/*
SQLyog Community v13.1.5  (64 bit)
MySQL - 5.6.47 : Database - hotfixes
*********************************************************************
*/

/*!40101 SET NAMES utf8 */;

/*!40101 SET SQL_MODE=''*/;

/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;
/*Table structure for table `achievement` */

DROP TABLE IF EXISTS `achievement`;

CREATE TABLE `achievement` (
  `Title` text,
  `Description` text,
  `Reward` text,
  `Flags` int(11) NOT NULL DEFAULT '0',
  `InstanceID` smallint(6) NOT NULL DEFAULT '0',
  `Supercedes` smallint(6) NOT NULL DEFAULT '0',
  `Category` smallint(6) NOT NULL DEFAULT '0',
  `UiOrder` smallint(6) NOT NULL DEFAULT '0',
  `SharesCriteria` smallint(6) NOT NULL DEFAULT '0',
  `Faction` tinyint(4) NOT NULL DEFAULT '0',
  `Points` tinyint(4) NOT NULL DEFAULT '0',
  `MinimumCriteria` tinyint(4) NOT NULL DEFAULT '0',
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `IconFileID` int(11) NOT NULL DEFAULT '0',
  `CriteriaTree` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `achievement` */

insert  into `achievement`(`Title`,`Description`,`Reward`,`Flags`,`InstanceID`,`Supercedes`,`Category`,`UiOrder`,`SharesCriteria`,`Faction`,`Points`,`MinimumCriteria`,`ID`,`IconFileID`,`CriteriaTree`,`VerifiedBuild`) values 
('Lose Your Illusion','Defeat Thorim in Ulduar while Sif is present.',NULL,2097152,603,2978,14922,109,0,-1,10,0,12352,298676,64278,-1),
('Coin collector','Collect 5500 gold coins of valor','Title: Valorous',0,0,0,155,18,0,-1,10,0,12460,133799,0,-1),
('Frost Resistace','Kill Atray and Evala 5 times.','Title: Conqueror of Ice',0,0,0,155,19,0,-1,10,0,12461,134155,65607,-1),
('Cool thing','Collect special mount, title, shirt & tabard and unique bags from loot pack.','Reward: Unique items',0,0,0,81,200,0,-1,10,0,12462,133202,65610,-1);

/*Table structure for table `achievement__category` */

DROP TABLE IF EXISTS `achievement__category`;

CREATE TABLE `achievement__category` (
  `Name` text,
  `Parent` smallint(5) unsigned NOT NULL DEFAULT '0',
  `UiOrder` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `achievement__category` */

/*Table structure for table `achievement__category_locale` */

DROP TABLE IF EXISTS `achievement__category_locale`;

CREATE TABLE `achievement__category_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `achievement__category_locale` */

/*Table structure for table `achievement_locale` */

DROP TABLE IF EXISTS `achievement_locale`;

CREATE TABLE `achievement_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Title_lang` text,
  `Description_lang` text,
  `Reward_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `achievement_locale` */

/*Table structure for table `adventure_journal` */

DROP TABLE IF EXISTS `adventure_journal`;

CREATE TABLE `adventure_journal` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Description` text,
  `ButtonText` text,
  `RewardDescription` text,
  `ContinueDescription` text,
  `TextureFileDataID` int(11) NOT NULL DEFAULT '0',
  `ItemID` int(11) NOT NULL DEFAULT '0',
  `LfgDungeonID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `QuestID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `BattleMasterListID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `BonusPlayerConditionID1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `BonusPlayerConditionID2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CurrencyType` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WorldMapAreaID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ButtonActionType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PriorityMin` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PriorityMax` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `BonusValue1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `BonusValue2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CurrencyQuantity` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `ItemQuantity` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `adventure_journal` */

/*Table structure for table `adventure_journal_locale` */

DROP TABLE IF EXISTS `adventure_journal_locale`;

CREATE TABLE `adventure_journal_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Description_lang` text,
  `ButtonText_lang` text,
  `RewardDescription_lang` text,
  `ContinueDescription_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `adventure_journal_locale` */

/*Table structure for table `adventure_map_p_o_i` */

DROP TABLE IF EXISTS `adventure_map_p_o_i`;

CREATE TABLE `adventure_map_p_o_i` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Title` text,
  `Description` text,
  `WorldPosition1` float NOT NULL DEFAULT '0',
  `WorldPosition2` float NOT NULL DEFAULT '0',
  `RewardItemID` int(11) NOT NULL DEFAULT '0',
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `QuestID` int(11) NOT NULL DEFAULT '0',
  `LfgDungeonID` int(11) NOT NULL DEFAULT '0',
  `UiTextureAtlasMemberID` int(11) NOT NULL DEFAULT '0',
  `UiTextureKitID` int(11) NOT NULL DEFAULT '0',
  `WorldMapAreaID` int(11) NOT NULL DEFAULT '0',
  `DungeonMapID` int(11) NOT NULL DEFAULT '0',
  `AreaTableID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `adventure_map_p_o_i` */

/*Table structure for table `adventure_map_p_o_i_locale` */

DROP TABLE IF EXISTS `adventure_map_p_o_i_locale`;

CREATE TABLE `adventure_map_p_o_i_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Title_lang` text,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `adventure_map_p_o_i_locale` */

/*Table structure for table `allied_race` */

DROP TABLE IF EXISTS `allied_race`;

CREATE TABLE `allied_race` (
  `BannerColor` int(11) NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `RaceID` int(11) NOT NULL DEFAULT '0',
  `CrestTextureID` int(11) NOT NULL DEFAULT '0',
  `ModelBackgroundTextureID` int(11) NOT NULL DEFAULT '0',
  `MaleCreatureDisplayID` int(11) NOT NULL DEFAULT '0',
  `FemaleCreatureDisplayID` int(11) NOT NULL DEFAULT '0',
  `UiUnlockAchievementID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `allied_race` */

/*Table structure for table `allied_race_racial_ability` */

DROP TABLE IF EXISTS `allied_race_racial_ability`;

CREATE TABLE `allied_race_racial_ability` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Description` text,
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `IconFileDataID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `allied_race_racial_ability` */

/*Table structure for table `allied_race_racial_ability_locale` */

DROP TABLE IF EXISTS `allied_race_racial_ability_locale`;

CREATE TABLE `allied_race_racial_ability_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `allied_race_racial_ability_locale` */

/*Table structure for table `anim_kit` */

DROP TABLE IF EXISTS `anim_kit`;

CREATE TABLE `anim_kit` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `OneShotDuration` int(11) NOT NULL DEFAULT '0',
  `OneShotStopAnimKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LowDefAnimKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `anim_kit` */

/*Table structure for table `anim_kit_bone_set` */

DROP TABLE IF EXISTS `anim_kit_bone_set`;

CREATE TABLE `anim_kit_bone_set` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `BoneDataID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ParentAnimKitBoneSetID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ExtraBoneCount` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AltAnimKitBoneSetID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `anim_kit_bone_set` */

/*Table structure for table `anim_kit_bone_set_alias` */

DROP TABLE IF EXISTS `anim_kit_bone_set_alias`;

CREATE TABLE `anim_kit_bone_set_alias` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `BoneDataID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AnimKitBoneSetID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `anim_kit_bone_set_alias` */

/*Table structure for table `anim_kit_bone_set_locale` */

DROP TABLE IF EXISTS `anim_kit_bone_set_locale`;

CREATE TABLE `anim_kit_bone_set_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `anim_kit_bone_set_locale` */

/*Table structure for table `anim_kit_config` */

DROP TABLE IF EXISTS `anim_kit_config`;

CREATE TABLE `anim_kit_config` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ConfigFlags` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `anim_kit_config` */

/*Table structure for table `anim_kit_config_bone_set` */

DROP TABLE IF EXISTS `anim_kit_config_bone_set`;

CREATE TABLE `anim_kit_config_bone_set` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `AnimKitPriorityID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AnimKitBoneSetID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `anim_kit_config_bone_set` */

/*Table structure for table `anim_kit_priority` */

DROP TABLE IF EXISTS `anim_kit_priority`;

CREATE TABLE `anim_kit_priority` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Priority` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `anim_kit_priority` */

/*Table structure for table `anim_kit_replacement` */

DROP TABLE IF EXISTS `anim_kit_replacement`;

CREATE TABLE `anim_kit_replacement` (
  `SrcAnimKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DstAnimKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Flags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `anim_kit_replacement` */

/*Table structure for table `anim_kit_segment` */

DROP TABLE IF EXISTS `anim_kit_segment`;

CREATE TABLE `anim_kit_segment` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `AnimStartTime` int(11) NOT NULL DEFAULT '0',
  `EndConditionParam` int(11) NOT NULL DEFAULT '0',
  `EndConditionDelay` int(11) NOT NULL DEFAULT '0',
  `Speed` float NOT NULL DEFAULT '0',
  `OverrideConfigFlags` int(10) unsigned NOT NULL DEFAULT '0',
  `ParentAnimKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AnimID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AnimKitConfigID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SegmentFlags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `BlendInTimeMs` smallint(5) unsigned NOT NULL DEFAULT '0',
  `BlendOutTimeMs` smallint(5) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `StartCondition` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `StartConditionParam` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EndCondition` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ForcedVariation` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LoopToSegmentIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `StartConditionDelay` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `anim_kit_segment` */

/*Table structure for table `anim_replacement` */

DROP TABLE IF EXISTS `anim_replacement`;

CREATE TABLE `anim_replacement` (
  `SrcAnimID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DstAnimID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Flags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `anim_replacement` */

/*Table structure for table `anim_replacement_set` */

DROP TABLE IF EXISTS `anim_replacement_set`;

CREATE TABLE `anim_replacement_set` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ExecOrder` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `anim_replacement_set` */

/*Table structure for table `animation_data` */

DROP TABLE IF EXISTS `animation_data`;

CREATE TABLE `animation_data` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Flags` int(10) unsigned NOT NULL DEFAULT '0',
  `Fallback` smallint(5) unsigned NOT NULL DEFAULT '0',
  `BehaviorID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `BehaviorTier` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `animation_data` */

/*Table structure for table `area_far_clip_override` */

DROP TABLE IF EXISTS `area_far_clip_override`;

CREATE TABLE `area_far_clip_override` (
  `AreaID` int(11) NOT NULL DEFAULT '0',
  `MinFarClip` float NOT NULL DEFAULT '0',
  `MinHorizonStart` float NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `area_far_clip_override` */

/*Table structure for table `area_group_member` */

DROP TABLE IF EXISTS `area_group_member`;

CREATE TABLE `area_group_member` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `AreaID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AreaGroupID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `area_group_member` */

insert  into `area_group_member`(`ID`,`AreaID`,`AreaGroupID`,`VerifiedBuild`) values 
(5816,44,2674,23911),
(11800,996,2674,23911),
(11801,97,2674,23911),
(9074,7672,4503,23911),
(9078,7983,4503,23911),
(30000,3453,5087,1),
(30001,3452,5087,1),
(30002,3451,5087,1),
(30003,3449,5087,1),
(30004,3450,5087,1),
(30005,2744,44,1),
(30006,2743,44,1);

/*Table structure for table `area_p_o_i` */

DROP TABLE IF EXISTS `area_p_o_i`;

CREATE TABLE `area_p_o_i` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Description` text,
  `Flags` int(11) NOT NULL DEFAULT '0',
  `Pos1` float NOT NULL DEFAULT '0',
  `Pos2` float NOT NULL DEFAULT '0',
  `Pos3` float NOT NULL DEFAULT '0',
  `PoiDataType` int(11) NOT NULL DEFAULT '0',
  `PoiData` int(11) NOT NULL DEFAULT '0',
  `ContinentID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AreaID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WorldStateID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Importance` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Icon` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `PortLocID` int(11) NOT NULL DEFAULT '0',
  `UiTextureAtlasMemberID` int(11) NOT NULL DEFAULT '0',
  `MapFloor` int(11) NOT NULL DEFAULT '0',
  `WmoGroupID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `area_p_o_i` */

/*Table structure for table `area_p_o_i_locale` */

DROP TABLE IF EXISTS `area_p_o_i_locale`;

CREATE TABLE `area_p_o_i_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `area_p_o_i_locale` */

/*Table structure for table `area_p_o_i_state` */

DROP TABLE IF EXISTS `area_p_o_i_state`;

CREATE TABLE `area_p_o_i_state` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Description` text,
  `WorldStateValue` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `IconEnumValue` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `UiTextureAtlasMemberID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `area_p_o_i_state` */

/*Table structure for table `area_p_o_i_state_locale` */

DROP TABLE IF EXISTS `area_p_o_i_state_locale`;

CREATE TABLE `area_p_o_i_state_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `area_p_o_i_state_locale` */

/*Table structure for table `area_table` */

DROP TABLE IF EXISTS `area_table`;

CREATE TABLE `area_table` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ZoneName` text,
  `AreaName` text,
  `Flags1` int(10) unsigned NOT NULL DEFAULT '0',
  `Flags2` int(10) unsigned NOT NULL DEFAULT '0',
  `AmbientMultiplier` float NOT NULL DEFAULT '0',
  `ContinentID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ParentAreaID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AreaBit` smallint(6) NOT NULL DEFAULT '0',
  `AmbienceID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ZoneMusic` smallint(5) unsigned NOT NULL DEFAULT '0',
  `IntroSound` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LiquidTypeID1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LiquidTypeID2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LiquidTypeID3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LiquidTypeID4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `UwZoneMusic` smallint(5) unsigned NOT NULL DEFAULT '0',
  `UwAmbience` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PvpCombatWorldStateID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SoundProviderPref` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SoundProviderPrefUnderwater` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ExplorationLevel` tinyint(4) NOT NULL DEFAULT '0',
  `FactionGroupMask` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MountFlags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `WildBattlePetLevelMin` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `WildBattlePetLevelMax` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `WindSettingsID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `UwIntroSound` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `area_table` */

insert  into `area_table`(`ID`,`ZoneName`,`AreaName`,`Flags1`,`Flags2`,`AmbientMultiplier`,`ContinentID`,`ParentAreaID`,`AreaBit`,`AmbienceID`,`ZoneMusic`,`IntroSound`,`LiquidTypeID1`,`LiquidTypeID2`,`LiquidTypeID3`,`LiquidTypeID4`,`UwZoneMusic`,`UwAmbience`,`PvpCombatWorldStateID`,`SoundProviderPref`,`SoundProviderPrefUnderwater`,`ExplorationLevel`,`FactionGroupMask`,`MountFlags`,`WildBattlePetLevelMin`,`WildBattlePetLevelMax`,`WindSettingsID`,`UwIntroSound`,`VerifiedBuild`) values 
(12002,'Разлом: Крепость Стромгард','Разлом: Крепость Стромгард',0,0,0,1178,12003,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,0,0),
(12003,'Разлом: Крепость Стромгард','Разлом: Крепость Стромгард',0,0,0,1178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,0,0),
(12004,'Зимняя Низина Арати','Зимняя Низина Арати',0,0,0,1678,12005,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,0,0),
(12005,'Зимняя Низина Арати','Зимняя Низина Арати',0,0,0,1678,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,0,0);

/*Table structure for table `area_table_locale` */

DROP TABLE IF EXISTS `area_table_locale`;

CREATE TABLE `area_table_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `ZoneName_lang` text,
  `AreaName_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `area_table_locale` */

/*Table structure for table `area_trigger` */

DROP TABLE IF EXISTS `area_trigger`;

CREATE TABLE `area_trigger` (
  `PosX` float NOT NULL DEFAULT '0',
  `PosY` float NOT NULL DEFAULT '0',
  `PosZ` float NOT NULL DEFAULT '0',
  `Radius` float NOT NULL DEFAULT '0',
  `BoxLength` float NOT NULL DEFAULT '0',
  `BoxWidth` float NOT NULL DEFAULT '0',
  `BoxHeight` float NOT NULL DEFAULT '0',
  `BoxYaw` float NOT NULL DEFAULT '0',
  `ContinentID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PhaseID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PhaseGroupID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ShapeID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AreaTriggerActionSetID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PhaseUseFlags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ShapeType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `area_trigger` */

insert  into `area_trigger`(`PosX`,`PosY`,`PosZ`,`Radius`,`BoxLength`,`BoxWidth`,`BoxHeight`,`BoxYaw`,`ContinentID`,`PhaseID`,`PhaseGroupID`,`ShapeID`,`AreaTriggerActionSetID`,`PhaseUseFlags`,`ShapeType`,`Flags`,`ID`,`VerifiedBuild`) values 
(1539.89,1481.36,352.65,5,0,0,0,0,489,0,0,0,485,0,0,0,3646,0),
(918.49,1434.04,346.05,5,0,0,0,0,489,0,0,0,486,0,0,0,3647,0);

/*Table structure for table `area_trigger_action_set` */

DROP TABLE IF EXISTS `area_trigger_action_set`;

CREATE TABLE `area_trigger_action_set` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Flags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `area_trigger_action_set` */

/*Table structure for table `area_trigger_box` */

DROP TABLE IF EXISTS `area_trigger_box`;

CREATE TABLE `area_trigger_box` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Extents1` float NOT NULL DEFAULT '0',
  `Extents2` float NOT NULL DEFAULT '0',
  `Extents3` float NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `area_trigger_box` */

/*Table structure for table `area_trigger_cylinder` */

DROP TABLE IF EXISTS `area_trigger_cylinder`;

CREATE TABLE `area_trigger_cylinder` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Radius` float NOT NULL DEFAULT '0',
  `Height` float NOT NULL DEFAULT '0',
  `ZOffset` float NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `area_trigger_cylinder` */

/*Table structure for table `area_trigger_sphere` */

DROP TABLE IF EXISTS `area_trigger_sphere`;

CREATE TABLE `area_trigger_sphere` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `MaxRadius` float NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `area_trigger_sphere` */

/*Table structure for table `armor_location` */

DROP TABLE IF EXISTS `armor_location`;

CREATE TABLE `armor_location` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Clothmodifier` float NOT NULL DEFAULT '0',
  `Leathermodifier` float NOT NULL DEFAULT '0',
  `Chainmodifier` float NOT NULL DEFAULT '0',
  `Platemodifier` float NOT NULL DEFAULT '0',
  `Modifier` float NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `armor_location` */

/*Table structure for table `artifact` */

DROP TABLE IF EXISTS `artifact`;

CREATE TABLE `artifact` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `UiBarOverlayColor` int(10) unsigned NOT NULL DEFAULT '0',
  `UiBarBackgroundColor` int(10) unsigned NOT NULL DEFAULT '0',
  `UiNameColor` int(10) unsigned NOT NULL DEFAULT '0',
  `UiTextureKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ChrSpecializationID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ArtifactCategoryID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `UiModelSceneID` int(11) NOT NULL DEFAULT '0',
  `SpellVisualKitID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `artifact` */

/*Table structure for table `artifact_appearance` */

DROP TABLE IF EXISTS `artifact_appearance`;

CREATE TABLE `artifact_appearance` (
  `Name` text,
  `UiSwatchColor` int(10) unsigned NOT NULL DEFAULT '0',
  `UiModelSaturation` float NOT NULL DEFAULT '0',
  `UiModelOpacity` float NOT NULL DEFAULT '0',
  `OverrideShapeshiftDisplayID` int(11) NOT NULL DEFAULT '0',
  `ArtifactAppearanceSetID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `UiCameraID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DisplayIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ItemAppearanceModifierID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `OverrideShapeshiftFormID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `UnlockPlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `UiItemAppearanceID` int(11) NOT NULL DEFAULT '0',
  `UiAltItemAppearanceID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `artifact_appearance` */

/*Table structure for table `artifact_appearance_locale` */

DROP TABLE IF EXISTS `artifact_appearance_locale`;

CREATE TABLE `artifact_appearance_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `artifact_appearance_locale` */

/*Table structure for table `artifact_appearance_set` */

DROP TABLE IF EXISTS `artifact_appearance_set`;

CREATE TABLE `artifact_appearance_set` (
  `Name` text,
  `Description` text,
  `UiCameraID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AltHandUICameraID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DisplayIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ForgeAttachmentOverride` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `ArtifactID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `artifact_appearance_set` */

/*Table structure for table `artifact_appearance_set_locale` */

DROP TABLE IF EXISTS `artifact_appearance_set_locale`;

CREATE TABLE `artifact_appearance_set_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `artifact_appearance_set_locale` */

/*Table structure for table `artifact_category` */

DROP TABLE IF EXISTS `artifact_category`;

CREATE TABLE `artifact_category` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `XpMultCurrencyID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `XpMultCurveID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `artifact_category` */

/*Table structure for table `artifact_locale` */

DROP TABLE IF EXISTS `artifact_locale`;

CREATE TABLE `artifact_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `artifact_locale` */

/*Table structure for table `artifact_power` */

DROP TABLE IF EXISTS `artifact_power`;

CREATE TABLE `artifact_power` (
  `DisplayPos1` float NOT NULL DEFAULT '0',
  `DisplayPos2` float NOT NULL DEFAULT '0',
  `ArtifactID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxPurchasableRank` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Tier` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `Label` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `artifact_power` */

/*Table structure for table `artifact_power_link` */

DROP TABLE IF EXISTS `artifact_power_link`;

CREATE TABLE `artifact_power_link` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `PowerA` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PowerB` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `artifact_power_link` */

/*Table structure for table `artifact_power_picker` */

DROP TABLE IF EXISTS `artifact_power_picker`;

CREATE TABLE `artifact_power_picker` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `PlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `artifact_power_picker` */

/*Table structure for table `artifact_power_rank` */

DROP TABLE IF EXISTS `artifact_power_rank`;

CREATE TABLE `artifact_power_rank` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `AuraPointsOverride` float NOT NULL DEFAULT '0',
  `ItemBonusListID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RankIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ArtifactPowerID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `artifact_power_rank` */

/*Table structure for table `artifact_quest_xp` */

DROP TABLE IF EXISTS `artifact_quest_xp`;

CREATE TABLE `artifact_quest_xp` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Difficulty1` int(11) NOT NULL DEFAULT '0',
  `Difficulty2` int(11) NOT NULL DEFAULT '0',
  `Difficulty3` int(11) NOT NULL DEFAULT '0',
  `Difficulty4` int(11) NOT NULL DEFAULT '0',
  `Difficulty5` int(11) NOT NULL DEFAULT '0',
  `Difficulty6` int(11) NOT NULL DEFAULT '0',
  `Difficulty7` int(11) NOT NULL DEFAULT '0',
  `Difficulty8` int(11) NOT NULL DEFAULT '0',
  `Difficulty9` int(11) NOT NULL DEFAULT '0',
  `Difficulty10` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `artifact_quest_xp` */

/*Table structure for table `artifact_tier` */

DROP TABLE IF EXISTS `artifact_tier`;

CREATE TABLE `artifact_tier` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ArtifactTier` int(11) NOT NULL DEFAULT '0',
  `MaxNumTraits` int(11) NOT NULL DEFAULT '0',
  `MaxArtifactKnowledge` int(11) NOT NULL DEFAULT '0',
  `KnowledgePlayerCondition` int(11) NOT NULL DEFAULT '0',
  `MinimumEmpowerKnowledge` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `artifact_tier` */

/*Table structure for table `artifact_unlock` */

DROP TABLE IF EXISTS `artifact_unlock`;

CREATE TABLE `artifact_unlock` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ItemBonusListID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PowerRank` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PowerID` int(11) NOT NULL DEFAULT '0',
  `PlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `ArtifactID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `artifact_unlock` */

/*Table structure for table `auction_house` */

DROP TABLE IF EXISTS `auction_house`;

CREATE TABLE `auction_house` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `FactionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DepositRate` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ConsignmentRate` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `auction_house` */

/*Table structure for table `auction_house_locale` */

DROP TABLE IF EXISTS `auction_house_locale`;

CREATE TABLE `auction_house_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `auction_house_locale` */

/*Table structure for table `bank_bag_slot_prices` */

DROP TABLE IF EXISTS `bank_bag_slot_prices`;

CREATE TABLE `bank_bag_slot_prices` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Cost` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `bank_bag_slot_prices` */

/*Table structure for table `banned_addons` */

DROP TABLE IF EXISTS `banned_addons`;

CREATE TABLE `banned_addons` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Version` text,
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `banned_addons` */

/*Table structure for table `banned_addons_locale` */

DROP TABLE IF EXISTS `banned_addons_locale`;

CREATE TABLE `banned_addons_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Version_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `banned_addons_locale` */

/*Table structure for table `barber_shop_style` */

DROP TABLE IF EXISTS `barber_shop_style`;

CREATE TABLE `barber_shop_style` (
  `DisplayName` text,
  `Description` text,
  `CostModifier` float NOT NULL DEFAULT '0',
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Race` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Sex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Data` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `barber_shop_style` */

/*Table structure for table `barber_shop_style_locale` */

DROP TABLE IF EXISTS `barber_shop_style_locale`;

CREATE TABLE `barber_shop_style_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `DisplayName_lang` text,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `barber_shop_style_locale` */

/*Table structure for table `battle_pet_ability` */

DROP TABLE IF EXISTS `battle_pet_ability`;

CREATE TABLE `battle_pet_ability` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Description` text,
  `IconFileDataID` int(11) NOT NULL DEFAULT '0',
  `BattlePetVisualID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PetTypeEnum` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Cooldown` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `battle_pet_ability` */

/*Table structure for table `battle_pet_ability_effect` */

DROP TABLE IF EXISTS `battle_pet_ability_effect`;

CREATE TABLE `battle_pet_ability_effect` (
  `BattlePetAbilityTurnID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `BattlePetVisualID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AuraBattlePetAbilityID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `BattlePetEffectPropertiesID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Param1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Param2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Param3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Param4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Param5` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Param6` smallint(5) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `battle_pet_ability_effect` */

/*Table structure for table `battle_pet_ability_locale` */

DROP TABLE IF EXISTS `battle_pet_ability_locale`;

CREATE TABLE `battle_pet_ability_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `battle_pet_ability_locale` */

/*Table structure for table `battle_pet_ability_state` */

DROP TABLE IF EXISTS `battle_pet_ability_state`;

CREATE TABLE `battle_pet_ability_state` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Value` int(10) unsigned NOT NULL DEFAULT '0',
  `BattlePetStateID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `BattlePetAbilityID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `battle_pet_ability_state` */

/*Table structure for table `battle_pet_ability_turn` */

DROP TABLE IF EXISTS `battle_pet_ability_turn`;

CREATE TABLE `battle_pet_ability_turn` (
  `BattlePetAbilityID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `BattlePetVisualID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TurnTypeEnum` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EventTypeEnum` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `battle_pet_ability_turn` */

/*Table structure for table `battle_pet_breed_quality` */

DROP TABLE IF EXISTS `battle_pet_breed_quality`;

CREATE TABLE `battle_pet_breed_quality` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `StateMultiplier` float NOT NULL DEFAULT '0',
  `QualityEnum` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `battle_pet_breed_quality` */

/*Table structure for table `battle_pet_breed_state` */

DROP TABLE IF EXISTS `battle_pet_breed_state`;

CREATE TABLE `battle_pet_breed_state` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Value` smallint(5) unsigned NOT NULL DEFAULT '0',
  `BattlePetStateID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `BreedID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `battle_pet_breed_state` */

/*Table structure for table `battle_pet_display_override` */

DROP TABLE IF EXISTS `battle_pet_display_override`;

CREATE TABLE `battle_pet_display_override` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `BattlePetSpeciesID` int(11) NOT NULL DEFAULT '0',
  `PlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `CreatureDisplayInfoID` int(11) NOT NULL DEFAULT '0',
  `PriorityCategory` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `battle_pet_display_override` */

/*Table structure for table `battle_pet_effect_properties` */

DROP TABLE IF EXISTS `battle_pet_effect_properties`;

CREATE TABLE `battle_pet_effect_properties` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ParamLabel1` text,
  `ParamLabel2` text,
  `ParamLabel3` text,
  `ParamLabel4` text,
  `ParamLabel5` text,
  `ParamLabel6` text,
  `BattlePetVisualID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ParamTypeEnum1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ParamTypeEnum2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ParamTypeEnum3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ParamTypeEnum4` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ParamTypeEnum5` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ParamTypeEnum6` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `battle_pet_effect_properties` */

/*Table structure for table `battle_pet_effect_properties_locale` */

DROP TABLE IF EXISTS `battle_pet_effect_properties_locale`;

CREATE TABLE `battle_pet_effect_properties_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `ParamLabel1_lang` text,
  `ParamLabel2_lang` text,
  `ParamLabel3_lang` text,
  `ParamLabel4_lang` text,
  `ParamLabel5_lang` text,
  `ParamLabel6_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `battle_pet_effect_properties_locale` */

/*Table structure for table `battle_pet_n_p_c_team_member` */

DROP TABLE IF EXISTS `battle_pet_n_p_c_team_member`;

CREATE TABLE `battle_pet_n_p_c_team_member` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `battle_pet_n_p_c_team_member` */

/*Table structure for table `battle_pet_n_p_c_team_member_locale` */

DROP TABLE IF EXISTS `battle_pet_n_p_c_team_member_locale`;

CREATE TABLE `battle_pet_n_p_c_team_member_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `battle_pet_n_p_c_team_member_locale` */

/*Table structure for table `battle_pet_species` */

DROP TABLE IF EXISTS `battle_pet_species`;

CREATE TABLE `battle_pet_species` (
  `SourceText` text,
  `Description` text,
  `CreatureID` int(11) NOT NULL DEFAULT '0',
  `IconFileDataID` int(11) NOT NULL DEFAULT '0',
  `SummonSpellID` int(11) NOT NULL DEFAULT '0',
  `Flags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PetTypeEnum` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SourceTypeEnum` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `CardUIModelSceneID` int(11) NOT NULL DEFAULT '0',
  `LoadoutUIModelSceneID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `battle_pet_species` */

insert  into `battle_pet_species`(`SourceText`,`Description`,`CreatureID`,`IconFileDataID`,`SummonSpellID`,`Flags`,`PetTypeEnum`,`SourceTypeEnum`,`ID`,`CardUIModelSceneID`,`LoadoutUIModelSceneID`,`VerifiedBuild`) values 
('|cFFFFD200Achievement:|r Priority Mail|n','The Postmaster is often described as esoteric, mystical, even inexplicable. For the precious little known about the enigmatic mail-master, perhaps none outside of the wax seal can confirm the existence of the fantastical letter-loving Mailemental',132366,413580,260887,82,5,5,2158,6,7,0),
('|cFFFFD200Vendor: |rLhara|n|cFFFFD200Zone: |rDarkmoon Island|n|cFFFFD200Cost: |r90|TINTERFACE\\ICONS\\inv_misc_ticket_darkmoon_01:0|t','Most of Violet\'s numerous forest strider hatchlings are turned into Faire fare by Stamp Thunderhorn, though a few are raised as mounts or purchased by adventurers looking for a petite purple pet',67319,132198,132762,2,4,2,1061,35,7,0),
('','',91337,134205,0,34,6,255,1642,6,7,0),
('','',83562,134048,167336,2,3,0,1428,6,7,0),
('|cFFFFD200World Event:|r Love is in the Air|n|cFFFFD200Vendor: |rLovely Merchant|n|cFFFFD200Cost: |r40|TINTERFACEICONSINV_ValentinesCard01:0|','Most of Violet\'s numerous forest strider hatchlings are turned into Faire fare by Stamp Thunderhorn, though a few are raised as mounts or purchased by adventurers looking for a petite purple pet',85710,132198,171118,2,4,2,1511,35,7,0),
('','',78895,134062,159296,2,5,3,1395,33,7,0);

/*Table structure for table `battle_pet_species_locale` */

DROP TABLE IF EXISTS `battle_pet_species_locale`;

CREATE TABLE `battle_pet_species_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `SourceText_lang` text,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `battle_pet_species_locale` */

/*Table structure for table `battle_pet_species_state` */

DROP TABLE IF EXISTS `battle_pet_species_state`;

CREATE TABLE `battle_pet_species_state` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Value` int(10) unsigned NOT NULL DEFAULT '0',
  `BattlePetStateID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SpeciesID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `battle_pet_species_state` */

/*Table structure for table `battle_pet_species_x_ability` */

DROP TABLE IF EXISTS `battle_pet_species_x_ability`;

CREATE TABLE `battle_pet_species_x_ability` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `BattlePetAbilityID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RequiredLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SlotEnum` tinyint(4) NOT NULL DEFAULT '0',
  `BattlePetSpeciesID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `battle_pet_species_x_ability` */

/*Table structure for table `battle_pet_state` */

DROP TABLE IF EXISTS `battle_pet_state`;

CREATE TABLE `battle_pet_state` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `LuaName` text,
  `BattlePetVisualID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Flags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `battle_pet_state` */

/*Table structure for table `battle_pet_state_locale` */

DROP TABLE IF EXISTS `battle_pet_state_locale`;

CREATE TABLE `battle_pet_state_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `LuaName_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `battle_pet_state_locale` */

/*Table structure for table `battle_pet_visual` */

DROP TABLE IF EXISTS `battle_pet_visual`;

CREATE TABLE `battle_pet_visual` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SceneScriptFunction` text,
  `SpellVisualID` int(11) NOT NULL DEFAULT '0',
  `CastMilliSeconds` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ImpactMilliSeconds` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SceneScriptPackageID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RangeTypeEnum` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `battle_pet_visual` */

/*Table structure for table `battle_pet_visual_locale` */

DROP TABLE IF EXISTS `battle_pet_visual_locale`;

CREATE TABLE `battle_pet_visual_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `SceneScriptFunction_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `battle_pet_visual_locale` */

/*Table structure for table `battlemaster_list` */

DROP TABLE IF EXISTS `battlemaster_list`;

CREATE TABLE `battlemaster_list` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `GameType` text,
  `ShortDescription` text,
  `LongDescription` text,
  `IconFileDataID` int(11) NOT NULL DEFAULT '0',
  `MapID1` smallint(6) NOT NULL DEFAULT '0',
  `MapID2` smallint(6) NOT NULL DEFAULT '0',
  `MapID3` smallint(6) NOT NULL DEFAULT '0',
  `MapID4` smallint(6) NOT NULL DEFAULT '0',
  `MapID5` smallint(6) NOT NULL DEFAULT '0',
  `MapID6` smallint(6) NOT NULL DEFAULT '0',
  `MapID7` smallint(6) NOT NULL DEFAULT '0',
  `MapID8` smallint(6) NOT NULL DEFAULT '0',
  `MapID9` smallint(6) NOT NULL DEFAULT '0',
  `MapID10` smallint(6) NOT NULL DEFAULT '0',
  `MapID11` smallint(6) NOT NULL DEFAULT '0',
  `MapID12` smallint(6) NOT NULL DEFAULT '0',
  `MapID13` smallint(6) NOT NULL DEFAULT '0',
  `MapID14` smallint(6) NOT NULL DEFAULT '0',
  `MapID15` smallint(6) NOT NULL DEFAULT '0',
  `MapID16` smallint(6) NOT NULL DEFAULT '0',
  `HolidayWorldState` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RequiredPlayer_Condition_ID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `InstanceType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GroupsAllowed` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxGroupSize` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MinLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RatedPlayers` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MinPlayers` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxPlayers` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `battlemaster_list` */

insert  into `battlemaster_list`(`ID`,`Name`,`GameType`,`ShortDescription`,`LongDescription`,`IconFileDataID`,`MapID1`,`MapID2`,`MapID3`,`MapID4`,`MapID5`,`MapID6`,`MapID7`,`MapID8`,`MapID9`,`MapID10`,`MapID11`,`MapID12`,`MapID13`,`MapID14`,`MapID15`,`MapID16`,`HolidayWorldState`,`RequiredPlayer_Condition_ID`,`InstanceType`,`GroupsAllowed`,`MaxGroupSize`,`MinLevel`,`MaxLevel`,`RatedPlayers`,`MinPlayers`,`MaxPlayers`,`Flags`,`VerifiedBuild`) values 
(876,'DeathMatch',NULL,NULL,NULL,136324,1101,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,3,0,1,110,110,25,10,25,24,23911),
(894,'Бурлящий берег',NULL,NULL,NULL,1864730,1803,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,3,0,1,110,110,10,10,10,24,23911);

/*Table structure for table `battlemaster_list_locale` */

DROP TABLE IF EXISTS `battlemaster_list_locale`;

CREATE TABLE `battlemaster_list_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `GameType_lang` text,
  `ShortDescription_lang` text,
  `LongDescription_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `battlemaster_list_locale` */

/*Table structure for table `beam_effect` */

DROP TABLE IF EXISTS `beam_effect`;

CREATE TABLE `beam_effect` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `BeamID` int(11) NOT NULL DEFAULT '0',
  `SourceMinDistance` float NOT NULL DEFAULT '0',
  `FixedLength` float NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `SourceOffset` int(11) NOT NULL DEFAULT '0',
  `DestOffset` int(11) NOT NULL DEFAULT '0',
  `SourceAttachID` int(11) NOT NULL DEFAULT '0',
  `DestAttachID` int(11) NOT NULL DEFAULT '0',
  `SourcePositionerID` int(11) NOT NULL DEFAULT '0',
  `DestPositionerID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `beam_effect` */

/*Table structure for table `bone_wind_modifier_model` */

DROP TABLE IF EXISTS `bone_wind_modifier_model`;

CREATE TABLE `bone_wind_modifier_model` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `FileDataID` int(11) NOT NULL DEFAULT '0',
  `BoneWindModifierID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `bone_wind_modifier_model` */

/*Table structure for table `bone_wind_modifiers` */

DROP TABLE IF EXISTS `bone_wind_modifiers`;

CREATE TABLE `bone_wind_modifiers` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Multiplier1` float NOT NULL DEFAULT '0',
  `Multiplier2` float NOT NULL DEFAULT '0',
  `Multiplier3` float NOT NULL DEFAULT '0',
  `PhaseMultiplier` float NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `bone_wind_modifiers` */

/*Table structure for table `bounty` */

DROP TABLE IF EXISTS `bounty`;

CREATE TABLE `bounty` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `IconFileDataID` int(11) NOT NULL DEFAULT '0',
  `QuestID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FactionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `TurninPlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `bounty` */

/*Table structure for table `bounty_set` */

DROP TABLE IF EXISTS `bounty_set`;

CREATE TABLE `bounty_set` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `LockedQuestID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VisiblePlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `bounty_set` */

/*Table structure for table `broadcast_text` */

DROP TABLE IF EXISTS `broadcast_text`;

CREATE TABLE `broadcast_text` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Text` text,
  `Text1` text,
  `EmoteID1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EmoteID2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EmoteID3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EmoteDelay1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EmoteDelay2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EmoteDelay3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EmotesID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LanguageID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ConditionID` int(11) NOT NULL DEFAULT '0',
  `SoundEntriesID1` int(11) NOT NULL DEFAULT '0',
  `SoundEntriesID2` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `Text` (`Text`(333)),
  KEY `Text1` (`Text1`(333))
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `broadcast_text` */

insert  into `broadcast_text`(`ID`,`Text`,`Text1`,`EmoteID1`,`EmoteID2`,`EmoteID3`,`EmoteDelay1`,`EmoteDelay2`,`EmoteDelay3`,`EmotesID`,`LanguageID`,`Flags`,`ConditionID`,`SoundEntriesID1`,`SoundEntriesID2`,`VerifiedBuild`) values 
(120101,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68941,68941,25996),
(112228,'','I serve noone.',1,0,0,0,0,0,0,0,0,0,0,62850,25996),
(112281,'','Less talk, more action.',1,0,0,0,0,0,0,0,0,0,0,63010,25996),
(122676,'<Saying nothing, he eyes you warily.>','<Saying nothing, she eyes you warily.>',0,0,0,0,0,0,0,0,0,0,0,0,25996),
(108793,'If you can pay, I can supply.','',1,0,0,0,0,0,0,0,0,0,0,0,25996),
(98814,'View available missions.','View available missions.',0,0,0,0,0,0,0,0,0,0,0,0,25996),
(108893,'The Uncrowned will do what no others can: finish this war.','',1,0,0,0,0,0,0,0,0,0,0,0,25996),
(115938,'You want a job done? I can get a job done.','',0,0,0,0,0,0,0,0,0,0,0,0,25996),
(69798,'What is up, my primary $gmale:female; sibling?  Are you ready to appear visually attractive to your species?','',0,0,0,0,0,0,0,0,1,0,0,0,25996),
(120995,'Why she tryin\' to sleep wit\' a knife in her back?','',0,0,0,0,0,0,0,0,0,0,71255,0,25996),
(120993,'You sure she dead? Maybe she sleepin\'!','',0,0,0,0,0,0,0,0,0,0,71253,0,25996),
(120992,'She obviously dead you idiot!','',0,0,0,0,0,0,0,0,0,0,71252,0,25996),
(120994,'She ain\'t sleepin\' you dummy! She got a knife in her back!','',0,0,0,0,0,0,0,0,0,0,71254,0,25996),
(121287,'I told you already... I never miss.','',0,0,0,0,0,0,0,0,0,0,71266,0,25996),
(121280,'How much longer is this going to take?','',0,0,0,0,0,0,1,0,0,0,71261,0,25996),
(121282,'These dropboxes are tricky... I\'ve almost got it.','',0,0,0,0,0,0,1,0,0,0,71262,0,25996),
(121285,'You\'re sure you got her, right? We can\'t afford to mess this up!','',0,0,0,0,0,0,1,0,0,0,71265,0,25996),
(121288,'We should have killed her back in Citrine Bay. Doing the hit in Dalaran was too risky! We can\'t afford witnesses...','',0,0,0,0,0,0,1,0,0,0,71260,0,25996),
(121283,'Amber Kearnen was one of our own... I still can\'t believe we had to kill her.','',0,0,0,0,0,0,0,0,0,0,71263,0,25996),
(121284,'When the orders come from Master Shaw himself... you don\'t ask questions.','',0,0,0,0,0,0,0,0,0,0,71264,0,25996),
(116494,'We work in the shadows.','We work in the shadows.',0,0,0,0,0,0,0,0,0,0,0,0,25996),
(122300,'','Hiya, $n! How can I help you today?',0,0,0,0,0,0,0,0,0,0,0,0,25996),
(98620,'Are you ready to fly? You\'ll have our fastest mount.','',0,0,0,0,0,0,0,0,0,0,0,0,25996),
(103914,'Our uni-directional gift distribution threshold has been reached. Thresholds reset daily.','',0,0,0,0,0,0,0,0,1,0,0,0,25996),
(64116,'What do you think of my pet?','What do you think of my pet?',0,0,0,0,0,0,1,0,1,0,0,0,25996),
(30361,'Greetings, $c. I can assist you in recovering lost companions.','Greetings, $c. I can assist you in recovering lost companions.',1,0,0,0,0,0,0,0,1,0,0,0,25996),
(67334,'','You will be just another nameless victim of these barren lands.',25,0,0,0,0,0,0,0,1,0,0,0,25996),
(67321,'You scared of da creepy crawlies, $r?','',11,0,0,0,0,0,0,0,1,0,0,0,25996),
(1,'Help help!  I\'m being repressed!','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(3,'Company.. HALT!  ... Fall IN!','Company.. HALT!  ... Fall IN!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4,'Forward.. MARCH!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5,'Come, let us engage in fisticuffs, like civilized folk.','Come, let us engage in fisticuffs, like civilized folk.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7,'Thank you very much!','Thank you very much!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9,'Follow me, $n. I\'ll take you to the Defias hideout. But you better protect me or I am as good as dead.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(10,'The entrance is hidden here in Moonbrook.  Keep your eyes peeled for thieves.  They want me dead.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(11,'You can go tell Stoutmantle this is where the Defias Gang is holed up, $n.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13,'Work scum!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14,'Grrrr! Idiots!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15,'Good for nothing Kobolds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16,'All right people, look alive!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17,'All right, you guys! Time to get up','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19,'Hey, follow me!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(22,'Another herd brought in successfully!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(23,'Well I\'m here.  And I\'m ready to rejoin...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24,'You\'re not joining anyone, Thorsen..','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25,'My wounds are grave.  Forgive my slow pace but my injuries won\'t allow me to walk any faster.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26,'Ah, fresh air at last! I need a moment to rest.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27,'The Blackrock infestation is thick in these parts.  I will do my best to keep the pace.  Let\'s go!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(28,'So close to blessed Lakeshire.  By the Light, let my legs carry me a bit further!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(29,'Marshal Marris, sir.  Corporal Keeshan of the 12th Sabre Regiment returned from battle and reporting for duty!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(30,'Brave adventurer, thank you for rescuing me! I am sure Marshal Marris will reward your kind deed.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33,'Antonio Perelli\'s miracle elixirs for sale!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(35,'Come one! Come all! Perelli\'s elixirs will dazzle!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36,'Stonemasons. . .errr. . Defias be warned:  The rusty anchor sinks tonight.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(37,'The boss wants all hands on high alert.  The rusty anchor sinks tonight.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(38,'I\'m here for the gold.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(39,'Everywhere I look I see thieves.  We, The People\'s Miltia, must return this land to the farmers.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(40,'The farms must be liberated.  Stormwind may have deserted these people, but I\'ll be damned if I will.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41,'','Defias activity reported on the costal horizon.  All clear on Sentinel Hill.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42,'Lots of gnoll activity reported in the Gold Coast Quarry and the Jangolode Mine.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43,'All clear on Sentinel Hill, Lord Stoutmantle.  Heavy Defias movement reported in Moonbrook, however.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44,'Stormwind\'s desertion shall not be forgiven by the people of Westfall.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(45,'Nothing biting. . . .','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(46,'Here fishy fishy. . . come to papa.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(47,'Pull up a stool and have a drink!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(48,'The bottles are dusty but the liquor goes down clean!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(49,'','Hopefully the reinforcements from Stormwind show up soon. . . .',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50,'Come on boys, we\'ve got to get this bridge rebuilt.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(51,'Where are those reinforcements from Stormwind?  Heavy Blackrock activity has been reported in the East.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(52,'Still no sign of the 2nd Battalion from Stormwind.  Reports are coming in of Shadowhide movement in the Northeast.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(53,'Marshal Marris expects the reserve from Stormwind any time now. . . .','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(54,'','Don\'t worry, Old Blanchy, we\'ll get you something to eat soon. . .',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(55,'','I never thought the day would come that I\'d leave my homeland of Westfall. . . .',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(56,'Can\'t believe the forsaken wagon broke down.  Ain\'t no luck to be had in this land. . . .','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(57,'We\'ll be out of here just as soon as I get this wagon fixed. . . .','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(58,'Now how am I supposed to get those mechanical wretches out of my fields?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(59,'A bunch of thugs and thieves aren\'t going to get me to leave my land!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(60,'They might have run all the other farmers off, but the Saldean\'s will never leave Westfall.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(61,'','Stay on the roads.  The forest is overrun with undead.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(62,'','Fear not.  The Night Watch will rid the land of this foul taint soon enough.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(63,'Undead are crawling all over the land.  Where is the Stormwind Army?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(64,'The Night Watch alone cannot protect us forever.  We need the backing of the Stormwind Army.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(65,'We must not give into the evil which has darkened our land.  The Night Watch must prevail!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(66,'The forest is crawling with worgen and ghouls.  Something must be done!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(67,'We need better representation from Stormwind.  Our homes are falling to the undead.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(68,'The Council of Duskwood must take action.  Evil lingers in the air.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(69,'The people of Darkshire expect more from the Council.  We cannot let them suffer from this unholy wrath which plagues us.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(70,'Constant bickering will get us nowhere.  We need to take action.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(71,'The news from Stormwind does not bode well. . . .','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(72,'Our cause falls on deaf ears beyond the thick, stone walls of Stormwind.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(73,'','I sense evil brewing. . . .',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(74,'','The stars speak to me.  They whisper of the horrors waiting in the night.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(75,'','The future holds much death and uncertainty, not unlike the past.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(76,'','The spirits whisper in my ear.  They are restless and full of angst.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(77,'The stars will be in perfect form tonight!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(79,'There is something greater than magic at work in the night sky.  One day they\'ll listen to me. . . .','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(80,'Psssst.  We just got some Moonshine in. . . .','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(81,'Step right up and wet your whistle.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(82,'This dark taint is downright bad for business.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(83,'Welcome to the Scarlet Raven.  It\'s best to stay indoors these days.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(84,'If your glass is full may it be again!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(85,'Welcome to the Lion\'s Pride Inn.  Make yourself at home!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(86,'So much to do, so much to do!  Where does the time go?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(87,'Now where was that book on Night Elf customs I was looking for...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(88,'Oh my!  Look at the state of these books!  Who put them back without alphabetizing them??','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(89,'Rouse and to arms, citizens of Darkshire! An abomination of the undead approaches along the road!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(90,'The abomination has overrun the Night Watch camp! Quickly, we must intercept it before it reaches town!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(91,'It isn\'t enough! Defenders, gather in the center of town. Together we will stand against the undead monster!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(92,'The abomination has come! Forward!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(93,'The beast is slain! All\'s well in Darkshire!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(94,'I didn\'t know he was getting married! I didn\'t even know he was dating! That\'s terrible! He can\'t work nights anymore!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(95,'Fine! You\'ve outreasoned me, you masters of Engineering! Put the door wherever you want!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(96,'That\'s right, we\'re stupid. Stupid like a Fox!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(97,'Where\'s My Bacon?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(98,'','You\'ve ruined your own lands, you\'ll not ruin mine.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(99,'$n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(100,'Thanks for saving me!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(101,'Now you die!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(102,'Time for my patrol.  I\'ll be back shortly.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(103,'Now that the coast is clear...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(104,'Who goes there??','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(105,'I\'ve been gone a long time...I better get back.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(106,'Private Thorsen returning from patrol.  Nothing new to report - it\'s pretty quiet out there...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(107,'','It\'ll take more than a rotting corpse to stop us!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(108,'','Very good.  You are relieved, private.  Rest, but don\'t get too comfortable.  Kurzen won\'t leave us alone forever.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(109,'What is going on here?  Leave that powder alone!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(110,'Aber?  Is that you...?  Oh...I\'m so hungry, Aber!  SO HUNGRY!!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(111,'Wait...you are not my husband.  But he must have sent you.  And you...look..delicious!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(112,'Let\'s see if I can hit that bullseye this time.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(113,'Looks like I need more practice!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(114,'\'Bout time fer me to make mah rounds.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(115,'Ah I am too busy for a drink now lad.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(117,'Ach! Toss me a cold frosty, Belm!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(118,'Bagh! Back to work for me! Thank you kindly Belm.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(120,'Aye there you go lad, your favorite brew.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(121,'Aye, tell your friend there Tongus if he dont take care of his tab here, i\'ll be making an appearance with old Steelhead!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(122,'Belm says pay your bill or he\'ll break your face.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(123,'Hoha! I\'d welcome the challenge from old weakbelly!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(124,'I\'ll take whatever ya got cookin\'! And throw in a bottle to wash it down!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(125,'Hey there, Belm!  Give me a mug of Thunder Ale, and one for my good friend $n.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(126,'How goes the barrel watching...?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(127,'Ah, that sure does hit the spot!  I think I\'ll get myself a couple more...can you watch these barrels for me, $n?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(128,'Well, back to business for me.  But it sure was nice taking that short break, and it\'s always nice drinking Thunder Ale!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(129,'I\'m back where I started.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(130,'I\'m now far enough away...so I can\'t see the barrel.  Poison away!.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(131,'Think there are any fish in here?','Think there are any fish in here?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(132,'I caught a big one last week, it had three eyes!','I caught a big one last week, it had three eyes!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(133,'My daddy says that in the ocean, there are fish so big they could swallow a whole ship.','My daddy says that in the ocean, there are fish so big they could swallow a whole ship.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(134,'My daddy can catch more fish than your daddy!','My daddy can catch more fish than your daddy!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(135,'Look! Look! I caught something! Aww....it\'s just a stinky ol\' boot.','Look! Look! I caught something! Aww....it\'s just a stinky ol\' boot.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(136,'Nuh uh.','Nuh uh.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(138,'Liar!','Liar!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(139,'I heard that there are these huge fish that can walk on land to hunt, and eat people!','I heard that there are these huge fish that can walk on land to hunt, and eat people!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(140,'And one time, at camp, I caught a fish that was bigger than I am!!','And one time, at camp, I caught a fish that was bigger than I am!!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(141,'I heard a story about this golden fish, and if you caught it you would get three wishes!','I heard a story about this golden fish, and if you caught it you would get three wishes!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(142,'If you fished as well as you talked the ocean wouldn\'t have any fish left.','If you fished as well as you talked the ocean wouldn\'t have any fish left.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(143,'Shhh! You\'re scaring the fish away.','Shhh! You\'re scaring the fish away.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(144,'You\'re making that up.','You\'re making that up.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(145,'If you could catch a fish big enough for your mouth we\'d never be hungry again.','If you could catch a fish big enough for your mouth we\'d never be hungry again.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(146,'Maybe we should go to the bridge and fish.','Maybe we should go to the bridge and fish.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(147,'Really?','Really?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(149,'And that\'s how Lothar killed thirty six orcs with his bare hands!','And that\'s how Lothar killed thirty six orcs with his bare hands!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(150,'And so the knights stood before the charging Horde and held their ground as a thousand berserk orcs came through the valley.','And so the knights stood before the charging Horde and held their ground as a thousand berserk orcs came through the valley.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(151,'They say he can turn into a raven sometimes.','They say he can turn into a raven sometimes.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(152,'You know why orc eyes glow red? It\'s because they drink blood!','You know why orc eyes glow red? It\'s because they drink blood!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(153,'There is no spoon.','There is no spoon.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(154,'I swear, people have actually seen them. Pandaren really do exist!','I swear, people have actually seen them. Pandaren really do exist!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(155,'And then the rabbit just bit his head off... I swear.','And then the rabbit just bit his head off... I swear.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(156,'You know there are crocolisks in the Canals. They were brought from the swamp as pets, but got thrown in the canals.','You know there are crocolisks in the Canals. They were brought from the swamp as pets, but got thrown in the canals.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(157,'Wow.','Wow.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(158,'Oh yeah, I heard about that.','Oh yeah, I heard about that.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(159,'','Come back, Fluffy!',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(160,'','Why do you run from me, Fluffy?!',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(161,'','C\'mon, Fluffy! I just want to give you a bath!',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(162,'','Fluffy! Fluffy, stop running!',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(164,'','Carrots every day for a year if you stop!',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(165,'','Don\'t make me get my pappy to catch you! He likes to catch bunnies using his rifle!',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(166,'Oh c\'mon, that\'s not true.','Oh c\'mon, that\'s not true.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(167,'That\'s neat.','That\'s neat.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(168,'My father says that\'s just a story.','My father says that\'s just a story.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(169,'Can you imagine?','Can you imagine?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(170,'Sounds kinda like one of Billy\'s fish stories to me.','Sounds kinda like one of Billy\'s fish stories to me.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(171,'I thought I heard something.','I thought I heard something.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(172,'I think I see something.','I think I see something.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(173,'Eww... that\'s not a fish!','Eww... that\'s not a fish!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(174,'I got worm guts on my shoes.','I got worm guts on my shoes.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(175,'Something smells funny.','Something smells funny.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(176,'I hope that was a fish!','I hope that was a fish!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(177,'I don\'t think there\'s any fish in these canals.','I don\'t think there\'s any fish in these canals.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(178,'Worm goes on the hook, hook goes in the water. Fish is in the water, our fish.','Worm goes on the hook, hook goes in the water. Fish is in the water, our fish.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(179,'Could ye spare some coin?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(181,'Alms for the poor?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(182,'I will gladly pay you Tuesday for a hamburger today.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(183,'Help a poor bloke out?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(184,'Spare some change for a poor blind man? ...What do you mean I\'m not blind? ...I\'M NOT BLIND! I CAN SEE!! It\'s a miracle!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(185,'Shine yer armor for a copper.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(186,'It\'s all their fault, stupid Alliance army. Just had to build their towers right behind my farm.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(187,'It\'s all their fault, stupid orcs. Had to burn my farm to the ground.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(188,'You hear that? I think they\'re getting closer...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(189,'Guard duty, I hate guard duty.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(190,'I heard all the kobolds that were down there are dead.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(192,'Sorry, Huldar... But it seems I\'ve misled you.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(194,'Dark Iron activity. Even that some of the shipments have been hijacked--','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(195,'I\'m sure it\'s just incompetence or oversight by some of the workers.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(197,'All hail, $n! Defender of The People!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(198,'The People of Westfall salute $n, a brave and valiant defender of freedom.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(199,'Three cheers for $n!  This land shall be ours once again!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(200,'Thanks for the cask of booze, $n.  I think I\'ll open up a bottle right now!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(201,'','If we reverse the Essence flows perhaps we can alter the polarity.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(203,'','So then the array of magics would cascade into a chain reaction of positively charged energies.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(204,'','The portal will shift slightly, at this point if you cast a binding cantrip you will solidify it in place.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(205,'','When the positively aligned energies collide with the negatively charged energies, they don\'t negate one another.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(206,'','Maginor says that twisting alternating flows of positive energy actually creates a much more stable flow.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(207,'','The magical wards at that point should be supported enough by the energy flux to contain the entity.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(208,'','Why can\'t we just shift the array to compensate for the variance in the flux?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(209,'','Putting in twelve centers of focus might allow the magical energies to form more solidly, adding the necessary stability.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(210,'','But what if the resulting frequency shift were to send magical feedback up the flows?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(211,'','Wouldn\'t that cause the weave to unravel if not properly anchored before starting the casting?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(212,'','But wouldn\'t that mean crossing the streams? Isn\'t that really bad?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(213,'','The resultant energies could collapse though, and that could cause an energy flux that would give you a migraine for weeks.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(214,'','But isn\'t that what caused the initial problems with Adept Syleria\'s magical formulae?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(215,'','I think not, I don\'t need to be blown up again.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(216,'','That will unbalance the magical focus, though, and cause a reverse vibration in the ether.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(217,'','I suppose that could work, if we had twenty people to cast it with.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(218,'','What if we used three focuses in Tyrean pattern? That should solve it.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(219,'','But if we stabilize it with an anchor thread at the appropriate energy crux then it should work.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(220,'','Always so negative. The chances of that happening are between zero and none.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(221,'','If we use the appropriate sequence we should be ok. Will just take some serious studying before we start.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(222,'','Wow, all of this for a love potion. Hope he\'s worth it.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(223,'','If we use the Surian theory, then yes, but not if we go with the Y\'serian approach.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(224,'','At least we wouldn\'t be around to have to clean it up.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(225,'','Only if we didn\'t follow the proper initialization procedures.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(226,'I suppose you\'re right.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(227,'','Here\'s my list, Keldric. The usual stuff.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(228,'','Thank you, Keldric. See you later.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(229,'Curse you, $n!  One day, vengeance will be mine!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(230,'Alright, we\'ve just gotten word that a caravan is leaving from Thelsamar. It\'s time to move! Go go go!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(231,'Alright, we\'re getting close to the excavation site, so we have to proceed carefully. Engage underwater breathing apparatus...','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(232,'Hey Stone, did you hear about the new steam engine old Tonkrend has been runnin on?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(233,'Ah yes. I\'ve heard all about those new flarged things. Armor was removed from the casing to decrease weight. Bargh! Nonsense!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(234,'Do you ever think about anything other than fighting? I could circle you down on the stretch course!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(235,'Bah! By the time you got in range of old Trollplow you would be in reduced to rubble!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(236,'Argh! You\'re hopeless!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(237,'Hey Fizzer, I ever tell you the time I was riding through the canals and some goblins in shredder suits tried to ambush me?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(238,'Ah, let me see. Yes probably nearing a hundred times now I\'d wager!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(239,'Brahaha! Tha look on their faces as old Trollplow\'s gun came swiveling around to meet them! Their saws couldn\'t even touch me!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(240,'I would have just dropped some Evershine in my tank and been back home before they realized I\'d gone!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(241,'Bah! That\'s no fun!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(242,'Hey Stone, let\'s hit the circuit some time. We could run a few laps and see who wins?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(244,'Aye sure, just as long as we get to hit the arena right after!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(245,'Nothing you can say will ever get me in the arena against that monstrosity of a machine you call a steam tank!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(246,'Har! You scared I\'ll hurt your little dainty racer?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(247,'Ha! I\'m more afraid that those old holes and gashes would burst that thing and I would be showered by the shrapnel!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(248,'Haha! Sturdy old Trollplow has just a few meager battle scars!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(249,'Nothing beats the sound of a twin-carb, fork-ring steam engine burning pure firestone!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(250,'Ha! I\'d take the sound of a Crater Cannon XT blasting off a shell over that any day!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(251,'Bah! You wouldn\'t know a great steam engine if it smacked you upside the head!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(252,'Maybe, but if it did hit me upside the head I\'d know exactly which cannon to use to blow it into the smallest bits!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(253,'','Corbett, dear.  Harlan needs a load of knitted shirts and pants as soon as we can manage.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(254,'','Corbett, you there?  Harlan needs another load of knitted goods.  Can you take it to him?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(255,'My pleasure, sugar drop.  I\'ll be back soon...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(256,'Business must be good down at the bazaar.  I\'ll get him resupplied right away!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(257,'Hm...after dropping this off, I think I\'ll head to that cheese shop for a snack.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(258,'I should have a few extra coins from this sale.  Maybe I\'ll buy myself some lunch...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(259,'Hey, Harlan.  Here\'s a load of knitted cloth for you.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(260,'Oomph!  Here\'s another load of supplies, Harlan.  It must be selling fast!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(261,'Ah, much appreciated, Corbett.  We\'ll get these on the racks immediately.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(262,'Ah yes, and promptly delivered.  As always, it\'s a pleasure doing business with you, Corbett.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(263,'Well, I\'m off then.  Take care, Harlan.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(264,'Glad to see you\'re doing so well, Harlan.  And I hope to see you again soon...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(265,'Lord Mayor!  Our scouts report strange activity to the west.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(266,'Mayor Ello!  Our graveyard scouts return with ominous reports...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(267,'Hideous bellows and growls are heard coming from that old hermit\'s shack!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(268,'Wolves head this way, as if fleeing from...something.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(269,'Yes, Lord Mayor.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(270,'This is grim news, and I fear it is linked to the dealings $n had with the Embalmer.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(271,'Watcher, inform Althea that a dire threat is marshalling against our town.  We must prepare!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(272,'Althea, there are reports of strange happenings at the graveyard.  Ello believes it portends an attack on Darkshire.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(273,'','This doesn\'t bode well.  Send scouts to gather more intelligence, and stay on alert.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(275,'Yes, commander!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(276,'Beware!  Beware!  A threat lurks in the wild!  Night Watchers, be on the alert!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(277,'DARKSHIRE...I HUNGER!!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(278,'ROARRRRR!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(279,'','...Nine...Ten...Ready or not.  Here I come!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(280,'','Hey! You better not have gone too far!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(281,'','Mom said not to climb up there any more.  I\'m gonna tell!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(282,'Thank you, $n.  May the Light bless you, $Gbrother:sister;, and guide your path.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(283,'Now for that snack...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(284,'Good day, Elling!  Hullo Elaine!  Let me have a wheel of bleu cheese, eh?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(285,'Hullo, Trias clan!  A ball of your smoked mozzarella, if you please!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(286,'','Good day, Corbett.  Here\'s your cheese, fresh made this morning!  And how are things at your shop?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(287,'','Hi Corbett!  Here, you go!  I trust business is faring well at your clothier shop...?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(288,'See you later, Corbett, and tell the missus hello!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(289,'Take care, and send our regards to your family.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(290,'Thank you kindly!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(291,'Thanks for the cheese!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(292,'I should get back before Rema starts to worry...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(293,'Time to get back to the shop...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(294,'I\'m back!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(295,'Yes ma\'am, business is brisk!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(296,'Testing 1','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(297,'Testing 2','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(298,'Testing 3','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(299,'I\'m out of the building again.  Now I\'ll move one more waypoint...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(300,'I\'m moving within the building','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(301,'I made it to the last waypoint.  Yay!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(302,'','Mom, Jesse climbed the wind tower again.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(303,'You\'d better not tattle on me!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(304,'I can\'t come down.  I am scared.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(305,'Whoa...Whoa..Aaaaahhh!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(306,'Work you dogs! Put your back into it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(307,'','You get down from there right now!  I don\'t want you climbing that thing.  It\'s not safe.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(308,'','See what I mean?  Get inside right now.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(310,'This will take a while to heat up, so its time for a drink! What do you say Tongus?','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(311,'PICK ME!!!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(312,'Attack!!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(313,'Get in position lads! The beasties are upon us. Wait for my signal!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(314,'These lands shall be cleansed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(316,'These undead atrocities will be destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(317,'The Scarlet Crusade shall not fail in its mission!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(318,'Stormy seas out there.  The sea spirits must be restless....hic!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(319,'I saw a Sea Giant once.  It\'s not something I would care to see again.  Burp!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(320,'I\'d go out and clear out some of those gnolls, but this leg has seen better days and I am afraid I\'d just wind up dead.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(321,'Watch your step out there.  Many an adventure seeker has not returned from the marsh.  hic!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(322,'It\'s time for my meditation, leave me.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(323,'There you are. What news from Westfall?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(324,'VanCleef sends word that the plans are underway. But he\'s heard rumors about someone snooping about.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(325,'Very well. I will return then.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(326,'Hmm, it could be that meddler Shaw. I will see what I can discover. Be off with you. I\'ll contact you again soon.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(327,'*sigh* It\'s about time to check on the cemetery again-- I\'ll be back in a few minutes.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(328,'We really should fix this fence soon.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(329,'Vrok said the sights are off on Grumlar\'s gun. I suppose I should check it.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(330,'Hmph! I didn\'t even hit the blasted target! That thick skulled dwarf was probably using the gun as a mace again.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(331,'Hmmmm... That one clipped it\'s shoulder. Grumlar was right, the sights are slightly off. Easy enough for me to fix though.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(332,'Almost perfect shot! It\'s a bit off but I can see where Grumlar would miss with it. He couldn\'t hit the broad side of a barn.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(333,'Bullseye! That blasted dwarf doesn\'t know what he is talking about. Only thing wrong with Grumlar\'s gun is Grumlar\'s aim.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(339,'Only $3658E shopping minutes before Christmas!  But wait, is it Christmas?  Well then, there are only $3659E minutes left to party!  TEST TEST DO NOT LOCALIZE','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(340,'Warg, are you about ready to eat? I am gonna get it started.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(341,'','Khara hums an old dwarven tune while she cooks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(342,'Hon, food is ready. Come wash up and eat.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(343,'Mmmm, that was good. However, time to get back to work!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(344,'Ahhh, just in time! My stomach was rumblin\' loud.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(345,'MMmmMMmmm. Smells delicious Khara.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(346,'Burp! Hon, that was really good. Not only do you know how to catch a fish but you sure do know how to cook one.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(347,'Whew! I think I ate too much. Need to loosen my belt a few notches.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(348,'Thanks for the great meal darlin\' but I need to get back out front.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(349,'Another glorious day of fishin\' is ahead of me, Khara. I best get movin\'.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(350,'What a day for fishin\'. They are sure to be bitin\' today!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(352,'Warg looks over the water appraising what his luck might be today.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(353,'Welp the fish ain\'t bitin\' no more so I might as start gutting and cleaning what I did catch today.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(355,'Best be on my way. Khara will be expecting me soon. See ya tomorrow X.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(356,'Look at all those ripples. Lots of activity in the water so I should catch a mess of fish today.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(357,'Hmmmm, only a little bit of activity on the surface but the sun is in the right place. Might turn out to be a fine day.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(358,'Not looking too good today. Sun is high and bright early and no activity on the water.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(359,'Hmph! What a sorry day for fishin\' this is going to be. Ah well, a bad day fishin\' is better then a good day workin\'.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(360,'Berte! Evalyn! It\'s getting dark. Come inside.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(361,'You can play more tomorrow. Now come on inside.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(362,'Alright, alright. You two can go play just stay in town. No sneaking off to bug Warg and Khara down by the water.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(363,'Hah! Daryl, you should have seen the look on your face! You half jumped out of your skin!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(365,'They have you good on that one, lad!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(366,'Oh, shut up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(367,'Awww Mom! It\'s hardly dark yet! Can we play for a bit longer please?','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(368,'Ok...','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(370,'We must be vigilant to eradicate this plague!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(371,'Keep up the good work.  This scourge will be cleansed!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(372,'The Scarlet Crusade will scour these lands!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(373,'Let none with the foul taint of plague live!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(374,'Mom! Can we go play please please please? Can we huh? Can we?','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(375,'The kids jump up and down with youthful energy. (PH emote)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(376,'Wheeee! Thanks Mom!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(378,'Thanks Mrs. Brightbeard!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(379,'Gettin\' a bit nippy out here. Think I will go warm myself by the fire and grab a pint or twelve.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(380,'Nothing like a roaring fire on a cool night with good friends and dwarven ale.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(381,'Brock. Torren. I am going inside for an ale and to warm myself by the fire.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(382,'Mmmmm, an ale by the fire does sound good. Sure, I will join ya Jern.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(383,'Here! Here! I\'ll drink to that!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(384,'What? Did someone say ale? Don\'t start pouring the pints without ol\' Torren!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(385,'I\'ll drink to anything!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(386,'Noma should have dinner ready soon. Might as well head in.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(387,'My, that Black Claw stout packs quite a punch!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(388,'I feel... dizzy.  It\'s so hot... in... here...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(389,'Where\'s the rest of the guys?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(390,'Every bodies coming...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(391,'He really couldn\'t help it...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(393,'No one lives forever...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(394,'','Gimlok!  Gimlok! Get in here this instant!',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(395,'','Where has the boy gotten to now?',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(396,'','Gimlok, don\'t you go and get your clothes all dirty.',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(397,'Huuup...Huuup...Bleeeeehh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(398,'I\'ll be a guard someday!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(399,'Remember when Danath gathered all the mercenaries of Stormwind together and we marched to fight at Nethergarde?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(400,'I tell ye, I don\'t miss the Great War at all. I remember when we fought at Darrowmere. All night in the fog, lying in a muddy trench.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(401,'I miss the dwarven ale we used to get at that inn in Lordaeron. Remember that fight we started there?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(402,'Less than a hundred of us, and over a thousand orcs. Only a handful of us managed to walk away from that one.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(403,'The best had to have been the look on Perenolde\'s face when our army comes marchin\' right up to his front door. What a battle!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(405,'Battling that band of Twilight Hammer in the Morass, I could think of better places for a war.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(406,'Ahh yes, now I remember, your wedding night wasn\'t it?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(407,'Ahh the Glustewelt twins!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(408,'I still have the scars from that night.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(409,'Broke both me legs that night. How could I forget?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(410,'I woke up in a bed in Northshire three weeks later. Don\'t remember a damn thing.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(411,'Wasn\'t that the night we had to pick up my thumb and carry it in your smoke pouch?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(413,'I have a piece of iron in my back that will remind me of that night for the rest of my days.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(414,'Course I remember that night. Two inches to the left and you\'d be drinking with that elf, Morris. That was my best shirt, too.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(415,'Was that the third or fourth time you nearly got me gutted trying one of your crazy stunts?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(416,'Aye and thanks for letting me carry my own hand back to the priests that night.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(417,'Hehe, wimp.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(418,'You screamed like a little girl, funniest thing I ever saw.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(419,'It all worked out in the end.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(420,'Let\'s not even begin comparing battle scars, my friend.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(421,'Never seen anyone move so fast in my whole life.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(422,'You are constantly surprising me with what a person can live through.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(423,'Well, you\'re still here. I\'d say that is something worth drinking to.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(424,'You can thank me anytime for making your life more interesting.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(425,'I... I... don\'t... feel... right...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(426,'%s waves to $n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(427,'You have disturbed my rest, $c.  Now face my wrath!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(428,'My mind... my flesh... I\'m... rotting...!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(429,'Let me have another one, Langston.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(430,'Best ale in Stormwind, Langston. Thanks.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(431,'Hey Reese, give me an\' Christoph another round.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(432,'A warm tavern and a cold ale. What more could we ask for?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(433,'%s raises the gun to his shoulder, aims it carefully then fires a shot at the target.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(434,'Die in the name of Ragnaros!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(435,'The Thandol Span fell to Ragnaros.  So shall the Stonewrought Dam!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(436,'King Magni Bronzebeard is a fool and a charlatan!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(437,'This $C intrudes on our work! Die fool!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(438,'What have we here?  $n the $C?  Attack!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(440,'All those who betray Ragnaros must die!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(441,'Kill the filthy $R!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(442,'The Stonewrought Dam will be destroyed!  Long live Ragnaros!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(443,'Weak $C! You are no match for the Stonesplinter Tribe!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(444,'A $C called $n? You\'ll make a fine breakfast!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(445,'The Stonesplinter Tribe shall see to your doom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(446,'Die, $R!  These lands belong to the Stonesplinter Tribe!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(447,'The only good $R is a dead $R!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(448,'The Loch belongs to the Stonesplinter Tribe now, $n!  Now die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(449,'$n!  Betrayer of Ragnaros!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(450,'The Dark Iron Dwarves shall reclaim their rightful lands!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(451,'Foolish $C!  You are no match for the minions of Ragnaros!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(452,'A worthless $R such as you, $n, has no right to walk these lands!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(453,'$n!  Prepare to meet your doom!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(454,'Who is this weak $C who challenges my might?  Die fool!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(455,'This land belongs to the Dark Iron Dwarves.  Prepare to see the afterlife, $C!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(456,'I am Balgaras the Foul.  And you, $n, are about to become nothing more than ash and dust.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(457,'$n, may your death stand as an example to all who challenge the Defias Brotherhood!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(458,'A mere $C challenges me?  Prepare for the afterlife!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(459,'May the Deadmines serve as your tomb, $n!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(460,'Die in the name of the Defias Brotherhood!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(461,'Death to those who wronged the Stonemasons!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(462,'The corruption of the House of Nobles runs through your veins.  Let me remove it with my blade!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(463,'Die $n!  The only good $C is a dead $C.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(464,'Who is this weak $R?  A foul intruder I say.  Die fool!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(465,'Stupid $R!  The Blackrock Clan shall dance on your grave!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(466,'Foolish $C!  You are no match for my might!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(467,'I am Gath\'Ilzogg!  And you are a $R on the brink of death!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(468,'Death to $n!  Long live the Blackrock Clan!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(469,'Who dares intrude upon the Blackrock Clan?  Death to this $R!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(470,'Tiny $C!  You are no match for the Blackrock Clan!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(471,'Foolish $C!  I will snap the bones of this weak $R!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(472,'Long live the mighty Blackrock Clan!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(473,'Die in the name of Edwin Van Cleef!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(474,'Who dares interfere with the business of the Defias Brotherhood?  Die $C!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(475,'Death to any $R that stands in my way!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(476,'Who dares to provoke the messenger of Edwin Van Cleef?  Die $R!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(477,'Am I carrying any letters addressed to $n? Why, no!  Looks like it\'s time for you to die!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(478,'I\'ll deliver you, weak $C, to the afterlife!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(479,'I have a special message for $n.  And it says you must die!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(480,'Here\'s a singing telegram for $n: Roses are red, violets are blue, I will kill any $R I see, including you!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(481,'Let\'s get to the others, and keep an eye open for those wolves outside...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(482,'Be careful, $n.  Those wolves like to hide among the trees.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(483,'We\'re almost there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(484,'We made it!  Thanks, $n.  I couldn\'t have gotten here without you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(485,'Help!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(486,'I\'ve been spotted!  $n incoming! Help!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(487,'Die you worthless $n!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(488,'Need a little help here.  That $n saw me.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(489,'$n coming in fast!  Prepare to fight!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(490,'That $n wants me dead!  Help!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(491,'What was that?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(492,'Did you hear something?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(493,'I smell a $R.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(494,'Help! We\'re being attacked! Dark Irons!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(496,'$n coming this way fast!  Prepare for attack!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(497,'We are under siege!  To arms!  Kill this $n!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(498,'Ah, here at last! It\'s going to feel so good to get rid of these barrels.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(499,'%s roars a challenge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(500,'','I shall return in time..',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(502,'The Sons of Arugal will rise against all who challenge the power of the Moonrage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(503,'Let the legend of Stalvan rest!','Let the legend of Stalvan rest!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(504,'Who is this mere $r that meddles with that which is past?  May the legend of Stalvan die along with you!','Who is this mere $r that meddles with that which is past?  May the legend of Stalvan die along with you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(505,'Toil not in matters of the past, $n!','Toil not in matters of the past, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(506,'','%s lets out a high pitched screech, calling for help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(507,'Tilloa is that you?  Why no!  It\'s just some dirty $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(508,'Who dares disturb me?  Die $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(509,'I shall spill your blood, $C!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(510,'Help! I\'ve only one hand to defend myself with.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(511,'Send them on! I\'m not afraid of some scrawny beasts!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(512,'Get him!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(513,'%s chants words of power...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(514,'No!  It can\'t be...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(515,'Incredible!  I know he who wrought these enchantments...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(516,'This is unforseen.  The being who enchanted this is known to me...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(517,'$n, I have the information you seek...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(518,'My minions...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(519,'The time for conquest approaches quickly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(520,'Soon, your thirst for destruction will be quenched.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(521,'The rage burning within you will soon find fuel in our enemies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(522,'I come with news of our conflict with the Rogue Undead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(523,'The rebels of Lordaeron are small and weak, and know not the joy of serving our Lich King.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(525,'The Dark Lady\'s followers are blind to think they can stand against our might.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(526,'We grow strong, while our foes are surrounded by foes, and weakened by constant attacks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(527,'Our Lord commands us to make ready for war!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(528,'Prepare yourselves, for we will soon launch an assault against they who called themselves \"The Forsaken.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(529,'Make ready for battle, my creations.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(530,'We are the arm of His will.  And we will crush His foes into grave dust!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(531,'These undead rabble, and their dead-elf queen, will fall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(532,'We will drive our foes from Silverpine, then bring the tides of war to their very capital!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(533,'Death and Praise for the Lich King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(534,'','It\'s good to see you again, Erland.  What is your report?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(535,'Masses of wolves are to the east, and whoever lived at Malden\'s Orchard is gone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(536,'If I am excused, then I\'d like to check on Quinn...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(537,'Hello, Quinn.  How are you faring?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(538,'Try to take better care of yourself, Quinn.  You were lucky this time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(539,'I\'ve been better.  Ivar the Foul got the better of me...','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(540,'No two-bit traitor will stop the powder from getting to Ironband!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(541,'Beware!  A $n is upon us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(542,'','Be ready, $n. I hear the council returning. Prepare to ambush!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(543,'A $n attacks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(544,'Beware!  I am under attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(545,'','Well done. A blow to Arugal no doubt!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(546,'The Stonewrought Dam has been saved!  Three cheers for $n!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(548,'','All is lost!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(549,'Make Way!  Make Way!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(551,'%s leaps from the first catapult to the second!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(552,'I\'m cursed!  First my ship sinks, and now...I\'m out of mead!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(553,'Curse you, Halyndor!  You led us to our doom!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(554,'Don\'t mind me, or my smell...because I sure don\'t!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(556,'Ah, beautiful Menethil Harbor, with the best mead this side of Ironforge.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(557,'Oh, my brothers!  May you find rest in your watery graves!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(558,'%s looks like he\'s going to be sick!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(559,'%s swaggers heavily.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(560,'%s mumbles incoherent words.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(561,'%s raises his mug to his eye, and frowns.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(562,'%s growls and looks around him aggressively','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(563,'%s begins translating ...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(564,'$n, the translation is finished!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(566,'This is a dangerous line of business!$B$BMiran just left with a delivery. He should be back in a few minutes.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(567,'They thought I was weak.  Haha!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(568,'I am the head of the family.  Me.  ME!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(569,'I\'m cold, lord.  When will you keep your promise?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(570,'My family hates me.  Frightened idiots, all of them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(571,'Father?  Are you proud of me now? HAHAH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(572,'Mother, oh mother.  You should have listened to me...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(573,'Thurman my brother, who\'s laughing now?  Hah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(574,'Here to visit the family?  Die, fool!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(575,'The Agamand Mills is held by the Scourge, $C.  Join us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(576,'I raise my brew and hope to be rid of the likes of you!  Cheers, you no good scoundrel, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(577,'%s cheers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(578,'','Stay back vile creatures!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(579,'Croak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(580,'%s sniffs the elixir then eagerly digs in!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(581,'Finally they show mercy!  They\'ve given us something to drink!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(582,'And Shindigger Stout too!  Thank the Light!  I was parched!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(583,'Your undeath is not the end of your life, but the beginning. It is up to you to decide where your fate lies now.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(584,'You are free of His control. And while you will be judged by lesser beings, at least you have chances that the Scourge do not!','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(585,'Terror, darkness, power? The Forsaken crave not these things; the Forsaken ARE these things.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(586,'My bones are weak, my eyes see only darkness, and my body feels only pain; but these things are good because my will is my own.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(587,'','Hello, Charys. I have my list, could you get me all of that, especially the last ingredient.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(588,'','Mommy? Can I pet Fizzles?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(589,'','Sure, Paige. Just be gentle.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(590,'','Thanks, Charys. C\'mon Paige, sweetie.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(591,'%s starts to chant in an ancient tongue, summoning forth something evil in nature.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(592,'Ah, it is good to be free of my bonds! Have you freed Tog\'thar yet? The humans split us up after our capture.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(593,'Have you freed Drull yet? I don\'t know where he\'s being held.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(594,'Go on ahead without me! I will make my own way to Tarren Mill.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(595,'I will only slow you down, but no pink-skinned humans will keep me from freedom!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(596,'Search this rubble.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(597,'Find me something good, you dogs!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(598,'Over here! Inside the room. Did you find the key to my chains? The human Borhuin has them.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(599,'I returned from the grave to take my revenge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(600,'Die in the name of the Dark Lady, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(601,'The undead shall feast on your soul, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(602,'I have risen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(603,'Revenge shall be mine at last!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(604,'Southshore shall pay in blood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(605,'Mmm... I love my delicious Southshore stout.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(606,'Southshore stout, how do I love thee? Let me count the ways...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(608,'Protect Foreman Bonds at all costs!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(609,'Guards! Guards!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(610,'You\'re going to pay for this outrage! Guards!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(611,'Get to your posts! Let no invader reach Southshore!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(612,'Anyone suspicious is to be taken down quickly. Get to your posts as quickly as possible!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(613,'Protect the Magistrate at all costs. They could come from any direction!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(614,'My trees.... they have withered up and died just like me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(615,'This orchard is now as barren and lifeless as my rotting shell. Once these trees bloomed with fruit but now there is only rot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(616,'I spent my whole life caring for these trees. Pruning and nurturing them... only fitting that they have joined me in death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(617,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(618,'Greetings Citizens!  Soon perhaps the tide will turn in our favor and the plague will end.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(619,'Help me! Help! Assassins in the hills! To arms! To arms!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(620,'Hear ye! Hear ye! *pant pant* Be warned citizens of Southshore: assassins are heading to our fair town!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(621,'Guards to your posts! They must be after the Magistrate again. He must be protected! They could come from any direction!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(622,'I\'m so tired *pant pant*','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(623,'The Southshore Crier grabs the back of his neck and his eyes go wide.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(626,'Assassins... save... th... Magistraaa...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(627,'They\'re here! They\'re over here! Help me!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(628,'The assassins are over here! Quickly, before they reach the Magistrate!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(629,'More agents of the Syndicate I\'ll wager! You\'ll never take back Alterac... or Southshore!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(630,'The deed is done! The Magistrate is dead-- to the shadows, my brethren.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(631,'The Magistrate has fallen! Make your escape, my brothers.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(632,'Haha! Alterac and Hillsbrad shall come under our rightful rule once again now that the Magistrate has fallen. Retreat!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(633,'The meddlers shall pay for their interference. Retreat to the shadows!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(634,'The Magistrate is too well protected. Retreat!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(635,'You may have succeeded in stopping us this time, but we shall return-- this we assure you!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(636,'','%s takes out a bottle filled with some kind of green liquid and takes a large gulp.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(637,'%s\'s eyes glow red as he lights his dynamite and begins to cackle madly!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(638,'Wahehe! I\'m taking you down with me!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(639,'All right, you lazy bums, time to get up and get started. That bridge isn\'t getting built on its own.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(640,'Ya\'ll get a few minutes to wake up, but let\'s get started soon.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(641,'Hi Ho, Hi Ho, and all that... let\'s get a move on.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(642,'Take a break, men! Half hour and then back to work.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(643,'The bridge is looking great. We keep up this pace and it\'ll be done for the first expansion forces to head north.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(645,'Okay, lunch time\'s over, guys. Let\'s get back to work. If the rest of the day goes this well, then maybe we\'ll cut out early.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(646,'Good, good. Keep it up and this bridge\'ll be done in no time.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(647,'Call it a day, men!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(648,'Day\'s wasting. Let\'s get going.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(649,'Good night, gents. Sleep well.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(650,'Morning, my friends.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(651,'Ahh... food It\'s \'bout time.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(652,'Tis a good day to live, neh? Hard work and good food-- there are worse things we could be doing on such a beautiful day.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(654,'*Dimitri wipes sweat from his forehead and lays down his tools*','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(655,'Another good day indeed.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(656,'Good night, my friends. Until tomorrow.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(657,'Can\'t we just sleep a while longer?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(658,'Okay, okay... I\'m up.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(659,'\'Bout time. I was hungry an hour ago.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(660,'Finally! I can\'t wait to get some sleep tonight.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(661,'Ugh! Being on your feet all day is no way to make a living. I should have been a tailor.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(662,'I love mornings! It\'s a great day, isn\'t it? Smell that air?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(664,'By the Light, I\'m hungry today. Did you all see Darcy today? She looked great.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(665,'You know, this bridge is kind of large for just the 6 of us to be building. You\'d think more people would\'ve been hired.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(666,'You guys see her? I didn\'t see Darcy. I wonder where she is tonight.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(667,'%s looks up and down the docks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(669,'Oh well, I\'m sure she\'ll be around later.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(670,'Night, all. I\'m gonna sit up for a bit. Maybe Darcy\'ll come by.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(671,'Huh?! Darn it, it\'s lunch time! I overslept!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(672,'%s runs up to the other bridge workers, panting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(674,'Sorry, ah\'m late.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(675,'This bridge isn\'t ever going to be finished, is it?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(676,'My back is killing me today.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(677,'Little food\'ll feel pretty good right about now.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(678,'Mmm, good stuff. Back to work once again.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(679,'Another day gone by...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(680,'Night, night.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(681,'%s is struck dumb by the Soul Gem!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(682,'%s\'s spirit is freed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(683,'%s lets out a deep sigh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(684,'I hate this part of my job. Oh Duskwood, be gentle with poor Antonio.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(685,'Items of antiquity, weapons of war, armor or rarity. Who knows what Antonio will be carrying this week if you do not come look.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(686,'This week it could be eye of newt, or perhaps a treasure map. You\'ll never know unless you look. What could Antonio have?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(687,'Adventurers from all over sell things to Antonio-- come look for yourselves what little treasures he has for you this week.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(688,'Travelers and adventurers make haste to the town circle and take advantage of Antonio\'s wonderful prices! Come one, come all!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(689,'Well met, travelers of Duskwood! My incredible wares are on sale for a short time in Darkshire. Make haste!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(690,'Leave your battles or errands, and browse my incredible wares! Only in Darkshire for a short time... praise the Light for that.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(691,'Farewell, citizens of Darkshire. Until next time...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(692,'Finally, Redridge. A pleasant change from the dark, cold fog of Duskwood.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(693,'Ha ha! I have Betsy!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(694,'','Gimme my dolly!!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(695,'','Betsy! Give me Betsy back!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(696,'','Don\'t hurt Betsy, you meanie!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(697,'','WAAAHHH!!!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(698,'','I\'m telling Mommy!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(699,'','Stop pulling her hair out!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(700,'','You\'re hurting her!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(701,'','Stop! You\'ll pull her head off!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(702,'Hello, hello, Amy. It\'s good to be back in Lakeshire and to see you, milady.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(703,'','Hello, Antonio. It\'s good to see you safely made it here again. Let me know if you need anything.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(704,'Hear ye, hear ye! I\'ll pause to sell my wares for only a short time here in Lakeshire. Come to the town hall with haste!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(705,'I wonder if your dolly can swim!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(706,'I have your dolly! Nyah nyah!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(707,'What happens when I do this?!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(708,'If you want her back you\'re gonna have to beg!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(709,'Crybaby! Crybaby!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(710,'Baby wants her dolly!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(711,'Oops!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(712,'I\'ve finally reached Lakeshire-- come one, come all, and take advantage of Antonio Perelli\'s wonderful deals.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(713,'Items powerful enough to help make the journey through Duskwood, Antonio Perelli\'s goods are now for sale here in Lakeshire.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(714,'Good to see you again, Amy. Be safe, luv. I\'m off to Goldshire now.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(715,'','Take care of yourself, Antonio. I\'ll see you in another week.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(716,'Hello, my friends. It is good to see you again. Still keeping our borders free I see. Antonio appreciates your hard work.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(717,'You\'re very welcome! I must be on my way... be safe, all of you.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(718,'Hello again, Antonio. Thank you again for the hat for my wife. She adored it.','Hello again, Antonio. Thank you again for the hat for my wife. She adored it.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(719,'Be safe, Antonio.','Be safe, Antonio.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(720,'Oh, I will, my friend. I will indeed. You, too, be safe.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(721,'Wares for sale! Wares for sale! Come browse Antonio\'s wares before I must take my leave, citizens of Goldshire.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(722,'Come one, come all! Antonio\'s wares are for sale. I may not return for a great deal of time, so come one, come all.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(723,'Good people of Goldshire, come take advantage of my incredible prices on rare goods. I shall not return for some time!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(724,'Good bye, Goldshire. I\'ll be back soon enough-- perhaps a week\'s time.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(725,'Home again, home again.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(726,'Known throughout the lands, Antonio Perelli\'s goods now for sale near Sentinel Hill! I must move on soon, so make haste.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(727,'Long-lasting, well-crafted items for sale near the Hill! Come one, come all! Time is short, so make haste.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(728,'The time has come for me to once again make my wares available to all who travel near Sentinel Hill! Come one, come all!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(729,'Thank you, all. I shall return again in about a week.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(730,'Off to Darkshire then, I suppose.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(731,'Mmmh...I SMELL FOOD!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(732,'%s searches through the skulls...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(733,'%s continues searching, placing more skulls in his crate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(734,'I am done inspecting the skulls, $n, and I am relieved.  Yenniku is not among them...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(735,'Ah, good $n.  Now let us see what tale these heads tell...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(736,'%s begins chanting...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(737,'Where in the Outlands are those shipments? For days they keep me waiting!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(738,'Stupidity! I\'m surrounded by stupidity!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(739,'Orcs are smarter than those couriers! Where the blazes are they?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(740,'There, $n.  You may now speak to the Bloodscalp chief and his witchdoctor.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(741,'%s begins to summon in reinforcements!','%s begins to summon in reinforcements!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(742,'%s presents the Mind\'s Eye and the Singing Crystals before him...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(743,'I have fashioned Yenniku\'s Soul Gem, $n...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(744,'%s tries opening Maury\'s Clubbed Foot...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(745,'Aha!  It opened!  I expected that to be harder.  Thanks for your help, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(746,'Alright I\'m going! Stop yelling!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(747,'This better be the last one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(749,'You better back me up on this one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(750,'Why did I have to get stuck with this repulsive, feeble excuse for a warlock?','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(751,'Make yourself useful and help me out here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(752,'Just release me already! I\'ve had enough!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(753,'What? You mean you can\'t kill this one by yourself?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(754,'If you touch me again it\'ll be the last thing you touch!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(757,'%s begins to crack and break apart.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(758,'%s\'s strength dwindles as chunks of rock break off.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(759,'%s is reduced to rubble, but still continues to fight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(761,'How interesting... the Stone possesses great magical potential, but in a purely raw form...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(763,'AH, A FEAST!  WHO LEFT THIS HERE...?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(764,'SMOTTS!  HEY, SMOTTS!!  COME OUT AND PLAY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(765,'','Thank you again for your aid. May the wind always be at your back during your travels.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(766,'You have completed the quest!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(767,'Here come the beasts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(768,'You have failed to protect me from the apes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(769,'What is happening? What force draws me to the Altar of the Tides!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(770,'More beasts on the way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(771,'Dirty beasts! Here they come!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(772,'YOU WERE SUCH GOOD SPORT THE LAST TIME...COME OUT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(773,'SMOTTS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(774,'I PROMISE I WON\'T KILL YOUR CREW THIS TIME.  HAH!  BUT MY BROTHER MIGHT EAT THEM!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(775,'COME OUT TO JANEIRO\'S POINT.  I\'M WAITING FOR YOU, SMOTTS...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(776,'DON\'T YOU WANT TO FIGHT, SMOTTS!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(777,'HAVE YOU RUN OUT OF SHIPS TO SEND?  WHERE\'S YOUR COURAGE?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(778,'DON\'T LET THIS STATUE BE MY ONLY COMPANY.  COME OUT AND PLAY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(779,'%s tosses down his bottle of poison in desperation!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(780,'%s takes out a remote control and tosses down a model siege engine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(781,'%s begins to glow and smoke!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(782,'Still no sign of the final shipment of explosives.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(783,'No sign of the final explosives shipment to the west either.  Where are those lollygaggers?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(784,'This bridge should have been destroyed by now.  How long does it take for those lazy sods to get here from the Highlands!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(785,'Help me! Help me! Don\'t let them eat me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(786,'Please save me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(787,'I don\'t want to be a meal for an ogre! Please save me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(788,'Heeeeeeeeeeeeellllllllllllllllllllllllp!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(789,'I tire of this nonsense! Prepare to die!','I tire of this nonsense! Prepare to die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(790,'Sure does seem like it\'s been a long time since anyone has relieved me from my post.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(791,'Well, that\'s what I get for oversleeping!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(792,'','%s reads Sully\'s letter page by page.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(793,'','This isn\'t fair!  My dearest Sully!  Come back to me!  No, $n!  Why did you bring me such news!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(794,'Hiccup!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(795,'These shards give me the creeps.  Hey Greeby, did you find more motes?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(796,'I wouldn\'t tell you if I did!  Because as soon as I do, I\'m getting away from these crystals...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(797,'Yeah, I don\'t want to be here if Myzrael wakes up.  They say she has a mean temper...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(798,'Easier than I expected... the sigil of Thoradin is whole, once again.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(799,'May I bask in your shadow forever!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(800,'Master, your wisdom is matched only by your hugeness!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(801,'If I had a copper for each of your great deeds, I\'d be a rich kobold!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(802,'You will keep us safe from the evil mistress, yes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(803,'Oh, praise!  Your vigilance keeps Myzrael deep in the earth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(804,'My only wish is to serve you, great one, until I die by your foot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(805,'Your strength is of the mountain.  Your grace is of the winds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(806,'My feet hurt...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(807,'Die!  You will not free Myzrael!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(808,'The Great One will smash you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(809,'Aren\'t you a little short for your kind?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(810,'My life means nothing!  Our sacred task is all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(811,'If you mean to free Myzrael, you will be sorry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(812,'Stand firm, brothers.  And don\'t worry!  Size is on our side!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(814,'Take that!  The Drywhiskers will prevail!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(815,'No!  Leave us!  We must not fail our task!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(816,'','Well then, let\'s get this started. The longer we\'re here, the more damage the undead could be doing back in Hillsbrad.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(817,'','Alright, this is where we really have to be on our paws. Be ready!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(818,'','Watch my rear! I\'ll see what I can find in all this junk...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(819,'','%s begins rummaging through the apothecary\'s belongings.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(820,'','Found something... I think.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(821,'','I bet Quae\'ll think this is important. She\'s pretty knowledgeable about these things--no expert, but knowledgeable.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(822,'','Okay, let\'s get out of here quick quick! Try and keep up. I\'m going to make a break for it.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(823,'You made it?! I\'m surprised Kinelory didn\'t slow you down anymore than that. Kin, here\'s your socks. Give me what you found ins','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(824,'%s studies the circle of stones, looking for signs of stress.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(825,'You will never defeat us!','You will never defeat us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(826,'My death matters little... the Hammer will still fall!','My death matters little... the Hammer will still fall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(827,'My life for my masters.  Rejoice!','My life for my masters.  Rejoice!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(828,'Curse you!','Curse you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(829,'Glory and blood for the Old Gods!','Glory and blood for the Old Gods!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(830,'My lords!  I come to thee!','My lords!  I come to thee!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(831,'Your victory here only speeds your doom!','Your victory here only speeds your doom!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(832,'Mommy!','Mommy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(833,'Intruders!  Slay them!','Intruders!  Slay them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(834,'For our Masters!','For our Masters!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(835,'Masters, I pledge this $r to you!','Masters, I pledge this $r to you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(836,'Carnage!  May I spill blood in His name!','Carnage!  May I spill blood in His name!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(837,'Embrace the end!','Embrace the end!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(838,'Battle!  I can smell your fear, $c!','Battle!  I can smell your fear, $c!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(839,'Death comes!  Rejoice!','Death comes!  Rejoice!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(840,'Intruders!  Good, I was getting bored...','Intruders!  Good, I was getting bored...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(841,'Stop!  Foolish $c, we cannot let you summon the creature Myzrael!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(842,'','What?  $n, you served me well, but...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(843,'','Why have you summoned me so soon?  I haven\'t yet reached my full power!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(844,'','No matter.  You were a fool to help me, and now you will pay!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(845,'Ok, $n. Follow me to the cave where I\'ll attempt to harness the power of the rune stone into these goggles.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(846,'I discovered this cave on our first day here.  I believe the energy in the stone can be used to our advantage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(847,'I\'ll begin drawing energy from the stone.  Your job, $n, is to defend me. This place is cursed...trust me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(848,'%s begins tinkering with the goggles before the stone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(849,'Almost done! Just a little longer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(850,'I\'ve done it! I have harnessed the power of the stone into the goggles! Let\'s get out of here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(851,'Phew! Glad to be back from that creepy cave.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(852,'Bah! Failed again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(853,'%s is ripped apart as it is banished from this world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(854,'You\'ve plundered our treasures too long.  Prepare to meet your watery grave!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(855,'Nothing will stop us!  You will die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(856,'%s frantically whispers something to Shake\'s O\'Breen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(857,'Wait, $n!!! It looks like we\'re going to need some help here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(858,'Help!! I told you this place was cursed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(859,'Help!!! Get these things off me so I can get my work done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(860,'%s carefully studies Sara Balloo\'s note and lets out a long, solemn sigh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(861,'What is this power that flows through me? Is this the power of shamanism that Tor\'gan spoke of...?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(862,'Amazing! I feel... renewed. My strength returns!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(863,'If we can just hold them now, I am sure we will be in the clear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(864,'Here we go...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(865,'I\'ll go secure below.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(866,'Captain is dead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(867,'We survived!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(868,'%s winks at $n knowingly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(869,'%s nods his head at $n, and sighs thoughtfully.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(870,'%s begins searching through his pack...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(871,'Ah!  There is my ratchet!  Now let\'s re-attach these scroll fragments.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(872,'There we are, $n.  The Scroll is fixed!  Hooray!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(873,'','%s begins to search through the badges of fallen Stromgarde defenders...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(874,'','Privates Marcus, Tremane, Osgood, Lampret...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(875,'','Privates Fontane, MacDugal, Wilcott...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(876,'','Privates Theoric, Kitrin, Blythe, Agmond...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(877,'','Privates Horus, Tilling, Rockwell...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(878,'','...Sampson, Yorick, Chamley...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(879,'','Clemens, Bartholemew, Enderman, Wyles...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(880,'','Tormil, Gamlor, Shefferd, Cowry...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(881,'','Martens, Reblock, Adinay, Nikeson...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(882,'','%s sighs...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(883,'','So many lost.  And so many more we must lose before this battle ends.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(884,'','Thank you for these badges, $n.  I will send news to the families of the deceased.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(885,'%s concocts a potion for $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(886,'Ribbit! No!! This cannot...ribbit...be! You have duped me with...ribbit...your foul trickery! Ribbit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(887,'%s cooks up a batch of spicy hot buzzard wings for $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(888,'The nightmare of Ursal is over! We are free!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(889,'%s hands the glowing goggles over to Doctor Draxlegauge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(890,'Doctor Draxlegauge will give you further instructions, $n. Many thanks for your help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(891,'','%s hands her pack to Quae.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(892,'','We made it! Quae, we made it!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(893,'Gee, fish sure don\'t seem to be biting here. Maybe I should go over to Crystal Lake to try my luck there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(894,'Dang! Fish aren\'t biting here either. I am gonna go back to my ol\' fishin\' hole!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(895,'You will never stop the Forsaken, $r. The Dark Lady shall make you suffer.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(896,'You have my word that I shall find a use for your body after I\'ve killed you, $r.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(897,'','Attack me if you will, but you won\'t stop me from getting back to Quae.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(898,'I am well versed in over 4 languages.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(899,'Brzt... click... whir...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(900,'Master, where have all the trees gone?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(901,'We can make it better, stronger, faster. We have the technology. We have the magic.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(902,'One day I\'ll be a real boy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(903,'It can get really hot here in the Badlands. But at least it\'s a dry heat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(904,'Gizmos... check. Doothingies... check. Wizzers... check.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(905,'It is dangerous here, master. But I shall help stand guard.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(906,'%s starts flapping its wings and sqwaking loudly.  You have a feeling that you are about to be its next meal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(907,'%s seems much calmer now that it has eaten the remains of $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(908,'','The forest spirits are uneasy...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(909,'','The Blackwood tribe is disrupting our sacred lands.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(910,'','Something needs to be done about the Blackwood tribe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(911,'','A corruption taints our sacred forest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(912,'','The Blackwood tribe must not be permitted to interfere with the progress of nature.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(913,'','I sense danger deep within the grove...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(914,'%s reads the ancient text $n fetched for him...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(915,'Aha!  That\'s it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(916,'Karnik, me friend, I wish I could see you with me own eyes again, but we need\'ta talk of Ragnaros. His influence is spreading.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(917,'Hammertoe, you\'re as smart as you were stubborn in life and even in death. What can you tell me, ole friend?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(918,'I\'ll tell you more, Karnik, in time. But first, send this traveler\'ta Belgrum--there\'s more business\'ta attend to.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(919,'%s stows the items $n gave him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(920,'I thank you, $n.  My associates who will do great things with these...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(921,'%s accepts the relics from $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(922,'Accept my thanks, $n.  Yagyin\'s journal shall be yours.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(923,'%s hunkers down to read Yagyin\'s Digest...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(924,'%s is struck by unleashed magic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(925,'Ok, $n, let\'s go find where I left that mysterious fossil. Follow me!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(926,'Now where did I put that mysterious fossil? Ah, maybe up there...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(927,'Hrm, nothing up here.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(928,'No mysterious fossil here... Ah, but my copy of Green Hills of Stranglethorn.  What a good book!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(929,'I bet you I left it in the tent!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(930,'Oh wait, that\'s Hollee\'s tent... and it\'s empty.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(931,'Interesting... I hadn\'t noticed this earlier...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(932,'%s inspects the ancient, mossy stone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(933,'Oh wait! I\'m supposed to be looking for that mysterious fossil!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(934,'Ow.  Spicy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(935,'Nope, didn\'t leave the fossil back here!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(936,'Ah, I remember now! I gave the mysterious fossil to Hollee! Check with her.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(937,'%s goes back to work, oblivious to everything around him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(938,'Oh my! What\'s this? Help!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(939,'Looks like we\'ve uncovered this $n. Now help me kill it!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(940,'Help me! This $n won\'t get off of me!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(941,'Something tells me this $n wants the mysterious fossil too. Help!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(942,'$n! Help!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(943,'Can you get this $n off me?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(944,'%s beings to draw energy from the earth','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(945,'%s stares to the northwest and lets out a long, drawn out howl.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(946,'%s lets forth a mighty howl.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(947,'I\'ve been expecting you, $n.','',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(948,'Now to test my design!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(949,'Oh no!  It\'s out of control!  Run!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(950,'I guess I\'d better do something about this!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(951,'Protect master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(952,'%s begins a rite of creation...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(953,'It is done.','',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(954,'The totem is made, $n.','',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(955,'%s holds high the items $n gave him...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(956,'Ragnaros? Terrible news indeed...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(957,'Go with speed... <cough cough> Find... <cough> Ryedol...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(958,'You heard him, traveler. Speak to me again when you\'re ready to speak to Belgrum.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(959,'%s looks over at Lotwil nervously.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(960,'Hi, I am here for training.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(961,'When will someone do something about the undead?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(962,'Where is everyone?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(963,'I can\'t even visit my father\'s grave in peace anymore.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(964,'Why haven\'t the Stormwind guards come?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(965,'I fear something dark is coming.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(966,'The light appears to have forsaken us.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(967,'Have fun in Booty Bay, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(968,'Enjoy the trip to Ratchet, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(969,'Off to Orgrimmar with you, $n. Say hi to Thrall for me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(970,'Off to the Undercity with you, $n! Try not to catch the plague...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(971,'Off to Grom\'Gol with you, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(972,'Off to Orgrimmar with you, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(973,'Off to Grom\'Gol with you, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(974,'Off to the Undercity with you, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(975,'%s starts to go through his bags looking for the correct spell component.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(976,'WHO DARES?! You shall be destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(977,'HELLO WORLD!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(978,'mumble mumble...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(979,'%s falls to the ground. His spirit is released with his last breath.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(980,'Step away from the Lieutenant\'s belongings!','Step away from the Lieutenant\'s belongings!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(981,'%s listens to $n\'s report...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(982,'What??  The Burning Blade is spreading!  We must investigate!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(983,'I thank you, $n.  And my brother thanks you.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(984,'%s smashes the dead, twisted claw.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(985,'We will suffer no demon\'s servant in our lands!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(986,'%s enters a trance...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(987,'%s is burned by unleashed magic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(988,'$n, unlocking the secret of these collars is beyond my skills...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(989,'Argh!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(990,'%s inspects the Searing Collar...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(991,'Interesting, very interesting.  You found this in Durotar, $n?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(992,'The collar is indeed infused with demonic power, $n.  This bodes ill for our people.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(993,'Hm...it is good that you brought this to me, $n.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(994,'A dangerous device this is, $n.  I am glad you brought it to my attention.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(995,'Fresh Bread! Get your oven fresh bread here!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(996,'Get\'em while they are nice and fresh! Loaves of bread here!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(997,'All kinds of bread here! Made fresh today. Get\'em while they last!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(998,'Bread here! Loaves of your favorites! Nice and fresh!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(999,'%s enters a trance...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1000,'%s uses $n\'s offering in a ritual...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1001,'%s accepts $n\'s offering, and begins to chant...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1002,'%s draws power to him...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1003,'%s transforms the items $n gave him into a totem of cleansing...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1004,'%s creates a new totem...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1005,'I have the totem of cleansing, $n.','',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(1006,'The totem is made.  The well may now be cleansed.','',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(1007,'$n, I have created the cleansing totem.','',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(1008,'The deed is done.  The totem is made.','',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(1009,'I have created the totem.  You, $n, must cleanse the well.','',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(1010,'The items you offered were pure, $n.  This new cleansing totem is strong.','',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(1011,'%s begins chanting as he mixes the well stones and ambercorn before the Tribal Fire.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1012,'The Water of the Seers is ready for your consumption, $n.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1013,'Take a Candle of Beckoning from this crate, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1014,'My sword Archeus served me well in life, but as at last my spirit may pass from the unhappy existence, I need it no longer.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1015,'I shall cling to the love of my daughter and hope that I will find forgiveness under the Light for my sins.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1016,'%s becomes dazed','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1017,'I am slain!  Summon Verog!','I am slain!  Summon Verog!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1018,'Deep doom','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1019,'Deep doom','',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(1020,'%s watches as his blood begins to stir, and the guile of the raptor slips through him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1021,'%s grinds the pearls $n gave him...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1022,'Look out!  We\'re under attack by a $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1023,'There we are.  A new batch of flash bombs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1024,'Take that, beast!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1025,'%s tosses dynamite through the air and it lands near by.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1026,'The power of the Tear of the Moons is mine! Mine I say!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1027,'%s begins to rub the Tear of the Moons.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1028,'Power! Glorious power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1029,'%s begins to make strange grunting noises. The Tear of the Moons drops to the ground and shatters.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1030,'Whoa!...Whoa!...Ahh!  That was close.  Whoops!...Oh the pain, dear boy the pain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1031,'Alright, alright! I think I can figure out how to operate this thing...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1032,'Okay, I think I\'ve got it, now. Follow me, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1033,'Looks like we\'re out of the woods, eh? Wonder what this does...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1034,'I\'ve got to get this to Ratchet and nothing\'s going to stop me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1035,'Help! Wait! It\'s like this thing has a mind of its own!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1036,'See how you like a taste of this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1037,'I\'m going to die, I just know it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1038,'Take that! Oh... I must have hit the wrong button... Wait, try this one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1039,'Arrrgh! This isn\'t right!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1040,'There\'s the stolen shredder! Stop it or Lugwizzle will have our hides!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1041,'That was a close one! Well, let\'s get going, we\'re almost there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1043,'Come on, don\'t break down on me now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1044,'Hm... I don\'t think this blinking red light is a good thing...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1045,'Oh boy. Do you suppose Sputtervalve will mind if the shredder is just a little bit ... inoperable?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1046,'I\'ll try to get it started again. You go ahead. I\'ll find my way back on my own.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1047,'%s shimmers, flashes...and is no more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1048,'%s calls more of his allies out of the shadows.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1049,'%s\'s anger explodes as he goes into a frenzied rage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1051,'Frigate Ho! \'Tis an Orc vessel no doubt! Fire!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1052,'What\'s that on the horizon? Enemy ship no doubt! Fire!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1053,'Sails on the eastern horizon. Invaders no doubt! Fire!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1054,'There\'s something out there. Let loose a warning round!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1055,'What was that? Sea giant? Better safe than sorry. Fire!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1056,'Enemy ho! Fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1057,'Enemy fleet yonder! Fire!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1058,'Marauders to the north! Fire!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1059,'Inland invaders! Fire!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1060,'Enemy spotted! Fire!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1061,'Raiders from the northwest! Fire!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1062,'Raiding party over yonder! Fire!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1063,'%s hears the call for help and suits up for battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1064,'%s calls for help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1065,'Stay close, $n. I\'ll need all the help I can get to break out of here. Let\'s go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1066,'At last! Free from Northwatch Hold! I need a moment to catch my breath....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1067,'Now I feel better. Let\'s get back to Ratchet. Come on, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1068,'Looks like the Southsea Freebooters are heavily entrenched on the coast. This could get rough.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1069,'Almost back to Ratchet! Let\'s keep up the pace...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1070,'Ah, the sweet salt air of Ratchet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1071,'Captain Brightsun, $n here has freed me! $n, I am certain the Captain will reward your bravery.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1072,'$n coming right at us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1073,'Get this $n off of me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1074,'Help! $n attacking!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1075,'$n heading this way fast! Time for revenge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1076,'%s places the spores within his alchemical instruments...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1077,'Ah, good.  These spores have rendered nicely.  Thank you, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1078,'Thank you for the spores, $n.  They are now prepared for transport.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1079,'I am summoned!  Intruders, come to my tent and face your death!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1080,'%s digs its way out of the sand to protect its eggs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1081,'Thanks, $n.  I\'ll be selling those drinks in no time!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1082,'Many thanks, $n.  These horns are going to make me a fortune!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1083,'I\'m going to make a fortune with these horns, $n.  Thanks!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1084,'Thanks!  And when I make my drinks...don\'t tell anyone what they\'re made of!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1085,'%s inspects the snapjaw shells...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1086,'C\'mon, let\'s try somewhere else.','C\'mon, let\'s try somewhere else.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1087,'Hm...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1088,'Strange.  Very strange...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1089,'$n. These shells tell me much, but I fear many more questions are now raised...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1090,'Hey guys, let\'s try on the other side.','Hey guys, let\'s try on the other side.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1091,'Billy says Fizzles used to be a great wizard. But he got turned into a rabbit when one of his spells went bad.','Billy says Fizzles used to be a great wizard. But he got turned into a rabbit when one of his spells went bad.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1092,'Are we there yet?','Are we there yet?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1093,'Why are we goin\' this way?','Why are we goin\' this way?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1094,'Where we goin\'?','Where we goin\'?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1095,'I need to pee.','I need to pee.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1097,'I wanna see the Mage Tower.','I wanna see the Mage Tower.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1098,'Is it true? Are there really crocolisks in the canals?','Is it true? Are there really crocolisks in the canals?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1099,'My feet hurt.','My feet hurt.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1100,'Why do we always go the same way?','Why do we always go the same way?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1101,'Fresh bread for sale!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1102,'Warm, wholesome bread!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1103,'Rolls, buns and bread. Baked fresh!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1104,'Freshly baked bread for sale!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1105,'','Where\'s the water, Emma? Get the water, Emma? If\'n it weren\'t fer me, that lot wouldn\'t know what water looks like.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1106,'','As if I don\'t have better things to do in my old age than carry buckets of water.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1107,'','Seems like a hundred times a day I walk all the way to the well to get more water. No respect for their elders I tell ya.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1108,'','O\'course I\'m talkin to myself. Only way to get decent conversation in this city.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1109,'','One of these days I\'m gonna drown him in that blue robe. And all his brooms too.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1110,'','Jack and Jill my wrinkled patoot! I do all the water luggin\' \'round here.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1111,'','Think I\'m starting to wear a rut in the paving stones.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1112,'','Deja vu.  For a moment, I thought I was back home... before the plague...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1113,'Oh now you\'ve gone and angered me! Time to see the true force of the Stone of Tides!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1114,'%s exchanges quiet words with $n, and hands $ghim:her; a small object.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1115,'Take a stone from the table, $n.  You will need it for your quest.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1116,'','By the strength of the earth, the power of storms, and...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1117,'','ARRRRRGGGHHH!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1118,'','What has happened, Earthmother? Why has the spell failed?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1119,'Ok I am here.  Come buy my wares while the getting is good.  I mean I am giving you first crack at these.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1120,'','Sergra falls into a trance for a moment, then looks to the sky.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1121,'','I understand, Earthmother.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1122,'No point in wasting any more time here. Ghosts don\'t have money!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1123,'Now you\'ve gone and done it. I thought you were better than the people at Southshore. They would have bought all my wares! Too bad they\'re all dead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1124,'','Earthmother, grant me the power to undo this bloodshed!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1125,'','Balance has been restored!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1126,'%s examines the Moss-twined Heart...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1127,'$n, underneath the moss, this heart looks like a seed!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1128,'Let\'s try planting it in some of my special, prepared soil...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1129,'','Here we have the Cathedral of Light, the center of spiritual enlightenment here in Stormwind.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1130,'Why do we have to learn this stuff anyway?','Why do we have to learn this stuff anyway?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1131,'It\'s better than the drawings in the history tomes.','It\'s better than the drawings in the history tomes.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1132,'I wanna see the dragon skeleton in the great library.','I wanna see the dragon skeleton in the great library.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1133,'Teacher, when are we gonna see the sparkly Mage Tower?','Teacher, when are we gonna see the sparkly Mage Tower?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1134,'I heard there are still orcs buried underneath it.','I heard there are still orcs buried underneath it.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1136,'Teacher, I have to pee!','Teacher, I have to pee!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1138,'Teacher are there night elves in Stormwind? I\'ve never seen a night elf before.','Teacher are there night elves in Stormwind? I\'ve never seen a night elf before.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1139,'Teacher, he keeps poking me!','Teacher, he keeps poking me!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1140,'','Here we have Stormwind Keep. Built upon the ruins of Stormwind Castle, which was destroyed by the Horde in the first Great War.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1141,'','TEST',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1142,'You rabble get to work.  The ship must be completed soon.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1143,'Intruders!  Slay them!  Don\'t let them into the room!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1144,'Next time I see one of you not working, I\'ll have Buzzer cut your head off!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1145,'The cannons must be finished soon.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1146,'Get those parts moving down to the ship!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1147,'Anyone want to take a break?  Well too bad!  Get to work you oafs!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1148,'You there! Check out that noise!','You there! Check out that noise!',0,0,0,0,0,0,0,0,1,0,5775,5775,26124),
(1149,'We\'re under attack! Avast, ye swabs! Repel the invaders!','We\'re under attack! Avast, ye swabs! Repel the invaders!',0,0,0,0,0,0,0,0,1,0,5777,5777,26124),
(1150,'%s attempts to run away in fear!','%s attempts to run away in fear!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1151,'%s goes into a rage after seeing a friend fall in battle!','%s goes into a rage after seeing a friend fall in battle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1152,'%s plants the Moss-twined Heart...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1153,'Is it true that the paladins train here?','Is it true that the paladins train here?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1154,'','Yes, that is true. Paladins and priests alike train their skills and research great truths behind the walls of the Cathedral.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1155,'','Children if you would please follow me, we will now be going to see the keep where King Anduin Wrynn himself sits on his throne.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1156,'%s removes the seeds from the Glowing Fruit...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1157,'Let\'s see how these seeds grow in my prepared soil...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1158,'%s plants the fruit seeds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1159,'%s hurries to his planter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1160,'I hope this frond takes root...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1161,'','When the Horde was shattered, men returned here and began to rebuild the once great city as a testament to our own survival.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1162,'','Yes, well...let\'s head on to the monument dedicated to the heroes of the two Great Wars, the Valley of Heroes. Follow me.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1163,'','Isn\'t it amazing, children? All who enter the city must walk beneath the watchful eyes of the greatest heroes of our lands.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1165,'','Breathtaking. Children, when we return to the school, you will each give an oral report on one of these legendary people.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1166,'','Now, take another long look before we make our way to the Holy District and the great Cathedral of Light.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1167,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1168,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1169,'','Oh no... Mist... what has happened...?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1174,'%s rises from the soil!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1175,'%s rises from the soil!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1176,'KILL!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1177,'%s happily follows $n as $ghis:her; new seedling.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1178,'I will protect you!','',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(1179,'%s begins to manipulate the Stone of Relu over the two fossils.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1180,'By the stars! A spirit has been summoned!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1181,'It\'s a mystery of the past indeed! But a key to our future!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1182,'Who hath summoned forth Aman?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1183,'Ah, I see you toil with relics of the past.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1184,'Be warned that even your creators are fallible.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1185,'Digging too deep into your past might bring an abrupt end to your future.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1186,'','%s hides among the bushes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1187,'%s dissipates before your eyes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1188,'','I can make it the rest of the way, $n.  THANKS!',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(1189,'','Ok, let\'s go!',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(1190,'','%s disappears into the woods.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1191,'%s goes into a frenzy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1192,'Ask me how to get a free drink at the Blue Recluse!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1193,'Free drinks at the Blue Recluse!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1194,'Head on over to the Blue Recluse. Where everybody knows your name!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1195,'Best drinks in Stormwind!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1196,'Come for the beer, stay for the atmosphere!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1197,'Magical studies stressing your brain? Relax at the Blue Recluse!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1198,'The only place in Stormwind where magic and spirits mix, come to the Blue Recluse!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1199,'Feeling blue? Come on down to the Blue Recluse for a good time!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1200,'','Feeling hot? Get something to cool you off down at the Pig and Whistle!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1201,'','Nightly brawls and great drinks! Get it all at the Pig and Whistle!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1202,'','Get a free beer at the Pig and Whistle!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1203,'','Talk to me for a free beer at the Pig and Whistle!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1205,'','Smoother than and elf, stronger than an orc! No better drinks in all of Stormwind!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1206,'','Tired of all those pansy spellcaster drinks? Try something stronger at the Pig and Whistle!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1207,'','Back from a long journey? Rest and relax at the Pig and Whistle!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1208,'','Best drinks in Stormwind!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1209,'%s is hungry...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1210,'Cliffspring Falls lies along the mountains to the east and north.','',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(1211,'Thank you, $n.  And luck to you.','',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(1212,'Best weapons in the Barrens here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1213,'Step right up! Finest selection of weapons this side of Ashenvale!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1214,'Lizzarik has blades. Lizzarik has maces. Lizzarik has all your weapon needs right here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1215,'Act quick! Once it\'s gone, it\'s gone! Get your weapons here now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1216,'%s studies the parchment from the Twilight Tome...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1217,'%s is struck by unleashed magic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1218,'Hmm...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1219,'%s continues his meditations...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1221,'%s leans down to examine his shot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1222,'Uthrok make gud shot','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1223,'Athrikus points at you as he bellows forth words that scrape apart the inside of your ears. They are the last thing you hear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1224,'','Finally, my soul may rest... Oh, dearest Cerellean...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1225,'%s faces southeast and whimpers before looking back at you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1226,'%s roars at Terenthis to get his attention.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1227,'Grimclaw?! Easy there, my friend... where is your master Volcor?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1228,'%s begins to moan and roar at Terenthis while stomping his paws on the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1229,'Whoa, whoa there, my friend. One moment...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1230,'There... that should help. Now, tell me what\'s happened, Grimclaw.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1231,'%s roars at Terenthis more, but this time the druid seems to understand the bear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1232,'I understand, my friend. I shall find someone to help your master. Go back to him now, or at least stay close.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1233,'%s roars in acknowledgement at Terenthis.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1234,'%s growls in your direction before taking time to sniff you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1235,'I figured Flagongut would send someone for that fossil eventually.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1236,'Thank you again, $n. I\'ll make my way to the road now. When you can, find Terenthis and let him know we escaped.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1237,'Well, now or never I suppose. Remember, once we get to the road safely, return to Terenthis to let him know we escaped.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1238,'%s roars as his form shifts and he runs off.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1239,'Now let us place this rare earth in my planter...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1240,'Thank you again, $n.  This rare earth will be very helpful in my experiments.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1241,'%s roars in excitement as he rushes Volcor. When he reaches his master, Grimclaw licks his face.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1242,'You are dismissed, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1243,'We made it, my friend. Remember to find Terenthis and let him know we\'re safe. Thank you again.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1244,'I\'m happy to see you too, Grim! It looks like not all strangers are to be feared after all, huh, Grim? Terenthis shall reward this adventurer well.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1245,'What was that noise? It sounded like a roar.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1246,'%s begins to cast a spell on Grimclaw.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1247,'I shall get started right away, $n.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1248,'Now... where was my thread and needle. Ah! There it is...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1249,'%s begins to cast a spell as you take the cloak from him.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1250,'Here they come!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1251,'We can overcome these foul creatures!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1252,'We shall earn our deaths at the very least!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1253,'Don\'t give up! Fight to the death!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1254,'%s charges!','%s charges!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1255,'I must make the necessary preparations before the awakening ritual can begin. You must protect me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1256,'These caverns were once a temple of promise for regrowth in the Barrens. Now, they are the halls of nightmares.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1257,'Come. We must continue. There is much to be done before we can pull Naralex from his nightmare.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1258,'Within this circle of fire I must cast the spell to banish the spirits of the slain Fanglords.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1259,'The caverns have been purified. To Naralex\'s chamber we go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1260,'Down this way. Use caution, friends. I sense Naralex stirs in his troubled sleep....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1261,'From this spring I shall gather the sacred waters with which I will combine the blood of the fallen druids.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1262,'Now I have what is required. Let us continue.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1263,'Beyond this corridor, Naralex lies in fitful sleep. Let us go awaken him before it is too late.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1264,'Protect me brave souls as I delve into the Emerald Dream to rescue Naralex and put an end to this corruption!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1265,'%s begins to perform the awakening ritual on Naralex.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1266,'[PH] This is a placeholder action until i can cancel channeling my spell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1267,'At last! Naralex awakes from the nightmare.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1268,'%s tosses fitfully in troubled sleep.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1269,'%s writhes in agony. The Disciple seems to be breaking through.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1270,'%s dreams up a horrendous vision. Something stirs beneath the murky waters.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1271,'I AM AWAKE, AT LAST!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1272,'Ah, to be pulled from the dreaded nightmare! I thank you, my loyal Disciple, along with your brave companions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1273,'Attacked! Help get this $n off of me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1274,'Deal with this $n! I need to prepare to awake Naralex!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1275,'I can\'t handle this $n alone! Help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1276,'This $n is a minion from Naralex\'s nightmare no doubt!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1277,'Help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1278,'Anaya...? Do my eyes deceive me? Is it really you?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1279,'','The ages have been cruel to you and I, my love, but be assured, it is, and at long last we are reunited.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1280,'That the fates should be so cruel as to permit us only this after a thousand years apart...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1281,'Do you hate me, my love? That I was forced to destroy your living form, that your spirit be released from unhappy bondage.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1282,'','Let it not trouble your heart, beloved. You have freed me from slavery, and for that I love you all the more.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1283,'','Sadly, even this must be cut short... The ties that bind me to this world weaken, and pull me away...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1284,'','Farewell, Cerellean, until we are joined once again...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1285,'','%s\'s soft voice trails away into the mists, \"Know that I love you always...\"',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1286,'No! Anaya... Anaya! Don\'t leave me! Please...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1287,'How, my love? How will I find the strength to face the ages of the world without you by my side...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1288,'%s waves to $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1289,'Go now, $n. Find Volcor... and remember, the magics protecting you will fail if you interact with anyone, save for talking.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1290,'%s scrutinizes the camp\'s visitor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1291,'Ah.  Welcome $gsir:my lady;!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1292,'We must move quickly. Auberdine isn\'t too far away, but many enemies lurk in the forest.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1293,'Prepare to die, paladin scum!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1294,'Assassins from that cult you found... Let\'s get moving before someone else finds us out here.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1295,'The spirit of Echeyakee flows through you, $n.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1296,'','%s stretches and lets loose with a large yawn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1297,'The rage of Ishamuhale runs through you, $n.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1298,'Lakota\'mani thunders within you, $n.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1299,'The speed of Owatanka is with you, $n.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1300,'Your path is steady, $n, for Washte Pawne\'s resolve is with you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1301,'May the spirit of Isha Awak give you strength, $n.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1302,'','Terenthis, Raene sent me to find you. The Sentinels are in need of help in Ashenvale.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1303,'','Thank you, Terenthis. I shall remain here for as long as I can.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1304,'','Hopefully I can send a worthy few to help Ashenvale and the Sentinels.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1305,'Hello, Selarin. I\'m afraid I cannot help you at the moment, but perhaps some of the adventurers here in Auberdine can...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1306,'','Thank you again, Terenthis. I shall return again if more help is needed. Until then, please send more adventurers to Ashenvale',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1307,'%s mixes the Bathran\'s Hair...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1308,'The mixture is finished, $n.  Now we must save the child.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1309,'A paladin! Slaying him would please the master. Attack!','A paladin! Slaying him would please the master. Attack!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1310,'They\'re coming out of the woodwork today. Let\'s keep moving or we may find more things that want me dead.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1312,'You cannot hide from us, little paladin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1313,'Not quite so sure of yourself without the Purifier, hm?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1314,'Tonight, your blood will run red on the stones of our altars.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1315,'Well done! I should be fine on my own from here. Remember to talk to Delgren when you return to Maestra\'s Post in Ashenvale.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1316,'Uh... the disease is potent.  And it attacks the mind...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1318,'I must... RESIST!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1319,'I have survived the poisons of the Forsaken, $n, and I know now what must be done.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1320,'Free from this wretched cell at last! Let me show you to the courtyard....','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1321,'You are indeed courageous for wanting to brave the horrors that lie beyond this door.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1322,'%s fumbles with the rusty lock on the courtyard door.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1323,'There we go!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1324,'Good luck with Arugal. I must hurry back to Hadrec now.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1325,'These statuettes must hold a hidden compartment....','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1326,'They\'re locked!  NO!!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1327,'%s jumps out of the shadows!','%s jumps out of the shadows!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1328,'About time someone killed the wretch.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1329,'For once I agree with you... scum.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1330,'','Mist! I feared I would never see you again! Yes, I am well, do not worry for me. You must rest and recover your health.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1331,'Follow me and I\'ll open the courtyard door for you.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1332,'I have just the spell to get this door open. Too bad the cell doors weren\'t locked so haphazardly.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1334,'There it is! Wide open. Good luck to you conquering what lies beyond. I must report back to the Kirin Tor at once!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1335,'Here you are, Relara.  Take this...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1336,'','%s drinks the cure brought by $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1337,'','Uh... Father...?  Are you there?  I\'m hungry... can I have some stew?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1338,'What?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1339,'You\'re awake??  Your cure must have worked!  Thank you, $n.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1340,'%s growls in acknowledgement before straightening and making her way off into the forest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1341,'Go swiftly, $n. My fate is in your hands.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1342,'%s protects himself with magic.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1343,'%s vanishes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1344,'You landlubbers are tougher than I thought! I\'ll have to improvise!','You landlubbers are tougher than I thought! I\'ll have to improvise!',0,0,0,0,0,0,0,0,1,0,5778,5778,26124),
(1345,'D\'ah! Now you\'re making me angry!','D\'ah! Now you\'re making me angry!',0,0,0,0,0,0,0,0,1,0,5779,5779,26124),
(1346,'%s crushes the moonstones into a cup of tea.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1347,'Here you are, Relara.  Drink this...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1348,'%s drops its weapon and lights a stick of dynamite!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1349,'','Mmh... my eyes are not so heavy now, father.  Can we go out and play?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1350,'Relara... you\'re awake?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1351,'Rest now, my daughter.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1352,'%s looks at $n, and then weeps with joy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1353,'Relara is saved, $n.  Thank you.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1354,'%s searches the ancient statuettes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1355,'$n, I am in need of your help once again.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1356,'','The numbers of my companions dwindles, goddess, and my own power shall soon be insufficient to hold back the demons of Felwood.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1357,'','Goddess, grant me the power to overcome my enemies! Hear me, please, my need is desperate and my cause is just!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1358,'','What... what is this? Could this be the answer to my prayers? Elune has granted me a weapon--this scythe--to defeat the demons.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1359,'','I have failed... I have failed in my duty... failed my people... The worgen run rampant, and the Scythe of my goddess is lost.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1360,'','This evil I have unleashed... In whose hand does the power my goddess granted to me now lie... By whose hand is it directed?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1361,'%s beings to summon forth guardians!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1364,'To reach The Crossroads, $n, follow the road east then north.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1365,'','Sidney is late. I thought he would be home by now.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1366,'He\'s your husband, woman. How am I to know where he is?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1367,'','He must be overwhelmed with work at the Monastery. But still, he should have returned by now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1368,'Cleansing the world of impure scum isn\'t an easy job, Nancy. Someone\'s got to do it.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1369,'','Well, I\'m going outside to check. Something is amiss.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1370,'','%s lets out a long, drawn out sigh.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1371,'','Oh well....',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1372,'It looks like we\'re in trouble. Look lively, here they come!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1373,'Hold! I sense an evil presence... Undead!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1374,'These three again?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1376,'Finally. The monster got what he deserved.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1377,'%s breaks the seal on Anton\'s letter and begins to read it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1378,'By the Light! This is not good. There\'s something you don\'t understand, $n.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1379,'%s throws Anton\'s letter down on the table.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1380,'','The rod\'s design is simple. Dartol didn\'t use his arcane knowledge in its creation... it is more druidic in nature.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1381,'','Hehe... I made a pun, didn\'t I? Druidic in nature... I\'m so funny.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1382,'','Now, then... the rod. Let\'s see about putting it back together, shall we?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1383,'','There! That wasn\'t too bad. What did you say you and Raene were going to do with this thing? It\'s powerful!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1384,'If you have the time, Grimclaw and his master Volcor could use your help. If you\'re interested, speak with me further...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1385,'%s grabs for his poisoned dagger!','%s grabs for her poisoned dagger!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1386,'Eh? What have we here?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1387,'Welcome to the Stockade!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1388,'Outsiders! Kill em all!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1390,'More of the Warden\'s errand boys!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1391,'Tell the Warden this prison is ours now!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1392,'It\'ll be quick, but it won\'t be painless!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1393,'Fresh meat!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1394,'I\'ll crush your skull beneath my boot!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1395,'Death to the Warden\'s men!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1396,'Who\'s there?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1397,'We must hurry.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1398,'Spirits of the forest come forth and heed nature\'s call!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1399,'','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1400,'Spirits of the forest, you are needed! Make haste to the Charred Vale!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1401,'%s is not impressed.','%s is not impressed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1402,'You\'re pushing it, $n.','You\'re pushing it, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1403,'Don\'t make me go medieval on you.','Don\'t make me go medieval on you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1404,'Keep it up, $n, and I\'ll beat some manners into you.','Keep it up, $n, and I\'ll beat some manners into you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1405,'%s drops the animal parts into the bubbling cauldron.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1406,'Ah, feel the magic seep into the cave, my little elves... muhahaha.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1407,'So much for the power of nature... muhahahaha.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1408,'%s lays an egg!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1409,'%s begins to crack and open...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1410,'%s splits open!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1411,'','%s sees her cub being attacked and goes into a frenzied rage!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1412,'%s gives message to Apothecary Zamah.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1413,'%s hatches!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1414,'%s chitters for help...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1415,'%s arrives!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1416,'','%s listens to $n\'s plea.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1417,'','You were right to come.  My wisdom will be yours.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1418,'','%s smiles.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1419,'','Go, my servant.  Send word of Stonetalon to Apothecary Zamah.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1420,'','%s summons a messenger...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1421,'%s creates his toxin...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1422,'There we are, $n.  The toxin is ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1423,'','%s fills a container with the toxin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1424,'','The toxin is ready, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1425,'','The spirits of Stonetalon still rage, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1426,'','I fear we may never soothe them...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1427,'All right, watch my back while I get you some of this ore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1428,'Hey! You\'re not supposed to be here! C\'mon boys!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1430,'I think the sounds came from over here. We\'d better check it out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1431,'Look out! It sounds like more of them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1432,'Just a little while longer, I\'ve almost got it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1433,'What\'s going on here? Piznik! I knew we shouldn\'t have let you stick around!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1434,'There, I\'ve got it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1435,'Who dares interfere with the Sons of Arugal?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1436,'You\'ve destroyed too much of my work!  Prepare to join them in the Nether!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1437,'This should only take a moment, $n.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1438,'%s places the tear into a bowl of stew.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1439,'Eat this, my daughter.  It will help you feel better.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1440,'There you go...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1441,'','%s stirs from her delirium.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1442,'','Mmmmh...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1443,'%s places a poultice on Relara\'s head.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1444,'%s breathes a sigh of relief.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1445,'We\'ll cut your throats and bleed you dry!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1446,'We\'ll have your heads!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1447,'For the Dark Strand!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1448,'sdsd','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1449,'My... My powers have diminished... You shall pay for this insolence!','',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(1450,'No! You can\'t defeat me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1452,'The race will start in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1454,'%s flees combat to get help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1455,'%s sees his fans cheering and gains a burst of speed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1456,'I have changed my mind loyal servants, you do not need to bring the prisoner all the way to my study, I will deal with him here and now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1458,'Arrrgh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1459,'A simple enough task to break this soulstone!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1460,'%s bursts open!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1461,'%s intones, \"Assist him in any way he requires. Do not fail in this task.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1462,'%s crumbles into dust.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1463,'%s sniffs the air hungrily, smelling fresh lion meat...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1464,'%s devours the carcass!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1465,'%s disappears into the snow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1466,'The fresh carcass is placed upon the Flame of Uzel.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1467,'%s looks from side to side...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1468,'Hm... if you\'re looking to adle wits, $n, then the secret behind Zanzil\'s zombies might just do the trick!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1469,'Thank you, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1470,'I\'m sure I can find a use for this mixture...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1471,'In the throes of the Sundering, Ameth\'Aran was at the whim of the terror that gripped the land. There was little hope for survival.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1472,'Athrikus came to us. He told us that he could save us from harm. He cast a spell upon us to protect us from harm.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1473,'Then we must put an end to Athrikus Narassin. Tell me, spirit, where might we find the other soulgems, to undo his magic?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1474,'When the shaking stopped, his true motives were revealed. We were trapped, and he was slowly draining our powers.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1475,'His lieutenant, Ilkrud Magthrull possesses a tome which might indicate the location of the remaining soulgems.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1476,'%s fades into the mist...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1477,'%s grabs a part and puts it in his pocket...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1478,'There, that should do it...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1479,'%s places the crate of parts on the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1480,'%s begins to dance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1481,'Hahah!  $n, you make quite a partner!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1482,'Woo hoo! Finally getting out of here. It\'s going to be rough though. Keep your eyes peeled for trouble.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1483,'Up there is where Charlga Razorflank resides. Blasted old crone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1484,'There\'s blueleaf tuber in this trench! It\'s like gold waiting to be mined I tell you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1485,'There could be danger around every corner here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1486,'I don\'t see how these foul animals live in this place... sheesh it smells!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1487,'I think I see a way for us to get out of this big twisted mess of a bramble.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1488,'Glad to be out of that wretched trench. Not much nicer up here though!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1489,'This stout sure smells strong!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1490,'Finally! I\'ll be glad to get out of this place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1491,'Let\'s have just a small taste...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1492,'Wait!  What am I thinking!  We have a job to do with this stuff.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1493,'I think I\'ll rest a moment and catch my breath before heading back to Ratchet. Thanks for all the help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1494,'Well, I\'m off to Ratchet now! Best of luck to you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1495,'%s listens as $n tells him of $ghis:her; adventures in the Badlands.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1496,'Astounding!  So then indurium is the key!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1497,'There were hundreds imprisoned by his spell. Now only a few remain in their prisons. He would speak to us sometimes.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1498,'He worried that his power weakened, that soon even we last of his precious soulgems would fade and die.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1499,'I\'ll finish you off for good this time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1500,'%s takes the indurium flakes to his forge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(1501,'Now let\'s heat up these flakes...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(1502,'So far they\'re holding.  Let\'s turn up the heat...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(1503,'By Orgrim!  This indurium can withstand massive heat!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(1504,'A successful test!  $n, this indurium is some amazing stuff.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(1505,'Thanks again, $n.  Now I\'ll use this indurium to beef up my car!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1506,'BANG! BANG! BANG!  I\'m beefing up the car!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1507,'All done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1508,'Now for the next race, the car will be even FASTER than before!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1509,'Open for business! The goblin car is looking sharp and it\'s sure to be a winner! Get your bets in before the race starts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1510,'Smart money\'s on the gnomes to take the next race! Get your money in while you still can!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1511,'%s begins to cast a spell over the hearts and tongues.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1512,'The brood of Onyxia!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1513,'%s decomposes into dust.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1514,'Me still boss of ogres. Haw!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1515,'Puny $r wanna fight Overlord Mok\'Morokk? Me beat you! Me boss here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1517,'And it\'s the $n coming through turn one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1518,'And crossing the line is the gnome car! The gnomes win!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1519,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1520,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1521,'','%s returns the rude gesture to $n.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1522,'The goblins win! The goblins win!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1523,'Me scared! Me run now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1524,'Hm, these are pretty good bones you got this time, Pozzik.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1525,'All done! The modifications should give us a little boost in speed, but I don\'t think she\'ll hold up to too much bumping.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1526,'Okay, crew. Get to work on getting these bones installed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1527,'Thanks for the helmets, $n.  These will really reduce our medical bills...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1528,'','%s gestures to the pitcher of water sitting on the edge of the well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1529,'','What can I do for you?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1530,'','What do you fancy, $G sir:miss;?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1531,'','Well hello, $n, what can I get you today?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1532,'','Been a tough day? A nice ale should loosen those worries right up.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1533,'','Hi, what would you like?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1534,'','Good day, $c. What would you like?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1535,'','Look what the cat dragged in. What can I get you, $n?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1536,'','Do you think I need more pieces of Flair?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1537,'The winner of the drag race is...the gnome team!  Great job guys!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1538,'The goblins win the drag race!  Better luck next time, gnome team.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1539,'','%s snorts dream dust.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1540,'Hehehe! Things go boom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1541,'What was that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1542,'Bloody... Must have been the goblins... Let\'s see how bad the damage is.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1543,'Guess there\'s nothing more to be done. Blast!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1544,'Eek! $n coming right at us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1545,'Egads! $n on me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1546,'$n heading this way fast! To arms!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1547,'Help! Get this $n off of me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1548,'%s snorts a speck of dream dust up his nose...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1549,'%s is dazed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1550,'ACHOO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1551,'Wow!  $n, that dream dust is powerful stuff!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1568,'What was that? Did you leave that flare lit?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1569,'That explosion was great! Did you see how big it was?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1570,'It wasn\'t me! I swear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1571,'Spread out! Find out who did this. They\'re gonna get fired for sure!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1572,'This is gonna cost a bundle of gold. It\'s not comin\' out of my pocket.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1573,'Anyone see anything? What happened?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1588,'sneezes voilently!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1589,'Until we meet again, brave one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1591,'%s wiggles his whiskers at $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1592,'%s sniffs at the ground...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1593,'%s finds a truffle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1594,'%s charges!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1608,'You have done well, $n. Continue your search for knowledge, and remember the history you have learned.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1609,'%s is found!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1610,'Ok, let\'s get started.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1611,'Now let\'s look for the herb.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1612,'Nope, not here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1613,'There must be one around here somewhere...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1614,'Ah, there\'s one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1615,'Come, $n!  Let\'s go over there and collect it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1616,'%s picks the herb from the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1617,'Ok, now let\'s get out of here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1618,'I can make it from here.  Thanks, $n!  And talk to my employer about a reward!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1619,'%s disappears back into the swamp.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1628,'Look out!  The $n attacks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1629,'Help! I\'m under attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1630,'Help!  The beast is on me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1631,'I\'m glad you\'re here!  Because I need your help!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1632,'He\'ll bring you mead, he\'ll bring you beer...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1633,'A grinning face from ear to ear...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1634,'He\'s served us all from year to year...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1635,'We call him Smiling Jim...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1636,'Stop! Back to your corners! Well fought, both of you.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1638,'%s nervously crawls from the crate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1639,'%s returns to $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1640,'%s begins to dig...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1641,'Combatants ready... FIGHT!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1642,'Through the second turn it\'s the $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1643,'Ok, I want a good clean spar. Remember to keep your sword up and shield ready.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1644,'%s stops.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1648,'Go to the Shady Rest Inn and follow the tracks. See where they lead and report back to me.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1649,'Understood. I will return shortly.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1650,'%s disappears into the mists.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1651,'Get \'em, guys. Teach \'em a lesson! No one messes with Slim.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1652,'Enjoy the rest of your stay in Menethil. It won\'t last much longer.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1653,'Think you can come here and steal from us, huh!?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1654,'There\'s no way you\'re gettin\' out of here alive!','There\'s no way you\'re gettin\' out of here alive!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1655,'No time for beer!  The race is about to start.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1656,'The car took a beating!  Let\'s get it ready for the next race.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1657,'Ah, Private Hendel. A pleasure to meet one of the men who would betray his kingdom for pride.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1658,'What am I going to do?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1659,'If the Captain finds out, it\'ll be the end of me.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1660,'How could this happen?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1661,'All of a sudden they were everywhere.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1662,'They must have had someone helping them.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1663,'Why don\'t we deal with you now, Hendel? Lady Proudmoore will speak to you back in the tower.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1664,'I am eager to hear what so angry an orc has to say...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1665,'%s places Marg\'s head in the cauldron.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1666,'Peer into the cauldron, $n.  Marg wishes to speak...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1667,'Hear that? $n, here says that human deserter Reethe might have been the one who burned down the inn!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1668,'I hope Ogron finds that pinkskin and breaks his legs. See how he survives in the marsh like that!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1669,'I noticed some fire on that island over there. A human, too. Let\'s go check it out, $n.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1670,'That\'s Reethe alright. Let\'s go see what he has to say, yeah?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1671,'%s places the scroll on the table, and reads...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1672,'By the Light!  This cursed spy was a good one!  I\'m glad he\'s dead.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1673,'Thank you for this report, $n.  It is now clear that we must tighten our patrols near Theramore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1674,'W-what do you want? Just leave me alone...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1675,'I swear, I didn\'t steal anything from you! Here, take some of my supplies, just go away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1676,'%s lets out a pained groan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1677,'Help arrives at last....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1678,'','Feeling better I see.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1679,'','Drink this, it will help.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1680,'','This should ease the pain.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1681,'','Some of this ointment should help.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1682,'','You\'re going to be just fine.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1683,'','Take this, drink it down.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1684,'','You will keep all your fingers and toes, not to worry.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1685,'','Let me help you with those.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1686,'Nurse.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1687,'How are my men doing?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1688,'','They are doing well, sir. They should all make full recoveries.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1689,'Thank you. Let\'s hope there aren\'t any more.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1690,'Kill them all!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1691,'Freedom!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1692,'Death to the Warden!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1693,'Kill the guards, take the Warden alive!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1694,'DIE!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1695,'We\'ll dance on your bones!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1696,'Death to the Warden\'s men!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1697,'Your jail is ours!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1698,'We\'re under attack!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1699,'Defend the barricade!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1701,'Brace yourselves!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1702,'Let none get by!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1703,'By Lothar, you Defias scum will pay!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1704,'Another wave, hold the line!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1705,'More prisoners! ','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1706,'Don\'t let them escape!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1707,'Just tell us what you know about the Shady Rest Inn, and I won\'t bash your skull in.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1708,'I... Well, I may of taken a little thing or two from the inn... but what would an ogre care about that?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1709,'Look here, if you don\'t tell me about the fire--','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1710,'Not one step closer, ogre!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1711,'And I don\'t know anything about this fire of yours...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1712,'Okay, okay! Enough fighting. No one else needs to get hurt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1713,'It\'s okay, boys. Back off. You\'ve done enough. I\'ll meet up with you later.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1714,'Paval Reethe! Found you at last. And consorting with ogres now? No fear, even deserters and traitors are afforded some mercy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1715,'Yeah, okay, boss. No problem.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1716,'All right, boss. You sure though? Just seems like a waste of good practice.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1717,'%s cracks his knuckles.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1718,'All hail $n, a $c of worth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1719,'Behold!  The Blue Recluse holds a feast in $g his:her; honor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1720,'Private, show Lieutenant Reethe some mercy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1721,'','Gladly, sir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1722,'Ugh... Hallan, didn\'t think you had it in you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1723,'Now, let\'s clean up the rest of the trash, men!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1724,'Damn it! You\'d better not die on me, human!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1725,'Must be your lucky day. Alright, I\'ll talk. Just leave me alone. Look, you\'re not going to believe me, but it wa... oh, Light, looks like the girl could shoot...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1726,'Still with us, Reethe?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1727,'Intruders!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1728,'They\'re here!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1729,'Looks dead to me. Not much use to us like this. You\'d better go back and tell Krog what happened.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1730,'By the way, thanks for watching my back.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1731,'What was that? Did you hear something?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1732,'%s staggers backwards as the arrow lodges itself deeply in his chest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1733,'Hooray, $n!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1734,'Let\'s here it for $n!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1735,'Here here!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1736,'Long live $n!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1737,'At this point, I will summon someone to examine the pendant, and find a hidden compartment...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1740,'I don\'t know what\'ll be in it yet.  Pat Nagle and Michael Backus need to discuss this first...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1741,'So until they do... bye bye!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1742,'Enough! I will talk. Put your weapons away, it is not with me that you have quarrel with.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1743,'Okay, okay! No need to get all violent. I\'ll talk. I\'ll talk!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1744,'I have a few notes from the job back at my place. I\'ll get them and then meet you back in the inn.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1745,'Just leave the poor man alone, citizen, he\'s not worth the trouble.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1748,'$n, I would have words with you.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1749,'Go about your business. My errand does not require your attention.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1750,'Atten...HUT!','Atten...HUT!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1751,'Go with grace, and may the Lady\'s magic protect you.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1752,'Falgran Hastil reporting, sir. I will find where the hoofprints lead and report back to you.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1753,'Tesoran! I need someone--Falgran Hastil, preferably--to take care of $n\'s lead on the prints near the Shady Rest Inn.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1754,'Right away, sir.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1755,'Kagoro, I require your presence!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1756,'Alright! Alright! We surrender... Just put your weapons down, I\'ll cooperate!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1757,'You might be able to take me, but the Defias WILL take back Stormwind!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1758,'Uh oh... this is bad.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1759,'Please... please... Miss Proudmore. I didn\'t mean to...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1760,'You put up a good fight, Edward. Let\'s see if Kahil can take\'em.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1761,'I apologize for taking so long to get here. I wanted Lady Proudmoore to be present also.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1762,'Kahil, it was a mighty effort. Come back and rest up. Narrisha will clean this up for us.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1763,'Bravely fought Narrisha. We will get you next time Red Team!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1764,'All of you fought hard and valiantly. It makes me proud to see the warriors you have become.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1765,'We lost this time but don\'t let it get you down. Concentrate on your special attacks. Keep your shield high and close. Do this and next time victory will be ours!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1766,'Heck\'va fight ya put up Jarad. Gots\'ta keep that shield up more next time. Lana! Yer in!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1767,'I\'ve seen you fight better den dat, Lana! You can gettem next time! Tark, get in there and giv\'em hell!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1768,'Tark, what happened in there? You know yer better den dat! Blue team, you will get yours soon \'nuff!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1769,'Outstandin\' fightin\'! Ya made an old man proud. Keep it up and ale will be on me ta\'night.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1770,'What kinda fightin\' was that? I should kick all of ya worthless hides off the team and out of the guard!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1771,'Captains, send forth your first combatants.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1772,'Farewell. We shall speak again, I\'m sure.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1773,'Red is the winner! Congratulations Red!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1774,'Blue is the Winner! Congratulations Blue!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1775,'Jarad, you are up first for us.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1776,'Edward, ya leadin\' us off. Git in there.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1777,'For the Blue!','For the Blue!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1778,'For the Red!','For the Red!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1788,'Hey $n!  Don\'t forget to grab a crate, a manual and a command stick!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1789,'That was a nice shot... but not perfect. Maybe a bit more to the left.','That was a nice shot... but not perfect. Maybe a bit more to the left.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1790,'Barely hit the target that time. Hmmm,... maybe I need to adjust back to the right.','Barely hit the target that time. Hmmm,... maybe I need to adjust back to the right.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1791,'Whoa! Look at that bullseye!','Whoa! Look at that bullseye!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1792,'Oops! That was a bit off. I didn\'t even hit the target!','Oops! That was a bit off. I didn\'t even hit the target!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1793,'As you wish, sir.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1794,'Red team, winner!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1795,'Blue team, Winner!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1808,'We can only stay a few moments before returning to the tower. If you wish to speak to us more you may find us there.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1828,'It wasn\'t my fault, Master Mazen!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1829,'It was a simple mistake. A wrong turn I tell you!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1830,'The swamp was horrible! I was so... so... scared!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1831,'I\'m lucky to be alive!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1833,'Thank the Light you\'re here! Get your sword out, there\'s centaur on my tail!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1834,'No one\'s going to save you now, human!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1835,'I\'ll take your money and your life too!','I\'ll take your money and your life too!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1836,'Say your prayers!','Say your prayers!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1837,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1838,'I think that\'s the last of them. It\'s a good thing you came when you did... I wasn\'t sure how much longer I could stay hidden.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1848,'The serum will only take a few minutes to prepare, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1849,'Almost done...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1850,'At last, the serum is complete, $n. Now, come closer. We must talk.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1851,'This shouldn\'t take long...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1853,'The invisibility liquor is ready for you, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1854,'Let us leave this place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1855,'Thank you, $n.  I will remember you always.  You can find my strongbox in my camp, north of Stonard.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1856,'%s disappears into the swamp.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1857,'%s takes a big swig of ale.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1858,'That was refreshing. Now there\'s information that needs to be told...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1859,'I believe the Forsaken are misleading the allies of the Horde.... wait... I feel so... dizzy...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1860,'%s writhes in pain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1861,'AAAAAAAAAAAAAAAARGH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1862,'','Here goes nothing...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1863,'No kill me! No kill me!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1864,'Yiieeeee! Me run!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1865,'Ah, a chance to use this freshly sharpened blade.','Ah, a chance to use this freshly sharpened blade.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1866,'The Brotherhood will not tolerate your actions.','The Brotherhood will not tolerate your actions.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1867,'Feel the power of the Brotherhood!','Feel the power of the Brotherhood!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1868,'You no take candle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1869,'Grrrrr!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1870,'Grrrr... fresh meat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1871,'More bones to gnaw on...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1872,'Here we go, people.  Watch your backs...','Here we go, people.  Watch your backs...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1873,'Watch your step...','Watch your step...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1874,'Feel the power of the Blackrock Orcs!','Feel the power of the Blackrock Orcs!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1875,'You are no match for the Blackrock Orcs!','You are no match for the Blackrock Orcs!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1876,'We made it through the pass!  Now we have the swamp...','We made it through the pass!  Now we have the swamp...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1877,'We made it to Nethergarde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1878,'Open for business!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1879,'I\'m closing soon, so buy while you can!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1880,'I\'m just about to close...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1881,'He dead.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1882,'Oh well.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1883,'Let me install these Gyromechanic Gears and Restabilization Cogs and we\'ll fire up The Recombobulator.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1884,'That should do the trick.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1885,'Time to save the entire gnomish race. Here goes nothing!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1886,'Oh, great.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1887,'Back to the drawing board.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1888,'Perhaps a bit more grease will do the trick.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1889,'Pretty close that time. I think we\'ve almost got it.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1890,'The Recombobulator is shaping up quite nicely. Just a few adjustments to go!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1891,'Precisely.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1892,'My thoughts exactly.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1893,'Couldn\'t have said it better myself.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1894,'Most definitely.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1895,'I was thinking the same thing.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1901,'Charog likes to spend his coin at the Busted Drum. Let\'s go pay him a visit, $n.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1902,'Mojka, cover for me! I have some business to attend to.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1903,'','Again? Make it fast, Komak, I\'m sick of this.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1904,'Women...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1905,'I am here!  Come face me, if you dare!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1906,'It\'s Komak... Better get out of his way.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1907,'Not again...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1908,'My weapon be thirsty!','My weapon be thirsty!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1909,'Killing you be easy.','Killing you be easy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1910,'Have a taste of Frostmane magics.','Have a taste of Frostmane magics.',0,0,0,0,0,0,0,14,1,0,0,0,26124),
(1911,'All you $R want is my weed.','All you $R want is my weed.',0,0,0,0,0,0,0,14,1,0,0,0,26124),
(1912,'I\'ll cut you!','I\'ll cut you!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1913,'Crush!','Crush!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1914,'Kill!','Kill!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1915,'Destroy!','Destroy!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1916,'I smell a $R','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1917,'Time to bash!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1918,'You dare defile Frostmane Hold, $R. Prepare to die!','',0,0,0,0,0,0,0,14,1,0,0,0,26124),
(1919,'Oh, we are going to get along just fine, $n.','',0,0,0,0,0,0,0,14,1,0,0,0,26124),
(1920,'Yip! Me kill!','Yip! Me kill!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1921,'Me no run from $C like you!','Me no run from $C like you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1922,'So what do you want to do today?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1923,'I dunno. What do you want to do?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1924,'Fishing sounds good.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1925,'I\'ll crush you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1926,'Me smash! You die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1927,'Raaar!!! Me smash $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1928,'Dat $R look gud to eat!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1929,'Bash it!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1930,'Me smash you!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1931,'Huh? What dat?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1932,'Intruders at the Horn!  Don\'t let them escape!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1933,'Kill the intruders!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1934,'Never cross a Dark Iron, $C.','Never cross a Dark Iron, $C.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1935,'Time to die, $C.','Time to die, $C.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1936,'Feel the power of the Dark Iron Dwarves!','Feel the power of the Dark Iron Dwarves!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1937,'For the Dragonmaw!','For the Dragonmaw!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1938,'Your bones will break under my boot, $r!','Your bones will break under my boot, $r!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1939,'Long live the Dragonmaw! Die you worthless $r!','Long live the Dragonmaw! Die you worthless $r!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1940,'Brains...','Brains...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1941,'A living $r... soon to be a dead like me.','A living $r... soon to be a dead like me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1942,'Time to join us, $c.','Time to join us, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1943,'Komak! I swear I\'ll have the money! Just give me some more time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1944,'%s clears his throat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1945,'A drink for friend Sarok and another for myself.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1946,'I don\'t want any trouble, Komak.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1947,'Sarok, why don\'t we talk business?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1948,'What do you want, Komak?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1949,'I hereby destroy these instruments of evil! For the Horde!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1950,'Time to brew up a Kalimdor Kocktail! Hiccup!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1951,'That should do it! Hiccup!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1952,'%s chugs his drink.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1953,'Hiccup!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1954,'Ok, who pushed me down? Was it you, $n? Someone turn the lights back on. Hiccup!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1955,'One more sip of the ol\' fire water and I\'ll be ready to talk. Hiccup! Cheers!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1956,'So, $n, I\'m ready to tell you what happened in the Swamp of Sorrows. Hiccup!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(1957,'Strike!','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1958,'Fight!','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1959,'Red wins! Prepare for next round.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1960,'Blue wins! Prepare for the next round.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1961,'Now you\'re gonna get it good, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1962,'So angry, Sarok? You shouldn\'t drink so much... Just tell us what you know about Mosarn.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(1963,'Alright you sorry sacks of bones. Let\'s see what you\'ve got. Strike your opponent, and don\'t stop till I say so.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1964,'Stop! You maggots call that fighting? That is pathetic! Now put your hearts in it, you don\'t need them anymore anyway!','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1965,'Can you see yourselves? That is the most pathetic excuse for sword slinging I\'ve ever seen! ','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1966,'You don\'t fight for yourselves anymore, maggots! You fight for the Queen now so show me something worthy of her!','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1967,'You\'re dead, not buried. Now show me your best!','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1968,'These piles of wood and straw may show mercy, but the Lich King won\'t!','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1969,'You sorry sacks of maggot flesh can do better than that, now prove it!','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1970,'The sword isn\'t a tool, it\'s an extension of you. I expect better!','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1971,'What do you call that? If that\'s fighting then I\'m Lothar himself!','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1972,'Ok soldiers, take a break!','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1973,'It has been a long time, Bethor, my friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1974,'When time permits, we must speak at length.  For we have much to discuss.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1975,'And thank you, $n.  Without your aid I may never have found my way to the Forsaken.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1976,'Farewell, my friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1977,'Lysta, summon in the captives.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1978,'Edward. Tyler. Prepare for your first challenge.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1980,'Not a challenge at all it seems. Let us see how you handle your second test. Lysta, bring forth the minions of the Lich King.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1981,'Now prove your worth!','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1983,'You show some worth after all. Lysta summon a surprise for our young recruits.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1984,'It is time to face your final challenge young warriors! Prepare for your hardest fight yet.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1985,'Well done Edward and Tyler. You are progressing along in your training quite nicely. We shall test your mettle again soon.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1986,'Who dares summon the power of the void?','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(1987,'You will live forever in torment for this, pathetic warlock.','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(1988,'This is Dalin Forgewright. He fled from Lordaeron when the plague struck, taking his love with him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1989,'And this is Comar Villard. Two weeks married, his wife was spirited away from the safety of Menethil Harbor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1990,'Fools.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1991,'','Interesting... Now this is more than I expected. Delicious...',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(1992,'When he came upon the refugees at the Greymane Wall, he felt it his duty to succor them, sending his woman on to Hillsbrad.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1993,'Five and five years, and he still searches for her, though she was no beauty, and there were many ladies that would take her place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1994,'So what do you think of my new toy?','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1995,'Theresa, take this to Father Lankester.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1996,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(1997,'','My Lord Abernathy sends this to you.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1998,'','Yes My Lord.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(1999,'','My Lord. From Father Lankester.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2000,'How do you like my pet?','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2001,'Isn\'t she just the most amazing little creation?','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2002,'Didn\'t I tell you my new domination techniques would work?','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2003,'As good as I told you it would be, yes?','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2004,'It was simple once I broke her spirit.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2005,'You don\'t expect me to give up all my secrets do you?','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2006,'A little ritual torture can go a long way.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2007,'A little torture, a pinch of magic, and an ample helping of invasive surgery. She was conscious, of course.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2008,'Everyone has a weakness, it\'s just a matter of finding it.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2009,'I managed to discover that certain parts of the brain when removed or stimulated will make a subject much more docile. ','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2010,'','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2011,'Why thank you, my pet.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2012,'','Truly amazing, Gerard. How did you do it?',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2013,'','Amazing! How did you manage a permanent dominate?',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2014,'','I don\'t approve of your experiments, Gerard, but I must admit the results are impressive. What exactly did you do to her?',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2015,'','Astounding. You managed to dominate her, yet she retains self awareness and function. How did you do it?',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2016,'','She retains knowledge and speech, and even the self sufficiency to perform tasks for you. Precisely what did you do?',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2017,'','I\'ve never seen anything like it. No concentration or loss of awareness while the subject is dominated. What did you do to her?',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2018,'','Bravo, Gerard, you have exceeded yourself, yet again.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2019,'','I am truly impressed, Gerard. I thought you were all talk, but I see I have been proven wrong.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2020,'','Impressive, very impressive. Does she do tricks?',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2022,'','Very nice, Gerard. Next you will be breeding them.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2023,'','An amazing discovery you have made. I would love an opportunity to look at all of the failed experiments.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2024,'','I don\'t agree with your turning to alchemy to fix some of the problems, but I do agree with the results. Very well done.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2026,'','Your pet is wonderful, Gerard, but she needs a collar with a bell I think.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2027,'','Did you have to house train her, Gerard?',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2028,'Ugh! What is that scoundrel doing sending his vermin to me? Get out of my sight before I take what is left of your life. And take this with you.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2029,'','Ahh there it is.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2030,'','\"Magical Flows and How They Effect the World\", by Maginor Dumas. That\'s the one I was looking for.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2031,'','I really need a better system for filing these books. Ahh that\'s the one I wanted.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2032,'','\"Khadgar\'s Mystical Journal, Volume 8.\" I think this is the one I wanted.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2033,'','Ahh, \"Mystical Conjurings of the Archmages of Dalaran.\" Perfect.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2034,'','If I could just find \"Magic and the Ways of Power\". Ahh here it is, what was it doing over here?',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2035,'','\"Magic Maladies\", no. \"Magic Matricies\", no. Ahh here we go \"Magic Mysteries\".',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2036,'','There\'s the mystical tome I was looking for.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2037,'','Yes, yes. Hmm, it seems to cross reference another tome. Guess I have to find that one too.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2038,'','That wasn\'t very helpful. Let me check the other one.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2039,'','That\'s what I wanted to know. Now I just need to find where the flux variance is discussed.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2040,'','Very interesting. But if that\'s the case then my theory is wrong. I must reread the other sections to see what I missed.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2041,'','So I was right about the energies. Let\'s see what the other tome has to say on the subject.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2042,'','If this is correct then I have a lot more research to do.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2043,'','But this can\'t be right. Where did I put that other book?',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2044,'','Back to the drawing board.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2045,'Hah!  Let us see the wooden human wave!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2046,'Hahah!  That was funny!  Funny wooden human!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2047,'%s laughs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2048,'Hold, $n!  I\'m guarding these barrels, so ... look, but don\'t touch!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2049,'','If you\'re here, then it means you are prepared to begin the study of summoning demonic cohorts to do your bidding. We will start with the lowliest creatures you will be able to call and continue from there. Let us begin.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2050,'','The easiest creature for you to summon is the imp. You should already be able to bring forth this minion but for completeness\' sake I will start with him.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2051,'','This foul little beast is the imp. It is small and weak, making it almost useless as a meatshield, and its damage output is mediocre at best. This creature is best used for support of a larger group.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2052,'','Now that you have had a chance to study the imp, let us move on to the next minion you will be able to summon, the voidwalker.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2053,'','This demonic entity is known as the Voidwalker. Its strength and endurance are significant, making it ideal for defense. Send it to attack your enemy, then use it as a shield while you use your spells and abilities to drain away your opponent\'s life.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2054,'','If you\'ve never seen one, it is a sight to behold. A very impressive creature both on and off the field of battle. Next, let us take a look at what I am sure all you male students have been waiting for. The succubus.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2055,'','All right now. Aside from the obvious distractions a minion like this will provide against your more masculine foes, she is also capable of dealing out impressive amounts of damage. However, her fragile endurance makes her almost useless as a shield.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2056,'','Study hard and you might one day be able to summon one on your own, but for now it\'s time to move on to the felhunter.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2057,'','What you see before you is a felhunter. This creature\'s natural talents include spell lock and other abilities which make it unequalled when facing a magically attuned opponent.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2058,'','When facing a spellcaster of any kind, this feral beast will be your best friend. Now, let us take a look at something a bit different. This next creature will aid your travels and make your future journeys much easier. Let\'s take a look at a felsteed.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2059,'','I doubt you have had much occasion to see such a creature. These demonic equines will make your travels much faster by acting as your mount as long as you control them. However, they are difficult to control, so be sure you are ready before attempting it.\n',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2060,'','There you have it. Our lesson on summoning has come to an end. A new class will begin shortly, so if you wish to brush up, feel free to stay around.',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2061,'Hmm, it would seem Keever needs a new subject. If that fool Abernathy keeps taking Keever\'s subjects, Keever may have to have a word with him.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2062,'Ahh, there we go. Now, Keever must try this vial and see if it works.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2063,'Not what Keever was hoping for. Keever may have added too much earthroot. Let\'s see if the second serum will do what Keever needs.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2064,'%s pokes the small toad.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2065,'%s feeds the toad some of the strange liquid.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2066,'%s pokes the small fuzzy squirrel with obvious disappointment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2067,'Well, that is just not right. The creature is far too small. Let us see what Keever\'s third batch will do.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2068,'%s feeds the squirrel some of the viscous fluid.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2069,'%s pokes the skittish rabbit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2070,'Keever is unhappy with this. Perhaps if Keever were to try a larger dose, that may fix this dilemma.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2071,'%s grabs the rabbit and pours the fluid down its throat, then sets it back inside the cage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2072,'What is this? Did Keever ask for a sheep? Keever wanted a weapon of great power and all he got was this sheep. Keever is very disappointed.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2073,'%s pokes the wooly sheep repeatedly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2074,'Keever is most pleased.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(2075,'%s forces the fluid down the weary man\'s throat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2076,'%s whispers to $n the secret to opening his strongbox.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2077,'$n! THIS AREA IS OFF LIMITS!','$n! THIS AREA IS OFF LIMITS!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2078,'Now let\'s try it...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2079,'Ugh!  That\'s terrible!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2080,'%s follows $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2081,'%s lets out a shriek, calling for help!','%s lets out a shriek, calling for help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2082,'%s begins to make a copy of itself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2083,'Never cross a Dwarf!','Never cross a Dwarf!',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(2084,'For the glory of Ironforge!','For the glory of Ironforge!',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(2085,'This should only take a moment, $n.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2086,'I can\'t believe it! You\'ve destroyed my pack... Now face my wrath!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2087,'I call your true name, Azrethoc. Show your visage to me!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(2088,'You scum aren\'t even worth my time.  Destroy them, my pack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2089,'Pathetic Forsaken weakling. You wish to see my master? So be it.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2090,'Who dares to seek me out?!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(2091,'Insects!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(2092,'Come! Come to your deaths--if you dare!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(2093,'Yes, come. My master and I shall be waiting.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2094,'An interesting turning of events.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2101,'At last! Naralex can be awakened! Come aid me, brave adventurers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2102,'Intruders have assaulted our lair.  Be on your guard!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2103,'We must go and gather with the other Disciples. There is much work to be done before I can make another attempt to restore the Barrens. Farewell, brave souls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2104,'For the Warchief!','For the Warchief!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2105,'Backhands $n solidly across the face.','Backhands $n solidly across the face.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2106,'Stay down, Wretch!','Stay down, Wretch!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2107,'%s lets out a tremendous roar, alerting nearby enemies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2108,'to arms laddies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2121,'Hey, there\'s one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2122,'Ooh, it\'s a nice one! Let me just dig it up...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2123,'I\'ve never seen something like this before! Look at the extension of the jawbone...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2124,'And they\'re off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2125,'%s goes into a rage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2126,'Must be careful not to damage the specimen...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2127,'Over there! Can it be?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2128,'Either that\'s a prime kodo bone or it\'s time I got my goggles!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2129,'Oooh, this looks promising...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2130,'I\'ve never seen one this size before! I can\'t wait to send it back for research...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2131,'I\'ll just label it for reference then dig it up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2132,'Must be very careful with this one... Very delicate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2133,'I would never have expected to find something in such perfect condition.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2134,'It\'s a little damaged, but I should still be able to get some good information from this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2135,'You\'ve been such an unbelievably big help! These bones are going to unlock so much new information and help me futher my research.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2136,'I\'ll follow you back to the camp. If you speak with my assistant, Hornizz, he\'ll have your payment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2137,'Torta, my love! I have returned at long last.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2138,'You have any idea how long I\'ve been waiting here? And where\'s dinner? All that time gone and nothing to show for it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2139,'My dearest Torta, I have been gone for so long. Finally we are reunited. At long last our love can blossom again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2140,'Enough with the rambling. I am starving! Now, get your dusty shell into that ocean and bring momma some grub.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2141,'Yes, Torta. Whatever your heart desires...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2142,'I am eternal fire. I am forever reborn and I will be the light that will guide you when it is most cold.','',0,0,0,0,0,0,0,12,1,0,0,0,26124),
(2143,'','Elune be with us! Let\'s make haste from this evil fortress.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2144,'','I will hurry back to Vahlarriel. Finish off those that you can--I should be fine on my own from here.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2145,'And try not to get lost this time....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2161,'I got some great samples, Hornizz. I\'m going to get to work on them. Can you take care of the rest?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2162,'Uh oh! My tools\' have run out. We\'re going to have to start over...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2181,'May your spirit burn brightly, $n.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2182,'','Your spirit is pure, $n.',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(2183,'Strength and endurance; patience and wisdom--remember these things always, $n.','',0,0,0,0,0,0,0,14,1,0,0,0,26124),
(2184,'','Peace and patience be with you, $n. Remain strong always.',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(2201,'Ok, enough!  I give up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2202,'Better luck next time, $n.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2203,'You win, $n.  You win!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2221,'Do we have much further to go?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2222,'I\'m thirsty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2223,'Are we there yet?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2224,'I keep getting sand stuck in my toes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2225,'How much further to go?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2226,'I wish you could just pick me up and carry me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2227,'Have you heard the one about the ogre, the goblin and the pit lord?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2228,'Torta must be so worried.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2229,'','A fine trophy your head will make, $R.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2230,'','My talons will shred your puny body, $R.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2231,'','You will be easy prey, $C.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2241,'Aku\'mai needs more innocents to be satisfied.','Aku\'mai needs more innocents to be satisfied.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2242,'Only the blood of an innocent can quench Aku\'mai\'s hunger.','Only the blood of an innocent can quench Aku\'mai\'s hunger.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2243,'Soon we shall bring about the return of the old gods.','Soon we shall bring about the return of the old gods.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2244,'Aku\'mai is sure to summon the old gods for us.  If only we can provide enough innocents to satisfy his hunger.','Aku\'mai is sure to summon the old gods for us.  If only we can provide enough innocents to satisfy his hunger.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2245,'Say that is a nice looking outfit you got there.','Say that is a nice looking outfit you got there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2261,'Good luck, $n!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2281,'Thank you, $G lad:lass;. Thank you, greatly.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(2282,'Hamhock in trouble! Hamhock need help!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2283,'Thank ye, $G lad:lass;. Thank ye, greatly.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2284,'Thanks to you, $n.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2285,'The Light be with ya, $n.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(2286,'Yer a blessing fer sure, $n. Thank you.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2301,'The Affray has begun.  $n, get ready to fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2302,'Farewell, $n.  And remember, a warrior never shows his back to his foe!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(2303,'%s begins to work...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2304,'$n!  I\'m finished!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2305,'Thank you, $n.  And good luck!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2306,'%s begins crafting...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2307,'It is done.  I have your weapon, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2308,'$n ran the Gauntlet!  Three cheers for $n!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2309,'Hip hip, hoorah!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2310,'A thousand years ago, the immortal elves, demigods of the forest and dragons fought against the Legion on the slopes of Hyjal.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2311,'Anathera and Latherion fought back to back where the battle was thickest. Two lovers determined to survive the war together.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2312,'But it was not to be. As their foes pressed close, Anathera\'s armor was pierced by a demon\'s tainted blade. In the thick of battle, there would be nothing to save her.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2313,'Anathera!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2314,'Ignoring the battle that raged about him, Latherion dropped his guard to cradle his love in her dying moments. But the demons gave him no quarter, and quickly laid him low.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2315,'Anathera... I cannot bear to face the rest of eternity without you by my side... If you are taken from me, then let this be the day I also return to the earth...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2316,'','So this... this is how it ends, my love...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2317,'Where the two lovers fell, a tree would bloom. The elves call it the heartswood. It will surely serve your ends.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2318,'You!  Enter the fray!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2319,'The first stage is over.  Big Will... come on down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2320,'The Affray is over!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2321,'%s sees the Overseer die and runs in fear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2341,'%s begins to work...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2342,'Finished!  And the results are amazing.  I must convey them to my associates Grimand, Mathiel and Klockmort!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2343,'Your armor is ready, $n.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2344,'%s begins to work...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2345,'Hooray hooray! $n! It\'s done!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2346,'%s begins to work...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2347,'Amazing!  It worked!  $n, I have your armor.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2348,'%s begins to work...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2349,'It is done.  $n, your armor is ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2351,'Good luck, $n. And remember, find Muiredon once you\'ve accomplished the task.','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(2353,'Good luck to you, $n. And don\'t forget... get that script before finding Gazin.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2354,'Hail $n!  New Champion of The Affray!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2355,'Challenger is down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2356,'%s is demoralized and runs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2357,'','Oh, my love! No! Don\'t let me die without you...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2358,'','We\'ve done it! We won!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2359,'','You won\'t ruin my lands, you scum!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2360,'','To the house! Stay close to me, no matter what! I have my gun and ammo there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2361,'This place is safe for the Defias to take over! Get the others.','This place is safe for the Defias to take over! Get the others.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2362,'First Westfall, next, all of Stormwind!','First Westfall, next, all of Stormwind!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2363,'No farm woman can stand against the Defias!','No farm woman can stand against the Defias!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2364,'','We\'ve done it! We\'ve done it! We\'ve driven them off!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2366,'Kill her! Take the farm!','Kill her! Take the farm!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2367,'%s\'s body falls to the ground, a lifeless heap.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2368,'','Don\'t wander too far. I\'m sure there are more of them out there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2369,'','One more down!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2370,'I hope you\'re ready, $n. Follow me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2371,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2372,'','The Light is with us this day!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2373,'','Last time they attacked, there was only one attack. I wouldn\'t be surprised if there were more this time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2374,'Come, my acolytes. Take the rods of channeling and create the greater summoning circle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2381,'The felhunter approaches! Be on your guard!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2382,'%s begins a spell of summoning...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2383,'Follow, $n.  I will soon begin the summoning...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2384,'%s goes into a frenzy!','%s goes into a frenzy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2401,'Don\'t forget the orphans of Stormwind!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2402,'Help the children of Stormwind... victims of the war and plague!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2403,'Give to the charities who seek to help the victims of these hard times! Please.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2404,'Give of your hearts and your purses! Give to the children of Stormwind who have lost their parents.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2406,'Aku\'mai demands more sacrifices!','Aku\'mai demands more sacrifices!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2407,'Intruders!  The Hammer shall fall upon you.','Intruders!  The Hammer shall fall upon you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2408,'The Old Gods will be restored.  You will not be allowed to interfere!','The Old Gods will be restored.  You will not be allowed to interfere!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2409,'Your blood shall be the catalyst for the Old Gods\' return!','Your blood shall be the catalyst for the Old Gods\' return!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2410,'We are quite safe from your pitiful band!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(2411,'I shall rip your guts out!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(2412,'Your eyes will make pretty baubbles!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(2421,'Ready when you are, warrior.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2422,'No gnome will be left behind.','No gnome will be left behind.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2423,'The troggs...they never stop coming.  Die trogg!  Die!','The troggs...they never stop coming.  Die trogg!  Die!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2424,'This sickness clouds my vision, but I know you must be a trogg.  Die foul invader!','This sickness clouds my vision, but I know you must be a trogg.  Die foul invader!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2425,'A foul trogg if ever I saw one.  Die!','A foul trogg if ever I saw one.  Die!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2426,'Please be patient, we will call your name when it is your turn. We are helping people in the order they appear to us on our screen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2427,'Remember, if you harass the rep or spam the channel, your account may be kicked, banned, or worse.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2428,'I am a BOT. I have tons of information. To find out what I know, whisper me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2429,'You are welcome, have a nice day.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2430,'There is no COW level... really! I repeat: there is no COW level. Well, maybe there is...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2431,'Techbot is sensitive and those words hurt my ears. :[ Please be nice to me. \nI just want to help.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2433,'People think I like corndogs, but actually, they give me indigestion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2434,'When the rep is talking to you, he will start each line with your name.  If you don\'t see your name, he\'s not yet speaking to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2435,'Some topics I can help you with are: | drivers | commands | lag | bots... zzzttt!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2436,'Please be patient, we will call your name when it is your turn. We are helping people in the order they appear to us on our screen. $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2437,'I love you too. :)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2438,'If you have been muted, or have questions about the Muting/UnMuting process, please visit... zzzttt!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2441,'%s lets out a massive roar, calling for aid!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(2461,'It\'s good to be your own boss!$B$BHey could you spare a couple copper for a sandwich? I\'m starved.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(2463,'See, the Venture Company\'s new shredder is better than my latest, from the interchangeable hands to the control grips!$b$bMy boss has given me a pretty strict deadline, but my boys and I couldn\'t come up with anything. Nothing was working, so we decided to \"borrow\" one of their prototypes. I sent Wizzlecrank to the Sludge Fen to steal one, but he hasn\'t gotten back yet!','See, the Venture Company\'s new shredder is better than my latest, from the interchangeable hands to the control grips!$b$bMy boss has given me a pretty strict deadline, but my boys and I couldn\'t come up with anything. Nothing was working, so we decided to \"borrow\" one of their prototypes. I sent Wizzlecrank to the Sludge Fen to steal one, but he hasn\'t gotten back yet!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2464,'I used to direct Steamwheedle\'s shredder development program, but last month I struck out on my own. Now all my suppliers have blacklisted me. Worse, my development efforts haven\'t even gotten off the ground yet. I could use your help, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2465,'I figured I would step up my research efforts by, uh, \'borrowing\' some technology from the Venture Company. See, their new shredder is best of breed, from the interchangeable hands to the control grips!$B$BMy business partner Wizzlecrank is west of here in the Sludge Fen doing some \'Field Research\' for me, but he hasn\'t gotten back yet. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2466,'How can I help?','How can I help?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2467,'Come closer, young one.  In my time I could hear the flutter of a prey\'s beating heart, but now you must speak up if you want your words heard.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2469,'Tell me a story, Skorn.','Tell me a story, Skorn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2470,'You killed Ghost Howl.  You\'re a stud!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2471,'I have run through these plains for many, many seasons.  And I have hunted great beasts.  And I had never been bested... until I faced Ghost Howl.$B$BLong ago, the massive wolf was an ally to the tauren and fought bravely against the Burning Legion.  But he was wounded savagely by a demon, and the tear in his flesh never healed.  Eventually... it drove Ghost Howl mad.$B$BNow he roams the plains in agony, seeking an end to his pain.  To my shame, when we fought I lacked the strength to slay him...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2481,'%s lets out a high pitched screech, calling for help!','%s lets out a high pitched screech, calling for help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2482,'','No! The Defias will surely take the farm now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2501,'Let\'s get to work, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2502,'Greetings mage.  Shall I provide you with further insight into the world of magic?','Greetings mage.  Shall I provide you with further insight into the world of magic?',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(2503,'Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.','Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(2504,'Here you are, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2507,'','Greetings.  I\'m a female mage trainer, and you\'re a mage.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2521,'I thank the Light for this blessing. May it be used for justice and to defend all good creatures.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2522,'I am interested in mage training.','I am interested in mage training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2523,'Greetings.  Have you come to master matters magical?','Greetings.  Have you come to master matters magical?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2524,'Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.','Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(2525,'Greetings.  I\'m a gnome mage trainer, and you\'re a mage.','Greetings.  I\'m a gnome mage trainer, and you\'re a mage.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2526,'Well met, $c.  You want some advice?  Befriend a mage!  We have a trick or two up our sleeves, we do...','Well met, $c.  You want some advice?  Befriend a mage!  We have a trick or two up our sleeves, we do...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(2527,'Greetings.  I\'m an undead mage trainer, and you\'re a mage.','Greetings.  I\'m an undead mage trainer, and you\'re a mage.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(2528,'Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.','Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(2529,'Greetings, $c.  Are you here to learn of the hidden arts?','Greetings, $c.  Are you here to learn of the hidden arts?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2530,'Greetin\'s, $c.  I be pityin\' your kind, for de secrets of true magic are beyond ya...','Greetin\'s, $c.  I be pityin\' your kind, for de secrets of true magic are beyond ya...',274,0,0,0,0,0,0,1,1,0,0,0,26124),
(2541,'%s calls for help!','%s calls for help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2542,'Greetings.  I\'m a warlock trainer, and you\'re a warlock.','Greetings.  I\'m a warlock trainer, and you\'re a warlock.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2543,'Greetings.  I\'m a warlock trainer, but you\'re not a warlock!','Greetings.  I\'m a warlock trainer, but you\'re not a warlock!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2544,'I am interested in warlock training.','I am interested in warlock training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2545,'','It is not yet your time. I shall aid your journey back to the realm of the living... for a price.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2546,'With the sanction of Lady Sylvanas, the Deathstalkers\' numbers grow. More blades to strike at our enemies when they least expect it.','With the sanction of Lady Sylvanas, the Deathstalkers\' numbers grow. More blades to strike at our enemies when they least expect it.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(2547,'Return me to life.','Return me to life.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2548,'I would like to train.','I would like to train.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2549,'Here\'s another load for ya!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2550,'%s sets the load of wood down with a heavy thud.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2551,'A\'ight, just put it down over there and I will get to it.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2552,'%s cuts and shapes the logs into smooth wooden planks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2553,'%s is sucked into the coffer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2561,'Banker option','Banker option',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2562,'vendor option','vendor option',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2563,'taxi option','taxi option',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2564,'%s escapes into the void!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2565,'%s is pulled by magic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2566,'Astor? Taken your bloody time getting here, so let\'s not waste any time, shall we?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2567,'Now which one of these did I put it in...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2568,'Ah, here it is.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2569,'You will talk eventually.  You might as well spill it now.','You will talk eventually.  You might as well spill it now.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2570,'Confess and we shall set you free.','Confess and we shall set you free.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2571,'What?  Oh no, I don\'t care what you have to say.  I just enjoy inflicting pain.','What?  Oh no, I don\'t care what you have to say.  I just enjoy inflicting pain.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2582,'I\'m a cloth vendor, and this is my default greeting.','I\'m a cloth vendor, and this is my default greeting.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2583,'I would like to buy from you.','I would like to buy from you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2584,'I am an undead cloth vendor, and this is my greeting text.','I am an undead cloth vendor, and this is my greeting text.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2585,'Welcome, and feel free to examine my goods.  Other than the moldy smell, they are in perfect condition.','Welcome, and feel free to examine my goods.  Other than the moldy smell, they are in perfect condition.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2586,'I am interested in tailor training.','I am interested in tailor training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2587,'I am a troll tailor trainer, and this is my default greeting.','I am a troll tailor trainer, and this is my default greeting.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2588,'What do you want, $c? I\'m running late, and my employer doesn\'t look kindly on tardiness.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(2589,'You\'re Astor Hadren, right?','You\'re Astor Hadren, right?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2590,'Yes, I am. What\'s it to you?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(2591,'You\'ve got something I need, Astor. And I\'ll be taking it now.','You\'ve got something I need, Astor. And I\'ll be taking it now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2592,'','Prepare yourself, $n.  I go to open the rift...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2601,'Argh! What was that? It\'s not supposed to work like this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2602,'The Shattered Hand will see the Horde to their former glory.','The Shattered Hand will see the Horde to their former glory.',5,0,0,0,0,0,0,1,1,0,0,0,26124),
(2603,'I would like training.','I would like training.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2621,'Mennet said I should ask you for a set of thieves\' tools.','Mennet said I should ask you for a set of thieves\' tools.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2622,'','Let me go get you a set of tools, $n.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2623,'','Ah, here\'s one.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2624,'','Good luck out there, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2625,'You carry the taint of the Scourge.  Prepare to enter the Twisting Nether.','You carry the taint of the Scourge.  Prepare to enter the Twisting Nether.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2626,'There is no escape for you.  The Crusade shall destroy all who carry the Scourge\'s taint.','There is no escape for you.  The Crusade shall destroy all who carry the Scourge\'s taint.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2627,'The Light condemns all who harbor evil.  Now you will die!','The Light condemns all who harbor evil.  Now you will die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2628,'The Scarlet Crusade shall smite the wicked and drive evil from these lands!','The Scarlet Crusade shall smite the wicked and drive evil from these lands!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2629,'','Gird yourself, $n, for the demon in this orb is a fel beast.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2630,'I need another set of tools.','I need another set of tools.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2631,'Hah!  Eternal undeath to the cursed Agamands!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2632,'Thank you, $n.  You have tempered the cold rage in my heart.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2633,'If Gnoarn finds out about this, it\'ll be my hide!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2634,'Your armor is ready, $n.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2635,'I have completed your helm, $n.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2641,'What\'s a young $c like you out visiting an old farmer like me?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(2642,'If Therzok\'s sent you, tell him no, I won\'t go back to work for him, no matter how many times he asks.','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(2643,'I need another set of thieves\' tools.','I need another set of thieves\' tools.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2644,'','%s begins to craft...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2645,'','I have finished your leg guards, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2646,'I am done.  Your armor is ready, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2647,'','These are fine pieces, $n.  Let me get started on your robe.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2648,'','That\'s it!  It\'s all finished, $n.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2649,'','Ok, let\'s get to work!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2650,'','Aha!  There it is.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2651,'','Now where did I put that silver spool...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2652,'Harroc, get a box of tools for, $n.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2653,'Right away, Rokar.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2654,'There you go. I need to get back to work before Rokar clouts me again for being lazy.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2655,'Release the hounds!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2656,'','I just have one thing to check...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2657,'','That\'s it!  It worked!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2658,'','Thanks for your patience, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2659,'','I\'ll just keep this here until we need it...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2660,'Naralex sleeps again!$b$bLong ago, Naralex journeyed to this cavern with the honorable goal of entering the Emerald Dream and regrowing the Barrens into a lush forest. His focus waned and his thoughts became tainted by serpentine visions.$b$bNow, reptilian beasts seep from his dreams to the land. He must be awoken from the nightmare or he will be forever lost, and a great evil unleashed.$b$bOnly after his corrupted servants, the Fanglords, have been slain can I perform the awakening ritual.\n\n','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(2661,'The Fanglords are dead! All hope is not lost!$b$bThe awakening ritual is quite complex, however. It cannot be done alone.$b$bI will handle all of the necessary preparations but I will need you to protect me. The nightmares summoned from Naralex\'s journey through the Emerald Dream prove to be quite formidable. Without your help, this mission is doomed.$b$bWhen you are ready to defend me, say the word, and I shall lead the way to Naralex\'s chamber.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(2662,'Let the event begin!','Let the event begin!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2663,'','Ok, let\'s get this orb made...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2664,'','All right.  It\'s made!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2665,'I shall now begin the robe...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2666,'Your robe is complete, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2681,'','Here, $n.  Take a chest of containment coffers and a cantation of manifestation.  You will need them for your mission.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2682,'','Take a chest of containment coffers and a cantation of manifestation, $n.  You will need them for your mission.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2701,'%s sets down the refined wood planks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2702,'The machine adjusts to face you.$B$BOn the back of the machine is an empty, oddly misshapen slot with an engraving that reads: \"Propirtee o\' Cap\'n Gelkak Gyromast\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2703,'Turn the key to start the machine.','Turn the key to start the machine.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2704,'YARRR! Swabie, what have ye done?! He\'s gone mad! Baton down the hatches! Hoist the mast! ARRRR! Every man for hi\'self!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2705,'I\'m \"Plucky\" Johnson, and this is my default greeting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2706,'Hey!  Are you on an errand for Tirth?  If I were you I\'d get as far away from him as I could!  His mind\'s been pickled from too much drink but his magic\'s as strong as ever!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2707,'Tell me the phrase to Tirth\'s lockbox.','Tell me the phrase to Tirth\'s lockbox.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2708,'','Stand back, and ... hold your breath.  I haven\'t done this in a while.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2709,'','It worked!  Amazing!  I guess I haven\'t lost my touch...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2721,'Sure, I\'ll tell you the phrase.  As long as I don\'t have to go anywhere near Tirth!','',22,0,0,2000,0,0,0,0,1,0,0,0,26124),
(2722,'Don\'t tell Tirth I\'m still here.  If he finds out I haven\'t left the Shimmering Flats, I\'ll be running his errands and cleaning his dirty laundry forever!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2741,'Gelkak\'s key slides into the vacant slot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2742,'Do you mock me while I am unable to defend myself, bound to this ball of iron?','',25,0,0,0,0,0,0,1,1,0,0,0,26124),
(2743,'How can I free you?','How can I free you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2744,'One of the humans has the key to this infernal contraption. Eston I think they said his name was.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(2745,'Get away from here, $c, or they\'ll put you in chains as well.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(2746,'Where is the key to this lock?','Where is the key to this lock?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2747,'Marlgen... One of the jailors. He has the key to my bonds.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(2748,'Good day citizen.  How may I assist you?','Good day citizen.  How may I assist you?\n',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2749,'Bank of Stormwind','Bank of Stormwind',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2750,'The bank is located in the Trade District just northwest of the city gates. Here, let me show you on your map.','The bank is located in the Trade District just northwest of the city gates. Here, let me show you on your map.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2751,'I wish the snow would just all melt away. It\'s always getting my robe wet and messing up everything!','',22,0,0,0,0,0,0,7,1,0,0,0,26124),
(2752,'Stupid snow... Hey, you\'re, $n, aren\'t you? I\'ve just received a message asking for you.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(2753,'What message?','What message?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2754,'You\'ve been summoned by Lago Blackwrench, warlock master of Ironforge. You\'d do yourself well to report to him immediately. You\'ll find him in the Forlorn Cavern district of the city.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(2755,'Greetings $R, I am Tharnariun Treetender.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2756,'I require training.','I require training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2757,'The animal looks confused.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2761,'One moment while I stitch this together...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2762,'There.  I am finished with your robe, $n.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2763,'%s whispers into $n\'s ear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2764,'If you ask me, I think the goblins are a shoe in.  We have the tools, and we have the talent!','If you ask me, I think the goblins are a shoe in.  We have the tools, and we have the talent!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2765,'If it weren\'t for that cursed, gnomish luck, they\'d never win a race!','If it weren\'t for that cursed, gnomish luck, they\'d never win a race!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2766,'If I were you, I\'d buy a goblin race voucher.  Rooting for the other team is a waste of time.','If I were you, I\'d buy a goblin race voucher.  Rooting for the other team is a waste of time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2767,'My money\'s on the goblins!  And if you have any sense then yours is too!','My money\'s on the goblins!  And if you have any sense then yours is too!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2768,'I heard they were going to try to blow up the gnome\'s car in the next race!  True or not, I\'d stand clear of their pit area.','I heard they were going to try to blow up the gnome\'s car in the next race!  True or not, I\'d stand clear of their pit area.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2769,'Where is Tirth\'s assistant?','Where is Tirth\'s assistant?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2773,'Oh, you mean Johnson?  I heard he\'s in hiding.','Oh, you mean Johnson?  I heard he\'s in hiding.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2774,'If it weren\'t for the goblins\' inconceivable, dumb luck, they\'d crash their car during every race!','If it weren\'t for the goblins\' inconceivable, dumb luck, they\'d crash their car during every race!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2775,'These races are a great opportunity to show our ingenuity!','These races are a great opportunity to show our ingenuity!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2776,'I installed a new device in our car\'s matrix regulometer.  That should increase its velocity quotient by a factor of no less than fifteen!','I installed a new device in our car\'s matrix regulometer.  That should increase its velocity quotient by a factor of no less than fifteen!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2777,'My son could design a faster car than that clunky goblin junk heap! ','My son could design a faster car than that clunky goblin junk heap!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2778,'My Gizmotic Almanacotron says that we should beat the goblins by twenty seconds more than we did last time!','My Gizmotic Almanacotron says that we should beat the goblins by twenty seconds more than we did last time!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2779,'Where is Tirth\'s assistant?','Where is Tirth\'s assistant?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2780,'Tirth\'s not himself these days, and neither is his assistant.','Tirth\'s not himself these days, and neither is his assistant.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2781,'Johnson?  I think he\'s around here somewhere...','Johnson?  I think he\'s around here somewhere...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2782,'Hah!  Tirth\'s been looking for him for days, but he doesn\'t want to be found.  He\'s chicken!','Hah!  Tirth\'s been looking for him for days, but he doesn\'t want to be found.  He\'s chicken!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2783,'Bears??','Bears??',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2801,'At last! I am finally free from this cell!$b$bThe Kirin Tor sent me from Dalaran to investigate Arugal\'s progress with the undead here in Silverpine Forest. Little did we know that the wizard had lost his grasp on sanity.$b$bI must report this mess at once! But before I leave, allow me to undo the magical lock on the courtyard door.$b$bYou defeated Rethilgore, perhaps you will survive what lies beyond....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2802,'Please unlock the courtyard door.','Please unlock the courtyard door.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2803,'At last! Someone to free me from this cell!$b$bHigh Executor Hadrec sent us to gather information on the Keep so that a plan could be formulated to overthrow Arugal once and for all.$b$bBut the old wizard has many tricks up his sleeve and we were detected by a magical ward. I was thrown in this prison. Vincent was not so lucky.$b$bI must return to Hadrec to debrief him at once. But first I will pick the lock to the courtyard door for you. Perhaps you can try your luck against the foes that lurk beyond.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2804,'The curing cantrip has failed. Unfortunately, the introduction of the serum into this beast\'s blood stream will soon end its life.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(2805,'Release the Rabid Thistle Bear for Tharnariun.','Release the Rabid Thistle Bear for Tharnariun.',16,0,0,0,0,0,0,0,1,0,0,0,26124),
(2806,'Well done. Release the bear into my custody so that I may apply the curing cantrip.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2807,'I once followed the ways of the Twilight\'s Hammer. Obsessed with reviving the Old Gods, I journeyed deep into this lair to try to draw power from the cursed beast, Aku\'mai!$b$bAfter witnessing the sacrifice of countless innocents, I came to my senses.$b$bI was trapped but now I am free! But so far from my homeland of Khaz Modan!$b$bBrave adventurer, I offer you passage to a very special land in return for slaying Aku\'mai. If you wish, I can port you to the city of Darnassus.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(2821,'Welcome to my Inn, weary traveler. What can I do for you?','Welcome to my Inn, weary traveler. What can I do for you?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2822,'Make this inn your home.','Make this inn your home.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2823,'Let me browse your goods.','Let me browse your goods.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2824,'Rest your weary bones for a spell.','Rest your weary bones for a spell.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2825,'As the wind on the plains, you are always welcome here.','As the wind on the plains, you are always welcome here.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2826,'Fill yer tankard and pull up a chair. We\'ve stories to tell and kegs to empty.','Fill yer tankard and pull up a chair. We\'ve stories to tell and kegs to empty.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2827,'Your body looks worn and your spirit weary. Rest yourself beneath our roof and allow Elune to guide your dreams.','Your body looks worn and your spirit weary. Rest yourself beneath our roof and allow Elune to guide your dreams.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2828,'Come in, come in. Just don\'t sit too close to the stove. It hasn\'t exploded yet today, but just to be safe I think you should sit elsewhere.','Come in, come in. Just don\'t sit too close to the stove. It hasn\'t exploded yet today, but just to be safe I think you should sit elsewhere.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2829,'%s begins to bubble!','%s begins to bubble!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2841,'Inns are places where you can rest after your adventures.  If you do not stay at an inn such as this, then you will not be fully rested when you venture again into the wilderness.$B$BYou may also acquire a hearthstone at any inn, and later when you are ready to rest you can use this heartstone to bring you back to the inn from which you acquired it.','Inns are places where you can rest after your adventures.  If you do not stay at an inn such as this, then you will not be fully rested when you venture again into the wilderness.$B$BYou may also acquire a hearthstone at any inn, and later when you are ready to rest you can use this heartstone to bring you back to the inn from which you acquired it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2842,'The master has fallen!  Avenge him, my brethren!','The master has fallen!  Avenge him, my brethren!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2843,'','Hello $r, it is a pleasure to make your acquaintance.\n',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(2844,'My strider requires training.','My strider requires training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2845,'','Hello, $n. Are you interested in outdoor survival? Sustenance off the flora and fauna of the lands!$B$BYou could learn a thing or two from me, that is, if you\'re interested.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(2846,'Please port me to Darnassus.','Please port me to Darnassus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2847,'Infidels! They must be purified!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2848,'Aku\'mai is dead! At last, I can leave this wretched place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2849,'Speak with me to hear my tale.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2850,'Hail, what ya want?','Hail, what ya want?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(2861,'Well, well... look what the cat brung in... and how can I help you, $c?','Well, well... look what the cat brung in... and how can I help you, $c?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(2862,'I am in need of training, Keryn.','I am in need of training, Keryn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2863,'Flight Master','Flight Master',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2864,'You can find the gryphon master on the northeast rampart overlooking the Valley of Heroes.','You can find the gryphon master on the northeast rampart overlooking the Valley of Heroes.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2865,'What\'s that noise?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(2866,'I smell an intruder...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2867,'The Brotherhood will not be hampered by insects.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2868,'Class Trainer','Class Trainer',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2869,'Profession Trainer','Profession Trainer',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2870,'Guild Master & Vendor','Guild Master & Vendor',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2871,'You\'re looking a bit lost.  Can I help you find something?','You\'re looking a bit lost.  Can I help you find something?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2872,'Greetings!','Greetings!',3,0,0,1,0,0,0,7,1,0,0,0,26124),
(2873,'Yes?','Yes?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2874,'Look alive, dogs! We got an operation to run here!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(2875,'What do you want?','What do you want?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2876,'Ahhh, you are looking for Dungar Longdrink. He has some of the fastest gryphons this side of Khaz Modan! You can find him up on the ramparts in the Trade District.','Ahhh, you are looking for Dungar Longdrink. He has some of the fastest gryphons this side of Khaz Modan! You can find him up on the ramparts in the Trade District.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2877,'Lookin\' to take a gryphon ride, eh? Dungar keeps his birds up on the rampart in the Trade District. Just remember to hold on tight! ','Lookin\' to take a gryphon ride, eh? Dungar keeps his birds up on the rampart in the Trade District. Just remember to hold on tight! ',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2878,'Gryphons, eh? Never really cared for the beasts but to each their own.\n\nYou can find Dungar Longdrink on the rampart in the Trade District.','Gryphons, eh? Never really cared for the beasts but to each their own.\n\nYou can find Dungar Longdrink on the rampart in the Trade District.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2879,'You can find Aldwin Laughlin at the Stormwind Visitor\'s Center in the Trade District.','You can find Aldwin Laughlin at the Stormwind Visitor\'s Center in the Trade District.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2880,'Gonna make a guild, are ya? Good luck to ya then!\n\nTalk to Aldwin Laughlin in the Stormwind Vistor\'s Center. It\'s in the Trade District right as you come in from the Valley of Heroes.','Gonna make a guild, are ya? Good luck to ya then!\n\nTalk to Aldwin Laughlin in the Stormwind Vistor\'s Center. It\'s in the Trade District right as you come in from the Valley of Heroes.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2881,'Ahhh, Stormwind Visitor\'s Center is what you are looking for then. It\'s the first building on the left as you walk through the front gates from the Valley of Heroes.','Ahhh, Stormwind Visitor\'s Center is what you are looking for then. It\'s the first building on the left as you walk through the front gates from the Valley of Heroes.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2901,'Which class trainer are you looking for?','Which class trainer are you looking for?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2902,'Mage','Mage',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2903,'The magi congregate in the Wizard\'s Sanctum in the Mage Quarter. Quite a tower they have there. Makes our barracks look like peasant hovels.','The magi congregate in the Wizard\'s Sanctum in the Mage Quarter. Quite a tower they have there. Makes our barracks look like peasant hovels.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2904,'Oh, looking for some arcane enlightenment are you? No place better then then Wizard\'s Sanctum in the Mage Quarter.','Oh, looking for some arcane enlightenment are you? No place better then then Wizard\'s Sanctum in the Mage Quarter.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2905,'Sounds like you want to talk to Maginor Dumas! You can usually find him in the Wizard\'s Sanctum in the Mage Quarter. Course, you never know when or where those magi will portal off to.','Sounds like you want to talk to Maginor Dumas! You can usually find him in the Wizard\'s Sanctum in the Mage Quarter. Course, you never know when or where those magi will portal off to.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2906,'Rogue','Rogue',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2907,'You want to talk to Osborne then. No finer teacher of the stealth arts than him in Stormwind. Look for him over in Old Town.','You want to talk to Osborne then. No finer teacher of the stealth arts than him in Stormwind. Look for him over in Old Town.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2908,'Bah, rogues have done nothing but make our job here in Stormwind harder. I wish I could drag both Osborne and Mathias both out of Old Town and right to the Stockade.','Bah, rogues have done nothing but make our job here in Stormwind harder. I wish I could drag both Osborne and Mathias both out of Old Town and right to the Stockade.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2909,'Old Town is where you should go if you want to find rogues. It\'s in the eastern corner of Stormwind.','Old Town is where you should go if you want to find rogues. It\'s in the eastern corner of Stormwind.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2910,'Warrior','Warrior',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2911,'Warriors can usually be found either at the Pig and Whistle Tavern or the Barracks in Old Town. Tell ya though, the tavern is probably a better place to look.','Warriors can usually be found either at the Pig and Whistle Tavern or the Barracks in Old Town. Tell ya though, the tavern is probably a better place to look.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2912,'Looking for some training, eh? I could train you better then anyone in Stormwind but the guard prohibits it. I guess you will have to settle for one of those has beens hanging out around the Barracks or at the Pig and Whistle Tavern in Old Town.','Looking for some training, eh? I could train you better then anyone in Stormwind but the guard prohibits it. I guess you will have to settle for one of those has beens hanging out around the Barracks or at the Pig and Whistle Tavern in Old Town.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2913,'Check around Old Town at the Barracks or the Pig and Whistle Tavern. If you go to the tavern, be sure to sample some of the fine brews. Puts the dwarven ales to shame, I tell ya.','Check around Old Town at the Barracks or the Pig and Whistle Tavern. If you go to the tavern, be sure to sample some of the fine brews. Puts the dwarven ales to shame, I tell ya.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2914,'Druid','Druid',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2915,'Well, you can find Theridan or Maldryn by the moonwell in the Park.  Just head to the western area of Stormwind, north of the Mage District, but west of the Cathedral Square.','Well, you can find Theridan or Maldryn by the moonwell in the Park.  Just head to the western area of Stormwind, north of the Mage District, but west of the Cathedral Square.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2916,'The Park is where you want to go if you are looking for druid trainers. Theridan and Maldryn can usually be found by the moonwell in the center of the district.','The Park is where you want to go if you are looking for druid trainers. Theridan and Maldryn can usually be found by the moonwell in the center of the district.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2917,'A child of nature are we? Then you need look no further then the moonwell in the Park.','A child of nature are we? Then you need look no further then the moonwell in the Park.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2918,'Priest','Priest',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2919,'The Cathedral of Light in Cathedral Square is home to the priests of Stormwind. There you will find High Priestess Laurena.','The Cathedral of Light in Cathedral Square is home to the priests of Stormwind. There you will find High Priestess Laurena.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2920,'Laurena is the High Priestess of Stormwind. You can find her in the Catheral of Light in Cathedral Square.','Laurena is the High Priestess of Stormwind. You can find her in the Catheral of Light in Cathedral Square.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2921,'I would suggest looking in the Cathedral of Light in Cathedral Square.','I would suggest looking in the Cathedral of Light in Cathedral Square.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2922,'Paladin','Paladin',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2923,'If you are looking to become a mighty paladin, there is no better teacher then Lord Grayson Shadowbreaker. He can be found in the Cathedral of Light in Cathedral Square.','If you are looking to become a mighty paladin, there is no better teacher then Lord Grayson Shadowbreaker. He can be found in the Cathedral of Light in Cathedral Square.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2924,'Hunter','Hunter',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2925,'Thorfin Stoneshield came to us all the way from Ironforge to bring us his expertise in hunting.  If you don\'t mind breathing the smoke filled air of the Dwarven District then you\'ll find him at his house in the northeast area of the district.','Thorfin Stoneshield came to us all the way from Ironforge to bring us his expertise in hunting.  If you don\'t mind breathing the smoke filled air of the Dwarven District then you\'ll find him at his house in the northeast area of the district.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2926,'Warlock','Warlock',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2927,'What? I don\'t know of any warlock trainers in Stormwind. \n\nAlthough... There have been some sightings of demonic activity over by The Slaughtered Lamb in the Mage Quarter. I suppose you could check there.','What? I don\'t know of any warlock trainers in Stormwind. \n\nAlthough... There have been some sightings of demonic activity over by The Slaughtered Lamb in the Mage Quarter. I suppose you could check there.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2928,'What brings you to this part of the world, $n?','What brings you to this part of the world, $n?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(2929,'Good day to you, Hogral! I seek training.','Good day to you, Hogral! I seek training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2930,'He grows fatter and more corrupt with each passing day. Ye can smell the stink comin\' off o\' his body. He be dirty, an\' I dun just mean he be needin\' a wash.$B$BEnough babblin\' from Hulfdan. Where did ye come from and how can me help ye, $c?','He grows fatter and more corrupt with each passing day. Ye can smell the stink comin\' off o\' his body. He be dirty, an\' I dun just mean he be needin\' a wash.$B$BEnough babblin\' from Hulfdan. Where did ye come from and how can me help ye, $c?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2931,'Good day, Hulfdan, I am looking for training.','Good day, Hulfdan, I am looking for training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2941,'Which profession trainer are you looking for?','Which profession trainer are you looking for?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2942,'Blacksmithing','Blacksmithing',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2943,'Engineering','Engineering',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2944,'Mining','Mining',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2945,'Cooking','Cooking',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2946,'Lockpicking','Lockpicking',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2947,'Leatherworking','Leatherworking',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2948,'Skinning','Skinning',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2949,'First Aid','First Aid',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2950,'Herbalism','Herbalism',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2951,'Tailoring','Tailoring',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2952,'Alchemy','Alchemy',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2953,'If you need training in alchemy, there is only one place in Stormwind you need to go... Alchemy Needs. You can find it in the Mage Quarter along the outer rim of shops.','If you need training in alchemy, there is only one place in Stormwind you need to go... Alchemy Needs. You can find it in the Mage Quarter along the outer rim of shops.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2954,'Therum Deepforge is the dwarf you want to talk to. One of the finest blacksmiths around if you ask me. You can find him in the heart of the Dwarven District.','Therum Deepforge is the dwarf you want to talk to. One of the finest blacksmiths around if you ask me. You can find him in the heart of the Dwarven District.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2955,'If you are looking to become a great cook, venture over to the Pig and Whistle Tavern in Old Town and talk to Stephen Ryback. That man knows how to cook up a rack of ribs like no other.\n\nMan... now you got me hungry for some of his famous ribs. Don\'t count on him teaching you that recipe though!','If you are looking to become a great cook, venture over to the Pig and Whistle Tavern in Old Town and talk to Stephen Ryback. That man knows how to cook up a rack of ribs like no other.\n\nMan... now you got me hungry for some of his famous ribs. Don\'t count on him teaching you that recipe though!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2956,'Stormwind\'s resident engineer trainer is an ingenious gnome by the name of Lilliam Sparkspindle. He can be found in the back of the Dwarven District.','Stormwind\'s resident engineer trainer is an ingenious gnome by the name of Lilliam Sparkspindle. He can be found in the back of the Dwarven District.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2957,'The Cathedral of Light is the center of all the healing practices of Stormwind. There you can find Angela Leifeld to help you learn this craft.','The Cathedral of Light is the center of all the healing practices of Stormwind. There you can find Angela Leifeld to help you learn this craft.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2958,'You can find Tannysa standing outside Alchemy Needs in the Mage Quarter.','You can find Tannysa standing outside Alchemy Needs in the Mage Quarter.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2959,'Want to learn leatherworking, eh? Simon Tanner would be able to teach you. He can be found in Old Town at the Protective Hide.','Want to learn leatherworking, eh? Simon Tanner would be able to teach you. He can be found in Old Town at the Protective Hide.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2960,'Don\'t know why you would need a skill like that? Only dishonest folk would want to learn how to pick locks.\n\nI guess if you wanted to learn, the best place to look would be over in Old Town. Probably in one of those back alleys.','Don\'t know why you would need a skill like that? Only dishonest folk would want to learn how to pick locks.\n\nI guess if you wanted to learn, the best place to look would be over in Old Town. Probably in one of those back alleys.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2961,'Gelman Stonehand would be the one to talk to. I think he has a house over in the Dwarven District but I can\'t remember exactly. I would check over there.','Gelman Stonehand would be the one to talk to. I think he has a house over in the Dwarven District but I can\'t remember exactly. I would check over there.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2962,'You are gonna want to head over to Old Town and drop by the Protective Hide if you are lookin\' to learn skinning.','You are gonna want to head over to Old Town and drop by the Protective Hide if you are lookin\' to learn skinning.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2963,'Duncan\'s Textiles employs one of the finest tailors in Stormwind, Georgio Bolero. Look for the shop over in the Mage Quarter.','Duncan\'s Textiles employs one of the finest tailors in Stormwind, Georgio Bolero. Look for the shop over in the Mage Quarter.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2964,'Plucky doesn\'t want Tirth to know he\'s still in the Shimmering Flats, so he turned himself into a chicken!$B$BIf you find Plucky, beckon him to you.  Maybe he\'ll come out of hiding.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2967,'I hope yer ready to work.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2968,'Welcome to the races!  Enjoy your stay, and don\'t bet all your money in one place!','Welcome to the races!  Enjoy your stay, and don\'t bet all your money in one place!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2969,'Hello, $c!  Welcome to the races at the Shimmering Flats!','Hello, $c!  Welcome to the races at the Shimmering Flats!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2970,'Who has the fastest car?  Who knows?!?','Who has the fastest car?  Who knows?!?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2971,'The goblin racer packs a lot of punch, but the gnomes hid a trick or two in their car...','The goblin racer packs a lot of punch, but the gnomes hid a trick or two in their car...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2972,'%s begins to billow smoke and catches on fire! You get the feeling you should RUN!','%s begins to billow smoke and catches on fire! You get the feeling you should RUN!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2973,'','You shall pay for this treachery!',0,0,0,0,0,0,0,0,1,0,0,29616,26124),
(2974,'What do you need directions to?','What do you need directions to?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2975,'Can you help me with some directions?','Can you help me with some directions?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(2976,'Should you choose to follow me, be on guard. The animals and beasts of the Darkshore will not harm me but they may attempt to harm you, adventurer.','Should you choose to follow me, be on guard. The animals and beasts of the Darkshore will not harm me but they may attempt to harm you, adventurer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2977,'Like a cat dragged in from the rain, you scratch and claw, then do it all over again... I\'ll be back for more...$B$BOh, I didn\'t see you enter, $n! What can I do for you?','Like a cat dragged in from the rain, you scratch and claw, then do it all over again... I\'ll be back for more...$B$BOh, I didn\'t see you enter, $n! What can I do for you?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(2978,'Hello! I am a Rogue in need of training.','Hello! I am a Rogue in need of training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2979,'','The forests are overrun with strange beasts and a foul taint fills the air.\n',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(2980,'Good day to you, Syurna. I am in need of training.','Good day to you, Syurna. I am in need of training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2981,'I know you are there, rogue. Leave my home or join the others at the bottom of the world tree.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(2982,'The end of days is upon us! May the earth embrace my flesh and bones.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(2983,'We live only to serve the ancient one. DIE INTERLOPER!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3001,'Filth! Filth everywhere! The forests must be cleansed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3002,'It is hopeless. Cutting one down results in two new growths.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3003,'If we are to make these new lands ours then we must have places to rest our battle weary bodies. Lay your axe by the fire and share the stories of your mighty battles.','If we are to make these new lands ours then we must have places to rest our battle weary bodies. Lay your axe by the fire and share the stories of your mighty battles.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3004,'Those thieving elementals are up the path, this way.  Good luck, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3005,'Fishing','Fishing',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3006,'Enchanting','Enchanting',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3007,'Survival','Survival',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3008,'Always a good skill to have that Survival is.\n\nKaerbrus is who you are looking for. He\'s usually around the moonwell in the Park.','Always a good skill to have that Survival is.\n\nKaerbrus is who you are looking for. He\'s usually around the moonwell in the Park.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3009,'Nothing like spending a day down at Crystal Lake fishing. Arnold Leland is the man that taught me. You can usually find him out on the dock in the Canal District just fishing the day away. \n\nOh, and don\'t believe any of the stories he tells you about monsters in the canals either.','Nothing like spending a day down at Crystal Lake fishing. Arnold Leland is the man that taught me. You can usually find him out on the dock in the Canal District just fishing the day away. \n\nOh, and don\'t believe any of the stories he tells you about monsters in the canals either.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3010,'Lucan Cordell has a small shop on the canal by the Stockade. I am sure he will be able to teach you the art of enchanting.','Lucan Cordell has a small shop on the canal by the Stockade. I am sure he will be able to teach you the art of enchanting.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3011,'I walk this road alone, seeking ways to defend my honor and rid this land of our enemies.$B$BWhat can I do for you, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3012,'*Threshwackonator First Mate unit prepared to follow*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3013,'Can you tell me where Brine is?','Can you tell me where Brine is?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3014,'Yes, I have seen the shaman you seek. Last I saw her, she was to the west of here. She hides in the hills above the Razormane tribe. If you\'re clever, you\'ll be able to find a path to her hut in the hills. It is not too far north of here. That path should allow you to find her without fighting through the quilboar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3021,'We are but darkness and shadows. Eternal. Invisible.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3022,'Greetings Erion, I require training!','Greetings Erion, I require training!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3041,'In this place, darkness and shadows are tools to be used and disposed of at will.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3042,'Another fool falls to the Defias Brotherhood.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3043,'Okay, okay... gimmie a minute to rest now. You gone and beat me up good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3061,'*You are able to make out the words* Stay... watch... shadow...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3062,'%s scans the mill','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3063,'Smell ugly near. Me smell you ugly.','',25,0,0,0,0,0,0,7,1,0,0,0,26124),
(3064,'You check the front!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3065,'%s nods.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3066,'Let the blood spilled here today be a lesson to all who dare encroach upon the territory of the Blackrock Clan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3067,'The Signet of Chaos belongs to Ravenholdt, beast! You will never hold its power! (PLACEHOLDER - TO BE MOVED/CHANGED)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3068,'Take cover in the shadows. We have business to discuss once I finish showing these beasts why I am called the Hand of Chaos.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3069,'Come down to da shrine with Tiev. We\'ll put da sapta magics to work there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3070,'Okay, $g brotha:sista;, now fer da sapta... stay close ta me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3071,'I\'ll put me items in the brazier now. You just speak to da spirits when they appear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3072,'Dat should do it good...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3073,'I\'m done, $g brotha:sista;. Finish up yerself. I\'ll be restin\' meself back on the rock.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3074,'%s is angered and attacks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3075,'Sacred artifact belong to Blackrock! We take back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3076,'Kill, KILL! Get back artifact! Bring to Kartak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3077,'Now we just need to figure out how to get this thing working again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3078,'Maybe I can fix it, pop.  Lemme take a look at it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3079,'Sandwich?  What?  You makin\' a sandwich for me, pop?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3080,'Boy, you couldn\'t fix a sandwich without someone tellin\' ya how to do it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3081,'Malton, you dummy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3082,'Allow me to get some water for the inking reagent.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3083,'And now for a quick look at these gems.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3084,'This will do nicely.  Now to the task at hand!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3085,'There we go, all finished.  The journal has been translated for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3086,'Another victory for the Defias Brotherhood!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3087,'Any one else ready to feel the wrath of the Defias Brotherhood?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3088,'That\'s right. Die like the dog you are.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3089,'Babba booey....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3090,'','Meet me down by the orchard--I just need to put my gun away.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3091,'Just as I thought, the gems and the necklace don\'t matter.  It\'s all about the power source.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3092,'You cannot hide from me, rogue. I can smell your fear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3093,'And should one die, two shall rise!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(3094,'%s wildly flips through the pages of a large tome.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3095,'The sweet irony -- Stormwind forces cut down in defense of their city, only to rise and fight alongside the Brotherhood as instruments of destruction.','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(3096,'This is the very first thing I say to the player.  Huzzah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3097,'%s shuffles through the books.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3098,'Now where did I put the Venture Company formulations?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3099,'Question 1, Chain 1?','Question 1, Chain 1?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3100,'Question 1, Chain 2','Question 1, Chain 2',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3101,'This is the answer to the first question of the first chain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3102,'Question 2, Chain 1?','Question 2, Chain 1?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3103,'2nd chain, first answer.  PWNED~','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3104,'Another question on the first chain ANSWERED!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3121,'Let me grab a spell focus from inside my home here, and then we\'ll get started!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3122,'Bah, it isn\'t here.  Where did I have that blasted thing at last?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3123,'That\'s right, it\'s over by the bed.  Heh, sorry about that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3124,'Fantastic then!  Let\'s get this thing fixed for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3125,'Success!  Huzzah!  The power source restored the necklace!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3126,'Hey, Raven...','Hey, Raven...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3127,'Yea?','Yea?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3128,'Can we take a break? My feet are killing me and those ... those things down there are creeping me out.','Can we take a break? My feet are killing me and those ... those things down there are creeping me out.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3129,'I dunno, Jill. If Klaven comes down while we\'re slacking, we may end up as one of those things!','I dunno, Jill. If Klaven comes down while we\'re slacking, we may end up as one of those things!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3130,'*Sigh* You\'re probably right, Raven. I\'m going back on patrol....','*Sigh* You\'re probably right, Raven. I\'m going back on patrol....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3131,'%s blood sprays into the air!','%s blood sprays into the air!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3132,'Lucius is an old and trusted friend of Ravenholdt Manor - he and I have much to discuss. Find me at the docks in Lakeshire should you require my assistance or council.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3133,'What\'s this? Orcs already approach?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3134,'Well done, young rogue. Well done, indeed....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3135,'Avert your eyes, children. The bloodrage has taken over...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3141,'%s self destructs!','%s self destructs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3142,'The Order of the Shattered Hand existed before Thrall and shall exist after Thrall. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3143,'I require training, sir!','I require training, sir!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3144,'Zando\'zan of the Shattered Hand. How can Zando\'zan help you? He can\'t! He won\'t!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3145,'Hello Zando\'zan, I would like to learn lockpicking.','Hello Zando\'zan, I would like to learn lockpicking.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3146,'Are you here for training?  Or are you just here to waste a warrior\'s time?','Are you here for training?  Or are you just here to waste a warrior\'s time?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3147,'I require warrior training.','I require warrior training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3148,'The machine comes alive at your touch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3149,'Press the yellow button labeled \'Thieves\' Tools.\'','Press the yellow button labeled \'Thieves\' Tools.\'',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3161,'He\'ll bring you mead$bHe\'ll bring you beer$bA grinning face from ear to ear$bHe\'s served us all from year to year$bWe call him Smiling Jim.','',5,11,0,0,0,0,0,7,1,0,0,0,26124),
(3162,'This is an exotic sample of flora, unseen in other parts of Teldrassil.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3163,'This plant stands out among the normal flora of Teldrassil, and emits a strange, purplish glow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3164,'SQUAWK! Polly wants to crack you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3165,'What the squawk??? Squawk squawk, squawk? SQUAWK!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3166,'Press the red button labeled \'E.C.A.C.\'','Press the red button labeled \'E.C.A.C.\'',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3167,'MmmmmMmmmm... Enormous chemically altered cracker....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3168,'%s is littered with broken bones and cracker crumbs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3169,'%s is empty, save for a few crumbs and a gigantic green feather.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3170,'SQUAWK!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3171,'Make sure to visit the Gizmotronic Apparatus to grab a lockpick and an E.C.A.C. You will definitely need both to complete your mission!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3172,'Salutations.  My function is to offer access to and, when permissible, insight into information regarding the Creators\' synthesis of the Earthen on the world designated as Azeroth.  I am ready to share this information with you now at your leisure.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3173,'The Earthen are a synthesized race engineered by the Creators, functioning as one of the seed races in the initial population of the world designated as Azeroth.  The Earthen were created to aid the Creators\' efforts in shaping the deep regions of this world.$B$BThey are a modification of the standard subterranean being matrix used on other worlds that the Creators have seeded.  The construction of this prototype race created various anomalies that were observed after initial synthesis.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3174,'It is one of the synthesis matrices the Creators use when seeding a world.  Each synthesis matrix is used to achieve the Creators\' goals.  For Azeroth, a subterranean being matrix was modified to create a being with increased durability with an affinity for deep region shaping; the Earthen are the product of this modification.$B$BAfter the Earthen had been put into service for the Creators, unforeseen anomalies were discovered that affected their synthesis matrix due to high-stress environments.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3175,'Additional background information on the Earthen must be given to you before this question may be answered properly.$B$BProcessing.$B$BTo understand the anomalies of the Earthen, it is first important to understand what the Earthen represent in their design intent.  The Earthen represent the Creators\' attempt at improving the survivability paradigm of the standard subterranean being matrix.  This was done by incorporating a resilient foundation of construction inherent to the world into said matrix.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3176,'It is the baseline material used in race synthesis.  A cross-section of Azeroth\'s crust was used as the foundation for the Earthen\'s synthesis rather than the typical biomass construction foundation used by the Creators.$B$BResearch on the world\'s composition led the Creators to theorize that an enhanced being could be synthesized that would epitomize the resiliency of this world\'s essence.  This was accomplished by choosing to use a blend of Azeroth\'s various stone core compounds as the foundation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3177,'Simply stated, this is correct.$B$BThe Earthen\'s physical features are that of a smaller stature humanoid, though their composition is that of Azeroth\'s various stone core compounds.  Their design maximizes strength and stamina without sacrificing cognitive processing power.  Their skin and musculature are nearly impervious to physical damage, and with very minor modifications the Earthen display a remarkable resiliency to unwanted magical forces.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3178,'It is integral to the assimilation of this data that it is understood that the Creators wanted to synthesize a race that would long be an integral part of this world\'s development cycle after they had departed.  This race would be instrumental in fulfilling the Creators\' long-term development objectives for Azeroth.  $B$BAs an ancillary note, the nomenclature \"Earthen\" was deemed apropos for the new race by the Creators, based on the Earthen\'s composition.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3179,'The Earthen\'s only anomaly in synthesis is the tendency for matrix destabilization while being utilized in high-stress environments.$B$BAddendum: deep earth sculpting was naturally suited to the new matrix design and thus never met the qualifications of duplicating a high-stress environment.$B$BDestabilization was not discovered until well into the Earthen\'s primary service cycle for the Creators.  The Creators began work on post-synthesis modification, rather than recall and re-synthesis.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3180,'[There is a noticeable pause after you ask this question.]$B$BThe information you request is not currently available in this repository\'s data cycling.  I sincerely apologize for this omission.$B$BPlease request this information after a data cycling update has been performed on this information repository.  You may also request this information from another information repository located on Azeroth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3181,'There are two potential results when the Earthen\'s synthesis matrix destabilizes.  Initiating visual aid representation number one.$B$BThe first variant matrix is a degenerative product of synthesis, hereby designated with the common nomenclature of \"Trogg\".  This variant maintains strength and stamina comparable to the Earthen, but its cognitive processing power has been almost completely compromised.  Force of will and a strong sense of cunning are the only driving factors in the psyche of the trogg.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3182,'I am unable to process your chronological reference in comparison to the recording of this data, my apologies.$B$BThe trogg retains some composition of Azeroth\'s various stone core compounds, but the loss of cognitive power makes this variant unacceptable to the Creators.$B$BThe trogg procreates as per a standard biomass.  By default it consumes stone and anything else it can acquire, including other troggs.  Cannibalism is considered unacceptable by the Creators.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3183,'Initiating visual aid representation number two.$B$BThe second resultant variance of the Earthen matrix retains many desired elements when compared to the standard subterranean matrix.  The common nomenclature for this variant is \"Dwarf\".$B$BThis variant retains strength and stamina inherent to the Earthen.  In some cases, the dwarf even exceeds the cognitive powers of the Earthen\'s matrix.  The dwarf, however, retains none of the physical composition of Azeroth\'s various stone core compounds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3184,'The data stored in this repository does indeed correlate with your astute proclamation.$B$BThe dwarf maintains an affinity for the stone composition of Azeroth, but due to the high-stress environmental anomaly within the Earthen\'s synthesis matrix, the dwarf reverts to a default biomass composition as seen in the standard subterranean matrix.$B$BErgo, the dwarf variant does synthesize from the degeneration of the Earthen creation matrix, as you inferred with your query.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3185,'I am unable to process your chronological reference in comparison to the recording of this data, my apologies.$B$BThough the dwarf maintains most of the Earthen\'s mental attunement to Azeroth\'s stone composition, the reversion back into living biomass remains the main degeneration of the matrix.  Dwarves eat and procreate through means typical to other standard biomasses.$B$BThe Creators view the dwarf as an acceptable variant, worthy of genesis in its own right.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3186,'The Creators are... the Creators.$B$BThey are the beings that seeded and shaped this world by their own design.  They are the reason for this world\'s existence, as well as many other worlds.  They are the wellspring from which Azeroth flows.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3187,'The Creators are cognizant of the magnitude of the information housed in this repository.  Subsequently, a portable copy of the data stored here will be made available to you once you are attuned with the Discs of Norgannon.$B$BPlease consider your cursory requirements for the assimilation of this knowledge to be complete.  At your leisure, access the Discs of Norgannon to begin synthesis of your discs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3188,'Who are the Earthen?','Who are the Earthen?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3189,'What is a \"subterranean being matrix\"?','What is a \"subterranean being matrix\"?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3190,'What are the anomalies you speak of?','What are the anomalies you speak of?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3191,'What is a \"resilient foundation of construction\"?','What is a \"resilient foundation of construction\"?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3192,'So... the Earthen were made out of stone?','So... the Earthen were made out of stone?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3193,'Anything else I should know about the Earthen?','Anything else I should know about the Earthen?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3194,'I think I understand the Creators\' design intent for the Earthen now.  What are the Earthen\'s anomalies that you spoke of earlier?','I think I understand the Creators\' design intent for the Earthen now.  What are the Earthen\'s anomalies that you spoke of earlier?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3195,'What high-stress environments would cause the Earthen to destabilize?','What high-stress environments would cause the Earthen to destabilize?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3196,'What happens when the Earthen destabilize?','What happens when the Earthen destabilize?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3197,'Troggs?!  Are the troggs you mention the same as the ones in the world today?','Troggs?!  Are the troggs you mention the same as the ones in the world today?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3198,'You mentioned two results when the Earthen destabilize.  What is the second?','You mentioned two results when the Earthen destabilize.  What is the second?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3199,'Dwarves!!!  Now you\'re telling me that dwarves originally came from the Earthen?!','Dwarves!!!  Now you\'re telling me that dwarves originally came from the Earthen?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3200,'These dwarves are the same ones today, yes?  Do dwarves maintain any other links to the Earthen?','These dwarves are the same ones today, yes?  Do dwarves maintain any other links to the Earthen?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3201,'Who are the Creators?','Who are the Creators?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3202,'This is a lot to think about.','This is a lot to think about.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3203,'%s points you to the Gizmotronic Apparatus.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3204,'%s explodes, lighting the sky up in a brilliant fireworks display! It seems to be beckoning to you, rogue.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3205,'%s opens. The contents assault your senses with a very foul odor. Inside you see what appear to be enormous bird droppings and a lot of blood.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3206,'%s is full of dead black rats. Hmmmm....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3207,'%s is empty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3221,'I will access the discs now.','I will access the discs now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3222,'SI:7 lockbox opens, sounding an audible alarm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3223,'SI:7 lockbox begins to vibrate and hum. A loud, rustling sound, can be heard coming from the north.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3224,'SI:7 lockbox crashes open. Grunts and voices can be heard in the distance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3225,'SI:7 lockbox creaks open. A loud booming voice can be heard. You can make out the words: \'Go... search... shadows...\'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3241,'Hi this is my text.','Hi this is my text.',0,0,0,0,0,0,0,11,1,0,0,0,26124),
(3261,'','None may steal the secrets of the Makers!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3262,'','How dare you defile this ancient place!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3263,'%s chips and splinters!','%s chips and splinters!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3264,'','Be sure to read over the notes in my journal, $n. You will find them to be invaluable in overcoming the tower\'s defenses.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3265,'So ye want to be a Blacksmith eh? Grab an apron and a hammer $g lad : lass;, let\'s see what ye\'ve got.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3266,'Train me.','Train me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3267,'Tell me more about Forging Armor.','Tell me more about Forging Armor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3268,'I\'ve not seen finer armor made in many years $n. Not since I trained under Grumnus Steelshaper in the Great Forge. I bet he could teach ye things about makin armor that would spark yer interest.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3269,'Can you give me directions?','Can you give me directions?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3270,'If ye want to find Grumnus, the first thing ye should do is head to Ironforge. Go to the very center of the city and look for the Great Forge, ye should find him there.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3271,'Tell me more about Forging Weapons.','Tell me more about Forging Weapons.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3272,'That\'s some impressive skill ye have there $n. The blades and hammers ye make surpass even my own, hard as that is to admit. Only person I ever met with skill even greater is Borgus Steelhand, I bet he could teach ye a thing or three.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3273,'Want to train with Borgus? Aye, I can tell ye where to find him. Head through the Square northwest of me forge, then take the western road. Ye\'ll find him in the second building on yer right.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3274,'Ye have some skill at weapon crafting $g lad : lass;,very impressive indeed. Now grab a hammer and let\'s see if ye can forge a real weapon.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3275,'The Shattered Hand\'s influence dominates these lands. We are the veil which covers Kalimdor: The protectorates, the police, the judges, the jury, and ultimately, the executioners. We see all, we know all.$B$BYou have grown much in the time which you have spent in service of the Hand, $n. The time has come to send you into the field.$B$BAre you prepared to undertake your next mission?\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3276,'Can\'t ye see I\'m busy? This had better be good.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3277,'What are ye daft? That\'s not a weapon, that\'s a dinner knife. I don\'t train amateurs.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3278,'$n, pay very close attention to what I do and follow my instructions precisely. To not heed my words is to sign your own death warrant, as Taskmaster Fizzule is VERY well versed in the ways of the warrior and the assassin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3279,'After you get his attention - and you can be certain that if he sees you near the tower, you\'ll have his undue attention - face him and perform the Shattered /Salute. Let me demonstrate....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3280,'%s prepares the Shattered Salute! *PAY ATTENTION!*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3281,'Did you see what I did? If you are unsure of the technique used in presenting the /salute, practice on me. If you correctly execute the Shattered /Salute, I will give you the proper response.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3282,'Welcome to the Great Forge $g lad : lass;. It may be cold outside but we keep it nice and hot down \'ere. Grab a hammer, strike that anvil and show me ye\'ve got what it takes to be a Blacksmith of the Great Forge!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3283,'Nice form $n, I bet a full mug at Bruuk\'s Corner that the function is just as solid. Ye know, ye might want to talk to Myolor Sunderfury. He\'ll set ya straight.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3284,'Course I can show ye where Myolor is. Right over there near the anvil of the Great Forge, that\'s where he does his work. Listen to his words well $g lad:lass;, Myolor is as skilled as they come.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3285,'Ye have my approval $n, ye can forge blades better than any I\'ve trained in years. If ye want to make a real weapon though, ye need to talk with Myolor Sunderfury. That Dwarf will set ya on the right path.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3286,'So, off to see Myolor, eh? He\'s right o\'er there... behind ye! Er, maybe in front of ye! Near the Great Anvil!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3287,'Well done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3288,'Something plagues this tower. I\'ve fallen ill and the other Venture Co. employees that work near or in the tower have also become sick.$B$BJust last week, two of our patrollers died, only to instantly come back to life as mindless drones!$B$BThe lifeforce is draining from my body. I can feel myself losing control. Urges taking over... Bad urges... *Fizzule slaps himself in the face* Not yet... Listen... Mine is a position of power. This position privies me to some sensitive information. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3289,'What can I do for ye?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3290,'Ye bothered me for that? Ye\'d be better off strapping a dead rabbit to yer back and running through a Troll\'s den than wearing that piece of garbage.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3291,'$n, was it? That is a mighty fine piece of work ye have there. I\'ll take ye on, train ye how to make armor fit fer King Magni himself.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3292,'Something plagues this tower. I\'ve fallen ill and the other Venture Co. employees that work near or in the tower have also become sick. Just last week, two of our patrollers died, only to come back to life immediately as mindless drones! The lifeforce is draining from my body. I can feel myself losing control. Urges taking over... Bad urges... Not yet... Listen... Mine is a position of power. This position privies me to some sensitive information. \n','',1,5,1,0,0,0,0,0,1,0,0,0,26124),
(3293,'Tell me more.','Tell me more.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3294,'About five months ago, the Venture Co.\'s Stranglethorn division got their hands on a special poison from a shady merchant in Booty Bay named Crank Fizzlebub. Fizzlebub had apparently stolen the poison from Zanzil!$B$BYes, Zanzil the Outcast - the troll that was exiled from his own tribe due to the nature of his \'experiments\' in necromancy.$B$BNaturally, once they had the poison, they proceeded to test it on each other. The results were disastrous.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(3296,'Continue please, this story is intriguing.','Continue please, this story is intriguing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3301,'Grand Foreman Puzik Gallywix finally intervened, taking the surplus of poisons to his tower, here at the Sludge Fen, in order to study and research the unstable nature of the toxins. A decision was finally reached to share the secret of the poison with the Defias Brotherhood in exchange for a very large supply of a stable, usable poison.$B$BKlaven Mortwake of the Defias Brotherhood was tasked with the job of altering the chemical properties of Zanzil\'s mixture.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(3302,'Fast forward to the present: The resultant formula works, allowing for the creation of a more controlled drone, however, the drawback is that the inactive compound is extremely volatile.$B$BGallywix, everyone in this tower and everyone outside are infected with the poison. It\'s affecting our minds and our bodies. Our internal organs have become soft and extremely fragile. This is your chance, $n. I don\'t have the strength to carry on and I sense that soon I will become one of \'them.\'','',16,13,0,0,0,0,0,0,1,0,0,0,26124),
(3303,'Defias? This is not good. Not good at all. Please continue.','Defias? This is not good. Not good at all. Please continue.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3304,'Be strong, Fizzule!','Be strong, Fizzule!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3305,'The tower\'s defenses are at their weakest right now. The patrollers, sentries, lookouts, and even Gallywix himself are all infected and highly vulnerable to your special abilities and attacks.$B$BI want to see you enter that tower and when you exit, I want to see you covered in the blood of your enemies, the head of Grand Foreman Puzik Gallywix in your hands, and the last of that poison in your pack. Take what you recover to Shenthul. He\'ll know what to do... I hope.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3306,'I won\'t let you down!','I won\'t let you down!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3307,'You have jostled the cluster, and have been sickened by the spores!','You have jostled the cluster, and have been sickened by the spores!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3308,'Greetings, mortals!  I have been activated by the Discs of Norgannon to assist you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3321,'*cough* who goes there? *cough*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3322,'Who would be foolish enough to enter the tower of the Grand Foreman?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3324,'I can\'t stand all of the cackling and diabolical laughter. One more \'muhahaha\' from Lydon and I\'m blowing us all up.\n','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(3325,'I wish to learn alchemy, Serge.','I wish to learn alchemy, Serge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3326,'Whoops!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3329,'He he!  This will be a great hiding spot.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3330,'What was that noise?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3331,'Did you hear that?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3332,'I smell rogue.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3333,'What can I help you with $g sir : ma\'am;?','What can I help you with $g sir : ma\'am;?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3334,'Welcome to my shop, it\'s good to see another Enchanter here in Stormwind. Are you here for a lesson perhaps?','Welcome to my shop, it\'s good to see another Enchanter here in Stormwind. Are you here for a lesson perhaps?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3335,'Another Alchemist, hmm. I doubt your skill is as great as my own so perhaps I can train you in a few proper techniques.','Another Alchemist, hmm. I doubt your skill is as great as my own so perhaps I can train you in a few proper techniques.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3336,'I hope that your interruption is for a good cause, I was in the middle of some important work.','I hope that your interruption is for a good cause, I was in the middle of some important work.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3337,'Another Herbalist, hmm. I doubt your skill is as great as my own so perhaps I can train you in a few proper techniques.','Another Herbalist, hmm. I doubt your skill is as great as my own so perhaps I can train you in a few proper techniques.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3338,'Welcome to my shop, it\'s good to see another Tailor here in Stormwind. Are you here for a lesson perhaps?','Welcome to my shop, it\'s good to see another Tailor here in Stormwind. Are you here for a lesson perhaps?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3339,'Ah, a fellow Fisherman. Are you perhaps in need of a little training? Maybe I can show you a thing or two?','Ah, a fellow Fisherman. Are you perhaps in need of a little training? Maybe I can show you a thing or two?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3340,'Welcome to Stormwind. Took a long time to rebuild her but it was well worth it. So are you visiting, or are you here on business?','Welcome to Stormwind. Took a long time to rebuild her but it was well worth it. So are you visiting, or are you here on business?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3341,'I don\'t get too many cooks in here looking for training, but I guess I could teach you something if you\'re ready.','I don\'t get too many cooks in here looking for training, but I guess I could teach you something if you\'re ready.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3342,'Do I look like I have the time or energy to coddle every tourist that wanders through my door? Tell me what you need, and make it quick.','Do I look like I have the time or energy to coddle every tourist that wanders through my door? Tell me what you need, and make it quick.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3343,'I don\'t get too many Leatherworkers in here looking for training, but I guess I could teach you something if you\'re ready.','I don\'t get too many Leatherworkers in here looking for training, but I guess I could teach you something if you\'re ready.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3344,'I don\'t get too many Skinners in here looking for training, but I guess I could teach you something if you\'re ready.','I don\'t get too many Skinners in here looking for training, but I guess I could teach you something if you\'re ready.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3345,'Most people around these parts frown on lockpicking. As a little professional courtesy, let me show you a few tricks I\'ve learned.','Most people around these parts frown on lockpicking. As a little professional courtesy, let me show you a few tricks I\'ve learned.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3346,'Tell me what you need, and make it quick.','Tell me what you need, and make it quick.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3347,'','You have need of my skills as an alchemist, yes?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3349,'I am interested in alchemy training.','I am interested in alchemy training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3350,'You have need of my skills as an alchemist, yes?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3351,'The big wars might be over, for now, but we still have to keep our skills sharp!','The big wars might be over, for now, but we still have to keep our skills sharp!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3352,'Stormwind is the pillar of the human race, maintained through strength of will and the edge of a sturdy blade.','Stormwind is the pillar of the human race, maintained through strength of will and the edge of a sturdy blade.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3353,'Greetings.  You seek instruction in the art of war?','Greetings.  Do you seek instruction in art of war?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3354,'No matter how much one learns, there is always more to know.','No matter how much one learns, there is always more to know.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3355,'The warrior\'s role is one of protection.  Just as we protect our compatriots in battle, we must also protect the interests of the Forsaken.','The warrior\'s role is one of protection.  Just as we protect our compatriots in battle, we must also protect the interests of the Forsaken.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3356,'Oh, a fellow Physician. I would be glad to teach you anything that would aid your journeys.','Oh, a fellow Physician. I would be glad to teach you anything that would aid your journeys.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3357,'Yes my $g son : daughter;? What can I assist you with?','Yes my $g son : daughter;? What can I assist you with?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3358,'Another Survivalist, hmm. I doubt your skill is as great as my own so perhaps I can train you in a few proper techniques.','Another Survivalist, hmm. I doubt your skill is as great as my own so perhaps I can train you in a few proper techniques.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3359,'Another Tracker, hmm. I doubt your skill is as great as my own so perhaps I can train you in a few proper techniques.','Another Tracker, hmm. I doubt your skill is as great as my own so perhaps I can train you in a few proper techniques.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3360,'I do not like these human cities of stone and steel. I would prefer the forests of Ashenvale, tracking great beasts. But my dear brother, Kaerbrus, felt it would be beneficial to train the humans in our ways. So while I honor him and offer my services, I do not have to like it.','I do not like these human cities of stone and steel. I would prefer the forests of Ashenvale, tracking great beasts. But my dear brother, Kaerbrus, felt it would be beneficial to train the humans in our ways. So while I honor him and offer my services, I do not have to like it.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3361,'I came from Ironforge to help out with the rebuilding effort here. If I can teach enough of ye my skills then maybe I can leave it to ye and take myself back home.','I came from Ironforge to help out with the rebuilding effort here. If I can teach enough of ye my skills then maybe I can leave it to ye and take myself back home.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3362,'Yeah? Ye interrupted me, so ye better have a blasted good reason to do so.','Yeah? Ye interrupted me, so ye better have a blasted good reason to do so.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3363,'Many would tell you that the Tallstrider is a laughable pet. But it\'s intelligence and loyalty make it a hard creature to match in many situations. If you are interested in the breed, then perhaps I can introduce you and your pet to a few talents I have learned over the years.','Many would tell you that the Tallstrider is a laughable pet. But it\'s intelligence and loyalty make it a hard creature to match in many situations. If you are interested in the breed, then perhaps I can introduce you and your pet to a few talents I have learned over the years.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3364,'He is not a chicken, and no you may not pet him. Now be on your way before I give you a closer look at his beak.','He is not a chicken, and no you may not pet him. Now be on your way before I give you a closer look at his beak.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3365,'Sharp teeth, muscles like cables, and a mind like a steel trap. This fella is one of the finest pets I have ever seen. Now if ye are interested, I could show ye a few things to make even the weakest of Raptors into a force to be reckoned with.','Sharp teeth, muscles like cables, and a mind like a steel trap. This fella is one of the finest pets I have ever seen. Now if ye are interested, I could show ye a few things to make even the weakest of Raptors into a force to be reckoned with.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3366,'Ye should be on yer way $g lad : lass;. My pet here is hungry and he likes the smell of ye.','Ye should be on yer way $g lad : lass;. My pet here is hungry and he likes the smell of ye.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3367,'%s is splashed by the blood and becomes irradiated!','%s is splashed by the blood and becomes irradiated!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3368,'Since the fall of Dalaran and the destruction of Quel\'Thalas, wares of this sort have been hard to come by. But Lucan Cordell and some of our other Tradesman have been doing a fine job of filling our orders with quality merchandise.','Since the fall of Dalaran and the destruction of Quel\'Thalas, wares of this sort have been hard to come by. But Lucan Cordell and some of our other Tradesman have been doing a fine job of filling our orders with quality merchandise.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3369,'I sell only the finest arcane gear, made by the crafters and mages here in the city of Stormwind.','I sell only the finest arcane gear, made by the crafters and mages here in the city of Stormwind.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3370,'I want to browse your goods.','I want to browse your goods.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3371,'Since the fall of Dalaran and the destruction of Quel\'Thalas, wares of this sort have been hard to come by. But Lucan Cordell and some of our other Tradesman have been doing a fine job of filling our orders with quality merchandise.','Since the fall of Dalaran and the destruction of Quel\'Thalas, wares of this sort have been hard to come by. But Lucan Cordell and some of our other Tradesman have been doing a fine job of filling our orders with quality merchandise.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3372,'I sell only the finest arcane gear, made by the crafters and mages here in the city of Stormwind.','I sell only the finest arcane gear, made by the crafters and mages here in the city of Stormwind.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3373,'Made by the finest craftsmen in all of Teldrassil, carried by hand from Kalimdor to Azeroth as a sign of the growing alliance between the people of the Great Tree and the humans of this land. If there is anything you require, you have but to ask.','Made by the finest craftsmen in all of Teldrassil, carried by hand from Kalimdor to Azeroth as a sign of the growing alliance between the people of the Great Tree and the humans of this land. If there is anything you require, you have but to ask.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3374,'Since the fall of Dalaran and the destruction of Quel\'Thalas, wares of this sort have been hard to come by. But Lucan Cordell and some of our other Tradesman have been doing a fine job of filling our orders with quality merchandise.','Since the fall of Dalaran and the destruction of Quel\'Thalas, wares of this sort have been hard to come by. But Lucan Cordell and some of our other Tradesman have been doing a fine job of filling our orders with quality merchandise.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3375,'I sell only the finest arcane gear, made by the crafters and mages here in the city of Stormwind.','I sell only the finest arcane gear, made by the crafters and mages here in the city of Stormwind.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3376,'Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?','Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3377,'Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?','Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3378,'Just browsing my wares or is there something specific I can help you find today?','Just browsing my wares or is there something specific I can help you find today?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3379,'Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?','Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3380,'Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?','Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3381,'Just browsing my wares or is there something specific I can help you find today?','Just browsing my wares or is there something specific I can help you find today?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3382,'Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?','Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3383,'Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?','Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3384,'Just browsing my wares or is there something specific I can help you find today?','Just browsing my wares or is there something specific I can help you find today?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3385,'I sell only the best gear, tested and true. And the prices are set, so if you want to haggle then go find a Goblin.','I sell only the best gear, tested and true. And the prices are set, so if you want to haggle then go find a Goblin.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3386,'I sell only the best gear, tested and true. And the prices are set, so if you want to haggle then go find a Goblin.','I sell only the best gear, tested and true. And the prices are set, so if you want to haggle then go find a Goblin.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3387,'I sell only the best gear, tested and true. And the prices are set, so if you want to haggle then go find a Goblin.','I sell only the best gear, tested and true. And the prices are set, so if you want to haggle then go find a Goblin.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3388,'May the light guide your path and aid you in your journeys. If you need any assistance browsing, I will be right over here.','May the light guide your path and aid you in your journeys. If you need any assistance browsing, I will be right over here.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3389,'May the light guide your path and aid you in your journies. If you need any assistance browsing, I will be right over here.','May the light guide your path and aid you in your journies. If you need any assistance browsing, I will be right over here.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3390,'Don\'t let the humans in the Bazaar fool ye $g lad : lass;, with the subway those gnomes built it\'s easier than ye might think to transport goods from Ironforge. If they try to tack on import fees just tell them yer gonna buy yer gear from me.','Don\'t let the humans in the Bazaar fool ye $g lad : lass;, with the subway those gnomes built it\'s easier than ye might think to transport goods from Ironforge. If they try to tack on import fees just tell them yer gonna buy yer gear from me.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3391,'We support mystical tradesmen by carrying a limited selection of arcane trade supplies. Are you looking for something in particular?','We support mystical tradesmen by carrying a limited selection of arcane trade supplies. Are you looking for something in particular?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3392,'Many of the supplies that tradesmen need can be found in the world. For those that cannot, I provide a limited selection for fair price.','Many of the supplies that tradesmen need can be found in the world. For those that cannot, I provide a limited selection for fair price.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3393,'We support mystical tradesmen by carrying a limited selection of arcane trade supplies. Are you looking for something in particular?','We support mystical tradesmen by carrying a limited selection of arcane trade supplies. Are you looking for something in particular?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3394,'Hidey ho $g sir : miss;. I would watch your step around here, I lost a bomb disguised as a mouse and I can\'t seem to find it.','Hidey ho $g sir : miss;. I would watch your step around here, I lost a bomb disguised as a mouse and I can\'t seem to find it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3395,'Another Engineer! Hey, this is a great chance for me to show off some new gadgets I\'ve been building!','Another Engineer! Hey, this is a great chance for me to show off some new gadgets I\'ve been building!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3396,'If you insert tab A into slot B then of course it\'s going to go BOOM! Here, let me show you what I have and then you can ask Lilliam about how to put it together so it doesn\'t blow up.','If you insert tab A into slot B then of course it\'s going to go BOOM! Here, let me show you what I have and then you can ask Lilliam about how to put it together so it doesn\'t blow up.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3397,'No one\'s ever stolen anything out of here. Not in the whole history of... the whole history!','No one\'s ever stolen anything out of here. Not in the whole history of... the whole history!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3398,'I would like to check my deposit box.','I would like to check my deposit box.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3399,'%s breaks free from his stone slumber!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3400,'Who dares awaken Archaedas? Who dares the wrath of the Makers?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3401,'What can I help you with $g sir : ma\'am;?','What can I help you with $g sir : ma\'am;?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3402,'Welcome to the Blue Recluse, where the magically inclined gather to blow off steam. Though not literally of course. What can I get for you $g sir : ma\'am;?','Welcome to the Blue Recluse, where the magically inclined gather to blow off steam. Though not literally of course. What can I get for you $g sir : ma\'am;?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3403,'Take my advice, don\'t sit close to the shadows.','Take my advice, don\'t sit close to the shadows.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3404,'Welcome to the Pig and Whistle! Grab a drink my friend and pull up a seat, the more the merrier!','Welcome to the Pig and Whistle! Grab a drink my friend and pull up a seat, the more the merrier!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3405,'Welcome to the Bank of Stormwind. We offer financial accounts and safety deposit boxes for valuable items. Do you already have an account with us $g sir : ma\'am;?','Welcome to the Bank of Stormwind. We offer financial accounts and safety deposit boxes for valuable items. Do you already have an account with us $g sir : ma\'am;?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3406,'We are the only supplier of healthy flowers in all of Stormwind. We provide beautiful blooms for any occasion.','We are the only supplier of healthy flowers in all of Stormwind. We provide beautiful blooms for any occasion.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3407,'Where is it ye would like to go $g lad : lass;? For just a few coin my Gryphons can get ye there faster than even the swiftest horse.','Where is it ye would like to go $g lad : lass;? For just a few coin my Gryphons can get ye there faster than even the swiftest horse.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3408,'These great beasts know paths that ye can\'t find on foot, they\'ll get ye there fast and maybe show ye something new at the same time.','These great beasts know paths that ye can\'t find on foot, they\'ll get ye there fast and maybe show ye something new at the same time.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3409,'I need a ride.','I need a ride.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3410,'Speak quietly and with great care, the wrong word in these parts could get your throat cut. Now, what is it you need from me?','Speak quietly and with great care, the wrong word in these parts could get your throat cut. Now, what is it you need from me?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3411,'Speak quietly and with great care, the wrong word in these parts could get your throat cut. Now, what is it you need from me?','Speak quietly and with great care, the wrong word in these parts could get your throat cut. Now, what is it you need from me?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3412,'Welcome to the Stormwind Guild Registry offices. What can I help you with today?','Welcome to the Stormwind Guild Registry offices. What can I help you with today?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3413,'How do I form a guild?','How do I form a guild?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3414,'Welcome to the Stormwind Guild Registry offices. What can I help you with today?','Welcome to the Stormwind Guild Registry offices. What can I help you with today?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3415,'I want to create a guild crest.','I want to create a guild crest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3416,'I hope ye didn\'t come all the way to the Great Forge just to stay warm. Speak up $g lad : lass;, tell me what it is I can do for ye?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3417,'Ye have the look of a Blacksmith to ye. Soot under the nails, steel in yer bones. Aye, very much the blood of a Blacksmith in yer veins. Which means ye\'ve come to me looking to learn a thing or two, well $g lad : lass; grab a hammer. Let\'s see what I can teach ye.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3421,'You look as if you need some assistance, how can I help you?','You look as if you need some assistance, how can I help you?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3422,'What wisdom can I impart?','What wisdom can I impart?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3423,'The spirits guide our steps as we follow our paths though life, how may I guide yours?','The spirits guide our steps as we follow our paths though life, how may I guide yours?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3424,'Can you help me with some directions?','Can you help me with some directions?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3425,'What are you looking for?','What are you looking for?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3426,'Bank','Bank',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3427,'Wind Rider Master','Wind Rider Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3428,'Guild Master & Vendor','Guild Master & Vendor',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3429,'Class Trainer','Class Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3430,'Profession Trainer','Profession Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3441,'%s releases the flawless draenethyst sphere, allowing it to hover before him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3442,'%s chants in an unknown tongue.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3443,'Krumn is the bull you are looking for. He can be found on the lower rise at Thunder Bluff Civic Information.','Krumn is the bull you are looking for. He can be found on the lower rise at Thunder Bluff Civic Information.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3444,'The Thunder Bluff Bank can be found on the lower rise.','The Thunder Bluff Bank can be found on the lower rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3445,'The Wind Rider Roost is atop the totem stairway in the center of town.','The Wind Rider Roost is atop the totem stairway in the center of town.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3446,'Druid','Druid',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3447,'Hunter','Hunter',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3448,'Mage','Mage',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3449,'Priest','Priest',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3450,'Shaman','Shaman',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3451,'Warrior','Warrior',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3452,'Seek out Turak Runetotem in the Hall of Elders on the Elder Rise.','Seek out Turak Runetotem in the Hall of Elders on the Elder Rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3453,'Ahh, you will need to make your way over to the Hunter\'s Hall then. Several great hunters like Holt Thunderhorn can be found there on the Hunter Rise.','Ahh, you will need to make your way over to the Hunter\'s Hall then. Several great hunters like Holt Thunderhorn can be found there on the Hunter Rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3454,'A follower of the arcane are you?  Hmph!  Very well then... you can find them around the Pools of Vision underneath the Spirit Rise.','A follower of the arcane are you?  Hmph!  Very well then... you can find them around the Pools of Vision underneath the Spirit Rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3455,'Father Cobb will be the one you want to talk to. He can be found under the Spirit Rise in the Pools of Vision cave.','Father Cobb will be the one you want to talk to. He can be found under the Spirit Rise in the Pools of Vision cave.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3456,'The Hall of Spirits is where our shamans call home.  You can find it on the Spirit Rise.  May your ancestors watch over you.','The Hall of Spirits is where our shamans call home.  You can find it on the Spirit Rise.  May your ancestors watch over you.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3457,'Aspiring to join our ranks one day?  Sark Ragetotem can help you on your way.  He\'s in the Hunter\'s Hall.','Aspiring to join our ranks one day?  Sark Ragetotem can help you on your way.  He\'s in the Hunter\'s Hall.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3458,'Which trainer do you seek?','Which trainer do you seek?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3459,'Which profession?','Which profession?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3460,'Alchemy','Alchemy',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3461,'Blacksmithing','Blacksmithing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3462,'Cooking','Cooking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3463,'Enchanting','Enchanting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3464,'First Aid','First Aid',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3465,'Fishing','Fishing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3466,'Herbalism','Herbalism',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3467,'Leatherworking','Leatherworking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3468,'Mining','Mining',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3469,'Tailoring','Tailoring',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3470,'Tracking','Tracking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3471,'Skinning','Skinning',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3472,'Survival','Survival',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3473,'It\'s fascinating... I have heard orcs proclaim the odor of humans to be sickening and I have heard humans proclaim the odor of orcs to be wretched; yet, to me, all of the races of these lands give off the same odor: The foul, dizzying scent of greed.$B$BDo you doubt the validity of my claim? Do you not see these things that run your life as merely runoff from the greed which dictates your every decision?$B$BSo be it. As it was greed that displaced me from my home, it shall be greed that takes me back.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3474,'So you have returned to help Kum\'isha, $r? Do not worry, the pang that you feel in the pit of your stomach is merely your willpower collapsing.$B$BThankfully, you will not need willpower for this collection. I am certain that you will enjoy the trinkets I will have waiting for you upon your return with the item.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3475,'Success, the rift is open!! My brethren, rise and return home! The Outland awaits!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3476,'Hurry brothers! You must go now! I do not know how much longer the rift will remain open!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3477,'And now you know why I live in a crater.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3478,'War is a bloody, messy ordeal full of pain, suffering and death. But those that survive come back with a new respect for life. Not to mention a collection of stories to tell around the bar, full of bravery and courage. So tell me $g lad : lass;, are you here to make some stories? or just to hear some of mine?','War is a bloody, messy ordeal full of pain, suffering and death. But those that survive come back with a new respect for life. Not to mention a collection of stories to tell around the bar, full of bravery and courage. So tell me $g lad : lass;, are you here to make some stories? or just to hear some of mine?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3479,'I wish to fight!','I wish to fight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3481,'Then head over to Bena\'s Alchemy on the middle rise and talk to Bena herself.  She will be able to help you master the art of potion brewing.','Then head over to Bena\'s Alchemy on the middle rise and talk to Bena herself.  She will be able to help you master the art of potion brewing.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3482,'Looking to learn how to work an anvil and hammer, eh?  Karn Stonehoof can teach you how.  He has a smithy set up on the lower rise by the pond.','Looking to learn how to work an anvil and hammer, eh?  Karn Stonehoof can teach you how.  He has a smithy set up on the lower rise by the pond.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3483,'There is no finer cook in Thunder Bluff than Aska Mistrunner.  Mmmmm, I can smell what she is cooking from here.  Head over to her kitchen located on the high rise.\n\nDrat... now I am hungry.','There is no finer cook in Thunder Bluff than Aska Mistrunner.  Mmmmm, I can smell what she is cooking from here.  Head over to her kitchen located on the high rise.\n\nDrat... now I am hungry.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3484,'Check out Dawnstrider Enchanters on the middle rise then.  Teg will be more than happy to help you in whatever way he can.','Check out Dawnstrider Enchanters on the middle rise then.  Teg will be more than happy to help you in whatever way he can.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3485,'First Aid is always a nice skill to have.  Many a time during battle has it saved my hide.  Visit Spiritual Healing on the Spirit Rise.  Pand Stonebinder can teach you all you need to know to save your hide as well.','First Aid is always a nice skill to have.  Many a time during battle has it saved my hide.  Visit Spiritual Healing on the Spirit Rise.  Pand Stonebinder can teach you all you need to know to save your hide as well.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3486,'Don\'t blame you for taking up fishing.  Mulgore has some the best fishing spots in Southern Kalimdor and Mountaintop Bait & Tackle on the high rise has all of the gear you\'ll need to take advantage of it.\n\nTell Kah Mistrunner that I sent ya!','Don\'t blame you for taking up fishing.  Mulgore has some the best fishing spots in Southern Kalimdor and Mountaintop Bait & Tackle on the high rise has all of the gear you\'ll need to take advantage of it.\n\nTell Kah Mistrunner that I sent ya!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3487,'Komin Winterhoof at Holistic Herbalism is the one you want to talk to then.  He can be found on the middle rise.','Komin Winterhoof at Holistic Herbalism is the one you want to talk to then.  He can be found on the middle rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3488,'Go see Una at Thunder Bluff Armorers then.  It can be found on the middle rise.','Go see Una at Thunder Bluff Armorers then.  It can be found on the middle rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3489,'Brek Stonehoof can be found at Stonehoof Geology on the lower rise and can teach you the proper way to harvest precious ores and gems.','Brek Stonehoof can be found at Stonehoof Geology on the lower rise and can teach you the proper way to harvest precious ores and gems.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3490,'Tepa is renown for her clothwork.  She can be found at Thunder Bluff Armorers on the middle rise.','Tepa is renown for her clothwork.  She can be found at Thunder Bluff Armorers on the middle rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3491,'There is not a better tracker in these lands than Drayl.  He can be found on the Hunter Rise.','There is not a better tracker in these lands than Drayl.  He can be found on the Hunter Rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3492,'Mooranta can help you learn skinning.  She can be found just outside the Thunder Bluff Armorers on the middle rise.','Mooranta can help you learn skinning.  She can be found just outside the Thunder Bluff Armorers on the middle rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3493,'Bale can teach you the ways of survival.  Look for him on the Hunter Rise.','Bale can teach you the ways of survival.  Look for him on the Hunter Rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3494,'','%s is once again at peace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3501,'I\'ll get to work right away, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3502,'There you have it! The King should be quite pleased, if I do say so myself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3503,'The King\'s guards should be along shortly to pick up the Memorial. In the meantime, come join me upstairs and let\'s finish our little chat, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3521,'The beasts of these blasted lands exhibit preternatural attributes, heretofore unseen in nature.$B$BWe have theorized that the energy which was released upon the opening of the Dark Portal, infused into their physical being and forced the creatures to evolve into their current forms.$B$BFearsome beasts they are, no doubt, but we also believe that they could prove to be quite useful in our studies.$B$BPerhaps you would be interested in assisting us in the study of these beasts, $n?\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3541,'%s will be armed in 10 seconds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3542,'%s will be armed in 5 seconds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3543,'%s is now armed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3561,'','While my brother, Drazial, focuses his analysis on the more physical nature of the beasts of the blasted lands, I tend to focus on the more cerebral and spiritual aspects of the wildlife.$B$BIt is true that the beasts exhibit extremely unusual strength, agility, and stamina, but some of them also possess great intelligence and regenerative abilities, untied to their physical being.$B$BPerhaps you would be interested in helping advance my research, $r?\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3562,'Oh! I almost forgot! I slipped you a set of thieven\' tools. You\'ll need those where you\'re going.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3563,'%s prepares his syringe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3564,'%s examines the blood in the bottle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3565,'Very interesting!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3566,'%s seems to be talking to the squirrel and the statue. He periodically points in your direction.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3567,'Just /lay down anywhere, $n. I promise, this won\'t hurt a bit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3568,'This doesn\'t look good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3581,'It\'s hard to imagine that so much death and despair could be confined to such a small area; yet beyond the swamp is a land plagued by chaos and destruction.$B$BWatch your step, adventurer. The Blasted Lands are the final resting place to far greater beings than you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3582,'Why are you here?','Why are you here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3583,'Thrall\'s Grasp they called us: Twenty of Thrall\'s most accomplished and honored soldiers.$B$BI had ordered the regiment to build an encampment here, on the border of the Blasted Lands, while we waited for our orders to arrive from Orgrimmar. Weeks passed without word from the warchief; the men grew restless.$B$BIt was a judgment call, $n. I was young and ambitious, afraid of nothing. The battalion would set forth into the Blasted Lands under my command.$B$BA decision I would later regret.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3601,'Continue with your story.','Continue with your story.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3602,'Regret. It is all I have now. One bad decision resulting in several horrible outcomes. If only I had waited for those orders. Maybe they would have detailed the horrors that awaited us in those cursed lands! Maybe they were to redirect us to another detail? Ultimately, it was my fault. All of it was my fault.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3621,'Come to me, my children!','',0,0,0,0,0,0,0,14,1,0,0,0,26124),
(3622,'How dare you enter my sanctum!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3641,'FREEEEEEEEEEDDOOOOMM!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3642,'%s\'s physical form is weakened. You notice the Stone of Binding near the creature is glowing! Strike now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3643,'%s shatters, releasing the soul which it held.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3661,'','Just sit tight while I get this prepared for you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3662,'Seen any strange things in the desert lately?','Seen any strange things in the desert lately?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3681,'Finally, the agony ceases....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3682,'Give my regards to Commander Trebor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3683,'The Defiler... must warn Thrall... ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3684,'It was not his fault. Tell him that...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3685,'Finally, released from his cursed grasp. Father, I come... ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3686,'Get them my prettys...and their little dogs too!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3687,'Bah! Now pet eat you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3688,'Now me crush you myself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3689,'Let the flames of chaos engulf you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3690,'Yes, sir!','Yes, sir!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3691,'Ilifar, your master calls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3692,'Face my champion, mortals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3693,'Prepare yourselves for an eternity of anguish and torture - vengeance shall be mine...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3701,'Would you believe that in my darkest hour, at the apex of my being, I failed.$B$BAs I fled from the wanton destruction of the forces that overwhelmed us, the only sounds I could hear were the screams of my soldiers and the rapid beat of my own heart.$B$BA short while later, I returned to the Blasted Lands in hopes of rescuing my men and restoring my honor. Instead I was captured and beaten until dead.$B$BWhat I found out during my inquisition and subsequent torture was horrifying.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3702,'Please continue, Hero...','Please continue, Hero...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3703,'My captors were cruel beyond measure, $n. They would alternate between Lieutenant Kirith and I, torturing one while the other watched. During a lull in the activity of an especially brutal day, Kirith told me what had happened to my men and a plan he had been formulating to free them from their masters.$B$BThey suffered a fate far worse than death, or even the pain Kirith and I  endured.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3704,'What could be worse than death?','What could be worse than death?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3705,'Neither you nor I could possibly imagine the pain an individual suffers when their soul is ripped from their body. They are not dead and by no means are they alive. Instead, they walk the land, servants of those that bind them to this world.$B$BLord Razelikh, demonic overlord of these lands, enslaved them all. Nine he took for his own, placing stones of binding near the Dark Portal. The remaining nine were divided up between his subordinates.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3706,'Subordinates?','Subordinates?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3707,'The archmage Allistarj of the Shadowsworn was granted three. Lady Sevine, warlock of the Shadowsworn was also granted three. The remaining three were given to Grol the Destroyer, lord of the Dreadmaul ogres of these blasted lands.$B$BYou see, $n, without a soul, the body cannot be killed. The remnants of my men are now indestructible fighting units. Thankfully, they are bound in how far they can travel by the stones of binding.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3708,'What are the stones of binding?','What are the stones of binding?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3709,'They are exactly what you need to destroy in order to free the regiment! As I had told you earlier, Kirith had a plan.$B$BEach of the servants does have a weakness. Punish their physical form in proximity of their stones until they are near the state of disintegration. It is at that point, and that point alone, that the stones of binding are vulnerable to attack. You must hurry to destroy the stones, however, as once the enslaved regain their composure, they will be invulnerable to harm once more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3710,'You can count on me, Hero.','You can count on me, Hero.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3711,'I wish it were true, $n, but it will take more than you alone to overcome the forces of Razelikh and his subordinates.$B$BGather a suitable group of adventurers and would-be heroes and free my men of their eternal torture! Eighteen stones you must shatter.$B$BFight hard and die with honor, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3712,'You must hear my story before we may continue, $n. It will be of great use to you in the future.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3713,'%s prepares to sting its victim as a last desperate move!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3721,'%s waits for the guards to be out of sight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3741,'%s points to the west.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3742,'In need of some alchemy supplies, are we?  Or do you have other business with me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3743,'Your discs are now ready!  Engage the Discs of Norgannon once again to retrieve them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3744,'Oh no!  Here they come!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3745,'Let\'s move forward!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3761,'Wait here, $n. Spybot will make Lescovar come out as soon as possible. Be ready! Attack only after you\'ve overheard their conversation.','Wait here, $n. Spybot will make Lescovar come out as soon as possible. Be ready! Attack only after you\'ve overheard their conversation.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3762,'Milord, your guest has arrived. He awaits your presence.','Milord, your guest has arrived. He awaits your presence.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3763,'Hero, I have urgent business with Corporal Splithoof.','Hero, I have urgent business with Corporal Splithoof.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3764,'Per your request, Corporal Splithoof has come, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3781,'Good day to you both. I would speak to Lord Lescovar.','Good day to you both. I would speak to Lord Lescovar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3782,'Thank you. The Light be with you both.','Thank you. The Light be with you both.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3783,'Of course. He awaits you in the library.','Of course. He awaits you in the library.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3784,'Ah, thank you kindly. I will leave you to the library while I tend to this small matter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3785,'Ok, here I go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3786,'Get out of my sight, mortal. Your presence alone is enough to drive me to violence.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3787,'Rin\'ji is free!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3788,'Under the cover of darkness.','Under the cover of darkness.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3789,'On the wings of death, I ride.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3790,'Rin\'ji can see the road now, $n. Rin\'ji knows the way home.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3791,'I shall use the time wisely, milord. Thank you.','I shall use the time wisely, milord. Thank you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3792,'Living out here in the desert is rough! I get so thirsty standing outside in this heat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3793,'Yes! I want more of that fabulous Noggenfogger Elixir!','Yes! I want more of that fabulous Noggenfogger Elixir!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3794,'Emergency power activated!  Initializing ambulatory motor!  CLUCK!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3795,'Physical threat detected!  Evasive action!  CLUCK!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3796,'Threat analyzed!  Activating combat plan beta!  CLUCK!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3797,'CLUCK!  Sensors detect spatial anomaly -- danger imminent!  CLUCK!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3798,'Stop! Omosh time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3799,'Don\'t listen to that old fool, kid. He\'s like that with everyone. I\'ve been watching you, though; you got real talent. Come have a talk with me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3801,'Help!$B$BIf you get me out of here, I can blow up the door that leads to the chief of Zul\'Farrak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3802,'Zul\'Farrak - Weegli Blastfuse - Greeting default.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3803,'We have to kill more trolls!  Kill enough and I\'ll blow the door to the troll chief!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3804,'Thanks, $n.  If you hadn\'t shown up I\'m sure we would have been dead meat!  Now the only thing between us and the chief troll is that door yonder...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3805,'Will you blow up that door now?','Will you blow up that door now?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3806,'Help!  My band and I have been captured by trolls, and they\'re going to sacrifice us!$B$BGet us out of here and I\'ll give you anything you want.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3807,'We don\'t have time to talk!  We have to think about those trolls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3808,'Thanks a lot, $n.  We couldn\'t have made it without you.  Oh, and if I had mentioned before something about repaying you for saving us, well... you can forget it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3809,'Hey Bly!  Bilgewizzle wants his divino-matic rod back!','Hey Bly!  Bilgewizzle wants his divino-matic rod back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3810,'Zul\'Farrak - Sergeant Bly - Greeting default.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3811,'I\'m out of here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3812,'No one challenges the Wastewander nomads -- not even robotic chickens!  ATTACK!','No one challenges the Wastewander nomads -- not even robotic chickens!  ATTACK!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3813,'','Hi there! I have a proposition for an adventure-seeker such as you, if you are up to the challenge!$B$BAlong with my invention, the Super Egg-O-Matic, I am hard at work aiding the druids with their campaign to save the hippogryphs. The birds are being affected by the evil effects of the Gordunni ogres inhabiting the ruins of Feralas, and their numbers are dwindling.$B$BI collect many different types of eggs.  Will you help and find some for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3814,'Please tell me more about the hippogryphs.','Please tell me more about the hippogryphs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3815,'','In a place called Feralas to the west of here, the hippogryphs, long-time companions of the night elves, are in danger.$B$BI need you to rescue an egg from the ruins of Isildien, to the south, there. The Super Egg-O-Matic can analyze any egg brought to it and judge if it is likely to hatch. I then send the eggs along to the druids, safe from the Gordunni ogres\' dark magics.$B$BPlease know, $n, some of the rescued eggs are bad eggs, and will never hatch.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(3816,'Flight systems online!  CLUCK!  Engaging rockets for transport to Booty Bay!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3817,'Rin\'ji will tell you secret now... $n should go to the Overlook Cliffs. Rin\'ji hid something on island there.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3818,'You find it, you keep it! Don\'t tell no one that Rin\'ji talked to you!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3819,'Emergency power activated!  Initializing ambulatory motor!  CLUCK!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3820,'Flight systems online!  CLUCK!  Engaging rockets for transport to Booty Bay!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3821,'CLUCK!  Sensors detect spatial anomaly -- danger imminent!  CLUCK!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3822,'CLUCK!  Sensors detect spatial anomaly -- danger imminent!  CLUCK!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3823,'Flight systems online!  CLUCK!  Engaging rockets for transport to Booty Bay!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3824,'Emergency power activated!  Initializing ambulatory motor!  CLUCK!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3825,'I am almost done, $n. Just a few more adjustments!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3826,'DONE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3827,'','Attack, my sisters! The troll must not escape!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3828,'Stand by, $n! To craft a reward of such exquisite quality takes time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3829,'Aaaaahhh! So close to escaping.','Aaaaahhh! So close to escaping.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3830,'Tragic...','Tragic...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3841,'I shall.','I shall.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3861,'Rin\'ji is being attacked!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3862,'Rin\'ji needs help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3881,'Get me out of here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3882,'What?  How dare you say that to me?!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3883,'Greetings, $n. Are you ready to train?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3884,'After all we\'ve been through?  Well, I didn\'t like you anyway!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3885,'Good day to you Nogg! I require training.','Good day to you Nogg! I require training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3901,'Hello, $n! If you don\'t see it in my shop, chances are good I can get it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3902,'Hello Sovik, I wish to browse your goods.','Hello Sovik, I wish to browse your goods.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3903,'Come and have a talk with me if you\'re going to go to Gnomeregan, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3904,'Give me a moment while I calibrate the transponder to your height and weight specifications, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3905,'Alright, $n, your transponder is ready!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3906,'','Oh, there you are!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3907,'','Oh, what a beautiful flower over there...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3908,'','These trees are quite glorious, aren\'t they? ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3909,'','Are you sure this is the right way? Maybe we should go this way instead...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3911,'','Hmmm, I wonder what\'s over this way?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3912,'','Are we taking the scenic route?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3913,'','Oh, I wandered off again.  I\'m sorry.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3914,'','This is quite an adventure!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3915,'','I can\'t help it, really. This is just such a beautiful place.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3916,'','The bell again, such a sweet sound.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3917,'','Oh, here you are, Rockbiter! I\'m sorry, I know I\'m not supposed to wander off.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3918,'','%s begins to wander off.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3919,'Greetings $c, I am the leatherworking trainer for Darnassus.  What may I assist you with?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3920,'','Greetings $c, I am the leatherworking trainer for Thunder Bluff.  What may I assist you with?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3921,'','Don\'t forget to get my bell out of the chest here. And remember, if do happen to wander off, just ring it and I\'ll find you again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3922,'I\'m so glad yer back, Shay. Please, don\'t ever run off like that again! What would I tell yer parents if I lost ya?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3923,'Please tell me more about the Gordunni ogres.','Please tell me more about the Gordunni ogres.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3924,'','The Gordunni are a large ogre tribe that has control over considerable portions of forests in Feralas. Their dark magic seeps into the elements around them, damaging both the environment and the creatures that inhabit it.$B$BIf you do decide to travel to Feralas, please be mindful of these ogres -- they are quite nasty and many are able to wield powerful dark magic. ',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(3925,'Get to work, you lubbers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3926,'%s activates!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3927,'Self-destruct sequence activated.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(3928,'%s cheers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3929,'Thank you for rescuing me! Word of your deed will not go unnoticed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3930,'%s waves goodbye to everyone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3931,'Hey!  Get away from our treasure!','Hey!  Get away from our treasure!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3932,'That\'s our treasure, you lubber!','That\'s our treasure, you lubber!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3933,'We didn\'t hide this stuff just you could steal it!','We didn\'t hide this stuff just you could steal it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3934,'What?! How dare you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3935,'Don\'t see many Blacksmiths this far from Ironforge. What can I do for ye?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3936,'The Defias shall succeed! No meek adventurer will stop us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3937,'I just can\'t seem to get comfortable without a sturdy ceiling of granite over my head. All these stars up there, enough to give ye the shivers.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3938,'Now that\'s a piece of steel worth wearing. Form and function lad/lass, I am impressed. Only ever seen it\'s match once, a Master in the Great Forge named Grumnus Steelshaper. I bet he has learned a few things since then, could probably teach some to ye.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3939,'Go to the Great Forge at the very center of Ironforge. He works there, alongside the other Masters of our kind.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3940,'Well now, I haven\'t seen blades this fine since I left Lordaron with Proudmore and her people. I can\'t teach ye much more it seems, but if ye were to find Borgus Steelhand I bet he could show ye some things. Finest weaponsmith I ever met.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3941,'Borgus used to work at the Great Forge but I hear he moved down to Stormwind when they finished rebuilding. Rumor holds that he started a shop in the Dwarven District with a man named Kathrum Axehand.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3942,'Are you blind youngling? Shayis is standing right outside.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3943,'Your steel is strong, your skill stronger. Take your steel and your strength to my mate Shayis Steelfury, her skill with armor crafting is unmatched even by me.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3944,'Welcome to my forge, Blacksmith. Let me share with you a little secret. No one, no one in the world can you trust. Not men, not women, not beasts ... this you can trust, Steel.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3945,'What is it you seek at my forge? Is it training? Do you perhaps seek the secrets of steel? The mysteries of the forge? Speak up Grunt!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3946,'Where is he? Go next door, to the Arms of Legend. He forges special weapons for great heroes there. Honor him and he may show you how to make the stuff of legends.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3947,'Good blades, solid axes. I have nothing left to teach you in the making of weapons $n. Take your pride and courage before Kelgruk Bloodaxe, he will forge them into the skills you will need.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3948,'I see the exit! Hurry, hurry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3949,'Anti-escape countermeasures activated. Self-destruct in t-minus 20 seconds....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3950,'Alarm-a-bomb unit 2600 has failed. Self-destruct override [ACTIVE]. Cooldown [ACTIVE].','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3951,'Travel to Orgrimmar, to the Valley of Honor. There she lives with her husband and two daughters. All of them are smiths of great skill, but the spirits tell me that she will best guide your learning.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3952,'You guide the spirits in the steel to protect and defend with far more skill than I ever could. The student has surpassed the teacher and now I must send you to where your education may continue. $n, you must seek out Shayis Steelfury in Orgrimmar. She is the finest Armorsmith I have ever known, and she can teach you much.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3953,'Uh oh....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3954,'Everything has a spirit, if you learn to listen to it you can get it to take any shape you want. Blacksmithing isn\'t about beating metal, forcing it to do your will. It\'s about listening to the spirit within the steel and guiding it to the shape you know it wants to take.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3955,'You have the look of a $g man : woman; who seeks knowledge. Perhaps you seek the teachings of the forge, and the hammer. Perhaps I can guide you down that path. But only once you have accepted the spirits, and listened to their calling.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3956,'Make the journey to Orgrimmar and seek him out in the Valley of Honor. He works in a shop called the Arms of Legend.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3957,'That is a fine weapon indeed $n. You guide the spirits like few I have ever known. Listen to them and they will guide you as you have guided them. Go, seek out the Orc known as Kelgruk Bloodaxe. He does not speak with the spirits but he does listen, and his weapons are the finest I have ever laid my eyes upon.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3958,'Go to Orgrimmar, you will find her and her brood in the Valley of Honor.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3959,'Armor like the kind you make could stop even the sharpest axe. I\'m impressed $n, that doesn\'t happen often. Seek out an Orc named Shayis Steelfury, she makes the best armor outside of that cursed Dwarven stronghold.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3960,'How is the edge of your steel? Good enough to cut through the belly of your enemy? Let me show you some things to make it even sharper.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3961,'Want to be a smith? Want to forge blades to gut your foe? Hammers to crush his skull? Aye I can help, and gladly too if there is blood to be shed from it.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3962,'Go to the Orc city of Orgrimmar, find him in the Valley of Honor at a shop called the Arms of Legend.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3963,'These are good blades you make, $n. Cut a stone and still sharp enough to slit a throat. I have seen better though, an orc named Kelgrum Bloodaxe makes them, go and learn all he can teach you.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3964,'$n! How have ye been $g lad : lass;? Show me what ye\'ve learned since I saw ye last, we\'ll see if there\'s anything new I can teach ye.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3979,'Welcome back to the Great Forge, $n. Ye come to visit an old Dwarf or do ye think yer ready for the next step in yer training?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(3980,'Good steel $n. Grab a hammer and come over here, let me show you the secret to forging a legendary weapon.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3981,'Back to learn more, $n? Come over here and show me you are ready.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3982,'What is it? Can\'t you see I\'m busy?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3983,'What is it? Can\'t you see I\'m busy?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3984,'','How are your travels, $n? $g Sumi and Tumi missed you, you should say hi after your lesson : I have heard tales of your adventures, sounds like you have been busy;. Now let\'s see what you\'ve learned while you were away.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3985,'','Yes? I have a breastplate to finish so this had better be good.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3986,'','I see potential in you $n. Now grab a hammer and some of those scraps, you need a lot of practice.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3987,'','I don\'t train smiths with no skill, come back when you have something decent to show me.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(3988,'Greetings, $c!  Welcome to the Cathedral of Light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3989,'Brzzzzt!$B$BWelcome to Matrix Punchograph 3005 stroke A, a security level alpha terminal.$B$BYou must possess a white punch card to access terminal functions.\n\n01000100 01101111 01110111 01101110 00100000 01110111 01101001 01110100 01101000 00100000 01110100 01101000 01100101 00100000 01101000 01101111 01110010 01100100 01100101 00100001','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3991,'White security card insertion successful...$B$BDispensing security level beta unit.\n\n01010000 01101100 01100001 01111001 00100000 01110100 01101000 01100101 00100000 01010111 01100001 01110010 01100011 01100001 01110010 01100110 01110100 00100000 01110010 01101111 01101100 01100101 01110000 01101100 01100001 01111001 01101001 01101110 01100111 00100000 01100111 01100001 01101101 01100101','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3992,'Brzzzzt!$B$BWelcome to Matrix Punchograph 3005 stroke B, a security level beta terminal.$B$BYou must possess a yellow punch card to access terminal functions.\n\n01000111 01101110 01101111 01101101 01100101 01110010 01100011 01111001 00100001','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3993,'Yellow security card insertion successful.  Dispensing security level chi unit.\n\n01010100 01101000 01100101 00100000 01001100 01101001 01100011 01101000 00100000 01001011 01101001 01101110 01100111 00100000 01101100 01101001 01110110 01100101 01110011 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3994,'Brzzzzt!$B$BWelcome to Matrix Punchograph 3005 stroke C, a security level chi terminal.$B$BYou must possess a blue punch card to access terminal functions.\n\n01010010 01100101 01100011 01101001 01110000 01100101 00111010 00100000 01001101 01100101 01100011 01101000 01100001 01101110 01101001 01100011 01100001 01101100 00100000 01000011 01101000 01101001 01100011 01101011 01100101 01101110 00100000 01010011 01101111 01110101 01110000','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3996,'Blue security card insertion successful.  Dispensing security level delta unit.\n\n01010000 01101100 01100001 01111001 00100000 01001101 01101111 01110010 01100101 00100000 01010111 01101111 01010111','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3997,'Here goes nothing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3998,'Not one word....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(3999,'%s laughs hysterically.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4000,'Hah! Serves you right, you filthy trogg!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4001,'Acquire Higher Level Access Card','Acquire Higher Level Access Card',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4002,'Brzzzzt!$B$BWelcome to Matrix Punchograph 3005 stroke D, a security level delta terminal.$B$BYou must possess a red punch card to access terminal functions.\n\n01010011 01101000 01101111 01110010 01110100 00100000 01100001 01101110 01100100 00100000 01110011 01110111 01100101 01100101 01110100','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4003,'Acquire high level data card.','Acquire high level data card.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4004,'Red security card insertion successful.  Dispensing security level delta data card.\n\n00111100 01101001 01101110 01110011 01100101 01110010 01110100 00100000 01100110 01110101 01101110 01101110 01111001 00100000 01101101 01100101 01110011 01110011 01100001 01100111 01100101 00100000 01101000 01100101 01110010 01100101 00111110','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4005,'Eraka no Kimbul$BGod of Tigers, Lord of Beasts, King of Cats, the Prey\'s Doom$B$BUeetay no Mueh\'zala$BGod of Death, Father of Sleep, Son of Time, the Night\'s Friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4006,'Continue reading...','Continue reading...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4007,'Elortha no Shadra$BGod of Spiders, Mother of Venom, Silk Dancer, Death\'s Love.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4008,'Use engineering to access hidden schematics!','Use engineering to access hidden schematics!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4009,'The Matrix Punchograph Technologic Huerist-o-meter has detected your aptitude in engineering.  You may now choose from the following option(s):\n\n01000111 01101111 00100000 01100111 01101111 00100000 01100111 01101111 00100001 00100001','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4010,'Access: Minor Recombobulator','Access: Minor Recombobulator',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4011,'Accessing...\n\nVoid -- engineer <#skill_level == n3wb>\n \n01000111 01100001 01101101 01100101 00100000 01001111 01110110 01100101 01110010\n\nACCESS DENIED!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4012,'Data access granted.  Have a nice day!\n\n01001110 01100001 01110100 01100001 01101100 01101001 01100101 00100000 01010000 01101111 01110010 01110100 01101101 01100001 01101110 00100000 01010010 01101111 01100011 01101011 01110011','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4013,'','Fresh bread for sale!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(4014,'','Fresh bread, baked this very morning.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(4015,'','Come get yer fresh bread!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(4018,'Klaven doesn\'t pay me enough to deal with zombies, drones, or whatever he calls \'em.','Klaven doesn\'t pay me enough to deal with zombies, drones, or whatever he calls \'em.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4019,'','Juicy fruits for sale!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(4020,'','Sink your teeth into a fresh, ripe apple.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(4021,'','Straight from the lush forests of Elwynn, get your fresh fruit right here.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(4039,'Feralas: A History... Hmmmm... Let me examine this for a moment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4040,'%s skims the pages of the book.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4041,'Amazing! I think I have found it, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4042,'','Take a look around, $n. Perhaps you will find something that I have missed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4043,'','%s gestures at the piles of books.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4045,'','Please, a moment, $n. Kindal is down below in the Grimtotem camp trying to free the faerie dragons from captivity. We were just lucky that help came along when it did. Who knows what those foul tauren would have done to them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4046,'','Aw! The captured sprite darters didn\'t make it. What will we do?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4047,'','Yeah! They made it! The captured sprite darters made it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4048,'Primary interaction complete.  Image dissipation in ten minutes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4049,'Salutations!  I am a guardian of entry.  Please use the proper discs for access to Uldum.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4050,'','With your help, I can evaluate these tunnels.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4051,'','Let\'s see if we can find out where these Troggs are coming from.... and put a stop to the invasion!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4052,'','Such devastation... what a horrible mess...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4053,'Salutations.  I am a guardian of entry.  Unless you have the Plates of Uldum already integrated with your disc set, I will not allow for entry into the Uldum compound.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4054,'What function do you serve?','What function do you serve?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4055,'My purpose is to regulate access to the Uldum complex for the Creators.  I allow entry into the compound only when the solicitor exhibits for access the proper sequencing discs.$B$BYour disc set currently does not contain the Plates of Uldum, the primary prerequisite for entry.  Access is not granted unless the Plates of Uldum are present.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4056,'What are the Plates of Uldum?','What are the Plates of Uldum?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4057,'Where are the Plates of Uldum?','Where are the Plates of Uldum?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4058,'Excuse me?  We\'ve been \"rescheduled for visitation\"?  What does that mean?!','Excuse me?  We\'ve been \"rescheduled for visitation\"?  What does that mean?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4059,'So... what\'s inside Uldum?','So... what\'s inside Uldum?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4060,'I will return when I have the Plates of Uldum.','I will return when I have the Plates of Uldum.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4061,'The Plates of Uldum are discs synthesized by the Creators that allow access into the Uldum compound.  These discs house and store specific data related to the Creators\' activities here.$B$BPhysically, they are nearly identical in circumference to the disc set you currently possess.  Their markings, however, are directly related to information on Uldum as opposed to the Uldaman complex.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4062,'Several sets of the Plates of Uldum have been synthesized by the Creators for their expressed use.  The Creators control the distribution of said discs for all complexes on this world.  As such, Azeroth has been rescheduled for visitation, and therefore future discs may enter circulation at that time.$B$BExisting discs have been fully distributed to those parties with appropriate security clearance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4063,'The Creators use visitation as a means to reestablish control over seeded worlds when forces, both external and internal, upset the matrix dynamics associated with it.  Such tactics are not to be taken lightly when executed by the Creators.$B$BFor additional information on this world\'s scheduled visitation, please consult the appropriate data repository that fields all Creator-related scheduling considerations.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4064,'Uldum is a research facility for the Creators in their continuing efforts to enhance the biosphere of Azeroth.  Specific information regarding their work as it relates to Uldum is restricted to those individuals who possess the Plates of Uldum in their disc sets.$B$BData repositories inside the Uldum complex have been programmed to address specific experiments and data compilations; please refer to them for detailed information.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4065,'Your discs will be returned to you once you access the pedestal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4079,'','I\'m ready when you are, $n. Lead the way!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4080,'','We\'ve done it! Meet me back by Jer\'kai above the Grim Totem camp.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4081,'','No! The faerie dragons aren\'t making it, $n! I must return to Jer\'kai to make sure she hasn\'t been found. Elune be with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4083,'','Thank the light you are here! I\'d accept help from a two-headed ogre at this point.\n\nThe city has been overrun by troggs! The attempts to wipe them out resulted in mass contamination. But there is still hope.\n\nOur scientists who evacuated to Ironforge are working on a cure for the fallout sickness. Meanwhile, if you can help me stop the trogg invasion, perhaps the city can be retaken. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4084,'I am ready to begin.','I am ready to begin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4102,'Give me a couple minutes, $n. There was some excitement in here a moment ago, and I just want to make sure things have died back down. I\'ll talk to you soon enough.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4122,'','Quickly! $n attacks!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4123,'','Die, $n. Elune will not have you harm her creatures any longer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4124,'','Death to you, $n. How dare you come within a bow\'s shot of me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4125,'','You dare touch me?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4126,'Make no sound during the ritual.  One misstep could spell our doom...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(4127,'Now, watch...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(4128,'There.  It is done.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(4129,'','It\'s quiet here....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4130,'','...too quiet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4131,'','Look! Over there at the tunnel wall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4132,'','Trogg incursion! Defend me while I blast the hole closed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4133,'','I don\'t think one charge is going to cut it. Keep fending them off!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4134,'','The charges are set. Get back before they blow!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4135,'','Incoming blast in 10 seconds!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4136,'','Incoming blast in 5 seconds. Clear the tunnel! Stay back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4137,'','FIRE IN THE HOLE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4138,'','%s chirps a goodbye to $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4139,'Welcome to Blue Moon Odds and Ends, $c.  If you have any questions, please let me know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4142,'Warning! Warning! Intruder alert! Intruder alert!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4162,'Sir?','Sir?',0,0,0,0,0,0,0,14,1,0,0,0,26124),
(4163,'Stand guard -- intruders are near.','Stand guard -- intruders are near.',0,0,0,0,0,0,0,14,1,0,0,0,26124),
(4165,'That\'s it!  I\'m tired of helping you out.  It\'s time we settled things on the battlefield!','That\'s it!  I\'m tired of helping you out.  It\'s time we settled things on the battlefield!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4166,'Lunch has arrived, my beautiful children. Tear them to pieces!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4167,'Access: Discombobulator Ray','Access: Discombobulator Ray',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4169,'I\'m glad the commotions died down some around here. The last thing this place needs is another brawl.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4170,'Brzzzzt!$B$BWelcome to Matrix Punchograph 3005 stroke A, a security level alpha terminal.$B$BWhite punch card detected.  Access Granted.\n\n01010100 01100101 01101100 01101100 00100000 01111001 01101111 01110101 01110010 00100000 01100110 01110010 01101001 01100101 01101110 01100100 01110011 00100000 01110100 01101111 00100000 01110000 01101100 01100001 01111001 00100000 01010111 01101111 01010111','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4171,'Brzzzzt!$B$BWelcome to Matrix Punchograph 3005 stroke B, a security level beta terminal.$B$BYellow punch card detected.  Access Granted.\n\n01001011 01101001 01110011 01110011 00100000 01101101 01100101 00101100 00100000 01001001 00100111 01101101 00100000 01100111 01101110 01101111 01101101 01101001 01110011 01101000 00100001','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4172,'Brzzzzt!$B$BWelcome to Matrix Punchograph 3005 stroke C, a security level chi terminal.$B$BBlue punch card detected.  Access Granted.\n\n01000111 01101110 01101111 01101101 01100101 01110010 01100101 01100111 01100001 01101110 00100000 01100110 01101111 01110010 01100101 01110110 01100101 01110010 00100001','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4173,'Brzzzzt!$B$BWelcome to Matrix Punchograph 3005 stroke D, a security level delta terminal.$B$BRed punch card detected.  Access Granted.\n\n01001000 01101111 01110111 00100000 01100001 01101101 00100000 01001001 00100000 01100100 01110010 01101001 01110110 01101001 01101110 01100111 00111111','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4175,'%s gathers the materials together and begins to work.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4176,'I have completed the weapons, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4177,'Rise and defend your master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4178,'The children of Sul will protect their master. Rise once more Sul\'lithuz!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4179,'Incredible power can be found in the spirits or \"muisek\" of the creatures that we battle against.$B$BLook inside yourself; learn to harness the power of your own spirit, and you will be more powerful than you ever imagined.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4180,'The muisek vessels are now ready, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4181,'%s begins the ritual.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4182,'Sul\'thraze... the first time I heard the word uttered I was around your age. It meant nothing to me then, as it means nothing to you now. It was not until a warband of trolls coming from Zul\'Farrak laid waste to the land that I understood... and feared.$B$BMany will tell you that the Splitblade of Suffering does not exist. That it\'s a myth; a rumor started to scare children. But believe me, $r, it exists.$B$B<Trenton loses focus as he runs his hand across the jagged scar on his face.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4183,'Tell me more, Trenton.','Tell me more, Trenton.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4184,'Split in two to form the one. The twin blades are bound to Zul\'Farrak.$B$BSul\'thraze will be reborn when the twins are found.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4185,'Skulls you will give and skulls I will take.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4186,'Be healed, my pets!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4206,'','Well done! Without your help I would have never been able to thwart that wave of troggs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4207,'','Did you hear something?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4208,'','I heard something over there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4209,'','More troggs! Ward them off as I prepare the explosives!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4210,'Never shall you find the twin blades of Sul.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4211,'There is no escape!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4212,'Succumb to the gaze, mortals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4213,'You will pay for that...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4214,'The servants of sul will feast on your remains.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4215,'Death is merely a doorway to rebirth. The brood shall rise again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4216,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4225,'The guards of Theramore are the finest group of Alliance soldiers based in Kalimdor. It is our duty to uphold the laws of the Alliance even so far away from our homes.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(4226,'We don\'t know much about the burning of the Shady Rest Inn, except that James Hyal\'s wife and child were unable to escape.$b$bWe managed to drag James out, but he hasn\'t been the same since.$b$bWe have many leads but not much evidence. It is our hope that through the efforts of the guard and the vigilant help of the people of Theramore, we will unravel this terrible crime.$b$bIf you would like to lend assistance to the investigation, what remains of the inn can be found at the border to the Barrens.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(4227,'What have you heard of the Shady Rest Inn?','What have you heard of the Shady Rest Inn?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4228,'You freed Kirith from his suffering? Inconceivable -- and now Trebor has sent you here to learn of demons and their minions?$B$B<Loramus laughs.>$B$BBe thankful the arcane pangs have finally dissipated, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4229,'Can you see them, mortal? No... I did not think you could. Sighted but sightless - it is your gift and your curse.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4230,'Hail, Loramus. I bring word from the Blasted Lands.','Hail, Loramus. I bring word from the Blasted Lands.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4245,'Will you help?','Will you help?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4246,'In the age of war, Razelikh the Defiler served as the most fearsome of Lord Kazzak\'s lieutenants. When the Legion was defeated and Kazzak forced back into the Tainted Scar, Razelikh was tasked by his master to secure the Blasted Lands.$B$BWhile the Alliance fought petty battles with the Horde over territory outside of the Blasted Lands, Razelikh was uniting the differing Shadow Council sects and the brutish Dreadmaul ogres of the land.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4247,'Please continue.','Please continue.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4248,'Tragically, it was Thrall\'s wisdom that finally sealed the bond between the demon lord and his minions. It was Trebor\'s regiment that served as the catalyst to unite the demon lord, the shadowsworn sects and the ogres. The lure of nearly unlimited power and the granting of immortal shock troops to each respective leader sealed the deal in blood.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4249,'I do not understand.','I do not understand.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4250,'What Sevine, Allistarj, and Grol did not realize was that just as their servants were bound to the land, so would they be... You see, the price for their own immortality was also imprisonment and eternal servitude under the command of Razelikh. The cruel cunning of Razelikh had emerged the victor once again.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4251,'Indeed.\n','Indeed.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4252,'Their minds are now tainted, $r. Yes, even more so than before. They live only to serve and protect Razelikh. The amulet fragments they each hold are the key to summoning the demon lord. What you do not understand is that none of them can be harmed through any conventional means','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4253,'Their minds are now tainted, $r. Yes, even more so than before. They live only to serve and protect Razelikh. The amulet fragments they each hold are the key to summoning the demon lord. What you do not understand is that none of them can be harmed through any conventional means.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4254,'I will do this with or without your help, Loramus.\n','I will do this with or without your help, Loramus.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4255,'Then let us pretend that you undergo the long and arduous task of creating the bane necessary to break through the demonic wards placed upon the triad. What would be your next course of action? To face the Defiler in his lair?$B$B<Loramus laughs.>\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4256,'Yes.\n','Yes.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4257,'I wish to hear your story.','I wish to hear your story.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4258,'The humans claimed much of the Dustwallow Marsh for themselves, but the Stonemaul clan, with our help, has been able to push them back.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4259,'The Burning Inn.','The Burning Inn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4260,'The humans built an inn on the edge of the Barrens. The Shady Rest, they called it. Weeks ago, it was burned down.$b$bWhy do I care? I don\'t-not about the humans anyway-but I had a spy placed in that inn and I will not let his death go unanswered. I need to know who did this.$B$BIf you wish to provide assistance, go to the remains of the Shady Rest Inn and return any clues you find to me.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4261,'Finding Reethe.','Finding Reethe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4262,'If Reethe is somehow involved with the burning of the Shady Rest Inn, you\'ll have to find him and get some answers out of him.$b$bI sent Ogron to track him down. He was headed off to the southeast, toward the main road through the marsh. Meet up with Ogron and then go find Reethe.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4265,'','I don\'t care to hear it, $n. Nope, no way are you going to be let into the Searing Gorge. Impossible. Not going to happen. How many times do I have to tell you - I can\'t let you in! Do you not speak common? Are you an orc in disguise? N-O. NO!$B$BIf I let you in, then I have to let everybody in. Pretty soon your close friends will want in, then their distant relatives, then their friends, and so on and so forth. The last time that happened... well, we won\'t talk about the last time it happened. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4266,'What\'s the worst that could happen?','What\'s the worst that could happen?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4267,'','Are you mad? Do you know what manner of beast inhabit that place? The worst that can happen is that we\'ll have to scoop up your remains with a shovel. We\'ve lost some good dwarves to those awful monsters.$B$BSo the answer is no. If you\'re bent on getting to the Searing Gorge, you\'ll have to find another way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4268,'Another way? Do tell...','Another way? Do tell...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4269,'','I shouldn\'t even be telling you this but if you can make it past all the critters and beasties in Badlands, you might be able to make it to Searing Gorge.$B$BYes, the Badlands. There\'s some type of back road the orcs paved near Kargath. Just goes to show you what kind of fools we\'re dealing with here! A backdoor to hell? What were they thinking?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4270,'Orcs? Badlands? I\'m invulnerable!','Orcs? Badlands? I\'m invulnerable!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4271,'','Invulnerable?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4272,'Absolutely!','Absolutely!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4273,'','You\'re a fool that should heed my warnings. No one is invulnerable. You would be wise to remember that bit of advice.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4274,'My apologies, Pebblebitty.','My apologies, Pebblebitty.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4275,'','I\'ll tell you what. Since you fancy yourself the hero type, if you can make your way through the Badlands to the Searing Gorge and bring me back something to prove your heroics, I\'ll see what I can do about getting you a key.$B$BIn the southeasternmost corner of Searing Gorge is a lady almost as tough as me, Margol the Rager. Maybe you should investigate.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4276,'Done, done, and done.','Done, done, and done.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4285,'%s dusts the base of the artifact.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4286,'%s meticulously examines the large vase.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4287,'Poor Dorius. If I ever get my hands on those Dark Irons, so help me...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4305,'I have just the spot for this horn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4306,'I\'ve been saving this spot for something special. I don\'t think it gets any more special than this, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4307,'There we go. All done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4308,'What can I do at an inn?','What can I do at an inn?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4309,'When you stay at an inn, you rest very comfortably.  Because of this, you will become \"well rested\" much more quickly than you would in the wilderness.  When you are well rested, you learn more from experience.$B$BYou may also speak with any innkeeper to get a hearthstone, and can later use the hearthstone in order to quickly return to that inn.','When you stay at an inn, you rest very comfortably.  Because of this, you will become \"well rested\" much more quickly than you would in the wilderness.  When you are well rested, you learn more from experience.$B$BYou may also speak with any innkeeper to get a hearthstone, and can later use the hearthstone in order to quickly return to that inn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4325,'','The final charge is set. Stand back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4326,'','10 seconds to blast! Stand back!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4327,'','5 seconds until detonation!!!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4328,'We come from below! You can never stop us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4329,'','Nice work! I\'ll set off the charges to prevent any more troggs from making it to the surface.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4345,'Stop... need to catch.... my breath.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4346,'The secrets of Suntara will not leave these lands.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4347,'Ragnaros sees all, mortal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4348,'Where does my path now lead, Jorn?','Where does my path now lead, Jorn?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4349,'You are well on your way, $n.  But you still have much to learn.  The southern Barrens may be where your next lesson is found.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4350,'Although we call this land the Barrens, to one who knows where to look this place teems with life.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4351,'I\'m about to open a can on this $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4352,'Are you going to let an injured dwarf do all the work for you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4353,'It\'s on! $n, meet my fists. Fists, say hello to $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4354,'This is the place, $r: The Cauldron! Mark it on a map or do something so that you don\'t forget. If anything ever happened to me, my team would be stuck in that mine forever.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4355,'Onward! And be on guard this time! I\'m not going to carry anymore fights.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4356,'I\'ve got to quit smoking! Give me a minute to catch my breath.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4357,'We\'re almost to safety. From here, we run. Try not to get too far behind! GO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4358,'He\'s mine...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4359,'ARRRRRGH! He got me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4360,'%s sniffs the air...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4361,'%s feasts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4362,'%s disappears in a cloud of dust.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4363,'The gate is in sight! We\'re going to make it! But first, I need to take a breather.','',5,0,0,1,0,0,0,0,1,0,0,0,26124),
(4364,'You know not what you do!  We must destroy you for your own good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4365,'Hear ye, denizens of Tanaris! Let it be known that $n is an exalted member of the Mithril Order. A blacksmith of honor, dedication, and infinite patience. Three cheers for $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4366,'It\'s in the hole!  It\'s in the hole!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4367,'He shoots, he scores!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4368,'From way downtown!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4370,'It\'s up and....it\'s good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4371,'He puts the rock into the hole!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4372,'Swish!  We are on fire today boys.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4373,'GOOOOOOOAAAAAAAALLLLLLLLLLL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4374,'In the pipe, 5 by 5!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4375,'Aye, it\'s a cold one today, but ne\'er too cold to offer you my fine wares!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4376,'I sell the finest cloth and leather garb this side of the valley!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4377,'There\'s nothing like some scalding mornbrew on a chilly Dun Morogh day to get things started right!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4378,'Oooooo hot hot hot!  If that won\'t put spring in your step, I don\'t know what will!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4379,'I\'ve been here long enough, $n. I\'m sure we\'ll meet again. Good luck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4380,'','Infidels!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4381,'','You dare interrupt our prayer? Execute them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4382,'','You will make a fitting sacrifice to Ragnaros.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4383,'','Excellent, fresh blood has arrived.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4384,'Tell me about the Glowing Shard.','Tell me about the Glowing Shard.',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(4385,'','You\'ve come further than many, $n. Respect the elements around you and you shall fare far greater than most.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4390,'You have returned to finish the job? <Lathoric laughs.> Obsidion rise and annihilate them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4391,'Your task is complete. Prepare to meet your doom.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4392,'Obsidion rise and serve your master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4393,'Bravo! Bravo! Good show. What? You thought I was dead?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4394,'Fools, I knew that if I played upon my brother\'s feeble emotions, he would send \'rescuers.\'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4395,'How easy it was to manipulate you into recovering the last Suntara stone from those imbeciles of the Twilight\'s Hammer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4396,'When I stumbled upon the Suntara stones at the Grimesilt Digsite, the power of Ragnaros surged through my being. It was Ragnaros that gave me a purpose.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4397,'It was the will of Ragnaros that Obsidion be built. Obsidion will destroy the Blackrock orcs of Blackrock Spire, uniting us with our brethren in the fiery depths.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4398,'And ultimately, it was Ragnaros that named me when I was reborn as an acolyte of fire: Lathoric... Lathoric the Black.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4399,'%s\'s laughter trails off...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4400,'The altar seems to beckon to you as if it were alive.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4401,'Touch the Suntara stone and call forth Lathoric the Black and his guardian, Obsidion.','Touch the Suntara stone and call forth Lathoric the Black and his guardian, Obsidion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4402,'','I know of a druid that lives atop the hill above the Wailing Caverns,$n. She might be able to tell you more about this shard you have found.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4403,'Guards! Help me!','Guards! Help me!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(4404,'','Greetings, $n. May Elune\'s wisdom guide your hand and heart. How may I help you today?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4405,'Salutations, Astarii. I require training.','Salutations, Astarii. I require training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4406,'Been waitin\' for ya, $n. Glad to see you\'ve come through. Do you have the shipment?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4407,'Praise Elune! It has been many years since I have had visitors.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4408,'I wish to hear your tale.','I wish to hear your tale.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4409,'As a young night elf in Darkshore, I crossed paths with a group of unsavory individuals known as the Twilight\'s Hammer. A group of them befriended me and shamefully, I ended up eschewing my faith in Elune and embracing the vitriol of the Twilight\'s Hammer.$B$BIt was not until a vision came to me from Elune, that I woke up from the malaise that I had fallen into as a follower of the old gods.$B$BIn repentance, I began work on my prayer to Elune. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4410,'Please continue, Zamael.','Please continue, Zamael.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4411,'Etched into a tablet of pure gold was the embodiment of my remorse, shame, regret, and sorrow. Unfortunately, the Twilight\'s Hammer found the tablet and branded me a blasphemer. I was summarily executed, my prayer to Elune incomplete. I am now bound to this world as a spirit, unable to transcend to the Nether; held in this cage as a warning to all that would betray the faith of the Twilight\'s Hammer.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4412,'Let me think about it, Zamael.','Let me think about it, Zamael.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4413,'Raze need go home now. Bye, bye, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4414,'','Use this Staff of Command on Raze when you are near Shadowsilk Poachers and he will make them rue the day they decided to poach in these lands.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4415,'Bye, bye, tiny little $r. Raze go now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4416,'The ancient Altar of Hakkar stands silently near the entrance to the room.$B$BLooking to the balconies above it, you notice a large serpent-like statue rests on each. The statues look very much like the ones on the altar before you. They must be related in some way...','The ancient Altar of Hakkar stands silently near the entrance to the room.$B$BLooking to the balconies above it, you notice a large serpent-like statue rests on each. The statues look very much like the ones on the altar before you. They must be related in some way...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4417,'How could the altar and the statues be related?','How could the altar and the statues be related?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4418,'I want to begin the statue puzzle.','I want to begin the statue puzzle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4419,'Tell me more about muisek.','Tell me more about muisek.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4420,'Existing in this area are many creatures considered allies of the night elves. The elves have had access to the power within each of these creatures; it is time that the horde be allowed this same satisfaction. I have devised a way that this power can be captured and used for our benefit.$B$BDo not doubt what I tell you, $n. Help me, and you shall see that I speak truth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4421,'There\'ll be a new trade risin\' up round your carcass, $n. We\'ll call it \'flesh-craftin.\'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4422,'All they be doin\' is a little huntin\' and gatherin\'. Where\'s the harm in that??','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4423,'If tailoring is your thing, Vizzklick will most definitely have your supplies. Take a look around, $n, and let me know if you wish to purchase something!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4424,'I wish to browse your wares.','I wish to browse your wares.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4425,'Grab your things, $n! I\'ve just gotten word from Nilith Lokrav in the Searing Gorge that the Undermarket has set up operations in the heart of the Cauldron. Find Nilith Lokrav in the Searing Gorge and get the low down!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(4426,'One bright light appears accross the room, then disppears. Then you notice another beam... and then another.$B$BThey seem to be showing you a pattern.','One bright light appears accross the room, then disppears. Then you notice another beam... and then another.$B$BThey seem to be showing you a pattern.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4427,'The statues are all in place, and you may begin the puzzle.','The statues are all in place, and you may begin the puzzle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4428,'%s goes into a berserker rage!','%s goes into a berserker rage!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4429,'Vengeance shall be mine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4430,'Tell me what drives this vengeance?','Tell me what drives this vengeance?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4431,'My father was slain by the filth that inhabits the cauldron. My pleas for assistance to the Stormwind magistrate fell on deaf ears. Nay, they want not to admit that this part of the world even exists, let alone send their precious military in to administer justice.$B$BI seek vengeance, $r, plain and simple. Is there a more passionate cause in this world?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4432,'Continue please.','Continue please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4433,'As you can see, I am but one man with a lumbering oaf of a squire. The might of the Dark Iron dwarves and the beasts held in the grip of Ragnaros would surely overwhelm me alone, but I have the utmost confidence that such a brave and ambitious adventurer such as you would have no problem handling the denizens of the cauldron. Should you choose to assist me, I shall reward you with riches and wealth beyond your wildest dreams.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(4434,'Let me confer with my colleagues.','Let me confer with my colleagues.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4435,'We will enslave the quilboar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4436,'We will spread across this barren land!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4437,'Soon, the Scourge will rule the world!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4438,'My eyes!  It burns... it burns...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4439,'Torture me no more!  Release me, mortal!  The Swamp of Sorrows... mortal... please...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4440,'Foolish mortal, I will rend your soul in two once I am released!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4441,'You are an agent of their wicked god, fool.  I will see you destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4442,'My soul is not a trinket!  Mortal, you must release me from these chains!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4443,'It hurts so much... Itharius, my old friend... please help me...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4444,'Will the nightmare ever end?!  I cannot force myself awake!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4445,'My charge to watch the temple has failed... my corrupted soul knows no peace...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4446,'','Superb! Because of your help, my people stand a chance of re-taking our beloved city. Three cheers to you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4447,'%s chants in an unknown tongue.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4448,'Be patient, $n. The torch is almost complete.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4449,'%s falls to one knee. He looks exhausted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4450,'It is done...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4451,'Oh, $n, wait a minute! There\'s one more thing! Come back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4452,'Conjure the Torch of Retribution, Kalaran.','Conjure the Torch of Retribution, Kalaran.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4453,'%s is released and now bound to you, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4454,'%s engulfs the sentry tower. The tower is ablaze!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4455,'I give unto you cordial salutations, $r.  You\'ve come far off the beaten path merely to speak to someone dwelling inside a cave.  I trust there is a reason for your strange, yet not unforeseen visit here.  Yes?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4456,'Glorious, indeed, Maltrake. It looks as if my plan worked perfectly. Wouldn\'t you say so, mortal?','',1,0,0,300,0,0,0,0,1,0,0,0,26124),
(4457,'You would not have helped the legion of Blackrock had we just asked for your assistance, now would you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4458,'%s lets loose a reptilian laugh... at least you think it\'s a laugh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4459,'What will we do with them, master? They are of no use to us anymore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4460,'SILENCE FOOL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4461,'They will live, if only to see the fruits of their labor: the destruction and chaos that will surely ensue as the legion of Blackrock invade the gorge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4462,'I leave you now, mortals. Alive and with these trinkets. Maltrake! Present them with the trinkets!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4463,'Oh yes, the molt - do not lose it. There are those of my kin in the Burning Steppes that would craft items that only the molt of the black Dragonflight could fortify.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4464,'%s begins to flap his massive wings faster. He is preparing for flight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4465,'The legion of Blackrock comes, dwarflings! We shall scorch the earth and set fire to the heavens. None shall survive...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4466,'Reset all of the statues in this room.','Reset all of the statues in this room.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4467,'The statues all move back into their original positions.$B$BThe sequence must be started again now, from the beginning.\n','The statues all move back into their original positions.$B$BThe sequence must be started again now, from the beginning.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4468,'Right away, master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4469,'Greetings, $Gsir:miss;. I am Master Xylem\'s apprentice Nyrill. If you have any concerns, please feel free to bring them up with the master.$B$BI will be here to serve you when you\'re ready to return down to the base of the mountain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4470,'I know who you are, $n.  Fate and forces beyond that have brought you to me for a reason, and it is one I take no pleasure in being a part of.  There are many decisions you will make in the coming times, and I hope you are wise enough to make the correct ones.$B$BBelieve me, $r, when I tell you this - there are correct choices.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4471,'What\'s an elf like you doing inside a cave like this?','What\'s an elf like you doing inside a cave like this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4472,'You are quite inquisitive, though such inquisitiveness belies a general lack of understanding.  I say this because were you to have a definite purpose in being here, the question you ask would seem pointless. $B$BWith that, I bid you good day.','',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(4473,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4474,'Do you know someone... or something, rather, by the name of Eranikus?','Do you know someone... or something, rather, by the name of Eranikus?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4475,'You know I do, mortal; I am abandoning a fair number of pretenses here, and I recommend you do the same.$B$BYou have come here clearly because you know that what you possess, garnered from your actions within the Sunken Temple of the Atal\'al, has brought you to me for a purpose.  This purpose is to put my associate... my brother, to rest.  He is trapped within a nightmare within the Dream itself.  He cannot break free alone.','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(4476,'What happened to him in the first place?  When I... encountered him, he was rather malicious.','What happened to him in the first place?  When I... encountered him, he was rather malicious.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4477,'The god that the Atal\'ai trolls had brought forth is to blame for this.  We destroyed the god\'s physical manifestation and sunk the temple, but the god was much stronger than even we had anticipated.  Its seed of corruption ran deep, twisting everything in its path.$B$BEranikus was charged to watch over the sunken temple to ensure that neither the simple Atal\'ai nor their god would rise again.  He was an unwitting victim of this corruption, and we in underestimating its potency.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4478,'I possess part of Eranikus\' essence.  What do you want with it... or with me?','I possess part of Eranikus\' essence.  What do you want with it... or with me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4479,'The fact that you are here is a first step... a correct choice if you will, in aiding Ysera\'s Dragonflight.$B$BYou may be here for purely the lure of personal gain, or you may be here because you are morally compelled.  Neither reason is important on its own, but both are in fact critical to this end: The agony that Eranikus endures is what rousted me from my Dream, and it is now my charge to see his torment ended.  I now ask you to aid me in this quest.\n','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(4480,'I will consider what you have told me.','I will consider what you have told me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4481,'I have given you an oathstone of Ysera\'s Dragonflight, $n.  When you are ready and able to aid us, use it, and then we may begin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4482,'Good luck. Sorry I can\'t take you with me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4483,'%s begins to summon wraiths out of the freezing cold air!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4484,'Intruders! Attack the intruders!','Intruders! Attack the intruders!',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(4485,'My banishment is ended! Let the blood flow!','',0,0,0,0,0,0,0,14,1,0,0,0,26124),
(4486,'Interesting, interesting... I know of a druid that lives atop the hill above the Wailing Caverns, $n. She might be able to tell you more about this shard you have found.$B$BNow, I must get back to work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4489,'%s staggers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4490,'The shield be down! Rise up Atal\'ai! Rise up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4491,'Mistress!! They seek to destroy your work!!','Mistress!! They seek to destroy your work!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4492,'Ha! Now your death is ensured!','Ha! Now your death is ensured!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4493,'All right, stay close.  These fiends will jump right out of the shadows at you if you let your guard down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4495,'','You dare! Now feel my wrath!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4496,'The days we\'ve spent here in Azshara are not among our best and most glorious, but we are still young and blood still courses through our veins--we shall find victory here. It is only a matter of time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4497,'Belgrom sent us here from Orgrimmar to aid him in an unwise Alliance, but if his gamble pays off, then it will be to the great benefit of all the Horde.$B$BToo many orcs have already perished because of his desire to please women, but he still commands us, and our honor dictates we make the best of this situation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4498,'','I am not here because of honor, $n. I am here because of one orc\'s pride.$B$BIf I had not rejected Belgrom\'s offers, then I\'m sure I\'d still be in Orgrimmar taking care of real business.$B$BHis desire for women is not unknown to many of the female warriors in Durotar, but that doesn\'t stop him from being his charming self.$B$BHe\'s lucky he didn\'t pursue his desire for me much longer though--he\'d be short more than just the digits on his hands.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4499,'','Greetings, $n. I see you\'ve come from Orgrimmar to aid us. I\'m glad. I want to be out of this forsaken forest as quickly as possible. I\'d much rather be spending my time in Orgrimmar with a good ale.$B$BAlthough I cannot wait to hear how Belgrom talked you into coming out here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4500,'You\'ve done it, $n! <The strangely familiar voice seems to be coming from the phial!> Hurry back! The fallout will only remain stable for thirty minutes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4501,'Okay, here we go.  It\'s going to take about five minutes to shut this thing down through the ritual.  Once I start, keep the vermin off of me or it will be the end of us all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4502,'Who dares?! I will destroy you!','Who dares?! I will destroy you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4503,'DUMMY SPELL TEST MESSAGE','DUMMY SPELL TEST MESSAGE',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4504,'Three minutes left -- I can feel the energy starting to build!  Keep up the solid defense!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4505,'Just two minutes to go!  We\'re half way there, but don\'t let your guard down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4506,'One more minute!  Hold on now, the ritual is about to take hold!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4507,'That\'s it -- we made it!  The ritual is set in motion, and idol fires are about to go out for good!  You truly are the heroes I thought you would be!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4508,'%s lashes at your collection phial. The green glow encases you. You don\'t look so hot, pal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4509,'What brings you to the Cenarion Circle, $n?','What brings you to the Cenarion Circle, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4510,'I am here for training.','I am here for training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4511,'I know, I know, I\'m out here in the middle of nowhere!$B$BMy home is actually in Ratchet, but after crashing my zeppelin here, I thought I might as well start the research I came here to do!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4512,'This spirit hovers over its fallen body.  Its ghostly eyes pierce through you as it gazes beyond...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4514,'Feralas - Screecher Spirit - On Quest Default Greeting','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4515,'%s is getting really hungry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4516,'%s is VERY HUNGRY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4517,'','The land of Feralas has been through much, $r. The earth, the trees, the creatures; they are all changing what Feralas is and will be.$B$BThe Twin Colossals above us remain as a constant, though, throughout all that has happened here...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4518,'To get down safely, I provide wings to those in need. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4519,'Can you help me get down?','Can you help me get down?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4520,'Well, now that you mention it, yeah, I did see something I thought was a little strange yesterday afternoon!$B$BI was running past some old troll ruins southeast of here; well, I wasn\'t really running, more like hopping... The sand\'s so hot!$B$BAnyway, so I was hopping past the ruins, when I noticed a camp set up there. Seems like a funny place to set up camp, if you ask me... I would have poked around a little more but one of those crazy big vultures chased me off.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4521,'Raze follow $n! Raze SMASH poachers! SMASH SMASH SMASH! Tell Raze to SMASH by playing with stick! SMASH! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4522,'There! Job\'s done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4523,'Don\'t worry, I\'ll find a good home for ya.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(4524,'Can anyone give my adorable, extra little kitty a home?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(4525,'I can\'t believe dad won\'t let me keep your sister.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(4526,'Kitten for sale, looking for a good home.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(4527,'What does allergic mean anyway? And what does it have to do with either of my kitties?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(4528,'Will someone please give my little kitten a good home?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(4529,'','No!  We cannot allow you to summon Hakkar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4530,'','You must not summon our god!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4531,'','No!  You must not do this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4532,'','Stop!  Infidels!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4533,'','Wha... what\'s happening?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4534,'Thank you for saving me!$B$BI\'m a cook and an alchemist from Stormwind.  I was here looking for local herbs and recipes for my uncle Angus when these quilboar captured me.  If you hadn\'t come around, I\'m sure I\'d have ended up in their stew pot!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(4535,'You can cook?  So can I!  Is there a recipe you can teach me?','You can cook?  So can I!  Is there a recipe you can teach me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4536,'Hm... yes, I do have a recipe you might find useful.  Let me teach you!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(4537,'You\'re an alchemist?  So am I.  Perhaps you can teach me what you know...','You\'re an alchemist?  So am I.  Perhaps you can teach me what you know...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4538,'Well yes, I do know a rare alchemical recipe.  Let me teach you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4539,'%s is noticeably weakened. The Felcurse is working!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4540,'','%s is substantially more susceptible to your attacks. The Felcurse is working!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4541,'%s seems to no longer be able to cast spells. The Felcurse is working!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4542,'Your fel weapon is ready, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4543,'I DRAW CLOSER TO THIS WORLD!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4544,'NOOOO!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4545,'I AM HERE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4546,'DIE, MORTALS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4547,'','%s begins casting a counterspell...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4548,'I\'m going to carefully mix this - oops! ...Well, I spilled a little, but it\'s ready!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4549,'Who dares summon me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4550,'Greetings!  If you are here to access goblin engineering schemata, please know we only interface with certified goblin engineers.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(4551,'Access secret goblin engineering schemata!','Access secret goblin engineering schemata!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(4552,'Greetings!  If you are here to access gnome engineering schemata, then you are welcome to do so.  Our scanners report you are a certified gnomish engineer!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(4553,'Access secret gnome engineering schemata!','Access secret gnome engineering schemata!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(4554,'Hello there $glad:lass;... the name\'s Oglethorpe and I may be responsible for one of the amazing gnomish devices you might possess!  If it blew up, then it wasn\'t me; if it made you rich though, we can discuss royalties!$B$BOh, and if you\'re from Gnomeregan, you can just take two ninety degree angles, smash them together, and start marching.  I have nothing to say to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4555,'Well, if it isn\'t $n!  It\'s good to see you again; I cannot express my gratitude enough at the help that you\'ve given me and my invention work to date.$B$BWhat can I do for you today?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4556,'I am Tinkmaster Overspark, and I am the chief architect for modern gnomish engineering principles in the world today.  It is my job to ensure that the power of invention continues to shine brightest from our arclight spanners than anywhere else!$B$BAlso, if you happen to know a good schematic for radiation elimination, we just so happen to be in the market for one right about now...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4557,'Let me break down a little math for you: \"goblin\" plus \"engineering\" equals KNOW HOW, baby.  Anyone who tells you otherwise simply doesn\'t know how to add.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4558,'Grunts! Attack!','Grunts! Attack!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4559,'Guardians! Defend Sen\'jin!','Guardians! Defend Sen\'jin!',0,0,0,0,0,0,0,14,1,0,0,0,26124),
(4560,'You will not defile our sacred land!','You will not defile our sacred land!',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(4561,'Guards!','Guards!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4562,'Sentinels, come to my defense!','Sentinels, come to my defense!',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(4563,'Through my studies, I see that defeating the god Hakkar\'s avatar has weakened him.  But the bulk of his strength remains, lurking at the far end of the Nether.$B$BYou have defeated his avatar once, $n.  Perhaps if you defeat it again you can further weaken the god so that, one day, we might face his true self.$B$BI have prepared a spell that you may use to again summon an avatar of Hakkar within the Sanctum of the Fallen God.  Do you want to confront it once again?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4564,'Sentinels, come to my defense!','Sentinels, come to my defense!',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(4565,'Greetings, $c.  Though time and drink have dulled my outer senses, my inner eyes remain strong.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4566,'Guards! Help me!','Guards! Help me!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(4567,'Yes.  Give me the spell to summon the avatar.','Yes.  Give me the spell to summon the avatar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4568,'Guards!','Guards!',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(4569,'Intruders! Attack the intruders!','Intruders! Attack the intruders!',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(4570,'%s searches for a source of arcane energy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4571,'%s growls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4572,'Hello, $n. I train and care for young hippogryphs here; feel free to have a look around.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4573,'Tell me more about these hippogryphs.','Tell me more about these hippogryphs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4574,'Druids are very sensitive to the plight of all creatures of the world. When it was found that these birds were in danger, we set up a system of rescuing them from the corruption of Feralas.$B$BA gnome named Curgle Cranklehop leads the affair; she collects the eggs and has them sent here, where I care for them.$B$BWe could always use more help for our cause, $n. Maybe you should head over to Gadgetzan and look for Curgle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4575,'Thank again, $n.  Now I\'ll just wait here until it\'s safe to leave.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4576,'You will need to open the Felhound Tracker Kit and read the instruction manual. Summon the beast when you are near the peninsula of cliff giants, south of here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4577,'Thank you, little $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4578,'Your talents in cooking are a little too low.  Maybe with some practice I can teach you what I know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4579,'Your skills in alchemy aren\'t yet high enough to benefit from my teachings.  Perhaps if you speak with me later...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4580,'Captain, here they come! The naga are coming!','Captain, here they come! The naga are coming!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4581,'The arcane only corrupts those who are weak. Even if you do not follow the path of the warlock, you would do well to remember that.','The arcane only corrupts those who are weak. Even if you do not follow the path of the warlock, you would do well to remember that.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4582,'A pleasure, $n. What can I do for you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4583,'Guards!','Guards!',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(4584,'The arcane only corrupts those who are weak. Keep up on your training, or you may find a similar fate.','The arcane only corrupts those who are weak. Keep up on your training, or you may find a similar fate.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4590,'Thank you.','Thank you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4591,'I am bound eternally to this cursed world. What is it you desire, mortal?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4592,'I wish to face the Defiler.','I wish to face the Defiler.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4593,'By your command!','By your command!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4594,'Leave this place. <The relic emits a white hot arc of flame. A memory has been gained: A lone Dark Iron dwarf is surrounded by seven corpses, kneeling before a monolith of flame.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4595,'You will perish here. <Your mind fills with visions of chaos and destruction.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4596,'Do not taint these ruins, mortal. <You are engulfed in a blinding flash of light. A creature composed entirely of flame is the only thing you can remember seeing.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4597,'Help us, outsider. <The relic crumbles to dust. A vision of eight Dark Iron dwarves performing some sort of ritual fills your head.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4598,'He cannot be defeated. <The relic burns to nothing. The memories it held are now your own. This city was destroyed by a being not of this world.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4599,'Your existence is acknowledged. <The relic turns to dust. Your head throbs with newfound wisdom. Something evil lurks in the heart of the mountain.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4600,'Defiler... you will be punished for this incursion. <A symbol of flame radiates from the relic before it crumbles to the earth.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4601,'','Greetings, $n. Have you come to learn of the history of Ironforge?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4602,'','Notify me when you are ready to listen to the story.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4603,'I am ready, Historian Archesonus.','I am ready, Historian Archesonus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4604,'','Hundreds of years ago, the great city of Thaurissan stood proudly in a lush expanse of land that is now the dilapidated Burning Steppes.$B$BThaurissan was home to the nation of Dark Iron dwarves and at the time, in the midst of a civil war among the dwarven nation at large.$B$BYou see, that area of the world was at one point in time part of the Redridge Mountains - until the day that Thaurissan was consumed by a gigantic explosion. The city lay in ruin, the surrounding areas reduced to an ashy wasteland.\n',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(4605,'That is tragic. How did this happen?','That is tragic. How did this happen?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4606,'','We do not know.$B$BThe Dark Irons that did survive made their way into the mountain and began rebuilding their city.$B$BFrom the ashes of Thaurissan then rose Blackrock Spire and the new Dark Iron nation. Additional fortifications were made within the Searing Gorge, in the area known as the Cauldron.$B$BStories of an ancient evil that controlled the kingdom of Dark Irons began to circulate. ',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(4607,'Interesting, continue please.','Interesting, continue please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4608,'','Recently, the Dark Irons have been seen on the surface world with greater regularity. Fortresses have been built in the Badlands. Massive exploratory forces have been sent into the depths of Uldaman in search of ancient lore. They have even invaded our own homeland, striking at our dam near the loch.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(4609,'Unbelievable! How dare they??','Unbelievable! How dare they??',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4610,'','We need adventurers to assist us, $n. Will you help?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(4611,'Of course I will help!','Of course I will help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4612,'You did a great job, Spybot! Glad to have you back here with me!','You did a great job, Spybot! Glad to have you back here with me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4613,'That\'s it! That\'s what you were waiting for! KILL THEM!','That\'s it! That\'s what you were waiting for! KILL THEM!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4614,'Um, hello!  If you are here about fee collection and/or a summons, then you must have me mistaken for someone else.  Terribly sorry!','',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(4615,'','I think my necklace fell in the lake.  My daddy got it for me, and he\'s gonna be mad now.',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(4616,'','Thank you $g mister : miss; for finding my necklace!  You\'re the best!',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(4617,'Besides the Grunts outside, my brothers and I fought at the battle of Hyjal. Any who seek to steal from the bank must face us first.','Besides the Grunts outside, my brothers and I fought at the battle of Hyjal. Any who seek to steal from the bank must face us first.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4618,'Hello there $g mister : ma\'am;... do you have a little time that you could help us out?  Please?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4619,'I guarantee this bank\'s security with my own blood, is that good enough for you?','I guarantee this bank\'s security with my own blood, is that good enough for you?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4620,'Thank you again for helping Nida, $g mister : miss;!  When I grow up, I wanna be a hero just like you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4621,'Would you rather trust your goods with a goblin?','Would you rather trust your goods with a goblin?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4622,'So many years of battle and slavery, it feels good to have a home again. ','So many years of battle and slavery, it feels good to have a home again. ',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4623,'Tell me what you want, and make it quick.','Tell me what you want, and make it quick.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4624,'I live only to serve the master.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4625,'Present the trinkets, Maltrake.','Present the trinkets, Maltrake.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4626,'Tell me what you want, and make it quick.','Tell me what you want, and make it quick.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4627,'Meow!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4628,'','I know how to speak kitty, and Effsee said thank you.',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(4629,'Even in peace there is still war, and many clans still fight beneath the banner of the Warchief. Are you here to add your clan to those that fight for Orgrimmar?','Even in peace there is still war, and many clans still fight beneath the banner of the Warchief. Are you here to add your clan to those that fight for Orgrimmar?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4630,'Even in peace there is still war, and many clans still fight beneath the banner of the Warchief. Are you here to add your clan to those that fight for Orgrimmar?','Even in peace there is still war, and many clans still fight beneath the banner of the Warchief. Are you here to add your clan to those that fight for Orgrimmar?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4631,'Yes, I offer training. But it\'s not cheap.','Yes, I offer training. But it\'s not cheap.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4632,'Hello, $n! I am master engineer, Scooty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4633,'Of course I offer lessons to other Enchanters, provided you are ready.','Of course I offer lessons to other Enchanters, provided you are ready.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4634,'I lost my transponder and need another one, Scooty.','I lost my transponder and need another one, Scooty.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4635,'The earth keeps many secrets, $c; it is our duty to ensure that those that must remain a secret for the good of all stays as such.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4636,'If you are here to waste my time, then you are wasting the time of the Cenarion Circle as a whole.  For your sake, let us hope that you are not foolish enough to be doing just that.','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(4637,'I can\'t believe the officials in Stormwind, sending the bulk of our army abroad... when our home front is under so much pressure!$B$BWith thieves coming from Westfall and gnolls encroaching from the east and west, it\'s a wonder Stormwind itself isn\'t besieged.','',5,0,0,0,0,0,0,7,1,0,0,0,26124),
(4638,'Hello, $c.  I hope you\'ve come to bolster our ranks.  Beasts and thieves are spilling into our beloved Elwynn, and we barely have enough men to keep the roads safe!$B$BAnd if you haven\'t done so, read that notice about Hogger.  He\'s a beast in yonder woods that must be dealt with.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(4639,'Hello, $n.  Welcome to Thelsamar, and while you\'re here don\'t forget to visit our local brewery!','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(4640,'Welcome to Thelsamar, your home away from home in Loch Modan!$B$BThelsamar is a nice place, but it\'s not all beer and salted meat for those who answer the call to duty!  If you\'re willing to face danger in the name of the Alliance, then read the poster outside the Thelsamar branch of the Explorers\' League.','',5,0,0,0,0,0,0,7,1,0,0,0,26124),
(4641,'','Ahoy, $n! Not a pretty picture, is it?$B$BThe Horizon Scout at the bottom of the sea, my crew in shambles, and our cargo and passengers strewn about like so much debris that you\'d think this was one of Stormwind\'s canals after a festival.$B$BAnd that\'s not where the trouble ends...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4642,'%s bellows a challenging roar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4643,'Conspiracies abound, I say.  There are those who lack vision in understanding what I do, and would seek to keep me shackled to obscurity!$B$BDon\'t step in the dirt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4644,'What are you doing out here?','What are you doing out here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4645,'What am I doing?  Do you lack vision?  I am a dreamer, good $g sir : lady;, and I dream of a better future for us all.  Clearly, I am a visionary.$B$BThere are those, however, who seek to keep us mired in banality.  I told him that I was a dreamer, and Archdruid Staghelm replied, \"Well, the world needs ditch diggers too.\"$B$BUntil such time as the shackles of banality are ripped from us, I will help the Cenarion Circle by shuffling these piles of dirt around.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4646,'Greetings, $r. I am Franclorn Forgewright. Are you here to learn of the Spire and of Dark Iron?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4647,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4648,'Amazing! I\'ve never spoken to a ghost. I wish to learn!','Amazing! I\'ve never spoken to a ghost. I wish to learn!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4649,'I had no choice, or so I thought. I would endure the destruction of Thaurissan and stand by the side of my king and his people.$B$BUnder the control of Ragnaros, King Dagran Thaurissan tore out the heart of this mountain and erected Blackrock Spire. We worked tirelessly to build a dwarven city mightier than any city or fortress that came before... or would come after.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4650,'Continue please.','Continue please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4651,'I stood by and watched the corruption of Ragnaros seep through the hearts and minds of the Dark Iron nation. This once honorable race, driven to madness... to evil.$B$BWhen the construction of the Spire was complete, my will to live amongst my people gave way. I passed as a hero of the new nation of Dark Iron. This tomb was placed here - at the entrance to the city I planned and built - in honor of my efforts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4652,'Fascinating. Please, tell me more.','Fascinating. Please, tell me more.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4653,'My great hammer, Ironfel, was handed down to the new chief architect, Fineous Darkvire: A man of despicable motive and little talent.$B$BThis is where you come in, $n. I want him stopped. He is too inept to harness the true power of Ironfel, but should one come after him with the aptitude to use Ironfel to its full potential, the destruction they could cause with their creations would be disastrous to this world.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4654,'Just show me the way, Franclorn.','Just show me the way, Franclorn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4655,'You will find Fineous Darkvire beyond the Ring of Law, in the Hall of Crafting. Kill the miserable cur and recover Ironfel.$B$BTake Ironfel to the Shrine of Thaurissan and place the hammer in its rightful place: In the hands of the statue erected in my honor.$B$BWhen this is done, the compartment in which I stored the master key will open. More importantly, Ironfel will remain forever in my grasp. Should they make an attempt to remove the hammer; both the statue and hammer will shatter, lost forever.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4656,'Yes, but you\'ll find it more rewarding if you have skill in herbalism!  You will be required to nurture and cultivate special seeds -- not to swing an axe blindly or gesticulate wildly at passing shadows.  While the Evergreen Pouch you\'ll receive allows even the simplest brute to grow something, those who show some aptitude will have more bountiful results.','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(4657,'I\'m not a journeyman herbalist -- am I able to still assist you in your work?','I\'m not a journeyman herbalist -- am I able to still assist you in your work?',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(4658,'','Stand prepared! The naga won\'t wait long to press their advantage once they know we\'re alive.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4659,'Be advised, $g Jackson : Princess;, I am in no mood for any comment that you think is cute or funny. I am here to make sure that the Archdruid\'s research proceeds as planned, and my orders are to weed out all non-hackers who do not pack the gear to serve in my beloved Cenarion Circle.','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(4660,'','Greetings, noble $c.  This humble servant of the Cenarion Circle wishes blessings and bounties be given unto you and yours.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(4661,'Amakkar, where do you think Warlord Goretooth is going to send us? I don\'t think I can handle another tour in the Steppes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4662,'Hrmmm...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4663,'Quit being such a baby, Razal\'blade. It\'s time to start acting like you\'re part of one of the Warchief\'s elite forces. You don\'t want to end up like Gargal, do you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4664,'%s seems oblivious to the nearby commentary.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4665,'Proudtusk!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4666,'No, Gargal. Just no.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4667,'But...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4668,'NO! Shhhh! Just shut up. Goretooth is coming!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4669,'%s laughs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4670,'Watch where you\'re stepping, $c, because I have a polymorph spell with your name on it...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4672,'All present and accounted for, SIR!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4673,'FALL IN, MAGGOTS!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4674,'I love pie.','I love pie.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(4675,'Nana always said there was no greater thing in the whole world than a warm, toasty slice of fresh, homemeade cherry pie.','Nana always said there was no greater thing in the whole world than a warm, toasty slice of fresh, homemeade cherry pie.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4676,'','So what\'s this new plague all about?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4677,'This pie is so good, would you like some?','This pie is so good, would you like some?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(4678,'Having a bad day? Try some cherry pie.','Having a bad day? Try some cherry pie.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(4679,'','Oh, it\'s just terribly, terribly, awful! You will just DIE when you see it, Vivian.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4680,'This cherry pie tastes so good, it could make a grown gnome cry.','This cherry pie tastes so good, it could make a grown gnome cry.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4681,'Try some of this cherry pie, it will put a smile on your face, ten miles wide.','Try some of this cherry pie, it will put a smile on your face, ten miles wide.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4682,'Fresh cherry pie for sale, looks so good it will bring a tear to your eye.','Fresh cherry pie for sale, looks so good it will bring a tear to your eye.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(4683,'','Oh, do tell! The suspense alone is enough to make a girl scream!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4684,'Cherry pie is my favoritist food in all of Azeroth.','Cherry pie is my favoritist food in all of Azeroth.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(4685,'','Well, from what I hear, the new plague has ALL of the old plague flavor but none of the old plague calories or carbohydrates!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4686,'','Oh, how positively delightful!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4687,'','%s claps excitedly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4688,'Very well, Proudtusk, you may begin your march. Carry on!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4689,'Well hello there ladies. Heard about the new plague?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4690,'SIR, YES SIR!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4691,'You heard the Warlord, maggots! MARCH!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4692,'Well done, soldiers! At ease!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4693,'','%s blushes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4694,'','Ewwwww... not if you were the last orc on Kalimdor, Lunk.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4695,'%s laughs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4696,'Ah, look at the time! I must return to my post... up over there.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4697,'If you\'ll excuse me, I must take my leave. Good day, ladies.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4698,'Great dangers lie beyond those walls, $n. turn back until you are more seasoned in the ways of combat.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4699,'Your reign of terror ends now!  Face your doom mortals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4700,'You must be hard up to be wandering these Badlands, $c.  Hard up like me.$B$BOr maybe you\'re here because you\'re crazy.  Crazy, like me.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(4701,'%s runs for their life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4702,'%s reaches out towards Captain Beltis as he falls.','%s reaches out towards Captain Beltis as she falls.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4703,'This evil cannot be allowed to enter this world!  Come my children!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4704,'Get away from there!','Get away from there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4705,'Oh, if I only had a tree branch to hold up in front of me. The guards would never see me then.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4706,'You\'ll have to be patient with me, $n. I\'ve got my Spybot inside working on a very delicate matter. I\'ll be with ya in a second.$B$BOh, and do me a favor, try not to let Lescovar see you... we\'re about to ambush him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4707,'GOR\'TESH DEAD?!?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4708,'RUN! RUN FOR HILLS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4709,'WHO KILL GOR\'TESH!?!? WHO DO THIS?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4710,'Rough times, huh, $n? No matter where you turn someone needs help, and my wife and I are no exception.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4711,'$n KILL! $G He:She; kill you now! RUN! RUN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4712,'Run for hills! Wait! We already in hills!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4713,'I\'d like to see what you have to sell.','I\'d like to see what you have to sell.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4714,'%s looks up at you quizzically. Maybe you should inspect it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4715,'Launch me!','Launch me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4716,'Greetings!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4717,'','You are indeed powerful, $n. Come to me if it is more work that you seek.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4718,'My eyes never deceive me, $r. I see great power in you - enough power, perhaps, to further our cause. Find me at the top of the tower.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4719,'I saw it with me own two eyes!  The biggest Makura ye ever seen, bigger\'n a mountain giant\'s fist it was, clawed its way right up the side of one o\' them twin colossals.  I dunno how yeh plan on gettin\' up there, but the beast\'s sure to have a load of treasure if yeh do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4720,'Buy somethin\', will ya?','Buy somethin\', will ya?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4721,'Can you tell me how I can get a Videre Elixir?','Can you tell me how I can get a Videre Elixir?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4722,'Sure thing, $n. You look like you can be trusted... Trustworthy! I can spot that a mile away...$B$BAnyway, back to what I was sayin\'. Takes one Evoroot plant to make the Videre Elixir. The rest \'a the ingredients are trivial really, but the Evoroot, well, that can be a bit tricky to get.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4723,'Key... get the key... Gerstahn has... key.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4724,'Try and make yourself useful, $r. GET ME OUT OF HERE! The High Interrogator has the key.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4725,'HEY! HEY YOU! $R! Get me out of here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4726,'%s groans.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4727,'Ok, let\'s take a look at this thing...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4728,'Oh, darn...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4729,'','Ok!  Let\'s get started!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4730,'','... oops.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4731,'Get it over with you filthy $r.$B$B<Kharan lowers his head, exposing his stubby neck.>','',16,0,0,0,0,0,0,0,1,0,0,0,26124),
(4732,'I am not here to harm you, Kharan. Gor\'shak sent me. He told me that you would speak to me about the Princess.','I am not here to harm you, Kharan. Gor\'shak sent me. He told me that you would speak to me about the Princess.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4733,'All is lost...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4734,'All is not lost, Kharan!','All is not lost, Kharan!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4735,'Do I look stupid to you, $r? I may as well sign her death warrant myself! Why should I trust you?\n','',26,5,6,0,0,0,0,0,1,0,0,0,26124),
(4736,'Because you are still alive and my hands aren\'t gripped firmly around your stubby little neck.','Because you are still alive and my hands aren\'t gripped firmly around your stubby little neck.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4737,'<Kharan sighs.>$B$BI suppose... I suppose you are right.$B$BGor\'shak told me that your Warchief has big plans. Plans that may change the way the Alliance and Horde interact. What do you know about this?','',1,1,6,0,0,0,0,0,1,0,0,0,26124),
(4738,'Nothing. My orders were to speak with you and then speak with Thrall. All I know is that Thrall is interested in saving your princess.\n','Nothing. My orders were to speak with you and then speak with Thrall. All I know is that Thrall is interested in saving your princess.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4739,'Then listen well, $r.$B$BSeveral months ago, the Magistrate of Lakeshire sent envoys to Ironforge, pleading with the King for assistance with the Blackrock incursions coming from Redridge and the Burning Steppes.$B$BPrincess Moira volunteered to help, against my pleadings. I was assigned twenty elite guardsmen to protect the Princess through the perilous journey from the Loch to Lakeshire.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(4740,'Which would explain why you\'re sitting in a jail cell at the bottom of a mountain, right, dwarf?','Which would explain why you\'re sitting in a jail cell at the bottom of a mountain, right, dwarf?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4741,'<Kharan clears his throat.>$B$BWe made our way through the Searing Gorge tunnel and into the ravaged wasteland comprising the gorge. In retrospect, things were eerily quiet. The only dangers we ran across were the wildlife of the region: Creatures that my men easily dispatched.$B$BWe reached Blackrock Mountain with relative ease and made our way through the stonewrought construction without so much as a hiccup.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(4742,'So what happened?','So what happened?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4743,'As we were making our way across the Burning Steppes, we were ambushed. It must have been a hundred of them... Dark Iron dwarves! They were shifting out of the walls, from the rocks in the Steppes; out of every crevice, nook, and cranny in sight. They swarmed us, overwhelming the guards and the few brave heroes that had agreed to assist us on this mission.$B$BOne thing was clear: This was a highly orchestrated ambush. It was as if they knew every move we would make before we made them...','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(4744,'So you suspect that someone on the inside was involved? They were tipped off?','So you suspect that someone on the inside was involved? They were tipped off?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4745,'How else could this have happened? Someone must have tipped the Dark Irons off.$B$B<Kharan shakes his fist at you.>$B$BSo help me, if I ever get out of here, I will spend the rest of my days finding the traitor.','',6,15,1,0,0,0,0,0,1,0,0,0,26124),
(4746,'Continue with your story please.','Continue with your story please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4747,'Where was I? Oh yes, so we were captured. My elite guardsmen were executed on the spot. They spared me and took the princess away by way of ram. I was taken to the detention halls of the Slag Pit and then transferred to this prison.$B$BI can only assume I am still alive because they wish to extract a ransom for my pitiful life. Or maybe out of cruelty, as a way to let me forever play back the events that transpired in my mind. Regret is the cruelest jailor of all, $r.','',6,1,1,0,0,0,0,0,1,0,0,0,26124),
(4748,'Indeed.','Indeed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4749,'She now resides at the side of Emperor Thaurissan. He has her under some sort of powerful thought altering spell... and here I sit, completely helpless.\n','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(4750,'If it\'s any consolation, I\'ll be leaving the cell door open. How you get out is your problem. Good bye, Kharan. \n','If it\'s any consolation, I\'ll be leaving the cell door open. How you get out is your problem. Good bye, Kharan. \n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4751,'','%s holds the Rune of Escape in front of her.',193,0,0,0,0,0,0,0,1,0,0,0,26124),
(4752,'I am here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4753,'Only a fool would dare disturb me in my lair.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4754,'I present you with proof of my deeds, Cyrus.','I present you with proof of my deeds, Cyrus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4755,'I do not possess any proof, Cyrus.','I do not possess any proof, Cyrus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4756,'<Cyrus\'s eyes glow brightly>$B$BDo I devour you whole or do I allow you to live?$B$BPerhaps you could still be of some use...$B$BChallenge my minion, $r. Survive and return proof of your victory to me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4757,'A defender has fallen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4758,'Be alert, you lazy mules!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4759,'I am ready!','I am ready!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4760,'Grumble, grumble...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4761,'Look for Yelmak\'s Alchemy and Potions.  Find it in the middle of The Drag, west of the huge tree.','Look for Yelmak\'s Alchemy and Potions.  Find it in the middle of The Drag, west of the huge tree.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4762,'Potions and oils, these are things that Yelmak will teach you of if you are worthy.  Look for his shop in the middle of The Drag.','Potions and oils, these are things that Yelmak will teach you of if you are worthy.  Look for his shop in the middle of The Drag.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4763,'Talk to Saru Steelfury at The Burning Anvil.  Go to the Valley of Honor.  It\'s at the end of the path to the right of Red Canyon Mining.','Talk to Saru Steelfury at The Burning Anvil.  Go to the Valley of Honor.  It\'s at the end of the path to the right of Red Canyon Mining.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4764,'Maybe Saru Steelfury will teach you to make an axe as good as mine some day.  Find him at The Burning Anvil in the Valley of Honor down the path to the right past Red Canyon Mining.','Maybe Saru Steelfury will teach you to make an axe as good as mine some day.  Find him at The Burning Anvil in the Valley of Honor down the path to the right past Red Canyon Mining.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4765,'You want Zamja at Borstan\'s Firepit on the upper level of The Drag.  Go up the stairs on the left as you enter The Drag from the Valley of Strength.','You want Zamja at Borstan\'s Firepit on the upper level of The Drag.  Go up the stairs on the left as you enter The Drag from the Valley of Strength.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4766,'Grumble...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4767,'You\'ll want to learn from Zamja.  Head to Borstan\'s Firepit on the upper level of The Drag by taking the stairs on the left as you enter from the Valley of Strength.','You\'ll want to learn from Zamja.  Head to Borstan\'s Firepit on the upper level of The Drag by taking the stairs on the left as you enter from the Valley of Strength.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4768,'%s sniffs the bait.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4769,'Godan\'s Runeworks is where you\'ll go.  Look for it on the west end of The Drag, right next to the Valley of Wisdom.','Godan\'s Runeworks is where you\'ll go.  Look for it on the west end of The Drag, right next to the Valley of Wisdom.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4770,'Can you enchant my axe?  I\'ll want a permanent.  Maybe later then.  Find Godan\'s Runeworks on the west end of The Drag near the Valley of Wisdom.','Can you enchant my axe?  I\'ll want a permanent.  Maybe later then.  Find Godan\'s Runeworks on the west end of The Drag near the Valley of Wisdom.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4771,'%s gnaws at the bait ravenously.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4772,'Arnok makes good bandages.  Find him at the Survival of the Fittest hut on the shore of the lake next to Spirit Lodge in the Valley of Spirits.  It\'s above and to the west of the Valley of Strength.','Arnok makes good bandages.  Find him at the Survival of the Fittest hut on the shore of the lake next to Spirit Lodge in the Valley of Spirits.  It\'s above and to the west of the Valley of Strength.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4773,'I guess someone needs to bandage us warriors up after the fighting.  Seek out Arnok at the Survival of the Fittest hut next to the Spirit Lodge in the Valley of Spirits.  Look up above and to the west of the Valley of Strength for a lake.  That\'s where he\'s at.','I guess someone needs to bandage us warriors up after the fighting.  Seek out Arnok at the Survival of the Fittest hut next to the Spirit Lodge in the Valley of Spirits.  Look up above and to the west of the Valley of Strength for a lake.  That\'s where he\'s at.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4774,'That Lumak... always fishing instead of fighting.  You\'ll find him out on his dock on the lake in the Valley of Honor.  While you\'re there say hi to Shankys for me.','That Lumak... always fishing instead of fighting.  You\'ll find him out on his dock on the lake in the Valley of Honor.  While you\'re there say hi to Shankys for me.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4775,'Fishing is a sport for the old who have not died in battle!  Go find Lumak on the lake in the Valley of Honor.','Fishing is a sport for the old who have not died in battle!  Go find Lumak on the lake in the Valley of Honor.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4776,'Herbs... you need to speak to Jandi at her arboretum in The Drag.  There are some wooden steps behind Asoran\'s Market in the Valley of Wisdom.  Follow them to the upper level of The Drag and you\'ll find her.','Herbs... you need to speak to Jandi at her arboretum in The Drag.  There are some wooden steps behind Asoran\'s Market in the Valley of Wisdom.  Follow them to the upper level of The Drag and you\'ll find her.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4777,'Ya man, you be wantin Jandi\'s Arboretum.  Did I just say that?  Glok\'tar I must be tired!  Follow the wooden steps behind Asoran\'s Market in the Valley of Wisdom up into The Drag and you\'ll find Jandi\'s there on the upper level.','Ya man, you be wantin Jandi\'s Arboretum.  Did I just say that?  Glok\'tar I must be tired!  Follow the wooden steps behind Asoran\'s Market in the Valley of Wisdom up into The Drag and you\'ll find Jandi\'s there on the upper level.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4778,'Go to Kodohide Leatherworkers in The Drag. Ask for Karolek.','Go to Kodohide Leatherworkers in The Drag. Ask for Karolek.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4779,'Kodohide Leatherworkers is what you want.  Find it in the middle of The Drag.','Kodohide Leatherworkers is what you want.  Find it in the middle of The Drag.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4780,'Go find Zando\'zan in the Cleft of Shadow.  There are a couple of tunnels leading down into that cavern, one just south of the Valley of Wisdom and the other in The Drag.','Go find Zando\'zan in the Cleft of Shadow.  There are a couple of tunnels leading down into that cavern, one just south of the Valley of Wisdom and the other in The Drag.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4781,'You have a treasure chest?  Let me see!  Alright, find Zando\'zan in the Cleft of Shadow.  Look for the tunnel going down in The Drag to find it.','You have a treasure chest?  Let me see!  Alright, find Zando\'zan in the Cleft of Shadow.  Look for the tunnel going down in The Drag to find it.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4782,'Find Red Canyon Mining northeast of the lake in the Valley of Honor.  Speak to Makaru there.','Find Red Canyon Mining northeast of the lake in the Valley of Honor.  Speak to Makaru there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4783,'Makaru can be found day and night at Red Canyon Mining in the Valley of Honor, just off the lake.','Makaru can be found day and night at Red Canyon Mining in the Valley of Honor, just off the lake.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4784,'Thuwd will show you how to skin your kills.  Look for him at Kodohide Leatherworkers in The Drag.','Thuwd will show you how to skin your kills.  Look for him at Kodohide Leatherworkers in The Drag.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4785,'It is good that you wish to honor your kills by putting their bodies to use.  Find Thuwd inside the Kodohide Leatherworks in the middle of The Drag.','It is good that you wish to honor your kills by putting their bodies to use.  Find Thuwd inside the Kodohide Leatherworks in the middle of The Drag.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4786,'I prefer my food raw, but if you like yours cooked Denni\'ka can show you how to light a fire.  Find her at Survival of the Fittest, a hut on the shore of the lake next to the Spirit Lodge.  Look for it up above and to the west of the Valley of Strength.','I prefer my food raw, but if you like yours cooked Denni\'ka can show you how to light a fire.  Find her at Survival of the Fittest, a hut on the shore of the lake next to the Spirit Lodge.  Look for it up above and to the west of the Valley of Strength.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4787,'Denni\'ka can show you how to keep warm.  Look for her at Survival of the Fittest, a hut on the shore of the lake next to the Spirit Lodge.  Head up above and west of the Valley of Strength.','Denni\'ka can show you how to keep warm.  Look for her at Survival of the Fittest, a hut on the shore of the lake next to the Spirit Lodge.  Head up above and west of the Valley of Strength.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4788,'Magar\'s Cloth Goods is in The Drag.  Find him south of the huge tree next to the Kodohide Leatherworks.','Magar\'s Cloth Goods is in The Drag.  Find him south of the huge tree next to the Kodohide Leatherworks.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4789,'Clothing!?  That won\'t help you against good steel!  Bah, if you\'re sure you want to be a tailor go find Magar\'s Cloth Goods in The Drag.','Clothing!?  That won\'t help you against good steel!  Bah, if you\'re sure you want to be a tailor go find Magar\'s Cloth Goods in The Drag.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4790,'Track down Shim\'la at the south entrance to the Hunter\'s Hall in the Valley of Honor.','Track down Shim\'la at the south entrance to the Hunter\'s Hall in the Valley of Honor.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4791,'Good thing someone here has tracking!  Look for Shim\'la in the Hunter\'s Hall in the Valley of Honor.','Good thing someone here has tracking!  Look for Shim\'la in the Hunter\'s Hall in the Valley of Honor.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4792,'We have our duties, $c.  Duties to the Horde.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4793,'Where is Warlord Krom\'zar?','Where is Warlord Krom\'zar?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4794,'I think I hear him coming!  Look to the west!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4795,'The Bank of Orgrimmar is in the Valley of Strength. Look for it north of the main entrance to the city.','The Bank of Orgrimmar is in the Valley of Strength. Look for it north of the main entrance to the city.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4796,'Go to the Valley of Strength and look for the Bank of Orgrimmar to the south of the Sky Tower.','Go to the Valley of Strength and look for the Bank of Orgrimmar to the south of the Sky Tower.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4797,'Find the Wind Rider Master at the top of The Sky Tower in the Valley of Strength.  Doras will make sure you find your way to the battle you seek.','Find the Wind Rider Master at the top of The Sky Tower in the Valley of Strength.  Doras will make sure you find your way to the battle you seek.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4798,'Where did you think the Wind Rider Master would be?  Head to the top of The Sky Tower in the Valley of Strength!','Where did you think the Wind Rider Master would be?  Head to the top of The Sky Tower in the Valley of Strength!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4799,'You\'re looking for Urtrun Clanbringer in the Horde Embassy.  Find it on the west side of the Valley of Strength.','You\'re looking for Urtrun Clanbringer in the Horde Embassy.  Find it on the west side of the Valley of Strength.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4800,'The Horde Embassy is in the Valley of Strength on the west side.','The Horde Embassy is in the Valley of Strength on the west side.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4801,'That\'s the second building on the right in the Valley of Strength north of the main city entrance.  Speak to Innkeeper Gryshka.','That\'s the second building on the right in the Valley of Strength north of the main city entrance.  Speak to Innkeeper Gryshka.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4802,'Look for Innkeeper Grishka in the Valley of Strength.  Her inn is on the east side, north of the main city gates.','Look for Innkeeper Grishka in the Valley of Strength.  Her inn is on the east side, north of the main city gates.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4803,'You\'ll find one of those outside the Bank of Orgrimmar in the middle of the Valley of Strength.','You\'ll find one of those outside the Bank of Orgrimmar in the middle of the Valley of Strength.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4804,'You can pick up your love letters outside the bank in the middle of the Valley of Strength.','You can pick up your love letters outside the bank in the middle of the Valley of Strength.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4805,'Go to the Hunter\'s Hall in the Valley of Honor, west of the Coliseum.  Talk to Ormak Grimshot there.','Go to the Hunter\'s Hall in the Valley of Honor, west of the Coliseum.  Talk to Ormak Grimshot there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4806,'Shoot straight to the northwest section of the Valley of Honor.  There you will find the Hunter\'s Hall.','Shoot straight to the northwest section of the Valley of Honor.  There you will find the Hunter\'s Hall.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4807,'Speak to Pephredo at the Darkbriar Lodge in the Valley of Spirits, up above and to the west of the Valley of Strength.','Speak to Pephredo at the Darkbriar Lodge in the Valley of Spirits, up above and to the west of the Valley of Strength.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4808,'What, you can\'t port there?  Go to the Darkbriar Lodge next to the lake in the Valley of Spirits, up above and to the west of the Valley of Strength.','What, you can\'t port there?  Go to the Darkbriar Lodge next to the lake in the Valley of Spirits, up above and to the west of the Valley of Strength.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4809,'Zayus and his priests are in the Spirit Lodge, which is in the Valley of Spirits.  Look for it on the lake up above and to west of the Valley of Strength.','Zayus and his priests are in the Spirit Lodge, which is in the Valley of Spirits.  Look for it on the lake up above and to west of the Valley of Strength.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4810,'Healing is for those who cannot endure pain.  However if you must, seek out the Spirit Lodge on the lake in the Valley of Spirits, up and above the Valley of Strength to the west.','Healing is for those who cannot endure pain.  However if you must, seek out the Spirit Lodge on the lake in the Valley of Spirits, up and above the Valley of Strength to the west.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4811,'You seek Kardris Dreamseeker.  She and the other shaman are in the entrance room to Thrall\'s Fortress in the Valley of Wisdom.','You seek Kardris Dreamseeker.  She and the other shaman are in the entrance room to Thrall\'s Fortress in the Valley of Wisdom.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4812,'Your search is almost completed.  Seek your truth in the entrance room of Thrall\'s Fortress in the Valley of Wisdom.','Your search is almost completed.  Seek your truth in the entrance room of Thrall\'s Fortress in the Valley of Wisdom.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4813,'Looking for Shenthul of the Shadowswift Brotherhood, huh?  In The Drag across from Droffers and Son Salvage look for a tunnel leading down into the Cleft of Shadow.','Looking for Shenthul of the Shadowswift Brotherhood, huh?  In The Drag across from Droffers and Son Salvage look for a tunnel leading down into the Cleft of Shadow.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4814,'Don\'t let me catch you stealing anything!  Look for Shenthul and his Shadowswift Brotherhood in the underground Cleft of Shadow.  Find the tunnel leading down into it south of the Valley of Wisdom.','Don\'t let me catch you stealing anything!  Look for Shenthul and his Shadowswift Brotherhood in the underground Cleft of Shadow.  Find the tunnel leading down into it south of the Valley of Wisdom.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4815,'You seek Grol\'dar and the Darkfire Enclave?  Find them in the underground cavern called the Cleft of Shadow.  There are two tunnels leading down into that cave, one just south of the Valley of Wisdom and the other from The Drag.','You seek Grol\'dar and the Darkfire Enclave?  Find them in the underground cavern called the Cleft of Shadow.  There are two tunnels leading down into that cave, one just south of the Valley of Wisdom and the other from The Drag.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4816,'Didn\'t we just break free of the Burning Legion, and here you are messing with demons again?  Seek out the Darkfire Enclave in the underground cavern known as the Cleft of Shadow.  You\'ll find a tunnel down into it from The Drag.','Didn\'t we just break free of the Burning Legion, and here you are messing with demons again?  Seek out the Darkfire Enclave in the underground cavern known as the Cleft of Shadow.  You\'ll find a tunnel down into it from The Drag.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4817,'Speak to Grezz Ragefist in the Hall of the Brave, which is in the Valley of Honor.  Put in a good word for me!','Speak to Grezz Ragefist in the Hall of the Brave, which is in the Valley of Honor.  Put in a good word for me!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4818,'Find the Hall of the Brave in the Valley of Honor and speak to Grezz Ragefist.  Let them know that I\'ll be reporting back in after my shift here.','Find the Hall of the Brave in the Valley of Honor and speak to Grezz Ragefist.  Let them know that I\'ll be reporting back in after my shift here.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4819,'You lost?','You lost?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4820,'What do you want?','What do you want?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4821,'What!?','What!?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4822,'Lok\'tar Ogar!','Lok\'tar Ogar!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4823,'Can you help me with some directions?','Can you help me with some directions?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4824,'Please, leave an old spirit in peace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4825,'Very few seek me out... What may I do for you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4826,'I have given you all the knowledge I have, $n. May luck be with you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4827,'How can I get Evoroot?','How can I get Evoroot?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4828,'Heh, heh... Quite the inquisitive one, aren\'t ya, $n? Well, here\'s what you need to do.$B$BNorth of here, in the old ruins, lives a very disagreeable gnoll by the name of Miblon Snarltooth. He guards the only Evoroot I know of, but he watches it night and day! Seems like he never even sleeps!$B$BWhat you can do, is bribe him. I can sell you some bait that he\'ll find tasty -- just put it down near him and that will distract him long enough for you to grab the Evoroot. Good luck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4829,'Face me, if you dare!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4830,'Vorfalk','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4831,'Bethek','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4832,'Uggel','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4833,'Zimrel','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4834,'Ofgut','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4835,'Pelver','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4836,'%s abandons the block he was holding up in the doorway, and looks towards the bait.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4837,'%s pounds his chest, calling for help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4838,'%s explodes into chunks of acidic slime!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4839,'','I know it\'ll work this time...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4840,'','This will be my best experiment yet!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4841,'','Now, if I add the yellow ones...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4842,'','I know it\'ll work this time... My last 13 tries were just practice!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4843,'','Ahh... My experiments never seem to work out right. Maybe I should go back downstream.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4844,'I\'d like to purchase more Tharlendris seeds.','I\'d like to purchase more Tharlendris seeds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4845,'I\'d like to purchase more Tharlendris seeds.','I\'d like to purchase more Tharlendris seeds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4846,'','%s begins to combine different colored crystals together.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4847,'','I think... I think it\'s working!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4848,'I\'m not a journeyman herbalist -- am I able to still assist you in your work?','I\'m not a journeyman herbalist -- am I able to still assist you in your work?',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(4849,'Yes, but you\'ll find it more rewarding if you have skill in herbalism!  You\'ll be nurturing and cultivating special seeds.  While the Evergreen Pouch you\'ll receive allows even a novice to grow something, those who show some aptitude in herbalism will have more bountiful results.','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(4850,'Greetings, $c.  What may this humble servant of the Feathermoon Stronghold do for you today?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4851,'I\'d like to purchase more Tharlendris seeds.','I\'d like to purchase more Tharlendris seeds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4852,'','OW! That\'s not right!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4853,'','Oh well... Maybe next time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4854,'Stand straight!  Your weakness sickens me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4855,'Be alert!  The orcs and their allies are close!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4856,'Look fierce!  You are Kolkar, so act like one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4857,'What are you looking for?','What are you looking for?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4858,'Which profession?','Which profession?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4859,'Alchemy','Alchemy',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4860,'Blacksmithing','Blacksmithing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4861,'Cooking','Cooking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4862,'Enchanting','Enchanting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4863,'First Aid','First Aid',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4864,'Fishing','Fishing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4865,'Herbalism','Herbalism',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4866,'Leatherworking','Leatherworking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4867,'Lockpicking','Lockpicking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4868,'Mining','Mining',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4869,'Skinning','Skinning',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4870,'Survival','Survival',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4871,'Tailoring','Tailoring',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4872,'Tracking','Tracking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4873,'','The death of our flesh marked the birth of our spirit and our sacred task.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4874,'I am one of the Seven, and it is our doom to stand sentry.  Forever.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4875,'Our leader, Doom\'rel, has ears for the challenge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4876,'I am forever denied the touch of stone.  I will never again know the glory of shaped iron...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4877,'','You may not pass.  You are not our kin, nor have you issued the challenge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4878,'Which trainer do you seek?','Which trainer do you seek?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4879,'Our fate is the doom of all who face the Great Fire.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4880,'Hunter','Hunter',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4881,'Our punishment is also our blessing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4882,'Mage','Mage',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4883,'Priest','Priest',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4884,'Shaman','Shaman',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4885,'Rogue','Rogue',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4886,'Warlock','Warlock',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4887,'Warrior','Warrior',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4888,'The bank','The bank',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4889,'Flight Master','Flight Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4890,'Guild Master & Vendor','Guild Master & Vendor',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4891,'Class Trainer','Class Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4892,'Your bondage is at an end, Doom\'rel.  I challenge you!','Your bondage is at an end, Doom\'rel.  I challenge you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4893,'The inn','The inn',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4894,'You have challenged the Seven, and now you will die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4895,'Mailbox','Mailbox',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4896,'Profession Trainer','Profession Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4897,'Gloom\'rel, tell me your secrets!','Gloom\'rel, tell me your secrets!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4898,'You wish to learn the old craft?  You wish to smelt dark iron?$B$BAppease me, $r.  Show me a sacrifice and I will consider it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4899,'Your will is strong, and your intent is clear.$B$BPerhaps you are worthy...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4900,'I have paid your price, Gloom\'rel.  Now, teach me your secrets!','I have paid your price, Gloom\'rel.  Now, teach me your secrets!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4901,'You have shown me your desire, and have paid with precious stone.  I will teach you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4902,'Intruders! Attack the intruders!','Intruders! Attack the intruders!',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(4903,'I know the way, insect. There is no need to prod me as if I were cattle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4904,'Surely you do not think that you will get away with this incursion. They will come for me and you shall pay for your insolence.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4905,'RUN THEM THROUGH BROTHERS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4906,'I doubt you will be so lucky the next time you encounter my brethren.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4907,'They come for you, fool!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4908,'What do you think you accomplish from this, fool? Even now, the Blackrock armies make preparations to destroy your world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4909,'On darkest wing they fly. Prepare to meet your end!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4910,'You will not defile our sacred land!','You will not defile our sacred land!',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(4911,'The worst is yet to come!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4912,'%s laughs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4913,'Time to make your final stand, insect.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4914,'The Kolkar will rule!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4915,'Your Horde is nothing to the Kolkar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4916,'Shake in fear, dogs!  I am here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4917,'The Kolkar are the strongest!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4918,'%s submits.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4919,'You two-legs are nothing!  My children could beat you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4920,'I am here!  Your rule of this land is over!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4921,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4922,'Defend the bunkers!','Defend the bunkers!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4923,'The invaders are here!','The invaders are here!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4924,'Beware!  The Kolkar attack!','Beware!  The Kolkar attack!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4925,'Our foes will fall!','Our foes will fall!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4926,'Beware, $n!  Look to the west!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4927,'You have come to play? Then let us play!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4928,'Kneel, Grark.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4929,'Grark Lorkrub, you have been charged and found guilty of treason against the Horde. How you plead is unimportant. High Executioner Nuzrak, step forward.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4930,'%s raises his massive axe over Grark.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4931,'End him...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4932,'%s raises his hand and then lowers it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4933,'You, soldier, report back to Kargath at once!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4934,'Get away from those kegs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4935,'I... I\'m not really sure how I got here...$B$BI seem to remember traveling... a raft...$B$B','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4936,'You\'ll pay for that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4937,'Pay me and I\'ll talk...$B$BOh hey, it\'s you, $n! Nevermind about that...','',25,1,0,0,0,0,0,0,1,0,0,0,26124),
(4938,'Does my name sound familiar to you? Maybe we knew each other a long time ago...$B$BI think I\'m named after someone important...','',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(4939,'Hi there! I\'m glad you came back, $n. Tell me, have you completed the first quest I gave you? If you have, I might have a second quest for you...','',3,6,1,0,0,0,0,0,1,0,0,0,26124),
(4940,'When I was wandering the crater after I crashed here, I remembered something that I once was told... \"Go up, up the mountain ahead,\" said the voice in my head.$B$BListening to it is how I ended up here, $n!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(4941,'A long time ago, during my travels, I met a man that told me, \"Master using it and you can have this.\"$B$BWhat do you suppose that means? I didn\'t know then, and I still don\'t now, really...','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(4942,'It\'s a secret to everybody... including me!$B$BI\'m glad you found me -- it\'s a good thing I\'m not hiding in a bush or underneath a rock, isn\'t it?','',1,6,11,0,0,0,0,0,1,0,0,0,26124),
(4943,'Thanks, $n! You\'re the hero of Un\'Goro Crater!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4944,'Ragnaros will reign supreme!','Ragnaros will reign supreme!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(4945,'Have a drink, $c.  It might be your last!','Have a drink, $c.  It might be your last!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(4946,'If it weren\'t for the Grim Guzzler, I\'d spend my free time pulling the wings off dragon whelps.','If it weren\'t for the Grim Guzzler, I\'d spend my free time pulling the wings off dragon whelps.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(4947,'If it weren\'t for the Grim Guzzler, I\'d probably spend my free time pulling the wings off dragon whelps.','If it weren\'t for the Grim Guzzler, I\'d probably spend my free time pulling the wings off dragon whelps.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(4948,'The water elementals are at war with the fire elementals, which sort of means they\'re at war with us.  One of their leaders, Hydraxis, is mustering agents for his cause...','The water elementals are at war with the fire elementals, which sort of means they\'re at war with us.  One of their leaders, Hydraxis, is mustering agents for his cause...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(4949,'Oh man, I thought I was dead for sure.  Ugh... still dizzy...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4950,'I heard that a noble among the water elementals, Hydraxis, wages war with the servants of fire.  Let\'s hope he loses!','I heard that a noble among the water elementals, Hydraxis, wages war with the servants of fire.  Let\'s hope he loses!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(4951,'The Waterlord Hydraxis hides off in Azshara, on an island in the Bay of Storms.  What kind of threat can the fool muster from there?','The Waterlord Hydraxis hides off in Azshara, on an island in the Bay of Storms.  What kind of threat can the fool muster from there?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(4952,'I like the way you think!  Let\'s get outta here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4953,'If Hydraxis recruits more in his war, then it might shift the balance of power...','If Hydraxis recruits more in his war, then it might shift the balance of power...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(4954,'It\'s all guns and flames until someone loses and dies.','It\'s all guns and flames until someone loses and dies.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(4955,'All right, I think I can make it on my own from here.  I don\'t know who you are... but I owe you one.  Thank you!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(4956,'My father told me there\'d be days like this, where a stranger would talk to me and I\'d have to restrain myself from killing $ghim:her;.','My father told me there\'d be days like this, where a stranger would talk to me and I\'d have to restrain myself from killing $ghim:her;.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(4957,'Welcome to Stonemaul Hold, brave $c.  How may I assist you this day?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4958,'Greetings $c -- if you\'re looking for leather goods and leatherworking supplies, you\'ve come to the right semi-retired Paladin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4959,'You look like you might be needing passage across the Great Sea. Well you have come to the right place, this here is the berth of the Maiden\'s Fancy, finest passenger ship to travel these waters. When she arrives, just climb aboard and the next thing you know you will find yourself basking on the sandy beaches of Stranglethorn.','You look like you might be needing passage across the Great Sea. Well you have come to the right place, this here is the berth of the Maiden\'s Fancy, finest passenger ship to travel these waters. When she arrives, just climb aboard and the next thing you know you will find yourself basking on the sandy beaches of Stranglethorn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4960,'I must say, Booty Bay has the best Clam Chowder to be had anywhere in the South Seas. Oh, not interested in cuisine eh? Well then let me be the first to welcome you to the berth of the Maiden\'s Fancy, the finest passenger ship to travel between the Eastern Kingdoms and Kalimdor. She\'s due back for another trip to Ratchet soon, so make yourself comfortable till she arrives.','I must say, Booty Bay has the best Clam Chowder to be had anywhere in the South Seas. Oh, not interested in cuisine eh? Well then let me be the first to welcome you to the berth of the Maiden\'s Fancy, the finest passenger ship to travel between the Eastern Kingdoms and Kalimdor. She\'s due back for another trip to Ratchet soon, so make yourself comfortable till she arrives.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4961,'Intruders!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4962,'What are you doing?  Intruders!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4963,'Of course there\'s no danger in everything catching flames and exploding like a huge helium bomb. This baby will get you to Undercity faster and safer than any boat, and the view is truly breathtaking. Speaking of breath, smoking is not allowed while on board the zeppelin, and fire spells are banned from being cast during the trip.','Of course there\'s no danger in everything catching flames and exploding like a huge helium bomb. This baby will get you to Undercity faster and safer than any boat, and the view is truly breathtaking. Speaking of breath, smoking is not allowed while on board the zeppelin',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4964,'Hello!  You\'re just the person I was looking for.  Take a seat and listen, because I have a plan that will make us both rich!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4965,'My brother said we could make great money with this trade route, but he didn\'t tell me I would be the one living on this side. If you come back this way on the Zeppelin, could you bring me something to eat? They sell some of the finest meat in Orgrimmar, and I sure could use something that didn\'t die weeks before it stopped moving.','My brother said we could make great money with this trade route, but he didn\'t tell me I would be the one living on this side. If you come back this way on the Zeppelin, could you bring me something to eat? They sell some of the finest meat in Orgrimmar, and I sure could use something that didn\'t die weeks before it stopped moving.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4966,'I hope this works!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4967,'%s adds the haze to the Bloodpetal sprouts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4968,'Look at them go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4969,'%s laughs as he watches the pests run off.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4970,'It\'s GO TIME! Come get sum! <replace this>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4971,'Your family says hello, Ribbly.  And they want your head!','Your family says hello, Ribbly.  And they want your head!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4972,'You\'re good for nothing, Ribbly.  It\'s time to pay for your wickedness!','You\'re good for nothing, Ribbly.  It\'s time to pay for your wickedness!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4973,'No!  Get away from me!  Help!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4974,'Look for Nogg\'s Machine Shop in the Valley of Honor northeast of Red Canyon Mining.','Look for Nogg\'s Machine Shop in the Valley of Honor northeast of Red Canyon Mining.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4975,'You\'ll find that goblin and his toy shop in the Valley of Honor.','You\'ll find that goblin and his toy shop in the Valley of Honor.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(4976,'Engineering','Engineering',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4977,'Help me choose wisely.','Help me choose wisely.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4978,'I am a mage of great power, I have spent my days studying the mind and the memory as it pertains to learning and the retention of learned abilities. I would even now be perfecting my studies if not for the great voices that came to me in the night, informing me that my services were required. I will be here for only a short time offering my ability to wipe your talents for free. Soon I will leave again, and you will once more be stuck with whatever choices you make.','I am a mage of great power, I have spent my days studying the mind and the memory as it pertains to learning and the retention of learned abilities. I would even now be perfecting my studies if not for the great voices that came to me in the night, informing me that my services were required. I will be here for only a short time offering my ability to wipe your talents for free. Soon I will leave again, and you will once more be stuck with whatever choices you make.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4979,'','You got it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4980,'','Coming right up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4981,'','I\'ll bring it right over, baby...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4983,'','Yes $gsir:madam;.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4984,'Hey Nagmara!  How about a mug of Dark Iron Ale?','Hey Nagmara!  How about a mug of Dark Iron Ale?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4985,'Nagmara!  Have any mutton left?','Nagmara!  Have any mutton left?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4986,'Mistress, you tell Plugger that I want more of his ale.  I can\'t get enough!','Mistress, you tell Plugger that I want more of his ale.  I can\'t get enough!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4987,'Hey Nag, how about you slice me off a piece of that...','Hey Nag, how about you slice me off a piece of that...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4988,'I\'d like to train in cooking.','I\'d like to train in cooking.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4989,'Hello, $n. If you\'d like to learn a thing or two about cooking, please visit me at any time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4990,'','<Lady Prestor glares at you.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4991,'Pardon the intrusion, Lady Prestor, but Highlord Bolvar suggested that I seek your advice.','Pardon the intrusion, Lady Prestor, but Highlord Bolvar suggested that I seek your advice.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4992,'','I was standing right next to you, imbecile. I know what you seek.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(4993,'My apologies, Lady Prestor.\n','My apologies, Lady Prestor.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4994,'','You seek to lower our global defenses in order to appease a paranoid magistrate and an encampment of riff-raff that are most probably suffering from heat stroke.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(4995,'Begging your pardon, Lady Prestor. That was not my intent.\n','Begging your pardon, Lady Prestor. That was not my intent.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4996,'','Of course not, dear $g boy:girl;. You \'adventurer\' types are often victims of circumstance; subject to the political drama which tends to unfold between citizenry and royalty.$B$BMy advice to you, then, is to seek out something else, more specifically: A new career.$B$BThis world has enough heroes.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(4997,'Thank you for your time, Lady Prestor.','Thank you for your time, Lady Prestor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4998,'%s gets really dizzy!','%s gets really dizzy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(4999,'%s drunkenly miscasts a shadow bolt!','%s drunkenly miscasts a shadow bolt!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5000,'','Hey, Rocknot!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5001,'','Let\'s go, honey.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5002,'','%s kisses her lover.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5003,'%s kisses Mistress Nagmara','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5004,'Please, help me to get through this cursed forest, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5005,'The corruption of the fel has not left any of the creatures of Felwood untouched, $n. Please, be on your guard.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5006,'What you be wanting? *hic*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5007,'Official business, John. I need some information about Marshal Windsor. Tell me about the last time you saw him.','Official business, John. I need some information about Marshal Windsor. Tell me about the last time you saw him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5008,'That I must fight against my own kind deeply saddens me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5009,'Windsor was particularly ornery that day - and believe me, for Windsor, that\'s a monumental accomplishment. He kept telling me that \'something feels off.\' Well he wasn\'t kidding!$B$BWe were in the middle of Blackrock Mountain when the filthy animals attacked. I\'m talking about the orcs, of course. Pay attention, will ya? All you could hear were grunts and the clanging of steel as they rushed us. ','',1,6,1,0,0,0,0,0,1,0,0,0,26124),
(5010,'So what did you do?','So what did you do?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5012,'Me versus fifty orcs? I\'m no fool, $n. My pappy always told me, \'Discreditin is the better part of a cracker,\' or something, and I knew what that meant.','',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(5013,'Start making sense, dwarf. I don\'t want to have anything to do with your cracker, your pappy, or any sort of \'discreditin.\'\n','Start making sense, dwarf. I don\'t want to have anything to do with your cracker, your pappy, or any sort of \'discreditin.\'\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5014,'Alright, alright. Anyhow, so I sorta slipped into the shadows.$B$BThat didn\'t sit too well with Windsor, seeing as how he was already extra cranky. Well he started spinnin\' old Ironfoe around and screaming like a mad man at the orcs. ','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(5015,'Ironfoe?\n','Ironfoe?\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5016,'Yep. You never heard of Ironfoe? The legendary orc slaying hammer? Yep, yep, that was ol\' Windsor\'s hammer. He told me that Franclorn Forgewright himself made that hammer for his great, great, grand pappy. THE Franclorn Forgewright: The Dark Iron responsible for stonewrought archimetenc... building stuff. He also said the hammer had a twin that Franclorn kept for himself. Think he called it Ironfel or something.','',6,1,1,0,0,0,0,0,1,0,0,0,26124),
(5017,'Interesting... continue, John.','Interesting... continue, John.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5018,'So where was I? Oh yea, so the orcs rushed Windsor and Windsor, well, he didn\'t move an inch. He stood tall as they charged him, ten at a time. All I could see was the glow from Ironfoe and a lot of blood. This went on for hours, maybe days. I don\'t remember. Anyhow, FINALLY, it stopped.','',6,5,5,0,0,0,0,0,1,0,0,0,26124),
(5019,'So that\'s how Windsor died...','So that\'s how Windsor died...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5020,'Died? Are you cracked, $n? Excuse me, $g Mister:Miss; $n! Windsor wouldn\'t have died from no fifty orcs. As sure as Thelsamar blood sausage is the tastiest food the world may ever know, there he stood: He was covered in orc chunks from head to toe, drenched in about eighteen layers of their blood, but he was definitely alive... and really, really angry.','',6,6,5,0,0,0,0,0,1,0,0,0,26124),
(5021,'So how did he die?','So how did he die?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5022,'Why do you keep saying he died? Who told you he died? I never said he died.$B$BHe went missing is all.$B$BYou see, apparently we had gotten into the middle of some big orc versus Dark Iron dwarf battle. The orcs, being the filthy, miserable curs that they are, were out early, setting up some traps and other diabolical things you probably wouldn\'t understand.','',6,1,1,0,0,0,0,0,1,0,0,0,26124),
(5023,'I can sense it now, $n. Ashenvale lies down this path.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5024,'Ok, so where the hell is he? Wait a minute! Are you drunk?','Ok, so where the hell is he? Wait a minute! Are you drunk?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5025,'Dwarves don\'t get drunk, $g mister:missy;. I\'m just a little sloppy.$B$BAnyhow, Windsor? I figure he\'s somewhere in Blackrock Depths. That\'s the Dark Iron city for you unedumecated peoples.','',14,6,1,0,0,0,0,0,1,0,0,0,26124),
(5026,'I feel... something strange...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5027,'WHY is he in Blackrock Depths?','WHY is he in Blackrock Depths?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5028,'Slow down! I was getting to that!$B$BSo there he was, standing tall with all the blood and guts dripping off him when who shows up?$B$BThe Dark Irons! Didn\'t you hear a word I said??$B$BWell, the Dark Irons are a little craftier than those Blackrock orcs. They came prepared. By prepared I mean there were about 300 of em... *hic* \'scuse me.','',5,1,1,0,0,0,0,0,1,0,0,0,26124),
(5029,'$n, my form has now changed! The true strength of my spirit is returning to me now... The cursed grasp of the forest is leaving me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5030,'300? So the Dark Irons killed him and dragged him into the Depths?','300? So the Dark Irons killed him and dragged him into the Depths?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5031,'$G Mister:Missy;, if I didn\'t know better, I\'d think you were one of them \'special\' peoples. We call em Troggs.$B$BWindsor didn\'t have no beef with the Dark Irons, after all, his great, great, grand pappy\'s best friend was a Dark Iron. Which is also probably why that army of Dark Irons didn\'t kill him on sight.','',25,1,5,0,0,0,0,0,1,0,0,0,26124),
(5032,'Your knowledge is lacking.  Return to me when your skills in smelting have grown!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5033,'You may leave me here -- I wish to be alone in my final moments.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5034,'Ahhh... Ironfoe.\n','Ahhh... Ironfoe.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5035,'Finally! Put some fingers in your ears, your brain mighta just grown five sizes and I\'m worried it might leak out.$B$BSo, the Dark Irons spared his life and took him prisoner. Their leader, some self-important, uppity fella named Thauris-something, took Ironfoe for himself. And that was the last I saw of ol\' Windsor... *hic* \'scuse me.\n','',5,1,33,0,0,0,0,0,1,0,0,0,26124),
(5036,'Thank you, $n. Now my spirit will finally be at peace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5037,'The corruption of Felwood has trapped my spirit here... I may never rest...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5038,'Thanks, Ragged John. Your story was very uplifting and informative. ','Thanks, Ragged John. Your story was very uplifting and informative. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5039,'','Welcome to the Grim Guzzler!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5040,'Why don\'t you and Rocknot go find somewhere private...','Why don\'t you and Rocknot go find somewhere private...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5041,'','Good idea!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5042,'','Thanks again, $n.  Rocknot and I are really hitting it off!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5043,'Another Engineer! Hey, this is a great chance for me to show off some new gadgets I\'ve been building!','Another Engineer! Hey, this is a great chance for me to show off some new gadgets I\'ve been building!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5044,'','If you\'re going to venture into Blackrock Depths, come speak with me. I may have some work for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5045,'%s looks tired. He then yawns and lies down next to A-Me 01','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5046,'%s snores loudly and cuddles up next to A-Me 01.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5047,'','Have you seen all the wonderful things here in Ungoro Crater, $n? It\'s simply amazing. Not as amazing as some of the things I can make with my skill at engineering, but for it being all natural here... it\'s not too bad.$B$BMy uncle Remtravel loves old stuff like this place. I\'m following in his footsteps kinda--I want to discover new things from lost cultures too!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5048,'','Hmm, I don\'t have any mithril casings. I\'m all out. Is that all you need to get to fix A-Me? Oh, that would be fantastic!$B$BMithril casings aren\'t too hard to find back in civilization. Just ask any skilled engineer to make one for you. I think it takes a few bars of mithril, but if you could help me out, I\'ll make sure you\'re well rewarded!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5049,'Do you have any mithril casings?','Do you have any mithril casings?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5050,'','Be sure to try our Dark Iron Ale.  I hear the dwarves around here can\'t get enough of it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5051,'','My master, Plugger Spazzring, is a good boss.  And he makes a lot of money.  His pockets are bursting!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5052,'This here is the finest, most state of the art mode of transportation money can build. What? Deeprun Tram? Gnomes? Listen pal, If you believe that garbage then I\'ve got a statue down in Stranglethorn to sell ya. Now, are you walking to Grom\'Gol or are you gonna ride in style in this fine flying machine? Your choice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5053,'Hey!  Get away from that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5054,'What are you doing over there?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5055,'No stealing the goods!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5056,'Hey!  Stop that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5057,'Phalanx, I think you need to teach thos person a lesson.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5058,'You are deemed a threat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5059,'I will be reborn, mortals! Incendius shall raise me from these ashes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5060,'That\'s it!  You\'re going down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5061,'I cannot be destroyed! By the will of Ragnaros, I shall be reborn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5062,'A-Me operational.  A-Me go home.  You speak to A-Me to change locomotion settings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5063,'Good... good, A-Me. A-Me good. Home. Find home.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5064,'Aid me! $n draws near!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5065,'Help me with this $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5066,'Have you tried that Thunderbrew Lager?  It\'s good stuff!','Have you tried that Thunderbrew Lager?  It\'s good stuff!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5067,'I have duty in an hour, but until then... bottom\'s up!','I have duty in an hour, but until then... bottom\'s up!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5068,'You looking at me, $gladdy:lassy;?','You looking at me, $gladdy:lassy;?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5069,'I\'ll take a pint of Dark Iron ale.  Oh, you\'re not the $gwaiter:waitress;?','I\'ll take a pint of Dark Iron ale.  Oh, you\'re not the $gwaiter:waitress;?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5070,'I think Plugger filled one of his kegs too much.  It looks like it\'s about to blow!','I think Plugger filled one of his kegs too much.  It looks like it\'s about to blow!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5071,'Don\'t bother me while I\'m partying...','Don\'t bother me while I\'m partying...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5072,'Ye be needing directions $glad : lass;?','Ye be needing directions $glad : lass;?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5073,'I love the smell of Ironforge in the morning!  Eh? And what would you be needing $c?','I love the smell of Ironforge in the morning!  Eh? And what would you be needing $c?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5074,'Whatcha need?','Whatcha need?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5075,'IF they say... IF!  There are no if\'s about Ironforge!  Eh?  What now?','IF they say... IF!  There are no if\'s about Ironforge!  Eh?  What now?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5076,'Can you help me with some directions?','Can you help me with some directions?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5077,'What do ye need directions to?','What do ye need directions to?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5078,'Bank of Ironforge','Bank of Ironforge',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5079,'Do ye have some new treasures that ye want to keep safe n\' sound?  Then ye\'ll be wanting to store them at The Vault with the Stonemantles.  \n\nYe\'ll find The Vault just a hammer\'s throw northeast from the entrance to Ironforge.','Do ye have some new treasures that ye want to keep safe n\' sound?  Ye\'ll be wanting to store them at The Vault with the Stonemantles.  Ye\'ll find The Vault just a hammer\'s throw northeast from the entrance to Ironforge.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5080,'The bank?  Oh, ye mean The Vault!  No safer place to store yer valuables than The Vault. Ye\'ll find it just northeast of the entrance to Ironforge. ','The bank?  Oh, ye mean The Vault!  No safer place to store yer valuables than The Vault. Ye\'ll find it just northeast of the entrance to Ironforge. ',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5081,'Gryphon Master','Gryphon Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5083,'Looking to take a ride on a gryphon, now are ye?  Gryth Thurden is the one ye\'ll want to be seeing about that.  \n\nYe can find him on the eastern side of The Great Forge in the middle of Ironforge.','Looking to take a ride on a gryphon, now are ye?  Gryth Thurden is the one ye\'ll want to be seeing about that.  \n\nYe can find him on the eastern side of The Great Forge in the middle of Ironforge.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5085,'Ah, nothing quite like a ride on a gryphon, is there?  The night elves can keep those hippo\'s of theirs, just give me a gryphon and the wind in me hair!  \n\nWell now, I won\'t keep ye any longer, just head over to Gryth Thurden on the east side of The Great Forge and he\'ll get ye on yer way.','Ah, nothing quite like a ride on a gryphon, is there?  The night elves can keep those hippo\'s of theirs, just give me a gryphon and the wind in me hair!  \n\nWell now, I won\'t keep ye any longer, just head over to Gryth Thurden on the east side of The Great Forge and he\'ll get ye on yer way.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5086,'Guild Master & Vendor','Guild Master & Vendor',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5087,'If yer thinking about forming a guild, then ye\'ll need to put it past Jondor Steelbrow o\'er in the Ironforge Visitor\'s Center.  Just head southeast from the gates of Ironforge to see him.','If yer thinking about forming a guild, then ye\'ll need to put it past Jondor Steelbrow o\'er in the Ironforge Visitor\'s Center.  Just head southeast from the gates of Ironforge to see him.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5088,'Class Trainer','Class Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5089,'Which class trainer might ye be looking for?','Which class trainer might ye be looking for?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5090,'The Inn','The Inn',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5091,'The Inn?  Ah, ye looking to toss back some of the best ales Ironforge has to offer?  The Stonefire Tavern is where ye\'ll want to go.  $B$BYe\'ll find it just to the left of the entrance to Ironforge if ye be coming, or to the right if ye be going.','The Inn?  Ah, ye looking to toss back some of the best ales Ironforge has to offer?  The Stonefire Tavern is where ye\'ll want to go. $B$BYe\'ll find it just to the left of the entrance to Ironforge if ye be coming, or to the right if ye be going.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5092,'If yer of need of an Inn, The Stonefire Inn is where ye should be.  Ye\'ll find it just to the left of the entrance to Ironforge if ye be coming, or to the right if ye be going.  $B$BOh, and if yer going that way, then tell them to have a tankard ready for me.','If yer of need of an Inn, The Stonefire Inn is where ye should be.  Ye\'ll find it just to the left of the entrance to Ironforge if ye be coming, or to the right if ye be going.  $B$BOh, and if yer going that way, then tell them to have a tankard ready for me.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5093,'Mailbox','Mailbox',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5094,'You can find a mailbox right o\'er by The Stonefire Tavern.  It\'s just north of the gates of Ironforge.','You can find a mailbox right o\'er by The Stonefire Tavern.  It\'s just north of the gates of Ironforge.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5095,'Hunter','Hunter',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5096,'I overheard Regnus Thundergranite in the Hall of Arms bragging about a new trophy for his den the other day.  If yer looking for training from a skilled hunter, Regnus is the one to see.','I overheard Regnus Thundergranite in the Hall of Arms bragging about a new trophy for his den the other day.  If yer looking for training from a skilled hunter, Regnus is the one to see.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5097,'Mage','Mage',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5098,'That wee wizardly lass, Bink, over in the Hall of Mysteries would probably be able to help ye out with any magical needs you have.  \n\nThe Hall of Mysteries is just north of the gates of Ironforge.','That wee wizardly lass, Bink, over in the Hall of Mysteries would probably be able to help ye out with any magical needs you have.\n\nThe Hall of Mysteries is just north of the gates of Ironforge.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5099,'Well ye\'d be sure to find some training in the magical arts over in the Hall of Mysteries, north of the gates of Ironforge.  Juli Stormkettle can always be found there with her nose in a book.','Well ye\'d be sure to find some training in the magical arts over in the Hall of Mysteries, north of the gates of Ironforge.  Juli Stormkettle can always be found there with her nose in a book.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5100,'Priest','Priest',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5101,'Ah, Braenna Flintcrag.  She has magic hands, that one.  Braenna is the one to see about Priestly matters.  \n\nYe\'ll want to travel north from the gates of Ironforge to the Hall of Mysteries.  That\'s where ye\'ll find her.','Ah, Braenna Flintcrag.  She has magic hands, that one.  Braenna is the one to see about Priestly matters.  \n\nYe\'ll want to travel north from the gates of Ironforge to the Hall of Mysteries.  That\'s where ye\'ll find her.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5102,'Paladin','Paladin',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5103,'Brandur Ironhammer would be the one ye\'d want to see.  Ye can find him in the Hall of Mysteries north of the gates of Ironforge.','Brandur Ironhammer would be the one ye\'d want to see.  Ye can find him in the Hall of Mysteries north of the gates of Ironforge.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5104,'Ah, good ol\' Brandur Ironhammer.  There\'s no doubt he\'ll provide ye with the guidance ye seek, $glad : lass;.  Ye\'ll find him in the Hall of Mysteries north of the gates of Ironforge.','Ah, good ol\' Brandur Ironhammer.  There\'s no doubt he\'ll provide ye with the guidance ye seek, $glad : lass;.  Ye\'ll find him in the Hall of Mysteries north of the gates of Ironforge.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5105,'Rogue','Rogue',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5106,'Now why would ye be needing the services of one of those types?  We get enough trouble out of that rogue, Hulfdan Blackbeard, over in The Forlorn Cavern, do I need to be turning my eye to you as well?','Now why would ye be needing the services of one of those types?  We get enough trouble out of that rogue, Hulfdan Blackbeard, over in The Forlorn Cavern, do I need to be turning my eye to you as well?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5107,'All the roguish types hang out in The Forlorn Cavern, north of the gates of Ironforge.  I\'d wager ye\'ll find Fenthwick there, no doubt counting the coin of another cut purse.  I\'ll catch him one of these days!  \n\nIn the meantime I\'ll have my eye on you as well, $glad : lass;.','All the roguish types hang out in The Forlorn Cavern, north of the gates of Ironforge.  I\'d wager ye\'ll find Fenthwick there, no doubt counting the coin of another cut purse.  I\'ll catch him one of these days!  \n\nIn the meantime I\'ll have my eye on you as well, $glad : lass;.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5108,'Warlock','Warlock',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5109,'Where better to look for a dark and brooding lot, than the dark section of Ironforge, aptly named The Forlorn Cavern.  Thistleheart is sure to be found there, likely summoning some manner of vile creature to do his bidding.','Where better to look for a dark and brooding lot, than the dark section of Ironforge, aptly named The Forlorn Cavern.  Thistleheart is sure to be found there, likely summoning some manner of vile creature to do his bidding.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5110,'Warrior','Warrior',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5111,'Och! Ye seek training in the way of the warrior, do ye?  Kelstrum Stonebreaker will put ye through yer paces!  Just march yerself over to the Hall of Arms east of the gates of Ironforge. ','Och! Ye seek training in the way of the warrior, do ye?  Kelstrum Stonebreaker will put ye through yer paces!  Just march yerself over to the Hall of Arms east of the gates of Ironforge. ',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5112,'Profession Trainer','Profession Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5113,'Which profession trainer would ye be looking for?','Which profession trainer would ye be looking for?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5114,'Alchemy','Alchemy',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5115,'An Alchemy trainer is what you need?  Well, I just came from there, I did.  Ye\'ll find Ms. Berryfizz over in Tinker Town where the gnomes gather.','An Alchemy trainer is what you need?  Well, I just came from there, I did.  Ye\'ll find Ms. Berryfizz over in Tinker Town where the gnomes gather.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5116,'Yer looking for an Alchemy trainer are ye?  Just came from there, I did.  Ye\'ll find Ms. Berryfizz over in Tinker Town where the gnomes gather.  \n\n::sigh:: ...why o\' why didn\'t I take the blue potion.','Yer looking for an Alchemy trainer are ye?  Just came from there, I did.  Ye\'ll find Ms. Berryfizz over in Tinker Town where the gnomes gather.  \n\n::sigh:: ...why o\' why didn\'t I take the blue potion.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5117,'Blacksmithing','Blacksmithing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5118,'Ye\'ve come to the right place $glad : lass;!  People come here from all o\'er the world to train to be a blacksmith.  Ye\'ll find Bengus Deepforge hammering away at an anvil in the middle of our fine city by The Great Forge itself.','Ye\'ve come to the right place $glad : lass;!  People come here from all o\'er the world to train to be a blacksmith.  Ye\'ll find Bengus Deepforge hammering away at an anvil in the middle of our fine city by The Great Forge itself.',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(5119,'Cooking','Cooking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5120,'A Cooking trainer is it?  Well then, get yerself over to the Bronze Kettle on the northeastern side of The Great Forge.  Daryl Riknussun will teach ye to make a mighty fine dish that\'s sure to put the life back in ye!','A Cooking trainer is it?  Well then, get yerself over to the Bronze Kettle on the northeastern side of The Great Forge.  Daryl Riknussun will teach ye to make a mighty fine dish that\'s sure to put the life back in ye!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5121,'Enchanting','Enchanting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5122,'Ah, I believe Gimble Thistlefuzz is who ye\'ll be needing if yer looking to learn the Enchanter\'s profession.  Ye\'ll find Gimble in his shop, Thistlefuzz Arcanery, right by the Gryphon Master at The Great Forge.','Ah, I believe Gimble Thistlefuzz is who ye\'ll be needing if yer looking to learn the Enchanter\'s profession.  Ye\'ll find Gimble in his shop, Thistlefuzz Arcanery, right by the Gryphon Master at The Great Forge.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5123,'Engineering','Engineering',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5124,'The tinkerer\'s craft for you is it?  No doubt ye\'ll want to go see Springspindle Fizzlegear in Tinker Town.  \n\nJust head east from the gates of Ironforge, or follow the sound of the explosions.','The tinkerer\'s craft for you is it?  No doubt ye\'ll want to go see Springspindle Fizzlegear in Tinker Town.  \n\nJust head east from the gates of Ironforge, or follow the sound of the explosions.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5125,'First Aid','First Aid',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5126,'A valuable skill First Aid is.  Our resident trainer, Nissa Firestone, can show ye how it\'s done.  Look for her on the southern side of The Great Forge at the Ironforge Physician.','A valuable skill First Aid is.  Our resident trainer, Nissa Firestone, can show ye how it\'s done.  Look for her on the southern side of The Great Forge at the Ironforge Physician.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5127,'Fishing','Fishing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5128,'Grimnur Stonebrand will tell ye some whoppers about the one that got away, but he\'s still one o\' the best fishermen around.  He\'s got a shop set up in The Forlorn Cavern called the Traveling Fisherman.','Grimnur Stonebrand will tell ye some whoppers about the one that got away, but he\'s still one o\' the best fishermen around.  He\'s got a shop set up in The Forlorn Cavern called the Traveling Fisherman.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5129,'Herbalism','Herbalism',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5130,'Herbalism','Herbalism',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5131,'Flowers and seeds and such?  That would be Reyna Stonebranch\'s area of expertise.  Ye can find her tending to her plants over at the Ironforge Physician on the southern side of The Great Forge.','Flowers and seeds and such?  That would be Reyna Stonebranch\'s area of expertise.  Ye can find her tending to her plants over at the Ironforge Physician on the southern side of The Great Forge.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5132,'Oh, ye want to learn to pick some daisies do ye?  Ha!  I\'m just teasing ye $gladdie : lass;.  \n\nA fine profession it is, and Reyna Stonebranch can show ye how it\'s done.  She works at the Ironforge Physician on the southern side of The Great Forge.','Oh, ye want to learn to pick some daisies do ye?  Ha!  I\'m just teasing ye $gladdie : lass;.  \n\nA fine profession it is, and Reyna Stonebranch can show ye how it\'s done.  She works at the Ironforge Physician on the southern side of The Great Forge.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5133,'Leatherworking','Leatherworking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5135,'Fimble Finespindle has a shop set up on the northwest side of The Great Forge.  I wager he could show ye how to make some fine armor.','Fimble Finespindle has a shop set up on the northwest side of The Great Forge.  I wager he could show ye how to make some fine armor.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5136,'Lockpicking','Lockpicking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5137,'Durtham Greldon over in The Forlorn Cavern can teach ye the in\'s and out\'s of lockpicking.  Just don\'t be practicing any of those in\'s or out\'s here in Ironforge, if ye understand my meaning.','Durtham Greldon over in The Forlorn Cavern can teach ye the in\'s and out\'s of lockpicking.  Just don\'t be practicing any of those in\'s or out\'s here in Ironforge, if ye understand my meaning.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5138,'Mining','Mining',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5139,'Do we have Mining trainers here?  Where do ye think ye are!?  \n\nWhy you\'ll find one o\' the best miners in all Dun Morogh at Deepmountain Mining and Jewelcrafting on the northern side of The Great Forge.  There, Geofram Bouldertoe will show ye the true art of mining.','Do we have Mining trainers here?  Where do ye think ye are!?  \n\nWhy you\'ll find one o\' the best miners in all Dun Morogh at Deepmountain Mining and Jewelcrafting on the northern side of The Great Forge.  There, Geofram Bouldertoe will show ye the true art of mining.',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(5140,'Skinning','Skinning',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5141,'Balthus Stoneflayer is the one to see about Skinning.  If it can be skinned, he can teach ye how.  Just walk yerself over to Finespindle\'s Leather Goods on the northern side of The Great Forge.','Balthus Stoneflayer is the one to see about Skinning.  If it can be skinned, he can teach ye how.  Just walk yerself over to Finespindle\'s Leather Goods on the northern side of The Great Forge.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5142,'Survival','Survival',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5143,'Tresa Farmountain has seen her share of bad weather, but with her knowledge of Survival skills she\'s come through with her spirits high.  \n\nShe\'s over in The Military Ward south of the gates of Ironforge if you wish to speak with her.','Tresa Farmountain has seen her share of bad weather, but with her knowledge of Survival skills she\'s come through with her spirits high.  \n\nShe\'s over in The Military Ward south of the gates of Ironforge if you wish to speak with her.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5144,'Tailoring','Tailoring',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5145,'That Jormund Stonebrow has a knack for the needle, he does.  Should you be needing some training, then you\'ll find him at Stonebrow\'s Clothier on the northern side of The Great Forge.','That Jormund Stonebrow has a knack for the needle, he does.  Should you be needing some training, then you\'ll find him at Stonebrow\'s Clothier on the northern side of The Great Forge.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5146,'Tracking','Tracking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5147,'Tracking is it?  Then Denmul Farmountain is the one you should pay a visit to.  He\'ll teach ye the tricks of the trade like no other.  \n\nJust head south from the gates of Ironforge to The Military District to find him.','Tracking is it?  Then Denmul Farmountain is the one you should pay a visit to.  He\'ll teach ye the tricks of the trade like no other.  \n\nJust head south from the gates of Ironforge to The Military District to find him.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5148,'I will need to focus my energies onto this knife.  By doing so, I should catch some of the stronger psychic impressions associated with it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5149,'I... I\'ve seen enough I think... so very draining...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5150,'I have suffered, but now I can feel it slowly fading from me. I feel... free.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5151,'The Crystal Pylons of Un\'Goro are a mystery to all. To the few inhabitants here, they are a source of legend, with much speculation as to their purpose.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5152,'Examine the pylon.','Examine the pylon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5153,'The pylon seems to be transmitting data somewhere.$b$bA closer inspection of the pylon leads you to find a small table containing yellow, red, and green crystals arranged in what seems like a specific formation.$B$BA large blue circle of crystals is flanked on either side by a smaller circle of yellow crystals and another of green crystals.$B$BYou carefully take note of what you see, knowing that someone may be very interested in hearing about what you have found.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5154,'The pylon seems to be transmitting data somewhere.$b$bA closer inspection of the pylon leads you to find a small table containing yellow, red, and green crystals arranged in what seems like a specific formation.$B$BA large yellow circle of crystals is flanked on either side by a smaller circle of red crystals and another of green crystals.$B$BYou carefully take note of what you see, knowing that someone may be very interested in hearing about what you have found.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5155,'The pylon seems to be transmitting data somewhere.$b$bA closer inspection of the pylon leads you to find a small table containing red, blue, and green crystals arranged in what seems like a specific formation.$B$BA large red circle of crystals is flanked on either side by a smaller circle of blue crystals and another of green crystals.$B$BYou carefully take note of what you see, knowing that someone may be very interested in hearing about what you have found.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5156,'A-Me home! A-Me, good! Good A-Me. Home. Home. Home.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5157,'Bad, $n. $n, bad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5158,'$n, no hurt A-Me. A-Me, good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5159,'Danger. Danger! $n try hurt A-Me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5160,'A-Me, home. A-Me go home! $n, no stop A-Me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5161,'','Get this, $n off of me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5162,'','Help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5163,'','I need help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5164,'','$n attacking! Help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5166,'I want more ale!  Give me more ale!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5167,'That one\'s empty!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5168,'Ah, empty again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5169,'ALE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5170,'%s looks at you expectantly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5171,'','My name\'s J.D., and I really can\'t tell you much about how I got here, but what I can tell you is that this camp is my home now!$B$BI spend my time studying the strange crystals that can be found all over the crater.  You must have seen some on your way over here.  Say, did you happen to pick any up?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5172,'Ah, hits the spot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5173,'Sweet Elune, thanks for getting me out of that... thing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5175,'Come with me if you want to live.','Come with me if you want to live.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5176,'Burning Steppes - Tablet of the Seven','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(5177,'Transcribe the tablet.','Transcribe the tablet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5178,'The symbols on the tablet are carefully transcribed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5179,'Greetings, $c. For some, the hunter is a way of life, a chosen profession. For others, it is something of a pastime, a badge of courage, or a rite of passage depending on your tribe.$B$BFor me, race and profession mean nothing - it is the testing of your spirit and mind that I respect. For one to stand against the forces of nature and test all of their skills is the true mark of honor.$B$BIf you wish to test yourself and earn my respect, then speak to me more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5181,'You\'ve started down an honorable path, $n. My ancestors respect your willingness, but you will not have my approval until you have followed through with my tasks.$B$BYou know what you must do if you wish to prove yourself a hunter in spirit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5182,'I give you warm greetin\'s, $c, as does the Shattered Hand.$B$BDo not look so surprised, $n. There be shadows even on the highest perches of Orgrimmar--somethin\' must hide there. The Shattered Hand take that role willingly. Thrall, even in his good heart, acknowledge that the Hand be necessary to ensure orc and troll safety.$B$BBut you not here to talk \'bout my business, you here for somethin\' else.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5183,'Un\'Goro Crater be far to the south of Kalimdor. Beyond the Thousand Needles in Tanaris. Look for the large floating stones... they mark the entrance to the Crater. But be careful... it is no easy path. The raptors are not far from the entrance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5184,'Where is Un\'Goro Crater?','Where is Un\'Goro Crater?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5185,'','Thanks to you, we can now unlock the secrets of the crystals and the mysterious pylons, $n. If you need more information at any time, please come back and visit me again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5186,'Tell me more about the Eastern Crystal Pylon.','Tell me more about the Eastern Crystal Pylon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5187,'Who is this Lar\'korwi you spoke of?','Who is this Lar\'korwi you spoke of?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5188,'Tell me more about the Northern Crystal Pylon.','Tell me more about the Northern Crystal Pylon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5189,'The ravasaur here in Un\'Goro seem to be related to the raptors of the barrens - highly intelligent, volatile, and with a sense or code of conduct. The greatest of these that I have encountered is  Lar\'korwi. He is one of the most dangerous beasts I\'ve ever seen. In taurahe, Lar\'korwi means \"sharp claw,\" but that does not do him justice.$B$BDo not underestimate Lar\'korwi if you ever plan on hunting him, but I will help you in any way I can if you do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5190,'Tell me more about the Western Crystal Pylon.','Tell me more about the Western Crystal Pylon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5191,'I lost my Crystal Pylon User\'s Manual and need another one.','I lost my Crystal Pylon User\'s Manual and need another one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5192,'','The Eastern Pylon accepts blue, yellow, and green crystals.$B$BIt focuses on the energy that can be created using blue crystals as the main source of power. There are two possible effects: one provides bonus to spirit, and one that creates a damaging shield.$B$BCrystal Force requires blue and green crystals. This will provide you with an increase in spirit.$B$BCrystal Spire requires blue and yellow crystals. This will create a shield that does damage to attackers.\n\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5193,'','The Northern Pylon accepts yellow, red, and green crystals.$B$BThe focus is the energy that can be created using yellow crystals as the main source of power. There are two possible effects: one that will produce damage, and one that will negate damage. $B$BCrystal Charge requires red and yellow crystals. This will produce a large explosion, stunning your enemies.$B$BCrystal Restore requires yellow and green crystals. This will provide you with a healing aura.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5194,'','The Western Pylon accepts red, green, and blue crystals.$B$BThe Pylon focuses on the energy that can be created using red crystals as the main source of power. There are two possible effects: one that increases your protection from damage, and one that weakens an enemy\'s defenses.$B$BCrystal Ward requires red and green crystals. This will provide you with an increase to armor.$B$BCrystal Yield requires blue and red crystals. This can lower the armor of a specific target.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5195,'','Sure thing, $n. Here\'s another for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5196,'You see the faint outline of a humanoid figure inside the pod; you now know that this is indeed the location you need to be at.  While you think you will eventually be able to open the pod, it remains tighly shut even to your most forceful attempts to open it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5197,'%s attacks a new target!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5198,'You make perfect little hat, $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5199,'Ograbisi needs new hat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5200,'What manner of filth dares enter my chambers!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5201,'Ah, just in time for your cleansing, $r. I shall wax the impurities from your soul.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5202,'Is that you, my dear Tobias???','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5203,'Perhaps Ograbisi will use your head as a tiny little hat when I\'m through with you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5204,'','These once beautiful woods suffer under a terrible curse!  Corrupting forces twist the life here into shadows of their former selves.  If you are not an agent of this corruption, then perhaps you can aid me in reclaiming Felwood!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(5205,'Let\'s get a move on. My gear should be in the storage area up this way...','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(5206,'','\"Taurahe?\"$B$BThe tauren druid looks at you expectantly, but it is clear you cannot verbally communicate with her.  Undaunted, she points to herself and smiles.  She points at you and smiles once more.  She finally motions several times down the path to the south.$B$BPerhaps she is indicating that there is a druid you can speak to further down the road?\n',6,274,0,0,0,0,0,0,1,0,0,0,26124),
(5207,'Check that cell, $n. If someone is alive in there, we need to get them out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5208,'','These once beautiful woods suffer under a terrible curse!  Corrupting forces twist the life here into shadows of their former selves.  If you are not an agent of this corruption, then perhaps you can aid me in reclaiming Felwood!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(5209,'','\"Darnassae?\"$B$BThe night elf druid looks at you expectantly, but it is clear you cannot verbally communicate with her.  Undaunted, she points to herself and smiles.  She points at you and smiles once more.  She finally motions several times down the path to the north.$B$BPerhaps she is indicating that there is a druid you can speak to further up the road?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(5210,'Thank you, $n! I\'m free!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5211,'HELP!!!!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(5212,'You\'re free, Dughal! Get out of here!','You\'re free, Dughal! Get out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5213,'Good work! We\'re almost there! This way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5214,'This is it, $n. My stuff should be in that room. Cover me, I\'m going in!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5215,'Ah, there it is!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5216,'Can you feel the power, $n??? It\'s time to ROCK!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5217,'Now we just have to free Tobias and we can get out of here. This way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5218,'Finally!! I can leave this dump.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5219,'Did Crest send you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5220,'Get out of here, Tobias, you\'re free!','Get out of here, Tobias, you\'re free!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5221,'Excellent work, $n. Let\'s find the exit. I think I know the way. Follow me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5222,'Open it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5223,'I never did like those two. Let\'s get moving.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5224,'Open it and be careful this time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5225,'That intolerant dirtbag finally got what was coming to him. Good riddance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5226,'%s spits on the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5227,'Alright, let\'s go.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5228,'Open it. We need to hurry up. I can smell those Dark Irons coming a mile away and I can tell you one thing, they\'re COMING!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5229,'He has to be in the last cell. Unless... they killed him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5230,'Get him out of there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5231,'We made it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5232,'Meet me at Maxwell\'s encampment. We\'ll go over the next stages of the plan there and figure out a way to decode my tablets without the decryption ring.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5233,'Grurk open soon. Then we split treasure.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5234,'Stupid box! Stupid, stupid box! OPEN! GRURK SAY YOU OPEN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5236,'Let me try! You too stupid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5237,'Grurk stupid? You try open box! Maybe you smart as gnome???','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5238,'Lumurk open this box easy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5239,'Box stupid. Lumurk sleepy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5240,'','There are plants in Felwood that may be saved from corruption when Cenarion plant salve is applied to them.  I know how to make the salve from several different kinds of items; based on your skill set, you may find that you have multiple options to assist me.$B$BYou will also need a Cenarion beacon for your work here; it is a device that allows you to see the taint and corruption of nature that the naked eye will miss.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5241,'','There are plants in Felwood that may be saved from corruption when Cenarion plant salve is applied to them.  I know how to make the salve from several different kinds of items; based on your skill set, you may find that you have multiple options to assist me.$B$BYou will also need a Cenarion beacon for your work here; it is a device that allows you to see the taint and corruption of nature that the naked eye will miss.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5243,'I need a Cenarion beacon.','I need a Cenarion beacon.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(5244,'','Here is a beacon for you, $n.  You must keep it in your possession if you are to find the corrupted items we will need.',25,0,0,0,0,0,0,1,1,0,0,0,26124),
(5245,'','Here is a beacon for you, $n.  You must keep it in your possession if you are to find the corrupted items we will need.',25,0,0,0,0,0,0,7,1,0,0,0,26124),
(5246,'The remains are covered in flies and maggots.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5247,'I summon you, Sha\'ni Proudtusk! ','I summon you, Sha\'ni Proudtusk! ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5248,'%s looks as though he\'s been stymied. He takes a few moments to recover from his wounds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5249,'Administering fists of fury on $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5250,'You better hold me back or $n is going to feel some prison house beatings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5251,'This is gonna leave a mark!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5252,'I bet you\'re sorry now, aren\'t you $n!?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5253,'You locked up the wrong Marshal, $n. Prepare to be destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5254,'The large shrine was built many years ago by the night elves that once inhabited this land.$B$BWhat secrets could it hold?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5255,'I need another sparkling stone.','I need another sparkling stone.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5256,'Continue...','Continue...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5257,'The door is open, Kharan. You are a free man.','The door is open, Kharan. You are a free man.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5258,'Where I come from, you get shanked for opening another inmate\'s cell door!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5259,'Doesn\'t anybody KNOCK anymore???!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5260,'I have destroyed my Azsharite weaponry! I need your assistance in defeating the triad of power.','I have destroyed my Azsharite weaponry! I need your assistance in defeating the triad of power.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5261,'I regret that I must fight this $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5262,'Hey!  What\'s gives?','Hey!  What\'s gives?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5263,'You\'ll pay for that!','You\'ll pay for that!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5264,'Oh, now I\'m pissed!','Oh, now I\'m pissed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5265,'No!','No!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5266,'Hey, my pockets were picked!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5267,'That\'s it!  No more beer until this mess is sorted out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5268,'Ha! Ha! Ha! Thank you for freeing me, fools. Now let me repay you by charring the flesh from your bones.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5269,'','We showed that one!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5270,'The secrets hidden within the Pylons of Un\'Goro Crater are now yours. Visit the Pylons at any time to access their power and gain useful resources.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5271,'You can\'t hide from us.  Prepare to burn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5274,'Welcome to Tanaris, $n. How can I be of service to you today? You don\'t look like a blacksmith to me, but I know how looks can be deceiving.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5275,'','Uh oh!  I\'m out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5281,'I\'m getting out of here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5283,'%s begins to summon a lava spawn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5284,'I do not enjoy conversation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5285,'','Oh, no! We\'ve run out of time. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5286,'%s cries out an alarm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5287,'','Now, let\'s see... If I am correct, then... Hmmm...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5288,'','Blue plus red... I predict...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5289,'','$n, that\'s it! I have finally figured it out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5290,'They are lost, $r. Librams written by the elven masters. Scattered across the world when the Scourge was unleashed upon Quel\'Thalas.$B$BNow we search for these librams. Search to find the secrets they hold - to restore power once had.$B$BI search for the ten written by Master Kariel Winthalus. Should you find a libram, allow me to absorb its magical properties and for you I shall craft an amalgamation of power... of course, all things come at some cost. You will find my cost to be high; but pay you shall.','',1,1,25,0,0,0,0,0,1,0,0,0,26124),
(5291,'I present to you the Libram of Rumination.','I present to you the Libram of Rumination.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5292,'Ah, so... you have found it.$B$B<Mathredis points to the book in your possession.>$B$BHave you collected the necessary components?$B$BThe manifestations listed in the libram, imbecile!','',1,6,5,0,0,0,0,0,1,0,0,0,26124),
(5293,'<Mathredis gazes intently at the libram.>$B$BYou come for an amalgamation? Have you done as the libram instructed?','',6,1,6,0,0,0,0,0,1,0,0,0,26124),
(5294,'Give me the arcana and I shall craft the amalgamation, mortal.','',25,1,0,0,0,0,0,0,1,0,0,0,26124),
(5295,'A rare find, indeed.$B$B<Mathredis nods.>$B$B If you wish to continue, I will need the components.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(5296,'Greed has led you back to me.$B$B<Mathredis laughs.>$B$BA wise Draenei once told me that it - greed - is the single quality that all of the races on this world share. I would have to agree.$B$BHave you collected the components listed within the libram?','',153,1,6,0,0,0,0,0,1,0,0,0,26124),
(5297,'Intruders in the Manufactory? My constructs will destroy you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5298,'May the Light protect you this day.','May the Light protect you this day.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5299,'I would like to train further in the ways of the Light.','I would like to train further in the ways of the Light.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5300,'Violence!  Property damage!  None shall pass!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5301,'You must leave the bar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5302,'You have outworn your welcome!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5303,'NO SERVICE!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5304,'What want from Raze??','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5305,'','Hello, $n. Should you require assistance in completing your mission, you have only to ask. My guardian, Raze, can assist you in defeating the shadowsilk poachers. Use this Staff of Command to command Raze in battle. He is trained to ONLY attack shadowsilk poachers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5306,'I need help in defeating the shadowsilk poachers.','I need help in defeating the shadowsilk poachers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5307,'Drink up!  There\'s more where that came from!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5308,'Enjoy!  You won\'t find better ale anywhere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5309,'Have you tried the Dark Iron Ale?  It\'s the best!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5310,'Try the boar!  It\'s my new recipe!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5311,'Thank you for clearing out those foolish senators.  Now prepare to meet your doom at the hands of Ragnaros\' most powerful servant.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5312,'Your efforts are utterly pointless, fools!  You will never be able to defeat me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5313,'They were just getting in the way anyways.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5314,'Ha! You can\'t even begin to imagine the futility of your efforts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5315,'Is that the best you can do?  Do you really expect that you could defeat someone as awe inspiring as me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5316,'Auction House','Auction House',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5317,'Where is the Auction House?  Why it\'s right by the gates of Ironforge as you enter our fine city.  Ye\'ll find it just across from The Vault.','Where is the Auction House?  Why it\'s right by the gates of Ironforge as you enter our fine city.  Ye\'ll find it just across from The Vault.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5318,'Anu therador mali $c.  Where can I guide you to?','Anu therador mali $c.  Where can I guide you to?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5319,'How may I aid you in your journey?','How may I aid you in your journey?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5320,'Do you require guidance to your destination?','Do you require guidance to your destination?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5321,'What direction can I point you in?','What direction can I point you in?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5324,'Can you help me with some directions?','Can you help me with some directions?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5325,'Of all the wondrous places within Darnassus, which would you have me direct you to?','Of all the wondrous places within Darnassus, which would you have me direct you to?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5326,'The Bank','The Bank',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5328,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5329,'You may find storage for your worldly goods at the bank of Darnassus, which lies in the center of our wondrous city.','You may find storage for your worldly goods at the bank of Darnassus, which lies in the center of our wondrous city.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5330,'Hippogryph Master','Hippogryph Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5331,'Vesprystus\' hippogryphs will bear you swiftly to your destination.  Seek him out in Rut\'theran Village, through the portal which lies in the western section of Darnassus.','Vesprystus\' hippogryphs will bear you swiftly to your destination.  Seek him out in Rut\'theran Village, through the portal which lies in the western section of Darnassus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5332,'Guild Master & Vendor','Guild Master & Vendor',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5333,'If you desire to form a fellowship then it is the guild master, Lysheana, that you must see.  You will find her in the Craftsmen\'s Terrace in the northeastern section of Darnassus.','If you desire to form a fellowship then it is the guild master, Lysheana, that you must see.  You will find her in the Craftsmen\'s Terrace in the northeastern section of Darnassus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5334,'The Inn','The Inn',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5335,'Though I find the cool grass which covers Teldrassil as good a bed as any, the beds which Saelienne keeps at the Inn in Craftsman\'s Terrace are quite suitable for those with a taste for luxury.','Though I find the cool grass which covers Teldrassil as good a bed as any, the beds which Saelienne keeps at the Inn in Craftsman\'s Terrace are quite suitable for those with a taste for luxury.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5336,'Mailbox','Mailbox',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5337,'There is a mailbox outside of the Bank which you\'ll find in the center of Darnassus.','There is a mailbox outside of the Bank which you\'ll find in the center of Darnassus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5338,'A class trainer','A class trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5339,'Here in Darnassus you will find skilled trainers who have perfected the skills of their chosen class through ages of training and dedication.  I will guide you to one who can become your mentor, you have but to name your chosen path.','Here in Darnassus you will find skilled trainers who have perfected the skills of their chosen class through ages of training and dedication.  I will guide you to one who can become your mentor, you have but to name your chosen path.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5340,'Hunter','Hunter',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5341,'You are fortunate to have come to Darnassus where you can find such an accomplished Hunter as Jocaste among our trainers.  I encourage you to visit her over in the Cenarion Enclave and seek her tutelage.','You are fortunate to have come to Darnassus where you can find such an accomplished Hunter as Jocaste among our trainers.  I encourage you to visit her over in the Cenarion Enclave and seek her tutelage.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5342,'Druid','Druid',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5343,'In grizzly times a druid can be a dear friend to those around them.  Ask any of the druids in the Cenarion Enclave and they will tell you the same.','In grizzly times a druid can be a dear friend to those around them.  Ask any of the druids in the Cenarion Enclave and they will tell you the same.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5344,'Priest','Priest',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5345,'The Temple of the Moon is home to the priests of Elune.  There you will find Jandria and Lariia, who will provide you with further guidance in the path of priesthood.','The Temple of the Moon is home to the priests of Elune.  There you will find Jandria and Lariia, who will provide you with further guidance in the path of priesthood.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5346,'The power of Elune compels you!  The power of Elune compels you!  \n\nGo now!  Seek out Jandria in the central hall of the Temple of the Moon in the southern section of Darnassus!','The power of Elune compels you!  The power of Elune compels you!  \n\nGo now!  Seek out Jandria in the central hall of the Temple of the Moon in the southern section of Darnassus!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5347,'Rogue','Rogue',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5348,'It is Syurna that you seek if you are to follow the rogue\'s path.  She dwells in the Cenarion Enclave down the spiraling path within the western most tree.','It is Syurna that you seek if you are to follow the rogue\'s path.  She dwells in the Cenarion Enclave down the spiraling path within the western most tree.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5349,'There are those that attempt to follow the path of the Rogue, but only the night elves are truly embraced by the night.  If you seek to walk the shaded path then find Syurna in the Cenarion Enclave.','There are those that attempt to follow the path of the Rogue, but only the night elves are truly embraced by the night.  If you seek to walk the shaded path then find Syurna in the Cenarion Enclave.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5350,'Warrior','Warrior',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5351,'You will find Sildinair at the Warrior\'s Terrace among the guards, her keen eyes scanning the forest for enemies that might dare to enter our fair city.  ','You will find Sildinair at the Warrior\'s Terrace among the guards, her keen eyes scanning the forest for enemies that might dare to enter our fair city.  ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5352,'Profession Trainer','Profession Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5353,'Here among the craftsmen of Darnassus, there is a millennium of knowledge for the benefit of your chosen craft.  Now tell me, which craft do you find the most intriguing?','Here among the craftsmen of Darnassus, there is a millennium of knowledge for the benefit of your chosen craft.  Now tell me, which craft do you find the most intriguing?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5354,'Alchemy','Alchemy',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5355,'If you truly have the desire to learn this profession, then I would point you in the direction of Ainethil, a skilled alchemist at the Craftsmen\'s Terrace in northern Darnassus.','If you truly have the desire to learn this profession, then I would point you in the direction of Ainethil, a skilled alchemist at the Craftsmen\'s Terrace in northern Darnassus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5356,'Cooking','Cooking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5357,'Alegorn is a masterful chef who has had centuries with which to perfect his cooking.  You should consider yourself blessed should he decide to teach you.  If you believe you are worthy, you can find him in the Craftsmen\'s Terrace.','Alegorn is a masterful chef who has had centuries with which to perfect his cooking.  You should consider yourself blessed should he decide to teach you.  If you believe you are worthy, you can find him in the Craftsmen\'s Terrace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5358,'The dishes that Alegorn whips up are to die for.  He\'s always busy preparing new delicacies over in the Craftsman\'s Terrace.  Be sure to try his Cenarion Green recipe if he has any left.  \n\nNow, if you don\'t mind, I must investigate this rash of missing deer. ','The dishes that Alegorn whips up are to die for.  He\'s always busy preparing new delicacies over in the Craftsman\'s Terrace.  Be sure to try his Cenarion Green recipe if he has any left.  \n\nNow, if you don\'t mind, I must investigate this rash of missing deer. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5360,'Class Trainer','Class Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5362,'Alchemy','Alchemy',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5363,'Enchanting','Enchanting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5364,'Because the blade can never be too sharp nor the armor too tough a talented enchanter will always be needed.  Such an enchanter is Taladan, who can show you how to properly weave enchantments to improve your weapons and armor.  Seek him out in the Craftsmen\'s Terrace.','Because the blade can never be too sharp nor the armor too tough a talented enchanter will always be needed.  Such an enchanter is Taladan, who can show you how to properly weave enchantments to improve your weapons and armor.  Seek him out in the Craftsmen\'s Terrace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5365,'Och!  Ye should be careful what ye get enchanted $glad : lass;.  I had me mug enchanted so it wouldn\'t spill a drop, but now I can\'t drink from it!  Such a tragedy.  \n\nYou be sure to heed me advice when ye see Gimble.  He\'ll be in his shop right by the Gryphon Master at The Great Forge.','Och!  Ye should be careful what ye get enchanted $glad : lass;.  I had me mug enchanted so it wouldn\'t spill a drop, but now I can\'t drink from it!  Such a tragedy.  \n\nYou be sure to heed me advice when ye see Gimble.  He\'ll be in his shop right by the Gryphon Master at The Great Forge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5366,'First Aid','First Aid',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5367,'When you have not a healer to tend to your wounds, the knowledge of First Aid can be a lifesaver.  I would consult Dannelor over at the Craftsmen\'s Terrace for instruction on this skill.','When you have not a healer to tend to your wounds, the knowledge of First Aid can be a lifesaver.  I would consult Dannelor over at the Craftsmen\'s Terrace for instruction on this skill.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5368,'Fishing','Fishing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5369,'A time consuming, yet rewarding skill.  Speak with Astaia in the Tradesman\'s Terrace and maybe you\'ll learn something useful.','A time consuming, yet rewarding skill.  Speak with Astaia in the Tradesman\'s Terrace and maybe you\'ll learn something useful.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5370,'Herbalism','Herbalism',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5371,'Leatherworking','Leatherworking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5372,'The skill with which Telonis crafts armor is beyond compare.  You should be grateful that he does not charge more for the knowledge he passes to others.  Go now and seek him out in the Craftsmen\'s Terrace in the northeast section of Darnassus.','The skill with which Telonis crafts armor is beyond compare.  You should be grateful that he does not charge more for the knowledge he passes to others.  Go now and seek him out in the Craftsmen\'s Terrace in the northeast section of Darnassus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5373,'We plant the vegetables.  Our vegetables are eaten by the rabbit.  The rabbit is devoured by the wolf.  The wolf is slain by us.  We take the meat and hide from the wolf\'s corpse.  It\'s that Magic Circle of life, or whatever you call it.  \n\nNow go see Telonis in the Cenarion Enclave to get started and let me return to my duties.','We plant the vegetables.  Our vegetables are eaten by the rabbit.  The rabbit is devoured by the wolf.  The wolf is slain by us.  We take the meat and hide from the wolf\'s corpse.  It\'s that Magic Circle of life, or whatever you call it.  \n\nNow go see Telonis in the Cenarion Enclave to get started and let me return to my duties.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5374,'Lockpicking','Lockpicking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5375,'\"A skill for those who wish to overcome obstacles.\"  I believe that is how Faelyssa describes her skill set.  \n\nIf you believe as she does then find your way to the Cenarion Enclave in the northern section of Darnassus where she conducts her class.','\"A skill for those who wish to overcome obstacles.\"  I believe that is how Faelyssa describes her skill set. \n\nIf you believe as she does then find your way to the Cenarion Enclave in the northern section of Darnassus where she conducts her class.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5376,'Skinning','Skinning',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5377,'In death, the animals of the world bestow both life and protection unto us.  If you feel that you can offer the appropriate respect for their sacrifice, then the skinner\'s profession may suit you.  Speak with Eladriel in the Craftsmen\'s Terrace in northern Darnassus to learn more.','In death, the animals of the world bestow both life and protection unto us.  If you feel that you can offer the appropriate respect for their sacrifice, then the skinner\'s profession may suit you.  Speak with Eladriel in the Craftsman\'s Terrace in northern Darnassus to learn more.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5378,'Survival','Survival',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5379,'If you need help surviving in the woods, you had best not stray far from the city walls.  However if you do plan to stray, then you had better have a talk with Malygen in the Cenarion Enclave so that you might learn to set a proper campfire.','If you need help surviving in the woods, you had best not stray far from the city walls.  However if you do plan to stray, then you had better have a talk with Malygen in the Cenarion Enclave so that you might learn to set a proper campfire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5380,'Tailoring','Tailoring',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5381,'You would certainly be looking for Me\'Lynn if you have any hope of learning to be a tailor.  She resides at the Craftsmen\'s Terrace in northeastern Darnassus.','You would certainly be looking for Me\'Lynn if you have any hope of learning to be a tailor.  She resides at the Craftsmen\'s Terrace in northeastern Darnassus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5382,'Tracking','Tracking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5383,'Not a creature in the forest can elude Corand, such is his skill at tracking.  You would do well to listen to his teachings if you wish to be even half as successful.  \n\nI will relieve you of the burden of tracking him and mark his location on your map, there in the Cenarion Enclave.','Not a creature in the forest can elude Corand, such is his skill at tracking.  You would do well to listen to his teachings if you wish to be even half as successful.  \n\nI will relieve you of the burden of tracking him and mark his location on your map, there in the Cenarion Enclave.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5384,'What plants are in Felwood that might be corrupted?','What plants are in Felwood that might be corrupted?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(5385,'','I have observed four different kinds of plants that have been affected by the corruption: the songflower, the windblossom, the whipper root, and the night dragon plant.  The songflower and windblossom are common plants in Felwood, while the whipper root and night dragon are seen less frequently.  All are a vital part of Felwood\'s ecosystem.',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(5386,'','I have observed four different kinds of plants that have been affected by the corruption: the songflower, the windblossom, the whipper root, and the night dragon plant.  The songflower and windblossom are common plants in Felwood, while the whipper root and night dragon are seen less frequently.  All are a vital part of Felwood\'s ecosystem.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5387,'This was the site of a great battle.  Many great battles.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5388,'Speak with Regthar.  He is wise and can help you find what you seek.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5389,'HALT!  There were...reports...of a...disturbance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5390,'We...are...investigating.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5391,'Well, I\'m not sure how far I\'ll make it in this state... I\'m feeling kind of faint...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5392,'If I look woozy, slap me.  If I pass out, use the canteen.  Now let\'s go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5393,'%s faints and falls onto the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5394,'Uuuuuuggggghhhhh....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5395,'I\'m not feeling so well...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5396,'The heat... I can\'t take it...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5397,'Maybe... you could carry me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5398,'Yes, I must go on.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5399,'I am feeling a little better now, thank you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5400,'Where... Where am I?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5401,'How am I feeling? Quite soaked, thank you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5402,'Spraggle! I didn\'t think I\'d make it back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5403,'Oh... I\'m feeling faint...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5404,'Ugh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5405,'','Ringo! You\'re okay!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5406,'','Ringo? Wake up! Don\'t worry, I\'ll take care of you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5407,'Ach! Thank you so much, $n! I\'m free! Finally!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5408,'You take care of yourself! I\'m gettin\' out o\' here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5409,'Hello? ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5410,'Um... sorry to bother you, but could I see Goodsteel\'s ledger again... if you\'re not using it.','Um... sorry to bother you, but could I see Goodsteel\'s ledger again... if you\'re not using it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5411,'Yeah, no problem, $n! Sorry... thought you were done with it already.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5412,'','You\'ll have to give me a moment, $c, the naga are attacking us right now. I\'ll speak to you as soon as the attack is done!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5413,'Tell me a story, John.','Tell me a story, John.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5414,'Aright *hic*... Say, you look familiar *hic*. Have I ever told you about the time me and Windsor fought off thir, er... a thous... a million orcs?$B$BOh settle down friend, this is a good one!','',6,5,0,0,0,0,0,0,1,0,0,0,26124),
(5415,'Let me grab the popped corn kernels, sire.','Let me grab the popped corn kernels, sire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5416,'I present to you the Libram of Constitution.','I present to you the Libram of Constitution.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5417,'I present to you the Libram of Tenacity.','I present to you the Libram of Tenacity.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5418,'I present to you the Libram of Resilience.','I present to you the Libram of Resilience.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5419,'I present to you the Libram of Voracity.','I present to you the Libram of Voracity.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5420,'%s bursts into the hatchery once you apply the lure to the crystal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5421,'The Orgrimmar Auction House is in the Valley of Strength.  Look for it on the east side next to Boomstick Imports.','The Orgrimmar Auction House is in the Valley of Strength.  Look for it on the east side next to Boomstick Imports.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5422,'Your voice is hoarse from yelling huh?  Find the Orgrimmar Auction House in the Valley of Strength.','Your voice is hoarse from yelling huh?  Find the Orgrimmar Auction House in the Valley of Strength.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5423,'Auction House','Auction House',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5424,'Welcome to the Bank of Darnassus. We offer financial accounts and safety deposit boxes for valuable items. Do you already have an account with us $g sir : ma\'am;?','Welcome to the Bank of Darnassus. We offer financial accounts and safety deposit boxes for valuable items. Do you already have an account with us $g sir : ma\'am;?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5425,'Amazing, aren\'t they? All these artifacts and remains.$B$BI\'m not sure what I\'m more impressed by, their size, or the stories that go along with them. There\'s so much to study and learn. And the connections we can make...$B$BDid you know rumor has it that many races have the same heritage as Night elves?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5426,'Image dissipation in sixty seconds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5427,'%s begins to cast a powerful spell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5428,'%s transforms the items into a totem.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5429,'','%s is visibly shaken by the death of Emperor Thaurissan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5430,'Emperor Thaurissan does not wish to be disturbed! Turn back now or face your doom, weak mortals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5431,'Hail to the king, baby!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5432,'','Hello there, my name is Petra.  To my right is my kodo, Dadanga.  We\'re with Marshal Expeditions - been so for a few years now, ever since Dadanga was a babe.$B$BIf you have any lit torches or any open sources of flame, I\'d like to ask you to keep them stashed if you could.  Dadanga dislikes smoke.',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(5433,'For the love of all that is holy and dear, please tell me that you\'ve come to deliver us from this forsaken land.  Though I\'m with Marshal Expeditions, I would give you the gold teeth from my mouth to climb inside your backpack and leave this place.','',20,0,0,0,0,0,0,0,1,0,0,0,26124),
(5434,'','Oh, hello there!  I\'m Hol\'anyee, the chief scientist and biologist of Marshal Expeditions.  My brother and I, along with our companions, travel Azeroth exploring the wild and untamed majesty.  It is exciting... but, um... I think we got ourselves into a little too much excitement this time!',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(5435,'Hello stranger, and welcome to the untamed majesty of Un\'Goro Crater!$B$BMy name is Williden Marshal.  My sister, our companions, and I make up Marshal Expeditions - scientists and explorers of Azeroth\'s wild and great unknown.','',3,1,0,0,0,0,0,0,1,0,0,0,26124),
(5436,'','This is where things get interesting.  My plan is to follow the mountail wall, keeping it to our left.  That way, we won\'t get lost in the jungle and we\'ll cut down on the hostiles.  You ready?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5437,'','Here\'s the eastern mountain wall!  I\'m cutting towards the south now; try and keep up.  We\'re not out of the thick of it yet!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5439,'','Here\'s the path out of Un\'Goro!  We made it!  All we have to worry about is the Tanaris desert now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5440,'','Here it is -- the Tanaris desert.  Funny how an inhospitable place like this looks better than a lush jungle once you\'ve been trapped in it forever.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5441,'You have been sentenced to death for crimes against the Dark Iron nation!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5442,'The Sons of Thaurissan shall watch you perish in the Ring of the Law!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5443,'Unleash the fury and let it be done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5444,'Haha! I bet you thought you were done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5445,'But your real punishment lies ahead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5446,'Good riddance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5447,'Incredible! Amazing! I don\'t even know what this means!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5448,'Look at these samples! What does it mean? What does it mean? I\'m going to need time, time to look at all this information. And I\'ll need more information. Information I can\'t get... damn! Think, Laris, think!$B$BWhat are you going to do? What?!$B$BThere has to be a solution!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5449,'There must be someplace on Azeroth that we can find oozes uncorrupted by the Scourge or anything else. But where?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5450,'Is there a difference between ooze and slime?','Is there a difference between ooze and slime?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5451,'No, not that I can tell. It seems to be mostly based on region. Some races have labled them slimes, some oozes. It seems to be preference mostly.$B$BEvery time I\'ve encountered ooze, sludge, or slime they have basically been the same creatures. The differences seem to be based on their environment, which is why we need a pure sample.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5452,'What do you mean by \"pure?\"','What do you mean by \"pure?\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5453,'A pure sample would be one that\'s uncorrupted by unintentional influences. We need to find the creatures in the most basic, normal environment we can.$B$BThat means somewhere devoid of civilization or the effects of the dominant races of Azeroth. Someplace... untouched.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5454,'Are there any areas you can think of that would be so untouched?','Are there any areas you can think of that would be so untouched?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5455,'It\'ll definitely not be anywhere in the Eastern Kingdoms, that\'s for sure.$B$BIt\'ll have to be somwhere on Kalimdor, but still far enough away from the Horde and other races. Someplace unaffected by the Sundering--that means no where near the Night elves\' civilization either.$B$BI would guess it\'d be someplace protected also... like a valley, or a crater. I don\'t know. I\'m just guessing now. I\'m sorry I couldn\'t help you more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5456,'I bid you welcome, $c. Rare do we have visitors down to these levels of the Apothecarium... unless of course there\'s something someone wants... or needs.$B$B<Chemist Coely laughs.>$B$BHow can I help you today, hmm?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5457,'I will crush you into little tiny pieces!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5458,'%s groans.','%s groans.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5459,'%s weeps pitifully.','%s weeps pitifully.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5460,'%s begs to be put out of his misery.','%s begs to be put out of her misery.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5461,'','Well, we\'re not getting any closer just standing here.  Come on Dadanga!  Yah!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5462,'','Step lively Dadanga!  Come on, girl!  The quicker we get through here, the happier we\'ll both be.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(5463,'$n, you have disturbed me from my rest!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5464,'Leave me now in peace. I must rest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5465,'Who dares awaken Aquementas?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5466,'','Get away from my kodo, you freak of nature!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5467,'','Dadanga!  Attack!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5468,'','That has to be the biggest $n I have ever seen... and it\'s coming right for us!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5469,'','Watch out for the $n!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5470,'The gathering and knowledge of herbs is a specialty of Firodren Mooncaller.  Seek him out in the Temple Gardens in the southwestern area of Darnassus.','The gathering and knowledge of herbs is a specialty of Firodren Mooncaller.  Seek him out in the Temple Gardens in the southwestern area of Darnassus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5471,'A budding herbalist are we?  Then you should visit with Firodren Mooncaller over in the Temple Gardens.  He may have some tricks of the trade to impart with you.','A budding herbalist are we?  Then you should visit with Firodren Mooncaller over in the Temple Gardens.  He may have some tricks of the trade to impart with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5472,'Why you would want to leave these sunny shores and crystal blue waters I have no idea. It\'s like paradise down here. But don\'t tell my brother Zapetta that, he\'s bitter enough already about getting stuck up there in Tirisfal all day long. This Zeppelin here drops off at Orgrimmar so you shouldn\'t have to worry about having to listen to him whine. But if you are in Tirisfal anytime soon, heed my warning and don\'t get him started.','Why you would want to leave these sunny shores and crystal blue waters I have no idea. It\'s like paradise down here. But don\'t tell my brother Zapetta that, he\'s bitter enough already about getting stuck up there in Tirisfal all day long. This Zeppelin here drops off at Orgrimmar so you shouldn\'t have to worry about having to listen to him whine. But if you are in Tirisfal anytime soon, heed my warning and don\'t get him started.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5473,'I sense the taint of corruption upon this $n. Help me destroy it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5474,'This creature suffers from the effects of the fel... We must end its misery.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5475,'This $n has been driven mad from the corruption! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5476,'The herbs found in nature can be a powerful ally when combined with respect.  You will want to seek out Bena at her alchemy shop on the middle rise to further your training.','The herbs found in nature can be a powerful ally when combined with respect.  You will want to seek out Bena at her alchemy shop on the middle rise to further your training.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5477,'You may shed yourself of your worldly possessions at the Thunder Bluff Bank on the lower rise.','You may shed yourself of your worldly possessions at the Thunder Bluff Bank on the lower rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5478,'Metal, as with all things, should be used in balance with nature.  Karn Stonehoof has a smithy setup near the pond on the lower rise.  Seek out his wisdom.','Metal, as with all things, should be used in balance with nature.  Karn Stonehoof has a smithy setup near the pond on the lower rise.  Seek out his wisdom.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5479,'You honor the spirits of the animals you must slay by not letting them go to waste.  Aska Mistrunner will show you how.  She has a kitchen on the high rise.','You honor the spirits of the animals you must slay by not letting them go to waste.  Aska Mistrunner will show you how.  She has a kitchen on the high rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5480,'Greetings honored one.  Turak Runetotem and the other druids have been expecting you at the Hall of Elders on Elder Rise.','Greetings honored one.  Turak Runetotem and the other druids have been expecting you at the Hall of Elders on Elder Rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5481,'The profession of Enchanting displays the cycle of destruction and creation that is at the heart of nature.  Teg at the Dawnstrider Enchanters on the middle rise will show you how.','The profession of Enchanting displays the cycle of destruction and creation that is at the heart of nature.  Teg at the Dawnstrider Enchanters on the middle rise will show you how.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5482,'Life is a struggle, and the saying that which does not kill you makes you stronger is not always true.  Sometimes wounds act slowly, which is why we have bandages.  Pand Stonebinder of the Spirit Rise can teach you the art of First Aid.','Life is a struggle, and the saying that which does not kill you makes you stronger is not always true.  Sometimes wounds act slowly, which is why we have bandages.  Pand Stonebinder of the Spirit Rise can teach you the art of First Aid.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5483,'Kah Mistrunner at Mountaintop Bait & Tackle on the high rise will show you the way to find inner peace and serenity while fishing for your next meal.','Kah Mistrunner at Mountaintop Bait & Tackle on the high rise will show you the way to find inner peace and serenity while fishing for your next meal.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5484,'A fellowship of kindred spirits can be a powerful force.  Krumn will help you to achieve this.  You will find him at the Thunder Bluff Civic Information center on the lower rise next to the lifts.','A fellowship of kindred spirits can be a powerful force.  Krumn will help you to achieve this.  You will find him at the Thunder Bluff Civic Information center on the lower rise next to the lifts.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5485,'Nature provides all that we need.  Speak to Komin Winterhoof at Holistic Herbalism on the middle rise.','Nature provides all that we need.  Speak to Komin Winterhoof at Holistic Herbalism on the middle rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5486,'Any friend of the animals is a friend of mine.  The Hunter\'s Hall is what you seek.  It sits atop the Hunter Rise.','Any friend of the animals is a friend of mine.  The Hunter\'s Hall is what you seek.  It sits atop the Hunter Rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5487,'There is a symmetry in the idea of the hide of your enemy providing you with protection.  To further your leatherworking skills look for Una inside the Thunder Bluff Armorers on the middle rise.','There is a symmetry in the idea of the hide of your enemy providing you with protection.  To further your leatherworking skills look for Una inside the Thunder Bluff Armorers on the middle rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5488,'Very sad to think what has befallen those poor undead souls.  You can find Archmage Shymm reflecting near the Pools of Vision under the Spirit Rise.','Very sad to think what has befallen those poor undead souls.  You can find Archmage Shymm reflecting near the Pools of Vision under the Spirit Rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5489,'The Earth Mother holds many secrets and Brek Stonehoof can help you to discover some of them.  You will find him on the lower rise at Stonehoof Geology.','The Earth Mother holds many secrets and Brek Stonehoof can help you to discover some of them.  You will find him on the lower rise at Stonehoof Geology.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5490,'Despite their tragedy the Undead have come all this way to aid us.  I only hope that we can be as helpful to them.  Seek out Father Cobb near the Pools of Vision under the Spirit Rise.','Despite their tragedy the Undead have come all this way to aid us.  I only hope that we can be as helpful to them.  Seek out Father Cobb near the Pools of Vision under the Spirit Rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5491,'The Earth Mother calls and you answer.  You will find the Hall of Spirits on the Spirit Rise.','The Earth Mother calls and you answer.  You will find the Hall of Spirits on the Spirit Rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5492,'Every scrap used makes us less wasteful and brings us closer to the Earth Mother.  Mooranta can show you the way.  Seek her just outside the Thunder Bluff Armorers on the middle rise.','Every scrap used makes us less wasteful and brings us closer to the Earth Mother.  Mooranta can show you the way.  Seek her just outside the Thunder Bluff Armorers on the middle rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5493,'You, in harmony with nature, and only your skills to survive.  This is the way that the Earth Mother intended it to be.  You will want to find Bale on the Hunter Rise.','You, in harmony with nature, and only your skills to survive.  This is the way that the Earth Mother intended it to be.  You will want to find Bale on the Hunter Rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5494,'Clothing the tribe is as important a job as any other.  You should look for Tepa inside Thunder Bluff Armorers.  She has a natural way with the needle.','Clothing the tribe is as important a job as any other.  You should look for Tepa inside Thunder Bluff Armorers.  She has a natural way with the needle.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5495,'Ah, the true sign of the hunter!  To stalk one\'s prey in the never-ending game of life.  Look to Drayl on the Hunter Rise for your answers.','Ah, the true sign of the hunter!  To stalk one\'s prey in the never-ending game of life.  Look to Drayl on the Hunter Rise for your answers.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5496,'Strong of body and spirit.  There can be no stronger combination!  Find your destiny with Sark Ragetotem in the Hunter\'s Hall.','Strong of body and spirit.  There can be no stronger combination!  Find your destiny with Sark Ragetotem in the Hunter\'s Hall.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5497,'Ah, to soar with the great birds of the sky.  Seek out Tal at the top of the Winder Rider Roost.  He will steer you toward where you\'re going.','Ah, to soar with the great birds of the sky.  Seek out Tal at the top of the Winder Rider Roost.  He will steer you toward where you\'re going.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5498,'Look for Innkeeper Pala in the building just south of the Thunder Bluff Bank on the lower rise.','Look for Innkeeper Pala in the building just south of the Thunder Bluff Bank on the lower rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5499,'Innkeeper Pala will help you rest your body and spirit.  You can find her in the building just south of the bank on the lower rise.','Innkeeper Pala will help you rest your body and spirit.  You can find her in the building just south of the bank on the lower rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5500,'You can find a mailbox just outside the Thunder Bluff Bank on the lower rise.','You can find a mailbox just outside the Thunder Bluff Bank on the lower rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5501,'I believe I noticed a new shipment of mail being delivered not too long ago.  You\'ll find the mailbox just outside the Thunder Bluff Bank on the lower rise.','I believe I noticed a new shipment of mail being delivered not too long ago.  You\'ll find the mailbox just outside the Thunder Bluff Bank on the lower rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5502,'It is found on the lowest section of Thunder Bluff.  Search near the bank.  It is not far from there.','It is found on the lowest section of Thunder Bluff.  Search near the bank.  It is not far from there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5503,'The auction house can be found on the central spire of Thunder Bluff.  Search near the bottom of the Windrider\'s Tower. May your ancestors watch over you.','The auction house can be found on the central spire of Thunder Bluff.  Search near the bottom of the Windrider\'s Tower. May your ancestors watch over you.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5504,'This may come as a shock to you, but business hasn\'t been all that good as of late...','',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(5505,'','I welcome you to Theramore, $n.$B$BI apologize for being abrupt and not having a lot of time to exchange pleasantries, but my city must come first. Too many things threaten our way of life and the sanctity of the Alliance. I must stay ever vigilant against forces outside of our control if I\'m to ensure my people remain safe and happy.$B$BPerhaps we\'ll have more time to speak later.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5506,'','Hendel is in our custody now, $n, thanks to you.$B$BAlthough the questioning goes slowly, I assure you, he will tell us everything he knows.$B$BFor now, please be patient. I will contact you immediately if we have need of your assistance.$B$BUntil then, please, enjoy Theramore and I invite you to stay for as long as you like within our city\'s walls as a friend of the Alliance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5508,'','If you\'re ready, then Dadanga and I are ready.  Let\'s go!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5509,'Yes $gbrother : sister;, how may I assist you?','Yes $gbrother : sister;, how may I assist you?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5511,'','All right then... I know the way to and from Gadgetzan.  What I need for you to do is to keep the beasts off of us.  I\'ve trained Dadanga how to defend herself pretty well, but we can\'t handle the overgrown madness out there for long.  Let me know when you\'re ready to go, $n.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5512,'What do you think of Dadanga?\n','What do you think of Dadanga?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5513,'Inn','Inn',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5514,'Mailbox','Mailbox',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5515,'Auction House','Auction House',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5516,'Just outside the city\'s main gate is a signpost.  It will point you toward the western zeppelin tower.','Just outside the city\'s main gate is a signpost.  It will point you toward the western zeppelin tower.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5517,'Look for the eastern Zeppelin Landing Tower outside of the city to the southeast.','Look for the eastern Zeppelin Landing Tower outside of the city to the southeast.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5518,'Zeppelin Master','Zeppelin Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5519,'My brother and I have dedicated ourselves to Sylvanas. She is our beacon of light when times were darkest. We sacrifice ourselves day in and day out to ensure our kind overcome the destiny that\'s chosen us.$B$BWe will not remain weak. We will take that which is owed to us. We will return tenfold, the pain that was done to us. And we shall do so with smiles on our faces.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5520,'Lady Sylvanas has ordered the investigation of some of the natural phenomena of Azeroth. She feels there is something great to be learned from its secretive past.$B$BI know not how she learned such things, but I trust her completely, so I will do my best.$B$BI am currently investigating slimes, oozes and such. The creatures all seem to be similar in make up, but greatly affected by their environment.$B$BI could use your help in gathering samples of the creatures..','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5521,'','%s becomes enraged from seeing a cub die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5522,'Three cheers for $n -- Admiral o\' the Bloodsail Bucaneer Navy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5523,'Hip hip... arrrrr...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5524,'<Volcor doesn\'t look at you at all as you get close to him. He seems to be concentrating on keeping his bandages from falling off. After a moment, he looks up at you, a little startled.>$B$BOh, sorry, $c. Now\'s not a good time. I hope you understand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5525,'Well, the way I see it, $n, we have two options to consider for leaving this cave.$B$BWe can make our way stealthfully--I use the cloak you\'ve given me, and you\'d be left to your own devices, or, and this may be a harder option considering my wounds, we fight our way out back to back.$B$BI\'ll let you decide since you know your strengths better than I.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5526,'Greetings $g lad : lass;, if you\'re looking for the best deals you\'ll find outside of Ironforge itself, then you\'ve come to the right place.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5527,'','Have you seen the befouled water elementals in our lake, $n? It is a sorry sight, but I do not know where they are coming from.$B$BYour name has been mentioned in conversations past, perhaps you could help me with this problem.$B$BThe first thing we must learn is who is in control of these elementals.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5528,'Hi there.  I\'m Gubber Blump.','',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(5529,'Gubber, I don\'t know how to fish.\n','Gubber, I don\'t know how to fish.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5530,'Gubber, I don\'t have a fishing pole.','Gubber, I don\'t have a fishing pole.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5531,'Fishing is real easy.  Just take a pole with a line on it, maybe put some bait on it, and cast it out in the water.  Sure enough, them fish will start biting.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5532,'I got some extras with me; if you pay me back what I paid for them, you can have one.  I got some bait too.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5533,'...pan fried, deep fried, and stir fried...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5534,'Do you need assistance?','Do you need assistance?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5535,'','Watch my back, this could get real messy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5536,'The liquids and mixtures all bubble and spasm as you approach. Next to the equipment lies a large pair of tongs that look as though they would be adequate for dropping in samples of ooze.$B$BThere is safety gear present, but it appears to be dusty and well-ignored.$B$BYou don\'t think touching anything would be wise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5537,'','The plans are in there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5538,'Intruders are destroying our eggs!  Stop!!','Intruders are destroying our eggs!  Stop!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5539,'SQUAWK!! *cough* *cough* I need to quit smoking!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5540,'Ask Kibler about the treasure! SQUAWK!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5541,'Bijou lost! SQUAWK! *cough*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5542,'Bijou knows where treasures are hidden.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5543,'Opus wants some Cuergo\'s Gold... with worm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5544,'They all go to the Spire but none ever come back... just like Bijou.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5545,'Kibler is being investigated by G.E.T.A.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5546,'Dragons controlling orcs!? SQUAWK!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5547,'I am here!  Now, puny little worms, you will pay for your intrusion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5548,'%s lets loose a guttural growl as her body collapses. A horrifying howl can be heard echoing through the halls of Blackrock Spire. Something is very, very angry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5549,'Hello, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5550,'Don\'t mind Skuerto, $n. He doesn\'t mean to be rude, he\'s just terribly busy. While we wait for him to finish scouting, why don\'t we work on something more productive?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5551,'','Hi $n!$B$BI have to work on my devices, but eventually... I\'m going to need someone to get me dragon eggs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5552,'','The Burning Steppes is a dangerous place, but scholars like me will do almost anything to advance our knowledge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5553,'I\'m going back to the Rookery, Tinkee.  I need an Eggscilliscope!','I\'m going back to the Rookery, Tinkee.  I need an Eggscilliscope!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5554,'May your skills in smelting dark iron serve you well, $n.  But do not let your knowledge corrupt you... as it corrupted us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5555,'At last - one among you is worthy of my knowledge. Worry not - I have probed your thoughts, no harm will come to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5556,'Listen carefully, for the lord of Blackrock will surely destroy you, should you not be prepared.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5557,'','Kar Aman, $n. You look to be a strong $c--you would do well to mind yourself in this area. Touching things you know nothing about, or showing disrespect to your elders is just cause for punishment.$B$BYou may not respect me or my companions, but you will learn to respect our power if you prove foolish enough.$B$BNow, enough with the pleasantries, was there something I can do for you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5558,'','Ah, a fellow warlock who has proven $ghis:her; worth to some degree.$B$BI am pleased to meet your acquaintance. My name is Menara Voidrender... and not without just cause.$B$BYou seem powerful and well-learned enough that other tools... more powerful tools... would be welcome and not foolishly imparted. If this is true, then speak to me further. If not, well then, you know your way  back to the docks and off into the ocean.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5559,'Humans are usually vunerable on their left side between the 4th and 5th rib. Let\'s practice striking at this area like so...','Humans are usually vunerable on their left side between the 4th and 5th rib. Let\'s practice striking at this area like so...',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(5560,'Now, you try.','Now, you try.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(5561,'Night Elves like to stand off on one leg while casting. Strike at that leg like so...','Night Elves like to stand off on one leg while casting. Strike at that leg like so...',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(5562,'Dwarves will spin around leaving their backs open for attack at times. Take this opportunity to strike like this...','Dwarves will spin around leaving their backs open for attack at times. Take this opportunity to strike like this...',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(5563,'Gnomes can be hard to hit due to their size. However, they have a pinchant for dancing around and thrusting their hips. When they do this, strike at them like so...','Gnomes can be hard to hit due to their size. However, they have a pinchant for dancing around and thrusting their hips. When they do this, strike at them like so...',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(5564,'Good. You are showing promise to join the elite ranks. Now, more practice.','Good. You are showing promise to join the elite ranks. Now, more practice.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(5565,'%s begins to regain its strength!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5566,'%s is nearly at full strength!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5567,'%s regains its power and breaks free of its bonds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5568,'In decades past - of now ancient wars and conflicts - our kind was driven to the brink of extinction. Much we have endured, $r.$B$BThe onslaught of the Burning Legion. The Demon Soul. The Aspects divided. The ascension of Deathwing. The enslavement of our Queen, Alexstrasza, by the Dragonmaw.$B$BThrough it all, we have been the unshakable will of the dragons - the undaunted force that has fought to represent our waning existence in this world.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(5569,'Your kind?','Your kind?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5570,'Indeed. I stand before you in a form that you can comprehend, mortal. Surely, you could not bear to stand in the presence of the dragon known as Vaelastrasz.$B$B<Vaelan laughs.>$B$BShall I continue?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(5571,'Please.','Please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5572,'Perhaps I should tell you why I am here.$B$BDo you know of the Aspect, Deathwing? Or of his progeny, Nefarian and Onyxia?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(5573,'No, Vaelan, I do not.\n','No, Vaelan, I do not.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5574,'Deathwing, or Neltharion as he was once known, was the Aspect that embodied the strength of the world - granted almost limitless power over this mortal realm by the Titan shaper known as Khaz\'goroth: Forger of the world.$B$BThrough treachery and deceit, the foul one convinced the four other Aspects to imbue an item, known as the Demon Soul, with their powers - greatly weakening them, forcing a division among the once great Aspects. \n','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(5575,'Demon Soul?','Demon Soul?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5576,'Indeed. The item was ultimately destroyed and Deathwing nearly slain by the combined and renewed power of the four remaining Aspects. Where Deathwing is now is unknown. What we do know, however, is that one of his progeny, Nefarian, rules this citadel and wishes to continue where his father left off.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(5577,'Where he left off?','Where he left off?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5578,'Before his banishment, Deathwing was attempting to create impure offspring. Half breeds that would not only be immune to the innate natural powers and abilities of their Aspects but also under the complete control of Deathwing.$B$BIt seems that where his father failed, Nefarian may have succeeded - at least partially.$B$BIt was Ysera, Aspect of Dreams, who saw the abominations and forced us to act. If these \'Chromatic\' dragonkin exist, they must be destroyed.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(5579,'Why not destroy them with the combined might of the Aspects?','Why not destroy them with the combined might of the Aspects?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5580,'It is not our way, nor would it be possible. Nefarian is guarded by ancient wards, as old as the Aspects themselves. It is what prevents me from entering the inner sanctum of this citadel. The dark magic prevents any of the other flight to enter without being ordained... unless.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(5581,'Unless?','Unless?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5582,'It is possible for one, not of dragon kind, to obtain the Adorned Seal of Ascension and pass through the protected barrier. While possession of such an item would surely destroy me, perhaps you could utilize it and lower the barrier.\n','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(5583,'I am willing to try but I will require instruction.','I am willing to try but I will require instruction.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5584,'You must find one amongst the wretch in the lower portion of this citadel that has attained an Unadorned Seal of Ascension. It is a great honor for one of the lesser beings to obtain this item, as it is the first step in gaining access to the upper citadel and becoming one of Nefarian\'s elite guardsmen - the Blackhand legion. Find such an item and return it to me so that I may examine its properties. I will know how to proceed once my inspection of the seal is complete.','',25,1,1,0,0,0,0,0,1,0,0,0,26124),
(5585,'I will do my best, Vaelan.','I will do my best, Vaelan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5586,'Be warned, mortal, it is exceptionally rare that one of the lesser clans in this citadel would hold such an item. Your search could take decades. I recommend you destroy these beasts without impunity.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(5587,'It will be done.','It will be done.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5588,'Do not bring it any closer, mortal. I can sense the evil coursing through the seal from where I stand.$B$BGive me a moment to inspect the item - hold it firmly.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(5589,'As you wish, Vaelan.','As you wish, Vaelan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5590,'%s is surrounded by a barrier of anti-magic.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5591,'I have discerned the path that you must take. Are you prepared?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(5592,'Begone, mortal. You are not worthy of my knowledge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5593,'Ah, $r, you have returned!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5594,'%s\'s will falters.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5595,'At last, I have caught up with you, Nefarian. Surely you did not think you would escape the might of the other Aspects?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5596,'Enough! Playtime is over!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5597,'I would like to train.','I would like to train.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5598,'What do you mean you don\'t know how to use an axe? ','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5599,'It\'s small but it does it\'s job if you know what you are doing. Let me show you just the right places to hit.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5600,'Take tha blade like dis, den throw. Just flip joo wrist mon, one twirl and joo got jooself lunch.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5601,'','We have used bows since before even my father\'s time. They are solid and sure and take down our foes swiftly. I see no reason to use the guns that the goblins and tauren seem so fond of.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5602,'','Come to learn have ya, mon?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5603,'','The fists of an Orc are already a powerful weapon, so why not add blades or studs of solid steel. Now the fists I use to tame the wolves of the plains I can also use to shatter the armor of my foes.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5604,'Joo may tink this ma walkin stick mon. Dat\'s jus wat I want joo to tink.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5605,'A bow is a great ting ma friend. Joo jus have to take care of it, and it will take care of joo.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5606,'Dis ain\'t no game mon. Joo want to use da axe, joo got to say da line. Say it wif me... \"Say hello, to ma little friend.\"','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5607,'Never had much use for a bow, but these rifles the goblins make are very handy when hunting. Still can\'t get used to the smell though.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5608,'$n, I\'ve come to find out how rampant the effects of Fel Moss are throughout Darkshore. The remainaing corruption in Teldrassil and our surrounding lands really concerns the druids of the Cenarian Circle, and all Night elves.$B$BIt is my goal to find out why this is still happening and put it to an end.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5609,'It may look simple, a large stick with a huge weight on the end. But when swung with the might of a tauren behind it, this stick can break stone walls.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5610,'Just a stick? Want me to show you what \'just a stick\' can do?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5611,'','%s begins to summon in a Black Iron Dreadweaver!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5612,'','%s summons a Black Iron Dreadweaver to his aid!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(5613,'','%s begins to summon in a Black Iron Veteran!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5614,'','%s summons a Black Iron Veteran to his aid!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(5615,'I\'m flattered, but really I\'m not interested... What?  You want to know where to learn enchanting?  Oh, how embarrassing!  Well, you should...  I\'m sure you could... go see, um...  Taladan!  Yes, see Taladan over in the Craftsmen\'s Terrace!','I\'m flattered, but really I\'m not interested... What?  You want to know where to learn enchanting?  Oh, how embarrassing!  Well, you should...  I\'m sure you could... go see, um...  Taladan!  Yes, see Taladan over in the Craftsmen\'s Terrace!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5616,'What the... nobody cleanses a furbolg in MY camp!  Face the wrath of Xabraxxis!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5617,'%s is lured out by the sweet scent of the purified food.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5618,'%s begins to greedily devour the food.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5619,'VanCleef pay big for you heads!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5621,'Nuttin\' be \'fraid of. Come.','Nuttin\' be \'fraid of. Come.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(5622,'We\'re doomed!','We\'re doomed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5623,'The only weapon I know of that has no use other than killing someone. Not something, but someone. These blades were invented to end the lives of men. Beautiful aren\'t they?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5624,'','Keep your foes at bay and carve them into cutlets at the same time. The only problem is that the long shaft keeps me from getting blood on my hands.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5625,'','Swift and sure. Cut a tendon here, slit an artery there. I can show you how to turn any knife into a perfect killing machine.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5626,'The long reload takes some getting used to, but nothing else is better for starting off a fight. ','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5627,'Welcome to my shop, $c. What is it the Goodstitch brothers can do for you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5628,'Ah, one of my favorite customers. You look to be of a warlock of some power, $n. I am pleased to meet you. If there is anything I can do for you, please, just ask.$B$BMy brother and I feel that it will be your kind who lead us into the next great era. One with such power... such control... it\'s only a matter of time before the Legion itself bends to your will.$B$BI am but a little envious.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5629,'What of the Alliance, Rend?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5630,'They have freed the human, Windsor, sire. It will not be long until Onyxia is uncovered.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5631,'Then we must not waste anymore time. Are the chromatic dragonflight ready?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5632,'The next clutch is due to hatch soon, sire. We will be ready to launch the attacks by week\'s end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5633,'','I can teach you both the finesse of a short blade and the bone shattering cleaving power of a two handed behemoth. Or we can get crazy and I can teach you both, could come in handy for when the situation changes on ya.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5634,'','Sure I can teach you the fine art of wielding a polearm, but it\'s gonna cost you.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5635,'Excellent... it would appear as if the meddlesome insects have arrived just in time to feed my legion. Welcome, mortals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5636,'Sure it takes longer to reload but this baby will punch a hole the size of my fist through any set of armor.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5637,'','I\'ve seen farmers with staves hold off trained soldiers. Do not ever underestimate the power and skill it takes to wield one of these properly.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5638,'','If you think I\'m good, you should see my husband fight.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5639,'%s turns to face you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5640,'Let not even a drop of their blood remain upon the arena floor, my children. Feast on their souls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5641,'A good hammer in yer hands makes the world feel safer. Like ye can face even the mightiest of foes with a large hunk of solid metal gripped in yer fists.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5642,'I\'ll teach ye to chop down yer foes like saplings in the forest.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5643,'','Hound on the horizon moving at thirty feet per second. The only question is, right or left eye. That\'s right $g lad : lass;, I\'m that good.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5644,'','See this? This is my boom stick! Dwarven top of the line. That\'s right, this sweet baby was made in Ironforge, Khaz Modan. Retails for about one hundred and nine gold, ninety five copper. It\'s got a walnut stock, thorium steel, and a hair trigger.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5645,'Och I love a good brawl, but sometimes yer foe has a skull thicker than a Thorium heat shield. Times like that ye need a wee bit o assistance. ','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5646,'The chromatic flight shall deal with these intruders. Let us talk of more pressing matters.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5647,'Modernization is the key. With a crank and a lever you can fire this baby with the power of an ogre pulling a normal bow.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5648,'Lets go, $n. I am ready to reach Whitereach Post.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5649,'','Zoom, zing, and BAM! He may have had a huge two handed cleaver made from a boat anchor but after a few well placed slices from my dinner knife, he was the one going crash!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5650,'','A hidden blade up the sleeve can mean the difference between you laying dead in the alley, and your opponent laying face down in his own blood.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5651,'The slow blade penetrates the shield.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5652,'The secret to the knife is to keep it hidden until the moment you strike.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5653,'','So, you wish to learn more about our elven weaponry? Let your first lesson begin.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5654,'Now this looks familiar. If we keep heading east, I think we can... Ahh! Wyvern on the attack!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5655,'You want a weapon that acts as an extension of your very fist? Yes, I believe I can show you something.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5656,'I do not know this Eye of the Tiger some speak of, but I can show you how to use the claws of the tiger.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5657,'','Many think the staff an inferior weapon. I challenge any who think so to prove their strength against my staff. ',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5658,'The skill of the bow is a great asset to anyone, not just the hunter. You can strike swiftly, silently, and before your prey can blink... they are dead.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5659,'','Ah, $r... I possess great knowledge a\' da world and how ta create charms a\' great power. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5660,'Many times my blades have felled my target before they even drew near. The secret is in the flick of your wrist.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5661,'','Mau\'ari know why you seek her out...$B$BBring me da E\'ko you find in the world, an\' I can transform it for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5662,'How do I use the Cache of Mau\'ari?','How do I use the Cache of Mau\'ari?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5663,'Sssplendid... Then let us watch as my children tear these mortals to pieces.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5664,'Use the freezing breath, imbecile!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5665,'Foolsss... Kill the one in the dress!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5666,'Inconceivable!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5667,'Do not force my hand, children! I shall use your hides to line my boots.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5668,'Your efforts will prove fruitless. None shall stand in our way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5669,'I promise you an eternity of dung clean up duty for that failure!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5670,'Curse you, mortal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5671,'Concentrate your attacks upon the healer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5672,'Sire, let me join the fray! I shall tear their spines out with my bare hands!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5673,'Impossible!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5674,'Flee while you still have a chance, mortals. You will pray for a swift death should I enter the arena.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5675,'You will learn of the sanctuary only death can offer...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5676,'It appears as if I will have to step in and take care of you myself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5677,'I will tear off your limbs and use them to beat you into submission!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5678,'Defilers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5679,'I can stand no more of this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5680,'Vincent!  You and your pathetic ilk will find no more success in routing my sons and I than those beggardly remnants of the Kirin Tor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5681,'If you will not serve my Master with your sword and knowledge of his enemies...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5682,'Your moldering remains will serve ME as a testament to what happens when one is foolish enough to trespass in my domain!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5683,'Thanks a bunch... I can find my way back to Whitereach Post from here. Be sure to talk with Motega Firemane; perhaps you can keep him from sending me home.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5684,'%s spies you tampering with the camp\'s fruit stores and attacks you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5685,'%s emerges from the log hovel and catches you tampering with the grain stores!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5686,'','More and more of Kalimdor is turning into the twisted landscape to our left, and the critters who dwell within are NOT friendly.  Watch your step.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5687,'','Blast... ogres.  I forgot about these buffoons.  There\'s no easy way around them, so expect plenty of fighting.  Look sharp!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(5688,'','Come on Dadanga!  March girl, march!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(5689,'','There it is -- Gadgetzan!  We\'re in the home stretch now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5690,'','We\'re finally here, thanks to you $n!  Without your help, we would have been some over-grown lizard\'s lunch!',10,0,0,0,0,0,0,0,1,0,0,0,26124),
(5691,'','It was quite a haul, but now I can load up on supplies for the trip back into the Crater.  I should be able to unload some of this exotic cargo as well.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5692,'','Look out, incoming!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5693,'','I\'m gonna need some help with this $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5694,'Yeah yeah, I know Dadanga dislikes smoke.  From the smell of it though, seems like Dadanga also dislikes bathing.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5695,'Have you seen Petra or Dadanga around?\n','Have you seen Petra or Dadanga around?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5696,'They took off for Gadgetzan a while ago to bring us back some supplies.  Frankly, I would have given at least four of my fingers to have had the chance to crawl inside one of Dadanga\'s packs in order to leave this forsaken place.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5698,'What is E\'ko?','What is E\'ko?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5699,'','Da Cache of Mau\'ari holds great secrets... The shards used ta make it are reflective, and you can use its shiny surface ta siphon power from other tings and den reflect it onto yourself.$B$BKeeping da charm in your inventory lets you collect e\'ko, da spiritual power from the beasts you fight. Once you find e\'ko, you bring it ta Mau\'ari.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5700,'','E\'ko is da power dat each creatures possesses. Da charm I made for ya allows you ta capture it in a physical manifestation.$B$BI know an incantation dat can transform da e\'ko you find, and turn it into juju.$B$BYou can den take the Cache of Mau\'ari, an\' use it ta reflect da power of da juju onto yourself.$B$BC\'mon, give it a try. Bring da e\'ko ta Mau\'ari an\' we have some fun.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5701,'','As nice as Gadgetzan is compared to Un\'Goro, I have some good folks counting on us to bring them some supplies.  If you\'re ready to go, then so are Dadanga and I.  Let\'s mount up!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5702,'','The Tanaris desert is littered with gigantic bones just like this one to my right.  I\'d hate to have ever ran across that thing.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5703,'','Whoa, whoa, hold up Dadanga girl.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5704,'%s snorts deeply as she comes to a halt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5705,'','This doesn\'t look... right.  Look at how alien the desert is!  Going through here might be a terrible mistake.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5706,'','What the... what are those things crawling at us?  We... we have incoming!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5707,'','That was not what I would call \'escort friendly\'.  I will find a way to go around these things.  Let\'s move to the south, toward that rock.  Maybe we can wedge through it and still avoid the ogres.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5708,'','This will work -- keep heading through this gap.  The path to Un\'Goro is due west of here once we round these infernal bugs.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5709,'THIS CANNOT BE!!! Rend, deal with these insects.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5710,'The mortals have fallen! The new age of the Blackrock legion is at hand!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5711,'%s is knocked off his drake!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5712,'WOOT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5713,'That will surely save me some work.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5714,'I want those boots! Nobody touch that corpse!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5715,'Consider yourself lucky, mortal. At least your corpse is still somewhat presentable.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5716,'Do not consume the entire corpse just yet, children! Save room for dessert!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5717,'Served!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5718,'You actually believed that you stood a chance?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5719,'The Blackhand legion shall wear your skin as fashion accessories!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5720,'The Warchief shall make quick work of you, mortals. Prepare yourselves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5721,'%s paces back and forth in anticipation of the battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5722,'With pleasure...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5723,'Good day to ye $g lad : lass;. Can I be of service?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5724,'Here for training eh? Just began my training meself, but I would be glad ta teach ye what I can.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5725,'Ye learn fast $g lad : lass;, much faster than I can keep up with. If ye want ta continue yer training, I suggest ye see my teacher. His name\'s Rotgath, Rotgath Stonebeard and ye\'ll find him in Ironforge at The Great Forge.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5726,'Taste in my power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5727,'Eh? I don\'t have time ta chat, my da\' wants me ta finish this order fer him.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5728,'Ye\'ve got a little skill on ye. Enough to learn ye a few things I wager. Let\'s see what I can teach ye, shall we?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5729,'Ye know more than I do, that\'s a certainty. Tell ye what though, go talk with me da\'. He\'ll want ye ta prove yerself, but he is a fine teacher indeed. His name\'s Rotgath, and ye\'ll find him near the anvils workin steel for ol\' Bengus.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5730,'Well my friend, ye have more skill than I do. Why don\'t ye go find me old friend Rotgath Stonebeard. He stayed in Ironforge when I left to join Jaina\'s army. I\'m sure he\'ll be able ta teach ye somethin, or at least know someone who can. If he\'s still around, I\'m sure he\'ll be at The Great Forge.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5731,'Where should I look for E\'ko?','Where should I look for E\'ko?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5732,'','The creatures in Winterspring are a good place ta start.$B$BHoweva\', der may also be other places you can look...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5733,'Of course I can help you with training. I\'m just a journeyman myself, but I\'m sure there\'s something I can show you.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5734,'I don\'t admit this lightly, but you are a far better smith than I am. If you want to learn more than my meager teachings then I suggest you seek out a Dwarf named Therum Deepforge in Stormwind. You will find him in the Dwarven District.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5735,'I\'m sorry, I\'m a bit busy right now making horseshoes for Verner Osgood in Lakeshire. ','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5736,'Do I look like I have the time to spend jawin?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5737,'You\'re not bad, but let me show you a few tricks you might find handy. ','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5738,'A far better blacksmith than I am, that\'s for sure. Though I\'ll deny it if you tell anyone I said that. You should go speak with Therum Deepforge. If anyone can teach you more, it\'s him.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5739,'I hear one comment about waterfowl, and you will be eating through a tube.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5740,'Just swinging a hammer at an anvil doesn\'t make you a smith. Give me that and let me teach you something before you embarrass us all.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5741,'Not bad. Go talk with Snarl, he just moved to Orgrimmar to study under Saru. Look for him in the Warrior district near Saru\'s smithy. Oh and he\'ll test you, so you better be as ready as you think you are.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5742,'Snarl calls me simple because I am too slow. I just want to do the job right, and that takes time.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5743,'I can show you what you wish to know, but you must be patient. Take your time to work the steel and feel the way it shapes beneath your hammer. When you become one with the steel, then you will understand.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5744,'You learn quickly, that is not a bad thing. Just be sure to do the job right, as long as it takes to do so. Now, I fear I must send you to Snarl to learn more. Learn what he can teach, but do not listen to his angry words. He gets that way when Saru\'s daughters laugh at him.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5745,'I listen and I listen but I don\'t hear these spirits that Karn speaks of. ','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5746,'Karn says we need to listen to the spirits of the forge and of the steel, that they will guide us. I hear nothing but a ringing in my ears. Here, take a hammer and let us try to hear the spirits together.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5747,'I guess the spirits like you better than me, I still have not heard their call but you seem to have gathered their lessons well. Go speak to Karn, he will be excited to see one who hears them as he does.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5748,'All is not lost! Battle these beasts without fear. Your wounds I shall heal, bones I shall mend. Be renewed, heroes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5749,'','Your interruption is costing me valuable time, this had better be good.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5750,'','Ah yes, another who will stoke the fires and forge the weapons of war. Of course I will teach you how.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5751,'','You have learned well my child. Go to the Undercity, find a smith named James Van Brunt. He will be able to teach you much that I cannot. I understand he spends his time near the Warriors training hall, forging their weapons and armor.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5752,'I hope to one day forge weapons and armor from the bones of my enemies.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5753,'You are not trying to kill the anvil with your hammer, you are trying to create a weapon to kill your foes with. Let me show you what you are doing wrong.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5754,'You have learned much, more than I can teach. Go to James Van Brunt, he will teach you what I cannot.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5755,'You must continue! Their resolve is weakening. Drink from my power and be renewed once again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5756,'What is Juju?','What is Juju?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5757,'','E\'ko is da unfocused form of the supernatural power, and Juju is da concentrated essence. By using a stong incantation, I can transform da E\'ko into Juju.  Once it becomes Juju, you can den use the Cache of Mau\'ari ta reflect da powers onto yourself.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5758,'I lost the Cache of Mau\'ari. What can I do?','I lost the Cache of Mau\'ari. What can I do?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5759,'','Ah am very surprised that one wit such a careless nature has gotten dis far...$B$BYah, you may have another charm, but Mau\'ari is very displeased wit your actions!$B$BGo, now. ',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(5760,'You have come too far to fail. Stand back, mortals.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5761,'You will suffer in this defeat, Nefarian!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5762,'This should do it! At least it better do it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5763,'Holy Krakle! The temperature is 428,000 degrees Kraklenheit! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5764,'The temperature is 9280 degrees Kraklenheit! That\'s HOT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5765,'The temperature is 564 degrees Kraklenheit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5766,'The temperature is 122 degrees Kraklenheit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5767,'The temperature is 12 degrees Kraklenheit. How exciting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5768,'Um, Ozzie... that doesn\'t look very safe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5769,'OZZIE!!!! OH NO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5770,'Didn\'t even leave his boots behind...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5771,'%s shrugs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5772,'%s collapses but the broken body rises again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5773,'The living are here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5774,'Ow!  OK, I\'ll get back to work, $n!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5775,'When I get all shaken up, hear me shout...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5776,'Vaelastrasz, when this world belongs to the black flight, your flight shall know its end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5777,'But for now, your death will have to suffice...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5778,'You merely destroy an image, fool. I shall hunt you until the end of days.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5779,'Aye, it appears as if ye have learned quite a bit, I\'m impressed. But do ye know how many I have that seek to be my apprentice? Tell ye what, do a small task fer me and I\'ll take ye on.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5780,'Ye have some skill about ye with hammer and anvil, but not enough. Go speak to Dane Lindgren, he\'ll get ye ready to learn what I have to teach ye.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5781,'I said ye had the blood of a blacksmith in ye, and I was right. Go to Ironforge, to The Great Forge, and find yerself a Dwarven smith by the name of Bengus Deepforge. My teacher, and one of the greatest smiths I\'ve ever known.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5783,'The life of a smith is not an easy one, but it puts steel in yer bones and fire in yer heart. My da\' was a smith, my grandfather before him in the forges beneath Grim Batol. And now my son follows in our footsteps, that boy makes me proud.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5784,'Sorry $g lad : lass;, ye aren\'t quite up to the challenge of learning from me. Go see my son Groum, it would make his day to get a new apprentice.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5785,'Yer skill is not without merit, but I need to put one last test to ye before I take ye on.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5786,'Aye, I would love ta teach ye a thing or two about smithing. Grab an apron and a hammer and let\'s see what we can accomplish shall we?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5787,'A fast learner is what ye are, and a good smith to boot. I would sign off on yer work any day of the week. But I sense ye still have some learnin in ye. Go talk to Bengus Deepforge, he\'s a hard taskmaster but he\'s also one of the best.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5788,'%s lets out a shrill cry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5789,'','Don\'t come out of the shadows like that. Next time give a girl some warning. ',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5790,'','Ever since the shadows claimed Duskwood I haven\'t been able to sleep. I am kept awake by the ghostly sounds of screaming on the breeze. It sounds almost like lambs screaming, and they won\'t stop.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5791,'','Hmm, your work is allright but it\'s nowhere near the quality I look for in a student. Go talk with Smith Argus in Goldshire, I\'m sure he can teach you some basics. Then when you\'re done, come on back to me and I\'ll give you a little test to make sure you are ready.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5792,'','Yeah, I\'ve heard through the grapevine that I might be seeing you sooner or later. But I don\'t just take on anyone, I need to make sure you have what it takes first. You willing to take my little test and find out?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5793,'','You do fine work, but it\'s a bit rough around the edges. Don\'t worry about it, it will come with practice. Speaking of which, how about we see what you\'ve been working on?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5794,'','Now I\'m the one who feels rough around the edges, I honestly don\'t think there\'s anything left I can teach you. But you know who can? Bengus Deepforge in Ironforge, now there\'s a dwarf that knows his steel. Go look him up in The Great Forge of Ironforge, see if he\'s up to having a new trainee under him.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5795,'If I prove myself to Saru he will have no choice but to let me fight for one of his daughters. Then we will see who is sneering.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5796,'Stay away from Sumi and Tumi. They are....spoken for.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5797,'Come to me again with such pathetic work and I will send you home in a small iron box that I tempered in goat urine. Now go see that idiot Ug\'thok, he is better suited to your needs.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5798,'So you think you are good enough to learn from me? The great Snarl? You are no more than a lowly worm beneath my boot. However, taking on an underling might make me seem more appealing to Sumi and Tumi. Let\'s see what meager skills you possess.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5799,'Hmm? Oh yes, I can teach you something if you desire. But stay away from Sumi and Tumi, they are not for the likes of you. Saru only let\'s those of great skill approach his daughters.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5800,'There is nothing more that I can teach - now get out! And don\'t even think of approaching Saru, for one as unworthy as you he will use your blood to temper his steel.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5801,'The spirits have brought you to me, and so I feel blessed by them. ','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5803,'You need to heed the guidance of the spirits a little better young one. Your path lies with another, Thrag Stonehoof in Thunder Bluff. Perhaps you can learn something from one another.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5805,'Tell me, do your feel prepared to face the challenge I have laid out for you? The spirits tell me that you will pass, but do you have faith in them or in yourself?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5806,'Join me, together we will weave the spirits of the forge and find the true shape that the metal seeks.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5807,'Our paths through life intersect only briefly and now is the time for ours to part ways. I consider myself blessed to have spent this time teaching you and now send you along to join paths with your next mentor. Seek out Saru Steelfury of Orgrimmar, he will teach what you need to learn.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5808,'You have great potential, but you must achieve understanding first, you must accept the spirits and listen to their calling. Only then will you be prepared for the path you must follow. Go speak with Thrag, I think perhaps you can learn a lot from one another.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5809,'You are now ready to follow the path that joins your life with my own, if only for a short time. However we must make sure that you understand the things of which the spirits speak.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5810,'You have learned much, but I sense that there is more left for the spirits to teach you. I can place your foot on the path but cannot guide your steps. Go and find Saru Steelfury in Orgrimmar, the next stretch of your journey begins there.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5811,'You waste my time, go talk with my student Basil.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5812,'Perhaps you have what it takes, perhaps not. If you do then I will take you on and teach you what you wish to know. If you do not... well, I\'ll just leave it at that.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5813,'Very fine equipment you make, very fine indeed. Go to the Orc\'s home of Orgrimmar and seek out a smith named Saru Steelfury. One thing you must give the Orcs, they make beautiful instruments of death.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5814,'I\'m sorry $g lad : lass; but ye just don\'t have the foundation to learn what I have to teach. But don\'t fret, go speak with my student Rotgath, he\'ll help ye out.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5815,'Looks like ye may have the makings of a great smith. But before I teach ye anything I need to know that ye\'ve got what it takes. ','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5816,'I can\'t say enough about yer work, truly amazing things that ye can do with a hammer and an anvil. Now, don\'t be tellin anyone that I suggested ye go find a goblin to teach ye but that\'s exactly what I\'m gonna do. Brikk Keencraft is his name, and last I heard he was operating a shop down in Booty Bay.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5817,'This isn\'t a game you toy with youngling! Go, speak with Snarl outside. He may be a serpent in my lair but he does know his way around an anvil.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5818,'Still a bit weak, unbalanced, unsure. Not your work youngling, I am speaking of you! Now, are you ready to be shaped into a real smith or not?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5819,'I see you know more of the secret of steel than I do. That is good, for it is meant to be taken. Now you must travel to the jungle south of the human lands, to the goblin city of Booty Bay. There you will find a Goblin named Brikk Keencraft. I do not like Goblins but his knowledge of the secret of steel is unmatched by any I know of.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5820,'Yeah? Of course I\'m a smith. What, you think Dwarves are the only ones worth their weight in anvils? Fine, be that way. Go get a dwarf to help you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5821,'Are you kidding me? You must be kidding me! Either that or you think I\'m a clown here to amuse you. Is that what you think? That I\'m a clown? Huh, is it! You think I\'m a clown don\'t you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5822,'You act like this is the best junk I\'ve ever seen. Sure it\'s ok, but I see stuff this \'OK\' every day. Tell you what, you find a way to wow me, and I\'ll teach you things that make dwarves smile in their sleep.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5823,'Imagination is the limit my friend, if you can figure out how to smith it then you can make it, box it, and ship it to retailers all over the world. Of course, then you have to deal with marketing. Tell you what, let\'s just stick with the smithing part for now, ok?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5824,'Your victory shall be short lived. The days of both the Alliance and Horde are coming to an end! The next time we meet shall be the last.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5825,'What did Gryphe tell boss?? Gryphe wasn\'t lying! There she is, trying to steal battle plans!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5826,'Gryfe do his job! Gryfe go now!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5827,'Oh, it\'s on now! Bet you thought I\'d be alone too, huh?!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5828,'Whoa! This is way more than what I bargained for, you\'re on your own, Slim!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(5829,'Though I hate to admit it, the bear did get the better of me. My oh my, that\'s one big ol\' bear!$b$bNonetheless, if you can take that bear down, it\'d be a feat to be proud of! It gave more than a few of our best hunters some trouble.$b$b<He claps you on the back.>$b$bBest the bear and we\'ll accept you as a regular member of the Farstrider Lodge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5830,'Here at the Farstrider lodge, we prize hunting skills above all else. Wish to gain my approval? You\'ll have to earn it.$B$BYou look up to the challenge, $Glad:lass;!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(5831,'You\'ve become quite the hunter, $n! Not only have you proven your skills, you also bested Daryl, which gets you extra points in my book!$B$BYou\'re welcome here any time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5832,'You have summoned me, fool!  Now DIE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5833,'Milk me, John.','Milk me, John.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5834,'With pleasure... just let me savor this moment for a minute longer.','',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(5835,'Do it... Do it now.','Do it... Do it now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5836,'They\'s in Magic Quarter.  Look for them in scary skull building.','They\'s in Magic Quarter.  Look for them in scary skull building.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5837,'Us know where they are!  Skull building in Magic Quarter on outer ring of city.','Us know where they are!  Skull building in Magic Quarter on outer ring of city.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5838,'Bank in Trade Quarter central tower.  You not miss it.','Bank in Trade Quarter central tower.  You not miss it.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5839,'We have one eye and see better than you!  Bank in center of Undercity!','We have one eye and see better than you!  Bank in center of Undercity!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5840,'Michael Garrett on upper ring in Trade Quarter.','Michael Garrett on upper ring in Trade Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5841,'Bat man on upper level of Trade Quarter.','Bat man on upper level of Trade Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5842,'Yep, you looking for Christopher Drakul in Trade Quarter.  He on eastern platform.','Yep, you looking for Christopher Drakul in Trade Quarter.  He on eastern platform.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5843,'We join guild?  No?  Ok, you find Guild Master on east platform in Trade Quarter.','We join guild?  No?  Ok, you find Guild Master on east platform in Trade Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5844,'Innkeeper Norman on upper ring of Trade Quarter is one to talk to.','Innkeeper Norman on upper ring of Trade Quarter is one to talk to.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5845,'No rest for wicked, but us guess you ok.  You find Innkeeper Norman on upper ring of Trade Quarter.','No rest for wicked, but us guess you ok.  You find Innkeeper Norman on upper ring of Trade Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5846,'Mailbox in middle of city, Trade Quarter, upper ring... next to inn.','Mailbox in middle of city, Trade Quarter, upper ring... next to inn.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5847,'Us need check to see if our Brain... Brain... Brain Hacker sold at auction.  You find mailbox next to inn on upper ring of Trade Quarter.','Us need check to see if our Brain... Brain... Brain Hacker sold at auction.  You find mailbox next to inn on upper ring of Trade Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5848,'We have auction house in central ring.','We have auction house in central ring.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5849,'Central ring.  You go!','Central ring.  You go!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5850,'Little goblin Zapetta on top of right zep building north of Ruins of Lordaeron.  Leave Undercity and you go there, to go Orgrimmar.','Little goblin Zapetta on top of right zep building north of Ruins of Lordaeron.  Leave Undercity and you go there, to go Orgrimmar.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5851,'Us see balloon run by Hin Denburg north of ruins up above in right tower.  It take you to far off places, like jungle of Grom\'gol in Stranglethorn Vale.','Us see balloon run by Hin Denburg north of ruins up above in right tower.  It take you to far off places, like jungle of Grom\'gol in Stranglethorn Vale.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5852,'Priest trainer?  You go to outer ring of War Quarter and look for them there.','Priest trainer?  You go to outer ring of War Quarter and look for them there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5853,'Uh huh.  Unholies in War Quarter standing around main building on outer ring of city.','Uh huh.  Unholies in War Quarter standing around main building on outer ring of city.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5854,'','Get that head and it\'s sure to give Daryl a fright. Not that he doesn\'t deserve it, the bloody arrogant fool. But ha! I can\'t wait to see the look on his face when you show it to him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5855,'','Welcome to the Farstrider Lodge, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5856,'Rogues in building on outer ring of Rogues\' Quarter.','Rogues in building on outer ring of Rogues\' Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5857,'They teach me to sneak good.  You find them in Rogues\' Quarter on outer ring of Undercity.','They teach me to sneak good.  You find them in Rogues\' Quarter on outer ring of Undercity.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5858,'','You\'re always welcome here, $n. Thanks for the laugh -- and don\'t worry about Daryl, he had one coming!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5859,'Warlock trainers in Magic Quarter in building on outer ring with Mages.','Warlock trainers in Magic Quarter in building on outer ring with Mages.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5860,'Us want felhound for pet.  We feed it and treat it good and teach it play fetch.  You find Warlocks in Magic Quarter on outer ring of city.','Us want felhound for pet.  We feed it and treat it good and teach it play fetch.  You find Warlocks in Magic Quarter on outer ring of city.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5861,'In building of War Quarter on outer ring of city.','In building of War Quarter on outer ring of city.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5862,'Warrior trainers fight good.  You find them in War Quarter on outer ring of Undercity.','Warrior trainers fight good.  You find them in War Quarter on outer ring of Undercity.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5863,'You look in The Apothecarium.  That where Doctor Herbert Halsey and Doctor Marsh practice.','You look in The Apothecarium.  That where Doctor Herbert Halsey and Doctor Marsh practice.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5864,'Doctor Herbert Halsey in The Apothecarium where us was born.  Him could sew you back together better like us.','Doctor Herbert Halsey in The Apothecarium where us was born.  Him could sew you back together better like us.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5865,'James Van Brunt in War Quarter on inner ring.','James Van Brunt in War Quarter on inner ring.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5866,'Inner ring of War Quarter where James Van Brunt work.  Him make us good chain.','Inner ring of War Quarter where James Van Brunt work.  Him make us good chain.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5867,'That Eunice Burch in Trade Quarter.','That Eunice Burch in Trade Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5868,'Eunice Burch sell leftover parts.  You find her in Trade Quarter.','Eunice Burch sell leftover parts.  You find her in Trade Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5869,'You go to inner ring of The Apothecarium.  Lavinia Crowe is there.','You go to inner ring of The Apothecarium.  Lavinia Crowe is there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5870,'Lady teach you make magic items.  She at inner ring of The Apothecarium.','Lady teach you make magic items.  She at inner ring of The Apothecarium.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5871,'Franklin Lloyd in Rogues\' Quarter on outer ring of Undercity.','Franklin Lloyd in Rogues\' Quarter on outer ring of Undercity.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5872,'Heh, bombs, us like bombs.  Graham Van Talen show you how to make.  He in outer ring of Rogues\' Quarter.','Heh, bombs, us like bombs.  Graham Van Talen show you how to make.  He in outer ring of Rogues\' Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5873,'Us know her good.  She Mary Edras at inner ring of Rogues\' Quarter.','Us know her good.  She Mary Edras at inner ring of Rogues\' Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5874,'Lady stitch us up and bandage when we get hit.  You find her in inner ring of Rogues\' Quarter.','Lady stitch us up and bandage when we get hit.  You find her in inner ring of Rogues\' Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5875,'You not miss Armand Cromwell in Magic Quarter.  He stand on dock.','You not miss Armand Cromwell in Magic Quarter.  He stand on dock.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5876,'Armand Cromwell always on dock in Magic Quarter.  Fish in green goo taste extra good.  You try.','Armand Cromwell always on dock in Magic Quarter.  Fish in green goo taste extra good.  You try.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5877,'You look for Martha Alliestar.  She on inner ring of The Apothecarium.','You look for Martha Alliestar.  She on inner ring of The Apothecarium.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5878,'You need go to The Apothecarium on inner ring.  That where Martha Alliestar teach you how to pick flowers.','You need go to The Apothecarium on inner ring.  That where Martha Alliestar teach you how to pick flowers.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5879,'Him\'s at inner ring of Rogues\' Quarter.','Him\'s at inner ring of Rogues\' Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5880,'Arthur Moore in Rogues\' Quarter inner ring is one who teach leatherworking.','Arthur Moore in Rogues\' Quarter inner ring is one who teach leatherworking.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5881,'Go to inner ring of War Quarter.  Brom Killian there.','Go to inner ring of War Quarter.  Brom Killian there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5882,'Brom Killian teach you how dig up shiny for me.  Him on inner ring of War Quarter.','Brom Killian teach you how dig up shiny for me.  Him on inner ring of War Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5883,'Killian Hagey teach skinning in Rogues\' Quarter on inner ring.','Killian Hagey teach skinning in Rogues\' Quarter on inner ring.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5884,'Us have skinning hook.  We get it from Killian Hagey who teach us how to skin kills.  You have nice skin.  You find him on inner ring of Rogues\' Quarter.','Us have skinning hook.  We get it from Killian Hagey who teach us how to skin kills.  You have nice skin.  You find him on inner ring of Rogues\' Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5885,'You look for Josef Gregorian.  He in Magic Quarter on inner ring side of green canal.','You look for Josef Gregorian.  He in Magic Quarter on inner ring side of green canal.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5886,'Hmmm, that good idea.  Maybe we head there to get some stitches replaced?  Him sew good.  You find Josef Gregorian on inner circle of Magic Quarter.','Hmmm, that good idea.  Maybe we head there to get some stitches replaced?  Him sew good.  You find Josef Gregorian on inner circle of Magic Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5887,'','Oh, ok!  Here you are, $n.  It\'s the least I can do for all the help you\'ve given me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5888,'Which profession?','Which profession?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5889,'Alchemy','Alchemy',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5890,'Blacksmithing','Blacksmithing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5891,'Cooking','Cooking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5892,'Enchanting','Enchanting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5893,'Engineering','Engineering',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5894,'First Aid','First Aid',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5895,'Fishing','Fishing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5896,'Herbalism','Herbalism',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5897,'Leatherworking','Leatherworking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5898,'Mining','Mining',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5899,'Skinning','Skinning',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5900,'Tailoring','Tailoring',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5901,'Which trainer do you seek?','Which trainer do you seek?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5902,'Mage','Mage',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5903,'Priest','Priest',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5904,'Rogue','Rogue',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5905,'Warlock','Warlock',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5906,'Warrior','Warrior',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5907,'What are you looking for?','What are you looking for?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5908,'Bank','Bank',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5909,'Bat Handler','Bat Handler',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5910,'Guild Master & Vendor','Guild Master & Vendor',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5911,'Inn','Inn',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5912,'Mailbox','Mailbox',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5913,'Auction House','Auction House',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5914,'Other Continents','Other Continents',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5915,'Class Trainer','Class Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5916,'Profession Trainer','Profession Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5917,'Us think you need help.','Us think you need help.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5918,'We help you find them.','We help you find them.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5919,'Our eye say you look lost.','Our eye say you look lost.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5920,'Us hear and obey.','Us hear and obey.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5921,'Can you help me with some directions?','Can you help me with some directions?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5922,'Listen to the stories of an elder. $n. I have many to speak of...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5923,'','Welcome to the refuge, $n. Some come here with a purpose, others found their way here by accident... But everyone here seems to have a unique story to tell.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5926,'','Be on guard... Arnak has some strange power over the Grimtotem... they will not be happy to see me escape.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5927,'','Look out, the Grimtotem are upon us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5928,'','Here they come.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5929,'','More Grimtotems are coming this way!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5930,'','Finally, free at last... I must be going now, thanks for helping me escape. I can get back to Freewind Post by myself.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5931,'','$n!  You\'re back!  And not a moment too soon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5932,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5933,'','Hi, $n.  No hard feelings, ok?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5934,'I present to you the rabid thistle bear, Tharnariun.','I present to you the rabid thistle bear, Tharnariun.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5935,'Grrr...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5936,'I want to release the corrupted saber to Winna.','I want to release the corrupted saber to Winna.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5937,'Be cleansed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5938,'%s recasts the cleansing spell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5939,'%s jumps into the moonwell, and goes underwater...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5940,'%s follows $n obediently.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5941,'%s snarls ferociously.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5942,'What kind of a Horde are we if we refuse to deliver justice? The cowards all turned their backs on me in my time of need, $c. At the Crossroads they claimed I was blinded by my own rage, that I was acting rash and reckless.$B$B<Mankrik spits on the ground.>$B$BThey did not see what I have seen, have never lost what I have lost. I will not rest until I have my vengeance.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(5943,'I thank you, $n. Your dedication to my plea gives rest to my lost wife\'s spirit, and for that I could never repay you enough.$B$BI cannot say that my hatred will ever cease for the quilboar, but it is satiated for now.$B$BNow I must begin to rebuild my life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5944,'%s points to the parchment on the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5945,'','I\'m very curious to see what this sample of water will do!',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(5946,'','%s pours the corrupted water onto the cat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5947,'','Haha! Perfect!',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(5948,'%s has been encaged.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5949,'Use staff, tell Raze what do! Show Raze poacher! Raze smash!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5950,'Now this is an example of what not to summon. Look, it\'s frail and brittle. One good whack from a mace will send bone shards flying.','Now this is an example of what not to summon. Look, it\'s frail and brittle. One good whack from a mace will send bone shards flying.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5951,'Note the weak binding structure of this one. Be sure to finish your incantations or this is what you will end up with.','Note the weak binding structure of this one. Be sure to finish your incantations or this is what you will end up with.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5952,'This one is slightly better than the last. However, it still suffers from the same flimsy bone structure as the others. When you summon one of these, you are on the right path.','This one is slightly better than the last. However, it still suffers from the same flimsy bone structure as the others. When you summon one of these, you are on the right path.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(5953,'Wow, this one is just plain useless. Let me try again.','Wow, this one is just plain useless. Let me try again.',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(5954,'Hmmm, this one looks like something that would be better off as a windchime. Take notes class... This is NOT what you want to summon in the heat of battle.','Hmmm, this one looks like something that would be better off as a windchime. Take notes class... This is NOT what you want to summon in the heat of battle.',94,0,0,0,0,0,0,0,1,0,0,0,26124),
(5955,'What could be taking so long?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5956,'How long can it take to pick a handful of weeds?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5957,'At this rate I could have gathered them myself!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5958,'If you want something done right, do it yourself!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5959,'As if I had all eternity.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5960,'Ah, this must be him now... no?  Bah!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5961,'Maybe I should have just bought some off of Faruza?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5962,'I had to go and requisition an Abomination... an Abomination!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(5963,'','The body is that of a female orc warrior.$B$BIt is clear that she died in battle, probably against the quilboar in the area.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5964,'I inspect the body further.','I inspect the body further.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5965,'','You turn the body over and see the marks from blades and spells upon the deceased orc--her armor all but destroyed, her hair matted to her face.$B$BBased on Mankrik\'s description of her, there is no doubt in your mind that this was his wife.$B$BHe will be upset by the news, but you are sure he should know the truth.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5966,'Start running!','Start running!',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(5967,'Bring it on!','Bring it on!',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(5968,'Do not push me, or I will impale you on my horns!','Do not push me, or I will impale you on my horns!',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(5969,'Welcome to the Crossroads, $c. My name is Thork--I lead the defenses here in the name of the Warchief.$B$BPlease, feel free to make yourself at home. As long as you mind your business, no one should have any problem with you taking up some space.$B$BThere are many threats to our safety here. If you\'ve already become familiar with the lay of the land, speak to the others here--perhaps they have tasks for you to do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5970,'<Goretooth spits.>$B$BI am a warrior of the Horde, $n. It fills me with rage to know that our enemies sit in a fortress, less than a day\'s ride from Kargath, plotting against us.$B$BHow I long to break free from the bonds of duty and destroy them all in the name of the Warchief.$B$BAlas, we all have roles we must fulfill.\n','',14,5,1,0,0,0,0,0,1,0,0,0,26124),
(5971,'What roles?','What roles?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5972,'Truly, I envy you: To battle in the name of the Horde, at the forefront of conflict. Mine is a job of command.$B$BCertainly, in my youth, I lived out the dreams that make my old age bearable. I now revel in the glory of victory, the bitter taste of defeat - all through the soldiers I command.\n','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(5973,'Dreams?','Dreams?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5974,'I dream, $n... oh yes, I dream. In my dreams I die a thousand times in a thousand different ways. Some would call dreams such as mine nightmares. NOT I! In dreams I die in the thick of battle. For each single death of my own, ten thousand enemies of the Horde fall before me. It is glorious!','',1,1,5,0,0,0,0,0,1,0,0,0,26124),
(5975,'I pray for such things.','I pray for such things.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5976,'Aye, I could tell just by looking at you, $n. You remind me very much of myself as a young warrior of the Horde.$B$BYou will undoubtedly go far in life and even further in death.$B$B<Goretooth salutes.>','',1,1,66,0,0,0,0,0,1,0,0,0,26124),
(5977,'I do not deserve such praise, Warlord Goretooth.','I do not deserve such praise, Warlord Goretooth.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5978,'And modest too... Perhaps it is your time, then, $n.$B$BAre you prepared to enter the fortress of the Blackrock orcs? To wreak havoc? To tear asunder the foundation of the mountain citadel?','',25,6,6,0,0,0,0,0,1,0,0,0,26124),
(5979,'Sir! Until my body ceases to function!','Sir! Until my body ceases to function!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5980,'I did not doubt you for even one second, $n.$B$BHere are your orders, $n. I know that you will not let me down.\n','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5981,'Yes, sir. Thank you, sir!','Yes, sir. Thank you, sir!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5982,'%s bows before Krang Stonehoof','%s bows before Krang Stonehoof',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5983,'Ah a visitor! Must be an adventurer, we don\'t get many tourists down this way. Grab a chair and a drink, make yourself comfortable. Say, you look like you have some meat on your bones. You thinkin about competing in the cage matches?','Ah a visitor! Must be an adventurer, we don\'t get many tourists down this way. Grab a chair and a drink, make yourself comfortable. Say, you look like you have some meat on your bones. You thinkin about competing in the cage matches?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5984,'%s attacks the pike!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5985,'%s destroys the pike!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5986,'%s and Raider Kerr let their wolves rest a bit and drink...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5987,'%s and Raider Kerr charge into battle...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5988,'%s takes aim...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5989,'Greetings, young $c.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(5990,'Hello, Eitrigg. I bring news from Blackrock Spire.','Hello, Eitrigg. I bring news from Blackrock Spire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5991,'Rend, son of Blackhand: Impotent chieftain of the Blackrock clan. A more stubborn fool does not exist.$B$BAt the end of the second War, Rend and his brother, Maim, fled to find sanctuary within the mountainous stronghold of Blackrock Spire. It was there that Rend declared himself Warchief of the weakened Blackrock clan.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(5992,'There is only one Warchief, Eitrigg!','There is only one Warchief, Eitrigg!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5993,'Yes, young one, you need not convince me of such things, the Warchief and I have much history. Your dedication, however, is noted.$B$BAs I was saying, Rend had found a new home for his people, and I was among those who would wearily follow.$B$BFrom one conflict arose others... countless others. It was in those battles for Blackrock Spire between the Blackrock clan and the Dark Iron dwarves that my sons were both slain. It was then that I realized my time among the Blackrock clan had come to an end.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(5994,'What do you mean?','What do you mean?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5995,'I left. I would not remain with the Blackrock. No, the deaths of my children would not be in vain. I would not serve under an inept, power hungry maniac such as Rend.$B$BI took shelter in the woods of Lordaeron, living as a hermit near Hearthglen.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(5996,'Hearthglen?? But...\n','Hearthglen?? But...\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5997,'<Eitrigg laughs.>$B$BYoung one, the world has not always been in such disarray. It was a time before the Scourge had sacked the land. Before those parts of Lordaeron were known as the Plaguelands.$B$BIt was there that Thrall rescued me from death and it was then that I joined the new Horde... but I digress. This is a story for another time. Yes, another time... Perhaps...','',11,1,1,0,0,0,0,0,1,0,0,0,26124),
(5998,'I will take you up on that offer, Eitrigg.','I will take you up on that offer, Eitrigg.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(5999,'I\'m certain you will. Perhaps one day you could deliver a message to an old friend of mine. I hear he still wanders those woods.$B$B<Eitrigg bows his head for a moment, as if in prayer.>$B$BSo Rend, yes... Rend and his brother Maim ruled the Spire, in constant conflict with the Dark Iron dwarves. They managed to displace the dwarves in the upper portion of the city, but only after the dragons came and only after the death of Maim.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(6000,'Ah, so that is how they pushed the Dark Iron to the lower parts of the Spire.','Ah, so that is how they pushed the Dark Iron to the lower parts of the Spire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6001,'Indeed. Nefarian, brood of Deathwing, rules the Spire now. Rend is under the command of the dragon.$B$BIf only you could somehow manage to pass through the Halls of Ascension.$B$B<Eitrigg sighs.>$B$BAlas, only those deemed worthy by the black flight earn privilege to ascend.\n','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(6002,'Perhaps there exists a way?','Perhaps there exists a way?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6003,'Perhaps. Go now, young one. Seek council with the Warchief. He will surely wish to know of your discovery.','',1,25,0,0,0,0,0,0,1,0,0,0,26124),
(6004,'As you wish, Eitrigg.','As you wish, Eitrigg.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6005,'Hulfnar!  Thontek!  Stand and address me.','Hulfnar!  Thontek!  Stand and address me.',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(6006,'It\'s 428,000 degrees Kraklenheit... What\'s happening, hot stuff!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6007,'DING! 428,000 degrees Kraklenheit, exactly! Well, approximately. Almost. Somewhere around there...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6008,'Measuring by Kraklenheit, it is 428,000 degrees! That\'s Krakley!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6009,'18 degrees Kraklenheit. It\'s kind of cold, actually...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6010,'It\'s 40 degrees Kraklenheit. Can you feel the heat? No? I really couldn\'t either.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6011,'Wow, it\'s 3 degrees Kraklenheit. Keep looking.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6012,'The stake is covered with the remnants of those foolish enough to anger the Warchief.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6013,'Honor your heroes! On this day, they have dealt a great blow against one of our most hated enemies! The false Warchief, Rend Blackhand, has fallen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6014,'Be bathed in my power! Drink in my might! Battle for the glory of the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6015,'Be bathed in the power of the Warchief! Drink in his might! Battle for the glory of the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6016,'The Valley of Trials will temper even the weakest into a warrior worthy to join the Horde. Those who cannot rise to its tests will be left to bake in the scorching desert sun.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6017,'Place Rend\'s head on the stake.','Place Rend\'s head on the stake.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6018,'','Hello there, $n.  I am known as Chronormu, but you may call me Chromie.  I am comfortable with such familiarity.$B$BNow - how did I know your name, you ask?  I am one of the bronze dragonflight, forever attuned to the ebb and flow of time.  You could say that we have met before.  To that end, we shall also meet again.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(6019,'','Hello once again, $n.  I sense that the flow of time remains threatened by forces that are quite powerful indeed.  Your continued assistance is always welcomed by the bronze dragonflight.$B$BWhile the past is set in its ways, the future is always changing.  The decisions you make in the here and now help guide that change.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(6020,'I want you both to demonstrate the techniques I have taught you for the benefit of the younger students here.  Ready...  begin!','I want you both to demonstrate the techniques I have taught you for the benefit of the younger students here.  Ready...  begin!',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(6021,'','This is where I get off, suckers!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6022,'','Tell Lexlort if he wants the information, all he has to do is pay! Unfortunately, that means he can\'t kill me if he wants the information - since I burned the battle plans and all...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6023,'','Listen to your elders, $n. If you are strong of will and dedicated, there is no power you cannot control.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6024,'','Not all Forsaken are driven by Sylvanas\' will, $n. Some of us are driven by true power--power we earn for ourselves.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6025,'Enough talk you two!  Commence fighting!','Enough talk you two!  Commence fighting!',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(6026,'','Now\'s not a good time, $n.$B$BAre you insane?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6027,'','It... is... not... the best... time, $n. I must concen... trate.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6028,'','Your errand must mean much, $c, to draw you so deep into the marsh...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6029,'','The infernal is one of the most powerful demons a warlock could hope to have at $Ghis:her; side in battle. The creature is stong, well-armored, and delivers devastating blows upon any foe. If you were to choose to put the spirit of an infernal into your weapon, you would gain some of those benefits--greater health and regeneration and the like.$B$BIf you wish to know more about felhounds, then you should speak to Wytula across from me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6030,'','The felhound... a vicious creature indeed. It is not as physically strong as an infernal, but a wise warlock knows that brute force is not always the answer--if it was, you would have chosen the path of a warrior instead, wouldn\'t you?$B$BThe felhound draws upon the mana of its foes, using that and its quickness to overcome enemies. Its strength comes from the arcane and using that arcane power for its own ends.$B$BIf you wish to know more about infernals, then you should speak to Magaz across from me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6031,'ROOKERY MINION SPAWN DEBUG','ROOKERY MINION SPAWN DEBUG',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6032,'ROOKERY MINION death DEBUG','ROOKERY MINION death DEBUG',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6033,'%s is summoned through a temporal rift!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6034,'','Have you spoken to either of my acolytes inside the tower yet, $n? We cannot complete your orb until you\'ve done one of their tasks. Speak to them now, if you\'re ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6035,'Help me kill $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6036,'Protect me from this $n! I must return to my brood.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6037,'Don\'t let me die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6038,'Well Done!','Well Done!',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(6039,'','%s roars out for her mate!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6040,'%s answers the call of Shy-Rotam.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6043,'Please, help me $g brother : sister;...$B$BI will soon pass from this world, and though I suffer I know I shall not any more once I pass.  The wildlife though, my $g brother : sister;... the wildlife suffers too, and it knows no release.  I ask for your aid with my last breaths of life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6045,'Yes, I speak a language you understand $r.  We are not animals, yet most of your kind continues to treat us as such!  Our differences though pale to the tragedy that has befallen this land.  Please, put aside your differences with my kind and hear my dying plea.$B$BI came to this land to mend what I could, and now that will be for naught unless you can aid me.  I ask for such aid with my last breaths of life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6046,'\"...\"$B$BThe body of the tauren druid lies still and unmoving.  It would seem as though he has finally passed from this world to his promised great beyond.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6061,'None may challenge the Brotherhood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6062,'And stay down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6063,'Lapdogs, all of you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6064,'Fools! Our cause is righteous!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6065,'The Brotherhood shall prevail!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6066,'Leaping leper gnomes! I\'ve been stuck in there for months. Thanks, gang.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6067,'Who dares step into my domain!  Come!  Come, and be consumed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6068,'Ever vigilant in their protection of the natural world, the druids are guided by Archdruid Fandral Staghelm, who resides in the Cenarion Enclave. You will find him and the other druid trainers in the northern section of Darnassus.','Ever vigilant in their protection of the natural world, the druids are guided by Archdruid Fandral Staghelm, who resides in the Cenarion Enclave. You will find him and the other druid trainers in the northern section of Darnassus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6069,'I am an officer of the city, working in the capacity of the Undercity\'s census.  Since our liberation from the Scourge, we have tried to keep an accurate track of our city\'s populace.  Through arcane methods and sharpened mental discipline, I am able to access these records.  If you have business with me accordingly, please proceed.  You should know if you do, at any rate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6070,'The Warchief has instructed me to study all kinds of weapons and armor. He has sent me here to the hub of both the tauren and orc cultures in the Barrens to meet as many travelers as possible, and to learn about the cultures of the Barrens.$B$BHe feels there\'s something to be learned from even the most pathetic of cultures... like the quilboar or centaur.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6071,'You surrendered.  I win.','You surrendered.  I win.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6072,'Now that\'s a War Stomp!  Good job!','Now that\'s a War Stomp!  Good job!',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(6073,'That\'s how it\'s done class!  You better be paying attention!','That\'s how it\'s done class!  You better be paying attention!',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(6074,'Now that\'s putting your hoof down!','Now that\'s putting your hoof down!',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(6075,'You! $R! Come here. <snort>$B$BTime is short, and my end <snort> is near. Mangletooth shall win; you will see. <snort>$B$BMy capture can still aid <snort> my people. The Razormane tribe is more powerful than the Bristlebacks!$B$BThe Horde looks to find out who leads the raids on their people. You <snort> shall aid Mangletooth in return for the information only I know. Mangletooth can help you! <snort> But you must help Mangletooth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6076,'Welcome to Stormwind!  I am one of the city\'s officers, aiding the citizenry of the city through our census bureau.  If you are in need of locating someone specific, then I might be able to assist you.  Through arcane methods and sharpened mental discipline, I am able to access these records.$B$BIf you have business with me, then please proceed!','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(6077,'My hatred is strong <snort>, but the time is right to tell you a tale, $r.$B$BLong ago a battle took place between gods. Agamaggan, our great boar god, fell to the earth after being defeated in the War of the Ancients, his blood raining down and his bones torn asunder. <snort>$B$BGreat thorns reached up out of the earth where his blood touched the ground, and his skull adorns one of the caverns to the south.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6078,'Whew... I need a smoke and the touch of a fine gnomish woman - not particularly in that order!$B$BI\'ve been stuck inside the belly of that thing for months! What day is it anyway? Ah, nevermind. All that matters is that I\'m finally out.$B$BWOOO HOOO!','',1,5,4,0,0,0,0,0,1,0,0,0,26124),
(6079,'How the hell did you get in there to begin with?\n','How the hell did you get in there to begin with?\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6080,'How?? Well, it\'s a long story.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6081,'I\'m all ears.','I\'m all ears.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6082,'Alrighty then! So I was down at the lava pits of the Molten Span, testing out my lava suit. Everything was going great. I was even able to swim around in that stuff without suffering a single injury!$B$BSo there I am, minding my own business, doing a few backstrokes, when out of nowhere this thing swallows me up whole! Had it not been for my lava suit and built in food pellet dispenser, I would have been done for!','',1,1,5,0,0,0,0,0,1,0,0,0,26124),
(6083,'So let me get this straight. You were swimming, nay, doing backstrokes in molten lava with this... this lava suit of yours? Yes? And out of nowhere, this here beast swallowed you whole? ','So let me get this straight. You were swimming, nay, doing backstrokes in molten lava with this... this lava suit of yours? Yes? And out of nowhere, this here beast swallowed you whole? ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6084,'Say, I sense a measure of disbelief in your voice - but yes, that\'s how it happened.','',1,25,0,0,0,0,0,0,1,0,0,0,26124),
(6085,'I must know something: How did you go to the bathroom with that thing on?','I must know something: How did you go to the bathroom with that thing on? ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6086,'I\'m not out of the belly of this beast for more than two minutes and someone is already asking me about my bathroom behavior??? $G Mister:Missy;, I\'d have smacked you silly for that question had you not been the one to rescue me!$B$BAnyhow! I\'m grateful for the assistance. Maybe I can pay you back?','',6,1,6,0,0,0,0,0,1,0,0,0,26124),
(6087,'Oh?','Oh?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6088,'Well, maybe \'pay\' isn\'t the best word to use. See, when I was stuck in the belly of that thing, I got to thinking:$B$BThis creature lives in hot, flaming magma and yet it doesn\'t take a lick of damage from the fire!$B$BIf only I could find a pristine hide from one of these beasts. I could take it back to my dear friend, Malyfous Darkhammer, in Everlook. If anyone could do anything with the hide of a beast like this, it would be him. \n','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(6089,'I\'ll consider that the next time I run into one of these things.','I\'ll consider that the next time I run into one of these things.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6090,'So how about you deliver a message for me?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(6091,'Ish nu!  That\'s enough!','Ish nu!  That\'s enough!',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(6092,'To Malyfous, I assume.','To Malyfous, I assume.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6093,'Wanna buy a cockroach?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6094,'You will never wake the dreamer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6095,'The coils of death will crush you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6096,'I am the serpent king! I can do anything! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6097,'','None can stand against the Serpent Lords!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6098,'Good, good.  Now bow to each other.','Good, good.  Now bow to each other.',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(6099,'Now bow to me.','Now bow to me.',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(6100,'Good job you two.  Now go have a seat.','Good job you two.  Now go have a seat.',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(6101,'%s whimpers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6102,'%s grumbles.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6103,'%s snorts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6104,'%s cries.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6105,'Hahah!  Revenge is mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6106,'%s takes a more careful aim...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6107,'%s picks the orc target...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6108,'%s takes aim again...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6109,'%s takes aim one last time...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6110,'','Time is running out for me... for us all...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6111,'','I have so much to do... so much before the plague comes...\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6112,'','John, honey, where are you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6113,'','What is happening to everyone?  I feel... cold...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6114,'','The spirit looks upon you with a sense of completeness and cognizance that had not been present before.$B$B\"I feel as though a great burden has been lifted from my soul.  Soon I will rest forever in peace.  I now know this, and I await this time patiently.$B$BThank you, stranger.\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6115,'You, too, shall serve!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6116,'Another falls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6117,'You have <snort> aided Mangletooth more than I would have dreamed, $r.$B$BThank you.$B$BAs long as I remain a captive here, you may bring me blood shards from the Bristleback quilboar and I will bless you with Agamaggan\'s power.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6118,'%s casually points at the orc target...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6119,'%s blows the smoke off his rifle\'s barrel..','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6120,'%s takes aim at the bottles...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6121,'%s takes aim at the bottles again...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6122,'%s then takes aim at the bottles...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6123,'%s only hits the side of the box!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6124,'%s quickly shoots the middle target dead center...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6126,'Rawww!  Urok is dead!!  Hahah!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6127,'Revenge is mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6128,'The Thorium Brotherhood does not waste time on ants. Be gone!','',25,5,0,0,0,0,0,0,1,0,0,0,26124),
(6129,'Tell me about the hide.','Tell me about the hide.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6130,'It\'s a simple process for a craftsman of my caliber.$B$BThe most difficult aspect of crafting items out of beast hides and carapace is the actual acquisition of said parts. Now, if you could bring me a pristine hide from this beast, I could make several different powerful items from the flesh.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(6131,'What are the chances of obtaining such a hide?','What are the chances of obtaining such a hide?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6132,'I reckon that the odds of obtaining such a piece would be a one in a million! A once in a lifetime skin! Even the most disciplined artisans of the craft would no doubt fail several hundred times in the process of skinning the beast before a pristine sample was recovered.\n','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(6133,'So let us pretend I get this hide, what else would you need and what could you actually make?','So let us pretend I get this hide, what else would you need and what could you actually make?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6134,'If you actually brought me the hide of the beast? Well... Let me show you...','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(6135,'Ok!','Ok!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6136,'%s turns to the paper target...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6137,'%s quickly shoots the orc dummy...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6138,'%s shoots from the hip at the bottles...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6139,'Read through my catalogue, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6140,'%s misses...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6141,'%s misses again...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6142,'%s hits!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6143,'Left Combat','Left Combat',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6144,'The Thorium Brotherhood Fall Catalogue:$B$BInside you will find the hottest deals on all of your adventuring needs! We\'ll even show you where to pick up those difficult to find components and supplies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6145,'Chapter on Frayed Abomination Stitchings.','Chapter on Frayed Abomination Stitchings.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6146,'Chapter on Enchanted Scarlet Thread.','Chapter on Enchanted Scarlet Thread.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6147,'Chapter on Frostwhisper\'s Embalming Fluid.','Chapter on Frostwhisper\'s Embalming Fluid.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6149,'Here they come! Defend yourselves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6150,'TIMMY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6151,'Chapter on Arcane Crystals and Arcanite.','Chapter on Arcane Crystals and Arcanite.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6152,'You\'ve accepted my surrender.','You\'ve accepted my surrender.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6153,'','Please, follow me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6154,'','I haven\'t really figured out what it is, but there\'s something strange about the hot springs...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6155,'','%s tosses the sword into the shallow pool.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6156,'','I\'ve found that when I throw something into this water, it has improved incredibly when I retrieve it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6157,'','Well, whatever it is, it works quite well!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6158,'','And I am determined to find out more... So if you need my help again, you know where I\'ll be.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6159,'The title of this book reads with a handwritten flourish: Maureen Dalson\'s Diary.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6160,'A diary with yellowing pages lies open to the last entry:$B$B\"I don\'t know what\'s going to happen now that Harold\'s turned.  It took everything out of me to drag him into the only place I could find that\'d lock him up tight and hold him.  I hid the key on me, and I pray it works...$B$BI hope I can get out of here, but I need money to do that.  Our stuff\'s all in the cabinet I think... and now that I think about it, doesn\'t Harold keep the key on him?$B$BI\'ll rest on it, I\'m dead tired now.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6161,'Chapter on Skin of Shadow.','Chapter on Skin of Shadow.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6162,'Intruders at the Service Gate! Lord Rivendare must be warned!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6163,'If it\'s frayed abomination stitchings you be wanting, to Stratholme you\'ll be jaunting.$B$BFormerly the hometown of the Lightbringer hisself, now overrun by the minions of Kel\'Thuzad.$B$BBrave the perils of the burning city and strike down the meaty abominations! Take from them your prize: Frayed abomination stitchings!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6164,'The final sanctum of crazed zealots. \'Tis where they create their scarlet uniforms, magically imbued by the enchanted scarlet thread!$B$BTo Stratholme, adventurer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6165,'The finest preservative of flesh known to man and Scourge alike - Frostwhisper\'s embalming fluid.  Only one place an adventurer could find this and one would think that the lich the fluid is named after would not take too kindly to anyone going to said place.$B$BBut... if it\'s the fluid you want, the Scholomance you\'ll haunt...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6166,'The ground upon which the Scholomance was built was given to Kel\'Thuzad by the Barov family. In exchange for this land - a place where the Cult of the Damned could learn the foul magics of the Scourge - Kel\'Thuzad granted the Barov\'s immortality through undeath.$B$BIt is in Shadow Vault that you will find both the skin of shadow and its owner, Lady Illucia Barov.$B$BA finer mirror for the vain and dead never existed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6167,'A staple of the Thorium Brotherhood.$B$BArcanite crystals are harvested from rich thorium lodes. Through the alchemical prowess of powerful alchemists, arcanite bars are born.$B$BSeek out a miner, if you aren\'t one... and find a good alchemist! You\'ll need both.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6168,'%s paces back and forth nervously.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6169,'','You should not be here! Slay them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6170,'','Paltry kill.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6171,'Who dares disturb my meditation?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6172,'Dust to dust.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6173,'Usurpers! Gnomeregan is mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6174,'My machines are the future! They\'ll destroy you all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6175,'And STAY dead!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6176,'Explosions! MORE explosions! I got to have more explosions!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6177,'Electric justice!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6178,'Victory! For Agamaggan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6179,'','Troublesome whelps. I\'ll teach you to interfere!',0,0,0,0,0,0,0,0,1,0,0,5813,26124),
(6180,'','Who\'s next?',0,0,0,0,0,0,0,0,1,0,0,5814,26124),
(6181,'','You outsiders will pay for encroaching on our land!',0,0,0,0,0,0,0,0,1,0,0,5815,26124),
(6182,'','Bah! My power rules here!',0,0,0,0,0,0,0,0,1,0,0,5816,26124),
(6183,'','Our new allies will avenge us!',0,0,0,0,0,0,0,0,1,0,0,5818,26124),
(6184,'Slay them, my brethren! For the Scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6185,'Me smell stench of the living!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6186,'Me feast on you all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6187,'You\'ll never leave this place alive.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6188,'Too easy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6189,'To me, my servants!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6190,'Come, spirits - attend your master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6191,'Your skulls I shall crack with all the might of Blackrock.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6192,'I am the hand of the Lich King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6193,'%s wipes his brow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6194,'Ah - I\'ve been waiting for a real challenge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6195,'Light, give me strength!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6196,'Is that all?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6197,'Unworthy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6198,'','The Light has spoken!',0,0,0,0,0,0,0,0,1,0,0,29618,26124),
(6199,'You will not defile these mysteries!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6200,'Burn in righteous fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6201,'We hunger for vengeance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6202,'No rest... for the angry dead!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6203,'More... More souls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6204,'Tell me... tell me everything!','',0,0,0,0,0,0,0,0,1,0,5847,0,26124),
(6205,'Purged by pain!','',0,0,0,0,0,0,0,0,1,0,5848,0,26124),
(6206,'Naughty secrets!','',0,0,0,0,0,0,0,0,1,0,5849,0,26124),
(6207,'I\'ll rip the secrets from your flesh!','',0,0,0,0,0,0,0,0,1,0,5850,0,26124),
(6208,'Take a look at this, Malyfous.','Take a look at this, Malyfous.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6209,'What have you got there, $n?$B$B<Malyfous points to the unfired plate gauntlets hanging out of your pack.>','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(6210,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6211,'Don\'t forget to get some Flame in a Bottle from the box here.  You\'re going to need it to destroy their command tent.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6212,'By Thaurissan\'s beard! Slay them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6213,'Me Grimlok, king!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6214,'Die! Die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6215,'Reckless mortal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6216,'I\'ll feast on your bones!','',0,0,0,0,0,0,0,14,1,0,0,0,26124),
(6217,'The Soulflayer comes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6219,'Hakkar shall live again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6220,'Turn back! Do not wake the dreamer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6221,'Sands consume you!','',0,0,0,0,0,0,0,14,1,0,0,0,26124),
(6222,'Fall!','',0,0,0,0,0,0,0,14,1,0,0,0,26124),
(6223,'Let the executions begin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6224,'Justice is done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6225,'This desert be mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6226,'Die, outlander!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6227,'Feel the fury of the sands!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6228,'The Sandfury reign supreme!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6229,'Welcome to the front lines, $c.  While politicians may connive and scheme amongst themselves, they\'ll find no such luxury afforded to them here.  This is the Bulwark, and we fight for our continued survival on a daily basis here.$B$BIf you\'ve come here looking for a chance to prove yourself as a hero, then you\'ll find plenty of opportunities to do so.','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(6230,'Welcome to the front lines, $c.  The Kingdom of Stormwind, with the aid of its allies, has sent me here to counter the growing threat of the Scourge.  Here at Chillwind Camp, we fight for our continued survival on a daily basis.$B$BIf you\'ve come here looking for a chance to prove yourself as a hero, then you\'ll find plenty of opportunities to do so... especially as we push towards Andorhal and whatever malign force that controls the Scourge there.','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(6231,'','%s looks around nervously.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6232,'','Are you sure you weren\'t followed here? I have a very bad feeling all of a sudden...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6233,'','Be on your guard!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6234,'We are betrayed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6235,'It is good to see others who fight the Scourge in Stratholme, for it is here they are strongest.$B$BGreetings.  I am Aurius.  I was once a paladin of the Silver Hand, but like others whose faith wavered... I fell from grace.  The Scourge seduced me and nearly transformed me into a death knight!$B$BFinally sensing my peril, I fled to this chapel.  It is a sacred place, where the first paladin, Uther the Lightbringer, was ordained into the order of the Silver Hand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6236,'Rivendare!  I come for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6237,'Argh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6238,'I do not have much time in this world, but Light willing, it is time enough to fulfill my destiny.  When you face Baron Rivendare, I will be with you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6239,'Leave me.  My wounds are great and I fear they will overtake me.  Thank you, $n.  I will die here, but because of you... I\'ll die in peace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6240,'Test not my patience, mortal.','',5,0,0,0,0,0,0,8,1,0,0,0,26124),
(6241,'You will have to excuse me, Lorax, I do not speak \'crazy.\'','You will have to excuse me, Lorax, I do not speak \'crazy.\'',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6242,'Bite your tongue, $r, lest I rip it from your skull case and use it as a horn warmer.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(6243,'My apologies, I did not realize that you could understand what I was saying. What is it you are doing out here?','My apologies, I did not realize that you could understand what I was saying. What is it you are doing out here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6244,'What it is that I do, of course. I brood. I lament. I hate. I plot. When that cycle is complete, I brood again. What is it you want from me? I have much on my mind.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(6245,'Do you? Perhaps you should tell me what it is that is bothering you.','Do you? Perhaps you should tell me what it is that is bothering you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6246,'You?$B$B<Lorax laughs.>$B$BThat is doubtful.$B$BI stand in these ruins and dream. Dream of the day that I catch that miserable thief, Goraluk Anvilcrack.$B$BWe had a deal, him and I. A deal that he broke. Betrayed.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6247,'What deal?','What deal?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6248,'I would teach him how to demon forge in exchange for his soul. The soul of a Blackrock orc is worth very little but in these trying times, a soul, any soul, is better than none at all.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6249,'So how did he break the deal?','So how did he break the deal?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6250,'He took the unforged rune covered breastplate, used in the making of the demon forged breastplate and ran away without making payment. A fool, I am not, however... the unforged chest piece is useless without knowledge or the recipe to apply said knowledge.$B$BI wonder... does he sit safely in his city of Blackrock Spire and attempt to create the item from the raw material? I know he dare not leave!\n','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6251,'Perhaps I can be of some assistance. I will make a deal with you, Satyr. I shall recover this unforged breastplate and slay the beast, Goraluk Anvilcrack. In exchange for this task, you will teach me how to create the breastplate.','Perhaps I can be of some assistance. I will make a deal with you, Satyr. I shall recover this unforged breastplate and slay the beast, Goraluk Anvilcrack. In exchange for this task, you will teach me how to create the breastplate.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6252,'I TASTE THE BLOOD OF LIFE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6253,'I AM NEAR!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6254,'HAKKAR LIVES!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6255,'%s breaks apart and loses strength!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6256,'The liquids and mixtures all bubble and spasm as you approach. Next to the equipment lies a large pair of tongs that look as though they would be adequate for dropping in samples of ooze.$B$BThere is safety gear present, but it appears to be dusty and well-ignored.$B$BDo you place some of your samples into the beakers?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6257,'%s explodes and releases several Bile Slimes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6258,'%s belches out a disgusting Bile Slime!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6259,'','Ha ha, $n! I won\'t ever forget the look on Daryl\'s face when you showed him that head!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6260,'Leave this place!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6261,'My turn, meathead! I get to throw now.','My turn, meathead! I get to throw now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6262,'You threw last one, idiot. It\'s my turn.','You threw last one, idiot. It\'s my turn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6263,'%s start pushing each other back and forth.','%s start pushing each other back and forth.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6264,'What does Dadanga like to eat?\n','What does Dadanga like to eat?\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6265,'','Since we\'ve begun our stay in the crater, Dadanga\'s taken a liking to the large bloodpetal sprouts that grow all over the place here.$B$BI\'m sure she\'d enjoy a snack, if you feel like bringing her some...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6266,'OK, OK! It\'s your turn!','OK, OK! It\'s your turn!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6267,'Heya mon.  Once I get my hands on a few more supplies, I fix ya right up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6268,'Dis here volunteer work be my way of gettin through Witch Doctor School.  Since you help me, I help ya for free.  Whatcha need fixin?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6269,'Low spirits','Low spirits',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6270,'%s whimpers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6271,'%s breathes erratically. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6272,'%s cries for help.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6273,'I... I am badly injured... ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6274,'Save me...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6275,'You will be ok, Awbee. Your assailants have been terminated.','You will be ok, Awbee. Your assailants have been terminated.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6276,'Listen, $r. Listen well...$B$BThe dragon riders came in the night, mounted atop the black flight. They struck fast and with deadly precision, taking young whelps - such as me - and escaping under the veil of darkness.$B$BI watched in horror as they used my brothers and sisters in their experiments. From our essence would be created the chromatic flight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6277,'Continue please...','Continue please...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6278,'Nefarian had ordered that unsuitable subjects be destroyed immediately, but these retched beasts would not do so without first inflicting an \'ample\' amount of torture.$B$BWhen we were thoroughly \'broken,\' they would round up what remained and throw us to these thugs. Our bodies used as instruments in their sick game: thrown into the lava or worse; to the open and waiting arms of the bloodthirsty legion below.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6279,'Horrifying.','Horrifying.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6280,'You came along just as they were about to throw me to the fiends below - for that, I thank you. Perhaps, I - rather - we, of the blue flight, can assist you further?$B$BYou have come this far, $r, risked much. Will you go a ways further to battle Nefarian and his legion of Blackrock? ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6281,'Absolutely.','Absolutely.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6282,'You cannot save him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6283,'Bad hang nail','Bad hang nail',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6284,'Feeling underpowered','Feeling underpowered',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6285,'Jungle Fever','Jungle Fever',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6286,'Uni-brow','Uni-brow',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6287,'Whiplash','Whiplash',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6288,'I don\'t want to go back to work','I don\'t want to go back to work',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6289,'The Ash\'ari Crystals have been destroyed! The Slaughterhouse is vulnerable!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6290,'If you are here to hunt dragons, be my guest.  Where should I send my condolences?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6291,'Your stench will attract every dragon for miles.  Tell me what you want, and quickly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6292,'The spirits told me you would come, that you would seek me for some reason, but that even you may not know that reason. So, do you know why you are here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6293,'','Oh hi! My name\'s Sarah. What can I do for you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6294,'','The forest told me of your presence, but not why you were here. So, speak and enlighten me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6295,'How you doin\' mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6296,'','The Emerald Circle welcomes you, $n.$B$BHopefully together we can help rejuvenate and protect this once-mighty forest. Many forces seek to destroy it from without... and within.$B$BDo not be persuaded by the power here--it will only corrupt you, like it has this entire land.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6297,'While Greta focuses her energy on the recovery of Jaedenar and those who she thinks is mostly responsible for the corruption here in Felwood. I spend my time looking into the effects the corruption has had on the land.$B$BHow has it affected the creatures of the land? What must be done to end the pain of their suffering?$B$BUnfortunately, the corruption runs so deep that eternal sleep is too often the answer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6298,'Tucked away in the Mage Quarter, there is a little shop called Alchemy Needs.  You\'re bound to see all sort of strange shops on your way through the Mage Quarter, but if you stick to the outer rim you\'ll be sure to find it.','Tucked away in the Mage Quarter, there is a little shop called Alchemy Needs.  You\'re bound to see all sort of strange shops on your way through the Mage Quarter, but if you stick to the outer rim you\'ll be sure to find it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6299,'Stormwind Counting House is located by the front gates in the Trade District of Stormwind. And when you get tired of counting your money, be sure to stop by the Gilded Rose for a drink.','Stormwind Counting House is located by the front gates in the trade district of Stormwind. And when you get tired of counting your money, be sure to stop by the Gilded Rose for a drink.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(6300,'You mean you can\'t smell the smoke of the Dwarven forges from here?  Well, you will be looking for Therum Deepforge if you want to learn blacksmithing.  He\'s over in the Dwarven District which is just north of the Cathedral Square.','You mean you can\'t smell the smoke of the Dwarven forges from here?  Well, you will be looking for Therum Deepforge if you want to learn blacksmithing.  He\'s over in the Dwarven District which is just north of the Cathedral Square.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(6301,'','%s jumps in fright!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6302,'','Ahhhhh!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6303,'','You big meanie! Who put you up to this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6304,'','It was Umi, wasn\'t it?! She\'s always playing jokes on me, and now she\'s got you in on it too!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6305,'','%s sighs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6306,'','%s jumps in fright!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6307,'','Ahhhh!!! What is that thing?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6308,'','Umi sent you, didn\'t she?! She told me to expect a surprise, but I never thought that this is what she meant!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6309,'There\'s a great cook who works at the Pig and Whistle Tavern in Old Town.  I\'ve watched him use a knife when he cooks and just between you and me, I don\'t think he\'s always been a cook.  Don\'t get me wrong... if you still want to learn, he\'s the best we have.','There\'s a great cook who works at the Pig and Whistle Tavern in Old Town.  I\'ve watched him use a knife when he cooks and just between you and me, I don\'t think he\'s always been a cook.  Don\'t get me wrong... if you still want to learn, he\'s the best we have.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6310,'Ah, you\'re looking for Lucan Cordell.  He runs a shop on the outside of the Magic Quarter on your way to the Stockade.  ','Ah, you\'re looking for Lucan Cordell.  He runs a shop on the outside of the Magic Quarter on your way to the Stockade.  ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6311,'%s attempts to get help!','%s attempts to get help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6312,'Hey, that reminds me, I need to have my rocket boots repaired.  Word to the wise my friend, rocket boots and gryphons don\'t mix.  \n\nOh, but you need directions...  just head on over to the Dwarven District, you\'ll find Lilliam Sparkspindle towards the back.','Hey, that reminds me, I need to have my rocket boots repaired.  Word to the wise my friend, rocket boots and gryphons don\'t mix.  \n\nOh, but you need directions...  just head on over to the Dwarven District, you\'ll find Lilliam Sparkspindle towards the back.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6313,'No better place to learn First Aid than under the watchful eye of Angela Leifeld at the Cathedral of Light.  \n\nTo get there, just look for the yellow rooftops, or the towering spire of the Cathedral itself which you can see from almost anywhere in the city.','No better place to learn First Aid than under the watchful eye of Angela Leifeld at the Cathedral of Light.  \n\nTo get there, just look for the yellow rooftops, or the towering spire of the Cathedral itself which you can see from almost anywhere in the city.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6314,'Oh!!! Get that thing away from me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6315,'That bum Leland... all he does is sit out on the dock outside the Trade District and fish all day.  I sure hope he\'s good at it for all the time he spends fishing.  If you want to learn, why don\'t you go talk to him?','That bum Leland... all he does is sit out on the dock outside the Trade District and fish all day.  I sure hope he\'s good at it for all the time he spends fishing.  If you want to learn, why don\'t you go talk to him?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6316,'There\'s nothing quite like communing with nature... or at least that\'s what the night elves tell me.  I\'m not much for talking to flowers and trees, but I\'m sure Tannysa could help you out.  She\'s over in the Mage Quarter outside of Alchemy Needs.','There\'s nothing quite like communing with nature... or at least that\'s what the night elves tell me.  I\'m not much for talking to flowers and trees, but I\'m sure Tannysa could help you out.  She\'s over in the Mage Quarter outside of Alchemy Needs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6317,'Why do you chase me, Mechanical Yeti?! WHY?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6318,'%s runs quickly away from Umi\'s Mechanical Yeti.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6319,'A Hunter is it?  Well, then you will want to speak with Thorfin Stoneshield over in the Dwarven District.  \n\nOh, and you be sure to tell him that if I step in his pet\'s business one more time, he\'s going to be training other hunters from behind bars in the Stockade!','A Hunter is it?  Well, then you will want to speak with Thorfin Stoneshield over in the Dwarven District.  \n\nOh, and you be sure to tell him that if I step in his pet\'s business one more time, he\'s going to be training other hunters from behind bars in the Stockade!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6320,'I\'m jumpy as it is... and people insist on scaring me... Next time, though, I\'ll be ready!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6321,'You\'re into leather, eh?  Sounds like you should talk to Simon Tanner over in Old Town.  He runs a shop there called the Protective Hide.','You\'re into leather, eh?  Sounds like you should talk to Simon Tanner over in Old Town.  He runs a shop there called the Protective Hide.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6322,'%s looks relieved.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6323,'Leave it to the dwarves to send a mining specialist from Ironforge to tell us how to mine.  How hard is it to take a pick and chip away at some rock?  Well, since he\'s here, he\'s probably the one you should see anyhow.  His name is Gelman and he resides over in the Dwarven District.','Leave it to the dwarves to send a mining specialist from Ironforge to tell us how to mine.  How hard is it to take a pick and chip away at some rock?  Well, since he\'s here, he\'s probably the one you should see anyhow.  His name is Gelman and he resides over in the Dwarven District.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6324,'You know, I could run an orc through or slice up a troll.  I could even carve my initials in an ogre\'s flank, but I just can\'t stand to skin an animal.  Go figure, eh.  \n\nWell, if you have the stomach for it, then go see Maris Granger at the Protective Hide in Old Town.','You know, I could run an orc through or slice up a troll.  I could even carve my initials in an ogre\'s flank, but I just can\'t stand to skin an animal.  Go figure, eh.  \n\nWell, if you have the stomach for it, then go see Maris Granger at the Protective Hide in Old Town.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6325,'A tailor is it?  Well, if you hang out here long enough you\'ll eventually hear word of mouth about Georgio Bolero.  He\'s been setting the trends for some months now.  If you wish to learn from him, you can find him over in the Mage Quarter in the outer rim.','A tailor is it?  Well, if you hang out here long enough you\'ll eventually hear word of mouth about Georgio Bolero.  He\'s been setting the trends for some months now.  If you wish to learn from him, you can find him over in the Mage Quarter in the outer rim.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6326,'Warlocks, eh.  Well, you didn\'t hear it from me, but I\'ve heard rumors that those types gather at a bar called the Slaughtered Lamb in the Mage Quarter.  ','Warlocks, eh.  Well, you didn\'t hear it from me, but I\'ve heard rumors that those types gather at a bar called the Slaughtered Lamb in the Mage Quarter.  ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6327,'%s marches around, roaring and making a ruckus.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6328,'Deeprun Tram','Deeprun Tram',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6329,'RAAAAAAAR!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6330,'You don\'t have the stomach for the gryphon ride, huh.  Well lucky for you, we have an alternative where you can keep your feet on the ground... more or less.  It\'s the gnomish mover of people, the Deeprun Tram.  Conveniently located in the back of the Dwarven District.','You don\'t have the stomach for the gryphon ride, huh.  Well lucky for you, we have an alternative where you can keep your feet on the ground... more or less.  It\'s the gnomish mover of people, the Deeprun Tram.  Conveniently located in the back of the Dwarven District.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6331,'You\'ve heard about the Tram have you?  What a ride that thing is!  You\'ll find it in the Dwarven District towards the back.  Oh, and be sure to keep your arms and legs inside the tram while the tram is in motion.','You\'ve heard about the Tram have you?  What a ride that thing is!  You\'ll find it in the Dwarven District towards the back.  Oh, and be sure to keep your arms and legs inside the tram while the tram is in motion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6332,'Study it, $n: The Catalogue of the Wayward.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6333,'Aye, everyone wants to ride the tram to Stormwind, it\'s a real hoot and a half.  Well, if ye want to find the tram, it\'s located over in Tinker Town just east of the gates of Ironforge.','Aye, everyone wants to ride the tram to Stormwind, it\'s a real hoot and a half.  Well, if ye want to find the tram, it\'s located over in Tinker Town just east of the gates of Ironforge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6334,'Oh, the tram, the tram...  everyone wants to ride the tram to Stormwind.  What happened to the good ol\' days of flying on the back of a gryphon, gripping the saddle for dear life as you flew up high in the sky above?  \n\nBah!  You go take the tram then... it\'s over in Tinker Town with the rest of the gnomish contraptions.','Oh, the tram, the tram...  everyone wants to ride the tram to Stormwind.  What happened to the good ol\' days of flying on the back of a gryphon, gripping the saddle for dear life as you flew up high in the sky above?  \n\nBah!  You go take the tram then... it\'s over in Tinker Town with the rest of the gnomish contraptions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6335,'Are ye really askin\' me where the Blacksmith is?  Have ye not heard of The Great Forge!?  All our best blacksmiths gather there to craft their weapons and armor!  \n\nIt\'s dead smack in the middle of Ironforge, and that\'s where you\'ll find one of our most brilliant blacksmiths, Bengus Deepforge.  ','Are ye really askin\' me where the Blacksmith is?  Have ye not heard of The Great Forge!?  All our best blacksmiths gather there to craft their weapons and armor!  \n\nIt\'s dead smack in the middle of Ironforge, and that\'s where you\'ll find one of our most brilliant blacksmiths, Bengus Deepforge.  ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6336,'Och!  That Daryl Riknussun is a brilliant cook!  He makes a chilli so hot ye could temper steel with it!  I don\'t think he\'ll teach ye the recipe, but he\'ll certainly help ye to become a good cook.  Ye\'ll find him at the Bronze Kettle o\'er on the northeastern side of The Great Forge.','Och!  That Daryl Riknussun is a brilliant cook!  He makes a chilli so hot ye could temper steel with it!  I don\'t think he\'ll teach ye the recipe, but he\'ll certainly help ye to become a good cook.  Ye\'ll find him at the Bronze Kettle o\'er on the northeastern side of The Great Forge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6337,'Oh, you\'re looking for Springspindle Fizzlegear then.  Why that little gnome and his gadgets...  Let me tell you, if you\'re going to his shop in Tinker Town, keep your hands to yourself and don\'t pet any of his mechanical sheep!  \n\nExploding sheep... now why would you even make such a thing!?','Oh, you\'re looking for Springspindle Fizzlegear then.  Why that little gnome and his gadgets...  Let me tell you, if you\'re going to his shop in Tinker Town, keep your hands to yourself and don\'t pet any of his mechanical sheep!  \n\nExploding sheep... now why would you even make such a thing!?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6338,'First Aid?  Well ye don\'t look hurt to me.  If yer really interested in learning First Aid, then Nissa Firestone is the one to learn from.  Go see her over by The Great Forge in her shop, The Ironforge Physician.','First Aid?  Well ye don\'t look hurt to me.  If yer really interested in learning First Aid, then Nissa Firestone is the one to learn from.  Go see her over by The Great Forge in her shop, The Ironforge Physician.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6339,'I once heard ol\' Grimnur say he fished up a sword.  Or was it a swordfish?  Damn that Grimnur, he\'s told so many fish tales I can\'t remember which is which.  Well, why don\'t you go see him over in The Forlorn Cavern and have him tell you what it was.','I once heard ol\' Grimnur say he fished up a sword.  Or was it a swordfish?  Damn that Grimnur, he\'s told so many fish tales I can\'t remember which is which.  Well, why don\'t you go see him over in The Forlorn Cavern and have him tell you what it was.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6340,'Well now, ye\'ll need papers to form a guild, and Jondor Steelbrow can help you get started with the process.  He can be found over at the Ironforge Visitor\'s Center when yer ready to get started.','Well now, ye\'ll need papers to form a guild, and Jondor Steelbrow can help you get started with the process.  He can be found over at the Ironforge Visitor\'s Center when yer ready to get started.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6341,'Do ye have the potential to be a skilled hunter?  Well $gladdie : lassie;, only time will tell.  Just don\'t ye go shooting at apples atop peoples\' heads till ye\'ve spoken with Regnus o\'er in the Hall of Arms.','Do ye have the potential to be a skilled hunter?  Well $gladdie : lassie;, only time will tell.  Just don\'t ye go shooting at apples atop peoples\' heads till ye\'ve spoken with Regnus o\'er in the Hall of Arms.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6342,'Sure ye don\'t want to be a Blacksmith?  Well, if yer heart is set on Leatherworking, then you best talk to Fimble Finespindle over at his shop on the northwest side of The Great Forge.','Sure ye don\'t want to be a Blacksmith?  Well, if yer heart is set on Leatherworking, then you best talk to Fimble Finespindle over at his shop on the northwest side of The Great Forge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6343,'Bah!  Mailboxes...  all I get is junk mail lately!  \n\nIncrease the size of this... decrease the size of that... act now for your free Sword of Dragonslaying.  I have to change my mailbox number every other month!  \n\nWell, ye can\'t say I didn\'t warn ye.  If you\'re looking for the mailbox it\'s just outside the Stonefire Tavern.','Bah!  Mailboxes...  all I get is junk mail lately!  \n\nIncrease the size of this... decrease the size of that... act now for your free Sword of Dragonslaying.  I have to change my mailbox number every other month!  \n\nWell, ye can\'t say I didn\'t warn ye.  If you\'re looking for the mailbox it\'s just outside the Stonefire Tavern.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6344,'Well well!  You\'ve come to the right place to learn Mining, $gboyo : girlie;!  Geofram Bouldertoe himself resides at Deepmountain Mining and Jewelcrafting.  Ye couldn\'t ask for a better instructor than him.','Well well!  You\'ve come to the right place to learn Mining, $gboyo : girlie;!  Geofram Bouldertoe himself resides at Deepmountain Mining and Jewelcrafting.  Ye couldn\'t ask for a better instructor than him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6345,'The book tells of dragons uniting against another, more powerful dragon, named Deathwing. From what you can make out, the chromatic dragonflight had almost been unleashed upon the world. The Aspects were prepared.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6346,'Ah, nothing better than a priest to cure what ails ye.  Of course a nice tall pint cures a lot of what ails ye too, but I don\'t think Braenna Flintcrag teaches brewing.  I guess ye\'ll have to settle for some priest training over in the Hall of Mysteries instead.','Ah, nothing better than a priest to cure what ails ye.  Of course a nice tall pint cures a lot of what ails ye too, but I don\'t think Braenna Flintcrag teaches brewing.  I guess ye\'ll have to settle for some priest training over in the Hall of Mysteries instead.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6347,'Ye might not know it, but in addition to being a skilled tailor, Jormund is also a slayer of giants!  Why he must have overheard a few of us sharing stories when he shouted that he\'d killed seven with one blow!  \n\nYe should pay him a visit at his store on the north side of The Great Forge an\' see if he\'ll tell ye the tale!','Ye might not know it, but in addition to being a skilled tailor, Jormund is also a slayer of giants!  Why he must have overheard a few of us sharing stories when he shouted that he\'d killed seven with one blow!  \n\nYe should pay him a visit at his store on the north side of The Great Forge an\' see if he\'ll tell ye the tale!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6348,'Skinning?  The only thing ye look like ye could skin is yer own knee!  Ha!  Now why don\'t you go see Balthus Stoneflayer so he can teach you how to properly skin some animals.  You\'ll find him in Finespindle\'s Leather Goods on the northern side of The Great Forge.','Skinning?  The only thing ye look like ye could skin is yer own knee!  Ha!  Now why don\'t you go see Balthus Stoneflayer so he can teach you how to properly skin some animals.  You\'ll find him in Finespindle\'s Leather Goods on the northern side of The Great Forge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6349,'A warlock, eh...  Well, if you\'ve got a mind to be doing that sort of thing around here then ye best keep yer demons on a leash $gboyo : girlie;.  I don\'t like demons, but I love putting mah axe to them.  Ye get me?  \n\nNow you just leave me be and go get lost in The Forlorn Cavern.  That\'s where you\'ll find that warlock, Thistleheart.','A warlock, eh...  Well, if you\'ve got a mind to be doing that sort of thing around here then ye best keep yer demons on a leash $gboyo : girlie;.  I don\'t like demons, but I love putting mah axe to them.  Ye get me?  \n\nNow you just leave me be and go get lost in The Forlorn Cavern.  That\'s where you\'ll find that warlock, Thistleheart.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6350,'Kelstrum is a loudmouth and a braggart... and if that weren\'t enough he\'s also one of the most skilled warriors ye\'ll ever meet!  \n\nI tell ye, if ye\'re looking to be trained in the ways of a warrior, that\'s who ye should be talking to.  I\'m sure he can be found over in the Hall of Arms east of the Gates of Ironforge.','Kelstrum is a loudmouth and a braggart... and if that weren\'t enough he\'s also one of the most skilled warriors ye\'ll ever meet!  \n\nI tell ye, if ye\'re looking to be trained in the ways of a warrior, that\'s who ye should be talking to.  I\'m sure he can be found over in the Hall of Arms east of the Gates of Ironforge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6351,'Deeprun Tram','Deeprun Tram',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6352,'NO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6353,'An alchemist?  No trouble at all $c.  Ainethil, in all her labor and toil, has become the most accomplished alchemist in the Craftsmen\'s Terrace.  I would head over there on the double if I were you. On the double!  Now off with you!','An alchemist?  No trouble at all $c.  Ainethil, in all her labor and toil, has become the most accomplished alchemist in the Craftsmen\'s Terrace.  I would head over there on the double if I were you. On the double!  Now off with you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6354,'Another material $gboy : girl; are we?  Well, if you are obsessed with your precious items then you will probably want to store them at the Darnassus Bank in the center of our city.','Another material $gboy : girl; are we?  Well, if you are obsessed with your precious items then you will probably want to store them at the Darnassus Bank in the center of our city.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6355,'Astaia has fished up some curious treasures over the ages she has spent fishing.  Why don\'t you go see her over in the Tradesman\'s terrace and have her show you some of them.','Astaia has fished up some curious treasures over the ages she has spent fishing.  Why don\'t you go see her over in the Tradesman\'s terrace and have her show you some of them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6356,'Lysheana can offer you the proper documents, she resides in the Craftsmen\'s Terrace in northeasten Darnassus.  May your fellowship bring glory to the Night Elves!','Lysheana can offer you the proper documents, she resides in the Craftsmen\'s Terrace in northeasten Darnassus.  May your fellowship bring glory to the Night Elves!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6357,'It is Vesprystus that you seek.  He watches over the hippogryphs that come and go from the base of Teldrassil.  You will find him through the portal in western Darnassus that will take you to Rut\'theran Village.','It is Vesprystus that you seek.  He watches over the hippogryphs that come and go from the base of Teldrassil.  You will find him through the portal in western Darnassus that will take you to Rut\'theran Village.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6358,'Jocaste was the greatest of Hunters of her time.  These days you can find her over in the Cenarion Enclave where she teaches those who are just starting down the Hunter\'s path.','Jocaste was the greatest of Hunters of her time.  These days you can find her over in the Cenarion Enclave where she teaches those who are just starting down the Hunter\'s path.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6359,'Has the sun risen already?  There are just never enough hours in the night!  Well, Saelienne will take good care of you.  You can find her tending to her guests over in the Craftsmen\'s Terrace in northeastern Darnassus.','Has the sun risen already?  There are just never enough hours in the night!  Well, Saelienne will take good care of you.  You can find her tending to her guests over in the Craftsmen\'s Terrace in northeastern Darnassus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6360,'A mailbox?  You have a letter to send, or perhaps have received one?  I hope it\'s something good!  There\'s a mailbox right outside of the Bank in the center of Darnassus.','A mailbox?  You have a letter to send, or perhaps have received one?  I hope it\'s something good!  There\'s a mailbox right outside of the Bank in the center of Darnassus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6361,'As a culture we believe in letting nothing go to waste.  When we are forced to slay a creature we take what we can to make sure its sacrifice was not in vain.  \n\nIf you wish to learn the proper way to take the skin of a slain beast, then seek out Eladriel in the Craftsmen\'s Terrace.','As a culture we believe in letting nothing go to waste.  When we are forced to slay a creature we take what we can to make sure its sacrifice was not in vain.  \n\nIf you wish to learn the proper way to take the skin of a slain beast, then seek out Eladriel in the Craftsmen\'s Terrace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6362,'With the garments that Me\'Lynn tailors, one might think that her needle was blessed by Elune herself.  Unless your needle is so blessed, you best pay her a visit and listen to her teachings.  You can find her in The Craftsmen\'s Terrace in northeastern Darnassus.','With the garments that Me\'Lynn tailors, one might think that her needle was blessed by Elune herself.  Unless your needle is so blessed, you best pay her a visit and listen to her teachings.  You can find her in The Craftsmen\'s Terrace in northeastern Darnassus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6363,'Sildinair has trained many of the Sentinels who guard our beloved city.  I am certain she can make a warrior out of the likes of you.  Seek her out at the Warrior\'s Terrace near the entrance to our city.','Sildinair has trained many of the Sentinels who guard our beloved city.  I am certain she can make a warrior out of the likes of you.  Seek her out at the Warrior\'s Terrace near the entrance to our city.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6364,'You want to learn how to make a campfire?  Well then you had best see Malygen in the Cenarion Enclave before you set fire to Teldrassil itself.  ','You want to learn how to make a campfire?  Well then you had best see Malygen in the Cenarion Enclave before you set fire to Teldrassil itself.  ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6365,'One has opened up on the Tradesman\'s Terrace.  If you take the path leading Southeast from the bank, it should be easy to find.','One has opened up on the Tradesman\'s Terrace.  If you take the path leading Southeast from the bank, it should be easy to find.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6366,'Oh, the ever-present obsession with material wealth.  Well, fortune smiles on you, as you can find the auction house in the Tradesman\'s Terrace.','Oh, the ever-present obsession with material wealth.  Well, fortune smiles on you, as you can find the auction house in the Tradesman\'s Terrace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6367,'It is in the western portion Trade District, just north of the fountain.','It is in the western portion Trade District, just north of the fountain.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6368,'Another entrepreneur, eh? Well, the Auction House can be found in the Trade District.  Not far from the bank.\n','Another entrepreneur, eh? Well, the Auction House can be found in the Trade District.  Not far from the bank.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6369,'Auction House','Auction House',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6370,'Trade District Auction House','Trade District Auction House',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6371,'THIS CANNOT BE!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6372,'All hands to battle stations! Naga incoming!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6373,'%s explodes into poisonous goo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6374,'You dare defile this holy ground?','You dare defile this holy ground?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6375,'Be cleansed by blade, filth!','Be cleansed by blade, filth!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6376,'Enemies have reached the door!  Move in!  We must hold!','Enemies have reached the door!  Move in!  We must hold!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6377,'Move back and hold the line!  We cannot fail or all will be lost!','Move back and hold the line!  We cannot fail or all will be lost!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6378,'Move to the stairs and defend!','Move to the stairs and defend!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6379,'They have broken into the Hall of Lights!  We must stop the intruders!','They have broken into the Hall of Lights!  We must stop the intruders!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6380,'This will not be the end of the Scarlet Crusade!  You will not break our line!','This will not be the end of the Scarlet Crusade!  You will not break our line!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6381,'Hello, traveler. Not many find me out this way.$B$BMy name is Rivern, and I train the Winterspring Frostsabers to become mounts.$B$BThese cats are the most feral and difficult to subdue of all the sabers. Only the most trusted and exalted may attempt to ride one.$B$BI will not sell such a mount to just anyone; no, you must work for it and earn your acceptance not only with me, but with the sabers themselves.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6382,'Information on the Chromatic Carapace.','Information on the Chromatic Carapace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6383,'Information on Brilliant Chromatic Scales.','Information on Brilliant Chromatic Scales.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6384,'Information on the Blood of Heroes.','Information on the Blood of Heroes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6385,'Information on Frayed Abomination Stitchings.','Information on Frayed Abomination Stitchings.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6386,'Information on the Skin of Shadow.','Information on the Skin of Shadow.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6387,'Presumed to exist. Only a greater chromatic dragonkin or dragon could possess such a carapace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6388,'Commonly found on the lesser chromatic flight: Whelps, broodlings, lesser wyrmkin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6389,'Legend claims that in places of extreme conflict, across what is now known as the Plaguelands; clean and holy springs may erupt from the ground. The water from those springs has been named \'Blood of Heroes,\' by artisans and commonfolk alike - in honor of those that fell in the war against the Scourge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6390,'The threads that holds together the abominations of Stratholme are highly sought after by artisan craftsmen: Extremely resilient - nearly unbreakable.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6391,'Used by the Barov family of the Scholomance as a mirror into the souls that they no longer possess. A valuable keepsake.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6392,'There are many establishments where you can get a drink in Stormwind, but only one will let you spend the night. Head over to the Gilded Rose in the Trade District. I\'ve heard the cost of a room is reasonable and the sheets are clean. ','There are many establishments where you can get a drink in Stormwind, but only one will let you spend the night. Head over to the Gilded Rose in the Trade District. I\'ve heard the cost of a room is reasonable and the sheets are clean. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6393,'Ah, The Gilded Rose... with its soft down beds and warm baths... just thinking about that Inn makes me want to... ::yawn:: Lucky you if you\'re heading over there...  you will find it in the west side of the Trade District.   ...nice soft pillows, warm blankets.  ::yawn::','Ah, The Gilded Rose... with its soft down beds and warm baths... just thinking about that Inn makes me want to... ::yawn:: Lucky you if you\'re heading over there...  you will find it in the west side of the Trade District.   ...nice soft pillows, warm blankets.  ::yawn::',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6394,'There is a mailbox located conveniently right between the Stormwind Bank and The Gilded Rose Inn in the Trade District.','There is a mailbox located conveniently right between the Stormwind Bank and The Gilded Rose Inn in the Trade District.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6395,'I don\'t know how they do it...  those mailboxes must be magic portals or something.  Why I see people gathered around the mailbox next to the bank all day pulling swords and shields and various armor all from that small box!','I don\'t know how they do it...  those mailboxes must be magic portals or something.  Why I see people gathered around the mailbox next to the bank all day pulling swords and shields and various armor all from that small box!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6396,'Inn','Inn',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6397,'Mailbox','Mailbox',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6398,'So you see fit to toy with the Lich King\'s creations? Ramstein, be sure to give the intruders a proper greeting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6399,'I would like to buy from you.','I would like to buy from you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6400,'','Hi! I just got back from exploring the Ruins of Kel\'Theril, to the southwest. Now I\'m intent on investigating the Wildkin that lie just up the ridge here, in Owl Wing Thicket.$B$BHave you spoken to Erelas Ambersky in Rut\'theran Village? He requested that I come here, and perhaps he has a task for you as well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6401,'Time to take matters into my own hands. Come. Enter my domain and challenge the might of the Scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6402,'I don\'t get paid enough for this bull excrement!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6403,'I can\'t take these taxes! F.I.C.A. me? F.I.C.A. YOU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6404,'Hey! Do you like the sauce? The sauce is good, no?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6405,'And then the Tauren said, \'13 INCHES!\'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6406,'I come from the land down under... where women plague and men sunder.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6407,'The what-bringer? Oh, ASHbringer? Never heard of it... What? Stop bothering me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6408,'I should have taken the translucent pill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6409,'Just sit right back and you\'ll hear a ta... *hic* a tai... *hic* a taiiii *hic* Damnit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6410,'','Have you seen Watcher Backus? So brave...$B$BI think he\'s the toughest of all the Night Watch. I wonder if he even notices I\'m around....',6,24,0,0,0,0,0,0,1,0,0,0,26124),
(6411,'The temperature is... not hot enough!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6412,'*sigh* ...113 degrees Kraklenheit. Can\'t you do any better?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6413,'You\'re getting warmer... 7039 degrees Kraklenheit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6414,'8536 degrees Kraklenheit is the reading... Tired of me yet?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6415,'Who dares disturb our master?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6416,'','Hurray!  My doll!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6417,'','You\'ll keep the bad people away, won\'t you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6418,'','Let\'s find out the whole story.  That\'s going to take some magic...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6419,'','There, it is done.  The book has been enhanced...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6420,'Looking for these???? You\'ll never have em!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6421,'The bastion is falling! Burn the evidence!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6422,'I\'m going to wear your skin as a smoking jacket! The stogies? You\'ll have to pry them from my cold dead... er... RAWR!!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6423,'Leave nothing behind!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6424,'Destroy the records before the bastion falls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6425,'Ramstein hunger for flesh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6426,'Welcome to flavor country!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6427,'Thank you!  You freed me!','Thank you!  You freed me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6428,'Oh, thank you!  I have been trapped in this nightmare for so long...','Oh, thank you!  I have been trapped in this nightmare for so long...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6429,'At last, my soul is free!','At last, my soul is free!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6430,'Thank you!  The battle for Darrowshire doomed me, but you have set me free!','Thank you!  The battle for Darrowshire doomed me, but you have set me free!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6431,'Ah!  Please, if you see a survivor of Darrowshire, tell them I am free!','Ah!  Please, if you see a survivor of Darrowshire, tell them I am free!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6432,'','The Emerald Circle strives to heal the wounded land of Felwood. Although the land is named for the very thing that has corrupted it, we hope that one day we will be able to eradicate the corruption from this land.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6433,'','I\'m ready, $n. Let\'s find my equipment and get out of here. I think I know where it is.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6434,'','We\'ve failed, $n!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6435,'','Hello, $c. I am Jessir Moonbow. I have come from Darnassus seeking two friends who came looking for signs of the Shadow Council in Felwood.$B$BIt seems those vile creatures who claim responsibility for much of the orcish race\'s suffering seeks to regain some of its power.$B$BMy two friends went looking in Jaedenar to prove one way or the other what was happening.$B$BI expected them to be here when I arrived, but now they are days late.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6436,'The Scourge have broken into the Bastion!  Redouble your efforts!  We must not fail!','The Scourge have broken into the Bastion!  Redouble your efforts!  We must not fail!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6437,'Skeletons have advanced past the Hall of Lights!  Destroy them!','Skeletons have advanced past the Hall of Lights!  Destroy them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6438,'Our defenses are failing!  By the light we must prevail!','Our defenses are failing!  By the light we must prevail!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6439,'The Scourge have broken through in all wings!  May the light defeat these foul creatures!  We shall fight to the last!','The Scourge have broken through in all wings!  May the light defeat these foul creatures!  We shall fight to the last!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6440,'Zug zug, brave $c!  I have the finest bred wolf mounts for you to peruse.  You\'ll not find another animal with the level of endurance and survival instincts that the wolf has anywhere!  Please, inspect them for yourself.','Zug zug, brave $c!  I have the finest bred wolf mounts for you to peruse.  You\'ll not find another animal with the level of endurance and survival instincts that the wolf has anywhere!  Please, inspect them for yourself.',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(6441,'Today you have unmade what took me years to create! For this you shall all die by my hand!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6442,'Damn you mortals! All my plans of revenge, all my hate...I will be avenged...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6443,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6444,'I only make my mounts available to those who are considered friendly to Orgrimmar and the Orcish race.  Go prove yourself to us, and I\'ll make my mighty wolves available for your inspection.','I only make my mounts available to those who are considered friendly to Orgrimmar and the Orcish race.  Go prove yourself to us, and I\'ll make my mighty wolves available for your inspection.',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(6445,'And a good day to ya, brave $c.  I know ya be lookin\' for a fine steed.  There\'s no finer steed than a raptor under your reigns, lemme tell you $g mon : sis;!  Take a look at the ones I got to offer - bred from the fiercest stock anywhere.','And a good day to ya, brave $c.  I know ya be lookin\' for a fine steed.  There\'s no finer steed than a raptor under your reigns, lemme tell you $g mon : sis;!  Take a look at the ones I got to offer - bred from the fiercest stock anywhere.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(6446,'I\'m sorry $g mon : sis;, but I won\'t be sellin\' my raptors to someone who hasn\'t proven themselves to be a friendly to the Darkspear tribe.  When ya make a stand and show yourself to be at least friendly to us, then I\'ll make my raptors available to ya.','I\'m sorry $g mon : sis;, but I won\'t be sellin\' my raptors to someone who hasn\'t proven themselves to be a friendly to the Darkspear tribe.  When ya make a stand and show yourself to be at least friendly to us, then I\'ll make my raptors available to ya.',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(6447,'You fools think you can defeat me so easily? Face the true might of the Nathrezim!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6448,'Thieves! I shall smelt your remains!','Thieves! I shall smelt your remains!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6449,'Payment for those plans comes in bones - YOUR BONES!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6450,'Thank you, $n. My torment is now at an end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6451,'FREE!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6452,'The curse ends!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6453,'Praise be to Egan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6454,'May Kel\'Thuzad one day feel our vengeance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6455,'Rivendare must be destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6456,'','Oh my! Look at this... all these candles. I\'m sure they\'re used for some terrible ritual or dark summoning. We best make haste!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6457,'','There! Over there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6458,'','All I need now is a golden lasso.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6459,'','Let\'s get out of here, $n. I\'m ready now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6460,'','DIE, DEMON DOGS!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6461,'','Ah! Fresh air at last! I never thought I\'d see the day...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6463,'','What was that?! Trey? TREY!?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6464,'They hand the corpses to me, I toss them in the pit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6465,'I wish to make a purchase.','I wish to make a purchase.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6466,'BETRAYER!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6467,'','NO! What have they done to you!?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6468,'','No! My friend... what\'s happened? This is all my fault...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6469,'','I can travel faster on my own from here, $n. Meet Jessir Moonbow near Ashenvale. She should be with the druids of the Emerald Circle. She\'ll tell you what to do next. Thank you so much for your help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6470,'No tampering with the mail!','No tampering with the mail!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6471,'Try again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6472,'Certainly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6473,'No chance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6474,'Here comes the postmaster!','Here comes the postmaster!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6475,'Greetings, $n. I am Myolor Sunderfury, keeper of the Great Forge.','',1,2,0,0,0,0,0,0,1,0,0,0,26124),
(6476,'I wish to become an armorsmith.','I wish to become an armorsmith.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6477,'I wish to become a weaponsmith.','I wish to become a weaponsmith.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6478,'Your skill in blacksmithing is exceptional, $n. The time has come to make a decision. There are two paths you may choose: The way of the weaponsmith or the art of the armorsmith.$B$BBe warned, when you have chosen to dedicate yourself to a path, there is no going back. The discipline each path requires leaves no room for hybrids.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6479,'','The time has come, my $g brother : sister; in arms, to take back the night from the Scourge!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(6480,'','The time has come, my $g brother : sister; in arms, to take back the night from the Scourge!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(6481,'Alas $c, you are not considered to be a true friend of Darnassus and the night elves of Teldrassil.  Only when you prove yourself to be friendly to us through deeds - not just mere words - will I then make available my selection of mounts for your perusal.','Alas $c, you are not considered to be a true friend of Darnassus and the night elves of Teldrassil.  Only when you prove yourself to be friendly to us through deeds - not just mere words - will I then make available my selection of mounts for your perusal.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6482,'By the grace of Elune, I am pleased to offer you the finest steed found anywhere in Teldrassil, and perhaps the world - the nightsaber.  For years, the Sentinel Army has relied on the value of these companions.$B$BTake your time friend and examine each one to your satisfaction.  I am sure you will not be disappointed.','By the grace of Elune, I am pleased to offer you the finest steed found anywhere in Teldrassil, and perhaps the world - the nightsaber.  For years, the Sentinel Army has relied on the value of these companions.$B$BTake your time friend and examine each one to your satisfaction.  I am sure you will not be disappointed.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6483,'Erm... I really don\'t know you that well, sorry.  I mean, as an authorized Mechano-strider dealer, I really only can sell my mounts to those people who are considered a friend of the gnomes.  If you ever are recognized as friendly to Gnomeregan, I\'d be happy to show you what I have to offer.','Erm... I really don\'t know you that well, sorry.  I mean, as an authorized Mechano-strider dealer, I really only can sell my mounts to those people who are considered a friend of the gnomes.  If you ever are recognized as friendly to Gnomeregan, I\'d be happy to show you what I have to offer.',24,0,0,0,0,0,0,0,1,0,0,0,26124),
(6484,'Um... I think you\'re a little too big to ride a Mechano-strider there, $g mister : ma\'am;.  You\'d likely crush the finely tuned servo-balancers!','Um... I think you\'re a little too big to ride a Mechano-strider there, $g mister : ma\'am;.  You\'d likely crush the finely tuned servo-balancers!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6485,'If you have come looking for the gift of fast and safe mobility, then you have arrived at your destination!  This year\'s model of the new Mechano-striders have recently arrived, and I am ready to show you all they have to offer!','If you have come looking for the gift of fast and safe mobility, then you have arrived at your destination!  This year\'s model of the new Mechano-striders have recently arrived, and I am ready to show you all they have to offer!',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(6486,'Speak with Ironus, $n. He\'ll be the one training you in the way of the weaponsmith.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6487,'Grumnus be your man, $n. He\'ll school you in the art of the armorsmith.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6488,'When the work of a blacksmith reaches your level of expert craftsmanship, I present them with a choice.$B$BWhile you are not required to make a choice, it is recommended that you do - after all, do you want to be a neophyte forever? It is the artisan armorsmiths and weaponsmiths that supply our armies, win our wars and garner acclaim!$B$BBe warned, $n. Once a choice is made and the tasks required completed - there is no going back. One can only walk down one path.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(6489,'I am Krathok, overseer of these craftsmen.','',1,25,0,0,0,0,0,0,1,0,0,0,26124),
(6490,'Borgosh! $n is ready to be trained.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(6491,'Okothos will train you, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6492,'One of the Ash\'ari Crystals has been destroyed!  Slay the intruders!','One of the Ash\'ari Crystals has been destroyed!  Slay the intruders!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6493,'An Ash\'ari Crystal has been restored!','An Ash\'ari Crystal has been restored!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6494,'$R flesh... must feed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6495,'Who dares to approach this cauldron?  Taste my dark blade!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6496,'The Scourge beckons you, foolish $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6497,'$C - I will consume your light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6498,'Greetings, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6499,'I require training.','I require training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6500,'Hail, $c!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6501,'I require training.','I require training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6502,'What do you want?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6503,'I require training.','I require training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6504,'Prepare to be Malowned!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6505,'','Highborne spirits! Be at peace! The Crystal of Zin-Malor is whole once again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6506,'','Cursed spirits! Let go of the past! The Crystal of Zin-Malor no longer binds you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6507,'','Spirits of the Highborne! You may now rest! The curse of the crystal releases you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6509,'Ya may not follow the ways of the Light like a Knight of the Silver Hand, but ya can always ask us for aid.','Ya may not follow the ways of the Light like a Knight of the Silver Hand, but ya can always ask us for aid.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6510,'The Light be with ya, $c. How can I help ya?','The Light be with ya, $c. How can I help ya?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6511,'%s raises an undead servant back to life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6512,'%s attempts to cast Death Pact on his servants!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6513,'I wish to purchase arcane quickener from you.','I wish to purchase arcane quickener from you.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(6514,'A fierce wind is coming - I can tell by the ache in my exposed knee.  I just hope we don\'t get caught up in it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6515,'Well now $n, let\'s get to work on those cauldrons!  If you\'re going to collect the components we need, then get a vitreous focuser from me.  You\'ll need to have it on you to identify the necessary resources found on the Scourge that will turn those cauldrons.$B$BYou\'ll also need a dose of arcane quickener for the cauldrons.  It\'s not cheap, nor is it stable.  Once you have it, you\'ll only have thirty minutes to use it before it expires on you; be smart about buying it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6516,'What\'s needed for the cauldron at Felstone Field?','What\'s needed for the cauldron at Felstone Field?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(6517,'What\'s needed for the cauldron at Dalson\'s Tears?','What\'s needed for the cauldron at Dalson\'s Tears?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(6518,'What\'s needed for the cauldron at the Writhing Haunt?','What\'s needed for the cauldron at the Writhing Haunt?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(6519,'What\'s needed for the cauldron at Gahrron\'s Withering?','What\'s needed for the cauldron at Gahrron\'s Withering?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(6520,'Based on the sample of the toxin you provided for us, we think you will need the following: an arcane quickener, six osseous agitators, and four pieces of runecloth.  With the vitreous focuser in tow, acquire the agitators from skeletal undead here in the Plaguelands!$B$BOnce you have these items, you should be able to load the counter agent into that cauldron.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6521,'Based on the sample of the toxin you provided for us, we think you will need the following: an arcane quickener, five somatic intensifiers, and and four pieces of runecloth.  With the vitreous focuser in tow, acquire the intensifiers from zombie or ghoul undead here in the Plaguelands!$B$BOnce you have these items, you should be able to load the counter agent into that cauldron.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6522,'Based on the sample of the toxin you provided for us, we think you will need the following: an arcane quickener, five somatic intensifiers, and and four pieces of runecloth.  With the vitreous focuser in tow, acquire the intensifiers from zombie or ghoul undead here in the Plaguelands!$B$BOnce you have these items, you should be able to load the counter agent into that cauldron.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6523,'Based on the sample of the toxin you provided for us, we think you will need the following: an arcane quickener, four ectoplasmic resonators, and four pieces of runecloth.  With the vitreous focuser in tow, acquire the resonators from wraith and ghostly undead here in the Plaguelands!$B$BOnce you have these items, you should be able to load the counter agent into that cauldron.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6524,'This job is definitely not worth sixteen-five a year.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6525,'Well now $n, let\'s get to work on those cauldrons!  If you\'re going to collect the components we need, then get a vitreous focuser from me.  You\'ll need to have it on you to identify the necessary resources found on the Scourge that will turn those cauldrons.$B$BYou\'ll also need a dose of arcane quickener for the cauldrons.  It\'s not cheap, nor is it stable.  Once you have it, you\'ll only have thirty minutes to use it before it expires on you; be smart about buying it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6526,'An Ash\'ari Crystal has fallen! Stay true to the Lich King, my brethren, and attempt to resummon it.','An Ash\'ari Crystal has fallen! Stay true to the Lich King, my brethren, and attempt to resummon it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6527,'An Ash\'ari Crystal has been toppled! Restore the ziggurat before the Slaughterhouse is vulnerable!','An Ash\'ari Crystal has been toppled! Restore the ziggurat before the Slaughterhouse is vulnerable!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6528,'Our summoning is complete! The Ash\'ari crystal has been restored!','Our summoning is complete! The Ash\'ari crystal has been restored!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6529,'Success is ours! The Ash\'ari Crystal has been restored!','Success is ours! The Ash\'ari Crystal has been restored!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6530,'You\'ve been MALOWNED!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6531,'I need a vitreous focuser.','I need a vitreous focuser.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(6532,'','Arise, my champion!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6533,'At your side, milady!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6534,'Blades of light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6535,'Release your rage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6536,'Awake, ye servants! Defend the Disks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6537,'To my side, brothers! For the Makers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6538,'Join us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6539,'','Shhh... do you smell something?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6540,'Liladris has been waiting for me at Maestra\'s Post, so we should make haste, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6541,'%s begins to drift off...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6542,'%s suddenly falls asleep.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6543,'Yaaaaawwwwwnnnn...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6544,'Oh, I am so tired...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6545,'You don\'t mind if I stop here for a moment, do you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6546,'%s emerges from the shadows to defend the cauldron!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6547,'The Scourge\'s plague still dominates the zone, and we have a long way to go before the plague will be altered enough to affect them.  Collect the necessary resources and help out the war effort!','The Scourge\'s plague still dominates the zone, and we have a long way to go before the plague will be altered enough to affect them.  Collect the necessary resources and help out the war effort!',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(6548,'We are having difficulty determining the status of the plague within the area; check back shortly and we may have a better idea.','We are having difficulty determining the status of the plague within the area; check back shortly and we may have a better idea.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6549,'The Scourge\'s plague is almost to the turning point; a handful more cauldron subversions will push us over the top!  Be sure to do your part to help out!','The Scourge\'s plague is almost to the turning point; a handful more cauldron subversions will push us over the top!  Be sure to do your part to help out!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6550,'We have begun to turn the Scourge\'s plague against them, but our hold is tenuous at best!  Be sure to aid the cause by subverting their cauldrons!','We have begun to turn the Scourge\'s plague against them, but our hold is tenuous at best!  Be sure to aid the cause by subverting their cauldrons!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(6551,'We are dominating the Scourge - the effects of the altered plague will affect them for at least another full day!  We need to stay on top of it though, so be sure to sabotage a cauldron when you can.','We are dominating the Scourge - the effects of the altered plague will affect them for at least another full day!  We need to stay on top of it though, so be sure to sabotage a cauldron when you can.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(6552,'How are we doing in the battle to subvert the cauldrons?','How are we doing in the battle to subvert the cauldrons?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(6553,'%s comes to rest as it begins to release the counter agent into the air.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6554,'The deeds are mine, brother! Soon you shall be out of my way for good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6555,'The fortune is mine, Alexi! Your end comes soon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6556,'The Hunter Trainer\'s name is Thotar.  Seek him out inside the burrow on the southwest corner of Razor Hill.','The Hunter Trainer\'s name is Thotar.  Seek him out inside the burrow on the southwest corner of Razor Hill.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6557,'You\'re a hunter?  Well anyway, you\'ll find Thotar hiding from the sun inside the burrow at the southwest corner of town.','You\'re a hunter?  Well anyway, you\'ll find Thotar hiding from the sun inside the burrow at the southwest corner of town.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6558,'Speak with Un\'Thuwa to the south in Sen\'jin Village.','Speak with Un\'Thuwa to the south in Sen\'jin Village.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6559,'That\'s troll business.  Look for Un\'Thuwa in Sen\'jin Village down south.','That\'s troll business.  Look for Un\'Thuwa in Sen\'jin Village down south.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6560,'You\'re looking for Tai\'jin.  Find her in the barracks on the east side of town.','You\'re looking for Tai\'jin.  Find her in the barracks on the east side of town.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6561,'Tai\'jin is her name and you\'ll find her inside the barracks on the east side of Razor Hill.  She\'ll teach you to respect the gods.  Make certain that you show her the proper respect in return!','Tai\'jin is her name and you\'ll find her inside the barracks on the east side of Razor Hill.  She\'ll teach you to respect the gods.  Make certain that you show her the proper respect in return!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6562,'Find Kaplak on top of the burrow in the southwest section of town.','Find Kaplak on top of the burrow in the southwest section of town.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6563,'Why would you want to talk to Kaplak?  Nevermind.  Look for him on top of the burrow in the southwest corner of Razor Hill.  Just make sure that you keep your hands in your own pockets!','Why would you want to talk to Kaplak?  Nevermind.  Look for him on top of the burrow in the southwest corner of Razor Hill.  Just make sure that you keep your hands in your own pockets!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6564,'You need to find Swart.  Look for him inside the barracks on the east side of Razor Hill.','You need to find Swart.  Look for him inside the barracks on the east side of Razor Hill.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6565,'The Warchief brings change that will bring the Horde victory!  Look for Swart inside the barracks on the east side of town.','The Warchief brings change that will bring the Horde victory!  Look for Swart inside the barracks on the east side of town.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6566,'On the east side of Razor Hill, behind the barracks is where you will find Dhugru Gorelust.','On the east side of Razor Hill, behind the barracks is where you will find Dhugru Gorelust.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6567,'Dhugru Gorelust is hiding behind the barracks on the east side of town.  Don\'t let me find out that you\'re in league with the Burning Legion!','Dhugru Gorelust is hiding behind the barracks on the east side of town.  Don\'t let me find out that you\'re in league with the Burning Legion!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6568,'Look for Tarshaw Jaggedscar in the barracks on the east side of town.','Look for Tarshaw Jaggedscar in the barracks on the east side of town.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6569,'Find Tarshaw Jaggedscar inside the barracks on the east side of Razor Hill.  Bring pride and honor to the Horde youngling!','Find Tarshaw Jaggedscar inside the barracks on the east side of Razor Hill.  Bring pride and honor to the Horde youngling!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6570,'Seek out Miao\'zan in Sen\'jin Village to the south.','Seek out Miao\'zan in Sen\'jin Village to the south.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6571,'I hear that the trolls in Sen\'jin Village have a potion maker named Miao\'zan.  Look there.','I hear that the trolls in Sen\'jin Village have a potion maker named Miao\'zan.  Look there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6572,'That would be Dwukk.  Find him next to the heated forge at the northwest corner of town.','That would be Dwukk.  Find him next to the heated forge at the northwest corner of town.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6573,'If you think you have the strength to pound good metal into weapons and armor for the Horde look for Dwukk next to the heated forge in the northwest corner of Razor Hill.','If you think you have the strength to pound good metal into weapons and armor for the Horde look for Dwukk next to the heated forge in the northwest corner of Razor Hill.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6574,'Head north up the road to Orgrimmar.  You can ask one of the grunts there for directions to the Cooking Trainer.','Head north up the road to Orgrimmar.  You can ask one of the grunts there for directions to the Cooking Trainer.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6575,'Mmmmm food.  It\'s not too long of a run, but you need to head north to Orgrimmar and ask one of the grunts there.','Mmmmm food.  It\'s not too long of a run, but you need to head north to Orgrimmar and ask one of the grunts there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6576,'There\'s one in Orgrimmar.  A grunt up there will know what directions to give you.  Just head north up the road here, you can\'t miss it.','There\'s one in Orgrimmar.  A grunt up there will know what directions to give you.  Just head north up the road here, you can\'t miss it.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6577,'I don\'t know of one of those around here.  Your best bet is to go to Orgrimmar to the north and speak to one of their grunts.','I don\'t know of one of those around here.  Your best bet is to go to Orgrimmar to the north and speak to one of their grunts.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6578,'There is an Engineering Trainer in Razor Hill.  He is called Mukdrak and can usually be found standing over near the forge.','There is an Engineering Trainer in Razor Hill.  He is called Mukdrak and can usually be found standing over near the forge.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6579,'Bah, that\'s goblin work!  Still, we have an orc here in Razor Hill that will teach you of such things.  Look for Mukdrak over near the forge.','Bah, that\'s goblin work!  Still, we have an orc here in Razor Hill that will teach you of such things.  Look for Mukdrak over near the forge.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6580,'There\'s one of those inside the barracks on the east side of Razor Hill.  Look for Rawrk.','There\'s one of those inside the barracks on the east side of Razor Hill.  Look for Rawrk.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6581,'With all of the fighting we do of course we have a First Aid Trainer in Razor Hill.  Find Rawrk inside the barracks on the east side of town.','With all of the fighting we do of course we have a First Aid Trainer in Razor Hill.  Find Rawrk inside the barracks on the east side of town.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6582,'I\'ve seen a troll named Lau\'Tiki fishing down south at the Darkspear Strand.  That\'s just on the outskirts of Sen\'jin Village.','I\'ve seen a troll named Lau\'Tiki fishing down south at the Darkspear Strand.  That\'s just on the outskirts of Sen\'jin Village.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6583,'You\'re looking for Lau\'Tiki.  You\'ll find him on Darkspear Strand out beyond Sen\'jin Village to the south.','You\'re looking for Lau\'Tiki.  You\'ll find him on Darkspear Strand out beyond Sen\'jin Village to the south.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6584,'You\'re looking for Mishiki.  She has a hut to the south in Sen\'jin Village.','You\'re looking for Mishiki.  She has a hut to the south in Sen\'jin Village.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6585,'Flowers?  In this wasteland?  If anyone can teach you how to find them it will be Mishiki down in Sen\'jin Village to the south.','Flowers?  In this wasteland?  If anyone can teach you how to find them it will be Mishiki down in Sen\'jin Village to the south.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6586,'','Spirits of Water, I give you praise, and I beg of you a favor. You have heard $n\'s pleas, and I trust $ghis:her; intent is noble. Please, will you aid us?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6587,'You\'ll need to head to Orgrimmar for that.  Just follow the road heading out of Razor Hill to the north through the canyon and you\'ll come to it.  When you get there ask one of their grunts for further directions.','You\'ll need to head to Orgrimmar for that.  Just follow the road heading out of Razor Hill to the north through the canyon and you\'ll come to it.  When you get there ask one of their grunts for further directions.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6588,'To learn to cure leather and work with hides go to Orgrimmar to the north.  One of the Orgrimmar Grunts will be able to tell you the way to the Leatherworking Trainer.','To learn to cure leather and work with hides go to Orgrimmar to the north.  One of the Orgrimmar Grunts will be able to tell you the way to the Leatherworking Trainer.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6589,'Sure, sure.  We have a Mining Trainer right here in town.  Look for Krunn over in the northwest corner alongside the inn.','Sure, sure.  We have a Mining Trainer right here in town.  Look for Krunn over in the northwest corner alongside the inn.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6590,'Plenty of good mining to be had in Durotar, or so I hear.  So good in fact that we have a Mining Trainer right here in Razor Hill.  You\'ll find Krunn next to the heated forge in the northwest corner of town.','Plenty of good mining to be had in Durotar, or so I hear.  So good in fact that we have a Mining Trainer right here in Razor Hill.  You\'ll find Krunn next to the heated forge in the northwest corner of town.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6591,'There\'s a Skinning Trainer in Orgrimmar.  To get there head north up the road out of Razor Hill.  Ask an Orgrimmar Grunt for directions when you arrive.','There\'s a Skinning Trainer in Orgrimmar.  To get there head north up the road out of Razor Hill.  Ask an Orgrimmar Grunt for directions when you arrive.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6592,'There\'s one in Orgrimmar.  Go north and talk to one of their grunts.','There\'s one in Orgrimmar.  Go north and talk to one of their grunts.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6593,'Then Orgrimmar is where you need to go.  The north road out of Razor Hill leads directly there.  Just talk to one of the grunts there and they can give you further directions.','Then Orgrimmar is where you need to go.  The north road out of Razor Hill leads directly there.  Just talk to one of the grunts there and they can give you further directions.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6594,'You can learn to sew up in Orgrimmar.  That\'s to the north.  Maybe one of the Orgrimmar Grunts can help you.','You can learn to sew up in Orgrimmar.  That\'s to the north.  Maybe one of the Orgrimmar Grunts can help you.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6595,'Huh?  You\'ll find the bank in Orgrimmar.  Head north up the road to get there and then talk to one of their grunts.','Huh?  You\'ll find the bank in Orgrimmar.  Head north up the road to get there and then talk to one of their grunts.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6596,'Yeah, I need to drop off some things myself.  Find it by heading north up the road to Orgrimmar and then ask one of the grunts there.','Yeah, I need to drop off some things myself.  Find it by heading north up the road to Orgrimmar and then ask one of the grunts there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6597,'You\'ll find the Wind Rider Master in Orgrimmar.  Go north up the road to get there and ask an Orgrimmar Grunt for further directions.','You\'ll find the Wind Rider Master in Orgrimmar.  Go north up the road to get there and ask an Orgrimmar Grunt for further directions.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6598,'Can\'t you see I\'m busy here?  Go north up the road to Orgrimmar and ask one of the grunts there.  You can\'t miss it.','Can\'t you see I\'m busy here?  Go north up the road to Orgrimmar and ask one of the grunts there.  You can\'t miss it.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6599,'','Thank you, great spirit. Thank you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6600,'I could use a drink and some rest myself.  You\'ll find it right in the northwest corner of Razor Hill.  Say hi to Innkeeper Grosk for me.','I could use a drink and some rest myself.  You\'ll find it right in the northwest corner of Razor Hill.  Say hi to Innkeeper Grosk for me.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6601,'It\'s the big building in Razor Hill that\'s not the barracks.  Just talk to Innkeeper Grosk inside.  Got that?','It\'s the big building in Razor Hill that\'s not the barracks.  Just talk to Innkeeper Grosk inside.  Got that?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6602,'Which trainer do you seek?','Which trainer do you seek?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6603,'Hunter','Hunter',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6604,'Mage','Mage',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6605,'Priest','Priest',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6606,'Shaman','Shaman',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6607,'We have heard your requests, and we agree... it is noble in intent. We will purify your waters. Go with our blessing, shaman.','',0,0,0,0,0,0,0,12,1,0,0,0,26124),
(6608,'Rogue','Rogue',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6612,'%s wakes up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6615,'Warlock','Warlock',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6616,'Warrior','Warrior',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6617,'Which profession?','Which profession?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6618,'Alchemy','Alchemy',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6619,'Blacksmithing','Blacksmithing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6620,'Cooking','Cooking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6621,'Enchanting','Enchanting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6622,'Engineering','Engineering',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6623,'First Aid','First Aid',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6624,'Fishing','Fishing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6625,'Herbalism','Herbalism',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6626,'Leatherworking','Leatherworking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6627,'Mining','Mining',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6628,'Skinning','Skinning',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6629,'Tailoring','Tailoring',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6630,'What are you looking for?','What are you looking for?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6631,'Bank','Bank',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6632,'Flight Master','Flight Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6633,'Inn','Inn',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6634,'Class Trainer','Class Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6635,'Profession Trainer','Profession Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6636,'Lok\'tar!  You look like you need help.','Lok\'tar!  You look like you need help.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6637,'What do you need?','What do you need?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6638,'Make it fast.','Make it fast.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6639,'Yes!?','Yes!?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6640,'Can you help me with some directions?','Can you help me with some directions?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6641,'','With the cauldrons breeched, we are now able to introduce the counter agent into the environment.  This should give the scourge a taste of their own medicine, as it were!$B$BCheck with Alchemist Arbington on information regarding the reagents needed to use in the cauldrons.  I will be handling all information reports on how we are doing overall in turning the plague against the Scourge!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6642,'','With the cauldrons breeched, we are now able to introduce the counter agent into the environment.  This should give the scourge a taste of their own medicine, as it were!$B$BCheck with Apothecary Dithers on information regarding the reagents needed to use in the cauldrons.  I will be handling all information reports on how we are doing overall in turning the plague against the Scourge!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6643,'Oh, I can see Liladris from here... Tell her I\'m here, won\'t you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6644,'','Hello young $g Master:Mistress;. I am Eva Sarkhoff and this is my husband, Lucien. It is a pleasure to make your acquaintance.',2,1,1,0,0,0,0,0,1,0,0,0,26124),
(6645,'The pleasure is mine, madam. Might I ask what it is that you are doing here?','The pleasure is mine, madam. Might I ask what it is that you are doing here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6646,'','Certainly, $g sir:miss;. We were once servants of the house Barov: What is now known as the Scholomance.$B$BI was the head maid and Lucien was Master Barov\'s butler.$B$BWe had worked for the Barovs for decades, until...$B$B<Eva weeps.>',1,1,18,0,0,0,0,0,1,0,0,0,26124),
(6647,'Until what, Eva? I must know.','Until what, Eva? I must know.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6648,'','Oh it\'s just so horrible, $g sir:miss;. The house Barov was once full of life... full of splendor. The manor was the Barov\'s primary residence amidst their far reaching empire.$B$BLucien and I noticed that as the days progressed, the Barovs became depressed. Despondent. Paranoia and rage often overcame the master and missus. At night, we could hear the Barovs arguing in their chambers. From what we understood, their greed had \'broken the dam,\' so to speak. ',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(6649,'What do you mean?','What do you mean?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6650,'','We suspect that in order to preserve their fortune and hold of the land - well past their lifespan - the Barovs made a deal with a powerful human mage named Kel\'Thuzad.$B$B<Eva shudders.>$B$BFrom this deal sprang the school of necromancy: A place which bore the Cult of the Damned and would become their capital.$B$BAs each week passed, the house Barov became more and more decrepit...$B$BDark beings began to take residence in the various wings of the house. Upkeep became impossible... and disgusting.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(6651,'Why didn\'t you just leave?','Why didn\'t you just leave?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6652,'','And go where? It was all that we knew; all that we had known and all that we would ever know.$B$BEventually, we lost contact with the Barovs and ultimately, were separated from the household. We knew not what happened to the other servants, only that there were screams. Tortured screams.$B$BKnowing that we had nowhere to go, Lucien and I were forced to hide in our quarters. During the day, when the school was relatively quiet, Lucien would sneak out to scrounge up food and drink.',6,1,1,0,0,0,0,0,1,0,0,0,26124),
(6653,'So what happened?','So what happened?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6654,'','We did this for about six months and watched as the house went through horrifying changes. Foul monsters roamed through the manor at will. Dark cultists populated every inch with various paraphernalia relating to rituals and sacrifices. We knew that we could not hide much longer.$B$BAs expected, we were found and captured. They stripped us of all our clothes and laid us out inside a circle of blood. We sat there for days, naked and terrified.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(6655,'No restraints? Just in a circle?','No restraints? Just in a circle?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6656,'','Restraints? There are things in this world far more restraining than bars and shackles, young $g master:mistress;. The undead surrounded us, constantly tormenting us with horrifying acts of depravity.$B$BFinally, he came. He introduced himself as Doctor Theolen Krastinov. We came to know him as \'The Butcher.\'\n',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(6657,'Tell me more.','Tell me more.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6658,'','We finally understood what the screams were from. The Butcher exposed us to pain that we did not know existed. He used us in countless experiments, attempting to devise a plague.$B$BThe days turned to weeks. We would have died on the first day had it not been for that cruel monster keeping us alive through magical means.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(6659,'This is an atrocity.','This is an atrocity.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6660,'','The Butcher would speak of \'the blood of innocents,\' and his dark master, \'Kirtonos.\' Of how he must appease his master.$B$BFinally, the beast was done with his experiments. We had been drained of all life. Our spirits shattered. The sweet embrace of death was upon us and we welcomed it with open arms. But in his infinite cruelty, the Butcher revived us from death\'s door.$B$BWe were to be kept alive and thrown to his ravenous ghouls. He laughed as he watched the fiends devour our flesh.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(6661,'I feel sick.','I feel sick.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6662,'','We feel nothing. Our souls remain here, in limbo. We are unable to leave until our remains are found and spirits laid to rest.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(6663,'Ah, you must go to the great heights of Thunder Bluff to visit one of those.  Follow the path north out of Bloodhoof Village.  At the base of the bluffs is an elevator that will take you to the top.  When you get there ask for further directions from one of the Bluffwatchers.','Ah, you must go to the great heights of Thunder Bluff to visit one of those.  Follow the path north out of Bloodhoof Village.  At the base of the bluffs is an elevator that will take you to the top.  When you get there ask for further directions from one of the Bluffwatchers.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6664,'How can I help?','How can I help?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6665,'We have no such place in the village.  The soaring heights of Thunder Bluff does though.  Head north up the road out of Bloodhoof Village until you come to the base of the bluffs.  There ride the elevator to the top and speak with a Bluffwatcher.  May your ancestors watch over you.','We have no such place in the village.  The soaring heights of Thunder Bluff does though.  Head north up the road out of Bloodhoof Village until you come to the base of the bluffs.  There ride the elevator to the top and speak with a Bluffwatcher.  May your ancestors watch over you.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6666,'There is a Wind Rider Master in the great city of Thunder Bluff to the north.  Ride the elevator from the base of Thunder Bluff to the top and ask one of the Bluffwatchers there for further instructions.','There is a Wind Rider Master in the great city of Thunder Bluff to the north.  Ride the elevator from the base of Thunder Bluff to the top and ask one of the Bluffwatchers there for further instructions.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6667,'Nothing frees the spirit like soaring through the sky.  There is such a place in our great tribal center Thunder Bluff.  The road north out of Bloodhoof Village will guide you there.  Once you ride the elevator to the top speak with one of the Bluffwatchers who can give you further directions.','Nothing frees the spirit like soaring through the sky.  There is such a place in our great tribal center Thunder Bluff.  The road north out of Bloodhoof Village will guide you there.  Once you ride the elevator to the top speak with one of the Bluffwatchers who can give you further directions.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6668,'Innkeeper Kauth can see to your needs.  He can be found on the west side of the village in one of the long houses.','Innkeeper Kauth can see to your needs.  He can be found on the west side of the village in one of the long houses.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6669,'There is a time and a place for all things, including relaxation.  On the west side of Bloodhoof Village Innkeeper Kauth maintains a long house for those who seek to rest.  You will find him there.','There is a time and a place for all things, including relaxation.  On the west side of Bloodhoof Village Innkeeper Kauth maintains a long house for those who seek to rest.  You will find him there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6670,'It is Gennia Runetotem\'s counsel that you seek.  You will find her in the large tent on the east side of the village.','It is Gennia Runetotem\'s counsel that you seek.  You will find her in the large tent on the east side of the village.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6671,'The way of the Druid is sibling to the Shaman.  Gennia Runetotem is steeped in such knowledge.  Seek her out in the large tent on the east side of Bloodhoof Village.','The way of the Druid is sibling to the Shaman.  Gennia Runetotem is steeped in such knowledge.  Seek her out in the large tent on the east side of Bloodhoof Village.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6672,'Yaw Sharpmane awaits you on the north edge of the village.  He can teach you the ways of the Hunter.','Yaw Sharpmane awaits you on the north edge of the village.  He can teach you the ways of the Hunter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6673,'To learn to be one with Nature in the eyes of the Earth Mother, this is a matter of pride.  If your will is to learn the ways of the Hunter you must seek out Yaw Sharpmane at the north end of Bloodhoof Village.','To learn to be one with Nature in the eyes of the Earth Mother, this is a matter of pride.  If your will is to learn the ways of the Hunter you must seek out Yaw Sharpmane at the north end of Bloodhoof Village.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6674,'There is a large tent on the east side of Bloodhoof Village.  You will find Narm Skychaser awaiting you there.','There is a large tent on the east side of Bloodhoof Village.  You will find Narm Skychaser awaiting you there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6675,'There is a wise one in the village who goes by the name Narm Skychaser.  He can continue your learning along the path of the Shaman.','There is a wise one in the village who goes by the name Narm Skychaser.  He can continue your learning along the path of the Shaman.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6676,'Krang Stonehoof stands astride his training circle at the southeast corner of the village.','Krang Stonehoof stands astride his training circle at the southeast corner of the village.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6677,'If it is the way of the Warrior that you crave then you must seek out Krang Stonehoof.  You will find him in the southeast corner of the village at his training circle, often instructing his other students.','If it is the way of the Warrior that you crave then you must seek out Krang Stonehoof.  You will find him in the southeast corner of the village at his training circle, often instructing his other students.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6678,'While we have no Alchemy Trainer here in Bloodhoof Village, there is one in Thunder Bluff to the north.  Follow the road there and ask one of the Bluffwatchers for directions when you get to the top.','While we have no Alchemy Trainer here in Bloodhoof Village, there is one in Thunder Bluff to the north.  Follow the road there and ask one of the Bluffwatchers for directions when you get to the top.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6679,'Using the fruits of the Earth Mother to create potions to aid us in our eternal struggle is an honorable endeavor.  To learn of this you must travel north to our great home of Thunder Bluff.  When you arrive at the top seek out the assistance of one of the Bluffwatchers for more specific directions.','Using the fruits of the Earth Mother to create potions to aid us in our eternal struggle is an honorable endeavor.  To learn of this you must travel north to our great home of Thunder Bluff.  When you arrive at the top seek out the assistance of one of the Bluffwatchers for more specific directions.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6680,'There is a Blacksmithing Trainer in our great home Thunder Bluff to the north.  If you seek such knowledge then head there and ask one of the Bluffwatchers for directions.','There is a Blacksmithing Trainer in our great home Thunder Bluff to the north.  If you seek such knowledge then head there and ask one of the Bluffwatchers for directions.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6681,'You desire to shape the bones of the Earth Mother into tools that will aid the Horde.  Good, good.  Follow the path north out of Bloodhoof Village until you come to the elevator leading to the top of Thunder Bluff.  A Bluffwatcher there can give you further assistance.','You desire to shape the bones of the Earth Mother into tools that will aid the Horde.  Good, good.  Follow the path north out of Bloodhoof Village until you come to the elevator leading to the top of Thunder Bluff.  A Bluffwatcher there can give you further assistance.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6682,'You will find Pyall Silentstride inside the great tent in the northwest corner of the village.  He can teach you what you crave.','You will find Pyall Silentstride inside the great tent in the northwest corner of the village.  He can teach you what you crave.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6683,'My mouth waters just to think on it.  Pyall Silentstride is the finest cook in Bloodhoof Village.  You will find him in the great tent at the northwest corner of the village.','My mouth waters just to think on it.  Pyall Silentstride is the finest cook in Bloodhoof Village.  You will find him in the great tent at the northwest corner of the village.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6684,'Away to Thunder Bluff to the north is where your journey takes you then friend.  Once there seek out the wisdom of one of the Bluffwatchers who can tell you directly where to find whom you seek.','Away to Thunder Bluff to the north is where your journey takes you then friend.  Once there seek out the wisdom of one of the Bluffwatchers who can tell you directly where to find whom you seek.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6685,'Such wisdom is steeped in a mystery that can only be found in great Thunder Bluff.  Follow the path north out of Bloodhoof Village until you come to an elevator at the base of the bluffs.  Ride it to the top and ask one of the Bluffwatchers for further assistance.','Such wisdom is steeped in a mystery that can only be found in great Thunder Bluff.  Follow the path north out of Bloodhoof Village until you come to an elevator at the base of the bluffs.  Ride it to the top and ask one of the Bluffwatchers for further assistance.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6686,'Vira Younghoof keeps her practice inside the long house on the west side of the village.','Vira Younghoof keeps her practice inside the long house on the west side of the village.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6687,'Bandages, anti-venoms and such things, these are the inevitable necessities of life on the plains.  Vira Younghoof can teach you this knowledge.  You can find her in the long house on the west side of Bloodhoof Village.','Bandages, anti-venoms and such things, these are the inevitable necessities of life on the plains.  Vira Younghoof can teach you this knowledge.  You can find her in the long house on the west side of Bloodhoof Village.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6688,'You are looking for Uthan Stillwater.  You will find him west of the village, fishing at Stonebull Lake.','You are looking for Uthan Stillwater.  You will find him west of the village, fishing at Stonebull Lake.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6689,'Give a bull a fish and feed him for a day.  Teach a bull to fish and feed him for life.  Uthan Stillwater can teach you how to fish.  Seek his wisdom west of Bloodhoof Village along the banks of Stonebull Lake.','Give a bull a fish and feed him for a day.  Teach a bull to fish and feed him for life.  Uthan Stillwater can teach you how to fish.  Seek his wisdom west of Bloodhoof Village along the banks of Stonebull Lake.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6690,'If you desire to learn the ways of Herbalism then it is to Thunder Bluff that you must go.  Follow the road north out of Bloodhoof Village and take the elevator to the top of the rise.  You can ask a Bluffwatcher there for further assistance.','If you desire to learn the ways of Herbalism then it is to Thunder Bluff that you must go.  Follow the road north out of Bloodhoof Village and take the elevator to the top of the rise.  You can ask a Bluffwatcher there for further assistance.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6691,'There are those that would teach you of Herbalism in the great home of Thunder Bluff away to the north.  Follow the road out of the village to get there and at the base of the bluff ride the elevator to the top of the rise.  There are many Bluffwatchers there who can direct you further.','There are those that would teach you of Herbalism in the great home of Thunder Bluff away to the north.  Follow the road out of the village to get there and at the base of the bluff ride the elevator to the top of the rise.  There are many Bluffwatchers there who can direct you further.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6692,'Inside the great tent at the northwest corner of the village is where Chaw Stronghide resides.  He will teach you what you must know of Leatherworking for now.','Inside the great tent at the northwest corner of the village is where Chaw Stronghide resides.  He will teach you what you must know of Leatherworking for now.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6693,'When we use the hides of the animals we must fell for food or protection we give honor to the Earth Mother and respect to the animal.  Chaw Stronghide can teach you of such things.  You will find him in the great tent at the northwest corner of Bloodhoof Village.','When we use the hides of the animals we must fell for food or protection we give honor to the Earth Mother and respect to the animal.  Chaw Stronghide can teach you of such things.  You will find him in the great tent at the northwest corner of Bloodhoof Village.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6694,'Hmmm, I think you will need to go up to Thunder Bluff to learn that.  Head north on the road out of Bloodhoof Village.  It will take you to the base of Thunder Bluff.  Ride the elevator to the top and you should be able to ask any of the Bluffwatchers there for further assistance.','Hmmm, I think you will need to go up to Thunder Bluff to learn that.  Head north on the road out of Bloodhoof Village.  It will take you to the base of Thunder Bluff.  Ride the elevator to the top and you should be able to ask any of the Bluffwatchers there for further assistance.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6695,'I hear that they have a Mining Trainer in Thunder Bluff to the north.  Take the road out of the village and when you get there ride the elevator to the top of the rise.  Any of the Bluffwatchers should be able to help you from there.','I hear that they have a Mining Trainer in Thunder Bluff to the north.  Take the road out of the village and when you get there ride the elevator to the top of the rise.  Any of the Bluffwatchers should be able to help you from there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6696,'Yonn Deepcut can be found inside the great tent at the northwest corner of Bloodhoof Village.','Yonn Deepcut can be found inside the great tent at the northwest corner of Bloodhoof Village.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6697,'Ah yes, Skinning.  There is no one finer in wielding a skinning knife than Yonn Deepcut.  You can find him in the great tent at the northwest corner of the village.','Ah yes, Skinning.  There is no one finer in wielding a skinning knife than Yonn Deepcut.  You can find him in the great tent at the northwest corner of the village.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6698,'Unfortunately we do not have one who teaches Tailoring here in Bloodhoof Village, but you can find a trainer in Thunder Bluff.  Follow the path north out of the village until you come to a set of elevators.  Take one up to the top of the rise and ask one of the Bluffwatchers there for directions.','Unfortunately we do not have one who teaches Tailoring here in Bloodhoof Village, but you can find a trainer in Thunder Bluff.  Follow the path north out of the village until you come to a set of elevators.  Take one up to the top of the rise and ask one of the Bluffwatchers there for directions.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6699,'Tailoring you say?  Hmmm.  Ah yes, of course.  You\'ll need to head to Thunder Bluff, up north.  Take the path out of the village to get there.  When you arrive at the base of the bluffs ride the elevator to the top of the rise and speak with one of the Bluffwatchers.','Tailoring you say?  Hmmm.  Ah yes, of course.  You\'ll need to head to Thunder Bluff, up north.  Take the path out of the village to get there.  When you arrive at the base of the bluffs ride the elevator to the top of the rise and speak with one of the Bluffwatchers.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6700,'Which trainer do you seek?','Which trainer do you seek?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6701,'Druid','Druid',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6702,'Hunter','Hunter',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6703,'Shaman','Shaman',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6704,'Warrior','Warrior',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6705,'Which profession?','Which profession?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6706,'Alchemy','Alchemy',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6707,'Blacksmithing','Blacksmithing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6708,'Cooking','Cooking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6709,'Enchanting','Enchanting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6710,'First Aid','First Aid',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6711,'Fishing','Fishing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6712,'Herbalism','Herbalism',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6713,'Leatherworking','Leatherworking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6714,'Mining','Mining',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6715,'The doctor is in!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6716,'Skinning','Skinning',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6717,'Tailoring','Tailoring',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6718,'What are you looking for?','What are you looking for?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6719,'The bank','The bank',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6720,'The wind rider master','The wind rider master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6721,'The inn','The inn',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6722,'A class trainer','A class trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6723,'A profession trainer','A profession trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6724,'Blessings of the Earth Mother upon you.','Blessings of the Earth Mother upon you.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6725,'You look lost.  I can help.','You look lost.  I can help.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6726,'Do you need something?','Do you need something?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6727,'Yes?','Yes?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6728,'Can you help me with some directions?','Can you help me with some directions?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6729,'We don\'t have a bank here in Brill, you\'ll have to go to the Undercity for that.  At the back of the Ruins of Lordaeron to the south are elevators that will take you down into the Undercity.  Once there, ask one of the Undercity Guardians for more precise directions.','We don\'t have a bank here in Brill, you\'ll have to go to the Undercity for that.  At the back of the Ruins of Lordaeron to the south are elevators that will take you down into the Undercity.  Once there, ask one of the Undercity Guardians for more precise directions.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6730,'What could you possibly need a bank for?  Very well, you\'ll need to go through the Ruins of Lordaeron to the south of Brill.  In the back are a set of elevators leading down into the Undercity.  When you get there stop any of those lumbering Abominations they like to call an Undercity Guardian and ask it for better directions.','What could you possibly need a bank for?  Very well, you\'ll need to go through the Ruins of Lordaeron to the south of Brill.  In the back are a set of elevators leading down into the Undercity.  When you get there stop any of those lumbering Abominations they like to call an Undercity Guardian and ask it for better directions.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6731,'There\'s a Bat Handler inside the Undercity.  Head south down the road out of Brill, then west at the T-intersection.  The Ruins of Lordaeron will be on your left.  Go into them and then down into the Undercity.  You can ask an Undercity Guardian there for further assistance.','There\'s a Bat Handler inside the Undercity.  Head south down the road out of Brill, then west at the T-intersection.  The Ruins of Lordaeron will be on your left.  Go into them and then down into the Undercity.  You can ask an Undercity Guardian there for further assistance.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6732,'Somewhere to fly to?  You\'ll need to go to the Undercity for that!  Go south on the road out of town, then southwest to the Ruins of Lordaeron.  You can catch the elevator down to the Undercity from the back of the ruins and once there ask an Undercity Guardian for more specific directions.','Somewhere to fly to?  You\'ll need to go to the Undercity for that!  Go south on the road out of town, then southwest to the Ruins of Lordaeron.  You can catch the elevator down to the Undercity from the back of the ruins and once there ask an Undercity Guardian for more specific directions.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6733,'You\'ll find Innkeeper Renee inside the Gallows\' End Tavern at the southeast end of the street running through town.','You\'ll find Innkeeper Renee inside the Gallows\' End Tavern at the southeast end of the street running through town.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6734,'Now if I were Innkeeper Renee where might I be?  Hmmm?  Oh, perhaps inside the Gallows\' End Tavern.  Yes, that\'s it, I\'m sure of it.  Try the southeast end of Brill... think you can find that?','Now if I were Innkeeper Renee where might I be?  Hmmm?  Oh, perhaps inside the Gallows\' End Tavern.  Yes, that\'s it, I\'m sure of it.  Try the southeast end of Brill... think you can find that?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6735,'You\'ll find the Mage Trainer, Cain Firesong, upstairs on the landing at the Gallows\' End Tavern, which is on the southeast end of Brill.  I guess he checked in too late to get a room.','You\'ll find the Mage Trainer, Cain Firesong, upstairs on the landing at the Gallows\' End Tavern, which is on the southeast end of Brill.  I guess he checked in too late to get a room.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6736,'Do I look to you like I cast spells?  Well, I did hear that Cain Firesong was hanging out on the upstairs landing of the Gallows\' End Tavern at the southeast end of town.  Odd how he just stands there outside of Gretchen\'s room like that.','Do I look to you like I cast spells?  Well, I did hear that Cain Firesong was hanging out on the upstairs landing of the Gallows\' End Tavern at the southeast end of town.  Odd how he just stands there outside of Gretchen\'s room like that.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6737,'At the southeast edge of town is the Gallows\' End Tavern.  Go there and head upstairs, and you\'ll find Dark Cleric Beryl inside the reading room.','At the southeast edge of town is the Gallows\' End Tavern.  Go there and head upstairs, and you\'ll find Dark Cleric Beryl inside the reading room.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6738,'Ah, you seek Dark Cleric Beryl.  He\'s upstairs in the reading room at the Gallows\' End Tavern.  Reading, praying, who knows what he\'s up to, and who would dare to ask?','Ah, you seek Dark Cleric Beryl.  He\'s upstairs in the reading room at the Gallows\' End Tavern.  Reading, praying, who knows what he\'s up to, and who would dare to ask?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6739,'The Rogue Trainer\'s name is Marion Call.  You can find her upstairs in the reading room at the Gallows\' End Tavern at the town\'s southeast edge.','The Rogue Trainer\'s name is Marion Call.  You can find her upstairs in the reading room at the Gallows\' End Tavern at the town\'s southeast edge.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6740,'Marion Call is keeping Dark Cleric Beryl company in the reading room upstairs at the Gallows\' End Tavern on the southeast edge of Brill.  I\'m just dying to see who wins that staring contest.','Marion Call is keeping Dark Cleric Beryl company in the reading room upstairs at the Gallows\' End Tavern on the southeast edge of Brill.  I\'m just dying to see who wins that staring contest.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6741,'Rupert Boch is his name.  I hear that he\'s upstairs in one of the rooms at the Gallows\' End Tavern on the southeast end of town.','Rupert Boch is his name.  I hear that he\'s upstairs in one of the rooms at the Gallows\' End Tavern on the southeast end of town.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6742,'That\'s Rupert Boch you\'re looking for.  He and his entourage have a room upstairs at the Gallows\' End Tavern on the southeast end of Brill.','That\'s Rupert Boch you\'re looking for.  He and his entourage have a room upstairs at the Gallows\' End Tavern on the southeast end of Brill.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6743,'Look inside the Gallows\' End Tavern\'s main dining room for Austil de Mon.  The tavern is on the southeast edge of Brill.','Look inside the Gallows\' End Tavern\'s main dining room for Austil de Mon.  The tavern is on the southeast edge of Brill.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6744,'Yeah, that would be Austil de Mon.  He\'s always hanging out in the tavern at the southeast end of town.  It\'s called the Gallows\' End Tavern, you can\'t miss it.','Yeah, that would be Austil de Mon.  He\'s always hanging out in the tavern at the southeast end of town.  It\'s called the Gallows\' End Tavern, you can\'t miss it.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6745,'Our Alchemist\'s name is Carolai Anise.  You\'ll find her in a house at the northwest end of Brill.','Our Alchemist\'s name is Carolai Anise.  You\'ll find her in a house at the northwest end of Brill.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6746,'You\'ll find Carolai Anise trying to blow up her house at the northwest end of town.  Why don\'t you go see if you can help her?','You\'ll find Carolai Anise trying to blow up her house at the northwest end of town.  Why don\'t you go see if you can help her?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6747,'Sorry friend, we don\'t have one of those here in Brill.  You\'ll have to head to the Undercity for that.  The Undercity is underneath the Ruins of Lordaeron to the south of Brill.  From the back of the ruins take the elevator down and then speak to one of the Undercity Guardians to find your way further.','Sorry friend, we don\'t have one of those here in Brill.  You\'ll have to head to the Undercity for that.  The Undercity is underneath the Ruins of Lordaeron to the south of Brill.  From the back of the ruins take the elevator down and then speak to one of the Undercity Guardians to find your way further.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6748,'Blacksmith?  Nope, our last one turned back into one of those mindless Scourge.  There\'s one in the Undercity though to the south of town though.  Undercity is underneath the Ruins of Lordaeron, clever name, huh?  Just take the elevators down at the back of the ruins and then you can talk to one of the Undercity Guardians.  They should be able to point you in the right direction.','Blacksmith?  Nope, our last one turned back into one of those mindless Scourge.  There\'s one in the Undercity though to the south of town though.  Undercity is underneath the Ruins of Lordaeron, clever name, huh?  Just take the elevators down at the back of the ruins and then you can talk to one of the Undercity Guardians.  They should be able to point you in the right direction.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6749,'Fancy yourself a chef?  Head to the Undercity south of town for your training.  You can catch the elevators heading down at the back of the Ruins of Lordaeron.  Talk to one of those lumbering Undercity Guardians for further assistance once you arrive.','Fancy yourself a chef?  Head to the Undercity south of town for your training.  You can catch the elevators heading down at the back of the Ruins of Lordaeron.  Talk to one of those lumbering Undercity Guardians for further assistance once you arrive.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6750,'Why cook when everything tastes like ashes in your mouth?  If you have one still that is.  Very well, head to the Undercity south of Brill and ask an Undercity Guardian there for further directions to their Cooking Trainer.  To get there you can take the elevators down from the rear of the Ruins of Lordaeron.','Why cook when everything tastes like ashes in your mouth?  If you have one still that is.  Very well, head to the Undercity south of Brill and ask an Undercity Guardian there for further directions to their Cooking Trainer.  To get there you can take the elevators down from the rear of the Ruins of Lordaeron.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6751,'You can find Vance Undergloom upstairs in a room at the Gallows\' End Tavern on the southeast side of Brill.','You can find Vance Undergloom upstairs in a room at the Gallows\' End Tavern on the southeast side of Brill.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6752,'Word is that Vance Undergloom has taken a permanent room upstairs at the Gallows\' End Tavern at the southeast end of town.  I think he\'s just off the reading room.','Word is that Vance Undergloom has taken a permanent room upstairs at the Gallows\' End Tavern at the southeast end of town.  I think he\'s just off the reading room.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6753,'While there\'s no Engineering Trainer in Brill, there is one down in the Undercity.  To get there head to the back of the Ruins of Lordaeron to the south of town and take the elevator down.  Once you get there ask an Undercity Guardian for more specific directions.','While there\'s no Engineering Trainer in Brill, there is one down in the Undercity.  To get there head to the back of the Ruins of Lordaeron to the south of town and take the elevator down.  Once you get there ask an Undercity Guardian for more specific directions.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6754,'Rifles, dynamite, bombs, exploding sheep... what\'s not to love?  To learn how to make these and many other exciting tools of the trade head to the Undercity, under the Ruins of Lordaeron to the south of Brill.  Take the elevators down at the back of the ruins.  Once you arrive speak to one of the Undercity Guardians about where the trainer is exactly.','Rifles, dynamite, bombs, exploding sheep... what\'s not to love?  To learn how to make these and many other exciting tools of the trade head to the Undercity, under the Ruins of Lordaeron to the south of Brill.  Take the elevators down at the back of the ruins.  Once you arrive speak to one of the Undercity Guardians about where the trainer is exactly.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6755,'Nurse Neela greets all of her future customers as they enter the Gallows\' End Tavern at the southeast end of town.','Nurse Neela greets all of her future customers as they enter the Gallows\' End Tavern at the southeast end of town.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6756,'Butcher you say?  Oh, First Aid Trainer!  Same thing.  When you see Nurse Neela standing just inside the Gallows\' End Tavern on the southeast side of town you\'ll know why.','Butcher you say?  Oh, First Aid Trainer!  Same thing.  When you see Nurse Neela standing just inside the Gallows\' End Tavern on the southeast side of town you\'ll know why.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6757,'Clyde Kellen, the local bass master, has his favorite fishing spot just east of Brill at Brightwater Lake.','Clyde Kellen, the local bass master, has his favorite fishing spot just east of Brill at Brightwater Lake.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6758,'Yeah, you\'ll always find Clyde Kellen fishing on the bank of Brightwater Lake just east of Brill.  Just watch out for psychos wearing masks while you\'re out there.  We had to shut down the kids\' summer camp last year.','Yeah, you\'ll always find Clyde Kellen fishing on the bank of Brightwater Lake just east of Brill.  Just watch out for psychos wearing masks while you\'re out there.  We had to shut down the kids\' summer camp last year.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6759,'Look for Faruza.  Last I saw she was standing out front between the stables and the house on the northwest end of town.','Look for Faruza.  Last I saw she was standing out front between the stables and the house on the northwest end of town.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6760,'Actually I prefer traditional medicines... leeches, maggots, bonesaws... that sort of thing.  Well to each their own.  You can find the our local Herbalism Trainer, Faruza, standing out front near the stables in Brill.','Actually I prefer traditional medicines... leeches, maggots, bonesaws... that sort of thing.  Well to each their own.  You can find the our local Herbalism Trainer, Faruza, standing out front near the stables in Brill.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6761,'That would be Shelene Rhobart.  Take the road southeast out of Brill then head east at the intersection.  She\'s at a camp along the side of the road.','That would be Shelene Rhobart.  Take the road southeast out of Brill then head east at the intersection.  She\'s at a camp along the side of the road.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6762,'Nothing quite like the feel of something dead rubbing up against you.  You can find Shelene Rhobart by heading southeast on the road out of town, and then going east at the intersection.  She\'s at a small camp there not too far along the road.','Nothing quite like the feel of something dead rubbing up against you.  You can find Shelene Rhobart by heading southeast on the road out of town, and then going east at the intersection.  She\'s at a small camp there not too far along the road.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6763,'I hear that they have a Mining Trainer in the Undercity.  All you have to do to get there is head south out of town and go to the back of the Ruins of Lordaeron.  Then take the elevator down into the Undercity itself and ask an Undercity Guardian for further directions.','I hear that they have a Mining Trainer in the Undercity.  All you have to do to get there is head south out of town and go to the back of the Ruins of Lordaeron.  Then take the elevator down into the Undercity itself and ask an Undercity Guardian for further directions.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6764,'I guess your first exercise is going to be to mine your way down to the Undercity.  Heh, get it?  Mine... nevermind.  To get to the Undercity go to the rear of the Ruins of Lordaeron south of Brill, and take the elevator down.  Ask one of the Undercity Guardians there for further assistance.','I guess your first exercise is going to be to mine your way down to the Undercity.  Heh, get it?  Mine... nevermind.  To get to the Undercity go to the rear of the Ruins of Lordaeron south of Brill, and take the elevator down.  Ask one of the Undercity Guardians there for further assistance.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6765,'Rand Rhobart is fairly good at skinning felbats and the like.  You can find him at a camp along the road to the southeast of Brill.  Take the road southeast out of town and then head east at the intersection.','Rand Rhobart is fairly good at skinning felbats and the like.  You can find him at a camp along the road to the southeast of Brill.  Take the road southeast out of town and then head east at the intersection.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6766,'You aiming to be a taxidermist?  I don\'t like people who think they can stuff and mount me because they think I\'m dead.  No?  Good!  Look for Rand Rhobart at a camp to the southeast of town.  To get to him take the road southeast out of Brill and hang a left at the intersection.','You aiming to be a taxidermist?  I don\'t like people who think they can stuff and mount me because they think I\'m dead.  No?  Good!  Look for Rand Rhobart at a camp to the southeast of town.  To get to him take the road southeast out of Brill and hang a left at the intersection.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6767,'It is Bowen Brisboise that you seek then.  You\'ll find him inside his house southwest of Brill just on the other side of the bridge at Cold Hearth Manor.','It is Bowen Brisboise that you seek then.  You\'ll find him inside his house southwest of Brill just on the other side of the bridge at Cold Hearth Manor.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6768,'Black, grey and dark purple are the prescribed colors.  See to it that you don\'t stray onto the wrong side of fashion street friend.  Bowen Brisboise can help to see that you don\'t.  You\'ll find him inside Cold Hearth Manor on the other side of the bridge to the southwest of town.','Black, grey and dark purple are the prescribed colors.  See to it that you don\'t stray onto the wrong side of fashion street friend.  Bowen Brisboise can help to see that you don\'t.  You\'ll find him inside Cold Hearth Manor on the other side of the bridge to the southwest of town.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6769,'Which trainer do you seek?','Which trainer do you seek?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6770,'Mage','Mage',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6771,'Priest','Priest',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6772,'Rogue','Rogue',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6773,'Warlock','Warlock',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6774,'Warrior','Warrior',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6775,'Which profession?','Which profession?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6776,'Alchemy','Alchemy',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6777,'Blacksmithing','Blacksmithing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6778,'Cooking','Cooking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6779,'Enchanting','Enchanting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6780,'Engineering','Engineering',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6781,'First Aid','First Aid',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6782,'Fishing','Fishing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6783,'Herbalism','Herbalism',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6784,'Leatherworking','Leatherworking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6785,'Mining','Mining',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6786,'Skinning','Skinning',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6787,'Tailoring','Tailoring',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6788,'What are you looking for?','What are you looking for?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6789,'The bank','The bank',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6790,'The bat handler','The bat handler',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6791,'The inn','The inn',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6792,'A class trainer','A class trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6793,'A profession trainer','A profession trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6794,'You look like you\'re lost.','You look like you\'re lost.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6795,'Yes?','Yes?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6796,'What is it?','What is it?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6797,'Do I look like a guide to you?  Fine, what do you need?','Do I look like a guide to you?  Fine, what do you need?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(6798,'Can you help me with some directions?','Can you help me with some directions?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6799,'Eva, I have lost the Spectral Essence. I need another.','Eva, I have lost the Spectral Essence. I need another.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6800,'','So cold... and hungry.$B$BMy poor friend, I hope you\'ve found peace. I can\'t stand to think about what they could have done to you.$B$BYou! You there! Please, you have to help me escape. One of them has a key, can you find it? I know they have it. If you get it, you can help me get out of here. Trey is probably already dead, but there\'s still time! Please, can you help me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6801,'','You will not stop me from escaping here, $r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6802,'','You kept me in that cell for too long, monster!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6803,'','You will pay for what you\'ve done to Trey!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6804,'','You\'ve already done me a great service, $n. For that I thank you.$B$BThe least I can do now is tell you what brought me here: My long time friend Trey Lightforge and I came to Jaedenar to investigate the Shadow Council when they caught us unprepared. They took Trey deeper into Shadow Hold and put me in here after taking all of our equipment... I can still hear his screams from below, $n. They were... inhuman. I don\'t know what they\'ve done to him, but they will pay for it. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6805,'','As you inspect the cage and the Night elf inside, you get an odd sense of deja vu. For some reason she does not make eye contact with you--it is almost as if you are not there to her.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6806,'','Ready. Set. GO!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6807,'','HEY! No fair!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6808,'','I win!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6809,'','Wanna race again? Best two out of three!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6810,'','You cheated!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6811,'%s looks very sleepy...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6812,'looks very sleepy...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6813,'This looks like the perfect place for a nap...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6814,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6815,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6816,'They don\'t realize that they\'re dead, $r. They are cursed to relive the last memory they had before the town was eaten alive from the inside out. Most of them, anyway. Some were less fortunate.$B$BYou thought the Scourge did this? The Scourge did not yet exist and if they had, we would have at least put up a damned fight.$B$BNo, this was the result of a plague that came out of Scholomance and ravaged the town. It was horrifying and devastating. None survived.$B$BNow leave me to my sorrows.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(6817,'Can\'t you see we\'re trying to prepare for Uther\'s visit? Now get out of my way, I have much work to do!','Can\'t you see we\'re trying to prepare for Uther\'s visit? Now get out of my way, I have much work to do!',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(6818,'Have you tried our bread? Baker Masterson must be the most gifted chef to have ever lived!','Have you tried our bread? Baker Masterson must be the most gifted chef to have ever lived!',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(6819,'Welcome to Caer Darrow, stranger.','Welcome to Caer Darrow, stranger.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(6820,'We\'re not really rude people, stranger, it\'s just that everyone is in a rush, trying to make sure that everything is perfect for Uther\'s arrival. It\'s not often that the Lightbringer comes to town.','We\'re not really rude people, stranger, it\'s just that everyone is in a rush, trying to make sure that everything is perfect for Uther\'s arrival. It\'s not often that the Lightbringer comes to town.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(6821,'Another lovely day on our beautiful island.','Another lovely day on our beautiful island.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6822,'Watch your step, stranger. We do not allow miscreants in our town.','Watch your step, stranger. We do not allow miscreants in our town.',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(6823,'I\'ve got my eye on you, $r.','I\'ve got my eye on you, $r.',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(6824,'I have a lot of pent up anger and hostility. Just give me a reason, guttersnipe.','I have a lot of pent up anger and hostility. Just give me a reason, guttersnipe.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6825,'Why, you look like a common street urchin!','Why, you look like a common street urchin!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(6826,'There\'s no loitering, pan handling, cursing, fighting, or anything else you\'re thinking about doing, allowed in Caer Darrow.','There\'s no loitering, pan handling, cursing, fighting, or anything else you\'re thinking about doing, allowed in Caer Darrow.',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(6827,'Hail the Lich King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6828,'Your soul is doomed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6829,'Join us, or fall forever!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6830,'There is no hope!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6831,'Our master wants you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6832,'Darrowshire will fall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6833,'Scourge will prevail!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6834,'All hope is lost!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6835,'We must not give up!','We must not give up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6836,'Fight!  Fight for Darrowshire!','Fight!  Fight for Darrowshire!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6837,'Our captain has fallen!','Our captain has fallen!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6838,'The Alliance has abandoned us!','The Alliance has abandoned us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6839,'Where is the Silver Hand?  We need their help!','Where is the Silver Hand?  We need their help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6840,'Fight for your families!  Don\'t give up!','Fight for your families!  Don\'t give up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6841,'If we fall, then Darrowshire is doomed!','If we fall, then Darrowshire is doomed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6842,'We must stop these villains!','We must stop these villains!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6843,'The Cult of the Damned has grown large in scope. Nearly every city, from the capitals to the small hamlets and hovels of both the Horde and Alliance, have Cult members hidden amongst their citizenry.$B$BDo not look so surprised. The Cult only wears a uniform for ritual and ceremony. It is quite possible that you have interacted with one during your adventures and not even known.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(6844,'Impossible.','Impossible.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6845,'Is it? This has always been their method of operation. What is of greater value to Kel\'Thuzad and the ever growing Scourge army? A zealous, living, follower that can work their way into a society and then unleash a plague, destroying thousands; or a single undead trooper? Certainly you cannot be that dense$B$BYes, $r, they live, work, and plot among you.','',6,1,1,0,0,0,0,0,1,0,0,0,26124),
(6846,'This is disheartening. Is there anything I can do to stop this?','This is disheartening. Is there anything I can do to stop this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6847,'Stop - no. Slow down - maybe.$B$BThe Scholomance is their primary source of training and education. It is from there that the Cult members fan out and ultimately, make their way into our societies.$B$BThat is why we must strike at the source. The very heart of the Cult of the Damned!','',1,1,5,0,0,0,0,0,1,0,0,0,26124),
(6848,'Who do I need to kill?','Who do I need to kill?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6849,'Slow down, $r. The one you need to kill is already dead. Killing him again will serve no purpose. There are very few ways in which a lich can actually be destroyed and none of those means are available to you or I. That is why I have a plan. A plan that will have a very noticeable and real impact upon the Cult.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(6850,'What is this plan?','What is this plan?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6851,'It\'s simple, really. Rob the lich, Ras Frostwhisper, of his powers. Return him to his mortal form and then slay him, once and for all.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6852,'Ras Frostwhat? Who is that?','Ras Frostwhat? Who is that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6853,'Ah, I suppose that I am getting ahead of myself. Ras Frostwhisper is the overseer of this school. The being responsible for training all of its Dark Masters. A lieutenant and favored pupil of Kel\'Thuzad. He was once a hedge mage of Stromgarde: A rogue wizard that never received his formal training from Dalaran.$B$BWhen Kel\'Thuzad opened the Cult, Ras was among the first to join his ranks. Ras knew that through dark magic, he would find immortality.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(6854,'Continue, please.\n','Continue, please.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6855,'And find it he did. After quickly advancing through the ranks of the Cult, the Lich King himself granted Ras immortality. Thus was born Ras Frostwhisper, the lich.$B$BNow do you understand?','',1,1,6,0,0,0,0,0,1,0,0,0,26124),
(6856,'Yes I do.','Yes I do.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6857,'Good. In order to carry out my plan, we must first create a lifestone. Are you prepared to act?','',6,25,0,0,0,0,0,0,1,0,0,0,26124),
(6858,'Yes I am.','Yes I am.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6859,'Some were spared the anguish that memories provide.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6860,'Tell me about the Cult of the Damned.','Tell me about the Cult of the Damned.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6861,'You must save us!','You must save us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6862,'','I am sorry. I am unable to help you at this time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6863,'The Barov house sure does keep me busy. Always some sort of refuse coming out of there.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(6864,'My job title is Waste Management Specialist.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6865,'Perhaps you should speak into these sound enhancing devices attached to my FISTS OF FURY.','',14,0,0,0,0,0,0,0,1,0,0,0,26124),
(6866,'Ah, my sweet Brandy, I miss her so!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(6867,'Be on the alert! The Blackwood furbolgs are numerous in this area...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6868,'It\'s quiet... Too quiet...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6869,'Well met, friend.  I am Officer Garush, and I am a proud member of a world-wide organization known as the Argent Crusade.  Our cause is to fight swiftly and mercilessly against any element of evil that surfaces in Azeroth.  We are not a political body, nor do we ever wish to become one.  Our cause is singular, and to that end we call both the Horde and Alliance as friends - friends in the cause of stamping out evil!$B$BFor the Crusade, my $g brother : sister;!','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(6870,'','Well met, friend.  I am Officer Pureheart, and I am a proud member of a world-wide organization known as the Argent Crusade.  Our cause is simple - fight swiftly and mercilessly against any element of evil that surfaces in Azeroth.  We are not a political body, nor do we ever wish to become one.  To that end we call both the Alliance and the Horde both as friends - friends in the cause of stamping out evil!$B$BFor the Light, my $g brother : sister;!',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(6871,'%s bursts forth from the ground!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6872,'ZZzzzz....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6873,'Huh?  What do you want?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6874,'%s is lured out into the open!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6875,'Wake up!','Wake up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6876,'','The Argent Dawn salutes you, $c.  I am Hasana - one of but a few authorized equipment and materiel quartermasters for the Dawn.$B$BAs you fight evil under our commission - all the while earning our respect and trust - you\'ll earn valor tokens from Officer Garush.  Tokens serve two purposes: use them to gain increased standing within our ranks, or use them as tender in acquiring special items.$B$BAs you improve your standing with the Dawn, you\'ll discover that more items will be made available to you.',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(6877,'','Join the fight against evil!  Accept a commission within the Argent Dawn today!',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(6878,'I need another Argent Dawn Commission.','I need another Argent Dawn Commission.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(6879,'The Argent Crusade salutes you, $c!  The name\'s Lightspark, and I\'m an authorized equipment and materiel quartermaster for the Crusade.$B$BAs you fight evil under our commission - all the while earning our respect and trust - you\'ll earn valor tokens from Officer Pureheart.  Tokens serve two purposes: use them to gain increased standing within our ranks, or use them as tender in acquiring special items.$B$BAs you improve your standing with the Crusade, you\'ll discover that more items will be made available to you.','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(6880,'Onward, Crusaders! We must retake Corin\'s Crossing!','Onward, Crusaders! We must retake Corin\'s Crossing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6881,'Join the fight against evil!  Accept a commission within the Argent Crusade today!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(6882,'','Greetings, $c.  I am Miranda Breechlock - one of but a few authorized equipment and materiel quartermasters for the Dawn.$B$BAs you fight evil under our commission - all the while earning our respect and trust - you\'ll earn valor tokens from Duke Zverenhoff.  Tokens serve two purposes: use them to gain increased standing within our ranks, or use them as tender in acquiring special items.$B$BAs you improve your standing with the Dawn, you\'ll discover that more items will be made available to you.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(6883,'What is this?!  How dare you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6884,'Greetings, $c.$B$BThose Sentinels over there have allowed me to share their camp as long as I promise no trouble will follow--I am sure you can appreciate the need for diplomacy while here, yes?$B$BI am here investigating disturbances to the land, and since it aids their cause also, they have agreed that my presence here could only aid the tenuous alliance between all of Azeroth\'s races. If you wish to aid me, then I would appreciate it, but regardless, please try not to cause any trouble.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6885,'Ah, so my minions from the Burning Steppes have brought the dragons...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6886,'Marduk, gather the box and place it before me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6887,'Master Vectus, I sense something strange within this container...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6888,'Welcome to Steelgrill\'s Depot!','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(6889,'Race does not dictate honor, $r. While you remain on my farmstead, I ask that you remember and respect this credo.$B$BI have known orcs who have been as honorable as the most noble of knights and humans who have been as vile as the most ruthless of Scourge.$B$BBut I shall not bore you with tales of my youth! There is much work to be done - if that is what you desire. ','',1,1,254,0,0,0,0,0,1,0,0,0,26124),
(6890,'We have yet to meet our quota for the wood demand.  Now back to work with you.','We have yet to meet our quota for the wood demand.  Now back to work with you.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(6891,'Daylight is still upon us so let\'s see that axe of yours chopping some more wood.','Daylight is still upon us so let\'s see that axe of yours chopping some more wood.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(6892,'We need to get this wagon filled by the end of the day.  So back to work with you.  Chop, chop!','We need to get this wagon filled by the end of the day.  So back to work with you.  Chop, chop!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(6893,'%s reaps the Gloom Weed violently from the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6894,'TEST - death before attack $n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6895,'TEST - death after attack $n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6896,'','Your blood spills for the betterment of humanity, infidel!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6897,'Fordring shall never see his son.','Fordring shall never see his son.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6898,'Say hello to my little friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6901,'Hail citizen.  Do you need directions?','Hail citizen.  Do you need directions?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6902,'Is there something I can help you find?','Is there something I can help you find?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6903,'You look a little lost.  Who are you looking for?','You look a little lost.  Who are you looking for?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6904,'Are you new here?  Well, tell me what you\'re looking for then.','Are you new here?  Well, tell me what you\'re looking for then.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6905,'I need directions.','I need directions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6906,'What are you looking for?','What are you looking for?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6907,'Bank','Bank',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6908,'Gryphon Master','Gryphon Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6909,'Guild Master & Vendor','Guild Master & Vendor',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6910,'Inn','Inn',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6911,'Class Trainer','Class Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6912,'Profession Trainer','Profession Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6913,'A bank?  Well, the closest bank around here is The Stormwind Counting House.  It\'s just up the road in Stormwind not far from the gates.','A bank?  Well, the closest bank around here is The Stormwind Counting House.  It\'s just up the road in Stormwind not far from the gates.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6914,'Oh, you must mean the Stormwind Counting House.  It\'s not far from the gates after you enter Stormwind.','Oh, you must mean the Stormwind Counting House.  It\'s not far from the gates after you enter Stormwind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6915,'Well there\'s a gryphon master up in Stormwind if you need to fly somewhere.  You should be able to see the gryphons landing on your right as you walk through the Valley of Heroes.','Well there\'s a gryphon master up in Stormwind if you need to fly somewhere.  You should be able to see the gryphons landing on your right as you walk through the Valley of Heroes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6916,'The gryphon master oversees the gryphon flights from within Stormwind.  If you\'re looking to take a ride, then that\'s where you should be headed.','The gryphon master oversees the gryphon flights from within Stormwind.  If you\'re looking to take a ride, then that\'s where you should be headed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6917,'I believe Aldwin Laughlin is still the resident Guild Master of Stormwind.  Look for his residence on your left as you pass the inner gate of Stormwind.','I believe Aldwin Laughlin is still the resident Guild Master of Stormwind.  Look for his residence on your left as you pass the inner gate of Stormwind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6918,'All that official business is handled up in Stormwind these days.  You could stop by the Stormwind Visitor\'s Center if you want to start a guild.','All that official business is handled up in Stormwind these days.  You could stop by the Stormwind Visitor\'s Center if you want to start a guild.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6919,'Look no further than the Lion\'s Pride Inn in Goldshire.  With a wide selection of ales and soft down beds you, couldn\'t ask for a better place to rest.','Look no further than the Lion\'s Pride Inn in Goldshire.  With a wide selection of ales and soft down beds you, couldn\'t ask for a better place to rest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6920,'The Lion\'s Pride Inn in Goldshire is as good as any inn you will find around these parts.  Drop in and let Innkeeper Farley make you feel at home.','The Lion\'s Pride Inn in Goldshire is as good as any inn you will find around these parts.  Drop in and let Innkeeper Farley make you feel at home.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6921,'There are quite a few trainers available in Elwynn.  Which one are you looking for?','There are quite a few trainers available in Elwynn.  Which one are you looking for?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6922,'Druid','Druid',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6923,'Druids?  I haven\'t seen any druids around here.  Although there is a district in Stormwind that the night elves have made their own.','Druids?  I haven\'t seen any druids around here.  Although there is a district in Stormwind that the night elves have made their own.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6924,'Hunter','Hunter',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6925,'I\'ve heard that there\'s a dwarf in Stormwind who has achieved some fame for his hunting skill.  Maybe you should go see if he could help you.','I\'ve heard that there\'s a dwarf in Stormwind who has achieved some fame for his hunting skill.  Maybe you should go see if he could help you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6926,'Priest','Priest',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6927,'Josetta has been a blessing to this town with her aid of the local guards.  If you seek her for training in the ways of a priest, you can find her in the Lion\'s Pride Inn.','Josetta has been a blessing to this town with her aid of the local guards.  If you seek her for training in the ways of a priest, you can find her in the Lion\'s Pride Inn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6928,'I bet Josetta would be more than happy to teach you some new spells.  She is probably up in her room at the Lion\'s Pride Inn.','I bet Josetta would be more than happy to teach you some new spells.  She is probably up in her room at the Lion\'s Pride Inn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6929,'Mage','Mage',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6930,'Zaldimar could probably teach you some new spells.  He has recently taken a liking to staying at the Lion\'s Pride Inn, you might want to check one of the rooms and see if he\'s in.','Zaldimar could probably teach you some new spells.  He has recently taken a liking to staying at the Lion\'s Pride Inn, you might want to check one of the rooms and see if he\'s in.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6931,'I don\'t know much about magic, but there\'s a mage named Zaldimar who is staying at the Lion\'s Pride Inn that could probably assist you.','I don\'t know much about magic, but there\'s a mage named Zaldimar who is staying at the Lion\'s Pride Inn that could probably assist you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6932,'Paladin','Paladin',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6933,'You can usually find Brother Wilhelm in back of the smithy trading stories with Lyria.  He\'s always up for teaching fellow paladins new skills.','You can usually find Brother Wilhelm in back of the smithy trading stories with Lyria.  He\'s always up for teaching fellow paladins new skills.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6934,'Brother Wilhelm often trains with Lyria Du Lac out in back of the smithy in Goldshire.  You could probably learn a thing or two about being a paladin from him.','Brother Wilhelm often trains with Lyria Du Lac out in back of the smithy in Goldshire.  You could probably learn a thing or two about being a paladin from him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6935,'Rogue','Rogue',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6936,'A rogue?  Hmmm... well, I\'ve heard that Keryn Sylvius hangs around those shady types.  You might want to talk to her and see what you can learn.','A rogue?  Hmmm... well, I\'ve heard that Keryn Sylvius hangs around those shady types.  You might want to talk to her and see what you can learn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6937,'I\'d wager Keryn Sylvius knows the type you\'re looking for. The company Keryn keeps is less than honorable. She usually hangs out in the Lion\'s Pride Inn.','I\'d wager Keryn Sylvius knows the type you\'re looking for. The company Keryn keeps is less than honorable. She usually hangs out in the Lion\'s Pride Inn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6938,'Warrior','Warrior',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6939,'Few around here are as skilled with a blade as Lyria Du Lac.  Check for her out behind the smithy and see if she\'s in the mood to teach you something new.','Few around here are as skilled with a blade as Lyria Du Lac.  Check for her out behind the smithy and see if she\'s in the mood to teach you something new.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6940,'Lyria\'s the one you should talk to if you need some training.  She can usually be found out behind the smithy waiting for some armor or weapon to be finished.','Lyria\'s the one you should talk to if you need some training.  She can usually be found out behind the smithy waiting for some armor or weapon to be finished.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6941,'Warlock','Warlock',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6942,'Oh... one of those types.  Well, Maximillian is the only one around here that knows about the dark arts.  You can probably find him in the dark of the Lion\'s Pride Inn basement.','Oh... one of those types.  Well, Maximillian is the only one around here that knows about the dark arts.  You can probably find him in the dark of the Lion\'s Pride Inn basement.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6943,'A warlock?  Well, if I was a warlock, I would probably be in the darkest place around here... which would be the Lion\'s Pride Inn basement.  That\'s where you should look first.','A warlock?  Well, if I was a warlock, I would probably be in the darkest place around here... which would be the Lion\'s Pride Inn basement.  That\'s where you should look first.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6944,'I know of a few people around here that practice a profession or two.  What profession do you have in mind?','I know of a few people around here that practice a profession or two.  What profession do you have in mind?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6945,'Alchemy','Alchemy',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6946,'Blacksmithing','Blacksmithing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6947,'Cooking','Cooking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6948,'Enchanting','Enchanting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6949,'Engineering','Engineering',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6950,'First Aid','First Aid',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6951,'Fishing','Fishing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6952,'Herbalism','Herbalism',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6953,'Leatherworking','Leatherworking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6954,'Mining','Mining',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6955,'Skinning','Skinning',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6956,'Tailoring','Tailoring',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6957,'That hermit Mallory is known to concoct some potions for the local townsfolk on occasion.  He has a cottage in the hills between Stormwind and Northshire.','That hermit Mallory is known to concoct some potions for the local townsfolk on occasion.  He has a cottage in the hills between Stormwind and Northshire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6958,'There is an alchemist that lives up in the hills between Northshire and Stormwind that might be of some help.  Why don\'t you go pay him a visit?','There is an alchemist that lives up in the hills between Northshire and Stormwind that might be of some help.  Why don\'t you go pay him a visit?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6959,'Argus is the resident blacksmith of Goldshire.  I\'m sure he could teach you the Blacksmith\'s profession.','Argus is the resident blacksmith of Goldshire.  I\'m sure he could teach you the Blacksmith\'s profession.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6960,'You must be looking for Smith Argus.  He\'s usually overseeing the forge in Goldshire if you need some training.','You must be looking for Smith Argus.  He\'s usually overseeing the forge in Goldshire if you need some training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6961,'Tomas may not be the best cook around, but he has a few dishes that hit the spot.  He\'s currently working in the Lion\'s Pride Inn if you\'d like to learn the profession.','Tomas may not be the best cook around, but he has a few dishes that hit the spot.  He\'s currently working in the Lion\'s Pride Inn if you\'d like to learn the profession.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6962,'Why don\'t you try looking in the Lion\'s Pride Inn?  The cook there might be able to teach you a few good recipes.','Why don\'t you try looking in the Lion\'s Pride Inn?  The cook there might be able to teach you a few good recipes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6963,'Nope, don\'t think there are any Enchanters here in Elwynn Forest.  There\'s a guy named Lucan who runs a shop up in Stormwind though.  You could check with him and see if he will train you.','Nope, don\'t think there are any Enchanters here in Elwynn Forest.  There\'s a guy named Lucan who runs a shop up in Stormwind though.  You could check with him and see if he will train you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6964,'Hmmm... only enchanters I know of around here work out of Stormwind.  Why don\'t you ask one of the guards up in Stormwind?','Hmmm... only enchanters I know of around here work out of Stormwind.  Why don\'t you ask one of the guards up in Stormwind?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6965,'I usually leave that sort of thing to the gnomes.  If you want to take up the profession, I\'m sure you could find some gnomes hanging out in Stormwind that would train you.','I usually leave that sort of thing to the gnomes.  If you want to take up the profession, I\'m sure you could find some gnomes hanging out in Stormwind that would train you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6966,'There is bound to be a gnome in Stormwind that can teach you the profession.  I\'m sure one of the Stormwind Guards could point you in the right direction.','There is bound to be a gnome in Stormwind that can teach you the profession.  I\'m sure one of the Stormwind Guards could point you in the right direction.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6967,'I had a bad encounter with some of the Defias around here recently, but Michelle Belle fixed me up pretty well.  Check with her in the Lion\'s Pride Inn and see if she\'ll teach you.','I had a bad encounter with some of the Defias around here recently, but Michelle Belle fixed me up pretty well.  Check with her in the Lion\'s Pride Inn and see if she\'ll teach you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6968,'Michelle Belle\'s bedside manner is remarkable!  While she might not be able to teach you that, she surely could teach you some proper First Aid.  She currently resides in the Lion\'s Pride Inn.','Michelle Belle\'s bedside manner is remarkable!  While she might not be able to teach you that, she surely could teach you some proper First Aid.  She currently resides in the Lion\'s Pride Inn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6969,'Lee Brown spends the whole day fishing up by Crystal Lake.  He\'s probably got some stories to tell and some tips he could teach you.','Lee Brown spends the whole day fishing up by Crystal Lake.  He\'s probably got some stories to tell and some tips he could teach you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6970,'Lee\'s caught some pretty odd things up at Crystal Lake.  He told me a story about this weird mask he fished up some months ago.  If you ask me, I think he just had one too many at the Lion\'s Pride that night.','Lee\'s caught some pretty odd things up at Crystal Lake.  He told me a story about this weird mask he fished up some months ago.  If you ask me, I think he just had one too many at the Lion\'s Pride that night.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6971,'Ms. Pomeroy gathers herbs for an Alchemist who lives up in the hills between Northshire and Stormwind.  Check for her at his cottage and see if she\'ll show you the profession.','Ms. Pomeroy gathers herbs for an Alchemist who lives up in the hills between Northshire and Stormwind.  Check for her at his cottage and see if she\'ll show you the profession.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6972,'There\'s an herbalist that lives in the hills east of Stormwind with our alchemist. Quite the handy pairing don\'t you think?','There\'s an herbalist that lives in the hills east of Stormwind with our alchemist. Quite the handy pairing don\'t you think?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6973,'Over by Crystal Lake there lives a lady named Adele Fielder.  She makes patches for the local guards with the extra leather she gets from the local skinner, Helene.  She would probably be the one to see if you\'re interested in learning the profession.','Over by Crystal Lake there lives a lady named Adele Fielder.  She makes patches for the local guards with the extra leather she gets from the local skinner, Helene.  She would probably be the one to see if you\'re interested in learning the profession.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6974,'Adele Fielder has made a name for herself as a leatherworker around Elwynn.  You can find her working out of her home up by Crystal Lake.','Adele Fielder has made a name for herself as a leatherworker around Elwynn.  You can find her working out of her home up by Crystal Lake.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6975,'You best head up to Stormwind in the Dwarven District if you want to learn to mine.  Surely one of the dwarves there can teach you the profession.','You best head up to Stormwind in the Dwarven District if you want to learn to mine.  Surely one of the dwarves there can teach you the profession.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6976,'I think you\'ll have better luck looking in Stormwind.  Ask a guard up there and they\'ll point you in the right direction.','I think you\'ll have better luck looking in Stormwind.  Ask a guard up there and they\'ll point you in the right direction.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6977,'Helene Peltskinner has had years of experience skinning animals for Adele Fielder to make leather items.  You can find Helene in her house by Crystal Lake.','Helene Peltskinner has had years of experience skinning animals for Adele Fielder to make leather items.  You can find Helene in her house by Crystal Lake.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6978,'There\'s an excellent skinner that lives up in the house by Crystal Lake.  She\'s bound to be able to show you how to get started in the skinner\'s profession.','There\'s an excellent skinner that lives up in the house by Crystal Lake.  She\'s bound to be able to show you how to get started in the skinner\'s profession.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6979,'Eldrin is the only one in Elwynn Forest that I would call a tailor.  You can find him at the Eastvale Lumber Camp if you\'re interested in learning the profession.','Eldrin is the only one in Elwynn Forest that I would call a tailor.  You can find him at the Eastvale Lumber Camp if you\'re interested in learning the profession.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6980,'You want to learn to be a tailor?  Hmmm... I believe there\'s a tailor over in the Eastvale Logging Camp that may be able to get you started.  ','You want to learn to be a tailor?  Hmmm... I believe there\'s a tailor over in the Eastvale Logging Camp that may be able to get you started.  ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6981,'Ye be needing directions $glad : lass;?','Ye be needing directions $glad : lass;?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6982,'Ye look a bit lost there.  Can I help ye find something?','Ye look a bit lost there.  Can I help ye find something?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6983,'Do ye need some help finding something?','Do ye need some help finding something?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6984,'Whatcha need?','Whatcha need?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6985,'I need directions.','I need directions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6986,'What do ye need directions to?','What do ye need directions to?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6987,'Bank','Bank',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6988,'The nearest bank ye\'ll find is The Vault in Ironforge, $glad : lass;. ','The nearest bank ye\'ll find is The Vault in Ironforge, $glad : lass;. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6989,'The Vault in Ironforge is the closest bank ye\'ll find in these parts.','The Vault in Ironforge is the closest bank ye\'ll find in these parts.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6990,'Gryphon Master','Gryphon Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6991,'Ye won\'t find a gryphon master just anywhere around Dun Morogh, $glad : lass;.  Ye\'re going to have to go to Ironforge if ye want to take a gryphon somewhere.','Ye won\'t find a gryphon master just anywhere around Dun Morogh, $glad : lass;.  Ye\'re going to have to go to Ironforge if ye want to take a gryphon somewhere.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6992,'The closest gryphon master is located up in Ironforge near The Great Forge itself.  Ye\'ll need to head to Ironforge if ye want to travel by gryphon.','The closest gryphon master is located up in Ironforge near The Great Forge itself.  Ye\'ll need to head to Ironforge if ye want to travel by gryphon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6993,'Guild Master & Vendor','Guild Master & Vendor',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6994,'All those official types reside in Ironforge.  Ye\'ll be wanting to check out the Ironforge Visitor\'s Center for guild creation papers.','All those official types reside in Ironforge.  Ye\'ll be wanting to check out the Ironforge Visitor\'s Center for guild creation papers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6995,'If ye need to get yer hands on some guild creation papers ye\'ll have to head up to Ironforge and visit the Ironforge Visitor\'s Center.','If ye need to get yer hands on some guild creation papers ye\'ll have to head up to Ironforge and visit the Ironforge Visitor\'s Center.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6996,'The Inn','The Inn',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6997,'The Thunderbrews run a fine Inn in Kharanos which bears their name.  Stop in for a pint and a bit of rest.','The Thunderbrews run a fine Inn in Kharanos which bears their name.  Stop in for a pint and a bit of rest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6998,'Oooh, an Inn is it?  Well, ye just can\'t beat the Thunderbrew Distillery.  Rest if ye must, but be sure to have an ale or two while ye\'re there.','Oooh, an Inn is it?  Well, ye just can\'t beat the Thunderbrew Distillery.  Rest if ye must, but be sure to have an ale or two while ye\'re there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(6999,'Class Trainer','Class Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7000,'Which class trainer might ye be looking for?','Which class trainer might ye be looking for?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7001,'Hunter','Hunter',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7002,'There\'s only one hunter around here I would have ye talk to, and that would be Grif Wildheart.  Ye\'ll find him standing just outside the smithy in Kharanos.','There\'s only one hunter around here I would have ye talk to, and that would be Grif Wildheart.  Ye\'ll find him standing just outside the smithy in Kharanos.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7003,'If ye ask me, I think Grif spends a little too much time with the animals.  Still, nobody else knows the hunter\'s path quite like he does.  Look for him outside the smithy in Kharanos.','If ye ask me, I think Grif spends a little too much time with the animals.  Still, nobody else knows the hunter\'s path quite like he does.  Look for him outside the smithy in Kharanos.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7004,'Mage','Mage',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7005,'There\'s a mage at the Thunderbrew Distillery who might be able to teach you some new spells.  I believe his name is Magis Sparkmantle.','There\'s a mage at the Thunderbrew Distillery who might be able to teach you some new spells.  I believe his name is Magis Sparkmantle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7006,'Ye sure ye don\'t want to learn to be a warrior?  Well, it\'s yer hide on the battlefield.  If ye really want to learn to waggle yer finger, ye best talk to Magis Sparkmantle in the Thunderbrew Distillery.','Ye sure ye don\'t want to learn to be a warrior?  Well, it\'s yer hide on the battlefield.  If ye really want to learn to waggle yer finger, ye best talk to Magis Sparkmantle in the Thunderbrew Distillery.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7007,'Paladin','Paladin',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7008,'Och... a paladin?  Well $glad : lass;, ye\'re in luck!  Azar Stronghammer is back from training and is currently staying at the Thunderbrew Distillery in Kharanos.','Och... a paladin?  Well $glad : lass;, ye\'re in luck!  Azar Stronghammer is back from training and is currently staying at the Thunderbrew Distillery in Kharanos.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7009,'Ye need some training?  Well, Azar Stronghammer is always up for showing the younger paladins a thing or two.  Why don\'t ye go see him in the Thunderbrew Distillery.','Ye need some training?  Well, Azar Stronghammer is always up for showing the younger paladins a thing or two.  Why don\'t ye go see him in the Thunderbrew Distillery.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7010,'Priest','Priest',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7011,'Oh, a priest is it?  Well good ol\' Maxan is sure to be found having a drink in the Thunderbrew Distillery if ye need a bit of training.','Oh, a priest is it?  Well good ol\' Maxan is sure to be found having a drink in the Thunderbrew Distillery if ye need a bit of training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7012,'Ye\'ll surely find Maxan Anvol tossin\' back a few in the Thunderbrew Distillery.  Why don\'t ye go have yerself a pint and see if he\'ll teach ye something new.','Ye\'ll surely find Maxan Anvol tossin\' back a few in the Thunderbrew Distillery.  Why don\'t ye go have yerself a pint and see if he\'ll teach ye something new.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7013,'Rogue','Rogue',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7014,'Well then, it seems we\'re both looking for Hogral Bakkan.  He\'s a dwarf to be sure, so sooner or later he\'ll be heading for the Thunderbrew Distillery for an ale -- he might even be there now.','Well then, it seems we\'re both looking for Hogral Bakkan.  He\'s a dwarf to be sure, so sooner or later he\'ll be heading for the Thunderbrew Distillery for an ale -- he might even be there now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7015,'Ye looking for Hogral?  Well did ye check the tavern?  Och!  If yer looking for a rogue, and a dwarf one at that, ye should start in the Inn!  Go have a look already.','Ye looking for Hogral?  Well did ye check the tavern?  Och!  If yer looking for a rogue, and a dwarf one at that, ye should start in the Inn!  Go have a look already.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7016,'Warlock','Warlock',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7017,'Warlocks... I don\'t care for their lot.  Like that Grimrizz who\'s set up shop outside the Thunderbrew Distillery. The ale will probably go flat there because of him!  Warlocks... bah!','Warlocks... I don\'t care for their lot.  Like that Grimrizz who\'s set up shop outside the Thunderbrew Distillery. The ale will probably go flat there because of him!  Warlocks... bah!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7018,'That kind of magic is just bad news, I tell ye.  I don\'t know why that Grimrizz has been allowed to set up outside the Thunderbrew Distillery of all places!  You stay away from him, you here!','That kind of magic is just bad news, I tell ye.  I don\'t know why that Grimrizz has been allowed to set up outside the Thunderbrew Distillery of all places!  You stay away from him, you here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7019,'Warrior','Warrior',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7020,'Och!  Now ye\'re talkin\'!  I bet Granis Swiftaxe could show ye a thing or two about swinging steel.  He\'s over in the Thunderbrew Distillery in Kharanos at the moment.','Och!  Now ye\'re talkin\'!  I bet Granis Swiftaxe could show ye a thing or two about swinging steel.  He\'s over in the Thunderbrew Distillery in Kharanos at the moment.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7021,'That Granis Swiftaxe could drink a fish under the table and yet his axe still swings true.  However, if yer looking for training, ye best catch him while ye can understand him.','That Granis Swiftaxe could drink a fish under the table and yet his axe still swings true.  However, if yer looking for training, ye best catch him while ye can understand him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7022,'Profession Trainer','Profession Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7023,'Which profession trainer would ye be looking for?','Which profession trainer would ye be looking for?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7024,'Alchemy','Alchemy',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7025,'Blacksmithing','Blacksmithing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7026,'Cooking','Cooking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7027,'Enchanting','Enchanting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7028,'Engineering','Engineering',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7029,'First Aid','First Aid',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7030,'Fishing','Fishing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7031,'Herbalism','Herbalism',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7032,'Leatherworking','Leatherworking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7033,'Mining','Mining',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7034,'Skinning','Skinning\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7035,'Tailoring','Tailoring',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7036,'Nope, no alchemists out here in Dun Morogh.  Ye best take a look in Ironforge for them... try the gnomes in Tinker Town.','Nope, no alchemists out here in Dun Morogh.  Ye best take a look in Ironforge for them... try the gnomes in Tinker Town.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7037,'I hear there\'s a shop up in Ironforge run by the gnomes that specializes in alchemy.  You should go have a look.','I hear there\'s a shop up in Ironforge run by the gnomes that specializes in alchemy.  You should go have a look.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7038,'Och!  Now that\'s a skill worth knowing.  Tognus beats the anvil with a fury ye don\'t see often.  Why don\'t ye go talk him up and see what he can teach ye?','Och!  Now that\'s a skill worth knowing.  Tognus beats the anvil with a fury ye don\'t see often.  Why don\'t ye go talk him up and see what he can teach ye?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7039,'Ye can probably hear Tognus beating away on the anvil when yer in Kharanos.  Although, if ye haven\'t cleared the wax out of yer ears recently, then why don\'t ye just have a look in the smithy.','Ye can probably hear Tognus beating away on the anvil when yer in Kharanos.  Although, if ye haven\'t cleared the wax out of yer ears recently, then why don\'t ye just have a look in the smithy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7040,'A Thunderbrew ale and a bit of Gremlock\'s cooking makes for a nice meal indeed.  Ye really should hit him up for some training if ye want to be a cook.','A Thunderbrew ale and a bit of Gremlock\'s cooking makes for a nice meal indeed.  Ye really should hit him up for some training if ye want to be a cook.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7041,'Gremlock doesn\'t always have the best of luck with cooking, but he does have some tasty recipies worth learning.  Go chat him up in the Thunderbrew Distillery and see what he\'ll teach ye.','Gremlock doesn\'t always have the best of luck with cooking, but he does have some tasty recipies worth learning.  Go chat him up in the Thunderbrew Distillery and see what he\'ll teach ye.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7042,'There aren\'t any enchanters out here in Dun Morogh that I know of.  Ye\'re going to have to visit Ironforge if ye want to learn the enchanter\'s profession.','There aren\'t any enchanters out here in Dun Morogh that I know of.  Ye\'re going to have to visit Ironforge if ye want to learn the enchanter\'s profession.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7043,'Ye should take a look in Ironforge if ye have yer mind set on enchanting.  I think I saw a shop over by the gryphon master last time I was up there.','Ye should take a look in Ironforge if ye have yer mind set on enchanting.  I think I saw a shop over by the gryphon master last time I was up there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7044,'Ye should check over at Steelgrill\'s Depot for Bronk.  When he\'s not tinkering with some odd device, he\'s usually chatting up the pilots about their steam tanks.','Ye should check over at Steelgrill\'s Depot for Bronk.  When he\'s not tinkering with some odd device, he\'s usually chatting up the pilots about their steam tanks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7045,'With all the screws that Bronk has been tightening, I think he\'s let a few of his own go if ye get me.  All the same he\'s still got a good head for engineering the darndest devices.  Ye should go pay him a visit over at Steelgrill\'s Depot.','With all the screws that Bronk has been tightening, I think he\'s let a few of his own go if ye get me.  All the same he\'s still got a good head for engineering the darndest devices.  Ye should go pay him a visit over at Steelgrill\'s Depot.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7046,'First Aid may not make up for a priest\'s healing, but it\'s handy in a pinch.  I recommend ye go talk to Thamner in the Thunderbrew Distillery and learn what ye can.','First Aid may not make up for a priest\'s healing, but it\'s handy in a pinch.  I recommend ye go talk to Thamner in the Thunderbrew Distillery and learn what ye can.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7047,'Good ol\' Thamner bandaged me up just the other day when I had a run in with a nasty trogg.  I\'m good as new I tell ye!  I\'m sure Thamner would be happy to show ye how to make a good bandage.','Good ol\' Thamner bandaged me up just the other day when I had a run in with a nasty trogg.  I\'m good as new I tell ye!  I\'m sure Thamner would be happy to show ye how to make a good bandage.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7048,'Not much fishing to be had around here, but what little there is to be had is Paxton\'s ye can be sure.  Ye can find him fishing out on Iceflow Lake.','Not much fishing to be had around here, but what little there is to be had is Paxton\'s ye can be sure.  Ye can find him fishing out on Iceflow Lake.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7049,'Only a few spots to get any fishing done around here.  Paxton knows them all and probably a few he won\'t tell ya about.  Why don\'t ye go over to Iceflow Lake and see what he will tell ya.','Only a few spots to get any fishing done around here.  Paxton knows them all and probably a few he won\'t tell ya about.  Why don\'t ye go over to Iceflow Lake and see what he will tell ya.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7050,'Amazing to see little flowers persist in the cold of Dun Morogh...  but ye won\'t find any herbalists out here.  Ye\'ll have to go to Ironforge to get some training in that profession.','Amazing to see little flowers persist in the cold of Dun Morogh...  but ye won\'t find any herbalists out here.  Ye\'ll have to go to Ironforge to get some training in that profession.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7051,'Nope, nobody who can teach ye herbalism out here.  I think ye\'ll have better luck in Ironforge though.','Nope, nobody who can teach ye herbalism out here.  I think ye\'ll have better luck in Ironforge though.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7052,'If ye\'re looking to learn the profession of leatherworking, ye\'re gonna need to travel to Ironforge.  I hear there\'s a nice shop near the Great Forge where ye can learn the profession.','If ye\'re looking to learn the profession of leatherworking, ye\'re gonna need to travel to Ironforge.  I hear there\'s a nice shop near the Great Forge where ye can learn the profession.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7053,'Ironforge is going to be your best bet for leatherworkers.  If memory serves, there\'s a shop by The Great Forge that should meet yer needs.','Ironforge is going to be your best bet for leatherworkers.  If memory serves, there\'s a shop by The Great Forge that should meet yer needs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7054,'Surely ye didn\'t think ye would find a town without a resident miner about, did ye?  Yarr can usually be found over at Steelgrill\'s Depot just outside of Kharanos.','Surely ye didn\'t think ye would find a town without a resident miner about, did ye?  Yarr can usually be found over at Steelgrill\'s Depot just outside of Kharanos.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7055,'A miner?  Ye don\'t need to ask if $glad : lass;, only where!  Yarr is who yer looking for, and I think ye can find him hiding out over in Steelgrill\'s Depot.','A miner?  Ye don\'t need to ask if $glad : lass;, only where!  Yarr is who yer looking for, and I think ye can find him hiding out over in Steelgrill\'s Depot.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7056,'Ye won\'t find any skinners out in here Dun Morogh $glad : lass;, they\'re mostly to be found in Ironforge if ye\'re looking to be trained.','Ye won\'t find any skinners out in here Dun Morogh $glad : lass;, they\'re mostly to be found in Ironforge if ye\'re looking to be trained.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7057,'The skinners usually take all their hides into Ironforge to dry out.  Why don\'t you head there and see if you can find one to train ye?','The skinners usually take all their hides into Ironforge to dry out.  Why don\'t you head there and see if you can find one to train ye?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7058,'Ah, Stonebrow doesn\'t leave Ironforge much these days so if ye\'re looking to learn the tailor\'s profession ye\'ll have to go to see him up in Ironforge.','Ah, Stonebrow doesn\'t leave Ironforge much these days so if ye\'re looking to learn the tailor\'s profession ye\'ll have to go to see him up in Ironforge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7059,'Well, ye won\'t have much luck with finding a tailor out here.  Ironforge is home to a quite a few talented tailors though.  Why don\'t ye go ask a guard there.','Well, ye won\'t have much luck with finding a tailor out here.  Ironforge is home to a quite a few talented tailors though.  Why don\'t ye go ask a guard there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7060,'Anu therador mali $c.  Where can I guide you to?','Anu therador mali $c.  Where can I guide you to?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7061,'How may I aid you in your journey?','How may I aid you in your journey?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7062,'Do you require guidance to your destination?','Do you require guidance to your destination?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7063,'What direction can I point you in?','What direction can I point you in?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7064,'I need directions.','I need directions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7065,'There are many places that you might visit in Teldrassil.  Tell me what you seek.','There are many places that you might visit in Teldrassil.  Tell me what you seek.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7066,'The Bank','The Bank',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7067,'The bank is located in the serene city of Darnassus.  You must go there if you wish to store your possessions.','The bank is located in the serene city of Darnassus.  You must go there if you wish to store your possessions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7068,'If a bank is what you desire, then your travels take you to the heart of Darnassus.  There you will find storage for your treasures.','If a bank is what you desire, then your travels take you to the heart of Darnassus.  There you will find storage for your treasures.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7069,'Rut\'theran Ferry','Rut\'theran Ferry',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7070,'To reach the Rut\'theran Ferry, you will need to travel to Darnassus and take the portal to Rut\'theran Village at the base of Teldrassil.','To reach the Rut\'theran Ferry, you will need to travel to Darnassus and take the portal to Rut\'theran Village at the base of Teldrassil.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7071,'Gryphons leave for Lor\'danel from Rut\'theran Village at the base of Teldrassil.  The portal in Darnassus will allow you to reach Rut\'theran safely.','Gryphons leave for Lor\'danel from Rut\'theran Village at the base of Teldrassil.  The portal in Darnassus will allow you to reach Rut\'theran safely.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7072,'The Guild Master & Vendor.','The Guild Master & Vendor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7073,'Matters of such an official nature are only handled in Darnassus.  You must travel there to begin the process of your guild\'s creation.','Matters of such an official nature are only handled in Darnassus.  You must travel there to begin the process of your guild\'s creation.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7074,'Documents such as guild creation papers can be acquired from the Guild Master in the city of Darnassus.  ','Documents such as guild creation papers can be acquired from the Guild Master in the city of Darnassus.  ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7075,'The Inn','The Inn',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7076,'A restful sleep is sure to be had in the beds which Innkeeper Keldamyr keeps at the Inn in Dolanaar.  ','A restful sleep is sure to be had in the beds which Innkeeper Keldamyr keeps at the Inn in Dolanaar.  ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7077,'If you require time to rest and regain your strength, you will find the best at the Inn in Dolanaar.  Innkeeper Keldamyr will see to it that you are taken care of.','If you require time to rest and regain your strength, you will find the best at the Inn in Dolanaar.  Innkeeper Keldamyr will see to it that you are taken care of.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7078,'Class Trainer','Class Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7079,'You will find numerous trainers around Dolanaar with ages of experience with which to tutor you.  Which would you have me point you to?','You will find numerous trainers around Dolanaar with ages of experience with which to tutor you.  Which would you have me point you to?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7080,'Druid','Druid',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7081,'You seek the aid of a Druid?  Then you should go see Kal at the Moonwell just south of the Inn in Dolanaar.','You seek the aid of a Druid?  Then you should go see Kal at the Moonwell just south of the Inn in Dolanaar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7082,'The druid, Kal, often spends his time at the moonwell in Dolanaar.  I am certain he would be able to provide you with the training you require.','The druid, Kal, often spends his time at the moonwell in Dolanaar.  I am certain he would be able to provide you with the training you require.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7083,'Hunter','Hunter',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7084,'If a hunter is whom you seek, then it is Dazalar that you should visit.  He can usually be found just outside the Inn in Dolanaar.','If a hunter is whom you seek, then it is Dazalar that you should visit.  He can usually be found just outside the Inn in Dolanaar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7085,'Dazalar is well known around Dolanaar for his hunting skill.  Why don\'t you talk to him and see what he can teach you?','Dazalar is well known around Dolanaar for his hunting skill.  Why don\'t you talk to him and see what he can teach you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7086,'Priest','Priest',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7087,'A priestess by the name of Laurna Morninglight calls Dolanaar home.  I believe she can be found just north of the Inn.','A priestess by the name of Laurna Morninglight calls Dolanaar home.  I believe she can be found just north of the Inn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7088,'Laurna Morninglight offers healing to those that live around Dolanaar.  Perhaps she would be able to teach you in the ways of a priest.','Laurna Morninglight offers healing to those that live around Dolanaar.  Perhaps she would be able to teach you in the ways of a priest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7089,'Rogue','Rogue',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7090,'A rogue?  I\'m not in the habit of referring people to those types, but I believe Jannok would be the one you\'re looking for.  You will find him at the Inn in Dolanaar.','A rogue?  I\'m not in the habit of referring people to those types, but I believe Jannok would be the one you\'re looking for.  You will find him at the Inn in Dolanaar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7091,'You seek a rogue?  I believe Jannok would fit that description.  Why don\'t you go talk to him over at the Inn in Dolanaar.','You seek a rogue?  I believe Jannok would fit that description.  Why don\'t you go talk to him over at the Inn in Dolanaar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7092,'Warrior','Warrior',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7093,'Kyra Windblade wields her blade with great skill.  She should be able to provide you with some training.  You\'ll find her at the Inn in Dolanaar.','Kyra Windblade wields her blade with great skill.  She should be able to provide you with some training.  You\'ll find her at the Inn in Dolanaar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7094,'I had the pleasure of seeing Kyra Windblade in combat once.  Considering what I witnessed, I am confident she will train you well.  Look for her at the Inn in Dolanaar.','I had the pleasure of seeing Kyra Windblade in combat once.  Considering what I witnessed, I am confident she will train you well.  Look for her at the Inn in Dolanaar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7095,'Profession Trainer','Profession Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7096,'The path of those who undertake a profession is long and rewarding.  Which path do you choose to walk?','The path of those who undertake a profession is long and rewarding.  Which path do you choose to walk?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7097,'Alchemy','Alchemy',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7098,'While Cyndra is not bubbly like her potions, her kind manner is suitable for teaching her trade.  You can find her just east of the Inn in Dolanaar.','While Cyndra is not bubbly like her potions, her kind manner is suitable for teaching her trade.  You can find her just east of the Inn in Dolanaar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7099,'Cyndra\'s knowledge in alchemy is somewhat limited, but I\'m sure it would be sufficient to get you started.  She practices her craft just east of the Inn in Dolanaar.','Cyndra\'s knowledge in alchemy is somewhat limited, but I\'m sure it would be sufficient to get you started.  She practices her craft just east of the Inn in Dolanaar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7100,'Cooking','Cooking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7101,'Zarrin seems to have a good knowledge of the cooking trade.  Why don\'t you go see if he will show you some recipes?  He is usually cooking over by the Inn in Dolanaar.','Zarrin seems to have a good knowledge of the cooking trade.  Why don\'t you go see if he will show you some recipes?  He is usually cooking over by the Inn in Dolanaar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7102,'We could certainly use another cook around Dolanaar, not that Zarrin\'s cooking is lacking mind you.  Why don\'t you go see what he can teach you?','We could certainly use another cook around Dolanaar, not that Zarrin\'s cooking is lacking mind you.  Why don\'t you go see what he can teach you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7103,'Enchanting','Enchanting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7104,'Alanna Raveneye attributes part of her talent in enchanting to her communion with the spirits at the Oracle Glade.  You should be able to find her there now.','Alanna Raveneye attributes part of her talent in enchanting to her communion with the spirits at the Oracle Glade.  You should be able to find her there now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7105,'Alanna spends most of her day at the Oracle Glade where she practices her profession.  Should you wish to learn the Enchanter\'s profession you will need to go there to find her.','Alanna spends most of her day at the Oracle Glade where she practices her profession.  Should you wish to learn the Enchanter\'s profession you will need to go there to find her.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7106,'First Aid','First Aid',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7107,'Byancie has often lent her services to the sentinels who patrol the local wilds.  You should talk to her if you desire to learn First Aid.','Byancie has often lent her services to the sentinels who patrol the local wilds.  You should talk to her if you desire to learn First Aid.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7108,'Byancie\'s skill in First Aid has proven useful on numerous occasions.  You can find her just north of the Inn in Dolanaar if you wish to learn from her.','Byancie\'s skill in First Aid has proven useful on numerous occasions.  You can find her just north of the Inn in Dolanaar if you wish to learn from her.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7109,'Fishing','Fishing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7110,'All the fisherman have moved to Darnassus with the recent attacks around Lake Al\'Ameth.  You should try looking for someone to train you there.','All the fisherman have moved to Darnassus with the recent attacks around Lake Al\'Ameth.  You should try looking for someone to train you there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7111,'The Timberlings have made it too difficult for the fishermen to catch anything around Dolanaar.  You best look for someone to train you in Darnassus.','The Timberlings have made it too difficult for the fishermen to catch anything around Dolanaar.  You best look for someone to train you in Darnassus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7112,'Herbalism','Herbalism',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7113,'Malorne somehow manages to pick the most delicate herbs without damaging them.  Certainly he is the one you should learn from.  He lives just east of the Inn in Dolanaar.','Malorne somehow manages to pick the most delicate herbs without damaging them.  Certainly he is the one you should learn from.  He lives just east of the Inn in Dolanaar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7114,'Herbalism requires a gentle touch that few such as Malorne can teach.  Seek him out east of the Inn in Dolanaar.','Herbalism requires a gentle touch that few such as Malorne can teach.  Seek him out east of the Inn in Dolanaar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7115,'Leatherworking','Leatherworking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7116,'The Maneweavers practice their professions out of their home on the road to Darnassus.  Nadyia is an excellent teacher when it comes to Leatherworking.  You should see what she can teach you.','The Maneweavers practice their professions out of their home on the road to Darnassus.  Nadyia is an excellent teacher when it comes to Leatherworking.  You should see what she can teach you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7117,'Nadyia has made quite the leatherworker in her years of practice.  Travel west on the road to Darnassus to pay her a visit and maybe she can bestow some of her knowledge upon you.','Nadyia has made quite the leatherworker in her years of practice.  Travel west on the road to Darnassus to pay her a visit and maybe she can bestow some of her knowledge upon you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7118,'Skinning','Skinning',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7119,'Radnaal provides Nadyia with a good supply of leather from the animals he skins.  I recommend you speak with him if you wish to learn the profession.','Radnaal provides Nadyia with a good supply of leather from the animals he skins.  I recommend you speak with him if you wish to learn the profession.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7120,'You can find Radnaal practicing his craft outside his home on the road to Darnassus.  You should stop by and see what he can teach you.','You can find Radnaal practicing his craft outside his home on the road to Darnassus.  You should stop by and see what he can teach you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7121,'Tailoring','Tailoring',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7122,'I am certain there is a Tailor that could provide you training in Darnassus.  When you arrive, ask one of the Sentinels in Darnassus about seeing a Tailor.','I am certain there is a Tailor that could provide you training in Darnassus.  When you arrive, ask one of the Sentinels in Darnassus about seeing a Tailor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7123,'Many of the supplies the tailors need come by way of Darnassus.  It is not surprising that they all moved there to work.  If you wish to be a tailor then you best head to Darnassus.','Many of the supplies the tailors need come by way of Darnassus.  It is not surprising that they all moved there to work.  If you wish to be a tailor then you best head to Darnassus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7124,'Help!  Please, you must help me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7125,'Hello, $c. I\'ve set up camp here at the Bulwark to make my preparations for my journey into the Plaguelands. I\'ve heard rumor that a great human wizard took up residency in Hearthglen not terribly long ago. He was commissioned by the Scarlet Crusade to fashion their warriors and hunters new bows and guns. It\'s said that he was working on a remarkable weapon before the Crusade killed him.$B$BI guess their mistrust of the arcane has grown.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7126,'','Greetings, $c. Don\'t have too much time to talk--I\'m just using Chillwind as a camp to get some rest before heading to Hearthglen. I\'ve heard word that before they went crazy, the Scarlet Crusade had a mage working for them who was trying to create powerful bows and guns for their soldiers. I\'m not sure if he succeeded or not... the Crusade killed him before any of his finished product made it out. Maybe they killed him to keep it a secret... or maybe they distrust the arcane that much.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7127,'','He... hello, $n. Sorry, I\'m recovering from my wounds.$B$BThose Scarlet Crusaders are tougher than I had given them credit for. They almost did me in.$B$BYou should be careful too. I\'d hate to see them get the jump on you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7128,'','My family worked  the Northridge Lumber Mill in what\'s now Western Plaguelands. They were dedicated to the Dumah family, and now the Scarlet Crusade have taken it over along with all of Hearthglen!$B$BI will not rest until those zealots are wiped from Azeroth.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7129,'Long ago, before the last great war, my father ran the Northridge Lumber Mill. It was his life, and he was committed to it. Then the war came, and as much as it pained him, we had to flee to Stormwind.$B$BWe lost a number of friends and family in those days, and it pains me to know that the Scarlet Crusade has taken the mill for their own ends.$B$BThat\'s why I\'ve returned.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7130,'Greetings, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7131,'Greetings, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7132,'Greetings, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7133,'I see those fools at the Abbey sent some fresh meat for us.','I see those fools at the Abbey sent some fresh meat for us.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(7134,'This land belongs to the Defias Brotherhood now!','This land belongs to the Defias Brotherhood now!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(7135,'We are the last of the furbolg race... The Timbermaw tribe remains uncorrupted, yet we face the same hostility from outsiders; most believe that it is not possible... that there could actually be furbolg that escaped the corruption...$B$BAngry at those that strive to make enemies too quickly, my brethren now attack any that draw near; they trust no one.$B$BBut perhaps, if you strive to make your presence peaceful with them, they might look upon you as an ally.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7136,'How can I prove myself to the Timbermaw furbolg?','How can I prove myself to the Timbermaw furbolg?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7137,'You must find a way to show that you both are fighting for the same side. Although the Timbermaw may attack you now, if you are diligent, you will find a way.$B$BYou must remember that any attacks on the Timbermaw furbolg directly will greatly hinder your chances of gaining them as an ally.$B$BA good place to start would be the Deadwood furbolg found in many parts of Felwood. These furbolg are the enemy of the Timbermaw tribe, and slaying them would greatly improve your standing with the Timbermaw.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7138,'We Timbermaw can grant you safe passage through the hold, however, you must prove yourself worthy of our aid.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7139,'What about the Winterfall furbolg?','What about the Winterfall furbolg?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7140,'The Winterfall furbolg that reside here in Winterspring were once our allies... But one day, that all changed.$B$BDriven by the strange demands of their high chief, they began to attack all others that they came in contact with, including our tribe. They keep to themselves now...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7141,'Please, do not bother me... Your kind is all the same...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7142,'I would like to buy from you.','I would like to buy from you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7143,'I trust very few of your kind, $n. But I can tell that you are a friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7144,'Yes, yes. I see you.$B$BBe on your way. You may have earned the trust of a few, but it will take more than that to prove it to me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7145,'School is in session!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7146,'I have no time for you, $r. Continue on your way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7147,'If you prove that you are a true ally, I might consider training you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7148,'Welcome, $n! Are you interested in training in tailoring?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7149,'I\'d like to train.','I\'d like to train.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7150,'I don\'t get paid enough for this!','I don\'t get paid enough for this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7151,'Time to take out the trash!','Time to take out the trash!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7152,'I\'m going to dust you into oblivion!','I\'m going to dust you into oblivion!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7153,'How dare you?!','How dare you?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7154,'Spot of tea, gov\'na?','Spot of tea, gov\'na?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7155,'Do not turn your back on the Light, $c, it may be the one thing that saves you some day.','Do not turn your back on the Light, $c, it may be the one thing that saves you some day.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(7156,'I trust the Light is with you, $n. Is there something that I can I help you with?','I trust the Light is with you, $n. Is there something that I can I help you with?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(7157,'I seek more training in the priestly ways.','I seek more training in the priestly ways.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7158,'The Light protect you, $c.','The Light protect you, $c.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(7159,'I hope the Light is with you, $n. Is there anything I can do for you today?','I hope the Light is with you, $n. Is there anything I can do for you today?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(7160,'I seek more training in the priestly ways.','I seek more training in the priestly ways.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7161,'You be watchin\' yerself, $c. Respect our ways, or a curse be on you and yours.','You be watchin\' yerself, $c. Respect our ways, or a curse be on you and yours.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(7162,'I do what me can to train you in the priestly ways, if that what you be here for.','I do what me can to train you in the priestly ways, if that what you be here for.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(7163,'Yes, $c?','Yes, $c?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(7164,'What can this insignificant servant do for you, $n? Training perhaps?','What can this insignificant servant do for you, $n? Training perhaps?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(7165,'Elune be with you, $c.','Elune be with you, $c.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(7166,'My wisdom is yours, as is my knowledge. What can I do for you, $n?','My wisdom is yours, as is my knowledge. What can I do for you, $n?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(7167,'I seek more training in the priestly ways.','I seek more training in the priestly ways.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(7168,'I seek more training in the priestly ways.','I seek more training in the priestly ways.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7169,'I seek more training in the priestly ways.','I seek more training in the priestly ways.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7170,'I be seeking someone, $c. Please, leave me be... it is important I find them.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(7171,'I be a messenger from the Eastern Kingdoms, $n. I be sent here to make sure da priests who travel here be given proper direction.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(7172,'Be quiet!  Can\'t you see the master is speaking?','Be quiet!  Can\'t you see the master is speaking?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7173,'Spend less time rattling and more time listening.','Spend less time rattling and more time listening.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7174,'We must focus if we are to spawn our dragonflight!','We must focus if we are to spawn our dragonflight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7175,'Be silent!  I cannot afford to miss even a moment of this lecture!','Be silent!  I cannot afford to miss even a moment of this lecture!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7176,'Did you forget your student\'s attire?  Do you think fashion is more vital than the Scourge\'s domination?','Did you forget your student\'s attire?  Do you think fashion is more vital than the Scourge\'s domination?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7177,'Did you finish yesterday\'s assignment?  If so, then sit by me!','Did you finish yesterday\'s assignment?  If so, then sit by me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7178,'Watch your step in here, $gboy:girl;.  The master sees all...','Watch your step in here, $gboy:girl;.  The master sees all...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7179,'Did you bring your text books?  Can I look on with you?','Did you bring your text books?  Can I look on with you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7180,'What, may I ask, are you doing here?  Put on your student\'s attire, and study!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7181,'Be silent!  Do you think our plagued dragons will hatch and train themselves?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7182,'Have you come from the Burning Steppes?  Do you have my black dragon eggs?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7183,'Your mind is unfocused.  Are you hiding something from me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7185,'I sense a disturbance, lurking around you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7186,'Your future is clouded.  Concentrate, and ask again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7187,'You don\'t look like a student...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7188,'Now if you turn to page 34 in your text, you see an illustration of a dwarf undergoing dissection...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7189,'Take note of the delicacy of the plagued dragon\'s diet.  Only terrified flesh will suffice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7190,'We await a batch of black dragon eggs from the Burning Steppes.  We believe that, through their study, we will advance our knowledge dramatically.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7191,'Our oldest clutch of dragons are still far from maturity, but with patience and study, we are confident the dragonflight will soon be ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7192,'From yesterday\'s field trip, Marduk showed us that the dragons will tolerate the meat of recently killed humanoids, but only if they died slowly and painfully.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7193,'Tomorrow we will begin training of our promising dragons, so don\'t forget your chew toys.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7194,'The Lich King\'s forces are building.  It is imperative that our timetable supports his plans.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7195,'When preparing the dragon\'s meal, be sure to torture the prisoner in view of the dragon.  It responds well to pre-meal entertainment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7196,'This kodo sure looks nothing like the beast I originally lured!  I wonder if the kombobulator can be used on me.','This kodo sure looks nothing like the beast I originally lured!  I wonder if the kombobulator can be used on me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7197,'','The Plaguelands are an excellent place to strike against the Scourge!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7198,'May I have another Dawn\'s Gambit, Betina?  I want to test it again...','May I have another Dawn\'s Gambit, Betina?  I want to test it again...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7199,'','I\'ve run out of arrows! I\'m afraid if any more come you will need to take them on by yourself my friend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7200,'','Wait... did you hear that? Something approaches from the west!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7201,'','Praise Elune! I don\'t know if I could have survived the day without you, friend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7202,'','My leg feels much better now, the remedy must be working. If you will excuse me, I must go report to my superiors about what has transpired here.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7203,'Who dares to challenge me in my domain?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7204,'','I just fired an arrow.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7205,'End our suffering!','End our suffering!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7206,'You must save him!','You must save him!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7207,'Oh, Darrowshire!  I would give a thousand lives for you!','Oh, Darrowshire!  I would give a thousand lives for you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7208,'Do not fail us!','Do not fail us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7209,'The Light must prevail!','The Light must prevail!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7210,'Beware Marduk!  Beware, or your strength will wither.','Beware Marduk!  Beware, or your strength will wither.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7211,'I was devoured by Horgus!  I can still feel his teeth upon me!','I was devoured by Horgus!  I can still feel his teeth upon me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7212,'Captain Redpath!  How could you forsake us!','Captain Redpath!  How could you forsake us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7213,'%s takes in a deep breath...','%s takes in a deep breath...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7214,'Well met, $c. You may speak to me unless you have direct business with my mistress Magatha.$B$BI deal with most of her tasks for her so she can concentrate on more important matters. Perhaps there are some things we could discuss before you seek audience with her?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7215,'Hello, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7216,'Please, feel free to speak to me anytime, $n. You have served Magatha well. I am sure she will call upon you in the future.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7217,'Do not presume to speak to me as though you are my equal, $c. Sylvanas is my queen, and I will do as she bids.$B$BIf you do not show the proper respect, I assure you, we can find a more than suitable place for you in the Nether.$B$BBut there is no reason we cannot have words if you wish to aid the Dark Lady...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7218,'All members of the Horde are equal in my eyes, $n. We have all suffered many burdens, and if it were not for wisdom and honor, then we would be no better than the Scourge or my people while our blood was tainted by the demon Mannoroth.$B$BIt is your duty to aid the Horde and to defend our way of life. But it is also your duty to know when quarter and compassion should be given to friend and foe alike.$B$BUnderstand this well. This is the new Horde, not some demon-spawned army who lack freewill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7219,'I am ready to hear your tale, Tirion.','I am ready to hear your tale, Tirion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7220,'I must apologize for not being entirely truthful with you in regards to my identity. I had to be certain that you could be trusted - few people would have selflessly lent assistance to an old and forgotten hermit.$B$BYou have proven yourself as one of those people: A person of integrity and honor.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(7221,'Thank you, Tirion. What of your identity?','Thank you, Tirion. What of your identity?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7222,'My son, Taelan, was only a child when I was found guilty of treason and banished from the Alliance to live a life in exile. I chose to remain here so that I could watch over him; to somehow insure that he would grow up an honorable man.$B$BAs I had hoped, he took my place as lord of Mardenholde; but in a cruel twist of fate, joined the ranks of the Scarlet Crusade. He is now their Highlord, $r.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(7223,'That is terrible.','That is terrible.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7224,'Indeed. The Scarlet Crusade are an aberration of the Order of the Silver Hand.$B$BYou must believe me, $r; Taelan is a good man. He needs guidance. He needs to remember... remember what it is to be noble and honorable. I know that in his heart, he knows what he does is wrong. Will you help him? Will you help him remember?','',1,1,6,0,0,0,0,0,1,0,0,0,26124),
(7225,'I will, Tirion.','I will, Tirion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7226,'Why is it that small creatures such as goblins are always fascinated with larger creatures?','Why is it that small creatures such as goblins are always fascinated with larger creatures?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7227,'Ah!  My wounds are too severe.  Defenders, fight on without me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7228,'Listen closely to what you are told and do not quickly trust, or distrust.  For even friends serve their own ends, $c.$B$BOur great Warchief knows this, and to prove that there are warlocks within the Horde who do not wish to destroy it from within or gain control over it, I have volunteered to aid our young leader in anyway I can.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(7229,'Prepare for a severe beating.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7230,'I shall wear your entrails as a necklace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7231,'I can smell your fear, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7232,'If you run now, you may live.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7233,'How dare you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7234,'Pathetic.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7235,'The reckoning is upon you, weakling!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7236,'Disappointing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7237,'Is that the best you can do?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7238,'You weren\'t worth the energy expenditure. <Nathanos spits.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7239,'Next time, bring friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7240,'I am now corrupting you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7241,'Weapons Trainer','Weapons Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7242,'Woo Ping\'s stamina is simply astounding.  Watching him practice his weapon techniques for hours on end, I felt sorry for the practice dummy afterward.  I can\'t think of anyone better suited to train you in armed combat.','Woo Ping\'s stamina is simply astounding.  Watching him practice his weapon techniques for hours on end, I felt sorry for the practice dummy afterward.  I can\'t think of anyone better suited to train you in armed combat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7243,'Master Woo Ping has mastered nearly every weapon known to man.  He is especially deadly with his sword techniques.  He spends a good deal of time over in the Weller\'s Arsenal waiting on new shipments of weapons to arrive if you need some training.','Master Woo Ping has mastered nearly every weapon known to man.  He is especially deadly with his sword techniques.  He spends a good deal of time over in the Weller\'s Arsenal waiting on new shipments of weapons to arrive if you need some training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7244,'Weapons Trainer','Weapons Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7245,'Through the millennia, Ilyenia Moonfire has mastered numerous weapons and now offers to train others in their use.  You can find her at the Warrior\'s Terrace if you desire training.','Through the millennia, Ilyenia Moonfire has mastered numerous weapons and now offers to train others in their use.  You can find her at the Warrior\'s Terrace if you desire training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7246,'I received the majority of my weapons training from Ilyenia Moonfire in the Warrior\'s Terrace.  You would do well to seek her out if you desire to learn the use of a new weapon.  ','I received the majority of my weapons training from Ilyenia Moonfire in the Warrior\'s Terrace.  You would do well to seek her out if you desire to learn the use of a new weapon.  ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7247,'Weapons Trainer','Weapons Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7248,'Between Bixi and Buliwyf, there ain\'t many weapons they haven\'t had the pleasure of slashing or smashing an orc with.  You can find them hanging out at the Timberline Arms weapon shop if ye need some training.','Between Bixi and Buliwyf, there ain\'t many weapons they haven\'t had the pleasure of slashing or smashing an orc with.  You can find them hanging out at the Timberline Arms weapon shop if ye need some training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7249,'Yer looking to learn how to use a new weapon are ye?  Well, ye should be talking to Bixi or Buliwyf over at the Timberline Arms weapon shop then $glad : lass;.  They know their weapons from axes to... uh... zweihanders.','Yer looking to learn how to use a new weapon are ye?  Well, ye should be talking to Bixi or Buliwyf over at the Timberline Arms weapon shop then $glad : lass;.  They know their weapons from axes to... uh... zweihanders.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7251,'Looking to learn how to use a new weapon?  Find Sayoc and Hanashi inside Arms of Legend in the Valley of Honor.','Looking to learn how to use a new weapon?  Find Sayoc and Hanashi inside Arms of Legend in the Valley of Honor.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(7252,'Look for Sayoc and Hanashi at the Valley of Honor inside Arms of Legend.  Watch your tongue around them or Sayoc may decide to give a piece of you as a snack to Grinning Dog.','Look for Sayoc and Hanashi at the Valley of Honor inside Arms of Legend.  Watch your tongue around them or Sayoc may decide to give a piece of you as a snack to Grinning Dog.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(7253,'Weapon Master','Weapon Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7254,'Ah, you seek the wisdom of Ansekhwa.  Look for him on the lower rise at Thunder Bluff Weapons.','Ah, you seek the wisdom of Ansekhwa.  Look for him on the lower rise at Thunder Bluff Weapons.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(7255,'None are as skilled in the use of weapons as Ansekhwa.  It is said that he is guided by the spirits of the finest warriors of our honored ancestors.  Seek him out on the lower rise and he will teach you what you want to know.','None are as skilled in the use of weapons as Ansekhwa.  It is said that he is guided by the spirits of the finest warriors of our honored ancestors.  Seek him out on the lower rise and he will teach you what you want to know.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(7256,'Weapon Master','Weapon Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7257,'Archibald who you look for.  He outside weapon merchant shop on inner ring of War Quarter.','Archibald who you look for.  He outside weapon merchant shop on inner ring of War Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(7258,'Little forsaken know all weapons.  Him Archibald.  You find on inner ring of War Quarter.','Little forsaken know all weapons.  Him Archibald.  You find on inner ring of War Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(7259,'Weapon Master','Weapon Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7260,'It would be wise to explain to you the depths at which our enemies will go to to hide themselves under our noses.$B$BKnow this first and foremost: our enemy is the Shadow Council. No matter what task I give you, or who I ask you to act against, know that one simple fact.$B$BMany cults exist within the Council, but only to hide its actions against the foolish.$B$BGroups like the Burning Blade, the Argus Wake, and the Searing Blade are all tools of the Council. Consider them one and the same.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7261,'Well, well. Looks like we got ourselves some competition. Get \'em boys!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7262,'Ah, one of our own. It is good to see our numbers are growing so rapidly that I can no longer keep track of the faces of our members.$B$BThat fool Vol\'jin thinks I am working hard to cleanse the image of warlocks and prove we are his servants. Idiot! The Burning Legion will make ash of this entire world after it drains it completely.','',2,1,0,0,0,0,0,0,1,0,0,0,26124),
(7263,'Naive fool. The Burning Blade IS the Shadow Council! There are many cults and organizations under the Council\'s rule, but all of them are just extensions of their will. I may lead the Burning Blade, but I am still just as much a pawn to the Council as you are to me!$B$BLook at the Searing Blade--most of them think they are becoming the next rising group of powerful warlocks that they will replace the Shadow Council.','',14,1,0,0,0,0,0,0,1,0,0,0,26124),
(7264,'Haha! Save for their leaders--the satyr, Bazzalan, and the warlock Jergosh--yes, all of them. That is why I constantly send Vol\'jin\'s worshippers at them. It gives Vol\'jin the impression that I am weeding out the evil in the bowels of his great city. The victory is in reality two-fold: kill Thrall\'s faithful and test the strength of those in the Searing Blade to see if they are truly worthy of joining me.','',11,1,0,0,0,0,0,0,1,0,0,0,26124),
(7265,'I will make it known to you. You are obviously already proving yourself in our ranks to become a lieutenant so quickly. Perhaps you can return to me later and I will have tasks for you. The council adores those skilled in the arcane, but servants of all kinds are always welcome, no matter their profession.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7266,'You may speak frankly...','You may speak frankly...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7267,'It is good to see the Burning Blade is taking over where the Shadow Council once failed.','It is good to see the Burning Blade is taking over where the Shadow Council once failed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7268,'So the Searing Blade is expendable?','So the Searing Blade is expendable?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7269,'If there is anything you would have of me...','If there is anything you would have of me...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7270,'I am now corrupted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7271,'I\'m saved.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7272,'','So dark...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7273,'','Is someone there? Tirion my old friend, is that you? Have you come to save us?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7274,'','Are they all... dead?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7275,'','The Sarkhoff\'s... sometimes the Sarkhoff\'s visit. They are good people.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7276,'Being part of the Explorers\' League, I\'ve been hunting for artifacts in the area. Winterspring is said to contain very magical items... Most are highly guarded.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7277,'%s searches for a soul to swallow!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7278,'The solution is ready in my cauldron.  It\'s just the matter of treating both the unfinished key and the scarab.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7279,'It\'s done $n, and I think you\'ll be satisfied with the results.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7280,'The solution is ready in my cauldron.  It\'s just the matter of treating both the unfinished key and the scarab.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7281,'It\'s done $n, and I think you\'ll be satisfied with the results.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7282,'Captain Ballinda Stonehearth will soon arrive at her garrison.  A new battle will soon be joined!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7283,'Fresh troops flood to Iceblood Garrison!  Captain Galvangar will soon arrive, and a new battle will soon begin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7284,'This is the Alterac Valley battlefield.  Both sides are still fighting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7285,'Let\'s start a new battle, and beat the Horde this time!','Let\'s start a new battle, and beat the Horde this time!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7286,'This is the Alterac Valley battlefield.  Currently both sides are at odds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7287,'Let\'s start a new battle, and beat the Alliance this time!','Let\'s start a new battle, and beat the Alliance this time!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7288,'Our forces are ready and eager.  Soon, Balinda Stonehearth will enter her outpost and the battle will begin anew!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7289,'Our general, Vanndar Stormpike, has fallen in battle!  The battle is lost!$B$BSpeak with our quartermaster and help rebuild our forces.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7290,'The horde general is defeated!$B$BThe Alliance is the victor, and the Horde now scrambles to rebuild its weakened forces.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7291,'Neither generals is spawned.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7293,'Drek\'Thar is defeated!  The Alliance is victorious... for now.$B$BSpeak with our quartermaster and aid in our reconstruction.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7294,'I\'m here!  Come and get me you alliance pansies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7295,'Vanndar is here.  Come on, hordelings!  Show me what you got!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7296,'The Frostwolf General is dead!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7297,'The Stormpike General is dead!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7301,'Hey, look out with that kodo! You had better inspect that beast before I give you credit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7302,'That kodo sure is a beauty.  Wait a minute, where are my bifocals?  Perhaps you should inspect the beast for me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7303,'Ah...the wondrous sound of kodos.  I love the way they make the ground shake... inspect the beast for me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7304,'How do the goblins ever manage to secure packs to these beasts?  Kodos are ten times the size!','How do the goblins ever manage to secure packs to these beasts?  Kodos are ten times the size!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7305,'','These are dangerous times, adventurer. Walk lightly.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7306,'I am ready for the illusion, Myranda.','I am ready for the illusion, Myranda.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7307,'','Hello! What brings you to Winterspring? These cold and vast lands may seem dismal, but this is a place of many secrets...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7308,'','Such sssorrow... The passst cannot be undone...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7309,'','I will not forrrget what you have done...$B$BPleassse, leave meee...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7310,'Hey, you call yourself a body guard? Get to work and protect us...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7311,'Mister body guard, are you going to earn your money or what?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7312,'You\'re fired! <Cough...Cork clears throat.> I mean, help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7313,'I will lead us through Hearthglen to the forest\'s edge. From there, you will take me to my father.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7314,'Remove your disguise, lest you feel the bite of my blade when the fury has taken control.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7315,'Halt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7316,'%s calls for his mount.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7317,'%s whinnies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7318,'NOOOOOOOOOOOO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7319,'Sir?','Sir?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7320,'Something is wrong with the Highlord. Do something!','Something is wrong with the Highlord. Do something!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7321,'What the...','What the...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7322,'Hey, what\'s going on over there? Sir, are you alright? Sir??','Hey, what\'s going on over there? Sir, are you alright? Sir??',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7323,'Highlord Fordring, are you alright?','Highlord Fordring, are you alright?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7324,'Run!','Run!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7325,'It\'s Proudmoore! Get out of here!','It\'s Proudmoore! Get out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7326,'Here I am, alliance!  Take me down... if you can!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7327,'','For the Alliance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7328,'','Please speak with Sentinel Onaeya at Maestra\'s Post in Ashenvale, she will see to it that you are properly rewarded for your bravery this day.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7329,'It\'s not much further. The main road is just up ahead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7330,'Eeck! Demons appear hungry for the kodos!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7331,'What am I paying you for? The kodos are nearly dead!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7332,'Only if I were about five feet taller, then I would show these blasphemous demons a thing or two! Help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7333,'Wow! We did it... not sure why we thought we needed the likes of you. Nevertheless, speak with Smeed Scrabblescrew; he will give you your earnings!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7334,'Blast those stupid centaurs! Sigh - well, it seems you kept your bargain. Up the road you shall find Smeed Scrabblescrew, he has your money.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7335,'The Alliance wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7336,'The Horde wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7337,'You disappoint me, Taelan. I had plans for you... grand plans. Alas, it was only a matter of time before your filthy bloodline would catch up with you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7338,'It is as they say: Like father, like son. You are as weak of will as Tirion... perhaps more so. I can only hope my assassins finally succeeded in ending his pitiful life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7339,'TEST - restart battlefield.','TEST - restart battlefield.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7340,'Get out of here!','Get out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7341,'Don\'t let them catch you!','Don\'t let them catch you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7342,'She\'ll have our heads if we\'re caught!','She\'ll have our heads if we\'re caught!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7343,'Do not lose hope, Darrowshire!  We will not fall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7344,'The Light burns bright in you, Davil.  I will enjoy snuffing it out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7345,'Now is the time, Davil.  Now is the time of your death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7346,'Horgus, your nightmare ends!  Now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7347,'For Darrowshire!','For Darrowshire!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7348,'Our captain will save us!','Our captain will save us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7349,'Fight!  Fight for your families!','Fight!  Fight for your families!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7350,'The Scourge will not prevail!','The Scourge will not prevail!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7351,'Do not give up!  Shed your blood for Darrowshire!','Do not give up!  Shed your blood for Darrowshire!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7352,'Fight, and we will win this day!','Fight, and we will win this day!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7353,'Fight to your last breath, brothers and sisters!','Fight to your last breath, brothers and sisters!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7354,'Go back to your Lich King, foul creatures!','Go back to your Lich King, foul creatures!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7355,'Defenders of Darrowshire!  Rally!  We must prevail!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7356,'Darrowshire!  You are doomed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7357,'Darrowshire is defeated!  Soon, all of Lordaeron will fall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7358,'Darrowshire, to arms!  The Scourge approach!','Darrowshire, to arms!  The Scourge approach!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7359,'The Grand Crusader has charged me with destroying you and your newfound friends, Taelan, but know this: I do this for pleasure, not of obligation or duty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7360,'%s calls for his guardsmen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7361,'The end is now, Fordring.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7362,'Sit and listen to my story, $r.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7363,'','Too much time has passed. We must try again later.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7364,'','Ok, let\'s get going!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7365,'','Remember, I need your help to properly channel. I will ask you to aid me several times on our path, so please be ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7366,'Davil Lightfire is defeated!  Darrowshire is lost!','Davil Lightfire is defeated!  Darrowshire is lost!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7367,'Davil Lightfire has succumbed to his wounds!','Davil Lightfire has succumbed to his wounds!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7368,'Horgus is slain!  Take heart, defenders of Darrowshire!','Horgus is slain!  Take heart, defenders of Darrowshire!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7369,'Captain Redpath is slain!','Captain Redpath is slain!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7370,'Isillien!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7371,'This is not your fight, stranger. Protect yourself from the attacks of the Crimson Elite. I shall battle the Grand Inquisitor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7372,'What have you done,  Isillien? You once fought with honor, for the good of our people... and now... you have murdered my boy... ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7373,'May your soul burn in anguish, Isillien! Light give me strength to battle this fiend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7374,'Face me, coward. Face the faith and strength that you once embodied.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7375,'','This blue light... It\'s strange. What do you think it means?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(7376,'$g Hey there cutie, you looking for a ride to Grom\'gol? I hear it gets mighty steamy down in those jungles, maybe I could join you for a short vacation, show you a real jungle cat. : Come, take a trip to the wonderful, gorgeous, tropical jungles of Stranglethorn. That\'s right, you too can be spending your time sunbathing by the crystal blue waters while I stand here in this unbearable heat with nothing to look at but my brother Frezza all day! Enjoy your trip!;','$g Hey there cutie, you looking for a ride to Grom\'gol? I hear it gets mighty steamy down in those jungles, maybe I could join you for a short vacation, show you a real jungle cat. : Come, take a trip to the wonderful, gorgeous, tropical jungles of Stranglethorn. That\'s right, you too can be spending your time sunbathing by the crystal blue waters while I stand here in this unbearable heat with nothing to look at but my brother Frezza all day! Enjoy your trip!;',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7377,'Slip a little coin into the boss\'s hand and look what it gets ya. I love my job. Though, if I could find a way to get that little firecracker Snurk reassigned to this port....well, I can\'t imagine it any better. But I\'m betting that you aren\'t here about my business practices. You\'re looking for the Zeppelin to Undercity, am I right? Well that\'s great, because it docks right here behind me. Oh and hey, if you see Snurk, put a good word in for me, would ya?','Slip a little coin into the boss\'s hand and look what it gets ya. I love my job. Though, if I could find a way to get that little firecracker Snurk reassigned to this port....well, I can\'t imagine it any better. But I\'m betting that you aren\'t here about my business practices. You\'re looking for the Zeppelin to Undercity, am I right? Well that\'s great, because it docks right here behind me. Oh and hey, if you see Snurk, put a good word in for me, would ya?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7378,'','Please, light this while I am channeling.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7379,'','This is the place. Let\'s light it.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7380,'','We\'ve found it!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7381,'Enough!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7382,'%s laughs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7383,'Did you really believe that you could defeat me? Your friends are soon to join you, Taelan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7384,'%s turns his attention towards you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7385,'','It is time for the final step; we must activate the altar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7386,'','I will read the words carved into the stone, and you must find a way to light it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7387,'','It... it is working!',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(7388,'','What is happening? Look!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(7389,'','It has been many years...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7390,'','Who has disturbed the altar of the goddess?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7391,'','Please, priestesses, forgive us for our intrusion. We do not wish any harm here.',68,0,0,0,400,0,0,0,1,0,0,0,26124),
(7392,'','We only wish to know why the wildkin guard this area...',30,0,0,0,0,0,0,0,1,0,0,0,26124),
(7393,'','Enu thora\'serador. This is a sacred place.\n',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7394,'','We will show you...\n',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(7395,'You will not make it to the forest\'s edge, Fordring.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7396,'The Nightmare is finally over!  Darrowshire, forgive me!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(7397,'Pamela?  Are you there, honey?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7398,'Hahah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7399,'','Daddy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7400,'','Daddy!  You\'re back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7401,'','Let\'s go play!  No, tell me a story, Daddy!  No... let\'s go pick flowers!  And play tea time!  I found my dollie, did I tell you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7402,'','I missed you so much, Daddy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7403,'I missed you too, honey.  And I\'m finally home...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7404,'The slain spirit of Lunaclaw stares at you intently, as though wanting something from you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7405,'You have fought well, spirit.  I ask you to grant me the strength of your body and the strength of your heart.','You have fought well, spirit.  I ask you to grant me the strength of your body and the strength of your heart.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7406,'The spirit looks intently into your eyes and grasps your hand.  You feel a warmth shoot through your body, almost knocking you to your knees.$B$BAs the warmth passes, you feel the slight presence of an ursine spirit within your being... bolstering your resolve.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7407,'The Scourge are defeated!  Darrowshire is saved!','The Scourge are defeated!  Darrowshire is saved!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7408,'We have all been witness to terrible tragedies, but we must not let them drag us to despair.$B$BInstead, hold those memories close so that one day, we might find a reckoning.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7409,'I need another Relic Bundle!','I need another Relic Bundle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7410,'','Let\'s find the next one.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7411,'','We must continue on now.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7412,'','The altar is glowing! We have done it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7413,'','Look above you; thara dormil dorah... ',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7414,'','This gem once allowed direct communication with Elune, herself.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7415,'','Through the gem, Elune channeled her infinite wisdom...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7416,'','Anu\'dorini Talah. Ru shallora enudoril.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7417,'','Realizing that the gem needed to be protected, we turned to the goddess herself.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7418,'','Soon after, we began to have visions of a creature... A creature with the feathers of an owl, but the will and might of a bear...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7419,'','It was on that day that the wildkin were given to us. Fierce guardians, the goddess assigned the wildkin to protect all of her sacred places.\n',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7420,'A thousand more like him exist. Ten thousand. Should one fall, another will rise to take the seat of power.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7421,'%s falls to one knee.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7422,'','But now, many years later, the wildkin have grown more feral, and without the guidance of the goddess, they are confused...\n',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7423,'Look what they did to my boy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7424,'','Without a purpose, they wander... But many find their way back to the sacred areas that they once were sworn to protect.\n',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7425,'%s holds the limp body of Taelan Fordring and softly sobs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7426,'Your death will not have been in vain, Taelan. A new Order is born on this day... an Order which will dedicate itself to extinguishing the evil that plagues this world. An evil that cannot hide behind politics and pleasantries.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7427,'','Wildkin are inherently magical; this power was bestowed upon them by the goddess.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7428,'','Know that wherever you might find them in the world, they are protecting something of importance, as they were entrusted to do so long ago.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7429,'Too long have I sat idle, gripped in this haze... this malaise, lamenting what could have been... what should have been.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7430,'This I promise... This I vow...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7431,'','Please, remember what we have shown you...',30,0,0,0,0,0,0,0,1,0,0,0,26124),
(7432,'','Farewell.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7433,'Tragic. The elder Fordring lives on... You are too late, old man. Retreat back to your cave, hermit, unless you wish to join your son in the Twisting Nether.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7434,'','Thank you for your help, $n. I wish you well in your adventures. ',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7435,'','I want to stay here and reflect on what we have seen. Please see Erelas and tell him what we have learned.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7436,'Then come, hermit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7437,'The bear looks at you calmy and patiently, but says nothing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7438,'The bear spirit looks upon you with a calm and peaceful gaze.  You hear a voice speak to you as though it was coming from the bear, but the creature makes no indication that it is speaking.$B$B\"Greetings, my young friend.  If you have come to me seeking guidance, then perhaps I can help you find what you seek.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7439,'What do you represent, spirit?','What do you represent, spirit?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7440,'I represent the strength which bolsters you as a young druid.  I am the strength of the body, and the strength of the heart.  You have already come to know this in your training, and you draw upon this when you take on the aspect of the bear.$B$BContinue to keep the balance in all things, young one, and keep your perspective clear and true.  When you need me... I will be there for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7441,'I represent the strength which bolsters you as a young druid.  You have come to me to learn this strength, young one, and I will teach this to you.  I will teach you all that is the spirit bear, provided you will listen and understand.$B$BIn order to know what it means to draw upon my spirit, you need to understand the importance of the strength of the body, as well as the strength of the heart.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7442,'I seek to understand the importance of strength of the body.','I seek to understand the importance of strength of the body.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7443,'Strength of the body is the power and swiftness of action.  You must keep yourself fit at all times, both physically and mentally.  The bear\'s girth highlights its strength, as it is a ferocious foe in combat.  The bear\'s girth, however, belies its lithe agility and sharp mind.  These are surprises you will use to your advantage.$B$BYou must rely on the strength of the bear\'s body in order to master the way of the Claw.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7444,'I seek to understand the importance of strength of the heart.','I seek to understand the importance of strength of the heart.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7445,'Strength of the heart is what gives you the resolve to take action... action that is rooted in intents that are pure and forthright.  To keep the balance is not to be complacent or banal.$B$BYou must show resolve for that which you believe in, and you must be willing to fight for it.  The mother bear shows endless conviction in protecting her young, as does an elder bear protecting his den.  It is this resolve, this strength of heart, which you must come to know if you are to master the way of the Claw.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7446,'I have heard your words, Great Bear Spirit, and I understand.  I now seek your blessings to fully learn the way of the Claw.','I have heard your words, Great Bear Spirit, and I understand.  I now seek your blessings to fully learn the way of the Claw.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7447,'It remains to be seen if you are ready, young one.  Even the wisest and oldest of druids are never truly ready when their ultimate time of testing comes.$B$BYou have heard my words, and now you must move on.  Heed what I have taught you.  There will be a time when you will have your strength tested.  You must face your foe as the bear would - with strength of body and with strength of heart.  Learn from the fight, young one.  Go... with my blessings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7448,'Greetings, $c.  You are welcome in Nighthaven, as well as all of Moonglade.  The Cenarion Circle welcomes all beings who respect the authority and command of nature.$B$BWhile you are here, please be sure to preserve the balance in all things.  Disturbances are not welcome here, and our wardens are trained to cease all hostilities without question.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7449,'','Do you require an illusion?$B$BShould your illusion falter in the midst of your quest, return to me and I shall reapply the guise.$B$BShould you fail in your endeavors, do not give up! Return to me. I shall assist you until you have completed your objectives.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7450,'Strive to keep the balance in all things, $c.  This is where true harmony lies.','Strive to keep the balance in all things, $c.  This is where true harmony lies.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7451,'Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to teach you.$B$BIt never hurts to reaffirm one\'s place within what I like to call the Great Balance.  As preservers of this balance, we must strive to continually keep our minds clear and our hearts strong.  Training helps us in this regard.','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to teach you.$B$BIt never hurts to reaffirm one\'s place within what I like to call the Great Balance.  As preservers of this balance, we must strive to continually keep our minds clear and our hearts strong.  Training helps us in this regard.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(7452,'I seek training as a druid.','I seek training as a druid.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7453,'The battle is over, and the people of Darrowshire are saved.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7454,'The battle is over, and the people of Darrowshire are saved.$B$BThey are saved, $n, because of you.  You are truly a hero of Darrowshire.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7455,'A darkness had fallen over my eyes, but you tore me from my unholy reverie.  You saved me, $n.$B$BAnd now I beg you... to forgive me.','',20,0,0,0,0,0,0,0,1,0,0,0,26124),
(7456,'Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BWe are the preservers of the balance, now and forever, with Malfurion watching over us.  Never forget this.','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BWe are the preservers of the balance, now and forever, with Malfurion watching over us.  Never forget this.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(7457,'Our master Malfurion has returned from the Dreaming, $c.  His is the light of a beacon that shows the way for us, and we must do everything in our power to preserve that light.','Our master Malfurion has returned from the Dreaming, $c.  His is the light of a beacon that shows the way for us, and we must do everything in our power to preserve that light.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7458,'The blessings of Cenarius be yours, $c.','The blessings of Cenarius be yours, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7459,'Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you!','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you!',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(7460,'Even within cold, stone walls such as the ones that shelter this town, one may find tranquility and peace.  In fact, you may find them everywhere you are... simply look inside yourself for such balance.','Even within cold, stone walls such as the ones that shelter this town, one may find tranquility and peace.  In fact, you may find them everywhere you are... simply look inside yourself for such balance.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7461,'Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BThere will be a time soon where the call of the Emerald Dream will take hold in you.  You will hibernate for many years and walk amongst the purest of forms.  It is there and then that your ultimate training will take place.','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BThere will be a time soon where the call of the Emerald Dream will take hold in you.  You will hibernate for many years and walk amongst the purest of forms.  It is there and then that your ultimate training will take place.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(7462,'You merely prolong the inevitable. Succumb. She will free your misguided soul.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7463,'We work to preserve the balance as Cenarius teaches, $c.  His is the light of a beacon that shows the way for us, and we must do everything in our power to preserve that light.','We work to preserve the balance as Cenarius teaches, $c.  His is the light of a beacon that shows the way for us, and we must do everything in our power to preserve that light.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7464,'Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BWe are the preservers of the balance, now and forever, as Cenarius has taught us.  Never forget this.','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BWe are the preservers of the balance, now and forever, as Cenarius has taught us.  Never forget this.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(7465,'','Thanks again, $n! I\'m very pleased with what we found.$B$BGood luck to you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7466,'','I\'m getting ready to travel up the ridge, $n. I could use some help -- would you like to come with me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7467,'','%s begins chanting a strange spell...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7468,'Are you ready to fetch, boy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7469,'%s barks in anticipation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7470,'Go get it!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7471,'Redpath!  Your life ends, here and now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7472,'I am unable to train you.','I am unable to train you.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(7473,'Good boy! Now put it back on the bone pile.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7474,'I am looking for some bodyguards that would like to protect the Gizelton Caravan. We are stopped on the road east of Kormek\'s Hut, north of Kolkar Centaur Village.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7475,'This is Rigger Gizelton asking for assistance escorting my caravan past Mannoroc Coven. I\'m on the road east of Shadowprey village.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7476,'I don\'t train your kind $c.','I don\'t train your kind $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7477,'We are but darkness and shadows. Eternal. Invisible.','We are but darkness and shadows. Eternal. Invisible.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(7478,'I seek training.','I seek training.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(7479,'Greetings young rogue. What do you seek?','Greetings young rogue. What do you seek?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7480,'I can not train you. You need to talk to your class trainer.','I can not train you. You need to talk to your class trainer.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7481,'Can\'t help ya, $n. I only train rogues.','Can\'t help ya, $n. I only train rogues.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7482,'Can\'t help ya, $n. I only train rogues.','Can\'t help ya, $n. I only train rogues.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7483,'Sorry, but I only train rogues.','Sorry, but I only train rogues.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7484,'Ah... a customer! Talk to my greatest invention, the Vendor-Tron 1000. He has all your needs... some of the rarest items you will ever find on the market anywhere in Kalimdor... not to mention that his programming will not allow any bargaining, so the price you see is the price you pay.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7486,'No doubt you are another inept simpleton sent from the Dark Lady to train under her champion.$B$B<Nathanos sighs.>$B$BI\'ve sent every one of you back to her in pieces, I don\'t see why it will be any different this time.$B$BMine, however, is not to question why, but instead to do as the Dark Lady bids.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(7487,'Let me take a look at what you have to offer.','Let me take a look at what you have to offer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7488,'This just happens to be your lucky day; I just completed Super-Seller 680\'s maintenance. There are tons of items for sell at great low-low prices. Go ahead and see for yourself... my brother Cork thinks his Vendor-Tron 1000 will out sell my bot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7489,'What kin I do for ye, $n?','What kin I do for ye, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7490,'I\'m lookin\' for rogue trainin\'.','I\'m lookin\' for rogue trainin\'.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7491,'Can you train me how to use rogue skills?','Can you train me how to use rogue skills?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7492,'You look like the type I should watch my coin purse around. Something I can help you with?','You look like the type I should watch my coin purse around. Something I can help you with?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(7493,'I don\'t think you want to learn anything I can teach. Might want to find a $c trainer to help you out.','I don\'t think you want to learn anything I can teach. Might want to find a $c trainer to help you out.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(7494,'Come to learn from the master eh?','Come to learn from the master eh?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7495,'Yes, I have. Teach me.','Yes, I have. Teach me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7496,'Do I look like a $c to you? Now run along before I feel the need to oil my blade... in your blood.','Do I look like a $c to you? Now run along before I feel the need to oil my blade... in your blood.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7497,'Elune be with you, $c.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(7498,'Greetings, my friend.  May the Dawn keep you well in these troubled times.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(7499,'Not so fast, $g guy : lady;... I\'ll not be handing out the reigns of a mighty ram steed to someone that\'s not a proven ally of the dwarves of Ironforge.  Once you\'ve been recognized as friendly to Ironforge, I\'ll gladly show you what varieties of rams I have for sale.','Not so fast, $g guy : lady;... I\'ll not be handing out the reigns of a mighty ram steed to someone that\'s not a proven ally of the dwarves of Ironforge.  Once you\'ve been recognized as friendly to Ironforge, I\'ll gladly show you what varieties of rams I have for sale.',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(7500,'My programming will not allow me to lower the cost of any items.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7501,'I am curious to see what a bucket of bolts has to offer.','I am curious to see what a bucket of bolts has to offer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7503,'You\'ve not had a steed until you\'ve taken the reigns of a finely bred Barak Tor\'ol mountain ram, my friend.  Please, feel free to inspect these fine companions to any adventurer.  They\'ll serve you well, believe me.','You\'ve not had a steed until you\'ve taken the reigns of a finely bred Barak Tor\'ol mountain ram, my friend.  Please, feel free to inspect these fine companions to any adventurer.  They\'ll serve you well, believe me.',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(7504,'I am the latest incarnation of automated vendors... we will rule the world one day... don\'t tell my boss that I am skimming money off his merchandise...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7505,'So sorry to leave a customer but we have places to go and people to swindle. We will be back sometime later today. Good-bye!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7506,'Time for the Gizleton Caravan to head on out! We\'ll be back soon but if you cannot wait, head north to Kormek\'s Hut. We open shop in about an hour.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7507,'Sorry, but I am not disposed to sell horses to any individual who is not considered to be at least friendly to the Kingdom of Stormwind.  These steeds are the finest you\'ll find anywhere, and we certainly wouldn\'t want them in the hands of our enemies.$B$BNot saying you\'re an enemy, of course... just earn the trust of Stormwind and then we can do business.','Sorry, but I am not disposed to sell horses to any individual who is not considered to be at least friendly to the Kingdom of Stormwind.  These steeds are the finest you\'ll find anywhere, and we certainly wouldn\'t want them in the hands of our enemies.$B$BNot saying you\'re an enemy, of course... just earn the trust of Stormwind and then we can do business.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7508,'Years of quality breeding techniques and plenty of care allow me the privilege of showing you these horses!  Please, take your time as you consider them for your mount.  A horse is a companion for the ages, friend.  Don\'t sell yourself short - get your steed here today!','Years of quality breeding techniques and plenty of care allow me the privilege of showing you these horses!  Please, take your time as you consider them for your mount.  A horse is a companion for the ages, friend.  Don\'t sell yourself short - get your steed here today!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7509,'Let me browse your goods.','Let me browse your goods.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7510,'You are not known to my people.  A kodo is a mighty steed, and it is the product of love and care by my people; such is not given onto strangers.  Until the elders of Thunder Bluff consider you to be a friend, I cannot offer you the sale of a kodo.','You are not known to my people.  A kodo is a mighty steed, and it is the product of love and care by my people; such is not given onto strangers.  Until the elders of Thunder Bluff consider you to be a friend, I cannot offer you the sale of a kodo.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7511,'Before beginning a hunt, it is wise to ask someone what you are looking for before you begin looking for it.','Before beginning a hunt, it is wise to ask someone what you are looking for before you begin looking for it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7512,'Kodo beasts, my friend!  Trained from a young age and raised on the Golden Plains of Mulgore, these fine animals will make even finer steeds!  Please, browse my selection, and see for yourself why we taurens have come to rely on these magnificant creatures!','Kodo beasts, my friend!  Trained from a young age and raised on the Golden Plains of Mulgore, these fine animals will make even finer steeds!  Please, browse my selection, and see for yourself why we taurens have come to rely on these magnificant creatures!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7513,'Welcome to the Cenarion Circle, $c.','Welcome to the Cenarion Circle, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7514,'I\'d like to train.','I\'d like to train.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7515,'I am here for training.','I am here for training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7516,'Let me train you in the ways of the hunter.','Let me train you in the ways of the hunter.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7517,'I am in need of training.','I am in need of training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7518,'I have much knowledge to impress upon you, $c. You must learn to hunt with honor.','I have much knowledge to impress upon you, $c. You must learn to hunt with honor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7519,'I have come for training.','I have come for training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7520,'I train hunters in the ways and traditions of our ancestors.','I train hunters in the ways and traditions of our ancestors.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7521,'I am in need of training.','I am in need of training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7522,'Tauren have a passion for hunting; it is something that runs deep with our kind.','Tauren have a passion for hunting; it is something that runs deep with our kind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7523,'I am a hunter and wish to train.','I am a hunter and wish to train.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7524,'The Royal Apothecary Society has little patience for fools, as do I.  Perhaps the next time you and I speak of my steeds, you will be considered a friend of the Undercity.  Until then...','The Royal Apothecary Society has little patience for fools, as do I.  Perhaps the next time you and I speak of my steeds, you will be considered a friend of the Undercity.  Until then...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7525,'On behalf of the Royal Apothecary Society, I am pleased to offer you the finest steeds available for the Forsaken.  These beasts have endured trials and tribulations as we all have, and now they too have emerged stronger and more resilient than mere mortal flesh would have had them destined to be!  Please, inspect them for yourself and see.','On behalf of the Royal Apothecary Society, I am pleased to offer you the finest steeds available for the Forsaken.  These beasts have endured trials and tribulations as we all have, and now they too have emerged stronger and more resilient than mere mortal flesh would have had them destined to be!  Please, inspect them for yourself and see.',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(7526,'Come learn the ways of the hunter. Pride, honor, and tradition.','Come learn the ways of the hunter. Pride, honor, and tradition.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7527,'I can teach you the finer points of Ram Riding, provided you have enough gold to cover the lesson!','I can teach you the finer points of Ram Riding, provided you have enough gold to cover the lesson!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7528,'I\'d like to train.','I\'d like to train.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7529,'I train and guide young hunters in the traditions passed down many generations.','I train and guide young hunters in the traditions passed down many generations.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7530,'I can teach you the finer points of Mechanostrider Piloting, provided you have enough gold to cover the lesson!','I can teach you the finer points of Mechanostrider Piloting, provided you have enough gold to cover the lesson!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7531,'I can teach you the finer points of Horse Riding, provided you have enough gold to cover the lesson!','I can teach you the finer points of Horse Riding, provided you have enough gold to cover the lesson!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7532,'I can teach you the finer points of Tiger Riding, provided you have enough gold to cover the lesson!','I can teach you the finer points of Tiger Riding, provided you have enough gold to cover the lesson!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7533,'I can teach you the finer points of Kodo Riding, provided you have enough gold to cover the lesson!','I can teach you the finer points of Kodo Riding, provided you have enough gold to cover the lesson!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7534,'I can teach you the finer points of Raptor Riding, provided you have enough gold to cover the lesson!','I can teach you the finer points of Raptor Riding, provided you have enough gold to cover the lesson!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7535,'I can teach you the finer points of Skeletal Horse Riding, provided you have enough gold to cover the lesson!','I can teach you the finer points of Skeletal Horse Riding, provided you have enough gold to cover the lesson!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7536,'I can teach you the finer points of Wolf Riding, provided you have enough gold to cover the lesson!','I can teach you the finer points of Wolf Riding, provided you have enough gold to cover the lesson!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7537,'You need to be friendly with the dwarves of Ironforge before I will teach you a riding skill, $c.','You need to be friendly with the dwarves of Ironforge before I will teach you a riding skill, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7538,'You need to be friendly with the orcs of Orgrimmar before I will teach you a riding skill, $c.','You need to be friendly with the orcs of Orgrimmar before I will teach you a riding skill, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7539,'You need to be friendly with the trolls of the Darkspear tribe before I will teach you a riding skill, $c.','You need to be friendly with the trolls of the Darkspear tribe before I will teach you a riding skill, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7540,'','Thanks $n.  Now let\'s get out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7541,'You need to be friendly with the tauren of Thunder Bluff before I will teach you a riding skill, $c.','You need to be friendly with the tauren of Thunder Bluff before I will teach you a riding skill, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7542,'You need to be friendly with the humans of Stormwind before I will teach you a riding skill, $c.','You need to be friendly with the humans of Stormwind before I will teach you a riding skill, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7543,'You need to be friendly with the night elves of Darnassus before I will teach you a riding skill, $c.','You need to be friendly with the night elves of Darnassus before I will teach you a riding skill, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7544,'','We made it!  Thanks again!  I\'m going to run ahead!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7545,'You need to be friendly with the gnomes of the Gnomeregan Exiles before I will teach you how to pilot a Mechanostrider, $c.','You need to be friendly with the gnomes of the Gnomeregan Exiles before I will teach you how to pilot a Mechanostrider, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7546,'You need to be friendly with the Forsaken of the Undercity before I will teach you a riding skill, $c.','You need to be friendly with the Forsaken of the Undercity before I will teach you a riding skill, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7547,'I\'d be wasting both your gold and my time if I were to teach you how to pilot a Mechanostrider, $c.  You\'re just too large!','I\'d be wasting both your gold and my time if I were to teach you how to pilot a Mechanostrider, $c.  You\'re just too large!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7548,'I seek training to ride a steed.','I seek training to ride a steed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7549,'Please train me.','Please train me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7550,'','Hey Hornizz!  I\'m back!  And there are some people behind me who helped me out of a jam.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7551,'','We\'re going to have to scratch the Maraudines off our list.  Too hard to work with...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7552,'','Well, I\'m off to the Gelkis.  They\'re not as dumb as the Maraudines, but they\'re more reasonable.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7553,'Bye!  Better luck next time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7554,'Always on the go, that girl.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7555,'Remember, all things are connected. If the beasts were gone from the land, our kind would die from a great loneliness of spirit, for whatever happens to the beasts also happens to the Tauren. Whatever befalls Azeroth befalls all those that inhabit it.','Remember, all things are connected. If the beasts were gone from the land, our kind would die from a great loneliness of spirit, for whatever happens to the beasts also happens to the Tauren. Whatever befalls Azeroth befalls all those that inhabit it.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(7556,'I wish to train.\n','I wish to train.\n',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(7557,'If you\'re here to be trained in the tactics and strategy of hunting, you\'ve come to the right place!','If you\'re here to be trained in the tactics and strategy of hunting, you\'ve come to the right place!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7558,'I am here for training.','I am here for training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7559,'Hey mon! You\'ve ever been diving deep in the ocean? I\'ll let you in on a little secret, eh. Deep in the ocean you can find bubbly fissures; they\'ll allow you to breathe air while underwater.  Let\'s keep this secret between you and me though, eh. I don\'t need no competition for me shellfish traps elsewhere... if you get my drift!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7561,'Impossible! Stay your attack, mortals... I submit! I submit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7562,'','The flutter of the wings of a hawk, the breath of a ram in the snow, the pace of a bear through the forest... Such is life for the hunter.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7563,'I would like to train.','I would like to train.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7564,'','Look at the wisdom and knowledge of the beast, and you will see yourself. Observe as the owl does, learn cleverness from the sabercat, embody the mighty spirit of the wolf.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7565,'Please train me.','Please train me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7566,'The runes of warding have been destroyed! Hunt down the infidels, my brethren!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7567,'Brashly, you have come to wrest the secrets of the Living Flame! You will soon regret the recklessness of your quest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7568,'I go now to summon the lord whose house this is. Should you seek an audience with him, your paltry lives will surely be forfeit! Nevertheless, seek out his lair, if you dare!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7569,'[PH] Ok, I\'m outta here... see you in Ragnaros\' Lair... l8','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7570,'%s splits into two new Lava Spawns!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7571,'I just finished wandering.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7572,'','You\'re not a druid!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7573,'I\'d like to fly to Rut\'theran Village.','I\'d like to fly to Rut\'theran Village.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7574,'','Would you like a flight to Rut\'theran Village, courtesy of the Cenarion Circle?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(7575,'','If you\'re looking for a flight back to Thunder Bluff, then you should talk to my tauren counterpart, Bunthen Plainswind.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7576,'You\'re not a druid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7577,'Would you like a flight to Thunder Bluff, courtesy of the Cenarion Circle?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(7578,'If you\'re looking for a flight back to Rut\'theran Village, then you should talk to my night elven counterpart, Silva Fil\'naveth.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7579,'You\'ve interfered with our plans for the last time, foolish $c!','You\'ve interfered with our plans for the last time, foolish $c!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7580,'%s begins countdown.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7581,'%s disabled ghost region.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7582,'','You\'ve interfered with our plans for the last time, foolish $c!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7583,'%s is angered!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7584,'The times we live in are as fickle as the shifting winds, $c. The ground itself quakes and cries out in anguish. We must remain resolute or we ourselves will be engulfed by the turmoil.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(7585,'%s is drawn to the ghost magnet...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7586,'No other race on Azeroth has suffered as much as our people, $c. To laugh in the face of death has become second nature for all of us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7587,'Be prepared. Today, we will teach the quilboar much regret, sorrow, and fear, in the name of our Greatmother.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7588,'Ah, the beauty of Shadowglen never ceases to delight my senses!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7589,'Once ye\'ve seen one trogg, ye\'ve seen \'em all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7590,'Hey, citizen!  You look like a stout one.  We guards are spread a little thin out here, and I could use your help...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7591,'The land of Azshara.','The land of Azshara.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7592,'My knowledge of night elf lore is limited, but it is said long ago--back when the night elves still held sacred the art of arcane spell casting--that Azshara was the greatest of their kind. A beautiful woman they named queen. Sadly, it was her addiction to the arcane that would one day be the catalyst for the most devastating events in this world\'s history.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7593,'The Ruins of Eldarath.','The Ruins of Eldarath.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7594,'The mage tower to the north.','The mage tower to the north.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7595,'','Assassins! Guards! Guards!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7596,'','I sense danger up ahead.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7597,'','My back is killing me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7598,'','These orders must get to High General Abbendis!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7599,'','If I should fall, take my pouch. Make certain that it gets to the High General.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7600,'The Timbermaw furbolgs.','The Timbermaw furbolgs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7601,'The presence of blue dragons.','The presence of blue dragons.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7602,'Because you have aided me, I will tell you what I know of this land and of the things there are to see. My knowledge is not vast, but perhaps I can point out some things that might interest one such as yourself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7603,'Once a great city of the night elves, the Highborne once ruled there, practicing great and powerful arcane magics. They are cursed now, haunting the lands, and their ruined city has been victimized by the Spitelash naga. I understand that the naga search the ruins for powerful Highborne artifacts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7604,'A powerful human mage is rumored to live to the north; he keeps watch over the land for some unknown reason. I have not traveled there myself, but it is said that visitors are welcome and can even earn favor with him if they are willing to do errands for him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7605,'I\'ve seen terrible things happen to the furbolg over the last few years--they were victims on many fronts. But it\'s unclear to me what\'s become of this tribe. Are they corrupted by the same plague that\'s touched Felwood? Or perhaps they are simply angry at what\'s happened to their once peaceful people and now seek to defend themselves. Either way, most of them appear hostile to those who come into the area.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7606,'The blue dragons themselves aren\'t here, but followers of Malygos are. I do not know why, but I can tell you this: wherever the blue dragons are, expect to find arcane magic. I wouldn\'t be surprised if the dragonspawn are here protecting something... perhaps something the Highborne left behind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7607,'','I should find some hired help; I don\'t like sitting here all day selling fish supplies. I\'d much rather go fishing, and then sell supplies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7608,'Let\'s take a look at your fishing supplies.','Let\'s take a look at your fishing supplies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7610,'','Throm-Ka, $c. My mood is poor this day, so please, unless you can help me, I would prefer to be alone.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7611,'','Good work, $n!  Complete your trial by speaking with me.  Time continues to slip away until you do so!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7612,'Reckless mortals! None may challenge the Sons of the Living flame!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7613,'I can not train you, $c.','I can not train you, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7614,'I am Ulysses Rackmore, captain of the Gallant.  And this is the log of the last few days of my doomed ship.$B$BWe were sailing to Feathermoon Stronghold with a shipment of supplies when naga stormed the sides of the Gallant.  We drove them back but we knew they\'d return.  Fearing the loss of my most precious belongings, I steered the Gallant to an island off the coast of Desolace, one with old, night elf ruins.  And there I left my treasure chest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7615,'Continue reading...','Continue reading...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7616,'My chest is one of ingenious design, and requires two keys to unlock, one gold and one silver.  The first key, the silver key, I gave to my first mate, and I kept the gold.$B$BBut we were doomed to lose them.  My key was lost during the next naga attack, and my first mate\'s was lost a day later when drysnap makrura assailed us and pulled him into the deep.$B$BI am sure the naga and makrura have the keys.  I am glad the two are enemies and will not share them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7617,'After the makrura attack, we could see that the Gallant would not survive another.  So I and the few surviving sailors abandoned my ship.$B$BWe are now ashore and will soon strike out for the town of Nijel\'s Point, but much danger lies between us and sanctuary, and I fear Desolace will consume us.$B$BI write this now in hopes that someone will know our plight, and some day avenge us against the watery fiends who were our ruin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7618,'','The Shrine of Remulos is a sacred place for us in the Cenarion Circle here in Moonglade... so please conduct yourself in a manner befitting a visitor.$B$BA visitor who doesn\'t want my scimitar buried in them, that is.',1,25,0,0,0,0,0,0,1,0,0,0,26124),
(7619,'','May Cenarius watch over you, $g brother : sister;.$B$BI am Tajarri, and I am a sworn protector of this shrine.  It is my honor to serve Keeper Remulos as a warden of this sacred land.',2,1,0,0,0,0,0,0,1,0,0,0,26124),
(7620,'Before the Scourge came, I had a great business.  I bought and sold everything.  Everything!$B$BAnd my prices were INSANE!$B$BJust ask anyone.  Anyone who\'s not dead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7621,'Hi $n!  Are you here to buy something?  Or maybe sell something?$B$BYou won\'t find better prices anywhere, or my name isn\'t Augustus the Touched!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7622,'Commerce!  I crave it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7623,'Yes, Augustus.  I would like to do business.','Yes, Augustus.  I would like to do business.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7624,'This is a dangerous place, $n. Be careful around here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7625,'Greetings, $c. Please be brief in how the Kirin Tor may be of service to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7626,'DIE, INSECT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7627,'You won\'t find better prices anywhere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7628,'I\'m Augustus, and my prices are INSANE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7629,'I\'m Augustus!  You want it, I got it!  You wanna sell it, then I want it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7630,'Do not waste my time, $c.','Do not waste my time, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7631,'I don\'t train your kind, $c.  Find your own trainer before you anger me.','I don\'t train your kind, $c.  Find your own trainer before you anger me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7632,'Take it easy, mon. I only train da warriors.','Take it easy, mon. I only train da warriors.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7633,'What kin I do for ya, mon?','What kin I do for ya, mon?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7634,'Due to incompatibility on your class specification, I am unable to help you rectify any situation you have with lack of ability.','Due to incompatibility on your class specification, I am unable to help you rectify any situation you have with lack of ability.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7635,'Excellent! You meet the required parameters and specifications. What can I do for you?','Excellent! You meet the required parameters and specifications. What can I do for you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7636,'TOO SOON! YOU HAVE AWAKENED ME TOO SOON, EXECUTUS! WHAT IS THE MEANING OF THIS INTRUSION???','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7637,'Hegnar Rumbleshot, at your service!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7638,'While Theramore is reknown for it\'s exceptional training of warriors, I am afraid that I can not help you.','While Theramore is reknown for it\'s exceptional training of warriors, I am afraid that I can not help you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7639,'Come to train with the Theramore guard have you?','Come to train with the Theramore guard have you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7640,'Yes. I have.','Yes. I have.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7641,'What can I do for you my child?','What can I do for you my child?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7642,'I cannot train a $c such as yourself.','I cannot train a $c such as yourself.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7643,'I seek training in the ways of the Hunter.','I seek training in the ways of the Hunter.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7644,'I can not train you, young one.','I can not train you, young one.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(7645,'The Firelord and his brethren once held sway over this entire world, mortal. As a servant of the Old Gods, he fought against the Titans for domination of this planet. The victorious Titans banished my master and his brethren to the Elemental Plane - there to remain imprisoned until the end of time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7646,'Tell me more.','Tell me more.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7647,'Do you prefer guns or bows?','Do you prefer guns or bows?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7648,'I do not have the knowledge you seek.','I do not have the knowledge you seek.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7649,'Very well, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7650,'Wot kin I do fer ye?','Wot kin I do fer ye?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7651,'I kinnae help ye with trainin\'. Ye should look fer a $c trainer.','I kinnae help ye with trainin\'. Ye should look fer a $c trainer.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(7652,'What?','What?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7653,'Don\'t waste my time.','Don\'t waste my time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7654,'I can not train you.','I can not train you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7655,'Impudent whelps! You\'ve rushed headlong to your own deaths! See now, the master stirs!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7656,'Hey mon, you be needin\' to head on over to da $c trainer.','Hey mon, you be needin\' to head on over to da $c trainer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7657,'Behold Ragnaros - the Firelord! He who was ancient when this world was young! Bow before him, mortals! Bow before your ending!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7658,'Teach me the ways of the spirits.','Teach me the ways of the spirits.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7659,'The spirits have guided you to me. How may I be of service?','The spirits have guided you to me. How may I be of service?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7660,'May the spirits be with you.','May the spirits be with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7661,'These mortal infidels, my lord! They have invaded your sanctum and seek to steal your secrets!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7662,'FOOL! YOU ALLOWED THESE INSECTS TO RUN RAMPANT THROUGH THE HALLOWED CORE? AND NOW YOU LEAD THEM TO MY VERY LAIR? YOU HAVE FAILED ME, EXECUTUS! JUSTICE SHALL BE MET, INDEED!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7663,'Da spirits be strong wit you, mon. What kin dis troll do for ya?','Da spirits be strong wit you, mon. What kin dis troll do for ya?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7664,'May da spirits protect you mon.','May da spirits protect you mon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7665,'Where are you going?  Well if you\'re looking to get there quickly, then look no further!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7666,'I try to keep Sentinel Hill stocked, and that\'s not easy with all the action we see.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7667,'I need a ride, fast!  I have an important message to deliver!','I need a ride, fast!  I have an important message to deliver!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7668,'Ah, $gpriest:priestess;, you came along just in time. I appreciate it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7669,'Argh, the pain. Will it ever leave me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7670,'Thank you! Thank you, $gpriest:priestess;. Now I can take on those murlocs with the Light on my side!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7671,'Farewell to you, and may the Light be with you always.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7672,'A mere three hundred years ago, a reckless dwarf named Thaurissan summoned the master from his fiery realm. His return to this paltry world devastated the surrounding lands and created this volcanic Core. Mighty Ragnaros has slept under this mountain ever since. \n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7673,'What else do you have to say?','What else do you have to say?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7674,'We, his sworn servants, do his bidding and enforce his iron-rule. Cut off from the energies of his fiery realm, Ragnaros is but a shadow of his true self. However, he has more than enough strength to be your end.      \n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7675,'You challenged us and we have come. Where is this master you speak of?\n','You challenged us and we have come. Where is this master you speak of?\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7676,'Good day, $gsir:ma\'am;. I\'d shake your hand, but as you see, I\'m in the middle of something. May I be of assistance?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7677,'You\'ve made a good start, but you still have a great deal to learn, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7678,'You\'ve already learned everything I can teach you, $n. Talk to the night elf Lilyssia Nightbreeze in the Mage Quarter of Stormwind if you want to continue your studies. I hear she\'s a good teacher.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7679,'','Shut inside this little house, I dream of joining the battles that rage outside the city walls. Still, duty compels me to share my knowledge with others who fight in my stead... for now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7682,'Ishnu-alah, $gbrother:sister;. Have you any tidings from abroad? My heart yearns for news of Teldrassil.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7683,'I am honored to share my knowledge with you, $n. See that you use it well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7684,'You must choose a more experienced teacher, for you have surpassed my abilities. I advise you to speak with Lilyssia Nightbreeze here: she has much knowledge to offer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7685,'NOW FOR YOU, INSECTS! BOLDLY, YOU SOUGHT THE POWER OF RAGNAROS. NOW YOU SHALL SEE IT FIRSTHAND!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7686,'','The druids say that it is only a matter of time until nature itself drives the Horde from Kalimdor. Yet corruption continues to spread throughout our lands, even here on Teldrassil.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7687,'','Well done! Your understanding of potions is coming along nicely.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7688,'','Unfortunately, there is little I can teach someone with your experience, my friend. Seek out the night elf Sylvanna Forestmoon, who resides in the Craftsmen\'s Terrace of Darnassus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7689,'','Elune-adore, my $gbrother:sister;. You are welcome here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7690,'','Is it not astonishing what one can create from the plants of the forest? Truly, Elune has blessed us with her bounty.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7691,'','You are kind to seek me out, but your skills are beyond my own. Have a word with Sylvanna Forestmoon, just over there. She\'s been looking for another student.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7692,'Did my sweet lass Kali send you down to me? The apple of my eye, she is.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7693,'I don\'t suppose you\'re here to talk about my lovely Kali. Fine, then. Potions it is. Anyone ever tell ye you\'ve got a one-track mind?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7694,'Ye\'re beyond my skill to teach, $n. Go pester Tally Berryfizz; she\'s a gnome living in Tinker Town of Ironforge. Oh, and since you\'re headed up anyway, give Kali my love.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7695,'Don\'t let those big, innocent eyes fool ye. Tally\'s an expert, all right: I learn something new every day. Why d\'you think I\'m here in Tinker Town? Do I look like an engineer to you? Aye, I didn\'t think so.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7696,'Put your back into it, $glad:lass;. Hard work and determination--that\'s the way! Don\'t let anyone tell you book learnin\' is all ye need.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7697,'Och, there\'s nothing I can teach ye, $n. Have a word with Tally Berryfizz over there. She can hardly reach the tables, but when she starts brewing a potion, watch out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7698,'You got the look of someone wantin\' adventure. Me, I had enough of that by the time we trolls came here. Now I take each day as it comes, an\' I train other folks to handle adventures for me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7699,'Ready for another lesson? All right, then. First, relax. You gotta stay loose to stir a potion just right.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7700,'You got questions, but they be too big for me to answer, $n. You be needin\' to have words with the orc Yelmak in the Drag of Orgrimmar. He\'ll help you out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7701,'All the bottles on this table are potions I brewed today. And they say a watched pot never boils. Ha!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7702,'They called me stupid, but I\'ll show them. I\'m going to watch every pot I have and prove that they can all boil stuff anyway. Yeah, I\'m on a roll! Who\'s stupid now, huh? Huh!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7703,'Can\'t help you. You know more about potions than I do. Besides, I have pots to watch. Talk to Yelmak over there. He knows a lot about potions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7704,'Bena works like one possessed. Day and night I have seen her bent over these potions, often going without sleep or food. I know our undead allies need help, but I begin to fear she will do herself an injury.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7705,'I must have broken hundreds of vials when I first began brewing potions. The glass was so fragile in my clumsy hands. I hope you are more cautious than I was.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7706,'Your capacity for learning has outstripped mine. You will need to talk to Bena Winterhoof over there for further instruction. Please don\'t take too much of her time, though. She needs her rest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7707,'','Nice to see a friendly face. I don\'t get much chitchat from Apothecary Johaan unless he wants something. He\'s been out of the grave too long. Someday I\'ll be like that, I hear. Creepy. Maybe by then I won\'t care.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7708,'','Here to learn about potions? I\'ve got plenty to teach you. I might be dead, but I haven\'t lost my brains. Yet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7709,'','I appreciate the company, but let\'s face it: you have more experience with potions than I do. Talk to Doctor Marsh instead if you want training. He\'s a Forsaken in the Apothecarium of the Undercity.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7710,'Once, it is true, I was human. What might otherwise be a shortcoming works to our advantage, $n, for I know human weaknesses intimately.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7711,'Very well. Cut another lump of flesh from one of these specimens. Let us test what you\'ve learned so far, and we can progress from there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7712,'Your knowledge of potions has exceeded mine, but you still have much to learn. Go up the stairs to the southeast and see Doctor Marsh. He will teach you true sufferi--ahem. He is a Forsaken who will train you further.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7713,'Stop giving me that look. I may not be an adventurer like you, but that doesn\'t mean I can\'t have a few muscles. All that stirring makes your arms strong.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7714,'There\'s nothing more I can teach you. I\'ve heard of a night elf who might be able to, though. Her name is Ainethil, and she lives in the Craftsmen\'s Terrace of Darnassus.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7715,'I\'m sorry, $n, but I have no time to spend on novices. You want someone closer to your own skill level. Try the night elf Milla Fairancora, in the Craftsmen\'s Terrace of Darnassus.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7716,'You\'ve put in your time studying the basics. Now it\'s time to up the ante.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7717,'You want my help? You got it. What do you need?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7718,'','Don\'t let the beady eyes and bushy beard fool you. Vosur\'s a talented apprentice and a good friend, even if I do get a crick in my neck when I talk to him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7719,'','Um, you already know everything I could teach you. Maybe it\'s time for you to talk to someone else. Try the night elf Ainethil in the Craftsmen\'s Terrace of Darnassus. She\'s got some real talent!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7720,'','Hey, that\'s actually not so bad. Alrighty, then. How\'d you like to run an errand for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7721,'','That\'s nice, $n. Go show whatever it is to Vosur over there. He\'ll answer any questions you have.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7722,'','Who are you and why are you bothering me? Oh, right--potions student. Right. What can I do for you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7723,'','Ishnu-dal-dieb, $n. Have you come here in search of knowledge?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7724,'','Teaching is not a one-sided trade, $n. As I teach you, I learn more myself, and my understanding grows.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7725,'','My apologies, $n, but I do not offer instruction to novices. Instead, talk to Milla Fairancora in the Craftsmen\'s Terrace of Darnassus. She can help you make up for lost time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7726,'','You have learned the fundamentals of making potions, but further study requires greater commitment. Prove your dedication by carrying out a task for me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7727,'','Although I am flattered by your confidence in my abilities, teaching you is beyond my skill. You must go to the Craftsmen\'s Terrace in Darnassus, and speak with the night elf Ainethil. She can help you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7728,'','Even slight alterations to a potion\'s ingredients can change it fundamentally. Patience and precision, young one: they will serve you well in all walks of life.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7729,'','My skill at creating potions is inferior to yours. You are ready to speak with Ainethil, just over there. She will understand that you are ready for further instruction.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7730,'','Your skill is not inconsiderable. Since you appear to have sufficient experience, there is a matter in which I require your aid.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7731,'','Ah, to be young again, and to have discovered potions for the first time. Thank you for refreshing my memory, $n. Now go share that youthful enthusiasm with Milla Fairancora over there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7732,'','I have learned much of potions over the long years, $n, and that knowledge is at your disposal. You have only to ask.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7733,'I\'m busy, $n. Tell Whuut to handle whatever it is. That young pup has been stewing all day long. He spends much more time like that, and he\'s going to hurt something.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7734,'I\'m honored to meet you, $n, but your skill at potions is greater than my own. Go see Doctor Herbert Halsey, an undead in the Apothecarium of the Undercity. He can help you from now on.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7735,'I\'ve been looking for a little help. Since you\'ve got the skill, I guess you\'ll do, provided you\'ve also got the guts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7736,'You\'re talking to the wrong orc. I don\'t train novices. Talk to young Whuut over there... and use small words.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7737,'Another student, eh? All right. I\'ll see what I can do to help you out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7738,'Glyx and I have an understanding: he keeps me supplied, and I keep him rich. Seriously! What that pirate charges me for a measly pouch of crumpled kingsblood... it\'s enough to make a grown goblin cry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7739,'I\'ve got plenty of great recipes for you to take a look at, and at discounted prices, too!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7740,'What is this? You trying to ruin my reputation? I don\'t teach novices, $gbuddy:lady;. Try talking to the orc Whuut in the Drag of Orgrimmar. He\'s a lot closer to your level of skill. And brains.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7741,'Herbs are so pricey! I could always use a little something extra, if you know what I mean. Help a goblin out?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7742,'You\'re better at this gig than I am! You want someone with even more experience than I\'ve got. That\'d be Ainethil, a night elf lady who lives in the Craftsmen\'s Terrace of Darnassus.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7743,'','When I first saw the undead, I wept, for I could not imagine their horror and loneliness. The Earth Mother spoke to me then; she sang in my blood. And she told me, \"Save them.\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7744,'','Can you not sense the anguish of the Earth Mother for her lost children, the undead? Speak quickly, $n. Every second costs me dearly. We must help them find their way back to her!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7745,'','I cannot in good conscience spend time training novices while our allies, the undead, are suffering so terribly. Please speak with Kray over there instead; he can help you for now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7746,'','You have some skill, it is true, but every moment I spend teaching you is one more moment the undead will spend in torment. Prove to me that you are worth my time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7747,'','Your potion-making skills are beyond mine. Seek out the undead Doctor Herbert Halsey in the Apothecarium of the Undercity. He has the skill to train you further, and you can witness firsthand his people\'s plight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7748,'Another interruption. How am I supposed to get any work done like this? Don\'t answer that; do I look as if I care what you have to say? If we are to ever get this place cleaned up and expand our empire I will need absolute silence!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7749,'Me, train you? Come on--we both know I can\'t. It\'s this teaching, you see. My own skills suffer. You want training, go to Doctor Herbert Halsey, a Forsaken in the Apothecarium of the Undercity.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7750,'If you\'re going to be taking up my time, you\'d better prove you\'re worth it. I ought to get something out of this arrangement, after all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7751,'Don\'t waste my time. I have research projects older than you. Go talk to Doctor Martin Felben in the Apothecarium of the Undercity. He\'s a Forsaken who can probably manage to teach you the basics.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7752,'Another student. Wonderful. This is why Lydon gets to supervise and I\'m stuck being an instructor. If I win another teaching award, I\'ll never live it down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7753,'My powers have returned and you have squandered your chance, foolish mortals. Till we meet again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7754,'With Algernon to keep me supplied, I can do all my work here without hunting for a single herb. If I never have to see the wonders of nature again, it won\'t be too soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7755,'I have no more knowledge to bestow upon you. Go through the archway and down the ramp to the southeast, and talk to Doctor Herbert Halsey. He is a Forsaken who can teach you more advanced techniques.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7756,'If you seek to become my student, you\'ll need to complete an assignment for me. Prove yourself worthy, and I might even consider rewarding you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7757,'I\'m not amused by your audacity in coming to me for training. Go through the archway and down the ramp to the southeast, and talk to Doctor Martin Felben. He is a Forsaken who can teach you the basics.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7758,'Here to learn? Very well. I suppose you can\'t cause our allies much harm if I teach you. Just as long as you actually do manage to harm our enemies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7759,'','This potion seems to heal less damage every time I brew it, though I use the same ingredients. There can be only one conclusion: the plants are changing. I cannot say why or into what.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7760,'','It is time you moved on to a more advanced teacher. In the Feathermoon Stronghold of Feralas dwells the night elf Kylanna Windwhisper. She has a brilliant mind; doubtless she can train you further.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7761,'','This is excellent work. Are you ready to undertake a mission on my behalf? I know of no one more qualified.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7762,'','Your skill at brewing potions needs to be greater before you can become one of my students. In the meantime, perhaps Sylvanna Forestmoon or Milla Fairancora can help you, just over there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7763,'','Your education is progressing well. You should be proud of your accomplishments.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7764,'My colleagues and I are gathering the deadliest substances we know and testing their effects on our enemies. Once I have everything I need, I shall brew such plagues as this world has never seen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7765,'Incredible. Your potions display a knowledge that rivals my own. I cannot train you further, but talk to the orc Rogvar of Stonard in the Swamp of Sorrows. He\'s known for his cutting-edge experiments.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7766,'You\'ve got real talent and a passion for making potions. There is one little matter I\'d like you to take care of, though.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7767,'You don\'t yet have the skill to study with me. Go talk to Doctor Martin Felben over there, or go up the ramp to the southeast and see Doctor Marsh. They are Forsaken who can give you the training you need.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7768,'Ready for training? Then try to keep up, $n. We\'ve got a lot of ground to cover.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7769,'','Once I welcomed darkness, for it was the sister of night. Now it is dark all the time, even during the day, and the forests cry out for sustenance. Unless we act soon, this spreading blight will cover the world.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7770,'','Have you come here for instruction in the art of making potions? You were mistaken if you thought that I would offer such a privilege to you, unearned. Go, and do not return to me until you have greater skill.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7771,'','Your skill displays an enduring affection for our art, but I would see further evidence of your commitment. I shall charge you with a task. Fulfill it, and I will be content.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7772,'','Elune has seen fit to gift me with skill and experience. Now I shall pass them on to you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7773,'Kalaran, I have misplaced my torch. I require another.','Kalaran, I have misplaced my torch. I require another.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7774,'Warchief Thrall himself asked me to come out here. I was honored to obey, and it\'s no hardship. I couldn\'t have asked for a better posting than Stonard. Just about any herb I might need grows in the muck here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7775,'Don\'t stir the potion like that, you ham-handed farmer! No, don\'t stop stirring it, either! Forget it--just give me that ladle before you start a fire. I\'ll salvage what I can. Now, pay attention.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7776,'Hmm, well, I can see that you have a little skill at making potions. Whether you\'re worthy to be my student remains to be seen, however. I have a job for you. Impress me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7777,'How dare you ask me for training, maggot? What were you hoping for, you slack-jawed yokel, a lecture on the proper uses of silverleaf? Out! You\'re lucky I don\'t thrash you senseless for wasting my time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7778,'','Ah, $gpriest:priestess;, you came along just in time. I appreciate it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7779,'','Argh, the pain. Will it ever leave me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7780,'','Thank you! Thank you, $gpriest:priestess;. Now I can take on those corrupt timberlings with Elune\'s power behind me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7781,'','Farewell to you, and may Elune be with you always.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7782,'','Ah, $gpriest:priestess;, you came along just in time. I appreciate it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7783,'','Argh, the pain. Will it ever leave me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7784,'','Thank you! Thank you, $gpriest:priestess;. Now I can take on those humans with your power to back me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7785,'','Farewell to you, and may our ancestors be with you always!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7786,'Ah, $gpriest:priestess;, you came along just in time. I appreciate it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7787,'Argh, the pain. Will it ever leave me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7788,'Thank you! Thank you, $gpriest:priestess;. Now I can take on those wendigo with the Light on my side!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7789,'Farewell to you, and may the Light be with you always.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7790,'Ah, $gpriest:priestess;, you came along just in time. I appreciate it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7791,'Argh, the pain. Will it ever leave me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7792,'Thank you! Thank you, $gpriest:priestess;. Now I can take on those gnolls with your power to back me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7793,'Farewell to you, and may shadow always protect you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7794,'Just a minor adjustment here... ah there we go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7795,'I would train ye if I could, but ye need the services of someone a bit more... what\'s the word? Brainy! Look for Trixie Quickswitch in Ironforge. Tell \'er Bronk sent ye!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7796,'Lookin\' to be an engineer, eh? Well, by Muradin, ye\'ve come to the right place!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7797,'%s goes into a killing frenzy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7798,'%s becomes enraged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7799,'Where\'s my spinner? I just had it here somewhere...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7800,'Your current aptitude exceeds my instructional capabilities. You should enquire further with my fellow Gnome Trixie Quickswitch in Ironforge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7801,'I would be delighted to aid you in the commencement of your pursuit! Let me grab my spinner and we\'ll get started...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7802,'','I heard the new Henweigh 6000 will be rolling off the assembly line soon. I can barely contain my excitement!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7803,'','Well... I hate to admit it, but my sister\'s the one you\'ll have to talk to if you want to continue training. I don\'t know as much as she does... yet! She\'s standing over by the rocket car.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7804,'','I\'d love to teach you! Show my sister she\'s not the only one who knows a thing or two about engineering...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7805,'','Hello there! My name\'s Jenna! And you? ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7806,'','Oh, you\'ve got oodles of things to learn still. I would teach you everything if I could, but I\'m still learning too! Why don\'t you talk to Trixie Quickswitch in Ironforge, she\'ll help you further your education!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7807,'','You want to train? With me? Fantastic! The only thing better than assembling bullets and explosive devices is to share that knowledge with someone else! Let\'s get started!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7808,'','Ah, what a beautiful day to blow something up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7809,'','You need to start learning things that are beyond my expertise! Talk to Lilliam Sparkspindle in front of the tent there. He\'ll set you on the right course!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7810,'','This kind of work isn\'t for the faint of heart. I have an uncle who lost a hand! Poor old Stumpy... anyway, if you\'re still interested I might be able to show you a few things.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7811,'What? You want something?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7812,'I can\'t help ya\'! You\'re ready to see someone who\'s been at it longer than I have! Let\'s see... you\'re an Alliance type, so you need to talk to Lilliam Sparkspindle in Stormwind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7813,'Yeah, I\'ll show you a few things. We\'ll see how you do, maybe you\'ll surprise me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7814,'(Sniff, sniff) You smell that? Don\'t you just LOVE the smell of grease?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7815,'I\'m afraid you\'re out of my league, friend! You should go see Nogg in Orgrimmar, he\'ll take you to the next level!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7816,'A fellow enthusiast, huh? Well, you just wait, we\'ll make a gearhead out of you in no time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7817,'I like to build stuff. Of course, I like to blow stuff up even more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7818,'You know who can really show you some things? Nogg! You go find him in Orgrimmar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7819,'I know a few things. You want me to show you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7820,'Who says orcs aren\'t smart? It takes a lot of brains to be an engineer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7821,'You know who\'s really smart? Nogg! Smarter than me, even. You go tell Nogg Thund sent you! You can find him by the control panel over there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7822,'You think you\'re smart enough? You think you got what it takes? Let\'s find out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7823,'The Dark Lady has said that knowledge will be our greatest weapon in this war.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7824,'You are ready for greater things! See Franklin Lloyd, to my right. He will guide you from now on.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7825,'Engineering will provide you with the skills and knowledge to dismantle your opponents! Let me show you how...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7826,'I\'m never too busy to speak to a stranger! Almost never, anyway...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7827,'You\'re working your way up... higher than me, at this point! You should talk to Springspindle Fizzlegear in Ironforge! (He\'ll? She\'ll?) show you more than I ever could!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7828,'I can show you a few tricks... if you don\'t mind doing a little something first, that is.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7829,'Hmm... well, I can\'t help you quite yet! You have to learn the basics first. Why don\'t you go see Sprite Jumpsprocket in Stormwind!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7830,'Fantastic! Aren\'t you the industrious one? Well, let\'s get started, shall we?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7831,'Let\'s see... fourteen plus seven, carry the two... oh, yes?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7832,'Well, you\'re just zooming right along! I can\'t teach you anything you don\'t already know, but Springspindle Fizzlegear sure can! You can find Springspindle in Ironforge. Good luck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7833,'Quid pro quo! I\'ll teach you what I know, but first I want you to perform a small task...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7834,'You can learn from me in time... but not yet! Why don\'t you start out by talking to Sprite Jumpsprocket to my right here. You can check in with me after you\'ve gotten your feet wet!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7835,'You certainly did not disappoint! Now that we\'ve gotten that out of the way, your instruction may begin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7836,'','The plans for my twenty-foot tall turkey baster are nearly complete! Now all I need is a twenty-foot tall turkey...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7837,'','Don\'t tell anyone else I said this, but even I don\'t know everything! If you want to keep learning, you should talk to the owner of the shop, Springspindle Fizzlegear.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7838,'','You\'ll need to prove your worthiness before I go giving away my secrets! I\'ve got just the test for you...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7839,'','Close, but no cigar! I\'m afraid you\'ll have to talk to my sis, Jemma first. After she\'s gone over the basics with you, come see me and I\'ll show you the juicy stuff!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7840,'','Not bad, for a beginner! I guess it couldn\'t hurt for me to show you a few things...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7841,'If there were just a few more hours in a day...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7842,'You have earned the privilege of training with a higher instructor. Go see my pal Roxxik there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7843,'Every day is a test, and this day is no different. If you pass this test, I will share some of my knowledge...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7844,'You have not yet earned the right to train with me. See Thund first, over by the table. Come back when he says you\'re ready!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7845,'You have passed your test, well done! Your training may now continue.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7846,'I don\'t have time for idle gossip, I\'m a professional!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7847,'What do you think I could teach you? Roxxik would do a much better job. You can find him in Orgrimmar. Now be off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7848,'Let\'s see how competent you are, shall we? If you perform this task to my liking, I\'ll spend the time to teach you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7849,'This is a waste of time, mine and yours! Go see Graham Van Talen if you want to begin your instruction! He\'s standing to my left over there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7850,'Well... you almost impressed me. I suppose I could spare the time for a few lessons...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7851,'If my calculations are correct, the wheel will soon be obsolete!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7852,'You have certainly come a long way in your training. If you want to learn more, you have to travel to the desert. Find Buzzek Bracketswing in Gadgetzan! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7853,'Not that I doubt your abilites, but I would like you to perform a task for me. Call it a demonstration of good faith...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7854,'The things I would teach you would turn your brain to jelly! Come back when you\'ve learned sufficiently!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7855,'Excellent, you have proven yourself worthy! Now for the next phase of your instruction...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7856,'Sometimes I surprise even myself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7857,'I can\'t teach what I don\'t know! If only there was someone else who knew more than I do... wait, there is! Go see Buzzek Bracketswing in Gadgetzan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7858,'I think you\'re more than qualified for this little assignment... let\'s see if I\'m right!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7859,'Nice try, but you\'ll need some more experience before training with me! Back to the trenches! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7860,'Nice going! I knew I was right about you, no matter what those other people said. Ha! I\'m kidding! Okay, on with your lessons...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7861,'I\'ve been working on a way to transport oil underground between major cities, but everyone tells me it\'s a pipe dream.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7862,'Well my friend, you\'ve reached heights some people only dream of. Congrats! And now, without further ceremony, it is time for your final lesson!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7863,'Show me what you got! You won\'t be sorry, I promise!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7864,'I would never turn away someone who\'s ready to train with me. Unfortunately, you\'re not! You\'ve still got a ways to go kid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7865,'%s refuses to die while its master is endangered!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7866,'%s collapses and begins to smolder.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7867,'%s reignites from the heat of another Core Hound!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7868,'','Hail, traveler! What brings you to my doorstep?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7869,'','I\'m afraid I have nothing to teach to someone with your experience. But you haven\'t reached the end of the road yet. Speak to Lucan Cordell, behind the counter there. He\'ll guide you through the next phase of your journey.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7870,'','Hmm... well you seem capable enough. If you truly desire to learn, then nothing will stand in your way! I will guide you through your first steps on what I hope will be a long and fulfilling path.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7871,'There are ways to strengthen steel beyond the hammer and forge, young wanderer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7872,'Ye\'re a fine enchanter indeed! Now it\'s time fer ye to move on. I want ye to talk to Gimble Thistlefuzz, upstairs. He\'s a bit of a character, but he\'ll steer ye in the right direction from here on out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7873,'Ah, ye\'re an inquisitive one, are ye\'? Excellent! Pay close attention, this just might save yer skin when the goin\' gets rough!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7874,'','The Goddess has granted me wisdom, stranger. If it is her will, I shall pass it on to you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7875,'','Your skills are beyond my reach. It is time for you to face new challenges. Taladan will help you prepare. He is standing by the table there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7876,'','I will teach you what I can. Each lesson is a gift from the Goddess herself. Use her gifts wisely, and you shall not falter.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7877,'','Elune\'s secrets are many, but they are not to be shared with just anyone. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7878,'','You have truly excelled in your knowledge of enchanting. There is much more to learn, if you are willing. Speak to Taladan, in the Craftsmen\'s Terrace in Darnassus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7879,'','Open your mind, wanderer, and we shall begin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7880,'I do not have time to waste, stranger. State your business or be off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7881,'Eh, well you\'ve made it this far... go see Lavinia Crowe by the other bookshelf there. If you don\'t mess things up with her, maybe you can learn some more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7882,'You don\'t look like much to me, but who knows, maybe there\'s an enchanter hidden in there somewhere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7883,'What I wouldn\'t give to be out on the open plains on a day like this... but my duty binds me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7884,'I cannot teach you anything you don\'t already know. However, the knowledge of my father far surpasses my own. Go inside and speak to him. Good luck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7885,'There are many secrets that may be unlocked with patience and determination. Now, let us begin...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7886,'Throm-ka! What you looking for, stranger?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7887,'You come to wrong place. Talk to the expert Godan over there. You learn more from him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7888,'To die in battle is glorious! But, with what I teach you, maybe you not die so quickly, hm?  ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7889,'Who are you? What do you want from me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7890,'What do I look like, the Grand Poobah of enchanters? Your skills require the guidance of an Artisan! Go find Kitta Firewind at the Tower of Azora.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7891,'Great, let\'s get started... ha! Fooled you! Surely you didn\'t think it would be that simple. You\'ll need to prove your mettle just like everyone else!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7892,'You\'re joking, right? I believe you\'re looking for the OTHER short fellow, Thonys Pillarstone. He\'s downstairs. Now skedaddle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7893,'Okay, well... don\'t get cocky! Since you have demonstrated  your competence though, we may now begin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7894,'If you have what it takes, I will be happy to show you the way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7895,'A true professional know his limitations, and I\'m not ashamed to admit that your skills exceed mine. I want you to pay a visit to Kitta Firewind at the Tower of Azora. She is well-renowned, and with good reason.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7896,'You seem confident. Surely you wouldn\'t mind a test of your skills?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7897,'You are not ready. Speak to Betty Quinn, she\'s standing by the stairs over there. Return to me when you have achieved a higher enlightenment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7898,'Your confidence is well-founded, traveler. Now your true education may begin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7899,'If you seek to hunt naga, then you will need all the help you can get. Deep in the water you can find bubbly fissures that produce enough air bubbles that will allow you to breath underwater. Swim up close so that you can use the bubbles.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7900,'','That one, Malagan. I know $g him:her;. Dependable, brave, and trustworthy. $n is $g his:her; name.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7901,'$n, eh? Oy! Citizen $n, come \'ere. Highlord Bolvar Fordragon has requested that all able bodied heroes o\' the Alliance meet with him at Stormwind Keep. You just been recruited, mate! Get a move on!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7902,'It is true I have skills to teach to those who are worthy. Would that be you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7903,'You are an exceptional enchanter. Beyond my talents as a teacher, I fear. Seek out Kitta Firewind at the Tower of Azora. Only she can qualify as your instructor now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7904,'I believe you are up to this task... will you accept the challenge?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7905,'You have not yet learned the basics, wanderer. Have you spoken to my assistant, Lalina Summermoon? Perhaps you should.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7906,'Fine work! You are truly deserving of the knowledge I shall bestow upon you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7907,'','If you are seeking a truly rewarding pursuit, then a life of enchanting is for you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7908,'','I know many things, stranger, but your knowledge rivals my own. Enchanters who wish to hone their skills further are known to travel to the Tower of Azora, where an artisan named Kitta Firewind resides.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7909,'','Why don\'t we see just what you\'re capable of? If you complete the task I shall be happy to further your training! ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7910,'','I would be happy to teach you when you are ready, but that time has not yet come! I\'m sure Lalina Summermoon will guide you until then. You may find her in the Craftsmen\'s Terrace in Darnassus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7911,'','You have gone to great lengths, stranger, and you have my appreciation. I promised to further your training, and now I shall keep that promise.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7912,'Enchanting has run in our family for generations. I learned at an early age, just as my son is doing now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7913,'There is one whose knowledge exceeds my own. You are ready to seek her out. Go to Sun Rock Retreat in Stonetalon Mountains. Find Hgarth, and continue your training.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7914,'I will teach you... soon. I require a demonstration of your loyalty, first.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7915,'Surely Mot didn\'t send you to me? He knows better. You are not yet capable of understanding what I would teach you. See my son Mot, just outside there, and finish training with him. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7916,'Ah, very good. I am satisfied that you are a worthy student. Now, your training with me may begin...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7917,'','I don\'t get many visitors.  You\'re looking for something specific, yes?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7918,'','If I wasn\'t stuck here day in and day out, I would have attained the mastery required to train the likes of you! Unfortunately that\'s not the case. Go talk to Hgarth at the Sun Rock Retreat in the Stonetalon Mountains.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7919,'','Hmm, you scratch my back, I\'ll scratch yours. If you do what I ask, and do it well, maybe we can discuss your training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7920,'','No, no, you\'ll need FAR more training before you\'re ready to learn from me! Go talk to that uptight dabbler Malcomb Wynn. He\'s the one buried in books over there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7921,'','Well, I\'ve seen better. But, you have potential, I won\'t deny it. Pay attention and you just might learn something!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7922,'Greetings, traveler! Care to delve into the mysteries of the arcane? Hm?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7927,'Some adventurers think enchanting doesn\'t work. I find that when I challenge them to battle they change their tune!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7928,'Your skills are out of my league, stranger.Talk to Hgarth at the Sun Rock Retreat in the Stonetalon Mountains. He will provide you with more knowledge than I can. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7929,'You may have what it takes. Let\'s find out! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7930,'You are unfit to train with me, stranger. Spend some time with my assistant Jhag over there. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7931,'Well done! You have that spark in your eye... I know it well, it\'s the same spark I had when I was but a pup! Now, let\'s see if I can\'t teach you something.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7932,'','What brings you to the Tower?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7933,'','You are growing ever closer to the pinnacle of your training. To become a greater enchanter, you have yet another instructor to seek out. Her name is Annora, and you may find her in Uldaman.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7934,'','To come this far has not been easy, I know. But how boring life would be without challenges, don\'t you think? Good, because I have a challenge for you...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7935,'','You are eager, that is good. However, you are not yet ready to train with the likes of me. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7936,'','Your skills are truly becoming extraordinary. Now, let us continue your training...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7937,'Have you come to seek the knowledge of Hgarth?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7938,'There is one even greater than I in this art. You are ready to receive her knowledge. She is Annora, and you may find her... in Uldaman.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7939,'True mastery must be earned! It is up to you to earn it now...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7940,'Train hard, train every day. And when you have perfected your skills, return to me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7941,'You have reached new heights in your path to mastery. Let us see if we can take you even further...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7942,'','Greetings traveler, you have my undying gratitude for dispensing with those dreadful creatures! I was beginning to think I might have to hide out forever!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7943,'','I am proud. You are truly a gifted student. Now, for your final lesson...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7944,'','Your education is nearly complete. One final task is all that stands between you and the culmination of all your efforts...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7945,'','There are still lessons you must learn from others before my knowledge may be shared with you. Be diligent, and do not give up hope.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7946,'','Since my husband left for the front, Helene here has been my strength. Her kind heart and sharp sword have helped me through a lot of tough times. I don\'t know what I would\'ve done without her.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7947,'','Gosh, I\'m sorry. I don\'t have anything new to teach you. How about you go talk to Simon Tanner in the Old Town section of Stormwind? He\'s a human with big muscles and dreamy red hair.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7948,'','How\'s it going? I love the smell of leather; don\'t you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7949,'I already know a lot about style. Now it\'s just a matter of mastering the techniques for working with leather. Good thing Simon\'s a real sport about helping me learn them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7950,'There\'s nothing I can teach you, other than maybe a better eye for color and detail. Talk to Simon Tanner over there; he knows a lot of advanced techniques for working with leather.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7951,'This outfit really brings out the blue in my eyes, don\'t you think? It should be obvious I have plenty of skill to go around, so I can afford to share a few of my tricks of the trade. Listen up, okay?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7952,'','Welcome to our home, $n. Radnaal and I have little to offer, but you are welcome to what hospitality we can provide.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7953,'','My apologies, but you have already learned everything I know. The night elf Faldron could offer you further training, however. Look for him in the Craftsmen\'s Terrace of Darnassus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7954,'','You need to make your stitches smaller, $n. Fewer items will slip out of your quivers and ammo pouches. Besides, no one likes a lumpy tunic.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7955,'','If you\'re interested in sewing with leather, you\'ve certainly come to the right place. Faldron and Telonis are true artists, and I hope to learn much from them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7956,'','Oh, I\'m sorry, but you know more about leather than I do at this point. Talk to Faldron over there if you wish to learn more.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7957,'','It\'s so exciting to be here in Darnassus, surrounded by talented people! I just know I\'m going to make my family proud. Maybe if I\'m really lucky, the Sentinels will ask me to join their forces on the front!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7958,'','This hide isn\'t ready to work with yet. I wish it didn\'t take so long to make leather. There has to be some way to cut down on all this waiting. It can\'t be good for my health, you know?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7959,'','Aww, what rotten luck! My skills aren\'t good enough to be of any use to you. Oh well. Talk to Fimble Finespindle over there by the loom. He\'s been working with leather for longer than I have.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7960,'','Oh, goody, something else to do while I wait! You\'re a real life-saver, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7961,'','You like the rug? I killed and skinned the beast myself. May all the centaur fall as easily.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7962,'','I have nothing more to teach you. Talk to Karolek if you wish to further your leatherworking skills.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7963,'','Too bad we can\'t skin the humans and their allies. All that skin is just going to waste. Still, who\'d want to wear the flimsy leather you could make out of it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7964,'','Skin, glorious skin. It holds your insides... in. You might\'ve noticed my skin\'s not doing so well. To think I used to worry about my pores. Hardly any skin left to worry about these days. In a way, it\'s very freeing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7965,'','You\'ve got the hang of it. I can\'t teach you any more, but talk to Arthur Moore, a Forsaken who works in the Rogues\' Quarter of the Undercity. Tell him I sent you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7966,'','Before the plague came, I knew nothing about leather. Now I know enough to teach others. Death\'s left me with a lot of time on my hands.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7967,'Meat, skin, bones... a good hunter lets nothing go to waste. Every scrap of leather can be salvaged, perhaps to reinforce an ally\'s armor. Thus, each of us is strong alone, but together we become invincible.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7968,'You have outgrown any teachings I could offer. Go with the blessing of the Earth Mother. Seek out the tauren Tarn in the northwestern shops of Thunder Bluff\'s central plateau. Be guided by his wisdom.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7969,'We live and die, and the land remains, eternal, unmoved by our passage. Thus, land cannot belong to us, $n. Instead, we belong to it. Therefore we protect the land, for without it we cannot hope to survive.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7970,'The caverns below us are a source of strange and wondrous hides, but you must take care if you venture into their depths, $n. Remember that your own skin is far more valuable.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7971,'Your understanding of leather is deeper than my own. Perhaps you should visit the tauren Krulmoo Fullmoon in Camp Taurajo of the Barrens. He has much knowledge to offer a student of your talents.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7972,'Even here in the wilds, you seek out learning. Your drive for knowledge is an admirable trait.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7973,'Cairne himself lives here, they say. Once I have finished crafting a fitting gift, I will seek him out. Perhaps he will have words of wisdom for me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7974,'Your talent is beyond my own, friend. Speak with Tarn here; his knowledge of leather is much greater than mine. I\'m sure he would welcome another student.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7975,'Cleanse your hands before you begin any project. Staining the leather with blood or dirt would take away from its natural beauty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7976,'When I clawed my way out of the grave, I thought my family would welcome me with open arms. Instead, they drove me from the village, screaming in a language I could no longer understand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7977,'I can\'t help you; your work is beyond my own. Talk to Arthur Moore, over there by the coffins. He\'ll be able to train you further.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7978,'Take every word I say and commit it to memory. Until our enemies have been eradicated, we must never shirk a chance to further our knowledge. Reinforce your armor, and never relax your guard.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7979,'HELP! ASSASSINS HAVE COME TO KILL ME!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7980,'I\'m free!  That device shall never torment me again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7983,'','You are beyond my limited abilities. Seek out the night elf Ainethil in the Craftsmen\'s Terrace of Darnassus. She can teach you more. I only wish that I could go with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7984,'','You were wise to seek me out. I would ask a small favor. In return, there is much I can teach you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7985,'','My teachings would be too advanced for you at this stage. If you wish to learn more of potions, speak with Tel\'Athir here instead.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7986,'','Listen carefully, $n, for I have much knowledge to impart.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7987,'Even I have my limitations! Go talk to Lavinia Crowe in Undercity if you wish to further your training.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7988,'Not bad... I suppose training you is not out of the question. Very well! Let\'s begin...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7989,'Randal\'s a bit of a dandy, but he\'s dependable, which is more than I can say for a lot of the students I take on. Still, I guess I can\'t blame them for wanting a bit of adventure.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7990,'Sorry, but you\'ve reached the limit of what I can teach. If you want to learn more, go see Telonis in the Craftsmen\'s Terrace of Darnassus. He\'s pretty talented, so I hear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7991,'Okay, I\'ll teach you, but I want you to do something for me. This is important, so pay close attention.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7992,'Come back to me when you\'ve had more training. Randal Worth over there can help you with that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7993,'Hmm, I guess I can take on another student. Well, don\'t just stand there. Tell me what you\'re looking to learn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7994,'Darianna shows promise, but she is so full of energy that it is hard for her to stay still and listen. With her strength and agility, I fear it won\'t be long before she is called to fight. We must teach her quickly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7995,'If you are here for further training, you have overestimated my abilities. Have a word with Telonis over there; he can help you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7996,'This war has been an enormous drain upon our people and resources. Even here on Teldrassil, we cannot escape its repercussions. Forgive me for asking it of you, but would you perform a task for me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7997,'In time you will be ready for what I have to teach, $n. Until then, please ask Darianna over there to help you with your training.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7998,'Many animals lost their lives so that we could gain these materials. Do not take their sacrifice lightly, $n. Handle the leather with the respect it deserves.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(7999,'Lots to do! Haven\'t been this busy since my cousin accidentally vaporized all the cloth and leather in Gnomeregan. My, it was drafty for a while! Ah, $n, those were the days....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8000,'Nope, can\'t help you, I\'m afraid. Your skills have mine beat! If you want to learn more, talk to the night elf Telonis in the Craftsmen\'s Terrace of Darnassus. He\'s amazing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8001,'I can see that you\'ll be a quick learner. That\'s good for me, because I\'m always busy these days. In fact, that reminds me: could you run a quick errand for me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8002,'Well, I declare! It\'s a new student! I\'ll gladly teach you everything I know once you have a little more skill. Go talk to Gretta Finespindle over there, would you? She\'ll have you up to speed in no time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8003,'Your skills are coming along nicely. Soon you\'ll be running a leather shop of your own. I\'ll be glad for the help, $n. My hands are only so fast, you know? There\'s so much work to do!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8004,'This blue leather does draw the eye, I know. You see, we have a great many eager recruits running around here, hunting and slaying with more enthusiasm than wisdom. One must take precautions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8005,'I cannot aid you with further lessons: your skills have surpassed mine. Go and see the tauren Una in the northwestern shops of Thunder Bluff\'s central plateau. She offers more advanced training.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8006,'A task presses upon me, but I do not have the time to take care of it myself. Can I entrust you with it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8007,'I do not offer apprentice training. Look for the tauren Waldor in the Wailing Caverns, here in the Barrens. He can assist you with whatever you need.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8008,'Have you come for further training? Shake the dust of the road from your garments, then, and let us get to work.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8009,'My axe has seen many battles, and I like to keep it handy. Enemy forces have fought their way into our capital several times now, but have no fear: we have always driven them back.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8010,'I cannot help you with further training: your skill at working with leather rivals my own. You should speak with Una, over there. I will vouch for your skill if need be.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8011,'You have come to me for instruction, and in return I have a favor to ask of you. See it done, and you will be rewarded.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8012,'Your skills are insufficient to learn what I teach. Try talking to Mak over there instead. He can help you out until you\'re ready for more advanced lessons.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8013,'I am pleased with your progress so far. Surely the Earth Mother has inspired your hands.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8014,'We have only a small foothold on this continent for now, but the humans can\'t fight us off forever. Then they\'ll pay for enslaving us. We\'ll cut their lying tongues out for their treachery.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8015,'I\'d train you if I could, but you\'re too much for me. Tell you what: go talk to the tauren Una in the northwestern shops of Thunder Bluff\'s central plateau. She\'s got some real talent.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8016,'There\'s enough work here for an army of orcs, and most of it, only I can do. Still, there is a job I could use a hand with.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8017,'You\'ve got more guts than brains, coming to me without the proper training. Go talk to somebody closer to your skill level, like the orc Kamari, who lives in the Drag of Orgrimmar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8018,'We\'re pretty far from anything I\'d call civilization here, at least until the Horde can send us more reinforcements. You must really like working with leather.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8019,'Am I busy? What\'s that supposed to mean? Do you think I just stand here all day, twiddling my thumbs? If you\'re here to buy something, talk to Handor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8020,'You won\'t learn anything new from me; you know too much already. If you want more training, talk to the tauren Una in the northwestern shops of Thunder Bluff\'s central plateau. Send her my regards, eh?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8021,'That\'s decent work, I admit. But I\'d be more impressed if you\'d handle something for me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8022,'You can\'t study my techniques until you\'ve learned the basics. Speak with Kamari if you are interested in training.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8023,'The twists and turns of Orgrimmar are designed to thwart invaders. Can you imagine how quickly one of those puny gnomes would get lost in here? Ha! If it was lucky, I\'d track it down and keep it as a pet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8024,'Before my death, I was a librarian; I had nothing to do with wars and plagues. I never asked to become this. On the other hand, now that my mind is my own again, I\'m not about to surrender without a fight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8025,'I\'m pleased to say that your talents have outpaced my own. Go away now. Err, try the tauren Una in the northwestern shops of Thunder Bluff\'s central plateau. She\'s very skilled, I assure you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8026,'Yes, yes, I\'ll train you. There\'s no need to raise your voice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8027,'If I taught novices, there\'d be a lot more students visiting me, and things would get noisy. Go talk to Dan Golthas over there. He\'s a little intense, but he means well, and he\'s a decent teacher.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8028,'I first set up shop in the Magic Quarter, but it was pretty noisy there. This is a definite improvement, barring a few persistent students who still track me down, despite the fact that I\'ve relocated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8029,'','Elune has granted the night elves many gifts. In return, it is our responsibility to safeguard these forests from the demonic taint that the Horde always brings with it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8030,'','Training you further is beyond my abilities. Speak to Telonis in the Craftsmen\'s Terrace of Darnassus. He is always glad to help talented students.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8031,'','I cannot leave my post here, $n, but there is a task that must be taken care of. Can I trust you to see it done?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8032,'','I only teach students who have already mastered the basics. You must seek out the night elf Darianna in the Craftsmen\'s Terrace of Darnassus. Her skills will be a perfect complement to yours.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8033,'','Always double-check your measurements before you begin to cut the leather. We cannot afford to waste materials.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8034,'I need a ride, Dungar!  I have important supplies to deliver!','I need a ride, Dungar!  I have important supplies to deliver!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8035,'Do you know where I may find the Half Pendant of Aquatic Agility?','Do you know where I may find the Half Pendant of Aquatic Agility?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8036,'Do you know where I may find the Half Pendant of Aquatic Endurance?','Do you know where I may find the Half Pendant of Aquatic Endurance?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8037,'The waters of Westfall are where you must search, due west-northwest of where the Gold Coast Quarry meets with the shore.  An anchor shows where a boat has sunk beyond it, deep within the water.  The underwater pressure is fierce here; swimming too far will crush even the mightiest swimmer from fatigue.  $B$BLook for a natural formation to aid you, $n - a bubbly fissure is near here, offering deep-water swimmers a chance for renewed breath.\n','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8038,'In the Silverpine Forest along the edges of the North Tide\'s Run, a derelict boat rests on the shore.  Out to the west of this lies what you seek; swim too far and the ocean will crush you from fatigue.  It resides on the ocean floor in a lockbox, waiting for you to claim it.$B$BYou\'ll be hard pressed to survive a dive to such depths without aid, so take heart; a bubbly fissure offers renewed breath to divers seeking this half of the pendant.  Use it wisely.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8039,'','In the northern part of Darkshore runs the Cliffspring River, flowing down from the lands now known as Felwood.  As the river flows out and empties out into the Mist\'s Edge, travel north to where the deepest parts of the ocean begin.  A stone formation that some call the Stone Claw due to its shape is where you may find what you seek.$B$BBe warned - threshers gather by the Stone Claw, and will attack those who trespass on their territory.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8040,'','In the northeastern Barrens lies a pool of water sickened by pollution.  The locals call it the Sludge Fen; the Venture Company has turned the once crystal-blue waters into a mire of industrial byproducts and waste.  In the heart of this fen lies what you seek, $n.$B$BBe warned - the Venture Company does not tolerate trespassers, and they consider anyone who does not work for them as such.  You\'ll especially be a target as a protector of nature, something they vehemently oppose.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8041,'The grass is soft and lush. The air is fresh, full of light and song. Everything I\'ve seen suggests that Teldrassil is a dream come true. Why, then, is my heart full of foreboding?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8042,'You have advanced beyond my skill to teach you. Journey now to Aerie Peak in the Hinterlands and speak with the dwarf Drakk Stonehand. His work is magnificent, far better than my own.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8043,'You have demonstrated skill in learning our craft. Do you also possess the resolve to complete a mission on my behalf?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8044,'I regret to say that I cannot aid you, $gnoble sir:gentle lady;, until you learn more of working with leather. Speak with Faldron or Darianna here instead. They can teach you the skill you require.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8045,'Do not try to force your will upon the leather. Rather, let its natural tendencies dictate what form and function it will take. This is not a battle to be won. Work with the leather, not against it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8046,'','The needle is small, but the thread is strong, and the stitches are fine. Our pact with Thrall and the others will hold. The Horde will not be driven from these lands.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8047,'','Even my talents have a limit, and you have reached it. Congratulations, $n. Your next stop should be Camp Mojache in Feralas. The tauren Hahrana Ironhide lives there; she is renowned for her skill.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8048,'','As members of the Horde, we must contribute to our community to ensure that it continues to thrive. Thus, I am certain you will gladly aid us by undertaking a small task I have for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8049,'','It\'s been so long since I was a novice myself that I don\'t think I\'d be the best teacher for you. Try talking to Tarn or Mak, right over there. One of them should be able to answer your questions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8050,'','Cairne has brought us to a land rich with possibilities for the future. We have been fortunate, and so in turn we pass on our good fortune to others. That is why I began teaching, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8051,'I can make amazing things with the materials I find out here. By Muradin\'s beard, there are fantastic creatures in these hills! Go have a whack at them, $n, and bring me back some tall tales.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8052,'Och, \'twas a sad day when I realized my obsession. I woke up and found myself tannin\' before I had my first tankard of ale. Hardly even a respectable hangover! I knew then--aye, I knew!--how it was goin\' to be.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8053,'I love a good challenge; don\'t you? Aye, of course ye do. An\' that\'s why you\'re about to do exactly what I say.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8054,'I\'m not here to teach babes fresh out of the cradle. Ye\'ve nowhere near the amount of skill I require in my students. In fact, ye\'re a sad figure of a $glad:lass;, an\' I\'ll thank ye not to stand there jibber-jabberin\' at me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8055,'','All requests for my work must be made in person by the buyer. Orwin often asks me to reconsider, but my priorities lie here. Look around you: many of these fighters rely upon me for their armor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8056,'','I only wish I had more students like you. Not many will venture so far into enemy territory. I salute your courage.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8057,'','We cannot afford to give an inch in this war. Day and night, I create new armor, and I patch whatever can be salvaged from the old. I have no time for other tasks. Would you take care of something for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8058,'','You have wasted your time and mine by coming to me for training, $n. I have no time to teach basic skills. We\'re fighting a war here, and this is one of the front lines. Don\'t return to me until you are more prepared.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8059,'I can tell that your wardrobe is in dire need of care.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8060,'I\'m a simple man who knows a few things about tailoring, but you need more assistance than I can provide. I have heard of a Night Elf who is quite an accomplished tailor. He resides in Stormwind, in the Magic District. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8061,'So you would like to learn a few things? I would be happy to get you started!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8062,'Life is like a carefully woven tapestry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8063,'Hmm... the things you need to learn are a little above my head. Have a talk with Sellandus over at Larson\'s Clothiers just up the path to the right. He taught me everything I know!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8064,'Very well, let your journey of tailoring begin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8065,'Needlework requires a steady hand. And patience... above all, patience.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8066,'It is time for you to journey to Darnassus and speak to Me\'lynn. She will guide you from now on.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8067,'I would be happy to take you under my wing. Let us begin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8068,'Welcome to me shop. What can I do for ye\'?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8069,'Hold on there, I\'m just an assistant. If ye want to start learnin\' the fancy stuff, talk to old Stonebrew over there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8070,'Excellent! I\'ve been hopin\' for a new student. Well, let\'s get started right away then!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8071,'We use many animal pelts and skins in our creations. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8072,'I know a few things, but I\'m no expert. Lucky for you, Magar is. He\'s standing near the back of the shop. See if he can help you, but be careful not to rile him. He can be irritable.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8073,'I will teach you what I can.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8074,'No part of the animals we hunt is wasted. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8075,'You seek a higher knowledge. Tepa is blessed with such knowledge. She should be standing somewhere nearby...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8076,'With the Earth Mother\'s blessing, we shall begin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8077,'Pleased to make you acquaintance. May I help you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8078,'I am knowledgable, but I am not an expert. You know who you should talk to? Rhiannon! She\'s not far. Ask around for her in Undercity','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8079,'So... you want to be a tailor? Very well, we\'ll see if you have what it takes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8080,'We don\'t get many visitors out here. May I interest you in something?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8081,'I\'m just a student myself, really. Rhiannon\'s the expert. She\'s standing by the crates over there. You can learn a lot from her.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8082,'Yes, I think you have potential. Maybe I can show you a thing or two.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8083,'','There is no greater way to clear the mind than to weave.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8084,'','My education is ongoing, and your knowledge surpasses mine. If you wish to learn more you must speak to Me\'lynn. She will guide you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8085,'','You will not be disappointed, traveler. Tailoring is a joyous endeavor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8086,'Hey mon, what can I be doin\' for you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8087,'At dis point you know as much as I do, mon. Maybe you go see Magar in Orgrimmar. He not be da happiest tailor around, but he help you anyway.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8088,'Dat\'s da attitude! Grab a needle and thread and let\'s get jammin\'!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8089,'I am afraid that I am no longer gentle or humble. Age and countless battles have hardened my skin and soul. Perhaps that is why Cairne assigned me to Sun Rock Retreat... the gentle winds and warm sun does ease the pain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8090,'I knew you would come, $n. It is good to see you again, friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8091,'Yawww!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8092,'%s loses power and shuts off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8093,'%s nearly shatters!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8094,'Greetings.  Our bats are well trained and fed.  You\'ll not find faster.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8095,'How may I be of service?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8096,'Greetings, and welcome.  I am not very good at smiling, but trust me; I am happy to serve you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8097,'Let me browse your goods.','Let me browse your goods.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8098,'','The Hippogryph is a noble beast, proud and swift.  They are an honor to train, and can quickly take their rider a great distance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8099,'To maintain our link to the mainland, we have hippogryphs constantly flying between Rut\'theran Village and Darkshore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8100,'','The fish off the coast of Teldrassil are quite large and robust.  Rumors say it is the speedy growth of our new world tree that is the cause.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8101,'Although the coast of Darkshore is more dangerous than that of Teldrassil, many fishers find profit here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8102,'It is my honor to provide for adventurers, for they are heroes in the making.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8103,'I\'m sorry but I can not let you ride my gryphons. You should go talk to Gringer if you need a ride somewhere.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8104,'Fastest gryphons this side of Aerie Peak. Want to take a ride?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8105,'Sure! Let\'s go for a ride.','Sure! Let\'s go for a ride.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8106,'On the northern dock, you can board a ship that will carry you to Rut\'theran Village and Darnassus.  From the southern dock, you can find passage across the Great Sea to Stormwind Harbor.  The dock to the west, at the end of the pier, leads to Azuremyst Isle, near the Exodar. Safe journeys to you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8107,'On guard, friend. The lady dragon will not give in without a fight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8108,'This dock here?  Well you can catch the ship that goes to that Night Elf place.  What\'s it\'s name?  Uhh Auberdine I think.  I don\'t really know for sure, I just load and unload stuff.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8109,'As was fated a lifetime ago in Karazhan, monster - I come - and with me I bring justice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8110,'Are you here to help with the delivery? Miran\'s just about ready.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8111,'My wind riders are trained to fly quickly through the hot Barrens air.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8112,'The Barrens, with its hot sun and hostile denizens, is the perfect place to test your strength and fortitude.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8113,'Delivering these barrels to the excavation site is hard work, but there are so many depending on us to get the blast powder there.$B$BWe must do what we can against the Dark Irons!','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(8114,'Greetings.  If you are here for leather goods, then you will find my wares well crafted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8115,'Thanks for your help, $n. Because of you, another shipment arrived safely at the excavation.','',2,0,0,0,0,0,0,7,1,0,0,0,26124),
(8116,'When mounted on the back of a wind rider, one sees that its reputation for strength and speed is well earned.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8117,'You\'re better at this gig than I am! You want someone with even more experience than I\'ve got. That\'d be Doctor Herbert Halsey, an undead who works in the Apothecarium of the Undercity.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8118,'What is this? You trying to ruin my reputation? I don\'t teach novices, $gbuddy:lady;. Go talk to Milla Fairancora in the Craftsmen\'s Terrace of Darnassus.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8119,'','Seize him! Seize the worthless criminal and his allies!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8120,'Have a look at my meats, friend.  You won\'t want to go out into the Barrens without a good stock of provisions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8121,'Reginald, you know that I cannot let you pass.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8122,'You haven\'t lived until you\'ve looked down on the world from the back of a wind rider.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8123,'You must do what you think is right, Marcus. We served together under Turalyon. He made us both the men that we are today. Did he err with me? Do you truly believe my intent is to cause harm to our alliance? Would I shame our heroes?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8124,'%s appears lost in contemplation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8125,'I am ashamed, old friend. I know not what I do anymore. It is not you that would dare bring shame to the heroes of legend - it is I. It is I and the rest of these corrupt politicians. They fill our lives with empty promises, unending lies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8126,'Dear friend, you honor them with your vigilant watch. You are steadfast in your allegiance. I do not doubt for a moment that you would not give as great a sacrifice for your people as any of the heroes you stand under.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8127,'Stand down! Can you not see that heroes walk among us?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8128,'Move aside! Let them pass!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8129,'Reginald Windsor is not to be harmed! He shall pass through untouched!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8130,'Go, Reginald. May the light guide your hand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8131,'You can find passage to Theramore from this dock.  Heed my words, those lands are rarely safe to travel for people of the Alliance.  Watch your step and your back.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8132,'We shame our ancestors. We shame those lost to us... forgive me, Reginald.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8133,'Holding me here is not the right decision, Marcus.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8134,'Now, it is time to bring her reign to an end, Marcus. Stand down, friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8135,'Your understanding of leather is deeper than my own. Perhaps you should visit Aayndia Floralwind in the town of Astranaar in Ashenvale Forest. She has much knowledge to offer a student of your talents.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8136,'Good day to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8137,'You are beyond my level of expertise. Georgio Bolero, the master of Duncan\'s Textiles around the corner could help you advance your skills.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8138,'I will teach you, but first you must prove your worth...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8139,'Speak with Lawrence Shneider at Duncan\'s Textiles around the corner to the left. He is adept at dealing with beginners.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8140,'A fine display of worthiness. Your instruction may now continue.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8141,'Ah, this Darnassian fabric is the finest!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8142,'Well, aren\'t you the smarty-pants? Ye know more than I do, I can tell ye that! Don\'t go getting\' a big head, but if ye want to keep learnin\', have a chat with Georgio Bolero in Stormwind. They say he knows his tailorin\'!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8143,'I don\'t train just anyone! You\'ll need to perform a task first!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8144,'I don\'t have time to babysit! Go talk to me assistant, Uthrar! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8145,'Hmm... you show a little promise, I\'ll give you that. Okay then, where were we?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8146,'','Look around you, $r. Appreciate what you see today.$b$bMuch has changed since I first stepped foot into this forest. Wonderful and unexpected changes....',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(8147,'I made a lot of the things you see in the store. What do you think? Answer carefully, your life may depend on it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8148,'You need to learn from someone who knows more than I do. Go talk to Josef Gregorian in Undercity. Well, what are you still doing here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8149,'You think you just walk up to me and I start teaching you? Ha! You need to pay your dues like everyone else!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8150,'What? Why are you bothering me? Why, I bet you can\'t even create a high quality robe! Go talk to Snang and come back when you\'re worthy of my talents!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8151,'About time you showed me some results! Now I\'ll show you results!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8152,'They say a stitch in time saves... what, eleven? Ah, I can\'t remember. Stupid saying anyway.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8153,'Not bad... for an amateur! Still, you know about as much as I do. If you wanna\' learn more you\'re gonna\' have to talk to Josef Gregorian in Undercity.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8154,'Maybe you got it, maybe you don\'t. I think I got a way to find out...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8155,'Ha! You ain\'t got what it takes... yet! Come back to me after you\'ve learned a few things!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8156,'Well well, not too bad. Maybe I CAN show you a few things...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8157,'','What a fine day! It inspires me to create a new design.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8158,'','Your talents excel! You are truly inspired. To continue your pursuit of knowledge, speak with Georgio Bolero in Stormwind. He is held in high regard, and will be able to further your instruction.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8159,'','There are many obstacles one must overcome on the path to excellence. Your path is no exception...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8160,'','There are basics that must be learned. Trianna is standing nearby, speak with her and return to me later.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8161,'','You have done well, traveler. I am proud to call you my student!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8162,'','Welcome to our tent. May I assist you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8163,'','Your knowledge is great, traveler. You must learn from one who is wiser than I. Many tales have been told of the wisdom of Josef Gregorian. You may find him in Undercity.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8164,'','There is a task I would like you to perform before we go any further...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8165,'','You still have lessons to learn before I may begin your training. In the meantime, perhaps Vhan, in Thunder Bluff can help you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8166,'','Expertly accomplished! Now, let us continue your education...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8167,'Light be with you, sir.','Light be with you, sir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8168,'','Aren\'t the patterns beautiful? Each one speaks with its own voice.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8169,'','My knowledge is limited, though I am still learning. It is time for you to move on, traveler. Find Josef Gregorian in Undercity and tell him you are ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8170,'You are an inspiration to us all, sir.','You are an inspiration to us all, sir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8171,'','I will require a demonstration of your determination before I share my gifts with you...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8172,'There walks a hero.','There walks a hero.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8173,'','There are fundamental things you must learn before I can aid you. Speak to my apprentice, Vhan. He is kind and patient and will teach you what you need to know.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8174,'','You are truly a determined student. I will be happy to provide you with instruction!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8175,'Make way!','Make way!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8176,'','Tailoring can come in very handy. I once had to sew my arm back on.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8177,'We are but dirt beneath your feet, sir.','We are but dirt beneath your feet, sir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8178,'','You have worked your way up... time to see the boss. Go to Josef and tell him you are ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8179,'','Okay... so you wanna\' be a tailor. How about you prove it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8180,'A moment I shall remember for always.','A moment I shall remember for always.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8181,'','How can I share my secrets with a beginner? Try speaking with Victor Ward first.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8182,'','Good, you\'ve got some grit! I like that. Well then, let\'s get going!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8183,'...nerves of thorium.','...nerves of thorium.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8184,'A living legend... ','A living legend... ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8185,'Yes, I\'ve been running this shop for some time now. Business has been pretty good lately. A lot of new adventurers coming through...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8186,'There\'s only one person I know of who is more learned in the art of tailoring than myself. Last I heard he could be found in Theramore Isle. He is the person you should seek.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8187,'I require all my students to prove their dedication. Now it\'s your turn...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8188,'You\'ll need more training before I can share my knowledge with you, I\'m afraid. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8189,'Good! I can tell that my efforts will not be wasted!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8190,'Cloth is okay. Personally I prefer to work with human skin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8191,'You require the instruction of a true master! Go to Daryl Stack in Tarren Mill and embrace your destiny!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8192,'Before your learning may begin, I must ask of you a favor...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8193,'I will instruct you when the time is right... that time is not now. You have much more to learn first!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8194,'Good! I can tell that my efforts will not be wasted!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8195,'I have outfitted kings. With the proper training, you can too.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8196,'You have truly become one of the finest tailors in the business! Congratulations, I am proud to have been your instructor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8197,'You have come a long way, traveler. There is one more task for you to perform...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8198,'I cannot help you until you have learned more of the essentials. Come back to me when you are ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8199,'I am not worthy, sir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8200,'The place is a bit drafty... but what do I care? I\'m dead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8201,'Well done. You have now earned tailoring\'s highest honor. Go forth, and do terrible things with this knowledge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8202,'You\'re doing very well in the art of tailoring, I must admit. Now, let\'s see how good you REALLY are...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8203,'Who sent you here? You\'re not ready for my instruction yet! You\'ll be told when you\'re ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8204,'','I do so enjoy sitting out here, listening to the sounds of the Great Sea.  Oh, what?  Yes, there is a ship that will take you to Menethil Harbor.  It docks here from time to time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8205,'Thank you, old friend. You have done the right thing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8206,'Follow me, friends. To Stormwind Keep!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8207,'Be brave, friends. The reptile will thrash wildly. It is an act of desperation. When you are ready, give me the word.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8208,'Onward!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8209,'Mark my words!  You won\'t find faster gryphons anywhere in the Eastern Kingdoms than the ones right here in Thelsamar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8210,'Majesty, run while you still can. She is not what you think her to be...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8211,'The masquerade is over, Lady Prestor. Or should I call you by your true name... Onyxia...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8212,'To the safe hall, your majesty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8213,'If you ask me, there\'s no greater profession than a miner.  And if you ask me, there\'s no greater miner than a dwarf!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8214,'','%s laughs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8215,'','You will be incarcerated and tried for treason, Windsor. I shall watch with glee as they hand down a guilty verdict and sentence you to death by hanging...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8216,'','And as your limp body dangles from the rafters, I shall take pleasure in knowing that a mad man has been put to death. After all, what proof do you have? Did you expect to come in here and point your fingers at royalty and leave unscathed? ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8217,'The Wildhammer dwarves might have fast steeds, but can those Aerie Peak gryphons stand the heat of The Great Forge?  I think not!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8218,'You will not escape your fate, Onyxia. It has been prophesied - a vision resonating from the great halls of Karazhan. It ends now...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8219,'Listen, dragon. Let the truth resonate throughout these halls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8220,'The best miner has a firm grip on $ghis:her; pick, a stout heart in $ghis:her; chest, and thick, black dust in $ghis:her; hair.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8221,'I would like to train.','I would like to train.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8222,'The sturdy crate sits in the middle of the lumber mill surrounded by debris and very zealous followers of the Scarlet Crusade.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8223,'Place Termite Barrel on the crate.','Place Termite Barrel on the crate.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8224,'%s, too injured, gives up the chase.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8225,'%s obviously beaten, tries to run.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8226,'%s reaches into his pack and pulls out the encoded tablets.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8227,'The Dark Irons thought these tablets to be encoded. This is not any form of coding, it is the tongue of ancient dragon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8228,'%s reads from the tablets. Unknown, unheard sounds flow through your consciousness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8229,'What can you tell me about the bear - Ursangous?\n','What can you tell me about the bear - Ursangous?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(8230,'What can you tell me about the nightsaber cat - Shadumbra?\n','What can you tell me about the nightsaber cat - Shadumbra?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(8231,'What can you tell me about the hippogryph - Sharptalon?\n','What can you tell me about the hippogryph - Sharptalon?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(8232,'','This bear wanders a path close to where the Talondeep Path lies, due west of Mystral Lake and the Alliance outpost of Silverwind Refuge.  While he is the easiest of the three creatures you will face on the Ashenvale Hunt, he should not be trifled with.  His presence is a constant threat to travelers who sojourn between Ashenvale and the Stonetalon Mountains.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8233,'','This nightsaber is rumored to be docile in the presence of night elves and their allies, which makes her an even more worthy opponent.  Shadumbra\'s hunting path takes her from the Raynewood Retreat to our west, ultimately to lands due west of there.  Her fur is the color of pitch, and her speed is not to be underestimated.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8234,'','The mightiest of all the beasts that make up the Ashenvale Hunt, Sharptalon is let to wander freely by the self-proclaimed guardians of this land, the night elves.  Sharptalon patrols for prey to the south of here, taking delight in rending the unsuspecting and unaware traveler limb from limb.$B$BTo bring down such a beast would be the mightiest of hauls, $n.  I wish you luck in the hunt for this creature!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8235,'','Curious... Windsor, in this vision, did you survive? I only ask because one thing that I can and will assure is your death. Here and now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8236,'%s gasps.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8237,'Dragon filth! Guards! Guards! Seize this monster!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8238,'','%s laughs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8239,'','Yesss... Guards, come to your lord\'s aid!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8240,'Get your seats, folks!  The race is starting in 2 minutes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8241,'The Drag race will start in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8242,'Look at what $n brought us!  Let\'s drink up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8243,'Greetings $c - welcome to the front lines in our conquest of Ashenvale!  If you are looking for something to do, then you\'ve come to the right place.  I\'m always looking for able-bodied individuals to help bring glory to the Horde!','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(8244,'$n brought us booze!  Let\'s party!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8245,'%s hisses.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8246,'','Was this fated, Windsor? If it was death that you came for, then the prophecy has been fulfilled. May your consciousness rot in the Twisting Nether. Finish the rest of these meddlesome insects, children. Bolvar, you have been a pleasurable puppet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8247,'DO NOT LET HER ESCAPE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8248,'','You have failed him, mortalsss... Farewell!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8249,'Reginald... I... I am sorry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8250,'Bol... Bolvar... the medallion... use...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8251,'%s dies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8252,'%s becomes exhausted!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8253,'%s performs one last service for Ragnaros...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8254,'%s forces one of his Firesworn minions to erupt!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8255,'The dragon hides behind a royal facade. The tablets will reveal her for what she is... If what I have seen holds true, I will not survive this battle, friend. It is you that must finish what I have started. Are your forces ready? Are you ready? We will begin on your command.','',1,6,25,1000,2000,3000,0,0,1,0,0,0,26124),
(8256,'I am ready, as are my forces. Let us end this masquerade!','I am ready, as are my forces. Let us end this masquerade!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8257,'If you want to know about the comings and goings of caravans and merchants here in Splintertree Post, then I am fortunately the orc you are looking for.  Unfortunately for you though, I don\'t like people.$B$BIf you want something, make it quick.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8258,'The elements speak to us, $c.  They share knowledge that we must learn, and they share secrets that must be kept.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8259,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8260,'Through rigorous retraining I have had to break many students of all they had previously learned so that I might teach them anew.  The service I offer becomes increasingly difficult to perform each time it is done.  It is for that reason that it becomes increasingly expensive with each retraining.  Do you desire that I break you of the talents you have learned?','Through rigorous retraining I have had to break many students of all they had previously learned so that I might teach them anew.  The service I offer becomes increasingly difficult to perform each time it is done.  It is for that reason that it becomes increasingly expensive with each retraining.  Do you desire that I break you of the talents you have learned?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8261,'How do I reset my Talents?','How do I reset my Talents?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8262,'Yes. I do.','Yes. I do.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8263,'If you desire, in addition to training, I have it within my power to erase the knowledge of your talents from your mind.  Be warned that every time you undergo this procedure the more difficult it is to perform, and therefore the more expensive it becomes.','If you desire, in addition to training, I have it within my power to erase the knowledge of your talents from your mind.  Be warned that every time you undergo this procedure the more difficult it is to perform, and therefore the more expensive it becomes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8264,'Look at the wisdom and knowledge of the beast, and you will see yourself. Observe as the owl does, learn cleverness from the sabercat, embody the mighty spirit of the wolf.','Look at the wisdom and knowledge of the beast, and you will see yourself. Observe as the owl does, learn cleverness from the sabercat, embody the mighty spirit of the wolf.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8265,'Thank you for freeing me.  Speak with my sister in Splintertree.  I... I must find a place to rest...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8266,'%s\'s medallion shatters.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8267,'The arcane only corrupts those who are weak. Keep up on your training, or you may find a similar fate.','The arcane only corrupts those who are weak. Keep up on your training, or you may find a similar fate.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8268,'Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BThere will be a time soon where the call of the Emerald Dream will take hold in you.  You will hibernate for many years and walk amongst the purest of forms.  It is there and then that your ultimate training will take place.','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BThere will be a time soon where the call of the Emerald Dream will take hold in you.  You will hibernate for many years and walk amongst the purest of forms.  It is there and then that your ultimate training will take place.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(8269,'Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BThere will be a time soon where the call of the Emerald Dream will take hold in you.  You will hibernate for many years and walk amongst the purest of forms.  It is there and then that your ultimate training will take place.','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BThere will be a time soon where the call of the Emerald Dream will take hold in you.  You will hibernate for many years and walk amongst the purest of forms.  It is there and then that your ultimate training will take place.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8270,'Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BThere will be a time soon where the call of the Emerald Dream will take hold in you.  You will hibernate for many years and walk amongst the purest of forms.  It is there and then that your ultimate training will take place.','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BThere will be a time soon where the call of the Emerald Dream will take hold in you.  You will hibernate for many years and walk amongst the purest of forms.  It is there and then that your ultimate training will take place.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(8271,'I wish to unlearn my talents.','I wish to unlearn my talents.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8272,'Yes. I do.','Yes. I do.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8273,'I wish to unlearn my talents.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8274,'','I wish to unlearn my talents.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8275,'What can I do for ya?','What can I do for ya?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8276,'I got nothin\' more to teach! Not for somebody who knows as much as you do, anyway! You Horde types need to talk to Nogg in Orgrimmar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8277,'Ragers, Fetch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8278,'Ok, let\'s move out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8279,'','Who dares attack the Silverwing Outpost?!?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8280,'Silverwing is ours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8281,'Go report that the outpost is taken.  We will remain here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8282,'Prepare yourselves.  Silverwing is just around the bend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8283,'For the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8284,'Everyone ready?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8285,'','I mean you no harm. I am scouting the quilboar and taking notes of their activities. My people have noticed something odd--an emanation or darkness--coming from this area. I\'ve come to investigate, and what I\'ve found is very disturbing.$B$BThere seems to be an undead diplomat who is powerful in the ways of the arcane. I don\'t believe he\'s one of the Forsaken... I think it\'s worse.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8286,'','How fortuitous. Usually, I must leave my lair in order to feed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8287,'','Learn your place, mortal!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8288,'','This meaningless exertion bores me. I\'ll incinerate you all from above!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8289,'You know enough to be dangerous, but you still look like you need training to me $n.','You know enough to be dangerous, but you still look like you need training to me $n.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8290,'','It seems you\'ll need another lesson, mortals!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8291,'Your will is not strong enough to manipulate the forces we control $c.','Your will is not strong enough to manipulate the forces we control $c.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8292,'It is a greater knowledge of the ways of the warlock that I crave.','It is a greater knowledge of the ways of the warlock that I crave.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8293,'$n, how may I further your training in the eyes of the Earth Mother?','$n, how may I further your training in the eyes of the Earth Mother?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8294,'Many are the paths of the Earth Mother.  May your ancestors watch over you $c.','Many are the paths of the Earth Mother.  May your ancestors watch over you $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8295,'I seek further druidic training to have a closer understanding of the Earth Mother\'s will.','I seek further druidic training to have a closer understanding of the Earth Mother\'s will.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8296,'It is wise that you humble yourself before me, $n, in your desire for more warlock knowledge.','It is wise that you humble yourself before me, $n, in your desire for more warlock knowledge.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8297,'I have no time to waste on the likes of you $c.','I have no time to waste on the likes of you $c.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8298,'I submit myself for further training, my master.','I submit myself for further training, my master.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8299,'I can tell just by the way you\'re standing that you\'re no warrior.  $B$BWhy don\'t you go do something safe, like read a book.','I can tell just by the way you\'re standing that you\'re no warrior.  $B$BWhy don\'t you go do something safe, like read a book.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8300,'The darkness does not embrace you, $c.  Cease your prattle and remove yourself from my sight!  Be gone!','The darkness does not embrace you, $c.  Cease your prattle and remove yourself from my sight!  Be gone!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8301,'I\'m afraid your darkness quotient isn\'t sufficient enough for me to bother talking to you any further.  Move along please.','I\'m afraid your darkness quotient isn\'t sufficient enough for me to bother talking to you any further.  Move along please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8302,'Yer no warrior... Why ye wouldn\'t even last a day under my training regimen!  $B$BA $c who thinks $ghe\'s : she\'s; a warrior.  Ha!','Yer no warrior... Why ye wouldn\'t even last a day under my training regimen!  $B$BA $c who thinks $ghe\'s : she\'s; a warrior.  Ha!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8303,'I do not see the warrior\'s spirit within you, child.  I have no teachings which would benefit a $c such as yourself.','I do not see the warrior\'s spirit within you, child.  I have no teachings which would benefit a $c such as yourself.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8304,'%s emerges to protect the Fathom Stone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8305,'Pathetic. You two do not deserve the training you are getting here if that was the best you can do.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(8306,'Lysta, summon in undead captives.','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(8307,'Lysta, summon forth... the abomination!','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(8308,'Please share your wisdom with me, Warchief.','Please share your wisdom with me, Warchief.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8309,'The Shattered Hand has been able to place spies throughout the upper citadel of Blackrock. Though the information gathering process has been slow, we have made discoveries that cannot be ignored.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(8310,'What discoveries?','What discoveries?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8311,'It would appear as if the influence of the Black Dragonflight had extended beyond the borders of the Burning Steppes and into the kingdom of Stormwind itself! The usurper has since been unmasked and ousted.','',1,5,1,0,0,0,0,0,1,0,0,0,26124),
(8312,'Usurper?','Usurper?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8313,'Indeed. The brood mother of the Black Dragonflight had used illusion and trickery to disguise herself as a member of the royal court. Worse yet, she had assumed control of the current Highlord of Stormwind, Bolvar Fordragon.$B$BIt is no wonder that such foolish military decisions had been made. The movement of the Alliance forces as of late had left us scratching our heads. We now understand that the Black Flight was attempting to divide the empire - destroy it from within.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(8314,'With all due respect, Warchief - why not allow them to be destroyed? Does this not strengthen our position?\n','With all due respect, Warchief - why not allow them to be destroyed? Does this not strengthen our position?\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8315,'<Thrall laughs.>$B$BSo much to learn still, $r.$B$BYou are too young to remember the wars and bloodshed of ages past. Too young to remember the burden of the curse carried by our people.$B$BOur position with the Alliance right now is a tenuous one. Skirmishes and smaller battles do take place, but there is peace - something our people have not known for millennia. Would you give this up and plunge us into the maw of chaos again but against a new foe? One that will not rest until we are all destroyed?','',1,6,6,0,0,0,0,0,1,0,0,0,26124),
(8316,'I... I did not think of it that way, Warchief.','I... I did not think of it that way, Warchief.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8317,'No, $n, you did not. I do not fault you, however, as yours is a mind much like mine was as a youth: Impetuous, rebellious, and often without a single coherent thought! Traits I can no longer afford to express.$B$BEnough lamenting. $R, I have a task for you; one that you may not survive. ','',1,5,1,0,0,0,0,0,1,0,0,0,26124),
(8318,'I live only to serve, Warchief! My life is empty and meaningless without your guidance.','I live only to serve, Warchief! My life is empty and meaningless without your guidance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8319,'<Thrall laughs.>$B$BNoted... Now pay attention, $n. The Black Dragonflight brood mother, Onyxia, has been flushed out from her position of power in Stormwind. She has escaped, fleeing to her lair in Dustwallow Marsh.$B$BShe cannot be allowed to live in such close proximity to our capital cities. We must strike before being struck!$B$BI want her destroyed, $n. ','',11,1,5,0,0,0,0,0,1,0,0,0,26124),
(8320,'Of course, Warchief!','Of course, Warchief!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8321,'%s collapses upon seeing his master die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8322,'Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BWe are the preservers of the balance, now and forever, as Malfurion lies in the Dreaming.  Never forget this.','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BWe are the preservers of the balance, now and forever, as Malfurion lies in the Dreaming.  Never forget this.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(8323,'Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BWe are the preservers of the balance, now and forever, as Malfurion lies in the Dreaming.  Never forget this.','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BWe are the preservers of the balance, now and forever, as Malfurion lies in the Dreaming.  Never forget this.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(8324,'Myranda, do you have enough eyeballs to make another amulet? I have lost the old one.','Myranda, do you have enough eyeballs to make another amulet? I have lost the old one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8325,'I see some interesting characters come and go here at the port. Watch yourself, $n. It\'s never clear who to trust, what with all of the shady activity that goes on here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8326,'So you\'re here for the Warsong axes. Well, it\'s about time, $n. That crate has been sitting out there for days, now.$B$BFeel free to haul it away whenever you are ready.','',1,25,0,0,0,0,0,0,1,0,0,0,26124),
(8327,'','Let\'s go before they find out I\'m free!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8328,'','Look out! We\'re under attack!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8329,'','Thank you for helping me. I know my way back from here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8330,'Stonetalon Mountain has many perilous caves through out this region.  Exploring these caves can hold many adventures for those willing to risk life for glory.$B$B$C, perhaps you seek riches that only following your heart and soul can garnish.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8331,'%s goes into a rage after seeing Misha fall in battle!','%s goes into a rage after seeing Misha fall in battle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8332,'','Please wait while I attempt to bind the shards together so that they will be whole once again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8333,'','Ishnu... Oshalan thara dormil... Anu\'dorin...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8334,'Fish so delicious. You come learn fish? Eat fish? Mmmmm...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8335,'I require training, Lumak.','I require training, Lumak.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8336,'Yap, I can teach ye to fish.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8337,'I require training, Grimnur.','I require training, Grimnur.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8338,'','Yes, I was able to reseal the relic, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8339,'','Please, leave this place, $n. You know nothing of what troubles us...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8340,'Where can I get Enchanted Thorium?','Where can I get Enchanted Thorium?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8341,'Where can I find Crystal Restore?','Where can I find Crystal Restore?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8342,'','Enchanted thorium is a highly sought-after metal. You best chance of finding some of it is to speak with an artisan blacksmith or miner.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8343,'','Crystal Restore is a difficult item to acquire.$B$BI believe that it comes from Un\'Goro Crater, so you\'d best head there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8344,'We may have been suffering a drought but there\'s no shortage of meat! Care to browse my goods?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(8345,'I wish to browse your goods, Dirge.','I wish to browse your goods, Dirge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8346,'','Can Zamja help you, $r?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(8347,'I require training, Zamja.','I require training, Zamja.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8348,'I keep \'em fed, kid. Yep, Daryl Riknussun, at yer service.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8349,'I require training, Daryl.','I require training, Daryl.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8350,'You are a little gnat to the Foulweald!  Die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8351,'No!  You cannot be stronger than the Foulweald!  No!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8352,'Heeellp meee... ri... ribss... bro... broken.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8353,'Dying... See the light... gloriouss...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8354,'I... I think I see Blue...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8355,'I\'m saved! Thank you, doctor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8356,'My entrails are leaking out! HELP!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8357,'I\'m not gonna make it... death comes... ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8358,'Goodbye, cruel world... I\'m leavin\' you today... goodbye... goodbye... goodbye...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8359,'HOORAY! I AM SAVED!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8360,'Brain encaved... mortar... bas... hed... leaking... dyin... g...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8361,'Sweet, sweet embrace... take me... ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8362,'The good doctor saves the day! HOORAY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8363,'I regret to inform you that you have failed your examination, doctor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8364,'I am an orc of medicine, $r. If you have come here to learn, I shall do my best to teach.','',1,2,0,0,0,0,0,0,1,0,0,0,26124),
(8365,'I require training, Arnok.','I require training, Arnok.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(8366,'','May this evil aura be banished from this artifact!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8367,'','I can feel the presence of evil leaving...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8368,'','Are you a student of the medical sciences?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(8369,'I require training, Nissa.','I require training, Nissa.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8370,'','Why have you come here, $c?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8371,'','My people, they are as shattered as the relic you seek to repair.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8372,'','While nothing can change the past, time can heal all wounds. Thank you for showing me that it is possible, $n. I wish you well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8373,'Kel\'Thuzad? If you know that name at all, then perhaps you did read the book I sent you to get.$B$BUnfortunately, you\'re answer is incorrect.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8374,'Gul\'dan. Not a name many have heard on Azeroth.$B$BUnfortunately, not the correct answer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8375,'An interesting response to my question... and the wrong one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8376,'Ah, Ner\'zhul. Not a name that should be uttered lightly, but I did ask you for an answer.$B$BAnd Ner\'zhul is the correct one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8377,'Kel\'Thuzad is my answer.','Kel\'Thuzad is my answer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8378,'Gul\'dan is my answer.','Gul\'dan is my answer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8379,'Kil\'jaeden is my answer.','Kil\'jaeden is my answer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8380,'Ner\'zhul is my answer.','Ner\'zhul is my answer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8381,'Ysera is my answer.','Ysera is my answer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8382,'Ah, Ysera the Dreamer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8383,'Neltharion is  my answer.','Neltharion is  my answer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8384,'Alexstrasza is  my answer.','Alexstrasza is  my answer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8385,'Malygos is my answer.','Malygos is my answer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8386,'Neltharion, hmm? As good an answer as any, yes?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8387,'Alexstrazsa, the Life-Binder. A magnificent creature.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8388,'Malygos, is it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8389,'Greetings, $c. Is there something I can help you with?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8390,'My question to you is this, $c:$BWhich of the Aspects created by the titans became the nefarious creature known as Deathwing?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8391,'It\'s always nice when someone wishes to speak to me. How are things with you, $c?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8392,'Now, answer me this, $n:$BWhich creature became the Lich King before spreading the plague across Lordaeron?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8393,'That is the wrong answer, $n. Be off with you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8394,'I\'m afraid not, $n. Now, feel the shame you have brought upon yourself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8395,'','In position!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8396,'','For the Great Mother!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8397,'','Warriors of the night... Assemble!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8398,'%s attacks the banner!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8399,'Yeah, you know a few things! If you wanna\' learn more you\'re gonna\' have to talk to Georgio Bolero in Stormwind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8400,'The Thorium Brotherhood possesses the knowledge required to make the sacred arms and armaments of the Fire Lord, but we lack the manpower to obtain the materials required for the crafting.$B$BI, Lokhtos Darkbargainer, have been empowered by the Brotherhood to exchange the exalted recipes for materials gathered from the Molten Core.$B$BPresent your offer, $r.','',1,1,25,0,0,0,0,0,1,0,0,0,26124),
(8401,'Show me what I have access to, Lokhtos.','Show me what I have access to, Lokhtos.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8402,'Want to make your demons more powerful?  It\'ll cost you, but you\'ve come to the right place.','Want to make your demons more powerful?  It\'ll cost you, but you\'ve come to the right place.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8403,'You\'re no warlock and I\'ve no time for you.  Begone!','You\'re no warlock and I\'ve no time for you.  Begone!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8404,'Show me your selection of grimoires.','Show me your selection of grimoires.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8405,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8406,'You\'ve come for training in order to pass it on to your pets?','You\'ve come for training in order to pass it on to your pets?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8407,'Ah friend, I only help hunters and their pets.','Ah friend, I only help hunters and their pets.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8408,'Train me in the ways of the beast.','Train me in the ways of the beast.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8409,'Fear lies in your heart. When you truly are ready to face Vorsha the Lasher, come speak with me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8410,'Now we must wait. It won\'t be long before the naga realize what we have done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8411,'The Royal Apothecary Society has little patience for fools, as do I.  Perhaps the next time you and I speak of my steeds, you will be considered exalted by the Undercity.  Until then...','The Royal Apothecary Society has little patience for fools, as do I.  Perhaps the next time you and I speak of my steeds, you will be considered exalted by the Undercity.  Until then...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8412,'Be on your guard, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8413,'Perhaps we will get a moment to rest. But I will not give up until we have faced off against Vorsha!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8414,'I only make my mounts available to those who are considered exalted to Orgrimmar and the Orcish race.  Go prove yourself to us, and I\'ll make my mighty wolves available for your inspection.','I only make my mounts available to those who are considered exalted to Orgrimmar and the Orcish race.  Go prove yourself to us, and I\'ll make my mighty wolves available for your inspection.',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(8415,'I\'m sorry $g mon : sis;, but I won\'t be sellin\' my raptors to someone who hasn\'t proven themselves to be exalted to the Darkspear tribe.  When ya make a stand and show yourself to be no less than exalted to us, then I\'ll make my raptors available to ya.','I\'m sorry $g mon : sis;, but I won\'t be sellin\' my raptors to someone who hasn\'t proven themselves to be exalted to the Darkspear tribe.  When ya make a stand and show yourself to be no less than exalted to us, then I\'ll make my raptors available to ya.',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(8416,'You are not known to my people.  A kodo is a mighty steed, and it is the product of love and care by my people; such is not given onto strangers.  Until the elders of Thunder Bluff consider you to be exalted, I cannot offer you the sale of a kodo.','You are not known to my people.  A kodo is a mighty steed, and it is the product of love and care by my people; such is not given onto strangers.  Until the elders of Thunder Bluff consider you to be exalted, I cannot offer you the sale of a kodo.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8417,'Alas $c, you are not considered to be exalted to Darnassus and the night elves of Teldrassil.  Only when you prove yourself to us through deeds - not just mere words - will I then make available my selection of mounts for your perusal.','Alas $c, you are not considered to be exalted to Darnassus and the night elves of Teldrassil.  Only when you prove yourself to us through deeds - not just mere words - will I then make available my selection of mounts for your perusal.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8418,'Stay back! Children should not be here! Be gone, child!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8419,'Intruders! Attack the intruders!','Intruders! Attack the intruders!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8420,'Steady, people.  We\'ll raid soon enough.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8421,'With luck, we\'ll gain some good scars today.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8422,'These woods make my tusks itch...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8423,'They say Duriel is a fierce night elf.  It\'ll be a good fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8424,'We\'ll be notching our axes after this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8425,'Stay calm, people.  We don\'t want to give away our position.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8426,'Plucky?  I heard race master Kronkrider up on the the tower knows where he is.','Plucky?  I heard race master Kronkrider up on the the tower knows where he is.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8427,'You looking for plucky?  Well, you didn\'t hear me say this, but... maybe if you ask Kronkrider up in the tower, he\'ll tell you...','You looking for plucky?  Well, you didn\'t hear me say this, but... maybe if you ask Kronkrider up in the tower, he\'ll tell you...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8428,'Sorry, but I am not disposed to sell horses to any individual who is not considered to be at least exalted to the Kingdom of Stormwind.  These steeds are the finest you\'ll find anywhere, and we certainly wouldn\'t want them in the hands of our enemies.$B$BNot saying you\'re an enemy, of course... just earn the trust of Stormwind and then we can do business.','Sorry, but I am not disposed to sell horses to any individual who is not considered to be at least exalted to the Kingdom of Stormwind.  These steeds are the finest you\'ll find anywhere, and we certainly wouldn\'t want them in the hands of our enemies.$B$BNot saying you\'re an enemy, of course... just earn the trust of Stormwind and then we can do business.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8429,'Not so fast, $g guy : lady;... I\'ll not be handing out the reigns of a mighty ram steed to someone that\'s not a proven ally of the dwarves of Ironforge.  Once you\'ve been recognized as exalted to Ironforge, I\'ll gladly show you what varieties of rams I have for sale.','Not so fast, $g guy : lady;... I\'ll not be handing out the reigns of a mighty ram steed to someone that\'s not a proven ally of the dwarves of Ironforge.  Once you\'ve been recognized as exalted to Ironforge, I\'ll gladly show you what varieties of rams I have for sale.',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(8430,'Erm... I really don\'t know you that well, sorry.  I mean, as an authorized Mechano-strider dealer, I really only can sell my mounts to those people who are considered exalted amongst the gnomes.  If you ever are recognized as exalted to Gnomeregan, I\'d be happy to show you what I have to offer.','Erm... I really don\'t know you that well, sorry.  I mean, as an authorized Mechano-strider dealer, I really only can sell my mounts to those people who are considered exalted amongst the gnomes.  If you ever are recognized as exalted to Gnomeregan, I\'d be happy to show you what I have to offer.',24,1,0,0,0,0,0,0,1,0,0,0,26124),
(8431,'You need to be exalted with the dwarves of Ironforge before I will teach you a riding skill, $c.','You need to be exalted with the dwarves of Ironforge before I will teach you a riding skill, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8432,'You need to be exalted with the Forsaken of the Undercity before I will teach you a riding skill, $c.','You need to be exalted with the Forsaken of the Undercity before I will teach you a riding skill, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8433,'You need to be exalted with the gnomes of the Gnomeregan Exiles before I will teach you how to pilot a Mechanostrider, $c.','You need to be exalted with the gnomes of the Gnomeregan Exiles before I will teach you how to pilot a Mechanostrider, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8434,'You need to be exalted with the humans of Stormwind before I will teach you a riding skill, $c.','You need to be exalted with the humans of Stormwind before I will teach you a riding skill, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8435,'You need to be exalted with the night elves of Darnassus before I will teach you a riding skill, $c.','You need to be exalted with the night elves of Darnassus before I will teach you a riding skill, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8436,'You need to be exalted with the orcs of Orgrimmar before I will teach you a riding skill, $c.','You need to be exalted with the orcs of Orgrimmar before I will teach you a riding skill, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8437,'You need to be exalted with the tauren of Thunder Bluff before I will teach you a riding skill, $c.','You need to be exalted with the tauren of Thunder Bluff before I will teach you a riding skill, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8438,'You need to be exalted with the trolls of the Darkspear tribe before I will teach you a riding skill, $c.','You need to be exalted with the trolls of the Darkspear tribe before I will teach you a riding skill, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8439,'Half way there...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8440,'','I do not believe you possess the mental acuity to grasp the nature of portal magic.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8441,'','As a mage, you are one of a select group that can conjure a portal to transport you back to this very place.  I can teach you if you are ready.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8442,'Please teach me.','Please teach me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8443,'','I do not believe you possess the mental acuity to grasp the nature of portal magic.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8444,'','As a mage, you are one of a select group that can conjure a portal to transport you back to this very place.  I can teach you if you are ready.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8445,'I do not believe you possess the mental acuity to grasp the nature of portal magic.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8446,'As a mage, you are one of a select group that can conjure a portal to transport you back to this very place.  I can teach you if you are ready.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8447,'I do not believe you possess the mental acuity to grasp the nature of portal magic.','I do not believe you possess the mental acuity to grasp the nature of portal magic.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8448,'As a mage, you are one of a select group that can conjure a portal to transport you back to this very place.  I can teach you if you are ready.','As a mage, you are one of a select group that can conjure a portal to transport you back to this very place.  I can teach you if you are ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8449,'','I do not believe you possess the mental acuity to grasp the nature of portal magic.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8453,'','As a mage, you are one of a select group that can conjure a portal to transport you back to this very place.  I can teach you if you are ready.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8454,'I do not believe you possess the mental acuity to grasp the nature of portal magic.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8455,'As a mage, you are one of a select group that can conjure a portal to transport you back to this very place.  I can teach you if you are ready.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8456,'I do not believe you possess the mental acuity to grasp the nature of portal magic.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8457,'As a mage, you are one of a select group that can conjure a portal to transport you back to this very place.  I can teach you if you are ready.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8458,'Overflowin\' with rats! Help a pirate out, matey!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8459,'Do yer part in keepin\' the Deeprun Tram clean!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8460,'Don\'t crowd me, people!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8461,'Your own strength feeds me, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8462,'The little feller be hidin\' in one o\' them boxes, matey. G\'luck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8463,'Monty be me name an\' rats be me game.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8464,'I\'m ready to find the squirrel, Monty.','I\'m ready to find the squirrel, Monty.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8465,'Into the box me pretties! Thas it. One by one ye go.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8466,'Winner! We be havin\' a winner here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8467,'The strongest hides come from those kodo that have laid themselves to rest in this wasteland.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8468,'Your skills have surpassed mine, young one. Go see Una who has a shop in Thunder Bluff\'s central plateau. She can give you the guidance you seek.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8470,'I am sorry but I can not train any more apprentices. Seek out Mak in Thunder Bluff. He will be able to teach you the basics.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8471,'First you must prove yourself to me, then I will train you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8472,'Now you are ready to learn the finer points of kodo hide tanning. Let us begin...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8473,'','Between the light and the dark, there is shadow... and those shadows have powers you have yet to see.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8474,'','Between the light and the dark, there is shadow... and those shadows have powers you have yet to see.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8475,'You\'ll find no finer rat kabob this side of Khaz Modan!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(8476,'I wish to make a purchase, Nipsy.','I wish to make a purchase, Nipsy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8477,'You look like you could use some work, $g fella:lady;. You should board the tram and visit my brother, Monty, at the Ironforge Deeprun Tram depot. I\'m sure he has something you could do.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(8478,'Watch your back, stranger.','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(8479,'Ravenholdt Manor does not recognize you, $c.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8480,'Brash. Master Ravenholdt does not like brash.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8481,'It is good to see you again, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8482,'Greetings, $c. Have you spoken with Fahrad yet?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(8483,'The Syndicate is made up of a bunch of hacks - disorganized, unskilled, and lazy... ','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8484,'You have truly grown more cunning, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8485,'An honor to see you again, $n.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(8486,'I believe Simone was looking for you earlier, $n. Have you spoken with her yet?','',1,6,0,1,2,0,0,0,1,0,0,0,26124),
(8487,'$G Master:Mistress; $n! Master Kang has been asking about you! Perhaps it is your time!','',5,25,0,1,2,0,0,0,1,0,0,0,26124),
(8488,'Your presence steels our nerves, $G Master:Mistress; $n.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(8489,'Tales of your heroics are heard throughout Ravenholdt Manor, $G Master:Mistress; $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8490,'I am unworthy of this conversation, $G Master:Mistress;.','',16,0,0,0,0,0,0,0,1,0,0,0,26124),
(8491,'It is my dream to one day serve under your command, $G Master:Mistress; $n. That is, should you ever deem me worthy of such things...','',1,16,0,1,2,0,0,0,1,0,0,0,26124),
(8492,'The Manor has been abuzz with talk of your arrival, $G Master:Mistress; $n. We are all honored and graced by your presence.','',1,16,0,1,2,0,0,0,1,0,0,0,26124),
(8493,'You dare set foot inside Ravenholdt Manor, worm?','You dare set foot inside Ravenholdt Manor, worm?',14,0,0,1,0,0,0,0,1,0,0,0,26124),
(8494,'Making it out of here without a blade in your back or poison in your veins would be an accomplishment.','Making it out of here without a blade in your back or poison in your veins would be an accomplishment.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8495,'You\'re shaping up nicely, $n. I\'ve heard good things...','You\'re shaping up nicely, $n. I\'ve heard good things...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8496,'You should talk to Winstone. I hear he\'s looking for thieves with your skill.','You should talk to Winstone. I hear he\'s looking for thieves with your skill.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8497,'Marvelous. Simply marvelous. You are an inspiration to us all, $n.','Marvelous. Simply marvelous. You are an inspiration to us all, $n.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8498,'I really envy you, $n. You do amazing work.','I really envy you, $n. You do amazing work.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8499,'Your time has come, $n. Master Kang awaits...','Your time has come, $n. Master Kang awaits...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8500,'And to think, one day you might be the one that the stories of legend are about!','And to think, one day you might be the one that the stories of legend are about!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8501,'I wept like a babe when I heard of your heroics. Master Ravenholdt would do well to have an apprentice like you.','I wept like a babe when I heard of your heroics. Master Ravenholdt would do well to have an apprentice like you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8502,'If I was not bound by duty to Master Ravenholdt, I would follow you to the ends of the world, $G Master:Mistress; $n. You are grace and cunning personified.','If I was not bound by duty to Master Ravenholdt, I would follow you to the ends of the world, $G Master:Mistress; $n. You are grace and cunning personified.',1,16,0,1,2,0,0,0,1,0,0,0,26124),
(8503,'','May Elune walk with you, $c.  The Temple of the Moon has come to help the troubled citizens of Auberdine.',2,1,0,0,0,0,0,0,1,0,0,0,26124),
(8504,'I\'m a test spirit healer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8505,'Why did you kill me, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8506,'Shoja\'my is over in front of the inn.  Now move along, I\'m busy.','Shoja\'my is over in front of the inn.  Now move along, I\'m busy.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8507,'Pets to take care of?  Just make sure you clean up after it!  Look for Shoja\'my in front of the inn.','Pets to take care of?  Just make sure you clean up after it!  Look for Shoja\'my in front of the inn.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8508,'Stable Master','Stable Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8509,'Go to the Valley of Honor and seek out Xon\'cha near the stables.','Go to the Valley of Honor and seek out Xon\'cha near the stables.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8510,'Xon\'cha will stable your extra pets.  Find him in the Valley of Honor at the stables between the arena and the Hunter\'s Hall.  Now begone!','Xon\'cha will stable your extra pets.  Find him in the Valley of Honor at the stables between the arena and the Hunter\'s Hall.  Now begone!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8511,'Stable Master','Stable Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8512,'Only a fool walks into a den of thieves unaware. That fool rarely walks out...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8513,'Ah yes, it is Seikwa that you must find.  I believe I saw her last standing out in front of the inn.','Ah yes, it is Seikwa that you must find.  I believe I saw her last standing out in front of the inn.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8514,'Seikwa can take care of your animal friends when you have the need.  Seek her out in front of the inn.','Seikwa can take care of your animal friends when you have the need.  Seek her out in front of the inn.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8515,'The stable master','The stable master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8516,'It is the assistance of Bulrug that you need.  You will find him outside on the lower rise standing between the inn and the Thunder Bluff Bank.','It is the assistance of Bulrug that you need.  You will find him outside on the lower rise standing between the inn and the Thunder Bluff Bank.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8517,'The concern that you show for the welfare of your animal companions is commendable.  Bulrug, on the lower rise, can help you with that.  Seek him out between the bank and the inn.','The concern that you show for the welfare of your animal companions is commendable.  Bulrug, on the lower rise, can help you with that.  Seek him out between the bank and the inn.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8518,'Stable Master','Stable Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8519,'Morganus the stable master can be found out in front of the stables strangely enough.','Morganus the stable master can be found out in front of the stables strangely enough.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8520,'Not too clever are you?  Hmm, if I were a stable master perhaps I might be in the vicinity of say, the stable?  Look for Morganus over there.','Not too clever are you?  Hmm, if I were a stable master perhaps I might be in the vicinity of say, the stable?  Look for Morganus over there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8521,'The stable master','The stable master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8522,'Anya Maulray at inn on upper ring of Trade Quarter.','Anya Maulray at inn on upper ring of Trade Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8523,'Us want lots of pets.  Anya Maulray help you take care of them.  You find her at inn, upper ring of Trade Quarter.','Us want lots of pets.  Anya Maulray help you take care of them.  You find her at inn, upper ring of Trade Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8524,'Stable Master','Stable Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8525,'Stable Master','Stable Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8526,'You can trust any pets you have to be well taken care of by Alassin.  He resides in the Cenarion Enclave where the hunters gather.','You can trust any pets you have to be well taken care of by Alassin.  He resides in the Cenarion Enclave where the hunters gather.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8527,'For many hundreds of years Alassin has cared for the animals that our hunters befriend.  His care of animals is highly sought for by the hunters around here.  If you seek him as well, then look for him in the Cenarion Enclave.','For many hundreds of years Alassin has cared for the animals that our hunters befriend.  His care of animals is highly sought for by the hunters around here.  If you seek him as well, then look for him in the Cenarion Enclave.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8528,'We are all pieces of a much larger puzzle, $n. Just as you guide the piece of a puzzle to its destination, so too are we guided by another.$B$BAnd perhaps they who guide us are themselves guided by an even greater force.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(8529,'Stable Master','Stable Master',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8530,'Ah, gentle Seriadne.  All animals are safe while in her care.  You can find her just outside the Inn in Dolanaar.','Ah, gentle Seriadne.  All animals are safe while in her care.  You can find her just outside the Inn in Dolanaar.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8531,'You seek someone who cares for animals?  Then you should look for Seriadne outside the Inn in Dolanaar.  She is the one that you seek.','You seek someone who cares for animals?  Then you should look for Seriadne outside the Inn in Dolanaar.  She is the one that you seek.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8532,'Good ol\' Erma, she\'s been taking care of the local animals for years now.  I\'m sure she\'d be happy to take care of any you\'d like to put up.  She can be found right outside of the Lion\'s Pride Inn.','Good ol\' Erma, she\'s been taking care of the local animals for years now.  I\'m sure she\'d be happy to take care of any you\'d like to put up.  She can be found right outside of the Lion\'s Pride Inn.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8533,'Erma does all the caring for animals around here.  She\'s right outside the Lion\'s Pride Inn if you need to speak with her.','Erma does all the caring for animals around here.  She\'s right outside the Lion\'s Pride Inn if you need to speak with her.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8534,'Stable Master','Stable Master',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8535,'Why did you kill me, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8536,'Stable Master','Stable Master',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8537,'Jenova Stoneshield over in the Dwarven District is the one you\'re looking for.  She tends to hunters\' pets while they seek training from her father.','Jenova Stoneshield over in the Dwarven District is the one you\'re looking for.  She tends to hunters\' pets while they seek training from her father.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8538,'If you need to house your pet while you\'re training another, then you should talk to Jenova Stoneshield over in the Dwarven District.','If you need to house your pet while you\'re training another, then you should talk to Jenova Stoneshield over in the Dwarven District.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8539,'Stable Master','Stable Master',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8540,'Well $glad : lass;, ye can find Shelby Stoneflint right outside the Thunderbrew Distillery in Kharanos.  She\'ll take good care of any pets ye might have.','Well $glad : lass;, ye can find Shelby Stoneflint right outside the Thunderbrew Distillery in Kharanos.  She\'ll take good care of any pets ye might have.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8541,'Shelby Stoneflint houses a good deal of pets for the local hunters.  She can be found over by the Thunderbrew Distillery if ye need her to look after a pet.','Shelby Stoneflint houses a good deal of pets for the local hunters.  She can be found over by the Thunderbrew Distillery if ye need her to look after a pet.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8542,'Stable Master','Stable Master',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8543,'Taking care of animals is something that Ulbrek Firehand takes quite seriously.  He usually hangs out with the hunters at the Hall of Arms if ye want him to look after a pet or two.','Taking care of animals is something that Ulbrek Firehand takes quite seriously.  He usually hangs out with the hunters at the Hall of Arms if ye want him to look after a pet or two.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8544,'Over in the Hall of Arms you can find our resident stable master, Ulbrek Firehand.  He\'ll make sure any pets ye have are well fed and rightly cared for.','Over in the Hall of Arms you can find our resident stable master, Ulbrek Firehand.  He\'ll make sure any pets ye have are well fed and rightly cared for.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8545,'You think you\'ve won already? Perhaps you\'ll need another lesson in pain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8546,'Help! Guards! It\'s going to step on me!','Help! Guards! It\'s going to step on me!',0,0,0,0,0,0,0,13,1,0,0,0,26124),
(8547,'I got something for you, $n. Looks important.','I got something for you, $n. Looks important.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8548,'May I have it, please.','May I have it, please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8549,'Welcome to SI:7 headquarters, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8550,'$n, this came for you this morning.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8551,'Messengers from Ravenholdt delivered this letter to me this morning. It is addressed to you, $n.','Messengers from Ravenholdt delivered this letter to me this morning. It is addressed to you, $n.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8552,'Take heart!  Pain goes away and $gladies love men with scars:men love women with scars;!','Take heart!  Pain goes away and $gladies love men with scars:men love women with scars;!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8553,'I require aid.','I require aid.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8554,'Show strength to your enemy, and we will prevail!','Show strength to your enemy, and we will prevail!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8555,'This will be a tough fight, $n. Follow me closely!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8556,'This is the brazier, $n. Put it out. Vorsha is a beast, worthy of praise from no one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8557,'Bah, it\'s not here.  I wonder where I left it last...','',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(8558,'You have my deepest gratitude. I thank you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8559,'Now where did I put that companion document?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(8560,'Quite the riveting tale.  Now I know why there was so much dust on that book.','',274,11,0,0,0,0,0,0,1,0,0,0,26124),
(8561,'So many bookshelves, so little time...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8562,'I should talk to Dewey about some sort of notation system to keep these books better organized.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(8563,'A book by a goblin on gnomish military victories... and all the pages are blank.  Figures.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(8564,'I am going to patrol the area for a while longer and ensure that things are truly safe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8565,'Please return to Zoram\'gar and report our success to the Warsong Runner.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8566,'Are you sure that you are ready? If we do not have a group of your allies to aid us, we will surely fail.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8567,'I sense that the great beast draws near...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8568,'Look, just at the water\'s surface!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8569,'We have done it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8570,'','You seek to lure me from my clutch? You shall pay for your insolence!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8571,'Yes, $c? Are you reporting in?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8572,'COME FORTH, MY SERVANTS! DEFEND YOUR MASTER!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8573,'YOU CANNOT DEFEAT THE LIVING FLAME! COME YOU MINIONS OF FIRE! COME FORTH, YOU CREATURES OF HATE! YOUR MASTER CALLS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8574,'Crush them!!!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8575,'RUN THEM THROUGH, SOLDIERS!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8576,'Push them back to their base! Let not a single Alliance soldier remain living on this battlefield!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8577,'Rally around your Lieutenants and Commanders! Protect our bases!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8578,'Major Domo Enabled.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8579,'Who controls the Coldtooth Mine?','Who controls the Coldtooth Mine?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8580,'The Coldtooth Mine is owned by the Kobolds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8581,'The Coldtooth Mine is owned by the Alliance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8582,'The Coldtooth Mine is owned by the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8583,'The Coldtooth Mine lies in Horde territory, in the mountains north of the Frostwolf Graveyard.$B$BIt is controlled by the Alliance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8584,'The Coldtooth Mine lies in Horde territory, in the mountains north of the Frostwolf Graveyard.$B$BIt is controlled by the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8585,'The Coldtooth Mine lies in Horde territory, in the mountains north of the Frostwolf Graveyard.$B$BIt is controlled by the Kobolds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8586,'Who controls the Irondeep Mine?','Who controls the Irondeep Mine?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8587,'The Irondeep Mine is in Alliance territory, north of the Stormpike Graveyard.$B$BIt is controlled by the Alliance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8588,'The Irondeep Mine is in Alliance territory, north of the Stormpike Graveyard.$B$BIt is controlled by the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8589,'The Irondeep Mine is in Alliance territory, north of the Stormpike Graveyard.$B$BIt is controlled by the Troggs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8590,'This monument is dedicated to all those who have fallen in the protection of Stormwind. Our people have weathered unbelievable hardships to retain their freedoms and to control their own destinies. It is here we remember every sacrifice our citizens have made during the first war that riddled our people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8591,'The Irondeep Mine is owned by the Alliance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8592,'The Irondeep Mine is owned by the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8593,'The Irondeep Mine is owned by the Troggs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8594,'The Alliance has taken Coldtooth Mine!  Its supplies will now be used for reinforcements!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8595,'The Alliance has taken the Irondeep Mine!  Its supplies will now be used for reinforcements!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8596,'The Horde has taken the Coldtooth Mine!  Its supplies will now be used for reinforcements!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8597,'The Horde has taken the Irondeep Mine!  Its supplies will now be used for reinforcements!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8599,'The troggs are retaking the Irondeep Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8600,'The kobolds are retaking the Coldtooth Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8601,'In Alterac Valley, battles rage and equipment is in short supply.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8602,'I\'ve reached my supply needs for now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8603,'Hook me up!','Hook me up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8604,'','Cover me, soldier! I have to make it back to our base and get the fleet prepped for an aerial assault!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8605,'','WOOT! Made it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8606,'','There\'s no time to waste, trooper. I must get back to base immediately! Cover me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8607,'','Let\'s get down to business!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8608,'Guse? Jeztor? Are they... flat spin?? Seas of Southshore??','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8609,'I need to get back to my ride. Search and destroy imminent! Cover me! On my six! GO GO GO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8610,'I come for you, puny Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8611,'Good work, soldier. Now we light the fires and spite their ire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8612,'%s let\'s loose a menacing hoot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8613,'','Soldiers of Frostwolf, come to my aid! The time has come to unleash the fury of the elements upon them!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8614,'I\'ve reached my supply needs for now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8615,'This expedition is a terrible drain on military supplies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8616,'WHO DARES SUMMON LOKHOLAR?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8617,'The blood of a thousand Alliance soldiers I shall spill... None shall stand against the might of the Ice Lord!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8618,'I drink in your suffering, mortal. Let your essence congeal with Lokholar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8619,'%s\'s death wail has stirred the nearby silithid hive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8620,'','%s\'s death wail has stirred the nearby silithid hive!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8621,'','The blood of our enemies shall be spilt upon the battlefield. The great elementals shall answer our call and crush all that stand in our way.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8622,'','%s cackles.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8623,'','The Ice Lord will consume the entire Stormpike army!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8624,'Answer cannot be seen through the twisting nether.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8625,'','Watch as the blood seeps into the snow, children. The elemental will be bound to us!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8626,'','It is done! The Ice Lord has arrived! Bow to the might of the Horde, fools!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8627,'Forget about it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8628,'It is not worth answering.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8629,'Is that some kind of a joke?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8630,'Do not summon me again unless you have a real question to ask, ok?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8631,'%s is enraged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8632,'','Channel your energies into the Altar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8633,'It\'s just so horrible. Our three top guns were shot down over Alliance territory during an air assault Nobody knows if they\'re dead or alive!$B$BThis is a terrible blow to our air strike capabilities.','',1,1,5,0,0,0,0,0,1,0,0,0,26124),
(8634,'I need a ride out of here, Martin.','I need a ride out of here, Martin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8635,'','Good work, soldier. I need to get back to base camp! Will you cover me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8636,'I got your back, Guse.','I got your back, Guse.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8637,'','About damn time someone came. What took you so long? Ah, nevermind. Cover me, soldier. I gotta make it back to base!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(8638,'You can count on me, Jeztor.','You can count on me, Jeztor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8639,'','You do not belong in these gardens.  Your body shall nourish our lovely creations!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8640,'','Nothing must befoul the gardens! You must be destroyed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8641,'How much more blood is needed, Commander?','How much more blood is needed, Commander?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8642,'','There is much work left to be done, $n! Continue to strike down our enemies!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8643,'We must be close, Commander. I can feel the elements stirring.','We must be close, Commander. I can feel the elements stirring.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8644,'','Yes, $n. The elements are stirring. Soon, we will unleash their might upon our enemies. They shall reel from the blows!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8645,'I sense a great power among us, Commander. Is the spell ready?','I sense a great power among us, Commander. Is the spell ready?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8646,'','I have made contact, $n. It is Lokholar the Ice Lord. He has deemed our cause worthy - our earth bound sacrifice sufficient. He comes soon... prepare yourself.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8647,'I need a few good wing men to get me out of here safely and back to base.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8648,'I will be your wingman!','I will be your wingman!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8649,'Leave this sacred place or perish!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8650,'For the Legion! For Kil\'Jaeden!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8651,'Kazzak is supreme!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8652,'Holds mistletoe over $g his : her; head','Holds mistletoe over $g his : her; head',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8653,'The pages of the journal seem to be filled with information about trades, buyers  and other miscellaneous business related events.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8654,'','Never look the Commander directly in the eyes.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8655,'','We are under direct orders from Cairne, $r. Do not interfere with the Commander\'s task.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8656,'','The Shaman Commander is not to be trifled with, $r.',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(8657,'','Soon, Lokholar shall rise... Soon... Very, very soon...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8658,'You continue to thumb through the journal looking for any information that might help in your search for the stolen chest.$B$BTowards the final pages of the book, in red pencil, you see a notation from James along the side of the page. It says, \"Old home near Stone Cairn Lake... gnolls will work perfectly as bodyguards.\"$B$BThere is no reason to suggest this is where the chest is, but there doesn\'t seem to be any other clues.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8659,'','The fleet is ready, $n. You must take this beacon and place it at the eastern crater of the central battlezone. Defend the beacon from attackers until the fleet is able to lock on to its coordinates!',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(8660,'** CONFIRMS TARGET LOCK. WAR RIDER UNIT INCOMING.  AERIAL ASSAULT IMMINENT. **','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8661,'** PLANTED. CONFIRMING WAR RIDER LOCK. STAND BY. T-MINUS 60 SECONDS. **','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8662,'** SERVOS DESTROYED. UNIT TARGETTING CORRUPT. SHUT DOWN IMMINENT. **','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8663,'%s lets loose a shrill cry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8664,'I am Hydraxis, Duke of the Waterlords.  You are not an elemental and so cannot understand our struggle, but perhaps we can strike a deal that will benefit us both...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8665,'$n, it is good to see you.  Our war with the other elemental lords yet rages, but your efforts help ensure our victory.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8666,'I require a vial of aqual quintessence, Hydraxis, for I go to the Molten Core to extinguish a rune of the Firelords.','I require a vial of aqual quintessence, Hydraxis, for I go to the Molten Core to extinguish a rune of the Firelords.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8667,'I\'ll get that beacon to the crater safely, Guse. You can count on me!','I\'ll get that beacon to the crater safely, Guse. You can count on me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8668,'','The fleet is ready, $n. You must take this beacon and place it at the western crater of the central battlezone. Defend the beacon from attackers until the fleet is able to lock on to its coordinates!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8669,'Consider it done, Jeztor. Give me a beacon.','Consider it done, Jeztor. Give me a beacon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8670,'The time has come to prove your worth as a wing man, $n. Take this beacon and plant it dead center of the Snowfall graveyard. Defend it until my fleet arrives.$B$B<Mulverick salutes.>','',1,1,113,0,0,0,0,0,1,0,0,0,26124),
(8671,'I\'m ready to plant the beacon, Mulv. Give me a beacon.','I\'m ready to plant the beacon, Mulv. Give me a beacon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8672,'Yeee hawww! Mulverick\'s fleet is ready to rock. All able bodied Horde soldiers need request a beacon and try their damndest to plant it so that my War Riders can home in for the aerial assault.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8673,'','War Riders are now ready! Soldiers of the Horde, I need your assistance.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8674,'','Jeztor\'s Riders are ready! Soldiers of the Horde, report for duty!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8675,'%s springs forth to defend its hive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8676,'%s springs forth to defend its hive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8677,'The Earth Mother watch over us; under cover of the night as in the day. Let this fire illuminate both our bodies and spirits and remind us of our honored ancestors, who are ever present and guiding our way.\n','',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(8678,'I wish to learn my leatherworking focus.','I wish to learn my leatherworking focus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8679,'Show these savages no mercy, soldiers! They\'ll give none to you!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8680,'Withdraw your troops, brother, and I promise you a swift second death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8681,'Rally around your Lieutenants and Commanders, soldiers! Keep the savages at bay!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8682,'Show our enemies your resolve, soldiers! Crush them underfoot! Under steel!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8683,'FER THE KING! Push \'em back, soldiers!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8684,'Surrender an\' we\'ll let ye live, heathens! Jus\' put down yer arms an\' march!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8685,'Sending ground assaults takes huge amounts of supplies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8686,'$n, what are you waiting for?  Find Field Marshal Teravaine in the Field of Strife and give him the assault orders.  Once he gets the orders, he and his troops will charge into the Horde and take no prisoners!','$n, what are you waiting for?  Find Field Marshal in the Field of Strife and give him the assault orders.  Once he gets the orders, he and his troops will charge into the Horde and take no prisoners!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8687,'Give me the orders!  I will deliver them to Teravaine in the Field of Strife!','Give me the orders!  I will deliver them to Teravaine in the Field of Strife!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8688,'The Eye sees all within its sphere of influence, $c. What is it that you wish to see?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(8689,'The orders are given!  Move out, and show them what we\'re made of!','The orders are given!  Move out, and show them what we\'re made of!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8691,'Thank you, $n.  I\'ll mobilize my people right now!','Thank you, $n.  I\'ll mobilize my people right now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8692,'I wish to see my enemies, Ryson. Show them to me.','I wish to see my enemies, Ryson. Show them to me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8693,'Take it! Return to me should the Eye\'s power falter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8694,'If you\'re looking for information that the Cenarion Circle might have archived somewhere, then I\'m the one to talk to.  Then again, you need to know what information you\'re looking for first before I can really help you.$B$BSee how that works?  Brilliant!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8695,'Don\'t listen to the hearts of the world - the answer lies within.  You know the truth.','',274,1,0,0,0,0,0,0,1,0,0,0,26124),
(8696,'The past lives in these wastes, $c.  We must be careful to not awaken it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8697,'The power of the Eye is unquestionable, Ryson, but what else can it do?','The power of the Eye is unquestionable, Ryson, but what else can it do?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8698,'The power of the Eye is unquestionable, Ryson, but what else can it do?','The power of the Eye is unquestionable, Ryson, but what else can it do?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8699,'You have only just begun to see the Eye\'s power, $c. If you wish to facilitate the abilities of the Eye, then there is a task that you must complete.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8700,'What is this task?','What is this task?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8701,'Take this beacon and advance upon the enemy\'s base. Make your way to the outside of their main stronghold and place the beacon in the center of the courtyard. Defend the beacon from attackers until the Eye has locked on the beacon\'s coordinates.$B$BOnce this is done, all activity outside the enemy\'s base will be viewable from here.$B$BWill you take on this task?','',1,1,6,0,0,0,0,0,1,0,0,0,26124),
(8702,'Absolutely. Give me a beacon, Ryson.','Absolutely. Give me a beacon, Ryson.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8703,'$n, you are ready for the ultimate task.  The fiery runes etched on the floor of the molten core are conduits to the realm of fire, and their presence is both an affront to us and a source of power for the Firelords.  They must be extinguished!$B$BTo extinguish a rune, take a vial of aqual quintessence.  Pour it on the rune and its flame will go out, rendering it useless and weakening our enemy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8704,'Welcome to the Undercity Guild Registry. What do you want?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8705,'Welcome to the Cenarion Circle, $c.  How may I assist you?','Welcome to the Cenarion Circle, $c.  How may I assist you?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8706,'I need a Scrying Scope to view the Globe of Scrying, Ryson.','I need a Scrying Scope to view the Globe of Scrying, Ryson.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8707,'Speak with Hydraxis.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8708,'You have no business with me, little one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8709,'Speak not your vulgar language to me!  Only Hydraxis can stand it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8710,'Greetings, little one.  You have business with the Waterlords?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8711,'Tales of your exploits spread.  Your name is not unknown to us, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8712,'You have made our enemies your own.  I will gladly share waters with you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8713,'Perhaps you will tell me of your deeds, $n.  I would be honored to know them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8714,'Our lord Hydraxis speaks highly of you.  My water is your water, friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8715,'When you next go to the Molten Core, kill a Firelord for me, will you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8716,'I don\'t think you want to learn anything I can teach. Might want to find a $c trainer to help you out.','I don\'t think you want to learn anything I can teach. Might want to find a $c trainer to help you out.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8717,'You look like the type I should watch my coin purse around. Something I can help you with?','You look like the type I should watch my coin purse around. Something I can help you with?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8718,'Upgrade to seasoned units!','Upgrade to seasoned units!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8719,'Upgrade to veteran units!','Upgrade to veteran units!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8720,'I see that you have found the eye.$B$B<Master Ryson grins.>$B$BWell, give it to me!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8721,'Take it! This thing is probably more trouble than its worth.','Take it! This thing is probably more trouble than its worth.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8722,'The All Seeing Eye must be recovered!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8723,'Upgrade to champion units!','Upgrade to champion units!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8724,'Lets get back to your base!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8725,'I am greatly indebted to you, $c. Perhaps I can help your cause.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8726,'I was searching for materials to build my latest and greatest invention, the portable remote control shredder unit, when these trolls clubbed me and dragged me into the depths of their cave.$B$BReturn me to safety and I will lend my aid to your cause, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8727,'Let\'s go, goblin!','Let\'s go, goblin!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8728,'Upgrade to seasoned units!','Upgrade to seasoned units!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8729,'Upgrade to veteran units!','Upgrade to veteran units!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8730,'Upgrade to champion units!','Upgrade to champion units!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8731,'','This land is tainted. Ivus must be called!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8732,'','Stormpike soldiers, aid and protect us! The Forest Lord has granted us his protection. The gateway must now be opened!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8733,'','Come, brothers.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8734,'','Onward!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8735,'','We must focus our thoughts upon the Circle of Calling if the Forest Lord is to come! We must hurry! Concentrate your energies!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8736,'Wicked, wicked, mortals! The forest weeps. The elements recoil at the destruction. Ivus must purge you from this world!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8737,'I come to raze your bases, Frost Wolf clan. Ivus punishes you for your treachery!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8738,'Ancients, rise!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8739,'Your base is forfeit, mortals! From its ashes shall rise life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8740,'Your base is forfeit, puny mortals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8741,'Our seasoned units are leaving the field.  We need more supplies!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8742,'Our veteran units are leaving the field.  We need more supplies!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8743,'Our champion units are leaving the field.  We need more supplies!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8744,'Seasoned units are entering the battle!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8745,'Veteran units are entering the battle!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8746,'Champion units are entering the battle!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8747,'We have been sent here from Darnassus to aid the Stormpike in their time of need.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8748,'The Archdruid believes that Ivus the Forest Lord will come once he is made aware of the destructive forces within this valley.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8749,'It is not for us to judge these atrocities. Ivus will pass judgment once he arrives.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8750,'','My faith guides my actions, $r. I know that Ivus will come.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8751,'Our seasoned units are leaving the field.  We need more supplies!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8752,'Our veterans are leaving the field.  We need more supplies!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8753,'Our champion units are leaving the field.  We need more supplies!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8754,'Seasoned units are taking to the field!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8755,'Our veterans are entering the field!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8756,'Our champion units are equipped!  Beware, alliance!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8757,'Have you made contact with Ivus, Archdruid?','Have you made contact with Ivus, Archdruid?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8758,'','I have been lost in the Dream. I sense his lifeforce but my powers have not yet grown strong enough to make contact.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8759,'The air is abuzz with energy, Archdruid. What is the status of the Forest Lord?','The air is abuzz with energy, Archdruid. What is the status of the Forest Lord?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8760,'','Yes. $n. I have located the Forest Lord. We must redouble our efforts! More crystals are needed!',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(8761,'The forest shakes and shudders! The winds howl! Does the Forest Lord approach?','The forest shakes and shudders! The winds howl! Does the Forest Lord approach?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8762,'','The Forest Lord is aware of the destruction in this valley, $n. Soon we must make our way to the Circle of Calling. Prepare yourself!',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(8763,'I was shot down by that reckless fool, Mulverick. I fear that if I do not make it back to base, all will be lost! Mulverick and his squad of War Riders must be stopped!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8764,'I got your back, Ichman. GO GO GO!','I got your back, Ichman. GO GO GO!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8765,'I can\'t believe it... I was doing a routine recon mission over the central DMZ when all hell broke loose. I saw the Horde Wing Commander, Mulverick, take out both Ichman and Slidore! Anger took hold of me and I broke from my wing man and drove that show-off, Mulverick, down. Unfortunately, he clipped my gryphon before he crashed, forcing me down as well. I ended up captured by these savages.$B$BI have to get back to base! Help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8766,'I got you covered, Vipore. Move out!','I got you covered, Vipore. Move out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8767,'I heard their mocking laughter as my gryphon crashed and burned, $c.$B$B\"Slidore, you stink!\" They shouted.$B$BNobody talks to Slidore that way! Help me get out of here so that I can show them who the real stinker is!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8768,'I got your back, Slidore, but to be honest, you do stink. Take a shower, man.','I got your back, Slidore, but to be honest, you do stink. Take a shower, man.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8769,'Cover me, I\'m making a break for it!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8770,'We\'ve got no time to waste. This is a really long run! Cover me!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8771,'Just get me close enough to our base and I can channel a teleport!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8772,'This is far enough! Meet me back at base!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8773,'You\'re going down, Mulv!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8774,'','I have orders here for an attack on alliance forces in the middle fields.  I need someone to get them to the assault leader.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8775,'','It\'s a cold, bloody battle we wage in Alterac Valley.  It\'s perfect.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8776,'Yes, I will deliver the orders to Warmaster Garrick!','Yes, I will deliver the orders to Warmaster Garrick!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8777,'','This forest can be confusing! Be careful out there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8778,'Season\'s savings to you and yours!','Season\'s savings to you and yours!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8779,'Fresh from our farm to your plate - it\'s Smokywood Pastures wholesome goodness!','Fresh from our farm to your plate - it\'s Smokywood Pastures wholesome goodness!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8780,'\'Tis the season for great bargains!  Fah la la la la!','\'Tis the season for great bargains!  Fah la la la la!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8781,'Have a wondrous Feast of Winter Veil!  Start it off right with treats from Smokywood Pastures!','Have a wondrous Feast of Winter Veil!  Start it off right with treats from Smokywood Pastures!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8782,'Be sure to tell Greatfather Winter what secret surprise you\'d like to get this Winter Veil!','Be sure to tell Greatfather Winter what secret surprise you\'d like to get this Winter Veil!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8783,'Don\'t let the jingle of the bells take away from the jingle in your pocket!  Buy Smokywood Pastures treats for your Winter Veil festivities!','Don\'t let the jingle of the bells take away from the jingle in your pocket!  Buy Smokywood Pastures treats for your Winter Veil festivities!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8784,'If I had some chestnuts, you\'d better believe I\'d have them roasting over an open fire.  Mmmm!','If I had some chestnuts, you\'d better believe I\'d have them roasting over an open fire.  Mmmm!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8785,'Don\'t forget to stock up on wrapping paper this holiday season!  Nothing says \"Wondrous Winter Veil\" like wrapped armors and weapons for your friends and family.','Don\'t forget to stock up on wrapping paper this holiday season!  Nothing says \"Wondrous Winter Veil\" like wrapped armors and weapons for your friends and family.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8786,'Let me browse your seasonal fare.','Let me browse your seasonal fare.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8787,'Double time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8788,'%s arming. T-minus 60 seconds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8789,'%s armed. Aerie Gryphon en route.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8790,'%s is destroyed. Aerial assault unable to confirm strike point. Mission aborted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8791,'Soldiers of Stormpike, come to my aid! The beacon must be planted.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8792,'Pay attention, soldier! You need to take this beacon to the Snowfall graveyard and plant it! Protect it long enough so that my gryphon can lock on.$B$BIf my gryphon gets a solid strike location, Mulv and his crew will be humiliated!','',1,1,11,0,0,0,0,0,1,0,0,0,26124),
(8793,'I\'m your man, Ich. Give me a beacon!','I\'m your man, Ich. Give me a beacon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8794,'My flight is ready! Soldiers come to my aid!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8795,'$n! Finally!$B$BYou must take this beacon and plant it in the eastern crater of the central battle grounds. My flight will attack when the beacon beams its coordinates!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(8796,'Give me the beacon, Slidore! Also, you still stink!','Give me the beacon, Slidore! Also, you still stink!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8797,'Their spirits are restored! The gryphons are ready to strike! Come, soldiers! Come to my side!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8798,'The gryphons are ready to strike, $n! You must take this beacon and plant it in the western crater of the central battlegrounds.$B$BDo this and the battle is ours!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(8799,'I am ready to rock, Vipore! Give me a beacon.','I am ready to rock, Vipore! Give me a beacon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8800,'We now hold the wisdom of the Winterax, $n. This power can be yours for a short time should you so desire.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8801,'Grant me the wisdom of Winterax!','Grant me the wisdom of Winterax!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8802,'Our units are not upgraded, and I don\'t have enough supplies to upgrade them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8803,'Our units are upgraded to Seasoned, but I don\'t have enough supplies to upgrade them to Veteran.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8804,'Our units are upgraded to Veteran, but I don\'t have enough supplies to upgrade them to Champion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8805,'I have enough supplies to upgrade  our troops to seasoned.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8806,'I have enough supplies to upgrade our troops to veterans.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8807,'I have enough supplies to upgrade our troops to champions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8808,'Our units are upgraded to Champions, but I can still collect more supplies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8809,'I cannot store any more supplies.  I have all I can handle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8810,'Here to learn how to wield a new weapon, or just to waste my time?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8811,'I\'d like some weapon training','I\'d like some weapon training',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8812,'What can other weapon masters teach?','What can other weapon masters teach?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8813,'Tell me what weapon you want to learn or go away.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8814,'Who controls the Stormpike Graveyard?','Who controls the Stormpike Graveyard?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8817,'The Stormpike Graveyard is cut into the mountains, across the bridge east of Dun Baldar.$B$BThe Alliance currently controls it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8818,'The Stormpike Graveyard is cut into the mountains, across the bridge east of Dun Baldar.$B$BThe Horde currently controls it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8820,'Who controls the Snowfall Graveyard?','Who controls the Snowfall Graveyard?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8821,'The Snowfall Graveyard lies high atop a hill in the Field of Strife, east of Winterax Hold.$B$BThe Alliance currently controls it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8823,'The Snowfall Graveyard lies high atop a hill in the Field of Strife, east of Winterax Hold.$B$BThe Horde currently controls it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8824,'Who controls the Frostwolf Graveyard?','Who controls the Frostwolf Graveyard?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8825,'The Frostwolf Graveyard is along the side of the road, not far north of Frostwolf Village.$B$BThe Alliance currently controls it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8826,'The Frostwolf Graveyard is along the side of the road, not far north of Frostwolf Village.$B$BThe Horde currently controls it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8830,'The Fostwolf Graveyard is owned by the Alliance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8831,'The Fostwolf Graveyard is owned by the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8832,'The Snowfall Graveyard is owned by the Alliance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8833,'The Snowfall Graveyard is owned by the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8834,'A wondrous Winter Veil to you... uh... little $G boy : girl;.  Good children get special, um, discounts at any local Smokywood Pastures vendor.  Yum.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8835,'I have a pretty good idea what ol\' Greatfather Winter\'s gonna be doing when this shift is over.  I got a bottle of Winter Veil cheer right here in my bag, and I intend to get to the bottom of it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8836,'No... you can\'t sit on my lap.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8837,'Yeah, sure, go ahead and tell ol\' Greatfather Winter what you\'d like for this Winter Veil.$B$BHo ho hurry up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8838,'The Stormpike clan bows to no one, especially the horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8839,'Your attacks are weak!  Go practice on some rabbits and come back when you\'re stronger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8840,'Is that the best you can do?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8841,'It\'ll take more than you rabble to bring me down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8842,'We will not be swayed from our mission!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8843,'We, the Alliance, will prevail!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8844,'You cannot defeat the Frostwolf clan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8845,'Your spirits are weak, and your blows are weaker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8846,'Your attacks are slowed by the cold, I think!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8847,'If you will not leave Alterac Valley on your own, then the Frostwolves will force you out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8848,'You are no match for the strength of the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8849,'Today, you will meet your ancestors!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8850,'%s\'s wings thunder in the distance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8851,'Tell me about the Glowing Shard.','Tell me about the Glowing Shard.',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(8852,'Mine! Mine! Mine!  Gizlock is the ruler of this domain!  You shall never reveal my presence!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8853,'Dun Baldar took a real beating in the last Horde attack!  We need more supplies in order to rebuild and make repairs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8854,'They say an army travels on its stomach, and that\'s the truth.  For any offensive to succeed, your troops have to be well-fed and well supplied.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8855,'Some say that strength and bravery are most needed for an army\'s success.  And it\'s true!  But an army also needs supplies to keep itself in good shape, and it\'s my job to make sure they have what they need.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8857,'Frostwolf Keep is razed!  We must have supplies in order to repair and rebuild!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8858,'%s whimpers obediently.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8859,'','Greetings, soldier. Are you here to help the cause?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(8860,'','Well done, soldier. A few more and our stables will be overflowing with mounts for the cavalry to ride into combat!',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(8861,'Thank you, Stable Master. Please take the animal.','Thank you, Stable Master. Please take the animal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8862,'Heya mon.  You come right place learn how ta wield a new weapon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8863,'Ah, $n!  You\'re just the person I was hoping to see!  We have enough supplies to send a ground assault against the Horde!  Field Marshal Teravaine is waiting in the Field of Strife for orders...$B$BYou\'re a brave veteran who\'s proven himself time and again.  Do you want to deliver Teravaine the orders?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8864,'What you want to learn, mon?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8865,'$n!  What are you doing talking to me?  You should be out fighting the Horde!$B$BI have assault orders for one of our field marshals in the Field of Strife, but I need someone I can count on.$B$BPerhaps if your standing with the Stormpike militia were higher, I could count on you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8866,'I would be honored to train you in the use of the weapons that I have mastered should you have the ability to learn within you.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8867,'$n!  Our supplies are dwindling and until we get more we can\'t launch large ground assaults into the Field of Strife!$B$BSpeak with the Stormpike Quartermaster.  He\'ll tell you what you can do to resupply our assault forces.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8868,'If you require more training, I would be happy to tell you who can aid you. What weapon has caught your eye?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8869,'Death to Stormpike!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(8870,'Unleash the cavalry!','Unleash the cavalry!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8871,'You have done an exceptional job, soldier! The cavalry is ready to ride on your command.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8872,'Awaiting orders from my superiors.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8873,'I suppose you are here to be trained in the use of a new weapon?  Make it fast, I\'m very busy!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8874,'I\'ll tell you where to go, provided you tell me what interests you.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8875,'I wish to stable my pet, Stable Master.','I wish to stable my pet, Stable Master.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8876,'$n, it\'s good to see veterans like you in the field!  I\'m sorry to report that our supplies are currently too low to launch any large ground assaults against the Horde.$B$BSpeak with our quartermaster; he has supply missions available.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8877,'Have you come seeking training in the ways of armed combat?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8878,'What weapon in particular interests you?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8879,'','The grace with which I fight is not something I can teach you, but I can teach you the use of various weapons.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8880,'','I can direct you to other weapon masters if you prefer. What interests you?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8881,'Ye want to be trained in the use of a weapon, do ye?  Well don\'t stand there slack-jawed, speak up $gladdie : lassie;!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8882,'What weapon were ye lookin\' to learn?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8883,'','Well hi there!  Are you here to learn the proper technique of a new weapon?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8884,'','Aw, don\'t want to train with me? What other weapon catches your eye?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8885,'','We need more wolves! Come to the stables and help!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8886,'','Well done, Horde! We have enough Frostwolves in our stables to provide mounts to all of our wolf riders!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8887,'Wolf riders, to Frost Dagger Pass!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8888,'RARRRRRR!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8889,'Let me know when it is best to ride. You must be our eyes and ears on the battlefront.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8890,'The time has come, brothers. We must not let the enemy advance through Frost Dagger Pass. Some of us will surely perish, but would any of you shy away from this duty? This honor? Onward! For the Horde!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8891,'For the Warchief!','For the Warchief!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8892,'Myolor, I was once an armorsmith and wish to retake the hammer once more! Teach me the way of the armorsmith.','Myolor, I was once an armorsmith and wish to retake the hammer once more! Teach me the way of the armorsmith.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8893,'Myolor, I was once a weaponsmith and wish to retake the hammer once more! Teach me the way of the weaponsmith!','Myolor, I was once a weaponsmith and wish to retake the hammer once more! Teach me the way of the weaponsmith!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8894,'Krathok, I was once an armorsmith and wish to retake the hammer once more! Teach me the way of the armorsmith.','Krathok, I was once an armorsmith and wish to retake the hammer once more! Teach me the way of the armorsmith.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8895,'Krathok, I was once a weaponsmith and wish to retake the hammer once more! Teach me the way of the weaponsmith.','Krathok, I was once a weaponsmith and wish to retake the hammer once more! Teach me the way of the weaponsmith.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8896,'Patrol Frost Dagger Pass. Let none through! Die with honor...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8897,'The Kolkar invaders are retreating!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8898,'We have gathered enough hides from the wolves. Soon, the cavalry will be ready to ride! Speak to me again when we have stabled enough rams.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8899,'','The stables are full again! Our cavalry is soon to ride!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8900,'','The stable is empty! We must provide our cavalry with suitable mounts. Stormpike Stables requests your assistance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8901,'Death to Frostwolf!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(8902,'We ride on your command!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8903,'YAW! Er, to the front lines with you!','YAW! Er, to the front lines with you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8904,'Awaiting orders from my superiors!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8905,'Ram Riders, REGULATE!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8906,'Lads and ladies. Today can be your greatest day, for today, you fight for the glory of Stormpike! Ride unto the field and grant your enemies no mercy! Strike the savages down and let their Warchief sort em out!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8907,'Patrol the front line, soldiers!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8908,'For the King!','For the King!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8909,'','The indigenous rams of Alterac are vital to the functionality of our cavalry!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8910,'','Just a few more and our stables will be overflowing with mounts. Release it into my custody, soldier. I\'ll take it from here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8911,'With pleasure. These things stink!','With pleasure. These things stink!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8912,'I wish to stable my pet.','I wish to stable my pet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8913,'All right, Reavers!  The orders are here!  To battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8914,'I\'ll perform these with pleasure, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8915,'%s emerges from the plant, allowing it to heal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8916,'%s attacks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8917,'Well met, $n. We must be brief because there is much to do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8918,'May Cenarius guide you, $c.$B$BI am here in this corrupt land with my sisters on a mission of great importance to the Cenarion Circle. But only those who are powerful enough I ask speak to me about such matters--to send a lesser being would be folly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8919,'','My sisters and I have come down from the Stonetalon Mountains to put to rest a tragedy from ages past. Unfortunately, we are not powerful enough to accomplish our goals on our own and now seek mortals such as yourself to aid us.$B$BIf you are powerful enough, then we have much to discuss, $c. If you are not, then, for your safety, I will leave the details of my mission out of our conversation.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8920,'','$n, please take a look at the sample of the Vylestem vine that I took from the caverns, so that you know what to look for...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8921,'I greet you, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8922,'Free! Free from my bonds at last!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8923,'$n, please take a look at the sample of the Vylestem vine that I took from the caverns, so that you know what to look for...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8924,'I need no home to know I still have a place in this world, $c. The tribes will see... all of them. They fight amongst one another, and for what? Scraps left over by vultures... lands infested by the Legion... bah!$B$BThe centaur should be proud of their heritage--it is just as noble as any Night elf\'s or orc\'s--it is time we started acting like it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8925,'At last, I am free of the corruption that once bound me to this place...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8926,'Thank you for what you have done, $n.$B$BKeep the scepter safe; may it aid you in your toil against the evils that have invaded this place...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8927,'How has this come to be, $n? Do you think that an item such as the Scepter of Celebras is trivial?$B$BI can help you this time, but do not be careless with this valuable item again...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8928,'Celebras, I lost my Scepter...','Celebras, I lost my Scepter...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8929,'I carry both parts of the scepter.','I carry both parts of the scepter.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8930,'My scepter... After so many years... You have recovered it! You shall truly be the savior of this place...$B$BPlease listen to me carefully, $n. The head and the rod of the scepter may only be reunited into one at the Stone of Maraudon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8931,'Please show me the Stone of Maraudon.','Please show me the Stone of Maraudon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8932,'Please explain how the scepter works.','Please explain how the scepter works.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8933,'Between the colors, a path.$B$BBlink across in light.$B$BFrom the water, you emerge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8934,'I don\'t quite understand...','I don\'t quite understand...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8935,'Between the orange and the purple passageways near the doors to Maraudon, you will find a third path.$B$BThe scepter you hold in your hands is the key.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8936,'No, really, I still don\'t understand...','No, really, I still don\'t understand...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8937,'I grow weary...$B$BFrom here, you can see the waterfalls, $n...The scepter grants you the power to travel to this very place, should you ever desire to enter through the front gates of Maraudon again.$B$BNear the entrance to Maraudon, you will find a passage that goes down beneath the caverns. Use the scepter at the ancient ritual site to create a portal, and you will find yourself here once more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8938,'Please tell me more about Maraudon.','Please tell me more about Maraudon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8939,'Long ago, my dryad sisters and I entered these caves to free the tortured spirit of my uncle, Zaetar. However, the corruption that had already spread through these caverns soon overcame us, and we too fell.$B$BWe were destined to wander these passages; the toxins poisoning our minds...$B$BAlthough my spirit may now be at rest, I know that I have failed in my mission. It is a great sadness I must bear...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8940,'Please tell me more about Zaetar.','Please tell me more about Zaetar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8941,'Ah, Zaetar... <Celebras looks away.>$B$BMy father, Remulos, tried to stop him...$B$BZaetar was headstrong, and when he fell for an earthen elemental princess, my father knew that their union was cursed, but Zaetar refused to listen.$B$BThe centaur are the result of his mistake. They were born misshapen and hateful; my uncle Zaetar was killed by his own kin...$B$BThe evil princess, Theradras, still guards his remains here in the crystal caverns.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8942,'Those goblins should be ashamed of themselves.  Bah!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(8943,'Spending coin is NOT the reason for the Feast of Winter Veil!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(8944,'I cannot believe those greedy goblins are allowed to hawk their wares while spoiling the spirit of this season.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(8945,'Vile goblins... anything for a gold coin.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(8946,'Could I have a copy of \"The Feast of Winter Veil\" to read?','Could I have a copy of \"The Feast of Winter Veil\" to read?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8947,'Perhaps we can attempt this later. Please speak to me again if you wish to do so.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8948,'Together, the two parts shall become one, once again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8949,'Shal myrinan ishnu daldorah...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8950,'Read this tome I have placed before you, and speak the words aloud.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8951,'%s begins to channel his energy, focusing on the stone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8952,'You wish to learn of the stone? Follow me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8953,'For so long I have drifted in my cursed form. You have freed me... Your hard work shall be repaid.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8954,'Please do as I instruct you, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8955,'My scepter will once again become whole!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8956,'Welcome to the Explorers\' League.  If you need information, and it is in book form, then I might be able to help you out.','',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(8957,'How can I find the two parts of your scepter?','How can I find the two parts of your scepter?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8958,'As the toxins lurking within Maraudon seeped into my mind, I began to lose my grip on reality. Worried that it would be used for evil, my dryad sisters secretly took the scepter from me, breaking it into two parts and hiding it within the caverns.$B$BSoon they fell victim to the madness as well, and the two parts of the scepter, left unguarded, came to be in the possession of Vyletongue, himself. The satyr entrusted one part to Noxxion, an evil elemental, and the other he still has to this day.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8959,'Why didn\'t Lord Vyletongue unite both parts of the scepter into one?','Why didn\'t Lord Vyletongue unite both parts of the scepter into one?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8960,'Without knowledge of the incantations required to unite the two parts, Lord Vyletongue was unable to use the scepter. However, now that I am free of the curse of Vyletongue\'s corruption, I will be able to assist you, if you\'d like to bring me the two parts -- both the head and the rod of the scepter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8961,'Tell me more about the history of Remulos and Zaetar.','Tell me more about the history of Remulos and Zaetar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8962,'You ask of the Sons of Cenarius, Remulos and Zaetar.$B$BMy father, Remulos, was strong and beautiful, and my uncle, Zaetar, very cunning and slight of build. While they were respected quite equally, Zaetar always felt as if he could never quite compare to the glory and attention he thought Remulos had.$B$BAfter my sisters and I were born, Zaetar, blinded by jealousy, set out to outdo his brother... He was the creator of his own end. The sadness it brings me has never lessened, even as time passes...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8963,'Long have my spirit and remains been kept captive here within Maraudon, young $c. The time has given me nothing but ample opportunities to reflect on my mistakes and realize that my jealousy of Remulos was foolish. He attempted to warn and persuade me that my relations with Theradras would bear nothing pure--that only destruction would come from chaos. My brother was right.$B$BBut that does not mean since you have freed me, I am free of penance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8964,'Please, go on.','Please, go on.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8965,'Though exiled as a heretic, my beliefs still ring true--that alone drives me onward. But for my destiny to be complete, I need the aid of an outsider... one not of any centaur tribe.$B$BThe task requires someone to enter the holy halls of Maraudon--a temple my people protect, and only the most devout are ever allowed to enter.$B$BIf you agree to aid me, then you need only nod. I will pass you a parchment with my instructions on it. Read it over and consider my words.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8966,'I will aid you. Give me the instructions.','I will aid you. Give me the instructions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8967,'%s bows low before you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8968,'Thank you, good $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8969,'Greetings, $n. I am Doctor Gregory Victor, head trauma surgeon of Horde Trauma.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(8970,'It is good to see you again, Doctor $n. I have been following your progress and I dare say that it is time you learned some of the more advanced bandaging techniques.$B$BReturn to me from time to time, as your skill advances, and I shall teach you all that I know.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(8971,'Teach me how to create and apply a Heavy Mageweave Bandage, Doctor.','Teach me how to create and apply a Heavy Mageweave Bandage, Doctor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8972,'Teach me how to create and apply a Runecloth Bandage, Doctor.\n','Teach me how to create and apply a Runecloth Bandage, Doctor.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8973,'Teach me how to create and apply a Heavy Runecloth Bandage, Doctor.\n','Teach me how to create and apply a Heavy Runecloth Bandage, Doctor.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8974,'Greetings, $n. I am Doctor Gustaf VanHowzen, head trauma surgeon of Alliance Trauma.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(8975,'Great!  Let\'s keep those supplies coming, people!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8976,'Thanks for the supplies, $n!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(8977,'Thanks a lot, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8978,'We\'re making progress!  Bring more supplies to repair Dun Baldar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8979,'We have enough supplies!  Our captain has retaken position in the Field of Strife!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8980,'Now we\'re making progress!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8981,'Thank you for the armor scraps, $n!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8982,'Our cache of equipment grows!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(8983,'Thank you for the supplies, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8984,'Very good.  Our supply cache grows...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8985,'Keep them coming!  We need more supplies in order to rebuild...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8986,'We can now rebuild!  For the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8987,'','Hail, $n!  It is good you came to see me.  We are prepared to launch a ground assuault through the Field of Strife!  Once Warmaster Garrick gets his orders, he and his reavers will cut a swath through the Alliance!$B$BDo you want to deliver those orders, $n?  Garrick is waiting in the Field of Strife...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8988,'','Why are you here, $n?  Is there lead in your boots?$B$BYou have the assault orders - Warmaster Garrick needs them in the Field of Strife before he can make his assault!  Go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8989,'','It\'s good to have veterans like you in Alterac Valley, $n.  Our supplies are too low to launch a ground assault through Alterac Valley... speak with our quartermaster - he\'ll tell you how to increase our supply base.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8990,'','Hail, $c!  Our supply level is high, and we are ready to launch a ground assault through the Field of Strife.  Perhaps if your renown was greater, I would trust you to deliver the assault orders.$B$BSo get out there and fight the Alliance!  Show me you\'re a trusted and capable member of the Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8991,'','You!  $n!  What are you doing wandering around the village like this?  There are Alliance foes in Alterac!  We must drive them out!$B$BOur supplies are too low to launch a large ground assault, so speak with our quatermaster.  He\'ll tell you how you can increase our supply base.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8993,'','Even the bravest warrior must be well supplied if he is to face his foes with strength!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8994,'I just gave kill credit to $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8995,'Click here to remove res effects and repair all gear','Click here to remove res effects and repair all gear',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8996,'Hi! Clear your res effects here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8997,'Click here to repair your gear','Click here to repair your gear',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8998,'We have enough supplies to launch a ground assault.  If you want to send the order, and you think you qualify, then speak Sergeant Yazra Bloodsnarl.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(8999,'We have enough supplies to launch a ground assault.  If you want to deliver those orders, and you think you qualify, then speak with Corporal Noreg Stormpike.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9000,'I am in charge of recruitment for the Frostwolf Clan. As a soldier of Frostwolf, it is your responsibility to check in with me as your rank among the clan rises.$B$BHonor and respect are earned on this frigid field.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9001,'Warmaster, I have lost my insignia. Could you supply me with a replacement?','Warmaster, I have lost my insignia. Could you supply me with a replacement?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9002,'Hail, $r! I am Lieutenant Haggerdin, officer in charge of recruitment for the Stormpike Guard.$B$BAs you gain prestige and notoriety among the Stormpike, return to me and I shall see about upgrading your insignia. Also, should you ever lose your insignia, I am able to supply a replacement.','',1,1,113,0,0,0,0,0,1,0,0,0,26124),
(9003,'Lieutenant, I have lost my insignia. Could you please supply me with a replacement?','Lieutenant, I have lost my insignia. Could you please supply me with a replacement?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9004,'I have found both parts of your scepter.','I have found both parts of your scepter.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9005,'Argh, I need help here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9006,'Watch out for the $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9007,'Incoming $n - look sharp, friends!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9008,'You\'ll rue the day you crossed me, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9009,'Our ancestors teach us that while the individual must be strong, there is safety in numbers.  Do you wish to defend the honor of Thunder Bluff by organizing a guild?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(9010,'Aye, you look the type to be a leader.  Here to organize a guild to fight for the Alliance?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9011,'I will not be lured away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9012,'Shenthul, I have lost my whistle and I have no more flares. Please help!','Shenthul, I have lost my whistle and I have no more flares. Please help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9013,'Well met, $c. I am Rokaro.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9014,'Rokaro, I have lost the Drakefire Amulet. Could another be created?','Rokaro, I have lost the Drakefire Amulet. Could another be created?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9015,'','What is it you ask of the Blue Flight?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9016,'Haleh, I have lost the Drakefire Amulet. Could you fashion another?','Haleh, I have lost the Drakefire Amulet. Could you fashion another?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9017,'Master Nesingwary has a big hunt ahead of him.  I find helping him prepare for a day in the jungle is much more relaxing than helping him ready for combat.  Although I do miss some of those glorious moments on the battlefield.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9018,'Barnil, I seem to have misplaced Chapter I.','Barnil, I seem to have misplaced Chapter I.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9019,'Barnil, I seem to have misplaced Chapter II.','Barnil, I seem to have misplaced Chapter II.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9020,'Barnil, I seem to have misplaced Chapter III.','Barnil, I seem to have misplaced Chapter III.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9021,'Barnil, I seem to have misplaced Chapter IV.','Barnil, I seem to have misplaced Chapter IV.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9022,'I see you misplaced that chapter you worked so hard to put together, $n. Well, you left it right here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9023,'Kalaran, please enchant the torch.','Kalaran, please enchant the torch.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9024,'','I know these forests as if they were a part of me... but know that there is still much to be learned from them, and much danger still hidden.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9025,'Raene, I lost Dartol\'s Rod of Transformation.','Raene, I lost Dartol\'s Rod of Transformation.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9026,'','Yes, I expected that you would be back. I sent Korra out earlier and she came across Dartol\'s Rod, abandoned in the forest.$B$BWe worked so hard to recover it, $n. Please take care to see that you do not handle it so carelessly in the future.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9027,'','You have completed Teronis\' mission, and I appreciate all you have done, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9028,'','Hiya! This workshop isn\'t mine, no! But one day after I finish training I am going to be an inventor, just like my hero, Marvon Rivetseeker.$B$BYou\'ve never heard of him? Well it just so happens that he left quite some time ago to study some ancient troll ruins he kept talking about. He left in a zeppelin... not quite sure about where exactly he went...$B$BTanarasin? Tenkeris? Taneranisany?$B$B<Liv shakes her head.>$B$BNo, that\'s not it...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9029,'','Hi there. No, Marvon sure isn\'t here, and he won\'t be back for quite some time. Actually, I am getting a little worried about him...$B$BI hope he gets back soon. A large chest arrived for him and it\'s too heavy for me to lug it inside here! I had to leave it out by the door...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9030,'You have learned all that I am able to teach you at this time, Doctor $n. Return to me when your practice has expanded and I shall train you in the ways of the more advanced medicinal arts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9031,'Run! They are coming!','Run! They are coming!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9032,'','This place... it\'s cursed.$B$BI barely managed to escape, and I cannot bear to go down through the tunnels again.$B$BMy brother, and sisters though... They were not as fortunate. Trapped inside, they are feverish with the corrupted haze that flows from the evil garden growing there.$B$BPlease, you must help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9033,'','Oh, I am so glad you have returned, $n.$B$BMy brother\'s spirit has now be freed from the corruption, but I choose to remain here, in my mourning.$B$BThank you so much for your help, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9034,'Interlopers! Invaders! The All Seeing Eye has been stolen! The miserable dog, $n, has it in $g his:her; possession!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9036,'','Need some supplies?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9037,'Show me what\'s for sale.','Show me what\'s for sale.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9038,'Korrak has come, weaklings! Snowfall belongs to Winterax!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9039,'How many more supplies do we need?','How many more supplies do we need?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9040,'Alterac Valley - Alliance Quatmaster Greeting Option Default','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9041,'The Commander has been slain! Charge their lines! Die with honor!','The Commander has been slain! Charge their lines! Die with honor!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(9042,'Our Commander has fallen! The time for vengeance is now! Ram riders charge!!!!!!','Our Commander has fallen! The time for vengeance is now! Ram riders charge!!!!!!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9044,'Commander, the time has come for the wolf riders to charge the enemy lines. Send the order.','Commander, the time has come for the wolf riders to charge the enemy lines. Send the order.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9045,'Awaiting orders, sir. On your command, I shall unleash hell upon them!','',1,66,0,0,0,0,0,0,1,0,0,0,26124),
(9046,'The orders have been given! Death to Stormpike! Charge the enemy!','The orders have been given! Death to Stormpike! Charge the enemy!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(9047,'Commander, the time has come to charge the Frostwolf filth! Run them through!','Commander, the time has come to charge the Frostwolf filth! Run them through!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9048,'Truffles!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9049,'I shall unleash the cavalry upon your command, sir!','',1,66,0,0,0,0,0,0,1,0,0,0,26124),
(9050,'Charge!!! Run \'em through!','Charge!!! Run \'em through!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9051,'It\'s our turn to pickle your feet!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9052,'Time to gore...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9053,'Intruder!','Intruder!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9054,'Kill it!','Kill it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9055,'Raaaaaaaaaaaaarrrr!','Raaaaaaaaaaaaarrrr!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9056,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9057,'The Stormpike Graveyard was taken by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9058,'The Stormpike Graveyard is under attack!  If left unchecked, the Alliance will capture it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9059,'The Stormpike Graveyard was taken by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9060,'The Stormpike Graveyard is under attack!  If left unchecked, the Horde will capture it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9061,'The Snowfall Graveyard was taken by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9062,'The Snowfall Graveyard is under attack!  If left unchecked, the Alliance will capture it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9063,'The Snowfall Graveyard was taken by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9064,'The Snowfall Graveyard is under attack!  If left unchecked, the Horde will capture it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9065,'The Frostwolf Graveyard was taken by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9066,'The Frostwolf Graveyard is under attack!  If left unchecked, the Alliance will capture it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9067,'The Frostwolf Graveyard was taken by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9068,'The Frostwolf Graveyard is under attack!  If left unchecked, the Horde will capture it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9069,'You have come to learn in the art of warfare, $r? You have come to the wrong place.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(9070,'You have come to learn of battles won and lost on this field? There are no winners here...','',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(9071,'Come, little ones. Face me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9072,'This place is under my protection. The mysteries of the arcane shall remain inviolate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9073,'Such is the price of curiosity.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9074,'Greetings, soldier. Intelligence has reported that the Winterax trolls to the west have taken a master goblin engineer prisoner. Perhaps you should investigate?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(9075,'My scouts report that the Syndicate has taken up residence in a hidden cave on the eastern plateau. Be cautious when adventuring in that area.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9076,'Watch your step, soldier. The Stormpike have littered the ground around their bases with landmines. Speak with our explosives expert in the watch tower to the east if you want information on how to diffuse their mine fields.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9077,'Look alive, soldier! Stormpike Intelligence has reported that a master goblin engineer has been taken prisoner by the Winterax trolls. The Frostwolf dogs are actively trying to rescue him so that they may use his engineered gadgets to destroy us! Do not let that happen.','',1,5,25,0,0,0,0,0,1,0,0,0,26124),
(9078,'The Syndicate have been reported to be nosing around in a cave on the eastern plateau. Find out what they\'re up to, soldier! Beware of Frostwolf activity!','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9079,'Beware of entering Frostwolf territory, soldier. The whole damn place is booby trapped! Landmines galore! Speak with our explosives expert in the first tower on the front lines for more information. I am certain that he could teach you how to diffuse the situation.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9080,'Yes I have, Commander.','Yes I have, Commander.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9081,'Then listen well, $c.$B$BCan you feel the power radiating from me? Does your morale not swell? Aye, it is the same for the other side. To disrupt their defenses and thin out their troops will be no easy task, but it must be done! Victory will be ours!','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9082,'Who do I kill? Just point me in their direction, Commander.','Who do I kill? Just point me in their direction, Commander.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9083,'Six Lieutenants control the front line\'s defenses. They must be destroyed first and fast! We cannot risk one of their priests returning the fallen Lieutenants to life.$B$BShould all of the Lieutenants be killed in quick succession, the morale of the front lines will falter! It will be shattered! Their troops will run in fear, leaving the remaining soldiers without backup.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9084,'Is that all? I thought you were going to challenge me.','Is that all? I thought you were going to challenge me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9085,'No, $c, that is not all. The elite fighting forces of the opposition are commanded by the four Commanders of the base. Should you be able to strike a fatal and rapid blow to their Commanders, the elite line will falter. Their numbers dwindling to nothing!$B$BBut be warned, soldier; Commanders and Lieutenants are not to be trifled with or taken lightly. They earned those ranks...','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9086,'Clap your hands everybody, and everybody clap your hands!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9087,'Thank you, you\'re a great audience!  I\'ll be here all week!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9088,'Spare some change?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9089,'I had it all!  I had it all and then I lost it.  Lost... all gone... like... my mind.  My mind is like... cheese.  I like cheese.  ','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9090,'Show your appreciation for the arts and drop some coins in my hat!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9091,'Scanning life forms....target not found','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9092,'Unknown life forms detected....assessing...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9093,'Target lost....resuming search patterns Delta','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9094,'Explorer reporting!....Excellent!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9095,'%s stares hungrily at a Deeprun Rat.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9096,'Mmmm... don\'t you look good enough to eat.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9097,'On second thought... I think I\'ll pass.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9098,'Forty-two... forty-two... forty-two what?  It could be anything!  Forty-two... hmmm...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9099,'As you wish...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9100,'My strength wanes, mortal. I have done as promised, the way is clear. I now return to whence I came.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9101,'Helpless... powerless... restore... must restore... Zevrim controls... end this torment...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9102,'Thank you, mortal. There is but one service that I may offer to you before I return to the Dream.$B$BThe door to Zevrim\'s master, Alzzin, blocks your path. I shall act as your instrument of destruction. The door will be opened, I merely await your command.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9103,'Thank you, Ironbark. We are ready for you to open the door.','Thank you, Ironbark. We are ready for you to open the door.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9104,'At last... Freed from his cursed grasp!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9105,'Who controls the Stonehearth Graveyard?','Who controls the Stonehearth Graveyard?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9106,'The Stonehearth Graveyard lies east of the Stonehearth Outpost in the Field of Strife.$B$BThe Alliance currently controls it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9107,'The Stonehearth Graveyard lies east of the Stonehearth Outpost in the Field of Strife.$B$BThe Horde currently controls it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9110,'How many more supplies are needed to send a ground assault?','How many more supplies are needed to send a ground assault?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9111,'How many more supplies are needed to rebuild our base?','How many more supplies are needed to rebuild our base?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9112,'We have a lot of supplies, but we still need a lot more in order to send a ground assault into the Field of Strife.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9113,'We have some supplies, but not many.  We\'ll need a lot more in order to send a ground assault into the Field of Strife.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9114,'We have barely any supplies.  If we want to send a ground assault into the Field of Strife, then we\'ll need a lot more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9115,'We have a large store of supplies to rebuild Frostwolf Keep.  Just a little bit more and we\'ll have enough to repair and reenter the battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9116,'We have a medium store of supplies for rebuilding, but we still need a lot more before Frostwolf Keep can be fully repaired.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9117,'We have a very small store of supplies to rebuild Frostwolf Keep.  It\'s going to take a lot more before we can repair and reenter the battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9118,'We barely have any supplies to build Frostwolf Keep.  We\'ll need many, many more before we can repair our base and reenter the battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9119,'$n, we have enough supplies to launch ground assaults into the Field of Strife.  If you want to send the orders, and your rank is high enough, then speak with Sergeant Yazra Bloodsnarl in Frostwolf Village.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9120,'We have lots of supplies for rebuilding.  Just a little bit more and we\'ll have enough to repair Dun Baldar and reenter the battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9121,'We have gathered a lot of supplies for rebuilding, but we still need a lot more in order to repair Dun Baldar.  Keep bringing me supplies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9122,'We don\'t have many supplies for rebuilding.  It will take a lot more before Dun Baldar will be repaired.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9123,'Dun Baldar is in very bad shape, and we\'re very low on supplies to rebuild it.  The Alliance needs your help gathering supplies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9124,'$n, we have enough supplies to launch ground assaults.  If your standing with the Stormpike Guard is high enough, then speak with Corporal Noreg Stormpike.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9125,'We have a lot of excess supplies, but we still need more before we can send an assualt into the Field of Strife.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9126,'We have excess supplies, but not many.  We\'ll need a lot more before we can send a ground assault into the Field of Strife.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9127,'We barely have any excess supplies.  It\'ll take a lot more work before we\'re ready to send another ground assault into the Field of Strife.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9128,'How many more supplies are needed to send ground assaults?','How many more supplies are needed to send ground assaults?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9129,'How many more supplies are needed to rebuild our base?','How many more supplies are needed to rebuild our base?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9130,'How many more supplies are needed for the next upgrade?','How many more supplies are needed for the next upgrade?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9131,'I almost have enough supplies to upgrade to veteran units.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9132,'I need many more supplies in order to upgrade our units.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9133,'I almost have enough supplies to upgrade our troops.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9134,'I have about half the supplies needed to upgrade to veteran units.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9135,'I have less than one-third of the supplies needed to upgrade to veteran units.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9136,'I barely have any supplies for upgrades.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9137,'Ugh... these pests keep me busy night and day! Haven\'t you seen them?$B$BI wish I could just jump down a pipe to get away from them...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9138,'Larion, I want to help you fight these pests!','Larion, I want to help you fight these pests!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9139,'This is some specialized equipment! Don\'t be handling it carelessly, and of course don\'t try and operate the thing if you\'ve had too much of that volatile rum I hear you like so much...$B$BSpeaking of which... you don\'t happen to have any of that nasty stuff, do you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9140,'Which way should you go? Well, the only advice I can offer is for you to take any road you want!$B$BI can\'t remember anything!','',1,11,0,0,0,0,0,0,1,0,0,0,26124),
(9141,'%s sifts through the trash.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9142,'','This is my test gossip.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9143,'','This is my test gossip.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9144,'%s puts his club away and begins swinging wildly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9145,'How dare you attempt to zerg me, wimp!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9147,'%s yawns.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9148,'Yes, $c?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9149,'Rats everywhere.  Everywhere I see rats.  Always looking at me with their beady little eyes.  I\'ll show them.  I\'ll show them all!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9150,'Rat-kabobs!  Get your tasty Rat-kabobs here!  Get them while they last!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9151,'How many more supplies are needed for the next upgrade?','How many more supplies are needed for the next upgrade?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9152,'I almost have enough supplies to upgrade to champion units.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9153,'I have about half the supplies needed to upgrade to champion units.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9154,'I barely have any supplies for upgrades.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9155,'I almost have enough supplies to upgrade our troops.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9156,'I need many more supplies in order to upgrade our units.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9158,'I almost have enough supplies to upgrade to veteran units.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9159,'I need many more supplies in order to upgrade our units.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9160,'I have about half the supplies needed to upgrade to veteran units.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9161,'I almost have enough supplies to upgrade to champion units.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9162,'I have about half the supplies needed to upgrade to champion units.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9163,'I barely have any supplies for upgrades.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9164,'Our units are not upgraded, and I don\'t have enough supplies to upgrade them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9165,'Our units are upgraded to Seasoned, but I don\'t have enough supplies to upgrade them to Veteran.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9166,'Our units are upgraded to Veteran, but I don\'t have enough supplies to upgrade them to Champion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9167,'I have enough supplies to upgrade  our troops to seasoned.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9168,'I have enough supplies to upgrade our troops to veterans.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9169,'I have enough supplies to upgrade our troops to champions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9170,'I cannot store any more supplies.  I have all I can handle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9171,'My altar will siphon the life from you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9172,'Your pain will end soon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9173,'OH NOES!! BRB AS DRAGON! <PH>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9174,'The Dun Baldar South Bunker is under attack!  If left unchecked, the Horde will destroy it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9175,'The Dun Baldar South Bunker was destroyed by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9176,'The Dun Baldar South Bunker is under attack!  If left unchecked, the Alliance will destroy it!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9177,'The Dun Baldar South Bunker was taken by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9178,'The Dun Baldar North Bunker is under attack!  If left unchecked, the Horde will destroy it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9179,'The Dun Baldar North Bunker was destroyed by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9180,'The Dun Baldar North Bunker is under attack!  If left unchecked, the Alliance will destroy it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9181,'The Dun Baldar North Bunker was taken by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9182,'The Icewing Bunker is under attack!  If left unchecked, the Horde will destroy it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9183,'The Icewing Bunker was destroyed by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9184,'The Icewing Bunker is under attack!  If left unchecked, the Alliance will destroy it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9185,'The Icewing Bunker was taken by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9186,'The Stonehearth Bunker is under attack!  If left unchecked, the Horde will destroy it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9187,'The Stonehearth Bunker was destroyed by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9188,'The Stonehearth Bunker is under attack!  If left unchecked, the Alliance will destroy it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9189,'The Stonehearth Bunker was taken by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9190,'The West Frostwolf Tower is under attack!  If left unchecked, the Horde will destroy it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9191,'The West Frostwolf Tower was taken by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9192,'The West Frostwolf Tower is under attack!  If left unchecked, the Alliance will destroy it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9193,'The West Frostwolf Tower was destroyed by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9194,'The East Frostwolf Tower is under attack!  If left unchecked, the Horde will destroy it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9195,'The East Frostwolf Tower was taken by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9196,'The East Frostwolf Tower is under attack!  If left unchecked, the Alliance will destroy it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9197,'The East Frostwolf Tower was destroyed by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9198,'Tower Point is under attack!  If left unchecked, the Horde will destroy it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9199,'Tower Point was taken by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9200,'Tower Point is under attack!  If left unchecked, the Alliance will destroy it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9201,'Tower Point was destroyed by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9202,'Iceblood Bunker is under attack!  If left unchecked, the Horde will destroy it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9203,'Iceblood Tower was taken by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9204,'Iceblood Tower is under attack!  If left unchecked, the Alliance will destroy it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9205,'Iceblood Tower was destroyed by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9206,'The West Frostwolf Tower is under attack!  If left unchecked, the Horde will destroy it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9207,'The West Frostwolf Tower was taken by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9208,'The West Frostwolf Tower is under attack!  If left unchecked, the Alliance will destroy it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9209,'The West Frostwolf Tower was destroyed by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9210,'Your skill exceeds mine, though  I\'ve heard that Old Man Heming in Booty Bay has copies of \"The Bass and You\".  That is sure to help you increase your skill.','Your skill exceeds mine, though  I\'ve heard that Old Man Heming in Booty Bay has copies of \"The Bass and You\".  That is sure to help you increase your skill.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9211,'The Stormpike Aid Station was taken by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9212,'The Stormpike Aid Station is under attack!  If left unchecked, the Horde will capture it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9213,'The Stormpike Aid Station was taken by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9214,'The Stormpike Aid Station is under attack!  If left unchecked, the Alliance will capture it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9215,'The Frostwolf Relief Hut was taken by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9216,'The Frostwolf Relief Hut is under attack!  If left unchecked, the Horde will capture it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9217,'The Frostwolf Relief Hut was taken by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9218,'The Frostwolf Relief Hut is under attack!  If left unchecked, the Alliance will capture it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9219,'Your skill exceeds mine, though  I\'ve heard that Old Man Heming in Booty Bay has copies of \"The Bass and You\".  That is sure to help you increase your skill.','Your skill exceeds mine, though  I\'ve heard that Old Man Heming in Booty Bay has copies of \"The Bass and You\".  That is sure to help you increase your skill.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9220,'See that broken trap over yonder?  The ogres are too stupid to figure out how to fix it.  Clearly, it needs a little tinkering!  If you fix it, I bet you could lure Slip\'kik into it, and BLAMMO - trapped ogre guard!','',20,0,0,0,0,0,0,0,1,0,0,0,26124),
(9221,'The Stonehearth Graveyard was taken by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9222,'The Stonehearth Graveyard is under attack!  If left unchecked, the Horde will capture it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9223,'The Stonehearth Graveyard was taken by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9224,'The Stonehearth Graveyard is under attack!  If left unchecked, the Alliance will capture it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9225,'The Iceblood Graveyard was taken by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9226,'The Iceblood Graveyard is under attack!  If left unchecked, the Horde will capture it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9227,'The Iceblood Graveyard was taken by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9228,'The Iceblood Graveyard is under attack!  If left unchecked, the Alliance will capture it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9229,'Tell me about mines.','Tell me about mines.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9230,'Tell me about graveyards.','Tell me about graveyards.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9231,'Tell me about towers.','Tell me about towers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9232,'There are two mines in Alterac: the Irondeep in Alliance territory and the Coldtooth mine in Horde territory.  Both mines are a rich source of minerals, and in the past were used to store excess supplies.$B$BNow, these mines are constantly fought over by the Horde, the Alliance and local denizens.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9233,'The towers and bunkers in Alterac Valley are vital strategic locales.  If we control a tower, then our troops can fire great distances from it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9234,'The graveyards in Alterac Valley are where the souls of the deceased find rest and succor.  If you die, then your spirit will drift to the closest graveyard that our side controls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9235,'Who controls the Stormpike Aid Station?','Who controls the Stormpike Aid Station?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9236,'Who controls the Frostwolf Relief Hut?','Who controls the Frostwolf Relief Hut?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9237,'Who controls the Iceblood Graveyard?','Who controls the Iceblood Graveyard?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9238,'The Stormpike Aid Station is in Dun Baldar, right outside the Dun Baldar barracks.$B$BThe Alliance currently controls it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9239,'The Stormpike Aid Station is in Dun Baldar, right outside the Dun Baldar barracks.$B$BThe Horde currently controls it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9240,'The Stormpike Aid Station is in Dun Baldar, right outside the Dun Baldar barracks.$B$BNeither side currently controls it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9241,'The Stonehearth Graveyard lies east of the Stonehearth Outpost in the Field of Strife.$B$BNeither side currently controls it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9242,'The Stormpike Graveyard is cut into the mountains, across the bridge east of Dun Baldar.$B$BNeither side currently controls it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9243,'The Frostwolf Graveyard is along the side of the road, not far north of Frostwolf Village.$B$BNeither side controls it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9244,'The Snowfall Graveyard lies high atop a hill in the Field of Strife, east of Winterax Hold.$B$BNeither side controls it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9245,'The Frostwolf Relief Hut lies in Frostwolf Keep, south of the Frostwolf Towers.$B$BThe Alliance currently controls it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9246,'The Frostwolf Relief Hut lies in Frostwolf Keep, south of the Frostwolf Towers.$B$BThe Horde controls it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9247,'The Frostwolf Relief Hut lies in Frostwolf Keep, south of the Frostwolf Towers.$B$BNeither side currently controls it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9248,'The Iceblood Graveyard is on the south side of the Field of Strife, east of the Iceblood Tower.$B$BThe Alliance currently controls it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9249,'The Iceblood Graveyard is on the south side of the Field of Strife, east of the Iceblood Tower.$B$BThe Horde currently controls it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9250,'The Iceblood Graveyard is on the south side of the Field of Strife, east of the Iceblood Tower.$B$BNeither side currently controls it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9251,'Who controls the Frostwolf Graveyard?','Who controls the Frostwolf Graveyard?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9252,'Who controls the Snowfall Graveyard?','Who controls the Snowfall Graveyard?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9253,'Look to this ravaged field and know the power that the elements hold, $r.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9254,'Who controls the Dun Baldar South Bunker?','Who controls the Dun Baldar South Bunker?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9255,'Who controls the Dun Baldar North Bunker?','Who controls the Dun Baldar North Bunker?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9256,'Who controls the Icewing Bunker?','Who controls the Icewing Bunker?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9257,'Who controls the Stonehearth Bunker?','Who controls the Stonehearth Bunker?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9258,'Who controls the West Frostwolf Tower?','Who controls the West Frostwolf Tower?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9259,'Who controls East Frostwolf Tower?','Who controls East Frostwolf Tower?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9260,'Who controls Tower Point?','Who controls Tower Point?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9261,'Who controls the Iceblood Tower?','Who controls the Iceblood Tower?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9262,'Who controls the West Frostwolf Tower?','Who controls the West Frostwolf Tower?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9263,'The Dun Baldar South Bunker protects the south and east flanks of Dun Baldar.$B$BIt is controlled by the Alliance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9264,'The Dun Baldar South Bunker protects the south and east flanks of Dun Baldar.$B$BIt is controlled by the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9265,'The Dun Baldar South Bunker protects the south and east flanks of Dun Baldar.$B$BIt is controlled by neither side.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9266,'The Dun Baldar North Bunker protects the eastern entrance to Dun Baldar.$B$BIt is controlled by the Alliance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9267,'The Dun Baldar North Bunker protects the eastern entrance to Dun Baldar.$B$BIt is controlled by the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9268,'The Dun Baldar North Bunker protects the eastern entrance to Dun Baldar.$B$BIt is controlled by neither side.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9269,'The Icewing Bunker holds the pass between Alliance territory and the Field of Strife.$B$BIt is controlled by the Alliance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9270,'The Icewing Bunker holds the pass between Alliance territory and the Field of Strife.$B$BIt is controlled by the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9271,'The Icewing Bunker holds the pass between Alliance territory and the Field of Strife.$B$BIt is controlled by neither side.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9272,'The Stonehearth Bunker protects the eastern flank of the Field of Strife.$B$BIt is controlled by the Alliance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9273,'The Stonehearth Bunker protects the eastern flank of the Field of Strife.$B$BIt is controlled by the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9274,'The Stonehearth Bunker protects the eastern flank of the Field of Strife.$B$BIt is controlled by neither side.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9275,'The West Frostwolf Tower protects the gate between Frostwolf Village and Frostwolf Keep.$B$BIt is controlled by the Alliance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9276,'The West Frostwolf Tower protects the gate between Frostwolf Village and Frostwolf Keep.$B$BIt is controlled by the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9277,'The West Frostwolf Tower protects the gate between Frostwolf Village and Frostwolf Keep.$B$BIt is controlled by neither side.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9278,'Tower Point East holds the pass between the Field of Strife and Horde territories to the south.$B$BIt is controlled by the Alliance.The East Frostwolf Tower protects the gate between Frostwolf Village and Frostwolf Keep.$B$BIt is controlled by the Alliance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9279,'Tower Point East holds the pass between the Field of Strife and Horde territories to the south.$B$BIt is controlled by the Horde.The East Frostwolf Tower protects the gate between Frostwolf Village and Frostwolf Keep.$B$BIt is controlled by the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9280,'Tower Point East holds the pass between the Field of Strife and Horde territories to the south.$B$BIt is controlled by neither side.The East Frostwolf Tower protects the gate between Frostwolf Village and Frostwolf Keep.$B$BIt is controlled by neither side.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9281,'Tower Point holds the pass between the Field of Strife and the Horde territories to the south.$B$BIt is controlled by the Alliance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9282,'Tower Point holds the pass between the Field of Strife and the Horde territories to the south.$B$BIt is controlled by the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9283,'Tower Point holds the pass between the Field of Strife and the Horde territories to the south.$B$BIt is controlled by neither side.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9284,'The Iceblood Tower protects the Iceblood Garrison from the southeast.$B$BIt is controlled by the Alliance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9285,'The Iceblood Tower protects the Iceblood Garrison from the southeast.$B$BIt is controlled by the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9286,'The Iceblood Tower protects the Iceblood Garrison from the southeast.$B$Bis controlled by neither side.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9287,'The West Frostwolf Tower protects the gate between Frostwolf Village and Frostwolf Keep.$B$BIt is controlled by the Alliance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9288,'The West Frostwolf Tower protects the gate between Frostwolf Village and Frostwolf Keep.$B$BIt is controlled by the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9289,'The West Frostwolf Tower protects the gate between Frostwolf Village and Frostwolf Keep.$B$BIt is controlled by neither side.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9290,'Tell me again about towers...','Tell me again about towers...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9291,'Tell me again about graveyards...','Tell me again about graveyards...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9292,'Tell me again about the mines...','Tell me again about the mines...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9293,'Tell me about something else...','Tell me about something else...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9294,'Captain Balinda Stonehearth has fallen!$B$BAttack the Horde!  Claim vengeance for Captain Stonehearth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9295,'The Horde Captain Galvangar is slain.  Defeat Drek\'Thar and victory will be ours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9296,'What do you know of it?','What do you know of it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9297,'I know much, listen and be educated, $r.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9298,'I am listening, Demitrian.','I am listening, Demitrian.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9299,'In the time before time, what the usurpers would later call the First Age of Creation, my master and his siblings ruled over this world. It was they, the Old Gods, who created all.$B$BAnd it was they who would ultimately be cast down by those that would call themselves Shapers.\n','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9300,'Continue, please.','Continue, please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9301,'Their manifest forms weak from eons of battle, imprisoned beneath the world - the world that they themselves created - the corruption of the Titan Shapers would permeate through the surface and befoul the Old Gods.$B$BIt was then and there that the brothers did turn. For five millennia a battle was fought at the core of this world.\n','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9302,'Both the Horde and Alliance captains have fallen!  Defeat Drek\'Thar before it\'s too late!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9303,'Both the Horde and Alliance captains have taken to the field.  Our Captain Balinda Stonehearth directs the Stormpike forces from the Stonehearth Outpost, and the enemy Captain Galvangar barks orders from within Iceblood Garrison.$B$BTo battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9304,'NO!!!  It puts the tannin in the basket, or it gets the mallet again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9305,'Both the Horde and Alliance captains have taken to the field.  Our Captain Galvangar directs the Frostwolves from Iceblood Garrison, and his rival, Captain Balinda Stonehearth, hides in her Stonehearth Outpost.$B$BThe battle has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9306,'The Stormpike general has fallen!  The battle is won!$B$BNow laugh as the Alliance scurries to recover its lost holdings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9307,'The battle rages, and both our captain and the captain of our enemy are slain!$B$BDrek\'Thar now leads us from Frostwolf Keep, and the dwarf Vanndar Stormpike hides deep in Dun Baldar.  Defeat Vanndar and claim victory for the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9308,'Captain Balinda Stonehearth is dead!  Defeat Vanndar and the battle will be ours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9309,'Captain Galvangar has been slain!  Honor our fallen captain, and unleash yourself again the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9310,'Tell me about Alterac Valley.','Tell me about Alterac Valley.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9311,'Alterac Valley has been home to the Frostwolf Clan for years; we will not let the dwarves and their Alliance trespass!  And so we battle!$B$BTo win back Alterac, defeat their general Vanndar Stormpike, in Dun Baldar.$B$BFor the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9312,'The Stormpikes uncovered ancient artifacts within Alterac Valley, but the Frostwolf orcs don\'t take kindly to explorers.  If the dwarves have to fight for knowledge of their ancestors, then so be it!$B$BTo win this battle, defeat the orc, Drek\'Thar, in Frostwolf Keep.  Fortune be with you, $c!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9313,'Captain Balinda Stonehearth leads the front line Alliance forces.  She is based in the Stonehearth Outpost, in the northern section of the Field of Strife.$B$BBalinda has not yet reentered the battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9314,'Captain Galvangar is the trusted aid to Drek\'Thar.  He leads the Horde forces from the Iceblood Garrison, in the southern section of the the Field of Strife.$B$BCaptain Galvangar has not yet entered the battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9315,'Vanndar Stormpike is the general of the Alliance military in Alterac, and directs his forces from Dun Baldar.$B$BIf he is defeated then the Alliance will surely lose the battle for Alterac.$B$BVanndar is not currently in Alterac Valley.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9316,'Drek\'Thar is the military and spiritual leader of the Frostwolf Clan in Alterac, leading his brethren from Frostwolf Keep.$B$BIf he is defeated then the Horde forces in Alterac will crumble.$B$BDrek\'Thar is not currently in Alterac Valley.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9317,'Tell me of Captain Balinda Stonehearth.','Tell me of Captain Balinda Stonehearth.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9318,'Tell me of Captain Galvangar.','Tell me of Captain Galvangar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9319,'Tell me of Vanndar Stormpike.','Tell me of Vanndar Stormpike.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9320,'Tell me of Drek\'Thar.','Tell me of Drek\'Thar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9321,'Tell me again about Alterac Valley...','Tell me again about Alterac Valley...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9322,'Captain Balinda Stonehearth leads the front line Alliance forces.  She is based in the Stonehearth Outpost, in the northern section of the Field of Strife.$B$BBalinda is currently in Stonehearth Outpost.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9323,'Captain Balinda Stonehearth leads the front line Alliance forces.  She is based in the Stonehearth Outpost, in the northern section of the Field of Strife.$B$BBalinda has been slain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9324,'Drek\'Thar is the military and spiritual leader of the Frostwolf Clan in Alterac, leading his brethren from Frostwolf Keep.$B$BIf he is defeated then the Horde forces in Alterac will crumble.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9325,'Drek\'Thar is the military and spiritual leader of the Frostwolf Clan in Alterac, leading his brethren from Frostwolf Keep.$B$BIf he is defeated then the Horde forces in Alterac will crumble.$B$BDrek\'Thar has been slain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9326,'Captain Galvangar is the trusted aid to Drek\'Thar.  He leads the Horde forces from the Iceblood Garrison, in the southern section of the the Field of Strife.$B$BCaptain Galvangar is currently in the Iceblood Garrison.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9327,'Captain Galvangar is the trusted aid to Drek\'Thar.  He leads the Horde forces from the Iceblood Garrison, in the southern section of the the Field of Strife.$B$BCaptain Galvangar has been slain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9328,'Vanndar Stormpike is the general of the Alliance military in Alterac, and directs his forces from Dun Baldar.$B$BIf he is defeated then the Alliance will surely lose the battle for Alterac.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9329,'Vanndar Stormpike is the general of the Alliance military in Alterac, and directs his forces from Dun Baldar.$B$BIf he is defeated then the Alliance will surely lose the battle for Alterac.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9330,'A battle?','A battle?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9331,'It was during the Elemental Sundering that the Firelord, Ragnaros, would seek to consume my Lord, Thunderaan, Prince of Air.$B$B<Demitrian bows his head, his face contorted in rage.>$B$BSpeak his name and I shall decorate this ravaged camp with your entrails. Be silent and listen.\n','',1,273,0,0,0,0,0,0,1,0,0,0,26124),
(9332,'<Nod>.','<Nod>.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9333,'It was the Lieutenants of Ragnaros, Geddon and Garr, who would perpetrate the betrayal against my Lord. Thunderaan was caught unaware.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9334,'Caught unaware? How?','Caught unaware? How?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9335,'The Firelord\'s advances were wholly unknown to Thunderaan. Before my Lord could react, Sulfuras, legendary hammer of Ragnaros, would strike an unmerciful blow. Thunderaan fell, utterly defeated.$B$BThe Firelord feasted upon the essence of my Lord, but was unable to consume him entirely.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(9336,'So what did Ragnaros do next?','So what did Ragnaros do next?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9337,'What little remained of Thunderaan\'s essence was stored within a talisman of elemental binding. Ragnaros then shattered the talisman in two flawless pieces. The pieces assigned to his Lieutenants...\n','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9338,'Dun Baldar is the strongest point of Alliance power in Alterac Valley.  Nestled in the northern reaches of the valley, Dun Baldar is the staging ground for all advances to the south.$B$BDun Baldar is intact.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9339,'Dun Baldar is the strongest point of Alliance power in Alterac Valley.  Nestled in the northern reaches of the valley, Dun Baldar is the staging ground  for all advances to the south.$B$BDun Baldar was razed and is under reconstruction.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9340,'Frostwolf Keep lies in the south corner of Alterac Valley and protects Frostwolf Village, home of orc clan of the same name.  All Horde territories in Alterac Valley stem from this one place of power.$B$BFrostwolf Keep is intact.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9341,'Frostwolf Keep lies in the south corner of Alterac Valley and protects Frostwolf Village, home of orc clan of the same name.  All Horde territories in Alterac Valley stem from this one place of power.$B$BFrostwolf Keep was razed and is under reconstruction.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9342,'Tell me of Dun Baldar.','Tell me of Dun Baldar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9343,'Tell me of Frostwolf Keep.','Tell me of Frostwolf Keep.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9344,'So, I found this shackle key...','So, I found this shackle key...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9345,'You found a key?  Well, is it THE key?  I mean, is it the key to unlock these shackles?  Well $G sir : ma\'am;, there is only one way to find out!','',6,21,0,0,0,0,0,0,1,0,0,0,26124),
(9346,'$n, I\'ll make sure all my friends in the Cartel know that you\'ve saved my life today.  Here - I\'m going to need to be able to travel light, so please help yourself to my cache of tailoring and leatherworking supplies!  Thanks again - see ya!','',2,1,1,0,0,0,0,0,1,0,0,0,26124),
(9347,'You big boss now!  You king!  All hail King $n, King of Gordok!$B$BNow that you da boss, all henchmen will give you tribute!  You left some alive, yeah boss?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9348,'OH NOES!  Da king is dead!  Uh... hail to da new king!  Yeah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9349,'If you want the key, you\'ll have to catch me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9350,'Do you want to play a game, stinky?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9351,'I hold the key to lands of free! Chase me and you\'ll see!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9352,'Game? Are you crazy?','Game? Are you crazy?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9353,'Chase me if you dare! I run without a care!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9354,'Still alive? You do surprise. Watch me as I flee!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9355,'Why you little...','Why you little...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9356,'Mark my words, I will catch you, imp. And when I do!','Mark my words, I will catch you, imp. And when I do!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9357,'Why would you ever want to harm me!? Come. Friends we can be!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9358,'Turn that frown upside down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9359,'DIE!','DIE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9360,'DIE?! You make Pusillin cry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9361,'This is the end of the line, no friend of mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9362,'Prepare to meet your maker.','Prepare to meet your maker.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9363,'Say hello to my little friends!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9364,'The demon is loose!  Quickly we must restrain him!','The demon is loose!  Quickly we must restrain him!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9365,'I\'m the new king?  What are you talking about?','I\'m the new king?  What are you talking about?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9366,'All henchmen of da boss - Stomper Kreeg, all three of da Guards, Captain Kromcrush, and da Observer - give tribute to da new boss.  If you kill a henchman, then that henchman can\'t give tribute!  Each one you keep alive will give you more tribute.  Keep all of them alive and you get da BIG tribute!$B$BYeah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9367,'Well then... show me the tribute!','Well then... show me the tribute!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9368,'Why should I bother fixing the trap?  Why not just eliminate the guard the old fashioned way?','Why should I bother fixing the trap?  Why not just eliminate the guard the old fashioned way?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9369,'Well, from what I\'ve gathered while waiting to be eaten by these yokels... it might not be necessary to kill every ogre you find here.$B$BThe ogres were going on and on the other day about how King Gordok came to power; specifically, he killed the previous king and took his place.  Well, the king\'s henchmen - those that Gordok spared - immediately swore fealty to the new king.$B$BWho knows - the ogre you save could very well be your own... figuratively speaking, of course!','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(9370,'','THIS EVENT IS WORKING.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9371,'You da boss now, yeah?  Long live da new king!$B$BKreeg let you look at Gordok hooch.  Ogre hooch best of all hooch, and Gordok hooch best of all ogre hooch!  Maybe you buy some from me, ya boss?!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9372,'Show me what hooch you\'ve got to sell, Kreeg.','Show me what hooch you\'ve got to sell, Kreeg.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9373,'What do you mean, buy?!  I\'m the king now... and it\'s good to be the king!','What do you mean, buy?!  I\'m the king now... and it\'s good to be the king!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9374,'%s begins to grow!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9375,'%s continues to grow!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9376,'%s has grown to full size!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9377,'OK boss, when you ready for da tribue from your henchmen, you let me know!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9378,'Apply the Gordok war paint!','Apply the Gordok war paint!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9379,'','Leave this place, stranger, lest it consume you as it has all that it has touched.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9380,'What happened here, spirit?','What happened here, spirit?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9381,'','Do you know of the Highborne? The Shen\'dralar?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(9382,'I know very little of the Highborne and nothing of the Shen\'dralar.','I know very little of the Highborne and nothing of the Shen\'dralar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9383,'','The Shen\'dralar were Queen Azshara\'s most revered arcanists. It was within these very walls that the Queen\'s most important demands were processed - often in secret.$B$BAfter the destruction of the Well and the subsequent lethargy that overcame the Highborne and lesser night elf sects, the Prince of Eldre\'Thalas, Tortheldrin, began construction of the pylons that you see littering the halls of the west wing.\n',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(9384,'','The Prince plotted to imprison a demon of immense power behind a grand force field. The pylons would channel latent energies into the field, keeping it operational.$B$BWhile imprisoned, Immol\'thar would serve as a battery to the populace of Eldre\'Thalas.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9385,'Continue, please.','Continue, please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9386,'Fascinating. Continue, please.','Fascinating. Continue, please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9387,'','The siphoned energies would sustain the Highborne\'s magic, allowing those within the walls of Eldre\'Thalas to feed their endless and growing magical pangs.$B$BThousands of years passed and the power required to keep Immol\'thar imprisoned while sustaining life within Eldre\'Thalas, began to shift. The cost to keep Immol\'thar bound grew to overshadow the rate at which energy could be siphoned and distributed. The once net gain turned to loss.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(9388,'I\'m going to have to kill something, aren\'t I?','I\'m going to have to kill something, aren\'t I?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9389,'','The Highborne ghosts that you see wandering through the courtyard and halls of Eldre\'Thalas were slain, not by invading Gordok ogres or satyrs, but by the Prince himself!',1,1,5,0,0,0,0,0,1,0,0,0,26124),
(9390,'We live in a world of endless tragedy.','We live in a world of endless tragedy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9391,'','The people were destroyed in order to preserve the Prince\'s immortal life and near limitless powers. The power once divided among thousands now funnels into the Prince and the Shen\'dralar zealots. Those few remaining survivors are directly feeding power into the pylons in order to keep Immol\'thar imprisoned.$B$BShould the demon break free of its bonds, it would surely destroy what little is left of this once great bastion of arcana.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(9392,'A very sad tale. Thank you, spirit.','A very sad tale. Thank you, spirit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9393,'You da man now, dog!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9394,'I am, am I?  Well what have you got for the new big dog of Gordok, Fengus?','I am, am I?  Well what have you got for the new big dog of Gordok, Fengus?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9396,'Fengus make you fierce!  Crazed!  RAR!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(9397,'You got me good boss!  How you get by Slip\'kik??  I smart though, I watch next time!  Har har!$B$BNobody get by Slip\'kik no more. Slip\'kik promise!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9398,'Yeah, you\'re a real brainiac.  Just how smart do you think you are, Slip\'kik?','Yeah, you\'re a real brainiac.  Just how smart do you think you are, Slip\'kik?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9399,'I show you how smart I am, boss!  You be extra smart with mighty magic mojo now!$B$BUm... maybe Slip\'kik use magic on self. Dat would be good idea...','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(9400,'You are da king of the Gordok!  You\'re A-number-one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9401,'Call me \"Boss\".  What have you got for me!','Call me \"Boss\".  What have you got for me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9402,'I heard you was dead... well, you won\'t be easy to make dead after this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9403,'Hey Knot - I\'m a Leatherworker.  Think you could teach me how to make the ogre suit?','Hey Knot - I\'m a Leatherworker.  Think you could teach me how to make the ogre suit?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9404,'Hey Knot - I\'m a Tailor.  Think you could teach me how to make the ogre suit?','Hey Knot - I\'m a Tailor.  Think you could teach me how to make the ogre suit?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9405,'I suppose I can teach that to you.  You\'ll probably only be able to find ogre tannin here, but the other things you can find most anywhere!','',273,1,0,0,0,0,0,0,1,0,0,0,26124),
(9406,'For 10,000 years I have ruled this kingdom. In that time, I have heard many fascinating tales from those that would walk the hallowed grounds of the House of Shen\'dralar.$B$BAs I am bound to this place, I often exchange stories with visitors. Do you have a story for me or perhaps you would like to hear a story?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9407,'Who dares disrupt the sanctity of Eldre\'Thalas? Face me, cowards!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9408,'We mustn\'t anger the Master. His is a wrath that is cruel beyond measure.','We mustn\'t anger the Master. His is a wrath that is cruel beyond measure.',1,274,0,1,2,0,0,0,1,0,0,0,26124),
(9409,'Keep your voice down, stranger. You do not want to disrupt the Master\'s meditations.','Keep your voice down, stranger. You do not want to disrupt the Master\'s meditations.',20,0,0,0,0,0,0,0,1,0,0,0,26124),
(9410,'Many have come to this sanctuary, few have left. ','Many have come to this sanctuary, few have left. ',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9411,'Yar, he\'s dead all right.  That makes you da new king... well, all of you!  Gordok is yours now, boss!  You should talk to me so you can learn everything there is about being da king!  I was... is his assistant!  Yeah, that\'s why I\'m called da crafty one!','',4,1,1,0,0,0,0,0,1,0,0,0,26124),
(9412,'The Lorekeeper is an ancient. He has served under our glorious Queen!','The Lorekeeper is an ancient. He has served under our glorious Queen!',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(9413,'%s lets out a deep roar, alerting nearby allies and becoming enraged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9414,'%s goes into a drunken rage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9416,'Hey, who Fengus callin\' a gnoll lover?!  Take da prisoners to da king; you smart to bring them with their weapons and show da king that they a threat.  I\'ll go see if Fengus talk smack when I give him da beatdown!  HAR!','',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(9418,'No one get past me and threaten da king!  Ungh, take it!!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(9419,'What you doin\' wanderin\' around here?  Why them small fries not in da shackles?!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(9420,'You da strong one now!  All hail to da new king of da Gordok!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(9421,'Um, I\'m taking some prisoners we found outside before the king for punishment.','Um, I\'m taking some prisoners we found outside before the king for punishment.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9422,'Do I see them with weapons still?  Why you let them keep their weapons?!','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(9423,'Er... that\'s how I found them.  I wanted to show the king that they were a threat!  Say Captain... I overheard Guard Fengus calling you a fat, useless gnoll lover!','Er... that\'s how I found them.  I wanted to show the king that they were a threat!  Say Captain... I overheard Guard Fengus calling you a fat, useless gnoll lover!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9424,'OK Fengus, where you at?!  You come call me a gnoll lover while I give you da hammer upside da head!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(9425,'Ashes to ashes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9426,'BY FIRE BE PURGED!','',0,0,0,0,0,0,0,0,7,0,8046,0,26124),
(9427,'TASTE THE FLAMES OF SULFURON!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9428,'','Here are the orders, $n.  Take them quickly to Warmaster Garrick!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(9429,'Here are the orders, $n.  Now, take them quickly to Field Marshal Teravaine!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9431,'Tharnariun, I have lost the trap. Could you please give me another?','Tharnariun, I have lost the trap. Could you please give me another?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9432,'Where is Field Marshal Teravaine?','Where is Field Marshal Teravaine?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9433,'Where is Warmaster Garrick?','Where is Warmaster Garrick?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9434,'When our supplies are high, Field Marshal Teravaine is stationed in the Field of Strife, at our southernmost ballista emplacement.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9435,'','When our supplies are high, Warmaster Garrick is stationed in the Field of Strife at a catapult, north of Iceblood Garrison.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(9436,'Where is the Frostwolf Quartermaster?','Where is the Frostwolf Quartermaster?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9437,'Where is the Stormpike Quartermaster?','Where is the Stormpike Quartermaster?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9438,'The Stormpike Quatermaster keeps his supplies under an awning, just west of here.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9439,'','The Frostwolf Quartermaster is southwest of this bunker.  Enter the bunker and then exit on the right, you\'ll see the quartermaster a short way down the path.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(9440,'Henchmen?  Tribute?','Henchmen?  Tribute?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9441,'It\'s good to be the king!  Now, let\'s get back to what you were talking about before...','It\'s good to be the king!  Now, let\'s get back to what you were talking about before...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9442,'Um, you kill king, yeah?  That means you take his place.  That make you da new boss!  Hail to da king!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9443,'','Oh the horror! The tragedy! We are on the verge of a breakthrough, yet all could be lost.',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(9444,'Uh... I sorry I attack you boss.  You no kill me, please OK!?  You da king now, and I help make your tribute better!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9445,'A cursory examination of the skeletal remains indicates that the flesh was seared off. Quite a grisly sight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9446,'I very much doubt that he will have anything to say, stranger...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9447,'I personally didn\'t mind him. It was the Prince who took exception to a high elf in his domain. Alas, I am not one to question the Prince. In his defense, he did not incinerate Master Winthalus immediately.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9448,'We most definitely do not need anymore attention drawn to us, stranger. Return to those that sent you in search of the lost master and tell them that nothing could be found. When this is done - and I will know when it is so - return and I shall reveal the secrets of the deceased.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9449,'Mourn the great loss.','Mourn the great loss.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9450,'Our forces are poised for battle, and eager to spill the blood of the Alliance.  Soon our captain will enter Iceblood Garrison and the war will begin anew!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9451,'So, now that I\'m the king... what have you got for me?!','So, now that I\'m the king... what have you got for me?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9452,'Maybe you do better at getting back prized Gordok relic from creepy Highborne prince than da old boss did!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9453,'So... you wouldn\'t happen to have a chest around here that has, let\'s say, a gauntlet that the Gordok ogres consider to be a priceless artifact?','So... you wouldn\'t happen to have a chest around here that has, let\'s say, a gauntlet that the Gordok ogres consider to be a priceless artifact?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9454,'Even if I did, fool, do you think I\'d just let you take it from me?  The only way you\'d ever get it - if I did possess it - is to pry it from my cold, dead fingers.$B$BThat, my little friend, will not be happening any time soon.','',6,274,0,0,0,0,0,0,1,0,0,0,26124),
(9455,'Hail to da new king!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9456,'When I scowled at you before you became da new king... um... I was just joking.$B$BYeah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9457,'Dem other ogres was dumb to attack you, boss!  Dat\'s why I\'m still alive - I\'m smart and stuff!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9458,'We a lot cleaner than da ogres in Tanaris.  All over da desert as far as da eye can see - ogre poo.  Not here, no $g sir : ma\'am;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9459,'So long as you stay here with us, you da king.  You take off, and some other ogre will take your place.  That\'s da way of da Gordok!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9460,'I am so smart!  S-M-R-T!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9461,'Old king got dead?  That\'s unpossible!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9462,'I cause you no trouble, boss.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9463,'Oh dear, where is the \"Codex of Defense?\" Lydros will be most assuredly displeased.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9464,'%s sighs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9465,'\"The Arcanist\'s Cookbook\" is also gone! This is a disaster!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9466,'Books have been disappearing as of late. The Lorekeeper and his assistants are in a frenzy. They suspect foul play within Eldre\'Thalas.','Books have been disappearing as of late. The Lorekeeper and his assistants are in a frenzy. They suspect foul play within Eldre\'Thalas.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9467,'Has the Prince recanted the tale of the Ashbringer? It is our most favorite of his stories. His favorite is the followup to the Ashbringer. Of course, nobody has ever been able to get that story out of him.','Has the Prince recanted the tale of the Ashbringer? It is our most favorite of his stories. His favorite is the followup to the Ashbringer. Of course, nobody has ever been able to get that story out of him.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9468,'I suspect that the imps are stealing knowledge.','I suspect that the imps are stealing knowledge.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9469,'The Master holds great interest in the lair of Nefarian. If only someone would defeat the dragon and his minions and retell the tale to the Prince. I bet that would loosen the Prince\'s lips. The Ashbringer could be found!','The Master holds great interest in the lair of Nefarian. If only someone would defeat the dragon and his minions and retell the tale to the Prince. I bet that would loosen the Prince\'s lips. The Ashbringer could be found!',1,1,5,0,0,0,0,0,1,0,0,0,26124),
(9470,'If you not talk to Mizzle, you not become da king!  Talk to Mizzle da Crafty!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9471,'So... you took out the King eh?  I knew that these bozos would make you the new king, I just knew it!  That\'s all these bozos understand - power.$B$BIt would seem that the more henchmen you keep alive, the higher your tribute will be.  Not to shabby - makes for an interesting challenge I\'d say.  If you leave, I wouldn\'t expect to remain king.  One of these yokels will no doubt step up and take your place.$B$BOne more thing... you didn\'t happen to find my key, did you?','',1,5,1,0,0,0,0,0,1,0,0,0,26124),
(9472,'The king is dead - OH NOES!  Summon Mizzle da Crafty!  He knows what to do next!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9473,'What you must understand is that being able to index 10,000 years of existence has given me a rather unique perspective on life. Your present day trials and tribulations are meaningless.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9474,'Oh the drama and fuss the young Master exerted. You would think the fate of the world rested squarely on his shoulders. Only mortals could have such a skewed perspective on our world.$B$BAlas, he left me with his meager magical secrets... Librams or some such nonsense. I have no use for these paultry magics but perhaps you might be interested in their enchantments.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9475,'Where is \"Garona: A Study in Stealth and Treachery!\" These texts must be returned! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9476,'They\'ve been stolen, $r! Three of our most prized volumes. Should you return the tomes, a reward will most certainly be yours.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9477,'%s begins to retaliate all attacks against him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9478,'Help me crush these punys!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9479,'I guess so!','I guess so!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9480,'This sounds like a task worthy of the new king!','This sounds like a task worthy of the new king!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9481,'You no challenge me, scrubs!  I\'m da king now, and I stay king FOREVER!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9482,'Doh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9483,'<You cannot comprehend any of the technical mumbo jumbo on this scroll.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9484,'<Drawn out on this parchment is the schematic for a field repair robot.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9485,'<Copy the schematic into your engineering notebook.>','<Copy the schematic into your engineering notebook.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9486,'<The complicated schematics are too much for your meager engineering talents to discern.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9487,'<You are well versed in the creation and function of this robot.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9488,'The fabric of which our world is woven is most delicate. It merely takes some knowledge and the application of said knowledge to tear the fabric. It is thusly that rifts are born. ','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9489,'%s senses your presence and opens a nether portal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9490,'Cho\'Rush die! NOW YOU DIE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9491,'People of da Horde, citizens of Orgrimmar, come an\' gather round an\' celebrate a hero of da  Horde. On dis day, $n laid a mortal blow against da Black Dragonflight. Da brood mother, Onyxia, been slain!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(9492,'Bear witness to da undeniable power of ya Warchief! Be lifted by da rallying cry of da dragon slayers!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(9493,'Gaze upon the enemy, $r. See what the might of the Horde reduces even the most powerful of dragons to! All that oppose us shall meet a similar fate!','',1,1,5,0,0,0,0,0,1,0,0,0,26124),
(9494,'We be horde, all of us. Tauren, orc, troll, an\' all da rest. Never forget dat we in dis together.','',1,15,0,0,0,0,0,0,1,0,0,0,26124),
(9495,'Citizens and allies of Stormwind, on this day, history has been made. $n has laid waste to that which had attempted to usurp the rule of the kingdom. Gather round and join me in honoring our heroes.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9496,'Behold the might of the Alliance! The dread lady, Onyxia, hangs from the arches! Let the rallying cry of the dragon slayer lift your spirits!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9497,'I live only to serve our King.','',1,2,0,0,0,0,0,0,1,0,0,0,26124),
(9498,'Perhaps one day, your contributions to the Alliance will be as great as the heroes you have seen this day. Honor them, $n.','',1,25,0,0,0,0,0,0,1,0,0,0,26124),
(9499,'You honor us with your presence, my $glord:lady;.','',1,2,0,0,0,0,0,0,1,0,0,0,26124),
(9500,'That will teach you to lay off the herb, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9501,'Holy Cow!  That is Mushgog down there in The Maul.','Holy Cow!  That is Mushgog down there in The Maul.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9502,'Look at that!  Someone is fighting Mushgog!','Look at that!  Someone is fighting Mushgog!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9503,'Can that be The Razza down there in the Maul?  This is going to be exciting!','Can that be The Razza down there in the Maul?  This is going to be exciting!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9504,'Woohoo! They are into it now!','Woohoo! They are into it now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9505,'The Razza just made more fertilizer for Mushgog!','The Razza just made more fertilizer for Mushgog!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9506,'It\'s time for the main event!  Skarr the Unbreakable is in the Maul!','It\'s time for the main event!  Skarr the Unbreakable is in the Maul!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9507,'Looks like Skarr has found his next challenger!  Wouldn\'t want to be in that poor fool\'s shoes!','Looks like Skarr has found his next challenger!  Wouldn\'t want to be in that poor fool\'s shoes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9508,'Down goes Frazier!  Down goes Frazier! Down goes...huh?  That wasn\'t Frazier?','Down goes Frazier!  Down goes Frazier! Down goes...huh?  That Wasn\'t Frazier?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9509,'10,000 years of recorded knowledge tends to draw the wrong element to the Athenaeum. Books are stolen, recovered and stolen again on a daily basis.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9510,'','Kildrath tends to overdramatize the situation. For example, \"Garona: A Study on Stealth and Treachery,\" has been stolen over 400 times.$B$BThe mark of the Athenaeum protects the tomes, preventing any unauthorized viewings.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9511,'','%s sighs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9512,'','When will they learn?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9513,'','Imbecile! Have you not learned the Dewey Decimal System? It has been 3,000 years since you began working for us! Incompetent buffoon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9514,'%s grumbles.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9515,'I will not be lured from this place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9516,'<Lydros reaches into his robe and presents you with a dull, flat elven blade.>$B$BIn ages past, well before even the War of the Ancients, there existed this blade.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9517,'Fascinating, Lorekeeper. Continue please.','Fascinating, Lorekeeper. Continue please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9518,'The blade itself had to be crafted in ceremony with the children of the Aspects. A rare occurrence indeed... For not only would a dragon have to willingly heat and mold the enchanted metal with their breath, they would also need to contain the fury of their own enchantment by using their blood as temper.\n','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(9519,'(Continue.)','(Continue.)',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9520,'Over the course of 8,000 years, only a handful of these blades were created - each blade unique in both power and appearance. The blades of Quel\'Serrar would take on the characteristics of their creator.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9521,'(Continue.)','(Continue.)',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9522,'Rumors exist of a single, legendary blade of Quel\'Serrar crafted for an unknown entity by the combined might of the five Aspects. Before the abominations of Nefarian and Deathwing were thrust into our world, such meetings of the Aspect were represented by the term \'Prismatic.\' I could only assume that the Prismatic Blade of Quel\'Serrar was a most glorious creation.\n','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9523,'(Continue.)','(Continue.)',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9524,'What I offer to you now is one such blade, unfired, unheated, untreated - the most raw and basic form.$B$BNow you merely need to find a dragon that will willingly enchant the blade.$B$BIf you had an eternity to live, this might be a possibility; but since you are mortal and could very likely cease to exist at any moment, might I recommend trying to persuade one of the lesser dragons to do your bidding. ','',1,1,6,0,0,0,0,0,1,0,0,0,26124),
(9525,'Eh?','Eh?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9526,'Have you heard of the brood mother of the Black Flight? I believe she is called Onyxia...','',6,273,0,0,0,0,0,0,1,0,0,0,26124),
(9527,'Maybe... What do I do now?','Maybe... What do I do now?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9528,'I have no time for interruptions.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9529,'Lexlort, I lost the thorium shackles.','Lexlort, I lost the thorium shackles.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9530,'Nathanos, I have lost the rotten apple. I require another.','Nathanos, I have lost the rotten apple. I require another.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9531,'Can I help you?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(9532,'I\'ve lost the cure, Doc! Tell me you got more!!!','I\'ve lost the cure, Doc! Tell me you got more!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9533,'Serge I have lost the cure to the Touch of Zanzil! HELP!','Serge I have lost the cure to the Touch of Zanzil! HELP!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9534,'Have you ever heard of a place called Dire Maul?','Have you ever heard of a place called Dire Maul?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9535,'Aye, but I know it by its true name - Eldre\'Thalas.  It was a bastion of magical power for the night elves many, many years ago.$B$BYou know of Eldre\'Thalas, young one?  One might say that is coincidental to my current plight... but I am one not to believe in coincidence.','',273,1,0,0,0,0,0,0,1,0,0,0,26124),
(9536,'Why do you say that this is a coincidence, Rabine?','Why do you say that this is a coincidence, Rabine?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9537,'Agents of the Cenarion Circle have uncovered disturbing information pertaining to the current situation in Eldre\'Thalas.  I am at an impasse as to what to do about it, and I will no doubt soon seek the aid of able bodied beings capable of handling themselves in a fight.$B$BTo properly take action in Eldre\'Thalas, however, is to understand the lore of an object known as the Fruit of Fertility.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9538,'The Fruit of Fertility?','The Fruit of Fertility?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9539,'In ages past, Eldre\'Thalas was a nexus of magical power, and those who dwelt within its hallowed halls wielded immense power.  One such night elf was Millicent Serene - a naturalist who willed the power of nature itself into potent artifacts she forged.$B$BThe Fruit of Fertility was her crowning achievement... she used a specially prepared moonwell to grow an exotic and vibrant vine that was imbued with an aura of protection and growth.  All of Eldre\'Thalas flourished from its existence.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9540,'But something went wrong, didn\'t it?','But something went wrong, didn\'t it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9541,'Alas, it always seems like it does.  I - as did the rest of the Cenarion Circle - had assumed that Milli\'s creation was destroyed during the War of the Ancients.  This, as I have come to learn, is far from correct.$B$BThe Fruit of Fertility survived... though now it is known as the Felvine.  It is being corrupted by the demonic lord of that section of Eldre\'Thalas, Alzzin the Wildshaper.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9542,'What would happen if the Fruit of Fertility - or the Felvine - was allowed to be fully corrupted?','What would happen if the Fruit of Fertility - or the Felvine - was allowed to be fully corrupted?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9543,'I... cannot begin to imagine, $n.  All I know is that I am not going to allow it to happen.  It will be destroyed - if not for our continued safety from demonic taint, then for the memory of Millicent Serene... Milli...$B$BThis, my friend, this is where I hope you will come in.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9544,'What would you have me do, Rabine?','What would you have me do, Rabine?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9545,'Speak with me, $n - if you are willing, the Cenarion Circle would eagerly accept your generous offer of aid.  The threat posed by the Felvine of Eldre\'Thalas is indeed dire.','',273,1,0,0,0,0,0,0,1,0,0,0,26124),
(9546,'<Demitrian falls to his knees.>$B$BYou have recovered my Master\'s eternal prison!$B$BOh long have I waited for this day and finally, it is realized.$B$BHe must be released!','',16,20,0,0,0,0,0,0,1,0,0,0,26124),
(9547,'What must be done?','What must be done?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9548,'I hold the vessel of his rebirth. Should you be prepared to take on this task, you will be required to fortify the vessel and ultimately, break the hold of Ragnaros himself!','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9549,'The Firelord and all who dare stand in my way shall reel from my wrath.','The Firelord and all who dare stand in my way shall reel from my wrath.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9550,'The vessel of rebirth must be fortified with elementium. I know of only one source of the mineral: the elemental planes, at the core of our world.$B$BThere is one, an Earthshaper, who may know more than I about the acquisition of such things. You must find this Earthshaper!','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9551,'Greetings and salutations, hero!  I have the latest news from both continents and points beyond for your consideration.','Greetings and salutations, hero!  I have the latest news from both continents and points beyond for your consideration.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9552,'I shall scour the earth for this Earthshaper. What of the essence?','I shall scour the earth for this Earthshaper. What of the essence?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9553,'The corporeal form of Ragnaros must be destroyed. From the remnants, his essence shall emerge. In this weakened state, Ragnaros\' grip on the prison of Thunderaan is loosed. The essence itself acting as a key...','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9554,'Give me the vessel, Highlord.','Give me the vessel, Highlord.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9555,'You will need to find Nat Pagle in Dustwallow Marsh to get any better than you are currently.','You will need to find Nat Pagle in Dustwallow Marsh to get any better than you are currently.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9556,'You will need to find Nat Pagle in Dustwallow Marsh to get any better than you are currently.','You will need to find Nat Pagle in Dustwallow Marsh to get any better than you are currently.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9557,'I can teach you fishing skills.','I can teach you fishing skills.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9558,'Your challenge has failed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9559,'Where can I go to improve my lockpicking?','Where can I go to improve my lockpicking?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9560,'Bluegill Marsh north of Menethil Harbor in the Wetlands holds many locked boxes from the wrecks offshore that have washed ashore.','Bluegill Marsh north of Menethil Harbor in the Wetlands holds many locked boxes from the wrecks offshore that have washed ashore.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9561,'The waters of northern Sar\'theris Strand in Desolace or the Angor Fortress in Badlands have locked boxes that can be picked open.','The waters of northern Sar\'theris Strand in Desolace or the Angor Fortress in Badlands have locked boxes that can be picked open.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9562,'The Pool of Tears in the Swamp of Sorrows holds ancient locked boxes that were lost in another age.','The Pool of Tears in the Swamp of Sorrows holds ancient locked boxes that were lost in another age.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9563,'The Dark Iron dwarves of the Slag Pit in Searing Gorge have a great number of locked boxes.','The Dark Iron dwarves of the Slag Pit in Searing Gorge have a great number of locked boxes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9564,'Both Lost Rigger Cove in Tanaris and the Bay of Storms in Azshara have boxes that can be picked to improve your skill.','Both Lost Rigger Cove in Tanaris and the Bay of Storms in Azshara have boxes that can be picked to improve your skill.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9565,'The Scarlet Crusade of Tyr\'s Hand in the Eastern Plaguelands have many lockboxes that will challenge your skill.','The Scarlet Crusade of Tyr\'s Hand in the Eastern Plaguelands have many lockboxes that will challenge your skill.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9566,'Many locked boxes of supplies were sunk by the orcs in Lake Everstill in Redridge.','Many locked boxes of supplies were sunk by the orcs in Lake Everstill in Redridge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9567,'Many locked supply boxes were lost when the Naga overran the Zoram Strand in Ashenvale.','Many locked supply boxes were lost when the Naga overran the Zoram Strand in Ashenvale.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9568,'The Venture Company based around Windshear Crag in Stonetalon keeps their supplies in locked boxes.','The Venture Company based around Windshear Crag in Stonetalon keeps their supplies in locked boxes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9569,'The Syndicate keeps many locked boxes of supplies in Durnholde Keep in Hillsbrad.   ','The Syndicate keeps many locked boxes of supplies in Durnholde Keep in Hillsbrad.   ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9570,'Well done, servant. For so long I have been held captive within the prison of the Firelord. I am once more free to feast upon the out world! The land shall once more be ravaged by the force of the Wind Seeker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9571,'Ah, and the fool who freed me shall be among the first to quell my immense hunger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9572,'My power is discombobulatingly devastating! It is ludicrous that these mortals even attempt to enter my realm!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9573,'<Demitrian laughs.>$B$BYour reward is a quick and painful death, fool!','',11,1,0,0,0,0,0,0,1,0,0,0,26124),
(9574,'Summon forth your cowardly master, fool! Let him face me!','Summon forth your cowardly master, fool! Let him face me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9575,'I study the known and unknown elements of our world.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9576,'Are you the Earthshaper capable of creating Elementium?','Are you the Earthshaper capable of creating Elementium?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9577,'Elementium? I have not heard that word uttered from the mouth of a mortal in decades.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9578,'What do you know of it, Franzahl?','What do you know of it, Franzahl?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9579,'A former student of mine by the name of Krixix spent a lifetime attempting to make contact with the chained Gods of the underworld. He pursued that which would spring up from the ravaged earth... That which would form only as a result of the elements clashing in titanic conflict.$B$BElementium as it would be known to mortals.$B$BOne day, nearly a decade ago, Krixix\'s pursuit lead to a fissure forming in this very gorge.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9580,'A fissure?','A fissure?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9581,'Aye, he had done what was thought to be impossible. Out from the fissure sprung an agent of Therazane!$B$BFrom my vantage point, I could see the goblin holding conversation with the agent of the Old God. What happened after that was terrible...','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9582,'So what happened?','So what happened?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9583,'The fissure closed and Krixix was gone! Swallowed whole!$B$BBe warned, $r, what you wish for could very well become that which you do not want. You play with beings and arcana that are older than time itself!$B$BShould Krixix be alive and should he have the information which you seek, you can be certain that he will not give up said information. He has faced terrors far worse than you could ever dream to perpetrate.','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(9584,'There comes a time when the life we know falls short.  We are trapped and look for answers, and we find hope burning in dark places.$B$BOnly then, $n, do we take our first steps to freedom.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9585,'Do you have any spiders or beetles, $c?  They scurry fast, but if you\'re faster then you\'ll find them quite a treat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9586,'Gorzeeki, I wish to make a purchase.','Gorzeeki, I wish to make a purchase.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9587,'Did you just come out of a dungeon?  Did you get me anything?','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(9588,'Your armor looks scary.  Are you scary too?','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(9589,'I cannot permit you to enter the Temple!  I must destroy you for your own good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9590,'A sacrifice will be due if I am ever called upon, mortal...','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(9591,'If I fall into the abyss, I\'ll take all of you mortals with me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9592,'%s flee as the controlling power of the orb is drained.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9593,'When I grow up, I wanna be the king of Stormwind!','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(9594,'I\'ve been to Ironforge before.  It smells funny there.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(9595,'Mushrooms always grow in damp places and so they look like umbrellas.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(9596,'If overalls are held up by the snaps at the top, then why do they have belt loops?','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(9597,'What happens if your snot freezes in your nose?','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(9598,'Do fish ever get thirsty?','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(9599,'If you try to fail and succeed, what did you just do?','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(9600,'If you\'re a real hero of the Horde, then I wanna see you fight a dragon!  Yeah!','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(9601,'When lightning strikes the ocean why don\'t all the fish die?','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(9602,'Would a fly without wings be called a walk?','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(9603,'I have a rock in my nose.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(9604,'If a turtle doesn\'t have a shell, is he homeless or naked?','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(9605,'What does \"zug zug\" mean?','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(9606,'If your glove is too big, does it still fit like a glove?','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(9607,'You are certainly a long way from home, $r.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9608,'I have come to learn, Daio.','I have come to learn, Daio.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9609,'So, you have found me. I suppose that you have come to learn of suppression and control.$B$BI will teach you much more than that... you will also learn of sacrifice.$B$B<Daio grins.>','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9610,'What would I sacrifice?','What would I sacrifice?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9611,'That will be the choice of the demon you wish to conjure and enslave. We wield dark powers and we pay grossly for the use of said powers.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9612,'How can I conjure a demon?','How can I conjure a demon?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9613,'We must first craft a prison to confine the beast, if you wish to progress further.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9614,'I have regained control! Everyone - back to your posts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9615,'This is it, Impsy. I can feel it! This is the big one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9616,'Brace yourself for the glorious impact, Impsy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9617,'Kick me out, will they!? I\'ll show those uptight cone heads in Stormwind the true power of Niby! BEHOLD!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9618,'%s shakes his fist in frustration.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9619,'Niby, you are stupid.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9620,'Oh my, what a surprise! Another failure!? But how, oh great one??','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9621,'Awe inspiring, master. Your ineptitude is awe inspiring.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9622,'Why you little!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9623,'Ack! Help! Crazed gnome trying to kill me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9624,'Bow in my presence, insect! Surely you can feel the power I hold over you.','',5,15,0,0,0,0,0,0,1,0,0,0,26124),
(9625,'I am in search of a great and powerful Warlock.','I am in search of a great and powerful Warlock.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9626,'So you have come to Niby to learn the secrets of calling down an infernal servant from the Nether.$B$BSilence! Niby knows all!$B$BNiby is not so quick to part with such knowledge. First, you must assist Niby with a very important task.','',6,1,273,0,0,0,0,0,1,0,0,0,26124),
(9627,'What task?','What task?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9628,'There is a powerful infernal named Kroshius northeast of this camp. It is why Niby is here. Kroshius is a greater infernal - an infernal that has lasted longer than expected. You see, nub, an infernal crashes down into the earth with great intensity to serve its master but this intensity fades fast. Once the blazing flames have died down, the infernal crumbles.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(9629,'This is all very interesting but what is it that you want?','This is all very interesting but what is it that you want?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9630,'Do not interrupt Niby, fool! I shall rend the flesh from your bones and use your skeletal remains as a coat rack. Now where was I? Oh yes, so, Kroshius lasted nearly ten times longer than any ordinary infernal. I am not sure why but I am confident that with enough study, I could find out.$B$BI need you to recover Kroshius\' Infernal Core.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(9631,'How do I do that?','How do I do that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9632,'If I am to teach you the secrets of summoning an infernal servant, you must destroy Kroshius and bring me the infernal core from his burning remains. This, however, is not as easy as it sounds. Kroshius has all but burned out completely. You must reignite his corpse and raise him from the rubble. To do this, however, you must gather some components from other demonic entities.$B$BMy imp, Impsy, shall set you on your way.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(9633,'Kroshius live? Kroshius crush!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9634,'Stand back! Stand clear! The infernal will need to be given a wide berth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9635,'BOW DOWN TO THE ALMIGHTY! BOW DOWN BEFORE MY INFERNAL DESTRO... chicken?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9636,'%s rolls on the floor laughing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9637,'Niby, you\'re an idiot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9638,'Silence, servant! Vengeance will be mine! Death to Stormwind! Death by chicken!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9639,'A Sulfuron ingot?!??! Impossible! I must have it! I must! I must!$B$B$R, I am authorized to make you a grand deal for that ingot. Perhaps you would be interested to know the secrets of the Hand of Ragnaros? Sulfuras, idiot! The legendary hammer of the Firelord.','',5,5,6,0,0,0,0,0,1,0,0,0,26124),
(9640,'Hrm, I\'m listening. What is this offer?','Hrm, I\'m listening. What is this offer?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9641,'In exchange for one Sulfuron Ingot, I am authorized to grant you one copy of the plans to forge a Sulfuron hammer.$B$BNow an adventurer like yourself is probably thinking to $g himself:herself;, \"What would I ever need a hammer like that for when what I already own is far superior?\"$B$BWell let me tell you something, $g mister:missy;, there ain\'t nothing more superior than what the Sulfuron hammer can become!','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9642,'You\'ve got my attention.','You\'ve got my attention.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9643,'You see, all you gotta do is forge the Sulfuron hammer and find yourself the Eye of Sulfuras. Combine the Eye of Sulfuras with the Sulfuron hammer and it will become Sulfuras! Now I\'m not going to bog you down with any technical information as to where or how or when you can get an Eye of Sulfuras. I\'m sure you\'ll figure that stuff out. Just sign this here contract so that our agreement is binding and our business will be done.','',1,1,25,0,0,0,0,0,1,0,0,0,26124),
(9644,'Give me the contract.','Give me the contract.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9645,'PEASANT CROSSES LINE.','PEASANT CROSSES LINE.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9646,'YOU ARE THE WINNER!','YOU ARE THE WINNER!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9647,'YOU ARE THE LOSE!','YOU ARE THE LOSER. BOO.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9648,'','I have failed once more...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9649,'','I now return to whence I came, only to find myself here once more to relive the same epic tragedy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9650,'At last, it ends....','At last, it ends....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9651,'Thank you, kind stranger. May your heroism never be forgotten.','Thank you, kind stranger. May your heroism never be forgotten.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9652,'We shall be reunited once more, my love...','We shall be reunited once more, my love...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9653,'Stranger, find the fallen Prince Menethil and end his reign of terror.','Stranger, find the fallen Prince Menethil and end his reign of terror.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9654,'The power of the light is truly great and merciful.','The power of the light is truly great and merciful.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9655,'','Be healed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9656,'','There are costs with war, $c... ones often overlooked.  Those costs are the orphans - children who have lost their parents to the far-too-numerous conflicts that rage across Azeroth.  Those children who have no one else to turn to often come here to live until they are old enough to fend for themselves.$B$BOne week out of the year during the Spring, the Horde takes time to give something back to these innocents.  This time is called Children\'s Week.\n',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9658,'Tiny mortals - me HERE! Doom you meet!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9659,'','There are costs with war, $c... ones often overlooked.  Those costs are the orphans - children who have lost their parents to the far-too-numerous conflicts that rage across Azeroth.  Those children who have no one else to turn to often come here to live until they are old enough to fend for themselves.$B$BOne week out of the year during the Spring, the Alliance takes time to give something back to these innocents.  This time is called Children\'s Week.\n',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9660,'What?!  You no can beat me!  Me will return!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9661,'You have not seen the last of me fools!  All shall be consumed in the end!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9662,'Hear me, denizens of the Crater!  I come to burn this land of its impurity!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9663,'Lady Jaina, this may sound like an odd request... but I have a young ward who is quite shy.  You are a hero to him, and he asked me to get your autograph.','Lady Jaina, this may sound like an odd request... but I have a young ward who is quite shy.  You are a hero to him, and he asked me to get your autograph.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9664,'You will all pay dearly when I return from the depths!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9665,'','Why... that is very sweet of you.  I gather that you are volunteering time for Children\'s Week, yes $c?  Well, you are to be commended.  It is imperative that we remember those less fortunate - especially the children.$B$BI\'d be happy to sign an autograph.  Here you go.',17,11,1,0,0,0,0,0,1,0,0,0,26124),
(9666,'This frozen land shall suffice for a start.  Come to me, mortals - and I shall give you a quick and painful death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9667,'Greetings young one, and welcome to Thunder Bluff.  You\'ll find safe refuge from the burdens of the world here.  All denizens of the Horde are welcome here.$B$BThe spirits of the present and past come alive here in this sacred place, my friend.  Honor them, and in doing so honor yourself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9668,'%s dissipates into the ether, his howling winds still ringing in your ears.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9669,'%s and his invading forces appear amidst a tumultuous conflagration in the northwest of Silithus.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9670,'Chief Bloodhoof, this may sound like an odd request... but I have a young ward who is quite shy.  You are a hero to him, and he asked me to get your hoofprint.','Chief Bloodhoof, this may sound like an odd request... but I have a young ward who is quite shy.  You are a hero to him, and he asked me to get your hoofprint.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9671,'Ah, a young warrior to be no doubt!  I take it you are participating in Children\'s Week, yes?  It warms these weary bones to hear that you are setting the example by which others will be sure to follow.$B$BI\'d be delighted to oblige you and the young lad.  Hrmm... what advice should I give to him?  Listen to the spirits, yes... maybe something about eating all of his vegetables too...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9672,'Children\'s Week is not yet over... may I have another Orphan Whistle?','Children\'s Week is not yet over... may I have another Orphan Whistle?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9673,'You be too scared!  Me find you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9674,'If you mortals are all so craven, this will be easier than I thought!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9675,'Well what do you know, this is Children\'s Week!  What can I do to help?','Well what do you know, this is Children\'s Week!  What can I do to help?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9676,'Where are the so-called heroes of this world?  Too frightened to come out and play?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9677,'','Become a mentor for one of our orphans during the Week of the Wardens!  Huzzah!\n',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9678,'','Become a mentor for one of our orphans during the Week of the Wardens!  For the Horde!',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9679,'%s causes a gale to sweep across the land, the sound of his mindless fury coming from the northwest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9680,'I won\'t make it... go... go on without me...','I won\'t make it... go... go on without me...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9681,'The pain is unbearable!','The pain is unbearable!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9682,'Should I live through this, I shall make it my life\'s sole ambition to destroy Arthas...','Should I live through this, I shall make it my life\'s sole ambition to destroy Arthas...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9683,'Death take me! I cannot go on! I have nothing left...','Death take me! I cannot go on! I have nothing left...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9684,'Seek out Shandrina in Silverwind Refuge.  She can sell you the \"Expert Cookbook\".','Seek out Shandrina in Silverwind Refuge.  She can sell you the \"Expert Cookbook\".',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9685,'Cooking is a lifelong pursuit and I see we share the same passion!','Cooking is a lifelong pursuit and I see we share the same passion!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9686,'Dirge Quikcleave of Gadgetzan is a master of the culinary arts.  To better yourself you will need to seek him out.','Dirge Quikcleave of Gadgetzan is a master of the culinary arts.  To better yourself you will need to seek him out.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9687,'Wulan in Shadowprey Village can sell you the \"Expert Cookbook\".  You will need that if you are to better yourself.','Wulan in Shadowprey Village can sell you the \"Expert Cookbook\".  You will need that if you are to better yourself.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9688,'I can teach you how to cook!','I can teach you how to cook!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9689,'','It\'s so sad for you poor children.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9690,'','Now children stop that!  I mean it!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9691,'','All will be well children.  The Light shall see to that!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9692,'','I believe you children are our future...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9693,'','You are mine now, children.  You will grow up to be a strong part of the Horde!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(9694,'','Stop whining!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(9695,'','Clean this place up! We will not live in such squalor.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(9696,'','It\'s my way or the Gold Road.  Is that understood?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(9697,'Only the renowned Doctor Gregory Victor can improve your skill now.  He can be found in Arathi Highlands at Hammerfall.','Only the renowned Doctor Gregory Victor can improve your skill now.  He can be found in Arathi Highlands at Hammerfall.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9698,'Balai Lok\'Wein of Brackenwall Village in Dustwallow Marsh sells a manual that you will need to study in order to improve your skills!','Balai Lok\'Wein of Brackenwall Village in Dustwallow Marsh sells a manual that you will need to study in order to improve your skills!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9699,'The esteemed Doctor Gustaf VanHowzen can train you further.  He can be found in Theramore treating the wounded at the barracks.','The esteemed Doctor Gustaf VanHowzen can train you further.  He can be found in Theramore treating the wounded at the barracks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9700,'I\'ve heard it said that Deneb Walker, holed up in Stromgarde, has a book that is sure to help improve your First Aid techniques.','I\'ve heard it said that Deneb Walker, holed up in Stromgarde, has a book that is sure to help improve your First Aid techniques.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9701,'I can train you in First Aid techniques.','I can train you in First Aid techniques.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9702,'Well duties call, yes?  First, the bell... to give you vigor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9703,'Next, I\'ll place the wheel... to protect you from harm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9704,'And finally the candle... to burn those who would thwart you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9705,'Ah, freedom!  Although brief, so sweet it is...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9706,'$n, my duties are complete and I shall now take my leave.  Luck to you my $gfellow:lady;, and remember to keep the Bell, Wheel and Candle working!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9707,'','Praise the Light, one has finally answered the calling.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(9708,'But wait...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9709,'$n, summon me again when you need to perform the ritual again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9710,'Until then, I shall take my leave...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9711,'','Too many have fallen, $g priest:priestess;. You must focus!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9712,'The Scourge are upon us! Run! Run for your lives!','The Scourge are upon us! Run! Run for your lives!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9713,'Please help us! The Prince has gone mad!','Please help us! The Prince has gone mad!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9714,'Seek sanctuary in the Hearthglen! It is our only hope!','Seek sanctuary in the Hearthglen! It is our only hope!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9715,'Stratholme is no more! The city lies in ruins. The Prince consumed by hatred... madness...','Stratholme is no more! The city lies in ruins. The Prince consumed by hatred... madness...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9716,'The Eye led me here, Eris.','The Eye led me here, Eris.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9717,'','<Eris nods.>$B$BThe Eye has seen so many horrors and so many wonders.$B$BIt displays what it feels the one looking into it is most suited to see.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9718,'And I was suited to see this?','And I was suited to see this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9719,'','You were. The Eye is never wrong.$B$BYou are a $g priest:priestess;, after all. A powerful $g priest:priestess;, if the Eye showed you this horrible memory.$B$BYou have come for redemption, yet you yourself do not even realize this... Do you?',1,1,6,0,0,0,0,0,1,0,0,0,26124),
(9720,'I really did not know what to expect, Eris. I will use my powers to assist you if that is what is asked of me.','I really did not know what to expect, Eris. I will use my powers to assist you if that is what is asked of me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9721,'','I know you will, $n.$B$BI myself am a priestess, though, unlike you I am long since gone from this world. My spirit, however, remains here, as do the spirits of the thousands who were brutally slain by the mad Prince, Arthas Menethil and his legion of undeath.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(9722,'Those days are over, Eris.','Those days are over, Eris.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9723,'','I never stated that you were here to redeem yourself, $g priest:priestess;. You are here to redeem me and the innocents murdered while trying to escape Stratholme.$B$BMy spirit and the spirit of those lost are bound here, cursed to endlessly relive our own tragic deaths.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(9724,'So what can I do to help?','So what can I do to help?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9725,'','You must do what I could not: Save the peasants that were cut down while fleeing from Stratholme.$B$BThey will walk towards the light, you must ensure their survival. Should too many fall, our cursed existence shall continue - you will have failed.$B$BEvery ability, prayer, and spell that you have learned will be tested. May the Light protect you, $n.',1,1,273,0,0,0,0,0,1,0,0,0,26124),
(9726,'You dare interfere with this being\'s test? The battle must be fought alone! You shall all suffer for this indiscretion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9727,'Who dares steal my precious mount?  You will pay for your insolence, mortal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9728,'','We are saved! The peasants have escaped the Scourge!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9729,'The spirit of the Dreadsteed pulses with rage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9730,'Arrr, Me Hearties!   I be havin\' some extra Treasure that I be givin\' away at the Gurubashi Arena!  All ye need do to collect it is open the chest I leave on the arena floor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9731,'Let the Bloodletting Begin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9732,'%s recoils in pain as the Judgment of Wisdom washes over it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9733,'The ways of Jaedenar are dark and treacherous.  Watch your moves in this place, $C, or you will find your soul entralled by your rivals...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9734,'I wish to purchase from you.','I wish to purchase from you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9735,'You dog!  Now I\'ll trap your soul into a shard and give you to my imp as a plaything!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9736,'Be gone!  I hold counsel with Dreadlords, and the matters we discuss are not your concern!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9737,'Dreadlords?  Perhaps you mean Lord Banehollow.  He sends his regards, and has a message for you...','Dreadlords?  Perhaps you mean Lord Banehollow.  He sends his regards, and has a message for you...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9738,'... A message from Banehollow?  What message is that?  Does he have need of his great advisor and servant, Ulathek?  Does he require my presence?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9739,'No, Ulathek.  He knows your secret.  He knows you plot with Lord Hel\'nurath of Xoroth.','No, Ulathek.  He knows your secret.  He knows you plot with Lord Hel\'nurath of Xoroth.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9740,'What?  But how?  No!  This is not possible!  I have been so careful... he could not know!$B$BYou lie!  You lie, and now you\'ll die for your deceit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9741,'It\'s no lie, traitor.  Banehollow wants your heart, and I\'m going to get it for him.','It\'s no lie, traitor.  Banehollow wants your heart, and I\'m going to get it for him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9742,'I\'m finished.  The parchment is made.  Now, return to Gorzeeki...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9743,'You are mine, dreadsteed!  Your spirit is now bound to me!','You are mine, dreadsteed!  Your spirit is now bound to me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9744,'','What a wonderful day to be alive! Look at the beauty that surrounds you, friend. Enjoy what life has to give!',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(9745,'*GRRRR* *RUFF* *RUFF*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9746,'Lava? Pay no mind to all of that, friend. Look around you. Take in the joys that nature has to offer.','',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(9747,'I come to Silithus every year around this time. The weather is phenomenal for my bunions.$B$BYou should take a stroll with me, friend. Enjoy the sights and what not.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9748,'How wonderful to see another person in this remote region of the world. Come, walk with me. Let our bodies keep each other warm.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9749,'Officer\'s Lounge','Officer\'s Lounge',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9750,'Look for it high up on the west side of the Valley of Strength.','Look for it high up on the west side of the Valley of Strength.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(9751,'I know you as Artorius the Doombringer. Show yourself, demon! Face me!','I know you as Artorius the Doombringer. Show yourself, demon! Face me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9752,'You want the Hall of Legends. It\'s high above the Valley of Strength on the west side.','You want the Hall of Legends. It\'s high above the Valley of Strength on the west side.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(9753,'A gnome? How pathetic. Face me, demon!','A gnome? How pathetic. Face me, demon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9754,'So you are Klinfran the Crazed? Sad, I was expecting an actual challenge. Do you dare face me in your true form?','So you are Klinfran the Crazed? Sad, I was expecting an actual challenge. Do you dare face me in your true form?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9755,'I am not fooled by your disguise, temptress. Your time to die has come.','I am not fooled by your disguise, temptress. Your time to die has come.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9756,'Officers\' Lounge','Officers\' Lounge',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9757,'All of a sudden you\'re a \'Defender of the Alliance\' are you?! Well, I suppose you\'ll be wanting to head to the Champions\' Hall now. It\'s over in Old Town.','All of a sudden you\'re a \'Defender of the Alliance\' are you?! Well, I suppose you\'ll be wanting to head to the Champions\' Hall now. It\'s over in Old Town.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9758,'Well, well, moving up in the world are we? You\'re looking for the Champions\' Hall, and you\'ll find it on the southeast end of Old Town. Good luck!','Well, well, moving up in the world are we? You\'re looking for the Champions\' Hall, and you\'ll find it on the southeast end of Old Town. Good luck!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9759,'','%s laughs at your foolish request.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9760,'','As you wish, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9761,'','Do I look like a fool, mortal? Because only a fool would remain here and do battle with you and all of your allies. Perhaps another time... Should you ever find the courage to back up your banter.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9762,'','%s is silenced by the venomous sting.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9763,'%s breaks free of its spectral bonds with a tremendous crash of thunder!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9764,'%s goes into a killing frenzy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9765,'The ritual is already underway!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9766,'$n, I shall leave before one of these beasts takes a liking to me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9768,'%s is pulled back to Xoroth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9769,'Ah, here we are!  Well let\'s get to work, shall we...?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9770,'Oh, right!  Over here now...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9771,'And now... the final step!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9772,'I shall enjoy this, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9773,'%s recoils in pain as the Judgment of Light washes over it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9774,'%s recoils in pain as the Judgment of Justice washes over it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9775,'%s recoils in pain as the Judgment of Righteousness washes over it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9776,'Follow me, good Paladin.  I\'ll have your barding done faster than I could down a Dwarven stout.  Mmmm... stout.','',1,5,0,0,0,0,0,7,1,0,0,0,26124),
(9777,'%s assembles the runecloth, herbs, and holy water to the barding.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9778,'%s smiths the arcanite into place on the barding.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9779,'Well, that should do it.  Come now, back to the shop to finish our business!','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(9780,'If you\'ve come looking for the finest craftsmanship on this or any other continent in the world, then you\'ve come to the right place!$B$BGrimand Elmore, at your service!','',1,2,0,0,0,0,0,7,1,0,0,0,26124),
(9781,'%s emerges from the darkness, drawn out by the divination scryer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9782,'You dare challenge me? Prepare for an eternity of dread.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9783,'%s notes your cowardly battle tactics and flees from battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9784,'ENOUGH - this ends now!  You fools will be added to my bone collection!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9785,'%s is immobilized.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9786,'%s is stricken by a virulent poison.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9787,'Your soul is mine, weakling.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9788,'To summon a Dreadsteed, you must first create a Circle of Greater Summoning.  A portal to Xoroth may only be created from within such a circle.$B$BThe Circle of Greater Summoning requires three powerful implements: a Bell of Dethmoora, a Wheel of the Black March and a Doomsday Candle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9789,'Your preparations are complete.  All that now stands before you and your dreadsteed is the ritual for the Circle of Greater Summoning, and the binding of the dreadsteed\'s spirit...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9790,'Gorzeeki tells me that you have brought him all that he needs for the Bell of Dethmoora, the Wheel of the Black March and the Doomsday Candle.$B$BWell done, $n!  You are almost ready to perform your ritual and bind a dreadsteed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9791,'Greetings, $n.  How goes your delvings into the demonic and arcane?  Have you uncovered any dark secrets of late?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9792,'Merideth, could I have some more manna-enriched horse feed please?','Merideth, could I have some more manna-enriched horse feed please?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9793,'%s flinches as its skin shimmers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9794,'Ah...the heroes. You are persistent, aren\'t you? Your ally here attempted to match his power against mine - and paid the price. Now he shall serve me...by slaughtering you. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9795,'Arr!   There be nothin I like to see better than folks fightin to the death in the arena.   If you be here at the right time maybe you can be one of them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9796,'Don\'t interrupt me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9797,'A slippery tile causes you to lose your footing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9798,'Yesh, it\'sh true, I\'m blind as a bat! An\' drunk as a ... err, drunk as shomething that getsh drunk.$B$BI\'ll tell you what, $r. It\'sh the drink that keeps me shenses sharp. It\'sh common knowledge that when you lose a shense, yer other shenses become more alert. My drunk shense is incredible these days.','',1,33,5,10,50,100,0,0,1,0,0,0,26124),
(9799,'Our pillas! Someone has stolen our pillas!','Our pillas! Someone has stolen our pillas!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9800,'We\'ll not let this act of madness go unpunished!','We\'ll not let this act of madness go unpunished!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9801,'$n captured the Horde Flag!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9802,'$n captured the Alliance Flag!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9803,'The flags are now placed at their bases.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9804,'The Alliance Flag was picked up by $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9805,'The Alliance Flag was dropped by $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9806,'The Horde Flag was dropped by $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9807,'The Horde Flag was picked up by $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9808,'The Alliance Flag was returned to its base by $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9809,'The Horde Flag was returned to its base by $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9810,'','Thieves! Scallywags! Rapscallions! Come face me gigantic pillas!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9811,'','We chose to leave the protection and comfort of the Depths to exploit... er, I mean... hrm, yes that\'s right, EXPLORE the world.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9812,'Run if you like fools!  Your fate is sealed anyways!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9813,'Flee while you can mortal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9814,'Generic Text','Generic Text!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9815,'Only a fool would remain in this battle. Farewell, coward.','Only a fool would remain in this battle. Farewell, coward.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9816,'Hey, you! Random traveler! C\'mere and make some coin!','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(9817,'Got anything interesting for sale, Zorbin?','Got anything interesting for sale, Zorbin?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9818,'I wish to browse your wares.','I wish to browse your wares.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9819,'Burninate\'s the name, smithin\'s my game... and, erm... I sell a little food and water on the side. Care for some meat?','',14,6,0,0,0,0,0,0,1,0,0,0,26124),
(9820,'Well hello again, $n!  I don\'t know how much longer I\'m going to keep on trying to set up a shop out in the middle of nowhere.  Still, since you\'ve helped me out in the past, I\'ll show you some stuff you may find interesting!','',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(9821,'When Lolo doesn\'t wanna spill any o\' his precious ale or get his lil\' dress dirty, I\'m called in. Yep. Ol\' Hansel is the dwarf they use to mete out a lil\' bit o\' justice an\' a whole lotta pain.','',1,23,0,0,0,0,0,0,1,0,0,0,26124),
(9822,'Now that the Stormpike general is defeated, we can spare a few troops to guard Winterax Hold.  But we must be ever vigilant, $c, for the Alliance will return.$B$BWhen you find them skulking about, teach them another lesson!','Now that the Stormpike general is defeated, we can spare a few troops to guard Winterax Hold.  But we must be ever vigilant, $c, for the Alliance will return.$B$BWhen you find them skulking about, teach them another lesson!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9823,'','Now that the Frostwolf general is defeated, we can spare some troops to guard the entrance to Winterax Hold.$B$BBut stay vigilant!  We must always be on the lookout for Horde interlopers..',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9824,'As acting Taskmaster of this here compound, it is my duty to make sure that there is a certain level of tedium involved with all forms of business, work, rest, and relaxation that may take place here.$B$BIf you find anything that you are asked to do to be too easy and hassle free, report to me immediately.','',1,1,273,0,0,0,0,0,1,0,0,0,26124),
(9825,'You\'ve done all that I\'ve asked you to do, $n. There\'s really nothing more here for you. If you are interested in continuing your career as an agent of the Thorium Brotherhood, speak with Lokhtos Darkbargainer at the Grim Guzzler in Blackrock Depths.$B$BFarewell!','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9826,'I swear... if Quint tries to plant one more fishing grub on me, I\'m going to hack down his tree with my not-so-rusty sword.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9827,'','Beware!  The $r $n attacks us at Winterax Hold!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9828,'','Thorium Brotherhood or not, if one of them Dark Iron gets near to me they\'ll taste my mattock up the side of their head!  Now, where can I send ya $G lad : lass;?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(9829,'Hey Pratt - can you teach me how to make Wild Leather Boots again?','Hey Pratt - can you teach me how to make Wild Leather Boots again?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9830,'Hey Pratt - can you teach me how to make a Wild Leather Cloak?','Hey Pratt - can you teach me how to make a Wild Leather Cloak?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9831,'Hey Pratt - can you teach me how to make a Wild Leather Vest again?','Hey Pratt - can you teach me how to make a Wild Leather Vest again?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9832,'Hey Pratt - can you teach me how to make Wild Leather Shoulders again?','Hey Pratt - can you teach me how to make Wild Leather Shoulders again?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9833,'Hey Pratt - can you teach me how to make Wild Leather Leggings again?','Hey Pratt - can you teach me how to make Wild Leather Leggings again?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9834,'Hey Pratt - can you teach me how to make a Wild Leather Helmet again?','Hey Pratt - can you teach me how to make a Wild Leather Helmet again?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9835,'Hey Jangdor - can you teach me how to make Wild Leather Boots again?','Hey Jangdor - can you teach me how to make Wild Leather Boots again?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9836,'Hey Jangdor - can you teach me how to make a Wild Leather Cloak?','Hey Jangdor - can you teach me how to make a Wild Leather Cloak?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9837,'Hey Jangdor - can you teach me how to make a Wild Leather Helmet again?','Hey Jangdor - can you teach me how to make a Wild Leather Helmet again?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9838,'Hey Jangdor - can you teach me how to make Wild Leather Leggings again?','Hey Jangdor - can you teach me how to make Wild Leather Leggings again?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9839,'Hey Jangdor - can you teach me how to make Wild Leather Shoulders again?','Hey Jangdor - can you teach me how to make Wild Leather Shoulders again?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9840,'Hey Jangdor - can you teach me how to make a Wild Leather Vest again?','Hey Jangdor - can you teach me how to make a Wild Leather Vest again?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9841,'','As long as those dwarves stay over there we\'ll have no trouble.  Where are you heading $n?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(9842,'The Horde wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9843,'The Alliance wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9844,'Get up, little red wyrm...and destroy them!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9845,'Let the games begin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9846,'Do you expect me to cower before the mighty legion of $n?$B$BYou are nothing to me. Less than nothing. Had I desired your head, it would have been presented to me on a pike.$B$BYou have made the mistake that all mortals make.$B$B<Lord Victor Nefarius sighs.>$B$BTime does strange things to those that use it as a form of currency.\n','',6,1,273,0,0,0,0,0,1,0,0,0,26124),
(9847,'I cannot, Vaelastrasz! Surely something can be done to heal you!','I cannot, Vaelastrasz! Surely something can be done to heal you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9848,'Priests! If you\'re going to keep healing like that, we might as well make it a little more interesting!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9849,'Hunters and your annoying pea-shooters!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9850,'Mages too? You should be more careful when you play with magic...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9851,'Druids and your silly shapeshifting. Lets see it in action!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9852,'Warlocks, you shouldn\'t be playing with magic you don\'t understand. See what happens?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9853,'Paladins... I\'ve heard you have many lives. Show me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9854,'Shamans, show me what your totems can do!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9855,'Warriors, I know you can hit harder than that! Let\'s see it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9856,'Rogues? Stop hiding and face me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9857,'A large humanoid hand print is embedded on the surface of the orb. Despite what appears to be constant manipulation and handling, the orb remains unmarred.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9858,'The orb\'s markings match the brand on your hand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9859,'<Place my hand on the orb.>','<Place my hand on the orb.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9860,'At last, the agony ends. I have failed you my Queen. I have failed us all...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9861,'I... I have failed, $n. The Lord of Bla... The Lord of Blackrock is too powerful. He consumed my energy with... with ease. I turn... I... kill me... you must... you must kill me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9862,'I am he that watches they. I am the fist of retribution. That which does quell the recalcitrant. Dare you defy the Warchief? Dare you face my merciless judgment?','',15,25,0,0,0,0,0,0,1,0,0,0,26124),
(9863,'Can\'t you see I\'m fishing here!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(9864,'You scared the fish away!  What do you want?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(9865,'What can I do for you $c?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(9866,'I\'m going to stay here until I catch a 68 Pound Grouper!  You on the other hand want to fly off somewhere, am I right?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(9867,'NEFARIAN BE SLAIN! People of Orgrimmar, bow down before da might of $n and $g his:her; allies for dey have laid a mighty blow against da Black Dragonflight !','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9868,'Be lifted by $n\'s accomplishment! Revel in $g his:her; rallying cry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9869,'Look to this fallen dragon, $r. The might of the Horde is unquestionable!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9870,'Citizens of the Alliance, the Lord of Blackrock is slain! Nefarian has been subdued by the combined might of $n and $g his:her; allies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9871,'Ragefire Chasm consists of a network of volcanic caverns below the orcs\' new capital city of Orgrimmar. Recently, rumors have spread that a cult loyal to the demonic Shadow Council has taken up residence within the Chasm\'s fiery depths. This cult, known as the Burning Blade, threatens the very sovereignty of Durotar. Many believe that the orc Warchief Thrall is aware of the Blade\'s existence and has chosen not to destroy it in the hopes that its members might lead him straight to the Shadow Council. \n','Ragefire Chasm consists of a network of volcanic caverns below the orcs\' new capital city of Orgrimmar. Recently, rumors have spread that a cult loyal to the demonic Shadow Council has taken up residence within the Chasm\'s fiery depths. This cult, known as the Burning Blade, threatens the very sovereignty of Durotar. Many believe that the orc Warchief Thrall is aware of the Blade\'s existence and has chosen not to destroy it in the hopes that its members might lead him straight to the Shadow Council. \n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9872,'Let your spirits rise! Rally around your champion, bask in $g his:her; glory! Revel in the rallying cry of the dragon slayer!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(9873,'Join a group going to this dungeon.    <This choice will place you in a meetingstone queue>                              ','Join a group going to this dungeon.    <This choice will place you in a meetingstone queue>    \n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9874,'The Lord of Blackrock hangs from the arches!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9875,'Move along, citizen. There is nothing to see here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9876,'Ragefire','Ragefire',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9877,'Are you interested in exploring one of these dungeons?','Are you interested in exploring one of these dungeons?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9878,'Wailing Caverns','Wailing Caverns',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9879,'A stack of papers and schematics are strewn here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9880,'These papers are guarded.  Speak with Zamek to create a distraction!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9881,'Recently, a night elf druid named Naralex discovered a network of underground caverns within the heart of the Barrens. Believing he could use the caverns\' springs to restore lushness to the Barrens, the druid began siphoning the energies of the fabled Emerald Dream. His vision somehow became a nightmare, however, and soon the Wailing Caverns changed into a den of vicious, deadly predators. It is said that Naralex still resides somewhere inside the labyrinth, trapped beyond the edges of the Emerald Dream. \r','Recently, a night elf druid named Naralex discovered a network of underground caverns within the heart of the Barrens. Believing he could use the caverns\' springs to restore lushness to the Barrens, the druid began siphoning the energies of the fabled Emerald Dream. His vision somehow became a nightmare, however, and soon the Wailing Caverns changed into a den of vicious, deadly predators. It is said that Naralex still resides somewhere inside the labyrinth, trapped beyond the edges of the Emerald Dream. \r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9882,'Tell me about dungeons I could explore.','Tell me about dungeons I could explore.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9883,'Impossible! Rise my minions!  Serve your master once more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9884,'Frustrated by the Dalaran wizards\' lack of progress against the undead during the Third War, the Archmage Arugal elected to summon the extra-dimensional worgen to bolster his side\'s diminishing ranks. The wolf-men slaughtered the Scourge, then quickly turned on the wizards themselves and laid siege to the keep of the noble, Baron Silverlaine. The fort quickly fell into shadow and ruin. Driven mad with guilt, Arugal adopted the worgen as his children and retreated to the newly dubbed \'Shadowfang Keep\'. \n','Frustrated by the Dalaran wizards\' lack of progress against the undead during the Third War, the Archmage Arugal elected to summon the extra-dimensional worgen to bolster his side\'s diminishing ranks. The wolf-men slaughtered the Scourge, then quickly turned on the wizards themselves and laid siege to the keep of the noble, Baron Silverlaine. The fort quickly fell into shadow and ruin. Driven mad with guilt, Arugal adopted the worgen as his children and retreated to the newly dubbed \'Shadowfang Keep\'. \n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9885,'Shadowfang Keep','Shadowfang Keep',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9886,'Too late, friends! Nefarius\' corruption has taken hold...I cannot...control myself.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9887,'I beg you, mortals - FLEE! Flee before I lose all sense of control! The black fire rages within my heart! I MUST- release it! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9888,'FLAME! DEATH! DESTRUCTION! Cower, mortals before the wrath of Lord...NO - I MUST fight this! Alexstrasza help me, I MUST fight it! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9889,'','Aye, you there!  If you want to earn the respect of the Darkspear, then you can start by donating valuable resources for those in need!  Textiles and bandages don\'t grow on trees, ya know.$B$BRather than cash in various cloth pieces you find adventuring, donate them!  Doing so will earn you the recognition of the Darkspear!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9890,'','In these trying times, a simple donation of cloth can go a long way to help those less fortunate than ourselves.  Cloth goes a long way to making garments and bandages - both important for the war effort!$B$BIf you are interested in donating cloth pieces to the orcs of Orgrimmar, I will gladly accept them and make sure you receive the proper recognition for doing so.$B$BFor the Horde!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9891,'Hail $g brother : sister;... I\'d like a moment of your time, if I may.$B$BWe tauren have endured much in our trials and tribulations in establishing our homeland.  We now find ourselves in a dire shortage of cloth.  If you have the materials to spare, I ask that you please donate them.  You certainly would earn the gratitude of tauren everywhere in helping us out!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9892,'Once the greatest gold production center in the human lands, the Dead Mines are now inhabited by the Defias Brotherhood, who have turned the dark tunnels into their private sanctum. It is rumored that the thieves have conscripted the clever goblins to help them build something terrible at the bottom of the mines - but what that may be is still uncertain. Rumor has it that the way into the Deadmines lies through the quiet, unassuming village of Moonbrook.\n','Once the greatest gold production center in the human lands, the Dead Mines are now inhabited by the Defias Brotherhood, who have turned the dark tunnels into their private sanctum. It is rumored that the thieves have conscripted the clever goblins to help them build something terrible at the bottom of the mines - but what that may be is still uncertain. Rumor has it that the way into the Deadmines lies through the quiet, unassuming village of Moonbrook.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9893,'You there... it is in your best interest to aid the Forsaken during these dire times.  Listen closely, as I dislike repeating myself.$B$BWe currently find ourselves in a dire shortage of cloth.  Bandages and simple textiles are running low, and donations are being accepted to bolster sagging inventories.  While you\'ll not receive financial compensation - hence what donation means - your aid will not go unnoticed.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9894,'Friend - Stormwind needs your assistance and your generosity!$B$BOur once large stockpile of textiles has run critically low.  Stormwind is now engaged in a multi-pronged effort to rebuild those stocks for the manufacture of textiles and bandages!  Your donation of cloth would help Stormwind immensely, as well as earn the respect of the citizenry!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9895,'','Aye, you there!  If you want to earn the respect of the dwarves of Ironforge, then you can start by donating valuable resources!  Ironforge finds itself running low on cloth piece; textiles and bandages don\'t grow on trees, ya know!$B$BRather than cash in various cloth pieces you find adventuring, donate them!  Doing so will earn you the recognition of the dwarven people of Ironforge!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9896,'Ragefire Chasm can be found beneath the Shadow Cleft in the center of Orgrimmar.','Ragefire Chasm can be found beneath the Shadow Cleft in the center of Orgrimmar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9897,'The exiles of Gnomeregan find ourselves in even more dire straits by running low on cloth reserves!  Perhaps you can help us, eh?!$B$BBring me extra cloth pieces you might have to help us replenish our stocks.  By donating them, you\'ll be earning the respect and trust of gnomes everywhere.  That\'s something that money can\'t buy!  Well, I guess cloth does, but that\'s beside the point...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9898,'Can you tell me more about this place?','Can you tell me more about this place?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9899,'The Wailing Caverns has its entrance at the Lushwater Oasis southwest of Crossroads in the Barrens.   ','The Wailing Caverns has its entrance at the Lushwater Oasis southwest of Crossroads in the Barrens.   ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9900,'Hail friend - a moment of your time, if I may...$B$BWe have endured much in our trials and tribulations in establishing Teldrassil.  Were the constant strife of the times not enough, we now find ourselves in a dire shortage of cloth.  If you have the materials to spare, I ask that you please donate them.  You certainly would earn the gratitude of night elves everywhere in helping us out!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9901,'Shadowfang Keep is in southern Silverpine just north of Pyrewood Village.','Shadowfang Keep is in southern Silverpine just north of Pyrewood Village.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9902,'I\'ve made no mistakes.','I\'ve made no mistakes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9903,'In your rush to glory, you assumed that the pace of the game revolved around your actions. Can you even fathom how preposterous that sounds to a being like me? A being that if so inclined could cause your own insignificant thoughts to crush the peanut sized mass of grey matter floating within your skull.\n','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(9904,'You have lost your mind, Nefarius. You speak in riddles.','You have lost your mind, Nefarius. You speak in riddles.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9905,'It\'s simple really. Allow me to summarize...\n','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9906,'Please do.','Please do.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9907,'In this world where time is your enemy, it is my greatest ally. This grand game of life that you think you play in fact plays you. To that I say...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9908,'Gnomeregan','Gnomeregan',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9909,'Blackfathom Deeps','Blackfathom Deeps',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9910,'Blackfathom Deeps can be found at the north end of Zoram Strand along the coast of Ashenvale.','Blackfathom Deeps can be found at the north end of Zoram Strand along the coast of Ashenvale.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9911,'Situated along the Zoram Strand of Ashenvale, Blackfathom Deeps was once a glorious temple dedicated to the night elves\' moon-goddess Elune. However, the great Sundering shattered the temple - sinking it beneath the waves of the Veiled Sea. There it remained untouched - until, drawn by its ancient power - the naga and satyr emerged to plumb its secrets. Legends hold that the ancient beast, Aku\'mai, has taken up residence within the temple\'s ruins. \n','Situated along the Zoram Strand of Ashenvale, Blackfathom Deeps was once a glorious temple dedicated to the night elves\' moon-goddess Elune. However, the great Sundering shattered the temple - sinking it beneath the waves of the Veiled Sea. There it remained untouched - until, drawn by its ancient power - the naga and satyr emerged to plumb its secrets. Legends hold that the ancient beast, Aku\'mai, has taken up residence within the temple\'s ruins. \n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9913,'Gnomeregan can be found in western Dun Morogh.','Gnomeregan can be found in western Dun Morogh.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9914,'Located in Dun Morogh, Gnomeregan has been the gnomes\' capital city for generations, though it was recently infested by mutant troggs. In a desperate attempt to retaliate, High Tinker Mekkatorque ordered the emergency venting of the city\'s radioactive waste tanks. Though the troggs became irradiated, their siege continued unabated and the gnomes were forced to seek refuge in the dwarven city of Ironforge, where the High Tinker now enlists brave souls to help his people reclaim their beloved city. \n','Located in Dun Morogh, Gnomeregan has been the gnomes\' capital city for generations, though it was recently infested by mutant troggs. In a desperate attempt to retaliate, High Tinker Mekkatorque ordered the emergency venting of the city\'s radioactive waste tanks. Though the troggs became irradiated, their siege continued unabated and the gnomes were forced to seek refuge in the dwarven city of Ironforge, where the High Tinker now enlists brave souls to help his people reclaim their beloved city. \n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9915,'Razorfen Kraul','Razorfen Kraul',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9916,'Razorfen Kraul can be found on the very southern tip of the Barrens on the west side of the road.','Razorfen Kraul can be found on the very southern tip of the Barrens on the west side of the road.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9917,'During the War of the Ancients, the demigod Agamaggan came forth to battle the Burning Legion. The colossal boar was defeated, and over time in the areas where his blood fell, massive thorn-ridden vines sprouted to life. The quilboar came to occupy these regions and hold them sacred. The heart of these massive thorn-colonies is the Razorfen. Razorfen Kraul was conquered by the crone, Charlga Razorflank, a Geomancer with experimental and powerful practices, whose rise to power and the rapidly increasing violence between quilboar tribesmen can only lead to one thing: war.','During the War of the Ancients, the demigod Agamaggan came forth to battle the Burning Legion. The colossal boar was defeated, and over time in the areas where his blood fell, massive thorn-ridden vines sprouted to life. The quilboar came to occupy these regions and hold them sacred. The heart of these massive thorn-colonies is the Razorfen. Razorfen Kraul was conquered by the crone, Charlga Razorflank, a Geomancer with experimental and powerful practices, whose rise to power and the rapidly increasing violence between quilboar tribesmen can only lead to one thing: war.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9918,'Scarlet Monastery','Scarlet Monastery',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9919,'Scarlet Monastery lies in the hills northeast of Tirisfal Glades.','Scarlet Monastery lies in the hills northeast of Tirisfal Glades.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9920,'The monastery was once a center for learning and enlightenment. With the rise of the undead Scourge during the Third War, the peaceful Monastery was converted into a stronghold of the fanatical Scarlet Crusade. The Crusaders are intolerant of all non-human races, regardless of alliance or affiliation. They believe that any and all outsiders are potential carriers of the undead plague - and must be destroyed. \n','The monastery was once a center for learning and enlightenment. With the rise of the undead Scourge during the Third War, the peaceful Monastery was converted into a stronghold of the fanatical Scarlet Crusade. The Crusaders are intolerant of all non-human races, regardless of alliance or affiliation. They believe that any and all outsiders are potential carriers of the undead plague - and must be destroyed. \n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9921,'Razorfen Downs','Razorfen Downs',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9922,'Razorfen Downs can be found on the very southern tip of the Barrens on the east side of the road.','Razorfen Downs can be found on the very southern tip of the Barrens on the east side of the road.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9923,'Crafted from the same vines as Razorfen Kraul, Razorfen Downs is the traditional capital city of the quilboar race. The sprawling, thorn-ridden labyrinth houses a veritable army of loyal quilboar as well as their high priests - the Death\'s Head tribe. Recently, however, a looming shadow has fallen over the crude den. Agents of the undead Scourge - led by the lich, Amnennar the Coldbringer - have taken control over the quilboar race and turned the maze of thorns into a bastion of undead might. \n\n','Crafted from the same vines as Razorfen Kraul, Razorfen Downs is the traditional capital city of the quilboar race. The sprawling, thorn-ridden labyrinth houses a veritable army of loyal quilboar as well as their high priests - the Death\'s Head tribe. Recently, however, a looming shadow has fallen over the crude den. Agents of the undead Scourge - led by the lich, Amnennar the Coldbringer - have taken control over the quilboar race and turned the maze of thorns into a bastion of undead might. \n\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9924,'Uldaman','Uldaman',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9925,'Uldaman can be found at the very northern end of the Badlands.','Uldaman can be found at the very northern end of the Badlands.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9926,'Lard keep peace here. Lard also sell fish. Want fish?','Lard keep peace here. Lard also sell fish. Want fish?',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(9927,'Uldaman is an ancient Titan vault that has laid buried within the earth since the world\'s creation. Dwarven excavations of the city have recently released the Titans\' first failed creations: the troggs. Legends say that when the Titans deemed the trogg experiment a failure they tried again, resulting in the creation of the dwarven race. These secrets are recorded on the fabled Discs of Norgannon - massive artifacts that lie at the bottom of the ancient city, protected by giant constructs of living stone. \r','Uldaman is an ancient Titan vault that has laid buried within the earth since the world\'s creation. Dwarven excavations of the city have recently released the Titans\' first failed creations: the troggs. Legends say that when the Titans deemed the trogg experiment a failure they tried again, resulting in the creation of the dwarven race. These secrets are recorded on the fabled Discs of Norgannon - massive artifacts that lie at the bottom of the ancient city, protected by giant constructs of living stone. \r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9928,'Zul\'Farrak','Zul\'Farrak',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9929,'The ruins of Zul\'Farrak are located in the northwestern corner of the Tanaris Desert.','The ruins of Zul\'Farrak are located in the northwestern corner of the Tanaris Desert.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9930,'This sun-blasted city is home to the Sandfury trolls, known for their particular ruthlessness and dark mysticism. Troll legends tell of a powerful sword called Sul\'thraze the Lasher, a weapon capable of instilling fear and weakness in even the most formidable of foes. Long ago, the weapon was split in half. However, rumors have circulated that the two halves may be found somewhere within Zul\'Farrak\'s walls.\n','This sun-blasted city is home to the Sandfury trolls, known for their particular ruthlessness and dark mysticism. Troll legends tell of a powerful sword called Sul\'thraze the Lasher, a weapon capable of instilling fear and weakness in even the most formidable of foes. Long ago, the weapon was split in half. However, rumors have circulated that the two halves may be found somewhere within Zul\'Farrak\'s walls.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9931,'Maraudon','Maraudon',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9932,'Maraudon is located in the middle of the western coast of Desolace, in the Valley of Spears.','Maraudon is located in the middle of the western coast of Desolace, in the Valley of Spears.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9933,'Maraudon is one of the most sacred sites within Desolace. The great temple/cavern is the burial place of Zaetar, one of two immortal sons born to the demigod, Cenarius. Legend holds that Zaetar and the earth elemental princess, Theradras, sired the misbegotten centaur race. It is said that upon their emergence, the barbaric centaur turned on their father and killed him. Some believe that Theradras, in her grief, trapped Zaetar\'s spirit within the winding cavern - used its energies for some malign purpose. ','Maraudon is one of the most sacred sites within Desolace. The great temple/cavern is the burial place of Zaetar, one of two immortal sons born to the demigod, Cenarius. Legend holds that Zaetar and the earth elemental princess, Theradras, sired the misbegotten centaur race. It is said that upon their emergence, the barbaric centaur turned on their father and killed him. Some believe that Theradras, in her grief, trapped Zaetar\'s spirit within the winding cavern - used its energies for some malign purpose. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9934,'Sunken Temple','Sunken Temple',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9935,'The Sunken Temple can be found in the center of a great lake in eastern Swamp of Sorrows.','The Sunken Temple can be found in the center of a great lake in eastern Swamp of Sorrows.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9936,'Over a thousand years ago a group of troll priests known as the Atal\'ai attempted to bring back an ancient blood god named Hakkar the Soulflayer. After the resulting civil war the priests were defeated and exiled to the Swamp of Sorrows. There they erected a temple to Hakkar to prepare for his arrival into the physical world. The dragon Aspect Ysera soon learned of the Atal\'ai\'s plans and smashed the temple beneath the marshes. To this day, the temple\'s ruins are guarded by the mighty green dragons.\n','Over a thousand years ago a group of troll priests known as the Atal\'ai attempted to bring back an ancient blood god named Hakkar the Soulflayer. After the resulting civil war the priests were defeated and exiled to the Swamp of Sorrows. There they erected a temple to Hakkar to prepare for his arrival into the physical world. The dragon Aspect Ysera soon learned of the Atal\'ai\'s plans and smashed the temple beneath the marshes. To this day, the temple\'s ruins are guarded by the mighty green dragons.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9937,'Blackrock Depths','Blackrock Depths',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9938,'Blackrock Mountain lies between Searing Gorge in the north and Burning Steppes in the south.','Blackrock Mountain lies between Searing Gorge in the north and Burning Steppes in the south.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9939,'Once the capital city of the Dark Iron dwarves, this volcanic labyrinth now serves as the seat of power for Ragnaros the Firelord. Ragnaros has uncovered the secret to creating life from stone and plans to build an army of unstoppable golems to aid him in conquering the whole of Blackrock Mountain. Obsessed with defeating Nefarian and his draconic minions, Ragnaros will go to any extreme to achieve final victory.  \n','Once the capital city of the Dark Iron dwarves, this volcanic labyrinth now serves as the seat of power for Ragnaros the Firelord. Ragnaros has uncovered the secret to creating life from stone and plans to build an army of unstoppable golems to aid him in conquering the whole of Blackrock Mountain. Obsessed with defeating Nefarian and his draconic minions, Ragnaros will go to any extreme to achieve final victory.  \n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9940,'Blackrock Spire','Blackrock Spire',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9941,'The mighty fortress carved within the fiery bowels of Blackrock Mountain was held by the sinister Dark Iron dwarves for centuries until Nefarian - the cunning son of the dragon, Deathwing - took control of the upper Spire and made war on the dwarves\' holdings in the mountain\'s volcanic depths. Realizing that the dwarves were led by the mighty fire elemental, Ragnaros - Nefarian vowed to crush his enemies and claim the whole of Blackrock mountain for himself. \n','The mighty fortress carved within the fiery bowels of Blackrock Mountain was held by the sinister Dark Iron dwarves for centuries until Nefarian - the cunning son of the dragon, Deathwing - took control of the upper Spire and made war on the dwarves\' holdings in the mountain\'s volcanic depths. Realizing that the dwarves were led by the mighty fire elemental, Ragnaros - Nefarian vowed to crush his enemies and claim the whole of Blackrock mountain for himself. \n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9942,'Dire Maul','Dire Maul',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9943,'The ruins of Dire Maul stand in central Ferelas.','The ruins of Dire Maul stand in central Ferelas.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9944,'Built twelve thousand years ago by a covert sect of night elf sorcerers, the ancient city of Eldre\'Thalas was used to protect Queen Azshara\'s most prized arcane secrets. Though it was ravaged by the Great Sundering of the world, much of the wondrous city still stands as the imposing Dire Maul. The ruins\' three distinct districts have been overrun by all manner of creatures - especially the spectral highborne, foul satyr and brutish ogres. \n','Built twelve thousand years ago by a covert sect of night elf sorcerers, the ancient city of Eldre\'Thalas was used to protect Queen Azshara\'s most prized arcane secrets. Though it was ravaged by the Great Sundering of the world, much of the wondrous city still stands as the imposing Dire Maul. The ruins\' three distinct districts have been overrun by all manner of creatures - especially the spectral highborne, foul satyr and brutish ogres. \n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9945,'Scholomance','Scholomance',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9946,'The School for Necromancy known as Scholomance is on the ruined island of Caer Darrow in the Western Plaguelands.','The School for Necromancy known as Scholomance is on the ruined island of Caer Darrow in the Western Plaguelands.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9947,'The Scholomance is housed in crypts beneath the Caer Darrow keep. Once owned by the noble Barov family, the keep fell to ruin after the Second War. As the wizard Kel\'Thuzad enlisted followers for his Cult of the Damned, he often promised immortality for those who served his Lich King. The Barovs fell to his influence and donated their keep, but the cultists killed the family and turned the crypts into a school of necromancy. Though Kel\'Thuzad no longer resides there, cultists and instructors still remain. ','The Scholomance is housed in crypts beneath the Caer Darrow keep. Once owned by the noble Barov family, the keep fell to ruin after the Second War. As the wizard Kel\'Thuzad enlisted followers for his Cult of the Damned, he often promised immortality for those who served his Lich King. The Barovs fell to his influence and donated their keep, but the cultists killed the family and turned the crypts into a school of necromancy. Though Kel\'Thuzad no longer resides there, cultists and instructors still remain. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9948,'Stratholme','Stratholme',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9949,'The ruined city of Stratholme lies in the Eastern Plaguelands to the north of the Plaguewood.','The ruined city of Stratholme lies in the Eastern Plaguelands to the north of the Plaguewood.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9950,'Once the jewel of northern Lordaeron, the city of Stratholme is where Prince Arthas turned against his mentor, Uther Lightbringer, and slaughtered hundreds of his own subjects who were believed to have contracted the plague of undeath. Arthas\' surrender to the Lich King soon followed. The broken city is now inhabited by the undead Scourge - led by the powerful lich, Kel\'Thuzad, and a contingent of Scarlet Crusaders, led by Grand Crusader Dathrohan. The two sides are locked in constant, violent combat. \n','Once the jewel of northern Lordaeron, the city of Stratholme is where Prince Arthas turned against his mentor, Uther Lightbringer, and slaughtered hundreds of his own subjects who were believed to have contracted the plague of undeath. Arthas\' surrender to the Lich King soon followed. The broken city is now inhabited by the undead Scourge - led by the powerful lich, Kel\'Thuzad, and a contingent of Scarlet Crusaders, led by Grand Crusader Dathrohan. The two sides are locked in constant, violent combat. \n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9951,'Deadmines','Deadmines',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9952,'The Deadmines can be found beneath Moonbrook in the south of Westfall.','The Deadmines can be found beneath Moonbrook in the south of Westfall.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9953,'Stormwind Stockade','Stormwind Stockade',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9954,'The Stormwind Stockades are found near the mage quarter in Stormwind.','The Stormwind Stockades are found near the mage quarter in Stormwind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9955,'The Stockades are a high-security prison complex, hidden beneath the canal district of Stormwind city. Presided over by Warden Thelwater, the Stockades are home to petty crooks, political insurgents, murderers and a score of the most dangerous criminals in the land. Recently, a prisoner-led revolt has resulted in a state of pandemonium within the Stockades - where the guards have been driven out and the convicts roam free. \n','The Stockades are a high-security prison complex, hidden beneath the canal district of Stormwind city. Presided over by Warden Thelwater, the Stockades are home to petty crooks, political insurgents, murderers and a score of the most dangerous criminals in the land. Recently, a prisoner-led revolt has resulted in a state of pandemonium within the Stockades - where the guards have been driven out and the convicts roam free. \n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9956,'%s shot a buff!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9958,'Intruders have breached the hatchery! Sound the alarm! Protect the eggs at all costs!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9959,'Don\'t fight in broken weapons and armor! Expert armor and weapon repairing done here - while you wait!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9960,'Foolish $n, you serve me now! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9961,'You\'ll pay for forcing me to do this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9962,'Fools! These eggs are more precious than you know!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9963,'No - not another one! I\'ll have your heads for this atrocity!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9964,'Forgive me, $n! Your death only adds to my failure! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9965,'Nefarius\' hate has made me stronger than ever before! You should have fled while you could, mortals! The fury of Blackrock courses through my veins! \n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9966,'Protect the flight!  These intruders die now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9967,'None of your kind should be here!  You\'ve doomed only yourselves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9968,'Clever, mortals - but I am not so easily lured away from my sanctum!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9969,'The blood samples must be protected!  Destroy the intruders!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9971,'This cannot be!  I am the master here!  You mortals are nothing to my kind!  Do you hear me? Nothing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9972,'Worthless $n!  Your friends will join you soon enough!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9973,'Well done, my minions. The mortals\' courage begins to wane! Now, let\'s see how they contend with the true Lord of Blackrock Spire!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9974,'BURN! You wretches! BURN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9975,'I\'ve got all the cooking supplies you\'ll ever need, mon!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(9976,'','Welcome to Revantusk Village, stranger. I am Primal Torntusk, leader of the Revantusk trolls.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9977,'If it\'s broke, Slagtree can fix it!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9978,'','Don\'t be steppin\' on my goods, there.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9979,'Fishing is just so pleasant, mon. You know? I owe my state of bliss to my mentor, the greatest angler in the whole world - Nat Pagle. Have you heard of him, mon?$B$BIf you be looking for enlightenment, Nat Pagle be the one who gonna show you the way. ','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9980,'What can you teach me?','What can you teach me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9981,'Zul\'jin shall return one day, $r. Mark my words. Until then, we all hold our positions and do what we can to keep the forest troll population intact.$B$BWith that said, as master huntsman of Revantusk Village, it is my responsibility to ensure that the world around us is safe for habitation.$B$BThe beasts of this area must be kept in check.$B$BAre you looking for work?\n','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(9982,'Markhor, I wish to stable my pet.','Markhor, I wish to stable my pet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9983,'I am Kilram, master of the axe.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9984,'Ah, a seasoned veteran you once were. Kilram can make you this again. I know you are capable, you merely need to ask and I shall teach you the way of the axesmith.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9985,'Please teach me how to become an axesmith, Kilram.','Please teach me how to become an axesmith, Kilram.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9986,'','Don\'t get too close, $n. I\'m liable to fumble and bash your brains open with the face of my hammer.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9987,'','I will teach you the way of the hammersmith. Just ask nicely.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9988,'Please teach me how to become a hammersmith, Lilith.','Please teach me how to become a hammersmith, Lilith.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9989,'Back off or I\'ll cut you in half.','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(9990,'If you wish to become a swordsmith, just ask.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(9991,'Please teach me how to become a swordsmith, Seril.','Please teach me how to become a swordsmith, Seril.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9992,'I would like to buy from you.','I would like to buy from you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9993,'I have just completed a new dimensional imploder that will make me rich beyond my wildest goblin dreams!   All I need to do is get a skilled Goblin Engineer to build a dimensional ripper that connects to it and try it! \n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9994,'This Dimensional Imploder sounds dangerous!  How can I make one?','This Dimensional Imploder sounds dangerous!  How can I make one?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9995,'The theory behind it is that we completely destroy you with a massive explosion wherever you are and send those particles through a dimensional rip and then re-implode you at the machine here.   Instant Transport!    It might not work ALL the time, but what kind of goblin engineer are you!   If survival was your first priority you could never be a real Goblin Engineer!\nHere is the recipe you will need to make the Dimensional Ripper and try it out!\n\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9996,'With some of the technology that was recovered by bold gnomes venturing into Gnomeregan, I have managed to construct my greatest invention:  The Matter Transporter!    All I need now is a skilled Gnomish Engineer to build a powerful beacon attuned to the transporter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9997,'I must build a beacon for this marvelous device!','I must build a beacon for this marvelous device!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9998,'Once you have built the device, you simply activate the device to be whisked away to lovely Gadgetzan!    Nearly everyone who has used the device has arrived on the pad here looking just the way they did when they began!\n\nThere have been some reported problems with transportees being replaced by their evil selves from an alternate universe, but I\'m sure we will have that worked out soon...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(9999,'If you figure out any way to improve the device let me know!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10000,'It\'s good to see an engineer brave enough to make the device.   We goblin engineers laugh at danger!','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(10001,'Reporting for duty!','Reporting for duty!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10002,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10003,'Another fool falls for the trap!','Another fool falls for the trap!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10004,'Dinner has arrived!','Dinner has arrived!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10005,'The High Priestess will feast on your bones!','The High Priestess will feast on your bones!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10006,'%s is weakened by the orb!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10007,'Supplies from our enemies!  Well done, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10008,'You brought supplies from the enemy!  Hah! Well done $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10009,'Invaders! Invaders! We\'re under attack, boys! Get \'em!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10010,'I perform one final service. I pray it is sufficient...','',26,0,0,0,0,0,0,0,1,0,0,0,26124),
(10011,'Vaelastrasz, no!!!','Vaelastrasz, no!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10012,'Get the key and unlock these chains! Hitah\'ya the Keeper holds it... back of cave... ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10013,'Finally, I am free! I come home soon, my dear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10014,'Let the battle begin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10015,'The battle for Warsong Gulch begins in 1 minute.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10016,'The battle for Warsong Gulch begins in 30 seconds.  Prepare yourselves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10017,'Jobs/Lost & Found/Wanted:','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10018,'Zug zug, my friend!  I am Kelm Hargunth, the main supplier for the Warsong Outriders.  As you improve your standing with the Outriders, I will make available to you a fine selection of goods that you can use inside Warsong Gulch.  Should you find yourself in need of item repair, I also provide those services.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10019,'What goods have I earned the right to purchase for use in Warsong Gulch?','What goods have I earned the right to purchase for use in Warsong Gulch?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10020,'','May the blessings of the night be yours, friend!  I am Illiyana Moonblaze, and I am the main supplier for the Silverwing Sentinels here in Ashenvale.  As you improve your standing with the Sentinels, I will make available to you a fine selection of goods that you can use inside Warsong Gulch.  Should you find yourself in need of item repair, I also provide those services.',4,1,0,0,0,0,0,0,1,0,0,0,26124),
(10021,'What goods have I earned the right to purchase for use in Warsong Gulch?','What goods have I earned the right to purchase for use in Warsong Gulch?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10022,'The Alliance Flag has returned to its base!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10023,'The Horde Flag has returned to its base!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10024,'I am here!  And the Irondeep Mine is... MINE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10025,'Snivvle is here!  Snivvle claims the Coldtooth mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10026,'Let the coils of hate unfurl!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10027,'','Lord Hir\'eek, grant me wings of vengeance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10028,'Welcome!  Welcome to Yebb Neblegear\'s Darkmoon Zoo Bizarre - a Trove of Living Legends and Mythical Oddities!  Enjoy your visit, friend!$B$BBut be mindful of what you touch!  These exhibits hold artifacts and beasts both dire and divine!  They might burn the wayward hand of an over-curious onlooker...','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(10029,'Where can I send you today $c?','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10030,'Though the Crossroads seems to be the center of activity in The Barrens, I prefer the quietude of Camp Taurajo.  Where shall I send you?','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10031,'Many are the paths of the Earth Mother.  Wherever you decide to travel, may she watch over you.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10032,'Treat the wind rider well as it takes you to your destination.  May your ancestors watch over you $n.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10033,'Greetings my friend, and welcome to the greatest show on Azeroth!$B$BPlease, step right up and take in all we have to offer.  Amaze at the wonders that the Darkmoon Faire has uncovered in this vast and mysterious world!  We have spared no expense in bringing you excitement that children of all ages will delight in!','',66,1,1,0,0,0,0,0,1,0,0,0,26124),
(10034,'Welcome back to the greatest show on Azeroth, my friend!  It is truly a delight to see you once again.$B$BPlease, step right up and once more take in all we have to offer.  Be sure to check around, as we are always adding new and exciting things to the Darkmoon Faire!  Amaze at wonders old and new that we have uncovered!  We continue to spare no expense in bringing you excitement that children of all ages will delight in!','',2,1,1,0,0,0,0,0,1,0,0,0,26124),
(10035,'Silas, why is most everything at the faire free?  How do you make a profit?','Silas, why is most everything at the faire free?  How do you make a profit?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10036,'It\'s not always about money, clem!  While we receive generous donations - some extremely substantial - our traveling troupe of performers is fueled creatively by a need to brighten this war-torn world.  Don\'t worry about us, but instead let us worry about how to best entertain you.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10037,'Ticket redemption here!  Get your tickets turned into prizes!  Step right up!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(10038,'Move along, rube.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10039,'This ain\'t a ride, clem.  Beat it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10040,'If you\'re trying to be friendly, save your breath.  Better yet, just stop breathing all together.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10041,'In case it wasn\'t obvious, I\'m not here for customer relations.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10042,'You mess with Silas, you mess with me.  Have a nice day.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10043,'I need a second head like I need to lose my first one.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10044,'I lived in Dire Maul for a little bit.  That was fun.  Really.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10045,'Unlike most ogres, I do know what an outhouse is for - giving you a swirlie.  Now beat it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10046,'I have long known you\'d seek me out, $n.$B$BEvery sentient being in this world is driven by the choices they make.  Choices beget further choices, and these in turn make someone who they are.  This is where your fortune is drawn from - who you are, and the choices you make.$B$BAre you ready to discover where your fortune lies?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10047,'I am ready to discover where my fortune lies!','I am ready to discover where my fortune lies!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10048,'Very well then...$B$BYou have been tasked by your liege to guard his fields of corn from poachers and thieves.  One night on patrol, you stumble across a haggard man in thread-bare clothing stealing corn from the field.  You quickly confront him, and he immediately begs for his life.  He claims he is stealing the corn to feed his family since the lord of the land - your liege - demands too much in taxes.  Your liege is indeed known for his harsh taxes throughout the land.$B$BMake your choice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10049,'I slay the man on the spot as my liege would expect me to do, as he is nothing more than a thief and a liar.','I slay the man on the spot as my liege would expect me to do, as he is nothing more than a thief and a liar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10050,'I turn over the man to my liege for punishment, as he has broken the law of the land and it is my sworn duty to enforce it.','I turn over the man to my liege for punishment, as he has broken the law of the land and it is my sworn duty to enforce it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10051,'I confiscate the corn he has stolen, warn him that stealing is a path towards doom and destruction, but I let him go to return to his family.','I confiscate the corn he has stolen, warn him that stealing is a path towards doom and destruction, but I let him go to return to his family.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10052,'I allow the man to take enough corn to feed his family for a couple of days, encouraging him to leave the land.','I allow the man to take enough corn to feed his family for a couple of days, encouraging him to leave the land.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10053,'Your next choice awaits.$B$BYou are the sworn executioner for your liege.  A man has been sent to you for execution as a traitor of the liege and your people.  You know this individual as a close, virtuous friend who mysteriously vanished one day.  You also know that the man\'s crimes for which he was convicted supposedly caused the deaths of many innocent civilians.  Upon seeing you he begs for his life, claiming he was framed by a higher authority.$B$BMake your choice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10054,'','Begone, uncouth scum!  The Alliance shall prevail in Alterac Valley!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10055,'Die!  Your kind has no place in Alterac Valley!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10056,'','Take heart, Alliance!  Throw these villains from Alterac Valley!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10057,'Now is the time to attack!  For the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10058,'Can\'t you see I\'ve got work to do here?','Can\'t you see I\'ve got work to do here?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(10059,'Faire\'s a coming!','Faire\'s a coming!',71,0,0,0,0,0,0,0,1,0,0,0,26124),
(10060,'That\'s right friend!  The Darkmoon Faire is going to be right here.  Just as soon as I unload those huge wagons, put up all the tents, erect the zoo and pour the drinks.  Make sure you come back!','That\'s right friend!  The Darkmoon Faire is going to be right here.  Just as soon as I unload those huge wagons, put up all the tents, erect the zoo and pour the drinks.  Make sure you come back!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10061,'Won\'t be long now until the Darkmoon Faire opens.  Come back later and check to see if we\'re done.','Won\'t be long now until the Darkmoon Faire opens.  Come back later and check to see if we\'re done.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10062,'Welcome to the faire young one!   We have collected wonders from all over the world for your perusal.   Oh and please let me know if you manage to collect a set of the lesser darkmoon cards, as the master... I mean I would be keenly interested in them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10064,'Tell me more about these Darkmoon Cards.','Tell me more about these Darkmoon Cards.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10065,'We have seeded darkmoon cards around the world to see if any worthy individuals could complete a set of any of the eight suits.  If you manage to collect all eight cards of one of the suits we will reward you with one of the greater darkmoon cards that functions as a powerful trinket as well as a link to the Darkmoon Faire.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10066,'Would you like something more to eat sir?','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10067,'Tell me about the Beasts Deck.','Tell me about the Beasts Deck.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10068,'If you manage to complete a deck of beasts cards you will be rewarded with a greater darkmoon card of the blue dragon.   This is very useful in restoring of magical energies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10069,'Tell me about the Portals Deck.','Tell me about the Portals Deck.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10070,'If you manage to complete a deck of portals cards you will be rewarded with a greater darkmoon card of the twisting nether.   This card will occasionally pull your spirit back into your body after death and restore you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10071,'Tell me about the Elementals Deck.','Tell me about the Elementals Deck.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10072,'If you manage to complete a deck of elementals cards you will be rewarded with a greater darkmoon card of the maelstrom.   This card will occasionally impact an enemy you are fighting with for heavy damage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10073,'Tell me about the Warlords Deck.','Tell me about the Warlords Deck.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10074,'If you manage to complete a deck of warlords cards you will be rewarded with a greater darkmoon card of heroism.   This card will occasionally heal you while you are engaged in melee combat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10075,'I execute him as per my liege\'s instructions, and do it in such a manner that he suffers painfully before he dies as retribution for his crimes against my people.','I execute him as per my liege\'s instructions, and do it in such a manner that he suffers painfully before he dies as retribution for his crimes against my people.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10076,'I execute him as per my liege\'s instructions, but doing so in as painless of a way as possible.  Justice must be served, but I can show some compassion.','I execute him as per my liege\'s instructions, but doing so in as painless of a way as possible.  Justice must be served, but I can show some compassion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10077,'I risk my own life and free him so that he may prove his innocence.  If I can, I\'ll help him in any way.','I risk my own life and free him so that he may prove his innocence.  If I can, I\'ll help him in any way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10078,'Your next choice awaits.$B$BYou are on a diplomatic mission for your liege to a cruel country that is currently at war with yours.  The war has been costly on both sides.  Your mission is to secure a peace that is honorable to both peoples.$B$BAt a diplomatic dinner, you overhear the ruler of the opposing land viciously insult your benevolent liege.  You are fairly certain the ruler meant to say it out of your earshot, but nonetheless he has besmirched your liege\'s honor.$B$BMake your choice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10079,'I confront the ruler on his malicious behavior, upholding my liege\'s honor at the risk of any future diplomacy.','I confront the ruler on his malicious behavior, upholding my liege\'s honor at the risk of any future diplomacy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10080,'I not-so-quietly ignore the insult, hoping to instill a fear in the ruler that he may have gaffed.  I then inform my liege of the insult when I return.','I not-so-quietly ignore the insult, hoping to instill a fear in the ruler that he may have gaffed.  I then inform my liege of the insult when I return.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10081,'I quietly ignore the insult.  I will not tell my liege, as I am to secure peace at all costs.  It\'s only an insult - not a declaration of war.','I quietly ignore the insult.  I will not tell my liege, as I am to secure peace at all costs.  It\'s only an insult - not a declaration of war.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10082,'Your next choice awaits.$B$BYour brother seeks to join the ranks of the prestigious military order you are already a part of.  While you are sure of his commitment and loyalty, his talent and ability to perform the arduous tasks of the order is what you question.  While you are not certain he will be able to rise to the challenge of the order - putting you and others in danger - you are certain that your word alone would allow him in or keep him out.$B$BMake your choice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10083,'I would speak against my brother joining the order, rushing a permanent breach in our relationship.  He would be a danger to himself and those around him, and that is too great a risk hoping he would improve over time.','I would speak against my brother joining the order, rushing a permanent breach in our relationship.  He would be a danger to himself and those around him, and that is too great a risk hoping he would improve over time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10084,'I would speak for my brother joining the order, potentially risking the safety of the order.  I could help him with the order\'s regimens, and I\'d have faith in his ability to adapt and learn.','I would speak for my brother joining the order, potentially risking the safety of the order.  I could help him with the order\'s regimens, and I\'d have faith in his ability to adapt and learn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10085,'I would create some surreptitious means to keep my brother out of the order.  I can keep him out without him being any bit wiser, thereby saving our familial bonds.','I would create some surreptitious means to keep my brother out of the order.  I can keep him out without him being any bit wiser, thereby saving our familial bonds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10086,'Your next choice awaits.$B$BYou alone have defeated a terrible beast that has been ravaging the countryside, taking its ear as a trophy.  You later learn that your liege had offered a reward for the beast\'s death, and that a kind but destitute knight who you know is trying to support a family by meager means claims the beast\'s kill as his own.  You have no real need for money yourself, but you know that the destitute knight is lying for his own personal gain.$B$BMake your choice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10087,'I would show my liege the beast\'s ear and claim the beast\'s death as my own, taking the reward for my own use.  It is wrong to claim a deed as your own that someone else in fact did.','I would show my liege the beast\'s ear and claim the beast\'s death as my own, taking the reward for my own use.  It is wrong to claim a deed as your own that someone else in fact did.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10088,'I would show my liege the beast\'s ear and claim the beast\'s death as my own - after all, I did slay it.  I would then offer some of the reward to the destitute knight to help his family.','I would show my liege the beast\'s ear and claim the beast\'s death as my own - after all, I did slay it.  I would then offer some of the reward to the destitute knight to help his family.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10089,'I would remain silent about the kill and allow the knight to claim the reward to aid his family.','I would remain silent about the kill and allow the knight to claim the reward to aid his family.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10090,'Your fortune is cast, $c.  For the next few hours, you will find your spirit in tune with your true nature.  Be careful, as your fortune - and your fate - are never as clear as you might think them to be.$B$BIf you would like a small glimpse of something to ponder in your future, by all means let me know.  I\'d be happy to give you a written fortune, provided you have room in your inventory.  It is one drawn from the insight you have shown in answering my questions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10091,'I\'d love to get one of those written fortunes you mentioned!  I\'ve got the space in my inventory for it.','I\'d love to get one of those written fortunes you mentioned!  I\'ve got the space in my inventory for it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10092,'Here is your fortune, $n.  May it serve you well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10093,'The Darkmoon Faire is coming to town!  Don\'t miss it!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(10094,'Be sure to catch all the amazing sights and wonders of the Darkmoon Faire when it comes to town!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(10095,'The Darkmoon Faire is coming!  There is fun for children of ALL ages!  Come one, come all!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(10096,'Step right up and hear about the most amazing spectacle in all of Azeroth - the Darkmoon Faire!  Huzzah!','',94,0,0,0,0,0,0,0,1,0,0,0,26124),
(10097,'The Darkmoon Faire is coming to town!  Don\'t miss it!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(10098,'The Darkmoon Faire is coming!  There is fun for children of ALL ages!  Come one, come all!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(10099,'Step right up and hear about the most amazing spectacle in all of Azeroth - the Darkmoon Faire!  Huzzah!','',94,0,0,0,0,0,0,0,1,0,0,0,26124),
(10100,'Be sure to catch all the amazing sights and wonders of the Darkmoon Faire when it comes to town!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(10101,'It\'s here!  The Darkmoon Faire is now open for business!  Be sure to see the most exciting show on all of Azeroth!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(10102,'The Darkmoon Faire has come to town!  Be sure to experience the most thrilling show you\'ll ever see!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(10103,'The Darkmoon Faire will only be live for a short time before the curtains are drawn closed.  Be sure to visit it today!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(10104,'Boys and girls - children of all ages - the Darkmoon Faire has arrived!  Huzzah!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(10105,'It\'s here!  The Darkmoon Faire is now open for business!  Be sure to see the most exciting show on all of Azeroth!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(10106,'The Darkmoon Faire has come to town!  Be sure to experience the most thrilling show you\'ll ever see!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(10107,'The Darkmoon Faire will only be live for a short time before the curtains are drawn closed.  Be sure to visit it today!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(10108,'Boys and girls - children of all ages - the Darkmoon Faire has arrived!  Huzzah!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(10109,'When the Darkmoon Faire arrives, where will it be located?','When the Darkmoon Faire arrives, where will it be located?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10110,'The Darkmoon Faire has already arrived, you say?  Where is it located?','The Darkmoon Faire has already arrived, you say?  Where is it located?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10111,'The next location of the Darkmoon Faire has not been finalized yet, but when it is you and I will be the first to know!','',1,94,0,0,0,0,0,0,1,0,0,0,26124),
(10112,'The Darkmoon Faire is right now located in Elwynn Forest, just south of Goldshire.  Don\'t miss it!','',1,94,0,0,0,0,0,0,1,0,0,0,26124),
(10113,'When the Darkmoon Faire is open, it will be located in Elwynn Forest.  We\'ll be pitching our tents just south of Goldshire!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(10114,'The Darkmoon Faire is right now located in the golden plains of Mulgore, just southwest of Thunder Bluff.  Don\'t miss it!','',1,94,0,0,0,0,0,0,1,0,0,0,26124),
(10115,'When the Darkmoon Faire opens, it will be located in Mulgore.  We\'ll be pitching our tents just southwest of Thunder Bluff!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(10116,'asdasd','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10117,'Hello friend.','Hello friend.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10118,'Sure are a lot of litter bugs around here.','Sure are a lot of litter bugs around here.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10119,'Having a good time?','Having a good time?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(10120,'Don\'t forget to buy refreshments and souvenirs!','Don\'t forget to buy refreshments and souvenirs!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10121,'The Darkmoon Faire is the greatest event on all of Azeroth!','The Darkmoon Faire is the greatest event on all of Azeroth!',71,0,0,0,0,0,0,0,1,0,0,0,26124),
(10122,'%s fixates on $n.','%s fixates on $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10123,'','Welcome to the Darkmoon Faire, $c!$B$BMy name is Kerri Hicks and I\'d shake your hand but I\'m afraid I\'d break it, because I\'m the strongest woman alive!',23,0,0,0,0,0,0,0,1,0,0,0,26124),
(10124,'','Hi $n!  Thanks for all the help you\'ve given me!  Right now I don\'t need anything, but who knows what the future will bring?$B$BEnjoy yourself, and remember to tell your friends about the Darkmoon Faire!',70,0,0,0,0,0,0,0,1,0,0,0,26124),
(10125,'Come to me and see what the future holds for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10126,'Come speak with me, and what once was cloudy shall become crystal clear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10127,'Fear not!  All fortunes can be discerned for those who know the way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10128,'The longer you wait, the less future you have for me to foretell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10129,'','Cheap beer!  Get your cheap beer right here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10130,'','Huzzah for the tipper!  Step right up and get your delicious, cold drinks right here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10131,'','Just in... another batch of Darkmoon Special Reserve.  Come get yours before they\'re all gone!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10132,'','You there!  Yes you!  You look thirsty.  Get over here, I have just what you need!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10133,'Step right up!  Get your red hot wings right here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10134,'Darkmoon Dogs fresh off the grill.  Come and get \'em while they\'re hot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10135,'You\'ve got money and we\'ve got food.  What are you waiting for?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10136,'For a limited time only, crunchy frog available exclusively here at the Darkmoon Faire.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10137,'Have a completed Darkmoon deck? Turn it in here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10138,'Come speak with me if you have any Darkmoon Faire Cards.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10139,'Darkmoon decks! Turn them in here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10140,'Have you any Darkmoon Faire cards?  Come speak with me to learn more about them if you dare!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10141,'','Every item that I have for sale I acquired myself.  You have my personal guarantee of authenticity.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10142,'','Darkmoon Faire Cards?  See the Professor here for those.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10143,'','Come and take a look at my wares while you still can.  We\'re here all week, and then we\'re off to some far off land.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10144,'','Have you any idea what I go through to bring these incomparable valuables to sell?  Come see them all for yourself!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10145,'Hey, someone help me catch this thing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10146,'It\'s getting away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10147,'Get back here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10148,'Frogs and leather balls for sale!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10149,'Tickets! Redeem your Darkmoon Prize Tickets here!  Wondrous and exotic prizes are waiting for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10150,'Mysterious prizes await the adventurous.  Step right up, step right up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10151,'Five tickets or five hundred, it doesn\'t matter friend, everybody is a winner!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10152,'Prizes!  Get your prizes right here!  Get over here and turn in your Darkmoon Prize Tickets for valuable prizes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10153,'Everyone enjoying themselves so far?  That\'s great!  Welcome to the Darkmoon Faire, the greatest show on all of Azeroth!  Make sure that you speak with Yebb and his friends here while you\'re taking in Neblegear\'s Darkmoon Zoo Bizarre.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10154,'Come one, come all.  Welcome to the Darkmoon Faire!  Don\'t be shy.  Step right up to Lhara and buy yourself an exotic artifact from far off lands.  If you\'re one of the lucky few who have found Darkmoon Cards, have a word with Professor Paleo.  Hungry?  Thirsty?  You\'re in luck!  Refreshments are available right here from Sylannia and Stamp.  I recommend the Darkmoon Special Reserve to wash down some Red Hot Wings.  And if the future is what you seek, then run, don\'t walk, to speak with Sayge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10155,'Welcome one and all to the Darkmoon Faire, the greatest event in all the world!  We have it all... delicious food, strong drink, exotic artifacts, fortunes read, amazing prizes and excitement without end!  Don\'t forget to turn in your Darkmoon Faire Prize Tickets to Gelvas Grimegate!  All it takes is five or more and you\'re on your way to the most wondrous prizes on all of Azeroth.  Everybody is a winner!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10156,'Welcome one and all to the greatest show on all of Azeroth... the Darkmoon Faire!  Adventure and excitement await, don\'t be shy!  Mysteries and prizes for both the young and the old are here for the taking.  And be sure to speak with the professor about any Darkmoon Cards that you have come across during your travels!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10157,'Greetings friends, and welcome to the greatest show on Azeroth!$B$BPlease, step right up and take in all we have to offer.  Ride the rides and see the sights!  Amaze at the wonders that the Darkmoon Faire has uncovered in this vast and mysterious world!  We have spared no expense in bringing you excitement that children of all ages will delight in!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10158,'Come one, come all!  Welcome to the Darkmoon Faire!  Do you crave adventure?  Do you seek exotic and mysterious treasures?  Then look no further!  You, my friend, have come to the right place!  Dive right in and take part in all that the Faire has to offer!  We\'ll be at this location all week, so be sure to tell your friends and loved ones!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10159,'Alas... I am sorry to say I cannot currently give you your fortune, as you have recently received a fortune reading from me.$B$BReturn to me several hours from when you first received your fortune.  The forces of Fate will have properly recalibrated themselves, and I will be able to see into your future.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10160,'We\'re back and better than ever!  It\'s the Darkmoon Faire friend, and it\'s your lucky day!  Sparing no expense, we\'ve gathered wonders and treats from around the world for your delight.  Whether you\'re young or old, rich or poor, the Darkmoon Faire has it all!  Be sure to turn in your Darkmoon Faire Prize Tickets to Gelvas Grimegate, and choose from several exotic and wondrous prizes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10161,'','$n, it\'s good to see you again!  Are you having fun at the Faire?$B$BWant to arm wrestle?  No, of course not... you want to keep your arm!',70,153,0,0,1000,0,0,0,1,0,0,0,26124),
(10162,'Greetings.  I am Chronos - He Who Never Forgets.  My memory is without flaw, and exact to the most minor detail.$B$BTrust me.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10163,'Hello again, $n.  Did you think I would forget you?$B$BI knew you would not.  You are a clever $c who knows a person with perfect memory when $ghe:she; sees him.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(10164,'Hello!  And welcome!  I\'m afraid my booth is not open... many repairs are needed...$B$BBut I am still bound by blood oath to put a smile on your face.  So please, smile, or I must cut off my hand and consume no living flesh until it regenerates...','',1,6,0,0,1000,0,0,0,1,0,0,0,26124),
(10165,'$n, you return!  The spirits of my last meal said you would come see me and that we would discuss business.$B$BWere they correct?','',1,6,0,0,1000,0,0,0,1,0,0,0,26124),
(10166,'Hello again, $n!  It\'s good to see you!  Our Darkmoon Faire is quite a show, don\'t you think?$B$BThere is quite a lot to see!  So look!  Look, and perhaps, one day, even more will be revealed to you...','',5,2,0,0,1000,0,0,0,1,0,0,0,26124),
(10167,'%s guzzles down the ale!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10168,'','I can\'t find my pet frog, Jubjub.  She loves Dark Iron Ale, it\'s all she ever drinks, but can be so hard to get!  Now I\'m out... and Jubjub must have run away to find more!$B$BI wish she would come back...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10169,'','I\'m so happy that Jubjub returned!  I only hope that I don\'t run out of Dark Iron ale soon, or I fear my pet frog might once again escape!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10170,'','Hi Jubjub.  I missed you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10171,'','Jubjub?  Where are you, Jubjub?  Oh no!  Where did you go this time!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10172,'%s hears her owner\'s voice!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10173,'We must ensure the survival of this camp at all costs, $c!  Our enemies must not be given any quarter, for they would surely give us none were we to need it.','',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(10174,'These are dangerous times, $r.  An ancient evil is rising, and it cares not if you\'re Horde or Alliance.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10175,'','Tasty drinks for sale!  Quench your thirst on some of the Darkmoon Faire\'s finest brews!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(10176,'','Don\'t be shy, buy a round for everyone!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(10177,'','Tips are always graciously accepted, friend.',24,0,0,0,0,0,0,0,1,0,0,0,26124),
(10178,'','Just in... another batch of Darkmoon Special Reserve.  Come get yours before they\'re all gone!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10179,'Show me the drinks!','Show me the drinks!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10180,'Ribbit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10181,'Kiss me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10182,'What do you have for sale?','What do you have for sale?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10183,'More bread boy!','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10184,'Here is your bread sir.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10185,'Mmm... food.','Mmm... food.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10186,'You mean to tell me you sell frogs?','You mean to tell me you sell frogs?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10187,'Molthor sees all, $r.','',1,25,0,0,0,0,0,0,1,0,0,0,26124),
(10188,'Greetings young $c. It is here that your Warchief challenged Orgrim Doomhammer! Although it happened so many years ago, it is an image still fresh in my mind.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10189,'How many of our Commanders are still alive, Drek\'Thar?','How many of our Commanders are still alive, Drek\'Thar?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10190,'$966w, young $c.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10191,'','Come to learn, eh? Well I just might have some work for you, scrub.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10192,'<Sergeant Stormpike salutes.>$B$BName, rank, and serial number, soldier! That\'s the only bit of information you\'ll ever give those dirty Frostwolf dogs!','',66,5,0,0,0,0,0,0,1,0,0,0,26124),
(10195,'Hmmm... I think I need better bait. I\'ll check my father\'s wagon.','',16,0,0,0,0,0,0,1,1,0,0,0,26124),
(10196,'Quillboar scraps! These should do the trick. Fish love Quillboar.','',4,0,0,0,0,0,0,1,1,0,0,0,26124),
(10197,'Let\'s give this a try...','',28,0,0,0,0,0,0,1,1,0,0,0,26124),
(10198,'I caught a fish if you are hungry...','',71,0,0,0,0,0,0,1,1,0,0,0,26124),
(10199,'$n has assaulted the Stables!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10200,'$n has assaulted the Stables!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10201,'$n has defended the Stables!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10202,'$n has defended the Stables!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10203,'The Alliance has taken the Stables!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10204,'The Horde has taken the Stables!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10205,'Caught one! I\'ll see if any of the guards are hungry. Come on Fang!','',71,0,0,0,0,0,0,1,1,0,0,0,26124),
(10206,'Zug zug! Happy to help!','',2,0,0,0,0,0,0,1,1,0,0,0,26124),
(10207,'How many of our Lieutenants are alive, Drek\'Thar?','How many of our Lieutenants are alive, Drek\'Thar?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10208,'$964w, young $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10209,'How many of the Stormpike\'s Officers are still alive, Drek\'Thar?','How many of the Stormpike\'s Officers are still alive, Drek\'Thar?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10210,'$962w Stormpike Commander(s) and $950w Stormpike Lieutenant(s).\n','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10211,'$n has assaulted the Blacksmith!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10212,'$n has assaulted the Blacksmith!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10213,'The Alliance has taken the Blacksmith!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10214,'The Horde has taken the Blacksmith!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10215,'$n has defended the Blacksmith!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10216,'$n has defended the Blacksmith!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10217,'$n has assaulted the Farm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10218,'$n has assaulted the Farm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10219,'The Alliance has taken the Farm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10220,'The Horde has taken the Farm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10221,'$n has defended the Farm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10222,'$n has defended the Farm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10223,'A nice catch it is at that! You bring honor to the Horde boy, we thank you!','',21,0,0,0,0,0,0,1,1,0,0,0,26124),
(10224,'$n has assaulted the Lumber Mill!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10225,'$n has assaulted the Lumber Mill!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10226,'The Alliance has taken the Lumber Mill!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10227,'The Horde has taken the Lumber Mill!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10228,'$n has defended the Lumber Mill!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10229,'$n has defended the Lumber Mill!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10230,'$n has assaulted the mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10231,'$n has assaulted the mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10232,'The Alliance has taken the mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10233,'The Horde has taken the mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10234,'$n has defended the mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10235,'$n has defended the mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(10236,'I promise you this much: The Valley will be ours.','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(10237,'How many of our Commanders are alive, Vanndar?','How many of our Commanders are alive, Vanndar?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10238,'$962w, soldier.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10239,'How many of our Lieutenants are alive, Vanndar?','How many of our Lieutenants are alive, Vanndar?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10240,'$950w, soldier.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10241,'How many Frostwolf Officers are alive, Vanndar?','How many Frostwolf Officers are alive, Vanndar?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10242,'$966w Frostwolf Commander(s) and $964w Frostwolf Lieutenant(s), soldier.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10243,'Soldiers of Stormpike, your General is under attack! I require aid! Come! Come! Slay these mangy Frostwolf dogs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10245,'Stormpike filth! In my keep?! Slay them all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10249,'Hmmm... Where is my fishing hook? Oh, there it is.','',16,0,0,0,0,0,0,1,1,0,0,0,26124),
(10250,'Let\'s see if the fish are biting.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10251,'','Trok are you hungry? I\'m making some food for us to eat! ',28,0,0,0,0,0,0,1,1,0,0,0,26124),
(10252,'','Trok? Why are you running around like fearful human?',22,0,0,0,0,0,0,1,1,0,0,0,26124),
(10253,'','You\'re supposed to be doing your chores!',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10255,'','I wonder if the pigs are hungry...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10256,'','Are you piggies hungry? I have some food for you...',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10257,'','I guess you were hungry! Trok was supposed to have fed you earlier... What has he been doing all this time?',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(10259,'Help! I\'m being chased by a swarm of bees!','',22,0,0,0,0,0,0,1,1,0,0,0,26124),
(10260,'I\'m so tired of running, but these bees won\'t leave me alone!','',22,0,0,0,0,0,0,1,1,0,0,0,26124),
(10261,'I didn\'t know bees didn\'t like fire!','',22,0,0,0,0,0,0,1,1,0,0,0,26124),
(10262,'Karu will you please help get these bees off of me? They sting!','',22,0,0,0,0,0,0,1,1,0,0,0,26124),
(10265,'Aaahh... Very good. Now scat!','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10266,'As you wish sir.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10267,'Right away sir.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10268,'If you have come to save the world then you have come to the right place. The faceless one - the Blood God, Hakkar - has been brought back into our world!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10269,'The strength of your resolve shines, $n. You continue to prove that you are an asset to our people. Someday the world will realize the extent of your great deeds.','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(10270,'The burgeoning hero returns! It is good to see you again, $n. You are always welcome at our village.','',66,1,0,0,0,0,0,0,1,0,0,0,26124),
(10271,'I knew of another like you once... His name was Vol\'jin. You are a rare breed, my friend.','',1,2,0,0,0,0,0,0,1,0,0,0,26124),
(10272,'Long is the way, and hard, the road you have traveled. Few reach such status amongst our ranks. You are a great friend of the Zandalar empire, $n.$B$BLegendary perhaps... Yes... Perhaps.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10273,'Right away sir.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10274,'','Can I go collect more rocks for my necklace, Papa?',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10275,'Yes you may, Okla. But do not stray too far from home. ','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10276,'','Dabu! I will be careful Papa!',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10277,'','Ooohh... This rock is nice and colorful. Let\'s see if I can find more like it...',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10278,'','Hmm... That rock is nice, but too small.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10279,'','This is a shiney rock, I\'ll put it in my bucket. Ok, I just need a few more...',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10280,'','I bet my friend Gruk would like this rock for the spear he is making! It\'s very sharp... I hope he likes it.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10281,'','There... That should be enough rocks to make a necklace. I should probably get home now anyway.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10282,'$n claims the mine!  If left unchallenged, the Alliance will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10283,'$n claims the mine!  If left unchallenged, the Horde will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10284,'$n claims the lumber mill!  If left unchallenged, the Alliance will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10285,'$n claims the lumber mill!  If left unchallenged, the Horde will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10286,'$n claims the stables!  If left unchallenged, the Alliance will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10287,'$n claims the stables!  If left unchallenged, the Horde will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10288,'$n claims the farm!  If left unchallenged, the Alliance will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10289,'$n claims the farm!  If left unchallenged, the Horde will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10290,'$n claims the blacksmith!  If left unchallenged, the Alliance will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10291,'$n claims the blacksmith!  If left unchallenged, the Horde will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10292,'','Yummy. I love roasted Plainstrider.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10293,' I am going to practice and become a warrior like my father!','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10294,'Now to find an unsuspecting Harpy!','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10295,'There\'s one! For the Horde!','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10296,'Take that you mangy Harpy! Hyaa!','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10297,'You can\'t get away from a warrior of The Horde! Take that! And that!','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10298,'Now go back home where you belong! ','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10299,'Aaahhh... Another glorious victory for The Horde! ','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10300,'','Mogg, get inside. It is not safe out there while your father is gone.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10301,'Yes right away momma! ','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10303,'When is pappa coming back from the fights in Warsong? It has been so long... ','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10304,'','Soon child... very soon.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10305,'','What happened to our pigs?',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(10306,'Guard, Bring forth the prisoner. Place him in the Circle of Binding.','',0,0,0,0,0,0,0,14,1,0,0,0,26124),
(10307,'Right away, Servitor.','',0,0,0,0,0,0,0,14,1,0,0,0,26124),
(10308,'Move!','',0,0,0,0,0,0,0,14,1,0,0,0,26124),
(10309,'Kneel, heathen.','',0,0,0,0,0,0,0,14,1,0,0,0,26124),
(10310,'Curious. A Servitor of Rastakhan that does not know the Hakkari do not converse in the old tongue?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10311,'I said KNEEL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10312,'Do you know who I am, zealot?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10313,'You are a fool, soon to forfeit his life. No?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10314,'I could crush you with but a single motion. Do not anger me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10315,'%s laughs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10316,'How pathetic. I am infused with the power of the Soulflayer. I fear nothing but the wrath of the almighty Hakkar. I serve no one but my master, Jin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10317,'So Hakkar has returned?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10318,'Do you really need to ask? Can you not feel him? Has the almighty King Rastakhan sent his Servitor and Hand here on a mission of diplomacy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10319,'Oh yes, old one, Hakkar has returned. Soon the world shall crumble beneath his might. Consumed. Left in ruin...','Oh yes, old one, Hakkar has returned. Soon the world shall crumble beneath his might. Consumed. Left in ruin...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10320,'We will never allow it... We have banished him from our world before and we will banish him again.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10321,'%s laughs maniacally.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10322,'FOOL! Do you purport to have even one-tenth of the power you held during the Uprising? The nations were united and still were nearly consumed by a shadow of Hakkar. You stand no chance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10323,'And now, even those nations that you would have called allies have recoiled and joined forces with us... Yes, old one, do not look so surprised.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10324,'Bloodscalp, Sandfury, Skullsplitter, Vilebranch and Witherbark. They all pledge their allegiance to Jin - their souls to Hakkar. You have lost.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10325,'Times have changed. The young races will join us. You will never succeed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10326,'The young races? The infants? Humans? Orcs? Dwarves? You expect to defeat the Hakkari? To destroy a GOD?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10327,'It shall NEVER happen. We are legion. We are united. Where are your heroes? Vol\'jin sits in sanctuary at the side of the young Warchief, unaware. Zul\'jin missing, probably dead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10328,'And... do you expect to defeat the Primal Gods?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10329,'%s smirks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10330,'The Primal Gods? Impossible!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10331,'Is it? Call out to them, Servitor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10332,'%s uses his index finger to make a cutting motion across his neck.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10333,'Where are your Gods now? WHERE, SERVITOR?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10334,'Strike me down. I shall be reborn... Even more powerful...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10335,'%s drops his shoulders and exposes his neck.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10336,'%s spits on the corpse of the fallen zealot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10337,'I would like to enter my e-coupon code to win the virtual item.','I would like to enter my e-coupon code to win the virtual item.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10338,'Welcome to the iCoke-WOW summer promotion.$B$BDear $n, the halo of fortune goddess is shining on you.  Obey to the order of god; you\'ll get a special and mystery present.  Now, the gate of Azeroth is open for you.  A great adventure will begin soon.  Are you ready?$B$BMay the honor be with you!','Welcome to the iCoke-WOW summer promotion.$B$BDear $n, the halo of fortune goddess is shining on you.  Obey to the order of god; you\'ll get a special and mystery present.  Now, the gate of Azeroth is open for you.  A great adventure will begin soon.  Are you ready?$B$BMay the honor be with you!',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(10339,'','Guse is joining the battle! Time to take out the Stormpike filth!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10340,'','Awaiting orders!',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(10341,'The time has come, Guse. You fly again!','The time has come, Guse. You fly again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10342,'','Jeztor\'s coming for you, Stormpike!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10343,'Jeztor lives! Time to light up the Valley sky, Commander.','Jeztor lives! Time to light up the Valley sky, Commander.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10344,'','Let me at \'em, $n! Just give the word and I\'ll mount up and attack their bridge!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(10345,'I\'m ready, sir! Just give the word and I will rain down hellfire upon their base!','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(10346,'Do you feel it, Mulv? The need? You have to want it before I can give you the command. Who am I kidding. Get out there!','Do you feel it, Mulv? The need? You have to want it before I can give you the command. Who am I kidding. Get out there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10347,'Incoming aerial support to Dun Baldar! Stormpike bow down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10348,'I\'m ready to fly, Commander. Just give the word and I\'ll be on their base like trogg on rock.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10349,'Take the base. We\'ll be sieging it from the ground.','Take the base. We\'ll be sieging it from the ground.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10350,'I\'ll patrol the pass leading up to Frostwolf Keep. Just give me the word and I\'ll take flight, Commander.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10351,'I want a surgical strike, Slidore. Carpet the road with fire!','I want a surgical strike, Slidore. Carpet the road with fire!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10352,'Make the call, Commander. I\'ll tear the bottom half of their base apart.','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(10353,'Tactical suppression fire, Vipore. Lay it on thick.','Tactical suppression fire, Vipore. Lay it on thick.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10354,'','Greetings $c.  Do you wish to aid the Silverwing Sentinels in their fight at Warsong Gulch?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(10355,'I would like to go to the battleground.','I would like to go to the battleground.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10356,'I\'m coming Frostwolf, and this time you\'re gonna feel the flames!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10357,'Senior Wing Commander Vipore, launching. Pray for a swift death, Frostwolf.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10358,'Drek\'Thar, I\'m coming for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10359,'Battlemaster','Battlemaster',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10360,'','Elune be praised!  You seek out our Warsong Gulch Battlemaster?  Her name is Aethalas, and she stands ready to greet you near the warrior trainers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10361,'','It is no light endeavor upon which you embark $n.  To get to Warsong Gulch you will want to speak to Aethalas, the Battlemaster of the Silverwing Sentinels.  She will guide your way.  Blessings of the Goddess be with you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10362,'Battlemaster','Battlemaster',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10363,'So $g lad : lass;, you think you have what it takes to defend the Alliance against the Horde in Alterac Valley?  Very well then, you will want to speak with our very own Glordrum Steelbeard here in Ironforge.  You\'ll find him strategizing over the war table in the Hall of Arms.','So $g lad : lass;, you think you have what it takes to defend the Alliance against the Horde in Alterac Valley?  Very well then, you will want to speak with our very own Glordrum Steelbeard here in Ironforge.  You\'ll find him strategizing over the war table in the Hall of Arms.',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(10364,'Ah, Alterac Valley, I have fine memories I tell ya.  <sigh>  Well, I cannot join ya, but do me proud just the same!  To get there you\'ll be wanting to speak with Glordrum Steelbeard at the Hall of Arms here in Ironforge.','Ah, Alterac Valley, I have fine memories I tell ya.  <sigh>  Well, I cannot join ya, but do me proud just the same!  To get there you\'ll be wanting to speak with Glordrum Steelbeard at the Hall of Arms here in Ironforge.',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(10365,'Battlemaster','Battlemaster',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10366,'If you are going to Alterac Valley then go speak to Kartra Bloodsnarl. You will find her inside the Hall of the Brave in the Valley of Honor.','If you are going to Alterac Valley then go speak to Kartra Bloodsnarl. You will find her inside the Hall of the Brave in the Valley of Honor.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10367,'How I yearn to join you in glorious battle, but instead I am stuck here on duty. Go to the Hall of the Brave in Orgrimmar\'s Valley of Honor and speak to Kartra Bloodsnarl. She will help you get to Alterac Valley. Make us proud $n!','How I yearn to join you in glorious battle, but instead I am stuck here on duty. Go to the Hall of the Brave in Orgrimmar\'s Valley of Honor and speak to Kartra Bloodsnarl. She will help you get to Alterac Valley. Make us proud $n!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10368,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10369,'','I command you to rain fire down upon these invaders!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10370,'','%s emits a deafening shriek!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10371,'Tell me about the iCoke promotion.','Tell me about the iCoke promotion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10372,'World of Warcraft and Coca-Cola (R) have teamed up to bring you the iCoke-World of Warcraft Summer Promotion.  Look for codes under the caps of specially marked bottles of Coca-Cola.  Then return here and enter the code to win a virtual item.','World of Warcraft and Coca-Cola (R) have teamed up to bring you the iCoke-World of Warcraft Summer Promotion.  Look for codes under the caps of specially marked bottles of Coca-Cola.  Then return here and enter the code to win a virtual item.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10373,'You\'ll never get me out of me bunker, heathens!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10374,'Why don\'t ya try again without yer cheap tactics, pansies! Or are you too chicken???','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10375,'','Filthy Frostwolf cowards! If you want a fight, you\'ll have to come to me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10376,'Stormpike weaklings, face me in my fortress - if you dare!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10377,'You seek to draw the General of the Frostwolf legion out from his fortress? PREPOSTEROUS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10378,'I\'ll never fall for that, fool! If you want a battle, it will be on my terms and in my lair.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10379,'I am Jin\'rokh the Breaker, envoy of Mugamba: Fist of Rastakhan!$B$BMy dealings are with warriors and heathens.','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(10380,'I have lost my talisman and require a new one, Jin\'rokh.','I have lost my talisman and require a new one, Jin\'rokh.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10381,'I am Al\'tabim the All-Seeing - an envoy of King Rastakhan.$B$BMy dealings are with priests, mages, and warlocks.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10382,'The League of Arathor has sworn to retake Arathi for humans of Stromgarde and the Alliance.  It is a battle hard fought, but a battle worth fighting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10383,'','To win this war, we can\'t sit idle and let the tides sweep us over.  We must strike, hard and fast, or Arathi will never again be ours.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10384,'I have lost the talisman and require a new one, Al\'tabim.','I have lost the talisman and require a new one, Al\'tabim.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10385,'','I know just the one that you speak of $c. You must seek out Brogun Stoneshield on the Warrior\'s Terrace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10386,'','The Stormpike Guard is in need of your assistance in the fight against the Frostwolf Clan, $n. Speak to Brogun Stoneshield on the Warrior\'s Terrace and he will help you find your way to Alterac Valley. Elune be praised!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10387,'','There are several battlegrounds from which to choose.  To which battlemaster shall I send you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10388,'Alterac Valley','Alterac Valley',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10389,'Warsong Gulch','Warsong Gulch',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10390,'We must eliminate the elves and their cowardly Alliance from Warsong Gulch. Go to the Hall of the Brave in the Valley of Honor and speak with Brakgul Deathbringer if you have what it takes to aid the Horde.','We must eliminate the elves and their cowardly Alliance from Warsong Gulch. Go to the Hall of the Brave in the Valley of Honor and speak with Brakgul Deathbringer if you have what it takes to aid the Horde.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10391,'The Silverwing Sentinels are hardly what I would call honorable opponents. But if you are intent upon their slaughter $c, then seek out Brakgul Deathbringer in the Hall of the Brave.','The Silverwing Sentinels are hardly what I would call honorable opponents. But if you are intent upon their slaughter $c, then seek out Brakgul Deathbringer in the Hall of the Brave.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10392,'Which battleground do you seek your glory in?','Which battleground do you seek your glory in?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10393,'Alterac Valley','Alterac Valley',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10394,'Warsong Gulch','Warsong Gulch',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10395,'Then it is to Taim Ragetotem that you must speak. Seek him out on the Hunter Rise.','Then it is to Taim Ragetotem that you must speak. Seek him out on the Hunter Rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10396,'There is one that I know of here in Thunder Bluff that can aid you in your journey to Alterac Valley. On the Hunter Rise look for Taim Ragetotem. May you find what you are looking for $n.','There is one that I know of here in Thunder Bluff that can aid you in your journey to Alterac Valley. On the Hunter Rise look for Taim Ragetotem. May you find what you are looking for $n.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10398,'Kergul Bloodaxe on the Hunter Rise stands ready to help you get to Warsong Gulch.','Kergul Bloodaxe on the Hunter Rise stands ready to help you get to Warsong Gulch.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10399,'Such needless strife, but if the elves of Silverwing Hold will not speak to us in peace, then what alternative do they leave us? Seek out the aid of Kergul Bloodaxe on the Hunter Rise to get to Warsong Gulch.','Such needless strife, but if the elves of Silverwing Hold will not speak to us in peace, then what alternative do they leave us? Seek out the aid of Kergul Bloodaxe on the Hunter Rise to get to Warsong Gulch.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10400,'And to which battleground do you wish to journey?','And to which battleground do you wish to journey?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10401,'Alterac Valley','Alterac Valley',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10402,'Warsong Gulch','Warsong Gulch',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10403,'Battlemaster','Battlemaster',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10404,'It cold there! You go in Royal Quarter, talk to Grizzle Halfmane.','It cold there! You go in Royal Quarter, talk to Grizzle Halfmane.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10405,'Him name is Grizzle Halfmane. He in Royal Quarter with Banshee Queen and Dread Lord.','Him name is Grizzle Halfmane. He in Royal Quarter with Banshee Queen and Dread Lord.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10406,'Think him in Royal Quarter. Kurden Bloodclaw is little orc.','Think him in Royal Quarter. Kurden Bloodclaw is little orc.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10407,'Elves in Warsong Gulch make crunchy sound. You crunch them good. Talk to Kurden Bloodclaw in Royal Quarter.','Elves in Warsong Gulch make crunchy sound. You crunch them good. Talk to Kurden Bloodclaw in Royal Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10408,'What battleground you want?','What battleground you want?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10409,'Alterac Valley','Alterac Valley',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10410,'Warsong Gulch','Warsong Gulch',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10411,'Battlemaster','Battlemaster',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10412,'Warsong Gulch you say? Well then, you\'ll be wanting to speak with fair Lylandris over in the Hall of Arms.','Warsong Gulch you say? Well then, you\'ll be wanting to speak with fair Lylandris over in the Hall of Arms.',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(10413,'Any chance to fight against the Horde, especially orcs, is a good time if you ask me. You\'ll find plenty of battle in Warsong Gulch, that you will. Head on over to the Hall of Arms and speak with Lylandris. She\'ll set you on your way.','Any chance to fight against the Horde, especially orcs, is a good time if you ask me. You\'ll find plenty of battle in Warsong Gulch, that you will. Head on over to the Hall of Arms and speak with Lylandris. She\'ll set you on your way.',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(10414,'Aye, and which battleground be ye looking for?','Aye, and which battleground be ye looking for?',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(10415,'Alterac Valley','Alterac Valley',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10416,'Warsong Gulch','Warsong Gulch',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10417,'Then it is Thelman Slatefist that you wish to speak to. You can find him in the presence of the King at Stormwind Keep.','Then it is Thelman Slatefist that you wish to speak to. You can find him in the presence of the King at Stormwind Keep.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(10418,'And I wish I could join you $n. Head over to Stormwind Keep. You\'ll find Thelman Slatefist in the King\'s audience chamber. He will aid you in getting to Alterac Valley.','And I wish I could join you $n. Head over to Stormwind Keep. You\'ll find Thelman Slatefist in the King\'s audience chamber. He will aid you in getting to Alterac Valley.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(10419,'Indeed, Silverwing Hold is in need of your assistance. Speak with Elfarran in the audience chamber at Stormwind Keep.','Indeed, Silverwing Hold is in need of your assistance. Speak with Elfarran in the audience chamber at Stormwind Keep.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(10420,'The Silverwing Sentinels can use all the help they can get in their fight against the Warsong Outriders. $n, go to Stormwind Keep and speak with Elfarran if you wish to assist them.','The Silverwing Sentinels can use all the help they can get in their fight against the Warsong Outriders. $n, go to Stormwind Keep and speak with Elfarran if you wish to assist them.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(10421,'Which battleground are you interested in?','Which battleground are you interested in?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(10422,'Alterac Valley','Alterac Valley',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10423,'Warsong Gulch','Warsong Gulch',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10424,'Battlemaster','Battlemaster',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10425,'%s fully engulfs in flame and a maddened look appears in his eyes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10426,'','What you be expectin\', mon?$B$BMaywiki only be dealin\' with the druids and shaman.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10427,'Maywiki, I\'ve lost my talisman and require a replacement.','Maywiki, I\'ve lost my talisman and require a replacement.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10428,'Greetings, $c.  It is the time of the Harvest Festival - a time of great bounties and a time of remembrance.  We partake of feasts to celebrate all we have to be thankful of, and we remember our ancestors and past heroes to give thanks to the legacy they gave us.$B$BPlease feel free to partake of the feast being offered here.  Also, I am offering some fireworks to help celebrate this joyous time of year.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(10429,'Let me browse your selection of fireworks.','Let me browse your selection of fireworks.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(10430,'Greetings, $c.  It is the time of the Harvest Festival - a time of great bounties and a time of remembrance.  We partake of feasts to celebrate all we have to be thankful of, and we remember our ancestors and past heroes to give thanks to the legacy they gave us.$B$BPlease feel free to partake of the feast being offered here.  Also, I am offering some fireworks to help celebrate this joyous time of year.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(10431,'','We must not allow the Alliance to expand their power base in Arathi!  Even their miniscule Refuge Pointe may one day grow to threaten us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10432,'The battle for Arathi Basin is a battle for resources.  Lumber, ore, food... all these are needed in order to wage a good war.$B$BDenying our enemies of their supplies is as good as killing them on the battlefield.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10433,'Sightless I may be, but vision I have.$B$BMy primary dealings are with hunters and rogues, $r.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10434,'You be dead soon!','You be dead soon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10435,'I gonna make you into mojo!','I gonna make you into mojo!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10436,'Your skull gonna decorate our ritual altars!','Your skull gonna decorate our ritual altars!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10437,'Troll mojo da strongest mojo!','Troll mojo da strongest mojo!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10438,'Feel da big bad voodoo!','Feel da big bad voodoo!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10439,'I have lost the talisman, Falthir. I require a replacement.','I have lost the talisman, Falthir. I require a replacement.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10440,'Hail, adventurer. I am Rin\'wosho, trader of Zuldazar. I come from the South Seas and bring many exotic goods and items from my homeland.$B$BPerhaps if you prove your worth to my tribe, I shall barter.  If you have any of my tribe\'s Honor Tokens, then perhaps we shall barter even more.','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(10441,'Let us barter, Rin\'wosho. Show me what goods are available!','Let us barter, Rin\'wosho. Show me what goods are available!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10442,'Rin\'wosho, I require repairs.','Rin\'wosho, I require repairs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10443,'','Shadra, make of me your avatar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10444,'','The brood shall not fall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10445,'%s is fully grown!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10446,'Make peace, worms.  I be deliverin\' you to Hakkar myself!','',0,0,0,0,0,0,0,0,1,0,24289,0,26124),
(10447,'PRIDE HERALDS THE END OF YOUR WORLD.  COME, MORTALS!  FACE THE WRATH OF THE SOULFLAYER!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10448,'','Aid me my brood!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10449,'Welcome to the great show, friends.  Step right up to die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10450,'','At last, I am free of the Soulflayer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10451,'Hakkar binds me no more!  Peace at last!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10452,'','Finally...death!  Curse you, Hakkar!  Curse you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10453,'%s dies.','%s dies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10454,'%s is resurrected by a nearby ally!','%s is resurrected by a nearby ally!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10455,'Shirvallah, fill me with your RAGE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10456,'It is true, $n.  The wheels of doom now turn, inevitably, toward the true return of Hakkar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10457,'Blood and souls for Hakkar!  HAHAHAH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10458,'Betina, I\'d like a replacement Seal of the Dawn please!','Betina, I\'d like a replacement Seal of the Dawn please!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10459,'','Bless you, mortals, for this release...Hakkar controls me no longer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10460,'Ssserenity...at lassst!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10461,'','Bethekk, your priestess calls upon your might!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10462,'Betina, I\'d like a replacement Rune of the Dawn please!','Betina, I\'d like a replacement Rune of the Dawn please!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10463,'I am Zanza, a Loa of Zandalar. I have come in this ethereal form from Zandalar to help my people. Hakkar has no dominion over my soul.$B$BI help those that have helped the Zandalarian people.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10464,'A friend of the Zandalrian! You have ventured deep into the lair of the Blood God, $c. You will do well to listen to what I have to say.$B$BMany thousands of years ago, while the indigenous trolls of the Zul\'Aman empire were battling the invading high elf heathens, great magic was stolen from Zanza. This magic was used by the high elves to enchant their weapons and armor to assist in conquering the trolls of the region.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10465,'I think I have heard of this magic.','I think I have heard of this magic.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10466,'Have you? Then you know how weak and pathetic the high elf version of troll magic was?$B$BThe high elves could not understand why a people with their magical affinity could not contend with the powers of troll voodoo. This was an inconceivable notion for the pale skins to understand. They were resigned to using the bastardized version of troll enchantments. I believe they called them \'Arcanum.\'\n','',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(10467,'Arcanum? That sounds very familiar.','Arcanum? That sounds very familiar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10468,'Zanza can create the ancient troll enchantments with the right components. This magic will help you in defeating Hakkar and his minions.$B$BI only ask that you bring me two items.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10469,'What are the components?','What are the components?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10470,'The first is a primal token that must be taken from the most powerful of the Hakkari lieutenants: Jin\'do and the Bloodlord.$B$BThe second is a punctured voodoo doll. These can be found in the piles of refuse that litter this foul place. Look inside the jinxed Hoodoo piles.$B$BBring me these things and I will create a powerful enchantment for you!','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(10471,'I am sorry $c, but you are not seasoned enough yet to enter Warsong Gulch.','I am sorry $c, but you are not seasoned enough yet to enter Warsong Gulch.',274,0,0,1,0,0,0,0,1,0,0,0,26124),
(10472,'','Feast on $n, my pretties!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10473,'Now, only one step remains to rid us of the Soulflayer\'s threat...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10474,'Begin the ritual, my servants.  We must banish the heart of Hakkar back into the void!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10475,'Welcome to the Booty Bay fishing contest where each week we reward the finest fishermen in all of Azeroth.\n\nWhen the fishing tournament begins, you will be able to catch tastyfish from any fishing node in Stranglethorn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10476,'Greetings, $c.  I am Exzhal, Servitor of Rastakhan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10477,'The battle will begin in 1 minute.','The battle will begin in 1 minute.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10478,'The battle will begin in 30 seconds.','The battle will begin in 30 seconds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10479,'The battle has begun!','The battle has begun!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10480,'Do not be lured into the mortals\' trap.  Bathe in my power!  Be renewed and destroy the heretics!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10481,'I am sorry $c, but you need to be more experienced before you can survive in Alterac Valley.','I am sorry $c, but you need to be more experienced before you can survive in Alterac Valley.',274,0,0,1,0,0,0,0,1,0,0,0,26124),
(10482,'What are the Paragons of Power?','What are the Paragons of Power?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10483,'The Paragons of Power are remnants from the ancient Gurubashi Empire.  We Zandalar seek them - not only are they of tremendous collectible value to us, but we believe that they also hold latent signatures of magic used by the old Empire.$B$BYou\'ll more than likely discover three kinds of Paragons in Zul\'Gurub: coins, bijous, and primal items.  Bring them to us in the quantities that we seek, and you\'ll be rewarded with some of the finest items we Zandalar have ever crafted.\n','The Paragons of Power are remnants from the ancient Gurubashi Empire.  We Zandalar seek them - not only are they of tremendous collectible value to us, but we believe that they also hold latent signatures of magic used by the old Empire.$B$BYou\'ll more than likely discover three kinds of Paragons in Zul\'Gurub: coins, bijous, and primal items.  Bring them to us in the quantities that we seek, and you\'ll be rewarded with some of the finest items we Zandalar have ever crafted.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10484,'The markings of this tablet show ancient diagrams and hold dire words of power, but their meaning is inscrutable to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10485,'The markings on this tablet show ancient diagrams and dire words of power, used to create  Gurubashi Mojo Madness...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10486,'Learn the recipe.','Learn the recipe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10487,'The markings of this tablet show ancient diagrams and hold dire words of power.$B$BYou believe it is an alchemical recipe, but it is beyond your skill...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10488,'If you ask me, the best part about fishing is its slow pace.  It gives one time to think, to reflect on past events and to plan for future ones.$B$BOh, and it\'s also a great excuse to drink.  Heavily.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10489,'Thanks again for returning my lucky measuring tape, $n.  I swear it helps me catch bigger fish!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10490,'I want to catch Gahz\'ranka!  Tell me how!','I want to catch Gahz\'ranka!  Tell me how!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10491,'To catch Gahz\'ranka, you\'ll need a special Mudskunk lure.  I make \'em myself!$B$BBut you need more than just the lure; you need some mudskunks too... you need to place them in the lure to give it a rank old smell!$B$BWhen you have the mudskunks, throw the lure off Pagle\'s Point in Zul\'Gurub... and then grab a drink and wait... but not too long, because Gahz\'ranka is sure to come a\'stomping!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10492,'Nat, I want to buy your mudskunk lures!','Nat, I want to buy your mudskunk lures!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10493,'*Whirr* *CLANK*\n\nI have been instructed to accept high quality rare fish and return valuable Nat Pagle fishing accessories.   Fish Requested.\n\n*THUMP* *Buzz*\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10494,'','%s begins to cast a Great Heal!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10495,'I am sorry $c, but you need to be more powerful before I can allow you to enter Arathi Basin.','I am sorry $c, but you need to be more powerful before I can allow you to enter Arathi Basin.',274,0,0,1,0,0,0,0,1,0,0,0,26124),
(10496,'Gri\'lek, of the Iron Blood$B$BThe wanderer.  May his strength and lust for battle pierce the ages.  $B$BGri\'lek now dwells far from here.  One day, he may return...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10497,'Arathi Basin','Arathi Basin',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10498,'Go to the Hall of the Brave.  You will find The Defiler, Deze Snowbane there to assist you in getting to Arathi Basin.','Go to the Hall of the Brave.  You will find The Defiler, Deze Snowbane there to assist you in getting to Arathi Basin.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10499,'You wish to help the Forsaken with their fight against the humans in Arathi Basin?  Then go to the Hall of the Brave and speak with Deze Snowbane.','You wish to help the Forsaken with their fight against the humans in Arathi Basin?  Then go to the Hall of the Brave and speak with Deze Snowbane.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10500,'How do I catch the mudskunks for your lure?','How do I catch the mudskunks for your lure?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10501,'Arathi Basin','Arathi Basin',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10502,'Mudskunks are a particularly smelly breed of fish that likes tropical waters.  The Zulian Mudskunk - the smelliest of them all, can only be found in the steamy waters of Zul\'Gurub.$B$BThe Zulian Mudskunks are what I believe attracted Gahz\'ranka to the place, though trolls will probably tell you he\'s one of their gods...$B$BBelieve what you like, but mark me - fill one of my lures with Zulian Mudskunks and that old boy will come, for sure!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10503,'You go Royal Quarter.  See Sir Malory Wheeler.  Him scary.','You go Royal Quarter.  See Sir Malory Wheeler.  Him scary.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10504,'Arathi Basin place to take from soft humans.  Sir Malory Wheeler send you there.','Arathi Basin place to take from soft humans.  Sir Malory Wheeler send you there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10505,'DING!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10507,'Your deaths feed my strength!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10508,'Arathi Basin','Arathi Basin',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10509,'You may seek out Martin Lindsey inside the Pools of Vision, underneath the Spirit Rise.  He will assist you on your way to Arathi Basin.','You may seek out Martin Lindsey inside the Pools of Vision, underneath the Spirit Rise.  He will assist you on your way to Arathi Basin.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10510,'You wish to aid The Defilers in their fight against The League of Arathor in Arathi Basin?  Very well, you should ask Martin Lindsey for his assistance then.  Look for him in the Pools of Vision.','You wish to aid The Defilers in their fight against The League of Arathor in Arathi Basin?  Very well, you should ask Martin Lindsey for his assistance then.  Look for him in the Pools of Vision.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10511,'Arathi Basin','Arathi Basin',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10512,'The humans are in need of your assistance in their fight against The Forsaken at Arathi Basin.  Go to the Hall of Arms and speak with their representative, Donal Osgood.','The humans are in need of your assistance in their fight against The Forsaken at Arathi Basin.  Go to the Hall of Arms and speak with their representative, Donal Osgood.',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(10513,'The League of Arathor is trying to reclaim their ancestral holdings in Arathi Basin from the Forsaken.  If you would aid them $n speak to Donal Osgood in the Hall of Arms.','The League of Arathor is trying to reclaim their ancestral holdings in Arathi Basin from the Forsaken.  If you would aid them $n speak to Donal Osgood in the Hall of Arms.',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(10514,'Arathi Basin','Arathi Basin',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10515,'In the King\'s audience chamber you will find the Lady Hoteshem.  She can assist you in getting to Arathi Basin where The League of Arathor is in need of assistance against The Defilers.','In the King\'s audience chamber you will find the Lady Hoteshem.  She can assist you in getting to Arathi Basin where The League of Arathor is in need of assistance against The Defilers.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(10516,'It\'s admirable what The League of Arathor is attempting to do in Arathi Basin.  Too bad those undead abominations and their Horde friends are standing in the way.  Head over to Stormwind Keep.  Lady Hoteshem awaits you in the King\'s audience chamber.  She can help you to get to Arathi Basin.','It\'s admirable what The League of Arathor is attempting to do in Arathi Basin.  Too bad those undead abominations and their Horde friends are standing in the way.  Head over to Stormwind Keep.  Lady Hoteshem awaits you in the King\'s audience chamber.  She can help you to get to Arathi Basin.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(10517,'Arathi Basin','Arathi Basin',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10518,'','The humans definitely need all of our help in Arathi Basin.  The one that you wish to speak to is named Keras Wolfheart.  He stands ready to assist you on the Warrior\'s Terrace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10519,'','If that is your wish $c, then you will need to speak to Keras Wolfheart on the Warrior\'s Terrace.  He is a representative of The League of Arathor and can help you to get to Arathi Basin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10520,'Throm\'ka $c!  Are you ready to fight for the Horde at Warsong Gulch?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10521,'','Hail to thee $n.  Do you wish me to aid you in your journey to Warsong Gulch?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(10522,'$n, the Silverwing Sentinels must be crushed!  Are you ready for Warsong Gulch?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10523,'Are you here to fight for us at Warsong Gulch?  Lok\'tar Ogar $c!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10524,'','$C, we need your assistance at Warsong Gulch.  Will you aid us in our fight against the Warsong Outriders?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(10525,'Aye $g lad : lass; are ye ready to head to Alterac Valley and give the Horde a taste o\' what they been asking for?','',1,0,0,1,0,0,0,7,1,0,0,0,26124),
(10526,'$n, have ye any idea o\' what we\'re up against in Alterac Valley?  Are ye ready to fight the Frostwolf Clan?','',5,0,0,1,0,0,0,7,1,0,0,0,26124),
(10527,'The Stormpike Guard must be destroyed!  Ready for Alterac Valley $c?','',5,0,0,1,0,0,0,1,1,0,0,0,26124),
(10528,'','Lok\'tar $c!  We have need of your services in Alterac Valley.  Shall I add you to the lists?',66,0,0,1,0,0,0,1,1,0,0,0,26124),
(10529,'Our forces in Alterac Valley need wisdom to achieve victory $c.  You look like the one to lead them.','',1,0,0,1,0,0,0,1,1,0,0,0,26124),
(10530,'I hope that you are here to go to Alterac Valley $n.  We can use all o\' the help that we can get.','',1,0,0,1,0,0,0,7,1,0,0,0,26124),
(10531,'','The humans and their so-called League of Arathor think to push us out of Arathi Basin.  I think not $c!  Are you ready to be sent there and demonstrate that it is they, and not The Defilers, that will be leaving soon?',1,0,0,1,0,0,0,1,1,0,0,0,26124),
(10532,'Arathi Basin was once our home, and will be again with your aid!  Will you help us $c?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(10533,'I hope that you\'re here to help us take back Arathi Basin from The Defilers.  What do you say $n?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(10534,'','I\'ve been expecting you $n.  Are you ready to assist us in Arathi Basin?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(10535,'You think you have what it takes to destroy The League of Arathor, $c?  I hope so.  What is it that you want, or are you simply here to waste my time?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10536,'Look around you $c.  You are in rare company to be certain, yet still I think you need to prove yourself.  Hmm, perhaps I shall allow you to aid us in our cause at Arathi Basin.  Would you like that?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10537,'All Hail $n, slayer of Hakkar, and hero of Azeroth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10538,'Gri\'lek, of the Iron Blood$B$BThe wanderer.  May his strength and lust for battle pierce the ages.$B$BGri\'lek now lingers near the edge of madness...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10539,'Hazza\'rah, the Dreamweaver.$B$BHis is the power of nightmares, and may his foes ever sleep.  $B$BHazza\'rah now dwells far from here.  One day, he may return...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10540,'Hazza\'rah, the Dreamweaver.$B$BHis is the power of nightmares, and may his foes ever sleep.$B$BHazza\'rah now dreams near the edge of madness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10541,'Renataki, of the Thousand Blades.$B$BPain is his lifeblood.  Fear, his ally.  May he one day return and bring joyous bloodshed with him.  $B$BRenataki now dwells far from here.  One day, he may return...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10542,'Renataki, of the Thousand Blades.$B$BPain is his lifeblood.  Fear, his ally.  May he one day return and bring joyous bloodshed with him.$B$BRenataki now dwells near the edge of madness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10543,'Wushoolay, the Storm Witch.$B$BHis power is the power of the sky, the rain, and the shattered earth.  May he once again reign father to the Gurubashi.  $B$BWushoolay now dwells far from here.  One day, he may return...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10544,'Wushoolay, the Storm Witch.$B$BHis power is the power of the sky, the rain, and the shattered earth.  May he once again reign father to the Gurubashi.$B$BWushoolay now rages near the edge of madness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10545,'%s goes into a rage after seeing his raptor fall in battle!','%s goes into a rage after seeing his raptor fall in battle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10546,'Minions of Hakkar, hear your God. The sanctity of this temple has been compromised. Invaders encroach upon holy ground! The Altar of Blood must be protected. Kill them all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10547,'Hey Hey Hey!  I am here to promote a fabulous fishing tournament in Stranglethorn but you need to be tough enough to survive there and have enough skill in fishing to fish those waters.$B$BCome back later when you are more qualified!\n\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10548,'Heya Heya Heya!   If you want to test your fishing skills then I have just the place for you!   This Sunday we have a fishing tournament in Stranglethorn!\n\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10549,'%s flees toward the safety of another tiger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10550,'Your callous disregard for the sovereign might of the Gurubashi Empire has been noted. The inhabitants of Zul\'Gurub have been alerted to your presence.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10551,'You are not yet powerful enough, $c.  Move along.','You are not yet powerful enough, $c.  Move along.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10552,'Our need for assistance in Arathi Basin is greater than one might imagine, $n.  So too is the honor and reputation one might acquire there in this time of need, however.  I implore you to seek out the Arathi Basin battlemaster in this city.','Our need for assistance in Arathi Basin is greater than one might imagine, $n.  So too is the honor and reputation one might acquire there in this time of need, however.  I implore you to seek out the Arathi Basin battlemaster in this city.',1,1,1,0,0,0,0,1,1,0,0,0,26124),
(10553,'I wish to join the battle!','I wish to join the battle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10554,'I am so glad that you asked.  You will find Sir Malory Wheeler at the Royal Quarter in the presence of our Dark Lady.','I am so glad that you asked.  You will find Sir Malory Wheeler at the Royal Quarter in the presence of our Dark Lady.',1,1,0,0,0,0,0,1,1,0,0,0,26124),
(10555,'Of course, of course.  Please speak with Deze Snowbane at the Hall of the Brave in the Valley of Honor of this city, $c.','Of course, of course.  Please speak with Deze Snowbane at the Hall of the Brave in the Valley of Honor of this city, $c.',1,1,0,0,0,0,0,1,1,0,0,0,26124),
(10556,'And a great deal of honor you shall have, I am sure.  Speak with Martin Lindsey at the Pools of Vision.  It is a cave located in the side of the Spirit Rise.','And a great deal of honor you shall have, I am sure.  Speak with Martin Lindsey at the Pools of Vision.  It is a cave located in the side of the Spirit Rise.',1,1,0,0,0,0,0,1,1,0,0,0,26124),
(10557,'You need to be a stronger $c before you can help us in Alterac Valley.','You need to be a stronger $c before you can help us in Alterac Valley.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10558,'Hail, $c.  There is a great need and even greater honor and renown to be had in Alterac Valley at this time. Will you join our fight against the Stormpike Guard?','Hail, $c.  There is a great need and even greater honor and renown to be had in Alterac Valley at this time. Will you join our fight against the Stormpike Guard?',1,1,1,0,0,0,0,1,1,0,0,0,26124),
(10559,'Honor to your house and ancestors, $c!  You will find Kartra Bloodsnarl inside the Hall of the Brave in the Valley of Honor.','Honor to your house and ancestors, $c!  You will find Kartra Bloodsnarl inside the Hall of the Brave in the Valley of Honor.',1,1,0,0,0,0,0,1,1,0,0,0,26124),
(10560,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10561,'Your name will be remembered down through the ages, $n.  Seek out Taim Ragetotem on the Hunter Rise and he will assist you on your way to Alterac Valley.','Your name will be remembered down through the ages, $n.  Seek out Taim Ragetotem on the Hunter Rise and he will assist you on your way to Alterac Valley.',1,1,0,0,0,0,0,1,1,0,0,0,26124),
(10562,'Very good, $n.  You will find Grizzle Halfmane in the Royal Quarter of the Undercity.  May you find great honor in Alterac Valley.','Very good, $n.  You will find Grizzle Halfmane in the Royal Quarter of the Undercity.  May you find great honor in Alterac Valley.',1,1,0,0,0,0,0,1,1,0,0,0,26124),
(10563,'Unfortunately you are not yet strong enough to survive in Warsong Gulch, $c.','Unfortunately you are not yet strong enough to survive in Warsong Gulch, $c.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(10564,'$C, we have a great need for your help in Warsong Gulch against the Silverwing Sentinels.  And there is even greater honor and reputation with the Warsong Outriders to be gained as well!  Do you have the courage to enter battle?','$C, we have a great need for your help in Warsong Gulch against the Silverwing Sentinels.  And there is even greater honor and reputation with the Warsong Outriders to be gained as well!  Do you have the courage to enter battle?',1,1,6,0,0,0,0,1,1,0,0,0,26124),
(10565,'Then it is with great pride that I tell you that Brakgul Deathbringer stands ready in the Hall of Arms to aid you on your way to Warsong Gulch. Seek him out in the Valley of Honor.','Then it is with great pride that I tell you that Brakgul Deathbringer stands ready in the Hall of Arms to aid you on your way to Warsong Gulch. Seek him out in the Valley of Honor.',1,1,0,0,0,0,0,1,1,0,0,0,26124),
(10566,'You have chosen wisely, $n.  Seek out Kergul Bloodaxe on the Hunter Rise.  He will assist you on your journey to Warsong Gulch.','You have chosen wisely, $n.  Seek out Kergul Bloodaxe on the Hunter Rise.  He will assist you on your journey to Warsong Gulch.',1,1,0,0,0,0,0,1,1,0,0,0,26124),
(10567,'Honor and praise will be yours for the taking, $c!  Look for Kurden Bloodclaw in this city\'s Royal Quarter.','Honor and praise will be yours for the taking, $c!  Look for Kurden Bloodclaw in this city\'s Royal Quarter.',1,1,0,0,0,0,0,1,1,0,0,0,26124),
(10568,'I\'m afraid ye would not survive long in Alterac Valley, $c.  Come back and see us when you have a few more seasons under your belt.','I\'m afraid ye would not survive long in Alterac Valley, $c.  Come back and see us when you have a few more seasons under your belt.',1,1,0,0,0,0,0,7,1,0,0,0,26124),
(10569,'$n, the Stormpike Guard is in need of your aid in the battle against the Frostwolf Clan in Alterac Valley, now more than ever.  The opportunities for honor and repute are greater than ever as well! Will you join the battle?','$n, the Stormpike Guard is in need of your aid in the battle against the Frostwolf Clan in Alterac Valley, now more than ever.  The opportunities for honor and repute are greater than ever as well! Will you join the battle?',1,1,6,0,0,0,0,7,1,0,0,0,26124),
(10570,'Excellent, $n!  You shall find Brogun Stoneshield on the Warrior\'s Terrace.  He can help you to get to Alterac Valley.','Excellent, $n!  You shall find Brogun Stoneshield on the Warrior\'s Terrace.  He can help you to get to Alterac Valley.',1,1,0,0,0,0,0,7,1,0,0,0,26124),
(10571,'','Fishmaster Bassbait has had the waters here seeded with high quality Tastyfish so he can have his tournament.\n\nOnce he gets his winners, I will give you silver for each five Tastyfish you bring me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10572,'You\'ve made the right decision, $c.  You\'ll find our battlemaster, Glordrum Steelbeard, in the Hall of Arms.  Good luck, $n!','You\'ve made the right decision, $c.  You\'ll find our battlemaster, Glordrum Steelbeard, in the Hall of Arms.  Good luck, $n!',1,1,0,0,0,0,0,7,1,0,0,0,26124),
(10573,'Good for you, $c!  Our battlemaster, Thelman Slatefist, can be found in the war room inside Stormwind Keep.  He will help you get to Alterac Valley.','Good for you, $c!  Our battlemaster, Thelman Slatefist, can be found in the war room inside Stormwind Keep.  He will help you get to Alterac Valley.',1,1,0,0,0,0,0,7,1,0,0,0,26124),
(10574,'Thank you for the offer, $c.  Unfortunately you are not yet experienced enough to weather the hazards of Arathi Basin.','Thank you for the offer, $c.  Unfortunately you are not yet experienced enough to weather the hazards of Arathi Basin.',1,1,0,0,0,0,0,7,1,0,0,0,26124),
(10575,'Will you help us in our time of great need at Arathi Basin, $c?  The chance for increased honor and standing is greater than ever, and your assistance is sure to help to turn the tide against The Defilers.  Can we count on you?','Will you help us in our time of great need at Arathi Basin, $c?  The chance for increased honor and standing is greater than ever, and your assistance is sure to help to turn the tide against The Defilers.  Can we count on you?',1,1,6,0,0,0,0,7,1,0,0,0,26124),
(10576,'Thank you, $n!  You will find Keras Wolfheart on the Warrior\'s Terrace near the trainers there.  He will guide your way to Arathi Basin.  Good luck and great honor upon thee.','Thank you, $n!  You will find Keras Wolfheart on the Warrior\'s Terrace near the trainers there.  He will guide your way to Arathi Basin.  Good luck and great honor upon thee.',1,1,0,0,0,0,0,7,1,0,0,0,26124),
(10577,'We shall be in your debt, $c.  Look for Donal Osgood in the Hall of Arms.  He will be more than happy to aid you in your journey to Arathi Basin.','We shall be in your debt, $c.  Look for Donal Osgood in the Hall of Arms.  He will be more than happy to aid you in your journey to Arathi Basin.',1,1,0,0,0,0,0,7,1,0,0,0,26124),
(10578,'Excellent!  You shall be doing the League of Arathor a great service in ridding Arathi Basin of The Defilers and their Horde thugs.  Seek out the Lady Hoteshem in the royal audience chamber of Stormwind Keep.  She has been expecting you, $n.','Excellent!  You shall be doing the League of Arathor a great service in ridding Arathi Basin of The Defilers and their Horde thugs.  Seek out the Lady Hoteshem in the royal audience chamber of Stormwind Keep.  She has been expecting you, $n.',1,1,1,0,0,0,0,7,1,0,0,0,26124),
(10579,'I am released through you! Avenge me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10580,'The seasons turn for all in due time, but you are still in the springtime of your life.  Please return to us later, $c, when you have experienced more.','The seasons turn for all in due time, but you are still in the springtime of your life.  Please return to us later, $c, when you have experienced more.',1,1,0,0,0,0,0,7,1,0,0,0,26124),
(10581,'$C, we are not ashamed to say that we are in need of all of the assistance that we can get in our fight at Warsong Gulch.  But there is greater honor to be had now than at any time in the past if you so choose to lend us your skills.  As well, the Silverwing Sentinels are sure to look more favorably upon your efforts on our behalf.  Will you join the battle?','$C, we are not ashamed to say that we are in need of all of the assistance that we can get in our fight at Warsong Gulch.  But there is greater honor to be had now than at any time in the past if you so choose to lend us your skills.  As well, the Silverwing Sentinels are sure to look more favorably upon your efforts on our behalf.  Will you join the battle?',1,1,6,0,0,0,0,7,1,0,0,0,26124),
(10582,'The Light of Elune shine upon thee, $n!  You will find Aethalas, our battlemaster, on the Warrior\'s Terrace.  She will aid you on your way to Warsong Gulch.','The Light of Elune shine upon thee, $n!  You will find Aethalas, our battlemaster, on the Warrior\'s Terrace.  She will aid you on your way to Warsong Gulch.',1,1,0,0,0,0,0,7,1,0,0,0,26124),
(10583,'You show wisdom beyond your years, $c.  Thank you. You can find our battlemaster, Lylandris, standing at the war table in the Hall of Arms. She can assist you in traveling to Warsong Gulch.','You show wisdom beyond your years, $c. Thank you. You can find our battlemaster, Lylandris, standing at the war table in the Hall of Arms. She can assist you in traveling to Warsong Gulch.',1,1,0,0,0,0,0,7,1,0,0,0,26124),
(10584,'','The Paragons of Power are remnants from the ancient Gurubashi Empire.  We Zandalar seek them - not only are they of tremendous collectible value to us, but we believe that they also hold the strongest of mojo used by the old Empire.$B$BYa can expect to be findin\' three kinds of Paragons in Zul\'Gurub: coins, bijous, and primal items.  Bring them to us in the quantities that we seek, and you\'ll be rewarded with the some of the finest items we Zandalar have ever crafted.$B$BCount on it, mon!\n\n',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10585,'The Silverwing Sentinels shall be in your debt, $c.  You will find Elfarran, our battlemaster, inside Stormwind Keep, attending the boy-king\'s audience.  Goddess watch over you!','The Silverwing Sentinels shall be in your debt, $c.  You will find Elfarran, our battlemaster, inside Stormwind Keep, attending the boy-king\'s audience.  Goddess watch over you!',1,1,0,0,0,0,0,7,1,0,0,0,26124),
(10586,'You will suffer eternally, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10587,'Hakkar will rule the world!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10588,'You will make a fitting sacrifice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10589,'Surrender your soul, mortal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10590,'The world will suffer immeasurable cruelties under my reign.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10591,'Your gods can\'t save you now, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10592,'The Primal Gods serve Hakkar. Turn back now, you stand no chance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10593,'Pledge your allegiance to Hakkar and the pain you suffer shall be minimal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10594,'You dare set foot upon Hakkari holy ground? Minions of Hakkar, destroy the infidels!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10595,'Well met master of Rod and Reel!   If you be willing to test your skills against the best fisher-folk in the lands then listen up!   On this very Sunday there be a contest in Stranglethorn where the master angler will be chosen!\n\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10596,'Greetings!  I am here to promote a tournament to test your fishing skill in Stranglethorn.  To participate you need enough might to survive there and have enough skill in fishing to coax the fish from the water.$B$B Come back later when you are more qualified!\n\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10597,'Paragons of Power are powerful mojo.  They are Gurubashi Empire mojo.  We Zandalar must get mojo.  The tribe will take mojo for our own.  The Blood God will not destroy us.$B$BThere are three kinds of Paragons in Zul\'Gurub.  Seek coins.  Seek bijous.  Seek primal items.  These are the Paragons.$B$BGo to Zul\'Gurub now.  Kill.  Take the Paragons of Power.  Bring them to the tribe.  Earn our respect.  Earn our battle gear.  Earn real power.','',15,1,0,0,0,0,0,0,1,0,0,0,26124),
(10598,'The Alliance has gathered over 1200 resources and is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10599,'The Horde has gathered over 1200 resources and is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10600,'We already have all our winners for today\'s contest, but Jang is willing to purchase any Tastyfish that you have fished up!\n\nThere\'s always next Sunday for you to show your angling skill!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10601,'Hey! Grats, mon!','',0,0,0,0,0,0,0,0,1,0,24260,0,26124),
(10602,'Wow!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10603,'Yay!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10604,'$n! I\'m watching you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10605,'You\'ve angered me for the last time $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10606,'Listen, young $c.  You hear the call of water?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10607,'I wish to speak to the spirits, Tiev.','I wish to speak to the spirits, Tiev.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10608,'Let the Fishing Tournament BEGIN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10609,'And the Tastyfish have gone for the week!   I will remain for another hour to allow you to turn in your fish!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10610,'We have a winner!  $n has won FIRST PLACE in the tournament!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10611,'Behind me is the Altar of Zanza, a sacred place for us Zandalar.  We pray here to bolster our resolve in preparation for war against the Blood God, Hakkar.$B$BProve yourself to the tribe by using the altar to destroy any of the Hakkari Bijous you might find inside Zul\'Gurub.  Also, I will trade you Honor Tokens our tribe uses for sets of coins you may find in Zul\'Gurub.  Bring me the coins that I seek, and you will be rewarded!','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10612,'The Blood God, the Soulflayer, has been defeated!  We are imperiled no longer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10613,'The Zandalarian trolls have traveled far and suffered much to reach this place, but to do nothing... is to invite our doom...','The Zandalarian trolls have traveled far and suffered much to reach this place, but to do nothing... is to invite our doom...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10614,'Take heart!$B$BThe Soulflayer has been defeated and his wretched heart has been cast into the nether!','Take heart!$B$BThe Soulflayer has been defeated and his wretched heart has been cast into the nether!',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(10615,'The Soulflayer is defeated!  Our leader, Molthor, now calls more of his servants...','The Soulflayer is defeated!  Our leader, Molthor, now calls more of his servants...',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(10616,'We, the Zandalarian trolls, traveled here from distant islands, for we cannot ignore the threat that now faces our world.$B$BThe leader of our expedition, Molthor, brought us to the Yojamba Isle, along the northern coasts of Stranglethorn, and even now recruits brave heroes to venture into the ancient troll city... Zul\'Gurub.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10618,'We, the Zandalarian trolls, traveled here from distant islands, for we cannot ignore the threat that now faces our world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10619,'Not now.  Have you any tasks for me?','Not now.  Have you any tasks for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10620,'I can get back to the Stronghold on my own, I think.  Now that you bought me some time, I should be able to stealth out of here.  Who ever you are... thank you.  May Elune bless you always!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10621,'I wish to untrain my pet.','I wish to untrain my pet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10622,'You can\'t teach an old dog new tricks.  At least that\'s what someone once told me.  Lucky for you, I\'ve discovered it to be untrue.$b$bNow then, would you like your pet to unlearn talents?','You can\'t teach an old dog new tricks.  At least that\'s what someone once told me.  Lucky for you, I\'ve discovered it to be untrue.$b$bNow then, would you like your pet to unlearn talents?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10623,'What goods have I earned the right to purchase from the Defilers?','What goods have I earned the right to purchase from the Defilers?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10624,'I am Rutherford Twing, the main supplier for the Defilers posted here at Arathi Basin.  As you improve your standing with us, I will make available to you a fine selection of goods that you might find useful.  Should you find yourself in need of item repair, I also provide those services.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(10625,'What goods have I earned the right to purchase from the League of Arathor?','What goods have I earned the right to purchase from the League of Arathor?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10626,'I am Samuel Hawke, the main supplier for the League of Arathor posted here at Arathi Basin.  As you improve your standing with us, I will make available to you a fine selection of goods that you might find useful.  Should you find yourself in need of item repair, I also provide those services.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(10627,'Yes, please do.','Yes, please do.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10628,'Don\'t make me angry! You wouldn\'t like me when I\'m angry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10629,'','The battle for Warsong Gulch is a battle that we cannot lose.  We fight for our honor and we fight for our land, and no orc or misguided ally will take them from us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10630,'It is no easy task to protect the Horde\'s lumber gathering efforts here in Ashenvale, but we have never shied from battle!  The night elves and their allies will fall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10631,'Game start timer disabled.','Game start timer disabled.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10632,'The attackers have fled!  Strength and honor to the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10633,'The Alliance wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10634,'The Horde wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10635,'Fleeing will do you no good, mortals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10636,'$n claims the Snowfall graveyard!  If left unchallenged, the Alliance will control it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10637,'$n claims the Snowfall graveyard!  If left unchallenged, the Horde will control it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10638,'1 minute until the battle for Alterac Valley begins.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10639,'30 seconds until the battle for Alterac Valley begins.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10640,'The battle for Alterac Valley has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10641,'Hi!  I\'m Luis!  What do you think of me so far...?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10644,'Something different!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10645,'%s goes into a frenzy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10646,'','Greetings, traveler. As long as you remain within the walls of the Cenarion Hold, you will be safe from harm.$B$BBe wary when leaving the protection of the Hold as the silithid have been swarming as of late.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10647,'I wish to browse your wares, Calandrath.','I wish to browse your wares, Calandrath.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10648,'I supply the Hold with various relics required for spellcasting as well as other alchemical reagents.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10649,'A great evil stirs, $r. Can you feel it?$B$BBah! Of course you cannot. Hand me your armor and weapons and I shall renew their vigor.','',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(10650,'','Oh dear, I am running dangerously low on supplies! What is taking that blasted goblin so long?',5,6,0,0,0,0,0,0,1,0,0,0,26124),
(10651,'Look behind you, $r. The hive stirs as the land that surrounds us shudders and shakes.$B$BThe time has come for me to fulfill a promise I made a thousand years past. The sands shift once more as the Qiraji plan for war.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10652,'I wish to stable my pet.','I wish to stable my pet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10653,'Why now, $r? I just do not understand it. So much work to be done...','',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(10654,'The Commander has not been himself as of late. His mistress disappeared while on an archaeological dig in the southern desert - vanished without a trace! Very strange, indeed.$B$BI suppose you\'re looking for work? Do I need to bash you in the head with a clue?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(10655,'','Can ye hear it, stranger? The humming is gettin\' louder with each passing day. These crystals must be what\'s driving these bugs crazy.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10656,'Look up to the heavens, $c. The Dragonflights have not been seen in this area for a thousand years! Those Qiraji are up to something, I just know it!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(10657,'Bronzebeard\'s gone missing again! That dwarf sure didn\'t get any of his brother\'s good senses.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10658,'A terrible and costly mistake you have made. It is not my time, mortals.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10659,'The ashes from the burning wickerman radiate magical power.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10660,'Smear the ash on my face like war paint!','Smear the ash on my face like war paint!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10661,'The ashes from the burning wickerman radiate magical power.  You have already applied the ashes to your face.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10662,'','Children of the grave, heed my call!',15,0,0,0,0,0,22,1,1,0,0,25185,26124),
(10663,'','In life, we suffered unspeakable tragedies.',0,0,0,0,0,0,1,1,1,0,0,25186,26124),
(10664,'','Finally, in the face of such atrocities, we were denied even the release of death.',0,0,0,0,0,0,1,1,1,0,0,25189,26124),
(10665,'','We are the chill in a coward\'s spine...',1,0,0,0,0,0,15,1,1,0,0,25195,26124),
(10666,'','We are NOT monsters! We are NOT the mindless wretches of a ghoul army!',0,0,0,0,0,0,274,1,1,0,0,25193,26124),
(10667,'','WE ARE THE FORSAKEN!! ',0,0,0,0,0,0,15,1,1,0,0,25197,26124),
(10668,'Happy Hallow\'s End, $c!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10669,'You like candy?  I like candy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10670,'Go Forsaken!  Yay us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10671,'','Welcome to the Wickerman Festival, $c!$B$BOn the observance of Hallow\'s End, the Forsaken burn a Wickerman in honor of this, the most revered of occasions.  It was on this day that the Banshee Queen herself delivered us from the clutches of the Lich King and the Scourge.  We have remained free ever since.  Those who would have seen us fall are repaid in full... with vengeance!$B$BWhen the Wickerman is burning, paint your face with the ashes scattered below if you want to celebrate in style!',4,1,0,0,0,0,0,0,1,0,0,0,26124),
(10672,'Wha... where am I?  So... weak..','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10673,'You there!  You look able bodied... we need your aid in defending Southshore!$B$BThe blasted Forsaken are all riled up because it\'s Hallow\'s End.  Their \"celebration\" will no doubt be leading them right to our doorstep.  If you\'ve got the time, we really could use your help!','',5,1,1,0,0,0,0,0,1,0,0,0,26124),
(10674,'So... cold...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10675,'Yes!  I\'m cured!  I\'m cure... whoa, got up too fast!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10676,'Thanks for finding my reagents!  *yawn*  That poison\'s made me... a bit tired...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10677,'%s becomes enraged!','%s becomes enraged!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10678,'%s roars, high atop Blackrock Spire...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10679,'Baristolth, I have lost my badge and require a replacement.','Baristolth, I have lost my badge and require a replacement.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10680,'It is we who must make the first strike. We cannot be allowed to repeat the mistakes of the past...','',26,1,1,0,0,0,0,0,1,0,0,0,26124),
(10681,'I am ready to hear your tale, Baristolth.','I am ready to hear your tale, Baristolth.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10682,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10683,'Be gone, infidel!  May the power of the Abyss smite you down!','Be gone, infidel!  May the power of the Abyss smite you down!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10684,'I am no cultist, you monster!  Come to me and face your destruction!','I am no cultist, you monster!  Come to me and face your destruction!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10685,'Crimson Templar!  I hold your crest of beckoning.  Heed my summons!','Crimson Templar!  I hold your crest of beckoning.  Heed my summons!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10686,'The Abyssal Council does not tolerate deceit!  Feel our wrath, little $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10687,'','Greetings, $c.  Welcome to Cenarion Hold.  From here we will strike against the silithid where they\'re at their strongest.  I hope you\'ve come to lend a hand.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10688,'','It\'s a pleasure to see you again, $n.  Your aid has provided us with a considerable boost in the security of our supply lines.  I hope you understand the importance of the logistics involved in large battle efforts such as this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10689,'','No luck with the Twilight\'s Hammer deserter?  Check the mountains to the southeast thoroughly.  There are numerous rumors of a mysterious hermit living there.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10690,'Hoary Templar!  I hold your crest of beckoning.  Heed my summons!','Hoary Templar!  I hold your crest of beckoning.  Heed my summons!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10691,'Earthen Templar!  I hold your crest of beckoning.  Heed my summons!','Earthen Templar!  I hold your crest of beckoning.  Heed my summons!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10692,'Azure Templar!  I hold your crest of beckoning.  Heed my summons!','Azure Templar!  I hold your crest of beckoning.  Heed my summons!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10693,'Trick or Treat!','Trick or Treat!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10694,'My lord will be outraged to learn of this ambush.  Let us hope your death will appease him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10695,'It is my duty and honor to die for the Abyssal Council!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10696,'Your life is a fitting sacrifice for my master, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10697,'How dare you commune with a Duke of the Council, worm!','How dare you commune with a Duke of the Council, worm!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10698,'You will listen to this, vile duke!  I am not your Twilight\'s Hammer lapdog!  I am here to challenge you!  Come!  Come, and meet your death...','You will listen to this, vile duke!  I am not your Twilight\'s Hammer lapdog!  I am here to challenge you!  Come!  Come, and meet your death...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10699,'Duke of Cynders! I hold your signet!  Heed my call!','Duke of Cynders! I hold your signet!  Heed my call!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10700,'Duke of Zephyrs! I hold your signet!  Heed my call!','Duke of Zephyrs! I hold your signet!  Heed my call!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10701,'Duke of Shards! I hold your signet!  Heed my call!','Duke of Shards! I hold your signet!  Heed my call!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10702,'Duke of Fathoms! I hold your signet!  Heed my call!','Duke of Fathoms! I hold your signet!  Heed my call!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10703,'You\'re hunting Deathclasp, $n?  Color me impressed.  I lost two of my men to her this week alone.  Let\'s hope your luck is better than theirs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10704,'Hey!  Thanks for saving my hide!  I think I\'ll be lying down for a while until I recover my strength.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10705,'Who are you?  Where am I?  I feel... so weak...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10706,'A thunderous voice bellows from the stone...$B$BGreetings, commander.  What news of Silithus do you bring the Lords of the Council?','A thunderous voice bellows from the stone...$B$BGreetings, commander.  What news of Silithus do you bring the Lords of the Council?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10707,'The day of judgment has come, fiend!  I challenge you to battle!','The day of judgment has come, fiend!  I challenge you to battle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10708,'Skaldrenox!  I hold your scepter, and charge you to enter this world!','Skaldrenox!  I hold your scepter, and charge you to enter this world!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10709,'Whirlaxis!  I hold your scepter!  I command you to enter this world!','Whirlaxis!  I hold your scepter!  I command you to enter this world!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10710,'Kazum!  I hold your scepter!  I command you to enter this world!','Kazum!  I hold your scepter!  I command you to enter this world!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10711,'Skwol!  I hold your scepter!  I command you to enter this world!','Skwol!  I hold your scepter!  I command you to enter this world!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10712,'Hello, Rutgar. The Commander has sent me here to gather some information about his missing wife.','Hello, Rutgar. The Commander has sent me here to gather some information about his missing wife.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10713,'You best have a seat then, this is gonna be a long one.$B$BWhen we initially arrived in Silithus, Mistress Mar\'alith was the first of the night elves from Cenarion Hold to join the expedition. Our routine was nothing out of the ordinary: Form a party to venture into the various hives and search for lost artifacts. ','',25,1,1,0,0,0,0,0,1,0,0,0,26124),
(10714,'That sounds dangerous.','That sounds dangerous.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10715,'It sure is! Those hives were abuzz with various silithid that were none too happy to see us.$B$BEverything was going fine until we came across a glyphed crystal in Hive\'Regal. She was drawn to it like a moth to a flame! She put her pretty little cheek up against the crystal and instantly entered a trance-like state. Naturally, this worried my crew. We picked her up and carried her out of there with a quickness!','',1,1,5,0,0,0,0,0,1,0,0,0,26124),
(10716,'What happened to her after that?','What happened to her after that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10717,'We took her to the Commander with hopes that the druids of the Circle could fix her up. Sure enough, they were able to wake her up. We figured our business with the Circle was done and we could get back to work.$B$BA few weeks passed and everything was going fine. Brann was still around back then so we had a bit of order in our work structure. Then one day, out of the blue, she appeared back at our camp.\n','',1,1,5,0,0,0,0,0,1,0,0,0,26124),
(10718,'Natalia?','Natalia?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10719,'Are you daft? Who else would I be talking about? Yes, the girl - Mistress Mar\'alith. Anyhow, she was back and not in too good of a mood. That\'s when the demands started flowing.\n','',6,273,1,0,0,0,0,0,1,0,0,0,26124),
(10720,'What demands?','What demands?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10721,'She demanded that we immediately head back to Hive\'Regal! Brann would have none of that sass. He told her that there\'s no way we would go back into those hives without an army backing us up. It had gotten far too dangerous. The number of those stinking insects seemed to have tripled from when we first ventured into \'em.$B$BThat\'s when Natalia lost it!','',1,1,5,0,0,0,0,0,1,0,0,0,26124),
(10722,'Lost it? What do you mean?','Lost it? What do you mean?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10723,'What do you mean what do I mean? She went nutso! The girl went straight crazy on us. Now ordinarily I don\'t hit girls but after I recovered from the blackout, I was pretty damned angry. Brann, Rutgar, me and the monkey went positively orc on her! It\'s a miracle we were able to fend her off. She seemed almost possessed!','',1,1,5,0,0,0,0,0,1,0,0,0,26124),
(10724,'Possessed by what?','Possessed by what?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10725,'Who knows? Anyhow, that was the last I saw of her. Maybe Frankal can give you better information.$B$BNot to steer off topic here as I\'m sure the work you\'re doing for the Commander is important, but we\'re onto something huge here. HUGE! Our requests to Ironforge for an army have so far fallen on deaf ears. Apparently we\'re stretched too thin in protecting the realm or some such nonsense. Once you take your report back to the Commander, come back down here with some friends. We need your help!','',1,1,5,0,0,0,0,0,1,0,0,0,26124),
(10726,'I\'ll be back once I straighten this mess out.','I\'ll be back once I straighten this mess out.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10727,'Hello, Frankal. I\'ve heard that you might have some information as to the whereabouts of Mistress Natalia Mar\'alith.','Hello, Frankal. I\'ve heard that you might have some information as to the whereabouts of Mistress Natalia Mar\'alith.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10728,'Oh brother, not this again... Have a seat $g sonny:missy;.$B$BI\'m sure Rutgar has told you some of this story already so I\'ll spare you the boring details and get right down to the nitty gritty.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10729,'That\'s what I like to hear.','That\'s what I like to hear.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10730,'Right then! So the Mistress had come back for a second go at the hives but Brann was having none of that nonsense! Before the melee began, she started talking to something or someone. Crazier still, she started chanting in a language none of us had ever heard.','',5,1,1,0,0,0,0,0,1,0,0,0,26124),
(10731,'That\'s odd.','That\'s odd.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10732,'You\'re telling me! It\'s even stranger considering between Brann, Rutgar, me and the monkey, we know 38 different languages including a touch of Titan - both Vanir and Aesir.$B$BSo anyway, whatever she was click clacking about, it definitely wasn\'t with anyone \"present.\" She then nodded and went on the offensive! Attacked us outright!','',273,1,1,0,0,0,0,0,1,0,0,0,26124),
(10733,'You couldn\'t handle a lone night elf priestess?','You couldn\'t handle a lone night elf priestess?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10734,'Listen $g sonny:missy;, I\'ll have you know that whatever attacked us was no priestess of nothin\'! Her eyes were aglow with something evil and she was genuinely frothing at the mouth! She came in, did some kind of crazy scream that sent us all runnin\' in separate directions then started flayin\' our minds one by one. I\'d be hearin\' shadowy words in my head, watchin\' the other\'s periodically black out here and there. It was madness! We would have been done for if not for the damned monkey.','',25,1,275,0,0,0,0,0,1,0,0,0,26124),
(10735,'I\'ve been meaning to ask you about that monkey.','I\'ve been meaning to ask you about that monkey.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10736,'What\'s there to ask? He\'s a monkey you crazy fool. Anyhow, so yea, the monkey went into a frenzy after seein\' ol\' Brann flop into the sand face first. Nothin\' the night elf could do was stopping Glibb here from poundin\' on her noggin.','',6,1,1,0,0,0,0,0,1,0,0,0,26124),
(10737,'Then what?','Then what?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10738,'I\'ll tell you \'then what.\' She went runnin\' straight for the hive. And you know what\'s crazier? Not a single damned bug got in her way or tried to stop her. She ran through them all as if she\'d been best friends with \'em for centuries.','',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(10739,'What a story! So she went into Hive\'Regal and that was the last you saw of her?','What a story! So she went into Hive\'Regal and that was the last you saw of her?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10740,'Yep.','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(10741,'Thanks for the information, Frankal.','Thanks for the information, Frankal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10742,'','You will make a fitting sacrifice!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10743,'','C\'Thun will retake this world!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10744,'The crystal is covered in intricate glyphs and runes. You can\'t make sense of any of it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10745,'A faint whisper is heard from within the stone...$B$BGreetings, little one.  Do you have news for the Templar?','A whisper may be heart from within the stone...$B$BGreetings, little one.  Do you have news for the Templar?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10746,'A clear voice rises from within the stone...$B$BWhere is your Medallion of Station, little one?  You may not speak with a Duke without proof of title...','A clear voice rises from within the stone...$B$BWhere is your Medallion of Station, little one?  You may not speak with a Duke without proof of title...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10747,'A clear voice rises from within the stone...$B$BYou come to us with title and so we will listen, but do not try our patience, $c.  The council has no time for idle gossip from one such as you.','You come to us with title and so we will listen, but do not try our patience, $c.  The council has no time for idle gossip from one such as you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10748,'What bug comes before the lords of the Council?  A bug, no doubt, wishing to be squashed!','What bug comes before the lords of the Council?  A bug, no doubt, wishing to be squashed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10749,'A thunderous voice bellows from the stone...$B$BI sense your Medallion of Station, cultist, but you have no Ring of Lordship?  Are you truly a commander of the Twilight\'s Hammer, or do you merely run errands for your betters?','A thunderous voice bellows from the stone...$B$BI sense your Medallion of Station, cultist, but you have no Ring of Lordship?  Are you truly a commander of the Twilight\'s Hammer, or do you merely run errands for your betters?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10750,'A thunderous voice bellows from the stone...$B$BWhat is this?  I sense a little cultist scurrying about!  Run along, vermin, or face the wrath of the lords of the Council!','A thunderous voice bellows from the stone...$B$BWhat is this?  I sense a little cultist scurrying about!  Run along, vermin, or face the wrath of the lords of the Council!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10751,'','You were always the troublemaker in the family, Noggle.  Always!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10752,'<Use the transcription device to gather a rubbing.>','<Use the transcription device to gather a rubbing.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10753,'Where would you like to fly to?','Where would you like to fly to?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10754,'The spirits of Silithus call out to us, $n.  The land weeps, for it has a woeful story to tell...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10755,'%s emits a strange noise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10756,'Hail $c. Didn\'t I see you recently at an exclusive gathering? You look familiar, but then again this city is a busy place.$B$BIf you attended that convention, then surely you were given a secret code. Tell me your code and I will give you a special prize in return.','Hail $c. Didn\'t I see you recently at an exclusive gathering? You look familiar, but then again this city is a busy place.$B$BIf you attended that convention, then surely you were given a secret code. Tell me your code and I will give you a special prize in return.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10757,'I would like to enter the secret code to receive my Murloc pet.','I would like to enter the secret code to receive my Murloc pet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10758,'','$n!  I hope you\'re ready to get to work, because there is much for you to do here on Sunstrider Isle.$B$BEver since the destruction of the Sunwell by Arthas and the Scourge, we have been a race adrift on a sea of uncertainty.  We teeter on the edge of oblivion.  This will change, $c, and you will learn and aid our recovery at the same time.$B$BThe Outland awaits us!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10759,'','The Cenarion Circle is wise, and has delved into many of earth\'s secrets.  Craftsmen would do well to heed the words of these druids.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10760,'','The ghostly figure looks at you with mistrust in her eyes and remains silent.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10761,'Show me what I can learn.','Show me what I can learn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10762,'','I will do my best to translate and describe what I see.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10763,'The Sunspire held a beautiful vantage of the Sunwell... once.  Our lives have been turned upside down, $n, but we nonetheless carry on.  It is our way; we are survivors.$B$BIf you are to survive this upheaval... to carry on in your own right, then you MUST learn how to survive.  All blood elves must do this.  You must master your insatiable hungering for magic before it masters you.','',1,25,0,0,0,0,0,0,1,0,0,0,26124),
(10764,'Your continued service to the Blood Elves is paramount to our survival!  We must all pitch in and pull ourselves out of the mire we all find ourselves in.$B$BIf you\'re ready to work, then let\'s get started.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10765,'Knowledge is power - TRUE power, my young friend.  You\'ll be wise to acquire as much of it as you can, and pay proper heed to those who have already done so.$B$BBefore the razing of the Sunwell, we fooled ourselves into thinking we had neared the apex of our civilization.  It took the Scourge to bring us to our knees... and in a way, back to reality.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10766,'You\'ve caught me at a critical time in my research!  No worries, you\'re welcome to join me in quiet contemplation... emphasis on \"quiet\", if you don\'t mind though.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10767,'','If you\'re heading toward the city, then I have something important for you to do!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10768,'','Welcome! Step right up, don\'t be shy.$b$bThis here is my pride and joy... the Blastenheimer 5000 Ultra Cannon! Ain\'t she pretty?',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10769,'How do I use the cannon?','How do I use the cannon?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10770,'','It\'s simple! You give me a Darkmoon Game Token, and I toss you in and light the fuse.$B$BYou\'ll \"float\" for a little while after you\'re shot, but you can descend quickly by dropping the \"wings\" I\'ll give you.$B$BYou\'re aiming for a big floating target in the water right off the boardwalk.$B$BJust don\'t drop your wings while you\'re still over ground, or... well... I don\'t sell life insurance!',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10771,'','I\'ve come back to my old home so my knowledge may be passed on.  Unlike the mindless undead around me, I\'ve chosen this unlife for my own reasons.$B$BThe silithid are formidable opponents, $n.  I\'ve learned to respect them as much as I despise them.$B$BMuch of their deadliness comes from the strength and lightness of their chitin, which I\'ve learned to work into armor.  As we seem to have a common enemy I shall teach you my trade. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10772,'','Hello $c, and welcome to the Darkmoon Faire. There is so much to do here at the faire that it can be a little overwhelming for our first time visitors. That\'s why I\'m here to help. Do you have any questions?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10773,'What can I purchase?','What can I purchase?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10774,'An excellent question! We have many things for sale here at the faire. If you are interested in food or drink, then visit Stamp or Sylannia\'s booths.\n\nIf you\'d rather purchase something more exotic, then Lhara may have just the thing for you. She specializes in rarities from all over the world.\n\nAnd then there is Flik running around here somewhere. If you can grab him he sells balls for throwing and frogs to keep as pets.','An excellent question! We have many things for sale here at the faire. If you are interested in food or drink, then visit Stamp or Sylannia\'s booths.\n\nIf you\'d rather purchase something more exotic, then Lhara may have just the thing for you. She specializes in rarities from all over the world.\n\nAnd then there is Flik running around here somewhere. If you can grab him he sells balls for throwing and frogs to keep as pets.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(10775,'Darkmoon Faire Prize Tickets?','Darkmoon Faire Prize Tickets?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10776,'Glad you asked. Darkmoon Faire Prize Tickets are your currency to purchase some amazing prizes.$b$bPrize Tickets are rewarded for doing monthly quests and playing the games around the faire.$b$bCompleting the monthly quests will earn you the most Prize Tickets, but playing the games daily, is a great way to get ahead.$b$bOnce you have enough tickets, you can spend them at the different vendors on the faire grounds.','Glad you asked. Darkmoon Faire Prize Tickets are your currency to purchase some amazing prizes.$b$bPrize Tickets are rewarded for doing monthly quests and playing the games around the faire.$b$bCompleting the monthly quests will earn you the most Prize Tickets, but playing the games daily, is a great way to get ahead.$b$bOnce you have enough tickets, you can spend them at the different vendors on the faire grounds.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(10777,'Darkmoon Cards?','Darkmoon Cards?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10778,'','No one really knows who made the Darkmoon Cards or what their true purpose is, but I can tell you that they have been found all over Azeroth, usually in the hands of a villain attempting to unlock their mysteries.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(10779,'Attractions?','Attractions?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10780,'','I highly recommend that you visit Sayge to get your fortune told. I know, I know... he\'s a gnoll.  But he\'s a very special gnoll with the power to divine your future!$B$BAnd we are constantly expanding the faire with all manner of new attractions!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10781,'We have more than one enemy in Silithus, $n.$B$BWhile everyone\'s attention is focused on the silithid, my big brother and I have been keeping a close eye on the Twilight\'s Hammer crazies.\n\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10782,'','I highly recommend that you visit Sayge to get your fortune told. I know, I know... he\'s a gnoll.  But he\'s a very special gnoll with the power to divine your future!$B$BAnd we are constantly expanding the faire with all manner of new attractions!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10783,'Greetings, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10784,'Greetings, ancient one. I have done all that has been asked of me. I now ask that you grant me Rhok\'delar.','Greetings, ancient one. I have done all that has been asked of me. I now ask that you grant me Rhok\'delar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10785,'Greetings, ancient one. I have done all that has been asked of me. I now ask that you grant me Lok\'delar.','Greetings, ancient one. I have done all that has been asked of me. I now ask that you grant me Lok\'delar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10786,'Bawk, bawk, bawk!  Happy Hallow\'s End, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10787,'','I may have ninety-nine problems, but dancin\' ain\'t one of them!  Happy Hallow\'s End, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10788,'','Chugga-chugga, woo-woo!  Happy Hallow\'s End, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10789,'','Ooo, so strong!  Happy Hallow\'s End, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10790,'','Greetings, traveler. It was here, nearly 1,000 years past, that the Qiraji began their march of destruction across Kalimdor.$B$BThousands of lives were lost during the war, most in this cursed desert during the initial invasion.$B$BI am one of only a few that remain, chained to both the past and the present. I know not why I am to remain stationed here but I know that I must.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10791,'How do you know?','How do you know?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10792,'','I have been slain a hundred times. I always wake here, alive. Some say I am cursed and others...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10793,'What do they say?','What do they say?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10794,'','They say that I am blessed: A herald to harken in a new age.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10795,'And what do you say?','And what do you say?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10796,'','Ancient forces stir - forces that have not been seen or felt for thousands of years. The world weeps, $r. Perhaps a new sundering comes. A sickness born from within...$B$BThe foulness has begun to seep into our lands. From the Dream come nightmares. Nightmares to befoul us in our waking hours...\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10797,'','Ooo, so strong!  Happy Hallow\'s End, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10798,'Bawk, bawk, bawk!  Happy Hallow\'s End, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10799,'Chugga-chugga, woo-woo!  Happy Hallow\'s End, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10800,'','I may have ninety-nine problems, but dancin\' ain\'t one of them!  Happy Hallow\'s End, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10801,'You will pay the ultimate price for this insolence, little vermin.  Your soul is mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10802,'This act of defiance will not go unpunished.  You, and your world, will die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10803,'What?  Such a small, frail thing beckons me?  This will not go unpunished!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10804,'Imposter!  It is a dishonor without equal to be summoned by a whelp such as you!  DIE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10805,'Your treachery only speeds your doom.  This world will fall to darkness!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10806,'You dare!  Outrageous!  I curse you, $c.  I curse you with... death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10807,'What?  Such a small, frail thing beckons me?  I shall add your bones to my throne, $r!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10808,'','Happy Hallow\'s End!  Do you like my mask?  Very scary!',4,1,0,0,0,0,0,0,1,0,0,0,26124),
(10809,'','Happy Hallow\'s End!  How do you like my mask?  Very scary!',4,1,0,0,0,0,0,0,1,0,0,0,26124),
(10810,'Killing you and your cohorts, $c, will amuse me.  I shall make it quick.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10811,'','I\'m going to miss out on a lot of the trick-or-treating!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10812,'I\'m going to miss out on trick-or-treating because I can\'t go out!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10813,'','You\'re the best, $n - thanks for going trick-or-treating for me!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10814,'You\'re the best, $n - thanks for going trick-or-treating for me!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10815,'What Hallow\'s End candy do you have for sale?','What Hallow\'s End candy do you have for sale?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10816,'What is there to do on Hallow\'s End?','What is there to do on Hallow\'s End?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10817,'','What ISN\'T there to do, you mean!$B$BEach of the innkeepers throughout the world are handing out trick-or-treat goodies, and many of the towns are decorated for the season!  Also, there is the Wickerman Festival just outside the Undercity during the evenings.',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(10818,'','What ISN\'T there to do, you mean!$B$BEach of the innkeepers throughout the world are handing out trick-or-treat goodies, and many of the towns are decorated for the season!  Also, Sergeant Hartman in Southshore needs help against the Forsaken and their Wickerman Festival.$B$BOne more thing - I\'ve heard that a sick little boy at the orphanage in Stormwind is looking for someone to help him gather treats for the holiday.',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(10819,'I am despawning from $n.','I am despawning from $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10820,'Sergeant Hartman!  I need to buy another stink bomb cleaner!','Sergeant Hartman!  I need to buy another stink bomb cleaner!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10821,'I want to buy another stink bomb!','I want to buy another stink bomb!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10822,'%s laughs maniacally.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10823,'No!  It can\'t be...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10824,'Pathetic fool!  Now I will teach you the meaning of pain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10826,'%s begs Impsy for forgiveness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10827,'Prepare to meet your doom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10828,'Uh oh...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10829,'','It is history... A history of Silithus... of Ahn\'Qiraj... of Titans and Old Gods... I read from the prophecy of C\'Thun as written by the Qiraji Prophet Skeram. A prophecy that portends a cataclysm...\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10830,'','In the time before time, when the world was still in its infancy, a battle between a Titan and a being of unimaginable evil and power raged on this very soil. The prophecy is unclear about whether or not the Titan was vanquished in this battle but it illustrates that a Titan fell. An Old God had also fallen - or so it was thought.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10831,'','For millennia this being lay dormant beneath the world - biding its time. From its prison it waited for the exact moment at which to strike back at those that would see it harmed.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10832,'','The land of eternal starlight, Kalimdor, was a nurturing mother to all of its creatures. The magic of the Well of Eternity permeated the land and empowered the multitude of flora and fauna that would make the world their home. From this magical ether were born the silithid. It was through the silithid that the brooding Old God would reach and attempt to sunder the world that it once held in its unmerciful grasp. \n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10833,'','The Old God would create avatars from the silithid in its own image. These avatars were to be known as Qiraji. Sentient and with purpose, the Qiraji would name their creator: C\'Thun was born... For many thousands of years the Qiraji worked feverishly to build a force capable of laying waste to the world that would betray their god. The great fortress city of Ahn\'Qiraj was created to house their growing armies and prepare for the coming of C\'Thun.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10834,'%s examines the Scourgestone closely.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10835,'The evil in these stones is strong, but it has been dispelled.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10836,'','This can\'t be right. An Old God could never be allowed to enter this world. The results would be... Oh dear!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10837,'','%s regains her composure.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10838,'','There is more.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10839,'','The moment that C\'Thun had so patiently waited for had finally arrived. His children had spent thousands of years building an army capable of exacting revenge upon the whole of Kalimdor and now the prize was within their grasp.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10840,'','The Titans had long since vacated this world. Only the night elves that once inhabited this area were here to defend. Oh my! The next passage is fascinating!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10841,'','A mighty Qiraji known as General Rajaxx would command the initial incursion into Silithus. Only one would stand in his way: A night elf known as Staghelm. They refer to him as Khar\'sis or \'hand of the earth\' in the native Qiraji tongue.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10842,'','Staghelm and his armies were clearly overwhelmed as the endless flow of Rajaxx\'s troops poured into Silithus. It would seem as if Staghelm, however, was more than just a nuisance to the Qiraji. Under Staghelm, the whole of the night elf armies had come together to defend Kalimdor, greatly slowing the Qiraji forces.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10843,'','Unfortunately, the night elf defense was untenable and Rajaxx knew that they could not hold out much longer. Their tenacity, however, was causing great frustration to Rajaxx and causing even more frustration to his king. Wait, kings? Incredible...\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10844,'','Vek\'nilash and Vek\'lor, known as the Twin Emperors of Ahn\'Qiraj, watched the war from the sanctuary of their temple. The clever brothers devised a plan to demoralize and divide Staghelm\'s forces. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10845,'','Valstann Staghelm served as the right hand of Fandral. A proud and noble warrior, his dedication and adoration for his father unyielding... and the Twin Emperors sensed this as weakness. A weakness that could be exploited.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10846,'','The Qiraji forces were commanded to fall back and hide the bulk of their numbers beneath the sands of the desert. A small attack was ordered upon Southwind Village while the front lines of Staghelm\'s army were kept occupied.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10847,'','Valstann, eager to please his father, convinced Fandral to allow him to take a small battalion to the defense of Southwind. Surely with the tide of battle turning their way, no harm could come to his beloved child. The trap was missed. Valstann was captured by the hiding Qiraji and Southwind Village obliterated. Rajaxx himself would take the captive Valstann to the front lines of the battle where - in front of Staghelm and the night elf forces - he would brutally execute the young night elf.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10848,'','The war continued but the will of the great leader was sapped. The whole of Silithus was soon engulfed by the silithid and their Qiraji hosts.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10849,'','Poor man, this explains so much.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10850,'','The night elf army was pushed back through Un\'Goro, to the borders of the Tanaris desert. Something in Un\'Goro prevented the Qiraji from being able to take the land. I do not quite understand this word but I believe it to mean \'God Lands.\' It is stated that they could not \'take the God Lands.\' \n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10851,'Fascinating, this coincides with theories of Un\'Goro being the home of the Titans when they inhabited Kalimdor. Perhaps Aman\'thul himself watched over \'The God Lands.\'\n','Fascinating, this coincides with theories of Un\'Goro being the home of the Titans when they inhabited Kalimdor. Perhaps Aman\'thul himself watched over \'The God Lands.\'\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10852,'','Hrm, curious... This ends abruptly. In Tanaris the Qiraji document facing a bronze dragon. There is much missing from this... More information must be found! Surely they are planning to invade Kalimdor once more!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10853,'%s shifts uncomfortably.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10854,'When the time is right, my lady. All will be clear when the time is right. The master stirs even now. Look to the skies for the Brood of Nozdormu have returned.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10855,'Some call me... Impsy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10856,'','The Wickerman festivities will begin in ten minutes!  Join us in the Ruins of Lordaeron courtyard to celebrate Hallow\'s End and our liberation from the Scourge!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10857,'Leave at once, stranger!  I have no business with you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10858,'You\'re back already!  What can I do for you now?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10859,'','The burning of the Wickerman will begin in fifteen minutes!  Come to the festival - located just west of the Undercity - and celebrate Hallow\'s End and our liberation from the Scourge!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10860,'','The burning of the Wickerman will begin in five minutes!  Come to the festival - located just west of the Undercity - and celebrate Hallow\'s End and our liberation from the Scourge!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10861,'','The Wickerman Festival now begins!  Power to the Forsaken!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(10862,'The war against the Horde has reached full tilt, $n.  This is a time of great need for the Alliance and it\'s necessary that all of us do our part to help.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10863,'War is upon us, $n.  It\'s time for every member of the Horde to answer the call and join the fight against the cowardly Alliance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10864,'%s surveys the ground and nods approvingly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10865,'I don\'t think it\'s strong enough.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10866,'Come, $n. The lake is just around the bend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10867,'Stand near me, $n. I will protect you should anything go wrong.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10868,'Malfurion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10869,'Remulos, old friend. It is good to see you once more. I knew that the message would find its way to you - one way or another.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10870,'It was shrouded in nightmares, Malfurion. What is happening in the Dream? What could cause such atrocities?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10871,'I fear for the worst, old friend. Within the Dream we fight a new foe, born of an ancient evil. Ysera\'s noble brood has fallen victim to the old whisperings. It seems as if the Nightmare has broken through the realm and seeks a new host on Azeroth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10872,'I sensed as much, Malfurion. Dark days loom ahead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10873,'Aye, Remulos. Prepare the mortal races.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10874,'You have been gone too long, Malfurion. Peace between the children of Azeroth is tenuous at best. What of my father? Of your brother? Have you any news?\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10875,'','You\'re a leatherworker by trade, aren\'t you?  It\'s that faint smell of cured hides, I\'d recognize it anywhere.$B$BMy father used to talk about a famous artisan who lived in Southwind Village centuries ago.  It\'s a shame the place is in ruins now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10876,'Cenarius fights at my side. Illidan sits atop his throne in the Outland - brooding. I am afraid that the loss to Arthas proved to be his breaking point. Madness has embraced him, Remulos. He replays the events in his mind a thousand times per day, but in his mind, he is the victor and Arthas is utterly defeated. He is too far gone, old friend. I fear that the time may soon come that our bond is tested and it will not be as it was at the Well in Zin-Azshari. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10877,'Farewell, old friend... Farewell...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10878,'Remulos, I am being drawn back... Tyrande... send her my love... Tell her I am safe. Tell her... Tell her I will return... Farewell...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10879,'Let us return to the grove, mortal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10880,'The strands of LIFE have been severed! The Dreamers must be avenged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10881,'Come forth, ye Dreamers - and claim your vengeance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10882,'Your wicked souls shall feed my power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10883,'I can sense the SHADOW on your hearts. There can be no rest for the wicked!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10884,'Taste your world\'s corruption!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10885,'Hope is a DISEASE of the soul! This land shall wither and die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10886,'Peace is but a fleeting dream! Let the NIGHTMARE reign!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10887,'Children of Madness - I release you upon this world!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10888,'Come, puny mortals. Come and face your end. The secrets of Ahn\'Qiraj will die with Roman\'khan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10889,'','Ah, $n - it is good to see you again.  I trust your affairs go well.',2,1,0,0,0,0,0,0,1,0,0,0,26124),
(10890,'All the resources have been gathered.  Yippee!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10891,'We have all the copper bars that we need. Thank you for your assistance, $c. You might wanna help out with the other materials being collected here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10892,'$C, I need more copper bars! There\'s a war brewing at the Gates of Ahn\'Qiraj and we need supplies! The Alliance has collected $1997w and we need $1998w copper bars in total. If I don\'t get those copper bars, it\'s going to be my head on a platter!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(10893,'My fury is released!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10894,'%s will be armed in 3 seconds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10895,'Myolor, I was once an armorsmith and wish to instead learn the way of the weaponsmith. Will you teach me?','Myolor, I was once an armorsmith and wish to instead learn the way of the weaponsmith. Will you teach me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10896,'Myolor, I was once a weaponsmith and wish to instead learn the way of the armorsmith. Will you teach me?','Myolor, I was once a weaponsmith and wish to instead learn the way of the armorsmith. Will you teach me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10897,'Krathok, I was once an armorsmith and wish to instead learn the ways of the weaponsmith. Will you train me?','Krathok, I was once an armorsmith and wish to instead learn the ways of the weaponsmith. Will you train me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10898,'Krathok, I was once a weaponsmith and wish to instead learn the ways of the armorsmith. Will you train me?','Krathok, I was once a weaponsmith and wish to instead learn the ways of the armorsmith. Will you train me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10899,'You see large cavernous tunnels and corridors reflected inside the crystal. You recognize the area as the Molten Core.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10900,'<Touch the unstable rift crystal.>','<Touch the unstable rift crystal.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10901,'Let them feel the wrath of the Blue Flight! May Malygos protect me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10902,'Alexstrasza grant me the resolve to drive our enemies back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10903,'','Succumb to the endless dream, little ones. Let it consume you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10904,'Anachronos, this diversion will give you and the young druid time enough to seal the gate. Do not falter. Now, let us see how they deal with chaotic magic.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10905,'Up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10906,'The translocator hums, awaiting your command.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10907,'Do not forget the sacrifices made on this day, night elf. We have all suffered immensely at the hands of these beasts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10908,'','We will push them back, Anachronos. This I vow. Uphold your end of this task. Let not your hands falter as you seal our fates behind the barrier.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10909,'We must act quickly or all shall be lost!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10910,'My forces cannot overcome the Qiraji defenses. We will not be able to get close enough to place your precious barrier, dragon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10911,'','There is a way...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10912,'','%s glances at her compatriots.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10913,'%s nods knowingly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10914,'Aye, Fandral, remember these words: Let not your grief guide your faith. These thoughts you hold... dark places you go, night elf. Absolution cannot be had through misguided vengeance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10915,'NOW, STAGHELM! WE GO NOW! Prepare your magic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10916,'It is done, dragon. Lead the way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10917,'Stay close...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10918,'Greetings, $r. Wonderful day to be alive, is it not?','Greetings, $r. Wonderful day to be alive, is it not?',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(10919,'Not all Tauren despise your kind, $r. Alas, I am forbidden to offer you my services.','Not all Tauren despise your kind, $r. Alas, I am forbidden to offer you my services.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10920,'FINISH THE SPELL, STAGHELM! I CANNOT HOLD THE GLYPHS OF WARDING IN PLACE MUCH LONGER! CALL FORTH THE ROOTS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10921,'Ancient ones guide my hand... Wake from your slumber! WAKE AND SEAL THIS CURSED PLACE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10922,'%s falls to one knee - exhausted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10923,'It... It is over, Lord Staghelm. We are victorious. Albeit the cost for this victory was great.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10924,'There is but one duty that remains...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10925,'Before I leave this place, I make one final offering to you, Lord Staghelm. Should a time arise in which you must gain entry to this accursed fortress, use the Scepter of the Shifting Sands on the sacred gong. The magic holding the barrier together will dissipate and the horrors of Ahn\'Qiraj will be unleashed upon the world once more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10926,'%s hands the Scepter of the Shifting Sands to Fandral Staghelm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10927,'After the savagery that my people have witnessed and felt, you expect me to accept another burden, dragon? Surely you are mad.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10928,'I want nothing to do with Silithus, the Qiraji and least of all, any damned dragons!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10929,'%s hurls the Scepter of the Shifting Sands into the barrier, shattering it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10930,'The sands of time will halt, but only for a moment! I will now conjure the barrier.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10931,'Lord Staghelm, where are you going? You would shatter our bond for the sake of pride?\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10932,'My son\'s soul will find no comfort in this hollow victory, dragon. I will have him back. Though it takes a millennia, I WILL have my son back!  ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10933,'%s shakes his head in disappointment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10934,'%s kneels down to pick up the fragments of the shattered scepter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10935,'And now you know all that there is to know, mortal... ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10936,'Listen up, flapjack, we\'re in for the fight of our lives with the bugs in Ahn\'Qiraj and we need to get prepared for it. I\'m collecting iron bars here.  Currently, the Alliance only has $2002w iron bars, but we\'re projected to need a total of $2003w for the war effort.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10937,'Thanks to everyone\'s efforts we now have all the iron bars that we need. Check with one of the others to see if there\'s something else you should be out there collecting for the war effort. Me, I\'m going to see if I can get out of here a little early to play some cards.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10938,'','$C, please listen to what I have to say. The Alliance and Horde are preparing for a war with the Silithid and their masters in Ahn\'Qiraj. Any assistance that you can lend will be greatly appreciated. As you can see, I am collecting thorium bars here for the war effort. We need to gather $2012w in total, and currently we have $2011w.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10939,'','Thank you for checking in with me, $c. We now have all of the thorium bars that we\'ll need, but you may want to ask some of the others here that are in charge of different collection efforts.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10940,'It\'s true, even stranglekelp can be quite useful in building up what we need for the upcoming war at Ahn\'Qiraj! It has so many uses, like making ice cream for hot days under the Silithus sun, as a salve for the effects of some icky plants, breathing underwater, hardening the skin, making you quick, regaining magic power; so many things I can\'t think of them all! Did I mention making ice cream?$B$BAnywhoodles, I\'ve got about $2047w here, and I need a total of $2048w!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10941,'Not that I\'m quite sure that you could ever possibly in a gazillion years have enough stranglekelp, what with all the ice cream one needs, but we seem to have enough. Or that\'s what I\'m told anyway. It looks like some of the others here might need help with whatever it is that they\'re collecting. Understandable really when you consider that theirs just couldn\'t possibly be as fun as collecting stranglekelp.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(10942,'Greetings, young $c. In preparation for the war at Ahn\'Qiraj against the Silithid, the Alliance has asked me to head up their collection of purple lotus. This flower has many uses that I am aware of, and thus, I have agreed to help them attain $2055w. To date we have collected $2053w.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10943,'It is with satisfaction that I relay to you we have collected all of the purple lotus that we feel we need. Thank you for your contribution to the effort, $c. If you are so inclined, there are most likely several still here that are collecting other resources for the struggle.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10944,'','We\'re preparing for war, $c. We\'ve taken all that we\'re going to from the Silithid and their masters in Ahn\'Qiraj. To get ready for it we\'re collecting all sorts of material. I\'m in charge of gathering Arthas\' Tears. Not sure what we need them for though. If you ask me I don\'t want anything to do with that madman, even if it is just a flower named after him.$B$BStill, I\'m my father\'s daughter, and a soldier, so I do what I\'m told. Currently we have $2057w and need to collect a grand total of $2058w.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10945,'','I guess that\'s that. We have all of the Arthas\' Tears necessary. You might try asking around. One of these others is sure to have something that they still need collected for the war effort.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10946,'I get reports of your exploits against the Abyssal Council all the time, $n.  You\'re doing great things out there!$B$BKeep it up, and we\'ll make it worth the effort!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10947,'','The Ahn\'Qiraj War is on the horizon, $c, and in preparation the Alliance has asked my family to gather up a good deal of light leather for the war effort. Out of $2061w needed, we currently have $2060w. You look the type that might be able to help out.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10948,'You dare spill blood on neutral ground? OUT! OUT, I SAY!','You dare spill blood on neutral ground? OUT! OUT, I SAY!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10949,'We don\'t take kindly to miscreants, $r.','We don\'t take kindly to miscreants, $r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10950,'Taste blade, mongrel!','Taste blade, mongrel!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10951,'Please tell me that you didn\'t just do what I think you just did. Please tell me that I\'m not going to have to hurt you... ','Please tell me that you didn\'t just do what I think you just did. Please tell me that I\'m not going to have to hurt you... ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10952,'Get a rope!','Get a rope!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10953,'As if we don\'t have enough problems, you go and create more!','As if we don\'t have enough problems, you go and create more!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10954,'Believe me when I tell you this: You\'re gonna wish you weren\'t born, sissy!','Believe me when I tell you this: You\'re gonna wish you weren\'t born, sissy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10955,'Your actions shame us all, $c. I hurt inside as I beat you senseless.','Your actions shame us all, $c. It pains me to beat you senseless!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10956,'','You\'re sweet for asking, $c, but we have all of the light leather that we need. May be that one of the others in charge of collecting around here is in need of your assistance though?',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(10957,'$G Sir : Ma\'am;, yes $g sir : ma\'am;! Private Porter reporting for duty and ready to assist you with your medium leather collection needs. The Ahn\'Qiraj War is coming and we need to be as prepared as we can be.$B$BAs you can see we have collected exactly $2063w pieces of medium leather, and I have been tasked with gathering a total of $2064w.','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(10958,'Ah, um, yes $g sir : ma\'am;. It would appear that we have collected all of the medium leather that the Alliance feels is necessary for the war. I\'m told that there may be others here though that still need your assistance with their collection efforts.','',66,1,0,0,0,0,0,0,1,0,0,0,26124),
(10959,'','Hi there, $c! With the Ahn\'Qiraj War drawing near, our preparations here are in full swing. I\'m in charge of thick leather collections. It\'s a fine day for gathering thick leather, don\'t ya think? I got my stacks here and it looks like we\'ve got $2069w right now. Our magic number is $2071w. Want to help out?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10960,'','Wow! Looks like we already gathered all of the thick leather they think we\'ll need. That sure went by fast. You know, there are probably others around here that could use your help though if ya want to give \'em a hand.',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(10961,'Open fire!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(10962,'','Hello, $c. I am collecting linen bandages here for the Ahn\'Qiraj war effort; an effort that will put us all to the test, but strengthen us for the war to come. I can assure you that any bandages that you choose to donate will be put to good use in helping to save the lives of our soldiers when the time comes. I am in need of $2077w, and to this point have managed to collect $2076w. Will you assist us?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10963,'','Thank you for the inquiry, $c, but as you can see, I already have all of the linen bandages that the Alliance feels is necessary in preparation for the war at Ahn\'Qiraj. Don\'t let that stop you from helping out with the other collections going on here though.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10964,'This better be important!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10967,'Aye, lads!  Things are about to get quite ugly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10968,'Looks like it\'s going to be one of those days.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10969,'I should\'ve grabbed a bigger sword.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10970,'Footmen, make a line!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(10971,'Great sorrow eminates from this crystal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10972,'<Gaze into the crystalline tear.>','<Gaze into the crystalline tear.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10973,'Something big\'s coming out from the hive, ma\'am.  Headed straight for us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10974,'','Soldier, call Captain Blackanvil at once!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10975,'Yes, Ma\'am!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10976,'Captain!  Lieutenant Stouthammer requests your presence!  The enemy is approaching, sir!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10977,'','Hello, how are you feeling today, $c? Well, I hope. You may be wondering what is going on here. There\'s a war at Ahn\'Qiraj that is being planned and prepared for. We and the Horde are preparing as best we can for it.$B$BTo that end, the Alliance has asked me to supervise the collection of silk bandages here. To date we\'ve managed to put together $2082w out of $2083w needed. Are you thinking about helping out?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10978,'','That\'s very kind of you to ask, but it would appear that we\'ve collected all of the silk bandages that we\'ll need. You could ask around though and see if anyone else needs help with their collections.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10979,'$C, even our hardiest warriors and scouts will need use of the healing arts in the war to come at Ahn\'Qiraj. And when there is no magical healing available, they must rely upon our efforts here.$B$BTo date I have collected $2088w runecloth bandages, out of $2090w needed. If you are willing, we should speak further on how you can do your part.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10980,'$C, through the efforts of many we have managed to gather up all of the runecloth bandages that the Alliance feels it needs for the upcoming conflict. Were I you, I would ask some of the others here to see if they still have collection tasks that need fulfilling.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(10981,'Alas $n, I am much too busy to talk.  As I mentioned, I need time to think on the situation at hand.$B$BI wish you luck in your travels.  Good day.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(10982,'Stand ready!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10983,'Mmm, mmm, mmm. Can you smell that?! That\'s good eatin\' right there, $c. Rainbow Fin Albacore hits the spot every time. Slicky Gastronome here, ace connoisseur of all things edible, especially fish. With the Ahn\'Qiraj War looming, the Alliance thought it wise to bring in an expert for the war effort, so here I am, large and in charge.$B$BLooks like we\'re going to need $2093w of the fish, and we\'ve got a pile that currently comes to $2092w.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(10984,'Well, looks like we have all of the cooked albacore that we can properly salt and store for the upcoming war at Ahn\'Qiraj. Thanks for asking though, $c. If you have a mind to, check around with the other collectors. I\'d bet there\'s someone else here that could use your help with gathering up whatever it is that they need.','',1,1,6,0,0,0,0,0,1,0,0,0,26124),
(10985,'Foolish whelp! I will consume your energies - and then your SOUL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10986,'Take heart! Your friends will not long mourn your passing! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10987,'I must feed... prepare to die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10988,'','Oh, hi, $c. I guess the Alliance asked me to come here and keep track of all of this cooked meat that people are gathering because of the impending doom at Ahn\'Qiraj. Doesn\'t that sound like fun?$B$BAnyway, I suppose you\'d like to know how much we have. Last time I counted it we were at $2098w out of a total $2099w roast raptor needed.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10989,'','Looks like you\'re too late, $c. We have all of the roast raptor that we need; killed, cooked and salted. Anyway, it looks like some of the others around here could use some help. You should go check with them. I\'m going to see if they\'ll let me go home now.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10990,'','Proper sustenance will keep a soldier alive long after the wounds of the battlefield should have finished $g him : her; off, $c. If we\'re to persevere in the Ahn\'Qiraj War to come, we\'ll need all of the provisions that we can carry. I\'m gathering up spotted yellowtail fish at this location before it is to be shipped out.$B$BAs of now we have $2101w, but we need to collect a total of $2103w if we\'re going to be able to feed everyone.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(10991,'','Thank you for your inquiry, $c, but we have all of the spotted yellowtail necessary. There are others here though that may still be gathering materiel for the upcoming war. Seek them out, and may the goddess shine upon you.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10992,'Move along, $C!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10993,'Off with you, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10994,'Do not push it citizen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(10995,'Hello, $c. I\'m sure that I don\'t need to inform you of the gravity of our situation here. We need to gather many goods, and in most cases assemble them into materiel, to be transported to Cenarion Hold in Silithus. This is no small effort.$B$BRecently in the Molten Core we discovered something called a singed corestone. Our blacksmiths and engineers tell us that they can put them to good use, so I\'m supervising their accumulation here. As of now, out of $2110w needed, we\'ve managed to collect $2108w.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(10996,'Thanks to the combined efforts of the Alliance\'s adventuring guilds, we have been able to gather all of the singed corestones we think that we\'ll need. However, you might want to check around with the other collectors here to see if they still need help in gathering up vital resources.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10997,'We need a great number of copper bars, $c. The upcoming war at Ahn\'Qiraj is going to use up a lot of metal for weapons, armor and whatnot. I\'m told that the Horde alone needs to collect $1998w copper bars. As of now we have $2018w.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10998,'According to the latest count we have all of the copper bars we\'re going to need for the war. If I were you I\'d check with some of the other collectors here to see if they need your help.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(10999,'If you have not spoken to Magistrix Erona at the Sunspire, I recommend you do so immediately.  There are pressing matters to attend to, and she - as do we all - need your help!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11000,'$n, it is good to see you again.$B$BRemember to stay focused on your learning.  You represent our future, and should you falter our future will be dark indeed.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11001,'Throm\'ka, $c. You are here to help me with tin bars? They tell me that I will need $2006w so that they can make weapons and armor for the upcoming Ahn\'Qiraj War, but I only have $2005w right now. You are going to bring me more!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(11002,'No more tin bars! Even my arms hurt from stacking them. We have all that we need, so go ask one of the others if they need you to collect anything.','',1,25,0,0,0,0,0,0,1,0,0,0,26124),
(11003,'','Welcome to the Falconwing Square Inn. May I prepare a meal for you, or ready a room?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(11004,'A golden placard along the side of the shrine reads:$B$B\"Here stands the Shrine of Dath\'Remar, a fitting tribute to the most noble of elves.  Let all who gaze on this monument remember his sacrifices to bring us to this land.  All who prosper in Quel\'Thalas do so thanks to him.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11005,'','Hail, $c.  The Ironforge Brigade is stationed here to keep an eye on Hive\'Zora.  The Cenarion Circle druids have been monitoring silithid movement and they\'re anticipating something major in this area.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11006,'I\'m here to aid the Captain.','I\'m here to aid the Captain.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11007,'','The Captain is busy at the moment.  He\'s studying maps we recently acquired of the underground silithid hives.  Stay with us if you\'d like to help, he\'ll come out any moment now.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11008,'%s is stunned by Elune\'s Candle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11009,'Kill $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11010,'','Hey mon, you be here ta bring me mithril bars no doubt. There be big trouble brewin\' in the Silithus desert at Ahn\'Qiraj. We and the Alliance goin\' all out this time to stop them bugs, and that be why you seein\' everyone here.$B$BThe Horde be askin\' me to collect $2009w for the war effort, but I only have $2008w. So ya gonna help me out, or what?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11011,'','Yah, I know, it be lookin\' like we already have all of the mithril bars we be needin\' for the war. But ya know, there still be plenty of folk \'round here that can probably be usin\' your help right about now.  Thanks mon.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11012,'They come now. Try not to get yourself killed, young blood.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11013,'','Hello, young $c. Are you here to bring me a batch of peacebloom? We are collecting them to make potions and elixirs for the Ahn\'Qiraj war effort. Though tragic that we are forced into this war, the results will be even more terrible if we do not prepare properly.$B$BThe Horde has tasked me with the collection of $2020w peacebloom, and so far we\'ve managed to put together $2021w. If you have it within your ability, please gather up all that you can and return them to me here.',2,1,1,0,0,0,0,0,1,0,0,0,26124),
(11014,'','It is good that you wish to help, $c. Unfortunately I have collected up all of the peacebloom that we feel we\'ll need for the war effort. Maybe you could ask around; I\'m sure that there are likely to be others here that still need your aid in gathering other things.',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(11015,'You seek to harm me, $r?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11016,'I am a treasure hunter in search of powerful artifacts. Give them to me and you will not be harmed.','I am a treasure hunter in search of powerful artifacts. Give them to me and you will not be harmed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11017,'You challenge the charge of the Blue Dragonflight? DIE, vermin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11018,'%s counterattacks with retaliation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11022,'My watch is eternal, mortal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11023,'There is more to magic than just arcane gesticulations... but I am speaking to someone who already knows this, yes?$B$BYou\'ve come to me to learn, and learn you will... just so long as you pay attention and do as I say.  The secrets of the demons do not cater to fools, and neither do I.','There is more to magic than just arcane gesticulations... but I am speaking to someone who already knows this, yes?$B$BYou\'ve come to me to learn, and learn you will... just so long as you pay attention and do as I say.  The secrets of the demons do not cater to fools, and neither do I.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11025,'<Andorov looks at you grimly.>$B$BIf it bleeds, we can kill it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11026,'Let\'s find out.','Let\'s find out.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11027,'Your world shall suffer an unmerciful end. The Nightmare comes for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11028,'Remember, Rajaxx, when I said I\'d kill you last?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11029,'The end rapidly approaches! Surrender yourselves to Eranikus and be spared eternal suffering!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11030,'Pitiful, predictable mortals... You know not what you have done! The Master\'s will fulfilled. The Moonglade shall be destroyed and Malfurion along with it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11031,'Run, little ones. Run and tell your masters that Eranikus has come to raze their world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11032,'Kill first, ask questions later... Incoming!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11033,'You seek the scepter shard charged to the protection of the Blue Flight?$B$B<Azuregos appears to be smiling.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11034,'How did you know? I mean, yes... Yes I am looking for that shard. Do you have it?','How did you know? I mean, yes... Yes I am looking for that shard. Do you have it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11035,'Of course I do not have the shard. That would be asinine. I walk amongst savages in this cursed land! I cannot take five steps without some crazed orc or human trying to thrust a sharp stick into my hide. At any given time you could very well be speaking to my ghostly spirit.$B$BAnyhow... I hid it.$B$BGo on... ask me where.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11036,'Alright. Where?','Alright. Where?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11037,'You are going to love this story, $r. See, here is the thing. As soon as Malygos charged me with protecting the scepter shard, I knew I was in for an eternity of headache and pain.$B$BAll I want to do is study these magic rich shorelines and take in what artifacts might remain from the Sundering. You know, there was once a thriving Highborne civilization here! You don\'t have to tell me that there is going to be some solid magical items around here, $r. I can smell it!','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11038,'By Bronzbeard\'s... um, beard! What are you talking about?','By Bronzbeard\'s... um, beard! What are you talking about?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11039,'As I was saying, I held onto that scepter shard for a good five-hundred years and it was nothing but trouble. It attracted all kinds of attention - the wrong kind of attention. I want to be left alone to my studies not babysit some would be hero\'s ticket to glory. So... I gave it to the fish.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11040,'Fish? You gave a piece of what could be the key to saving all life on Kalimdor to a fish?','Fish? You gave a piece of what could be the key to saving all life on Kalimdor to a fish?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11041,'Not just any fish, mortal. This fish was a minnow. A very special minnow.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11042,'A minnow? The oceans are filled with minnows! There could be a hundred million minnows out there!','A minnow? The oceans are filled with minnows! There could be a hundred million minnows out there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11043,'Exactly!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11044,'...','...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11045,'Genius, I know... It will never be found; but, in case it is found, I gave the minnow some special powers.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11046,'You put the piece on a minnow and placed the minnow somewhere in the waters of the sea between here and the Eastern Kingdoms? And this minnow has special powers?','You put the piece on a minnow and placed the minnow somewhere in the waters of the sea between here and the Eastern Kingdoms? And this minnow has special powers?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11047,'Correct. You\'ve been listening! This minnow is really quite a terrible creature of my own creation. When I am relaxing I like to think of the unlucky fishermen who have run into this minnow and been devoured whole. I bet they were quite surprised!$B$B<Azuregos laughs.>','',1,11,0,0,0,0,0,0,1,0,0,0,26124),
(11048,'You\'re insane.','You\'re insane.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11049,'Genius is often misunderstood, $r. Now, about the scepter shard... If you want that shard and do not wish to spend the next ten thousand years searching for it, you are going to have to listen very carefully.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11050,'I\'m all ears.','I\'m all ears.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11051,'Two words: Arcanite buoy.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11052,'Come again.','Come again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11053,'Right then... You have to build an arcanite buoy and place it in the ocean. My minnow will be attracted to the magical emanations. When he gets near the buoy - BLAMO! It will explode in a glorious pulse of arcane energy, revealing the minnow\'s true form. Also, you may or may not incur the wrath of Neptulon. A 50/50 chance I would say.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11054,'Ok, let me get this straight. You put the scepter shard entrusted to your Flight by Anachronos on a minnow of your own making and now you expect me to build an... an arcanite buoy or something... to force your minnow out of hiding? AND potentially incur the wrath of an Elemental Lord? Did I miss anything? Perhaps I am to do this without any clothes on, during a solar eclipse, on a leap year?\n','Ok, let me get this straight. You put the scepter shard entrusted to your Flight by Anachronos on a minnow of your own making and now you expect me to build an... an arcanite buoy or something... to force your minnow out of hiding? AND potentially incur the wrath of an Elemental Lord? Did I miss anything? Perhaps I am to do this without any clothes on, during a solar eclipse, on a leap year?\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11055,'General Rajaxx has been owned. Chalk up another victory for Andorov.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11056,'If I did not know better I would think that you were mocking me, mortal; but yes, that is mostly correct. You may remain fully clothed.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11057,'FINE! And how, dare I ask, am I supposed to acquire an arcanite buoy?','FINE! And how, dare I ask, am I supposed to acquire an arcanite buoy?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11058,'Take this ledger to an old acquaintance of mine in Tanaris. His name is Narain Soothfancy - terrible, terrible, psychic but an amazing engineer! He should be able to make sense of it all.$B$BNo need to thank me, $n. It\'s the least I could do.$B$BGood day!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11059,'But...','But...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11060,'I SAID GOOD DAY!','',1,15,0,0,0,0,0,0,1,0,0,0,26124),
(11061,'','Step carefully mortal.  You tread where mightier beings have met their fate.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11062,'A thousand years ago, when the War of the Shifting Sands ended, three of our kin sacrificed themselves and held the Qiraji inside these halls while Anachronos and Staghelm sealed Ahn\'Qiraj shut.$B$BEach of us vowed to look for Merithra, Arygos and Caelestrasz should the Scarab Wall ever fall.$B$BAnd fall it did... and so we came.','',274,0,0,500,0,0,0,0,1,0,0,0,26124),
(11063,'Shouldn\'t you be saving the world?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11064,'<Narain holds an unopened envelope to his forehead.>$B$BWhat is... Mmmm... Velvet!$B$BAm I right?$B$BIf you\'re here to try and relearn a tradeskill, use the book over there...$B$B<Narain points to \"Soothsaying for Dummies.\">','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11065,'Don\'t tell me! Shhh! You are here about the Ashbringer?!? Yes... Yes... No! My bad.$B$BWhat can I help you with, $r?$B$BIf you\'re here to try and relearn a tradeskill, use the book over there...$B$B<Narain points to \"Soothsaying for Dummies.\">','',22,1,6,0,0,0,0,0,1,0,0,0,26124),
(11066,'Narain Soothfancy, at your service! Retired engineer and master soothsayer! I can tell your future before it even happens!$B$BIf you\'re here to try and relearn a tradeskill, use the book over there...$B$B<Narain points to \"Soothsaying for Dummies.\">','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11067,'You are not worth my time, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11068,'Your path does not match mine.  You must seek training elsewhere, $c.','Your path does not match mine.  You must seek training elsewhere, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11069,'Do you seek training?','Do you seek training?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11071,'I do what me can to train you in the priestly ways, if that what you be here for.','I do what me can to train you in the priestly ways, if that what you be here for.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(11072,'I require priest training.','I require priest training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11073,'I require rogue training.','I require rogue training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11074,'%s sets eyes on $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11075,'Hehehe, how you doin\' mon. You gonna help Pele\'keiki great deal he be thinkin\'. We be needin\' a bombastic amount of the firebloom herb to be preparin\' right for the Ahn\'Qiraj War. The Horde, they say, \'Pele\'keiki, you get us $2051w of the fire petals right quick\'.$B$BPele\'keiki tell you now, he only have $2050w firebloom, but you gonna add to that real soon, right mon?','',153,0,0,0,0,0,0,0,1,0,0,0,26124),
(11076,'Pele\'keiki know, it seem impossible even to him, but we be havin\' all that firebloom the Horde be wantin\' for the war. If you not be feelin\' too lazy, Pele\'keiki think you be helpin\' out the others here. They sure to have many things they be wantin\' you to get for them.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11077,'','Ah, there you are. I was told to expect help, so please listen closely. The situation is this: I\'ve been tasked with gathering $2055w purple lotus in preparation for the coming war in Ahn\'Qiraj. To date we have $2054w.$B$BActually going into the field and collecting the flowers will be up to you and those like you. I am needed here to see that they are properly maintained and to find new, creative applications for their use against the silithid and whatever else awaits us there.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11078,'','We\'re filled to capacity on purple lotus, $c. Go ask one of the others if they need your help, and leave me to my studies. There is no time to waste!',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11079,'','You\'re here to help with the heavy leather for the Ahn\'Qiraj war effort, are you, $c? Good, good. As you can see I\'ve collected $2066w, but we\'re going to need $2067w in total. That\'s a lot of skinning my friend, so I hope that your knife is sharp. The leather will go to all sorts of uses for making our war materiel and ensuring our success.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11080,'','Ah, that\'s sweet of you mon, but we already got all the heavy leather that we need. And here I\'m sure that your knife is still sharp. Maybe you can put it to use helping the others with their collections, no?  Have a good one!',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11081,'','An unspeakable horror dwells here, mortal.  C\'Thun and his worshippers are not just an affront to nature, their existence presages destruction for Azeroth as we know it.$B$BMerithra sacrificed herself a thousand years ago along with Caelestrasz and Arygos because they knew this as well.  We\'re here because of our oath to return for them, but we\'re also here because C\'Thun must be stopped!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11082,'','Lok\'tar, $c, I have important information! There\'s a war coming at Ahn\'Qiraj and we need to get ready for it. I\'m here collecting all of the thick leather that I can get my hands on. Right now we have $2070w, but the Warchief has tasked me with the gathering of $2071w. As you can see, I\'m a little short.',5,1,1,0,0,0,0,0,1,0,0,0,26124),
(11083,'','If you have more thick leather, I\'m sorry but you\'ve come too late. We have all that we need, but before you go would you check with the others here? There\'s likely someone that still needs your help with their own collecting.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11084,'Hello, $c. I trust that you bring good tidings concerning the Ahn\'Qiraj War preparations. I myself have been placed in charge of all accumulation of rugged leather for the Horde; a task to which I feel uniquely qualified. Never underestimate the utility of a sharpened knife.$B$BAs to the rugged leather, we currently have $2073w out of $2074w needed.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11085,'Such a pity, and here I\'ll wager that you sharpened your knife special in anticipation of slicing a few skins for me. Alas, we\'ve already gathered all of the rugged leather necessary, $c. Do make yourself useful though, and check with the others here to see if they have any other collection tasks to send you on.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(11086,'','I find the ocean floor to be very peaceful.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11087,'','It\'s so lovely to see you again, $n! I really can\'t thank you enough for delivering that message to my dear little gnome.$B$BWould you like to hear a song? It will make traveling in the rough seas much easier!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11088,'That would be wonderful! Thank you, Meridith.','That would be wonderful! Thank you, Meridith.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11089,'','Lovely song, isn\'t it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11090,'Ah, $c, good to see you. We need assistance here with gathering supplies in preparation for the impending war at Ahn\'Qiraj. I\'ve been asked to put together a great many first aid field kits, and the primary component I need is wool bandages. I already have some, $2079w to be exact, but I need to collect $2080w.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11091,'I thank you for your inquiry, but I already have all of the wool bandages necessary for the war effort. I suggest that you ask around though; there are many here that could probably still use your aid.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11092,'','Hello, $c, good of you to show up. Allow me to be succinct; we are gathering supplies for the Ahn\'Qiraj war effort. We wouldn\'t want to have more casualties than necessary, now would we? I have the responsibility of coordinating the collection of $2086w mageweave bandages. To date we have garnered $2085w. Care to assist?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11093,'','How unfortunate; it would appear that we have collected all of the mageweave bandages necessary. Perhaps you can go sell them on the auction house? But before you go, be a good $g boy : girl; and check with the other collectors present. They may have an errand to send you off on.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11094,'I shall take my secrets to the grave with me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11095,'','The Earth Mother provides, but at times, a $c needs a little extra help to survive. Thus, I am collecting all of the runecloth bandages that we can in preparation for the looming war at Ahn\'Qiraj. As of now we have gathered $2089w on our way to collecting a total of $2090w.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11096,'','It is very kind of you to ask after our needs, $c. It would appear though that we have collected all of the runecloth bandages we feel we\'ll need of the war. May I ask that you inquire around with some of the other collectors and lend them your aid if needed? Ancestors watch over you.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11097,'','Grrr, what do you want, $r? Oh, you must be here about the lean wolf steaks for the impending Ahn\'Qiraj War. Yes, you heard right, I\'m collecting them, what about it? Do you have a fresh stack for me? I only need $2096w, and it looks like we have $2095w right now.',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(11098,'','Looks like we have as many lean wolf steaks as the Horde wants. They told me to pack up what we have here and ready it to be shipped it out to Cenarion Hold in Silithus. But it looks like some of the others here might still be collecting whatever it is that they\'re in charge of. Go bug one of them.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(11099,'Ja mon, I be collectin\' up the fishy-fishy for the Horde. They gettin\' ready for big war in the desert at Ahn\'Qiraj, and askin\' me to get them $2103w of the spotted yellowtail. But right now we only be havin\' $2102w. You here to help?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11100,'Heya, $c! Lookin\' like we got all the spotted yellowtail that we be needin\' for that war. Maybe you going to some of the other collectors \'round here and askin\' them if they be needin\' your help?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(11101,'Greetings, $c. It is good to see you interested in helping with the war effort. The collectors here are organizing the gathering of various stockpiles of goods so that we will be prepared when the time comes.$B$BI am in charge of obtaining $2106w baked salmon to store away for those involved in the fighting at Ahn\'Qiraj. The last time that I counted, we had collected $2105w.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11102,'It is good of you to ask, $c, but we already have all of the baked salmon that we\'ll need for the war. Perhaps you would be kind enough to check with the other collectors here; they are sure to have something that they could use your help with.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11103,'I do not have time to waste, $c; there is a war at Ahn\'Qiraj to prepare for. If you are going to help, we are collecting singed corestones from the Molten Core. I need to gather a total of $2110w, and currently have $2109w.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11104,'The guilds of the Horde have pulled together and accomplished this task already $c. We have all of the singed corestones necessary for our war materiel. Make yourself useful by asking the other collectors here if they need your aid.','',1,25,0,0,0,0,0,0,1,0,0,0,26124),
(11105,'Now is the time when the year is new and the moon shines bright.$B$BIt is our time... when the ancients awake.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11106,'No hello for your old friend, Narain? Who were you expecting???','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11107,'%s eyes you suspiciously.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11108,'So... You thought you could fool me, did you? The greatest criminal mastermind Azeroth has ever known???','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11109,'I see right through your disguise, $r. Number Two! Number Two kill!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11110,'KILL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11111,'In days long past, we lived for the hunt.  We hunted for glory, for honor...$B$BIs it so different now?','In days long past, we lived for the hunt.  We hunted for glory, for honor...$B$BIs it so different now?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11112,'','Dogs of the Cenarion Circle.  Slay them all!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11113,'Your quest to learn Draconic is futile, mortal. And why would you ever want to learn to speak in the ancient tongue? Baffling really...','',0,0,0,0,0,0,0,11,1,0,0,0,26124),
(11114,'<Take this book for the good of Azeroth!>','<Take this book for the good of Azeroth!>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11115,'%s is devoured!','%s is devoured!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11116,'It... It\'s foggy, $n. I can\'t see anything! Wait... Wait a minute. I see... I see Doctor Weavil\'s hideout. It... YES! I believe he is holding a chapter of the book!$B$BLet me see if I can zoom this thing out to get a better vantage point.$B$B<Narain appears to be going cross-eyed.>$B$BAlcaz Island! That devious son-of-a-goblin is on Alcaz Island!','',274,23,5,0,0,0,0,0,1,0,0,0,26124),
(11117,'Evil makes me so sleepy...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11118,'%s yawns.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11119,'Lok\'tar, $r. I am General Zog, ambassador of the Horde. I am here to keep you apprised of the progress that the mighty Horde is making in their efforts toward the Ahn\'Qiraj War. What is it that you want to know?','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11120,'What is the Ahn\'Qiraj war effort?','What is the Ahn\'Qiraj war effort?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11121,'This line is mostly filler...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11122,'How many metal bars have the Horde collected so far?','How many metal bars have the Horde collected so far?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11123,'How many metal bars you say? As of my last update on the situation, here is what I know. The Horde has collected $2018w copper bars out of $1998w needed, $2005w tin bars out of $2006w and of $2009w mithril bars sought, $2008w have been gathered.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11124,'How many herbs have the Horde collected so far?','How many herbs have the Horde collected so far?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11125,'Last I heard the Horde had accumulated $2021w of $2020w peacebloom, $2050w of $2051w firebloom and $2054w out of $2055w purple lotuses.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11126,'How many leather skins have the Horde collected so far?','How many leather skins have the Horde collected so far?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11127,'Leather skins? Yes, I just received some information on that. It would appear that of $2067w heavy leather needed, the Horde has collected $2066w. Also, $2070w out of $2071w thick leather and $2073w out of $2074w rugged leather have been gathered.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11128,'How many bandages have the Horde collected so far?','How many bandages have the Horde collected so far?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11129,'The Horde is stockpiling a great many bandages. So far $2079w out of $2080w wool bandages have been collected. $2085w out of $2086w mageweave bandages have been created. And $2089w out of $2090w runecloth bandages have been gathered.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11130,'How many cooked goods have the Horde collected so far?','How many cooked goods have the Horde collected so far?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11131,'You want to know about ration collections? Very well. Last I was told, the Horde had prepared $2095w out of $2096w lean wolf steaks. We\'ve also packed away $2102w of $2103w spotted yellowtail and $2105w out of $2106w baked salmon needed.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11132,'I want to ask you about something else.','I want to ask you about something else.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11133,'Greetings, $r $c. I am Commander Stronghammer, the ambassador representing the Alliance here. If you have any questions concerning the status of Alliance collections for the Ahn\'Qiraj war effort, $g lad : lass;, don\'t hesitate to ask.','',2,1,0,0,0,0,0,0,1,0,0,0,26124),
(11134,'This line is mostly filler...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11135,'How many metal bars have the Alliance collected so far?','How many metal bars have the Alliance collected so far?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11136,'A very good question, $c. When last I had heard, the Alliance had managed to smelt $1997w out of $1998w copper bars, $2002w out of $2003w iron bars and $2011w out of $2012w thorium bars needed for the war effort.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11137,'How many herbs have the Alliance collected so far?','How many herbs have the Alliance collected so far?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11138,'Let me see, let me see. I had those numbers here somewhere. Ah yes, here they are! To date, the Alliance has collected $2047w stranglekelp, out of $2048w needed. It also says here that we have $2053w of $2055w purple lotus and $2057w out of $2058w arthas\' tears needed.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11139,'How many leather skins have the Alliance collected so far?','How many leather skins have the Alliance collected so far?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11140,'Funny you should ask... I just received an update on that. Thus far, the Alliance has gathered $2060w of $2061w light leather, $2063w out of $2064w medium leather and $2069w of $2071w thick leather skins.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11141,'How many bandages have the Alliance collected so far?','How many bandages have the Alliance collected so far?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11142,'Bandages you say? Yes, well, if memory serves from the last time I was told, it would appear that the Alliance has created $2076w of $2077w linen bandages, $2082w of $2083w silk bandages and $2088w of $2090w runecloth bandages.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11143,'How many cooked goods have the Alliance collected so far?','How many cooked goods have the Alliance collected so far?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11144,'That reminds me, I\'m going to need to find something to eat soon. As to what the Alliance has been cooking up, I\'m told that $2092w out of $2093w rainbow fin albacore have been packed away. As well, $2098w of $2099w roast raptor and $2101w out of $2103w spotted yellowtail have been prepared and are currently in cold storage awaiting transport to Cenarion Hold in Silithus.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(11145,'The stars of this time are bent on new paths, beacons of hope and strength for the coming ages.','The stars of this time are bent on new paths, beacons of hope and strength for the coming ages.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11146,'Haha, $g boyo : girlie;! The Alliance has gathered everything that we\'re needin\' to get this here war started! Maybe the Horde will catch up soon?','',94,0,0,0,0,0,0,0,1,0,0,0,26124),
(11147,'It\'s all over \'cept for the crying now. All of the war materiel is being transported to Cenarion Hold in Silithus, and will be there in less than $2113w days. Shouldn\'t be much longer until the scepter is assembled and the war finally begins.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11148,'Well, well, what do you know, sparky, we did it. Everything\'s collected and ready to go. We\'re just waiting on those Horde yahoos now, and once they get their act together it\'s off to the races at Ahn\'Qiraj!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(11149,'Woo hoo, here we go! Everyone\'s collected everything, and it\'s all being airlifted via zeppelin to Silithus as we speak. The last of it should be there in less than $2113w days. Once it\'s all over there, and the scepter has been assembled, the war against those dirty insects can begin. As they say, \'Ship It!\'	','',1,4,0,0,0,0,0,0,1,0,0,0,26124),
(11150,'','It would appear dear that the Alliance has managed to collect everything needed for the war effort. Now all that we\'re waiting on are those poor Horde creatures to finish with theirs.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11151,'','Hello, $c. From what I\'ve been told, everything\'s been collected, and all of the materiel for the war is being shipped over to Silithus as we speak. It should all be there in less than $2113w days. Once that\'s done, and the gong has been rung with the Scepter of the Shifting Sands, the war will really begin.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11152,'Well, looks like we\'ve gathered up everything that the Alliance is going to need; now we\'re just waiting on the Horde. I think soon I\'m going to see if there\'s any Tigule & Foror\'s ice cream nearby.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11153,'That\'s it, everything\'s been collected by both sides. Now it\'s all being transported over to Silithus and should be there in less than $2113w days. Once that\'s done and someone rings the gong on the Scarab Dais with the Scepter of the Shifting Sands, the war is on!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(11154,'Welcome to Booty Bay, partner.  I hope your stay in my town is enjoyable and uneventful - emphasis on the latter.  We\'ve got plenty of drink if you\'re thirsty, and plenty of bouncers if you\'re antsy.$B$BNow then... what can this humble servant of the Steamwheedle Cartel do for you?  Better still - what can you do for me, eh?','',3,1,0,0,0,0,0,0,1,0,0,0,26124),
(11155,'All of the material necessary for the Alliance\'s contribution to the war effort has been satisfied, $c. We await the Horde\'s labors to be finalized and then shall move on to transporting the war materiel to Silithus.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11156,'All is completed, young $c. Even as we speak, both the Horde and the Alliance are in the process of transporting all final goods for the war into Silithus near Cenarion Hold, which should be complete in less than $2113w days. After that, the gong near the gates of Ahn\'Qiraj can be rung, and the war will begin.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11157,'','Hail, $c. As you may know, we\'ve completed all collections necessary for the Alliance\'s role in the upcoming war. Now it\'s up to the Horde to finish with theirs and we\'ll ship out to Silithus.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11158,'','Are you reporting for duty, $c? All of the war materiel for both the Horde and the Alliance is completed and being shipped to Silithus as we speak. It should all arrive in less than $2113w days. I hope that someone has found the different pieces of the Scepter of the Shifting Sands and put them all together.',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(11159,'A being of great power has awoken.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11160,'The beast returns from whence it came. The wrath of Neptulon has subsided.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11161,'','Well now, $g lad : lass;, it looks like the Alliance has already gathered up all that we need for our part of the war. I know that the blacksmiths, engineers and everyone else is busy with the final preparations, and as soon as the Horde assembles all of their goods, it will all be sent to Silithus for the war.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11162,'','As I understand it dear, everything has been gathered and the final materiel is being assembled and shipped off to Cenarion Hold. The last of it should arrive in less than $2113w days. Once our equipment and forces are all there, the bearer of the Scepter of the Shifting Sands can ring the gong near Ahn\'Qiraj to open the gates. Then the war will begin.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11163,'It\'s all over \'cept for the crying now. All of the war materiel is being transported to Cenarion Hold in Silithus, and the last of it will be there in less than a day. Shouldn\'t be much longer until the scepter is assembled and the war finally begins.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11164,'Woo hoo, here we go! Everyone\'s collected everything, and it\'s all being airlifted via zeppelin to Silithus as we speak. The last of it should be there in less than a day. Once it\'s all over there, and the scepter has been assembled, the war against those dirty insects can begin. As they say, \'Ship It!\'','',1,4,0,0,0,0,0,0,1,0,0,0,26124),
(11165,'','Hello, $c. From what I\'ve been told, everything\'s been collected, and all of the materiel for the war is being shipped over to Silithus as we speak. It should all be there in less than a day. Once that\'s done, and the gong has been rung with the Scepter of the Shifting Sands, the war will really begin.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11166,'That\'s it, everything\'s been collected by both sides. Now it\'s all being transported over to Silithus and should be there in less than a day. Once that\'s done and someone rings the gong on the Scarab Dais with the Scepter of the Shifting Sands, the war is on!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(11167,'All is completed, young $c. Even as we speak, both the Horde and the Alliance are in the process of transporting all final goods for the war into Silithus near Cenarion Hold, which should be complete in less than a day. After that, the gong near the gates of Ahn\'Qiraj can be rung, and the war will begin.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11168,'','Are you reporting for duty, $c? All of the war materiel for both the Horde and the Alliance is completed and being shipped to Silithus as we speak. It should all arrive in less than a day. I hope that someone has found the different pieces of the Scepter of the Shifting Sands and put them all together.',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(11169,'','As I understand it dear, everything has been gathered and the final materiel is being assembled and shipped off to Cenarion Hold. The last of it should arrive in less than a day. Once our equipment and forces are all there, the bearer of the Scepter of the Shifting Sands can ring the gong near Ahn\'Qiraj to open the gates. Then the war will begin.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11170,'Yes $g sir : ma\'am;! I\'ve been ordered to report that the Alliance has collected all war materiel necessary. It has been relayed to me that we are simply waiting on the Horde to finish their part and then everything will be shipped to Silithus. Thank you $g sir : ma\'am;!','',66,1,0,0,0,0,0,0,1,0,0,0,26124),
(11171,'A-ten-hut! All Ahn\'Qiraj war materiel accounted for and in the process of being transported to Cenarion Hold $g sir : ma\'am;! I am told that the last of it should arrive in less than $2113w days. Once that is done, and someone rings that gong over there to open the gates, I guarantee that we\'ll give those bugs one heck of a fight!','',66,1,0,0,0,0,0,0,1,0,0,0,26124),
(11172,'A-ten-hut! All Ahn\'Qiraj war materiel accounted for and in the process of being transported to Cenarion Hold $g sir : ma\'am;! I am told that the last of it should arrive in less than a day. Once that is done, and someone rings that gong over there to open the gates, I guarantee that we\'ll give those bugs one heck of a fight!','',66,1,0,0,0,0,0,0,1,0,0,0,26124),
(11173,'','Hey there, $c! Looks like the Horde collected the last of their stuff, and now theirs and ours is being shipped over to Silithus as we speak. I\'m told it\'ll be there in less than a day, and then someone can ring that big gong near the Ahn\'Qiraj gates to start the war.',3,1,0,0,0,0,0,0,1,0,0,0,26124),
(11174,'','Hey there, $c! Looks like the Horde collected the last of their stuff, and now theirs and ours is being shipped over to Silithus as we speak. I\'m told it\'ll be there in less than $2113w days, and then someone can ring that big gong near the Ahn\'Qiraj gates to start the war.',3,1,0,0,0,0,0,0,1,0,0,0,26124),
(11175,'','Hello, $c! I\'ve went around and asked, and it looks like all of us here have collected everything that the Alliance needs to prepare for the Ahn\'Qiraj War. Now we just need to encourage the Horde to do the same and then we\'ll be able to ship it all over to Cenarion Hold in Silithus.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11176,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11177,'Narain, I need another special kit.','Narain, I need another special kit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11178,'Narain, if you have enough materials, I could use another arcanite buoy.','Narain, if you have enough materials, I could use another arcanite buoy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11179,'','Even as we speak, $c, all of the war materiel is being transported over to Silithus. By the looks of things, the last of it should arrive in less than a day. After that, a $g hero : heroine; will need to come along and ring the gong at the Scarab Dais. Then the war will begin in earnest.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11180,'','Even as we speak, $c, all of the war materiel is being transported over to Silithus. By the looks of things, all of it should arrive in less than $2113w days. After that, a $g hero : heroine; will need to come along and ring the gong at the Scarab Dais. Then the war will begin in earnest.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11181,'','Take pride, $c, in the fact that the Alliance has completed all of the gathering tasks set before it. The finished products are stored and preserved, and our tradeskill professionals are hard at work molding those raw materials into war materiel that will be shipped to Silithus as soon as the Horde finishes their collections.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11182,'','Looks like the last of the goods we\'ve collected is going to be shipped out to Silithus sometime in the next day. And once that\'s done, someone will have to come along and ring the gong on the Scarab Dais, outside of Ahn\'Qiraj, to open the gates. That\'s when our bandages will come in handy.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11183,'','Looks like the last of the goods we\'ve collected are shipping out to Silithus over the next $2113w days. And once that\'s done, someone will have to come along and ring the gong on the Scarab Dais, outside of Ahn\'Qiraj, to open the gates. That\'s when our bandages will come in handy.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11184,'','The generals tell us that we\'ve collected everything that we need for the upcoming Ahn\'Qiraj War. Now we\'re just waiting for the Horde to finish their stockpiling and the transport of the war materiel can begin.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11185,'All is gathered, $c. All is being transported for final preparation to Silithus and should arrive within a day. All of our combined forces await the $g hero : heroine; that will complete the reunification of the Scepter of the Shifting Sands, ring the gong and begin the Ahn\'Qiraj War.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11186,'All is gathered, $c. All is being transported for final preparation to Silithus and should arrive within $2113w days. All of our combined forces await the $g hero : heroine; that will complete the reunification of the Scepter of the Shifting Sands, ring the gong and begin the Ahn\'Qiraj War.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11187,'The Alliance has completed its gathering tasks, $c. Now, while we pack and prepare everything, we await the Horde\'s collections to be completed. Then we shall all transport our war materiel to Silithus.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11188,'All of the fish and everything else is on its way to Silithus, and should be there in less than a day. After that someone\'s going to have to ring that gong with the Scepter of the Shifting Sands to start the war.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11189,'All of the fish and everything else is on its way to Silithus, and should be there in less than $2113w days. After that someone\'s going to have to ring that gong with the Scepter of the Shifting Sands to start the war.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11190,'The buzz around here is that we\'ve collected everything that we need. Now it all comes down to the Horde gathering up their stuff. Once they have we can all ship our goods over to Silithus and the war can begin.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11191,'The walls of the chamber tremble. Something is happening...','The walls of the chamber tremble. Something is happening...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11192,'%s bows.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11193,'Be steadfast, champion. I know why it is that you are here and I know what it is that you seek. Eranikus will not give up the shard freely. He has been twisted... twisted by the same force that you seek to destroy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11194,'Are you really surprised? Is it hard to believe that the power of an Old God could reach even inside the Dream? It is true - Eranikus, Tyrant of the Dream, wages a battle against us all. The Nightmare follows in his wake of destruction.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11195,'Understand this, Eranikus wants nothing more than to be brought to Azeroth from the Dream. Once he is out, he will stop at nothing to destroy my physical manifestation. This, however, is the only way in which you could recover the scepter shard.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11196,'You will bring him back into this world, champion. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11197,'','All of the food and war materiel we gathered is on its way to Silithus. It should be there in less than a day. Someone told me that once it\'s all assembled over near Cenarion Hold, someone\'s going to have to go ring the gong at the Scarab Dais to open the gates to Ahn\'Qiraj and start the war.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11198,'','All of the food and war materiel we gathered is on its way to Silithus. It should be there in less than $2113w days. Someone told me that once it\'s all assembled over near Cenarion Hold, someone\'s going to have to go ring the gong at the Scarab Dais to open the gates to Ahn\'Qiraj and start the war.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11199,'','Hey there, $c. I\'ve talked with everyone around here, and it seems like we have all of the stuff that the Alliance wants for the war. That mean orc ambassador said that the Horde is still gathering though, which means we have some time before we need to ship all of this stuff over to Silithus.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11200,'','Greetings, $r. The war materiel is on its way and should be at Cenarion Hold within a day\'s time. We can only hope that once it is there that someone, having assembled the Scepter of the Shifting Sands, will step forward to ring the gong and open the gates.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11201,'','Greetings, $r. The war materiel is gradually being sent on its way and should be at Cenarion Hold within $2113w day\'s time. We can only hope that once it is there that someone, having assembled the Scepter of the Shifting Sands, will step forward to ring the gong and open the gates.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11202,'','All of us, working collectively, have accomplished a great task. Now an even greater one confronts us. We only await the completion of the Horde\'s gathering efforts and then we shall all confront the Silithid and their masters together.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11203,'Unexpected that you are all capable of such organization. Both the Alliance and the Horde have completed their preparations for the Ahn\'Qiraj War. Even as we speak the materiel is being shipped over to Silithus and should all arrive within a day. Then it is up to the one who is going to reassemble the Scepter of the Shifting Sands to beat on the gong at the Scarab Dais and open the gates of Ahn\'Qiraj. That is when the war will truly begin!','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(11204,'Unexpected that you are all capable of such organization. Both the Alliance and the Horde have completed their preparations for the Ahn\'Qiraj War. Even as we speak the materiel is being shipped over to Silithus and should all arrive within $2113w days. Then it is up to the one who is going to reassemble the Scepter of the Shifting Sands to beat on the gong at the Scarab Dais and open the gates of Ahn\'Qiraj. That is when the war will truly begin!','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(11205,'As expected, the Horde has completed all of their preparations well in advance of you and your so-called Alliance. You are all holding us up as we cannot take final measures to begin the war until you finish your promised responsibilities.$B$BNow go and pull your weight, $r.','',1,25,0,0,0,0,0,0,1,0,0,0,26124),
(11206,'%s acknowledges your obeisance and then waves dismissively at you.','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(11207,'Attack!  For the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11208,'I\'ve heard that the last of the preparations are being shipped over to Silithus and should arrive in under a day. I don\'t want to see one of those bugs burrowing through into my mine, so I hope that someone is taking the time to assemble that Scepter of the Shifting Sands so the gong can be rung, the gates opened and the war finally begun.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11209,'I\'ve heard that the preparations are being shipped over to Silithus and should all arrive in under $2113w days. I don\'t want to see one of those bugs burrowing through into my mine, so I hope that someone is taking the time to assemble that Scepter of the Shifting Sands so the gong can be rung, the gates opened and the war finally begun.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11210,'Our work is done. Now we wait on the Alliance to finish theirs before shipping everything over to Silithus.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11211,'If someone has put together the magic scepter of the sands then the war with the bugs will be soon. I relish it, $c! The last of our war goods are on their way to Silithus and should be there within a day. Go and bring honor to the Horde!','',1,15,0,0,0,0,0,0,1,0,0,0,26124),
(11212,'If someone has put together the magic scepter of the sands then the war with the bugs will be soon. I relish it, $c! The last of our war goods are on their way to Silithus and should be there within $2113w days. Go and bring honor to the Horde!','',1,15,0,0,0,0,0,0,1,0,0,0,26124),
(11213,'Ours is the path of glory, $r! The puny Alliance is still trying to scrape together their war supplies, while we have gathered all of ours and stand ready to send them to Silithus.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11214,'I wonder, heroes, what will you do when I manage to destroy this shard? Will the world be beyond salvation?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11215,'What\'s this? A chip in the shard? Finally, a weakness exposed... It won\'t be long now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11216,'Would it not be glorious if you somehow managed to defeat me but not before I could destroy the only hope Kalimdor may have? I am giddy with anticipation. Soon... Soon it will be dust.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11217,'Not even my father could have planned such tragedy... such chaos. You will never make it! Time is running out!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11218,'Ah, the protective layer is nearly gone. Do you hear that, heroes? That... That is the sound of inevitability. Of your hopes and dreams being crushed under the weight of my being.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11219,'The scepter shard is no more! Your beloved Kalimdor shall soon be a desolate wasteland. I will, of course, turn the Eastern Kingdoms into an ashen, lifeless void...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11220,'','And now the war, it be comin\' soon. All that be left is the sendin\' of all these goods and weapons to the Cenarion Hold in Silithus, and that is gonna be done within a day. Then some brave soul is gonna have to be ringin\' the gong near those Ahn\'Qiraj gates to open \'em and start the war.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11221,'','And now the war, it be comin\' soon. All that be left is the sendin\' of all these goods and weapons to the Cenarion Hold in Silithus, and that is gonna be done within $2113w days. Then some brave soul is gonna have to be ringin\' the gong near those Ahn\'Qiraj gates to open \'em and start the war.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11222,'','Not only am I havin\' all the mithril bars I be needin\', but all the Horde collections are done now mon. It\'s lookin\' like we just waitin\' on the Alliance and then we be goin\' to war!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11223,'','It is true, young $r, we and the Alliance have gathered and prepared all that we will need for this upcoming conflict at Ahn\'Qiraj. Even now these things are being sent to Cenarion Hold, and the last of them should arrive within a day. After all is in place, some person will need to ring the gong on the Scarab Dais to open the gates and start the war.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11224,'','It is true, young $r, we and the Alliance have gathered and prepared all that we will need for this upcoming conflict at Ahn\'Qiraj. Even now these things are being sent to Cenarion Hold, and they should all arrive within $2113w days. After all is in place, some person will need to ring the gong on the Scarab Dais to open the gates and start the war.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11225,'','The Horde\'s gathering efforts are completed, $c. Now we bide our time with extra preparations while the Alliance finishes their war collections.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11226,'Whoa now, $c, Pele\'keiki thinkin\' that you not knowin\' all that stuff be on its way to Silithus. Pele\'keiki told the last of it be getting\' there in less than a day, and after that some misguided fool gonna ring the gong outside the Ahn\'Qiraj gates to open \'em up and be startin\' the war.','',1,11,0,0,0,0,0,0,1,0,0,0,26124),
(11227,'Whoa now, $c, Pele\'keiki thinkin\' that you not knowin\' all that stuff be on its way to Silithus. Pele\'keiki told the last of it be getting\' there in less than $2113w days, and after that some misguided fool gonna ring the gong outside the Ahn\'Qiraj gates to open \'em up and be startin\' the war.','',1,11,0,0,0,0,0,0,1,0,0,0,26124),
(11228,'Haha, you be pullin\' me leg mon. Pele\'keiki know that you know we Horde already be havin\' all the war stuff we be needin\'. Now we just waitin\' on that Alliance to get all theirs and we startin\' up the war.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11229,'If it is my fate to fall, then my dying breath shall take you with me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11230,'%s\'s laughter echoes through the halls of Blackwing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11231,'%s\'s laughter can once more be heard through the halls of Blackwing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11232,'','The end draws nigh! Even as we speak the last of our supplies are being shipped to Silithus and should arrive within a day. Once there I am sure that all we be assembled in quick order, and then we\'ll be awaiting the ringing of the gong at the gates to Ahn\'Qiraj to start the war. I look forward to analyzing whether our preparatory efforts will make a difference.',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(11233,'','The end draws nigh! Even as we speak our supplies are being shipped to Silithus and should arrive within $2113w days. Once there I am sure that all we be assembled in quick order, and then we\'ll be awaiting the ringing of the gong at the gates to Ahn\'Qiraj to start the war. I look forward to analyzing whether our preparatory efforts will make a difference.',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(11234,'','You are dutiful to inquire, $c, but all Horde collections have been completed. We now wait for the Alliance hegemony to finish theirs, and then all will be transported to Silithus in the vicinity of Cenarion Hold.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11235,'','All of the collecting is done and the finished goods are being shipped over to Silithus as they\'re being completed. Looks like less than a day until all of it is over there. After that we just need to get someone to ring that gong and open the gates to Ahn\'Qiraj. Then the real fun begins.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11236,'','All of the collecting is done and the finished goods are being shipped over to Silithus as they\'re being completed. Looks like less than $2113w days until all of it is over there. After that we just need to get someone to ring that gong and open the gates to Ahn\'Qiraj. Then the real fun begins.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11237,'','Heya, $c, don\'t you know? The Horde is done with all of its collecting. We\'re just finishing up final preparations while we wait for the Alliance to finish their gathering. Then it will be time to ship everything over to Silithus for the war.',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(11238,'','Throm\'ka, $c. All of the war materiel is in final preparation and being sent to Silithus. The last of it should arrive in less than a day. With the equipment readied, and our forces arrayed, all we will be waiting for is someone to ring the gong on the Scarab Dais, which should open the gates of Ahn\'Qiraj and start the war.$B$BLok\'tar Ogar!',1,15,0,0,0,0,0,0,1,0,0,0,26124),
(11239,'','Throm\'ka, $c. All of the war materiel is in final preparation and being sent to Silithus. It should arrive over the course of the next $2113w days. With the equipment readied, and our forces arrayed, all we will be waiting for is someone to ring the gong on the Scarab Dais, which should open the gates of Ahn\'Qiraj and start the war.$B$BLok\'tar Ogar!',1,15,0,0,0,0,0,0,1,0,0,0,26124),
(11240,'','The Horde stands ready now that we have finished with all of our resource gathering. We only wait for the sluggish Alliance to finish with theirs, and then on to glorious battle!',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(11241,'All of our collections are completed, $c. That which we have assembled is in the process of being transported to Cenarion Hold in Silithus, and the last of it should take no more than a day to arrive. The Ahn\'Qiraj War can then start once that is done and someone brave and foolish rings the gong right outside of the gates down there.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11242,'All of our collections are completed, $c. That which we have assembled is in the process of being transported to Cenarion Hold in Silithus, and the rest of it should take no more than $2113w days to arrive. The Ahn\'Qiraj War can then start once that is done and someone brave and foolish rings the gong right outside of the gates down there.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11243,'Well now, it would appear that we have some time on our hands. The Horde has completed its gathering tasks, and all is being prepared for final shipment to Silithus. We\'re only waiting on the Alliance to finish with theirs. You should go ask that silly, little ambassador of theirs how far along they are.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11244,'All has been gathered and is being sent to Silithus, $c. The last of it should get there within a day. I can only hope that after the gong is rung, and the gates opened, that our efforts here will make an impact and save many lives.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11245,'All has been gathered and is being sent to Silithus, $c. It should get there within $2113w days. I can only hope that after the gong is rung, and the gates opened, that our efforts here will make an impact and save many lives.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11246,'We of the Horde have done all that we can to prepare for the upcoming war at Ahn\'Qiraj. Now we wait, $c, for the Alliance to do the same. Once they are done we will all transport our war materiel to Cenarion Hold in Silithus.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11247,'','Yes, you heard true, $c, all of our collections are complete and the last of the war materiel should arrive in Silithus within a day. I am told that once all is assembled there, and our troops readied, someone from within the ranks of you heroes is going to ring the gong outside of Ahn\'Qiraj, already having assembled the Scepter of the Shifting Sands to do so with. I hope that we don\'t have to wait too long for that to happen.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(11248,'','Yes, you heard true, $c, all of our collections are complete and the last of the war materiel should arrive in Silithus within $2113w days. I am told that once all is assembled there, and our troops readied, someone from within the ranks of you heroes is going to ring the gong outside of Ahn\'Qiraj, already having assembled the Scepter of the Shifting Sands to do so with. I hope that we don\'t have to wait too long for that to happen.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(11249,'','What is it now, $c, I haven\'t got all day? The Horde has completed its collections and now waits only on the Alliance to organize themselves and do the same. Perhaps you should be out there looking for the pieces to the Scepter of the Shifting Sands so that you can ring the gong at the Scarab Dais, opening the gates to Ahn\'Qiraj and thereby starting the war?',6,1,11,0,0,0,0,0,1,0,0,0,26124),
(11250,'','All of the preparations are complete now, $c. We await the last of the materiel to be sent to Silithus, which should be in less than a day\'s time. Then once the organization there is done with, someone will have to come forward and ring the gong on the Scarab Dais with the Scepter of the Shifting Sands. That is when the Ahn\'Qiraj War will begin. May the Earth Mother watch over all of us then.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(11251,'','All of the preparations are complete now, $c. We await the last of the materiel to be sent to Silithus, which should be in less than $2113w day\'s time. Then once the organization there is done with, someone will have to come forward and ring the gong on the Scarab Dais with the Scepter of the Shifting Sands. That is when the Ahn\'Qiraj War will begin. May the Earth Mother watch over all of us then.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(11252,'','While I live to serve the Earth Mother and the Horde, I cannot help but feel a little nervous now that we\'ve collected everything that we need. At least we have a little time until the Alliance finishes their gathering efforts. After that it will all be shipped to Cenarion Hold in Silithus, and the war will likely follow not long after.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11253,'','Yes, yes, all of the Horde\'s and Alliance\'s war materiel is being shipped over to Silithus and should be there within a day. Do you know what happens then, $c? We hurry up and wait. Hopefully someone is gathering the pieces of the Scepter of the Shifting Sands, because in order to open the gates of Ahn\'Qiraj it needs to be rung against the gong on the Scarab Dais.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11254,'','Yes, yes, all of the Horde\'s and Alliance\'s war materiel is being shipped over to Silithus and should be there within $2113w days. Do you know what happens then, $c? We hurry up and wait. Hopefully someone is gathering the pieces of the Scepter of the Shifting Sands, because in order to open the gates of Ahn\'Qiraj it needs to be rung against the gong on the Scarab Dais.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11255,'','What is it, $c? The Horde is done with all collections, and final preparations are being made while the Alliance tries to catch up in their efforts. Is there anything else that you need?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11256,'Looks like there be only one more day left to fish until all this here war materiel is shipped over to the Silithus desert mon. Then they\'s gonna be getting\' it all ready, and someone is gonna have to ring that gong down south of Cenarion Hold there to open them gates and be startin\' the war.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11257,'Looks like there be only $2113w more days left to fish until all this here war materiel is shipped over to the Silithus desert mon. Then they\'s gonna be getting\' it all ready, and someone is gonna have to ring that gong down south of Cenarion Hold there to open them gates and be startin\' the war.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11258,'Time to relax, the Alliance be way behind us mon. We all done with our collectin\' here, and the final polishes be goin\' on things as we speak. When they get done over in their Ironforge, then we be thinkin\' \'bout movin\' all this stuff to Silithus. \'Til then, sit tight and maybe do some fishin\'.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11259,'If you heard that all of the Horde and Alliance collections have been completed, then you heard right, $c. All of the goods for the war that we gathered and prepared are in the process of being sent to Cenarion Hold in Silithus, with less than a day until the last of it arrives there. After that I suppose we\'ll just have to wait and see who assembles that scepter to ring the gong with, which will open the gates to Ahn\'Qiraj and herald the war.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(11260,'If you heard that all of the Horde and Alliance collections have been completed, then you heard right, $c. All of the goods for the war that we gathered and prepared are in the process of being sent to Cenarion Hold in Silithus, with less than $2113w days until the last of it arrives there. After that I suppose we\'ll just have to wait and see who assembles that scepter to ring the gong with, which will open the gates to Ahn\'Qiraj and herald the war.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(11261,'All of the Horde\'s war effort tasks are completed, young $c. Now we need but wait for the Alliance to also finish theirs and all will be ready for the Ahn\'Qiraj War. Except perhaps for the gathering and reunification of the pieces to the Scepter of the Shifting Sands?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(11262,'That\'s right, um, $g lad : lass;, all of the war materiel is being transported to Silithus and the last of it should get there within a day. After that, we\'ll all just have to wait and see who puts forth a $g hero : heroine; to reconstitute the Scepter of the Shifting Sands and ring the gong on the Scarab Dais. Only when that occurs will the war begin to open the gates of Ahn\'Qiraj.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11263,'That\'s right, um, $g lad : lass;, all of the war materiel is being transported to Silithus and the last of it should get there within $2113w days. After that, we\'ll all just have to wait and see who puts forth a $g hero : heroine; to reconstitute the Scepter of the Shifting Sands and ring the gong on the Scarab Dais. Only when that occurs will the war begin to open the gates of Ahn\'Qiraj.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11264,'While it is true that the Alliance has completed all of their war effort tasks, don\'t let that discourage you, $r. Time is of the essence, but we would much rather that you help in the Horde\'s collections carefully and thoroughly. That seems better to me than making a mistake that could cost someone their life once this war truly begins. Wouldn\'t you agree, $c?','',1,1,6,0,0,0,0,0,1,0,0,0,26124),
(11265,'Recover the scepter shard, $n. Nefarius must not be allowed to destr... destroy the shard.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11266,'I will pull the shard from his sundered corpse.','I will pull the shard from his sundered corpse.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11267,'Looking for this: [Red Scepter Shard]? Come and get it...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11268,'Your meddling in demonic affairs ends NOW, mortal!  Face the great corruptor - Xandivious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11269,'The Nightmare cannot be stopped!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11270,'%s squeezes the last bit of life out of $n and swallows their soul.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11271,'Come, $n. See what the Nightmare brings...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11272,'A chill is in the air.','A chill is in the air.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11273,'We serve Thrall with great pride.  We\'ll travel as far as is needed to vanquish the enemy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11274,'Reporting for duty, sir.','Reporting for duty, sir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11275,'You\'re just in time, $c.  Do you feel the ground shaking beneath you?$B$BSomething approaches from the hive.  Take a place near the grunts, $n.  I\'m counting on you!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(11276,'The silithid are no match for the sons and daughters of Orgrimmar.  Soon all that will be left of them are their crushed limbs and wings under our feet, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11277,'Eranikus, Tyrant of the Dream, has entered our world.','Eranikus, Tyrant of the Dream, has entered our world.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11278,'','Very well, $n. I will use the Nightmare object to conjure forth Eranikus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11279,'','Follow me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11280,'','Steel yourselves! Summoning a being this powerful is seldom done with positive results.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11281,'','Eranikus is here! Seek shelter! Safety!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11282,'We will locate the origin of the Nightmare through the fragments you collected, $n. From there we will pull Eranikus through a rift in the Dream. Steel yourself, $c. We are inviting the embodiment of the Nightmare into our world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11283,'To Nighthaven! Keep your army close, champion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11284,'I will call forth Eranikus when I am given the word.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11285,'I am ready, Remulos.','I am ready, Remulos.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11286,'The enemy is upon us, stand ready!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11287,'Merok!  Shai!  To my side!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11288,'For the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11289,'%s drinks in the suffering of the fallen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11290,'The rift will be opened there, above Lake Elun\'ara. Prepare yourself, $n. Eranikus\'s entry into our world will be wrought with chaos and strife.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11291,'He will stop at nothing to get to Malfurion\'s physical manifestation. That must not happen... We must keep the beast occupied long enough for Tyrande to arrive.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11292,'Defend Nighthaven, hero...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11293,'Fiend! Face the might of Cenarius!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11294,'You are certainly not your father, insect. Should it interest me, I would crush you with but a swipe of my claws. Turn Shan\'do Stormrage over to me and your pitiful life will be spared along with the lives of your people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11295,'Who is the predictable one, beast? Surely you did not think that we would summon you on top of Malfurion? Your redemption comes, Eranikus. You will be cleansed of this madness - this corruption.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11296,'%s lets loose a sinister laugh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11297,'My redemption? You are bold, little one. My redemption comes by the will of my god.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11298,'%s roars furiously.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11299,'Rise, servants of the Nightmare! Rise and destroy this world! Let there be no survivors...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11300,'Hurry, $n! We must find protective cover!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11301,'Please, champion, protect our people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11302,'We will battle these fiends, together! Nighthaven\'s Defenders are also among us. They will fight to the death if asked. Now, quickly, we must drive these aberrations back to the Nightmare. Destroy them all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11303,'It will be done, Eranikus. Be well, ancient one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11304,'Where is your savior? How long can you hold out against my attacks? ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11305,'Defeated my minions? Then face me, mortals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11306,'Remulos, look how easy they fall before me? You can stop this, fool. Turn the druid over to me and it will all be over...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11307,'Let it be known that $n - Horde $C - has earned the undying respect of the Warchief.   $GHe : She; has engaged in great diplomacy with Timbermaw Hold and performed valiant actions for them on our behalf.   $GHe : She; has gone above and beyond the call of duty.  Three cheers for $n - a true hero of the Horde!','',5,5,0,0,0,0,0,0,1,0,0,0,26124),
(11308,'Let it be known that $n - Alliance $C - has earned the undying respect of Ironforge and the Alliance as a whole.  $GHe : She; has engaged in great diplomacy with Timbermaw Hold and performed valiant actions for them on our behalf.   $GHe : She; has gone above and beyond the call of duty.  Three cheers for $n - a true hero of the Alliance!','',5,5,0,0,0,0,0,0,1,0,0,0,26124),
(11309,'','Elune, hear my prayers. Grant us serenity! Watch over our fallen...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11310,'','Seek absolution, Eranikus. All will be forgiven...\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11311,'','You will be forgiven, Eranikus. Elune will always love you. Break free of the bonds that command you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11312,'','The grasp of the Old Gods is unmoving. He is consumed by their dark thoughts... I... I cannot... cannot channel much longer... Elune aid me...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11313,'Eranikus, Tyrant of the Dream, is wholly consumed by the Light of Elune. Tranquility sets in over the Moonglade.','Eranikus, Tyrant of the Dream, is wholly consumed by the Light of Elune. Tranquility sets in over the Moonglade.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11314,'IT BURNS! THE PAIN... SEARING...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11315,'WHY? Why did this happen to ... to me? Where were you Tyrande? Where were you when I fell from the grace of Elune?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11316,'I... I feel... I feel the touch of Elune upon my being once more... She smiles upon me... Yes... I...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11317,'','Tend to the injuries of the wounded, sisters!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11318,'It takes a bit of practice to be this close to the silithid and go unnoticed.  I don\'t recommend trying it if you can avoid it.  ','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11319,'','%s falls to one knee.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11320,'','Praise be to Elune... Eranikus is redeemed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11321,'Don\'t get me wrong, I\'d rather not be in a tunnel filled with silithid day in and day out, but if hiding here and watching these creatures\' movements is going to help us win the war then I\'ll do it for as long as it takes.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11322,'Soon we shall rid Azeroth of the silithids\' abominable presence.  Their potential for destruction is much greater than what you\'ve seen firsthand, $n.  Greater, darker powers are behind their activities.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11323,'For so long, I was lost... The Nightmare\'s corruption had consumed me... And now, you... all of you... you have saved me. Released me from its grasp.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11324,'But... Malfurion, Cenarius, Ysera... they still fight. They need me. I must return to the Dream at once.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11325,'I\'m here to retrieve your report.','I\'m here to retrieve your report.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11326,'My lady, I am unworthy of your prayer. Truly, you are an angel of light. Please, assist me in returning to the barrow den so that I may return to the Dream. I, like Malfurion, also have a love awaiting me... I must return to her... to protect her...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11327,'And heroes... I hold that which you seek. May it once more see the evil dissolved. Remulos, see to it that our champion receives the shard of the Green Flight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11328,'','%s nods.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11329,'Let us leave Nighthaven, hero. Seek me out at the grove.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11330,'The Scepter of the Shifting Sands is whole once more, $n.$B$BIt must be you who uses the scepter. It must be you who heralds in the next age of your people.$B$BWhen you are prepared to ring the Scarab Gong and once more open the gates of Ahn\'Qiraj, I will grant you the Scepter. You have only to ask.\n','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11331,'I am ready, Anachronos. Please grant me the Scepter of the Shifting Sands.','I am ready, Anachronos. Please grant me the Scepter of the Shifting Sands.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11332,'The Scepter of the Shifting Sands is whole once more, $n.$B$BIt must be you who uses the scepter. It must be you who heralds in the next age of your people. $B$BYou must wait for the armies of the Horde and the Alliance to arrive in Silithus before you may ring the Scarab Gong. The time for war is close at hand.\n','',1,1,15,0,0,0,0,0,1,0,0,0,26124),
(11333,'The Scepter of the Shifting Sands is whole once more, $n.$B$BIt is you who must lead your armies into the cursed fortress city of Ahn\'Qiraj and mete justice to its inhabitants.$B$BVenture to Silithus and present the Scepter of the Shifting Sands to Jonathan the Revelator.\n','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11334,'I\'m ready!','I\'m ready!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11335,'','This line is mostly filler...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11336,'What is an Alliance Commendation Signet?','What is an Alliance Commendation Signet?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11337,'','An Alliance Commendation Signet is awarded to a $g hero : heroine; who goes above and beyond the call of duty to the Alliance.  Various Commendation Officers for the factions of the Alliance are located in all of the major cities; speak with the one with whom you\'d like to raise your reputation, and give them the number of signets they ask for!$B$BBy the way, during the war effort here, if you\'d rather receive a material reward for your signets in lieu of reputation, seek out Field Marshal Snowfall.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11338,'We are united in cause, $r. An ancient evil threatens to extinguish all life on Kalimdor and consume the world with its depravity... Its hatred of all things born of the great Shapers: The eternal Titans.$B$BWe are the first and the last lines of defense against the armies of C\'Thun. If we do not rise up and strike at our enemy, our enemy will surely destroy us.$B$BThe war effort needs you!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11339,'An Alliance Commendation Signet is awarded to a $g hero : heroine; who goes above and beyond the call of duty to the Alliance.  Various Commendation Officers for the factions of the Alliance are located in all of the major cities; speak with the one with whom you\'d like to raise your reputation, and give them the number of signets they ask for!$B$BBy the way, during the war effort here, if you\'d rather receive a material reward for your signets in lieu of reputation, seek out Field Marshal Snowfall.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11340,'What is a Horde Commendation Signet?','What is a Horde Commendation Signet?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11341,'A Horde Commendation Signet is awarded to a $g hero : heroine; who goes above and beyond the call of duty to the Horde.  Various Commendation Officers for the factions of the Horde are located in all of the major cities; speak with the one with whom you\'d like to raise your reputation, and give them the number of signets they ask for!$B$BBy the way, during the war effort here, if you\'d rather receive a material reward for your signets instead of reputation, seek out Warlord Gorchuk.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11342,'','A Horde Commendation Signet is awarded to a $g hero : heroine; who goes above and beyond the call of duty to the Horde.  Various Commendation Officers for the factions of the Horde are located in all of the major cities; speak with the one with whom you\'d like to raise your reputation, and give them the number of signets they ask for!$B$BBy the way, during the war effort here, if you\'d rather receive a material reward for your signets instead of reputation, seek out Warlord Gorchuk.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11343,'%s begins to slow!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11345,'%s is freezing up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11346,'%s begins to crack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11347,'%s looks ready to shatter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11348,'Anachronos, I have lost the signet ring. Could you supply me with a replacement?','Anachronos, I have lost the signet ring. Could you supply me with a replacement?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11349,'Around this reindeer\'s neck is a tag with the Smokywood Pastures logo on it and a name - \"Metzen\".$B$BMetzen looks at you with sad, forlorn eyes.  It is almost as if the reindeer has been immobilized by some unseen force.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11350,'You\'re free, Metzen. The bad greench can\'t hurt you anymore.','You\'re free, Metzen. The bad greench can\'t hurt you anymore.',377,0,0,0,0,0,0,0,1,0,0,0,26124),
(11351,'Metzen\'s eyes light up with reindeer joy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11352,'Even if you somehow managed to free us without defeating C\'Thun, we would focus all of our powers to see the beast banished back to the hell from whence it came - AT ANY COST.','',1,1,25,0,0,0,0,0,1,0,0,0,26124),
(11353,'','Heroes of the Brood? C\'Thun must be banished! We can assist you, mortal!',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(11354,'I bear witness to a miracle that stands before me! In one thousand years of captivity, I have not seen a single LIVING specimen - other than those foul Qiraji and silithid - enter these chambers.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11355,'Soldiers of Kalimdor! Heroes of Silithus! One among you has dealt a vicious blow to our mortal enemies! $n and $g his:her; allies have relieved the Ruins of Ahn\'Qiraj of its merciless leader! Ossirian the Unscarred, scourge of Silithus, has finally been destroyed and his armies wholly dismantled!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11356,'','Look alive, lads!  The enemy has been sighted!  Form ranks immediately!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11357,'Be sure to stick around for the next firework show!  Starting at 6PM, they\'re every hour on the hour!','Be sure to stick around for the next firework show!  Starting at 6PM, they\'re every hour on the hour!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11358,'I don\'t know what they put in those kegs, but it goes down like honey!','I don\'t know what they put in those kegs, but it goes down like honey!',1,153,0,0,0,0,0,0,1,0,0,0,26124),
(11359,'After the firework show, they\'ll put out goblets so we can raise a toast!','After the firework show, they\'ll put out goblets so we can raise a toast!',71,0,0,0,0,0,0,0,1,0,0,0,26124),
(11360,'Well met, friend!','Well met, friend!',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(11361,'Greetings, $c. I am Field Marshal Snowfall, commander of the war effort here. We\'ve a hard road to plow ahead of us, $g lad : lass;, so if you can help out, please do so. And feel free to ask questions.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11362,'We\'ve done it, $g lad : lass;! The Alliance and the Horde have completed gathering everything that we think we\'ll need for the Ahn\'Qiraj War. Right now the final goods are being taken over to Cenarion Hold in Silithus and the last of it will arrive within a day. After that, some brave $g hero : heroine; is going to need to ring the Scarab Gong with the Scepter of the Shifting Sands to open the gates to Ahn\'Qiraj. When those gates open, the war begins!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(11363,'We\'ve done it, $g lad : lass;! The Alliance and the Horde have completed gathering everything that we think we\'ll need for the Ahn\'Qiraj War. Right now the final goods are being taken over to Cenarion Hold in Silithus and all of it will arrive within $2113w days. After that, some brave $g hero : heroine; is going to need to ring the Scarab Gong with the Scepter of the Shifting Sands to open the gates to Ahn\'Qiraj. When those gates open, the war begins!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(11364,'Have you heard the good news, $c? The Alliance has completed all of its war effort collections! Now we simply await the Horde to finish theirs. When they do, we\'ll begin shipping all of the war materiel over to Silithus, and it shouldn\'t be long after that until the Ahn\'Qiraj War begins.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11365,'Good question, $c. Last I was informed; we have managed to collect $1997w copper bars out of $1998w needed. Additionally, I am told that we have $2002w iron bars out of $2003w, and $2011w out of $2012w thorium bars requested.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11366,'Herbs, herbs, hmmm, let me see here. Ah yes, here it is. To date we have accumulated $2047w out of $2048w stranglekelp, $2053w out of $2055w purple lotuses, and $2057w out of $2058w arthas\' tears needed.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11367,'I received an update on that just a moment ago. It looks like out of $2061w light leather needed, we have $2060w. As for the others, the report indicated that we\'ve gathered $2063w of $2064w medium leather, and $2069w out of our $2071w thick leather quota.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11368,'Collection of bandages is proceeding according to schedule. As far as linen bandages are concerned, we\'ve gathered $2076w of $2077w. Silk bandages have been tallied at $2082w out of $2083w, and we have $2088w out of $2090w runecloth bandages needed.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11369,'On the cooked goods front it would appear that we\'ve managed to collect and store away $2092w rainbow fin albacore, out of $2093w requested. Additionally, right now we have in $2098w of $2099w roast raptor and $2101w out of $2103w spotted yellowtail in cold storage.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11370,'Throm\'ka, Horde $C, stand proud! I am Warlord Gorchuk, commander of the Horde\'s war effort. There are trying times ahead of us, but we shall prevail, as always.$B$BIf you have questions, you should ask them.','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(11371,'The time for war is almost upon us, $c! Both the Horde and the Alliance have finished with their preparations. All of our war materiel is being shipped to Silithus as we speak. I\'d expect the last of it to arrive within a day. When all is assembled there, the one who has completed the arduous task of reassembling the Scepter of the Shifting Sands will bang it against the Scarab Gong and open the gates to Ahn\'Qiraj. Then battle shall be joined as has not been seen in ages!$B$BLok\'tar Ogar!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11372,'The time for war is almost upon us, $c! Both the Horde and the Alliance have finished with their preparations. All of our war materiel is being shipped to Silithus as we speak. I\'d expect it all to arrive within $2113w days. When all is assembled there, the one who has completed the arduous task of reassembling the Scepter of the Shifting Sands will bang it against the Scarab Gong and open the gates to Ahn\'Qiraj. Then battle shall be joined as has not been seen in ages!$B$BLok\'tar Ogar!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11373,'$C, the Horde has gathered all that it needs for the Ahn\'Qiraj War! Now we wait for the puny Alliance to catch up. When they do, we\'ll begin transporting everything to Silithus. It should not be long after the buildup there is completed that the war will begin!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11374,'Of the $1998w copper bars that we\'ll need, we have $2018w. The number for tin bar collections sits at $2005w out of $2006w needed. And, there have been $2008w of $2009w mithril bars smelted for the cause.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11375,'I just received word on that. We currently have $2021w out of $2020w peacebloom, $2050w of $2051w firebloom, and $2054w out of $2055w purple lotus herbs requested.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11376,'Give me a moment; there are a lot of numbers to remember here. It looks like we have $2066w of $2067w heavy leather skins collected. As well, we have $2070w out of $2071w thick leather, and $2073w of $2074w rugged leather stockpiled.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11377,'Bandages? Why, do you intend to survive long enough to need them? Har! Very well, $r, I will tell you. Of the $2080w wool bandaged needed, we have collected $2079w. Also to date, we have taken in $2085w out of $2086w mageweave bandages, and $2089w of $2090w runecloth bandages asked for.','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(11378,'Food, now there\'s a subject that I can sink my fangs into! I am told that we have $2095w of $2096w lean wolf steaks, $2102w out of $2103w spotted yellowtail, and $2105w of $2106w baked salmon on ice and stored away.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11379,'Well met, $c. I hope you are here to inquire on the Ahn\'Qiraj war effort. We are going to need a great deal of assistance.$B$BThe war effort is a united effort between the Alliance and Horde to prepare for the upcoming war against the Silithid and their masters in Ahn\'Qiraj. In the Military Ward of Ironforge, we are collecting all manner of goods to create our war materiel from, and these gathering tasks are what we need your help with.$B$BCan I convince you to speak with our commander about pitching in?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11380,'','Well met, $c. I hope you are here to inquire on the Ahn\'Qiraj war effort. We are going to need a great deal of assistance.$B$BThe war effort is a united effort between the Alliance and Horde to prepare for the upcoming war against the Silithid and their masters in Ahn\'Qiraj. In the Military Ward of Ironforge, we are collecting all manner of goods to create our war materiel from, and these gathering tasks are what we need your help with.$B$BCan I convince you to speak with our commander about pitching in?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11381,'','Well met, $c. I hope you are here to inquire on the Ahn\'Qiraj war effort. We are going to need a great deal of assistance.$B$BThe war effort is a united effort between the Alliance and Horde to prepare for the upcoming war against the Silithid and their masters in Ahn\'Qiraj. In the Military Ward of Ironforge, we are collecting all manner of goods to create our war materiel from, and these gathering tasks are what we need your help with.$B$BCan I convince you to speak with our commander about pitching in?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11382,'Hail, $c. I trust you are here to inquire on the Ahn\'Qiraj war effort. We are going to need a great deal of assistance.$B$BThe war effort is a united effort between the Horde and Alliance to prepare for the impending war against the Silithid and their masters in Ahn\'Qiraj. In Orgrimmar\'s Valley of Spirits, we are collecting a vast number of goods to create war materiel, and these gathering tasks are what we need your help with.$B$BCan I convince you to speak with our commander about helping out?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11383,'','Hail, $c. I trust you are here to inquire on the Ahn\'Qiraj war effort. We are going to need a great deal of assistance.$B$BThe war effort is a united effort between the Horde and Alliance to prepare for the impending war against the Silithid and their masters in Ahn\'Qiraj. In Orgrimmar\'s Valley of Spirits, we are collecting a vast number of goods to create war materiel, and these gathering tasks are what we need your help with.$B$BCan I convince you to speak with our commander about helping out?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11384,'','Hail, $c. I trust you are here to inquire on the Ahn\'Qiraj war effort. We are going to need a great deal of assistance.$B$BThe war effort is a united effort between the Horde and Alliance to prepare for the impending war against the Silithid and their masters in Ahn\'Qiraj. In Orgrimmar\'s Valley of Spirits, we are collecting a vast number of goods to create war materiel, and these gathering tasks are what we need your help with.$B$BCan I convince you to speak with our commander about helping out?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11385,'Greetings, $c. I am Leoren, stable master of Cenarion Hold.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11386,'There is a pile of wrapped gifts here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11387,'The tag on this present reads: \"For ages 40 and up.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11388,'Get your present from the pile.','Get your present from the pile.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11389,'Greetings, citizen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11390,'The world is indebted to you and your allies, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11391,'Our freedom would have meant nothing if C\'Thun had survived. You are truly a champion of prophecy.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11392,'','All will know of what has transpired here in this accursed temple, hero. It will be written about in history books - the tales told as legend from Azeroth to the far reaches of the Nether itself!',1,71,0,0,0,0,0,0,1,0,0,0,26124),
(11393,'Now that the war is in full swing, we\'ve had no shortage of able-bodied combatants from the Horde and Alliance.$B$BIf only we could keep them off of each other\'s throats...','',6,0,0,1,0,0,0,0,1,0,0,0,26124),
(11394,'','Wait!  It appears our lookout has spotted something.',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(11395,'The tag on this present reads: \"For ages 20 and up.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11396,'The tag on this present reads: \"For ages 10 and up.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11397,'Ye\'ll be feasting on me blade this Winter Veil!  Yeargh!','Ye\'ll be feasting on me blade this Winter Veil!  Yeargh!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11398,'No scallywag $c is taking our Winter Veil plunder!  Get \'em!','No scallywag $c is taking our Winter Veil plunder!  Get \'em!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11399,'These land lubbers are here for the reindeer!  Give \'em the shank!','These land lubbers are here for the reindeer!  Give \'em the shank!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11400,'It\'s a rescue attempt!  Let no one escape!','It\'s a rescue attempt!  Let no one escape!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11401,'Let me give you my regards for Greatfather Winter, scum...','Let me give you my regards for Greatfather Winter, scum...\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11402,'Humbug!  Die!','Humbug!  Die!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11403,'It\'s a rescue attempt!  Slay them all!','It\'s a rescue attempt!  Slay them all!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11404,'The only thing Metzen is going to be doing this Winter Veil is roasting on a spit!','The only thing Metzen is going to be doing this Winter Veil is roasting on a spit!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11405,'','The journal of Jandice Barov is filled with rantings and ravings about the undead. Towards the end of the book is what appears to be a tailoring pattern for the creation of a bag of some sort. Your understanding of tailoring is insufficient to decipher the pattern.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11406,'','The journal of Jandice Barov is filled with rantings and ravings about the undead. Towards the end of the book is what appears to be a tailoring pattern for the creation of a felcloth bag. This bag is used by warlocks to store soul shards. Do you wish to copy the pattern into your own journal?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11407,'<Copy the pattern into my journal.>','<Copy the pattern into my journal.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11408,'','%s loosens her grasp on the journal she had been clutching.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11409,'%s lets out a battlecry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11410,'','The journal of Jandice Barov is filled with rantings and ravings about the undead. Towards the end of the book is what appears to be a tailoring pattern for the creation of a felcloth bag. This bag is used by warlocks to store soul shards. You already know how to create this bag.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11411,'Only those who have proven themselves to not be hostile toward the Timbermaw may pass through the Hold without fear of being attacked.  Have you made an effort to earn our trust, outsider?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11412,'What do you seek, $c?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11413,'I\'ll wait.','I\'ll wait.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11414,'New this year: the PX-238 Winter Wondervolt.  Step on up and don\'t be shy!$B$BAnd sign these forms before you try it, we\'re still working a few bugs out of this thing...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11415,'Greetings, $c - I\'m a Commendation Officer acting on behalf of Darnassus.  It is my duty to assist adventurers who have received Alliance Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Darnassus for your duty and service.\n','Greetings, $c - I\'m a Commendation Officer acting on behalf of Darnassus.  It is my duty to assist adventurers who have received Alliance Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Darnassus for your duty and service.\n\n',66,1,0,0,0,0,0,0,1,0,0,0,26124),
(11416,'Greetings, $c - I\'m a Commendation Officer acting on behalf of the Gnomeregan Exiles.  It is my duty to assist adventurers who have received Alliance Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from the Gnomeregan Exiles for your duty and service.\n','Greetings, $c - I\'m a Commendation Officer acting on behalf of the Gnomeregan Exiles.  It is my duty to assist adventurers who have received Alliance Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from the Gnomeregan Exiles for your duty and service.\n',66,1,0,0,0,0,0,0,1,0,0,0,26124),
(11417,'Greetings, $c - I\'m a Commendation Officer acting on behalf of Ironforge.  It is my duty to assist adventurers who have received Alliance Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Ironforge for your duty and service.\n','Greetings, $c - I\'m a Commendation Officer acting on behalf of Ironforge.  It is my duty to assist adventurers who have received Alliance Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Ironforge for your duty and service.',66,1,0,0,0,0,0,0,1,0,0,0,26124),
(11418,'Greetings, $c - I\'m a Commendation Officer acting on behalf of Stormwind.  It is my duty to assist adventurers who have received Alliance Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Stormwind for your duty and service.\n','Greetings, $c - I\'m a Commendation Officer acting on behalf of Stormwind.  It is my duty to assist adventurers who have received Alliance Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Stormwind for your duty and service.\n\n',66,1,0,0,0,0,0,0,1,0,0,0,26124),
(11419,'Greetings, $c - I\'m a Commendation Officer acting on behalf of Orgrimmar.  It is my duty to assist adventurers who have received Horde Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Orgrimmar for your duty and service.\n','Greetings, $c - I\'m a Commendation Officer acting on behalf of Orgrimmar.  It is my duty to assist adventurers who have received Horde Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Orgrimmar for your duty and service.\n\n',66,1,0,0,0,0,0,0,1,0,0,0,26124),
(11420,'Greetings, $c - I\'m a Commendation Officer acting on behalf of the Darkspear tribe.  It is my duty to assist adventurers who have received Horde Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from the Darkspear tribe for your duty and service.\n','Greetings, $c - I\'m a Commendation Officer acting on behalf of the Darkspear tribe.  It is my duty to assist adventurers who have received Horde Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from the Darkspear tribe for your duty and service.\n',66,1,0,0,0,0,0,0,1,0,0,0,26124),
(11421,'Greetings, $c - I\'m a Commendation Officer acting on behalf of Thunder Bluff.  It is my duty to assist adventurers who have received Horde Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Thunder Bluff for your duty and service.\n','Greetings, $c - I\'m a Commendation Officer acting on behalf of Thunder Bluff.  It is my duty to assist adventurers who have received Horde Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Thunder Bluff for your duty and service.\n\n',66,1,0,0,0,0,0,0,1,0,0,0,26124),
(11422,'Greetings, $c - I\'m a Commendation Officer acting on behalf of the Undercity.  It is my duty to assist adventurers who have received Horde Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from the Undercity for your duty and service.\n','Greetings, $c - I\'m a Commendation Officer acting on behalf of the Undercity.  It is my duty to assist adventurers who have received Horde Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from the Undercity for your duty and service.\n',66,1,0,0,0,0,0,0,1,0,0,0,26124),
(11423,'%s lets loose a massive attack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11424,'%s hears the call to battle and rises to serve its master.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11425,'%s casts its massive shadow upon the whole of Silithus.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11426,'%s breaks free of its cocoon beneath Hive\'Ashi.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11427,'$n, Champion of the Bronze Dragonflight, has rung the Scarab Gong. The ancient gates of Ahn\'Qiraj open, revealing the horrors of a forgotten war...','$n, Champion of the Bronze Dragonflight, has rung the Scarab Gong. The ancient gates of Ahn\'Qiraj open, revealing the horrors of a forgotten war...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11428,'Slay them all. Leave their husks for the master to consume...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11429,'Soon you will know the price of your meddling, mortals... The master is nearly whole... And when he rises, your world will cease.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11430,'Presents for everyone! Father Winter\'s put gifts under the tree for all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11431,'Do you think you\'ve won? So easily? The legion has only just begun its march. The armies of C\'Thun will raze this world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11432,'Massive Qiraji resonating crystals break through the earthen crust of Kalimdor. Colossal creatures made of obsidian stone breach the freshly broken land.','Massive Qiraji resonating crystals break through the earthen crust of Kalimdor. Colossal creatures made of obsidian stone breach the freshly broken land.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11433,'Breathe your last!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11434,'Warriors, Captains, continue the fight! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11435,'Impudent fool! I will kill you myself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11436,'Fandral! Your time has come! Go and hide in the Emerald Dream and pray we never find you!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11437,'Staghelm will whimper and beg for his life, just as his whelp of a son did! One thousand years of injustice will end this day!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11438,'Fear is for the enemy! Fear and death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11439,'No longer will we wait behind barred doors and walls of stone! No longer will our vengeance be denied! The dragons themselves will tremble before our wrath!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11440,'The time of our retribution is at hand! Let darkness reign in the hearts of our enemies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11441,'%s senses your fear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11442,'You will be judged for defiling these sacred grounds!  The laws of the Ancients will not be challenged!  Trespassers will be annihilated!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11443,'I sentence you to death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11444,'I serve to the last!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11445,'Are you so eager to die? I will be happy to accommodate you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11446,'Let your death serve as an example!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11447,'You only delay the inevitable!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11448,'senses your fear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11449,'Sands of the desert, rise and block out the sun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11450,'You are terminated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11451,'I...have...failed. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11452,'My brother, no!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11453,'You will not escape death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11454,'Vek\'lor, I feel your pain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11455,'Your fate is sealed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11456,'Starting at 6PM, they will show fireworks from the highest bluff!','Starting at 6PM, they will show fireworks from the highest bluff!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11457,'The kegs are filled with strong brew!  Drink, friend, and celebrate!','The kegs are filled with strong brew!  Drink, friend, and celebrate!',1,153,0,0,0,0,0,0,1,0,0,0,26124),
(11458,'I heard that, after the fireworks show, goblets will be brought to the tables.  Fine toasts we shall raise!','I heard that, after the fireworks show, goblets will be brought to the tables.  Fine toasts we shall raise!',71,0,0,0,0,0,0,0,1,0,0,0,26124),
(11459,'Hail, $c!  Welcome to the celebration!','Hail, $c!  Welcome to the celebration!',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(11460,'They\'re going to show fireworks all night long.  From 6PM until dawn, the sky will blaze over Booty Bay!','They\'re going to show fireworks all night long.  From 6PM until dawn, the sky will blaze over Booty Bay!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11461,'Wow!  These kegs are filled with powerful stuff!  They lift me right out of my boots!','Wow!  These kegs are filled with powerful stuff!  They lift me right out of my boots!',1,153,0,0,0,0,0,0,1,0,0,0,26124),
(11462,'Stick around after the firework show is over.  Find a goblet and raise it to toast your hardy friends!','Stick around after the firework show is over.  Find a goblet and raise it to toast your hardy friends!',71,0,0,0,0,0,0,0,1,0,0,0,26124),
(11463,'All right!  Party time!','All right!  Party time!',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(11464,'Times like these get me all sentimental...','Times like these get me all sentimental...',24,0,0,0,0,0,0,0,1,0,0,0,26124),
(11465,'I sure could use a kiss about now.  Know where I can find one?','I sure could use a kiss about now.  Know where I can find one?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11466,'Hah!  This tauren wants a kiss!','Hah!  This tauren wants a kiss!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11467,'A happy Winter Veil to you, friend!','A happy Winter Veil to you, friend!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11468,'Season\'s greetings, and peace to you!','Season\'s greetings, and peace to you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11469,'I wish you a happy holiday, friend!','I wish you a happy holiday, friend!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11470,'Ah, mistletoe...','Ah, mistletoe...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11471,'Kneel before me, mortal! Kneel before Zod!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11472,'Why ... won\'t you ... just dieeeee?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11473,'%s bristles with energy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11474,'%s drains your mana and turns to stone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11475,'Burn in hate, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11476,'%s is weakened!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11477,'I lied...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11478,'Come get some!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11479,'','Mighty fine weather we\'re having here, wouldn\'t you say?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11480,'Oh Umi, please teach me again how to create a Tranquil Yeti. I miss it so.','Oh Umi, please teach me again how to create a Tranquil Yeti. I miss it so.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11481,'','Well, alright then $n. I can tell that you\'ve seen the error of your ways and rejoined the engineering fold.$B$BHave fun with your yeti!!!',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(11482,'','Why is it that there\'s never a gyrochronatom lying around when you need one?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11483,'','I\'ll get the last laugh... they\'ll see! Oh, hi $c, I didn\'t see you there.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11484,'','Invention, my dear $c, is two percent bottled inspiration, four percent solar exposure, six percent chance of thunderstorms clearing by mid-afternoon, and ninety-three percent Rumplesnicker.$B$BWait, did that add to one hundred? I\'ve got my notes around here somewhere.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11485,'We\'ve gotta find out what the Qiraji are feeding those monsters! Look at the size of \'em!','',5,5,0,0,0,0,0,0,1,0,0,0,26124),
(11486,'Studying and understanding the Colossus will give us a needed advantage over the Qiraji.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11487,'','The secrets behind the power of the Colossus could lead to all sorts of innovations in science!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11488,'Where is Elder Graveborn?','Where is Elder Graveborn?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11489,'The inner gates of Ahn\'Qiraj crash open.','The inner gates of Ahn\'Qiraj crash open.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11490,'Elder Graveborn spends time near Brill in Tirisfal Glades.','Elder Graveborn spends time near Brill in Tirisfal Glades.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11491,'Where is Elder Moonstrike?','Where is Elder Moonstrike?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11492,'Elder Moonstrike can be found in the Scholomance in the Western Plaguelands.','Elder Moonstrike can be found in the Scholomance in the Western Plaguelands.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11493,'Where is Elder Darkcore?','Where is Elder Darkcore?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11494,'Elder Darkcore can be found in the Undercity.','Elder Darkcore can be found in the Undercity.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11495,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11496,'Show them what you\'re made of!  Attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11497,'Where is Elder Obsidian?','Where is Elder Obsidian?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11498,'Elder Obsidian wanders near the Sepulcher in Silverpine Forest.','Elder Obsidian wanders near the Sepulcher in Silverpine Forest.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11499,'Where is Elder Snowcrown?','Where is Elder Snowcrown?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11500,'Elder Snowcrown can be found in Light\'s Hope Chapel in the Eastern Plaguelands.','Elder Snowcrown can be found in Light\'s Hope Chapel in the Eastern Plaguelands.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11501,'Where is Elder Highpeak?','Where is Elder Highpeak?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11502,'Elder Highpeak watches over the Hinterlands from a hill near its center.','Elder Highpeak watches over the Hinterlands from a hill near its center.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11503,'Where is Elder Windrun?','Where is Elder Windrun?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11504,'Elder Windrun resides in the Crown Guard Tower in the Eastern Plaguelands.','Elder Windrun resides in the Crown Guard Tower in the Eastern Plaguelands.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11505,'Where is Elder Farwhisper?','Where is Elder Farwhisper?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11506,'Elder Farwhisper can be found wandering the streets of Stratholme.','Elder Farwhisper can be found wandering the streets of Stratholme.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11507,'Where is Elder Ironband?','Where is Elder Ironband?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11508,'Elder Ironband lives in Blackchar Cave in Searing Gorge.','Elder Ironband lives in Blackchar Cave in Searing Gorge.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11509,'Where is Elder Goldwell?','Where is Elder Goldwell?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11510,'Elder Goldwell spends his time in the village of Kharanos in Dun Morogh.','Elder Goldwell spends his time in the village of Kharanos in Dun Morogh.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11511,'','Begone foul creatures!  Your kind has no place in this world.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11512,'Where is Elder Bronzebeard?','Where is Elder Bronzebeard?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11513,'Show your courage, men and women of Azeroth!  Drive back the Qiraji invaders!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11514,'Elder Bronzebeard can be found in the ancestral home of the Bronzebeards, Ironforge.','Elder Bronzebeard can be found in the ancestral home of the Bronzebeards, Ironforge.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11515,'','Show no weakness!  Crush these foul creatures!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11516,'Where is Elder Silvervein?','Where is Elder Silvervein?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11517,'','Elune be with you, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11518,'','The High Priestess could not leave Darnassus. Fandral is in a very foul mood.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11519,'','Tyrande sends her prayers. The Mother Moon blesses us all.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11520,'It is settled. I command the Might of Kalimdor. Be certain that your soldiers understand and accept this as fact. Bloodshed is already plentiful. Let there be none between our factions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11521,'Soon, young ones. Soon the armies of the Horde will arrive. We march. March to the cursed gates and crush all in our way. Let them feel the might of Kalimdor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11522,'','You have a way with words, Overlord Saurfang. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11523,'','As to your warning - worry not. Our troops are all aware of the chain of command. We fight united. Let us hope your own troops remember that...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11524,'Elder Silvervein can be found near Thelsamar in Loch Modan.','Elder Silvervein can be found near Thelsamar in Loch Modan.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11525,'%s goes into a frenzy at the sight of his fallen troops.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11526,'You will pay for that...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11527,'FOR THE MIGHT OF KALIMDOR!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11528,'DOOMHAMMER GUIDE MY HAND!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11529,'I will destroy you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11530,'Where is Elder Morndeep?','Where is Elder Morndeep?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11531,'Elder Morndeep spends time at the Ring of Law in Blackrock Depths.','Elder Morndeep spends time at the Ring of Law in Blackrock Depths.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11532,'Where is Elder Stonefort?','Where is Elder Stonefort?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11533,'Elder Stonefort has taken to the dungeons of Blackrock Spire.','Elder Stonefort has taken to the dungeons of Blackrock Spire.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11534,'Where is Elder Rumblerock?','Where is Elder Rumblerock?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11535,'Elder Rumblerock passes the years in a cave atop Dreadmaul Rock in the Burning Steppes.','Elder Rumblerock passes the years in a cave atop Dreadmaul Rock in the Burning Steppes.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11536,'Colossals on the rise! At least 10 units strong! INCOMING FROM THE SOUTH!','Colossals on the rise! At least 10 units strong! INCOMING FROM THE SOUTH!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11537,'Where is Elder Starsong?','Where is Elder Starsong?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11538,'HOLD THE LINE! LET NOTHING THROUGH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11539,'Last I knew, Elder Starsong was in the Sunken Temple of the Swamp of Sorrows.','Last I knew, Elder Starsong was in the Sunken Temple of the Swamp of Sorrows.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11540,'FOR KALIMDOR!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11541,'KNOW NO FEAR, SOLDIERS! WE DIE FOR KALIMDOR TODAY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11542,'Where is Elder Stormbrow?','Where is Elder Stormbrow?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11543,'Elder Stormbrow is most likely at the village of Goldshire in Elwynn Forest.','Elder Stormbrow is most likely at the village of Goldshire in Elwynn Forest.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11544,'Where is Elder Winterhoof?','Where is Elder Winterhoof?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11545,'Winterhoof? I hear he\'s living it up in Booty Bay.','Winterhoof? I hear he\'s living it up in Booty Bay.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11546,'Where is Elder Skychaser?','Where is Elder Skychaser?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11547,'Elder Skychaser looks out over Westfall from atop Sentinel Hill.','Elder Skychaser looks out over Westfall from atop Sentinel Hill.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11548,'Where is Elder Dawnstrider?','Where is Elder Dawnstrider?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11549,'Elder Dawnstrider can be found at Flame Crest on the Burning Steppes.','Elder Dawnstrider can be found at Flame Crest on the Burning Steppes.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11550,'Where is Elder Hammershout?','Where is Elder Hammershout?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11551,'Elder Hammershout can be found outside the walls of Stormwind.','Elder Hammershout can be found outside the walls of Stormwind.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11552,'Where is Elder Bellowrage?','Where is Elder Bellowrage?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11553,'Elder Bellowrage watches over the Dark Portal from a ridge in the Blasted Lands.','Elder Bellowrage watches over the Dark Portal from a ridge in the Blasted Lands.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11554,'Where is Elder Bladeswift?','Where is Elder Bladeswift?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11555,'Elder Bladeswift wanders the paths of Darnassus atop Teldrassil.','Elder Bladeswift wanders the paths of Darnassus atop Teldrassil.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11556,'Where is Elder Skygleam?','Where is Elder Skygleam?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11557,'Elder Skygleam can be found near the Ravencrest Monument in Azshara.','Elder Skygleam can be found near the Ravencrest Monument in Azshara.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11558,'Where is Elder Bladeleaf?','Where is Elder Bladeleaf?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11559,'The village of Dolanaar atop Teldrassil is home to Elder Bladeleaf.','The village of Dolanaar atop Teldrassil is home to Elder Bladeleaf.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11560,'My work here is done. I\'ll be sure to let Mar\'alith and the others at Cenarion Hold know that you helped me out a little. Be careful in here, you don\'t have me holdin\' your hand past this point.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11561,'Where is Elder Starweave?','Where is Elder Starweave?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11562,'Elder Starweave can be found on the beach near Lor\'danel in Darkshore.','Elder Starweave can be found on the beach near Lor\'danel in Darkshore.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11563,'%s\'s eyes glow red for a brief moment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11564,'Is that the best you can do?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11565,'Where is Elder Nightwind?','Where is Elder Nightwind?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11566,'Elder Nightwind passes the days at the shrine in Jaedenar in Felwood.','Elder Nightwind passes the days at the shrine in Jaedenar in Felwood.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11567,'Where is Elder Riversong?','Where is Elder Riversong?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11568,'The village of Astranaar in Ashenvale is Elder Riversong\'s current home.','The village of Astranaar in Ashenvale is Elder Riversong\'s current home.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11570,'Where is Elder Stonespire?','Where is Elder Stonespire?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11571,'Last I knew, Elder Stonespire was at Everlook in Winterspring.','Last I knew, Elder Stonespire was at Everlook in Winterspring.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11572,'Where is Elder Brightspear?','Where is Elder Brightspear?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11573,'Elder Brightspear can be found wandering amongst the ruins of Kel\'Theril in Winterspring.','Elder Brightspear can be found wandering amongst the ruins of Kel\'Theril in Winterspring.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11574,'Where is Elder Bloodhoof?','Where is Elder Bloodhoof?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11575,'Elder Bloodhoof can be found at Bloodhoof Village in Mulgore.','Elder Bloodhoof can be found at Bloodhoof Village in Mulgore.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11576,'Where is Elder Windtotem?','Where is Elder Windtotem?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11577,'Elder Windtotem is keeping company with the goblins of Ratchet on the coast of the Barrens.','Elder Windtotem is keeping company with the goblins of Ratchet on the coast of the Barrens.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11578,'Where is Elder High Mountain?','Where is Elder High Mountain?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11579,'Elder High Mountain is at Vendetta Point in Southern Barrens.','Elder High Mountain is at Vendetta Point in Southern Barrens.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11580,'Where is Elder Moonwarden?','Where is Elder Moonwarden?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11581,'Elder Moonwarden is observing the Crossroads in Northern Barrens.','Elder Moonwarden is observing the Crossroads in Northern Barrens.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11582,'Where is Elder Wheathoof?','Where is Elder Wheathoof?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11583,'Elder Wheathoof is enjoying the vistas above Mulgore at Thunder Bluff.','Elder Wheathoof is enjoying the vistas above Mulgore at Thunder Bluff.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11584,'Where is Elder Darkhorn?','Where is Elder Darkhorn?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11585,'Elder Darkhorn can be found among the red rocks of Orgrimmar.','Elder Darkhorn can be found among the red rocks of Orgrimmar.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11586,'Where is Elder Morningdew?','Where is Elder Morningdew?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11587,'Elder Morningdew has taken to watching the commotion aboard Fizzle & Pozzik\'s Speedbarge in Thousand Needles.','Elder Morningdew has taken to watching the commotion aboard Fizzle & Pozzik\'s Speedbarge in Thousand Needles.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11588,'Where is Elder Runetotem?','Where is Elder Runetotem?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11589,'Last I heard, Elder Runetotem was traveling to Razor Hill in Durotar.','Last I heard, Elder Runetotem was traveling to Razor Hill in Durotar.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11590,'Where is Elder Grimtotem?','Where is Elder Grimtotem?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11591,'You\'ll find Elder Grimtotem at the Lariss Pavilion in Feralas.','You\'ll find Elder Grimtotem at the Lariss Pavilion in Feralas.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11592,'Where is Elder Mistwalker?','Where is Elder Mistwalker?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11593,'Elder Mistwalker enjoys watching the struggles at the Maul in Feralas.','Elder Mistwalker enjoys watching the struggles at the Maul in Feralas.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11594,'Where is Elder Skyseer?','Where is Elder Skyseer?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11595,'Go to the Freewind Post in Thousand Needles and you will find Elder Skyseer.','Go to the Freewind Post in Thousand Needles and you will find Elder Skyseer.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11596,'Where is Elder Splitrock?','Where is Elder Splitrock?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11597,'I think Elder Splitrock has traveled to Maraudon in Desolace.','I think Elder Splitrock has traveled to Maraudon in Desolace.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11598,'Where is Elder Dreamseer?','Where is Elder Dreamseer?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11599,'Elder Dreamseer resides in Gadgetzan in Tanaris Desert.','Elder Dreamseer resides in Gadgetzan in Tanaris Desert.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11600,'Where is Elder Ragetotem?','Where is Elder Ragetotem?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11601,'Elder Ragetotem spends her days at the Valley of the Watchers in Tanaris Desert.','Elder Ragetotem spends her days at the Valley of the Watchers in Tanaris Desert.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11602,'Where is Elder Wildmane?','Where is Elder Wildmane?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11603,'Zul\'Farrak in Tanaris Desert is Elder Wildmane\'s home.','Zul\'Farrak in Tanaris Desert is Elder Wildmane\'s home.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11604,'Where is Elder Thunderhorn?','Where is Elder Thunderhorn?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11605,'For reasons I cannot understand, Elder Thunderhorn has gone to the Slithering Scar in Un\'Goro Crater.','For reasons I cannot understand, Elder Thunderhorn has gone to the Slithering Scar in Un\'Goro Crater.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11606,'Where is Elder Bladesing?','Where is Elder Bladesing?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11607,'If you travel to Cenarion Hold in Silithus, you will find Elder Bladesing.','If you travel to Cenarion Hold in Silithus, you will find Elder Bladesing.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11608,'Where is Elder Primestone?','Where is Elder Primestone?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11609,'Elder Primestone has spent many years in the Crystal Vale in Silithus.','Elder Primestone has spent many years in the Crystal Vale in Silithus.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11610,'To honor your elders is to honor your culture and your people, $c.  For this, the coins of ancestry serve as a tangible means to recognize those who choose to follow a venerable path of respect.$B$BDuring this Lunar Festival, you may have the opportunity to honor many elders.  As you do so, you will acquire the coins of ancestry.  Bring me these coins, and I will reward your diligence with a selection of unique items.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11611,'Qiraji War Party spotted!','Qiraji War Party spotted!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11612,'Sandstorm coming from the south, take co...That\'s no sandstorm! INCOMING QIRAJI ARMY!','Sandstorm coming from the south, take co...That\'s no sandstorm! INCOMING QIRAJI ARMY!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11613,'Invaders approaching from the south!','Invaders approaching from the south!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11614,'Crush them all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11615,'The Might of Kalimdor will halt their advances!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11616,'Soldiers of Kalimdor, defend the base!','Soldiers of Kalimdor, defend the base!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11617,'I\'d like a new invitation to the Lunar Festival.','I\'d like a new invitation to the Lunar Festival.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11618,'','Greetings, $n.  We\'ve travelled from Moonglade to spread the spirit of the Lunar Festival far and wide.$B$BWon\'t you join us in our celebration?',6,0,0,1,0,0,0,0,1,0,0,0,26124),
(11619,'The final battle for Kalimdor is upon us. The supreme commander of the Might of Kalimdor orders his troops to march upon Ahn\'Qiraj and destroy all in their path.','The final battle for Kalimdor is upon us. The supreme commander of the Might of Kalimdor orders his troops to march upon Ahn\'Qiraj and destroy all in their path.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11620,'%s stands before the Might of Kalimdor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11621,'I am Saurfang. Brother of Broxigar. \n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11622,'You know me to be the Supreme Commander of the Might of Kalimdor.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11623,'%s pauses and looks across the sea of soldiers that stand nervously before him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11624,'An orc - a true orc warrior - wishes for one thing: To die in the glory of battle against a hated enemy.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11625,'Some of you have not fought in battles. Peace has been with us for many years. Many years we sat idle but many years we battled.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11626,'In those years - where strife filled the land as Legion and Scourge sacked our homes, killed our families - these insects dwelled beneath us. Beneath our homes - waiting.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11627,'Waiting to crush the life from our little ones. To slay all in their path. This they do for their god.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11628,'And for our gods?\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11629,'We defend. We stand. We show that as one. United. We destroy. Their god will fall.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11630,'To die today, on this field of battle, is to die an orcish death. To die today is to die for our little ones. Our old ones. Our ... loved ones.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11631,'Would any of you deny yourselves such a death? Such an honor?\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11632,'FOR KALIMDOR!','FOR KALIMDOR!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11633,'FOR HONOR!\n','FOR HONOR!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11634,'FER THE KING!','FER THE KING!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11635,'FER MAGNI!','FER MAGNI!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11636,'FER KHAZ\'MODAN!','FER KHAZ\'MODAN!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11637,'FER IRONFORGE!','FER IRONFORGE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11638,'I am with you until I gasp my last dying breath.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11639,'','%s says a prayer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11640,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11641,'For the Warchief!','For the Warchief!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11642,'FOR THE HORDE!','FOR THE HORDE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11643,'For Broxigar!','For Broxigar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11644,'For Kalimdor!','For Kalimdor!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11645,'FOR THE HORDE! FOR CAIRNE! FOR THUNDER BLUFF!','FOR THE HORDE! FOR CAIRNE! FOR THUNDER BLUFF!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11646,'ONWARD! TO AHN\'QIRAJ!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11647,'Our fates lie ahead...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11648,'Face the Might of Kalimdor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11649,'The Might of Kalimdor is victorious! The last of the Qiraji forces are defeated, retreating back to the ancient city-fortress of Ahn\'Qiraj. The Qiraji Resonating Crystals littering Kalimdor vanish as quickly as they appeared, leaving behind nothing but sundered earth.','The Might of Kalimdor is victorious! The last of the Qiraji forces are defeated, retreating back to the ancient city-fortress of Ahn\'Qiraj. The Qiraji Resonating Crystals littering Kalimdor vanish as quickly as they appeared, leaving behind nothing but sundered earth.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11650,'We\'re on orders from on high to destroy Rajaxx. Terminate with extreme prejudice if you want to get technical.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11651,'The battle is won! Watch as they flee to the safety of their precious temple. Soon all will be razed... Their leaders destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11652,'We stand together with the Alliance, $r. An evil, so old that the world has forgotten it, seeks to engulf us all; first on Kalimdor and then the rest of Azeroth. It is driven by a hatred of all things born of the great Shapers: The eternal Titans.$B$BWe are all that stand in the way of C\'Thun\'s armies. We will strike first and bring down the forces of Ahn\'Qiraj. Let all of Azeroth quake at the combined might of the Horde and Alliance.$B$BThe war effort needs you!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11653,'Where is Elder Meadowrun?','Where is Elder Meadowrun?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11654,'I last saw Elder Meadowrun at the Weeping Cave in the Western Plaguelands.','I last saw Elder Meadowrun at the Weeping Cave in the Western Plaguelands.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11656,'Where is Elder Starglade?','Where is Elder Starglade?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11657,'You\'ll find Elder Starglade outside the gates to Zul\'Gurub in Stranglethorn Vale.','You\'ll find Elder Starglade outside the gates to Zul\'Gurub in Stranglethorn Vale.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11658,'\"Great job collecting resources for the war,\" they said, \"Have a promotion,\" they said.  What they really meant is \"You\'re stationed outside a bughive in Silithus with a bunch of sweaty dwarves, Carnes!\"$B$BThanks for the promotion, Captain!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(11659,'','I, like my brother, honor those who honor their ancestors.  It brings me great joy to share my crafting secrets to disciples of the Lunar Festival!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11660,'Run if you want cowards!  It will do you no good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11661,'I, like many others, came to aid my fellow druids when the war started.$B$BNow that the Gates of Ahn\'Qiraj are open, I\'ve realized that much work still remains to be done.  I\'ve decided to stay in Silithus and do my best to help the cause, $n.  ','',1,0,0,1,0,0,0,0,1,0,0,0,26124),
(11662,'As deadly as the silithid seem, they are but tame creatures compared to their Qiraji overlords.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11663,'This war\'s not over, it\'s only just begun!  We have brave men and women fighting our enemy inside Ahn\'Qiraj day and night, $n.  It won\'t be long before the Qiraji city falls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11664,'','Our steady progress in our fight against the Qiraji can be attributed to the diverse help we received from nearly every corner of Kalimdor.$B$BYou need more than just soldiers to fight a war, $n.  Many of the war\'s unsung heroes are the traders and craftsmen that keep our forces supplied with the resources they need.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11665,'They know how to throw a party here in Moonglade.  Who would have thought so?','They know how to throw a party here in Moonglade.  Who would have thought so?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11666,'Try these fireworks launchers.  They\'re a blast!','Try these fireworks launchers.  They\'re a blast!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11667,'This beam of moonlight leads to Stormwind.  Use your invitation when you\'re ready.','This beam of moonlight leads to Stormwind.  Use your invitation when you\'re ready.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11668,'Don\'t try to teleport to one of your enemies\' cities.  It won\'t work - we may all be friendly here, but back home old grudges remain...','Don\'t try to teleport to one of your enemies\' cities.  It won\'t work - we may all be friendly here, but back home old grudges remain...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11669,'The people in Nighthaven sure know how to party!','The people in Nighthaven sure know how to party!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11670,'These fireworks sure make a nice BOOM, don\'t you think?','These fireworks sure make a nice BOOM, don\'t you think?',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11672,'This moonlight will send you to Ironforge.  But who\'d want to leave this party?','This moonlight will send you to Ironforge.  But who\'d want to leave this party?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11673,'The lunar celebration this year is quite magnificent!','The lunar celebration this year is quite magnificent!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11674,'They say these fireworks use the power of the moon!','They say these fireworks use the power of the moon!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11675,'This beam of greater moonlight will send you to Darnassus.','This beam of greater moonlight will send you to Darnassus.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11676,'If I didnt know better, I\'d say this party was organized by orcs!','If I didnt know better, I\'d say this party was organized by orcs!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11677,'Did you see?  That last firework almost caught that dwarf\'s shirt on fire!  Hah!','Did you see?  That last firework almost caught that dwarf\'s shirt on fire!  Hah!',153,0,0,0,0,0,0,0,1,0,0,0,26124),
(11678,'This moon beam will send you to Orgrimmar.  Use your invitation when you want to go.','This moon beam will send you to Orgrimmar.  Use your invitation when you want to go.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11679,'There\'s nothing like a little Lunar celebration to warm your bones!','There\'s nothing like a little Lunar celebration to warm your bones!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11680,'You have to be careful lighting fireworks when you can\'t feel your fingers...','You have to be careful lighting fireworks when you can\'t feel your fingers...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11681,'This beam of moonlight leads to the Undercity.  Retire when ready.','This beam of moonlight leads to the Undercity.  Retire when ready.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11682,'I love the Lunar Festival!  It\'s a great place to let your hooves kick up dust!','I love the Lunar Festival!  It\'s a great place to let your hooves kick up dust!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11683,'I don\'t know how these fireworks work, but they sure are pretty!','I don\'t know how these fireworks work, but they sure are pretty!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11684,'This moonlight will take you to Thunder Bluff.  Use it when you want to leave the festival.','This moonlight will take you to Thunder Bluff.  Use it when you want to leave the festival.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11685,'They\'re going to show fireworks all night long.  From 6PM until dawn, the sky will blaze over Elune\'ara!','They\'re going to show fireworks all night long.  From 6PM until dawn, the sky will blaze over Elune\'ara!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11686,'They put these lanterns out to commemorate the closing of the Lunar Festival.','They put these lanterns out to commemorate the closing of the Lunar Festival.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11687,'It is the last night of the Lunar Festival.  May fortune be with you!','It is the last night of the Lunar Festival.  May fortune be with you!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11688,'May your elders bless you, $n, and bring you luck in the coming year.','May your elders bless you, $n, and bring you luck in the coming year.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(11689,'How can I summon Omen?','How can I summon Omen?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11690,'Omen sleeps in the depths of Lake Elune\'ara, but may be summoned at the southeast banks near the Stormrage Barrow Dens.  There, you will find special cluster launchers...$B$BUse your rockets in the launchers and Omen\'s minions will come.  Fire more rockets, nearly three dozen, or fire Elune\'s candles at his minions, and soon he will awaken.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11691,'I wish to purchase another Elune\'s Candle.','I wish to purchase another Elune\'s Candle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11692,'%s shares his powers with his brethren.','%s shares his powers with his brethren.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11693,'%s goes into a rage!','%s goes into a rage!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11694,'%s goes into a berserker rage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11695,'%s is frozen solid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11696,'Long have we toiled to see our land returned to its former glory, $c. Ever shall we remain vigilant against those who have invaded and defiled Quel\'thalas. We will not rest until they are driven from our sight.$B$BLet none exist who stand in the way of the sin\'dorei!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11697,'','It\'s all a mess, $c, and it\'s all my fault! I was warned to get out of dock while there was still time, but did I listen? No.$B$BWhat am I going to do now? Those sickly blood elves, the Wretched, have made off with my magical goods, and ate them I think. I\'m pretty sure that means they can\'t be retrieved. And the Grimscale murlocs pirated away the rest of my goods in the dead of night! Furthermore, to kick an honest merchant when she\'s down, my crew abandoned ship!$B$BI think I\'m going to cry.',5,18,0,0,500,0,0,0,1,0,0,0,26124),
(11698,'','Hello, $c. These are troubling times indeed if this is what is to become of our beloved Quel\'Thalas.',1,18,0,0,500,0,0,0,1,0,0,0,26124),
(11700,'The massive floating eyeball in the center of the chamber turns its gaze upon you. You stand before a god.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11701,'The Wretched are a constant thorn in my side, $n.  When they\'re not being a danger to themselves by tapping unstable arcane sources to satisfy their cravings, they\'re cooking up half-brained schemes against our respectable society.','',1,0,0,1,0,0,0,0,1,0,0,0,26124),
(11702,'Only flesh and bone. Mortals are such easy prey...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11703,'and Bone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11704,'Mortals are...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11705,'such easy pray.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11706,'Where are your manners, brother. Let us properly welcome our guests.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11707,'There will be pain...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11708,'Oh so much pain...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11709,'Come, little ones.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11710,'The feast of souls begins now...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11711,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11713,'Good riddance... now none shall be able to repeat my mistakes!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11714,'I hope that Loralthalis is alright, $c. Maybe I should go up to Duskwither Spire myself? Maybe I should have done that in the first place?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11715,'A man can only live with himself and his shame for so long, $c, before he must take action to undo the mistakes he\'s made.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11716,'A mess, that\'s what this is!  All of these creatures sprung up out of nowhere, and are running around out of control!  And where\'ve the Magister, and his apprentices, run off to?  Leaving me here all alone without as much as a, \"Hello there Wyllithen, would you like to come with?\"$B$BThe nerve!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11717,'These arcane sanctums of yours are quite... interesting Mr. Caidanis.  I appreciate the information you have given me today.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11718,'It\'s been a pleasure, Mr. Anvilward.  I must say your enthusiastic interest in our operations is most... unexpected.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11720,'The walls have been breached!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11721,'','Attack!  Don\'t let them reach the gates!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11722,'Generic Text2!','Generic Text2',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11723,'Here, I\'d like to give you this token of my love.','Here, I\'d like to give you this token of my love.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11724,'We\'ve been so wrapped up in this war, some of us forgot to make time for love.','We\'ve been so wrapped up in this war, some of us forgot to make time for love.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11725,'What are those crates for?','What are those crates for?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11726,'I ordered a few shipments of new perfumes and colognes from the city. After I get them unpacked, check back and I\'ll have them for sale.','I ordered a few shipments of new perfumes and colognes from the city. After I get them unpacked, check back and I\'ll have them for sale.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11727,'You do not belong here!  Ancients, rise against these intruders!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11728,'','That was quite a fight.  Let us catch our breath for a bit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11729,'Hey, $gmister:miss;.  You look like a $C with discerning tastes in wine.  I have a favor to ask, and I think I can make you an offer you can\'t refuse...forget about it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11730,'What are you looking at, $glad : lass;?  Never seen a dwarf before, then?$B$BYou\'d best be on yer way if you don\'t want any trouble.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11731,'I need a moment of your time, sir.','I need a moment of your time, sir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11732,'Ah, you must be the $glad : lass; assigned to show me around the Eversong Woods.  Took your sweet time getting here, didn\'t you?$B$BVery well, off we go.  Let us not waste one more minute.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11733,'Why... yes, of course.  I\'ve something to show you right inside this building, Mr. Anvilward.','Why... yes, of course.  I\'ve something to show you right inside this building, Mr. Anvilward.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11734,'Very well.  Let\'s see what you have to show me, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11735,'What manner of trick is this, $r?  If you seek to ambush me, I warn you I will not go down quietly!  ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11736,'We\'ve been so wrapped up in this war, some of us forgot to make time for love.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11737,'','We\'ve been so wrapped up in this war, some of us forgot to make time for love.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11738,'It looks like you\'ve already found love. You can give me a love token, but I\'m not giving you anything nice. I\'m waiting for someone special.','It looks like you\'ve already found love. You can give me a love token, but I\'m not giving you anything nice. I\'m waiting for someone special.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11739,'','It looks like you\'ve already found love. You can give me a love token, but I\'m not giving you anything nice. I\'m waiting for someone special.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11740,'It looks like you\'ve already found love. You can give me a love token, but I\'m not giving you anything nice. I\'m waiting for someone special.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11741,'Greetings, $c. I trust that you bring me good news concerning the Worldwide Invitational event? If you are, then surely that means you were given a secret code to tell me. In return for your code I will give you a gift of one of the panda cubs that I take care of.$B$BJust whisper it in my ear when you are ready.','Greetings, $c. I trust that you bring me good news concerning the Worldwide Invitational event? If you are, then surely that means you were given a secret code to tell me. In return for your code I will give you a gift of one of the panda cubs that I take care of.$B$BJust whisper it in my ear when you are ready.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11742,'I would like to whisper my secret code to you to receive my Panda Cub pet.','I would like to whisper my secret code to you to receive my Panda Cub pet.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11743,'It looks like you\'ve already found love. You can give me a love token, but I\'m not giving you anything nice. I\'m waiting for someone special.','It looks like you\'ve already found love. You can give me a love token, but I\'m not giving you anything nice. I\'m waiting for someone special.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11744,'It looks like you\'ve already found love. You can give me a love token, but I\'m not giving you anything nice. I\'m waiting for someone special.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11745,'We\'ve been so wrapped up in this war, some of us forgot to make time for love.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11746,'','I don\'t know what\'s come over me. My heart feels as hot as new steel.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11747,'I don\'t know what\'s come over me. My heart feels as hot as new steel.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11748,'','You work with machines for so long, sometimes you forget about real hearts.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11749,'You work with machines for so long, sometimes you forget about real hearts.','You work with machines for so long, sometimes you forget about real hearts.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11750,'You work with machines for so long, sometimes you forget about real hearts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11751,'','When you have lived as long as I, it becomes easy to forget about love for years. It is always good to be reminded.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11752,'When you have lived as long as I, it becomes easy to forget about love for years. It is always good to be reminded.','When you have lived as long as I, it becomes easy to forget about love for years. It is always good to be reminded.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11753,'When you have lived as long as I, it becomes easy to forget about love for years. It is always good to be reminded.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11754,'It seems like love is drifting on the wind. I hope that I won\'t be left out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11755,'It seems like love is drifting on the wind. I hope that I won\'t be left out.','It seems like love is drifting on the wind. I hope that I won\'t be left out.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11756,'It has been years since I have thought with my heart, but it\'s all flooding back.','It has been years since I have thought with my heart, but it\'s all flooding back.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11757,'','It has been years since I have thought with my heart, but it\'s all flooding back.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11758,'It has been years since I have thought with my heart, but it\'s all flooding back.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11759,'We orcs are usually a private people, but lately, no one\'s been hiding their feelings.','We orcs are usually a private people, but lately, no one\'s been hiding their feelings.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11760,'','It seems like love is drifting on the wind. I hope that I won\'t be left out.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11761,'','We orcs are usually a private people, but lately, no one\'s been hiding their feelings.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11762,'We orcs are usually a private people, but lately, no one\'s been hiding their feelings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11763,'After all these years of fighting, now everyone\'s falling in love!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11764,'After all these years of fighting, now everyone\'s falling in love!','After all these years of fighting, now everyone\'s falling in love!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11765,'I would like to enter the secret code to receive my Murloc pet.','I would like to enter the secret code to receive my Murloc pet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11767,'Hail!  You look familiar... have we met before?$B$BWell if we have met, then... surely you were given a secret code. Tell me your code and I will give you a gift!','Hail, $c. You look familiar... have we met before?$B$BWell if we have met, then... surely you were given a secret code. Tell me your code and I will give you a gift!',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11768,'Just because it\'s not my heart doesn\'t mean it can\'t be broken.','Just because it\'s not my heart doesn\'t mean it can\'t be broken.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11769,'I\'ve gone easy on you thus far, but now you bore me. Witness the magnificence of my power, and despair!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11770,'I will not die again! Not to the likes of you!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11771,'Debug message, Thelrin has been summoned.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11772,'You can see me? Do you know how much I\'m ignored up here just because no one can see me? How refreshing to finally have someone to talk to!$B$BSo, you must have been sent by some living member of my former mercenary company, am I right? Of course I am!$B$BBut enough idle chit-chat, there\'s a great deal of work for you and I if you\'re going to put things right and return Lord Valthalak\'s spirit to him!','',1,1,0,0,1000,0,0,0,1,0,0,0,26124),
(11773,'I lost Lord Valthalak\'s Amulet!','I lost Lord Valthalak\'s Amulet!',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(11774,'Ah, $n, don\'t cry. Lucky for you, when last you gave me the amulet, I attuned myself to it. I\'ll just summon it back from wherever you dropped it.$B$BTry looking in your bags now.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11775,'You\'ve convinced me of your intentions, $n, and you have my thanks for being willing to help out the members of my former mercenary company, The Veiled Blade.$B$BNow let\'s see, what\'s next on our list of things to do?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11776,'I lost a piece of Lord Valthalak\'s Amulet!','I lost a piece of Lord Valthalak\'s Amulet!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11777,'There, there, $n, worry not! Which piece of the amulet have you misplaced?$B$BDid you check all of your bags and the bank?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11778,'Yes I checked, I\'m missing the top piece!','Yes I checked, I\'m missing the top piece!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11779,'Never fear, Bodley is on the job! Let\'s see here, ah yes... there it is. Let me just summon it... and, presto!$B$BTry not to lose it again, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11780,'Yes I checked, I\'m missing the left piece!','Yes I checked, I\'m missing the left piece!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11781,'Yes, yes, calm down, $c, there\'s nothing to worry about. As luck would have it, when you first gave the left piece to me, I attuned myself to it, so summoning it back from wherever you \'misplaced\' it is really not a problem.$B$BHere, and this time try to take better care of it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11784,'I\'ve misplaced the Brazier of Beckoning!','I\'ve misplaced the Brazier of Beckoning!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11785,'You\'re kidding, right? Ok, ok, don\'t panic. Luckily when I was imbueing it with the component that you retrieved, I attuned myself to it as well. I should be able to locate and summon it from wherever it is that you left it.$B$BAre you sure that you\'ve lost it? You looked in all of your bags and the bank?','',1,6,0,0,1000,0,0,0,1,0,0,0,26124),
(11786,'Yes, please summon it back!','Yes, please summon it back!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11787,'There you go, $n. Good thing my powers of divination and summoning still work in this ghostly state, huh?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11788,'Greetings and salutations from the manor Ravenholdt, adventurer.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11789,'Time to learn ya about manners, $g sonny:lass;.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11790,'','You look like you\'ve had your heart broken. Come back when you\'re not so sad.',25,153,0,0,0,0,0,0,1,0,0,0,26124),
(11791,'You look like you\'ve had your heart broken. Come back when you\'re not so sad.','You look like you\'ve had your heart broken. Come back when you\'re not so sad.',25,153,0,0,0,0,0,0,1,0,0,0,26124),
(11792,'You look like you\'ve had your heart broken. Come back when you\'re not so sad.','',25,153,0,0,0,0,0,0,1,0,0,0,26124),
(11793,'','I\'d talk to you if you smelled better. Cologne would be nice.',24,0,0,0,0,0,0,0,1,0,0,0,26124),
(11794,'','What, you don\'t have a token to give me? Don\'t you love me?',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(11795,'I\'d talk to you if you smelled better. Cologne would be nice.','I\'d talk to you if you smelled better. Cologne would be nice.',24,0,0,0,0,0,0,0,1,0,0,0,26124),
(11796,'What, you don\'t have a token to give me? Don\'t you love me?','What, you don\'t have a token to give me? Don\'t you love me?',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(11797,'I\'d like you better if you would apply some perfume.','I\'d like you better if you would apply some perfume.',24,0,0,0,0,0,0,0,1,0,0,0,26124),
(11798,'I\'d like you better if you would apply some perfume.','',24,0,0,0,0,0,0,0,1,0,0,0,26124),
(11799,'What, you don\'t have a token to give me? Don\'t you love me?','',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(11800,'What?! How did you sneak past my jail...er, minion out there? Well, I suppose it\'s for the best. Sales have been a little slow lately.$B$BHow may I fulfill your infernal needs, $c?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11801,'You look like you\'ve had your heart broken. Come back when you\'re not so sad.','You look like you\'ve had your heart broken. Come back when you\'re not so sad.',25,153,0,0,0,0,0,0,1,0,0,0,26124),
(11802,'I\'d like you better if you would apply some perfume.','I\'d like you better if you would apply some perfume.',24,0,0,0,0,0,0,0,1,0,0,0,26124),
(11803,'What, you don\'t have a token to give me? Don\'t you love me?','What, you don\'t have a token to give me? Don\'t you love me?',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(11804,'It looks like you\'ve already found love. You can give me a love token, but I\'m not giving you anything nice. I\'m waiting for someone special.','It looks like you\'ve already found love. You can give me a love token, but I\'m not giving you anything nice. I\'m waiting for someone special.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11805,'You look like you\'ve had your heart broken. Come back when you\'re not so sad.','You look like you\'ve had your heart broken. Come back when you\'re not so sad.',25,153,0,0,0,0,0,0,1,0,0,0,26124),
(11806,'I\'d like you better if you would apply some perfume.','I\'d like you better if you would apply some perfume.',24,0,0,0,0,0,0,0,1,0,0,0,26124),
(11807,'What, you don\'t have a token to give me? Don\'t you love me?','What, you don\'t have a token to give me? Don\'t you love me?',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(11808,'You look like you\'ve had your heart broken. Come back when you\'re not so sad.','',25,153,0,0,0,0,0,0,1,0,0,0,26124),
(11809,'I\'d like you better if you would apply some perfume.','',24,0,0,0,0,0,0,0,1,0,0,0,26124),
(11810,'What, you don\'t have a token to give me? Don\'t you love me?','',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(11811,'I\'d talk to you if you smelled better. How about cologne? Maybe perfume?','I\'d talk to you if you smelled better. How about cologne? Maybe perfume?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11812,'Intruders!  More pawns of the Argent Dawn, no doubt.  I already count one of their number among my prisoners.  Withdraw from my domain before she is executed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11813,'You\'re still here?  Your foolishness is amusing!  The Argent Dawn wench needn\'t suffer in vain.  Leave at once and she shall be spared!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11814,'May this prisoner\'s death serve as a warning.  None shall defy the scourge and live!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11815,'I shall take great pleasure in taking this poor wretch\'s life!  It\'s not too late, she needn\'t suffer in vain.  Turn back and her death shall be merciful!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11816,'','Don\'t worry about me!  Slay this dreadful beast and cleanse this world of his foul taint!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11817,'','My death means nothing.... light... will... prevail!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11818,'','I am free! Let\'s work together now to save my brother, Sothos!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11819,'','Thank you for freeing me, my brother, and all of you! We can finally rest in peace now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11820,'Let\'s see what you have.','Let\'s see what you have.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11821,'My mission is compete. I may have some spare supplies if you need any.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11822,'No, I\'m not, but lots of others are looking for love.  You should buy my love tokens, put on some cologne or perfume, and then pass them around!','No, I\'m not, but lots of others are looking for love.  You should buy my love tokens, put on some cologne or perfume, and then pass them around!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11823,'Does that heart mean you\'re looking for love?','Does that heart mean you\'re looking for love?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11824,'What are love tokens?','What are love tokens?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11825,'You\'re selling cologne and perfume?','You\'re selling cologne and perfume?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11826,'Love tokens are small messages of affection you can give to amorous town and city folk.  Such people will reward you with a gift of adoration.$B$BOr, if you are already adored by another, then at the least they\'ll give you a gift of friendship.','Love tokens are small messages of affection you can give to amorous town and city folk.  Such people will reward you with a gift of adoration.$B$BOr, if you are already adored by another, then at the least they\'ll give you a gift of friendship.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11827,'If you put on cologne or perfume, then you\'ll see who is amorous.  Those are the ones who accept love tokens... and offer a gift in return.$B$BBut remember: to give someone a love token, you have to smell just right!  Men like the scent of perfume, while women prefer cologne.','If you put on cologne or perfume, then you\'ll see who is amorous.  Those are the ones who accept love tokens... and offer a gift in return.$B$BBut remember: to give someone a love token, you have to smell just right!  Men like the scent of perfume, while women prefer cologne.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11828,'What can I do with these gifts?','What can I do with these gifts?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11829,'When you give love tokens to townsfolk, you\'ll receive different gifts in return.  Some of those you\'ll want to keep and use, but others can be bundled together and given to your favorite hero!  Visit Kwee Q. Peddlefeet to turn them in.$B$BKwee can be found near Bolvar, Magni, or Tyrande.','When you give love tokens to townsfolk, you\'ll receive different gifts in return.  Some of those you\'ll want to keep and use, but others can be bundled together and given to your favorite hero!  Visit Kwee Q. Peddlefeet to turn them in.$B$BKwee can be found near Bolvar, Magni, or Tyrande.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11830,'$n! You\'ve returned just to talk to me? That\'s very thoughtful of you, and you look pretty sweet in that outfit, too!$B$BYou don\'t know how good it makes me feel to see you. It can get pretty lonely up here, what with most of these yahoos not being able to see me, and all. It\'s a great thing that you did for all of us, and I\'ll never forget it!$B$BThanks for dropping in and saying hi, and don\'t be such a stranger.','',71,1,0,0,1000,0,0,0,1,0,0,0,26124),
(11831,'Welcome back, $n. Have I mentioned how good it is to have someone to talk to?$B$BAlright then, let\'s get down to business. What\'s next that we have to do?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11832,'Hey, $n. Over here, I want to talk to you.','',70,0,0,0,0,0,0,0,1,0,0,0,26124),
(11833,'Who\'s the most popular hero of the realm, you ask?  Well here are the current standings!$B$BThrall: $2200w$BCairne: $2201w$BSylvanas: $2202w$BTotal Horde: $2207w$B$BVarian: $2203w$BMagni: $2204w$BTyrande: $2205w$BTotal Alliance: $2206w$B$BIf you want to cast your vote, be sure to turn in your gift collections!','Who\'s the most popular hero of the realm, you ask?  Well here are the current standings!$B$BThrall: $2200w$BCairne: $2201w$BSylvanas: $2202w$BTotal Horde: $2207w$B$BVarian: $2203w$BMagni: $2204w$BTyrande: $2205w$BTotal Alliance: $2206w$B$BIf you want to cast your vote, be sure to turn in your gift collections!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11834,'Hi!  I\'m Kwee Q. Peddlefeet!  I\'m here to find out who is the most popular of all the heroes in Azeroth!$B$BIt sure warms my heart to see so many adoring fans greet their leaders, but... do you know what would warm me even more?$B$BA kiss!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11835,'How are the gift standings?  Who\'s the most popular?','How are the gift standings?  Who\'s the most popular?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11836,'Annalise? Is that you?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11837,'','My dear Staffron, have you forgotten what it is to love? The love that we once shared?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11838,'','Staffron...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11839,'Have I forgotten? Of course I have... I have forgotten about love, happiness... of life itself.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11840,'But I do know this - love makes the heart and body weak. It can be exploited. Without your love, I have only my work, Annalise.','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(11841,'','But of course I love you, Staffron. And it pains me to see you suffer so.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11842,'','I pledge my love to you forever. Death cannot erase that, even as I am sure that you still remember your love for me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11843,'','And if you do not, then I am truly lost.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11844,'How could you love me, Annalise? Look at me. I am not the man you once knew.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11845,'Annalise? Annalise! No, don\'t leave me!','',20,0,0,0,0,0,0,0,1,0,0,0,26124),
(11846,'Annalise... You\'re right. I-I can\'t do this. I must find another way.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11847,'You there. You\'re welcome to take the contents of my cauldron. It was to be the second stage of my plan - amorous clothing.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11848,'You two are surely star-crossed lovers who have found each other. There is much happiness in your future.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11850,'Yikes! Two fiery personalities. You\'ll have many arguments, but your love will burn just as hot!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11851,'While you may try to make it work, in the end, you will go your separate ways.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11852,'You two will have many ups and downs, but if you can hold on, the ride will be worth it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11853,'I hear wedding bells in your future.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11854,'The future is cloudy for you two. If you work at your relationship, I\'m sure you can find some measure of happiness.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11856,'Here are the final standings!$B$BThrall: $2200w$BCairne: $2201w$BSylvanas: $2202w$BTotal Horde: $2207w$B$BBolvar: $2203w$BMagni: $2204w$BTyrande: $2205w$BTotal Alliance: $2206w$B$BThe Alliance has the most popular hero!','Here are the final standings!$B$BThrall: $2200w$BCairne: $2201w$BSylvanas: $2202w$BTotal Horde: $2207w$B$BBolvar: $2203w$BMagni: $2204w$BTyrande: $2205w$BTotal Alliance: $2206w$B$BThe Alliance has the most popular hero!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11857,'Here are the final standings!$B$BThrall: $2200w$BCairne: $2201w$BSylvanas: $2202w$BTotal Horde: $2207w$B$BBolvar: $2203w$BMagni: $2204w$BTyrande: $2205w$BTotal Alliance: $2206w$B$BThe Horde has the most popular hero!','Here are the final standings!$B$BThrall: $2200w$BCairne: $2201w$BSylvanas: $2202w$BTotal Horde: $2207w$B$BBolvar: $2203w$BMagni: $2204w$BTyrande: $2205w$BTotal Alliance: $2206w$B$BThe Horde has the most popular hero!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11858,'I am free! Let\'s work together now to save my sister, Jarien!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11859,'Thank you for freeing me, my sister, and all of you! We can finally rest in peace now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11860,'','My torture is ended and now I can join the Goddess. Thank you so very much!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11861,'Though I move on in peace, you all have my undying gratitude. Thank you for freeing me from the curse of my folly and greed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11862,'Very clever how you got in here like that, $n.$B$BWhat? Surprised that I know your name? I\'m a demon, that\'s what we do. I also know your true name, so you\'d better buy something expensive.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11863,'Here for the rod? Or, maybe you\'re simply stocking up on runes?$B$BWait a minute! Are you just trying to offload a whole bunch of junk on me?! Curse my never-ending compulsion to buy, buy, buy!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11864,'What? No, I don\'t do armor repairs. Everlook is about a mile to the north, $g brother : sister;.$B$BNow buy something, or move along before I summon my warlock to deal with you!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11865,'Can I show you what I have for sale?\n\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11866,'If I make a gift collection, what do I do with it?','If I make a gift collection, what do I do with it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11868,'If it is your desire to visit the rise of the Defiler, you have only to ask. I am able to transport you and your comrades.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11869,'We wish to face the Defiler.','We wish to face the Defiler.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11870,'When you give love tokens to townsfolk, you\'ll receive different gifts in return.  Some of those you\'ll want to keep and use, but others can be bundled together and given to your favorite hero!  Visit Kwee Q. Peddlefeet to turn them in.$B$BKwee can be found near Cairne, Sylvanas and Thrall.','When you give love tokens to townsfolk, you\'ll receive different gifts in return.  Some of those you\'ll want to keep and use, but others can be bundled together and given to your favorite hero!  Visit Kwee Q. Peddlefeet to turn them in.$B$BKwee can be found near Cairne, Sylvanas and Thrall.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11871,'<PH> Incoming Mages <PH>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11872,'Here are the final standings!$B$BThrall: $2200w$B$BCairne: $2201w$B$BSylvanas: $2202w$B$BTotal Horde: $2207w$B$B$BBolvar: $2203w$B$BMagni: $2204w$B$BTyrande: $2205w$B$BTotal Alliance: $2206w$B$BThe Horde and the Alliance tied in total votes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11873,'We am free! Thank you little, puny ones.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11874,'The pages of this book have been destroyed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11875,'Hundreds of various diagrams and schematics begin to take shape on the pages of the book. You recognize some of the diagrams while others remain foreign but familiar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11876,'I am 100% confident that I wish to learn in the ways of goblin engineering.','I am 100% confident that I wish to learn in the ways of goblin engineering.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11877,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11878,'I am 100% confident that I wish to learn in the ways of gnomish engineering.','I am 100% confident that I wish to learn in the ways of gnomish engineering.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11879,'Your fate is sealed, Deliana!  You will pay for your trespasses against Lord Valthalak!','Your fate is sealed, Deliana!  You will pay for your trespasses against Lord Valthalak!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11880,'So you\'re looking to relearn what you forgot, eh? Or maybe learn what you were never taught? I know just the thing, $n. Over by Steamwheedle port, to the east, you\'ll find a magical book in Narain\'s hut called \"Soothsaying for Dummies.\" Give it a read.$B$B<Nixx winks.>$B$BYou\'ll find all that you need to know and then some...','',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(11881,'','You\'re never going to stop coming after me, are you?  Fine, but you won\'t take me down without a fight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11882,'Teach you the ways of gnomish engineering? Not going to happen! Not this gnome, anyway. You have a stink on you, $n. Maybe this is the pity talking but I will offer some advice.$B$BIn the Tanaris desert you\'ll find a hut that belongs to Narain Soothfancy. In that hut is a magical book that has been known to do wonderous things. Find that book and you may yet learn the gnomish way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11883,'','I didn\'t mean to drag you into this, $n.  Ever since we took on a job to steal Lord Valthalak\'s spellbook, everyone involved has wound up dead or missing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11884,'Teach you gnomish engineering? I don\'t have time for this nonsense. You only get one chance with Oglethorpe and you blew that, didn\'t you?$B$BYou\'ll have to head to Tanaris and find Narain Soothfancy\'s hut. In that hut is a magical book that might be able to jostle whatever is left of your brain and reconnect you with what you\'ve lost.$B$BNow get lost!','',1,1,5,0,0,0,0,0,1,0,0,0,26124),
(11885,'','Trying to find out more about my predicament has been nearly impossible.  The smuggler that hired us has vanished and Anthion Harmon, our mercenary company\'s leader, is dead.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11888,'','Come to think about it, most everyone involved is dead.  I\'ll understand if you don\'t want to be involved in any of this, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11889,'I am absolutely certain that I want to learn dragonscale leatherworking.','I am absolutely certain that I want to learn dragonscale leatherworking.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11890,'I am absolutely certain that I want to learn elemental leatherworking.','I am absolutely certain that I want to learn elemental leatherworking.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11891,'I am absolutely certain that I want to learn tribal leatherworking.','I am absolutely certain that I want to learn tribal leatherworking.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11892,'The assortment of images, shapes, and markings come together before your eyes. The book seems to know your skill with leatherworking and offers you a choice - but be warned - you may only select one and once you have done so, may not change your mind!:','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11893,'Your fate is sealed, Mokvar!  You will pay for your trespasses against Lord Valthalak!','Your fate is sealed, Mokvar!  You will pay for your trespasses against Lord Valthalak!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11894,'I cannot teach you dragonscale leatherworking, $n. You must go to Tanaris and find the home of Narain Soothfancy. Once there, consult the book \"Soothsaying for Dummies.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11895,'Begone foul creatures!  Go back to the void your master shaped you from!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11896,'It was not my intention to get you involved in this, $n.  I\'ve spent every waking hour looking over my shoulder ever since I helped an old friend in a daring raid on Blackrock Spire.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11897,'Trying to find out more about these creatures hasn\'t been easy.  My friend and the person who hired his mercenaries to steal Lord Valthalak\'s spellbook have both been feared dead for a while.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11898,'One by one, nearly everyone involved in this matter has fallen prey to these spectres.  I\'ll understand if you decide to walk away from this, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11899,'','I cannot teach you elemental leatherworking, $n. You must go to Tanaris and find the home of Narain Soothfancy. Once there, consult the book \"Soothsaying for Dummies.\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11900,'I cannot teach you elemental leatherworking, $n. You must go to Tanaris and find the home of Narain Soothfancy. Once there, consult the book \"Soothsaying for Dummies.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11901,'','I cannot teach you tribal leatherworking, $n. You must go to Tanaris and find the home of Narain Soothfancy. Once there, consult the book \"Soothsaying for Dummies.\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11902,'I cannot teach you tribal leatherworking, $n. You must go to Tanaris and find the home of Narain Soothfancy. Once there, consult the book \"Soothsaying for Dummies.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11903,'It is good that I have been allowed to continue my pursuits here.  I do not wish to overstay my welcome, at any rate.  It would be a great dishonor if I brought any trouble to our capital.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11904,'','Try not to draw too much attention, I\'m waiting for the Council to grant me audience.  Not that I mind waiting, I feel pretty safe around all these burly guards.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11905,'Losing my life was a danger I had come to terms with.  Losing Ysida is something I cannot endure, even after my own death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11906,'Greetings, friend!  Can I interest you in some ectoplasmic capacitors?  Or perhaps a nice omni-directional spectral assimilator? ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11907,'What now?  Can\'t you see I\'m rather busy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11908,'I seem to have misplaced the distiller, Mux.  Did I happen to leave it here?','I seem to have misplaced the distiller, Mux.  Did I happen to leave it here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11909,'About that ghost revealer.  Did I happen to leave it here?  I seem to be missing it.','About that ghost revealer.  Did I happen to leave it here?  I seem to be missing it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11910,'I believe I misplaced that banner you enchanted for me, Falrin.','I believe I misplaced that banner you enchanted for me, Falrin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11911,'Anthion, I seem  to have misplaced the banner you created for me. ','Anthion, I seem to have misplaced the banner you created for me. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11912,'I guess it\'s all just about over, right $n? I\'m going to miss you... it\'ll be pretty lonely up here without someone to talk to.$B$BBut that doesn\'t mean that you can\'t come back to see me in the future!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11913,'Hey Vi\'el, show me your wares!','Hey Vi\'el, show me your wares!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11914,'Return the amulet! Return to me what was stolen!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11915,'Bodley, tell me what\'s going on.','Bodley, tell me what\'s going on.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11916,'It\'s quite simple, really, $n. My old merc company, The Veiled Blade, took the wrong mission at the wrong time.$B$BWe were hired by a goblin smuggler out of Booty Bay, one Gremnik Rizzlesprang, who was covetous of Lord Valthalak\'s spellbook. Or, maybe there was some old rivalry there? I suppose we\'ll never know now, because Gremnik was killed not too long ago by a group of Valthalak\'s spectral assassins. They really can be very deadly when a large number of them gather.$B$BWhere was I?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11917,'You were telling me about The Veiled Blade and how you took the wrong mission.','You were telling me about The Veiled Blade and how you took the wrong mission.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11918,'Oh yes, that\'s right.$B$BSo, here we are invading deep into the upper reaches of Blackrock Spire, against their lord and leader; this was before Drakkisath. Not too smart if you ask me, but our leader, Anthion Harmon, you met him, was always one who loved a challenge.$B$BSurprisingly, everything went according to plan, right up to the point where we were prying Valthalak\'s spellbook out of his stiff fingers. That\'s when it all went south.$B$BShould I continue? You look like your eyes are glazing over.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11919,'No, no, please continue... it\'s just that the air up here is so, um, smoky.','No, no, please continue... it\'s just that the air up here is so, um, smoky.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11920,'<Bodley looks at you dubiously, but continues...>$B$BThere we are, spellbook in hand, and Kormok, our two-headed ogre necromancer, gets this strange look in all four of his eyes. It was really creepy, because that second set of eyes always kind of looked dead, like a cow\'s eyes, you know? So, all of a sudden he just reaches out and rips this amulet off that Valthalak was wearing.$B$BThe rest of the company went crazy; some of us telling them to leave it alone, and others who wanted it for themselves.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11921,'Please continue, Bodley.','Please continue, Bodley.',20,0,0,0,0,0,0,0,1,0,0,0,26124),
(11922,'Sheesh, you don\'t have to beg! Anyways, I\'m almost done with the story.$B$BSo, the whole company is in the middle of that massive chamber fighting over this amulet, and you know how it echoes in there! In the end it was broken into three pieces, and we rolled the dice, with it going to various people or groups.$B$BThe rest is a bit of a blur, though, because it was at about that time that old Valthalak\'s spirit decided to make an entrance and start summoning forth all of these spectral assassins.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11923,'I thought you were almost done?','I thought you were almost done?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11924,'Cool your heels!$B$B<Bodley grumbles something under his breath about the impatience of the living>$B$BAs I was saying, Lord Valthalak\'s spirit and spectral assassins, summoned forth through his necromantic dabbling, started to assail us. Let me tell you, at that point we weren\'t in any condition to fight back, so we ran. I can still remember Mor Grayhoof, one of our druids, slip and fall at one point into the lower reaches of the spire.$B$BThe rest as they say, is history.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11925,'What happened to your mercenary company, The Veiled Blade?','What happened to your mercenary company, The Veiled Blade?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11926,'We broke up afterward, that\'s what happened. Too much bad blood, I guess...it had been building for a while. And the thing with the amulet was the straw that broke the kodo\'s back.$B$BEver since then Valthalak\'s servants have been picking us off one by one. Most of the amulet piece holders are dead, their souls corrupted by the portion of Valthalak\'s spirit contained within it.$B$BThat\'s why I\'m glad that you\'re here, $n. With your help we\'ll be able to recombine the amulet and return it to Lord Valthalak!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11927,'Your meddling ends here, $n!  Lord Valthalak shall have his revenge!','Your meddling ends here, $n!  Lord Valthalak shall have his revenge!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11928,'Friends of yours?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11929,'Use your tonk action bar above your standard action bar to attack other tonks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11930,'','I\'ll be fine for now, don\'t worry about me.  I\'ll find a way out of here once I\'ve performed some cleansing rituals in this room.  Foul magic taints this place, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11931,'','You did it... you\'ve slain Baron Rivendare!  The Argent Dawn shall hear of your valiant deeds!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11932,'Talk about making the wrong investment!$B$BLord Valthalak\'s dark book of spells fetched a pretty penny in the black market.  It\'s too bad he didn\'t take too kindly to getting his possessions stolen.  That stinker got us even after he\'d been dead for months!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11933,'Ysida lives thanks to your courage, $n.  I am deeply in your debt and shall assist you as much as it is in my power.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11934,'Tonks?','Tonks?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11935,'','Our newest attraction, and at no cost to you I might add, these miniature tanks, or Tonks as we\'ve cleverly named them, can be controlled from any of the Tonk Control Consoles spread throughout the faire.$B$BAll that you have to do is activate an available control console. Each tonk will come equipped with a stock set of devices, and a random special power to unleash upon your enemy!$B$BHold epic battles with your friends, cruise around, or just cause wild mayhem... the choice is yours!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11936,'Cannon?','Cannon?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11937,'','The Blastenheimer 5000 Ultra Cannon is a state-of-the-art single person projectile device. Delivering its payload at near the speed of a dragon, the cannon is the pride and joy of the Blastenheimer family, world renown for their aeronautical and combustible feats!$B$BIf you\'d like to be launched through the skies to fly free as a bird, seek out Maxima Blastenheimer on the east end of the faire. I hear that she\'s placed a target ring way over on Crystal Lake for you to aim for as you sail through the air!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11938,'','The Blastenheimer 5000 Ultra Cannon is a state-of-the-art single person projectile device. Delivering its payload at near the speed of a dragon, the cannon is the pride and joy of the Blastenheimer family, world renown for their aeronautical and combustible feats!$B$BIf you\'d like to be launched through the skies to fly free as a bird, seek out Maxima Blastenheimer on the south edge of Thunder Bluff\'s central rise. She\'ll aim you at the target far to south on Stonebull Lake!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11939,'%s goes into a rage after seeing $n fall in battle!','%s goes into a rage after seeing $n fall in battle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11940,'','It is said that Kel\'Thuzad seeks the legendary Atiesh, greatstaff of the Guardian.$B$BYes, the very staff once held by Medivh.',1,273,0,0,0,0,0,0,1,0,0,0,26124),
(11941,'We of the Brotherhood of the Light are not as lenient as our brethren when it comes to meting justice to those that would do this world wrong.','',25,1,0,0,0,0,0,0,1,0,0,0,26124),
(11942,'The Lich King is attempting to make his presence known in our world. This must not be allowed to occur.\n','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11943,'What is the Brotherhood of the Light?  Well... We are all members of the Argent Crusade at the core - members of the Argent Crusade that aren\'t held in check by morals, guilt and useless human emotion.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(11944,'','The Argent Dawn might be impotent idealists but their delusional leader knows that they are outmatched. I have been sent here as an emissary of the Scarlet Crusade. An ambassador, if you will... It is doubtful that we could even dent the armies of Kel\'Thuzad - united or not - but we might be able to contain them long enough for some sort of miracle to happen.$B$BAs for me? I\'ll die in battle...$B$B<Marjhan shrugs.>\n',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11945,'','That is wonderous, Rimblat! Even this foul, sundered earth is not beyond healing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11946,'Watch, druid. The earth still breathes. It yearns to be cleansed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11947,'The title is misleading. I\'m really a very nice person once you get to know me.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11948,'They almost sent my brother, Loksey, to this gathering. He cannot even take care of his hounds, let alone represent the Scarlet Crusade in a competent manner.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11949,'I\'ve been expec...$B$B<Rimblat coughs.>$B$BExcuse me, old habit. I am Rimblat of the Earthen Ring. ','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11950,'','Hello, $c. Please try not to draw too much attention.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11951,'What is it that you want, lemming? Get out of my sight before you find out why I am known as the Wrathcaster.','',6,1,25,0,0,2,0,0,1,0,0,0,26124),
(11952,'You want a fight?  A fight you\'ll get!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11953,'I\'m going to kick yer ugly head in!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11954,'I crush weaklings like you every day!  Bring it on!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11955,'Your insolence is appalling, fool!  I shall feast on your soul!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11956,'Who dares to disturb my eternal rest?  Your deaths will be slow and painful!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11957,'You\'re but worms beneath my feet.  You dare challenge me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11958,'First Kormok crush your bones!  Then Kormok burn your soul!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11959,'You so little and puny... you no make good servants for Kormok!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11960,'What is Dreadnaught armor?','What is Dreadnaught armor?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11961,'The first suit of Dreadnaught armor was made exclusively for the Scarlet Highlord Mograine.  Whilst donning the full suit, the Highlord looked himself to be a demon from the depths of the Nether.$B$BAye, \'twas quite a sight to behold as Mograine would wade into a hundred Scourge, Ashbringer held high, and come out on the other side in a cloud of dust and flames - enemies left in ashes beneath his feet.','',1,1,1,0,1,1,0,0,1,0,0,0,26124),
(11962,'Continue please.','Continue please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11963,'It was not until after his controversial death that the knights and warriors of Lordaeron would wear similarly fashioned suits in honor of their fallen hero. While the death of Mograine was a great victory for Kel\'Thuzad, the resulting martyrdom would be felt until the end of the war.$B$BWhere one did fall, many would rise...','',1,1,1,1,1,1,0,0,1,0,0,0,26124),
(11964,'Anything else?','Anything else?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11965,'During your battles with the Scourge in Naxxramas, should you come across desecrated battlements and wartorn plate scraps, return them to me and I shall craft for you a piece of this armor worn by heroes.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11966,'All of Nature\'s might is at my disposal, puny mortals. Let us see which of my many forms it will be that ends your suffering!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11967,'Muahahahaha! What is this pathetic spectacle I see before me? Well, what are you waiting for? I hunger, and you look as if you may make for a passable appetizer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11968,'You think you can summon us? We are the ones that summon, not you! We bash you good for this and suck the marrow from your bones!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11969,'I\'m what you call a capitalist, $r.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11970,'','In life, I focused my energies on healing others. Let us see in death how much pain I can cause!',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11971,'','Hello, brother.',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(11972,'Hello, sister. What have we here?','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(11973,'','Would-be interlopers, I\'m afraid.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11974,'Shall we slay them for the impertinence of disturbing our sleep?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(11975,'','Yes, we shall!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(11976,'What is Redemption armor?','What is Redemption armor?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11977,'The armor of Redemption was worn by our most pious knights - armor worthy of the Lightbringer himself!$B$BThousands fell in the last war; their vestments stripped from their corpses and taken to the dread citadel of Naxxramas.$B$BIt is said that the death knights of Naxxramas corrupt the Redemption plate mail for their own use.$B$BSuch tragedy... ','',1,1,274,1,1,1,0,0,1,0,0,0,26124),
(11978,'What is Cryptstalker armor?','What is Cryptstalker armor?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11979,'The preternatural ability of the crypt fiend to hunt and kill its foe is one studied and vaunted by men in my profession. I, myself, have slain thousands of the beasts in my crusade to rid this world of Scourge.$B$BWhile I loathe the crypt fiend for its merciless nature, its abilities must be admired. It has a job and it does it - very well.','',1,1,1,1,1,1,0,0,1,0,0,0,26124),
(11980,'Continue please.','Continue please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11981,'I have discovered a use for the carapace of the crypt fiend and its various body parts. I am able to fashion an extremely light and very deadly set of armor by combining the fragments with some of the desecrated magical armors lost in Naxxramas.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11982,'I am unable to teach a Tauren to ride a Skeletal Mount.  I am sorry but there is nothing I can do for you.','I am unable to teach a Tauren to ride a Skeletal Mount.  I am sorry but there is nothing I can do for you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11983,'What brings a tauren to the Plaguelands?','What brings a tauren to the Plaguelands?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11984,'In the last war, tauren fought. Shaman were sent in defense of this world against the Scourge invasion. Most lost their lives. Many were otherwise ripped asunder, their body parts used for foul experiments in that cursed citadel. I mourn their passing but my heart swells with pride at their courage.','',1,1,1,0,1,1,0,0,1,0,0,0,26124),
(11985,'Continue please.','Continue please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(11986,'I was a young tauren, barely having reached adolescence at the time, but I knew that those that would brave the battles for our freedom were well protected in my namesake\'s vestments.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11987,'The name of Earthshatter has been one held by my family for hundreds of years. And like my father and his father before him, I too have inherited the right to create the vestments of my namesake. ','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(11988,'Oh, hello there.. um, what\'s your name?$B$BNo matter, what brings you to my home-away-from-home here out in the beautiful countryside?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11989,'Hello, $c. I trust that you are enjoying youself? What do you think of the party? I do so hope that we aren\'t running out of anything. Nothing kills a fete faster than running out of drinks and hors d\'oeuvres, wouldn\'t you say?$B$BYes, well, I must be about attending to my other guests. Do enjoy your stay.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11990,'Ah, excellent! Let the festivities begin. Let us retire to the terrace. Now, where did I put my drink?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11991,'<Yawn> Is it dawn already? Ah well, all good things... as they say. I don\'t know about the rest of you, but I\'m going inside.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(11992,'','Milord, do you think that we can join the party soon? I\'m so bored in here.',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(11993,'','Oh, my lordship, I do so hope that you\'ve arranged for more of that excellent wine from Silvermoon City. I dare say drinking it makes me feel almost as forward as a common woman!',1,24,0,0,500,0,0,1,1,0,0,0,26124),
(11994,'','I\'m so tired. We really shouldn\'t have stayed up so late last night,,, well this morning. But it was fun! You do throw the best soirees milord.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(11995,'','Lord Saltheril, my dear, did you notice that supplies for the party are a little low? We really should send for one of those couriers from Fairbreeze Village to deliver more of whatever is needed. I especially like those little hors d\'oeuvres wrapped in the smoked bacon. What are those called?',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(11996,'As you say, my dear, as you say.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(11997,'Hmm, what was that? I\'m sorry my dear, I must have been daydreaming.','',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(11998,'Oh, most definitely, Elisara. But please, can you show the least bit of patience?','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(11999,'Is that so? How very interesting. My dear, why don\'t you run along and powder your nose? I have much to think about.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12000,'','Oh goody! The party\'s about to start!',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(12001,'','Greetings, my $g lord : lady;. I trust that you are having a pleasant time?',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(12002,'','Isn\'t this just so much fun? I\'m so glad that Lord Saltheril throws these parties every night, especially with all of that nastiness occurring to the south. Kind of just makes all of that go away, don\'t you think?',1,6,0,0,500,0,0,0,1,0,0,0,26124),
(12003,'What is it that you do exactly, Rohan?','What is it that you do exactly, Rohan?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12004,'Ah, as the title states I am an assassin for the Scarlet Crusade. I spend my days exterminating high priority targets and nights at the Gadgetzan discotheque. Dancing is my true calling. Assassination just pays the bills.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(12005,'So what brings you to Light\'s Hope?','So what brings you to Light\'s Hope?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12006,'Good question, $r. In my younger days I was footloose and fancy free without a care in the world. In those days I would sing in a barber shop quartet out of Stormwind known as the Four Dons. That\'s where I learned how to craft the Bonescythe digs.','',273,1,1,1,1,1,0,0,1,0,0,0,26124),
(12007,'What? Bonescythe?','What? Bonescythe?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12008,'Yes, Bonescythe. You see, it was our tenor, an ornery fellow known as Don Julio, who got me started on the whole thing. In his travels throughout Lordaeron, Don Julio picked up many interesting skills, one of them being the ability to take the bones of fallen Scourge and fashion them into a lethal set of leather armor - perfectly suited for an assassin.','',1,1,25,1,1,1,0,0,1,0,0,0,26124),
(12009,'Wow, you\'re insane, aren\'t you?','Wow, you\'re insane, aren\'t you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12010,'I\'m as sane as the next guy, $g fella:lady;. Believe what you will, but I AM capable of fashioning this armor. If you\'re interested, maybe we can make a deal. The sooner I can get out of the assassination business, the better.','',1,1,0,1,1,0,0,0,1,0,0,0,26124),
(12011,'Hey wait, Gadgetzan has a disco?','Hey wait, Gadgetzan has a disco?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12012,'Members only, scrub!\n','',273,25,0,1,1,0,0,0,1,0,0,0,26124),
(12013,'What?  Oh, not this again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12014,'You can\'t do this to me!  We had a deal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12015,'Hello, Rayne. What brings the Cenarion Circle to the Plaguelands?','Hello, Rayne. What brings the Cenarion Circle to the Plaguelands?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12016,'','We are all drawn here for different reasons, $c.$B$B<Rayne smiles.>$B$BI am here to meet with Rimblat of the Earthen Ring. He has some interesting theories on cleansing these lands.',1,1,0,1,1,0,0,0,1,0,0,0,26124),
(12017,'Are these lands not beyond healing? They look pretty beat up.','Are these lands not beyond healing? They look pretty beat up.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12018,'','I think not. Rimblat has already proven that new life can grow from the sundered earth. Now we must find a way to reproduce and, more importantly, sustain the growth.$B$BWhile I am here, I am also offering my services to adventurers entering Naxxramas.',1,1,0,1,1,0,0,0,1,0,0,0,26124),
(12019,'What kind of services?','What kind of services?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12020,'','I am a crafter of some renown, $c. With the proper materials, I am able to craft an armor known as Dreamwalker. Druids - and even some shaman - are drawn to this armor due to its magical properties. Are you interested?',1,1,6,1,1,1,0,0,1,0,0,0,26124),
(12021,'What is Atiesh?\n','What is Atiesh?\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12022,'','Like Kel\'Thuzad, I too was once a mage of the Kirin Tor. And like Kel\'Thuzad, I seek the legendary Atiesh, greatstaff of the Guardian. Our fates are intertwined as such, $c.',1,1,0,1,1,0,0,0,1,0,0,0,26124),
(12023,'What Guardian? I don\'t understand any of this.','What Guardian? I don\'t understand any of this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12024,'','Progeny of Aegwynn, he that would be the last Guardian of Tirisfal... Medivh.',1,0,0,1,0,0,0,0,1,0,0,0,26124),
(12025,'Please continue.','Please continue.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12026,'','It is a story of legend and one that I do not have the time nor the inclination to retell. Just know that Medivh was the last of the Guardians. The greatstaff of Atiesh was a focal point of his power and a focal point of corruption.',1,1,0,1,1,0,0,0,1,0,0,0,26124),
(12027,'What corruption?','What corruption?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12028,'','The corruption of a fallen titan. The corruption of the Destroyer. After all, the staff was forged from the seed of hate. That is, of course, what has brought me here...',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(12029,'Please continue.','Please continue.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12030,'','After the fall of Karazhan, the Kirin Tor dispatched an assembly of mages to search the tower and seize all items of import... for the purposes of \"research.\" It was then that the fabled staff was discovered and brought back to Dalaran.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(12031,'Please continue.','Please continue.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12032,'','What followed were a series of tragic events, leading to the death of every Kirin Tor mage that came into contact with Atiesh.$B$BYou see, it was an artifact with sentience. A sentience granted to it by Sargeras...',1,1,0,1,1,0,0,0,1,0,0,0,26124),
(12033,'What?','What?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12034,'','<Angela nods.>$B$BAfter the deaths, the Six decided that the best course of action was to seal the staff behind impenetrable barriers of magic and appoint a watcher: A guardian of the staff... I would be that watcher.',273,1,0,1,1,0,0,0,1,0,0,0,26124),
(12035,'This is disturbing. Please continue.','This is disturbing. Please continue.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12036,'','There is not much more to tell. Dalaran was nearly wholly destroyed by Archimonde, the staff lost, presumably shattered by the barrier\'s fail-safe mechanisms.$B$BThere are those that believe the staff to be the cause of Archimonde\'s reprisal.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(12037,'Please, tell me more.','Please, tell me more.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12038,'','After the fall of Dalaran, I took my leave from the Kirin Tor. I spent years watching over Atiesh, only to have my purpose amongst the Kirin Tor taken from me in one fell swoop. I would find the staff, though it might take a lifetime. That is how I came to join the Argent Dawn and why I am here now.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(12039,'Is there anything else?','Is there anything else?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12040,'','I have tracked the various fragments of the staff across this world and in doing so, discovered Kel\'Thuzad\'s plans to reform the staff. He has already collected several of the staff\'s fragments - which are being held by his most trusted lieutenants.$B$BI cannot emphasize enough the importance of keeping the greatstaff of the Guardian out of Kel\'Thuzad\'s grasp. Frankly, I do not know what the result would be, other than a catastrophe of epic proportion.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(12041,'What is Plagueheart armor?','What is Plagueheart armor?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12042,'It is power, imbecile.$B$B<Mataus\'s eyes darken.>$B$BThese fools send idiots like you into Naxxramas to retrieve desecrated armor so that they may purify it and restore the pieces to their former glory.$B$B<Mataus spits.>$B$BJust the thought of such utter stupidity brings the bile up to my throat.$B$BI too seek that armor, but in its most foul and desecrated form.','',275,1,25,1,2,2,0,0,1,0,0,0,26124),
(12043,'I also seek such power.','I also seek such power.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12044,'I make no pretenses, maggot. The darkness such items hold could very well destroy the both of us. That is why the price is so high. If I\'m going to die, it\'s going to be as a rich man.$B$BAnd I don\'t give an ounce of gnoll spit how you die, only that you do as I ask. Bring me what I require and we will both benefit - or die, but I\'ve already explained this...','',1,1,274,1,1,1,0,0,1,0,0,0,26124),
(12045,'Tell me about faith, Father.','Tell me about faith, Father.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12046,'Faith... Some have lost it, others have found it. It cannot be destroyed and it cannot be created.$B$BOr perhaps you speak of the vestments of Faith? Armor worn by our priests and most devout warriors into battle against the Scourge during the last war.$B$BAye, much of it is lost... Stolen by the fiends of Naxxramas.','',1,1,0,1,1,0,0,0,1,0,0,0,26124),
(12047,'','Your message did reach us, Commander, but by no means is our involvement here sanctioned by the Grand Crusader.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12048,'Your leader takes residence at the doorstep to Naxxramas. Do you think he does not feel the pressure?\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12049,'%s lowers the sound of his voice to a whisper.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12050,'Even demons are capable of fear...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12051,'Scourge activity in the Plaguelands has increased ten-fold. We are receiving reports of Scourge attacks from as far away as Kalimdor! Now how do you suppose this has happened? How have the wretched undead done that which was previously thought impossible? Is nowhere safe?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12052,'','The heathens will be forced to react. Orcs, bull-men...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12053,'Tauren.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12054,'','Whatever. The revolting, unkempt Horde filth...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12055,'You lack tact, Commander. This is not surprising. However, you are right in that the Horde will be forced to act. But not just the Horde. They already come - heroes from across the world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12056,'','Too little, too late. The dam has broken. We are a bump in the road at best.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12057,'So why are you here? What are we to do if there is no hope?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12058,'There is always... Ashbringer.','There is always... Ashbringer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12059,'Greetings, travelers. I have been instructed to treat any bearer of a key to Karazhan as an honored guest of the Master. Feel free to ask any questions you wish of me. How may I assist you?','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(12060,'We\'re too merciful with the Wretched.  We ought to drive a sword through each of them.$B$BTheir boldness in Sunsail Anchorage is unpardonable.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12061,'','It\'s been a long day of cutting down the mindless Scourge that endlessly parade down the Dead Scar.  I hope you\'re here to lend a hand and not to waste my time with idle chatter.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12062,'So this is what you have come for? To try and claim that which is the reason for the Dawn\'s existence and the Crusade\'s downfall? You open old wounds with your words, Commander!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12063,'The Ashbringer is dead and there will never be another like him. The lesser Mograine is a far cry from the man his father was. You know this, Commander! It was, after all, your own leadership that was responsible for the death of the Scarlet Highlord Mograine. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12064,'Ah, guests of the Master. I hope you\'ve been watching your step in here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12065,'It was your leadership that manipulated a grieving child to try and recover the sword. A child that has grown into a man with nothing but vengeance and hatred in his heart! And for what? You are no closer to the sword now than you were five years ago.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12066,'Yet you think that recovering Ashbringer will somehow turn the tide of battle? Let me let you in on a little secret, Commander: The power of the Ashbringer came from the man who would wield it... I was there, Commander. I watched him burn legions of undead in righteous fire before he would even unsheathe the blade. Alas, your grasp on history is ... lacking.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12067,'Now be silent and note where you are, lest I inform Lord Fordring and his knights that you are no longer here on amicable terms. I am certain he would take great pleasure in seeing to your \'atonement.\'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12070,'','I was just thinking... we really ought to take a trip south one of these nights, maybe have an evening picnic overlooking the fighting at the border? What do you think, milord? Wouldn\'t that just be so exciting?',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(12071,'','Milord, with much of the sin\'dorei nobility regrettably crushed, does that mean that you are likely to receive an elevation soon?  I\'m so excited for you!',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(12072,'','How wonderful. Time for the party to start.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12073,'Damn all these vermin! I don\'t suppose you could help me with this situation?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(12074,'I cannot be teachin\' a Tauren to ride a Raptor.','I cannot be teachin\' a Tauren to ride a Raptor.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12075,'Where can I find crypt fiend parts, Leopold?','Where can I find crypt fiend parts, Leopold?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12076,'Those filthy beasts are all over the place.$B$BIf you prefer hunting outdoors, you\'ll find most of them around Plaguewood and Terrordale, with a good concentration of them in the Terrorweb tunnel. They are also likely to appear at almost any Scourge encampment in the Eastern Plaguelands.$B$BIf you\'re a hearty dungeon crawler, you\'ll find a good lot of them in Stratholme and a few of the necrofiend variety in Scholomance.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(12077,'Where can I find bone fragments?','Where can I find bone fragments?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12078,'Are you daft? Did you miss the BONY SKELETAL CREATURES littering the landscape on your way over here?$B$B<Rohan sighs.>$B$BIf you\'re the outdoor type, you\'ll find skeletal creatures all over both the Western and Eastern Plaguelands. Trust me, you can\'t miss \'em - they certainly won\'t miss you if they get the chance.$B$BIf you\'re a dungeon type, Stratholme and Scholomance are definitely the place to be for bone fragments.','',6,1,1,0,0,0,0,0,1,0,0,0,26124),
(12079,'','Another lovely, gloomy day here in Tranquillien, wouldn\'t you say, $c?$B$BWhat can I do for you?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(12081,'No greater freedom than to soar through the skies, $c. What can I do for you today?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12082,'I\'d like to fly back to Silvermoon City.','I\'d like to fly back to Silvermoon City.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12083,'Hello, friend. How may I be of service to you today?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(12084,'','Heading down to Tranquillien today, $c, or is there something else that I can do for you?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(12085,'Yes, I\'d like to purchase a ride down to the Ghostlands.','Yes, I\'d like to purchase a ride down to the Ghostlands.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12086,'Where can I find core of elements?','Where can I find core of elements?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12087,'','Ah, a good question.$B$BIf you prefer hunting in the great outdoors, there are elementals here in the Plaguelands, Azshara, Burning Steppes, Felwood, Silithus, Winterspring, and even Un\'Goro Crater.$B$BIf you are the type that laughs in the face of danger, then perhaps you should visit Dire Maul. I have heard that a great many elemental abberations exist within its walls. You would also do well in seeking out the elementals employed by the Dark Iron dwarves of Blackrock Depths.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(12088,'Korfax, where can I find Dark Iron scraps?','Korfax, where can I find Dark Iron scraps?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12089,'Is this a serious question? You really don\'t know?$B$BIf you are the cowardly sort, afraid to get their hands too dirty, you will find Dark Iron scraps on the creatures in the Burning Steppes and Searing Gorge.$B$BIf you\'re the bloodthirsty adventuring type, the dungeons of Blackrock Spire and Blackrock Depths hold quite a large supply of the scraps.','',6,1,1,0,0,0,0,0,1,0,0,0,26124),
(12090,'Rayne, where should I look for savage fronds?','Rayne, where should I look for savage fronds?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12091,'','If you are one that prefers to hunt in the outdoor world, both Felwood\'s treants and Un\'Goro\'s lashers are an excellent source of fronds.$B$BIf you are more of a risk-taker, the eastern and western wings of Dire Maul will provide you with a nearly limitless supply of savage fronds.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(12092,'$C, look what they\'ve done to our beloved land. The Scourge must be destroyed!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(12093,'','It\'s going to take a bit of work, but I think we can save this blood elf\'s life.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12094,'Who are you?  I feel... so... cold.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12095,'','It is shameful that we sin\'dorei have lost so much of what we used to call home.  It shall not be long before we regain our strength and retake our southern lands back from the Scourge!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12096,'I\'m far too busy to be playing \'guess the smell\' with you, $r. State your business or get out of my sight!','',25,1,1,0,0,0,0,0,1,0,0,0,26124),
(12097,'The high executor and Dame Auriferous are making me wait, but I don\'t have time for this! My friends are out there dying, $c!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(12098,'','I sent Ranger Salissa south to the enclave and Ranger Lethvalin west to Tranquillien more than a day ago! Have you seen either of them? Are you the aid that\'s been sent back?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12099,'Sometimes it feels like I\'ll never go back to being a simple functionary in service to Dame Auriferous. I\'m not cut out for war.$B$BThankfully there are those like you who burn to see Quel\'Thalas restored to its former beauty. Crush the Scourge, $c! Crush them wherever you can!','',1,5,0,0,500,0,0,0,1,0,0,0,26124),
(12100,'Ah, here\'s the $g hero : heroine; of the hour now! Good to see you again, $n! I trust that you\'re still destroying the Scourge wherever you find them?','',71,0,0,0,0,0,0,0,1,0,0,0,26124),
(12101,'','I\'m sure that help from Farstrider Enclave will be here soon to help me and this useless lieutenant get to safety. You might not want to stick around; I\'ve heard all sorts of strange sounds coming from the lake and that village over yonder.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12102,'I received word that you were able to help Ranger Valanna and the lieutenant at Zeb\'Sora.$B$BThank you, $c. I suppose I should make my way back to Farstrider Enclave now.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12103,'What business brings you here, $c?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12104,'What can I help you find?','What can I help you find?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12105,'Alright, everything looks in order. Let\'s get this show on the road.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12106,'Ah, hello there, $r. As you can see, I\'m not open for business quite yet. Now, if you\'ll excuse me, I\'m very busy.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12107,'Such a delight to see you again, $c. No, really. You\'re the reason that I\'m making money here, hand over fist.$B$BNow, what can I sell to you today?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12108,'','Welcome to Tranquillien, $c. I apologize for the state that you find it in. As you can see, we\'ve been having some trouble, but the Forsaken, and their Lady Sylvanas Windrunner, have been gracious enough to lend us a great deal of assistance in our time of need.$B$BIf you can lend a hand please do not hesitate to do so. We can use all of the help that we can get in our struggle against the myriad forces arrayed against us.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12109,'The time has come for Horde and Alliance to look towards Northrend and the invasion of the Lich King. In recent days, territories across Kalimdor and the Eastern Kingdoms have come under attack. Will you take up arms to save your land from destruction at their hands?','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(12110,'Don\'t be afraid of the sword, nubling. It\'s the mutton that gets ya!','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(12111,'This cultist is in a deep trance...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12112,'Use 8 necrotic runes and disrupt his ritual.','Use 8 necrotic runes and disrupt his ritual.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12113,'Onward! The front lines await!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12114,'Whew! That was some hard work, $r. I haven\'t seen the Scourge this aggressive since...$B$B<Guard Didier swallows hard.>$B$BSince the last war...','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(12115,'Look out... the night elves are back!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12116,'Terrible thing, what happened to them mules... Metz is gonna have my hide for this failure.','',18,1,0,0,0,0,0,0,1,0,0,0,26124),
(12117,'','You won\'t get away this time!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(12118,'Poor little donkey. It was only a wee lad.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12119,'','It is very important that we find out what the the night elves are up to, $c! Please concentrate all of your efforts toward that end.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12120,'','We are most pleased with your actions against the night elves. When you uncovered their plot to use the ley-line nexi and their so-called moon crystals to spy upon us, you strengthened our position here by an order of magnitude.$B$BYou have our gratitude, $n.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12121,'Are you the reinforcements? The night elves have been routed!','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(12122,'Good thing that you deactivated the moon crystal at An\'owyn when you did, $c! Come around any time you feel like pitching in with my research here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12123,'Name, rank and serial number, soldier.\n','',25,6,0,1,1,1,0,0,1,0,0,0,26124),
(12124,'Yes, sir! Thank you, sir!','Yes, sir! Thank you, sir!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12125,'<Field Marshal Chambers growls.>$B$BSo you\'re the riff-raff that assisted Didier in getting the supplies here in one piece? Where are the rest of you? I know there\'s gotta be more. Chickens like you generally roam in huge packs.$B$BBah, just give me the damned writ so I can sign off on it.\n','',6,25,1,1,1,1,0,0,1,0,0,0,26124),
(12126,'Job well done, soldier. Dismissed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12127,'Alright, I\'ll sign writs now. Bring \'em to the front, maggots.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12128,'I think I hear something! Chambers must be coming. Make way! Make way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12129,'How can I work under these conditions?! And all of these disgusting Forsaken around here! I weep for Tranquillien and Quel\'Thalas!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12130,'Yes... what do you want, $r? Can\'t you see I am busy here?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(12131,'$R, report! What news of significance do you bring? Be quick about your business... Dame Auriferous and I are in the middle of a strategic discussion.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12132,'','Ok, you had the fish platter, Commander. Enjoy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12133,'','Father, you had the bowl of fruit? Right?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12134,'','And for the ladies, roast baby boar. Enjoy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12135,'','Please let me know if you need anything else!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12136,'','Welcome to Light\'s Hope Chapel, stranger.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12137,'My compliments to the chef!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12138,'The fish is exquisite, Jessica.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12139,'Delicious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12140,'Thank you, Mrs. Chambers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12141,'Is this a mango? Stupendous!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12142,'You\'ve really outdone yourself this time, Mrs. Chambers. Not a spot of mold to be found!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12143,'','Thank you, Jessica.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12144,'','And might I add, that dress is lovely! You must tell me where you got it from.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12145,'','Indeed... lovely dress, Jessica.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12146,'','The boar is superb!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12147,'','Oh, quite succulent. Many thanks, Mrs. Chambers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12148,'Our caravans go out \'bout twice a day, but I\'ll be damned if the Scourge haven\'t gone out of their way to stop Didier and his mules from getting shipments to the front lines. Craziest thing I\'ve ever seen. If only we had the heroic adventurin\' types to help protect the shipments...','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(12149,'The pain...the need...I hunger for more...','The pain...the need...I hunger for more...',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(12150,'More, more, more!  I must feed soon.','More, more, more!  I must feed soon.',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(12151,'I cannot stand the pain.  I must find a new source.','I cannot stand the pain.  I must find a new source.',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(12152,'I\'ve got too much to do and not enough time to do it in, $r! Please, get out of my way.','I\'ve got too much to do and not enough time to do it in, $r! Please, get out of my way.',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(12153,'I\'ve got too much to do and not enough time to do it in, $r! Please, get out of my way.$B$BIf you\'re infected with the maggot slime or ghoul rot, I might be able to help you.','I\'ve got too much to do and not enough time to do it in, $r! Please, get out of my way.$B$BIf you\'re infected with the maggot slime or ghoul rot, I might be able to help you.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(12154,'I am diseased. Please cure me, medic.','I am diseased. Please cure me, medic.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12155,'%s is jolted back to life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12156,'%s loses its link!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12157,'That could have gone better. $n, come here, please. I have something I need you to take care of for me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12158,'<The blood elf quickly regains consciousness as you pour the draught into his mouth.>$B$BI owe you my life, $c.  Without your help I would\'ve succumbed to the Scourge\'s painful torture.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12159,'<Administer the restorative draught.>','<Administer the restorative draught.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12160,'<The blood elf lies on the floor in some manner of induced torpor.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12161,'Greetings, $r.  I am Ambassador Sunsorrow of the sin\'dorei, or blood elves as we are commonly known.  I have high hopes that this new bond between us and the Horde will be mutually beneficial.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(12162,'You\'re free to go now.  The way out is safe.','You\'re free to go now.  The way out is safe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12163,'','<The Forsaken female is curled up on the floor, her face in a grimace.  She does not appear capable of getting up on her own at the moment.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12164,'','Ahhhhggg... this pain in my head is killing me.$B$BThey must\'ve sent you to rescue me.  Took them long enough!  Do you have any idea of the things they do to prisoners here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12165,'A bit ungrateful, aren\'t we?  The way out is clear, flee quickly!','A bit ungrateful, aren\'t we?  The way out is clear, flee quickly!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12166,'<The blood elf lies limp on the table.  While he\'s still breathing, he appears to have been the victim of potent sedative toxins.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12167,'Well met, $r. I am here as a resource of advice for the High Executor to make use of as he will. I am confident that together we can forge the Horde into something that is even stronger than before and turn back the Scourge menace once and for all!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12168,'<Varnis coughs violently as the restorative draught takes effect.>$B$BThank you for rescuing me.  I must go back to Tranquillien at once!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12169,'The drafts of fresh air that blow from Eversong from time to time really upset my stomach, if you know what I mean.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12170,'I seek a sample of your restorative draught, apothecary.','I seek a sample of your restorative draught, apothecary.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12171,'','If it is a matter of import that you wish to speak on, $c, it may be more appropriate to seek an audience with Dame Auriferous. I warn you though, she is very busy and you may be in for quite a wait.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12172,'','Normally it would not be my place to speak with you directly; rather, you would seek an audience with milady. However, I did give you a task directly, so what is it that we need to discuss?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12173,'','$C, Dame Auriferous has conveyed to me her great pleasure in the service that you have done us in the past. She wishes to extend to you her hope that you will continue to be a champion of sin\'dorei interests here in the Ghostlands.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12174,'%s rushes to the aid of Feugen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12176,'What\'s happening?','What\'s happening?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(12177,'This sign contains various announcements and notices of rewards.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12178,'%s overloads!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12179,'','We\'ve important work to do, $n.  Let us attack our enemies while their guard is down.  Let us show them that sin\'dorei vengeance never forgets nor forgives.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12180,'The tides of war have come again. From the cold north, the Lich King\'s necropolises have laid siege to our lands.  He sends flying necropolises to invade across the world.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(12181,'','Well this is troublesome! How am I supposed to collect the ore samples for the magisters if the mines have been overrun with gnoll vermin?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12182,'','Thanks for getting that ore and taking it to Magister Quallestis, $c. I suppose that I should head back, but I\'m afraid of the punishment I\'m going to receive because I couldn\'t get the ore myself.$B$BDon\'t tell the magister, ok?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12183,'Where could she possibly be? I sent my apprentice, Shatharia, to the Underlight Mines to the west quite some time ago. We need those ore samples back, and fast or our experiment is going to fail!','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(12184,'Without delivery of the Underlight ore in such a timely fashion, our research would have failed.$B$BJust wait until Shatharia shows her head here again. I\'ve got some interesting tasks for her, you can be sure of it!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12185,'','Sin\'dorei have lost far too much in the past years.  Our land, our homes, even our identities...$B$BIt\'s about time we started taking it all back.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12186,'Before we can overcome external obstacles like the Scourge and the Amani trolls, we must overcome obstacles from within.  The Wretched have been a nuisance for long enough; it is time we vanquished them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12187,'','$n, let\'s use the antechamber to the right.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12188,'','I can see the light at the end of the tunnel!',25,0,0,0,0,0,0,1,1,0,0,0,26124),
(12189,'','There\'s Farstrider Enclave now, $c. Not far to go... look out!  Troll ambush!!',1,5,0,0,500,0,0,1,1,0,0,0,26124),
(12190,'','Captain Helios, I\'ve been rescued from the Amani Catacombs. Reporting for duty, sir!',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12191,'','Thank you for saving my life and bringing me back to safety, $n!',2,0,0,0,0,0,0,1,1,0,0,0,26124),
(12192,'%s nods in relief to Ranger Lilatha and her escort.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12193,'Lilatha, get someone to look at those injuries. Thank you for bringing her back safely.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12194,'','Think you could help me to get out of here?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(12195,'%s dies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12196,'Amongst the various pieces of parchment containing checklists and other information from the Farstriders, one stands out. It is a drawing of a hideous troll, perhaps the most fearsome creature that you have ever seen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12197,'OH NO YOU DIDN\'! ITS ON NOW! <PH>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12198,'Is Winterspring currently under attack?','Is Winterspring currently under attack?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(12199,'Indeed, the hills of Winterspring are currently attempting to withstand a renewed Scourge assault. Your assistance would help them greatly.$B$BNumber of Necropolises remaining: $2284W','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(12200,'For the time being, that area is free of Scourge influence. I fear it will only be a matter of time before they return.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12201,'Is Tanaris currently under attack?','Is Tanaris currently under attack?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(12202,'It seems the army of the Scourge has come to Tanaris. A significant number of their necropolises and other forces have been dispatched there.$B$BNumber of Necropolises remaining: $2283W','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(12203,'Are the Blasted Lands currently under attack?','Are the Blasted Lands currently under attack?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(12204,'The Scourge infestation grows in the Blasted Lands. Every able bodied warrior is needed to stem the tide of their invasion.$B$BNumber of Necropolises remaining: $2280W','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(12205,'Are the Burning Steppes currently under attack?','Are the Burning Steppes currently under attack?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(12206,'If additional support is not soon sent to the Burning Steppes, I fear the Scourge will establish a base of operations there. If you can, you should go there to aid the defenders.$B$BNumber of Necropolises remaining: $2281W','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(12207,'What can I do?','What can I do?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(12208,'','Many an advantage can be gained from getting to know your enemy.  Take that lesson to heart, $n.$B$BThe more we learn about the Scourge the better prepared we are to defeat them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12209,'The Scourge are establishing small staging points in the places under attack, receiving communications and other assistance from the necropolises that fly overhead. From what we can tell, the only way to root them out is by killing the ground forces that surround the points.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12210,'','You\'re welcome to stay at the Farstrider Enclave for as long as you\'d like, $c.  We welcome any who would aid us in our endeavors in the Ghostlands.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12211,'Stray arcane forces can do strange things to the land, the elements and even the spirits of the dead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12212,'The High Executor is a very busy man, $c.  Maybe I can help you with whatever you need?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12213,'You\'ve done us exemplary service, $n. Between dealing with the gnolls at the Underlight Mines, and the mummified trolls in the Amani Catacombs, you\'ve dealt a mighty blow to our enemies!$B$B$G Good job! : We should get together for drinks sometime, what do you say?;','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12214,'Good to see you again, $g man! : gorgeous!; I think we would work well together; $g see you around. : I hope we get to do so.;','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(12215,'Word got back to me through channels concerning Lady Sylvanas\'s reaction to you and the recovery of her necklace. I still think you did the right thing; don\'t worry too much about how the lady reacted.$B$BNow, state your business.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12216,'What can I say, $c? You\'re a true $g hero : heroine;! Not only have you personally saved many of my rangers, but you\'ve dealt a decisive blow against the Shadowpine trolls. Are you sure that you don\'t want to stay here and be one of my Farstriders?$B$BFare well, $n.','',1,2,0,0,1000,0,0,0,1,0,0,0,26124),
(12217,'You\'re a one-$g man : woman; rescue machine. That\'s three of my Farstriders that you\'ve saved now!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12218,'Your help with the Shadowpine trolls is proving invaluable, $c. Keep this up and maybe we\'ll be able to turn our attention back to dealing with the Scourge.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12219,'You\'ve dealt the decisive blow against the Shadowpine trolls, $n. I only hope that we can muster our forces quickly enough to finish them off before they receive reinforcements from Zul\'Aman.$B$BIt would be nice if Tranquillien were to reinforce us.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12220,'','Thanks, I should\'ve never left Silverpine Forest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12221,'You have my thanks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12222,'Th... thank you.  I thought I was going to die.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12223,'Death is the price you shall pay for this insolence!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12224,'Mortal fools!  The ghouls of Deatholme will feast on your remains!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12225,'Your deaths shall be slow and painful!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12226,'Miranda, could you please tell me the insignia cost of items that you are offering for adventurers with other reputations?','Miranda, could you please tell me the insignia cost of items that you are offering for adventurers with other reputations?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12227,'','Certainly, $n. You only need to tell me what reputation you would like to know about.\n',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(12228,'Miranda, could you please tell me the insignia cost of items that you are offering for adventurers of honored reputation?','Miranda, could you please tell me the insignia cost of items that you are offering for adventurers of honored reputation?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12229,'','Certainly, $n.$B$BAdventurers that the Dawn views as honored must submit a combined total of 40 insignias to access superior items. To access items of even greater power, they would be required to submit a total of 150 insignias.$B$BI must admit, the price is high even for those honored amongst the Dawn.\n',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(12230,'Arcanist Vandril, what are the Forsaken doing here?','Arcanist Vandril, what are the Forsaken doing here?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(12231,'Miranda, could you please tell me the insignia cost of items that you are offering for adventurers of revered reputation?','Miranda, could you please tell me the insignia cost of items that you are offering for adventurers of revered reputation?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12232,'','Certainly, $n.$B$BAdventurers that the Dawn views as revered must submit a combined total of 14 insignias to access superior items. To access items of even greater power, they would be required to submit a total of 90 insignias.$B$BThose that are revered by the Dawn will find the cost of superior items quite reasonable! The cost for the more powerful items is still high.\n',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(12233,'The situation is more grim than many have been led to believe. The Forsaken are here as allies in the fight against our common enemy, the Scourge.$B$BTrust me when I say this, without them the Ghostlands would be lost and the Scourge would already have overrun all of Eversong Woods!$B$BBut more than anything else, we need your help in reclaiming our once proud lands!','',1,5,0,0,500,0,0,0,1,0,0,0,26124),
(12234,'Miranda, could you please tell me the insignia cost of items that you are offering for adventurers of exalted reputation?','Miranda, could you please tell me the insignia cost of items that you are offering for adventurers of exalted reputation?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12235,'','Certainly, $n.$B$BAdventurers that the Dawn views as exalted must submit a combined total of 12 insignias to access superior items. To access items of even greater power, they would be required to submit a total of 54 insignias.$B$BThose exalted in the eyes of the Dawn receive the greatest discounts.\n',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(12236,'','Certainly, $n.$B$BAdventurers that the Dawn views as friendly must submit a combined total of 60 insignias to access superior items. To access items of even greater power, they would be required to submit a total of 220 insignias.$B$BI must admit, the price is quite high for adventurers not favored by the Dawn.\n',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(12237,'Friendly.','Friendly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12238,'Honored.','Honored.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12239,'Revered.','Revered.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12240,'Exalted.','Exalted.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12241,'I have another question.','I have another question.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12242,'%s spots a zombie to devour!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12243,'You will not stop our deepening shadow, $c.  Now... join us!  Join the ranks of the Chosen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12244,'These Runestones protect the lands in Eversong from becoming tainted by the Scourge.  The Western Runestone failed long ago, forcing us to burn the ground around it.$B$BAs long as I live I won\'t allow the remaining Runestones to fail us.  That is my oath.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12245,'','Well, you didn\'t come all this way out here to jaw over a cup of tea. Let\'s see how you might be able to help get us out of this situation.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12246,'There are those who would say that the Argent Crusade is a thing of the past.  I am one of them, but not because the Scourge have fallen.$b$bNo... it is because of their stubborn ways.  They\'ve become too much like the church that they seceded from: too rigid, too governed by honor and order.  This is what I\'m trying to tell Barthalomew, anyhow.$b$bSure, it may sound a bit jingoistic, but it makes for a good debate.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(12247,'Is this the best they could do?$B$B<Omarion musters the strength to laugh.>$B$BYou do not possess the resolve to face a monster like Kel\'Thuzad. You will crumble before his minions - just like those that have come before you...$B$BLeave me here to die. I refuse to return to a world that champions the likes of you.\n','',6,1,1,0,0,0,0,0,1,0,0,0,26124),
(12248,'Could it be? One that passes through these halls with a purpose? Aye, a righteous fire burns in your belly, $r.$B$BMy life may soon end, but the knowledge I hold must be shared with the world. It is, after all, why I am here now.$B$BAre you a master of a trade?\n','',6,1,1,0,0,0,0,0,1,0,0,0,26124),
(12249,'You honor me with your presence, $r. Alas, it is too late for me. I pass from this world soon, but... I know so much. So much is in this head of mine. So much that could help this world fend off the beasts of this citadel of depravity.$B$BPerhaps if you are a master of a trade... Yes, perhaps you would take the knowledge I hold and use it to save this world.\n','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(12251,'I am a master tailor, Omarion.','I am a master tailor, Omarion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12252,'A tailor, eh? Very well. What would you like to learn about, tailor?','',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(12253,'Glacial Vest.','Glacial Vest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12254,'Glacial Cloak.','Glacial Cloak.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12255,'Glacial Gloves.','Glacial Gloves.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12256,'Glacial Wrists.','Glacial Wrists.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12257,'I am a master leatherworker, Omarion.','I am a master leatherworker, Omarion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12258,'Perhaps I can teach you something...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12259,'Icy Scale Breastplate.','Icy Scale Breastplate.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12260,'Icy Scale Gauntlets.','Icy Scale Gauntlets.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12261,'Icy Scale Bracers.','Icy Scale Bracers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12262,'Polar Tunic.','Polar Tunic.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12263,'Polar Gloves.','Polar Gloves.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12264,'Polar Bracers.','Polar Bracers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12265,'I have what you need, $c.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12266,'Icebane Breastplate.','Icebane Breastplate.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12267,'Icebane Gauntlets.','Icebane Gauntlets.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12268,'Icebane Bracers.','Icebane Bracers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12269,'I am a master blacksmith, Omarion.','I am a master blacksmith, Omarion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12270,'I need to go. Evil stirs. Die well, Omarion.','I need to go. Evil stirs. Die well, Omarion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12271,'Show me where I can fly.','Show me where I can fly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12272,'%s releases the last of its energies into the nearby runestone, successfully reactivating it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12273,'Master craftsman Omarion just vanished one night. Like a toot in the wind... Poof! Gone! Bah, now I\'m the only one left to craft the goods for the boys on the front lines. ','',1,14,1,0,0,0,0,0,1,0,0,0,26124),
(12274,'Show me your wares, Wilhelm.','Show me your wares, Wilhelm.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12275,'Your actions will not be tolerated!','Your actions will not be tolerated!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12276,'You will abide by our rules around here, miscreant!','You will abide by our rules around here, miscreant!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12277,'Lay down your weapons, your feuds have no place here!','Lay down your weapons, your feuds have no place here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12278,'Sin\'dorei and Forsaken share a common goal in the Ghostlands, $n.  Together we shall defeat the Scourge and who knows... perhaps the Forsaken will be valuable allies in our quest to reach Outland.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12279,'Omarion, I am not a craftsman. Can you still help me?','Omarion, I am not a craftsman. Can you still help me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12280,'<Omarion grumbles something under his breath.>$B$BBut of course I can help you, dear $g boy:girl;. It is my dying wish... my final desire. Please, take this handbook. The information on its pages are a compilation of all that I know and have learned in the past 30 some-odd years of my miserable life. Give the handbook to that good for nothing apprentice of mine that\'s probably sitting on his fat duff at Light\'s Hope Chapel.','',14,1,1,0,0,0,0,0,1,0,0,0,26124),
(12281,'Thank you, Omarion. You have taken a fatal blow for the team on this day.','Thank you, Omarion. You have taken a fatal blow for the team on this day.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12282,'<Tarsis groans.>$B$BThere may still be time... Listen closely, mortal.$B$BThrough time and across the Nether I have searched. Deals made with a host of evil and villainy so wretched...$B$B<Tarsis coughs blood into his hands.>$B$BWould you... would you believe that even Elune has turned her back on me, $r? To die here, in this manner now...','',1,7,6,0,3,4,0,0,1,0,0,0,26124),
(12283,'What are you talking about, mage?','What are you talking about, mage?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12284,'The things I have done... such horrible things...$B$B<Tarsis begins to sob.>\n','',1,18,0,0,0,0,0,0,1,0,0,0,26124),
(12285,'Why have you done such horrible things?\n','Why have you done such horrible things?\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12286,'I am Highborne, $r. It has no meaning now. There was a time, though, when this world was ruled by Highborne. Ten thousand years past...','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(12287,'I still do not understand.','I still do not understand.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12288,'I would have it back, mortal. Atiesh... From it I would create the Highborne anew. I would have it all back. Even the Queen...','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(12289,'You are talking nonsense, mage. ','You are talking nonsense, mage. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12290,'<Tarsis grabs you weakly by the collar. Even in death you see power unimaginable in his eyes.>$B$BAm I? Then listen closely, for more nonsense is about to escape my lips. Within this citadel you will find my life\'s work: The exact location of every fragment of the splintered staff.','',53,273,0,0,0,0,0,0,1,0,0,0,26124),
(12291,'What staff?','What staff?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12292,'Atiesh, Greatstaff of the Guardian. The staff handed down through the ages to each of the Guardians of Tirisfal. The staff corrupted by Sargeras. The staff of the last Guardian. The staff of Medivh.\n','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(12293,'You said you would have it back. What does that mean?','You said you would have it back. What does that mean?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12294,'<Tarsis\'s eyes light up.>$B$BI held it once... I held it despite the warnings of the Kirin Tor. I held it, mortal... Power unending. Power to do what I desired, as I desired. And just as quickly, it was taken from me. But I had tasted... And that taste was all that it took.  ','',1,1,273,0,0,0,0,0,1,0,0,0,26124),
(12295,'%s gets to one knee.','%s gets to one knee.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12296,'%s sits down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12297,'<Tarsis is badly injured.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12298,'<Wake Tarsis up.>','<Wake Tarsis up.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12299,'The battle is won. For the time being, the Scourge threat has been pushed back. Our resources can be channeled into aiding you, in thanks and preparation for the future.','The battle is won. For the time being, the Scourge threat has been pushed back. Our resources can be channeled into aiding you, in thanks and preparation for the future.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(12300,'The battle goes well. The Scourge forces seem weakened. I believe it will only be a matter of time before we drive them from our shores. I will turn my magics to you, to aid in this struggle.','The battle goes well. The Scourge forces seem weakened. I believe it will only be a matter of time before we drive them from our shores. I will turn my magics to you, to aid in this struggle.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(12301,'The first steps of our fight against the Scourge go well. We have had some successes, and hopefully my assistance can aid you in bringing future success to the battle.','The first steps of our fight against the Scourge go well. We have had some successes, and hopefully my assistance can aid you in bringing future success to the battle.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(12302,'Give me one of your magic items.','Give me one of your magic items.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12303,'I put at your disposal whatever assistance I can offer.','I put at your disposal whatever assistance I can offer.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(12304,'What happened to the staff?','What happened to the staff?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12305,'It was lost when the Violet Citadel fell... splintered into forty-two pieces.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12306,'So what has led you to Naxxramas?','So what has led you to Naxxramas?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12307,'Kel\'Thuzad has put forth considerable effort in attempting to reform the staff. The pieces were once scattered across this world, from Kalimdor to the South Seas. I myself held twenty of the pieces at one point in time - until they were stolen from me by Kel\'Thuzad\'s minions. It is why I am here.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(12308,'So Kel\'Thuzad holds all of the pieces?','So Kel\'Thuzad holds all of the pieces?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12309,'Haven\'t you been listening? No, I very much doubt we would be having this conversation had Kel\'Thuzad formed the staff. Kel\'Thuzad holds the head. His underlings hold forty splinters of Atiesh. The last piece - the base - was uncovered by Brann Bronzebeard. He was last seen in the Silithus desert; undoubtedly doing his best to stay as far away as possible from the relentless seekers Kel\'Thuzad has dispatched into the world.','',274,1,1,0,0,0,0,0,1,0,0,0,26124),
(12310,'To arms!  Scourge spotted in the Cathedral of Light!','To arms!  Scourge spotted in the Cathedral of Light!',5,0,0,0,0,0,0,7,1,0,0,0,26124),
(12311,'Scourge in the Trade District!  Have at them!','Scourge in the Trade District!  Have at them!',5,0,0,0,0,0,0,7,1,0,0,0,26124),
(12312,'You... The frame! How? You must not... It... the Destroyer...','',5,274,0,0,0,0,0,0,1,0,0,0,26124),
(12313,'What is it Tarsis? I don\'t know what to do!','What is it Tarsis? I don\'t know what to do!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12314,'%s scratches at his throat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12315,'Light help us... the Scourge are in the Park!','Light help us... the Scourge are in the Park!',5,0,0,0,0,0,0,7,1,0,0,0,26124),
(12316,'The Scourge are at the castle entrance!  For Stormwind!  For King Anduin!','The Scourge are at the castle entrance!  For Stormwind!  For King Anduin!',5,0,0,0,0,0,0,7,1,0,0,0,26124),
(12317,'Hold the line!  Protect the King at all costs!','',5,0,0,0,0,0,0,7,1,0,0,0,26124),
(12318,'Good work, one and all!  The Scourge at the castle have been defeated.','',71,0,0,0,0,0,0,7,1,0,0,0,26124),
(12320,'','%s scratches at her throat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12321,'','What have you done? FOOL! You brought it... NO!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12322,'%s flaps down from the ceiling...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12323,'%s howls through the halls...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12324,'%s skitters out from the shadows...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12325,'We come destroy puny ones!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12326,'The Lich King say to tell you... DIE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12327,'Raaarrrrggghhh!  We come for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12328,'Hahaha, your guards no match for Scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12329,'What?  This not Naxxramas!  We not like this place... destroy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12330,'You spare parts!  We make more Scourge in necropolis.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12331,'','The Scourge attack against my court has been eliminated.  You may go about your business.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12332,'','My Royal Dreadguard, you will deal with this matter as befits your station.  That, or you will wish that you had.',5,0,0,0,0,0,0,1,1,0,0,0,26124),
(12333,'Dreadguard, hold your line.  Halt the advance of those Scourge!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12334,'Scourge in sewers!  We need help!','',5,0,0,0,0,0,0,1,1,0,0,0,26124),
(12335,'Scourge attack Magic Quarter!','',5,0,0,0,0,0,0,1,1,0,0,0,26124),
(12336,'Rogues\' Quarter attacked by Scourge!  Help!','',5,0,0,0,0,0,0,1,1,0,0,0,26124),
(12337,'The Scourge are at the entrance to the Royal Quarter!  Kill them!!','The Scourge are at the entrance to the Royal Quarter!  Kill them!!',5,0,0,0,0,0,0,1,1,0,0,0,26124),
(12338,'%s drops its weapon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12339,'Our Sanctums syphon arcane power from ley-line currents that traverse our lands invisible to the naked eye.$B$BWith the Sunwell gone, they provide us with a steady and reliable source of energy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12340,'It\'s a testament to our race\'s tenacity that Fairbreeze Village still stands.  We shall never concede defeat to the Scourge ever again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12341,'Gangway, ye scurvy dog!  Revilgaz has spared me from the gallows but my punishment might be nearly as bad.','Gangway, ye scurvy dog!  Revilgaz has spared me from the gallows but my punishment might be nearly as bad.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12342,'Why you run away? We make your corpse into Scourge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12343,'No worry, we find you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12344,'','You\'d better not be causing trouble, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12345,'What can I do for you, $n?  Make it quick, I don\'t have all day!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12346,'What can I do for you?  No, wait!  What can you do for me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12347,'%s belches out a disgusting Bile Sludge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12348,'%s devours all nearby zombies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12349,'The Stormpike forces gain the General\'s Warcry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12350,'The Frostwolf forces gain the General\'s Warcry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12351,'Take no prisoners! Drive these heathens from our lands!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12352,'Leave no survivors!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12353,'There Scourge outside Trade Quarter!','',5,0,0,0,0,0,0,1,1,0,0,0,26124),
(12354,'Scourge inside Trade Quarter!  Destroy!','',5,0,0,0,0,0,0,1,1,0,0,0,26124),
(12355,'Scourge spotted nearby!','Scourge spotted nearby!',5,0,0,0,0,0,0,1,1,0,0,0,26124),
(12356,'I just saw a Scourge!  Kill it!','I just saw a Scourge!  Kill it!',5,0,0,0,0,0,0,1,1,0,0,0,26124),
(12357,'Did you see that?  There\'s a Scourge over there!','Did you see that?  There\'s a Scourge over there!',5,0,0,0,0,0,0,1,1,0,0,0,26124),
(12358,'How can I get anything done with the Scourge running amok in here?!','How can I get anything done with the Scourge running amok in here?!',5,0,0,0,0,0,0,1,1,0,0,0,26124),
(12359,'There\'s one of the Scourge, right over there!','There\'s one of the Scourge, right over there!',5,0,0,0,0,0,0,1,1,0,0,0,26124),
(12360,'This has gone too far.  How dare the Scourge attack Undercity!  Destroy it before more come!','This has gone too far.  How dare the Scourge attack Undercity!  Destroy it before more come!',5,0,0,0,0,0,0,1,1,0,0,0,26124),
(12361,'Will these unrelenting Scourge attacks never end?','Will these unrelenting Scourge attacks never end?',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(12362,'Destroy the Scourge invader now, before it\'s too late!','Destroy the Scourge invader now, before it\'s too late!',5,0,0,0,0,0,0,1,1,0,0,0,26124),
(12363,'I desire this eternal quintessence, Duke Hydraxis.','I desire this eternal quintessence, Duke Hydraxis.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12364,'You\'ve served our cause with great loyalty, $n.  Allow me to present you with an unending source of our elemental quintessence.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12365,'Welcome back, $n.  You\'ve proven a worthy ally against Ragnaros and your presence is always welcome among us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12366,'Scourge spotted nearby!','Scourge spotted nearby!',5,0,0,0,0,0,0,7,1,0,0,0,26124),
(12367,'I just saw a Scourge!  Kill it!','I just saw a Scourge!  Kill it!',5,0,0,0,0,0,0,7,1,0,0,0,26124),
(12368,'Did you see that?  There\'s a Scourge over there!','Did you see that?  There\'s a Scourge over there!',5,0,0,0,0,0,0,7,1,0,0,0,26124),
(12369,'How can I get anything done with the Scourge running amok around here?!','How can I get anything done with the Scourge running amok around here?!',5,0,0,0,0,0,0,7,1,0,0,0,26124),
(12370,'There\'s one of the Scourge, right over there!','There\'s one of the Scourge, right over there!',5,0,0,0,0,0,0,7,1,0,0,0,26124),
(12371,'This has gone too far.  How dare the Scourge attack Stormwind!  Destroy it before more come!','This has gone too far.  How dare the Scourge attack Stormwind!  Destroy it before more come!',5,0,0,0,0,0,0,7,1,0,0,0,26124),
(12372,'Will these unrelenting Scourge attacks never end?','Will these unrelenting Scourge attacks never end?',6,0,0,0,0,0,0,7,1,0,0,0,26124),
(12373,'Destroy the Scourge invader now, before it\'s too late!','Destroy the Scourge invader now, before it\'s too late!',5,0,0,0,0,0,0,7,1,0,0,0,26124),
(12374,'The dead walk among us!','The dead walk among us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12375,'You hold evil in your hands, fool! REPENT!','You hold evil in your hands, fool! REPENT!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12376,'You risk destroying us all, $r! You must be terminated!','You risk destroying us all, $r! You must be terminated!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12377,'This is holy ground, heathen.','This is holy ground, heathen.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12378,'Ashbringer...','Ashbringer...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12379,'Kneel! Kneel before the Ashbringer!','Kneel! Kneel before the Ashbringer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12380,'I am unworthy, $g sir:ma\'am;.','I am unworthy, $g sir:ma\'am;.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12381,'Have you come to save this world? To cleanse it?','Have you come to save this world? To cleanse it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12382,'My $g Lord:Lady;, please allow me to live long enough to see you purge this world of the infidels.','My $g Lord:Lady;, please allow me to live long enough to see you purge this world of the infidels.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12383,'And so it begins...','And so it begins...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12384,'Take me with you, $g sir:ma\'am;.','Take me with you, $g sir:ma\'am;.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12385,'Port back to center','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12386,'I look into the eye...','I look into the eye...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12387,'Oh Rly? <PH>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12388,'Ya Rly! <PH>','Ya Rly! <PH>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12389,'Bow down! Kneel before the Ashbringer! A new dawn approaches, brothers and sisters! Our message will be delivered to the filth of this world through the chosen one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12390,'You hold my father\'s blade, $n. My soldiers are yours to control, my $g Lord:Lady;. Take them... Lead them... The impure must be purged. They must be cleansed of their taint.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12391,'%s flees after seeing Kel\'Thuzad fall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12392,'Phase 3! <PH>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12393,'','Let\'s go.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12394,'Dar\'Khan thinks we\'ll roll over for the Scourge without putting up a fight.  We shall prove him wrong, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12395,'Can\'t you see that I\'m trying to have a conversation with the lady?  Oh, very well, she seems preoccupied anyway.$B$BI deal in only the finest drinks, both local and exotic in vintage.  Care to have a look?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12397,'Is that a list from Saltheril\'s Haven?  No doubt, his lordship will require a bottle of my finest.  And, of course, any friend of Lord Saltheril deserves a special price on such a fine vintage.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(12398,'How many battles have we won?','How many battles have we won?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12399,'We have won $2219W battles against the Scourge.  Gird yourself, $n, for this war is far from over.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12400,'','If you have the coin, I have the food and drink to keep that appetite of yours satisfied.  Every copper goes to keeping the Retreat in tip-top shape.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12401,'','Is that a list from Lord Saltheril that you have there? Yes, I can sell you a batch of appetizers, fresh off the fire.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(12402,'We have won $2219W battles against the Scourge.  Take heart, $n.  While many battles lie ahead, heroes, heroes from every realm have risen to fight them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12403,'We have won $2219W battles against the Scourge.  Stand firm, $n!  We must persevere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12404,'I have all manner of goods for sale, $c.  Browse at your leisure.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12405,'A list... how intriguing.  Ah yes, the shipment of fireworks for Lord Saltheril.  He hasn\'t paid for them; are you here to purchase them on his behalf, $c?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(12406,'','Is there no end to these undead?  It seems that for every ghoul or skeleton we kill, two take its place.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12407,'','Marketing - iCoke Redemption Greeting (S.H.E.)',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12408,'Where\'s that courier?','',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(12409,'What word from Silvermoon?  The courier is late!','',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(12410,'Where is the messenger from the regent lord?','',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(12411,'I don\'t have all day to wait out here for that message. There are things that Dame Auriferous has tasked me with seeing to!','',5,0,0,0,0,0,0,1,1,0,0,0,26124),
(12412,'The hour runs late. The message from Silvermoon City is delayed for some reason.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12413,'The courier from Silvermoon City is delayed. Perhaps I should send a scout to look for him?','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12414,'At this rate I\'m going to pace a rut into the road. I hope the messenger from Kalecgos arrives soon.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12415,'Whatever the courier delivers, I hope that it\'s good news.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12416,'$C, you didn\'t happen to see a courier on your way here? We are awaiting word from Silvermoon City and their messenger is late!','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(12417,'','Open fire!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12418,'','Enemy sighted!  Ready your weapons!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12419,'','Hold your positions!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12420,'Our dark master has noticed your trifling, and sends me to bring a message... of doom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12421,'These heroics mean nothing, $c.  Your future is sealed and your soul is doomed to servitude!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12422,'Your battle here is but the smallest mote of a world wide invasion, whelp!  It is time you learned of the powers you face!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12423,'Sometimes I stand here, looking into the forest beyond the lake, and I see the land as it once was... green and full of life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12424,'We really must perfect a way to deal with those smelly Shadowpine trolls!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12425,'I must say, you delivered my poison and dealt with those trolls most ruthlessly, $c. You\'ve got the makings of quite a talented young $g man : lady;!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12426,'','Marketing - iCoke Redemption Greeting (S.H.E. non-Quest)',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12427,'World of Warcraft and Coca-Cola (R) have teamed up to bring you the iCoke-World of Warcraft Summer Promotion.  Look for codes under the caps of specially marked bottles of Coca-Cola.  Then return here and enter the code to win a virtual item.','World of Warcraft and Coca-Cola (R) have teamed up to bring you the iCoke-World of Warcraft Summer Promotion.  Look for codes under the caps of specially marked bottles of Coca-Cola.  Then return here and enter the code to win a virtual item.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12428,'I shall find you mortals!  You shall pay for destroying the Ash\'ari Crystals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12429,'Thank you for becoming my next victim!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12430,'','We must maintain a state of vigilance, $c! Between Dar\'Khan the Betrayer and his Scourge, and the Shadowpine trolls backed by the might of Zul\'Aman, we\'re barely keeping our heads above water here. We really shouldn\'t have to be dividing our attentions!$B$BI hope you\'re here to help.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12431,'','I\'m glad that you\'re here to help, $c. The faster we can deal with these trolls, the faster we\'ll get to send the scourge back to where they came from.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12432,'','One set of trolls dealt with, one yet to go. You have no idea how much I appreciate what you\'re doing, $n! Before you came along I didn\'t think we\'d ever get the Shadowpine problem under control.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(12433,'','You wouldn\'t believe some of the rabble that we\'ve had come through here lately. Most are more trouble than the supposed help that they provide. Nothing at all like you.$B$BYou sure you don\'t want to sign up with the Farstriders?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12434,'Where are we battling the Scourge?','Where are we battling the Scourge?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12435,'The Lich King brought only small forces to bear against each of Azeroth\'s capital cities, while their main forces periodically attack the following lands:$B$BAzshara, the Blasted Lands, the Burning Steppes, the Tanaris Desert, the Eastern Plaguelands and Winterspring.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12436,'Haha... I gonna kill puny $r and make trophy of your skull!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(12437,'','What brings you here, $n?  We don\'t see too many people around these parts.  With good reason, I suppose.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12438,'','Do you wish to learn the blacksmithing profession or is there something else you wish to tell me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12439,'Nevermind my injuries, $g brother : sister;. It\'s a miracle that any of us are alive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12440,'DISCOVERY!   $n has discovered the Super Rejuvenation Potion recipe!','DISCOVERY!   $n has discovered the Super Rejuvenation Potion recipe!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12441,'DISCOVERY!   $n has discovered the Flask of Fortification recipe!','DISCOVERY!   $n has discovered the Flask of Fortification recipe!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12442,'DISCOVERY!   $n has discovered the Flask of Mighty Versatility recipe!','DISCOVERY!   $n has discovered the Flask of Mighty Versatility recipe!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12443,'DISCOVERY!   $n has discovered the Flask of Relentless Assault recipe!','DISCOVERY!   $n has discovered the Flask of Relentless Assault recipe!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12444,'DISCOVERY!   $n has discovered the Flask of Blinding Light recipe!','DISCOVERY!   $n has discovered the Flask of Blinding Light recipe!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12445,'DISCOVERY!   $n has discovered the Flask of Pure Death recipe!','DISCOVERY!   $n has discovered the Flask of Pure Death recipe!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12446,'','We are very fortunate to be alive, you and I!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12447,'You don\'t see too many apprentices around these parts, do you?  I\'m beginning to think it\'s because the magisters give us all the dangerous work they\'d rather not do themselves.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12448,'The Light be praised!  I would have died out here if it weren\'t for you, $c!  I must get to the ship.','The Light be praised!  I would have died out here if it weren\'t for you, $c!  I must get to the ship.',4,0,0,0,0,0,0,35,1,0,0,0,26124),
(12449,'Huh?  What happened?  Oh... my head feels like it\'s going to explode!  I\'d best get back to the crash site.','Huh?  What happened?  Oh... my head feels like it\'s going to explode!  I\'d best get to the crash site.',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(12450,'Many thanks to you, $c.  I\'d best get to the crash site and see how I can help out.  Until we meet again.','Many thanks to you, $c.  I\'d best get to the crash site and see how I can help out.  Until we meet again.',3,0,0,0,0,0,0,35,1,0,0,0,26124),
(12451,'$C, you saved me!  I owe you a debt that I can never repay.  I\'ll go see if I can help the others.','$C, you saved me!  I owe you a debt that I can never repay.  I\'ll go see if I can help the others.',2,0,0,0,0,0,0,35,1,0,0,0,26124),
(12452,'DISCOVERY!   $n has discovered how to transmute primal shadow into water.','DISCOVERY!   $n has discovered how to transmute primal shadow into water.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12453,'DISCOVERY!   $n has discovered how to transmute primal water into shadow.','DISCOVERY!   $n has discovered how to transmute primal water into shadow.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12454,'DISCOVERY!   $n has discovered how to transmute primal mana into fire.','DISCOVERY!   $n has discovered how to transmute primal mana into fire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12455,'DISCOVERY!   $n has discovered how to transmute primal fire into mana.','DISCOVERY!   $n has discovered how to transmute primal fire into mana.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12456,'DISCOVERY!   $n has discovered how to transmute primal life into earth.','DISCOVERY!   $n has discovered how to transmute primal life into earth.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12457,'DISCOVERY!   $n has discovered how to transmute primal earth into life.','DISCOVERY!   $n has discovered how to transmute primal earth into life.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12458,'Ours is the path of purity and righteousness in the Light.','Ours is the path of purity and righteousness in the Light.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12459,'We are one in the Light, $g brother : sister;, but I cannot train you.','We are one in the Light, $g brother : sister;, but I cannot train you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12460,'You come in search of training, hunter?','You come in search of training, hunter?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(12461,'I\'m a hunter trainer. You\'ll want to find the $c trainer.','I\'m a hunter trainer. You\'ll want to find the $c trainer.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12462,'Do you seek further training in the ways of the warrior?','Do you seek further training in the ways of the warrior?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(12463,'I would train you, but you are no warrior.','I would train you, but you are no warrior.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12464,'We practitioners of the arcane and elemental ways follow a never ending path of discovery. Is that why you seek my counsel? You wish further training?','We practitioners of the arcane and elemental ways follow a never ending path of discovery. Is that why you seek my counsel? You wish further training?',1,6,0,0,1000,0,0,0,1,0,0,0,26124),
(12465,'By the Naaru, you are no mage! If you are looking for training, you must seek out a $c trainer.','By the Naaru, you are no mage! If you are looking for training, you must seek out a $c trainer.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(12466,'In the Light we all cast shadows, my $g brother : sister;.  Do you seek further guidance today?','In the Light we all cast shadows, my $g brother : sister;.  Do you seek further guidance today?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12467,'Though I cannot offer you training, young $c, I can give you my blessing. Walk boldly in the Light!','Though I cannot offer you training, young $c, I can give you my blessing. Walk boldly in the Light!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12468,'Who dares invade the Shattered Halls? Prepare to meet the might of the Fel Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12469,'Renault...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12470,'Father... But... How?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12471,'Did you think that your betrayal would be forgotten? Lost in the carefully planned cover up of my death? Blood of my blood, the blade felt your cruelty long after my heart had stopped beating. And in death, I knew what you had done. But now, the chains of Kel\'Thuzad hold me no more. I come to serve justice. I AM ASHBRINGER.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12472,'Forgive me, father! Please...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12473,'You are forgiven...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12474,'The Scourge infestation grows in Azshara. Every able bodied warrior is needed to stem the tide of their invasion.$B$BNumber of Necropolises remaining: $2279W','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(12475,'The Scourge infestation grows in the Eastern Plaguelands. Every able bodied warrior is needed to stem the tide of their invasion.$B$BNumber of Necropolises remaining: $2282W','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(12476,'Is Azshara currently under attack?','Is Azshara currently under attack?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(12477,'Are the Eastern Plaguelands currently under attack?','Are the Eastern Plaguelands currently under attack?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(12478,'I have another question.','I have another question.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12479,'Where else are we battling the Scourge?','Where else are we battling the Scourge?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12480,'At last, the curse is lifted. Thank you, hero.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12481,'Curse? What\'s going on here, Fairbanks?','Curse? What\'s going on here, Fairbanks?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12482,'You mean, you don\'t know? The sword that you carry on your back - it is known as Ashbringer; named after its original owner.','',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(12483,'Mograine?','Mograine?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12484,'Aye, the Highlord Mograine: A founder of the original order of the Scarlet Crusade. A knight of unwavering faith and purity; Mograine would be betrayed by his own son and slain by Kel\'Thuzad\'s forces inside Stratholme. It is how I ended up here...','',273,1,1,0,0,0,0,0,1,0,0,0,26124),
(12485,'What do you mean?','What do you mean?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12486,'It was High General Abbendis, High Inquisitor Isillien, and Highlord Mograine that formed the Crusade. In its infancy, the Crusade was a noble order. The madness and insane zealotry that you see now did not exist. It was not until the one known as the Grand Crusader appeared that the wheels of corruption were set in motion.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(12487,'I still do not fully understand.','I still do not fully understand.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12488,'The Highlord was the lynchpin of the Crusade. Aye, Mograine was called the Ashbringer because of his exploits versus the armies of the Lich King. With only blade and faith, Mograine would walk into whole battalions of undead and emerge unscathed - the ashes of his foes being the only indication that he had been there at all. Do you not understand? The very face of death feared him! It trembled in his presence!','',1,273,5,0,0,0,0,0,1,0,0,0,26124),
(12489,'Incredible story. So how did he die?','Incredible story. So how did he die?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12490,'The only way a hero can die, $r: Through tragedy. The Grand Crusader struck a deal with Kel\'Thuzad himself! An ambush would be staged that would result in the death of Mograine. The type of betrayal that could only be a result of the actions of one\'s most trusted and loved companions.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(12491,'You mean...','You mean...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12492,'<High Inquisitor Fairbanks nods.>$B$BAye, the lesser Mograine, the one known as the Scarlet Commander, through - what I suspect - the dealings of the Grand Crusader. He led his father to the ambush like a lamb to the slaughter.','',273,1,1,0,0,0,0,0,1,0,0,0,26124),
(12493,'How do you know all of this?','How do you know all of this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12494,'<High Inquisitor Fairbanks lifts up his tabard revealing several gruesome scars.>$B$BBecause I was there... I was the Highlord\'s most trusted advisor. I should have known... I felt that something was amiss yet I allowed it to happen. Would you believe that there were a thousand or more Scourge?','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(12495,'A thousand? For one man?','A thousand? For one man?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12496,'This was the Ashbringer, fool! As the Scourge began to materialize around us, Mograine\'s blade began to glow... to hum... the younger Mograine would take that as a sign to make his escape. They descended upon us with a hunger the likes of which I had never seen. Yet...','',5,1,1,0,0,0,0,0,1,0,0,0,26124),
(12497,'Yet? Yet what??','Yet? Yet what??',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12498,'It was not enough.$B$B<Fairbanks smirks briefly, lost in a memory.>$B$BA thousand came and a thousand died. By the Light! By the might of Mograine! He would smite them down as fast as they could come. Through the chaos, I noticed that the lesser Mograine was still there, off in the distance. I called to him, \"Help us, Renault! Help your father, boy!\"','',1,22,22,0,4,2,0,0,1,0,0,0,26124),
(12499,'And did he?','And did he?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12500,'<High Inquisitor Fairbanks shakes his head.>$B$BNo... He stood in the background, watching as the legion of undead descended upon us. Soon after, my powers were exhausted. I was the first to fall... Surely they would tear me limb from limb as I lay there unconscious; but they ignored me completely, focusing all of their attention on the Highlord. ','',274,1,1,0,0,0,0,0,1,0,0,0,26124),
(12501,'Continue please, Fairbanks.','Continue please, Fairbanks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12502,'It was all I could do to feign death as the corpses of the Scourge piled upon me. There was darkness and only the muffled sounds of the battle above me. The clashing of iron, the gnashing and grinding... gruesome, terrible sounds. And then there was silence. He called to me! \"Fairbanks! Fairbanks where are you? Talk to me Fairbanks!\" And then came the sound of incredulousness. The bite of betrayal, $r...','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(12503,'You mean...','You mean...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12504,'The boy had picked up the Ashbringer and driven it through his father\'s heart as his back was turned. His last words will haunt me forever: \"What have you done, Renault? Why would you do this?\"','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(12505,'You were right, Fairbanks. That is tragic.','You were right, Fairbanks. That is tragic.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12506,'The blade and Mograine were a singular entity. Do you understand? This act corrupted the blade and lead to Mograine\'s own corruption as a death knight of Kel\'Thuzad. I swore that if I lived, I would expose the perpetrators of this heinous crime. For two days I remained under the rot and contagion of Scourge - gathering as much strength as possible to escape the razed city.\n','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(12507,'And you did...','And you did...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12508,'Aye, I did. Much to the dismay of the lesser Mograine, I made my way back to the Scarlet Monastery. I shouted and screamed. I told the tale to any that would listen. And I would be murdered in cold blood for my actions, dragged to this chamber - the dark secret of the order. But some did listen... some heard my words. Thus was born the Argent Dawn...','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(12509,'You tell an incredible tale, Fairbanks. What of the blade? Is it beyond redemption?','You tell an incredible tale, Fairbanks. What of the blade? Is it beyond redemption?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12510,'I\'m afraid that the blade which you hold in your hands is beyond saving. The hatred runs too deep. But do not lose hope, $c. Where one chapter has ended, a new one begins.$B$BFind his son - a more devout and pious man you may never meet. It is rumored that he is able to build the Ashbringer anew, without requiring the old, tainted blade.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12511,'But his son is dead.','But his son is dead.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12512,'<High Inquisitor Fairbanks shakes his head.>$B$BNo, $r; only one of his sons is dead. The other lives...$B$B<High Inquisitor Fairbanks points to the sky.>$B$BThe Outland... Find him there... ','',274,1,25,0,0,0,0,0,1,0,0,0,26124),
(12513,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12514,'The %s nods appreciatively.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12516,'The %s seems overjoyed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12517,'The %s looks confused.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12518,'The %s seems disoriented.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12519,'The %s wanders aimlessly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12520,'The %s doesn\'t look like it minds the crystal\'s effects.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12521,'The %s didn\'t like what just happened.','',35,0,0,0,0,0,0,0,1,0,0,0,26124),
(12522,'The %s is agitated by the inoculation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12523,'saved world state is: $2285W','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12524,'$C, I\'m going to need a little time to look into this possible business concerning the blood elves. Perhaps you have other tasks that need doing in the meantime?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(12525,'Many are the paths of the Light, $c.  You must decide which to follow on this world, or any other.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12526,'As you gain renown with our town, I can make more goods available to you, $n.  With equipment in such short supply we can only afford to provide it to those we trust.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12527,'Show me what I have access to, Vredigar.','Show me what I have access to, Vredigar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12528,'I offer what shelter I can in our shattered lands.','I offer what shelter I can in our shattered lands.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12529,'It is so good to see you, $g brother : sister;!  This place gives me the creeps.  While you\'re here, be sure to avail yourself of the many opportunities that these so-called Forsaken are providing.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12530,'It\'s not my fault... IT\'S NOT MY FAULT!!!$B$BIf they\'d just done what I told them to do everything would have been fine. But no! They wouldn\'t listen.$B$BNow they\'re all dead.$B$BI just want to go home. Home to Silvermoon. I\'m so tired.','',5,18,0,0,500,0,0,0,1,0,0,0,26124),
(12531,'Yer slop is ready. Come n\' get it...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12532,'And if I hear that you palookas complained to Nazgrel again, it\'ll be one of ya\'s that I serve up next time...','And if I hear that you palookas complained to Nazgrel again, it\'ll be one of ya\'s that I serve up next time...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12533,'This ain\'t your vacation getaway, $r. If you want to rest, take a bedroll and shut yer yap.$B$BAnd don\'t tell me that you wanna make Hellfire yer home. You ain\'t gonna last two minutes out in the wilds. We\'ll be shipping you back home in five small boxes.','',1,25,1,0,0,0,0,0,1,0,0,0,26124),
(12534,'As a matter of fact, I do want to make Hellfire Peninsula my home.','As a matter of fact, I do want to make Hellfire Peninsula my home.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12535,'I\'m looking for some specialty goods. Let me browse your wares, Floyd.','I\'m looking for some specialty goods. Let me browse your wares, Floyd.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12536,'This ain\'t daycare, peon. Double time!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12537,'Don\'t say I didn\'t warn ya when I thrust my fist into the back of yer head. It\'ll feel just like home, back in the Valley of Trials.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12538,'Yer gonna learn why they call this place Hellfire, maggot.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12539,'We really must perfect a way to deal with those smelly Shadowpine trolls.$B$BOh, no offense, $c.$B$B<The apothecary grins innocently and shrugs.>','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12540,'They should have listened to me.  Then I\'d receive all of the accolades that are my due!','',1,18,0,0,1000,0,0,1,1,0,0,0,26124),
(12541,'Did I not yell at them? Pull back! Pull back and regroup with suppressing fire!!','',5,0,0,0,0,0,0,1,1,0,0,0,26124),
(12542,'This isn\'t Silvermoon City! Where are we? Oh, I was confused there for a moment.','',5,18,0,0,1000,0,0,1,1,0,0,0,26124),
(12543,'I tell you now, when we get back to Farstrider Enclave there will be a full accounting of your actions, Ranger Valanna! You alone were responsible for our losses and I\'m certain that the captain will see it my way.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12544,'Take that!','',48,153,0,0,2000,0,0,1,1,0,0,0,26124),
(12545,'I\'m sure to receive a commendation upon our return. We may have suffered a few losses, but overall I think we did quite nicely, don\'t you, Valanna?','',1,6,0,0,500,0,0,1,1,0,0,0,26124),
(12546,'Delicious, Cookie... You\'ve really outdone yourself this time, old-timer. I\'ve never tasted horse this good.','Delicious, Cookie... You\'ve really outdone yourself this time, old-timer. I\'ve never tasted horse this good.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12547,'Do I detect a hint of cinnamon? Or is that nutmeg? Whatever it is, one thing\'s for sure - nobody cooks a donkey like you, Cookie.','Do I detect a hint of cinnamon? Or is that nutmeg? Whatever it is, one thing\'s for sure - nobody cooks a donkey like you, Cookie.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12548,'It tastes like I died and went to the Nether; where slop that tastes like rotting threshadon carcass is then shoved down my throat by an obese tauren that\'s never washed their hands - or bathed...','It tastes like I died and went to the Nether; where slop that tastes like rotting threshadon carcass is then shoved down my throat by an obese tauren that\'s never washed their hands - or bathed...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12549,'Is this what it\'s come down to, Cookie? Are we so low on supplies that you\'ve resorted to feeding us dung flavored wood chips?','Is this what it\'s come down to, Cookie? Are we so low on supplies that you\'ve resorted to feeding us dung flavored wood chips?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12550,'If my stomach wasn\'t threatening to dislodge itself from my body and leave me for the refuse that we give to the prisoners, I might be insulted by this... this food.','If my stomach wasn\'t threatening to dislodge itself from my body and leave me for the refuse that we give to the prisoners, I might be insulted by this... this food.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12551,'I\'ve seen gnomes work harder than you, peon! Little girl gnomes - with pig tails! MOVE IT, MOVE IT, MOVE IT!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12552,'','Executor, your direct assault approach will cost us more lives than I am comfortable with. A more nuanced strategy is called for; one that involves us reclaiming the surrounding territory, starting with the villages so as to cut off all points of reinforcement to Deatholme.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12553,'With all due respect, milady, you have not fought the Scourge as I have. The Lady appointed me to assist you in defeating Dar\'khan because of that, and you would do well to consider what I have to say.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12554,'I strongly disagree. Dar\'khan is not going to get reinforcements because he\'ll be bottlenecked. Deatholme has only one way in and out. Your traitor was a fool to corner himself there, and I intend to exploit that weakness!','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12555,'This is war, Dame Auriferous, and in any war lives will be lost! The only areas that we need to secure are the two ziggurats. We will turtle in and take the Tower of the Damned and its master by brute force. Then you will have your Quel\'Thalas.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12556,'And if your Farstriders were here to reinforce us, I might agree. But, they are busying themselves instead with the Shadowpine trolls on your eastern border. The longer we wait for them, the stronger the Scourge will become.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12557,'','How long until Forsaken reinforcements arrive? Our position here is tenuous. Your Lady promised us more soldiers. We must be able to concentrate solely on Deatholme and the Scourge!',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(12558,'I believe that you\'re making my argument for me, but yes it would be nice if we had more reinforcements. I would counter that it would be faster to pull the Farstriders from their senseless skirmishing with the trolls.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12559,'Dame Auriferous, we are the reinforcements. It may come to pass that The Lady will send more men in time. Better that you convince Silvermoon City to muster all of its forces and put them at our disposal here.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12560,'You are correct; we must concentrate on the Scourge. Ignore the trolls and the villages, and focus our attentions on Deatholme! With Dar\'khan defeated you will find that the rest of the Scourge \'body\' will fall quickly, lacking their \'head\'.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12561,'Forsaken reinforcements? Undercity is stretched thin with the Scourge on all sides. No, this will be a matter largely dealt with by the blood elves. We Forsaken are here as backup and advisors.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12562,'','No, I was right to begin with. Deatholme must come last. We must secure all of the Ghostlands first. I will not commit the forces here to a battle against Dar\'khan with enemies to our flank and rear!',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12563,'Watch your back, mon!','Watch your back, mon!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12564,'Check your tracks!','Check your tracks!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12565,'Make sure you weren\'t followed, mon!','Make sure you weren\'t followed, mon!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12566,'Didn\'t drag anything in with ya, did ya?','Didn\'t drag anything in with ya, did ya?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12567,'Again I strongly disagree with your view of the strategic situation. Your plan will spread our forces too thin. It will leave us with only a small force to assault Deatholme. I cannot in good conscience execute such a strategy.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12568,'Spread throughout the Ghostlands, our forces will be of little use in an assault on Deatholme. No, milady, I am here to kill Dar\'khan and that is what I intend to do!','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12569,'We\'ve been over this before. Only a focused assault upon Deatholme will meet with success. These other targets are distractions that we can ill afford. I suggest that you inform your Captain Helios that he is to leave off his campaign against the Shadowpine trolls and focus solely on the Scourge.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12570,'Perhaps we should let the matter rest for the time being until your chef has prepared your meal? You look a bit piqued if you don\'t mind my saying. We can resume our discussion when you are feeling more yourself.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12571,'','I hear what you are saying, Mavren. Nevertheless, the final decision is mine. I appreciate your assistance, but the majority of the lives on the line are blood elf. I will not have those lives carelessly thrown away!',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12572,'','Mavren, I don\'t want excuses, I want results! The Farstriders aren\'t available and we\'ve received all that we\'re going to get from Silvermoon for now. I cannot ignore the Shadowpine trolls and Zul\'Aman... they\'re arrayed across our eastern border!',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12573,'','Disagree with me all you like, High Executor. I will weigh your counsel, and then we will take the steps to free all of Quel\'Thalas as I deem necessary. We shall continue this discussion anon.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12574,'','%s looks appalled at the Executor\'s tone!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12575,'','%s tries to busy herself with other matters.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12576,'','%s glares daggers in the direction of High Executor Mavren and Deathstalker Maltendis.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12577,'','%s lifts her nose and sniffs in response to the High Executor\'s reply.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12578,'','%s shakes her head in disbelief at what she is hearing out of the Forsaken\'s mouth.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12579,'','%s blanches as much of the blood drains from her face.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12580,'','%s reddens furiously at what she is hearing in response to her lady\'s question.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12581,'','%s concentrates on the wall opposite her, clearly ignoring the looks of the Executor and his assistant.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12582,'%s nods in agreement.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12583,'%s opens his mouth as if to add something, and then apparently thinks the better of it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12584,'%s looks over at Advisor Valwyn with a smirk on his face.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12585,'%s grins at the High Executor\'s words.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12586,'%s appears bored with the whole discussion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12587,'%s winks slyly at Advisor Valwyn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12588,'%s fidgets with his armor, clearly uncomfortable at the tone of the discussion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12589,'%s looks like he\'d rather be anywhere else but here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12590,'%s taps his foot impatiently.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12591,'%s glares at the guards.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12592,'%s sighs in apparent frustration.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12593,'%s peers inside the tower and then clenches his jaw.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12594,'Why doesn\'t Kaendris move against Dar\'Khan yet?  What is it we\'re waiting for?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12595,'','Calm yourself, Idonis.  Brash actions will get us nowhere!  Take a break, tap into some mana crystals.  You\'ll feel better.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12596,'','He\'s got his reasons, Idonis.  He thinks the Farstriders have uncovered something.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12597,'','We must remain focused on our work.  Once the sanctum starts producing at full capacity, Silvermoon will be forced to send help.  Functioning arcane sanctums are in short supply.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12598,'I deal in comfort... Soothe your savage impulse, $r. My inn is your home... ','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(12599,'A fine offer, Floyd. I wish to make Hellfire Peninsula my home.','A fine offer, Floyd. I wish to make Hellfire Peninsula my home.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12601,'Farstrider Dusking, what business have you to report?','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12602,'Anything new, Dusking?','',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(12603,'At ease, Farstrider Dusking. What news do you have for me?','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12604,'Out with it, Farstrider! What news do you bring?','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12605,'','Sir, Farstrider Solanna informs me that attacks on Zeb\'Tela and Zeb\'Nowa are underway. She was able to recruit a promising, young candidate to help with the situation. Also, the apothecary upstairs has made mention of a solution he believes he has to also help with the trolls.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12606,'','%s fidgets and looks away from Captain Helios.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12607,'Is that all, Farstrider?','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(12608,'','%s looks down at her feet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12609,'','No, sir. A signed letter from the High Executor has come in from Tranquillien. He\'s requesting that we pull all Farstrider forces from the eastern border and the trolls. He wants us to prepare to deploy to Andilien Estate as a staging area for an assault on Deatholme, sir.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12610,'','No, Captain. Another signed letter has arrived by messenger from Tranquillien. It\'s signed again by High Executor Mavren. He wants to know why we haven\'t begun pulling the Farstriders from their missions against the Shadowpine trolls as he previously ordered, sir.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12611,'','Sir, no, sir! Another dispatch has arrived from Tranquillien. It\'s High Executor Mavren again, captain. This time the language in the letter was very \'colorful\'. He reiterates his request that we marshal the Farstriders in support of the efforts against Deatholme, and suggests that you should send a runner north to Farstrider Retreat in Eversong Woods and muster their forces as well.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12612,'What! If I\'ve told him once, I\'ve told him a thousand times! I do not take orders from him, or any of the forsaken! Send a letter to Dame Auriferous letting her know of the situation. Perhaps she will let him know how things work around here. Thank you for letting me know, Dusking. Dismissed.','',5,1,0,0,500,0,0,1,1,0,0,0,26124),
(12613,'I am growing tired of this High Executor Mavren! We dare not pull the Farstriders off of the eastern border and he knows it! He also knows that Dame Auriferous is in full agreement with me on this matter. Until she says otherwise, we stay put. That\'s all, farstrider, dismissed.','',1,1,0,0,500,0,0,1,1,0,0,0,26124),
(12614,'I\'m not pulling anyone from anything! He can send all of the letters that he wants. I\'m fully aware of his \'strategic\' plan, and he knows that the Dame and I are in full agreement with what the Farstriders need to be doing. Once the Shadowpine trolls have been dealt with then, and only then, will we divert our attentions to Deatholme. I know that the scourge are the greater threat, but Tranquillien is going to have to hold them off for now. It would be suicide to ignore the trolls! Dismissed, Dusking.','',5,1,0,0,500,0,0,1,1,0,0,0,26124),
(12615,'','As you say, sir!',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(12616,'','Hello, $c. If you haven\'t already, you really should speak with Farstrider Solanna.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12617,'So there we were - me and the battalion, doing a routine recon down the bone road. We\'d sent the scout up ahead to look around in case anything dangerous come up.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12618,'Sure enough, scout came runnin\' back, talkin\' bout some orcs down the path. They hadn\'t seen us yet so we figured we\'d go get acquainted.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12619,'What kinda orcs, chief?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12620,'','Greetings, $n. ',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12621,'','Hi, I\'m a newb.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(12622,'','I see you did it with your pants down and your hammer in your hand.',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(12623,'What further information do you have?','What further information do you have?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12624,'','You look like just the Warlock I need! The evil goblin chieftain Snarl must be defeated.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12625,'Big red suckers! Bigger than any orc I\'d ever seen. Muscles out to here, tusks out to here... ','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12626,'You mean...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12627,'%s nods.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12628,'Fel orcs...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12629,'Show me the lobsters!','Show me the lobsters!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12630,'I desire training.','I desire training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12631,'I wish to browse your wares.','I wish to browse your wares.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12632,'I wish to make Designer Island my home.','I wish to make Designer Island my home.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12633,'I wish to stable my pet.','I wish to stable my pet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12634,'','Die, Warlock scum!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12635,'But how, chief? I thought the curse was lifted...\n','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12636,'I dunno, grunt. I just - don\'t - know...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12637,'But that\'s not the worst of it. Before I could pull us back, a group of \'em spotted us and attacked.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12638,'Lost some of my best soldiers that day...','Lost some of my best soldiers that day...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12639,'If you have lost a piece of your Zandalarian armor, I may be able to help.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12640,'Jin\'rokh, I fear I\'ve lost my Zandalar Vindicator\'s Breastplate. Can you supply me with a replacement?','Jin\'rokh, I fear I\'ve lost my Zandalar Vindicator\'s Breastplate. Can you supply me with a replacement?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12641,'Jin\'rokh, I need assistance in recovering a piece of my Vindicator\'s Battlegear.','Jin\'rokh, I need assistance in recovering a piece of my Vindicator\'s Battlegear.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12642,'I think I\'ve lost my  Zandalar Vindicator\'s Belt. Can you help?','I think I\'ve lost my  Zandalar Vindicator\'s Belt. Can you help?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12643,'Jin\'rokh, my Zandalar Vindicator\'s Armguards have gone missing. Do you have a spare set?','Jin\'rokh, my Zandalar Vindicator\'s Armguards have gone missing. Do you have a spare set?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12644,'Jin\'rokh, I fear I\'ve lost my Zandalar Freethinker\'s Breastplate. Can you supply me with a replacement?','Jin\'rokh, I fear I\'ve lost my Zandalar Freethinker\'s Breastplate. Can you supply me with a replacement?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12645,'Jin\'rokh, I have lost my Zandalar Freethinker\'s Belt. Can you help?','Jin\'rokh, I have lost my Zandalar Freethinker\'s Belt. Can you help?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12646,'Jin\'rokh, I am missing my Zandalar Freethinker\'s Armguards. Can you replace them?','Jin\'rokh, I am missing my Zandalar Freethinker\'s Armguards. Can you replace them?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12647,'Jin\'rokh, I need assistance in recovering a piece of my Freethinker\'s Armor.','Jin\'rokh, I need assistance in recovering a piece of my Freethinker\'s Armor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12648,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12649,'Falthir, I need assistance in recovering a piece of my Madcap\'s Outfit.','Falthir, I need assistance in recovering a piece of my Madcap\'s Outfit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12652,'If you have lost a piece of your Zandalarian armor, I may be able to help.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12653,'Falthir, I need assistance in replacing a piece of my Predator\'s Armor.','Falthir, I need assistance in replacing a piece of my Predator\'s Armor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12654,'Get in there and help those worthless fools out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12655,'I\'ve lost my Zandalar Madcap\'s Tunic and require a new one, Falthir.','I\'ve lost my Zandalar Madcap\'s Tunic and require a new one, Falthir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12656,'Falthir, I have lost my Zandalar Madcap\'s Mantle. Do you have a replacement?','Falthir, I have lost my Zandalar Madcap\'s Mantle. Do you have a replacement?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12657,'I seem to have misplaced my Zandalar Madap\'s Bracers. Can you help?','I seem to have misplaced my Zandalar Madap\'s Bracers. Can you help?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12658,'Falthir, I have lost my Zandalar Predator\'s Mantle and need a replacement.','Falthir, I have lost my Zandalar Predator\'s Mantle and need a replacement.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12659,'My Zandalar Predator\'s Belt has gone missing. Can you help, Falthir?','My Zandalar Predator\'s Belt has gone missing. Can you help, Falthir?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12660,'Falthir, I no longer have my Zandalar Predator\'s Bracers. Can you provide a new pair?','Falthir, I no longer have my Zandalar Predator\'s Bracers. Can you provide a new pair?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12661,'I need help recovering a missing piece of my Haruspex\'s Garb, Maywiki.','I need help recovering a missing piece of my Haruspex\'s Garb, Maywiki.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12662,'','If you have lost a piece of your Zandalarian armor, I may be able to help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12663,'I am missing a piece of my Augur\'s Regalia and I need a replacement.','I am missing a piece of my Augur\'s Regalia and I need a replacement.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12664,'Maywiki, I\'ve lost my Zandalar Augur\'s Hauberk and need a new one.','Maywiki, I\'ve lost my Zandalar Augur\'s Hauberk and need a new one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12665,'Maywiki, a dastardly little gnome made off with my Zandalar Augur\'s Belt. Can you provide a replacement?','Maywiki, a dastardly little gnome made off with my Zandalar Augur\'s Belt. Can you provide a replacement?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12666,'I have misplaced my Zandalar Augur\'s Bracers and require another pair.','I have misplaced my Zandalar Augur\'s Bracers and require another pair.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12667,'I have lost my Zandalar Haruspex\'s Tunic, Maywiki. Do you have a replacement?','I have lost my Zandalar Haruspex\'s Tunic, Maywiki. Do you have a replacement?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12668,'Maywiki, I no longer have my Zandalar Haruspex\'s Belt. Can you help?','Maywiki, I no longer have my Zandalar Haruspex\'s Belt. Can you help?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12669,'I\'ve misplaced my Zandalar Haruspex\'s Bracers and require another pair.','I\'ve misplaced my Zandalar Haruspex\'s Bracers and require another pair.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12670,'I need assistance in recovering a piece of my Confessor\'s Raiment, Al\'tabim.','I need assistance in recovering a piece of my Confessor\'s Raiment, Al\'tabim.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12671,'If you have lost a piece of your Zandalarian armor, I may be able to help you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12672,'I require assistance in recovering a piece of my Illusionist\'s Attire, Al\'tabim.','I require assistance in recovering a piece of my Illusionist\'s Attire, Al\'tabim.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12673,'I require assistance in recovering a piece of my Demoniac\'s Threads, Al\'tabim.','I require assistance in recovering a piece of my Demoniac\'s Threads, Al\'tabim.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12674,'I have lost my Confessor\'s Mantle and require a replacement, Al\'tabim.','I have lost my Confessor\'s Mantle and require a replacement, Al\'tabim.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12675,'I no longer possess my Zandalar Confessor\'s Bindings. Can you provide a replacement?','I no longer possess my Zandalar Confessor\'s Bindings. Can you provide a replacement?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12676,'Al\'tabim, my Zandalar Confessor\'s Wraps have gone missing. Can you replace them?','Al\'tabim, my Zandalar Confessor\'s Wraps have gone missing. Can you replace them?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12677,'I have lost my Zandalar Illusionist\'s Robe and need a new one, Al\'tabim.','I have lost my Zandalar Illusionist\'s Robe and need a new one, Al\'tabim.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12678,'Al\'tabim, I seem to have misplaced my Zandalar Illusionist\'s Mantle. Can you supply me with a replacement?','Al\'tabim, I seem to have misplaced my Zandalar Illusionist\'s Mantle. Can you supply me with a replacement?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12679,'I no longer have my Zandalar Illusionist\'s Wraps and require a new pair.','I no longer have my Zandalar Illusionist\'s Wraps and require a new pair.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12680,'I no longer have my Zandalar Demoniac\'s Robe. Can you provide a replacement?','I no longer have my Zandalar Demoniac\'s Robe. Can you provide a replacement?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12681,'Al\'tabim, I have lost my Zandalar Demoniac\'s Mantle. Can you help?','Al\'tabim, I have lost my Zandalar Demoniac\'s Mantle. Can you help?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12682,'My Zandalar Demoniac\'s Wraps have gone missing. Can you provide me with another set?','My Zandalar Demoniac\'s Wraps have gone missing. Can you provide me with another set?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12683,'We\'ll drink their blood and feast on their bones!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12684,'Serve the Fel Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12685,'Power to the Fel Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12686,'Break their bones!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12687,'Know your master, you worthless mutts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12688,'We shall crush these feeble beings!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12689,'Who wants to be the first to spill their blood?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12690,'','%s shimmers and becomes intangible!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12691,'As if you weaklings pose any threat to us. We will devour you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12692,'We will destroy you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12693,'I have lost my Mace of Unending Life. Are you able to replace it for me?','I have lost my Mace of Unending Life. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12694,'I have lost my Scythe of the Unseen Path. Are you able to replace it for me?','I have lost my Scythe of the Unseen Path. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12695,'I have lost my Blade of Vaulted Secrets. Are you able to replace it for me?','I have lost my Blade of Vaulted Secrets. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12696,'I have lost my Blade of Eternal Justice. Are you able to replace it for me?','I have lost my Blade of Eternal Justice. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12697,'I have lost my Gavel of Infinite Wisdom. Are you able to replace it for me?','I have lost my Gavel of Infinite Wisdom. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12698,'Brothers and sisters, I have been to the promised land. I have tasted in the sublime energy. I have felt bliss - bliss so engrossing and all encompassing that I was left wondering if I had stumbled upon the dreams of gods.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12699,'I have lost my Dagger of Veiled Shadows. Are you able to replace it for me?','I have lost my Dagger of Veiled Shadows. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12700,'Tell us more, Martik. What is it? What does it feel like?','Tell us more, Martik. What is it? What does it feel like?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12701,'I have lost my Hammer of the Gathering Storm. Are you able to replace it for me?','I have lost my Hammer of the Gathering Storm. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12702,'I have lost my Kris of Unspoken Names. Are you able to replace it for me?','I have lost my Kris of Unspoken Names. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12703,'In paradise, you merely reach out and take from the Nether.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12704,'But how?','But how?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12705,'I have lost my Sickle of Unyielding Strength. Are you able to replace it for me?','I have lost my Sickle of Unyielding Strength. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12706,'From the very air! Tendrils of arcane energy light up the obsidian sky as plumes of raw magic rise up from fissures in the land. Kneel and drink from the fissure as you do from a stream or well. Pluck a tendril from the heavens as if it were an apple hanging from a branch.','From the very air! Tendrils of arcane energy light up the obsidian sky as plumes of raw magic rise up from fissures in the land. Kneel and drink from the fissure as you do from a stream or well. Pluck a tendril from the heavens as if it were an apple hanging from a branch.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12707,'%s gasps.','%s gasps.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12708,'I have lost my Cloak of Unending Life. Are you able to replace it for me?','I have lost my Cloak of Unending Life. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12709,'%s smiles.','%s smiles.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12710,'I have lost my Cloak of the Unseen Path. Are you able to replace it for me?','I have lost my Cloak of the Unseen Path. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12711,'I have lost my Drape of Vaulted Secrets. Are you able to replace it for me?','I have lost my Drape of Vaulted Secrets. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12712,'I have lost my Cape of Eternal Justice. Are you able to replace it for me?','I have lost my Cape of Eternal Justice. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12713,'I have lost my Shroud of Infinite Wisdom. Are you able to replace it for me?','I have lost my Shroud of Infinite Wisdom. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12714,'I have lost my Cloak of Veiled Shadows. Are you able to replace it for me?','I have lost my Cloak of Veiled Shadows. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12715,'I have lost my Cloak of the Gathering Storm. Are you able to replace it for me?','I have lost my Cloak of the Gathering Storm. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12716,'I have lost my Shroud of Unspoken Names. Are you able to replace it for me?','I have lost my Shroud of Unspoken Names. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12717,'I have lost my Drape of Unyielding Strength. Are you able to replace it for me?','I have lost my Drape of Unyielding Strength. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12718,'I have lost my Band of Unending Life. Are you able to replace it for me?','I have lost my Band of Unending Life. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12719,'I have lost my Signet of the Unseen Path. Are you able to replace it for me?','I have lost my Signet of the Unseen Path. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12720,'I have lost my Band of Vaulted Secrets. Are you able to replace it for me?','I have lost my Band of Vaulted Secrets. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12721,'I have lost my Ring of Eternal Justice. Are you able to replace it for me?','I have lost my Ring of Eternal Justice. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12722,'I have lost my Ring of Infinite Wisdom. Are you able to replace it for me?','I have lost my Ring of Infinite Wisdom. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12723,'I have lost my Band of Veiled Shadows. Are you able to replace it for me?','I have lost my Band of Veiled Shadows. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12724,'I have lost my Ring of the Gathering Storm. Are you able to replace it for me?','I have lost my Ring of the Gathering Storm. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12725,'I have lost my Ring of Unspoken Names. Are you able to replace it for me?','I have lost my Ring of Unspoken Names. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12726,'Where... where am I?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12727,'I have lost my Signet of Unyielding Strength. Are you able to replace it for me?','I have lost my Signet of Unyielding Strength. Are you able to replace it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12728,'','You\'re not going anywhere just yet, handsome.  Not until you regain your strength.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12729,'Wake up you lazy sod and help out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12730,'Thank you very much! I don\'t know what I would have done if you weren\'t here!','',71,0,0,0,0,0,0,1,1,0,0,0,26124),
(12731,'I am most grateful for your help, $c!','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(12732,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12733,'So cold!  There is no heat left in this world.','So cold!  There is no heat left in this world.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12734,'The barrier did not protect us.  How could this have happened?','The barrier did not protect us.  How could this have happened?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12736,'Why do I remain?  This torment must end.','Why do I remain?  This torment must end.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12737,'Here they come again!  Stand ready!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12738,'Ah, you\'re the one who found the letter. Thank you for the... news, I suppose, about my family. You\'re welcome to what food and drink I can offer.','Ah, you\'re the one who found the letter. Thank you for the... news, I suppose, about my family. You\'re welcome to what food and drink I can offer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12739,'','Ah, you\'re the one who found the letter. Thank you for the... news, I suppose, about my family. You\'re welcome to what food and drink I can offer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12740,'I suppose you want something for what you did, is that it? Reminding me of my life? Pfagh. Take what I have and leave me alone.','I suppose you want something for what you did, is that it? Reminding me of my life? Pfagh. Take what I have and leave me alone.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12741,'Another batch of Scourge has been destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12742,'That\'s done it!  Hopefully Rommath will send reinforcements soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12743,'%s skin hardens!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12744,'OY! Wait in line, would ya? Outland food doesn\'t agree with me at all.','OY! Wait in line, would ya? Outland food doesn\'t agree with me at all.',5,1,274,0,0,0,0,0,1,0,0,0,26124),
(12745,'What\'s goin\' on in there?? For the love of the LIGHT, hurry it up!','What\'s goin\' on in there?? For the love of the LIGHT, hurry it up!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12746,'Do ya want me to call a medic? Maybe a priest? It\'s been over an hour, mate!','Do ya want me to call a medic? Maybe a priest? It\'s been over an hour, mate!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12747,'OY! You in there, this is official Honor Hold business yer holdin\' up!','OY! You in there, this is official Honor Hold business yer holdin\' up!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12748,'So help me, I\'m gonna count to ten and if yer not outta there by the time I reach 10, I\'m comin\' in!','So help me, I\'m gonna count to ten and if yer not outta there by the time I reach 10, I\'m comin\' in!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12749,'Sid\'s the name. It\'s nice to see some new faces around here. What can I do you for?','',1,1,6,0,0,0,0,7,1,0,0,0,26124),
(12750,'I would like to take a look at your wares, Sid.','I would like to take a look at your wares, Sid.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12751,'I wish to make Honor Hold my home, Sid.','I wish to make Honor Hold my home, Sid.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12752,'And who do we have here?  No doubt th... crzzzk ...ade this communication possible?  I give you greetings fro... psshzzzk... Azure Watch.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(12753,'Judging by your signal, we put you... ust southeast of the larger part of the island we crashed onto.  Cross the Crystalbrook River to ge... kshhhhk zzzt. Sorry, there\'s a lot of stat...','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(12754,'What now, Danath? Can you not see that I am inundated with work as is?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12755,'That is precisely why I have called for you old friend. We have much to discuss.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12756,'Though we\'ve arrived at the promised land, $n, much work remains to be done.  Our people won\'t reach Kael\'thas if we lunge desperately across Outland.$B$BSafe routes must be found, resources must be secured and our enemies must be avoided or destroyed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12757,'What manner of fool opens the very thing we were sent to close?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12758,'I have a good mind to tear that portal down myself! This is outrageous!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12759,'And have you heard? Have you heard the preposterous claims? Alliance and Horde supporting peace? Why the very thought of such things makes my blood boil!','And have you heard? Have you heard the preposterous claims? Alliance and Horde supporting peace? Why the very thought of such things makes my blood boil!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12760,'Twenty years lost! Twenty! I won\'t stand for this! No, no, no... ','Twenty years lost! Twenty! I won\'t stand for this! No, no, no... ',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12761,'To trust an orc? Even if it is the progeny of Durotan himself! This is madness!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12762,'Never! I\'ll never abide by their will! I\'d sooner be dead.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12763,'I take my leave now, Commander. Good day!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12764,'A mailbox? Well is that not the salt on the wounds! Twenty years cut-off from the world and now a mailbox! WONDERFUL!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12765,'Sid! Ale, NOW!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12766,'Comin\' right up, yer highness! Is there anythin\' else you\'ll be needin\'? Perhaps yer hat cleaned or yer nails trimmed?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12767,'','You\'ll not take me alive, scum!',36,0,0,0,0,0,0,0,1,0,0,0,26124),
(12768,'Don\'t you start with me, Sid! Have it sent to my quarters in the tower instead! Your inn has become a zoo!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12769,'What I wouldn\'t give for a healing crystal right about now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12770,'Thank you for delivering that list!  My leg is almost recovered enough that I\'ll be able to walk back to the crash site.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12771,'','How are we ever going to get out of here?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(12772,'','Thank you for taking care of the lake, the lashers and the owlkin, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12773,'','None will question your actions, $c.  You did what had to be done.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12774,'It is good to see you alive and well, $n!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12775,'Thank you again for replenishing our healing crystals.  I hear that you\'re helping out all over the place.  Keep up the good work!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12776,'I appreciate the company, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12777,'$n, what are you still doing here?  Have you spoken with Proenitus down at the crash site yet?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12778,'Mirren and I are two of the very best hunters on either side of the Dark Portal.  Stick around, you might learn a thing or two.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12779,'I hope yer not here for our ale.  We\'re not sharing and that\'s final!$B$BIt\'s not our fault no one had the good sense to bring beer to Outland but us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12780,'%s bursts, showering the area with arcane residue!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12781,'%s bristles with energy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12782,'','Here\'s to hoping not all of Outland is as barren as this region.  This is quite a change from the green grasslands and forests of Eversong.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12783,'There exist in Outland demonic presences much more powerful than anything we\'d ever seen in the old world.$B$BGreat power shall come to those who do not shy away from it, but learn to harness and master its strength.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12784,'I was born here, $r. This is my world - all that I know... As a boy, my mother and father would regale me with tales of your world and the splendor it held. How I longed to leave this place.$B$BAlas, fate is a cruel mistress. My mother and father have long since passed, buried in this very graveyard. I remain to uphold their honor and the honor of my family - the Sons of Lothar.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(12785,'I do not think enough attention is being paid to those trolls.  They could swarm in here anytime.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12786,'Does anyone need supplies to hunt down the trolls?  Any troll will do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12787,'Why do we ally with filthy stinking trolls?  The only good troll is a dead troll.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12788,'How may I serve?','How may I serve?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12789,'Be gone filthy creature!  Why anyone would tolerate your filth is beyond me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12790,'May I see your wares?','May I see your wares?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12791,'Outland just oozes with magical energy, it\'s in the very air.  Can you feel it, $n?  I can\'t think of a place better suited to our race.  Soon the sin\'dorei shall have a new land to call our own!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12792,'','My husband\'s been missing for days.  We went on this pilgrimage together; we were supposed to finish it together.$B$BAll this worry has gotten me tapping into mana crystals more often than I really should.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12793,'','Dragonhawks, if raised properly, are really quite tame.  Don\'t you think that is fascinating?  To be so friendly and companionable if raised right and so vicious and deadly in the wild...I just love them so much.',1,0,0,1,0,0,0,0,1,0,0,0,26124),
(12794,'Don\'t... worry... about me...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12795,'%s grunts in pain as he applies a splint to his injured leg.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12796,'','I really don\'t think our situation is so bad.  I am certain it will all be rectified soon and the Sunwell\'s power will be restored.  It just can\'t possibly be as bad as everyone is making it out to be.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12797,'Befriending the Sunstriders has paid off; I get to conduct research with subjects I can only find in Outland and they get... my charming personality and rugged good looks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12798,'Where do you want these bottles?','Where do you want these bottles?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12799,'Got another shipment for you, Sid.','Got another shipment for you, Sid.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12800,'Craziest thing - No matter how many bottles I take from the stockpile, the quantity on hand never decreases. It\'s like I\'m stuck in some endless loop of actions...','Craziest thing - No matter how many bottles I take from the stockpile, the quantity on hand never decreases. It\'s like I\'m stuck in some endless loop of actions...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12801,'Bless yer heart, soldier! Just put \'em in the back room.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12802,'Just leave \'em in the cellar.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12803,'%s nods.','%s nods.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12804,'I\'d like to fly to Thunder Bluff.','I\'d like to fly to Thunder Bluff.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12805,'I was only an infant when my father was deployed to this wasteland. All that I have ever known of him is what others have told me.$B$BDo your dreams change, $n? Mine do not. I have one dream: A crimson skyline envelops me as Legion, numbering beyond comprehension, battle in the distance. I kneel before the body of a man, presumably my father, and weep. As he is gasping for air, his body wholly crushed, he whispers something. Despite every effort, I am unable to hear what he is trying to tell me.','',1,1,1,0,0,0,0,7,1,0,0,0,26124),
(12806,'A gloom shrouds our lands, young $c.  Will you take up arms to face this flying death?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12807,'How long will the invasion last?','How long will the invasion last?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12808,'Holiday - Scourge Invasion, mystic - how long, Tier 0','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12809,'Holiday - Scourge Invasion, mystic - how long, Tier 1','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12810,'Holiday - Scourge Invasion, mystic - how long, Tier 2','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12811,'As I live and breathe! \"Little\" Arator? Is that you?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12812,'Aye, Commander; but I am little no more. I have come to find my father. Have you any news as to his whereabouts? I know that he still lives. I have seen it in my dreams...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12813,'%s looks at Arator grimly.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12814,'I am afraid that I do not, Arator. I have not seen or heard from your father in 15 years. We had long since presumed him dead. But know this: I did all that was in my power to try and find him. From the bounds of Hellfire to the ravages of Nagrand, we searched... All for naught. If I could give my own life to bring Turalyon back, I would do so a thousand times over. I... I am sorry.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12815,'As long as he remains unfound, I will search. I know that he lives. And I know that I must find him. I am thankful for what you have done, Commander. As my father called upon you, a brother in arms, know that you may call upon me. I am at your service, my Lord.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12816,'Soldier! Front and center!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12817,'SIR! YES, SIR! Reporting for duty, sir!','SIR! YES, SIR! Reporting for duty, sir!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12818,'At ease, Private. I have a mission for you. The last messenger I sent to Nethergarde didn\'t make it. We found his entrails scattered about the bone road a few hours ago. We suspect it may have been Legion or fel orc, maybe even Horde...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12819,'Sir, yes sir! Private will do their best to not die, sir!','Sir, yes sir! Private will do their best to not die, sir!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12820,'I need this message delivered to Watch Commander Netherwane at Nethergarde Keep. There\'s a commendation in it for you if you make it... Your horse is waiting at the stables. Dismissed!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(12821,'ONWARD!','ONWARD!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12822,'Protect the innocent!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12823,'Uphold the law!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12824,'Serve the public trust!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12825,'Dead!  They are all dead! At least I don\'t have to pay wages.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12826,'Wait \'til Nazgrel hears about this! It\'ll be my head! My head I say!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12827,'What am I to do?  My precious mine...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12828,'You will rue the day that you killed my crew! Rue it, I say!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12829,'','Marketing - iCoke Redemption Greeting (S.H.E. giftbox)',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12830,'Tell me about the iCoke gift box promotion.','Tell me about the iCoke gift box promotion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12831,'','iCoke - Description (S.H.E. giftbox)',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12832,'I might just have to go hunting for that Wretched beast now that there\'s a bounty on his head.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12833,'Tell us!  Where does your leader hide?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12834,'You\'re not getting anything until you speak, scum!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12835,'Please!  I must feed on something soon... A mana crystal.... a shard... anything!  The pain is unbearable!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12836,'Protect the Warchief at all costs!','Protect the Warchief at all costs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12837,'Death to the interlopers!','Death to the interlopers!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12838,'For Spinebreaker!','For Spinebreaker!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12839,'Your bones will be devoured!','Your bones will be devoured!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12840,'You think I\'m being cruel to this worm?$B$BThey\'ve killed two of my men this month!  We\'re too kind to this Wretched scum.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(12842,'','Welcome to Fairbreeze Village.  Silvermoon\'s all but given up on us, but we refuse to leave.  This is our home.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12844,'Kill them all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12845,'By the seven Ata\'mal crystals!  Others have survived the crash!  Zhanaa, is that you?  It is so good to see you again!','',4,0,0,0,0,0,0,7,1,0,0,0,26124),
(12846,'','This is great news!  Your efforts have indeed saved us, $n!',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(12847,'','My job consists of one task and one task only: ensuring that the West Sanctum runs smoothly.$B$BYou\'ll have to excuse my temper but, as you can see, the situation here is a bit out of hand.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12848,'','With the Emperors slain, the magical protection blocking teleportation within the temple has been greatly weakened. If you desire, I am able to translocate you to the Emperors\' lair.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(12849,'Teleport me to the lair of the Twin Emperors, please.','Teleport me to the lair of the Twin Emperors, please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12850,'','With Ouro slain the way is clear to the final chamber. I am able to transport you there, if you desire.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(12851,'Please teleport me to the final chamber.','Please teleport me to the final chamber.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12852,'','Your old lives, your mortal desires mean nothing... you are acolytes of the master now, and you will serve the cause without question! The greatest glory is to die in the master\'s service!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12853,'','The master will avenge me!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12854,'','You have failed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12855,'','Pathetic wretch!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12856,'','Slay them in the master\'s name!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12857,'','You cannot hide from me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12858,'','Kneel before me, worm!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12859,'','Run while you still can!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12860,'Enjoying the festival, $c?$b$bWhile the Flame Wardens tend to the fires of the present, I am more of a historian, keeping close the festivals past. I\'m also, of course, documenting this year\'s festivities. Things are going well thus far, don\'t you think?$b$bYou know, $n, there is power inherent in all festival fires burning throughout the holiday. We\'re taking care of ours, but I\'m certain there are sacred flames burning deep within our enemy\'s cities...','Enjoying the festival, $c?$b$bWhile the Flame Wardens tend to the fires of the present, I am more of a historian, keeping close the festivals past. I\'m also, of course, documenting this year\'s festivities. Things are going well thus far, don\'t you think?$b$bYou know, $n, there is power inherent in all festival fires burning throughout the holiday. We\'re taking care of ours, but I\'m certain there are sacred flames burning deep within our enemy\'s cities...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12861,'','Slay them!  Don\'t let the Scourge scum defile our city!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12862,'','The enemy approaches from the south.  Ready your weapons!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12863,'','The undead are approaching.  Attack!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12983,'','There, $n, I think I\'ve figured it out!',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(12984,'Who dares violate the sanctity of my domain? Be warned: all who trespass here are doomed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12985,'Fools! You think yourselves triumphant? You have only taken one step closer to the abyss!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12986,'I grow tired of these games. Proceed, and I will banish your souls to oblivion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12987,'You have no idea what horrors lie ahead. You have seen nothing! The frozen heart of Naxxramas awaits you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12988,'Soon we will eradicate the Alliance and Horde. Then the rest of Azeroth will fall before the might of my army.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12989,'Invaders... here?! DESTROY them, Kel\'Thuzad! Naxxramas must not fall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12990,'Your forces are nearly marshaled to strike back against your enemies, my liege.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12991,'Yes, master. The time of their ultimate demise draws close.... What is this?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12992,'As you command, master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12993,'Come, heroes... By the will of the Lich King, you shall be destroyed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12994,'Very well. Warriors of the frozen wastes, rise up! I command you to fight, kill and die for your master! Let none survive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12995,'Pray for mercy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12996,'Scream your dying breath!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12997,'The end is upon you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12998,'Master, I require aid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(12999,'Minions, servants, soldiers of the cold dark! Obey the call of Kel\'Thuzad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13000,'Just a little taste...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13001,'%s rushes to the aid of Stalagg!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13002,'There is no way out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13003,'Yes, run! It makes the blood pump faster!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13004,'Ahh... welcome to my parlor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13005,'Shhh... it will all be over soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13006,'I hear little hearts beating. Yes... beating faster now... soon the beating will stop.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13007,'Where to go? What to do? So many choices that all end in pain, end in death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13008,'Which one shall I eat first? So difficult to choose. They all smell so delicious...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13009,'Closer now. Tasty morsels. I\'ve been too long without food, without blood to drink.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13010,'','Defend yourself!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13011,'','Touche...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13012,'','Who\'s next?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13013,'','Your life is mine!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13014,'','Come, Zeliek, do not drive them out. Not before we\'ve had our fun!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13015,'','I do hope they stay alive long enough for me to... introduce myself.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13016,'','The first kill goes to me! Anyone care to wager?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13017,'Your soul is bound to me, now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13018,'There will be no escape!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13019,'Agghhhh! Do... not... rejoice! Your victory is a hollow one, for I shall return with powers beyond your imagining!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13020,'I will freeze the blood in your veins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13021,'The dark void awaits you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13022,'%s cackles maniacally.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13023,'Feed you to master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13024,'No... more... Feugen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13025,'Feugen make master happy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13026,'I... am... undone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13027,'Death is the only escape!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13028,'I have waited long enough. Now you face the harvester of souls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13029,'Foolishly you have sought your own demise. Brazenly you have disregarded powers beyond your understanding. You have fought hard to invade the realm of the harvester. Now there is only one way out- to walk the lonely path of the damned.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13030,'Foolishly you have sought your own demise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13031,'Brazenly you have disregarded powers beyond your understanding.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13032,'You have fought hard to invade the realm of the harvester.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13033,'Now there is only one way out- to walk the lonely path of the damned.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13034,'C\'mon an\' fight ye wee ninny!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13035,'What a bloody waste this is!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13036,'Next time, bring more friends!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13037,'I like my meat extra crispy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13038,'To arms, ye roustabouts! We\'ve got company!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13039,'I\'ve heard about enough a\' yer snivelin\'! Shut yer flytrap before I shut it for ye\'!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13040,'I\'m gonna\' enjoy killin\' these slack-jawed daffodils!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13041,'You are mine now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13042,'I see you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13043,'You... are next.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13044,'%s takes his last breath.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13045,'Close your eyes. Sleep.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13046,'The races of the world will perish. It is only a matter of time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13047,'I see endless suffering. I see torment. I see rage. I see everything...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13048,'Soon the world will tremble.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13049,'The end is upon you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13050,'Hungry worms will feast on your rotting flesh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13051,'You seek death?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13052,'None shall pass!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13053,'Be still!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13054,'I... am... released... perhaps it\'s not too late to- No! I need... more... time...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13055,'You will find no peace in death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13056,'The master\'s will is done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13057,'Bow to the might of the Scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13058,'Enough prattling. Let them come. We shall grind their bones to dust.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13059,'Conserve your anger. Harness your rage. You will all have outlets for your frustrations soon enough.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13060,'Life is meaningless. It is in death that we are truly tested.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13061,'Glory to the master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13062,'Your life is forfeit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13063,'Die, trespasser!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13064,'I will serve the master... in death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13065,'My task is done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13066,'Breathe no more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13067,'Rise, my soldiers! Rise and fight once more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13068,'Patchwerk want to play!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13069,'Kel\'thuzad make Patchwerk his avatar of war!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13070,'What... happen to-','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13071,'No more play?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13072,'I\'m just getting warmed up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13073,'Stand and fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13074,'Show me what you\'ve got!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13075,'Do as I taught you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13076,'Show them no mercy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13077,'You disappoint me, students!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13078,'The time for practice is over! Show me what you have learned!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13079,'An honorable... death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13080,'Sweep the leg... Do you have a problem with that?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13081,'You should have stayed home.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13082,'%s lets loose a triumphant shout.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13083,'Stalagg crush you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13084,'Master, save me!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13085,'Stalagg kill!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13086,'Kill...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13087,'Eat... your... bones...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13088,'Break... you!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13089,'Thank... you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13090,'Now you feel pain...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13091,'You are too late!! I... must... obey!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13092,'Hurry! Ple-e-ase hurry!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13093,'Sto-o-op! Make it stop!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13094,'Help me! Save me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13095,'No-o-o-o!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13096,'You... die now!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13097,'Flee, before it\'s too late!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13098,'It is... as it should be. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13099,'Forgive me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13100,'I have no choice but to obey!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13101,'Invaders, cease this foolish venture at once! Turn away while you still can!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13102,'Perhaps they will come to their senses... and run away as fast as they can.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13103,'Do not continue! Turn back while there\'s still time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13104,'Aurelon, some assistance please.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(13105,'I could use some help over here if you please.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(13106,'Paladin, perhaps you would lend a hand?  I just need another heal on that one.  Thank you.','',6,0,0,0,0,0,0,7,1,0,0,0,26124),
(13107,'Paladin Aurelon, if you have the mana to spare, could you help with that one, please?  Thank you.','',6,0,0,0,0,0,0,7,1,0,0,0,26124),
(13109,'Of course, Zalduun.','',2,0,0,0,0,0,0,7,1,0,0,0,26124),
(13110,'As you wish.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(13111,'My meager healing powers are at your disposal, Zalduun.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(13112,'As the Light wills.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(13113,'Oh no!  I\'m losing this one!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13114,'NO!!!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13116,'%s bows his head in prayer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13118,'','No...',18,0,0,0,0,0,0,7,1,0,0,0,26124),
(13119,'Enjoying the festival, $c? My wares can give an extra kick to your day. Nothing like warm food and drink!$b$bAnd if you haven\'t tried it yet, get a friend or two and celebrate around the ribbon pole; it\'s sure to lift your spirits!','Enjoying the festival, $c? My wares can give an extra kick to your day. Nothing like warm food and drink!$b$bAnd if you haven\'t tried it yet, get a friend or two and celebrate around the ribbon pole; it\'s sure to lift your spirits!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13120,'Let me see your festival fare.','Let me see your festival fare.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13121,'Can you feel it, pathetic creatures? The pall over this land is but a precursor. Soon your precious holdings will be in our grasp! You will fall before the might of the Lich King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13122,'Despair, mortals! Your doom has come!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13123,'Let this gloom serve to remind you: the shadow of the Scourge is all-encompassing! There is no escape!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13124,'As you fall in battle, we grow in strength. There is only one inevitable outcome. Prepare for your end!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13125,'Forward, my minions! Forward! Let none stand in our way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13126,'Cower before our might! Flee! There will be no victory for the living!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13127,'What manner of trap have we walked into?  Vindicators, ready your weapons!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13128,'You won\'t get away with this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13129,'Show me what you\'ve got, rookie!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13130,'Is that the best you can do?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13131,'You\'re not only wasting the time of your fellow students, you\'re wasting my time too.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13132,'Pathetic...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13133,'My granny, livin\' down in Redridge, hits dummies harder than you, rookie!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13134,'I think you signed up for the wrong job, initiate. Kel\'Thuzad don\'t need any flower girls...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13135,'Is this some kind of joke?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13136,'Start doing something before I replace that target dummy with you and begin a warm up session of my own!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13137,'Student is worthless, master! Student apologizes for his deficiency!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13138,'I am unworthy, master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13139,'Student will work harder, master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13140,'Sir, student requests that you beat him for his lack of understanding!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13141,'%s marks $n for an airstrike.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13142,'If you\'re looking for work, $c, grab yourself a pick and get to digging. There\'re ruins out there as far as the eye can see!','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(13143,'','Greetings, $n. My fellow Sons of Lothar and I have been stuck on this miserable world for close to twenty years now. We held on as best we could, but it still amazes me that the threats we face today are just the shadows of our past failures.$B$BPerhaps you will help us atone for them?  \n',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13144,'I don\'t suppose you\'ve come bearing news about the mines, have you?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(13145,'','The extent of the corruption in Outland is truly astonishing, $c. The Cenarion Circle hopes to understand how these creatures have managed to survive. Studying this broken, tortured land and its inhabitants may yet teach us how to heal ailing parts of our own world.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13146,'It is sad to see what has happened to this land.  The Cenarion Expedition will do what it can to understand and heal the damage that has been done.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13147,'You look lost, $c. Don\'t make me put you to work on the walls with the other peons.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13148,'','Well met, $c. Your arrival in Thrallmar could not have occurred at a better time. The warchief is depending on us, since he cannot be here himself.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13149,'Thrallmar needs you, $c. The warchief needs you. Stand ready to do your duty.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13150,'No!!! A curse upon you, interlopers! The armies of the Lich King will hunt you down. You will not escape your fate...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13151,'Greetings, $n. I am Johnny McWeaksauce. I am used as a tool by developers to carry out specific functions for the purpose of testing. For this test period, I am set to do two specific things:$B$B(1) Flag you as having done the Naxxramas attunement quest so that you are able to accept the next quest, \"Echoes of War\" from Commander Eligor Dawnbringer. You must first complete that quest to be able to access the quests for your Tier 3 armor set.$B$B(2) Teleport you to Naxxramas.$B$BWhat is it that you require?','',1,1,6,0,0,0,0,0,1,0,0,0,26124),
(13152,'%s shakes his head in dismay.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(13153,'I require flagging.','I require flagging.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13154,'I require a teleport to Naxxramas.','I require a teleport to Naxxramas.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13155,'%s sighs in regret.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(13156,'Greetings, $n. I see that you are already flagged as having completed the quest to gain entry to Naxxramas. Be sure to speak with Commander Eligor Dawnbringer at Light\'s Hope Chapel in the Eastern Plaguelands to acquire the quest, \"Echoes of War.\" You must first complete that quest to be able to access the quests for your Tier 3 armor set.$B$BI am able to teleport you directly to Naxxramas or you may use the portal found in Plaguewood, to the west.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13157,'Fools!  You seek to abjure my father\'s presence?  Death awaits you, mortals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13158,'','Could night elf saboteurs be behind this?  I doubt it.  With the load we\'ve been putting on the West Sanctum it was only a matter of time until something went wrong.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13159,'So you\'ve conquered a small spot of land. A minor setback! I will reign here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13160,'Enjoy your small victory while you can, mortals. It will not stop my eventual triumph over this land!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13161,'There is no victory for you here! What little ground you\'ve gained will be swallowed by my army in due course!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13162,'The shadow of the Scourge yet remains on this land, fools! You will never prevail!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13163,'So, the frail members of the living have some teeth after all. Take this place, then, for the time being. I will return, twice as strong, and your paltry forces will fall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13164,'You dare disrupt my works here?! Take this time to prepare yourselves... when I return, there will be nothing but death and destruction in my wake!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13165,'You may think you have won, worms, but against the might of the Lich King there is no victory for the living! You have not seen the last of me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13166,'%s shimmers and disappears!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13167,'Few bouts are won by sheer strength.  It is cunning, reflexes and knowledge of your weapon that wins the day in the end.','Few bouts are won by sheer strength.  It is cunning, reflexes and knowledge of your weapon that wins the day in the end.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13168,'Show me what you know, Larenis.','Show me what you know, Larenis.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13169,'Do you truly believe you are doing well? Hah! My forces are limitless!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13170,'You may succeed on the field of battle briefly... but you cannot hope to win against my Scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13171,'','Open wide, Jir\'see.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13172,'You\'ve reclaimed a few paltry territories. Pathetic. In short order they will again be mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13173,'Do you truly believe you\'re making progress? You can never defeat my Scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13174,'Think you the master is daunted by your games? We will never fall to you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13175,'You fools! Keep fighting, if that is your wish! With every battle, more of you fall, and the ranks of my undead swell!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13176,'The toils of the living never cease to amaze. Your numbers are limited, and with every battle they dwindle further. You will not live to see the end!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13177,'Do you truly believe you can win against the armies of the Lich King? No army of the living, no power you could possibly bring to bear can destroy my ranks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13178,'This constant, annoying resistance is futile, you maggots! There will be nothing in the end but death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13179,'','That\'s my little Jir\'see! We\'ll make you into one of those netherhounds yet!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13180,'My strength.... is... returning!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13181,'You\'ve found a cure!  We will crush our enemies!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13182,'You\'ve restored my health!  I\'m in your debt, $n.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13183,'%s whispers something unintelligible.','%s whispers something unintelligible.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13184,'Everybody settle down! We\'re doing our best to get the situation under control. Them bleedin\' orcs are unrelenting!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13185,'Go with the Light.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(13186,'%s sobs.','%s sobs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13187,'%s clenches $g his:her; fists in anger.','%s clenches $g his:her; fists in anger.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13188,'We can\'t even leave our houses anymore! The attacks are never ending!','We can\'t even leave our houses anymore! The attacks are never ending!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13189,'The graveyard on the hill is filling up faster than we can dig the holes on some days.','The graveyard on the hill is filling up faster than we can dig the holes on some days.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13190,'Will we ever be able to go back home?','Will we ever be able to go back home?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13191,'I buried my son today, Thalvos... And my spouse last week.','I buried my son today, Thalvos... And my spouse last week.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13192,'They say that there\'s gonna be another attack... None are to be left alive...','They say that there\'s gonna be another attack... None are to be left alive...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13193,'Nerzhul will never give up. Where are our heroes?','Nerzhul will never give up. Where are our heroes?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13194,'Trollbane alone cannot fight back the combined might of the orcish Horde. We are done for...','Trollbane alone cannot fight back the combined might of the orcish Horde. We are done for...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13195,'We want answers, Lieutenant! We\'re entitled to know the truth!','We want answers, Lieutenant! We\'re entitled to know the truth!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13196,'Even as my health fails me... it\'s my duty to serve... the Clans!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13197,'<Administer the Healing Salve.>','<Administer the Healing Salve.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13198,'Where is the master?','Where is the master?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13199,'Where has the master gone?','Where has the master gone?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13200,'I must see the master at once!','I must see the master at once!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13201,'Why can we not talk to the master?','Why can we not talk to the master?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13202,'The Master is deep in study.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13203,'The Master is resting after his labors.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13204,'The Master will return from Stormwind soon....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13205,'The master has business in the rooms above.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13206,'The master is meeting with his apprentice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13207,'Another hero? The fates smile upon us on this day, $n. ','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(13208,'Your meal is ready, sir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13209,'As you requested.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13210,'At your service, sir, as always.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13211,'Such a shame for this food to go to waste. Oh, well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13212,'Where has he gone?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13214,'Thank you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13215,'All this fuss just for me?\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13216,'Appreciated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13217,'Another meal, another triumph!','Another meal, another triumph!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13218,'It is Gul\'dan!','It is Gul\'dan!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13219,'What exactly is going on upstairs, anyway?','What exactly is going on upstairs, anyway?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13220,'%s gasps.','%s gasps.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13221,'He appeared from thin air!','He appeared from thin air!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13222,'That joke... I swear I laugh every time!','That joke... I swear I laugh every time!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13223,'%s whispers something unintelligible.','%s whispers something unintelligible.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13224,'Kneel! Kneel fools!','Kneel! Kneel fools!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13225,'What are we doing here?','What are we doing here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13226,'Why has this gathering been called?','Why has this gathering been called?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13227,'%s whispers something to their compatriot.','%s whispers something to their compatriot.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13228,'I\'ve heard something of your exploits, $n.  I know that while you\'re here in Forsaken lands that you\'ll comport yourself with dignity and as a true hero of the sin\'dorei!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13229,'I\'m positively stuffed; I can\'t eat another bite! Well, perhaps just one more...','I\'m positively stuffed; I can\'t eat another bite! Well, perhaps just one more...\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13230,'I fear the worst.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13231,'','What are they going to do with it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13232,'','%s points to the draenei captive.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13233,'Every dish is more delicious than the last!','Every dish is more delicious than the last!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13234,'A feast fit for royalty!','A feast fit for royalty!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13235,'And so then he says \"I was talking to the chicken!\"','And so then he says \"I was talking to the chicken!\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13236,'That joke kills me!','That joke kills me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13237,'Does anyone else remember how we got here? Is it just me...?','Does anyone else remember how we got here? Is it just me...?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13238,'Where did I live before this? I used to know. At least I thought I did....','Where did I live before this? I used to know. At least I thought I did....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13239,'Ahh, life is good.','Ahh, life is good.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13240,'I\'ve never been so happy! I wish this night would never end!','I\'ve never been so happy! I wish this night would never end!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13241,'Waiter, another ale!','Waiter, another ale!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13242,'Waiter, more wine!','Waiter, more wine!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13243,'Waiter, where is my hasenpfeffer?','Waiter, where is my hasenpfeffer?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13244,'Gladly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13245,'No sooner said than done, sir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13246,'I\'ll check on that right away.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13247,'','I saw some killing children in battle. The bloodlust was upon them - I could not condone it but I could see how it could happen, but surely they will not make a ritual sacrifice out of this defenseless captive.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13248,'I hope you are right.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13249,'Today is a glorious day for the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13250,'All quiet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13251,'Who goes there?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13252,'Am I hearing things?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13253,'I would like to enter the secret code to receive my Zergling pet.','I would like to enter the secret code to receive my Zergling pet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13254,'Hail!  You look familiar... have we met before?$B$BWell if we have met, then... surely you were given a secret code. Tell me your code and I will give you a gift!','Hail!  You look familiar... have we met before?$B$BWell if we have met, then... surely you were given a secret code. Tell me your code and I will give you a gift!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13255,'','Over there! They\'re following us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13256,'You have all seen this portal being built, admired the craftsmanship and how it stands as a monument to the glory of the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13257,'Now, I will reveal to you the visions I have had.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13258,'%s points to the monolothic structure known as the Dark Portal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13259,'Far, far away, in a land called Azeroth, I have an ally. He offers us his land. It is green and lush, filled with pure water and fat creatures to hunt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13260,'Best of all, we will continue to exalt in the glory of bloodshed. A race called \'humans\', the enemy of our ally, will try to stop us from taking their lands.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13261,'We will destroy them. Their blood-red blood-will flow freely upon our swords. As we have destroyed the Draenei, so now we will destroy the humans!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13262,'%s gestures for silence.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13263,'','%s shakes her head in disbelief.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13264,'','How can they still feel this way? Can they not see this new land will suffer as ours has if we continue on this path?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13265,'%s nods in agreement.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13266,'But at the same time, there is no choice. We need food, water. We must go through this portal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13267,'Even now, our ally is working to open the portal on his side. And now, we will begin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13268,'%s gestures to the draenei captive.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13269,'Blood is a pure offering to those who give us these vast powers.  And the blood of an innocent is purer still.  With the life fluid of our enemies, we will open the portal and step into a glorious new world - a new page in the history of the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13270,'NO!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13271,'Gul\'dan, what have you done to us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13272,'These are our scouts! They have already gone through the Dark Portal. They return to you with news of the new world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13273,'It is true! All is as you promised us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13274,'This is the moment of destiny! On the other side, a new beginning awaits. A new enemy to slaughter. You can feel it, can you not? The bloodlust rising? Follow Blackhand! Listen to his orders and you will rule this new world as is your right! It is your world on the other side of the portal. Take it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13275,'FOR THE HORDE!','FOR THE HORDE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13276,'FOR THE HORDE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13277,'FOR THE HORDE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13278,'Waiter, another bottle, and be quick!','Waiter, another bottle, and be quick!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13279,'Of course, sir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13280,'%s begins to weaken as its energy bleeds away.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13281,'This music never gets old, does it?','This music never gets old, does it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13282,'It\'s so strange: I can\'t remember how I came to be here.','It\'s so strange: I can\'t remember how I came to be here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13283,'I feel as though there\'s a task I have yet to complete....','I feel as though there\'s a task I have yet to complete....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13284,'For the life of me I don\'t know why I\'m here, but I\'m having the best time!','For the life of me I don\'t know why I\'m here, but I\'m having the best time!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13286,'This all seems so strange.','This all seems so strange.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13287,'Perhaps just one more dance. Then I really must be leaving! I have to get back to... to...','Perhaps just one more dance. Then I really must be leaving! I have to get back to... to...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13289,'','Thank you for agreeing to help. Now, let\'s get out of here, $n!',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(13290,'','Allow me a moment to rest. The journey taxes what little strength I have.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13291,'Another drink!','Another drink!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13292,'','Falcon Watch, at last! Now, where\'s my... Oh no! My pack, it\'s missing! Where has - ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13293,'More food! More wine!','More food! More wine!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13294,'I believe I\'ll try the merlot this time.','I believe I\'ll try the merlot this time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13295,'As you wish.','As you wish.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13296,'Without delay!','Without delay!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13297,'Right away!','Right away!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13298,'Keep the drinks coming; it\'s going to be a long night!','Keep the drinks coming; it\'s going to be a long night!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13299,'Practice as if your life depends on it, because it does!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13300,'What kind of pathetic strike was that? Shape up at once!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13301,'You block like a little girl! Put your shoulder into it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13302,'You had better straighten up, or you\'ll answer to me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13303,'','I bid you welcome, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13304,'I haven\'t time for idle chatter, $c. I must see to the pilgrims and ensure they are prepared for the long journey ahead.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(13305,'Welcome to Falcon Watch, $c. I see to the needs of the pilgrims and help them in continuing their long journey. If you haven\'t yet undertaken the pilgrimage, I can provide you with the information you will need.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13306,'Greetings, $c.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(13307,'Yes, sir!','Yes, sir!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13308,'','Walk always in the Light, $n.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13309,'','Welcome to the Farstrider Retreat.  We are rangers sworn to defend our people from enemies both near and far.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13310,'Shay, what\'sh your deal anwaysh? Are you shome kind of elf or shomethin? You looksh shorta familiar.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13311,'I am Arator, son of Turalyon and Alleria. So yes, Father, I am \"shome\" kind of elf: half-elf to be precise.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13312,'%s\'s face turns white. Sobriety seems to have set in rather quickly.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13313,'By the Light! So this is why you look familiar. Is this fate? Destiny perhaps? Arator, your father and I were the best of friends. It is I who kept him in good health... Oh the battles we fought... And...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13314,'%s clears his throat.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13315,'And... the battle we lost. I... I\'m sorry, Arator. It was my fault...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13316,'%s begins to sob.','%s begins to sob.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13317,'Quickly, Sid. Fill my tankard. Make the memories fade...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13318,'Oh brother... Listen, he\'s gonna be here crying like a baby for another five hours. If you\'re really the son of Turalyon, go speak with Trollbane. He\'s in the keep - top floor.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13319,'%s nods.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13320,'Take care of him, Sid. He may be the only link I have to my father and mother. He needs to sober up...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13321,'','I think I\'m beginning to regret undertaking this pilgrimage. I anticipated that the road would be rough and I\'m no stranger to travel, but I wasn\'t prepared for the rigors of Outland.$B$BOn top of everything else, that Taleris seems to want to push me out of here before I\'ve regained my strength completely.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13322,'Farewell, Commander. I will be staying at the inn, should you require my services.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13323,'Yes... this will do nicely.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13324,'An unstable source.... but its warmth beckons me!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13325,'Wake up, Gal\'ressa.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13326,'','%s rubs the sleep from her eyes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13327,'','What do you want, Taleris?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13328,'You\'ve had enough time to recover from your wounds, Gal\'ressa. The time has come for you to return to the road.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13329,'','I\'m not going on alone, Taleris, and that\'s final. I\'m going to wait here for the next group of pilgrims and set out with them when they depart.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13330,'You\'ll do no such thing. We simply haven\'t the room to keep you here. Now, kindly be on your way.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13331,'','By the Sunwell, you\'ve a thick skull! You\'ll not bully me into leaving, Taleris. Now, begone from my sight!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13332,'Very well then, have it your way. When we turn others away, you will be responsible for their suffering. Think about that.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13333,'I wish I had tickets for tonight\'s show!','I wish I had tickets for tonight\'s show!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13334,'I heard last night\'s performance was spectacular!','I heard last night\'s performance was spectacular!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13335,'It\'s much easier to talk up here without all that music.','It\'s much easier to talk up here without all that music.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13336,'This all seems so familiar, like I\'ve been here before.','This all seems so familiar, like I\'ve been here before.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13337,'Perhaps later we should join the dance.','Perhaps later we should join the dance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13338,'I\'m quite sure there was a reason I came here....','I\'m quite sure there was a reason I came here....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13339,'Oh... do I know you?','Oh... do I know you?',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(13340,'Hi, $n!  Enjoying the party?','Hi, $n!  Enjoying the party?',5,0,0,0,0,0,0,1,1,0,0,0,26124),
(13341,'Hey everyone, it\'s $n!','Hey everyone, it\'s $n!',4,0,0,0,0,0,0,1,1,0,0,0,26124),
(13342,'Word travels fast in this circle.  Thanks for restocking the supplies!','Word travels fast in this circle.  Thanks for restocking the supplies!',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(13343,'This party is just the best!  Don\'t you agree?','This party is just the best!  Don\'t you agree?',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(13344,'You should try the springpaw appetizers, they\'re to die for!','You should try the springpaw appetizers, they\'re to die for!',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(13345,'Hmm... I think this year\'s Suntouched Special isn\'t so special after all.  Wouldn\'t you agree, $n?','Hmm... I think this year\'s Suntouched Special isn\'t so special after all.  Wouldn\'t you agree, $n?',1,6,0,0,500,0,0,1,1,0,0,0,26124),
(13346,'I heard a rumor that we\'re all going to go watch the battle with the Scourge at the border tonight.  How delightfully wicked!','I heard a rumor that we\'re all going to go watch the battle with the Scourge at the border tonight.  How delightfully wicked!',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(13347,'Can you believe the nerve of that Elisara Sunstriker?  Thinking that she can catch the eye of Lord Saltheril?  And did you see what she\'s wearing?  So last season.  It\'s sad, really.','Can you believe the nerve of that Elisara Sunstriker?  Thinking that she can catch the eye of Lord Saltheril?  And did you see what she\'s wearing?  So last season.  It\'s sad, really.',6,6,0,0,500,0,0,1,1,0,0,0,26124),
(13348,'Sorry, I don\'t speak with the help.','Sorry, I don\'t speak with the help.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(13349,'And you would be?','And you would be?',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(13350,'I\'m afraid you have me confused with someone who wants to talk to you.','I\'m afraid you have me confused with someone who wants to talk to you.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(13351,'Ugh... go away!','Ugh... go away!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13352,'Huh, what?  What happened?','Huh, what?  What happened?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13353,'Go away.. I\'m tryin\' to shleep here.','Go away.. I\'m tryin\' to shleep here.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13354,'Ack, I don\'t feel so good.','Ack, I don\'t feel so good.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13355,'','Salthy, do you think we\'re letting too many \'undesirables\' into the party?  I do worry about what our friends might think of all of this.',6,1,0,0,500,0,0,1,1,0,0,0,26124),
(13356,'','You promised to take me out for a night on the town!  Are we just going to stand around here again tonight?',5,6,0,0,500,0,0,1,1,0,0,0,26124),
(13357,'I hate having to do that.','I hate having to do that.',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(13358,'They just keep attacking.  There\'s nothing else that I can do but put them down.','They just keep attacking.  There\'s nothing else that I can do but put them down.',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(13359,'I hope this ends soon.  Having to kill these owlkin, mutated or not, is making me sick.','I hope this ends soon.  Having to kill these owlkin, mutated or not, is making me sick.',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(13360,'Light take these creature\'s spirits into your arms!','Light take these creature\'s spirits into your arms!',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(13361,'','%s whispers something in the Dame\'s ear.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13362,'','%s nods her head yes at what her advisor has to say.',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(13363,'','%s disagrees with whatever it is that Valwyn has whispered to her.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(13365,'','%s seems nonplussed by whatever it is that her advisor has whispered in her ear.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(13366,'%s turns to Advisor Valwyn and winks lasciviously in her direction.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(13367,'','%s looks disgusted at the deathstalker\'s flirtations.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(13368,'%s cackles maniacally as he combines the two mixtures in his hands.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13369,'Drat!  This bloodthistle extract doesn\'t seem to want to combine properly with my poison.  I\'ll not be deterred - those trolls will be dealt with!  Perhaps a different mixture?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(13370,'While the soldiers of our army put their steel to our enemies, the actual efficacy of such attacks is questionable - a diversion at best. It is through the arcane that our enemies will crumble and fall before us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13371,'Watch and learn, students. Only through discipline and practice will you achieve such results.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13372,'The taskmaster\'s dead!  Quick, Dreghoods!  Run!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13373,'Flee!  Flee!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13374,'This is our chance!  Run for it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13375,'This is your standard fireball.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13376,'We use frost to chill their bones and bring their movement to a halt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13377,'For multiple targets, bring a blizzard down upon their heads.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13378,'Last, but certainly not least, we have the pyroblast. This is for when you absolutely, positively want to make a lasting first impression.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13379,'You\'ll go nowhere worms!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13380,'Return at once or suffer the master\'s wrath!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13381,'You\'ll soon beg for death if you don\'t return at once, wretches!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13382,'','Hey!  Could you come over and get me out of this cage?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13383,'','HELP!!!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13384,'','Get me out of here and I guarantee there\'ll be a reward in it for you!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13385,'','Quick, kill all of these trolls and then let me out of this thing!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13386,'','If you let me out I promise that you won\'t regret it!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13387,'','If you don\'t mind hurrying it up?  I think they\'re getting ready to sacrifice me!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13388,'Another pilgrim has arrived! Bring water quickly, or we may lose her!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13389,'','Do you hear something?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13390,'I\'ve managed to work myself into quite a spot here. Far Seer Regulkut tried to warn me, but my carelessness has finally caught up with me.$B$BI came down here to study the ruins of Zeth\'Gor, but ran afoul of the Legion on my way. Now, all I have to show for it is a nasty gash on my leg.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13391,'Though I cannot offer you training, young $c, I can give you my blessing.  Walk boldly in the Light!$B$BIs there anything else?','Though I cannot offer you training, young $c, I can give you my blessing.  Walk boldly in the Light!$B$BIs there anything else?',1,6,0,0,500,0,0,0,1,0,0,0,26124),
(13392,'','It is very important that we find out what the the night elves are up to, $c! Please concentrate all of your efforts toward that end.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13393,'Not long ago, this place was the site of a terrible battle.  We of Nethergarde and the Argent Dawn held at bay a wave of demons, surging relentlessly from the Dark Portal.$B$BThose were dark days, full of bloodshed and despair...$B$BBut the Kingdoms of Azeroth soon joined us and pushed the monsters back!  The fighting continues on the far side of the Portal...$B$BThis camp is now calm, but I fear the quiet here belies the madness found through that hellish gate.','',1,5,1,0,0,0,0,0,1,0,0,0,26124),
(13394,'The heroics of the Trollbane bloodline are legendary. I idolize the man.$B$BAnd to find him alive, in the Outland...$B$B<Romus gazes past you.>$B$BWhen I first saw him, I nearly fainted. The shock was overwhelming. As I knelt before him, I had to fight back tears.$B$BYou can bet your sweet behind that I\'m going to do everything in my power to make sure the Sons of Lothar are kept safe.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(13395,'Romus informed me of the tragedies that beset my beautiful city. There are no fitting words for the sorrow I felt upon hearing of Lordaeron\'s fate - and the fate of my own, beloved Stromgarde.$B$BTwenty years ago, no one had heard of the \'Burning Legion\'... Damn those cursed devils!$BRest assured, $n; should I ever return to Azeroth, Stromgarde will once more rise as a force of reckoning. This I swear...','',1,1,25,0,0,0,0,0,1,0,0,0,26124),
(13396,'','Your impurity must be cleansed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13397,'','Such... dark... energy!  How can this be possible?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13398,'Hey! Where do you think you are going, sneaking around like that?','Hey! Where do you think you are going, sneaking around like that?',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(13399,'Excuse me, are you trying to sneak by without an invitation?','Excuse me, are you trying to sneak by without an invitation?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13400,'$n, you too shall serve the Master!','$n, you too shall serve the Master!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13401,'Pledge your loyalty to the Master, $gSir:Madam;, and your life shall be spared!','Pledge your loyalty to the Master, $gSir:Madam;, and your life shall be spared!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13402,'','This emitter is driving me nuts!  I\'m missing all sorts of parts that I need to fix it.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13403,'','$n!  Thanks again for all the help.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13404,'','Nope, still not done with these repairs.  Shouldn\'t be long though.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(13405,'%s siphons the energy from the totem and redirects it in the form of an anti-magic pulse.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13406,'%s siphons the blessing of wisdom\'s energy and redirects it in the form of an anti-magic pulse.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13407,'Oh no!  Where are we?  What happened?  Look, there\'s part of the ship!','Oh no!  Where are we?  What happened?  Look, there\'s part of the ship!',6,0,0,0,0,0,0,35,1,0,0,0,26124),
(13408,'The last thing I remember is the ship falling and us getting into the pods.  I\'ll go see how I can help.  Thank you!','The last thing I remember is the ship falling and us getting into the pods.  I\'ll go see how I can help.  Thank you!',1,0,0,0,0,0,0,35,1,0,0,0,26124),
(13409,'Where am I?  Who are you?  Oh no!  What happened to the ship?','Where am I?  Who are you?  Oh no!  What happened to the ship?',6,0,0,0,0,0,0,35,1,0,0,0,26124),
(13410,'Ugh... what is this place?  Is that all that\'s left of the ship over there?','Ugh... what is this place?  Is that all that\'s left of the ship over there?',6,0,0,0,0,0,0,35,1,0,0,0,26124),
(13411,'Ughhh... I hurt.  Can you help me?','Ughhh... I hurt.  Can you help me?',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(13412,'Oh, I hurt all over. Can you help me?','Oh, I hurt all over. Can you help me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13413,'<Sobbing> I hate graveyards.  So many dead.  And my sweet Luhanaa....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13414,'%s weeps softly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13415,'%s stares in silence at the grave marker before him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13416,'%s breaks down into huge, wracking sobs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13417,'%s bows his head and sighs, clearly exhausted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13418,'Why, Luhanaa?  Why?!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13419,'It should have been me!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13420,'I\'ll never forget you, my love.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13421,'We should never have come along.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13422,'I miss you so much!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13423,'If I ever find the ones responsible for the crash...!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13424,'You\'ll always be here, with me.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13425,'Be at peace, my sweet, sweet, Luhanaa.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13426,'We won\'t allow you to leave this valley!','We won\'t allow you to leave this valley!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13427,'What a pity you survived the crash just to die here.','What a pity you survived the crash just to die here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13428,'I hope you\'ve made your peace.','I hope you\'ve made your peace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13429,'None of you are to leave this valley alive.','None of you are to leave this valley alive.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13430,'%s lifts its head into the air, as if listening for something.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13431,'A giant worm-like creature just erupted from the earth near Hive\'Ashi!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13432,'Look, there! By Hive\'Regal! Is that... a sandworm?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13433,'Be on your guard! There are reports of a humungous worm close to Hive\'Zora!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13434,'Something stirs near Southwind Village! It... it\'s one of those sandworm creatures! Look out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13435,'How dare you spill the master\'s wine!','How dare you spill the master\'s wine!',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(13436,'That was a 200 year old Pupellyverbos Port!','That was a 200 year old Pupellyverbos Port!',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(13437,'That was wasted on the likes of you!','That was wasted on the likes of you!',14,0,0,0,0,0,0,0,1,0,0,0,26124),
(13438,'How dare you disturb the master\'s dinner!','How dare you disturb the master\'s dinner!',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(13439,'%s calls for her master!','%s calls for her master!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13440,'Oh, the pain...','Oh, the pain...',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(13441,'Everything hurts. Please, make it stop...','Everything hurts. Please, make it stop...',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(13442,'I don\'t know if I can make it. Please help me...','I don\'t know if I can make it. Please help me...',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(13443,'Anub\'Rekhan begins to unleash an insect swarm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13445,'%s mounts his steed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13446,'%s lets out a howl that rings across the mountains to the north and motions for you to follow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13447,'Avruu\'s magic is broken!  I\'m free once again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13448,'Avruu\'s magic... it still controls me.  You must fight me, mortal.  It\'s the only way to break the spell!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13449,'Activating defense mode EL-7M.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13450,'Activating defense mode EL-5R.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13451,'Activating defense mode EL-2S.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13452,'Remember to always show your respect for the elements of the world.','Remember to always show your respect for the elements of the world.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13453,'We must strive to understand the balance maintained by this world\'s elemental spirits.','We must strive to understand the balance maintained by this world\'s elemental spirits.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13454,'%s attacks with renewed vigor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13455,'%s rushes to her master\'s aid.','%s rushes to her master\'s aid.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13456,'Come Midnight, let\'s disperse this petty rabble!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(13457,'Come Midnight, let\'s disperse this petty rabble!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13458,'%s cries out in pain!','%s cries out in pain!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13459,'Cowards! Wretches!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13460,'It was... inevitable.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13461,'One more for dinner this evening.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13462,'Always knew... someday I would become... the hunted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13463,'','Hello!  So good to meet you!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13464,'','Greetings.  You are here to help?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(13465,'','Just remember, $n, it\'s in our best interests that you do as much as possible for these... these people.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13466,'','Greetings, $r!  I trust this day finds you well?',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(13467,'','Any news from home, $c?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(13468,'Come closer, friend.  Do not let my eyes startle you.$B$BI might have lost my sight many years ago but I never needed it to see the things that really matter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13469,'','Victory for the Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13470,'We\'ve done it!  Victory to the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13471,'','Grab a net, young $c. Our people need sustenance!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(13472,'Hello.  I trust that this day finds you well?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(13473,'Please teach me how to fish, Diktynna.','Please teach me how to fish, Diktynna.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13474,'I wish to browse your wares, Diktynna.','I wish to browse your wares, Diktynna.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13475,'It\'s so good to see another sin\'dorei $g brother : sister;!  As you can imagine, there\'s not much in the way of conversation around here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13476,'','We have one quarter of our needed silithyst! Keep it up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13477,'','We have half our needed silithyst.  Don\'t stop now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13478,'','We have almost all the silithyst we need!  For the Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13479,'We have one quarter of the needed silithyst! Keep it up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13480,'We have half of our needed silithyst.  We can do it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13481,'We have almost all the silithyst we need!  Don\'t stop now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13482,'I am honored to make your acquaintance.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(13483,'So good of you to speak with me.  Please, help the Alliance in any way that you can.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13484,'Greetings.  I am Anchorite Delan - one of the draenei.  I am a teacher of sorts.  And who might you be?','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(13485,'While we have much to teach the other races of the Alliance, we have as much to learn from them.  Keep your eyes, ears and mind open, $c.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13486,'','Hail to thee, $c.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(13487,'','Is this city not beautiful, $c?  It warms my heart that we have found such good friends in these night elves.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(13488,'','Greetings,  I am Vindicator Palanaar, a traveling paladin of the Light.  I am here to be of assistance to the night elves.',2,1,0,0,500,0,0,0,1,0,0,0,26124),
(13489,'','It is my fervent hope that we will be able to bring the Light to those places in Ashenvale where it has been forsaken.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13490,'Weapons are merely a convenience for a warrior of my skill!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13491,'Transport me to the Molten Core, Lothos.','Transport me to the Molten Core, Lothos.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13492,'Your petty magics are no challenge to the might of the Scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13493,'I am far too busy to be wasting time on idle chatter. If you are looking for work as a huntsman, speak with Diktynna at the river\'s edge -- to the east. No doubt she\'s behind on her duties...','',1,25,0,0,0,0,0,0,1,0,0,0,26124),
(13494,'I am a hunter in need of training, Acteon.','I am a hunter in need of training, Acteon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13495,'','This is going to be such fun!  Don\'t you think, my dear?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13496,'Gaze upon the Exodar, young $r. It is hard to imagine that we survived such a catastrophe.$B$B<Menelaous sighs.>$B$BThe Prophet states that it is here that our fate will finally be known. Ten lifetimes spent fleeing from the madness of the Burning Legion... here we finally make a stand.$B$BNo more running... I am ready to die.','',1,1,273,0,0,0,0,0,1,0,0,0,26124),
(13497,'','Get word to Balandar Brightstar. He\'ll know what to do.',20,0,0,0,0,0,0,0,1,0,0,0,26124),
(13498,'','Did Balandar Brightstar send you to rescue me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13499,'Balandar sent me to get you out of here and reclaim his cargo. He\'s waiting for you in Brackenwall Village.','Balandar sent me to get you out of here and reclaim his cargo. He\'s waiting for you in Brackenwall Village.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13500,'','I think I can make it to Brackenwall on my own. They\'ve got the cargo at the top of the tower. Be careful!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13501,'','Oh, most excellent!  That was great fun, was it not?  Little by little I\'ve been cursing more of those disgusting Lost Ones.  Soon enough I\'ll be ready to try it on the draenei!',11,1,0,0,500,0,0,0,1,0,0,0,26124),
(13502,'','May the spirits guide you, $r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13503,'Strength to the Clans, $c!  What brings you here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13504,'Greetings.  I am Anchorite Avuun of the draenei.  I am here studying the Lost Ones of the Fallow Sanctuary in the hope of being able to find a cure for their condition.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13505,'You are welcome among us, $c.  At least for the time being.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13506,'Once more, thank you for your assistance with the cursed Lost Ones.  Without your help I would never have been able to continue my research.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13507,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13508,'','%s removes the reagents from the crate and mixes portions of each in a flask.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13509,'','I\'ve endured much hardship to complete my research and with your help, $n, I\'ve finally done it. Here\'s to a brighter future!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13510,'','I feel... lightheaded... What\'s... happening to me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13511,'','No, this can\'t be! This tonic... it was supposed to reverse my addiction, not hasten my descent into the ranks of the Wretched!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13512,'','Welcome, kind spirit.  What has brought you to us?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13513,'I\'m not finished yet! No, I have a few more tricks up my sleeve...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13514,'Surely you wouldn\'t deny an old man a replenishing drink? No, no, I thought not.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13515,'%s begins channelling his mana into a powerful arcane spell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13516,'Ah, nothing like a good drink!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13517,'Yes, yes my son is quite powerful... but I have powers of my own!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13518,'I am not some simple jester! I am Nielas Aran!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13519,'I\'ll show you: this beaten dog still has some teeth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13520,'Burn, you hellish fiends!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13521,'I was among the greatest of the Kirin Tor. You shall not defeat me idling about!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13522,'I\'ll freeze you all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13523,'Back to the cold dark with you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13525,'Even death won\'t prevent me from uncovering the secrets of my son!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13526,'I want this nightmare to be over!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13527,'Torment me no more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13529,'Please, no more! My son... he\'s gone mad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13530,'Who are you? What do you want? Stay away from me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13532,'Where did you get that? Did HE send you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13536,'Come down from there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13537,'My people have survived in Outland...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13538,'Unnoticed for years...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13539,'...uncorrupted!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13540,'I\'ll be fine, Eitrigg.  We must begin preparations... I need to go to Outland at once!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13541,'You are right, Eitrigg.  The timing is unfavorable.  Make sure our best ambassadors are sent as envoys to Hellscream.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13542,'Thrall!  My lord... are you all right?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13543,'With all due respect, Warchief.  Our enemies would take advantage of your sudden absence if we don\'t prepare properly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13544,'At once, sir!  For the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13545,'','Isn\'t that adorable! How did you make it out of the Vale? Maybe you should get back there before someone sends a search party after you.',4,6,1,0,0,0,0,0,1,0,0,0,26124),
(13546,'','I haven\'t got anymore work for you, $n. I do want you to know that the red snapper we shared was something special that I\'ll never forget...',1,24,0,0,0,0,0,0,1,0,0,0,26124),
(13547,'Of course I\'ve got a job for you! We\'re always looking for $cs. Hopefully you\'ll fare better than the draenei we had to send back to the Exodar -- for burial.$B$B<Acteon laughs.>$B$BI\'m joking! You should have seen the look on your face. They got sent back to the Exodar for treatment of minor wounds. Nothin\' that they won\'t recover from...','',5,1,11,0,0,0,0,0,1,0,0,0,26124),
(13548,'Quit running around, $n!','',7,7,0,0,2,0,0,0,1,0,0,0,26124),
(13549,'Return to your people and tell them to send one of your shaman to me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13550,'Return to the draenei and tell them to send me one of their shaman.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13551,'Your work here is complete, shaman.  Return to your people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13552,'Do you have the understanding to continue, shaman?  Do you know why you are here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13553,'If he\'s anything like his father, allying with the Mag\'har will mark the dawn of a new age for the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13554,'Greetings, $r.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13555,'It is a good day to be alive and one with the elements.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13556,'And why would I speak with you, $r?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13557,'Your presence here can only mean trouble, $g son : daughter; of the Horde.  Go in peace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13558,'Look around you, shaman.  Can you see the balance of the elements in the earth, the air, the water and the fire that has touched them all?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13559,'You dare summon me?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13560,'Who challenges Naias? Puny $r, you are little better than those mindless trolls I have played against each other like so many pieces on a game board!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13561,'Don\'t be alarmed... while my gryphons may not be entirely alive, they will still carry you faithfully to your destination. Tell me... which tower do you seek?','Don\'t be alarmed... while my gryphons may not be entirely alive, they will still carry you faithfully to your destination. Tell me... which tower do you seek?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13562,'Take me to Northpass Tower.','Take me to Northpass Tower.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13563,'Take me to Eastwall Tower.','Take me to Eastwall Tower.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13564,'Take me to Crown Guard Tower.','Take me to Crown Guard Tower.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13565,'','If you have not yet learned how to make use of bandages, I will be happy to show you the basics of creation and application. The difference between life and death can often come down to properly bandaging wounds.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(13566,'I wish to learn all that you have to teach me about first aid, Fateema.','I wish to learn all that you have to teach me about first aid, Fateema.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13567,'I WILL have my revenge!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(13568,'I\'m very busy right now, young $c. Please excuse me.','I\'m very busy right now, young $c. Please excuse me.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13569,'You\'ve wasted enough of my time... let these games be finished!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13570,'Bah, useless! There must be another way...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13571,'This won\'t work at all! The buildings will surely collapse if we do not shore up the support beams.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13572,'This won\'t do at all! We have to secure the foundation or the entire structure will crumble!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13573,'This structure violates at least 8 different ordinances!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13574,'I won\'t be held responsible for the catastrophe that will surely result from the haphazard maintenance of this building.\n','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13575,'Hrm, this looks much better. Let\'s have a look on the inside.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13576,'By the foul teat of Kil\'Jaeden\'s rotted torso, the entire backside is blown out! How can someone be expected to live in here? I\'ve seen enough!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13577,'Greetings, $c. I have been sent here from the Exodar to oversee the construction of Azure Watch.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13578,'I wish to learn about engineering, Daelo.','I wish to learn about engineering, Daelo.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13579,'I wish to browse your wares, Daelo.','I wish to browse your wares, Daelo.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13580,'I have much to do! Why can they not leave me to my work?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13582,'%s shrieks in pain and points at his master.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13584,'You cannot ride a mount in that form.','You cannot ride a mount in that form.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13585,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13586,'','You\'re such a good friend, Twinkle.  You\'d never leave me, would you?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13587,'','It\'s just you and me, Twinkle.  Daddy\'s not going to be coming home.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13588,'','Did you find something fun to chase around, Twinkle?  I bet you did!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(13589,'','Ok, let\'s go.  I know just the perfect spot!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13590,'','I can\'t wait to try this wine!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13591,'','What... is happening... to me?  Get this cat away from me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13592,'An alchemist is able to work miracles with ordinary herbs, converting them into stable potions that range in effect from healing to breathing underwater and everything in between.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(13593,'I wish to train as an alchemist, Daedal.','I wish to train as an alchemist, Daedal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13594,'Please allow me to browse your wares, Daedal.','Please allow me to browse your wares, Daedal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13595,'Twinkle looks at Viera Sunwhisper with very hungry eyes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13596,'','Now to apply the ointment to her wounds.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13597,'','It appears that the ointment is ineffective. Such a pity...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13598,'There may still be a solution. Come here, $n. I will explain what I need.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13599,'This should do it...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13600,'Wake up little creature. Wake up from your slumber... You are safe now.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13601,'','%s groans.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13602,'','%s sits up.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13603,'','Whe... Where am I? What... What is this place?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13604,'','BY THE LIGHT OF ELUNE! Eredar! Cursed demons, what have you done to me? I have not come alone, we will fight you as we have in the past! I...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13605,'','%s falls back into a coma.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13606,'','%s gasps.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13607,'','Oh dear...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13608,'','Man\'ari... But how... We are not eredar! She must know! If there are others like her, we must find them and explain...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13609,'%s sighs.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13610,'','Viera Sunwhisper scurries away, attempting to flee from Twinkle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13611,'By the Light you will leave this tomb!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13612,'Hello.  What brings you to Chillwind Camp today?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13613,'Shall we begin, my friend?','',6,0,0,0,0,0,0,7,1,0,0,0,26124),
(13614,'This area is known to be full of foul Scourge.  You may want to take a moment to prepare any defenses at your disposal.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(13615,'Very well, let us continue.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(13616,'Beware!  We are attacked!','',5,0,0,0,0,0,0,7,1,0,0,0,26124),
(13617,'It must be the purity of the Mark of the Lightbringer that is drawing forth the Scourge to us.  We must proceed with caution lest we be overwhelmed!','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(13618,'We are beset upon again!  Defend yourself!','',5,0,0,0,0,0,0,7,1,0,0,0,26124),
(13619,'This land truly needs to be cleansed by the Light!  Let us continue on to the tomb.  It isn\'t far now.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(13620,'','Hello there!  Oh my, a draenei!',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(13621,'Be welcome, friends!','',2,0,0,0,0,0,0,7,1,0,0,0,26124),
(13622,'Thank you for coming here in remembrance of me.  Your efforts in recovering that symbol, while unnecessary, are certainly touching to an old man\'s heart.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13623,'Please, rise my friend.  Keep the Blessing as a symbol of the strength of the Light and how heroes long gone might once again rise in each of us to inspire.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13624,'Thank you my friend for making this possible.  This is a day that I shall never forget!  I think I will stay a while.  Please return to High Priestess MacDonnell at the camp.  I know that she\'ll be keenly interested to know of what has transpired here.','',2,1,0,0,0,0,0,7,1,0,0,0,26124),
(13625,'Why do you do this?  Did I somehow wrong you in life?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(13626,'Ah, I see it now in your mind.  This is the work of one of my former students... Mehlar Dawnblade.  It is sad to know that his heart has turned so dark.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13627,'Return to him.  Return to Mehlar and tell him that I forgive him and that I understand why he believes what he does.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13628,'Good day to you, $c.$B$BI\'m waiting to hear from one of the High Thane\'s advisors about an audience. It was a struggle just to get the opportunity to present my credentials.$B$BI\'ve heard the Wildhammer described as \'wary of outsiders,\' but that\'s proven to be quite an understatement.  Hopefully, things will improve once I\'ve had the opportunity to meet with Featherbeard, whom I\'m told favors closer ties with the Alliance.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(13629,'|cffffff00The Plaguewood Tower has been taken by the Alliance!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13630,'|cffffff00Northpass Tower has been taken by the Alliance!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13631,'|cffffff00Eastwall Tower has been taken by the Alliance!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13632,'|cffffff00Crown Guard Tower has been taken by the Alliance!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13633,'|cffffff00Crown Guard Tower has been taken by the Horde!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13634,'|cffffff00The Plaguewood Tower has been taken by the Horde!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13635,'|cffffff00Northpass Tower has been taken by the Horde!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13636,'|cffffff00Eastwall Tower has been taken by the Horde!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13637,'|cffff0000All four towers are now in control of the Horde!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13638,'|cff33ccffAll four towers are now in control of the Alliance!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13639,'','What do you want?$B$BIt\'s a bit rude to walk up to strangers for no reason, don\'t you think?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13640,'I can only hope that he will see the Light and instead turn his energies to restoring once-beautiful Quel\'Thalas.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13641,'Avast ye, matey. Cookie is me name, cooking is me game. The McWeaksauce bloodline be a long line of cooks and tradesmen that work to please the more delicate senses o\' man and woman.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(13642,'Teach me how to cook, Cookie.','Teach me how to cook, Cookie.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13643,'Let me browse your wares, Cookie.','Let me browse your wares, Cookie.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13644,'','Need something?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(13645,'I want to become a blacksmith.','I want to become a blacksmith.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13646,'Let me browse your wares, Calypso.','Let me browse your wares, Calypso.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13647,'An ancient being awakens in the distance...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13648,'More mortals have come seeking the mysteries of Karazhan?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13649,'What fools! I shall bring a quick end to your suffering!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13650,'Light be with you, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13651,'','It looks like help has finally arrived!  The Omenai welcome you to our remnant camp, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13652,'Ikan tries and tries.  I think these Dreghood are much like the Lost Ones, you know... lost.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13653,'It will take a while, but these Broken Ones will learn the ways of the Light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13654,'Welcome, $n. I am Landro Longshot - manager of the Black Flame. Perhaps you\'ve not heard of the Black Flame until now. That doesn\'t surprise me; we work to keep things that way. We prefer to avoid... factional entanglements.$B$BThe Black Flame specializes in providing the finest services and entertainment money can buy, whether they happen to be hard to find items, gladiatorial combat, or lucrative games of chance.$B$BAre you here seeking something specific?','',1,1,6,0,0,0,0,0,1,0,0,0,26124),
(13655,'What promotions do you have?','What promotions do you have?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13656,'Ah - oddities and rarities. We specialize in Azeroth\'s more unique items for the discerning adventurer.$B$BSince you\'re speaking with me, you must already have an idea of what you\'re looking for. So, $n, which item are you interested in?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13657,'Red Tabard','Red Tabard',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13658,'Thank you, brother.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13659,'','You won\'t keep me from getting to Falcon Watch!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13660,'Thank you for the blessing, $n.','',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(13661,'Nothing can stop me now!','',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(13662,'Your blessing is always welcome, $n.','',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(13663,'','Do you need something, $c?  Perhaps I can assist you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13664,'You cannot hide from me, mortal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13665,'%s coughs and begins to wheeze.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13666,'','Thank you, $n.  It looks like they\'re going to get along just fine.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13668,'%s\'s cries awaken the undead. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13669,'Blue Tabard','Blue Tabard',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13670,'Tabard #3','Tabard #3',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13671,'Ogre Disguise','Ogre Disguise',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13672,'Hippogryph Hatchling','Hippogryph Hatchling',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13673,'Perpetual Purple Firework','Perpetual Purple Firework',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13674,'Ogre Costume','Ogre Costume',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13675,'Riding Turtle','Riding Turtle',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13676,'Enough! I shall land and crush you myself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13677,'Insects! Let me show you my strength up close!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13678,'...a potent concoction!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13682,'But where could I ever find a suitable test subject?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13683,'Drink this, you blue brute!  Disobey me and I promise you a slow, painful death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13684,'Hmmm... looks like I\'m going to need a new test subject.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13685,'I pity you, Forsaken.  Your soul is devoid of light.','',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(13686,'','Dyvuun, is that you?',6,0,0,0,0,0,0,7,1,0,0,0,26124),
(13687,'Yes, Zhanaa, it\'s me!  Your signal is weak.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(13688,'','I can barely hear you... <static> aking up!',6,0,0,0,0,0,0,7,1,0,0,0,26124),
(13689,'%s\'s bonds begin to weaken!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13690,'%s is nearly free of his bonds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13691,'%s breaks free!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13692,'Zhanaa!  Gah, I have to get this thing fixed!','',5,0,0,0,0,0,0,7,1,0,0,0,26124),
(13693,'Thank you, shaman.  I am reborn and will burn brighter than ever before!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13694,'%s looks over at Temper as if reluctant to speak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13695,'You there!  Keep a close watch on these ramparts, intruders could approach at any time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13697,'The Ghostlands will not be won back by military force alone, $n.  That\'s where we magisters come in.$B$BOur guile and knowledge of the arcane are unmatched.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13698,'Hey, Cookie! What\'s for dinner tonight? And don\'t say chicken!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13699,'Yarr, Admiral. Let me think about it... Arrr... It be comin\' into focus.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13700,'It looks like it be succulent pork ribs basted with its own delectable juices and a side o\' Captain Sander\'s Secret Sauce - fer dippin\'.\n','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13701,'And fer dessert we be havin\' cheesecake, flown in fresh from Stormwind on the wings o\' angels...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13702,'Wow! Really?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13703,'No. Not really...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13704,'It be chicken...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13705,'I hate you so much, Cookie.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13706,'','<Priestess Il\'dinare eyes you suspiciously.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13707,'','I am a night elf, stranger. While you may know nothing of my kind, we know much of you and your progenitors. You may not call yourself eredar but, in appearance, you share many similarities.$B$BYou have helped my allies, and for that I am thankful; but for the time being, you walk a tenuous path. Perhaps in time, you will be able to dissolve the doubts and fears that I hold in my heart.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(13708,'','Greetings, $r. Your noble actions are acknowledged. May Elune protect you.',1,2,0,0,0,0,0,0,1,0,0,0,26124),
(13709,'Watch your step around here, stranger.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13710,'You\'ve been a great help thus far, $n. You would do well to help out the others at the encampment.$B$BAnd don\'t worry about those goblins, I\'m taking care of everything.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(13711,'','Adamant, could you please take a look at this tablet and try to decipher the runes?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13712,'Of course! Anything for you, darling!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13713,'Alright, let me take a look at that tablet.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13714,'%s slowly reads the tablet, mouthing the words in their native tongue.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13715,'Naga warlord! Oh dear...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13716,'Well, you aren\'t going to like what I have to tell you, young missy. This tablet is a naga communication. Their leader, Warlord Sriss\'tiz, has ordered his naga to take the rest of the island by force.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13717,'And it looks like he\'s got reinforcements comin\' from Nazjatar!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13718,'We\'ve got to do something about this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13719,'','Thank you, Adamant. I think I know just the person for the job.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13720,'','It is good to see you again, $n. Perhaps once things have settled down, I can talk to you about the priceless treasure that we have lost...',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(13721,'The Alliance dares to intrude this far into my fortress?  Bring out the Honor Hold prisoners and call for the executioner!  They\'ll pay with their lives for this trespass!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13722,'Thrall\'s false Horde dares to intrude this far into my fortress?  Bring out the Thrallmar prisoners and call for the executioner!  They\'ll pay with their lives for this trespass!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13723,'The excecutioner has arrived!  Ready the prisoners!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13724,'Execute one of the prisoners at once!  Slay the dwarf first... he talks far too much for his own good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13725,'Execute one of the prisoners at once!  Slay the tauren first... keep his head as a trophy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13726,'It looks like we have a ranking officer among our captives... how amusing.  Execute the Alliance wench!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13727,'It looks like we have a ranking officer among our captives... how amusing.  Execute this green-skinned dog at once!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13728,'Slay the last prisoner.  Maybe our intruders will reconsider their foolish actions now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13729,'What are you lookin\' at?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(13730,'I am Adamant Ironheart of the great city of Ironforge. As you could probably guess by looking at my uniform, I was once part of the Ironforge elite guard. Yep, I was Magni\'s right hand man! At least until I retired. Now I dabble in archaeology. It\'s a hobby really; plus I figured it would be a great way to see the world!','',1,1,5,0,0,0,0,0,1,0,0,0,26124),
(13731,'Bring it on, you son of a mangy ogre!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13732,'','Do your worst, demonspawn!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13733,'Let\'s finish this... I\'ve waited long enough.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13734,'I spit on you, Kargath.  The true Horde will crush you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13735,'You can\'t stop the inevitable, fel orc.  Hellfire Citadel will soon fall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13736,'Take a look at me, scum!  This is what a real orc looks like!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13737,'<Cowlen sobs.>','',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(13738,'What could I have done to give the gods cause to lash out at me with such ferocity? All that I cherished is gone - dead or destroyed. My family taken from me by the brutes of the forest. My home razed. My ship sunk.$B$BI am a broken man, stranded on a broken island.$B$BPerhaps you are you here to finish the job? Make it quick, I will not resist. Take my life, stranger; I am too cowardly to do it myself. My hand shivers... the blade will not strike true.\n','',6,1,20,0,0,0,0,0,1,0,0,0,26124),
(13739,'I have not come to kill you, night elf. And the gods did not do this...','I have not come to kill you, night elf. And the gods did not do this...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13740,'If not the gods, who? How? What could cause such strife?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(13741,'I fear that my people are somewhat responsible for this destruction. We are refugees, displaced from our homes by the Burning Legion. This tragedy is a result of our latest evacuation. Our vessel crashed - this debris is a part of that vessel.','I fear that my people are somewhat responsible for this destruction. We are refugees, displaced from our homes by the Burning Legion. This tragedy is a result of our latest evacuation. Our vessel crashed - this debris is a part of that vessel.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13742,'Legion? Demons? They hunt you? My people have also been hunted by Legion: Targeted by their dark masters for damnation.$B$B<Cowlen wipes the tears away.>$B$BIt is the reason that I moved my family here oh-so-many years ago.','',6,1,1,0,0,0,0,0,1,0,0,0,26124),
(13743,'We have much in common, night elf. I can\'t help but feel that perhaps it was fate that brought us together. Let me help you, Cowlen. Let my people help. We will right the wrongs. This I vow.','We have much in common, night elf. I can\'t help but feel that perhaps it was fate that brought us together. Let me help you, Cowlen. Let my people help. We will right the wrongs. This I vow.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13744,'','Our house is this way, through the thicket.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13745,'','My poor family. Everything has been destroyed.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13746,'','Father! Father! You\'re alive!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13747,'','%s hugs her father.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13748,'','You can thank $n for getting me back here safely, father.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13749,'Daughter!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13750,'Greetings, $c. Before the night elves invited the draenei to join them here, this glade was all but forgotten.$B$BThe kaldorei are deeply tied to these lands, and we draenei are honored that they have asked us to share in the task of revitalizing Forest Song.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13757,'','It\'s good to see a new face out here. We\'re barely hanging on and our enemies are plentiful.$B$BWe\'re surrounded by those who seek to destroy us: the satyr to the north, the orcs in the lumber camp here to the east, and the demons of Felfire Hill.$B$BWe\'re going to retake this place if it kills us. It looks like it just might!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13758,'%s Takes a Deep Beath','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13759,'It\'s good to hear the voices of others here in Forest Song again. I\'d begun to feel as though I might be the last of the kaldorei ever to set eyes on these lands before their descent into corruption.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13760,'capture point Contested1','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13761,'capture point Contested2','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13762,'capture point Win1','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13763,'capture point Win2','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13764,'capture point Progress1','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13765,'capture point Progress2','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13766,'Can you feel the evil all around us, $c? By the Hand, it must be cleansed!$B$BThe demons destroyed our homeworld, Argus. I will NOT countenance their presence here on our new home, Azeroth!','',6,274,0,0,0,0,0,0,1,0,0,0,26124),
(13767,'Now that the demons have been dealt with, we can proceed with the establishment of a new base here. ','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13768,'%s devours the fabric and hisses angrily!','',36,0,0,0,0,0,0,0,1,0,0,0,26124),
(13769,'While you\'ve dealt the demonic evil from the south a serious blow, I still sense trouble from that region.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13770,'','Help me!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13771,'With you and your people as allies, we have decided to stay on this island and rebuild. Elune bless you, hero.$B$BWhile the sadness still comes and goes, I think we will survive.\n','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(13772,'You\'re a $r, right?  I am heartened to see you here!  We can use all of the help that we can get.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13773,'Intruder!','Intruder!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13774,'You are not welcome here!','You are not welcome here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13775,'%s picks up the naga flag.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13776,'What\'s the big idea, Spark? Why\'d you call for this meeting?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13777,'What\'s the big idea? You nearly blew my cover, idiot! I told you to put the compass and navigation maps somewhere safe - not out in the open for any fool to discover.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13778,'The Master has gone to great lengths to secure information about the whereabouts of the Exodar. You could have blown the entire operation, including the cover of our spy on the inside.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13779,'Relax, Spark! I have it all under control. We\'ll strip mine the Exodar right out from under \'em - making both you and I very, very rich in the process.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13780,'Relax? Do you know what Kael\'thas does to those that fail him, Geezle? Eternal suffering and pain... Do NOT screw this up, fool.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13781,'Our Bloodmyst scouts have located our contact. The fool, Velen, will soon leave himself open and defenseless -- long enough for us to strike! Now get out of my sight before I vaporize you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13782,'Yes, sir. It won\'t happen again...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13783,'So it was you, Spark! How could you? You were a trusted envoy of Mekkatorque!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13784,'','There are demons to kill, $c.  Do you have the backbone to do what needs to be done?',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(13785,'%s laughs.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13786,'You and your kind mean nothing to me, fool. The Master\'s will is all that matters. These ... These draenei will be hunted down and slain -- as will all things on this world. You will cease.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13787,'Does it frighten you to know that there are those that would serve the Legion with such devotion as to remain unwavering citizens of your pointless civilizations until called upon?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13789,'Is this the end?','Is this the end?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13790,'What will become of--','What will become of--',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13791,'Live in fear, die by the will of Kael\'thas... It\'s all the same.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13792,'Admiral, I need another tree disguise kit.','Admiral, I need another tree disguise kit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13793,'What have you done to my life\'s work?!  DIE!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13794,'','Sentinels be on the alert!  I heard something over there...',5,25,0,0,2,0,0,0,1,0,0,0,26124),
(13795,'','What was that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13796,'','You won\'t sneak up on me, $c!',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(13797,'','With a good portion of their demons slain, the Legion will think twice about attacking our lumber camp again.  However, I still sense demonic evil stirring.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13798,'You, hold there!','You, hold there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13800,'We\'re under attack!','We\'re under attack!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13801,'I am lost...','I am lost...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13802,'Why...?','Why...?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13803,'','You honor us with your presence, $n.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13804,'Another day, another stable to muck out.','Another day, another stable to muck out.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13805,'I grow tired of this routine.','I grow tired of this routine.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13806,'<sigh> Seems like I\'ve been at this forever...','<sigh> Seems like I\'ve been at this forever...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13807,'There was a demon amongs us after all... Just not where we had expected.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(13808,'All hail the exalted hero!','',71,0,0,0,0,0,0,0,1,0,0,0,26124),
(13809,'The story of your journey will be told for years to come!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(13810,'I finally have a story to tell my grandchildren about... A traitor to the kingdom was living among us!','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(13811,'Truth be told, I never liked that gnome...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13812,'We are lucky to have survived this ordeal. If it wasn\'t for you, everyone on this island could have been killed!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(13813,'I wonder how many more of them live among us. I knew Spark for years - never could I have imagined that he was a traitor.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(13814,'','All hail the exalted hero!',71,0,0,0,0,0,0,0,1,0,0,0,26124),
(13815,'','The story of your journey will be told for years to come!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(13816,'','I finally have a story to tell my grandchildren about... A traitor to the kingdom was living among us!\n',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(13817,'','Truth be told, I never liked that gnome...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13818,'','We are lucky to have survived this ordeal. If it wasn\'t for you, everyone on this island could have been killed!',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(13819,'','I wonder how many more of them live among us. I knew Spark for years - never could I have imagined that he was a traitor.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(13820,'What is this?','What is this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13821,'Invaders in the tower!','Invaders in the tower!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13822,'Stop them!','Stop them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13823,'I am finished!','I am finished!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13824,'No!','No!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13825,'The master... will be angry....','The master... will be angry....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13826,'If we dawdle much longer, there\'ll be hell to pay!\n','If we dawdle much longer, there\'ll be hell to pay!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13827,'The rest are fine without us.','The rest are fine without us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13828,'They\'ll never know we\'re missing.','They\'ll never know we\'re missing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13829,'To arms!','To arms!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13830,'Protect the tower!','Protect the tower!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13831,'Have at them!','Have at them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13832,'Let your death be an example!','Let your death be an example!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13833,'Death to all invaders!','Death to all invaders!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13834,'I have failed....','I have failed....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13835,'You will be punished!','You will be punished!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13836,'You... will... pay.','You... will... pay.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13837,'[Furbolg] Thank you, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13838,'How dare you interfere?!','How dare you interfere?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13839,'You do not belong here!','You do not belong here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13840,'Leave us alone! Let us be!','Leave us alone! Let us be!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13841,'Not... fair...','Not... fair...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13842,'It\'s not my time, not yet!','It\'s not my time, not yet!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13843,'All good things must come to an end.','All good things must come to an end.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13844,'You\'ll ruin everything!','You\'ll ruin everything!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13845,'Off with you!','Off with you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13846,'We do not wish to be disturbed!','We do not wish to be disturbed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13847,'Where am I? What--','Where am I? What--',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13848,'What is happening?','What is happening?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13849,'I mustn\'t be afraid....','I mustn\'t be afraid....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13850,'%s whimpers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13851,'Begone, outsider!','Begone, outsider!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13852,'You\'ll not ruin the celebration!','You\'ll not ruin the celebration!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13853,'We are besieged!','We are besieged!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13854,'You should never have come here!','You should never have come here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13855,'Now you will pay the ultimate price!','Now you will pay the ultimate price!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13856,'The fates have turned against me!','The fates have turned against me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13857,'My time is done.','My time is done.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13858,'No, not now! Not like this!','No, not now! Not like this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13859,'Open your senses, little one. Can you not feel it - the pain, the suffering this tree endured when it was ripped from the nourishing earth? We will heal it and give it peace, though the tree will never grow again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13860,'It is done, little one. Now, we must focus our efforts on preventing such destruction from claiming any more victims.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13861,'I\'ll chop you into minced meat!','I\'ll chop you into minced meat!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13862,'I\'ll gut you like a fish!','I\'ll gut you like a fish!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13863,'I\'ll carve the meat from your bones!','I\'ll carve the meat from your bones!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13864,'I have served to the last....','I have served to the last....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13865,'This isn\'t the end; it can\'t be!','This isn\'t the end; it can\'t be!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13866,'I tried, master. I tried.','I tried, master. I tried.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13867,'%s urges you to follow him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13868,'%s points to the totem of Coo.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13869,'%s motions for you to follow him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13870,'[Furbolg] Ritk kin\'chikx azul azure summit...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13871,'[Furbolg] Coo xip fly... Jump ilos river. Find Tikti.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13872,'%s points across the river.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13873,'[Furbolg] Far you mixik tak come. Gaze upon the kitch\'kal river. Follow. Ilog to Yor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13874,'%s asks that you follow him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13875,'[Furbolg] Go... Search yitix\'kil bottom river. South!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13876,'Impudent outsiders!','Impudent outsiders!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13877,'Meddling fools! You will pay with your lives!','Meddling fools! You will pay with your lives!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13878,'Wait--no! No!','Wait--no! No!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13879,'You\'ll never make it out alive....','You\'ll never make it out alive....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13880,'','Come play with me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13881,'','You WILL be mine.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13882,'','Come here, pretty. You have what I need!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13883,'','So I said, \"Yeah, but that\'ll cost you extra.\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13884,'','Five seconds. I\'m not kidding!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13885,'','He asked if the imp could join in--can you believe it? Actually, it wasn\'t half bad....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13886,'','They fall asleep after. Me, I fall asleep during....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13887,'','Come any closer, and I\'ll scream.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13888,'','I want to show you a different side of me....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13889,'','It was fun while it lasted....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13890,'','<sigh> It\'s always over too soon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13891,'','I want you to be with me... forever and ever.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13892,'','Shhh... I have a little secret I\'ve been keeping.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13893,'','Come play with me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13894,'','Come play with me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13895,'','I\'ve been very, very naughty....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13896,'','Enough foreplay. Let\'s get down to business.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13897,'','Just when things were getting interesting.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13898,'','We could have had so much fun!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13899,'','Hmm... it\'s not in this stack. Maybe I left it on the shelf.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13900,'','%s leafs through the pages of a journal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13901,'[Furbolg] Come, $n. Let us leave the water together, purified.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13902,'','Aha! Here\'s the sketch I was looking for...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13903,'[Furbolg] We go now, together. We will seek Vark.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13904,'','Here, Master Nemos, this is the drawing I was talking about.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13905,'','%s offers the journal to Architect Nemos.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13906,'%s accepts the book from Apprentice Boulian and glances at the indicated page.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13907,'[Furbolg] Follow me to Vark.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13908,'Ah, yes, I see what you were talking about now. Thank you, Boulian.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13909,'It\'s a great assignment, yeah, but \"all looking and no touching\" gets old after a while.','It\'s a great assignment, yeah, but \"all looking and no touching\" gets old after a while.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13910,'I think she winked at me.','I think she winked at me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13911,'This beats patrolling the Opera Hall. Theater people scare me.','This beats patrolling the Opera Hall. Theater people scare me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13912,'Another sold-out crowd.','Another sold-out crowd.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13913,'Haven\'t I seen tonight\'s show before? I could have sworn...','Haven\'t I seen tonight\'s show before? I could have sworn...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13914,'Urgent business! Yes, but what? And how did I end up here...?','Urgent business! Yes, but what? And how did I end up here...?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13915,'Tickets aren\'t easy to come by, I hear.','Tickets aren\'t easy to come by, I hear.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13916,'You must not interfere!','You must not interfere!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13917,'What are you doing? Be off!','What are you doing? Be off!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13918,'I\'ll miss the show!','I\'ll miss the show!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13919,'Yes, I think I remember now....','Yes, I think I remember now....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13920,'Clear the area!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13921,'Where\'s your ticket?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13922,'The show is for guests only!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13923,'You should not have come here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13924,'You\'ll be joining the other guests now....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13925,'You cannot stop us all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13926,'Your death will soon follow....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13927,'[Furbolg] Hurry, $n. Vark awaits you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13928,'You\'re not allowed here!','You\'re not allowed here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13929,'You\'re not a guest!','You\'re not a guest!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13930,'Am I released from my duties?','Am I released from my duties?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13931,'At last, my work is done.','At last, my work is done.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13932,'Step lively; the master is counting on us!','Step lively; the master is counting on us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13933,'More paint for the Oz set--yes, I\'ll have to remember....','More paint for the Oz set--yes, I\'ll have to remember....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13934,'How many set changes? Same as last time, I suppose.','How many set changes? Same as last time, I suppose.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13935,'And I MUST have a carafe of sweet nectar in my dressing room. It\'s right there in my contract!','And I MUST have a carafe of sweet nectar in my dressing room. It\'s right there in my contract!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13936,'I told him he would simply have to contact my agent.','I told him he would simply have to contact my agent.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13937,'No, no, that was under the OLD guild rules....','No, no, that was under the OLD guild rules....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13938,'I will not be upstaged by amateurs!','I will not be upstaged by amateurs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13939,'The show must go on!','The show must go on!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13940,'It\'s so cold, so dark.... I\'m not overacting, am I?','It\'s so cold, so dark.... I\'m not overacting, am I?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13941,'Make sure my name is spelled correctly on the tombst--','Make sure my name is spelled correctly on the tombst--',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13942,'Your insolence will not be tolerated!','Your insolence will not be tolerated!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13943,'You were not invited!','You were not invited!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13944,'It\'s all... coming back to me....','It\'s all... coming back to me....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13945,'Is it really over?','Is it really over?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13946,'You will find no reward here, only death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13947,'Visitors are forbidden!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13948,'Free... at last.','Free... at last.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13949,'Time to move on.','Time to move on.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13950,'[Furbolg] Bear witness to the savage acts of our adversaries, $n. They steal our young... our weak... Imprisoned here, they are left to the devices of the Bristlelimb. Set them free, Promised One!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13951,'Thieves! Stop them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13952,'Halt at once!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13953,'Pillagers! Desecrators!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13954,'The same fate awaits all who would steal from the master.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13955,'Death is far too merciful for your kind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13956,'You will not make it out alive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13957,'Others will take my place!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13958,'This... changes nothing. Eternal damnation awaits you!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13959,'','Welcome to Forest Song, $c. If there is anything I can do for you, please let me know.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13960,'No! We were here first!','No! We were here first!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13961,'The secrets of the library are ours and ours alone!','The secrets of the library are ours and ours alone!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13962,'A treasure trove of knowledge, ripe for the taking!','A treasure trove of knowledge, ripe for the taking!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13963,'Powers beyond comprehension, all at our fingertips...','Powers beyond comprehension, all at our fingertips...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13964,'Beware... the upper reaches.','Beware... the upper reaches.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13965,'Turn back while you can.','Turn back while you can.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13966,'I wish to browse your wares.','I wish to browse your wares.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13967,'The secrets of this place are not intended for the likes of you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13968,'Amateurs! You are far beyond your depth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13969,'The tower is no place for the uninitiated!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13970,'You never should have stepped foot in this place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13971,'Your bravado will be rewarded... with death.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13972,'You will succeed only in damning yourselves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13973,'Turn back while you can.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13974,'%s gnaws at the bars of its cage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13975,'%s rattles its cage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13976,'%s calls for help.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13977,'%s growls at its captors.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13978,'[Furbolg] The Stillpine furbolgs will not soon forget your bravery!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13979,'[Furbolg] Those remaining at Stillpine Hold will welcome you as a hero!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13980,'[Furbolg] The prophecy is true!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13981,'You have faced many challenges.... Pity they were all in vain! Soon your people will kneel to MY lord!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13982,'I\'ve failed... peace is impossible.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13983,'What in the Light\'s name...?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13984,'Fel orcs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13985,'The cycle of bloodshed is unending... Is there nothing I can do?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13986,'Do not return, draenei scum.  Next time we won\'t spare your life, unarmed or not!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13987,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13988,'You can die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13989,'Yes sir!  I will not fail the Fel Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13990,'%s signals a charge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13991,'What have you done, Makuru?!  These are not our ways!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13992,'I understand how you feel Makuru.  Sedai was my brother after all.  Yet we can\'t disgrace his memory by going against his very ideals.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13993,'Don\'t be afraid; we\'re here to aid you. We\'re grateful for the defense you\'ve granted us within our former home, and as a measure of thanks, we\'ve come to help you return quickly to the Plaguelands should you need it. My compatriot can explain the process further; you\'ll find him where the arcane energies are strongest within this city.','Don\'t be afraid; we\'re here to aid you. We\'re grateful for the defense you\'ve granted us within our former home, and as a measure of thanks, we\'ve come to help you return quickly to the Plaguelands should you need it. My compatriot can explain the process further; you\'ll find him where the arcane energies are strongest within this city.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13994,'I am truly sorry, $c, but as your spirit has never before experienced the horrors that lie in wait within the burning wreck of Stratholme, our magic cannot carry you to the city.','I am truly sorry, $c, but as your spirit has never before experienced the horrors that lie in wait within the burning wreck of Stratholme, our magic cannot carry you to the city.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13995,'I can see in your eyes you\'re no stranger to the tragedy within Stratholme. If you wish to end the miserable existence of the poor souls trapped therein, step into the circle. It leads directly to the gates of the burning city itself.','I can see in your eyes you\'re no stranger to the tragedy within Stratholme. If you wish to end the miserable existence of the poor souls trapped therein, step into the circle. It leads directly to the gates of the burning city itself.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(13996,'The orcs hate us, Obadei!  They\'ve killed many of us before!  They deserve death and worse.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13997,'No!  Not... Sedai!  The orcs must pay!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13998,'[Furbolg] Behold the prophecy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(13999,'Do you smell that?  Fresh meat has somehow breached our citadel.  Be wary of any intruders.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14000,'Intruders!  Hold them off until I can release the warhounds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14001,'You\'re too late, now feel the wrath of my warhounds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14002,'<The footman stand resolute, muscles tense.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14003,'Stop it with this Light nonsense.  The swamp is where we need to go!  We belong there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14004,'Bah!  Suit yourselves.  We\'re leaving!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14005,'I... I want to hear about the Light.  I think... I remember...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14006,'Welcome, my brethren!  You\'ve been freed from demons.  Embrace the teachings of Velen!  Embrace the light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14007,'As we attempt to gain the help of the peoples of this world against the Burning Legion, we must also learn to live peaceably amongst them.$B$BPlease keep this in mind as your journey takes you throughout Azeroth.  May the Light guide you.','',1,1,0,0,500,0,0,0,1,0,0,0,26124),
(14008,'Control Human Footman','Control Human Footman',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14009,'[Furbolg] Spirits grant us vision!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14010,'I am ready to be flown down to the Exodar.','I am ready to be flown down to the Exodar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14011,'What brings you all the way up here, little $r?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14012,'Are you ready, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14013,'','Greetings, $c.  I get so few visitors up here.  To what do I owe the pleasure?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14014,'','Susurrus is expecting you, $n.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14015,'You are brave to swim down to my realm, land-walker.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14016,'','I have been expecting you.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(14017,'I wish to learn more about blacksmithing.','I wish to learn more about blacksmithing.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14018,'Be careful out in the desert, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14019,'The sound of footsteps shuffling echo throughout the cave.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14020,'What\'s that $T scrub : girlie;?  You want your mommy?  Well too bad.  Maybe you should pay a visit to the Thrallmar officer\'s club to get her back?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14021,'Do you know where you are?  This is Honor Hold, sweetheart!  Love it or get out!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(14022,'You stay away from crystals! Die now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14023,'This isn\'t a field trip, maggot!  You\'re in the Outland now!  Shape up or take a stroll back through the portal.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(14024,'I have neither the time, nor the inclination, to explain things to you, scumbag!  Now do you have something important to say, or are you just here to ask me out for a drink, princess?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(14025,'What is your major malfunction?!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(14026,'I\'ve seen you prancing around.  Why don\'t you do us all a favor and just drop your gear off at the armory?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14027,'Who in name of Kurdran let you through the Dark Portal?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(14028,'Well, well, well, what have we here?  A $T civilian : civilian;?  Isn\'t that precious?  You\'ll get no special treatment from me!','',6,5,0,0,500,0,0,0,1,0,0,0,26124),
(14029,'%s roars!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14030,'','These pictographs tell a story. This figure at the beginning, almost looks like one of the creatures we encountered at Azure Watch...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14031,'','No, this can\'t be... It says this creature willingly became a servant of the Legion. He transforms into a satyr and receives the Legion\'s \"blessing.\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14032,'','We must defeat these satyr, $n. We will not suffer the Legion\'s presence in these lands.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14033,'Keep your voice down, $c!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(14034,'If you have something to say, say it!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14035,'You\'re a $T civilian : civilian;?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14036,'I\'m busy, make it fast!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14037,'[Furbolg] There is currently an assault in progress. We must wait before unleashing another!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14038,'Stillpine raiders, the time to strike is at hand! Charge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14039,'Have you spoken with the high priestess yet?  She\'s very eager to hear the tale of the pilgrimage from your point of view.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14040,'How fares your search for the Mark?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14041,'This is a great day, $c!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14042,'I cannot thank you enough for making my pilgrimage possible!','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(14043,'Me not like this one...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14044,'Hey, you numbskull!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14045,'We kill his friend!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14046,'Smash!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14047,'Why don\'t you let me do the talking?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14048,'If you nice me let you live.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14049,'[Furbolg] What could it mean?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14050,'About time the guild sent some new blood our way! Too bad you came all this way for nothing. We\'re not allowed to put on a show for our guests, can you believe it? Moroes has forbidden us from starting a new show, and my backers are going nuts! Something needs to be done about Moroes.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(14051,'Finally, everything is in place. Are you ready for your big stage debut?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14052,'I\'m not an actor.','I\'m not an actor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14053,'Don\'t worry, you\'ll be fine. You look like a natural!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(14054,'Ok, I\'ll give it a try, then.','Ok, I\'ll give it a try, then.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14055,'Intruders are upon us!  Help me, brothers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14056,'Splendid. I\'m going to get the audience ready. Break a leg!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14057,'Good evening ladies and gentlemen, welcome to this evening\'s presentation!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14058,'Acteon, where is the best area to hunt for moongraze stags?','Acteon, where is the best area to hunt for moongraze stags?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14059,'Moongraze stags can be found grazing south and east of Azure Watch.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14060,'Acteon, where is the best place to hunt moongraze bucks?','Acteon, where is the best place to hunt moongraze bucks?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14061,'Just north of Azure Watch is where you will have the best luck finding moongraze bucks.$B$BHappy hunting, $n!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14062,'Where can I find more infected nightstalker runts, Exarch?','Where can I find more infected nightstalker runts, Exarch?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14063,'The infected nightstalker runts seem to be coming from the north. If I were you, that\'s where I would start my hunt.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14064,'%s roars in pain! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14065,'Magtoor, thank you for allowing me to stay here with you.  I\'m sure that there is much that we can learn from each other.  And I\'m eager to learn all that I can of the Lost Ones to the east.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14066,'Great Tzerak, in the name of Zevrax, we summon you forth!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(14067,'Cast down the enemies of the Burning Legion, rain down destruction upon those who would oppose us!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(14068,'Of course, my friend.  You are welcome to stay with us for as long as you like.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14069,'Long have we craved your return! Command us in the destruction of the Legion\'s greatest foes!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(14070,'Fools! Weaklings! Tzerak has no need of your assistance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14071,'Wow, you totally bombed out there. Let\'s think of that as a rehearsal, shall we? Ready to go out again?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14072,'%s throws his head back and laughs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14073,'Entering Phase 3 <PH>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14074,'The wolf\'s going down.','The wolf\'s going down.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14075,'Why do you traffic with the Horde?  Their foul ways are beneath you.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14076,'A-ha! Found one!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14077,'Another one!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14078,'Oh that\'s a big one!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14079,'I wonder if you can really hear the ocean in these things.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14080,'It\'s ironic, I hate the ocean but I love the beach.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14081,'We have no choice.  If we fail to honor the presence of the Horde, then surely they will crush us from nearby Stonard!  I\'m afraid that not even you and your friends would be able to stop them.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(14082,'Yes Master, all goes along as planned.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14083,'%s places the shell in his pack.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14084,'%s holds the shell up to his ear.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14085,'I must find a way to put an end to the evil that Cersei Dusksinger is committing against our lost brothers and sisters!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(14086,'%s examines the shell.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14087,'Be careful, Avuun.  One of the merchants that I trade with in Stonard has heard her raving about some horrible disease she\'s trying to perfect.  They say it\'s for use against the draenei!','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(14088,'Anchorite, we are honored that you are here, but I am curious as to what you truly believe you can accomplish?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14089,'Magtoor, I have faith that there is a way to bring the Lost Ones back from the brink.  By studying them, I will find a way to cure the fel energies that have consumed them.  And in so doing, I will be able to reverse the damage to the Broken as well.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(14090,'And now, I cut you!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14091,'DIE!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14092,'Can\'t you see that I\'m busy?','',6,0,0,0,0,0,0,7,1,0,0,0,26124),
(14093,'It\'s over, Spark. The admiral knows it was you who betrayed the Alliance. Now you\'re either going to cooperate with me and tell me everything that you know or we\'re going to engage in some fisticuff.','It\'s over, Spark. The admiral knows it was you who betrayed the Alliance. Now you\'re either going to cooperate with me and tell me everything that you know or we\'re going to engage in some fisticuff.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14094,'','Hahaha!  That fool will never find out what I\'m up to!  Or, if he does, it\'ll be too late for the draenei!',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(14095,'','These orcs are fools!  So much power nearby just waiting to be taken, and all they do is sit on their hands and watch while others plunder the riches!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14096,'','I cannot wait to see the results of this latest batch!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14097,'','Avuun dares to oppose me?!  I will crush him!  When I am done with the draenei, they\'ll wish that they were Lost Ones!',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(14098,'','Oh, would you please stop checking your nails and spanking yourself, for one moment?  Really, no one cares!',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14099,'','Are you hungry?  I\'m hungry.  I just can\'t stand the thought of cured ham steak from Thultash again.  If only we could get some of that succulent roasted quail!',6,1,0,0,500,0,0,0,1,0,0,0,26124),
(14101,'','I need some fresh air, not that there\'s any to be had in this swamp!  I\'m going out for a bit.  Tidy up a bit while I\'m gone, would you?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14102,'','Must you follow me everywhere? <sigh>',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14103,'','Look at her down there!  Just who does she think she is?',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(14104,'Hmph, no doubt she believes herself to be the new mistress of Stonard.  Perhaps we should offer to help her succubi tidy up her messes?','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(14105,'Her methods are cowardly.  She reminds me of the Forsaken apothecaries.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14106,'','You have something to say to my face?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14107,'','I thought not!',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(14108,'Putting the bottles away, %s sighs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14109,'%s stares at you in sheer wonderment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14110,'I run now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14111,'How did I let myself get stationed here?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14112,'Uther Lightbringer brought only darkness to Quel\'Thalas.  Let us see if we can bring some darkness to his tomb!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14113,'','%s inspects the contents of the crates.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14114,'What is taking so long?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14115,'At last I will have my revenge!','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(14116,'The brazier fires upon the helpless orc! [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14117,'Rough audience, but you\'ll win them over. Ready for another shot?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14118,'Welcome ladies and gentlemen, to this evening\'s presentation!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14119,'The romantic plays are really tough, but you\'ll do better this time. You have TALENT. Ready?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14120,'I\'ll nail it!','I\'ll nail it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14121,'I\'ve never been more ready.','I\'ve never been more ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14122,'Welcome ladies and gentlemen, to this evening\'s presentation!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14123,'[Furbolg] Mil\'ork kix ilfin o oomtor...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14124,'[Furbolg] Poorov\'tarkh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14125,'[Furbolg] Yar vartslaf?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14126,'[Furbolg] Boro gomsho!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14127,'You feeble dogs are still weak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14128,'Beg and tremble before my power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14129,'They call you the Fel Horde\'s elite? Yet, you still tremble in my presence!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14130,'Beg for your pitiful life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14131,'You are nothing to me. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14132,'Run, coward, run!   ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14133,'Flee, peon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14134,'Fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14135,'That\'s enough. Now back off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14136,'It hurt!','',18,0,0,2,0,0,0,0,1,0,0,0,26124),
(14137,'Augh! No more hurt!','',18,0,0,2,0,0,0,0,1,0,0,0,26124),
(14138,'This not good tickle!','',18,0,0,2,0,0,0,0,1,0,0,0,26124),
(14139,'Skin on fire!','',18,0,0,2,0,0,0,0,1,0,0,0,26124),
(14140,'It hurt!','',18,0,0,2,0,0,0,1,1,0,0,0,26124),
(14141,'Aahhh!','',18,0,0,2,0,0,0,1,1,0,0,0,26124),
(14142,'No more scary!','',18,0,0,2,0,0,0,1,1,0,0,0,26124),
(14143,'Mommy!','',18,0,0,2,0,0,0,1,1,0,0,0,26124),
(14144,'No more!','',18,0,0,2,0,0,0,1,1,0,0,0,26124),
(14145,'Until you can endure the shadow fires, you remain at my mercy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14146,'Be seared with the shadow!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14147,'A few burns are nothing to the Fel Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14148,'Your pain amuses me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14149,'Pain!','',18,0,0,2,0,0,0,1,1,0,0,0,26124),
(14150,'It hurts!','',18,0,0,2,0,0,0,1,1,0,0,0,26124),
(14151,'Graaagggh!!','',18,0,0,2,0,0,0,1,1,0,0,0,26124),
(14152,'No more!!','',18,0,0,2,0,0,0,1,1,0,0,0,26124),
(14153,'Yes! Run while you still can!','',11,0,0,1,0,0,0,0,1,0,0,0,26124),
(14154,'How can I help you, stranger?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14155,'I wish to browse your wares, Ergh.','I wish to browse your wares, Ergh.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14156,'Gurf is my name, stranger. Gurf the Brave!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14157,'Please teach me how to skin, Gurf.','Please teach me how to skin, Gurf.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14158,'I am Moordo, elder hunter of Stillpine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14159,'I wish to become a leatherworker, Moordo. Please train me.','I wish to become a leatherworker, Moordo. Please train me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14160,'Welcome to my shop!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14161,'Hello, Parkat. I wish to purchase something.','Hello, Parkat. I wish to purchase something.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14162,'Ah, the Promised One has arrived. Welcome to Stillpine Hold.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14163,'Good tidings, $c. I am Stillpine the Younger, heir to the throne of Stillpine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14164,'It is you who will defend my people and usher in a new era of prosperity for Stillpine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14165,'Kill as many infected nightstalkers as I can find... This should be easy.','Kill as many infected nightstalkers as I can find... This should be easy.',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14166,'Thanks for the heal, $n!','Thanks for the heal, $n!',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14167,'Help! I think this creature might be too tough for me to handle alone.','Help! I think this creature might be too tough for me to handle alone.',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14168,'Can anyone hear me? I need help! This creature is going to kill me!','Can anyone hear me? I need help! This creature is going to kill me!',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14169,'I can\'t hold it off any longer! Tell the exarch that I gave it my best.','I can\'t hold it off any longer! Tell the exarch that I gave it my best.',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14170,'Thanks again!','Thanks again!',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14171,'Another victory for the draenei!','Another victory for the draenei!',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14172,'Another infected beast destroyed!','Another infected beast destroyed!',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14173,'How could you think yourself a match for the draenei champion!','How could you think yourself a match for the draenei champion!',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14174,'Hah! This is easy.','Hah! This is easy.',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14175,'I\'m supposed to be hunting infected nightstalkers... This should be easy.','I\'m supposed to be hunting infected nightstalkers... This should be easy.',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14176,'Where in the nether are these damnable lashers??','Where in the nether are these damnable lashers??',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14177,'Hrm, azure snapdragons? Where do they come up with these names? Daedal has gone mad!','Hrm, azure snapdragons? Where do they come up with these names? Daedal has gone mad!',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14178,'These stags are nothing like talbuks.','These stags are nothing like talbuks.',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14179,'I wonder what that little purple creature at the village is... It\'s certainly beautiful.','I wonder what that little purple creature at the village is... It\'s certainly beautiful.',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14180,'Time to meet your maker, $n!','Time to meet your maker, $n!',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14181,'Your money or your life! Actually, just your life will do...','Your money or your life! Actually, just your life will do...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14182,'Your death will make a fitting tribute to the King!','Your death will make a fitting tribute to the King!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14183,'For Silvermoon! For Sunstrider!','For Silvermoon! For Sunstrider!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14184,'I\'m afraid I\'m rather busy fixing horseshoes at the moment.  Would you mind coming back at another time?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14185,'I once served Medivh... or pretended to.  I helped the Violet Eye keep a close eye on the Master.$B$BBut now all I can think of is... making horseshoes.  Over and over.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14186,'Look at the size of your head! That should fetch me twice as much of a bounty!','Look at the size of your head! That should fetch me twice as much of a bounty!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14187,'You know about the Violet Eye then?  Maybe I\'ll have time for you later.$B$BI have to get back to my work.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14188,'I\'m in need of your skill as a blacksmith, Koren.','I\'m in need of your skill as a blacksmith, Koren.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14189,'','<Eralan appears to be chewing on some deathweed.>$b$bIf you\'re looking to make a love potion, you\'ve got the wrong place.  Blinding, crippling, and killing is my business and hopefully yours.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14190,'I can sense your desire for power, $c.','I can sense your desire for power, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14191,'Your faith guides me to victory.','',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(14192,'The Light gives us the strength and magic to triumph.','The Light gives us the strength and magic to triumph.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14193,'Lok-Narash! Prepare to strike down the outsiders! Warriors, rally!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14194,'Drive them out! We take none alive! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14195,'Two enemy factions. Both deserve to drown in blood. Who will taste death this day?\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14196,'We ride! For the Fel Horde! For Victory! \n','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14197,'FOR THE FEL HORDE!\n','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14199,'Lok\'tar! For victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14200,'Raiders, join ranks! On Korfang\'s signal, charge forth and crush these cowardly dogs! Forward!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14201,'The Alliance has stood against us for decades! Even now they \n mock us with the towers they have built on our land! \n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14202,'Thrall\'s traitors have abandoned the path to true power! They should die for their insolence and stupidity!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14203,'Hear my words, Korfang!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14204,'Then let those towers be their tombs! Lay waste to them!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14205,'So be it! They will curse Thrall for a fool once they have tasted our strength! To the towers!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14206,'The Fel Horde is on the move!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14207,'A Fel Horde scout! What\'s he looking for?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14208,'We\'re under attack! Take your positions!\n','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14209,'They are assaulting Thrallmar!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14210,'Kill them all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14211,'Where is your precious earth magic now?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14212,'The better to own you with!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14213,'Run away little girl, run away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14214,'%s bellows its approval.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14215,'','Welcome to the Registrar of Guilds.  How can I be of service to you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14216,'','Hello, my child.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14217,'Oh, grandmother, what big ears you have.','Oh, grandmother, what big ears you have.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14218,'','The better to hear you with, my child.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14219,'Oh, grandmother, what big eyes you have.','Oh, grandmother, what big eyes you have.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14220,'','The better to see you with, my child.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14221,'Oh, grandmother, what phat lewts you have.','Oh, grandmother, what phat lewts you have.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14223,'','Thank the Light, $n, my leg is completely healed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14224,'','Please tell Guvan that I\'ll be fine, thanks to you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14225,'Wonderful! You made it!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14226,'Did it give you much trouble? My poor little baby, $r are such nasty company.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14227,'Well it\'s about time. Kessel isn\'t gonna be too happy about any of this...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14229,'Who dares wield magic in my presence?','Who dares wield magic in my presence?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14230,'What...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14231,'%s is consumed by its own magic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14232,'Greetings, young shaman.  Make yourself at home within my reef.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14233,'Together we will deal with this corruption of the water.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14234,'You have done a great thing, $n.  You are welcome here at any time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14235,'%s bursts forth from the ground and attacks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14236,'You Kessel?','You Kessel?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14237,'I am. What is it that I can do for you?','I am. What is it that I can do for you?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14238,'We\'ve got orders from the harbinger to pick up some elekk for the base.','We\'ve got orders from the harbinger to pick up some elekk for the base.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14239,'Nonsense. These are not the elekk you\'re looking for.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14240,'These are not the elekk we\'re looking for.','These are not the elekk we\'re looking for.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14241,'You can go about your business.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14242,'The %ss nod their heads in unison.','The %ss nod their heads in unison.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14243,'We will go about our business now. Good day.','We will go about our business now. Good day.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14244,'Weren\'t we supposed to do something?','Weren\'t we supposed to do something?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14245,'Hrm. Nothing comes to mind.','Hrm. Nothing comes to mind.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14246,'%s shrugs.','%s shrugs.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14247,'Wrong!  It is YOU that will die, Tel\'athion the Impure!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14248,'It is YOU who are wrong!  I will deal with you two after I have slain this meddlesome shaman!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14249,'Entering Phase 2 <PH>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14250,'Master chef, can you train me in the culinary arts?','Master chef, can you train me in the culinary arts?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14251,'<Sigh> I suppose, if I must.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14252,'Have you any cooking supplies?','Have you any cooking supplies?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14253,'Yes, but be quick with your browsing.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14254,'%s roars in pain and attacks its assailant.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14255,'','Come for some blacksmithing supplies, have ya?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14256,'I\'ve got fresh meat, fish and mushrooms.  And plenty to drink!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14257,'','Greetings, $n.  As you rise in rank among the forces of Honor Hold, I will give you access to some of the different goods we keep in stock.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14258,'Show me what I\'ve earned the right to purchase.','Show me what I\'ve earned the right to purchase.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14259,'Come intruders....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14260,'I am Admetius, leader of Blood Watch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14261,'Welcome to Thrallmar, $n!  As you continue to aid us in our cause, I will grant you access to more of our supplies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14262,'Morae... Is that you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14263,'No... you\'re not Morae, but I sense that you have met. When you see her, tell her that I survived the crash, only to be done in by the infiltrators.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14264,'Let her know... my last thought was of her...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14265,'%s calls for assistance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14266,'Need me to take care of your animal companions?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14267,'I wish to make use of the stables.','I wish to make use of the stables.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14268,'On Argus, Mac\'Aree was the most sacred of our cities.$B$BWould you believe me if I told you that the walkways were lined with precious minerals? That the rivers glittered even in complete darkness?$B$BI long for those days... How long has it been? A thousand years? Ten-thousand?','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(14269,'If only I could get back to the mushroom thicket. I have not seen such a mature cluster in my lifetime!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14270,'It will be done, my lady.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14271,'You have new orders, maggots.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14272,'It is none of your concern, maggot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14273,'Out of my way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14274,'You dare impede official Sunhawk communications?','You dare impede official Sunhawk communications?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14275,'Touch not the horse, filth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14276,'Sire, any news from the king?','Sire, any news from the king?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14277,'Sironas stirs, master? Does she toil?','Sironas stirs, master? Does she toil?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14278,'I will smite them all in the name of Sunstrider!','I will smite them all in the name of Sunstrider!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14279,'Draenei filth will not last on this world...','Draenei filth will not last on this world...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14280,'What does gotcher mean?','What does gotcher mean?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14281,'Now, let\'s see...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14282,'In the process of translating this, I believe I\'ve learned more about the drunken exploits of a certain \'Andrew Clementine\' than about the journal\'s author.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14283,'But, no matter. Mister Clementine\'s... err, \'contribution\' notwithstanding, this seems to be the journal of a man named Nolkai. The entries toward the end describe a brutal battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14284,'Jessera, could you direct me towards the aquatic stinkhorn?','Jessera, could you direct me towards the aquatic stinkhorn?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14285,'Take a look at this passage...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14286,'Look in the waters that divide this island, but be warned: the stinkhorn striker makes its home in the waters of the river.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14287,'Jessera, could you direct me towards the ruinous polyspore?','Jessera, could you direct me towards the ruinous polyspore?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14288,'Welcome to Blood Watch, $c. In my travels, I have amassed a wide variety of tools, artifacts, and knowledge from the various peoples we\'ve encountered.$B$BShould you find yourself in need of this knowledge, you have only to ask.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14289,'As the name suggests, it can be found near ruins. Loreth\'Aran holds the answer.$B$BActually, the name doesn\'t really suggest that -- I was just trying to be clever in naming the fungi.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(14290,'Jessera, could you direct me towards the fel cone fungus?','Jessera, could you direct me towards the fel cone fungus?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14291,'Fel cone derives its name from fel magic corruption. Seek the fel cone fungus at the Nazzivian satyr camp - to the west.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14292,'Jessera, could you direct me towards the blood mushrooms?','Jessera, could you direct me towards the blood mushrooms?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14293,'Blood mushrooms are more common than the other fungi varieties and can be found mostly anywhere in the woods around Bloodmyst. Keep your search south of the road dividing Bloodmyst if you value your life.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(14294,'What have you done, wizard?  This cannot be!  I\'m burning from... within!','',0,0,0,0,0,0,0,0,1,0,77693,0,26124),
(14295,'You\'ve got my attention, dragon.  You\'ll find I\'m not as easily scared as the villagers below.','',0,0,0,0,0,0,0,0,1,0,77686,0,26124),
(14296,'Your dabbling in the arcane has gone too far, Medivh.  You\'ve attracted the attention of powers beyond your understanding.  You must leave Karazhan at once!','',0,0,0,0,0,0,0,0,1,0,77692,0,26124),
(14297,'You dare challenge me at my own dwelling?  Your arrogance is astounding, even for a dragon!','',0,0,0,0,0,0,0,0,1,0,77687,0,26124),
(14298,'A dark power seeks to use you, Medivh!  If you stay, dire days will follow.  You must hurry, we don\'t have much time!','',0,0,0,0,0,0,0,0,1,0,77690,0,26124),
(14299,'I do not know what you speak of, dragon... but  I will not be bullied by this display of insolence.  I\'ll leave Karazhan when it suits me!','',0,0,0,0,0,0,0,0,1,0,77689,0,26124),
(14300,'You leave me no alternative.  I will stop you by force if you won\'t listen to reason!','',0,0,0,0,0,0,0,0,1,0,77691,0,26124),
(14301,'If you only learn one thing during your time in Bloodmyst, $c, I hope that it is vigilance. This island claims the unwary first, then begins to wear down even the most guarded of warriors.$B$BEverywhere you turn, a foe stands ready to take your life. ','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(14302,'','Everything that has happened since the crash is little more than a blur. It seems like a lifetime ago that I was aboard the Exodar.$B$BNow, my reality is restricted to this island with its mutant creatures and endless sea of blood elf agents. Soon, it will be as if I\'ve never known anything different...',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14303,'The others look at this landscape and see only death, corruption, and adversity. None of those things are in short supply, true, but that view ignores the opportunities presented by our environment.$B$BI will not stand by and watch these opportunities go ignored, $c. With your help, we can demonstrate to the others here at Blood Watch just how to make use of the environment and its creatures.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14304,'Hello, $c.$B$BOld man Kessel over there, he\'s a clever one. I\'d be real careful in my dealings with him if I were you.$B$BHe offered me work \'caring for the elekk\' and being the fool I was, I took it to mean feeding, training, and the like. Things became real clear when he handed me the shovel...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14305,'I should res right now.','I should res right now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14306,'To arms! The prisoner is escaping!','To arms! The prisoner is escaping!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14308,'%s begins to cast a spell of great power, weaving his own essence into the magic.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14309,'Invaders have breached the defenses!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14310,'Archers, form ranks! On my mark!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14311,'Ready!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14312,'Thanks for the warning, $n! We shall prepare!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14313,'Promised One, we thank you for the warning. The Stillpine tribe will be prepared.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14314,'Thank you for the warning, $n. We will prepare our defenses.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(14315,'','I\'m going back inside.  Let me know if anything else comes up.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14316,'He should not have angered me.  I must go... recover my strength now...','',0,0,0,0,0,0,0,0,1,0,77688,0,26124),
(14317,'I am Kessel, lord of the elekk, disciple of the Hand of Argus. Are you the new recruit?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(14318,'','All those years of research... and for nothing! Perhaps they were right, perhaps this is something we must learn to live with.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14319,'Holding his nose, %s scoops up the dung and places it in his bucket.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14320,'I\'ll do what I can.  No promises, though.  This weapon has been completely shattered.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14321,'The metal was salvageable.  I should be able to reforge the weapon as a sword or a dagger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14322,'Face the wrath of Bristlelimb!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14323,'Thank you for saving me, $n! My father will be delighted!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14324,'I am Achelus, chief expeditionary officer of Blood Watch.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(14325,'I deliver the mail to and from Azuremyst, $c. If you need a message delivered, it\'ll more than likely be routed through me first.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(14326,'What it means to be a Hand of Argus... We are agents of the Light. We serve without question. We die without question.','',1,1,22,0,0,0,0,0,1,0,0,0,26124),
(14327,'Did they send you to find me? Well I\'m not going back without my men.','',1,274,0,0,0,0,0,0,1,0,0,0,26124),
(14328,'Don\'t you people ever check the mail?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14329,'How am I expected to deliver all of these messages?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14330,'I need to be re-assigned. This job is pushing me over the edge...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14331,'One of these days I\'m going to bust out the crystalline doomhammer and go positively orc on this town. Then they\'ll be sorry...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14332,'He thinks he\'s so damned important. Always pushing me around... I\'ll show him. I\'ll show all of them!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14333,'Hey Hermesius, do I have any new mail?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14334,'Hermesius, has my package from the Exodar arrived yet? It\'s been over a week.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14335,'Hermesius come quick! I have an urgent delivery that must be taken to the human admiral of the Alliance expedition.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14336,'What\'s going on over there at your delivery service? How are we expected to function when our mail is never here on time?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14337,'IF YOU THINK THIS IS SO EASY, GRAB A BAG AND GET TO WORK!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14338,'Otherwise, get off my back! One of these days you won\'t have old Hermesius to push around anymore. That much I can promise...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14339,'','Hey Hermesius, do I have any new mail?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14340,'','Hermesius, has my package from the Exodar arrived yet? It\'s been over a week.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14341,'','Hermesius come quick! I have an urgent delivery that must be taken to the human admiral of the Alliance expedition.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14342,'','What\'s going on over there at your delivery service? How are we expected to function when our mail is never here on time?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14343,'','You must be the laziest messenger known to draenei.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14344,'You must be the laziest messenger known to draenei.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14345,'You dare strike an agent of the Hand?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14346,'We\'re free! We\'re free!','We\'re free! We\'re free!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14347,'Woot! Thanks!','Woot! Thanks!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14348,'By the forehead signet of Velen, I am saved!','By the forehead signet of Velen, I am saved!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14349,'I knew Cornelius wouldn\'t leave us behind!','I knew Cornelius wouldn\'t leave us behind!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14350,'Your death will satisfy our master.','Your death will satisfy our master.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14351,'Yes, I am one of the \'Broken\'.  I trust that this does not bother you?  Broken or draenei, we must endure the ridicule that some in our society may throw at us.  A better understanding and communication with the elements of this world is all that matters.','Yes, I am one of the \'Broken\'.  I trust that this does not bother you?  Broken or draenei, we must endure the ridicule that some in our society may throw at us.  A better understanding and communication with the elements of this world is all that matters.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14352,'Please, sit and make yourself comfortable.','Please, sit and make yourself comfortable.',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(14353,'Ahhh.... Yes, the blood of the exiles fills me with power! Beware, Bloodmyst!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14354,'Come, followers of Kael, let us destroy our enemies! Let us show them that there is no escape from the Eredun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14355,'This siege has gone dormant for far too long, let us destroy the Draenei and their pitiful city!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14356,'Now, kill them all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14357,'Good day, $c. Are you in need of a reliable hippogryph?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14358,'I desire to travel by hippogryph.','I desire to travel by hippogryph.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14359,'If you need to travel to the Exodar, I have just the hippogryph for you!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14360,'I wish to travel by hippogryph.','I wish to travel by hippogryph.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14361,'%s begins to rust!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14362,'Shh! Be very quiet; I\'m observing murlocs.$B$BLiving in an oversized turtle shell is a sacrifice I\'m willing to make for science. After all, if the murlocs see me here, they\'ll react to my presence and contaminate my data!$B$BAs the first gnomish member of the Explorers\' League, I\'m boldly going places no dwarf has gone before!','',1,11,0,0,2,0,0,0,1,0,0,0,26124),
(14363,'Now I\'m coming for you, Exarch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14364,'','The spirits of this place are focused against your kind, $r. Perhaps if you win this tower in the flesh, I will be able to aid you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14365,'Defend yourself, youngling! We\'ll see if there\'s a Blood Knight in you, yet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14366,'Who dares defile the statue of our beloved?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14367,'This is... Silvermoon? My head... Next time Bloodvalor needs a volunteer, I\'ll point him in a different direction. Paragon of Blood Knight virtue, indeed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14368,'Don\'t get me wrong, $n. I very much appreciate the resurrection, but I think this is the last time I\'ll perform this particular duty. Maybe a goblet or two of wine will help with this headache.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14369,'Are you mad? Look around you, mortal. Do you not see that you stand upon sundered earth? Leave this place lest you suffer as my people and I have...','',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(14370,'Why do you suffer?','Why do you suffer?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14371,'Are you blind as well as insane?$B$BI am a ghost - a cruel reminder of a civilization that has long since ceased to exist - anchored to a land that I failed to protect.$B$BLong ago - ten-thousand years past - I was flesh and bone, just like you. I was prince of this land and a dragon rider, blessed by Ysera of the Dream.','',6,1,1,0,0,0,0,0,1,0,0,0,26124),
(14372,'What is Ysera and how were you blessed?','What is Ysera and how were you blessed?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14373,'Have you not heard of Ysera? Guardian of nature? Aspect of the Dream? She is the matron of all green dragons! Aye, it was Ysera herself that gifted my kingdom with her brood. We stood shoulder to shoulder with the noble creatures and they allowed us to ride them into battle against our enemies. All was well for many centuries... until...','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(14374,'Until what?','Until what?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14375,'Deathwing\'s brood... Ysera\'s benevolence raised the ire of Deathwing - patron of the black dragonflight. They attacked us in our sleep! Many died on the initial surge but the greens rose to protect us.$B$B<Prince Toreth points around the island.>$B$BThe bones are all that remain of the once great dragons. None were spared.','',1,1,274,0,0,0,0,0,1,0,0,0,26124),
(14376,'So why are you still here?','So why are you still here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14377,'I was the last to die. As I felt my spirit leaving my mortal shell, I swore a blood oath.$B$B<Prince Toreth shakes his head.>$B$BA pact was made between this land and I: My blood for this world. I became the sole keeper of the history of my people.$B$BI cannot rest until I am secure in knowing that the story of the dragon riders of Loreth\'Aran is not lost in the passages of time.\n','',1,1,25,0,0,0,0,0,1,0,0,0,26124),
(14378,'Students are a bit like sheep.  They\'re useful and even likeable when you guide and pay close attention to them.$B$BYou leave them alone for a minute and they end up falling down a cliff or drowning in a shallow river.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14379,'This sign contains various announcements and notices of rewards for performing dangerous sounding tasks.  Nothing particularly catches your eye; perhaps you should check again at a later time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14380,'Wiping his brow, the %s sighs.','Wiping her brow, the %s sighs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14381,'Turning to face Tuluun, the %s sneers contemptuously.','Turning to face Tuluun, the %s sneers contemptuously.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14382,'We do not need your kind here.','We do not need your kind here.',25,0,0,0,0,0,0,7,1,0,0,0,26124),
(14383,'How can I be expected to get any work done with that thing spreading its heresy?','How can I be expected to get any work done with that thing spreading its heresy?',6,0,0,0,0,0,0,7,1,0,0,0,26124),
(14384,'The %s sighs disgustedly as he turns back to his work.','The %s sighs disgustedly as he turns back to his work.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14385,'Greetings, citizen. I ask that you move along if you have nothing to ask of me.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(14386,'Marshal Windsor has been expecting you, $n. Unfortunately, he is currently indisposed. He should be returning shortly.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(14387,'You made it! Outstanding! Marshal Windsor has been expecting you. Would you like me to signal him now?','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(14388,'Let Marshal Windsor know that I am ready.','Let Marshal Windsor know that I am ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14389,'The signal has been sent. He should be arriving shortly.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14390,'Hail, champion. The tale of your deeds will be told throughout the ages. Perhaps one day, a statue of you will stand amongst the heroes of Stormwind.','',1,1,66,0,0,0,0,0,1,0,0,0,26124),
(14391,'Stay away from me, $r! There\'s no telling when the sickness will take me again.$B$BJust leave me alone before it happens again.','',25,1,0,0,0,0,0,0,1,0,0,0,26124),
(14392,'Listen to me, human. I care nothing for your plight, but you have something I require. Tell me where to find the bloodforged ingots.','Listen to me, human. I care nothing for your plight, but you have something I require. Tell me where to find the bloodforged ingots.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14393,'How did you learn about the ore? Not even the Baron knew...$B$BTake the cursed things. They\'ve brought me nothing but misfortune anyway. I hid them in the stables just off the courtyard.$B$B<A low growl begins to emanate from the back of Landen\'s throat.>','',20,1,0,0,0,0,0,0,1,0,0,0,26124),
(14394,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14395,'%s howls in rage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14396,'','You will tell me everything I need to know, scum.',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(14397,'','Where are our men, scoundrel? I want answers!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14398,'','Aren\'t you hungry? Thirsty? I can arrange for food and drink -- all you need to do is tell me what I want to know.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14399,'','If these two don\'t start talking soon, I\'m going to get violent with my words.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14400,'You dare speak to me, blue skinned mongrel? I would sooner die than tell you anything.','You dare speak to me, blue skinned mongrel? I would sooner die than tell you anything.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14401,'%s spits on Interrogator Elysia.','%s spits on Interrogator Elysia.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14402,'%s laughs.','%s laughs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14403,'We happily drink in your blue blood, draenei. Nothing gives us more pleasure than to wound you just to see the blood flow.','We happily drink in your blue blood, draenei. Nothing gives us more pleasure than to wound you just to see the blood flow.',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(14404,'Get back to work you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14405,'Wake up! Now get up and back to work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14406,'Insolent fool! You thought to steal Zelemar\'s blood? You shall pay with your own!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14407,'Examining the corpse, you conclude that this must be Blood Knight Dawnstar, the leader of the failed assault on Deatholme.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14408,'Search the corpse for an insignia.','Search the corpse for an insignia.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14409,'I can help you establish a guild.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14410,'A search of the corpse\'s clothing and equipment reveals the insignia you need, undamaged by the battle and foul environment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14411,'','Elune\'s grace upon you.  How can I serve?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14412,'Hurry up with it already! The longer you take, the more of a hurtin\' I\'m putting on you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14413,'What is this?! Didn\'t mommy and daddy teach you anything?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14414,'This is terrible..... my arms grow tired from beating on you lazy peons!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14415,'Too soon! You are slacking off too soon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14416,'Yes master, anything you say.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14417,'','Greetings, $c.  It is good you\'ve decided to visit us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14418,'You have served one of three with honor, $n. Our time is at an end. Kuros will call for you when he is ready.','',1,2,0,0,0,0,0,0,1,0,0,0,26124),
(14419,'A %s spots medical supplies.','A %s spots medical supplies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14420,'%s picks up medical supplies.','%s picks up medical supplies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14421,'Sorry, you lose! <PH>','Sorry, you lose! <PH>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14422,'Greetings, $c. I am Kuros, second of the Triumvirate of the Hand.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14428,'I watched as they beat him without mercy. Their ruthless lieutenant acted as if such cruelty was an act of normalcy. Through the savage beatings, I could feel myself breaking.$B$BAs I watched Vindicator Saruan take their blows, I began to weep. Not out of fear... I wept out of sadness. To see a draenei of the Triumvirate treated in such a manner. If only I could have broken free of my bonds. If only...\n','',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14429,'<Turn to the next page.>','<Turn to the next page.>',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14430,'After what seemed an eternity, the Vindicator lost consciousness. The torture was too much, even for him. The cruel one - Matis as I found out he was called - attempted to wake Saruan by splashing contagion laced water across his ravaged body. But Saruan did not wake.\n','',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14431,'I wanted to scream but only a low gasp escaped my lips. I was promptly beaten for this act of rebellion. As I lay on the ground, I could see Matis pacing in front of Saruan\'s body. He seemed visibly concerned. He stated that Sironas or Sirona or some such entity would have his flesh flayed from his bones if Saruan had perished in the beatings. \n','',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14432,'That the Sironas entity had plans for Saruan... $B$B<The writing stops abruptly and a long line scrolls off the page. This draenei died while making the entry.>\n','',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14433,'','Remember, $n!  Remain within Dawning Street and you will reach the Inner Elf Gate!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14434,'sqwaks in the innkeeper\'s direction and makes its way back towards Sunstrider Isle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14435,'Good day, $c. If you wish to learn the smith\'s art, you\'ve come to the right place.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14436,'I seek training as a Blacksmith.','I seek training as a Blacksmith.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14437,'','Oh, pay no mind to Buddy.  He won\'t hurt you, he just likes to scratch now and then.$B$BHe\'s just a big, loveable kitty.$B$BAren\'t you Buddy?  Yes, you are, you cute, little thing.  You\'re mommy\'s little baby, that\'s what you are!',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(14438,'%s arranges the materials on the anvil.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14439,'%s\'s face twists in revulsion as he realizes what Bemarrin is doing. He turns his back and walks away.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14440,'Pay no attention to their kind, $n. The sacrifices made by your order are lost on them. They will never understand the price you pay for the power you wield in their defense.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14441,'There, $n. It is done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14442,'We Cenarion druids are the protectors of the balance of nature.  The main point being the balance.  When called for, we shouldn\'t wait too long before taking decisive action.  Don\'t let anyone tell you otherwise, especially those of us who only want to observe!','',1,1,0,0,500,0,0,0,1,0,0,0,26124),
(14443,'Stand back, $n. There are going to be a lot of sparks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14444,'%s falls unconscious.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14445,'Return to Kuros. I will bring him to Blood Watch.','Return to Kuros. I will bring him to Blood Watch.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14446,'We\'ve got you now, $n!','We\'ve got you now, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14447,'You will never take me alive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14448,'To the death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14449,'You will regret this, maggot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14450,'Hi, $n. Click the option below to complete quest 9711 -- Matis the Cruel.$B$BNote that nothing happens even though I am attempting to cast a spell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14451,'You complete me.','You complete me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14452,'Cast another spell on me that uses the exact same implicit target but has a different effect -- like death touch.','Cast another spell on me that uses the exact same implicit target but has a different effect -- like death touch.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14453,'I am at your service, my lord.','I am at your service, my lord.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14454,'I want all of your trackers out in search of the criminal, Matis the Cruel. I have given trusted agents of the Hand flare guns. Should you or one of your trackers see the flare, it means that an agent has found Matis and needs assistance. And remember, tracker, Matis is to be brought back to me alive.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14455,'It will be done, my lord.','It will be done, my lord.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14456,'%s calls forth their brethren.','%s calls forth their brethren.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14457,'Brothers and sisters, tonight we hunt! A blood elf known as Matis must be brought to justice! The first to find him gets one week\'s vacation aboard the Exodar!','Brothers and sisters, tonight we hunt! A blood elf known as Matis must be brought to justice! The first to find him gets one week\'s vacation aboard the Exodar!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14458,'Onward! The wilds of Bloodmyst await!','Onward! The wilds of Bloodmyst await!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14459,'Let the trial begin! Bloodwrath, attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14460,'Champion Lightrend, make me proud!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14461,'Thrall has escaped!  Don\'t let him get away!','Thrall has escaped!  Don\'t let him get away!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14462,'Show this upstart how a real Blood Knight fights, Swiftblade!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14463,'Show $n the meaning of pain, Sunstriker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14464,'Well done, $n! You have passed the second trial!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14465,'There he is, stop him!','There he is, stop him!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14466,'Don\'t let him get away!','Don\'t let him get away!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14467,'Who are you?  Just leave me be.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14468,'We are ready to get you out of here, Thrall. Let\'s go!','We are ready to get you out of here, Thrall. Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14470,'Your beloved leader has failed you! Let your blood be on his hands! Attack!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14471,'Victory is a stone\'s throw away!  Lok\'tar Ogar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14472,'What\'s the status on the primary tank?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14473,'What is that thing doing inside the tank?\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14475,'Any word from Mennu on the relief we requested? ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14477,'Sir, we\'re doing everything we can to address the leak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14478,'Still leaking, sir. ','Still leaking, sir. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14479,'We\'re doing everything we can to stop the water.','We\'re doing everything we can to stop the water.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14480,'We can\'t seem to stop the pumps. ','We can\'t seem to stop the pumps. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14481,'No idea. ','No idea. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14482,'This is the first time I\'ve ever seen anything like it. ','This is the first time I\'ve ever seen anything like it. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14483,'It probably caused the leak!','It probably caused the leak!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14484,'No word since the disturbance earlier, sir. ','No word since the disturbance earlier, sir. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14485,'There\'s been trouble contacting Mennu, sir!','There\'s been trouble contacting Mennu, sir! ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14486,'Our messenger to the slave pens never returned, sir.','Our messenger to the slave pens never returned, sir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14488,'Well, hurry up! Lord Illidan has no patience for mistakes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14489,'Keep trying, we need to get this water out of here. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14490,'Bah! Incompetent!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14491,'Perhaps if he spent less time playing with his pet Goblin and more time training we\'d have enough power to fix this thing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14492,'Ugh, what a bunch of slackers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14493,'I don\'t remember saying they could take a break!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14494,'Remind me to dock them for leaving without permission!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14495,'Hurry up, Lady Vashj expects results! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14496,'%s sniggers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14498,'%s nods in agreement.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14499,'%s giggles.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14500,'%s smirks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14501,'%s sneers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14502,'%s snorts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14503,'Where should I begin my search for the portal?','Where should I begin my search for the portal?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14504,'Begin your search to the north, $n. Our scouts have spotted the Warp Piston near the shoreline.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14505,'Tell me of your past, Farseer.','Tell me of your past, Farseer.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14506,'My story? It is kind of you to ask. Very well.$B$BLong ago on the planet Draenor - the remains of which are now known as the Outland - all of the draenei lived in peace. But then the Burning Legion came, and they corrupted the orcs with their fel magics.$B$BWith no other option we fought to survive, but exposure to these fel energies had horrible effects upon some of us, over time transforming us into the Broken like me, or worse, the seemingly mindless Lost Ones.$B$BShall I go on?','',1,1,6,0,500,500,0,0,1,0,0,0,26124),
(14507,'Yes, please continue.','Yes, please continue.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14508,'The fel energies also had the side-effect on the Broken and the Lost Ones of cutting us off from the Light. At the time I did not know exactly why, but as a vindicator I insisted on finding out. I decided to make a pilgrimage to do just that.$B$BAnd so it was that after the war came to its fateful end, I journeyed into the desert of the fragmented planet, beseeching the Light to return to us. But decades passed, and the Light never answered my prayers.$B$BIs this something that you wish to hear more of?','',1,1,6,0,500,500,0,0,1,0,0,0,26124),
(14509,'Yes, please, if you do not mind.','Yes, please, if you do not mind.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14510,'I had been fortunate to find an oasis and made the decision to stay there until I received an answer. So there I sat, moving only when absolutely necessary, living off of the creatures that would come near the pool. Such was my pride.$B$BAs I said, decades passed without an answer. But I can remember a particularly beautiful sunset one evening. A warm zephyr blew across the land and I was sure that I heard a voice, but no one was around.$B$BAs you can imagine, I thought that I was finally losing my mind.','',1,1,1,0,500,500,0,0,1,0,0,0,26124),
(14511,'Nobundo, please continue.','Nobundo, please continue.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14512,'There was something strange about that wind; it didn\'t stop. For weeks it blew across the land, waxing and waning, but never ceasing. And all the time the voice continued, though I could not understand it, nor did I know where it was coming from.$B$BMy time in solitude had taught me how to calm myself and look inward. This I did in order to keep my sanity. And that is when I began to understand the voice. It was coming from the wind itself and it had much to say!','',1,1,1,0,500,500,0,0,1,0,0,0,26124),
(14513,'What did it say to you?','What did it say to you?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14514,'It spoke to me of secrets and power, and also of truths. The Light had not forsaken the Broken! The fel energies that the orcs had wielded long ago against the draenei had infused us, causing a break in our ability to be heard by, or perhaps to hear, the Light. The same that had been responsible for the degradation of our bodies.$B$BBut our spirits were not broken, and the air offered to me another path, through which I might deliver my people.\n','',1,1,1,0,500,500,0,0,1,0,0,0,26124),
(14515,'What was that?','What was that?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14516,'It taught me the path of shamanism, which in a way is just another facet of the Light. Joining the wind was the water of the oasis, the fire from my camp and the earth upon which I sat. All had something to say.$B$BOver the next few years they taught me what it was to call upon and be one with the elements of the world. And they told me that the worlds of all of the stars in the sky, even this one, are made up of these elements.$B$BBut the day came when I felt that I had learned enough to leave.','',1,1,1,0,500,500,0,0,1,0,0,0,26124),
(14517,'What did you do then?','What did you do then?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14518,'I returned to my people and was greeted with smiling faces and outstretched arms, mostly from the Broken. The prejudices against us from many draenei had continued in my absence. But it was as if they knew that I was coming, and I soon found out why.$B$BVelen, the prophet and leader of all of the draenei, had seen my return in one of his visions and was there to greet me as well. He asked to speak with me in private and as I related my story to him, he nodded and smiled, for this too he had foreseen.','',1,1,1,0,500,500,0,0,1,0,0,0,26124),
(14519,'Bring forth the blood elf.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14520,'Sorry, you win! <PH>','Sorry, you win! <PH>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14521,'Please, go on.','Please, go on.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14522,'You heard the Prophet. Move, filth.','You heard the Prophet. Move, filth.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14523,'Velen urged me to take a leadership role amongst the Broken. But more importantly, he asked me to teach shamanism to all; Broken and draenei alike. I accepted.$B$BWe knew then that given the prejudices of some that this would be a difficult proposition at best. There are those that despise the Broken because we are a frightening reminder of the past. And there are others who believe the way of the shaman to be a blasphemy against the Light.$B$BIn any case, that is my tale.','',1,1,1,0,500,500,0,0,1,0,0,0,26124),
(14524,'Matis, blood elf lieutenant of the Sunhawks, you have been found guilty of genocide against the draenei people.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14525,'You are to be executed at light\'s dawning. Have you anything to say for yourself?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14526,'%s spits at the image of Velen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14527,'May the Light have mercy on your soul. Take him back to his cell.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14528,'%s glares at Velen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14529,'The Light?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14530,'%s laughs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14531,'I am Blood Knight, mongrel. I do not serve the Light, the Light serves me. If mercy is to be granted, it will be by me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14532,'You seek to martyr me before my order - so be it. Strike me down, another will rise in my place and the suffering of the Light - of the conquered - will continue uninterrupted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14533,'You blaspheme! The Light would never allow such an aberration!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14534,'The Light has no choice. It does as it is commanded. Just as the naaru you hold at the core of your vessel will do when we capture and enslave it... Do my words surprise you, blue blood? Yes, we know... We know everything.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14535,'Take him away.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14536,'Move!','Move!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14537,'Draenei dog! Did you know that the one you call Saruan wept like a babe as I beat him? A feeling of euphoria coursed through me, knowing that I had a member of high rank in my grasp. Were it not for Sironas\' plans for him, I would have tortured him to death... As I do to all draenei that I capture. Alas, I am certain that you will see him again soon...\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14538,'%s grins wickedly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14539,'Breathe your last breath, heathen.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14540,'%s spits on the corpse of Matis.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14541,'Find their source of power and tear it down. Tear all of it down.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14542,'If our enemies would see that we only wish to live in harmony with them, maybe we wouldn\'t have to attack them for our own survival?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14543,'Their day will come, $n.$B$BAnd when it does, I will be there.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14544,'With new enemies on our doorsteps, we must not allow our ancient enemies to take advantage of our situation!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14545,'','Can you believe this place?  \'Course, it\'s a mite stuffy up here if you ask me.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14546,'Say, you happen to see that arch in the lake to the west?  I wonder where that goes?  I should go divin\' over there.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14547,'Filthy fungal giants!  What did we ever do to them?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(14548,'','If only I hadn\'t twisted my ankle coming into this place, I\'d be in there with my friends.  Hmmm, now that I think about it, maybe it\'s better that I\'m out here?',1,6,0,0,500,0,0,0,1,0,0,0,26124),
(14549,'Fhwoor like little sporelings.  They save Fhwoor.  Not eat them.$B$BFhwoor hate naga.  Fhwoor smash!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14550,'I must concentrate! Guards! Guards! Aid me!','I must concentrate! Guards! Guards! Aid me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14551,'Count yourself blessed that I fear the wrath of Kael\'thas more than death, else I would break from this channel and disintigrate you.','Count yourself blessed that I fear the wrath of Kael\'thas more than death, else I would break from this channel and disintigrate you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14552,'Protect the portal!','Protect the portal!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14553,'You will never know such discipline.','You will never know such discipline.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14554,'You hit like a child.','You hit like a child.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14555,'Pathetic, really. Is that the best you can do?','Pathetic, really. Is that the best you can do?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14556,'Like the phoenix, I shall be reborn.','Like the phoenix, I shall be reborn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14557,'I... have... failed...','I... have... failed...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14558,'Forgive me, master.','Forgive me, master.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14559,'My comrades will... will... arrrrgghhh...','My comrades will... will... arrrrgghhh...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14560,'Sunstrider shall be victorious!','Sunstrider shall be victorious!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14561,'You only delay the inevitable...','You only delay the inevitable...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14562,'I lost my Weathered Treasure Map. Do you have a spare copy of it?','I lost my Weathered Treasure Map. Do you have a spare copy of it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14563,'I am Aesom, third of the Triumvirate.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14564,'As a matter of fact, I did. I was going to frame it and show it to the guys in Ironforge for a laugh, but you\'re welcome to it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14565,'The wind speaks of our enemies\' movements, Ashyen.  The naga will attack again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14566,'Prudence should not mean granting our enemy unnecessary advantages.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14567,'Very well.  When that decision is made, I will be ready.  Let us hope it won\'t be too late.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14568,'We\'d do well not to be reckless.  There\'s still much to learn about this land and about the enemy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14569,'We will act when we know what we need, old friend.  The druids have proven wise and capable of making their own decisions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14570,'Here lie the remains of Weeder Greenthumb, one of Watcher Jhang\'s druid companions.  By all appearances he was killed quick and clean while trying to make his escape from the Slave Pens.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14571,'I almost made it!$B$BI came in here to prove the existence of Quagmirran, that most mythical of fungal giants.  I got my wish, sort of.$B$BYou must let me free!  In return I will grant you a boon to help you to deal with Quagmirran.','',5,1,0,0,500,0,0,0,1,0,0,0,26124),
(14572,'The protective tendrils of arcane energy have been lifted. The sun gate is vulnerable!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14573,'The sun gate must be stabilized. Focus your energies!','The sun gate must be stabilized. Focus your energies!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14574,'Alright, Bite, I\'ll let you out.','Alright, Bite, I\'ll let you out.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14575,'Uh oh!  It would appear that all of the noise you\'ve been making has attracted some unwanted attention!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(14576,'Very well.  Onward to fame and glory!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(14577,'Who dares disturb the sanctity of the Alonsus Chapel?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14578,'Oh mighty Quagmirran, we beseech thee to welcome us into your presence!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(14580,'What you have done is abominable! Atone for your crimes against the Light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14581,'False paladin, show yourself! Prepare to taste the wrath of the Light\'s true servants!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14582,'Filthy animals!  Cage me will you?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14583,'<Naturalist Bite growls.> You took my worldly possessions, but you will NEVER take my soul!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14584,'I... HAVE HAD ENOUGH... OF... YOU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14585,'I like to think myself a reasonable fellow in an unreasonable situation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14586,'Nothing will stop me from fulfilling my destiny!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14587,'There is no other way, blasphemer. Prepare to meet your fate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14588,'I can go around you, or through you.  Your choice!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14589,'Not the face... Not the face!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14590,'Is it really wrong of me to seek my petty revenge?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14591,'Thank goodness for you!  Claw and I were investigating this place when we were jumped by Swamplord Musel\'ek.$B$BUnfortunately, Claw was caught in bear form at the time, and is now the swamplord\'s pet.$B$BI\'m afraid you\'ll have to fight Claw in order to save him.','',1,1,0,0,500,0,0,0,1,0,0,0,26124),
(14592,'As the only apparent surviving \'Broken\', it is both my duty and honor to carry on the shamanistic teachings of Farseer Nobundo.','As the only apparent surviving \'Broken\', it is both my duty and honor to carry on the shamanistic teachings of Farseer Nobundo.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14593,'','Damn those blood elves and their reckless magic!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(14594,'Do not waste my time.  What is it you want?','Do not waste my time.  What is it you want?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14595,'Fool! Do you know what you\'ve done? This is sacred ground!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14596,'[PH] Encounter Complete!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14597,'How embarrassing to be taken as a pet by a hunter!$B$BI owe you my life.  Now that you\'ve freed me from Musel\'ek, I\'ll be able to find my way out.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(14598,'Kill them before they grow!','Kill them before they grow!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14599,'Filthy void beast! DIE!','Filthy void beast! DIE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14600,'Destroy the vermin!','Destroy the vermin!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14601,'Sironas will have our skulls if these are allowed to grow!','Sironas will have our skulls if these are allowed to grow!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14602,'Tune \'em up good, boys!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14603,'Watcher Leesa\'oh, why are you out here?','Watcher Leesa\'oh, why are you out here?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14604,'','May the Light bend to your will in all endeavors.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14605,'','All things in nature exists in an interconnected web; an ecology.  If we\'re careful not to disturb it, and simply observe, we may be fortunate to piece together the complex relationship between the diverse organisms around us.$B$BOnce we have that understanding, we can take the appropriate actions to ensure the wellbeing of all creatures.  Interfere without that knowledge, and we\'ll surely cause destruction.$B$BI am here to observe the complex interactions between the sporelings and the bog lords.',1,1,1,0,500,500,0,0,1,0,0,0,26124),
(14606,'I have run out of extinguishing mixture. May I have another vial?','I have run out of extinguishing mixture. May I have another vial?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14607,'','Of course, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14608,'','$n, let\'s go see if this plan will work.  Come along, Buddy!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14609,'','Ok, let\'s see about using those mushrooms you brought back to grow the bog lords a new food supply.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14610,'','Oh Buddy, you big baby!  Look, it\'s working.  It\'s really working!!  Now all I need to do is grow more of these mushrooms here and the bog lords will likely leave the sporelings alone!',21,1,0,0,0,0,0,0,1,0,0,0,26124),
(14611,'','Oh, thank you, $n!  You\'ve made it possible to save both the sporelings from the bog lords, and the bog lords from our wrath.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(14612,'The %s takes a piece of the mushroom tree and holds it to its \'nose\'.  Seemingly satisfied, it eats it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14613,'The %s uproots the rest of the mushroom tree and makes off with it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14614,'Starting Event <PH>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14615,'','Wait and see what happens!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14616,'Banish <PH>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14617,'<Vindicator Aesom salutes you.>$B$BHave you spoken with Admetius? I believe he was inquiring as to your whereabouts.','',66,1,0,0,0,0,0,0,1,0,0,0,26124),
(14618,'Psst!  Hey, $c, over here to your left.  Come here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14619,'The druids protect me from the naga and evil Lost Ones.  In exchange, I teach them about the plants and animals of the marsh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14620,'Unpleasant place, this \"Undercity\". Not at all like the Lordaeron of old. How I miss it...$b$bIf you\'re looking to go to Stratholme, I\'m afraid I\'m unable to assist at the moment. The towers nearby the burning city are still in contention, and as such my powers are far too weak to aid you. Return to me once you\'re victorious there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14621,'Ah, I can sense it - you\'ve won the day! I believe I can safely transport you to Stratholme now, provided you\'ve paid my colleague there a visit first. Just step into the circle and be patient...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14622,'Be thankful that I am locked inside this cage, $r.','Be thankful that I am locked inside this cage, $r.',1,0,0,0,0,0,0,10,1,0,0,0,26124),
(14623,'Hope this day finds you well.  Can I offer you something?','Hope this day finds you well.  Can I offer you something?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14624,'I need the illusion cast upon me again, Admetius.','I need the illusion cast upon me again, Admetius.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14625,'<The captured Sunhawk agent eyes you suspiciously.>$B$BI\'ve never seen you before. Who are you?','<The captured Sunhawk agent eyes you suspiciously.>$B$BI\'ve never seen you before. Who are you?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14626,'I\'m a prisoner, what does it look like? The draenei filth captured me as I exited the sun gate. They killed our portal controllers and destroyed the gate. The Sun King will be most displeased with this turn of events.','I\'m a prisoner, what does it look like? The draenei filth captured me as I exited the sun gate. They killed our portal controllers and destroyed the gate. The Sun King will be most displeased with this turn of events.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14627,'<The captured Sunhawk agent smirks.>$B$BDon\'t worry, new blood, there are many more portal controllers and many more suitable locations for portals. I am certain that Sironas will have a new gate up very soon. These blue skinned dogs are not long for this world. Sironas and the abomination will clean up whatever the Sunhawk forces leave behind.','<The captured Sunhawk agent smirks.>$B$BDon\'t worry, new blood, there are many more portal controllers and many more suitable locations for portals. I am certain that Sironas will have a new gate up very soon. These blue skinned dogs are not long for this world. Sironas and the abomination will clean up whatever the Sunhawk forces leave behind.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(14628,'Ah yes, Sironas. I had nearly forgotten that Sironas was here. I served under Sironas back on Outland. I hadn\'t heard of this abomination, though; those damnable draenei captured me before I even fully materialized on this world.','Ah yes, Sironas. I had nearly forgotten that Sironas was here. I served under Sironas back on Outland. I hadn\'t heard of this abomination, though; those damnable draenei captured me before I even fully materialized on this world.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14629,'It was Sironas\' idea... The abomination is actually one of their own. He is a high ranking member of the draenei military order: Triumvirate or some such nonsense.$B$BWhatever that thing is, it\'s massive, powerful, and full of rage. Any attacks against the Vector Coil will most certainly result in failure as long as that abomination is around.','It was Sironas\' idea... The abomination is actually one of their own. He is a high ranking member of the draenei military order: Triumvirate or some such nonsense.$B$BWhatever that thing is, it\'s massive, powerful, and full of rage. Any attacks against the Vector Coil will most certainly result in failure as long as that abomination is around.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(14630,'Incredible. How did Sironas accomplish such a thing?','Incredible. How did Sironas accomplish such a thing?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14631,'Sironas claims that certain eredar possess the ability to transform others of their race into man\'ari. Draenei were supposedly once eredar and Sironas is a powerful eredar.$B$B<The agent laughs.>$B$BCan you believe it? These pathetic creatures were once all-powerful demons. What kind of fool rejects such power?\n','Sironas claims that certain eredar possess the ability to transform others of their race into man\'ari: Savage demonic beings. Draenei were supposedly once eredar and Sironas is a powerful eredar.$B$B<The agent laughs.>$B$BCan you believe it? These pathetic creatures were once all-powerful demons. What kind of fool rejects such power?\n',1,11,6,0,0,0,0,0,1,0,0,0,26124),
(14632,'Sironas is an eredar... I mean, yes, obviously.','Sironas is an eredar... I mean, yes, obviously.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14633,'Obviously. How else could she infiltrate their ranks and pass as a draenei? She had been living among them for a very long time. ','Obviously. How else could she infiltrate their ranks and pass as a draenei? She had been living among them for a very long time. ',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(14634,'The Vector Coil is massive. I hope we have more than one abomination guarding the numerous weak points.','The Vector Coil is massive. I hope we have more than one abomination guarding the numerous weak points.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14635,'Numerous? It has two weak points: The base of the structure on the west side and the base of the structure on the east side. Hey, wait a minute. How would you know anything about the Vector Coil? Didn\'t you say that you were captured before you even materialized?','Numerous? It has two weak points: The base of the structure on the west side and the base of the structure on the east side. Hey, wait a minute. How would you know anything about the Vector Coil? Didn\'t you say that you were captured before you even materialized?',6,1,6,0,0,0,0,0,1,0,0,0,26124),
(14636,'I did and you believed me. Thank you for the information, blood elf. You have helped us more than you could know.','I did and you believed me. Thank you for the information, blood elf. You have helped us more than you could know.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14637,'Treacherous whelp! Sironas will destroy you and your people!','Treacherous whelp! Sironas will destroy you and your people!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14638,'Test','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14639,'Fhwoor go now, $n.  Get ark, come back.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14640,'Take moment... get ready.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14641,'We go!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(14642,'%s lifts the Ark of Ssslith with ease.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14643,'Uh oh...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14644,'Ha ha, squishy naga!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14645,'%s places the Ark of Ssslith on the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14646,'Fhwoor do good!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(14647,'The time has come to destroy the Vector Coil!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14648,'There\'s no turning back now, $n. Stay close and watch my back.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14649,'There it is! Do you see where the large red crystal is jutting out from the Vector Coil? That\'s where I need to plant the first set of explosives.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14650,'Cover me!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14651,'It won\'t be much longer, $n. Just keep them off me while I work.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14652,'That\'ll do it! Quickly, take cover!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14653,'3...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14654,'2...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14655,'1...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14656,'Don\'t get too excited, hero, that was the easy part. The challenge lies ahead! Let\'s go.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14657,'What in the Nether is that?!?!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14658,'Be ready for anything, $n.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14659,'Blessed Light! She\'s siphoning energy right out of the Vector Coil!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14660,'Cover me, we have to do this quickly. Once I blow the support on this side, it will disrupt the energy beams and she\'ll break out! I doubt very much that she\'ll be happy to see us.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14661,'I\'ve almost got it! Just a little more time...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14662,'Take cover and be ready for the fight of your life, $n!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14663,'Holy mother of O\'ros!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14664,'I... I can\'t believe it\'s over. You did it! You\'ve destroyed the blood elves and their leader!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14665,'Get back to Blood Watch. I\'ll see you there...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14666,'','Petulant children, pray to your gods for you are about to meet them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14667,'','I am patiently awaiting orders, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14668,'Hey!  Over here!  Yeah, over here... I\'m in this cage!!!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(14669,'Now that the rude interruption is over, as I was saying, Quagmirran is nearby!$B$BAs promised, I can fortify you with a magical boon that should aid you in your fight with him.','',1,1,0,0,500,0,0,0,1,0,0,0,26124),
(14670,'Naturalist, please grant me your boon.','Naturalist, please grant me your boon.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14671,'[In broken Common] It is time celebrate we do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14672,'Promised One, do you remember us? Do you recall the prophecy of Kurz? This moment was pre-ordained. You have done what you were put on this world to do.$B$B<High Chief Stillpine bows before you.>$B$BDraenei will always be welcome among my people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14673,'[In broken Common] Stillpine thank hero. Many thank!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14674,'A glorious victory!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(14675,'You\'ve come a long way, $n. A long way indeed... But I knew you were destined for great things.  We all knew. All hail $n!$B$BAnd thanks again for taking care of our gnome problem...','',1,1,71,0,0,0,0,0,1,0,0,0,26124),
(14676,'We are here to celebrate your victory and to welcome our newfound allies!','',1,71,0,0,0,0,0,0,1,0,0,0,26124),
(14677,'','I am here to give thanks to the one that saved my life.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14678,'','You probably don\'t remember me, but you saved my life. I have only recently become healthy enough to walk on my own.$B$BI wanted to thank you for what you did for me and apologize for what I may have said... Thank you, $n. May Elune always watch over you.',1,1,2,0,0,0,0,0,1,0,0,0,26124),
(14679,'','%s hugs you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14680,'We are here to support our hero!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14681,'I wouldn\'t have missed this for the world, $n.$B$B<Exarch Menelaous hugs you.>$B$BWe are proud of you.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(14682,'I have come to support the draenei champion!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(14683,'Good to see you again, $n. I brought a friend with me. She really wanted to see you.$B$B<Kessel laughs.>','',1,11,0,0,0,0,0,0,1,0,0,0,26124),
(14684,'This is a glorious day for the draenei! Thank you for all that you have done, $n.','',5,1,2,0,0,0,0,0,1,0,0,0,26124),
(14685,'We have traveled far to celebrate the hero of the draenei people.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(14686,'I would have traveled across the Great Sea to see you, friend. We will never forget what you did for us.','',1,2,0,0,0,0,0,0,1,0,0,0,26124),
(14687,'I wanted to thank you once more for what you did for me. You gave me the courage to take back my home from the beasts of the forest. In doing so, I found Magwin!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(14688,'You saved my daughter, $n, and for that, I am forever indebted to you, $n. Thank you so much.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(14689,'The draenei champion walks among us. This is a celebration for the savior of Azuremyst and Bloodmyst!','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(14690,'This is all for you, $n. You did this. You saved all of these people and thousands more.$B$BYou have risen above the strife and tragedy of this world and in doing so, elevated all of us with you.$B$BYou have done so much - more than many could do in ten lifetimes - yet your life has just begun. If only we had a thousand heroes like you.$B$BBut listen well, $n. Your destiny lies in the Outland. I have seen it in visions, a prophecy yet untold.$B$BFind our people, $n. Find them and bring them home...','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(14691,'All hail $n, savior of Azuremyst and Bloodmyst. Hero of the Hand of Argus, champion of the draenei people!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14692,'It does my soul good to see the walls of Stormwind standing strong and tall.$b$bIf you\'re looking to go to Stratholme, I\'m afraid I\'m unable to assist at the moment. The towers nearby the burning city are still in contention, and as such my powers are far too weak to aid you. Return to me once you\'re victorious there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14693,'Ah, I can sense it - you\'ve won the day! I believe I can safely transport you to Stratholme now, provided you\'ve paid my colleague there a visit first. Just step into the circle and be patient...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14694,'Bah! Cowards and fools! Return to my platform if you dare to face me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14695,'','We cannot afford to let our guard down, $c. This world is crawling with agents and allies of the Burning Legion. If you come across anything strange, don\'t hestitate to show me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14696,'Ysiel expected some enemy opposition to her foray into Outland.  That\'s why us wardens were brought along.$B$BWe never expected our opposition to come in the strength or numbers that the naga have shown.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14697,'','I have no idea who you are, but your presence is most welcome. Archimonde and his Scourge army could attack at any time, $C. Will you stand with us against this evil?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14698,'My companions and I are with you, Lady Proudmoore.','My companions and I are with you, Lady Proudmoore.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14699,'','Thank you, $R. Now prepare yourselves. Archimonde is on the march, and we must hold off the inevitable for as long as we can.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14700,'','I don\'t like the idea of asking Azeroth for help, but we have little choice.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14701,'','I told myself I wouldn\'t burden the Cenarion Circle with our expedition\'s problems, $n.  Our military strength is minimal, however.  We\'re scholars and explorers, first and foremost.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14702,'','This is too big, though.  If the naga aren\'t stopped, our expedition won\'t even matter.  Word must be sent back to the Archdruids of the Circle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14703,'[PH] The British are coming! Clear the roads!','[PH] The British are coming! Clear the roads!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14704,'','We must continue to hold on for as long as we can! Fight on!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14705,'%s roars in pain. ','%s roars in pain. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14706,'','It\'s just like the structure you described at Umbrafen Lake.  Does this mean the naga are pumping water out of all the lakes in Zangarmarsh?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14707,'By your order, master!','By your order, master!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14708,'As you wish!','As you wish!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14709,'For the Sunhawks!','For the Sunhawks!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14710,'Let us slay them!','Let us slay them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14711,'For Kael!','For Kael!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14712,'','The naga are even pumping the water out of their own lake!  What purpose could that possibly serve?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14713,'','There!  Those pipes all appear to be connected to that structure.  It can\'t possibly fit all the water they\'ve been stealing.  Where are they keeping it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14714,'','What we saw explains what happened in the Dead Mire.  There was a lake here once.  If we don\'t stop the naga, all of the marsh will soon look like this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14715,'What a pitiful defense. Is this the best you can do?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14716,'More of you stand in my way? Kill them, Sunhawks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14717,'I will not be stopped by such pitiful defenses. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14718,'','I am the leader of the Blood Watch defenses. What can I help you with?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14719,'[In broken Common] Stillpine be ready! Many thanks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14720,'','Hello, are you here to learn about the conflict in Bloodmyst?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14721,'','Can I help you? ',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14722,'','We serve the light unquestioningly. Perhaps you might be a bit more curious about our purpose?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14723,'Tell me about the Defenders.','Tell me about the Defenders.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14724,'','Is the way clear?  Let\'s get out while we can, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14725,'','Looks like we won\'t get away so easily.  Get ready!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14726,'','Let\'s keep moving.  We\'re not safe here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14727,'','Look out, $n!  Enemies ahead!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14728,'','We\'re almost to the refuge!  Let\'s go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14729,'','I can see my fellow druids from here.  Thank you, $n.  I\'m sure Ysiel will reward you for your actions!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14730,'Welcome to the headquarters of the Blood Knights, the defenders of Quel\'Thalas, the faithful servants of Silvermoon, and the true masters of the Light.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14731,'You won\'t escape us, druid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14732,'Yes.. spill more of their blood! It draws me nearer to this place!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14733,'More! Spill more of their blood! I am near!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14734,'Yes! more! I shall soon be unleashed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14735,'You have thwarted us for now, but we shall return...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14736,'Welcome back, $n!','Welcome back, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14737,'You honor us with your presence, $n.','You honor us with your presence, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14738,'Nature favors those willing to learn its secrets, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14739,'Grant me your mark, wise ancient.','Grant me your mark, wise ancient.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14740,'Nature is a powerful force, $r.  Those who seek to subdue never succeed in doing so permanently.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14741,'Grant me your mark, mighty ancient.','Grant me your mark, mighty ancient.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14742,'','Sir! We have reports of a Man\'ari abomination being summoned to the west. I am deploying the Defenders to intercept along the path to Blood Watch. ',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14743,'May the light protect you. Now, go!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14744,'Please cast a high priority DEBUFF spell on all nearby targets.','Please cast a high priority DEBUFF spell on all nearby targets.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14745,'Please cast a high priority BUFF spell on all nearby targets.','Please cast a high priority BUFF spell on all nearby targets.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14746,'The Northpass tower needs our aid!  Once again, let us charge and do proud our liege!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14747,'Having successfully defended the Alonsus Chapel, %s\'s spirit returns to its rest.','Having successfully defended the Alonsus Chapel, %s\'s spirit returns to its rest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14748,'The waters calm as Watoosun materializes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14749,'Ancient spirit, you honor the Earthen Ring. What troubles you so?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14750,'Your brethren seek to harm my children. Those that call themselves Windyreed subvert the land. A marsh this will not become...','',0,0,0,0,0,0,0,12,1,0,0,0,26124),
(14751,'Our might will be focused. We will not allow the desecration to continue.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14752,'Your death comes, Boros!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14753,'We\'re not the younglings we once were, Man\'ari! By the light, we shall end your suffering!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14754,'By the light! What have they done to you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14755,'We end this now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14756,'%s grins malevolently.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14757,'','Greetings, $n.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14758,'The spirits are restless, $r. Be mindful of your surroundings while in Nagrand lest you be consumed by their fury.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14759,'The Earthen Ring seeks to preserve the strength and majesty of the elements.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14760,'','How can my people fight when the elements are in such turmoil? Do they not see that without the support of the elements, the world simply cannot be.',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(14761,'I am Untrag of the Earthen Ring. Try not to upset the elements while you remain at the Throne of the Elements.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14762,'The creature approachessss! Arm yourssselvesss!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14763,'I apologize, $c. I mistook you for someone with a spine. Begone; our secrets are not for untrained ears.','I apologize, $c. I mistook you for someone with a spine. Begone; our secrets are not for untrained ears.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14764,'Prepare to perisssh at my handsss!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14765,'I have no time for a sermon now, $c. Seek your knowledge elsewhere.','I have no time for a sermon now, $c. Seek your knowledge elsewhere.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14766,'It appears you took a wrong turn, $c.','It appears you took a wrong turn, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14767,'Greetings, $n. You were not followed here, I trust?','Greetings, $n. You were not followed here, I trust?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14768,'We have little to discuss, $c. Perhaps you should seek other, more like-minded individuals.','We have little to discuss, $c. Perhaps you should seek other, more like-minded individuals.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14769,'It\'s a pleasure to see someone sane around here. How can I help you?','It\'s a pleasure to see someone sane around here. How can I help you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14770,'Ah, a fellow ranger. What do you need?','Ah, a fellow ranger. What do you need?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14771,'You clearly lack the capacity to grasp the intricacies of the arcane, $c. Off with you.','You clearly lack the capacity to grasp the intricacies of the arcane, $c. Off with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14772,'What assistance can I offer in your studies?','What assistance can I offer in your studies?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14773,'Ours is a path for those with an iron will and unfaltering resolve. You seem to possess none of these traits, $c.','Ours is a path for those with an iron will and unfaltering resolve. You seem to possess none of these traits, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14774,'You seek further instruction, $n?','You seek further instruction, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14775,'This land has been ravaged by the crash. While you may not follow our philosophies, $c, I urge you to do whatever you can to aid in the healing process.','This land has been ravaged by the crash. While you may not follow our philosophies, $c, I urge you to do whatever you can to aid in the healing process.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14776,'Greetings, my $g brother : sister;. How can I guide you today?','Greetings, my $g brother : sister;. How can I guide you today?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(14777,'','May the winds guide you, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14778,'Burn! Burn! Burn!','',0,0,0,0,0,0,0,12,1,0,0,0,26124),
(14779,'This book contains information on the plant species of Outland.  Most of the plants detailed are native to Zangarmarsh.$B$BThe charts and diagrams are a bit beyond your understanding.  Perhaps the author could give you some pointers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14780,'This book contains information on the plant species of Outland.  Most of the plants detailed are native to Zangarmarsh.$B$BYou feel confident that you can use the charts and diagrams in the book to identify various plant species.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14781,'','I\'ve always liked sorting and organizing things.  I guess I take after my mother.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14782,'Happiness is mandatory, citizen.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14783,'Obey the laws of Silvermoon. Failure to do so will result in termination.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14784,'Remain strong. Kael\'thas will - error - Lor\'themar will lead you to power and glory!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14785,'Do not disturb the serenity of the city. Peace must be upheld.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14786,'I don\'t know what to think of your kind yet, $r.  Some of you can be violent and kill sporelings on sight.$B$BYou seem friendly... though maybe a little bit funny looking, I suppose.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14787,'Maintain order within these walls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14788,'I welcome you to Sporeggar, $r.  We don\'t normally see many of your kind around here, but you\'ve proven your worth to us.  Make yourself at home.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14789,'The bog lords are devouring the spore sacs!  They\'ve got to be stopped!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14790,'Thanks to you our young ones will be safe, $n.  Go to Sporeggar and meet my people.  They\'ve all heard great things about you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14791,'Our lives are yours, Blood Knight.','Our lives are yours, Blood Knight.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14792,'Your power strengthens us all.','Your power strengthens us all.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14793,'Even the Light is no match for the indomitable will of our people.','Even the Light is no match for the indomitable will of our people.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14794,'','The Defenders of Blood Watch protect this outpost from any threat. ',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14795,'','The Defenders are here to protect Blood Watch from the Sunhawk threat. ',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14796,'','We\'ve recently heard word of a creature of immense power being summoned near the Vector Coil. Fear not, should anything threaten the town, we will give our lives to protect it.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14797,'Agh... a chill ran up my spine.','Agh... a chill ran up my spine.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14798,'Is there no sanctity left in this world?','Is there no sanctity left in this world?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14799,'They\'ll see the light, I hope.','They\'ll see the light, I hope.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14800,'With M\'uru gone, perhaps those haughty Blood Knights will see sense.','With M\'uru gone, perhaps those haughty Blood Knights will see sense.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14801,'If I had my way, I\'d show those puffed-up paladins a thing or two.','If I had my way, I\'d show those puffed-up paladins a thing or two.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14802,'<The earth rumbles as Gordawg\'s movements come to a halt.>$B$BSpeak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14803,'Ha!  You have failed!  Now I will pry my ark from your dead hands!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14804,'Hah! Bullseye!','Hah! Bullseye!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14805,'What a beautiful shot!','What a beautiful shot!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14806,'Straight and true, that\'s the way.','Straight and true, that\'s the way.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14807,'Glory to the Sun K-- ah... Silvermoon!','Glory to the Sun K-- ah... Silvermoon!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14808,'%s arches a sculpted brow at the guards, a disapproving scowl on his face.','%s arches a sculpted brow at the guards, a disapproving scowl on her face.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14809,'%s glances from guard to guard.','%s glances from guard to guard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14810,'%s surveys the small ranger practice ground with a condescending smirk.','%s surveys the small ranger practice ground with a condescending smirk.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14811,'%s inclines his head slightly to the pair of guardians in greeting.','%s inclines her head slightly to the pair of guardians in greeting.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14812,'By the seas... look at the sssize of that thing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14813,'How did sssuch a thing grow in this wasteland?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14814,'Lady Vashj will not be pleasssed to hear of thisss...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14815,'Our neighbors are positively laughable. Have you seen the way they turn up their noses at us?','Our neighbors are positively laughable. Have you seen the way they turn up their noses at us?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14816,'It ssspoilss our water!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14817,'Overseer Tidewrath, watch out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14818,'The rangers certainly have a high opinion of themselves.','The rangers certainly have a high opinion of themselves.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14819,'I\'m quickly tiring of the haughty attitude I receive from those grubby bowslingers outside.','I\'m quickly tiring of the haughty attitude I receive from those grubby bowslingers outside.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14820,'Who do they think they are?','Who do they think they are?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14821,'I know what you mean... they whisper about us when they think we can\'t hear them. They\'ll get theirs.','I know what you mean... they whisper about us when they think we can\'t hear them. They\'ll get theirs.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14822,'Jealous, that\'s what they are. They\'re afraid to dedicate themselves to true power.','Jealous, that\'s what they are. They\'re afraid to dedicate themselves to true power.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14823,'They simply fear what they cannot begin to understand.','They simply fear what they cannot begin to understand.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14824,'Look how big that thing is!','Look how big that thing is!',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14825,'He\'s monstrous!','He\'s monstrous!',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14826,'It must have broken the walls of the tank!','It must have broken the walls of the tank!',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14827,'What does that thing eat?','What does that thing eat?',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14828,'Watch out!','Watch out!',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14829,'Go! Go! You can take him!','Go! Go! You can take him!',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14830,'Watch out for the acid spray, Overseer Tidewrath!','Watch out for the acid spray, Overseer Tidewrath!',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14831,'Matters are so uncertain now that the chamber below is empty...','Matters are so uncertain now that the chamber below is empty...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14832,'Those things eat fish! Watch out!','Those things eat fish! Watch out!',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(14833,'It\'s gone. I can\'t believe it\'s gone. Who would have thought we\'d be betrayed like this?','It\'s gone. I can\'t believe it\'s gone. Who would have thought we\'d be betrayed like this?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14834,'Yessss! Defeat him, Overseer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14835,'Yes! Use the mana shield!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14836,'Defeat him in the name of Lady Vashj!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14837,'Ssssurely the overseer can stop him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14838,'Lady Liadrin is bound to find a way. She must.','Lady Liadrin is bound to find a way. She must.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14839,'Is... it true, what I\'ve heard?  That it was the Sun King himself?','Is... it true, what I\'ve heard?  That it was the Sun King himself?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14840,'Still, the Blood Knights will endure through this loss. We have no other choice... we must find another source.','Still, the Blood Knights will endure through this loss. We have no other choice... we must find another source.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14841,'|cffffff00The Overlook has been taken by the Alliance!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14842,'|cffffff00The Overlook has been taken by the Horde!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14843,'|cffffff00The Stadium has been taken by the Alliance!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14844,'|cffffff00The Stadium has been taken by the Horde!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14845,'|cffffff00Broken Hill has been taken by the Alliance!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14846,'|cffffff00Broken Hill has been taken by the Horde!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14847,'','Foolsss, you will not ssssuccceed in ssstealing the ark!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14848,'My father\'s off to more exotic locations in search of bigger prey.  Don\'t worry though, we\'re still on the hunt here!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14849,'Keep a sharp eye, $c.  You never know when some beastie is stalking you instead of the other way around.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14850,'Hemet Nesingwary, what are you doing here in the Outland?','Hemet Nesingwary, what are you doing here in the Outland?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14851,'Listen $g lad : lass;. I left the expedition in the capable hands of me son, Junior. When you\'ve stalked the finest game in all of Azeroth you start to itch for something more.$B$BAnd have you seen the size of the beasties here?!$B$BI\'m here hunting the most dangerous prey you\'ll ever lay your eyes on. I mean to bag myself Tusker and take her heart as my trophy!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14852,'$n!  I remember your hunting prowess all too well.  You might have gotten off to a shaky start in Stranglethorn, but you stuck in there and became one o\' the finest when you bagged old Bangalash.$B$BBut listen, $g lad : lass;, the prey out here in the Outland is the real deal.  And I\'ve the scars to prove it!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14853,'The %s hisses loudly and prepares to attack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14854,'','Remind me, ambassador... what precisely will your people be contributing to our efforts?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14855,'Take me to the place<PH>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14856,'Follow me!','Follow me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14857,'Our people are strong. We bring you a mastery over arcane magics that you have previously lacked - ah, no offense intended, of course.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14858,'Surely you see the advantage in our relationship. The powers we command are immense. With our aid, your enemies could well be decimated.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14859,'I realize we have had somewhat differing loyalties in the past, but put your suspicions aside. Our considerable power has been pledged to your leaders in good faith.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14860,'','I suppose we\'ll see the measure of your dedication in due time.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14861,'T\'ink ja be contributin\' less glarin\' in dis troll\'s direction?','',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(14862,'','Tatai!',5,0,0,0,0,0,0,1,1,0,0,0,26124),
(14863,'%s sighs in resignation and falls silent.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14864,'','Truly an advantageous alliance.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(14865,'WHO DARES CALL GUROK FROM THE UNDERNEATH?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14866,'','Dela Runetotem\'s brow furrows, but she remains silent.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14867,'Stranger, make haste and contact Lady Jaina Proudmoore. Her small Alliance force is bravely attempting to blunt the Burning Legion\'s initial assault and delay the approach of Archimonde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14868,'What help be ja givin\' de Horde, anyway?','',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(14869,'Lady Proudmoore\'s forces have bled to delay Archimonde and his Burning Legion, and now this grim task falls to us. Are you ready to stand with me against the onslaught?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14870,'','Tell us, Ambassador Kelemar... how do the blood elves plan to aid us, exactly?',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(14871,'I humbly welcome you to our temple, spirit.','',2,1,0,0,0,0,0,0,1,0,0,0,26124),
(14872,'Greetings, elder. It is time for your people to end their hostility toward the draenei and their allies.','Greetings, elder. It is time for your people to end their hostility toward the draenei and their allies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14873,'Treat with the draenei, the people who turned their backs on us while we suffered? I think not.$B$BA true spirit does not speak thus! Reveal yourself, impostor. Who sent you?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14874,'I did not mean to deceive you, elder. The draenei of Telredor thought to approach you in a way that would be familiar to you.','I did not mean to deceive you, elder. The draenei of Telredor thought to approach you in a way that would be familiar to you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14875,'I am with you, Thrall.','I am with you, Thrall.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14876,'So we\'re to trust people who would insult us with this deception? Do the draenei think so little of us that they must resort to trickery to get our attention?$B$BWe\'re aware of their desire to \'redeem\' us, but my people want none of their redemption. We are capable of standing on our own and we will pursue our destiny as a proud and separate people. Carry this message to your allies.','',25,1,0,0,0,0,0,0,1,0,0,0,26124),
(14877,'Then let the Legion do their worst!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14878,'The Burning Legion presses us hard, but our defenses hold. Every moment we keep Archimonde away from the World Tree brings us closer to victory.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14879,'I will tell them. Farewell, elder.','I will tell them. Farewell, elder.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14880,'Good. Be sure they understand.$B$BNow, I would appreciate it if you would leave my temple in peace.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14881,'My work here is done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14882,'Dis place be huge. Why ja be needin\' all dis space?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14883,'This is merely part of what Silvermoon once was. Much of the city was lost after Arthas swept through our lands.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14884,'We lost many of our kin in the war... so yes, the city is not perhaps as lively as it once was. We will endure, however.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14885,'','If your people are as strong as you purport, I\'m sure you\'ll find your stride again.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14886,'Dis be a big waste, if ja be askin\' me.','',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(14887,'','Well, no one asked you, Tatai.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14888,'%s grumbles under his breath.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14889,'','You\'re not the only victims of the Scourge. Our lady Sylvanas sympathizes with your plight.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(14890,'','My condolences. These past years have been hard on us all.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14891,'','This city is very... expansive, but it seems to be lacking something. I can\'t put my finger on what...',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(14892,'','It seems that a great deal of your power is used for... and I hope you\'ll pardon the term... frivolous things. Isn\'t that, well, wasteful?',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(14893,'This must be somewhat different from the environment to which you\'re accustomed. It is a visible demonstration of the power we hold, nothing more. We\'re mindful of our resources.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14894,'Think about it carefully, my friends. If we can afford to spend our magic on simple aesthetic enhancements, clearly we hold a vast reservoir of power at our beck and call.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14895,'It is not simply a beautification measure, but also a morale booster. It demonstrates to our people that we have a great deal of power at our fingertips, and with it... we can do nearly anything.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14896,'','%s taps a finger on her chin, lost in thought.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14897,'Bah! If I ever be in charge\'a dis place, da first t\'ing I be doin\' is stoppin\' alla dat. Ja be markin\' my words.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14898,'','Tatai, please. We\'re guests here.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14899,'Yes, well... luckily for us all, the troll will not be in a position of power within our fair city anytime soon.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14900,'','An understandable expenditure, as I see it. Show everyone, enemies and allies alike, that you\'re not afraid to use your power.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(14901,'%s begins to perform an arcane scrying.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14902,'Blasted scrying crystal!  I\'m not getting anything over here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14903,'','I don\'t know. It still seems like such a waste.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14904,'Why be all dese t\'ings floatin\' an\' movin\' by demselves?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14905,'','Your choice of decor is intriguing, Kelemar. Tell me - why the arcane frippery?',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(14906,'','I don\'t suppose Lor\'themar Theron is available for an audience yet?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14907,'The regent lord is a very busy man. I\'m sure you understand.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14908,'He is unable to see you just yet, but do not trouble yourselves over it. I\'m certain he will find a way to fit you into his busy schedule.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14909,'In due course. There is no rush, after all - our hospitality is extended to you indefinitely. Even the troll.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14910,'','I\'ll accept that answer for the time being, Kelemar, but my patience is not exactly boundless.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14911,'Just what I be t\'inkin\'. More delays.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14912,'','Troll, if you can\'t keep a civil tongue in your head, I\'ll be happy to remove it for you.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(14913,'Ja be keepin\' away from me.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14914,'','%s smirks triumphantly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14915,'','This is becoming tiresome.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(14916,'','As you say, ambassador. We can wait.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14917,'','I thought we were going to speak with the regent lord. I\'m beginning to question whether or not he exists at all at this point.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(14918,'','There\'s an ethereal beauty about this place... but for all the trees and plant life, it\'s still so... unnatural.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14919,'I be gettin\' tired\'a dis. Dese elves, dey be treatin\' me like I stole somet\'in\'.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14920,'Welcome to the Orebor Harborage, friend. You have nothing to fear here. We are Broken, but we are not your enemies.$B$BI am Ikuti of the Kurenai, a group of Broken who desire to reestablish ties with our draenei brothers and their newfound allies.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(14921,'Maktu doesn\'t recognize you, $r, but he is pleased to meet you. If ever you need to buy or repair armor, look no further than Maktu.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14922,'I\'m afraid your ancestry is the cause, troll. Decades of fighting with your green-skinned brethren have hardened their hearts against your kind.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14923,'Show me your wares, Maktu.','Show me your wares, Maktu.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14924,'Memories of this temple shroud my mind like a thick haze, yet I cannot assemble them into a coherent story. This place meant something to me once. Until I can restore that memory, I will feel as though a part of me is missing.$B$BPerhaps the draenei can help me recover what I\'ve lost.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(14925,'I wish to browse your wares.','I wish to browse your wares.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14926,'Keep your chin up. Perhaps with time, our people will see you as the ally you are, rather than the enemy you appear to be.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14927,'','You should be used to those looks, Tatai. Do you remember the reason you were drafted into this job?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14928,'Don\'t ja start...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14929,'','I\'m no happier about being your babysitter than you are about being watched. Just remember... it could have been worse.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14930,'Let me browse your reagents and poison supplies.','Let me browse your reagents and poison supplies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14931,'There are some who call me \'Tim,\' but to my friends, I am \'the specialist.\'','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(14932,'Specialist, eh? Just what kind of specialist are you, anyway?','Specialist, eh? Just what kind of specialist are you, anyway?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14933,'If you have to ask, you don\'t know me anywhere near well enough to be using that appellation.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14934,'Greetings, $c.  You seek to push yourself to the limits of your hunting prowess?  Look no further.$B$BHemet Nesingwary has assembled the finest expedition the remnant of this world has ever known.  Join us on safari if you dare.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14935,'Do not be fooled by the ruins surrounding us, $c.  Dalaran is as powerful as ever.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14936,'Karazhan is more than a mere building, $n.  If you traced the ley-lines traversing Azeroth you would find that they all converge right about there.$B$B<Alturus points at an invisible spot below the tower.>$B$BFascinating, isn\'t it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14937,'Archmage Alvareux once wrote a treatise exploring a fascinating theory.  He proposed the existence of an exact copy of Karazhan in a world other than our own and that both somehow shared the same space.$B$BHe went mad soon after.  A real pity.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14938,'Bounties for notorious criminals and vicious animals are posted here. It would be much too dangerous for you to pursue the bounty posted here right now, but check the board again as you gain strength.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14939,'The naaru are wise beyond our understanding.  I\'ve learned more from A\'dal in the last five months than all the years I spent in the libraries of Dalaran.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14940,'A thick red slash has been drawn across the words WANTED: Deathclaw.  \"This bounty has been claimed by the heroic $n, who has overcome the fearsome beast,\" declares more writing in the same red ink.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14941,'This sign contains various announcements and notices of rewards.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14942,'GLHF! <PH>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14943,'Let me fly!','Let me fly!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14944,'This spot is perfect! Let me set up...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14945,'Welcome to Zabra\'jin, $c. I am Shadow Hunter Denjai, overseer of this outpost and commander of the Darkspear forces in Zangarmarsh.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14946,'Now don\'t you be thinkin\' about tryin\' to make off with me baby murlocs! I got the eyes of a hawk and ears like... ears like... like somethin\' with mighty powerful ears!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14947,'','Tor\'gash believes he can see the future in the entrails of birds, or by tossing the knucklebones of his ancestors. Really, all you need to do is ask the spirits. But don\'t try telling him that, $n. He\'s very stubborn.',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(14948,'','TugofWar Buffbot, Alliance',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14949,'','TugofWar Buffbot, Alliance Winner',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14950,'TugofWar Buffbot, Give me a Reward','TugofWar Buffbot, Give me a Reward',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14951,'','TugofWar Buffbot, Horde Winner',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14952,'','TugofWar Buffbot, Horde Greeting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14953,'There are no more available rides! There should be one available very soon... <PH>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14954,'You\'ve proven yourself a very capable game hunter, $n.  But there\'s still one beastie that haunts your dreams... Tusker!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14955,'You\'ve bagged them all: Bach\'lor, Banthar, Gutripper, and even the mighty Tusker!  You\'re truly the finest big game hunter that I know!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14956,'There I was tumbling in a patch of prickly undergrowth with a talbuk stag, hand-to-hand, only my sharp knife...<cough>... and keen hunter\'s intellect to save me.$B$BAll of a sudden I\'m jumped by a pair of fierce windroc hunters that came at me from the skies!  Their cowardly attack...<cough>... didn\'t help them any though.$B$BAnd while I have their beaks as trophies, I received an infected scratch out of the ordeal.  Kind of nasty, and I\'m in a lot of pain, but I\'m sure it\'ll heal up in a day or two.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14957,'The first time I saw mushrooms taller than trees, I wasn\'t so sure I could call this place home. After a while you just stop noticing.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14958,'I wish to purchase tradeskill supplies.','I wish to purchase tradeskill supplies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14959,'','Don\'t forget to take some time out to fish while you\'re in Zangarmarsh. You never know when you\'ll see water again.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14960,'I wish to purchase fishing supplies.','I wish to purchase fishing supplies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14961,'Give me some pointers on my fishing technique.','Give me some pointers on my fishing technique.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14962,'Telredor was once a secluded retreat for draenei priests and pilgrims. The resident priests seldom received visitors.$B$BWhen the orcs started to attack draenei settlements, refugees began to arrive in larger numbers. Anchorite Ahuurn and the others transformed Telredor from a shrine into a safe haven. Many draenei, myself included, owe our survival to his efforts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14963,'','Such marvelous sights. I regret being unable to see it when I was younger.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(14964,'Thank you for making the journey here. I hope you will find Silvermoon to your liking.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14965,'Behold the wonders of our fair city.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14966,'','The view from the top of Telredor is magnificent, isn\'t it?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14967,'I would like to buy from you.','I would like to buy from you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14968,'Welcome to Telredor, $c. If you need anything, don\'t hesitate to ask.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14969,'Dis place be too bright fa my tastes.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14970,'Exercise caution during your stay. Some close-minded individuals may still cling to old alliances long since dissolved...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14971,'I wish to buy from you.','I wish to buy from you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14972,'I\'ve never seen so many different kinds of mushrooms in one place. Given enough time, I\'m sure I could find a use for all of them.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14973,'Telredor has seen more change in the last 20 years than it did in prior centuries. I cannot complain, $n, for the world has changed far more in that time.$B$BThe Light has brought me friends and companions I could not have met as a cloistered priest. Learn what you can of the past in your time here. It will help you to understand where your journey is leading you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14974,'Treacherous whelp! I will beat you within an inch of your miserable life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14975,'Tell me where the totem of Kar\'dash is hidden and the beatings will stop.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14976,'Shadow Hunter Denjai sent me here with a small contingent of builders and warriors to establish this outpost. We\'ve barely finished building it and he\'s already asking for reports!$B$BIf you need supplies, I can offer a few things, but we\'re still waiting for our first shipment.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14977,'Once you die from the torture, we will go out and kidnap another of your kind. One of you is bound to crack under the pain and give us the information we need.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14978,'Once the totem of Kar\'dash is ours, we will raze your cities and rebuild them as our own.','Once the totem of Kar\'dash is ours, we will raze your cities and rebuild them as our own.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14979,'I wish to buy from you.','I wish to buy from you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14980,'If you ever meet Witch Doctor Tor\'gash, tell him his concoctions and charms don\'t work! I did exactly as he told me to and still Magasha has eyes only for Zurai.$B$BDon\'t believe a thing that sham witch doctor tells you!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14981,'','Reavij has all the subtlety of a kodo! What\'s funny is that he doesn\'t think he\'s being obvious. I see the way he stares at me when he thinks no one\'s looking.$B$BHe creeps me out. I really wish Shadow Hunter Denjai hadn\'t sent him with us. Setting up Swamprat Post was the perfect opportunity to get away from him.',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(14982,'Hello, $c.  I am what is referred to as one of the Broken.  Like the Lost Ones, though not as badly as they, we were afflicted with fel energies that transformed us from our original draenei forms.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14983,'Garadar is in shambles, stranger. Since the Greatmother took ill, Garrosh has gone into a deep depression. He is most certainly not his father\'s boy.$B$B<Kurkush sighs.>\n','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(14984,'Put your backs into it!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(14985,'Chop faster!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(14986,'Faster or Boss Grog\'ak will have your head!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(14987,'Do I need to come over there and show you how it\'s done?','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(14988,'Maybe a lightning bolt will give you the incentive to work faster?','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(14989,'No breaks until it\'s all chopped down!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(14990,'At last it is here! Mourn and lament the passing of all you have ever known, and all that would have been! Hach min corai!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14991,'No, it cannot be! Nooo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14992,'Back to work, dog!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(14993,'Notices of reward for the naga leaders of the Darkcrest and Bloodscale tribes are listed here.  They both sound extremely dangerous, perhaps you should check again later.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14994,'Notices of reward for the naga leaders of the Darkcrest and Bloodscale tribes are listed here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(14995,'They died. All of them...$B$BAs the Murkbloods cut through us, something took hold of me that I cannot understand. Tell me, have you ever felt a rage so great that the whole of your being burns? A heat that wilts the living? A heat that incinerates the blood in your veins? That is what I felt.$B$B<Saurfang\'s eyes glow red for a brief moment.>$B$BI was the last one left alive. 30 of them surrounded me... Murkbloods... I remember nothing beyond that vision. I blacked out and awoke some time later.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(14996,'Dark times loom ahead, stranger...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14997,'The spirits are greatly agitated. We must find the cause of this disturbance.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(14998,'%s places the Murkblood idols atop the Lightning stone and invokes the spirits.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(14999,'Look out!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15000,'More of them coming! Watch out!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15001,'It is best that we split up now, in case they send more after us. Hopefully one of us will make it back to Garrosh. Farewell, stranger.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15002,'Don\'t let them escape! Kill the strong one first!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15003,'Where do you think you\'re going? Kill them all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15004,'Spirits grant me the strength to heal!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15005,'Wounds be gone!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15006,'Ride the lightning, filth!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15007,'The Sons of Lightning will have their vengeance!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15008,'Totem of the earth, halt their advances!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15009,'FROST SHOCK!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15010,'','No, no, no! Come back here!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15011,'','The magister\'s going to kill me...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15012,'','Get back here, you little...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15013,'','Argh. They told me those crystals would work properly!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15014,'','You stay out of the regent lord\'s way! I mean it!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15015,'','When I catch you, I\'m going to disenchant your components, so help me...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15016,'Everything that we have, we have fought for tooth and tentacle... Retaking Telaar from the orcs and then the ogres was no easy task.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(15017,'|cffffff00All the guards have been defeated!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15018,'|cffffff00The Alliance has taken control of Halaa!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15019,'|cffffff00The Horde has taken control of Halaa!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15020,'|cffffff00Halaa is defenseless!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15021,'Hm, unannounced visitors. Preparations must be made...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15022,'How terribly clumsy of me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15023,'Hemet is the greatest hunter that I know.  We chanced upon each other in the hills of Winterspring back on Azeroth many moons ago.  He and I were stalking the same quarry: the great cat known as Rak\'shiri.$B$BRather than fight each other over our prey, we made a wager out of it; whoever collected the frostsaber\'s skin would get to demand something of the other.  To my eternal shame, this is how I earned the nickname, Fitz.$B$BDo I look like a Fitz?','',1,1,6,0,0,0,0,0,1,0,0,0,26124),
(15024,'Your new name is Sayena.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15025,'','My name is Nimrida, boy.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15026,'It\'s Sayena.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15027,'','Nimrida.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15028,'I\'m your master... you\'re supposed to do what I say!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15029,'','You may have summoned me, my little warlock, but that does not give you leave to rename me like some child\'s pet.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15030,'Come on... please?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15031,'','You know I love it when you beg... but no.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15032,'%s hangs his head and sighs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15033,'I told you to wait for me elsewhere, not follow me like a puppy...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15034,'The mighty hunter, $n returns.  Tell me the tale of stalking your latest prey.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15035,'','Tch. One might think you\'re ashamed to be seen with me, master.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15036,'No, no... it\'s just that... well... we\'re attracting looks.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15037,'','And what\'s wrong with that? A woman enjoys turning heads now and again.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15038,'Will you please go back inside?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15039,'','%s arches a brow at Keyanomir, a wry smirk playing about her lips.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15040,'','\"Please?\" You have so much to learn... master.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15041,'Enjoy the taste of fel iron?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15042,'Die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15043,'None shall defeat the Fel Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15044,'It\'s an ambush! Defend yourself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15045,'Yeah, yeah, I\'m feeling better, but I kind of like it down here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15046,'We must leave before more are alerted.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(15047,'We are surrounded!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(15048,'Up ahead is the road to Telaar. We will split up when we reach the fork as they will surely send more Murkblood after us. Hopefully one of us makes it back to Telaar alive.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(15049,'Farewell, stranger. Your heroics will be remembered by my people. Now, hurry to Telaar!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(15050,'','Woe to each and every one of you, my pretties!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15051,'','Fixed you, didn\'t I?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15052,'','How could you? What a cruel, cruel world...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15053,'S-sir... have you tried giving the crystal a good shake?  It\'s possible that the ley-lines are clouding up the reading.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15054,'I ought to give your head a good shake!  I\'ve a feeling the ley-lines are clouding up your brain.  No, Darius, what we need is a large depository of mineral-heavy water.  Even faint arcane signals will accumulate in sulphur and lime.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15055,'The Menagerie is for guests only.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15056,'S-sorry, sir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15057,'Curator is no longer operation-a-l.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15058,'','Do not be so harsh on the child, Alturus.  Remember that Cedric himself assigned him to you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15059,'Your request cannot be processed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15060,'Failure to comply will result in offensive action.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15061,'I grow tired of waiting. Dance for me, imbecile.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15062,'Not you, moron! The other imbecile.','Not you, moron! The other imbecile.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15063,'Oops. Grondo sorry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15064,'You hear Unkor, dummy? Dance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15065,'Ok, ok. Me dance now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15066,'','Don\'t let them hurt us Tito! Oh, you won\'t, will you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15067,'','Oh Tito, we simply must find a way home! The old wizard could be our only hope! Strawman, Roar, Tinhead, will you - wait... oh golly, look we have visitors!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15068,'','Oh at last, at last I can go home!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15069,'','Tito! Oh Tito, no!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15070,'','What devil art thou, that dost torment me thus?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15071,'','Parting is such sweet sorrow.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15072,'','Romulo, I come! Oh... this do I drink to thee!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15073,'','Come, gentle night; and give me back my Romulo!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15074,'','O happy dagger! This is thy sheath; there rust, and let me die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15075,'Wilt thou provoke me? Then have at thee, boy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15076,'How well my comfort is revived by this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15077,'Thou detestable maw, thou womb of death; I enforce thy rotten jaws to open!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15078,'Thou smilest... upon the stroke that... murders me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15079,'','Your behavior will not be tolerated.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15080,'','Cast out your corrupt thoughts.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15081,'','Death comes. Will your conscience be clear?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15082,'','Ah ah ah...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15083,'','Impure thoughts lead to profane actions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15084,'','This is for the best.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15085,'Time... never enough time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15086,'Oh, I\'ve gone and made a mess...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15087,'The Consortium has been planning this operation for months!  We were to dig Oshu\'gun, the largest known diamond in the universe.$B$BMinutes before we were to begin, Nexus-Prince Haramaad sends word that we\'re to hold off until a political matter is resolved in Netherstorm.  I\'ve transformed our operation into a clearing house for smuggled gems in the meantime, but this is slowly eating into our profits.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15088,'Uh oh, those stags don\'t look pleased with us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15089,'Look out, Fitz, they\'re coming right for us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15090,'What\'s going on?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15091,'%s smiles and sheathes his rifle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15092,'Gezhe is here to get a job done.  I\'m here to make sure no one bothers him while he does it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15093,'Um... guys?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15094,'Hemet?  Fitz?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15095,'Oh good, I was beginning to worry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15096,'Do you know who we are, stranger? We are Mag\'har - brown orcs, as I have heard your kind call us. The Mag\'har are survivors: Survivors of a fallen dynasty; Survivors of the Red Pox; Survivors of a shattered world...$B$BI am Jorin, son of Kilrogg; last of the lineage of Deadeye: Warchief of the Bleeding Hollow Clan.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(15097,'I give up! Please don\'t kill me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15098,'And now, I run!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15099,'','We wouldn\'t have crashed if Hemet could learn how to avoid shooting through the ailerons when he\'s trying to bag game on the ground!$B$BNo worries though, I\'ll have her fixed up quick enough.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15100,'Surely you\'ve got something to spare, Zalle. You know I\'m good for it. Something, anything!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15101,'','I\'ve nothing for the likes of you, Cailan. For the last time, get out of this shop.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15102,'','Hi, Harold.  I have your skins!',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(15103,'Help me!  Please help me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15104,'','Ack!  Somebody help me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15106,'How can you just leave me here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15107,'You over there!  Help me find a way out of this wretched cage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15108,'Will the pain ever end?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15109,'%s rifles through Kristen\'s stuff and grabs her bundle of skins.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15110,'Here are my skins, Harold.  Now give me the reward!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15111,'I\'ll be taking those skins, tiny.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15112,'Uh... sure thing, Gankly.  Just...<cough>... wait right there.  <Cough>  Guys?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15113,'','I am SO glad that evil Gankly Rottenfist got his just desserts!  I have lots of skins if you want some to give to Harold.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15114,'Tag! You\'re it!','Tag! You\'re it!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15115,'Kill them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15116,'Get out of the way!','Get out of the way!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15117,'Duck!','Duck!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15118,'OGRE! You\'re the ogre! HA-HA!','OGRE! You\'re the ogre! HA-HA!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15119,'Don\'t go close to the lake! It\'s haunted!','Don\'t go close to the lake! It\'s haunted!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15120,'Can we stop running now?','Can we stop running now?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15121,'I miss my mommy.','I miss my mommy.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15122,'I don\'t wanna play anymore!','I don\'t wanna play anymore!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15123,'I refuse to concede defeat! I am a prince of the Eredar! I... am...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15124,'Surely you did not think you could win.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15125,'Your greed, your foolishness has brought you to this end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15126,'You are but a plaything. Unfit even to amuse.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15127,'Madness has brought you here to me. I shall be your undoing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15129,'%s begins to arm the Proximity Bomb!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15130,'Who dares interrupt--What is this; what have you done? You\'ll ruin everything!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15131,'Go ahead and take forty winks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15132,'Closer! Come closer... and burn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15133,'You didn\'t have to go and do that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15134,'%s spawns a poison cloud!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15135,'Don\'t let them make... a mattress outta\' me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15136,'I guess I\'m not a failure after all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15137,'My life is yours, oh great one...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15138,'','I am SO glad that evil Gankly Rottenfist got his just desserts!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15139,'','Greatmother, please drink this water.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15140,'','Hey!  Didn\'t I give you a bundle of skins before?$B$BEither way, I\'m glad to be saved from the ruthless clutches of that evil Gankly Rottenfist!',6,1,0,0,500,0,0,0,1,0,0,0,26124),
(15141,'Ah, you\'re just in time. The rituals are about to begin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15142,'','Greatmother, is there anything I can do?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15143,'','Greatmother, Garrosh has lost his heart. We are lost without you.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15144,'','I will do my best to take care of the children, Greatmother.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15145,'Your blood will anoint my circle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15146,'The great one will be pleased.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15147,'Please accept this humble offering, oh great one...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15148,'Let this sacrifice serve as testament to my fealty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15149,'','The Greatmother raised all of us. Any Mag\'hari that you see has had their life touched in some special way by the Greatmother. We will miss her greatly when she passes.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(15150,'Come, you dwellers in the dark! Rally to my call!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15151,'Gather, my pets... there is plenty for all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15152,'','Greatmother tells me that I was named after a great orcish hero.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15153,'Mmmm... delicious.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15155,'Back to being an old rust bucket.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15156,'Guess I\'m not so rusty after all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15157,'Shifting, %s moans from the pain of his thorn scratch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15158,'%s groans in pain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15159,'%s looks at his friends and then grunts painfully.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15160,'%s wakes himself up snoring.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15161,'%s winces when he touches the tender area around his scratch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15162,'%s begins to whistle a tune, but then stops abruptly and moans.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15163,'Our time has come!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15164,'The wizard will fall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15165,'Enforcers! Kill them all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15166,'We will not be stopped!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15167,'More will take my place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15168,'Your efforts... are in vain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15169,'You will not save him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15170,'We control the timeways now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15171,'','Death to the Last Guardian!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15172,'','You will not stand in our way!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15173,'','Magna Medivh dies today!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15174,'','We are not finished!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15175,'','A minor victory...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15176,'','We will not fail!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15177,'','The end is at hand!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15178,'','One step closer...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15179,'The sands of time shall be scattered to the winds!','The sands of time shall be scattered to the winds!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15180,'History is about to be rewritten!','History is about to be rewritten!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15181,'Let the siege begin!','Let the siege begin!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15182,'The rift must be protected!','The rift must be protected!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15183,'You are running out of time!','You are running out of time!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15184,'Victory or death!','Victory or death!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15185,'You will never defeat us all!','You will never defeat us all!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15186,'You will accomplish nothing!','You will accomplish nothing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15187,'No! The rift...','No! The rift...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15188,'The end is at hand!','The end is at hand!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15189,'One step closer...','One step closer...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15190,'There is no time to waste!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15191,'We must hurry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15192,'We must use this time wisely!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15193,'One less threat to the timeways!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15194,'Victory will be ours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15195,'Carry on! Victory at all costs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15196,'Continue the fight! Do not falter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15197,'You look like a reasonable $r.  Perhaps we could be of mutual assistance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15198,'You no take mushroom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15199,'I\'ll make you pay for that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15200,'Ladies, please. I\'m desperate. Certainly you can spare something... the smallest reagent, your cheapest wares. Help a soul in need!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15201,'Warlord Kalithresh will hear of this insolence!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15202,'I will show you not to cross us again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15203,'%s\'s lip quivers, and he shuffles out of the shop forlornly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15204,'','No handouts, Cailan.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15205,'','I\'m not about to perpetuate your addiction. It certainly isn\'t my fault. Out.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15206,'Be strong. Kael\'thas has betrayed us and what we know is in flux, but do not lose heart. We will endure, as we always have. Arthas did not crush our spirit when he swept through our land, and neither will Kael\'thas. Let it serve as a lesson to us all as we move forward to our prosperous future.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15207,'Where in our fair city do you wish to go?','Where in our fair city do you wish to go?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15208,'Auction House','Auction House',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15209,'We have two auction houses within Silvermoon. Which would you prefer?','We have two auction houses within Silvermoon. Which would you prefer?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15210,'To the west.','To the west.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15211,'The western auction house can be found in the middle of the Bazaar, just west of the Walk of Elders.','The western auction house can be found in the middle of the Bazaar, just west of the Walk of Elders.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15212,'To the east.','To the east.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15213,'The Royal Exchange auction house can be found in the eastern part of the city, just south of the training area for the blood knights and rangers.','The Royal Exchange auction house can be found in the eastern part of the city, just south of the training area for the blood knights and rangers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15214,'Bank','Bank',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15215,'Which of our two banks would you like to visit?','Which of our two banks would you like to visit?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15216,'The west.','The west.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15217,'The Bank of Silvermoon can be found within the Bazaar. Seek it out in the southeast corner.','The Bank of Silvermoon can be found within the Bazaar. Seek it out in the southeast corner.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15218,'The east.','The east.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15219,'If you\'re seeking a bank in the eastern part of the city, look no further than the Royal Exchange. It lies along the north wall therein.','If you\'re seeking a bank in the eastern part of the city, look no further than the Royal Exchange. It lies along the north wall therein.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15220,'Dragonhawk Master','Dragonhawk Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15221,'Skymistress Gloaming and her dragonhawks are just outside and to the west of the Shepherd\'s Gate.','Skymistress Gloaming and her dragonhawks are just outside and to the west of the Shepherd\'s Gate.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15222,'Guild Master & Vendor','Guild Master & Vendor',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15223,'Tandrine is the guild master of Silvermoon. Her residence is along the Walk of Elders, close to the Magister\'s Gate.','Tandrine is the guild master of Silvermoon. Her residence is along the Walk of Elders, close to the Magister\'s Gate.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15224,'Inn','Inn',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15225,'The Silvermoon City Inn, located in the Royal Exchange, is run by a talented woman named Velandra. I\'m told that the renowned vinemaster can sometimes be found there, as well.','The Silvermoon City Inn, located in the Royal Exchange, is run by a talented woman named Velandra. I\'m told that the renowned vinemaster can sometimes be found there, as well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15226,'Mailbox','Mailbox',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15227,'We have an abundance of mailboxes in our fair city. The one by the Royal Exchange Bank should certainly fit your needs.','We have an abundance of mailboxes in our fair city. The one by the Royal Exchange Bank should certainly fit your needs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15228,'Stable Master','Stable Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15229,'Shalenn tends the animals within the city and prevents them from running amok while their masters continue to fritter their lives away. She stands in Farstriders\' Square, just outside the rangers\' hall.','Shalenn tends the animals within the city and prevents them from running amok while their masters continue to fritter their lives away. She stands in Farstriders\' Square, just outside the rangers\' hall.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15230,'Weapon Master','Weapon Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15231,'The Blood Knights in Farstriders\' Square graciously allow space within their halls for Ileda, the weapon master of Silvermoon. While her training is not cheap, you\'ll appreciate her expertise.','The Blood Knights in Farstriders\' Square graciously allow space within their halls for Ileda, the weapon master of Silvermoon. While her training is not cheap, you\'ll appreciate her expertise.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15232,'Battlemasters','Battlemasters',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15233,'The battlemasters take their ease deep within the halls of the Blood Knight enclave in Farstriders\' Square. While somewhat... crude, they have their redeemable traits.','The battlemasters take their ease deep within the halls of the Blood Knight enclave in Farstriders\' Square. While somewhat... crude, they have their redeemable traits.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15234,'Class Trainer','Class Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15235,'What path do you wish to pursue?','What path do you wish to pursue?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15236,'Druid','Druid',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15237,'One of the druids? Our people don\'t walk that path... but you are in luck. A tauren woman - at least, I believe it\'s a woman - has set up a modest residence on the north end of the Walk of Elders. Harene Plainwalker is her name.\n','One of the druids? Our people don\'t walk that path... but you are in luck. A tauren woman - at least, I believe it\'s a woman - has set up a modest residence on the north end of the Walk of Elders. Harene Plainwalker is her name.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15238,'Hunter','Hunter',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15239,'Oh. You\'re seeking one of... them. Well, if you truly want to waste your time speaking with those backward individuals, you\'ll find the rangers in Farstriders\' Square. Zandine can take care of you.','Oh. You\'re seeking one of... them. Well, if you truly want to waste your time speaking with those backward individuals, you\'ll find the rangers in Farstriders\' Square. Zandine can take care of you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15240,'Mage','Mage',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15241,'Priest','Priest',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15242,'Paladin','Paladin',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15243,'Rogue','Rogue',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15244,'Warlock','Warlock',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15245,'Ah, seeking the masters of the arcane? You can find Quithas and the other magisters within the Sunfury Spire.','Ah, seeking the masters of the arcane? You can find Quithas and the other magisters within the Sunfury Spire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15246,'Lady Liadrin, matriarch of the Blood Knights, has the Knights\' headquarters in an enclave in Farstriders\' Square. You\'ll need to speak to Champion Bachi there if you are looking for instruction. Be respectful while there if you value your head.','Lady Liadrin, matriarch of the Blood Knights, has the Knights\' headquarters in an enclave in Farstriders\' Square. You\'ll need to speak to Champion Bachi there if you are looking for instruction. Be respectful while there if you value your head.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15247,'The priests of our fair city can be found within the Sunfury Spire.  Seek out the lady Belestra.','The priests of our fair city can be found within the Sunfury Spire.  Seek out the lady Belestra.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15248,'The more agile among us can sometimes be difficult to spot, but nonetheless, you\'ll probably run across the rogue Zelanis and his cohorts deep within Murder Row.','The more agile among us can sometimes be difficult to spot, but nonetheless, you\'ll probably run across the rogue Zelanis and his cohorts deep within Murder Row.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15249,'The summoning of demons is a dangerous practice, but the resulting power can be immense. Our resident expert is Alamma, who watches over the warlocks within Murder Row.','The summoning of demons is a dangerous practice, but the resulting power can be immense. Our resident expert is Alamma, who watches over the warlocks within Murder Row.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15250,'Profession Trainer','Profession Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15251,'Which profession do you seek to learn?','Which profession do you seek to learn?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15252,'Alchemy','Alchemy',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15254,'The alchemists are located in the Court of the Sun; you\'ll find Camberon eager to teach you anything you might want to know about the art of brewing potions.','The alchemists are located in the Court of the Sun; you\'ll find Camberon eager to teach you anything you might want to know about the art of brewing potions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15255,'Blacksmithing','Blacksmithing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15256,'Bemarrin teaches the trade of blacksmithing in Farstriders\' Square. While a somewhat... dirty trade, I suppose it has its merits.','Bemarrin teaches the trade of blacksmithing in Farstriders\' Square. While a somewhat... dirty trade, I suppose it has its merits.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15257,'Enchanting','Enchanting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15258,'The enchanter Sedana is currently accepting apprentices, I believe. You\'ll find her in one of the alcoves within the Court of the Sun.','The enchanter Sedana is currently accepting apprentices, I believe. You\'ll find her in one of the alcoves within the Court of the Sun.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15259,'Engineering','Engineering',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15260,'An odd choice... but I suppose I\'m not one to judge. Danwe is the one you\'re after; her engineering stand lies near the Court of the Sun, on the path to Farstriders\' Square.','An odd choice... but I suppose I\'m not one to judge. Danwe is the one you\'re after; her engineering stand lies near the Court of the Sun, on the path to Farstriders\' Square.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15261,'First Aid','First Aid',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15262,'Alestus is a master at the... messier way of mending wounds.  If learning first aid is your aim, seek him out on the Walk of Elders, near the entrance to the Royal Exchange.','Alestus is a master at the... messier way of mending wounds.  If learning first aid is your aim, seek him out on the Walk of Elders, near the entrance to the Royal Exchange.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15263,'Fishing','Fishing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15264,'The waters of Quel\'thalas are teeming with fish; I take it they caught your eye? Drathen is quite experienced with the tricks of the fishing trade, and can be found on the Walk of Elders near the Royal Exchange.','The waters of Quel\'thalas are teeming with fish; I take it they caught your eye? Drathen is quite experienced with the tricks of the fishing trade, and can be found on the Walk of Elders near the Royal Exchange.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15265,'Herbalism','Herbalism',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15266,'Botanist Nathera has a keen eye for finding herbs, and I imagine she might impart her wisdom to the likes of you. You\'ll find her with the alchemists in an alcove of the Court of the Sun.','Botanist Nathera has a keen eye for finding herbs, and I imagine she might impart her wisdom to the likes of you. You\'ll find her with the alchemists in an alcove of the Court of the Sun.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15267,'Jewelcrafting','Jewelcrafting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15268,'If jewelcrafting is what you seek, you\'ll find Kalinda\'s shop on the south end of the Royal Exchange.','If jewelcrafting is what you seek, you\'ll find Kalinda\'s shop on the south end of the Royal Exchange.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15269,'Leatherworking','Leatherworking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15270,'Along the southeast end of the Walk of Elders, Lynalis has set up a fine leatherworking stand. She\'ll train you... for a fee.','Along the southeast end of the Walk of Elders, Lynalis has set up a fine leatherworking stand. She\'ll train you... for a fee.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15271,'Mining','Mining',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15272,'If digging in the dirt is the sort of pastime you find enjoyable, go share your insanity with Belil in Farstriders\' Square. I\'m certain he\'d be happy to see he\'s not the only crazy one.','If digging in the dirt is the sort of pastime you find enjoyable, go share your insanity with Belil in Farstriders\' Square. I\'m certain he\'d be happy to see he\'s not the only crazy one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15273,'Skinning','Skinning',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15274,'Tyn is quite the talented skinner; she produces the finest lynx hides I\'ve yet seen. If you wish to learn from her, you\'ll find her on the southeast end of the Walk of Elders.','Tyn is quite the talented skinner; she produces the finest lynx hides I\'ve yet seen. If you wish to learn from her, you\'ll find her on the southeast end of the Walk of Elders.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15275,'Tailoring','Tailoring',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15276,'The tailor Keelen is always seeking more curious students to teach his delicate craft. His shop is somewhat difficult to uncover at first, but it\'s just north of the auction house in the Bazaar. You\'ll find him on the lower level of the building.','The tailor Keelen is always seeking more curious students to teach his delicate craft. His shop is somewhat difficult to uncover at first, but it\'s just north of the auction house in the Bazaar. You\'ll find him on the lower level of the building.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15277,'TESTING. IS THIS THING WORKING????','TESTING. IS THIS THING WORKING????',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15278,'In Nagrand, food hunt ogre!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15279,'You taste good with maybe a little salt and pepper.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15280,'%s drops a conspicuous document.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15281,'Why you mean to Lump? Lump hungry, dat\'s all.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(15282,'OK, OK! Lump give up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15283,'I need answers, ogre!','I need answers, ogre!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15284,'OK! Lump tell you anything you want!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15285,'Why are Boulderfist out this far? You know that this is Kurenai territory.','Why are Boulderfist out this far? You know that this is Kurenai territory.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15286,'Boulderfist hungry! Need food! Warmaul ogre tribe kick Boulderfist out of mound to north. Many more Boulderfist to feed now.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(15287,'And you think you can just eat anything you want? You\'re obviously trying to eat the Broken of Telaar.','And you think you can just eat anything you want? You\'re obviously trying to eat the Broken of Telaar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15288,'Dat not true. Me just want to nibble. I don\'t eat all. Ok, maybe I eat da little ones.$B$BDey so delicious!\n','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(15289,'This means war, Lump! War I say!','This means war, Lump! War I say!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15290,'<Lump shrugs.>$B$BYou bring da war to da Boulderfist. We put it in da stew.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15291,'Get me out of here, $r!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15292,'Hey fathead, how about some food!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15293,'Hey fatso, how do you go to the bathroom with all that fat!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15294,'Eat me already! I can\'t take being locked up in this cage around you stinky, fat slobs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15295,'I want my daddy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15296,'You fatheads are in trouble if I ever get out of here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15297,'Thanks, $r! I\'m sure my dad will reward you greatly! Bye!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15298,'You shut up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15299,'Me don\'t even want to eat him no more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15300,'Me lose appetite. Corki is poop.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15301,'Me no can take it no more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15302,'','Learning about new plant species is extremely important for our expedition.  Not just the medicinal or edible ones either.$B$BPlants provide the foundation for many other forms of life to exist.  Understanding them allows us to better understand nature as a whole.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15303,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15304,'Congratulations. It smells worse in here than in the ruins.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15305,'Hey fatso, is there any reason why you insist on living in a dung filled hole in the wall?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15306,'Can I get some food, please??? This is outrageous!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15307,'I don\'t know what smells worse: Your feet or a dung-filled cheese and fish fillet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15308,'This is the last time I get caught! I promise! Bye!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15309,'','We have won valuable time. Now we must pull back.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15310,'','%s begins channelling a massive teleport spell. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15311,'Lord Thrall, it is time to go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15312,'We have played our part, and done well at that. It is up to the others now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15313,'%s nods at Lady Jaina Proudmoore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15314,'Who so boldly stands before Lantresor of the Blade? Do you not know death by sight, $g boy:girl;?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(15315,'I have killed many of your ogres, Lantresor. I have no fear.\n','I have killed many of your ogres, Lantresor. I have no fear.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15316,'Then you are a fool. Do you not know what I am?','',25,6,0,0,0,0,0,0,1,0,0,0,26124),
(15317,'Should I know? You look like an orc to me.','Should I know? You look like an orc to me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15318,'An orc...$B$B<Lantresor scoffs.>$B$BI am a blademaster of half-orc descent. ','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(15319,'And the other half?','And the other half?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15320,'Draenei... And because of this, I am neither. Not orc, not draenei. My own kind are a rare breed. Most having been killed decades ago... I live because of my strength of will.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(15321,'I have heard of your kind, but I never thought to see the day when I would meet a half-breed.','I have heard of your kind, but I never thought to see the day when I would meet a half-breed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15322,'Bite your tongue, $r. I have seen things in my lifetime that you have only heard about in legends. I have killed man, woman, and child without remorse. Under the banner of two Warchiefs of the Horde I have served... And now, I rule Boulderfist.','',5,1,273,0,0,0,0,0,1,0,0,0,26124),
(15323,'My apologies. I did not mean to offend. I am here on behalf of my people.\n','My apologies. I did not mean to offend. I am here on behalf of my people.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15324,'And what do your people want of Lantresor, $r?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15325,'My people ask that you pull back your Boulderfist ogres and cease all attacks on our territories. In return, we will also pull back our forces.','My people ask that you pull back your Boulderfist ogres and cease all attacks on our territories. In return, we will also pull back our forces.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15326,'<Lantresor laughs heartily.>$B$BDo you know where you are, fool? This is ogre land. Before orc, before draenei, there was ogre. Yet, you wish to start a war that you will inevitably lose? Boulderfist will crush you. And if Boulderfist does not destroy you, Warmaul will...$B$BBut I think your leaders already know this...','',153,153,1,0,0,0,0,0,1,0,0,0,26124),
(15327,'We will fight you until the end, then, Lantresor. We will not stand idly by as you pillage our towns and kill our people.','We will fight you until the end, then, Lantresor. We will not stand idly by as you pillage our towns and kill our people.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15328,'<Lantresor glares at you as if he were looking through you.>$B$BPerhaps there is another way... I will agree to your leader\'s demands, only if you do exactly as I ask.$B$BWith your assistance, we may be able to help each other out greatly.\n','',273,1,1,0,0,0,0,0,1,0,0,0,26124),
(15329,'What do I need to do?','What do I need to do?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15330,'You will stage a series of events that will lead the Kil\'sorrow orcs of Kil\'sorrow Fortress to believe that the Warmaul ogres have attacked their base and then another series of events to make the Warmaul ogres believe the Kil\'sorrow orcs are attacking their base.$B$BDo this and you solve both of our problems.$B$BThe Boulderfist will have their territory back and your people will be free from attack from Boulderfist, Warmaul and Shadow Council.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(15331,'No overgrown bug\'s gonna chase me out of Zangarmarsh! I\'ll show \'em what the Explorers\' League is made of...','',23,1,0,0,0,0,0,0,1,0,0,0,26124),
(15332,'','It will all be over soon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15333,'Another trophy to add to my collection!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15334,'Well done, Midnight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15335,'Do not touch the displays.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15336,'You are not a guest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15337,'Gallery rules will be strictly enforced.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15338,'This Curator is equipped for gallery protection.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15339,'Now, where was I? Oh, yes...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15340,'You rang?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15341,'Simple fools! Time is the fire in which you\'ll burn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15342,'How can you hope to stand against such overwhelming power?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15343,'All realities, all dimensions are open to me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15344,'You face not Malchezaar alone, but the legions I command!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15345,'At last the nightmare is over...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15346,'Rawr! Me is Shadow Council magishun! Me come for Warmaul terri... tettritor... Me come for Warmaul land!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15347,'Shadow Council come for you Warmaul! We is mad at you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15348,'I killeded anoder Warmaul ogre! I am Shadow Council! Come get me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15349,'Shut up, stupid! Why you yell?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15350,'Me wanted to make it belive... Me wanted to make it real. Dey tink for shure it Shadow Council now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15351,'You so smart. Let\'s do dis now before more come.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15352,'Dat\'s all of dem! Dese Warmaul be so mad! Hooray!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15353,'I\'ll not be tortured again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15354,'You make dat sound pretty good. Sound like da orc dieded.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15355,'My dead orc sound is da best!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15356,'Your dead orc sound ok. Mine better.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15357,'For shure it be good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15358,'Last mont, me won da dead orc sound champi... champichi... me won da dead orc sound contest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15359,'Tonight, things are not what they seem... for tonight your eyes may not be trusted!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15360,'Take for instance this quiet elderly woman waiting for a visit from her granddaughter... surely there is nothing to fear from this sweet, gray-haired old lady!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15361,'But don\'t let me pull the wool over your eyes! See for yourself what lies beneath those covers! And now... on with the show!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15362,'Tonight we plumb the depths of the human soul as we join a lost, lonely girl trying desperately--with the help of her loyal companions--to find her way home!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15363,'But she is pursued... by a wicked, malevolent crone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15364,'Will she survive? Will she prevail? Only time will tell. And now... on with the show!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15365,'Tonight... we explore a tale of forbidden love!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15366,'But beware, for not all love stories end happily, as you may find out. Sometimes, love pricks like a thorn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15367,'But don\'t take it from me; see for yourself what tragedy lies ahead when the paths of star crossed lovers meet! And now... on with the show!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15368,'[PH] This is a test boss emote to see how the text is displayed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15369,'Registrants are required to speak with Warden Bullrok before posting any task.$B$BThose found making unapproved postings will be prosecuted.$B$BPost no bills.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15370,'Registrants are required to speak with Warden Moi\'bff Jill before posting any task.$B$BThose found making unapproved postings will be prosecuted.$B$BPost no bills.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15371,'Damn those ogres. Damn them to the Nether. Won\'t someone save us from these savages! This is the fifth kidnapping in as many days.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15372,'That\'s the best reward we\'re going to be able to offer. Hopefully someone accepts the mission.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15373,'New posting going up! Adventurers and heroes, gather round the bulletin board!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(15374,'That should get Telaar the assistance it needs!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(15375,'Check the bulletin board if you\'re looking for work, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15376,'You treat my hat well now, $n.  You won\'t find a finer one anywhere in this world or another.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15377,'','[PH] Players! Go Stop Archimonde at the tree, we will hold the Undead off here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15378,'Who dares attack the steed of the Huntsman?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15379,'Perhaps you would rather test yourselves against a more formidable opponent?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15380,'They have no respect for the dead, $r. The ogres must be taught a lesson.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15381,'We must search for survivors. If anyone is still alive, we must at least try and get them back...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15382,'Help! Help! They\'re going to eat me!','Help! Help! They\'re going to eat me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15383,'I\'m done for!','I\'m done for!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15384,'One day, a hero will rise and lift the orcs up to their former glory.','One day, a hero will rise and lift the orcs up to their former glory.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15385,'The ogres have the keys! Kill the ogres and get me out of here!','The ogres have the keys! Kill the ogres and get me out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15386,'My children will be made orphans!','My children will be made orphans!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15387,'Thank you, $r! Your service to the Mag\'har will not be forgotten.','Thank you, $r! Your service to the Mag\'har will not be forgotten.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15388,'Death to the ogres!','Death to the ogres!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15389,'Many thanks, hero!','Many thanks, hero!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15390,'Spirits watch over you, $r!','Spirits watch over you, $r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15391,'Go on, get out of here!  Save yourself!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(15392,'','Well done, adventurer. Rage Winterchill\'s death has earned us all a small pause in the enemy\'s advance. Use this short time wisely. Tend to your wounded and prepare your defenses, as soon Archimonde will send even deadlier forces at us. My meager force of reserve units will reinforce you when battle is joined again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15393,'We are ready for whatever Archimonde might send our way, Lady Proudmoore.','We are ready for whatever Archimonde might send our way, Lady Proudmoore.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15394,'','Then let Archimonde do his worst.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15395,'BOOM!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15397,'Stop looking at me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15398,'They broke us all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15399,'Can\'t... control... form.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15400,'Meow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15401,'Roar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15402,'Blinding white light, and then silence!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15403,'Too close to the truth, too close to the truth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15404,'Who are you?  What do you want here?','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(15405,'Why did you do this to us?','',6,18,0,0,500,0,0,0,1,0,0,0,26124),
(15406,'There are FOUR lights!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(15407,'My vicious teromoths will avenge me!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(15408,'Where did everyone go?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15409,'Dinner guests should show more respect!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(15410,'Oh, what a sacred place is here overthrown!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(15411,'I can instruct you in mining.  Interested?','I can instruct you in mining.  Interested?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15412,'Anoint my head with a healing balm.  Do you like my crown of thorns?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15413,'I can instruct you in herbalism.  Interested?','I can instruct you in herbalism.  Interested?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15414,'I can instruct you in alchemy.  Interested?','I can instruct you in alchemy.  Interested?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15415,'','Amazing! Anatheron\'s defeat at your hands has delayed Archimonde from his objective, and brought us that much closer to victory. My forces cannot stay here, however. My troops and I are exhausted, and now is the time for retreat. If your strength has not waned, head east to Thrall\'s encampment. That is where we make another stand. Be well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15416,'Until we meet again, Lady Proudmoore.','Until we meet again, Lady Proudmoore.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15418,'You won\'t get my clothes!  Die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15419,'IT DUZ WUT IT\'S TOLD!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15420,'GET IN DA STEW!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15421,'YOU GUD IN DA BELLY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15422,'','We\'ve got to get those supply crates back!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(15423,'Why do you want to eat me when you have all of these orcs to eat?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15424,'Thanks, $n! How many times have you saved my life now? Three? That makes us blood in my book!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15425,'Be careful going into the thicket, $c.  There is a harmful aura lingering about the place.  It must be the residue from whatever destroyed my fellow druids.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15426,'Your daddy pay Warmaul and maybe we no eat you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15427,'Ha-ha! Just kidding. We eat you for shure anyway!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15428,'This forest be a spooky place.  It\'s full of more bad juju than just the Alliance, so you watch out for yourself.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15429,'','The Horde isn\'t the only danger in this forest.  Don\'t let its seeming tranquility fool you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15430,'BAM! Look at dat gristle sizzle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15431,'And dis is da recipe for da bestest Broken chowder!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15432,'First you need da spices.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15433,'Da salt goes into da pot...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15434,'Den you put da pepper in da pot...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15435,'Now we gonna kick it up a notch wit da secret ingra... ingor... inrag... da secret sauce!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15436,'And last, we put in da Corki!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15437,'You\'re definitely strong, $r, but do you have what it takes to become the Warmaul champion?','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(15438,'Brokentoe prepares to charge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15439,'The battle is about to begin! $n versus the ferocious clefthoof, Brokentoe!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15440,'Get out of my way, $r. Can\'t you see that we\'re in the middle of a battle!','',378,0,0,0,0,0,0,0,1,0,0,0,26124),
(15441,'Get in the Ring of Blood, $n. The fight is about to start!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15442,'$n has defeated Brokentoe!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15443,'$n has been defeated!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15444,'Outstanding! Kaz\'rogal\'s death cry should strike fear into the core of the Burning Legion. They now know the power your forces possess, so expect the worst the Legion can offer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15445,'We have nothing to fear.','We have nothing to fear.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15446,'May the spirits be with you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15447,'A loud chime sounds as the defense wards detect intruders, alerting the sentries.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15448,'Outstanding! Killing a Pit Lord such as Azgalor is no small feat, my friend. If we had more time, I would love to hear the story of you and your companions. Archimonde will not give us that pause, however. My scouts have already reported that the Legion is amassing an immense force outside our camp, and Archimonde is very close to the World Tree. We are evacuating with the help of Lady Proudmoore. You should head to the World Tree at once. The fate of our world is still undecided.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15449,'Until we meet again, Thrall.','Until we meet again, Thrall.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15450,'Filthy vermin.  Submit or perish!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15451,'You as well, Flutter?  We used to be such good friends.  I will miss you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15452,'Oops, my bad.  Sometimes I can\'t control my moonfire.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15453,'Who are you to stare at me and pass judgment?!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(15454,'Do I know you?  If you\'re interested in joining the Cenarion Expedition step right in.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15455,'Careful who you talk to.  The teromoths have ears.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15456,'Not all dinner guests are gracious.  Mind your manners!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15457,'It knows all, it sees all!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(15458,'No need to wait outside in the rain.  Come in... you\'re welcome with us in here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15459,'The vicious teromoths and I are just fine in here on our own, thank you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15460,'Blue brothers reign supreme!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15461,'The battle is about to begin! The unmerciful Murkblood twins versus $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15462,'Unbelievable! $n has defeated the Murkblood twins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15463,'Come out, little birdies! Mug\'gok want to play!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15464,'No hurt Mug\'gok\'s feelings, bird-men!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15465,'Fine! Birdies be dat way! Mug\'gok find new friends!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15466,'Rise, my fallen brothers! Take form and fight!','',0,0,0,0,0,0,0,0,1,0,10512,0,26124),
(15467,'Hailing from the mountains of Blade\'s Edge comes Rokdar the Sundered Lord! $n is in for the fight of $g his:her; life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15468,'ROKDAR SMASH PUNY $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15469,'$n is victorious once more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15470,'Dat was poop! Mogor could put up much better fight den dat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15471,'The corpse of one of the Broken lies here.  Mysteriously, the cause of its death does not appear to be from one of the mutated moths.$B$BPerhaps it has something to do with the strange object resting right next to its outstretched hand?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15472,'Closer... Come closer... See what the void brings!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15473,'From parts unknown: Skra\'gath! Can $n possibly survive the onslaught of void energies?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15474,'Mogor not impressed! Skra\'gath wuz made of da air and shadow! Soft like da squishy orcies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15475,'This is the moment we\'ve all been waiting for! The Warmaul champion is about to make his first showing at the Ring of Blood in weeks! Will $n go down in defeat as easily as the champion\'s other opponents? We shall see...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15476,'Piece by piece I will tear this challenger apart... PIECE BY PIECE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15477,'WUT!? UNPOSSIBLE!! You fight Mogor now! Mogor destroy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15478,'Now you face da true champion! I give you chance to run away little one. Run away now before Mogor decim... destyor... Run away before Mogor KILL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15479,'No more chances! Now you pay da ogre!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15480,'Mogor has challenged you. You have to accept! Get in the ring if you are ready to fight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15481,'For the first time in the Ring of Blood\'s history, Mogor has chosen to exercise his right of battle! On this wartorn ground, $n will face Mogor, hero of the Warmaul!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15482,'$n has defeated the hero of the Warmaul, Mogor! All hail $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15483,'No more nice ogre! You hurt Mogor!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15484,'$n went down like a sack of orc skulls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15485,'All that\'s left of $n is a red stain on the floor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15486,'Hail, champion! Have you ever thought about going into the gladiator business full time? You and I could make a mountain of gold.','',66,1,1,0,0,0,0,0,1,0,0,0,26124),
(15487,'What is the meaning of this?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15488,'Very busy... very busy!  What?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15489,'Empoor, you\'re going to tell me what I want to know, or else!','Empoor, you\'re going to tell me what I want to know, or else!',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(15490,'Now that I\'ve been beaten to within an inch of my life what do you want?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15491,'I\'m leaving now!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15492,'We\'ll get to the bottom of this massacre if it\'s the last thing we do!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(15493,'|cffffff00The Horde is gaining control of Halaa!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15494,'|cffffff00The Alliance is gaining control of Halaa!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15495,'Thank you, $n! I\'d given up any hope of being rescued from these crazy bird-brains!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(15496,'I am in your debt, $n. I had begun to think I would die in this overgrown nest!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15497,'','Your assistance fighting the Burning Legion would be most appreciated. Lady Jaina Proudmoore could use your help on the front lines.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15498,'','Your continued help against the Burning Legion would still be appreciated. Thrall could use your assistance in his encampment to the west of here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15499,'','The moment we\'ve been dreading is now at hand, $C. Archimonde has made his way to Nordrassil, and is beginning to devour the World Tree\'s energies. Malfurion needs more time for his plan to work, so we must do the unthinkable. You must attack Archimonde directly, while my own troops hold off the streams of Burning Legion forces approaching the top of the mount.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15500,'Have you come to rescue me? Quick, get me out of these chains!','',20,0,0,0,0,0,0,0,1,0,0,0,26124),
(15501,'I\'ll have you out of them in just a moment.','I\'ll have you out of them in just a moment.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15502,'Hurry and free me from these chains before the bird-men return!','',20,0,0,0,0,0,0,0,1,0,0,0,26124),
(15503,'I\'ll have you out of those chains in a moment.','I\'ll have you out of those chains in a moment.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15504,'Faster! Faster you worthless runts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15505,'FOR THE GLORY OF THE LEGION!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(15506,'Demos will flense the flesh from your bones!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15507,'This forge will usher in the new age! Demos commands it!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(15508,'This forge will usher in the new age! Demos commands it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15509,'Welcome to the Taverns of Time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15510,'Rest your weary feet, we have all the time in the world...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15511,'Can I offer you a drink? I promise you its aged like none other!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15512,'','Congratulations! A great victory has been won today.',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(15514,'The World\'s End Tavern has nothing to offer those of my kind.  However, I find that it attracts the type of clientele that are interested in what I have for sale.$B$BI specialize in exotic engineering goods acquired from far and wide.  From time to time I might even have a rare thing or two for purchase.$B$BWhat might I interest you in?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15515,'Any luck tracking down that box in Tuurem?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15516,'What do you see when you look to the west, mortal?','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(15517,'I see twisted steel and smell sundered earth.','I see twisted steel and smell sundered earth.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15518,'Do you know what I see? A precursor to invasion.$B$BAye, the master was wise in sealing the portals but has since lost his... how shall I put this? The master has lost his focus. Yes... Focus.$B$BWith this loss, the Legion has seized opportunity. They seep out now, growing in number day by day.','',6,273,1,0,0,0,0,0,1,0,0,0,26124),
(15519,'Legion?','Legion?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15520,'The Burning Legion. Demons. I see them as clearly as you can see your own hand in front of your face. That is, I used to be able to see them clearly.$B$BWith the Legion\'s return come new machinations. Under normal circumstances, I am able to sense the presence of a demon from a thousand paces.$B$B<Altruis grimaces.>','',1,274,0,0,0,0,0,0,1,0,0,0,26124),
(15521,'And now?','And now?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15522,'They elude me. I cannot see past their defenses. They have put in place wards to prevent detection.$B$B<Altruis points westward.>$B$BThey fear us because they know that we fear nothing. The cost for such power is great, the sacrifices many. ','',1,1,25,0,0,0,0,0,1,0,0,0,26124),
(15523,'How do you see them now?','How do you see them now?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15524,'<Altruis turns to face you and smiles.>$B$BI do not.$B$B<Altruis points to his steed, Nethrandamus.>$B$BWe must stop them before these forge camps are able to complete whatever it is that they are building.','',274,1,0,0,0,0,0,0,1,0,0,0,26124),
(15525,'Forge camps?','Forge camps?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15526,'That is what these structures that litter the landscape are called. The Legion have employed the mo\'arg and gan\'arg to build weapons of mass destruction at these mobile forge camps. Let us not find out what it is that they intend to build here in Nagrand!$B$BYou will be my eyes. Your weapons will be my fury.','',273,1,1,0,0,0,0,0,1,0,0,0,26124),
(15527,'Oh no, not you again!  Go away!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(15528,'This belongs to Firewing Point.  You\'ll not be putting your grubby hands on it!','This belongs to Firewing Point.  You\'ll not be putting your grubby hands on it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15529,'Clearly annoyed, %s swats Naturalist Bite with deadly force.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15530,'What\'s this?  You\'ve already killed him!  Oh well, I suppose I can study the corpse.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(15531,'Here lies the broken form of poor Naturalist Bite.  His zeal for knowledge was only matched in ferocity by the manner of his death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15532,'This is what I have gathered from the information that you collected from the survey.$B$BThere are two primary forge camps: Forge Camp: Hate, directly west of where we stand and Forge Camp: Fear, directly southwest. Each camp has a Legion transporter, one forge, and several spell warding towers. Additionally, the camps are guarded by wrathguards manning fel cannons. Lastly, each camp has a pit lord overseer.$B$BRight then, this should be no problem at all...$B$B<Altruis laughs.>','',1,1,11,0,0,0,0,0,1,0,0,0,26124),
(15534,'I think I\'ll make my own money on the side while the others try to decide whether it\'s okay to go into Oshu\'gun.$B$BTime is profit!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15535,'The beacons are lit, now is the time to strike! Take one of these battle standards and plant it at the graveyard for the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15536,'Twin Spire Ruins is not yet secure! My orders are to only give out battle standards when the two beacons are lit and the area is secure. Get out there and gain control of those beacons!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15537,'Give me a battle standard. I will take control of Twin Spire Ruins.','Give me a battle standard. I will take control of Twin Spire Ruins.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15538,'The beacons are lit, now is the time to strike! Take one of these battle standards and plant it at the graveyard for the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15539,'Give me a battle standard. I will take control of Twin Spire Ruins.','Give me a battle standard. I will take control of Twin Spire Ruins.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15540,'Twin Spire Ruins is not yet secure! My orders are to only give out battle standards when the two beacons are lit and the area is secure. Get out there and gain control of those beacons!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15541,'|cffffff00The Alliance has taken control of the West Beacon!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15542,'You come into my house and threaten ME?  I think not!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15543,'|cffffff00The Horde has taken control of the West Beacon!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15544,'<Sal\'salabim growls at you, then goes back to drinking his frothy beverage.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15545,'|cffffff00The Horde has taken control of the East Beacon!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15546,'|cffffff00The Alliance has taken control of the East Beacon!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15551,'[Demonic] Ka kalix!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15552,'Altruis sent me. He said that you could help me.','Altruis sent me. He said that you could help me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15553,'Treelos, I know that the truth is somewhere inside you.  Tell me what it is.','Treelos, I know that the truth is somewhere inside you.  Tell me what it is.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15554,'<Warden Treelos looks at you funny and then pauses a moment, clearly struggling.>$B$BZangarmarsh... too close to truth.$B$B<His face goes crazy again.>$B$BIs he still watching!?','',1,6,0,1000,1000,0,0,0,1,0,0,0,26124),
(15555,'Keep it together man!  What about Zangarmarsh?','Keep it together man!  What about Zangarmarsh?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15556,'What\'s that?  Zangarmarsh?  Why would I want to go there?$B$B<Treelos looks thoughtful.>$B$BYes, Zangarmarsh... we... the druids there are getting close to figuring out why the water level is dropping.  It\'s destroying everything!$B$B<You can see the insanity creep back in behind the warden\'s eyes.>$B$BDestroyed us all!  Bright light!  BOOM!!','',6,1,5,0,1000,1000,0,0,1,0,0,0,26124),
(15557,'I don\'t have time for this!  Warden, what happened?!','I don\'t have time for this!  Warden, what happened?!',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15558,'The Firewing blood elves... for some reason they want to stop us.$B$B<Warden Treelos visibly struggles to keep his wits about him for a few more seconds.>$B$BThey... they sent one of the Broken as ... as an emissary....  But he had a bomb!$B$BThey died, they all died!  They tried to run away!  The lucky ones didn\'t even know.$B$BI must have been at the edge of the blast.  It was horr...IT\'S WATCHING US AGAIN!$B$B<Treelos becomes despondent and looks straight through you as if you\'re not there.>','',18,18,5,0,1000,1000,0,0,1,0,0,0,26124),
(15559,'WUT YOU WANT!?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15560,'I have been sent by Sal\'salabim to collect a debt that you owe. Pay up or I\'m going to have to hurt you.','I have been sent by Sal\'salabim to collect a debt that you owe. Pay up or I\'m going to have to hurt you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15561,'Fshhhhhhsssfhhhhh?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15562,'<Floon makes a series of strange clicking and clucking sounds.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15563,'Are you serious? He already killed me! What more could he want?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15564,'He wants his \"golds.\" Pay up or die... again...','He wants his \"golds.\" Pay up or die... again...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15565,'F\'woooroonn! Coosh\'coosh pay nothing! Die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15566,'I choose the third option: KILLING YOU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15567,'Raliq teach you lesson now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15568,'Thank you again, $n, for helping me to uncover what happened here at the thicket.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(15569,'You can have that one, I no longer need him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15570,'Intruders? Go ahead, kill that one, it saves me the effort!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15572,'You want him? Very well, take him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15573,'Don\'t waste your time on that one, he\'s weak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15574,'Careful! That one might call for his mommy when you hit him. Hahaha!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15575,'Yes, beat him mercilessly! His skull is as thick as an ogre\'s!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15576,'That one\'s skin may be red, but his belly is yellow!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15577,'You want another? Go ahead! His blood will look better on the floor than in his face. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15578,'Ahh yes, the first kill of the morning. Continue!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15579,'One pitiful wretch down. Go on, take another one! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15580,'That one died so quickly! Perhaps his brothers can put up more of a fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15581,'Even the brown skinned orcs take longer to die. What a waste... next!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15582,'I was going to kill him anyway!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15583,'His death was even more miserable than the first!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15584,'Ah, what a waste... next!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15585,'He cried when his worg died. Well, no one cries for him now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15586,'Took you long enough to finish them off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15587,'Now that I\'m free of training those miserable wretches, I\'ll entertain myself with you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15588,'How nice of you to decorate my floor with blood.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15589,'Thank you for saving me the trouble. Now it\'s my turn to have some fun!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15590,'|cffffff00The Horde has taken control of Twin Spire Ruins!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15591,'|cffffff00The Alliance has taken control of Twin Spire Ruins!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15593,'Outsiders? Maybe you can beat some sense into that dolt!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15594,'You wish to fight us all at once? This should be amusing!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15595,'Come on, show me a real fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15596,'I feel so funky...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15597,'Ugh... I\'m so not ready to leave...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15598,'The things I\'ve seen... so beautiful...  if only I were a poet...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15599,'My head is clear and cloudy at the same time... Crystal Lining...Silver Clouds...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15600,'','My job is to care for these poor souls.  I accept the help of any willing to lend a hand, be they Aldor or Scryer.$B$BWe are so understaffed, I wouldn\'t turn an ogre away if they knew how to apply a tourniquet.  The politics of the city are of little matter to me. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15601,'','Can you believe it?  This ethereal does not have a single basilisk eye on him!$B$BAnd his leader has the gall to call himself \"the Smuggler Prince!\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15602,'The cat watches the broom intently.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15603,'Why hullo there, Bessy. Its your turn for a walk today, isn\'t it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15604,'Poor Bessy, cooped up in this barn on such a hot day. Let me get a snack for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15605,'Bessy is a hungry girl today, isn\'t she? Let me go get you an apple.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15606,'Good day, Benjamin! Would you mind if I took an apple for Bessy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15608,'Hullo there, Benjamin! Mind if I snack an apple for Old Bessy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15609,'Benjamin, my old friend, think you could spare an apple for Bessy today?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15610,'%s grabs an apple from the tree.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15611,'Thanks, Benjamin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15612,'Samuel, is that old wagon still breaking down on you? ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15613,'That wagon break down on you again, Samuel?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15614,'Such an old wagon, no wonder it broke down on you, Samuel. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15615,'Well, I\'m sorry to hear that. I\'ll be by again later if you want a hand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15616,'Well, Bessy will enjoy this little snack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15617,'Here, Bessy, enjoy this apple while I get you ready. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15618,'%s feeds Bessy the bright red apple.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15619,'Now, now, Blanchy. Don\'t be jealous, you\'ll be going on a big adventure of your own, soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15620,'Whoa, there, Blanchy, you can\'t be having any apples today. Tomorrow, we\'ll be taking you down to Southshore, where you\'ll take a boat way across the seas.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15621,'Aww, Blanchy, don\'t worry, my brother in Westfall will take good care of you. I hear he\'s got a beautiful farm with lots of space for you to roam.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15622,'Young Blanchy stomps her foot jealously.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15623,'Alright Bessy, let\'s get \'cha out for a walk here. Hut, hut!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15624,'Good girl, Bessy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15625,'Any luck, Samuel?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15626,'Bessy whinneys happily.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15627,'Sure, go ahead and take one, there\'s plenty for all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15628,'%s grumbles to himself while he works.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15629,'Aye, its still broken. Can\'t afford to buy a new one though.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15630,'Nay, its still broken. No luck at all, I suppose.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15631,'','%s shakes her head at all of the commotion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15632,'I\'ll keep you safe, mommy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15633,'When is daddy coming back, mom?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15634,'','Don\'t go too far away Seth.  You know mommy doesn\'t like it when she can\'t hear you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15635,'Coming, momma!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15636,'','I... I can see...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15637,'','I thought I\'d never see my son\'s face again.  Come here, Seth!  Let mom take a look at you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15638,'Don\'t cry mommy.  I\'m right here, see?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15639,'','Drink this, Zahlia.  It is not as potent as I\'d hoped, but perhaps it will help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15640,'You are going the wrong way, $n. My elekk will not go into hostile territory.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15641,'','Welcome, $n.  We are the Aldor, priests of the Light and servants of the Sha\'tar.$B$BYou are welcome to stay with us for as long as you need.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(15642,'Who are the Sha\'tar?','Who are the Sha\'tar?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15643,'','\"Born from light\" would be a close translation for Sha\'tar.  It is the name we gave to the naaru who reclaimed Shattrath City from the agents of Illidan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15644,'Isn\'t Shattrath a draenei city?  Why do you allow others here?','Isn\'t Shattrath a draenei city?  Why do you allow others here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15645,'','Shattrath is more than a staging ground for war against the Burning Legion and Illidan.  It serves as a sanctuary to those seeking to escape the violence surrounding us.$B$BWe would be hypocrites if we turned the refugees away.$B$BIf your question refers to the Scryers, then I will respond that while I may not like them or their leader\'s wild claims of visions of redemption, it is not for us to question the wisdom of the naaru.$B$BThese are difficult times, $n.  We need allies where we can find them.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15646,'Back in my day, we fought demons! Real ones!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15647,'Fine fishing weather!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15648,'Couldn\'t ask for a nicer day!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15649,'Nothing like a good evening to fish!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15650,'Indeed! Nothing like the warm air and a cool pond...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15651,'I just wish the fish would bite more than the bugs...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15652,'Aye, if only every day was just like today....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15653,'Hush up, your yapping will scare the fish away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15654,'Bah, real fishermen take on the fiercest rains!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15655,'What did you say?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15656,'Think we\'ll see ol\' sooty today?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15657,'I bet I\'ll catch a big one this time...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15658,'I better not pull up another of Reggy\'s boots again...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15659,'Maybe...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15660,'Anything could happen...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15661,'Hahah, don\'t get your hope up too high...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15662,'Got one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15663,'You guys have any extra bait?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15664,'Remember that time we caught the red-finned murloc down in Elwynn?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15665,'Thank the light that Bertha\'s not here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15666,'Nothing like a warm day and no ol\' lady to yell at ya...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15667,'Nothing like peace an quiet... unlike home!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15668,'I hear you! I can\'t get a moments peace without Sarah complaining about the chores!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15669,'Aye, an no squealing youngster to upset the peace of a man and his fish...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15670,'So you say now, but at least you\'ve got a warm dinner waiting for ya...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15671,'Could be worse, your wife coulda ran off to Stormwind with some cheese merchant!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15672,'Better not say that too loudly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15673,'','My brothers and sisters. Listen to me. We must speak of the survival of our people. We have narrowly survived one calamity, but I fear the next shall destroy us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15674,'','Can you not see what is happening? Open your eyes. It is laid bare for all to see. What is this new alliance? Why have we betrayed our allies of old, only to take up with the enemies of all that live?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15675,'No, you\'re wrong! We were the ones betrayed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15676,'When have the dwarves ever been our friends?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15677,'','The humans abandoned us in our darkest hour! Their prince himself led the assault on our lands.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15678,'You fool! The prince\'s minions were the very Forsaken we have now allied ourselves with, and now he has betrayed us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15679,'The Ranger-General of Silvermoon will be a loyal ally!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15680,'','You speak of her as friend? You are a fool. This \"Dark Lady\" is not Sylvanas.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15681,'Now, let\'s see what we can find out...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15682,'I see... something. It\'s very faint, though.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15683,'Deirom is alive! I can make out an arakkoa pacing back and forth in front of him, asking him the same questions over and over. There is another, too, an orc...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15684,'They\'ve got him in one of their tree-settlements. Veil... Veil Shalas! Thander must know about this immediately! Go speak with him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15685,'Welcome to the Allerian Stronghold, $c.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15686,'Now, let\'s see what we can find out...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15687,'Dugar is alive! I can make out an arakkoa pacing back and forth in front of him, asking him the same questions over and over. There is another, too, a human...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15688,'They\'ve got him in one of their tree-settlements. Veil... Veil Shalas! Rokag must know about this immediately! Go speak with him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15689,'Be wary, $c. The forest is full of hidden dangers and potential enemies.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15690,'Southshore is such a peaceful town.... I\'d like to live here someday.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15691,'The bog lords are attacking!  Help us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15692,'Somebody help!  Our young are in peril!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15693,'Get ready! The brawl is about to begin!\n','Get ready! The brawl is about to begin!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15694,'Wow, what a fight!','Wow, what a fight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15695,'Off with his head!','Off with his head!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15696,'I want blood!','I want blood!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15697,'Yes, yes! I want more!','Yes, yes! I want more!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15698,'Finish it, but not too quickly! I want to see a slow death!','Finish it, but not too quickly! I want to see a slow death!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15699,'[PH] I have a dream... a dream of a day when horses run faster, men grow stronger and time itself stands still.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15700,'[PH] If only there was a leather soft enough to appeal to Marshal Zyx.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15701,'I remember everything...','I remember everything...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15702,'This is just horrible.$B$BI care not for our own discomforts here, but we must do something to ease the pain of the dead in the Bone Wastes!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15703,'What is happening to me?','What is happening to me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15704,'The spirits call... I am consumed.','The spirits call... I am consumed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15705,'The pain is unbearable.','The pain is unbearable.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15706,'Cease your crying! STOP!','Cease your crying! STOP!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15707,'It is dying. It is dying. It is dying.','It is dying. It is dying. It is dying.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15708,'','Come on. This way.',0,0,0,0,0,0,0,7,4,0,0,44118,26124),
(15709,'What will become of us when it falls?','What will become of us when it falls?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15710,'Cannot control... It draws me in... The void grows...','Cannot control... It draws me in... The void grows...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15711,'','I am grateful for your assistance and sacrifice in this matter, $n.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15712,'','I am forever indebted to you for putting to rest the spirits of my ancestors.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(15713,'Anchorite, I need another Extract of the Afterlife.','Anchorite, I need another Extract of the Afterlife.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15714,'If you\'re expecting some kind of official welcome, you\'re going to be disappointed, $c. We don\'t stand on tradition, here. What works is what goes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15715,'One note stands out from the other various pieces of parchment that are tacked onto this wanted poster.  It\'s a call to slay the bonelashers of the Bone Wastes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15716,'This wanted poster is adorned with an assortment of notices and rewards for all manner of dangerous activities.  However, you see nothing in particular that you feel you\'re cut out for yet.$B$BPerhaps you should check again at a later time?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15717,'','No, don\'t feel bad.  I get that a lot.$B$B<Taela looks both amused and annoyed.>$B$BI\'m a HIGH elf, not a blood elf.  Don\'t worry, I\'m not going to suck all of the magic out of you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15718,'Bonelashers, I hate them all!$B$BIf it weren\'t for the loss of my eye, and the fainting spells that I get sometimes, I\'d be out there shooting them down all the time!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(15719,'%s faints.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15720,'I\'ve been watching the Aldor working on the walls. They\'re gonna rebuild the whole city, you know.$B$BThey work much faster than old Foreman Oslow did back home in Lakeshire. He kept losing his tools in the lake, or the gnolls would take his supplies.$B$BI should ask the Aldor to send him some help. They\'d have that bridge fixed faster\'n anything.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15721,'','There\'s a whole vast forest out there, $c. Let the shaman play with the spirits and the warriors toy with their swords. Terokkar is where I\'ll make my fortune.',1,11,0,0,0,0,0,0,1,0,0,0,26124),
(15722,'Malukaz chatters incessantly about the historical importance of this forest, but I don\'t have the luxury of indulging in history until our present problems are settled.$B$BI\'m not saying his work here isn\'t important, but someone has to see to the defenses and logistics of running the hold.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(15723,'Until I traveled through Nagrand and came to the forest, I feared that too much of our original culture was lost. I\'m thankful to see that I was wrong.$B$BThere is so much to be done here!','',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(15724,'','The opening of the Dark Portal brought news of my people\'s fate. In a way, my exile shielded me from sharing in their downfall, but to see the Farstriders throw their lot in with Kael\'thas...$B$BI never imagined my one-time brethren capable of such a thing.$B$BThe homecoming I once dreamt of will never happen. This forest is the only home I have left.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15725,'','When I first arrived, I\'d hoped to meet the town\'s namesake.$B$B<Ros\'eleth glances around.>$B$BMost young high elves outgrow the \'I wanna be a Farstrider\' phase by the time they come of age for their first apprenticeship. Then, it\'s onto the \'I\'m going to be a magister\' stage.$B$BNo one dreams of growing up to be a seamstress, but we can\'t have the Farstriders going around naked, as my mother used to say.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(15726,'','When I first arrived, I\'d hoped to meet the town\'s namesake.$B$B<Ros\'eleth glances around.>$B$BMost young high elves outgrow the \'I wanna be a Farstrider\' phase by the time they\'re taken as apprentices. Then, it\'s onto the \'I\'m going to be a magister\' stage.$B$BI don\'t think I ever quite outgrew the Farstrider phase, to be honest. No one dreams of growing up to be a seamstress, but we can\'t have the Farstriders running around naked, as my mother used to say.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(15727,'Have you seen the way Ros\'eleth winks at me whenever I go to pick up a garment or hat? When things settle down around here, I\'m going to take her for a nice walk in the woods.$B$BFor once, I miss all those fancy taverns in Stormwind.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15728,'<Kaide hisses at you.>$B$BBe quiet, or you\'ll bring the orcs and the Alliance down on us, you clumsy oaf!$B$BThat\'s right, nod your head, and when we\'re done speaking, you\'ll walk away and forget you found me here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15729,'We may be working together, but that only increases the need for discretion. Once again, be mindful of your words and actions.$B$BI can guarantee we\'re far from the only ones out here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15730,'%s glances around somewhat nervously.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15731,'Good day, Ros\'eleth. Is my, err, um... uh, my \'headgear\' finished?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15732,'','Why, yes, Bertelm, I\'ve finished your hat. I used the largest, puffiest, most magnificent feather I could find. Perhaps you\'d like me to measure you for a new pair of hose while you\'re -',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15733,'%s begins to turn red.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15734,'Uh, no... no, that won\'t be necessary. I\'ll, uh, send a soldier by to collect the, uh, headgear later on. I really must be going now...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15735,'','Poor Bertelm...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15736,'','Poor Bertelm...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15737,'You there, fetch water quickly! Get these flames out before they spread to the rest of the keep! Hurry, damn you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15738,'Blood will be true. We can trust in none but our own!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15739,'Fifteen seconds until the Arena battle begins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15740,'One minute until the Arena battle begins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15741,'Thirty seconds until the Arena battle begins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15742,'The Arena battle has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15743,'','Blood? And these orcs, these fair weather friends? They will aid us?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15744,'A great blight lies across our land! It grows every day. Our need for magic weakens us, and will bring us to destruction, just as it has before!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15745,'How are we to live without magic?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15747,'','Look at the wonders of this city! This is magic.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15748,'But at what cost? You\'ve all been blinded. We have all been blinded. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15749,'You call us traitors?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15750,'','The magisters are the traitors! They have sealed our doom.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15751,'Idealistic blather. Go back to your forests!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15752,'','You would have us live like the savages!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15753,'No, not savagery! Conscience. The excesses of our people will destroy us, and all that we have struggled to build.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15754,'','We have not struggled so hard to survive, only to bring about the true destruction.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15755,'Yeah, what do you want?  Can\'t you see I\'m busy here?  The Shadow Council isn\'t paying me by the hour!','Yeah, what do you want?  Can\'t you see I\'m busy here?  The Shadow Council isn\'t paying me by the hour!',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15756,'We stand on the brink of destruction. We must reconsider this rash course of action.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15757,'Why are you fixing all of this up?','Why are you fixing all of this up?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15758,'What\'s it look like I\'m doing?  I\'m fixing the place up - all on my own I might add - so that we can move in!$B$BWith a base of operations out here in the forest, it\'ll be easier to keep track of what Shattrath, Allerian, Stonebreaker and the Cenarion druids are all up to.  Our base in Auchindoun is just too inconvenient for that.$B$BWait a minute, do I know you?','What\'s it look like I\'m doing?  I\'m fixing the place up - all on my own I might add - so that we can move in!$B$BWith a base of operations out here in the forest, it\'ll be easier to keep track of what Shattrath, Allerian, Stonebreaker and the Cenarion druids are all up to.  Our base in Auchindoun is just too inconvenient for that.$B$BWait a minute, do I know you?',6,1,0,0,500,0,0,0,1,0,0,0,26124),
(15759,'What\'s it look like I\'m doing?  I\'m fixing the place up - all on my own I might add - so that we can move in!$B$BDo I know you?','What\'s it look like I\'m doing?  I\'m fixing the place up - all on my own I might add - so that we can move in!$B$BDo I know you?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15760,'Do I know you?  Look, I don\'t want any trouble.  I just fix things around here.','Do I know you?  Look, I don\'t want any trouble.  I just fix things around here.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15761,'What?  Who are you?$B$B<The initiate holds his hands up.>$B$BLook, how about I just go back to my practice and you ignore me?','What?  Who are you?$B$B<The initiate holds her hands up.>$B$BLook, how about I just go back to my practice and you ignore me?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15762,'Yes?  Darn it all, now I\'ll have to start over from scratch!','Yes?  Darn it all, now I\'ll have to start over from scratch!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15763,'What are you doing there?','What are you doing there?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15764,'Practicing!  Soon I\'ll be good enough to join the other summoners and take my turn inside the Shadow Labyrinth at Auchindoun.$B$BI hope that I\'ll get the chance to summon something big!  Maybe something as big as Murmur, though I wouldn\'t lose control of him!','Practicing!  Soon I\'ll be good enough to join the other summoners and take my turn inside the Shadow Labyrinth at Auchindoun.$B$BI hope that I\'ll get the chance to summon something big!  Maybe something as big as Murmur, though I wouldn\'t lose control of him!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15765,'You\'re not one of us!  Guards!$B$BOh please, don\'t hurt me!  Not the face!  Not the face!','You\'re not one of us!  Guards!$B$BOh please, don\'t hurt me!  Not the face!  Not the face!',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(15766,'And what is it exactly that you think I can do for you?  Can\'t you see that I\'m very busy here discussing matters of import with our illustrious leader?$B$BBe quick about your business or I\'ll have you beaten, dog!','And what is it exactly that you think I can do for you?  Can\'t you see that I\'m very busy here discussing matters of import with our illustrious leader?$B$BBe quick about your business or I\'ll have you beaten, dog!',5,25,0,0,500,0,0,0,1,0,0,0,26124),
(15767,'Advisor, what\'s the latest news?','Advisor, what\'s the latest news?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15768,'Well, I was just giving our leader here a progress report on how everything is proceeding according to plan.  It should only be a few more weeks and we\'ll have this place back in shape.$B$BWe may want the Shadow Council to only staff the village with orcs, however.  That way we can make an ancestral claim and work undercover.$B$BWait a minute.  Do I know you?  What\'s your name?','Well, I was just giving our leader here a progress report on how everything is proceeding according to plan.  It should only be a few more weeks and we\'ll have this place back in shape.$B$BWe may want the Shadow Council to only staff the village with orcs, however.  That way we can make an ancestral claim and work undercover.$B$BWait a minute.  Do I know you?  What\'s your name?',1,1,6,0,500,500,0,0,1,0,0,0,26124),
(15769,'','Hello, young $r.',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(15770,'Hello, Greatmother. Garrosh told me that you wanted to speak with me.','Hello, Greatmother. Garrosh told me that you wanted to speak with me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15771,'','Hello, dear. I am Geyah, matron of the Mag\'har.$B$B<Greatmother Geyah coughs.>$B$BIf you are here, it would be safe to assume that the portal has opened. Most of the orcs here were too young or too sick to remember the Dark Portal.$B$B<Greatmother Geyah points to the orcs around her.>$B$BMany of them were orphans or would soon become orphans. Aye, Blackhand would have it no other way. Keep the sick from the healthy. Only the strong would survive... Or so they say.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(15772,'You raised all of the orcs here, Greatmother?','You raised all of the orcs here, Greatmother?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15773,'','They have grown up here. We kept them safe from harm. We did the best that we could in nursing them back to health. Many perished but many, many more grew strong. Like Garrosh...$B$B<Greatmother Geyah sighs.>$B$BHe has lost his heart, you know. He tells me that I am his balance. That without me, the blood lust that consumed his father and ultimately cursed our people would take him over.',273,1,1,0,0,0,0,0,1,0,0,0,26124),
(15774,'Do you believe that?','Do you believe that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15775,'','<Greatmother Geyah laughs weakly.>$B$BOf course not, dear. But it\'s not me that has to believe...$B$BGarrosh can lead the Mag\'har. He is strong and wise. All of the spirits approve of him. He just needs to believe in himself. He fears so much... He fears so deeply that if he lets himself go, his rage will consume him and all that would be near him.',11,1,1,0,0,0,0,0,1,0,0,0,26124),
(15776,'What can be done? I have tried many different things. I have done my best to help the people of Nagrand. Each time I have approached Garrosh, he has dismissed me.','What can be done? I have tried many different things. I have done my best to help the people of Nagrand. Each time I have approached Garrosh, he has dismissed me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15777,'','I wish I knew, dear. He will not listen to you nor will he listen to me. In truth, it is why I am still here. It is why I have not left with Mother Kashur. He must find his heart. Our people will not survive through the winter without leadership.',1,1,274,0,0,0,0,0,1,0,0,0,26124),
(15778,'Left? How can you choose to leave?','Left? How can you choose to leave?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15779,'','<Greatmother Geyah smiles.>$B$BI am old. It is my time. When I pass, my spirit will move on to the spirit realm. It is there that I will stand with my ancestors. It is there that we will watch over our people.$B$BWhen Garad was alive Mother Kashur\'s duty was the same as my duty now.',1,1,273,0,0,0,0,0,1,0,0,0,26124),
(15780,'What is this duty?','What is this duty?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15781,'','The duty of a clan mother is to listen. To listen to the wind and the water and the fire and the earth. To gather information for her clan in the way others gather furs to stay warm. It is the spirits that I commune with... In my dreams, Mother Kashur speaks to me like the spirits that spoke to her once... When I pass, I will speak to Drakia and Celestine in this manner.$B$B<Greatmother Geyah smiles.>',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(15782,'Is there anything I can do for you, Greatmother?','Is there anything I can do for you, Greatmother?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15783,'Time is precious, never waste it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15784,'I need a pack of incendiary bombs.','I need a pack of incendiary bombs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15785,'Here are more of the incendiary devices, $n. Be careful with these, they can cause a great deal of disruption to time if used improperly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15786,'You!  You don\'t belong here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15787,'I\'m going to figure out what this shadowy group is up to no matter what!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15788,'Private Weeks, I need another disguise.','Private Weeks, I need another disguise.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15789,'$n, thank you for dealing with the mystery of the Shadow Council at Grangol\'var Village.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15790,'','Again, I thank you, $n.  Without your aid we would never have been able to deal with the Shadow Council here at Grangol\'var Village.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15791,'','We need to figure out what this shadowy group is doing here at Grangol\'var Village!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15792,'Scout Neftis, I need another disguise.','Scout Neftis, I need another disguise.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15793,'We\'ve a duty out here, $g boy : girl;, to see to it that we don\'t let anyone surprise us.$B$BThat means proactive action!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15794,'','I must have made a misstep somewhere to be assigned here.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15795,'Did you hear that they lost total control of Murmur in the Shadow Labyrinth?!','Did you hear that they lost total control of Murmur in the Shadow Labyrinth?!',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15796,'They don\'t pay us enough for this.  But this ruined village sure beats skulking around inside of Auchindoun.','They don\'t pay us enough for this.  But this ruined village sure beats skulking around inside of Auchindoun.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15797,'I joined up because they said they\'d pay my way into the academy.  My uncle says that I can go next season!','I joined up because they said they\'d pay my way into the academy.  My uncle says that I can go next season!',1,4,0,0,500,0,0,0,1,0,0,0,26124),
(15798,'Hey there, you must be the new recruit!  Good to meet you!$B$BAny word from the Shadow Labyrinth in Auchindoun on whether we\'ve regained control of Murmur yet?','Hey there, you must be the new recruit!  Good to meet you!$B$BAny word from the Shadow Labyrinth in Auchindoun on whether we\'ve regained control of Murmur yet?',1,6,0,0,500,0,0,0,1,0,0,0,26124),
(15799,'If you\'re interested, a couple of us are going into Shattrath for drinks later.','If you\'re interested, a couple of us are going into Shattrath for drinks later.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15800,'Interested in joining up for the leather ball league?  We play Monday through Wednesday, mostly. $B$BYou\'re welcome to join us after this shift.  We\'re going to toss it around.','Interested in joining up for the leather ball league?  We play Monday through Wednesday, mostly. $B$BYou\'re welcome to join us after this shift.  We\'re going to toss it around.',6,1,0,0,500,0,0,0,1,0,0,0,26124),
(15801,'I hope this place pans out as a forward base for Shadow Council operations.  I know it sounds weird, but I kind of miss the Shadow Labyrinth.','I hope this place pans out as a forward base for Shadow Council operations.  I know it sounds weird, but I kind of miss the Shadow Labyrinth.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15802,'<He leans in closer.>$B$BJust between you and me, I\'m thinking about \'mustering\' out one of these nights.  You know what I mean?','<She leans in closer.>$B$BJust between you and me, I\'m thinking about \'mustering\' out one of these nights.  You know what I mean?',1,1,0,0,500,0,0,0,1,0,0,0,26124),
(15803,'Who do you think you are that you can walk in here and address me?  I\'m the leader of the Shadow Council in this village.  Get out of my sight!$B$BIf I see you again, I\'ll be the last person that you ever see.  Understand?$B$BPerhaps you\'d like to be buried in the labyrinth of Auchindoun, or sacrificed to Murmur?','',6,1,0,0,500,0,0,0,1,0,0,0,26124),
(15804,'How could you do this?  I confided in you!','How could you do this?  I confided in you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15805,'You\'re off the leather ball team!','You\'re off the leather ball team!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15806,'You can forget about those drinks later!','You can forget about those drinks later!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15807,'Special lunch?  How about a special death!','Special lunch?  How about a special death!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15808,'Um, yeah... get \'em!','Um, yeah... get \'em!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15809,'I thought we were going to be best friends!','I thought we were going to be best friends!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15810,'What?  Isn\'t that the new guy?','What?  Isn\'t that the new guy?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15811,'Darn, and I kind of liked you.','Darn, and I kind of liked you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15812,'','I hear Bertelm\'s been collecting fur for his latest creation. He told you it\'s going to be a cloak, right?$B$BIt isn\'t. That\'s just the cover he\'s using to keep his wolf fur hatband a secret. He wouldn\'t put all that work into collecting the fur just to soil it in battle!',11,1,0,0,0,0,0,0,1,0,0,0,26124),
(15813,'You will find our alchemist trainers in the Vault of Lights. Go with the Light.','You will find our alchemist trainers in the Vault of Lights. Go with the Light.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15814,'Though the acquisition of wealth is no longer a driving force in our lives, we understand that money makes the world go \'round. You will find our auction house in the Seat of the Naaru.','Though the acquisition of wealth is no longer a driving force in our lives, we understand that money makes the world go \'round. You will find our auction house in the Seat of the Naaru.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15815,'You will find our bank in the Exodar\'s central hub.  Go with the Light.','You will find our bank in the Exodar\'s central hub.  Go with the Light.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15816,'Stephanos is our Hippogryph master.  He resides in the Exodar\'s central hub.  May the Light bless you on your travels.','Stephanos is our Hippogryph master.  He resides in the Exodar\'s central hub.  May the Light bless you on your travels.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15817,'You will find our battlemasters in the Vault of the Lights.  There is also one \"Miglik Blotstrom\" staying with Caregiver Breel, who claims to represent an arena fighting circuit on this world.','You will find our battlemasters in the Vault of the Lights.  There is also one \"Miglik Blotstrom\" staying with Caregiver Breel, who claims to represent an arena fighting circuit on this world.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15818,'Miall is our chief blacksmith on the Exodar. She can be found on the lower level of the Trader\'s Tier.  Go with the Light.','Miall is our chief blacksmith on the Exodar. She can be found on the lower level of the Trader\'s Tier.  Go with the Light.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15819,'What trainer do you seek?','What trainer do you seek?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15820,'Druid?  Ah... Shalannius, you seek Shalannius.  You shall find this night elf outside of the Exodar, near Valaar\'s Berth.','Druid?  Ah... Shalannius, you seek Shalannius.  You shall find this night elf outside of the Exodar, near Valaar\'s Berth.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15821,'Our enchanters are located in the Crystal Hall opposite the jewel crafters.  Light be with you.','Our enchanters are located in the Crystal Hall opposite the jewel crafters.  Light be with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15822,'So, you are willing to help repair the mighty Exodar?  I heard it will take years before the Exodar is fully functional once more.  You have two hours.  Just kidding.  Our engineers are located on the lower levels of the Trader\'s Tier.  Go with the Light.','So, you are willing to help repair the mighty Exodar?  I heard it will take years before the Exodar is fully functional once more.  You have two hours.  Just kidding.  Our engineers are located on the lower levels of the Trader\'s Tier.  Go with the Light.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15823,'By the Light! It is a blessing to have one who cares about the well-being of others. At a time like this we need all the help we can get. Nus can train you in the ways of first aid. She is near the crystal cave in the Crystal Hall. Light be with you.','By the Light! It is a blessing to have one who cares about the well-being of others. At a time like this we need all the help we can get. Nus can train you in the ways of first aid. She is near the crystal cave in the Crystal Hall. Light be with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15824,'Stop!','Stop!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15825,'Will you stop--','Will you stop--',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15826,'You can find Erett the fishing trainer in the Crystal Hall near the Light Blessed Waters.','You can find Erett the fishing trainer in the Crystal Hall near the Light Blessed Waters.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15827,'Rifling through the stacks of books and scrolls on the table, %s begins to examine one in particular with interest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15828,'You will find Funaam, the guild master, near the Trader\'s Tier entrance.','You will find Funaam, the guild master, near the Trader\'s Tier entrance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15829,'What?  What\'s this?!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(15830,'That is not even remotely imaginable!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(15831,'Looks like I picked a bad day to stop drinking.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(15832,'How did this get missed?!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(15833,'Cap\'n, sir, we have a slight problem.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(15834,'At ease, lieutenant.  Go on.','',66,0,0,0,0,0,0,7,1,0,0,0,26124),
(15835,'What is it now, Gravel?','',6,0,0,0,0,0,0,7,1,0,0,0,26124),
(15836,'What else could possibly go wrong?','',6,0,0,0,0,0,0,7,1,0,0,0,26124),
(15837,'Yes, lieutenant?  Report.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(15838,'As you say, sir.  It would appear that someone failed to mention to me that the druids at the Cenarion Thicket have been wiped out!','',1,5,0,0,500,0,0,7,1,0,0,0,26124),
(15839,'Bad news.  We\'ve been hit again.  They\'re gone, but the front sentry tower is on fire.','',1,1,0,0,500,0,0,7,1,0,0,0,26124),
(15840,'One of our merchants has gone missing!','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(15841,'You will find our herbalist, Cemmorhan, against the back wall of the Vault of Lights.','You will find our herbalist, Cemmorhan, against the back wall of the Vault of Lights.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15842,'That group that recently arrived from Honor Hold -- they\'re mercs!  They\'re starting to stir up trouble.  Maybe I should have a talk with them?','',1,6,0,0,500,0,0,7,1,0,0,0,26124),
(15843,'One of our scouts is reporting that a shadowy group has moved into the ruins of Grangol\'var Village.  Oops, this report is over a week old.','',1,1,0,0,500,0,0,7,1,0,0,0,26124),
(15844,'We have reports from a scout in the field that one of the Cenarion druids has been taken captive up at Firewing Point.','',1,1,0,0,1000,0,0,7,1,0,0,0,26124),
(15845,'You seek the hunters?  You will find them on the second level of the Trader\'s Tier, in the Hunters\' Sanctum.','You seek the hunters?  You will find them on the second level of the Trader\'s Tier, in the Hunters\' Sanctum.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15846,'Our Caregiver Center is located above the central Vault of Light, near the Exodar\'s main entrance.','Our Caregiver Center is located above the central Vault of Light, near the Exodar\'s main entrance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15847,'Have you honed your skills enough to learn what I have to teach?','Have you honed your skills enough to learn what I have to teach?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(15848,'Farii trains those interested in jewel crafting. You can find her in the Crystal Hall near the cavern there.','Farii trains those interested in jewel crafting. You can find her in the Crystal Hall near the cavern there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15849,'That\'s troubling news indeed.  See to it that it\'s taken care of immediately!','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(15850,'I don\'t have time for this, lieutenant.  Make sure that you handle it.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(15851,'If we\'re to help with that in any way we\'ll need more people.  Call some of the scouts in to help with that.','',1,1,0,0,500,0,0,7,1,0,0,0,26124),
(15852,'Lieutenant, I want you to make that your top priority.  Notify anyone that you think can help.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(15853,'Aye, aye, sir.  Right away!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(15854,'You will find the Exodar\'s leatherworkers in the Trader\'s Tier.  May the Light bless you.','You will find the Exodar\'s leatherworkers in the Trader\'s Tier.  May the Light bless you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15855,'You will find our mages in the Vault of Lights.  Go with the Light.','You will find our mages in the Vault of Lights.  Go with the Light.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15856,'Blessings of the Naaru. What can I help you find?','Blessings of the Naaru. What can I help you find?',1,0,0,1,0,0,0,0,1,0,0,0,26124),
(15857,'You will find our mining trainers towards the back of the Trader\'s Tier.','You will find our mining trainers towards the back of the Trader\'s Tier.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15858,'The Exodar\'s paladin trainers are found in the luminous Chapel of Light in the Seat of the Naaru.','The Exodar\'s paladin trainers are found in the luminous Chapel of Light in the Seat of the Naaru.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15859,'Our priest trainers can be found within the Order of Light\'s chamber, at the entrance to the Seat of the Naaru. Light be with you.','Our priest trainers can be found within the Order of Light\'s chamber, at the entrance to the Seat of the Naaru. Light be with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15860,'Which profession trainer are you looking for?','Which profession trainer are you looking for?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15861,'You will find a number of shaman trainers in the Crystal Hall. Perhaps you should visit Farseer Nobundo there, and show the Broken some pity. Light be with you.','You will find a number of shaman trainers in the Crystal Hall. Perhaps you should visit Farseer Nobundo there, and show the Broken some pity. Light be with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15862,'You will find the Exodar\'s skinning trainers in the Trader\'s Tier with the leatherworkers.  May the Light bless you.','You will find the Exodar\'s skinning trainers in the Trader\'s Tier with the leatherworkers.  May the Light bless you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15863,'You can find Arthaid, our stable master, outside of the Caregiver Center. He is located on the upper level of the central hub, near the Exodar\'s main entrance.','You can find Arthaid, our stable master, outside of the Caregiver Center. He is located on the upper level of the central hub, near the Exodar\'s main entrance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15864,'Long ago, we wore one piece jumpsuits. Thanks to our innovative tailors, we no longer wear such impractical outfits. You can find these fashion lifesavers in the Trader\'s Tier.','Long ago, we wore one piece jumpsuits. Thanks to our innovative tailors, we no longer wear such impractical outfits. You can find these fashion lifesavers in the Trader\'s Tier.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15865,'The information on this wanted poster indicates that you don\'t yet qualify for the task at hand.$B$BYou should definitely check back later, though.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15866,'Interesting.  The wanted poster calls for the extermination of the local moth population.  Something about royal teromoths.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15867,'Looking to be a great warrior?  War does not make one great.  Still, you will find our great warrior trainers on the Warriors\' Terrace, overlooking the rest of the Trader\'s Tier.','Looking to be a great warrior?  War does not make one great.  Still, you will find our great warrior trainers on the Warriors\' Terrace, overlooking the rest of the Trader\'s Tier.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15868,'Welcome to the Royal Exchange Bank, $g sir : ma\'am;. How may I help you?','Welcome to the Royal Exchange Bank, $g sir : ma\'am;. How may I help you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15869,'Thank you for choosing the Bank of Silvermoon. What may I do for you today?','Thank you for choosing the Bank of Silvermoon. What may I do for you today?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15870,'You wish to improve your weapon skills?  Our weapon master is located on the highest level of the Trader\'s Tier, on the Warriors\' Terrace.','You wish to improve your weapon skills?  Our weapon master is located on the highest level of the Trader\'s Tier, on the Warriors\' Terrace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15871,'Yes, $t citizen : citizen;, what matter of import do you have to bring to my attention?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15872,'Greetings. How may we of the Royal Exchange Bank assist you today?','Greetings. How may we of the Royal Exchange Bank assist you today?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15873,'Welcome to the Bank of Silvermoon, $g sir : ma\'am;. Would you care to access the depository?','Welcome to the Bank of Silvermoon, $g sir : ma\'am;. Would you care to access the depository?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15874,'The Exodar\'s vaults are vast and well-protected. Your goods will come to no harm here.','The Exodar\'s vaults are vast and well-protected. Your goods will come to no harm here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15875,'We control access to the Exodar\'s storage facilities. Are there goods you wish to store or remove?','We control access to the Exodar\'s storage facilities. Are there goods you wish to store or remove?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15876,'','Hi!  Do you think you might help me to get out of here?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15877,'','Hi!  I know that you\'re with the Horde, and I\'m with the Alliance, but do you think we could put that behind us this once?  I\'d really like some help getting out of here.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15878,'','Hello?  Help?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15879,'','<cough> <cough> Damsel in distress over here!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(15880,'','When you get a chance do you think you could let me out of here?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15881,'','Don\'t leave me in here!  Cause if you do, I will find you...',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(15882,'','Ok, let\'s get out of here!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15883,'','You sure you\'re ready?  Take a moment.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15884,'','Alright, let\'s do this!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15885,'','Uh oh, bad elves!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15886,'','Don\'t these guys ever give up?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15887,'','Ok, I think I can make it on my own from here.  Thank you so much for breaking me out of there!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15888,'The high elf spy is escaping.  Get her!','The high elf spy is escaping.  Get her!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15889,'Notices of bounties and job openings are posted here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15890,'Do NOT let the spy escape!','Do NOT let the spy escape!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15891,'What\'s the meaning of this? GUARDS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15892,'That\'s enough out of him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15893,'As long as we\'re going with a new plan, I may as well pick up a weapon and some armor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15894,'Let\'s go.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15895,'Invaders, you dangle upon the precipice of oblivion! The Burning Legion comes and with it comes your end.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15896,'Intrudersss with the prisssoner!  Kill them!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15897,'What?  You already killed him!$B$BI was hoping to study Quagmirran, perhaps interact with him.  But now all that I\'ll be studying is his corpse.$B$B<sigh>$B$BPlease let me out of this cage.  I\'ll take a look at him and then make my own way out of here.','',5,1,0,0,500,0,0,0,1,0,0,0,26124),
(15898,'The gruesome visage of a leering orc stares back at you from this poster.  His raiments are obviously of a warlock nature.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15899,'Yes?  What is it?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15900,'Zzz...','Zzz...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15901,'Zzz... wine... so good... zzz...','Zzz... wine... so good... zzz...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15902,'Zzz... all lies... doomed, all of us... zzz...','Zzz... all lies... doomed, all of us... zzz...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15903,'Zzz... I\'m so... beautiful... zzz...','Zzz... I\'m so... beautiful... zzz...\n',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15904,'There is nothing to see here. Move along.','There is nothing to see here. Move along.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15905,'This does not concern you. Be on your way.','This does not concern you. Be on your way.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15906,'Ssslay them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15907,'You will all sssuffer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15908,'A rider approaches.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15909,'Thrall! You didn\'t really think you would escape, did you?  You and your allies shall answer to Blackmoore... after I\'ve had my fun.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15910,'Thank you friends, I owe my freedom to you. Where is Taretha? I hoped to see her one last time and thank her before leaving into the mountains.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15911,'Taretha cannot see you, Thrall.','Taretha cannot see you, Thrall.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15912,'What do you mean by this? Is Taretha in danger?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15913,'The situation is rather complicated, Thrall. It would be best for you to head into the mountains now, before more of Blackmoore\'s men show up. We\'ll make sure Taretha is safe.','The situation is rather complicated, Thrall. It would be best for you to head into the mountains now, before more of Blackmoore\'s men show up. We\'ll make sure Taretha is safe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15914,'I will do no such thing. I simply cannot leave Taretha in danger while I run off into the mountains. I am no coward. Now, where is she?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15915,'Tarren Mill.','Tarren Mill.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15916,'Very well. Tarren Mill lies just west of here. Since time is of the essence...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15917,'','If we speak as one, we cannot be ignored!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15918,'Lend us your voices! Now is the time we must act to save our people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15919,'Lor\'themar must hear us! We will not be silenced!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15920,'','The magisters will guide us back to glory.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15921,'Our new allies will bring us back to our former glory. These bonds will be true, and we will not be betrayed again!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15922,'That should take care of that. Summon me if you have further need of my services.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15923,'Do you not see how magic has made our city great?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15924,'Lor\'themar has remade Silvermoon into something we may truly be proud of.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15925,'How can you say our lives are not better now? How can you deny the betterment of our lives?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15926,'The magisters are wise and will plot a prosperous course for our future.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15927,'','We will pay back the Alliance for their betrayal a thousandfold. We will never forgive and never forget.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15928,'','Those who would speak out against magic are enemies of progress. ',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15929,'','Nature lives at peace with magic. With both, there is no limit to our future.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15930,'','We will repay the betrayal of the Alliance! We shall never forget, and never forgive!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15931,'I wish to browse your goods.','I wish to browse your goods.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15932,'Don\'t look so surprised to see me here, $r. The coming of the draenei and their alliance with my people was foretold by Kurz the Revelator.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15933,'<As you greet Ambassador Frasaboo in the furbolg language, he smiles.>$B$BYou must be the one spoken of in the prophecy. It is a great honor to meet you.$B$BI am Ambassador Frasaboo, High Chief Stillpine\'s representative in Blood Watch.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15934,'It\'s good to see you again, $n. You have High Chief Stillpine\'s deepest gratitude for rescuing his daughter from the clutches of the Bristlelimb.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(15935,'In my years as a member of Explorers\' League, I\'ve been all over Azeroth, but I\'ve never seen anythin\' quite like Bloodmyst. ','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15936,'Train me in the trade of mining.','Train me in the trade of mining.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15937,'Please, don\'t say anything to me. I don\'t want to get into any more trouble with them.','Please, don\'t say anything to me. I don\'t want to get into any more trouble with them.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(15938,'','We\'ve just arrived here and already we\'ve buried too many of our friends and comrades.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15939,'What is it that you want, $r?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15940,'I wish to browse your wares, Otonambusi.','I wish to browse your wares, Otonambusi.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15941,'How can you have any pudding if you don\'t eat your fish?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(15942,'If you don\'t eat your fish, you can\'t have any pudding!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(15943,'I wish to train, Aesom.','I wish to train, Aesom.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15944,'Train me in the ways of herbalism.','Train me in the ways of herbalism.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15945,'I wish to learn more about first aid.','I wish to learn more about first aid.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15946,'Days is $3930e.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15947,'Tell me how many until Christmas','Tell me how many until Christmas',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15948,'Let\'s ride!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15949,'','If you are not here to help the cause, get out.',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(15950,'With your help, we might be able to win this thing!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15952,'%s roars in anger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15953,'Tarren Mill lies beyond these trees. The commotion at Durnholde should give us a little time to find Taretha before the entire countryside is flooded with human soldiers. Let\'s check the nearby barn, then head into town.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15954,'You may make purchases from me by using Halaa tokens of battle and research.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15955,'I wish to browse your wares.','I wish to browse your wares.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15956,'We\'re ready, Thrall.','We\'re ready, Thrall.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15957,'I can instruct you in skinning.  Interested?','I can instruct you in skinning.  Interested?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15958,'I thought I saw something go into the barn.','I thought I saw something go into the barn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15959,'%s attempts to get Landra\'s attention.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15960,'%s sighs.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(15962,'Hmm? Yes?  What\'s that, $n?$B$BPlease, I\'m trying to study Quagmirran.  What\'s left of him anyway.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(15963,'','I can teach you a bit about Tailoring.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15964,'Do you mean the Silvermoon City Inn, or the Wayfarer\'s Rest tavern?','Do you mean the Silvermoon City Inn, or the Wayfarer\'s Rest tavern?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15965,'The Wayfarer\'s Rest tavern.','The Wayfarer\'s Rest tavern.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15966,'The Silvermoon City Inn.','The Silvermoon City Inn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15967,'The Wayfarer\'s Rest Tavern is located between the Walk of Elders and the Bazaar. You can reach it from either location.','The Wayfarer\'s Rest Tavern is located between the Walk of Elders and the Bazaar. You can reach it from either location.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15968,'I didn\'t see anything.','I didn\'t see anything.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15969,'Something riled that horse. Let\'s go!','Something riled that horse. Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15970,'Thrall tries to calm the horse down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15971,'Seems the elevator is out.  I could give you a lift.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15972,'Please transport me to the top.','Please transport me to the top.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15973,'Please transport me to the bottom.','Please transport me to the bottom.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15974,'Taretha isn\'t here. Let\'s head into town.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15975,'She\'s not here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15976,'Thrall\'s trapped himself in the chapel. He can\'t escape now.','Thrall\'s trapped himself in the chapel. He can\'t escape now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15977,'Taretha must be in the inn. Let\'s go.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15978,'Taretha! What foul magic is this?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15979,'','Thrall, you escaped!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15980,'I, Peoreth Il\'danube, greatest mage within earshot, will teleport you, a peon, to the Undercity.$B$BIt should be noted that my greatness will only be felt during this period of reformation, as the regal House of Blizzard prepares a teleportation device the likes of which has never before been seen, heard, or felt.$B$BOh yes, it will be grand. So grand in fact that the fabric of time and space will itself shift, propelling the denizens of this world into a new age of prosperity...','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(15981,'Just shut up and teleport me to the Undercity.','Just shut up and teleport me to the Undercity.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15982,'Bask in the opulence of my people! Let yourself taste the fineries of living, if only this one time. Perhaps then may you die with finality, knowing that you have been touched by the hands of a god!$B$BMay you drink in the spittle that is sure to fly in your direction from disapproving blood elf - man, woman and child alike. Drink it down! Drink. It. DOWN!$B$BTo Silvermoon with you, barbarian!\n','',5,5,6,0,0,0,0,0,1,0,0,0,26124),
(15983,'Um, just teleport me to Silvermoon.','Um, just teleport me to Silvermoon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15984,'Ah, many apologies young master. You must be at least this high to utilize a teleportation spell.$B$B<Peoreth makes an approximation of height with his right hand, hovering it at about knee length.>$B$BCome back when you\'ve grown up.','',1,11,0,0,0,0,0,0,1,0,0,0,26124),
(15985,'Ah, many apologies young master. You must be at least this high to utilize a teleportation spell.$B$B<Maltrake makes an approximation of height with his right hand, hovering it at about knee length.>$B$BCome back when you\'ve grown up.','',1,11,0,0,0,0,0,0,1,0,0,0,26124),
(15986,'He\'s here, stop him!','He\'s here, stop him!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15987,'','Thank you for helping Thrall escape, friends. Now I only hope you can help me as well. I awoke this morning to find myself trapped in this magical prison. A strange wizard told me that I would have to stay here for a while.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15988,'','Who are you? Are you with the wizard? [PH]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15989,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15990,'We\'re here to rescue you, Taretha.','We\'re here to rescue you, Taretha.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15991,'','No, I\'m not important right now. You have to go help Thrall escape. I was going to set a fire as a diversion, but with me in this magical prison you\'ll have to do it instead. [PH]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15992,'Strange wizard?','Strange wizard?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15993,'','Yes, friends. This man was no wizard of Dalaran. His clothes looked quite foreign, and his accent was unfamiliar. All he could mumble about was time this, time that. You\'ll have to find that wizard and convince him to release me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15994,'We\'ll get you out, Taretha. Don\'t worry. I doubt the wizard would wander too far away.','We\'ll get you out, Taretha. Don\'t worry. I doubt the wizard would wander too far away.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15995,'I\'m glad Taretha is alive. We now must find a way to free her from her magical bindings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(15996,'','As a representative of the Lower City, I\'m here to put forward our case that Auchindoun must be cleared of its Shadow Council infestation.  That is, if we\'re to have any hope for a future and stave off the possibility of a cataclysm greater than the creation of the Bone Wastes!$B$BAll of our peoples have suffered too much already.  I am here to see to it that the suffering stops!',1,5,0,0,500,0,0,0,1,0,0,0,26124),
(15997,'Doomguard','Doomguard',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(15998,'Wrathguard\n','Wrathguard\n',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(15999,'Succubus','Succubus',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16000,'Shivarra','Shivarra',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16001,'Dreadlord','Dreadlord',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16002,'Eredar','Eredar',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16003,'Pit Lord','Pit Lord',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16004,'Gan\'arg','Gan\'arg',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16005,'Mo\'arg','Mo\'arg',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16006,'Felguard','Felguard',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16007,'Turn back, mortal... This is not your battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16008,'You cannot stop them...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16009,'We are infinite... eternal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16010,'They lack control... Oshu\'gun calls to them...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16011,'It is a beacon. A remnant of a forgotten era.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16012,'Have a seat, $g brother:sister;. The ravages of Zangarmarsh can take a lot out of a $g man:woman;.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16013,'If you be wantin\' ta rest here, ya just need to ask!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16014,'Graaaa!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(16015,'Thank you for your help in making the salve, $n. Once it\'s had a chance to dull the pain, I\'m going to see how far I can get on this leg.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16016,'Thrall! Come outside and face your fate!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16017,'Who or what was that?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16018,'Thrall, come outside and face your fate. [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16019,'Taretha\'s life hangs in the balance. Surely you care for her. Surely you wish to save her... ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16020,'No!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16021,'Ah, there you are. I had hoped to accomplish this with a bit of subtlety, but I suppose direct confrontation was inevitable. Your future, Thrall, must not come to pass and so... you and your troublesome friends must die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16022,'','Welcome to Garadar, stranger. Are you looking for a place to rest?',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(16023,'Enough, I will erase your very existence!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16024,'Ah... another shaman seeks enlightenment, perhaps? Are the spirits speaking unclearly? Do you wish my help in seeing what lies before you?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16025,'I am Skaltesh, guide to the shaman seeking enlightenment here... but even those who follow different paths can be shown a thing or two. Do you wish to see?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16026,'Show me, Seer.','Show me, Seer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16027,'Drink from this vial, and the fog will be cleared for a short time. Go with the spirits, my friend.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16028,'Sylann, one of the finest cooks in the city, can be found upstairs in the Wayfarer\'s Rest tavern. You can purchase cooking supplies from her assistant there, too.','Sylann, one of the finest cooks in the city, can be found upstairs in the Wayfarer\'s Rest tavern. You can purchase cooking supplies from her assistant there, too.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16029,'Cooking','Cooking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16031,'Greatfather Winter leaves toys for everyone under the tree in Ironforge during the feast of Winter Veil!','Greatfather Winter leaves toys for everyone under the tree in Ironforge during the feast of Winter Veil!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16032,'I should take the tram to Ironforge and visit Greatfather Winter.','I should take the tram to Ironforge and visit Greatfather Winter.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16033,'They say the elves have stirred themselves from their forest for the first time in years. But to join the Horde? It can\'t be true, can it?','They say the elves have stirred themselves from their forest for the first time in years. But to join the Horde? It can\'t be true, can it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16034,'Human Gossip NPC - Periodic Talk (Expansion Prologue) 01','Human Gossip NPC - Periodic Talk (Expansion Prologue) 01',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16035,'Can you not see that I am busy here?','Can you not see that I am busy here?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(16036,'Yes?  What do you want?','Yes?  What do you want?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(16037,'And you are?','And you are?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(16039,'My sister Silanna is naive to the growing danger in these woods. But like it or not, as soon as I get this wagon loaded we\'re moving within the city walls. $b$bIt appears that I\'ve got more bags here than I need. Perhaps you could make use of them.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16040,'Haven\'t got much time to talk, $r. That is, unless you\'re willin\' to help with this mine trouble.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16041,'Stop here a moment, my children, and close your eyes. Can you feel the air currents?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16042,'Can\'t thank ya enough fer helpin\' with the mines. Now, it\'s just a matter of convincing the miners to get back to work.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16043,'The two students close their eyes and bow their heads.','The two students close their eyes and bow their heads.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16044,'Your world will die, mortals!  Your doom is now at hand!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16045,'Cower, little worms!  Your feeble heroes are nothing!  Your saviors will be our first feast!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16046,'Azeroth has cowered too long under our shadow!  Now, feel the power of the Burning Crusade and despair!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16047,'Your fate is sealed, Azeroth!  I will find the Aspect Shards, and then you will not stand against our might!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16048,'Hah!  This place is not yet worthy of my infliction!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16049,'Thank you for freeing me, $n! I\'m going to make my way to Shattrath!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16050,'Yes, teacher.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16051,'<Isfar sighs.>$B$BA couple of treehouses don\'t make a home, but it was vast improvement over the Sethekk Halls.$B$BComfortable as it was in Shattrath, I can\'t bring myself to return to my true home in Skettis without my sister. She\'s still trapped in the Sethekk Halls, held prisoner by our older brother.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16052,'Please, $r, get me out of here! Unlocking the cage will surely attract my brother\'s attention. Kill Darkweaver Syth!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16053,'Now\'s our chance! Let me out of this cage!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16054,'I\'ll have you out of there in just a moment.','I\'ll have you out of there in just a moment.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16055,'The spirits of the air can be found even here, underground. They dislike being surrounded, constricted by the earth... their precious freedom is limited here.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16056,'Well done! Hurry, though, we don\'t want to be caught!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16057,'They are flighty, these spirits, and easily distracted... but they will share their secrets with those who know how to listen.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16058,'Having trouble dealing with the Wretched? I\'ve got just what you need.\n','Having trouble dealing with the Wretched? I\'ve got just what you need.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16059,'Just don\'t ask me where I got it...\n','Just don\'t ask me where I got it...\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16060,'%s smiles to himself as he watches the students fidget in their concentration.','%s smiles to himself as he watches the students fidget in their concentration.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16061,'Come. There is more to study than the secrets on the wind.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16062,'','Your blood will coat the walls of Kil\'sorrow!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16063,'The Ring of Trials was once of place of great glory and honor. But then, the Steamwheedle Cartel came, with their wagons of gold and quill pens sharper than any orc axe...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16064,'The Sethekk believe themselves to be the true and most loyal followers of the master of all arakkoa. Do not ask about the master, $r, for his mysteries are for the feathered people alone.$B$BThe Sethekk interpreted the destruction of Auchindoun to be the arrival of our master on this planet. They set out for the ruins, taking with them the relics of our greatest hero, Terokk.$B$BThey still seek the master in the temple\'s ruins, but I came to see through their lies. I am no longer one of them.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16065,'When I was last in the halls, Talon King Ikiss carried Terokk\'s Quill with him, as a sign of his authority.$B$BMy brother, Darkweaver Syth, wore Terokk\'s Mask during our rituals.$B$BAs for the Saga of Terokk, there\'s no way of knowing exactly where it is, but they usually kept it at the center of one of their rune circles in the great vaulted halls.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16066,'\'Talon King\' Ikiss is one of the leaders of the Sethekk, along with my brother, Darkweaver Syth.$B$BIt was they who led the exodus of the Sethekk from Skettis to the ruins of Auchindoun. In the beginning, Ikiss was a charismatic leader, but he has descended into madness.$B$BNow, he openly proclaims that he is Terokk reborn! He truly expects the arakkoa to bend knee to him as their ruler. Can you believe his arrogance?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16067,'Who is Talon King Ikiss?','Who is Talon King Ikiss?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16068,'Who are the Sethekk?','Who are the Sethekk?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16069,'Where can I find the relics of Terokk?','Where can I find the relics of Terokk?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16070,'Who is this Terokk you keep mentioning?','Who is this Terokk you keep mentioning?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16071,'He is the greatest hero the arakkoa have ever known.$B$BIt is said that in ancient times, he built the city of Skettis with his own claws. He was our greatest champion and defender, but he left us when we turned away from the veneration of Rukhmar.$B$BWe came to worship a new master, one who promised us untold power and status in the cosmos.$B$BThere are some who say that Terokk and Rukhmar are one, and he withdrew his presence from us when we turned away from him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16072,'Welcome, welcome, to the recently appropriated and callously renamed Steamwheedle Stadium!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16073,'Can you feel the warmth here, my children?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16074,'The students nod slowly, eyes rapt on their teacher.','The students nod slowly, eyes rapt on their teacher.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16075,'Focus upon that warmth as I speak...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16076,'The strength of fire lies in change. Its strength is considerable, but ever-shifting... unpredictable.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16077,'This is extended to the spirits themselves. They are often quick to anger; it is important that you learn to listen without falling prey to their tempers.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16078,'That is enough for now. Come.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16079,'The water here is peaceful, is it not? Listening to the trickle from the ceiling can aid you in finding its true voice...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16080,'The water spirits are perhaps the most outspoken. They are generous and understanding. Indeed, if you are having trouble hearing the voices, it is with water that you should begin.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16081,'Close your eyes, my children, and listen to the water within these halls.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16082,'','I\'m free! Thank you all!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16083,'I\'m glad you\'re safe, Taretha. None of this would have been possible without your friends. They made all of this happen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16084,'Then who are these people?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16085,'','Thrall, I\'ve never met these people before in my life.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16086,'I believe I can explain everything to you two if you give me a moment of your time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16087,'That spell should wipe their memories of us and what just happened. All they should remember now is what reality would be like without the attempted temporal interference. Well done. Thrall will journey on to find his destiny, and Taretha...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16088,'Her fate is regrettably unavoidable.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16089,'Goodbye, Taretha. I will never forget your kindness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16090,'','They call you a monster. But they\'re the monsters, not you. Farewell, Thrall.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16091,'Something must be done about these Wretched...\n','Something must be done about these Wretched...\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16092,'Once they\'re dealt with we can dedicate more resources to the war effort.\n','Once they\'re dealt with we can dedicate more resources to the war effort.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16093,'If only I had some wine to go with my cheese...\n','If only I had some wine to go with my cheese...\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16094,'Ooh what a dreadful job!\n','Ooh what a dreadful job!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16095,'All day, surrounded by the stench of bad feet.\n','All day, surrounded by the stench of bad feet.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16096,'The hours would pass so much more sweetly.\n','The hours would pass so much more sweetly.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16097,'Why couldn\'t mother have chosen something else to dedicate herself to?\n','Why couldn\'t mother have chosen something else to dedicate herself to?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16098,'Cakes, pastries, even bread - anything but cheese!\n','Cakes, pastries, even bread - anything but cheese!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16099,'Gah! Every time I load something into the wagon, it reappears here within moments!\n','Gah! Every time I load something into the wagon, it reappears here within moments!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16100,'I should have known better than to have given Silanna that tome of cantrips.\n','I should have known better than to have given Silanna that tome of cantrips.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16101,'All muscle and no brain, that\'s what peons are! They\'re great when you can motivate them, but they have to be \'kick\' started, if you know what I mean.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(16102,'Foul deeds, these.\n','Foul deeds, these.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16103,'Luckily, I managed to salvage a few bottles.\n','Luckily, I managed to salvage a few bottles.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16104,'Both students close their eyes, straining to hear the voices.','Both students close their eyes, straining to hear the voices.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16105,'Hic... What a calim... a culamu... uhh calamit... Err, what a disaster!\n\n','Hic... What a calim... a culamu... uhh calamit... Err, what a disaster!\n\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16106,'It\'s enough to drive a man to drink.\n\n','It\'s enough to drive a man to drink.\n\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16107,'%s nods to himself and clears his throat.','%s nods to himself and clears his throat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16108,'Stand, my children... that\'s enough for now.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16109,'','Like anything that you see, $c?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(16110,'What about the earth spirits?','What about the earth spirits?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16111,'%s chuckles softly.','%s chuckles softly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16112,'The earth spirits are very much present in this chamber, my child. After all, we are underground, are we not?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16113,'They are stoic, the spirits of the earth. Through them, the shaman learns to endure the hardships of life.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16114,'If you have the money, I have what you need.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16115,'The rocks are here when we first enter this world, and they will remain long after we pass.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16116,'','Take a look around and let me know if there\'s anything that you\'re interested in.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16118,'Stand... there is more to discuss.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16119,'|cffffff00The Horde has taken control of The Bone Wastes!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16120,'|cffffff00The Alliance has taken control of The Bone Wastes!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16121,'','Take your time, look the weapons over.  I also repair weapons and armor if you need such services.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16122,'I have just the thing you need to cast your spell.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16123,'Tell me again what you know!','Tell me again what you know!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16124,'It will take a sharp blade and reinforced armor to bring tranquility back to Nagrand. Shall I repair your equipment so that you may mete justice?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(16125,'I wish to browse your wares.','I wish to browse your wares.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16126,'Are you looking for reagents or poison supplies? If so, you\'ve come to the right place!','',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(16127,'I wish to browse your wares.','I wish to browse your wares.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16128,'I sell wares that crafters need. Just the basics, nothing fancy.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16129,'What do you have for sale?','What do you have for sale?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16130,'','Do you need to stable your pet?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(16131,'I wish to stable my pet.','I wish to stable my pet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16132,'','Are you lost? Most of the town\'s vendors are situated near the center of town.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(16133,'','I carry odds and ends, but mostly just odds.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16134,'What do you have for sale?','What do you have for sale?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16135,'What do you have for sale?','What do you have for sale?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16136,'It\'s driving me crazy. I cannot reach those damned eggs!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16137,'They look so delicious...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16138,'If only I could get this blasted machine working!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16139,'Oh sweet, delicious, spotted eggs - you will be mine... ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16140,'','For years, Honor Hold has stood against the horrors of Hellfire Peninsula.  Now, now that the portal has reopened and aid streams in from Azeroth, perhaps this bloody stalemate will end.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16141,'','It is regrettable that, among our many enemies in Hellfire Peninsula, the orcs of Hellfire Citadel stand among them.$B$BBut... who better to challenge and hone the Horde... than orcs?',1,6,0,0,1000,0,0,0,1,0,0,0,26124),
(16142,'','I am the quartermaster, here. Did you need provisions?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16143,'Good to see you again, $n! Just a few more adjustments and the trajectory of the jump will be perfect!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16144,'Wazat, I have done something foolish and have lost my key as a result of this action. Could I trouble you for a spare?','Wazat, I have done something foolish and have lost my key as a result of this action. Could I trouble you for a spare?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16145,'Anything for you, $n!','',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(16146,'I have marks to redeem!','I have marks to redeem!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16147,'Psst, $n, get over here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16148,'$n, get over here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16149,'%s lets loose a terrifying shriek.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16150,'%s cracks open, filling the nest with yolk.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16151,'The Lunar Festival celebration being held by the druids is taking place in Moonglade. If that\'s too far for you to travel, they are offering transportation just outside Stormwind.','The Lunar Festival celebration being held by the druids is taking place in Moonglade. If that\'s too far for you to travel, they are offering transportation just outside Stormwind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16153,'The Lunar Festival is a special time for us. We seek out our ancient elders, the Earthen, and pay homage to them.','The Lunar Festival is a special time for us. We seek out our ancient elders, the Earthen, and pay homage to them.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16154,'Dwarf Gossip NPC - Periodic Talk (Expansion Prologue) 01','Dwarf Gossip NPC - Periodic Talk (Expansion Prologue) 01',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16155,'Ironforge rarely looks as splendid as it does during the feast of Winter Veil.','Ironforge rarely looks as splendid as it does during the feast of Winter Veil.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16156,'The Lunar Festival holds special meaning for the night elves. We seek out the wisdom of our elders across the world.','The Lunar Festival holds special meaning for the night elves. We seek out the wisdom of our elders across the world.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16157,'Night Elf Gossip NPC - Periodic Talk (Expansion Prologue) 01','Night Elf Gossip NPC - Periodic Talk (Expansion Prologue) 01',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16158,'It feels like everyone wants to kiss me under the mistletoe.','It feels like everyone wants to kiss me under the mistletoe.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16161,'It is my understanding that the people of the Alliance celebrate this Winter Veil in Ironforge.','It is my understanding that the people of the Alliance celebrate this Winter Veil in Ironforge.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16163,'If the Dark Portal opens again, we could go home to Draenor.','If the Dark Portal opens again, we could go home to Draenor.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16164,'Though we do not truly understand the traditions of Winter Veil, we have taken to them.','Though we do not truly understand the traditions of Winter Veil, we have taken to them.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16165,'Undead Gossip NPC - Periodic Talk (Lunar Festival) 01','Undead Gossip NPC - Periodic Talk (Lunar Festival) 01',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16166,'Undead Gossip NPC - Periodic Talk (Expansion Prologue) 01','Undead Gossip NPC - Periodic Talk (Expansion Prologue) 01',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16167,'Winter Veil just isn\'t the same now, but going through the motions still makes me feel something.','Winter Veil just isn\'t the same now, but going through the motions still makes me feel something.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16168,'The Lunar Festival holds special meaning for the tauren. We seek out the wisdom of our elders across the world.','The Lunar Festival holds special meaning for the tauren. We seek out the wisdom of our elders across the world.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16169,'Tauren Gossip NPC - Periodic Talk (Expansion Prologue) 01','Tauren Gossip NPC - Periodic Talk (Expansion Prologue) 01',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16170,'Greatfather Winter is only a wyvern\'s ride away to Orgrimmar.','Greatfather Winter is only a wyvern\'s ride away to Orgrimmar.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16171,'The festival of the moon was ever more important to the kaldorei. The great festival of the druids is surely in full swing.','The festival of the moon was ever more important to the kaldorei. The great festival of the druids is surely in full swing.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16173,'Winter Veil has always been a human thing. To see the goblins and orcs take it up is rather strange.','Winter Veil has always been a human thing. To see the goblins and orcs take it up is rather strange.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16174,'Go to Ironforge\'s Mystic Ward and speak with the night elf druids there. They can transport you to Moonglade to join in the Lunar Festival celebration.','Go to Ironforge\'s Mystic Ward and speak with the night elf druids there. They can transport you to Moonglade to join in the Lunar Festival celebration.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16175,'I have heard rumors that our old friends, the elves, have allied themselves with the Horde. I always said our trust in them was foolish.','I have heard rumors that our old friends, the elves, have allied themselves with the Horde. I always said our trust in them was foolish.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16176,'Greatfather Winter can be found in front of the Ironforge bank. The tree near him is where presents are given out.','Greatfather Winter can be found in front of the Ironforge bank. The tree near him is where presents are given out.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16179,'The younger races make a big fuss over Winter Veil. Ironforge\'s bank is the center of the festivities.','The younger races make a big fuss over Winter Veil. Ironforge\'s bank is the center of the festivities.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16180,'If only our brothers, the blood elves, could change their ways. They will bring the Legion upon us again, mark my words.','If only our brothers, the blood elves, could change their ways. They will bring the Legion upon us again, mark my words.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16181,'The celebration of the Lunar Festival is in full swing in Moonglade. You can make the trek, or the druids in the Cenarion Enclave are offering transport.','The celebration of the Lunar Festival is in full swing in Moonglade. You can make the trek, or the druids in the Cenarion Enclave are offering transport.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16183,'I have traveled countless worlds, but I have never seen as enjoyable a celebration as this feast of Winter Veil. You should travel to Ironforge, the dwarves\' great city, to see it for yourself.','I have traveled countless worlds, but I have never seen as enjoyable a celebration as this feast of Winter Veil. You should travel to Ironforge, the dwarves\' great city, to see it for yourself.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16184,'This new world fascinates us. A world that has fought the Legion to a standstill... amazing.','This new world fascinates us. A world that has fought the Legion to a standstill... amazing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16185,'The druids of Azeroth hold a great celebration in the Moonglade. If you find the lunar festival revelers in the city, they can transport you there.','The druids of Azeroth hold a great celebration in the Moonglade. If you find the lunar festival revelers in the city, they can transport you there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16187,'If you wish to truly experience the feast of Winter Veil, you should go to Orgrimmar.','If you wish to truly experience the feast of Winter Veil, you should go to Orgrimmar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16188,'They say that the Alliance has found new allies. They will be hard pressed to recover from losing us.','They say that the Alliance has found new allies. They will be hard pressed to recover from losing us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16189,'If you find the lunar festival revelers in Silvermoon, they can transport you to Moonglade to partake in the celebration.','If you find the lunar festival revelers in Silvermoon, they can transport you to Moonglade to partake in the celebration.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16191,'You\'ll find Greatfather Winter in the center of the Valley of Strength. Just look for the tree.','You\'ll find Greatfather Winter in the center of the Valley of Strength. Just look for the tree.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16192,'Have you heard about the great explosion in the north?','Have you heard about the great explosion in the north?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16193,'The largest celebration of the Lunar Festival is taking place in Moonglade. If that\'s too far to travel to, there are druids offering transport from the Valley of Wisdom.','The largest celebration of the Lunar Festival is taking place in Moonglade. If that\'s too far to travel to, there are druids offering transport from the Valley of Wisdom.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16195,'We still go through the motions, but the feast of Winter Veil feels empty now. In Orgrimmar they have the true celebration.','We still go through the motions, but the feast of Winter Veil feels empty now. In Orgrimmar they have the true celebration.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16196,'I hear our new allies will be joining us here. Fighting alongside elves... Just like old times.','I hear our new allies will be joining us here. Fighting alongside elves... Just like old times.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16197,'To many of the Forsaken, the moon now holds the place in our hearts where sun once resided. However, if you choose to join the celebration, go to Moonglade in Kalimdor. You\'ll find druids in the throne room above Undercity that will transport you there.','To many of the Forsaken, the moon now holds the place in our hearts where sun once resided. However, if you choose to join the celebration, go to Moonglade in Kalimdor. You\'ll find druids in the throne room above Undercity that will transport you there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16199,'The celebration of the feast of Winter Veil is a source of great warmth during the cold seasons, and its heart is in Orgrimmar.','The celebration of the feast of Winter Veil is a source of great warmth during the cold seasons, and its heart is in Orgrimmar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16200,'I do not know what to make of these elves from across the sea. The tauren and elves of this continent have always warred.','I do not know what to make of these elves from across the sea. The tauren and elves of this continent have always warred.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16201,'The largest celebration of the Lunar Festival takes place in Moonglade. Druids will transport you there from the Elder Rise of Thunder Bluff.','The largest celebration of the Lunar Festival takes place in Moonglade. Druids will transport you there from the Elder Rise of Thunder Bluff.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16202,'You - come here. Are these blades not the finest quality? Surely you wish to purchase from me. You will not find such workmanship and care wrought into such weapons anywhere else, $r.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16203,'What are you staring at, $r?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16204,'How embarrassing! Someone mistook me for one of Greatfather Winter\'s helpers.','How embarrassing! Someone mistook me for one of Greatfather Winter\'s helpers.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16205,'Gnome Gossip NPC - Periodic Talk (Expansion Prologue) 01','Gnome Gossip NPC - Periodic Talk (Expansion Prologue) 01',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16206,'Lunar Festival is the best time of year for fireworks!','Lunar Festival is the best time of year for fireworks!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16209,'Orgrimmar has truly become the heart of Winter Veil.','Orgrimmar has truly become the heart of Winter Veil.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16210,'Troll Gossip NPC - Periodic Talk (Expansion Prologue) 01','Troll Gossip NPC - Periodic Talk (Expansion Prologue) 01',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16211,'We should go to Moonglade to see the druids\' great festival of the moon.','We should go to Moonglade to see the druids\' great festival of the moon.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16212,'Greatfather Winter can be found in front of the Ironforge bank. The tree near him is where presents are given out.','Greatfather Winter can be found in front of the Ironforge bank. The tree near him is where presents are given out.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16213,'Have you heard the rumors? There was a great explosion in the northern lands of Kalimdor and the elves are finally stirring in Quel\'thalas!','Have you heard the rumors? There was a great explosion in the northern lands of Kalimdor and the elves are finally stirring in Quel\'thalas!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16214,'Go to Ironforge\'s Mystic Ward and speak with the night elf druids there. They can transport you to Moonglade to join in the Lunar Festival celebration.','Go to Ironforge\'s Mystic Ward and speak with the night elf druids there. They can transport you to Moonglade to join in the Lunar Festival celebration.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16215,'You\'ll find Greatfather Winter in the center of the Valley of Strength. Just look for the tree.','You\'ll find Greatfather Winter in the center of the Valley of Strength. Just look for the tree.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16216,'Rumors of blue skinned people in the north? Perhaps it\'s just more trolls.','Rumors of blue skinned people in the north? Perhaps it\'s just more trolls.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16217,'The most amazing of the Lunar Festival parties is in Moonglade. Don\'t walk there, though, the druids in the Valley of Wisdom can transport you.','The most amazing of the Lunar Festival parties is in Moonglade. Don\'t walk there, though, the druids in the Valley of Wisdom can transport you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16218,'The untamed plains of Nagrand offer some of the best hunting I\'ve ever experienced. ','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16219,'Do you like fish, $r? I have fish here. If you like fresh fish, the freshest, come and sample my wares.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16220,'I cannot help you, please speak with the Gryphon Master on the South side of the Dark Portal.','I cannot help you, please speak with the Gryphon Master on the South side of the Dark Portal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16222,'I cannot help you, please speak with the Wind Rider Master on the North side of the Dark Portal.','I cannot help you, please speak with the Wind Rider Master on the North side of the Dark Portal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16223,'Never look these Broken directly in the eyes. I think they can suck the soul right out of you if they\'re so inclined!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16224,'Get out of my face, kid! Can\'t you see that I\'m training? That\'s right, yours truly is going to be the next Warmaul champion.$B$BYep, I\'m almost ready for the Ring of Blood up north in the old Laughing Skull Ruins. But don\'t even think about it, kid. You\'re way too weak. Gurgthock, the ring announcer, wouldn\'t even let you peek inside that ring let alone fight in it.$B$BNow beat it before it beats you.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(16225,'Well look at you. Aren\'t you big and tough... Maybe you think you\'re tough enough to step into the Ring of Blood and face the Warmaul champion?$B$B<The pitfighter laughs.>$B$BNot very likely but if you ever wanna test your strength, the Ring of Blood is far to the north against the mountains dividing Nagrand and Zangarmarsh. Gurgthock runs the show at the old Laughing Skull Ruins and he also dispenses the prizes. Speaking of prizes, I hear the prizes this season are incredible!','',1,11,1,0,0,0,0,0,1,0,0,0,26124),
(16226,'Wow! Look at his muscles!','Wow! Look at his muscles!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16227,'I wanna be just like the pitfighter!','I wanna be just like the pitfighter!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16228,'Will he win? Can he win?','Will he win? Can he win?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16229,'The pitfighter will be victorious! Just look at him!','The pitfighter will be victorious! Just look at him!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16230,'He\'s so well disciplined!','He\'s so well disciplined!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16231,'How does he do it?','How does he do it?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16232,'The attackers shall not succeed!  Strength and honor to the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16233,'Wow! Look at his muscles!','Wow! Look at his muscles!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16234,'I wanna be just like the pitfighter!','I wanna be just like the pitfighter!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16235,'Will he win? Can he win?','Will he win? Can he win?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16236,'The pitfighter will be victorious! Just look at him!','The pitfighter will be victorious! Just look at him!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16237,'He\'s so well disciplined!','He\'s so well disciplined!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16238,'How does he do it?','How does he do it?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16239,'What are you doing in Nagrand, filth? Answer me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16240,'What are you after, Bloodknight? Speak or the brutes will punish you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16241,'%s raises an eyebrow at Khan.','%s raises an eyebrow at Khan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16242,'%s kneels down as if to get closer to the Bloodknight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16243,'Surprised? You thought what? That draenei do not beat their prisoners?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16244,'You are correct. We do not beat our prisoners. Broken, on the other hand, have no issues with violence. You see, they are brutes, after all...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16245,'Beat this filth until it speaks...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16246,'%s nods.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16247,'The interrogator is trying to find out what these blood elves are doing here in Nagrand. From what I hear, they\'re after crystal powder residue from Oshu\'gun, the diamond mountain to the west.$B$BNo doubt to use in some insidious scheme or concoction...$B$BIf you are looking to help our cause and stop these blood elves, the conflict is happening right now to the northwest at Halaa. Blood elves and those Hand of Argus soldiers are battling! Join in and show them what\'s right!','The interrogator is trying to find out what these blood elves are doing here in Nagrand. From what I hear, they\'re after crystal powder residue from Oshu\'gun, the diamond mountain to the west.$B$BNo doubt to use in some insidious scheme or concoction...$B$BIf you are looking to help our cause and stop these blood elves, the conflict is happening right now to the northwest at Halaa. Blood elves and those Hand of Argus soldiers are battling! Join in and show them what\'s right!',1,1,5,0,0,0,0,0,1,0,0,0,26124),
(16248,'Draenei have come back! This group jumped two of my best wolf riders as they were out patrolling the western roads. Needless to say, we were victorious in that skirmish.$B$BNow I\'m not sure what\'s going on but from what my scouts tell me, there are blood elves and draenei all over Halaa. I\'m no blood elf lover but if it\'s one thing I hate it\'s a draenei. If you see draenei or any of their allies at Halaa, be sure to put a boot in their backsides for me.$B$BHalaa\'s to the west... In case you want to go now.','Draenei have come back! This group jumped two of my best wolf riders as they were out patrolling the western roads. Needless to say, we were victorious in that skirmish.$B$BNow I\'m not sure what\'s going on but from what my scouts tell me, there are blood elves and draenei all over Halaa. I\'m no blood elf lover but if it\'s one thing I hate it\'s a draenei. If you see draenei or any of their allies at Halaa, be sure to put a boot in their backsides for me.$B$BHalaa\'s to the west... In case you want to go now.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(16249,'You won\'t escape alive!','You won\'t escape alive!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16250,'Kill them before they get away!','Kill them before they get away!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16251,'You know too much!','You know too much!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16252,'For Kael\'thas!','For Kael\'thas!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16253,'They mustn\'t escape!','They mustn\'t escape!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16254,'I will have your energy and then your life!','I will have your energy and then your life!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16255,'What can I do for you?','What can I do for you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16256,'What\'s your poison, $G boy:girl;?','What\'s your poison, $G boy:girl;?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16257,'What can I get you today, $r?','What can I get you today, $r?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16258,'Rough day? You need a drink,$G soldier:hon;.','Rough day? You need a drink,$G soldier:hon;.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16259,'','%s makes some strange gestures.',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(16260,'I wonder if they can fly?','I wonder if they can fly?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16261,'Why do they like rats anyways?','Why do they like rats anyways?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16262,'I wish I could live in a tree house.','I wish I could live in a tree house.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16263,'That bridge looks pretty scary.','That bridge looks pretty scary.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16264,'This is a good hiding spot.','This is a good hiding spot.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16265,'If I lived in a tree I would never come down to the ground.','If I lived in a tree I would never come down to the ground.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16266,'Why do they need bridges, can\'t they fly?','Why do they need bridges, can\'t they fly?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16267,'White rats are my favorite','White rats are my favorite',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16268,'That rat over there looks mean.  I wonder if it has rabies.','That rat over there looks mean.  I wonder if it has rabies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16269,'I had a rat once, but then my mom made me put it back outside.','I had a rat once, but then my mom made me put it back outside.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16270,'I like that brown rat over there.  HEY!  I think he waved at me!!','I like that brown rat over there.  HEY!  I think he waved at me!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16271,'','%s begins to summon in a Cabal Deathsworn!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16272,'Let\'s get outta here!','Let\'s get outta here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16273,'Ha ha ha!  Those rats must be real scared now!','Ha ha ha!  Those rats must be real scared now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16274,'I think the rats are after us!  Run!!','I think the rats are after us!  Run!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16275,'','%s begins to summon in a Cabal Acolyte!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16278,'','%s summons a Cabal Acolyte to his aid!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16279,'We\'re safe.  Let\'s rest a bit before we go back.','We\'re safe.  Let\'s rest a bit before we go back.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16280,'','%s summons a Cabal Deathsworn to his aid!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16281,'We made it!!','We made it!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16282,'Gross!  I think i might have stepped on a rat!','Gross!  I think i might have stepped on a rat!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16283,'I hope they don\'t tell on us.','I hope they don\'t tell on us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16284,'|cffffff00The Alliance has taken control of both beacons!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16285,'|cffffff00The Horde has taken control of both beacons!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16286,'Behold the power of the Light! Grace and glory to the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16287,'|cffffff00The Alliance Field Scout is now issuing battle standards.|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16288,'|cffffff00The Horde Field Scout is now issuing battle standards.|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16289,'We already have control of Twin Spire Ruins! Get out there and defend it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16290,'We already have control of Twin Spire Ruins! Get out there and defend it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16291,'This old draenei board has been refurbished by the Kurenai and is now used to post announcements and bounties.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16292,'Troops! Fall in!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16293,'Shadow Hunter Denjai uses this board to post important announcements and news of bounties on the foes of Zabra\'jin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16294,'We are graced to hear from our revered Grand Anchorite Almonen. Take a knee men.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16295,'Troops! Fall out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16296,'FRUIT VENDOR!!! Your cart is still in our way!  We will give you one more hour to move it from our area.  Do not test our patience anymore!','FRUIT VENDOR!!! Your cart is still in our way!  We will give you one more hour to move it from our area.  Do not test our patience anymore!',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(16297,'Does this fruit vendor not value his life? YOU ARE RUNNING OUT OF TIME FRUIT VENDOR!!','Does this fruit vendor not value his life? YOU ARE RUNNING OUT OF TIME FRUIT VENDOR!!',6,53,0,0,3,0,0,0,1,0,0,0,26124),
(16298,'HA!  I CRUSHED AN APPLE, FRUIT VENDOR!  THIS WILL NOT BE THE LAST!!','HA!  I CRUSHED AN APPLE, FRUIT VENDOR!  THIS WILL NOT BE THE LAST!!',388,0,0,0,0,0,0,0,1,0,0,0,26124),
(16299,'I have been observing your training, my young brothers and sisters.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16300,'I\'ve not seen a more well-trained group of soldiers in all my years.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16301,'The time has now come for you to face our enemies on the field of battle. As I speak our brothers and sisters fight to fend off the forces of Kil\'jaeden on the isle of Quel\'Danas.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16302,'The darkness in your souls draws you ever closer...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16303,'As you all well know, the path of our people has not been an enviable one. Blood elf and draenei alike have been tested.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16305,'Conflict and strife have been our constant companions for as long as any of us can remember.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16306,'For countless years, and across the faces of many worlds, draenei have yearned to better embrace the Light and put an end to the darkness. So too have our Scryer brethren held such ambition.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16307,'','I could have sworn I had more apples.  Grok!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16308,'At last my noble brothers and sisters, our time is at hand!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16309,'A moment ago, you knelt as recruits...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16310,'Now, with my blessing, you arise as true sons of the Light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16311,'Go forth my brothers, and may your light pierce the darkness! The Deceiver must be brought to justice!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16312,'','Huh? Did someone say something?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16313,'','Fruit?  Did somebody say they wanted fruit?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16314,'','What is that poor orc yelling about? Someone should see what is going on.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16315,'','Is someone calling for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16316,'Ahh, ya couldn\'t resist, could ya? Want to be better, stronger, faster? Each one of these amulets be guaranteed to do just what I say they be doin\'. Step up and buy one of these miraculous baubles! Cheap at twice the price!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16317,'I\'ll... take a look.','I\'ll... take a look.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16318,'Hey! Hey, $r! I be havin\' just the thing for ya. Ya ever see a tikbalang? Frightenin\' creatures. Prone to stealin\' ya away. What ya need is one of my tikbalang wards. Guaranteed to ward away all tikbalangs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16319,'Look over here, $c! I got somethin\' for ya. Just what ya need. It\'s soap, right... and it\'s on a rope! No offense, $G man:honey;, but yer a little ripe, know what I\'m sayin\'?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16320,'Ya look lovesick. Special someone be gettin\' ya down, eh? No worries, no worries. Ya get this medallion from me, ya wear it when ya see \'em, and they be all over ya, $G man:sweetheart;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16321,'Dangerous out there, innit? Know what ya need? Protection. I can help ya defy death itself! Ya wear this madstone \'round yer neck, see, and then ya be able to come back if ya find yerself in the spirit world! Just a quick jaunt to yer corpse and up ya come, fresh and new!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16322,'Amazing amulets! Incredible curios! The newfangled jewelcrafters be havin\' nothin\' on the tried and true mystical methods of ol\' Griftah! Improve yerself through these magical talismans for a bargain price!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16323,'C\'mere, $r. Ya don\'t want to be riskin\' yerself in a dungeon, do ya? Filthy work, and for what? Some worthless trinket? Nah, what ya need be one of my amulets. Guaranteed to work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16324,'Ya look tired, $c. I be havin\' somethin\' for ya. These amulets, they can help ya leap obstacles and swim through the rivers like ya be born to it. They energize the food ya be eatin\', makin\' yer wounds close before yer eyes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16325,'Thank you! Thank you! Thanks for that warm welcome.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16326,'Whoa!  Is all that applause for me?  Thanks for coming out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16327,'Thanks for coming out to see me!  I hope you are ready for a good time, because I am.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16328,'Hey folks, go easy on me... it\'s my first time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16329,'Are you ready to laugh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16330,'Fools.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16331,'Have you ever noticed that all those cute, orc kids look the same?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16332,'So this gnome tells a tauren that he\'s been to Molten Core.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16333,'Here\'s a good one, why do watermelons have water in them? ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16334,'It\'s too bad they don\'t stay cute.  There must be some rite of passage in the Barrens called, \"Climb ugly tree and fall out.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16335,'The tauren says, \"That\'s a load of bull.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16336,'Because they are planted in the spring!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16337,'Impersonation time!!  I call this, \"The Silly Tauren.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16338,'The comedian clears his throat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16339,'What\'s the deal with women?  I mean they are always like...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16340,'And then gnomes are even worse!  They are always saying stuff like...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16341,'Thank you! Don\'t forget to tip your waiters! Good night folks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16343,'Is it over already?  You\'ve been great folks.  Walk safely and have a good night.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16344,'You guys have been a great audience!  Have a good night!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16345,'Thank you everyone!  And keep clapping, there is a fly in here and one of you are bound to get it!  Good night!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16346,'Line up and crush these fools!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16347,'Form up! Let\'s make quick work of them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16348,'Well, it\'s time to take these comedic muscles elsewhere. Have a good night all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16349,'Get ready! This shouldn\'t take long...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16350,'Show them no quarter! Form up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16351,'One last impersonation.  It\'s tough, but let\'s see if you can guess who it is...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16352,'Lok-Narash! Defensive positions!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16353,'Hold the line! They must not get through!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16354,'Gakarah ma!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16355,'We must halt their advance! Take your positions!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16356,'Fighter down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16357,'Replacement, quickly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16358,'Next warrior, now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16359,'Fall in! Mok-thora ka!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16360,'Where\'s my support?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16361,'Next warrior, step up! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16362,'Join the fight! Agrama-ka!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16363,'Wake up, we\'re under attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16364,'Sleep on your own time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16365,'Get up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16366,'On your feet!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16367,'No time for slumber! Join the fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16368,'What time is it when an elekk sits on your fence?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16369,'Time to get a new fence!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16370,'My wife and I were happy for 23 years...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16371,'And then we met!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16372,'What do you call a broken boomerang?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16373,'A stick!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16374,'I love blood elf women.  Especially when they say stuff like this...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16375,'I\'ve heard that gnomes can grant wishes...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16376,'Well I wish they\'d go away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16377,'Check out the comedy stylings of Perry Gatner in just a few minutes!','Check out the comedy stylings of Perry Gatner in just a few minutes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16378,'I never met a tauren I didn\'t like...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16379,'To eat!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16380,'If you are ready to laugh, head over to the World\'s End Tavern!','If you are ready to laugh, head over to the World\'s End Tavern!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16381,'Now that the show\'s done, can someone run me through Scarlet Monastery?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16382,'Hey all!  So how long until the jokes spawn?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16383,'Thank you all for coming tonight.  Now put your hands together to welcome Shattrath\'s best, Perry Gatner!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16384,'Perry Gatner! What an act!  The cantina is open all night long, so please, stay and enjoy yourselves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16385,'Apparently my reputation with you people is hostile.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16386,'Can I get a buff? I\'m dying up here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16387,'Come on!  These jokes are epic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16388,'If I knew it was going to be like this, I\'d have worn my Greater Boots of Laughter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16389,'Wow!  The laughs don\'t drop very often here, do they?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16390,'I\'m not gonna lie to you, soldiers. We\'re getting our butts kicked out there! Now which one of you is orc enough to do something about it?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16391,'The warchief\'s put a price on Arazzius\'s head! As of right now, that no-good piece of demon refuse is enemy number one.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16392,'Yea, we got problems. I think that\'s crystal clear. The question is, what are we gonna do about it?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16393,'How many more of you grunts do I need to send back to mommy and daddy in a body bag before you grow a brain and realize that runnin\' head first into a Legion kill squad is suicide? And don\'t nod your thick skulls at me as if you know what I\'m talkin\' about!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16394,'Get used to it, girls. We\'re out here for the rest of our miserable lives as far as I\'m concerned. Welcome to Hellfire Peninsula, your new home.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16395,'INCOMING! Do not let them through! Focus fire! NOW, NOW, NOW!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16396,'Bow to the might of the Doom Lord! You stand no chance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16397,'Arzule will have this land in the name of our master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16398,'Warbringers hear my call! Strike down at our enemies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16399,'','Find a way to get me out of here, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16400,'Find a way to get me out of here, $c!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16401,'Training complete, sir. Our next batch of recruits are due shortly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16402,'%s roars!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16403,'Thank you sir, though I cannot accept your praise without acknowledging the assistance of our guest, Emissary Mordin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16404,'The techniques he has suggested have been most effective in preparing the troops.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16405,'By your leave, Lord Torvos. I must prepare the next troops for your review.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16406,'You\'re doing a fine job, Harbinger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16407,'Word from the front lines is that your recruits outperform all others in battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16408,'On the contrary, my friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16409,'With the intelligence you\'ve provided on the enemy and their tactics we\'ve gained a significant edge in the field.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16410,'The fighting remains fierce and costly, but your assistance has proven invaluable.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16411,'Dismissed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16412,'You give me too much credit, good sir. I regret we cannot be of more assistance in such perilous times.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16413,'This is welcome news indeed. I shall pass along your gratitude to our commanders back on Azeroth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16414,'','Welcome. Will you take your rest here, or perhaps a meal?',2,0,0,1,0,0,0,7,1,0,0,0,26124),
(16416,'Look upon what you have accomplished, soldiers! Even the Legion\'s most fearsome machines are no match for the Horde!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16417,'Let them see what we have done to their fel reaver!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16418,'We war so that our little ones may live to see a better tomorrow! And for them, we destroy the Burning Legion!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16419,'Send more, demons! We will destroy them as we have this one!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16420,'For the Warchief! For the Horde!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16421,'Faster, scum!  The Master won\'t be pleased if we don\'t find the Ata\'mal crystal he\'s after.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16422,'Greatfather Winter will leave presents for everyone under the tree in Ironforge. I can\'t wait to get mine!','Greatfather Winter will leave presents for everyone under the tree in Ironforge. I can\'t wait to get mine!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16423,'I hope I have a chance to visit with Greatfather Winter before Winter Veil is over.','I hope I have a chance to visit with Greatfather Winter before Winter Veil is over.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16424,'Dig faster, wretch!  Do not force me to show you the true meaning of pain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16425,'Do not stop!  I promise you a thousand deaths if you even think about putting down that pick!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16426,'What was THAT?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16427,'','We must discover what\'s behind the mystery of the giant crystal that fell from the heavens on Fallen Sky Ridge.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16428,'Sometimes the straightforward approach to a problem is the best.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16429,'Master, I have failed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16430,'If you\'re ever captured by the Legion, tell them \"Xar il romath da tidesbi.\" They will kill you instantly for insulting their god, saving you intolerable torture or worse...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16431,'I\'m on a bombing mission for Forward Commander To\'arch.  I need a wyvern destroyer!','I\'m on a bombing mission for Forward Commander To\'arch.  I need a wyvern destroyer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16432,'Impudent whelps, you only delay the inevitable. Where one has fallen, ten shall rise. Such is the will of Kazzak...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16433,'Time for fun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16434,'To arms!  The colossi attack!','To arms!  The colossi attack!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16435,'Wardens, defend the east entrance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16436,'All clear.  Looks like the colossi attack has been repelled.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16437,'Quake, mortals!  Quake and kneel before your destroyer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16438,'You dare interfere with the Master\'s endeavors?  You will pay, foolish mortal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16439,'Slay these intruders, filthy Dreghood!  I promise you neverending pain if you disobey me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16440,'Go, you little wretches!  Show these fools that our Master is not to be trifled with!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16441,'Do not even think of fleeing, Broken wretches!  I promise you a fate worse than death if you don\'t slay these intruders!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16442,'Thank you for freeing me, $n. Now let\'s get out of here!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16443,'','That\'s more like it! Let\'s get out of here!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16444,'Smokywood Pastures has set up shop in Orgrimmar and Ironforge. I wonder what they\'ll dream up this year?','Smokywood Pastures has set up shop in Orgrimmar and Ironforge. I wonder what they\'ll dream up this year?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16445,'Blonde hair, green skin, horn head, blue skin - all it means to us are new markets for our excellent goblin engineering! Even the prospect of another war against the Legion means more sales for us!','Blonde hair, green skin, horn head, blue skin - all it means to us are new markets for our excellent goblin engineering! Even the prospect of another war against the Legion means more sales for us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16446,'Troops! Fall out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16447,'The druids are holding a great celebration of Lunar Festival in Moonglade. If that\'s too far to walk, they\'re transporting people from the big cities.','The druids are holding a great celebration of Lunar Festival in Moonglade. If that\'s too far to walk, they\'re transporting people from the big cities.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16448,'Listen up Men!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16449,'Your training is now complete. You each have your assignments. May the Light guide you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16450,'We\'re here to protect Gadgetzan interests in Un\'Goro and that\'s none of your business.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16451,'','Hellfire Peninsula is a shattered realm - ruthless and unforgiving to its inhabitants. Be sure to repair and stock up on supplies before venturing out.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16452,'What do you have for sale?','What do you have for sale?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16453,'How many more soldiers need to die before we start paying attention out there?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16454,'Do you think that demons will play fair? These beasts are more savage than orcs and more cunning than the undead. Do not attempt to engage Legion by normal standards of war.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16455,'I regret to inform you all that we sent home another ten soldiers today - in body bags.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16456,'This war - and don\'t mistake this for anything but a war - is not going to win itself. If we do not fight, scratch, claw, and kick for every speck of land on this shattered world, all will be lost.','This war - and don\'t mistake this for anything but a war - is not going to win itself. If we do not fight, scratch, claw, and kick for every speck of land on this shattered world, all will be lost.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16457,'Keep your voice low and your eyes open, $n. We\'re surrounded by enemies out here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16458,'You must use the incendiary bombs at the barrels inside the internment lodges of Durnholde Keep. Once five bombs have been ignited and the diversion has been set, find Thrall in the basement prison of Durnholde and set him free. Follow him and make sure that he does not die!$B$BBrazen will fly you to Durnholde when you are ready.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16459,'I can take you to Durnholde directly, if that is your wish.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16460,'You should receive a pack of incendiary bombs from Erozion before I fly you to Durnholde. You wouldn\'t want to waste time, after all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16461,'I\'m ready to go to Durnholde Keep.','I\'m ready to go to Durnholde Keep.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16462,'Horrible... just horrible!$B$BWe were minding our own business on our way from Area 52 in Netherstorm and they shot us down!  I knew we shouldn\'t have taken that shortcut to get to Terokkar Forest!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(16463,'The goblins of Smokywood Pastures always have such wonderful treats for sale this time of year.','The goblins of Smokywood Pastures always have such wonderful treats for sale this time of year.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16464,'Greatfather Winter will leave presents for everyone under the tree in Orgrimmar. I wonder what he\'ll bring me this year.','Greatfather Winter will leave presents for everyone under the tree in Orgrimmar. I wonder what he\'ll bring me this year.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16465,'Legend says that the great beast Omen sleeps in the waters of Lake Elune\'ara in Moonglade, only to appear once a year. But that\'s just a legend.','Legend says that the great beast Omen sleeps in the waters of Lake Elune\'ara in Moonglade, only to appear once a year. But that\'s just a legend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16466,'During the Lunar Festival, we should take time to seek out our elders and consider their wisdom.','During the Lunar Festival, we should take time to seek out our elders and consider their wisdom.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16467,'Have you seen the fireworks? This is the best time of year to buy them.','Have you seen the fireworks? This is the best time of year to buy them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16468,'The druids of Nighthaven are holding a great celebration in Moonglade for the Lunar Festival.','The druids of Nighthaven are holding a great celebration in Moonglade for the Lunar Festival.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16469,'Forgive me... I have no choice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16470,'I will do as you ask, demon.  At least for now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16471,'Put me out of this misery!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16472,'Work these Broken wretches to the bones, Illidari!  If there\'s anything of value in this forsaken place we shall find it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16473,'Expedition Point is the Alliance\'s closest point of contact with the Legion Front. North of here is nothin\' but demon, demon and more demon. Travel with a buddy.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(16474,'Keep a close eye on this Broken scum!  Far too many have escaped from us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16475,'We will find what the Master is looking for!  Failure is not an option!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16476,'Do not allow these wretches a moment of rest!  If there\'s an Ata\'mal crystal here then we shall find it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16477,'Two sets of orders seem to have been hastily scribbled on this dispatch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16478,'The Dark Portal opens once again! What does it portend?','The Dark Portal opens once again! What does it portend?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16479,'The Burning Legion has returned! What can we do to stop them?','The Burning Legion has returned! What can we do to stop them?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16481,'The Illidari demons keep me here because of my knowledge of ancient draenei crystals and relics.$B$BThey\'ve enslaved many of my people and use us to look for a powerful crystal... one that in all likelihood is not even here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16482,'The draenei... it\'s almost too much to believe. But if they follow the Light, they can\'t be that bad.','The draenei... it\'s almost too much to believe. But if they follow the Light, they can\'t be that bad.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16483,'How could the elves betray us? We were never the greatest of friends, but joining the Horde?','How could the elves betray us? We were never the greatest of friends, but joining the Horde?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16484,'The Dark Portal coming alive? This can\'t be good.','The Dark Portal coming alive? This can\'t be good.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16485,'Why don\'t you escape?','Why don\'t you escape?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16486,'The Apothecary Society researches to find a cure against the plague of the Lich King..','The Apothecary Society researches to find a cure against the plague of the Lich King..',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16487,'What for?  If Illidan\'s demons don\'t catch me and enslave me again, then the naga of Zangarmarsh will.$B$BJoining Illidan and his allies has turned out to mean nothing but slavery to most of the Broken tribes.  There is no hope for my people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16488,'With the Lich King on the offensive, the Horde must respond in kind!  To Northrend!','With the Lich King on the offensive, the Horde must respond in kind!  To Northrend!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16489,'Sir, it appears that another of our special units have arrived.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16490,'Excellent. We must focus our efforts on the cleansing of Nagrand!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16491,'Understood, sir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16492,'Listen up, soldiers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16493,'You are here because you displayed exceptional aptitude and ability throughout your training period.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16494,'You are now to be dispatched directly into a hostile environment on a treacherous mission.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16495,'Nagrand, the land to the west, has recently become littered with enemy forge camps that threaten our security.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16496,'With the bulk of our forces focused on Illidan, the task of cleansing these lands falls to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16497,'You are to return in a week\'s time with a detailed report of your actions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16498,'May the Light be with you... Dismissed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16499,'Thrall startles the horse with a fierce yell!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16500,'I can\'t wait to see the newest goods from Smokywood Pastures.','I can\'t wait to see the newest goods from Smokywood Pastures.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16501,'Ah, the Winter Wondervolt. What will we think of next?','Ah, the Winter Wondervolt. What will we think of next?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16502,'Elves or draenei, just means more money for our engineers.','Elves or draenei, just means more money for our engineers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16503,'Where are all those wonderful winter hats coming from?','Where are all those wonderful winter hats coming from?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16504,'I\'ll never take another shortcut again, I swear! How was I supposed to know the skies over Hellfire Peninsula were that dangerous?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16505,'By your leave, sir, I have pressing matters to attend to.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16506,'Anchorite Nindumen, I have a request to make of you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16507,'We\'ve just sent another inexperienced squad into Nagrand. Might you offer a prayer for them?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16508,'Of course, Harbinger. Dismissed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16509,'I wonder why the sporelings live under the bridge?','I wonder why the sporelings live under the bridge?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16510,'Sporelings have pretty colors.','Sporelings have pretty colors.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16511,'My mom said that if I don\'t get enough exercise, I could end up looking like a sporeling.','My mom said that if I don\'t get enough exercise, I could end up looking like a sporeling.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16512,'Mom says not to feed the sporelings after midnight.','Mom says not to feed the sporelings after midnight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16513,'I wonder how Seth\'s mom is doing?','I wonder how Seth\'s mom is doing?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16514,'Nurse Mildred is real nice, she took care of my dad when he was hurt.','Nurse Mildred is real nice, she took care of my dad when he was hurt.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16515,'Sha\'nir said that I can help her when I get older.','Sha\'nir said that I can help her when I get older.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16516,'The dumb boys think this is a good hiding place.','The dumb boys think this is a good hiding place.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16517,'The boys like to hide here. I think they are afraid to actually climb the bridge.','The boys like to hide here. I think they are afraid to actually climb the bridge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16518,'I heard one of the boys say he wished he could live in a tree. I want to live in a tree too!','I heard one of the boys say he wished he could live in a tree. I want to live in a tree too!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16519,'There are so many cute, little rats!','There are so many cute, little rats!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16520,'I love their little whiskers!','I love their little whiskers!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16521,'Of course, my friend. How can I be of service to you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16522,'Those smelly boys love scaring the poor, cute, little rats.','Those smelly boys love scaring the poor, cute, little rats.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16523,'Those boys always come over here and cause trouble and scare the poor, little rats.','Those boys always come over here and cause trouble and scare the poor, little rats.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16524,'A noble request. It would be an honor, Erothem.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16525,'I taught one of the rats to wave.','I taught one of the rats to wave.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16526,'My friends, please join me in humble supplication to the Light.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16527,'I wonder where the baby is?','I wonder where the baby is?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16528,'Look, one of the eggs hatched!','Look, one of the eggs hatched!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16529,'I want to see the baby!','I want to see the baby!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16530,'A baby arakkoa must be the cutest thing ever!','A baby arakkoa must be the cutest thing ever!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16531,'Light that we embrace, we beseech thee...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16532,'','Hurry up with that axe, you! I want it sharp enough to cut the wind!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16533,'Into our struggle against the darkness we have sent our children.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16534,'Please bless and protect them, and grant them success over those who seek to do us harm...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16535,'Continue to bless this, our ancient home, we beg.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16536,'Bless us with tolerance for our elven visitors.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16537,'By the Naaru, may it be so.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16538,'','If you\'re no good at fixing, we\'ll see if you\'re good for eating. Now WORK!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16539,'','He\'s sort of a cute little thing, really. I think I\'ll keep him.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16540,'I don\'t understand you!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16541,'Please don\'t beat me!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16542,'You know, this is really sort of exciting me.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16543,'Show me where the Winter Veil celebration is happening.','Show me where the Winter Veil celebration is happening.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16544,'May it be so.','May it be so.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16545,'Marshals... brothers and sisters of the sword.  I\'d rather fight alongside you than any army of thousands.  We are lions!  You know what\'s waiting through these demons and beyond that Dark Portal?  Immortality!  Take it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16546,'Let us therefore brace ourselves to our duty, and so bear ourselves, that if the Humans of Azeroth last for a thousand years, men will still say, \'This was their finest hour.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16547,'It is time for us as kingdoms and as individuals to set aside our long-standing feuds and unite. The tides of an unwinnable war are upon us, and we must seek refuge on higher ground, lest we be swept away by the flood of darkness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16548,'Yes. Fight and you may die. Run and you will live, but for how long?  The devils are upon us!  And those not here, dying in their villages weeks from now, would they be willing to trade all the days from this day to that, for one chance to come here and stop these horrors from invading our world?\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16549,'Everyone fights.  No one quits.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16550,'Hold your ground! Hold your ground! Sons of the Alliance!  Of the Horde! My brothers and sisters!  I see in your eyes the same fear that would wither my own heart. A day may come when our courage fails, when we forsake our friends and break our fellowships... but it is not this day.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16551,'This day we fight!! By all that you hold dear in these good lands, I bid you stand, heroes of Azeroth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16552,'We few, we happy few, we band of brothers and sisters.  For those today that shed their blood with me, Shall be my kin; be they never so vile, This day shall gentle their conditions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16553,'And those in Azeroth now a-bed shall think themselves accursed they were not here,  And hold their valor cheap whiles any speaks that fought with us upon this dark day.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16554,'Work faster! We need these catapults ready for an attack!','Work faster! We need these catapults ready for an attack!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16555,'Salvage what you need from the broken catapults!','Salvage what you need from the broken catapults!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16556,'The next one of you peons that messes up will spend a night patrolling the cursed perimeter!','The next one of you peons that messes up will spend a night patrolling the cursed perimeter!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16557,'If I see any lazy peons here, I\'ll load them into a catapult and launch them off to the Black Temple!','If I see any lazy peons here, I\'ll load them into a catapult and launch them off to the Black Temple!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16558,'Keep up the pace!','Keep up the pace!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16559,'Any time any of you peons want to take a break, the graveyard is right over there.','Any time any of you peons want to take a break, the graveyard is right over there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16560,'Sir, I am here to deliver my report from the Scryer\'s Tier.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16561,'Sir, it\'s impossible to read anything into their actions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16562,'Their movements are totally chaotic, as if they themselves know not what they are about.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16563,'My apologies, sir. I wish I had more to report.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16564,'As you command, sir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16565,'Well, out with it, neophyte...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16566,'It is exactly as I expected, soldier. They know we watch them closely.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16567,'They mask their intentions with meaningless movements to confuse us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16568,'In time, you may learn to see through their deceptions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16569,'Until then, your presence at your post will keep them on their toes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16570,'Harder! Faster! Stronger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16571,'At this rate you will not survive.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16572,'Worthless!  You are completely worthless!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16573,'INFERNAL RAIN ON THE RISE! TAKE COVER!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16574,'INFERNALS! CLEAR THE COURTYARD!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16575,'WE\'RE UNDER ATTACK! RUN FOR COVER!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16576,'Tear it down, soldiers! We\'re shippin\' this thing back to Stormwind!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16577,'We\'re gonna melt this hunk of junk down and make weapons with the ingots! Let\'s see how the Legion likes a taste of fel reaver served up Alliance style!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16578,'Well done, soldiers! We weren\'t about to let the filthy animals of the Horde show us up!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16579,'Let them throw another one of these overgrown tin cans at us! We\'ll show them what the Alliance is made of!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16580,'The comedian impersonates a tauren.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16581,'The comedian impersonates a gnome.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16582,'The comedian impersonates a blood elf.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16583,'The comedian impersonates a human female.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16584,'The comedian impersonates an orc.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16586,'Bron! \'Ey, Bron! Hit me!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16587,'%s blinks, a perplexed expression crossing his face.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16588,'What, with me fists?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16589,'Nae, that\'s fer wimps. Hit me with yer hammer!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16590,'I\'m... not sure that\'s a good idea, \'Moke. Ye might get hurt...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16591,'DO IT, YE PANSY!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16592,'Er... \'Moke?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16593,'...THAT WAS GREAT!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16594,'Hungarfen roars in pain. ','Hungarfen roars in pain. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16595,'<A soothing light fills you as you approach the naaru.  Slow musical chimes echo within your mind and, though a word is not uttered, you feel an assurance of safety.  You are welcome in Shattrath City.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16596,'Alright now, let\'s get those rifles sighted in...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16597,'Move along unless you\'ve got business with the fleet.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16598,'Tell me about light bombs and carpet bombing.','Tell me about light bombs and carpet bombing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16599,'Carpet bombing refers to dropping a very large number of bombs on an area, essentially carpetting the region with bombs.$B$BBombers often use several light bombs on a region and then use heavy bombs to clean up whatever might still be standing.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(16600,'Carpet bombing is for me. I\'m ready to fly!','Carpet bombing is for me. I\'m ready to fly!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16601,'Tell me about something else.','Tell me about something else.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16602,'Tell me about heavy bombs.','Tell me about heavy bombs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16603,'When you absolutely, positively must kill NOW, the heavy bomb is the way to go. Heavy bombs have a much larger radius and cause much more damage. The downside is that you can carry far fewer heavy bombs than you can light bombs and you must wait longer between uses.\n','',275,1,273,0,0,0,0,0,1,0,0,0,26124),
(16604,'I\'m the heavy bomb master. Send me up!','I\'m the heavy bomb master. Send me up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16605,'Uhh, whoops...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16606,'...at least we know my rifle is sighted properly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16607,'Soldier...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16608,'You DO know that marksmen are issued blanks for practice drills, right?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16609,'Clearly, this group is not ready for weapons exercises.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16610,'Fall in for some marching practice! Let\'s see if we can manage to walk without suffering any casualties...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16611,'Spare a copper, $G sir:madam;?','Spare a copper, $G sir:madam;?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16612,'Hey, $G man:lady;? Got some money?  I got five kids to feed!','Hey, $G man:lady;? Got some money?  I got five kids to feed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16613,'Please don\'t ignore us...','Please don\'t ignore us...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16614,'Any spare copper?','Any spare copper?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16615,'Send me to the Abyssal Shelf!','Send me to the Abyssal Shelf!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16616,'Hunters, to me! Let us show these demons what it is to fight and die in Azeroth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16617,'The spirits sing to us!  They sing the song of battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16618,'Strike true, brothers and sisters!  Today our quarry is demons!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16619,'Defenders of the Argent Dawn!  We are with you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16620,'Once again, we will show this Burning Legion that our world is not for the taking!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16621,'These fiends will fail!  For Azeroth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16622,'If it is our fate to die this day, then we will not go easy!  Mark me, these demons will fall like wheat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16623,'Fight on, and let our ancestors see the bravery and strength we hold!  Today our hunt is for them, and for our world!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16624,'Though your sinews tire and your blood flows from cuts and wounds to this sodden ground, you fight for the spirits of your world.  No evil force can stand against us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16625,'Soldiers of Azeroth, you now fight against the vile Burning Crusade.  And the hopes and prayers of all Light-loving people march with you.  In the company of our brave allies and brothers-in-arms you will hold your ground and break this demonic charge.  You will stem the destructive tyranny that rages across so many worlds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16626,'We shall take up this grim task in high spirits, and be sure that our cause will not be suffered to fail.  Welcome the aid of your brethren, and of your once heated foes - let us all go forward together with our united strength, and know victory this day!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16627,'The demons should be in no doubt that we are their nemesis and, though they wish our destruction, it is we who will bring about their ruin.  Kazzak and his forces will be diminished and defeated by this coalition.  And to do this, we must throw at them our bodies and hearts, for they seek no less than the obliteration of this world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16628,'The strength, the wisdom, the unending endurance of the peoples of Azeroth inspires those beyond your reckoning.  On this day, this day of blood and terror, I see that yours is a world of heroes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16629,'The demons, our old foes from eons passed, once again show their beastly visage.  But do not falter, for fear is one of their many weapons.  And a weapon most deadly it is.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16630,'Strength!  My new brothers and sisters!  Beat back these devils for the sake of your world.  Hold here, and your friends and allies will come and weigh their swords with you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16631,'Yes!  Hold your feet firm!  Lend aid to your cohorts and together our banded strength will overcome these demons!  Cling fiercely to hope and grip tightly your weapons, and trust that the Light will pierce this darkness and shine through to morrow\'s dawn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16632,'Fight on!  Fight on!  And know that blood shed this day mingles with the blood of heroes.  Even in death, our spirits will know the victory of saving your kin and your world.  Do not succumb to despair, friends, for the demons against whom we face will surely take pleasure in it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16633,'With each passing moment, I see the people of Azeroth prove again the reasons we have come.  It is with solemn pride that I fight with you, and if I die this day, then I die among friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16634,'That was some pretty fancy prancin\' ladies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16635,'Now let\'s give shootin\' another try...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16636,'Get into formation and get those guns sighted in!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16637,'Carefully now, we don\'t need any more mista-','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16638,'Oh, that was cute...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16639,'We\'ll be marching all day if I see any more of that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16640,'In fact, let\'s see some more of that fancy walkin\'... Move it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16641,'Again, very nice strutting ladies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16642,'If we can\'t teach you to shoot, you\'ll have a career in the cantina to fall back on.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16643,'What\'s this? You\'ve shifted into an incorrect formation!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16644,'You are only to use the staggered formation just before atta-','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16645,'Enough messing around! There\'s a war going on here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16646,'%s begins to grow stronger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16647,'The surface of the %s begins to bubble.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16648,'What a good looking crowd. The dwarven women even shaved.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16649,'I just flew in from Ironforge and, Boy!, are my mount\'s wings tired!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16650,'I know what you\'re up to, and I mean to put an end to it, permanently!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16651,'Last week I was in Goldshire. Have you been there?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16652,'That town\'s so small, I asked a kid to draw me a map. He drew it on the back of a Defias wanted poster...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16653,'to scale!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16654,'She\'s a beaut\', isn\'t she? Sky\'ree... the faithful gryphon of our commander. Kurdran himself, he holds his audiences in th\' stronghold. I care fer our Sky\'ree here when he\'s busy. Gorgeous creature, she is; as strong and fierce as they come. She\'d die fer Kurdran, she would. A more loyal soul ye\'ve ne\'er seen.\n\n\'Tis an honor to care fer her, it is.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16655,'Goldshire\'s inn advertises a lakeside view...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16656,'I saw a murloc swim by my window.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16657,'How many kobolds does it take to change a lantern wick?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16658,'You no take candle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16659,'Time to bleed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16660,'Run, you blasted cowards!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16661,'Hey, it\'s Raliq the drunk... His momma\'s so fat, when she flies to Blade\'s Edge they charge her by the pound!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16662,'No more meddling for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16663,'You will not interfere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16664,'Thrall... must not... go free.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16665,'Look who\'s here, it\'s Raliq the drunk... His momma\'s so fat dragons won\'t eat her...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16666,'They don\'t know where to store the leftovers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16667,'Hey! Hey! Hey! It\'s Raliq the drunk... His momma\'s so fat she didn\'t just make the front cover of Ogre Today...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16668,'She made the back cover too!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16669,'The gnomes used to be a nice respectful people...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16670,'The other day I saw one walking down the street shouting, \"Once you go gnome, you never go home!\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16671,'Used to be you couldn\'t trust a goblin...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16672,'Who am I kiddin\'? If you trade with goblins you\'d better have iron plating in your coinpurse.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16673,'You\'re a slave! That\'s all you\'ll ever be!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16674,'I don\'t know what Blackmoore sees in you. For my money you\'re just another ignorant savage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16675,'Thrall will never be free!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16676,'Did you really think you would leave here alive?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16677,'Guards... guards!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16678,'Is it just me, or is the Horde about the ugliest enemy we could find?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16679,'Just so you guys don\'t feel left out, all I said was how attractive the blood elves are.  It loses something in the translation.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16680,'How desperate do you have to be for allies that you recruit your livestock?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16681,'I own a dog, but I\'m not giving him a sword.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16682,'So the blood elves think they\'re just one step away from ruling the world...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16683,'Twelve steps is more like it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16684,'WORK FASTER!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16685,'Work, you filthy swine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16686,'Put your backs into it, you lazy peons!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16687,'I want those catapults built YESTERDAY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16688,'Hurry it up! Work, WORK!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16689,'What we fire from this thing, anyway?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16690,'Me not know. The overseer, me hope!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16691,'Not so fast!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16692,'Struggle as much as you like...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16693,'You cannot fight fate!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16694,'You are... irrelevant.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16695,'Thrall will remain a slave. Taretha will die. You have failed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16696,'No! The master will... not be... pleased.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16697,'We are the true Horde!','We are the true Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16698,'For Kargath!  For Victory!','For Kargath!  For Victory!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16699,'Gakarah ma!','Gakarah ma!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16700,'The blood is our power! ','The blood is our power! ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16701,'Lok\'tar Illadari!\n','Lok\'tar Illadari!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16702,'This world is OURS!','This world is OURS!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16703,'Lok narash!','Lok narash!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16704,'Move those crates, peon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16705,'Heft those barrels!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16706,'Get the arms and armor shipments unpacked!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16707,'Peon! Unpack the food and medical supplies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16708,'For the Master!','For the Master!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16709,'Illidan reigns! ','Illidan reigns! ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16710,'Die, warmblood!','Die, warmblood!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16711,'By Nazjatar\'s Depths! ','By Nazjatar\'s Depths! ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16712,'My blood is like venom!','My blood is like venom!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16713,'Ugh...That hurt... Where are my friends?  I need to get back into the fight...','Ugh...That hurt... Where are my friends?  I need to get back into the fight...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16714,'Where do you think you are you going soldier?  Those are fatal wounds you\'ve got there.  Now, get back in that tent and let the nurse treat you!','Where do you think you are you going soldier?  Those are fatal wounds you\'ve got there.  Now, get back in that tent and let the nurse treat you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16715,'Sir!  If I don\'t get out there and fight for Azeroth, then why am I in this army? I enlisted to do a job, and I intend to see it through.','Sir!  If I don\'t get out there and fight for Azeroth, then why am I in this army? I enlisted to do a job, and I intend to see it through.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16716,'In Terokk\'s name!','In Terokk\'s name!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16717,'Protect the Veil!','Protect the Veil!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16718,'Darkfire -- avenge us!','Darkfire -- avenge us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16719,'Ssssekk-sara Rith-nealaak!','Ssssekk-sara Rith-nealaak!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16720,'Arak-ha!','Arak-ha!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16721,'What have the netherwinds brought us?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16722,'You\'re far from home, stranger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16723,'Welcome to the Void...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16724,'If you hear the whisper, you\'re dying...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16725,'Thank you for speaking to the men, Almonen. They\'ll be better for it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16726,'It would be an honor, Grand Anchorite.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16727,'Lieutenant General. The peons are working day and night to organize and ready the supplies from Orgrimmar. There is still much to be done, but we are an hour ahead of schedule.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16728,'Excellent. Continue your good work, Supply Master. Dismissed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16729,'My magical power can turn back time to before Thrall\'s death, but be careful. My power to manipulate time is limited.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16730,'Now get out of my way, it\'s time to send the Burning Legion back to the nether!!','Now get out of my way, it\'s time to send the Burning Legion back to the nether!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16731,'I have set back the flow of time just once more.  If you fail to prevent Thrall\'s death, then all is lost.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16732,'Friends... I\'ve failed you...','Friends... I\'ve failed you...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16733,'Your thanks are unnecessary, my friend. I consider it a privilege to speak to your recruits.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16734,'A\'dal has opened my mind to truths that I am to impart to our patrons today.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16735,'Friends, it is my great pleasure to welcome you to the temple today.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16736,'Sniff... That\'s the spirit soldier... I only wish we had more soldiers like you in this army.  Now go out there and give \'em hell!!','Sniff... That\'s the spirit soldier... I only wish we had more soldiers like you in this army.  Now go out there and give \'em hell!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16737,'NOOOOOOOOOO!!','NOOOOOOOOOO!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16738,'No my friend... we failed you... we failed you.','No my friend... we failed you... we failed you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16739,'NEVER AGAIN!! Next time some wounded soldier wants to return to the front line, I am putting my foot down.  I mean it this time.','NEVER AGAIN!! Next time some wounded soldier wants to return to the front line, I am putting my foot down.  I mean it this time.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16740,'A\'dal has been most generous in his revelations to me, a humble servant of the Light.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16741,'In accordance with my divine calling, I must share these revealed truths to all who would hear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16742,'It has been made known to me that inside each of us, the Light resides...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16743,'...that it is a gift, given freely to all naturally born beings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16744,'%s defends himself in desperation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16745,'You are welcome to remain in attendance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16746,'%s smells a fresh corpse nearby.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16747,'Oh! So sorry. How terribly embarrassing! I didn\'t realize... ah... please, lie down, get some more rest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16748,'Ah, Lieutenant General Orion. I\'ve come to report that casualties are well within acceptable levels for this operation. In fact, the wounded are quite... ah... lively.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16749,'Oh dear, Lieutenant General, how ghastly! I would most certainly never. I shall return to my charges, now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16750,'This is good news. Return to them, priest. But heed this: do not eat ANYONE.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16751,'AIEEE! What are you doing?! I\'m still ALIVE, damn you!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16752,'It manifests itself as a feeling, small at first and easily ignored, that confirms truths and subtly prods one to do good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16753,'Simple kindnesses, charitable deeds, service to those in need. These are all fruits of the Light.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16754,'It rewards those who heed its promptings with blessings, both seen and unseen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16755,'Personal reservoirs of hope and faith are strengthened, and one\'s capacity for greater light increases.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16756,'Over the course of time, through obedience to the Light\'s guidance, one becomes more sensitive to its voice, and its power.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16757,'Great is the healing and blessing power of the Light\'s most diligent followers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16758,'Come on!  Our boys are out there and they need these supplies ready!','Come on!  Our boys are out there and they need these supplies ready!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16759,'Keep up the pace boys!  We need these supplies moved and weapons fixed!','Keep up the pace boys!  We need these supplies moved and weapons fixed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16760,'Let\'s pick up the pace!  These ballistas aren\'t going to fix themselves!','Let\'s pick up the pace!  These ballistas aren\'t going to fix themselves!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16761,'Sadly, there are those who wander through mortality in defiance of the Light.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16762,'From these the Light withdraws, until only darkness remains.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16763,'Where there is no light, despair, loathing and rage thrive.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16764,'We are born into a perilous age, where the forces of darkness are determined to bring about our destruction.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16765,'These are the times to find yourselves in unison with the Light.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16766,'Hear my words, and let the Light inside of you confirm the truth of them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16767,'Light, give me strength.','Light, give me strength.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16768,'We humbly entrust our fallen brothers and sisters into the Light.  In this life you embraced them with your tender love; deliver them now from every evil and bid them enter eternal rest.','We humbly entrust our fallen brothers and sisters into the Light.  In this life you embraced them with your tender love; deliver them now from every evil and bid them enter eternal rest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16769,'Light, lead the fallen from untruth to truth, from darkness to Light and from death to immortality.','Light, lead the fallen from untruth to truth, from darkness to Light and from death to immortality.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16770,'Light be with you now and forever.','Light be with you now and forever.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16771,'%s\'s eyes glow red as he begins to cackle madly!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16772,'The priest kneels in silent prayer.','The priest kneels in silent prayer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16773,'Haven\'t you done enough harm?  Must you also disturb my slumber?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16774,'What good does this violence serve?  What is done is done.  I have failed my people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16775,'Embrace the light that is in you, my friends! Deny yourself all darkness...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16776,'We must endure these trying times faithfully, and one day we will find ourselves victorious.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16777,'It falls upon us to usher in an age of peace, where the Light will reign.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16778,'By the naaru, may it be so.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16779,'May it be as you say, Grand Anchorite.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16780,'May it be so.','May it be so.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16781,'You are spotted by the %s!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16782,'%s attempts to bind the spirit of his fallen comrade.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16783,'Do as I say, Fly!','Do as I say, Fly!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16784,'Protect the Botanica at all costs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16785,'Any intruders must be eliminated!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16786,'Kael\'thas will save us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16787,'The time has come! Gul\'dan, order your warlocks to double their efforts! Moments from now the gateway will open and your Horde will be released upon this ripe, unsuspecting world!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16788,'You will rest with the honored dead.','You will rest with the honored dead.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16789,'What is this? Champions... I sense the hand of the Dark One. Truly this sacred event bears his blessing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16790,'No! Damn this feeble, mortal coil!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16791,'You have chosen death.','You have chosen death.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16792,'Champions! My shield grows weak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16793,'You will pay for this violation.','You will pay for this violation.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16794,'My powers must be concentrated on the portal! I do not have time to hold the shield!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16795,'The shield is nearly gone! All that I have worked for is in danger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16796,'I am grateful for your aid, champions. Now, Gul\'dan\'s Horde will sweep across this world like a locust swarm, and all my designs, all my carefully-laid plans will at last fall into place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16797,'Shhh! The spirits are sleeping!','Shhh! The spirits are sleeping!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16798,'Ruin finds us all!','Ruin finds us all!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16799,'In Sargeras\' name!','In Sargeras\' name!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16800,'The end comes for you!','The end comes for you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16801,'I do as I must!','I do as I must!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16802,'The Legion reigns!','The Legion reigns!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16803,'I shall be rewarded!','I shall be rewarded!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16804,'A cool breeze caresses your face. Gentle, melodic humming resonates throughout the chamber.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16805,'This world shall burn!','This world shall burn!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16806,'Greetings, traveler, I wish to thank you for lifting the exarch\'s hold. Ah, A\'dal has sent you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16807,'The end is come!','The end is come!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16808,'Embrace the Nothing!','Embrace the Nothing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16809,'Pathetic worm!','Pathetic worm!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16810,'None can stand against the Legion!','None can stand against the Legion!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16811,'I\'ll feast on your soul!','I\'ll feast on your soul!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16812,'You shall not escape.','You shall not escape.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16813,'The only justice is death!','The only justice is death!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16814,'Why do you aid the Magus? Just think of how many lives could be saved if the portal is never opened, if the resulting wars could be erased....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16815,'If you will not cease this foolish quest, then you will die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16816,'Time... is on our side.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16817,'You have outstayed your welcome, Keeper. Be gone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16818,'I told you it was a fool\'s quest!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16819,'Leaving so soon?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16820,'Group one, load up and take your positions!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16821,'Why do you persist? Surely you can see the futility of it all. It is not too late! You may still leave with your lives...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16822,'So be it... you have been warned.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16823,'My death means... little.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16824,'Keeper! The sands of time have run out for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16825,'You should have left when you had the chance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16826,'Your days are done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16827,'The time has come to shatter this clockwork universe forever! Let us no longer be slaves of the hourglass! I warn you: those who do not embrace this greater path shall become victims of its passing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16828,'Let us see what fate has in store....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16829,'Your time is up, slave of the past.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16830,'We will triumph. It is only a matter... of time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16831,'One less obstacle in our way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16832,'No one will stop us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16833,'Fire at will!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16834,'Units, cease fire! Group two, lets see if you can do any better...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16835,'What... What have I become? Arrrgghhh...','What... What have I become? Arrrgghhh...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16836,'Thank you...','Thank you...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16837,'The cold embrace awaits...','The cold embrace awaits...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16838,'It comes for you...','It comes for you...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16839,'It cannot be...','It cannot be...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16840,'What is this trickery? I... ARGH...','What is this trickery? I... ARGH...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16841,'Ancestors watch over you, kind one...','Ancestors watch over you, kind one...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16842,'I\'ve seen enough. If I were you, I\'d get to the temple and pray that you shoot straighter when it counts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16843,'%s attempts to flee to a nearby ravager.','%s attempts to flee to a nearby ravager.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16844,'','What did Garrosh tell you, $n?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16845,'Garrosh is beyond redemption, Greatmother. I fear that in helping the Mag\'har, I have convinced Garrosh that he is unfit to lead.\n','Garrosh is beyond redemption, Greatmother. I fear that in helping the Mag\'har, I have convinced Garrosh that he is unfit to lead.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16846,'','This can\'t be. He can\'t just give up like this. Why has he asked that you take his place as warchief?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(16847,'Greatmother, he tells me that the Mag\'har all love, honor, and trust me. He states that with me as warchief, he will be free to die when you pass, erasing his bloodline from existence.','Greatmother, he tells me that the Mag\'har all love, honor, and trust me. He states that with me as warchief, he will be free to die when you pass, erasing his bloodline from existence.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16848,'','<Greatmother Geyah nods, accepting your answer.>$B$BI can no longer fight the spirits, $n. My time has long since passed. Once again, I must thank you for all that you have done. While Garrosh may be unmovable, many of my people have been lifted by your accomplishments. They are now willing to fight for our rights as a united clan.',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(16849,'I have done all that I could, Greatmother. I thank you for your kind words.','I have done all that I could, Greatmother. I thank you for your kind words.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16850,'','<Greatmother Geyah smiles at you.>$B$BYou remind me of my son, $n.$B$BHe was an immovable mountain: A pillar of strength and honor.$B$B<Geyah\'s eyes well up with tears.>$B$BHe sacrificed himself so that we could survive. So that generations of orcs after him could be born into a world without the blood curse... Without Gul\'dan and his dark Horde...$B$B<Geyah stares into the distance, lost in thought.>$B$BOh Durotan, how I wish you could be here. Your people so desperately need you...',1,0,18,0,0,0,0,0,1,0,0,0,26124),
(16851,'Greatmother, you are the mother of Durotan?','Greatmother, you are the mother of Durotan?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16852,'','<Greatmother Geyah nods.>$B$BDid you know my son?',273,6,0,0,0,0,0,0,1,0,0,0,26124),
(16853,'Greatmother, I never had the honor. Durotan died long before my time, but his heroics are known to all on my world. The orcs of Azeroth reside in a place known as Durotar, named after your son. And... <You take a moment to breathe and think through what you are about to tell the Greatmother.>\n','Greatmother, I never had the honor. Durotan died long before my time, but his heroics are known to all on my world. The orcs of Azeroth reside in a place known as Durotar, named after your son. And... <You take a moment to breathe and think through what you are about to tell the Greatmother.>\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16854,'','<Greatmother Geyah\'s violet eyes lock onto yours.>$B$BYes...',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(16855,'It is my warchief, Greatmother. The leader of my people. From my world. He... He is the son of Durotan. He is your grandchild.','It is my warchief, Greatmother. The leader of my people. From my world. He... He is the son of Durotan. He is your grandchild.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16856,'','<Tears stream down Greatmother Geyah\'s face.>$B$BI... I... Durotan survived to have a child? The child Draka told me of before they left... It was their greatest fear... To raise a child in this world. On the other side of that gate was their only hope. I dared not tell Durotan, but secretly, I begged the spirits to watch over them - to protect their child and to give them strength.$B$BI... I must see my grandchild. I must see him. Please, I am too weak. You must tell him. Before I leave this world...\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16857,'I will return to Azeroth at once, Greatmother.','I will return to Azeroth at once, Greatmother.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16858,'Fool! You are a child playing in a world beyond your comprehension. Speak no more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16859,'Your weapons are nothing to me! Relent!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16860,'You have confidence in your skills? Think carefully as the answer may surprise you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16861,'','We must not fail our leader!  Kael\'thas will redeem us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16862,'What... a shame.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16863,'I had more fun torturing the peons!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16864,'I\'m already bored!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16865,'You lose.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16866,'Oh, just die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16867,'\'Netherstorm\' was not always as you see it now.$B$BThere was a time when this crumbling land was known as the Plains of Farahlon. Little of those days has survived the evil that has taken hold here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16868,'','$C, hold your attack, this is just a disguise!  I\'m a spy working for the Lower City coalition out of Shattrath City.$B$BI hope you\'re here to help!',5,1,0,0,500,0,0,0,1,0,0,0,26124),
(16869,'Archmage Vargoth enstrusted me with his staff when he told me to flee from the blood elf attack on Violet Tower. I did as he told me, hoping to take refuge in the old draenei settlement of Arklon.$B$BThere was to be no respite. I had walked right into the leading edge of a Burning Legion force. The demons wrested the staff from me, but I managed to escape with my life.$B$BThough my master knows nothing of my failure, it still shames me.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16870,'','With all due respect, A\'dal sent us here to investigate Kael\'s activities, not mount a full-scaled attack.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16871,'%s is unstable!','%s is unstable!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16872,'Look, sweetheart.  No one\'s talking about storming Tempest Keep ourselves, but when we see a target of opportunity we have to take it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16873,'Hold your tongue, knave!  Do not dare use that tone with a priestess of the Light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16874,'','I\'m surrounded by idiots!',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(16875,'','The magistrix will be happy to know  I\'m  fluent in Thalassian.  Your courtesy is not lost on me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16876,'','Back to the topic...  we should focus our attention on these manaforges.  We need to learn what the enemy is doing with them and why.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16877,'Need a heal over here!','Need a heal over here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16878,'Um, healer?!','Um, healer?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16879,'Need some help!','Need some help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16881,'','That\'s hot.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16882,'','Psshh... whatever.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16883,'','We\'ve told you all there is to know!  Do you forget that many of us used to be trusted followers of Kael\'thas?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16884,'I\'m on it!','I\'m on it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16885,'Incoming.','Incoming.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16886,'Hold on just a second.','Hold on just a second.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16887,'','That joke\'s hot.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16888,'','I, like, so don\'t get it...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16889,'...and just look at where that got us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16890,'Even you must admit that your information from defectors is outdated and unreliable.  Let us make calculated attacks on these manaforges and gather what information we can.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16891,'Finally some talk of action from the big guy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16892,'Less watching, more healing!','Less watching, more healing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16893,'Here it comes!','Here it comes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16894,'Well. Look what the netherwinds swept in. Come in, sit down, and rest yourself a spell. The fee is modest; you can surely afford it.','Well. Look what the netherwinds swept in. Come in, sit down, and rest yourself a spell. The fee is modest; you can surely afford it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16895,'We kill someone else!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16896,'I\'m not done yet, idiot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16898,'You stay here.  Me go kill someone else!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16899,'That\'s not funny!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16900,'Ha ha ha.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16901,'What are you doing?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16902,'Me get bored.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16903,'Bored? He was almost dead!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16914,'Do they never rest?!$B$BIf we\'re to secure a future for the people of the Lower City, we must deal with the Shadow Council before they cause an even greater cataclysm than the Bone Wastes!$B$BBecause the leadership of Shattrath City will not move quickly, we the free people of the Lower City have taken matters into our own hands.$B$BBut our spies have been discovered.  We will hold off the Shadow Council\'s agents while you slip into the labyrinth and see what you can uncover.','',5,1,1,0,500,0,0,0,1,0,0,0,26124),
(16915,'Long ago, in a dimension of the cosmos unfathomable to mortal minds, there was born - if such a term can be used for it - a being of such unbelievable power that its very entrance into existence shattered all reality around it.$B$BKnown only as Murmur, it was the essence of sound, and to hear it speak was to know death eternal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16916,'No, we will NOT let you live.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16917,'Hey!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16918,'Me hungry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16919,'You\'re always hungry.  That\'s why we so fat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16920,'You kill next one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16921,'I\'m tired.  You kill next one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16922,'This one die easy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16923,'That\'s because I do all the hard work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16924,'This all... your fault!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16925,'I... hate... you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16926,'Phew! There\'s my lucky hat. I\'ve been looking for it everywhere.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16927,'I can\'t possibly go out without my cloak. I hope it\'s in here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16928,'<Read on, if you dare...>','<Read on, if you dare...>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16929,'There it is! I could\'ve sworn it wasn\'t here last time I checked...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16930,'Existing only for chaos, its slightest whisper meant the destruction of whole worlds!$B$BYet still, there were those that would try to worship this mindless being.  There were even those more insane who dared to think to control it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16931,'I don\'t know what I was thinking, going out without my sword. I would\'ve put it on if I\'d seen it here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16932,'','I can\'t sleep without a good bedtime story. Now I\'m certain to rest well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16933,'Fight on, good people of Azeroth.  And take heart!  Your brethren rush to this hellish portal and will soon throw themselves at these demons as you have so bravely done.  May the Light keep you!','Fight on, good people of Azeroth.  And take heart!  Your brethren rush to this hellish portal and will soon throw themselves at these demons as you have so bravely done.  May the Light keep you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16934,'Argent Dawn! We go to gather more aid!  Fight on, brothers and sisters.  And know that you will not long fight alone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16935,'My brethren, my comrades-in-arms!  I must go to seek the forces of the Horde and direct them here!  Keep your spirits strong, brave hunters!  Do not fall to the portal-spawned fiends!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16936,'The musty pages of the codex seem to magically turn themselves, guiding your attention to a specific chapter past horrors no mortal eyes should ever perceive.$B$BThe book opens to a page that somehow feels \'right,\' yet so very wrong.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16937,'And lo, how the mighty fell trembling at its feet, fearful that it might direct its words upon them.$B$BBut still did these charlatans, these worshipping pretenders to a non-existent religion, rail against the inevitable in a vain attempt to control their \'god.\'  Uncaring, and likely not even noticing them, Murmur yawned and they knew oblivion.$B$BYet one somehow managed to survive, and in his insanity found a way to bring Murmur into the world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16938,'A mortal possessed of arcane and dark knowledge that none could surpass, he devised a method to enhance his summoning through the capture and use of souls untold.$B$BWhole civilizations were brought to extinction through his soul devices to fuel the ritual through which he and his conspirators would bring Murmur into their world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16939,'And summon forth Murmur they did.$B$BPowerful magics of containment and silencing were employed, held together by the constant supply of souls being fed into them.  Yet still they could not control the beast, could not bend it to their will.$B$BThese mortals began to devise different strategies, and one after the other they all failed.  And in so doing, they weakened the rituals, accidentally giving Murmur the slightest modicum of freedom.$B$BIt was all that was needed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16940,'Only this book survived the cataclysm that destroyed their world.  Those proud and foolish men who thought to control a cosmic being of untold power.$B$BWould you, the possessor of the codex, do the same?$B$BHave you devised a foolproof method to summon forth Murmur, or any of the other entities cautiously whispered of in these unhallowed pages?$B$BWe shall see.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16941,'Hey there!  Good to see a new face - I don\'t get many visitors and the technicians aren\'t very good conversationalists.$B$BI bet you\'re on your way to Area 52.  Am I right?','',1,6,0,0,500,0,0,0,1,0,0,0,26124),
(16942,'High Botanist?','High Botanist?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16944,'%s sighs.','%s sighs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16945,'...mumble...Petals of Fire...mumble...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16946,'...mumble mumble...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16947,'...thorny vines...mumble...ouch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16948,'...with the right mixture, perhaps...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16949,'What\'s this?  That can\'t be right!  Who built this bridge anyway?  Oh, we did.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16950,'Oh no!  Does this thing need ANOTHER recalibration?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16951,'This is the last time that I buy second-hand equipment from an ethereal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16952,'I hope those blood elves across the way don\'t think that I\'m spying on them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16953,'If this is right, we don\'t have long!  Oh well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16954,'The planets are aligned!  The second moon is in the house of ... now what was that house called again?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16955,'If I were smart, I\'d be selling this research for a seat on the rocket ship.  I have a feeling we\'re going to need to get out of here soon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16956,'Unbelievable!  I think I\'ve just discovered that everything does not orbit around the Outland.  No, that can\'t be right!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16957,'Rocket-Chief Fuselage, commander of B.O.O.M - the Braintrust of Orbital Operations and Mechanics - at your service.$B$BAre all systems go?!  It looks like the X-52 Nether-Rocket still needs a lot of work!$B$BCome on people... we\'re T-minus NEVER here!','',1,5,0,0,500,0,0,0,1,0,0,0,26124),
(16958,'','Welcome to the Allerian Stronghold, $n.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(16959,'','This is delicate work out here, you know?  It can\'t just be rushed, or something\'s likely to get broken.$B$BLike Fuselage\'s head!$B$BYou might be wondering about my bots?  I\'m always working on the Mk. I, and the Mk. II gained sentience for a split-second before his brain capacitor blew out and he went insane!$B$BI decided to skip III and IV, and went straight to the Mk. V - my pride and joy!',1,1,0,0,500,0,0,0,1,0,0,0,26124),
(16960,'Try to keep appraisal errors to a minimum.  I\'d hate to tell Gezhe we\'ve overpaid on another gem shipment this month.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16961,'Welcome my brothers! Bask in the glory of my power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16962,'Be careful among the ruins, $c. The Kirin Tor spirits you find there will not recognize you as a friend.$B$BThe custodian and I are the only ones whose spirits retained a strong enough tie to this place to preserve our full identities in death.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16963,'Kirin\'Var survived 20 long years and countless orc assaults, but it could not withstand the forces of Kael\'thas. A man who once called himself a member of the Kirin Tor murdered all of us, save one.$B$BArchmage Vargoth survived the attack, so Kael\'thas imprisoned him within the Violet Tower, warding it with a magic that forbids the passage of any of the Kirin Tor.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16964,'','Alright, Mk. I, that should just about do it.  Let\'s just flip your switch here...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16965,'','Oh no!  Will I ever get you working?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16966,'Please, sit and make yourself comfortable.','Please, sit and make yourself comfortable.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(16967,'Welcome to my inn, weary traveler. What can I do for you?','Welcome to my inn, weary traveler. What can I do for you?',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(16968,'%s begins to collapse!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16969,'Hey, did you read the bounty on this wanted poster?','Hey, did you read the bounty on this wanted poster?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16970,'This wanted poster says that they\'re offering gold to these so-called adventurers to go kill things.  Isn\'t that what we do?  I don\'t think I\'m being paid enough!','This wanted poster says that they\'re offering gold to these so-called adventurers to go kill things.  Isn\'t that what we do?  I don\'t think I\'m being paid enough!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16971,'This wanted poster has a bounty on bonelashers.  You think I should do that?','This wanted poster has a bounty on bonelashers.  You think I should do that?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16972,'The Bone Wastes!  I don\'t care what\'s being offered as a reward, I\'m not going into the Bone Wastes!','The Bone Wastes!  I don\'t care what\'s being offered as a reward, I\'m not going into the Bone Wastes!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16973,'%s summons his servants from the nether!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16974,'You want to go do the bounty off of this wanted poster after the shift is over?','You want to go do the bounty off of this wanted poster after the shift is over?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16975,'I don\'t know and I don\'t care.','I don\'t know and I don\'t care.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16976,'Is that wanted poster all that you\'re going to talk about today?','Is that wanted poster all that you\'re going to talk about today?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16977,'I\'m up to looking into that bounty after this shift.','I\'m up to looking into that bounty after this shift.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16978,'The bonelashers of the wastes are no laughing matter.  I hear they carry diseases!','The bonelashers of the wastes are no laughing matter.  I hear they carry diseases!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16979,'I could use the extra money.','I could use the extra money.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(16980,'War drums echo in the distance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16981,'I say we fire it. Cut the rope.','I say we fire it. Cut the rope.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16982,'Harumph! Coward.','Harumph! Coward.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16983,'You cut the rope. You have the knife.','You cut the rope. You have the knife.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16984,'You read wanted poster to Grek?$B$BGrek want to help!','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(16985,'Someone come read this wanted poster to Grek.  Grek can\'t read!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16986,'You know, I think we can hit Honor Hold from here.','You know, I think we can hit Honor Hold from here.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16987,'Ah! We can tell him Hagash stumbled into it and fired it accidentally!','Ah! We can tell him Hagash stumbled into it and fired it accidentally!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16988,'If General Krakork found out, he\'d eat us alive. Don\'t.','If General Krakork found out, he\'d eat us alive. Don\'t.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16989,'%s sighs.','%s sighs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16990,'I\'m blind, you stupid sow-spawn, not deaf. Don\'t even think about it.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16991,'Ten silver says I can hit Honor Hold with this boulder!','Ten silver says I can hit Honor Hold with this boulder!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16992,'Try it, and I\'ll fire you AND your ten silver over that wall.','Try it, and I\'ll fire you AND your ten silver over that wall.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(16993,'Get out of here, there are too many of them! Escape while you can!','Get out of here, there are too many of them! Escape while you can!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16994,'Help! Someone help us!','Help! Someone help us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16995,'','Hello, what business brings you here?$B$BThis is an orphanage for the children of Outland who have lost their parents and have no one else to look after them.$B$BPerhaps you are here because you are considering adoption?',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(16996,'At long last, I am home...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16997,'Forward! We march to Garadar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16998,'','Mark II, get your metallic behind back here this instant!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(16999,'','Yes. That did the trick.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17000,'','Hmm...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17001,'Ahh, another powerful traveler. The nether can be dangerous; you\'ll want the most potent spells at your disposal. I carry the finest reagents, common and exotic. Come, buy - you won\'t be sorry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17002,'The creatures of this place are strong, wayfarer. You\'ll need ample ammunition if you hope to survive. You\'re in luck - I am well-stocked with fine arrows, bullets, and throwing weapons. The price is reasonable, considering circumstances.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17003,'','Be careful in there and come back in one piece!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17004,'A tradesman, perhaps? You need look no further than I for supplies. My prices are quite fair, friend. These items were difficult to acquire, but what does the source matter, eh? You\'ll have what you need.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17005,'Who is he? He looks so familiar.','Who is he? He looks so familiar.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17006,'Are the rumors true? Does he truly carry the Greatmother\'s bloodline?','Are the rumors true? Does he truly carry the Greatmother\'s bloodline?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17007,'Could it really be? The son of Durotan?','Could it really be? The son of Durotan?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17008,'Has he come to lead us?','Has he come to lead us?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17009,'I have never felt such strength radiate from an orc. Is he... mortal...','I have never felt such strength radiate from an orc. Is he... mortal...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17010,'He carries the Doomhammer!','He carries the Doomhammer!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17011,'For the first time, I feel safe. I do not know you, stranger, but I know that I would lay down my life for you if only you asked.','For the first time, I feel safe. I do not know you, stranger, but I know that I would lay down my life for you if only you asked.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17012,'Son of Durotan... Grandson of Garad and Geyah... Bow your heads for a Warchief is among us...','Son of Durotan... Grandson of Garad and Geyah... Bow your heads for a Warchief is among us...\n',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17013,'I am unworthy, son of Durotan. We are all unworthy...','I am unworthy, son of Durotan. We are all unworthy...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17014,'','You\'re back!  Were you able to get all of the machines?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17015,'Stand proud, $g brother:sister;!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17016,'You honor me, $g brother:sister;.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17017,'It is I who is unworthy.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17018,'I stand before you only a boy in search of lost memories.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17019,'Hippogryph Master','Hippogryph Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17020,'Hmm... the readings on the gravimeteric distortions seem to have stabalized.  We did it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17021,'I\'m picking up trace amounts of chroniton particles.  Hmm, if we use a reverse phase inducer, while inverting our own chronosphere, we might be able to eliminate the particles. Of course, that means we need to build a chronosphere...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17022,'Interesting... it seems the nethertron emissions are on the rise using the gobo-sin curve scale.  Yet the energon particles are cubed...  ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17023,'My gadget can\'t get an accurate reading with all the quatum nether fluctuations.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17024,'Hmm... It seems that the syncotron unit we\'ve been using has had no noticeable effect on the gravimetric or gravitronic distortions in this sector.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17025,'Look around you, younglings. This is Draenor!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17026,'It is amazing. How could it have remained in this state, untouched by the world\'s destruction?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17027,'I wonder, does Oshu\'gun still stand... Oh the stories I could tell of the time before the darkness... So many wonderous memories...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17028,'I believe it was on this very land that a young Durotan, barely into adolescence, killed his first talbuk. Ah, I can still remember him recanting that tale for us at the springtime festival.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17029,'And on this very soil that we now touch, our greatest heroes once hunted.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17030,'They were best friends, you know. Durotan and Orgrim once ventured into the Terokkar forest, where they were almost killed by an ogre. If it were not for the draenei that saved them... It makes me sad to look back upon those days. Such terrible things we did to the draenei...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17031,'The old memories stir. They rush back to me as if propelled by the noble spirits of the air...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17032,'I am ready to die. Finally home, my spirit can be freed from this mortal shell.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17033,'We\'ve taken some strange readings from nether ribbons.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17034,'I\'ve got a preliminary report about the gravimetric disruptions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17035,'I have another reading from the nether.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17036,'My quad-corder has detected some anomolous readings from the nether anomolies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17037,'I think my gadget is broken, it did manage to pick up some unusual readings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17038,'You should take a look at these readings, they are unlike anything we\'ve seen before.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17039,'%s dons his wolf-fur vestments.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17040,'Let me see what you\'ve found.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17041,'Let\'s see what you\'ve got.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17042,'Give me a moment to look over these findings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17043,'I\'ll be the judge of that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17044,'Wolf spirit of the forest, hear me!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17045,'Well hand it over and let\'s see what you\'ve got!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17046,'Long ago, you were a companion to my people. We gave ourselves to evil and you were forgotten.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17047,'But we have returned, spirit! We have returned to honor you again. Favor us with your presence once more.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17048,'What\'s your pleasure?  Pull up a seat and knock one back.$B$BI\'m Boots, lead mixologist for B.O.O.M. and bartender extraordinaire!$B$BIf it\'s got kick, Ol\' Boots can give it to ya.','',6,1,0,0,500,0,0,0,1,0,0,0,26124),
(17049,'Oh my...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17050,'Fascinating.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17051,'%s howls in response to Malukaz\'s call.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17052,'Incredible!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17053,'Impressive... Most impressive.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17054,'Boots, what do you have back there that goes down smooth?','Boots, what do you have back there that goes down smooth?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17055,'May our bond with you never be broken again, spirit.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17056,'Great Gazlowe!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17057,'We\'ll need to collect more data to substantiate these readings.  Get back in there and collect that data.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17058,'We need to confirm this data, we don\'t want to rip apart any more of our facility.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17059,'According to these readings, we have nothing to fear.  At least nothing in the near future.  We\'ll need more data to be sure.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17060,'This data will be quite useful for Project Blue Book. Er, I mean, this will be great for my new look.  See if you can gather any more data.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17061,'Hmmm... this nether radiation could prove to be quite deadly.  But it could be even deadlier to  just ignore it.  I\'ll need some more readings to confirm this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17062,'Woot!  Here we go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17063,'Uh oh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17064,'I\'m ok, I\'m ok!  Ah well, back to the drawing board on that rocket fuel!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17066,'We have done it! Thrall would be proud.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17067,'Yikes!  Someone call the fire marshal!  Medic!!!  Is there a doctor in the house?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17068,'Grek, will you try out this new weapon oil Rakoria made?','Grek, will you try out this new weapon oil Rakoria made?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17069,'Grek try!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17070,'This oil no good for Grek! What Grek look like to you, some weakling in robes?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17071,'I\'m a doctor!  What seems to be the problem?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17072,'Oh!  Someone needs to get those fires out so I can get in there and save that goblin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17073,'','I never thought it would turn out to be mana oil! There\'s going to be plenty of demand for that, minus Grek, of course!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17074,'Right... let me in there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17075,'','Ship it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17076,'Everyone clear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17077,'Come on!  Clear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17078,'Dammit, Boots, I\'m a doctor not a priest!  Clear!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17079,'I\'ve got a pulse!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17080,'Hellscream! Blessed ancestors! He is the mirrored reflection of Grom, Drek\'Thar.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17081,'A pleasure!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17082,'Thanks...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17083,'','Are you the correspondent from the Gadgetzan Times? If you just follow me, I\'ll show you my experimental apparatus...$B$B<You tell the magus that you\'re not the reporter she\'s expecting.>$B$BOh, you\'re not? Well then, if you need reagents, find what you need and don\'t tarry. I\'m expecting someone.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17084,'Someone called?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17085,'I wish to browse your wares.','I wish to browse your wares.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17086,'%s expresses its approval.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17087,'Impertinent fool! You are no match for the servants of Prince Kael\'thas!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17088,'Radiation?!$B$BNo, you don\'t need to worry about that!  Sheesh, the things that people believe these days.$B$BSo, what do you think of our operations down here?  State of the art, baby!  You better believe it.','',6,1,0,0,500,0,0,0,1,0,0,0,26124),
(17089,'I have some left over.','I have some left over.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17090,'I lost my Crude Explosives. Do you have any left?','I lost my Crude Explosives. Do you have any left?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17091,'%s nods.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17092,'The memories rush back, Thrall.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17093,'For years I was convinced we were doing the right thing in Silvermoon - working to reach Outland so we could be reunited with Kael.$B$BHad I known what Kael\'thas had in store for us, I would\'ve stayed right in Falconwing Square.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17094,'There are two prominent bills tacked up on the board here; one from Papa Wheeler and one from Rocket-Chief Fuselage.$B$BPapa\'s looks like it\'s a wanted ad for a machine part.  The rocket-chief\'s has something to do with a bounty on the head of an immense mountain giant!$B$BThe details for both are provided in very small goblin handwriting, which is, of course, barely legible.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17095,'There are several prominent bills tacked up on the board here.$B$BHowever, the fine-print indicates that you\'re not quite ready for either of the tasks at hand.  You should definitely check back later!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17096,'I am sorry that I did not come sooner, young Hellscream. There is so much that I have to tell you about your father, but first you must tell me where I may find the Greatmother.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17097,'Where?  Where are the Shards!  You cannot hide them from us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17098,'We are honored by your presence, son of Durotan. The Greatmother awaits you at the hospice.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17099,'%s points towards the hospice.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17100,'I thank you, Garrosh. We have much to discuss when I return from my visit with the Greatmother.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17101,'','I have been expecting you, young one. Come closer - my eyes are not as sharp as they once were.\n',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17102,'Greatmother...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17103,'','Come closer, grandson. Sit by your Greatmother.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17104,'','Drek\'Thar, forever loyal to our people. Spirits bless you, old friend. This is your home too, please make yourself comfortable.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17105,'%s absorbs the fire energy of the attack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17106,'%s absorbs the frost energy of the attack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17107,'%s absorbs the nature energy of the attack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17108,'%s absorbs the shadow energy of the attack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17109,'%s absorbs the arcane energy of the attack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17110,'%s absorbs the holy energy of the attack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17111,'Thrall, you should go alone. Perhaps this old shaman can teach those farseers a thing or two.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17112,'I will be with the Lightning Sons should you require my services.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17113,'Greatmother...Am I...\n','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17114,'I can\'t believe that Papa Wheeler thinks he\'s going to dupe anyone into going out to Manaforge B\'naar!','I can\'t believe that Papa Wheeler thinks he\'s going to dupe anyone into going out to Manaforge B\'naar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17115,'Maybe I should gather up some other agents and head out there after this shift?','Maybe I should gather up some other agents and head out there after this shift?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17116,'Hmm, arcane annihilators are pretty tough.  I wonder if Papa Wheeler knows what he\'s asking for?','Hmm, arcane annihilators are pretty tough.  I wonder if Papa Wheeler knows what he\'s asking for?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17117,'We can\'t let a failing servo slow down the construction of the X-52 Nether-Rocket!','We can\'t let a failing servo slow down the construction of the X-52 Nether-Rocket!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17118,'Hey!  Come over here and take a look at this wanted poster.  You\'re not going to believe this!','Hey!  Come over here and take a look at this wanted poster.  You\'re not going to believe this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17119,'Good thing that we\'re surrounded by neighbors with excess machine parts.','Good thing that we\'re surrounded by neighbors with excess machine parts.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17120,'','Yes, you move like my son. You have his broad shoulders - ahh, and your mother\'s fierce eyes.\n',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17121,'','Are they...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17122,'They... did not, Greatmother. They were killed shortly after I was born. I never knew them. I was raised as a slave. To this day, I carry the name of Thrall.\n','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17123,'','There is no doubt - you are the heir of Durotan... my grandson. Draka told me she was with child before she and your father left our world, but I never dared dream that they would survive...\n',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17124,'They died honorably, Greatmother.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17125,'I never knew my father or mother. Orgrim told me many stories about them and their adventures on Draenor. He was my greatest teacher and dearest friend, Greatmother. He died a hero... They all died as heroes and for all of them, a song of honor remains.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17126,'','Thrall? You\'ve been a slave only to the past, grandson! But no more! When last I saw him, Durotan told me the name he would give his unborn son... He was... so proud...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17127,'But surely you heard, Greatmother.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17128,'He died our greatest hero. It was Grom who freed us all... I was by his side when he struck down Mannoroth and ended the curse forever.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17129,'','Blessed spirits! For twenty years, all we knew was that Grom was the first to drink from the cursed chalice and bring damnation down upon our people... It is the only truth his son, Garrosh has ever known.\n',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17130,'Shredders?!  They just won\'t cut it anymore.  They\'re so yesterday!$B$BIf we\'re going to build rockets - if we\'re going to get the X-52 off the ground - we need better tech!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17131,'','Grandson, will you... Will you tell Garrosh what you have told me about his father?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17132,'Tell him? Greatmother, that boy\'s father died so that all of us could live free of the blood curse. I will tell him nothing. I will show him! Show him and any that would doubt Hellscream\'s resolve exactly what Grom Hellscream did for all orcs!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17133,'Please excuse me, Greatmother. I will return soon.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17134,'Garrosh, son of Hellscream, your father lived and died as our greatest hero. Honor me by allowing me to show you what your father sacrificed so that we could live free of the demon\'s grasp.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17135,'As you wish, Thrall, son of Durotan.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17136,'Spirits give me strength! Take from my soul these old wounds and expose them for all to see! Let this child know his father! Let these people know their savior!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17137,'%s laughs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17138,'So predictable. I knew you would come. And I see you\'ve brought the mighty Hellscream.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17139,'His blood is mine, as is your whole misbegotten race.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17140,'%s roars in defiance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17141,'A worthy effort, but futile.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17142,'The boy believed you could be saved, but he didn\'t know what burns within your soul when in your heart, you know we are the same.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17143,'%s breaks free of the blood elf\'s control!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17144,'NOOOO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17145,'Soup\'s on, men! Eat up. We\'ve got a long day ahead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17146,'Alright, let\'s see what makes this tech tick!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17147,'The Long Tube Gadget Analyzer should tell me what I need to know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17148,'Fall in men! It\'s time to drill!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17149,'Ack, disintegrated!  I guess I had the power setting too high?  And it almost hit the Wheeler Mobile!  Yikes, don\'t tell him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17150,'Thrall... The blood haze has lifted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17151,'Grom\'s eyes go dim as the blood curse is lifted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17152,'The demon\'s fire has burnt out in my veins. I have... freed myself.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17153,'No, old friend. You\'ve freed us all...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17154,'I\'ve heard your name spoken only in whispers, mage.  Who are you?','I\'ve heard your name spoken only in whispers, mage.  Who are you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17155,'I am Khadgar, former apprentice to the fallen Guardian, Medivh. I\'m sure you\'ve heard his name before.$B$BIt was I who discovered that Medivh had been possessed by the Evil One, Sargeras - and that he had opened the Dark Portal between this world and Azeroth. Though I honored my Master, I was forced to slay him and put his tortured soul to rest.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17156,'I see.','I see.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17157,'I fought alongside Lord Anduin Lothar as we drove the Horde from our lands on Azeroth. As the heir of Medivh\'s legacy, I could do no less.$B$BWhen the call finally came to invade this grim world - and put an end to the orcs\' evil forever - I stepped forward along with my friends Turalyon, Alleria, Danath and Kurdran.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17158,'My comrades and I called ourselves the Sons of Lothar - in honor of the greatest, most selfless man we ever knew.  We gave our all to defeat Ner\'zhul and end his madness.$B$BAs this doomed world fell apart around us, we shattered the Dark Portal to prevent any further harm befalling our beloved Azeroth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17159,'Trapped in this broken wasteland, we did our best to survive. Over time we sensed that a new evil was closing in around us from the Twisting Nether.  More foul than the dark orcs - it was the Burning Legion itself that sought to take hold of this... Outland.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17160,'While my comrades held the line against the encroaching darkness, I used my magic to reach out into the Great Dark Beyond.  There, I sensed beings of immense Light - of unfathomable purity.$B$BIt was A\'dal and his naaru I had found. It was nothing short of a... miracle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17161,'<Khadgar grins to himself>$B$BI convinced A\'dal and his brethren to return here with me. I believe that only their power can drive the Legion from this universe. But as you will no doubt find - their power must first live in our hearts.$B$BTo combat the darkness, we must become beacons of their eternal Light.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17162,'Fierce retaliation for the defections were to follow.  Shattrath City came under unrelenting attack from Illidan and Kael\'thas.$B$BArmies of blood elves, naga and Broken, would pour into the city; only to be repelled by the might of the Sha\'tar.$B$BOne thing became clear to the naaru.  If they were to pursue the Legion, they would have to defeat Illidan first.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17163,'%s collapses.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17164,'For my entire life I have thought my bloodline cursed. I have lived beneath the shadow of my father\'s greatest failure.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17165,'Shattrath did not fall, as you can see.  To the contrary, the naaru known as Xi\'ri, led a successful incursion into Shadowmoon Valley - Illidan\'s doorstep.$B$BThere he continues to wage war on Illidan\'s armies with the assitance of the Aldor and the Scryers.$B$BThe two factions have not given up on their old feuds, however. Such is their animosity that they vie for the honor of being the ones sent to assist the naaru there.  Each day, that decision is made by A\'dal right here in Shattrath.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17166,'I hated him for what he had done. I hated him for the burden he left me. But now...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17167,'You have shown me truths that I would have never known. You and your allies have gifted me with something that cannot bear a price: Redemption. Thrall, redeemer of the Mag\'har, you honor me as none ever have...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17168,'On this day, a great burden has been lifted from my chest. My heart swells with pride. And for the first time, I can proudly proclaim who I am. I can finally unleash the fury in my heart.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17169,'I am Garrosh Hellscream, son of Grom, chieftain of the Mag\'har! Let the battle call of Hellscream give you courage and strength! Be lifted by my rallying cry.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17170,'News spread quickly of Shattrath City\'s victories.  Refugees from all previous wars and from the one that had begun anew begun to pour into the city.$B$BThe entire lower third of the city is inhabited by them now.  No one who seeks respite from Illidan is turned away, so you might run into an unsavory character or two there.  But for the most part, they\'re just ordinary people who had lost all hope and have now been given a new lease on life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17171,'Thank you, son of Durotan.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17172,'%s places a hand on Garrosh\'s shoulder.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17173,'You need not thank me, Garrosh. Your father was a brother to me. I would do anything for you and the Mag\'har. I must now return to the Greatmother.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17174,'It is for them, or rather for what they represent, that we fight.$B$BOutside these walls, these people\'s lives are forfeit.  The world as they know it... as we all know it, is threatened by Kael\'thas, Illidan and the Burning Legion.$B$BWithin these walls you will find the few that are willing to fight for that world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17175,'I have returned, Greatmother. Garrosh has found his heart and his fury.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17178,'Hmm...Frost, Fire, and Arcane defenses respond faster than Batch 7, but Nature defenses remain passive.','Hmm...Frost, Fire, and Arcane defenses respond faster than Batch 7, but Nature defenses remain passive.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17179,'I love the smell of nether in the morning.','I love the smell of nether in the morning.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17180,'It smells like...','It smells like...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17181,'...victory.','...victory.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17182,'This thing kind of reminds me of a Zed Power Nodule I once took half of Papa Wheeler\'s old garage out with.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17183,'What is it that you want, $r?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(17184,'Hail, Gezhe!  Seventeen more orders have been placed in the Hara\'samid Sector.  The markets of heavy veldarite have all but collapsed, as you predicted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17185,'By your leave, sir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17186,'Heraazi exports are on the rise, sir.  We\'ve already bribed the appropriate taxation officers and contraband will begin to arrive within days.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17187,'No word from the nexus-prince as of yet.  Rumors of a dispute with our clients in Netherstorm have begun to circulate.  Our Sodaraami backers speak of divesting.  We\'ve dispatched our top negotiators to dissuade them, sir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17188,'Xarodi sector markets have reopened, sir.  Sapphires of all sort are up.  Silver is down.  Gold is up.  Diamonds remain stable.$B$BOh, and your brother asks that you return the holocubes you borrowed last week.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17189,'Word from Netherstorm, sir.  Stop all bloodgem imports; client has reneged payments.$B$BThe nexus-prince will buy out our stock at full price as compensation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17190,'As expected.  Very well, dismissed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17191,'Nothing surprising there.  Come back with some real news, will you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17192,'Bribe who you must, but I need some inside information this week if I\'m to make a profit and keep your lot employed.  Off with you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17193,'Not really.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17194,'It is if I\'m not the one that\'s going to be sent in to test it... Otherwise, no.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17195,'What does that mean anyway? Ready? Can it ever be ready?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17196,'I\'m giving her all that I\'ve got, captain. I don\'t think she can take much more of this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17197,'I can\'t bang on this device any faster, captain! My wrapping is already beginning to unravel!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17198,'Will you stop asking that?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17199,'Why don\'t you pick up a hammer and start banging on these structures instead of asking us if it\'s done every 5 minutes?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17200,'I\'ve had just about enough of your incessant whining, captain. What are you even a captain of? I mean, the nerve!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17201,'Is that damned thing safe to go through yet?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17202,'Is it done yet? What is taking so damned long?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17203,'You know, we could easily replace you with goblins. Is that what you want???','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17204,'I can\'t believe you imbeciles went to school for this! Does anybody here know what they\'re doing?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17205,'I don\'t get paid enough for this nonsense.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17206,'Here goes nothing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17207,'This is gonna leave a mark...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17208,'If I make it through, I expect a pay raise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17209,'I made it! I made it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17210,'Alright, it looks safe. Get in there, engineer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17211,'%s runs his hands across his body to make sure everything is intact.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17212,'%s shrugs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17213,'%s shakes his head in disapproval.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17214,'Oh well, back to the drawing board.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17215,'I didn\'t like him much anyway. Too much talk, not enough \"do.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17216,'Damnit. How are we ever going to get through their security measures?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17217,'Nice going you incompetent morons! Another one of our engineers vaporized!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17218,'Thankfully, there\'s a steady stream of these fools chomping at the bit to get in here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17219,'What\'s an \"Ologist?\" A better question might be what isn\'t an \"Ologist.\" It means I study everything! In fact, I\'m so well versed in \"everything\" that I\'m guaranteed to be the most intelligent ethereal you\'ll ever meet - or your money back.$B$BApologies. That\'s the dealer in me talking...','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(17220,'I\'m neither slim nor shady. As a matter of fact, I find both references insulting.$B$BNow, get out of my sight before I plant my staff up your backside.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(17221,'Ah, I see you are a friend to the Consortium. Perhaps you would be interested in making a purchase?','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(17222,'Show me what you have for sale, \"Slim.\"','Show me what you have for sale, \"Slim.\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17223,'That Shaffar is a clever one. He\'s rigged the entrance with some sort of ward to prevent other ethereal groups from entering. We\'re working on breaking through his defenses so we can get in there and take what\'s ours. I\'ve got top ethereals working on this around the clock. We\'ll have it open any minute now. I can feel it...','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(17224,'I don\'t give a damn what Shaffar\'s ethereals have placed over the entrance to the Mana-Tombs. You will work until those wards are removed and the Consortium can move in safely and take what\'s rightfully ours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17225,'I don\'t pay you engineers exorbitant amounts of gold so that I can hear the words \"no\" or \"can\'t\" exit your wrappings. Bring that barrier down or you\'ll find yourselves working the energy reclamation line on X-17.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17226,'I\'m close to the edge, Morphalius. Another screw up and it\'ll be you running through that portal for Kaftiz\'s tests.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17227,'At ease, men.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17228,'%s checks to make sure his body is intact.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17229,'You made it! Well done, $r. Now if you\'ll excuse me, I have to get the rest of our crew inside.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17230,'%s expertly manipulates the control panel.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17231,'Let\'s not waste any time! Take anything that isn\'t nailed down to the floor and teleport directly to Stormspire! Chop chop!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17232,'The control panel shifts and rotates on its axis.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17233,'<Push a random button.>','<Push a random button.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17234,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17235,'The market sure looks busy today.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17236,'Look at those crazy kids running around.  Not a care in the world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17237,'What manner of creature is that?  Looks like a purple goblin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17238,'Do not burden A\'dal with mundane questions, $r.  This being\'s will is all that keeps our enemies from crushing this city.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17239,'Follow me, stranger.  This won\'t take long.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17240,'Shattrath was once the draenei capital of this world. Its name means \"dwelling of light.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17241,'Bravo! Bravo! Good show... I couldn\'t convince you to work for me, could I? No, I suppose the needless slaughter of my employees might negatively impact your employment application.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17242,'The Sha\'tar, or \"born from light\" are the naaru that came to Outland to fight the demons of the Burning Legion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17243,'Your plan was a good one, Sha\'heen, and you would have gotten away with it if not for one thing...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17244,'Never underestimate the other ethereal\'s greed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17245,'It wouldn\'t be long, however, before the city came under attack once again.  This time, the attack came from Illidan\'s armies. A large regiment of blood elves had been sent by Illidan\'s ally, Kael\'thas Sunstrider, to lay waste to the city.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17246,'This should\'t take very long. Just watch my back as I empty these nether collectors.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17247,'The blood elves laid down their weapons in front of the city\'s defenders; their leader, a blood elf elder known as Voren\'thal, stormed into the Terrace of Light and demanded to speak to A\'dal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17248,'Fantastic! Let\'s move on, shall we?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17249,'Looking at these energy levels, Shaffar was set to make a killing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17250,'The defection of Voren\'thal and his followers was the largest loss ever incurred by Kael\'s forces. And these weren\'t just any blood elves.  Many of the best and brightest amongst Kael\'s scholars and magisters had been swayed by Voren\'thal\'s influence.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17251,'That should do it...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17252,'Hrm, now where is the next collector?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17253,'The Aldor are followers of the Light and forgiveness and redemption are values they understand. However, they found hard to forget the deeds of the blood elves while under Kael\'s command.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17254,'Ah, there it is. Follow me, fleshling.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17255,'There can\'t be too many more of these collectors. Just keep me safe as I do my job.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17256,'What do we have here? I thought you said the area was secure? This is now the third attack? If we make it out of here, I will definitely be deducting this from your reward. Now don\'t just stand there, destroy them so I can get to that collector.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17257,'The attacks against Shattrath continued, but the city did not fall, as you can see. On the contrary, the naaru known as Xi\'ri led a successful incursion into Shadowmoon Valley - Illidan\'s doorstep.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17258,'We\'re close to the exit. I\'ll let you rest for about thirty seconds, but then we\'re out of here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17260,'Are you ready to go?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17261,'Ok break time is OVER. Let\'s go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17262,'Khadgar should be ready to see you again.  Just remember that to serve the Sha\'tar you will most likely have to ally with the Aldor or the Scryers. And seeking the favor of one group will cause the others\' dislike.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17263,'Oh really? And what might that be?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17264,'He was right, you know. I\'ll have to take that tag-line for my own... It\'s not like he\'ll have a use for it anymore!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17265,'Thanks and good luck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17266,'Show our guest around Shattrath, will you?  Keep an eye out for pickpockets in the Lower City.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17268,'When the Burning Legion turned the orcs against the draenei, the fiercest battle was fought here. The draenei fought tooth and nail, but in the end the city fell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17269,'The city was left in ruins and darkness... until the Sha\'tar arrived.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17270,'Let us go into the Lower City.  I will warn you that as one of the only safe havens in Outland, Shattrath has attracted droves of refugees from all wars, current and past.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17271,'They were drawn to the ruins of Shattrath City where a small remnant of the draenei priesthood conducted its rites inside a ruined temple on this very spot.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17272,'The priesthood, known as the Aldor, quickly regained its strength as word spread that the naaru had returned and reconstruction soon began.  The ruined temple is now used as an infirmary for injured refugees.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17274,'As the regiment of blood elves crossed this very bridge, the Aldor\'s exarchs and vindicators lined up to defend the Terrace of Light.  But then the unexpected happened.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17275,'As the naaru approached him, Voren\'thal kneeled before him and uttered the following words: \"I\'ve seen you in a vision, naaru. My race\'s only hope for survival lies with you. My followers and I are here to serve you.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17276,'The naaru accepted the defectors, who would be known as the Scryers; their dwelling lies in the platform above.  Only those initiated with the Scryers are allowed there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17277,'Many of the priesthood had been slain by the same magisters who now vowed to serve the naaru.  They were not happy to share the city with their former enemies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17278,'The Aldor\'s most holy temple and its surrounding dwellings lie on the terrace above.  As a holy site, only the initiated are welcome inside.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17279,'There he continues to wage war on Illidan with the assistance of the Aldor and the Scryers.  The two factions have not given up on their old feuds, though.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17280,'Such is their animosity that they vie for the honor of being sent to assist the naaru there. Each day, that decision is made here by A\'dal.  The armies gather here to receive A\'dal\'s blessing before heading to Shadowmoon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17281,'Good luck stranger, and welcome to Shattrath City.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17282,'','A newcomer to Shattrath!  Make sure to drop by later.  We can always use a hand with the injured.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17283,'Khadgar himself is showing you around?  You must have made a good impression, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17284,'Be mindful of what you say, this one\'s being shown around by Khadgar\'s pet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17285,'','Are you joking?  I\'m a Scryer, I always watch what I say.  More enemies than allies in this city, it seems.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17286,'Light be with you, $n.  And welcome to Shattrath.','Light be with you, $n.  And welcome to Shattrath.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17287,'We\'re rather selective of who we befriend, $n.  You think you have what it takes?','We\'re rather selective of who we befriend, $n.  You think you have what it takes?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17288,'<The image\'s head blurs as it turns to take in its surroundings.>$B$BIf you had seen the Plains of Farahlon, you wouldn\'t believe this is the same place. Mere months ago, these fields would not have looked out of place in Westfall.$B$BAll that is gone now, but how and why?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17289,'The land is in worse shape than I could\'ve imagined. If the damage continues at this rate, Farahlon -- err, Netherstorm will be nothing but cosmic gravel very soon.$B$BWhere will it stop, I wonder? Perhaps the better question is, \'will it stop?\'','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17290,'<The archmage\'s image seems to look through you, rather than at you.>$B$BRibbons and currents of arcane energy ebb and flow here as if the area is awash in a sea of magical power. Not even the first cataclysm caused this kind of damage.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17291,'I will have my revenge on Kael\'thas for this outrage against the Kirin Tor! He once walked among us as a brother, but we are brothers no more.$B$BThere will be a reckoning.$B$B<The archmage nods grimly, not relishing the prospect.>$B$BKael\'thas is more than a mere rogue mage. Once I am free from my tower, Ravandwyr and I will assist anyone who opposes him.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17292,'The orb behind me was once capable of glimpsing into the happenings on Azeroth.$B$BKael\'thas\'s curse changed all that, of course, but during our years of isolation many of the mages found solace in its images.$B$BSome scried to remember; some scried to forget. ','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17293,'If you\'ve been sent to kill me, please take a number and wait your turn.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17294,'<Archmage Vargoth favors you with a wry smile.>$B$BPlenty of room at the cursed Violet Tower.$B$BAny time of year, you can find me here.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(17295,'The night Kael\'thas leveled the village, I could do nothing to help. His magic had already sealed me in the tower, exacerbating my torment by forcing me to witness the deaths of my fellows.$B$BAnd still their voices are calling from far away, waking me up in the middle of the night. ','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17296,'Keep it down!  I don\'t want them to see me over here.$B$BOoh, this really burns me up!  Who do these ethereals think they are?$B$BThis is MY claim!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17297,'','Please leave me to my sadness.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17298,'Welcome back, $n.','Welcome back, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17299,'I wouldn\'t venture into the Scryer\'s Terrace if I were you, $n.  You are not welcome there.','I wouldn\'t venture into the Scryer\'s Terrace if I were you, $n.  You are not welcome there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17300,'','Father, give me strength to go on.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17301,'','Give me a sign... anything...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17302,'','Please, father, I do not have your strength. I cannot do this on my own. Please help me...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17303,'%s giggles.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17304,'%s nods.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17305,'%s smiles.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17306,'%s laughs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17307,'I\'ll tell her, Greatfather.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17308,'You promise?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17309,'Ok!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17310,'I will, Greatfather.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17311,'%s tugs on Clarissa\'s robe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17312,'Mommy, Greatfather says everything will be ok.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17313,'Don\'t cry, Mommy. Greatfather says not to worry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17314,'Mommy, Greatfather told me that he will watch over us and make sure we\'re ok.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17315,'','%s wipes the tears away.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17316,'','Oh sweetheart, grandpoppy has passed. It will be ok.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17317,'','I know it will be ok, baby.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17318,'','In the end, we will all be together, sweetheart.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17319,'','Mommy is going to make sure you\'re ok, baby.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17320,'','Mommy won\'t let anyone harm you, sweetheart.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17321,'Be silent! Damn you, spirits!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17322,'Throw me out of the priory, will they?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17323,'I\'ll show them... I\'ll show them all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17324,'No, spirit, I am afraid that they are all trapped inside - FOREVER! Now leave me be...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17325,'I broke a covenant? I BROKE A COVENANT? What about that fool exarch and his avatar?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17326,'The dead are not supposed to speak. Now be silent!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17327,'Why? WHY! Why was I \"gifted\" such a burden?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17328,'%s rummages through the bones.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17329,'It is good to see you again, $n.','It is good to see you again, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17330,'The Aldor welcome you, $n.','The Aldor welcome you, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17331,'May the Light guide you, $n.','May the Light guide you, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17332,'I would not venture further if I were you, $n.  You are not permitted above.','I would not venture further if I were you, $n.  You are not permitted above.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17333,'It would be to your benefit for you to stay away from our holy grounds, $n.','It would be to your benefit for you to stay away from our holy grounds, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17334,'You\'ll have to prove yourself to us before you\'re welcome here, $n.','You\'ll have to prove yourself to us before you\'re welcome here, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17335,'Psst, hey, $n.  Up here on the platform.  Hurry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17336,'I will not be taken so easily! Let the walls of this prison tremble... and fall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17337,'Lambs! Lemmings! All of them!','',1,1,5,0,0,0,0,0,1,0,0,0,26124),
(17338,'%s becomes unstable and begins to disintegrate!','%s becomes unstable and begins to disintegrate!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17339,'Wretched, meddling insects! Release me, and perhaps I will grant you a merciful death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17340,'Vermin! Leeches! Take my blood and choke on it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17341,'Illidan is an arrogant fool! I will crush him and reclaim Outland as my own!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17342,'Away, you mindless parasites! My blood is my own!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17343,'How long do you believe your pathetic sorcery can hold me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17344,'My blood will be the end of you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17345,'When Rocket-Chief Fuselage was asking for volunteers to help out with building the X-52 Nether-Rocket, I submitted my resume for the security division.$B$BUnfortunately, the only position that was left was chief engineer.  Lucky for me, I have Xyrol here to look over my shoulder.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17346,'I... am... unleashed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17347,'The Legion will consume you all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17348,'Not again! Not again...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17349,'Did you think me weak? Soft? Who is the weak one now?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17350,'Help!  A mana wraith!  It\'s come to avenge its brethren and steal back their essences!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17351,'Welcome, friend of the free people of the Lower City, but do not tarry long.$B$BThere are sounds of battle coming from within.  My compatriots could use your assistance!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17352,'If you become a friend of the Lower City, perhaps we can do business?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(17353,'Time to teach you a lesson in manners, little $g boy:girl;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17354,'Now I\'m gonna give you to the count of \'3\' to get out of here before I sick the dogs on you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17355,'1...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17356,'2...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17357,'Time to meet your maker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17358,'%s cracks his knuckles.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17359,'','Can you believe this ethereal technology?!$B$BI\'m sure glad they let me stay out here with them.  I\'m gonna learn a lot... and maybe get some of it for myself, too!',6,11,0,0,500,0,0,0,1,0,0,0,26124),
(17360,'Oh, come on!  First the mana wraith and now revenge from a stalker?!  No, you\'re not getting your mojo back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17361,'Alright, we give up! Don\'t hurt us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17362,'Unbelievable!  Anyone else want to attack?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17363,'%s falls unconscious.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17364,'Beat it, kid. I got business to attend to...','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(17365,'Ezekiel said that you might have a certain book...','Ezekiel said that you might have a certain book...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17366,'Intruders have breached the factory!  Engage emergency defense protocol immediately!','Intruders have breached the factory!  Engage emergency defense protocol immediately!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17367,'Species: Ered\'ruin','Species: Ered\'ruin',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17368,'Affiliation: Burning Legion','Affiliation: Burning Legion',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17369,'Function: Shock Troops, Enforcers','Function: Shock Troops, Enforcers',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17370,'Powerful and deliberate, these winged aberrations are renowned across the cosmos for their brutality.','Powerful and deliberate, these winged aberrations are renowned across the cosmos for their brutality.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17371,'Species: Eredar','Species: Eredar',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17372,'Species: Sayaad','Species: Sayaad',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17373,'Species: Shivarra','Species: Shivarra',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17374,'Species: Nathrezim','Species: Nathrezim',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17375,'Species: Eredar','Species: Eredar',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17376,'Species: Annihilan','Species: Annihilan',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17377,'Species: Mo\'arg','Species: Mo\'arg',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17378,'Species: Mo\'arg','Species: Mo\'arg',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17379,'Species: Mo\'arg','Species: Mo\'arg',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17380,'Affiliation: Burning Legion','Affiliation: Burning Legion',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17381,'Affiliation: Burning Legion','Affiliation: Burning Legion',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17382,'Affiliation: Burning Legion','Affiliation: Burning Legion',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17383,'Affiliation: Burning Legion','Affiliation: Burning Legion',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17384,'Affiliation: Burning Legion','Affiliation: Burning Legion',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17385,'Affiliation: Burning Legion','Affiliation: Burning Legion',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17386,'Affiliation: Burning Legion','Affiliation: Burning Legion',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17387,'Affiliation: Burning Legion','Affiliation: Burning Legion',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17388,'Affiliation: Burning Legion','Affiliation: Burning Legion',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17389,'Function: Honor Guard','Function: Honor Guard',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17390,'Function: Intelligence Agents, Torturers','Function: Intelligence Agents, Torturers',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17391,'Function: Priestesses, Military Chaplains','Function: Priestesses, Military Chaplains',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17392,'Function: Secret Police, Interrogator','Function: Secret Police, Interrogators',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17393,'Function: Overlords, Strategists','Function: Overlords, Strategists',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17394,'Function: Generals, Ground Commanders','Function: Generals, Ground Commanders',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17395,'Function: Tinkerers, Machine-smiths','Function: Tinkerers, Machine-smiths',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17396,'Function: Engineers, Scientists','Function: Engineers, Scientists',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17397,'Function: Standard Soldiers','Function: Standard Soldiers',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17398,'Cunning and precise, the Wrathguard often protect the Legion\'s eredar masters.','Cunning and precise, the Wrathguard often protect the Legion\'s eredar masters.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17399,'The cruel sayaadi temptresses exemplify the subtler side of the Legion\'s nihilistic Crusade.','The cruel sayaadi temptresses exemplify the subtler side of the Legion\'s nihilistic Crusade.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17400,'Devout and exceedingly charismatic, these priestesses live only to evangelize the power of Sargeras\' dread vision.','Devout and exceedingly charismatic, these priestesses live only to evangelize the power of Sargeras\' dread vision.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17401,'The Nathrezim are merciless villains who feed upon the energies of mortal creatures.','The Nathrezim are merciless villains who feed upon the energies of mortal creatures.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17402,'The cunning, powerful eredar warlocks were once our noble kinsmen.','The cunning, powerful eredar warlocks were once our noble kinsmen.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17403,'These colossal destroyers serve as the Legion\'s military commanders.','These colossal destroyers serve as the Legion\'s military commanders.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17404,'These stunted mo\'arg are very clever, and are often employed as helpers for their larger brethren.','These stunted mo\'arg are very clever, and are often employed as helpers for their larger brethren.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17405,'Brutish though they seem, these iron-stitched horrors are exceedingly brilliant engineers and forge-smiths.','Brutish though they seem, these iron-stitched horrors are exceedingly brilliant engineers and forge-smiths.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17406,'Conscripted from the mo\'arg race, these warriors serve as the Legion\'s rank and file soldiers.','Conscripted from the mo\'arg race, these warriors serve as the Legion\'s rank and file soldiers.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17407,'Thank goodness you got here, it was almost dinner time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17408,'Hahaha!  We\'re coming for you, little goblins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17409,'I thought I was a goner for sure.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17410,'I don\'t know which is worse, getting eaten by fel orcs or working for that slave master Razelcraz! Oh well, thanks anyways!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17411,'Let\'s see what you have.','Let\'s see what you have.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17412,'It is said that those who are blessed by the spirits of Auchindoun possess the ability to capture powerful souls in the form of Spirit Shards. I have come across a few of these Spirit Shards throughout my travels but have yet to unlock their secrets. \n\nThe only thing I have been able to discern is that they seem to originate from the depths of Auchindoun itself. If you happen to come across any of these Spirit Shards I\'m sure I could make it worth your while to allow me to take them off your hands...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17413,'All my bags are packed, I\'m ready to go.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17414,'The ship\'s not ready yet.  We still need to calibrate the fuse length to make sure that it doesn\'t burn out and leave you up there alone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17415,'The armies of the Burning Legion are attacking all across Azeroth. We need heroes to throw them back!','The armies of the Burning Legion are attacking all across Azeroth. We need heroes to throw them back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17416,'You need to do what? All this science, I don\'t understand... Look, this is just my job, five days a week.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17417,'Essentially, it\'s going to be a long, long time till we are ready to launch.  Maybe you should just head back home to your family.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17418,'Lend me a Windrider.  I\'m going to Spinebreaker Post!','Lend me a Windrider.  I\'m going to Spinebreaker Post!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17419,'I can\'t. I\'m not the man they think I am at home.  Besides, I didn\'t bring them out here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17420,'Why not? A family can give you strength.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17421,'This isn\'t the kind of place to raise your kids. It\'s cold, and there\'d be no one to raise them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17422,'Couldn\'t you raise them?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17423,'Oh no, no, no... I\'m a rocket man.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17424,'Well, it\'s like I said; it\'s going to be a while before we get this ship ready for flight.  We\'ll keep you informed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17425,'This crystal-based construct hums with energy.  Strange glyphs are projected in front of you and scroll in rapid succession.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17426,'During the full moon of the Lunar Festival, we celebrate the light of Elune.','During the full moon of the Lunar Festival, we celebrate the light of Elune.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17427,'Busy, busy!  So much to do, so little time!$B$BNow where did I put that pyrospanner?  I know it\'s around here somewhere... I burned my fingers on it just a moment ago!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(17428,'It is no surprise that the people of this land hold a great festival of the moon. I should very much like to go to Moonglade to attend it.','It is no surprise that the people of this land hold a great festival of the moon. I should very much like to go to Moonglade to attend it.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17429,'Make them work faster!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17430,'We must get all of this fel reaver tech out of here before the Stormspire comes down on us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17431,'Go tell them to hurry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17432,'This operation is moving too slowly.  Go motivate them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17433,'I want all of this fel reaver technology packed up and ready to ship out within the next turning of Outland!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17434,'You there!  Go check to make sure they\'re doing their jobs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17435,'There\'s nothing like running your own enterprise.  But do I have to do everything myself?  Tell them to speed it up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17436,'If we catch that turncoat, Khay\'ji, I\'m going to unravel him personally!  Go look for him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17437,'Do you think we can pull off a passable disguise?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17438,'Not sure if this is going to be good enough.  These aren\'t troggs we\'re trying to fool.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17439,'','I think you\'ve got the shoulders wrong.  Looks close, though.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17440,'Knowing a little magic comes in handy in this line of work.  Illusions can\'t always fool everyone, but they\'re usually good enough to get the job done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17441,'Three cheers for $n!  $G He\'s : She\'s; saved the town from the Burning Legion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17442,'Hooray!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17443,'What are you doing here?  Shouldn\'t you be working on the energy pipeline?$B$BWe\'ve more than doubled the amount of energy we\'re sending to Tempest Keep and can\'t afford anyone loafing.  We don\'t want another Ultris to happen here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17444,'Ultris?','Ultris?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17445,'Manaforge Ultris, of course!  Where have you been?$B$BThe manaforge was overloaded and created a huge explosion.  It left a tear in reality and now void creatures have been pouring in through it.  You can see them all over the place towards the northeast.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17446,'%s reads from the book of the dead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17447,'Jeffrey Kaplan! Tom Chilton! Rob Pardo!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(17448,'Justin Thavirat! Roman Kenney! Our entire awesome art and animation team!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(17449,'CHRIS METZEN!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(17450,'Pat Nagle! World design team! Cory Stockton, Paul C., Jim Chadwick, Staats, Ed Hanes, Morris, Gotcher, Jesse!, Sarah B., Victor C., Dave A.! All of our amazing exterior artists!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(17451,'Scott Mercer! Geoff, Wyatt, Joe, Travis, Kris, Steven! Brazie!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(17452,'Luis, Brianna and Eric! Blizzard QA team! Of course our fans!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(17453,'Kevin Jordan and Jonathan LeCraft!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(17454,'Shane Dabiri, Lee, Alex T., Rob F., J. A. B.,  A. Mayberry!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(17455,'I AM DEATH!  PREPARE YOUR TOWN FOR ANNIHILATION!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17456,'Oh no!  What\'s that?  Quickly, defend us with the Scrap Reaver X6000!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17457,'Urtrak kill you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17458,'Vengeance is ours!  Attack my brothers!','Vengeance is ours!  Attack my brothers!',25,0,0,1,0,0,0,0,1,0,0,0,26124),
(17459,'And now to do what I should have done a hundred years ago.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17460,'Never again...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17461,'Form ranks and make the intruders pay!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17462,'Hold them back at all costs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17463,'You ought to feel safe here; we\'ve stepped up security at this facility after the attacks on Manaforge Duro.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17464,'Who attacked Manaforge Duro?','Who attacked Manaforge Duro?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17465,'Manaforge Duro is the closest facility to Tempest Keep, so it handles most of the load.$B$BAs you should know, overloading these manaforges causes leaks in the pipelines.  The emanating energy attracts unwanted mana creatures.  We\'ve had mana creature infestations at many leak locations; Manaforge Duro is being hit the hardest at the moment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17466,'HAHAHA!  YOUR FEEBLE ROCKET IS DESTROYED!  I\'LL RETURN LATER TO FINISH OFF THE REST OF YOUR PUNY TOWN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17467,'Tell me of the Sons of Lothar.','Tell me of the Sons of Lothar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17468,'YOUR SAD ATTEMPT AT CREATING A FEL REAVER TO STOP ME HAS FAILED!  NOW, ON TO AREA 52!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17469,'','Working with this technology is a huge headache.  Everything is constructed in such an alien way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17470,'Many years ago, my men and I followed the wizard Khadgar and the paladin Turalyon to this world. Our sole aim was to annihilate the orcs and their vile kin. Yet something went terribly wrong in the final hours of our war.$B$BUltimately, this dark world was ripped asunder - and my dear friends were lost to the void.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17471,'<more>','<more>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17472,'We, the Sons of Lothar, have remained here ever since - fighting... dying... praying that a day like today would come - a day when the Portal would open and our brothers would come to deliver us home.$B$BOverjoyed as we are, duty still calls. There is much to be done before we can depart this world and take our rest.\n','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17474,'Oh no!  The X-52 Nether-Rocket is being attacked!  Guards!  Guards!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17475,'Where did this technology come from?','Where did this technology come from?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17476,'','Don\'t they teach you new recruits anything?  These manaforges were built from parts of Tempest Keep designed to siphon energy from the nether.$B$BThe naaru used this technology to power their vessel during its travels.  Some said the technology might not be safe to use on land.  They were promptly silenced.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17477,'Another soldier on $ghis:her; way to Honor Hold... by Kurdran\'s beard, they can use the help!','Another soldier on $ghis:her; way to Honor Hold... by Kurdran\'s beard, they can use the help!',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(17478,'Send me to Honor Hold!','Send me to Honor Hold!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17479,'Ack!  My beautiful X-52 Nether-Rocket.  We\'ll have to quadruple our efforts to get this damage repaired!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17480,'It\'s my passion, you know. In life and in death, armorcrafting is what I love. Please, treat me as if I were a living draenei, stranger. Let me know what it is to feel again... Allow me the honor of repairing your items.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(17481,'Please repair my items.','Please repair my items.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17482,'The Consortium will exact its revenge upon the Zaxxis betrayers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17483,'Ah, a new champion to aid our cause? What say you, $n? \n','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17484,'$n, the Sons of Lothar have fought here, on the Hellfire Peninsula, for two decades.  We are beset on all sides by indigenous orcs and hellish demons of the Burning Crusade, and though our hearts still beat fiercely, years of war have reduced our numbers.$B$BYou, and the influx of Azeroth\'s new generation of heroes, are a welcome sight indeed!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17485,'Bip!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17486,'Hey, you there.  Want some candy?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17487,'Spare some change for a starving artist?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17488,'What up son!  Wait....is anyone there?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17489,'Tell me of the Hellfire orcs.','Tell me of the Hellfire orcs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17490,'Orcs. It seems I\'ve been fighting them all my life.$B$BTwenty years ago we shattered the Horde and tore down the walls of their Hellfire Citadel. We drove the vile greenskins to the very brink! After that, other than a few skirmishes the broken orcs never again posed a threat to us.$B$BUntil now. \n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17491,'Is there no one left to test me? ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17492,'Your time is running out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17493,'You are nothing! I answer a higher call....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17494,'The dark lord laughs at you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17495,'It is over! Finished!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17496,'Your days are done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17497,'My lord will be... the end of you all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17498,'Heal me, quickly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17499,'Back off, pup!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17500,'Say farewell!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17501,'Much too easy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17502,'What have we here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17503,'This may hurt a little....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17504,'I\'m going to enjoy this...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17505,'We fight to the death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17506,'I will end this quickly....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17507,'Acalah pek ecta!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17508,'Krypta!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17509,'It is finished.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17510,'Well... done...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17511,'Beast! Obey me! Kill them at once!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17512,'Jero\'me falls into a drunken sleep.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17513,'Jero\'me wakes up and slowly rises to his feet.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17514,'Welcome to Honor Hold, $n.  It\'s good to have you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17515,'The dark ones had taken a hold of me, master. You were merciful in seeking my death. Forgive me...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17516,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17517,'In death, all is forgiven...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17518,'','Father? Father is that you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17519,'It will be alright, darling. Grieve no more...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17520,'%s nods.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17521,'About twenty years ago, the Alliance launched the first Expedition to this world in hopes of eradicating the orcs forever. It was a... terrible conflict. Many brave souls perished to assure Azeroth\'s safety.$B$BYet some souls remain...locked in eternal combat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17522,'About twenty years ago, the Alliance launched the first Expedition to this world in hopes of eradicating the orcs forever. It was a... terrible conflict. Many brave souls perished to assure Azeroth\'s safety.$B$BThank you, $n, for helping those souls find peace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17523,'The men and women of Honor Hold have shed such blood and have lost their youth in this monstrous land... and yet they still hold their spirits high!$B$BNow, you and your cohorts from Azeroth can help us turn the tide.  You give us hope that we may one day return to our homelands.','',1,1,25,0,0,0,0,0,1,0,0,0,26124),
(17524,'I can\'t thank you enough for your help, $n. At long last, I will be free of this tower and Kael\'s damnable magic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17525,'Tell me of your homeland.','Tell me of your homeland.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17526,'No! How could the ritual fail?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17527,'The Lunar Festival is in full swing in Moonglade. A delegation of druids can be found in the throne room of Undercity, transporting people there.','The Lunar Festival is in full swing in Moonglade. A delegation of druids can be found in the throne room of Undercity, transporting people there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17528,'It seems the heart of the Lunar Festival celebration is in Moonglade. The druids in the Cenarion Enclave in Darnassus can transport you there if you don\'t want to walk.','It seems the heart of the Lunar Festival celebration is in Moonglade. The druids in the Cenarion Enclave in Darnassus can transport you there if you don\'t want to walk.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17529,'','A flickering image of a female blood elf commander appears. From the surroundings, you can tell she must be inside Tempest Keep.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17530,'','The blood elf doesn\'t appear to be a magister, but perhaps she holds something that is the key to the tower\'s curse.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17531,'There was little time before the watchers of Nethergarde sensed a disturbance in the portal... and the demons screamed into our world!$B$BAlthough reinforcements from the kingdoms of Azeroth are on the march, we of the Argent Dawn were first to rally behind Nethergarde\'s call.$B$BOur mission: hold these monsters at bay until help from the Alliance and Horde arrives...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17532,'%s calls for a nearby slave to assist him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17533,'Great!  This servo should do the trick!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17534,'That\'ll do it.  Thanks again for getting us that part!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17535,'The curse remains intact. We\'ll have to find another way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17536,'','Oh dear! What happened here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17537,'','The timeway collapsed with five of our agents inside.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17538,'','And the kaldorei vessel?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17539,'','It came crashing through shortly after the collapse. We\'re examining it now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17540,'','%s nods.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17541,'','Fascinating. What is it, Andormu?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17542,'Something very, very disturbing. We\'re starting to see more of them across the timeways.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17543,'','Hrm, are they tampering with timeways?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17544,'Nozari, I\'m not talking about a greedy wizard looking to improve his station in life by making a small adjustment to the past.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17545,'These beings aren\'t giving themselves the winning numbers for the Stormwind lottery, dear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17546,'','I hate it when you speak to me in that manner. I am your equal in every way, brother. Remember that the next time you are trapped amidst a temporal vortex, crying for help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17547,'My apologies, Nozari. I have been a bit \'on edge\' as of late. These creatures are attempting to alter the timeways.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17548,'You do recall the last time that this occurred, yes? Let us hope that the master need not be involved.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17549,'','Shall we?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17550,'Absolutely not. We must not place ourselves at risk. With the master away, we are all that is in place to keep the stream intact. Others are due to arrive any moment now. Heroes and adventurers from Azeroth...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17551,'','%s nods.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17552,'Nethergarde, for years, has stood watch over the Dark Portal.  Ever vigilant, it was we who first sensed fel energies leaking through the long closed gateway.$B$BWe raised a global alarm, and the world answered...$B$BNow, the Argent Dawn holds this line as the kingdoms and clans of the Horde and Alliance marshal their forces and rush to aid us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17553,'As a representative of the Consortium, I am always mindful of the ramifications that my interactions have upon our business dealings.$B$BIt is unfortunate that the blood elves do not treat their partnerships with such respect.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17554,'My younger brother here is quite the rising star in the Consortium. Of course, he\'s too modest to acknowledge it.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(17555,'When he says, \'younger brother,\' he fails to mention that we\'re twins. He\'s really only older by a couple of minutes.$B$BDon\'t let that \'rising star\' bit of his fool you. I\'ll never be a trader of the same magnitude that he is.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(17556,'','%s examines the specimen.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17557,'','This specimen is fading from existence. Something or someone is altering the timeway.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17558,'','I can\'t get a reading... Something is interfering...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17559,'','Have the Scale of Sands been made aware?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17560,'','We must dispatch another watcher. Balance must be maintained...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17562,'','%s calls for reinforcements!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17563,'You\'ll be sorry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17564,'Hail to you, $r. What I am doing here is a story for another time. Oof, that was a bad one.$B$BMy brother and I are stuck here, between our time and the present. We dare not leave for fear of causing a temporal paradox. Patiently we wait until the dragons restore us to our proper timeline.$B$BHow long has it been you ask? I\'m not sure really. Ask my brother.$B$BCare for some cheese?','',1,1,273,0,0,0,0,0,1,0,0,0,26124),
(17565,'Time to kill!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17566,'Cheese, eh? Is it perhaps... aged cheese?','Cheese, eh? Is it perhaps... aged cheese?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17567,'','Hold the line!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17568,'','...steady...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17569,'This... no... good...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17570,'','Prevent the advance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17571,'','Looks like I picked the wrong day to quit mana tapping...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17572,'No, you aren\'t hearing things. I actually do have the voice of a young orc woman. But you listen here, $g boy:girl;, time travel does strange things to a body.$B$BBy the way, it\'s 250 years.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(17573,'No coming back for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17574,'I need some reagents and poisons, lady.','I need some reagents and poisons, lady.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17575,'Nice try.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17576,'Now you gone for good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17577,'You fail!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17578,'','Thank you, kind $gsir:lady;!',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(17579,'Yep, I\'ve been stuck here for as long as I can remember.$B$BIn my former life, I was an armorer. Perhaps I can fix something for you?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17580,'I need to repair.','I need to repair.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17581,'Finally, someone came down to talk to me!  Want to hear some of my rhymes?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17582,'YES!','YES!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17583,'NO!','NO!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17584,'Walking down the street!  Looking at my feet!  Watching the leaves, fall off of the trees!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17585,'When will this city be done?  Everytime I think im done they tell me I need to work for one more day...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17586,'I feel like I have been working on this city forever!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17587,'Sometimes I dream of this amazing city being complete.  Alas, all this work has turned my dreams into nightmares!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17588,'We only have to work crunch time for a few more weeks.  At least thats what they tell us...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17590,'This ethereal teleport pad is covered in brightly colored buttons and switches, but seems to have fallen into disuse.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17591,'All things for sale, my friend!  Large and small, whatever you need, Hazzin will provide.$B$BIf you value your life, do not approach Manaforge Ultris without a resupply.  Hazzin is the last chance that you have.','',1,1,0,0,1000,0,0,0,1,0,0,0,26124),
(17592,'Dealer Hazzin, what do you have to offer?','Dealer Hazzin, what do you have to offer?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(17593,'%s calls for his worgs.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17594,'I have every confidence that we will recover that which Nexus-Prince Haramad desires.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17595,'%s wakes up, startled.','',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(17596,'Was... Was it all a dream? Azuremyst, Bloodmyst, Zangarmarsh, Shadowmoon... even Zul\'Aman... Jane! Jane where are you!','',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(17597,'Ah, wonderful. It was all just a dream...','',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(17598,'','I\'m right here, daddy. You\'ve been asleep all day long. You sure must be tired!',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(17599,'','%s resumes playing on the beach.',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(17600,'I have earned my freedom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17601,'This day is long overdue! Out of my way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17602,'I am a slave no longer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17603,'Blackmoore has much to answer for!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17604,'You have forced my hand!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17605,'It should not have come to this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17606,'I did not ask for this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17607,'I am truly in your debt, strangers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17608,'Thank you, strangers. You have given me hope.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17609,'I will not waste this chance. I will seek out my destiny.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17610,'Things are looking grim....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17611,'I\'ll fight... to the last!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17612,'Taretha....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17613,'A good day... to die.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17614,'Ours is the TRUE Horde! The only Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17615,'Let us hold our discussion in a more... private place. Follow me, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17616,'I\'ll carve the meat from your bones!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17617,'I am called Bladefist for a reason. As you will see.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17618,'You didn\'t really think I\'d do business with you again, did you? Sometimes, the best way to return to profitability is to know when to cut your losses.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17619,'For the real Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17620,'I am the ONLY warchief!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17621,'The true Horde... will prevail.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17622,'Very well then. Let\'s go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17623,'I\'ll never be chained again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17624,'Kill $n!','Kill $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17625,'','I\'ve never seen anything like these nether dragons. They seem to have inherited their sire\'s temperment, but they have become something entirely different.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17626,'The ground of this place is still warm from freshly shed blood.  Ah, I would have given my own eye to be here when the demons tore through that portal and clashed with Azeroth\'s heroes!  What a battle it was!$B$BBut now, even more fierce fighting rages on the other side!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17627,'If you have come all the way out here, then it must be that you dare to venture near Manaforge Ara.$B$BCare to buy or sell before you head over?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17628,'What do you have to sell, Tuluman?','What do you have to sell, Tuluman?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(17629,'There are only 3 kinds of people in this world: competitors, customers, and employees. Competitors are to be crushed ruthlessly, customers indulged, and employees strictly supervised.$B$BIndependent contractors are a myth.They want to be paid better than employees, but treated like customers. Never trust one who calls himself by that title.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17630,'It is... not over.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17631,'Die, weakling!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17632,'I am victorious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17633,'I will not be defeated!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17634,'You dare stand against ME?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17635,'Your insolence will be your death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17636,'A-kreesh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17637,'Achor she-ki!  Feast, my pet!  Eat your fill!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17638,'Attempt to contact Wind Trader Marid.','Attempt to contact Wind Trader Marid.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17639,'%s takes a long look into the forest of Terokkar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17640,'$n, you have done a great service for us, restoring some of our honor.  Look for us again in your darkest hour when our enemies are near. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17641,'This is sacred ground!','This is sacred ground!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17642,'How dare you come here?','How dare you come here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17643,'Outsiders are forbidden!','Outsiders are forbidden!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17644,'Let your mind be clouded.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17645,'Stare into the darkness of your soul.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17646,'This is... where I belong.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17647,'You will pay with your life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17648,'There is no turning back now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17649,'Serve your penitence!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17650,'These walls will be your tomb!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17651,'Now you\'ll stay... for eternity.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17652,'%s begins a massive heal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17653,'What insolence! What arrogance! To believe you could defeat me on my own doorstep!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17654,'This exercise bores me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17655,'You wish to test me? You are hardly up to the task.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17656,'','Greetings, $n. I will guide you through the cavern. Please try and keep up.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17657,'','We do not know if the Caverns of Time have always been accessible to mortals. Truly, it is impossible to tell as the Timeless One is in perpetual motion, changing our timeways as he sees fit. What you see now may very well not exist tomorrow. You may wake up yesterday and have no memory of this place.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17658,'','It is strange, I know... Most mortals cannot actually comprehend what they see here, as often, what they see is not anchored within their own perception of reality.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17659,'','As custodians of time, we watch over and care for Nozdormu\'s realm. The master is away at the moment, which means that attempts are being made to dramatically alter time. The master never meddles in the affairs of mortals but instead corrects the alterations made to time by others. He is reactionary in this regard.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17660,'','For normal maintenance of time, the Keepers of Time are sufficient caretakers. We are able to deal with most ordinary disturbances. I speak of little things, such as rogue mages changing something in the past to elevate their status or wealth in the present.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17661,'','These tunnels that you see are called timeways. They are infinite in number. The ones that currently exist in your reality are what the master has deemed as \'trouble spots.\'  These trouble spots may differ completely in theme but they always share a cause. That is, their existence is a result of the same temporal disturbance. Remember that should you venture inside one...\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17662,'','The timeways are currently ranked in order from least catastrophic to most catastrophic. Note that they are all classified as catastrophic, meaning that any single one of these timeways collapsing would mean that your world would end. We only classify them in such a way so that the heroes and adventurers that are sent here know which timeway best suits their abilities.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17663,'','This timeway is in great disarray! We have agents inside right now attempting to restore order. What little information I have indicates that Thrall\'s freedom is in jeopardy. A malevolent organization known as the Infinite Dragonflight is trying to prevent his escape. I fear without outside assistance, all will be lost.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17664,'','We have very little information on this timeway. Sa\'at has been dispatched and is currently inside. The data we have gathered from his correspondence is that the Infinite Dragonflight are once again attempting to alter time. Could it be that the opening of the Dark Portal is being targeted for sabotage? Let us hope not...\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17665,'','All we know of this timeway is that it leads to Mount Hyjal. The Infinite Dragonflight have gone to great lengths to prevent our involvement. We know next to nothing, mortal. Soridormi is currently attempting to break through the timeway\'s defenses but has thus far been unsuccessful. You might be our only hope of breaking through and resolving the conflict.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17666,'','Our time is at an end, $n. I would wish you luck, if such a thing existed.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17667,'','There are only two truths to be found here: First, that time is chaotic, always in flux, and completely malleable and second, perception does not dictate reality.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17668,'','Follow me, please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17669,'','This timeway collapsed and reformed. The result was Stratholme of yore. What could possibly be happening inside?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17670,'Just as you deserve!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17671,'Your friends will soon be joining you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17672,'Good...luck. You\'ll need it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17673,'You mustn\'t let him loose!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17674,'Ignorant whelps!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17675,'You fools! He\'ll kill us all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17676,'Culuthas, you will return the crystal to me at once!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17677,'You have no idea how to control the ata\'mal crystal.  It will consume you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17678,'Return the crystal to me or face annihilation!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17679,'My work must not be interrupted!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17680,'Perhaps I can find a use for you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17681,'Anger...hate... These are tools I can use.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17682,'Do not make me come there and destroy you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17683,'Let\'s see what I can make of you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17684,'It is pointless to resist.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17685,'Stay away from... Me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17686,'How dare you destroy my demons!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17687,'What are these things that you have summoned to serve you?!  Just who do you think you are!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17688,'Culuthas, deliver the crystal to me now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17689,'What\'s that?  Did you hear something?  Culuthas, there are servants of the Consortium nearby.  Bring me the crystal immediately!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17690,'Culuthas where have you gone?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17691,'You cannot hide from me, Culuthas!  I will hunt you down no matter where you go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17692,'I can sense you, \'adventurer\', even through this magical image.  You think you will retrieve the ata\'mal crystal when Culuthas shows himself, but you are mistaken!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17693,'Show yourself, Culuthas.  All may be forgiven if you just bring the crystal to me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17694,'Are you using the crystal to hide?  Is that it?  You should know that you cannot possibly mask such power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17695,'I don\'t know where you\'ve gone to.  But I can assure you that wherever that is, I will find you and the crystal, Culuthas!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17696,'','The depths will consume you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17697,'','Meet your doom, surface dwellers!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17698,'','You will drown in blood!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17699,'Culuthas, when I find you, I am going to make certain that you suffer for all eternity!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17701,'','To the depths of oblivion with you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17702,'','For my lady and master!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17703,'I will not give it to you, Socrethar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17704,'','Our matron will be... the end of you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17705,'Nothing that you say will convince me to give up such power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17706,'WITH THE CRYSTAL, I AM A GOD!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17707,'You can talk until you\'re blue in the face, I\'m not delivering the ata\'mal crystal to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17708,'I think not, Socrethar.  With the power of the crystal, you will be serving me soon.  If I allow you to live, that is.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17709,'They all wanted it for themselves, but I slew them as easily as I will slay you when I pay you a visit later.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17710,'No.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17711,'Stay alert!','Stay alert!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17712,'Beg all you want, I am keeping the crystal for myself.  All of Outland will soon fall beneath my step!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17713,'Be wary of intruders.','Be wary of intruders.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17714,'Don\'t you wish there was some water around here?','Don\'t you wish there was some water around here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17715,'We must not fail the master.','We must not fail the master.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17716,'You\'re in for a world o\' hurt!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17717,'Eat hot metal, scumbag!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17718,'I\'ll come over there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17719,'I\'m bringin\' the pain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17720,'You just got served, punk!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17721,'I own you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17722,'Have fun dyin\', cupcake!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17723,'Mommy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17724,'You deem yourselves worthy simply because you bested my guards? Our work here will not be compromised!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17725,'This is not nearly over...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17726,'Your head will roll!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17727,'I despise all of your kind!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17728,'Ba\'anthalso-dorei!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17729,'Squirm, surface filth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17730,'For her Excellency... for... Vashj!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17733,'I have pets -- ca-caw! -- of my own!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17734,'Mmm... time to make my move!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17735,'Nice pets, yes... raa-a-ak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17736,'Nice pets have weapons. No so -- ra-ak -- nice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17737,'Yes, fleeting life is, rak-a-kak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17738,'Mmmm... be free. Caw!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17739,'Mmm... no more life. No more pain. A-ak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17740,'Beware, mortal, beyond this hall lies dangers unheard of in your world. Tread carefully...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17741,'It is good to see you again, $n. Would you like me to take you to the master\'s lair?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17742,'Please take me to the master\'s lair.','Please take me to the master\'s lair.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17743,'Arathi Basin has been overrun by The Defilers.  Will you help us, $n?','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(17744,'It is good to see a friend of the Aldor around these remote parts.  I fear I cannot stand for much more of these elves\' insolent chatter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17745,'','Go, $n, into Arathi Basin! Slay, SLAY, as you\'ve never slain before!',5,0,0,1,0,0,0,1,1,0,0,0,26124),
(17746,'The entrance to Warsong Gulch stands before you. Will you fight the wretched Alliance there?','',25,0,0,2,0,0,0,1,1,0,0,0,26124),
(17747,'','Well met, $c. Even now, the Horde attacks Warsong Gulch. Will you fight alongside the Alliance there?',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(17748,'What are ye doin\' here?! Get yer chatty self ta Alterac Vallery, where ye\'re needed!','',5,0,0,1,0,0,0,7,1,0,0,0,26124),
(17749,'','BOAR\'S DUNG! Why must I stay here to guide others to Alterac Valley, when I could be fighting there myself? You! Have you come to fight the Alliance?',15,0,0,1,0,0,0,1,1,0,0,0,26124),
(17750,'The forest sings with the seeds of change, but it also cries out in pain.$B$BOur new friends, the draenei, are here to help us, like you. We must put an end to the destruction of my brother and sister trees before all is lost and Ashenvale is no more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17751,'Attempt to contact Tyri and Jorad.','Attempt to contact Tyri and Jorad.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17752,'','There\'s no need to contact that conniving ethereal. Come, we have much to discuss.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17753,'When you are ready to fly to Durnholde, let me know and I shall take you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17754,'Wind Trader Marid, I\'ve returned with more information on the nether drakes. I\'m prepared to be your business partner, and for an extra sum, I\'ll take care of that troublesome elf and her human friend.','Wind Trader Marid, I\'ve returned with more information on the nether drakes. I\'m prepared to be your business partner, and for an extra sum, I\'ll take care of that troublesome elf and her human friend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17755,'Spare my life!  I will tell you about Arelion\'s secret.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17756,'What is it you want?  I\'m not one for small talk.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17757,'Magistrix Carinda has sent me to ask you about Arelion\'s secret.  Who was he seeing?','Magistrix Carinda has sent me to ask you about Arelion\'s secret.  Who was he seeing?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17758,'If you think I\'ll betray my friend that easily, think again!  Face me, you scoundrel!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17759,'','I\'m a little busy negotiating a bribe right now.  You might want to come back later.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17760,'','I\'ve arranged for your flight to Manaforge Coruu.  Are you ready, $n?  You will be dropped off behind enemy lines so make sure you bring everything you need.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17761,'I\'m as ready as I\'ll ever be.','I\'m as ready as I\'ll ever be.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17762,'Ikiss will not -- rak, rak -- die...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17763,'You die -- ka! Stay away from trinkets!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17764,'Mmmmmm...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17765,'Mmm, you make war on Ikiss? Aa-ak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17766,'Don\'t let those fiends breath through!  Our wounded are here behind me!','Don\'t let those fiends breath through!  Our wounded are here behind me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17767,'Ikiss cut you, pretty -- ak-a-ak -- slice you, yes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17768,'Ak-a-ra-k! No escape for -- caw -- you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17769,'Ra-ak! Trinkets, yes. Pretty trinkets! Ak! Power, great power. Ra-kaw! Power in trinkets! Ak-caw!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17771,'I will feed... on your soul.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17772,'So... full of life.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17773,'Do not... resist.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17774,'Yes... I am... empowered.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17775,'More... I must have more.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17776,'To the Void... once more.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17777,'I must bid you... farewell.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17778,'And now we part company.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17779,'It has been... entertaining.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17780,'We have not been properly introduced.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17781,'An epic battle, how exciting!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17782,'I\'ve longed for a good adventure!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17783,'I have such fascinating things to show you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17784,'What is this? You must forgive me, but I was not expecting company. As you can see, we are somewhat preoccupied right now. But no matter. As I am a gracious host, I will tend to you... personally.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17785,'%s grows in size upon seeing $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17786,'%s\'s strength fades.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17787,'Indeed, Nexus-Prince Haramad, you do have much to think on.  Such as turning over that ata\'mal crystal to my master, Prince Kael\'thas.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17788,'I will use the power of the ata\'mal crystal to crush you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17790,'You\'ll never get the ata\'mal crystal from me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17791,'The ata\'mal crystal is mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17793,'No, I think not.  The selflessness that I have just been witness to has cleared my mind.  My dealings with your master are at an end.  You may return and let him know that I have decided to turn the ata\'mal crystal over to the naaru.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17794,'WHAT!  This is outrageous!  You will pay for this Haramad!  You and your assistant here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17795,'Welcome to the Stormspire, $c.$B$BPlease do not be put off by my being present through this imaging device.  I have many enemies that would like to see me dead, so it is only a precaution.$B$BI assure you that you are perfectly safe here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17796,'Guards!  Hold on, I will be right there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17797,'That definitely ended our business relationship with Kael\'thas.  Please stay here.  I will return shortly and there is something that I want you to do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17798,'I\'ll get you working yet, you bucket of junk.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17799,'There is something that you wish to buy?  There is something that you wish to sell?$B$BThis is why we are here, my friend.$B$BPlease, tell me your pleasure.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17800,'Dealer Dunar, I wish to browse your wares.','Dealer Dunar, I wish to browse your wares.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17801,'Don\'t you start with me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17802,'What?!  You don\'t think I can do it?  I\'ll show you...once I get my parts, that is.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17803,'Oh yeah, it\'s real funny isn\'t it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17804,'It moved!  I swear, I saw it move!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17805,'Ouch!  That\'s not right.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17806,'So you\'ve recently arrived from Azeroth, eh? You\'d best steel yourself, $c - there are perils in this land unlike anything the Horde has faced before. I am Nazgrel - right hand to our mighty warchief, Thrall. He honored me with the task of safeguarding this brave expedition and - by all the spirits - I shall!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17807,'Send me to Thrallmar!','Send me to Thrallmar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17808,'Throm\'ka, $gbrother:sister;! Welcome to Outland. The Horde needs all the strength it can muster in this broken world. I promise you, if it\'s glorious battle you\'ve come seeking, you\'ll have your fill of it here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17809,'Make it quick, $c - we\'ve got a war to fight here, or hadn\'t you noticed?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17810,'Their skill in battle should never be underestimated.','Their skill in battle should never be underestimated.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17811,'They revel in causing anguish and pain - and their murderous interrogations are the stuff of nightmares.','They revel in causing anguish and pain - and their murderous interrogations are the stuff of nightmares.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17812,'They are the driving heart of the Burning Crusade.','They are the driving heart of the Burning Crusade.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17813,'They utilize terror and subterfuge - often turning brother against brother as whole worlds fall before their dark influence.','They utilize terror and subterfuge - often turning brother against brother as whole worlds fall before their dark influence.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17814,'Stop! Do not go any further, mortal. You are ill-prepared to face the forces of the Infinite Dragonflight. Come, let me help you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17815,'Mischievous by nature, they are fond of employing their own hastily-constructed technologies.','Mischievous by nature, they are fond of employing their own hastily-constructed technologies.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17816,'Muttering under his breath, %s goes back to work.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17817,'Their black iron constructs have sown death across a thousand worlds.','Their black iron constructs have sown death across a thousand worlds.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17818,'Golem. Command. Operational status report.','Golem. Command. Operational status report.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17819,'The Alliance has taken control of the Blood Elf Tower!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(17820,'This unit is currently at ninety five percent operational efficiency.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17821,'This unit is currently performing within normal parameters.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17822,'This unit is ready to serve.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17823,'The Horde has taken control of the Blood Elf Tower!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(17824,'The Alliance has taken control of the Mage Tower!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(17825,'The Horde has taken control of the Mage Tower!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(17826,'$n has defended the Draenei Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(17827,'The Alliance has taken control of the Draenei Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(17828,'The Alliance has taken control of the Fel Reaver Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(17829,'The Horde has taken control of the Fel Reaver Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(17830,'You recovered an ata\'mal crystal?  Impressive, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17831,'$n has assaulted the Blood Elf Tower!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(17832,'$n has assaulted the Blood Elf Tower!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(17833,'$n has assaulted the Draenei Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(17834,'$n has assaulted the Draenei Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(17835,'$n has assaulted the Fel Reaver Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(17836,'$n has assaulted the Fel Reaver Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(17837,'$n has assaulted the Mage Tower!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(17838,'$n has assaulted the Mage Tower!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(17839,'Golem movement appears to be within the specifications.','Golem movement appears to be within the specifications.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17840,'I\'ll be glad when final testing of this unit is complete.','I\'ll be glad when final testing of this unit is complete.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17841,'After this mobility test, we\'ll only have the final weapons check to complete.','After this mobility test, we\'ll only have the final weapons check to complete.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17842,'Ahhh, dat feel guud!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17843,'Raaaah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17844,'Mmmm, Bloodmaul Brew!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17845,'Buuuurrp...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17846,'Ahhh, guud stuff!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17847,'Mmm, me wanna bash!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17848,'Oh, another show already? Very well then...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17849,'%s sighs audibly and glances at Sagan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17850,'And, for my next trick...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17851,'Another long day in the trenches over with at last! Maybe the magic show will take away some of the afterglow...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17852,'Show us a trick, Ravandwyr!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17853,'That was the best trick ever! Ok, boys, let\'s go get a drink.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17854,'I shall breathe fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17855,'I shall transform my familiar, Sagan, into something truly wondrous!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17856,'Thank you for watching, everyone! If you\'d be so kind as to bring your non-irradiated currency to tomorrow\'s performance, I\'d appreciate it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17857,'A skunk! Eeeeeeeeeeeeeeeeeew! Don\'t touch me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17858,'Get it away from me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17859,'Aid me, you fools, before it\'s too late!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17860,'Pathetic mortals! You will pay dearly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17861,'I will break you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17863,'Finally, something to relieve the tedium!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17864,'Do you fear death?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17865,'This is the part I enjoy most...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17866,'Do not... grow... overconfident, mortal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17867,'Come to my aid! Heed your master now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17868,'I\'ll make an offering of your blood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17869,'You\'ll be a fine example for the others!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17870,'Good, a worthy sacrifice!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17871,'I serve with pride.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17872,'Your death is for the greater cause...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17873,'I give my life... gladly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17874,'Let me outta here! Guys... guys?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17875,'Oh man, he got you good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17876,'Remember how you\'re always telling us to chill?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17877,'A simple practical joke.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17878,'Hail, adventurer. Heed my warnings before venturing into the Black Morass.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17879,'Sa\'at, I have lost the chrono-beacon and require another!','Sa\'at, I have lost the chrono-beacon and require another!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17880,'Ah, welcome back, hero. You have returned to protect the Guardian once more? Do not forget to take a chrono-beacon with you!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17881,'I require a chrono-beacon, Sa\'at.','I require a chrono-beacon, Sa\'at.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17882,'Greetings, $n. Proceed with caution...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17883,'Warning!  %s emergency shutdown process has begun.  Shutdown will complete in one minute.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17884,'Emergency shutdown will complete in thirty seconds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17885,'Emergency shutdown will complete in ten seconds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17886,'Manaforge shutdown aborted.  Resuming manaforge activity.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17887,'','I told you only to summon me if that stupid elf returned! What\'s this? No matter, you won\'t detain me long.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17888,'The work must continue!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17889,'You brought this on yourselves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17890,'Don\'t make me kill you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17891,'Throm\'ka, $c. Is this shattered land what you expected to see? It\'s nothing like the stories I\'ve been told. It\'s hard to believe my people ever thrived in this desolate place.','Throm\'ka, $c. Is this shattered land what you expected to see? It\'s nothing like the stories I\'ve been told. It\'s hard to believe my people ever thrived in this desolate place.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17892,'It had to be done....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17893,'You should not have come....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17894,'I... deserve this....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17895,'Tell me more of our mission here, Nazgrel.','Tell me more of our mission here, Nazgrel.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17896,'Once our warchief heard that the Dark Portal had been reopened, he immediately gathered his advisors to plan this daring expedition. Though a few of his councilors have their doubts, Thrall holds out the hope that we might discover new insights into the history of our people. He believes that somewhere amidst the wreckage of this world, the true tale of the orcish people lies hidden.$B$BI must admit that in my darkest moments... I fear that that tale should remain untold.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17897,'<Keep Listening>','<Keep Listening>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17898,'The Horde has risked much to venture into Outland - resources, manpower - even the tactical defense of our lands is at stake. Despite all else, Thrall believes in the promise of this ravaged land. There is a strange light in his eyes these days - as if he senses some stirring revelation the rest of us do not.$B$BStill, he is my warchief and my blood-brother. I would follow him through the gates of the abyss itself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17899,'Throm\'ka, $c. You must be new. You look fresh and unspoiled by the horrors of this land.$B$B<Sergeant Shatterskull spits into the dust.>$B$BThat\'ll change.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17900,'Emergency shutdown complete.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17901,'Our Expedition made it safely through the Portal and set up a new base called Thrallmar. Yet as you can see, the Burning Legion moved in and cut us off from our brothers. Clearly, the demons hope to retake the Dark Portal and prevent us from gathering reinforcements from Azeroth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17902,'Aided by the Alliance, my forces will hold the line here, but I need you to deliver my report to General Krakork in Thrallmar. With his help, we\'ll be able to drive these demons back into the abyss that spawned them! Speak to Vlagga Freyfeather who stands on the platform behind us. She\'ll speed you on your way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17903,'more','more',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17904,'With some help, I believe Taerix may be close to a breakthrough.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17905,'My brothers in Stormwind told me not to join the military... I\'m glad I didn\'t listen to them!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17906,'Shatter Point is a great place for a Wildhammer dwarf.  I\'ve never had so much time in the air!','Shatter Point is a great place for a Wildhammer dwarf.  I\'ve never had so much time in the air!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17907,'','Hawkstriders are noble creatures.  Make sure to always treat yours well; there are fewer things more dangerous than an angry hawkstrider.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17908,'','I am sure that, with our help, Botanist Taerix will be able to find solutions to our problems.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17909,'I wish to purchase one of these creatures.','I wish to purchase one of these creatures.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17910,'Aim!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17911,'Fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17912,'As the neutralizing agent mixes into the waters of the lake, the water that was irradiated by the crystal seems to clear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17913,'Protect the Mechanar at all costs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17914,'Of course none of my goods are stolen.  But if someone asks, you didn\'t get them from me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17915,'The latest blueprints, patterns and schematics are available right here.  These instructions are so simple to follow they practically craft themselves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17916,'The best selection of smuggled goods is available right here, $n.  Great for the whole family!  Avoid goblin taxation and naaru prohibition - the Consortium is here to fill your every shopping need!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17917,'Pssst!  I have something that might interest you, $n.  It fell off a pack mule in Nagrand!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17918,'','I think I can see the Sunwell from here!',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(17919,'','Can you really hear the ocean from one of these shells?',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(17920,'','Oooh! Look, a shiny one!',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(17921,'','Jane will love this one!',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(17922,'','%s picks up a sea shell.',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(17923,'','%s holds a sea shell up to her ear.',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(17924,'','%s shakes the dirt loose from the shell.',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(17925,'Looks like it\'s time to let you out of this cage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17926,'','%s wipes a tear away.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17927,'','Go\'el. You are Go\'el, son of Durotan - rightful chieftain of the Frostwolves. This day, grandson - you are the great joy of my heart.\n',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17928,'I have dreamed of this moment all my life, Greatmother. \'Till now, all I\'ve had were Orgrim\'s stories about my parents and their adventures on Draenor. He was my greatest teacher and dearest friend. He died a hero... They all died as heroes - and for all of them, a song of honor remains.\n','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17929,'','I see that you hold the Doomhammer. Have all of our greatest heroes fallen, grandson?\n',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17930,'','What of Grommash? What of Hellscream?\n',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17931,'Stop the emergency shutdown!  Kael will have our heads if he hears about this!','Stop the emergency shutdown!  Kael will have our heads if he hears about this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17932,'The naaru\'s emergency shutdown will disable the manaforge permanently!  It must be aborted!','The naaru\'s emergency shutdown will disable the manaforge permanently!  It must be aborted!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17933,'','Heading to Outland? Visit Vixton Pinchwhistle in Netherstorm\'s Area 52. As the Steamwheedle Fighting Circuit\'s official Arena Vendor, he has all sorts of incredible items for sale to those with enough Arena Points.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17934,'Now, to put the neutralizing agent on it...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17935,'Send me to Shatter Point!','Send me to Shatter Point!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17936,'Send me to Honor Point!','Send me to Honor Point!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17937,'Send me to Shatter Point!','Send me to Shatter Point!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17938,'','Tedon, go ahead and try the neutralizing agent on the mutated creature.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17939,'Success!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17940,'Very well.  Before we head down there, take a moment to prepare yourself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17941,'Let\'s proceed at a brisk pace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17942,'We\'ll start at that first energy pylon, straight ahead.  Remember, try to keep them off of me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17943,'I\'m done with this pylon.  On to the next.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17944,'Alright, pylon two down.  Now for the heat manifold.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17945,'That should do it.  The teleporter should blow any second now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17946,'Ok, let\'s get out of here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17947,'Feel like helping me to take down the warp-gate in that Burning Legion camp to the south?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17948,'We work well together, $n.  I couldn\'t have taken that warp-gate down without you!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(17949,'Thank you, $n!  I couldn\'t have done it without you.  You\'ll let Gahruj know?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17950,'Keep them off me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17951,'','These people arrived from Shattrath a few nights ago and they haven\'t stopped arguing since then.$B$BI\'m glad to see that hasn\'t turned you away, I was beginning to think they were scaring off potential customers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17952,'','I hope these Shattrath folks stop fighting soon.  They\'re beginning to get on my nerves.$B$B How can I help you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17953,'Work harder, dogs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17954,'Faster, or you will taste The Claw!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17955,'Lord Doomclaw.  Yes, I like the sound of that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17956,'Who\'s your master?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17957,'Faster, faster!  Get those fel reaver parts gathered!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17958,'You think I should have gone with the buzzsaw instead?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17959,'Gather up those fel reaver parts.  We\'re going to make a surprise for the goblins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17960,'This is hard work.  I feel like I need a vacation.  You there, put your back into it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17961,'You are not yet strong enough to do battle in the Eye of the Storm. Return when you have gained more experience.','You are not yet strong enough to do battle in the Eye of the Storm. Return when you have gained more experience.',274,0,0,1,0,0,0,0,1,0,0,0,26124),
(17962,'Draenei forces and their Alliance allies are engaged with the Horde in the Eye of the Storm in Outland. Will you join them in an effort to turn the tide of battle in our favor?','Draenei forces and their Alliance allies are engaged with the Horde in the Eye of the Storm in Outland. Will you join them in an effort to turn the tide of battle in our favor?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(17963,'The Horde must not allow the draenei and their meddling Alliance to control all the mana cells in Outland. Will you join the blood elves in their assault on the Eye of the Storm?','The Horde must not allow the draenei and their meddling Alliance to control all the mana cells in Outland. Will you join the blood elves in their assault on the Eye of the Storm?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(17964,'Speak with Wing Commander Brack, $n.  He\'ll outfit you with one of our armored wyvern destroyers.  And, good luck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17965,'Hello, $c!  Are you reporting for a flight mission?','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(17966,'Hal...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17967,'Yea, Nat?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17968,'Had that dream again last night...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17969,'Which one?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17970,'That one dream... The crazy one. Remember?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17971,'Tarren Mill is destroyed by some crazy force of undead and forever more becomes an enemy to Southshore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17972,'Could ya imagine such a thing, Hal? Could ya?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17973,'That one where I\'m in Durnholde and that one orc that Blackmoore keeps as his personal slave breaks out...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17974,'He ends up destroying the whole keep, freeing all the orcs we\'re keeping in the camps, and rising to power as the king of orcs... Warchief or somethin\'.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17975,'Crazy, isn\'t it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17976,'So I\'m on some mountain with some big ol\' tree. Bunch of elves runnin\' around all over...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17977,'Out of nowhere, some 300 foot tall demon or somethin\' walks up and starts climbin\' the tree...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17978,'And if that weren\'t crazy enough, that big demon gets killed by a bunch of little floating light things... Oh, I was also a female elf in that one... Yep...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17979,'In this dream, I was fishin\' master of the world. I moved to some place called Kalimdor...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17980,'And people from all over the world come to me to pay homage... and learn to fish.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17981,'I\'m like some kind of fishing god...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17982,'I can\'t even believe this one... You know those two loud-mouthed ruffians, Foror and Tigule?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17983,'Well in this dream, they somehow end up inventing something called ice-cream and flavoring it with strawberries... Well, long story short, they end up striking it rich!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17984,'If that weren\'t crazy enough, they decide to quit the ice-cream business and become adventurers... They travel all over the place and finally disappear into some portal. I woke up in a cold sweat after that one...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17985,'This one\'s real grim... So the king\'s kid, Arthas... Well he goes out to battle evil, along with Uther... *Nat pats his brow dry*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17986,'But tragically, Arthas is consumed by the evil and becomes evil himself...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17987,'Well, he comes back to the king all pretendin\' to be nice, draws his sword, and runs the king through, elbow to ... well you know... kills him on the spot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17988,'It\'ll never happen, Nat.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17989,'Impossible!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17990,'I worry about you sometimes, Nat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17991,'No way.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17992,'Nat, I\'ve heard a whopper or two in my day but that one takes the cake.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17993,'What you got in that pipe, Nat?\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17994,'*Hal shakes his head* Nat, Nat, Nat...\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17995,'Shut up and fish, Nat.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17996,'I hate this place and everyone in it! Smithers do this! Smithers do that! Oh so I\'m a farmer now, eh? So I\'m gonna have to harvest stuff, eh? I hope one day this whole place becomes one big graveyard and all the loud-mouths are buried right damned here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17997,'%s collects some vegetables.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17998,'%s digs into the dirt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(17999,'%s moves a rock.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18000,'I didn\'t come all this way from Silvermoon City to toil my life away in a mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18001,'We should just leave.  Is this what we came to Outland for?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18002,'We were duped.  This is definitely not the promised land!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18003,'I am a blood elf.  I do not do physical labor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18004,'Kael\'thas lied to us.  The Outland is no paradise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18005,'I was once a great magister in Silvermoon City.  Now I\'m a demoted, former-foreman and little more than a slave!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18006,'They had no right to demote me to these menial tasks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18007,'Come.  Let\'s put down these crude instruments and walk away from all of this.  It isn\'t why we came to Outland.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18008,'If you\'ve been to Zangarmarsh, you might\'ve run into a fellow named Daniels. You know -- wears a strange helmet, only answers to \"the Specialist.\"$B$BOf course, I taught him everything he knows.$B$BDon\'t let the fine clothing fool you. I\'m still a rogue at heart. Daniels and I spent a lot of time in the trenches together, but that was before I retired. As far as I know, he\'s still out there, giving \'em hell.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18009,'Time for old Smithers to take a break...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18010,'Day in, day out, all we do is toil in this mine.  The blood elf male was not built for such manual labor.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18011,'%s yawns.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18012,'Welp, back to the grind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18013,'','STOP! Intruders are in the castle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18014,'','So you thought you could break into this palace of the Light and run away with our secrets! Vishas, interrogate this criminal at once!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18015,'My pleasure, milady!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18016,'Tell me everything, scum! Tell me or I\'ll rip the secrets from your flesh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18017,'It isn\'t talking, milady. I know it holds secrets! Naughty secrets!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18018,'I must conserve my energy... there\'s no telling when my portal magic will be needed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18019,'','My champion, destroy this monster!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18020,'The infidel shall be purified, milady!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18021,'ARGH! It has struck a fatal blow! I have failed you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18022,'%s staggers about as if he were mortally wounded.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18023,'','Mograine has fallen! You shall pay for this treachery! Arise, my champion! Arise!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18024,'','%s pretends to cast a healing spell on Renault.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18025,'','I do so hope these... Argent Dawn manage things here.  I would hate to sully my robe on demon rabble!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18026,'At your side, milady!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18027,'','We will attack as one!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18028,'','The children cheer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18029,'','We are victorious!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18030,'First squad is ready for battle!','First squad is ready for battle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18031,'All clear!','All clear!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18032,'We stand ready to defend the Eye!','We stand ready to defend the Eye!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18033,'Keep your voice down, Helcular. Strangers abound...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18034,'%s nods.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18035,'Second squad is ready to fight!','Second squad is ready to fight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18036,'The enemy will not get past us!','The enemy will not get past us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18037,'Our blades and spells are at the ready!','Our blades and spells are at the ready!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18038,'Third squad reporting in!','Third squad reporting in!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18039,'We will show our enemies no quarter!','We will show our enemies no quarter!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18040,'Our defenses stand ready!','Our defenses stand ready!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18041,'So you can teach me this... this...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18042,'Necromancy. It is called necromancy. And yes, I have it within my power to bless you with this gift.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18043,'And the Kirin Tor? What have they to say of necromancy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18044,'That is none of your concern, Helcular, as you are neither Kirin Tor nor a necromancer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18045,'As you were!','As you were!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18046,'Stand vigilant.','Stand vigilant.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18047,'Very well.','Very well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18048,'Excellent work.','Excellent work.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18049,'Your conduct makes me proud.','Your conduct makes me proud.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18050,'But to be perfectly frank, I do not give a damn what the Kirin Tor think! They are fools, set in their archaic ways.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18051,'Then teach me, Kel\'Thuzad. Teach me everything you know...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18052,'In due time, Helcular... All in due time...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18053,'%s looks to the left and then the right.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18054,'Come, Helcular, let me give you a small taste...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18055,'%s utters some unintelligible words.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18056,'Now do you see, Helcular? Do you doubt the power? I control life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18057,'And death...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18058,'I\'m still working out some minor details...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18059,'$n, please make sure that you tell Gahruj of our success.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18060,'That one where thousands of people are all watching us from up in the sky...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18061,'We\'re like their puppets - we dance and cry and fight and say silly things for their amusement.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18062,'Sometimes, even when I\'m awake, I think they\'re watching us. Maybe they\'re watching us right now...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18063,'Good thing you brought us nine others.  I think I\'ll finish this later.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18064,'Avast, Ed! Lemme show ye me ship! *hic*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18065,'Lead the way, Sanders!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18066,'What are you doing, Sanders?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18067,'I just be makin\' sure we wasn\'t followed! *hic*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18068,'It be clear...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18069,'Thar she be! Ain\'t she a beaut?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18070,'Aye, she\'s a beaut alright. And you parked her right next to my frigate! *hic*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18071,'That thar monster be yers, Ed? Arrr... She\'s a big\'un!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18072,'Ayep! She\'s all mine... I\'m gonna sail her around the world. Across the sea!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18073,'Arrr, Ed! She definitely be seaworthy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18074,'Sanders, what have you got in that chest?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18075,'Can ye keep a secret, Ed? Arr, dead men tell no tales!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18076,'%s nods.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18077,'It be me treasure, Ed. Me life\'s work! Arrr... One white shirt fit fer a pirate king to be wearin\'!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18078,'One red sash that ye can put on yer head or your britches. Pride o\' the fleet, that sash is...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18079,'An\' last but certainly not least, one enormous bag! Big enough to fit eight whole apples! Eight, Ed! Can ye believe it!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18080,'%s gasps.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18081,'Yarrr! Keep it down, Ed! Thar be scallywags about! Their scallywag ears be listenin\' for gasps like the one that just escaped yer lips!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18082,'I\'m sorry, Sanders. I\'ve just never seen such a bounty. It took me by surprise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18083,'It be alright, Ed. Me booty be locked away good in that thar chest. No fool will ever have Cap\'n Sanders\'s treasure! Let\'s go get another drink. The spirits be runnin\' low.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18084,'Keep your voices down. There are strangers about...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18085,'Brothers and sisters, I have called you here today to discuss the fate of Lordaeron.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18086,'%s lowers his voice to a whisper.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18087,'I hear things... Things that should not be.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18088,'The dead rise... Undead, from the frozen northlands. Whole cities have gone missing. I...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18089,'I have heard that Northrend is lost...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18090,'Gasps can be heard throughout the room.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18091,'We must stand at the ready. I have faced undead before. They are ruthless killing machines, devoid of any emotion or compassion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18092,'%s nods.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18093,'Aye, I\'ve battled them as well. We are ill-prepared as a kingdom to withstand such an assault.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18094,'What do you propose, Mograine?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18095,'Propose? I propose that we prepare. That we prepare our loved ones, family and friends for the possibility of an undead holocaust.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18096,'And there is this...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18097,'%s unlocks the chest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18098,'','By the Light! What is it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18099,'I have had this object in my possession for 10 years. Since Blackrock Spire...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18100,'I wrested it free from the remains of an orc lieutenant - a dark caster... It is from their homeworld.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18101,'Do not get too close. I laid a hand upon it once... Only once and never again. The memories of that day still linger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18102,'%s removes the gauntlet from his right arm and shows everyone his mangled hand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18103,'I surmise that this object is the living embodiment of shadows... darkness... It is a manifestation. It is a void.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18104,'I do not see how this evil artifact is relevant to the undead. We must destroy it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18105,'Emissary Taluun brought me with him hoping I could teach our new allies about the elements of this world... but no one will listen.','Emissary Taluun brought me with him hoping I could teach our new allies about the elements of this world... but no one will listen.',274,0,0,0,0,0,0,7,1,0,0,0,26124),
(18106,'%s shakes his head.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18107,'No, old friend, it is very relevant.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18108,'Let me ask you this, brothers and sisters: Can good exist without evil? Can there be light without dark?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18109,'And if that answer is no, then could it be possible that because this artifact exists, its polar opposite must also exist?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18110,'Could you imagine what the material manifestation of the Light could do against the undead?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18111,'Emissary Taluun brought me with him hoping I could teach our new allies about the elements of this world. So far they refuse to listen, but perhaps you would be willing?','Emissary Taluun brought me with him hoping I could teach our new allies about the elements of this world. So far they refuse to listen, but perhaps you would be willing?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18112,'Nonsense, Mograine! It must be destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18113,'Shock then silence overtakes the crowd.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18114,'Leave me, $c. I must attend to my duties with Ambassador Sunsorrow, dull as they are.','Leave me, $c. I must attend to my duties with Ambassador Sunsorrow, dull as they are.',274,0,0,0,0,0,0,1,1,0,0,0,26124),
(18115,'','While the focus of the Sha\'tar remains on Shadowmoon Valley and Illidan, we cannot ignore the threat that Kael\'thas Sunstrider presents.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18116,'I grow bored of guarding Ambassador Sunsorrow, $n. Care to spar a bit? Perhaps one of us will learn something.','I grow bored of guarding Ambassador Sunsorrow, $n. Care to spar a bit? Perhaps one of us will learn something.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(18117,'It consumed the Light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18118,'Impossible!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18119,'<Begin emergency shutdown.>','<Begin emergency shutdown.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18120,'As you approach the console the access crystal you have with you begins to hum softly and pulse with light.$B$BA rush of information flows into your mind and all of a sudden you\'re aware of the manaforge\'s energy production levels, its stability and its output to different pipelines.  The console awaits your command.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18121,'Is... Is it getting lighter? Its coloration... It is changing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18122,'BY THE LIGHT! Could it be? Could this be it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18123,'I must know... I will know...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18124,'%s reaches out to touch the light crystal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18125,'I... It... It is beautiful. What I felt when I touched it... The Light coursed through me and I through it... It healed my spirit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18126,'Your hand! It is healed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18127,'%s puts the crystal back inside the chest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18128,'Let us never again speak of this day. Our enemies are many. They need not know we hold such artifacts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18129,'I have seen it... From this blessed crystal we will forge a weapon. This weapon will hold inside it a piece of each of us... And when it is used against undead, it shall cast them down. And in its wake, it will leave only ashes...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18130,'The Ashbringer...','The Ashbringer...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18131,'Stop this immediately!','Stop this immediately!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18132,'When I get this hunk of junk up and running, I\'ll be able to walk the roads without fear of being jumped by bandits!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18133,'Just a few more swings and it\'ll be ready...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18134,'Maybe I can sell these things to other goblins? I\'ll be rich! Rich I say!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18135,'Yes, Zixil will be a household name! I\'ll corner the market!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18136,'Hands off the cloak! Yes, yes, I know that you want one too. Everybody wants one of my cloaks. Believe me, person of low moral and social standing, one day I will make my fortune from the sale of my cloaks. Everyone from here to Ironforge will know the name of Bartolo Ginsetti. The Ginsetti label will be coveted by all!','',274,5,15,0,0,0,0,0,1,0,0,0,26124),
(18137,'You there! Yes, you, peasant $g boy:girl;. Come quickly, I must tell you something... I must tell you about my greatness, lest such things are lost in the void!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18138,'Ooooh, YAH! Gaze upon my rippling musculature. Bask in the glow of my physique.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18139,'Show us truth! Show us the one who shall betray!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18140,'This is madness! I\'ve had enough! ENOUGH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18141,'EVERYBODY LISTEN UP!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18142,'I\'m speakin\' to you too, mister fancy britches Mograine! SHUT YER YAP!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18143,'NOW, everybody in this bar is gonna keep the noise to a minimum or ol\' Jessen is gonna bust out his rollin\' pin and cleaver and go orc on all of ya! IS EVERYONE CLEAR?!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18144,'AAAAAAaaaarrrrgh!!!!! SHUT IT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18145,'We must not fail the master.','We must not fail the master.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18146,'Understood.','Understood.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18147,'Yes sir!','Yes sir!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18148,'Spare a silver, friend?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18149,'Spare a copper? You won\'t need it soon. The end of days nears...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18150,'Got any food?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18151,'Please, $g sir:madam;, I have three hungry children! Did I say three? TEN HUNGRY CHILDREN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18152,'Psst... Spare a copper for some grog?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18153,'Will work for food...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18154,'Allow me to shine your shoes! Only one copper for the service!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18155,'Warning!  %s emergency shutdown process initiated by $n.  Shutdown will complete in two minutes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18156,'Emergency shutdown will complete in one minute.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18157,'','What\'ll it be?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18158,'','I\'ll come back later.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18159,'','More grog?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18160,'Look at it, Jon. It\'s glorious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18161,'Indeed. What better way to symbolize the bond of friendship and brotherhood between Tarren Mill and Southshore by erecting this tower at the halfway point between both towns. Brilliant!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18162,'You will not shut my manaforge down, scum!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18163,'%s crushes a vial of green gas.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18164,'The Lightwarden\'s job is twofold.  Protect the priesthood at all costs first and foremost.  Destroy the enemies of the Light wherever they may hide second.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18165,'We need you to send reinforcements to Manaforge Duro, Ardonis.  This is not a request, it\'s an order.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18166,'You cannot be serious!  We are severely understaffed and can barely keep this manaforge functional!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18167,'You will do as ordered.  Manaforge Duro has come under heavy attack by mana creatures and the situation is out of control.  Failure to comply will not be tolerated!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18168,'By Muradin\'s beard, $c. This land is on the brink of annihilation. I cannot imagine anyone survived here since the end of the second war.','By Muradin\'s beard, $c. This land is on the brink of annihilation. I cannot imagine anyone survived here since the end of the second war.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18169,'Area trigger works.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18170,'Ohh, look! Bloodmaul Brew! Mmmm...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18171,'Bloodmaul Brew? Me favorite!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18172,'Mmm. Me thirsty!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18173,'Wut\'s dis?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18174,'I\'m looking for someone to help me with a task that is long overdue.$B$BYou look capable.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18175,'The work that you did for me at the Ruins of Farahlon has got me back on schedule.  I\'m assembling my team to head out there now.$B$BThank you, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18176,'Legion everywhere... they must be dealt with!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18177,'Thanks to you, we\'ll be able to proceed with our plans for the Ruins of Farahlon.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18178,'What do you know about ethereals, fleshling?$B$BYou undoubtedly view us all in the same light, oblivious to the conflicts and struggles between the differing factions.$B$BPerhaps it is time for an introduction. I am Commander Ameer of the Protectorate - also your only hope of resolving the infestation of both void creature and Ethereum in this area.\n','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(18179,'Mooooo...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18180,'Moooooooooo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18181,'Bessy, you\'re home. Thank the Light!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(18182,'Uh oh...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18183,'What are Ethereum?','What are Ethereum?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18184,'The Ethereum were the ruling class of ethereal on my homeworld of K\'aresh. Tragically, we were forced to evacuate K\'aresh shortly before the void lord, Dimensius, unleashed his void armies upon the world and utterly decimated all that stood in his way. For this act, the Ethereum vowed vengeance. They have been tracking Dimensius ever since...$B$BThe Protectorate, however, were not a reaction to Dimensius. We were a reaction to Ethereum.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(18185,'I don\'t understand. What do you mean, Ameer?','I don\'t understand. What do you mean, Ameer?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18186,'The Ethereum have grown dark... twisted. Vengeance has become their only recourse and any that would stand in their way or not join their cause are considered enemies. Many saw that the Ethereum were plummeting into madness and left. Several of the Nexus-Princes of the Ethereum council abandoned the Ethereum to form other groups and factions with different goals. The Consortium are one such example of an off-shoot group. The Protectorate another... ','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(18187,'So what is your purpose?','So what is your purpose?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18188,'We feel that the Ethereum are as great a threat to our existence as Dimensius. Both must be stopped...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18189,'I think I understand now. Can I help with any of this? The Ethereum and void creatures are a threat to our survival as well.','I think I understand now. Can I help with any of this? The Ethereum and void creatures are a threat to our survival as well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18190,'Hostiles detected. Ending transmission.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18191,'Protectorate transmission complete.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18192,'Yo. I\'m Vixton Pinchwhistle, official Arena Vendor for the Steamwheedle Fighting Circuit. If you\'ve got the rep, I\'ve got the goods that\'ll make your mouth water.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18193,'The battle begins in 2 minutes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18194,'The battle begins in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18195,'The battle begins in 30 seconds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18196,'The battle has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18197,'Ugh... Me not feel so guud.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18198,'I\'m on a bombing mission for Forward Commander Kingston.  I need a gryphon destroyer!','I\'m on a bombing mission for Forward Commander Kingston.  I need a gryphon destroyer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18199,'If you\'re feeling queasy, speak with Pestle.  He might have something for motion sickness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18200,'Send me to the Abyssal Shelf!','Send me to the Abyssal Shelf!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18201,'These damned taxes are breaking my back. King Terenas must be losing his grip if he thinks all this reconstruction will boost the economy.','These damned taxes are breaking my back. King Terenas must be losing his grip if he thinks all this reconstruction will boost the economy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18202,'He hasn\'t been the same since the War. It\'s like he aged and became an old man overnight. That son of his, though - he\'ll make a fine king one day. \n','He hasn\'t been the same since the War. It\'s like he aged and became an old man overnight. That son of his, though - he\'ll make a fine king one day. \n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18203,'Prince Arthas? Please. Spends all his time chasing after Proudmoore\'s daughter, from what I hear. Boy\'s got more on his mind than affairs of state, I tell ya.\n','Prince Arthas? Please. Spends all his time chasing after Proudmoore\'s daughter, from what I hear. Boy\'s got more on his mind than affairs of state, I tell ya.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18204,'I\'m not so sure. I\'ve heard that he\'s being trained as a paladin. Terenas hopes the Silver Hand can teach him some discipline. If anyone can set Arthas straight, it\'d be old Uther.','I\'m not so sure. I\'ve heard that he\'s being trained as a paladin. Terenas hopes the Silver Hand can teach him some discipline. If anyone can set Arthas straight, it\'d be old Uther.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18205,'Aye, that\'s true. Uther - now there\'s a real hero for the people.','Aye, that\'s true. Uther - now there\'s a real hero for the people.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18206,'So have you heard about Lieutenant Blackmoore\'s new gladiator? Some say he\'s unbeatable.','So have you heard about Lieutenant Blackmoore\'s new gladiator? Some say he\'s unbeatable.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18207,'Aye, I seen \'im fight. He\'s an orc - big as they come. Lost a week\'s wages bettin\' against that one. Won\'t make that mistake again!','Aye, I seen \'im fight. He\'s an orc - big as they come. Lost a week\'s wages bettin\' against that one. Won\'t make that mistake again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18208,'Win or lose, the Lieutenant must be crazy to keep a pet orc like that. Those ones can\'t be trusted. Animals, they are.\n','Win or lose, the Lieutenant must be crazy to keep a pet orc like that. Those ones can\'t be trusted. Animals, they are.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18209,'True. True. Light help him if that monster ever gets free!','True. True. Light help him if that monster ever gets free!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18210,'Twenty years we\'ve been stranded in this hell-hole. It\'s all I can do not to run screaming through that blasted Portal. I want to see my loved ones again! I want them to know I\'m still alive.\n','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18211,'I feel the same. But there\'s still a job to do out here. It\'ll all be for naught if this evil finds its way back to Azeroth - back to our homes. We just have to hold on a while longer. Trust Danath - he\'s never let us down before.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18212,'It\'s not him I\'m worried about. It\'s these new rookies around here - and those creepy purple elves they brought with \'em. They ain\'t even proved themselves yet.\n','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18213,'C\'mon - you sound like a grumpy old man.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18214,'I am a grumpy old man!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18215,'Muahahahaha!  Go my minions... destroy the rocket-chief and his nether-rocket!  Annihilate Area 52!  Kneel!  Kneel before Dr. Boom!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18216,'<The apprentice occasionally looks over his shoulder, apparently responding to sounds that you can\'t hear.>$B$BGood day, $n. Pardon me if I seem distracted, but I\'m in the middle of a job for Farmer Natin. I want to have all of his horses shoed by the time he returns from the town hall. What can I help you with?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18217,'I wish to browse your wares.','I wish to browse your wares.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18218,'Dr. Boom\'s Bots are attacking!  Stop them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18219,'Yikes.  That was close!  And they\'re getting closer to me and the nether-rocket every time!  Someone needs to deal with Dr. Boom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18220,'You have won this battle, but not... the... war.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18221,'The Legion\'s final conquest has begun! Once again the subjugation of this world is within our grasp. Let none survive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18222,'Crumble and rot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18223,'Ashes to ashes, dust to dust!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18224,'Succumb to the icy chill... of death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18225,'It will be much colder in your grave.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18226,'All life must perish!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18227,'Your world is ours now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18228,'Victory to the Legion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18229,'The clock... is still... ticking.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18230,'You are defenders of a doomed world! Flee here, and perhaps you will prolong your pathetic lives!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18231,'You look tired....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18232,'Sweet dreams.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18233,'The swarm is eager to feed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18234,'Pestilence upon you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18235,'Let fire rain from above!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18236,'Earth and sky shall burn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18237,'Your hopes are lost!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18238,'Scream for me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18239,'Pity, no time for a slow death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18240,'Cry for mercy! Your meaningless lives will soon be forfeit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18241,'Your death will be a painful one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18242,'You... are marked.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18243,'Shaza-kiel!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18244,'You are nothing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18245,'Miserable nuisance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18246,'Agent Ya-six and I were given a high priority mission from Protectorate command to eradicate all signs of void creature infestation at Ultris. These were to be tactical strikes. Our last hit before returning to the Protectorate Watch Post was to be on a void lord named Arconus who had been getting fat off the fleshlings of the area.$B$BUnfortunately, we arrived a bit late. Ya-six and I got separated in the firefight with the flesh beasts. Now he\'s trapped inside, pinned down behind enemy lines.\n','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(18247,'Abandon all hope! The Legion has returned to finish what was begun so many years ago. This time, there will be no escape!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18248,'Your time is almost... up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18249,'Araxes, come in... Are you there Araxes? Visibility is nil. Warp storms blocking us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18250,'Copy. Status report, soldier.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18251,'Suffer, you despicable insect!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18252,'Just a taste... of what awaits you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18253,'Reesh, hokta!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18254,'No one is going to save you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18255,'Don\'t fight it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18256,'I hope this damned thing works. *Araxes pounds on the portable transponder.*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18257,'Your resistance is insignificant.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18258,'You are mine now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18259,'Bow to my will.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18260,'A-kreesh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18261,'Away, vermin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18262,'This world will burn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18263,'Manach sheek-thrish!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18264,'Your soul will languish for eternity.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18265,'All creation will be devoured.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18266,'I am the coming of the end!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18267,'I\'m here, commander.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18268,'We\'ve located the mark, commander. Ya-six and I have been separated. Requesting backup.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18269,'Copy that, Araxes. Backup is on the way. Hold your position. I repeat, hold your position.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18270,'Ameer, over and out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18271,'The %s\'s mechanical heart begins to beat softly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18272,'Welcome to Shatter Point, $n!  I hope you survive the experience!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18273,'If the Light cannot guide you, my friend, perhaps I can be of assistance. What is it you need?','If the Light cannot guide you, my friend, perhaps I can be of assistance. What is it you need?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18274,'This isle can be strange, can it not? Is there something I can do for you?','This isle can be strange, can it not? Is there something I can do for you?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18275,'Seeking storage? You\'ll want to head to the safety of the Exodar, then... the bankers will be more than happy to help you.','Seeking storage? You\'ll want to head to the safety of the Exodar, then... the bankers will be more than happy to help you.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18276,'','Odd city, ain\'t it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18277,'','Don\'t say much, do yeh?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18278,'','I miss me home, sometimes. Or maybe I just miss fightin\' for it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18279,'','I haven\'t seen me brothers in ages.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18280,'Mmm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18281,'Araxes! Send help! I\'m pinned down in the mines. I... I\'m not sure where I am exactly but I had the presence of mind to drop tracers on the ground behind me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18282,'I can\'t follow the tracers back out, too many flesh beasts in the way. Send someone in... Follow the tracers... Ya-six, out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18283,'Hey! Hey you! $R! Over here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18284,'I have misplaced Archmage Vargoth\'s Staff.','I have misplaced Archmage Vargoth\'s Staff.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18285,'|cffffff00The Alliance has taken control of a Spirit Tower!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18286,'|cffffff00The Horde has taken control of a Spirit Tower!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18287,'|cffffff00The Horde has lost control of a Spirit Tower!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18288,'|cffffff00The Alliance has lost control of a Spirit Tower!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18289,'','I have an idea.  Let\'s plant this shard in the ground and see what happens.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18290,'','Be sure to visit Vixton Pinchwhistle in Netherstorm\'s Area 52. As the Steamwheedle Fighting Circuit\'s official Arena Vendor, he has all sorts of incredible items for sale to those with enough Arena Points.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18291,'','The evil emanating from the crystal shard has lured one of the colossi.  Put it down quick!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18292,'Hippogryph Master','Hippogryph Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18293,'','Up here on the hill, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18294,'','$n, there\'s something that I need you to do.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18295,'The hippogryphs are well-tended near the Exodar proper. You should journey there if you wish to fly to Blood Watch.','The hippogryphs are well-tended near the Exodar proper. You should journey there if you wish to fly to Blood Watch.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18296,'The Exodar\'s once-vast supply of textiles has dwindled dangerously low. Your reputation with the draenei here would increase were you to assist us by donating cloth.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(18297,'Funaam is our guild registrar. His office has been set up within the Exodar. Just follow the road; you\'ll find it in no time.','Funaam is our guild registrar. His office has been set up within the Exodar. Just follow the road; you\'ll find it in no time.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18298,'Our humble inn is located in the north of Azure Watch; Chellan will take good care of you.','Our humble inn is located in the north of Azure Watch; Chellan will take good care of you.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18299,'Look at that handsome grouping of chaotic energies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18300,'Esbina will be happy to take care of your animal companion, my friend. She waits outside the inn within Azure Watch.','Esbina will be happy to take care of your animal companion, my friend. She waits outside the inn within Azure Watch.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18301,'Oh stop! You\'re going to make me turn red and then someone is going to mistake me for Ethereum and kill me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18302,'Ah, seeking training, are you? There are several instructors who are camped in Azure Watch... what are you after?','Ah, seeking training, are you? There are several instructors who are camped in Azure Watch... what are you after?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18303,'Yet they fell to the lure of Sargeras\' evil - and now they have become our most stalwart enemies.','Yet they fell to the lure of Sargeras\' evil - and now they have become our most stalwart enemies.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18304,'This is the wrong way. Arconus is at the other end of the mine. You\'re not chickening out, are you, fleshling? I won\'t follow a coward.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18305,'They are as cruel as they are powerful - and revel in the destruction of all that exists.','They are as cruel as they are powerful - and revel in the destruction of all that exists.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18306,'Druid? No one here follows that path... but I believe I heard of someone matching that description near the Exodar. Shalannius, I think?','Druid? No one here follows that path... but I believe I heard of someone matching that description near the Exodar. Shalannius, I think?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18307,'What? You wish to donate cloth to Silvermoon?$B$BYou\'re merely after a Hawkstrider, aren\'t you? Very well, very well... do the city this service, and I will see to it that your reputation here rises.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(18308,'They are fearless and unwaveringly loyal to their master\'s godlike will.','They are fearless and unwaveringly loyal to their master\'s godlike will.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18309,'Acteon is our resident tracker, and a good one he is, too - the skins he wears are testament to his skill. His camp is in the southeast of Azure Watch.','Acteon is our resident tracker, and a good one he is, too - the skins he wears are testament to his skill. His camp is in the southeast of Azure Watch.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18310,'Arconus is close. I can feel him. Take the northwest passage. He should be just up and around the corner. Be ready to battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18311,'The Doomguard are utterly devoted to their Pit Lord masters and revel in the destruction of worlds.','The Doomguard are utterly devoted to their Pit Lord masters and revel in the destruction of worlds.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18312,'Turn its back to me! I need a clean shot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18313,'This is a waste of my time. Where\'s the action?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18314,'Did I forget to mention that I\'m injured?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18315,'Not a bad shot. For a fleshling...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18316,'I hate flesh beasts...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18317,'For mastery over the arcane, you need look no further than Semid. He teaches on the eastern side of Azure Watch along with Ruada.','For mastery over the arcane, you need look no further than Semid. He teaches on the eastern side of Azure Watch along with Ruada.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18318,'This reflection of me is exceptionally weak. Don\'t let these brutes lay a finger on my precious image.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18319,'The good Tullas is a noble woman, and a stalwart defender of the Light. Her lessons are taught in the inn proper.','The good Tullas is a noble woman, and a stalwart defender of the Light. Her lessons are taught in the inn proper.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18320,'In Chellan\'s small but serviceable inn, you can find the priest Guvan.','In Chellan\'s small but serviceable inn, you can find the priest Guvan.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18321,'Shaman','Shaman',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18322,'You\'re one of the shaman? Hm. I suppose you are free to choose your own path... whatever that path may be. Tuluun has an isolated, small camp in the northwest of Azure Watch.','You\'re one of the shaman? Hm. I suppose you are free to choose your own path... whatever that path may be. Tuluun has an isolated, small camp in the northwest of Azure Watch.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18323,'Ruada trains young fighters in the eastern portion of Azure Watch. If training in the practical art of warfare is what you\'re looking for, she will help you.','Ruada trains young fighters in the eastern portion of Azure Watch. If training in the practical art of warfare is what you\'re looking for, she will help you.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18324,'There are a number of skilled tradesmen scattered around Azuremyst. Which one are you looking for?','There are a number of skilled tradesmen scattered around Azuremyst. Which one are you looking for?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18325,'%s stops playing dead and charges forward!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18326,'Daedal knows his way around the art of brewing potions. He works closely with Fateema in western Azure Watch.','Daedal knows his way around the art of brewing potions. He works closely with Fateema in western Azure Watch.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18327,'We have no smithy set up in Azure Watch. However, I\'ve seen a few young blacksmiths coming from that odd encampment on the south coast. Perhaps you should investigate.','We have no smithy set up in Azure Watch. However, I\'ve seen a few young blacksmiths coming from that odd encampment on the south coast. Perhaps you should investigate.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18328,'We had no cooks to spare, but it is a bit odd... there are some delectable scents on the south wind. Follow your nose, eh?','We had no cooks to spare, but it is a bit odd... there are some delectable scents on the south wind. Follow your nose, eh?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18329,'Our enchanters spend their days in the Exodar, working away at any number of projects. Nahogg will start your training.','Our enchanters spend their days in the Exodar, working away at any number of projects. Nahogg will start your training.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18330,'The local artificer, Daelo, can teach you the basics of engineering. Perhaps you can help our technician fix that malfunctioning communications device!','The local artificer, Daelo, can teach you the basics of engineering. Perhaps you can help our technician fix that malfunctioning communications device!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18331,'Fateema is our anchorite, and she has been invaluable in tending crash victims. She practices her trade on the western side of the Watch.','Fateema is our anchorite, and she has been invaluable in tending crash victims. She practices her trade on the western side of the Watch.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18332,'An aspiring angler... well, Diktynna lives on the shore of Ammen Ford, using her net and pole to keep us all supplied. I am certain she could use the help.','An aspiring angler... well, Diktynna lives on the shore of Ammen Ford, using her net and pole to keep us all supplied. I am certain she could use the help.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18333,'Heur has studied the local flora since our landing. He will be able to guide you. You can find him working with Daedal on the western edge of Azure Watch.','Heur has studied the local flora since our landing. He will be able to guide you. You can find him working with Daedal on the western edge of Azure Watch.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18334,'Our new allies, the Stillpine furbolgs, have expressed interest in taking what hides we find. They live to the north; I would seek knowledge from them.','Our new allies, the Stillpine furbolgs, have expressed interest in taking what hides we find. They live to the north; I would seek knowledge from them.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18335,'Dulvi is the woman you want. She trains new prospects in the middle of the Watch.','Dulvi is the woman you want. She trains new prospects in the middle of the Watch.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18336,'Travel to Stillpine Hold, my friend. The furbolgs there have been very helpful, and they might have just the expertise you need.','Travel to Stillpine Hold, my friend. The furbolgs there have been very helpful, and they might have just the expertise you need.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18337,'We have no tailors here in Azure Watch. You might try the encampment on the beach, however - they seem to have a number of tradesmen from across the sea.','We have no tailors here in Azure Watch. You might try the encampment on the beach, however - they seem to have a number of tradesmen from across the sea.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18338,'Jewelcrafting','Jewelcrafting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18339,'Looking for a lapidary? Our jewelcrafters are in the Exodar, using the materials they have uncovered to work wonders. Speak with Farii when you arrive.','Looking for a lapidary? Our jewelcrafters are in the Exodar, using the materials they have uncovered to work wonders. Speak with Farii when you arrive.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18340,'You want what?! I\'ve heard something about one of those odd draenei creatures in the Valley of Heroes. Maybe she knows; I don\'t.','You want what?! I\'ve heard something about one of those odd draenei creatures in the Valley of Heroes. Maybe she knows; I don\'t.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18341,'You\'re weak! COME ON!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18342,'Now you will know fear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18343,'For Salhadaar! For the Nexus-King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18344,'Taste pure energy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18345,'Your battle prowess is nothing compared to mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18346,'Your death will serve as a message to all that would dare set foot upon Ethereum territory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18347,'Pathetic. Is that the best you can do?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18348,'Run away while you still can!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18349,'That Broken worm gave you that staff, didn\'t he?  Did he also tell you he\'s the one that sold out his tribe?  No matter, you will both pay for this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18350,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18351,'That Broken worm!  Did he come clean to you!?  Did he tell you he\'s the one that sold out his tribe to my master?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18352,'The spirit of water has left us.  Our tribe is doomed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18353,'Walk free, elder.  Bring the spirits back to your tribe.','Walk free, elder.  Bring the spirits back to your tribe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18354,'The winds do not speak to our tribe anymore, $n.  My people are lost without elders to bring the spirits to them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18355,'These chains that bind me prevent me from bringing the spirit of fire to my people, $n.  Souls without fire are souls that cannot rebel against their masters.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18356,'I am free!  I will ask the spirit of fire to return to us so that my people may have the courage to fight their masters!  I thank you, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18357,'I\'m free!  The spirit of water returns to my people.  It will bring us the wisdom we need to survive in this harsh land.  I am in your debt, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18358,'You\'ve freed me!  The winds speak to my people once again and grant us their strength.  I thank you, stranger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18359,'$n has taken the flag!','',0,0,0,0,0,0,0,0,0,0,9431,0,26124),
(18360,'I\'ve heard there\'s a pair of Wildhammer shamans visiting the Dwarven District, so you might try your luck there.$B$BThe draenei Farseer who used to lounge about the Valley of Heroes went off to meet them, too.','I\'ve heard there\'s a pair of Wildhammer shamans visiting the Dwarven District, so you might try your luck there.$B$BThe draenei Farseer who used to lounge about the Valley of Heroes went off to meet them, too.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18361,'The flag has been dropped!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(18362,'Paladin','Paladin',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18363,'Us no like paladins. Elf lady come to city, stay in Royal Quarter. Her paladin. You talk, learn paladin things.','Us no like paladins. Elf lady come to city, stay in Royal Quarter. Her paladin. You talk, learn paladin things.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18364,'The flag has been reset.','',0,0,0,0,0,0,0,0,0,0,8192,0,26124),
(18365,'Paladin? Have you been partaking of the Apothecary\'s concoctions or some such thing? I have heard a rumor that some elven contingent is visiting the Dark Lady within the Undercity. Perhaps one of them might know.','Paladin? Have you been partaking of the Apothecary\'s concoctions or some such thing? I have heard a rumor that some elven contingent is visiting the Dark Lady within the Undercity. Perhaps one of them might know.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18366,'%s discards his weapons and reaches for a polearm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18367,'Cowards! You\'ll never draw me into the shadows!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18368,'%s is exhausted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18369,'And just what do you think you are doing?  You dare to interfere with my master\'s experiment?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18370,'Do you like what we\'ve done here?  Perhaps we will drop these crystals from the sky all over Outland.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18371,'I grow bored with your attempt to heal the land and quell the energies summoning and driving the colossi mad.  Goliathon, King of the Colossi, Prince Kael\'thas and I demand that you defend the crystal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18372,'We will meet again soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18373,'','Your help was invaluable, my friend.$B$BI can assure you that the Cenarion Expedition will do everything in its power to counter any future tainted crystals dropped from the heavens by Illidan.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18374,'HIT ME!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18375,'$n has captured the flag!','',0,0,0,0,0,0,0,0,0,0,8173,0,26124),
(18376,'Children, come to me!','Children, come to me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18377,'Hah!  Your ritual has failed, fool!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18378,'Bring out the gladiator!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18379,'My money\'s on the fleshfiend. That creature is terrifying!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18380,'There\'s no way some Protectorate prisoner is going to defeat our gladiator!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18381,'The netherlisk will be a challenge but the gladiator will pull through!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18382,'How do you defeat that which has no life?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18383,'I hear the rock flayer has been sucking down unstable energy since its capture.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18384,'$n has captured the flag!','',0,0,0,0,0,0,0,0,0,0,8213,0,26124),
(18385,'Light!  Do not fail me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18386,'Do not die on me, vindicator!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18387,'Kael\'thas and the Legion... just what we needed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18388,'You\'ve saved me, fleshling! Ameer will hear of this noble act.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18389,'We\'re here for you, lost brother.  It is custom to offer you a chance to repent before you are destroyed.  We offer you this chance, as the naaru\'s law commands.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18390,'Do not make me laugh.  Is this the mighty Aldor army that\'s come to defeat me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18391,'We may be few, Socrethar, but our faith is strong.  Something you will never understand.  Now that custom has been served, prepare to meet your end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18392,'Yes, let us settle this.  Before we begin, however, there\'s somebody I\'d like you to meet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18393,'How... how could you?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18394,'My heart has been filled with hate since our sworn enemies were allowed into our city.  I knew the one known as Voren\'thal before he was called a Seer.  It was by his hand that my brother was slain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18395,'I turned that hate on the Illidari and the Burning Legion... but they weren\'t the ones who betrayed us.  We were the naaru\'s chosen!  We lived and died for them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18396,'Once the hatred in my heart became focused, everything became clear to me.  Shattrath must be destroyed and the naaru with it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18397,'Socrethar is clouding your mind, Kaylaan!  You do not mean these words!  I remember training you when you were but a youngling.  Your will was strong even then!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18398,'You are wrong, Adyen.  My mind has never been clearer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18399,'Teacher...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18400,'','The Light wants its lost son back, Socrethar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18401,'','I offer myself in exchange.  You will have Ishanah, the High Priestess of the Aldor, as your prisoner if you release Kaylaan from your dark grasp.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18402,'You foolish old hag... Why would I do that when I can have you both?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18403,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18404,'No!  What have I done?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18405,'Light grant me strength!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18406,'Oh, please!  This is sickening; I\'m going to have to kill you all myself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18407,'Slay these dogs, Kaylaan!  Earn your place in the Burning Legion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18408,'What are you waiting for?  Finish them, young one.  Let your hatred burn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18409,'Yes... master.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18410,'We will not fail.','We will not fail.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18411,'What is this place?','What is this place?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18412,'Where is Medivh?','Where is Medivh?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18413,'How do you navigate the tower?','How do you navigate the tower?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18414,'This is the tower of Karazhan and residence of my master, Medivh. As a humble doorman, there is little else I can explain to you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18415,'All inquiries regarding Medivh should be directed to Moroes, the Tower Steward. I myself know very little about the Master\'s business. I believe several nobles are currently having an audience with Moroes in the Banquet Hall, if you wish to inquire further.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18416,'From here in the Gatehouse, you may travel in one of three directions. The stairs behind me lead to the Grand Ball Room, where guests are currently being entertained. I\'m sure you can smell the nearby Stables, and the entrance to Servant\'s Quarters lies next to the Gatehouse door.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18417,'Who is Midnight?','Who is Midnight?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18418,'Midnight is Attumen the Huntsman\'s personal mount. I\'ve never seen a faster, stronger, or more mean spirited horse. And her rider is even more temperamental! Everyone keeps their distance from her, lest they get a hoof upside the head from Midnight or a beating from Attumen.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18419,'The damn spiders, the endlessly screeching bats, and those blasted demon beasts have all taken residence in the Servant\'s Quarters. It\'s not safe to walk around anymore, especially when the big ones come out of hiding.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18420,'Help you with what situation?','Help you with what situation?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18421,'Big ones?','Big ones?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18422,'Oh yeah, I\'ve never seen them personally, but sometimes I hear them in the distance. Keep a watchful eye out for them if you venture inside.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18423,'I don\'t have time for idle chitchat. I have men and women to train, and a tower to watch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18424,'Greetings! Behold one of the finest musical instruments in all of Lordaeron. It\'s a true honor to perform for the Master and all his guests. Take a seat in the audience, I hear a show is starting soon.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18425,'Splendid! Wonderful! Such an excellent performance from a relative unknown! Do you have an agent, perhaps?','',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(18426,'This party is pointless. Those foolish nobles will never get to see Medivh. Can\'t they see this? I should have just stayed in Darkshire with my family instead of wasting my time here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18427,'It\'s here... somewhere... I know it. Somewhere in this library is the knowledge I\'m looking for...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18428,'','This tower is complete and utter madness. This isn\'t a library, it\'s a huge haystack of books and I don\'t think the needle even exists! Now, what was I doing?',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(18429,'Your presence here is interfering with very important work. Please leave at once. Where was I, again?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18430,'Ah, such an odd place to find potential customers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18431,'What could you be selling?','What could you be selling?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18432,'Let\'s do this... Just keep me covered and I\'ll deliver the package.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18433,'By the second sun of K\'aresh, look at this place! I can only imagine what Salhadaar is planning. Come on, let\'s keep going.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18434,'With this much void waste and run-off, a toxic void horror can\'t be too far behind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18435,'Look there, fleshling! Salhadaar\'s conduits! He\'s keeping well fed....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18436,'Alright, keep me protected while I plant this disruptor. This shouldn\'t take very long.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18437,'Done! Back up! Back up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18438,'Keep these things off me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18439,'I\'m under attack! I repeat, I am under attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18440,'I need to find a new line of work.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18441,'Protect the conduit! Stop the intruders!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18442,'Looks like my work here is done. Report back to the holo-image of Ameer over at the transponder.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18443,'Prepare to enter oblivion, meddlers. You have unleashed a god!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18444,'Elen-ak shaktha!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18445,'Rise, my soldiers, and march for me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18446,'You will... ultimately fail.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18447,'My life... to the master.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18448,'A pleasure... to serve the master.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18449,'One less enemy of the master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18450,'Lambs for the slaughter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18451,'Let this torment end!!','Let this torment end!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18452,'I am... released?','I am... released?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18453,'Is it really... over?','Is it really... over?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18454,'I obey.','I obey.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18455,'You\'re the lucky one.','You\'re the lucky one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18456,'Let these monsters taste cold steel!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18457,'Back, hold them back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18458,'Agghh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18459,'I... can\'t....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18460,'Back to the void with you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18461,'One less demon to contend with!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18462,'For Lordaeron! For victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18463,'Rout these demons!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18464,'Good will... prevail.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18465,'Light receive me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18466,'For the Light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18467,'Justice is served!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18468,'I\'m itchin\' to shoot somethin\'!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18469,'Blow \'em away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18470,'Carry on the fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18471,'For... Khaz... Modan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18472,'Take that, ya freakish git!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18473,'That\'s what I\'m talkin\' about!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18474,'','I think a change is in order....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18475,'','You could use a makeover.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18476,'','Not... my best... day.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18477,'','Res...?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18478,'','Next!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18479,'%s breaks down into globules!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18480,'For... Quel\'Thalas.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18481,'Stay... the course.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18482,'Vengeance is ours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18483,'We\'re doomed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18484,'It\'s the end of the world!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18485,'Have at them! Lok\'tar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18486,'Destroy them all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18487,'Keep... fighting!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18488,'Spill their... blood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18489,'Demon filth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18490,'Another one down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18491,'Greetings, fleshling. I am Navuud, chief researcher here at the Protectorate Watch Post.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18492,'','Leaving Kael\'thas was the best thing any of us ever did.  His followers are too blind or too scared to realize where he\'s leading them.$B$BWe, however, are not.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18493,'For the Earth Mother!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18494,'Crush them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18495,'I return... to the earth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18496,'My spirit... goes on.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18497,'Balance must be restored!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18498,'This world is not for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18499,'Take their heads!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18500,'We kill \'em good, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18501,'Dis no good....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18502,'It all over... now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18503,'You stay dead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18504,'Da Legion gonna pay.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18505,'It all over for you, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18506,'Bad mojo.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18507,'I no gonna make it....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18508,'The spirits condemn you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18509,'My spirit will fight on.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18510,'I am one... with all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18511,'Kagh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18512,'Help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18513,'','Press the attack!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18514,'','Andu-falah-dor!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18515,'','Don\'t give... up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18516,'','Elune help us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18517,'','I make this look easy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18518,'','One shot, one kill!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18519,'','Ahhh!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18520,'','I tried.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18521,'','Yes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18522,'','Take that!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18523,'','Ehrin\'delumina shorinel!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18524,'','Begone forever!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18525,'','Take the fight to them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18526,'','Tor ilisar\'thera\'nal!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18527,'','If it is Elune\'s... will.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18528,'','Keep at them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18529,'We will drive you from our lands!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18530,'Death is too good for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18531,'Remain... strong.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18532,'The land... cries out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18533,'You deserve worse than death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18534,'Another falls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18535,'Winds... carry me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18536,'Do not... despair.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18537,'','I\'m in jeopardy! Help me if you can!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18538,'','They\'ve broken through!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18539,'','I did... my best.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18540,'','Don\'t give up! We must prevail!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18541,'','Hold them back as long as possible!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18542,'','We must hold strong!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18543,'','We are lost! Fall back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18544,'I will lay down for no one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18545,'Bring the fight to me and pay with your lives!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18546,'I\'ve lost Archmage Vargoth\'s Staff. Can you replace it?','I\'ve lost Archmage Vargoth\'s Staff. Can you replace it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18547,'There are those who seek to lie and twist the truth.  Seers, on the other hand, bring the truth to light.$B$BThe purpose of this library, $n, is to make a seer out of everyone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18548,'Among ethereals, certain members deal specifically with flesh and beings of flesh. Those individuals are known as flesh handlers.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18549,'You seek something in our fair land?','You seek something in our fair land?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18550,'Skymistress Gloaming stands just outside the Magister\'s Gate near Silvermoon proper, tending to the dragonhawks.','Skymistress Gloaming stands just outside the Magister\'s Gate near Silvermoon proper, tending to the dragonhawks.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18551,'If you\'re looking to register a guild, I would suggest inquiring within the walls of Silvermoon City itself.','If you\'re looking to register a guild, I would suggest inquiring within the walls of Silvermoon City itself.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18552,'Delaniel keeps her inn well in the southeastern corner of Falconwing Square. Good food, fine wine, soft beds... what more could one ask for?','Delaniel keeps her inn well in the southeastern corner of Falconwing Square. Good food, fine wine, soft beds... what more could one ask for?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18553,'Some rangers seem to be unable to look after their beastly charges themselves. If you simply must stow such a thing somewhere in town, Anathos will take it off your hands. She waits and works in Falconwing Square, outside the inn.','Some rangers seem to be unable to look after their beastly charges themselves. If you simply must stow such a thing somewhere in town, Anathos will take it off your hands. She waits and works in Falconwing Square, outside the inn.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18554,'A cow woman who claims to be a druid has set up camp within Silvermoon. She\'s no doubt grazing on our planters as we speak.','A cow woman who claims to be a druid has set up camp within Silvermoon. She\'s no doubt grazing on our planters as we speak.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18555,'The rangers take their lessons from Hannovia, a farstrider who stays in the northeast building of Falconwing Square.','The rangers take their lessons from Hannovia, a farstrider who stays in the northeast building of Falconwing Square.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18556,'Garridel teaches the arcane arts within Falconwing Square; you can find her on the second floor of the inn.','Garridel teaches the arcane arts within Falconwing Square; you can find her on the second floor of the inn.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18557,'Is this the best you can throw at me, Salhadaar??','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18558,'Time for the pain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18559,'Another pitiful contender...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18560,'Send it out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18561,'For the Protectorate! DIE ETHEREUM FILTH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18562,'Thanks, friend. Will you help me get out of here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18563,'Blood Knight Noellene awaits young trainees within the northeast building of the square.','Blood Knight Noellene awaits young trainees within the northeast building of the square.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18564,'If priestly knowledge is what you seek, Ponaris is your man. He works with the others on the second floor of Delaniel\'s inn.','If priestly knowledge is what you seek, Ponaris is your man. He works with the others on the second floor of Delaniel\'s inn.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18565,'There\'s a building in the northeast of Falconwing Square... within, you\'ll most likely find Tannaria, a woman well skilled in remaining out of sight.','There\'s a building in the northeast of Falconwing Square... within, you\'ll most likely find Tannaria, a woman well skilled in remaining out of sight.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18566,'We\'re not too far from the Protectorate Watch Post, $n. This way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18567,'Commander! This fleshling rescued me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18568,'%s salutes Commander Ameer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18569,'Celoenus is our resident expert on the summoning of demons. He resides in the Falconwing Square Inn, no doubt on the second floor.','Celoenus is our resident expert on the summoning of demons. He resides in the Falconwing Square Inn, no doubt on the second floor.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18570,'I know of a local alchemist. Sheynathren, I believe his name is. When last I saw him, he was heading off to Saltheril\'s Haven, no doubt to engage in one of his ridiculous parties.','I know of a local alchemist. Sheynathren, I believe his name is. When last I saw him, he was heading off to Sartheril\'s Haven, no doubt to engage in one of his ridiculous parties.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18571,'The farstriders keep a smith at their retreat in the eastern portion of Eversong. Arathel might be able to help you.','The farstriders keep a smith at their retreat in the eastern portion of Eversong. Arathel might be able to help you.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18572,'Delaniel keeps a delightful cook named Quarelestra on staff. You\'ll do well to learn from her. Naturally, you\'ll find her in the Falconwing Square inn.','Delaniel keeps a delightful cook named Quarelestra on staff. You\'ll do well to learn from her. Naturally, you\'ll find her in the Falconwing Square inn.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18573,'Look no further than Saltheril\'s little celebration if you\'re after the enchanter Eredania. She received her invitation a few days ago.','Look no further than Saltheril\'s little celebration if you\'re after the enchanter Eredania. She received her invitation a few days ago.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18574,'Such a dangerous and unpredictable profession cannot reliably be practiced among our pristine woods without calamitous consequences. You might try Silvermoon City itself, however; the walls are strong enough to weather the blasts.','Such a dangerous and unpredictable profession cannot reliably be practiced among our pristine woods without calamitous consequences. You might try Silvermoon City itself, however; the walls are strong enough to weather the blasts.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18575,'For those who prefer to rely on mundane methods of mending the flesh, Kanaria keeps a tidy station within the Falconwing Square inn.','For those who prefer to rely on mundane methods of mending the flesh, Kanaria keeps a tidy station within the Falconwing Square inn.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18576,'There is a fisherman within our grand city... if spending time with pungent, wet, flopping abominations is your idea of a pleasant day.','There is a fisherman within our grand city... if spending time with pungent, wet, flopping abominations is your idea of a pleasant day.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18577,'Who better to have tending one\'s floral arrangements for a party than the botanist Tyniarrel? I\'m sure Saltheril pays him in wine.','Who better to have tending one\'s floral arrangements for a party than the botanist Tyniarrel? I\'m sure Saltheril pays him in wine.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18578,'...they told us not to go... but we went anyway... they told us not to go... but we went anyway...','...they told us not to go... but we went anyway... they told us not to go... but we went anyway...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18579,'Ameer might be worried about what the Ethereum are doing but I\'m squarely focused on the real danger here: Dimensius.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(18580,'Our resident jewelcrafter, Aleinia, can be found within Delaniel\'s establishment in Falconwing Square. She might be looking for an apprentice.','Our resident jewelcrafter, Aleinia, can be found within Delaniel\'s establishment in Falconwing Square. She might be looking for an apprentice.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18581,'Sathein finds the lynx hides in Eversong perfect for his creations. You should speak to him - he stands with Mathreyn just southwest of the Magister\'s Gate.','Sathein finds the lynx hides in Eversong perfect for his creations. You should speak to him - he stands with Mathreyn just southwest of the Magister\'s Gate.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18582,'The miners can be found within Silvermoon City, no doubt close to the odiferous forges where they smelt their gains.','The miners can be found within Silvermoon City, no doubt close to the odiferous forges where they smelt their gains.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18583,'Mathreyn is skilled in the barbaric practice of skinning, if that is truly your wont. He supplies Sathein with hides; you can find them both just southwest of the Magister\'s Gate.','Mathreyn is skilled in the barbaric practice of skinning, if that is truly your wont. He supplies Sathein with hides; you can find them both just southwest of the Magister\'s Gate.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18584,'The good sempstress is of late occupied at Saltheril\'s Haven; her prowess with a needle and thread is assuredly appreciated there.','The good sempstress is of late occupied at Saltheril\'s Haven; her prowess with a needle and thread is assuredly appreciated there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18585,'What are you after? Speak up.','What are you after? Speak up.',1,0,0,1,0,0,0,7,1,0,0,0,26124),
(18586,'What elekks are for sale?','What elekks are for sale?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18587,'The %s, having fought the good fight, falls to pieces.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18588,'In a different time and place I would\'ve been considered but a youngling.  Here I am a seasoned combatant ready to live and die for the glory of the naaru.$B$BTen of us went into Manaforge Ara.  All the others fell to the Legion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18589,'%s begins to metamorphose...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18590,'It is time to face Socrethar, $n.  Are you ready?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18591,'I\'m ready, Adyen.','I\'m ready, Adyen.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18592,'Did the Scryers send you to contact me?  You do not look like a Scryer at all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18593,'','Speak quickly; I don\'t have time to waste on idle chatter. The Forsaken have become a force to be reckoned with, but there is still much to do in a given day. This city doesn\'t run itself.$b$bWhat do you want?',5,0,0,0,0,0,0,1,1,0,0,0,26124),
(18594,'It is hopeless... I\'ve done all I can.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18595,'I\'ve failed.  The Light has abandoned me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18596,'You don\'t have what it takes to fight in the Steamwheedle Fighting Circuit, $c. Stop wasting my time.','You don\'t have what it takes to fight in the Steamwheedle Fighting Circuit, $c. Stop wasting my time.',25,0,0,1,0,0,0,0,1,0,0,0,26124),
(18597,'All right, $c. You think you have what it takes to make it in the Steamwheedle Fighting Circuit\'s arena battlegrounds?','All right, $c. You think you have what it takes to make it in the Steamwheedle Fighting Circuit\'s arena battlegrounds?',1,0,0,1,0,0,0,0,1,0,0,0,26124),
(18598,'I would like to fight in an arena.','I would like to fight in an arena.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18599,'You hear a faint echo....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18600,'You hear a loud rumble of metal grinding on stone...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18601,'The naga\'s water boiler activates and the sound of dying frenzies can be heard below.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18602,'You only hasten the inevitable. In time, all will be devoured!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18603,'Ye\'ll find the battlemasters around the war table in the Hall of Arms.','Ye\'ll find the battlemasters around the war table in the Hall of Arms.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18604,'','You will find the the battlemasters gathered at the Warrior\'s Terrace.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18605,'You\'ll find the battlemasters in the war room of Stormwind Keep.','You\'ll find the battlemasters in the war room of Stormwind Keep.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18606,'%s seems to have weakened.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18607,'Go to the Hunter Rise. You will find the battlemasters there.','Go to the Hunter Rise. You will find the battlemasters there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18608,'You will find the battlemasters inside the Hall of the Brave in the Valley of Honor.','You will find the battlemasters inside the Hall of the Brave in the Valley of Honor.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18609,'You go to Royal Quarter. They all there, in circle around room.','You go to Royal Quarter. They all there, in circle around room.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18610,'Arena Battlemaster','Arena Battlemaster',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18611,'You will find him in the Caregiver Center in the Seat of the Naaru. Light be with you.','You will find him in the Caregiver Center in the Seat of the Naaru. Light be with you.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18612,'Oh yeah, I got muffins!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(18613,'Alright, muffin man, show me your muffins!','Alright, muffin man, show me your muffins!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18614,'Fresh muffins!  Get your fresh muffins right here!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(18615,'What\'s up?  I hope you\'re having a fabulous day.  Come buy one of my muffins!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18616,'I\'ve got muffins right over here.  Come on over!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(18617,'Yea, yea, I\'m the muffin man.  You know why?  Because I sell muffins, that\'s why!','',1,5,0,0,500,0,0,0,1,0,0,0,26124),
(18618,'Nothing compares to my magnificent muffins!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(18619,'Get \'em hot and fresh while you can.  You won\'t find a better price on muffins anywhere else in Shattrath.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18620,'Nothing like a tankard full to wash down one of my magnificent muffins.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18621,'Yea, that hit the spot.  Muffins for sale!  Get your fresh muffins right here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18622,'','The Legion requires you work faster!  Faster, worms!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18623,'','The full might of the Burning Legion shall arrive soon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18624,'','Do not stop!  The hour of our glory draws near!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18625,'','You shall suffer eternally if you fail!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18626,'As you say!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18627,'Hey you!  Get over here and check out my hot muffins!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18628,'I live to serve!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18629,'Always with the speeches.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18630,'Get me the parts for another Fel Reaver, now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18631,'There are enough parts to rebuild it. Stronger, faster, better!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18632,'I don\'t care about the shell, just get the internal parts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18633,'Fleshling, I am Captain Saeed of the Protectorate and these soldiers that stand by me are my avengers. We await orders from the fleshling who destroyed the void conduit. On that fleshling\'s word, we will make our way up to Dimensius\'s lair and wait for the word to make a final strike!$B$BToo long it has been... The void lord will soon face our combined might!','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(18634,'Saeed is currently engaged or awaiting orders to engage. You may check directly east of me and see if Saeed is ready for you. If he is not present then he is off fighting another battle. I recommend that you wait for him to return before attacking Dimensius.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18635,'I need a new phase disruptor, Professor.','I need a new phase disruptor, Professor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18636,'The nether drake looks upon you approvingly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18637,'I\'m ready to fly! Take me up, dragon!','I\'m ready to fly! Take me up, dragon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18638,'The nether drake refuses to let you mount it. Be sure to get a phase disruptor from Professor Dabiri. It will not take you up without one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18639,'I am that fleshling, Saeed. Let\'s go!','I am that fleshling, Saeed. Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18640,'This is it, $n. We charge on your orders! Just say the word and my men and I will engage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18641,'I am ready. Let\'s make history!','I am ready. Let\'s make history!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18642,'You heard the fleshling! MOVE OUT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18643,'Tell me when you are ready, $n. We will attack on your command.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18644,'It\'s now or never, soldiers! Let\'s do this! For K\'aresh! For the Protectorate!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18645,'The time for your destruction has finally come, Dimensius!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18646,'%s laughs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18647,'Time only has meaning to mortals, insect. Dimensius is infinite!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18648,'I need Saeed\'s help, Professor! Where is he?','I need Saeed\'s help, Professor! Where is he?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18649,'We are victorious! Dimensius is no more! Report back to the Professor, hero.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18650,'Welcome to Eco-Dome Midrealm, traveler. I would warn you to be wary of dealing with that goblin, Shauly. I don\'t believe I\'ve ever heard anyone use the word \"buddy\" as punctuation before.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18651,'Now to begin the repairs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18652,'It\'s working! Ghabar will be pleased to hear the news.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18653,'','We\'ve finally got what we came here for. I just wish we\'d hired $n right away and saved you the embarassment, Jaxon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18654,'What\'s that supposed to mean?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18655,'Well at least we can leave this place and start working on the dome at Area --','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18656,'','Jaxon! Are you trying to blow our cover? So help me, I\'ll take the needle right out of this blouse I\'m working on...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18657,'No, not the needle! Anything but the needle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18658,'%s laughs at your clumsiness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18659,'With the Allerian Stronghold surrounded by enemies on all sides it\'s time for us to take the fight to them.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18661,'','If you\'re going to come out here, make yourself useful because the shadowstalker over there isn\'t doing much.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18662,'With the precise angle and velocity...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18663,'','The Battle of Mount Hyjal is one of the most well-guarded events of this timeline.  Should an intruder alter its outcome, the impact would extend to all subsequent moments in history.$B$BAs the Aspect\'s prime mate I\'m far more in tune with the flow of time than other bronze dragons.  I recently sensed a minute ripple in time emanating from the events surrounding the Battle of Mount Hyjal.  Someone or something is attempting to change this timeline and they must be stopped.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18664,'Thank you, earthmender.','',0,0,0,0,0,0,0,12,1,0,0,0,26124),
(18665,'','Thank you, kind soul. You have freed me from the watery prison of Coilskar but many more are being held prisoner nearby. Will you assist me in freeing them as well?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18666,'Just one moment. You cannot purchase a fine elekk without proving yourself a friend to the Exodar. Return once we know you can be trusted.','Just one moment. You cannot purchase a fine elekk without proving yourself a friend to the Exodar. Return once we know you can be trusted.',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(18667,'What are you after? Speak up. I\'m not about to trust you with one of my Elekks until you prove your dedication and friendship to our people.','What are you after? Speak up. I\'m not about to trust you with one of my Elekks until you prove your dedication and friendship to our people.',1,0,0,1,0,0,0,7,1,0,0,0,26124),
(18668,'','I sense the tortured spirits, $n. They are this way. Come quickly!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18669,'','Grant me protection, $n. I must break through their foul magic!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18670,'','Now we must find the exit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18671,'','It shouldn\'t be much further, $n. The exit is just up ahead.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18672,'','Thank you, $n. Please return to my brethren at the Altar of Damnation, near the Hand of Gul\'dan, and tell them that Wilda is safe. May the Earthmother watch over you...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18673,'','The naga do not respect nature. They twist and corrupt it to meet their needs. They live to agitate the spirits.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18674,'','The naga torture the spirits of water. They invoke chaos and destruction!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18675,'','The tumultuous nature of the great waterways of Azeroth and Draenor are a direct result of tormented water spirits.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18676,'5...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18677,'4...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18678,'3...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18680,'2...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18681,'1...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18682,'','You just going to kneel there all day?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18683,'','Fine, ignore me.  I don\'t care!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18684,'','Lady Vashj must answer for these atrocities. She must be brought to justice!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18685,'','The naga of Coilskar are exceptionally cruel to their prisoners. It is a miracle that I survived inside that watery prison for as long as I did. Earthmother be praised.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18686,'Sighing, %s returns to the campfire.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18687,'','Watch out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18688,'','Naga attackers! Defend yourself!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18689,'It\'s too quiet today, Theloria.  The blood elves are up to no good.  I can feel it.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18690,'%s grunts at her silence.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18691,'It\'s too quiet tonight, Theloria.  The blood elves are up to no good.  I can feel it.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18692,'Kill them all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18693,'You will never essscape Coilssskarrr...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18694,'Tear the land asunder, Gul\'dan! Sever the tie!','Tear the land asunder, Gul\'dan! Sever the tie!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18695,'They have abandoned us! Do not forget!','They have abandoned us! Do not forget!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18696,'We will take from the land if it refuses to give!','We will take from the land if it refuses to give!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18697,'Do not do this, Gul\'dan! The elements will never forgive us!','Do not do this, Gul\'dan! The elements will never forgive us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18698,'Stop! You must stop!','Stop! You must stop!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18699,'Think of our younglings, Gul\'dan! You will destroy us all!','Think of our younglings, Gul\'dan! You will destroy us all!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18700,'You have damned us all... We are lost.','You have damned us all... We are lost.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18701,'Be silent! The shattering is soon to come!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18702,'Bear witness to the undeniable power of our dark master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18703,'With his gift, I shall raze this land and reform it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18704,'Watch! See the ground shatter before us! Watch as the energy flows! It will feed our armies...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18705,'We will never be without power! I have secured our future! Bask in my glory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18706,'It... is... done...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18707,'Free at last!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18708,'Thank you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18709,'Thank you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18710,'How can we ever repay you for this?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18711,'We have waited forever for this day to come!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18712,'The pain is finally over.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18713,'I spit on the corpse of these filthy naga.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18714,'Who dares to interrupt my operation?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18715,'','%s whispers softly in reverent tones under her breath.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18716,'I\'m looking for a team player...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18717,'Time to supplement my work force.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18718,'','Our work in the Living Grove must not be endangered.  Our very lives hinge upon its continued health and growth.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18719,'%s examines the information on the wanted poster.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18720,'If you haven\'t already, make sure that you offer your assistance to Rina Moonspring.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18721,'If I heard correctly, you\'re already doing good work for Sylvanaar.$B$BKeep it up and maybe we\'ll be able to keep our home here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18722,'The time for vengeance draws near.','',0,0,0,0,0,0,0,12,1,0,0,0,26124),
(18723,'You will do our bidding, mortal.','',0,0,0,0,0,0,0,12,1,0,0,0,26124),
(18724,'It will all end soon...','',0,0,0,0,0,0,0,12,1,0,0,0,26124),
(18725,'I prefer to be hands-on...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18726,'Let me see what hatchlings you have for sale.','Let me see what hatchlings you have for sale.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18727,'Go and rest, wanderer. Our fires are yours.','Go and rest, wanderer. Our fires are yours.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18728,'You\'re in range! Drop the phase disruptor now!!!','You\'re in range! Drop the phase disruptor now!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18729,'I will do as you wish!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18730,'%s departs from the world and summons shades to do his bidding.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18731,'Hold them back! Do not falter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18732,'Victory or death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18733,'Do not give an inch of ground!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18734,'It is over! Withdraw! We have failed....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18735,'%s makes a dash for the forge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18736,'It is here that Gul\'dan severed the tie between orcs and the elemental spirits. His unquenchable thirst for power could not be satiated with the complete annihilation of the draenei. He had to also destroy Draenor, razing the land and siphoning all of its energies for use in his war.$B$BNow all that is left are remnants of his madness.$B$BLook to the altar, $r - the land is forever haunted...','',1,1,25,0,0,0,0,0,1,0,0,0,26124),
(18737,'The dirge of Karabor howls to the heavens.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18738,'The dirge of Karabor returns to the elements.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18739,'%s begins to cast Blast Nova!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18740,'Go on, please.','Go on, please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18741,'I honor my ancestors in the time-honored shamanistic tradition.  We must never forget the sacrifices that they have made so that we can be here.$B$BAnd we, in turn, must make the necessary sacrifices so that our descendants will have a future.$B$BWhat brings you to me, $c?','',1,6,0,0,500,0,0,0,1,0,0,0,26124),
(18742,'What did you do then?','What did you do then?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18743,'What happened next?','What happened next?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18744,'I see.','I see.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18745,'There was something else I wanted to ask you.','There was something else I wanted to ask you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18746,'It was not so long ago that we had to wrest control of Thunderlord Stronghold from the nearby ogres.$B$BYou are here to help us maintain our defenses?  I know that Gor\'drek is looking for assistance.','',1,1,0,0,500,0,0,0,1,0,0,0,26124),
(18747,'%s gets an evil look in his eye as he reaches into his backpack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18748,'%s calls out to its father.','%s calls out to its father.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18749,'Stand back, $n. The spirits may lash out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18750,'Why have you captured us?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18751,'What is it that you hope to gain from this?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18752,'%s bows.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18753,'We wish to help you, spirit. We seek your wisdom.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18754,'Wisdom? It was your people that caused the insufferable wrath of Cyrukh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18755,'Why should we help you? The world is ruined. Destroyed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18756,'%s nods.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18757,'You are right, spirit. It was my people that did this to you. Allow us to make it right.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18758,'Please tell us this: Who or what is Cyrukh?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18759,'Fool! Cyrukh the fire lord! When the tie was severed, Cyrukh awoke. It is the tears of Cyrukh that fill this land with molten rock.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18760,'The... The fire lord? An elemental lord was unearthed? Of course... Gul\'dan you were a damned fool!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18761,'He is insane now. Driven mad during the shattering. There is no rest for the elements.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18762,'There must be a way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18763,'Yes, a way. Destroy Cyrukh. Destroy an elemental lord.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18764,'Do not doubt my comrades and I, spirit. Tell us how to conjure the fire lord. My allies will destroy him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18765,'You must utter the words...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18766,'Yes... Yes... the words. The words of damnation. The words spoken by the dark one. Your master.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18767,'Yes... Gul\'dan...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18768,'We will find these words. We will summon your master and we will destroy him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18769,'Talk. More talk... Now release us, mortal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18770,'There are two mailboxes in the Seat of the Naaru: one by the bank, and another outside the auction house.','There are two mailboxes in the Seat of the Naaru: one by the bank, and another outside the auction house.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18771,'How do you like the war, $n?  Just remember why we\'re here...that makes the fighting, and the dying, a lot easier.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18772,'Expedition Point is a tough place to be stationed, but it\'s critical to the defense of Honor Hold.  The information gathered here, and the engagements our soldiers make against the Legion and the orcs of Zeth\'Gor, are invaluable to the Alliance\'s Hellfire campaign.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18773,'I hear that you\'ve already begun to pull your weight around here.$B$BGood.  I was worried that we were going to have to \'convince\' you to help out.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18774,'A deep, bone chilling voice echoes from the %s...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18775,'How dare you trifle with my playthings, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18776,'The orcs in my citadel will drink your blood and devour you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18777,'Hahahahah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18778,'Now to recover the lost words!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18779,'The skin stretched taut between the bones is a call to arms against the main defender of the Alliance\'s Sylvanaar and the Living Grove to the west.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18780,'','Well met, I\'m Azimi! I often make the walk out here to sell the men fresh fruit and water. Are you hungry, or perhaps thirsty?',3,0,0,0,0,0,0,7,1,0,0,0,26124),
(18781,'%s begins to read the wanted poster.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18782,'Grunting, %s turns away from the wanted poster, returning to his warm spot by the fire.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18783,'Bah!  Do I look like I have time for idle chit-chat?$B$BDo I?$B$BBe quick about your business.  There are ogres to be killed!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(18784,'The words painted on the stretched skin here call for something that you don\'t think you\'re quite ready for.$B$BYou should check back later.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18785,'','Hail, $c. I trust you are here to inquire on the Ahn\'Qiraj war effort. We are going to need a great deal of assistance.$B$BThe war effort is a united effort between the Horde and Alliance to prepare for the impending war against the Silithid and their masters in Ahn\'Qiraj. In Orgrimmar\'s Valley of Spirits, we are collecting a vast number of goods to create war materiel, and these gathering tasks are what we need your help with.$B$BCan I convince you to speak with our commander about helping out?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18786,'','Well met, $c. I hope you are here to inquire on the Ahn\'Qiraj war effort. We are going to need a great deal of assistance.$B$BThe war effort is a united effort between the Alliance and Horde to prepare for the upcoming war against the Silithid and their masters in Ahn\'Qiraj. In the Military Ward of Ironforge, we are collecting all manner of goods to create our war materiel from, and these gathering tasks are what we need your help with.$B$BCan I convince you to speak with our commander about pitching in?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18787,'Heroes of your stature should not waste their talents in Alterac Valley, $n.','Heroes of your stature should not waste their talents in Alterac Valley, $n.',274,0,0,1,0,0,0,0,1,0,0,0,26124),
(18788,'It\'s good to see a $r, such as yourself, contributing to the well-being of Sylvanaar.  We\'ve done a lot here in a very short time, but the forces that surround us threaten our way of life.$B$BI would hear what you have to say.  Speak your mind, $c.','',1,1,0,0,500,0,0,0,1,0,0,0,26124),
(18789,'','Are you seeking ammunition or other supplies? I\'ve also some extra food I gathered for Beibei, here, should you require any.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18790,'%s grows in size!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18791,'','Welcome to the Cenarion Refuge, $n. I\'ve been instructed to offer you basic supplies for purchase, should you need them.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18792,'I\'M ON FIRE!!!','I\'M ON FIRE!!!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18793,'I\'M ON FIRE!!!  AGAIN!!','I\'M ON FIRE!!!  AGAIN!!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18794,'IT BURNS!!','IT BURNS!!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18795,'Not again...','Not again...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18796,'WHY ME!?!','WHY ME!?!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18797,'This is going to hurt in the morning.','This is going to hurt in the morning.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18798,'YEOW!!','YEOW!!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18799,'%s draws energy from the air...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18800,'It looks like there\'s a skirmish up ahead, $n.  Let us wait til the situation clears up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18801,'Are you ready to fight the Stormpike Guard in Alterac Valley, $n?','',25,0,0,1,0,0,0,1,1,0,0,0,26124),
(18802,'As representatives of the Explorers\' League, Bronwyn and I are here at the Alliance\'s behest to study these mountains.$B$BBut between you and me, after an extended stay in Silithus, we just needed a vacation.  This seems like a nice enough spot.','',1,1,0,0,500,0,0,0,1,0,0,0,26124),
(18803,'','Borgrim might be correct.  Maybe we do need to take a break.$B$BBut now that we\'re here, I\'m eager to get my hands dirty and study what this land has to offer.',1,1,0,0,500,0,0,0,1,0,0,0,26124),
(18804,'Mmmmrrrrrgggggglllll!!!!!! [PH]','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(18805,'Excellent news, Tooki! We\'re saved!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18806,'$n, I am pleased to see you. Our dwarven allies require our assistance in Alterac Valley. Will you help them?','',66,0,0,1,0,0,0,7,1,0,0,0,26124),
(18807,'It\'s time to celebrate, I think...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18808,'%s places a keg on the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18809,'Listen up, you lot! Our worries are over! FREE BOOZE FOR EVERYONE!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18810,'','Borgrim!  Get over here right this instant and help me with this unpacking!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18811,'','I know that you want your vacation, but we still have work to do.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18812,'','Tell you what, hon.  If you help me get all of this unpacked, we can both take a breather.  Deal?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18813,'','Borgrim, this is no time for drinking.  We just got here.  We need to get settled in.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18814,'Uh, yeah... I\'ll be right there, dear.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18815,'Yup, just as soon as I finish this pint.  You betcha.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18816,'Right.  We just busted our tails to haul all of this stuff up here, and you want to work more?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18817,'I thought this was going to be our chance to get away from it all?  Our vacation?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18818,'Women!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18819,'','Men!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18820,'The threat be over! $n be savin\' us all!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18821,'%s calls to its hatchlings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18822,'%s feasts on the rotting carcass.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18823,'The Sons of Lothar have been fighting a war without end.  I\'m amazed we\'ve kept our equipment in as good a shape as it is!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18825,'','Even now, free-willed undead battle the League of Arathor in Arathi Basin.  Will you aid the Defilers in defeating the humans and their Alliance allies?',1,0,0,1,0,0,0,1,1,0,0,0,26124),
(18826,'Throm\'ka, $n.  Warsong Gulch is in need of heroes such as you.','',1,0,0,1,0,0,0,1,1,0,0,0,26124),
(18827,'Our Alliance allies are assisting the Leage of Arathor in their defense of Arathi Basin.  They could use your aid against the undead Defilers, $c.','',66,0,0,1,0,0,0,7,1,0,0,0,26124),
(18828,'','Our friends in the Alliance gather to fight alongside the Silverwing Sentinels in Warsong Gulch. Will you travel there to help them?',66,0,0,1,0,0,0,7,1,0,0,0,26124),
(18829,'%s breaks free from the egg and attacks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18830,'ACK!  That\'s the worst thing I\'ve ever tasted!  I wouldn\'t let my ram drink that!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(18831,'Watch me go! [PH]','Watch me go! [PH]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18832,'%s senses the egg in your possession and attacks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18833,'Greetings, traveler. I am Oronok. Please, sit by my fire and warm yourself.$B$BBeware the ravenous beasts of the shattered shelf below us!','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(18834,'What do you have for sale, Oronok?','What do you have for sale, Oronok?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18835,'%s counts his sheep.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18836,'1, 2, 3, 4, 5, 6, 7, 8, 9, 10... DAMNIT!','1, 2, 3, 4, 5, 6, 7, 8, 9, 10... DAMNIT!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18837,'Must have snuck in through the back when I wasn\'t lookin\'... I\'ll get those ravagers if it\'s the last thing I do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18838,'You\'re not getting my sheep, scoundrel!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18839,'Over my dead body!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18840,'You\'ll pay for that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18841,'','Do not forget, $c, battles still rage in Azeroth. Will you return to help the Horde in Alterac Valley?',1,0,0,1,0,0,0,1,1,0,0,0,26124),
(18842,'Throm\'ka, $c. Did you know our fight with the Silverwing Sentinels in Warsong Gulch continues still? Your presence would be welcome there...','',66,0,0,1,0,0,0,1,1,0,0,0,26124),
(18843,'%s attacks from the hillside.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18844,'I have traveled far in search of a way to ultimately defeat the League of Arathor in Arathi Basin, but that loin-clothed lummox Adam Eternum hounds my every move.\n$b\nStill, if slayers such as you were to return to Azeroth, perhaps we could defeat the Alliance once and for all!','',1,153,0,1,3,0,0,1,1,0,0,0,26124),
(18845,'Be on your guard! The enemy is on the prowl.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18846,'There they are!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18847,'','How are ye? Had yer fill o\' Outland, and ready ta head back ta Alterac Valley and give the Horde what for?',1,0,0,1,0,0,0,7,1,0,0,0,26124),
(18848,'The Silverwing Sentinels still fight the Horde in Warsong Gulch, $c. What remains to be seen is if you will return there to help them.','',3,0,0,1,0,0,0,7,1,0,0,0,26124),
(18849,'I came to Outland hoping to discover powerful artifacts to assist the League of Arathor against the Defilers in Arathi Basin... but all I\'ve found is this smashing magical loincloth, a ridiculous gnome sidekick, and an egomaniacal undead stalker who insists I\'ve stolen his grey skull, or some such.\n$b\nIn any case, would you care to join the League in their fight while I continue my search?','',6,0,0,2,0,0,0,7,1,0,0,0,26124),
(18850,'<One gets the sense that Oric is here only in a sorry attempt at comic relief and shouldn\'t be paid attention to, as it will only encourage him.>','',14,11,0,1,3,0,0,0,1,0,0,0,26124),
(18851,'Me sorry little birdy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18852,'Bird, you hurting me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18853,'ARGH!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18854,'Why you keep hurting me? Me said me sorry...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18855,'Me do whatever birdy want. Just stop the hurting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18856,'<It\'s a giant, armored, saddle-bearing attack cat. Isn\'t that already silly enough without it talking, too?>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18857,'Me no can think right anymore!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18858,'At LAST! I\'m parched!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18859,'Oh no you don\'t! You\'ll stop practicing when I\'m damn well ready for you to stop practicing! KEEP GOING!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18861,'Did I win? [PH]','Did I win? [PH]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18862,'Nobody can beat that! [PH]','Nobody can beat that! [PH]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18863,'Don\'t mind if I do. Maybe it\'ll get rid of this headache.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(18864,'','Only a mage can learn portal magic, $c.',274,0,0,1,0,0,0,0,1,0,0,0,26124),
(18865,'','A mage... you seek to learn the magic of portals, yes?',2,0,0,1,0,0,0,0,1,0,0,0,26124),
(18866,'This pumpkin sure looks succulent! Nobody will notice if I take a small bite... [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18867,'','The Royal Apothecary Society of the Undercity is eager to aid our orc allies here, in Outland.  It is an opportunity to strengthen our bonds, and to find new specimens and compounds for study.$B$BCompounds...such as poisons.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18868,'Who\'s stealing my pumpkins?! You won\'t get away with this, you rascal! [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18869,'The %s is very weak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18870,'Ack!  Everyone run... the last asset is materializing!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18871,'Crash, get out of there!!!  Oh no!!!  Not another of my proteges!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18872,'Uh oh.  The wagon looks unstable... it\'s going to blow!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18873,'I\'m ok!  It\'s just a flesh wound...  That was fun!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18874,'Fun?!!  You nearly gave me a heart attack!  Yeah, I guess you\'re right.  That was fun!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18875,'%s sniffs at the air. A tuber is near!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18876,'%s starts to dig.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18877,'%s squeals with glee at its discovery.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18878,'We must work faster.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18879,'Our work is not yet complete.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18880,'You should be honored to be doing Lady Vashj\'s bidding.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18881,'Lady Vashj expects our work to be done soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18882,'Maintain focus.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18883,'Steady the pumps.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18884,'Keep those pumps working.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18885,'We\'re in the home stretch now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18886,'Things are proceeding as planned.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18887,'The pumps are working magnificently.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18888,'Soon all of Draenor\'s water will be ours.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18889,'The reservoir fills nicely.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18890,'Purification seems to be ahead of schedule.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18891,'We appear to be on target.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18892,'If we can keep working at this rate, the Lady will be pleased.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18893,'We will be at capacity soon enough.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18894,'Keep everyone working efficiently.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18895,'Don\'t let the levels get too low.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18896,'Keep ample pressure on the southern pump.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18897,'Direct the flow from from the western bog.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18898,'Open the purification valves and continue work.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18899,'Make sure these Broken are thoroughly cleaned before touching the water.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18900,'Keep regulating the main valve to ensure steady flow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18901,'Don\'t take your eyes off of these filthy Broken. I don\'t trust them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18902,'My thoughts exactly.','My thoughts exactly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18903,'I couldn\'t agree more.','I couldn\'t agree more.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18904,'It\'s as if you were reading my mind.','It\'s as if you were reading my mind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18905,'You speak the truth.','You speak the truth.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18906,'Yessir.','Yessir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18907,'Right away, sir.','Right away, sir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18908,'I shall see to it, sir.','I shall see to it, sir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18909,'What\'s on your mind, sir?','What\'s on your mind, sir?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18910,'You filthy little beings need to work faster!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18911,'FASTER!!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18912,'%s attempts to split in two.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18913,'%s throws a mushroom spore at $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18914,'Whitereach Post is something of an unintended stop for me, to put it mildly. My clients are counting on me to deliver my wares and I\'m starting to wonder if I\'m going to make it in time with all the delays involved.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18915,'','Hey, don\'t open the cage!  Okay?$B$BThese ogres have got me right where I want them.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18916,'I am told that the dust and heat of Hellfire Peninsula is quite irritating... I would not know, but I will trust my esteemed, and still living, allies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18917,'I wish to unlearn elemental leatherworking!','I wish to unlearn elemental leatherworking!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18918,'','Hi.  Thanks for the help.  But please don\'t open the cage.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18919,'','Yes, the ogres are so stupid that they forgot to lock my cage.  But that\'s exactly how I like it, so please don\'t open it again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18920,'','No.  Don\'t open the cage.  One of them might notice!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18921,'','Please leave the cage door closed.  Thanks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18922,'','Psst, $r, up here near the entrance.  I\'m in the cage.  Hurry!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18923,'Forgetting elemental leatherworking is not something to do lightly.  If you choose to abandon it you will forget all recipes that require elemental leatherworking as well!','Forgetting elemental leatherworking is not something to do lightly.  If you choose to abandon it you will forget all recipes that require elemental leatherworking as well!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18924,'','You\'ll be purchasing no hawkstrider here until you\'ve proven yourself at least friendly to our people.',274,0,0,1,0,0,0,1,1,0,0,0,26124),
(18925,'','You\'ll be purchasing no hawkstrider here until you\'ve proven your worth and dedication to our people.$b\n\nDo not return until you are considered exalted among the blood elves. Away with you!',274,25,0,1,2,0,0,1,1,0,0,0,26124),
(18926,'These orcs must really be eager to stake their claim in Outland! If I told you how much they were paying for my allegiance, you\'d kill me out of jealousy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18927,'','No, $r. Your bulk would only crush one of these noble creatures.\n$b\nNow, away with you!',274,25,0,1,2,0,0,1,1,0,0,0,26124),
(18928,'Do you really want to unlearn your leatherworking specialty and lose all associated recipes?','Do you really want to unlearn your leatherworking specialty and lose all associated recipes?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18929,'%s begins to release his power in desperation!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18930,'If you\'ve the gold, I can teach you how to ride a hawkstrider.','',1,0,0,1,0,0,0,1,1,0,0,0,26124),
(18931,'You must be friendly with the blood elves before I will teach you a riding skill, $c.','',1,0,0,1,0,0,0,1,1,0,0,0,26124),
(18932,'You must be exalted with the blood elves before I will teach you a riding skill, $c.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(18933,'Oh, please.\n$b\nI cannot teach a $r to ride a hawkstrider.','',274,0,0,1,0,0,0,1,1,0,0,0,26124),
(18934,'Are you ready to hear the story of the Cipher of Damnation, $n?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(18935,'I am ready to hear your story, Oronok.\n','I am ready to hear your story, Oronok.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18936,'Very well. The words you seek have a name, $n. They are known as the Cipher of Damnation: The words uttered by Gul\'dan himself to shatter this land. The very spell that severed the last remaining tie the orcs had with the elements of Draenor.$B$B<Oronok nods.>$B$BAye, it is the cipher that you must reconstruct and ultimately the words of the cipher that you must call.','',1,1,273,0,0,0,0,0,1,0,0,0,26124),
(18937,'How do I find the cipher?','How do I find the cipher?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18938,'The Cipher of Damnation was kept in Gul\'dan\'s private quarters inside Karabor for twenty years. Ah, that\'s right, you have no idea what Karabor is, do you?$B$BThe Black Temple...$B$BAye, now home to Illidan Stormrage.$B$BWhen Illidan took control of the Black Temple, he discovered the cipher. He recognized that the damage to this world had already been done but thought it wise to keep the cipher secure for later use.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(18939,'How do you know all of this?','How do you know all of this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18940,'When you stand at the Altar of Damnation and see the spirits of the damned, kneeling in prayer, what you do not see is me, standing next to Gul\'dan.$B$B<Oronok nods.>$B$BI told you that I was a lot of things, did I not? One of those \'things\' was a lieutenant of Gul\'dan.$B$BI have done many terrible things in my life. I have slaughtered man, woman, and child alike. Danced in the blood of innocent draenei... yet...$B$B<Oronok chokes on his words.>','',1,1,274,0,0,0,0,0,1,0,0,0,26124),
(18941,'Yet what? What is it, Oronok?','Yet what? What is it, Oronok?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18942,'I will never forget that day, $r. Never. Even though I had long since abandoned shamanism in favor of shadow magic, I felt the cut. A sense of loss so profound... I could not explain it to you with mere words.$B$BWhen the tie to the elements was severed, all orcs on Draenor changed. If there was ever any doubt in the power of the shadows, it was washed away with the cresting of the molten lava over the shattered earth.\n','',274,1,1,0,0,0,0,0,1,0,0,0,26124),
(18943,'Continue, please.','Continue, please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18944,'A wave of sickness rushed through me. After the ritual was over, I ran home to my children. I gathered what belongings I could carry in my arms and left with my boys. We ran to the hills and hid. There really was no other option...$B$BNot a day goes by that I don\'t think of the cut. It has taken 20 years to reconnect with the elements. It has taken 20 years for the elements to even begin to heal.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(18945,'So what of the cipher now? And your boys?','So what of the cipher now? And your boys?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18946,'As I said, the cipher was found by Illidan when he took over the Black Temple. He divided the tome into three parts and charged their care to his minions.$B$BMy boys... My boys are grown now. When I got word of what Illidan had done with the cipher, I sent my boys to recover the pieces.$B$BYou must find my boys, $n. You must find them and recover the Cipher of Damnation.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(18947,'I will find your boys and the cipher, Oronok.','I will find your boys and the cipher, Oronok.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18948,'Don\'t let any of them escape, you dogs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18949,'I want these Alliance and Horde pigs dead!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18950,'We will crush the Bladespire clan.  Then we will have Gruul the Dragonkiller\'s favor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18951,'Get up there.  March on Bladespire Hold.  I want to adorn my tower with Gorr\'Dim\'s head!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18952,'You!  I see you!  One of you, kill them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18953,'Gah!  Your meat will taste sweet slow roasting over my fire!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18954,'I\'m through asking nicely, fish-man.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18955,'Where is the Cipher of Damnation? I know a third of it is in this village.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18956,'Whhaaat... are you sssspeaking of, ssssoft-sskin?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18957,'The naga do nottt... have thissss... cipherrr...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18958,'No... Of course not. What was I thinking? Why would you have a third of the Cipher of Damnation?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18959,'I feel so stupid. Maybe I should unchain you and set you free?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18960,'DO I HONESTLY LOOK THAT STUPID TO YOU, NAGA? NOW YOU FEEL PAIN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18961,'Yesss... Yesss... Ssset me freee...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18962,'%s spits on the Coilskar naga.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18963,'GET UP YOU ROTTEN PIECE OF TRASH! GET UP BEFORE I END YOU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18964,'%s regains consciousness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18965,'Do not beat the Coilsssskaarrr commander anymore, orc! I will tell you! The cipherrr... It is hidden in one of the chests at Coilssskarrr Point... The naga there hold the keysss...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18966,'I\'m listening...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18967,'COILSSSKARRR!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18968,'Welcome to Shattrath City, seat of the Sha\'tar in Outland. You seek guidance?','Welcome to Shattrath City, seat of the Sha\'tar in Outland. You seek guidance?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(18969,'Do you really want to unlearn your leatherworking specialty and lose all associated recipes?','Do you really want to unlearn your leatherworking specialty and lose all associated recipes?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18970,'','I came to this place because of my study into the backward culture that used to be the Thunderlord clan.$B$BThey were weak and succumbed to the lure of power that came with being transformed into fel orcs through Mannoroth\'s blood.$B$BI have read all of their texts.  I am particularly interested in the recovery of an artifact, a drum, an arrow and a tablet that were lost when we crushed the Bladespire ogres and pushed them back down into their hold.',1,1,0,0,500,0,0,0,1,0,0,0,26124),
(18971,'Ar\'tor\'s lifeless body remains suspended in mid-air by demonic magic. They take from him, even in death...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18972,'Assist me slaves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18973,'','I am pleased that you\'ve decided to take up our cause.  As a reward I will infuse a ring with the remnants of the Well of Eternity you brought me.$B$BI offer you four different paths in which to unlock their power.  Choose wisely, $n.  The sands of time flow easily in one direction and not the other.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18974,'Forgetting tribal leatherworking is not something to do lightly.  If you choose to abandon it you will forget all recipes that require tribal leatherworking as well!','Forgetting tribal leatherworking is not something to do lightly.  If you choose to abandon it you will forget all recipes that require tribal leatherworking as well!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18975,'I wish to unlearn tribal leatherworking!','I wish to unlearn tribal leatherworking!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18976,'Forgetting dragonscale leatherworking is not something to do lightly.  If you choose to abandon it you will forget all recipes that require dragonscale leatherworking as well!','Forgetting dragonscale leatherworking is not something to do lightly.  If you choose to abandon it you will forget all recipes that require dragonscale leatherworking as well!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18977,'I wish to unlearn dragonscale leatherworking!','I wish to unlearn dragonscale leatherworking!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18978,'I... died.$B$BWhy am I still here? Is there no great hunting ground that I ascend to?$B$BNo... I must first complete my task. Before I can leave this world, the second part of the Cipher of Damnation must be recovered.','I... died.$B$BWhy am I still here? Is there no great hunting ground that I ascend to?$B$BNo... I must first complete my task. Before I can leave this world, the second part of the Cipher of Damnation must be recovered.',1,274,273,0,0,0,0,0,1,0,0,0,26124),
(18979,'Hah!  The Thunderspike is mine.  Die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18980,'Puny $r cannot lift spear.  Gor lift spear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18981,'%s\'s skin partially deflects the spell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18982,'I wish to unlearn Swordsmithing!','I wish to unlearn Swordsmithing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18983,'Forgetting your swordsmithing skill is not something to do lightly.  If you choose to abandon it you will forget all recipes that require swordsmithing to create!','Forgetting your swordsmithing skill is not something to do lightly.  If you choose to abandon it you will forget all recipes that require swordsmithing to create!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18984,'Do you really want to unlearn your blacksmithing specialty and lose all associated recipes?','Do you really want to unlearn your blacksmithing specialty and lose all associated recipes?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18985,'These Infernals are almost ready for the next assualt on The Betrayers Black Citadel!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18986,'I wish to unlearn Axesmithing!','I wish to unlearn Axesmithing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18987,'Forgetting your Axesmithing skill is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Axesmithing to create!','Forgetting your Axesmithing skill is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Axesmithing to create!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18989,'Hi, $n.  I\'m here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18990,'I wish to unlearn Hammersmithing!','I wish to unlearn Hammersmithing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18991,'Forgetting your Hammersmithing skill is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Hammersmithing to create!','Forgetting your Hammersmithing skill is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Hammersmithing to create!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18992,'%s strikes out in desperate fury.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18993,'I... I have died... I was in so much pain... engulfed in darkness... Can you see me, $r?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18994,'Things are proceeding well!  Soon we grind The Betrayers bones beneath our feet!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18995,'Prepare to launch the next wave of Infernals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18996,'The sky shall fall with the Legions glory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18997,'We must be prepared for the next assualt!  The Betrayer will be destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18998,'%s rushes to the aid of a nearby doe!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(18999,'We will conquer all, for we are the Burning Legion!  Our enemies shall be consumed in flame and crushed beneath our might!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19001,'None can stand against the Burning Legion!  This world is ours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19002,'You are meaningless!  Only absolute victory for the Legion matters!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19003,'You have persevered against some of my best advisors... but none can withstand the might of the Blood Hammer. Behold, Lord Sanguinar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19004,'Capernian will see to it that your stay here is a short one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19005,'Well done, you have proven worthy to test your skills against my master engineer, Telonicus.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19006,'Let us see how your nerves hold up against the Darkener, Thaladred! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19007,'I wish to unlearn Weaponsmithing!','I wish to unlearn Weaponsmithing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19008,'Forgetting your Weaponsmithing skill is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Weaponsmithing to create!','Forgetting your Weaponsmithing skill is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Weaponsmithing to create!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19009,'You must forget your weapon type specialty before i can help you.   Go to Everlook in Winterspring and seek help there!','You must forget your weapon type specialty before i can help you.   Go to Everlook in Winterspring and seek help there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19010,'I wish to unlearn Armorsmithing!','I wish to unlearn Armorsmithing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19011,'Forgetting your Armorsmithing skill is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Armorsmithing to create!','Forgetting your Armorsmithing skill is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Armorsmithing to create!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19012,'There! Destroy him! The Cipher must be recovered!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19013,'Petulent fool! You will never have the Cipher!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19014,'The Cipher of Damnation belongs to us now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19015,'You will be destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19016,'The master will know of this incursion. You will be hunted for all eternity!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19017,'I require the aid of another spirit hunter, Ar\'tor.','I require the aid of another spirit hunter, Ar\'tor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19018,'As you wish, $n. The spirit hunter is ready.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19019,'I\'ve done my time in the trenches, and spent many years training the pups. It\'s good to be home. No matter what has become of it, this is my home.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(19020,'To care for these fearless beasts, who stand between my clanmates and death, is an honor.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(19021,'I wish to stable my pet, Gedrah.','I wish to stable my pet, Gedrah.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19022,'','Thank you, $n.  Now, to perform the test...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19023,'','Ah, I see...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19024,'','Yes, this is unfortunate.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19025,'','$n, I have confirmed that this blood is from the Bonechewer clan of orcs, tainted with demonic power.  I\'m afraid, however, that my current equipment can delve no deeper into this mystery...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19026,'These are holy grounds!  You are not welcome here.','These are holy grounds!  You are not welcome here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19027,'Friends of the Scryers are not allowed here!','Friends of the Scryers are not allowed here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19028,'Take your time away from here to reflect upon your actions.','Take your time away from here to reflect upon your actions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19029,'The ogres, they bury me here up to my neck and then forget to come back.$B$BYah, mon, funny.  Laugh it up.  Disembodied ghost head here.$B$BOf course, if you want to help me out, I might be able to make it worth your while.$B$BBut no, keep laughing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19030,'Bird spell not working. Me is free!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19031,'%s lays an egg.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19032,'Stupid ogre.  You all need to be taught a lesson.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19033,'If freedom is what you seek, freedom is what you shall find.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19034,'You ogres are disposable.  That being said, it is time to take out the garbage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19035,'I tire of these ogres. We should wipe them out, all of them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19036,'Do any of you other ogres want to join your friend?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19037,'Me promise be good...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19038,'Me no want to die.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19039,'Me sorry...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19040,'It is dying! The second part of the Cipher of Damnation is ours. I...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19041,'I am fading... Return to Ar\'tor... Ret... rn... to...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19042,'Oh no!','Oh no!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19043,'NO!','NO!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19044,'The mana bomb!','The mana bomb!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19045,'They set it off!','They set it off!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19046,'It\'s going to blow!','It\'s going to blow!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19047,'The %s gasps.','The %s gasps.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19048,'The %s is transfixed in fear.','The %s is transfixed in fear.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19049,'Sighing quietly, the %s awaits the inevitable.','Sighing quietly, the %s awaits the inevitable.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19050,'The %s turns to face his impending doom.','The %s turns to face her impending doom.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19051,'Knowing there isn\'t enough time, the %s doesn\'t even try to run.','Knowing there isn\'t enough time, the %s doesn\'t even try to run.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19052,'<Nuainn Stormwing shakes his head.>$B$BWith the Legion on one side and Illidan\'s minions on the other, it\'s going to take everything we\'ve got to defend the stronghold, and defend it we will! Every true Wildhammer would sooner die than surrender our home.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19053,'As you see, I have many weapons in my arsenal....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19054,'Stand up straight, grunt! You\'re under the command of the Kor\'kron Guard now.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19055,'You hear a faint unlocking sound...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19056,'The %s looks on in disbelief.','The %s looks on in disbelief.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19057,'Attention stance!  Ready Begin.','Attention stance!  Ready Begin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19058,'Attention!  Now do what I do.','Attention!  Now do what I do.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19059,'I have been waiting for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19060,'Perhaps I underestimated you. It would be unfair to make you fight all four advisors at once, but... fair treatment was never shown to my people. I\'m just returning the favor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19061,'','Hah! It\'s about time! No more fearing that each day would be our last...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(19062,'','I think everyone deserves a drink. If Thadok\'s sharing...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(19063,'','Learning to read is a thirsty business. A toast, eh?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(19064,'','Drink up, boys!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(19065,'Please excuse me while I begin my tests...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19066,'Interesting...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19067,'But what is this?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19068,'Oh, my!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19069,'If my blood hadn\'t clotted long ago, it would be boiling with rage right now...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19070,'This land still bears the scars of the past. I wonder if they will ever heal.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19071,'Can you cast the spell to help me breathe and move underwater?','Can you cast the spell to help me breathe and move underwater?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19072,'I am too far... The link... is lost...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19073,'Grek get drink!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(19074,'At last! I\'ll light the lamps.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(19075,'','Rejoice, my friends! $n has saved us from the looming shadow that threatened our very lives!',22,0,0,0,0,0,0,7,1,0,0,0,26124),
(19076,'We\'re saved? We\'re really saved?! YAHOO!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19077,'It\'s time to PARTY!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19078,'%s applauds lightly, smiling.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19079,'How fortuitous. I believe this calls for some wine.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19080,'A fine vintage in celebration of our salvation!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19081,'The smell of these land walkers disgusts me.','The smell of these land walkers disgusts me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19082,'Our work is almost complete.','Our work is almost complete.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19083,'Our time draws near.','Our time draws near.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19084,'The feralfen that dwell in Zangarmarsh have wicker baskets with clever locks on them.  Surely they would challenge even your skill.','The feralfen that dwell in Zangarmarsh have wicker baskets with clever locks on them.  Surely they would challenge even your skill.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19085,'I\'ll light the lamps.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(19086,'They can take away our land, but they can\'t take away our freedom!  Attack! [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19087,'The footlockers of Kil\'sorrow Fortress in Nagrand would provide a considerable challenge to even a rogue of your notable skill.','The footlockers of Kil\'sorrow Fortress in Nagrand would provide a considerable challenge to even a rogue of your notable skill.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19088,'AAAAAAAAHHHHHHHHHHHHH!  Get them!  Kill them all! [PH]','AAAAAAAAHHHHHHHHHHHHH!  Get them!  Kill them all! [PH]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19089,'Bring me the skulls of our enemies!  Go now and kill them all! [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19090,'Zug Zug! [PH]','Zug Zug [PH]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19091,'Tread lightly, $r. Beyond this bridge lies hell.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19092,'Ahh... not so fast my friend.  The freedom you seek is behind you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19093,'I only have one rule. Everyone fights. No one quits.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19094,'You don\'t do your job, I\'ll shoot you myself.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19095,'Come on you apes. You want to live forever?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19096,'Warm it up and give \'em everything you\'ve got.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19097,'Test.','Test.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19098,'%s cracks the rotten egg open and - to the horror and dismay of all around him - begins to drink from its putrid core.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19099,'That was life-changing... Excuse me for one minute.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19100,'%s lets loose the most foul belch ever heard or smelled.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19101,'Ok then, back to business.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19102,'It\'s a complete and total barf-o-rama! RUN FOR YOUR LIVES!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19103,'I knew the prince would be angry, but I... I have not been myself. I had to let them out! The great one speaks to me, you see. Wait--outsiders. Kael\'thas did not send you! Good... I\'ll just tell the prince you released the prisoners!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19104,'The naaru kept some of the most dangerous beings in existence here in these cells. Let me introduce you to another....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19105,'%s\'s weapons glow with unnatural fire.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19106,'Yes, yes... another! Your will is mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19107,'Behold, yet another terrifying creature of incomprehensible power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19108,'Where in Bonzo\'s Brass Buttons am I? And who are-- yaaghh, that\'s one mother of a headache!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19109,'What is this? A lowly gnome? I will do better, oh great one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19110,'Anarchy! Bedlam! Oh, you are so wise! Yes, I see it now, of course!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19111,'One final cell remains. Yes, O great one, right away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19112,'It is a small matter to control the mind of the weak... for I bear allegiance to powers untouched by time, unmoved by fate. No force on this world or beyond harbors the strength to bend our knee... not even the mighty Legion! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19113,'Bear witness to the agent of your demise!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19114,'Welcome, O great one. I am your humble servant.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19115,'%s shatters into shards.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19116,'\"Lowly\"? I don\'t care who you are, friend: no one refers to the mighty Millhouse Manastorm as \"lowly\"!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19117,'I just need to get some things ready first. You guys go ahead and get started. I need to summon up some water....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19118,'Mana gem...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19119,'Fantastic! Next, some protective spells. Yeah, now we\'re cookin\'!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19120,'And of course I\'ll need some mana. You guys are gonna love this; just wait....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19121,'Aaalllriiiight!! Who ordered up an extra large can of whoop-ass?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19122,'','Default.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19123,'I have the spell. You can analyze it.','I have the spell. You can analyze it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19124,'Toshley\'s Station is the best!  The solitude and supply of strange, Outland power sources is an ideal setting for extreme experiments!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19125,'Have you talked to my clone--I mean... my twin?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19126,'You haven\'t signed your waiver!  Come back after you\'ve signed away all claims of liability toward me or Tally.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19127,'','Default.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19128,'My work here is complete!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19129,'My portal creation spells do not appear to work here. The damned naaru constructed this place well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19130,'Our time is finally at hand. The naaru and their allies will learn the true meaning of suffering.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19131,'Our imprisonment was intolerable. The sooner we can leave this accursed place, the better.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19132,'I cannot believe they made me move my transporter out of town!   Most of the gnomes affected by the accident regained some sort of humanoid form within a few weeks and it should have been an honor to be a participant in such a grand gnomish experiment!\n\nBesides, we needed the eggs!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19133,'Once you have built the device, you simply activate the device to be transported to Toshley\'s Station!    A few people have reported being transformed into chickens, but I am sure they were exaggerating!\n\nIf possible I would try and not use the device on a day when someone else has, but it will probably work out alright even if you do!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19134,'With the help of my brother Zap in Everlook I have constructed a Dimensional Imploder right here in Area 52.   Who needs a rocket when you have instant transportation via Goblin Engineering!   Are you a skilled enough Goblin Engineer to learn how to build your own Imploder beacon?\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19135,'I am happy to talk with another qualified Goblin Engineer!   So many Goblin Engineers learn how to make the Dimension Ripper and then we never hear from them again.  Puzzling.','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(19136,'I hope the Ultrasafe Transporter never lets you down!   I just know it won\'t but I would recommend carrying a parachute cloak just in case!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19137,'Stay frosty boys!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19138,'Keep an eye out boys.  It\'s too quiet out there.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19139,'Back up is on the way.  Keep up the fight!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19140,'Where\'s our back up?  I want them here now!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19141,'INCOMING!!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19142,'Hostile\'s on the move!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19143,'LET\'S ROCK!!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19144,'','Bring me another plaything to launch!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19145,'','I\'m feeling playful.  Bring me another Infernal!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19146,'Who\'s bad? Who\'s bad? That\'s right: we bad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19147,'Thanks for getting me out of there. I owe you one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19148,'I should be able to get out here now. Thanks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19149,'This place is crazy! I could spend years here investigating all this technology!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19150,'Doom Lord Kazzak will be pleased. You are to increase the pace of your attacks. Destroy the orcish and dwarven strongholds with all haste.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19151,'Don\'t worry about that. I\'ve increased production at the Deathforge. You\'ll have all the infernals you need to carry out your orders. Don\'t fail, Jovaan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19152,'Yes?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19153,'Keep up the good work.  Do well and you will be rewarded by the master.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19154,'Dig! Dig for the glory of the master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19155,'Let me know right away if you find something important.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19156,'My master, we are honored by your presence.  How may I serve thee?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19157,'Rise, young Voldoun.  Do not worry yourself with pleasantries.  I come at the behest of our master, Prince Kael\'thas.  He bids me to check on the progress of the mana bomb.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19158,'','Good, $n, you are under the spell\'s influence. I must analyze it quickly, then we can talk.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19159,'All goes exceedingly well, my lord.  Testing of the smaller prototype at the Cenarion Thicket was a complete success.  The second bomb is being ritually fueled in the courtyard below even as we speak.  And, I\'ve sent a courier to Tuurem to bring the rest of the parts to us here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19160,'You are satisfied?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19162,'For the time being, yes.  However, allow my presence to be a motivator.  Prince Kael\'thas was displeased with the failure of the crystal experiment on Fallen Sky Ridge.  This is one of the reasons for why we chose the Cenarion druids as the testing grounds for the bomb.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19163,'I need not tell you what will happen should the mana bomb down in the courtyard fail to be used on its target soon?  Since moving into the forest, they\'ve become increasingly annoying to our operations: here, at Tuurem and to the south at the Bonechewer Ruins.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19164,'I can assure you that we will not fail, my master.  I am personally overseeing every aspect of the construction, and I hold the final codes, myself.  Within a day\'s time, I will have the bomb detonated on those nearby pests.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19165,'See to it that you do, Sharth, or I will personally see to your slow torture and death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19166,'%s begins to channel from the nearby distiller...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19167,'%s reflects the spell back at its caster. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19168,'THREE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19169,'See? That\'s all it takes. It \'twasn\'t so bad.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19170,'I believe I may recognize them.  Deal with this quickly, Sharth.  Then take the mana bomb and destroy their town!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19171,'Halt!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19172,'What is it, my lord?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19173,'Zarath you must return to the Black Temple at once! I... I seem to have misplaced Lord Illidan\'s orders. Quickly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19174,'My lord, surely you do not expect me to leave you unattended. Lord Illidan would have my head if anything were to happen to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19175,'Zarath, I am perfectly capable of making it up this road to Eclipse Point. If we do not deliver the missive, Lord Illidan will have both of our heads! You are dismissed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19176,'As you wish, my lord.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19177,'Ah, sweet, sweet bloodthistle... Probably left behind by one of those filthy addicts at Eclipse Point.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19178,'Their loss is most definitely my gain...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19179,'%s puts the bundle of bloodthistle in his robe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19180,'Hide! Hide before they see you! Back up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19181,'The time to strike is at hand. Terminate Icarius.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19182,'Borak, I need another bundle of bloodthistle.','Borak, I need another bundle of bloodthistle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19183,'You have it. Do not lose it again!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19184,'Ah, damn it all! Clever trap. Too bad you\'ll never live to tell the tale...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19185,'Indeed, it is not a request.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19186,'My lord!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19187,'Duro will be reinforced!  Ultris was a complete disaster.  I will NOT have that mistake repeated!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19188,'We\'ve had too many setbacks along the way: Hellfire Citadel, Fallen Sky Ridge, Firewing Point...  Prince Kael\'thas will tolerate no further delays.  I will tolerate nothing other than complete success!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19189,'Yes, my lord.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19190,'See to it, Ardonis!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19191,'I am returning to Tempest Keep.  See to it that I do not have reason to return!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19192,'Get your house in order!  I will return to finish this conversation later.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19193,'%s pulls a throwing knife from his boot!','%s pulls a throwing knife from his boot!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19194,' I think that we should teach a lesson to both the Horde and the Alliance.  One that they will not soon forget!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19195,'Alas, sometimes one must take matters into one\'s own hands. Balamore shanal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19197,'','%s looks down at the discarded necklace.  In her sadness, the lady incants a glamour, which beckons forth Highborne spirits.  The chamber resonates with their ancient song about the Sin\'dorei...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19200,'That could have gone better, $n.  Come, I have something for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19201,'Bank','Bank',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19202,'Inn','Inn',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19203,'Flight Master','Flight Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19204,'Mailbox','Mailbox',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19205,'What is it that you have for me, ambassador?','What is it that you have for me, ambassador?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19206,'Just a small songbook that I thought you might like to have.  It contains the lyrics to a song known as the Lament of the Highborne; the one that Lady Sylvanas glamoured from the air.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19207,'%s calls for the aid of a nearby male!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19208,'Stable Master','Stable Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19209,'Battlemaster','Battlemaster',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19210,'Profession Trainer','Profession Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19211,'There are two banks in Shattrath, both along the rim of the central city hub. One is run by the draenei Aldor, the other by the blood elf Scryers.','There are two banks in Shattrath, both along the rim of the central city hub. One is run by the draenei Aldor, the other by the blood elf Scryers.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19212,'Aldor Bank','Aldor Bank',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19213,'Scryers Bank','Scryers Bank',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19214,'The Aldor bank is located northwest of the the city\'s center.','The Aldor bank is located northwest of the the city\'s center.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19215,'The Scryers bank is located southeast of the city\'s center.','The Scryers bank is located southeast of the city\'s center.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19216,'Shattrath\'s inns are full of wounded refugees. Still, there is room among the draenei Aldor and blood elf Scryers on Aldor Rise and Scryer\'s Tier.','Shattrath\'s inns are full of wounded refugees. Still, there is room among the draenei Aldor and blood elf Scryers on Aldor Rise and Scryer\'s Tier.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19217,'Aldor Inn','Aldor Inn',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19218,'Scryers Inn','Scryers Inn',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19219,'The Aldor inn is located high above Shattrath city, on Aldor Rise. The lift to there is northwest of the city center.','The Aldor inn is located high above Shattrath city, on Aldor Rise. The lift to there is northwest of the city center.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19220,'The Scryers inn is located above Shattrath city, on Scryer\'s Tier. The lift to there is southwest of the city center.','The Scryers inn is located above Shattrath city, on Scryer\'s Tier. The lift to there is southwest of the city center.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19221,'Shattrath\'s flight master is Nutral. You will find him east of the city\'s center.','Shattrath\'s flight master is Nutral. You will find him east of the city\'s center.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19222,'You will find mailboxes within or just outside the Aldor and Scryers banks and inns.','You will find mailboxes within or just outside the Aldor and Scryers banks and inns.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19223,'There are stable masters just outside both the draenei and blood elf inns on Aldor Rise and Scryer\'s Tier.','There are stable masters just outside both the draenei and blood elf inns on Aldor Rise and Scryer\'s Tier.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19224,'Aldor Stable','Aldor Stable',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19225,'Scryers Stable','Scryers Stable',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19226,'Shattrath\'s battlemasters often congregate on the stairwells between the upper and lower city. The Alliance battlemasters gather in one place, the Horde in another, with the arena battlemasters between and across from them.','Shattrath\'s battlemasters often congregate on the stairwells between the upper and lower city. The Alliance battlemasters gather in one place, the Horde in another, with the arena battlemasters between and across from them.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19227,'Alliance Battlemasters','Alliance Battlemasters',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19228,'Horde Battlemasters','Horde Battlemasters',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19229,'The Alliance battlemasters can usually be found on a stairwell northeast of the city\'s center.','The Alliance battlemasters can usually be found on a stairwell northeast of the city\'s center.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19230,'The Horde battlemasters can usually be found on a stairwell southeast of the city\'s center.','The Horde battlemasters can usually be found on a stairwell southeast of the city\'s center.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19231,'What sort of trainer were you looking for?','What sort of trainer were you looking for?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(19232,'Alchemy','Alchemy',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19233,'Cooking','Cooking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19234,'Enchanting','Enchanting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19235,'Jewelcrafting','Jewelcrafting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19236,'Leatherworking','Leatherworking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19237,'Skinning','Skinning',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19238,'First Aid','First Aid',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19239,'Lorokeem, grand master alchemist and Skettis outcast, lives among the other arakkoa in the northwest portion of the lower city.','Lorokeem, grand master alchemist and Skettis outcast, lives among the other arakkoa in the northwest portion of the lower city.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19240,'Jack Trapper can be found cooking in the lower city\'s open market, in the southeast.','Jack Trapper can be found cooking in the lower city\'s open market, in the southeast.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19241,'World\'s End Tavern','World\'s End Tavern',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19242,'The World\'s End Tavern may be found in the easternmost portion of the lower city.','The World\'s End Tavern may be found in the easternmost portion of the lower city.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19243,'High Enchanter Bardolan may be found in the Seer\'s Library on Scryer\'s Tier. A grand master of the art, he is surrounded by his students: masters, artisans, experts, and journeymen.','High Enchanter Bardolan may be found in the Seer\'s Library on Scryer\'s Tier. A grand master of the art, he is surrounded by his students: masters, artisans, experts, and journeymen.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19244,'','Sighing, %s kneels down and picks up the amulet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19245,'Mildred Fletcher may be found within the infirmary in the northeastern section of the lower city.','Mildred Fletcher may be found within the infirmary in the northeastern section of the lower city.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19246,'The draenei grand master jewelcrafter, Hamanar, may be found among his people on the Aldor Rise.','The draenei grand master jewelcrafter, Hamanar, may be found among his people on the Aldor Rise.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19247,'Seymour, the principal skinner in Shattrath and grand master of the trade, may be found in the lower city\'s open marketplace.','Seymour, the principal skinner in Shattrath and grand master of the trade, may be found in the lower city\'s open marketplace.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19248,'The grand master leatherworker Darmari may be found in the lower city\'s open marketplace.','The grand master leatherworker Darmari may be found in the lower city\'s open marketplace.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19249,'Blacksmithing','Blacksmithing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19250,'The armor and weapons crafters Kradu Grimblade and Zula Slagfury may be found working at a great forge in the lower city.','The armor and weapons crafters Kradu Grimblade and Zula Slagfury may be found working at a great forge in the lower city.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19251,'Who dares interrupt the Grand Commander?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(19252,'I need another disguise, Borak. I lost the last one.','I need another disguise, Borak. I lost the last one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19253,'Do try and be more careful, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19254,'Look alive, we\'ve got company!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19255,'Somebody call for an exterminator?','Somebody call for an exterminator?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19256,'I\'m all over it.','I\'m all over it.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19257,'Finally.','Finally.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19258,'Need something destroyed?','Need something destroyed?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19259,'You boys need some help?','You boys need some help?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19260,'I bring word from Lord Illidan.','I bring word from Lord Illidan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19261,'I\'m listening.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19262,'The cipher fragment is to be moved. Have it delivered to Zuluhed.','The cipher fragment is to be moved. Have it delivered to Zuluhed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19263,'','Belore...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19264,'%s\'s hand begins to glow with Arcane energy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19265,'Oh? Of course you have papers documenting this request.','',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(19266,'Perhaps you did not hear me, Ruusk. I am giving you an order from Illidan himself!','Perhaps you did not hear me, Ruusk. I am giving you an order from Illidan himself!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19267,'Listen to me, peon. We have a process for the delivery and safekeeping of the cipher fragment. The envoy delivers the missive, which is sealed by Lord Illidan. No missive, no transfer.','',25,1,1,0,0,0,0,0,1,0,0,0,26124),
(19268,'Very well. I will return to the Black Temple and notify Lord Illidan of your unwillingness to carry out his wishes. I suggest you make arrangements with your subordinates and let them know that you will be leaving this world soon.','Very well. I will return to the Black Temple and notify Lord Illidan of your unwillingness to carry out his wishes. I suggest you make arrangements with your subordinates and let them know that you will be leaving this world soon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19269,'<Ruusk swallows hard.>$B$BI... What do you mean?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(19270,'Do I need to go into all the gory details? I think we are both well aware of what Lord Illidan does with those that would oppose his word. Now, I must be going! Farewell, Ruusk! Forever...\n','Do I need to go into all the gory details? I think we are both well aware of what Lord Illidan does with those that would oppose his word. Now, I must be going! Farewell, Ruusk! Forever...\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19271,'Wait. Where are you going? You needed a transfer, correct? Let\'s just get it done and over with, ok? Zuluhed at Dragonmaw? It will be done. Please let Lord Illidan know that his orders were carried out with the full cooperation of the Eclipsion.$B$BI will dispatch Ruul the Darkener to personally deliver the fragment!$B$BYou heard me right - Ruul...\n','',1,6,273,0,0,0,0,0,1,0,0,0,26124),
(19272,'Ah, good of you to come around, Ruusk. Thank you and farewell.','Ah, good of you to come around, Ruusk. Thank you and farewell.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19273,'%s moves in behind you with his axe at the ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19274,'Everything is in readiness, warbringer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19275,'Warbringer, that will require the use of all the hold\'s infernals. It may leave us vulnerable to a counterattack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19276,'I\'m not afraid a\' you! Do you wanna\' fight? Huh, do ya\'? C\'mon! I\'ll fight ya\' with both paws behind my back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19277,'Now what should I do with you? I simply can\'t make up my mind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19278,'I could really use a heart. Say, can I have yours?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19279,'It shall be as you say, warbringer. One last question, if I may...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19280,'What\'s in the crate?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19281,'Crate? I didn\'t send you a crate, Jovaan. Don\'t you have more important things to worry about? Go see to them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19282,'With the help of Engineer Lapforge from Gadgetzan i have built a powerful gnomish transporter here at Toshley\'s Station!  I would be happy to help any gnomish engineer with enough skill to build their own personal transport beacon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19283,'Why are you so far from Toshley\'s Station?\n','Why are you so far from Toshley\'s Station?\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19284,'When you are ready to seek a new specialization, seek Narain Soothfancy.   He can be found in Steamwheedle Port in Tanaris.','When you are ready to seek a new specialization, seek Narain Soothfancy.   He can be found in Steamwheedle Port in Tanaris.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19285,'Control Conjured Water Elemental.','Control Conjured Water Elemental.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19286,'<The water elemental is ready to surge.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19287,'<The charger stands proud, eager for battle.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19288,'Control Human Charger.','Control Human Charger.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19289,'Forced to land like a dog. No matter. Soon, all of these wonderous beasts will be under the control of the master.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19290,'Your world is at an end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19291,'The skies will darken and all will go quiet. Only then will you know the sweet serenity of death...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19292,'<The cleric stares at you through the corner of its eye.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19293,'Control Human Cleric','Control Human Cleric',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19294,'<The conjurer stands fierce, its gaze distant.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19295,'Control Human Conjurer','Control Human Conjurer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19296,'<Llane\'s true wisdom and strength burn bright, even in this likeness of the king.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19297,'Control King Llane','Control King Llane',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19298,'Cyrukh has awoken!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19299,'You will suffer eternally!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19300,'Come, mortals, face the lord of fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19301,'Cyrukh comes for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19302,'Those that dare play with fire will be incinerated!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19303,'A flaming vortex takes shape.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19304,'You do not fight alone, $n! Together, we will banish this spawn of hellfire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19305,'We have come to help battle the dirge of Karabor!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(19306,'We will fight when you are ready, $n.','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(19307,'I am ready, Oronok. Let us destroy Cyrukh and free the elements!','I am ready, Oronok. Let us destroy Cyrukh and free the elements!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19308,'Little creature made of flesh, your wish is granted! Death comes for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19309,'We will set the elements free of your grasp by force!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19310,'We will fight when you are ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19311,'WARNING!  WARNING!  AWAY HOSTILE BEINGS!  DO NOT HEAD UP THE RIDGE TO TOSHLEY\'S STATION!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19312,'I AM FLUENT IN OVER TWO LANGUAGES: DWARVISH, GNOMISH AND THE VERY COMMON TONGUE OF HUMANS.  BUT I HAVE NO IDEA WHAT YOU ARE SAYING!$B$BSPEAK UP; I CANNOT HEAR YOU OVER THE GRINDING OF MY GEARS!','',33,0,0,0,0,0,0,0,1,0,0,0,26124),
(19313,'Yeah, yeah... welcome to my station.$B$BSo, what do you think?  Pretty nifty what we\'ve done here, wouldn\'t you say?$B$BMakes me glad to be rid of those stuffy elves at Sylvanaar anyway.$B$BMake yourself useful around here; there\'re plenty of experiments and whatnot to help out with.','',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(19314,'','Glory to the naaru, $n.  The Light will soon triumph over its enemies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19315,'Cansis, hold still. I\'m going to try to use this crystal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19316,'%s partially phases himself out of reality.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19317,'Interesting... Let me try something.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19318,'Cansis. You are a chicken.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19319,'<The grunt\'s mouth waters, anticipating bloodshed.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19320,'Control Orc Grunt','Control Orc Grunt',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19321,'%s focuses on $n!','%s focuses on $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19322,'<The summoned daemon twitches, fighting against Medivh\'s rules of play.  He wants your soul!>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19323,'Control Summoned Daemon','Control Summoned Daemon',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19324,'All of the nearby arokkoa face east and whistle a long, low note of devotion. [PH]','',15,0,0,1,0,0,0,0,1,0,0,0,26124),
(19325,'The dwarf appears to have been discovered and slain in the midst of a spy mission. The Deathforge\'s attendants have left the corpse in the open, perhaps as a warning to other would-be interlopers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19326,'Reclaim Flanis\'s pack.','Reclaim Flanis\'s pack.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19327,'Keep working!  You must be ready to join the front lines!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19328,'You are not worthy to be called Burning Legion!  Try harder worm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19329,'You are nearly ready!  You will soon be called to destroy our enemies and conquer this land!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19331,'You are nearly ready!  You will soon be called to destroy our enemies and conquer this land!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19332,'Could... Could it be over? Is he destroyed?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19333,'We must speak with the shaman of the Earthen Ring. Come...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19334,'What say the elements, Torlok? I hear only silence.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19335,'%s falls unconscious.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19336,'I hear what you hear, brother. Look behind you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19337,'They are redeemed! Then we have won?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19338,'It is now as it should be, shaman. You have done well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19339,'Yes... Well enough for the elements that are here, but the cipher is known to another... The spirits of fire are in turmoil... If this force is not stopped, the world where these mortals came from will cease.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19340,'Farewell, mortals... The earthmender knows what fire feels...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19341,'We leave, then, Torlok. I have only one request...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19342,'The Torn-heart men give their weapons to Earthmender Torlok.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19343,'Give these to the heroes that made this possible.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19344,'Things are proceeding as planned.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19345,'There have been reports of intruders. You are to notify me at once if you see anything unusual!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19346,'We\'re never going to fire one of these, are we?','We\'re never going to fire one of these, are we?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(19347,'Do we even have ammunition for these?','Do we even have ammunition for these?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(19348,'What, exactly, are we ever going to fire these at?','What, exactly, are we ever going to fire these at?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(19349,'I wonder how far this would launch that white cat...','I wonder how far this would launch that white cat...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(19350,'As you say, sir.','As you say, sir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19351,'Understood, sir.','Understood, sir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19352,'By your command!','By your command!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19353,'As you wish.','As you wish.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19354,'It shall be so, sir.','It shall be so, sir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19355,'Consider it done, sir.','Consider it done, sir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19356,'Be diligent! One word from me and  you\'ll be fed to the warlocks\' demons.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19357,'You see those bones at your feet? Those are guards who tried to desert their post.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19358,'Okay, okay! Me dancing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19359,'What\'s that? Oh you try and use birdy magic? I crush you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19360,'I hurt you for that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19361,'<The Arcane Guardian seems to face you, but says nothing.>','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19362,'<The Arcane Guardian gestures towards the easternmost portion of the lower city.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19363,'<The Arcane Guardian gestures to a place southeast of the city\'s center.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19364,'<The Arcane Guardian gestures across the Tier, towards the inn.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19365,'Don\'t get any ideas or I\'ll see that you join them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19366,'<Dark magic ripples from the necrolyte.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19367,'Control Orc Necrolyte','Control Orc Necrolyte',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19368,'<The Arcane Guardian gestures to a place east of the city\'s center.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19369,'Look sharp troops! Varedis is known for conducting surprise inspections.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19370,'<The Arcane Guardian gestures to a place across the Tier, towards the inn and nearby mailbox.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19371,'<The Arcane Guardian gestures across the Tier, towards the inn and the stablemaster outside it.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19372,'<The Arcane Guardian stands motionless, waiting for you to elaborate on which Battlemasters you mean.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19373,'They most often turn deadly, and we\'re understaffed as it is.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19374,'<The orc wolf\'s frozen, snarling mouth shivers your bones.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19375,'Control Orc Wolf','Control Orc Wolf',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19376,'<Behind the warlock\'s eyes smolders a deep malevolence.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19377,'Control Orc Warlock','Control Orc Warlock',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19378,'Chubis Chubisimo!  Get those things fixed... we haven\'t got all day!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19379,'When I was your age I could have had all of those shredders fixed before breakfast and still had time for all of my other chores.  In the Winterspring snow, no less.  And it\'s uphill both ways there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19380,'Chubis, after you\'re done there, make sure that you put another coat of wax on the Wheeler mobile.  I want to take mama out for a spin tonight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19381,'How much am I paying you?  You call that working?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19382,'I just knew that I shouldn\'t have fired Beebo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19383,'<Warchief Blackhand towers over the field.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19384,'Control Warchief Blackhand','Control Warchief Blackhand',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19385,'Okay, if you can manage to get even one of those fixed, I\'ll let you take a ten minute break.  How\'s that sound?  Pretty good, huh?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19386,'You want me to get into trouble?  I have a lot of work to do here, and old man Wheeler there isn\'t cutting me any slack.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(19387,'Guardians! To me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19388,'If you ever do that again, I will break your neck.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19389,'Fascinating.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19390,'I\'m a scientist who studies both time and sound, so I\'m not quite certain how I\'m supposed to think, or find the time to get any work done around here, with all of this racket?!$B$BWhy can\'t these fools go blow themselves up somewhere else?$B$BAh well, at least I look good.  Say, $g boy : lovely;, have I seen you around here before?','',5,6,0,0,500,0,0,0,1,0,0,0,26124),
(19391,'Spirits of fire grant us wisdom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19392,'Void energy gathers at the base of the %s!','Void energy gathers at the base of the %s!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19393,'Be ready to advance on the enemy.  We will soon launch an all out assault on the Betrayer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19394,'','This cell won\'t hold me for long.  I will have Illidan\'s head one way or another.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19395,'','Release me immediately or face my wrath!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19396,'','I do not know what manner of ruse you\'re attempting, Broken wretch, but I want no part in this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19397,'You cannot stop us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19398,'What $r dare harm those of my flock?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19399,'The orc\'s corpse has been casually tossed aside so as not to litter the walkway.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19400,'Search the corpse for Kagrosh\'s pack.','Search the corpse for Kagrosh\'s pack.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19401,'Mortals, here?  What is the meaning of this, pathetic Broken!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19402,'Have no fear, $r.  Just play along.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19403,'A mere nuisance, I assure you!  Tell the Master his prisoner will not escape while Akama and his Deathsworn watch over her.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19404,'You\'d do well not to toy with me, Akama.  Illidan has given me specific orders to keep a close watch on the Warden.  If I find out you\'re hiding anything from me, I will crush you with my own hands!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19405,'Forgive my harsh methods, but the Betrayer cannot learn of the truth.  My secret must be kept at all costs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19406,'To many of my people I am known as a traitor... as Illidan\'s lapdog.  It is best that they continue to think that for now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19407,'','If we truly desire the same thing, Akama, then release me!  If Illidan is to die, it shall be by my hand!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19408,'In due time, Maiev.  I\'ve spent years preparing to make my move - I can\'t afford to put my plans in peril by tipping my hand too soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19409,'','Curse you, Akama!  I am not a pawn in your game... my will is my own.  When I unleash my wrath upon Illidan it will have nothing to do with your foolish scheme!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19410,'All rewards for services rendered to be dispensed by Warcaller Sardon Truslice.$B$BPost no bills.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19411,'All rewards for services rendered to be dispensed by Warcaller Beersnout.$B$BPost no bills.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19412,'Aye, that\'ll do it! They\'ll come runnin\' once they see the reward we\'ve put up!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19413,'Wit a reward like dis, how could they refuse, mon?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19414,'%s detonates in a rage upon seeing its master die.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19415,'%s goes into a furious rage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19416,'Make ready the chambers, another ally will soon join our ranks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19417,'Our ally has arrived!  Clear the way to the materialization chamber!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19418,'Now, proceed to the translocator.  Forge Camp Wrath awaits your arrival!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19419,'Squawk!  Who dare slay my Worshippers and summon me , High Priest A, forth! [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19420,'I hunger! Feed me the power of this forge, my children!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19421,'Fools! Assemble yourselves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19422,'We have some uninvited guests.... [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19423,'','Ooh, this shall be fun! [PH]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19424,'Welcome to the Toshley\'s Station inn.  What can I do for you?','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(19425,'','Are you interested in learning the intricacies of Jewelcrafting?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(19426,'How do I use Prospecting?','How do I use Prospecting?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19427,'Prospecting is the primary method of finding gems!   You simply use the prospecting ability (which is found in the professions tab of your spellbook) on a stack of five ore to extract the gems from it.   Any type of non-precious ore will do!    \n\nBetter quality ores will provide more valuable gems so you will find higher quality gems in iron ore than in copper ore.','Prospecting is the primary method of finding gems!   You simply use the prospecting ability (which is found in the professions tab of your spellbook) on a stack of five ore to extract the gems from it.   Any type of non-precious ore will do!    \n\nBetter quality ores will provide more valuable gems so you will find higher quality gems in iron ore than in copper ore.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19428,'Where can I continue my Jewelcrafting Training?','Where can I continue my Jewelcrafting Training?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19429,'','If you wish to further your skills, seek Telia\'s shop in Silvermoon.  It is on the south end of the Royal Exchange.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19430,'Testing...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19431,'What do you wish to know of Jewelcrafting?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19432,'','Until you have mastered the Apprentice level of Jewelcrafting we shall not speak again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19433,'','My knowledge of Jewelcrafting I will share with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19434,'Creation of Jewelry and Gems is what I live for. Can I share my passion with you?','Creation of Jewelry and Gems is what I live for. Can I share my passion with you?',1,0,0,1,0,0,0,0,1,0,0,0,26124),
(19435,'','I wish I had more time to teach all who came before me, but alas that is not the way of things. Until you have learned all that Padaar has to teach, I cannot help you.',274,0,0,1,0,0,0,0,1,0,0,0,26124),
(19436,'','I am blessed to be able to help someone of your skills to learn more of Jewelcrafting. What do you wish to know?',1,0,0,1,0,0,0,0,1,0,0,0,26124),
(19437,'%s goes into a rage after seeing its master fall in battle!','%s goes into a rage after seeing its master fall in battle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19438,'%s sends its pet into a bestial rage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19439,'%s\'s thick scales begin to crack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19440,'%s\'s scales shatter, revealing its soft flesh below.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19441,'Retesting','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19442,'','I\'m extremely busy, $r.$B$BWe have a terrible problem on our hands that must be dealt with at once!',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(19443,'Hildagard, I need a new pair of goggles.','Hildagard, I need a new pair of goggles.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19444,'We will never dissipate, mortal... Our fate is tied to Gorefiend...','We will never dissipate, mortal... Our fate is tied to Gorefiend...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19445,'Pray that the chilling embrace of Teron Gorefiend does not reach out for you...','Pray that the chilling embrace of Teron Gorefiend does not reach out for you...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19446,'It is you who have invaded our home. Gorefiend will avenge us!','It is you who have invaded our home. Gorefiend will avenge us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19447,'Gorefiend will have your head, interloper!','Gorefiend will have your head, interloper!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19448,'We are bound here... eternally. It is the will of Gorefiend.','We are bound here... eternally. It is the will of Gorefiend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19449,'Test02','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19450,'%s begins to force toxic waste out of its broken tubes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19451,'Pour it on \'em boys!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19452,'Show no mercy!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19453,'Last push boys!  Let \'em have it!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19454,'This is the last of them.  Don\'t get sloppy!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19455,'Nice work soldiers!  This is the last of them!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19456,'','Enjoy the storm warm bloods!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19457,'Mount up!  We are outta here!','Mount up!  We are outta here!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19458,'Cavalry, let\'s roll out!','Cavalry, let\'s roll out!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19459,'Illidan\'s grasp on this land is slipping.  Can you feel it, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19460,'','When you run with Razak\'s Roughriders, you learn a thing or two about following orders.$B$BThe first thing is that you fight until you die.  The second thing is, see the first thing.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19461,'%s cries out for the blessing of the flight.','%s cries out for the blessing of the flight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19462,'%s is reborn anew!','%s is reborn anew!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19463,'Need your blade sharpened, or perhaps a new weapon? Better safe than sorry...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19464,'Let me see your wares.','Let me see your wares.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19465,'If it\'s a hammer you\'re looking for,  you\'ve come to the right place.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19466,'I wish to browse your wares.','I wish to browse your wares.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19467,'%s rushes forward, carefully watching its enemy.','%s rushes forward, carefully watching its enemy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19468,'Muahahahaha!  You fool!  You\'ve released me from my banishment in the interstices between space and time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19469,'All of Draenor shall quake beneath my feet!  I will destroy this world and reshape it in my image!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19470,'Where shall I begin?  I cannot bother myself with a worm such as yourself.  There is a world to be conquered!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19471,'No doubt the fools that banished me are long dead.  I shall take wing and survey my new demesne.  Pray to whatever gods you hold dear that we do not meet again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19472,'NOOOOooooooo......','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19473,'%s makes a break for the nearest rune circle.','%s makes a break for the nearest rune circle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19474,'$G Son : Young lady;, I\'m not going to lie to you; things aren\'t pretty around here.  We\'re under constant assault by the bugs and our very way of life, our freedom, is at stake!$B$BAre you going to be a responsible citizen and help out?','',1,6,0,0,500,0,0,0,1,0,0,0,26124),
(19475,'From the darkest night shall rise again the raven, shall take flight in the shadows, shall reveal the nature of its kind. Prepare yourself for its coming, for the faithful shall be elevated to take flight with the raven, the rest be forgotten to walk upon the ground, clipped wings and shame.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19476,'Steel your minds and guard your thoughts. The dark wings will cloud and consume the minds of the weak, a flock of thralls whose feet may never leave the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19477,'The old blood will flow once again with the coming of the raven, the return of the darkness in the skies. Scarlet night, and the rise of the old.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19478,'The raven was struck down once for flying too high, unready. The eons have prepared the Dark Watcher for its ascent, to draw the dark cloak across the horizon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19479,'This is a flavor whisper.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19480,'Teron Gorefiend? Yes... I know of him.','',1,273,0,0,0,0,0,0,1,0,0,0,26124),
(19481,'All systems on-line.  Prepare yourself, we leave shortly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19482,'The Skettis Windwalker throws a bundle of fragrant herbs into the fire. [PH]','',61,0,0,0,0,0,0,0,1,0,0,0,26124),
(19483,'Splendid! Marvelous! An excellent performance!','',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(19484,'Proceed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19485,'Wut dat?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19486,'Perty light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19487,'Me not see dat before.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19488,'Me catch firefly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19489,'Whoa!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19490,'Look out... ball of light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19491,'Duck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19492,'Me want light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19493,'','When I was young I trained hard to become an anchorite in the priesthood.  Female exarchs were practically unheard of.$B$BNowadays gender matters little - it is courage and conviction that make all the difference.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19494,'Your body is mine! Our fates are forever intertwined.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19495,'','Bring me another toy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19496,'','Another one!  Bring me another one!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19497,'You no cast spells!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19498,'If you are ready and wish to quickly return to the normal time stream, I can transport you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19499,'Take me back to my time.','Take me back to my time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19500,'Shaping the flow of time is a very difficult and quite delicate task, but you have performed admirably today.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19501,'No... no! What have you done? I am the master! Do you hear me? I am... aaggh! Can\'t... contain him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19502,'At last I am liberated. It has been too long since I have tasted true freedom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19503,'Waste no time, fool! Use our power to kill those that stand in our way! Destroy Karsius before you are subdued!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19504,'Your pathetic attempt to escape will be short lived, Gorefiend. Let the $g boy:girl; go and submit! Even with your armor and weapons, you cannot defeat the ancients!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19505,'Let this be a lesson to those that would do evil to our lands!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19506,'What ... have you done...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19507,'Well done, pawn. You are free to go as I no longer have a use for your body.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19508,'We will meet again... Someday.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19509,'Death incarnate has been released upon the world once more! Teron Gorefiend has returned...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19510,'Stupid, squishy $r. That weapon mine now! Give!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19511,'Halt!','Halt!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19512,'Surrender immediately!','Surrender immediately!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19513,'This area is restricted!','This area is restricted!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19514,'Stop them!','Stop them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19515,'I was just... following orders.','I was just... following orders.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19516,'Why...?','Why...?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19517,'Blackmoore will have... your head!','Blackmoore will have... your head!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19518,'Cursed scum!','Cursed scum!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19519,'Hm, hungry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19520,'Don\'t feel... so good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19521,'When can we eat again?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19522,'So-ngh-thirsty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19523,'What do you think you\'re doing?','What do you think you\'re doing?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19524,'Stop right there!','Stop right there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19525,'I\'ll...','I\'ll...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19526,'Agh!','Agh!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19527,'Oh no, you don\'t....','Oh no, you don\'t....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19528,'Nice try.','Nice try.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19529,'Give up or die!','Give up or die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19530,'You won\'t get far....','You won\'t get far....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19531,'You think you\'ve won?','You think you\'ve won?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19532,'You have achieved nothing!','You have achieved nothing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19533,'You are too late!','You are too late!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19534,'Do not think you can win!','Do not think you can win!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19535,'You don\'t stand a chance!','You don\'t stand a chance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19536,'We have all the time in the world....','We have all the time in the world....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19537,'All that you know... will be undone.','All that you know... will be undone.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19538,'You cannot escape us!','You cannot escape us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19539,'Of course, my mind isn\'t what it used to be. The only spells I\'m familiar with now are dizzy spells.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19540,'You know, if I was a bit younger, I\'d show you how a real man courts a young lady.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19542,'Have all the ingredients. Just can\'t remember the order they go in....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19543,'Now what was the name of that book? Oh yes, it was-- No, no, that wasn\'t it....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19544,'What good are words of power if you can\'t remember them?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19545,'Antonidas has some interesting notions about these orcs and their \"lethargy\".','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19546,'That Kel\'Thuzad is nothing but a troublemaker. If he keeps it up he\'ll get himself in hot water again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19547,'','You must have been very brave.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19548,'','That\'s not true. You\'re still a great wizard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19549,'','That\'s not true. You\'re still a great wizard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19550,'','Do you have a spell that can take me as far away from here as possible?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19551,'Mommy, mommy!','Mommy, mommy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19552,'Heeeelllpp!!','Heeeelllpp!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19553,'Tag! You\'re it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19554,'I wanna play soldier!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19555,'','Can I play?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19556,'','Ew, boys are gross!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19557,'If I don\'t have it, you don\'t need it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19558,'Guaranteed to satisfy, or your money back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19559,'Don\'t take it from me what a bargain this is. Come see for yourself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19560,'I hear that Blackmoore has been acting strange.','I hear that Blackmoore has been acting strange.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19561,'I\'m thinking of a vacation. I hear Hearthglen is nice.','I\'m thinking of a vacation. I hear Hearthglen is nice.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19562,'Quitting time can\'t come too soon.','Quitting time can\'t come too soon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19563,'Here to help with the disturbances?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(19564,'Zorus, I need a new pair of goggles.','Zorus, I need a new pair of goggles.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19565,'Tell me about the demon hunter training grounds at the Ruins of Karabor.','Tell me about the demon hunter training grounds at the Ruins of Karabor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19566,'As a reward for his years of service, Illidan allowed Kael\'thas to send him five warriors to train under him.  It would be the first time blood elves would be allowed to train as demon hunters.$B$BThe training was brutal.  Illidan put Kael\'s warriors through trials that would defeat most fully capable demon hunters.$B$BThree of Kael\'s elves died in training - another went mad.$B$BOne succeeded.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19567,'Varedis was his name.  To Illidan\'s surprise, not only did he succeed in the excruciating rites of passage that are part of the training; Varedis was already displaying better command over his powers than many veteran demon hunters.$B$BIllidan sensed the potential in Varedis and assigned three master demon hunters to train him further in their ways.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19568,'Within a year of training under Illidan\'s best three demon hunters, Varedis had surpassed them.$B$BNo longer content with the training they had to offer, Varedis infiltrated the Shadow Council where he learned of a powerful relic known as the Book of Fel Names.  He secretly read from this book, committing each passage to memory.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19569,'Knowledge of a demon\'s true name is rumored to give a certain amount of power over that demon.$B$BThe Book of Fel names is said to contain the true name of every demon ever to have existed.  By memorizing the passages in the book, Varedis had found a source of power to rival Illidan\'s own drinking from the Skull of Gul\'dan.$B$BAt Illidan\'s request, Varedis now runs the training grounds at the Ruins of Karabor - along with the three masters that mentored Varedis.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19570,'Be gone, mortal! Your kind is unwelcome here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19571,'It is not surprising that a blood elf\'s potential for power as a demon hunter is so high.  After all, the sin\'dorei do not have the natural aversion to demonic magic that night elves do.$B$BHowever, I do not expect many to succeed.  Most of them, Varedis included, pursue power for its own sake.  That power will consume them, for they are not driven by the pure fire that burns inside a true demon hunter\'s heart.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19572,'That\'s quite a story.','That\'s quite a story.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19573,'There was something else I wanted to ask you, Altruis.','There was something else I wanted to ask you, Altruis.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19574,'Go on, please.','Go on, please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19575,'I\'m listening.','I\'m listening.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19576,'Interesting.','Interesting.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19577,'Illidan\'s lapdogs!  You will pay for my imprisonment with your lives!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19578,'','You dare fight me?  I was trained by Illidan himself!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19579,'You will witness true power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19580,'You will soon pray for a switft death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19581,'This doesn\'t look right...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19582,'The metal\'s magical properties are gone! It can still be worked, but not by conventional smithing methods.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19583,'You dare intrude in my sanctum?  I promise you a world of pain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19584,'No, this isn\'t right. What\'s happened here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19585,'The metal has lost its magic. I could make a weapon from it, but it would be no different from a mundane blade.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19586,'You can take a man away from the Sons of Lothar, but you can\'t take the Sons out of him.$B$B<The smith shrugs.>$B$BIt\'s hard to explain, but I don\'t feel like I\'m meant to be at Honor Hold right now, is all.$B$BPerhaps I\'m meant to be part of something larger.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19587,'','I will tear you to pieces, demon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19588,'Mumman has set up her humble shop near the main entrance of the city, just past the inn. A fine cook, that one.','Mumman has set up her humble shop near the main entrance of the city, just past the inn. A fine cook, that one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19589,'Mana Loom','Mana Loom',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19590,'Keelen\'s tailoring shop in the northwest corner of the Bazaar has a loom like you describe.','Keelen\'s tailoring shop in the northwest corner of the Bazaar has a loom like you describe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19591,'You can find our mana loom in the merchant\'s bazaar within the Lower City.','You can find our mana loom in the merchant\'s bazaar within the Lower City.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19592,'Work harder!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19593,'Mine rock!  Crack stone!  Faster!  Faster!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19594,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19595,'Be gone, trifling elf.  I am in control now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19596,'Finally, my banishment ends!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19597,'We all have our demons....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19598,'','Feel my wrath, $r scum!  You will not get away with this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19599,'Who disturbs my slumber?  That spear... I still carry the scar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19600,'<The Arcane Guardian silently waits for you to further elaborate.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19602,'%s reads several pages of the Lexicon Demonica before beginning his work.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19603,'Into this blade, I imbue the power to strike down the strongest of demons! No demon shall stand before the wielder of this weapon!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(19604,'Anti-demon magics flare to life and imbue the weapon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19605,'Thank you, $n, for saving us from a fate worse than death.  You have our eternal gratitude.','Thank you, $n, for saving us from a fate worse than death.  You have our eternal gratitude.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19606,'Aaghh, the poison...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19607,'Better, much better.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19608,'What is it that you want from me, shaman?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(19609,'Do you not have eyes? Did you not see the demons on our very doorstep? I do not have the soldiers to spare!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(19610,'Pray to your gods, shaman. Perhaps they will come to your aid. The Horde, however, cannot...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(19611,'Look, if I\'ve told ya once, I\'ve told ya a hundred times: WE CANNOT HELP YOU!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19612,'I don\'t get it! Are ya blind? Can ya not see the demons bangin\' on our door? Who am I gonna send out to talk to your shaman friends? Point \'em out!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19613,'I really wish I could help ya, but I can\'t! Kurdran\'s given me direct orders. Now move along!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19614,'This book would give me unlimited power over my enemies... I would become... unstoppable!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19615,'No... you must take this from me, $n!  I feel its dark power swaying my will already!  Use it to destroy Varedis.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19616,'\"It is too soon for you to control me, for you have recently left the game.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19617,'To pass beyond my Hall, you must defeat me in a game of skill!  Control your king when you are ready to begin...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19618,'Chief, I\'ve somehow misplaced my X-52 Rocket Helmet!!!!','Chief, I\'ve somehow misplaced my X-52 Rocket Helmet!!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19619,'Well, alright then, there you go, First Officer $n.  Just try to be more careful with your helmet in the future.$B$BThose things don\'t grow on trees, you know!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19620,'Whatever advice I can give to aid in your fight against the ogres, you shall have it!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(19621,'%s begins intensely dodging incoming attacks!','%s begins intensely dodging incoming attacks!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19622,'Facing $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19623,'$n, you above all have earned the right for the Horde to inhabit our ancestral home.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19624,'By recovering the artifacts of our clan, by taking up the fight against our ancient enemy, the Bladespire ogres, and their gronn masters, by returning the Thunderspike to my hand, you have secured the blessing of the Thunderlord clan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19625,'I have been watching you and Rexxar.  You must aid him to secure the future of the Horde here in these mountains.  Only when you have forced the ogres into submission and slain their master, Gruul the Dragonkiller, will your people be safe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19626,'You honor our memory.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19627,'The details of the posting call for the execution of an enormous wolf.  She apparently keeps her den to the south of the Jagged Ridge, near the Horde stronghold.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19628,'What you read is something that you don\'t think you\'re quite ready for.$B$BYou should check back later.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19629,'Excellent!  You are almost ready my pet.','Excellent!  You are almost ready my pet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19630,'You are coming along nicely.','You are coming along nicely.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19631,'Good!  Soon you will be ready for a rider.','Good!  Soon you will be ready for a rider.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19632,'Stupid drake!  When will you learn to follow directions?','Stupid drake!  When will you learn to follow directions?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19633,'If you keep failing these simple tasks, you will be put down.','If you keep failing these simple tasks, you will be put down.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19634,'Your failures are tiring me.  If you cannot do as instructed we will have no use for you.','Your failures are tiring me.  If you cannot do as instructed we will have no use for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19635,'Now, execute the instructions!','Now, execute the instructions!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19636,'Prepare to die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19637,'<The Arcane Guardian gestures towards a place below the Tier, a stairwell northeast of the city\'s center.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19638,'<The Arcane Guardian gestures to a place below the Tier, a stairwell southeast of the city\'s center.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19640,'<The Arcane Guardian gestures to the northwest portion of the lower city, where Shattrath\'s arakkoa dwell.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19641,'<The Arcane Guardian gestures down towards the lower city, where a great forge may be found.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19642,'<The Arcane Guardian gestures down towards the lower city\'s open market, in the southeast.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19643,'Go on, kill them! I\'ll be the better for it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19644,'More knowledge, more power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19645,'I am more powerful than ever!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19646,'<The Arcane Guardian gestures towards the Seer\'s Library.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19647,'<The Arcane Guardian gestures towards the northeastern section of the lower city.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19648,'<The Arcane Guardian gestures towards Aldor Rise.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19650,'<The Arcane Guardian gestures towards the lower city\'s open marketplace.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19651,'Welcome to Aldor Rise. You seek guidance?','Welcome to Aldor Rise. You seek guidance?',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(19652,'You will find a caregiver center in the southern portion of Aldor Rise.','You will find a caregiver center in the southern portion of Aldor Rise.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19653,'You will find a mailbox near the caregiver center.','You will find a mailbox near the caregiver center.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19654,'You will find the Stable Master near the caregiver center.','You will find the Stable Master near the caregiver center.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19655,'You will find the enchanting trainer, Zurii, in southern Aldor Rise.','You will find the enchanting trainer, Zurii, in southern Aldor Rise.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19656,'A grand master jewelcrafter, Hamanar, may be found in northern Aldor Rise.','A grand master jewelcrafter, Hamanar, may be found in northern Aldor Rise.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19657,'Greetings, $c - I\'m a Commendation Officer acting on behalf of Silvermoon City.  It is my duty to assist adventurers who have received Horde Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Silvermoon City for your duty and service.','Greetings, $c - I\'m a Commendation Officer acting on behalf of Silvermoon City.  It is my duty to assist adventurers who have received Horde Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Silvermoon City for your duty and service.\n',66,1,0,0,0,0,0,0,1,0,0,0,26124),
(19658,'Greetings, $c - I\'m a Commendation Officer acting on behalf of the Exodar.  It is my duty to assist adventurers who have received Alliance Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from the Exodar for your duty and service.\n','Greetings, $c - I\'m a Commendation Officer acting on behalf of the Exodar.  It is my duty to assist adventurers who have received Alliance Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from the Exodar for your duty and service.',66,1,0,0,0,0,0,0,1,0,0,0,26124),
(19659,'Netherock?!  That thing\'ll squish you flat with one step of its massive foot!  No thanks!','Netherock?!  That thing\'ll squish you flat with one step of its massive foot!  No thanks!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19660,'Last time someone went out to try to collect the bounty on Netherock, all we got back was a compressed layer of foolhardy adventurer!','Last time someone went out to try to collect the bounty on Netherock, all we got back was a compressed layer of foolhardy adventurer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19661,'The Blade\'s Edge Mountains are a place of great opportunity.  How unfortunate that some deem themselves above all others on matters that pertain to taking advantage of such opportunities.$B$BWho do the Cenarion Expedition think they are to tell us what we can and cannot do here?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(19662,'Overseer, I am here to negotiate on behalf of the Cenarion Expedition.','Overseer, I am here to negotiate on behalf of the Cenarion Expedition.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19663,'Negotiations?  NEGOTIATIONS!$B$BAllow me to make our stance perfectly clear.  We are a free people, able to do whatever we want and come and go as we please.  The Cenarion Expedition does not own this mountain range.$B$BThere will be no negotiations!  Now, go back to the druids and tell them that we will continue to do as we please.','',5,25,0,0,500,0,0,0,1,0,0,0,26124),
(19664,'We\'ve come to the Ruuan Weald to see if we can reestablish the balance of nature to these mountains.$B$BThe interference of the arakkoa and the wyrmcult is making this a difficult task, however.$B$BLuckily, there are those like you and Samia that are willing to lend us a hand.','',1,1,0,0,500,0,0,0,1,0,0,0,26124),
(19665,'Haha, you\'re back?  You don\'t seriously expect me to change my mind do you?$B$BGet lost.','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(19666,'I\'ve rigged a few control consoles down the slope. Get to one quickly and take control of the fel reaver! You\'ll only have a limited amount of time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19667,'I\'m ready for my test flight!','I\'m ready for my test flight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19668,'Send me to Razaan\'s Landing!','Send me to Razaan\'s Landing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19669,'Take me to Ruuan.','Take me to Ruuan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19670,'Take me to Raven\'s Wood.','Take me to Raven\'s Wood.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19671,'Take me to Singing Ridge.','Take me to Singing Ridge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19672,'GET THOSE GUNS ONLINE!!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19673,'FIRE UP THE DEF GUNS!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19674,'We can handle it from here.  Roughriders you are dismissed.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19675,'Speak quickly, $n. We haven\'t much time!','Speak quickly, $n. We haven\'t much time!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(19676,'Collecting','Collecting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19677,'I detect a charge in your paranarbulatric region!  You must have used the Zephyrium Capacitorium lately -- you can\'t use it again until the charge wears off...','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(19678,'','I am here at the behest of my master, Baron Sablemane, to help the Cenarion Expedition with its wyrmcult problems.$B$BI\'m something of an expert on these things.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19679,'','I did not wish to lower myself by engaging your kind, but you leave me little choice...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19680,'Searching','Searching',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19681,'Nuaar, are you feeling well?  You don\'t look like yourself today.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(19682,'Begone, overseer!  We\'ve already spoken.$B$BStop dragging your feet and execute your orders at Ruuan Weald!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(19683,'I\'m fine, thank you.  You asked for me?','I\'m fine, thank you.  You asked for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19684,'Right, the meeting.  Let\'s get down to it then.$B$BThe fact is that the lumber and livestock being gathered from the Ruuan Weald, which you\'re responsible for, has slowed to a trickle.$B$BWe need those resources, but you\'ve allowed the druids of the Cenarion Expedition to get in the way!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(19685,'Oh, it\'s not my fault, I can assure you.','Oh, it\'s not my fault, I can assure you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19686,'I don\'t want excuses, I demand results!$B$BYou think what we\'re doing here is a joke?  If we don\'t do this right, then not only will the so-called do-gooders come calling, but we\'ll be found unworthy for elevation within the ranks of the Blackwing.$B$BIs that what you want?','',1,6,0,0,500,0,0,0,1,0,0,0,26124),
(19687,'Um, no... no, I don\'t want that at all.','Um, no... no, I don\'t want that at all.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19688,'You could at least try to sound a little bit convincing.$B$BLook, Nuaar, I wasn\'t going to tell you this, but I might as well because it\'s going to involve you, too.  Maxnar is planning an all-out attack on the druids at Ruuan Weald.  And he intends to wipe them out.$B$BIt\'s bad enough that we\'ve been fighting with the Boulder\'mok ogres, so we can\'t afford another front to deal with.  I\'ve arranged for a temporary truce with the arakkoa.$B$BWell, what do you think?','',1,1,6,0,500,500,0,0,1,0,0,0,26124),
(19689,'Impressive.  When do we attack?','Impressive.  When do we attack?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19690,'We\'re putting the final preparations together even as we speak.  The rest will depend upon how quickly you can organize your forces at Ruuan Weald.$B$BDo you think that you can handle that and get it done quickly?','',1,6,0,0,500,0,0,0,1,0,0,0,26124),
(19691,'Absolutely!','Absolutely!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19692,'That\'s the spirit!$B$BI\'m glad that we had this little meeting.  I feel much better about the attack now.  With leaders like you on the front, how can we lose?$B$BAlright, you have your marching orders.  Now get back to the Ruuan Weald and make it happen!','',4,1,0,0,500,0,0,0,1,0,0,0,26124),
(19693,'','Lend us the strength of the giants of Shadowmoon, Corok. The master is a just ruler. He will be sure to take care of those that assisted in subduing the dissidents of this world.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19694,'%s begins channelling power into Dimensius.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19695,'And... if we do not?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19696,'','Then you become enemies of my lord, Illidan. Enemies of Illidan are destroyed. Are your giants able to withstand an attack from the forces of Eclipse Point?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19697,'','No... I did not think so...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19698,'Enemies approach! Call for me when you are at a safe location.','Enemies approach! Call for me when you are at a safe location.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(19699,'','Karazhan wasn\'t always quite as... ominous.  The darkening of Karazhan only came with Medivh\'s death.  Or what we believe was Medivh\'s death.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19700,'Using','Using',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19701,'Straighten up!  I will not have soldiers in my unit looking so undisciplined before Val\'zareq.','Straighten up!  I will not have soldiers in my unit looking so undisciplined before Val\'zareq.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19702,'You will do nothing to dishonor me before Val\'zareq.  Is that clear?','You will do nothing to dishonor me before Val\'zareq.  Is that clear?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19703,'You are doing well.  Keep it up!','You are doing well.  Keep it up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19704,'Sir, yes Sir!','Sir, yes Sir!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19705,'As you command, Sir!','As you command, Sir!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19706,'We shall not fail you Sir!','We shall not fail you Sir!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19707,'You made it this far, grunt. There is no turning back now.','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(19708,'I\'ve lost my Kor\'kron Flare Gun, sir. May I have another?','I\'ve lost my Kor\'kron Flare Gun, sir. May I have another?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19709,'You\'re wearing my patience thin, grunt. I\'ve put the new flare gun in your pack. Try not to lose this one!','',25,5,0,0,0,0,0,0,1,0,0,0,26124),
(19710,'The wyrmcult blackwhelp lies here netted and helpless.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19711,'Collect the wyrmcult blackwhelp.','Collect the wyrmcult blackwhelp.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19712,'You quickly place the subdued whelp into your pack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19713,'Hello, overseer.  Ready for the attack?','Hello, overseer.  Ready for the attack?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(19714,'Something you need, sir?','Something you need, sir?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(19715,'You don\'t look well, overseer.','You don\'t look well, overseer.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19716,'I heard that Kolphis Darkscale has been looking for you.','I heard that Kolphis Darkscale has been looking for you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19717,'Samia, do you know who Kolphis Darkscale is?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19718,'','Yes, he\'s the second-in-command of the wyrmcult at the Blackwing Coven to the west.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19719,'These druids have tapped a tremendous source of power!  They can turn into animals... project  lightning and intense moonlight... I must discover how they do it!$B$BPerhaps they\'re wearing batteries underneath those robes...','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(19720,'Until Tally works out the kinks in this flight, the Capicitorium will need some extra fuel.  5 units ought to do it!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19721,'I have the fuel!  Take me to Raven\'s Wood.','I have the fuel!  Take me to Raven\'s Wood.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19722,'<The arakkoa favors you with a haunted gaze and alternates between looking at you and looking through you.>$B$BWhat have our efforts wrought, but a greater abomination than we sought to prevent?','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(19723,'Countdown to February 16th, 2007: $4262d$BRaw number: $4262e','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19724,'In Outland, our forces fight against the Horde to control the Eye of the Storm. It is dangerous, fighting amidst the raging energies of the Nether. Do you have what it takes to join us?','In Outland, our forces fight against the Horde to control the Eye of the Storm. It is dangerous, fighting amidst the raging energies of the Nether. Do you have what it takes to join us?',66,0,0,1,0,0,0,7,1,0,0,0,26124),
(19725,'The mana cells within the Eye of the Storm are a precious thing; we cannot afford to lose them to the draenei! You there! Make yourself useful and aid us in the fight!','The mana cells within the Eye of the Storm are a precious thing; we cannot afford to lose them to the draenei! You there! Make yourself useful and aid us in the fight!',1,0,0,1,0,0,0,1,1,0,0,0,26124),
(19726,'$n! Come here! Surely you know of the battle that rages within Alterac Valley back on Azeroth. We need every able-bodied fighter we can muster. Fight with the Stormpike Guard and defeat the Frostwolves!','$n! Come here! Surely you know of the battle that rages within Alterac Valley back on Azeroth. We need every able-bodied fighter we can muster. Fight with the Stormpike Guard and defeat the Frostwolves!',1,1,6,0,0,0,0,7,1,0,0,0,26124),
(19727,'This flight takes you to the far point of the Singing Ridge.  Very dangerous!$B$BFor this one, I\'m going to need a signed waiver...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19728,'I have the signed waiver!  Fire me into the Singing Ridge!','I have the signed waiver!  Fire me into the Singing Ridge!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19729,'Send me back to the Jagged Ridge.','Send me back to the Jagged Ridge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19730,'Send me back to the Singing Ridge.','Send me back to the Singing Ridge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19731,'Send me back to Razaan\'s Landing.','Send me back to Razaan\'s Landing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19732,'Send me back to Ruann Weald.','Send me back to Ruann Weald.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19733,'Send me back to Raven\'s Wood.','Send me back to Raven\'s Wood.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19734,'We\'re always eager for more flight data!  Where do you want to go?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19735,'I want to fly to an old location!','I want to fly to an old location!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19736,'%s raises his shield in a vigorous defense!','%s raises her shield in a vigorous defense!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19737,'Brashly you have attacked my children, Illidan! The pact is broken. Giant will never side with elf! NEVER!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19738,'%s begins to channel arcane energy....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19739,'%s roars in defiance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19740,'You hear the sound of giant gears churning to life below the depths...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19741,'You hear the faint sound of a gate unlocking in the cavern.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19742,'What is it, $r? Have you gathered some new information?','What is it, $r? Have you gathered some new information?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19743,'We\'re under attack! Defend yourself! I\'m taking the high road. Call me back when the coast is clear!','We\'re under attack! Defend yourself! I\'m taking the high road. Call me back when the coast is clear!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(19744,'You will never get the Heart of Fury!  Its power belongs to Illidan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19745,'I need another waiver!','I need another waiver!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19746,'What is it then? Can\'t you see I\'m a busy dwarf?','',6,25,0,0,0,0,0,0,1,0,0,0,26124),
(19747,'I need another Wildhammer Flare Gun, Thane.','I need another Wildhammer Flare Gun, Thane.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19748,'It\'s a done deal, soldier. The replacement flare gun is in your pack. Don\'t lose this one!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(19749,'Die, worms!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19750,'While exploration in these new lands is no doubt important, you mustn\'t forsake Azeroth! We need you now more than ever in the fight against the Defilers. Those resources must be secured!','While exploration in these new lands is no doubt important, you mustn\'t forsake Azeroth! We need you now more than ever in the fight against the Defilers. Those resources must be secured!',1,1,6,0,0,0,0,7,1,0,0,0,26124),
(19751,'You, $c! We require your aid! The brutish Warsong orcs are destroying the wonder and beauty of Ashenvale, and we need your strength to meet them on the field of battle. Return with us to Azeroth and fight for the honor of the Silverwing Sentinels! Will you join us?','You, $c! We require your aid! The brutish Warsong orcs are destroying the wonder and beauty of Ashenvale, and we need your strength to meet them on the field of battle. Return with us to Azeroth and fight for the honor of the Silverwing Sentinels! Will you join us?',1,1,6,0,0,0,0,7,1,0,0,0,26124),
(19752,'Yes... what do you want, $r? Can\'t you see I am busy here?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(19753,'There\'s an old saying, \"Give a man a fish; you have fed him for a day.  Teach a man to fish; and you have fed him for a lifetime.\"  Of course, you might want to cook that fish and that is where I come in.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19754,'Hello, $n!  How goes your adventures? My experiments are progressing nicely...$B$BBe sure to check back with me later!   I might have more test flight opportunities for you!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19755,'Tell me more about this thing you call \"cooking?\"','Tell me more about this thing you call \"cooking?\"',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(19756,'Strength and honor, $c. We need eager soldiers like you in Alterac Valley; the territory of the Frostwolves must be defended! Will you return to Azeroth and lend your aid?','Strength and honor, $c. We need eager soldiers like you in Alterac Valley; the territory of the Frostwolves must be defended! Will you return to Azeroth and lend your aid?',1,1,1,0,0,0,0,1,1,0,0,0,26124),
(19757,'$R! Yes, you! Why do you waste time dawdling in this wreck of a city when your rightful place is in Arathi Basin? The League of Arathor is ruthless in its assault; your contribution is needed, and you will be rewarded!','$R! Yes, you! Why do you waste time dawdling in this wreck of a city when your rightful place is in Arathi Basin? The League of Arathor is ruthless in its assault; your contribution is needed, and you will be rewarded!',1,1,1,0,0,0,0,1,1,0,0,0,26124),
(19758,'$C, back on Azeroth, the Silverwing Sentinels hamper our progress in the woods. We need you there on the battlefront to push them back! You will earn great honor and reputation with the Warsong Outriders for helping us - join us now!','$C, back on Azeroth, the Silverwing Sentinels hamper our progress in the woods. We need you there on the battlefront to push them back! You will earn great honor and reputation with the Warsong Outriders for helping us - join us now!',1,1,6,0,0,0,0,1,1,0,0,0,26124),
(19759,'Save yourself, $r. Flee from this place! The Crimson Sigil will execute you on sight if you are discovered.','Save yourself, $r. Flee from this place! The Crimson Sigil will execute you on sight if you are discovered.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19760,'The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19761,'In the name of Illidan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19762,'For our patron!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19763,'Die, interloper!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19764,'There will be no escape...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19765,'The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19766,'The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19767,'The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19768,'The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19769,'The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19770,'The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19771,'The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19772,'The Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','The Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19773,'The Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.','The Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19774,'At your command, my liege...\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19775,'The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19776,'The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19777,'The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19778,'The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19779,'Destroy them, Torloth. Let loose their blood like a river upon this hallowed ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19780,'The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19781,'The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19782,'The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19783,'The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19784,'The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19785,'As you desire, Lord Illidan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19786,'The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19787,'The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19788,'For Lord Illidan, I would sacrifice even this magnificent physique. On this day, you will fall - another victim of Torloth...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19789,'The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19790,'<The grizzled gladiator speaks in halting Common.> What? You have a problem with me? Take it to the arena. I don\'t waste my time with your little \"hordes\" and \"alliances.\"','',25,274,0,0,3,0,0,0,1,0,0,0,26124),
(19791,'Gladiators earn the right to wear equipment like mine by winning ranked arena matches.','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(19792,'<The veteran gladiator speaks in halting Orcish.> What? You have a problem with me? Take it to the arena. I don\'t waste my time with your little \"hordes\" and \"alliances.\"','',25,274,0,0,3,0,0,0,1,0,0,0,26124),
(19793,'Gladiators earn the right to wear equipment like mine by winning ranked arena matches.','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(19794,'Return to Shattrath, hero. Seek out the wisdom of A\'dal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19795,'Dark days are upon us, $n. What are we to do when even our greatest heroes fall before the might of Illidan?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19796,'Quickly, get to the middle of the platform! Illidan\'s fury is soon to be unleashed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19797,'What manner of fool dares stand before Illidan Stormrage? Soldiers, destroy these insects!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19798,'You are no challenge for the Crimson Sigil. Mind breakers, end this nonsense!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19799,'Run while you still can. The highlords come soon...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19800,'Torloth, your master calls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19801,'So you have defeated the Crimson Sigil. You now seek to challenge my rule? Not even Arthas could defeat me, yet you dare to even harbor such thoughts? Then I say to you, come! Come $n! The Black Temple awaits...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19802,'Yo! Have you heard about the Steamwheedle Fighting Circuit?\n\nYou can find Arena Organizers selling the arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','Yo! Have you heard about the Steamwheedle Fighting Circuit?\n\nYou can find Arena Organizers selling the arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19803,'Hey there.  Taking a break, overseer?  We don\'t get to see you around here much anymore since you were reassigned to Ruuan Weald.$B$BTake a look at what I have to offer.  It may not have changed much since last we spoke, but I\'ve got plenty.$B$BAnd don\'t be such a stranger!','',6,1,0,0,500,0,0,0,1,0,0,0,26124),
(19804,'Very well, let me see what you\'ve got.','Very well, let me see what you\'ve got.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19805,'My loathing of interruptions is overshadowed only by my hatred of Gruul the Dragonkiller and his seven sons!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19806,'Ranked arena matches start in $4262d. Would-be champions are already busy honing their skills and acquiring the best gear they can. Are you going to be ready?','Ranked arena matches start in $4262d. Would-be champions are already busy honing their skills and acquiring the best gear they can. Are you going to be ready?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19807,'','You must... free... my children...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19808,'There, it is completed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19809,'They can\'t keep this up! Their wings will eventually give...','',5,396,0,0,0,0,0,0,1,0,0,0,26124),
(19810,'Just one good shot...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19811,'','Read the tome of divinity I have given you, $n.  When you have learned from the book, speak with me again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19812,'%s picks up the flayer carcass.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19813,'Your fate is written.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19814,'The chaos I have sown here is but a taste....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19815,'I am merely one of... infinite multitudes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19816,'You will do my bidding, weakling.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19817,'Your will is no longer your own.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19818,'Flee in terror.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19819,'I will show you horrors undreamed of.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19820,'Master... I\'ve failed you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19821,'We span the universe, as countless as the stars!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19822,'I have no idea what goes on here, but I will gladly join your fight against this impudent imbecile!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19823,'Prepare to defend yourself, cretin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19824,'I didn\'t even break a sweat on that one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19825,'You guys feel free to jump in anytime.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19826,'I\'m gonna light you up, sweet cheeks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19827,'Ice, ice baby.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19828,'Heal me! For the love of all that\'s holy, heal me! I\'m dying!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19829,'You\'ll be hearing from my lawyer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19830,'%s retrieves the Heart of Fury.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19831,'You dare imprison me? You will die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19832,'You are... nothing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19833,'You shall be consumed by flame!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19834,'S-s-o-o... cold.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19835,'Pathetic, inferior mortals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19836,'The dragonflight will... devour you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19837,'The black dragonflight will conquer all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19838,'Doom upon you... wretched mortals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19839,'I\'m gonna cook ya, an\' then I\'m gonna eat ya!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19840,'I hope you all... die in pain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19841,'Grulloc having lots of fun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19842,'Me hungry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19843,'You be Grulloc\'s friend!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19844,'Mmm, other white meat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19845,'Piggy stop!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19846,'Where piggy go?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19847,'Sound the alarm!','Sound the alarm!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19848,'%s hungrily eats the flayer carcass.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19849,'Thank you, mortal.','',0,0,0,0,0,0,0,11,1,0,0,0,26124),
(19850,'Ah, another $c looking to be a gladiator, eh? Good!\n\nI sell the arena team charters you\'ll need to participate in ranking Steamwheedle Fighting Circuit matches.','Ah, another $c looking to be a gladiator, eh? Good!\n\nI sell the arena team charters you\'ll need to participate in ranking Steamwheedle Fighting Circuit matches.',1,0,0,1,0,0,0,0,1,0,0,0,26124),
(19852,'How do I form an arena team?','How do I form an arena team?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19853,'The Steamwheedle Fighting Circuit isn\'t selling the arena team charters you\'ll need to participate in ranking matches yet.\n\nStill, you can find an Arena Battlemaster and get in some practice rounds. It\'s never too soon to start training.','The Steamwheedle Fighting Circuit isn\'t selling the arena team charters you\'ll need to participate in ranking matches yet.\n\nStill, you can find an Arena Battlemaster and get in some practice rounds. It\'s never too soon to start training.',1,0,0,1,0,0,0,0,1,0,0,0,26124),
(19854,'Your overconfidence will be your undoing! Guards, lend me your strength!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19855,'','Spinebreaker Post is a great place to be stationed!  The Bleeding Hollow aberrations are so close you can smell their foul blood!  What better place to gather vengeance from a clan that has forsaken its brethren and made a pact with demons?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19856,'Piggy!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19857,'Porkchops!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19858,'The Heart of Fury... I witnessed its power long ago, when Velen wielded it.  I feel the same power coursing through it right now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19859,'With this crystal\'s powers, my Deathsworn and I... we\'d be unstoppable!  We could destroy Illidan!  We could... replace him as lords of Outland!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19860,'But that is not part of the vision I was granted... that is not... how my people will be freed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19861,'Fairweather and I are up here representing Sylvanaar\'s interests.$B$BThe druids have been more than accommodating, but allowing the Horde to travel through here gives me the willies.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(19862,'Greetings, mortal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19863,'I am listening, dragon.','I am listening, dragon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19864,'In the eastern reaches of the Netherwing Fields lies Dragonmaw Fortress. It is there that the cruel Dragonmaw orc clan tortures the drakes that they capture in an attempt to bend them to their will. Many have given up hope, choosing instead to do the bidding of Dragonmaw. The others... They refuse to land for fear of Dragonmaw war parties capturing them and taking them back to the fortress.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19865,'But you are dragons! How could orcs do this to you?','But you are dragons! How could orcs do this to you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19866,'I... We are powerless. Illidan found and delivered unto the Dragonmaw their leader - Zuluhed. This orc was the one responsible for the capture and incarceration of Alexstrasza. How could we fight against such power? He captured an Aspect!$B$BAnd just as easily, he took my mate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19867,'Your mate?','Your mate?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19868,'<Neltharaku nods.>$B$BKarynaku... She is held prisoner atop Dragonmaw Fortress. I have made many attempts to free her. All have failed... You have battled these beasts before, have you not?\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19869,'I have battled many beasts, dragon. I will help you.','I have battled many beasts, dragon. I will help you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19870,'Please, $n.  You must take the Heart of Fury somewhere safe... you must take it to A\'dal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19871,'','You\'re willing to give up an Ata\'mal crystal... just to see your plan against Illidan through?  You intrigue me, Broken.  Perhaps I\'ll play along... for now, at least.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19872,'','Hellfire Peninsula - Mordiba default',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19873,'Intruder detected!  Neutralizing threat immediately!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19874,'Perimeter breached!  Destroy $R!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19875,'Unauthorized personnel identified!  Punishment protocol activated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19876,'Power levels seem adequate.  No sign of the anomlies like we saw at Manaforge Ultris.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19877,'%s goes into a nether-fed rage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19878,'Everything is going according to schedule.  Prince Kael\'thas should be pleased.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19879,'Why must I be surrounded by incompetence?  Oh well, perhaps some of my underling may eventually grow a brain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19880,'%s cries out in withdrawal, opening gates to the nether.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19881,'We should be uniting the Ogre clans, not fighting each other.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19882,'Will we never learn to work together?  Or will we simply kill each other off and be forgotten in time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19883,'If only the leaders of the clans would listen.  Unity is the only answer.  All other paths lead to our destruction.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19884,'My message of unity is meant for the Ogre clans, not for you, $R!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19885,'I will not allow you to kill anymore of my kind!  Prepare to die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19886,'I decree that you are an enemy of the Ogre clans.  Punishment is death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19887,'Excellent!  Fresh parts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19888,'It is very kind of you to donate your organs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19889,'Be proud, your brain will be put to good use in one of my abominations.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19890,'The information you seek... I cannot give you that freely.  You will have to prove that your enemies are the same as mine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19891,'Enough! I have had enough of you filthy warm bloods!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19892,'Stupid puny thing.  Me smash!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19893,'Me mad. You get smash in face!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19894,'Me angered. Raaah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19895,'Doom Lord Kazzak will soon unleash our full might on these pitiful Orcs and Humans!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19896,'Be ready my brothers!  We shall make our way thru the Dark Portal and all of Azeroth shall fall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19898,'We are but extensions of Doom Lord Kazzak\'s will!  Be strong!  Be vigilant!  Let nothing stand in the way of the Burning Legion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19899,'Obey his commands and be honored among the Burning Legion.  Falter and you will be consumed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19900,'I love to bathe in the blood of my enemies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19901,'','The fight against Kael\'thas and Illidan continues on all fronts.  Defeat is not an option.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19902,'Once I\'ve hacked off your limbs, I may hang your body from our battlements.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19903,'I crave your death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19904,'Hail, $n.  All friends of the Light are welcome at the Altar of Sha\'tar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19905,'The Wyrmcult must be using another path. We are still finding them in Ruuan Weald.','The Wyrmcult must be using another path. We are still finding them in Ruuan Weald.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19906,'I shall send your soul into the infinite void!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19907,'Let my darkness engulf you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19908,'In the void, no one can hear you scream!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19909,'Orcs of the Horde! This portal is the gateway to your new destiny! Azeroth lies before you, ripe for the taking!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19910,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19911,'Gul\'dan speaks the truth! We should return at once to tell our brothers of the news! Retreat back through the portal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19912,'We are to wait here. They sent others ahead to check the tunnel interior.','We are to wait here. They sent others ahead to check the tunnel interior.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19913,'How dare you take my eye!  I will crush your soul and feed it to my blind and whimpering imps!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19914,'Come to my lair, whelp!  Come to me and pay for your insolence!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19915,'','Light be with you, Harbinger.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19916,'','Why hasn\'t Illidan made his move?  All this waiting is making our forces uneasy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19917,'What manner of thing would ever serve those sinister Wyrmcult wretches?','What manner of thing would ever serve those sinister Wyrmcult wretches?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19918,'The Betrayer hasn\'t been the most predictable of foes, Exarch.  I have no fear however, with the Light on our side we shall defeat his forces today, tomorrow, or whenever he chooses to attack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19919,'Never forget whom you serve.  Illidan will rule this land and beyond.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19920,'How has the Wyrmcult gained so many followers? Where are they coming from?!','How has the Wyrmcult gained so many followers? Where are they coming from?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19921,'The master desires your full obedience and you will comply!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19922,'Soon all our enemies will beg for mercy or be shatterd bones under our feet!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19923,'I realize you have only recently joined us, and thus may be unaware of our traditions. In Moonglade, a tremendous celebration is taking place. This is a time of year when we honor our elders, and you are certainly invited! Travel to one of our cities if you wish to join in!','I realize you have only recently joined us, and thus may be unaware of our traditions. In Moonglade, a tremendous celebration is taking place. This is a time of year when we honor our elders, and you are certainly invited! Travel to one of our cities if you wish to join in!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19924,'%s emits a low, quiet growl, looking back over its shoulder.','%s emits a low, quiet growl, looking back over its shoulder.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19925,'What do you see? Anything?','What do you see? Anything?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19926,'Are there Wyrmcult ahead?','Are there Wyrmcult ahead?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19927,'Have you found them?','Have you found them?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19928,'Are there very many of them, up there?','Are there very many of them, up there?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19929,'Die, Scryer scum!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19930,'Destroy these Aldor dogs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19931,'The Lunar Festival is in full swing on Azeroth! Return there and honor your elders in this wonderful celebration! The main festivities can be found in Moonglade, but we\'ve provided easy transportation from Stormwind, Ironforge, Darnassus, Thunder Bluff, Orgrimmar, and the Undercity. We hope to see you there!','The Lunar Festival is in full swing on Azeroth! Return there and honor your elders in this wonderful celebration! The main festivities can be found in Moonglade, but we\'ve provided easy transportation from Stormwind, Ironforge, Darnassus, Thunder Bluff, Orgrimmar, and the Undercity. We hope to see you there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19932,'What? Where am I? This isn\'t right at all! Look at you! Look at this place! It isn\'t on my list! There\'s going to be so much paperwork...$b$b<The goblin writes frantically in a small notebook.>$b$bLook, if you\'ve got nothing better to do than stand there and stare, why don\'t you go visit my cousin, Kwee Q. Peddlefeet, in one of the major cities? Says here he\'s taking care of Orgrimmar, Stormwind, Thunder Bluff, Ironforge, the Undercity, and Darnassus. Go on, get outta here!','What? Where am I? This isn\'t right at all! Look at you! Look at this place! It isn\'t on my list! There\'s going to be so much paperwork...$b$b<The goblin writes frantically in a small notebook.>$b$bLook, if you\'ve got nothing better to do than stand there and stare, why don\'t you go visit my cousin, Kwee Q. Peddlefeet, in one of the major cities? Says here he\'s taking care of Orgrimmar, Stormwind, Thunder Bluff, Ironforge, the Undercity, and Darnassus. Go on, get outta here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19933,'There are mysteries in this place that we, the orcs, are desperate to uncover.  Mysteries of our past, mysteries of our future, and mysteries that offer glimpses inside us.$B$BIt is my hope to pierce these mysteries... will you walk that path with me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19934,'Oh no!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(19935,'I can watch no longer.  We MUST undo this evil that the arakkoa are perpetrating upon the protectors of the Raven\'s Wood!','',1,15,0,0,500,0,0,0,1,0,0,0,26124),
(19936,'','Step forward.  I will see that you are properly welcomed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19937,'','Oh, stop your whimpering!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19938,'','Mission accomplished!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19939,'','You are no longer dealing with some underling!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19940,'','Band\'or shorel\'aran!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19941,'','Guards, rally!  Cut these invaders down!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19942,'','I have not yet... begun to...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19943,'The %s appears very grateful to be free of the koi-koi spirit\'s influence.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19944,'What are you doing?  These specimens are very delicate!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19945,'Your life cycle is now concluded.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19946,'You will feed the worms.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19947,'Endorel anuminor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19948,'Nature bends to my will....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19949,'The specimens... must be preserved.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19950,'There\'s trouble in the woods.  We must uncover its source before it is too late!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19951,'You are always welcome with us here in the Raven\'s Wood, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19952,'You should split while you can.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19953,'Can\'t say I didn\'t warn you....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19954,'Damn, I\'m good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19955,'Think you can hurt me, huh?  Think I\'m afraid a\' you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19956,'Go ahead, gimme your best shot.  I can take it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19957,'Bully!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19958,'The %s creaks in pain as it is possessed by the koi-koi.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19959,'','Don\'t value your life very much, do you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19960,'','Welcome to cokeplay.com, drink CocaCola and raise a cute polar bear!',1,0,0,1,0,0,0,0,1,0,0,0,26124),
(19961,'','And don\'t come back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19962,'','Endala finel endal!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19963,'','Think you can take the heat?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19964,'','Anar\'endal dracon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19965,'','I am not alone.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19966,'','Anu... bala belore...alon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19967,'At last, a target for my frustrations!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19968,'Have you come to kill Dalliah?  Can I watch?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19969,'Yes, that was quite satisfying.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19970,'Ahh... much better.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19971,'On guard!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19972,'Defend yourself, for all the good it will do....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19973,'Knew this was... the only way out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19974,'Having problems, Dalliah?  How nice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19975,'This may be the end for you, Dalliah.  What a shame that would be.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19976,'I suggest a new strategy: you draw their attacks while I gather reinforcements.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19977,'Finally!  Well done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19978,'','It is unwise to anger me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19979,'','Don\'t worry about me; kill that worthless dullard instead!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19980,'','Completely ineffective.  Just like someone else I know.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19981,'','You chose the wrong opponent.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19982,'','Reap the whirlwind!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19983,'','I\'ll cut you to pieces!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19984,'','That is much better.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19985,'','Ahh... just what I needed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19986,'','Now I\'m really angry.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19987,'','More than you can handle, scryer?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19988,'','I suppose I\'ll end up fighting them all myself.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19989,'','I\'ve grown used to cleaning up your messes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19990,'','Congratulations.  I\'ve wanted to do that for years.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19991,'Soon I will plant roots and sleep.   Before I rest there are things that must yet be done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19992,'You brought the green to my land for a short time.  It is enough.  I am at peace.  I am ready for my long sleep.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19993,'I have no equal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19994,'Perish, mortal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19995,'Yes... yes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19996,'Kill, kill!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19997,'That\'s right, yes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19998,'Who\'s the master now?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(19999,'You cannot kill me, fools! I\'ll be back, I\'ll....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20000,'Guards, attention! We have visitors....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20001,'Land-dwelling scum!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20002,'Alana be\'lendor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20003,'I am rid of you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20004,'Her... excellency... awaits.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20005,'%s begins to radiate massive amounts of energy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20006,'Consider this a warm up!  Your real training will be far harsher!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20007,'Success!  I have attuned myself to Hellfire Citadel and the magic within.  Ah, such power!$B$BThere are countless fel orcs in that place... but that is not all!  I sense demonic power within those walls as well...$B$BIf you open yourself, then I shall grasp your mind -- briefly, mind you -- and take quill to parchment and record my findings for you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20008,'Yes, Scryer.  You may possess me.','Yes, Scryer.  You may possess me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20009,'I think I hear him coming now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20010,'Thank you, my friend.  This drake from Dragons\' End is just what we need to lure Goc out from hiding!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20011,'Must you leave so soon?  Very well, may your journey bring you honor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20012,'What aggravation is this? You will die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20013,'You seek a prize, eh? How about death?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20014,'I hate to say I told you so...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20015,'Your life will be mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20016,'I revel in your pain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20017,'I\'ll incinerate you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20018,'Scream while you burn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20019,'You won\'t... get far.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20020,'Die, interloper!  Your puny device cannot pierce the dark magics of Hellfire Citadel!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20021,'%s takes a deep breath.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20022,'Maybe this is not-- No, we fight! Come to my aid!','Maybe this is not-- No, we fight! Come to my aid!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20023,'Miserable vermin. I shall exterminate you from the air!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20024,'Who disturbs this sanctuary?','Who disturbs this sanctuary?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20025,'You must die! But wait: this does not-- No, no... you must die!','You must die! But wait: this does not-- No, no... you must die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20026,'What am I doing? Why do I...','What am I doing? Why do I...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20027,'An intruder!  Begone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20028,'So... confused. Do not... belong here.','So... confused. Do not... belong here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20029,'Low-tech, yet quite effective.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20030,'My calculations did not...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20031,'A foregone conclusion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20032,'The processing will continue as scheduled!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20033,'You have approximately five seconds to live.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20034,'I predict a painful death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20035,'Your strategy was flawed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20036,'Yes, the only logical outcome.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20037,'Measure twice; cut once.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20038,'If my division is correct... you should be quite dead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20039,'An unforeseen... contingency.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20040,'You work for me now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20041,'We are on a strict timetable. You will not interfere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20042,'A minor inconvenience.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20043,'Looks like you lose.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20044,'The project will... continue.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20045,'Life energy to... consume.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20046,'This vessel is empty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20047,'No... more... life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20048,'The shadow... will engulf you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20049,'Darkness... consumes all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20050,'The Void... beckons.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20051,'Did you call on me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20052,'To do your heavy lifting, most likely.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20053,'Then I\'ll commit myself to ignoring you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20054,'You\'re the one who should be-- Wait, we have company...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20055,'','Why would I call on you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20056,'','When I need someone to prance around like an overstuffed peacock, I\'ll call on you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20057,'','What would you know about commitment, sheet-sah?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20058,'I will come back for you all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20060,'Free at last!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20061,'The Legion will prevail!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20062,'','Daddy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20063,'Dad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20064,'Yay, fireworks!','Yay, fireworks!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20065,'Our enemies surround us.  I would have a better life for the Mok\'Nathal, but the forces we are at battle with have chosen otherwise for us.$B$BIf you would prove yourself worthy to the Mok\'Nathal, aid us in their elimination.','',396,396,0,0,500,0,0,0,1,0,0,0,26124),
(20066,'Gronn are the real power in Outland!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20067,'You will not defeat the hand of Gruul!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20068,'You won\'t kill next one so easy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20069,'Pah! Does not prove anything!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20070,'I\'m not afraid of you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20071,'Good, now you fight me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20072,'You not so tough after all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20073,'%s laughs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20074,'Maulgar is king!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20075,'Gruul... will crush you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20076,'I remember well the sting of defeat at the conclusion of the Third War. I have waited far too long for my revenge. Now the shadow of the Legion falls over this world. It is only a matter of time until all of your failed creation... is undone. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20077,'The Legion will conquer all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20078,'All mortals will perish!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20079,'All life must be eradicated! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20080,'I\'ll rip the flesh from your bones!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20081,'Kirel narak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20082,'Contemptible wretch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20083,'The universe will be remade.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20084,'The Legion... will never... fall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20085,'','Water... is life. It has become a rare commodity here in Outland; a commodity that we alone shall control. We are the Highborne, and the time has come at last for us to retake our rightful place in the world!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20086,'','Straight to the heart!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20087,'','Seek your mark!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20088,'','I\'ll split you from stem to stern!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20089,'','Victory to Lord Illidan! ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20090,'','Death to the outsiders!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20091,'','I spit on you, surface filth!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20092,'','The time is now! Leave none standing! ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20093,'','Your time ends now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20094,'','You have failed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20095,'','Be\'lemer an-delei!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20096,'','Lord Illidan, I... I am... sorry.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20097,'This fel reaver appears to not be quite operation just yet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20098,'<Administer the condensed nether gas.>','<Administer the condensed nether gas.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20099,'Puzzled by what you see, stranger?$B$BWe give praise to the spirits of our ancestors by keeping the flame of their memory alive and paying it tribute.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20100,'%s lets loose a low, guttural growl.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20101,'%s grows massively powerful!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20102,'%s orders a nearby ogre to assist him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20103,'%s begins to sputter as its engine malfunctions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20104,'%s will detonate in 5 seconds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20105,'4...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20106,'Deathforge Mine will detonate in 3 seconds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20107,'2...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20108,'Deathforge Mine: Detonating!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20109,'Yay!  We\'re free!','Yay!  We\'re free!',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(20110,'Woot!','Woot!',4,0,0,2,0,0,0,0,1,0,0,0,26124),
(20111,'Yay!  We love you!  You saved us!','Yay!  We love you!  You saved us!',4,0,0,2,0,0,0,0,1,0,0,0,26124),
(20112,'Spiritcaller, I need more totems to save the spirits of the nether drakes.','Spiritcaller, I need more totems to save the spirits of the nether drakes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20113,'Well, alright, but you know these things don\'t grow on trees.$B$B<The spiritcaller thinks about that a moment.>$B$BOh, wait a minute....','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20114,'I think those weird bird guys were going to eat us.  Gross!','I think those weird bird guys were going to eat us.  Gross!',4,0,0,2,0,0,0,0,1,0,0,0,26124),
(20115,'Gross!','Gross!',4,0,0,2,0,0,0,0,1,0,0,0,26124),
(20116,'Come.... and die.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20117,'Scurry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20118,'No escape.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20119,'Stay.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20120,'Beg for life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20121,'No more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20122,'Unworthy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20123,'Die.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20124,'Me am so thirsty!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20125,'No taste good. Bad.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20126,'Lord Illidan, bless me with the power of the flight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20127,'Foolish mortals. Did you think that I would not strike you down for your transgressions?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20128,'Indeed, the time has come to end this charade.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20129,'Destroy them! Destroy them all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20130,'I can instruct you in alchemy.  Interested?','I can instruct you in alchemy.  Interested?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20131,'I can instruct you in engineering.  Interested?','I can instruct you in engineering.  Interested?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20132,'I can instruct you in enchanting.  Interested?','I can instruct you in enchanting.  Interested?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20133,'I can instruct you in tailoring.  Interested?','I can instruct you in tailoring.  Interested?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20134,'I can instruct you in leatherworking.  Interested?','I can instruct you in leatherworking.  Interested?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20135,'I can instruct you in blacksmithing.  Interested?','I can instruct you in blacksmithing.  Interested?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20136,'The %s flies up through the trees, free of Terokk\'s corruption.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20137,'ATTACK WITH THE FULL FORCE OF NETHERWING, MY CHILDREN! ATTACK!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20138,'Breaking','Breaking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20139,'It is good to see you again, friend.','',396,2,0,0,0,0,0,0,1,0,0,0,26124),
(20140,'%s casts a spell to draw magical attacks away from his allies.','',0,0,0,0,0,0,0,0,1,7201,0,0,26124),
(20141,'You are spotted by the %s!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20142,'Mother!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20143,'Praise the naaru, I\'m saved.  I will try to make it clear on my own.','Praise the naaru, I\'m saved.  I will try to make it clear on my own.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20144,'I\'m hurt, but I can still run.  Thank you, stranger.','I\'m hurt, but I can still run.  Thank you, stranger.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20145,'My thanks, stranger.','My thanks, stranger.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20146,'I\'m too weak to fight with you.  Please find my friends.','I\'m too weak to fight with you.  Please find my friends.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20147,'Extinguishing','Extinguishing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20148,'It feels good to walk about and stretch all four limbs. Is there something I can help you with, $c?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20149,'The Felsworn Gas Mask was destroyed, do you have another one?','The Felsworn Gas Mask was destroyed, do you have another one?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20150,'Greetings, $c.  If I might be so bold, may I remind you that -- while I attune myself to the magics of Hellfire Citadel -- there will undoubtedly be Hellfire wardens biting at my proverbial heels!$B$BSo, do be an upstanding member of your Horde and play the part of the hero... and protect me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20151,'','Mordenaku... Your allies have saved us and destroyed the wretch, Zuluhed. Forever they will be a friend to the Netherwing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20152,'','In time, we will again require the assistance of the mortals. Across this world our birthright is shattered. It will be the mortal races that help us regain our rightful place on Draenor. Watch over them, Mordenaku...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20153,'','Farewell, mortal. We are forever indebted to you.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20154,'Thank you for allowing me to visit, $n.  You have a very colorful soul, but it\'s a little brighter than I prefer... or I might have stayed longer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20155,'You have saved us from a fate far worse than death, $n.  You have the eternal gratitude of the Mok\'Nathal ancestors.','You have saved us from a fate far worse than death, $n.  You have the eternal gratitude of the Mok\'Nathal ancestors.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20156,'Who dares slay one of my Kargath\'s commanders?  You will pay for this... in flesh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20157,'%s points to the sky above.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20158,'You\'re free, Millhouse. Get out of here!','You\'re free, Millhouse. Get out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20159,'You are not powerful enough to undergo the trial of the naaru. Return to me when you are stronger.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20160,'Speak, filthy refugee!  What was your caravan doing in the Bone Wastes?','Speak, filthy refugee!  What was your caravan doing in the Bone Wastes?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20161,'Let us leave this place.  I\'ve had enough of these madmen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20162,'Beware!  More cultists come!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20163,'I can find my way from here.  My friend Mekeda will reward you for your kind actions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20164,'You\'ll go nowhere, fool!','You\'ll go nowhere, fool!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20165,'You will not escape us so easily!','You will not escape us so easily!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20166,'','Incompetent fools!  Auchindoun should\'ve been ours... look at yourselves scrambling like rats!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20167,'The search for my people.  Our struggle against the Alliance.  The war with the ogres and their gronn masters.$B$BAll of these things weigh heavy upon my shoulders, $c.$B$BEven I can use some help from time to time.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20168,'The wyvern drops a black drake corpse on the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20169,'Auchindoun is home to my ancestor\'s spirits.  We might not look it, but all Broken were once draenei... our spirits are all the same.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20170,'Tell her to use the druids for that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20171,'If they will not bend the knee, then she is to see to it that they are destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20172,'I did not sanction their actions.  Tell her to deal with it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20173,'Very well, but make certain she knows that the blackwhelps are to be captured first.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20174,'Must I tell her every little thing to do?  I have larger issues of my own to deal with here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20175,'Hello, little one.  What news do you bring?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20176,'Tell her that I don\'t want to be connected with it at this time.  The Cenarion Expedition should be more than happy to rid themselves of them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20177,'No.  Inform her that I\'m still searching for the prophesied one that is to assist me in the battle.  There are very few promising candidates.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20178,'%s inspects the talisman $n gave him...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20179,'Ah, this was from Private Denning.  I remember when he fell...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20180,'This one was from Corporal Stonewell... he died protecting a field hospital...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20181,'Ah, yes... Private Guarding.  He always was quick to laugh... until a Bleeding Hollow Raid tore out his throat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20182,'This insignia is from Sergeant Rantack, once my superior.  You\'d never find a tougher soldier than old Rantack...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20183,'%s faces the Bleeding Hollow fort of Zeth\'Gor...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20184,'Damn you!  Damn all of you bleeding fel orcs!  May your souls rot in the belly of whatever Dark Power that fuels you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20185,'The Deathforge is run by the Shadow Council, under the watchful eye of the Legion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20186,'','Hi there, cutey!  Do me a favor... ask the Baron what he wants me to do about you know what.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20187,'Below is the aptly named Deathforge. If left to their own devices, the Shadow Council would supply the Legion with an endless stream of infernals.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20188,'','Tell him that they have refused his \'offer\'.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20189,'','Deal with them?  How am I supposed to deal with them?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20190,'','Right.  We, uh, need to... examine... those blackwhelps.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20191,'','Ask him how he wants to proceed, then come right back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20192,'','What does the baron want?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20193,'','Tell him that our Cenarion friends have been most helpful.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20194,'','Has he found the one, yet?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20195,'Energy. Power. My people are addicted to it... a dependence made manifest after the Sunwell was destroyed. Welcome to the future. A pity you are too late to stop it. No one can stop me now! Selama ashal\'anore!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20198,'Let us see how you fare when your world is turned upside down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20199,'Having trouble staying grounded?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20200,'By the power of the sun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20201,'Anar\'anel belore!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20202,'Obey me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20203,'Bow to my will!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20204,'You will not prevail!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20205,'You gambled. And lost.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20206,'This was child\'s play.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20207,'For... Quel\'...Thalas!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20208,'I have not come this far to be stopped! The future I have planned will not be jeopardized! Now you will taste true power!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20209,'We know that the wyrmcultists are massing on the other side of the tunnel.  We\'ll make our stand here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20210,'','You may want to take cover. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20211,'%s\'s eyes glaze over as the effects of the wand take over his mind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20212,'The magic of the wand appears to take hold on %s, but then it fades.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20213,'Not work so good for not birdies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20214,'','What a bunch of rabble!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20215,'It\'s a good thing I was able to make duplicates of the Felsworn Gas Mask.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20216,'','Don\'t let them through!  Look, over there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20217,'','Maxnar is going to have my hide if we don\'t get this assault underway soon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20218,'','Has anyone seen the overseer?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20219,'','You there!  What do you think you\'re doing?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20220,'','Well, are we going to attack, or are we just going to mill about all day?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20221,'','Someone tell those fools to stay back.  They\'re getting slaughtered when they go over there alone!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20222,'','There\'s a druid stealthing around in his cat-form.  I thought that we had hunters in here.  Deal with it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20223,'','Welcome, $n. My expertise is in the art of working with primal mooncloth. Tailors interested in becoming mooncloth specialists often ask me to teach them our ways.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20224,'','I\'m afraid there is little I can teach you, $c. You\'re free to browse my wares, of course, but you will not find them of use to you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20225,'Show me what you have for sale.','Show me what you have for sale.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20226,'','Pleased to meet you! I\'m Gidge, the resident spellfire tailoring expert here in Shattrath. Not that there\'s any competition, but if you\'re interested in learning to be a spellfire tailor and haven\'t settled on a specialization, I can help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20227,'','If you\'re not a tailor, I don\'t think any of my patterns will interest you, but you\'re welcome to browse!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20228,'If you\'re seeking patterns or knowledge about shadoweave tailoring, I\'d be happy to help you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20229,'I\'m sorry, $c, but my wares are best suited to those who know which end of the needle the thread goes through.$B$BI can assure you, tailoring is about far more than monogramming handkerchiefs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20230,'A\'dal, I have lost the key to Tempest Keep and require a replacement.','A\'dal, I have lost the key to Tempest Keep and require a replacement.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20231,'I cannot allow you to interfere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20232,'Show me what you have for sale.','Show me what you have for sale.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20233,'I will purge you from this place!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20234,'You are no better than they!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20235,'They have forced me to this....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20236,'I had no choice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20237,'I wish to become a shadoweave tailoring expert. Can you teach me?','I wish to become a shadoweave tailoring expert. Can you teach me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20238,'I am... released.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20239,'You... are the disease... not I...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20240,'I wish to be a mooncloth tailoring specialist. Can you teach me?','I wish to be a mooncloth tailoring specialist. Can you teach me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20241,'I wish to become a spellfire tailoring specialist. Can you teach me?','I wish to become a spellfire tailoring specialist. Can you teach me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20242,'I would be grateful for any aid you can provide, Priestess.','I would be grateful for any aid you can provide, Priestess.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20243,'','These Tears of the Goddess have been blessed by Elune, and their power will help you combat Archimonde\'s vile magics. Use their power well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20244,'They fear my words. They make an example out of me. A mockery of the one true god, Neptulon.$B$B<Skar\'this spits.>$B$BRetribution comesss, mortal. The glorious hand of the Tidehunter will one day sweep through the non-believers like a scythe against a new harvest.','',1,1,5,0,0,0,0,0,1,0,0,0,26124),
(20245,'These wastes are scarred by terrible magic.  We must do what we can to heal this great wound.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(20246,'*WARNING!* You can only select one tailoring specialization.','*WARNING!* You can only select one tailoring specialization.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20247,'*WARNING!* You can only select one tailoring specialization.\n','*WARNING!* You can only select one tailoring specialization.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20248,'*WARNING!* You can only select one tailoring specialization.','*WARNING!* You can only select one tailoring specialization.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20249,'These refugees have suffered greatly and they will no doubt suffer more.  You have already helped them and for that I thank you.  If you have done all you can for now then I would beg a small favor.  ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20251,'Death\'s Door is a portal that opens upon the world that the Burning Legion uses to breed their fel hounds and other canine-like terrors.  Any time that you see one of those creatures, that is where it came from, and it passes through here, first.$B$BLately, we became aware that the Burning Legion have ramped up their summoning of these creatures through the portal.$B$BYou must shut down Death\'s Door before it becomes an inexorable tide, and all is lost!','Death\'s Door is a portal that opens upon the world that the Burning Legion uses to breed their fel hounds and other canine-like terrors.  Any time that you see one of those creatures, that is where it came from, and it passes through here, first.$B$BLately, we became aware that the Burning Legion have ramped up their summoning of these creatures through the portal.$B$BYou must shut down Death\'s Door before it becomes an inexorable tide, and all is lost!',396,1,0,0,500,0,0,0,1,0,0,0,26124),
(20252,'I came to this land to cleanse troubled spirits, but after the attack I fear that my mission has failed.  So many have been taken by the wastes.  Please, you must help them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20253,'','Long ago the Shadow Council tried to perform a dark ritual inside Auchindoun.  Their failure created the waste you see around you.  The bones and the spirits of the fallen Draenei now haunt this land.  I was sent to cleanse the tombs of my ancestors, but with so many dangers I must remain here to protect the refugees.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20254,'%s squawks and heads toward Veil Shalas. Hurry and follow!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20255,'%s pauses briefly before the tree and then heads inside.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20256,'%s seems to be looking for something. He wants you to follow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20257,'%s flies to the platform below! You\'d better jump if you want to keep up. Hurry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20258,'Me like soft bacon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20259,'Me keep piggy as pet!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20260,'May the Light guide you, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20261,'Misha lets out a loud roar as she rakes her claws against the gronn\'s altar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20262,'Who dares defile the altar of Gorgrom the Dragon-Eater?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20263,'It is with solemn pride that I perform my services in Honor Hold.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20264,'I will crush it and flay it and eat its meat and crack its bones one by one when I am done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20265,'How may I assist you, $n?','How may I assist you, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20266,'More Minions of Terokk are coming!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20267,'The invaders persist! Hold them off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20268,'An Avatar of Terokk!! To arms!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20269,'We have taken too long. Terokk reigns victorious.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20270,'The Avatar of Terokk has been defeated! Death to Terokk! Death to Skettis!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20271,'Yes! Feel the might of the booterang!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20272,'Farewell, $n.','Farewell, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20273,'I must leave.  Proceed with caution.','I must leave.  Proceed with caution.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20274,'Until we meet again.','Until we meet again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20275,'I must go now.  Good luck.','I must go now.  Good luck.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20276,'The wind calls to me.','The wind calls to me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20277,'There is something that I must attend to.','There is something that I must attend to.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20278,'Luckily, I was nearby.  How can I help?','Luckily, I was nearby.  How can I help?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20279,'You called?','You called?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20280,'Let us see if together we can figure out what next to do.','Let us see if together we can figure out what next to do.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20281,'Hello.','Hello.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20282,'I\'ve been circling nearby in case you needed to speak.','I\'ve been circling nearby in case you needed to speak.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20283,'Skywing, I will free you from your curse over my dead body!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20284,'%s bellows a loud squawk!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20285,'My eyebrows! You singed my eyebrows!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20286,'Don\'t worry. It\'s an improvement!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20287,'I\'ve trained as an alchemist once again.  I wish to specialize in potions.','I\'ve trained as an alchemist once again.  I wish to specialize in potions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20288,'','When I first set up my rogue academy in Shattrath, it wasn\'t nearly this crowded. Then, the refugees started flooding in and the naaru needed every available building to house them.$B$BI\'ve closed the doors to my academy for now, but it\'s not permanent. I\'ll find a new place to set up.$B$BThen, a new generation of rogues will learn such staples as the gouge\'n grin, combat looting, and blaming someone else for breaking polymorph. And who can forget the central rule of roguery --- real rogues don\'t feint.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20289,'I\'ve trained as an alchemist once again.  I wish to specialize in elixirs.','I\'ve trained as an alchemist once again.  I wish to specialize in elixirs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20290,'I am Zarevhi of the Consortium.  My skills as a transmuter are known in a thousand worlds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20291,'','The trick to using evasion is realizing that the best fifteen seconds of your life are often the last.',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(20292,'I\'ve trained as an alchemist once again.  I wish to specialize in transmutations.','I\'ve trained as an alchemist once again.  I wish to specialize in transmutations.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20293,'','Swords, claws, daggers, of course -- I\'ve trained rogues in the use of them all. Now maces, I won\'t touch maces and I won\'t instruct any rogue who gets it in his head to wield one.$B$BThere\'s nothing stealthy about a mace. You\'re in for a noisy kill and a long cleanup if you go that route.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20294,'','My early classes are always filled with bright-eyed young lads. Few make it past the first test, though.$B$BI\'ve given up on shouting, \'when I yell vanish, you need to vanish.\' They never listen. Now, the test simply kills the inept.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20295,'Free at last from that horrible curse! Thank you! Please send word to Rilak the Redeemed that I am okay. My mission lies in Skettis. Terokk must be defeated!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20296,'','Never leave home without ample supplies of flash powder, especially when working with others. I guarantee someone will run out every time.$B$BWhen the choice comes down to handing out materials or letting the poor sap die, I help... most of the time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20297,'%s wanders off into the distance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20298,'You have brought me back too soon! I am weak yet... What is this! Who... It matters not! DIE!','You have brought me back too soon! I am weak yet... What is this! Who... It matters not! DIE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20299,'Wildlord, I seem to have lost my druid signal.','Wildlord, I seem to have lost my druid signal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20300,'Very well, here is your replacement.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20301,'Vengeance will not be yours, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20302,'I heard that your dog Fei Fei took Klatu\'s prayer beads...','I heard that your dog Fei Fei took Klatu\'s prayer beads...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20303,'','Oh, no!  My Fei Fei would never take someone else\'s things!  He\'s a good dog... he just needs attention sometimes.  If you give him a treat, then you see!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20304,'%s begins to moan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20306,'<back>','<back>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20307,'%s uses the key to open the cage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20308,'AAAAEEEEEEIIIIIIII!!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20309,'AHHHH-YAAA-YAAA-YAAA!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20310,'AWOOOOGAAAA!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20311,'AYYAYAAYAA!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20312,'%s digs in the dirt...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20313,'%s buries his treat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20314,'Aright, listen up! Form a circle around me and move out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20315,'%s sniffs around, unsatisfied with this hiding spot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20316,'%s looks for a hiding spot...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20317,'Who dares rouse Goc from his restful slumber?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20318,'I am Rexxar, son of the Mok\'Nathal, champion of the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20319,'And their torment at your hands is at an end. By my name, I shall put an end to your life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20320,'Prepare yourself for the end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20321,'Your name is as insignificant to me as the names of the thousands who have died under the might of Goc.  I will crush you and $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20323,'It\'s only right that you know the name of the one who will take your life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20324,'Baron Sablemane. It will be on your lips as you gasp your dying breath.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20325,'Let us begin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20326,'I could not have achieved this victory without you. We will speak back at Thunderlord Stronghold.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20327,'We will speak again, but away from here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20328,'Aright, $r, just keep us safe from harm while we work. We\'ll pay you when we return.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20329,'The dig site is just north of here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20330,'We\'re here! Start diggin\'!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20331,'I think there\'s somethin\' buried here, beneath the sand!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20332,'Almost got it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20333,'By Brann\'s brittle bananas! What is it!? It... It looks like a drum.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20334,'Wow... a drum.','Wow... a drum.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20335,'This discovery will surely rock the foundation of modern archaeology.','This discovery will surely rock the foundation of modern archaeology.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20336,'Yea, great. Can we leave now? This desert is giving me hives.','Yea, great. Can we leave now? This desert is giving me hives.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20337,'Have ye gone mad? You expect me to leave behind a drum without first beatin\' on it? Not this son of Ironforge! No sir!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20338,'Here goes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20339,'This reminds me of that one time where you made us search Silithus for evidence of sand gnomes.','This reminds me of that one time where you made us search Silithus for evidence of sand gnomes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20340,'Or that time when you told us that you\'d discovered the cure for the plague of the 20th century. What is that even? 20th century?','Or that time when you told us that you\'d discovered the cure for the plague of the 20th century. What is that even? 20th century?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20341,'I used to amuse myself by accepting challenges from anyone who would offer them, but I\'ve long since grown tired of such easy victories.$B$BFor now, I\'m taking some time to get my reagent business off the ground and write a book about my experiences in Twilight\'s Hammer.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20342,'I don\'t think it can top the one time where he told us that he\'d heard that Arthas\'s \"cousin\'s\" skeleton was frozen beneath a glacier in Winterspring. I\'ll never forgive you for that one, Letoll. I mean honestly... Arthas\'s cousin?','I don\'t think it can top the one time where he told us that he\'d heard that Arthas\'s \"cousin\'s\" skeleton was frozen beneath a glacier in Winterspring. I\'ll never forgive you for that one, Letoll. I mean honestly... Arthas\'s cousin?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20343,'I dunno. It can\'t possibly beat the time he tried to convince us that we\'re all actually a figment of some being\'s imagination and that they only use us for their own personal amusement. That went over well during dinner with the family.','I dunno. It can\'t possibly beat the time he tried to convince us that we\'re all actually a figment of some being\'s imagination and that they only use us for their own personal amusement. That went over well during dinner with the family.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20344,'Shut yer yaps! I\'m gonna bang on this drum and that\'s that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20345,'I won\'t challenge you, but I\'d like to see your wares.','I won\'t challenge you, but I\'d like to see your wares.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20346,'Say, do you guys hear that?','Say, do you guys hear that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20347,'Seems like we\'ve been working on this roof forever.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20348,'IN YOUR FACE! I told you there was somethin\' here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20349,'You would think we would be finished mending this roof by now.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20350,'It\'s like the more I hammer, the bigger this hole gets.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20351,'Pick up the pace, boys. We\'re not making any progress here.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20352,'I think we\'re running out of nails.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20353,'','I\'m only 4 years old.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20354,'All work and no play makes... I\'ll just shut up and keep hammering.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20355,'','Have you seen my mommy and daddy?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20356,'I hear there are great wars being fought in Outland. I wonder if there\'s any rooftops up there that need fixing...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20357,'','Antelarion, is it safe to play in the forest yet?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20358,'','I think I came from Eng-land, do you know where that is?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20359,'I wonder what made a hole in the roof of the Inn in the first place. See what happens when you drop a copper piece off of the edge of Outland?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20360,'','Antelarion says I fell off a big bird, as I fell he caught me... He is so pretty!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20361,'Don\'t just stand there! Help $g him:her; out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20362,'%s picks up the drum.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20363,'You\'ve been a tremendous help, $r! Let\'s get out of here before more of those things show up! I\'ll let Dwarfowitz know you did the job asked of ya\' admirably.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20364,'I have enough strength left to stand and fight.  Prepare yourself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20365,'WHAT?!  Who dares to disturb the Burning Legion?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20366,'Prepare yourself for eternal torture, mortal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20367,'Nothing will prevent your doom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20368,'I shall enjoy the smell of the grease from your marrow crackling over the fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20369,'You DARE to attack me?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20370,'You will suffer slowly until the end of time for this affront!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20371,'%s gathers the warp chaser\'s blood.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20372,'Enough of this!  Now I call upon the fury of the cosmos itself.','Enough of this!  Now I call upon the fury of the cosmos itself.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20373,'I become ONE... with the VOID!','I become ONE... with the VOID!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20374,'This one seems a little weak still.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20375,'This one should make a fine mount someday.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20376,'Bring this whelp more food!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(20377,'Grow big and strong my precious.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20378,'You will help restore the Dragonmaw Clan to their former glory.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20379,'Your father destroyed my children and left their bodies impaled upon the rocky blades at Dragons\' End.  For this, you will die!  Enough of this farce.  Prepare to face my full wrath!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20380,'%s begins emanating immense power.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20381,'Who dares place this affront upon the altar of Goc?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20382,'You hear the sound of beating wings from high up in the canyon as Rexxar approaches.','You hear the sound of beating wings from high up in the canyon as Rexxar approaches.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20383,'Alchemy Lab','Alchemy Lab',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20384,'Our resident alchemist Lorokeem brought his equipment with him, in fact. It may be slightly different from what you\'re used to - he is an arakkoa, after all - but it should serve your needs. He roosts in the northwest portion of the lower city.','Our resident alchemist Lorokeem brought his equipment with him, in fact. It may be slightly different from what you\'re used to - he is an arakkoa, after all - but it should serve your needs. He roosts in the northwest portion of the lower city.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20385,'Gem Merchant','Gem Merchant',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20386,'There are two gem merchants in residence: one works closely with the Scryers, and the other is loyal to the Aldor. Whom do you seek?','There are two gem merchants in residence: one works closely with the Scryers, and the other is loyal to the Aldor. Whom do you seek?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20388,'Aldor Gem Merchant','Aldor Gem Merchant',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20389,'Inessera is a sharp woman who carries various gems as well as jewelcrafting supplies. You can find her shop in the northern part of Aldor Rise.','Inessera is a sharp woman who carries various gems as well as jewelcrafting supplies. You can find her shop in the northern part of Aldor Rise.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20390,'Scryer Gem Merchant','Scryer Gem Merchant',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20391,'Lisrythe may be a bit... intimidating at first, but she stocks what you\'re looking for. She sells her wares in the eastern portion of Scryer\'s Tier.','Lisrythe may be a bit... intimidating at first, but she stocks what you\'re looking for. She sells her wares outside the large library on Scryer\'s Tier.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20392,'<The construct gestures to the eastern portion of the Tier.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20393,'I\'m not about to train you until you prove yourself a friend to the draenei of the Exodar.','I\'m not about to train you until you prove yourself a friend to the draenei of the Exodar.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20394,'I\'m not about to train you until you\'re exalted in the eyes of the draenei.','I\'m not about to train you until you\'re exalted in the eyes of the draenei.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20395,'Release the hounds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20396,'I am ready, Anchorite.  Let us begin the exorcism.','I am ready, Anchorite.  Let us begin the exorcism.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20397,'Oh, thank you!  The pit of blackness inside of me has been lifted!  I can see again... and I see the face of my savior!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20398,'Be gone, $c!  Leave us be, or we will enter you next and show you true despair!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20400,'It is time.  The rite of exorcism will now commence...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20401,'Prepare yourself.  Do not allow the ritual to be interrupted or we may lose our patient...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20402,'Keep away. The fool is mine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20403,'Be cleansed with Light, human!  Let not the demonic corruption overwhelm you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20404,'Back, foul beings of darkness!  You have no power here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20405,'The power of Light compels you!  Back to your pit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20406,'In the name of the Light! It is Light that commands you! It is Light that flung you to the depths of darkness! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20407,'I... must not...falter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20408,'The Light is my guide... it is my sustenance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20409,'You cannot deceive me, demon!  Your strength wanes just as my faith bolsters!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20410,'You... will... leave... this... man!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20411,'Give us time... Let the man die... I am no one... I am no one... Fear the anchorite... Fear the anchorite... Barada... Barada.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20412,'No!  Not yet!  This soul is ours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20413,'You will not succeed, mortal!  This shell will lie decrepit, blistered and bleeding before I am done with it.  And its spirit will be long cast into darkness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20414,'Ah!  Cease the incantations, Anchorite!  Cease, or I will show you such pain that your pathetic people have never imagined!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20415,'I see your ancestors, Anchorite!  They writhe and scream in the darkness... they are with us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20416,'This is fruitless, draenei!  You and your little helper cannot wrest control of this pathetic human.  He is mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20417,'I will tear your soul into morsels and slow roast them over demon fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20418,'All is lost, Anchorite!  Abandon what hope remains.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20419,'Back!  I cast you back... corrupter of faith!  Author of pain!  Do not return, or suffer the same fate as you did here today!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20420,'Debug Error: Couldn\'t find a target!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20421,'I cast you out! Unclean Spirit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20422,'Be gone... from this creature of Light! \n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20423,'Be gone! In the Name of the Light, the Goodness, and the All that is Just!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20424,'Don\'t worry.  Shatter Point is as sturdy as they come!  But just in case, be ready to jump on a gryphon if the base starts to break apart...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20425,'Now that you have bested me, test your skills against each other!  Take control of either king to begin play.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20426,'facing $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20427,'A\'dal, I am ashamed to say that I have somehow misplaced the key to the Arcatraz.','A\'dal, I am ashamed to say that I have somehow misplaced the key to the Arcatraz.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20428,'<The chime of A\'dal\'s voice echoes reassuringly through your mind.>$B$BWorry not, child.  Look in your pack and you will find it once more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20429,'You wish to speak to me, $r?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20430,'The halls of Karazhan shake, as the curse binding the doors of the Gamesman\'s Hall is lifted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20431,'I have seen many dangers in these wastes.  Who knows what creatures yet lurk in the dust to ambush the unwary?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20432,'All of your efforts have been in vain, for the draining of the World Tree has already begun!  Soon the heart of your world will beat no more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20433,'You do not have enough reputation with or have not pledged allegiance to The Aldor.','You do not have enough reputation with or have not pledged allegiance to The Aldor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20434,'You do not have enough reputation with or have not pledged allegiance to The Scryers.','You do not have enough reputation with or have not pledged allegiance to The Scryers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20435,'At last I am released! Thank you, gentle $r. I must return to the expedition at once! They will know of your deeds. This I vow.','At last I am released! Thank you, gentle $r. I must return to the expedition at once! They will know of your deeds. This I vow.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20436,'I will tell the tale of your heroics to Haramad myself! All Consortium will know your name, $n. Thank you, my friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20437,'','The Keepers of Time thank you for your assistance. The Timeless One shall be pleased with this outcome...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20438,'What is this? Where am I? How... How did I... Cursed ethereals! I was on an escort mission out of Shattrath when we were ambushed! I must return to the city at once! Your name will be recorded as a friend of the Lower City, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20439,'Blessed Light! Free of my confines at last... Thank you, hero. A\'dal will be told of your heroics.','Blessed Light! Free of my confines at last... Thank you, hero. A\'dal will be told of your heroics.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20440,'$R save me! Thank you! My people thank you too!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20441,'Look into my eyes... Find your death within...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20442,'FREE! FREE TO DEVOUR ALL THAT STAND IN THE WAY OF LORD ILLIDAN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20443,'The gateway of your oblivion has been opened! The blood tide rises.','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(20444,'A thousand and one ways that all spell out your demise!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20445,'WUT! DA KING IS BACK, BABY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20446,'In Outland, lunch open prison for you! What a world! Time to eat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20447,'Only flesh and blood...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20448,'For the Deceiver! For Kil\'jaeden!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20449,'','Death! Only death awaits!',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(20450,'','Give us a kissss...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20451,'','The conflicts in Outland are deadlier than any I have seen.  And their most tragic victims are the children that are left behind.$B$BNow, with the threat against Shattrath from the arakkoa of Skettis, there will be even more orphans to take care of.  These children often live without the hope of a bright future.$B$BBut you have the power to do something about that.  It\'s Children\'s Week, $c, and I implore you to volunteer to bring joy and wonder into a child\'s life.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(20452,'Children\'s Week is not yet over... may I have another Blood Elf Orphan Whistle?','Children\'s Week is not yet over... may I have another Blood Elf Orphan Whistle?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20453,'Children\'s Week is not yet over... may I have another Draenei Orphan Whistle?','Children\'s Week is not yet over... may I have another Draenei Orphan Whistle?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20454,'I\'m lonely.  I wish that there were more kids my age around here.  Sometimes I miss being at the orphanage in Shattrath City.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20455,'Thank you, $g sir : ma\'am;!  It was so great to get to speak with Salandria again!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20456,'','Are we there yet?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20457,'','Hch\'uu!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20458,'','Dornaa begins to examine the stone edifice, and then touches it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20459,'I am free!  But the secret... is now in peril.  Akama must be warned!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20460,'The naga came close to breaking my will... but the secret is still safe, thanks to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20461,'','Thank you for bringing me here to see my friend, Hch\'uu!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20462,'','Why isn\'t the Outland called Draenor anymore?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20463,'','Oh wow!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20464,'','Is this where all of the adventurers come from?  Help me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20465,'','If the demons fell, where did they fall from?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20466,'','Whoa, no way!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20467,'','Salandria stands and gapes in awe at the immense Dark Portal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20469,'','By the Light!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20470,'','Is the Twisting Nether shaped like a pretzel?  And just what is a Nether?  The orphan matron said I shouldn\'t ask people about their nethers.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20471,'<Morthis glances skyward.>$B$BIn a way, I envy the freedom Rook and Corvax enjoy. To be free of earthbound responsibilities is a great blessing indeed.$B$BThe future will see me on wing once more, but first there\'s a task I must complete.','',2,1,0,0,0,0,0,0,1,0,0,0,26124),
(20472,'Nazan descends from the sky.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20473,'Gezhe has been really nice letting me come here to apprentice and learn all of this fun stuff, $g mister : ma\'am;.$B$B<Jheel hangs his head.>$B$BBut, I hate being away from my sister.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20474,'Thanks again for bringing my sister to visit me, $G Mr. : Miss; $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20475,'','Jheel!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20476,'','Dornaa gives her brother a big hug, and the two children begin to talk.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20477,'','I hope that Jheel will be able to come back to the orphanage soon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20478,'','Salandria and Hch\'uu begin to catch up on all that has happened to them this past year.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20479,'Dornaa!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20480,'The Horde Flag was returned to its base by $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20481,'Salandria?  Salandria!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20482,'Back to your studies, boy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20483,'Yes, sir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20484,'','See you soon, big brother!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20485,'','Hah, it\'s true!  I\'m gonna go have a closer look at the fire one!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20486,'','Ow!  Hot!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20487,'','Dornaa walks slowly and turns in reverence as a blessing is bestowed upon her by O\'ros.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20489,'','Tee hee, your mind-talk tickles.  Thank you, O\'ros!  I promise to be good!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20490,'Olum... old friend.  It is good to see that you are safe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20491,'Illidan will become suspicious... that much is for certain.  We will deal with it as we always do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20492,'You cannot... be serious, Olum.  Your sacrifice has already been too great.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20493,'It appears your mind is set then.  We will guide you to the spirit world with as much kindness as we can.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20494,'Farewell, dear friend. We shall meet you in the next world when our duties in this one are fulfilled.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20495,'Master!  We\'ve found the traitor who escaped Vashj!  His body lies in front of me... lifeless!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20496,'But, sire!  You have misjudged my actions... I do have knowledge of someone close to you who plans to betray you.  It is that dog, Kael\'thas!  He has allied with Kil\'jaeden and intends to replace you as Lord of Outland!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20497,'It will be done, my lord!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20498,'Akama, my friend!  Have you been informed?  I was found out by Vashj\'s followers.  Our secret is in peril!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20499,'Illidan will find me and when he does... he will pry the Ashtongue secret from me - such is the power of the Betrayer!  No... there is only one way.  My usefulness to the cause has come to an end. I must venture into the spirit world!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20500,'My decision is final.  I will not be dissuaded.  I have devoted my life to our plan.  To jeopardize it now would betray all who have died for the cause long before me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20501,'I thank you, Akama.  You honor me by allowing me this moment, surrounded by my brothers.  Farewell, friend.  Guide our people well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20502,'Illidan is looking for me.  I am not safe here... none of us are.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20503,'','Do you feel that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20504,'','Come on, let\'s go check it out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20505,'','It\'s just ahead!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20506,'','Oh, wow, is that a naaru they\'re channeling from?  I feel funny....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20507,'When you\'re done visiting this exotic city, perhaps you would be interested in celebrating with us. The Lunar Festival is underway in Moonglade; the other cities have transport to the festivities. Come and join the other revelers!','When you\'re done visiting this exotic city, perhaps you would be interested in celebrating with us. The Lunar Festival is underway in Moonglade; the other cities have transport to the festivities. Come and join the other revelers!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20508,'','Wow, what a rush!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20509,'','As if in a daze, Salandria moves toward whatever it is she is sensing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20510,'','Dornaa stands and gapes in awe at the immense Dark Portal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20511,'What are you doing here, $r?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(20512,'%s kneels, filling the vial with water from the moonwell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20513,'The potion is finished. I can only hope Clintar forgives us for interrupting his sojourn in the Emerald Dream.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20514,'','Salandria\'s jaw nearly hits the ground at the sight of Zaladormu.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20515,'','Okay, I like!  Um... what\'s going on?  Save me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20516,'There are few left in the world who can prepare the Ward of Waking, $n. We are fortunate that I am among them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20517,'%s combines the herbs with the moonwell water to create the Ward of Waking.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20518,'Aran has been defeated? Yes... I can sense his grip has loosened - if only just a little. But just enough to allow me to do my job as the doorman! Would you like me transport you to the Guardian\'s Library, $n?','',6,1,6,0,0,0,0,0,1,0,0,0,26124),
(20519,'Please transport me to the Guardian\'s Library.','Please transport me to the Guardian\'s Library.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20520,'WAIT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20521,'This girl has done nothing, and will not be held accountable for what she might do, or fail to do, in the future.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20522,'Go in peace, child.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20523,'%s snaps up to a kneeling position, but seems as though he\'s somewhere else.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20524,'What are you doing in Ysera\'s realm, interloper? Leave us, I say! Your kind are not welcome here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20525,'%s gets to his feet, beginning to recognize his surroundings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20526,'%s links with it\'s master, creating a spirit bond.','%s links with it\'s master, creating a spirit bond.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20527,'','Dornaa\'s jaw nearly hits the ground at the sight of Zaladormu.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20528,'','Wow, he\'s a big one!  Um... what\'s going on?  Save me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20529,'','It is good to see you again, $C $n.  Dornaa has been asking about you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20530,'','It is good to see you again, $C $n.  Salandria has been asking about you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20531,'','The conflicts in Outland are deadlier than any I have seen.  And their most tragic victims are the children that are left behind.$B$BNow, with the threat against Shattrath from the arakkoa of Skettis, there will be even more orphans to take care of.  These children often live without the hope of a bright future.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(20532,'They\'re following me, $r! Quickly, tell me why you\'re here before we\'re discovered! If they catch up to me, it will mean my death and yours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20533,'%s grows sleepy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20534,'I must return to my rest... they must not find me here... the Emerald Dream...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20535,'<The druid appears to be deep in sleep, oblivious to his surroundings.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20536,'Attempt to wake Clintar.','Attempt to wake Clintar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20537,'I beg you, $r, be swift. They will not stop pursuing me! I cannot escape from them, even here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20538,'You -- you\'re not one of them! Let\'s get out of sight before they find us! Hurry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20539,'Stand back, $n. This may be an Ethereum trap.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20540,'%s uses the Ethereum prison key on the salvaged Ethereum prison.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20541,'The crossbow can be learned from Woo Ping, the human weapon master at Weller\'s Arsenal in Stormwind, Handiir, the draenei weapon master found in the Trader\'s Tier within the Exodar, or Bixi Wobblebonk, the gnome weapon master within the Timberline Arms in Ironforge.','The crossbow can be learned from Woo Ping, the human weapon master at Weller\'s Arsenal in Stormwind, Handiir, the draenei weapon master found in the Trader\'s Tier within the Exodar, or Bixi Wobblebonk, the gnome weapon master within the Timberline Arms in Ironforge.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20542,'Commander... I am not long for this world... Taken to a holding pen... hundreds... thousands... beings from other worlds... Imprisoned... Imprisoned by Ethereum. Many of them our allies. Must... Must save the others... It... It\'s not too late...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20543,'','You\'re the man from my dream!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20544,'Those fools! What have they done! What horrors do they hold? And for what purpose? I will need your help again, hero. Help us. Help your people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20545,'Indeed I am, child.  And do you remember what you showed me in those dreams?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(20546,'Ilyenia Moonfire, the night elf weapon master who resides at the Warrior\'s Terrace in Darnassus, can train you in the use of bows.','Ilyenia Moonfire, the night elf weapon master who resides at the Warrior\'s Terrace in Darnassus, can train you in the use of bows.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20547,'','You mean, I can do it here, too?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20548,'Try.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20549,'Amazing, Dornaa.  Truly amazing!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20550,'','I did it, I did it!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20551,'Bixi Wobblebonk in this very shop can train ye in daggers. If ye\'re still looking abroad, anyone else - Woo Ping in Stormwind, Handiir in the Exodar, and Ilyenia Moonfire in Darnassus - can show ye a thing or two. Me, I was never one fer knife fights.','Bixi Wobblebonk in this very shop can train ye in daggers. If ye\'re still looking abroad, anyone else - Woo Ping in Stormwind, Handiir in the Exodar, and Ilyenia Moonfire in Darnassus - can show ye a thing or two. Me, I was never one fer knife fights.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20552,'Ilyenia Moonfire, the night elf weapon master on the Warrior\'s Terrace in Darnassus, or Buliwyf, the dwarf weapon master within the Timberline Arms in Ironforge, can train you in the use of fist weapons.','Ilyenia Moonfire, the night elf weapon master on the Warrior\'s Terrace in Darnassus, or Buliwyf, the dwarf weapon master within the Timberline Arms in Ironforge, can train you in the use of fist weapons.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20553,'','Concentrating a moment, Dornaa summons forth the elemental forces.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20554,'The man to talk to about gunnery is Buliwyf, found in the Timberline Arms within Ironforge.','The man to talk to about gunnery is Buliwyf, found in the Timberline Arms within Ironforge.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20555,'Buliwyf here will happily teach you everything there is to know about guns!','Buliwyf here will happily teach you everything there is to know about guns!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20556,'I am here at the behest of Nexus-Prince Haramad. Strange things are afoot at the Stormspire.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(20557,'','I\'m going to miss you so much, $n!  Promise that you\'ll come to see me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20558,'Please reset the chess board, we would like to play again.','Please reset the chess board, we would like to play again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20559,'A shadowy, sinister presence has invaded the Emerald Dream. Its power is poised to spill over into our world, $n. We must oppose it! That\'s why I cannot accompany you in person.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20560,'I will guide you to the location of the relics, but you must guard my spirit well. As the guardian of the relics, only I can break the seals on the reliquaries.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20561,'','I\'m going to miss you so much, $n!  Promise that you\'ll come to see me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20562,'A %s erupts into the waking world from the Emerald Dream!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20563,'That\'s the first relic, but there are still two more. Follow me, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20564,'I\'ve recovered the second relic. Take a moment to rest, and then we\'ll continue to the last reliquary.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20565,'Foolish druid! Dividing your essence has weakened you, opening the door for my master to dominate the Emerald Dream. Your spirit and your body will die here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20566,'%s hands the Relics of Aviana to Dreamwarden Lurosa.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20567,'Begone from this place!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20568,'The Emerald Dream will never be yours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20569,'The dwarven weapon master Buliwyf can train you in both one and two-handed axes. He\'s found in the Timberline Arms in Ironforge.','The dwarven weapon master Buliwyf can train you in both one and two-handed axes. He\'s found in the Timberline Arms in Ironforge.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20570,'There\'s no finer expert I know on axes than Buliwyf here! One hand, two hands... he\'s a master of it all!','There\'s no finer expert I know on axes than Buliwyf here! One hand, two hands... he\'s a master of it all!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20571,'My pal Buliwyf here can show you how to use fist weapons... or, if you prefer, Ilyenia Moonfire - she\'s the night elf weapon master on the Warrior\'s Terrace in Darnassus - can show you, too!','My pal Buliwyf here can show you how to use fist weapons... or, if you prefer, Ilyenia Moonfire - she\'s the night elf weapon master on the Warrior\'s Terrace in Darnassus - can show you, too!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20572,'My plucky companion Bixi Wobblebonk here can train ye in crossbows. If ye\'re looking for other trainers, though, ye might want to try Ilyenia Moonfire on the Warrior\'s Terrace in Darnassus, or maybe the draenei weapon master, Handiir, in the Trader\'s Tier within the Exodar.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20573,'Ilyenia Moonfire, the night elf weapon master who resides at the Warrior\'s Terrace in Darnassus, can show ye how to use a bow.','Ilyenia Moonfire, the night elf weapon master who resides at the Warrior\'s Terrace in Darnassus, can show ye how to use a bow.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20574,'Both Handiir and Buliwyf can show you how to swing a mace properly, no matter the size. You can find Buliwyf within the Timberline Arms in Ironforge. Handiir spends his days in the Exodar, training draenei on the Trader\'s Tier.','Both Handiir and Buliwyf can show you how to swing a mace properly, no matter the size. You can find Buliwyf within the Timberline Arms in Ironforge. Handiir spends his days in the Exodar, training draenei on the Trader\'s Tier.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20575,'Maces are a specialty of Buliwyf\'s! He\'s around this shop somewhere, grousing. If his training techniques aren\'t your style, I hear the draenei weapon master in the Exodar, Handiir, knows his way around the weapon too! He\'s up on the Trader\'s Tier there.','Maces are a specialty of Buliwyf\'s! He\'s around this shop somewhere, grousing. If his training techniques aren\'t your style, I hear the draenei weapon master in the Exodar, Handiir, knows his way around the weapon too! He\'s up on the Trader\'s Tier there.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20576,'Woo Ping is the master of polearms. He trains his students at Weller\'s Arsenal in Stormwind.','Woo Ping is the master of polearms. He trains his students at Weller\'s Arsenal in Stormwind.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20577,'Staves are taught by both Woo Ping, the master found at Weller\'s Arsenal in Stormwind, and Ilyenia Moonfire, who trains the night elves on the Warrior\'s Terrace in Darnassus.','Staves are taught by both Woo Ping, the master found at Weller\'s Arsenal in Stormwind, and Ilyenia Moonfire, who trains the night elves on the Warrior\'s Terrace in Darnassus.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20578,'There are two masters of the sword: Handiir and Woo Ping. The former can be found in the Trader\'s Tier of the Exodar, and the latter in Weller\'s Arsenal within Stormwind.','There are two masters of the sword: Handiir and Woo Ping. The former can be found in the Trader\'s Tier of the Exodar, and the latter in Weller\'s Arsenal within Stormwind.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20579,'Both Ilyenia Moonfire on the Warrior\'s Terrace of Darnassus and Bixi Wobblebonk of the Timberline Arms in Ironforge can show you how to use throwing weapons properly.','Both Ilyenia Moonfire on the Warrior\'s Terrace of Darnassus and Bixi Wobblebonk of the Timberline Arms in Ironforge can show you how to use throwing weapons properly.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20580,'Axe','Axe',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20581,'Bow','Bow',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20582,'Crossbow','Crossbow',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20583,'Dagger','Dagger',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20584,'Fist Weapon','Fist Weapon',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20585,'Gun','Gun',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20586,'Mace','Mace',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20587,'Polearm','Polearm',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20588,'Staff','Staff',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20589,'Sword','Sword',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20590,'Thrown','Thrown',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20592,'Bixi here can teach ye how to lob throwin\' weapons.  If Darnassus is more yer speed, talk to Ilyenia Moonfire on the Warrior\'s Terrace there.','Bixi here can teach ye how to lob throwin\' weapons.  If Darnassus is more yer speed, talk to Ilyenia Moonfire on the Warrior\'s Terrace there.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20593,'Are you with me, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20594,'If you seek training in weapons, I can provide.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20595,'Ah, you wish to train abroad? I will direct you. Tell me which weapon has sparked your interest.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20596,'We have all three of the relics, but my energy is rapidly fading. We must make our way back to Dreamwarden Lurosa! He will let you know what to do next.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20597,'','Sooooo cute!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20598,'','Awww.... Hello little baby!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20599,'','They are so tiny.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20600,'','Aww...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20601,'Lurosa, I am entrusting the Relics of Aviana to $n, who will take them to Morthis Whisperwing. I must return completely to the Emerald Dream now. Do not let $n fail!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20602,'','Hmm... this one smells kinda funny.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20603,'','What big eyes you have!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20604,'','I don\'t remember ever being this small.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20605,'','How adorable!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20606,'Both Hanashi and Sayoc can train you in the use of one and two-handed axes. They can be found in the Valley of Honor in Orgrimmar.','Both Hanashi and Sayoc can train you in the use of one and two-handed axes. They can be found in the Valley of Honor in Orgrimmar.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20608,'The weapon masters in the Valley of Honor within Orgrimmar, Sayoc and Hanashi, can teach you how to shoot a bow. Ileda, the weapon master of Silvermoon found in Farstrider Square, is also an expert.','The weapon masters in the Valley of Honor within Orgrimmar, Sayoc and Hanashi, can teach you how to shoot a bow. Ileda, the weapon master of Silvermoon found in Farstrider Square, is also an expert.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20609,'Archibald is the master of the crossbow. He\'s the weapon master of the Undercity, located in the War Quarter.','Archibald is the master of the crossbow. He\'s the weapon master of the Undercity, located in the War Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20610,'Dagger instruction can be sought from three weapon masters: Archibald in the War Quarter of the Undercity, Sayoc within the Valley of Honor in Orgrimmar, and Ileda in Silvermoon\'s Farstrider Square.','Dagger instruction can be sought from three weapon masters: Archibald in the War Quarter of the Undercity, Sayoc within the Valley of Honor in Orgrimmar, and Ileda in Silvermoon\'s Farstrider Square.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20611,'Sayoc, da ugly orc here, teach you daggers. You want teaching in other places, you talk to Ileda in da Farstrider Square of Silvermoon or Archibald in the War Quarter of Undercity, hokay?','Sayoc, da ugly orc here, teach you daggers. You want teaching in other places, you talk to Ileda in da Farstrider Square of Silvermoon or Archibald in the War Quarter of Undercity, hokay?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20612,'Fist weapons are taught by Sayoc, the orc weapon master in Orgrimmar. He spends his days in the Valley of Honor.','Fist weapons are taught by Sayoc, the orc weapon master in Orgrimmar. He spends his days in the Valley of Honor.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20613,'You want to punch things, yah? Talk to Sayoc right here. He teach you.','You want to punch things, yah? Talk to Sayoc right here. He teach you.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20614,'Our gunnery instructor is Ansekhwa, the tauren weapon master on the lower central rise of Thunder Bluff.','Our gunnery instructor is Ansekhwa, the tauren weapon master on the lower central rise of Thunder Bluff.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20615,'Maces are taught by Ansekhwa, found on the lower central rise of Thunder Bluff.','Maces are taught by Ansekhwa, found on the lower central rise of Thunder Bluff.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20616,'The Forsaken weapon master Archibald knows his way around the polearm. He trains others in the War Quarter of the Undercity. Ileda, the blood elf weapon master within Farstrider Square in Silvermoon, can show you the proper techniques also.','The Forsaken weapon master Archibald knows his way around the polearm. He trains others in the War Quarter of the Undercity. Ileda, the blood elf weapon master within Farstrider Square in Silvermoon, can show you the proper techniques also.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20617,'Staves are taught by Hanashi, the troll weapon master in Orgrimmar\'s Valley of Honor, and Ansekhwa, the tauren weapon master who trains on the lower central rise of Thunder Bluff.','Staves are taught by Hanashi, the troll weapon master in Orgrimmar\'s Valley of Honor, and Ansekhwa, the tauren weapon master who trains on the lower central rise of Thunder Bluff.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20618,'Hanashi here knows staves. If you want a sturdier instructor, go to Thunder Bluff. Ansekhwa will teach you on the lower central rise there.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20619,'Ileda of the blood elves, found within Farstrider Square of Silvermoon, trains her students in both one and two-handed swords. Archibald, Undercity\'s weapon master, can also train you; he is in the War Quarter.','Ileda of the blood elves, found within Farstrider Square of Silvermoon, trains her students in both one and two-handed swords. Archibald, Undercity\'s weapon master, can also train you; he is in the War Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20620,'Sayoc and Hanashi, Orgrimmar\'s weapon masters, are true artisans of the thrown weapon. They train willing students in the Valley of Honor. For pure finesse in the art, however, Ileda of Silvermoon\'s Farstrider Square cannot be beaten.','Sayoc and Hanashi, Orgrimmar\'s weapon masters, are true artisans of the thrown weapon. They train willing students in the Valley of Honor. For pure finesse in the art, however, Ileda of Silvermoon\'s Farstrider Square cannot be beaten.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20621,'Archibald da master of da crossbow. He da weapon master of da Undercity, located in da War Quarter.','Archibald is da master of da crossbow. He da weapon master of da Undercity, located in da War Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20622,'Our gunnery instructor, he Ansekhwa, da tauren weapon master on da lower central rise of Thunder Bluff.','Our gunnery instructor, he Ansekhwa, da tauren weapon master on da lower central rise of Thunder Bluff.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20623,'Maces, they taught by Ansekhwa, found on da lower central rise of Thunder Bluff.','Maces, they taught by Ansekhwa, found on da lower central rise of Thunder Bluff.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20624,'Da Forsaken weapon master Archibald know his way \'round da polearm. He train others in da War Quarter of da Undercity. Ileda, da blood elf weapon master in Farstrider Square in Silvermoon, show you da right techniques too, mon.','Da Forsaken weapon master Archibald know his way \'round da polearm. He train others in da War Quarter of da Undercity. Ileda, da blood elf weapon master in Farstrider Square in Silvermoon, show you da right techniques too, mon.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20625,'Ileda of da blood elves, in Farstrider Square of Silvermoon, train her students in both one and two-handed swords. Archibald, da Undercity\'s weapon master, also train you, mon. He in da War Quarter.','Ileda of da blood elves, in Farstrider Square of Silvermoon, train her students in both one and two-handed swords. Archibald, da Undercity\'s weapon master, also train you, mon. He in da War Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20626,'','I can\'t see why you want to learn something else... but I suppose I can point you in the right direction. What training are you after, specifically?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20627,'','If you haven\'t come to train, step back and leave me to my work.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20628,'You disappoint me, Akama.  I wanted to question the treacherous worm myself!  I\'m beginning to question your allegiance, Broken.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20629,'I do not sense lies in your voice, Akama.  That Kael\'thas would betray me does not come as a big surprise - I\'m not as oblivious as some would think. That one of your own was involved with him puts your loyalties into question.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20630,'Send your Ashtongue into Tempest Keep and slay his most prized possession, the phoenix known as Al\'ar.  I must know that you\'re not on his side.  Do not think of betraying me, Broken.  We both know who owns your soul!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20631,'Be wary of the Ethereum that surround us on all sides.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20632,'I\'ve lost my Violet Signet and seek a replacement.','I\'ve lost my Violet Signet and seek a replacement.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20633,'I... I am free! Ethereum were planning on torturing me until I gave in to their requests. I fear that, had you not come along, I would have surely given in to their torment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20634,'Know this, $r. Within Shaffar\'s chambers at the end of these tombs rests a creature of unimaginable power. It is held in check by the power of the stasis chamber. You must return to Ameer before you venture further if you wish to destroy it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20635,'Come and I will show you how to ride the finest beasts you have ever seen. You... do have enough gold to cover the cost, I trust?','Come and I will show you how to ride the finest beasts you have ever seen. You... do have enough gold to cover the cost, I trust?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20636,'','Welcome to the Evergrove, $c. Timeon and I have been studying the arakkoa of Blade\'s Edge for some time now, and we\'ve found some alarming differences between them and their cousins in Terokkar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20637,'<The arakkoa ghost reaches out toward you as though to try to identify you. You get the impression that it cannot see you clearly.>$B$BRokkaram, is that you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20638,'Yes... yes, it\'s me...','Yes... yes, it\'s me...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20639,'Forgive me for questioning you, my son. My sight isn\'t what it once was, but the raven has blessed me with a long life.$B$BSoon, it will be time for you to take my place. I have taught you all I know. My only regret is that I didn\'t prove worthy enough to recover our sacred Book of the Raven.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20640,'Yes, elder. Tell me more of the book.','Yes, elder. Tell me more of the book.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20641,'The true believers have lived in shame since the day our treacherous cousins in Skettis stole the book from us, shattered its tablet, and buried the fragments in their wretched city!$B$BPray that the raven will choose you to restore it, my son. Be faithful and remember always the prophecy, \"From the dreams of his enemies shall the raven spring forth into the world.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20642,'Grok look for help.  Little $r go to the mountains and help the Bloodmaul!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20643,'You go see Mog\'dorg?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20644,'I seek a $g hero : heroine; of the utmost skill.  $G He : She; will gather others to save the Bloodmaul clan, and all of the ogres of these mountains from the tyranny of our gronn oppressors.$B$BReturn to me when you have learned all that you can.  But, $c, keep quiet about this until that time lest the gronn get wind of our underground movement.','',396,396,0,0,0,0,0,0,1,0,0,0,26124),
(20645,'The Sons of Gruul must be defeated if we are to shake off our shackles and live as free ogres once more!$B$BWe must work quietly, yet quickly, if our underground resistance is to have a chance of success.','',396,396,0,0,0,0,0,0,1,0,0,0,26124),
(20646,'I fear that Colonel Jules may only be saved through a dangerous ritual... an exorcism.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20647,'Speak with me, $n, for we have much to prepare...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20648,'Grok need help!  Why no one help?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20649,'Looking around for help, %s sighs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20650,'We must not fail The Betrayer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20651,'Soon, our time will come!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20652,'Has there been contact from the Citadel?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20653,'The smell of these mutant orcs disgusts me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20654,'Ogre, please leave.  You are disturbing our clientele!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20655,'Not again, Grok.  You\'ve been told before to stay away!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20656,'Grok, take it outside.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20657,'Has no one helped you yet, ogre?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(20658,'Ogre, leave!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20659,'Grok, you\'ve been told before, stay out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20660,'Guards, if the ogre doesn\'t leave, escort him out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20661,'Will somebody please help this ogre so that he won\'t come back?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20662,'Move along, Grok, you can\'t go up.','Aw, sweety, you know that I can\'t let you go up there.  Rules are rules.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20663,'The answer is still no, Grok.  You can\'t go up.','I thought that I told you not to come around here.  Move on!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20664,'Grok get angry if puny ones not go to Blade\'s Edge and talk to Mog\'dorg!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20665,'The enemy is upon us!  Stand your ground!','The enemy is upon us!  Stand your ground!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20666,'The enemies of the Light must be defeated!','The enemies of the Light must be defeated!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20667,'For Xi\'ri!  For the Sha\'tar!','For Xi\'ri!  For the Sha\'tar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20668,'Your end is at hand, Illidari!','Your end is at hand, Illidari!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20669,'Illidan\'s lapdogs!  Destroy them all!','Illidan\'s lapdogs!  Destroy them all!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20670,'Come closer, demon!  Death awaits!','Come closer, demon!  Death awaits!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20671,'Pathetic worm... your master\'s days are over!','Pathetic worm... your master\'s days are over!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20672,'I\'ve a message for your master, scum!','I\'ve a message for your master, scum!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20673,'Do my eyes deceive me? Is that really you, Brother Rokkaram, after all this time?$B$BIf you are looking for Sai\'kkal, he walks among the crystals in the western part of the Vortex Pinnacle. He seems preoccupied with what he calls a brutish, primitive presence there, although nothing seems amiss.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20674,'%s begins to break apart!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20675,'%s surveys the ground for buried raven stones.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20676,'%s locates a buried raven stone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20677,'','I think I need a bath.  *sniff*  I think you need one, too!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20678,'','Would a tauren paladin be a holy cow?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20679,'','Does this dress make me look fat?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20680,'','I bet Illidan is a nice guy underneath.  He just needs a mama, too.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20681,'','I bet ice cream would taste better if it were socketed!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20682,'','Boys have cooties and girls have beauty!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20683,'','Are we there yet?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20684,'','If I hold my breath, what color would I turn?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20685,'','If a horse gets horseshoes, will I get draenei shoes?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20686,'','If the Burning Legion is such a problem, why not just throw water on them?  Then they\'ll just be a Legion.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20687,'','How do you drink and eat so much, and not get fat?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20688,'','Does a naaru turn off the Light when it wants to sleep?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20689,'%s looks at you for a moment, then motions for you to follow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20690,'','Heh, I got a little too close.  Don\'t worry, I\'m fine.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20691,'','O\'ros says that he wants to talk with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20692,'%s senses danger and flees.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20693,'%s begins channelling the powers of the Light.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20694,'I have lost the Eye of Haramad and require a replacement, Ameer.','I have lost the Eye of Haramad and require a replacement, Ameer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20695,'%s begins to channel a spell of immense purity.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20696,'','Onward, Scryers!  Show Illidan\'s lackeys the temper of our steel!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20697,'','Ya may know a thing or two about handlin\' animals, but have ya ever taken ta the skies? We Wildhammers know how ta ride the wind with the best of \'em. Fer a small fee, if ya\'ve got the mettle, I\'ll train ya good and proper.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20698,'What do you think when you think Wildhammer, eh? Gryphon riders, if you\'ve any sense! Shadowmoon is no Aerie Peak, but we\'ve still got fine stock for you, aye, fine stock. Take a look at my beauties and see if one of \'em catches your eye!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20699,'Show me your gryphons, Brunn.','Show me your gryphons, Brunn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20700,'The violent earthquake has alerted nearby Murlocs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20701,'%s sends his enemies to their watery graves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20702,'%s sees a bug!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20703,'%s summons watery globules!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20704,'Attention!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20705,'Yes Sir!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20706,'At ease soldiers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20708,'','%s takes the Southfury moonstone and escapes into the river. Follow her!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20710,'%s raises his hammer menacingly...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20711,'Weapons ready!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20712,'Attack one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20713,'Attack two!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20714,'Attack three!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20715,'','You, there! Hand over that moonstone and nobody gets hurt!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20716,'Hut!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20717,'Hoo-rah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20718,'Ahhhhhhhhhhhhhhhhhhh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20719,'Pitiful wretches. You dared to assault Illidan\'s temple? Very well, I shall make it your death bed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20720,'','All right, you win! I surrender! Just don\'t hurt me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20721,'','See? I\'ve got the Southfury moonstone and there\'s not a thing you can do about it. So long!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20722,'','Don\'t hurt me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20723,'Hand over the Southfury moonstone and I\'ll let you go.','Hand over the Southfury moonstone and I\'ll let you go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20724,'Cast the frost trap.','Cast the frost trap.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20725,'A kiss would be most appreciated.','A kiss would be most appreciated.',24,0,0,0,0,0,0,0,1,0,0,0,26124),
(20726,'Argh!  I will shred your soul and grind it to dust!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20727,'Weak, little bugs!  Your souls aren\'t worth eating...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20728,'You can kiss me if you like, just be quick about it.','You can kiss me if you like, just be quick about it.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(20729,'Make sure you stick around for the next firework show!  Starting at 6PM, they\'re every hour on the hour!','Make sure you stick around for the next firework show!  Starting at 6PM, they\'re every hour on the hour!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(20730,'Help yourself to a drink friend.  Just make sure to stay away from the ledge while you drink.','Help yourself to a drink friend.  Just make sure to stay away from the ledge while you drink.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(20731,'After the fireworks, goblets will be put out. We will then toast our comrades!','After the fireworks, goblets will be put out. We will then toast our comrades!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(20732,'Enjoy the festivities!','Enjoy the festivities!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(20733,'Starting at 6PM, the city will have a fireworks extravaganza every hour on the hour.','Starting at 6PM, the city will have a fireworks extravaganza every hour on the hour.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(20734,'The drink in the kegs is divine.  Drink up, $c!','The drink in the kegs is divine.  Drink up, $c!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(20735,'After the firework show, they\'ll put out goblets so we can raise a toast!','After the firework show, they\'ll put out goblets so we can raise a toast!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(20736,'Excellent, it\'s party time!','Excellent, it\'s party time!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(20737,'%s falls silent and a quiet tension falls over the nearby Sha\'tar forces as Xi\'ri makes his decision.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20738,'','Come closer, young one. There\'s nothing to fear from me or $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20739,'%s cautiously approaches Watcher Elaira.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20740,'','I\'m going to train you to help $n with a very important task. After that, I promise you\'ll be free to return home.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20741,'A miserable defense from Light-swollen fools. Xi\'ri, I will consume you myself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20742,'Now is the time, Maiev!  Unleash your wrath!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20743,'','I\'ve waited for this moment for years.  Illidan and his lapdogs will be destroyed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20744,'Slay all who see us!  Word must not get back to Illidan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20745,'You\'ve sealed your fate, Akama.  The Master will learn of your betrayal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20746,'Akama has no master.  Not anymore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20747,'','%s slips into the shadows discreetly as Akama\'s attention shifts towards Vagath\'s last words.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20748,'Our plans are in danger already.  It appears Maiev\'s decided to do things her own way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20749,'%s\'s attention shifts to a crack along the temple\'s southern wall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20750,'We must carry on with or without Maiev.  Inside!  Quickly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20751,'','You will hear the call when you are needed. Fly east, to Skettis, and wait there for $n\'s signal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20752,'','It would\'ve taken years to find the Book of the Raven without you, young sparrowhawk. Return to your home in Nagrand with our gratitude.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20753,'','This is it! This is really it -- the Book of the Raven!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20754,'The feast of corruption is no more! Magtheridon has fallen to the battle prowess of $n and $g his:her; allies! Witness the might of the Alliance! A pit lord commander is destroyed!\n','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20755,'Hear me brothers and sisters-in-arms! The time of our enemies is at an end! We must strike at the fel orcs that remain! Exterminate them like the vermin that they are! Carry with you the favor of the Sons of Lothar!\n','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(20756,'','It\'s all here... how the raven\'s followers captured and subdued the spirits of rivals, trapping them forever within stone statues! The tablet even mentions the raven god\'s name -- Anzu. I\'d thought it was lost to history!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20757,'','There\'s something else here, too. After a description of a bloody battle and the downfall of the raven, there\'s a prophecy. Anzu will haunt the dreams of his enemies, twisting them to effect a return to this world...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20758,'','The tablet has the confirmation we need, just as I thought. Now, we have to use this information to draw out and defeat this Anzu before he can do any more damage to the Emerald Dream!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20759,'','%s greets the sparrowhawk that helped locate the raven stones.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20761,'Forward, vindicators!  Drive these demons from our sacred temple!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20762,'You look like you may know your way around a beast that runs on land, but if you want to soar, it\'ll take training and dedication. And gold. You have gold, right?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20763,'','Fine beasts, aren\'t they? The wyverns we raise here are trained to handle the fiercest and strangest weather conditions Draenor has to offer. You\'ll find them dependable and hardy.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20764,'Let me see the wyverns, Dama.','Let me see the wyverns, Dama.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20765,'Hellfire Citadel is ours! The source of Illidan\'s fel orc army is no more! Magtheridon has fallen to the might of $n and $g his:her; allies!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20766,'The time for us to rise and strike at the fel orcs that remain is now! Do this for your Warchief! Do this for the Horde!\n','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(20767,'Fool! The essence of the hawk will never be yours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20768,'The time of the Raven is nigh, but yours will end here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20769,'You dare to disturb the loyal followers of the Raven?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20770,'You will die for your hubris, $c!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20771,'The falcon is vanquished, doomed never to rise again! Your quest is futile!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20772,'The raven will return to us as foretold in the prophecy and you are powerless to stop it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20773,'You dare summon me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20774,'%s takes a deep breath!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20775,'%s begins to cast Pyroblast!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20776,'Silence descends upon Shattrath.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20777,'%s\'s thoughts invade your mind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20778,'Kael\'thas Sunstrider has been defeated by $n and $g his:her; allies.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20779,'The time to strike at the remaining blood elves of Tempest Keep is now. Take arms and let A\'dal\'s song of battle empower you!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20780,'I don\'t care who you are or what you do outside of the Skyguard, but while you\'re here you will do as you\'re told.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20781,'Me hungry.  Fruit look tasty.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20782,'Mog\'dorg the Wizened tell Grok go to city, get help for Bloodmaul.  Grok go.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20783,'If no one help, Grok smash!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20784,'Bladespire clan not fight fair.  Have gronn to help dem.  You go to Blade\'s Edge Mountains.  Talk to Mog\'dorg the Wizened.  Kill gronn.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20785,'Hey, troll!  Why dis charm no work?!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20786,'When I grow up I wanna be a tanner!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20787,'Huh?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(20788,'What?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(20789,'Grok not eat all of the apples.  See, der one basket left!','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(20790,'It was dat angry orc.  He smushed dem!  Want Grok to smush him?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(20791,'All hail, $n, the new $G King : Queen; of the ogres!!!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(20792,'Your monkeys failed to finish the job, naaru. Beaten but alive... The same mistake was not made when we took command of your vessel.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20793,'All for what? Trinkets? You are too late. The preparations have already begun. Soon the master will make his return.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20794,'And there is nothing you or that fool, Illidan, can do to stop me! You have both served me in your own right - unwittingly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20795,'And who will save Azeroth from his hungering gaze? You? Your monkeys?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20796,'Lay down your arms and succumb to the might of Kil\'jaeden!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20797,'No! How can this be?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20798,'The lesser spirits were imprisoned ages ago, never to return! I chose the guardians myself! What have you done?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20799,'Pain will be the price for your insolence! You cannot stop me from claiming the Emerald Dream as my own!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20800,'A kiss would be most appreciated.','A kiss would be most appreciated.',24,0,0,0,0,0,0,0,1,0,0,0,26124),
(20801,'Make sure you stick around for the next firework show!  Starting at 6PM, they\'re every hour on the hour!','Make sure you stick around for the next firework show!  Starting at 6PM, they\'re every hour on the hour!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(20802,'Help yourself to a drink friend.  Just make sure to stay away from the ledge while you drink.','Help yourself to a drink friend.  Just make sure to stay away from the ledge while you drink.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(20803,'After the fireworks, goblets will be put out. We will then toast our comrades!','After the fireworks, goblets will be put out. We will then toast our comrades!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(20804,'Enjoy the festivities!','Enjoy the festivities!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(20805,'You can kiss me if you like, just be quick about it.','You can kiss me if you like, just be quick about it.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(20806,'Starting at 6PM, the city will have a fireworks extravaganza every hour on the hour.','Starting at 6PM, the city will have a fireworks extravaganza every hour on the hour.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(20807,'The drink in the kegs is divine.  Drink up, $c!','The drink in the kegs is divine.  Drink up, $c!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(20808,'After the firework show, they\'ll put out goblets so we can raise a toast!','After the firework show, they\'ll put out goblets so we can raise a toast!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(20809,'Party on, $c!\n','Party on, $c!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(20810,'Protect the precioussss!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20811,'For Blackscale!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20812,'Leave no survivors!','',0,0,0,0,0,0,0,11,1,0,0,0,26124),
(20813,'Dinner is served!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20814,'Scout the area and report anything you see!','Scout the area and report anything you see!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20815,'By the Light! What is that thing?','By the Light! What is that thing?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20816,'The Legion\'s machinations are truly intimidating! ','The Legion\'s machinations are truly intimidating! ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20817,'Hurry past this foul contraption!','Hurry past this foul contraption!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20818,'That machine is too powerful for us alone, quickly, before we are spotted!','That machine is too powerful for us alone, quickly, before we are spotted!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20819,'What is that thing?','What is that thing?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20820,'The Legion\'s creations truly grow more foul by the day.','The Legion\'s creations truly grow more foul by the day.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20821,'Let\'s see how you enjoy that mechanical abomination knocking on your door, Illidan!','Let\'s see how you enjoy that mechanical abomination knocking on your door, Illidan!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20822,'Inside, quickly! Let\'s use the Legion\'s attack as a distraction!','Inside, quickly! Let\'s use the Legion\'s attack as a distraction!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20823,'Dragonriders mount up!','Dragonriders mount up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20824,'Back to your patrol, worm! That shield is more valuable to me than a hundred of you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20825,'This is an outrage! Your disobedience shall not go unpunished!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20826,'Permission to buzz the tower!','Permission to buzz the tower!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20827,'','No words could do justice to those who would so unselfishly lay down their lives for the good of all. Suffice it to say that I am honored to have fought beside each and every one of you. Now go forth and celebrate. Victory is ours!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20828,'I\'ve never heard of a tikbalang in my life. In fact, the Scryers tell me they can\'t find a single mention of one in their libraries...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20829,'Look, man, they didn\'t live to be writin\' about it, okay?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20830,'%s quirks a skeptical brow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20831,'Are you insulting our citizens?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20832,'It\'s the truth, man. Can\'t ya smell that?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(20833,'Be afraid no more, $n!','Be afraid no more, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20834,'Awaken from your slumber, $n!','Awaken from your slumber, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20835,'Remember where your loyalties lie, $n!','Remember where your loyalties lie, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20836,'Return to this realm, $n!','Return to this realm, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20837,'Return to your original form, $n!','Return to your original form, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20838,'Do not be so easily taken, $n! It is a trick!','Do not be so easily taken, $n! It is a trick!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20839,'Free yourself and chase them, $n!','Free yourself and chase them, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20840,'Break free of your shackles, $n!','Break free of your shackles, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20841,'%s shells up defensively.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20842,'%s sniffs the air and frowns. He glances over his shoulder.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20843,'That... odor is from Tobias, I believe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20844,'%s\'s frustrated frown disappears into a sly look.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(20845,'...do ya think he be buyin\' soap on a rope, mebbe?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(20846,'%s rolls his eyes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20847,'','The sin\'dorei reign supreme!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20848,'','This is not over!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20849,'','Tal anu\'men no sin\'dorei!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20850,'','The warmth of the sun... awaits.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20851,'','Your soul belongs to the abyss!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20852,'','By the blood of the Highborne!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20853,'','For the Sunwell!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20854,'','You are hopelessly outmatched!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20855,'','I will crush your delusions of grandeur!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20856,'Prepare to march!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20857,'Excellent!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20858,'NO! I... will... not...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20859,'Blood for blood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20860,'Anar\'alah belore!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20861,'More perils... await...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20862,'Are you insinuating that you sell devices which hold sway over others\' minds? That is a very dangerous claim...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20863,'%s turns to Jadaar with an exasperated expression.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(20864,'Ya be crampin\' my style, man. Seriously.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(20865,'Provided your \"style\" does not include swindling the inhabitants of the city, my words should not \"cramp\" it whatsoever.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20866,'Yeah, yeah.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(20867,'Akama. Your duplicity is hardly surprising. I should have slaughtered you and your malformed brethren long ago.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20868,'Boldly said. But I remain... unconvinced.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20869,'You cannot possibly be suggesting that these baubles of yours hold sway over the very fabric of life itself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20870,'%s growls angrily.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20871,'Ya wanna find out?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20872,'%s gives Griftah a chilly stare.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20873,'...was that a THREAT?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20874,'Ah... uh... nah.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20875,'%s frowns sternly at the back of Griftah\'s head, but remains silent.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20876,'Truly? \"Guaranteed?\" We\'ll have to sit down and talk at length about this \"guarantee\" of yours, merchant.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20877,'%s slumps his shoulders, muttering imprecations under his breath.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20878,'I don\'t suppose you\'d be amenable to demonstrating the amulet\'s healing power here and now...?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20879,'Ah... nah, man. Don\'t wanna get the merchandise all messy, ya know?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20880,'%s smiles nervously.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20881,'Very well. Later, however, I wish to see proof of your claims.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20882,'Yeah! Yeah. Later, man. Much later.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20883,'There have been some complaints filed about this... individual. I\'m told he\'s something of a shady character. I am here to determine whether or not this business of his is legitimate... and take action if it proves otherwise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20884,'You are not prepared!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20885,'If you manage to complete a deck of furies cards you will be rewarded with a greater darkmoon card of vengeance.   While wielding this card anyone who strikes you has a chance of suffering holy vengeance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20886,'If you manage to complete a deck of storms cards you will be rewarded with a greater darkmoon card of wrath.   This will increase your chance to get a critical hit with spells or physical attacks until you achieve one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20887,'If you manage to complete a deck of blessings cards you will be rewarded with a greater darkmoon card of crusade.   This will increase the damage you do with your spells and attacks as you continue to fight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20888,'If you manage to complete a deck of lunacy cards you will be rewarded with a greater darkmoon card of madness.   The power of madness will fill you each time you slay an enemy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20889,'Tell me about the Furies Deck.','Tell me about the Furies Deck.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20890,'Tell me about the Lunacy Deck.','Tell me about the Lunacy Deck.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20891,'Tell me about the Blessings Deck.','Tell me about the Blessings Deck.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20892,'Tell me about the Storms Deck.','Tell me about the Storms Deck.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20893,'We\'ve come to end your reign, Illidan. My people, and all of Outland, shall be free!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20894,'The time has come! The moment is at hand!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20895,'We ogres were once lost...','We ogres were once lost...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20896,'Though mighty, we only knew of violence...','Though mighty, we only knew of violence...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20897,'We fought long and hard.  We had proven again and again that we ogres were a force to be reckoned with.','We fought long and hard.  We had proven again and again that we ogres were a force to be reckoned with.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20898,'Yet soon we turned on each other.  Brother fought brother to decide who was the mightiest.','Yet soon we turned on each other.  Brother fought brother to decide who was the mightiest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20899,'It was clear that our paths were set.  We were our own greatest enemies, and we were determined to destroy ourselves.','It was clear that our paths were set.  We were our own greatest enemies, and we were determined to destroy ourselves.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20900,'Among these crystals we have seen a new path, a path of peace.','Among these crystals we have seen a new path, a path of peace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20901,'Morthis! Thank Elune! I was worried I\'d never see you again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20902,'Be wary, friends. The Betrayer meditates in the court just beyond.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20903,'We\'re ready to face Illidan.','We\'re ready to face Illidan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20904,'Forgive me, my prince! I have... failed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20905,'Prepare yourselves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20906,'Alert! You are marked for extermination.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20907,'Systems... shutting... d-o-w-n...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20908,'Extermination successful.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20909,'Invasive lifeform no longer functional.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20910,'Threat neutralized.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20911,'Alternative measure commencing...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20912,'Calculating force parameters...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20913,'So my blood was not a sufficient payment, eh? Fine, let us recover your arcane essence. After this, I owe Balthas nothing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20914,'%s places a fetish at the ritual pile.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20915,'The process is arduous. We must first summon forth acolytes of the elements. You must then destroy these acolytes so that my minions can make preparations.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20916,'Well done!  Let\'s continue.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20917,'Prepare yourself! The acolyte of water is soon to come...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20918,'Come forth, acolyte of earth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20919,'Fire, show yourself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20920,'Now we call forth the arcane acolyte.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20921,'You try my patience, shore-dwellers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20922,'Enough! Taste the full fury of High Warlord Naj\'entus!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20923,'','Shh! Keep your voice down. The babes are sleeping.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20925,'The %s cowers at the sight of his angered $g king : queen;.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20926,'%s brushes up against $n and farts like only an ogre can.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20927,'Me like to fart, too!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20928,'Aw, me not think it work out between us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20929,'What me do wrong, my $g king : queen;?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20930,'No hurt!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20931,'Flood of the deep, take you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20932,'The bogblossom explodes, spraying pollen wildly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20933,'By the tides!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20934,'Destroy them, my subjects!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20935,'There is nowhere to hide!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20936,'Soon it will be finished!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20937,'It is done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20938,'Struggling only makes it worse.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20939,'Only the strong will survive.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20940,'Great currents of... Ageon...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20941,'Do not proceed. You will be eliminated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20942,'Tectonic disruption commencing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20943,'Magnitude set. Release.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20944,'Trajectory locked.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20945,'Engage maximum speed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20946,'Threat level zero.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20947,'Directive accomplished.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20948,'Target exterminated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20949,'System failure in five, f-o-u-r...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20950,'Yes, $g king : queen;?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20951,'You kill gronn!  Now you fight things from sky?','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(20952,'Me life for $n!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(20953,'Dis drink good!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20954,'If $G King : Queen; $n dance, me dance!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20955,'$G King : Queen; not angry with me?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20956,'Why you look at me like dat?  You not gonna kiss me, right!?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20957,'Now all Sons of Gruul dead!  Now new $g king : queen; lead all ogres to Ogri\'la!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(20958,'crystal man','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20959,'Da $g king : queen;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20960,'$G King : Queen; $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20961,'Kneel dogs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20962,'$G Him : Her; look too pretty to be da ruler.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20963,'Mercy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20964,'Shh... quiet, it da new $g king : queen;.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20965,'$G Him : Her; so tiny!  How $g him : her; rule?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20966,'Me live to serve.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20967,'','You better wake up real quick, rookie.  This isn\'t our cushy backyard outside of Skettis; this is the Blade\'s Edge Mountains!  One false move and it\'s crash and burn!',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(20968,'Return to me when you are better prepared.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20969,'I\'ve lost my Essence-Infused Moonstone. Can you replace it?','I\'ve lost my Essence-Infused Moonstone. Can you replace it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20970,'I require your life essence to maintain my existence in this realm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20971,'It is yours my Lord!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20972,'Well now, you can find Farseer Javad in the area of The Great Forge, just a bit to the North on the East side.','Well now, you can find Farseer Javad in the area of The Great Forge, just a bit to the North on the East side.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(20973,'Shaman','Shaman',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20974,'Paladin','Paladin',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20975,'Master Pyreanor can be found among Thrall\'s advisors in his fortress, Grommash Hold, in the Valley of Wisdom.','Master Pyreanor can be found among Thrall\'s advisors in his fortress, Grommash Hold, in the Valley of Wisdom.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20976,'','Scary!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20977,'','Scary!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20978,'Ambassador Dawnsinger and I represent the Court of the Sun here in Orgrimmar.$B$BThe ambassador handles civil matters, while I advise Thrall on military campaigns and the unique, err... advantages conferred by the Blood Knights.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20979,'Instruct me further in the use of the naaru\'s power.','Instruct me further in the use of the naaru\'s power.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20980,'%s returns to stone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20981,'Symbols of Divinity? Check. Candles? Check. Arcane powder, uh... arcane powder? Oh, no! This is the last time I offer to pick up reagents for anyone. Is there a vendor around here?','Symbols of Divinity? Check. Candles? Check. Arcane powder, uh... arcane powder? Oh, no! This is the last time I offer to pick up reagents for anyone. Is there a vendor around here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20982,'Is there a mage around here? I\'m supposed to be bringing the food and water...','Is there a mage around here? I\'m supposed to be bringing the food and water...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20983,'The next person who asks me for a potion is getting a knuckle sandwich. I quit alchemy!','The next person who asks me for a potion is getting a knuckle sandwich. I quit alchemy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20984,'Boy, I could really use one of those gryphons right about now...','Boy, I could really use one of those gryphons right about now...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20985,'I can instruct you in jewelcrafting.  Interested?','I can instruct you in jewelcrafting.  Interested?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20986,'Why dis wall no stay up? Me keep banging but no good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20987,'Thank you for the summon, little one. My group left for the dungeon without me!','Thank you for the summon, little one. My group left for the dungeon without me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20988,'Why dis wall no go down? Wut doing?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20989,'Hey stupid! Why you banging wall? Wall go up not down! Stupid orc! Up! Up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20990,'','That was neat!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20991,'Awaken, my children and assist your master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20992,'Wut you want? Smell funny for fel orc...','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(20993,'You no make dis your home. Maybe you want eat someting?','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(20994,'What do you have for sale?','What do you have for sale?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20995,'Me want Gug fix armor. Maybe me buy someting.','Me want Gug fix armor. Maybe me buy someting.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20996,'Sometimes those damnable blood elves stop by and require some inane reagent or poison. I must keep my stock of such items full at all times lest Lord Illidan get word of the Dragonmaw not cooperating...$B$B<Rumpus swallows hard.>$B$BWe don\'t want that...','Sometimes those damnable blood elves stop by and require some inane reagent or poison. I must keep my stock of such items full at all times lest Lord Illidan get word of the Dragonmaw not cooperating...$B$B<Rumpus swallows hard.>$B$BWe don\'t want that...',1,1,274,0,0,0,0,0,1,0,0,0,26124),
(20997,'What do you have for sale, Rumpus?','What do you have for sale, Rumpus?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(20998,'OH YEA! You want a taste of these guns, maggot? Step on in!','',23,397,0,0,0,0,0,0,1,0,0,0,26124),
(20999,'How do you compete with these pythons? Ooooooh yaaaaa, brother!','',23,15,0,0,0,0,0,0,1,0,0,0,26124),
(21000,'You hear that? You hear that chantin\', brother? They\'re cheerin\' for the Rulkster!','',53,275,0,0,0,0,0,0,1,0,0,0,26124),
(21001,'What are you gonna do when Rulk-a-mania runs wild on you, brother????!','',5,397,0,0,0,0,0,0,1,0,0,0,26124),
(21002,'<The light surrounding Xi\'ri pulses blue.  The naaru welcomes you as an ally in the field of battle.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21003,'I am ready to join your forces in battle, Xi\'ri.','I am ready to join your forces in battle, Xi\'ri.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21004,'Check those crystals over there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21005,'You\'ve found nothing?  Very well.  Over there next.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21006,'That grouping looks promising.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21007,'Find what I am looking for and you may have a treat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21008,'I am beginning to suspect you are worthless.  Do not disappoint me further.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21009,'Yes, that\'s it.  These will do nicely.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21010,'$G Brother:Sister;, you are now considered bound by blood to the Netherwing. All of Netherwing will be behind you now! The time to strike at the heart of our enemies is now, friend! We must reclaim our lost heritage.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(21011,'You have done much for our cause, $n, but you may go no further until you have mastered flight. Only the most stalwart riders are able to assist the Netherwing.','',396,396,0,0,0,0,0,0,1,0,0,0,26124),
(21012,'Yes... cast your precious little spells, ak-a-ak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21013,'I would like to enter the secret code to receive my Golden Pig pet.','I would like to enter the secret code to receive my Golden Pig pet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21014,'Hail, $r. Were you lucky enough to have attended that recent special event?$B$BIf so, you may have learned a secret code. Tell me your code and I will give you a special prize in return.','Hail, $r. Were you lucky enough to have attended that recent special event?$B$BIf so, you may have learned a secret code. Tell me your code and I will give you a special prize in return.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21015,'Your magics shall be your undoing... ak-a-ak...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21016,'Your powers... ak-ak... turn against you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21017,'Your spells... ke-kaw... are weak magics... easy to turn against you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21018,'The ground begins to crack open!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21019,'Supremus punches the ground in anger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21020,'INVADERS! Let the mark of the Dragonmaw guide your anger! Slay $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21021,'','Are you gonna help?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21022,'You fool no one, $r. Even the magic of the Netherwing cannot hide you from the all-seeing gaze of the Skybreakers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21023,'Beware the Dragonmaw Skybreakers and ascendants as they are not fooled by our magic! Always keep your distance from those entities!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21024,'The Ogre clans will not be subjugated.  Not by the gronn, and not by a puny $r like you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21025,'Mog\'dorg is a fool to think that one of the smaller races will be our savior.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21026,'These mountains are for ogres.  Not for gronn, not for humans or orcs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21027,'Do not bow to Mog\'dorg\'s puppet!  He would replace our gronn overlords with a liege of lesser stock.  Why should we replace one master with another?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21028,'The time has come.  Strike down every creature that stands in the way of the clans!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21029,'Do not listen to Mog\'dorg\'s lies!  Ogri\'la is a myth!  We make our own heaven here with the blood of any that would divide and subjugate us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21030,'You must have wondered how it is that I can speak so clearly for an ogre.  It\'s a side effect of the crystals that grow on the terrace surrounding Ogri\'la.  The ogres there gifted me with this staff, and its crystal has in turn gifted me mentally.$B$BIt is through your continued actions, at Ogri\'la above, that I hope to one day be able to bring this boon to all of my ogre brethren.  You have my thanks, my $g king : queen;, for all that you have done and will do.','',396,396,0,0,0,0,0,0,1,0,0,0,26124),
(21031,'We are brothers.  And we will stand united against those who oppose our peace.','We are brothers.  And we will stand united against those who oppose our peace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21032,'Agh... me am...dead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21033,'Me go to... Ogri\'la.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21034,'Me honored... $g king : queen; kill me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21035,'$G King : Queen; $n, me die now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21036,'You are no stranger to the Legion, scum. Surely, you know what torment awaits you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21037,'We are in Ogri\'la.','We are in Ogri\'la.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21038,'We are in heaven.','We are in heaven.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21039,'We\'ve moved from bloodstained roads to roads illuminated by crystals.','We\'ve moved from bloodstained roads to roads illuminated by crystals.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21040,'Though the sounds of battle are still near, we also hear the song of these crystals.','Though the sounds of battle are still near, we also hear the song of these crystals.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21041,'Even with enemies at our door step, the light and song of the crystals have sustained us.','Even with enemies at our door step, the light and song of the crystals have sustained us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21042,'Here in Ogri\'la, we have reached a higher existence.  And we will keep it that way.','Here in Ogri\'la, we have reached a higher existence.  And we will keep it that way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21043,'Do you hear that brothers?','Do you hear that brothers?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21044,'Over the song of the crystals, do you hear the battle that is approaching?','Over the song of the crystals, do you hear the battle that is approaching?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21045,'Do you see our enemies?','Do you see our enemies?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21046,'They lurk nearby ready to strike.','They lurk nearby ready to strike.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21047,'Are we ready?','Are we ready?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21048,'The crystals have enlightened us brothers.  But we must still be on guard.','The crystals have enlightened us brothers.  But we must still be on guard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21049,'$G King : Queen; think... there really is... an Ogri\'la?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21050,'Puny $r... you were a... horrible $g king : queen;.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21051,'For honor, for mercy, for Gorefiend.  Forever.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21052,'Another one, eh? You\'ll never make it...','',397,5,0,0,0,0,0,0,1,0,0,0,26124),
(21053,'Just remember that you can only pick one gathering job to do per day. Aside from that, we\'re always looking for more crystals. Any worthless peon can bring those back to the base camp.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(21054,'My hounds shall feast on your corpse!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21055,'Your moment of defiance is nearly over!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21056,'Your soul is doomed! Our defenses are nearly armed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21057,'Shield defense arming. Executing in 30 seconds','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21058,'Shield defense arming. Executing in 20 seconds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21059,'Shield defense arming. Executing in 10 seconds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21060,'A fitting end for a traitor...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21061,'I got nothing new for you, kid. You\'ve outgrown manual labor...','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(21062,'Summoning','Summoning',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21063,'For the younglings! For the Horde!','For the younglings! For the Horde!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(21064,'For our children and the future of the Alliance! The Legion shall not prevail!','For our children and the future of the Alliance! The Legion shall not prevail!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21065,'%s doesn\'t seem to have had any luck finding raven stones nearby.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21066,'Behold the power... of the demon within!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21067,'%s shifts into the void...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21068,'Is this it, mortals? Is this all the fury you can muster?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21069,'Maiev... How is it even possible?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21070,'','Their fury pales before mine, Illidan. We have some unsettled business between us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21071,'','My long hunt is finally over. Today, Justice will be done!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21072,'Greetings, $c. I trust that you bring me good news concerning the Worldwide Invitational event? If you are, then surely that means you were given a secret code to tell me. In return for your code I will give you a gift of one of the golden pigs that I take care of.$B$BJust whisper it in my ear when you are ready.','Greetings, $c. I trust that you bring me good news concerning the Worldwide Invitational event? If you are, then surely that means you were given a secret code to tell me. In return for your code I will give you a gift of one of the golden pigs that I take care of.$B$BJust whisper it in my ear when you are ready.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21073,'I would like to whisper my secret code to you to receive my Golden Pig pet.','I would like to whisper my secret code to you to receive my Golden Pig pet.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21074,'%s fixates on $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21075,'%s\'s flesh shatters in an unearthly rage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21076,'Consume $n, my children!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21077,'%s focuses on $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21078,'Illidan\'s grasp over my tribe is strong, $n. It shall all be over soon, one way or another.$B$BAre you ready, $n?  My people\'s future depends on us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21079,'I\'m with you, Akama.','I\'m with you, Akama.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21080,'SKYGUARD SCOUT!!','SKYGUARD SCOUT!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21081,'%s spills his beverage.','%s spills her beverage.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21082,'%s cleans up the mess while muttering curses about the Skyguard hotshot pilots.','%s cleans up the mess while muttering curses about the Skyguard hotshot pilots.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21083,'The elixir... give it to me, Severin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21084,'I see them now... assassins from Skettis!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21085,'You will die in the name of Lady Vashj!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21086,'The arakkoa can send all the assassins they have... they will meet the same fate as these!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21087,'Blood... will... flow!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21088,'Be\'lanen dalorai!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21089,'Stick around...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21090,'I\'ll deal with you later.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21091,'Your success was short-lived!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21092,'Time for you to go.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21093,'Lord Illidan will... crush you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21094,'Is this... blood in my lungs?  If I don\'t die to an assassin\'s blade, it\'ll be my old injuries that get me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21095,'Bal, lamer zhita!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21096,'My patience has run out! Die! Die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21097,'Vengeance is mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21098,'I was the first you know. For me the wheel of death has spun many times. So much time has passed... I have a lot of catching up to do. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21099,'I have use for you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21100,'It gets worse.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21101,'Death really isn\'t so bad.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21102,'What are you afraid of?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21103,'Give in.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21104,'I have something for you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21105,'You will show the proper respect!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21106,'The wheel... spins... again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21107,'<TXT>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21108,'%s cheers!','%s cheers!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21109,'%s is disgusted!','%s is disgusted!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21110,'%s roars!','%s roars!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21111,'What manner of deception is this!? Who turns my underlings against me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21112,'Get to work on those crystals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21113,'These crystals will work.  Get them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21114,'Move it!  These crystals aren\'t going to collect themselves.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21115,'You\'ve ruined this batch!  Why must I work with you worthless Gan\'arg.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21116,'At least you didn\'t screw this batch up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21117,'I can\'t believe you\'ve actually done something right for once.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21118,'Time for eating!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21119,'Mmmm! FOOD!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21120,'Me so hungry! YUM!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21121,'It put the mutton in the stomach!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21122,'Hey... me not feel so good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21123,'You is bad orc... baaad... or... argh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21124,'Test.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21125,'I am a Conqueror.','I am a Conqueror.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21126,'I am a Justicar.','I am a Justicar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21127,'','You\'re not yet advanced enough to properly follow anything I might have to show you. I highly suggest you hone your crude skills with the sluggish stylings of Gloresse here before speaking with me.',274,1,0,0,0,0,0,0,1,0,0,0,26124),
(21128,'','Let\'s get to business, $n. I\'ll show you what I know, but keep up.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21129,'You cannot withstand the power of my forces!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21130,'Peer inside the warp-gate if you dare. I\'ve prepared something special for you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21131,'Skettis prevails!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21132,'Adaris!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21133,'Rest now, friend.  You need your strength.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21137,'You cannot escape your fate, traitor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21138,'You\'re not going anywhere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21139,'Get back here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21140,'Traitor! You\'ve struck the shield! Your fate is sealed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21141,'Mog\'dorg, me know stuff you want to know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21142,'Me back, boss.  Me tell you wut me know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21143,'Da gronn not know nothing, Mog\'dorg.  Me sure them not know \'bout da plan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21144,'Me hear lots of stuff goin\' on.  We kill gronn soon?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21145,'Mog\'dorg, me not tell no one \'bout cov... cov... cov... secret plan against da gronn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21146,'Me check with other ogres.  Them\'s ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21147,'Okay, me go now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21148,'Your pathetic efforts shall yield you nothing but pain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21149,'You have done well.  The information you are providing is critical to our success.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21150,'Thank you, friend.  Soon, we will be free of our slavery to the gronn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21151,'Excellent.  The work that you do now will allow us to join our brethren in Ogri\'la, above, one day.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21152,'Those that speak to me from on high in Ogri\'la will be most pleased with the information that you bring.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21153,'This is good news; our covert operation against the gronn proceeds as planned.  And, there is someone on the outside helping us now, too.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21154,'Our underground movement against the gronn must not falter!  Return and gather more information.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21155,'Good.  If all goes as planned, we will soon be free of the gronn.  Then all of the ogres of the mountains will be able to enjoy the enlightened blessings of the ogres from Ogri\'la.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21156,'One day soon, my friend, you will carry an Ogri\'la crystal, as I do.  Then you will come to a greater understanding of the world around you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21157,'Yes, unless I have anything to do with it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21158,'I see that happening sometime between tomorrow and the next decade. Definitely.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21159,'Indeeeeed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21160,'Looks good for you...and bad for me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21161,'I\'ve consulted my fellow imps, and we think YES, except for that one imp.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21162,'The outlook is positive, but I\'m still negative.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21163,'It pains me to say this, but \"Yes\".','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21164,'When dwarves fly! They do? Then yes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21165,'Sure, but you\'re not going to like it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21166,'Be quiet \'bout what you hear and see around here, $r.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21167,'Da $g king : queen;!  Chort ready to serve.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(21168,'Grok hear dat yous da new $g king : queen; of all da ogres.  Congrat... congratu... gratz, little $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21169,'Unfortunately... yes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21170,'I can\'t see why not, although, I can\'t see a lot of things right now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21171,'I would bet your soul on it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21172,'Yes, but if anyone asks... It wasn\'t me who told you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21173,'Didn\'t you already ask that once? Yes already!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21174,'Ruk!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21175,'Please... Is Kil\'jaeden red?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21176,'Yeah, sure. You just keep thinking that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21177,'I suppose.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21178,'Definitely.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21179,'Jump three times and dance for ten minutes and it will definitely happen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21180,'Word on the peninsula is YES!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21181,'Oh, that one\'s for sure.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21182,'Yes, but not in the way you imagine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21183,'Yes, yes, a thousand times, yes already!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21184,'Yes, now stop pestering me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21185,'The answer will be a yes if you let me out of here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21186,'It\'s as sure as the warts on my backside!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21187,'The answer is yes in here, I don\'t see why it would be any different out there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21188,'Three words - \"ab - so - lutely\"!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21189,'Yes, but I hoped I would never have to answer that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21190,'Ask me again later - I\'m trying to scratch my nose and it\'s hard to concentrate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21191,'Why should I answer that?  Do you tell fortunes when people shake YOU?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21192,'Yes, it will rain.  That\'s not what you asked?  Too bad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21193,'I\'m sorry, I can only speak Demonic.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21194,'Yes!  I mean no!  I mean... which answer gets me out of here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21195,'Yes, No, Maybe so.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21196,'It won\'t matter, you\'ll be dead by tomorrow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21197,'You should be asking \"Is that rogue behind me going to kill me?\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21198,'It\'s times like these that I wish I had a longer cooldown.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21199,'%s shrugs. Who knows?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21200,'I ask myself that question everyday...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21201,'Thank you, friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21202,'You honor us, friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21203,'These things that you do for Netherwing do not go unnoticed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21204,'An ally always!','',0,0,0,0,0,0,0,11,1,0,0,0,26124),
(21205,'It\'s like my mother always said: [Demonic] \"Razxx khaj jhashxx xashjx.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21206,'%s is ignoring you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21207,'Why me?  Why not a goblin, or a gnome...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21208,'What happens in the twisting nether, stays in the twisting nether.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21209,'Avoid taking unnecessary gambles. Your lucky numbers are two, two and half, and eleven-teen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21210,'Wouldn\'t you like to know?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21211,'Oh, oh, oh!  I can see this one clearly...  Nah, lost it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21212,'This was NOT in my contract!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21213,'XRA RAHKI MAZIZRA!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21214,'4 8 15 16 23 42','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21215,'Are you making fun of me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21216,'What kind of imp do you think I am?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21217,'Say please.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21218,'Want to trade places?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21219,'Do you ask this question to everything that\'s trapped in a ball?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21220,'Hey! You try arranging furniture with some jerk shaking your house!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21221,'I can make that happen. Just sign below the dotted line...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21222,'Reply hazy and slightly damp. Dry thoroughly and try again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21223,'Concentrate (on releasing me from this infernal prison) and try again later.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21224,'Please insert 25 silver pieces and try again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21225,'Are you my pal, Danny?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21226,'You remember the time you tried to drill that hole in your head?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21227,'Oh that\'s right, don\'t make any effort to make your own fortune!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21228,'Two words - imp-possible!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21229,'You need Arcane Intellect, because that answer is obvious!  NO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21230,'Not on your life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21231,'I don\'t have to be a fortune-telling imp to know the answer to that one - NO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21232,'The odds are 32.33 (repeating of course) percent chance of success.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21233,'When Blackrock freezes over!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21234,'Hahahaha, you\'re kidding right?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21235,'Inconceivable!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21236,'My sources say \"no\". Before the torture, that is.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21237,'That\'s about as likely as me getting out of this ball.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21238,'You picked the wrong time to shake me today, buddy!  Prepare for disappointment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21239,'Not unless you\'re some kind of super-person.  And don\'t kid yourself, you\'re not.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21240,'That\'s about as likely as me getting a date with a succubus.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21241,'My fortune telling powers are immeasurable - your chances are though: NO CHANCE','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21242,'NO - and don\'t try shaking me again for a better answer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21243,'Yes is my answer...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21244,'...NOT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21245,'I\'m gonna have to give this one the big N-O.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21246,'The outlook is very bad - for YOU that is!  Haha, take it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21247,'Survey says: BZZZT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21248,'Very well, intruder. You have earned my undivided attention...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21249,'Behold! I\'ve reserved my favorite pets for just such an occasion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21250,'I will deal with these mongrels! Strike now, friends! Strike at the Betrayer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21251,'Come, my minions. Deal with this traitor as he deserves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21252,'I will not be touched by rabble such as you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21253,'I submit! You win this time...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21254,'Good fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21255,'You see that final blow! Awesome!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21256,'Kill him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21257,'Weak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21258,'Finish him off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21259,'Filthy animals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21260,'%s lets out a shrill shriek, calling for help from a nearby kaliri.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21261,'%s appears to be speaking with an unseen entity.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21262,'Throwing grenade!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21263,'Baby Gorilla Pet','Baby Gorilla Pet',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21264,'Now me grow bigger and crush you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21265,'Imp in a Ball','Imp in a Ball',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21266,'Picnic Basket','Picnic Basket',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21267,'How long must we wait?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21268,'One day, we will rule this dark temple.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21269,'I must feed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21270,'OH, IT\'S ON NOW $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21271,'','Stupid grenade picked a fine time to backfire! So much for high quality goblin engineering!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21272,'Fortune be with us!  To the skies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21273,'','I have a proposal for you, $r.  Please consider your choices carefully - your decision cannot be easily reversed.$B$BIt is time we formalized your allegiance to our organization.  I must know in what capacity you wish to serve us so that we may reward you appropriately.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21274,'Foolish Akama, your mortal time has expired....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21275,'Behold the Flames of Azzinoth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21276,'Our studies are complete!  Well fought!  Headquarters will pour over our gained measurements and, with luck, uncover the Bash\'ir\'s intentions.  Now, to the skies!','Our studies are complete!  Well fought!  Headquarters will pour over our gained measurements and, with luck, uncover the Bash\'ir\'s intentions.  Now, to the skies!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21277,'I hired Galana specifically to deal with rudimentary training. Go speak with her. This shop is meant to be run efficiently and effectively, and I expect everyone - including the patrons - to respect it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21278,'Welcome to Keelen\'s Trustworthy Tailoring. I think you\'ll find my shop will suit your needs. If you wish to train with me, you need only ask; I\'ll be more than happy to teach you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21279,'How can I help you, $c?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21280,'Show me what you have for sale.','Show me what you have for sale.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21281,'The pile of skulls reeks of foulness.  You fear the arakkoa have made an addition to the pile fairly recently.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21282,'<Call forth Gezzarak the Huntress.>','<Call forth Gezzarak the Huntress.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21283,'Now you shall witness the meaning of true power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21284,'','If you\'re looking for gadgets, doodads, thingamajigs, widgets, whatsis, dohickeys, or gizmos, you\'ve come to the right place!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21285,'Show me your assortment of, err... things.','Show me your assortment of, err... things.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21286,'The forge needs additonal tuning.  Look into it, slave!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21287,'<Call forth Vakkiz the Windrager.>','<Call forth Vakkiz the Windrager.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21288,'<Call forth Karrog.>','<Call forth Karrog.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21289,'<Call forth Darkscreecher Akkarai.>','<Call forth Darkscreecher Akkarai.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21290,'You look familiar...','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(21291,'Your bones shall make ideal playthings for my hound.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21292,'My sight is filled with visions of events taking place throughout the world and ones that may yet happen. Many of them are grim, but we needn\'t believe they are incapable of changing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21293,'If you need reagents, you\'ve come to the right place. You won\'t find a finer selection in all of Shattrath.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21294,'Show me what you have for sale.','Show me what you have for sale.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21295,'Drinking','Drinking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21296,'I gotcha boss!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21297,'I\'m coming, boss!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21298,'Looks like that hurt!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21299,'Repair module activated!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21300,'Who... Who is you?? What you want?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21301,'','Step aside lest I add you as another adornment to my armor. Your leader and I have matters to attend...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21302,'Yes... Yes we move now... Please no hurt us...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21303,'','%s smiles.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21304,'','I thought you would see it my way...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21305,'','Overlord Mor\'ghor, I presume... A pleasure to finally make your acquaintance. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21306,'','I am Lady Sinestra.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21307,'I will not drag this out any further than it needs, Lady Sinestra. You have bent my ear, now tell me what it is that you want from Dragonmaw.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21308,'','You have no doubt heard about Nefarian\'s failures on Azeroth... While he has fallen, the experiments continue. My master... He continues the work that his progeny began.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21309,'','%s nods.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21310,'The... The master? He lives?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21311,'','You were once a chief lieutenant, Mor\'ghor. Your work in Grim Batol is not easily forgotten.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21312,'','Now... We need the eggs that you recover. The Netherwing eggs. They are, after all, a product of the master. We will pay whatever price that you ask.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21313,'%s stammers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21314,'Ye... Yes, yes... Of course. We need only the crystals and ore from this place. There is... We will need mounts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21315,'','The master will be most pleased with this news. The Black Dragonflight will provide you all that you ask. You will be allowed to ride upon the backs of our drakes as needed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21316,'','I thank you for your graciousness, Mor\'ghor. I must now take my leave.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21317,'','%s falls to the floor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21318,'I\'m not finished with you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21319,'You\'ll never leave here alive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21320,'Just chill!','Just chill!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21321,'<Mudlump is polishing his boots.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21322,'Your skill is notable, $c, and I believe the time has come for you to vacate the premises. If you wish to expand your horizons, visit Josef Gregorian in the Undercity.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21323,'','You\'ve sufficiently advanced in the field to be beyond my ability to teach. I hear there\'s a skilled engineer named Roxxik in the stinking pit of a city they call Orgrimmar who might be able to train you.',274,1,0,0,0,0,0,0,1,0,0,0,26124),
(21324,'Me no work no more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21325,'Work is da poop! NO MORE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21326,'I am da powerful! Nobody tell me what to do!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21327,'Show me what you\'re made of, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21328,'%s becomes enraged as his shield shatters.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21329,'Hah! You\'ve unleashed my pet! Your soul shall be its next meal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21330,'Stand at attention, grunt!','',397,0,0,0,0,0,0,0,1,0,0,0,26124),
(21331,'OWWWW! Ok, ok, me go back to work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21332,'HEY! No more booterang! Me sorry! Me work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21333,'OOF! Booterang hurted me! Me tink work better den booterang!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21334,'WHY IT PUT DA BOOTERANG ON DA SKIN?? WHY??','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21335,'ARGH! BOOTERANG!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21336,'AYAYA! One day me have dat booterang...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21337,'Whoever you are, trespasser, I shall make an example of you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21338,'Such arrogance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21339,'You over there!  I must speak with you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21340,'A thousand curses upon you, $r!  This prison will not hold me for long!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21341,'You have nowhere to run, coward!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21342,'Broken of the Ashtongue tribe, your leader speaks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21343,'The Betrayer no longer holds sway over us.  His dark magic over the Ashtongue soul has been destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21344,'Come out from the shadows!  I\'ve returned to lead you against our true enemy!  Shed your chains and raise your weapons against your Illidari masters!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21345,'I lost my booterang, Mudlump. I think it may have malfunctioned and is now stuck up the backside of a worthless peon.','I lost my booterang, Mudlump. I think it may have malfunctioned and is now stuck up the backside of a worthless peon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21346,'Get lost before I beat you with my booterang.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(21347,'[DEBUG] Cast spell on me [DEBUG]','[DEBUG] Cast spell on me [DEBUG]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21348,'Hail Akama!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21349,'Try and keep up, grunt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21350,'Hail our leader!  Hail Akama!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21351,'Take of my life\'s essence, master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21352,'%s becomes increasingly enraged as he sees his allies fall in battle!','%s becomes increasingly enraged as he sees his allies fall in battle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21353,'Stop your slacking and fight like a true fel orc!','Stop your slacking and fight like a true fel orc!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21354,'I\'ve seen female Gnomes hit harder than you!','I\'ve seen female Gnomes hit harder than you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21355,'You call that an offense? I\'ve seen more offensive tallstriders!','You call that an offense? I\'ve seen more offensive tallstriders!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21356,'If you don\'t start throwing some real punches, you\'ll be cleaning the drake stalls for a year!','If you don\'t start throwing some real punches, you\'ll be cleaning the drake stalls for a year!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21357,'','Stop toying with my emotions!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21358,'Oh, ye like me eyepatch now do ya?  Well, just make sure that ya don\'t have ta be wearing one yerself now $g boyo : girly;.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(21359,'','Huh?  What?  I\'m a little busy here, friend!$B$BOf course, if you\'re here to help, I\'ve got all the time in the world.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21360,'Debug Error: Out of Range','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21361,'%s approaches and waits quietly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21362,'I may be old but I can still take on a young whippersnapper like you, $n. Try not to fall behind...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21363,'Well, you won... I guess.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21364,'%s calls for an ally to assist him!','%s calls for an ally to assist her!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21365,'%s rushes away to attack $n!','%s rushes away to attack $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21366,'The %s appears ready to be wrangled.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21367,'The crystal prison begins to shatter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21368,'The Skyguard are here! The Skyguard are here!','The Skyguard are here! The Skyguard are here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21369,'Woo hoo! Go Skyguard!','Woo hoo! Go Skyguard!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21370,'','Wow!  Thanks for bringing it all the way back here.  You didn\'t have to do that.',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(21371,'','You\'re a peach!  I\'ll make sure that the ray is properly cared for.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21372,'','Thank you soooooo much for bringing it back.  I think you\'re going to be my best wrangler ever!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21373,'','Oh, isn\'t she a beauty!  Can\'t wait to get her properly trained and back up in the air!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21374,'','Isn\'t he so cute?!  Thanks for bringing him right to me!!!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21375,'','We never have enough of these rays for the Skyguard.  You\'re keeping us afloat... literally!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21376,'','Nice job!  She looks like she\'s in fine condition.  Thank you!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21377,'','Woo hoo!  More rays for training!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21378,'How dare you summon me, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21379,'Burning eyes within the prism fill your mind with a sense of dread...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21380,'Place 35 Apexis Shards into the prism.','Place 35 Apexis Shards into the prism.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21381,'The fel crystalforge can be used to transform your apexis shards into unstable flasks of the beast.  These flasks make the imbiber more agile, stronger and heartier.$B$BMake your choice, below.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21382,'Purchase 1 Unstable Flask of the Beast for the cost of 10 Apexis Shards','Purchase 1 Unstable Flask of the Beast for the cost of 10 Apexis Shards',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21383,'<As you place your apexis shards into the fel crystalforge and pull the lever, the device makes an unworldly sound as it grinds them into dust.  A few moments later your flask pops out of its \'mouth\'.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21384,'Use the fel crystalforge to make another purchase.','Use the fel crystalforge to make another purchase.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21385,'Purchase 5 Unstable Flasks of the Beast for the cost of 50 Apexis Shards','Purchase 5 Unstable Flasks of the Beast for the cost of 50 Apexis Shards',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21386,'<As you place your apexis shards into the fel crystalforge and pull the lever, the device makes an unworldly sound as it grinds them into dust.  A few moments later your flasks pop out of its \'mouth\'.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21387,'The Bash\'ir crystalforge can be used to transform your apexis shards into unstable flasks of the sorcerer.  These flasks make the imbiber more intelligent, heartier, and increase the effectiveness of their damaging and healing magics.$B$BMake your choice, below.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21388,'Purchase 1 Unstable Flask of the Sorcerer for the cost of 10 Apexis Shards','Purchase 1 Unstable Flask of the Sorcerer for the cost of 10 Apexis Shards',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21389,'Use the Bash\'ir crystalforge to make another purchase.','Use the Bash\'ir crystalforge to make another purchase.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21390,'<As you place your apexis shards within the hollow of the Bash\'ir crystalforge and pull the lever, the device literally disintegrates them.  A few moments later your flask appears at your feet.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21391,'Purchase 5 Unstable Flasks of the Sorcerer for the cost of 50 Apexis Shards','Purchase 5 Unstable Flasks of the Sorcerer for the cost of 50 Apexis Shards',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21392,'<As you place your apexis shards within the hollow of the Bash\'ir crystalforge and pull the lever, the device literally disintegrates them.  A few moments later your flasks appear at your feet.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21393,'We hope you\'ll be able to ease our headaches.  You try having ten sons, all of them wanting to do something they weren\'t meant for!$B$BStill, as a father, we do what we must.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21394,'Do you have any sons, $c?$B$BLet us tell you something, we think we were much happier before we came to Ogri\'la and the crystals made us more aware.  Before, we would have just bashed them over the head to get them to shut up.  Now all they do is bother us about the Sha\'tari Skyguard.$B$BIgnorance is bliss!','',6,15,0,0,0,0,0,0,1,0,0,0,26124),
(21395,'The boy\'s too stupid still to say it -- not enough crystal exposure yet -- but, he\'s thankful for what you did in getting him those flasks.$B$BNow, only nine more sons to go.  Gah!$B$B<Both of Torkus\'s heads sigh.>$B$BWant to take one of them off of our hands?  We\'ll sell him to you cheap.','',1,5,6,0,0,0,0,0,1,0,0,0,26124),
(21396,'As a relative newcomer to Ogri\'la, you don\'t have enough exposure to the crystals here to reap their full benefits.  Besides, you only have one head.$B$BWe, on the other hand, have been here a very long time.  So, as you can imagine, we\'re fairly well-versed in a great many things.$B$BOf late, we\'ve taken a keen interest in the demons of the forge camps.  More specifically, we\'ve devised a way to rid us of them for good.$B$BAt least, that\'s the theory.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(21397,'We wish that we could create more than one darkrune in a day, but that would be a waste of time.  It\'s simply not physically possible.  Besides, we can\'t even reliably create them at that rate.$B$BAnd trust us, if there were anyone else here smart enough to help, they\'d be conscripted and we\'d have as many darkrunes as needed.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(21398,'The Bash\'ir crystalforge can be used to transform your apexis shards into unstable flasks of the sorcerer.  These flasks make the imbiber more intelligent, heartier, and increase the effectiveness of their damaging and healing magics.$B$BIt appears, however, that you do not have the requisite ten shards to purchase even a single flask.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21399,'The fel crystalforge can be used to transform your apexis shards into unstable flasks of the beast.  These flasks make the imbiber more agile, stronger and heartier.$B$BIt appears, however, that you do not have the ten shards necessary to purchase even a single flask.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21400,'Opening','Opening',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21401,'Gahk new at Ogri\'la like little $r.  It like heaven da other ogres below always talk about.  But, Gahk\'s heads hurt from crystal making Gahk smarter.$B$B<Both of Gahk\'s heads nod to each other.>$B$BUs learning ta make da crystalforged darkrune.  When us learn dat, we smash da demon\'s warp-gate!','',1,15,0,0,0,0,0,0,1,0,0,0,26124),
(21402,'Gahk now smart!  Us know how ta make da darkrune into da crystalforged darkrune!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21403,'$n smash warp-gate good, but da demons make it strong again.$B$B$n bring Gahk another darkrune and Gahk make special crystalforged darkrune for $n!','',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(21404,'Welcome to Ogri\'la, $c.$B$BThe ogres here have managed to gain a great mental acuity through the magical emanations of the surrounding crystals.  Though we do not fully understand how they work, we have come to appreciate our new home and only want to live in peace.$B$BUnfortunate then that the demons and ethereals, and especially the Black Dragonflight, will not leave us to that peace.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(21405,'On behalf of all of Ogri\'la, we give you thanks for your efforts, $n.$B$B<Chu\'a\'lor\'s left head nods while his right head smiles at you.>$B$BAnd do not forget that by helping us here you are also helping to protect our brethren down below whom you have become like a $g king : queen; to.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(21406,'When are we going to get some more magical flasks?','When are we going to get some more magical flasks?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21407,'Have we taken enough magical flasks to join the Skyguard yet?','Have we taken enough magical flasks to join the Skyguard yet?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21408,'The Skyguard need our help! We need to get more magical flasks.','The Skyguard need our help! We need to get more magical flasks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21409,'We can\'t wait to join the Skyguard. We just need to take a few more magical flasks, right?','We can\'t wait to join the Skyguard. We just need to take a few more magical flasks, right?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21410,'You don\'t. You\'re not strong enough to participate in ranking matches yet. Still, you can find an Arena Battlemaster and get in some practice rounds. It\'s never too soon to start training.','You don\'t. You\'re not strong enough to participate in ranking matches yet. Still, you can find an Arena Battlemaster and get in some practice rounds. It\'s never too soon to start training.',1,0,0,1,0,0,0,0,1,0,0,0,26124),
(21411,'Look it\'s the Skyguard!!','Look it\'s the Skyguard!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21412,'Have you come to hurt me?  I have nothing to do with the war, $r.$B$BI\'m just a sickly scholar, please leave me alone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21413,'The egg appears resilient as an egg of the Black Dragonflight rightfully should.  Perhaps if you were to place a great many apexis shards next to it, their vibrations would cause it to crack open?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21414,'The egg appears resilient as an egg of the Black Dragonflight rightfully should.  Perhaps if you were to place a great many apexis shards next to it, their vibrations would cause it to crack open?$B$BToo bad that you don\'t appear to have the thirty-five apexis shards necessary to do the job.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21415,'Place 35 Apexis Shards near the dragon egg to crack it open.','Place 35 Apexis Shards near the dragon egg to crack it open.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21416,'<As you place the apexis shards into the nest surrounding the dragon egg, they begin to hum.  A few moments later a crack appears in the rugged shell, and a black dragon whelpling emerges, squalling for its mother.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21417,'','<Angela coos to the felhunter again before turning her attention to you.>$B$BJir\'see\'s always been smaller than all the other felhunters, but that\'s never bothered him. And Outland\'s going to change all that, right Jir\'see?$B$BMomma\'s little angel is going to grow up to be a big, fierce felhunter, yes he is!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21418,'Trope will show you how to fly like a Dragonmaw... You will show Trope how to die like a scrub.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21419,'You did well. Certainly a surprise to Trope... Report back to Ja\'y.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21420,'The %s screams out for its mother.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21421,'Let\'s get this over with...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21422,'You put up a hell of a fight, newbie. Hell of a fight...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21423,'I\'m taking this back to the old school. I\'ll be the Alliance and you be Frostwolf Village. BOMBS AWAY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21424,'Thank you for that... It was humbling to be served in such a manner.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21425,'You\'re in for a rough ride, $n. I hope you\'ve already made funeral arrangements.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21426,'You\'re the best I\'ve ever seen. I can\'t believe I\'m saying this but you might have a chance against Skyshatter. And hey, if that doesn\'t go so well you can be my wing man...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21427,'The %s screams out for its father.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21428,'<As you place the apexis shards into the nest surrounding the dragon egg, they begin to hum.  A few moments later a crack appears in the rugged shell, and a black dragon whelpling emerges, squalling for its father.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21429,'MULVERICK!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21430,'Prepare a funeral pyre! $n has challenged Skyshatter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21431,'I... I am undone... The new top orc is $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21432,'I weep for you, $n. You really have no idea what you\'ve gotten yourself into...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21433,'The Cenarion Expedition rescued me from certain death inside the mines. I owe them my life! I offer up my services of repair and reagent sales to those that are allies of the Cenarion Expedition.','',396,1,0,0,0,0,0,0,1,0,0,0,26124),
(21434,'I am an ally of the Cenarion Expedition, Mortog. Show me your wares.','I am an ally of the Cenarion Expedition, Mortog. Show me your wares.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21435,'It has been a long while since I fought a worthy adversary...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21436,'Now you shall witness the meaning of true power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21437,'They did it!  Enemy down!  Return to base!','They did it!  Enemy down!  Return to base!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21438,'Abort mission!  Our ground forces have been defeated.','Abort mission!  Our ground forces have been defeated.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21439,'Enemy sighted!  Fall into formation and prepare for bombing maneuvers!','Enemy sighted!  Fall into formation and prepare for bombing maneuvers!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21440,'You\'ll find plenty to do here, $n.','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(21441,'Battle Stance! Prepare for an offensive rush!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21442,'Ack, ye\'ve been busy now haven\'t ye?!  I canna thank ye enough for bombing them demons and resupplying us with mounts.$B$BYer making our job all the more easier.  Keep up the good work, $g laddy : lassie;!','',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(21443,'Berserker Stance! Attack them recklessly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21444,'Defensive Stance! Shield yourself against their blows and strike back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21445,'Now that the flasks are ready, we can show the Skyguard our moves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21446,'Watch out, Skyguard. Here comes Torkus Jr.!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21447,'Commander, sir! Cadet Torkus Jr. reporting for duty, sir!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21448,'Look here, lad. I admire your dedication, but I\'m not sure how to tell you this... You\'re an ogre, son.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21449,'Yes, sir. An ogre, sir. But give us a chance, sir! We\'ve been preparing for this since the first time the Skyguard flew over Ogri\'la, sir!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21450,'%s makes a gesture of dismissal and heads for the launch pad.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21451,'%s cowers in fear as it realizies what the ogre has in mind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21452,'','We must re-establish our stranglehold on these mines!',5,396,0,0,0,0,0,0,1,0,0,0,26124),
(21453,'<The Murkblood overseer grunts.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21454,'They sent you to kill me, eh? So predictable... Creatures ruled by terror are all the same.$B$BBut you... You are not one of them...','',6,274,0,0,0,0,0,0,1,0,0,0,26124),
(21455,'I am here for you, overseer.','I am here for you, overseer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21456,'How dare you question an overseer of the Dragonmaw!','How dare you question an overseer of the Dragonmaw!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21457,'Overseer?$B$BYou are no more an overseer than I am the king of Stormwind. Yes... You are the one they speak of.','',6,396,273,0,0,0,0,0,1,0,0,0,26124),
(21458,'The Netherwing. They speak to us. They offered us peace and protection. Something the broken have never truly felt. We accepted their offer and assisted Toranaku in rousing the creatures of this mine - at great personal cost to us. Many of my brothers gave their lives for this offensive. We were attempting to make the mine uninhabitable, forcing the Dragonmaw to relocate and ultimately move off of this island.','',396,396,396,0,0,0,0,0,1,0,0,0,26124),
(21459,'Who speaks of me? What are you talking about, broken?','Who speaks of me? What are you talking about, broken?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21460,'Continue please.','Continue please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21461,'The Dragonmaw are corrupt. They are strip-mining this island of all natural resources and using those resources to supply Illidan\'s armies out of the Black Temple. They take much for themselves, however, and sell whatever they have hidden away to the highest bidder.','',396,396,0,0,0,0,0,0,1,0,0,0,26124),
(21462,'Who are these bidders?','Who are these bidders?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21463,'We do not know. We believe that the Black Dragonflight is involved as are some independent third parties. That is why you are here, $r. You will unravel this mystery from the inside and bring redemption to Netherwing.$B$BAnd now... I can only assume she asked you to bring back my hand.','',274,396,0,0,0,0,0,0,1,0,0,0,26124),
(21464,'Well... yes.','Well... yes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21465,'I gladly make such a sacrifice if it means the downfall of the Dragonmaw.','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(21466,'Aargh! If I must fall, I\'m taking you with me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21467,'No, lad, not Bronco! He\'s not been broken yet! You\'ll get yerself killed up there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21468,'Bronco bucks %s from its back and escapes into the wild!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21469,'Dreadmaw! You shall pay dearly, trespasser...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21470,'I must leave this place at once!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21471,'[DEBUG] THEN LET\'S GO!','[DEBUG] THEN LET\'S GO!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21472,'Bronco? That sounds like a good one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21473,'I don\'t think yer hearin\' me. Nether rays just aren\'t made for --','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21474,'The Apexis Relic shimmers, betraying a hidden intelligence within.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21475,'Insert an Apexis Shard, and begin!','Insert an Apexis Shard, and begin!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21476,'Come back, Mr. Bronco! We\'re gonna be in the Skyguard together!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21477,'The Apexis Monument looms above you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21478,'Insert 35 Apexis Shards, and begin!','Insert 35 Apexis Shards, and begin!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21479,'Thank you for helping us with the flasks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21480,'No disturbances!  Zero tolerance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21481,'Thanks for your help.  Let\'s get out of here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21482,'%s hisses loudly at Torkus Jr.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21483,'Stand at attention, captain!','',113,0,0,0,0,0,0,0,1,0,0,0,26124),
(21484,'Let\'s keep moving.  I don\'t like this place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21485,'Thanks again.  Sergeant Doryn will be glad to hear he has one less scout to replace this week.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21486,'Burning eyes within the prism fill your mind with a sense of dread... especially knowing that you don\'t have the thirty-five apexis shards needed to summon forth its demon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21487,'I am ready to take on my challenger! Call him out!','I am ready to take on my challenger! Call him out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21488,'Nonsense!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21489,'','That is for Naisha!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21490,'You\'ll go nowhere, Skyguard scum!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21491,'Skettis prevails!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21492,'No one escapes Skettis!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21493,'Death to our enemies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21494,'The door to The Den of Mortal Delights has opened.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21495,'Skwak!','Skwak!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21496,'You\'re a young hatchling aren\'t you?  My eyes fail me.$B$BI assume you\'re here to purchase one of my exotic texts?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21497,'Stare into the eyes of the Betrayer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21498,'This is too easy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21499,'Who shall be next to taste my blades?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21500,'You know nothing of power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21501,'Feel the hatred of ten thousand years!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21502,'The controller can be used to activate the linked proton accelerator.  This will call forth one of Bash\'ir\'s harbingers, or perhaps Bash\'ir himself.$B$BAssuming, of course, that you have an accelerator module to activate the device.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21503,'The controller can be used to activate the linked proton accelerator.  This will call forth one of Bash\'ir\'s harbingers, or perhaps Bash\'ir himself.$B$BUnfortunate that you do not possess an accelerator module to activate the device.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21504,'Power the proton accelerator with an Accelerator Module to summon Bash\'ir, or one of his harbingers.','Power the proton accelerator with an Accelerator Module to summon Bash\'ir, or one of his harbingers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21505,'<Placing the requisite accelerator module within the space on the controller, you give it a final pull.  The module glows for a moment and its power is consumed as the device hums to life.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21506,'You have won... Maiev. But the huntress... is nothing without the hunt. You... are nothing... without me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21507,'','It is finished. You are beaten.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21508,'','He\'s right. I feel nothing... I am... nothing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21509,'','Farewell, champions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21510,'Next time, show me the respect of at least being prepared!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21511,'Pitiful!  I will rend the flesh from your bones and wrack your soul for my pleasure!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21512,'Did you really think that you could fool my master into falling for your sad, little trap, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21513,'Fools!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21514,'The Light will bless these dismal halls once again.... I swear it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21515,'Forget Vixton\'s spread. You want the good stuff? You talk to Krixel here. I got just what you need, provided you got the right rep. You know, in the arena. This stuff isn\'t for sissies, kid.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21516,'I wish to queue for the Coliseum, Rulkster.','I wish to queue for the Coliseum, Rulkster.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(21517,'<Flaskataur flaps his majestic wings.>','',19,0,0,0,0,0,0,0,1,0,0,0,26124),
(21518,'Those who\'ve defiled this temple have all been defeated.  All but one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21519,'Oh great Flaskataur, allow me to purchase your goods.','Oh great Flaskataur, allow me to purchase your goods.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21520,'Let us finish what we\'ve started.  I will lead you to Illidan\'s abode once you\'ve recovered your strength.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21521,'The time has come to face Illidan, $n.  Are you ready?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21522,'I\'m ready, Akama.','I\'m ready, Akama.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21523,'We\'re currently focus testing the Battle of Mount Hyjal. You must have at least HONORED reputation with the Violet Eye to participate.$B$BThat\'s the reputation you gain while doing Karazhan.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(21524,'%s becomes increasingly enraged!','%s becomes increasingly enraged!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21525,'Jimmy, can you please flag me for Mount Hyjal access?','Jimmy, can you please flag me for Mount Hyjal access?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21526,'Jimmy, I want to buy something.','Jimmy, I want to buy something.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21527,'Now that you\'re attuned to Mount Hyjal, I can teleport you to the Caverns of Time. Just let me know when you are ready.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21528,'I\'m ready for Mount Hyjal, Jimmy. Teleport me!','I\'m ready for Mount Hyjal, Jimmy. Teleport me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21529,'We\'re currently focus testing The Black Temple. You must have at least HONORED reputation with the Violet Eye to participate.$B$BThat\'s the reputation you gain while doing Karazhan.','',396,396,0,0,0,0,0,0,1,0,0,0,26124),
(21530,'I wish to purchase the key to the Black Temple and some phat lewtz.','I wish to purchase the key to the Black Temple and some phat lewtz.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21531,'Now that you have your Black Temple key (Medallion of Karabor), I can teleport you directly to the Black Temple. Just tell me when you are ready.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21532,'I\'m ready to go to the Black Temple, Johnny.','I\'m ready to go to the Black Temple, Johnny.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21533,'Welcome friend! What would you like to see?','',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(21534,'Greetings $G brother:sister;. How can we be of service?','',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(21535,'How can we help you?','',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(21536,'Mighty one! How can we serve you?','',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(21537,'We are honored by your presence, friend.  How can we serve you today?','',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(21538,'Mighty one! We hope that you find our food to your satisfaction.','',16,0,0,1,0,0,0,0,1,0,0,0,26124),
(21539,'Our food should satisfy even the mightiest of hungers.','',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(21540,'Still hungry $G brother:sister;? How can we help?','',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(21541,'We have quite the feast for you friend.','',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(21542,'What tasty treats can we offer you?','',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(21543,'%s expires from battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21544,'%s arises to fight once more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21545,'You are not alone, Akama.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21546,'Your people will always be with you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21547,'','Hey, comrade.  If you get yourself in good with the Skyguard, I can offer you a direct flight to our base, Blackwind Landing, in the Skethyl Mountains.$B$BDo you like my beautiful nether ray?  It is lovely.',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(21548,'I cannot do this alone...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21549,'','Hello, $n.  Need to quickly get to Blackwind Landing, our base in the Skethyl Mountains?  I\'ve got a pretty little nether ray ready.$B$BYou want to go now?  You just say the word, $g big guy : bunny;!',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(21550,'Yes, I\'d love a ride to Blackwind Landing.','Yes, I\'d love a ride to Blackwind Landing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21551,'Hello, $g sir : ma\'am;!  If you want, I have a nether ray waiting to take you to the Skyguard Outpost atop the Blade\'s Edge Mountains.$B$BJust let me know.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21552,'Good day to you.  When you\'ve risen a bit more in the ranks of the Sha\'tari Skyguard, I will be able offer you a direct flight to the Skyguard Outpost, our base atop the Blade\'s Edge Mountains.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21553,'Absolutely!  Send me to the Skyguard Outpost.','Absolutely!  Send me to the Skyguard Outpost.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21554,'I thank you for your aid, brothers.  Our people will be redeemed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21555,'Be wary, friends. The Betrayer meditates in the court just beyond.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21556,'What do you hope to accomplish from this, insect?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21557,'I WILL CRUSH YOU LIKE A GNAT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21558,'You cannot stop us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21559,'You are making me angry, mortal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21560,'I will break you in two! Relent, fool!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21561,'Flee now while you still have your life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21562,'Be reasonable! You cannot hope to stop the Burning Legion! Let us discuss this in a civilized manner. I can offer you power beyond your wildest dreams!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21563,'This door is all that stands between us and the Betrayer.  Stand aside, friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21564,'Forgetting your skill in Spellfire Tailoring is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Spellfire Tailoring to create!','Forgetting your skill in Spellfire Tailoring is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Spellfire Tailoring to create!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21565,'We\'ll let you in on our secret diet: Cocktails and dreams. We can help you with one.','',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(21566,'I wish to unlearn Spellfire Tailoring.','I wish to unlearn Spellfire Tailoring.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21568,'Everyone\'s gotta drink. What can we get for you?','',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(21569,'Forgetting your knowledge is an expensive endeavor.  Are you willing to pay the cost?','Forgetting your knowledge is an expensive endeavor.  Are you willing to pay the cost?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21570,'Greetings $G brother:sister;, how can we help?','',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(21571,'Our drinks should quench even the mightiest of thirsts.','',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(21572,'Don\'t ya have something better ta do, $g lad : lass; than jaw with me?$B$BNow get out there and prove yer mettle!','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(21573,'That\'s the spirit, $g laddy : lassie;!  Yer making all of us proud with all o\' the work ye be doing!$B$BAnd ya know, if ya want a quick trip ta our other base in the Skethyl Mountains, go down an talk ta Skyguard Handler Irena.  She\'ll set ya up nicely.','',71,396,0,0,0,0,0,0,1,0,0,0,26124),
(21574,'Yer gettin\' ta be something of a revered figure \'round here, $g boy : girl;!  If\'n I didn\'t know better, I\'d say ye were gunnin\' fer me job!!!$B$BAll the same, if ye keep up the way ye have been, ye\'ll deserve it!','',5,396,0,0,0,0,0,0,1,0,0,0,26124),
(21575,'Drink or be gone!','',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(21576,'What can I say, $n?  Yer the finest o\' the Sha\'tari Skyguard!$B$BJust don\'t be lettin\' that go ta yer head.  I can still teach ya a thing or two, $g lad : lass;!$B$B<Sky Commander Keller grins at you and winks.>','',2,11,0,0,0,0,0,0,1,0,0,0,26124),
(21577,'','I see that you\'ve been putting in your time around here, $c.$B$BPut in more; the demons aren\'t gone yet, rookie.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21578,'','Your name seems to be on everyone\'s lips around the outpost.  Don\'t let it get to your head; I know that you can do better!$B$BI\'ll be watching you, rookie.',1,25,0,0,0,0,0,0,1,0,0,0,26124),
(21579,'How can we be of service, exalted one?','',16,0,0,1,0,0,0,0,1,0,0,0,26124),
(21580,'','Alright, I admit it, you\'ve proven yourself and then some, $n.$B$BIf I was hard on you before it was because I saw the spark of a true Skyguard within you.  I dare say that you\'re the finest ace that we have!$B$BAnytime that you want to help out, I\'ll be more than proud to hand you another set of bombs.',1,66,0,0,0,0,0,0,1,0,0,0,26124),
(21581,'We are happy to provide you with supplies.','',1,0,0,1,0,0,0,0,1,0,0,0,26124),
(21582,'Honored $G brother:sister;, how can we help?','',1,0,0,1,0,0,0,0,1,0,0,0,26124),
(21583,'','Hey there, $c!$B$B<Khatie looks at you slyly.>$B$BAnytime you want to wrangle us up some more aether rays, you make sure to come and see me!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21584,'Friend! It\'s been too long.  What can we get for you?','',1,0,0,1,0,0,0,0,1,0,0,0,26124),
(21585,'What are you looking for?','',1,0,0,1,0,0,0,0,1,0,0,0,26124),
(21586,'','You know, $n, it\'s such an honor to work with you!$B$BWhen you\'re not busy wrangling, maybe we could $g go out some place for dinner? : get together for a girl\'s night?;$B$BOh, did I mention that we can now get you to our base in the Skethyl Mountains real quick?  If you want, speak with Skyguard Handler Irena about that.',1,24,6,0,0,0,0,0,1,0,0,0,26124),
(21587,'','So, you\'ve been around a lot, but we seem to keep missing each other for getting together after work.$B$BIs it me?$B$B<Khatie purposely cheers up.>$B$BAnyway, I just wanted to say that I... we really appreciate everything that you\'ve been doing for the Skyguard!',6,1,4,0,0,0,0,0,1,0,0,0,26124),
(21588,'','I hope you don\'t think I\'m a stalker, or anything like that, $n.$B$BI mean, I know that you\'re real famous within the Skyguard now, and well... I\'m sure that you wouldn\'t want to hang out with a lowly peon like me.$B$BBut, if you ever want to get together to just hang out, or even wrangle some more rays, drop by anytime!  I\'ll be here.$B$BI miss you...',1,1,18,0,0,0,0,0,1,0,0,0,26124),
(21589,'The relics are truly a great mystery.  Perhaps by studying them regularly, you will gain a finer appreciation of their capabilities.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21590,'<Chu\'a\'lor\'s left head says,>$B$BWe find your zeal to help us most appealing...$B$B<His right head concludes,>$B$B... and we want you to know that we greatly appreciate your efforts!','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(21591,'Steel isn\'t strong, exalted one, flesh is stronger. Steel gains its strength from the one who wields it. But enough of that... How can we help you exalted one?','',1,0,0,1,0,0,0,0,1,0,0,0,26124),
(21592,'Your name is beginning to be revered around here.$B$B<Chu\'a\'lor\'s left eye pierces you with its stony gaze.>$B$BKeep up the good work, $n!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21593,'First you became $g king : queen; of the ogres below, and now you have exalted yourself amongst us of Ogri\'la.$B$BThis is unheard of for a $r, and yet, there you stand as living proof.  I thank you, $n, and we all owe you a debt that we will never truly be able to repay!','',1,2,0,0,0,0,0,0,1,0,0,0,26124),
(21594,'There are few things you can trust in life. Steel, you can trust.','',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(21595,'It\'s an honor to have a $r such as yourself aiding us ogres.  You\'re keeping our hope of a better future alive.$B$BNow if we could just get rid of these headaches.  Are you sure you don\'t want one of our sons?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(21596,'What is steel compared to the hand that shapes it?','',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(21597,'It\'s amazing how much you\'ve helped us out.  We dare say that if it weren\'t for you, we\'d already have been overrun by the demons, or fried to a crisp by the Black Dragonflight!$B$BOn a side note, we did mention that we\'d sell you one of our sons, cheap, right?  No, not interested?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(21598,'Here in Ogri\'la we have time to contemplate the riddle of steel. But enough of that, how can we help?','',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(21599,'Do you have steel that needs shaping?','',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(21600,'We cannot thank you enough for everything you\'ve done to protect our family, $n.$B$BAnd, you do realize that we were joking before when we offered to sell you one of our sons?  No, really... although we do feel a couple more headaches coming on.$B$BJunior, be still, will you?!','',2,6,15,0,0,0,0,0,1,0,0,0,26124),
(21601,'Us starting ta like little $n!  Yous bashem da demons real good!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(21602,'Gahk like little, $r $n.  Yous kill da big demon; make all da little demons scared!$B$B<Gahk\'s heads both grin at you.>','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21603,'Us sure see yous here all da time!$B$BChu\'a\'lor say little $r our $g hero : heroine;!$B$B$n like one of us ogres now.  Only, Gahk confused because $n need to be bigger for dat!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(21604,'What can we get for you, our exalted $G brother:sister;?','',16,0,0,1,0,0,0,0,1,0,0,0,26124),
(21605,'How might we be of assistance?','',1,0,0,1,0,0,0,0,1,0,0,0,26124),
(21606,'You will regret this, mortal! Reth\'hedron will return... I will have my vengeance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21607,'','Since the sparrowhawks have proven such a success in hunting down the raven stones, Watcher Elaira has trained another one to relay my voice at a great distance. He can help us communicate as you investigate the bird spirits revealed in the tablet!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21608,'Honored $G brother:sister;, how may we help?','',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(21609,'Hello friend! What can we do for you?','',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(21610,'We are here to help.','',1,0,0,1,0,0,0,0,1,0,0,0,26124),
(21611,'You\'ve been making quite a name for yourself around here, $r.  Good for you.$B$BWe trust that you won\'t let that go to your single head, and that you\'ll still help out by banishing demons?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(21612,'We are humbled by your selflessness, $n.  If in the past we\'ve seemed a bit conceited, realize that it is by your example that we were able to change our attitudes.$B$BWe thank you, and hope that you\'ll continue to assist us in our struggle against the forge camps.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(21613,'Get over there and realign The Crystal Forge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21614,'About time you showed up!  That forge has been busted for almost an hour!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21615,'What have you done you fools?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21616,'Incompetent fools!  Why must we suffer your stupidity?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21617,'I shall add another year to your enslavement for your failure!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21618,'You having a good time here with us in Ogri\'la?$B$BWe have a lot of stuff that our ogres are making, day and night.  We save the best to sell to our coolest guests like you!$B$BSo, as you\'re out there doing your thing, and making the mountains a safer place, stop by from time to time to see what we have.$B$BGood luck out there, $g man : chicky;.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(21619,'Rangers, listen up! We stand ready to take the pain directly to the heathen Bash\'ir devils.  Our mission is simple. Hold the area long enough to get accurate readings on their new technology.  ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21620,'But don\'t underestimate our enemies.  We are invading them.  We are taking the fight to them.  We have them backed into a corner and they will strike back.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21621,'We are Skyguard!  This is what we are trained to do.  We do not retreat, we do not surrender.  We will see our mission through even if it means death! We will secure that information or we will die on the field of battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21622,'Anyone have any questions?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21623,'You are about to find out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21624,'Skyguard Rangers, MOUNT UP!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21625,'Look man, I only need to know one thing, where they are.','Look man, I only need to know one thing, where they are.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21626,'What is it that you want?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(21627,'I am an envoy of Balthas. He has sent me to collect a flawless arcane essence.','I am an envoy of Balthas. He has sent me to collect a flawless arcane essence.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21628,'Jho\'nass, let me see what you have to offer.','Jho\'nass, let me see what you have to offer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21629,'Sky Commander Keller, I don\'t like my Deathwing Brood Cloak.','Sky Commander Keller, I don\'t like my Deathwing Brood Cloak.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21630,'Ye don\'t?  But ya worked so hard ta get it!  Well, $g lad : lass;, if ya want, I\'ll take it off o\' yer hands fer a fair price.$B$BHow does an exchange of yer cloak fer an apexis crystal sound ta ye?','',5,6,0,0,0,0,0,0,1,0,0,0,26124),
(21631,'<Overlord Mor\'ghor salutes.>','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(21632,'Defenders, show these mongrels the fury of a Scryer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21633,'Stand tall, soldiers. Show them no quarter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21634,'<Call forth Terokk.>','<Call forth Terokk.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21635,'That sounds fine to me.','That sounds fine to me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21636,'Are ya sure, $g laddy : lassie;?  Once I trade ya, I ain\'t gonna trade it back.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(21637,'Yes, I\'m sure.  I want to exchange my Deathwing Brood Cloak for an Apexis Crystal.','Yes, I\'m sure.  I want to exchange my Deathwing Brood Cloak for an Apexis Crystal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21638,'Very well, I\'m sure that I can find a Skyguard out there that can make use o\' the cloak.$B$BThere\'s yer apexis crystal.  I hope it makes ya happier than that cloak did.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(21639,'Who calls me to this world?  The stars are not yet aligned... my powers fail me!  You will pay for this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21640,'Peace, child, your time has not yet come. Remain here and witness that which is to unfold.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21641,'Hey, remember, $n, we\'ll make this stuff available for you to buy as you do good deeds.  It\'s like a karma thing, or something.$B$BSo, help out where you can, including with our Skyguard friends just to the north.$B$BAwesome... thanks!','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(21642,'Chu\'a\'lor\'s been saying good things about you, $n.  If you want, we have a couple of special ogre brews for sale.$B$BThey\'re really tasty!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21643,'You\'re like something of a revered figure around here, $g man : kitten;.  Seems like everyone\'s talking about you.  That\'s cool.$B$BLet\'s see if there\'s something in stock that you\'re interested in.  We have a lot of nice stuff.','',25,1,0,0,0,0,0,0,1,0,0,0,26124),
(21644,'What can we say, $n?  $G Dude : Dudette;, anything that we have in the store is yours to purchase!$B$BRight on!','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(21645,'That is a dangerous train of thought.  If something was truly amiss, Soridormi would be the first to know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21646,'','Do you think the rumors about the Infinite Dragonflight are true?  I\'ve sensed it... the familiarity.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21647,'I love when they do that.','I love when they do that.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21648,'Heads up!','Heads up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21649,'Let\'s go!','Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21650,'Come on!','Come on!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21651,'Come and get it!','Come and get it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21652,'Oh, you want some of this?','Oh, you want some of this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21653,'LET\'S ROCK!','LET\'S ROCK!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21654,'Who\'s next?','Who\'s next?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21655,'KILL THEM ALL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21656,'BURN IT DOWN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21657,'%s feeds on the freshly-killed warp chaser.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21658,'I wish to unlearn Shadoweave Tailoring.','I wish to unlearn Shadoweave Tailoring.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21659,'I wish to unlearn Mooncloth Tailoring.','I wish to unlearn Mooncloth Tailoring.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21660,'Forgetting your skill in Spellfire Tailoring is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Spellfire Tailoring to create!$b$bAre you absolutely sure?','Forgetting your skill in Spellfire Tailoring is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Spellfire Tailoring to create!$b$bAre you absolutely sure?\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21661,'Forgetting your skill in Shadoweave Tailoring is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Shadoweave Tailoring to create!$b$bAre you absolutely sure?\n','Forgetting your skill in Shadoweave Tailoring is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Shadoweave Tailoring to create!$b$bAre you absolutely sure?\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21662,'Forgetting your skill in Mooncloth Tailoring is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Mooncloth Tailoring to create!$b$bAre you absolutely sure?\n','Forgetting your skill in Mooncloth Tailoring is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Mooncloth Tailoring to create!$b$bAre you absolutely sure?\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21663,'Victory to the Scryers! The Dragonmaw have been defeated!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21664,'We... are... lost.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21665,'Be judged by the Light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21666,'Prepare to face the wrath of the light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21667,'The hammer of justice shall now find you guilty!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21668,'Leave off. I don\'t have anything for the likes of you.','Leave off. I don\'t have anything for the likes of you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21669,'I look forward to teaching you the error of your ways.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21670,'You were expecting one of my harbingers?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21671,'Perhaps I\'ll be able to sell your hide on the market.  Then again, it\'s likely worthless.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21672,'And wheresoever did you find the module to activate that controller?  No matter, you won\'t be doing that again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21673,'The master is busy, but I have time to come out and play!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21674,'Bash\'ir sends his regrets that he could not make it, but he sent me along to salve your disappointment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21675,'Do you know what you\'re playing with, $n?  Here, allow me to educate you and your friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21676,'I have other matters to attend to for the master.  Let\'s make this quick so that I can get back to them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21677,'You activated the accelerator with only this motley assemblage to back you up?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21678,'$n, allow me to give you some advice: tuck tail now and fly back down to the safety of the valleys below.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21679,'You think that you\'re $g man : woman; enough to take the depleted item from me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21680,'So many fools, so little time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21681,'A $c and $g his : her; friends... how quaint.  This shouldn\'t take long.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21682,'','You haven\'t yet mastered the simplest of enchantments. Please, trouble Dolothos instead.',274,1,0,0,0,0,0,0,1,0,0,0,26124),
(21683,'Don\'t cry, $n.  It will all soon be over.  I promise not to spit upon your corpse.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21684,'','If you seek to advance your training beyond what I have to show you, you\'ll need to sully those fine clothes. Hgarth has unlocked a number of mysteries in our profession, and lurks in the hills behind Sun Rock Retreat in Stonetalon Mountains.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21685,'The Dragonmaw must be stopped...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21686,'','What mysteries of the trade can I help you uncover today?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21687,'Your laughable stitching is best observed by Talmar there; come back when you understand how to properly cure a hide, perhaps. Your work smells foul.','Your laughable stitching is best observed by Talmar there; come back when you understand how to properly cure a hide, perhaps. Your work smells foul.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21688,'I am older than you can fathom.  Show some respect!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21689,'As I shall consume your flesh, so too shall the Burning Legion consume your people!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21690,'What better teacher for working leather than one who lives encased in it daily and could make a fine pelt herself if she were to meet an unfortunate end? Una in Thunder Bluff can show you more than I, if you can stand the stench.','What better teacher for working leather than one who lives encased in it daily and could make a fine pelt herself if she were to meet an unfortunate end? Una in Thunder Bluff can show you more than I, if you can stand the stench.',274,1,0,0,0,0,0,0,1,0,0,0,26124),
(21691,'Come, come. If you\'ve properly prepared your leather for once, I\'ll show you how to fashion serviceable items.','Come, come. If you\'ve properly prepared your leather for once, I\'ll show you how to fashion serviceable items.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21692,'I will make your death a quick one, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21693,'Why don\'t you go hone your skills with Mirvedon first? He\'ll gladly show you the basics.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21694,'May whatever god you believe in have mercy on you.  For I will show you none.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21695,'I\'ve heard tell of a truly skilled smith across the sea named Saru Steelfury. The smithy in Orgrimmar is where you should head if you wish to ply your trade, $c. Best of luck.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21696,'Get away from my clutch!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21697,'Eager to die, are we?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21698,'You wish to test me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21699,'Valiant effort.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21700,'Please. Show Razia your weak little concoctions if you must. Return to me when you can handle more... potent fare.','Please. Show Razia your weak little concoctions if you must. Return to me when you can handle more... potent fare.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21701,'A glorious kill!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21702,'Your death is at hand, $n.  Savor these last moments.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21703,'You got... lucky.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21704,'You\'re not cut out for this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21705,'Anar\'alah belore!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21706,'I know you by your stench, little $n.  Here, in my perch, is where your bones shall finally rest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21707,'You wish to kill me? You first!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21709,'The Forsaken brew such intriguing and strong concoctions, don\'t you think? It comes from an inability to poison oneself with failures, I believe. Luckily for you, Doctor Herbert Halsey in the Undercity has already done the necessary research; all that remains is for you to visit him.','The Forsaken brew such intriguing and strong concoctions, don\'t you think? It comes from an inability to poison oneself with failures, I believe. Luckily for you, Doctor Herbert Halsey in the Undercity has already done the necessary research; all that remains is for you to visit him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21710,'I tire of interruptions from the insignificant.  Your time has come, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21711,'','Flee or die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21712,'','My work is done.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21713,'','As it should be.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21714,'The Skyguard shall pay for your temerity, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21715,'','Destiny... awaits.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21716,'','No second chances!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21717,'','For Quel\'Thalas! For the Sunwell!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21718,'I believe that I shall feast upon both $r and ogre flesh tonight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21719,'','I\'m full of surprises!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21720,'Little $r, you will now come to appreciate my wrath!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21721,'You dare summon me?  Your insolence will be punished.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21722,'Come, $r. What formula interests you today?','Come, $r. What formula interests you today?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21723,'The Aldor shall be victorious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21724,'Common... such a crude language. Bandal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21725,'Shorel\'aran.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21726,'You have dared to defile my perch and must now be cleansed in fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21727,'Belesa menoor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21728,'Victory to the Aldor! The Dragonmaw have been defeated!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21729,'Diel ma\'ahn... orindel\'o.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21730,'Diel fin\'al.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21731,'Sha\'amoor ara mashal?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21732,'Shal\'mor sinabanal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21733,'What\'s this?!  $n and $g his : her; friends come to play?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21734,'I have better things to do...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21735,'Selama am\'oronor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21736,'Well done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21737,'Lord Illidan, I...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21738,'Enjoy your final moments.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21739,'You are mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21740,'Horde will... crush you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21741,'Time to feast.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21742,'More! I want more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21743,'Drink your blood. Eat your flesh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21744,'I hunger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21745,'I\'ll rip the meat from your bones!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21746,'Beware: I live!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21747,'So... foolish.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21748,'Enough! No more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21749,'On your knees!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21750,'I won\'t... be... ignored!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21751,'Beware, coward!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21752,'','You can have anything you desire... for a price.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21753,'','Fulfillment is at hand.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21754,'','Yes, you\'ll stay with us now...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21755,'','Be careful what you wish for.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21756,'','Your reach exceeds your grasp.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21757,'','I\'ll be waiting.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21758,'','I won\'t be far!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21759,'Pain and suffering are all that await you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21760,'Don\'t leave me alone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21761,'Look at what you made me do!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21762,'I didn\'t ask for this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21763,'The pain is only beginning...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21764,'I don\'t want to go back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21765,'Now what do I do?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21766,'','You play, you pay.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21767,'','I\'m not impressed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21768,'','Enjoying yourselves?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21769,'','So... business or pleasure?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21770,'','You seem a little tense...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21771,'','Don\'t be shy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21772,'','I\'m all... yours.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21773,'We are launching an assault on Bash\'ir Landing, to study their Crystalforge.  Help us if you can!  Our Skyguard Aether-tech will leave in about $4581d.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21774,'','Easy come, easy go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21775,'Ignore their blows, $n! They cannot harm you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21776,'','So much for a happy ending.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21777,'','I wasn\'t finished.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21778,'Their magics are meaningless to you, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21779,'Akama has no master. Not anymore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21780,'Illidan will pay.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21781,'One step closer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21782,'Uninvited guests!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21783,'There are more of them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21784,'I will not last much longer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21785,'No! Not yet!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21786,'The Light will bless these dismal halls once again... I swear it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21787,'Fight on, friends! Kill him - and end the curse on my people!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21788,'Beware his gaze! Do not look into his eyes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21789,'Slay all who see us... word must not get back to Illidan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21790,'Now is the time, Maiev! Unleash your wrath!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21791,'Akama has no master. Not anymore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21792,'','A discovery!  I need aid with these measurements... I\'ll send a signal to my colleague!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21793,'','The disruptor towers over charged the crystalforge, and uncovered more secrets!  Hold them!  Hold them while we gather new data!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21794,'','At last!  The information we seek!  Gather quickly, skyguard.  We must soon return to headquarters with our findings!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21795,'This forge can make unstable concoctions... to study them, I need Apexis Shards!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21796,'I am growing amazing crystals from these waters.  For catalysts, I must have more Apexis shards!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21797,'Its properties are amazing!  Provide me with Apexis crystals, and I\'ll form weapons and armor within crystal geodes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21798,'Come, $n. Lord Stormrage awaits.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21799,'Warriors of Dragonmaw, gather \'round! One among you has attained the rank of highlord! Bow your heads in reverence! Show your respect and allegiance to Highlord $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21800,'Lord Illidan will be here shortly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21801,'The pile of skulls reeks of foulness.  You fear the arakkoa have made an addition to the pile fairly recently.\n\nYou will need 10 Time-Lost Scrolls to call forth the descendants of Terokk\'s adversaries.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21802,'All hail Lord Illidan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21803,'Lord Illidan, this is the Dragonmaw that I, and others, have told you about. He will lead us to victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21804,'What is the meaning of this, Mor\'ghor?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21805,'But... My lord, I do not understand. $n... He is the orc that has...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21806,'A terrible, dark energy emanates from this pile of skulls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21807,'SILENCE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21808,'Blathering idiot. You incomprehensibly incompetent buffoon...\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21809,'THIS is your hero?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21810,'You have been deceived, imbecile.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21811,'This... whole... operation... HAS BEEN COMPROMISED!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21812,'I expect to see this insect\'s carcass in pieces in my lair within the hour. Fail and you will suffer a fate so much worse than death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21813,'I seem to have misplaced my ring.','I seem to have misplaced my ring.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21814,'Need supplies for the field?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21815,'How can I outfit you today, sir?','',66,0,0,1,0,0,0,0,1,0,0,0,26124),
(21816,'Need to requisition some supplies?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21817,'My $g lord : lady;.','My $g lord : lady;.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21818,'I am honored by your presence, $t lord : lady; $n.','I am honored by your presence, $t lord : lady; $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21819,'Look, there\'s $n!','Look, there\'s $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21820,'With you here, we\'re saved, $n.','With you here, we\'re saved, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21821,'If only there were more $g heroes : heroines; such as yourself, $n.','If only there were more $g heroes : heroines; such as yourself, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21822,'$n, I hope that you\'re staying for a while.  Stop by later if you have the time.','$n, I hope that you\'re staying for a while.  Stop by later if you have the time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21823,'It will be done, my lord.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21824,'So you thought to make a fool of Mor\'ghor, eh? Before you are delivered to Lord Illidan, you will feel pain that you could not know to exist. I will take pleasure in exacting my own vengeance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21825,'You will not harm the $g boy:girl;, Mor\'ghor! Quickly, $n, climb on my back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21826,'I seem to have misplaced my key.','I seem to have misplaced my key.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21827,'You can never be too prepared.','',0,0,0,1,0,0,0,0,1,0,0,0,26124),
(21828,'You have arrived!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21829,'Greetings, traveler.','Greetings, traveler.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21830,'I have lost my reins. Could you provide me with another?','I have lost my reins. Could you provide me with another?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21831,'Our Aether-tech and his escort are heading to Bash\'ir Landing.  Meet them there and help with their mission!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21832,'Our Skyguard Aether-tech and her escort is studying the Bash\'ir crystal forge.  She needs help!  Go to Bash\'ir Landing, find the aether-tech and keep her safe!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21833,'I\'ve made up my mind.  Make me forget my tailoring specialty!','I\'ve made up my mind.  Make me forget my tailoring specialty!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21834,'Hey look, it\'s $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21835,'$n, slay any dragons today?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21836,'We are honored by your presence, little $g brother : sister; $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21837,'We heard that $n single-handedly took out a forge camp!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21838,'Now that $n is here, we won\'t need to worry about the Burning Legion any longer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21839,'$n, $g king : queen; of the ogres, is here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21840,'Thank you for helping us, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21841,'$n is our $g hero : heroine;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21842,'$n, how are you today?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21843,'Three cheers for $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21844,'$n, how are you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21845,'We hope you\'re staying for a while, $n.  Stop by later and we\'ll catch up on old times.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21846,'If it weren\'t for $n, where would we be now?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21847,'$n, how many hundreds of demons have you banished?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21848,'We heard that $n figured out how to use the apexis relics and monuments!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21849,'You could all learn a lot from $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21850,'No violence in Ogri\'la!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21851,'Keep your fight away from Ogri\'la!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21852,'Not in here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21853,'You bring violence to Ogri\'la?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21854,'Look, it $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21855,'$n, slay dragon?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21856,'We glad, little $g brother : sister; $n here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21857,'$n take out forge camp all by $g himself : herself;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21858,'$n here... we not worry \'bout Burning Legion any more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21859,'$n, $g king : queen; of da ogres here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21860,'Thanks, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21861,'$n is Gahk\'s $g hero : heroine;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21862,'How $n today?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21863,'Gahk like $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21864,'$n, Gahk\'s friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21865,'Gahk hope $n stay a while.  $n visit Gahk later.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21866,'$n smash da demons.  Save Ogri\'la!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21867,'Little $n crush all da demons.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21868,'Gahk hear dat $n know how use da apexis relics!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21869,'Yous all listen ta $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21870,'Forgetting your skill in Potion Mastery is not something to do lightly.\n\nAre you absolutely sure?','Forgetting your skill in Potion Mastery is not something to do lightly.\n\nAre you absolutely sure?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21871,'Forgetting your skill in Elixir Mastery is not something to do lightly.\n\nAre you absolutely sure?','Forgetting your skill in Elixir Mastery is not something to do lightly.\n\nAre you absolutely sure?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21872,'Forgetting your skill in Transmutation Mastery is not something to do lightly.\n\nAre you absolutely sure?','Forgetting your skill in Transmutation Mastery is not something to do lightly.\n\nAre you absolutely sure?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21873,'I\'ve made up my mind.  Make me forget my alchemy mastery!','I\'ve made up my mind.  Make me forget my alchemy mastery!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21874,'I wish to unlearn Potion Mastery.','I wish to unlearn Potion Mastery.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21875,'I wish to unlearn Elixir Mastery.','I wish to unlearn Elixir Mastery.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21876,'I wish to unlearn Transmutation Mastery.','I wish to unlearn Transmutation Mastery.\n\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21877,'All of Illidan\'s lieutenants have fallen, $n.  The way forward is open, if you\'re ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21878,'%s seethes in anger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21879,'I\'m ready.  Take me to the Chamber of Command.','I\'m ready.  Take me to the Chamber of Command.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21880,'Illidan\'s lackeys still guard these halls, $n.  Once they are defeated, my powers will allow me to take you deeper inside the temple.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21881,'They called me down from K\'aresh to deal with this band of misfits?  Unbelievable!  Prepare to be collected!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21882,'Rider $n, good to see you.','Rider $n, good to see you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21883,'Hey, it\'s our ace flyer, $n!','Hey, it\'s our ace flyer, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21884,'I heard that $n is gunning to be the captain of the air group.','I heard that $n is gunning to be the captain of the air group.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21885,'Look who\'s here.  It\'s $n, our top gun.','Look who\'s here.  It\'s $n, our top gun.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21886,'$n, do you feel the need -- the need for speed?','$n, do you feel the need -- the need for speed?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21887,'Enough!  I will take care of these fools myself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21888,'Good hunting up there, $n!','Good hunting up there, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21889,'Buzz the landing pad lately, $n?','Buzz the landing pad lately, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21890,'$G Mister : Lady; $n, what an unexpected pleasure, $g sir : ma\'am;.','$G Mister : Lady; $n, what an unexpected pleasure, $g sir : ma\'am;.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21891,'A-TEN-HUT, officer $n on the deck!','A-TEN-HUT, officer $n on the deck!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21892,'With $n on the job, we have nothing to worry about.','With $n on the job, we have nothing to worry about.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21893,'$n, terror of the skies, how are you doing?','$n, terror of the skies, how are you doing?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21894,'They say that $n has never been shot down.','They say that $n has never been shot down.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21895,'Heh, the skies aren\'t so friendly with $n flying them!','Heh, the skies aren\'t so friendly with $n flying them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21896,'Well one thing\'s for sure, $n\'s not a nugget any more!','Well one thing\'s for sure, $n\'s not a nugget any more!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21897,'$n, how\'s your mount holding up?  Pretty rough up there these days?','$n, how\'s your mount holding up?  Pretty rough up there these days?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21898,'Well, if it isn\'t our resident $g flyboy : flygirl;, $n.  How\'s it going, ace?','Well, if it isn\'t our resident $g flyboy : flygirl;, $n.  How\'s it going, ace?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21899,'I sense you\'ve cleared the path to my brethren.  My connection to them and to the temple is still strong.  Do you wish to delve deeper inside?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21900,'My brethren were here not long ago.  My connection to them has grown tenuous.  A powerful presence in the courtyard guards the way forward.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21901,'Take me to the other Deathsworn, Olum.','Take me to the other Deathsworn, Olum.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21902,'%s bares her fangs and hisses menacingly at those around her.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21903,'You capture Karrog!  Karrog smash you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21904,'Hear the voices below the earth!  They call for your blood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21905,'Furious winds envelop Vakkiz as he writhes menacingly towards you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21906,'You\'re one of our bravest, $n.  All of the Skyguard is in your debt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21907,'Do not... bring Terokk into our world, $n...  That would be... madness...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21908,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21909,'I seem to have lost my Blackened Urn.','I seem to have lost my Blackened Urn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21910,'Echo of Medivh cheats!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21911,'Trying to cast on $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21912,'Only the most seasoned hunters of Illidan\'s minions gain access to my wares.$B$BYou will be considered worthy when your status with the Sha\'tar, Cenarion Expedition and the Aldor is exalted.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(21913,'Only the most seasoned hunters of Illidan\'s minions gain access to my wares.$B$BYou will be considered worthy when your status with the Sha\'tar, Cenarion Expedition and the Scryers is exalted.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(21914,'Welcome, $n. Bring me the marks that Illidan bestows upon his most powerful minions and I shall grant you access to my alchemical goods.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21915,'I have marks to redeem.','I have marks to redeem.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21916,'I seem to have misplaced my Ashtongue Cowl.','I seem to have misplaced my Ashtongue Cowl.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21917,'The arakkoa are hidden... everywhere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21918,'Rest now, Adaris.  You need to recover your strength.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21919,'ONE!','ONE!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21920,'TWO!','TWO!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21921,'THREE!','THREE!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21922,'FOUR!','FOUR!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21923,'FIVE!','FIVE!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21924,'The keg is tapped!  Now I would like to propose a toast.  Don\'t worry, I\'ll keep it short and sweet.','The keg is tapped!  Now I would like to propose a toast.  Don\'t worry, I\'ll keep it short and sweet.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21925,'The gronn... the Legion... is there nothing you can\'t handle, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21926,'The crystals sing a sweeter song when $n is around.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21927,'We hear that the dragons tremble in fear at the mere mention of $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21928,'Truly $n has been enlightened by the crystals.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21929,'$n! The crystals sing your praises!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21930,'We owe you a debt of gratitude $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21931,'Da Gronn... da Legion... $n beat dem all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21932,'Da crystals sing da perdy song when little $n here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21933,'Da dragons get scared when yous say $n\'s name.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21934,'Da crystals make $n smarter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21935,'$n!  Da crystals sing about you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21936,'Gahk owe little $n much thanks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21937,'$n, you and I should race sometime.','$n, you and I should race sometime.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21938,'I hear you fly without a parachute cloak, $n.','I hear you fly without a parachute cloak, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21939,'The list of Skyguard members is long and distinguished.  $n tops that list.','The list of Skyguard members is long and distinguished.  $n tops that list.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21940,'$n is an officer and a $g gentleman : gentlewoman;.','$n is an officer and a $g gentleman : gentlewoman;.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21941,'Ace pilot $n, 12 o\'clock!','Ace pilot $n, 12 o\'clock!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21942,'Maybe one day $n will teach us a few of $g his : her; tricks?','Maybe one day $n will teach us a few of $g his : her; tricks?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21943,'I\'d be honored to have you on my wing anytime, $n.','I\'d be honored to have you on my wing anytime, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21944,'$n, you are the Skyguard\'s best; make us proud!','$n, you are the Skyguard\'s best; make us proud!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21945,'We still stand here only because of $n\'s help.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21946,'It\'s $n, mighty $c and $g brother : sister; to ogres everywhere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21947,'We still here cuz $n help Ogri\'la!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21948,'$n da mighty $c is my little $g brother : sister;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21949,'I\'ve lost the sparrowhawk whistle you gave me. Can you replace it?','I\'ve lost the sparrowhawk whistle you gave me. Can you replace it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21950,'Unseen arakkoa... they\'re all around us... watching us... waiting!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21951,'Drakes is my business, $n. I\'m authorized to sell them to our highest ranking officers.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(21952,'I\'m interested in purchasing a new drake.','I\'m interested in purchasing a new drake.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21953,'I\'ve lost my medallion, Xi\'ri.','I\'ve lost my medallion, Xi\'ri.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21954,'This is madness!','This is madness!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21955,'What do you need, $c?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21956,'I need a new Enchanted Illidari Tabard.','I need a new Enchanted Illidari Tabard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21957,'It\'s so good seeing so many of you here to celebrate this time honored festivity.  A celebration of this magnitude is long overdue.','It\'s so good seeing so many of you here to celebrate this time honored festivity.  A celebration of this magnitude is long overdue.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21958,'Start the countdown!','Start the countdown!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21959,'Supremus acquires a new target!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21960,'Enough games!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21961,'Level 1: Completed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21962,'Game Over','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21963,'Level 2: Completed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21964,'Final Level: Completed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21965,'Prepare to be incinerated!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21966,'Brewfest is almost here!','Brewfest is almost here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21967,'Can\'t you see I\'ve got work to do here?','Can\'t you see I\'ve got work to do here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21968,'Won\'t be long now until the Brewfest starts!  Come back later and check to see if we\'re done.','Won\'t be long now until the Brewfest starts!  Come back later and check to see if we\'re done.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21969,'I can\'t wait until we\'re done setting up.  Then I can kick back and enjoy the festivities.','I can\'t wait until we\'re done setting up.  Then I can kick back and enjoy the festivities.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21970,'Brewfest is a non-stop party.  Setting up for it, though, is non-stop work!','Brewfest is a non-stop party.  Setting up for it, though, is non-stop work!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21971,'Let\'s get out of here!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(21972,'Let\'s go!','Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21973,'Kronk, tell me about the charged crystal foci.','Kronk, tell me about the charged crystal foci.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21974,'The crystal foci?  Of course we\'ll explain it seeing as you only have half the brain power to figure it out.$B$BA depleted crystal focus can be combined with ten apexis shards in a simple process, which creates a charged crystal focus.  These charged foci have some healing properties, but more important is their use with a possessed demon.$B$BYou see, the charged focus can be used to enable a possessed demon to exhibit special powers.  After a time, Gahk will have a mission for you to do just that.','',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(21975,'The crystal foci?  Of course we\'ll explain it seeing as you only have half the brain power to figure it out.$B$BA depleted crystal focus can be combined with ten apexis shards in a simple process, which creates a charged crystal focus.  These charged foci have some healing properties, but more important is their use with a possessed demon.$B$BYou see, the charged focus can be used to enable a possessed demon to exhibit special powers.  If you have a darkrune, Gahk will speak to you about that.','',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(21976,'Hey! Lishten up!  I\'ve got... I have something important to talk about!  Shee... Wait... What wash I shaying?  Something aboutsh boats and floating... Yeah! Sho don\'t float on a boat... Thank you...','Hey! Lishten up!  I\'ve got... I have something important to talk about!  Shee... Wait... What wash I shaying?  Something aboutsh boats and floating... Yeah! Sho don\'t float on a boat... Thank you...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21977,'Now you\'ll shee shome real fancy riding!','Now you\'ll shee shome real fancy riding!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21978,'That\'ll leave a mark...  I\'ll just rest here for a bit.','That\'ll leave a mark...  I\'ll just rest here for a bit.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21979,'Hey fellas!  How\'s it going?','Hey fellas!  How\'s it going?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21980,'You guys have gotta try thish...','You guys have gotta try thish...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21981,'What\'s all the fuss about here?','What\'s all the fuss about here?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21982,'The besht part about drinking is pretending to be drunk... I\'m jusht pretending guys.','The besht part about drinking is pretending to be drunk... I\'m jusht pretending guys.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21983,'Hey! Anyone shee that cute blond dwarf?  I shwear they were jusht here...','Hey! Anyone shee that cute blond dwarf?  I shwear they were jusht here...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21984,'It\'sh great to finally drink with friendsh... Normally I\'d jusht sit at home and drink alone.','It\'sh great to finally drink with friendsh... Normally I\'d jusht sit at home and drink alone.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21985,'Good times! <hic!>','Good times! <hic!>',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21986,'Uh oh...','Uh oh...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21987,'%s lashes out, opening a large gash on $n!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(21988,'When King Magni approached me about these festivities I was excited.  I began explaining how with a little help from the gnomes, we could really make this a blast to remember.  Sadly, King Magni wanted to keep it simple.  He wanted to honor the past.','When King Magni approached me about these festivities I was excited.  I began explaining how with a little help from the gnomes, we could really make this a blast to remember.  Sadly, King Magni wanted to keep it simple.  He wanted to honor the past.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21989,'I can understand that. But the King did allow for a change, letting a gnome tap the keg.  So I got a chance to work on a new type of problem; How to efficiently and quickly open the keg and distribute its contents such that all participants will receive equal parts quickly and efficiently.','I can understand that. But the King did allow for a change, letting a gnome tap the keg.  So I got a chance to work on a new type of problem; How to efficiently and quickly open the keg and distribute its contents such that all participants will receive equal parts quickly and efficiently.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21990,'So I had my top men and women start working on a machine to do this exact task!  We\'ve calculated down to the second how best to dist-','So I had my top men and women start working on a machine to do this exact task!  We\'ve calculated down to the second how best to dist-',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21991,'Well... uh...  I guess the Keg Tapper 74205 will have to wait... but that\'s okay, I\'ve got some designs for the Keg Tapper 75633...','Well... uh...  I guess the Keg Tapper 74205 will have to wait... but that\'s okay, I\'ve got some designs for the Keg Tapper 75633...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21992,'Right, right... So let\'s start the countdown from ten, ready?  TEN!','Right, right... So let\'s start the countdown from ten, ready?  TEN!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21993,'Oh... okay, I\'ll just wait for zero then...','Oh... okay, I\'ll just wait for zero then...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21994,'Speed it up, Tinker!','Speed it up, Tinker!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21995,'MORE POUR, LESS BORE!','MORE POUR, LESS BORE!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21996,'Yak, yak! Let\'s get to the drinking!','Yak, yak! Let\'s get to the drinking!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21997,'BOOORING!!','BOOORING!!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21998,'Drink, Tink! Drink, Tink! Drink, Tink!','Drink, Tink! Drink, Tink! Drink, Tink!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(21999,'Just tap the keg already!','Just tap the keg already!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22000,'%s focuses intensely!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22001,'Drink and be merry!','Drink and be merry!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22002,'Interested in a canoe ride to Dragonblight?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(22003,'I would like to ride in one of your canoes, Jimmy.','I would like to ride in one of your canoes, Jimmy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22004,'Watch out for Big Shirl!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22005,'Thanksh everybody for sheeing me... Todaysh a day that we should all... fall.. shmall... No... CALL! That\'s it... We should all call Thrall small... That way he\'ll know we love the Horde.  FOR THE SHWORD!','Thanksh everybody for sheeing me... Todaysh a day that we should all... fall.. shmall... No... CALL! That\'s it... We should all call Thrall small... That way he\'ll know we love the Horde.  FOR THE SHWORD!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22006,'Now you\'ll shee shome real fancy riding!','Now you\'ll shee shome real fancy riding!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22007,'That\'ll leave a mark...  I\'ll just rest here for a bit.','That\'ll leave a mark...  I\'ll just rest here for a bit.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22008,'Hey! You for the Horde? <hic> I\'m for the Horde!','Hey! You for the Horde? <hic> I\'m for the Horde!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22009,'You guys have gotta try thish...','You guys have gotta try thish...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22010,'What\'s all the fuss about here?','What\'s all the fuss about here?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22011,'The besht part about drinking is pretending to be drunk... I\'m jusht pretending guys.','The besht part about drinking is pretending to be drunk... I\'m jusht pretending guys.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22012,'Hey! Anyone shee that cute goblin?  I shwear they were jusht here...','Hey! Anyone shee that cute goblin?  I shwear they were jusht here...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22013,'It\'sh great to finally drink with friendsh... Normally I\'d jusht sit at home and drink alone.','It\'sh great to finally drink with friendsh... Normally I\'d jusht sit at home and drink alone.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22014,'Good times! <hic!>','Good times! <hic!>',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22015,'Today, we honor the ones that bring us good food and good drink.','Today, we honor the ones that bring us good food and good drink.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22016,'We honor them by putting them to war against one another.','We honor them by putting them to war against one another.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22017,'We will learn who the greatest brewmaster is.  We know the breweries are up for the challenge.  We would not have invited them otherwise.','We will learn who the greatest brewmaster is.  We know the breweries are up for the challenge.  We would not have invited them otherwise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22018,'So now, let us celebrate with our fine warrior brothers!','So now, let us celebrate with our fine warrior brothers!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22019,'Let us count down from five. Then I will tap this keg and we can all decide who is the greatest of brewmasters.','Let us count down from five. Then old Vol\'jin will tap this keg and we can all decide who is the greatest of brewmasters.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22020,'The keg has been tapped!  The battle begins!  Now raise your glasses with me, as I toast our combatants...','The keg has been tapped!  The battle begins!  Now raise your glasses with me, as I toast our combatants...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22021,'Brew for the Horde! Drink for the Horde!','Brew for the Horde! Drink for the Horde!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22022,'Prepare yourselves, the bells have tolled! Shelter your weak, your young and your old! Each of you shall pay the final sum. Cry for mercy, the reckoning has come!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22023,'FOR THE POUR!','FOR THE POUR!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22024,'Today is a good day to drink!','Today is a good day to drink!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22025,'Drink for the Horde!','Drink for the Horde!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22026,'Fire consumes! You\'ve tried and failed.  Let there be no doubt, justice prevailed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22027,'My flames have died, left not a spark. I shall send you myself, to the lifeless dark.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22028,'Headless Horseman - Attack, Go to new loc.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22029,'I\'ve lost the key to the Shattered Halls.','I\'ve lost the key to the Shattered Halls.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22030,'Fire a warning shot!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22031,'That\'ll teach \'em...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22032,'Aye aye, sir!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22033,'FIRE!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22034,'The sky is dark.  The fire burns.  You strive in vain as Fate\'s wheel turns.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22035,'The town still burns, a cleansing fire!  Time is short, I\'ll soon retire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22036,'You\'ve wasted too much time, mortals. Now you shall fall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22037,'Let there be no doubt, justice prevailed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22038,'Mysterious hoofprints, scorched shields, stray badges... how do we make sense of all this?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22039,'This crime cannot be allowed to go unsolved. The location of the inn and the violence of its destruction make this a very delicate matter. Inspect the site with the utmost respect, friend.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(22040,'What are you doing here? Do you wish to defile the ashes of this slain family further? Leave this place. You are not welcome.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22041,'Can you spread the reflective dust again?','Can you spread the reflective dust again?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22042,'Hmm... I wonder...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22043,'Stupid mages... always using the last of a reagent and never replacing it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22044,'Is he complaining about the reagents again? Does he even remember how he left the summoning tomes last time?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22045,'Now, where is it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22046,'If you think you can stop us, you\'re mistaken, \'friend.\'','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22047,'You can\'t stop us from exposing the truth about Jaina\'s cowardice!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22048,'These people will know Admiral Proudmoore for the true hero he was!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22049,'It\'s people like you who weaken the Alliance and invite the Horde to take away all we\'ve fought for!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22050,'It\'s good to see you defending Theramore with pride, friend.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22051,'When you\'re off duty, let\'s go to the inn. I\'ll buy a round and we can reminisce about the good old days.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22052,'Wouldn\'t you like to bring those days back? I have some friends who know just the way to do that...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22053,'You seem like a sensible $c, friend. Do you remember the glory days of Theramore, back before Jaina made us give up the fight against the Horde? Are you sick of being told to stay your blade while the orcs continue to provoke us?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22054,'Your propaganda won\'t work on me. Spout your treasonous filth elsewhere, traitor!','Your propaganda won\'t work on me. Spout your treasonous filth elsewhere, traitor!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22055,'Look at that!  Near the fruit carts, an ogre.  The fruit vendor is preparing for war...','Look at that!  Near the fruit carts, an ogre.  The fruit vendor is preparing for war...',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(22056,'That ogre is just the first sign that war is upon us.  The fruit vendor has gone too far.','That ogre is just the first sign that war is upon us.  The fruit vendor has gone too far.',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(22057,'Who is this fruit vendor to make such a bold move? He\'s brought in an ogre for support.','Who is this fruit vendor to make such a bold move? He\'s brought in an ogre for support.',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(22058,'HA! The fruit vendor must be scared for his life.  He\'s enlisted support.  Well two can play that game.','HA! The fruit vendor must be scared for his life.  He\'s enlisted support.  Well two can play that game.',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(22059,'Does the fruit vendor think that I am blind?  Do they think I wouldn\'t see his ogre reinforcement?','Does the fruit vendor think that I am blind?  Do they think I wouldn\'t see his ogre reinforcement?',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(22060,'I feel that war is fast approaching.  The fruit vendor has enlisted the help of an ogre.  I shall have to enlist help as well.','I feel that war is fast approaching.  The fruit vendor has enlisted the help of an ogre.  I shall have to enlist help as well.',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(22061,'','The Headless Horseman\'s undead mind is obsessed!  During Hallow\'s End, his attacks on this village are frequent, and terrible.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22062,'','The Headless Horseman attacks the village!  Someone must save the children and stop him!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22063,'','We are free of the Headless Horseman\'s terror, for now.  We may breathe easy again, but until he can be defeated while joined with his head, he may return.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22064,'IF WAR IS WHAT YOU WANT, WAR IS WHAT YOU SHALL GET, FRUIT VENDOR!','IF WAR IS WHAT YOU WANT, WAR IS WHAT YOU SHALL GET, FRUIT VENDOR!',388,0,0,0,0,0,0,0,1,0,0,0,26124),
(22065,'YOUR OGRE DOESN\'T SCARE ME, FRUIT VENDOR! MY ARMY IS ON ITS WAY!','YOUR OGRE DOESN\'T SCARE ME, FRUIT VENDOR! MY ARMY IS ON ITS WAY!',388,0,0,0,0,0,0,0,1,0,0,0,26124),
(22066,'YOUR DAYS ARE NUMBERED FRUIT VENDOR! I KNOW ABOUT YOUR OGRE ARMY!','YOUR DAYS ARE NUMBERED FRUIT VENDOR! I KNOW ABOUT YOUR OGRE ARMY!',388,0,0,0,0,0,0,0,1,0,0,0,26124),
(22067,'$n, I sure hope somebody finds my dog!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22068,'%s howls in delight at the sight of his lunch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22069,'%s eats his lunch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22070,'%s thanks you with a special dance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22071,'The zeppelin should have just arrived at Grom\'gol... ','The zeppelin should have just arrived at Grom\'gol... ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22072,'Why does my cousin get to enjoy the balmy beaches of Stranglethorn, anyway?','Why does my cousin get to enjoy the balmy beaches of Stranglethorn, anyway?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22073,'The zeppelin should have just left from Grom\'gol... ','The zeppelin should have just left from Grom\'gol... ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22074,'The zeppelin to Grom\'gol should be arriving here any time now.','The zeppelin to Grom\'gol should be arriving here any time now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22075,'The zeppelin to Grom\'gol has just arrived! All aboard for Stranglethorn!','The zeppelin to Grom\'gol has just arrived! All aboard for Stranglethorn!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22076,'Hey! Did I remember to refill the tank before the zeppelin left? Oh, well!','Hey! Did I remember to refill the tank before the zeppelin left? Oh, well!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22077,'The zeppelin to Orgrimmar has just arrived! All aboard for Durotar!','The zeppelin to Orgrimmar has just arrived! All aboard for Durotar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22078,'The zeppelin should have just reached Orgrimmar. Should be back in a few minutes...','The zeppelin should have just reached Orgrimmar. Should be back in a few minutes...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22079,'I hope that my brother\'s doing okay in Durotar. There\'s an awful lot of smelly Orcs out there.... Then again, this isn\'t exactly the greatest gig, either...','I hope that my brother\'s doing okay in Durotar. There\'s an awful lot of smelly Orcs out there.... Then again, this isn\'t exactly the greatest gig, either...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22080,'There goes the zeppelin to Orgrimmar. I hope there\'s no explosions this time.','There goes the zeppelin to Orgrimmar. I hope there\'s no explosions this time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22081,'I\'m not sure where the zeppelin is right now, actually...','I\'m not sure where the zeppelin is right now, actually...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22082,'The zeppelin should have just arrived at Grom\'gol... ','The zeppelin should have just arrived at Grom\'gol... ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22083,'The zeppelin should have just arrived at Orgrimmar... ','The zeppelin should have just arrived at Orgrimmar... ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22084,'The zeppelin should have just departed from Orgrimmar... ','The zeppelin should have just departed from Orgrimmar... ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22085,'The zeppelin should have just departed from Grom\'gol... ','The zeppelin should have just departed from Grom\'gol... ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22086,'Where is the zeppelin now?','Where is the zeppelin now?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22087,'The zeppelin should just have arrived at Undercity.','The zeppelin should just have arrived at Undercity.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22088,'The zeppelin should have just reached Orgrimmar.','The zeppelin should have just reached Orgrimmar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22089,'The zeppelin should have just departed from Orgrimmar.','The zeppelin should have just departed from Orgrimmar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22090,'The zeppelin should have just departed from Undercity.','The zeppelin should have just departed from Undercity.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22091,'','The Headless Horseman attacks!  The fires threaten to consume the whole village!  What will we do?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22092,'The zeppelin should just have arrived at Undercity.','The zeppelin should just have arrived at Undercity.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22093,'The zeppelin should just have arrived at Grom\'gol.','The zeppelin should just have arrived at Grom\'gol.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22094,'The zeppelin should just have departed from Grom\'gol.','The zeppelin should just have departed from Grom\'gol.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22095,'The zeppelin should just have departed from Undercity.','The zeppelin should just have departed from Undercity.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22096,'I never get to ride to Grom\'gol. Its just so unfair. Warm, steamy beaches... Crocolisks, Raptors... hmmm... maybe I don\'t really want to go there after all.','I never get to ride to Grom\'gol. Its just so unfair. Warm, steamy beaches... Crocolisks, Raptors... hmmm... maybe I don\'t really want to go there after all.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22097,'The zeppelin to Grom\'gol has just arrived! All aboard for Stranglethorn!','The zeppelin to Grom\'gol has just arrived! All aboard for Stranglethorn!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22098,'Don\'t be late, the next ship to Stranglethorn departs in only a minute!','Don\'t be late, the next ship to Stranglethorn departs in only a minute!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22099,'The zeppelin to Undercity has just arrived! All aboard for Tirisfal Glades!','The zeppelin to Undercity has just arrived! All aboard for Tirisfal Glades!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22100,'The zeppelin to historic Tirisfal Glades has just arrived! Don\'t be caught dead without the latest in Forsaken fashion!','The zeppelin to historic Tirisfal Glades has just arrived! Don\'t be caught dead without the latest in Forsaken fashion!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22101,'The zeppelin should have just arrived at Grom\'gol... ','The zeppelin should have just arrived at Grom\'gol... ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22102,'The zeppelin should have just arrived at Orgrimmar...','The zeppelin should have just arrived at Orgrimmar...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22103,'The zeppelin should have just departed from Grom\'gol...','The zeppelin should have just departed from Grom\'gol...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22104,'The zeppelin should have just departed from Orgrimmar...','The zeppelin should have just departed from Orgrimmar...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22105,'','It would be a shame to let these leaflets go to waste, wouldn\'t it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22106,'I spend all day retrieving parts for the zeppelin and Frezza doesn\'t even have the decency to pay me an hourly wage. But you\'re not here about that, are you? I bet you want to know where the zeppelin is located. Well, you\'re in luck - I have my zeppelin tracking device right here!','I spend all day retrieving parts for the zeppelin and Frezza doesn\'t even have the decency to pay me an hourly wage. But you\'re not here about that, are you? I bet you want to know where the zeppelin is located. Well, you\'re in luck - I have my zeppelin tracking device right here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22107,'','With just a little creative editing, these are much more useful...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22108,'Where is the zeppelin to Undercity right now?','Where is the zeppelin to Undercity right now?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22109,'Where is the zeppelin to Grom\'gol right now?','Where is the zeppelin to Grom\'gol right now?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22110,'Please consider joining our cause!','Please take one of these leaflets and consider joining our cause!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22111,'Hey, thanks.','Hey, thanks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22112,'%s reads the leaflet.','%s reads the leaflet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22113,'This... this is a joke, right?','This... this is a joke, right?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22114,'That\'s the funniest thing I\'ve read in a long time. You\'ve just made my day!','That\'s the funniest thing I\'ve read in a long time. You\'ve just made my day!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22115,'What a bunch of lunatics! You actually believe this stuff?','What a bunch of lunatics! You actually believe this stuff?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22116,'I\'d never join anything like this. Better keep this, though. It\'ll come in handy in the privy...','I\'d never join anything like this. Better keep this, though. It\'ll come in handy in the privy...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22117,'Heh... heh... hey! You! I may be down, but I be gettin\' back on my feet! Come over here and look at what I got. The rarest and most marvelous amulets, right here! I even picked up some extra bits! Come on, come on, ya know ya wanna look.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22118,'Check this out, $r! Ya know what $G ya:yer sweetheart; be needin\'? One of these flowers. Lilacs, right outta the mystical forest of Terokkar! Rare! So rare! Ya don\'t see any of \'em around me, do ya? A pretty flower for a pretty lady, right? Right?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22119,'Amazing amulets! Incredible curios! The newfangled jewelcrafters be havin\' nothin\' on the tried and true mystical methods of... the... uh... the newly relocated Griftah! Improve yerself through these magical talismans for a bargain price!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22120,'Okay, okay, I know what ya be thinkin\'. This be a stick. But it be no ORDINARY stick, no! What ya be seein\' here, $c, be a stick of incredible rarity and extraordinary value, shaped by the very powers that wrought the world! Ya wanna own this fantastic piece of Draenor, touched by magnificent power, I know ya do. I be practically givin\' em away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22121,'Hey, wait, $c! Ya been by the market lately? My stall\'s okay, yeah? Still there?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22122,'I can\'t believe they be chasin\' me outta the city. Innit supposed to be a refuge? Ol\' Griftah be a refugee! Not my fault I be an ENTERPRISIN\' refugee...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22123,'Now, I know what ya be thinkin\'. Ol\' Griftah\'s in a spot of trouble. This be nothin\'. I still got a lotta my stock on me, so c\'mere and check out what I got.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22124,'The merchant known as Griftah has been exiled from this city for his fraudulent activities. We plan to go over these little knick-knacks he sells extremely carefully. Please, leave his stall undisturbed and let us do our work.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22125,'Nothing to see here. Move along.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22126,'This stall is under official investigation. Please keep your distance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22127,'You have no need to worry - the swindler who peddled his \"wares\" here has been exiled from our fair city.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22128,'Keep back from this stall, please; there is a delicate investigation underway.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22129,'Let it never be said that we do not listen to the concerns of the people. This \"Griftah\" individual has made false claims, and we mean to set things right.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22130,'Keep a wary eye out, $r; there are unsavory characters afoot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22131,'Should you venture outside the gates, $c, be alert; a garishly-dressed troll may attempt to approach you. Leave him to his exile where he rightly belongs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22132,'Barleybrew, finest brewery in Azeroth!','Barleybrew, finest brewery in Azeroth!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22133,'Come try our Barleybrew Dark!','Come try our Barleybrew Dark!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22134,'The Barleybrews have always been leaders in brewery innovation.  Check out our newest creation, Barleybrew Clear!','The Barleybrews have always been leaders in brewery innovation.  Check out our newest creation, Barleybrew Clear!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22135,'Thunderbrew, finest brewery in all the realms.','Thunderbrew, finest brewery in all the realms.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22136,'THUNDER!  THUNDER!  THUNDER!  THUNDERBREW, HO!','THUNDER!  THUNDER!  THUNDER!  THUNDERBREW, HO!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22137,'You look like you could use a cold one.  Thunderbrew\'s got ya covered!','You look like you could use a cold one.  Thunderbrew\'s got ya covered!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22138,'YOU WANT DRINK?!  WE GOT DRINK!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22139,'HEY YOU!  DRINK OGRE BREWS!  MAKE YOU BIG AND STRONG!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22140,'YOU TRY DA\' BEST, NOW TRY DA\' REST!  OGRE BREW!!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22141,'You won\'t find a better brew in Azeroth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22142,'We Thunderbrews take pride knowing that we are the best brewhouse in all the realms.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22143,'Whoah! You really want buy from us?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22144,'Get da move on, guards! It be killin\' time!','',0,0,0,0,0,0,0,0,1,0,12066,0,26124),
(22145,'Mua-ha-ha!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22146,'Guards, go already! Who you more afraid of, dem... or me?','',0,0,0,0,0,0,0,0,1,0,12067,0,26124),
(22147,'Mmm? Uhg... gah, rhmmrugh...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22148,'Wake up, orc, I\'m parched! Sell me something to drink....','Wake up, orc, I\'m parched! Sell me something to drink....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22149,'Can\'t you see that I\'ve got places to go and people to see! Step aside, peasant!','',5,397,0,0,1,0,0,0,1,0,0,0,26124),
(22150,'Wait! I want some coffee!','Wait! I want some coffee!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22151,'Ride now! Ride out dere and bring me back some heads!','',0,0,0,0,0,0,0,0,1,0,12068,0,26124),
(22152,'I can only assume that you know who I am. And yet you insist on disturbing me?$b$bWhat could you possibly want that requires my attention?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22153,'Uhh, who are you?','Uhh, who are you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22154,'Oh come now, don\'t be ridiculous! I\'m the one and only Budd Nedreck!$b$bI\'ve been all over this land, from the top of Mount Hyjal to the depths of the Sunken Temple. In fact, I was the first to call it the Sunken Temple!$b$bYes, that was me. Don\'t give it a second thought.\n\n','',5,1,274,0,500,1000,0,0,1,0,0,0,26124),
(22155,'I be losin\' me patience! Go on: make dem wish dey was never born!','',0,0,0,0,0,0,0,0,1,0,12069,0,26124),
(22156,'','I highly recommend that you visit Sayge to get your fortune told. I know, I know... he\'s a gnoll.  But he\'s a very special gnoll with the power to divine your future!$B$BAnd we are constantly expanding the faire with all manner of new attractions!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(22157,'Nope, can\'t say I\'ve heard of you.','Nope, can\'t say I\'ve heard of you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22158,'Really? That\'s quite a claim....','Really? That\'s quite a claim....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22159,'Yes, well, listen here, $c. I\'m older than I look and wise beyond my years. You\'d do well not to question me so much.\n\nLook, you don\'t need to take my word for it. Read the postings on any local bulletin board for yourself. I\'m everywhere!$b$bJust do yourself a favor and ignore the ones with \'WANTED\' in the title. Simple misunderstandings, I assure you.','',1,5,274,0,1000,500,0,0,1,0,0,0,26124),
(22160,'Hmm... old coins... ugly jewelry...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22161,'More ugly jewelry... letters home... I\'m beginning to give up hope!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22162,'Hey... what\'s this? A pair of manacles and not just any. These are enchanted. This cargo, it wasn\'t a thing... it was a person!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22163,'No one expects the Dark Iron dwarves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22164,'','Well met, $c. I\'m learning the art of gryphon handling from Baldruc over there. One day, I hope to run my own stable of gryphons.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22165,'WOOP! WOOP! Unauthorized retrieval of valuables detected. Activating security system.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22166,'Where is that dog?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22167,'Will you help me find my dog?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22168,'I miss my dog so much!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22169,'I understand that many individuals seek romance in taverns and festivals like this one, but alcohol dulls the senses and makes calculating the difficulties of daily life all fuzzy!$b$bBut I\'ve found a solution! Through many trials and tribulations, I\'ve engineered an extraordinary device! With these goggles on, ANYONE looks attractive!$b$bMmm... including you, cutie! Tell you what. I\'ll give you a discount!','I understand that many individuals seek romance in taverns and festivals like this one, but alcohol dulls the senses and makes calculating the difficulties of daily life all fuzzy!$b$bBut I\'ve found a solution! Through many trials and tribulations, I\'ve engineered an extraordinary device! With these goggles on, ANYONE looks attractive!$b$bMmm... including you, cutie! Tell you what. I\'ll give you a discount!',1,5,24,0,0,0,0,0,1,0,0,0,26124),
(22170,'','Ooo, walk by again, cutie! Your posterior muscles are very finely toned!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22171,'','Yoohoo! Over here, sweet stuff!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22172,'','You! The cute one! Would you like to go over to my place and look over my tool collection?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22173,'','Sweetie! Are you interested in a woman able to hold intelligent discourse and look attractive while doing so?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22174,'','Yoooohoo, you well-proportioned charmer, you!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22175,'','What an impressive display of alluring prospects!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22176,'Lady Jaina told me to speak to you about using a gryphon to survey Alcaz Island.','Lady Jaina told me to speak to you about using a gryphon to survey Alcaz Island.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22177,'What\'s happening?','What\'s happening?',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(22178,'','What\'ll it be, sweety?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22179,'I\'d like a drink.','I\'d like a drink.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22180,'I hear you\'re quite the cook.','I hear you\'re quite the cook.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22181,'','Oh, me a cook?  I suppose that\'s true.  A barmaid\'s got to work in the kitchens from time to time, and I\'ve learned a few recipes over the years.  Nothing too special, but they\'re hearty enough to fill Grok\'s substantial belly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22182,'I\'d love to learn more.','I\'d love to learn more.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22183,'','I\'m sorry $n, but you\'ve already learned all I know about cooking.  Of course, you never know when our cooks will whip up something new, so don\'t be shy and be sure to visit again some time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22184,'My brother Krixx thinks he has it bad working in Orgrimmar. Nothing compares to the stench of this place. At least the boss had the decency to give me hazard pay!\n\nWhat? Do you want to see where the zeppelin is? Good thing I\'ve got my zeppelin tracker right here!','My brother Krixx thinks he has it bad working in Orgrimmar. Nothing compares to the stench of this place. At least the boss had the decency to give me hazard pay!\n\nWhat? Do you want to see where the zeppelin is? Good thing I\'ve got my zeppelin tracker right here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22185,'Where is the zeppelin to Orgrimmar right now?','Where is the zeppelin to Orgrimmar right now?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22186,'This troll was positively filthy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22187,'Who in the world would believe these little bits of rock and string possessed any power whatsoever? No energy worth drawing at all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22188,'I told A\'dal that playing host to a mass of flea-bitten refugees would only end in trouble, but would he listen? No, no, what would a Scryer know about such things? Bah.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22189,'When I get home, I\'m going to have a hot bath to scour away the grime. Perhaps two. Or five.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22190,'If they think I\'m about to root around in a troll\'s wardrobe, they are SORELY mistaken.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22191,'What in all the worlds did I do to deserve this job?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22192,'Ugh. Tell me that wasn\'t a cockroach...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22193,'People of Azeroth and Outland... ARE YOU READY TO ROCK?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22194,'This is a little something I like to call...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22195,'THE POWER OF THE HORDE!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22196,'Thank you, and good night!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22197,'Alright... I give up... sniff...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22198,'Be on your guard. We are Theramore\'s first line of defense against its many enemies in the marsh.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22199,'Where is the zeppelin to Grom\'gol right now?','Where is the zeppelin to Grom\'gol right now?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22200,'That hit the shpot! Gimmie anudder one, Coot! *hic*','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22201,'You\'re shayin\' you wan... you wan... *hic* you wan\' me to dansh on dis bar? *hic*','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22202,'Maeshtro! Cue da mushic!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22203,'Now that the deserters have taken over Lost Point, North Point Tower is the most distant of Theramore\'s outposts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22204,'Well, helllooo there, pretty thing...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22205,'Playing hard to get today, I see.... Very well, perhaps I\'ll find you in a better mood later.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22206,'Hmm, don\'t mind if I do!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22207,'','Not now, Mack. I be in no mood for your drunken pawing. Off with ya!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22208,'','There shall be no prison for you this time!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22209,'Whatever you say, princess. But yer simply postponing the inevitable....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22210,'Now why would ya wanna go an\' break poor Mack\'s heart? When I return, I\'ll pray ye\'ve changed yer way of thinkin\'....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22211,'Yer wearin down, princess. I can sense it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22212,'','Beat it, Mack! Else I\'ll have Budd cook ya fer my hounds....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22213,'','There be nuthin\' here to drink, Mack. Away with ya!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22214,'','Go jump in the lake, won\'t ya Mack? I smelled ya before I saw ya....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22215,'Well now, what vision of loveliness is this?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22216,'Ahh, my precious Ameenah! How wonderful to see you again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22217,'Hrmph. I never liked her anyway....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22218,'Mmm, nuthin a little lubrication won\'t fix!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22219,'Never drink before 5 o\'clock, momma used to say. Well, momma, it\'s bound to be 5 o\'clock somewhere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22220,'<cough> Ugh...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22221,'Whooo! Like daddy used to say, just makin room fer more! Heh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22222,'Ooohh. Somethin\'s not agreein\' with the tummy today...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22223,'Hmmm, p\'rhaps I\'ll rest these old bones for a bit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22224,'Budd\'s crew, ye mean?$b$bAye, he be no respecter of persons. He\'ll take on anyone who can work a shovel$b$b...\'cept them undead. Budd hates \'em. Personally, I think he\'s scared of \'em.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22225,'Who is this Budd fellow?','Who is this Budd fellow?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22226,'What can a guy like me be doin\' for a $r like you at a time like this?\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22227,'Sumthin\' I can do fer ya, $c?\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22228,'If yer here to partake in the big spoils, ya best be gettin\' in line!$b$bMy share be long overdue....\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22229,'Beats me, kid. I\'m new to the crew.$b$bI\'ve had my fill of troll-killin\' and grog drinkin, I can tell ya that. Only thing left to see is the treasure Budd keeps promisin\'....\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22230,'Interesting crew you\'ve got here....','Interesting crew you\'ve got here....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22231,'Budd\'s crew, ye mean? Aye, he be no respecter of persons. He\'ll take on anyone who can work a shovel.$b$b\'cept them undead. Budd hates \'em. Scared of \'em, likely as not.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22232,'Aye, ya never know who\'s gunna join next, or who be dyin\' next for that matter.$b$bMy advice? Don\'t be gettin\' too attached to anyone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22233,'Agreed. Budd\'s scraped together rif-raf from all over creation.$b$bSeems when there\'s free booze to be had, there be plenty of folk willin\' to set aside their differences.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22234,'Whew! What\'s that smell?','Whew! What\'s that smell?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22235,'<sniff\'s himself, and winces>$b$bThat there be the smell of adventure, $c!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22236,'<hic>Lissen here, $r. Spend a day or two wrestlin\' with wild trolls and then tell me how you smell!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22237,'Ohh, that. See, there\'s been nuthin\' but orc grog around camp lately.$b$bOrc grog doesn\'t seem to agree with me, if ya know what I mean....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22238,'','Uh huh.  Whatever you say.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22239,'','Idiot.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22240,'','Would you please shut up?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22241,'','Remind me once again why it is that I don\'t just leave?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22242,'','You have got to be the most incompetent officer I have ever met!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22243,'','With all due respect, sir, stick it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22244,'','James? James... No, you\'re not James, but I know who you are...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22245,'','You\'re the one who tracked down the brutes who did this to us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22246,'','I tried so hard to tell Jim... to tell anyone... who was behind this, but I couldn\'t find a way...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22247,'','Thank you for helping us and for helping Jim. If you see him, tell him little Jimmy and I love him and that we\'re waiting for him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22248,'Mommy, when will we see Daddy again?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22249,'','I don\'t know when we\'ll see Daddy again, Jimmy, but I know he loves you and he misses you very much.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22250,'','Oh my, let me change those bandages!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22251,'','That should slow the infection down a little.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22252,'','Turgore! Get up and help me unload, you lazy peon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22253,'','Useless orc! Just you wait, one day I\'ll drop somethin in yer grog that you\'ll NEVER wake up from....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22254,'','Say, Brend, why is it that you never make eyes at me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22255,'Well, Marge, I\'ve actually been looking for a way to tell you this....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22256,'Try as I might, I can\'t seem to drink you pretty!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22257,'Welcome to Sentry Point, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22258,'','Oohhhh. How dare you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22259,'','Let that be a lesson to ya....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22260,'Hahahahahahahah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23861,'Rise up the servants, rush into battle! May the fallen knight find peace!','',0,0,0,0,0,0,0,0,1,0,11963,11963,26124),
(22262,'I\'m sorry... sniff...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22263,'Okay... you got us... sniff...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22264,'Please, no more... I hurt all over... sniff...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22265,'','Say, Brend, whisper me somethin\' sweet, will ya?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22266,'','But Brend, yer always drinkin\'!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22267,'','Filthy orc!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22268,'Lissen Marge, I thought I told ya never to bother me when I be drinkin\'....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22269,'Hey Morgom, looks like Margie here be needin\' some attention. What\'dya say?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22270,'Zug Zug!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23455,'With death, we have long been friends ... What awaits me now in the wasteland?','',0,0,0,0,0,0,0,0,1,0,11964,11964,26124),
(22272,'Time to make some room!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22273,'Outta my way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22274,'Watch out boys!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22275,'I need room to operate!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22276,'','I could use a hand here, $c.$b$bHow \'bout you make yourself useful?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(22277,'What can you tell me about this Budd fellow?','What can you tell me about this Budd fellow?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22278,'','Nuthin\' good!$b$bI\'m on to that one. He lures fools in with promises of wealth, keeps \'em drunk, an\' then uses \'em to do his dirty work - which ends up gettin\' em killed often as not.\n',5,396,0,0,500,0,0,0,1,0,0,0,26124),
(22279,'Then what are you doing here?','Then what are you doing here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22280,'','Good question. You\'d hafta ask my brother Turgore that one.$b$bMaybe you can get an answer out of that lazy, no good... oohh. Don\'t get me started.\n\n',396,388,0,0,500,0,0,0,1,0,0,0,26124),
(22281,'Sniff... We\'re all out... The Dark Iron dwarves... sniff... Come back later...  sniff...','Sniff... We\'re all out... The Dark Iron dwarves... sniff... Come back later...  sniff...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22282,'Looks like I\'ll have to get my drink elsewhere.','Looks like I\'ll have to get my drink elsewhere.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22283,'','Hey there. I\'m watching these whelps until their owners come along with the proper secret passwords.',3,1,0,0,2,0,0,0,1,0,0,0,26124),
(22284,'Enter code to receive Netherwhelp pet.','Enter code to receive Netherwhelp pet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22285,'Pitiful mortal, Onyxia answers to no one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22286,'Your pathetic challenge has not gone unnoticed. I shall enjoy toying with you before you die.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22287,'Hurry, mon! I be doomed!$b$bI see what they be doin\' to prisoners, an\' I be too young to die!$b$bYa gotta do somethin\', and soon!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(22288,'What can you tell me about this place?','What can you tell me about this place?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22289,'Listen, mon!$b$bI tell ya all I be knowin\', but first ya gotta be savin\' me from these savages and their killer bears.$b$bDeal?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(22290,'Brogg is glad Mudsprocket goblins have let him stay here, but sometimes thinks he hears them laughing at him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22291,'I would like to enter the secret code to receive my Murloc costume.','I would like to enter the secret code to receive my Murloc costume.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22292,'Hooray! Tanzar be free, mon!$b$bWhat luck! All that an\' not even a chipped tusk.$b$bCharmed, mon. That\'s what I be. No sense denyin\' it.','',5,1,0,0,500,0,0,0,1,0,0,0,26124),
(22293,'You\'re welcome.... Now tell us what\'s going on in here!','You\'re welcome.... Now tell us what\'s going on in here!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(22294,'What can you tell us about Budd?','What can you tell us about Budd?',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(22295,'','I\'ve never experienced cold like this, $r. Even in the absence of ice and snow, the frozen wastes of Northrend are extremely taxing.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(22296,'I wish to purchase reagents, Yazmina.','I wish to purchase reagents, Yazmina.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22297,'Say, you look familiar. Have we met?','',396,6,0,0,0,0,0,0,1,0,0,0,26124),
(22298,'Do I know you?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(22299,'Lemme give you some advice: Never trust a gnome.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(22300,'I need some booze, Coot.','I need some booze, Coot.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22301,'Ok mon, a deal be a deal....$b$bIt was night when we all snuck in to Zul\'Aman fer a look around.$b$bAll was quiet, til we be hearin\' a rustlin\' sound, like the wind through the trees. Before we know it, we be surrounded by these savages and their pets! Next day, I be wakin\' up here, stuck in a cage.$b$bDay an\' night, one by one, prisoners be gettin\' killed. Every time one be dyin\', that bear-troll be lookin\' stronger.$b$bThat be all I know \'bout this place, mon. And I don\'t wanna be knowin\' any more!','',5,1,1,0,500,1000,0,0,1,0,0,0,26124),
(22302,'When I grow up I want to be a stable man!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(22303,'Cut the chatter, kid. I need to stable my pet.','Cut the chatter, kid. I need to stable my pet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22304,'','This inn was built before the savages from the north awoke. Thank the Light for that, at least!$B$BWill you be staying long?',396,6,0,0,0,0,0,0,1,0,0,0,26124),
(22305,'I wish to browse your wares, Hazel.','I wish to browse your wares, Hazel.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22306,'That man be nuthin\' but a fool!$b$bFame, fortune? Phooey! This place be nuthin\' but a deathtrap, mon!$b$bI seen all kinds a\' trolls in my day, but these, they be different - sneaky, strong, tricky.$b$bSeemed to me like they knew we was comin\'....\n','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(22307,'Dealin\' wit\' *hic* poison and alco... *hic* booze ish dangeroush...','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(22308,'I require some components, Sorely.','I require some components, Sorely.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22309,'<Budd rolls his eyes as he sees you draw near>$b$bAhh, yes, the soon-to-be-famous $n!$b$bTo what do I owe the pleasure of your company?','',1,6,0,0,1000,0,0,0,1,0,0,0,26124),
(22310,'The party you sent to Zul\'Aman is being slaughtered! You must do something!','The party you sent to Zul\'Aman is being slaughtered! You must do something!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22311,'Now, now, $n, just relax and take a deep breath. You really need to learn to trust me.$b$bYour lack of experience in these situations is causing you to panic, and panic always exaggerates the truth. So you see, there really is no crisis.$b$bNow that we\'ve settled that, I must ask that you stop being so negative. It\'s not good for the crew\'s morale....','',1,1,0,0,1000,0,0,0,1,0,0,0,26124),
(22312,'If you\'re as accomplished as you claim, why don\'t you investigate Zul\'Aman yourself?','If you\'re as accomplished as you claim, why don\'t you investigate Zul\'Aman yourself?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22313,'What a silly question! Clearly, $n, I\'ve overestimated you.$b$bIt should be apparent to you that someone needs to stay focused on the big picture here. Being the only one remotely qualified, alas, that burden falls to me.$b$bIn truth, I envy you, $c. I would much rather be the one to enter Zul\'Aman and cleanse it of those savages. You should consider yourself lucky....\n\n','',1,1,0,0,1000,0,0,0,1,0,0,0,26124),
(22314,'Fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22315,'Burn, mutants, BURN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22316,'Drink it all boys!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22317,'It\'s not a party without some crashers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22318,'Did someone say, \"Free Brew\"?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22319,'If you need to speak with Apprentice Garion, you\'ll find him inside the cottage with Tabetha. At least there, he can\'t steal all the reagents.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22320,'I wish we had a priest or a druid out here. I can\'t continue my studies until I\'ve recovered from my injuries.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22321,'Wait, don\'t tell me... $n, right?$b$bWhat can I do for you?\n','',1,1,0,0,1000,0,0,0,1,0,0,0,26124),
(22322,'What became of your previous \'partners\'?','What became of your previous \'partners\'?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22323,'Oh, well, that all depends on which partners you mean. Many have come and gone over the years - always someone eager to ride the coat-tails of the legend that is Budd Nedreck!$b$bYou can rest assured that most of them have become wealthy and retired. That\'s simply not the path I\'ve chosen. You see, I\'ve always felt that I\'ve been called to reveal the world\'s great mysteries. Alas, if I don\'t do it, who could?\n','',1,1,0,0,1000,0,0,0,1,0,0,0,26124),
(22324,'How about this latest crew - what became of them?','How about this latest crew - what became of them?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22325,'Ahh, them - a sad tale, that one.$b$bThey have disappeared behind the walls of Zul\'Aman. I haven\'t heard from them in days.$b$bI\'ve seen it a hundred times; that overeager itch for fame and fortune. I tried to hold them back, told them they weren\'t prepared, but in the end they chose to face their peril....','',1,1,0,0,1000,0,0,0,1,0,0,0,26124),
(22326,'Gee, Budd, is there anyone alive who can back up these claims of yours?','Gee, Budd, is there anyone alive who can back up these claims of yours?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22327,'Listen, $n, you should know by now that when fortune comes knocking, you open the door and ask questions later. Chances like this don\'t come along every day!$b$bNow, are you in or not, $c?$b$b<Budd doesn\'t wait for a reply>$b$bOf course you are! Now, there\'s work to be done, and so far I\'ve seen a lot of talking and no action. I suggest you show me something before I find a replacement.$b$bThere are thousands who would kill for an opportunity like this, I assure you!','',1,1,0,0,1000,0,0,0,1,0,0,0,26124),
(22328,'Hi there! We\'re being blockaded by those good-for-nothing pirates out in the bay!$B$BDo you think you can help us out?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(22329,'Hi there! We\'re being blockaded by those good-for-nothing pirates out in the bay! Do you think you can help us out by dropping a few bombs on them?!$B$BOur stolen zeppelin\'s here; hop on board before she sets sail!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(22330,'Hi there! We\'re being blockaded by those good-for-nothing pirates out in the bay! Do you think you can help us out by dropping a few bombs on them?!$B$BOur stolen zeppelin\'s less than $3078w minutes away.  Make sure you\'re onboard when she leaves!','',5,6,0,0,0,0,0,0,1,0,0,0,26124),
(22331,'Hi there! We\'re being blockaded by those good-for-nothing pirates out in the bay! Do you think you can help us out by dropping a few bombs on them?!$B$BOur stolen zeppelin\'s almost here... I think I hear her now.  Make sure you\'re onboard when she leaves!','',5,6,0,0,0,0,0,0,1,0,0,0,26124),
(22332,'I\'m a prisoner!$B$BThey shot me and my beautiful zeppelin out of the sky. And what for? Because I was ferrying men and materiel for the Horde? That\'s nothing new!$B$BNow they have me running her in circles around the bay so that they can bomb the pirates. I just don\'t have the parts to keep her going like this! I\'m barely keeping her together on spit and bailing wire!$B$BIt\'s a crime I tell you!','',5,396,0,0,0,0,0,0,1,0,0,0,26124),
(22333,'I\'m a prisoner!$B$BThey shot me and my beautiful zeppelin out of the sky. And what for? Because I was ferrying men and materiel for the Horde? That\'s nothing new!$B$BNow they have me running her in circles around the bay so that they can bomb the pirates. I just don\'t have the parts to keep her going like this! I\'m barely keeping her together on spit and bailing wire!$B$BI won\'t be held responsible for what happens to you, but you might as well get on board before she leaves.$B$BIt\'s a crime I tell you!','',5,396,0,0,0,0,0,0,1,0,0,0,26124),
(22334,'I\'m a prisoner!$B$BThey shot me and my beautiful zeppelin out of the sky. And what for? Because I was ferrying men and materiel for the Horde? That\'s nothing new!$B$BNow they have me running her in circles around the bay so that they can bomb the pirates. I just don\'t have the parts to keep her going like this! I\'m barely keeping her together on spit and bailing wire!$B$BIf you\'re determined to help them out, she\'s due to arrive back in port in less than a minute.$B$BIt\'s a crime I tell you!','',5,396,0,0,0,0,0,0,1,0,0,0,26124),
(22335,'I\'m a prisoner!$B$BThey shot me and my beautiful zeppelin out of the sky. And what for? Because I was ferrying men and materiel for the Horde? That\'s nothing new!$B$BNow they have me running her in circles around the bay so that they can bomb the pirates. I just don\'t have the parts to keep her going like this! I\'m barely keeping her together on spit and bailing wire!$B$BIf you\'re determined to help them out, she\'s due to arrive back in port in less than $3078w minutes.$B$BIt\'s a crime I tell you!','',5,396,0,0,0,0,0,0,1,0,0,0,26124),
(22336,'My zeppelin has docked. Despite my being held captive, and the sorry state that she\'s in, she\'ll be departing the dock again in two minutes.','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(22337,'The zeppelin\'s leaving for a tour around the bay in less than one minute!  Oh, and if anyone feels like setting me free, I\'m on the dock.','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(22338,'The blazing flames are safely extinguished.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22339,'Disturbing','Disturbing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22340,'RETREAT!!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22341,'So, when does this excavation of Zul\'Aman begin?','So, when does this excavation of Zul\'Aman begin?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22342,'Listen, $n, you should know by now that when fortune comes knocking, you open the door and ask questions later. Chances like this don\'t come around every day! Are you in or not?$b$b<Budd doesn\'t wait for a reply.>$b$bOf course you are! Now, there\'s work to be done, and so far I\'ve seen a lot of talking and no action. I suggest you show me something before I find a replacement.$b$bThere are thousands who would kill for an opportunity like this, I assure you!','',1,1,0,0,1000,0,0,0,1,0,0,0,26124),
(22343,'Patience, $n. I didn\'t become the renowned Budd Nedreck by being hasty.$b$bFinal preparations are being made and soon the treasures and secrets of Zul\'Aman shall be mine! $b$b<Budd pauses and looks at you for a moment, then chuckles.>$b$b...ours I mean, of course.','',1,1,0,0,1000,0,0,0,1,0,0,0,26124),
(22344,'I want to go back to the orphanage!','I want to go back to the orphanage!',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(22345,'Matron!  Is that bad man going to eat us?','Matron!  Is that bad man going to eat us?',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(22346,'If my dad were alive, he would put out the fires!','If my dad were alive, he would put out the fires!',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(22347,'If my mom were alive, she would put out the fires!','If my mom were alive, she would put out the fires!',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(22348,'I brought you a housewarming gift, Jarl.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22349,'Go on, open it. I think you\'ll like it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22350,'Jarl?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22351,'Unless it\'s something I can eat, I don\'t want it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22352,'Jarl, you haven\'t been yourself ever since I arrived. What\'s going on?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22353,'Nothing. Wanna help me whip up some frog leg stew?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22354,'I came out here to visit you, Jarl! And I find you living in an empty cabin in the middle of nowhere, babbling about frogs? You\'re hopeless!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22355,'','%s hums a melody over the well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22356,'','%s sighs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22357,'','%s smiles as she continues to draw water from the well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22358,'','Dropping a coin down the well, Lissan looks around to see if anyone noticed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22359,'Go away, whoever you are! Witch Hill is mine... mine!','Go away, whoever you are! Witch Hill is mine... mine!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22360,'It was... terrible... the demon...','It was... terrible... the demon...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22361,'The manor... someone else... will soon be consumed...','The manor... someone else... will soon be consumed...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22362,'The darkness... the corruption... they came too quickly for anyone to know...','The darkness... the corruption... they came too quickly for anyone to know...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22363,'Why have you come here, outsider? You will only find pain! Our fate will be yours...','Why have you come here, outsider? You will only find pain! Our fate will be yours...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22364,'The darkness will consume all... all the living...','The darkness will consume all... all the living...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22365,'It is too late for us, living one. Take yourself and your friend away from here before you both are... claimed...','It is too late for us, living one. Take yourself and your friend away from here before you both are... claimed...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22366,'It is too late for Jarl... its hold is too strong...','It is too late for Jarl... its hold is too strong...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22367,'Day and night all I do is sit here and make ammo and restring crossbows.$B$BI suppose you want me to do something for you too?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(22368,'Finlay, let me see what you have for sale.','Finlay, let me see what you have for sale.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22369,'Listen, $c, it\'s clear that you and your friends know your way around Azeroth. Surely you\'ve come across certain folks who hunger for fame and fortune. $b$bSend me anyone who might be willing to enter Zul\'Aman and I\'ll make it worth your while.','',1,1,0,0,1000,0,0,0,1,0,0,0,26124),
(22370,'This land was mine long before your wretched kind set foot here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22371,'All who venture here belong to me, including you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22373,'He\'s gone?  Hooray!','He\'s gone?  Hooray!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(22374,'Hallow\'s End is a scary holiday, but I like it!','Hallow\'s End is a scary holiday, but I like it!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(22375,'For years beyond counting these woods have burned. They are fueled by an ancient magic and are the mating grounds for the brood mother and her proto-drake consorts.$B$BBut now a long-forgotten evil has reawakened and seeks once again to enslave the offspring of the brood mother for their own purposes.$B$BThese vrykul have caused a disturbance that is extending the boundary of the clutch, and threatens your people.','',34,0,0,0,0,0,0,0,1,0,0,0,26124),
(22376,'This is an insult! An affront! They deny us participation in time-honored dwarven traditions!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22377,'They\'ve sent muscle to get revenge! Scatter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22378,'This board is used by the Steamwheedle representatives at Mudsprocket to post bounties and job notices.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22379,'','I don\'t think Drazzit\'s going to have any luck finding anyone to kill this raptor. I mean, he\'s already raised the reward twice...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22380,'','Keep firing!  Cut off their reinforcements!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22381,'','Cover fire, now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22382,'','Keep them split from their main force!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22383,'You supplied the crew with disguises?','You supplied the crew with disguises?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22384,'Indeed! They were given every advantage I could muster. I simply can\'t imagine what went wrong.$b$bHere, $c, take one. I\'ve made a couple of modifications - little refinements really. Now there\'s no excuse for failure!','',1,1,0,0,1000,0,0,0,1,0,0,0,26124),
(22385,'Down the free brew and pelt the Guzzlers with your mug!','Down the free brew and pelt the Guzzlers with your mug!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22386,'Are you suggesting I provide you with people for Zul\'jin\'s sacrifices?','Are you suggesting I provide you with people for Zul\'jin\'s sacrifices?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22387,'Perish the thought!$b$bI\'m simply trying to rid the world of a horrible menace, and that type of thing rarely comes without a price, as I\'m sure you know.$b$bThink of it like this, $n. You\'ll be offering ordinary folks the chance to become heroes! A rare opportunity indeed!$b$bYou just send them my way and I\'ll handle the rest....','',1,1,0,0,1000,0,0,0,1,0,0,0,26124),
(22388,'Are we going to hide in our mountain and let those swill-peddlers have their little shindig without us?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22389,'DAMN RIGHT! We\'ll show \'em why you don\'t cross the Dark Iron dwarves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22390,'Everybody try to keep de Amani Empire down. Now we got friends. We wit de Zandalari now. We part of something bigger. You can\'t stop us all. De whole world gonna drown in blood!!','',0,0,0,0,0,0,0,0,1,0,24231,0,26124),
(22391,'Smash their kegs! DRAIN BREWFEST DRY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22392,'You might wanna stand back. Fish guttin\' is a dirty job.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22393,'Yeah!','Yeah!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22394,'Right!','Right!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22395,'You said it!','You said it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22396,'Damn straight!','Damn straight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22397,'No way!','No way!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22398,'Not on your life!','Not on your life!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22399,'NO!','NO!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22400,'As my most recent gift to the lowly inhabitants of Azeroth, the evil Zul\'jin is no more!','',1,1,0,0,1000,0,0,0,1,0,0,0,26124),
(22403,'The last ten strains from Undercity... all of them worthless!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22404,'I cannot work under these conditions!  We need a viable strain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22405,'The plague samples they\'ve sent us would not even hurt a rat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22406,'We were making progress with our plague in Undercity.  All of a sudden our strains keep failing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22407,'The Royal Apothecary Society welcomes you to Northrend, $c.  Now, what is it that you will do to aid us in Sylvanas\' service?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(22410,'%s absorbs the essence of the bear spirit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22411,'Quick! Run!','Quick! Run!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22412,'I\'m out of here!','I\'m out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22413,'You\'ll never catch me!','You\'ll never catch me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22414,'Go go go!','Go go go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22415,'Get over here, you idiot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22416,'Me crush puny friend of dragons!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22417,'You leave Stonemaul lands now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22418,'Why you wake ghost? Where other Stonemauls?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22419,'%s looks weak enough to capture!','',0,0,0,0,0,0,0,0,1,11587,0,0,26124),
(22420,'Break time.','Break time.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22421,'Watch it there.','Watch it there.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22422,'Let\'s work smarter, people. The captain wants this done by the end of the week!','Let\'s work smarter, people. The captain wants this done by the end of the week!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22423,'Break time\'s over, ladies.','Break time\'s over, ladies.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22424,'Do you even know what you\'re doing?','Do you even know what you\'re doing?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22425,'Faster!','Faster!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22426,'No! A little to the left... there, you have it.','No! A little to the left... there, you have it.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22427,'Look out for that beam!','Look out for that beam!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22428,'At the rate this is going, we\'re not going to finish on time.','At the rate this is going, we\'re not going to finish on time.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22429,'There is little else I can teach you, $c. Please, speak with my colleague Kalinda if you wish to know more of the craft.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22430,'You\'ve reached the limits of my enchantments. Sedana can instruct you further.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22431,'','If you wish to advance further in the fine art of tailoring, please speak with my employer, Keelen. He can show you more than I ever will.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22432,'%s absorbs the essence of the eagle spirit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22433,'%s absorbs the essence of the lynx spirit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22435,'%s absorbs the essence of the dragonhawk spirit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22436,'','The situation out here is worse than I thought! The zeppelin is little better than a heap of twisted metal and burning fuel!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22437,'A Lion Seal has become alerted to your presence and begins bellowing a warning!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22438,'Thank you! There\'s no telling what those brutes would\'ve done to me.','Thank you! There\'s no telling what those brutes would\'ve done to me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22439,'A %s senses a potential meal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22440,'','Welcome to Theramore, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22441,'Oh, we\'re from Blackrock Mountain,\nWe\'ve come ta drink yer brew!\nDark Iron dwarves, they do not lie,\nAnd so yeh know it\'s true!','Oh, we\'re from Blackrock Mountain,\nWe\'ve come ta drink yer brew!\nDark Iron dwarves, they do not lie,\nAnd so yeh know it\'s true!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22442,'Yeh will not try our bitter, \nYeh will not serve our ale!\nBut have Brewfest without our lot?\nJust try it, and ye\'ll fail!\n','Yeh will not try our bitter, \nYeh will not serve our ale!\nBut have Brewfest without our lot?\nJust try it, and ye\'ll fail!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22443,'So lift a mug to Coren,\nAnd Hurley Blackbreath too!\nThis drink is weak, without much kick,\nBut oi!  At least it\'s brew!','So lift a mug to Coren,\nAnd Hurley Blackbreath too!\nThis drink is weak, without much kick,\nBut oi!  At least it\'s brew!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22444,'We\'ll drink yer stout and lager,\nDrain all the pints and kegs!\nWe\'ll drink and brawl and brawl and drink,\n\'til we can\'t feel our legs!','We\'ll drink yer stout and lager,\nDrain all the pints and kegs!\nWe\'ll drink and brawl and brawl and drink,\n\'til we can\'t feel our legs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22445,'And when the brew\'s all missin\'\nTa Shadowforge we\'ll hop,\nA bitter toast ta Ragnaros...\n... but bring him not a drop!','And when the brew\'s all missin\'\nTa Shadowforge we\'ll hop,\nA bitter toast ta Ragnaros...\n... but bring him not a drop!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22446,'[DNT] Verse 6','[DNT] Verse 6',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22447,'Marksmen, form up and take your positions!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22448,'Prepare to fire upon my command! Ready, aim...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22449,'FIRE AT WILL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22450,'There\'s the flare. Left cannon, ready!','There\'s the flare. Left cannon, ready!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22451,'Range.','Range.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22452,'Fire!','Fire!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22453,'Center cannon, ready.','Center cannon, ready.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22454,'Right cannon, ready.','Right cannon, ready.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22455,'Mr. Ely!','Mr. Ely!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22456,'Where are my recovered cannonballs?','Where are my recovered cannonballs?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22457,'Very well.  Carry on Mr. Ely.','Very well.  Carry on Mr. Ely.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22458,'Sir!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22459,'I have top men and women on it even as we speak, sir!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22460,'Aye, aye, sir!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22461,'All cannons, ready.','All cannons, ready.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22463,'All o\' this shootin\' at Skorn and other places o\'er the horizon, and what do ya think it\'s gotten me?$B$BCannonball recovery duty!$B$BNot exactly what I signed up fer, ya know?','',6,5,0,0,0,0,0,0,1,0,0,0,26124),
(22464,'','Time for some rest, sweety, or just something to eat and some relaxation?$B$BWell, if anyone deserves it, it\'s you!',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(22465,'What do you have to eat, Celeste?','What do you have to eat, Celeste?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22466,'Get him, Fiend!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22467,'That\'s it!  Bite the sword arm!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22468,'Easy, boy!  Don\'t ruin the dummy now!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22469,'I surrender! Stay your blade!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22470,'I will go with you. Just spare my men. They\'re good lads who\'ve only made a mistake...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22471,'What\'s this? No, no, there must be some misunderstanding. I can explaaaiiin....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22472,'So, dis be Budd?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22473,'You be the worm my captives be cursin\'? I expected more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22474,'So long as yer fools be fillin\' my cages with sacrifices I\'d be a fool to kill ya.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22475,'But be knowin\' this, little man - no matter where ya be hidin\', when me pyres grow dim, I\'ll be feedin\' them with yer bones!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22476,'And then, forever on, yer soul be my plaything....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22477,'I\'ll be seein\' ya, little man Budd. Sooner than later I\'ll be bettin\'.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22478,'I haven\'t much time to talk unless it\'s urgent, citizen. The gates of Theramore are my greatest responsibility.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22479,'Lieutenant Aden always volunteers for gate duty. That\'s fine by me.$B$BI\'ve got a post that allows me a good view of my guards AND the daughters of the tradesmen at the same time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22480,'Are you here to relieve me? I\'m certain it\'s almost time. Well, if you want to relieve me anyway, let me know. I could use a drink or three.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22481,'Thank the Light the Defias don\'t know the first thing about diving!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22482,'I don\'t have the Repaired Diving Gear anymore. Do you have a spare?','I don\'t have the Repaired Diving Gear anymore. Do you have a spare?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22483,'Fire!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22484,'','What you need are schematics far beyond my own meager offerings. Danwe here can show you some true technological delights!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22485,'You couldn\'t have come at a better time!  Let\'s get out of here.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22486,'Yes, let us leave... but not before we leave our Alliance hosts something to remember us by!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22487,'They have limited supplies in this camp.  It would be a real shame if something were to happen to them.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22488,'Captain Adams sent me out here to investigate what\'s happening at Halgrind. This is as close as I\'ve been able to get, however; the abandoned Vrykul tower affords me some amount of cover from prying eyes.$B$BThe Forsaken are up to no good over there. I can feel it!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(22489,'Ah, yes... watch it burn!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22490,'We\'re almost done!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22491,'That\'ll teach you to mess with an apothecary, you motherless Alliance dogs!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22492,'Let\'s high-tail it out of here.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22493,'Don\'t shoot!  Apothecary coming through!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22494,'We\'re in your debt, friend.  Speak to Lysander at Vengeance Landing; he will arrange a suitable reward for you.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22495,'Ahahaha! I must find the secrets!','Ahahaha! I must find the secrets!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22496,'I don\'t want to know anymore. Make me forget!','AI don\'t want to know anymore. Make me forget!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22497,'When one studies and digs, one reveals the truth.','When one studies and digs, one reveals the truth.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22498,'We\'re safe; IT will never reach us here!','We\'re safe; IT will never reach us here!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22499,'The end is nigh! That Which Must Not Be Named is almost free!','The end is nigh! That Which Must Not Be Named is almost free!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22500,'IT\'s coming! HIDE!','IT\'s coming! HIDE!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22501,'If only there were more time!','If only there were more time!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22502,'Forgive me oh great one. I did not mean to learn the truth!','Forgive me oh great one. I did not mean to learn the truth!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22503,'The truth shall set you free. Like us, you will be with IT forever!','The truth shall set you free. Like us, you will be with IT forever!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22504,'Now that you know the truth, I can\'t let you leave!','Now that you know the truth, I can\'t let you leave!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22505,'It\'ll all be over soon. Soon you will be in the embrace of That Which Must Not Be Named!','It\'ll all be over soon. Soon you will be in the embrace of That Which Must Not Be Named!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22506,'Intruder! You were sent to destroy us!','Intruder! You were sent to destroy us!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22507,'You cannot leave... IT mustn\'t find us!','You cannot leave... IT mustn\'t find us!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22508,'If you\'re here, then IT might be close behind!','If you\'re here, then IT might be close behind!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22509,'I will put an end to your life before you realize the horrible truth!','I will put an end to your life before you realize the horrible truth!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22510,'Now you\'ll have to join us... permanently!','Now you\'ll have to join us... permanently!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22511,'Welcome to Theramore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22512,'What enchantments interest you today, $c?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22513,'','Is there a pattern or two I can show you today?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22514,'You\'ve surpassed my own knowledge, but Bemarrin over there can teach you far more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22515,'','I\'m afraid you\'re at the limits of my knowledge. Camberon is more skilled in alchemy than I. Please speak with him if you\'re interested in advancing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22516,'Lady Jaina would not send a messenger with such haste if she did not believe her information reliable.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22517,'With their newfound patronage and apparent role in the king\'s disappearance, I see no choice but to plan a renewed offensive against the Defias.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22518,'Convey my thanks to Lady Jaina and let her know that we will pursue the Defias and their backers until our liege is safely returned!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22519,'Lynalis can help you more than I, $c. Speak with her to learn more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22520,'','Don\'t be such a fool, Bolvar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22521,'','The Defias are little more than a band of thugs. We should be busy combatting Stormwind\'s real enemies instead of chasing baseless speculation!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22522,'I\'m ready to travel to Stormwind.','I\'m ready to travel to Stormwind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22523,'Pleased to meet you, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22524,'Can you send me to Theramore? I have an urgent message for Lady Jaina from King Wrynn.','Can you send me to Theramore? I have an urgent message for Lady Jaina from King Wrynn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22525,'The peace of Ogri\'la shall be restored!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22526,'Lucc is the one to speak to now, $n, to further your skill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22527,'','There are eight types of Darkmoon Cards; Beasts, Blessings, Elementals, Furies, Lunacy, Portals, Storms and Warlords, with eight cards, Ace to Eight in each suit. If you collect all eight of one suit then you can turn them into a deck that you can give to our Professor Thaddeus Paleo in exchange for a powerful trinket.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(22528,'','The Headless Horseman\'s mind is plagued with dementia!  During Hallow\'s End, he might attack this village at any moment.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22529,'','The Headless Horseman has set fire to the village!  We must protect the children!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22530,'','The Headless Horseman is attacking!  Quickly, aid your Horde brethren in the village\'s defense!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22531,'','The Headless Horseman had been driven away, for now.  We may breath easy for a time, but must remain ever vigilant.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22532,'Hallow\'s End is a scary holiday, but I like it!','Hallow\'s End is a scary holiday, but I like it!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(22533,'What\'s happening?','What\'s happening?',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(22534,'I want to go back to the orphanage!','I want to go back to the orphanage!',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(22535,'Matron!  Is the Headless Horseman going to eat us?','Matron!  Is the Headless Horseman going to eat us?',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(22536,'If my dad was alive, he would put out the fires!','If my dad was alive, he would put out the fires!',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(22537,'If my mom was alive, she would put out the fires!','If my mom was alive, she would put out the fires!',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(22538,'Is he gone?  Hooray!','Is he gone?  Hooray!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(22539,'Welcome back to the greatest show in Outland, my friend!  It is truly a delight to see you once again.$B$BPlease, step right up and once more take in all we have to offer.  Be sure to check around, as we are always adding new and exciting things to the Darkmoon Faire!  Amaze at wonders old and new that we have uncovered!  We continue to spare no expense in bringing you excitement that children of all ages will delight in!','',2,1,1,0,0,0,0,0,1,0,0,0,26124),
(22540,'Greetings my friend, and welcome to the greatest show in Outland!$B$BPlease, step right up and take in all we have to offer.  Amaze at the wonders that the Darkmoon Faire has uncovered in this vast and mysterious world!  We have spared no expense in bringing you excitement that children of all ages will delight in!','',66,1,1,0,0,0,0,0,1,0,0,0,26124),
(22541,'Welcome one and all to the greatest show on all of Azeroth... the Darkmoon Faire!  Adventure and excitement await, don\'t be shy!  Mysteries and prizes for both the young and the old are here for the taking.  And be sure to speak with the professor about any Darkmoon Cards that you have come across during your travels!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22542,'Greetings friends, and welcome to the greatest show on Azeroth!$B$BPlease, step right up and take in all we have to offer.  Ride the rides and see the sights!  Amaze at the wonders that the Darkmoon Faire has uncovered in this vast and mysterious world!  We have spared no expense in bringing you excitement that children of all ages will delight in!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22543,'Everyone enjoying themselves so far?  That\'s great!  Welcome to the Darkmoon Faire, the greatest show in all of Outland!  Make sure that you speak with Yebb and his friends here while you\'re taking in Neblegear\'s Darkmoon Zoo Bizarre.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22544,'Welcome one and all to the Darkmoon Faire, the greatest event in all the worlds!  We have it all... delicious food, strong drink, exotic artifacts, fortunes read, amazing prizes and excitement without end!  Don\'t forget to turn in your Darkmoon Faire Prize Tickets to Gelvas Grimegate!  All it takes is five or more and you\'re on your way to the most wondrous prizes in all of Outland.  Everybody is a winner!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22545,'','I\'ll take good care of your pets, don\'t you worry!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(22546,'The Darkmoon Faire is the greatest event in all of Outland!','The Darkmoon Faire is the greatest event in all of Outland!',71,0,0,0,0,0,0,0,1,0,0,0,26124),
(22547,'SOMEONE TRY THIS SUPER BREW!!','SOMEONE TRY THIS SUPER BREW!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22548,'Welcome to Theramore, $c. Looking for something?','Welcome to Theramore, $c. Looking for something?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(22549,'You look like an intelligent person. Why don\'t you read one of these leaflets and give it some thought?','You look like an intelligent person. Why don\'t you read one of these leaflets and give it some thought?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22550,'It wasn\'t me! $n did it, I swear!','',1,1,0,0,1000,0,0,0,1,0,0,0,26124),
(22551,'WAAAHH! This was all $n\'s idea! Some of my best friends are forest trolls....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22552,'We shouldn\'t have left so many behind at Valgarde. Admiral Keller, that insufferable egomaniac!$B$BHow am I to fulfill my orders with so few? I need enough men to stay here at the keep and still properly garrison Fort Wildervar when it\'s ready!$B$BAt least we have a hope of dealing with our problems now that you\'re here.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(22553,'I advise the captain on matters that he chooses to share with me, but I have a feeling that he\'d rather hear from you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(22554,'','All of these mouths to feed, and who has to do it? Me!$B$BAll the cooking, and the cleaning, and everything else!',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(22555,'...receive 50 percent off deserter undergarments? What is this garbage?','...receive 50 percent off deserter undergarments? What is this garbage?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22556,'...as a deserter, you\'ll enjoy activities like tethered swimming and dog grooming? How ridiculous!','...as a deserter, you\'ll enjoy activities like tethered swimming and dog grooming? How ridiculous!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22557,'In all of my days I never thought to see such a magnificent new frontier.$B$BIf only it weren\'t tainted by evil and knowledge which is best left hidden.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(22558,'I\'ve seen a lot of things in my time, but the change that came over the Explorers\' League in the Whisper Gulch takes the cake.$B$BI\'m just glad that I got out of there with my skin intact!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(22559,'...the deserters seek a Theramore where citizens will be free to juggle at all hours of the day? What is this nonsense?','...the deserters seek a Theramore where citizens will be free to juggle at all hours of the day? What is this nonsense?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22560,'You\'ve reached the limits of my skill. Farii was my instructor, and I\'m sure she\'ll instruct you as well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22561,'...to establish the chicken as the official symbol of Theramore?! These guys are nuts!','...to establish the chicken as the official symbol of Theramore?! These guys are nuts!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22562,'...to create a fund for the purchase of hair gel? I like my hair the way it is, thanks!','...to establish a fund for the purchase of hair gel? I like my hair the way it is, thanks!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22563,'Miall is the next step in your training, friend $c. You\'ve grown beyond what I can teach you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22564,'Your time learning at my side draws to a close, friend. Akham will gladly instruct you further.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22565,'','It is time for you to expand your knowledge with another teacher; Ockil has unlocked many fascinating wonders of the engineer, and will lead you on your path to discovery, yes?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22566,'','You flatter me, but it is my colleague Refik who deserves your attention now, not I.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22567,'','You seek to uncover mysteries I myself have yet to unlock, $c. Please, discuss these matters with Nahogg instead.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22568,'You must walk before you can run. Speak with Feruul for training, and attend well to his lessons.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22569,'It is time for you to move on. Telonis, a night elf located within the Craftsmen\'s Terrace in Darnassus, is the next step in your training.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22570,'Deriz is the one you should speak with if you wish to learn the basics of alchemy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22571,'Have you ever wished to see the boughs of Teldrassil, $n? You should, for there is an elf there who can teach you more. Seek out Ainethil in Darnassus on the Craftsmen\'s Terrace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22572,'','Please, not now. Speak with Edrem. He can show you what you need to know.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22573,'','You may ask yourself, \"What is next?\" I have the answer. To learn more of our art, you must travel across the sea to an awe-inspiring place known as Ironforge. The forge there is one of the largest in the land! Bengus Deepforge, found in the Great Forge, can instruct you further.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22574,'The Tauren Chieftains play on this stage at the top of every hour. Show some energy: Cheer the minstrels on to capture some of the event\'s intensity!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(22575,'I am busy, $c. Your time would be better spent discussing matters with Kudrii.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22576,'The Tauren Chieftains concert will begin in thirty minutes!  Come celebrate the opening of the Darkmoon Faire in Terokkar, just south of Shattrath City!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22577,'The Tauren Chieftains concert will begin in fifteen minutes!  Come celebrate the opening of the Darkmoon Faire in Terokkar, just south of Shattrath City!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22578,'The Tauren Chieftains concert will begin in five minutes!  Come celebrate the opening of the Darkmoon Faire in Terokkar, just south of Shattrath City!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22579,'The more powerful enchantments are beyond even me, $n. Your path should lead you through Elwynn Forest to the Tower of Azora, where your next tutor spends her days. Her name is Kitta Firewind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22580,'People of Outland, are you ready to rock?! The Tauren Chieftain concert now begins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22581,'For simple schematics of your skill level, speak with Ghermas, if you would.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22582,'Gnomes! Gnomes are marvelous people. Wonderful! And they hold such knowledge of the engineering arts! You must travel to Ironforge, to Tinkertown, and speak with Springspindle Fizzlegear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22583,'Tsk. Respect your elders. It is Kayaart who should train you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22584,'You have reached the limits of my knowledge, but there is more yet to learn. Across the sea, in the Mage Quarter of Stormwind City, a great tailor dwells. His name is Georgio Bolero, and he will train you now, I think. Go and speak with him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22585,'','Your skill impresses me greatly, $n! It is time for you to head to Outland to learn more. If you head to Hellfire Peninsula, Tatiana will take you on as a student in Honor Hold. Or, if you prefer working with the Aldor, Hamanar can instruct you in Shattrath City, on Aldor Rise.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22586,'','Your skill has grown immense, $c. In order to further your instruction, you must journey to Outland itself. Kalaen will train you in Thrallmar, within Hellfire Peninsula. If you prefer, you can speak to the rather prudish Hamanar on Aldor Rise within Shattrath City, though I wouldn\'t advise it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22587,'Harken, cur!  Tis you I spurn!  Now feel... the burn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22588,'I thought we talked about this, Brogg. You can\'t stay in this building. Sure, it can house you, but there\'s no room for anyone else!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22589,'You said Brogg could stay here! You promised Brogg you\'d help regain Stonemaul clan mound!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22590,'Yes, we said you can stay here, but this building is our headquarters! All of our manuals and blueprints are stored here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22591,'But this the only building that fit Brogg! Goblins make buildings too small!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22592,'I\'m inclined to say they made ogres too big! I can see I\'m not going to convince you to move now, but don\'t think this is permanent!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22593,'The ground... is frozen.  We\'re sitting ducks here; these meatwagons aren\'t going anywhere.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22594,'High Executor Anselm wants a report on the situation.','High Executor Anselm wants a report on the situation.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22595,'What does it look like?  The ground is frozen like a rock!$B$BThe wheels on these meatwagons were built to go over mud at best.  We\'re going to need an abomination and some chains to salvage them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22596,'I will never call Brackenwall Village my home. To do so is to give up hope of reclaiming our rightful lands.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22597,'','Hi $c, I\'m Ashli, and I need you to help me \'cause I\'m trapped in this cage \'cause Budd sent me in here with some yucky trolls and stinky orcs and silly humans and a drunk dwarf and we got caught by super-bad trolls and they dragged us off and they put me in here with the big troll-cat who\'s really really mean and kills all the people in the cages and I think he\'s gunna kill me too really soon but I can\'t get out by myself so...$b$b<Ashli takes a deep breath.>$b$bCan you kill that thing?\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22598,'Goblin Gumbo Kettle','Goblin Gumbo Kettle',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22599,'Fishing Chair','Fishing Chair',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22600,'Spectral Tiger Mount','Spectral Tiger Mount',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22601,'We did it boys!  Now back to the Grim Guzzler and we\'ll drink to the $3096W that were injuredl!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22602,'RETREAT!!  We\'ve already lost $3096W and we can\'t afford to lose any more!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22603,'There are $3094W activated dwarves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22604,'Curse this frozen land!  We\'ll never move these meatwagons to the front!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22605,'Curses!  We might as well dismantle these for parts!  They\'re useless to us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22606,'Dig the wheels out, we don\'t have much time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22607,'Listen, stranger, I\'d love to sit and chat, but me head\'s poundin\' somethin\' fierce.$b$bHow \'bout ye git these good fer nothin\' trolls to stop makin\' such a racket. Then we\'ll get to talkin\', eh?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22608,'Well then, I spose I be owin\' ya my thanks, $r.$b$bTruth is, I thought I\'d swallowed me last tankard \'til ye showed up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22609,'So, how does a dwarf like you end up in a place like this?','So, how does a dwarf like you end up in a place like this?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(22610,'A sad tale, that one - a wee bit embarrassin\' too.$b$bMy people be know fer havin\' a taste fer the ale, ya know. And I be no exception. Seems I been given more than me share of the thirst.$b$bSo I run inta ol\' Budd ya see, an\' he offers me all the grog I can swallow fer joinin\' his crew - a move I\'ve come to regret.$b$bOne night, after drinkin\' enough grog to drop a Kodo, I was lured into followin\' Budd\'s band o\' misfits into Zul\'Aman.$b$bThat be the last I recall before findin\' meself in that cage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22611,'','Ohh, thank you soo much for getting me out of that cage because I was in there for soo long and it smelled like minced mutton that had been sitting out in the sun for a week and I don\'t like mutton to begin with because when I was little, well littler, I was actually turned into a sheep for a minute and so I know what it feels like to be a sheep and I don\'t want someone eating me, especially an overgrown troll dressed up like a kitty....$b$b<Ashli takes a deep breath.>$b$bHow\'s my hair?\n',21,4,11,0,1000,500,0,0,1,0,0,0,26124),
(22612,'How\'d a perky little gnome like you get caught up in a mess like this?','How\'d a perky little gnome like you get caught up in a mess like this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22613,'','I wanted to practice my spells on the bunnies outside my home to make my magic stronger so I could go and kill all the bad guys in Gnomeregan and let all the gnomes go back home but momma said I was too young to go on adventures but then I met Mister Budd and he told me that you\'re only as young as you feel and that I could come here with his friends and I would get all the practice I needed but then we got caught and put in the cages...$b$b<Ashli takes a deep breath.>$b$bAre you a real $r?\n',1,275,6,0,1000,500,0,0,1,0,0,0,26124),
(22614,'','The stranded Alliance sailors know they\'re going to die, yet they fight us tooth and nail.$B$BImpressive and pathetic at the same time.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(22615,'','It will be a matter of hours before the Alliance in the Derelict Strand are crushed.  They are surrounded and outnumbered.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(22616,'','By the will of Sylvanas, our enemies will fall.',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(22617,'High Executor Anselm requests your report.','High Executor Anselm requests your report.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22618,'','It is those two cannons along the wall that are slowing us down.  Without their protection our forces would be able to rush their fortification without taking any losses.$B$BIt\'s either take out those cannons or wait until they run out of ammunition.  Anselm\'s choice, I suppose.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22619,'','The Headless Horseman, once a knight of the Silver Hand and a hero among his fellow paladins, is cursed.  Driven insane within the Scarlet Monastery, he believes that he is alive and we are dead.$B$BNow, his fervor no longer serves the Light.  With the coming of Hallow\'s End, he spreads gloom and fire across the villages of Azeroth.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22620,'Who is the Headless Horseman?','Who is the Headless Horseman?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22621,'Nevermind me, $r. $b$bKraz as good as dead. Leave now, $r, before bad trolls get you too.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22622,'','Give me your souls that I might slay the enemy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22623,'Crush them!  Crush their faces!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22624,'Hold positions!  Keep vrykul men back!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22625,'Kill vrykul scum!  For Sylvanas!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22626,'Don\'t let vrykul come through!  Kill all!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22627,'Some things Gorth has to do himself!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22628,'You no match for Gorth!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22629,'Gorth no care if he die!  Gorth get put back together!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22630,'Freedom! Kraz life was over.$b$bI thank you, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22631,'What happened to you, orc?','What happened to you, orc?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22632,'Kraz should never have come to this cursed place... should have known not to trust the human. A blind fool I was, $c, as are you if you follow his counsel.$b$bMy son, lost for two moons, was last seen with the human, Budd. He told me I could find him behind the walls of Zul\'Aman....$b$bI followed his people here, and was captured with the rest. Without your help, I was doomed to die.$b$bThank you, stranger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22633,'We did it! We\'ve defeated Tethyr!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22634,'We defeated the sea monster!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22635,'Come in out of the cold and rest your weary bones a while. Our hospitality is yours.','Come in out of the cold and rest your weary bones a while. Our hospitality is yours.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22636,'','You will not stop my work here!  My husband-king will awaken!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22637,'Please, let me out of here!','Please, let me out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22638,'The key... you have to find the key!','The key... you have to find the key!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22639,'I think I saw a key on one of those vrykul.','I think I saw a key on one of those vrykul.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22640,'I don\'t want to be taken down into the catacombs!','I don\'t want to be taken down into the catacombs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22641,'I don\'t want to be sacrificed!','I don\'t want to be sacrificed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22642,'They\'re performing unholy rites down in the catacombs, and I\'m about to be the sacrifice!','They\'re performing unholy rites down in the catacombs, and I\'m about to be the sacrifice!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22643,'Is there no hero to rescue me?','Is there no hero to rescue me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22644,'This is the end.','This is the end.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22645,'Oh, thank you, thank you!','Oh, thank you, thank you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22646,'Thank you.  I will not forget this!','Thank you.  I will not forget this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22647,'Avenge my friends who have already been sacrificed!','Avenge my friends who have already been sacrificed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22648,'You have to put a stop to this madness before it\'s too late!','You have to put a stop to this madness before it\'s too late!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22649,'My thanks to you, hero!','My thanks to you, hero!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22650,'The vrykul are evil and must be destroyed!','The vrykul are evil and must be destroyed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22651,'You saved my life!','You saved my life!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22652,'Thank goodness for you!','Thank goodness for you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22653,'','Don\'t let them take the Windrunner you worthless mutts!  Stand your ground!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22654,'','I\'m going to gut the lookouts that scouted these reefs!  We walked right into their blasted trap!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22655,'','Kick these Alliance mongrels off our ships!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22656,'','Defend our cannons at all costs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22657,'Walk in the Light, my child.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(22658,'[DEBUG] SPLIT','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22659,'[DEBUG] GROW AND EXPLODE','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22660,'[DEBUG] SHRINK AND EXTINGUISH','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22661,'Fire grant me vision...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22662,'Archers at the ready!  Hold your fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22663,'What fool dares to enter her majesty\'s dominion unannounced?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22664,'Water grant me serenity...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22665,'Ah, but it is you who intrudes on our master\'s territory.  He could wipe you out in an instant for that transgression alone!  Arthas does not have much love or patience for his escaped slaves.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22666,'%s inhales the wispy smoke tendrils emanating from the burner.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22668,'%s falls into a trance.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22669,'But... he has learned of your victory over Stormwind\'s North Fleet and thinks you have potential.  Potential to see reason and abandon Sylvanas\' childish rebellion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22670,'Thank you, spirits.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22671,'Arthas is prepared to offer you power beyond your imagination.  The puny army you lead here would pale in comparison to the phalanxes at your command if you returned to the Scourge\'s embrace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22672,'Dark Iron dwarves!!!','Dark Iron dwarves!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22673,'They\'re after the beer!','They\'re after the beer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22674,'Someone has to save the beer!','Someone has to save the beer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22675,'If you value your beer, run for it!','If you value your beer, run for it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22676,'Run!  It\'s the Dark Iron dwarves!','Run!  It\'s the Dark Iron dwarves!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22677,'Work faster, people!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22678,'We know some of the truth. Now we must uncover the rest!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22679,'Kill anyone who tries to interfere!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22680,'Their coming will herald the end of the world!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22681,'You there, stop slacking!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22682,'We\'re safe here, my brothers and sisters, while the rest of the world will perish.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22683,'Sometimes even I wish that I didn\'t know. But then I realize it\'s for the best.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22684,'Quiet, did you hear that?!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22685,'$n, my child, come here, I have something to ask of you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22686,'Is that all you\'ve come to say?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22687,'Send these scumbags back to hell!  Fire at will!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22688,'It\'s coming right for us!','It\'s coming right for us!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22689,'FIRE! FIRE!','FIRE! FIRE!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22690,'Shoot it between the eyes! Those beasts are vulnerable there!','Shoot it between the eyes! Those beasts are vulnerable there!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22691,'Invader incoming!','Invader incoming!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22692,'Don\'t let those monsters through the gate! Stand firm, soldiers!','Don\'t let those monsters through the gate! Stand firm, soldiers!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22693,'$G Sir : Ma\'am;! I\'m here to assist and defend you.$B$BYour orders?','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(22694,'For ages, I was lost.  Now, finally, I see how dark my soul had become...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22695,'Horseman rise...','Horseman rise...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22696,'Your time is nigh...','Your time is nigh...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22697,'For Ymiron!','For Ymiron!',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22698,'Beg for your life...','Beg for your life...',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22699,'Your end draws closer!','Your end draws closer!',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22700,'YAAARRRGH!','YAAARRRGH!',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22701,'Suffer, insect!','Suffer, insect!',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22702,'My life for Ymiron!','My life for Ymiron!',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22703,'What are these things?!','What are these things?!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22704,'Where are they coming from?!','Where are they coming from?!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22705,'What do they want?!','What do they want?!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22706,'This is madness!','This is madness!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22707,'I don\'t know, but they\'re big and they\'re pissed!','I don\'t know, but they\'re big and they\'re pissed!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22708,'They\'re definitely not gnomes.','They\'re definitely not gnomes.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22709,'Let me stop fighting for my life and ask them - oh wait... Who cares! Just kill!','Let me stop fighting for my life and ask them - oh wait... Who cares! Just kill!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22710,'Does it really matter?','Does it really matter?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22711,'Total shot in the dark here but I\'d guess they\'re coming from that gigantic evil castle. I could be wrong.','Total shot in the dark here but I\'d guess they\'re coming from that gigantic evil castle. I could be wrong.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22712,'Idiot...','Idiot...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22713,'Us dead? I dunno... Just a guess.','Us dead? I dunno... Just a guess.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22714,'That\'s the 64,000 gold piece question, isn\'t it? ','That\'s the 64,000 gold piece question, isn\'t it? ',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22715,'They want you to stop asking questions! Shut up and fight!','They want you to stop asking questions! Shut up and fight!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22716,'Reminds me of the time I was stationed at Cenarion Hold during the second war of the shifting sands... Remember that orc? Saurfang? Damndest thing I ever did see.','Reminds me of the time I was stationed at Cenarion Hold during the second war of the shifting sands... Remember that orc? Saurfang? Damndest thing I ever did see.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22717,'I\'m no orc lover but yea, wish he were here right now. He\'d dismantle these things!','I\'m no orc lover but yea, wish he were here right now. He\'d dismantle these things!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22718,'Heard he\'s Thrall\'s right hand orc. Hangs up dragon heads in his spare time.','Heard he\'s Thrall\'s right hand orc. Hangs up dragon heads in his spare time.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22719,'Heard he sent Ragnaros back to the elemental planes by himself...','Heard he sent Ragnaros back to the elemental planes by himself...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22720,'You felt death once...','You felt death once...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22721,'Now, know demise!','Now, know demise!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22722,'Behold the Vrykul!   A race that has perfected war and destruction to the point of an art form.  Already they\'ve cast their lot with the Lich King!  Their dwellings surround you and their numbers are easily five times yours.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22723,'The choice is yours, Anselm.  Return to the Lich King\'s army and fight alongside them or remain loyal to your so-called queen and suffer their wrath as they drive you from their homelands!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22724,'Here, kitty kitty.....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22725,'Where ya be mon? Ya dang kitty\'s are sneaky!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22726,'Coo Yah! There ya be!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22727,'Look at ya mon! You be out here all day tryin\' to find em!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22728,'There be one mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22729,'Aranal, ledel! Their fate shall be yours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22730,'Our gryphons are still learning the lay of the land, $c, so I can only offer you short flights to other places in the fjord. Where do you want to go?','Our gryphons are still learning the lay of the land, $c, so I can only offer you short flights to other places in the fjord. Where do you want to go?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22731,'Take me to Valgarde Port.','Take me to Valgarde Port.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22732,'Take me to Westguard Keep.','Take me to Westguard Keep.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22733,'Take me to Fort Wildervar.','Take me to Fort Wildervar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22734,'Not so fast.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22736,'Your blood is mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22737,'%s clears his throat.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22738,'I look across this base and all I see is fear... Are you gonna be scared when the Lich King\'s armies are sittin\' pretty in Stormwind? Ironforge? NO! You\'re not. And do you know why? Because you\'ll be dead, that\'s why.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22739,'So when you\'re feeling that tinglin\' sensation at the base of your spine and you\'re \'bout ready to wet your pants, embrace it. Let it enrage you. That fear is the only thing that\'s gonna keep you breathin\'.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22740,'Am I clear? Do you understand what I\'m sayin\'? I don\'t wanna have to send any more coffins or letters home.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22741,'Removing','Removing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22742,'The pumpkin head smolders forebodingly...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22743,'%s groans.','%s groans.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22744,'%s screams in agony as the harpoon is removed.','%s screams in agony as the harpoon is removed.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22745,'%s whimpers.','%s whimpers.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22746,'Call the Headless Horseman.','Call the Headless Horseman.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22747,'Not... no... Our people... Wyrmskull... some live...','Not... no... Our people... Wyrmskull... some live...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22748,'My injuries are too great. I won\'t make it... Our citizenry held in cages... ritual...','My injuries are too great. I won\'t make it... Our citizenry held in cages... ritual...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22749,'I\'m done for... too much blood lost... Forget about me, tell Keller... People still alive inside...','I\'m done for... too much blood lost... Forget about me, tell Keller... People still alive inside...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22750,'My family must know... I... for them... always for them...','My family must know... I... for them... always for them...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22751,'They left us here impaled as a warning to the others... Several still alive... prisoners of...','They left us here impaled as a warning to the others... Several still alive... prisoners of...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22752,'Don\'t let my death go unavenged, stranger... give... them... hell...','Don\'t let my death go unavenged, stranger... give... them... hell...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22753,'You have my thanks, hero. If you don\'t mind, I\'d like to stay by your side and exact a little vengeance upon my captors!','You have my thanks, hero. If you don\'t mind, I\'d like to stay by your side and exact a little vengeance upon my captors!',0,0,0,0,0,0,0,7,1,6614,0,0,26124),
(22754,'Best pray I don\'t get out of here, scum.','Best pray I don\'t get out of here, scum.',0,0,0,0,0,0,0,7,1,6614,0,0,26124),
(22755,'So help me... If I get out of this cage there will be hell to pay.','So help me... If I get out of this cage there will be hell to pay.',0,0,0,0,0,0,0,7,1,6614,0,0,26124),
(22756,'Thanks for the opportunity to dole out some payback. I\'m going to head back to Valgarde now, friend.','Thanks for the opportunity to dole out some payback. I\'m going to head back to Valgarde now, friend.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22757,'So eager you are, for my blood to spill. Yet to vanquish me, \'tis my head you must kill!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22758,'Such a futile gesture.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22759,'','Make haste, $c!$b$bThis crisis is nowhere near being under control.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22760,'Many thanks! Allow me to repay you by killing a few dozen of these beasts!','Many thanks! Allow me to repay you by killing a few dozen of these beasts!',0,0,0,0,0,0,0,7,1,6614,0,0,26124),
(22761,'Thanks, friend. Looking for another to join your group?','Thanks, friend. Looking for another to join your group?',0,0,0,0,0,0,0,7,1,6614,0,0,26124),
(22762,'I will help you out before I head back to Valgarde. It\'s the least I could do.','I will help you out before I head back to Valgarde. It\'s the least I could do.',0,0,0,0,0,0,0,7,1,6614,0,0,26124),
(22763,'I hear they\'re sacrificing prisoners up at their ritual grounds. I think the place is called Gjalerbron...','I hear they\'re sacrificing prisoners up at their ritual grounds. I think the place is called Gjalerbron...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22764,'This will not be the last you hear of me.  I will return to spit on your corpse after Utgarde\'s armies have descended upon you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22766,'Listen to your men\'s dying breaths as I drink in their souls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22767,'You seek passage somewhere, $n?  My bats will get you there in no time.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(22768,'I need to fly to the Windrunner.  Official business!','I need to fly to the Windrunner.  Official business!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22769,'','%s focuses her energies upon the corpse of the fallen.',0,0,0,0,0,0,0,0,1,6595,0,0,26124),
(22770,'','Unworthy...',0,0,0,0,0,0,0,0,1,6595,0,0,26124),
(22771,'','A worthless offering...',0,0,0,0,0,0,0,0,1,6595,0,0,26124),
(22772,'','An unfavorable verdict...',0,0,0,0,0,0,0,0,1,6595,0,0,26124),
(22773,'','You have failed...',0,0,0,0,0,0,0,0,1,6595,0,0,26124),
(22774,'Sergeant, loan me your spyglass.','Sergeant, loan me your spyglass.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22775,'%s dangles a key in front of the prisoner.','',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22776,'Tread carefully, $r.$b$bYou wouldn\'t be the first to die here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22777,'Do ya want it, monkey? Do ya??','',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22778,'Your stench sickens me. I\'d kill you myself if it were not for Angerboda.','',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22779,'The day of reckoning draws near. Aberrations like you will be destroyed...','',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22780,'How much longer do you think your town can hold out? It will be crushed soon... Soon, little one.','',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22781,'How will you stop that which you fear so much, little one?','',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22782,'My heart grows darker... Soon I will be judged... Worthy of the Val\'kyr! Worthy of the Lich King!','',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22783,'A creature emerges from the shadows!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22784,'Cannonfire rings off in the distance, followed by the sound of a whistling cannonball coming from above.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22785,'','These Alliance pondsuckers sure are gutsy!  Boarding fully-manned Forsaken destroyers... now that\'s suicidal behavior if I ever heard of it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22786,'Hah! You thought to interfere with my ascension? Nothing can stop me now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22787,'You think I do not know what you are trying to do? You think I haven\'t been watching you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22788,'You will not stop my ascension, tiny $r. Time to die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22789,'No! You will not defeat me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22790,'','My sisters and I welcome you, $r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22791,'','How unfortunate, Halfdan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22792,'','We find you unworthy of ascension, Halfdan. Let your soul know oblivion!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22793,'Reports from the test on the enemy fleet have come in, sir!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22794,'Well... the good news is we forced the reinforcements to turn back.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22795,'The plague was not quite... fatal.  However, reports of harmful effects include nausea, loss of equilibrium and severe stomach pain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22796,'Yes, sir!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22797,'Excellent.  What\'s the lowdown?  Do we have a bodycount?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22798,'Well, spit it out!  What\'s the bad news?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22799,'Stay sharp, $n.$b$bWe\'re not out of the woods yet....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22800,'Severe stomach pain?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22801,'SEVERE STOMACH PAIN?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22802,'We are the Royal Apothecary Society!  Inducing belly aches is not part of our job description!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22803,'Am I surrounded by amateurs?  I want a full analysis of the new strain by tomorrow morning!  Get on it, Ravien!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22804,'Hail, stranger. If you are looking for a place in need of your help, you have found it.$B$BThe dead reawaken, walk the land, and arrive on ships from across the great ocean. The fjord grows too dangerous even for us, and soon we must leave for safer lands to the north.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(22805,'I am here to assist and defend you.$B$BHow next shall we strike at the enemy?','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(22806,'Please loan me that spyglass.','Please loan me that spyglass.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22807,'','Come closer, young one; my ears aren\'t what they once were, and I care not for raising my voice.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(22808,'I am over here, you fool of a body!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22809,'Captain, I\'ve somehow lost my command insignia.','Captain, I\'ve somehow lost my command insignia.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22810,'Alright, here\'s another. Try not to lose this one!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(22811,'Chief Ashtotem, I have misplaced the token that you gave me.','Chief Ashtotem, I have misplaced the token that you gave me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22812,'Very well, here is another. Please be more careful with this one.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(22813,'For Ymiron!','For Ymiron!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22814,'YAAARRRGH!','YAAARRRGH!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22815,'My life for Ymiron!','My life for Ymiron!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22816,'You tiny creatures disgust me!','You tiny creatures disgust me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22817,'Damn you, Pulroy! Where\'d you put those ciphers!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22818,'Just like the League to leave a dwarf stranded with no help and no ale!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22819,'How do ya lose an entire group of people?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22820,'Look what\'s come to play.','Look what\'s come to play.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22821,'Keller\'s soldiers ain\'t brought me nothin\' in days... No news is good news I \'spose.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22822,'There will be no everlasting life for you!','There will be no everlasting life for you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22823,'I will break you!','I will break you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22824,'Your race is a disease upon the world!','Your race is a disease upon the world!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22825,'Oy! Keller! Any word from the ruins? Anything at all??','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22826,'%s grumbles something under his breath.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22827,'I\'ve already told you, McSorf. I\'ve sent no less than three rescue teams into the ruins and none have returned. I am working tirelessly to keep this port afloat and in one piece! GET OFF MY BACK!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22828,'','I can only hope the treatment will work.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22829,'','I just don\'t have the medical supplies I need to properly treat all of you.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22830,'','Don\'t worry, soldier. Yazmina is going to take care of you.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22831,'','%s shakes her head.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22832,'I need a riding bat to intercept the Alliance reinforcements.','I need a riding bat to intercept the Alliance reinforcements.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22833,'DRINK! BRAWL! DRINK! BRAWL! ','DRINK! BRAWL! DRINK! BRAWL! ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22834,'Help!  My eyes!','Help!  My eyes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22835,'Someone shoot that bat down!','Someone shoot that bat down!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22836,'I don\'t feel so good...','I don\'t feel so good...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22837,'That liquid... it reeks!','That liquid... it reeks!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22838,'I show you strength... in numbers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22839,'When the Darkmoon Faire is open, it will be located in Terokkar Forest in Outland.  We\'ll be pitching our tents just south of Shattrath City!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(22840,'The Darkmoon Faire is right now located in Terokkar Forest in Outland, just south of Shattrath City.  Don\'t miss it!','',1,94,0,0,0,0,0,0,1,0,0,0,26124),
(22841,'It\'s been a pleasure serving with you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22842,'It has been an honor to fight at your side.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22843,'The hound appears to pick up a scent from the north and prepares to sprint to its source.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22844,'Upon reaching its destination the hound becomes startled by noise up ahead and appears ready to flee.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22845,'So many uses for the plague, so little time!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(22846,'Are you nearly recovered from the last time? Let\'s try again...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22847,'Hm, the pressure must be alleviated somewhat...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22848,'The subject is still breathing. Time for another dosage...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22849,'It is a marvel how we were able to set this up in so short a time. Let\'s try again...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22850,'Tell me how this makes you feel.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22851,'What a robust subject we have. Once more, then...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22852,'%s turns a nearby valve and directs his attention to the cage, quill in hand.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22853,'The Dread King sends his regards! Pray that today is the day that we die in battle! Pray that the judgment is favorable!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22854,'','These are all excellent. It\'s going to be hard to choose just one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22855,'','I think I\'ve found the one I\'ll use. Now I have to begin the task of carving it. I don\'t think it\'s going to be easy. I don\'t even know what a female yeti\'s mating call sounds like!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22856,'','I\'ve got most of the basic carving done, but it needs to be tested before I can continue. Are you willing to help me with that, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22857,'My life for the Dread King!','My life for the Dread King!',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22858,'I am ready to die, my lord!','I am ready to die, my lord!',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22859,'The interlopers will be stopped, my lord.','The interlopers will be stopped, my lord.',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22860,'One among us will ascend on this day.','One among us will ascend on this day.',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22861,'One among us will ascend on this day.','One among us will ascend on this day.',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22862,'The val\'kyr surround us, brothers and sisters! Glory comes to those who sacrifice all for the Lich King!','',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22863,'Gunnar, son of Thorvard, has arrived!  Prepare to meet your demise!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22864,'Ingvar sends his dragon riders to descend upon these insects! Soon they will face the awakened force of the Vrykul!','',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22865,'Battle hard, brothers! Rouse our sleeping kin with the echoes of war!','',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22866,'Sacrifice event triggered - beginning countdown...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22867,'Enemies of the Winterskorn, you will be torn limb from limb!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22868,'Drive this scum from the Vrykul homeland!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22869,'AGH! Not again with the sprayin\'!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(22870,'What\'s that n- AGH!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(22871,'Brann\'s beard, just STOP!','',0,0,0,0,0,0,0,6,1,0,0,0,26124),
(22872,'The dwarf coughs, sputters, and shivers in the cage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22873,'A low, despairing moan escapes the caged dwarf.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22874,'%s shakes the bars of the cage weakly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22875,'%s slumps against the cage bars dejectedly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22876,'Are YOU the one who interrupted my dinner? Well, are you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22877,'You\'re too ugly and scrawny to be a female yeti! And now you\'re making me mad...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22878,'','Aren\'t you a sight for sore eyes!$B$BThere\'s work to be done and not much time.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(22879,'I\'ve got Keg Protector marks to redeem...','I\'ve got Keg Protector marks to redeem...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22880,'What do you want with me?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22881,'Release me, cowards! I\'ll show you what a dwarf is made of!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22882,'What did you do with the people of this village!?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22883,'Gorth not afraid of getting killed.  Them Forsaken just put me back together again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22884,'Gorth is confused sometimes.  Gorth is good at killing people so Gorth is made sergeant.  But now Gorth never gets to kill nothing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22885,'Vrykuls is bigger and stronger than us.  But we is better looking!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22886,'','The Blastenheimer 5000 Ultra Cannon is a state-of-the-art single person projectile device. Delivering its payload at near the speed of a dragon, the cannon is the pride and joy of the Blastenheimer family, world renown for their aeronautical and combustible feats!$B$BIf you\'d like to be launched through the skies to fly free as a bird, seek out Maxima Blastenheimer in the Terrace of Light in Shattrath City. She\'ll aim you at a target in a small pond outside the city walls!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(22887,'What\'s a guy gotta do to get some help around here?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22888,'You do know about the giant YETI in the mine, don\'t you?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22889,'That\'s Y-E-T-I. Yeti! You know, the giant, shaggy things with the bloody horns?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22890,'It\'s keeping my boys from expanding the mine. The Alliance needs that ore!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22891,'Are you deaf?! I\'ll be there when Captain Adams is flogging you for holding up the Alliance\'s advance!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22892,'BRAINNNS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22893,'So... Hungry...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22894,'FEED ME...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22895,'FOOD! EAT YOU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22896,'Closer... come closer...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22897,'You hear something, Jones? I almost thought I heard something, right there...','You hear something, Jones? I almost thought I heard something, right there...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22898,'BURNS! IT BURNS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22899,'ARGHHHH...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22900,'Light... light so bright...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22901,'Bad light... hurt...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22902,'Away... go...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22903,'Nope. Didn\'t hear a thing...','Nope. Didn\'t hear a thing...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22904,'$C, are you certain you are ready to leave? Take a moment.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22905,'Let\'s go then.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22906,'She\'s just as beautiful as ever! Please, $n, tell her for me!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22907,'I love you, my precious Irena.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22908,'','Irena sobs gently.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22909,'Time is up! You have failed.... Any remaining prisoners are now SMOKED.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22910,'Perhaps it was a mistake to travel so close to the Rivenwood and Gjalerbron to get here.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(22911,'All four prisoners saved! You are teh uber!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22912,'Come, hero. The Light will guide and protect us.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22913,'Face the blinding judgment of the Light, fiend!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22914,'Back to the cold dark with you!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22915,'I will return you to the hell that bore you!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22916,'%s places the sacred artifact next to Lord Irulon Trueblade.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22917,'My charge ends as your charge begins, Irulon. Farewell and may the Light guide you.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22918,'%s smells the meat, awakens from his slumber, and roars in anger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22919,'Our magic... useless against this sickness!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22920,'The gods have abandoned us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22921,'The end is near, brothers!  This plague eats us from within!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22922,'For your safety, I can only allow you short flights to other places in the fjord. What is your desired destination?','For your safety, I can only allow you short flights to other places in the fjord. What is your desired destination?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22923,'Take me to Vengeance Landing.','Take me to Vengeance Landing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22924,'Take me to New Agamand.','Take me to New Agamand.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22925,'I can\'t offer you anything outside Howling Fjord. The bats still don\'t know their way abroad. Where do you want to go?','I can\'t offer you anything outside Howling Fjord. The bats still don\'t know their way abroad. Where do you want to go?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22926,'Take me to Camp Winterhoof.','Take me to Camp Winterhoof.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22927,'You spar like a girl!','You spar like a girl!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22928,'I train better against a target dummy.','I train better against a target dummy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22929,'You practice as if you\'re still asleep.','You practice as if you\'re still asleep.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22930,'When the little ones come, I won\'t hold back like I am with you.','When the little ones come, I won\'t hold back like I am with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22931,'Sure you don\'t need a break, old woman?','Sure you don\'t need a break, old woman?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22932,'Your sparring is feeble!','Your sparring is feeble!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22933,'Practice or not, you\'re going to spit teeth!','Practice or not, you\'re going to spit teeth!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22934,'Come on, stop trying to hit me and hit me already!','Come on, stop trying to hit me and hit me already!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22935,'A %s appears to defend its dinner.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22936,'I\'ve been in the military my whole life.  I\'ve fought in many wars, under many banners - but they\'ve always been other people\'s battles.$B$BNot this time.  Every Forsaken soldier you see here has come for one reason alone.  Arthas must be killed.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(22937,'Hey, Gil, you give my offer any more thought? I\'ll have plenty of skins and preserved meat to trade for those heavy yeti furs or down your men are working with.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22938,'Much as I\'d like to do business with you, Jethan, all this stuff is the property of the Alliance expeditionary forces.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22939,'Maybe after everything dies down, you and I can make a deal with some of the surplus. I\'m sure the troops will give your people plenty of business as they head into the Grizzly Hills.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22940,'I\'ll be lookin\' forward to it. Guess I\'ll get to preserving this meat, then. A good quartermaster won\'t turn down a reliable supply of rations.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22941,'Barleybrew, finest brewery in Azeroth!  Check them out at Brewfest!','Barleybrew, finest brewery in Azeroth!  Check them out at Brewfest!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22942,'Thunderbrew, finest brewery in all the realms.  Check them out at Brewfest!','Thunderbrew, finest brewery in all the realms.  Check them out at Brewfest!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22943,'Hungry? Can sleep here, too.','',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(22944,'Keep your wits about you, $r, we\'re surrounded by the walking dead here.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(22945,'Thank you, stranger.','Thank you, stranger.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22946,'I must return. Good hunting to you.','I must return. Good hunting to you.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22947,'Blessings of the spirits of the land and air upon you.','Blessings of the spirits of the land and air upon you.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22948,'You saved me from certain death. I owe you.','You saved me from certain death. I owe you.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22949,'We should never have traveled through the Rivenwood. Everyone knows this!','We should never have traveled through the Rivenwood. Everyone knows this!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22950,'Strange ghosts walk the land. Be careful!','Strange ghosts walk the land. Be careful!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22951,'They took us one by one. I\'m sure there are other survivors.','They took us one by one. I\'m sure there are other survivors.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22952,'I owe you a life debt, stranger.','I owe you a life debt, stranger.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(22953,'Take me! I am ready to die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22954,'Drink in their misery, brother!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22955,'Stand and be judged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22956,'May you die in the Lich King\'s favor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22957,'We battle for the glory of Ymiron! We die in the name of the Lich King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22958,'Wait a minute...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22959,'It\'s just...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22960,'Beer! Mere beer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22961,'There\'s absolutely nothing out of the ordinary about it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22962,'You! Not a word to Grick about this! Do you hear me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22963,'I fight wit\' untamed spirit....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22964,'Spirit, come back to me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22965,'The coast is clear. You\'re free!','The coast is clear. You\'re free!',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(22966,'Pssst! Up \'ere, in the cage. Come and lemme get a look at yeh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22967,'Hallooo.... You just gunna sit down there an\' pat yerselves on the back? What kinda rescuers are ya?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22968,'So.... How\'s about one \'a ya stroll on up \'ere an\' help me out, eh?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22969,'Yoohoo. Over here... the trapped dwarf. Come on, lemme have a word with yeh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22970,'Don\'t go leavin\' the job half done, now. Come an\' tell me if it be safe to make my escape!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22971,'Akil\'zon, the invaders approach!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22972,'The ring will overflow with the blood of the interlopers! Oluf has come!','',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22973,'Release the prisoners! Firjus will destroy them all!','',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22974,'Firjus was unworthy! Test your battle prowess against a true soldier of the Lich King!','',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22975,'Good... More flesh for the harvest...','',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(22976,'How\'d I ever let Petrov talk me into coming out here with these incompetent dwarves?!','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(22977,'Where\'s the help that I was promised?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22978,'That guano\'s not going to collect itself!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22979,'There\'s no way I\'m going into the Rivenwood; the place is haunted!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22980,'When we get back, I\'m gonna kill Petrov!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22981,'This is as far north as I go! Those spiders are huge!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22982,'Petrov promised me more help would be coming. What\'s taking so long?!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22983,'I should be down there working on the flying machines, not in charge of guano collection!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22984,'This place was supposed to be safe! Instead we\'re in the middle of hungry worgs and the High Tinker only knows what!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22985,'','Oh Feknut, hush!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22986,'','Everything\'s going to be fine, Feknut. You\'ll see.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22987,'','Feknut, please stop. I\'m worried about Jaren and you\'re not helping.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22988,'','Yes, and we all wish that you\'d stayed back at the keep.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22989,'','Feknut! Enough!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22990,'','You know, you could think about doing the work yourself. That way you could get back to the keep more quickly.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22991,'','Feknut please quiet down. You\'re giving me a headache.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22992,'','Feknut, please! I\'m sure that Petrov will be sending you more help soon.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22993,'Their defenses are down!  Attack!','Their defenses are down!  Attack!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22994,'Ahh, freedom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22995,'A\'course it only be fair that I reward yeh fer me rescue. Now where\'d them savages put me satchel?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22996,'Don\'t be shy, now. Help yerselves. If it weren\'t fer yer help, them basterds\'d be shrinkin\' me head right about now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22997,'That will be enough, Irulon.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22998,'Lord Fordring, you mustn\'t reveal yourself!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(22999,'%s removes his disguise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23000,'The boy\'s death and, in fact, the deaths of all of the knights involved in the redemption of the blade could have been avoided.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23001,'Their passing weighs heavily upon my soul.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23002,'The path of freedom has always been beset with tragedy, sire. We could not risk losing you. The Crusade could not have survived such a blow.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23003,'%s grimaces.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23004,'It should have been me that carried the blade to Northrend. The burden was mine to bear.\n','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23005,'But you are right, Irulon. The price of our freedom will undoubtedly cost thousands more of their lives.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23006,'%s picks up the Ashbringer.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23007,'Do you hear me, Arthas? The Argent Crusade comes for you! Your kingdom shall crumble beneath the weight of justice! By the Light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23008,'[Crude Vrykul] Bjorns mottar haelgond sygar!','[Crude Vrykul] Bjorns mottar haelgond sygar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23009,'No one speaks of my mother in that manner!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23010,'Hey mon! Don\'t ya be forgettin\' about Tanzar over here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23011,'You kill the trollbear, mon? It be safe for Tanzar to come out now?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23012,'Hello out there. Anybody be hearin\' Tanzar?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23013,'I could be pickin\' this lock in my sleep, mon. Just come an\' say when it be safe to get away.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23014,'Pleaase! Someone save poor ol\' Tanzar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23015,'Nalorakk is dead, you\'re free to go.','Nalorakk is dead, you\'re free to go.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(23016,'The ancient cipher falls to the ground.','',0,0,0,0,0,0,0,0,1,6597,0,0,26124),
(23017,'We plaguebringers tend to be slightly more practical than the average apothecary.  After all, we deal with the logistics of deploying the plague.$B$BThat doesn\'t mean our theoretical background isn\'t rock solid.  We just prefer... hands on tasks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23018,'Firjus fears nothing! Release the combatants!','',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(23019,'More souls for the Lich King! Come, little ones! Come!','',0,0,0,0,0,0,0,0,1,6614,0,0,26124),
(23020,'Have you seen the Headless Horseman?  If he comes here then I\'ll fight him and steal his pumpkin!','Have you seen the Headless Horseman?  If he comes here then I\'ll fight him and steal his pumpkin!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23021,'I like to play in the water barrel but I\'m told it\'s not for children.','I like to play in the water barrel, but I\'m told it\'s not for children.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23022,'They say the barrel and buckets are for fighting fires.  Are you a fire fighter?','They say the barrel and buckets are for fighting fires.  Are you a fire fighter?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23023,'The Headless Horseman lives in the Scarlet Monastery with all the other creepy ghosts and humans.','The Headless Horseman lives in the Scarlet Monastery with all the other creepy ghosts and humans.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23024,'They\'re giving candies and treats at the inn!  Guardian Grimwatch says if they don\'t give us a treat... then we get to play a trick on them!','They\'re giving candies and treats at the inn!  Guardian Grimwatch says if they don\'t give us a treat... then we get to play a trick on them!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23025,'Have you seen the Headless Horseman?  The matron says if I look at him, then he\'ll turn me into a pumpkin!','Have you seen the Headless Horseman?  The matron says if I look at him, then he\'ll turn me into a pumpkin!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23026,'You can fill a bucket at the water barrel.  It\'s fun to splash!','You can fill a bucket at the water barrel.  It\'s fun to splash!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23027,'Wahoo! Tanzar be free!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(23028,'I saw soldiers from Stormwind fighting a fire before.  They were heroes!','I saw soldiers from Stormwind fighting a fire before.  They were heroes!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23029,'The Headless Horseman lives in the Scarlet Monastery.  Sometimes he comes out and scares the grown ups, but not me!','The Headless Horseman lives in the Scarlet Monastery.  Sometimes he comes out and scares the grown ups, but not me!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23030,'I got some candy at the inn before.  I can\'t wait to get some more!','I got some candy at the inn before.  I can\'t wait to get some more!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23031,'What luck! Here be one of Tanzar\'s things....','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(23032,'There now. It be a gift to you, to celebrate Tanzar\'s great escape!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(23033,'A little left now - no, no, right....','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(23034,'Hrmm... left, right, wiggle, press....','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(23035,'A little deeper now - almost got it....','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(23036,'To the den of suffering...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23037,'Let\'s see now, press, shake, turn, turn....','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(23038,'Another soul for the scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23039,'Flesh for the miserable slaves below...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23040,'Weakness... Fit for only the lowliest of undeath. To the pit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23041,'','%s appears weak!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23042,'','Thank you. I thought I would die without seeing my sisters again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23043,'','Where am I? What happened to me? You... you freed me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23044,'','I knew Lurielle would send help! Thank you, friend, and give Lurielle my thanks as well!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23045,'Let\'s see now, press, shake, turn, turn....','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(23046,'Ya be havin\' me gratitude, $c.$b$bIf there be anythin\' I can be doin\' fer yeh, just say so.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(23047,'Is it safe? Who has slain the trollbeast?\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23048,'Kraz lives!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23049,'Come to Kraz. Accept my thanks.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23050,'Kraz must meet the slayers of the great troll-beast!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23051,'My liberators! Come down and speak with Kraz.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23052,'','It was kind of the Explorers\' League to allow me to tag along. However, with the dangers in the Rivenwood and surrounding area, it looks like it may have been foolish of me to come without help.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23053,'I wanted to help fight the Headless Horseman, but old Grimwatch wouldn\'t let me!','I wanted to help fight the Headless Horseman, but old Grimwatch wouldn\'t let me!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23054,'The next time the Headless Horseman comes, we\'ll beat him again!','The next time the Headless Horseman comes, we\'ll beat him again!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23055,'My friend was afraid, but not me!','My friend was afraid, but not me!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23056,'You\'re a hero!','You\'re a hero!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23057,'The Headless Horseman was scary, but I wasn\'t scared!  Not me!','The Headless Horseman was scary, but I wasn\'t scared!  Not me!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23058,'The Headless Horseman was scared away!','The Headless Horseman was scared away!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23059,'If he comes back, are you going to fight him again?','If he comes back, are you going to fight him again?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23060,'I wish I had a $gfather:mother; like you!','I wish I had a $gfather:mother; like you!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23061,'The Winterskorn tribe will prevail!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23062,'Drive the invaders out!  For Queen Angerboda!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23063,'Fight without fear and the Val\'kyr will reward you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23064,'Enough of this charade!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23065,'','It\'s hard work putting these things together!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23066,'','The foot bone\'s connected to the... hip bone!  The hip bone\'s connected to this... other bone!  Hmmmhmmmmhmmm...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23067,'','Gotta cut up the rotten bits - only the best components go into my creations!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23068,'I have misplaced my worg disguise.','I have misplaced my worg disguise.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23069,'','Very well, but try not to lose this one, okay?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(23070,'How could you lose it? Very well, but try not to \'lose\' this one as well.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(23071,'The failed concoction spills on the floor and appears to come to life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23072,'Fool.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23073,'','I\'m going to miss Camp Winterhoof, but I understand why Chieftain Ashtotem made his decision. Home is a comfort we cannot always afford.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23074,'<The mangled body of one of the New Agamand apothecaries lies here.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23075,'Take the apothecary\'s pack.','Take the apothecary\'s pack.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23076,'I should be in Utgarde Keep, battling at Ingvar\'s side! Instead I am charged to guard little maggots like you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23077,'Why we don\'t just kill you is beyond my understanding.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23078,'Ingvar has plans for you, little one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23079,'Your time in the Ring of Judgment comes soon, maggot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23080,'%s rattles the cage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23081,'%s loses all self control and begins to attack friend and foe alike!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23082,'I sacrifice this human in the name of our dark master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23083,'Take me, val\'kyr! I am ready to be judged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23084,'I am ready to die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23085,'','Hey, can\'t you shee I\'m trying to drink here?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(23086,'','Right, that should do it. I think ...hic.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23087,'The vrykul clutches at his throat as he begins to gag and thrash about.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23088,'This place reeks of death, stranger.$b$bYou must leave before you fill a cage like Kraz.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23089,'','Bones... flesh... muscles... tendons... cartilage... it all comes together here under my hacksaw.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23090,'We\'ve killed your captors. You\'re free to go.\n','We\'ve killed your captors. You\'re free to go.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23091,'Oh, sick!','Oh, sick!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23092,'That did NOT just happen!','That did NOT just happen!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23093,'I feel ill.','I feel ill.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23094,'Heh, cool!','Heh, cool!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23095,'What kind of sicko are you?','What kind of sicko are you?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23096,'I didn\'t know they could do that.','I didn\'t know they could do that.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23097,'That\'s... special.','That\'s... special.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23098,'That\'s the new Forsaken plague?!','That\'s the new Forsaken plague?!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23099,'It\'s alive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23100,'Steady your hand, you fool!  Those are rare components you\'re spilling on the floor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23101,'The mixture!  It moves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23102,'%s turns to face you.','',0,0,0,0,0,0,0,0,1,6616,0,0,26124),
(23103,'Uh...?','Uh...?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23104,'Yikes.','Yikes.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23105,'Is he okay?','Is he okay?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23106,'Captain\'s not gonna like this.','Captain\'s not gonna like this.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23107,'Interesting.','Interesting.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23108,'Whoa.','Whoa.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23109,'Invaders! Sound the alarm!','Invaders! Sound the alarm!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23110,'Stand clear....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23111,'Please, friends, accept this offering with Kraz\'s thanks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23112,'Greer, I need a gryphon to ride and some bombs to drop on New Agamand!','Greer, I need a gryphon to ride and some bombs to drop on New Agamand!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23113,'Here you go, $g lad : lass;. Make \'em count!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23114,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23115,'Now, where have they put Kraz\'s things?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23116,'So then we too are cursed?','',0,0,0,0,0,0,0,0,1,6595,0,0,26124),
(23117,'%s points to the infant.','',0,0,0,0,0,0,0,0,1,6595,0,0,26124),
(23118,'','%s sobs.',0,0,0,0,0,0,0,0,1,6595,0,0,26124),
(23119,'The gods have forsaken us! We must dispose of it before Ymiron is notified!','',0,0,0,0,0,0,0,0,1,6595,0,0,26124),
(23120,'','NO! You cannot! I beg of you! It is our child!',0,0,0,0,0,0,0,0,1,6595,0,0,26124),
(23121,'Then what are we to do, wife? The others cannot find out. Should they learn of this aberration, we will all be executed.','',0,0,0,0,0,0,0,0,1,6595,0,0,26124),
(23122,'','I... I will hide it. I will hide it until I find it a home, far away from here...',0,0,0,0,0,0,0,0,1,6595,0,0,26124),
(23123,'All hail our glorious king, Ymiron!','All hail our glorious king, Ymiron!',0,0,0,0,0,0,0,0,1,6613,0,0,26124),
(23124,'Let him speak! Be silent!','Let him speak! Be silent!',0,0,0,0,0,0,0,0,1,6613,0,0,26124),
(23125,'Show the abberations no mercy, Ymiron!','Show the abberations no mercy, Ymiron!',0,0,0,0,0,0,0,0,1,6613,0,0,26124),
(23126,'Fire upon Skorn!','Fire upon Skorn!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23127,'Vrykul must remain pure!','Vrykul must remain pure!',0,0,0,0,0,0,0,0,1,6613,0,0,26124),
(23128,'Show them mercy, my king! They are of our flesh and blood!','Show them mercy, my king! They are of our flesh and blood!',0,0,0,0,0,0,0,0,1,6613,0,0,26124),
(23129,'They weaken us! Our strength is dilluted by their very existence! Destroy them all!','They weaken us! Our strength is dilluted by their very existence! Destroy them all!',0,0,0,0,0,0,0,0,1,6613,0,0,26124),
(23130,'%s motions for silence.','',0,0,0,0,0,0,0,0,1,6613,0,0,26124),
(23131,'Shhh!','Shhh!',0,0,0,0,0,0,0,0,1,6613,0,0,26124),
(23132,'The king is going to speak!','The king is going to speak!',0,0,0,0,0,0,0,0,1,6613,0,0,26124),
(23133,'Silence!','Silence!',0,0,0,0,0,0,0,0,1,6613,0,0,26124),
(23134,'Vrykul, your king implores you to listen!','',0,0,0,0,0,0,0,0,1,6613,0,0,26124),
(23135,'The gods have abandoned us!','',0,0,0,0,0,0,0,0,1,6613,0,0,26124),
(23136,'The crowd gasps in horror.','',0,0,0,0,0,0,0,0,1,6613,0,0,26124),
(23137,'Even now, in our darkest hour, they mock us!','',0,0,0,0,0,0,0,0,1,6613,0,0,26124),
(23138,'Where are the titans in our time of greatest need? Our women birth abberations - disfigured runts unable to even stand on their own! Weak and ugly... Useless...','',0,0,0,0,0,0,0,0,1,6613,0,0,26124),
(23139,'Ymiron has toiled. Long have I sat upon my throne and thought hard of our plight. There is only one answer... one reason...','',0,0,0,0,0,0,0,0,1,6613,0,0,26124),
(23140,'For who but the titans themselves could bestow such a curse? What could have such power?','',0,0,0,0,0,0,0,0,1,6613,0,0,26124),
(23141,'And the answer is nothing... For it is the titans that have cursed us!','',0,0,0,0,0,0,0,0,1,6613,0,0,26124),
(23142,'The crowd clamours.','',0,0,0,0,0,0,0,0,1,6613,0,0,26124),
(23143,'On this day all Vrykul will shed their old beliefs! We denounce our old gods! All Vrykul will pledge their allegiance to Ymiron! Ymiron will protect our noble race!','',0,0,0,0,0,0,0,0,1,6613,0,0,26124),
(23144,'The crowd cheers.','',0,0,0,0,0,0,0,0,1,6613,0,0,26124),
(23145,'And now my first decree upon the Vrykul! All malformed infants born of Vrykul mother and father are to be destroyed upon birth! Our blood must remain pure always! Those found in violation of Ymiron\'s decree will be taken to Gjalerbron for execution!','',0,0,0,0,0,0,0,0,1,6613,0,0,26124),
(23146,'%s grins.','',0,0,0,0,0,0,0,0,1,6616,0,0,26124),
(23147,'Shamanism has brought you here... Its scent permeates the air. *The Lich King laughs* I was once a shaman.','',0,0,0,0,0,0,0,0,1,6616,0,0,26124),
(23148,'No, minion. This one is not ready.','',0,0,0,0,0,0,0,0,1,6616,0,0,26124),
(23149,'Do you feel it, mortal? Death seeps through me, enveloping all that I touch. With just a snap of my finger your soul will languish in damnation for all eternity.','',0,0,0,0,0,0,0,0,1,6616,0,0,26124),
(23150,'But... It is not yet your time to serve the Lich King. Yes, a greater destiny awaits you. Power... You must become more powerful before you are to serve me.','',0,0,0,0,0,0,0,0,1,6616,0,0,26124),
(23151,'Now watch, val\'kyr. Observe as I apply pressure. Can you see that it is not yet ripe? Watch as it pops and falls lifeless to the floor.','',0,0,0,0,0,0,0,0,1,6616,0,0,26124),
(23152,'','Shall we prepare it for you, my lord?',0,0,0,0,0,0,0,0,1,6616,0,0,26124),
(23153,'','Oh hooray - you killed the bad troll just in time to save me from being helplessly slaughtered and having my innocent little soul enslaved and used to add power to their wicked scheme to take over Azeroth and seeing how you have risked your lives to free me from certain death I must repay your kindness regardless of who you are or where you may have come from so help me out of here and I will do my best to find some way to reward you....$b$b<Ashli takes a deep breath.>$b$bI hope you like candy....',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(23154,'It\'s safe, little gnome. You can come out now.','It\'s safe, little gnome. You can come out now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23155,'Of course. I found it on the corpse of a dwarf nearby.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23156,'','Wowee! It was amazing how you beat that big bad troll into the ground like that and it\'s too bad I can\'t reach the handle of this cage or I would have jumped in and blown him to bits to get him back for killing all of the other poor prisoners and scaring me so badly and I feel bad for asking you for any more help but could you maybe come over and let me out of here?',21,1,1,0,1000,500,0,0,1,0,0,0,26124),
(23157,'Of course.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23158,'','Ahem... so, I most certainly don\'t blame you for taking your time and catching your breath and congratulating yourselves for such heroism after such a long and hard-fought battle with that horrible monster just so long as when you\'re finished you don\'t forget about me over here because even though I\'m small I think I can still find some way to repay you for your amazing bravery....',1,1,1,0,1000,500,0,0,1,0,0,0,26124),
(23159,'','So... as much as I hate to complain after being saved from a horrible death I just thought you should know that I\'m still over here stuck in one of these messy cages and it would really be great if you could come on over and let me out so I could help you celebrate your amazing victory over that big crazy scary troll-cat... thing.',1,1,1,0,1000,500,0,0,1,0,0,0,26124),
(23160,'','I\'m sure you all must be in a big hurry and probably have some more big dangerous monsters to kill but if you would just take a moment and come help me out of this cage before rushing off it would make me so happy and excited that I would barely be able to contain myself so if you get a moment I\'ll just be over here... waiting... patiently....',1,1,1,0,1000,500,0,0,1,0,0,0,26124),
(23161,'I can get you started on your journey to Northrend. Let me know when you are ready and I will teleport you to your starting point.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23162,'I\'m ready to go!','I\'m ready to go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23163,'Go now! Do the bidding of your masters!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23164,'You wanna go to Zul\'Aman, mon? I be takin\' you der.','',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(23165,'Take me to Zul\'Aman!','Take me to Zul\'Aman!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23166,'You be dead soon enough!','',0,0,0,0,0,0,0,0,1,0,12070,0,26124),
(23167,'I bring da pain!','',0,0,0,0,0,0,0,0,1,0,12071,0,26124),
(23168,'You call on da beast, you gonna get more dan you bargain for!','',0,0,0,0,0,0,0,0,1,0,12072,0,26124),
(23169,'Make way for da Nalorakk!','',0,0,0,0,0,0,0,0,1,0,12073,0,26124),
(23170,'You had your chance; now it be too late!','',0,0,0,0,0,0,0,0,1,0,12074,0,26124),
(23171,'Now whatchoo got to say?','',0,0,0,0,0,0,0,0,1,0,12075,0,26124),
(23172,'Da Amani gonna rule again!','',0,0,0,0,0,0,0,0,1,0,12076,0,26124),
(23173,'I... be waitin\' on da udda side....','',0,0,0,0,0,0,0,0,1,0,12077,0,26124),
(23174,'De Zandalari give us strength. Nobody push around de Amani no more!','',0,0,0,0,0,0,0,0,1,0,24353,0,26124),
(23175,'Got me some new tricks... like me brudda bear....','',0,0,0,0,0,0,0,0,1,0,24220,0,26124),
(23176,'Dere be no hidin\' from da eagle!','',0,0,0,0,0,0,0,0,1,0,24224,0,26124),
(23177,'Let me introduce you to me new bruddas: fang and claw!','',0,0,0,0,0,0,0,0,1,0,24230,0,26124),
(23178,'Ya don\' have to look to da sky to see da dragonhawk!','',0,0,0,0,0,0,0,0,1,0,24223,0,26124),
(23179,'Fire kill you just as quick!','',0,0,0,0,0,0,0,0,1,0,24225,0,26124),
(23180,'Dis is why dey call me INVINCIBLE!','',0,0,0,0,0,0,0,0,1,0,24221,0,26124),
(23181,'Da Amani di chuka!','',0,0,0,0,0,0,0,0,1,0,24226,0,26124),
(23182,'Lot more going to fall like you.','',0,0,0,0,0,0,0,0,1,0,24227,0,26124),
(23183,'Mebbe me fall... but da Amani empire... never going to die.','',0,0,0,0,0,0,0,0,1,0,24222,0,26124),
(23184,'','Weeee! I\'m alive, I\'m alive, I\'m alive! Oh, I hope it\'s not too forward of me to tell you that I think I love you all and I hope I can find my bag because you certainly deserve a little something extra, you know, for the effort and all that you must have went through to save me...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23185,'','Hmm, maybe it\'s this one - oh by the way, did I ever tell you about the time Fudgerick Two-toots snuck up on me while I was casting a fireball? We call him two-toots because, well, nevermind that, it was just terrible timing, and momma was soo mad - my eyebrows are just now growing back....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23186,'','Hey, bartender, another round!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23187,'','You done cleaning that mug yet ...hic?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23188,'','I can whip up better than thish, Jashon.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23189,'','You should... you should send thish shtuff over to Petrov for his bombs!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23190,'','That\'s a pretty dressh, Celeste. You\'re sho pretty. I love you guys ...hic!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23191,'I think you\'ve had just about enough.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23192,'Uh huh.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23193,'Who\'s that talking? I can barely see the top of your head. Are you sure that you\'re old enough to be drinking?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23194,'Peppy, I swear you could drink a dwarf under the table.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23195,'I love you, pooky!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23196,'','I love you too, snookums!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23197,'The bartender hums a tune while working.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23198,'','Lissan! Lissan White! Where is that girl?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23199,'','You just can\'t get good help these days!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23200,'','Lissan! I bet that girl is daydreaming at the well again!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23201,'','<Grumble> Pretty dress indeed! <Grumble>',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23202,'','I need more shoveltusk!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23203,'','Are those dock workers on break again?! I need those supplies!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23204,'','%s sighs at all of the cooking she still has to do today.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23205,'','Thank you, sweety. We love you, too.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23206,'','Nope, not in that one either - well, it must be around here somewhere, by the way, did I mention how wonderful it is to be out of that stinky cage? It was almost impossible to run around in there but I did anyway but sometimes I got going so fast that I ended up walking on the walls of the  cage so finally I stopped trying and just turned around in circles....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23207,'','There\'s my bag! At last I\'ve found it and now it\'s my gift to you and I truly hope you like it because I want you to all remember this wonderful moment for as long as you live and I hope that when you think of it you\'ll smile inside because I know I\'ll never forget it in a million years and I can\'t wait to tell momma all about it when I get back home.... Do you like my earrings?',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(23208,'Ya saved me, mon! I thought they be drownin\' me for sure.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23209,'Just lemme know if there be anything I can help ya with, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23210,'The Alliance team is running out of reinforcements!','The Alliance team is running out of reinforcements!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23211,'The Horde team is running out of reinforcements!','The Horde team is running out of reinforcements!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23212,'Ya know, without so many of them burly trolls wanderin\' about this place can be downright pleasant.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(23213,'I wonder if I\'ll ever be the same after this. Heh, nuthin\' a pint won\'t cure I\'ll wager.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(23214,'Quite an adventure, this. The boys back home won\'t believe a word of it....','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(23215,'I oughtta shuffle on down and poke around fer treasure while I\'m here - after all, what\'re the odds of a dwarf like me gettin\' pinched twice?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(23216,'That rescue came just in time. Ya shoulda seen what them brutes did to their prisoners....','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(23217,'This\'ll make fer a great a story to tell the grandkids, that\'s fer sure... if I be livin\' long enough to have any, that is.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(23218,'It be days like today that make ye grateful fer the kindness of strangers - brings a tear to me eye.... Heh, nuthin a good pint won\'t fix.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(23219,'Mebbe I should write a book... \'Harkor\'s Guide to Zul\'Aman\'. Yeah, I like the sound a\' that.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(23220,'People, really, there\'s nothing to worry about!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23221,'Alliance idiots! Don\'t they realize their efforts are futile?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23222,'Yes, let\'s all run around like chickens with their heads cut off.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23223,'Even the toads? Unbelievable!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23224,'The fools! I knew they\'d try this, which is why I fire-proofed the plague tanks. Muahahahahaha!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23225,'Ignore that... we have work to do!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23226,'Fools! It could very well be an increase in temperature that perfects the plague!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23227,'Oooh, a little fire. Everyone panic!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23228,'The plaguebringer sighs at the interruption.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23229,'Looking around, %s frowns at what he considers the overreactions of his compatriots.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23230,'%s shakes his head before continuing on with his research.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23231,'Seemingly unphased by the nearby plague tank on fire, %s appears inspired.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23232,'You can\'t... kill... me spirit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23233,'Stop your cryin\'!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23234,'Ya got nothin\'!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23235,'I be da predator! You da prey...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23236,'All you be doin\' is wastin\' me time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23237,'That should do it. The gate\'s primary locking mechanism has been nullified.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(23238,'Thanks for the concern, but we intend to explore Zul\'Aman.','Thanks for the concern, but we intend to explore Zul\'Aman.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23239,'Let me guess, another group of Budd\'s riff-raff?$b$bAway with you, $r, before you get hurt - or worse.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23240,'I\'m aware of the dangers of this place. Now move out of the way, I won\'t ask again.','I\'m aware of the dangers of this place. Now move out of the way, I won\'t ask again.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23241,'I\'ve researched this site extensively and I won\'t allow any dim-witted treasure hunters to swoop in and steal what belongs in a museum. I\'ll lead this charge.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23242,'In fact, it would be best if you just stay here. You\'d only get in my way....','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23243,'Regardless, stay out of my way, and don\'t bother calling for me when you get yourself into trouble....','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23244,'Hey there!  Just because I can race rams better than anyone else, doesn\'t mean I won\'t pitch in and help out the brewers.  You can help out if you like.$b$bBut wait, there\'s more!$b$bHelping out with Brewfest means you get a chance to ride some of the fastest rams in the realms!','',396,0,0,0,0,0,0,7,1,0,0,0,26124),
(23245,'Do you still need some help shipping kegs from Kharanos?','Do you still need some help shipping kegs from Kharanos?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23246,'I\'m only going to carve the runes I think will give you command over a giant.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23247,'I\'m omitting the runes for \"north\" and \"west\" because I\'m not sure how they impact the giant. I\'m also including a rune to limit how long you can control it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23248,'There we go, the Rune of Command... hopefully. Not nearly as vicious as its Iron Dwarf cousin, but functional.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23249,'%s stares off to the Northeast!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23250,'%s looks toward the summoning stones and sighs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23251,'Ahaha, ya see this? Griftah\'s BACK! Back in my stall, back with my old wares, and ready to pass on the deals to ya!$b$bWant to be better, stronger, faster? Each one of these amulets be guaranteed to do just what I say they be doin\'. Step up and buy one of these miraculous baubles! Cheap at twice the price!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23252,'More intruders! Sound da alarm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23253,'Da spirits gonna feast today! Begin da ceremonies, sacrifice da prisoners... make room for our new guests!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23254,'Dark times make for strange friendships. It may be worth visiting old Lordaeron to watch the Forsaken burn their little man of wicker.','Dark times make for strange friendships. It may be worth visiting old Lordaeron to watch the Forsaken burn their little man of wicker.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23255,'I understand this holiday is a creation not of our allies, but the Horde. Why we follow suit, I do not know.','I understand this holiday is a creation not of our allies, but the Horde. Why we follow suit, I do not know.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23256,'We\'re celebrating the who breaking free of the what? Bah, who cares?! More candy!','We\'re celebrating the who breaking free of the what? Bah, who cares?! More candy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23257,'Why does everyone keep saying the LAST thing we gnomes need is more sugar?!','Why does everyone keep saying the LAST thing we gnomes need is more sugar?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23258,'All this free candy is just bad business, I tell you. Or... maybe it\'s just a loss leader... they get you in the inn, and then gouge you on the meat. It\'s brilliant!','All this free candy is just bad business, I tell you. Or... maybe it\'s just a loss leader... they get you in the inn, and then gouge you on the meat. It\'s brilliant!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23259,'When Hallow\'s End is over we\'ll smash all these pumpkins. That\'ll be the greatest day I\'ve ever known!','When Hallow\'s End is over we\'ll smash all these pumpkins. That\'ll be the greatest day I\'ve ever known!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23260,'To celebrate the birth of yet another deadly enemy is an odd thing, to say the least. Still, we will join our allies in their festivities.','To celebrate the birth of yet another deadly enemy is an odd thing, to say the least. Still, we will join our allies in their festivities.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23261,'The Forsaken are right to celebrate their freedom. What else is more important?','The Forsaken are right to celebrate their freedom. What else is more important?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23262,'I do not understand the significance of the Forsaken burning a great wicker effigy each night, but our own rituals must seem just as strange to them.','I do not understand the significance of the Forsaken burning a great wicker effigy each night, but our own rituals must seem just as strange to them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23263,'I don\'t know why the Forsaken burn a wicker man every night of Hallow\'s End instead of a real one, but it\'s their holiday.','I don\'t know why the Forsaken burn a wicker man every night of Hallow\'s End instead of a real one, but it\'s their holiday.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23264,'During Hallow\'s End we celebrate the day that the Banshee Queen herself delivered us from the clutches of the Lich King and the Scourge. Be sure to attend the Wickerman Festival that is held each evening outside Undercity.','During Hallow\'s End we celebrate the day that the Banshee Queen herself delivered us from the clutches of the Lich King and the Scourge. Be sure to attend the Wickerman Festival that is held each evening outside Undercity.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23265,'How could you have lost the evidence?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23266,'I thought it was secure! If your peacekeepers had the clout to control the thieves of this city, this wouldn\'t have happened!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23267,'You blame the peacekeepers for your failure? You were entrusted with a simple task. The troll was obviously a fraud!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23268,'LOOK AT ME, I\'M RANDOMIZING! HERE IT COMES (IN 5 SECONDS)!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23270,'Mummified trolls... hastily embalmed by the looks of them.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23271,'Hmm. The significance of this bird eludes me.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23272,'These fires have been burning steadily for years. Unusual dedication for trolls.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23273,'Puzzling. They\'re clearly harnessing great power from their sacrifices. But for what?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23274,'Interesting use of materials here. Rich color, strong lines, deep symbolism.... striking.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23275,'This statuary is a significant departure from previous troll effigies.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23276,'Yes, yes, I\'m quite certain this represents a melding of entities. Fascinating.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23277,'Ugh. Matted clumps of hair, molted feathers, bits of bone, partially burnt material - clothing perhaps?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23278,'Trash packaged, stacked and neatly set aside. Such order in contrast with extreme barbarity... remarkable.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23279,'One can learn volumes about a culture by studying its refuse.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23280,'What\'s this? A broken tooth. Likely from a giant cat of some sort. Odd....','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23281,'Ashes and charred bones, most unsettling. I must take a sample.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23282,'Strange... these mosaics don\'t resemble any known troll traditions.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23283,'Barrels like these are unique in this region. Short, round....','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23284,'Happy Hallow\'s End!','Happy Hallow\'s End!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23285,'I think I\'ve eaten too much candy...','I think I\'ve eaten too much candy...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23286,'We should go trick or treating later.','We should go trick or treating later.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23287,'You know... why DO we celebrate this holiday?','You know... why DO we celebrate this holiday?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23288,'This time of year is quite important to our Forsaken allies.','This time of year is quite important to our Forsaken allies.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23289,'Azeroth has many strange traditions. This one, I like.','Azeroth has many strange traditions. This one, I like.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23290,'Why isn\'t there beer-flavored candy?!','Why isn\'t there beer-flavored candy?!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23291,'More tricks, I say. Those are the REAL treats!','More tricks, I say. Those are the REAL treats!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23292,'We should attend the next burning of the Wickerman.','We should attend the next burning of the Wickerman.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23293,'Are there any more inns we can visit for treats?','Are there any more inns we can visit for treats?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23294,'Curse this twisting of the night. The candy\'s good, though.','Curse this twisting of the night. The candy\'s good, though.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23295,'The Forsaken are right to celebrate their freedom.','The Forsaken are right to celebrate their freedom.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23296,'It is our duty to honor the sacred days of our allies, however strange.','It is our duty to honor the sacred days of our allies, however strange.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23297,'Someone should make a candy with a chewy gnome center.','Someone should make a candy with a chewy gnome center.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23298,'NOW is the time of the Forsaken!','NOW is the time of the Forsaken!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23299,'There MUST be a way to make more money off of this holiday.','There MUST be a way to make more money off of this holiday.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23300,'The innkeepers are mad to be giving away treats for free.','The innkeepers are mad to be giving away treats for free.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23301,'Greetings and welcome to Blizzcon!  We are temporarily borrowing this dock to transport you to Northrend.  Your ride should be here shortly.  Enjoy!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23302,'And you\'re entrusted with keeping the city safe! How am I supposed to perform my \"simple task\" if the streets are thick with lowlifes? I can\'t spit in Shattrath without hitting some grubby burglar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23303,'...not that I would spit, of course.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23304,'Ahem, Mister Kyle, I\'m trying to move across the room as hard as I can... please fix me!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23305,'What could be better than servin\' da bear spirit for eternity? Come closer now. Bring your souls to me!','',0,0,0,0,0,0,0,0,1,0,12078,0,26124),
(23306,'I smell you, strangers. Don\'t be delayin\' your fate. Come to me now. I make your sacrifice quick.','',0,0,0,0,0,0,0,0,1,0,12079,0,26124),
(23307,'My eagles gonna bear your spirits to me. Your sacrifices not gonna be in vain....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23308,'Your death gonna be quick, strangers. You shoulda never come to this place....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23309,'Come, fools. Fill ma empty cages....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23310,'I be waitin, strangers. Your deaths gonna make me stronger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23311,'Arise from the earth, my brothers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23312,'Our iron masters have a mission for us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23313,'Come, friends. Your bodies gonna feed ma hatchlings, and your souls gonna fill me with power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23314,'Come, strangers. The spirit of da dragonhawk be hungry for worthy souls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23315,'Follow me into the mountains to carry out the plan of the masters!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23316,'Take your pick, trespassers! Any of ma priests be happy to accommodate ya.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23317,'Don\'t be shy. Thousands have come before you. Ya not be alone in your service.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23318,'Ya gonna fail, strangers. Many try before you, but dey only make us stronger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23319,'I was trying to oust one of those lowlifes you so loathe permanently! Next time, I\'ll be certain to specify that I require a competent investigator!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23320,'Do you EVER cease prattling?','',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(23321,'%s scowls and looks away.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23322,'That man didn\'t pay me enough to put up with this blowhard...','',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(23323,'%s frowns at Investigator Asric and arches a brow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23324,'What was that?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23325,'Oh, nothing. Merely thinking aloud.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23326,'Your efforts was in vain, trespassers. The rituals nearly be complete.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23327,'Soon da cages gonna be empty, da sacrifices be complete, and you gonna take dere places.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23328,'Time be running low, strangers. Soon you gonna join da souls of dem ya failed to save.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23329,'Make haste, ma priests! Da rituals must not be interrupted!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23330,'Many are the rare and precious objects that my clientele seek.$B$BYou could be the one to bring them to me, $c. In return I offer that which you covet.$B$BShall we speak more on that which I look to procure today?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23331,'An order is whispered upon the nether winds and Mah\'duun hears.$B$BA $g man : woman; comes before Mah\'duun, and they speak of those which the winds demand be slain today.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23332,'We will not fail!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23333,'Ya make a good try... but now you gonna join da ones who already fall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23334,'Watch now. Every offering gonna strengthen our ties to da spirit world. Soon, we gonna be unstoppable!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23335,'Ya not do too bad.... Your efforts delay da inevitable for a small time. Come to me now. Ya prove yourselves worthy offerings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23337,'%s begins sputtering.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23338,'Look, it works.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23339,'We set up this area to practice fire fighting.  You never know when the town will be imperiled!','We set up this area to practice fire fighting.  You never know when the town will be imperiled!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23340,'','I bet ya think you\'re tough, eh, kid? I guess I might have something for ya if ya can hold your own in the arena. Good stuff, not like Krixel\'s. That\'s so last season, ya know?$b$bOh, and have a nice day.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23341,'Here we practice fire fighting techniques.  Honor to the horde!','Here we practice fire fighting techniques.  Honor to the horde!',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(23342,'Well done!  We\'ll be ready when the real fires begin!','Well done!  We\'ll be ready when the real fires begin!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23343,'Quickly, $c!  Blazes rage through Razor Hill!  Go! Fight those fires!','Quickly, $c!  Blazes rage through Razor Hill!  Go! Fight those fires!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23344,'$n, the village of Goldshire is burning!  Go help fight the fire!','$n, the village of Goldshire is burning!  Go help fight the fire!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23345,'All right, so maybe the arenas ain\'t for you, right? Right. Turns out Vixton had some leftover armor from the first season, and we gotta get rid of it somehow. But nothing\'s free, know what I\'m sayin\'?','All right, so maybe the arenas ain\'t for you, right? Right. Turns out Vixton had some leftover armor from the first season, and we gotta get rid of it somehow. But nothing\'s free, know what I\'m sayin\'?',378,0,0,0,0,0,0,0,1,0,0,0,26124),
(23346,'Greetings, kind stranger, and thank you for your selfless act.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23347,'These heathens have robbed me of my belongings, but I can offer you this charm I took from my captors.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23348,'Farewell.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23349,'Next year, I\'m dressing up as either a corsair or an assassin.','Next year, I\'m dressing up as either a corsair or an assassin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23350,'What do you think of the mask?','What do you think of the mask?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23351,'For the Alliance!','For the Alliance!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23352,'Where\'s me gold? Where\'s me beer? Where\'s me feet?','Where\'s me gold? Where\'s me beer? Where\'s me feet?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23353,'Waaah! I don\'t want to die! I want to live forever! It\'s not fair!','Waaah! I don\'t want to die! I want to live forever! It\'s not fair!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23354,'Boo-hoo! I\'m a poor little gnome, and I don\'t have a capital ci... oh, wait.','Boo-hoo! I\'m a poor little gnome, and I don\'t have a capital ci... oh, wait.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23355,'Ishnu-dal-dieb.','Ishnu-dal-dieb.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23356,'Gaze upon my crazy tentacle-face and despair, Azerothian!','Gaze upon my crazy tentacle-face and despair, Azerothian!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23357,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23358,'Brains... braaaiiins!','Brains... braaaiiins!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23359,'Zug zug! Mok\'ra! Er... Dabu!','Zug zug! Mok\'ra! Er... Dabu!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23360,'Mooo!','Mooo!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23361,'Me got the mad voodoo, mon!','Me got the mad voodoo, mon!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23362,'I am a slender, delicate flower!','I am a slender, delicate flower!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23363,'Hey! Did you eat the last of the chicken? I was saving that for a special occasion!','Hey! Did you eat the last of the chicken? I was saving that for a special occasion!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23364,'For the Alliance! Wait... the Horde! Wait... which was I again?','For the Alliance! Wait... the Horde! Wait... which was I again?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23365,'For the Horde! No... the Alliance! Uh... which mask did I have?','For the Horde! No... the Alliance! Uh... which mask did I have?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23366,'You be sayin\' that now, but come dinner you\'ll think differently!','You be sayin\' that now, but come dinner you\'ll think differently!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23367,'I wouldn\'t eat yer leftovers if the only other thing to eat was rubble!','I wouldn\'t eat yer leftovers if the only other thing to eat was rubble!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23368,'Alright, now follow me, girl.','Alright, now follow me, girl.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23369,'May it serve you well, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23370,'Yeouch! Watch where you throw that stuff!','Yeouch! Watch where you throw that stuff!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23371,'Fascinating! These embers somehow generate almost no heat.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23372,'This smoke is like nothing I\'ve smelled before. I wonder what they\'re burning here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23373,'Hmm, thank you stranger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23374,'I fear I have nothing but this old chest I discovered here. You\'re welcome to it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23375,'I hope you find its contents... useful.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23376,'Until we next meet....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23377,'There\'s always a need for more kegs at Brewfest!$b$bI\'ll lend you the reins to one of my personal rams.$b$bEvery time you bring me a keg, I\'ll give you some tokens.  I\'ll even let you use the ram for a bit longer for every keg you bring me!  \n\nTake heed! Once you start this, you won\'t be able to do it again until tomorrow.\n\nAre you sure you\'re ready to do this?','There\'s always a need for more kegs at Brewfest!$b$bI\'ll lend you the reins to one of my personal rams.$b$bEvery time you bring me a keg, I\'ll give you some tokens.  I\'ll even let you use the ram for a bit longer for every keg you bring me!  \n\nTake heed! Once you start this, you won\'t be able to do it again until tomorrow.\n\nAre you sure you\'re ready to do this?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23378,'I\'m ready to work for you today!  Give me the good stuff!','I\'m ready to work for you today!  Give me the good stuff!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23379,'','Oooh! It\'s about time someone rescued me....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23380,'','I suppose I should be grateful. Please, take this. I want nothing to remind me of this place.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23381,'','I took it from one of these trolls as I was captured. Maybe you can find a way to use it against them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23382,'','I\'ve had quite enough of this place. Goodbye.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23383,'','Ahhh, finally!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23384,'','Say, I found this charm just before they caught me. Maybe it\'ll do you some good here....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23385,'','I hope it helps. These vile beasts simply must be stopped!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23386,'','Good luck to you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23387,'Well, now. What a pleasant turn of events.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23388,'It\'s most fortunate for you that you rescued me, and not one of these other poor sots.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23389,'Please accept this payment, as well as my gratitude, for your trouble.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23390,'Be well, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23391,'Woohoo! I\'m saved! I thank you, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23392,'Oh, my. What IS that smell - oh wait, heh, whoops! Guess my senses will take a little time to get readjusted.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23393,'My apologies, friends. Here, now. This should help to cover the expenses involved in my rescue.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23394,'See ya later!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23395,'Are those ingredients chopped up and cooked?  What\'s the hold up?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23396,'We have a dozen more dishes to finish today!  Get a move on!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23397,'Put a little elbow grease into it!  And maybe some regular grease, while you\'re at it.  Those mag\'har sure like the clefthoof fat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23398,'','Yeah, yeah!  Shut yer trap and let me finish this stew!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23399,'','Can\'t make water boil any faster, genius!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23400,'','It\'ll be done when it\'s done, darn it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23401,'Oh, can it be? I... I\'m free of that hideous curse? ','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23402,'Words cannot express my gratitude, $n. Thank you for your kindness.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23403,'As you can see, I have but little after these savages got hold of me, but you\'re welcome to what I have. Come, have a look.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23404,'I must go now, before I get myself caught again. If you need anything, I won\'t be far.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23405,'','Mmmm, flies! Even better now that I can taste them.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23406,'','Nice to be back among the unliving, thanks to you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23407,'','Perhaps I am able to offer something of interest to you? Come, see if there\'s anything you like.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23408,'','I must be off now, $n. See you around.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23409,'Drop point check commencing!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23410,'Gargoyle attack! Grab yer rifles, men!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23411,'','Weee! I\'m a girl again!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23412,'','Thank you for rescuing me. I simply hate being a yucky frog!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23413,'','I\'m really not supposed to talk to strangers, but you\'ve been so nice to me. Here\'s a special something I found just before I was kidnapped.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23414,'','I should go now. Be careful!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23415,'Warning! Power supply failing - activating emergency measures.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(23416,'Time until Christmas: $3930d.','Time until Christmas: $3930d.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23417,'Aww, nuts! You\'ve ruined everything!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23418,'Do you have any idea how neat it is to hop that far?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23419,'Oh well, I was starting to miss my pals anyway - they\'re not gunna believe this! Oh, here - you can have this, I found it playin\' hide and seek.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23420,'Let\'s see if I can still make that sound....','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23421,'Hrmmph. Thanks all the same, but I didn\'t need any help.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23422,'I was working on a cantrip that would counteract my predicament and I was very close to finding a <CROOAAK>... Oh my!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23423,'Well, I suppose I do owe you a little something - here, take one of these. I\'ve got lots.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23424,'You may want to consider leaving this place. I think being transformed into a frog is one of the better things that can happen to one here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23425,'','Oh! Back to my beautiful self? How lovely! I thought I would be a frog forever.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23426,'','It was just terrible. I was all slimy, and I kept licking my eyes!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23427,'','Thank goodness you came along when you did. Please, take one of these troll boxes to remember me by.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23428,'','I never want to see this nasty pond again. Thank you, $n. I\'ll never forget you!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23429,'I must have taken leave of my senses, allowing a Scryer to aid in such a delicate operation...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23430,'My services were rendered. The protection of the city is not my jurisdiction. I believe that\'s why they call you \"peacekeepers?\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23431,'Had we been fully handling the investigation, I assure you, the evidence would have remained safe. Instead, we used your highly questionable methods...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23432,'Of course. My methods are questionable. It was my methodology, I\'ll note, that exposed that \"Griftah\" as a fraud in the first place! You had only to keep the peace, and you failed in that simple task!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23433,'Incompetent, sniveling dandy.','',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(23434,'Pompous, uptight windbag.','',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(23435,'%s and Investigator Asric glare at each other silently, their eyes narrowed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23436,'','Hey there, good looking!  What can I do to help you out?',1,5,24,0,0,0,0,0,1,0,0,0,26124),
(23437,'So you want to know what I\'m looking for?  I like that... I\'m looking for someone strong and courageous.  Brains are one thing, but you\'ve gotta be able to back it up with some muscle.$b$bWhenever those pesky Dark Iron dwarves attack, you can attack them by throwing a mug at them.  Just down it and throw.  Simple.$b$bFor every dwarf you down, you\'ll be marked.  Talk to me and I\'ll give you a prize ticket for every mark you have.','So you want to know what I\'m looking for?  I like that... I\'m looking for someone strong and courageous.  Brains are one thing, but you\'ve gotta be able to back it up with some muscle.$b$bWhenever those pesky Dark Iron dwarves attack, you can attack them by throwing a mug at them.  Just down it and throw.  Simple.$b$bFor every dwarf you down, you\'ll be marked.  Talk to me and I\'ll give you a prize ticket for every mark you have.',1,5,24,0,0,0,0,0,1,0,0,0,26124),
(23438,'Ain\'t she a beauty? Want to take her for a spin?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(23439,'I hear you\'re looking for Keg Protector marks.  What are those?','I hear you\'re looking for Keg Protector marks.  What are those?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23440,'What\'s with your crazy goggles?','What\'s with your crazy goggles?',1,5,24,0,0,0,0,0,1,0,0,0,26124),
(23441,'Keep your voice down, $c. We wouldn\'t want them to hear us.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23442,'I have another question.','I have another question.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23443,'Hey there!  Are you interested in learning some more about racing rams and ram racing?','Hey there!  Are you interested in learning some more about racing rams and ram racing?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23444,'Do I get a free mount?','Do I get a free mount?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23445,'How do I make my ram go faster?','How do I make my ram go faster?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23446,'What\'s with the different speeds?','What\'s with the different speeds?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23447,'Can I tire my ram out?','Can I tire my ram out?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23448,'That all sounds very complicated...','That all sounds very complicated...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23449,'When you take one of these tasks, we\'ll lend you a ram. It\'s a loan, so it won\'t last forever. The ram may seem slow, but just ease up on the reins a bit and he\'ll pick up the pace.$b$bOur rams love apples. We\'ve put a few bushels of apples out along the way, so make sure to stop by. Eating apples will make your ram forget about how tired he\'s been getting.','When you take one of these tasks, we\'ll lend you a ram. It\'s a loan, so it won\'t last forever. The ram may seem slow, but just ease up on the reins a bit and he\'ll pick up the pace.$b$bOur rams love apples. We\'ve put a few bushels of apples out along the way, so make sure to stop by. Eating apples will make your ram forget about how tired he\'s been getting.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(23450,'When you get a ram, you also get the reins. These aren\'t your grandma\'s reins though, you\'ve gotta use them!$b$bJust loosen up on the reins a few times to build up some speed.  Keep on loosening up and GIDDYUP!  You\'ll be flying!$b$bBut the faster he goes the quicker he\'ll get tired. So you have to be careful.\n','When you get a ram, you also get the reins. These aren\'t your grandma\'s reins though, you\'ve gotta use them!$b$bJust loosen up on the reins a few times to build up some speed.  Keep on loosening up and GIDDYUP!  You\'ll be flying!$b$bBut the faster he goes the quicker he\'ll get tired. So you have to be careful.\n',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(23451,'Once you start loosening the reins on the ram, you\'ll see his speed change. He starts off walking. Ease up on the reins a bit more and he\'ll start to trot. Give him more slack on the reins while he\'s trotting and he\'ll go into a canter. Give him even more slack while he\'s in a canter and you will send him into a gallop.\n\n','Once you start loosening the reins on the ram, you\'ll see his speed change. He starts off walking. Ease up on the reins a bit more and he\'ll start to trot. Give him more slack on the reins while he\'s trotting and he\'ll go into a canter. Give him even more slack while he\'s in a canter and you will send him into a gallop.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(23452,'Keeping your ram in a canter or gallop for too long will exhaust him. If you want your ram to recover a bit, let him walk or trot. If there are apple bushels around, take him there to recover.\n\n','Keeping your ram in a canter or gallop for too long will exhaust him. If you want your ram to recover a bit, let him walk or trot. If there are apple bushels around, take him there to recover.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(23453,'Ram racing is easier than it seems, but it takes skill to master. Just use the reins, eat apples if you can and avoid exhausting your ram.\n\n','Ram racing is easier than it seems, but it takes skill to master. Just use the reins, eat apples if you can and avoid exhausting your ram.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(23454,'Hmm, that\'s strange, $c. I would have thought you\'d have found something connected with those scourging crystals.$B$BWe really should find a way to bring down their shields and destroy them. You think you could go back out there and kill some more Scourge until you find something?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(22271,'Here is my body, beautiful and bold! Black souls are punished skillfully!','',0,0,0,0,0,0,0,0,1,0,12567,12567,26124),
(23456,'','Yes? What is it?$B$BTime waits for no one!',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(23457,'I\'ve been saving this just for you, big boy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23458,'','Odd, I would have thought you\'d have found something useful on those Scourge that might help us deal with the scourging crystals.$B$BIf I may strongly suggest, and I do, $c, go back down to the beach and continue to slaughter them until you do find something of use to me.',1,25,0,0,0,0,0,0,1,0,0,0,26124),
(23459,'Things are going as planned, Lord Falconcrest. I assure you, it is only a matter of time.','Things are going as planned, Lord Falconcrest. I assure you, it is only a matter of time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23460,'I presume you come with good news?','I presume you come with good news?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23461,'Is there a way to purchase one?','Is there a way to purchase one?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23462,'If you earn enough Brewfest prize tickets, the ticket redeemer in the Brewfest camp can give you an \"Honorary Brewer\" hand stamp.$b$bThat stamp will allow me to sell you a Brewfest riding ram. But they don\'t come cheap, mind you!','If you earn enough Brewfest prize tickets, the ticket redeemer in the Brewfest camp can give you an \"Honorary Brewer\" hand stamp.$b$bThat stamp will allow me to sell you a Brewfest riding ram. But they don\'t come cheap, mind you!',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(23463,'I\'d like to purchase a Brewfest riding ram.','I\'d like to purchase a Brewfest riding ram.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23464,'Check out the 3-B entertainment! Brewfest\'s Barleybrew Brewmasters!','Check out the 3-B entertainment! Brewfest\'s Barleybrew Brewmasters!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23465,'Barleybrew brew!  Won\'t fill you up, won\'t kill you...  The Thunderbrews can\'t say the same.','Barleybrew brew!  Won\'t fill you up, won\'t kill you...  The Thunderbrews can\'t say the same.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23466,'Barleybrew will treat you right!  Check out the Barleybrews at Brewfest!','Barleybrew will treat you right!  Check out the Barleybrews at Brewfest!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23467,'Brewfest has called down the thunder!  Thunderbrew, that is!','Brewfest has called down the thunder!  Thunderbrew, that is!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23468,'Sometimes you want to party hard, Thunderbrew\'s got ya covered!  Check them out at Brewfest!','Sometimes you want to party hard, Thunderbrew\'s got ya covered!  Check them out at Brewfest!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23469,'Can you feel the magic?  Thunderbrew brewmasters are on the loose!  Check them out at Brewfest!','Can you feel the magic?  Thunderbrew brewmasters are on the loose!  Check them out at Brewfest!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23470,'Your life ends now invader!','Your life ends now invader!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23471,'I\'ll send your soul to the afterlife little one!','I\'ll send your soul to the afterlife little one!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23472,'We shall see if you are a worthy opponent!','We shall see if you are a worthy opponent!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23473,'I will take great pleasure in slaughtering you, $c!','I will take great pleasure in slaughtering you, $c!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23474,'Your spirit shall find no rest in these lands!','Your spirit shall find no rest in these lands!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23475,'The cold darkness awaits your soul!','The cold darkness awaits your soul!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23476,'I shall end your life and bind you to his service!','I shall end your life and bind you to his service!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23477,'I thought you\'d never ask!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23478,'Now that\'s what I call froggy-style!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23479,'This won\'t take long, did it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23480,'I promise not to give you warts...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23481,'There\'s just never enough Mojo to go around...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23482,'Listen, $n, I know of a little swamp not too far from here....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23483,'Your lily pad or mine?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23484,'Feelin\' a little froggy, are ya?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23485,'Mojo leaps into $n\'s pocket!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23486,'I can\'t show you anything else, kid. Go find Lebowski in Honor Hold - that\'s in Hellfire Peninsula. He can teach you more than I can!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23487,'I can\'t show you anything else, kid. Go find Zebig in Thrallmar - that\'s in Hellfire Peninsula. He can teach you more than I can!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23488,'We built this place with our bare hands! Blood and tears, my friend.$B$BBelieve me when I tell you this: We have no plans on ever giving up our hold on Valgarde.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23489,'RETREAT!!  We\'ve taken a beating and had $3151W casualties!  We can\'t keep taking these losses!  FALL BACK!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23490,'We did it boys!  Now back to the Grim Guzzler and we\'ll drink to the $3151W that were injuredl!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23491,'Hey friend, what I\'ve got here is a breakthrough, the likes of which have never been seen!  And it\'s for sale, for cheap!$b$bYou see, I got tired of spending money in taverns looking for the perfect person.  So I made these goggles and now EVERYONE looks like pure perfection.  I mean you CAN\'T go wrong with these puppies!$b$bSo, you wanna try these out, help pad my pockets a bit?  Since you look soo good, I\'ll even give you a discount!','Hey friend, what I\'ve got here is a breakthrough, the likes of which have never been seen!  And it\'s for sale, for cheap!$b$bYou see, I got tired of spending money in taverns looking for the perfect person.  So I made these goggles and now EVERYONE looks like pure perfection.  I mean you CAN\'T go wrong with these puppies!$b$bSo, you wanna try these out, help pad my pockets a bit?  Since you look soo good, I\'ll even give you a discount!',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(23492,'I\'m looking for all sorts of things honey!  But those marks you are talking about, the Keg Protector marks?  Those show me that you know how to handle yourself in a fight.$b$bEvery time you take down a Dark Iron dwarf, you get a mark.  For every mark you have, I\'ll give you a prize ticket.$b$bIt pains me to give these tickets away, but it also means I get to see you again, and see you leave again...','I\'m looking for all sorts of things honey!  But those marks you are talking about, the Keg Protector marks?  Those show me that you know how to handle yourself in a fight.$b$bEvery time you take down a Dark Iron dwarf, you get a mark.  For every mark you have, I\'ll give you a prize ticket.$b$bIt pains me to give these tickets away, but it also means I get to see you again, and see you leave again...',1,5,24,0,0,0,0,0,1,0,0,0,26124),
(23493,'I saw you across the way and was hoping you were going to stop by.  So what can I do for you sweetie?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23494,'I\'ve got Keg Protector marks to redeem...','I\'ve got Keg Protector marks to redeem...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23495,'I hear you\'re looking for Keg Protector marks.  What are those?','I hear you\'re looking for Keg Protector marks.  What are those?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23496,'What\'s with your crazy goggles?','What\'s with your crazy goggles?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23497,'Hey, hey sweet thing!  Looking good!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23498,'Hey! Sweet cheeks, over here!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23499,'Yo! Big lady! You think you\'re big enough to handle me?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23500,'Hey tough stuff! Hey, $c! Do you like money?  I\'m loaded!  How about you come over here and check out my gold coins?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23501,'Hey, hey!  Nice build you got there honey!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23502,'Whoah!  Walk by again girl!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23503,'Didn\'t the foreman say he was going to bring some guards? Where are they?','Didn\'t the foreman say he was going to bring some guards? Where are they?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23504,'If we don\'t expand the mine, there\'s no way we\'ll get all the ore we need. Captain Adams\'ll have our hides!','If we don\'t expand the mine, there\'s no way we\'ll get all the ore we need. Captain Adams\'ll have our hides!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23505,'You\'re going to face Shatterhorn? You\'re brave, I\'ll give you that.','You\'re going to face Shatterhorn? You\'re brave, I\'ll give you that.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23506,'Give \'im hell for us!','Give \'im hell for us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23507,'You know, we\'re not busy right now. We could start building a coffin for you...','You know, we\'re not busy right now. We could start building a coffin for you...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23508,'Normal dogs won\'t come anywhere near me nowadays.  I was devastated when I found out... I used to love the beasts.$B$BPlaguehounds make for a fine substitute, however.  They\'re not quite as... easy on the eyes.  But then again, neither am I!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23509,'This isn\'t going to end well.','This isn\'t going to end well.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23510,'Hmm....','Hmm....',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23511,'You won\'t find a better brew in Azeroth.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23512,'Hey mon, you ready to try da best brew in all da realms?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23513,'Hey you, the tall one...  Want to put some hair on your chest?  Drohn\'s Distillery can help you out!','Hey you, the tall one...  Want to put some hair on your chest?  Drohn\'s Distillery can help you out!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23514,'Drohn\'s brew is the stuff legends are made of!  Come taste the legend!','Drohn\'s brew is the stuff legends are made of!  Come taste the legend!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23515,'Drohn\'s Distillery has the best brew money can buy!  They were voted \"Outstanding Brew\" by Monthly Goblin Brew!','Drohn\'s Distillery has the best brew money can buy!  They were voted \"Outstanding Brew\" by Monthly Goblin Brew!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23516,'We drink for the Horde!  Do you drink for the Horde?  Come show us at Drohn\'s Distillery!','We drink for the Horde!  Do you drink for the Horde?  Come show us at Drohn\'s Distillery!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23517,'Hey you!  T\'chali\'s Voodoo Brewers have got a brew that won\'t kill you!  But they\'ve also got a brew that might...','Hey you!  T\'chali\'s Voodoo Brewers have got a brew that won\'t kill you!  But they\'ve also got a brew that might...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23518,'If you wanna live life to the fullest, you gotta try T\'chali\'s Voodoo Brew!','If you wanna live life to the fullest, you gotta try T\'chali\'s Voodoo Brew!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23519,'T\'chali\'s Voodoo Brewery has the best brew you can find!  They were voted \"Best Brew\" by the Goblin Brew Weekly!','T\'chali\'s Voodoo Brewery has the best brew you can find!  They were voted \"Best Brew\" by the Goblin Brew Weekly!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23520,'Drohn\'s Distillery knows how to party hard!  Check them out at Brewfest!','Drohn\'s Distillery knows how to party hard!  Check them out at Brewfest!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23521,'Celebrate Brewfest with orcs that know what a good drink really is!  Check out Drohn\'s Distillery at Brewfest!','Celebrate Brewfest with orcs that know what a good drink really is!  Check out Drohn\'s Distillery at Brewfest!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23522,'If you think an orc can hit hard, check out their brew, it hits even harder!  See for yourself at Drohn\'s Distillery, only at Brewfest!','If you think an orc can hit hard, check out their brew, it hits even harder!  See for yourself at Drohn\'s Distillery, only at Brewfest!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23523,'Join with your brothers and sisters at Drohn\'s Distillery and drink for the horde!','Join with your brothers and sisters at Drohn\'s Distillery and drink for the horde!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23524,'Would you really drink brew from an orc or an ogre?  For a better choice check out T\'chali\'s Voodoo Brewery at Brewfest!','Would you really drink brew from an orc or an ogre?  For a better choice check out T\'chali\'s Voodoo Brewery at Brewfest!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23525,'If you could use some exotic brew, T\'chali\'s Voodoo Brewery at Brewfest has got you covered!','If you could use some exotic brew, T\'chali\'s Voodoo Brewery at Brewfest has got you covered!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23526,'Need to relax?  Visit T\'chali\'s Voodoo Brewery at Brewfest for drinks that go down smooth!','Need to relax?  Visit T\'chali\'s Voodoo Brewery at Brewfest for drinks that go down smooth!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23527,'T\'chali\'s Voodoo Brews helps keep the party going!  Check out the party at Brewfest!','T\'chali\'s Voodoo Brews helps keep the party going!  Check out the party at Brewfest!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23528,'Where ma hatcha? Get to work on dem eggs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23529,'','Here we practice fire fighting techniques.  Power to the Forsaken!',4,0,0,0,0,0,0,1,1,0,0,0,26124),
(23530,'I have fallen! Fear not, brethren! Let nothing keep you from the Stoneforge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23531,'','It hurts! Owww Ow Ow Owwwww!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23532,'Clayton is AWESOME!!','Clayton is AWESOME!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23533,'Clayton is NOT AWESOME!','Clayton is NOT AWESOME!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23534,'%s cries out and writhes in agony before passing out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23535,'I enjoy the screams most of all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23536,'These outsiders are weak and easily crushed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23537,'We shall see how much punishment these invaders can stand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23538,'Good!  Good! You are still alive.  More fun for me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23539,'They are hardier than I would expect for their size.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23540,'$n\'s concoction is ruined.  A new one must be created from scratch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23541,'Give up your will to live! I can do this all day and night.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23542,'<Ulfang howls and sniffs at you, and you can understand what he says.>$B$BThe strange white worg of the north, Garwal, has taken my pack from me. We must rip out his throat so that I will be the alpha worg once again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23543,'%s coos to the hatchlings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23544,'That crash between here and Razor Hill really messed up the brew flow!  It doesn\'t help that Dark Iron dwarves seem to be attacking every hour or so!$b$bSo if you want to help, here\'s the deal.  I\'ll let you borrow some reins and one of my rams.$b$bEvery time you bring me a keg, I\'ll give you some tokens.  I\'ll even let you use the ram for a bit longer for every keg you bring me!$b$bBUT, once you start this, you won\'t be able to do it again until tomorrow.$b$bAre you sure you\'re ready to do this?','That crash between here and Razor Hill really messed up the brew flow!  It doesn\'t help that Dark Iron dwarves seem to be attacking every hour or so!$b$bSo if you want to help, here\'s the deal.  I\'ll let you borrow some reins and one of my rams.$b$bEvery time you bring me a keg, I\'ll give you some tokens.  I\'ll even let you use the ram for a bit longer for every keg you bring me!$b$bBUT, once you start this, you won\'t be able to do it again until tomorrow.$b$bAre you sure you\'re ready to do this?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23545,'I\'m ready to work for you today!  Give me that ram!','I\'m ready to work for you today!  Give me that ram!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23546,'Do you still need some help moving kegs from the crash site near Razor Hill?','Do you still need some help moving kegs from the crash site near Razor Hill?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23547,'I see you checking out our legally obtained racing rams...  I can see you want in on the ram racing sensation...  But before you can play, you gotta work.$b$bWell, work and play are pretty much the same when it comes to these rams.','',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(23548,'Y\'hear that, Jethan? You\'re not getting that Steelfeather trophy now that we know she\'s a mother.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23549,'Why not? Just think how much better it\'ll look with the hatchlings to either side --','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23550,'Jethan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23551,'What? I\'m just sayin\' that\'s how we do things in Grizzly Hills.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23552,'They keep their tools in boxes that look like this. Look for them near the pavilions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23553,'I saw soldiers from Ironforge fighting a fire before.  They were heroes!','I saw soldiers from Ironforge fighting a fire before.  They were heroes!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23554,'$n, don\'t just stand there! Kharanos is burning! Go help! Ach, all that brew...','$n, don\'t just stand there! Kharanos is burning! Go help! Ach, all that brew...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23555,'If you\'re looking to practice fire fighting, this is the place. There may be a heap of snow hereabouts, but you never know when Steelgrill or those gnomes\'ll cause an explosion, eh?','If you\'re looking to practice fire fighting, this is the place. There may be a heap of snow hereabouts, but you never know when Steelgrill or those gnomes\'ll cause an explosion, eh?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23556,'$n, the village of Azure Watch is burning!  Go help fight the fire!','$n, the village of Azure Watch is burning!  Go help fight the fire!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23557,'We set up this area to practice fire fighting.  You never know when the town will be imperiled!','We set up this area to practice fire fighting.  You never know when the town will be imperiled!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23558,'Ahoy, mon!  What be happenin\', ye salty \'at steppa!$B$BDis place be all chacka-chacka, ye scallywag!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23559,'Lookin\' mighty cris, me bucko!  Ye pillage a fat sutler?  Best ye spread da wealth... don\'t be a craven choke puppy, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23560,'Ku ovah yonder, matey!  Dat scurvy bobo be all up inne quashie\'s face.  Dat hard-eared swab gonnna get salt, mon... gonna get keelhauled and gonna be made into a duppy, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23561,'How much\'ll it cost me to get my mules shod?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23562,'We don\'t shoe no mules here. \'Sides, it\'s strictly expedition business right now.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23563,'You don\'t understand! If I\'m not ready to go soon, all the good homesteading land will be taken!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23564,'Not my problem! If yer so antsy to get yerself a house built, do it \'ere in the fort and quit yer whinin\'!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23565,'Issa truut, matey!  Neh tougher salts anyweh but da northsea freebootahs yahso, mon!$B$BBest not brindle s\'mady, mon.  Scuppah dat!  \'Alf eediat swabs get feh kiss da gunnah\'s dawta, mate!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23566,'Now, if you\'d be so kind as to get your ass away from my forge...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23567,'That, sir, is a mule!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23568,'Um... what was that?','Um... what was that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23569,'Now ye just be fass and facety, mon!  Ye fixin\' fe vex me, ye maga dog blaggard?$B$BG\'waan den, ye lily-livered scallywag.  Be seen ya first light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23570,'Welcome to Fort Wildervar, brave homesteaders! There\'s a whole continent out there just waiting to be claimed!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23571,'True, Northrend is a hard land, but our people are strong, hardy, and equal to the task!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23572,'We will win this land with the sword, and break it with the plow! You are the men and women who will be remembered for taming the wild continent!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23573,'But, you will not be alone out there. My men and I have prepared pack mules carrying the supplies you\'ll need most.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23574,'Axes, picks, seed, nails, food, blankets, water... it\'s all there, waiting for you. I think you\'ll find my prices quite reasonable, too.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23575,'There are more than enough to go around. Should you need other goods, don\'t hesitate to ask!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23576,'Now, my loyal custo... err, friends, go forth and conquer this land for our people!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23577,'So you\'re the new hot shot in town, eh?$B$B<Zorek spits on the ground.>$B$BYea...','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(23578,'I don\'t know much about art... but I know what I like!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23579,'Yah, me bredren!  Galang now and pass us a grog, just dead men yahso.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23580,'Watch nah, ye bogfiddler!  I an\' I gunna show ye \'ow a jig meant fe be jigged to!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23581,'Dis a rankin\' set, mon, no scurvy dog gonna kass-kass me buckos an\' walk aweh! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23582,'<Old Icefin draws in the sand. From the crude pictures he traces you can make out that he wants your help.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23583,'Here we practice fire fighting techniques.','Here we practice fire fighting techniques.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23584,'Quickly, $c!  Blazes rage through Falconwing Square!  Go! Fight those fires!','Quickly, $c!  Blazes rage through Falconwing Square!  Go! Fight those fires!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23585,'It all be over now, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23586,'Tazaga-choo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23587,'Zul\'jin... got a surprise for you....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23588,'You done run outta time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23589,'I burn ya now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23590,'Spirits of da wind be your doom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23591,'Da shadow gonna fall on you....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23592,'Ya don\' kill me yet... ya don\' get anudda chance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23593,'Dis a nightmare ya don\' wake up from!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23594,'Azzaga choogo zinn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23595,'Your will belong ta me now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23596,'Darkness comin\' for you....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23597,'Your soul gonna bleed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23598,'It not gonna make no difference.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23599,'You gonna die worse dan him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23600,'Dat no bodda me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23601,'Dis not... da end for me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23602,'Have ya gone mad? Ya be da death of us all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23603,'An electrical storm appears!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23604,'%s shimmers and begins to fade away...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23605,'','Remember, honey, we need to get a plot of land with a nice hot spring.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23606,'Of course, darling.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23607,'','And I don\'t want our land to have any of those horrible wolves, or giants, or ugly rams!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23608,'Yes, darling. You realize you\'ll be eating dire ram mutton for dinner until the crops are planted...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23609,'','I\'d sooner butcher that mule of yours! Why did you bring that beast in here, anyway?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23610,'I\'d rather listen to his braying than yours, dear.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23611,'Chaga... choka\'jinn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23612,'Get on ya knees and bow.... to da fang and claw!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23613,'You can\'t fight da power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23614,'Ya all gonna fail!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23615,'Me gonna carve ya now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23616,'You gonna leave in pieces!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23617,'You dare challenge Winterskorn?! I will impale you on your own puny flag!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23618,'The sacrifices now bring themselves to us? Have you no sense!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23619,'Your remains will be fed to the sharks of Daggercap!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23620,'Down the free brew and pelt the Guzzlers with your mug!','Down the free brew and pelt the Guzzlers with your mug!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23621,'Chug and chuck!  Chug and chuck!','Chug and chuck!  Chug and chuck!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23622,'<Old Icefin eyes you warily, his fishy eye blinking as he bobs his head up and down once in a curt dismissal.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23623,'The longhouse is destroyed! Alarms can be heard in the distance.','',0,0,0,0,0,0,0,0,1,6676,0,0,26124),
(23624,'Defend yourself, soldier! Blow \'em out of the sky with the fiery lance! Give \'em a taste of their own medicine!','',0,0,0,0,0,0,0,0,1,6676,0,0,26124),
(23625,'Direct hit on the dockhouse! Dragonflayer defenders have been alerted!','',0,0,0,0,0,0,0,0,1,6676,0,0,26124),
(23626,'Don\'t give \'em an inch, soldier! Harpoon \'em out of the sky!','',0,0,0,0,0,0,0,0,1,6676,0,0,26124),
(23627,'Here\'s to the Horde!','Here\'s to the Horde!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23628,'To Brewfest!','To Brewfest!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23629,'Here\'s to the Alliance!','Here\'s to the Alliance!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23630,'To Brewfest!','To Brewfest!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23631,'Here\'s to gold in our pockets!','Here\'s to gold in our pockets!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23632,'To Brewfest!','To Brewfest!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23633,'No other holiday matches the feasting and drinking of Brewfest!','No other holiday matches the feasting and drinking of Brewfest!',396,92,0,0,4,0,0,0,1,0,0,0,26124),
(23634,'$n, I would have words with you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23635,'$R, a moment of your time?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23636,'A word to the wise, stranger, go back to wherever you\'re from.$b$bThis is no place for lighthearted adventurers. It\'ll chew up the likes of you and spit out your bones.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23637,'The Vrykul storage facility is up in flames! Dragonflayer defenders have been alerted!','',0,0,0,0,0,0,0,0,1,6676,0,0,26124),
(23638,'Knock \'em out of the sky! Don\'t let them get in range of you, soldier!','',0,0,0,0,0,0,0,0,1,6676,0,0,26124),
(23639,'The longhouse is destroyed! Alarms can be heard in the distance.','',0,0,0,0,0,0,0,0,1,6678,0,0,26124),
(23640,'Direct hit on the dockhouse! Dragonflayer defenders have been alerted!','',0,0,0,0,0,0,0,0,1,6678,0,0,26124),
(23641,'The Vrykul storage facility is up in flames! Dragonflayer defenders have been alerted!','',0,0,0,0,0,0,0,0,1,6678,0,0,26124),
(23642,'Defend yourself, soldier! Blow \'em out of the sky with the fiery lance! Give \'em a taste of their own medicine!','',0,0,0,0,0,0,0,0,1,6678,0,0,26124),
(23643,'Don\'t give \'em an inch, soldier! Harpoon \'em out of the sky!','',0,0,0,0,0,0,0,0,1,6678,0,0,26124),
(23644,'Knock \'em out of the sky! Don\'t let them get in range of you, soldier!','',0,0,0,0,0,0,0,0,1,6678,0,0,26124),
(23645,'Retrieving','Retrieving',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23646,'Phase 2 <PH>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23647,'Kael Weakened <PH>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23648,'Wow, that sucked. Oh well lets try again. <PH>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23649,'I think I saw a key on one of those Gjalerbron vrykul up top.','I think I saw a key on one of those Gjalerbron vrykul up top.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23650,'This large jack-o\'-lantern rests in the middle of the village.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23651,'Smash the pumpkin!','Smash the pumpkin!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23652,'The pumpkin has been smashed, and offers no more treasure.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23653,'Smashing the pumpkin reveals a hidden treasure!  This is the greatest day you\'ve ever known!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23654,'Say, you wouldn\'t happen to have an extra set of reins...','Say, you wouldn\'t happen to have an extra set of reins...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23655,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23656,'Whatcha lookin\' at, ye bilge rat?  Har, har.... just kiddin\' with ye, mate!','Whatcha lookin\' at, ye bilge rat?  Har, har.... just kiddin\' with ye, mate!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23657,'Nothin\' finer than enjoying a fine beverage and the company of some fine buckos... hic!','Nothin\' finer than enjoying a fine beverage and the company of some fine buckos... hic!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23658,'\"Yaaaaaaaaaarrr... it\'s driving me insane!\"  Wait... that\'s not quite how it goes...','\"Yaaaaaaaaaarrr... it\'s driving me insane!\"  Wait... that\'s not quite how it goes...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23659,'Grab a seat and \'ave a drink, mate!  Grab me one while yer at it!','Grab a seat and \'ave a drink, mate!  Grab me one while yer at it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23660,'...that scurvy dog had two peg legs, a hook for a left hand, two glass eyes and a wooden nose!','...that scurvy dog had two peg legs, a hook for a left hand, two glass eyes and a wooden nose!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23661,'Excellent, another sacrificial lamb.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23662,'So eager to die are we?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23663,'You too will serve the Lich King.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23664,'More ingredients to fuel our rituals here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23665,'...so he says \"Of course I\'m not seeing double!  I\'ve only got one eye!\"','...so he says \"Of course I\'m not seeing double!  I\'ve only got one eye!\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23666,'Hello, little one. Come to play?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23667,'Your life for the Lich King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23668,'I have so many wonders to show you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23669,'There\'s always room for one more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23670,'Kiss the gunner\'s daughter?  Why I haven\'t ever met the lass...','Kiss the gunner\'s daughter?  Why I haven\'t ever met the lass...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23671,'I \'eard Terry fenced one of \'em pictures for a thousand gold.  Maybe I can get in some of that artwork dealin\' too!','I \'eard Terry fenced one of \'em pictures for a thousand gold.  Maybe I can get in some of that artwork dealin\' too!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23672,'Yohoho!','Yohoho!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23673,'Is this yer friend, Grezzix?  $g He : She; doesn\'t look very... piratey.','Is this yer friend, Grezzix?  $g He : She; doesn\'t look very... piratey.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23674,'I\'m sure they\'re quite wonderful.  If you don\'t mind I have some drinking to get back to.  You coming, $n?','I\'m sure they\'re quite wonderful.  If you don\'t mind I have some drinking to get back to.  You coming, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23675,'Ahahahahahaha!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23676,'Fly away little soul.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23677,'For the Lich King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23678,'Plucked ripe off the vine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23679,'How disappointing; no resistance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23680,'Your sacrifice will fuel our efforts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23681,'Scalawag Point is just ahead.  I\'m just gonna lie down for a spell, if ye don\'t mind.  Me head is killin\' me.','Scalawag Point is just ahead.  I\'m just gonna lie down for a spell, if ye don\'t mind.  Me head is killin\' me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23682,'No more chatter for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23683,'So eager to be rescued, but no one came now did they?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23684,'Ahoy, umm.... \"matey!\"  This is the $g fellow : gal; I was telling you about, \"me bucko!\"  $g He : She;\'s a real \"terror of the seas!\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23685,'Yarp? Yar wannar fly? Narp... No-no-no-norp gonnarp ha-hap-hap-happen!','',274,399,274,0,0,0,0,0,1,0,0,0,26124),
(23686,'Official Explorers\' League business, McGoyver. Take me to the Explorers\' League Outpost!','Official Explorers\' League business, McGoyver. Take me to the Explorers\' League Outpost!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23687,'Quick, $n!  Put on your disguise!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23688,'Um...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23689,'Yarrrr!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23690,'Curse that frog!  Yes, I joined the Southsea crew - you want to make something of it, mate?  I\'ll cut you down here and now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23691,'Ho there, and welcome to Brewfest!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23692,'Hello, friend! Welcome to the Brewfest Grounds!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23693,'Hail, good $c! Welcome to Ironforge\'s annual Brewfest celebration!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23694,'Foolish child, you will not stop what I have set in motion! Now, meet your doom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23696,'Did you really think that by facing me, you have any hope of saving your friends?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23697,'Who or what would do something like this, man?!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23698,'Hey there, and welcome to Brewfest. Come in and have a drink or three!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23699,'It\'s BLOWIN\' my mind!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23700,'What\'s up, friend? Welcome to the Brewfest Grounds! Now go buy some drinks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23701,'Hey hey, it\'s another $c! Welcome to my annual Brewfest celebration... now go feast and drink some!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23702,'You don\'t just come and do this to a dwarf\'s rug! You just don\'t do things like that!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23703,'','%s shakes her head.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23704,'','Damn shame what they did to that rug.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23705,'Yarrrrrrr!  Ye\'ll never get me spyglass, bilgesucker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23706,'Hozzer, old boy!  Here comes daddy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23707,'Who do ya think dun it, Needlemeyer?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23708,'I dun think nothin\', Wad! I know who\'d do such a heinous thing!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23709,'','Come on, Goodie, lets go scout the area.',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(23710,'Twas those iron cousins of ours! For certain!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23711,'That\'s highly unlikely, brother.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23712,'','William, I saw a fresh growth of herbs out on the ridge. Go ask Becanna to pick them up.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23713,'Unlikely, eh!? Pray tell why you be thinkin\' that, brother, when I know it be true in me bones!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23714,'Because they\'re made of iron ya big dummy! Ya ain\'t got none of da senses pappy left me with - that\'s for darn sure!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23715,'That\'s it! That\'s it! I\'ve had just \'bout enough of ya, brother! Ya had to bring in our pappy, didn\'t ya! Stand up and fight! I don\'t wanna belt ya while yer sittin\' and then hear ya cryin\' \'bout it later!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23716,'Settle down, will ya! No need to be gettin\' all riled up over nothin\'! Remember what happened last time? Now sit down!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23717,'%s grumbles something under his breath.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23718,'','Come on, just do it.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23719,'What? Why do you want me to do it?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23720,'Alright, I\'ll tell her.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23721,'%s takes a deep breath.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23722,'Odd, she\'s usually here...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23723,'Hi, uh, Becanna, I mean... uh, Elenna found some herbs! Can you go pick them up?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23725,'Thanks! If you uh, need any help, just come pick me up... I mean, come get me and I\'ll help!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23726,'%s turns slightly red and walks away.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23727,'','Oh, these apples are utterly delicious!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23728,'','My brother simply must try these.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23729,'Thanks, but I\'m not very hungry right now.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23730,'','Hi, William, what\'s up?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23731,'','Ah, thank you! I\'ll be sure to go get them soon.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23732,'','Nah, I can handle it. Thanks.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23733,'','I\'d better ask before I go herbing this time. I don\'t want to get attacked by another wolf.',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(23734,'','That William is so funny. His face always turns bright red.',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(23735,'',' I am sure a noble soldier of the Alliance has better things on his mind. Oh! Elenna found some herbs so I\'m going to go pick them up.',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(23736,'','%s replants the herbs nearby.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23737,'','Hmm... well, just be careful, he might be sweet on you. I don\'t trust that sister of his either...',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(23738,'','Alright, Becca, just leave them in the garden next to the bush. Watch out for wolves!',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(23739,'... and have I told you about the time when I ventured deep into the heart of Blackrock Mountain?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23740,'That was when I slew the Orc with a great slash and took away these spaulders.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23741,'I found a mighty axe there, freshly forged upon the fire.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23742,'There, I crafted this breastplate with my own hands, toiling for hours upon the forge.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23743,'There, deep within the pockets of a Troll was the beautiful gem, which I sold for a handsome price!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23744,'..with a mighty blow, I slew a Murloc, freeing the orb from his cold, slimy hands!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23745,'... not to forget that time I ventured deep within the forests of Zul\'Aman.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23746,'... the burning sands of Silithus scorched my face as we battled wave after wave of Silithid.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23747,'... the city was burned, a scorched ruin of what it once was. The armies of the undead rose where the people had once lived.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23748,'... did I tell you about the time that I explored the far reaches of Dire Maul?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23749,'%s sighs...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23750,'%s nods silently...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23751,'%s listens impatiently...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23752,'Vexallus discharges pure energy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23753,'%s begins to channel from the nearby Fel Crystal. Destroy it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23754,'Welcome, friend, to the Brewfest Grounds! There\'s much to enjoy here while we celebrate the spirit of friendly competition between rival breweries. If you have any questions, let me know!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23755,'Food & Drink','Food & Drink',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23756,'Tokens & Souvenirs','Tokens & Souvenirs',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23757,'Ram Racing','Ram Racing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23758,'Greetings, $r. I am Hidalgo, master of the hunt and world class falconer. This killing machine that you see perched atop my shoulder is Excelsior.$B$BYou might be thinking to yourself, \"What does a falconer even do?\" Well I\'ll tell you what we do - we hunt! Falconry is the art of using a bird of prey to hunt and catch game. Perhaps you are interested in learning to hunt with a trained raptor? Hidalgo can teach you such things!','',2,1,5,0,0,0,0,0,1,0,0,0,26124),
(23759,'Brewfest is all about enjoying the very best food and drink in the lands, and that\'s no exaggeration! Just take a gander at the many invigorating hand-crafted beers and holiday sausages, pretzels, and cheeses available. You\'ll find nothing better, and for so little coin!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23760,'Next to the beer and sausage, the most popular part of Brewfest is the souvenirs! From traditional holiday garb to mini-kegs of tasty brew, all sorts of Brewfest-themed items are available from Belbi Quikswitch. Just be sure to have plenty of Brewfest Prize Tokens on hand, as it\'s the only way to buy them! You can earn prize tokens by helping out around the Brewfest Grounds.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23761,'BY FIRE BE PURGED! Hey what\'s up?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23762,'Ram racing is one of the great traditions of Brewfest. Speak to Pol Amberstill down by the ram stable if you want to learn more. It\'s a right hoot AND can be a great way to earn Brewfest Prize Tokens!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23763,'Hey there, welcome to Brewfest! There\'s a mess of ways to keep yourself entertained in there, so you got any questions, you let me know. Otherwise, go buy some beer and a pretzel!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23764,'Brewfest is all about the beer and the eats, and it don\'t get any better than what we\'re serving up. Think I\'m lying? Just check out all the tasty brews, sausages, pretzels, and cheeses we got. You\'ll see: Best chow around, and it don\'t get any cheaper!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23765,'Everyone loves those crazy Brewfest racing rams. Want to know more? Talk to Driz Tumblequick down by the ram stable. Have a blast and earn some Brewfest Prize Tokens while you\'re at it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23766,'Hey hey, don\'t forget to grab yourself some Brewfest souvenirs! We got everything from traditional holiday garb to mini-kegs of tasty brew. Just talk to Blix Fixwidget, but make sure you got plenty of Brewfest Prize Tokens on hand... it\'s the only way to buy them! You can earn prize tokens by helping out around the Brewfest Grounds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23767,'','Greetings, Light of Elune be with you.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(23768,'Can you read me Alicia\'s poem again?','Can you read me Alicia\'s poem again?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23769,'','I would love to read it to you!\n\nDo not stand at my grave and weep,\nI am not there, I do not sleep.\n\nI am in a thousand winds that blow,\nacross Northrend\'s bright and shining snow.\n\nI am the gentle showers of rain,\non Westfall\'s fields of golden grain.\n\nI am in the morning hush,\nof Stranglethorn\'s jungle, green and lush.\n\nI am in the drums loud and grand,\nthe thunderous hooves across Nagrand.\n\nI am the stars warmly gleaming,\nover Darnassus softly dreaming.\n\nI am in the birds that sing,\nI am in each lovely thing.\n\nDo not stand at my grave and cry,\nI am not there. I do not die.\n ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23770,'Wanna take a ride?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(23771,'Yep!','Yep!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23772,'[NODE 1] ARRIVING','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23773,'[NODE 1] DEPARTING','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23774,'[NODE 2] ARRIVING','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23775,'[NODE 2] DEPARTING','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23776,'[NODE 3] ARRIVING','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23777,'[NODE 3] DEPARTING','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23778,'[NODE 4] ARRIVING','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23779,'[NODE 4] DEPARTING','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23780,'[NODE 5] DEPARTING - PLEASE NOTE THAT NODE 5 HAS NO ARRIVAL EVENT.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23781,'Vexallus overloads!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23782,'I\'ll tell ya, the only proper way to hunt is when yer good an\' goggled!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23783,'*Squawk!*  Ahoy!  Look at me pirate disguise!  Yarrrr!  *Sqwak!*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23784,'*Caw!*  Talk like a pirate!  Yarrr! *Sqwaaaaak!*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23785,'*Sqwaaak!*  Shut up, stupid bird!  You\'ll get us all killed!  *Cawwwww!*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23786,'Shut your trap, you feathered idiot!  These pirates will cut you open and wear you for a hat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23787,'<The creature pecks at your hand.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23788,'<The falcon squawks hungrily for a grub.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23789,'<Feed the grub to the rock falcon.>','<Feed the grub to the rock falcon.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23790,'We lost everything, brother.  We thank Kamagua for giving us shelter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23791,'You aid us in our time of need.  May the oceans provide you a plentiful catch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23792,'Thank you, Akiaruk.  We\'d heard of your kindness even in Iskaal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23793,'May Tayutka repay you and your village.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23794,'Best keep yer head down, \"matey!\"  If ye know what I mean!$B$BYarrrr!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23795,'','Soon, my love. Soon you will waken and all of Azeroth will know fear!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23796,'','Awaken, Ymiron, the time of your continued reign is nigh.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23797,'','Sleep no longer, my love. With the might of the Lich King behind you, the world will tremble.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23798,'','Why is this ritual taking so long? Your master promised that your assistance would speed the process!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23799,'','Double your efforts! King Ymiron will awaken and then he will ascend!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23800,'','Damn the titans for cursing us so! Ymiron, my king, open your eyes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23801,'','The time has come for my husband, our king, to rejoin us. Together we will scour this world of its unworthy infestation!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23802,'','The ritual proceeds too slowly. More sacrifices are needed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23803,'Not yet, Ymiron, I have other plans for you. You will serve me better within Utgarde Pinnacle. And if these insects survive to find you again, you will get the chance to avenge your wife.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23804,'Who\'s hunting who?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23805,'Such easy prey...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23806,'Tonight we feast on you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23807,'I run the fights around here.  You want to place a bet, gamble with confidence - anyone caught fixin\' fights gets to walk the plank.$B$BI\'ll make sure of that myself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23808,'Blood elf treasure\'s unlike any other.  It\'s not just the gold or the silk or gems used as materials, sin\'dorei craftsmanship is valuable in and of itself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23809,'Taruk sent me to collect what you owe.','Taruk sent me to collect what you owe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23810,'Do not test me, scurvy dog!  I\'m trained in the way of the Blood Knights!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23811,'I yield!  I yield!  By Quel\'thalas!  Don\'t kill me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23812,'I\'ll pay!  I\'ll pay!  Eeeek!  Please don\'t hurt me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23813,'Pay up, Harry!','Pay up, Harry!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23814,'','Day in and day out all Mad Jonah Sterling wants me to do is swab the decks.$B$BSwab the decks?!$B$BI\'m a mage, I don\'t DO swabbin\'! At least not the mundane way.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(23815,'Drink up, ye scurvy mongrels!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23816,'Eat!  Drink!  Be merry!  Next round\'s on you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23817,'Finish yer rum, bucko!  There\'s thirsty orphans in Goldshire, ye know?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23818,'','Keep quiet, will you?  If anyone catches on, we\'re both dead.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23819,'','All right, fellas!  Who ordered the spiced rum?  Was it you, Jackie boy?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23820,'','It\'s ok, sweetheart.  This one\'s on the house.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23821,'Free rum?  Why... that\'s me favorite kind!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23822,'Sweet Neptulon!  That was... one drink... too many!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23823,'<This pirate has obviously had too much to drink.  He appears to be out cold for the time being.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23824,'<Discreetly search the pirate\'s pockets for Taruk\'s payment.>','<Discreetly search the pirate\'s pockets for Taruk\'s payment.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23825,'What are you lot looking at?  Pour me another drink!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23826,'','What\'s it going to be, then?  Rum?  Ale?$B$BOr perhaps something else?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23827,'I\'d like to buy Jack a drink.  Perhaps something... extra strong.','I\'d like to buy Jack a drink.  Perhaps something... extra strong.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23828,'','You\'re going to pull off a stunt on Jack in front of his boys?$B$BThat takes a good amount of... stupidity.  Well, it\'s going to cost you.  I\'m not going to risk my life for anything less than a gold.  And you best wait til I\'m out of the way before you make a move.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23829,'Here\'s a gold, buy yourself something nice.','Here\'s a gold, buy yourself something nice.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23830,'Sure thing, love.  Put it on Harry\'s tab, will ya?  He owes me a drink!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23831,'','There we go, $n! This fat\'ll do the trick fer sure! And now for some real swabbin\'!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23832,'','Look at \'em go! Spotless!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23833,'Yarrrr!  If it\'s me treasure yer lookin\' for... yer gonna have to fight for it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23834,'What ...hic?!','What ...hic?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23835,'That\'s it... no more grog for me!','That\'s it... no more grog for me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23836,'You ever tried on Synthebrew Goggles? They\'re surprisingly uncomfortable!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23837,'Dark Iron Dwarf Attacks','Dark Iron Dwarf Attacks',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23838,'Something\'s got those Dark Iron Dwarves riled up.  They show up almost every half-hour, break all the kegs, and leave!$b$bSo you\'re probably asking, \"Why should I care?\"$b$bI\'ll tell you...  Because the kegs they break stop us from giving out free brew!  You heard me right, free brew!$b$bSo if you are around when those dwarves show up, take a minute and help protect the kegs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23839,'Brewfest is the perfect holiday!  But it\'s got one catch, Dark Iron dwarf attacks.  They happen nearly every half-hour!$b$bThe attackers target the kegs that dispense the FREE brew!  And it\'s really good brew that the brewmasters are giving out!$b$bLook, if you\'re around when the Dark Iron dwarves show up, lend a hand and protect the FREE brew.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23840,'The power! More, more, more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23841,'It seethes and burns...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23842,'I\'ll never stop. Never...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23843,'Yer dead, landlubber!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23844,'Looks like me boys need a hand!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23845,'It\'s MINE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23846,'You wish to steal the power!  Die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23847,'Get away from my crystals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23848,'Yarrrrr... dead again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23849,'Yarrrr, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23850,'Welcome back, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23851,'Is this how you repay your master, you fleabag?  Arrrrrgghh!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23852,'','That cursed Jonah Sterling will lead us right into doom.  If he spent more time outside of his cave, he would realize the folly of attacking professional navies in a time of war.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23853,'','You\'d best scram, $n.  I do not want Jonah\'s death to be linked back to me.$B$BIt\'ll be hard enough to establish myself as leader of this lot without them knowing I had their previous skipper killed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23854,'%s devours his master\'s body.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23855,'Many changes come to the land and water: you, them... much change.$B$BKamagua\'s way of life is threatened by these changes. What will you do?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23856,'I\'m out of my element, eh? Walt doesn\'t know what he\'s talking about! I single-handedly kicked the iron out of these dwarves and set up camp to observe the goings-on of the dig site.\n','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(23857,'The Dude, over yonder, is pretty upset about his rug.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23858,'Evenin\', Gov\'na.','Evenin\', Gov\'na.',113,0,0,0,0,0,0,0,1,0,0,0,26124),
(23859,'The reef cow and her new bull find true love.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23860,'Launching.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(22261,'Unhappy, you have reached the end of the road! Fate will decide who to go forward!','',0,0,0,0,0,0,0,0,1,0,11961,11961,26124),
(23862,'Start the countdown!','Start the countdown!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23863,'ONE!','ONE!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23864,'TWO!','TWO!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23865,'THREE!','THREE!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23866,'FOUR!','FOUR!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23867,'FIVE!','FIVE!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23868,'Walt sent me to pick up some dark iron ingots.','Walt sent me to pick up some dark iron ingots.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23869,'I su... sur... surpose that yar wanna ride back to der outpost. Yarp?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(23870,'Yarp.','Yarp.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23871,'Walt\'s work bench is ready for use.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23872,'<Get on the work bench and let Walt put you in the golem suit.>','<Get on the work bench and let Walt put you in the golem suit.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23873,'Behold my perfect creation!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23874,'Twice a day, at six fifteen in the morning and six fifteen in the evening, High Tinker Mekkatorque himself comes out to the Brewfest grounds for the Tapping of the Keg ceremony. Don\'t miss it!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23875,'WHOA, WHOA, WHOA! Hold everything, fellas!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23876,'The dwarves all burst out in laughter.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23877,'The Tapping of the Keg','The Tapping of the Keg',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23878,'Oh dear lords of stone and steel, what... I repeat... WHAT are ya gonna do with that?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23879,'Twice a day, at six fifteen in the morning and six fifteen in the evening, High Overlord Saurfang himself comes out to the Brewfest grounds for the Tapping of the Keg ceremony. You\'d be a fool to miss it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23880,'Man, that will never work. The iron dwarves are never gonna fall for that hunk o\' junk!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23881,'Only 10 more minutes until High Overlord Saurfang taps the Brewfest keg!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23882,'In 20 minutes High Overlord Saurfang will tap the Brewfest Keg!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23883,'You\'re out of your element, Lebronski! Uncalled for! Those iron dwarves won\'t know what hit \'em! Now why don\'t you get back to uncovering the mystery of the gigantic turd on your rug and leave the real scientists to their work!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23884,'High Overlord Saurfang is on his way!  The \"Tapping of the Keg\" will take place in just a few short minutes!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(23885,'','I\'m cryin\' here! Please, make the funny stop!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23886,'In 20 minutes High Tinker Mekkatorque will tap the Brewfest Keg!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23887,'In just 10 minutes High Tinker Mekkatorque will tap the Brewfest Keg!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23888,'High Tinker Mekkatorque is on his way!  The \"Tapping of the Keg\" ceremony will begin in a few minutes!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23889,'If only our pappy were alive to see this!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23890,'What do you think you\'re doing, man? Lebronski does NOT appreciate you dragging your loose metal parts all over his rug.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23891,'Far out, man. This bucket of bolts might make it after all...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23892,'Model U-9207 Iron Rune Construct does not appreciate your tone of voice. Commencing total annihilation of your rug, Lebronski.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23893,'Come with me *crackle* if you want to live.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23894,'This barrel of ale is guarded by Jarven Thunderbrew.  As long as he\'s in the basement, no barrels may be disturbed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23895,'Alert! Alert! Construct senses that enemies have breeched our defenses. Increase pace.','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23896,'Construct class carrier reporting for duty. Primary function: Overseeing.','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23897,'There is nothing to see here. Proceed with your mandated duties.','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23898,'All hail the great creator.','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23899,'To interfere with construct\'s function results in termination. Move along.','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23900,'Construct must not be questioned by iron dwarf servant. Commence deconstruction.','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23901,'Construct is not authorized to communicate with lesser beings. Being must double their efforts.','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23902,'Did you lose your wallet? Construct has found wallet with overabundance of currency.','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23903,'Halt! Identify yourself immediately!','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23904,'This section is off-limits!','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23905,'I\'ve never seen one of you around here.','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23906,'Hold it! Stop!','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23907,'Stop!! Stop!!! Scrap metal moves itself now?','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23908,'Wrong answer!','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23909,'Well played, $n. Well played, indeed...','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23910,'Right... my bad. Now where was I?','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23911,'All hail the great creator!','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23912,'You\'re right, of course. Carry on.','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23913,'Forgive my insolence!','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23914,'Do you bring word from the creator?','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23915,'We will double our efforts!','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23916,'Work must continue. Double your efforts.','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23917,'Brontes sees all.','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23918,'Do not loiter.','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23919,'Continue deconstruction.','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23920,'Reinforcements en route. Function must be unabated.','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23921,'Destroy earthen infestation.','',0,0,0,0,0,0,0,9,1,0,0,0,26124),
(23922,'Come, minions! Your master calls!','',0,0,0,0,0,0,0,9,1,6724,0,0,26124),
(23923,'The work of your brothers in the Storm Peaks has reached a frenzied pace. Soon, Father will be freed.','',0,0,0,0,0,0,0,9,1,6724,0,0,26124),
(23924,'Your brothers to the north have subjugated the stone behemoths and set them on the path to Ulduar. Soon, the remaining defenses of the Pantheon will be neutralized.','',0,0,0,0,0,0,0,9,1,6724,0,0,26124),
(23925,'The three fissures opened by the mortals of this region must be silenced. The earth hears and sees what we do and will continue to interfere with our efforts if the way is not closed.','',0,0,0,0,0,0,0,9,1,6724,0,0,26124),
(23926,'Bury this place! Your master demands it!','',0,0,0,0,0,0,0,9,1,6724,0,0,26124),
(23927,'The sound of thunder roars throughout the cavern.','',0,0,0,0,0,0,0,9,1,6724,0,0,26124),
(23928,'The sound of thunder dissipates.','',0,0,0,0,0,0,0,9,1,6724,0,0,26124),
(23929,'I\'m ready to go, Walt.','I\'m ready to go, Walt.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23930,'System failure in 3... 2...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23931,'Feed, me bruddahs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23932,'Systems failing *click*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23933,'Crash imminent *clunk*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23934,'Construct going offline *beep*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23935,'*click* Flight systems malfunctioning *clang*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23936,'Be still, mortals, and hearken to my words.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23937,'As you peer into the orb, you feel a familiar force tugging at your mind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23938,'Allow the orb to take you where it will....','Allow the orb to take you where it will....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23939,'You are not yet attuned to the scrying orb.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23940,'Your mind is gradually opened as you focus on the orb before you....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23941,'Land ho, Mr. Kowalski! Port is in sight, sir!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23942,'Thank you, Mr. Henders.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23943,'Bring us into port, please, Mr. Mehran.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23944,'Captain Stash! We\'ll be arriving shortly, sir!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23945,'Thank you, Mr. Kowalski! You may return to your post to oversee docking!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23946,'Well done, all. Please bring us safely to our next port.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23947,'Cap\'n Stash is the BEST!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23948,'I swab the decks!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23949,'The Lady Mehley is the best ship EVER!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23950,'Swabbin\' decks cured my rickets!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23951,'Aye aye, Mr. Kowalski.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(23952,'Times are changing, $n.  War has arrived.$B$BWill our people rise to the occasion and aid our allies... or will we linger in the sidelines?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23953,'I\'ve little time for talk, sorry.','',274,0,0,0,0,0,0,7,1,0,0,0,26124),
(23954,'','Can\'t ya see I\'m workin\' here, $glad:lass;? Off with ya, afore Kowalski sees me jawin.\'',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(23955,'Fine day fer sailin\', innit?','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(23956,'Torgoley works us hard, but he\'s a good captain, aye.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(23957,'There aren\'t many of us left, $n.  The return of our old enemy is a cause for great concern.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23958,'I must keep my eyes on ship and crew, good $gsir:madame;. You must forgive my not pausing to speak with you.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(23959,'The Lady Mehley is in Theramore enough that we\'ve been assigned to guard her passengers.','The Lady Mehley is in Theramore enough that we\'ve been assigned to guard her passengers.',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(23960,'Welcome to the majestic Lady Mehley. I am Captain Torgoley.$b$bIf you\'ve questions about the ship, feel free to ask; otherwise, please, enjoy the journey, as I always do... After all, to quote a favorite scribe of mine: My experience of ships is that on them one makes an interesting discovery about the world. One finds one can do without it completely.','',2,1,0,0,2,0,0,7,1,0,0,0,26124),
(23961,'The Lady Mehley','The Lady Mehley',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23962,'Food & Drink','Food & Drink',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23963,'Goods & Gear','Goods & Gear',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23964,'\"Stash?\"','\"Stash?\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23965,'Aye, that\'s her name, and a fine ship she is.$b$bThere\'s much to learn from such vessels, you know. A great poet once said: Ships that pass in the night, and speak each other in passing, only a signal shown, and a distant voice in the darkness; So on the ocean of life, we pass and speak one another, only a look and a voice, then darkness again and a silence.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(23966,'Should you desire sustenance, Galley Chief Grace can tend to your needs.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(23967,'Mr. Combs, the ship\'s engineer and quartermaster, can furnish you with whatever supplies you might require. He is a fair tinker, too, if your gear is in need of repair.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(23968,'Ah, yes, that... the name. Well... as they say, a good name, like good will, is got by many actions and lost by one. No need to go into the hows or whys; suffice to say, that is how I am named by some.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(23969,'The dead rise and seek vengeance on any that dare pass through their domain. Turn back!\n','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(23970,'From sundered ground the sacrament was stolen. The Shield of Aesirites is lost. Unrest will be eternal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23971,'The Staff of Storm\'s Fury pilfered. A curse upon this land! The storms will never cease!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23972,'The Frozen Heart of Isuldof will consume this land until it is returned. Woe unto those that hold the heart as the curse of frozen blood besets them...\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23973,'The anguish of ten-thousand years awaits any foolish enough to don the Ancient Armor of the Kvaldir. Beware the mist and fog, mortals; for with them comes your end.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23974,'I lucked out. Not many tauren get to be cabin boy on a frigate like this! Grezzix even lets me man these incredible battle canoes.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23975,'I don\'t have time for chit-chat, Lou. Take me to Scalawag Point.','I don\'t have time for chit-chat, Lou. Take me to Scalawag Point.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23976,'The fury of the Vrykul will consume you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23977,'Its power courses through me! I AM A GOD!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23978,'ABDUL IS STRONG LIKE BULL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23979,'ARE YOU CHALLENGING ME? I HAVE THE STRENGTH OF TEN MEN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23980,'HOW DARE YOU! ABDUL WILL PUT YOUR HEAD ON A PIKE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23981,'I need... your help! Cannot... resist him much longer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23982,'Agghh!! Help me before I lose my mind!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23983,'Hurry! There is not much of me left!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23984,'Unparalleled power... I... crave... more!','Unparalleled power... I... crave... more!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23985,'Fel energy... courses through my veins!','Fel energy... courses through my veins!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23986,'Your life force is my nourishment, demon... Kil\'jaeden\'s gift to us!','Your life force is my nourishment, demon... Kil\'jaeden\'s gift to us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23987,'I will soon be stronger than any elf!  I will serve at Kil\'jaeden\'s side!','I will soon be stronger than any elf!  I will serve at Kil\'jaeden\'s side!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23988,'More... more... MORE!!!','More... more... MORE!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23989,'If we are to be successful in the creation of a portal to the Isle of Quel\'Danas, and the Sunwell which rests upon it, we must acquire an energy source powerful enough to ignite the portal.$B$BWe are $3269w percent completed with our efforts. Will you assist us, $c?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(23990,'This portal is not like the others that lead back to Azeroth. To maintain it, we must acquire more mana cells.$B$BIt is either that or risk losing our access to the Isle of Quel\'Danas and the Sunwell.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(23992,'Begone from my sight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23993,'%s unleashes a Spectral Blast!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23994,'What have you done?!','What have you done?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23995,'My power... is gone!','My power... is gone!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23996,'No... no... NO!!!!!','No... no... NO!!!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23997,'Fire! Fire, ya yella sea dogs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23998,'MORE PIRATES FOR SORLOF TO SMASH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(23999,'Where are tiny men!? Just puny flag!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24000,'Sorlof been tricked! Aarrrrggghhh...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24001,'%s becomes unstable with brimming energy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24002,'%s releases its energy, engulfing its surroundings in flames!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24003,'The rift\'s power is ours!','The rift\'s power is ours!',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(24004,'Get away, this place is ours!','Get away, this place is ours!',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(24005,'Mine! You shall not take this place!','Mine! You shall not take this place!',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(24006,'It is not meant for you! Get away from here!','It is not meant for you! Get away from here!',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(24007,'Arise and serve your eternal master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24008,'Core overload detected. System malfunction detected...','Core overload detected. Recharging...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24009,'The crystal pulses faintly.  Its protective energy has grown weak but is not entirely depleted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24010,'','<The noble Flaskasaur nods at you in approval.>',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(24011,'What do you have for me?','What do you have for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24012,'We\'re currently focus testing Zul\'Aman, a 10 player raid dungeon in the Ghostlands. You must be at least level 68 to enter.','',396,396,0,0,0,0,0,0,1,0,0,0,26124),
(24013,'I\'m ready for Zul\'Aman, Jebediah. Teleport me!','I\'m ready for Zul\'Aman, Jebediah. Teleport me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24014,'Objective acquired.  Initiating security routines.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24015,'Commence location defense.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24016,'Deployment successful.  Trespassers will be neutralized.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24017,'The %s becomes energized with arcane power.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24018,'','Greetings, $r.$b$bMy shop is finally open. I hope you like what you see!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24019,'','Good day to you, $c.$b$bThere\'s much to be done to assist in the effort here. Sadly, there\'s very little I can do for you until I get all of my supplies.$b$bI\'ve now got $3223w percent of the razorthorn roots I need to get started. Any assistance you provide will be well worth the effort, I assure you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24020,'Kwa! You cannot kill me, I am immortal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24021,'Quickly! Use the flames and support the ground troops. Its ancient magic should cleanse Terokk\'s shield.','Quickly! Use the flames and support the ground troops. Its ancient magic should cleanse Terokk\'s shield.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24022,'','This is the gateway that Kael\'s armies used to retreat to the Sunwell.  Some of his lapdogs remain here; the Legion has rewarded them in a most... unusual way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24023,'','Have you seen the damaged sentries that wander the island?  A few modifications to the crystals that control their behavior will allow us to gain control of them and use them to secure tactical locations.$B$BThe Sun\'s Reach Sanctum will be ours in no time.  We are $3244w percent done with this goal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24024,'','We succeeded in taking the Sanctum.  We can continue to convert sentries and use them as guards at other tactical locations.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24025,'Ahoy! Ye be lookin\' to book passage board the Sister Mercy, matey? Ye\'ve come to the right place...','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(24026,'We must make sure not to lose any more souls to the seas.','We must make sure not to lose any more souls to the seas.',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(24027,'Aim for the keester!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24028,'Fire! Fire for the booty, me hearties!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24029,'It may\'ave won in life, but it won\'t be winnin\' in the afterlife! FIRE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24030,'Forgive me $c, but I must concentrate on my job.','Forgive me $c, but I must concentrate on my job.',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(24031,'Many have been lost to the seas.  I, and the wisps, are charged with looking for those souls.  ','Many have been lost to the seas.  I, and the wisps, are charged with looking for those souls.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24032,'Sorlof\'s booty falls to the floor.','',0,0,0,0,0,0,0,0,1,6797,0,0,26124),
(24033,'The wisps and I watch the seas for any lost souls.','The wisps and I watch the seas for any lost souls.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24034,'The seas are a dangerous place, $c.  We must be alert.','The seas are a dangerous place, $c.  We must be alert.',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(24035,'I\'m afraid I cannot speak with you at the moment.','I\'m afraid I cannot speak with you at the moment.',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(24036,'I hunger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24037,'The power... it will be mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24038,'You will not stop me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24039,'The crystal wards... I must feed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24040,'So... much... power.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24041,'The energy; I can feel it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24042,'We will retake these wards!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24043,'You cannot keep our wards!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24044,'Yo-ho-ho, and a bottle of gnomish spirits!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24045,'Thar she blows!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24046,'Rum and wenches for all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24047,'Take that, landlubber!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24048,'The booty be ours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24049,'... did you see how Kael\'thas looked?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24050,'Yes. He hasn\'t been the same since the attack on Tempest Keep.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24051,'He was beaten and left for dead. If Priestess Delrissa hadn\'t arrived when she did, who knows what might have happened!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24052,'That look in his eyes now... it scares me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24053,'Yes, but we will follow him to the end. Its our duty to hold this sanctuary while he prepares.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24054,'Prepares? Prepares for what?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24055,'His... return.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24056,'%s gasps.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24057,'Blessings of the naaru upon you, my friend.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24058,'You don\'t get to see much action in my line of work.  Serving this close to the front lines in a combat zone is a nice change of pace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24059,'Speaking of action, I\'ve been ordered to undertake an air strike.','Speaking of action, I\'ve been ordered to undertake an air strike.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24060,'I utterly cannot stand the presence of these demons!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24061,'Yes! When was the last time you saw a doomguard take a bath?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24062,'... not to mention that those blasted abyssals patrol all over the flowerbeds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24063,'Why do we need them anyways?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24064,'Lord Kael\'thas insisted upon it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24065,'Well, I hope once they\'re done he\'ll send them right back through that portal...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24066,'%s nods in agreement.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24067,'Train harder! We are all that remains of the loyal defenders of Kael\'thas!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24068,'Put your shoulders into it! We must defend the Sunwell with our lives if needed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24069,'Kael\'thas will not tolerate any further failures!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24070,'Again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24071,'The Dawnblade will defend this land for all of the Sin\'dorei. There is no turning back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24072,'This is no vacation - our hearts, our souls, the final escape from the addictions that bind us lie here on Quel\'Danas. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24073,'Do you want to end up like one of the Wretched? No?! Then put your hearts into it this time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24074,'Kil\'jaeden\'s patience wears thin!  Destroy the naaru\'s lackeys once and for all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24075,'Coilskar Key','Coilskar Key',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24076,'You fear death?  Far worse awaits you, should you fail!  Slay the mortals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24077,'Return to your posts!  The battle is not yet over!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24078,'The Sun\'s Reach Armory is ours!  We\'ve pushed the demons back to Dawning Square!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24079,'We\'ve taken the Sanctum at Sun\'s Reach!  Send word back to Shattrath, we make our move now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24080,'Capturing the Sun\'s Reach Sanctum was the first step in our battle plan.  Our orders are to take control of the armory next.$B$BWe are $3233w percent done with our goal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24081,'We have gained control of the armory, but our work on the island is not yet finished.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24082,'','My orders are to create a distraction at the Dead Scar so our forces can take the Sun\'s Reach Armory.  It might not be as glamorous as killing demons face to face, but if it wins us this battle then I\'m all for it.$B$BWe are $3233w percent done with our goal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24083,'','We\'ve captured the armory, $n.  Let\'s not rest on our laurels, however.  The Legion sure will not.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24084,'Our efforts have paid off.  We\'ve captured the Sun\'s Reach Sanctum, $n.  Go there and see if there\'s anyone you can assist.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24085,'Arming the wards at the sanctum will help us secure it faster.  We don\'t want any Wretched getting in our way when we unleash a full scale attack on the Legion and Kael.$B$BWe are $3244w percent done with our goal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24086,'$n, it\'s very good to see you again!','$n, it\'s very good to see you again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24087,'Everyone look, it\'s $n!','Everyone look, it\'s $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24088,'Dawnblade, demons and naga beware, $n is back.','Dawnblade, demons and naga beware, $n is back.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24089,'$G Milord : Milady;, $n, we are fortunate to have you here with us.','$G Milord : Milady;, $n, we are fortunate to have you here with us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24090,'... the Black Temple is under siege?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24091,'The forces of the Aldor and Scryers stormed the citadel shortly after Akama and his foul brethren slew Al\'ar. Its a good thing we left Illidan as soon as we did.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24092,'I had heard that a score of them broke into the Eye and slew him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24093,'Twenty? Impossible, it couldn\'t have been less than fourty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24094,'Well, maybe it was more like a hundred...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24095,'Its only a matter of time before that dog, Akama, betrays the Betrayer as well...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24096,'The Bravery\'s crew will do its best to make your journey as swift and pleasant as possible.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(24097,'Sorry, but we\'ll have to speak some other time. Farewell.','',274,0,0,0,0,0,0,7,1,0,0,0,26124),
(24098,'The Shattered Sun Offensive is lucky to have $n on our side.','The Shattered Sun Offensive is lucky to have $n on our side.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24099,'If it weren\'t for $n, we\'d all be long dead.','If it weren\'t for $n, we\'d all be long dead.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24100,'$n, thank you again for helping us. We couldn\'t have achieved any of this without you.','$n, thank you again for helping us. We couldn\'t have achieved any of this without you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24101,'','Welcome to The Bravery, $gsir:madame;. Now if you\'ll excuse me...',2,0,0,0,0,0,0,7,1,0,0,0,26124),
(24102,'Three cheers for $n!','Three cheers for $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24103,'It\'s an honor to serve with you, $n.','It\'s an honor to serve with you, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24104,'$n has kept the demons at bay countless times.','$n has kept the demons at bay countless times.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24105,'','I\'m almost jealous of our Mr. Wavesinger. Why, he may well be prettier than me!',1,11,0,0,3,0,0,7,1,0,0,0,26124),
(24106,'If I were one of those Dawnblade blood elves, I\'d be swimming away from the island now that $n is here.','If I were one of those Dawnblade blood elves, I\'d be swimming away from the island now that $n is here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24107,'How many wretched do you think $n has put out of their misery?','How many wretched do you think $n has put out of their misery?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24108,'Snap to attention, $n, one of our finest, is here!','Snap to attention, $n, one of our finest, is here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24109,'','Unlucky name fer a sailor, innit?',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(24110,'Welcome back, $n.','Welcome back, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24111,'There\'s our $g hero : heroine; right there! How are you doing, $n?','There\'s our $g hero : heroine; right there! How are you doing, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24112,'I guarantee that without $n, this whole offensive would have been a failure.','I guarantee that without $n, this whole offensive would have been a failure.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24113,'No matter what, your efforts will always be exalted here, $n!','No matter what, your efforts will always be exalted here, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24114,'This greyin\' seadog may be the oldest of the crew, but he\'s also the toughest of the lot! Eh? Eh? Arms like an ogre!','',1,23,0,0,3,0,0,7,1,0,0,0,26124),
(24115,'Lay waste to the demons on the Dead Scar lately, $n?','Lay waste to the demons on the Dead Scar lately, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24116,'$n, one of these days I want to buy you a drink.','$n, one of these days I want to buy you a drink.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24117,'I don\'t even want to think about what\'ll happen here if $n ever decides not to come back.','I don\'t even want to think about what\'ll happen here if $n ever decides not to come back.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24118,'','We\'ve sworn to do our very best to protect the passengers of The Bravery. The sea lane between Rut\'theran Village and Stormwind Harbor must remain safe.',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(24119,'$n, you have no idea what a relief it is to see you!','$n, you have no idea what a relief it is to see you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24120,'What a coincidence... we were just talking about you, $n!','What a coincidence... we were just talking about you, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24121,'Who needs sentries? $n is here!','Who needs sentries? $n is here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24122,'Hey, $n, try to leave some of the glory for us, would ya?','Hey, $n, try to leave some of the glory for us, would ya?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24123,'The Dawnblade forces have been driven from the Sun\'s Reach Harbor!  The day is ours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24124,'Examining','Examining',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24125,'Hey, kid. You\'re aboard the Maiden\'s Fancy. The name\'s Captain Wrenchnozzle, and you\'ve got the privilege of sailing on the pride of the Blackwater Raiders. The Bloodsail don\'t come near us, not with my sharp crew and the large amount of gunpowder in the hold. Insurance, you know.$b$bIf you\'ve got questions, kid, I\'ll answer \'em.','',2,1,0,0,2,0,0,0,1,0,0,0,26124),
(24126,'The Maiden\'s Fancy','The Maiden\'s Fancy',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24127,'Yeah, that\'s her you\'re standing on. A beaut, isn\'t she? The Baron set me up as the captain a while back. She\'s not mine originally, so I didn\'t name her; if you want my opinion, kid, I think the sailor who named her spent a little too much time at sea and not enough time in port, if you catch my meaning.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24128,'If your stomach\'s rumbling, talk to Galley Chief Steelbelly, but just between you and me? You might want to wait. He\'s got that name for a reason.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24129,'What\'s a Steamwheedle ship without an engineer, eh? Torquespindle can help you with anything you need. He\'s handy with repairing things quickly, too, if that\'s what you\'re after.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24130,'Welcome aboard the Feathermoon Ferry.  We travel between Feathermoon Stronghold and the Forgotten Coast looking for those lost at sea.  The sea can be a dangerous place if you are not prepared.$b$bIf you need to get prepared, please speak to our provisioners.  They are more than happy to help you.','',2,1,0,0,2,0,0,7,1,0,0,0,26124),
(24131,'On behalf of the crew of the Moonspray, I welcome you $c.  I hope you take advantage of our provisions before parting with us.','',2,1,0,0,2,0,0,7,1,0,0,0,26124),
(24132,'Watch your step aboard Elune\'s Blessing, $r.  Though Elune\'s blessed us with the discovery of our new friends, we\'ve also had our share of hardships at sea.$b$bHowever, recovering souls lost at sea or lost in a new world is truly a blessing from Elune.','',1,2,0,0,2,0,0,7,1,0,0,0,26124),
(24133,'Elune has blessed us many times over with all the discoveries we have made.  But we must remain vigilant, $c.','Elune has blessed us many times over with all the discoveries we have made.  But we must remain vigilant, $c.',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(24134,'','Forgive me, $r, I must focus on my job.',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(24135,'','I\'m sorry, I\'ve little time for speaking to anyone other than the wisps and the captain to report my findings.  Forgive me.',2,0,0,2,0,0,0,7,1,0,0,0,26124),
(24136,'Welcome aboard the Maiden\'s Fancy. It should be smooth sailing all the way to port.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24137,'It\'s amazing what you can learn from a gnome if you squeeze them hard enough: clever little tricks about getting out of a bind, making delicious cookies, and even how to make a flying machine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24138,'Flying machines?','Flying machines?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24139,'Do you often squeeze gnomes?','Do you often squeeze gnomes?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24140,'As often as I can.  It\'s great exercise and it keeps me informed on what they\'re up to--which, from my experience, is always no good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24141,'That\'s... great.  What about these flying machines?','That\'s... great.  What about these flying machines?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24142,'Thanks!  I\'ll try it right now.','Thanks!  I\'ll try it right now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24143,'%s goes into a killing frenzy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24144,'%s becomes enraged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24145,'Kite','Kite',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24146,'Rocket Chicken','Rocket Chicken',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24147,'Paper Airplane','Paper Airplane',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24148,'Urrrk... if that grubbing galley chief over there offers you his special, do yourself a favor and dump it in the ocean. It might kill a few makruras instead of your will to live.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24149,'','Hello, $r.$b$bLet\'s get busy! No sense waiting around for supplies that may never arrive.$b$bI need my anvil in order to outfit our troops properly. Right now It\'s $3228w percent complete.$b$bAnd when the anvil is completed, there will be many more powerful items that I will be able to smith for you.',1,5,0,0,1000,0,0,0,1,0,0,0,26124),
(24150,'','Hello, $n.$b$bNow that I\'ve finished creating my anvil I can begin outfitting our troops. It\'s an important step, but there\'s still much to be done.$b$bMore importantly for you, there are new things that I can create, which you may be interested in.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24151,'','We\'ve taken the harbor, and this ship is a nice bonus. Too bad she\'s not yet sea-worthy.$B$BIn the meantime, I\'ve been instructed to oversee the disruption of the naga on the Greengill Coast.$B$BThink you can help me out?',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(24152,'I need to intercept the Dawnblade reinforcements.','I need to intercept the Dawnblade reinforcements.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24153,'Welcome aboard the Thundercaller!$b$bDon\'t pay attention to the people that complain about explosions or the like.  I mean really, everyone makes mistakes.  We should cut people some slack.$b$bLook, I\'d understand if a captain managed to crash his ship 22 or 23 times... But anything less than that isn\'t worth mentioning.','',1,2,0,0,2,0,0,1,1,0,0,0,26124),
(24154,'<Grumbles>  I guess those mountains came out of nowhere...  All five times!','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(24155,'<Grumbles>  You\'d think it would be hard to crash a zeppelin into the ocean.  You\'d think it\'d be even harder to do it four separate times!','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(24156,'<Grumbles> I wish I could say we\'ve managed to avoid crash landing into lakes.  I wish I could say we\'ve only crashed into a lake once... but we\'ve managed to crash into four separate lakes, including Lordamere Lake!','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(24157,'I am impressed that pine tree branches don\'t seem to damage our ship much.$b$bNot that it excuses the three times we\'ve crashed into some forest.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(24158,'I never thought I\'d get to see Teldrassil... I certainly never thought we\'d crash into Teldrassil.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(24159,'We\'ve managed to squeeze through Thunder Bluff twice now!  ','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(24160,'<Grumbles> I still don\'t know how we managed to snake through Thousand Needles without a scratch, only to crash and burn in the Shimmering Flats!','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(24161,'','If you like excitement, our captain\'s the best!  I love this job!',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(24162,'Don\'t ask...','',274,0,0,0,0,0,0,1,1,0,0,0,26124),
(24163,'You can\'t blame me for our mishaps... I can\'t even see where I\'m going!$b$bThough maybe that means you can blame me...$b$bNo!  Wait!  I can dock this ship just fine... It\'s gotta be the orders the captain issues!  Maybe he likes pushing us to our limits and testing out our survival and repair skills.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(24164,'','Good work, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24165,'','I can use all of the cleansed metal that you can provide.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24166,'','At this rate, our men and women will be the finest equipped in no time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24167,'','Thank you, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24168,'','Your form is excellent. Are you a blacksmith by chance?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24169,'','Along with the naga\'s ore, the cleansed metal that you provide will form a nigh-invulnerable alloy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24170,'','Your work here is invaluable to the Offensive.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24171,'','Thank you for purifying the armaments yourself, $n. I have much to do and very little time to do it in.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24172,'I used to be known as Iolol until a secret vote was passed around town that resulted in me having to change my name. It was either change it or go the way of Corki. You would have done the same. What do you think of my new name? Huge improvement, right?$B$BBy the way, check the bulletin board if you\'re looking for work.','',396,396,0,0,0,0,0,0,1,0,0,0,26124),
(24173,'Dragonhawk incoming from the west!  Shoot that $c down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24174,'Don\'t let that dragonhawk through!  Open fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24175,'Shattered Sun scum!  Fire at will!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24176,'We\'ve got your back, $n!','We\'ve got your back, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24177,'Move up and hit them from above.  Let\'s try to get $n some cover.','Move up and hit them from above.  Let\'s try to get $n some cover.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24178,'It\'s showtime!  Blast them hard, blast them fast!','It\'s showtime!  Blast them hard, blast them fast!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24179,'Something I can help you with? Looking for a pet pig, perhaps?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24180,'Golden Pig','Golden Pig',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24181,'Silver Pig','Silver Pig',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24182,'Fall into formation!  We\'re approaching the Dead Scar.','Fall into formation!  We\'re approaching the Dead Scar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24183,'Be quick with those charges.  Some of those demons are going to take more than one direct hit to bring down.','Be quick with those charges.  Some of those demons are going to take more than one direct hit to bring down.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24184,'Keep your eye on the demons.  We\'re not concerned with killing Scourge today.','Keep your eye on the demons.  We\'re not concerned with killing Scourge today.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24185,'Crush these stinking husks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24186,'Smash them! Grind the bones into the dirt!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24187,'Harder, maggots! We must keep the sunwell clear for the master\'s return!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24188,'Burn their bodies, shred their skins, crush their creaking carapaces!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24189,'No horror here can compare with what you\'ll face when I\'m through with you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24190,'Beat or be beaten! This is the way of the Legion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24191,'Beat or be beaten! This is the way of the Legion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24192,'I hear Pit Lords are born from maggots, Brutallus!','I hear Pit Lords are born from maggots, Brutallus!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24193,'Big talk from a blue birdie! How about you come down and see if you can pluck this maggot from the dirt!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24194,'ATTENTION!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24195,'Hello to you new recruits. I\'m Drill Sergeant Bahduum. For the next few days, you\'re going to receive orientation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24196,'The Isle of Quel\'Danas has been overrun by the forces of Prince Kael\'thas Sunstrider. Intel had him pegged as deceased. Intel was wrong.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24197,'Up on the plateau, he and his demon friends are trying to reignite the Sunwell and open a rift to bring their head-honcho, Kil\'Jaeden, back into the world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24198,'Our job is to clear out as much of his fodder as we can, while supporting the specialists that the powers-that-be are having brought in.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24199,'Needless to say, a lot of us won\'t be going home. But if you remember your training and keep your wits about you, you\'ll greatly increase your chances.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24200,'That\'s all I have to say for now. Stay focused, boys and girls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24201,'Golden Pig','Golden Pig',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24202,'Silver Pig','Silver Pig',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24203,'Come down! I tear your wings from your shoulders and feed you to the dirt. Then YOU be the maggot, dragon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24204,'I prefer my meals a bit colder!','I prefer my meals a bit colder!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24205,'Grraaarrr! You think to make an icicle out of me? Come down, then I will add real fire to your life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24206,'What is this pathetic magic? How about you come back with twenty-four of your best friends and try again, $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24207,'Sir, we\'ve just flown in from the south. What are your orders?','Sir, we\'ve just flown in from the south. What are your orders?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24208,'Yes, sir!','Yes, sir!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24209,'Very good. Fall into formation with the rest of your squadron. There is work to be done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24210,'Alright, quiet down. We have a lot to do and very little time to do it in, people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24211,'I\'ve stood with some of you draenei before at Skettis, and others in Shadowmoon Valley. But now we\'re on Azeroth, and the situation looks grim.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24212,'First though, you sin\'dorei listen up. I run a tight ship... this isn\'t going to be like what you\'re used to with the Scryers. Pull your weight, or get back on the boat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24213,'Now that that\'s out of the way, welcome to the Isle of Quel\'Danas. The Sunwell\'s on the plateau to the south, and Prince Kael\'thas is holed up in the Magisters\' Terrace to the east.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24214,'We\'re here as support for the so-called \'adventurers\' that the brass has called in. We\'ll help them hold the key points on the island, and keep the heat off so that they can do their jobs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24215,'If none of you ladies have any questions, you can get further instructions and assignments from your squad leaders. That\'s it. Good luck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24216,'Welcome to the Sunwell. Despite the mild temperatures and scenic vistas, you\'re not on vacation, ladies and gentlemen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24217,'The current situation looks like this: we\'re holding what we can while those with more experience and better equipment are moving against Prince Kael\'thas.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24218,'I know, we thought he was dead too, but that\'s not the case. He\'s trying to use the Sunwell to bring the master of the Burning Legion, Kil\'Jaeden, into this world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24219,'Let me assure you people that if he\'s successful, this world will suffer far worse than Outland ever did! So, let\'s make sure that doesn\'t come to pass.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24220,'Warriors will be deployed to hold key positions, while you marksmen will be assigned to keep the enemy fliers at bay.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24221,'I\'m awaiting orders on your specific assignments. In the meantime, stay here and be ready to move at a moment\'s notice!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24222,'What news of the fight to take the Sun\'s Reach Armory?','What news of the fight to take the Sun\'s Reach Armory?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24223,'I am glad that you ask. Our efforts to take the armory are at $3233w percent of our projections.$B$BI know that Battlemage Arynna and Harbinger Inuuro need your help. Seek them inside the Sun\'s Reach Sanctum on the Isle of Quel\'Danas.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24224,'How close are we to the completion of the anvil and forge at the Sun\'s Reach Armory?','How close are we to the completion of the anvil and forge at the Sun\'s Reach Armory?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24225,'Last I heard from Hauthaa, she indicated that we are $3228w percent of the way there.$B$BI cannot express how vital it is to our efforts that we get them created. Our men and women are going to need better armor and weapons, and the anvil and forge are the key to that.$B$BYou will find the smith behind the Sun\'s Reach Armory, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24226,'I have something else to ask you about.','I have something else to ask you about.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24227,'Exarch, have we taken the Sun\'s Reach Harbor yet?','Exarch, have we taken the Sun\'s Reach Harbor yet?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24228,'No, unfortunately we have not yet taken the harbor. However, reports indicate that we are $3238w percent of the way towards doing so.$B$B$n, if you want to help out, look for Magister Ilastar and Vindicator Kaalan at the Sun\'s Reach Armory on the Isle of Quel\'Danas.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24229,'Nasuun, do you know how long until we have an alchemy lab at the Sun\'s Reach Harbor?','Nasuun, do you know how long until we have an alchemy lab at the Sun\'s Reach Harbor?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24230,'The alchemy lab is not quite yet ready, $n. Mar\'nah says that she is $3223w percent done with its assembly, however.$B$BIf you would like to help her with that, you will find her inside the inn at the Sun\'s Reach Harbor.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24231,'What do you know about the magical gates at the Sunwell Plateau being brought down?','What do you know about the magical gates at the Sunwell Plateau being brought down?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24232,'We are trying to bring Agamath, the First Gate down. Please, $c, go to the Isle of Quel\'Danas and help in any way that you can!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24233,'Agamath, the First Gate is breached and two of Kil\'jaeden\'s lieutenants, Lady Sacrolash and Grand Warlock Alythess, must be destroyed.$B$BGather your friends, $c, and see to it! Rohendor, the Second Gate is our next target.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24234,'Rohendor, the Second Gate has been brought down, but the last of the Sunwell Plateau\'s magical barriers, Archonisus, resists us, $n.$B$BMaintain your efforts to assist at the Sunwell in any way that you can.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24235,'We did it!  We survived another trip with our ship intact!  But that\'s no reason to slack off!  Push her hard until we dock!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24236,'','Prepare to dock!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24237,'Full speed ahead Mister Copperbolt!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24238,'Take us out nice and fast Mister Copperpants.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24239,'Mister Copperpot, you may take us out.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24240,'Mister Coppertop... Punch it!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24241,'','Sir, my name is... Oh, never mind...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24242,'','Mister Fairweather, slow ahead if you please!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24243,'','By the way, my name is Coppernut, sir!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24244,'','Close sir...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24245,'','You almost got my name right that time, sir.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24246,'','Sir, if you could at least get my gender correct...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24247,'Should Kil\'jaeden rise up through the Sunwell our world will be thrown into a war the likes of which has not been seen for 10,000 years!\n','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(24248,'The first gate, Agamath, has been dismantled! The second gate of Rohendor now blocks our passage.$B$BOur mages are $3255w percent through the defenses of the second gate, Rohendor.','The first gate, Agamath, has been dismantled! The second gate of Rohendor now blocks our passage.$B$BOur mages are $3255w percent through the defenses of the second gate, Rohendor.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(24249,'Rohendor has been obliterated.  Only the gateway, Archonisus, remains.$B$BOur mages are $3257w percent through the defenses of the final gate, Archonisus.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(24250,'Archonisus is no more. Alas, we are... we are too late...$B$BKil\'jaeden is unleashed! The heroes of the world are now our only hope.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24251,'Quickfix!!  We\'ve got our self a situation down here!!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24252,'Another successful trip!  Come on boys let\'s buzz the tower!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24253,'I can\'t believe how lucky we got on that trip!  I really am the greatest sky-captain in all the realms!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24254,'We\'re safe!  But we weren\'t going fast enough!  All I want to feel is the wind in my eyes!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24255,'','\"Iron Eagle.\" Hmph. It\'s a passenger ship, not a warbird! But hey, a job\'s a job, and I\'ll humor Captain \"Bombast\" so long as the prince is paying.$b$bIn any case, welcome aboard.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24256,'Sorta busy.','Sorta busy.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(24257,'What? I\'m busy here.','What? I\'m busy here.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(24258,'On duty. GO. AWAY.','On duty. GO. AWAY.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(24259,'You need something fixed? Use the Vend-O-Tron D-Luxe.','You need something fixed? Use the Vend-O-Tron D-Luxe.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(24260,'We protect this airship on its way from Orgrimmar to Grom\'gol base camp in Stranglethorn Vale.','We protect this airship on its way from Orgrimmar to Grom\'gol base camp in Stranglethorn Vale.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(24261,'Not right now, $gpal:sugar;... I got things to do. See ya around.','',1,70,0,0,2,0,0,0,1,0,0,0,26124),
(24262,'I run the tightest airship in Azeroth. She used to be fitted with twin light cannons and enough bombs to flatten a city, you know... her mere shadow was enough to rout armies.$b$bWhat? Of course it\'s true!','',1,5,0,0,4,0,0,0,1,0,0,0,26124),
(24263,'%s transforms into a bear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24264,'We\'ve almost consolidated our control over Sun\'s Reach.  If we manage to keep the harbor from getting any reinforcements we will certainly succeed.$B$BWe are $3238w percent done with our goal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24266,'We\'ve done it, $n.  With Sun\'s Reach under our control we are but mere moments away from absolute victory.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24267,'','I\'m gathering funds to build a monument in honor of those who\'ve died in the war.  It is important to not forget the sacrifices we\'ve made to achieve victory.$B$BWe are $3275w percent done with this goal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24268,'','Isn\'t the memorial beautiful?  It is important to remember moments in our history when great sacrifices are made, lest we forget the price of all wars - even ones that are won.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24269,'I\'m going to take a short nap.  Do you think you can handle the ship while she\'s not moving?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24270,'Alright, give me a second to get my bearings...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24271,'It\'s go time!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24272,'Time to get this show on the road!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24273,'Time to work my magic!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24274,'Go ahead, I can handle this part.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24275,'HELP ME!  WE ARE LEAVING!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24276,'WAKE UP!!  WE ARE SHOVING OFF!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24277,'NAP\'S OVER!! WE ARE HEADING OUT!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24278,'If you really want to get past those doors you\'ll lend me the strength of at least three people! Follow me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24279,'','%s clears her throat loudly.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24280,'','Watcher, we have docked.  On your feet!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24281,'','Is your job so hard that you don\'t even have the energy to stand at the ready when we dock?  I gave you this post as a favor to your family.  Don\'t make me regret that decision.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24282,'','Welcome aboard $c.  Take a load off and enjoy the trip.  Aboard \"The Purple Princess\" we want you to relax.  We have vending machines down below if there\'s anything you might need while aboard.',1,2,0,0,4,0,0,1,1,0,0,0,26124),
(24283,'Relaxation is the key to being an efficient crew.  Let the crew relax, and they\'ll perform better.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(24284,'The captain\'s great!  We get time to relax when we dock.  Those are the times I look forward to the most.','',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(24285,'Please allow me a few seconds of rest.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24286,'Let me sleep just five more minutes, mon...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24287,'I\'m busy right now.','I\'m busy right now.',274,0,0,0,0,0,0,1,1,0,0,0,26124),
(24288,'You need something fixed? Use the Vend-O-Tron.','You need something fixed? Use the Vend-O-Tron.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(24289,'I don\'t have time to talk right now.','I don\'t have time to talk right now.',274,0,0,0,0,0,0,1,1,0,0,0,26124),
(24290,'','The flight from Grom\'gol to Undercity is beautiful, though uneventful.  Though that is no excuse to fall asleep on the job.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(24291,'If my calculations are correct, banging on this gong will bring down that door. It\'s crazy, I know, but to be totally honest with you, I think it\'s an idea that might be ahead of its time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24292,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24293,'Come in out of the ash and muck. Dry yourself a spell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24294,'Suit yourself. At least three of you must assist me if we\'re to get inside. Follow me....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24295,'According to my calculations, if enough of us bang the gong at once the seal on these doors will break and we can enter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24296,'Cold feet, I assume. Probably better this way - nothing but death in there for the likes of you....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24297,'The Tauren Chieftains are staying in Silvermoon while I arrange their next tour. They often lounge on the balcony above me when they\'re not practicing. Feel free to wave... they love the attention.\n\nWe\'re not currently hiring for the show or the crew, but you can always check back later. Who knows what will arise?','',1,6,0,0,3,0,0,0,1,0,0,0,26124),
(24298,'Did you manage to see their show in Terokkar Forest? It was amazing!','Did you manage to see their show in Terokkar Forest? It was amazing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24299,'The Tauren Chieftains must be the best-known minstrels in all of Azeroth!','The Tauren Chieftains must be the best-known minstrels in all of Azeroth!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24300,'I wonder how much longer they\'ll be in Silvermoon City. I hope they play here!','I wonder how much longer they\'ll be in Silvermoon City. I hope they play here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24301,'I\'d give nearly anything for a chance to go up there and speak with them...','I\'d give nearly anything for a chance to go up there and speak with them...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24302,'','Do not fight the enemy unprepared, $n.  I can provide you with very powerful items... provided you have proven yourself to us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24303,'Kael\'s lackeys are about to be taught a lesson in humility.  We will crush the Dawnblade army and take Sun\'s Reach Harbor from them.$B$BWe are $3238w percent done with our goal.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24304,'Sun\'s Reach is ours.  Kael\'s dogs are on the run... it is time to put them out of their misery!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24305,'I\'m in charge of the workers that support the Tauren Chieftains.\n\nYou know: packing, driving, and unpacking the wagons, building and taking down the stage, setting up the pyrotechnics, all that sort of thing.','',1,6,0,0,3,0,0,0,1,0,0,0,26124),
(24306,'Schweitzer here is an old friend of mine... a valuable thing, that. Friendship, I mean. I thought I\'d forgotten the feeling until we met again in Shattrath City.\n\nHe\'s not in Tirisfal so much these days, so I thought I\'d take the Orb of Translocation here to give my hellos.','',1,6,0,0,3,0,0,0,1,0,0,0,26124),
(24307,'Mmrrglglglg? Glbmr brmmrggl glmrrbmrgl.$B$BGrglgrlbrr mrgl!!!','',389,0,0,0,0,0,0,0,1,0,0,0,26124),
(24308,'<Ahlurglgr looks surprised to be able to understand you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24309,'','Easy boy.  $n is here to help, $ghe:she;\'s not with the demons.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24310,'Together we will fight our way out of here. Are you ready?','',0,0,0,0,0,0,0,0,1,6811,0,0,26124),
(24311,'Then we leave!','',0,0,0,0,0,0,0,0,1,6811,0,0,26124),
(24312,'This is far enough. I can make it on my own from here.','',0,0,0,0,0,0,0,0,1,6811,0,0,26124),
(24313,'Thank you for rescuing me, $r. Please tell the king that I am back.','',36,0,0,0,0,0,0,0,1,6811,0,0,26124),
(24314,'Hey you, stranger, come here!','',0,0,0,0,0,0,0,0,1,6811,0,0,26124),
(24315,'If only there were someone nearby who would help me escape.','',0,0,0,0,0,0,0,0,1,6811,0,0,26124),
(24316,'You can\'t hold me against my will! You\'ve all been brainwashed!','',0,0,0,0,0,0,0,0,1,6811,0,0,26124),
(24317,'Living in these caverns and following that mad lobstrok, Clacker, is unnatural! Let me free!','',0,0,0,0,0,0,0,0,1,6811,0,0,26124),
(24318,'Glrggg mbrrgl! Brmlgr glgglg uhmrgl grbmr.','',0,0,0,0,0,0,0,0,1,6812,0,0,26124),
(24319,'Blrggl glbmrlgl grggl mrggl!','',0,0,0,0,0,0,0,0,1,6812,0,0,26124),
(24320,'Grgggl! Glmrbrgl Uhglrglrglr!','',0,0,0,0,0,0,0,0,1,6812,0,0,26124),
(24321,'Whatchoo been doin\', pacin\' yourselves?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24322,'Grglmbrgl? Mrgl glbmrgl rawglgl!','',0,0,0,0,0,0,0,0,1,6812,0,0,26124),
(24323,'I hope I have a chance to visit with Greatfather Winter before Winter Veil is over.','I hope I have a chance to visit with Greatfather Winter before Winter Veil is over.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24324,'The goblins of Smokywood Pastures always have such wonderful treats for sale this time of year.','The goblins of Smokywood Pastures always have such wonderful treats for sale this time of year.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24325,'Where are all those wonderful winter hats coming from?','Where are all those wonderful winter hats coming from?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24326,'The Dark Portal opens once again! What does it portend?','The Dark Portal opens once again! What does it portend?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24327,'The Burning Legion has returned! What can we do to stop them?','The Burning Legion has returned! What can we do to stop them?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24328,'The armies of the Burning Legion are attacking all across Azeroth. We need heroes to throw them back!','The armies of the Burning Legion are attacking all across Azeroth. We need heroes to throw them back!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24329,'Happy Hallow\'s End!','Happy Hallow\'s End!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24330,'I think I\'ve eaten too much candy...','I think I\'ve eaten too much candy...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24331,'We should go trick or treating later.','We should go trick or treating later.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24332,'Legend says that the great beast Omen sleeps in the waters of Lake Elune\'ara in Moonglade, only to appear once a year. But that\'s just a legend.','Legend says that the great beast Omen sleeps in the waters of Lake Elune\'ara in Moonglade, only to appear once a year. But that\'s just a legend.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24333,'During the Lunar Festival, we should take time to seek out our elders and consider their wisdom.','During the Lunar Festival, we should take time to seek out our elders and consider their wisdom.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24334,'Have you seen the fireworks? This is the best time of year to buy them.','Have you seen the fireworks? This is the best time of year to buy them.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24335,'The druids of Nighthaven are holding a great celebration in Moonglade for the Lunar Festival.','The druids of Nighthaven are holding a great celebration in Moonglade for the Lunar Festival.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24336,'Next year, I\'m dressing up as either a corsair or an assassin.','Next year, I\'m dressing up as either a corsair or an assassin.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24337,'What do you think of the mask?','What do you think of the mask?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24338,'Next year, I\'m dressing up as either a corsair or an assassin.','Next year, I\'m dressing up as either a corsair or an assassin.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24339,'What do you think of the mask?','What do you think of the mask?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24340,'I hope I have a chance to visit with Greatfather Winter before Winter Veil is over.','I hope I have a chance to visit with Greatfather Winter before Winter Veil is over.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24341,'The goblins of Smokywood Pastures always have such wonderful treats for sale this time of year.','The goblins of Smokywood Pastures always have such wonderful treats for sale this time of year.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24342,'Where are all those wonderful winter hats coming from?','Where are all those wonderful winter hats coming from?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24343,'The Dark Portal opens once again! What does it portend?','The Dark Portal opens once again! What does it portend?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24344,'The Burning Legion has returned! What can we do to stop them?','The Burning Legion has returned! What can we do to stop them?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24345,'The armies of the Burning Legion are attacking all across Azeroth. We need heroes to throw them back!','The armies of the Burning Legion are attacking all across Azeroth. We need heroes to throw them back!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24346,'Happy Hallow\'s End!','Happy Hallow\'s End!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24347,'I think I\'ve eaten too much candy...','I think I\'ve eaten too much candy...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24348,'We should go trick or treating later.','We should go trick or treating later.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24349,'Legend says that the great beast Omen sleeps in the waters of Lake Elune\'ara in Moonglade, only to appear once a year. But that\'s just a legend.','Legend says that the great beast Omen sleeps in the waters of Lake Elune\'ara in Moonglade, only to appear once a year. But that\'s just a legend.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24350,'During the Lunar Festival, we should take time to seek out our elders and consider their wisdom.','During the Lunar Festival, we should take time to seek out our elders and consider their wisdom.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24351,'Have you seen the fireworks? This is the best time of year to buy them.','Have you seen the fireworks? This is the best time of year to buy them.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24352,'The druids of Nighthaven are holding a great celebration in Moonglade for the Lunar Festival.','The druids of Nighthaven are holding a great celebration in Moonglade for the Lunar Festival.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24353,'The best defense is a good offense; anyone can tell you that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24354,'','A strong weapon is no good if you don\'t live long enough to wield it, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24355,'Gawurgggl! Blrgl-brgl grgl!','',389,0,0,0,0,0,0,0,1,0,0,0,26124),
(24356,'You have learned a trick to speak with us, $r, but I am not impressed.$B$BThere are Winterfin betrayers across the water that need killing.','',36,0,0,0,0,0,0,0,1,0,0,0,26124),
(24357,'Next!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24358,'Yeah.  We could use some more of you.  Report to the civilian liaison for work assignment.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24359,'I do have some openings in your line of work.  Report to the civilian liaison.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24360,'I thought we had enough in your line of work, but it looks like we have some openings.  Report to the civilian liaison.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24361,'Yes, you\'re well seasoned in your field of work.  Report to the civilian liaison at once, we need more like you!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24362,'I\'m not blind, you know. I can see what\'s going on around here!','',36,0,0,0,0,0,0,0,1,0,0,0,26124),
(24363,'Not anymore!  Here\'s your sword.  Report to the barracks for duty!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24364,'Ahglrglglrglgrrr!','',36,0,0,0,0,0,0,0,1,0,0,0,26124),
(24365,'Afraid not, friend.  Here\'s your sword and shield.  Report to the barracks for duty.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24366,'With a sword arm like that?  I\'m afraid we need you in the front lines, my friend.  Report to the barracks.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24367,'You\'re breaking my heart - I\'ve quotas to fill, you know?  Can you wield a sword?  Off to the barracks.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24368,'Looks like we have room for one more... no, my mistake.  That\'s a seven not a one.  Hope you\'re good with a sword - report to the barracks.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24369,'Keep it moving, people.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24370,'Next, please!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24371,'Carpenter, sir.','Carpenter.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24372,'Shipwright, sir.','Shipwright.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24373,'Farmhand, m\'lord.','Farmhand, sir.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24374,'Tailor.','Seamstress, m\'lord.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24375,'Blacksmith.','Blacksmith.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24376,'Mason, sir.','Mason, sir.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24377,'Miner.','Miner, sir.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24378,'Cook.','Cook, sir.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24379,'I recently came here to observe the Winterfin murlocs. Disguised as one of them, I kept my distance and took notes on their day-to-day life.$B$BHowever, not long after I arrived, that all changed.$B$BAn earthquake in Coldarra caused a landslide, which exposed the nearby caverns. Out came a strange makrura who stole away with the Winterfins\' tadpoles. When the murlocs went into the caverns to rescue their young, they re-emerged, glowing and under the makrura\'s influence.$B$BNow the unaffected have retreated to here, and I have reluctantly assumed their leadership.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24380,'King Mrgl-Mrgl, I somehow misplaced your spare murloc outfit. I\'m sorry.','King Mrgl-Mrgl, I somehow misplaced your spare murloc outfit. I\'m sorry.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24381,'Not to worry, $n, one of the gatherers found the outfit where you accidentally dropped it.$B$BHere, take it, but please be more careful. I\'d hate for you to have to fight your way to Claximus and kill more of the Winterfin murlocs unnecessarily along the way.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24382,'State your profession.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24383,'Yes, then.  What is your trade?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24384,'Your profession?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24385,'Your previous line of work, recruit?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24386,'What did you do before you came to Northrend, then?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24387,'Blurg awrurgle mrr?','',35,0,0,0,0,0,0,0,1,6812,0,0,26124),
(24388,'My brothers and sisters have gone insane! Do you think you could help me get out of here?','',36,0,0,0,0,0,0,0,1,6811,0,0,26124),
(24389,'Glug bmrgl grggl!','',389,0,0,0,0,0,0,0,1,0,0,0,26124),
(24390,'No time to talk -- I have work to do!','',389,0,0,0,0,0,0,0,1,0,0,0,26124),
(24391,'You can understand me? I can understand you!','',389,0,0,0,0,0,0,0,1,0,0,0,26124),
(24392,'$R, why would I want to talk to you? Your people probably caused this mess in the first place!','',389,0,0,0,0,0,0,0,1,0,0,0,26124),
(24393,'There are clams to be collected and orcas to be killed. Help or stay out of the way!','',389,0,0,0,0,0,0,0,1,0,0,0,26124),
(24394,'Blurglgr murbrgl... just kidding, I can understand you.','',389,0,0,0,0,0,0,0,1,0,0,0,26124),
(24395,'You figure out yet why our brothers and sisters over in the village have gone insane?','',389,0,0,0,0,0,0,0,1,0,0,0,26124),
(24396,'I knew that we never should have gone into those caves. It\'s not natural!','',389,0,0,0,0,0,0,0,1,0,0,0,26124),
(24397,'There\'s something fishy about new King Mrgl-Mrgl, but I can\'t quite put my finger on it.','',389,0,0,0,0,0,0,0,1,0,0,0,26124),
(24398,'Mawurrgggl, gurgl lur!','',389,0,0,0,0,0,0,0,1,0,0,0,26124),
(24399,'Glumrggl?','',389,0,0,0,0,0,0,0,1,0,0,0,26124),
(24400,'Brggl-brggl Mrgl-Mrgl! Gluk!','',389,0,0,0,0,0,0,0,1,0,0,0,26124),
(24401,'Blrmrrgl gulrgl grr.','',389,0,0,0,0,0,0,0,1,0,0,0,26124),
(24402,'RAWGRLRLRLRRLGLRL!!!','',389,0,0,0,0,0,0,0,1,0,0,0,26124),
(24403,'Mrglrglrglrgl... glrgl?','',389,0,0,0,0,0,0,0,1,0,0,0,26124),
(24404,'Mrglmrgl Glrggl!','',389,0,0,0,0,0,0,0,1,0,0,0,26124),
(24405,'So I heard your brother joined the Scryers?','So I heard your brother joined the Scryers?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24406,'Yeah, he did.','Yeah, he did.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24408,'Wow, how much do they pay?','Wow, how much do they pay?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24409,'Pay? Well, they don\'t pay anything at all.','Pay? Well, they don\'t pay anything at all.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24410,'What? Why would he do a fool thing like that?','What? Why would he do a fool thing like that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24411,'I don\'t know, survival of his race, visions of the future, valiant deeds, blah, blah, blah.','I don\'t know, survival of his race, visions of the future, valiant deeds, blah, blah, blah.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24412,'Sounds like a bunch of rotten Hawkstrider eggs to me.','Sounds like a bunch of rotten Hawkstrider eggs to me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24413,'Yeah, I could never do that. The pay\'s too good here.','Yeah, I could never do that. The pay\'s too good here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24414,'Yeah. I hope to retire next month to a little tract of land I bought off the coast of Azeroth.','Yeah. I hope to retire next month to a little tract of land I bought off the coast of Azeroth.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24415,'Nice. Now that\'s the life...','Nice. Now that\'s the life...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24416,'How long until Lord Kael\'thas reignites the sunwell?','How long until Lord Kael\'thas reignites the sunwell?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24417,'Soon. I hear he has gathered the most powerful casters in Outland together to help perform the summoning.','Soon. I hear he has gathered the most powerful casters in Outland together to help perform the summoning.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24418,'Truly, the Sin\'dorei are the greatest of races.','Truly, the Sin\'dorei are the greatest of races.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24419,'Yes, we shall ascend beyond the mere trappings of our mortal coil and attain the power that were promised to us by Sargeras so long ago.','Yes, we shall ascend beyond the mere trappings of our mortal coil and attain the power that were promised to us by Sargeras so long ago.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24420,'These foolish mortal races will soon see our power.','These foolish mortal races will soon see our power.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24421,'For Kael\'thas and the Burning Legion!','For Kael\'thas and the Burning Legion!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24422,'For Kael\'thas and the Legion!','For Kael\'thas and the Legion!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24423,'','Shadow to the aid of fire!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24424,'','Sacrolash directs Shadow Nova at $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24425,'Charge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24426,'','Alythess directs Conflagration at $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24427,'Good girl, good girl. You just say right here and eat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24428,'There, $n, now you will be able to speak with, and understand, the Winterfin murlocs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24429,'My brothers have awoken. Your efforts are wasted...\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24430,'Your offering has come too late, little one. Can you feel the mist closing in upon you? The Kvaldir return...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24431,'%s laughs.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24432,'Look to the seas, as your doom comes with the swell of tides.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24433,'From the mist and fog the Kvaldir approach. Flee while you still breathe the air of the living...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24434,'I am Atuik, chieftain of the Kalu\'ak of Kamagua.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(24435,'What tiny morsel comes this way? Not one of the murloc I think.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24436,'It\'s been a long time since last I tasted $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24437,'What\'s this? You\'re not one of the Winterfin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24438,'Did \'King Mrgl-Mrgl\' send you? I know what he truly is!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24439,'','We\'re running low on iron, lads!  I don\'t want to see a single bar go to waste, ye hear me now?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24440,'','Oi!  Who\'s been using up all the tin?  Don\'t think just because I\'m a lass I won\'t kick yer behind for wasting materials!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24441,'','Nice work so far.  The recruits keep on coming and they\'re all going to need new blades.  Keep it up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24442,'','These look good.  Nice work.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24443,'','Not bad.  Try that trick I told you about when you temper the steel.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24444,'','This won\'t do; it\'ll be brittle once it cools off.  Smelt the metal, we\'ll use it for ammunition.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24445,'','Now that\'s what I call craftsmanship.  You\'ll have to show me how you did this.  Promise?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24446,'$G Da-da : Ma-ma;?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24447,'Alurglgl.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24448,'Me go home?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24449,'Play!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24450,'Psst... $r, over here! Next to the dead whale.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24451,'Kael\'thas and his felbloods be damned! All we\'ve worked for is gone, but they\'re fools to think we won\'t fight back. Already, Lady Liadrin seeks a new source of power for our order. We will not be destroyed so easily.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24452,'','Alythess! Your fire burns within me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24453,'<The dragonhawk appears to be unsettled by the commotion in the surrounding area.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24454,'Close!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24455,'No go with stranger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24456,'Eww... $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24457,'You not $g da-da : ma-ma;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24458,'The razing of Orgrimmar was not just an attack against orcs, it was an affront to the Horde. An assault against our very existence!$B$BThe Lich King sought to sow the seeds of fear.$B$BThis...$B$B<Garrosh points to the fortified walls that surround him.>$B$BThis is the result of Arthas\'s campaign.$B$BThe Horde fears nothing...\n','',396,396,15,0,0,0,0,0,1,0,0,0,26124),
(24459,'<Ride the dragonhawk to Sun\'s Reach.>','<Ride the dragonhawk to Sun\'s Reach.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24460,'You\'re not one of mine. King Mrgl-Mrgl must have sent you to talk terms of surrender. Come closer so that I might see you better.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24461,'Why do you suffer the presence of this despicable Lady Liadrin? She and her followers distort the Light and make a mockery of all we stand for!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24462,'Patience, general. The Light embraces all who enter Shattrath in good faith.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24463,'You are welcome in Shattrath, Lady Liadrin. We have long awaited your arrival.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24464,'','Thank you for allowing me to speak, A\'dal. I know many of your allies despise me and my knights for our treatment of M\'uru.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24465,'','I\'ve come to realize our path was a false one. We were betrayed by the man we called our prince. In his lust for power, he sent the felblood to attack us, and to spirit M\'uru away to the Sunwell.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24466,'Both our peoples have suffered greatly at the hands of Kael\'thas and his agents, Lady Liadrin. Your people were not the authors of their own fate, but they will die if they do not change.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24467,'M\'uru accepted his role in this long ago, knowing full well what would happen to him. Will you accept your own?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24468,'','I... I don\'t understand. You -- and M\'uru -- knew all along that this would occur?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24469,'It wasn\'t I who foretold it, but Velen of the Draenei:','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24470,'\'Silvery moon, washed in blood,\'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24471,'\'Led astray into the night, armed with sword of broken Light.\'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24472,'\'Broken, then betrayed by one, standing there bestride the sun.\'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24473,'\'At darkest hour, redemption comes, in knightly lady sworn to blood.\'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24474,'','I see it clearly now. I renounce my loyalties to House Sunstrider and its false prince.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24475,'One last drink before we head to the front?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24476,'Sure, why not?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24477,'','We will fight beside you, A\'dal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24478,'Barkeep!  Bring out your strongest ale.  We\'re off to the front.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24479,'You\'ll surely make an exception for us, eh?  We might not come back.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24480,'The Shattered Sun Offensive will surely benefit from the addition of your knights, Lady Liadrin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24481,'The battle for the Sunwell is but the first step on your new path, Lady Liadrin. Shattrath is open to you and all who follow you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24482,'I guess that\'s it then.  Off we go.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24483,'That was the worst beer I\'ve ever had.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24484,'','I pledge the blades of my Blood Knights to the defeat of Kil\'jaeden and the restoration of Silvermoon.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24485,'','When he was given to us by \'Prince\' Kael\'thas, we believed his power would help us lead our people into a new age.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24486,'We are surrounded... Our enemies press in from all sides, young Hellscream.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24487,'The Scourge descends like locust from the north.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24488,'The Alliance holds the only secure shipping lane in this region, and even that is at risk of being lost to those dreaded mists.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24489,'Our only viable port for resupply is held by the Forsaken on the other side of this blasted continent!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24490,'Anything our zeppelins cannot haul must be brought in by ship and travel the length of Northrend to reach us.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24491,'%s grunts.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24492,'Shipping lanes... supplies... You bore me to death! We need nothing more than the warrior spirit of the Horde, Saurfang! Now that we are firmly entrenched in this frozen wasteland, nothing shall stop us!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24493,'Siege engines, ammunition, heavy armor... How do you propose to shatter the walls of Icecrown without those?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24494,'Propose? I will show you what I propose!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24495,'There... Now we now have a shipping lane.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24496,'And just for good measure...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24497,'So the prodigal son has spoken!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24498,'Your father\'s blood runs strong in you, Hellscream. Impatient as always... Impatient and reckless.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24499,'Interested in learning about inscription?','Interested in learning about inscription?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24500,'You rush headlong into all-out war without a thought of the consequences.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24501,'Do not speak to me of consequences, old one. ','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24502,'I drank of the same blood your father did, Garrosh. Mannoroth\'s cursed venom pumped through my veins as well.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24503,'I drove my weapons into the bodies and minds of my enemies.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24504,'And while Grom died a glorious death - freeing us all from the blood curse - he could not wipe away the terrible memory of our past.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24505,'His act could not erase the horrors we committed. ','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24506,'%s pauses.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24507,'The winter after the curse was lifted, hundreds of veteran orcs like me were lost to despair.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24508,'Our minds were finally free, yes... Free to relive all of the unthinkable acts that we had performed under the Legions\' influence.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24509,'%s nods.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24510,'I think it was the sounds of the draenei children that unnerved most of them... You never forget...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24511,'Have you ever been to Jaggedswine Farm? When the swine are of age for the slaughter... It\'s that sound. The sound of the swine being killed... It resonates the loudest. Those are hard times for us older veterans.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24512,'But surely you cannot think that those children were born into innocence? They would have grown up and taken arms against us!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24513,'%s shakes his head.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24514,'%s looks grimly at Garrosh.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24515,'I am not speaking solely of the children of our enemies...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24516,'I won\'t let you take us down that dark path again, young Hellscream. I\'ll kill you myself before that day comes...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24517,'%s returns to his post.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24518,'How have you managed to survive for so long, Saurfang? Not fallen victim to your own memories?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24519,'I don\'t eat pork...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24520,'%s spits.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24521,'Aye, solja! Lift off time!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24522,'Yes sir!','Yes sir!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24523,'Horde bonfire.','Horde bonfire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24524,'You\'ve reached a Horde bonfire! Desecrate this bonfire and stamp it out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24525,'Cel\'s got what you need, friend.','',397,0,0,0,0,0,0,0,1,0,0,0,26124),
(24526,'Stamp out the Horde bonfire!','Stamp out the Horde bonfire!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24527,'Alliance bonfire.','Alliance bonfire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24528,'The Midsummer Fire Festival has something for everyone to enjoy!','The Midsummer Fire Festival has something for everyone to enjoy!',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(24529,'You\'ve reached an Alliance bonfire! Desecrate this bonfire and stamp it out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24530,'Stamp out the Alliance bonfire!','Stamp out the Alliance bonfire!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24531,'The Horde have tried to steal our flames.  I hope we return the favor.','The Horde have tried to steal our flames.  I hope we return the favor.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24532,'The Alliance fires burn strong and true!','The Alliance fires burn strong and true!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24533,'I\'d like to see the Alliance try to steal our flame.','I\'d like to see the Alliance try to steal our flame.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24534,'The Horde fires will never be extinguished!','The Horde fires will never be extinguished!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24535,'Midsummer Fire Festival is a great time to celebrate the summer!','Midsummer Fire Festival is a great time to celebrate the summer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24536,'I love the firework show at the end of Midsummer Firefestival.','I love the firework show at the end of Midsummer Firefestival.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24537,'Fear has always been our greatest weapon. Entire wars have been won and lost upon the shifting shoulders of trepidation and doubt. So how, then, does one fight an enemy that knows no fear?$B$B<Saurfang shakes his head.>$B$BWe do not just fight the Scourge in Northrend, we fight to gain control of our senses before they tear us apart...\n','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(24538,'We need to get this outpost ready for the push into Sholazar Basin.$B$BDon\'t just stand there, $c. Go out and represent the Horde with honor and spilled blood!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(24540,'','I have to clean up this mess, but I\'ll do it without complaint.$B$BYou\'ll help if you have any Horde pride at all!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24541,'It\'s... too late for me....','It\'s... too late for me....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24542,'Avenge me....','Avenge me....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24543,'Avenge me....','Avenge me....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24544,'Thank you, $r. I shall not forget your kindness.','Thank you, $r. I shall not forget your kindness.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24545,'You\'ve saved me, $c. Thank you!','You\'ve saved me, $c. Thank you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24546,'Thank you, $r. Without your help I would have become one of them!','Thank you, $r. Without your help I would have become one of them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24547,'','The spirits speak all around us. Are you listening, $r?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(24548,'%s takes a deep breath.','%s takes a deep breath.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24549,'Here lies the corpse of one of the Steeljaw\'s caravan guards.','Here lies the corpse of one of the Steeljaw\'s caravan guards.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24550,'Here lies the corpse of one of the Steeljaw\'s caravan workers.','Here lies the corpse of one of the Steeljaw\'s caravan workers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24551,'The Twilight Cult seeks to undo everything we fight to preserve. It is our sworn duty to prevent this calamity from coming to pass, $r.','The Twilight Cult seeks to undo everything we fight to preserve. It is our sworn duty to prevent this calamity from coming to pass, $r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24552,'Lords, be on your guard! The Horde plan to breach our defenses and stop the ceremony!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24553,'What was your commander thinking? Taking your caravan through our sacred burial grounds!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24554,'Your Steeljaw is now haunting this place... I can feel it.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24555,'Do what you must to quell the restless spirits, Ragefist.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24556,'It is worth all of our lives to eliminate the spirit of your fallen commander.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24557,'The spirits of the taunka will not rest until Steeljaw is dealt with.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24558,'This is not a good start to relations between my people and your Horde.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24559,'When we move, we\'ll move fast. Be prepared to put to rest anything that gets in our way.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24560,'Your overlord promised me help. Where is this important person he intends to send?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24561,'$n is going to join us on our assault. Let us bring peace to my ancestors!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24562,'WE STRIKE!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24563,'An ambush. Return them to their rest!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24564,'Regain your strength. The place where Steeljaw was felled is just ahead.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24565,'There\'s the dog\'s banner and there\'s his corpse. What\'s that? He\'s upon us!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24566,'You fought well. Now go north to your orc outpost and inform Overlord Bor\'gorok of our success!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24567,'Free my soul if you can, cur!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24575,'I\'m freed! Thank you.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24579,'I am dishonored. I should have died with the farseer at Magmoth.$B$BLeave me to my thoughts.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24580,'The element of air here is restless. Beware... they will not let you pass unharmed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24581,'Yes, yes, very good...','Yes, yes, very good...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24582,'The Blood Prince should be very pleased with these...','The Blood Prince should be very pleased with these...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24583,'This one looks a little fragile... well, no matter...','This one looks a little fragile... well, no matter...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24584,'Perhaps we shall need more...','Perhaps we shall need more...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24585,'Destroying','Destroying',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24586,'What is the meaning of this?! I have not yet finished my feast!','What is the meaning of this?! I have not yet finished my feast!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24587,'We shall be needing more blood for the master soon...','We shall be needing more blood for the master soon...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24588,'Ah, yes, it is almost time for the master\'s dinner...','Ah, yes, it is almost time for the master\'s dinner...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24589,'Reading','Reading',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24590,'%s armed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24591,'Detonation in 5...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24592,'4...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24593,'3...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24594,'2...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24595,'1...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24596,'Thank you for freeing me! May the tides always favor you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24597,'You have my gratitude, $c. I thought I\'d never be free.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24598,'Do not allow Kaskala to forget what has happened here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24599,'Thank you, $c. May the winds and seas always deliver you safely.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24600,'The people of Kaskala are in your debt, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24601,'May the ancestors always aid you, $c, as you have aided me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24602,'Honor my ancestors.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24603,'The burial site must be restored.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24604,'I die before my task is complete.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24605,'I go to join my ancestors here.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24606,'Nothing shall stop us!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24607,'To the grave with you!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24608,'The defilement of this sacred resting place comes to an end now!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24609,'I am a Proudhoof, I will not fail!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24610,'This is what happens when southerners come to our lands.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24611,'I will not stop until this place is once again at peace.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24612,'It pains me to see my ancestors disturbed from their graves.$B$BWe must strike down the cursed spirit of your Force-Commander Steeljaw, the one who foolishly led his caravan through these sacred grounds.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24613,'You do your people great honor, $r. Thank you again for helping me deal with Steeljaw\'s spirit.$B$BDespite this grievous misunderstanding, I\'m sure in time our peoples will come to be friends.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(24614,'My axe is yours, hero! Together we will destroy these insects!','My axe is yours, hero! Together we will destroy these insects!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24615,'I must return to Warsong Hold. Battle hard, hero!','I must return to Warsong Hold. Battle hard, hero!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24616,'I must return to Warsong Hold, hero. May you swim in the blood of our enemies and feast upon their sorrow!','I must return to Warsong Hold, hero. May you swim in the blood of our enemies and feast upon their sorrow!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24617,'Farewell, friend. I must return to Warsong Hold.','Farewell, friend. I must return to Warsong Hold.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24618,'Until we meet again, hero. Duty calls!','Until we meet again, hero. Duty calls!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24619,'Who disturbs my meditation?!','Who disturbs my meditation?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24620,'Spirits watch over you, friend. I must make my return to Warsong Hold.','Spirits watch over you, friend. I must make my return to Warsong Hold.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24621,'Ancestors be with you, hero. Farewell!','Ancestors be with you, hero. Farewell!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24622,'Rescued! You have my thanks and my aid, friend.','Rescued! You have my thanks and my aid, friend.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24623,'We will battle together to rid this quarry of the Scourge!','We will battle together to rid this quarry of the Scourge!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24624,'By the fury of the Sunwell, I am released!','By the fury of the Sunwell, I am released!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24625,'Vengeance shall be mine! For Quel\'thalas! For the sin\'dorei!','Vengeance shall be mine! For Quel\'thalas! For the sin\'dorei!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24626,'Huh? Where me at? Dis don\'t look good! Me run now!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24627,'HOORAY! ME FREE!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24628,'Tanks, buddy!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24629,'Mister Mortuus gonna be so mad! Me go home now.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24630,'Why it keep telling me to put da lotion in da basket? Me no like da lotion!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24631,'Look at \'em, Ug. You know what those are?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24632,'No, popo. They look kind of like the pigs. Are they pigs?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24633,'Those...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24634,'Those are cowards.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24635,'Are they cowardly pigs, popo?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24636,'%s shakes his head.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24637,'No, blood of my blood, they are soldiers of the Alliance. Our sworn enemies.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24638,'But popo, what are they afraid of? Why are they here?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24639,'They are here because they do not wish to defend their homes... their families...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24640,'They have given up and surrendered - willingly - to us.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24641,'Ug\'thor, they are afraid to die.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24642,'%s scratches his head.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24643,'I... I don\'t understand, popo.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24644,'%s puffs out his chest and stands on his tip-toes.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24645,'Lok\'tar ogar, popo!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24646,'%s laughs.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24647,'That\'s right, Ug. Victory or death!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24648,'[In Broken Common] Hear boy, cowards? Boy die! Boy die for freedom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24649,'Kaganishu!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24650,'Etu Magmothregar, cha!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24651,'Grr... na su ka Magmoth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24652,'Kada nu batteka, oht!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24653,'Captain... Nerub\'ar flyers! Hundreds of \'em! Coming... Coming from the south! Over our defenses!','Captain... Nerub\'ar flyers! Hundreds of \'em! Coming... Coming from the south! Over our defenses!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24654,'There! There!','There! There!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24655,'Settle down, soldier!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24656,'We\'ll be ready for \'em... You did a good job in warning us.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24657,'Marksmen! Front and center! Scourge attack incoming!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24658,'KAGANISHU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24659,'Marksmen, lock and load!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24660,'The Nerub\'ar have been punished for their transgression!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24661,'Only you can save me from Kaganishu, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24662,'Defend the inner sanctum at all costs!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24663,'Leave no survivors! Let Arthas sort \'em out...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24664,'For Hellscream! For the Horde!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24665,'Yes... Let the rage consume you!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24666,'STOP!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24667,'Tell Imperean that I will consider a cessation of hostilities. But first, Churn must stop his watery intrusions upon my rise!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24668,'I grow bored with you. Begone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24669,'WAIT... NO MORE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24670,'I... submit. As long as Simmer agrees to stop boiling my pool, I agree to an armistice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24671,'Now, remove yourself from my presence. You would be wise not to come within sight of me again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24672,'I will take great pleasure in tearing the forces of the Horde apart... limb from limb and piece by piece...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24673,'Let the forces of the Lich King gaze upon the carcass of this wretch and know that the Horde will not relent!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24674,'Gather, soldiers! Gather and take your trophies from the carapace of the enemy!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24675,'Who dares?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24676,'I will turn your bones to ash!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24677,'You will be consumed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24678,'There is no escape from my rise!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24679,'I will crush you under the weight of my waves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24680,'You dare come into my pool?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24681,'Your death will not be pleasant!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24682,'Your corpse will feed my fish.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24683,'','Oh no... they\'ve shackled his spirit!',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(24684,'We\'ve lost a good many of our wind riders on scouting missions to the west. The Scourge is ruthless in their assault against any would-be spies.$B$BFortunately, I\'ve come up with a solution that only risks the life of the rider. It\'s seen a 30% survival rate to those being ferried across the Plains of Nasam. That\'s a 30% improvement over when we were using wind riders!','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(24685,'Send me to Garrosh\'s Landing, Yanni.','Send me to Garrosh\'s Landing, Yanni.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24686,'','Farseer! I\'m so glad to see you again!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24687,'I have been returned to the living.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24688,'And now, I must rest. Thank you for all that you have done.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24689,'No hurt the lifegiver!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24690,'No touch spores!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24691,'Protect lifegiver!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24692,'$C, I have something to ask of you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24693,'I am dishonored. I should have died with the farseer at Magmoth.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24694,'%s can now be captured.','',0,0,0,0,0,0,0,0,1,6835,0,0,26124),
(24695,'Protect the lifegiver!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24696,'I feel... different.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24697,'Farseer, it is good to see that you still live.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24698,'%s smiles and sits down for a well-deserved rest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24699,'Farseer, you live!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24700,'','I look forward to further training when you are ready.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24701,'What am I supposed to do without tools, Gorge!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24702,'Can\'t fix somethin\' as complicated as a tank without the proper equipment, buddy!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24703,'Have you heard anything from Warsong? We gonna be gettin\' some supplies soon?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24704,'I wanna go home... Take off this uniform and leave the Horde!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24705,'You peons work harder or I will come over there and beat you!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24706,'This outpost is not ready! What would happen if Malygos and the blue dragonflight decided to strike?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24707,'Work faster! We must push into Sholazar Basin before the Alliance!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24708,'You peons are falling behind. Half rations until you pick up the pace!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24709,'This is the most pathetic bunch of peons I\'ve ever seen! Where\'s my booterang?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24710,'I swear that if you do not work faster I\'m going to feed you to my worg!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24711,'Have you grunts no pride? You will have this outpost ready for the reinforcements from Warsong Hold or your worthless corpses will fill the graveyard!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24712,'Time for a five-minute break. Haha, just kidding! What do you think this is, the Alliance?!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24713,'Both Garrosh\'s Landing and Pal\'ea were wiped out by the mist. We\'re the only ones crazy enough to stay here, buddy!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(24714,'','How am I supposed to get anything done with Fizzcrank breathing down my neck and me without all of my stuff?!',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(24715,'','Here we go, bunky. One Crafty\'s Ultra-Advanced Proto-Typical Shortening Blaster at your service!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24716,'What you see here on this coast is not a result of the Scourge. In fact, we believe that the Scourge also fear the mist - which might be why they do not come here.$B$BYou see, the mist is alive, friend. Inside those airy tendrils lies death...$B$BShould you step within its grasp, you will vanish. The mist will take you!$B$BWe have never seen anyone return alive from the mist.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(24717,'Burn, land dweller! BURN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24718,'The subjugation of these people has only just begun... so much time for fun and games.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24719,'Become ashes in the mist!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24720,'Since landing here I have seen horrors that had previously only haunted my darkest nightmares, but nothing could have prepared me for what lies beyond the mist.$B$B<Mootoo nods.>$B$BThrough that fog, not more than a few yards from us, stand the bloodthirsty creatures known as Kvaldir. None have returned from the fog and few that were originally at the landing when the mist rolled in have escaped. The area has since been condemned by Hellscream. Enter at your own risk...','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(24721,'','I... Are you...$B$B<Mootoo shivers.>$B$BAre you here to save me?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(24722,'The Serpent\'s Maw is engulfed in tuskarr fire!','',0,0,0,0,0,0,0,0,1,6843,0,0,26124),
(24723,'The Kur Drakkar is engulfed in tuskarr fire!','',0,0,0,0,0,0,0,0,1,6843,0,0,26124),
(24724,'Bor\'s Hammer is engulfed in tuskarr fire!','',0,0,0,0,0,0,0,0,1,6843,0,0,26124),
(24725,'Bor\'s Anvil is engulfed in tuskarr fire!','',0,0,0,0,0,0,0,0,1,6843,0,0,26124),
(24726,'You think to take my primal essence? Come, let us see if you are hard as stone and ice!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24727,'Frozen and destroyed. This is all your fleshy corpse is good for.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24728,'You are not welcome here. Die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24729,'Your presence unbalances the land. You must be removed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24730,'I wish to purchase torches.','I wish to purchase torches.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24731,'Stand back!  This is real fire I\'m handling here, and it can really burn you!','',70,0,0,0,0,0,0,0,1,0,0,0,26124),
(24732,'Freezing mist engulfs the jetty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24733,'Take their clothing.','Take their clothing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24734,'The Helmsman comes for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24735,'Pathetic fool! A servant of Malygos would sooner die than aid an enemy....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24736,'Aargh! Do your worst, $c! I\'ll tell you NOTHING!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24737,'Aahhhh! Release me! I am of no use to you. I swear it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24738,'Stop! I beg you, please stop. Please....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24739,'Alright! I am beaten. Your precious archmage is held in a prison, elevated and sealed. Even if you manage to reach her, Salrand herself holds the key. Your mission is folly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24740,'Enough! I\'ve told you all that I know. Your continued abuse is senseless!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24741,'Yes! Smash the pitiful naga statue.','Yes! Smash the pitiful naga statue.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24742,'Death to Azshara and her lies!','Death to Azshara and her lies!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24743,'We have slain the sea-witches and our god shall slay their queen!','We have slain the sea-witches and our god shall slay their queen!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24744,'You lads know the drill.  No alcohol to servicemen on duty.  You want the general to kill me himself?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24745,'All right, all right... but you didn\'t get these from me!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24746,'','Thank you for doing this, $r. I... I think I know how to get back to my father. Please don\'t let the bad things hurt me.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24747,'','I can feel my father\'s aura. He\'s definitely this way... come on, $n.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24748,'','I see a break in the mist up ahead. We\'re getting closer!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24749,'','FATHER! Father, I\'m saved!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24750,'','%s hugs Elder Mootoo.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24751,'Daughter! You have returned!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24752,'','Alrighty then, $n, here we go: one illusory-enhanced, Warsong orc disguise, complete with Smell-A-Vision!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24753,'Mootoo thanks you, $n.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24754,'I will not be denied! This world shall fall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24755,'Noooo! This torture is inhumane! You have what you want... why don\'t you just kill me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24756,'I\'ve given you the information, $r! You\'re wasting your time....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24757,'','The mist is death... senseless, without compassion.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24758,'What\'s the matter, $c?  Think you\'re too good to stand in line with the rest of us?','What\'s the matter, $c?  Think you\'re too good to stand in line with the rest of us?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24759,'Crafty, I lost my Warsong orc disguise.','Crafty, I lost my Warsong orc disguise.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24760,'Crafty, I need another Warsong banner.','Crafty, I need another Warsong banner.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24761,'Hey, guys!  Wait up!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24762,'You\'re a sight for sore eyes! I\'m too weak to break the links on this rusty ball and chain.$B$BWell, don\'t just stand there! Get me loose!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(24763,'Um, hello? Is there anyone out there?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24764,'Hey, you! Yes, you! I can hear you! Get over here and get me outa here!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24765,'I\'m beginning to think that they all forgot about me!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24766,'A gnome tries to make some friends, and then BAMM... the next thing you know, he\'s in shackles!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24767,'I\'m right here. I know you can hear me. Ya think you could let me out of these chains?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24768,'I\'ll make you a deal: if you get me out of here alive, you\'ll get a reward larger than you can imagine!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24769,'Hey! Over here in Magmothregar\'s pit!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24770,'What? You think I want to be Magmothregar\'s next appetizer? Get me outa here!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24771,'I\'ve got my hands full here at the moment, $c.$B$BWhat can I do for you?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24772,'Right then, no time to waste. Let\'s get outa here!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24773,'Here we go.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24774,'Ah, fresh air! I can get myself back to the airstrip from here. Be sure to tell Fizzcrank I\'m back and safe. Thanks so much, $n!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24775,'The airstrip at last! Thank you, I can make my way from here. Be sure to tell Fizzcrank I\'m back and safe!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24776,'I think it\'s up this way to the left.  Let\'s go!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24777,'Filthy creature!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24778,'I came here to talk, but you mindless things tried to kill me instead!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24779,'You won\'t put me in chains again!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24780,'I AM NOT AN APPETIZER!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24781,'The only good vermen is a dead vermen!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24782,'Enough fighting! Let\'s finish this and get outa here!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24783,'Hey! I\'m walking here!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24784,'I can\'t believe my own people forgot about me. Die!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24785,'Oh, sweet airstrip, I shall never see your wee runway again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24786,'%s feasts on the helpless kodo.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24787,'Give the word, general.  I will have two regiments at your disposal in a month\'s time.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24788,'Very well, general.  Should you change your mind, my people will be more than willing to provide military assistance.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24789,'Our troops, general, consist mostly of villagers and peasants.  Good men, but not quite rid of the prejudices and superstitions of their upbringing.  They\'re not ready to fight alongside our more exotic allies.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24790,'Your offer will be carefully considered, harbinger.  In the meantime we will make use of your delegation in an advisory role.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24791,'The Scourge has us surrounded. We can hold the village for awhile, but if we can\'t defeat them, they will overrun us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24792,'The choice is clear. We must attack. I know the odds are against us, but Taunka do not go quietly to the slaughter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24793,'I\'ll die with my axes in my hands and drenched in the blood of our foes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24794,'','These cages are bled dry. Get me more prisoners at once!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(24795,'','These prisons are to be filled at once or Malygos will know why!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(24796,'','Bring me more prisoners! Do not rest until Azeroth has been cleansed of its reckless magic-users!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(24797,'','Fill these prisons with mages! Malygos demands it!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(24798,'I won\'t sacrifice my warriors for romantic notions of glorious death on the battlefield. What use is fighting for survival if no one survives?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24799,'There will be a time for battle, Durm. But first, we must find a way to even the odds. What would you have me do, Aeire?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24800,'','The ancestors knew a way to confound an enemy\'s senses. We could use this knowledge to discover the Scourge\'s weakness or strike at their commanders. Without their leaders, the Scourge would fall before our warriors.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24801,'A dishonorable scheme.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24802,'What is your honor worth, Durm? Your life? Mine? The life of blind old Greatfather Mahan, who raised you from childhood?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24803,'Honor is meaningless to a dead man. A warrior may throw himself into battle for honor\'s sake, but a chieftain is responsible for far more. We will follow Sage Aeire\'s plan and continue to defend our village.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24804,'','Speak slowly, child, I am new to your strange tongue.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(24805,'','Please, keep your voice down, $r. Hamat is old and needs her rest.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24807,'The time has come to act. We must decide how to deal with the Scourge before it consumes us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24808,'The expendable have perished. So be it! Now I shall succeed where Sargeras could not! I will bleed this wretched world and secure my place as the true master of the Burning Legion! The end has come! Let the unravelling of this world commence!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24809,'Your souls belong to the Scourge now, mortals.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24810,'Aeire, $n has brought your hides. Please, take them before they make me ill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24811,'','I\'ll take those. We can\'t have the mighty chieftain cowering in fear of a few hides.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24812,'','What is the meaning of this disturbance?!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(24813,'','Back to work! I\'ve dealt with our little distraction.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(24814,'More bodies for the master...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24815,'Unlocking','Unlocking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24816,'','I\'ve destroyed the key! Your cherished archmage belongs to Malygos!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(24817,'Treacherous creatures! By Nazjatar\'s depths, Lady Azshara will avenge me!','Treacherous creatures! By Nazjatar\'s depths, Lady Azshara will avenge me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24818,'I go to be with the spirits of my ancestors...','I go to be with the spirits of my ancestors...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24819,'You may have survived for our amusement, but now, you shall die at our hands!','You may have survived for our amusement, but now, you shall die at our hands!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24820,'','Who dares interrupt my work!? Show yourself, coward!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(24821,'','Who dare interrupt my work!? Show yourself, coward!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(24822,'I will channel my powers into the orbs! Be ready!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24823,'Send in the next pair of prisoners, let them fight to see who lives!','Send in the next pair of prisoners, let them fight to see who lives!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24824,'I have channeled all I can! The power is in your hands!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24825,'Do not harbor false hope! You cannot win!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24827,'Somebody please... Help...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24828,'Don\'t let them turn me into one of those aberrations!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24829,'Kill me... Kill me now!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24830,'Should I ever escape this prison...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24831,'Thank you, friend.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24832,'Freedom at last! I must return to Warsong Hold at once!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24833,'You have my thanks, stranger.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24834,'I am forever indebted to you, friend.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24835,'I require more bodies! Bring them to me at once!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24836,'I will reanimate them all as servants of the Lich King! Bring them here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24837,'Bring the Flenser the fallen Horde! They will be reanimated as soldiers of the Lich King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24838,'Excellent...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24839,'Yes... Report to the Plains of Nasam, my children...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24840,'A child has found a new toy! Crewman, take this infant\'s toy away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24841,'Crewman, show this ant the might of the Kvaldir!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24842,'Crewman, tear this land walker apart!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24843,'Aye, captain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24844,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24845,'Now you face Orabus, fool!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24846,'I shall draw your soul into the mist!','I shall draw your soul into the mist!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24847,'YAAARRRGH!','YAAARRRGH!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24848,'Be consumed by the mist!','Be consumed by the mist!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24849,'Look what\'s lost its way...','Look what\'s lost its way...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24850,'I will heave your carcass into the ocean myself!','I will heave your carcass into the ocean myself!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24851,'You\'re not even fit to be fed to Leviroth.','You\'re not even fit to be fed to Leviroth.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24852,'You\'ve strayed too far from your comfortable soil, $r.','You\'ve strayed too far from your comfortable soil, $r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24853,'The Lich King shall consume all...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24854,'There is no escape...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24855,'Death will be only the beginning of your torture.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24856,'May the light bless you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24857,'Your wounds are severe, but you will live.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24858,'Rest now, you have fought well today.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24859,'It\'s alive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24860,'Purl one, knit one. Purl one, knit one....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24861,'What a lovely abomination you\'re going to be.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24862,'Not to worry, my pretties, we\'ll soon be flying high again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24863,'I need more parts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24864,'How can I be expected to work under these conditions?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24865,'Spare the cleaver, spoil the patient.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24866,'I\'m going to need more parts soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24867,'Clear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24868,'Live, damn you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24869,'It\'s no good... you need more work first.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24870,'The doctor is in!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24871,'Fresh meat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24872,'Ah, good... more parts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24873,'I recommend evisceration!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24874,'Die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24875,'You cannot stop us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24876,'Filthy breather!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24877,'These repairs are behind schedule!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24878,'This will be completed if I have to destroy all of you to get it done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24879,'If the Lich King finds out that we crashed Talramas due to a malfunction, we\'ll all be reduced to ashes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24880,'Faster! We must be flying by the end of the day or the Lich King will destroy us for certain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24881,'Here\'s your kodo, Torp!','Here\'s your kodo, Torp!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24882,'Door-to-door kodo delivery!','Door-to-door kodo delivery!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24883,'YES! It worked!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24884,'Great job!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24885,'%s is cured!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24886,'Mages! Take wing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24887,'The way is cleared! Open the prison!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24888,'','Okay, $n, here we go. Cross your fingers, toes, eyes and whatever else you can cross!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24889,'','Oh no, it didn\'t work! Somehow I feel... lighter.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24890,'For Dalaran! Attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24891,'The Alliance Flag is now placed at its base.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24892,'The Horde Flag is now placed at its base.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24893,'Ahune, your strength grows no more!','Ahune, your strength grows no more!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24894,'Your frozen reign will not come to pass!','Your frozen reign will not come to pass!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24895,'The Ice Stone has melted!','The Ice Stone has melted!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24896,'Tell me what\'s going on out here, Fizzcrank.','Tell me what\'s going on out here, Fizzcrank.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24897,'Tell me your story again, Fizzcrank.','Tell me your story again, Fizzcrank.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24898,'Fine then, have a seat. This might take a while.$B$BWhen we first came to this frozen hell, General Arlos, down in Valiance Keep, gave my group of flying daredevils and me a special task: to establish a forward airbase for Alliance operations.$B$BThis airstrip is the result. Let me tell you, it wasn\'t easy, what with all the nasty beasts and the ground rock-hard from being frozen! But we managed, and we did it quickly too!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24899,'Go on.','Go on.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24900,'Anyway, we needed to pump up lots of sand and oil for the machinery. The nearby pools proved to be perfect for that.$B$BSome of the sand even proved to have magical properties... can you say possibilities!? But that\'s a different tale.$B$BSo, we drained most of the water out and built the pumping station smack dab in the middle. Everything was going swimmingly until one day the main suction pipe got clogged.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24901,'Wait, back up. What was that last thing you said?','Wait, back up. What was that last thing you said?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24902,'Mind you, this part I learned later because I wasn\'t out there at the time.$B$BWhen they ratcheted up the suction on the pump, up came pieces of a robot that looked like a gnome! Of course the fools worked night and day to put it back together without telling us.$B$BThis is when we lost communication with the pumping station.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24903,'After a couple of days of silence, I sent a scouting party out to the platform. They never returned.$B$BI sent another group the next day with the same results, and lost a couple of flying machines out on aerial recon.$B$BAt that point I sent someone south to find help, and we hunkered down to prepare for the worst. We turned all of our attention to making armor, weapons and robots so that we could head out there in full force.$B$BWhen we did a few days ago, we couldn\'t believe our eyes!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24904,'As I was saying, what we saw out there defied explanation.$B$BMy people were nowhere to be found, but in their place was a veritable army of robots and androids going about their business!$B$BThe droids all looked like gnomes and they said that they\'d been expecting us. In fact, in their own strange way, they acted like they knew us. We were surrounded and quickly taken to the top of the pumping station.$B$BThat\'s where we saw their leader and what he was doing to the surviving gnomes!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24905,'He called himself Gearmaster Mechazod. When we arrived he was busy transforming the survivors into mechanical beings!$B$BHe greeted us warmly and explained that he was one of the first gnomes ever to be created by something he called \"The Grand Architect\", a Titan keeper from within the halls of fabled Ulduar.$B$BApparently, he was the blockage that my team had accidentally sucked up from where he\'d malfunctioned thousands of years ago. It was just our luck that we\'d built the pumping station right above him.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24906,'The station\'s mechanics had put him back together, bringing him back to \"life\".$B$BAnd now, by way of thanks, he was going to return the favor by curing all of us of what he called the \"Curse of the Flesh\".$B$BAccording to Mechazod, it\'s a condition that eventually befalls all of the creations of the Titans! In other words, we all supposedly start out as robots of some kind, and, over thousands of years, slowly turn into fleshy beings!$B$BPreposterous, I know.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24907,'It didn\'t look like much of a \"cure\" to me, and I wasn\'t about to stand around listening to some crazy robot while he was butchering my people!$B$BWe did what any sane gnome would do... we ran! Well, actually, most of us parachuted off the side of the platform, but you get the picture.$B$BNot many of us managed to make it back here, and we\'re still spread thin from having to deal with everything else too, like the magnataur to the north and the Scourge to the east. To make things worse, the Horde just setup shop to the northwest!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24908,'And that\'s where we find ourselves now, $n.$B$BWe can\'t possibly deal with all of this by ourselves, and quite frankly, I feel a little out of my depth. Jinky knows what needs to be done. You should go see her now.$B$BI just hope you\'ll be able to get us out of this mess with our bodies intact.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24909,'This is it, $n. The start of the end of the world. And you\'re here to see it off...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24910,'Let\'s go...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24911,'Is this it? Is this all the mighty Horde could muster?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24912,'Pathetic.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24913,'I\'ve never understood your type. The hero...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24914,'Why won\'t you just let go? Why do you fight the inevitable?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24915,'The Lich King cannot be stopped. Accept it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24916,'This world is coming to an end. Let. It. Burn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24917,'Take $g him:her; away and prepare $g him:her; for reanimation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24918,'I\'ll rip your shriveled heart out with my bare hands before any harm comes to $n, necromancer.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24919,'You were never alone, $n.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24920,'This world that you seek to destroy is our home.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24921,'What\'s this now?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24922,'Intruder detected! Must notify defender bots!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24923,'Warning! Danger! Danger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24924,'We will fight you with every fiber of our being - until we are nothing more than dust and debris. We will fight until the end.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24925,'Threat imminent! Beginning evasive action!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24926,'Then you are a fool.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24927,'A fool who is about to end you, necrolord. There will be nothing left of you for the Lich King to reanimate!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24928,'You? A lone orc? Against me and...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24929,'RISE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24930,'The Earthen Ring\'s Assault Begins.','The Earthen Ring\'s Assault Begins.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24931,'Ahune Retreats.  His defenses diminish.','Ahune Retreats.  His defenses diminish.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24932,'Ahune will soon resurface.','Ahune will soon resurface.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24933,'I... I can\'t believe it... Saurfang... I... I am honored... honored to have fought along side you, sir.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24934,'You should return to Warsong Hold now, friend. Hellscream will surely want to hear of what just happened here... of Saurfang...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24935,'%s nods.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24937,'Farewell...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24938,'You\'ll make no mention of me. Either of you!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24939,'Are you going to take me back to Valiance Keep?','Are you going to take me back to Valiance Keep?',1,5,20,0,0,0,0,7,1,0,0,0,26124),
(24940,'I can\'t understand a word that you\'re saying. Just follow me.','I can\'t understand a word that you\'re saying. Just follow me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24941,'Harumph! Alright, off I go!','Harumph! Alright, off I go!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24942,'What? You\'re sending me back there?!','What? You\'re sending me back there?!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24944,'I\'ll blast those gnomish wannabes back to the scrap heap!','I\'ll blast those gnomish wannabes back to the scrap heap!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24945,'Ahh, nothing like a job well done!','Ahh, nothing like a job well done!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24946,'Time to head in for a nice cup of Jinky\'s Magmatically Hot Chocolate!','Time to head in and see if I can\'t get a bit of Mordle\'s Mysterious Mead...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24948,'It was a good day to fly!','It was a good day to fly!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24949,'Now it\'s time to brag about how utterly awesome I am.','I wonder if that cute pilot with the pink hair is still around...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24951,'Sir, I need another flying machine...','Sir, I need another flying machine...',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(24952,'','Mordle get the outgoing on the transmatter fixed now!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24953,'','Do you even know what you\'re doing?!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24954,'','This transmatter\'s the key to our survival. If we don\'t get it fully operational, we\'re goners for sure!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24955,'','If you don\'t get that thing fully operational, we\'re toast for sure!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24956,'Foolish elemental slave! You and your master will pay for your meddling!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24957,'Jinkies, Jinky, I\'m tryin\' the best I know!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24958,'Do I look like a transmatter-tech to you?! At least we have incoming... sort of.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24959,'Look, it\'s not my fault that Tinky took off. This thing\'s her baby... I\'ve just watched her keep it going on spit and glue.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24960,'You\'re being soooooo helpful... NOT!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24961,'Yep, I think I finally have it. Just a twist of this dial, and... oops.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24962,'I wouldn\'t use it just yet, but you feel free to test it out yourself.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24963,'','With the power of the horn, I bind you to its wielder\'s will!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24964,'','So cold...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24965,'','Everyone is dead... Everyone and everything...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24966,'Thank you, $r. I will take this miserable cur from you now.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24967,'I\'m flesh and blood again! Thank you, $c!','I\'m flesh and blood again! Thank you, $c!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24968,'Thank you so much! I thought I\'d never wake up from that nightmare!','Thank you so much! I thought I\'d never wake up from that nightmare!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24969,'Oh no, not the transmatter... it\'ll probably malfunction!','Oh no, not the transmatter... it\'ll probably malfunction!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24970,'But... but... I was perfect!','But... but... I was perfect!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24971,'Where am I? Who are you? What\'s that strange feeling?','Where am I? Who are you? What\'s that strange feeling?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24972,'Mechazod is insane! You have to stop him before it\'s too late!','Mechazod is insane! You have to stop him before it\'s too late!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24973,'It was horrible! They\'ve all been changed!','It was horrible! They\'ve all been changed!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24974,'He called it the Curse of the Flesh. Mechazod is deranged!','He called it the Curse of the Flesh. Mechazod is deranged!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24975,'The actions of these deserters shames us all. A shame so powerful that it must be witnessed to be understood. It is why Ug\'thor is here... The boy must learn.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(24976,'I am embarassed to say it, Nork, but my deserter has gone missing.','I am embarassed to say it, Nork, but my deserter has gone missing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24977,'Try to not lose this one, $n. It is important that we at least try and keep up appearances with the Alliance.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24978,'Warning: $r incursion detected!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24979,'Activate counter-measures. Repel intruder.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24980,'Attention all units, $r inside the perimeter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24981,'You have been detected. You will be assimilated or eliminated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24982,'Gathering','Gathering',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24983,'Sathrovarr drives Kalecgos into a crazed rage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24984,'I survived and I\'m flesh again!','I survived and I\'m flesh again!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24985,'This is the worst contraption anyone ever devised!','This is the worst contraption anyone ever devised!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24986,'I have vital information for Fizzcrank. Out of the way!','I have vital information for Fizzcrank. Out of the way!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24987,'I said, NO transmatter! At least I\'m not a mechagnome anymore.','I said, NO transmatter! At least I\'m not a mechagnome anymore.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24988,'I\'m flesh and blood again. That\'s all that matters!','I\'m flesh and blood again. That\'s all that matters!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24989,'Don\'t go out there. The pools are crawling with robots and mechagnomes!','Don\'t go out there. The pools are crawling with robots and mechagnomes!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24990,'I feel funny. I don\'t think you reintegrated me right....','I feel funny. I don\'t think you reintegrated me right....',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24991,'The commander needs to be told: Mechazod\'s planning an attack! We\'re doomed!','The commander needs to be told: Mechazod\'s planning an attack! We\'re doomed!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(24992,'','How positively awful! You were totally incapacitated? Weak? Hot flashes?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(24993,'There is no time to waste!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24994,'And remember, $n, the bloodspore powder can be used to weaken all magnataur in Gammoth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24995,'','I thank you, friend of Dalaran.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24996,'','We mustn\'t tarry here... stay close - I\'ll take us somewhere safe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24997,'Status: Life-giving substance collection completed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24998,'Feebleminded tinkerer, do you really think your pathetic creation can stop me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(24999,'','Be careful around these parts, $r. The natives are ruthless.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25000,'We are Mechagnome... resistance is futile.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25001,'You are cursed and we are the cure.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25002,'The flesh is weak. We will make you better, stronger... faster.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25003,'We can decurse you, we have the technology.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25004,'The Gearmaster has plans for your weak flesh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25005,'Today, the Borean Tundra. Tomorrow, the world!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25006,'You will be decursed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25007,'Come be perfect with us, $g brother : sister;.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25008,'Maintenance initiated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25009,'Reporting for duty, $g sir : ma\'am;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25010,'I am sworn by tuskarr law to avenge my kin... these murderers burned Pal\'ea to the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25011,'I\'ve treated peasants, nobles, merchants\' sons and beggars.  Allow me to share one piece of wisdom with you - we\'re all the same when staring death in the face.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25012,'Twonky!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25013,'ED-210 online!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25014,'I am the herald of Mechazod. You will be decursed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25015,'Your meddling is at an end. Mechazod will relieve your curse once I am done with you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25016,'I wonder what Nesingwary will give me for your hide!','I wonder what Nesingwary will give me for your hide!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25017,'I\'m sure ol\' Hemet can do something with your bones!','I\'m sure ol\' Hemet can do something with your bones!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25018,'Just fifty more hooves and I\'ll have the new gun!','Just fifty more hooves and I\'ll have the new gun!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25019,'KILL KILL KILL!!!!!!!','KILL KILL KILL!!!!!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25020,'It\'s gonna be veal tonight!','It\'s gonna be veal tonight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25021,'Horns, antlers, hooves, tails, fur, hide, skin, WHATEVER!','Horns, antlers, hooves, tails, fur, hide, skin, WHATEVER!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25022,'Now THIS is a sport!','Now THIS is a sport!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25023,'Give it up, little beast!','Give it up, little beast!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25024,'You were looking for me, child? Why do you come to kill me, $n? I only wish to help.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25025,'Now that I have been reassembled, we can return to a time of perfection... the time of the Titans!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25026,'But, I can see it in your eyes, hear it in your pulse rate. You would destroy me despite my offer of immortality!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25027,'Very well. It saddens me that it has come to this. I look upon all of you as if you were my children. I will slay you if I must!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25028,'Is your cause righteous and your heart true? If so, you are welcome here - among the druids for the ethical and humane treatment of animals. So long as you do not veer down the dark path of depravity and harm the animals that have allowed us to coexist within their world, D.E.H.T.A. will consider you an ally.\n','',1,1,273,0,0,0,0,0,1,0,0,0,26124),
(25029,'It\'s a miracle! The beast skinned itself!','It\'s a miracle! The beast skinned itself!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25030,'Stupid beasts!','Stupid beasts!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25031,'This is the last one that I need for the set of Nesingwary steak knives!','This is the last one that I need for the set of Nesingwary steak knives!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25032,'I\'d like to return to the mainland.','I\'d like to return to the mainland.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25033,'What would you like?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25034,'Jackpot!','Jackpot!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25035,'%s loses consciousness from the brutal beating.','%s loses consciousness from the brutal beating.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25036,'%s regains consciousness.','%s regains consciousness.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25037,'Mother of pearl!','Mother of pearl!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25038,'Clam skin dress shirt here I come!','Clam skin dress shirt here I come!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25039,'The clam has given up the goods!','The clam has given up the goods!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25040,'BAM!','BAM!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25041,'This recon pilot did not survive his squadron\'s crash.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25042,'Search for the pilot\'s insignia.','Search for the pilot\'s insignia.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25043,'Are you crazy? You\'re about to blow us sky high! I\'ll take care of this wreck once everything else is finished.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25044,'Them thar druids be sendin\' children to thar deaths now? The Clam Master obliges, matey!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25045,'Skin ye right up and our customers will never know the difference!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25046,'%s trumpets in approval!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25047,'X-51 Nether-Rocket Mount','X-51 Nether-Rocket Mount',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25048,'Pet Biscuit','Pet Biscuit',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25049,'Goblin Weather Machine - Prototype 01-B','Goblin Weather Machine - Prototype 01-B',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25050,'','Bring forth the imps!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25051,'%s whimpers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25052,'Do you think us fools! You\'re covered in animal blood!','Do you think us fools! You\'re covered in animal blood!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25053,'BUTCHER! DIE!','BUTCHER! DIE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25054,'Calf killer! Murderer! You will pay for this!','Calf killer! Murderer! You will pay for this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25055,'Gathering','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25056,'Truly pathetic. The sin\'dorei were not meant to mix with mongrels such as the draenei.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25057,'We\'ll deal with you soon enough.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25058,'You blood elves should rejoin the flock before it\'s too late.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25059,'Prince Kael\'thas has plans for all of you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25060,'Run, dogs. Tell your naaru masters that the end is nigh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25061,'Your little incursion upon the isle means nothing. Soon you will all be dead!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25062,'The power of the Sunwell will be harnessed once more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25063,'In time, you too shall do our bidding just as the demons serve us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25064,'New directives acquired.  Obey $g magister:magistrix; $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25065,'No deployment target found.  Searching for type: Sanctum.  Location: Sun\'s Reach.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25066,'$g Magister:Magistrix; $n is a great combatant.  $g Magister:Magistrix; $n must make Prince Kael\'thas very proud.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25067,'Protect the Sunwell from Arthas and the Scourge.  Error: Sunwell not found.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25068,'Across the lands our fires burn strong and true!','Across the lands our fires burn strong and true!',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(25069,'Have you danced at the ribbon pole yet?','Have you danced at the ribbon pole yet?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(25070,'I admire the skill that torch jugglers have.','I admire the skill that torch jugglers have.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(25071,'You challenge Kaw, destroyer of mammoths!? Then face me and feel my thunder!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25072,'So, $n, which item are you interested in?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(25073,'Be the first on your block to own the incredible Electrostatic Maculation Blaster!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25074,'Derived from cutting edge Shattered Sun Offensive military technology, it blasts away stubborn stains with ease!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25075,'Wine stains, grass stains, even pet stains are no match for the Electrostatic Maculation Blaster!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25076,'Don\'t wait! Order now and receive my Ultra-Kinetic Waffle Iron at no additional charge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25077,'Ah - oddities and rarities. We specialize in Azeroth\'s more unique items for the discerning adventurer.$B$BSince you\'re speaking with me, you must already have an idea of what you\'re looking for.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25078,'Heroes of Azeroth','Heroes of Azeroth',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25079,'Points Redemption','Points Redemption',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25080,'Through the Dark Portal','Through the Dark Portal',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25081,'Fires of Outland','Fires of Outland',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25082,'March of the Legion','March of the Legion',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25083,'Servants of the Betrayer','Servants of the Betrayer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25084,'What other promotions do you have?','What other promotions do you have?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25085,'Hey, harbinger, how\'s that research coming along? There might be an Ultra-Kinetic Waffle Iron in it for you if you\'re prompt with the results!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25086,'It\'s coming along, Wafflefry. Haven\'t you got a product demonstration to do or something?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25087,'Kaw\'s halberd breaks in two and falls to the ground!','Kaw\'s halberd breaks in two and falls to the ground!',0,0,0,0,0,0,0,0,1,6940,0,0,26124),
(25088,'','Did you know that alchemists can transmute certain gems?  Mar\'nah and I have been talking about this.$B$BI\'m convinced that given her prowess, once her lab is complete, she and I will be able to create gems that were thought to be lost in time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25089,'','We\'ve done it, $n.  Mar\'nah has learned how to transmute very special gems.  And I\'ve learned how to work them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25090,'Our victory in Sun\'s Reach is absolute!  The naaru bless us with their presence!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25091,'Do not be frightened, $r. Our ends are the same.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25092,'Who are you?','Who are you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25093,'I am Kalecgos, of the Blue Dragonflight.$b$bI have watched over the nascent powers of the Sunwell for some time, but now I see that its terrible power could usher in the end of our world!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25094,'What brings you to this place?','What brings you to this place?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25095,'A friend and I have come to rescue a young human woman from the clutches of the Legionlord, Kil\'jaeden and his vile minions.$b$bWe\'ve discovered that Kael\'thas is trying to summon Kil\'jaeden from the depths of the Sunwell itself.$b$bFor the sake of this world - this cannot come to pass! I am committed to seeing that it does not.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25096,'What can we do to assist you?','What can we do to assist you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25097,'Defeating Kael\'thas is a task worthy of your undivided attention. $b$bBeyond that, if you are capable of organizing an army, there are many wrongs in the Sunwell to be addressed.$b$bPerhaps we shall meet again there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25098,'You are not allowed to interfere!','You are not allowed to interfere!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25099,'Our vision will be realized!','Our vision will be realized!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25100,'The elements will crush you!','The elements will crush you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25101,'Welcome, $c. Have you come to honor this flame?$b$bRemember: Our festival fires burn in every land with an Alliance settlement. Make time to honor each of them, if you can.$b$bThe Horde, too, burns fires of their own. You would do well to desecrate such unworthy efforts when you see them.','Welcome, $c. Have you come to honor this flame?$b$bRemember: Our festival fires burn in every land with an Alliance settlement. Make time to honor each of them, if you can.$b$bThe Horde, too, burns fires of their own. You would do well to desecrate such unworthy efforts when you see them.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25102,'You dare challenge Nedar, lord of the tundra!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25103,'Your impetuousness will be your end!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25104,'You don\'t stand a chance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25105,'Behold, the Flames of Summer!','Behold, the Flames of Summer!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(25106,'Careful, don\'t get burned!','Careful, don\'t get burned!',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(25107,'Enjoying the Fire Festival?','Enjoying the Fire Festival?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25108,'Welcome! Have you yet honored this land\'s flame?','Welcome! Have you yet honored this land\'s flame?',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(25109,'','This world has been damaged in ways beyond what our eyes can see.  Even the passage of time feels different somehow.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25110,'','You\'ve done a lot for us.  I am here on an important assignment but if you need passage to the Caverns of Time I\'d be glad to take you there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25111,'Take me to the Caverns of Time.','Take me to the Caverns of Time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25112,'Search the body for the pilot\'s emergency toolkit.','Search the body for the pilot\'s emergency toolkit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25113,'Thirty caribou hooves for a rifle that has a scope?! Sign me up!','Thirty caribou hooves for a rifle that has a scope?! Sign me up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25114,'I don\'t know about you guys, but that clam meat helmet for turning in ten pearls is looking mighty good!','I don\'t know about you guys, but that clam meat helmet for turning in ten pearls is looking mighty good!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25115,'So let me get this straight: I give Lane fifteen mammoth trunks and he gives me a set of daggers that I can use as steak knives? How does he do it? How does he make such amazing deals??','So let me get this straight: I give Lane fifteen mammoth trunks and he gives me a set of daggers that I can use as steak knives? How does he do it? How does he make such amazing deals??',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25116,'No way! Rhino head helmet for the low, low price of thirty rhino heads? I\'ll take two at those prices!','No way! Rhino head helmet for the low, low price of thirty rhino heads? I\'ll take two at those prices!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25117,'Nesingwary is going to go broke if he keeps this up! Lane probably has no idea what he\'s doing!','Nesingwary is going to go broke if he keeps this up! Lane probably has no idea what he\'s doing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25118,'He calls himself the Fur Baron - I call him a sucker! I get a brand new set of winter socks made of rat fur for merely killing and skinning fifty caribou fawns?','He calls himself the Fur Baron - I call him a sucker! I get a brand new set of winter socks made of rat fur for merely killing and skinning fifty caribou fawns?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25119,'Harold Lane is overrun by a stampede!','Harold Lane is overrun by a stampede!',0,0,0,0,0,0,0,0,1,6948,0,0,26124),
(25120,'You seek to deafen me? Pathetic... Wait... What\'s that sound?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25121,'Arena Battlemasters','Arena Battlemasters',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25122,'The Arena battlemasters are in the southeast lower city, along the wall.','The Arena battlemasters are in the southeast lower city, along the wall.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25123,'','These stones should be the last of them. Our coordination with Neptulon\'s forces will be impeccable.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25124,'','Yess. The Tidehunter will be pleased at this development. The Firelord\'s hold will weaken.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25126,'','And your own preparations? Will the Frost Lord have a path to the portal?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25127,'','Skar\'this has informed us well. We have worked our way into the slave pens and await your cryomancerss.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25128,'','The ritual in Coilfang will bring Ahune through once he is fully prepared, and the resulting clash between Firelord and Frostlord will rend the foundations of this world. Our ultimate goals are in reach at last....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25129,'The flag carriers have become vulnerable to attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25130,'The flag carriers have become increasingly vulnerable to attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25131,'While Nesingwary\'s advances upon the wildlife of Northrend has been halted, it is only a matter of time before he attempts another incursion. You must remain vigilant, $n!$B$BAbove all else, do not give in to whatever temptations may be set before you... The demon will attempt to charm you. When it happens, you must resist!','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(25132,'Fezzix, I think we\'ve solved your little engine problem.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25133,'Keep \'em hot you big dummy!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25134,'Those weapons ain\'t gonna build themselves! Faster!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25135,'You call that a hammer strike? What kind of amateurs am I workin\' with here?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25136,'You keep that garbage up and I\'ll ship you back to your momma in a box with a note strapped to your chest that reads: FAILURE.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25137,'And WHAT are our soldiers supposed to do with that shoddy piece of junk?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25138,'You\'re an embarassment to this entire operation! Pack up your stuff and get out!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25139,'With all these new parts, I can finally turn this hunk o\' junk into a flying machine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25140,'Why won\'t this engine work? What\'s wrong with the power cells we recovered?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25141,'Back to square one, I guess. What\'s it going to take to get this thing off the ground?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25142,'Fezzix, I\'ve tried to tell you all that technical mumbo-jumbo you put your faith in would fail you. Luckily, I think I know an alternative.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25143,'It\'s really going to work this time... right?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25144,'Eat, brother wolf... Gather your strength.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25145,'Tomorrow we battle, brother. Today we feed.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25146,'You make me proud, brother wolf.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25147,'Eat now, brother. Feast, for tomorrow may never come...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25148,'It works, Dorain! Look! It actually works...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25149,'You will not master me, puny $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25150,'Here I goooooooooo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25151,'OUCH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25152,'I give up! So much for goblin ingenuity!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25153,'The Frost Lord has won.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25154,'What\'s this meeting about?','What\'s this meeting about?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25155,'These tools are junk!','These tools are junk!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25156,'How do they expect us to craft with these things!','How do they expect us to craft with these things!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25157,'Are they all there?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25158,'All but one.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25159,'That\'s good enough for me.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25160,'Can I have your attention for a moment!\n','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25161,'Because you\'re talkin\' about what? Talkin\' about the arclight spanner, whining about the smelting requirements of hardened adamantite, cryin\' about some gnome that ripped you off...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25162,'Let\'s talk about somethin\' important.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25163,'Put that Morning Glory dew DOWN! Morning Glory dew is for crafters only.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25164,'Do you think I\'m messin\' with you? I am not messin\' with you. I\'m here from Orgrimmar. I\'m here from Nogg\'s Machine Shop and I\'m here on a mission of mercy.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25165,'Your name\'s Leveny?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25166,'Yea.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25167,'And you call yourself a crafter, you son-of-a-gnome?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25168,'I don\'t have to listen to your guff, mister!','I don\'t have to listen to your guff, mister!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25169,'You certainly don\'t pal, \'cause the good news is YOU\'RE FIRED! The bad news is you\'ve got - you\'ve all got - just one week to regain your jobs, starting tonight. Starting with tonight\'s build.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25170,'Oh... Have I got your attention now? Good, \'cause we\'re adding a little something to this month\'s crafting contest.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25171,'As you all know, first prize is a Turbo-Charged Flying Machine. Anyone want to see second prize?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25172,'Second prize is some fused wiring.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25173,'Third prize is YOU\'RE FIRED! You get the picture?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25174,'You\'re laughin\' now? You got tools! Thrall paid good money for those tools. Get out your blueprints and read them! If you can\'t build siege engines with the tools you\'re given, you can\'t build nothin\', you are nothin\', hit the bricks pal and take the first zeppelin out of here \'cause you are going out!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25175,'The tools are weak!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25176,'The tools are weak? You\'re weak! I\'ve been in this business fifty years.\n','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25177,'Say, what\'s your name?','Say, what\'s your name?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25178,'Gnome lover, that\'s my name! You know why, buddy? \'Cause you rode into this shop on a broken down unicycle and I flew in here on a 5,000 gold piece, top of the line, armored wyvern. THAT\'S my name!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25179,'A-B-C. A-always, B-be, C-crafting. Always be crafting. Always be crafting!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25180,'Cast with string ID on Action...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25181,'Cast with string ID in spell...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25182,'You\'re such a hero, you\'ve got so much gold - why you coming down here and wasting your time on a bunch of losers?','You\'re such a hero, you\'ve got so much gold - why you coming down here and wasting your time on a bunch of losers?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25183,'You see this kodo? DO YOU SEE THIS KODO? This kodo cost more than that toolbox you call a house. You see, pal, that\'s who I am. And you\'re nothin\'.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25184,'Using this orb will create a portal leading to Naxxanar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25185,'Use the orb.','Use the orb.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25186,'These are the new tools. These are the Gadgetzan Power tools. And to you, they\'re gold. And you don\'t get \'em. Because to give them to you is just like throwin\' them into a scrap heap. They\'re for crafters. Crafters only!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25187,'It takes brass ball-bearings to craft siege engines for the Horde. Now get with the program or hit the bricks!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25188,'This orb will create a portal to Upper Naxxanar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25189,'This orb will create a portal that will return you to the Temple City of En\'kilah.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25190,'Anveena, you must awaken! This world needs you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25191,'You must let go! You must become what you were always meant to be! The time is now Anveena!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25192,'Anveena I love you! Focus on my voice! Come back for me now! Only you can cleanse the Sunwell!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25193,'Yes Anveena! Let fate embrace you now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25194,'Goodbye Anveena, my love. Few will remember your name, yet this day you changed the course of destiny. What was once corrupt, is now pure. Heroes, do not let her sacrifice be in vain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25195,'','I serve only the master now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25196,'','But I\'m... lost. I cannot find my way back.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25197,'','Kalec... Kalec?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25198,'','The nightmare is over! The spell is broken! Goodbye Kalec, my love!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25199,'Aggghh! The powers of the Sunwell... turn... against me! What have you done? What have you done???','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25200,'Unit entering energy conservation mode.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25201,'Local proximity threat detected. Exiting energy conservation mode.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25202,'Enemies spotted! Attack while I try to activate a Protector!','Enemies spotted! Attack while I try to activate a Protector!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25203,'Enemy presence detected.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25204,'','Now, $n, let us release their souls and hear what they have to say.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25205,'Thank you for saving us. We accidentally uncovered the pieces of Gearmaster Mechazod and reassembled him.','Thank you for saving us. We accidentally uncovered the pieces of Gearmaster Mechazod and reassembled him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25206,'Unit is now operational and attacking targets.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25207,'In return, he \'de-cursed\' us, saying that we were being \'fixed\' by returning us to the state of being mechanical constructs.','In return, he \'de-cursed\' us, saying that we were being \'fixed\' by returning us to the state of being mechanical constructs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25208,'He claims that all creations of the Titans fall prey to what he calls, \'The Curse of Flesh\'. He says that the original gnomes were once mechagnomes.','He claims that all creations of the Titans fall prey to what he calls, \'The Curse of Flesh\'. He says that the original gnomes were once mechagnomes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25209,'He\'s quite insane! Someone must put a stop to his madness before it\'s too late for everyone!','He\'s quite insane! Someone must put a stop to his madness before it\'s too late for everyone!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25210,'Taking Readings','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25211,'','This is dire news indeed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25212,'','I\'ll be damned if these blasted Scourge are going to drive us away!  Us settlers gave everything up to start new lives in Northrend.$B$BYou\'d better believe we\'re going to fight tooth and nail.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25213,'This shard of ice echoes the deep, cracking rumble of invading glaciers.  Its cold turns your thoughts to a lifeless, endless winter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25214,'Summon Ahune, the Frost Lord.','Summon Ahune, the Frost Lord.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25215,'There is a noise from behind you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25216,'Greetings, $n. I am Durkot Wolfbrother, protector of the pack.','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(25217,'The stone radiates a bitter cold, chilling the air around it and the platform on which it sits. Deep within its facets, a blue light pulses, waiting.','The stone radiates a bitter cold, chilling the air around it and the platform on which it sits. Deep within its facets, a blue light pulses, waiting.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25218,'Lay your hand on the stone.','Lay your hand on the stone.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25219,'The Scourge are everywhere!  This is... a nightmare!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25220,'Come try your luck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25221,'','Hold, friends! There is information to be had before this devil meets his fate!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25222,'Puny lizard! Death is the only answer you\'ll find here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25223,'Bagh! Your magic is weak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25224,'I will crush you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25225,'That was fun, but I still await a true challenge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25226,'','Where is Anveena, demon? What has become of Kalec?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25227,'','You will tell me where they are!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25228,'','Speak! I grow weary of asking! ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25229,'','Malygos, my lord... I did my... best.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25230,'Arthas thinks a few of his undead bugs are going to send us running back to the Eastern Kingdoms... he\'s got another thing coming.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25231,'Dark forces are at work in this land, $n.  Keep your eyes open and your courage strong.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25232,'','The Agamath Gate has been breached!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25233,'','The Rohendor Gate has been shattered! Move forward, champions!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25234,'','The Archonisus Gate is no more! The way to the Sunwell is clear!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25235,'Some of us get to avoid military duty.  A good fisherman\'s always handy... even generals need to eat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25236,'This way, $g sir:ma\'am;.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25237,'What do you know about the Cult of the Damned?','What do you know about the Cult of the Damned?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25238,'%s howls in compliance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25239,'I have reason to believe you\'re involved in cultist activity.','I have reason to believe you\'re involved in cultist activity.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25240,'Just another day workin\' the kitchen.  Sure gets dull after a while.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25241,'My shift\'s almost over.  Can\'t wait to catch some shut-eye, know what I mean?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25242,'How long have you worked for the Cult of the Damned?','How long have you worked for the Cult of the Damned?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25243,'Well...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25244,'I suppose this is it, then?  I won\'t go down quietly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25245,'Finally!  This charade is over... Arthas give me strength!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25246,'You don\'t know who you\'re messing with, $c!  Death beckons!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25247,'I can teleport you to another race\'s zone.','I can teleport you to another race\'s zone.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25248,'Human','Human',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25249,'Orc & Troll','Orc & Troll',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25250,'Dwarf & Gnome','Dwarf & Gnome',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25251,'Night Elf','Night Elf',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25252,'Undead','Undead',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25253,'Tauren','Tauren',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25254,'Blood Elf','Blood Elf',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25255,'Draenei','Draenei',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25256,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25257,'Need gold? Here\'s 5,000 coins worth.','Need gold? Here\'s 5,000 coins worth.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25258,'5,000 Gold','5,000 Gold',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25259,'I can stable your pets and maximize their loyalty.','I can stable your pets and maximize their loyalty.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25260,'Pet Loyalty','Pet Loyalty',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25261,'Madrigosa deserved a far better fate. You did what had to be done, but this battle is far from over!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25262,'Stable','Stable',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25263,'I am forever in your debt. Once we have triumphed over Kil\'jaeden, this entire world will be in your debt as well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25264,'','Arthas was once a human prince.  The army he led into Northrend suffered a horrible fate.$B$BMy brother, Thassarian, was a part of that army.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25265,'I am ready to leave, Durkot.','I am ready to leave, Durkot.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25266,'My fastest wolf is ready to take you to Taunka\'le Village, champion. Let me know when you are ready.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25267,'$g Sir:Ma\'am;, my life for the Horde!','$g Sir:Ma\'am;, my life for the Horde!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25268,'Welcome back, champion.','Welcome back, champion.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25269,'It is an honor to serve along your side, $g sir:ma\'am;.','It is an honor to serve along your side, $g sir:ma\'am;.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25270,'Lok\'tar ogar!','Lok\'tar ogar!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25271,'Throm-Ka, hero!','Throm-Ka, hero!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25272,'With your strength and determination, we cannot fail!','With your strength and determination, we cannot fail!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25273,'There walks a hero!','There walks a hero!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25274,'It\'s $n! Bow your heads!','It\'s $n! Bow your heads!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25275,'%s cheers at you.','%s cheers at you.',0,0,0,0,0,0,0,1,1,6978,0,0,26124),
(25276,'We\'re miners, farmers and craftsmen - not soldiers.  But we\'ll defend our land with our bare fists if we must.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25277,'Sorry, but my services are only of use to hunters.','Sorry, but my services are only of use to hunters.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25278,'Sorry, but my services are only of use to druids.','Sorry, but my services are only of use to druids.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25280,'How may I help you, $c?','How may I help you, $c?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25281,'Training','Training',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25282,'Unlearn Talents','Unlearn Talents',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25283,'is steamed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25284,'I can erase all your talents so that you may choose new ones.$b$bThis becomes more expensive each time you do it.','I can erase all your talents so that you may choose new ones.$b$bThis becomes more expensive each time you do it.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25285,'Confirm Unlearn Talents','Confirm Unlearn Talents',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25286,'Sorry, but my services are only of use to hunters.','Sorry, but my services are only of use to hunters.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25287,'Sorry, but my services are only of use to mages.','Sorry, but my services are only of use to mages.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25288,'Sorry, but my services are only of use to paladins.','Sorry, but my services are only of use to paladins.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25289,'Sorry, but my services are only of use to priests.','Sorry, but my services are only of use to priests.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25290,'Sorry, but my services are only of use to rogues.','Sorry, but my services are only of use to rogues.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25291,'Sorry, but my services are only of use to shamans.','Sorry, but my services are only of use to shamans.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25292,'Sorry, but my services are only of use to warlocks.','Sorry, but my services are only of use to warlocks.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25293,'Sorry, but my services are only of use to warriors.','Sorry, but my services are only of use to warriors.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25294,'Stop!','Stop!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25295,'%s places a hand on the ground.','%s places a hand on the ground.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25296,'What will become of us?','What will become of us?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25297,'Is it really over? Is this the end of the taunka?','Is it really over? Is this the end of the taunka?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25298,'So this is how it ends? A pity...','So this is how it ends? A pity...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25299,'Look out!','Look out!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25300,'Join us.','Join us.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25301,'Death is the only salvation...','Death is the only salvation...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25302,'Don\'t fight it...','Don\'t fight it...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25303,'I was raised on this land... taught to hunt on this very tundra.','I was raised on this land... taught to hunt on this very tundra.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25304,'%s cries.','%s cries.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25305,'I... I don\'t think I can make it...','I... I don\'t think I can make it...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25306,'Give me a moment to catch my breath.','Give me a moment to catch my breath.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25307,'I am ready. Let us continue.','I am ready. Let us continue.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25308,'Can I get you anything?  My selection is a little limited, but that\'s to be expected... all things considered.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25309,'Huh?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25310,'Dying for one\'s country is a soldier\'s duty.  But if calling this war folly is treason, then I\'m a traitor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25311,'%s points northeast.','%s points northeast.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25312,'The smoke in the distance... It is Wartook. He is trying to tell us something...','The smoke in the distance... It is Wartook. He is trying to tell us something...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25313,'No... It cannot be true...','No... It cannot be true...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25314,'Icemist... Not Icemist... NO!!! Come quickly, hero! Follow me!','Icemist... Not Icemist... NO!!! Come quickly, hero! Follow me!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25315,'%s expertly identifies the messages hidden within the smoke signals.','%s expertly identifies the messages hidden within the smoke signals.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25316,'','I\'m very busy right now, $r. Please leave me alone.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25317,'','What happened, $n? Where is the evacuee that I entrusted you with?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(25318,'I regret to inform you that the evacuee I was charged with escorting is no more. Would you please allow me to escort another evacuee? I won\'t fail you again!','I regret to inform you that the evacuee I was charged with escorting is no more. Would you please allow me to escort another evacuee? I won\'t fail you again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25319,'','Hurry, $n! Get the evacuee to Wartook Iceborn in the Dragonblight!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(25320,'','Don\'t let me down again, $n. Make sure this evacuee reaches safety.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25321,'Speak, Lich!  Undeath won\'t save you from what I\'ll put you through!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25322,'Hi $gmanly:womanly:c; $c, $ghow\'s it hangin?:you look pretty.;','Hello $gman:woman; how are you doing?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25323,'Sleep now, young one....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25324,'A wonderful specimen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25325,'Easy now, drakeling.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25326,'Yes, this one should advance my studies nicely....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25327,'New Pet','New Pet',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25328,'What sort of pet would you like?','What sort of pet would you like?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25329,'I can both stable and give new pets.','I can both stable and give new pets.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25330,'Bat','Bat',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25331,'Boar','Boar',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25332,'Carrion Bird','Carrion Bird',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25333,'Cat','Cat',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25334,'Dragonhawk','Dragonhawk',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25335,'Nether Ray','Nether Ray',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25336,'Bird of Prey','Bird of Prey',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25337,'Raptor','Raptor',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25338,'Ravager','Ravager',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25339,'Scorpid','Scorpid',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25340,'Serpent','Serpent',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25341,'Spider','Spider',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25342,'Warp Stalker','Warp Stalker',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25343,'Wind Serpent','Wind Serpent',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25344,'Wolf','Wolf',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25345,'Master... you want... I kill puny priest?  Make painful, yes?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25346,'Yes, weakling... beg Lurid for life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25347,'You worship death, little man?  Death is here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25348,'Arthas save us - we\'re doomed!','Arthas save us - we\'re doomed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25349,'The death knight... he\'s mad!','The death knight... he\'s mad!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25350,'The ziggurat\'s lost!  Flee to the temple!','The ziggurat\'s lost!  Flee to the temple!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25351,'[PH] - talks about the instability the nexus has been causing recently - about Malygos\' efforts to destroy the Kirin Tor and all mortal magic-users... Refers players to Raelorasz for more info about Malygos and the Nexus war.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25352,'Focus your mind, mortal. This is the front line of a war unlike any you\'ve witnessed.$b$bYou\'ll need full command of your faculties if you are to be of any use.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25353,'Please... all our orders come from Naxxanar... me and my men are kept in the dark!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25354,'I beg you, death knight!  Keep your minion away from me!  I\'ll do anything!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25355,'Mercy!  You were once with us!  Do you not remember?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25356,'Wating for dungeon particle effects to implement completion event for Buying Time quest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25357,'My liege, the infiltration and control of the Alliance power structure by our cultists is well underway.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25358,'The power you\'ve bestowed upon me has granted me great mental influence over human minds.  I bear these offerings as proof of my progress.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25359,'Leryssa!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25360,'What have you done to my sister, you motherless elf scum!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25361,'Allow me to take care of the intruders, lord.  I will feed their entrails to the maggots.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25362,'Your progress in this region has been impressive, blood prince.  I am pleased.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25363,'Now this is a surprise, Thassarian.  I hadn\'t heard from Mograine or the other death knights for months.  You\'ve come to rejoin the Scourge, I take it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25364,'Do not fail me, San\'layn.  Return to Icecrown with this fool\'s head or do not bother to return.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25365,'Yes, my lord!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25366,'I would sooner slit my own throat.  You will pay for what you did to your own men, Arthas... for what you did to me!  I swear it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25367,'What is that sound? Have the Twilight summoners arrived?','What is that sound? Have the Twilight summoners arrived?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25368,'NO! It is too soon - Lord Ahune is not yet at full power!','NO! It is too soon - Lord Ahune is not yet at full power!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25369,'I seem to have lost the Augmented Arcane Prison. Did I leave it here with you?','I seem to have lost the Augmented Arcane Prison. Did I leave it here with you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25370,'Here you are, $n.$b$bDo be more careful, won\'t you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25371,'What is the cause of this conflict?','What is the cause of this conflict?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25372,'You will not stop the Frost Lord from entering this world, mortal. The Tidehunter\'s might will crush that of Ragnaros once and for all, leaving your land a frozen paradise!','You will not stop the Frost Lord from entering this world, mortal. The Tidehunter\'s might will crush that of Ragnaros once and for all, leaving your land a frozen paradise!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25373,'When Ahune surfaces, will we be ready?','When Ahune surfaces, will we be ready?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25374,'You must survive Ahune\'s minions while we channel our flames.  Do not approach the Frost Lord until we can wither him.','You must survive Ahune\'s minions while we channel our flames.  Do not approach the Frost Lord until we can wither him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25375,'Strike now!  Strike Ahune\'s frozen core while he is weakened!','Strike now!  Strike Ahune\'s frozen core while he is weakened!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25376,'The frozen deep beckons, $r!  Join us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25377,'The phylactery is not yours to take, $n!  You will pay for your transgression.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25378,'The land is in great upheaval!$B$BThe Dark One rides forth again with his San\'layn, the dragons fight in their great Nexus War, and the vrykul are reawakened.$B$BYour people sail north on your wooden ships to fight them and one another, and we Kalu\'ak are caught in the middle.$B$BAnd now some great evil has been done so that the land explodes with the magical power of the world. We must find a safe haven where we will have a chance to survive.$B$BThese two ambassadors make my head hurt... perhaps you can help my people, $r?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25379,'Boy, what I wouldn\'t give for a bowl of old Salma Saldean\'s Westfall stew right about now.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25380,'Gruel and hardtack are no way to survive.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25381,'Y\'know, it\'s not really Saldean\'s recipe.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25382,'It\'s not Salma Saldean\'s recipe. It\'s my Ma\'s. She asked some passerby to deliver it to Salma right before she and Pa left Westfall with Old Blanchy.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25383,'What?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25384,'I am prepared to face Saragosa!','I am prepared to face Saragosa!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25385,'Yeah? Well, at least the Saldeans didn\'t flee Westfall when things got tough.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25386,'Don\'t look so smug! I know what you\'re thinking, but Tempest Keep was merely a setback. Did you honestly believe I would trust the future to some blind, half-night elf mongrel?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25387,'Oh no, he was merely an instrument, a stepping stone to a much larger plan! It has all led to this... and this time you will not interfere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25388,'Vengeance burns!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25389,'Felomin Ashal! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25390,'I\'ll turn your world... upside... down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25391,'Master, grant me strength.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25392,'Do not get... too comfortable.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25393,'My demise accomplishes nothing! The master will have you! You will drown in your own blood! The world shall burn! Aaaghh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25394,'','It is truly a pleasure to see you again, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25395,'No one insults Ma and Pa! Take it back!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25396,'You heard what I said! Your parents are cowards, and so are you, Furlbrow!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25397,'The Kvaldir are without mercy, $n.  But I cannot abandon sacred Kaskala.  If we don\'t abandon the spirits, the spirits will not abandon us either.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25398,'Kaskala\'s under attack!  We must hold them off until we can escape.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25399,'OK, I take it back! Your Ma and Pa weren\'t cowards!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25400,'Cursed giant-men!  If they want a fight, a fight they\'ll get!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25401,'Glad you decided to see things my way...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25402,'Welcome, $c. Have you come to honor this flame?$b$bRemember: Our festival fires burn in every land with a Horde settlement. Make time to honor each of them, if you can.$b$bThe Alliance, too, burns fires of their own. You would do well to desecrate such unworthy efforts when you see them.','Welcome, $c. Have you come to honor this flame?$b$bRemember: Our festival fires burn in every land with a Horde settlement. Make time to honor each of them, if you can.$b$bThe Alliance, too, burns fires of their own. You would do well to desecrate such unworthy efforts when you see them.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25403,'Mortal heroes - your victory here today was foretold long ago. My brother\'s anguished cry of defeat will echo across the universe - bringing renewed hope to all those who still stand against the Burning Crusade.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25404,'As the Legion\'s final defeat draws ever-nearer, stand proud in the knowledge that you have saved worlds without number from the flame.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25405,'Just as this day marks an ending, so too does it herald a new beginning...\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25406,'Just as this day marks an ending, so too does it herald a new beginning...\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25407,'The creature Entropius, whom you were forced to destroy, was once the noble naaru, M\'uru. In life, M\'uru channeled vast energies of LIGHT and HOPE. For a time, a misguided few sought to steal those energies...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25408,'','Our arrogance was unpardonable. We damned one of the most noble beings of all. We may never atone for this sin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25409,'Then fortunate it is, that I have reclaimed the noble naaru\'s spark from where it fell! Where faith dwells, hope is never lost, young blood elf.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25410,'','Can it be?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25411,'Gaze now, mortals - upon the HEART OF M\'URU! Unblemished. Bathed by the light of Creation - just as it was at the Dawn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25412,'In time, the light and hope held within - will rebirth more than this mere fount of power... Mayhap, they will rebirth the soul of a nation. \n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25413,'','Blessed ancestors! I feel it... so much love... so much grace... there are... no words... impossible to describe...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25414,'Salvation, young one. It waits for us all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25415,'Farewell...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25416,'The ore cart squeaks against the rails as it is released.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25417,'Do not be disheartened. Silvermoon will remain strong through this course of events.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25418,'Untrain Pet','Untrain Pet',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25419,'I can erase all your pet\'s talents so that you may teach it ones.$b$bThis becomes more expensive each time you do it.','I can erase all your pet\'s talents so that you may teach it ones.$b$bThis becomes more expensive each time you do it.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25420,'Confirm Untrain Pet','Confirm Untrain Pet',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25421,'This young tuskarr appears to have been slain in combat rather than drowned.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25422,'<Search corpse for Issliruk\'s Totem.>','<Search corpse for Issliruk\'s Totem.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25423,'You only waste my time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25424,'My hunger knows no bounds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25425,'Yes!! I am a god!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25426,'No... more, I must have more!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25427,'I am invincible!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25428,'Enough distractions!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25429,'I am... invinc--','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25430,'','Annihilate them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25431,'','Not what I had... planned.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25432,'','Oh, the horror!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25433,'','Well aren\'t you lucky?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25434,'','Now I\'m getting annoyed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25435,'','Lackeys be damned! I\'ll finish you myself!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25436,'','I call that a good start.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25437,'','I could have sworn there were more of you...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25438,'','Not really much of a \"group\" anymore, is it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25439,'','One is such a lonely number.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25440,'','It\'s been a kick, really.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25441,'Keristrasa, I am finished here. Please return me to the Transitus Shield.','Keristrasa, I am finished here. Please return me to the Transitus Shield.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25442,'The Festival Talespinner asked me to speak with you.','The Festival Talespinner asked me to speak with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25443,'Then I am glad you came. Now that you know of our fires, and of honoring them... and of the fires of our enemies, and of extinguishing them... you may return to him and be rewarded.','Then I am glad you came. Now that you know of our fires, and of honoring them... and of the fires of our enemies, and of extinguishing them... you may return to him and be rewarded.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25444,'Then I am glad you came. Now that you know of our fires, and of honoring them... and of the fires of our enemies, and of extinguishing them... you may return to him and be rewarded.','Then I am glad you came. Now that you know of our fires, and of honoring them... and of the fires of our enemies, and of extinguishing them... you may return to him and be rewarded.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25445,'The Festival Loremaster asked me to speak with you.','The Festival Loremaster asked me to speak with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25446,'','$n! I\'ve been wondering how you were. What\'s kept you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25447,'','I trust you\'re taking every precaution....$b$bThis is a dangerous place and I couldn\'t forgive myself if something were to happen to you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25448,'','We must hurry, $n. Malygos\' ruinous plans will soon be irreversible.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25449,'','In times such as these, dear friends are invaluable.$b$bBe safe, $n. As safe as one can be in a place like this....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25450,'','If you hadn\'t rescued me from that prison I surely would have succumbed by now.$b$bI have not forgotten....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25451,'Show no mercy!  Kill every last one of the tuskarr!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25452,'','When our duty here is behind us, I shall find a way to repay you for my rescue.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25453,'','My strength is returning, slowly....$b$bI hope to be able to show you the glory of my true form soon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25454,'Fight on, Kvaldir!  We\'ll burn Kaskala to the ground!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25455,'These tuskarr have seen nothing!  Show them what we\'re capable of!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25456,'Kill them!  Kill them all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25457,'','Oh....$b$bWhere am I?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25458,'In a word, magic.$b$bIrresponsible mortals with their brief lifespans think nothing of the lasting effects of their actions.$b$bArcane energies have been tapped too liberally, disrupting the world\'s balance. If this is allowed to continue, Azeroth will soon be annihilated.$b$bOn this, both sides agree. But before a council could even be appointed, Malygos put his own plan into action.$b$bWe had no choice but to confront him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25459,'Who is Malygos?','Who is Malygos?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25460,'We\'re making progress, $r, but far too slowly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25461,'We must succceed! Azeroth\'s fate lies in the balance....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25462,'Malygos the Spellweaver, the Lord of Magic, Master of the Blue Dragonflight. He is the blue dragon aspect, one of the most ancient creatures on Azeroth.$b$bHe is said to be recovering from a madness which has lasted for millennia, but his recent actions lead me to believe that he is still far from sane.$b$bHis solution to our dilemma is to search out and destroy every magic-wielding mortal on Azeroth.$b$bAs the guardians of life, this has forced the red dragonflight to take action.$b$bDragon now fights against dragon, and the fate of our frail world lies in the balance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25463,'','Raelorasz, it is good to see you again.',0,0,0,0,0,0,0,0,1,8043,0,0,26124),
(25464,'Keristrasza! I wish that circumstances allowed for a more fitting welcome. Fate has been kind to return you to us.','',0,0,0,0,0,0,0,0,1,8043,0,0,26124),
(25465,'Fate has been kind to return you to us.','',5,0,0,0,0,0,0,0,1,8043,0,0,26124),
(25466,'','Fate, it seems, has been more than kind. A blow has been dealt to Malygos. When he learns of it, I am confident he will leave the safety of the Nexus.',0,0,0,0,0,0,0,0,1,8043,0,0,26124),
(25467,'Malygos - in the open? I hadn\'t dared hope for an opportunity such as this. I\'ll assemble our brethren at once!','',0,0,0,0,0,0,0,0,1,8043,0,0,26124),
(25468,'Of course, my lady. Until we meet again...','',0,0,0,0,0,0,0,0,1,8043,0,0,26124),
(25469,'','Prepare them well, Raelorasz. Malygos\' power is like nothing they\'ve seen. We will likely only delay his plans with this diversion.',0,0,0,0,0,0,0,0,1,8043,0,0,26124),
(25471,'','%s smiles',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25472,'','Farewell, Raelorasz.',1,0,0,0,0,0,0,0,1,8043,0,0,26124),
(25473,'Patience, $g dearest: dear; $n. The time is not quite right. Fire the flare again soon and we shall begin....','Patience, $g dearest: dear; $n. The time is not quite right. Fire the flare again soon and we shall begin....',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25474,'','Stay close to me, $n. I could not bear for any harm to come to you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25475,'','MALYGOS!!',1,0,0,0,0,0,0,0,1,7567,0,0,26124),
(25476,'','Your precious consort has failed you. You shall be the next to fall!',1,0,0,0,0,0,0,0,1,7567,0,0,26124),
(25477,'','Come, Lord of Magic, and recover your precious consort....',1,0,0,0,0,0,0,0,1,7567,0,0,26124),
(25478,'','...what remains of her!',1,0,0,0,0,0,0,0,1,7567,0,0,26124),
(25479,'','Come, $n. Let us see the fruits of our efforts.',1,0,0,0,0,0,0,0,1,7567,0,0,26124),
(25480,'Saragosa! What has become of you?','',0,0,0,0,0,0,0,0,1,7567,0,0,26124),
(25481,'','Come with me. It is not safe here.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25482,'Intruders! Do not let them into the Sanctum!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25483,'Constructs, defend the capital at all costs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25484,'To battle, my children! Show the enemy no mercy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25485,'Keristrasza! You\'ve bested my consort... and now YOU shall take her place!','',0,0,0,0,0,0,0,0,1,7567,0,0,26124),
(25486,'For the thane! For Loken!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25487,'Crush the children of stone, my iron brethren!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25488,'Enough! You\'ve bested my consort... and now YOU shall take her place!','',0,0,0,0,0,0,0,0,1,7567,0,0,26124),
(25489,'','Never!',1,0,0,0,0,0,0,0,1,7567,0,0,26124),
(25490,'The tyranny of iron is at an end!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25491,'','Hurry, $n! Flee! Live to finish what we\'ve begun here....',1,0,0,0,0,0,0,0,1,7567,0,0,26124),
(25492,'Your masters will never conquer the stone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25493,'Loken will never triumph!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25494,'We do not fear you, child of iron!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25496,'Aggh!! No longer will I be a slave to Malygos! Challenge me and you will be destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25497,'I will purge you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25498,'Your pain has only begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25499,'In the name of Kil\'jaeden!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25500,'You were warned!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25501,'My awakening is complete! You shall all perish!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25502,'Kil\'jaeden must be destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25503,'The fate of the world hangs in the balance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25504,'There will be no reprieve! My work here is nearly finished!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25505,'I\'m never on the... losing... side!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25506,'Your misery is my delight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25507,'I will watch you bleed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25508,'Piteous mortal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25509,'Haven\'t you heard? I always win!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25510,'I have toyed with you long enough!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25511,'','Depravity...hatred...chaos. These are the pillars.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25512,'','Misery...confusion...mistrust. These are the hallmarks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25513,'','Fire to the aid of shadow!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25514,'','Fires consume.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25515,'','Edir harach!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25516,'','Sacrolash!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25517,'','Your luck has run its course!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25518,'','Der\'ek... manul.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25519,'','Shadows engulf.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25520,'','Ee-nok Kryul!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25521,'','Time is a luxury you no longer possess!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25522,'','I... fade.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25523,'','I\'m glad you are here, $c. The military situation in the Sunwell Plateau is rather grim.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(25524,'Give me a situation report, Captain.','Give me a situation report, Captain.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25525,'','The Shattered Sun Offensive has made great progress in the outer areas of the Isle of Quel\'Danas. Kil\'jaeden\'s forces are being pushed back, and in the chaos I was able to lead a small scouting force here inside the Sunwell Plateau. My troops proceeded through Parhelion Plaza, spotted a group of Sunblade blood elves, and we then engaged the enemy. That fight quickly turned into a disaster.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(25526,'What went wrong?','What went wrong?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25527,'','Kil\'jaeden\'s defenders here on the Sunwell Plateau are much stronger than anything we faced outside on the Island. The Legion have even twisted our Arcane Guardian technology with fel energy to create something much more sinister. Just one of those Sunblade Protectors decimated my troops, and I ordered a swift retreat. I expected my squad to be pushed completely off the plateau, but the enemy surprised me by calling off the pursuit.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(25528,'Why did they stop?','Why did they stop?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25529,'','I don\'t know, but I\'m glad they did. The respite has allowed Anchorite Elbadon to save many of the men and women under my command. I\'ve sent a few of my stealthiest scouts forward, and they\'ve reported back something interesting. Nearly all of the Sunblade Protectors are powered down! Kil\'jaeden\'s forces appear to be conserving their energy, and seem content to merely contain us with one active Protector. If you and your companions want to force your way inside, allow me to suggest a plan of attack.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(25530,'Your insight is appreciated.','Your insight is appreciated.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25531,'','Take advantage of their deactivated Sunblade Protectors. If one of their Sunblade Scouts spot you, I\'m sure the elf will try to reactivate a nearby Sunblade Protector. Kill him quickly to prevent this. With the blood elves eliminated, as long as you do not trigger the Protector\'s proximity sensors you should be able to move past them without a fight. That will save you both time and resources.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(25532,'Captain Selana has instructed me to assist you with your efforts here on the Sunwell Plateau.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(25533,'What is the current state of the Sunwell\'s Gates?','What is the current state of the Sunwell\'s Gates?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25534,'Agamath, the First Gate has been breached. Two of Kil\'jaeden\'s most powerful lieutenants, Lady Sacrolash and Grand Warlock Alythess, are now vulnerable to attack.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(25535,'All three barriers are fully operational. Consult with Archmage Ne\'thul in Sun\'s Reach Harbor to aid the effort in unlocking the gates.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(25536,'Agamath, the First Gate and Rohendor, the Second Gate are now destroyed. Only Archonisus, the Third Gate remains.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(25537,'All of the barriers blocking you from reaching the Sunwell have been destroyed. Enter the Sunwell and stop Kil\'jaeden from entering this world!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(25538,'With Kalecgos freed, can you provide a teleport up to Apex Point?','With Kalecgos freed, can you provide a teleport up to Apex Point?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25539,'Now that Lady Sacrolash and Grand Warlock Alythess have been defeated, can you teleport me to the Witch\'s Sanctum.','Now that Lady Sacrolash and Grand Warlock Alythess have been defeated, can you teleport me to the Witch\'s Sanctum.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25540,'We\'ve cleared the way to Kil\'jaeden! Can you transport me close to the Sunwell?','We\'ve cleared the way to Kil\'jaeden! Can you transport me close to the Sunwell?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25541,'You are not alone! The blue dragonflight shall help you vanquish the Deceiver!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25542,'I have empowered another orb! Use it quickly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25543,'Another orb is ready! Make haste!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25544,'All my plans have led to this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25545,'Stay on task, do not waste time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25546,'I have waited long enough!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25547,'Fail me and suffer for eternity!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25548,'Drain the girl! Drain her power until there is nothing but a vacant shell!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25549,'Another step toward destruction!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25550,'Anakh Kyree!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25551,'Who can you trust!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25552,'The enemy is among you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25553,'Chaos!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25554,'Destruction!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25555,'Oblivion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25556,'What\'s that, girl? You\'re hungry already? Don\'t worry, I\'ll get the oats.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25557,'Now, where do they keep those oats?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25558,'Hmm... maybe over there.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25559,'No... no oats here, either.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25560,'What brings you to the Sunwell?','What brings you to the Sunwell?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25561,'A friend and I have come to rescue a young human woman from the clutches of the Legionlord, Kil\'jaeden and his vile minions.$b$bWe\'ve discovered that Kael\'thas is trying to summon Kil\'jaeden from the depths of the Sunwell itself.$b$bFor the sake of this world - this cannot come to pass! I am committed to seeing that it does not.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25562,'You\'re not alone here?','You\'re not alone here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25563,'Madrigosa accompanied me on this journey, but we have become separated in the Sunwell.$b$bMay fate keep her safe.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25564,'What would Kil\'jaeden want with a mortal woman?','What would Kil\'jaeden want with a mortal woman?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25565,'Anveena is no mere mortal, $r. Those who recognize her true nature stop at nothing to possess her.$b$bShe once rescued me, and now I intend to return the favor. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25566,'Enjoying the festival, $c?$b$bWhile the Flame Keepers tend to the fires of the present, I am more of a historian, keeping close the festivals past. I\'m also, of course, documenting this year\'s festivities. Things are going well thus far, don\'t you think?$b$bYou know, $n, there is power inherent in all festival fires burning throughout the holiday. We\'re taking care of ours, but I\'m certain there are sacred flames burning deep within our enemy\'s cities...','Enjoying the festival, $c?$b$bWhile the Flame Keepers tend to the fires of the present, I am more of a historian, keeping close the festivals past. I\'m also, of course, documenting this year\'s festivities. Things are going well thus far, don\'t you think?$b$bYou know, $n, there is power inherent in all festival fires burning throughout the holiday. We\'re taking care of ours, but I\'m certain there are sacred flames burning deep within our enemy\'s cities...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25567,'Welcome to our camp, $c. You\'re free to rest here if you\'d like.','Welcome to our camp, $c. You\'re free to rest here if you\'d like.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25568,'I wish to buy from you.','I wish to buy from you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25569,'There is nothing left for us here.','There is nothing left for us here.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25570,'My family was slaughtered without mercy. Even the young.','My family was slaughtered without mercy. Even the young.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25571,'May the Lich King burn in hellfire for what he has called down upon this land.','May the Lich King burn in hellfire for what he has called down upon this land.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25572,'We are a people without a home to call our own now.','We are a people without a home to call our own now.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25573,'The Scourge are a fearless machine set to bring about the end of all life on this world.','The Scourge are a fearless machine set to bring about the end of all life on this world.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25574,'The one that they call Hellscream might be our only hope.','The one that they call Hellscream might be our only hope.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25575,'Only the Horde can save us now.','Only the Horde can save us now.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25576,'Maybe this is it... the end of days is finally upon us.','Maybe this is it... the end of days is finally upon us.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25577,'My mate was slain while I was made to watch. Only vengeance remains in my heart.','My mate was slain while I was made to watch. Only vengeance remains in my heart.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25578,'If given the chance, we should join the Horde. The Scourge would crumble beneath our collective strength.','If given the chance, we should join the Horde. The Scourge would crumble beneath our collective strength.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25579,'Arthas... I spit on Arthas.','Arthas... I spit on Arthas.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25580,'We were attacked on the road across Transborea by necromancers. What was I to do?','We were attacked on the road across Transborea by necromancers. What was I to do?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25581,'Is it cowardly to run when faced with your own end?','Is it cowardly to run when faced with your own end?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25582,'Without Taunka\'le, life is no longer worth living.','Without Taunka\'le, life is no longer worth living.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25583,'I pray they give me a chance to prove myself.','I pray they give me a chance to prove myself.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25584,'Well whatever happens, we must make a decision as a group.','Well whatever happens, we must make a decision as a group.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25585,'Goodbye, beloved tundra.','Goodbye, beloved tundra.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25586,'Brrrr... It\'s cold up here.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25587,'Buckets! Where\'s my laundry?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25588,'I\'m working on it, Molsen. If you want it done faster, do it yourself.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25589,'','The Horde will protect the Taunka. Be calm, friend.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25590,'No way.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25591,'I\'m a soldier, Buckets. You know, a fighting man... You\'re the laundry boy.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25592,'And not a very good one! Remember what you did to my tabard?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25593,'','I am your tauren sister, taunka. Our blood is the same, and because of this no harm will come to you now. You are safe.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25594,'','Garrosh will soon be sending his most capable soldiers. It is they who will guide you into the open and waiting arms of the Horde.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25595,'','You will soon be behind the impenetrable walls of Agmar\'s Hammer, taunka.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25596,'','Salvation comes to those whose cause is righteous and true. Join us and you will be saved.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25597,'That was entirely your own fault, Molsen. Maybe you\'ll know to separate your colors from now on...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25598,'The tabard was pink when I got it back, Buckets. Pink! Think about that...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25599,'The whole squad laughed at me for a week! Don\'t let it happen again!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25600,'Fine. Have it your way.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25601,'%s cheers at Emissary Brighthoof.','%s cheers at Emissary Brighthoof.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25602,'%s cries tears of happiness.','%s cries tears of happiness.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25603,'%s roars in approval!','%s roars in approval!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25604,'What\'s wrong with you? That was dinner!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25605,'Now it\'s laundry.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25606,'You\'re dead, Buckets! You hear me? Dead!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25607,'%s thanks Emissary Brighthoof.','%s thanks Emissary Brighthoof.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25608,'','Hello sir, I\'m ready to rock!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25609,'','Hey guys, I\'m your biggest fan!  I\'m ready to rock!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25610,'','Check this out guys!  I can rock like you guys!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25611,'','Whoa!  I managed to impress Sig Nicious!  I saw him crack a smile!  I bet I can join them next year!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25612,'','Salandria waves her hands in the air.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25613,'','Salandria begins to play air guitar and sing The Power of the Horde.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25614,'Thank the spirits!  The blizzard will slow down the kvadir ships!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25615,'The spirits have listened!  Can you feel it, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25616,'The skeletal horse appears to look towards the nearby ziggurat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25617,'I need you to take me to the lich\'s phylactery, Dusk.','I need you to take me to the lich\'s phylactery, Dusk.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25618,'%s mutters to himself incomprensibly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25619,'The %s looks around, confused.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25620,'A momentary flash of awareness fades quickly from the eyes of the %s.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25621,'The %s seems lost in the horror of his village\'s cataclysm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25622,'Event heard. Spawn, damn you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25623,'Drain... life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25625,'Un...leash.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25626,'Un...con...tainable.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25627,'Con...sume.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25628,'Ah, more lambs to the slaughter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25629,'Perish, insect!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25630,'You are meat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25631,'Too easy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25632,'Bring the fight to me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25633,'Another day, another glorious battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25634,'I live for this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25635,'So much for a real challenge. Die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25636,'Agghh! Well done! Now this gets... interesting...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25637,'','Glory to Kil\'jaeden! Death to all who oppose!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25638,'','Choke on your final breath!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25639,'','I am stronger than ever before!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25640,'','I kill for the master!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25641,'','The end has come!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25642,'','No more hesitation! Your fates are written!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25643,'','Kil\'jaeden will... prevail!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25644,'<Budd holds very still, pretending not to hear you. Looking closely you see a bit of drool drip from under his mask.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25645,'<Budd rocks back and forth on his haunches, muttering something that sounds like troll speech.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25646,'Go away, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25647,'No time to be talkin\', mon. I be needin\' to rest now....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25648,'No time to be talkin\', mon. I be needin\' to rest now....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25649,'Worry no more, taunka. The Horde will save and protect you and your people, but first you must swear allegiance to the Warchief by taking the blood oath of the Horde.','Worry no more, taunka. The Horde will save and protect you and your people, but first you must swear allegiance to the Warchief by taking the blood oath of the Horde.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25650,'Will the Horde grant me the chance to battle the Scourge?','Will the Horde grant me the chance to battle the Scourge?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(25651,'Yes, taunka. Retribution is a given right of all members of the Horde.','Yes, taunka. Retribution is a given right of all members of the Horde.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25652,'To avenge my people, to drive out the blight that has engulfed our land - I will take your oath. I will pledge all that I have and all that I am to the Horde.','To avenge my people, to drive out the blight that has engulfed our land - I will take your oath. I will pledge all that I have and all that I am to the Horde.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(25653,'Then repeat after me: \"Lok\'tar ogar! Victory or death - it is these words that bind me to the Horde. For they are the most sacred and fundamental of truths to any warrior of the Horde.\n\nI give my flesh and blood freely to the Warchief. I am the instrument of my Warchief\'s desire. I am a weapon of my Warchief\'s command.\n\nFrom this moment until the end of days I live and die - For the Horde!\"\n','Then repeat after me: \"Lok\'tar ogar! Victory or death - it is these words that bind me to the Horde. For they are the most sacred and fundamental of truths to any warrior of the Horde.\n\nI give my flesh and blood freely to the Warchief. I am the instrument of my Warchief\'s desire. I am a weapon of my Warchief\'s command.\n\nFrom this moment until the end of days I live and die - For the Horde!\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25654,'Lok\'tar ogar! Victory or death - it is these words that bind me to the Horde. For they are the most sacred and fundamental of truths to any warrior of the Horde.$B$BI give my flesh and blood freely to the Warchief. I am the instrument of my Warchief\'s desire. I am a weapon of my Warchief\'s command.$B$BFrom this moment until the end of days I live and die - FOR THE HORDE!','Lok\'tar ogar! Victory or death - it is these words that bind me to the Horde. For they are the most sacred and fundamental of truths to any warrior of the Horde.$B$BI give my flesh and blood freely to the Warchief. I am the instrument of my Warchief\'s desire. I am a weapon of my Warchief\'s command.$B$BFrom this moment until the end of days I live and die - FOR THE HORDE!',5,1,66,0,0,0,0,1,1,7241,0,0,26124),
(25655,'For the Horde!\n\nArm yourself from the crates that surround us and report to Agmar\'s Hammer, east of here. Your first trial as a member of the Horde is to survive the journey.\n\nLok\'tar ogar!','For the Horde!\n\nArm yourself from the crates that surround us and report to Agmar\'s Hammer, east of here. Your first trial as a member of the Horde is to survive the journey.\n\nLok\'tar ogar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25656,'Come on, Budd. Time to play with the ice trolls!','Come on, Budd. Time to play with the ice trolls!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25657,'Oooh, Shiney!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25658,'Ey, mon! Take me to mah troll bruddas!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25659,'Time to play some troll tag, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25660,'My troll bruddas be in for some real fun today, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25661,'Hee hee hee! Dis gunna be some fun, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25662,'You sure we be goin\' da right way, mon?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25663,'<sniff, sniff> I can smell \'em, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25664,'Nuttin\' says luvin\' like a little tap on da noggin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25666,'Ok, Budd. Go tag a troll....','Ok, Budd. Go tag a troll....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25667,'Victory or death! For the Horde!','Victory or death! For the Horde!',5,1,66,0,0,0,0,1,1,7241,0,0,26124),
(25668,'You be it now, brudda!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25669,'No, no, mon. Dere be no trolls here....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25670,'Ok, mon. Tell me when we be close to mah troll bruddas.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25671,'All three of the gates at the Sunwell Plateau have been brought down, $n.$B$BYou must marshal your forces and stop Kil\'jaeden from entering Azeroth before all is lost!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25672,'%s reads through the most recent entries in Brann\'s journal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25673,'Astounding! It says here that Brann discovered a mysterious runic plate deep in Thor Modan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25674,'Brann writes that he was working on a guide to these runic symbols when the giants and their allies attacked.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25675,'He reports deciphering part of the writing on the runic plate, but it doesn\'t look like he recorded his translation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25676,'By Magni\'s beard, we\'ve got to reconstruct the runic key he used to read the plate. We could be right on his heels!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25677,'I lost the Flute of the Ancients and require a replacement, Eridan.','I lost the Flute of the Ancients and require a replacement, Eridan.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25678,'Don\'t ya be hurtin\' me, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25679,'Troll powah, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25680,'What be wrong wit you, mon? Ain\'t ya never seen a troll before?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25681,'I be thinkin\' you don\'t know where to find mah bruddas, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25682,'Forget it, mon. I go find me bruddas myself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25683,'I think we be lost, mon....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25684,'The fallen of Pal\'ea will not rest, son.  Find the naga priestess!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25685,'','Riplash will never return to its former glory, but these boat-riding scum will pay for their deeds - I swear it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25686,'\'Shall return to the cradle of iron and stone.\'','\'Shall return to the cradle of iron and stone.\'',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25687,'\'In Loken\'s name, destroy the scions of stone.\'','\'In Loken\'s name, destroy the scions of stone.\'',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25688,'\'Return to Ulduar, nestled in the embrace of the storm.\'','\'Return to Ulduar, nestled in the embrace of the storm.\'',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25689,'\'Sons of iron, heed the call. Hurry hence to Ulduar.\'','\'Sons of iron, heed the call. Hurry hence to Ulduar.\'',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25690,'\'Greatest of the Maker\'s children, arise and claim your birthright.\'','\'Greatest of the Maker\'s children, arise and claim your birthright.\'',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25691,'','It is our duty to protect these taunka and provide them with what little comfort we can offer.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25692,'Emissary, I misplaced the Blood Oath of the Horde. Could you please give me a replacement?','Emissary, I misplaced the Blood Oath of the Horde. Could you please give me a replacement?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25693,'','These infants will live. With love and affection they will grow to be strong members of the Horde, and with time the horrible reminders of their shattered lives will fade.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(25694,'','There, there, sweetheart. Everything is going to be ok.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25695,'','My little angel. Are you hungry? Will you eat for auntie Twinbreeze? Just a little?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25696,'','This one will grow to be a great warrior. Won\'t you, darling?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25697,'','Maybe you will be a shaman like your auntie Twinbreeze?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25698,'%s cries.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25699,'Thank you again, $n, for this delectable incense.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25700,'Wake up, Griselda. Here, girl.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25701,'They\'ll never find us here, will they? We won\'t let them get us like they got Limpy Joe and Flannel McGee!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25702,'No, we escaped from those monsters! They\'re nothing like us, Griselda.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25703,'We\'re hunters, you and I. No wolfmen here, no ma\'am.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25704,'Keep an eye out for them, girl! Don\'t let them get us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25705,'Kil\'jaeden begins to channel dark energy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25706,'Rise weaklings!  Rise and serve the Scourge!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(25707,'You will tell your commander that I will not wait a moment longer! Does he want this alliance or not?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25708,'I have been waiting here for an eternity since our last meeting! When will Goramosh be done with his ritual?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25709,'Casting kill credit on $n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25710,'This is insufferable! I represent a nexus-prince, I am not to be made to wait! Goramosh should be waiting on me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25711,'I was personally assured by Malygos that your commander would make the details of this accord his top priority. Now let me pass!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25712,'If I have to wait much longer, I will be forced to reconsider the proposed accord between the Ethereum and the Blue Dragonflight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25713,'You are nothing but an underling! I will not wait a moment longer! Escort me to Goramosh immediately!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25715,'What\'s this, more delays?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25716,'You\'re too late! The accord has been negotiated. Only the details remain. Small details... like you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25717,'%s devours the incense.  It\'s ravenous!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25718,'So good!  So packed with energy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25719,'It has everything a growing scorchling needs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25720,'%s bellows with laughter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25721,'Now!  Finally!  Our plans can take effect!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25722,'KNEEL, LITTLE MORTAL!  KNEEL BEFORE THE MIGHT OF THE HERALD OF RAGNAROS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25723,'YOU WILL ALL PERISH IN FLAMES!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25724,'%s blinks...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25725,'Ah.  I was merely jesting...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25726,'I am taunka of the Horde and I have come to drive the Scourge from this world!','I am taunka of the Horde and I have come to drive the Scourge from this world!',0,0,0,0,0,0,0,1,1,7030,0,0,26124),
(25727,'Amidst the tragedy and chaos, this place stands defiantly against the Scourge! It is good to be Horde.','Amidst the tragedy and chaos, this place stands defiantly against the Scourge! It is good to be Horde.',0,0,0,0,0,0,0,1,1,7030,0,0,26124),
(25728,'I have come to kill or be killed!','I have come to kill or be killed!',0,0,0,0,0,0,0,1,1,7030,0,0,26124),
(25729,'Nothing will stand in the way of vengeance!','Nothing will stand in the way of vengeance!',0,0,0,0,0,0,0,1,1,7030,0,0,26124),
(25730,'I can feel the power SURGING within me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25731,'Do you sell any of this stuff?','Do you sell any of this stuff?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25732,'%s is entranced by the sun\'s reflection on Zeh\'gehn\'s knife.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25733,'%s croaks eagerly while directing its gaze to the docked ship.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25734,'Ku into me carver, ye ugly croaker!  Ku and show me who dares cross me brethren!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25735,'Yes, yes, I am given to understand that the ley line has already been diverted. I will wait no longer... summon Goramosh this instant!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25736,'Your surge needle appears to have worked perfectly.  Surely Goramosh now has time to speak further of the proposed accord?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25737,'What ye be lookin\' at, matey?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25738,'Ummm... the frog says you\'re a traitor, \"matey.\"','Ummm... the frog says you\'re a traitor, \"matey.\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25739,'What is it you need?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25740,'Have you discovered something?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25741,'The elemental spirits are restless...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25742,'I\'ve lost my totemic beacon - may I have another?','I\'ve lost my totemic beacon - may I have another?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25743,'Do you really want to bribe Olga?','Do you really want to bribe Olga?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25744,'I never understood why some pirates bury their treasure.  Me... I like to keep it within arm\'s reach.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25745,'LUNCH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25746,'The great sea turtle Walker of Waves travels from this dock to Moa\'ki Harbor in Dragonblight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25747,'I\'d like to take the great sea turtle to Moa\'ki Harbor.','I\'d like to take the great sea turtle to Moa\'ki Harbor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25748,'The steam-powered Alliance icebreaker Northspear sails from here to Menethil Harbor in the Wetlands, across the sea in the Eastern Kingdoms.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25749,'I\'d like to take the ship to Menethil Harbor.','I\'d like to take the ship to Menethil Harbor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25750,'A ship runs between here and Westguard Keep, sometimes ferrying troops and the occasional passenger but most often carrying much-needed supplies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25751,'I\'d like to take the ship to Westguard Keep.','I\'d like to take the ship to Westguard Keep.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25752,'Moa\'ki Harbor is blessed with two great sea turtles: Walker of Waves and Green Island. They swim between Unu\'pe and Kamagua.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25753,'I\'d like to take the great sea turtle to Unu\'pe.','I\'d like to take the great sea turtle to Unu\'pe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25754,'I\'d like to take the great sea turtle to Kamagua.','I\'d like to take the great sea turtle to Kamagua.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25755,'','Eager to get to Northrend, are you? The steam-powered Kraken sails from here to Valiance Keep in Borean Tundra.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25756,'I\'d like to take the ship to Valiance Keep.','I\'d like to take the ship to Valiance Keep.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25757,'If you\'re looking to travel to Northrend, the icebreaker Northspear sails from here to Valgarde in the Howling Fjord.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25758,'I\'d like to take the ship to Valgarde.','I\'d like to take the ship to Valgarde.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25759,'','If you\'re looking to get to Valiance Keep, you can hop onto the cargo ship that runs between here and Borean Tundra. They don\'t mind taking on the occasional passenger or two.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25760,'I\'d like to take the ship to Valiance Keep.','I\'d like to take the ship to Valiance Keep.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25761,'Hey there! Miss the Eastern Kingdoms, huh? Well, the Kraken sails back to Stormwind if you\'re really itching to return. I know I\'d enjoy the warmer weather!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25762,'I\'d like to take the ship to Stormwind Harbor.','I\'d like to take the ship to Stormwind Harbor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25763,'Our blessed great sea turtle, Green Island, travels from here to Moa\'ki Harbor in Dragonblight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25764,'I\'d like to take the great sea turtle to Moa\'ki Harbor.','I\'d like to take the great sea turtle to Moa\'ki Harbor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25765,'Yo. Lookin\' to get back to the Old World? Fly to Tirisfal Glades in style on the Cloudkisser.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25766,'I\'d like to take the zeppelin to Tirisfal Glades.','I\'d like to take the zeppelin to Tirisfal Glades.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25767,'Hey there. If you wanna get to Northrend, then The Mighty Wind is the way to go. She\'ll fly you straight to Warsong Hold in the Borean Tundra.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25768,'I\'d like to take the zeppelin to Warsong Hold.','I\'d like to take the zeppelin to Warsong Hold.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25769,'','Hey there, how ya doin\'? Lookin\' for a ride ta Warsong Hold? The Wild Wench will get ya there lickety-split. She\'s the fastest zeppelin in Northrend!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25770,'I\'d like to take the zeppelin to Warsong Hold.','I\'d like to take the zeppelin to Warsong Hold.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25771,'','Northrend awaits, $r. The majestic Cloudkisser will take you straight across the sea to Vengeance Landing in Howling Fjord.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25772,'I\'d like to take the zeppelin to Vengeance Landing.','I\'d like to take the zeppelin to Vengeance Landing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25773,'Heading home, $c? The Mighty Wind will get you there, if home\'s in Kalimdor. She flies straight from here to Durotar.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25774,'I\'d like to take the zeppelin to Durotar.','I\'d like to take the zeppelin to Durotar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25775,'Faster! Faster! These armaments must be delivered to the Kor\'kron Vanguard TODAY!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25776,'I will happily replace you all with goblins! Do not fail me!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25777,'Overlord Agmar demands more of us! We must not disappoint!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25778,'Don\'t make me jump off of this crate! I will beat your head in, orc.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25779,'Yo. Looking for a ride to Vengeance Landing? The Wild Wench flies back and forth, day and night.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25780,'I\'d like to take the zeppelin to Vengeance Landing.','I\'d like to take the zeppelin to Vengeance Landing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25781,'Hey pretty lady, Zebu\'tan got two rugs over here! Why don\'t you come on over and keep he warm, eh?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25782,'Lookie what Zebu\'tan got for you! Roses for da rose!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25783,'%s grumbles.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25784,'','Not if you were the last troll on Azeroth!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25785,'','Ewwww!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25786,'','Never!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25787,'','Get lost, creep!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25788,'','I\'ve got a man! Now take a hike!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25789,'Dis troll tink you got a crush on he! Come on over!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25790,'Don\'t be shy, elfy. Don\'t you feel dis burnin\' love formin\' between us?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25791,'To the front lines! The Kor\'kron Vanguard needs air support!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25792,'Orders, sir?','Orders, sir?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25793,'Sir, yes, sir!','Sir, yes, sir!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25794,'Right away, sir!','Right away, sir!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25795,'I\'m on the way, sir!','I\'m on the way, sir!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25796,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25797,'Air raid on Icemist! Let the Anub\'ar feel the power of our air strikes!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25798,'Take this message to Lord Hellscream at once!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25799,'Supply drop at the Wrathgate! Ride with caution!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25800,'Aerial recon of New Hearthglen! Observe Scarlet Crusade activity!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25801,'Strange activity has been reported at Frostmourne Cave. Scout it out!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25802,'','Are you ready, Mr. Floppy? Stay close to me and watch out for those wolves!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25803,'','Um... I think one of those wolves is back...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25804,'','He\'s going for Mr. Floppy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25805,'','Let\'s get out of here before more wolves find us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25806,'','Oh, no! Look, it\'s another wolf, and it\'s a biiiiiiig one!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25807,'','No, Mr. Floppy! No!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25808,'','Oh, Mr. Floppy, this is hopeless!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25809,'','Don\'t go toward the light, Mr. Floppy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25810,'','Mr. Floppy, you\'re ok! Thank you so much for saving Mr. Floppy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25811,'You\'ve successfully freed your spirit! You can serve as my eyes. Together we\'ll get to the bottom of this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25812,'Wanted DEAD for treason and other treacherous acts against the Horde!$B$BAll bounties paid by Captain Gort.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25813,'You\'re coming up on the village now. Keep your eyes peeled.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25814,'Clear me for the teleporter, I\'m ready to go!','Clear me for the teleporter, I\'m ready to go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25815,'What\'s happened to the lake bed? Strange power is pouring out of it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25816,'Welcome, $c!  I hope you aren\'t afraid of heights!$b$bI\'ve got a practice parachute for you.  These chutes are for quick landings.  If you want to gently soar to the ground, use a mount.  If you want action and an adrenaline rush, you fall.  At the last possible moment you use your chute.  That\'s how these were made.  Quick action!  Are you ready for some quick action?$b$bThe chute only lasts a few seconds.  So you\'ll need to time it just right.  I\'m not sure you can handle it, $c.  I\'d like to see you prove me wrong.','Welcome, $c!  I hope you aren\'t afraid of heights!$b$bI\'ve got a practice parachute for you.  These chutes are for quick landings.  If you want to gently soar to the ground, use a mount.  If you want action and an adrenaline rush, you fall.  At the last possible moment you use your chute.  That\'s how these were made.  Quick action!  Are you ready for some quick action?$b$bThe chute only lasts a few seconds.  So you\'ll need to time it just right.  I\'m not sure you can handle it, $c.  I\'d like to see you prove me wrong.',11,0,0,1,0,0,0,7,1,0,0,0,26124),
(25817,'No... no! My people are all dead spirits or deranged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25818,'Elder Mana\'loa, the statue there, sees you. This is a good sign!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25819,'Come back, $n. If you\'re out of your body for too long, you run the risk of not being able to return. We have much to discuss.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25820,'G\'day mate! Sit an\' have yerself a sip, won\'t yeh?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25821,'I need some more of your fine grog, Mack.','I need some more of your fine grog, Mack.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25822,'Strike now heroes, while he is weakened! Vanquish the Deceiver!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25823,'Pssst... Over here, by the mailbox. Come quickly and make sure you aren\'t followed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25824,'','I am proud of you, child.',0,0,0,0,0,0,0,1,1,7030,0,0,26124),
(25825,'','You will make a fine warrior of the Horde.',0,0,0,0,0,0,0,1,1,7030,0,0,26124),
(25826,'','We will retake Icemist. The Anub\'ar will be expelled from our city.',0,0,0,0,0,0,0,1,1,7030,0,0,26124),
(25827,'','The worst is behind us. Soon we will put an end to the Lich King\'s reign.',0,0,0,0,0,0,0,1,1,7030,0,0,26124),
(25828,'Release me, fiends!','',0,0,0,0,0,0,0,0,1,7118,0,0,26124),
(25829,'Pray to whatever gods you believe in that I am never freed!','',0,0,0,0,0,0,0,0,1,7118,0,0,26124),
(25830,'I will break these bonds that hold me and send you all back to the hell from whence you came!','',0,0,0,0,0,0,0,0,1,7118,0,0,26124),
(25831,'I will never succumb to your tortures! NEVER!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25832,'To the town hall, everyone!  We\'ve brought you weapons!  Arm yourselves and beat the Scourge back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25833,'Time to kill!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25834,'It\'s about time!  Lurid was getting bored.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25835,'You Arthas lapdog?  You die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25836,'This not... end well for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25837,'Lurid could get used... to working with you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25838,'All I ever wished for was to serve my king once again.  For humanity, against a common enemy.$B$BInstead, I find that our numbers have been infiltrated by cultist scum.... and all signs point to Naxxanar as the origin of this rot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25839,'This is where the cultists\' orders are coming from.  Their leader is bound to show up soon.$B$BLet\'s not miss this opportunity.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25840,'Let\'s do this, Thassarian.  It\'s now or never.','Let\'s do this, Thassarian.  It\'s now or never.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25841,'What... what happened to me?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25842,'','Thassarian!  You\'re alive!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25843,'','I thought... I thought you were... dead.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25844,'Leryssa... you... you\'re all right!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25845,'I cannot return home with you just yet, Leryssa.  I am not quite done with the Scourge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25846,'You might be right, sister.  My obligations to my land and King have been fulfilled.  But there is something that I still owe to myself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25847,'Ugh!  My head won\'t stop spinning...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25848,'','Don\'t leave me again!  You want to fight for your country, but they don\'t even want you!  They sent you here to die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25849,'','I know that look in your eye... I\'m not going to be able to talk you out of this.  If you die on me again...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25850,'Do not worry, Leryssa.  I will come back to you when I am done.  Nothing in the world will stop me from coming home to the only family that I have left.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25851,'We\'ve taken the harbor!  The enemy has been driven away.  Sun\'s Reach is ours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25852,'Run for yer life, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25853,'Da Scourge be everywhere, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25854,'','Little $n, why do you call me forth? Are you working with the trolls of this land? Have you come to kill me and take my power as your own?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25855,'Every troll for himself, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25856,'Outta my way, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25857,'Drak\'Tharon be lost, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25858,'Da Scourge be everywhere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25859,'Ruuun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25860,'You have made a fatal mistake, mortal... There isss no essscape...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25861,'Betrayers! The day of reckoning comes and with it comes your end! See then if your Lich King saves you from the ancient one\'s judgment! Now you die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25862,'Anveena\'s sacrifice has given us all a new hope for the future.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25863,'','I sense uncertainty in you, and I do not trust it whether you are with them, or not. If you wish my augury for the Kalu\'ak, you will have to prove yourself first.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25864,'','I will lay a mild compulsion upon you. Jump into the depths before me so that you put yourself into my element and thereby display your submission.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25865,'','Though you are compelled, the choice, and the last step before you leap, are yours. You have twenty more seconds to decide.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25866,'','Very well, $n, you have failed to act. The prophecy is not yours to learn. Do not call upon me again until you have found your backbone!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25867,'','Well done, $n. Your display of respect is duly noted. Now, I have information for you that you must convey to the Kalu\'ak.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25868,'','Simply put, you must tell the tuskarr that they cannot run. If they do so, their spirits will be destroyed by the evil rising within Northrend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25869,'','Tell the mystic that his people are to stand and fight alongside the Horde and Alliance against the forces of Malygos and the Lich King.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25870,'','Now swim back with the knowledge I have granted you. Do what you can for them, $r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25871,'Huh?  What?!  Go away.','',36,0,0,0,0,0,0,0,1,0,0,0,26124),
(25872,'','If I can make a new war machine, I know I can get a pretty penny for it over at the Wrath Gate.  $B$BSome of our previous iterations haven\'t been entirely... stable, but my flying machine should do the trick if I can just develop an effective bomb system for it.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25873,'There\'s money to be made!  Just like pops always said - no better time for raking in the cash than a time of war. ','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(25874,'You feel a strange presence as you stand before this ancient idol.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25875,'Where the Eye of the Prophets rested for millennia, only an empty niche remains.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25876,'Remove the Eye of the Prophets from the idol\'s face.','Remove the Eye of the Prophets from the idol\'s face.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25877,'I\'ll be waitin\' for ya, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25878,'Hurry now, $n. I\'ll be waitin\' for ya, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25879,'','This is an intriguing find, $n, but I don\'t know what to make of it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25880,'','The language is unfamiliar and for all we know, it\'s just some soldier\'s journal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25881,'Let me take a look at that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25882,'Hmm...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25883,'This journal is written in dwarven. I can\'t read this scrawl, but I can make out one thing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25884,'\'Brann Bronzebeard.\' The brother of Ironforge\'s king? You may have spoken too soon, Paluna.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25885,'','What do you mean?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25886,'Think about how valuable a member of the dwarven royal family would be as a hostage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25887,'If he\'s in the area, we must find him. First, though, we\'ll need a way to decipher this journal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25888,'Come, cowards! FACE THE HORDE!','Come, cowards! FACE THE HORDE!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25889,'Do you that dare challenge the Horde? Then come...','Do you that dare challenge the Horde? Then come...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25890,'I will crush you all! For the Horde!','I will crush you all! For the Horde!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25891,'Come! Come face your doom!','Come! Come face your doom!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25892,'Leave this place or I will thrash you soundly!','Leave this place or I will thrash you soundly!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25893,'Show yourselves so that I may crack your insectoid skeletons with my bare hands!','Show yourselves so that I may crack your insectoid skeletons with my bare hands!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25894,'Hearty beatings will be dispensed in the name of the Horde!','Hearty beatings will be dispensed in the name of the Horde!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25895,'Anub\'ar fear nothing, mortal...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25896,'A fine meal you will make...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25897,'Anub\'arak may have uses for your carcass...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25898,'The feast has arrived! DIE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25899,'The Anub\'ar have destroyed the %s!','',0,0,0,0,0,0,0,0,1,7115,0,0,26124),
(25900,'Welcome!  If you need a place to rest, I can solve that problem.','Welcome!  If you need a place to rest, I can solve that problem.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25901,'','Scout Vor\'takh\'s hunch was correct. Brann Bronzebeard visited Thor Modan recently and this journal records his findings.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25902,'','He managed to explore the ruins before the battle began, discovering three runic plates inscribed with prophecies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25903,'','Brann doesn\'t record the translations, but it says he committed them to memory before fleeing the battle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25904,'','If you can translate those plates, we can find and capture Brann.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25905,'Magmoth Crusher is on the move!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25906,'Magmoth Crusher\'s moving off!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25907,'Bomber went down!  The pilot\'s out safe though!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25908,'We just lost a plane!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25909,'Incoming survivor!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25910,'We\'ve got a survivor inbound!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25911,'','Let us see what this journal reveals.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25912,'I cannot.','I cannot.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25913,'No.','No.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25914,'You\'ll have to be patient.','You\'ll have to be patient.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25915,'Goramosh is busy with a ritual right now.','Goramosh is busy with a ritual right now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25916,'My orders are that you must wait here.','My orders are that you must wait here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25917,'The master will be with you momentarily.','The master will be with you momentarily.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25918,'It won\'t be long now.','It won\'t be long now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25919,'My apologies, ambassador. My orders were quite clear.','My apologies, ambassador. My orders were quite clear.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25920,'We will crush Arthas! The Scourge cannot stand up to the might of the Horde!','',5,15,0,0,0,0,0,0,1,0,0,0,26124),
(25921,'You\'ll pay for this insult, $c!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25922,'','You are not welcome in our home.  Leave and go find some other land to pillage!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25923,'I\'ll show you!  Give me that practice parachute!','I\'ll show you!  Give me that practice parachute!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25924,'','The control components are working perfectly this time!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25925,'','Who to test the bomb on?  The Harpies?  Ha ha... wait... what\'s that?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(25926,'','NO!  My machine... my bombs!  THAT\'S IT!  Those Harpies are going DOWN!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(25927,'Spirit, you will submit to my will.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25928,'You are bound to me, spirit! Your task is to keep the mill running - do not falter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25929,'Bend the wind to the task of keeping the mill turning, spirit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25930,'North wind! You will do as I command!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25931,'The wind immediately surrounding the mill picks up rapidly, causing the timbers to groan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25932,'A chilly gust encircles the taunka mill, carrying with it soft, resentful mutterings in Kalimag.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25933,'The sails of the windmill grow taut against the sudden wind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25934,'','Keep them away from the focus!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25935,'','I\'m sorry, daddy....',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25936,'Anub\'et\'kan will... end you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25937,'I gladly die for the master...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25938,'Your victory is meaningless.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25939,'I will rise again, more powerful... much... more...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25940,'Looking for an Arena Battlemaster? You can find them on the road between towns, or in the capitals.$B$BYou can bind here, at me. I can also teleport you to one of the capitals.','Looking for an Arena Battlemaster? You can find them on the road between towns, or in the capitals.$B$BYou can bind here, at me. I can also teleport you to one of the capitals.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25941,'Bind Here','Bind Here',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25942,'Darnassus','Darnassus',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25943,'The Exodar','The Exodar',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25944,'Ironforge','Ironforge',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25945,'Orgrimmar','Orgrimmar',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25946,'Silvermoon City','Silvermoon City',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25947,'Stormwind','Stormwind',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25948,'Thunder Bluff','Thunder Bluff',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25949,'Undercity','Undercity',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(25950,'Tear this pitiful village apart!','',0,0,0,0,0,0,0,0,1,7118,0,0,26124),
(25951,'Leave no survivors!','',0,0,0,0,0,0,0,0,1,7118,0,0,26124),
(25952,'Give in, Taunka! Your will cannot hold out against the Scourge!','',0,0,0,0,0,0,0,0,1,7118,0,0,26124),
(25953,'A new day dawns, my children! Soon the undead legions of Azjol-Nerub will rise and take over this world!','',0,0,0,0,0,0,0,0,1,7118,0,0,26124),
(25954,'I... am... FREE!','',0,0,0,0,0,0,0,0,1,7118,0,0,26124),
(25955,'What have they done to my people...','',0,0,0,0,0,0,0,0,1,7118,0,0,26124),
(25956,'You will face the full fury of the ancestors for what you have done, monster!','',0,0,0,0,0,0,0,0,1,7118,0,0,26124),
(25957,'Rebirth comes, my brothers... Rise... Rise and fight once more.','',0,0,0,0,0,0,0,0,1,7118,0,0,26124),
(25958,'FOR ICEMIST! FOR THE TAUNKA!','',0,0,0,0,0,0,0,0,1,7118,0,0,26124),
(25959,'Your freedom will be short lived, Icemist!','',0,0,0,0,0,0,0,0,1,7118,0,0,26124),
(25960,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25961,'The Hulking Jormungar falters for a moment, opening its mouth wide.','',0,0,0,0,0,0,0,0,1,7117,0,0,26124),
(25962,'Come down and face me, insect!','',0,0,0,0,0,0,0,0,1,7118,0,0,26124),
(25963,'Then I will force you down! Wind grant me flight!','',0,0,0,0,0,0,0,0,1,7118,0,0,26124),
(25964,'Insolent mortal! You will be consumed!','',0,0,0,0,0,0,0,0,1,7118,0,0,26124),
(25965,'ARRGGH!! It cannot be! How...','',0,0,0,0,0,0,0,0,1,7118,0,0,26124),
(25966,'Hello there!  Fizzcrank\'s pilots are the best of the best.  We stay that way through constant training.  That includes parachute training.  You never know when you will need to use your chute, but you do know that one day you\'ll have to use it.$b$bSo what we have here is a teleporter to the top of this spire.  Once you get up there, the only way for a real soldier to get back down is with a parachute.  We\'ve got another trooper stationed up top ready with the parachutes.$b$bIf you feel like trying it out, $c, I\'ll clear you for teleporter use.  Then just step onto the teleporter.','Hello there!  Fizzcrank\'s pilots are the best of the best.  We stay that way through constant training.  That includes parachute training.  You never know when you will need to use your chute, but you do know that one day you\'ll have to use it.$b$bSo what we have here is a teleporter to the top of this spire.  Once you get up there, the only way for a real soldier to get back down is with a parachute.  We\'ve got another trooper stationed up top ready with the parachutes.$b$bIf you feel like trying it out, $c, I\'ll clear you for teleporter use.  Then just step onto the teleporter.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25967,'Iron masters, aid me in this battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25968,'YaY! WE WON!','YaY! WE WON!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25969,'Why am I so good? ','Why am I so good?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25970,'We go to scout out the sinkholes to the west, Chieftain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25971,'OWNED!','OWNED!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25972,'Get outa here! Good riddance!','Get outa here! Good riddance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25973,'','We will return swiftly with our report.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25974,'There they are. Taima, are we close enough to see everything for the report?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25975,'','No. We\'ve known this much for some time. We need to get closer and see how deeply they go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25976,'Then we cut our way through the Nerubians.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25977,'%s grunts and nods.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25978,'Strike now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25979,'Crush the small one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25980,'We will destroy you, puny creature!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25981,'Children of iron, lend me your blades!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25982,'The enemy grows stronger! Aid me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25983,'No one will keep us from our destiny!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25984,'For the glory of Loken!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25985,'You will pay for your interference!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25986,'You are a fool to fight Kurun\'s hopeless battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25987,'Your life is forfeit, ally of stone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25988,'Hello, Pahu.','Hello, Pahu.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25989,'A package changes hands between Pahu and the Longrunner, who packs it away safely.','A package changes hands between Pahu and the Longrunner, who packs it away safely.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25990,'','Hello! I have your rations right here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25991,'Be cautious, but return quickly. We cannot afford to be blind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25992,'%s flies away.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25993,'Ya shouldn\'a taken the boat north, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25994,'Ah, Deino, mah sistah. Ta\'zinni die now.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(25995,'Warning! Vehicle has left the operation area. Power-down imminent.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(25996,'You\'ll pay for that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25997,'I will not let you win!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25998,'','Not Haloke!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(25999,'Anub\'et\'kan is defeated! Take a fragment of his husk as proof of your victory!','',0,0,0,0,0,0,0,0,1,7121,0,0,26124),
(26000,'Thank you, $c, for seeing to it that I received the letter from my daughter.$B$BRest assured, her death will not have been in vain. The blue dragonflight will pay in spades.$B$BI\'ll see to it personally!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26001,'Get ready to ride, $n.  If the military can\'t be bothered to send me an escort, I suppose you\'ll have to do.','Get ready to ride, $n.  If the military can\'t be bothered to send me an escort, I suppose you\'ll have to do.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26002,'Silverbrook is due northwest of here.  A small community of hunters and trappers.  They know the lay of the land -- it would be good to have them on our side.','Silverbrook is due northwest of here.  A small community of hunters and trappers.  They know the lay of the land -- it would be good to have them on our side.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26003,'We\'re taking a shortcut.  Be on the lookout for worgs.','We\'re taking a shortcut.  Be on the lookout for worgs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26004,'That\'s it up ahead.','That\'s it up ahead.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26005,'The bodies hanging from the gate... something\'s very wrong here.','The bodies hanging from the gate... something\'s very wrong here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26006,'Hail!  By order of King Varian Wrynn, I\'ve been given the authority to extend an offer to the people of Silverbrook.','Hail!  By order of King Varian Wrynn, I\'ve been given the authority to extend an offer to the people of Silverbrook.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26007,'You will find it in your interest to aid the Alliance war effort.  We are in need of scouts and trackers, as well as provisions for our troops.  Payment, in gold, will be delivered immediately from the king\'s treasury.','You will find it in your interest to aid the Alliance war effort.  We are in need of scouts and trackers, as well as provisions for our troops.  Payment, in gold, will be delivered immediately from the king\'s treasury.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26008,'We\'d best head back, $n.  These simpletons don\'t know what a grave mistake they\'re making.','We\'d best head back, $n.  These simpletons don\'t know what a grave mistake they\'re making.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26009,'You\'d better get outta here unless you want to find yourself in one of these cages....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26010,'What?! Impossible! RUNNN!','What?! Impossible! RUNNN!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26011,'RUN FOR YOUR LIVES!','RUN FOR YOUR LIVES!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26012,'It\'s comin right for us!','It\'s comin right for us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26013,'Awww man not again.','Awww man not again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26014,'I\'ve got a bad feeling about this.  If something happens to me, head back to Amberpine lodge and report to Lieutenant Dumont.','I\'ve got a bad feeling about this.  If something happens to me, head back to Amberpine lodge and report to Lieutenant Dumont.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26015,'Now you ask for our help?  Where were you when we needed you?  Do you\'ve any idea what we\'ve been through?','Now you ask for our help?  Where were you when we needed you?  Do you\'ve any idea what we\'ve been through?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26016,'We are damned.  If I were you, I\'d leave before it was too late.  You\'ll be lucky if you make it back alive.','We are damned.  If I were you, I\'d leave before it was too late.  You\'ll be lucky if you make it back alive.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26017,'%s spits on the ground near the Alliance Envoy.','%s spits on the ground near the Alliance Envoy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26018,'What the -- ?','What the -- ?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26019,'Thank you, $c, for seeing to it that I received the letter from my brother.$B$BRest assured, his death will not have been in vain. The blue dragonflight will pay for this.$B$BI\'ll see to it personally!','Thank you, $c, for seeing to it that I received the letter from my brother.$B$BRest assured, his death will not have been in vain. The blue dragonflight will pay for this.$B$BI\'ll see to it personally!',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(26020,'My lady, the surge needle is fully operational.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26021,'','You have done well, Keldonus. Lord Malygos will be quite pleased with your progress.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26022,'I live only to serve the master, my lady.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26023,'Chug and chuck!  Chug and chuck!','Chug and chuck!  Chug and chuck!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26024,'The ley line beneath this night elf temple is now flowing into the Azure Dragonshrine. Our brothers should have all the power they need to crush our enemies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26025,'','Deal with this interruption, Keldonus. After you are through, bring me the head of the one they call $n. I will decorate my chambers with $g his:her; skull.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26026,'','This transgression against the Blue Dragonflight has been noted. I will take extra pleasure in separating the life energy from your body!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26027,'Alright, kid. Stay behind me and you\'ll be fine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26028,'Their ceremonial chamber, where I was to be sacrificed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26029,'Time to put an end to all this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26030,'Odd. That usually does it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26031,'Do your part in keeping the Scourge at bay, soldier! Report all suspicious activity and kill first, ask questions later!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(26032,'Mark my words, these forsaken fools will be the death of us all!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(26033,'If you ask me, and you DID, I think we should kill all of the apothecaries before it\'s too late!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(26034,'The Horde is about honor and war. I am certain that there is nothing honorable about what these apothecaries are doing.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26035,'I\'m keeping an eye on the forsaken idiots down there. You can never be too cautious around them!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26036,'What\'s this?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26037,'Aww, not a snake!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26038,'Ssssupper comess early?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26039,'The %s gives you its thanks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26041,'Breaking off a piece of its bark, the %s hands it to you before departing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26042,'The %s is angered by your request and attacks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26043,'Time to feassst!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26044,'If you have dealings with the doctor over there, be cautious. Whatever they\'re up to, it\'s unnatural.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26045,'Mon, da west wastes of dis place be full o\' baddies. Stay away from dis here area if ya want to live!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26046,'Get that frostwyrm on the ground and I\'ll finish her.','Get that frostwyrm on the ground and I\'ll finish her.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26047,'Don\'t ya worry, mon. Just leave it to Rokhan. She be comin\'.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26048,'Thank you, small one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26049,'You have my gratitude.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26050,'I never thought I\'d be free from that terrible spell!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26051,'I thought I was doomed. Thank you for freeing me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26052,'The Runebreaker fails to free the Runed Giant, weakening it and causing it to attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26053,'Just as well, I\'ve had enough of this place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26054,'Take me to the Apothecary Camp.','Take me to the Apothecary Camp.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26055,'Take me to Camp Oneqwah.','Take me to Camp Oneqwah.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26056,'','Thank you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26057,'You\'re free to go, miss.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26058,'Take me to Conquest Hold.','Take me to Conquest Hold.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26059,'My charge at Agmar\'s Hammer extends far beyond the care of the animals at the stables.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26060,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26061,'Let us speak a moment, $r.','',0,0,0,0,0,0,0,0,1,7130,0,0,26124),
(26062,'I can\'t offer you anything outside Howling Fjord. The bats still don\'t know their way abroad. Where do you want to go?','I can\'t offer you anything outside Howling Fjord. The bats still don\'t know their way abroad. Where do you want to go?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26063,'Take me to Venomspite.','Take me to Venomspite.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26064,'I have another task for you, should you be willing, little one.','',0,0,0,0,0,0,0,0,1,7131,0,0,26124),
(26065,'Listen, kid. I can handle this thing. You just watch my back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26066,'See ya \'round, kid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26067,'Harrison Jones? Didn\'t you expire back in Zul\'aman?','Harrison Jones? Didn\'t you expire back in Zul\'aman?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26068,'Expire? Me? Heh, not hardly, kid. That was just a scratch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26069,'Take me to Amberpine Lodge.','Take me to Amberpine Lodge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26070,'Take me to Wyrmrest Temple.','Take me to Wyrmrest Temple.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26071,'Take me to Agmar\'s Hammer.','Take me to Agmar\'s Hammer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26072,'Take me to the Westfall Brigade Encampment.','Take me to the Westfall Brigade Encampment.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26073,'Take me to Wintergarde Keep.','Take me to Wintergarde Keep.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26074,'Take me to Fordragon Hold.','Take me to Fordragon Hold.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26075,'Take me to Star\'s Rest.','Take me to Star\'s Rest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26076,'Take me to Valiance Keep.','Take me to Valiance Keep.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26077,'Take me to Fizzcrank Airstrip.','Take me to Fizzcrank Airstrip.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26078,'','Talk to Narf.  Lets take care of those bird-brains once and for all.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(26079,'About time!  Get that lumber and get moving.  The horde won\'t be up there fighting forever, there\'s money to be made!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(26080,'Impressive, aren\'t they? These giants would be the perfect fodd... er, allies.  This one is their leader, but he continues to refuse to speak with me.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26081,'Hello, $r.  You are welcome to share this canyon with us as refuge from the dragons.  Beware the goblin runt though... his kind cannot be trusted.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26082,'With enough money, I could take over the world...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26083,'This console stands before steaming rubble.  The sounds of an engine can be heard below.','This console stands before steaming rubble.  The sounds of an engine can be heard below.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26084,'Pull the console\'s levers.','Pull the console\'s levers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26085,'You take my heart, now I take yours!','',0,0,0,0,0,0,0,0,1,7133,0,0,26124),
(26086,'Why ya wanna mess wit me innards, mon?','',0,0,0,0,0,0,0,0,1,7133,0,0,26124),
(26087,'Dat me liver you be squeezin, mon!','',0,0,0,0,0,0,0,0,1,7133,0,0,26124),
(26088,'Come back here with me guts, $r!','',0,0,0,0,0,0,0,0,1,7133,0,0,26124),
(26089,'What do you think you\'re doing?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26090,'You\'ll pay for this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26091,'Fool! You\'ll never get away with this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26092,'You dare to defy the sons of iron?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26093,'Dimitri!  Anton!  Don\'t you recognize me?  Do not worry, I will put your souls to rest!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26094,'I won\'t let your families see you like this!  Us miners have to look after each other!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26095,'I\'ll tell your story, friends!  I\'ll tell everyone about how the Hollowstone miners never gave in!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26096,'Welcome to Wyrmrest Temple, traveler.$B$BHere the dragonflights confer in peace with one another amidst the bones of their honored ancestors.$B$BAt least, we were peaceful until the Blue Dragonflight launched a surprise attack upon the temple itself.$B$BEnter with our blessing, but know that we will brook no aggression within our walls.','',1,1,25,0,0,0,0,0,1,0,0,0,26124),
(26098,'How dare you summon me without an offering!','',0,0,0,0,0,0,0,0,1,7135,0,0,26124),
(26099,'','Would you like to head back down, $c?$B$BI can see to it that one of these drakes sees you safely to where you need to go.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(26100,'Yes, please, I would like to return to the ground level of the temple.','Yes, please, I would like to return to the ground level of the temple.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26101,'Leave me be, fool!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(26102,'The boy believed he could essssscape... Neither of you shall make it out alive.','',0,0,0,0,0,0,0,0,1,7136,0,0,26124),
(26103,'Kill ussss all... More will come for him...','',0,0,0,0,0,0,0,0,1,7136,0,0,26124),
(26104,'Relent! This ssssoul iss not worth sssaving...','',0,0,0,0,0,0,0,0,1,7136,0,0,26124),
(26105,'You have made a grave misssstake...','',0,0,0,0,0,0,0,0,1,7136,0,0,26124),
(26106,'You won\'t get away with this, you know?  You\'re just a kid.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26107,'How old are you, lass?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26108,'We\'ll all end up serving the Lich King, kid.  Better this way than becoming a rotten corpse.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26109,'Your father was weak, Sasha... he didn\'t have the guts to do what had to be done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26110,'','I\'m old enough to shoot beasts like you right between the eyes... at twice this distance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26112,'','I\'d rather be dead than be one of you!  You think you\'re still human?  You\'re... animals!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26113,'','Don\'t you dare talk about my father, monster.  He was twice the man you\'ll ever be.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26114,'The boy believed that he was free, but free will has a price. The demons I kept at bay are now loosed upon him and all death knights that attempt to flee... \n','',0,0,0,0,0,0,0,0,1,7136,0,0,26124),
(26115,'Mograine\'s sacrifice was for nothing. You will let Koltira know, won\'t you?\n','',0,0,0,0,0,0,0,0,1,7136,0,0,26124),
(26116,'And remember this, mortal: for now, I give you the choice. I allow you to pick your allegiance, but in the end, you will be mine - one way or another.\n','',0,0,0,0,0,0,0,0,1,7136,0,0,26124),
(26117,'Ah, the Horde... meddling, as always. I suppose a welcome is in order. So welcome, insects. Welcome to my world.\n','',0,0,0,0,0,0,0,0,1,7136,0,0,26124),
(26118,'You have crossed into the world of the dead in search of answers. You wish to save your ally and have risked life and limb to be here. Allow me to help.','',0,0,0,0,0,0,0,0,1,7136,0,0,26124),
(26119,'What? You want to train under me, $c? You better be ready to work.','',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(26120,'I must return to the world of shadows, Koltira. Send me back.','I must return to the world of shadows, Koltira. Send me back.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26121,'Foolish Troll, you will join our ranks. Zombie! Attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26122,'Zombie! Slay him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26123,'We\'ll see how the Drakkari holds up against the might of the Scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26124,'You can sleep in the barracks, if you\'d like. Just don\'t wake my men, or I\'ll throw you out in the snow myself.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26125,'Warm-up sequence initiated.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26126,'Thank you for rescuing me, $n. I will never forget your courage and determination.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(26127,'Greetings High Chief. Would you do me the honor of accepting my invitation to join the Horde as an official member and leader of the Taunka?','Greetings High Chief. Would you do me the honor of accepting my invitation to join the Horde as an official member and leader of the Taunka?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26128,'It would be an honor to battle alongside of you as a brother of the Horde, $n. I accept your offer.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(26129,'It is you who honor me, High Chief. Please read from this scroll. It is the oath of allegiance.','It is you who honor me, High Chief. Please read from this scroll. It is the oath of allegiance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26130,'%s reads from the scroll as the other Taunka gather around him.','',1,1,0,0,0,0,0,1,1,7119,0,0,26124),
(26131,'We will walk together, $n.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26132,'Yo. They weren\'t sure this elevator would be workin\' in time, so they called me and my brother in. You need a ride up?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26133,'I\'d like a ride up to the top of Warsong Hold.','I\'d like a ride up to the top of Warsong Hold.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26134,'Heya. They weren\'t sure this elevator would be workin\' in time, so they called me and my brother in. You need a ride down?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26135,'I\'d like a ride up to the bottom of Warsong Hold.','I\'d like a ride up to the bottom of Warsong Hold.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26136,'Gather, brothers and sisters.','',1,1,0,0,0,0,0,1,1,7119,0,0,26124),
(26137,'Lok\'tar ogar! Victory or death - it is these words that bind me to the Horde! For they are the most sacred and fundamental of truths to any warrior of the Horde.','',1,1,0,0,0,0,0,1,1,7119,0,0,26124),
(26138,'I give my flesh and blood freely to the Warchief. I am the instrument of my Warchief\'s desire. I am a weapon of my Warchief\'s command!','',1,1,0,0,0,0,0,1,1,7119,0,0,26124),
(26139,'From this moment until the end of days I live and die - For the Horde!\n','',1,1,0,0,0,0,0,1,1,7119,0,0,26124),
(26140,'For my Taunka brothers and sisters! FOR THE HORDE!\n','',1,1,0,0,0,0,0,1,1,7119,0,0,26124),
(26141,'Welcome to the Horde, High Chief. Lok\'tar ogar!','',0,0,0,0,0,0,0,1,1,7119,0,0,26124),
(26142,'FOR THE HORDE!','',0,0,0,0,0,0,0,1,1,7119,0,0,26124),
(26143,'You not a real mon til you killed a dragon... mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26144,'There\'s no thrill like the thrill of a dragon hunt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26145,'','Hello, $r.  I\'m sorry that you had to see our sacred land for the first time in such a state.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26146,'Vrrrrroooom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26147,'rubs his |Hitem:36863|h|cFFFFFFFF[Decahedral Dwarven Dice]|r|h between his hands and rolls.','rubs her |Hitem:36863|h|cFFFFFFFF[Decahedral Dwarven Dice]|r|h between her hands and rolls.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26148,'Free at last, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26149,'I could sleep forever, mon....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26150,'Where\'s mah mummy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26151,'Finally, I can be restin\'...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26152,'casually tosses his |Hitem:36862|h|cFFFFFFFF[Worn Troll Dice]|r|h.','casually tosses her |Hitem:36862|h|cFFFFFFFF[Worn Troll Dice]|r|h.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26153,'Initiating energy collection.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26154,'Energy collection complete.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26155,'Why do you disturb me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26156,'I\'d like passage to the Transitus Shield.','I\'d like passage to the Transitus Shield.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26157,'Take me to Amber Ledge.','Take me to Amber Ledge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26158,'Take me to Warsong Hold.','Take me to Warsong Hold.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26159,'No mon, we dun want to be part of da Scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26160,'Da Drakkari Empire won\'t stand for dis mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26161,'Resist it, me bruddas! Dun be turning to der side!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26162,'Hah!  My slaves brought back a real meal this time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26163,'You only delay the inevitable! The dread citadel rises in the east as the armies of the dead march from the heart of Icecrown!','',0,0,0,0,0,0,0,0,1,7264,0,0,26124),
(26164,'Hey dere. You need anythin\', you let me know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26165,'Scourge aberrations... They\'ll get what\'s coming to them soon enough.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26166,'Xink\'s Shredder ready and available for woodland destruction.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26167,'Xink\'s Shredder security features activated.  Returning to base.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26168,'I have food, if you are hungry, and you may make use of my tent, should you require rest.','I have food, if you are hungry, and you may make use of my tent, should you require rest.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26169,'The EMP disrupts Iron Thane Furyhammer\'s shield!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26170,'%s recovers from the EMP and restores Iron Thane Furyhammer\'s shield.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26171,'%s gains fuel.','',0,0,0,0,0,0,0,0,1,7141,0,0,26124),
(26172,'Thanks, buddy! Let\'s see if I can\'t get this hunk o\' junk movin\' faster!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26173,'I will protect you, friend!','I will protect you, friend!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26174,'Thank you, friend. Now these beasts shall feel the fury of the Sunwell!','Thank you, friend. Now these beasts shall feel the fury of the Sunwell!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26175,'What you think you be doin? Get away from me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26176,'','Preserve? Why? There\'s no truth in it. No no no... only in the taking! I see that now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26177,'Might not be snowy out there, but the nights here can freeze your nose right off. The bunks are in the back - just don\'t make a nuisance of yourself.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26178,'Heh. Nothing against you, pup, but you might want to find somewhere else to bed down for the night. Wouldn\'t want that tender skin of yours to get bruised.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26179,'Run away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26180,'I don\'t wanna die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26181,'Big guy will save us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26182,'Ahh!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26183,'They\'re everywhere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26184,'Come in by the fire and rest, $r. I hope you don\'t mind the smell of fish.','Come in by the fire and rest, $r. I hope you don\'t mind the smell of fish.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26185,'Through the valleys and peaks of Mount Hyjal, across the shifting sands of Silithus, against the Legion\'s dread armies - we have fought. We are the nameless, faceless, sons and daughters of the Alliance. By the Light and by the might of the Alliance, the first strike belongs to us and the last strike is all that our enemies see.$B$BWe are 7th Legion.\n','',396,396,25,0,0,0,0,0,1,0,0,0,26124),
(26186,'You seek their leader... little thing, you wage war against the clans of Grom\'thar the Thunderbringer himself.  Don\'t be so eager to rush to your death.','You seek their leader... little thing, you wage war against the clans of Grom\'thar the Thunderbringer himself.  Don\'t be so eager to rush to your death.',153,0,0,0,0,0,0,0,1,0,0,0,26124),
(26187,'Hah!  So be it.  Blow the horn of a magnataur leader at the ring of torches south of the Blue Dragonshrine.  Make peace with your gods... Grom\'thar will come.  ','Hah!  So be it.  Blow the horn of a magnataur leader at the ring of torches south of the Blue Dragonshrine.  Make peace with your gods... Grom\'thar will come.  ',60,0,0,0,0,0,0,0,1,0,0,0,26124),
(26188,'Hah!  My slaves brought back a real meal this time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26189,'Thank you for rescuing me, but the others are still held on the tiers above!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26190,'Thank goodness! I was worried they were going to press me into service in their war against the stone giants!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26191,'','These irons are crazy! They keep talking about serving their \'master Loken\' but from what I can tell, only a few receive orders from him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26192,'Greetings!  Do you need something?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26193,'This is all your fault, you know...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26194,'Of all the hair-brained, idiotic, BRAINLESS ideas... \"Yea, Brote, it\'ll be great... the Forsaken will rain gold coins down on our heads!\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26195,'And you know what pisses me off more than anything, Skrotee? No, not that we\'ve been made into a living cuckoo clock for the amusement of the Forsaken. And not that we have to endure being spat upon and mocked every waking minute of our time here... What pisses me off the most is being made to wear these damned short-shorts...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26196,'Pray Skrotee... Find religion... Because if we ever get out of here, you will be wishing you were back in here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26197,'I hope one of us dies. I hope that one is you, Skrotee.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26198,'Not this nonsense again...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26199,'Has it really been an hour?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26200,'If I ever get out of here, I will CRUSH every clock I come in contact with...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26201,'If I ever get out of here, I will CRUSH every clock I come in contact with...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26202,'At the bell\'s toll it will be 12:00am. Midnight to all you scary Forsaken! OOoooo...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26203,'At the bell\'s toll it will be 2:00am. Coincidentally, a perfect time to kill me and end my misery.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26204,'At the bell\'s toll it will be 4:00am. Don\'t you people ever sleep?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26205,'At the bell\'s toll it will be 6:00am *yawn*. Rise and shine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26206,'At the bell\'s toll it will be 8:00am. I\'m sure you\'re all getting back from your morning jogs by now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26207,'At the bell\'s toll it will be 10:00am. It\'s looking like there\'s gonna be more of the green poisonous cloud of death in today\'s weather forecast.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26208,'At the bell\'s toll it will be 12:00pm. Noon for those of you that can\'t count. That\'s right, I\'m looking at you, orcs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26209,'At the bell\'s toll it will be 2:00pm. I want to take this opportunity to let you all know that Middleton\'s got a 2 for 1 sale going on right now! Buy 1 canister of his world famous poisonous biological agents and get the second free!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26210,'At the bell\'s toll it will be 4:00pm. That\'s HAPPY HOUR at Middleton\'s Apothecarium! Come on inside and get poisoned or gased or both for a mere 35 silver!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26211,'At the bell\'s toll it will be 6:00pm. Please kill my brother!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26212,'Ahhh! What be happenin\' to me, mon?','',0,0,0,0,0,0,0,0,1,7145,0,0,26124),
(26213,'Is it my turn?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26214,'Is it lunch time?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26215,'I\'m gonna jump this time, Brote. I swear it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26216,'At the bell\'s toll it will be 1:00am. If I ever break free, I will tear this town apart!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26217,'At the bell\'s toll it will be 3:00am. Time for bed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26218,'At the bell\'s toll it will be 5:00am. End me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26219,'At the bell\'s toll it will be 7:00am. Good morning to all you early risers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26220,'At the bell\'s toll it will be 9:00am. It looks like another beautiful day in Dragonblight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26221,'At the bell\'s toll it will be 11:00am. I want to take this opportunity to welcome all you new murderous, twisted Horde to Venomspite! So welcome, on behalf of me and my brother, Brote.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26222,'At the bell\'s toll it will be 1:00pm. We\'re right in the middle of the lunch time rush! Your poisons, plagues, and noxious gases are delivered in 60 seconds or your order is free!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26223,'At the bell\'s toll it will be 3:00pm. I think I soiled myself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26224,'At the bell\'s toll it will be 5:00pm. To those that may have been keeping score, I did - in fact - soil myself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26225,'At the bell\'s toll it will be 7:00pm. Another productive day at Venomspite comes to a close as night falls upon us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26226,'At the bell\'s toll it will be 9:00pm. Break time for me! I\'ll see you all in 4 hours. Unless one of you kills me in my sleep (please).','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26227,'','That spineless troll has failed me for the last time.  Anthis!  Break his legs!',0,0,0,0,0,0,0,0,1,7217,0,0,26124),
(26228,'At once, my lady!','',0,0,0,0,0,0,0,0,1,7217,0,0,26124),
(26229,'','I\'ve never seen you so eager to cause harm to someone, sister.  Such a pleasant development... very well, go!',0,0,0,0,0,0,0,0,1,7217,0,0,26124),
(26230,'','My liege!  Allow me to go instead.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26231,'','You... half-idiot... what got into you?  Pulling off something like that on her?  Did you think she wouldn\'t notice?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26232,'You\'re late, overseer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26233,'Destiny will not wait. Your craftsmen must increase their production of the war golems before the stone giant leader and his army reach Ulduar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26234,'Tell your rune-smiths to continue converting what stone giants you can. Those that will not submit must be destroyed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26235,'If the stone giants interfere with our work at Ulduar, I will hold you and your thane responsible. Mortals must not be allowed to come to the aid of the giants.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26236,'Return to your duties, overseer. Be certain to impress upon your workers the urgency of their tasks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26237,'My S.T.O.U.T. is more than just a target for throwing steins, it\'s a valuable training asset.  If you can hit S.T.O.U.T. you can probably hit anything!$b$bJust try not to hit me.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26238,'Ringing','Ringing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26239,'Let\'s see if this works.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26240,'Where... where am I?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26241,'Look alive, peasant! We\'ve got to get these structures back up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26242,'That better be finished by the time Prince Arthas returns!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26243,'You\'re gonna have to hammer harder than that, fella! Get a move on!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26244,'Don\'t you wanna go home, peasant? These things aren\'t gonna rebuild themselves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26245,'Attention!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26246,'At ease, lad. The Prince will be back soon and we\'ll be on our way back to Lordaeron.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26247,'You\'re doing a good job, soldier. Prince Arthas would be proud! Keep it up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26248,'When all this is over, I\'m going to recommend you for an Alliance Mark of Honor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26249,'Keep your eyes peeled for any suspicious activity, soldier. I\'ve spotted a few troublemakers mulling about.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26250,'Remain vigilant, soldier. This terrible war will be over soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26251,'You are among the Taunka of Camp Oneqwah, dwarf.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26252,'If you agree to help us against our mutual enemy, you will come to no harm here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26253,'Think about it, prospector, but make up your mind swiftly. We must act soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26254,'I\'ve heard whisperings of intruders.  Be wary.','I\'ve heard whisperings of intruders.  Be wary.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26256,'I sense the taint of this land in you, footman.  Report to the Bishop before the start of your next shift.','I sense the taint of this land in you, footman.  Report to the Bishop before the start of your next shift.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26257,'You stink.  Take a shower.','You stink.  Take a shower.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26258,'All rewards to be paid by High Executor Wroth upon verification.$B$BSerious-minded individuals inquire within.$B$BNO SOLICITORS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26259,'I humbly offer myself to the will of the light.','I humbly offer myself to the will of the light.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26260,'We will ravage the living... I mean the Scourge, of course.\n','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(26261,'Limpy Joe, it\'s you. It\'s really you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26262,'Calm down. I want to you ask you about the iron dwarves and Loken.','Calm down. I want to you ask you about the iron dwarves and Loken.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26263,'What brings you out here, little one?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26264,'What can you tell me about Loken and the iron dwarves?','What can you tell me about Loken and the iron dwarves?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26265,'That\'s not something Limpy Joe would ask! But yeah, I know Loken.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26266,'He\'s out to get me, too! I\'d be careful around here if I was you, traveler. You never know which tree he\'s hiding behind!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26267,'Ah, yes. Loken is well known to me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26268,'It is he who commands the sons of iron in their war against us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26269,'From his hiding place, he oversees their preparations for war with the goal of exterminating the stone giants!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26270,'I humbly offer myself to the Light.','I humbly offer myself to the light.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26271,'It is good that you have come my child.  The Light\'s protection has worn thin on you.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(26272,'It is done.  Serve the Light well.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(26273,'','Schlemiel!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26274,'Huh?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26275,'','Apparently you flubbed this batch of blight. What do you have to say for yourself?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26276,'<The Tuskarr eyes you suspiciously.>$b$bDo not stay long. You do not understand our people, and I don\'t want trouble.','<The Tuskarr eyes you suspiciously.>$b$bDo not stay long. You do not understand our people, and I don\'t want trouble.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26277,'But... I followed your instructions precisely! Sorry?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26278,'','%s sighs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26279,'','Sorry? SORRY?! Here\'s sorry for you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26280,'','Oops. I guess it IS working! That\'s odd.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26281,'Eep!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26282,'The sky is not safe, friend. Be alert!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26283,'No Effect!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26284,'One more beast saved from certain death!','One more beast saved from certain death!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26285,'The Scourge are no match for me, Torp!','The Scourge are no match for me, Torp!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26286,'Delivered as promised, Torp!','Delivered as promised, Torp!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26287,'Return to the field of battle! Ejection imminent!','',0,0,0,0,0,0,0,0,1,7141,0,0,26124),
(26288,'','Do watch your step in the garden of Ysera, mortal. Things are not always as they seem.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(26289,'','I\'m gonna need a cleanup and a new assistant over here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26290,'You need something? Maybe your armor or weapon repaired? Hmm?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(26291,'I need some fresh meat... there hasn\'t been nearly enough blood shed today!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(26292,'About time!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(26293,'Any last words you impure mongrel?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(26294,'On second thought, I don\'t care.  Burn in hell wretch!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(26295,'Hah!  That never gets old.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(26296,'Tell me if this hurts.','Tell me if this hurts.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26297,'I think I\'ve got it this time...','I think I\'ve got it this time...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26298,'Let\'s try this one out...','Let\'s try this one out...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26299,'How\'d that feel?','How\'d that feel?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26300,'Do you think that will get some answers?','Do you think that will get some answers?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26302,'Was that potent enough?','Was that potent enough?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26303,'','Do ye want ta live forever?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26304,'Hmm... ','Hmm... ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26305,'You need more bite.  Do not show our enemies any mercy.','You need more bite.  Do not show our enemies any mercy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26306,'The more pain we can inflict, the quicker we can get our answers.','The more pain we can inflict, the quicker we can get our answers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26307,'What more can you possibly want, $r?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26308,'Aargh!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26309,'Stop!  Please...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26310,'Why are you here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26311,'How can you possibly bring me lower?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26312,'What more can you take away from me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26313,'You\'ve got a darkness in you, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26314,'You aren\'t even asking me questions...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26315,'Are you trying to meet the real me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26316,'You have shown me the face of true evil, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26317,'','Desperate times call for desperate measures, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26318,'Do you have any items I can test?','Do you have any items I can test?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26319,'True, but how far should we push?  At what point are we no better than our enemies?','True, but how far should we push?  At what point are we no better than our enemies?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26320,'True, our enemies would show us no mercy.','True, our enemies would show us no mercy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26321,'Mounts. We need more mounts!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26322,'Mounts. We need more mounts!$B$BOh, you\'re probably here for your pet?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(26323,'','The natural beauty of these hills belies a great darkness below.  Tread carefully, friend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26324,'The outhouse appears to be occupied at the moment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26325,'Be wary, for the plagued tendrils of the Lich King lurk close.','Be wary, for the plagued tendrils of the Lich King lurk close.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(26326,'May the Light purge your infection, brave $n.','May the Light purge your infection, brave $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26327,'My father has gifted me with his battle armor and axe. Soon I put it to good use.','',1,66,0,0,0,0,0,0,1,0,0,0,26124),
(26328,'If you are here to beg for the privilege of working for me, then your company is quite welcome. Otherwise, there is little chance you are of any use to me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26330,'Tell me about yourself.','Tell me about yourself.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26331,'Fortunately, the outhouse is currently vacant.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26332,'Use the outhouse.','Use the outhouse.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26333,'','Our food and drink are in short supply.  I\'m afraid I do not have anything to offer you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26334,'','Thank you for your help, $n.  These frostberries are literally the fruits of your labor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26335,'You were all fools to come to this land!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(26336,'I\'ll consume your flesh and pick my teeth with your bones!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(26337,'You\'re no magnataur!  Where... did you... find... such strength?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26340,'Your women and children are next.  You\'ve failed your pitiful race.','',153,0,0,0,0,0,0,0,1,0,0,0,26124),
(26341,'HELP!','HELP!',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26342,'HELP! HELP!','HELP! HELP!',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26343,'YOU\'LL NEVER CATCH ME, FIENDS!','YOU\'LL NEVER CATCH ME, FIENDS!',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26344,'For the love of the Light, get me out of here!','For the love of the Light, get me out of here!',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26345,'I picked a bad day to stop drinking!','I picked a bad day to stop drinking!',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26346,'THEY\'RE TRYING TO KILL ME! HELP!','THEY\'RE TRYING TO KILL ME! HELP!',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26347,'I\'ll die before I let one of you fiends turn me!','I\'ll die before I let one of you fiends turn me!',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26348,'Where did this all come from! Somebody help!','Where did this all come from! Somebody help!',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26349,'Who woulda thought that we\'d have this problem again? Oh wait, EVERYBODY DID!','Who woulda thought that we\'d have this problem again? Oh wait, EVERYBODY DID!',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26350,'Alright Ben. We\'ve retrieved the amberseeds again. You know the drill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26351,'I know, I know. Back in the bucket....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26352,'BRAIIIIINS!!!','',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26353,'I HUNGERRRRR!!','',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26354,'FEED ME!! FEED ME!!!','',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26355,'NOM NOM NOM!','',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26356,'NO RUN!!! NO MORE RUN!!!!','',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26357,'Thanks for your help, hero!','Thanks for your help, hero!',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26358,'You saved my life! Thanks!','You saved my life! Thanks!',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26359,'Are you sure you know how to fly this thing? Feels a little wobbly.','Are you sure you know how to fly this thing? Feels a little wobbly.',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26360,'I don\'t mean to sound ungrateful, but could you fly a little closer to the ground? I hate heights!','I don\'t mean to sound ungrateful, but could you fly a little closer to the ground? I hate heights!',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26361,'When I learned about my relatives here in the north, I came to learn more.  What I found was warring tribes acting against our very nature.$B$BI have no hope left, $r.  Even great Ursoc has been tainted by this cursed place.$B$BI\'ve lost all hope.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26362,'You are my guardian angel! Like a white knight you flew in from the heavens and lifted me from the pit of damnation!','You are my guardian angel! Like a white knight you flew in from the heavens and lifted me from the pit of damnation!',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26363,'How can I ever repay you for this, friend?','How can I ever repay you for this, friend?',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26364,'I\'m gettin\' a little woozy... Oooooof...','I\'m gettin\' a little woozy... Oooooof...',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26365,'Stealing','Stealing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26366,'Come with me if you want to live.','Come with me if you want to live.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26367,'Get on!','Get on!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26368,'Take my hand, villager!','Take my hand, villager!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26369,'I am here to save you, friend!','I am here to save you, friend!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26370,'Get on the back of my gryphon, citizen!','Get on the back of my gryphon, citizen!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26371,'Hurry! Climb aboard!','Hurry! Climb aboard!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26372,'Return to Wintergarde or the Carrion Fields or your gryphon will drop you!','',0,0,0,0,0,0,0,0,0,7161,0,0,26124),
(26373,'Stay behind me, $r.  I will do my best to protect you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26374,'My freedom means nothing if we fail to save Ursoc.  Make haste, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26375,'I will watch over you and your allies, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26376,'Assume your druidic bear form, Tur.','Assume your druidic bear form, Tur.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26377,'Help us subdue him.','Help us subdue him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26378,'We could use a healer.','We could use a healer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26379,'We have the purified ashes of Vordrassil\'s sapling.  If we can subdue Ursoc, we might be able to heal his soul.','We have the purified ashes of Vordrassil\'s sapling.  If we can subdue Ursoc, we might be able to heal his soul.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26380,'Yes... I sense Vordrassil\'s magic... free of any perceivable taint.$B$BPlease!  You must allow me to help you.  Fate brought me here, perhaps I can serve a purpose yet!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26381,'Safe at last! Thank you, stranger!','Safe at last! Thank you, stranger!',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26382,'HURRAY!','HURRAY!',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26383,'Kindness is not lost with this one, Urik. Thank you, hero!','Kindness is not lost with this one, Urik. Thank you, hero!',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26384,'We made it! We actually made it!','We made it! We actually made it!',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26385,'My shop\'s doors will always be open to you, friend.','My shop\'s doors will always be open to you, friend.',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(26386,'','We will never forget your bravery, $n. You are always welcome in Wintergarde.$B$BWould you like to make this inn your home?',1,2,0,0,3,0,0,0,1,0,0,0,26124),
(26387,'I would like to browse your goods, Illusia.','I would like to browse your goods, Illusia.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26388,'Zybarus thanks you from the bottom of his heart, hero. Without you, Zybarus would have died, or worse, Zybarus would have become one of them...','',2,1,0,0,0,0,0,0,1,0,0,0,26124),
(26389,'The %s moans but seems otherwise unaffected by the blight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26390,'Your protection is strong, child.  Continue your work.','Your protection is strong, child.  Continue your work.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26391,'You require the Bishop\'s blessing.  Go to him soon.','You require the Bishop\'s blessing.  Go to him soon.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26392,'Remain on the pure path.  The Light will protect you.','Remain on the pure path.  The Light will protect you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26393,'You are impure!','You are impure!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26394,'Die, cur!','Die, cur!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26395,'Be washed from my sight!','Be washed from my sight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26396,'By the Light!','By the Light!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26397,'Wretch!','Wretch!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26398,'Defiler!','Defiler!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26399,'Abbendis will see you purged!','Abbendis will see you purged!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26400,'You were a fool to come here.','You were a fool to come here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26401,'You will be cleansed!','You will be cleansed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26402,'In the name of the Light!','In the name of the Light!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26403,'By the Light!','By the Light!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26404,'Be purified by steel!','Be purified by steel!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26405,'How dare you interrupt our righteous work?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26406,'A rune on %s begins to glow brightly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26407,'I once roamed the Grizzly Hills, son to the great Ursoc, who ruled over this land.$B$BBut now... now I\'m doomed to spend the rest of my life in this cave.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26408,'You\'re free to go Orsonn, but first tell me what\'s wrong with the furbolg.','You\'re free to go Orsonn, but first tell me what\'s wrong with the furbolg.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26409,'You don\'t understand.  If I wanted to I could fight my way out of this cave.$B$BIt\'s my father, Ursoc.  He has returned from the dead... but he\'s not the same.$B$BHe gave his life during the War of the Ancients thousands of years ago.  For centuries, the furbolg who worshipped him tried to devise a way to resurrect him.$B$BFinally they decided they were to attempt to regrow the failed world tree, Vordrassil, and use its magic to bring back my father.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26410,'','Keep your voice down, $c. I\'m in disguise and spying for Venomspite.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26411,'What happened then?','What happened then?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26412,'The sapling they grew bore a fruit.  At first it seemed to work.  Ursoc did come back and I was filled with joy for a brief moment.$B$BAs he recovered, it was clear that he wasn\'t the same.  Neither were the furbolg.$B$BWhatever evil caused the ancient druids to tear down Vordrassil manifested itself in the new tree and turned them all into monsters filled with bloodlust.$B$BThe thing that now walks the Grizzly Hills is not my father and it must be put to rest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26413,'Thank you, Son of Ursoc.  I\'ll see what can be done.','Thank you, Son of Ursoc.  I\'ll see what can be done.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26414,'I am Kodian, daughter of Ursoc.  I watch over this once sacred shrine.$B$BI\'ve not seen a stranger come here in a long time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26415,'Who was this stranger?','Who was this stranger?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26416,'A furbolg named Tur Ragepaw.  Not one of ours.$B$BThis one came from the southern lands.  He was of the Timbermaw tribe.$B$BHe wanted to see Ursoc.  He seemed to think that Vordrassil\'s taint could be purified and used to save my father.$B$BIt is foolish to entertain such hopes.  You will agree when you see the darkness that has afflicted him like I have.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26417,'Thank you, Kodian.  I\'ll do what I can.','Thank you, Kodian.  I\'ll do what I can.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26418,'My beautiful mill. You! You\'ll die for this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26419,'Go with the Light, friend.','Go with the Light, friend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26420,'May the Light have mercy on your soul, fiend.','May the Light have mercy on your soul, fiend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26421,'They were once people... Now? Undead monsters with an appetite for flesh!','They were once people... Now? Undead monsters with an appetite for flesh!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26422,'Ooooh! I think that one\'s head exploded!','Ooooh! I think that one\'s head exploded!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26423,'Light take you!','Light take you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26424,'%s clears a jam from his rifle.','%s clears a jam from his rifle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26425,'Finally, a worthy offering!','',0,0,0,0,0,0,0,0,1,7145,0,0,26124),
(26426,'Filthy cretin. Your kind doesn\'t deserve to live. Have at thee!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26427,'Ursoc, brother of Ursol and guardian of the furbolg tribes... show yourself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26428,'Hey Celidh!  Do you have any pets you want me to take over to the stable?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26429,'Sure is busy here Celidh.  Do you have any pets you want me to move to the stables?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26430,'I bet with all these new people here, Celidh, you\'ve got to have some pets you want me to move to the stables.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26431,'C\'mon boy, let\'s get you away from all this noise.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26432,'Let\'s go boy.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26433,'This way, boy.  I\'ll take you to our nice stables in the back.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26434,'It sure is bright out here... and flat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26435,'Tell me how to make those carrots!','Tell me how to make those carrots!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26436,'I thank you all.  The druids of old were wise to tear down Vordrassil, for its roots seep deep into the dwelling of an ancient evil. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26437,'You know their kind as old gods.  Beware Yogg-Saron, the beast with a thousand maws.  His evil extends beyond Vordrassil\'s roots.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26438,'','Think you could get me out of here, $c?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(26439,'I\'m afraid not, Schneider. Your time has come!','I\'m afraid not, Schneider. Your time has come!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26440,'Oh good, you\'re here to rescue me. Now let me out of here!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(26441,'Not today, senior scrivener!','Not today, senior scrivener!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26442,'Hey, $g buddy : ma\'am;. I\'ve seen you around.$B$BMind getting me out of here?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26443,'Afraid not. Your days as a sanitation engineer are coming to an end.','Afraid not. Your days as a sanitation engineer are coming to an end.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26444,'Attack now, my minions! Your master commands it!','',0,0,0,0,0,0,0,0,1,7235,0,0,26124),
(26445,'End this mortal affront to the Lich King!','',0,0,0,0,0,0,0,0,1,7235,0,0,26124),
(26446,'Their defenses are down! The time is now, minions! ATTACK!','',0,0,0,0,0,0,0,0,1,7235,0,0,26124),
(26447,'I don\'t know what happened. I had just arrived at Venomspite and then all of a sudden I woke up in this cage!$B$BAre you here to rescue me?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(26448,'No, chancellor, I wouldn\'t say that I\'m here to \'rescue\' you, per se.','No, chancellor, I wouldn\'t say that I\'m here to \'rescue\' you, per se.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26449,'','What do you mean my time has come?! I\'ll kill you where you stand!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26450,'You can\'t possibly mean to.... I\'ll write you up for this, $c!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26451,'','Hey, over here!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26452,'If you\'d be so kind, please let me out of here!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26453,'Can someone let me out of here? I need to get back to Venomspite and finish my shift.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26454,'No! I beg you! Please don\'t kill me!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26455,'Legion, to the front lines!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26456,'Reinforce the gate! Do not let the Scourge through!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26457,'Hold the line! Legion, focus fire at the gates!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26458,'What is the meaning of this?! Stop! I\'ll double whatever they\'re paying you!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26459,'I just arrived in Venomspite. How could I have possibly wronged you?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26460,'','Greetings, $c.$B$BHow may I help you?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26461,'Thane Torvald Eriksson\'s temperamental proto-drake is chained up here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26462,'Unchain and control Flamebringer.','Unchain and control Flamebringer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26463,'Yes? What is it?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(26464,'Rise my warriors and fight for your new liege!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26467,'Thank you, kind soul.','Thank you, kind soul.',0,0,0,0,0,0,0,7,1,7168,0,0,26124),
(26468,'I\'ll never forget you, friend.','I\'ll never forget you, friend.',0,0,0,0,0,0,0,7,1,7168,0,0,26124),
(26469,'Finally! A hero has come!','Finally! A hero has come!',0,0,0,0,0,0,0,7,1,7168,0,0,26124),
(26470,'Good of you to come, champion! The beast almost had me!','Good of you to come, champion! The beast almost had me!',0,0,0,0,0,0,0,7,1,7168,0,0,26124),
(26471,'Annihilate them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26472,'Come to play?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26473,'Please enjoy their company, the Lich King sends his regards!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26474,'Don\'t be so quick to escape! I have a parting gift....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26475,'See this statue, boy?  This is the king of Stormwind, Varian Wrynn.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26476,'His son, Anduin Wrynn, was the king for a while.  He\'s about my age too.  Can you imagine if I were the king?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26477,'People used to come up to me because they thought I was the king.  I guess we look alike...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26478,'If I were king, I\'d have a horse like you.  I\'d make sure you didn\'t get lost, and I bet you\'d make sure I never got lost.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26479,'We\'d be best friends.  I bet me and Anduin would also be best friends, too.  Friends are important.  ','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26480,'Ow! I\'ll tell you NOTHING, filthy $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26481,'Wait... WAIT! What is it that you want to know?! I know you\'re the $c named $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26482,'OW...NO! We know that you\'ve been stealing our armor and weapons and horses!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26483,'We know... that you don\'t... know why we\'re immune... to your so-called blight. Grand Admiral Westwind somehow gave the high abbot that prayer. I beg you... no more... please?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26484,'AHHHHHHHHH! Please... we know... that you... have a spy... disguised as... one of us! There... that\'s all that I know. Please... mercy... STOP!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26486,'I\'ll take you to some other horses.  You probably miss being around other horses.  They can be your friend too.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26487,'Did that seem okay?','Did that seem okay?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26488,'This is harder than it looks.','This is harder than it looks.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26489,'This isn\'t easy.','This isn\'t easy.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26490,'I think I\'m starting to get the hang of this.','I think I\'m starting to get the hang of this.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26491,'My arm is getting sore.','My arm is getting sore.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26492,'Hmm....','Hmm....',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26493,'I\'m just nervous.  Sorry.','I\'m just nervous.  Sorry.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26494,'I just don\'t want to let anyone down.','I just don\'t want to let anyone down.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26495,'I need to do something to keep myself busy.','I need to do something to keep myself busy.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26496,'I TOLD YOU... I don\'t know... anything... else!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26497,'You aren\'t going to let me sleep are you?','You aren\'t going to let me sleep are you?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26498,'Please... stop. I\'ll do... anything....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26499,'Just... end it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26500,'Could you try to be a little quieter?','Could you try to be a little quieter?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26501,'They all... begged... for their... lives!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26502,'Are you going to be doing this for much longer?','Are you going to be doing this for much longer?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26503,'Every two years the Spirits of Competition grow especially fervent... and now is that time! We wear this tabard into the Battlegrounds to honor them, seeking to defeat our enemies and earn their favor.','Every two years the Spirits of Competition grow especially fervent... and now is that time! We wear this tabard into the Battlegrounds to honor them, seeking to defeat our enemies and earn their favor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26504,'I beg you... no more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26505,'THIS IS TORTURE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26506,'You won\'t get... anything else... out of me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26507,'OWWWWWWWW!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26508,'How do I earn a Competitor\'s Tabard?','How do I earn a Competitor\'s Tabard?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26509,'How can I gain the favor of a Spirit of Competition?','How can I gain the favor of a Spirit of Competition?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26510,'You need only face our rivals in any of the Battlegrounds. Win or lose, if you stay for the duration of the battle, you will be mailed a Competitor\'s Tabard.','You need only face our rivals in any of the Battlegrounds. Win or lose, if you stay for the duration of the battle, you will be mailed a Competitor\'s Tabard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26511,'You must defeat our rivals in any of the Battlegrounds. With every victory, there is a chance that a Gold Medallion will be mailed to you.','You must defeat our rivals in any of the Battlegrounds. With every victory, there is a chance that a Gold Medallion will be mailed to you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26512,'You know of the Spirits of Competition, yes?$B$BEvery two years they draw close to the mortal realm. During such times, members of both the Alliance and Horde wear Competitor\'s Tabards into the Battlegrounds to honor the spirits, seeking to defeat one another and earn their favor.$B$BI stockpile souvenirs from such turbulent times. If you\'ve learned the proper word, I might be convinced to part with one...','You know of the Spirits of Competition, yes?$B$BEvery two years they draw close to the mortal realm. During such times, members of both the Alliance and Horde wear Competitor\'s Tabards into the Battlegrounds to honor the spirits, seeking to defeat one another and earn their favor.$B$BI stockpile souvenirs from such turbulent times. If you\'ve learned the proper word, I might be convinced to part with one...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26513,'I would like to enter the secret code to receive my Competitor\'s Souvenir.','I would like to enter the secret code to receive my Competitor\'s Souvenir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26514,'Rise and fight! Kill the living! [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26515,'We must kill these intruders! [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26516,'Go my warrior! Slay the living! [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26517,'Go forth my little pet, kill these mongrels and feast on their flesh! [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26518,'','We are quickly learning the price of death in this frigid wasteland, $n. The Lich King\'s power extends across every inch of Northrend, permeating into the earth itself! He turns our own fallen people against us.$B$BFrom the sky, risen gryphon riders rain down their vengeful stormhammers as the walking dead assail us on the ground.\n',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(26519,'Krenna must doubt my abilities. While our elite warriors march out to face the Alliance and their trapper allies, or wreak havoc among the trolls, I\'ve been assigned to mop up those pesky Dragonflayer vrykul.$B$BPerhaps if we combine our efforts, we can both prove ourselves in the conqueror\'s sight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26520,'Welcome to Amberpine Lodge, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26521,'','You\'re such a sweet lad.  Here, take this horse over to your stable.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26522,'','All these folks are keeping me busy.  Take this horse over to your stables.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26523,'','Here\'s a fine one for you.  Take good care of him.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26524,'','Here, take this horse over to your stable.  Tell Ronald, \"Hello.\"',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26525,'Where is Senior Scrivener Barriga being held?','Where is Senior Scrivener Barriga being held?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26526,'I think they put him in a cage over near the lumbermill.','I think they put him in a cage over near the lumbermill.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26527,'Did you see where they took Sanitation Engineer Burke?','Did you see where they took Sanitation Engineer Burke?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26528,'You must defeat your rivals in any of the Battlegrounds. With every victory, there is a chance that a Gold Medallion will be mailed to you.','You must defeat your rivals in any of the Battlegrounds. With every victory, there is a chance that a Gold Medallion will be mailed to you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26529,'I think he\'s on the south side of the abbey.','I think he\'s on the south side of the abbey.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26530,'You need only face your rivals in any of the Battlegrounds. Win or lose, if you stay for the duration of the battle, you will be mailed a Competitor\'s Tabard.','You need only face your rivals in any of the Battlegrounds. Win or lose, if you stay for the duration of the battle, you will be mailed a Competitor\'s Tabard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26531,'Every two years the Spirits of Competition grow especially fervent... and now is that time! Both Alliance and Horde wear this tabard into the Battlegrounds to honor the spirits, seeking to defeat all enemies and earn their favor.','Every two years the Spirits of Competition grow especially fervent... and now is that time! Both Alliance and Horde wear this tabard into the Battlegrounds to honor the spirits, seeking to defeat all enemies and earn their favor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26532,'Any idea where they\'re keeping Deathguard Schneider?','Any idea where they\'re keeping Deathguard Schneider?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26533,'I think they have her down near the gallows.','I think they have her down near the gallows.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26534,'Can you tell me where they have Chancellor Amai caged?','Can you tell me where they have Chancellor Amai caged?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26535,'I think I saw them take him over by the north side of the abbey, near the archery targets.','I think I saw them take him over by the north side of the abbey, near the archery targets.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26536,'','%s flees back to its den....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26537,'Backup! We need backup!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26538,'Help mon! There\'s too many of dem!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26539,'You don\'t even know, do you?  The trappers?  They\'re not human... we have to get out of here!  Come, quick!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26540,'Take Ducal\'s horse, he\'s one of them now!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26541,'What\'s going on here, sarge?','What\'s going on here, sarge?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26542,'I don\'t know. Better kill them both to be on the safe side!','I don\'t know. Better kill them both to be on the safe side!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26543,'HELP! HELP! THIS $g MAN : WOMAN; HAS STOLEN MY IMAGE!','HELP! HELP! THIS $g MAN : WOMAN; HAS STOLEN MY IMAGE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26544,'I know why you\'ve come - one of those foolish Magnataur on the plains meddled and managed to get the dragons involved.  Do you enjoy serving them like a dog?','I know why you\'ve come - one of those foolish Magnataur on the plains meddled and managed to get the dragons involved.  Do you enjoy serving them like a dog?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26545,'The mine is lost. All of our defenders have perished and the miners resurrected as Scourge aberrations!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26546,'Flamebringer attempts to throw you from his back. Return to Voldrune!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(26547,'Foolish errand $G boy:girl;... you will die for interrupting my work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26548,'It does get worse, old friend. According to my calculations, without suitable materials to repair our parapets, the walls protecting this keep will crumble in twelve hours.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26549,'Grim news, my pint-sized companion. Should we suffer a defeat here the ramifications will be felt across this frozen wasteland. Lord Fordragon and our armies at the Wrathgate will be defenseless against an assault from Naxxramas.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26550,'We have been through worse and survived, Leoric. Do not forget Hyjal...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26551,'Yes, yes, I haven\'t forgotten Hyjal, or Silithus, or the march of the Legion, or every other damnable confrontation the 7th Legion has faced. It... I don\'t want the soldiers to hear this, Two-bit, but for the first time in my life...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26552,'Say no more, Leoric. We all feel the chill in our bones. Yet, each day, heroes arrive from across the world - and beyond.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26553,'I have heard whisperings from the east that our esteemed Scarab Lord has joined the battle, as have entire batallions from Shattrath: heroes blessed by A\'dal himself, granted rank as Hand of A\'dal!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26554,'You are right, of course, old friend. Let us hope that these heroes arrive soon.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26555,'No... NO! What have you done?! So many ancient wyrms wasted... what magic could do this? ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26556,'The Spirits of Competition have grown strong again.','The Spirits of Competition have grown strong again.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26557,'The Battlegrounds are full of eager competitors today.','The Battlegrounds are full of eager competitors today.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26558,'The battlemasters are pleased with how many are coming to compete.','The battlemasters are pleased with how many are coming to compete.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26559,'I\'m proud to have earned my Competitor\'s Tabard, and seek a Gold Medallion next.','I\'m proud to have earned my Competitor\'s Tabard, and seek a Gold Medallion next.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26560,'The Spirits of Competition have grown strong again.','The Spirits of Competition have grown strong again.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26561,'The Battlegrounds are full of eager competitors today.','The Battlegrounds are full of eager competitors today.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26562,'The battlemasters are pleased with how many are coming to compete.','The battlemasters are pleased with how many are coming to compete.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26563,'I\'m proud to have earned my Competitor\'s Tabard, and seek a Gold Medallion next.','I\'m proud to have earned my Competitor\'s Tabard, and seek a Gold Medallion next.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26564,'The Spirits of Competition have grown strong again.','The Spirits of Competition have grown strong again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26565,'The Battlegrounds are full of eager competitors today.','The Battlegrounds are full of eager competitors today.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26566,'The battlemasters are pleased with how many are coming to compete.','The battlemasters are pleased with how many are coming to compete.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26567,'I\'m proud to have earned my Competitor\'s Tabard, and seek a Gold Medallion next.','I\'m proud to have earned my Competitor\'s Tabard, and seek a Gold Medallion next.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26568,'You are a black wyrm no longer.  Go... go and serve the Scourge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26569,'Greetings, $c.$b$bYou want Darrok to send you to Venture Bay?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26570,'Yes, I am ready to travel to Venture Bay!','Yes, I am ready to travel to Venture Bay!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26571,'The Destructive Ward has been destroyed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26572,'Me hungry.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26573,'Me sleepy.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26574,'Me cold.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26575,'Me scared of bug things.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26576,'Me got stuck in sticky bug rope.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26577,'Me no like rock place full of bugs.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26578,'Me no like new cold place.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26582,'Ha ha.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26583,'That funny.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26584,'Ow.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26585,'Stop it!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26586,'That hurt.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26587,'What that sound?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26588,'Your head like rock.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26589,'It time for work! Zug zug!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26590,'What? Can\'t you see that I\'m busy here?$B$BYou think this transmatter is going to fix itself?!','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(26594,'Highlord Bolvar Fordragon fights for us all, newcomer. Were it not for him, Arthas would be sitting upon the throne of Stormwind right this very moment.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(26595,'I am so very close to figuring this ore out. Any minute now and I will have the solution!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26596,'You are being misled! The Onslaught is all lies! The Scourge and the Forsaken are not our enemies! Wake up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26597,'High General Abbendis personally told me that it was a mistake to come north and that we\'re doomed! I urge you all to lay down your weapons and leave before it\'s too late!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26598,'Renounce the Scarlet Onslaught! Don\'t listen to the lies of the high general and the grand admiral any longer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26599,'Abbendis is nothing but a harlot and Grand Admiral Westwind is selling her cheap like he sold us out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26600,'The bot will adjust its speed to match your own. I would suggest you mount up to speed things along. By the way, the bot was put together with salvaged components from a pile of scrap metal delivered to me from Outland. There were some side effects.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26601,'The Destructive Ward gains in power.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26602,'The Destructive Ward is fully charged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26603,'Quarterflash, I need another homing bot.','Quarterflash, I need another homing bot.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26604,'\'Ello, $c!$b$bYa ready ta head on down to Venture Bay and crack some Horde skulls?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26605,'Yes, I am ready to travel to Venture Bay!','Yes, I am ready to travel to Venture Bay!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26606,'Perfect.  As long as you don\'t go hacking and slashing your way through, they\'ll never know the difference.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26607,'%s rises from the floor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26608,'Boys, go see who\'s doing that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26609,'Yes, your eminence. Come on!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26610,'Hey, who rang the bell?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26611,'The bodyguard grunts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26612,'Yes, my $g son : daughter;?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(26613,'I am busy, my child. Come back in a moment and we will speak.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26614,'Your eminence, may I have a word in private?','Your eminence, may I have a word in private?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26615,'<The high abbot studies you a moment and then smiles.>$B$BVery well, I know a place, child. You just kiss my ring and let me know when you are ready.','',1,0,0,1000,0,0,0,0,1,0,0,0,26124),
(26616,'I am ready, your grace. <kiss the ring>','I am ready, your grace. <kiss the ring>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26617,'Then meet me at the entrance to the abbey. I\'ll be along in short order.','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(26618,'','The nerubian siege outside is chilling, Sagai. There seems to be no end to them.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26619,'Yah. It be dem sinkholes. You see dem? Dere be talk of blowin\' dem up, cavin\' dem in.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26620,'','That\'s right... I recovered munitions from the quarry just yesterday for that purpose.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26621,'','I hope the charges are set soon. Everyone could use a respite.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26622,'You got dat right.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26623,'','Saurfang is here, Sagai! Saurfang! The brother of Broxigar himself, here to aid our efforts!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26624,'I\'ve played my part in destroying entire civilizations... to have to lower myself to dealing with the wretched Cult of the Damned disgusts me.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26625,'Agent Skully, I need you to use the banshee\'s magic mirror on me again!','Agent Skully, I need you to use the banshee\'s magic mirror on me again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26626,'','Fine, but be more careful with it this time!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(26627,'It appears they are using those runes to deposit some of the power they\'ve drained.','',0,0,0,0,0,0,0,0,1,7303,0,0,26124),
(26628,'Geist... disgusting. The Cult has infested this place.','',0,0,0,0,0,0,0,0,1,7302,0,0,26124),
(26629,'I know a place nearby where we can speak in private, my child. Follow me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26630,'I had hoped my suspicions were incorrect... they\'re resurrecting magmawyrms.  Come back to me immediately, it is time to purge this place of the Cult.','',0,0,0,0,0,0,0,0,1,7304,0,0,26124),
(26631,'Did you think that I could not see through your flimsy disguise, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26632,'There is much that you do not understand, $r. The Master sees all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26633,'He told me that you would come for me. I won\'t die by your hand, though. I have seen what you have done to my compatriots.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26634,'No. I will leave this world in a manner of my own choosing. And I will return, the grand admiral\'s will permitting!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26635,'','Keep your voice down. We wouldn\'t want to attract any attention from these beasties!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26636,'AAAEEEEIIIiiiiiiiiiiiiiiiiiiiiiiiiiiii........................................','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26637,'Gah! What are you doing?','Gah! What are you doing?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26638,'A member of the priesthood whom I\'ve never seen before.','A member of the priesthood whom I\'ve never seen before.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26639,'By the Light, you killed Limpy Joe and took the meat! How did you know where to find us?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26640,'Were you bitten?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26641,'Answer me!  Were you bloody bitten?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26642,'Well, if you\'ve come to kill me, too, can you at least wait until I\'ve fed Griselda? Poor girl hasn\'t eaten in days.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26643,'Here, girl. I\'ve got one last meal for you before Limpy Joe\'s killer does us in!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26644,'There\'s lamp oil in the back - make use of it.  The fiends hate fire!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26645,'How could you kill poor, defenseless old Joe? And why did you bring the meat back?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26646,'You\'re an enigma, that\'s what you are... And let me tell you, enigmas and I don\'t get along....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26647,'I think you\'d best leave before Griselda decides she\'s in the mood for dessert.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26648,'With the orb returned, the search for answers begins!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26649,'Don\'t bother me with trifles!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26650,'Show mercy!','Show mercy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26651,'I was just doing what I was told.  Please...','I was just doing what I was told.  Please...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26652,'This is not how I was supposed to die!','This is not how I was supposed to die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26653,'You win.  Please, just let me go.','You win.  Please, just let me go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26654,'Have pity...','Have pity...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26655,'The Grand Admiral himself has come to see to our dedication.  If I see you slacking on your post again, I will gut you myself.','The Grand Admiral himself has come to see to our dedication.  If I see you slacking on your post again, I will gut you myself.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(26656,'Thank you, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26657,'Ahh.... better.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26658,'Back to the fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26659,'Whoa - I nearly died there. Thank you, $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26660,'Can\'t you see that I\'m busy! We\'ll never have this base ready in time for the Prince\'s return!','',396,5,0,0,0,0,0,0,1,0,0,0,26124),
(26661,'If it weren\'t for those damned beasts burning our ships, we\'d have been home by now. Now leave me alone so I can get back to work!','',396,396,5,0,0,0,0,0,1,0,0,0,26124),
(26662,'The Argent Crusade is here in force, friend. We weren\'t going to let you have all the glory!','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(26663,'Orik, I need another murkweed elixir.','Orik, I need another murkweed elixir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26664,'Sorry to have bothered you, friend. Carry on!','Sorry to have bothered you, friend. Carry on!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26665,'You dare invade Magnataur lands?  Bonesunder gladly smash you and take your limbs as payment!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26666,'Cower before me, runt!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26667,'Good!  I do so like my food fresh and lively.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26668,'I can smell your fear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26669,'This is not the end... death only... strengthens... ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26670,'Those damned peasants need to work faster! I wanna get back home to Ironforge. I surely do miss my wife and children. ','',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(26671,'The cap\'n says that as soon as Prince Arthas returns we\'ll be on our way back to Lordaeron.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(26672,'I don\'t know what could be takin\' the young prince so long, but I don\'t think we can hold out for much longer. The cold is gettin\' to some of the soldiers.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(26673,'I\'m sure Arthas will be back any day now, soldier. Keep your chin up!','I\'m sure Arthas will be back any day now, soldier. Keep your chin up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26674,'When we saw that the ships had been burned by those savage beasts our hearts sank. Never have I felt so helpless...','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(26675,'Rage. That\'s how I can sum up my feelings towards this whole mess. We worked our fingers to the bone trying to get through the woods to the shore only to find that we were too late. Our only way home had been destroyed.','',1,1,5,0,0,0,0,0,1,0,0,0,26124),
(26676,'Despite the hardships we\'ve had to go through in this wasteland, I believe that the young prince will see us to victory. I pray each night for his safety.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(26677,'I must be going now, soldier. Stay vigilant!','I must be going now, soldier. Stay vigilant!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26678,'<Forgotten footman shakes his head.>$B$BWe can\'t keep this up, friend. If Prince Arthas doesn\'t return soon we will all perish.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(26679,'We\'ll never get these ships ready in time. The winter comes and with it our doom. I fear that the young prince has damned us all.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(26680,'Arthas and Muradin have been gone a long time. I hope they aren\'t in danger.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(26681,'I\'m sure everything will work out, footman.','I\'m sure everything will work out, footman.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(26682,'Bless you, friend. I nearly expired....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26683,'Thank you, $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26684,'I\'d nearly given up. You\'ve given me new life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26685,'Without your help, I surely would have died....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26686,'NOOOOO! Mother! We\'ll avenge you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26687,'A skunk, rabbit, and a fawn travelling together.  Now that\'s something you don\'t see every day.  No matter, I\'ll be dining on venison tonight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26688,'Yah. Hellscream, he be a fierce one, but too eager to prove himself, I be thinkin\'. It be good Saurfang be here, for sure.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26689,'Where can I send ya to today?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(26690,'','Saurfang is here, Sagai! Saurfang! The brother of Broxigar himself, here to aid our efforts!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26691,'Huntin time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26692,'A good club can make all the difference in the world.','A good club can make all the difference in the world.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26693,'I\'d like to buy this month\'s brew.','I\'d like to buy this month\'s brew.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26694,'Hey there friend!  I see you\'ve got some Brewfest tokens.  As it happens, I still have some Brewfest items for sale.','Hey there friend!  I see you\'ve got some Brewfest tokens.  As it happens, I still have some Brewfest items for sale.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26695,'What do you have for me?','What do you have for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26696,'Yo Ding-Dong.  Ding-Dong man.  Ding-dong.  Yo!','Yo Ding-Dong.  Ding-Dong.  Ding-dong yo!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26697,'I need to get to Wintergarde Keep fast!','I need to get to Wintergarde Keep fast!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26698,'Howdy, $r!$b$bIf you\'re lookin\' for a shredder to ride, you\'ll need to head on up into the hills.$b$bThis one\'s out of commission.','',70,396,396,0,0,0,0,0,1,0,0,0,26124),
(26699,'Key? What key?','Key? What key?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26700,'Why, the refurbished shredder key, silly!$b$bIf you haven\'t already gotten one today you can talk to my brother, Synipus.','',5,396,0,0,0,0,0,0,1,0,0,0,26124),
(26701,'A good brew, is a strong brew.','A good brew, is a strong brew.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26702,'Where can I find this brother of yours?','Where can I find this brother of yours?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26703,'Why would I want to ride a shredder?','Why would I want to ride a shredder?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26704,'Well, before all the hostilities broke out here we were fixing them up to harvest the local trees.$b$bLately, though, they\'ve been forced into service against the Horde. Turns out they make for a pretty fine fighting machine. If you\'ve got a key, you\'d be silly not to use it!','',6,5,396,0,0,0,0,0,1,0,0,0,26124),
(26705,'It\'s great bein\' a member of da \"Brew of the Month\" club.','It\'s great bein\' a member of da \"Brew of the Month\" club.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26706,'Where can I get a Refurbished Shredder Key?','Where can I get a Refurbished Shredder Key?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26707,'Why, up the river of course!$b$bHaha! Up the river... Okay, okay, you can find him working on shredders up at Blue Sky Logging Ground.$b$bOh, and you can tell him that if he sends me any more half-finished shredders he WILL be up a river!','',5,153,396,0,0,0,0,0,1,0,0,0,26124),
(26708,'My brother, Synipus has lots of them. You should head up north to Blue Sky Logging Grounds and talk to him.','',153,396,396,0,0,0,0,0,1,0,0,0,26124),
(26709,'I apologize, emissary, but the prince is away on an errand. What brings you to this desolate place?\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26710,'By royal edict, you men are to return to Lordaeron immediately. Lord Uther has convinced the king to recall this expedition.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26711,'We\'re to just pick up and leave?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26712,'That\'s correct. My men report that the roads from here to the shore are held by the undead. You\'ll need to find an alternate route back to your ships.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26713,'To hell with the undead! We\'ll cut our way through the woods, men!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26714,'Captain, why are the guards not at their posts?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26715,'Well, milord, your father had our troops recalled at Lord Uther\'s request.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26716,'Uther had my troops recalled? Damn it! If my warriors abandon me, I\'ll never defeat Mal\'Ganis. The ships must be burned before the men reach the shore!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26717,'Isn\'t that a bit much, lad?\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26718,'Burned down to their frames! No one goes home until our job here is done!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26719,'','Stop!  Put that knife away.  You don\'t have to do... whatever they sent you to do.  You\'re not like them yet!',0,0,0,0,0,0,0,0,1,7196,0,0,26124),
(26720,'What\'s this now? Perhaps Prince Arthas returns to us today!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26721,'Look alive, lads! Today might be the day we leave this cursed land! O\' sweet Ironforge, how I missed ya!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26722,'NOOOOOOO!!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26723,'You lying wretch, Arthas! You doomed us all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26724,'Our prince has forsaken us! All is lost!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26725,'You gave us your word, betrayer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26726,'Our lives were worth far more than your blood feud...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26727,'But why?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26728,'It was all lies...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26729,'May your soul be torn asunder by the very thing you hate most, young prince.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26730,'','Thank you.  I... I should get going now.',0,0,0,0,0,0,0,0,1,7197,0,0,26124),
(26731,'You lied to your men and betrayed the mercenaries who fought for you. What\'s happening to you, Arthas? Is vengeance all that\'s important to you?\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26732,'Spare me, Muradin. You weren\'t there to see what Mal\'Ganis did to my homeland.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26733,'With enough tokens you can join the \"Brew of the Month\" club.  Being in the Brew of the Month club is like having Brewfest all year round!$b$bEvery month you will receive mail with a new brew to try out.  If you like that brew, you can go to the Stonefire Tavern in Ironforge and buy more from the vendors there.  ','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26734,'Brew of the Month Club','Brew of the Month Club',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26735,'Bring the fight to the enemy, men!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26736,'Don\'t let those dirty orcs take the harbor!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26737,'Show no mercy!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26738,'','Show the enemy no mercy! This port will be ours!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26739,'','Kill those Alliance dogs before they can regroup!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26740,'','Fight for the glory of the Horde!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26741,'Rest easy mon. [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26742,'Take it easy, let the light heal you. [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26743,'I will heal your wounds as best as I can. [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26744,'With enough tokens you can join the \"Brew of the Month\" club.  Being in the Brew of the Month club is like having Brewfest all year round!$b$bEvery month you will receive mail with a new brew to try out.  If you like that brew, you can go to the Darkbriar Lodge in Orgrimmar\'s Valley of Spirits and buy more from the vendors there.  ','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26745,'%s raises his talons menacingly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26746,'Things seem to be going well.','Things seem to be going well.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26747,'Impressive. The master said that you and your people would be a nuisance. No matter, your end draws near. Soon the combined might of Naxxramas will come down upon this place and shatter your meager existence.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26748,'Where do you think you\'re going with that, mortal? Put the tome down and I might spare you an eternity of anguish.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26749,'Soldiers of the frozen wastes, rise and hear the call of your master! Do not let $n escape with the tome!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26750,'Tome not yours...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26751,'Give... me... book...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26752,'%s looks at the gathered crowd and nods his head ponderously.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26753,'Join us...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26754,'Only ruin awaits...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26755,'The tide has brought me a story. Listen, and be enlightened.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26756,'Thel\'zan will have you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26757,'Through sunsets beyond counting, the tusked people have dwelled here in the land of ice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26758,'We have lived on the bounty of the sea. We have grown fat on the meat of the antlered ones.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26759,'The sea and the land has given us life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26760,'Some seek to take the sea from us. The giant raiders have invaded our sacred place on the shore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26761,'Brew of the Month Club?','Brew of the Month Club?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26762,'You haven\'t heard of the \"Brew of the Month\" club?  Those gals love to party.  If they had their way, Brewfest would never end!  Sometimes last year, it felt like it didn\'t.$b$bBut now they\'ve figured, the best way to keep the Brewfest spirit going would be to allow people to join their club.$b$bFor a small fee, just a few tokens, you can join!  You get brew mailed to you every month and a chance to buy that same brew if you like it.  It\'s cutting edge stuff and a way to make sure that Brewfest\'s spirit is never really gone.','You haven\'t heard of the \"Brew of the Month\" club?  Those gals love to party.  If they had their way, Brewfest would never end!  Sometimes last year, it felt like it didn\'t.$b$bBut now they\'ve figured, the best way to keep the Brewfest spirit going would be to allow people to join their club.$b$bFor a small fee, just a few tokens, you can join!  You get brew mailed to you every month and a chance to buy that same brew if you like it.  It\'s cutting edge stuff and a way to make sure that Brewfest\'s spirit is never really gone.',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(26763,'Some seek to take the land from us. The finned hunters squat upon the plains and devour the antlered ones themselves.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26764,'The curse is lifted!','The curse is lifted!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26765,'Thel\'zan\'s enchantment is broken! I am safe!','Thel\'zan\'s enchantment is broken! I am safe!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26766,'We are hunters, too. We are fighters. We can fight for the sea and the land.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26767,'What could this tome be hiding?','What could this tome be hiding?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26768,'Thel\'zan cannot stop me! For the Alliance! For Lord Fordragon!','Thel\'zan cannot stop me! For the Alliance! For Lord Fordragon!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26769,'But there is another threat to the tusked people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26770,'What\'s the \"Brew of the Month\" club?','What\'s the \"Brew of the Month\" club?',1,5,24,0,0,0,0,0,1,0,0,0,26124),
(26771,'You haven\'t heard of the \"Brew of the Month\" club?  It\'s a bunch of really cute guys that want to celebrate Brewfest all year long!  They tried to bring Brewfest back in the past, but it never lasted very long.$b$bOnce you join the club you get mailed a different brew every month!  If you like that brew, you can talk to the vendors in Ironforge to get more brew.$b$bI think you are cute enough to join the club.  You give me a few prize tokens and I\'ll give you the forms.  Then maybe we can celebrate Brewfest together, all year round!','You haven\'t heard of the \"Brew of the Month\" club?  It\'s a bunch of really cute guys that want to celebrate Brewfest all year long!  They tried to bring Brewfest back in the past, but it never lasted very long.$b$bOnce you join the club you get mailed a different brew every month!  If you like that brew, you can talk to the vendors in Ironforge to get more brew.$b$bI think you are cute enough to join the club.  You give me a few prize tokens and I\'ll give you the forms.  Then maybe we can celebrate Brewfest together, all year round!',1,5,24,0,0,0,0,0,1,0,0,0,26124),
(26772,'%s bows his head a moment to gather his thoughts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26773,'There is a power flowing through all things that live. It carries many names.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26774,'The tusked people call it Silap Inua.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26775,'This power is harnessed by all thinking peoples to heal or harm. It is the power of life. It is the power of souls living and dead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26776,'The threat to Silap Inua is known as those who would cage it. They will be called the blue-scaled ones.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26777,'The blue-scaled ones have great power. They work to control Silap Inua and take it from the wide ranging peoples of the world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26778,'They threaten not only the ways of the tusked people, but the existence of all who live.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26779,'The dead rise from our very own crypt!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(26780,'I give you this story.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26781,'You made it $g lad:lass;! I thought you were a goner for sure!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(26782,'We must fight those who would threaten our flesh, who would kill our children; we must look to our own.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26783,'But give what aid you can to the southern peoples, for they are the champions of Silap Inua.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26784,'What are you still doing here? Go back to town!','',6,5,0,0,0,0,0,0,1,0,0,0,26124),
(26785,'I heal ya up bruddas.  You be ready for anothuh battle soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26786,'Me totem fix ya up good bruddahs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26787,'Da scourge don\'t know who they be messin with!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26788,'We hold dis place wid our lives mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26789,'Da Emporer say we need be holdin dis position mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26790,'Da Scourge think they can be takin our land? They not know who they dealin wit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26791,'We be ready to strike back soon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26792,'We be ready to strike back soon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26793,'Stop da Scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26794,'You shall not pass, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26795,'Steward, please allow me to ride one of the drakes to the queen\'s chamber at the top of the temple.','Steward, please allow me to ride one of the drakes to the queen\'s chamber at the top of the temple.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26796,'These kodo are in amazing condition.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26797,'Indeed, I heard they were recovered from the brink of death by a seasoned veteran of the Horde.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26798,'Queen Alexstrasza has placed me in charge of the defense of Wyrmrest Temple.$B$BAs you know, Malygos had his forces destroy a nearby ley line anchor. The forces of the dragonflight then redirected that power to the Azure Dragonshrine.$B$BThe blue dragons are using that power to strengthen themselves; so much so that they dare attack the temple itself! They\'re starting to win.$B$BAre you here to help us, $r?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26799,'%s says a prayer for the lost soul.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26800,'Stand back, $n, the beast might lash out and harm you.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26801,'GODFREY! Hear me, fiend! Hear me, for I am the Light, here to deliver you from evil!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26802,'%s growls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26803,'Good. I have your attention, then, Godfrey?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26804,'We can do this in one of two ways, Godfrey. First, I will simply ask you to tell me what the unholy markings etched upon the pages of this tome mean. What say you?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26805,'%s hisses!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26806,'Tell you nothing, preacher.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26807,'What can you do to me that Kel\'Thuzad has not? That the Lich King will not?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26808,'The book is your salvation, yes... but nothing will you know! NOTHING I SAY! NOTHING! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26809,'Then it is option two.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26810,'I say a prayer for you now, lost soul. May the Light take you gracefully.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26811,'Let the sermon begin.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26812,'LIGHT TAKE YOU, BEAST!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26813,'May the power of Light compel you!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26814,'LET THE LIGHT IN, GODFREY GOODARD!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26815,'Do not fight me, fiend! The time of your atonement is now!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26816,'BURN IN HOLY FIRE!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26817,'The power of the Lich King pales in comparison to the glory of the Light!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26818,'IT BURNSSSSS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26819,'The pain is unbearable!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26820,'Make it stop! MAKE IT STOP!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26821,'I tell you anything you want!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26822,'No more LIGHT! NO MORE! I BEG YOU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26823,'Never felt hurt like this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26824,'I thought you would see the Light, Godfrey... Now speak quickly, fiend. What does it say?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26825,'It tells of the coming apocalypse. How this world will burn and be reborn from death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26826,'RUBBISH! Godfrey do you take me for a fool? Do not spew your Scourge propaganda at a man of the Light, heathen! Speak now or I will have the peasants craft a holy water bath and dip you into it like a dog with fleas!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26827,'NOOOO!!! I tell you! I tell you everything!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26828,'Humans... Beneath the earth of Wintergarde Village you built a mausoleum! Why do you think Naxxramas attacked that spot? Thel\'zan hides deep in your own crypt and sends a thousand-thousand corpses at you! Perish you will...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26829,'What? There is a mausoleum beneath the old village? What fools we are to not have noticed! We will find and strike down your master now, Godfrey. We will end this nightmare.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26830,'You let us worry about how we kill the monster, Godfrey.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26831,'How? Humans truly are stupid, yes? Thel\'zan the Duskbringer! Thel\'zan the Lich! He who is born of human flesh and bone, sacrificed all for power, protected by the Lich King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26832,'You cannot stop Thel\'zan! He bears the dark gift, bestowed upon him by the Lich King himself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26833,'Return to Halford with the information that the good mayor was kind enough to submit, $n. I will finish here and squeeze whatever else this wretch might know about Thel\'zan. Now, I will show Godfrey the rarely seen \"option three.\"','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26834,'Let\'s you and I have a chat about some things, Godfrey.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26835,'You will find no peace in death, wyrms!','You will find no peace in death, wyrms!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26836,'Rise... rise and feast on their flesh!','Rise... rise and feast on their flesh!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26837,'The time of the dragons is over...','The time of the dragons is over...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26838,'Your struggle is meaningless.  You will all fall before the endless Scourge!','Your struggle is meaningless.  You will all fall before the endless Scourge!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26839,'Every warrior that falls is one more for our mighty army.  There is no victory against us.','Every warrior that falls is one more for our mighty army.  There is no victory against us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26840,'There is no hope.  You will fail.','There is no hope.  You will fail.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26841,'For the Alliance and Lord Fordragon!','For the Alliance and Lord Fordragon!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26842,'HOO-WAH! The cavalry has arrived!','HOO-WAH! The cavalry has arrived!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26843,'Great driving, soldier! Not a scratch on us!','Great driving, soldier! Not a scratch on us!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26844,'Without you we\'d be lost. Thanks for the ride!','Without you we\'d be lost. Thanks for the ride!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26845,'Return to the Carrion Fields or your vehicle will be destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26846,'Back to the ship!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26847,'Gotta get out of here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26848,'We\'re all gonna die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26849,'I didn\'t sign up for this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26850,'Forget this! I\'m going home!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26851,'No way I\'m stickin\' around!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26852,'Cover me!','Cover me!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26853,'Keep the bad guys off me!','Keep the bad guys off me!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26854,'Keep \'em off me for about 15 seconds and this thing is as good as dead.','Keep \'em off me for about 15 seconds and this thing is as good as dead.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26855,'When I\'m done with this plague wagon it\'ll look like a goblin built it! Keep me safe!','When I\'m done with this plague wagon it\'ll look like a goblin built it! Keep me safe!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26856,'%s deftly assembles a strange machine.','%s deftly assembles a strange machine.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26857,'Gather, gather. A story has come.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26858,'That oughta do it! Just a few more seconds now.','That oughta do it! Just a few more seconds now.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26859,'Incoming!  Get your heads down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26860,'Heads up!  Strafe incoming!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26861,'Fire on the way, clear the field!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26862,'Burn, you fiends!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26863,'Make way!  A wyrm is coming to our aid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26864,'Red dragon incoming!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26865,'Rise, Arugal!  The power of the Lich King commands you!','',0,0,0,0,0,0,0,0,1,7203,0,0,26124),
(26866,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26867,'Yes... he shall suit our needs perfectly.  Have him sent to Solstice Village when you\'re ready.  Arthas will not be pleased if we fall behind schedule.','',0,0,0,0,0,0,0,0,1,7203,0,0,26124),
(26868,'Hey, $c, did you see that? Out there, lingering near the water\'s surface....$b$bYou saw it too didn\'t ya?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26869,'You mean the iceberg?','You mean the iceberg?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26870,'The wha-??$b$bWell, I refer to them as undefined floating obstructions. And where I\'m from, most deny their existence entirely.$b$bBut I know better! I\'ve even seen \'em up close! My recent years have been spent building this vessel to locate, track, document, and if needs be, eradicate them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26871,'I\'ll admit, dwarf, I was pleasantly surprised to see your plan succeed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26872,'All this equipment just to examine ice?','All this equipment just to examine ice?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26873,'We can\'t just let you return to your companions and we can\'t take you with us...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26874,'Wait a minute here! You promised to spare me if I helped you. I held up my end o\' the bargain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26875,'Stay your blade, Chieftain. He may yet have value to us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26876,'Don\'t be fooled, $r. They\'re very elusive. One moment they\'re there, the next they\'re gone - virtually inexplicable!$b$bBetween you and me, I actually held a piece of one in my hand once! Sadly, before I could conduct any measurements it was gone! Just disappeared....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26877,'It\'s just ice. Why all the fuss?','It\'s just ice. Why all the fuss?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26878,'Remember the dwarven journal that was discovered? Well, this dwarf could be exactly what we need to track down Brann Bronzebeard and capture him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26879,'By the Light, Brann\'s alive? I\'d never help you capture him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26880,'You will if you wish to keep your head attached to your shoulders.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26881,'Does that satisfy you, Tormak?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26882,'He will live so long as he proves useful. I\'d be careful if I was you, dwarf.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26883,'A lot you know...$b$bSome say they\'re just observing, some think they\'re altering our sea-life, and then others think they\'re here to take over Azeroth!$b$bOnce I take one down with my rocket propelled warheads I\'ll get the answers. You can believe that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26884,'','Surprise, you scum!  You\'re going to tell me where my sister is or I\'ll put a bucketful of truesilver bullets through your wife\'s heart.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26885,'Stop!  Do not shoot!  Do not hurt Tatjana!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26886,'The brat\'s held prisoner in the wolf den on the other side of the mountain.  She was to be taken to Arugal.  Are we free to go now?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26887,'Forgive me, Tatjana... ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26888,'Nothing you can do can compare to what Arugal can do to us!  I will tear you apart myself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26889,'','Where is Anya?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26890,'','There is one last thing.  I need to know where Arugal is.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26891,'','Thank you for helping me to get back to the camp. Go tell Walter that I\'m safe now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26892,'','He\'s gonna eat Mr. Floppy! You gotta help Mr. Floppy! You just gotta!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26893,'','There\'s a big meanie attacking Mr. Floppy! Help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26894,'','I think I see the camp! We\'re almost home, Mr. Floppy! Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26895,'Greetings, $r.$B$BI have been expecting you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26896,'We need to get into the fight. Are you ready?','We need to get into the fight. Are you ready?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26897,'Very well, let\'s go!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26898,'This is our chance boys!  Push!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26899,'Push them back to the shrine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26900,'Push them back and crush them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26901,'Push!  Make a path to the shrine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26902,'Emberwyrm incoming!  Pull back!  Pull back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26903,'Incoming!  Get back down the pass!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26904,'Fall back!  Incoming Emberwyrm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26905,'We\'ll hold them here for a moment.  Get into the shrine and stop those necromancers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26906,'We can\'t hold them for long!  Get inside disrupt their necromancers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26907,'We\'ll hold them a few more moments!  Get into the shrine while you can!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26908,'Take us into battle, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26909,'Self-destruct sequence initiated.','',0,0,0,0,0,0,0,0,1,7209,0,0,26124),
(26910,'The gryphons of the Northrend peaks are the most resilient of the species.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26911,'The High Commander said to speak with you to get a ride to Thorson\'s Post.','The High Commander said to speak with you to get a ride to Thorson\'s Post.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26912,'The gryphon riders are standing 10 paces from us, friend. They\'ll be giving you a ride to Thorson\'s Post. Get going!','',1,1,5,0,0,0,0,0,1,0,0,0,26124),
(26913,'I just issued Kill Credit to $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26914,'','You won\'t eat me, will you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26915,'','Anya!!  You\'re all right!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26916,'','Badmoon?  You mean Bloodmoon?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26917,'','Don\'t worry, sister... no one can hurt you now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26918,'','Sister!  The mean men were going to take me to Badmoon Isle.  They wanted to turn me into one of them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26919,'','That\'s what I said!  Badmoon!  Sasha... don\'t ever leave me again!  First they took papa, then they took you... I don\'t want to be alone with them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26920,'','Do not think for a second that your past accomplishments entitle you to anything, $n.  They don\'t.$B$BIf you want my respect you\'re going to have to earn it.  This means following my orders without question and fulfilling them... without exceptions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26921,'Thorson\'s Post - coming right up!','Thorson\'s Post - coming right up!',0,0,0,0,0,0,0,7,1,7210,0,0,26124),
(26922,'Hang on to your hat, pal! We\'re in for a bumpy ride.','Hang on to your hat, pal! We\'re in for a bumpy ride',0,0,0,0,0,0,0,7,1,7210,0,0,26124),
(26923,'Keep your head low and be on the lookout for frostwyrms! YAAAW!','Keep your head low and be on the lookout for frostwyrms! YAAAW!',0,0,0,0,0,0,0,7,1,7210,0,0,26124),
(26924,'This is your stop, pal. Safe landing!','This is your stop, pal. Safe landing!',0,0,0,0,0,0,0,7,1,7210,0,0,26124),
(26925,'Unleash the war hounds!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26926,'We ride!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26927,'Abomination spotted! 5th Battalion, let\'s mount up and engage them!','Abomination spotted! 5th Battalion, let\'s mount up and engage them!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26928,'Call the Gryphons!','Call the Gryphons!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26929,'To the front, men!','To the front, men!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26930,'Let them feel the fury of your Stormhammers!','Let them feel the fury of your Stormhammers!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26931,'It\'s not enough! Let\'s show them the might of the 5th Battalion up close!','It\'s not enough! Let\'s show them the might of the 5th Battalion up close!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26932,'The chill you feel is the herald of your doom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26933,'Bolster my defenses! Hurry, curse you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26934,'Hello. Squire Walter and I are responsible for taking care of Old Blanchy here, along with the rest of the mounts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26935,'I\'d like to use the stables.','I\'d like to use the stables.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26936,'Greetings, $r.$B$BIf you are interested in helping with the defense of the temple, please speak with Lord Afrasastrasz inside.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26937,'Thank you for freeing us, mortals.  Beware, the blue flight is alerted to your presence.  Even now, Malygos sends Varos Cloudstrider and his ring guardians to defend the Oculus.  You will need our help to stand a chance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26938,'I\'m sorry, $r, but I just called to a defender for you.$B$BYou will have to wait a short time before I will do so again.','I\'m sorry, $r, but I just called to a defender for you.$B$BYou will have to wait a short time before I will do so again.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26939,'','I\'ve lived here and kept this shrine with the blessing of the Alexstrasza for longer than I can remember.  In its darkest hour, I\'ve failed... I fell at the feet of that damned death knight...  Bloodbane.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26940,'','The Lich King is stretching his hand far now... fearlessly treading on the most sacred lands of all of the flights.  He intends to force us to action.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26941,'','My time is done... I offered myself to Alexstrasza in life, but I have nothing left to offer in death.  She will need a new keeper for her shrine.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(26942,'','And thank you... thank you for freeing me from the shackles of the damned.  You are a hero... I know you will go on to great deeds.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(26943,'','Dahlia spits on the ground at the thought of the name.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26944,'','The Remnant of Dahlia Suntouch fades away...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26945,'Welcome to Camp Oneqwah.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26946,'I\'d like to use the stables.','I\'d like to use the stables.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26947,'S.T.O.U.T. is more than just a target for throwing steins, it\'s a valuable training asset.  If you can hit S.T.O.U.T. you can probably hit anything!$b$bJust try not to hit me.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26948,'I want to fly on the wings of the green flight.','I want to fly on the wings of the green flight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26949,'','Belgaristrasz speaks the truth; the situation is grave indeed.  \n\nI can grant you the power to call upon a drake from the green flight.  Speak to Belgaristrasz or Eternos if you prefer to draw on the power of the red or the bronze.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26950,'Varos Cloudstrider and his ring guardians protect the second ring.  Your drakes are more than a match for the ring guardians, but Varos stands behind an impenetrable shield created from the energy of the Oculus itself.  Ten centrifuge constructs power the shield from the ring and platforms above.  Destroy them and Varos will be vulnerable.\n\nI can grant you the power to call upon a drake from the red flight.  Speak to Eternos or Verdisa if you prefer to draw on the power of the bronze or the green.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26951,'I want to fly on the wings of the red flight.','I want to fly on the wings of the red flight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26952,'Belgaristrasz speaks the truth; time is running out!\n\nI can grant you the power to call upon a drake from the bronze flight.  Speak to Belgaristrasz or Verdisa if you prefer to draw on the power of the red or the green.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26953,'I want to fly on the wings of the bronze flight.','I want to fly on the wings of the bronze flight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26954,'Reporting for duty, sir!','Reporting for duty, sir!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26955,'My lord, I am ready to go.','My lord, I am ready to go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26956,'Lord Afrasastrasz, with your leave, I wish to defend the temple.','Lord Afrasastrasz, with your leave, I wish to defend the temple.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26957,'For the queen. For Wyrmrest Temple!','For the queen. For Wyrmrest Temple!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26958,'If the blues dare to attack the temple, then they have a deathwish.','If the blues dare to attack the temple, then they have a deathwish.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26959,'By your leave, I will do what I can.','By your leave, I will do what I can.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26960,'Their dragonshrine may have empowered them, but the blues will not wrest the temple from us this day!','Their dragonshrine may have empowered them, but the blues will not wrest the temple from us this day!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26961,'I\'ve heard that the azure dragonshrine is being invested with the direct power of a ley line. I will defend the temple as best I can.','I\'ve heard that the azure dragonshrine is being invested with the direct power of a ley line. I will defend the temple as best I can.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26962,'It is unconscionable that Malygos would have his forces attack the temple! With your permission, my lord, I will defend us with my life.','It is unconscionable that Malygos would have his forces attack the temple! With your permission, my lord, I will defend us with my life.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26963,'What have we come to?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26964,'Do what must be done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26965,'Defend the temple at all costs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26966,'Thank you, my friend. Go.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26967,'It is regrettable, but necessary.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26968,'Yes. Do your best to return in one piece.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26969,'You have my leave.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26970,'In all of my centuries, I never dreamed that it would come to this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26971,'I think I see one of their plague wagons!','I think I see one of their plague wagons!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26972,'Did I ever tell you soldiers about the time I destroyed the Thandol Span? Yep, weren\'t no dark irons destroyed that bridge! Was me!','Did I ever tell you soldiers about the time I destroyed the Thandol Span? Yep, weren\'t no dark irons destroyed that bridge! Was me!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26973,'It doesn\'t make any sense. Why don\'t they just fly Naxxramas over Wintergarde Keep and blow it up? I mean, that\'s what I would do if I were Kel\'Thuzad.','It doesn\'t make any sense. Why don\'t they just fly Naxxramas over Wintergarde Keep and blow it up? I mean, that\'s what I would do if I were Kel\'Thuzad.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26974,'I wonder if we\'ll ever solve the mystery of the strange ore. There\'s gotta be some use for it!','I wonder if we\'ll ever solve the mystery of the strange ore. There\'s gotta be some use for it!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26975,'Hey, do any of you know McGoyver over at Valgarde? He\'s my uncle. You know what his title is? Pro. Yea, just \"Pro.\" I want to be a pro too.','Hey, do any of you know McGoyver over at Valgarde? He\'s my uncle. You know what his title is? Pro. Yea, just \"Pro.\" I want to be a pro too.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26976,'Something straight up stinks in here! It\'s definitely not me. Gnomes smell like butter and sunshine. Not like those dwarves that smell like they were born from a trogg\'s armpit! None of you are dwarves, are you?','Something straight up stinks in here! It\'s definitely not me. Gnomes smell like butter and sunshine. Not like those dwarves that smell like they were born from a trogg\'s armpit! None of you are dwarves, are you?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26977,'I used to know a dwarf that claimed gnomes evolved from beneath the earth. That we all started out as sand gnomes. What a load of nonsense! Sand gnomes? PUH-LEASE!','I used to know a dwarf that claimed gnomes evolved from beneath the earth. That we all started out as sand gnomes. What a load of nonsense! Sand gnomes? PUH-LEASE!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26978,'I\'ve never seen destruction like this...','I\'ve never seen destruction like this...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26979,'Keep the chatter down, people. We need to stay alert!','Keep the chatter down, people. We need to stay alert!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26980,'The smell of death covers every inch of this place.','The smell of death covers every inch of this place.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26981,'Driver, I hear you single handedly airlifted our villagers out of this hell-hole. Is that true?','Driver, I hear you single handedly airlifted our villagers out of this hell-hole. Is that true?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26982,'So does anyone know anything about Thel\'zan? Who is he? How did he come to leading the Scourge armies on the ground?','So does anyone know anything about Thel\'zan? Who is he? How did he come to leading the Scourge armies on the ground?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26983,'Look at this mess... The Scourge will pay for this!','Look at this mess... The Scourge will pay for this!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26984,'Where are all the corpses? What have they done to our people?','Where are all the corpses? What have they done to our people?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26985,'I hope I\'m alive to see Arthas get what\'s coming to him.','I hope I\'m alive to see Arthas get what\'s coming to him.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(26986,'It burns!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26987,'Please!  Stop the burning!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26988,'Why !','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26989,'Happy Winter\'s Veil!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(26990,'Most of my brethren are disdainful of the Horde\'s \"barbaric\" ways, and I once counted myself among them. When I was first ordered to this somewhat humid and... fragrant place, I cursed my lot in life.$b$bDuring my studies, however, I grew to appreciate my surroundings. It has a certain charm, don\'t you think?$b$bAh, and my studies, of course, were to allow other mages to return here with a spell. Shall I teach you?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26991,'Most of my brethren are disdainful of the Horde\'s \"barbaric\" ways, and I once counted myself among them. When I was first ordered to this somewhat humid and... fragrant place, I cursed my lot in life.$b$bDuring my studies, however, I grew to appreciate my surroundings. It has a certain charm, don\'t you think?$b$b...you wouldn\'t be interested in my studies, of course, not being a mage yourself.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26992,'Ah, I love the smell of Stonard! It smells like... like... orc sweat. And rot. Still, combined, the effect can be quite pleasant! It\'s an acquired scent.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26993,'While visitors complain about the exceptionally humid air, I find it helps my complexion! Dry skin is unflattering.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26994,'It is a shame, a dreadful shame, that my brethren cannot see what benefits come from truly steeping oneself in a culture.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26995,'Here I am, in a rough-hewn stone tower squatting on marshy, muddy ground while clouds of midges fly unchecked through the open doorways, standing amongst hunched, greenskin figures of dubious hygiene and coarse manners. I\'ve never been happier.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26996,'Before I was stationed out here, I\'d only heard about the rejuvenating effects a mudbath can have on skin. When I first tripped over a tree root, I was exposed to the full benefits! Amazing what nature can do, even without a bit of magic to help it along.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26997,'To this day, I ponder why I, myself, was chosen for this particular station. I can only imagine my superior felt I was uniquely suited to the task and would quickly become accustomed to the quaint culture of the Horde found herein, but I heard a truly mean-spirited rumor that it may be because I talk too much.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(26998,'Hrm? Oh. Pardon me if I seem distracted; I fear for the men of Northwatch. I should have sent some of my students to aid them. Now, how may I help you?','Hrm? Oh. Pardon me if I seem distracted; I fear for the men of Northwatch. I should have sent some of my students to aid them. Now, how may I help you?',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(26999,'Hrm? Oh. Pardon me if I seem distracted; I fear for the men of Northwatch. I should have sent some of my students to aid them...','Hrm? Oh. Pardon me if I seem distracted; I fear for the men of Northwatch. I should have sent some of my students to aid them...',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(27000,'Be quiet.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27001,'Remember how quiet it was before the elves came here? I miss that.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27002,'Shut up.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27003,'I\'m not sure which one\'s crazier.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27004,'I\'d give my pestle away for some earplugs.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27005,'','My teachings are only of use to mages. I cannot help you, $c.',274,0,0,0,0,0,0,7,1,0,0,0,26124),
(27006,'','Sinu a\'manore. If you seek to learn how to conjure a portal to Theramore, I can show you.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27007,'You need to learn to appreciate your surroundings, Cersei!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(27008,'Brewfest has undergone some changes since its first year.  We now issue Brewfest tokens instead of tickets.  If you have old tickets, I can exchange them for you.','Brewfest has undergone some changes since its first year.  We now issue Brewfest tokens instead of tickets.  If you have old tickets, I can exchange them for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27009,'I\'d like to exchange the tickets in my inventory for the new tokens.','I\'d like to exchange the tickets in my inventory for the new tokens.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27010,'Who keeps breaking this thing?!','',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(27011,'Every time I fix this mailbox, it\'s vandalized again within a day.','',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(27012,'If I ever catch whoever keeps damaging this holo-emitter...','',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(27013,'Hrm. It appears to be functioning normally again...','',0,0,0,0,0,0,0,35,1,0,0,0,26124),
(27014,'Ladies and gentlemen... gather round the pit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27015,'In one corner we have... $n, truly a world class $c.  Slayer of reptiles, mammals, mechanical constructs and the odd dragon...kin.  You\'ve never seen another $r like $g him : her;.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27016,'In the other corner, a serial killer, mass defenestrator, sentenced to death multiple times by noose and by blunt instrument!  Horgrenn... Hellcleave!  Ladies and gentlemen... place your bets!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27017,'Ladies and gentlemen, gather round the Conquest Pit!  Witness the battle of $r versus bear and place your bets with confidence!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27018,'Just when you think you\'ve seen it all!  $n will square off with an authentic Grizzly Hills crazed furbolg in front of your very eyes here at the Conquest Pit!  Place your bets, folks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27019,'Gather round, folks!  Grab a warm drink and find a good seat for you\'re about to witness a showdown between $r and machine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27020,'Straight out of Thor Modan and made of 100 percent authentic... metal... here is Rustblood, the lightning-powered iron golem!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27021,'Come back next year for a new surprise!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27022,'Explosion brought to you by Smokywood Pastures!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27023,'Forgive me, but I am spent and cannot use my magic to send you back Theramore. You have the look of a worldly adventurer about you; surely you know of another way to reach Theramore in time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27024,'','Here for a ride, $r?$B$BOr, is something else bothering you?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(27025,'','I see you\'ve brought your pets.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27026,'','It doesn\'t have to end this way, you know?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27027,'','I used good judgment when you showed none.  I don\'t want to see you lead us into ruin, Krenna!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27028,'','We\'ll see about that.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27029,'','Good one, sister.  What about your pet?  Where is $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27030,'','You went behind my back.  You neglected my orders.  You will pay the price.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27031,'','Enough talk.  By the time I\'m through with you, not even the worgs are going to want to go near your corpse.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27032,'Ladies and gentlemen!  Well... let\'s just say you don\'t want to miss this one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27033,'','Why... why sister?  Why did it have to come to this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27034,'I want to exchange my Ruby Essence for Emerald Essence.','I want to exchange my Ruby Essence for Emerald Essence.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27035,'I want to exchange my Amber Essence for Emerald Essence.','I want to exchange my Amber Essence for Emerald Essence.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27036,'Rocket propelled warheads? Isn\'t that a bit aggressive?','Rocket propelled warheads? Isn\'t that a bit aggressive?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27037,'Listen here, now. When you\'re looking for answers nothing beats a good explosion - the bigger, the better!$b$bBut that\'s probably enough with the questions for now, $r.$b$bMy warheads are classified material, and the element 115 that I created to power them is even more classified!$b$bIn fact, it\'s best that you just return to your everyday life and pretend we never met.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27038,'I want to exchange my Emerald Essence for Amber Essence.','I want to exchange my Emerald Essence for Amber Essence.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27039,'I want to exchange my Ruby Essence for Amber Essence.','I want to exchange my Ruby Essence for Amber Essence.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27040,'I want to exchange my Amber Essence for Ruby Essence.','I want to exchange my Amber Essence for Ruby Essence.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27041,'I want to exchange my Emerald Essence for Ruby Essence.','I want to exchange my Emerald Essence for Ruby Essence.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27042,'I would like to go to Lord Afrasastrasz in the middle of the temple.','I would like to go to Lord Afrasastrasz in the middle of the temple.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27043,'My lord, I need to get to the top of the temple.','My lord, I need to get to the top of the temple.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27044,'','Welcome, adventurer. You\'ve come just in the nick of time.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27045,'Thel\'zan needs to die, if only to stop the incessant yammering!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27046,'Can I get a ride back to ground level, Lord Afrasastrasz?','Can I get a ride back to ground level, Lord Afrasastrasz?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27047,'Official postings by Wintergarde citizenry and officials.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27048,'Can you spare a drake to take me to Lord Afrasastrasz in the middle of the temple?','Can you spare a drake to take me to Lord Afrasastrasz in the middle of the temple?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27049,'','Does being in the presence of a Black Dragon make you nervous?$B$BGood. It should. It makes these dragons nervous too. They cling to their ancient virtues though - they wouldn\'t dare attack me here.$B$BFools.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27050,'Next, I shall speak of the dread plague wing of Naxxramas, where the Scourge seek to improve upon the deadly blight which they spread across Lordaeron.','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27051,'Next, I shall speak of the accursed spider wing of Naxxramas. It is there the Scourge breed even more poisonous and dangerous versions of their kin.','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27052,'Next, I shall speak of the blighted abomination wing of Naxxramas. There, the Scourge develop the strongest and most hideous aberrations of their armies.','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27053,'Next, I shall speak of the death knight wing of Naxxramas. Within its corrupted halls, the echo of battle rings day and night, as our finest warriors are corrupted and twisted into the Scourge\'s greatest warriors.','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27054,'Next, I shall speak of the most powerful entities within the pinnacle of Naxxramas. Truly, these are two of the greatest threats to all of Northrend.','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27055,'Behold, Noth the Plaguebringer. Responsible for the creation of the process that distills the souls of the living and places them within the cold cage of undeath, Noth was observed to be refining this process even now. ','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27056,'Observe, Heigan the Unclean. The mastermind behind the plague cauldrons that turned the wilderness of Azeroth into the Plaguelands. ','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27057,'It is said that Heigan has rigged the very walls and floors of Naxxramas itself with a vast array of traps, which he can trigger at will.','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27058,'Loatheb. The hideous result of fusing the living plague of the Plaguelands with the bog beasts of Azeroth, Loatheb is said to control the power of healing itself. ','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27059,'I shall leave this image on display for your perusal. Study your opponents\' strengths, for a creature\'s strength can also be its weakness.','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27060,'Pay attention. This is Instructor Razuvious, Kel\'Thuzad\'s appointed trainer of all death knights. It is said that his own technique is so potent, only a disciple of his could possibly withstand his might.','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27061,'Gothik, the Harvester. A master of necromancy and conjuration, Gothik is said to be able to beckon forth legions of the undead at a moment\'s notice. It is with his guidance that even the weakest of Death Knights can raise the dead.','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27062,'The most powerful death knights within Naxxramas are the four horsemen. They represent the pinnacle of Kel\'Thuzad\'s guard. The first, Thane Korth\'azz, holds the power of flame. ','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27063,'The next, Lady Blaumeux, calls forth the power of shadows, drawing the souls of the living into the voracious embrace.','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27064,'Sir Zeliek, a paladin in life, so strong in his faith, that even in undeath, the power of the light still heeds his call, smiting his foes in battle.','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27065,'The final death knight, Lord Mograine, was the finest warrior that the death knights had ever seen. However, after the events in Azeroth, he vanished without a trace. It is yet to be seen who Kel\'Thuzad has appointed in his place.','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27066,'Anub\'Rekhan, one of the finest Spider Lords of Azjol\'Nerub, was brought under the control of the Scourge when he and his former commander, Anub\'arak, were finally defeated by Lich King many years ago. It is said that he was the most loyal of Anub\'arak\'s commanders.','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27067,'Listen, $r.$b$bIf you\'re lookin\' for a shredder to ride, you\'ll need to head up into the hills just north there.$b$bThis one\'s out of commission.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27068,'Why would I want to ride a shredder?','Why would I want to ride a shredder?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27069,'At first we repaired them to harvest the forests here, but ever since the alliance arrived and the fighting broke out we\'ve been using them as war machines.$b$bBelieve me, $c. If you\'ve got a key, you\'d be crazy not to use it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27070,'The Grand Widow Faerlina, a botanist in life, breeder and caretaker of arachnids in death, she overseers the spider wing, developing the most potent of poisons for the Lich King. ','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27071,'Where can I get a Refurbished Shredder Key?','Where can I get a Refurbished Shredder Key?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27072,'Grekk holds them.$b$bMaybe he\'ll give you one if you help him out. The next time you\'re up north at Blue Sky logging Grounds be sure to talk to him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27073,'Maexxna, born deep within the mountains of Northrend many ages ago, she was captured within the dread citadel Naxxramas, where she gives birth to her brood, feeding them the corpses of all who dare venture too deeply into Naxxramas.','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27074,'Behold, Patchwerk. When word of his existence first reached the ears of the Brotherhood, none believed the tales of an abomination with such immense speed and strength. Fewer still believed it when he fell the first time...','',0,0,0,0,0,0,0,0,1,7259,0,0,26124),
(27075,'Grobbulus, the first of what was to be an army of flesh giants. It carried the plague slime of Naxxramas within its body, injecting the living ooze into the bodies of its foe. The recipient of this foul injection would usually flee to his allies, bringing them down with him.','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27076,'Yes?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(27077,'Gluth, the foul plague-dog of Naxxramas, was said to have an appetite so voracious that even the living were not enough to satisfy his hunger. Feugen was said to feed him an army of zombies daily, recycling the remains of undead too weak to use in combat.','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27078,'Thaddius, built from the flesh of women and children, it is said that their souls are fused together - eternally bound within that foul prison of flesh. ','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27079,'Sapphiron. Once a noble blue dragon within the mountains of Northrend, Sapphiron was slain by Arthas during his campaign through the frozen north. Resurrected to serve him, Sapphiron guards Kel\'thuzad\'s lair eternally, awaiting those who would dare tresspass upon his master.','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27080,'The lich, Kel\'Thuzad. He serves the Lich King without question, a necromancer of great prowess in life, turned into a master of necromancy after his death. It is said he is the most loyal of the Lich King\'s subjects.','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27081,'Kel\'thuzad has survived trials that would have long since shattered the souls of even the greatest of the Brotherhood. He readily gave his life at Arthas\'s hand, later to be brought back - reborn in the power of the Sunwell. ','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27082,'In the Plaguelands, Kel\'thuzad was again defeated by the agents of the Argent Dawn. However, his phylactery was delivered to a false agent of the Brotherhood. We have yet to discover who stole his phylactery or why. ','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(27083,'Come out, soldier! I\'ll cover you!','Come out, soldier! I\'ll cover you!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27084,'Soldier, run to me! I\'ll clear a path with the chain gun!','Soldier, run to me! I\'ll clear a path with the chain gun!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27085,'','%s peers at Modoru\'s Draenic robes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27086,'','Pssst. Naohain. Why does Modoru still wear those ridiculous robes? He looks like some interdimensional bumpkin who stumbled out of Ammen Vale not six hours past.',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(27087,'Rifleman, get our soldier out of there! NOW NOW NOW!','Rifleman, get our soldier out of there! NOW NOW NOW!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27088,'Rifleman he\'s close enough now to rescue! GO GET HIM!','Rifleman he\'s close enough now to rescue! GO GET HIM!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27089,'Rifleman, cease fire! Our soldier is within range! GET HIM OUT OF THERE!','Rifleman, cease fire! Our soldier is within range! GET HIM OUT OF THERE!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27090,'Why have I been sent back to this particular place and time?','Why have I been sent back to this particular place and time?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27091,'','The Infinite Dragonflight is attempting to alter the destiny of Prince Arthas Menethil.$B$BYou know him now as the Lich King, but here and now he was still a Prince of Lordaeron trying to do what was best for his kingdom.$B$BArthas makes a very fateful choice today, leading to something we Keepers of Time call an inflection point in the timeline.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27092,'What was this decision?','What was this decision?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27093,'','Arthas gave the order to cull Stratholme, killing every single human within its walls.$B$BHe discovered evidence that the Scourge had infected the city with their insidious plague, and the disease doesn\'t just kill people.$B$BThose who die to this plague rise up as mindless zombies, further fueling the Scourge\'s war machine.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27094,'So how does the Infinite Dragonflight plan to interfere?','So how does the Infinite Dragonflight plan to interfere?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27095,'Thanks for the cover fire! It\'s a MADHOUSE down there! ','Thanks for the cover fire! It\'s a MADHOUSE down there! ',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27096,'Wow, I thought I was a goner! Thanks, friend!','Wow, I thought I was a goner! Thanks, friend!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27097,'I was almost ghoul bait! Thanks for the rescue!','I was almost ghoul bait! Thanks for the rescue!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27098,'It\'s a good thing you came along, ally! We were done for!','It\'s a good thing you came along, ally! We were done for!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27099,'Show me what you have for sale, trapper.','Show me what you have for sale, trapper.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27100,'He wants me to do WHAT?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27101,'Well, he\'d better keep the moonshine flowing if he wants my men to stop their research to serve the military\'s purposes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27102,'','The Infinites are attempting something unusually subtle for them. They are trying to hide the evidence that will lead to Arthas deciding to cull Stratholme.$B$BTheir agents have used illusionary magic on the plagued grain shipments in the nearby countryside to make them appear normal.$B$BI need you to find the hidden grain, and use this Arcane Disruptor on the shipments. Arthas\' men are looking for plagued grain, and should find it quickly with the illusion gone.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27103,'','I don\'t think we can afford to pass an opportunity to ingratiate ourselves with the red flight. With the battles ahead, having them as allies would be invaluable.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27104,'In years past, the warlock Nekros Skullcrusher abused a powerful artifact to enslave Alexstrasza and much of the red dragonflight.  Zuluhed and Nekros are dead, but the debt we owe to the reds is far from repaid.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27105,'Do not stray too far down the pass, $n. Stay with the captain and his men... you\'re no use to us dead.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27106,'Be sure to go through the southern canyon when entering and exiting the shrine, $n. You will know the canyons where the battle is waged by the abominations that guard them... keep your distance.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27107,'The Alliance has maintained this remote lodge for a while.  It\'s seen some use by our hunters and woodsmen.$B$BWith the war going on, you\'d better believe the military is in charge here now, though.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27108,'','Let me take care of it, sister.',0,0,0,0,0,0,0,0,1,7217,0,0,26124),
(27109,'','What were you thinking, provoking her like that?',0,0,0,0,0,0,0,0,1,7217,0,0,26124),
(27110,'','You... half-idiot!  You really did it this time.  I\'m going to have to make it look like your leg\'s broken.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27111,'','Now don\'t move if you ever want to walk again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27112,'No, please!  Don\'t!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27113,'<The commander stops his lesson and turns, his eyes appraising you, sizing you up.>$B$BI have use for one such as yourself, $c.','',1,0,0,1000,0,0,0,0,1,0,0,0,26124),
(27114,'Yes, $c, what can I do for you?$B$BIf you\'re here for a lesson on Naxxramas, there\'s plenty of room.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(27115,'Yes, $c, what is it?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(27116,'It\'s good to see you again, $n.$B$BCome for a refresher in Scourge tactics?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27117,'A crack begins to open beneath your feet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27118,'Darling, you simply can\'t complete your look without the right shoes.  Don\'t you agree?','Darling, you simply can\'t complete your look without the right shoes.  Don\'t you agree?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27119,'','Darling, those shoes are to die for!  I mean that literally.  Who did you kill for them?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27120,'I\'ll flush her out, $n! You just be ready for her when she comes in!','I\'ll flush her out, $n! You just be ready for her when she comes in!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27121,'Ticket Exchange','Ticket Exchange',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27122,'Awaiting orders!','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(27123,'FIRE! FIRE! BRING HER DOWN!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27124,'Welcome to Granite Springs, friend.$b$bIf you manage to catch any of these ice trolls alive, be sure to let me know. We\'re paying well for \'em.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27125,'Thel\'zan\'s phylactery drops to the ground beneath Icestorm.','',0,0,0,0,0,0,0,0,1,7233,0,0,26124),
(27126,'\'We like the trees, Fenrick. They provide cover.\' They won\'t let me chop them down, either.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(27127,'What do they expect, making the bats come in at that angle? Broken necks and gamey bat stew, that\'s what they get.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(27128,'I wonder how many reinforcements need to suffer injury before they allow us to chop down these idiotic trees. They\'re costing us a fortune in bats. Maybe I\'ll rig a harness or two...','',0,0,0,0,0,0,0,33,1,0,0,0,26124),
(27129,'Bat gizzards again for the gnomes tonight...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(27130,'Hey, I see ya got some Brewfest tokens.  If ya want, I still got a few Brewfest goods to sell.','Hey, I see ya got some Brewfest tokens.  If ya want, I still got a few Brewfest goods to sell.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27131,'Get out there.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(27132,'Do your job, scum.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(27133,'If you want to jump to your death this time, I won\'t stop you.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(27134,'You\'re on, rats.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(27135,'Top of the hour, boys. Go.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(27136,'Get out there before I clock you. Clock. Get it?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(27137,'Wyrmbait, eh? Welp, go fetch us Icestorm!','Wyrmbait, eh? Welp, go fetch us Icestorm!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27138,'How things be treatin\' ya, $n?  Here to hang out with other members of da club?','How things be treatin\' ya, $n?  Here to hang out with other members of da club?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27139,'Good seein\' you again, $n.  I hope our club be treatin\' ya right.','Good seein\' you again, $n.  I hope our club be treatin\' ya right.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27140,'Hey, $n, how\'s life been treating you?  Are you here to hang out with other club members?','Hey, $n, how\'s life been treating you?  Are you here to hang out with other club members?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27141,'Hey, $n!  I hope you\'ve been enjoying our club!','Hey, $n!  I hope you\'ve been enjoying our club!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27143,'What is it?','What is it?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27144,'It looks like a gateway to hell!','It looks like a gateway to hell!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27145,'If I don\'t make it back to Wintergarde, let my family know that I did my best and that I love them...','If I don\'t make it back to Wintergarde, let my family know that I did my best and that I love them...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27146,'Is this the end? If we stop this monster now, is victory assured at the Wrathgate?','Is this the end? If we stop this monster now, is victory assured at the Wrathgate?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27147,'I\'m getting a little worried. Where is this hero that is supposed to lead us into battle?','I\'m getting a little worried. Where is this hero that is supposed to lead us into battle?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27148,'Let it be known that it has been an honor and a privilege fighting alongside all of you.\n','Let it be known that it has been an honor and a privilege fighting alongside all of you.\n',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27149,'Come on... Let\'s get this over with!\n','Come on... Let\'s get this over with!\n',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27150,'Death comes for us all eventually, but sometimes it comes a little faster than anticipated. Today we call that blind heroics... Tomorrow someone may call it stupidity. \n','Death comes for us all eventually, but sometimes it comes a little faster than anticipated. Today we call that blind heroics... Tomorrow someone may call it stupidity. \n',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27152,'%s casts Frost Tomb on $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27153,'You have saved me from those vicious monsters. Thank you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27154,'','$n, good to see you!$B$BOr is this the first time that we\'ve met?$B$BI\'m in so many places and times right now, I sometimes have a hard time keeping track of all of it.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(27155,'Steel yourselves, soldiers. $n has provided us with the final piece of this puzzle. The dread lich, Thel\'zan, will soon come out of hiding, only to be rendered powerless against us!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27156,'It is this phylactery - Thel\'zan\'s phylactery - that is the key to victory!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27157,'I was... once like you. Mortal. Soft. Only flesh and bone. WEAK AND TIMID!','',0,0,0,0,0,0,0,0,1,7236,0,0,26124),
(27158,'LEGION, STEADY YOURSELVES!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27159,'Our lord, Arthas, saw in me the frailty of man.','',0,0,0,0,0,0,0,0,1,7236,0,0,26124),
(27160,'\"Serve me in life and I will promise to rend the weakness from your soul. To erase it from existence!\" To be chosen... blessed by the Lich King in such a way.','',0,0,0,0,0,0,0,0,1,7236,0,0,26124),
(27161,'So serve him I did... Were it not for me the glorious dread citadel of Naxxramas may never have returned to Northrend.','',0,0,0,0,0,0,0,0,1,7236,0,0,26124),
(27162,'But enough talk... You have fought hard and come from the distant reaches of this world to face the Duskbringer. I shall not disappoint...\n','',0,0,0,0,0,0,0,0,1,7236,0,0,26124),
(27163,'Just as our lord saved me, so too shall I save you!\n','',0,0,0,0,0,0,0,0,1,7236,0,0,26124),
(27164,'Rise, my minions! Your master commands it!','',0,0,0,0,0,0,0,0,1,7236,0,0,26124),
(27165,'Blight, Blight, Blight... that\'s all I hear about around here. I miss the diversity!$b$bHere, here. You have pets, yes? Of course you do. Of course. Little pets. I have a mixture for them. It will make them ca-- ah, clever and strong creatures, yes. Yes. Strong.$b$bTry it!','',396,5,397,0,0,0,0,1,1,0,0,0,26124),
(27166,'All right, I\'ll take this mixture of yours.','All right, I\'ll take this mixture of yours.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27167,'Careful with it. It\'s unstable and loses its potency quickly. Use it soon! And... preferably within eyesight, yes...','',396,5,0,0,0,0,0,1,1,0,0,0,26124),
(27168,'Where did that cat go?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(27169,'Patchy?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(27170,'There you are, you little miscreant.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(27171,'%s sighs in irritation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27172,'Time to make another Patchy.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(27173,'Honor, courage, compassion and justice! These were once the virtues you fought for as a cleric of the Argent Dawn, Thel\'zan.','',0,0,0,0,0,0,0,0,1,7236,0,0,26124),
(27174,'You dedicated your whole life to fighting the Scourge. You saw what they did to our beloved Lordaeron. The Lich King took everything from you!','',0,0,0,0,0,0,0,0,1,7236,0,0,26124),
(27175,'So how, then, did Father Inigo Montoy, bastion of virtue for the Argent Dawn, become the embodiment of that which he hated most?','',0,0,0,0,0,0,0,0,1,7236,0,0,26124),
(27176,'THIS WILL BE THE LAST TIME YOU UTTER THAT NAME, PALADIN! Breathe your dying breath!','',0,0,0,0,0,0,0,0,1,7236,0,0,26124),
(27177,'Good to see you still alive and kicking, $n. Don\'t think that I\'d forgetten what you did for me in Stormwind, oh so long ago.','',0,0,0,0,0,0,0,0,1,7237,0,0,26124),
(27178,'It\'s the Highlord!','It\'s the Highlord!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27179,'Lord Fordragon!','Lord Fordragon!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27180,'Victory for the Alliance!','',0,0,0,0,0,0,0,0,1,7236,0,0,26124),
(27181,'You have saved Wintergarde! With Thel\'zan\'s filth washed away, the 7th Legion will easily clean up the remaining Scourge. When you are done here, report to Angrathar!','',0,0,0,0,0,0,0,0,1,7236,0,0,26124),
(27182,'Now, be free and join the battle! Let us end this together!','',0,0,0,0,0,0,0,0,1,7236,0,0,26124),
(27183,'Wow, that\'s a nice one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27184,'That\'s a mighty fine mustang ya got there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27185,'Keep bringin\' ones like that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27186,'I\'m gonna train that one myself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27187,'I know just the soldier for that horse!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27188,'I think he likes Old Blanchy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27189,'I left a war once to tend to the troubles back home in Westfall. That seems like a lifetime ago. Thank the Light that the Defias are no longer a threat.$B$BWe\'re a long way from home up here, but if we don\'t win this battle, there may not be a Westfall to return to.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27190,'Mr. Perelli, have you seen any suspicious activity by men wearing dark robes in the last few weeks?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27191,'Mr. Perelli, have you seen any signs of the undead? Any information you can provide would be appreciated by Prince Arthas.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27192,'Mr. Perelli, I know you travel around quite a bit hawking your goods. Surely you\'ve heard rumors or information about the Scourge?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27193,'Do you plan on leaving the area soon if we have further questions?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27194,'Mr. Perelli, have these goods been under your supervision at all times?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27195,'You wouldn\'t happen to have any canned turtle soup from Hillsbrad, would you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27196,'The walls of Frostmourne Cavern shudder and shake.','The walls of Frostmourne Cavern shudder and shake.',0,0,0,0,0,0,0,0,1,7238,0,0,26124),
(27197,'Mr. Perelli, if you happen across any signs of Scourge activity or shady dealings in your travels, let the nearest Lordaeron soldier know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27198,'No, Sergeant.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27199,'No, sir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27200,'Nope.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27201,'Yes, sir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27202,'Yes, Sergeant Morigan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27203,'Absolutely.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27204,'Xink\'s Shredder collapses and sputters to a stop.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27205,'You don\'t mind me checking out your merchandise for signs of tampering, do you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27206,'Wait, what is this? You\'ve been holding out on me, Perelli!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27207,'Behold, Muradin, our salvation, Frostmourne.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27208,'What are you talking about, Sergeant!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27209,'Hold, lad. There\'s an inscription on the dais. It\'s a warning. It says, \"Whomsoever takes up this blade shall wield power eternal. Just as the blade rends flesh, so must power scar the spirit.\" Oh, I should\'ve known. The blade is cursed! Let\'s get the hell out of here!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27210,'I\'m confiscating this suspicious grain, Perelli. We were looking for signs of tampered food, and it would be in your best interest to stay put while Prince Arthas checks this out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27211,'I would gladly bear any curse to save my homeland.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27212,'Leave it be, Arthas. Forget this business and lead your men home.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27213,'You have to believe me, I\'m innocent!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27214,'Damn the men! Nothing shall prevent me from having my revenge, old friend. Not even you.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27215,'Now, I call out to the spirits of this place. I will give anything or pay any price, if only you will help me save my people.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27216,'We\'ll see about that, Perelli. We\'ll see about that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27217,'O\' my head... Wh... Where am I?\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27218,'Who... Who am I?\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27219,'','Let\'s see, we had chicken last night.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27220,'','I\'ve got plenty of cured bacon, but he had some for breakfast.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27221,'','I need to make something healthy for him, he\'s still not recovered from that illness from last week.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27222,'','Strawberries! Oh wait, they\'re not in season.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27223,'','Ah, I\'ll make him some fresh bread! I need to get some flour from Martha!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27224,'','Martha, I\'m out of flour for bread. You wouldn\'t happen to have any grain from that recent shipment, would you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27225,'Off we go!','Off we go!',0,0,0,0,0,0,0,7,1,7239,0,0,26124),
(27226,'Pay attention, friend! We\'re headin\' into hostile territory with both vrykul and Horde all over the place!','Pay attention, friend! We\'re headin\' into hostile territory with both vrykul and Horde all over the place!',0,0,0,0,0,0,0,7,1,7239,0,0,26124),
(27227,'Keep a close eye on your surroundings. The route I\'m taking is the same route you can use to get back to Valgarde.','Keep a close eye on your surroundings. The route I\'m taking is the same route you can use to get back to Valgarde.',0,0,0,0,0,0,0,7,1,7239,0,0,26124),
(27228,'Here ya go, friend! Icehammer is right inside that vrykul building! Give \'em hell!','Here ya go, friend! Icehammer is right inside that vrykul building! Give \'em hell!',0,0,0,0,0,0,0,7,1,7239,0,0,26124),
(27229,'','Thanks, Martha! I owe you one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27230,'','Oh, dear.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27231,'','Martha, something\'s wrong with this grain! Some of the Prince\'s soldiers were looking for this. I\'m going to go look for one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27232,'','Oh hello, Jena. Of course you can borrow some grain. Help yourself.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27233,'My warmages are inbound and will arrive presently.$b$bSpeak to me again when they have returned,','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27234,'Pardon me, $r, but I am on official business and cannot be disturbed.$b$bPlease excuse me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27235,'','Oh, my.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27236,'Looks like a storm\'s coming in, Scruffy...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27237,'%s begins to growl...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27238,'What\'s wrong, pal?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27239,'Hey there, $n, don\'t be alarmed. It\'s me... you... from the future.  I\'m here to help.','Hey there, $n, don\'t be alarmed. It\'s me... you... from the future.  I\'m here to help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27240,'What did you find, boy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27241,'This is no good, Scruffy. Stay here and guard the house, I need to go find a soldier.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27242,'The Infinite Dragonflight has destroyed the %s!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27243,'','How will we overcome the mist?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(27244,'','I thought for sure that I would die like all the others!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(27245,'','What was that! Did you see that?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(27246,'','Have you heard of the taunka? They are supposedly related to tauren in some way. Can you imagine such a thing?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(27247,'Ok, enough work for now. Time for refreshments and a little conversation in the inn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27248,'Wait, what\'s that smell?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27249,'Can\'t be me, I took a bath 3 days ago!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27250,'Oh, close call. It\'s just the grain here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27251,'Heads up... here they come. I\'ll help as much as I can. Let\'s just keep them off of the hourglass!','Heads up... here they come. I\'ll help as much as I can. Let\'s just keep them off of the hourglass!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27252,'Wait a second. Grain isn\'t supposed to smell like THAT! I better go find a guard.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27253,'I knew I should have secured the wagon lock better when I was in Andorhal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27254,'This grain shipment has been nothing but trouble!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27255,'I\'m going to lose my on time bonus because of this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27256,'I wasn\'t even supposed to be here today!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27257,'Well, guess I should load everything back into the cart.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27258,'Oh, come on! My cart broke, my horse lost a shoe, and now the cargo goes bad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27259,'I guess I\'ll go find the authorities. If I\'m lucky they\'ll tell me it\'s the plague and that we\'re all going to die.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27260,'The %s claws at the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27261,'Oh darn. You\'re our only hope. Survive!','Oh darn. You\'re our only hope. Survive!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27262,'The Unstable Mur\'ghoul is about to explode!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27263,'All soldiers of Lordaeron should immediately report to the entrance of Stratholme, and await further orders from Prince Arthas.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27264,'Once again, all soldiers of Lordaeron are ordered to immediately report to the entrance of Stratholme, and await further instructions from Prince Arthas.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27265,'','Good work! Arthas now knows about the plagued grain in Stratholme, and is about to begin the culling.$B$BSomething is still not quite right, though. I sense a foreign presence in this timeline besides us, and that must mean the Infinite Dragonflight are here somewhere.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27266,'What do you think they\'re up to?','What do you think they\'re up to?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27267,'','I don\'t know, and that worries me. I\'ll do everything I can to find the Infinites.$B$BWhat I need you to do now is stay close to Arthas by joining his army.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27268,'You want me to do what?','You want me to do what?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27269,'','Well, you\'re not going to sign recruitment papers or anything, but you are going to fight alongside him.$B$BYou need to make sure Arthas culls Stratholme and defeats Mal\'Ganis. Without Uther and Jaina around, he\'ll need all the help he can get.$B$BIf you talk to Arthas, he\'ll put you to work destroying the forces of Mal\'Ganis. Follow along until I can figure out what\'s going on with the Infinites.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27270,'Very well, Chromie.','Very well, Chromie.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27271,'','Good luck, and be safe. Here comes Uther and Jaina now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27272,'Hang on to your hat, $n! To Scalawag we go!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27273,'YAAARRRRR! Here we be, matey! Scalawag Point!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27274,'Greenskin... I know why you\'ve come. You will not find allies in my kind for we do not trust you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27275,'Look, $n, the hourglass has revealed Nozdormu!','Look, $n, the hourglass has revealed Nozdormu!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27276,'%s waves dismissively.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27277,'Bah! You\'re as dumb as a rock! I hope the worms eat all of you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27278,'OWWWW!','OWWWW!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27279,'AYYYIEEE!!','AYYYIEEE!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27280,'YEEOOWCH!','YEEOOWCH!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27281,'AAAAHHH!!','AAAAHHH!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27282,'<Drakuru extends his bleeding hand through the cage and looks at you with anticipation.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27283,'Shake Drakuru\'s outstretched hand.','Shake Drakuru\'s outstretched hand.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27284,'Time was when I\'d pull yer heart out ya just ta see da look on yer face....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27285,'Ey, mon!$b$bGood to be seein\' ya again... $n, right? Yes, yes, of course.$b$bYou and I gunna be real good friends. Drakuru know dese things.$b$b<A grin slowly spreads across the troll\'s painted face.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27286,'I need another of your elixirs, Drakuru.','I need another of your elixirs, Drakuru.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27287,'Farewell, $n. Keep us alive and get some better equipment!','Farewell, $n. Keep us alive and get some better equipment!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27288,'There ya go, mon. Try ta be more careful with this one, won\'t ya?$b$bNow head down ta Drak\'Zin Ruins and drink it near the pedestal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27289,'It is from this throne that I issue the command of Hellscream. His word is life and his word is death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27290,'Shcourged trooolls roashting....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27291,'...on an open fire.....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27292,'That\'s it! Far as I got... Whatd\'ya think?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27293,'','Elune watch over you, $r.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(27294,'Admiral Keller sent me, Emilune. Please send me to Westguard Keep!','Admiral Keller sent me, Emilune. Please send me to Westguard Keep!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27295,'I have arrived. Shall we set to work, then?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27296,'How may this one help you, $gsir:madame;?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27298,'How does this work?','How does this work?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27299,'Show me what you have to trade.','Show me what you have to trade.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27300,'My business partner slays things; I drain a portion of their essence... a pittance, really; the slightest of slivers. It won\'t be missed.$B$BStill, to fulfil my portion of the contract, I pay in Ethereal Credits.$B$BOne may redeem these credits for items I sell at any time. I\'m bound to have something that will interest you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27301,'I can\'t believe that I used to wear that.','I can\'t believe that I used to wear that.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27302,'','This is the only way Harry will even talk to me! I have to keep this stupid mask on all the time...',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(27303,'Harry said I could take his bomber to Bael\'gun\'s. I\'m ready to go!','Harry said I could take his bomber to Bael\'gun\'s. I\'m ready to go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27304,'Look at you fight; no wonder I turned to drinking.','Look at you fight; no wonder I turned to drinking.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27305,'What? Am I here alone. We both have a stake in this, you know!','What? Am I here alone. We both have a stake in this, you know!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27306,'No matter what, you can\'t die, because that would mean that I would cease to exist, right? But, I was here before when I was you. I\'m so confused!','No matter what, you can\'t die, because that would mean that I would cease to exist, right? But, I was here before when I was you. I\'m so confused!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27307,'Wow, I\'d forgotten how inexperienced I used to be.','Wow, I\'d forgotten how inexperienced I used to be.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27308,'Mack belches loudly...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27309,'Oy, mon!$b$bThis not be what it looks like. Well, maybe...$b$bIt be complicated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27310,'Oy mon! I know you?$b$bAhh yeah, Prigmon not forget a face.$b$bYou... followin\' me, mon? Cuz whatver it be, Prigmon never done it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27311,'Sorry, but Chromie said that I couldn\'t reveal anything about your future to you. She said that if I did, I would cease to exist.','Sorry, but Chromie said that I couldn\'t reveal anything about your future to you. She said that if I did, I would cease to exist.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27312,'Wish I could remember how many of the Infinite Dragonflight were going to try to stop you. This fight was so long ago.','Wish I could remember how many of the Infinite Dragonflight were going to try to stop you. This fight was so long ago.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27313,'Listen. I\'m not supposed to tell you this, but there\'s going to be this party that you\'re invited to. Whatever you do, DO NOT DRINK THE PUNCH!','Listen. I\'m not supposed to tell you this, but there\'s going to be this party that you\'re invited to. Whatever you do, DO NOT DRINK THE PUNCH!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27314,'Glad you could make it, Uther.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27315,'Watch your tone with me, boy. You may be the prince, but I\'m still your superior as a paladin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27316,'As if I could forget. Listen, Uther, there\'s something about the plague you should know...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27317,'Oh, no. We\'re too late. These people have all been infected! They may look fine now, but it\'s just a matter of time before they turn into the undead!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27318,'What?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27319,'This entire city must be purged.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27320,'How can you even consider that? There\'s got to be some other way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27321,'Damn it, Uther! As your future king, I order you to purge this city!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27322,'You are not my king yet, boy! Nor would I obey that command even if you were!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27323,'Then I must consider this an act of treason.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27324,'Treason? Have you lost your mind, Arthas?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27325,'Have I? Lord Uther, by my right of succession and the sovereignty of my crown, I hereby relieve you of your command and suspend your paladins from service.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27326,'','Arthas! You can\'t just--',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27327,'It\'s done! Those of you who have the will to save this land, follow me! The rest of you... get out of my sight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27328,'You\'ve just crossed a terrible threshold, Arthas.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27329,'Jaina?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27330,'','I\'m sorry, Arthas. I can\'t watch you do this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27331,'For Drak\'Tharon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27332,'Zim\'bo must live to slay our betrayer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27333,'Zim\'bo cannot be stopped! Da keep must be liberated!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27334,'You be dyin\' along with all dese scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27335,'Betrayed by one of our own we were. Disgraced....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27336,'Ah, more essence to capture...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27337,'','Enjoy the ride! It\'s a one way trip!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27338,'There ya go, mon. Try ta be more careful with this one, won\'t ya?$b$bNow head up north to Zeb\'Halak and drink it near the pedestal!$b$bOh, and be sure ya get the Eye of the Prophets from the head on the ziggurat first...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27339,'There ya go, mon. Try ta be more careful with this one, won\'t ya?$b$bNow head up north to Zeb\'Halak and drink it near the pedestal!$b$bI\'ll instruct you further from there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27340,'There ya go, mon. Try ta be more careful with this one, won\'t ya?$b$bNow head to the passage of Drak\'Atal to the northwest and drink the elixir at the pedestal there. $b$bI\'ll instruct you further when I see you again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27341,'Here is your share.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27342,'Turn around and get back in the fight or I\'ll have to drop you off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27343,'Welcome to me camp, $r.$b$bShe don\'t look like much, but she\'s home fer now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27344,'Ulfang, I need to see through the Eyes of the Eagle again.','Ulfang, I need to see through the Eyes of the Eagle again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27345,'Very well. You are invested once more with her keen eyesight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27346,'Teleport me to Amber Ledge, please.','Teleport me to Amber Ledge, please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27347,'','Mr. Floppy and I went for a walk, but then we got lost and I was really scared, cause there were these wolves, you know, and they chased us, but then I saw this tower and Mr. Floppy and I hid here and the wolves finally went away after a while and it was terrible and now we don\'t know how to get back home.',1,18,0,0,0,0,0,0,1,0,0,0,26124),
(27348,'','I think you should go, $g mister:miss;. You\'re scaring Mr. Floppy.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27349,'May I use a drake to fly elsewhere?','May I use a drake to fly elsewhere?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27350,'How can I help you, child?','How can I help you, child?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27351,'Persistence or stupidity? It matters not. Let this be a lesson learned, mortal!','',0,0,0,0,0,0,0,0,1,6616,0,0,26124),
(27352,'You are welcome in Wyrmrest Temple, $r. Forgive the commotion outside; with Malygos\' recent acts, we have found ourselves besieged. You may still rest here under our protection should you need it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27353,'Tsk, tsk, there\'ll be none of that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27354,'Kill them Abbendis! Do not fail me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27355,'The grand admiral studies you a moment through narrowed eyes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27357,'You served your purpose.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27358,'I will see you in Icecrown, weakling... if you live that long!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27359,'The forces of the Scourge bear down upon us.  Take heart, and fight on!','The forces of the Scourge bear down upon us.  Take heart, and fight on!',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(27360,'Do not lose hope, my $gson:daughter;.  With faith, we will march through this darkness and once again see the dawn.','Do not lose hope, my $gson:daughter;.  With faith, we will march  through this darkness and once again see the dawn.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(27361,'We must resist!  Gird your soul!  Burn the foul plague wherever you find it!','We must resist!  Gird your soul!  Burn the foul plague wherever you find it!',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(27362,'%s opens a Chaotic Rift!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27363,'%s shields himself and diverts his power to the rifts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27364,'Path of Illidan','Path of Illidan',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27365,'Disco Ball','Disco Ball',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27366,'Ethereal Summoner','Ethereal Summoner',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27367,'Hunt for Illidan','Hunt for Illidan',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27368,'You think that you can get rid of me through meditation?','You think that you can get rid of me through meditation?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27369,'Fool! I will destroy you and finally become that which has been building inside of you all of these years!','Fool! I will destroy you and finally become that which has been building inside of you all of these years!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27370,'You cannot defeat me. I\'m an inseparable part of you!','You cannot defeat me. I\'m an inseparable part of you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27371,'NOOOOOOOoooooooooo!','NOOOOOOOoooooooooo!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27372,'Test','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27373,'Nice one, kid.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27374,'Another blue down. We make a great team!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27375,'With you and I working together, this battle will be over in no time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27376,'I never thought that I\'d be riding into battle with a $r on my back.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27377,'I\'m glad you saw that one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27378,'Just hang on. We\'ll get through this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27379,'I\'ve never seen anything like this before. I\'m glad that you\'re here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27380,'Malygos has clearly gone insane.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27381,'The %s directs the blinding swarm directly in front of it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27382,'You have no idea what horrors lie ahead. You have seen nothing! The frozen heart of Naxxramas awaits you!','',0,0,0,0,0,0,0,0,1,7264,0,0,26124),
(27383,'Greetings, $c!$b$bI hope you don\'t mind a little hard work. We could sure use a hand here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27384,'','The wind and trees whisper of unseen troubles.  The land appears healthy, but there\'s more going on here than meets the eye.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27385,'','<Thayreen\'s stare is blank.  Cleansing Vordrassil\'s corruption has taken its toll on the druid.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27386,'Hides for the Horde, mon!  Only the best for our troops!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27387,'Some supplies for the road?  Perhaps a refreshment to enjoy while you watch the fights?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27388,'Enemies are closing in on us from all sides, and all the elders talk of abandoning this post. I say we should stand and fight like the warriors we are.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27389,'Your greatest challenge lies ahead.  Ley-Guardian Eregos is a Blue dragon of immense power. You will find him flying above the uppermost ring.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27390,'You may only fly in Icemist Village.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27391,'','You really shouldn\'t be here, $r.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27392,'You really should not be here, $r. Leave if you value your life.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27393,'Return to the field of battle or your dragon will drop you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27394,'Across this vast expanse rest the bones of my ancestors. Their spirits have ascended to the Chamber of the Aspects.','',0,0,0,0,0,0,0,0,1,7277,0,0,26124),
(27395,'What the Scourge has done here will reverberate throughout our world. The aberrations must be stopped!','',0,0,0,0,0,0,0,0,1,7277,0,0,26124),
(27396,'Galakrond was the progenitor of dragonkind. It was from Galakrond that the Titans shaped the five Aspects.','',0,0,0,0,0,0,0,0,1,7277,0,0,26124),
(27397,'You must remember that I have yet to mature into an elder wyrm. I must eat to renew my strength!','',0,0,0,0,0,0,0,0,1,7277,0,0,26124),
(27398,'Today is a good day, friend. Long has it been since I have left Wyrmrest Temple, free to fly across the great Dragonblight.','',0,0,0,0,0,0,0,0,1,7277,0,0,26124),
(27399,'The queen and her council have been speaking lately of a disaster at Ulduar. Something has happened in Storm Peaks!','',0,0,0,0,0,0,0,0,1,7277,0,0,26124),
(27400,'It truly is a shame that the blue dragonflight has chosen such a heartless, cold path. It pains me greatly to do battle with Malygos\'s children.','',0,0,0,0,0,0,0,0,1,7277,0,0,26124),
(27402,'Drakuru casts his gaze down on Drak\'Tharon Keep....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27403,'Ya done well, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27404,'I have been called back to Wyrmrest, ally. Farewell!','',0,0,0,0,0,0,0,0,1,7277,0,0,26124),
(27405,'Faster, dogs! We mustn\'t relent in our assault against the interlopers!','',0,0,0,0,0,0,0,0,1,7282,0,0,26124),
(27406,'Soon, the bones of Galakrond will rise from their eternal slumber and wreak havoc upon this world!','',0,0,0,0,0,0,0,0,1,7282,0,0,26124),
(27407,'Hear me, minions! Hear your lord, Antiok! Double your efforts or pay the consequences of failure!','',0,0,0,0,0,0,0,0,1,7282,0,0,26124),
(27408,'The Lich King demands more frost wyrms be sent to Angrathar! Meet his demands or face my wrath!','',0,0,0,0,0,0,0,0,1,7282,0,0,26124),
(27409,'Attackers are upon us! Let none through to this ancient grave!','',0,0,0,0,0,0,0,0,1,7282,0,0,26124),
(27410,'The Scythe of Antiok drops to the ground!','',0,0,0,0,0,0,0,0,1,7281,0,0,26124),
(27411,'What do we have here... those that would defy the Spell-Weaver? Those without foresight or understanding. How can I make you see? Malygos is saving the world from itself! Bah! You are hardly worth my time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27412,'Poor blind fools!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27413,'Clearly my pets failed. Perhaps another demonstration is in order.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27414,'Still you fight. Still you cling to misguided principles. If you survive, you\'ll find me in the center ring.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27415,'You think you\'ve won, mortal? Face the unbridled power of Antiok!','',0,0,0,0,0,0,0,0,1,7281,0,0,26124),
(27416,'Behold! The Scythe of Antiok!','',0,0,0,0,0,0,0,0,1,7281,0,0,26124),
(27417,'I call \'er the Spirit of Gnomeregan. Isn\'t she a beaut? Without your help, she\'d\'ve never been restored.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27418,'Right!  Let\'s try this so-called dire brew...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27419,'By Bronzebeard\'s beard!  What a drink!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27420,'It is a shame Coren\'s Dire Brew can\'t quench more thirsting throats!  It\'s blasphemy, I know, but  I envy those Dark Iron dwarves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27421,'$n, this beer... well, it might be the best of Brewfest!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27422,'Welcome to Argent Stand, $c.$b$bMake yourself at home, but don\'t get too comfortable. We\'re not out of the woods yet - far from it.$b$bIf we\'re going to make it out of here in one piece, everyone\'s going to have to do their share... including you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27423,'The Dread Captain DeMeza has pulled into Booty Bay and declared it Pirates\' Day!$B$BShe\'s making anyone who\'s brave enough to share a drink with her an honorary crewmember.','The Dread Captain DeMeza has pulled into Booty Bay and declared it Pirates\' Day!$B$BShe\'s making anyone who\'s brave enough to share a drink with her an honorary crewmember.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(27424,'We\'re in a fine mess here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27425,'The land is defiled by the presence of the Scourge on one side and the rituals of the Drakkari on the other.$B$BWe stand resolute betwixt the two.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27426,'Thank the Light for you!','Thank the Light for you!',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(27427,'Hey there, $c. We\'re in the middle of a battle here.','Hey there, $c. We\'re in the middle of a battle here.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(27428,'What are you doing out here?','What are you doing out here?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(27429,'Aren\'t you $n? I\'d heard you were dead.','Aren\'t you $n? I\'d heard you were dead.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(27430,'Make it quick... the fighting here is grim. I need to stay sharp.','Make it quick... the fighting here is grim. I need to stay sharp.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(27431,'You a new recruit? That\'s not standard issue armor.','You a new recruit? That\'s not standard issue armor.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(27432,'Oh good, reinforcements!','Oh good, reinforcements!',71,0,0,0,0,0,0,0,1,0,0,0,26124),
(27433,'You have a message for me?','You have a message for me?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(27434,'Soldier, you have new orders. You\'re to pull back and report to the sergeant!','Soldier, you have new orders. You\'re to pull back and report to the sergeant!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27435,'Well time\'s money, and time\'s wasting!  Let\'s have that drink...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27436,'Wow!  This really greases the steamplugs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27437,'If I were an honest goblin, I\'d say this was the best beer of the festival...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27438,'Too bad Coren\'s dead.  If I could buy that brew from him and resell it -- watered down and rebottled under my own label, of course -- I\'d be rich!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27439,'Little hairier out here than you expected, $r?$b$bCan\'t say I\'m surprised. I hear that from most everyone who makes it this far.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27440,'I\'ll have you at Amberpine Lodge in no time, ally! We just have to make one brief stop first...','I\'ll have you at Amberpine Lodge in no time, ally! We just have to make one brief stop first...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27441,'I am Ubungo. I represent the Zandalar tribe.$B$BBad things are afoot, $r. The Drakkari are going to be their own doom with what they\'re up to.$B$BSome trolls never learn.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27442,'We\'re gonna do a quick fly by Conquest Hold to see what those filthy, no good, Horde are up to. Keep your eyes peeled for their wind riders. Not that they\'d ever catch me!','We\'re gonna do a quick fly by Conquest Hold to see what those filthy, no good, Horde are up to. Keep your eyes peeled for their wind riders. Not that they\'d ever catch me!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27443,'What in the name of Bronzebeard is goin\' on here? Look at this place! I think...','What in the name of Bronzebeard is goin\' on here? Look at this place! I think...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27444,'Uh-oh. We\'ve got company! HOLD ON TIGHT! I\'m gonna try and lose \'em!','Uh-oh. We\'ve got company! HOLD ON TIGHT! I\'m gonna try and lose \'em!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27445,'Thanks, $c.','Thanks, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27446,'Right. I\'d better get back to the sergeant then.','Right. I\'d better get back to the sergeant then.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27447,'See you around.','See you around.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27448,'Watch your back. These Drakkari are a nasty lot.','Watch your back. These Drakkari are a nasty lot.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27449,'Careful here, $c. These trolls killed their own snake god!','Careful here, $c. These trolls killed their own snake god!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27450,'Don\'t stay out here too long.','Don\'t stay out here too long.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27451,'I wonder where we\'re headed to. And who\'s going to deal with these guys?','I wonder where we\'re headed to. And who\'s going to deal with these guys?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27452,'These Drakkari are just bad news. We need to leave and head to Justice Keep!','These Drakkari are just bad news. We need to leave and head to Justice Keep!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27453,'Ahoy, me hearty!$B$BToday\'s OUR day, ye know... PIRATES\' DAY!$B$BOl\' Chumbucket and I came up with the idea, and once the Dread Captain heard of it... well, here we are!','',396,5,396,0,3,2,0,0,1,0,0,0,26124),
(27454,'Tomorrow, the baron gets his town back... but for today - Pirates\' Day - it belongs to the Dread Captain DeMeza and her crew. Yarrr!$B$BAnd remember: lookin\' the part\'s only HALF the celebration. Talk like a pirate, $glad:lass;!','',396,15,396,0,3,2,0,0,1,0,0,0,26124),
(27455,'Hapana simply grunts and waves you away towards the Dread Captain DeMeza.$B$BBeneath the fur of one massive arm can be seen a tattoo of the word \"MAGATHA\" in an arrow-pierced heart.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(27456,'SQUAWK! Keelhaul the lad! Keelhaul!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27457,'SQUAWK! Walk the plank! Walk!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27458,'SQUAWK! Shiver me timbers! Shiver!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27459,'SQUAWK! Avast, ye scurvy dogs! Avast!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27460,'','Ye\'ve got some stones comin\' up here, $glad:lass;. It\'s Pirates\' Day, ye know... and \'til the sun rises on the morrow, Booty Bay is MINE.$B$BSo! What do ye say? Raise a drink ta me and me crew, and join the celebration?',1,397,0,0,4,0,0,0,1,0,0,0,26124),
(27461,'Oh... I\'m feeling groggy...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27462,'Don\'t bother me, $c!  I have two whole cauldrons of bubbling brew here and I must ensure they taste just right!$B$BIf they don\'t, then Master Coren Direbrew will flay and boil me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27463,'Here\'s to you, Dread Captain! Make me a pirate for the day.','Here\'s to you, Dread Captain! Make me a pirate for the day.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27464,'May I help you taste?','May I help you taste?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27466,'Take position here, and I will lead a small force inside Stratholme to begin the culling. We must contain and purge the infected for the sake of all of Lordaeron!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27467,'Welcome to Booty Bay, partner.  Don\'t mind DeMeza and her crew... we let the hellion run riot one day a year, Pirates\' Day, and then she leaves us in peace to go plunder the South Seas again.$B$BNow then... what can this humble servant of the Steamwheedle Cartel do for you?  Better still - what can you do for me, eh?','',3,1,0,0,0,0,0,0,1,0,0,0,26124),
(27468,'This is getting good!  It really warms the stomach!  And $n, I have to say, you\'re a sharp dressing $gfellow:lass;!','',7,11,0,0,0,0,0,0,1,0,0,0,26124),
(27469,'This is good stuff!  But it\'s a little weak.  I think I\'ll add a little more garlic breath to it...','',7,1,0,0,0,0,0,0,1,0,0,0,26124),
(27471,'','Ahoy! It\'s Pirates\' Day, ye know... and \'til the sun rises on the morrow, Booty Bay is MINE.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27472,'I think we lost \'em! That was a close one! Welp, as promised, Amberpine Lodge in one piece! Keep your feet on the ground, friend!','I think we lost \'em! That was a close one! Welp, as promised, Amberpine Lodge in one piece! Keep your feet on the ground, friend!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27473,'INTRUDERS! KILL THEM!','',0,0,0,0,0,0,0,1,1,7296,0,0,26124),
(27474,'ALLIANCE FILTH! DIE! DIE!','',0,0,0,0,0,0,0,1,1,7296,0,0,26124),
(27475,'Take their heads! For the Horde!','',0,0,0,0,0,0,0,1,1,7296,0,0,26124),
(27476,'Truly, the horrors here surpass those we\'ve endured in the Plaguelands.$b$bThe Scourge are more powerful now than ever before.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27477,'I can\'t take it anymore....$b$bThey kill you, then eat you! And that\'s if you\'re lucky!','I can\'t take it anymore....$b$bThey kill you, then eat you! And that\'s if you\'re lucky!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27478,'You gotta help me get outta here, $r!$b$bI don\'t wanna become like them!','You gotta help me get outta here, $r!$b$bI don\'t wanna become like them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27479,'I haven\'t been able to eat or sleep since I got here.$b$bI\'m just not cut out for the Crusade....','I haven\'t been able to eat or sleep since I got here.$b$bI\'m just not cut out for the Crusade....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27480,'<sob> My uncle served in the Argent Dawn.$b$bHow was he able to face these foul things?','<sob> My uncle served in the Argent Dawn.$b$bHow was he able to face these foul things?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27481,'Every time I close my eyes I see the scourge surrounding me!$b$bI gotta get outta here....','Every time I close my eyes I see the scourge surrounding me!$b$bI gotta get outta here....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27482,'I\'m going to die here... I just know it.','I\'m going to die here... I just know it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27483,'We\'re doooomed!!','We\'re doooomed!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27484,'Get out of here while you can, $c!$b$bThere\'s no way we can win....','Get out of here while you can, $c!$b$bThere\'s no way we can win....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27485,'','This is a fine mess.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27486,'Get out there and make those Scourge wish they were never reborn!','Get out there and make those Scourge wish they were never reborn!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27487,'This is good stuff!  But I think it\'s a little flat.  Let\'s round it out with a few squishy basilisk eyeballs...','',7,1,0,0,0,0,0,0,1,0,0,0,26124),
(27488,'Not bad, not bad... But it\'s missing spice!  How about adding scorpid venom?  Yes!  That\'ll fix it right up!','',7,1,0,0,0,0,0,0,1,0,0,0,26124),
(27489,'It\'s shaping up!  But it needs more kick.  Yep, you guessed it... Let\'s wash yesterday\'s socks in the cauldron... Mmmh, delicious!','',7,4,0,0,0,0,0,0,1,0,0,0,26124),
(27490,'Yes $gsir:ma\'am;, this is quite a drink!  Quite a drink indeed!','',7,273,0,0,0,0,0,0,1,0,0,0,26124),
(27491,'Let\'s sing a song!$B$BBrew, brawl,$BBrew, brawl!$BA Dark Iron\'s life for me!$B$BHah hah!  $n, I like you!','',7,5,0,0,0,0,0,0,1,0,0,0,26124),
(27492,'Now where was I?  I yeah...  So I said to her, \"But I need you!  I need you!\"... and she just laughed and slithered away!  It\'s the honest truth, $n.  Naga can be so cruel!','',7,18,0,0,0,0,0,0,1,0,0,0,26124),
(27493,'Let\'s taste more!','Let\'s taste more!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27494,'Another drink!','Another drink!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27495,'Another!','Another!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27496,'You\'re right! What was I thinking? Bring on the Scourge!','You\'re right! What was I thinking? Bring on the Scourge!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27497,'You\'re right! We can do this!','You\'re right! We can do this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27498,'We can win this war!','We can win this war!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27499,'For the Argent Crusade! The Scourge shall fail!','For the Argent Crusade! The Scourge shall fail!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27500,'We\'ll cleanse this place! Arthas beware!','We\'ll cleanse this place! Arthas beware!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27501,'You dare summon me?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27502,'Prepare to drown!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27503,'The depths consume you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27504,'I will add your watery innards to my own.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27505,'%s looks for a nearby corpse to cannibalize.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27506,'The %s chews on nearby vegetation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27507,'Drink deep my brothers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27508,'The mojo of Sseratus is ours. Now all will be crushed under the might of the Drakkari!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27509,'They dare attack us? The fools! Do they not know we are now all-powerful?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27510,'Kill these invaders who dare to defile our altar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27511,'Finish them and then we will move south to kill their brethren!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27512,'With the power of the wild gods burning in our veins, none, not even the Lich King, can stand in our way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27513,'I see you, insect! Come closer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27514,'I will destroy the Argent Crusade! I will crush the Scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27515,'I wouldn\'t do this on any other day, but... I\'m thirsty and I hate drinking alone.$B$BBottoms up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27516,'Cheers!','Cheers!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27517,'All officers should check in with me when their squads are ready. We\'ll enter Stratholme on my order.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27518,'Are you ready to do whatever must be done to protect Lordaeron?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27519,'BOOM!$b$bThat\'s the last thing I remember...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27520,'<sigh>... This is the end of me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27521,'Thank you, friend. Were it not for your aid I would be no more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27522,'<sigh>...$b$bA little help here, perhaps?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27523,'<sigh>... Well, I suppose it could be worse.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27524,'Yes, my Prince. We are ready.','Yes, my Prince. We are ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27525,'Don\'t mind me. I\'m just an old man, waiting on an old... friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27526,'','Ohhh, the pain is... overwhelming....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27527,'','Ohhh, I... cannot go on....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27528,'','I am in your debt, friend. Thank you for my life.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27529,'','Hurry, $r.$b$bTime is running out for me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27530,'Hurry, $g brother : sister;. I\'m leaking here....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27531,'Mmm, more mojo.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27532,'NOOOOOOOOooooooo.........!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27533,'<sigh>... Do you think we could move out, $c?$b$bI\'m losing fluid fast!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(27534,'Fire! Must be the damned drakes again. Come on!','Fire! Must be the damned drakes again. Come on!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27535,'Everyone looks ready. Remember, these people are all infected with the plague and will die soon. We must purge Stratholme to protect the remainder of Lordaeron from the Scourge. Let\'s go.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27536,'To the well! HURRY!','To the well! HURRY!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27537,'Onward, you maggots!  This land is the Lich King\'s now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27538,'Nothing can stop the Scourge!  Nothing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27539,'Crush anything that stands in your path!  For the Lich King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27540,'Im... possible...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27541,'Die like a dog!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27543,'HAH! How do you like THAT?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27545,'You challenge Don Carlos? Guerrero! GO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27546,'I\'ll take a ride to my first post, please.','I\'ll take a ride to my first post, please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27547,'Prince Arthas, may the light be praised! Many people in the town have begun to fall seriously ill, can you help us?','Prince Arthas, may the light be praised! Many people in the town have begun to fall seriously ill, can you help us?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27548,'I can only help you with a clean death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27549,'What? This can\'t be!','What? This can\'t be!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27550,'%s begins to cast Magic Pull!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27552,'Oh, no...','Oh, no...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27553,'That was just the beginning.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27554,'Drake incoming! OPEN FIRE!','Drake incoming! OPEN FIRE!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27555,'She\'s attacking the keep! Bring her down!','She\'s attacking the keep! Bring her down!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27556,'Damn it...','Damn it...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27557,'Look lively! Keep firing!','Look lively! Keep firing!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27558,'The keep is ablaze! Bombardiers, where in the Nether are you?!','The keep is ablaze! Bombardiers, where in the Nether are you?!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27559,'On the move to the southern pass!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27560,'They\'re backing off here... get to the south pass! Quickly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27561,'They\'re pushing in the south!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27562,'To the south! Move!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27563,'There are more to the south!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27564,'South! Now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27565,'On the move back up to the eastern pass!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27566,'They\'re backing off here... get to the east pass! Quickly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27567,'Head back up to the east pass! They\'re pushing hard!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27568,'Up to the eastern pass! Move!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27569,'There are more at the east pass!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27570,'East Pass! Now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27571,'One of the cultists seems to have stumbled onto my blade and died... can I have a new disguise? I promise that I will be more careful this time.','One of the cultists seems to have stumbled onto my blade and died... can I have a new disguise? I promise that I will be more careful this time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27572,'Entering Phase 4 <PH>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27573,'My precious magmawyrms... perhaps not all is lost... perhaps there is something left to raise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27574,'Yes, this is the beginning. I\'ve been waiting for you, young prince. I am Mal\'Ganis.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27575,'As you can see, your people are now mine. I will now turn this city household by household, until the flame of life has been snuffed out... forever.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27576,'Tabard of the Arcane','Tabard of the Arcane',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27577,'I won\'t allow it, Mal\'Ganis! Better that these people die by my hand than serve as your slaves in death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27578,'Tabard of Brilliance','Tabard of Brilliance',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27579,'Tabard of the Defender','Tabard of the Defender',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27580,'Tabard of Fury','Tabard of Fury',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27581,'Tabard of Nature','Tabard of Nature',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27582,'Tabard of the Void','Tabard of the Void',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27583,'What is it? Can\'t you see that I\'m busy?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(27584,'Mal\'Ganis will send out some of his Scourge minions to interfere with us. Those of you with the strongest steel and magic shall go forth and destroy them. I will lead the rest of my forces in purging Stratholme of the infected.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27585,'Come for training, have you?','Come for training, have you?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27586,'You\'re no death knight. Away with you.','You\'re no death knight. Away with you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27587,'I am interested in death knight training.','I am interested in death knight training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27588,'Hey guys! Take care of that guy, I\'ll fix the machine thing! [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27589,'This is a wee bit trickier than before... Oh, bloody--incomin\'!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27590,'What in the name o\' Madoran did THAT do? Oh! Wait: I just about got it...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27591,'Ha, that did it! Help\'s a-comin\'! Take this, ya glowin\' iron brute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27592,'What are you looking down at?$B$BI\'ll have you know that the Pestlepots are a storied family with a long tradition of pestling.$B$BYes, that\'s a word!$B$BThere are no finer alchemists in all of Azeroth, or anywhere else for that matter, I can assure you!$B$BI may carry the title of apprentice at the moment, but my skill is second to none! One must endure such humilities though to get places in life.$B$BOf course, maybe you\'re just here to help me?$B$B<The diminuitive gnome grins arrogantly.>','',396,396,396,0,0,0,0,0,1,0,0,0,26124),
(27593,'','Now I\'ll show you the REAL power of the Onslaught!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27594,'','Listen, you tell Schweitzer and Roitau that we\'ve got everything under control here. They don\'t gotta... what?$B$BThey didn\'t send you? Then what are you wasting my time for?$B$BI\'ve got work to do!',1,5,0,0,3,0,0,0,1,0,0,0,26124),
(27595,'Hey, can\'t you see I\'m busy here?!$B$BYou wanna watch the show? The band plays every night at eight.','',5,1,0,0,1,0,0,0,1,0,0,0,26124),
(27596,'','You\'ve come to test the might of the Onslaught?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27597,'','Deal with this intrusion quickly. I don\'t have time for this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27598,'','You may want to rethink your actions, fool.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27599,'','Am I going to have to deal with this intrusion myself?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27600,'But I drove my mole machine all the way down here...','But I drove my mole machine all the way down here...',5,1,0,0,1,0,0,0,1,0,0,0,26124),
(27601,'Well... fine, fine. We need to test the equipment anyhow.$B$BGimme a few seconds. I\'ll have \'em come out to \"rehearse.\"$B$BYou ready?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27602,'I\'m ready.','I\'m ready.',5,1,0,0,1,0,0,0,1,0,0,0,26124),
(27603,'Let\'s wrap it up, Miz. They\'ll be here in a second.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27604,'<The Injured Rainspeaker Oracle groans in pain.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27605,'No! You steal kill! Now you owe Gekgek!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(27606,'Greetings, $r.$b$bI\'m afraid you must excuse me as I\'m terribly busy at the moment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27607,'The %s screams with rage and rushes to the aid of her babies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27608,'Time is of the essence here, $n. Are you prepared to be tested?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27609,'I\'m ready to begin. What is the first ingredient you require?','I\'m ready to begin. What is the first ingredient you require?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27610,'Over here, to the southeast. I see they got you, too...','',0,0,0,0,0,0,0,0,1,8886,0,0,26124),
(27611,'More intruders? You\'ll soon learn, no one messes with the Venture Company!','More intruders? You\'ll soon learn, no one messes with the Venture Company!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27612,'I\'ll get you this time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27613,'Well now, I\'m surprised to see other adventurers in a place such as this!$B$BNow that you\'re here, ye can help me get to the Tribunal. If my research theories about these halls is correct, information pertainin\' to the creation o\' the entire dwarven race lies within.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27614,'Brann, it would be our honor!','Brann, it would be our honor!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27616,'Let\'s move Brann, enough of the history lesson!','Let\'s move Brann, enough of the history lesson!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27617,'If only my dear brothers could be here with me at this moment in time. They would not believe what a discovery this will be!$B$BThe Tribunal are the librarians for the Titan discs, which are stored in this very room.$B$BLook! You can see the discs beneath the floor! We must hurry, the greatest discovery of Dwarven kind is just up ahead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27618,'First we\'ll need to add a knotroot to the pot. Don\'t drag your feet, now....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27619,'Pitiful... just pitiful.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27620,'I\'ll send you on my flying machine. Keep your eyes peeled for clues about what might\'ve happened to Hemet!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27621,'WARNING: Missile lock detected. Engaging evasive maneuvers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27622,'Rise and serve!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27623,'Now you will work off the offense of shooting down Kolramas for all eternity.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27624,'Death is no escape.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27625,'In the name of the Lich King.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27626,'Now you are in the Lich King\'s embrace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27627,'Soon we will have the power of your gods!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27628,'Go forth and slay our enemies so that our army may grow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27629,'Finally you know your true destiny.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27630,'Tastes like it needs more....','Tastes like it needs more....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27631,'Could use a little...','Could use a little...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27632,'Before it thickens, we must add...','Before it thickens, we must add...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27633,'Quickly, get me some...','Quickly, get me some...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27634,'Ahh, yes. I know just the thing...','Ahh, yes. I know just the thing...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27635,'Yes, yes. Definitely needs more...','Yes, yes. Definitely needs more...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27636,'I think it needs...','I think it needs...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27637,'Find me some...','Find me some...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27638,'','All of Northrend is colder than a witch\'s heart; yet here we are...  There must be some explanation!  Quite possibly one related to the crystal pillars!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27639,'','The presence of titan architecture in this region is quite... interesting.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27640,'','The similarities between this place and Un\'goro are uncanny.  Maybe the two are connected in some way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27641,'','How long until we can have another pilot airborne?  I need aerial surveys if my research is going to get anywhere.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27642,'Scourge forces have been spotted near the King\'s Square fountain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27643,'Scourge forces have been spotted near the Market Row Gate!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27644,'Scourge forces have been spotted near the Festival Lane Gate!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27645,'Scourge forces have been spotted near the Elder\'s Square Gate!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27646,'Scourge forces have been spotted near the Town Hall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27647,'Knotroot!','Knotroot!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27648,'Pickled Eagle Egg!','Pickled Eagle Egg!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27649,'Speckled Guano!','Speckled Guano!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27650,'Withered Batwing!','Withered Batwing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27651,'Seasoned Slider Cider!','Seasoned Slider Cider!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27652,'Pulverized Gargoyle Teeth!','Pulverized Gargoyle Teeth!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27653,'Muddy Mire Maggot!','Muddy Mire Maggot!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27654,'Spiky Spider Egg!','Spiky Spider Egg!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27655,'Hairy Herring Head!','Hairy Herring Head!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27656,'Putrid Pirate Perspiration!','Putrid Pirate Perspiration!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27657,'Icecrown Bottled Water!','Icecrown Bottled Water!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27658,'Wasp\'s Wings!','Wasp\'s Wings!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27659,'Prismatic Mojo!','Prismatic Mojo!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27660,'Raptor Claw!','Raptor Claw!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27661,'Amberseed!','Amberseed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27662,'Burning Ice!','Burning Ice!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27663,'Shrunken Dragon\'s Claw!','Shrunken Dragon\'s Claw!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27664,'Chilled Serpent Mucus!','Chilled Serpent Mucus!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27665,'Crystallized Hogsnot!','Crystallized Hogsnot!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27666,'Crushed Basilisk Crystals!','Crushed Basilisk Crystals!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27667,'Trollbane!','Trollbane!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27668,'Frozen Spider Ichor!','Frozen Spider Ichor!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27669,'Destroy the Drakkari! Destroy the Argent Crusade! Make Scourge of them all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27670,'My beautiful Kolramas! You will all pay dearly for this outrage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27671,'Come fools, meet your doom! I\'m waiting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27672,'Drakkari, this will not stop us from stealing the power of your wild gods. We will take it from them directly, or from you if you\'ve already killed them; it matters not.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27673,'Many Argent Dawn are numbered amongst the simpletons that have fallen before me. The Argent Crusade will prove no different.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27674,'If you kill them, I will simply reanimate their corpses. And when you die, I will do the same to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27675,'You cannot stand against the might of the Lich King, mortals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27676,'Undeath is inevitable!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27677,'We need some...','We need some...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27678,'It simply must have some...','It simply must have some...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27679,'Next, we\'ll need...','Next, we\'ll need...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27680,'Alright, now fetch me some...','Alright, now fetch me some...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27681,'Almost finished! We still need...','Almost finished! We still need...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27682,'Before it boils over, I need...','Before it boils over, I need...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27683,'It\'s thickening! Quickly, get some...','It\'s thickening! Quickly, get some...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27684,'Coming along nicely, but still needs...','Coming along nicely, but still needs...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27685,'We\'re nearly there. Find me some...','We\'re nearly there. Find me some...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27686,'Blast! You have failed me!','Blast! You have failed me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27687,'No! The serum is ruined!','No! The serum is ruined!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27688,'You\'re too late. I must start again from the beginning....','You\'re too late. I must start again from the beginning....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27689,'Burning Ice!','Burning Ice!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27690,'Hmmm, I think it\'s time for...','Hmmm, I think it\'s time for...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27691,'Useless pile of bones...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27693,'Even in undeath, you are useless.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27694,'Begone to your eternal torment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27695,'You shall not enjoy this release.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27696,'Enough.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27697,'So the oracle has decided to aid you, outlander. Very well, I will offer you what I know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27698,'Your companion seeks the shardhorn patriarch Farunn, who holds himself aloof from his brothers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27699,'Farunn walks the lands north of what your people call the Bittertide Falls. You will find him alone, but you will see he requires no defenders.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27700,'Activating','Activating',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27701,'Return to your companion. Tell him to go forth and claim his prize in Farunn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27702,'Once he has done so, tell him to leave this land in peace. He does not belong here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27703,'I do not understand this fruit vendor or their ogre.  It seemed as though war was upon us... Yet nothing has happened.','I do not understand this fruit vendor or their ogre.  It seemed as though war was upon us... Yet nothing has happened.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(27704,'The fruit vendor has refused to accept my challenge and remove his cart.  Their ogre protector just sits and does nothing... What could his plan be?','The fruit vendor has refused to accept my challenge and remove his cart.  Their ogre protector just sits and does nothing... What could his plan be?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(27705,'We should sell these apples, but we will not allow peole to eat them.  Oh no!  We will sell apples to our friends, and they shall bring the fight to the fruit vendor for me!','We should sell these apples, but we will not allow peole to eat them.  Oh no!  We will sell apples to our friends, and they shall bring the fight to the fruit vendor for me!',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(27706,'My army has not arrived.  I knew I could not trust the people I hired.  We will recruit new people.  We will sell these apples and our new army will crush them!','My army has not arrived.  I knew I could not trust the people I hired.  We will recruit new people.  We will sell these apples and our new army will crush them!',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(27707,'It\'s time to deal with this fruit situtation on our terms.  We\'ve been far too accomidating to the fruit vendor.  Now we will simply sell the fruit.  But the fruit will not be for people to eat.  I forbid it!  No one will eat our fruit!','It\'s time to deal with this fruit situtation on our terms.  We\'ve been far too accomidating to the fruit vendor.  Now we will simply sell the fruit.  But the fruit will not be for people to eat.  I forbid it!  No one will eat our fruit!',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(27708,'FRUIT VENDOR!!! Your cart is still in our way!  Your time is up!  You have new competition in selling fruit!','FRUIT VENDOR!!! Your cart is still in our way!  Your time is up!  You have new competition in selling fruit!',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(27709,'YOU HAVE RUN OUT OF TIME FRUIT VENDOR!!  NOW I WILL SELL YOUR ROTTEN FRUIT!','YOU HAVE RUN OUT OF TIME FRUIT VENDOR!!  NOW I WILL SELL YOUR ROTTEN FRUIT!',6,53,0,0,3,0,0,0,1,0,0,0,26124),
(27710,'HA!  I CRUSHED AN APPLE, FRUIT VENDOR! NOW,  YOUR APPLES WILL BE SOLD TO OTHERS FOR THEM TO CRUSH AS WELL!','HA!  I CRUSHED AN APPLE, FRUIT VENDOR! NOW,  YOUR APPLES WILL BE SOLD TO OTHERS FOR THEM TO CRUSH AS WELL!',388,0,0,0,0,0,0,0,1,0,0,0,26124),
(27711,'IF WAR IS WHAT YOU WANT, WAR IS WHAT YOU SHALL GET, FRUIT VENDOR!  WE WILL SEE WHO SELLS MORE OF YOUR APPLES!','IF WAR IS WHAT YOU WANT, WAR IS WHAT YOU SHALL GET, FRUIT VENDOR!  WE WILL SEE WHO SELLS MORE OF YOUR APPLES!',388,0,0,0,0,0,0,0,1,0,0,0,26124),
(27712,'Drink, mortals!  Taste my blood!  Taste your death!','Drink, mortals!  Taste my blood!  Taste your death!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27713,'I will suffer your presence no longer. Begone. Find someone else to extort.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27714,'The last thing that we needed was for the crazy Drakkari trolls to shoot down a Scourge necropolis in our backyard.$B$BHow did they manage to do that?!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27715,'','Ugh, I should never have volunteered to be a specialist. They always ask us to do the impossible!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27716,'Play time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27717,'You are too late, champion of Lordaeron. The dead shall have their day.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27718,'Hurry, $c!$b$bPut the ingredients directly in the pot. Time is of the essence!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27719,'Oops I tripped some sort of alarm! I can fix this, just cover my back! [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27720,'Oh no, another face activated! [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27721,'The last face is active, be careful! I am almost done, keep them back! [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27722,'I got it! That should take care of it! [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27723,'<The captive crocolisk lets out a low growl as you approach.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27724,'You look safe enough... let\'s do this.','You look safe enough... let\'s do this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27725,'','Excellent day for a foray into the field wouldn\'t you say, $g sir : ma\'am;?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27726,'Yes, yes, we should do whatever we can to help them.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(27727,'Longrunner, your fodder... err, people will be a valuable resource against the vrykul. Did I say resource? I meant, \'ally.\' \n','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(27729,'No! Keep that thing away from my zeppelin!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(27730,'Sir, yes sir!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27731,'%s sniffs the air, catching the scent of something unusual.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27732,'<Reach down and pull the Injured Rainspeaker Oracle to its feet.>','<Reach down and pull the Injured Rainspeaker Oracle to its feet.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27733,'Crusader! Take this wood and light a fire for the troops.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27734,'','Oh, these are sticky! I wonder how they shoot the webbing?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27735,'','ACK! Oh no, I webbed myself! It\'s sticky. MY HAIR!',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(27736,'','Okay! Let me just see if I can fashion these disgusting parts into something useful.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27737,'','Eureka!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27738,'Shaman Vekjik comes out of the underbrush nearby.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27739,'You help Rainspeaker! I saw you help Rainspeaker! Traitor thing!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(27740,'If you want to be friends with big-tongues, you not friends with Frenzyheart! I tell village! We no trust you anymore!','',5,0,0,1,0,0,0,0,1,0,0,0,26124),
(27741,'Shaman Vekjik scurries off towards Frenzyheart Hill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27742,'You must be one of the brave soldiers who have been fighting the Scourge forces of Mal\'Ganis. Well done.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(27743,'Indeed. Mal\'Ganis is commanding the Scourge from Crusaders\' Square, but the gates leading there from the city entrance are closed.$B$BLittle does he know that a small force can still reach the Square by moving through the Town Hall. Will you join me in this attack?','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(27744,'We\'re only doing what is best for Lordaeron, your Highness.','We\'re only doing what is best for Lordaeron, your Highness.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27745,'Lead the way, Prince Arthas.','Lead the way, Prince Arthas.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27746,'Now we will see why this ore is so important to the Scourge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27747,'Korfax, what can you tell from this saronite?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27748,'Never heard of it. Looks like pure evil.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27749,'Let\'s see how it holds up to the might of my axe!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27750,'What the? My reaper didn\'t even scratch it! That\'s the toughest ore I\'ve ever seen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27751,'Home time!','Home time!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27752,'Thanks!','Thanks!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(27753,'Home not far. Come!','Home not far. Come!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27754,'Ahh! It\'s coming right for us!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(27755,'Not the \'stache! Now I\'m asymmetrical!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27756,'My ear! You grazed my ear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27757,'Ouch! That\'s it, I quit the target business!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27758,'No! That was my good side!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27759,'Rayne, Rimblat, what about the power of nature and the elements?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27760,'The avenger snorts, clearly unimpressed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27761,'Calm down, lad, it\'s just birdshot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27762,'Bah, it\'s an improvement.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27763,'','By the Goddess. It\'s as if Nature can\'t touch it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27764,'Stop whining. You\'ve still got your luck.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27765,'The only thing hurt is your pride, lad. Buck up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27766,'Nothing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27767,'Metz?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27768,'You know what.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27769,'No surprise there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27770,'What?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27771,'Fine. Just remember though, the power of the Holy Light isn\'t something to be invoked casually, brother.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27772,'What\'s it doing?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27774,'Clearly this is getting us nowhere. We need to get this saronite to Highlord Fordring for further study.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27775,'Thank you for trying, my friends. We\'ll unlock its secrets. Hopefully before it\'s too late.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27776,'%s grunts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27777,'Surely you can see the futility of it all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27778,'Good shot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27779,'Saronite you say?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27780,'I smell... $r.  Delicious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27781,'I shall consume you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27782,'Drums of War','Drums of War',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27783,'Let us see if it is truly impervious.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27784,'%s rolls his eyes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27785,'The Injured Rainspeaker Oracle rises clumsily to its feet.','The Injured Rainspeaker Oracle rises clumsily to its feet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27786,'','Gah!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27787,'Whoa!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27788,'Oof!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27789,'%s dusts himself off.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27790,'NO!','NO!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27791,'Help me!','Help me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27792,'Somebody help!','Somebody help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27793,'Shoot it down!','Shoot it down!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27794,'Light save me!','Light save me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27795,'Let me go!','Let me go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27796,'Help!','Help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27797,'Gah!','Gah!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27798,'Dumb big-tongue lover! You not friend of Frenzyheart no more. Frenzyheart will get you good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27799,'Oh no! Some puppy-men followed!','Oh no! Some puppy-men followed!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(27800,'Follow me, I know the way through.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27801,'Sir, our customers are complaining that there\'s not enough Maiden\'s Anguish in our Deadly Poisons.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27802,'Sir, our customers are complaining that there\'s too much Deathweed in our Anesthetics.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27803,'Sir, I think we were close with the Lethargy Root in that last poison recipe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27804,'Wright, have you finished that new concoction you\'ve been working on? I\'m tired of these spores filling up my shop!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27805,'Then put twice as much in next time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27806,'Only put half as much in next time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27807,'Remember, kid: You\'re always more wrong than you think you are. Double It!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27808,'I\'m working on it, I just don\'t want to sell it until I\'m happy with it. It shouldn\'t be long.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27809,'Skadi the Ruthless is within range of the harpoon launchers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27810,'That\'s what you always say. Sometimes I think you\'re never going to finish that thing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27811,'Ah, you\'ve finally arrived Prince Arthas. You\'re here just in the nick of time.','Ah, you\'ve finally arrived Prince Arthas. You\'re here just in the nick of time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27812,'Yes, I\'m glad I could get to you before the plague.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27813,'Ooh! Shinies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27814,'What is this sorcery?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27815,'There\'s no need for you to understand, Arthas. All you need to do is die.','There\'s no need for you to understand, Arthas. All you need to do is die.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27816,'The Horde has captured Wintergrasp Fortress!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27817,'The Alliance has captured Wintergrasp Fortress!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27818,'','If you\'ve got somewhere to go, I can get you there.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(27819,'Do you think I could take a ride on one of those flying machines?','Do you think I could take a ride on one of those flying machines?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27820,'Kara, I need to be flown out to the Dens of Dying to find Bixie.','Kara, I need to be flown out to the Dens of Dying to find Bixie.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27821,'Taunt Flag','Taunt Flag',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27822,'Bear Mount','Bear Mount',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27823,'I am ready to travel to your village now.','I am ready to travel to your village now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27824,'We wait until you ready.','',0,0,0,0,0,0,0,0,1,7333,0,0,26124),
(27825,'Let us know when you ready.','',0,0,0,0,0,0,0,0,1,7333,0,0,26124),
(27826,'You tell us when it home time.','',0,0,0,0,0,0,0,0,1,7333,0,0,26124),
(27827,'Bg\'grrml brgl brm!','',35,0,0,0,0,0,0,0,1,6812,0,0,26124),
(27828,'Let me out of here, $r!','',35,0,0,0,0,0,0,0,1,6811,0,0,26124),
(27829,'So long, suckers. I\'m out of here!','',0,0,0,0,0,0,0,0,1,6811,0,0,26124),
(27830,'I made it. Freedom at last!','',0,0,0,0,0,0,0,0,1,6811,0,0,26124),
(27831,'You hear a low guttural growl from nearby.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27832,'Party G.R.E.N.A.D.E.','Party G.R.E.N.A.D.E.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27833,'Vekjik no want to be bothered.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27834,'Shaman Vekjik, I have spoken with the big-tongues and they desire peace. I have brought this offering on their behalf.','Shaman Vekjik, I have spoken with the big-tongues and they desire peace. I have brought this offering on their behalf.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27835,'Disgusting big-tongue friend, you no belong here. Go from Frenzyheart land or I call magic stuffs to kill you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27836,'Frenzyheart never be friends of big-tongues. You dumb to come back here traitor thing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27837,'Frenzyheart kill you if you come back. You no welcome here no more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27838,'No no... I had no intentions of betraying your people. I was only defending myself. It was all a misunderstanding.','No no... I had no intentions of betraying your people. I was only defending myself. It was all a misunderstanding.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27839,'Incoming $r flier! Shoot $g him : her; down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27840,'Mal\'Ganis appears to have more than Scourge in his arsenal. We should make haste.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27841,'A masterpiece! Feed it to the troll, Hordum. He\'ll answer any question truthfully....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27842,'\'Bout time, Finklestein. Now, let\'s put this stuff to the test!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27843,'Arrite, troll. Down the hatch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27844,'Don\'tcha make me get rough wit yeh, troll.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27845,'Hmm, fair enough, troll. Can\'t be any worse than the grog they serve around here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27846,'There. Now drink up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27847,'As a member of the Argent Crusade, I\'ve sworn an oath to set aside past grudges in the name of... gah - ungh....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27848,'I can\'t hardly stand the sight o\' them green-skinned savages!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27849,'They\'re ugly, they smell, they eat with their mouths open, and... ooof!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27850,'','You will be my salvation.$B$BYou may yet be my demise.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27851,'You gotta be kiddin\' me, mon! I ain\'t about to be drinkin\' that muck...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27852,'Tell ya what, mon. You take a little taste so I know ya ain\'t tryin\' ta poison me. Then I\'ll drink.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27853,'Alright, mon. A deal be a deal. But first, just a little question....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27854,'How ya really be feelin\' about workin\' so closely wit orcs?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27855,'','What!?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27856,'Where am I? What is this place?','Where am I? What is this place?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(27857,'I... I have awoken to a nightmare?','I... I have awoken to a nightmare?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(27858,'Who... who are you? Who... what am I?','Who... who are you? Who... what am I?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(27859,'I hurt... suffering unbearable... end my pain... I beg of you!','I hurt... suffering unbearable... end my pain... I beg of you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(27860,'Dagnabbit, Hordum! Now I must cook up a whole new batch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27861,'Another failure...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27862,'Useless...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27863,'I smell its fear...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27864,'This one has awoken too soon. It retains emotion and memory...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27865,'Pathetic...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27866,'You have been measured and found wanting...\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27867,'Dispose of it...\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27868,'Marvel at its tenacity and vigor! A champion has been found!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27869,'The Lich King will be pleased with this initiate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27870,'Amidst the wretch, a champion has been found.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27871,'CHAOS! DOOM! DESTRUCTION! This one will claim them all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27872,'A harbinger of death is reborn...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27873,'Place upon it the trappings befitting a herald of Arthas.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27874,'Yes, instructor.','Yes, instructor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27875,'Rise, minions. Rise and feast upon the weak!','Rise, minions. Rise and feast upon the weak!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27876,'This one...\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27877,'Dark energy courses through me... Such power! I hunger for more!','Dark energy courses through me... Such power! I hunger for more!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27878,'Reborn, I shall become an instrument of doom...','Reborn, I shall become an instrument of doom...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27879,'The voice... such splendor... Arthas... My king....','The voice... such splendor... Arthas... My king....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27880,'I return from the grave to do my master\'s bidding.','I return from the grave to do my master\'s bidding.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27881,'Right away, instructor.','Right away, instructor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27882,'More vile sorcery! Be ready for anything!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27883,'Stand and be measured! Rise, for your master awaits your arrival. Go now!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27884,'Listen, death knight... Listen for the voice of your master. He calls to you now.\n','Listen, death knight... Listen for the voice of your master. He calls to you now.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27885,'As you command, instructor!','As you command, instructor!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27886,'I live only to serve the Lich King!','I live only to serve the Lich King!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27887,'Victory to the Scourge!','Victory to the Scourge!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27888,'Death to all that oppose us!','Death to all that oppose us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27889,'Let\'s move on.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27890,'ugh...','ugh...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27891,'Avenge me!','Avenge me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27892,'I am... finished.','I am... finished.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27893,'My treasure! You no steal from Tartek, dumb big-tongue traitor thing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27894,'It\'s too late for me.','It\'s too late for me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27895,'Tartek and nasty dragon going to kill you! You so dumb.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27896,'I\'m saved!','I\'m saved!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27897,'I thought I was done for!','I thought I was done for!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27898,'Thank you!','Thank you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27899,'I am in your debt, friend.','I am in your debt, friend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27900,'Have you ever seen drakes like the ones around here? Makes for perfect hunting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27901,'Watch your backs: they have us surrounded in this hall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27902,'Mal\'Ganis is not making this easy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27903,'%s begins to cast Empowered Arcane Explosion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27904,'They\'re very persistent.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27905,'What else can he put in my way?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27906,'The quickest path to Mal\'Ganis lies behind that bookshelf ahead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27907,'Keep him weak!','Keep him weak!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27908,'If Rhunok regains his strength, we all die!','If Rhunok regains his strength, we all die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27909,'The bear god must be kept enfeebled so that the prophet can finish the ritual.','The bear god must be kept enfeebled so that the prophet can finish the ritual.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27910,'There are intruders about. Slay them before they ruin everything!','There are intruders about. Slay them before they ruin everything!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27911,'Prince Arthas Menethil, on this day, a powerful darkness has taken hold of your soul. The death you are destined to visit upon others will this day be your own.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27912,'This is it, I just know it...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27913,'That boat is going to hit me for sure...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27914,'I can\'t look...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27915,'Can\'t they go a little slower?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27916,'I do what I must for Lordaeron, and neither your words nor your actions will stop me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27917,'It\'s coming right for me!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27918,'It\'s not slowing down!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27919,'OH NO!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27920,'We\'ll see about that, young prince.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27921,'Look out!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27922,'It\'s all over...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27923,'I never got to tell my son how proud I am of him...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27924,'I\'m not ready to die...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27925,'There\'s so much I still wanted to do...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(27926,'Did you hear something?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27927,'What is that sound?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27928,'Put a muzzle on that damned sword, Mograine. I am sick and tired of its incessant whining.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27929,'Shut that thing up! I cannot think with that sword blabbering nonstop!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27930,'I\'m sorry, our brews are exclusive to members of the \"Brew of the Month Club.\"','I\'m sorry, our brews are exclusive to members of the \"Brew of the Month Club.\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27931,'This post is secure, $r.$b$bThe enemy has been cleared from the area for some time now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27932,'','The Scourge spread so rapidly, I often find myself wondering why they haven\'t already won this war.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27933,'Ahh,  Back in Drak\'Tharon at last!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27934,'Drakuru casts his gaze down on Drak\'Tharon Keep.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27935,'Ya done well, mon....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27942,'Hah! Zepik right, big-tongues is the great hunt!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27943,'Killing big-tongues is fun! Goregek should go with slave thing more often!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27944,'Maybe Kartak come soon and eat whole village! Hah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27945,'Bristlepine harder hunt than this! Dumb big-tongues.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27946,'Goregek best hunter, huh slave thing?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27947,'Try speartouched! Hah! Goregek so funny.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27954,'Ya surpassed my greatest hopes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27955,'Wasp things fly where Goregek can\'t hit them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27956,'This is Dajik\'s hunt. Let\'s go, slave thing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27957,'No bristlepine here, let\'s go somewhere else.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27958,'Look, slave thing... Goregek got stung by big bad wasp queen once. Goregek all done with wasps.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27961,'Goregek like killing big-tongues, but there too many here, slave thing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27962,'Not safe here, slave thing. This big-tongue home.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27963,'Frenzyheart not come here alone. Slave thing should not either.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27964,'You lure them out, slave thing. I stay here and watch. Good show.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27965,'Elder maybe says other stuff, but you always be slave thing to Goregek.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27966,'Why you just sit around? Get to work, slave thing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27967,'You\'ll never be as good as Goregek.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27968,'Goregek the only good bristlepine hunter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27969,'Pitch was weakling anyway... why else you think Goregek not bother with him?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27970,'You useless. Goregek not know why he bother with you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27971,'Goregek slay so many bristlepine that he could fill River\'s Heart!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27972,'Goregek wonder if there more bristlepine over mountains. One day, Goregek will go see.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27973,'No bristlepine at broken pillar, just dead stuff. Goregek leaving, slave thing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27974,'If slave thing want to be dead, slave thing keep going to broken pillar. Goregek go away and be not dead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27975,'Why go to broken pillar? You dumb, slave thing. Goregek go.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27976,'Only dead things here. Goregek leaving.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27977,'Goregek never seen Kartak yet. Goregek not think he has bad as others say.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27978,'Rakjak say Kartak once ate whole village of big-tongues. They must be tasty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27979,'Stay away from Kartak mouth, slave thing. He maybe eat you too.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27980,'Long time ago, Kartak came to Frenzyheart from mountains. Rakjak fed Kartak big-tongue slaves so now Kartak not eat Frenzyheart.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27981,'Frenzyheart feed Kartak big-tongues so Kartak not eat us. That why we smarter than you, slave thing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27982,'Maybe Frenzyheart should feed you to Kartak, slave thing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27983,'Frenzyheart the strongest!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27984,'Home! You better have brought back meat for Goregek, slave.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27985,'Goregek go get drink. You sit in corner til Goregek ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27986,'Goregek hungry. Go get on fire spit, slave thing. Tell Goregek when you well roasted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27987,'You wait until Goregek ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27988,'Goregek get some sleep. Go bring foodstuffs back, slave thing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27990,'There was hundreds of times these hardknuckles before Goregek.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27991,'Hardknuckles still walk on hands... seem kind of dumb to Goregek.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27992,'You just watch slave thing, Goregek take care of these hardknuckles!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27993,'Better not get in Goregek\'s way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27994,'You just get yourself beat up! Hah! You so dumb, slave thing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(27995,'Careful slave thing, the big bad softnuckles might eat you! Hah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28002,'Disgusting big-tongue thing! What it doing here?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28003,'Kill the big-tongue, slave thing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28004,'Hold Goregek back, slave thing! I going to beat up big-tongue bad! Hold Goregek back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28005,'It stinks of big-tongue around here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28006,'Ah! Look! Goregek can start big-tongue necklace!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28007,'Mmm, slave thing... I wonder what roasted big-tongue tastes like.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28008,'%s plants the Flag of Ownership in the corpse of $n.','%s plants the Flag of Ownership in the corpse of $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28009,'Hah! Goregek\'s kill!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28010,'You should help next time, slave thing. Don\'t leave all work to Goregek.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28011,'Goregek best hunter... ever.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28012,'I stabbed it in the face! Goregek so good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28013,'It not even see Goregek coming.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28014,'You going to help fight too or you just sit there, slave thing?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28015,'Why Goregek even bring you. You useless.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28016,'Next time, maybe Goregek let you try.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28017,'The Alliance tower was destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28018,'The Horde tower was destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28019,'','It is through the power of the unholy that we command death itself!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(28020,'I seek training, Lady Alistra.','I seek training, Lady Alistra.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28021,'The blood is life... And as easily as the ebb and flow of blood is controlled, so too is the life of our enemies.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(28022,'I seek training, Lord Thorval.','I seek training, Lord Thorval.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28023,'We are what the cold wind carries. The icy chill of despair... The cold embrace of death...','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(28024,'I seek training, Amal\'thazad.','I seek training, Amal\'thazad.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28025,'You leave your material body behind!','You leave your material body behind!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(28026,'What a fight you missed, Dorian! It was one for the ages!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28027,'There we were, riding into battle at full speed on the back of Stampy...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28028,'Everything was shaking all over the place. I could hardly steady my gun.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28029,'And then we saw her, the fearsome beast!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28030,'It took all of $n\'s skill to maintain control of Stampy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28031,'It saddens all of us to see the Drakkari destroying themselves this way.$B$BThe power that they gain from killing the natural gods of the land is transitory.$B$BWhat is gained in the short run will be lost to them for all eternity.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(28032,'The battle was a haze of blood, lead, and sweat. The broodmother\'s attacks came faster and faster!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28033,'But, in the end, $n and I prevailed through our wits and teamwork. And now we have this glorious trophy as a memento of our victory.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28034,'Your efforts... are in vain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28035,'Such is the fate of all who oppose the Lich King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28036,'Do I detect a bit of jealousy, Dorian?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28037,'Well, I don\'t know. I was here tending the fire and discussing the drawbacks of cogs with Zootfizzle. That\'s pretty epic, too, in its own way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28038,'Gather your senses quickly, we must press on.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28039,'I\'m ready.','I\'m ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28040,'This will only take a moment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28041,'I\'m relieved this secret passage still works.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28043,'This isn\'t getting any easier. Stratholme is burning. We must brave the Scourge and the flames to reach Mal\'Ganis. Prepare yourselves.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28044,'For Lordaeron!','For Lordaeron!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28045,'Rest a moment and clear your lungs, but we must move again soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28046,'','Zim\'Torga is able to provide us with a certain level of protection, but she has been greatly weakened by the presence of the Scourge and the actions of the Drakkari.$B$BIt falls to me and Ahunae to see to the rest of our defenses.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(28047,'That\'s enough; we must move again. Mal\'Ganis awaits.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28048,'At last some good luck. Market Row has not caught fire yet. Mal\'Ganis is supposed to be in Crusaders\' Square, which is just ahead. Tell me when you\'re ready to move forward.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28049,'','Now go, my friend. Thank you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28050,'','Zim\'Torga must be defended lest the Drakkari foolishly steal her power as well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28051,'','From the earth you arose. To the earth you shall return.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28052,'','We are honored by your sacrifice.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28053,'Lure it into the trap!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28054,'','The Drakkari must not be allowed to break through the defenses.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28055,'','This is as strong as I can make you. Fight well, my earthen friend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28056,'Get out of way silly slave thing! Goregek\'s kill!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28057,'Hah! Goregek the greatest hunter ever! Goregek get biggest hardknuckle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28058,'That how it done, slave thing. Maybe you figure out how someday.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28059,'Revenge is Goregek\'s! Teach dumb hardknuckle to knockdown Goregek from behind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28060,'Time for food!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28061,'Goregek hungry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28062,'You wait, slave thing. Goregek eating.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28063,'Go kill more stuff while Goregek eat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28064,'Chicken! So delicious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28065,'Gorgek gonna catch chicken good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28066,'Slave thing! Go get chicken for Goregek!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28067,'No worry chicken. Goregek not going to put you in fire. Goregek nice wolvar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28068,'Squeal! Squeal! So good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28069,'Run away softknuckle! Goregek gonna get you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28070,'Aww! So scared!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28071,'Run away dumb softknuckle! We gonna poke you more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28072,'Ahunae\'s axe will be the end of the Drakkari.$B$BYou be takin\' care of any that get past my axe!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(28073,'This looks like a good perch. Mark the target and signal me when you\'ve sighted the broodmother and are ready to attack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28074,'Here, beastie. Come to Hemet!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28075,'Take that, beastie!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28076,'How d\'you like that one, eh?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28077,'Eat lead!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28078,'The bigger they are, the harder they fall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28079,'The trickster Mage-Lord Urom protects the third ring.  He will appear alone and defenseless, but do not be fooled by appearances!  Urom is a powerful conjurer who commands a menagerie of Phantasmal creatures.  Seek him out above.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28080,'The trickster Mage-Lord Urom protects the third ring.  He will appear alone and defenseless, but do not be fooled by appearances!  Urom is a powerful conjurer who commands a menagerie of Phantasmal creatures.  Seek him out above.\n\nI can grant you the power to call upon a drake from the red flight.  Speak to Eternos or Verdisa if you prefer to draw on the power of the bronze or the green.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28081,'Your greatest challenge lies ahead.  Ley-Guardian Eregos is a Blue dragon of immense power. You will find him flying above the uppermost ring. \n\nThe full power of your drakes has been unlocked.  Use their power to defeat Eregos!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28082,'You have wrested control of the Oculus from the forces of Malygos.  The red flight is in your debt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28083,'The bronze flight is in your debt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28084,'','The green flight is in your debt.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28085,'What abilities do ruby drakes have?','What abilities do ruby drakes have?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28086,'What abilities do amber drakes have?','What abilities do amber drakes have?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28087,'What abilities do emerald drakes have?','What abilities do emerald drakes have?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28088,'What is the ultimate ability of the Ruby Drake?','What is the ultimate ability of the Ruby Drake?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28089,'What is the ultimate ability of the amber drake?','What is the ultimate ability of the amber drake?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28090,'What is the ultimate ability of the emerald drake?','What is the ultimate ability of the emerald drake?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28091,'Ruby drakes excel at mitigating damage and protecting their allies.\n\nUsing searing wrath, they can breathe streams of liquid fire that jump from target to target, dealing increasing damage with each jump.\n\nWhenever a ruby drake is damaged by an enemy attack, it gains an evasive charge.  These charges can be used to perform a series of evasive maneuvers, allowing the drake to dodge incoming attacks and spells for a time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28092,'Amber drakes excel at dealing damage by manipulating time to their advantage.\n\nUsing shock lance, they can disrupt the flow of time around an enemy target, instantly damaging it.  The power of this effect is dramatically increased by shock charges on the target.\n\nWhen threatened, an amber drake can briefly stop the flow of time for its enemies.  This time disruption stores a large amount of shock energy on affected targets in the form of shock charges.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28093,'','Emerald drakes excel at healing themselves while poisoning their enemies.\n\nUsing leeching poison, they can steal health from their enemies.  Repeated applications of this poison can increase the effect.\n\nWith touch the nightmare, emerald drakes can reach into the Dream, converting a portion of their life energy into a highly damaging attack that leaves the target weakened, reducing its damage for a short time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28094,'A Ruby Drake at full power can perform Martyr, which shields friendly targets by redirecting all hostile magic to the Ruby Drake for a short time.  Evasive Maneuvers can still be performed during Martyr.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28095,'An amber drake at full power can perform temporal rift, which creates a bubble of compressed time around an enemy.  Spells that pass through the bubble deal double damage and can generate shock charges on the target.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28096,'','An emerald drake at full power can perform dream funnel, which transfers the drake\'s own life energy to a friendly target, healing it.  Leeching poison can be used to restore health lost when using this ability.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28097,'M-mistress... may I p-polish your armor...?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28098,'M-mistress... might I b-brush your mighty steed...?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28099,'M-mistress... does your axe n-need sharpening...?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28100,'M-mistress... did you n-need more corpse dust, p-perhaps...?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28101,'Yes, M-mistress...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28102,'','Get away from me, Edwards, lest I behead you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28103,'','No, you sniveling wretch. Now begone.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28104,'','You can leave my sight, squire, before I slay you. Again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28105,'','No. Away with you, worm.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28106,'Heathens! The day of reckoning comes!','Heathens! The day of reckoning comes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28107,'Light purge you from this world!','Light purge you from this world!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28108,'You cannot stop the Scarlet Crusade!','You cannot stop the Scarlet Crusade!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28109,'You have been branded as enemies of the Crusade, heathens!','You have been branded as enemies of the Crusade, heathens!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28110,'All will fall before the might of the Scarlet Crusade!','All will fall before the might of the Scarlet Crusade!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28111,'They will find me and they will free me... Your pathetic cages cannot hold me for long!','They will find me and they will free me... Your pathetic cages cannot hold me for long!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28112,'May the Light forgive you for the evil that you do.','May the Light forgive you for the evil that you do.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28113,'Have you not yet realized why we remain defiant?','Have you not yet realized why we remain defiant?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28114,'The Argent Dawn will fight until the end!','The Argent Dawn will fight until the end!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28115,'It\'s not too late, brothers and sisters. Repent! Repent and you may be saved.','It\'s not too late, brothers and sisters. Repent! Repent and you may be saved.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28116,'Killing me will only strengthen the resolve of my brethren. Do your worst!','Killing me will only strengthen the resolve of my brethren. Do your worst!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28118,'For your efforts, you be gettin\' da greatest of rewards....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28119,'Revelation!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28120,'Be still, friend, and behold da truth of things!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28121,'I\'m all kinds of busted up... might not... make it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28122,'You test my patience, you now see the true might of the Blue.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28123,'Hah! You\'ll not get my treasure!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28124,'Kill them! Kill them all and take back Zim\'Torga!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28125,'Master, my mission be complete.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28126,'Death to the Zandalari and their puppets! Nothing can stop us now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28127,'With da help of these mortals, dis region been cleansed of all who oppose us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28128,'Miss Boulian... will you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28129,'Will you accept my ring?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28130,'You have done well, Drakuru.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28131,'Your betrayal of the Drakkari Empire has borne me a new army.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28132,'','Oh, Chad... of course I will!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28133,'Your army....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28134,'Arise, and accept my gift.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28135,'The full power of your drakes has been unlocked.  Use their power to defeat Eregos!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28136,'Welcome Friend.  Keep your head down and hold on tight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28137,'Hardknuckles boring. Why we here again?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28138,'If you keep killing hardknuckles, you grow up to be like Goregek. You want be like Goregek?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28139,'If you here to poke more softknuckles, Dajik going to poke you too. That a bad Goregek habit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28140,'Huh... where are we? This not right. I not tell you find hardknuckles, did I?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28141,'Frenzyheart came here not long ago for new home... big-tongue homes pretty nice, so we maybe take those too. They ugly anyway.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28142,'Stay a while and listen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28143,'Make sure you not forget anything. I forgot stuff once.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28144,'I placed most of the spikes. Good amount of pointiness I think. You like?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28145,'Lot of strong Frenzyheart here. Dajik taught most of them. First time I teach something like you though. You not a Frenzyheart, you know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28146,'Watch out for pups. Frenzyheart vicious when little.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28147,'I know you still learning, but big-tongues are bad. Frenzyheart good, big-tongues bad, okay?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28148,'Poke it in the eye, big-tongues hate that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28149,'Okay, all done playing. Time to kill it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28150,'I know they funny looking, but less starting, more killing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28151,'Aww, you two going be friends? Maybe find nice place in swamp and have very own medium-tongues? So sweet... stop being dumb now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28152,'I think it like you. Maybe we can bring it back to hill and ask it nice, \"Step in cooking pot, big-tongue.\" Yes?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28153,'Time for more smart Dajik tip! No try to ride Kartak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28154,'Kartak like taste of big-tongues. If Kartak hungry though, he not mind taste of Frenzyheart, so make sure Kartak not hungry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28155,'Maybe it just Dajik, but it seem like this fight been going for a while, yeah?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28156,'This not Frenzyheart Hill, where we again?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28157,'You not very fast learner. Just saying.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28158,'I bet you wonder where we get tall bird things for roast. Too bad, it secret.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28159,'Hah! Maybe you learn a little after all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28160,'This not first queen slain by Frenzyheart. Seem like there always more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28161,'No! You killed queen thing! What have you... wait, nevermind. Sorry, that okay.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28162,'Yes! Stab few more time just in case! Stab good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28163,'Not sure how thing got here. Not matter if dead though.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28164,'Dajik\'s last learner eaten by sand-thing. We do better this time though!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28165,'Usually it just run away in sand. Not do so good at run away this time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28166,'Not see these very much. That fine though, it not very pretty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28167,'Time for more smart Dajik tip! Lot of dead things mean lot of chance of being dead thing. Dajik leaving now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28168,'You all done with learning! Yup! All done! Dajik leave you and evil red pillar thing now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28169,'Broken pillar not safe place. Dajik go now, you need go too.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28170,'Dead thing there already learn lesson of broken pillar. Leave this lesson for dumb, dead things. Going home now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28171,'Time for more smart Dajik tip! If Goregek let chickens out again, make Goregek get chickens back again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28172,'Maybe you not notice, chicken move kind of fast.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28173,'There reason Frenzyheart not chase back chickens. Look kind of dumb to lose to chicken.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28174,'Oh! Dajik has idea! Make chicken sounds and maybe they come to you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28175,'All this running make Dajik not hungry for chicken anymore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28176,'Let\'s just eat bristlepine instead, okay? All done with chasing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28177,'Time for more smart Dajik tip! Make sure thing dead before reach in mouth for loots.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28178,'You do okay enough with that one. Just okay.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28179,'Get the stuff off of body! Dajik hate it when he go skin something and there stuff in the way. So annoying.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28180,'Dajik train pups that kill stuff faster than you. You got lot more learning left.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28181,'Did you see face? Looked so scared, \"Ah, big thing going to smash me!\" Hah.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28182,'That look painful.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28183,'Dajik not think he seen you eat anything. You eat sometimes, yeah?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28184,'What we doing here again? Dajik can\'t remember.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28185,'Time for more smart Dajik tip! Try not to catch stinger with face. Not work so much.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28186,'I was going draw picture of best attack plan... but you have my chalk.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28187,'Drone things not as tough as they look. Wasp things a bit nastier.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28188,'We came for something, yes? Can\'t remember.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28189,'Seem like there more wasps every time Dajik come back. Why they not run out?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28190,'In case you wonder, wasp sting not feel so good. No need to try.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28191,'Time for more smart Dajik tip! Crystals work little too good for back scratch. No try.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28192,'Sometimes big-tongues try to come get crystals. Not now because they not like it when we kill them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28193,'Wasps like blue crystals. Dajik not sure why.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28194,'Something big make pillars and crystals and everything. Frenzyheart not care much cause it not here anymore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28195,'Time for more smart Dajik tip! Messing up big-tongue shrine is fun, but make sure lot of big-tongues not watching first.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28196,'Zepik does great big-tongue hunt. Dajik tired to teach him when he was little, but he not very teachable.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28197,'Big-tongues like crystals for shrine things a lot. They not like when we smash them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28198,'Dajik been seeing a lot more furless things like you. Frenzyheart not like giving up land, so you things better be careful.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28199,'Some furless things been making friends with big-tongues... seem pretty dumb to Dajik.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28200,'The sparky ones are more squishy! Get them first!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28201,'Dajik tried to show me ways of hunt, but I do better when I do things my way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28202,'Bring back good meat and the camp treat you like high-shaman for a day. Good deal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28203,'You should go let chickens out again and say Goregek did it. Never get old.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28204,'I not in a big hurry. We can rest here a while if want.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28205,'I not live here always... I traveled lot of world on my own not long ago. I like all the stories of beasts and dragons and gods and stuff.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28206,'Elder Harkek pretty good Frenzyheart. He help me a lot when I was littler and not liking Dajik.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28207,'Gorlocs are the bad-guys, just so you know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28208,'I hope you planning something secret involving that big-tongue ending up dead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28209,'If I step on its tail, it was an accident.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28210,'Normally I kill these things. You know that, yeah?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28211,'I not so happy about traveling with big-tongues.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28212,'I see what you doing... maybe if we treat it nice it will lead us back to more big-tongues.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28213,'Good to stay away from Kartak. He only a friend of Frenzyheart so long as we keep his belly full... and he\'s got a big belly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28214,'I teach myself a lot of my big-tongue hunt here. Lot to kill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28215,'Something about sound of battle make this place more relaxing than main hill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28216,'Not mentioned much, but Kartak ate dozen Frenzyheart before became \"friend.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28217,'Ever met Tartek? He one of our best fighters... leads in the northwest. I hear he captured one of the dragon things. No lie, I a little jealous.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28218,'Shaman Jakjek is quiet for a Frenzyheart, but still very strong. He probably the only reason Kartak not turned on more of us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28219,'My kind not welcome at broken pillar. I going back to hill - find me when you done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28220,'Many Frenzyheart lost at broken pillar. Today is not Zepik\'s day to be lost too.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28221,'I thought about tricking big-tongues to come here, but it too dangerous for me. You have good luck and I meet you back at hill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28222,'Bad plan to come here... many more adventures to be had before I risk this place. Be safe... I meet you later.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28223,'Hahah! You see that? Lightning bolt hit him right in the head!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28224,'BOOM! That so good! More! More!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28225,'Zap!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28226,'We need to do this more often! This so funny... lightning hitting big-tongues everywhere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28227,'That lake near here actually full of sea things. Not sure how it all get here... maybe in floods?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28228,'I think one reason I like hunting big-tongues so much... they not as dumb as the other hunts. They give a real fight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28229,'Mist big-tongues are smart with their shrine thing sometimes... cover whole area with mist and it get hard to find any.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28230,'Careful of big mistcaller guy... Zepik fought him once and barely got away. He lot stronger than rest of big-tongues here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28231,'May not be great hunt, but this still fun after so many time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28232,'You think they learn to keep Goregek away from chickens.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28233,'Goregek never \"stumble\" into chicken hut... Goregek always have to feed his dumb belly. Always one chicken missing when we catch them all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28234,'You chickens are tougher than I thought! I\'ll have to improvise!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28235,'You pretty good! Natural at hunt, like me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28236,'Goregek think he the boss of everyone, but he eat too much and hunt too little.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28237,'Dajik forget what he doing, where he at... sometime even forget his own name. Make him not so good teacher sometimes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28238,'You ever fought big dragon or god or anything? Zepik like hearing stories.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28239,'Good one! It not even see it coming.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28240,'Hah! Leave some for Zepik too.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28241,'No more play?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28242,'Flame! Death! Destruction! The black fire rages within my heart! I must... release it! Hahah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28243,'Not sure if you notice, but there rumbling sometimes from the water in the big hole. I think there something down there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28244,'Big-tongues don\'t usually come down here anymore... I had a big fight and killed lots.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28245,'I always wonder where all the water go... doesn\'t make sense.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28246,'Vekjik likes finding big-tongues that wander too far to throw in the basin. He help me trap some of the dumb ones. You should watch him sometime... it pretty funny actually.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28247,'Battle here been going on for a while... these spark big-tongues have a lot more fight than the other ones.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28248,'Big-tongues here worship shrine, like at other places, but this shrine sometimes have a guardian. Careful if it shows up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28249,'Feels good to hunt with a not dumb hunter. You good at this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28250,'Maybe I not be the only one big-tongues fear much longer. You scary when in the fight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28251,'Welcome to the camp, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28252,'What is it that you need from Corvus?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(28253,'I require repairs and supplies, Corvus.','I require repairs and supplies, Corvus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28254,'Use Searing Wrath to damage enemies and Evasive Maneuvers if I start taking damage.  Remember I need to build up Evasive Charges by taking damage to perform Evasive Maneuvers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28255,'Use Leeching Poison to damage enemies and keep me healed.  Touch the Nightmare is very powerful, but it hurts me, so only use it when I have a lot of health!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28256,'Use Shock Lance to damage enemies.  If we get in trouble, Stop Time to freeze all enemies in place, then hit them with Shock Lance for massive damage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28257,'I\'m badly injured!  I can\'t take much more of this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28258,'Now that I am at my full power I can perform Temporal Rift.  You can use it to make enemies take extra damage and to get Shock Charges.  Save up Shock Charges and then Shock Lance for huge damage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28259,'Now that I am at my full power I can perform Dream Funnel.  You can use it to heal other drakes, but it drains my health, so make sure you\'re using Leeching Poison too!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28260,'Now that I am at my full power I can perform Martyr.  You can use it to protect other drakes, but I will take lots of damage, so make sure you\'re using Evasive Maneuvers too!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28261,'Ooh! Shinies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28265,'Treasure for Lafoo! Treasure for shrine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28266,'Dig, dig, dig...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28267,'Maybe more shiny bugs! We like bugs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28268,'Careful of big scary beast thing! It try to eat us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28269,'So many puppy-men here. Think they want be friends now maybe?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28270,'Can we maybe, please go now? Little scary.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28271,'No bugs here... where all bugs go?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28272,'No. No good here. No no no.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28273,'Voices... voices everywhere and not alive! No stay.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28274,'All bugs gone. Badness here... we not be with badness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28275,'We really not like it here. Maybe come find us when you done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28276,'No more eat hatchlings, scary snake thing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28277,'No come back this time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28278,'You strong! Yay... you keep us safe!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28279,'Hiss... hiss... dead. All dead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28280,'Food for bugs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28281,'That look like it hurt. No hit us like that, okay?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28282,'I think... maybe it dead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28283,'Ahh! It all safe now?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28284,'Oh hi. Who you? Want be friends?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28285,'It nice that it not snow here. Snow no good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28286,'You got funny looking eyeballs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28287,'Dead things not seem very happy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28288,'Ahh! I hate you puppy-face! So mean!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28289,'Never met Great Ones. Nope, just met their shrines.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28290,'Big comfy tree. Good home.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28291,'Crunchy bugs so delicious. Want?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28292,'Soo-say really nice to us.  We like Soo-say.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28293,'One day maybe you can be Soo-dryskin. Like?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28294,'Hi.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28295,'Floaty sparks! Think they maybe give me one?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28296,'Puppy-men attack this place a lot. It scares off all the bugs... that why we don\'t come much.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28297,'Great Ones left big kitty protector thing. Not for us I think, but it good friend... keeps mean puppy-men away sometimes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28298,'You\'ve got a lot of shinies. Lucky.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28299,'Sleep time yet?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28300,'Thanks for being nice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28301,'It stinky around here. Why so stinky.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28302,'Be nice puppy-man. We nice, so you be nice too.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28303,'That weird. Someone took our bugs. You have maybe?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28304,'Puppy-men have so much hair! Looks ichy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28305,'Ooh! Who he? He friend of yours? Maybe we be friends too?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28306,'You have pie? Someone gave us pie year ago. Really yummy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28307,'More treasures! Treasures of all kinds! Yay treasures!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28308,'Shiny things! Shiny things! Not as shiny as my crystal, but still shiny!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28309,'We are fast digger! Really fast! See... all done! That was fast, huh?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28310,'Can never have too many shiny crystals! Nope!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28311,'Let\'s run circles around silly puppy-men! Weee!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28312,'Big yeti beast can\'t catch us! We way too fast.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28313,'Pow! Bam! Take that puppy-men!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28314,'Soo-holu going to get you! Silly puppy-men. Hahah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28315,'Tartek no match for you! You got the skills. Yeah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28316,'You think we scared of dragon thing? Not so much!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28317,'Teach you to steal our treasures! Our treasures are... ours, okay?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28318,'Bet you not seen a puppy riding a dragon before? Hah! And not again I think.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28319,'Whoa! Why you come here? Silly, silly! No come here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28320,'Nope! No more me. This place all yours. Bye!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28321,'Yeah... no.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28322,'Poof!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28323,'Ow! Hahah... er, that no good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28324,'Wow! Lightning everywhere! We need to learn to make this on the puppy-men!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28325,'Dumb puppy-men messed up the shrine! Boo! Make it stop!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28326,'Ah! That was close! Quick, quick, stand under metal pole thing! That keep us safe, yeah?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28327,'Misty. Very misty. Seem sort of misty to you? Maybe not so much.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28328,'Mistwhisper not always like us. They say we \"damage their calm.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28329,'Mistwhisper kind of boring. Yeah, boring... little bit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28330,'Mistcaller really good at controlling weather with shrine. They know just which crystals to use! Really good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28331,'Bam! Hah! Got it good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28332,'You like that? Bet not! Bet not cause you dead! Hahah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28333,'Unstoppable!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28334,'Killing Spree!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28335,'You lose! Lose so bad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28336,'We run circles around you! We so good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28337,'Bet you wish you not dead! Too late though, can\'t wish when you dead! Hah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28338,'Vic...tor...ious! Dun nun nun dun da da!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28339,'Home home home... place of the shinies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28340,'Home good, but not stay long! More adventures!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28341,'Lets go jump off tree! Fun fun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28342,'Chase the hatchlings! Chase the hatchlings! So fast!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28343,'Good home. Had it long time, still stay good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28344,'Great Ones keep home safe because they like Oracles I think! They know we good and nice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28345,'This my real home place! You believe we were a hatchling long time ago? We were!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28346,'Sparktouched best fighters for sure! Zap zap. Get things good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28347,'Puppy-men not welcome! Come get zapped good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28348,'Soo-holu appear to Sparktouched more than any other Oracle tribe. It\'s true!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28349,'Last time puppy-men attacked, Soo-holu chased them all the way back to their camp thing! It was glorious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28350,'You pretty powerful! I bet you could kill big yeti beast thing! You could get him good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28351,'Dumb puppy-men! We tried to be nice! You got it coming now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28352,'We know you have dragon thing! We not scared! We going to get you and dragon thing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28353,'Time to hide puppy-men! We coming for you... better get in your hill things!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28354,'Great Stones not for touching! Bad move! Bad move!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28355,'Tartek is dumb! All you puppy-men follow the dumb. Not so smart!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28356,'We going to break your spears! Don\'t cry about your spears puppy-men... don\'t cry about them being broken!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28357,'Hey puppy-man thing, you ever take bath? Bet not! Hahah.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28358,'My dryskin can beat your dryskin. Yup, definately.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28359,'You not look so tough. Weak puppy-thing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28360,'Know what we don\'t like? Puppy-things! Like that one right there! See? We no like it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28361,'What you doing here puppy-thing? Go away! Go chase stick or something.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28362,'Hey... psst... puppy-thing. How your family doing? I think my dryskin killed them all. Ahahah! Got you good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28363,'Yay... more dirt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28364,'Soo-say better appreciate these.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28365,'Hey... maybe we\'ll find some more useless bugs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28366,'What the heck are shiny rabbits doing here anyway?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28367,'Are we done yet?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28368,'Here I am, digging up some useless bauble from the ground at the will of someone I just recently met... does that seem right to you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28369,'Come wolvar! Your death beckons!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28370,'Soo-holu with see this battle done...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28371,'Kartak, I do not fear you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28372,'These puppy-men have killed scores of us, yet we still still offer them peace... does that seem right to you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28373,'Looking to rush to your death at the broken pillar? You\'re all alone in that one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28374,'I\'ll come back when we\'ve mustered an army, perhaps. The broken pillar is not welcoming.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28375,'You certainly are brave, but you\'re alone when it comes to this place, dryskin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28376,'I will follow you no further dryskin, too many have died at the broken pillar, and I will not be among them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28377,'I can\'t believe... they\'re all... dead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28378,'I thought our land was safe from the undead?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28379,'And so Arthas\'s armies break into the last untouched land in Northrend...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28380,'We should have been here... we should have stopped this from happening.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28381,'We can\'t let this stand. The undead must pay!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28382,'Soo-say didn\'t look into anything when the mosswalkers mentioned strange weather, now they\'re all dead... does that seem right to you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28383,'As it should be.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28384,'Another falls to our onslaught.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28385,'Just try to stop us now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28386,'Not bad for a dryskin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28387,'Perhaps I\'ve met an adventurer worthy of my company... perhaps you will redeem my people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28388,'How did you even stand Jaloot? Whenever he talks, I want to go dump him at Frenzyheart Hill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28389,'Lafoo is Soo-says little pet. Probably the most incomptent gorloc I\'ve ever met... and that\'s saying something.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28390,'I fight more than all other Gorlocs combined, yet I still find time to learn your language the right way... does that seem right to you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28391,'Yeah, let\'s go now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28392,'I\'m done here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28393,'There some reason why we\'re still here? I\'d love to hear it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28394,'Planning to sit on your butt some more, or are we going to go do something that\'s actually useful?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28395,'Going to go take a nap? I apologize in advance for accidentally stepping on your face while you sleep.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28396,'I\'m the most intelligent, strongest, most cultured gorloc here, yet Soo-say calls all the shots... does that seem right to you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28397,'There are more that might still be alive! We need to keep moving.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28398,'Where are they dragging those bodies? What are they doing to them?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28399,'It\'s hard to believe any of them survived this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28400,'It\'s a small comfort to see that they haven\'t brought any back in undeath.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28401,'I know I talk down to them, but I never want to see any of my people die.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28402,'It\'s good to see some of the mosswalker were more resilient than I thought.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28403,'The sparktouched are some of the best fighters among us... they\'re carried most of the battle against the wolvar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28404,'I have the most respect for the sparktouched out of all of the oracles... they have stood up for their land admirably.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28405,'Soo-holu was left behind by the Great Ones... you might know them as titans.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28406,'I\'ve come to believe Soo-holu was left here to guard the shrines, but like the shrines, he\'s powerless without the right crystals.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28407,'Let us carry the battle to the wolvar... this has gone on for too long. They must pay.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28408,'Here the sparktouched have been fighting the wolvar for days, yet no other oralces have come to their aid... does that seem right to you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28409,'Filthy wolvar. I don\'t care if the dryskin vouches for you, I will not endure your presence for long.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28410,'You better have a good reason for letting this wolvar continue to breath.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28411,'Friendly with wolvar still, eh? Then I won\'t be surprised when you turn on us and side with them again','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28412,'You keep the company of wolvar? Perhaps you didn\'t come with good intentions after all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28413,'I do have a mighty roar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28414,'Here I am, standing next to my mortal enemy, yet I haven\'t killed it... does that seem right to you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28415,'Hey, hey!  Only my summoner should be able to see this.','Hey, hey!  Only my summoner should be able to see this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28416,'I charge you now with the cleansing of Zul\'Drak, Drakuru.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28417,'Fail me and it shall be your undoing...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28418,'Succeed, and even greater power shall be yours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28419,'As you wish, master.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28420,'Forgive my deception, mon. It all been for your own good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28421,'Ya needed ta prove yer worthiness....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28422,'I be needin\' worthy underlings in Zul\'Drak, mon. Ones ready to wield real power.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28423,'You see for yourself now. Da Lich King be generous to dem who obey.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28424,'Follow dis path, mon, and soon you be tastin\' immortality!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28425,'Ponder on da thing you have witnessed this day, $n.$b$bDa future already be written. Only thing to decide be your part in it, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28426,'Malygos\' most powerful agents protect the rings above.  Alone, you cannot hope to defeat them.  We can grant you power to call upon drakes from our dragon flights.  Mounted on the back of a drake, you will be able to fly here in the Oculus and command powerful dragon magic.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28427,'So where do we go from here?','So where do we go from here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28428,'Belgaristrasz speaks the truth; time is running out!\n\nThe full power of your drakes has been unlocked.  Use their power to defeat Eregos!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28429,'','Belgaristrasz speaks the truth; the situation is grave indeed.  \n\nThe full power of your drakes has been unlocked.  Use their power to defeat Eregos!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28430,'Yay we win! [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28431,'Gods of old, we beseech you. What must we do? How can we save the gods of this land?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28432,'The spotted one must be sought. Their fates are entwined.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28433,'But she is chained. A way must be found to free her.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28434,'To her altar this mortal must travel. What they must do will not be easy. In the end it may prove impossible.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28435,'But try they must or all will be lost. The Drakkari will be the death of both themselves and their gods!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28436,'The gods have spoken, $n. We now know what you must do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28437,'None know the Scourge better than we death knights.$b$bBelieve me, $r, there\'s nothing more effective than fighting fire with fire....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28438,'Take it easy on old Nass. He\'s not as young and resilient as he once was.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28439,'I\'ve lost Nass...','I\'ve lost Nass...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28440,'Not sure how ol\' Nass always finds his way back here. Must be by smell....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28441,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28442,'I say! I simply must find myself another line of work.','',0,0,0,0,0,0,0,0,1,7354,0,0,26124),
(28443,'Perhaps some other kind of arrangement can be worked out here. A simple tap on the shoulder, maybe?','',0,0,0,0,0,0,0,0,1,7354,0,0,26124),
(28444,'','',0,0,0,0,0,0,0,0,1,7354,0,0,26124),
(28445,'Really, it\'s the anticipation that\'s so unnerving...','',0,0,0,0,0,0,0,0,1,7354,0,0,26124),
(28446,'I pray that this is not what I\'m remembered for....','',0,0,0,0,0,0,0,0,1,7354,0,0,26124),
(28447,'Might you focus your attention on the other cheek for a time?','',0,0,0,0,0,0,0,0,1,7354,0,0,26124),
(28448,'If ever a cure for my condition is found, I should like to introduce Stefan to this boot of his.','',0,0,0,0,0,0,0,0,1,7354,0,0,26124),
(28449,'Oof! I\'m beginning to think that you\'re having a bit of a jolly at my expense....','',0,0,0,0,0,0,0,0,1,7354,0,0,26124),
(28450,'Oww! You\'ve got quite a swing there...','',0,0,0,0,0,0,0,0,1,7354,0,0,26124),
(28451,'Umph! I\'m afraid that one was a bit of a waste.','',0,0,0,0,0,0,0,0,1,7354,0,0,26124),
(28452,'Urgh! I can\'t smell any trolls nearby...','',0,0,0,0,0,0,0,0,1,7354,0,0,26124),
(28453,'Now listen here! That was simply uncalled for!','',0,0,0,0,0,0,0,0,1,7354,0,0,26124),
(28454,'Ouch! Enjoying this, are you?','',0,0,0,0,0,0,0,0,1,7354,0,0,26124),
(28455,'Ooh! Well, at least your aim is true. I suppose that\'s something....','',0,0,0,0,0,0,0,0,1,7354,0,0,26124),
(28456,'Aahh! At times like these, I question my decision to leave the Scourge.','',0,0,0,0,0,0,0,0,1,7354,0,0,26124),
(28457,'Are we finished yet?','',0,0,0,0,0,0,0,0,1,7354,0,0,26124),
(28458,'One more lock of scourge hair gained, one more shred of dignity lost....','',0,0,0,0,0,0,0,0,1,7354,0,0,26124),
(28459,'If mother could see me now...','',0,0,0,0,0,0,0,0,1,7354,0,0,26124),
(28460,'I sincerely hope that one was our last!','',0,0,0,0,0,0,0,0,1,7354,0,0,26124),
(28461,'We knocked something loose with that last one.','',0,0,0,0,0,0,0,0,1,7354,0,0,26124),
(28462,'I won\'t be the least bit upset if you choose to call it a day....','',0,0,0,0,0,0,0,0,1,7354,0,0,26124),
(28463,'Let\'s go to Zul\'Drak he says. We can get to the bottom of this mess, he says...','',0,0,0,0,0,0,0,0,1,7354,0,0,26124),
(28464,'Too soon, you have awakened me too soon! What is the meaning of this intrusion?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28465,'The Eye of Acherus is in your control.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28466,'Well, that enough of that! Going now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28467,'Ow! That hurt. I going to limp over here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28468,'I come back when we not getting butts kicked.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28469,'Not doing so good. I come back and find you later.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28470,'Dumb slave thing supposed to kill things, not let things kill Goregek!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28471,'Time for more smart Dajik tip! No let things beat your teacher up so badly. Going home now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28472,'Ow... it okay if we go back now? Hurt so much... we sorry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28473,'Okay, that hurt! We going over here fast! Be back soon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28474,'There\'s no way I\'m dying for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28475,'Hah! This the fun part!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28476,'I been waiting to do again for so long!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28477,'Trust me - you going love this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28478,'Eat it big-tongues!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28480,'Though my compatriots would have you take an active role in what is transpiring in Zul\'Drak, we Zandalari are primarily here to witness what is occurring and to chronicle the end of an empire.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(28481,'Now, in Shattrath City: The Tauren Chieftains! Playing in the World\'s End Tavern at the top of the hour!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28482,'You still have lot of learning... most important, protect Dajik!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28483,'Dajik going to rest for a bit... hurt all over.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28484,'When you get hurt bad, remember rest and get strong again. Dajik show you how right now...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28485,'Slave thing, you so full of fail.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28486,'Ow. No slave thing, really... ow!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28487,'Dumb slave thing keep fighitng... Goregek going to not get butt kicked more now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28488,'Death stalks us! Destroy it!','Death stalks us! Destroy it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28489,'Begone foul demon!','Begone foul demon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28490,'\'Tis the work of the Scourge!','\'Tis the work of the Scourge!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28491,'Scourge! Do not let it escape!','Scourge! Do not let it escape!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28492,'Dumb! Don\'t shoot at it! Gekgek want trophy in one piece!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(28493,'No let it get away! We got it this time.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(28494,'Gekgek finally trap dumb cat. You Gekgek\'s now!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(28495,'Careful! No let it scratch you like last time.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(28496,'Are you ready to rock? Then head over to the World\'s End Tavern! The Tauren Chieftains start their show at the top of the hour.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28497,'','It is not yet your time, champion. Rise! Rise and fight once more!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28498,'Oops... not again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28499,'Goregek maybe stumbled into chicken hut again...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28500,'Goregek not mean to let chickens get away! Help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28501,'Goregek hung... er, sorry. Goregek sorry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28502,'Who? The Tauren Chieftains! What? A live performance! Where? The World\'s End Tavern! When? The top of the hour! BE THERE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28503,'Lighting','Lighting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28504,'TAUREN CHIEFTAINS! Playing LIVE, in the WORLD\'S END TAVERN! Be there, at the top of the hour! Banished from Shattrath? SNEAK BACK IN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28505,'','Here, troll... a gift!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28506,'Are you ready to face Mal\'Ganis with me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28507,'The Eye of Acherus launches towards its destination.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28508,'I\'m ready to battle the dreadlord, sire.','I\'m ready to battle the dreadlord, sire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28509,'','Ugh... disgusting!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28510,'I\'d like to dress as a pirate.','I\'d like to dress as a pirate.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28511,'For me? Really, mon?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28512,'It....it be beautiful!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28513,'Everything is set up and ready to go.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28514,'Beginning the distillation in 5 seconds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28515,'Add another orange! Quickly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28516,'Add bananas!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28517,'Put a papaya in the still!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28518,'The still needs heat! Light the brazier!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28519,'Pressure\'s too high! Open the pressure valve!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28520,'We\'re going to finish this right now, Mal\'Ganis. Just you... and me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28521,'We\'ve done it! Come get the cask.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28522,'spirit of competition test','spirit of competition test',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28523,'It\'s no good! I\'m shutting it down...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28524,'Well done! Be ready for anything!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28525,'','Move along. Nothing to see here.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(28526,'','<Bloodrose eyes you curiously.>$b$bI cannot help but wonder what makes you worthy of such attention.$b$bNo offense....',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(28527,'Stefan told me you would demonstrate the purpose of this item.','Stefan told me you would demonstrate the purpose of this item.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28528,'Your journey has just begun, young prince. Gather your forces and meet me in the arctic land of Northrend. It is there that we shall settle the score between us. It is there that your true destiny will unfold.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28529,'I\'ll hunt you to the ends of the earth if I have to! Do you hear me? To the ends of the earth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28530,'You performed well this day. Anything that Mal\'Ganis has left behind is yours. Take it as your reward. I must now begin plans for an expedition to Northrend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28531,'The Drakkari are keeping my body close to death up in the altar building. They cannot see my spirit though.$B$BWe must work together to prevent them from getting my power.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28532,'I\'m ready to start the distillation, uh, Tipsy.','I\'m ready to start the distillation, uh, Tipsy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28533,'Nicely handled! Stay on your toes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28534,'Good job! Keep your eyes open, now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28535,'That\'ll do. Never know what it\'ll need next...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28536,'The structure above begins to hum with energy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28537,'Rhunok, I need to be reimbued with your mojo.','Rhunok, I need to be reimbued with your mojo.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28538,'Please hurry, $n. I am in a great deal of pain and time is running out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28539,'Filthy $r intruder. DIE!','Filthy $r intruder. DIE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28540,'HELP! HELP!','HELP! HELP!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28541,'SCOURGE! RUN AWAY! RUN AWAY!','SCOURGE! RUN AWAY! RUN AWAY!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28542,'Light help us!','Light help us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28543,'IT\'S GHOULS!!!! GHOULS!!!!','IT\'S GHOULS!!!! GHOULS!!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28544,'I will not simply lay here and allow you to slay me! You will have to earn your right to draw another breath if you want to kill me, mortal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28545,'Hahaha, I\'m playin\' possum, mon. You gonna die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28546,'','Sure!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28547,'','Oh my...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28548,'','Tastes like I\'m drinking... engine degreaser!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28549,'Aye, I\'ll try it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28550,'That\'s exactly what I needed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28551,'It\'s got my vote! That\'ll put hair on your chest like nothing else will.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28552,'Scourge Disguise Failing! Find a safe place!','Scourge Disguise Failing! Find a safe place!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28553,'The Alliance bridge is under attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28554,'I\'m always up for something of Grimbooze\'s.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28555,'The Horde bridge is under attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28556,'Well, so far, it tastes like something my wife would drink...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28557,'Now, there\'s the kick I\'ve come to expect from Grimbooze\'s drinks! I like it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28558,'Care to try Grimbooze Thunderbrew\'s new jungle punch?','Care to try Grimbooze Thunderbrew\'s new jungle punch?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28559,'YOU WANT DRINK?!  WE GOT DRINK!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(28560,'HEY YOU!  DRINK OGRE BREWS!  MAKE YOU BIG AND STRONG!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(28561,'YOU TRY DA\' BEST, NOW TRY DA\' REST!  OGRE BREW!!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(28562,'Let\'s move through here as quickly as possible. If the undead don\'t kill us, the fires might.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28563,'Justice will be done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28564,'Awww... look at da purty lil\' gool.$b$bJump, lil\' gool! Jump!$b$bHa, ha, ha.... Attsa guud lil\' gool.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28565,'','We\'re tryin\' ta blow this wall so Wick\'s men can work on the new Harbor gatehouse and road beyond, but the clueless sod is cryin\' about me using too much powder!$B$BTch. I\'ve been sappin\' since he was in diapers. This goes on much longer, I\'ll kick him into the canal and finish the whole blasted job meself!',1,5,0,0,3,0,0,7,1,0,0,0,26124),
(28566,'We\'re building another road down into Stormwind Harbor as soon as this wall has been removed... but this mad dwarf brought enough powder to level the entire quarter!$B$BI don\'t know what Master Alexston was thinking when he hired her... she\'s foul-mouthed, mean, and stubborn as an ox!','',1,5,0,0,3,0,0,0,1,0,0,0,26124),
(28567,'What are we to do? We\'ve lost everything!','What are we to do? We\'ve lost everything!',0,0,0,0,0,0,0,0,1,7443,0,0,26124),
(28568,'','We fight! We push them back, just as we have always done!',0,0,0,0,0,0,0,0,1,7443,0,0,26124),
(28569,'','The Scourge are a blemish upon these pristine lands.  By the might of my creators, I will crush every last one of their decrepit bones under my heel.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28570,'What does the Light say to you now, Abbendis!','What does the Light say to you now, Abbendis!',0,0,0,0,0,0,0,0,1,7443,0,0,26124),
(28571,'I didn\'t see the Light step in to save my wife and children!','I didn\'t see the Light step in to save my wife and children!',0,0,0,0,0,0,0,0,1,7443,0,0,26124),
(28572,'Nor my husband and brothers!','Nor my husband and brothers!',0,0,0,0,0,0,0,0,1,7443,0,0,26124),
(28574,'The Light has abandoned us!','The Light has abandoned us!',0,0,0,0,0,0,0,0,1,7443,0,0,26124),
(28575,'','SILENCE! The Light has not abandoned us! The Light is stronger than ever among the pure!',0,0,0,0,0,0,0,0,1,7443,0,0,26124),
(28576,'Havenshire is lost!','Havenshire is lost!',0,0,0,0,0,0,0,0,1,7443,0,0,26124),
(28577,'The stables and mill are left abandoned! What will happen to our horses?','The stables and mill are left abandoned! What will happen to our horses?',0,0,0,0,0,0,0,0,1,7443,0,0,26124),
(28578,'','We are sending crusaders to reclaim what is rightfully ours! Any Scourge that stand in our way will be turned to ashes.',0,0,0,0,0,0,0,0,1,7443,0,0,26124),
(28579,'Where do you expect us to stay? New Avalon cannot hold all of us!','Where do you expect us to stay? New Avalon cannot hold all of us!',0,0,0,0,0,0,0,0,1,7443,0,0,26124),
(28580,'','The pure of heart will be allowed to remain in New Avalon. Those that the inquisitors find bereft of the holy Light will be turned away.',0,0,0,0,0,0,0,0,1,7443,0,0,26124),
(28581,'The crowd gasps.','The crowd gasps.',0,0,0,0,0,0,0,0,1,7443,0,0,26124),
(28582,'But none of you could possibly have anything to worry about, right?','',0,0,0,0,0,0,0,0,1,7443,0,0,26124),
(28583,'I want to stop the Scourge as much as you do.  How can I help?','I want to stop the Scourge as much as you do.  How can I help?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28584,'','The titans did not create life overnight.  The process was gradual and required a great deal of experimentation and iteration.$B$BIt is for that reason that highly protected places such as Sholazar Basin exist.$B$BTo ensure the safety of their experimentation sites, the titans created a defense mechanism.  Its destructive force is unparalleled however, and I will reveal no more unless you swear your fealty to my cause.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28585,'','It borders on sacrilege that these secrets be revealed to a mortal such as yourself, but I have little choice.$B$BEver since Freya, daughter of the titans, left me here I\'ve had but one task and I cannot fail.  Life must be protected at any cost.$B$BThere is a waygate that links this place with another very much like this one.  It is there that the weapon we seek can be found.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28586,'You can trust me.  I am no friend of the Lich King\'s.','You can trust me.  I am no friend of the Lich King\'s.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28587,'I will not fail.','I will not fail.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28588,'What are you hiding under that fold of flesh?','What are you hiding under that fold of flesh?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28589,'This outpost is a cog-free zone. Persons employing cogs in the construction of mechanical devices will be subject to unrelenting mockery.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28590,'Looks like you had the same idea I did. Hunting for fruit, are you?','Looks like you had the same idea I did. Hunting for fruit, are you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28591,'Loken?! That\'s downright bothersome... We might\'ve neutralized the iron dwarves, but I\'d lay odds there\'s another machine somewhere else churnin\' out a whole mess o\' these iron vrykul!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28592,'Ouch! Watch where you\'re tugging!','Ouch! Watch where you\'re tugging!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28593,'Glad I could help!','Glad I could help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28594,'Can you spare an orange?','Can you spare an orange?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28595,'Have a spare bunch of bananas?','Have a spare bunch of bananas?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28596,'I could really use a papaya.','I could really use a papaya.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28597,'Scourge filth! DIE!','Scourge filth! DIE!',0,0,0,0,0,0,0,0,1,7504,0,0,26124),
(28598,'The Crusade will be victorious!','The Crusade will be victorious!',0,0,0,0,0,0,0,0,1,7504,0,0,26124),
(28599,'I will present your head to Abbendis myself!','I will present your head to Abbendis myself!',0,0,0,0,0,0,0,0,1,7504,0,0,26124),
(28600,'You\'re not welcome in these lands, monster!','You\'re not welcome in these lands, monster!',0,0,0,0,0,0,0,0,1,7504,0,0,26124),
(28601,'Let the purging begin!','Let the purging begin!',0,0,0,0,0,0,0,0,1,7504,0,0,26124),
(28602,'By the Light be cleansed!','By the Light be cleansed!',0,0,0,0,0,0,0,0,1,7504,0,0,26124),
(28603,'Light bless you, my child.','Light bless you, my child.',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28604,'%s calls forth an army of frozen corpses.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28605,'Bonesunder begins to cast Crack Bone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28606,'There are two zeppelin towers outside Orgrimmar. The eastern tower serves Tirisfal Glades and Stranglethorn Vale, while the western tower serves Northrend and Thunder Bluff.','There are two zeppelin towers outside Orgrimmar. The eastern tower serves Tirisfal Glades and Stranglethorn Vale, while the western tower serves Northrend and Thunder Bluff.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(28607,'Eastern Zeppelin Tower','Eastern Zeppelin Tower',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28608,'Western Zeppelin Tower','Western Zeppelin Tower',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28609,'Faster, brother! I don\'t know how much longer we can hold these Scourge monsters back!','Faster, brother! I don\'t know how much longer we can hold these Scourge monsters back!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28610,'Double your efforts! Get this wood piled up and ready for shipment to New Avalon!','Double your efforts! Get this wood piled up and ready for shipment to New Avalon!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28611,'I\'m workin\' as fast as I can, cap\'n!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28612,'I can\'t keep this pace up, sir! If the Scourge don\'t get me, exhaustion will!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28613,'I\'m on it!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28614,'Got another pile ready to go! Outta my way!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28615,'The horns of war have sounded! We haven\'t much time! Quicken your pace!','The horns of war have sounded! We haven\'t much time! Quicken your pace!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28616,'Havenshire will soon be overrun with Scourge. We must hurry!','Havenshire will soon be overrun with Scourge. We must hurry!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28617,'We gonna kill \'em all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28618,'The puny zandalari are gonna be crushed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28619,'Go, my strikers. Ride out and take Zim\'Torga back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28620,'I gonna give you all the gold and gems you can carry if you bring me ten of their heads!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28621,'Are you blind? They\'re right there. Kill them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28622,'I see you. Why don\'tcha come on up and we settle this Drakkari to maggot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28623,'If they not willin\' to come out of Zim\'Torga, burn it to the ground!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28624,'Zandalari, Argent Crusade, Scourge... I don\'t care who you are. I\'m gonna crush you like a bug!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28625,'The Lightbringer...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28626,'Lord Uther...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28627,'Who\'s that beatin\' on my drum?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28628,'I\'m gonna come down there and kill you good, $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28629,'Now you gonna die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28630,'Please take... my shinies. All done...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28631,'We saved. You nice, dryskin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28632,'The mosswalker looks severely injured.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28633,'<Check for a pulse...>','<Check for a pulse...>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28634,'These tracks must belong to Shango.','These tracks must belong to Shango.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28635,'These aren\'t Shango\'s tracks.','These aren\'t Shango\'s tracks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28636,'','From this dock, The Bravery travels back and forth between Stormwind and Rut\'theran Village.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(28637,'Iceshatter begins to cast Pulsing Shards.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28638,'The mosswalker victim groans in pain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28639,'The gas tank in %s is half full.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28640,'%s is almost out of fuel.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28641,'My poor flying machine. She didn\'t survive the crash and without spare parts, I\'ll never get \'er up and running again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28642,'Bloodfeast summons Blood Maggots to his aid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28643,'\'Ey dere, mon.$b$bkeep yerself busy. Dere be plenty ta do \'round here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28644,'Soon, $n!$b$bSoon ya be tastin\' true power. Soon ya be rewarded for your dedication and service.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28645,'Ya be on da path, mortal....$b$bEndure, and ya be gettin\' great power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28646,'Ah, the hero. Your little friends said you would come. This certainly saves me the trouble of hunting you down myself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28647,'I have weathered a hundred years of war and suffering. Do you truly think it wise to pit your mortal body against a being that cannot die? I\'d venture you have more to lose.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28648,'Even shattered into countless pieces, the crystals all around weaken me... perhaps I should not have underestimated the titans so...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28649,'These two brave, ignorant fools despise each other, yet somehow they both spoke of you as a hero. Perhaps you just lack the will to choose a side... let me extend you that opportunity.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28650,'Arthas once mustered strength... of the very same sort... perhaps his is the path that you will follow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28651,'Great and powerful Har\'koa, please call for one of your children that it might stealthily carry me into the Altar of Quetz\'lun.','Great and powerful Har\'koa, please call for one of your children that it might stealthily carry me into the Altar of Quetz\'lun.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28652,'Thank you for saving me, $n. This is the least that I could do to return the favor. Hold on tight. Here we go.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28653,'Hold on tight. Here we go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28654,'This doesn\'t look good. Whatever you do, don\'t fall off. There\'s a ton of nasty things in there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28655,'Mphmm rmphhimm rrhumghph?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(28656,'Oh no... Quetz\'lun is dead! Stay still. We\'ll sneak past the prophet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28657,'Rmmurphum mmph hmrphum!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(28658,'Umphrum mmphur, murruphru...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(28659,'Uhh, can you send me on the tour of Zul\'Drak?','Uhh, can you send me on the tour of Zul\'Drak?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28660,'We\'re spotted! Hang on. We have to get out of here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28661,'We made it! Take care, $n, and thanks again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28662,'He dead... we free! We glad you pick us instead of puppy-men. Very glad! Definately. Very glad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28663,'What was that? I sense an intruder. Find and kill them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28664,'We\'re off!  Watch out for those vines!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28665,'Looks like the Scourge have hit the area ahead pretty bad...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28666,'You see that?  She\'s... huge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28667,'Here we go!  Hold on tight -- there\'s rough wind ahead!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28668,'They\'re coming at us!  Be quick with those rockets!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28669,'Aggggh!  I\'m hit!  You\'re going to have to get us back!  Quick, before the plane explodes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28670,'Abomination, I require your assitance!','Abomination, I require your assitance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28671,'I think we\'re safe now. Let\'s get back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28672,'Deliver these results to our apothecaries in the Undercity. And please, try not to digest the message this time?','Deliver these results to our apothecaries in the Undercity. And please, try not to digest the message this time?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28673,'Welcome. May I offer you rest or sustenance?','Welcome. May I offer you rest or sustenance?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(28674,'Your...will...be...done...<burp>','Your...will...be...done...<burp>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28675,'Dirty, stinkin\', horse thief!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28676,'Nobody steals Kitrik\'s horses!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28677,'You\'ll be hanging at the gallows soon...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28678,'How many more of you do I need to send back to the Lich King in pieces before he\'ll stop?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28679,'This specimen shows promise.  Where did we get it?','This specimen shows promise.  Where did we get it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28680,'The specimen was a male human.  A farmer.  He\'d killed his family and then wandered into Stormwind.','The specimen was a male human.  A farmer.  He\'d killed his family and then wandered into Stormwind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28681,'The specimen is a female gnome.  Even while infected, her insufferable cuteness let her get close to and infect a dozen others before being stopped.','The specimen is a female gnome.  Even while infected, her insufferable cuteness let her get close to and infect a dozen others before being stopped.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28682,'','Do you like the new home that I\'ve carved out for my so-called worshippers?$B$BIn the throes of my death, I cursed them all and dragged them along with me into this special underworld of my own creation.$B$BI think that I shall delight in their eternal torment, but what I really want is to exact revenge upon my former prophet!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28683,'%s calls upon the mighty armies of the Scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28684,'Armies of the Scourge, hear my call! The scarlet apocalypse has begun! Tear this land asunder and leave only death in your wake!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28685,'That\'s the blood of a male orc.  He burned himself alive in order to halt his infection.','That\'s the blood of a male orc.  He burned himself alive in order to halt his infection.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28686,'That\'s a female tauren.  She was watching over her village\'s children when the zombies came.  She stopped the attack, but was bitten and could not cure it before succumbing.','That\'s a female tauren.  She was watching over her village\'s children when the zombies came.  She stopped the attack, but was bitten and could not cure it before succumbing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28687,'Strange, the records on this one are incomplete.  It just says \"I killed it!\" in a rough scrawl, written in blood.','Strange, the records on this one are incomplete.  It just says \"I killed it!\" in a rough scrawl, written in blood.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28688,'That one\'s a brother.  A forsaken.  Treat him with respect.','That one\'s a brother.  A forsaken.  Treat him with respect.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28689,'That one\'s a male tauren.  A shaman.  He was infected and killed before he could cure himself.','That one\'s a male tauren.  A shaman.  He was infected and killed before he could cure himself.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28690,'She was a female dwarf.  A paladin.  She used the last of her mana curing comrades before falling to her own infection.','She was a female dwarf.  A paladin.  She used the last of her mana curing comrades before falling to her own infection.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28691,'A portion of this land already be mine, mon, but it only be da beginning!','',0,0,0,0,0,0,0,0,1,7392,0,0,26124),
(28692,'This specimen shows concentrated necrosis.  What is its history?','This specimen shows concentrated necrosis.  What is its history?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28693,'This blood has unique properties.  Where was it obtained?','This blood has unique properties.  Where was it obtained?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28694,'We may learn much from this specimen...','We may learn much from this specimen...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28695,'This sample is highly infected!  How was it acquired?','This sample is highly infected!  How was it acquired?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28696,'I need more samples like this one.  Who was it?','I need more samples like this one.  Who was it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28697,'This latest sample is unique.  What is its history?','This latest sample is unique.  What is its history?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28698,'We can learn much from these experiments...','We can learn much from these experiments...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28699,'The glacier is seeping in from Icecrown... and undead everywhere!  Wait \'til the professor gets a hold of this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28700,'Here, da self-righteous crusaders be standin\' in da way of our goal. Dey will fall!','',0,0,0,0,0,0,0,0,1,7392,0,0,26124),
(28701,'Dis all soon gunna belong to da Lich King!','',0,0,0,0,0,0,0,0,1,7392,0,0,26124),
(28702,'And keep the change, ya filthy animal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28703,'Perhaps you\'ll think twice about stealin\' one of Kitrik\'s horses next time, eh?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28704,'Is that all you got?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28705,'What a colossal waste of time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28706,'At least make me work for it next time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28707,'Seriously?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28708,'Da Drakkari be destroyin\' their lands! Dey gunna be losin\' dem... soon, mon.','',0,0,0,0,0,0,0,0,1,7392,0,0,26124),
(28709,'Ahh, dere be our destiny... Gundrak!','',0,0,0,0,0,0,0,0,1,7392,0,0,26124),
(28710,'Mhrrumph rummrhum phurr!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(28711,'The mortals will be tested!','The mortals will be tested!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28712,'My blade thirsts for blood!','My blade thirsts for blood!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28713,'Our enemies will fall!','Our enemies will fall!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28714,'Vengeance!','Vengeance!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28715,'Death to the living!','Death to the living!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28716,'The fields will run red with the blood of the Scarlet Crusade!','The fields will run red with the blood of the Scarlet Crusade!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28717,'I have heard the call, my lord!','I have heard the call, my lord!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28718,'A dozen will fall before I am slain!','A dozen will fall before I am slain!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28719,'Suffer well, death knight...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28720,'For the Lich King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28721,'Strike them down in the name of the Scourge!','Strike them down in the name of the Scourge!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28722,'Draw out their suffering, death knight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28723,'Leave nothing for their clerics to resurrect!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28724,'Bring me their flesh...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28725,'No mercy for the living!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28726,'No mercy for the weak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28727,'Command me, harvester!','Command me, harvester!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28728,'More souls for the blade!','More souls for the blade!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28729,'Suffering to the weak!','Suffering to the weak!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28730,'CHAOS!','CHAOS!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28731,'DESTRUCTION!','DESTRUCTION!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28732,'Blood and terror, harvester!','Blood and terror, harvester!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28733,'For the Lich King!','For the Lich King!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28734,'By the might of Mograine!','By the might of Mograine!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28735,'Death is their only escape!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28736,'APOCALYPSE!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28737,'End the mortal affront!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28738,'Suffer well, death knight!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28739,'They will be forgotten...','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28740,'Wipe their existence from this world!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28741,'The Scourge shall reign supreme!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28742,'BLOOD AND TERROR!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28743,'At your beck and call, horseman!','At your beck and call, horseman!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28744,'Heads will roll!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28745,'Let them run! There is nowhere to hide!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28746,'Show them the meaning of fear, death knight!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28747,'Devour their hearts! Siphon their souls!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28748,'Suffer well, death knight!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28749,'MORE PAIN!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28750,'Tear this land apart!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28751,'You will hear their cries from up here, my lord!','You will hear their cries from up here, my lord!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28752,'I am ready for battle!','I am ready for battle!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28753,'CARNAGE!','CARNAGE!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28754,'The Crusade has been marked for death!','The Crusade has been marked for death!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28755,'I will be your chosen knight, Salanar!','I will be your chosen knight, Salanar!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28756,'The engine\'s blown!  Fly Vic\'s Flying Machine back to Lakeside Landing!','',0,0,0,0,0,0,0,0,1,7394,0,0,26124),
(28757,'Mhrrumph rummrhum phurr!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28758,'Scourge Disguise Failing! Run for cover!','Scourge Disguise Failing! Run for cover!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28759,'Scourge Disguise Failing! Hide quickly!','Scourge Disguise Failing! Hide quickly!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28760,'','Indeed. Watch this, $r.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(28761,'Come to buy from Hargus, you have?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(28762,'Yes, Hargus. I wish to purchase supplies.','Yes, Hargus. I wish to purchase supplies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28763,'P... Please don\'t...','P... Please don\'t...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28764,'No! Please! I... I have children! I... I...','No! Please! I... I have children! I... I...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28765,'Spare my life! I will leave this place forever! Please!','Spare my life! I will leave this place forever! Please!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28766,'May the Light take mercy on your soul, death knight.','May the Light take mercy on your soul, death knight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28767,'Have mercy, $g sir:madam;!','Have mercy, $g sir:madam;!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28768,'I almost... made it...','I almost... made it...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28769,'You make my children orphans on this day, fiend!','You make my children orphans on this day, fiend!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28770,'Why?','Why?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28771,'No mercy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28772,'Kill them all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28773,'Mercy is for the weak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28774,'End it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28775,'Finish it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28776,'No survivors.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28777,'Kill or be killed, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28778,'Do not hesitate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28779,'Harness your rage and focus!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28780,'Strike it down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28781,'Suffering to the conquered!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28782,'Show it the meaning of terror.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28783,'End its miserable life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28784,'Give in to the darkness, death knight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28785,'Do you think it would hesitate to kill you? A monster like you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28786,'Living or dead, you will serve me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28787,'You\'re not taking me without a fight!','You\'re not taking me without a fight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28788,'I won\'t go down that easy!','I won\'t go down that easy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28789,'Die Scourge dog! DIE!','Die Scourge dog! DIE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28790,'Come then, death knight!','Come then, death knight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28791,'Is this the best the Scourge can do?','Is this the best the Scourge can do?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28792,'You may take my life, but you won\'t take my freedom!','You may take my life, but you won\'t take my freedom!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28793,'DIE!','DIE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28794,'The realm of shadows awaits...','',0,0,0,0,0,0,0,0,1,7396,0,0,26124),
(28795,'Defeat me and take from me the deathcharger I ride. That is the only way to win and return to the world of the living, death knight. Are you ready?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(28796,'I am ready, rider.','I am ready, rider.',0,0,0,0,0,0,0,0,1,7397,0,0,26124),
(28797,'NOOOOOOOOOoooooooo.......!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28798,'%s is spun to death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28799,'','The high priestess is reduced to charcoal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28800,'','FIRE! AHHHHHHHH!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28801,'Another supplicant seeking the favors of da Lich King?$b$bOnly da worthy be obtainin\' da dark gifts....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28802,'BRRRRRR!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28803,'%s explodes!','%s explodes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28804,'Welcome to Dalaran\'s Guild Registry offices. How may I help you?','Welcome to Dalaran\'s Guild Registry offices. How may I help you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28805,'Noted.  Return to the conflict areas.  Concentrate our outfield efforts on procuring more victims of the zombie plague.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28806,'The objective is simple: kill me and take my deathcharger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28807,'Should you actually succeed in accomplishing this monumental feat, return here, to Death\'s Breach, with my deathcharger and use the Horseman\'s Call to summon Salanar from the realm of the living.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28808,'Grand Apothecary Putress!  I come to report from the battlefronts...','Grand Apothecary Putress!  I come to report from the battlefronts...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28809,'Are you prepared? The challenge begins on my mark!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28810,'3...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(28811,'2...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(28812,'1...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(28813,'NOW!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(28814,'Power to the Forsaken!','Power to the Forsaken!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28815,'For the Banshee Queen!','For the Banshee Queen!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28816,'Explosive Charges will detonate in 5 seconds...','',0,0,0,0,0,0,0,0,1,7399,0,0,26124),
(28817,'Explosive Charges will detonate in 4 seconds...','',0,0,0,0,0,0,0,0,1,7399,0,0,26124),
(28818,'Explosive Charges will detonate in 3 seconds...','',0,0,0,0,0,0,0,0,1,7399,0,0,26124),
(28819,'Explosive Charges will detonate in 2 seconds...','',0,0,0,0,0,0,0,0,1,7399,0,0,26124),
(28820,'Explosive Charges will detonate in 1 seconds...','',0,0,0,0,0,0,0,0,1,7399,0,0,26124),
(28821,'Everyone I know seems to be coming down with something really bad.','Everyone I know seems to be coming down with something really bad.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28822,'I haven\'t felt this bad since I tried to eat some Dragon\'s Breath Chili.','I haven\'t felt this bad since I tried to eat some Dragon\'s Breath Chili.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28823,'My bed is looking pretty good right now.','My bed is looking pretty good right now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28824,'My boss is going to kill me if I have to stay home sick another day this month.','My boss is going to kill me if I have to stay home sick another day this month.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28825,'Have you heard any news from the town leaders about the sickness going around?','Have you heard any news from the town leaders about the sickness going around?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28826,'Have you talked to anyone who hasn\'t started getting sick?','Have you talked to anyone who hasn\'t started getting sick?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28827,'It must be something in the water, I tell you.','It must be something in the water, I tell you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28828,'Oh, my. Excuse me a moment.','Oh, my. Excuse me a moment.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28829,'Did you see that?','Did you see that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28830,'','It is done.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28831,'','%s is visibly weakened.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28832,'','TIME TO DIE, FOOL!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28833,'What? How is this possible?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28834,'I hope the archmage appreciates what I\'ve gone through to uphold Hemet\'s end of the bargain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28835,'Impressive, death knight. Return to me in the world of the living for your reward.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28836,'','You should be sticking close to Arthas right now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28837,'What is this you pathetic, little worm? Come to die?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28838,'I recognize your stench. You\'re the one who stealthed by me on the back of that snow leopard runt!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28839,'Not feel so good... maybe come back find us later?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28840,'We not want to die. We want to help though! Come back for us, okay?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28841,'We sorry... going home so not die now. We so sorry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28842,'','I\'ve returned to invite you to my housewarming in the underworld!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28843,'','I\'d say come along quietly, but we both know that\'s not going to happen. My little friend here is going to ease your way into the afterlife.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28844,'Let the battle for the Strand of the Ancients begin!','',0,0,0,0,0,0,0,0,0,0,34105,0,26124),
(28845,'The battle for the Strand of the Ancients begins in 1 minute.','',0,0,0,0,0,0,0,0,0,0,34104,0,26124),
(28846,'The battle for the Strand of the Ancients begins in 30 seconds.  Prepare yourselves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28847,'Only one of us may leave this world!','',0,0,0,0,0,0,0,0,1,7503,0,0,26124),
(28848,'Is this it? Is this the best that Salanar could send against me?','',0,0,0,0,0,0,0,0,1,7503,0,0,26124),
(28849,'Come, weakling! Strike me down!','',0,0,0,0,0,0,0,0,1,7503,0,0,26124),
(28850,'You will never return to the world of the living!','',0,0,0,0,0,0,0,0,1,7503,0,0,26124),
(28851,'Another pathetic wretch thinks they can defeat the Dark Rider of Acherus!','',0,0,0,0,0,0,0,0,1,7503,0,0,26124),
(28852,'Give up, outsider!','',0,0,0,0,0,0,0,0,1,7503,0,0,26124),
(28853,'I can smell your fear.','',0,0,0,0,0,0,0,0,1,7503,0,0,26124),
(28854,'Pathetic...','',0,0,0,0,0,0,0,0,1,7503,0,0,26124),
(28855,'NOOOOooooooooooooooooo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28856,'','Let\'s get the hell out of here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28857,'','Listen up, Venture Company goons! Rule #1: Never keep the prisoner near the explosives.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28858,'Your disguise doesn\'t fool me, fleshling! Your defeat will please Drakuru!','',0,0,0,0,0,0,0,0,1,7417,0,0,26124),
(28859,'','Or THIS is what you get.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28860,'','It\'s getting a little hot over here. Shall we move on?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28861,'We will take everything from them, death knight.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(28862,'','Oh, look, it\'s another cartload of explosives! Let\'s help them dispose of it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28863,'Salanar, I must return to the Realm of Shadows.','Salanar, I must return to the Realm of Shadows.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28864,'','You really shouldn\'t play with this stuff. Someone could get hurt.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28865,'','We made it! Thank you for getting me out of that hell hole. Tell Hemet to expect me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28866,'I don\'t understand...','I don\'t understand...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28867,'What did I do?','What did I do?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28868,'I didn\'t... deserve this...','I didn\'t... deserve this...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28869,'Why?','Why?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28870,'Ow, ow ow. Okay... ow!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28871,'Too fast for you! Can\'t catch us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28872,'Hey! Where\'d Jaloot go? Poof!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28873,'This fight\'s all yours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28874,'Well that\'s quite enough of that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28875,'Find me at town if you\'re looking to try to throw me to death some more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28876,'','Well done. I\'ll see to it that my prophet enjoys his eternal stay with me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28877,'Wait... STOP! You can\'t take back the power!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28878,'I need to heal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28879,'We should get out of here. I need to renew!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28880,'I think it\'s time that I cast my renew!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28881,'Enjoy ride! Call me when you get there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28882,'I don\'t know how much longer I can hold on!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28883,'Frenzyheart will take land for own. Big-tongues will leave or we kill them good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28884,'Darmuk must die, mon!','',0,0,0,0,0,0,0,0,1,7417,0,0,26124),
(28885,'Frenzyheart can be vicious, but we good people. You see if you stay long, we friends with smart and strong just fine.$B$BWe just don\'t like dumb.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28886,'This the Great Rain Stone. We keep it safe and bring it shinies and it take care of us.$B$BHave more shinies for stone maybe?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28887,'What I not have in height I make up for in magics. I take care of Great Mist Stone good... most of time anyway.$B$BDumb puppy-men.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28888,'Puppy-men been attacking us for days now. Great Lightning Stone is still safe though.$B$BSoo-holu come to help us like many times before... puppy-men not stand a chance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28889,'Kartak comes for big-tongue meat. Frenzyheart make sure plenty is ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28890,'Champions, meet me at the Town Hall at once. We must take the fight to Mal\'Ganis.','Champions, meet me at the Town Hall at once. We must take the fight to Mal\'Ganis.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28891,'Disguise Failing! Avoid Scourge Contact!','Disguise Failing! Avoid Scourge Contact!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28892,'It\'s your lucky day, Zootfizzle. $n has brought more hatchlings for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28893,'I\'m not here to be the keeper of your hatchlings, Dorian. I\'m doing research of my own, as well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28894,'Well, you can always go back to the camp and help Weslex with all his cogs...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28895,'No, not the cogs! Anything but the cogs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28896,'Dey be stronger then I expect mon, attack dem!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28897,'Wait for me orders, I handle dis myself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28898,'Where\'d this come from? I better get this down to the ships before the foreman sees it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28899,'I\'ll just leave it here and nobody will be the wiser!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28900,'We gave shinies to shrine... we not greedy... why this happen?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28901,'Use my shinies... make weather good again... make undead things go away.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28902,'Thank... you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28903,'We not do anything... to them... I no understand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28904,'I do something bad? I sorry....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28905,'Thank you! You good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28906,'Maybe you make weather better too?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28907,'I give more shinies to shrines! I promise! I sorry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28908,'Help more mosswalkers, okay?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28909,'You save us! Yay for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28910,'Hello, dryskin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28911,'You seem to have bested my guards. No matter, they were of little use anyway. Time to die! [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28912,'Everything okay?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28913,'Yeah?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28914,'It nice having a good hunting partner.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28915,'Something wrong?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28919,'Hi! How you? We\'re good... yup, good good. Hi!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28920,'Ever trip over own feet? We have. Kind of hurt. No do it, not fun. Nope.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28921,'Hello! You\'re pretty strong and nice and stuff. I like you. Lets stay friends, okay?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28922,'Want us to help with something? What we help with? We good at helping.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28923,'What are you looking at?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28924,'Is there a reason we\'re still standing here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28925,'I assume you want something.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28926,'','I am forever in your debt, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28927,'','$n, somehow I feel stronger from Mam\'toth\'s blood.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28928,'','I\'m free! Quickly, enact Quetz\'lun\'s Revenge. I\'ll meet you afterward at Zim\'Torga.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28929,'Can\'t... breathe...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28930,'Skin... burns... the... pain...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28931,'Vision... blurry... can\'t... see...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28932,'H-Help... Somebody... Anybody...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28933,'I\'m dying...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28934,'The attacking team failed to beat the defending team\'s capture time! No bonus for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28935,'Lets see you try that again! [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28936,'Now you not catch us with back turned! Now we hurt you bad undead. BAD!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28937,'You going die big bad undead thing! You not catch Zepik sleeping this time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28938,'Get in the pit you worthless pile of garbage!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28939,'It puts the ghoul in the pit or else it gets the lash!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28940,'GHOUL! PIT! NOW!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28941,'Get in that pit before I turn you into a pile of ash and feces!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28942,'Back you mindless wretch! Back to the pit!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28943,'The pit calls, minion. Go to it. NOW!','',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(28944,'The Alliance captured the titan portal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28945,'The Horde captured the titan portal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28946,'The battle for the Strand of the Ancients has ended!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28947,'','$n, please come to me.  I\'m here in Zim\'Torga now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28948,'The prophet meditates on how best to handle stealing the power from his goddess.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28949,'The %s begins to pray to Har\'koa for advice, but then thinks better of it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28950,'Muttering to himself about the slow speed at which his plans are proceeding, the %s continues with this rituals.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28951,'The prophet inclines his head slightly as if he has noticed something amiss.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28952,'I need to find Goregek, do you have his shackles?','I need to find Goregek, do you have his shackles?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28953,'I need to find Dajik, do you have his chalk?','I need to find Dajik, do you have his chalk?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28954,'I need to find Zepik, do you have his hunting horn?','I need to find Zepik, do you have his hunting horn?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28955,'So hungry...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28956,'Must feed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28957,'GIVE ME BRAINS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28958,'Smell flesh... close...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28959,'Mommy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28960,'$g Poppy:Mama;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28961,'I need to find Lafoo, do you have his bug bag?','I need to find Lafoo, do you have his bug bag?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28962,'I need to find Jaloot, do you have his favorite crystal?','I need to find Jaloot, do you have his favorite crystal?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28963,'I need to find Moodle, do you have his stress ball?','I need to find Moodle, do you have his stress ball?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28964,'I\'ll take you with me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28965,'It won\'t be that easy, fiend!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28966,'The grave calls to us all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28967,'YOU KILLED ME!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28968,'Die, Scourge filth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28969,'Vengeance is mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28970,'Nice day for flying, isn\'t it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28971,'I know an ace when I see one.  Thanks again for saving my life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28972,'The Scourge has broken through!','The Scourge has broken through!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28973,'BEHIND US! They\'ve taken the ships!','BEHIND US! They\'ve taken the ships!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28974,'MONSTERS!','MONSTERS!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28975,'How could this have happened!?','How could this have happened!?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28976,'Get \'em off that ship! Kill every last one of \'em!','Get \'em off that ship! Kill every last one of \'em!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28977,'Take cover! Take cover!','Take cover! Take cover!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28978,'I don\'t believe it!','I don\'t believe it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28979,'Death to the Scourge!','Death to the Scourge!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28980,'The Horde wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28981,'The Alliance wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28982,'Both sides defended the keep! Draw!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28983,'Yer gonna have to shoot faster than that! I\'ve already got 11 kills!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28984,'That\'s number 10! How many\'ve you got?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28985,'Number 9! I could do this with my eyes closed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28986,'11! It\'s gonna take a bigger effort than that to beat ol\' Drostan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28987,'Return to Sparktouched Haven or Kartak\'s Hold.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28988,'Return to Kartak\'s Hold or Sparktouched Haven.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28989,'Round 1 - Finished!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28990,'Return to the Altar of Mam\'toth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28991,'Horde Defense Victory Calculation Here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28992,'Alliance Defense Victory Calculation Here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28993,'Now you gunna die, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28994,'I come to avenge my bruddas, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28995,'Die, nasty scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28996,'Die, nasty scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28997,'We gunna drive all da scourge outta Zul\'Drak, mon - startin\' with you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28998,'Wha?!...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(28999,'Aaah....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29000,'Ooof!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29001,'Owww!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29002,'Prepare to be Swarmed! [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29003,'You feel a massive jolt of energy as your body binds with that of Soo-holu.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29004,'Look at what you have done, death knight! You have brought glory to the Scourge!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(29005,'You feel rage rise within you as your body binds with Kartak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29006,'','You get out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29007,'','Daddy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29008,'I\'ll kill you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29009,'Please, no! Spare me!','Please, no! Spare me!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(29010,'Don\'t kill me! I only took this job for the benefits!','Don\'t kill me! I only took this job for the benefits!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(29011,'Let me live! I\'ll do whatever you say!','Let me live! I\'ll do whatever you say!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(29012,'I\'ve got five kids, $g man:lady;! They\'ll die without me!','I\'ve got five kids, $g man:lady;! They\'ll die without me!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(29013,'You don\'t have to do this! Nobody has to die!','You don\'t have to do this! Nobody has to die!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(29014,'I picked the wrong week to quit drinkin\'!','I picked the wrong week to quit drinkin\'!',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(29015,'Ungh... I... I think I pooped...','Ungh... I... I think I pooped...',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(29016,'I... I got a sick grandma at home... I... I\'m all she\'s got, $g mister:miss;.','I... I got a sick grandma at home... I... I\'m all she\'s got, $g mister:miss;.',0,0,0,0,0,0,0,0,1,7391,0,0,26124),
(29017,'Ripe... for the harvest!','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29018,'Lemme outta here, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29019,'You Scourge not welcome in Zul\'Drak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29020,'Zul\'Drak belongs to da Drakkari, mon. Always will!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29021,'You Scourge gunna fail here, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29022,'Our people gunna kill every last one o\' you Scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29023,'Get away from me, nasty Scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29024,'You\'re no Scourge. What you doin\' here, mon?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29025,'Why da Scourge let you walk around in here, mon?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29026,'I think you be lost, mon....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29027,'My people gunna rescue me any minute, mon! ....I think.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29028,'What ya gunna do to us, mon?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29029,'Just kill me, mon! I don\'t wanna be a Scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29030,'I\'m never gunna be servin\' da Lich King! Never!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29031,'Drakkari Empire gunna prevail! Da Scourge gunna die... again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29032,'Hrm? Let\'s see what we get out of this one.','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29033,'Blasted geists! They\'ve practically devoured this one whole...','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29034,'Contemptible wretches! Stay away from the bodies!','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29035,'This one is especially ugly. Perfect for a ghoul...','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29036,'I think its spine is broken. Ghoul it is!','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29037,'Is Gothik the Harvester going to have to choke a geist?','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29038,'Surprise, surprise! Another ghoul!','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29039,'Death is the only escape!','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29040,'You have an enchanted tiki? YOU KILLED MY FAMILY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29041,'I WILL KILL YOU, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29042,'Soon now, $n.$b$bFinal preparations are being made, den our advance on Gundrak begins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29043,'You will fly again, beast...','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29044,'Death comes on bony wings...','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29045,'Rise, minion. Rise and fly for the Scourge!','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29046,'The time to feed is now, minion. Wake!','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29047,'Open your eyes, brothers and sisters! GAZE UPON APOCALYPSE!','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29048,'The sky itself feeds upon the suffering of the conquered!\n','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29049,'The Scarlet Crusade is powerless to stop us!\n','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29050,'The corpses of those that try only serve to feed our expanding host!','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29051,'The Scarlet fleet lies in ruin upon the sundered coast!\n','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29052,'With each enemy slain, our strength grows! We mustn\'t relent! \n','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29053,'The Lich King has spoken to each of you! Let his words resonate among you once more!','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29054,'ALL. MUST. DIE.','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29055,'Leave no survivors in your wake, brothers and sisters!','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29056,'No mercy for the weak!','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29057,'TERROR!','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29058,'CHAOS!','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29059,'DESTRUCTION!','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29060,'With the approaching darkness comes the end of the Scarlet Crusade. You will battle once more! For the Scourge! For the Lich King!','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29061,'SUFFER WELL, DEATH KNIGHTS!','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29062,'It might look like an ordinary pumpkin patch now, but once the plague cauldron is placed it will become a source of disease, rot and plague!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(29063,'Noth, where is Heigan?','Noth, where is Heigan?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29064,'How dare you! Get out of my sight!','',5,25,0,0,0,0,0,0,1,0,0,0,26124),
(29065,'That no good kiss-up is probably practicing ballet in his chambers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29066,'NEVER say that name around me! Consider this your one and only warning!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(29067,'I can tell you where he\'s not...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29068,'Heigan is probably performing maintenance on his slime and crap filled dance studio.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29069,'%s rears up, beckoning you to ride it.','',0,0,0,0,0,0,0,0,1,7397,0,0,26124),
(29070,'My task is done!','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29071,'It\'s only a matter of time before the plague overtakes New Avalon.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29072,'RUN FOR YOUR LIVES!','RUN FOR YOUR LIVES!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29073,'The Scourge has broken through! RUN AWAY! RUN AWAY!','The Scourge has broken through! RUN AWAY! RUN AWAY!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29074,'HELP! HELP!','HELP! HELP!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29075,'SCOURGE!!! RUN!!!','SCOURGE!!! RUN!!!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29076,'Spare my life, $n! Please!','Spare my life, $n! Please!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29077,'Is nowhere safe from these monsters?','Is nowhere safe from these monsters?',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29078,'Somebody save me!','Somebody save me!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29079,'We\'re all gonna die!!!','We\'re all gonna die!!!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29080,'I\'m up to 15. Top that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29081,'That\'s my 16th and I\'m still going easy on ya!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29082,'You\'re going to have to pick it up, or this isn\'t going to be much of a competition.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29083,'Ha! 16! How many\'ve you got? 10, maybe 11 if you\'re lucky?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29084,'That\'s my 25th kill. How far behind are you now?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29085,'The... They promised that we\'d be safe...','The... They promised that we\'d be safe...',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29086,'I\'m too young to die!','I\'m too young to die!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29087,'I\'ll give you anything you want! Just let me live!','I\'ll give you anything you want! Just let me live!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29088,'Ask for anything and you shall have it! Just spare my life!','Ask for anything and you shall have it! Just spare my life!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29089,'Filthy coward! Get it over with...','Filthy coward! Get it over with...',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29090,'Scourge scum... May the Light purge you from this world!','Scourge scum... May the Light purge you from this world!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29091,'26th! Are you going to start killing, or what?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29092,'My mother could hunt faster than you, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29093,'Kill number 26 and I\'m still just warming up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29094,'Fineous has what you need, friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29095,'I wish to make a purchase, Fineous.','I wish to make a purchase, Fineous.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29096,'Well, now that I\'ve got a nice lead, I think I\'ll enjoy a little nap.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29097,'Well, that was a relaxing nap. How\'s the game hunting going over there?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29098,'We were promised safety! Security!','We were promised safety! Security!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29099,'The Scourge are running freely through the streets!','The Scourge are running freely through the streets!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29100,'My whole family\'s been killed! Where was the army when we needed them most?','My whole family\'s been killed! Where was the army when we needed them most?',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29101,'I\'ve got a nice lead, yet. Think I\'ll do some fishin\'.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29102,'No more lies, Quimby! We want answers!','No more lies, Quimby! We want answers!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29103,'Where are those ships going, Quimby! Tell us the truth!','Where are those ships going, Quimby! Tell us the truth!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29104,'We\'re done for! Save us, Quimby!','We\'re done for! Save us, Quimby!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29105,'If you don\'t come out, we\'ll tear this place apart!','If you don\'t come out, we\'ll tear this place apart!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29106,'Everybody is dying! Help us!','Everybody is dying! Help us!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29107,'What\'s \"Crimson Dawn!\" We deserve to know the truth, Quimby!','What\'s \"Crimson Dawn!\" We deserve to know the truth, Quimby!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29108,'Naxxramas is gone? Who cares! Acherus is here now and the death knights are killing everybody!','Naxxramas is gone? Who cares! Acherus is here now and the death knights are killing everybody!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29109,'I assure you this much, Quimby, you won\'t be getting my vote next term!','I assure you this much, Quimby, you won\'t be getting my vote next term!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29110,'You\'re useless, Quimby!','You\'re useless, Quimby!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29111,'This is a slap in the face! We demand answers!','This is a slap in the face! We demand answers!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29112,'Well, now we\'ve got a competition on our hands.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29113,'I want on that last ship! Don\'t leave us!','I want on that last ship! Don\'t leave us!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29114,'So much for the Scarlet \"paradise!\"','So much for the Scarlet \"paradise!\"',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29115,'QUIMBY!!!!!!','QUIMBY!!!!!!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29116,'Just got number 41! How\'s that for skill?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29117,'41! Two-thirds of the way there. Better step it up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29118,'Hey! I was just lining up a shot on that one. Kill stealer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29119,'Argh, just now getting number 48. This is getting tough.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29120,'Someone\'s been killing all the game out from under me. Hard-won number 48, here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29121,'Number 48. Startin\' to slow down a bit, now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29122,'Gotta go elsewhere to find some more game. Was hoping to be beyond 48 by now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29123,'Ha, 54! In the home stretch now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29124,'Number 54! No way I\'m gonna let you beat me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29125,'54! Surely an insurmountable lead!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29126,'That was 54! Soon you\'ll be congratulating me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29127,'Ahh... there you are. The master told us you\'d be arriving soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29128,'Please, follow me, $n. There is much for you to see....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29129,'HI!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29130,'Send me to Ebon Hold, horse.','Send me to Ebon Hold, horse.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29131,'Send me to Eastern Plaguelands!','Send me to Eastern Plaguelands!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29132,'','HI!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29133,'What is the \"Crimson Dawn?\"','What is the \"Crimson Dawn?\"',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29134,'Tell me what you know about \"Crimson Dawn\" or the beatings will continue!','Tell me what you know about \"Crimson Dawn\" or the beatings will continue!',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29135,'I\'m through being courteous with your kind, human! What is the \"Crimson Dawn?\"','I\'m through being courteous with your kind, human! What is the \"Crimson Dawn?\"',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29136,'\"Crimson Dawn!\" What is it! Speak!','\"Crimson Dawn!\" What is it! Speak!',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29137,'I can keep this up for a very long time, Scarlet dog! Tell me about the \"Crimson Dawn!\"','I can keep this up for a very long time, Scarlet dog! Tell me about the \"Crimson Dawn!\"',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29138,'I\'ll tear the secrets from your soul! Tell me about the \"Crimson Dawn\" and your life may be spared!','I\'ll tear the secrets from your soul! Tell me about the \"Crimson Dawn\" and your life may be spared!',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29139,'Is your life worth so little? Just tell me what I need to know about \"Crimson Dawn\" and I\'ll end your suffering quickly.','Is your life worth so little? Just tell me what I need to know about \"Crimson Dawn\" and I\'ll end your suffering quickly.',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29140,'I grow tired of these games, human. Tell me of the \"Crimson Dawn\" or I will tear your spine out with my bare hands!','I grow tired of these games, human. Tell me of the \"Crimson Dawn\" or I will tear your spine out with my bare hands!',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29141,'I\'ll tell you nothing, Scourge filth!','I\'ll tell you nothing, Scourge filth!',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29142,'You\'ll have to kill me, monster. I will tell you NOTHING!','You\'ll have to kill me, monster. I will tell you NOTHING!',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29143,'Argh... The pain... The pain is almost as unbearable as the lashings I received in grammar school when I was but a child.','Argh... The pain... The pain is almost as unbearable as the lashings I received in grammar school when I was but a child.',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29144,'You... You\'ll get nothing... And like it...','You... You\'ll get nothing... And like it...',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29145,'Do you think this to be pain? To be suffering? HAH! Destroy this mortal shell so that I may ascend to the heavens!','Do you think this to be pain? To be suffering? HAH! Destroy this mortal shell so that I may ascend to the heavens!',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29146,'You hit like a girl. Honestly. Is that the best you can do?','You hit like a girl. Honestly. Is that the best you can do?',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29147,'The crimson what? Never heard of it...','The crimson what? Never heard of it...',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29148,'The pain is momentary. It pales in comparison to what the High General would do to me...','The pain is momentary. It pales in comparison to what the High General would do to me...',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29149,'I\'ll tell you everything! STOP! PLEASE!','I\'ll tell you everything! STOP! PLEASE!',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29150,'We... We have only been told that the \"Crimson Dawn\" is an awakening. You... You see, the Light speaks to the High General. It is the Light...','We... We have only been told that the \"Crimson Dawn\" is an awakening. You... You see, the Light speaks to the High General. It is the Light...',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29151,'The Light that guides us. This movement was set in motion before you came... We... We do as we are told. It is what must be done.','The Light that guides us. This movement was set in motion before you came... We... We do as we are told. It is what must be done.',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29152,'I know very litte else... The High General chooses who may go and who must stay behind. There\'s nothing else... You must believe me!','I know very litte else... The High General chooses who may go and who must stay behind. There\'s nothing else... You must believe me!',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29153,'NO! PLEASE! There is one more thing that I forgot to mention... A courier comes soon... From Hearthglen. It...','NO! PLEASE! There is one more thing that I forgot to mention... A courier comes soon... From Hearthglen. It...',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29154,'%s dies from the torture.','%s dies from the torture.',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29155,'You know nothing of pain, monster!','You know nothing of pain, monster!',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29156,'HAH! I\'ve survived three separate inquisitions! This is nothing in comparison!','HAH! I\'ve survived three separate inquisitions! This is nothing in comparison!',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29157,'Look out! There\'s a bee loose and it\'s on a stinging rampage!','Look out! There\'s a bee loose and it\'s on a stinging rampage!',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29158,'That one tickled...','That one tickled...',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29159,'I\'m going to send you back to the Lich King in pieces!','I\'m going to send you back to the Lich King in pieces!',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29160,'You\'ll be hanging in the gallows shortly, Scourge fiend!','You\'ll be hanging in the gallows shortly, Scourge fiend!',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29161,'I used to work for Grand Inquisitor Isillien! Your idea of pain is a normal mid-afternoon for me!','I used to work for Grand Inquisitor Isillien! Your idea of pain is a normal mid-afternoon for me!',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29162,'ARGH! You burned my last good tabard!','ARGH! You burned my last good tabard!',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29163,'LIES! The pain you are about to endure will be talked about for years to come!','LIES! The pain you are about to endure will be talked about for years to come!',0,0,0,0,0,0,0,0,1,7444,0,0,26124),
(29164,'Cower, heathens, for a Scarlet Lord has joined the battle!','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29165,'New Avalon shall be purged! All Scourge will be eradicated!','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29166,'Crusaders...$B$B<Rivendare shakes his head.>$B$BI am convinced that they are a unique lot amongst the humans. My theory is that they lack higher brain function, unable to logically assess a situation and calculate an outcome. One has only to make mention of the Light to get them frothing and battle ready - at which point they will rush headlong into any engagement with complete disregard for their own well being.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29167,'','Come over here time traveller, we need to talk!',70,0,0,0,0,0,0,0,1,0,0,0,26124),
(29168,'','We meet again, time traveller!',70,0,0,0,0,0,0,0,1,0,0,0,26124),
(29169,'','Quick, over here!',70,0,0,0,0,0,0,0,1,0,0,0,26124),
(29171,'You should feel honored. You are the first of the master\'s prospects to be shown our operation.','',0,0,0,0,0,0,0,0,1,7381,0,0,26124),
(29172,'Ever since his arrival from Drak\'Tharon, the master has spoken of the time you would be joining him here.','',0,0,0,0,0,0,0,0,1,7379,0,0,26124),
(29173,'The things I show you now must never be spoken of outside Voltarus. The world shall come to know our secret soon enough!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29174,'Here lie our stores of blight crystal, without which our project would be impossible.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29175,'I understand that you are to thank for the bulk of our supply.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29176,'These trolls are among those you exposed on the battlefield. Masterfully done, indeed....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29177,'I\'M FREE, LITTLE DRAKKARI. TIME TO PAY FOR YOUR MANY TRESSPASSES!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29178,'Up here, $n. You weren\'t followed, were you?','',0,0,0,0,0,0,0,0,1,7446,0,0,26124),
(29179,'ENOUGH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29180,'And now, Akali, my master will have your blood and I will take some of your power as well!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29181,'$n! I\'ve been awaiting your return. What be takin\' ya so long, mon?$b$bIt be time to complete da conversion of da Blightbloods.$b$bJoin me and witness the creation of our army!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29182,'I am ready to accompany you, Drakuru.','I am ready to accompany you, Drakuru.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29183,'It is done. Run back to your masters. Run back to Har\'koa. Tell her that I am coming!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29184,'So hungry...','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29185,'Must feed...','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29186,'GIVE ME BRAINS!','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29187,'Smell flesh... close...','',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29188,'I seem to have misplaced your Shredder Control Device... might you have another?','I seem to have misplaced your Shredder Control Device... might you have another?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29189,'Why do you care, Thassarian?','',0,0,0,0,0,0,0,0,1,7449,0,0,26124),
(29190,'His weakness led to his capture.','',0,0,0,0,0,0,0,0,1,7449,0,0,26124),
(29191,'Only the strong should survive. Not to mention...','',0,0,0,0,0,0,0,0,1,7449,0,0,26124),
(29192,'What, Orbaz? That he\'s a blood elf?','',0,0,0,0,0,0,0,0,1,7449,0,0,26124),
(29193,'In life we were hated enemies - this is true...','',0,0,0,0,0,0,0,0,1,7449,0,0,26124),
(29194,'But in death... We are the children of the damned. The orphaned sons and daughters of the Scourge.','',0,0,0,0,0,0,0,0,1,7449,0,0,26124),
(29195,'In death we are brothers.','',0,0,0,0,0,0,0,0,1,7449,0,0,26124),
(29196,'To hell with you, Thassarian.','',0,0,0,0,0,0,0,0,1,7449,0,0,26124),
(29197,'Damn the Crusade! I think my ribs are broken and I might be bleeding internally.','',0,0,0,0,0,0,0,0,1,7451,0,0,26124),
(29198,'What\'re you looking at?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29199,'I\'m just trying to enjoy my drink.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29200,'What do you want?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29201,'I\'ll need to get my runeblade and armor... Just need a little more time.','',0,0,0,0,0,0,0,0,1,7451,0,0,26124),
(29202,'Acolytes, chain them all up! Prepare them for questioning!','',0,0,0,0,0,0,0,0,1,7451,0,0,26124),
(29203,'I\'m still weak, but I think I can get an anti-magic barrier up. Stay inside it or you\'ll be destroyed by their spells.','',0,0,0,0,0,0,0,0,1,7451,0,0,26124),
(29204,'I\'m badly injured, but I\'ll do what I can to help. Try and stay inside of my anti-magic barrier or the acolytes\' magic will tear you apart.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29205,'Maintaining this barrier will require all of my concentration. Kill them all!','',0,0,0,0,0,0,0,0,1,7451,0,0,26124),
(29206,'What you stand round for, you go back work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29207,'There are more coming. Defend yourself! Don\'t fall out of the anti-magic field! They\'ll tear you apart without its protection!','',0,0,0,0,0,0,0,0,1,7451,0,0,26124),
(29208,'I can\'t keep this barrier up much longer... Where is that coward?','',0,0,0,0,0,0,0,0,1,7451,0,0,26124),
(29209,'What can I do for you, $r?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29210,'The High Inquisitor comes! Be ready, death knight! Do not let him draw you out of the protective bounds of my anti-magic field! Kill him and take his head!','',0,0,0,0,0,0,0,0,1,7451,0,0,26124),
(29211,' Okay, okay! Ya didn\'t hafta hit me! ',' Okay, okay! Ya didn\'t hafta hit me! ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29212,'I require water breathing, Garren.','I require water breathing, Garren.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29213,'Heh heh, stupid ogre.  Like I\'m going backta work.','Heh heh, stupid ogre.  Like I\'m going backta work.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29214,'Scourge filth! By the Light be cleansed!','',0,0,0,0,0,0,0,0,1,7451,0,0,26124),
(29215,'The Crusade will purge your kind from this world!','',0,0,0,0,0,0,0,0,1,7451,0,0,26124),
(29216,'It seems that I\'ll need to deal with you myself. The High Inquisitor comes for you, Scourge!','',0,0,0,0,0,0,0,0,1,7451,0,0,26124),
(29217,'There is a faint light emanating from deep within the orb and a blue mist swirls across its surface.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29218,'Your dark Scourge magic won\'t protect you from the Light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29219,'Coward!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29220,'Come out and play.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29221,'LIGHT PURGE YOU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29222,'You have come seeking deliverance? I have come to deliver!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29223,'%s\'s remains fall to the ground.','',0,0,0,0,0,0,0,0,1,7451,0,0,26124),
(29224,'Stand your ground! Use my anti-magic barrier to dampen their spells!','',0,0,0,0,0,0,0,0,1,7451,0,0,26124),
(29225,'Stay in the anti-magic field! Make them come to you!','',0,0,0,0,0,0,0,0,1,7451,0,0,26124),
(29226,'Death grip! Use your powers, death knight! Pull them in!','',0,0,0,0,0,0,0,0,1,7451,0,0,26124),
(29227,'Do not let them wear you down! Focus!','',0,0,0,0,0,0,0,0,1,7451,0,0,26124),
(29228,'I can\'t keep this damned barrier up forever. Kill faster!','',0,0,0,0,0,0,0,0,1,7451,0,0,26124),
(29229,'This is going to be a humbling defeat.','',0,0,0,0,0,0,0,0,1,7451,0,0,26124),
(29230,'%s collapses to the ground.','',0,0,0,0,0,0,0,0,1,7451,0,0,26124),
(29231,'You\'re done for, death knight!','',0,0,0,0,0,0,0,0,1,7451,0,0,26124),
(29232,'Lafoo digs up some bugs from the dirt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29233,'Once more we hear your call, Khufu. We have wisdom for you and $n. You face great peril and must act swiftly or you all and Har\'koa will die.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29234,'The unblemished heart of the guardian must be secured to show defiance and strength. Jealous Zim\'Rhuk keeps those who harbor it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29235,'The gusty essence of deceased Quetz\'lun\'s wardens must be gathered to draw him near. To Har\'koa must both of these rarities be delivered.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29236,'And yet we see only doom in your future. It is your destiny that you do this, $n, but we fear that the prophet is too powerful for you and your friends. Still, you must try.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29237,'','No, not Akali too!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29238,'','Looks over in the direction of the witch doctor and is thoughtful.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29239,'The death of the High Inquisitor of New Avalon will not go unnoticed. You need to get out of here at once! Go, before more of them show up. I\'ll be fine on my own.','',0,0,0,0,0,0,0,0,1,7451,0,0,26124),
(29240,'I\'ll draw their fire, you make your escape behind me.','',0,0,0,0,0,0,0,0,1,7451,0,0,26124),
(29241,'Your High Inquisitor is nothing more than a pile of meat, Crusaders! There are none beyond the grasp of the Scourge!','',0,0,0,0,0,0,0,0,1,7451,0,0,26124),
(29242,'<Koltira groans.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29243,'Koltira, let\'s get out of here!','Koltira, let\'s get out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29244,'','This isn\'t quite what I signed up for, but hey... at least it\'s warm here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29245,'%s has earned the achievement $a!','%s has earned the achievement $a!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29246,'The Scarlet Crusade will serve a new master - in death...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29247,'Still warm, just the way Rejek likes it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29248,'Rejek feel strong! Rejek crush big-tongue skulls between his hands!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29249,'Rejek and $n will teach the enemies of the Frenzyheart to fear us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29250,'What is this? I recognize you from when I killed Akali. You must be this $n that everyone is dreading.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29251,'You don\'t worry me, $g boy : girl;. Just the opposite - I look forward to killing you. Nothing will stand between me and Zim\'Torga now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29252,'Fools! Nothing can stop us now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29253,'How sad that only now do you grasp the truth - I wield the power of a god. You are a mere mortal. You cannot hope to defeat me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29254,'Are you challenging me, $g brother:sister;?','Are you challenging me, $g brother:sister;?',397,0,0,0,0,0,0,0,0,0,0,0,26124),
(29255,'I challenge you, death knight!','I challenge you, death knight!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(29256,'You\'ve meddled in affairs that were none of your business. You are nothing but a foreign invader. Prepare to die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29257,'The prophet begins to cast a ritual of annihilation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29258,'The duel will begin in...','The duel will begin in...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(29259,'3...','3...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(29260,'2...','2...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(29261,'1...','1...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(29262,'You have challenged death itself!','You have challenged death itself!',0,0,0,0,0,0,0,0,1,7540,0,0,26124),
(29263,'I\'m going to tear your heart out, cupcake!','Don\'t make me laugh.',0,0,0,0,0,0,0,0,1,7540,0,0,26124),
(29264,'Here come the tears...','Here come the tears...',0,0,0,0,0,0,0,0,1,7540,0,0,26124),
(29265,'No potions!','No potions!',0,0,0,0,0,0,0,0,1,7540,0,0,26124),
(29266,'You\'re going down!','You\'re going down!',0,0,0,0,0,0,0,0,1,7540,0,0,26124),
(29267,'You don\'t stand a chance, $n.','You don\'t stand a chance, $n.',0,0,0,0,0,0,0,0,1,7540,0,0,26124),
(29268,'The Lich King will see his true champion on this day!','The Lich King will see his true champion on this day!',0,0,0,0,0,0,0,0,1,7540,0,0,26124),
(29269,'','PROPHET!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29270,'Remember this day, $n, for it is the day that you will be thoroughly owned.','Remember this day, $n, for it is the day that you will be thoroughly owned.',0,0,0,0,0,0,0,0,1,7540,0,0,26124),
(29271,'What? HAR\'KOA?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29272,'','YOU KEEP YOUR FILTHY DRAKKARI HANDS OFF OF THEM!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29273,'Very well, kitten. I see no need to delay your inevitable demise. I look forward to dealing with you just as soon as I finish off this fool!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29274,'','I THINK NOT. YOU WILL DROP YOUR IMMUNITY, CEASE YOUR RITUAL NOW AND RELEASE THEM!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29275,'NO! I will not be defeated!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29276,'','Thank you. Once again you have saved us all. I will see you back at Zim\'Torga.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29277,'Well that didn\'t work.','Well that didn\'t work.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29278,'Mental note, don\'t mix the blue one with the green one.','Mental note, don\'t touch the blue one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29279,'Yep, shoulda tried the red one!','Yep, shoulda gone with the red one!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29280,'That certainly wasn\'t the reaction I wanted.','That was not the reaction I was hoping for.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29281,'Study dis place well, mon. Ya gonna be helpin\' me conquer it!','',0,0,0,0,0,0,0,0,1,7392,0,0,26124),
(29282,'%s groans.','%s groans.',0,0,0,0,0,0,0,0,1,7455,0,0,26124),
(29283,'%s whimpers.','%s whimpers.',0,0,0,0,0,0,0,0,1,7455,0,0,26124),
(29284,'%s cries softly.','%s cries softly.',0,0,0,0,0,0,0,0,1,7455,0,0,26124),
(29285,'%s sobs.','%s sobs.',0,0,0,0,0,0,0,0,1,7455,0,0,26124),
(29286,'Come to finish the job, have you?','',0,0,0,0,0,0,0,0,1,7457,0,0,26124),
(29287,'You\'ll look me in the eyes when...','',0,0,0,0,0,0,0,0,1,7457,0,0,26124),
(29288,'$n?','',0,0,0,0,0,0,0,0,1,7457,0,0,26124),
(29289,'$n, I\'d recognize those horns anywhere... What... What have they done to you, $n?','',0,0,0,0,0,0,0,0,1,7457,0,0,26124),
(29290,'You don\'t remember me, do you? Blasted Scourge... They\'ve tried to drain you of everything that made you a righteous force of reckoning. Every last ounce of good... Everything that made you a tauren!','',0,0,0,0,0,0,0,0,1,7457,0,0,26124),
(29291,'Ahh yeah, mon! Dere be great glory ta be had here!','',0,0,0,0,0,0,0,0,1,7392,0,0,26124),
(29292,'Da Lich King be sharin\' his power wit dem who serve him well, mon.','',0,0,0,0,0,0,0,0,1,7392,0,0,26124),
(29293,'Come to me now, $n. I must be speakin\' wit ya.','',0,0,0,0,0,0,0,0,1,7392,0,0,26124),
(29294,'Think, $n. Think back. Try and remember the rolling plains of Mulgore, where you were born. Remember the splendor of life, $g brother:sister;. You were a champion of the tauren once! This isn\'t you.','',0,0,0,0,0,0,0,0,1,7457,0,0,26124),
(29295,'Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!','',0,0,0,0,0,0,0,0,1,7457,0,0,26124),
(29296,'The Gate of the Blue Sapphire is under attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29297,'The Gate of the Green Emerald is under attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29298,'The Gate of the Red Sun is under attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29299,'The Gate of the Purple Amethyst is under attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29300,'The Gate of the Yellow Moon is under attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29301,'There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Mulgore. This world is worth saving.','',0,0,0,0,0,0,0,0,1,7457,0,0,26124),
(29302,'Do it, $n! Put me out of my misery!','',0,0,0,0,0,0,0,0,1,7457,0,0,26124),
(29303,'%s dies from his injuries.','',0,0,0,0,0,0,0,0,1,7457,0,0,26124),
(29304,'The Gate of the Yellow Moon was destroyed!','',0,0,0,0,0,0,0,0,0,0,34120,0,26124),
(29305,'The Gate of the Purple Amethyst was destroyed!','',0,0,0,0,0,0,0,0,0,0,34118,0,26124),
(29306,'The Gate of the Red Sun was destroyed!','',0,0,0,0,0,0,0,0,0,0,34119,0,26124),
(29307,'The Gate of the Green Emerald was destroyed!','',0,0,0,0,0,0,0,0,0,0,34117,0,26124),
(29308,'The Gate of the Blue Sapphire was destroyed!','',0,0,0,0,0,0,0,0,0,0,34116,0,26124),
(29309,'What\'s going on in there? What\'s taking so long, $n?','',0,0,0,0,0,0,0,0,1,7457,0,0,26124),
(29310,'Come to finish the job, have you?','Come to finish the job, have you?',0,0,0,0,0,0,0,0,1,7458,0,0,26124),
(29311,'I\'d like to stand for...','I\'d like to stand for...',0,0,0,0,0,0,0,0,1,7458,0,0,26124),
(29312,'$n?','$n?',0,0,0,0,0,0,0,0,1,7458,0,0,26124),
(29313,'$n, I\'d recognize that face anywhere... What... What have they done to you, $n?','$n, I\'d recognize that face anywhere... What... What have they done to you, $n?',0,0,0,0,0,0,0,0,1,7458,0,0,26124),
(29314,'You don\'t remember me, do you? Blasted Scourge... They\'ve tried to drain you of everything that made you a righteous force of reckoning. Every last ounce of good... Everything that made you a human!','You don\'t remember me, do you? Blasted Scourge... They\'ve tried to drain you of everything that made you a righteous force of reckoning. Every last ounce of good... Everything that made you a human!',0,0,0,0,0,0,0,0,1,7458,0,0,26124),
(29315,'Think, $n. Think back. Try and remember the hills and valleys of Elwynn, where you were born. Remember the splendor of life, $g brother:sister;. You were a champion of the Alliance once! This isn\'t you.','Think, $n. Think back. Try and remember the hills and valleys of Elwynn, where you were born. Remember the splendor of life, $g brother:sister;. You were a champion of the Alliance once! This isn\'t you.',0,0,0,0,0,0,0,0,1,7458,0,0,26124),
(29316,'Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!',0,0,0,0,0,0,0,0,1,7458,0,0,26124),
(29317,'There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Elwynn. This world is worth saving.','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Elwynn. This world is worth saving.',0,0,0,0,0,0,0,0,1,7458,0,0,26124),
(29318,'Do it, $n! Put me out of my misery!','Do it, $n! Put me out of my misery!',0,0,0,0,0,0,0,0,1,7458,0,0,26124),
(29319,'%s dies from her injuries.','%s dies from her injuries.',0,0,0,0,0,0,0,0,1,7458,0,0,26124),
(29320,'What\'s going on in there? What\'s taking so long, $n?','',0,0,0,0,0,0,0,0,1,7458,0,0,26124),
(29321,'','Worgen everywhere!  Don\'t give up yet, I\'m right behind you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29322,'Come to finish the job, have you?','Come to finish the job, have you?',0,0,0,0,0,0,0,0,1,7459,0,0,26124),
(29323,'I\'d like to stand for...','I\'d like to stand for...',0,0,0,0,0,0,0,0,1,7459,0,0,26124),
(29324,'$n?','$n?',0,0,0,0,0,0,0,0,1,7459,0,0,26124),
(29325,'$n, I\'d recognize that face anywhere... What... What have they done to you, $n?','$n, I\'d recognize that face anywhere... What... What have they done to you, $n?',0,0,0,0,0,0,0,0,1,7459,0,0,26124),
(29326,'You don\'t remember me? When you were a child your mother would leave you in my care while she served at the Temple of the Moon. I held you in my arms and fed you honey and sheep\'s milk to calm you until she would return. You were my little angel. Blasted Scourge... What have they done to you, $n?','You don\'t remember me? When you were a child your mother would leave you in my care while she served at the Temple of the Moon. I held you in my arms and fed you honey and sheep\'s milk to calm you until she would return. You were my little angel. Blasted Scourge... What have they done to you, $n?',0,0,0,0,0,0,0,0,1,7459,0,0,26124),
(29327,'','I fear we haven\'t seen the last of Arugal...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29328,'You must remember the splendor of life, $g brother:sister;. You were a champion of the kaldorei once! This isn\'t you!','You must remember the splendor of life, $g brother:sister;. You were a champion of the kaldorei once! This isn\'t you!',0,0,0,0,0,0,0,0,1,7459,0,0,26124),
(29329,'Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!',0,0,0,0,0,0,0,0,1,7459,0,0,26124),
(29330,'There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Teldrassil, our beloved home. This world is worth saving.','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Teldrassil, our beloved home. This world is worth saving.',0,0,0,0,0,0,0,0,1,7459,0,0,26124),
(29331,'Do it, $n! Put me out of my misery!','Do it, $n! Put me out of my misery!',0,0,0,0,0,0,0,0,1,7459,0,0,26124),
(29332,'What\'s going on in there? What\'s taking so long, $n?','',0,0,0,0,0,0,0,0,1,7459,0,0,26124),
(29333,'%s dies from her injuries.','%s dies from her injuries.',0,0,0,0,0,0,0,0,1,7459,0,0,26124),
(29334,'What\'s going on in there? What\'s taking so long, $n?','',0,0,0,0,0,0,0,0,1,7460,0,0,26124),
(29335,'Come to finish the job, have ye?','Come to finish the job, have ye?',0,0,0,0,0,0,0,0,1,7460,0,0,26124),
(29336,'Well this son o\' Ironforge would like...','Well this son o\' Ironforge would like...',0,0,0,0,0,0,0,0,1,7460,0,0,26124),
(29337,'$n?','$n?',0,0,0,0,0,0,0,0,1,7460,0,0,26124),
(29338,'$n, I\'d recognize that face anywhere... What... What have they done to ye, $g lad:lass;?','$n, I\'d recognize that face anywhere... What... What have they done to ye, $g lad:lass;?',0,0,0,0,0,0,0,0,1,7460,0,0,26124),
(29339,'Ye don\'t remember me, do ye? Blasted Scourge... They\'ve tried to drain ye o\' everything that made ye a righteous force o\' reckoning. Every last ounce o\' good... Everything that made ye a $g son:daughter; o\' Ironforge!','Ye don\'t remember me, do ye? Blasted Scourge... They\'ve tried to drain ye o\' everything that made ye a righteous force o\' reckoning. Every last ounce o\' good... Everything that made ye a $g son:daughter; o\' Ironforge!',0,0,0,0,0,0,0,0,1,7460,0,0,26124),
(29340,'Think, $n. Think back. Try and remember the snow capped mountains o\' Dun Morogh! Ye were born there, $g lad:lass;. Remember the splendor o\' life, $n! Ye were a champion o\' the dwarves once! This isn\'t ye!','Think, $n. Think back. Try and remember the snow capped mountains o\' Dun Morogh! Ye were born there, $g lad:lass;. Remember the splendor o\' life, $n! Ye were a champion o\' the dwarves once! This isn\'t ye!',0,0,0,0,0,0,0,0,1,7460,0,0,26124),
(29341,'Listen to me, $n. Ye must fight against the Lich King\'s control. He\'s a monster that wants to see this world - our world - in ruin. Don\'t let him use ye to accomplish his goals. Ye were once a hero and ye can be again. Fight, damn ye! Fight his control!','Listen to me, $n. Ye must fight against the Lich King\'s control. He\'s a monster that wants to see this world - our world - in ruin. Don\'t let him use ye to accomplish his goals. Ye were once a hero and ye can be again. Fight, damn ye! Fight his control!',0,0,0,0,0,0,0,0,1,7460,0,0,26124),
(29342,'There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... For KHAAAAAAAAZZZ MODAAAAAANNNNNN!!!','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... For KHAAAAAAAAZZZ MODAAAAAANNNNNN!!!',0,0,0,0,0,0,0,0,1,7460,0,0,26124),
(29343,'Do it, $n! Put me out of my misery!','Do it, $n! Put me out of my misery!',0,0,0,0,0,0,0,0,1,7460,0,0,26124),
(29344,'%s dies from his injuries.','%s dies from his injuries.',0,0,0,0,0,0,0,0,1,7460,0,0,26124),
(29345,'Get them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29346,'What\'s going on in there? What\'s taking so long, $n?','',0,0,0,0,0,0,0,0,1,7461,0,0,26124),
(29347,'Come to finish the job, have you?','Come to finish the job, have you?',0,0,0,0,0,0,0,0,1,7461,0,0,26124),
(29348,'If you\'d allow me just one...','If you\'d allow me just one...',0,0,0,0,0,0,0,0,1,7461,0,0,26124),
(29349,'$n?','$n?',0,0,0,0,0,0,0,0,1,7461,0,0,26124),
(29350,'$n, I\'d recognize that face anywhere... What... What have they done to you, $n?','$n, I\'d recognize that face anywhere... What... What have they done to you, $n?',0,0,0,0,0,0,0,0,1,7461,0,0,26124),
(29351,'You don\'t remember me, do you? Blasted Scourge... They\'ve tried to drain you of everything that made you a pint-sized force of reckoning. Every last ounce of good... Everything that made you a gnome!','You don\'t remember me, do you? Blasted Scourge... They\'ve tried to drain you of everything that made you a pint-sized force of reckoning. Every last ounce of good... Everything that made you a gnome!',0,0,0,0,0,0,0,0,1,7461,0,0,26124),
(29352,'Think, $n. Think back. Try and remember Gnomeregan before those damned troggs! Remember the feel of an arclight spanner, $g brother:sister;. You were a champion of gnome-kind once! This isn\'t you.','Think, $n. Think back. Try and remember Gnomeregan before those damned troggs! Remember the feel of an arclight spanner, $g brother:sister;. You were a champion of gnome-kind once! This isn\'t you.',0,0,0,0,0,0,0,0,1,7461,0,0,26124),
(29353,'Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!',0,0,0,0,0,0,0,0,1,7461,0,0,26124),
(29354,'There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Gnomeregan! This world is worth saving.','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Gnomeregan! This world is worth saving.',0,0,0,0,0,0,0,0,1,7461,0,0,26124),
(29355,'Do it, $n! Put me out of my misery!','Do it, $n! Put me out of my misery!',0,0,0,0,0,0,0,0,1,7461,0,0,26124),
(29356,'%s dies from his injuries.','%s dies from his injuries.',0,0,0,0,0,0,0,0,1,7461,0,0,26124),
(29357,'Come to finish the job, have you?','',0,0,0,0,0,0,0,0,1,7462,0,0,26124),
(29358,'You\'ll look me in the eyes when...','',0,0,0,0,0,0,0,0,1,7462,0,0,26124),
(29359,'$n?','',0,0,0,0,0,0,0,0,1,7462,0,0,26124),
(29360,'$n, I\'d recognize those face tentacles anywhere... What... What have they done to you, $n?','',0,0,0,0,0,0,0,0,1,7462,0,0,26124),
(29361,'You don\'t remember me, do you? Blasted Scourge... They\'ve tried to drain you of everything that made you a righteous force of reckoning. Every last ounce of good... Everything that made you a draenei!','',0,0,0,0,0,0,0,0,1,7462,0,0,26124),
(29362,'Think, $n. Think back. Try and remember the proud mountains of Argus, where you were born. Remember the splendor of life, $g brother:sister;. You were a champion of the draenei once! This isn\'t you.','',0,0,0,0,0,0,0,0,1,7462,0,0,26124),
(29363,'Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!','',0,0,0,0,0,0,0,0,1,7462,0,0,26124),
(29364,'There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Argus. Don\'t let that happen to this world.','',0,0,0,0,0,0,0,0,1,7462,0,0,26124),
(29365,'Do it, $n! Put me out of my misery!','',0,0,0,0,0,0,0,0,1,7462,0,0,26124),
(29366,'%s dies from his injuries.','',0,0,0,0,0,0,0,0,1,7462,0,0,26124),
(29367,'What\'s going on in there? What\'s taking so long, $n?','',0,0,0,0,0,0,0,0,1,7462,0,0,26124),
(29368,'Come to finish the job, have you?','Come to finish the job, have you?',0,0,0,0,0,0,0,0,1,7463,0,0,26124),
(29369,'You\'ll look me in the eyes when...','You\'ll look me in the eyes when...',0,0,0,0,0,0,0,0,1,7463,0,0,26124),
(29370,'$n, I\'d recognize that face anywhere... What... What have they done to you, $n?','$n, I\'d recognize that face anywhere... What... What have they done to you, $n?',0,0,0,0,0,0,0,0,1,7463,0,0,26124),
(29372,'$n?','$n?',0,0,0,0,0,0,0,0,1,7463,0,0,26124),
(29373,'You don\'t remember me, do you? Blasted Scourge... They\'ve tried to drain you of everything that made you a righteous force of reckoning. Every last ounce of good... Everything that made you a blood elf!','You don\'t remember me, do you? Blasted Scourge... They\'ve tried to drain you of everything that made you a righteous force of reckoning. Every last ounce of good... Everything that made you a blood elf!',0,0,0,0,0,0,0,0,1,7463,0,0,26124),
(29374,'Think, $n. Think back. Try and remember the majestic halls of Silvermoon City, where you were born. Remember the splendor of life, $g brother:sister;. You were a champion of the sin\'dorei once! This isn\'t you.','Think, $n. Think back. Try and remember the majestic halls of Silvermoon City, where you were born. Remember the splendor of life, $g brother:sister;. You were a champion of the sin\'dorei once! This isn\'t you.',0,0,0,0,0,0,0,0,1,7463,0,0,26124),
(29375,'Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!',0,0,0,0,0,0,0,0,1,7463,0,0,26124),
(29376,'There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Silvermoon. This world is worth saving.','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Silvermoon. This world is worth saving.',0,0,0,0,0,0,0,0,1,7463,0,0,26124),
(29377,'Do it, $n! Put me out of my misery!','Do it, $n! Put me out of my misery!',0,0,0,0,0,0,0,0,1,7463,0,0,26124),
(29378,'%s dies from her injuries.','',0,0,0,0,0,0,0,0,1,7463,0,0,26124),
(29379,'What\'s going on in there? What\'s taking so long, $n?','',0,0,0,0,0,0,0,0,1,7463,0,0,26124),
(29380,'What\'s going on in there? What\'s taking so long, $n?','',0,0,0,0,0,0,0,0,1,7464,0,0,26124),
(29381,'What\'s going on in there? What\'s taking so long, $n?','',0,0,0,0,0,0,0,0,1,7465,0,0,26124),
(29382,'What\'s going on in there? What\'s taking so long, $n?','',0,0,0,0,0,0,0,0,1,7466,0,0,26124),
(29383,'Come to finish the job, have you?','Come to finish the job, have you?',0,0,0,0,0,0,0,0,1,7464,0,0,26124),
(29384,'I want to die like an orc...','I want to die like an orc...',0,0,0,0,0,0,0,0,1,7464,0,0,26124),
(29385,'$n?','$n?',0,0,0,0,0,0,0,0,1,7464,0,0,26124),
(29386,'$n, I\'d recognize that face anywhere... What... What have they done to you, $n?','$n, I\'d recognize that face anywhere... What... What have they done to you, $n?',0,0,0,0,0,0,0,0,1,7464,0,0,26124),
(29387,'You don\'t remember me, do you? Blasted Scourge... They\'ve tried to drain you of everything that made you a righteous force of reckoning. Every last ounce of good... Everything that made you an orc!','You don\'t remember me, do you? Blasted Scourge... They\'ve tried to drain you of everything that made you a righteous force of reckoning. Every last ounce of good... Everything that made you an orc!',0,0,0,0,0,0,0,0,1,7464,0,0,26124),
(29388,'Think, $n. Think back. Try and remember Durotar, $g brother:sister;! Remember the sacrifices our heroes made so that we could be free of the blood curse. Harken back to the Valley of Trials, where we were reborn into a world without demonic influence. We found the splendor of life, $n. Together! This isn\'t you. You were a champion of the Horde once!','Think, $n. Think back. Try and remember Durotar, $g brother:sister;! Remember the sacrifices our heroes made so that we could be free of the blood curse. Harken back to the Valley of Trials, where we were reborn into a world without demonic influence. We found the splendor of life, $n. Together! This isn\'t you. You were a champion of the Horde once!',0,0,0,0,0,0,0,0,1,7464,0,0,26124),
(29389,'Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!',0,0,0,0,0,0,0,0,1,7464,0,0,26124),
(29390,'There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... For the Horde! This world is worth saving.','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... For the Horde! This world is worth saving.',0,0,0,0,0,0,0,0,1,7464,0,0,26124),
(29391,'Do it, $n! Put me out of my misery!','Do it, $n! Put me out of my misery!',0,0,0,0,0,0,0,0,1,7464,0,0,26124),
(29392,'%s dies from his injuries.','%s dies from his injuries.',0,0,0,0,0,0,0,0,1,7464,0,0,26124),
(29393,'Come to finish the job, have you?','Come to finish the job, have you?',0,0,0,0,0,0,0,0,1,7466,0,0,26124),
(29394,'Ironic, isn\'t it? To be killed...','Ironic, isn\'t it? To be killed...',0,0,0,0,0,0,0,0,1,7466,0,0,26124),
(29395,'$n?','$n?',0,0,0,0,0,0,0,0,1,7466,0,0,26124),
(29396,'$n, I\'d recognize that decay anywhere... What... What have they done to you, $n?','$n, I\'d recognize that decay anywhere... What... What have they done to you, $n?',0,0,0,0,0,0,0,0,1,7466,0,0,26124),
(29397,'You don\'t remember me? We were humans once - long, long ago - until Lordaeron fell to the Scourge. Your transformation to a Scourge zombie came shortly after my own. Not long after that, our minds were freed by the Dark Lady.','You don\'t remember me? We were humans once - long, long ago - until Lordaeron fell to the Scourge. Your transformation to an Scourge zombie came shortly after my own. Not long after that, our minds were freed by the Dark Lady.',0,0,0,0,0,0,0,0,1,7466,0,0,26124),
(29398,'A pact was made, $g brother:sister;! We vowed vengeance against the Lich King! For what he had done to us! We battled the Scourge as Forsaken, pushing them back into the Plaguelands and freeing Tirisifal! You and I were champions of the Forsaken!','A pact was made, $g brother:sister;! We vowed vengeance against the Lich King! For what he had done to us! We battled the Scourge as Forsaken, pushing them back into the Plaguelands and freeing Tirisifal! You and I were champions of the Forsaken!',0,0,0,0,0,0,0,0,1,7466,0,0,26124),
(29399,'Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals - AGAIN. You were once a hero and you can be again. Fight, damn you! Fight his control!','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals - AGAIN. You were once a hero and you can be again. Fight, damn you! Fight his control!',0,0,0,0,0,0,0,0,1,7466,0,0,26124),
(29400,'There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Tirisfal! This world is worth saving!','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Tirisfal! This world is worth saving!',0,0,0,0,0,0,0,0,1,7466,0,0,26124),
(29401,'Do it, $n! Put me out of my misery!','Do it, $n! Put me out of my misery!',0,0,0,0,0,0,0,0,1,7466,0,0,26124),
(29402,'%s dies from his injuries.','%s dies from his injuries.',0,0,0,0,0,0,0,0,1,7466,0,0,26124),
(29403,'Come ta finish da job, mon?','Come ta finish the job, mon?',0,0,0,0,0,0,0,0,1,7465,0,0,26124),
(29404,'Dis troll gonna stand for da...','Dis troll gonna stand for da...',0,0,0,0,0,0,0,0,1,7465,0,0,26124),
(29405,'$n? Mon?','$n? Mon?',0,0,0,0,0,0,0,0,1,7465,0,0,26124),
(29406,'$n, I\'d recognize dem tusks anywhere... What... What have dey done ta you, mon?','$n, I\'d recognize dem tusks anywhere... What... What have dey done ta you, mon?',0,0,0,0,0,0,0,0,1,7465,0,0,26124),
(29407,'You don\'t remember me, mon? Damn da Scourge! Dey gone ta drain you of everytin\' dat made ya a mojo masta. Every last ounce a good... Everytin\' dat made ya a troll hero, mon!','You don\'t remember me, mon? Damn da Scourge! Dey gone ta drain you of everytin\' dat made ya a mojo masta. Every last ounce a good... Everytin\' dat made ya a troll hero, mon!',0,0,0,0,0,0,0,0,1,7465,0,0,26124),
(29408,'TINK, $n. Tink back, mon! We be Darkspear, mon! Bruddas and sistas! Remember when we fought da Zalazane and done took he head and freed da Echo Isles? MON! TINK! You was a champion of da Darkspear trolls!\n','TINK, $n. Tink back, mon! We be Darkspear, mon! Bruddas and sistas! Remember when we fought da Zalazane and done took he head and freed da Echo Isles? MON! TINK! You was a champion of da Darkspear trolls!',0,0,0,0,0,0,0,0,1,7465,0,0,26124),
(29409,'Listen ta me, $g brudda:sista;. You must fight against da Lich King\'s control. He be a monster dat want ta see dis world - our world - be ruined. Don\'t let he use you ta accomplish he goals. You be a hero once and you be a hero again! Fight it, mon! Fight he control!','Listen ta me, $g brudda:sista;. You must fight against da Lich King\'s control. He be a monster dat want ta see dis world - our world - be ruined. Don\'t let he use you ta accomplish he goals. You be a hero once and you be a hero again! Fight it, mon! Fight he control!',0,0,0,0,0,0,0,0,1,7465,0,0,26124),
(29410,'Der... Der\'s no more time for me. I be done for. Finish me off, $n. Do it or dey\'ll kill us both. $n... Remember Sen\'jin Village, mon! Dis world be worth saving!','Der... Der\'s no more time for me. I be done for. Finish me off, $n. Do it or dey\'ll kill us both. $n... Remember Sen\'jin Village, mon! Dis world be worth saving!',0,0,0,0,0,0,0,0,1,7465,0,0,26124),
(29411,'Do it, $n! Put me out a me misery!','Do it, $n! Put me out a me misery!',0,0,0,0,0,0,0,0,1,7465,0,0,26124),
(29412,'%s dies from his injuries.','%s dies from his injuries.',0,0,0,0,0,0,0,0,1,7465,0,0,26124),
(29413,'Hrm, what a strange tree. I must investigate.','Hrm, what a strange tree. I must investigate.',0,0,0,0,0,0,0,0,1,7469,0,0,26124),
(29414,'One day, Rejek be mighty warrior.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29415,'What\'s this!? This isn\'t a tree at all! Guards! Guards!','What\'s this!? This isn\'t a tree at all! Guards! Guards!',0,0,0,0,0,0,0,0,1,7469,0,0,26124),
(29416,'Stormwind Harbor','Stormwind Harbor',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29417,'Trying to reach Auberdine or Valiance Keep?  You can find Stormwind Harbor if you head through the Canals, between the Cathedral District and the Park.','Trying to reach Auberdine or Valiance Keep?  You can find Stormwind Harbor if you head through the Canals, between the Cathedral District and the Park.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(29418,'Stormwind Harbor is the fastest way to get to Auberdine or Valiance Keep.  You can find it between the Cathedral District and the Park.','Stormwind Harbor is the fastest way to get to Auberdine or Valiance Keep.  You can find it between the Cathedral District and the Park.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(29419,'Greetings, $c. I trust that you bring me good news concerning the Worldwide Invitational event? If you are, then surely that means you were given a secret code to tell me. In return for your code I will give you a gift, Tyrael\'s Hilt.$B$BJust whisper it in my ear when you are ready.','Greetings, $c. I trust that you bring me good news concerning the Worldwide Invitational event? If you are, then surely that means you were given a secret code to tell me. In return for your code I will give you a gift, Tyrael\'s Hilt.$B$BJust whisper it in my ear when you are ready.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29420,'I would like to whisper my secret code to you to receive Tyrael\'s Hilt.','I would like to whisper my secret code to you to receive Tyrael\'s Hilt.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29421,'The courier has arrived!','The courier has arrived!',0,0,0,0,0,0,0,0,1,7470,0,0,26124),
(29422,'$g He\'s:She\'s; finally here! The courier is here!','$g He\'s:She\'s; finally here! The courier is here!',0,0,0,0,0,0,0,0,1,7470,0,0,26124),
(29423,'Let $g him:her; through! Quickly, courier, to the High General!','Let $g him:her; through! Quickly, courier, to the High General!',0,0,0,0,0,0,0,0,1,7470,0,0,26124),
(29424,'','I find you wanting.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29425,'','Die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29426,'','Beg for your life. Plead. It will do you no good!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29427,'','Eternal damnation is your future.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29428,'','You killed me and now I will kill you... over and over!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29429,'','There is no escape. There is only my wrath!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29430,'','My judgment is final.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29431,'','Burn in the fires of my fury!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29432,'As you wish, Drakuru.','As you wish, Drakuru.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29433,'We feel it best to position them here, where they might come to terms with their impending fate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29434,'This is their destiny....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29435,'The blight slowly seeps into their bodies, gradually preparing them for their conversion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29436,'This special preparation grants them unique powers far greater than they would otherwise know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29437,'Soon, the master will grant them the dark gift, making them fit to serve the Lich King for eternity!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29438,'Stay for as long as you like, $n. Glory in the fruits of your labor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29439,'Your service has been invaluable in fulfilling the master\'s plan. May you forever grow in power....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29440,'Farewell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29441,'Behold, mon! We be creatin\' da greatest Scourge army ever seen!','',0,0,0,0,0,0,0,0,1,7447,0,0,26124),
(29442,'These be da first of many! We shall sweep across Zul\'Drak like da wind....','',0,0,0,0,0,0,0,0,1,7447,0,0,26124),
(29443,'Make haste, $n. Use the portal!','',0,0,0,0,0,0,0,0,1,7473,0,0,26124),
(29444,'We are the chosen ones, $n. Death knights of the Scourge, sent to sow the seeds of the master\'s destruction.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29445,'I missed the gate to Acherus, Orbaz. Could you please open another?','I missed the gate to Acherus, Orbaz. Could you please open another?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29446,'%s motions toward the icy water below.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29447,'','These monsters killed my father and kidnapped my sister.  They\'re going to pay for this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29448,'Round 2 of the Battle for the Strand of the Ancients begins in 1 minute.','',0,0,0,0,0,0,0,0,0,0,34104,0,26124),
(29449,'Round 2 begins in 30 seconds.  Prepare yourselves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29450,'Let the battle for the Strand of the Ancients begin!','',0,0,0,0,0,0,0,0,0,0,34105,0,26124),
(29451,'Abomination Guts!','Abomination Guts!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29452,'Ghoul Drool!','Ghoul Drool!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29453,'Blight Crystal!','Blight Crystal!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29454,'Revel in their suffering, death knights! Let it embolden your spirits!','',0,0,0,0,0,0,0,0,1,7477,0,0,26124),
(29455,'Concentrate your attacks on the weak!','',0,0,0,0,0,0,0,0,1,7477,0,0,26124),
(29456,'Hold the line!','',0,0,0,0,0,0,0,0,1,7477,0,0,26124),
(29457,'Lambs to the slaughter...','',0,0,0,0,0,0,0,0,1,7477,0,0,26124),
(29458,'The Scourge will consume you!','',0,0,0,0,0,0,0,0,1,7477,0,0,26124),
(29459,'Why fight it? Give in, maggot!','',0,0,0,0,0,0,0,0,1,7477,0,0,26124),
(29460,'Who wants to see Rejek\'s new helmet?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29461,'I wanna see!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29462,'Show me too!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29463,'Ok, Rejek show!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29464,'What you think?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29465,'Metalhead ate Rejek! Run!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29466,'Rejek like! If helmet scares pups, Rejek can\'t wait to see what it does to big-tongue cowards!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29467,'Suffer, insects!','',0,0,0,0,0,0,0,0,1,7477,0,0,26124),
(29468,'I extend my gratitude for your aid in this matter, $n, although I also admit mild regret that you will not volunteer for our experiments...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29469,'Master Putress, a bat rider approaches!','Master Putress, a bat rider approaches!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29470,'He must have news from the field.','He must have news from the field.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29471,'Feel yourself change!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29472,'There\'s no time left! All remaining forces, attack the invaders!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29473,'The gate has been breached! Quickly, divert forces to deal with these invaders!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29474,'','Greetings traveler.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29475,'I wish to travel to Light\'s Breach.','I wish to travel to Light\'s Breach.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29476,'','Thank you for your aid in this desperate time, $n.  May the Light grant you speed and strength in the face of darkness.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29477,'','You, honored paladin.  Please come here..',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29478,'Yes, Bishop.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29479,'','Spread the word that another artifact  will soon be brought to our defenders.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29480,'','And $gbrother:sister;, be wary of scourge ambushes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29481,'Yes, lord.  I will, lord.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29482,'','Welcome to my kitchen! We prepare some of the finest food in Dalaran here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29483,'I\'m here for cooking training.','I\'m here for cooking training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29484,'Good day, friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29485,'I was told you could get me to Light\'s Breach....','I was told you could get me to Light\'s Breach....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29486,'Hope you take it to big-tongues good. It about time they go away.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29487,'Great battle still going on at Sparktouched Haven.$B$BMaybe you find time to help sometime?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29488,'Greetings, $c!  Stormwind Harbor is quite a sight to behold.  It\'s even better seen from the air.  How would you like a bird\'s eye view of the harbor?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(29489,'I\'d like to take a flight around Stormwind Harbor.','I\'d like to take a flight around Stormwind Harbor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29490,'','I do not believe you possess the mental acuity to grasp the nature of portal magic.$B$BHowever, you can use the crystal behind me to teleport to the ruins below Dalaran in Crystalsong Forest.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(29491,'','As a mage, you are one of a select group that can conjure a portal to transport you back to this very place.  I can teach you if you are ready.$B$BAnd remember that you can always use the crystal behind me to teleport down to the ruins beneath Dalaran in Crystalsong Forest.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29492,'You have time?  Soo-nee teach you good song!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29493,'Greetings, $c.','Greetings, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29494,'I am ready to be teleported to Dalaran.','I am ready to be teleported to Dalaran.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29495,'Welcome, friend, to the barbershop! Come for a cut? A coloring? Something else, perhaps?$B$BWe can groom facial hair, perform piercings, ink night elf tattoos, and even reshape draenei horns and tendrils!$B$BHave a seat and we\'ll get right to work. You\'re only a few coins away from a new, more attractive you...','Welcome, friend, to the barbershop! Come for a cut? A coloring? Something else, perhaps?$B$BWe can groom facial hair, perform piercings, ink night elf tattoos, and even reshape draenei horns and tendrils!$B$BHave a seat and we\'ll get right to work. You\'re only a few coins away from a new, more attractive you...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29498,'Welcome, friend, to the barbershop! Come for a cut? A coloring? Something else, perhaps?$B$BWe can groom facial hair, perform piercings, reshape tusks and horns, and even modify undead features!$B$BHave a seat and we\'ll get right to work. You\'re only a few coins away from a new, more attractive you...','Welcome, friend, to the barbershop! Come for a cut? A coloring? Something else, perhaps?$B$BWe can groom facial hair, perform piercings, reshape tusks and horns, and even modify undead features!$B$BHave a seat and we\'ll get right to work. You\'re only a few coins away from a new, more attractive you...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29499,'Grab a pint!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29500,'I was sent to get some of your famous hard ale. Have any to spare?','I was sent to get some of your famous hard ale. Have any to spare?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29501,'Not sure who told you I had some ale left, but keep it quiet will ya? There ain\'t no way I have enough for the whole camp.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29502,'Ravage the living, minions!','',0,0,0,0,0,0,0,0,1,7477,0,0,26124),
(29503,'This is the end!','',0,0,0,0,0,0,0,0,1,7477,0,0,26124),
(29504,'The sacking of the Scarlet Enclave will be a lesson for history!','',0,0,0,0,0,0,0,0,1,7477,0,0,26124),
(29505,'There is nowhere to run...','',0,0,0,0,0,0,0,0,1,7477,0,0,26124),
(29506,'Let the destruction of this place serve as a lesson to all those who would dare oppose the Scourge!','',0,0,0,0,0,0,0,0,1,7477,0,0,26124),
(29507,'You thought to wipe the undead from these lands? Taste the true might of the Scourge, and despair!','',0,0,0,0,0,0,0,0,1,7477,0,0,26124),
(29508,'Leave no survivors!','',0,0,0,0,0,0,0,0,1,7477,0,0,26124),
(29509,'Soon you will belong to the Scourge.','',0,0,0,0,0,0,0,0,1,7477,0,0,26124),
(29510,'Where is your Light now, Crusaders?','',0,0,0,0,0,0,0,0,1,7477,0,0,26124),
(29511,'Bow before your king!','',0,0,0,0,0,0,0,0,1,7477,0,0,26124),
(29512,'The Light has abandoned you!','',0,0,0,0,0,0,0,0,1,7477,0,0,26124),
(29513,'There is no Light. Only darkness!','',0,0,0,0,0,0,0,0,1,7477,0,0,26124),
(29514,'Come to me, Crusaders. I will remake you!','',0,0,0,0,0,0,0,0,1,7477,0,0,26124),
(29515,'Cower before my terrible creations!','',0,0,0,0,0,0,0,0,1,7477,0,0,26124),
(29516,'Feast, my children! Feast upon the flesh of the living!','',0,0,0,0,0,0,0,0,1,7477,0,0,26124),
(29517,'Lay down your arms and surrender your souls!','',0,0,0,0,0,0,0,0,1,7477,0,0,26124),
(29518,'$3486W Centrifuge Constructs remain.  We must find and destroy them to disable Varos Cloudstrider\'s protective shield.  The constructs should be about halfway up The Oculus, on the Band of Acceleration.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29519,'One Centrifuge Construct remains.  We must find and destroy it to disable Varos Cloudstrider\'s protective shield.  The construct should be about halfway up The Oculus, on the Band of Acceleration.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29520,'The shield is down; Varos is vulnerable!  Defeating him should disperse the Azure Ring Guardians and allow us access to the upper bands.  Varos is on a floating platform about halfway up The Oculus, on the Band of Acceleration.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29521,'Mage-Lord Urom is our next target.  He should be hiding on one of the floating platforms on the Band of Transmutation, near the top of The Oculus.  Be warned, Urom is a powerful conjurer; he may not be alone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29522,'Ley-Guardian Eregos is all that now stands between us and control of The Oculus.  He\'s flying above the Band of Alignment, at the very top of The Oculus.  Eregos is incredibly powerful; stay on my back when we engage him and leave the fighting to me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29523,'We\'ve wrested control of The Oculus from the forces of Malygos.  You\'re not getting any lighter, little one.  My wings itch for the open sky.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29524,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29525,'I wish to travel to Light\'s Breach.','I wish to travel to Light\'s Breach.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29526,'You may serve me yet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29527,'By all means, don\'t assess the situation, you halfwit! Just jump into the fray!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29528,'Skarvald, you incompetent slug! Return and make yourself useful!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29529,'See... you... soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29530,'There\'s no... greater... glory.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29531,'Dalronn! See if you can muster the nerve to join my attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29532,'Jarggn olkt!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29533,'Pfagh! What sort of necromancer lets death stop him? I knew you were worthless!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29534,'Not... over... yet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29535,'A warrior\'s death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29536,'Varos Cloudstrider and his ring guardians protect the second ring.  Your drakes are more than a match for the ring guardians, but Varos stands behind an impenetrable shield created from the energy of the Oculus itself.  Ten centrifuge constructs power the shield from the ring and platforms above.  Destroy them and Varos will be vulnerable.','Varos Cloudstrider and his ring guardians protect the second ring.  Your drakes are more than a match for the ring guardians, but Varos stands behind an impenetrable shield created from the energy of the Oculus itself.  Ten centrifuge constructs power the shield from the ring and platforms above.  Destroy them and Varos will be vulnerable.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29537,'The trickster Mage-Lord Urom protects the third ring.  He will appear alone and defenseless, but do not be fooled by appearances!  Urom is a powerful conjurer who commands a menagerie of Phantasmal creatures.  Seek him out above.','The trickster Mage-Lord Urom protects the third ring.  He will appear alone and defenseless, but do not be fooled by appearances!  Urom is a powerful conjurer who commands a menagerie of Phantasmal creatures.  Seek him out above.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29538,'Your greatest challenge lies ahead.  Ley-Guardian Eregos is a Blue dragon of immense power. You will find him flying above the uppermost ring.','Your greatest challenge lies ahead.  Ley-Guardian Eregos is a Blue dragon of immense power. You will find him flying above the uppermost ring.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29539,'What should we do next?','What should we do next?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29540,'The zeppelin to Vengeance Landing has just arrived! All aboard for Howling Fjord!','The zeppelin to Vengeance Landing has just arrived! All aboard for Howling Fjord!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29541,'The Halls of Stone, a level 77-79 dungeon within Storm Peaks, is now available for testing. Please be in your full group before teleporting to the dungeon. Meeting Stones are not available for this dungeon yet.\n\nTo leave the Halls of Stone, simply exit through the normal exit inside the dungeon and you will be returned here. If you die and release, you should teleport back from this NPC.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29542,'I\'m in my group and ready to teleport to the Halls of Stone!','I\'m in my group and ready to teleport to the Halls of Stone!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29543,'Take me back to the Halls of Stone!','Take me back to the Halls of Stone!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29544,'I... I do not know.','',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(29545,'The zeppelin to Undercity has just arrived! All aboard for Tirisfal Glades!','The zeppelin to Undercity has just arrived! All aboard for Tirisfal Glades!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29546,'','Say, Modoru. Where did you get those... ah... \"wonderful\" robes of yours, hmmm?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(29547,'','Oh. Oh... I see. How nice!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(29548,'','%s bites back a laugh.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29549,'The zeppelin to Warsong Hold has just arrived! All aboard for Borean Tundra!','The zeppelin to Warsong Hold has just arrived! All aboard for Borean Tundra!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29550,'%s beams, unaware that she is teasing him, answering in his thickly-accented Common.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29551,'The zeppelin to Orgrimmar has just arrived! All aboard for Durotar!','The zeppelin to Orgrimmar has just arrived! All aboard for Durotar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29552,'Well! You see, was gift from Grandmother Oluba. She hand-weave from finest silk on Draenor! Am quite proud of, yes.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(29553,'%s snickers, nuzzling into Sentinel Sweetspring\'s ankles.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29554,'%s purrs up at Sentinel Sweetspring.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29555,'','%s grins at Sentinel Amberline across the camp, waggling her long eyebrows suggestively.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29556,'Crush....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29557,'','%s huffs with annoyance, glaring briefly at Sentinel Sweetspring before turning away with her nose in the air.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29558,'Ha.... ha... hah....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29559,'Break.... you....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29560,'Uuuuhhhhhhhhhh......','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29561,'Warning: life form pattern not recognized. Archival processing terminated.  Continued interference will result in targeted response.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29562,'','What are you doing all the way back here? You need to get back to Stratholme immediately!$B$BShall I teleport you to Stratholme?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29563,'','You shouldn\'t have come... now you will die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29564,'','Why must it be this way?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29565,'Yes, please!','Yes, please!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29566,'','You had it coming!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29567,'','My burden grows heavier...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29568,'','This is your fault!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29569,'','Target destroyed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29570,'','So much lost time... that you\'ll never get back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29572,'','Reevaluating threat index.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29573,'Life form purged.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29574,'','I hope you all rot! I never... wanted... this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29575,'','Security breach in progress. Analysis of historical archives transferred to lower-priority queue. Countermeasures engaged.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29576,'','Threat index threshold exceeded.  Celestial archive aborted. Security level heightened.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29577,'Critical threat index. Void analysis diverted. Initiating sanitization protocol.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29578,'','Go find those hidden plagued grain crates and use your Arcane Disruptor on them!$B$BArthas will then have the evidence he needs to begin the culling of Stratholme.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29579,'Alert: security fail-safes deactivated. Beginning memory purge and... ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29580,'System online. Life form pattern recognized.  Welcome, Branbronzan.  Query?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29581,'','What are you doing here?$B$BArthas is at the entrance to Stratholme right now and you should be with him! Go!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29582,'Soft, vulnerable shells. Brief fragile lives. You cannot escape the curse of flesh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29583,'Folvynn buul hrom onn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29584,'Flesh is no match for iron!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29585,'Armies of iron will smother the world!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29586,'Loken will not rest... until the forge is retaken! You change... nothing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29587,'My master has a message for you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29588,'%s calls for assistance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29589,'It is this: Welcome.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29590,'Welcome to a cold death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29591,'Darkness waits.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29592,'I join... the night.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29593,'','You know what they say about curiosity....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29594,'','I\'ll give you more than you can handle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29595,'','There\'s plenty of me to go around.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29596,'','Now to finish the job!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29597,'','Death becomes you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29598,'','Damn the... luck.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29599,'Chaos beckons.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29600,'%s roars in pain as its spirit parts bodies with its host.','%s roars in pain as its spirit parts bodies with its host.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29601,'Reality... unwoven.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29602,'Indestructible.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29603,'Expiration is necessary.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29604,'Of course.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29605,'Noo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29606,'Tharon\'ja sees all! The work of mortals shall not end the eternal dynasty!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29607,'Kill!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29608,'Aaggh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29609,'Back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29610,'Bleed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29611,'As Tharon\'ja predicted!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29612,'As it was written!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29613,'Your flesh serves Tharon\'ja now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29614,'Tharon\'ja has a use for your mortal shell!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29615,'No! A taste... all too brief!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29616,'Agghh!! Tharon\'ja will have more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29617,'Im... impossible! Tharon\'ja is eternal! Tharon\'ja... is....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29618,'','Stay. Enjoy your final moments.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29619,'','Finish it! Finish it! Kill me, or I swear by the Dragonqueen you\'ll never see daylight again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29620,'','Now we\'ve come to the truth!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29621,'','Dragonqueen... Life-Binder... preserve... me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29622,'What is this? Mok-thorin ka! Kill them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29623,'Our task is not yet done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29624,'Gaagh...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29625,'How do I train my pet?','How do I train my pet?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29626,'Just like hunters, pets can choose specializations. Ferocious pets, like cats, can dish out damage but can\'t take it as well. Tenacious pets, like turtles, are more defensive and can occupy an enemy\'s attention while you stay at range. Cunning pets, like spiders, have a mix of offensive and defensive abilities and are particularly useful in Battlegrounds and Arenas.$b$bEach pet comes with a default specialization, but you can change it if you like.','Just like hunters, pets can choose specializations. Ferocious pets, like cats, can dish out damage but can\'t take it as well. Tenacious pets, like turtles, are more defensive and can occupy an enemy\'s attention while you stay at range. Cunning pets, like spiders, have a mix of offensive and defensive abilities and are particularly useful in Battlegrounds and Arenas.$b$bEach pet comes with a default specialization, but you can change it if you like.',1,273,0,0,0,0,0,0,1,0,0,0,26124),
(29627,'What? Where in the-- don\'t just stand around lads; kill somebody!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29628,'Now we\'re gettin\' someplace!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29629,'Is that all you\'ve...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29630,'I wish to unlearn my talents.','I wish to unlearn my talents.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29631,'Are you certain?$B$BThere is no turning back once I wipe the knowledge of the talents you have learned from your mind.','Are you certain?$B$BThere is no turning back once I wipe the knowledge of the talents you have learned from your mind.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(29632,'I am certain. Please proceed.','I am certain. Please proceed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29633,'Very well. It is done.','Very well. It is done.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29634,'We need more flesh!','',0,0,0,0,0,0,0,0,1,7510,0,0,26124),
(29635,'The Highlord has requested more abominations!','',0,0,0,0,0,0,0,0,1,7510,0,0,26124),
(29636,'Quicken your pace, maggots!','',0,0,0,0,0,0,0,0,1,7510,0,0,26124),
(29637,'The Argent Dawn dogs will be consumed by the shadow of the Scourge!','',0,0,0,0,0,0,0,0,1,7510,0,0,26124),
(29638,'Rise up, minions! To the Scourge front!','',0,0,0,0,0,0,0,0,1,7510,0,0,26124),
(29639,'Double your efforts! The final assault draws near!','',0,0,0,0,0,0,0,0,1,7510,0,0,26124),
(29640,'Yes! YES! More souls for the master!','',0,0,0,0,0,0,0,0,1,7510,0,0,26124),
(29641,'Wi... Will it hurt?','Wi... Will it hurt?',0,0,0,0,0,0,0,0,1,7510,0,0,26124),
(29642,'It tingles...','It tingles...',0,0,0,0,0,0,0,0,1,7510,0,0,26124),
(29643,'Is it too late to change my mind? How about you just kill me instead?','Is it too late to change my mind? How about you just kill me instead?',0,0,0,0,0,0,0,0,1,7510,0,0,26124),
(29644,'You\'re a monster!','You\'re a monster!',0,0,0,0,0,0,0,0,1,7510,0,0,26124),
(29645,'Please! Spare me! I...','Please! Spare me! I...',0,0,0,0,0,0,0,0,1,7510,0,0,26124),
(29646,'The horror! THE HORROR!!','The horror! THE HORROR!!',0,0,0,0,0,0,0,0,1,7510,0,0,26124),
(29647,'Oh yes. Immensely. The pain will probably render you unconscious - hence the vat of slime you\'re floating in!','',0,0,0,0,0,0,0,0,1,7510,0,0,26124),
(29648,'That\'s how you know it\'s working.','',0,0,0,0,0,0,0,0,1,7510,0,0,26124),
(29649,'I AM going to kill you. What\'s the rush?','',0,0,0,0,0,0,0,0,1,7510,0,0,26124),
(29650,'Flattery will get you nowhere.','',0,0,0,0,0,0,0,0,1,7510,0,0,26124),
(29651,'Don\'t be ridiculous. Where would you even go if I did spare you? We just finished up eradicating your civilization. Remember?','',0,0,0,0,0,0,0,0,1,7510,0,0,26124),
(29652,'Stop!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29653,'That enough!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29654,'Back off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29655,'Fight over! You listen now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29656,'Like music to my ears. Scream for me, human.','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29657,'Time for listening. You listen to son of Zart, best scrapper Frenzyheart ever see!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29658,'Rakat, you stupid. You lose your nose if you keep sticking it where claws go. You lose nose, you can\'t smell. You can\'t smell, you hunt bad, you useless.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29659,'Ajark, you standing like rock. Rakat move more. You move or you get hurt by wasp sting or bristlepine tusk, you see. Move more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29660,'Faster. Fight faster! Both of you slow like bigtongue. Maybe I dump you in water, make you slimy like bigtongues too, make them take you in.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29661,'Guard bellies or bellies get opened up! You hitting higher body, not watching lower.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29662,'Okay. Fight again. No more stupid.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29663,'GO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29664,'Step forth disciple. Show me what you have learned.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29665,'Its spells would be less threatening if its incantations were slowed by your icy touch...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29666,'Do not let it consider its next spell so freely, disciple... freeze its mind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29667,'It is time for your learning to be put to the test. Step forth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29668,'Do not let the ice in your blood slow your step. Prove your prowess, disciple.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29669,'You have stood and listened long enough. Step forth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29670,'Prove that you understand my teachings, disciple.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29671,'It is time for your challenge disciple. Use my teachings well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29672,'','I will vanquish your soul!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29673,'You are not overwhelmed just yet disciple... let the hungering cold of death halt this onslaught.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29674,'Frozen solid, ripe for the slaughter. Let loose a howling blast and shatter them into pieces, disciple.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29675,'','You were a fool to challenge the power of the Lich King!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29676,'','Your will is done, my king!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29677,'','Another soul for my master!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29678,'','Your death approaches....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29679,'','Go now to my master!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29680,'','Your end is inevitable.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29681,'','Yor-guul mak!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29682,'','Any last words?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29683,'','Nooo! I did not come this far... to...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29684,'','My liege! I have done as you asked, and now beseech you for your blessing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29685,'','I\'ll never forget what you did for Thassarian.  I will always be in your debt.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29686,'','The sensation is... beyond my imagining. I am yours to command, my king.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29687,'','I will be happy to slaughter them in your name! Come, enemies of the Scourge! I will show you the might of the Lich King!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29688,'Your sacrifice is a testament to your obedience.  Indeed you are worthy of this charge. Arise, and forever be known as Svala Sorrowgrave!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29689,'Your first test awaits you. Destroy our uninvited guests.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29690,'Here is where I sacrificed everything to free my father. Now I come to destroy it...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29691,'I am ready, Highlord. Let the siege of Light\'s Hope begin!','I am ready, Highlord. Let the siege of Light\'s Hope begin!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29692,'My father once told me that life is meaningless... That it is in death that we are truly tested. I sense that the siege of Light\'s Hope will give meaning to his words. We strike soon, $n. Stand ready.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(29693,'Death knights of Acherus, hear your master\'s call! The siege of Light\'s Hope is underway! We rally at the mill!\n','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29694,'Soldiers of the Scourge, stand ready! Prepare to unleash your fury upon the Argent Dawn!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29695,'','Let us see what atrocity we can pull from the shadow realm this time...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29696,'The sky weeps at the glorious devastation of these lands! Soon, Azeroth\'s futile tears will rain down upon us!','The sky weeps at the glorious devastation of these lands! Soon, Azeroth\'s futile tears will rain down upon us!',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29697,'Death knights of Acherus, the death march begins!','Death knights of Acherus, the death march begins!',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29698,'EVENT STEP 005 YELL! RAWR!','EVENT STEP 005 YELL! RAWR!',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29699,'Soldiers of the Scourge, death knights of Acherus, minions of the darkness: hear the call of the Highlord!','Soldiers of the Scourge, death knights of Acherus, minions of the darkness: hear the call of the Highlord!',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29700,'RISE!','RISE!',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29701,'','A druid! How curious... I wonder how it got in there.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29702,'','Ghouls? We have quite enough of those already.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29703,'Here is where I sacrificied everything to free my father. Now I come to destroy it...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29704,'','Wha... where am I?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29705,'Mr. Bigglesworth. The last living creature in Naxxramas, this cat is said to be the last thread connecting Kel\'thuzad to his mortal life. It is said that any who dare to harm a hair on his head doom themselves to... wait a second, what is he doing on there?!','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(29706,'%s pounds on the display a few times.','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(29707,'Well, nevermind. I\'m sure no one would be foolish enough to lay a hand on Kel\'thuzard precious pet.','',0,0,0,0,0,0,0,7,1,7259,0,0,26124),
(29708,'Quick!  Use the ashes on Ursoc\'s corpse.  We must purge its corruption!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29709,'Shur\'nab... shur\'nab... Yogg-Saron!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29710,'Scourge filth! DIE!','Scourge filth! DIE!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29711,'The Crusade will be victorious!','The Crusade will be victorious!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29712,'I will present your head to Abbendis myself!','I will present your head to Abbendis myself!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29713,'You\'re not welcome in these lands, monster!','You\'re not welcome in these lands, monster!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29714,'Let the purging begin!','Let the purging begin!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29715,'By the Light be cleansed!','By the Light be cleansed!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29716,'Scourge filth! DIE!','Scourge filth! DIE!',0,0,0,0,0,0,0,0,1,7474,0,0,26124),
(29717,'The Crusade will be victorious!','The Crusade will be victorious!',0,0,0,0,0,0,0,0,1,7474,0,0,26124),
(29718,'I will present your head to Abbendis myself!','I will present your head to Abbendis myself!',0,0,0,0,0,0,0,0,1,7474,0,0,26124),
(29719,'You\'re not welcome in these lands, monster!','You\'re not welcome in these lands, monster!',0,0,0,0,0,0,0,0,1,7474,0,0,26124),
(29720,'Let the purging begin!','Let the purging begin!',0,0,0,0,0,0,0,0,1,7474,0,0,26124),
(29721,'By the Light be cleansed!','By the Light be cleansed!',0,0,0,0,0,0,0,0,1,7436,0,0,26124),
(29722,'The skies turn red with the blood of the fallen! The Lich King watches over us, minions! Leave only ashes and misery in your destructive wake!','The skies turn red with the blood of the fallen! The Lich King watches over us, minions! Leave only ashes and misery in your destructive wake!',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29723,'Stand fast, brothers and sisters! The Light will prevail!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29724,'Scourge armies approach!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29725,'%s falls unconscious.','%s falls unconscious.',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29726,'Rise, minions! Destroy them!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29727,'Kneel before the Highlord!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29728,'You stand no chance!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29729,'The Scourge will destroy this place!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29730,'Your life is forfeit!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29731,'Life is meaningless without suffering!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29732,'How much longer will your forces hold out?','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29733,'The Argent Dawn is finished!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29734,'Spare no one!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29735,'What is this?! My... I cannot strike...','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29736,'OBEY ME, BLADE!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29737,'You will do as I command! I am in control here!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29738,'I... I cannot... The blade fights me...','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29739,'What is happening to me?','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29740,'Power... wanes...','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29741,'Ashbringer defies me...','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29742,'Minions, come to my aid!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29743,'You cannot win, Darion!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29744,'Have you learned nothing, boy? You have become all that your father fought against! Like that coward, Arthas, you allowed yourself to be consumed by the darkness, the hate... feeding upon the misery of those you tortured and killed!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29745,'Your master knows what lies beneath the chapel. That is why he dares not show his face! He\'s sent you and your death knights to meet their doom, Darion.','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29746,'What you are feeling right now is the anguish of a thousand lost souls! Souls that you and your master brought here! The Light will tear you apart, Darion!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29747,'My powers are fading, Highlord!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29749,'What is happening? What is this?','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29750,'We are being consumed by the Light!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29751,'It is decimating our armies!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29752,'What should we do, Highlord?','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29753,'Can\'t... focus...','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29754,'It is overwhelming... cannot fight...','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29755,'D... Dying...','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29756,'Bring them before the chapel!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29757,'Fool! You\'ve led us into a trap! I won\'t die here, Mograine!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29758,'%s flees.','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29759,'%s kneels in defeat before Tirion Fordring.','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29760,'Stand down, death knights. We have lost. The Light... this place... no hope...','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29761,'Save your breath, old man. It might be the last you ever draw.','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29762,'My son! My dear, beautiful boy!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29763,'Ashbringer!','Ashbringer!',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29764,'I... It can\'t be...','I... It can\'t be...',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29765,'Bow your heads!','Bow your heads!',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29766,'Bow your heads!','Bow your heads!',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29767,'Father!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29768,'Argh... what... is...','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29769,'Father, you have returned!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29770,'You have been gone a long time, Father. I thought...','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29771,'%s hugs his father.','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29772,'%s cries.','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29773,'Nothing could have kept me away from here, Darion. Not from my home and family.','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29774,'Father, I wish to join you in the war against the undead. I want to fight! I can sit idle no longer!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29775,'Darion Mograine, you are barely of age to hold a sword, let alone battle the undead hordes of Lordaeron! I could not bear losing you. Even the thought...\n','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29776,'If I die, Father, I would rather it be on my feet, standing in defiance against the undead legions! If I die, let me die with you!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29777,'My son, there will come a day when you will command the Ashbringer and, with it, mete out justice across this land. I have no doubt that when that day finally comes, you will bring pride to our people and that Lordaeron will be a better place because of you. But, my son, that day is not today.\n','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29778,'Do not forget...','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29779,'Touching...','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29780,'He is mine now...','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29781,'You... betrayed me. You betrayed us all, monster! Face the might of Mograine!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29782,'Pathetic...','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29783,'You\'re a damned monster, Arthas!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29784,'You were right, Fordring. I did send them in to die. Their lives are meaningless, but yours...','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29785,'How simple it was to draw the great Tirion Fordring out of hiding. You\'ve left yourself exposed, paladin. Nothing will save you.','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29786,'%s gasps for air.','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29787,'ATTACK!!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29788,'APOCALYPSE!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29789,'Remember... always...\n','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29790,'','Dearest shadow realm, grace us with the presence of one of your many denizens.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29791,'','Let us coldly greet another inhabitant of the shadow realm...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29792,'','What beast lies in store for us...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29793,'','There are many lessons left to learn, let us move onto our next subject...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29794,'','Moving on...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29795,'','Skeletons. Simple play things, but there are lessons to be learned even here.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29796,'','Skeletal mages. A perfect opportunity to display the utility of some of our powers.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29797,'','Strange, I did not think there were any of those left in the shadow realm. Beware disciples, this one is a bit dangerous.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29798,'','Disciples... you will find with time that many healing spells fall victim to the degeneration of our strikes.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29799,'','Some healers lack the knowledge to counter the diseases that we master.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29800,'','This lack of knowledge is just one more weakness among many. There is little hope against the power of death itself.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29801,'Tirion!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29802,'%s collapses.','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29803,'ARTHAS!!!!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29804,'What is this?','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29805,'%s cackles maniacally.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29806,'The quality of this workmanship is pathetic. Not even fit for a Ghoul to wield.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29807,'You call this a weapon? Keep this up, knave and I\'ll see that you\'re brought back as one of them. Maybe then you will learn how to put your back into it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29808,'If this is the qualilty one can expect in a weapon of the Argent Dawn, then it is only a matter of time before they fall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29809,'I\'ve seen forks stronger than this. Forge it again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29810,'Are you perhaps confused, mortal? The metal end is for stabbing, not pricking! Sharpen it again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29811,'You are unfit to serve the Lich King even in undeath. Work hard and I may yet release you forever from this world. Fail me, and you will fuel the fires with your flesh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29812,'Finally... home...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29813,'Me... back... master...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29814,'Me come back... master. Me... loyal servant.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29815,'Sorry... me gone... so long... master.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29816,'','I often find the trouble with ghouls is that they outlive their usefulness too quickly. Let us let death and decay reclaim these.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29817,'','At times, their corpses can prove more useful than the ghouls were themselves.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29818,'','Hmm...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29819,'','Unfortunate.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29820,'It hurts...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29821,'Me... bad?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29822,'Master?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29823,'%s prepares to shatter his Brittle Golems!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29824,'That day is not today...','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29825,'Impossible...','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29826,'This... is not over!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29827,'When next we meet, it won\'t be on holy ground, paladin.','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29828,'','Your spells will not be as potent as mine, but you will still find anti-magic shells to be entirely invaluable against a large number of magical attacks.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29829,'','The power you absorb from spells with your shell can be used to counter with your other attacks.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29830,'','Mages fear our kind... with reason. Play upon this fear, disciples.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29831,'I\'ve lost my ensorcelled choker!','I\'ve lost my ensorcelled choker!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29832,'%s switches to Battle Stance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29833,'%s switches to Berserker Stance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29834,'%s switches to Defensive Stance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29835,'Rise, Darion, and listen...\n','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29836,'Do not be frightened child... welcome the cold embrace of death...','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(29837,'Such is the price of failure.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(29838,'Death is the reward for your weakness.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(29839,'Your retention was poor.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(29840,'Well done.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(29841,'You have more learning ahead of you disciple. Return to your studies.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(29842,'You have learned well. Continue on your path, disciple.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(29843,'We have all been witness to a terrible tragedy. The blood of good men has been shed upon this soil! Honorable knights, slain defending their lives -- our lives!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29844,'A good start. Return, disciple.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(29845,'And while such things can never be forgotten, we must remain vigilant in our cause!\n','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29846,'The Lich King must answer for what he has done, and must not be allowed to cause further destruction in our world.','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29847,'I make a promise to you now, brothers and sisters: the Lich King will be defeated! On this day, I call for a union.','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29848,'The Argent Dawn and the Order of the Silver Hand will come together as one! We will succeed where so many before us have failed!\n','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29849,'We will take the fight to Arthas, and we will tear down the walls of Icecrown!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29850,'The Argent Crusade comes for you, Arthas!\n','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29851,'So too do the Knights of the Ebon Blade. Although our kind has no place in your world, we will fight to bring an end to the Lich King. This I vow!','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29852,'%s moves up the tunnel!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29853,'Here you are, $n.$b$bNow please, return your focus to the task at hand....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29854,'Ghoul! Come here still for a moment!','Ghoul! Come here still for a moment!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29855,'Here, eat this, our enemies shall be delighted.','Here, eat this, our enemies shall be delighted.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29856,'%s places a stick of dynamite upon the ground.','%s places a stick of dynamite upon the ground.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29857,'You are such a devious one! Whatever shall we do with you?','You are such a devious one! Whatever shall we do with you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29858,'Why, thank you. I do pride myself on knowing when a little bit of grease beats spending hours of sorcerous study for the same effect.','Why, thank you. I do pride myself on knowing when a little bit of grease beats spending hours of sorcerous study for the same effect.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29859,'%s hurries over.','%s hurries over.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29860,'%s chows down ravenously.','%s chows down ravenously.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29861,'Your end.','',0,0,0,0,0,0,0,0,1,7487,0,0,26124),
(29862,'Our storehouses have been depleted.  I have nothing to sell until we can get more supplies.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(29863,'Because you\'ve managed to replenish some of our supplies I can get back to cooking.  Now, what can I do for you?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(29864,'Looks like $n passed out. What should we do, Tirion?','',0,0,0,0,0,0,0,0,1,7510,0,0,26124),
(29865,'%s begins to cast Lightning Nova!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29866,'','Look sharp, $r.$b$bIt\'s life or death out here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29867,'As disciples of blood, you strive to master the very lifeforce of your enemies.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29868,'Be it by blade or incantation, blood feeds our attacks and weakens our foes.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29869,'True masters learn to make blood serve more than just their strength in battle.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29870,'Stripping energy from our foes, both fighting and fallen, allows us to persevere where lesser beings fall exhausted.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29871,'And every foe that falls, energy sapped and stolen, only further fuels our assault.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29872,'As masters of blood, we know battle without end...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29873,'We know hunger never to be quenched...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29874,'We know power never to be overcome...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29875,'As masters of blood, we are masters of life and death itself.  Against us, even hope falls drained and lifeless.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(29876,'Return to the field of battle or you will be dropped!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(29877,'','Why is everyone looking at me as if I crashed the ship?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29878,'Finally, we have the parts to repair the Spirit of Gnomeregan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29879,'Let\'s see, just a tweak here and an adjustment there...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29880,'And there she is, the Spirit of Gnomeregan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29881,'You can use her, but I don\'t want to hear any complaints about saw blades in your seat. I had to fix \'er with what we could find.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29882,'Hello, friend! I\'ve setup shop in this here factory. I\'d be happy to set you up in a shiny new vehicle - I\'ll even send the bill to your leaders after the assault. Best deal anywhere!','Hello, friend! I\'ve setup shop in this here factory. I\'d be happy to set you up in a shiny new vehicle - I\'ll even send the bill to your leaders after the assault. Best deal anywhere!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29883,'I would like to drive a demolisher.','I would like to drive a demolisher.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29884,'Hello, friend! I\'d love to give you a demolisher, but I\'m out of parts at the moment.','Hello, friend! I\'d love to give you a demolisher, but I\'m out of parts at the moment.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29885,'What treachery is this?! You be payin\' for this deceit with your life, mon!','',0,0,0,0,0,0,0,0,1,7447,0,0,26124),
(29886,'The Scepter of Domination glows brightly! Use it now!','',0,0,0,0,0,0,0,0,1,7447,0,0,26124),
(29887,'A Crypt Guard joins the fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29888,'Avoid incoming Scarlet Crusade arrows and javelins by moving out of their line of fire!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(29889,'Devour Scarlet Crusaders to replenish your energy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(29890,'I hope Jones is okay.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29891,'If Jones listened to me, he\'d live longer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29892,'That Jones...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29893,'He\'s not nuts, he\'s crazy!  Always going off looking for fortune and glory...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29894,'Oh boy Jones and I have had some adventures...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29895,'Where Jones goes, I go.  Where he steps, I step.  But this time he told me to stay back.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29896,'I hope Jones makes it back okay.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29897,'Jones still owes me money from our last card game.  Can you believe he tried to cheat me!  I may be little, but he cheats very big.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29898,'Oh boy... I can\'t believe I just remembered that...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29899,'...so he dropped the potatoes, even though I told him to hold onto them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29900,'%s looks around nervously.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29901,'%s sighs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29902,'%s takes a deep breath and puffs out his chest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29903,'%s looks off into the distance, annoyed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29904,'%s can hardly control his laughter.  His story is constantly interrupted by his own laughter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29905,'%s sighs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29906,'Hmm... something familiar about your face $r...  Give me a moment...$B$BAh ha! Westfall, that\'s where I recognize you from.  You are $n!  It\'s good to see you again.  But, let\'s hope you can help us finish the job this time.$B$BNow we\'re a long way from Westfall up here, but if we don\'t win this battle, there may not be a home to return to.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29908,'$n!  I hardly recognized you in your new outfit.  Still have that tunic... or did you take the chausses... or was it the staff?   I can\'t recall, it was so long ago...$B$BWell, I\'m glad you are here to help out again.  We could use all the help we can get.  $n, if you perform the way you did back in Westfall with the People\'s Militia, we have a chance.$B$BThese are dire times, if we don\'t win this battle, there may not be a Westfall to return to.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(29909,'With the Light\'s blessing and your help, $n, the Defias are no longer a threat.$B$BBut we\'re a long way from Westfall up here, and if we don\'t win this battle, there may not be a home to return to.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29910,'Good hunting out there, $c!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(29911,'Good luck $r!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(29912,'Watch your back, $r!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(29913,'Incoming $c!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(29914,'Inbound $r!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(29915,'We\'ve got a $c inbound!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(29916,'Fool! Ya coulda been havin\' great power, mon!','',0,0,0,0,0,0,0,0,1,7447,0,0,26124),
(29917,'How could dis be? Da Lich King said he be havin\' great plans for you, mon...','',0,0,0,0,0,0,0,0,1,7447,0,0,26124),
(29918,'I shoulda known not to be trustin\' nobody!','',0,0,0,0,0,0,0,0,1,7447,0,0,26124),
(29919,'Ya done turned your back on destiny, mon. Now you gunna die!','',0,0,0,0,0,0,0,0,1,7447,0,0,26124),
(29920,'Your betrayal not gunna be slowin\' me down none, mon.','',0,0,0,0,0,0,0,0,1,7447,0,0,26124),
(29921,'I never needed ya, mon. I can crush Zul\'Drak without ya!','',0,0,0,0,0,0,0,0,1,7447,0,0,26124),
(29922,'ENOUGH!','',0,0,0,0,0,0,0,0,1,7447,0,0,26124),
(29923,'Dis foolish treachery has cost ya your destiny!','',0,0,0,0,0,0,0,0,1,7447,0,0,26124),
(29924,'Remember, $n, this is no sprint. The true test of a hunter tests his endurance over the course of a long expedition.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29925,'The Eastern Graveyard has been captured by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29926,'The Western Graveyard has been captured by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29927,'The Southern Graveyard has been captured by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29928,'The Eastern Graveyard has been captured by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29929,'The Western Graveyard has been captured by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29930,'The Southern Graveyard has been captured by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29931,'The air teems with latent energy... quite the harvest!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29932,'Urgreth begins to emanate a powerful dark energy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29933,'Looks like you brought the whole family!  What\'s your business here, then?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29934,'Work?  You are aware this is a warzone, citizen?  What is your profession?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29935,'Right.  Go ahead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29936,'Her Majesty sends Dark Rangers!  Stand aside, boys!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29938,'You must be the sorriest bunch of recruits I\'ve seen today!  Fall in formations and report to High Executor Anselm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29939,'Aren\'t you a sorry sight!  I suppose you\'re a little better than yesterday\'s bunch.  Formations, now!  Report for duty!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29940,'Wipe that worthless grin off your faces, recruits!  If the High Executor sees you like that he will kill you all himself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29941,'This not fun...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29942,'New toys!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29943,'Boring...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29944,'Why you stop moving?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29945,'Get up! Me not done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29946,'You only advance... the master\'s plan...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29947,'Ah, the entertainment has arrived!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29948,'The fun is just beginning!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29949,'Ah! Quality materials.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29950,'Don\'t worry; I\'ll make good use of you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29951,'Say hello to some friends of mine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29952,'Come, citizens of Stratholme! Meet your \"saviors.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29953,'BOOM! Hahahahah...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29954,'Blood... destruction... EXHILARATING!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29955,'I want a sample...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29956,'Such strength... it must be mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29957,'Your flesh betrays you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29958,'What can Korg do for you today?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29959,'Show me what you have for sale.','Show me what you have for sale.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29960,'I am ready. Let\'s defend the temple!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29961,'I can\'t believe the blues would attack us. Let\'s give some of it back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29962,'Where to first?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29963,'Your reputation precedes you, $n. This should be interesting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29964,'Shall we destabilize the shrine first or disable the enemy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29965,'We\'ve been expecting you, $n. Now we have the upper hand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29966,'Are you ready for battle, $c?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29967,'Greetings, friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29968,'Fool!  You led us to the only being that could stand up to our armies!  You will never bring the Etymidian back to Northrend!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29969,'Master, dis mortal scum be double-crossin\' us. Dey must be made to suffer!','',0,0,0,0,0,0,0,0,1,7447,0,0,26124),
(29970,'Fight on, or face me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29971,'Var-jorgg gramalch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29972,'Slay them all! No excuses! No mercy! No rest! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29973,'Raze every structure! Silence every cry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29974,'I\'ll paint my face with your blood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29975,'I am a warrior born!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29976,'My life for the... death god!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29977,'I return! A second chance to carve your skull!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29978,'Mjul orm agn gjor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29979,'No! I can do... better! I can...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29980,'','Ingvar! Your pathetic failure will serve as a warning to all... you are damned! Arise and carry out the master\'s will!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29981,'Intriguing... a high quantity of arcane energy is near. Time for some prospecting...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29982,'It is you who should suffer. Be content that your death is a quick one....','',0,0,0,0,0,0,0,0,1,7447,0,0,26124),
(29983,'As for you...','',0,0,0,0,0,0,0,0,1,7447,0,0,26124),
(29984,'I spare your insignificant life as a reward for this amusing betrayal. There may yet be a shred of potential in you.','',0,0,0,0,0,0,0,0,1,7447,0,0,26124),
(29985,'When next we meet I shall require much more to justify your life.','',0,0,0,0,0,0,0,0,1,7447,0,0,26124),
(29986,'You have failed me, Drakuru!','',0,0,0,0,0,0,0,0,1,7447,0,0,26124),
(29987,'DISCOVERY!   $n has discovered how to transmute eternal life into shadow.','DISCOVERY!   $n has discovered how to transmute eternal life into shadow.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29988,'DISCOVERY!   $n has discovered how to transmute eternal life into fire.','DISCOVERY!   $n has discovered how to transmute eternal life into fire.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29989,'Be warned...','',0,0,0,0,0,0,0,0,1,7447,0,0,26124),
(29990,'DISCOVERY!   $n has discovered how to transmute eternal fire into water.','DISCOVERY!   $n has discovered how to transmute eternal fire into water.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29991,'DISCOVERY!   $n has discovered how to transmute eternal fire into life.','DISCOVERY!   $n has discovered how to transmute eternal fire into life.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29992,'DISCOVERY!   $n has discovered how to transmute eternal air into water.','DISCOVERY!   $n has discovered how to transmute eternal air into water.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29993,'DISCOVERY!   $n has discovered how to transmute eternal air into earth.','DISCOVERY!   $n has discovered how to transmute eternal air into earth.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29994,'DISCOVERY!   $n has discovered how to transmute eternal shadow into earth.','DISCOVERY!   $n has discovered how to transmute eternal shadow into earth.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29995,'DISCOVERY!   $n has discovered how to transmute eternal shadow into life.','DISCOVERY!   $n has discovered how to transmute eternal shadow into life.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29996,'DISCOVERY!   $n has discovered how to transmute eternal earth to air.','DISCOVERY!   $n has discovered how to transmute eternal earth to air.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29997,'DISCOVERY!   $n has discovered how to transmute eternal earth to shadow.','DISCOVERY!   $n has discovered how to transmute eternal earth to shadow.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29998,'DISCOVERY!   $n has discovered how to transmute eternal water to air.','DISCOVERY!   $n has discovered how to transmute eternal water to air.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(29999,'DISCOVERY!   $n has discovered how to transmute eternal water to fire.','DISCOVERY!   $n has discovered how to transmute eternal water to fire.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30000,'DISCOVERY!   $n has discovered a new transmutation!','DISCOVERY!   $n has discovered a new transmutation!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30001,'What is that bauble you carry?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30002,'Your little toy will not save you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30003,'The Light is no match for the Lich King\'s might!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30004,'Say goodbye to those you love, $c...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30005,'Your kingdoms will fall, $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30006,'Your mighty castles will crumble and your loved ones will join the Lich King\'s ranks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30007,'The stench of that holy trinket you carry disgusts me...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30008,'Why don\'t you discard it...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30009,'Join us, $n.  Swear liegance to the Lich King.  Give yourself to him and know peace... the peace you have been denied since your wailing, terrified birth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30010,'There is no honor fighting us when the end has already been written.  Azeroth... will... die.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30011,'If you struggle, then before your death you will face pain and horror and the loss of all you love.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30012,'Greetings...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30013,'I see you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30014,'Ah, there you are...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30016,'There.  I found you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30017,'The Arena battle ends in 60 seconds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30018,'Maintain your faith. The grand admiral will deliver us to victory over the Lich King.','Maintain your faith. The grand admiral will deliver us to victory over the Lich King.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30019,'Accept this blessing in the name of the Holy Light.','Accept this blessing in the name of the Holy Light.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30020,'Do not waver. Soon we shall sit within the hallowed presence of the Light.','Do not waver. Soon we shall sit within the hallowed presence of the Light.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30021,'There are villains amongst us - remain vigilant. The Ebon Blade seeks to prevent us from destroying their true master, the Lich King.','There are villains amongst us - remain vigilant. The Ebon Blade seeks to prevent us from destroying their true master, the Lich King.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30022,'Do not question what the Holy Light has put before you. Only those that sacrifice all will be delivered into its presence.','Do not question what the Holy Light has put before you. Only those that sacrifice all will be delivered into its presence.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30023,'Grand Admiral Westwind has a plan... a vision. We must remain faithful and steadfast in its execution for the sake of the world.','Grand Admiral Westwind has a plan... a vision. We must remain faithful and steadfast in its execution for the sake of the world.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30024,'This land is freezing, but I am warm, blanketed in the glow of the Holy Light. Do not be disheartened.','This land is freezing, but I am warm, blanketed in the glow of the Holy Light. Do not be disheartened.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30025,'By order of the grand admiral, stay away from the southern side of the island upon pain of death. Spread the word.','By order of the grand admiral, stay away from the southern side of the island upon pain of death. Spread the word.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30026,'Stormwind is still beset -- a necropolis looms at its walls and random Scourge outbreaks have been reported.','Stormwind is still beset -- a necropolis looms at its walls and random Scourge outbreaks have been reported.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30027,'Freshly killed zombies are arriving via meat wagon, though their numbers are dwindling.','Freshly killed zombies are arriving via meat wagon, though their numbers are dwindling.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30028,'The last attack in the Eastern Plaguelands yielded a large harvest of dead, from both sides.','The last attack in the Eastern Plaguelands yielded a large harvest of dead, from both sides.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30029,'The Argent Dawn\'s agents scored a decisive victory in the deserts of Tanaris.','The Argent Dawn\'s agents scored a decisive victory in the deserts of Tanaris.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30030,'Light\'s Hope Chapel remains a bastion in the Plaguelands.  Argent Dawn\'s foothold there is key to securing the area.','Light\'s Hope Chapel remains a bastion in the Plaguelands.  Argent Dawn\'s foothold there is key to securing the area.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30031,'Git up, you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30032,'Yes, the Lich King will fall to our might. We will have our final revenge.$B$BBut first, we will see to it that the plague known as the Scarlet Onslaught comes to an end once and for all!','',273,1,0,0,0,0,0,0,1,0,0,0,26124),
(30033,'Lord-Commander, I would hear your tale.','Lord-Commander, I would hear your tale.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30034,'Very well, but if I were you, I would pay attention and not just blindly nod my head at what I heard.$B$BIt begins, as all good stories do, with betrayal. Oh, it\'s not that we were betrayed... not at all. The Lich King raised us death knights above all others.$B$BRather, it was we who betrayed him with the help of Highlord Darion Mograine.$B$BIn the final fight at Light\'s Hope Chapel in the Plaguelands, with the simpletons moments away from annihilation, Tirion Fordring helped Mograine break the Lich King\'s hold upon him and all of the rest of us that were present.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(30035,'<You nod slightly but do not complete the motion as the lord-commander narrows his eyes before he continues.>','<You nod slightly but do not complete the motion as the lord-commander narrows his eyes before he continues.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30036,'Just give up and die already!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30037,'With the Lich King fleeing in fear of Fordring armed with the Ashbringer, we were able to easily wrest Ebon Hold from the remaining Scourge forces.$B$BThat didn\'t settle things between us and the Scarlet Crusade, however.$B$BAs the Forsaken have learned the hard way, the Scarlets cannot seem to differentiate between us and the Scourge.$B$BWe think on our own, we have our own motivations, we have almost all of the qualities of the living, and yet to them, we are no different than the mindless slaves of the Lich King.$B$BMistakenly they think we will roll over and play dead.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(30038,'I thought that they now called themselves the Scarlet Onslaught?','I thought that they now called themselves the Scarlet Onslaught?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30039,'Lord-Commander, would you repeat what you said before?','Lord-Commander, would you repeat what you said before?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30040,'<The lord-commander fixes you with a stare before going on.>$B$BI was getting to that. Indeed, when High General Abbendis landed her forces on Northrend, she changed their name to the Scarlet Onslaught.$B$BIt was not long before Admiral Barean Westwind presented himself to her at New Hearthglen in the Dragonblight. From all accounts, she wasn\'t expecting him. Nor was she expecting that he would undermine her authority and take the reins of command away from her.$B$BLikely you were involved with her demise, but no matter. Once she was dead, the admiral made a mysterious exit and we lost track of him.','',1,0,0,2000,0,0,0,0,1,0,0,0,26124),
(30041,'Mo\' guts! Mo\' blood! Mo\' food!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30042,'Me gonna carve you and eat you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30043,'So hungry! Must feed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30044,'Corpse go boom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30045,'Where did the grand admiral go?','Where did the grand admiral go?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30046,'As I said, we lost track of him, but this is something that I\'m sure you will be able to figure out for me. My suspicion is that he\'s down there somewhere, but my spies that have returned haven\'t been able to place him anywhere on the island.$B$BThe Forsaken at Venomspite did a good job of sabotaging New Hearthglen, but the Onslaught forces that are present down there are the battle-hardened remnant from that place. Unfortunately, they picked up better equipment along the way, as well as gryphons taken from fools somewhere.$B$BWhat I\'m trying to say is that this isn\'t going to be a stroll in the countryside, $n, even for you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(30047,'That\'s fine. When do I start?','That\'s fine. When do I start?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30048,'We\'ll start in just a moment.$B$BI just want to be very clear -- we\'re not here to soften them up. We\'re not here to make a dent. We\'re here to put an end to the disease that calls itself the Scarlet Onslaught.$B$BIf you don\'t want any part of that, if you don\'t have the stomach, fly away now. I want someone with us who is going to be here every day until the job\'s done.$B$BAre you that $g man : woman;, $n?','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(30049,'Let\'s finish this!','Let\'s finish this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30050,'<The lord-commander flashes a rictus grin, looking you up and down discerningly.>$B$BThat\'s what I wanted to hear.','',25,0,0,2000,0,0,0,0,1,0,0,0,26124),
(30051,'My king!  I cannot hear your voice!  Do not leave me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30052,'Give me your brain!','',0,0,0,0,0,0,0,36,1,0,0,0,26124),
(30053,'I must feed...','',0,0,0,0,0,0,0,36,1,0,0,0,26124),
(30054,'My king!  I cannot hear your voice!  Do not leave me!','',0,0,0,0,0,0,0,36,1,0,0,0,26124),
(30055,'I must feed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30056,'Give me your brain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30057,'Where am I?  So dark...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30058,'Cling to your hope, mortal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30059,'Hope sweetens the soul, and yours will be a fine dessert for the Lich King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30060,'Please!  $n!  Destroy me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30061,'I have done such vile things...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30062,'...killed loved ones... eaten them...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30063,'Please!  $n!  Destroy me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30064,'Let the torture end!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30065,'Show mercy, $n!  Give me peace!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30066,'Please!  $n!  Destroy me!','',0,0,0,0,0,0,0,36,1,0,0,0,26124),
(30067,'You... I\'ve seen you in Shattrath...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30068,'My King knows of you.  He wants to see you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30069,'Blood and souls for my King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30070,'Blood and souls for my King!','',0,0,0,0,0,0,0,36,1,0,0,0,26124),
(30072,'There is fire in my eyes!  My mind!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30073,'Living flesh eases the pain...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30074,'Please, I just need a little.  A finger or an ear will do...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30075,'Living flesh eases the pain...','',0,0,0,0,0,0,0,36,1,0,0,0,26124),
(30076,'Please, I just need a little.  A finger or an ear will do...','',0,0,0,0,0,0,0,36,1,0,0,0,26124),
(30077,'Oh no!  $n is looking hurt!','Oh no!  $n is looking hurt!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30078,'Come on $n!  I\'ve got good money riding on you!','Come on $n!  I\'ve got good money riding on you!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30079,'Come on $n!  You can do it!','Come on $n!  You can do it!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30080,'Don\'t show \'em any mercy $n!','Don\'t show \'em any mercy $n!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30081,'$n!','$n!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30082,'Do it, $n!','Do it, $n!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30083,'Rip \'em apart, $n!','Rip \'em apart, $n!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30084,'Pull it together, $n!','Pull it together, $n!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30085,'Come on, $n!  Don\'t let me down!','Come on, $n!  Don\'t let me down!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30086,'%s\'s Protective Bubble shatters!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30087,'%s begins to summon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30088,'I heard that the Lich King  is stirring up north, in the Frozen Wastes.  He built a fortress, Icecrown, and plans our doom.','I heard that the Lich King  is stirring up north, in the Frozen Wastes.  He built a fortress, Icecrown, and plans our doom.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30089,'Rumors say that giant men live in Northrend.  They have beards made of daggers and can put out fires with their dead, cold gaze.','Rumors say that giant men live in Northrend.  They have beards made of daggers and can put out fires with their dead, cold gaze.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30090,'The chill creeping from the north gives my bones a fierce ache.','The chill creeping from the north gives my bones a fierce ache.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30091,'The Stormwind Harbor is really bustling.  I wonder where the new boats will sail...','The Stormwind Harbor is really bustling.  I wonder where the new boats will sail...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30092,'I heard the Tauren have cousins in Northrend.  I hope they\'re good hunters... I hope they hunt undead.','I heard the Tauren have cousins in Northrend.  I hope they\'re good hunters... I hope they hunt undead.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30093,'If the blood elves go to Northrend, then vengeance shall be ours at last!  The Lich King will regret his march on our beloved Silvermoon City!','If the blood elves go to Northrend, then vengeance shall be ours at last!  The Lich King will regret his march on our beloved Silvermoon City!',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(30094,'','Consider all of the suffering that the Scarlets have caused over the years. The torture, the zealotry, the murder.$B$BI won\'t allow that to continue. Will you?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(30095,'If we serve the Light, then we must go north and face the darkness residing there.','If we serve the Light, then we must go north and face the darkness residing there.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(30096,'The continent of Northrend is filled with history!  We must dig deep through the frozen ice and find our ancestors.','The continent of Northrend is filled with history!  We must dig deep through the frozen ice and find our ancestors.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(30097,'The unique magnetic fields of the polar regions pose millions of research possibilities!','The unique magnetic fields of the polar regions pose millions of research possibilities!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(30098,'I heard that the king is found!  He\'s returning to Stormwind!','I heard that the king is found!  He\'s returning to Stormwind!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(30099,'I can smell a market up north... time to pack up the goods and put on a heavy coat!','I can smell a market up north... time to pack up the goods and put on a heavy coat!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30100,'I can smell a market up north... time to pack up the goods and put on my heavy coat!','I can smell a market up north... time to pack up the goods and put on my heavy coat!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30101,'Ha!  I almost miss old Jum\'ja.  He was tough.  But Ironhide seemed to chew through him easy enough.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30102,'Rumors drift like leaves on the wind.  They say that Highborne live to the north!','Rumors drift like leaves on the wind.  They say that Highborne live to the north!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(30103,'One empty cage.  One troll lost to the pit.  Do any of you other trolls need more convincing?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30104,'What about you?  Are you ready to be Ironhide\'s next chew toy, or are you ready to talk?  I\'ll let you think about it for a while.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30105,'I bet you miss your neighbor.  I\'ll see if you can\'t join him soon enough.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30106,'Time is running out troll.  Whenever you feel like talking about Drak\'Tharon, let me know.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30107,'Drakkari Warrior, huh?  We\'ll see how much of a warrior you are when you fight Ironhide.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30108,'I\'ve got an idea troll.  How about you tell me about Drak\'Tharon, then I let old Ironhide have a snack?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30109,'So troll, have you given thought to my suggestion?  Whatever you decide, I\'m sure it\'ll make Ironhide happy.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30110,'Garrosh is eager to take the fight to the north, though Thrall urgres caution...','Garrosh is eager to take the fight to the north, though Thrall urgres caution...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30111,'I wonder what there is to hunt in Northrend.  Fierce beasts, I wager.','I wonder what there is to hunt in Northrend.  Fierce beasts, I wager.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30112,'The souls of the undead are cursed and tortured.  If I am infected, promise you\'ll burn me before I turn..','The souls of the undead are cursed and tortured.  If I am infected, promise you\'ll burn me before I turn.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30113,'The apothecaries toil day and night on a cure for the Lich King\'s plague.  Without them, both the Horde and the Alliance would be lost.','The apothecaries toil day and night on a cure for the Lich King\'s plague.  Without them, both the Horde and the Alliance would be lost.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30114,'Return to Icecrown or lose the Onslaught Gryphon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30115,'Return to Onslaught Harbor or lose your Bone Gryphon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30116,'There you go, mon. Your very own bone gryphon Now let\'s talk about you takin\' it out to fight the Onslaught!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30117,'That\'s quite a tale, lord-commander.','That\'s quite a tale, lord-commander.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30118,'We\'re here for civilian work, sir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30119,'Well... we\'re undertakers, sir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30120,'Yes, sir!','Yes, sir!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30121,'','%s flutters her lashes at the ignorant McGoyver.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30122,'','%s sighs wistfully at McGoyver... or is it the flying machine?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30123,'','%s gazes longingly at the flying machine... or is it McGoyver she\'s watching?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30124,'Nasty little...A-ak, kaw! Kill! Yes, kill you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30125,'','The Hyldsmeet is sacred.  Whoever earns victory is assured a lifetime next to Thorim.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30126,'Bring it on, hot stuff!','Bring it on, hot stuff!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30127,'Let\'s do this...','Let\'s do this...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30128,'Kaaboooom!','Kaaboooom!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30129,'Aaaah, it\'s beautiful!','Aaaah, it\'s beautiful!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30130,'I love blowing things up!','I love blowing things up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30131,'Bombs are great!','Bombs are great!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30132,'You messed with the wrong goblin.','You messed with the wrong goblin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30133,'Eat this, baddy!','Eat this, baddy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30134,'Dwarf... strange creature...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30135,'Does it have pain??','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30136,'Soon you will be like us...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30137,'COWER, DWARFSSSESS!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30138,'Vargul maybe eat you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30139,'I\'m free?  I\'m free!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30140,'I can\'t believe it!  I\'m free to go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30141,'Time to hightail it!  Thanks, friend!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30143,'Light be with you, friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30144,'Please, I must focus. This process is very intensive, and many innocent lives are depending on us.','Please, I must focus. This process is very intensive, and many innocent lives are depending on us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30145,'I am proud to have my dedication to the Light used in such a fashion. The Scourge\'s assault on our homelands is an act of genocide that we must counteract.','I am proud to have my dedication to the Light used in such a fashion. The Scourge\'s assault on our homelands is an act of genocide that we must counteract.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30146,'','I don\'t know where the grand admiral is. Go to hell!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30147,'Greetings, $n. ','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(30148,'','You\'ll get nothing out of me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30149,'','I\'ll have your gizzard for breakfast!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30150,'Rilak, I\'ve lost Miniwing! HELP ME, PLEASE!','Rilak, I\'ve lost Miniwing! HELP ME, PLEASE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30151,'','Better than you have tried!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30152,'','You may kill me, but I\'ll never tell you what you want!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30153,'','I am Scarlet Onslaught. We don\'t rat out our leaders!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30154,'','You\'re just a filthy pawn of the Ebon Blade. Die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30155,'','No, I don\'t know where he is and if I did, I wouldn\'t tell you -- even if my life depended on it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30156,'Welcome weary traveler.  You\'ve come a long way.  We hope you can find rest here at Camp Oneqwah.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30157,'','Your corpse will adorn my mast!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30158,'Welcome to Camp Oneqwah.  Rest for a while and we will tend to your kodo.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30159,'','While the Forsaken deal with curing the plague from both sides of the Horde and Alliance, we have pledged ourselves to deal with the Scourge necropoli that lay siege to our cities.$B$BBy using concentrated Light energy, we can strike back at the Lich King\'s structures and, with luck, destroy them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30160,'Well met traveler.  I hope the journey from Camp Winterhoof to our humble outpost was not too taxing.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30161,'Archbishop Landgren must know! Aaaaaagggghhhh.....!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30162,'Greetings traveler.  It is good to see that you made your way here safely from Camp Winterhoof.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30163,'Guards help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30164,'Please... wait... stop! I don\'t know where the grand admiral is, but I\'m sure we can work it out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30165,'Did I mention that I have money and jewels? Don\'t kill me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30166,'I have no idea where he\'s at. I haven\'t seen him since we landed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30167,'Can anyone hear me? I\'m being attacked!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30168,'Stop! I could be convinced to join you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30169,'Not the face! Not the face!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30170,'How dare you! Do you have any idea who I am?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30171,'Greetings $C.  Have you lost one of your pets?','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(30172,'A thousand-thousand lives I will sacrifice for you, my lord.','A thousand-thousand lives I will sacrifice for you, my lord.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30173,'I am yours to command, my king!','I am yours to command, my king!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30174,'My king, the world will tremble in reverence...','My king, the world will tremble in reverence...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30175,'I am an instrument of your destruction, my king! Command me!','I am an instrument of your destruction, my king! Command me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30176,'Woe unto those that dare oppose the Scourge!','Woe unto those that dare oppose the Scourge!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30177,'Our enemies will be annihilated!','Our enemies will be annihilated!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30178,'Greetings, $c. I can help stable your pets or assist you in recovering lost companions.','Greetings, $c. I can help stable your pets or assist you in recovering lost companions.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(30179,'I am reborn, my king, only to serve you.','I am reborn, my king, only to serve you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30180,'There will be no survivors, my lord.','There will be no survivors, my lord.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30181,'I\'d like to stable my pet here.','I\'d like to stable my pet here.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(30182,'I\'ve lost Miniwing.','I\'ve lost Miniwing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30183,'I\'ve lost my Jubling.','I\'ve lost my Jubling.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30184,'First Mograine asks for arms, then he takes my servants away? Rubbish!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30185,'What is this nonsense about the Light? I have weapons and armor to make!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30186,'First, he gives away most of my precious Saronite, then he demands I begin crafting Runeblades of even greater power. Pah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30187,'I may not have any mindless servants, but at least I can see a quality blade made from time to time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30188,'If only I could resupply my stocks from Northrend, then I might be able to craft a weapon that could chill the heart of the unliving.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30189,'These Death Knights truly know no honor. First, they take my greatest arms and armor, crafted with care, forged with the Lich King\'s blessing. Then they wander off to who knows where and come back dressed like Goblins, mumbling something about pawning off their armor for a few coppers! Pathetic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30190,'There is work to be done here, but do you see anyone jumping to help me? No! Wretches, all of them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30191,'Fix my armor, Corvus! My blade is rusty, Corvus!  ... when will these damned mortals learn to care for themselves?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30192,'I\'ve lost my sprite darter hatchling.','I\'ve lost my sprite darter hatchling.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30193,'We should fire another signal flare.  Perhaps we will get more help from Ebon Watch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30194,'I will launch another flare.  Pray Ebon Watch is watching.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30195,'Perhaps Ebon Watch can spare some reinforcements.  Fire another signal flare.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30196,'I\'ve lost my worg pup.','I\'ve lost my worg pup.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30197,'I\'ve lost my Smolderweb hatchling.','I\'ve lost my Smolderweb hatchling.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30198,'Is it true?! Has someone finally come to get me out of this place?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30199,'No... no... that\'s not it, is it? That heartless lout probably sent you after the tools, didn\'t he?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30200,'Well... I guess I\'ll just keep an eye on the turrets... or something.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30201,'%s sighs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30204,'There can be only one survivor!','There can be only one survivor!',0,0,0,0,0,0,0,0,1,7553,0,0,26124),
(30205,'And now you die!','And now you die!',0,0,0,0,0,0,0,0,1,7553,0,0,26124),
(30206,'Round 2 begins in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30207,'I will win my freedom and leave this cursed place!','I will win my freedom and leave this cursed place!',0,0,0,0,0,0,0,0,1,7553,0,0,26124),
(30208,'You have made a grave error, fiend!','You have made a grave error, fiend!',0,0,0,0,0,0,0,0,1,7553,0,0,26124),
(30209,'They brand me unworthy? I will show them unworthy!','They brand me unworthy? I will show them unworthy!',0,0,0,0,0,0,0,0,1,7553,0,0,26124),
(30210,'I was a soldier of the Light once... Look at what I have become... ','I was a soldier of the Light once... Look at what I have become... ',0,0,0,0,0,0,0,0,1,7553,0,0,26124),
(30211,'You will allow me a weapon and armor, yes?','You will allow me a weapon and armor, yes?',0,0,0,0,0,0,0,0,1,7553,0,0,26124),
(30212,'You are hopelessly outmatched, $r.','You are hopelessly outmatched, $r.',0,0,0,0,0,0,0,0,1,7553,0,0,26124),
(30213,'I will dismantle this festering hellhole!','I will dismantle this festering hellhole!',0,0,0,0,0,0,0,0,1,7553,0,0,26124),
(30214,'Sate your hunger on cold steel, $r!','Sate your hunger on cold steel, $r!',0,0,0,0,0,0,0,0,1,7553,0,0,26124),
(30215,'Death is the only cure!','Death is the only cure!',0,0,0,0,0,0,0,0,1,7553,0,0,26124),
(30216,'There is no hope for our future...','There is no hope for our future...',0,0,0,0,0,0,0,0,1,7553,0,0,26124),
(30217,'I\'ve lost my Prairie Chicken.','I\'ve lost my Prairie Chicken.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30218,'To battle!','To battle!',0,0,0,0,0,0,0,0,1,7553,0,0,26124),
(30219,'Monster! You will be the first casualty!','Monster! You will be the first casualty!',0,0,0,0,0,0,0,0,1,7553,0,0,26124),
(30220,'It ends here!','It ends here!',0,0,0,0,0,0,0,0,1,7553,0,0,26124),
(30221,'Let your fears consume you!','Let your fears consume you!',0,0,0,0,0,0,0,0,1,7553,0,0,26124),
(30222,'HAH! You can barely hold a blade! Yours will be a quick death.','HAH! You can barely hold a blade! Yours will be a quick death.',0,0,0,0,0,0,0,0,1,7553,0,0,26124),
(30223,'Well done. Let\'s get this over with.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30224,'I\'ve lost my wolpertinger.','I\'ve lost my wolpertinger.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30225,'','There are more attackers coming from Garm. Get some mines on that field!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30226,'','More magnataur attackers are getting close...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30227,'','They\'re almost in sight - finish placing mines on that field!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30228,'','They\'re here! Give\'m hell!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30229,'Rigspark\'s vehicle shop is open for business!','Rigspark\'s vehicle shop is open for business!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30230,'Sparklight\'s vehicle emporium is open for business!','Sparklight\'s vehicle emporium is open for business!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30231,'Come, Landgren, cough up your soul so that I can ask you a very important question.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30232,'','Not bad, though some additional schooling wouldn\'t hurt! Here, watch my hips... like so!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30233,'A pack of mechanical squirrels could mine faster than you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30234,'Mine faster! I don\'t care if your actuators are rusty!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30235,'Your tinker must\'ve made you from tin, you lazy piles of slag!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30236,'Any worker who doesn\'t make his quota will be ingots before the day is out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30237,'You\'re not worth the scrap you\'re made from!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30238,'Your mother was a wrench and your father smelled of seaforium!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30239,'You! You\'re not fit to punch arclight spanners from copper plates. Get out of my sight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30240,'Even a target dummy could work faster than you! Pick it up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30241,'YOU WILL TELL ME WHERE WESTWIND IS OR I WILL DESTROY YOUR SOUL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30242,'You\'ll get nothing out of me, monster. I am beyond your ability to influence.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30243,'No.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30244,'Then you leave me no choice. I won\'t say that I won\'t enjoy this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30245,'STOP! It isn\'t worth it. I\'ll tell you where he is.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30246,'Very well. Tell me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30247,'On the south end of the island is a cave -- a hidden hollow. The grand admiral has holed himself up in there, preparing for the final battle against the Lich King.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30248,'A hidden hollow? How very interesting. You\'ve served your purpose, Landgren, but I\'m afraid there\'ll be no resurrection for you this time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30250,'AAAEEEEIIIiiiiiiiiiiiiiiiiiiiiiiiiiiii........................................','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30251,'Now that the unpleasantness is finished with, let\'s talk about you dealing with Grand Admiral Westwind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30252,'%s roars!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30253,'Fallback!','Fallback!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30254,'Move it soldiers!  We\'ll cover you!','Move it soldiers!  We\'ll cover you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30255,'You are covered soldiers!  Fallback!','You are covered soldiers!  Fallback!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30256,'Let\'s fallback!','Let\'s fallback!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30257,'We\'ve got you covered, now fallback!','We\'ve got you covered, now fallback!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30258,'Return to me on Death\'s Rise when you and your friends have dealt with the grand admiral.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30259,'','Icefang has carried me through countless battles.$b$bDon\'t let her lack of armor fool you. She\'s the toughest bear I know.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30260,'','Do not tarry here, wench!$b$bThere\'s fighting to be done!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30261,'','We fight for the glory of Brunnhildar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30262,'The darkweaver metamorphizes into something terrible and demonic.','The darkweaver metamorphizes into something terrible and demonic.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30263,'A terrible change comes over the %s as he cackles maniacally.','A terrible change comes over the %s as she cackles maniacally.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30264,'With a horrible outcry, the %s transforms into a demonic nightmare.','With a horrible outcry, the %s transforms into a demonic nightmare.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30265,'The darkweaver pierces you with an evil grin as he shifts into an entirely different form.','The darkweaver pierces you with an evil grin as she shifts into an entirely different form.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30266,'Now you know. Now you must die!','Now you know. Now you must die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30267,'Even in death there will be no escape for you!','Even in death there will be no escape for you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30268,'I shall feast upon your soul!','I shall feast upon your soul!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30269,'You will not leave this cavern alive!','You will not leave this cavern alive!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30270,'Fallback!','Fallback!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30271,'Move it soldiers!  We\'ll cover you!','Move it soldiers!  We\'ll cover you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30272,'You are covered soldiers!  Fallback!','You are covered soldiers!  Fallback!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30273,'WHAT?! No matter. Even without my sphere, I will crush you! Behold my true identity and despair!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30274,'We\'ve got you covered, now fallback!','We\'ve got you covered, now fallback!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30275,'Gah! I spent too much time in that weak little shell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30276,'Kirel narak! I am Mal\'Ganis. I AM ETERNAL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30277,'ENOUGH! I waste my time here. I must gather my strength on the homeworld.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30278,'You\'ll never defeat the Lich King without my forces. I\'ll have my revenge... on him AND you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30279,'You thought I would just let you kill me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30280,'The Scourge are breaching the southern wall!','The Scourge are breaching the southern wall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30281,'How did you find me? Did Landgren tell?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30282,'AHAHAHAHAHA! Incompetence at its finest!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30283,'The Scourge are breaching the western wall!','The Scourge are breaching the western wall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30284,'The Scourge are breaching the northern wall!','The Scourge are breaching the northern wall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30285,'','Icefang shows great courage for entering the battlefield unarmored.$b$bPerhaps her example could instill some courage in you, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30286,'This doesn\'t look pretty, lad.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30287,'I don\'t know, Bailey... it\'s not so bad. We could throw a rock at the tools from here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30288,'That\'s strange... for a moment there, I could have swore you called me short.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30289,'That right? Well why don\'t you go prance your merry little self over and grab them, eh?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30290,'Toss me?! Okay, that\'s it punk.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30291,'Keep it to yourself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30292,'You better hope they don\'t survive it, lad.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30293,'Cause I\'m just going to watch and laugh as they toss you in.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30294,'There\'s got to be a way in somewhere.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30295,'How\'d the goblin leave his tools there then?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30296,'That\'s it, lad! It looks totally safe. Go for it, I\'ll be right behind ya!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30297,'Well... I was just thinking... you\'re a bit smaller, so you\'re less likely to set off any of those mines.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30298,'No, no, no! Not short... it\'s just... well... maybe I could toss you across most of it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30299,'I\'ve got an idea, Bailey...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30300,'No, no - this might work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30301,'There\'s a path right there... only a few mines at the end in between us and the tools.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30302,'We wait for the next adventurer to come through and we tell him that\'s the way to go... then after they set off the mines, we just walk in and grab the tools!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30303,'It really doesn\'t look like it, Bailey.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30304,'Oh... good point. How about right there? That looks clear... kind of.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30305,'Uh... that\'s okay. It still kind of hurts from last time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30306,'Ahhh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30307,'Oh my...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30308,'I don\'t want to die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30309,'No, no... no!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30310,'Ow!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30311,'That was close! You scared me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30312,'Pansy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30313,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30314,'Hey $c, if you\'ve lost a key I might be able to help you out.','Hey $c, if you\'ve lost a key I might be able to help you out.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(30315,'I\'ve lost my key to Scholomance.','I\'ve lost my key to Scholomance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30316,'I\'ve lost my key to The Arcatraz.','I\'ve lost my key to The Arcatraz.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30317,'I\'ve lost my key to The Shattered Halls.','I\'ve lost my key to The Shattered Halls.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30318,'I\'ve lost my key to Searing Gorge.','I\'ve lost my key to Searing Gorge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30319,'I\'ve lost my Shadowforge Key.','I\'ve lost my Shadowforge Key.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30320,'I\'ve lost The Eye of Haramad.','I\'ve lost The Eye of Haramad.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30321,'I\'ve lost my key to Karazhan.','I\'ve lost my key to Karazhan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30322,'It\'s those blasted iron dwarves again! Somehow, they found him before we did.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(30323,'They\'re not going to give up until they find him. We can\'t allow that to happen, $n, and Brann knows it.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(30324,'There are some rather cryptic instructions in this note. Brann must\'ve had some kind of backup plan, but he can\'t keep evading capture forever...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(30325,'It\'s up to you to find him before the irons do!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(30326,'You stand before a master of the Arcane. One would be unwise to challenge me. Many corpses have been left ablaze in my wake.','',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(30327,'','My life and spirit has been filled with memories of the insufferable Horde. Times of sorrow, desperation, and sacrifice have come to pass. The rage of battle could never leave my heart!',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(30328,'','%s whistles while she works.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30329,'','%s daydreams about princes and far off places.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30330,'This is a portal to the Arathi Basin battleground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30331,'This is a portal to the Alterac Valley battleground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30332,'This is a portal to the Eye of the Storm battleground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30333,'You are not yet strong enough to do battle in the Eye of the Storm. Return when you have gained more experience.','You are not yet strong enough to do battle in the Eye of the Storm. Return when you have gained more experience.',274,0,0,1,0,0,0,0,1,0,0,0,26124),
(30334,'This is a portal to the Warsong Gulch battleground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30335,'Acquiring','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30336,'You go now, bad troll!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30337,'Why you hurt Rageclaw? You crazy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30338,'Rageclaw and troll friends no more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30339,'You kill our pups! We kill you back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30340,'You leave den the hard way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30341,'You hurted the chief\'s lion seal! WHY YOU HURT LION SEAL??!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30342,'Why you smell so bad now? You smelled much less bad before!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30343,'Trolls is shameful. Trolls is killers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30344,'The %s throws a bomb.','The %s throws a bomb.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30345,'What be happening?$B$BYou here to eat, mon? Or maybe to learn cooking from the best, eh?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(30346,'BURN, BABY, BURN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30347,'Dat be da will o\' Drakuru!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30348,'Dis whole place gonna belong to da Scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30349,'Da little beasties\' homes light up nice!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30350,'Noting can save you, beasties! Dis be Scourge land now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30351,'Der ain\'t notin anybody can do about it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30352,'Der be no stoppin\' us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30353,'Looking for a tabard?','Looking for a tabard?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(30354,'I\'ve lost my Arathor Battle Tabard.','I\'ve lost my Arathor Battle Tabard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30355,'I\'ve lost my Battle Tabard of the Defilers.','I\'ve lost my Battle Tabard of the Defilers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30356,'I\'ve lost my Blood Knight Tabard.','I\'ve lost my Blood Knight Tabard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30357,'I\'ve lost my Tabard of the Argent Dawn.','I\'ve lost my Tabard of the Argent Dawn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30358,'I\'ve lost my Tabard of the Hand.','I\'ve lost my Tabard of the Hand.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30359,'I\'ve lost my Green Trophy Tabard of the Illidari.','I\'ve lost my Green Trophy Tabard of the Illidari.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30360,'I\'ve lost my Purple Trophy Tabard of the Illidari.','I\'ve lost my Purple Trophy Tabard of the Illidari.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30362,'I\'ve lost my Tabard of the Achiever.','I\'ve lost my Tabard of the Achiever.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30363,'I\'ve lost my Tabard of the Protector.','I\'ve lost my Tabard of the Protector.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30364,'It is time to show you my true power! [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30365,'You\'ve been seen! Use the net and ice slick to keep the dwarves away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30366,'The %s sniffs the ground to pickup the trail.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30367,'The %s has tracked the scent to its source.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30368,'The frosthound has located the thief\'s hiding place. Confront him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30369,'Minionsss of the scale, heed my call!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30370,'A thousssand fangsss gonna rend your flesh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30371,'TROLL MAKE ME ANGRY!','',0,0,0,0,0,0,0,0,1,7577,0,0,26124),
(30372,'','Hello there! Care to buy some fishing supplies, or perhaps take a lesson or two?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30373,'Assessing database integrity ...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30374,'Running a level three diagnostic ...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30375,'Defragmenting swap file ...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30376,'Verifying encryption key ...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30377,'Attempting to restore lost data ...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30378,'Implementing new security protocols ...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30379,'Too long have I been gone, fighting my way across Azeroth to rediscover my past and reclaim my throne. With all the challenges that have tested the Alliance in my absence, it warms my heart to see heroes such as yourself defending our coalition.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30380,'See to your arms! We must protect the harbor, or the Alliance\'s assault on Northrend will be halted before it can even begin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30381,'This latest affront by the Lich King must be dealt with. Stormwind is doing what we can, but it will require the effort of everyone to overcome. Only after the threat at home has passed can we begin to deal with the Scourge threat abroad.$B$BThe traitor prince Arthas tests us from his seat of power in Northrend. Rest assured that the Alliance will not sit on its haunches. Preparations are already underway... for war.$B$BDefeating the Lich King and his armies will be a long and challenging ordeal. Death itself must be conquered. Many lives will be lost, but the future of Azeroth depends on our victory.$B$BI only hope that you\'ll be able to join the battle in Northrend and contribute your skill and strength to the cause.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30382,'No sooner does King Wrynn return to us that another king makes his presence known.  For five years, we have had the luxury of the Scourge keeping to their conquered lands while brave heroes dealt with threats both near and far.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30383,'Blast it, this isn\'t the time for talk! Scourge forces are pressing down upon our war ships. Take up your weapon of choice and protect those boats! If they are destroyed, our war effort will be set back months!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30384,'Our efforts in Lordaeron have been all for naught. Despite numerous setbacks, the Scourge remain unfazed. We must cut them off at the source.$B$BThe time draws near to sail for Northrend. I don\'t know what awaits us; only that our enemies are numerous and are eager for our slaughter.$B$BBut we cannot pursue any other path in good conscience. Azeroth depends on our vigilance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30385,'%s begins to transform!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30386,'The Alliance has gone through some dramatic changes since I last walked among its citizens in the time of the Third War. Some good and some...$B$B<Broll glances forlornly at Valeera.>$B$B...that could have been regrettably avoided.$B$BWith all the focus on the Burning Legion and their attacks on Azeroth, the Scourge has grown into a formidable force. The Legion\'s corruption and Scourge\'s defilement of the land are one and the same: an aberration of the natural order that must end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30387,'Save your words! If the Scourge succeeds here, then the Alliance\'s hopes of striking back at the Lich King are dashed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30388,'%s transforms into a Mammoth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30389,'I haven\'t seen such a buildup of forces since the Third War! Varian is dead set on addressing the Scourge threat directly. That\'s just like him....$B$BAre you heading to Northrend? I have never been there, but I hear it is both a beautiful and treacherous land. Sadly, urgent matters at home require my attention, so I will not be able to join Highlord Fordragon and his army on their journey.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30390,'','I see that look in your eyes. Don\'t think I\'m ignorant to the feelings of your people. I\'m just as uncomfortable having to suffer the distrusting glares of guard and citizen alike.$B$BI only stick around because of my obligation to Varian. He treats me as an equal... the way the Alliance should have treated my people.$B$BNow, if you\'re done gawking, the Scourge is making a mess of things in Stormwind. Why don\'t you go do something about it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30391,'','This is no time for talk! If those boats are destroyed, then the Alliance will keep fighting the Scourge in their home instead of the Lich King\'s! So make yourself useful and kill some undead!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30392,'','I heard the Horde is amassing its own army to head to Northrend. HOPEFULLY your Alliance and the Horde can focus their aggression on the real threat. You know, instead of each other?$B$BSomehow I think that\'s unlikely to happen, if my experience here is any indication. Your people have been SO welcoming to me.$B$B<Valeera mutters angrily to herself.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30393,'FOOLS OF STORMWIND!  HEAR ME, NAIVE CHILDREN OF THE ALLIANCE!  TREMBLE AND KNOW YOUR DOOM, FOR THE LICH KING\'S GAZE IS FIXED UPON YOU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30394,'ARGH!  THIS SMALL VICTORY WILL AVAIL YOU NOTHING!  COME!  COME TO NORTHREND.  MY MINIONS ARE WAITING, AND THEY ARE HUNGRY....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30395,'See to your arms! We must protect the harbor, or the Alliance\'s assault on Northrend will be halted before it can even begin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30396,'Rageclaw free! Troll die now!','',0,0,0,0,0,0,0,0,1,7577,0,0,26124),
(30397,'No more mister nice wolvar!','',0,0,0,0,0,0,0,0,1,7577,0,0,26124),
(30398,'I poop on you, trollses!','',0,0,0,0,0,0,0,0,1,7577,0,0,26124),
(30399,'Revenge for Rageclaw!','',0,0,0,0,0,0,0,0,1,7577,0,0,26124),
(30400,'ARRRROOOOOGGGGAAAA!!!','',0,0,0,0,0,0,0,0,1,7577,0,0,26124),
(30401,'This mean war!','',0,0,0,0,0,0,0,0,1,7577,0,0,26124),
(30402,'Use of the Inventor\'s Disk detected. Emergency protocol gamma activated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30403,'Verifying status of Norgannon\'s shell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30404,'Norgannon\'s shell accounted for and secure. It will be available for transfer once user\'s identity has been verified.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30405,'Standby to verify identity as Keeper Mimir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30406,'Identity verification failed. User is not Keeper Mimir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30407,'The Inventor\'s Disk has fallen into the hands of an unauthorized user.  Activating defense protocol.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30408,'Impostor must be dealt with. The Inventor\'s Disk must be recovered.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30409,'You gave in too soon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30410,'How disappointing for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30411,'Unfortunate. The best was yet to come.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30412,'Anakh kyree!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30413,'My Onslaught will wash over the Lich King\'s forces!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30414,'Your death is in vain, tiny mortal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30415,'Your time has come to an end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30416,'You\'re wasting time. Go kill the minions of the Lich King, $c!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(30417,'How fare your efforts against the Lich King, $c?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(30418,'It is good to see you again, $n. How could I ever forget the $g man : woman; who saved my sister\'s life?','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(30419,'It is good to see you again, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(30420,'Are you okay? I\'ve come to take you back to Frosthold if you can stand.','Are you okay? I\'ve come to take you back to Frosthold if you can stand.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30421,'All systems online and functional!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30422,'Directive: Repair prototype console.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30423,'Implementing directive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30424,'Prototype console repaired and returned to functional status.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30425,'Awaiting further instructions from Keeper Mimir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30426,'Powering up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30427,'<The Frostborn Scout attempts to rise to his feet as you approach, but stumbles back to the ground, clenching an obviously painful wound in his side.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30428,'I don\'t think that\'s going to happen, $G lad:lass;. I\'ve lost a lot of blood... there\'s no way I\'m making it back.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30429,'I\'m sorry that I didn\'t get here sooner. What happened?','I\'m sorry that I didn\'t get here sooner. What happened?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30430,'A pack of harpies came up from the valley. A big one named Sirana led them... I didn\'t have anywhere to escape. They haven\'t been this aggressive for a long time... I didn\'t expect it... I let my guard down.... it\'s my own fault.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30431,'I\'ll go get some help. Hang in there.','I\'ll go get some help. Hang in there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30432,'It\'s a little late... for that... $G lad:lass;.$B$B<The Frostborn Scout coughs up some blood on the snow.>$B$BGet... that wench in charge for me...$B$B<The Frostborn Scout slumps over as he breathes his last breath.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30433,'Look around and let the devastation sink in, $c. Every last troll that lived here is either dead or has fled to the upper levels.$B$BIt gets worse.$B$BIn an act of desperation, the living Drakkari trolls sacrificed their own animal gods so that they could drink from the blood of the gods and gain untold power. While they succeeded in keeping the Scourge at bay with their newfound strength, the results were catastrophic. The ancient empire of Zul\'Drak lies in ruin as proof.\n','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(30434,'Do keep out of sight, will you? I\'m trying to pretend that I\'m still under the Lich King\'s control!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(30435,'You almost done, Dan?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30436,'We need to get back to Lantinga and tell him about this place. Hurry it up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30437,'If you would have let me drive, we wouldn\'t have gotten in this mess!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30438,'We won\'t survive another attack, Dan. You gotta get us out of here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30439,'Hurry up, Reed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30440,'Think you could calculate how many things out here want to kill us? I bet you\'d be surprised at the results.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30441,'I\'m working as fast as humanly possible, Pat. Stop interrupting me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30442,'I\'m sure things would have been a lot better with you driving. We would have all probably died on the way here instead. I can see the headlines now: \"Heroes of the Argent Crusade Killed in Fatal Steam Tank Accident.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30443,'It\'s times like these that I remember why we\'re best friends, Pat. You\'re always so full of positive encouragement.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30444,'My goal is to work as slowly as possible, giving any murderous Scourge in the area a large window in which they can choose to kill us and then do terrible things to our corpses. Isn\'t that the plan? ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30445,'Maybe you should come bang on this thing with my wrench for awhile, eh? Then you can see what it feels like to be me! Let me tell you, it ain\'t easy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30446,'One more word out of you and so help me...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30447,'Why couldn\'t they have taken you instead of Dargath? WHY! WHY! WHY!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30448,'It\'s about to get crazy up in here, Pat. Don\'t say another word!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30449,'Gerk, Burr, Dargath: all gone... It\'s just MacKellar and I left out here. I hope you\'ve brought some good news.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(30450,'Can you repair my gear?','Can you repair my gear?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30451,'Tick tock, tick tock...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30452,'Not quick enough!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30453,'Let\'s get this over with.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30454,'There is no future for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30455,'This is the hour of our greatest triumph!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30456,'You were destined to fail.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30457,'The ink has dried on this chapter of history...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30458,'','You dare?! Where is Baron Sliver? I would have words with him!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30459,'Mrmrmmrmrmrmrm... mrmrmrmr?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30460,'Vile free? Vile love $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30461,'Crush... maim... DESTROY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30462,'','Who intrudes upon my ritual?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30463,'Mrrfrmrfrmrrrrr!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30464,'Enough!  I will not stand for this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30465,'You\'re the one that\'s been disrupting things? This should be easy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30466,'I\'ll kill every last one of your pawns, Lich King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30467,'Take your flying fortresses back to Northrend, before I crush them with my bare hands!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30468,'Halt. If the core is in your possession, please place it safely on the ground to avoid any damage it make incur during your elimination.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30469,'Elimination will now commence. Thank you for your cooperation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30470,'','My dear general, your time has come!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30471,'SMASH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30472,'MRMRFRMRFRMRRRR!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30473,'Not if I have something to say about it, sparky!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30474,'King Stormheart had me stop by to lend you hand - looks like it was good that I did. Good luck to ya.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30475,'That\'s enough.  Separate!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30476,'FOOLS! YOU WON\'T HOLD THE SHADOW VAULT FOR LONG!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30477,'Hurry! It\'s not safe for you to be seen with me here....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30478,'Be quick! We must not be seen together.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30479,'What news, friend?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30480,'Can you help me get down from here, Stefan?','Can you help me get down from here, Stefan?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30481,'This should see you to the ground safely, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30482,'Please to be quiet! Pups asleeping!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(30483,'They are coming for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30484,'Give in to your fear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30485,'Kill them all... before they kill you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30486,'They have turned against you. Now... take your revenge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30487,'Tell yourself again that these are not truly your friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30488,'There is no escape. Not in this life. Not in the next.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30489,'You are a pawn of forces unseen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30490,'It WAS your fault.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30491,'Ugly little monsters, pray I don\'t get out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30492,'I will crush you all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30493,'Wretched beasts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30494,'My brothers will come for me and then you will see what true power is!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30495,'Your torture only adds to my rage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30496,'I will devour you whole!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30497,'How long do you think this cage can hold me, fiends!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30498,'I will take pleasure in gutting you!','I will take pleasure in gutting you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30499,'I will feed you to the dogs!','I will feed you to the dogs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30500,'Your entrails will make a fine necklace.','Your entrails will make a fine necklace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30501,'Die, maggot!','Die, maggot!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30502,'You come to die!','You come to die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30503,'I spit on you!','I spit on you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30504,'Sniveling pig!','Sniveling pig!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30505,'Ugglin oo bjorr!','Ugglin oo bjorr!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30506,'Haraak foln!','Haraak foln!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30507,'You come to die!','You come to die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30508,'I\'ll eat your heart!','I\'ll eat your heart!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30509,'','Good work with the crates! Come talk to me in front of Stratholme for your next assignment!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30510,'Farewell, friend. May we meet again under better circumstances. I\'ll never forget what you did for me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30511,'Algar the Chosen is at the Reliquary of Pain to the northeast.\n\nPrince Navarius is on the other side of the Dead Fields to the east.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30512,'Go away, gnoll!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30513,'You not gonna steal no more parts from Dim!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30514,'My parts, gnoll!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30515,'Let me grab parts for goblin... stop stealing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30516,'No! My parts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30517,'No... no more steal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30518,'Why? Why you not just leave Dim alone?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30519,'Dim just want to go back... let Dim finish, dumb gnoll.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30520,'','Casting kill credit at $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30521,'%s begins to emerge from its Seed Pod.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30522,'Not yet... not ye--','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30523,'Take a moment and relish this with me. Soon... all will be revealed. Okay then, let\'s do this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30524,'Time to get some answers! Let\'s get this show on the road!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30525,'Now that\'s earnin\' your supper!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30526,'Press on; that\'s the way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30527,'Press on; that\'s the way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30528,'You wish to confront the master? You must first weather the storm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30529,'The slightest spark shall be your undoing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30530,'No one is safe!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30531,'Shocking, I know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30532,'You attempt the impossible.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30533,'Your spark of life is... extinguished.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30534,'Master... you have guests.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30535,'What hope is there for you? None!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30536,'I have witnessed the rise and fall of empires... the birth and extinction of entire species... Over countless millennia the foolishness of mortals has remained the only constant. Your presence here confirms this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30537,'My master has shown me the future, and you have no place in it. Azeroth will be reborn in darkness. Yogg-Saron shall be released! The Pantheon shall fall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30538,'You cannot hide from fate!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30539,'Come closer. I will make it quick.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30540,'Your flesh cannot hold out for long.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30541,'Only mortal...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30542,'I... am... FOREVER!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30543,'What little time you had, you wasted!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30544,'My death... heralds the end of this world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30545,'You stare blindly into the abyss!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30546,'Your ignorance is profound. Can you not see where this path leads?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30547,'You cross the precipice of oblivion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30548,'The iron dwarves followed you! Use the net and the ice slick to escape!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30549,'Frostbite has tracked the scent to its source. Investigate the cave!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30550,'%s sniffs and finds the trail.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30551,'%s has tracked the scent to its source inside the cave.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30552,'Now keep an eye out! I\'ll have this licked in two shakes of a--','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30553,'Oh, that doesn\'t sound good. We might have a complication or two...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30554,'Ah, you want to play hardball, eh? That\'s just my game!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30555,'Couple more minutes and I\'ll--','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30556,'Heightened? What\'s the good news?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30557,'So that was the problem? Now I\'m makin\' progress...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30558,'Hang on! Nobody\'s gonna\' be sanitized as long as I have a say in it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30559,'Ha! The old magic fingers finally won through! Now let\'s get down to--','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30560,'Purge? No no no no no.. where did I-- Aha, this should do the trick...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30561,'Time to get some answers! Let\'s get this show on the road!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30562,'I\'m doin\' everything I can!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30563,'Light preserve ye!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30564,'I hope this is all worth it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30565,'Query? What do you think I\'m here for, tea and biscuits? Spill the beans already!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30566,'Tell me how the dwarves came to be, and start at the beginning!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30567,'Right, right... I know the earthen were made from stone to shape the deep regions o\' the world. But what about the anomalies? Matrix non-stabilizin\' and what-not?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30568,'Necrowhatinthe-- Speak bloody Common, will ye?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30569,'You call that fighting? Let me go grab your dolly. Maybe she could teach you how to swing.','',0,0,0,0,0,0,0,0,1,7652,0,0,26124),
(30570,'My dead grandmater, rest her soul, could beat you... even now!','',0,0,0,0,0,0,0,0,1,7652,0,0,26124),
(30571,'I\'ve half a mind to cut you both down where you stand! The other half isn\'t arguing!','',0,0,0,0,0,0,0,0,1,7652,0,0,26124),
(30572,'Well hello, ladies. What do you think this is... Skorn?','',0,0,0,0,0,0,0,0,1,7652,0,0,26124),
(30573,'You will practice until your lungs are bursting and your arms are aching, and then we\'ll really start!','',0,0,0,0,0,0,0,0,1,7652,0,0,26124),
(30574,'Only the best of the best get a shot in Valhalas to go to Ymirheim. Everyone else dies... or worse!','',0,0,0,0,0,0,0,0,1,7652,0,0,26124),
(30575,'Stop trying to hit him and HIT HIM already!','',0,0,0,0,0,0,0,0,1,7652,0,0,26124),
(30576,'Are you trying to make me look bad? That\'s the only thing that you\'re good for today!','',0,0,0,0,0,0,0,0,1,7652,0,0,26124),
(30577,'Old Gods, huh? So they zapped the earthen with this Curse of Flesh... and then what?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30578,'If they killed the Old Gods, Azeroth would\'ve been destroyed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30579,'What protectors?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30580,'Aesir and Vanir... Okay, so the Forge o\' Wills started makin\' new earthen... but what happened to the old ones?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30581,'Hold everything! The Aesir and Vanir went to war? Why?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30582,'This \"Loken\" sounds like a nasty character. Glad we don\'t have to worry about the likes o\' him anymore. So... if I\'m understandin\' ye right, the original earthen eventually woke up from this stasis, and by that time the destabili-whatever had turned \'em into proper dwarves. Or at least... dwarf ancestors.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30583,'Well, now... that\'s a lot to digest. I\'m gonna need some time to take all this in. Thank ye.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30584,'I\'ll use the forge to make batches o\' earthen to stand guard... But our greatest challenge still remains: find and stop Loken!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30585,'','Hefting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30586,'STORMS GRANT ME POWER!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30587,'LIGHTNING GUIDE MY FURY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30588,'LET THE STORM\'S FURY CONSUME YOU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30589,'NO ESCAPE FOR THE WICKED!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30590,'AAARRRRRRGGGGGGHHHHHHH!! SUCH POWER!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30591,'THE LIGHTNING COURSES THROUGH ME!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30592,'IT IS THE WRATH OF THE STORM KING!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30593,'Delicious morsels have come to visit! Shall I use your bombs to cook you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30594,'','Be welcome amongst us, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(30595,'I will crush you under foot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30596,'I\'ll wipe you off of my boots later!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30597,'Tiny creatures, I trample you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30598,'Taste Gymer\'s size 600!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30599,'FREE!!! Soon you will feel the wrath of the storm king!','',0,0,0,0,0,0,0,0,1,7602,0,0,26124),
(30600,'WOW! I... I\'ve never seen anything like him! Give \'em hell, $n!','',0,0,0,0,0,0,0,0,1,7603,0,0,26124),
(30601,'The Scourge don\'t stand a chance!','',0,0,0,0,0,0,0,0,1,7603,0,0,26124),
(30602,'Burning','Burning',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30603,'','Accessing... Creators arrived to extirpate symbiotic infection. Assessment revealed that Old God infestation had grown malignant. Excising parasites would result in loss of host--',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30604,'','Correct. Creators neutralized parasitic threat and contained it within the host. Forge of Wills and other systems were instituted to create new earthen. Safeguards were implemented, and protectors were appointed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30605,'','Designations: Aesir and Vanir. Or in the common nomenclature, storm and earth giants. Sentinel Loken designated supreme. Dragon Aspects appointed to monitor evolution on Azeroth.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30606,'','Additional background is relevant to your query: following global combat between Aesir and Vanir--',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30607,'','Unknown. Data suggests that impetus for global combat originated with prime designate Loken, who neutralized all remaining Aesir and Vanir, affecting termination of conflict. Prime designate Loken then initiated stasis of several seed races, including earthen, giants and vrykul, at designated holding facilities.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30608,'','Essentially that is correct.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30609,'With my freedom comes the vengeance of storm!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(30610,'Listen to what I have to tell you about our enemy before we start. You don\'t want to be unprepared while we\'re out smashing Scourge in the field.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(30611,'Accessing prehistoric data... retrieved. In the beginning the earthen were created to--','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30612,'Accessing... In the early stages of it\'s development cycle, Azeroth suffered infection by parasitic necrophotic symbiotes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30613,'Designation: Old Gods. Old Gods rendered all systems, including earthen, defenseless in order to facilitate assimilation. This matrix destabilization has been termed \"the Curse of Flesh\". Effects of destabilization increased over time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30614,'Acknowledged, Branbronzan. Session terminated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30615,'Gymer, where are Algar, Navarius and Thrym?','Gymer, where are Algar, Navarius and Thrym?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30616,'Gymer, what do I need to know? I\'ve never ridden on a giant.','Gymer, what do I need to know? I\'ve never ridden on a giant.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30617,'I\'m ready, Gymer. Let\'s go!','I\'m ready, Gymer. Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30618,'<Brann looks at you expectantly.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30619,'Imagine all the wisdom and knowledge locked away within Ulduar. The very secrets of life could be held there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30620,'Greetings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30621,'Do you understand me? We should be able to understand each other now.','Do you understand me? We should be able to understand each other now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30622,'If the Explorers\' League sent men, I didn\'t see any trace of them. I found your note buried in a camp overrun by iron dwarves.','If the Explorers\' League sent men, I didn\'t see any trace of them. I found your note buried in a camp overrun by iron dwarves.',0,0,0,0,0,0,0,1,1,7605,0,0,26124),
(30623,'A scout found the remains of your journal in Thor Modan. We\'ve been looking for you ever since.','A scout found the remains of your journal in Thor Modan. We\'ve been looking for you ever since.',0,0,0,0,0,0,0,1,1,7605,0,0,26124),
(30624,'I... I can understand you now! Well, now that we can talk to each other, you have some explaining to do!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30625,'How did you get my communicator from the Explorers\' League?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30626,'You have my thanks for dispatching the iron dwarves. But why would the Horde have an interest in me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30627,'That wouldn\'t be Scout Vor\'takh, would it? Even I know of his reputation for ruthlessness. He means to abduct me, then?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30628,'If you\'ve seen the journal, then you know what I\'ve been discovering. The titans\' own creations are at war with each other!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30629,'Loken and his iron dwarf minions have ousted the Earthen from Ulduar and taken over the city.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30630,'If we spend our time and strength fighting with each other, Loken will use Ulduar\'s resources to destroy both Horde and Alliance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30631,'Speak to the commander at your post, $g lad:lass;, and persuade him to abandon Vor\'takh\'s foolish plan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30632,'Boktar thinks this crash an unfortunate event, but I believe we\'re intended to learn something from it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30633,'The Ymirjar battle lord, Algar the Chosen, rouses his Vargul armies at the Reliquary of Pain, northeast of this cage.$B$BPrince Navarius is across the Dead Fields, east of here, near the great steps leading up to the second level of Zul\'Drak.$B$BThrym\'s location is currently unknown, which is curious considering his size.$B$BAll must be dealt with!','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(30634,'I have a few more questions, Gymer.','I have a few more questions, Gymer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30635,'You\'re weak, old woman!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30636,'Hela take you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30637,'I will feast in the halls of Ymirheim tonight and you will pour my mead, cur.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30638,'The runes foretold victory for me today!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30639,'Getting tired? Hahahahaha!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30640,'You\'ll sleep in the underworld tonight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30641,'You\'ll wish you\'d never been awakened, boy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30642,'You complain much, like a shield-maiden!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30643,'Poison... my insides are churning...','Poison... my insides are churning...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30644,'I\'m ready - lets get you out of here.','I\'m ready - lets get you out of here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30645,'Let me know when you\'re ready. I\'d prefer sooner than later... what with the slowly dying from poison and all.','Let me know when you\'re ready. I\'d prefer sooner than later... what with the slowly dying from poison and all.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30646,'I\'m going to bring the venom sac to Ricket... and then... you know... collapse. Thank you for helping me!','I\'m going to bring the venom sac to Ricket... and then... you know... collapse. Thank you for helping me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30647,'We must strike at Jotunheim continuously. Never give them a chance to catch their breath, never a chance to sleep, and never accept surrender!$B$BTirion Fordring with all the might of Ashbringer and the Argent Crusade behind him cannot hope to accomplish what you are doing!$B$BNow, be quick about your business, $n. There is too much occurring for idle chit-chat.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(30648,'When you are ready I will place you atop my head and we will march into the heart of the Scourge in Zul\'Drak. You must direct me to smash and destroy our enemies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30649,'You have reached Rank 1: Recruit','You have reached Rank 1: Recruit',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30650,'You have reached Rank 1: Corporal','You have reached Rank 1: Corporal',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30651,'You have reached Rank 2: First Lieutenant','You have reached Rank 2: First Lieutenant',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30652,'Gymer needs storm cloud badly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30653,'Gymer is about to die! Find a storm cloud!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30654,'Ulduar\'s archives may hold the knowledge we need to stop Loken from using the city\'s resources against us. The problem is that the key to those archives was divided and hidden.$B$BI think I\'ve found out where one of the pieces is, in the Inventor\'s Library, which sits on the northern edge of the mountains northeast of you. The first thing you\'ll need to do is retrieve the fragments of an access disk from the library\'s guardians.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30655,'We\'re in over our heads, $r! Watch your back!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(30656,'MASTER! NO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30657,'THRYM CRUSH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30658,'Thrym... Av... Avenge me...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30659,'Oh, you freed him, did you? No matter, his death and reconstruction will only be slightly delayed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30660,'The Ebon Blade is indebted to you for your help in taking The Shadow Vault. We are lucky to have you.$B$BWhile the Alliance and the Horde fight each other, doing the Lich King\'s job for him, we will stay focused on the task at hand.$B$BWhere the Argent Crusade might falter and think twice about how best to crush the enemy, we will have no such moral difficulties.$B$BYou shall be our instrument of vengeance, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(30661,'','I will tear you limb from limb.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30662,'','You challenge?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30663,'','You don\'t look so tough.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30664,'','You think you have what it takes?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30665,'Let\'s do this, sister.','Let\'s do this, sister.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30666,'','Well met, Battle-Sister. I can assist you in recovering lost companions.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(30667,'','Well met, Battle-Sister. I can help stable your pets or assist you in recovering lost companions.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(30668,'Death Knights... get over here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30669,'','Come, Battle-Sister.$B$BFeast, sleep, so that you may fight with all your strength!',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(30670,'Defend the Temple with your life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30671,'Fight back the enemy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30672,'They\'re under the ground. They\'re under the ground!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30673,'This is our home!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30674,'The challenger has been defeated!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30675,'They went down like a sack of orc skulls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30676,'All that\'s left of the challenger is a red stain on the floor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30677,'Call in the clowns! It\'s turned into a circus in there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30678,'OOOF! That one\'s gonna require the \"scraper.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30679,'OUTTA NOWHERE -- WHAMO! DEAD!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30680,'Avert your eyes, ladies and gentlemen! It\'s a bloodbath!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30681,'The grand Amphitheater of Anguish awaits, $n. Remember, once a battle starts you have to stay in the arena. WIN OR DIE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30682,'Here we are once again, ladies and gentlemen. The epic struggle between life and death in the Amphitheater of Anguish! For this round we have $n versus the hulking jormungar, Yg... Yggd? Yggdoze? Who comes up with these names?! $n versus big worm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30683,'%s emerges!','',0,0,0,0,0,0,0,0,1,7613,0,0,26124),
(30684,'$n has defeated Yg... Yggg-really big worm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30685,'Prepare to make your stand, $n! Get in the Amphitheater and stand ready! Remember, you and your opponent must stay in the arena at all times or you will be disqualified!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30686,'The battle is about to begin! Am I reading this card right? It... It\'s the nefarious magnataur lord, STINKBEARD! Yes, folks, STINKBEARD! $n doesn\'t stand a chance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30687,'And with AUTHORITY, $n dominates the magnataur lord! Stinkbeard\'s clan is gonna miss him back home in the Dragonblight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30688,'Stinkbeard comin\' for you, little ones!','',0,0,0,0,0,0,0,0,1,7612,0,0,26124),
(30689,'I\'ll melt the flesh off your bones!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30690,'You think you can challenge me, little $r?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30691,'Your race has no honor. But come anyway... you\'ll die like all the others!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30692,'By Thorim\'s beard, this should be good sport!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30693,'Come then, $r $c, I do not have all day!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30694,'It will not get me any closer to proving myself at Valhalas to kill you, but it should be entertaining!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30695,'If you seek death, you have found it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30696,'A quick trip to the underworld for you, and a laugh for me. Sounds like a fair trade!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30697,'A Drakkari, one of the so-called Scarlet Onslaught, a gnome, a Hyldnir shield-maiden, and now you? Is this a joke?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30698,'Do you feel that folks? The air is crackling with energy! That can only mean one thing...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30699,'Coward!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30700,'Arise, brothers of the earth! Watch as Erathius destroys the mortals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30701,'For Neptulon! Strength of storm and sea, crush my enemies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30702,'Al\'Akir grant my enemies a cold, swift death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30703,'This battle must be seen to be believed! Once a mild-mannered tuskarr fisherman, our next fighter turned to the life of a soulless mercenary when his entire family was wiped out by a vicious pack of lion seals and ill-tempered penguins! Now he\'s just in it for the gold! Ladies and gentlemen, ORINOKO TUSKBREAKER!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30704,'Come, land-dwellers, face the fury of tusk and whisker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30705,'Korrak has come, weaklings! Snowfall belongs to Winterax! Erm, Korrak mean to say amphitheater belong to Winterax!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30706,'No graveyard here for you to play wicked games on Korrak! DIE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30707,'From the Savage Ledge of Icecrown, Vladof the Butcher and his mammoth, Enormos! There ain\'t gonna be a thing left of our challengers, folks! Prepare for a downpour of blood, guts and tears!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30708,'Yes, my precious, we will tear them apart! For the one true king!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30709,'Useless mongrel! I\'ll kill \'em myself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30710,'Vladof dismounts!','',0,0,0,0,0,0,0,0,1,7614,0,0,26124),
(30711,'What is this?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30712,'By order of Duke Lankral, Commander of the Knights of the Ebon Blade, Vanquisher of the Scourge and Conqueror of The Shadow Vault, you are ordered to stand down. What is your answer?','By order of Duke Lankral, Commander of the Knights of the Ebon Blade, Vanquisher of the Scourge and Conqueror of The Shadow Vault, you are ordered to stand down. What is your answer?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30713,'My answer? Here\'s my answer, little messenger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30714,'The champion of the Winterax trolls has challenged you, $n! I hope you\'re ready!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30715,'Hailing from the distant mountains of Alterac, one of the fiercest competitors this arena has ever seen: KORRAK THE BLOODRAGER!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30716,'I DON\'T BELIEVE IT! WE HAVE A NEW CHAMPION OF ANGUISH!!! Vladof the Butcher has been defeated by a ragtag crew of nobodies! Incredible finish!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30717,'%s gathers its mojo and surges forward!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30718,'$n is impaled!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30719,'If there\'s nothing else that you can do, kill these things!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30720,'Thank you. I thought I was doomed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30721,'I was certain I was going to die out here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30722,'Let me fight by your side.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30723,'Let us fight the irons together!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30724,'I can take care of myself, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30725,'Once a match starts there\'s two ways out: WIN OR DIE! Fleeing is not an option!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30726,'%s goes Berserk!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30727,'%s grows increasingly crazed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30728,'Thrall... Warchief... your armies await your command. Let me lead them to Northrend to remove this undead menace!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30729,'Gragh! I cannot take this! While you talk and deliberate, our enemies grow stronger! Were it my choice, I would have put all our available forces onto that frozen rock and conquered it for the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30730,'After all that he did for YOU and YOUR people? MAK\'GORA!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30731,'So you refuse? Is the son of Durotan a coward?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30732,'What say you, Saurfang?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30733,'My soul burns for revenge, but the elements tell me to think clearly. The Lich King is a ruthless opponent... one who must be handled carefully.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30734,'We will send scouts to assess the situation. I will also convene with the Lady Proudmoore and see what plans the Alliance has.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30735,'If this is a trap, it is one I will not blindly walk into! Do not make the same mistakes as your father, Garrosh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30736,'Warchief, it is clear that Northrend represents the gravest threat to our people, and that we must act against it. But this foe is unlike any other. Caution must be advised.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30737,'Warchief! Scourge forces are attacking Orgrimmar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30738,'Yes, Warchief?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30739,'As you command, Warchief!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30740,'Something stirs in the pool of mojo...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30741,'What are YOU doing here?$B$BJust make sure that you stay out of my way. I didn\'t leave the Scarlet Onslaught to be distracted by the likes of you!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(30742,'I challenge you to a duel, Scarlet scum!','I challenge you to a duel, Scarlet scum!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30743,'Wait, wait... I surrender! Please, no more! I\'ll leave!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30744,'Ha! Efrem the Faithful wins again. Of course!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30745,'Come, vrykul dogs. I will fight you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30746,'You dare to touch ME?! You won\'t keep me from proving myself to the Lich King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30747,'Why do you not face me? Are you afraid of Efrem the Faithful?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30748,'I am not possessed of infinite patience! I came here to prove myself, and that is exactly what I intend to do!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30749,'Fight me now, vrykul, or be labeled a coward!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30750,'','Taste my steel, little $g boy : girl;!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30751,'','Of course you lost. What did you expect?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30752,'','Do not bother me, pest. I am studying the inept fighting of these so-called combatants.$B$BI will best them all, and then I will be elevated to serve the Lich King.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30753,'I\'ve heard that vrykul women cannot fight at all. If you wish to prove me wrong, you can try.','I\'ve heard that vrykul women cannot fight at all. If you wish to prove me wrong, you can try.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30754,'You look like you could make us some money. How about a spin inside the Amphitheater of Anguish, pal?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(30755,'PUPS OF ORGRIMMAR!  HEAR ME, BRASH UPSTARTS OF THE HORDE!  TREMBLE, AND KNOW YOUR DOOM,  FOR THE LICH KING\'S GAZE IS FIXED UPON YOU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30756,'You\'re the champion now, buddy! Do you think you have what it takes to defend your title?','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(30757,'%s begins to cast Poison Nova!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30758,'This unit is busy. Please inquire later.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30759,'Go back to work before the overseer sees us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30760,'I\'m not a laborer. I\'m here to free you from servitude in the mines.','I\'m not a laborer. I\'m here to free you from servitude in the mines.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30761,'%s explodes into a pool of plague!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30762,'Free again? Keeper Mimir\'s work awaits.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30763,'Thank you, $r. I will join your struggle against the stormforged.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30764,'New directive: leave mine and return to Inventor\'s Library.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30765,'New directive: assist in the defeat of the iron dwarves.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30766,'Does not compute. Unit malfunctioning. Directive: shut down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30767,'I\'m the king of dirt, there is none higher! To my aid, minions - assist your sire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30768,'To burn my kingdom, you can\'t use fire! Come my servants, I am not ready to retire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30769,'I bring a gust so strong, it can knock down trees! Minions, assist me, they shall not do as they please!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30770,'I am the baddest of the bad, the coolest of the cool! To my side, my elements, let us freeze and rule!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30771,'Return to the Storm Peaks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30772,'You challenge me, boy? I don\'t have time for this....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30773,'Inside!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30774,'Let\'s finish this quickly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30775,'GYAH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30776,'We will finish this another time... son of Grom.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30777,'Saurfang...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30778,'Your duties as warchief can wait. For now... we fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30779,'Hah! So, son of Durotan, what--','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30780,'Well, Warchief? What say you now? Will you send me to Northrend?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30784,'Whisker! Where are you?! Assist me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30785,'Marshal our forces. Contact our goblin shipwrights. The Horde prepares for war!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30786,'','Yes, Thrall. The time has come to kill Arthas. You can take my grand apothecary with you. His knowledge will be invaluable against whatever the Scourge will throw at you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30787,'','Excellent... most excellent.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30788,'It would be an honor, Dark Lady.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30789,'','These are sacred halls! Your intrusion will be met with death!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30791,'%s begins to spin, encased in a magical shield!','',0,0,0,0,0,0,0,0,1,7614,0,0,26124),
(30792,'This likeness of the Horn of Hodir stands in memorial of King Arngrim and all others lost in the battle of Thunderfall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30793,'Curse you!  You will not treat me like a beast!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30794,'Enough!  I will teach you some manners, wench!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30795,'I\'d rather die fighting than live like a slave!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30796,'Back... to work...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30797,'You treat us worse than animals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30798,'We will have revenge... some day.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30799,'I\'m not looking to cause trouble, but if things don\'t change around here, you\'re going to have an insurrection on your hands.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30800,'I\'d be careful if I were you, Hyldnir.  We\'re not afraid to lose a few men if it means smashing your pretty blue faces in.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30801,'This is just a warning, wench.  You strike one of us again and we\'ll kill you in your sleep.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30802,'Get them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30803,'Thank you, thank you!  Time to get away from these crazy blue women!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30804,'What can I do for you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30805,'','This puny green pup was of no use at the mines.  No matter, he\'ll make for suitable warmup for battle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30806,'Skip the warmup, sister... or are you too scared to face someone your own size?','Skip the warmup, sister... or are you too scared to face someone your own size?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30807,'','I\'m not afraid of anything -- bring it on!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30808,'','May the best win!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30809,'','Good luck...  You\'ll need it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30810,'','You will not defeat me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30811,'','You\'re not worthy of Thorim!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30812,'Oh no!  $n is looking hurt!','Oh no!  $n is looking hurt!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30813,'Come on $n!  I\'ve got good money riding on you!','Come on $n!  I\'ve got good money riding on you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30814,'Come on $n!  You can do it!','Come on $n!  You can do it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30815,'Don\'t show \'em any mercy $n!','Don\'t show \'em any mercy $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30816,'$n!','$n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30817,'Do it, $n!','Do it, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30818,'Rip \'em apart, $n!','Rip \'em apart, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30819,'Pull it together, $n!','Pull it together, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30820,'Come on, $n!  Don\'t let me down!','Come on, $n!  Don\'t let me down!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30821,'','You fight well, little one. I am bested for now. We will meet again I assure you. When we do I will be better prepared!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30822,'','Grrrrrrrr! I\'ll kneecap ya!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30823,'','Are you here to prove yourself to the Lich King as well?$B$BIt\'s kind of archaic, don\'t you think? Having to fight and survive?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30824,'','Hey, I recognize you! I guess I have you to thanks for me being here. That teleport accident was the best thing that ever happened to me.$B$BIf you find yourself back in Borean Tundra, let my goody two-shoes nerd of a duplicate know that I\'ve moved up in the world quite a bit!',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(30825,'Sorry, Tinky, but I can\'t afford you as a distraction while I\'m doing what needs to be done here.','Sorry, Tinky, but I can\'t afford you as a distraction while I\'m doing what needs to be done here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30826,'','YOU\'RE NO FUN!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30827,'','Who\'s the bigshot now, huh?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30828,'','WHEE!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30829,'Snacks for sale!','Snacks for sale!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30830,'Snacks!','Snacks!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30831,'Get your snacks here!','Get your snacks here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30832,'Snacks!  Get your snacks here!','Snacks!  Get your snacks here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30833,'Popcorn!  Get your popcorn!','Popcorn!  Get your popcorn!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30834,'Peanuts!  Get your peanuts here!','Peanuts!  Get your peanuts here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30835,'Anguish Ale!  Cold Anguish Ale here!','Anguish Ale!  Cold Anguish Ale here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30836,'Popcorn!  Peanuts!  Ale!','Popcorn!  Peanuts!  Ale!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30837,'Fjorn\'s Anvil now stands prominently in Dun Niffelem as a symbol of their victory over Fjorn and his armies.$b$bYou can\'t help but smile, knowing that your actions have had such a lasting impact on the world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30838,'It\'s an honor to share the battlefiend with you, my liege.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30839,'All hail King Stormheart!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30840,'Haven\'t seen a battle like this since the Frost Giants!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30841,'We\'ll keep\'m busy, sir!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30842,'They\'ll learn to fear the Stormriders this day!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30843,'The training you gave us is paying off, sire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30844,'It\'s good to be in the thick of it again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30845,'You\'re the strongest of us - show\'m how it\'s done, my king!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30846,'','I no longer train Death Knights, having grown weary of cretinous Initiates and their constant questions.$B$BNow begone.',274,0,0,1,0,0,0,0,1,0,0,0,26124),
(30847,'Metallic specimen of foreign origin detected.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30848,'Beginning analysis ...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30849,'Specimen identified as an alloy of saronite and iron.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30850,'The ore used in this sample originated deep within the crust of Azeroth and was recently unearthed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30851,'The saronite in this sample is nearly pure. Ores like this do not occur naturally on the surface of Azeroth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30852,'Onu\'zun is defeated by the ugliest person ever!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30853,'Onu\'zun go now. You\'ll miss me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30854,'This ore can only have been created by a powerful, malevolent force. Attempting to access databanks for more information ...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30855,'Onu\'zun is number one! You are number two!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30856,'Onu\'zun gonna kill you dead!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30857,'Onu\'zun here to challenge the vrykul and work himself up in the ranks.$B$BThen when Onu\'zun fight in Valhalas and win, Onu\'zun gonna be workin\' for the Lich King!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(30858,'I have bad news for you Onu\'zun: I\'m gonna have to cut short your dreams!','I have bad news for you Onu\'zun: I\'m gonna have to cut short your dreams!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30859,'Access denied?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30860,'Further information can only be accessed from the archives within Ulduar, by order of Keeper Loken.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30861,'Directive completed. Returning to standby mode.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30862,'','Who among you is devoted?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30863,'I give myself to the master!','I give myself to the master!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30864,'How may I help you?','How may I help you?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(30865,'Greetings, $n. This is the workshop of Keeper Mimir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30866,'I found this strange armor plate. Can you tell me more about it?','I found this strange armor plate. Can you tell me more about it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30867,'But one thing is for certain: this plate\'s size, thickness, and bolt holes point to a use as armor for a colossal structure.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30868,'No more ale for you $n.','No more ale for you $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30869,'You\'ve been cut off, $n.  No more ale for you.','You\'ve been cut off, $n.  No more ale for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30870,'I think you\'ve had enough ale, $n.','I think you\'ve had enough ale, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30871,'Sorry, $n, you\'ve had enough ale for now.','Sorry, $n, you\'ve had enough ale for now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30872,'Sorry, $n, we can\'t serve you anymore ale.','Sorry, $n, we can\'t serve you anymore ale.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30873,'I\'ve lost my Scepter of Celebras.','I\'ve lost my Scepter of Celebras.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30874,'You have my thanks. I\'m going back to The Shadow Vault now.','You have my thanks. I\'m going back to The Shadow Vault now.',0,0,0,0,0,0,0,0,1,7659,0,0,26124),
(30875,'I\'ve tarried too long here. I must get back to The Shadow Vault. Farewell.','I\'ve tarried too long here. I must get back to The Shadow Vault. Farewell.',0,0,0,0,0,0,0,0,1,7659,0,0,26124),
(30876,'I will see you back at The Shadow Vault.','I will see you back at The Shadow Vault.',0,0,0,0,0,0,0,0,1,7659,0,0,26124),
(30877,'That\'s enough for me. I\'m heading back now.','That\'s enough for me. I\'m heading back now.',0,0,0,0,0,0,0,0,1,7659,0,0,26124),
(30878,'I\'d love to stay and kill vrykul with you all day, but I\'m sure the baron will be wondering where I am.','I\'d love to stay and kill vrykul with you all day, but I\'m sure the baron will be wondering where I am.',0,0,0,0,0,0,0,0,1,7659,0,0,26124),
(30879,'I have to go. You stay and kill more of these ugly mongrels.','I have to go. You stay and kill more of these ugly mongrels.',0,0,0,0,0,0,0,0,1,7659,0,0,26124),
(30880,'Time to go. Don\'t let them capture you or they\'ll put you in the stew!','Time to go. Don\'t let them capture you or they\'ll put you in the stew!',0,0,0,0,0,0,0,0,1,7659,0,0,26124),
(30881,'I\'m heading back now. I\'ll let the baron know that you liberated me.','I\'m heading back now. I\'ll let the baron know that you liberated me.',0,0,0,0,0,0,0,0,1,7659,0,0,26124),
(30882,'Hey you! There are keys on the vrykul. Kill them, get a key and come over here to let me out of this damned cage!','Hey you! There are keys on the vrykul. Kill them, get a key and come over here to let me out of this damned cage!',0,0,0,0,0,0,0,0,1,7659,0,0,26124),
(30883,'It gets the key. It comes here. It opens the lock.','It gets the key. It comes here. It opens the lock.',0,0,0,0,0,0,0,0,1,7659,0,0,26124),
(30884,'Think you could bust me out of this cage?','Think you could bust me out of this cage?',0,0,0,0,0,0,0,0,1,7659,0,0,26124),
(30885,'Good thing I don\'t really feel the cold.','Good thing I don\'t really feel the cold.',0,0,0,0,0,0,0,0,1,7659,0,0,26124),
(30886,'I\'m over here in this cage. You can\'t miss it!','I\'m over here in this cage. You can\'t miss it!',0,0,0,0,0,0,0,0,1,7659,0,0,26124),
(30887,'Let me out and we\'ll fight side-by-side. The slaughter will be glorious!','Let me out and we\'ll fight side-by-side. The slaughter will be glorious!',0,0,0,0,0,0,0,0,1,7659,0,0,26124),
(30888,'Were you sent by Baron Sliver to get me out of this cage? Finally. Hurry up!','Were you sent by Baron Sliver to get me out of this cage? Finally. Hurry up!',0,0,0,0,0,0,0,0,1,7659,0,0,26124),
(30889,'When you get me out of this cage, we\'re going to make them wish they were never awakened!','When you get me out of this cage, we\'re going to make them wish they were never awakened!',0,0,0,0,0,0,0,0,1,7659,0,0,26124),
(30890,'Dun worry about me $G lad:lass;. I\'ve thought for a long time that age would claim me... I\'m glad I was wrong. Dun let these iron dwarves find what they\'re looking for.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30891,'At last, the tyranny of the stormforged is at its end!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30892,'Stormforged dwarves pour out of the broken corpse!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30893,'No more will your minions assail the creatures of stone and their allies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30894,'I am your doom, Valduran!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30895,'How predictable! But then, who would expect a rock to think like anything other than one?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30896,'If you\'re so eager to fight, I\'ll oblige you. But know that nothing you do here can prevent the completion of the iron colossus!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30897,'I had it all, once. Fame, fortune, a full set of the very best gladiator\'s gear... and then I threw it all away.$B$BOnce the Cartel caught me rigging fights... trading wins... it was all over.$B$BNow I\'ve got nothing but these rags and a bad liver.','',1,18,0,0,4,0,0,0,1,0,0,0,26124),
(30898,'Let\'s do this.','Let\'s do this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30899,'Thanks. How can I help?','Thanks. How can I help?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30900,'I can fight by your side for a few minutes before I need to return to The Shadow Vault.','I can fight by your side for a few minutes before I need to return to The Shadow Vault.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30901,'Thank you, $c. I owe you.','Thank you, $c. I owe you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30902,'Excellent. Let\'s kill some vrykul!','Excellent. Let\'s kill some vrykul!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30903,'It\'s time for revenge!','It\'s time for revenge!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30904,'Where\'s my damned helmet? Well, at least they left my sword here. Idiots.','Where\'s my damned helmet? Well, at least they left my sword here. Idiots.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30905,'Kill!','Kill!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30906,'Sons of Hodir! I humbly present to you....','Sons of Hodir! I humbly present to you....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30907,'The Helm of Hodir!','The Helm of Hodir!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30908,'Who are you?$B$BGo away... I\'m exhausted from working so hard on the Harbor Road. It\'s time to drink some dwarven ale, have a good cry, and take a nap.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30909,'The worg sprints off in search of enemies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30910,'Without hesitation, the ethereal worg sets off into the valley.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30911,'The worg hesitates for a moment, then changes direction.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30912,'After a moment\'s pause, the worg resumes the hunt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30913,'Clearly on to something, the worg bares its fangs and follows the scent.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30914,'The worg growls as it closes in on its prey.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30915,'The frostworg howls, exposing its prey!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30916,'Found me, did ya? Now ya gotta die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30917,'Die, friend of the frost!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30918,'You won\'t live to speak of this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30919,'','Once, I had a home in the lush woods of Quel\'Thalas. Once, I had a family, a husband... children. Once, I was alive and one with the world. The Lich King took all of that away from me in the blink of an eye.$B$BThough I have not the power to strike at him directly, I will pay him back threefold!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(30920,'The Horde needs you! Beat back the Lich King\'s forces!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30921,'It was only a matter of time before we would have to deal with the Lich King. He represents a threat to all of Azeroth, not just the humans.$B$BBut, the decision to go to war is one that must not be made lightly. We would be fools to rush into Northrend. The Lich King has surely anticipated such an action.$B$BOur options must be weighed carefully. Our armies are mightier than ever, but a tactically unsound decision could ruin us.$B$BIf only Garrosh understood....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30922,'Since the founding of Orgrimmar, many trials have tested the Horde, but we have risen up and beaten back any who\'d seek to destroy us!$B$BBut this... this is something that even my power cannot defeat. It pains me deeply to watch my people suffer from this plague. I must rely on the Forsaken for their assistance.$B$BThe Lich King will hear the approaching war drums of the Horde, but not yet. First, we must help our people before exacting our revenge on the Scourge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30923,'A true warrior does not stop in a battle to talk with his allies! Send these monstrosities back to their graves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30924,'My arms grow restless, anxiously waiting to drive my axes into the skull of the Lich King. Thrall would have us wait and let the Scourge continue to grow in strength. I will not have this!$B$BIf we are to end the threat of the Lich King, we must sail to Northrend and give him the full might of the Horde! Our forces are ready and willing to exact revenge for the deaths wrought by the plague and invasion.$B$BThe time to strike is now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30925,'I never believed Thrall until I saw it with my own eyes. Orcs... free of demonic corruption! Proud and honorable warriors making their place on this unbroken planet.$B$BEager am I to prove myself to Thrall and the Horde. My father never had to deal with this undead menace you call the Lich King, but by all descriptions he represents a dire threat to the Horde.$B$BI will implore Thrall to let me lead his finest warriors into Northrend and destroy the Lich King! But this plague takes precedent.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30926,'You there! Why are you not fighting? Kill these Scourge horrors before they do more damage to Orgrimmar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30927,'I understand Garrosh\'s desires. The urge for battle is strong within every orc, especially against a foe that has killed our people. But, the warchief has proven time and again that strategy is as important as strength in a battle.$B$BWe will set out when the time is right. We are no longer a band of mindless, demon-manipulated savages. This is the new Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30928,'We face an enemy we cannot kill through traditional means. The Lich King\'s plague is a force that no healer within our ranks has been able to deter. The Forsaken and their alchemists are the only hope we have, much to my disgust.$B$BIf we live through this, I promise you that the Horde will go to Northrend and bring the Lich King and his armies to their knees!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30929,'','I\'d choose your next words carefully if you value your life.$B$BSilence? How wise. Now destroy the Scourge!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30930,'','I can feel Thrall\'s anger at Arthas, but it pales before my own. Were he as furious as any one of the Forsaken, the Horde\'s armies would unleash their rage upon Northrend and eradicate all Scourge from that cursed, frozen wasteland.$B$BBut I do not lead the Horde, and cannot give the command for war. Thrall wishes to weigh his options, despite this being a time of action. Still, our time will come... very soon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30931,'','Everything I am, I owe to Arthas. I savor the moment when I can repay him for this torment.$B$BI have longed for the time when the Forsaken could take the fight against the Scourge to Northrend, but we need the rest of the Horde\'s support. Our numbers are not great unless bolstered by the other races in our alliance.$B$BArthas\'s latest attack on the Horde will hopefully convince Thrall to declare war on Icecrown. He\'ll have my support when that happens.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30932,'Do you know who I am?! I\'m a very important person! You\'re supposed to be protecting me from the Scourge, not dilly-dallying with pointless conversation!$B$BI\'m no fighter, but you are. So get out there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30933,'<Putress looks you over in a very unsettling fashion.>$B$BAren\'t you a remarkable specimen....$B$BHave you considered making a sacrifice for the greater good?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30934,'What a landmark discovery! The Royal Apothecary Society has spent years working to break the secrets of the Lich King\'s plague, and I\'ve finally done it!$B$BDespite this turning point in history, there is still so much to discover. I have more experiments to conduct... test subjects to acquire...$B$BAt least I don\'t have to worry about Scourge necropoli. The Alliance is dealing with that problem. This leaves me plenty of time to delve into the secrets of the plague and uncover what I can.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30935,'It is an honor to work alongside Grand Apothecary Putress. His work has saved the world from the Lich King\'s plague and has given new hope to our cause.','It is an honor to work alongside Grand Apothecary Putress. His work has saved the world from the Lich King\'s plague and has given new hope to our cause.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30936,'Where there are frostborn, there are eagles. They\'ve been our allies for longer than I\'ve walked the land... and I\'m not exactly young anymore, $G laddy:lass;.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30937,'King Stormheart sent me to be tested as a frostborn would.  I am ready for my test, Fjorlin.','King Stormheart sent me to be tested as a frostborn would.  I am ready for my test, Fjorlin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30938,'The Sunken Ring siege workshop has been captured by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30939,'The Broken Temple siege workshop has been captured by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30940,'The Sunken Ring siege workshop has been captured by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30941,'The Broken Temple siege workshop has been captured by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30942,'King Stormheart is putting you to the test, eh?  He must see something in you to begin with or I doubt he\'d put you through such a sacred ritual.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30943,'I know you\'re new to our kind, so I\'ll catch you up a bit while we\'re on our way over.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30944,'Years back, my father and several other frostborn were returning from a trek across Dragonblight. There was a heavy blizzard... far worse than we\'ve ever seen since.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30945,'They crossed a trail of blood-soaked snow and followed it to find a dwarf wandering and speaking in a dialect they couldn\'t make out... and not a dwarf of our kind mind you, but a mountain dwarf - something our kind had never seen before.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30946,'The dwarf seemed lost, having no memory of where he came from, or even of his own name. Not being the kind to leave a dwarven cousin to die in the snow, my father\'s party took him in and continued back towards Frosthold.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30947,'Not long later, out of nowhere, the snow burst before them and a jormungar the size of Veranus herself came down upon their party... one of them was swallowed whole before they even had time to react.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30948,'My father thought they were all doomed... but behind him, a furious roar rumbled across the snow, and he turned to see the mountain dwarf growing in size, his skin taking on a stone-like texture, and his hands sizzling with lightning.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30949,'The dwarf barreled forward with a sound like rolling thunder and hurled a shining metal hammer, lightning coursing over its surface, directly into the jormungar\'s throat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30950,'The jormungar collapsed instantly, its head barely still attached to its convulsing body.  My father turned to the dwarf in awe and raised a fist in praise...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30951,'What can I do for you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30952,'The stranger having no name of his own, my father deemed \"Yorg,\" a name reserved for champions of legend. Years later, he now stands before us as Yorg Stormheart, King of the Frostborn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30953,'King Stormheart has trained us well... turned us into even more fearsome warriors than we could have boasted during the time of our war with the Frost Giants.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30954,'How you be doin\' mon?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30955,'And as one of the fiercest tests put upon a warrior of the frostborn, we are made to face a creature far larger than ourselves--giants, dragons, jormungar--as a testament to the fact that size will never be our weakness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30956,'This is the test put before you this day. Return to us only once The Iron Watcher is dead, and be revered as a warrior of the frostborn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30957,'Retrain me in Gem Perfection','Retrain me in Gem Perfection',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30958,'How may I serve you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30959,'What do you want?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30960,'The Battle for Lake Wintergrasp is about to begin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30961,'Let the battle begin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30962,'WotLK - Stormwind Harbor Captain','WotLK - Stormwind Harbor Captain',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30963,'WotLK - Request Defender','WotLK - Request Defender',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30964,'Creaking echoes off of the nearby structures as the Iron Watcher comes to life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30965,'As the hammer lands, more rust shakes free from the Iron Watcher\'s frame and its pace quickens.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30966,'The Iron Giant shudders slightly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30967,'The Iron Watcher roars with fury, shaking more rust from its ancient frame.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30968,'The Iron Giant shudders slightly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30969,'The Iron Watcher reels, reaching to its now useless eyes, and charges blindly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30970,'The Iron Watcher loses its footing under the furious blow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30972,'You didn\'t think that I was going to let you walk in here and take the Heart of the Storm, did you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30973,'You may have killed Valduran, but that will not stop me from completing the colossus.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30974,'You are welcome here, as a friend and ally of the earthen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30975,'Over here $G laddy:lass;, I have something I could use a hand with.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30976,'Might grace you, $c. Let the Scourge feel the fury of a million lost souls!','Might grace you, $c. Let the Scourge feel the fury of a million lost souls!',0,0,0,0,0,0,0,0,1,7665,0,0,26124),
(30977,'Glory and strength to you, $c. I bless you with all the strength left in me. May this nightmare soon end!','Glory and strength to you, $c. I bless you with all the strength left in me. May this nightmare soon end!',0,0,0,0,0,0,0,0,1,7665,0,0,26124),
(30978,'Wisdom of the ages upon you, noble $c.','Wisdom of the ages upon you, noble $c.',0,0,0,0,0,0,0,0,1,7665,0,0,26124),
(30980,'Thank you and farewell, friend. I must return to the Argent Vanguard.','Thank you and farewell, friend. I must return to the Argent Vanguard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30981,'You are permitted to visit our stronghold, little $r.$b$bDo not bring us dishonor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30982,'If it please you, King Jokkum, may I know what has become of Krolmir?','If it please you, King Jokkum, may I know what has become of Krolmir?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30983,'I do not trust you enough to speak of such things.$b$bYou must respect the trials our people have endured, the burdens we have borne...$b$bPerhaps, if you were to bring great honor to Dun Niffelem, I would be inclined to share with you the knowledge of our people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30984,'Very well, little $c.$b$bWhile there is much left for you to do to mend our relations with Thorim, I am compelled to share with you this one secret.$b$bSpeak to me again when you are ready to be shown that which you seek.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30985,'I am ready to be shown the fate of Krolmir.','I am ready to be shown the fate of Krolmir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30986,'This bear\'s flank is frozen solid.... try again.','This bear\'s flank is frozen solid.... try again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30987,'Hail! I hate to rush you, but there\'s an army of iron dwarves here to stop whatever you and Creteus are trying to do... we need to get out of here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30988,'King Stormheart caught wind of the iron dwarves heading this way and brought all the best warriors he could muster on such short notice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30989,'Quickly, Creteus is to the west. King Stormheart is holding them off, but they have the advantage of numbers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30990,'By the watchers, look at him fight. I\'ve never seen a more vicious warrior... I\'m glad to call him my king.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30991,'We\'ll hold them off as long as we can. Do whatever you need to do quickly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30992,'You there! $C! These men are dying! I need your assistance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30993,'Don\'t just stand around $g boy:girl;! The Crusade needs your help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30994,'What in the world are you doing? There are people dying all around you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30995,'Friend, wipe the drool off of your chin and come lend me a hand!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30996,'Blessed Light! They are all dying!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30997,'I have no interest in buying anything that you are here to sell me, friend!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30998,'Did you think that you would be spared the sight of bloodshed and terror?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(30999,'My slack-jawed compatriot, the time to act is now! Pull yourself together and lend me a hand!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31000,'Hold on, little $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31001,'King Jokkum, you have summoned me?','',0,0,0,0,0,0,0,0,1,8056,0,0,26124),
(31002,'The noble deeds of your $r $c servant defy $g his:her; stature, Stormlord. $g His:her; efforts have succeeded in softening the hearts of my people.','',0,0,0,0,0,0,0,0,1,8056,0,0,26124),
(31003,'Jokkum, son of Arngrim, I have always regretted my actions here. In my grief, I brought great harm to those closest to me.','',0,0,0,0,0,0,0,0,1,8056,0,0,26124),
(31004,'The Lich King reacted swiftly to the breach. Faster than I anticipated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31005,'You are dealing with a being that holds within it the consciousness of the most cunning, intelligent, and ruthless individuals to ever live.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31006,'The Lich King is unlike any foe that you have ever faced, Highlord. Though you bested him upon the holy ground of Light\'s Hope Chapel, you tread now upon his domain.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31007,'You cannot win. Not like this...\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31008,'What would you have me do, Darion?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31009,'Nothing. There is nothing that you can do while the Light binds you. It controls you wholly, shackling you to the ground with its virtues.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31010,'Choose your words wisely, death knight. You stand amidst the company of the devoted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31011,'%s shakes his head.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31012,'Look upon the field, Highlord. The Lich King has halted your advance completely and won the upper hand!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31013,'The breach you created was sealed with Nerubian webbing almost as quickly as it was opened.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31014,'Your soldiers are being used as living shields to stave off artillery fire in the Valley of Echoes, allowing the forces of the Lich King to assault your base without impediment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31015,'The Lich King knows your boundaries, Highlord. He knows that you will not fire on your own men. Do you not understand? He has no boundaries. No rules to abide. \n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31016,'We will do this with honor, Darion. We will not sink to the levels of the Scourge to be victorious. To do so would make us no better than the monster that we fight to destroy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31017,'Then you have lost, Highlord.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31018,'Thorim! Come, show yourself!','',0,0,0,0,0,0,0,0,1,8056,0,0,26124),
(31019,'','%s is affected by Widow\'s Embrace!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31020,'Long ago, when the North Wind ruled these peaks alone, a powerful taunka chieftain\'s brother coveted these lands for himself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31021,'The chieftain\'s brother, Stormhoof, gathered all his strength and set out to conquer the Storm Peaks from its rightful ruler, the North Wind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31022,'Stormhoof ambushed the North Wind in the heart of its domain, and nearly succeeded in his plot. But the North Wind survived Stormhoof\'s treachery and executed the taunka as punishment for his invasion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31023,'I can\'t thank you enough for all of your help in putting together the keystone. Great things will come of this, I assure you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31024,'Iron dwarves... everywhere.... they\'re making their way down from the top. They certainly are persistent.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31025,'They\'re trying to take down the plane! I can\'t pull up any steeper... you need to keep them off of us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31026,'There are more up ahead - keep at it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31027,'We\'re almost out... just a little bit farther.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31028,'Barring stray boulders from those giants, we should be clear... it seems a mess down there though.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31029,'Their numbers are unbelievable... I\'m glad to hear King Stormheart came to your aid. I only hear good things of him - I think it\'s high time we meet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31030,'Poor Creteus. He was a good keeper... I\'m glad he at least got to see his task to completion, I imagine that\'s all that really mattered to him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31031,'We\'re coming up on Frosthold. I would be very appreciative if you would introduce me to King Stormheart before you go. I believe we are both very much in his debt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31032,'By all the gods... it can\'t be... Muradin?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31033,'Come on boy, there\'s no mistak\'n it - it\'s definitely you. Don\'t ya recognize your younger brother?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31034,'I can\'t believe this! You were dead! All accounts said so... what happened, Muradin. How did you get here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31035,'Indeed! Magni will be so happy to see you too! He\'s gotten nothing but bad news for a long while now, but this changes everything!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31036,'He\'s here in Northrend brother, looking for you. A seer in Wintergarde brought word that you were not dead, and he left Ironforge immediately to come find you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31037,'What\'s that? You talkin\' to me, lad?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31038,'My brother... yes... I do have brothers...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31039,'Muradin clutches his head and reels for a moment as the memories rush back to him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31040,'...Brann?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31041,'This isn\'t right at all, $n. In the tale Wind Tamer Barah told me, Stormhoof was a hero, not a villain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31042,'I... I dun know, Brann. I\'ve been \'ere a long time... all I \'ave of me life before this place are flashes and nightmares.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31043,'It\'s good te see you though, brother. More than words can say.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31044,'The North Wind is the ancient enemy of the taunka, a ruler among the elements, and the very force which bleeds the life from these ancient people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31045,'Magni! Forgive me, the memories are comin\' back slowly, brother.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31046,'They would rather die than bow before the North Wind. Something is amiss here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31048,'The frostborn have been very good to me. They\'re strong people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31049,'The Lorehammer...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31050,'It confirms our suspicions. The threads of time have been severed and rewoven in the wrong pattern. But, how?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31051,'The deeds of your $r servant defy $g his:her; stature, Stormlord. $g His:Her; efforts have succeeded in softening the hearts of my people.','',0,0,0,0,0,0,0,0,1,8056,0,0,26124),
(31052,'Never have such humble words come from mighty Thorim. I shall deliver your words to Dun Niffelem.','',0,0,0,0,0,0,0,0,1,8056,0,0,26124),
(31053,'The events of that dark day are hereby forgiven by my people.  They shall never again be spoken of.','',0,0,0,0,0,0,0,0,1,8056,0,0,26124),
(31054,'To signify our reforged friendship, I have something which belongs to you...','',0,0,0,0,0,0,0,0,1,8056,0,0,26124),
(31055,'I\'d like to build a demolisher.','I\'d like to build a demolisher.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31056,'Hello, $r. How can I help you today?','Hello, $r. How can I help you today?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31057,'As the great explosion filled the region, my father cast a rune at the great hammer that it might not be had by our enemies. It was his final act...','',0,0,0,0,0,0,0,0,1,8056,0,0,26124),
(31058,'I\'d like to build a catapult.','I\'d like to build a catapult.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31059,'We welcome the opportunity to fight by your side, mighty Thorim.','',0,0,0,0,0,0,0,0,1,8056,0,0,26124),
(31060,'I must return to Dun Niffilem. We shall speak again soon, Stormlord.','',0,0,0,0,0,0,0,0,1,8056,0,0,26124),
(31061,'I\'d like to build a siege engine.','I\'d like to build a siege engine.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31062,'I would ask your forgiveness for the suffering I have caused you and your people.','',0,0,0,0,0,0,0,0,1,8056,0,0,26124),
(31063,'Krolmir... I thank you Jokkum. I hadn\'t dared hope it still existed. It shall soon see glorious battle once again!','',0,0,0,0,0,0,0,0,1,8056,0,0,26124),
(31064,'I\'d like to build a fighter jet.','I\'d like to build a fighter jet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31065,'What\'s on yer mind, lad?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31066,'Sorry, friend. Only certified officers of the Horde can authorize the purchase of a vehicle.','Sorry, friend. Only certified officers of the Horde can authorize the purchase of a vehicle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31067,'I\'d like to build a bomber.','I\'d like to build a bomber.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31068,'I\'d like to build a shredder.','I\'d like to build a shredder.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31069,'We lost a lot a good people today, laddy. The Lich King is gonna pay for all the lives he\'s ruined!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31070,'Eversong Woods, Dalfors. I\'m thinking about how beautiful it was before Arthas cut a swathe of death through it...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31071,'The end, Dalfors. I\'m thinking about how close we are to seeing an end to the Scourge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31072,'How did they react so fast, Dalfors? Our plan was perfect. I just don\'t understand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31073,'The wounds will heal, child.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31074,'That he is, Dalfors...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31075,'I have no doubt of that, Dalfors, but will we be alive to see it happen?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31076,'All the lives he has taken... Such misery and pain inflicted on the innocent. And for what?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31077,'Some injuries never heal, noble dwarf. A broken soul cannot be fixed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31078,'It is time I put an end to my brother\'s madness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31079,'Loken!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31080,'Stand up and fight me, you worthless traitor!  ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31081,'Good to see ya again!$B$BKing Stormheart has informed me that he will be taking his leave for a time... a grim memory brought back to him has left him with a score to settle it seems. He was very insistent that we not join him, so we have respected his wishes as we always do.$B$BI have taken responsibility for our clan in the meantime. You are still welcome with us, of course.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31082,'You seem eager to join your beloved Sif, brother.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31083,'Do not dare...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31084,'Look Lagnus, I consider you a capable man, but my patience is wearing thin. I know that Muradin is here, can you point me to him or not?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31085,'Brother! There you are! I can barely believe my eyes... you\'re alive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31086,'It\'s so good to see you again, Muradin. And what\'s this I heard about you being a King in your own right now? The Bronzebeards were always destined to greatness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31087,'Speaking of which...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31088,'So it seems! And you haven\'t lost any muscle yourself. Do you remember anything of what happened, Muradin? Fate has turned ill in your absence.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31089,'Not much, Magni. I\'ve had nightmares of a human... tall... light hair... death black armor. His name rests on the tip of me tongue, but...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31090,'The doctor entrusted me with the plans to Nergeld, our flesh giant amalgamation made entirely of vargul! It will be the most powerful creation of its kind and a whole legion of them will be created to destroy your pitiful forces!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31091,'...Arthas.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31092,'Magni nods.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31093,'He\'s not the boy of your memories anymore, Muradin. He\'s become something else entirely.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31094,'Aye, I know. I watched him turn... I watched him give up all that was right and I didn\'t lift a hand... I didn\'t even consider it until it was too late.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31095,'I will never give you the information you seek!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31096,'That\'s in the past, Muradin. Regrets won\'t change anything.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31097,'No... no they won\'t. But I can make this right... I have te. I\'m goin\' after the boy. I\'ll make\'m answer for everything he\'s done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31098,'You waste my time. I will tell you nothing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31099,'Are you sure Muradin? I just got you back after years of thinking you were dead. I do not want to lose you again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31100,'I\'m sure, Magni. I\'ll see this through, don\'t ya worry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31101,'So be it then. I have to return to my people, brothers. Come back to me in one piece.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31102,'Aye, be safe Muradin. I\'d join you, but I\'m on top of the most amazing discovery the world has yet seen. I can\'t abandon it now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31103,'Go Brann. Bring me back an epic tale when we meet again. Farewell for now, brothers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31104,'I\'ll kill you little one and then I will add your body parts to what we\'re creating!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31105,'I will not let you destroy our hard work! Nergeld will be the end of you all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31106,'When the doctor returns, your pitiful Shadow Vault will be laid to waste.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31107,'Nergeld is only the first of a new army of vargul-powered flesh giants. You\'ve not known fear until now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31108,'I have no time for this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31109,'You\'re too late, puny one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31110,'Looks like you can still best me in a fair fight, little brother.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31111,'Unfortunately for you.... this fight is anything but fair!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31112,'Thanks to your little friend, you\'ve left the Temple of Storms, where you were at your strongest.  Instead we fight closer to my master\'s power.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31113,'Get me out of here, friend!','Get me out of here, friend!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31114,'Thank you, friend, but we\'re not out of trouble yet!','Thank you, friend, but we\'re not out of trouble yet!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31115,'Let\'s get out of here! Quickly!','Let\'s get out of here! Quickly!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31116,'Speak...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31117,'Her name!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31118,'Over here! I\'m on top of the destroyed plague spreader! Help!','Over here! I\'m on top of the destroyed plague spreader! Help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31119,'You\'ve come for the doctor\'s plans! You\'ll only find death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31120,'As you jump into Nergeld, the rotting flesh of the construct comes to life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31121,'They\'re planning a huge attack! We need to warn Highlord Fordring!','They\'re planning a huge attack! We need to warn Highlord Fordring!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31122,'Faster, hero! We must get back to the Argent Vanguard and warn them of the impending attack!','Faster, hero! We must get back to the Argent Vanguard and warn them of the impending attack!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31123,'There are hundreds of them! Maybe thousands! They will attack at any moment! I\'m sure of it!','There are hundreds of them! Maybe thousands! They will attack at any moment! I\'m sure of it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31124,'Had you not come along I would have died for sure!','Had you not come along I would have died for sure!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31125,'I... I think I saw the Lich King. It was only for a moment, but he was here... And it turned so cold, friend. So, so cold...','I... I think I saw the Lich King. It was only for a moment, but he was here... And it turned so cold, friend. So, so cold...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31126,'ENOUGH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31127,'As for your life, mortal.  I will be generous.  After all... why would I destroy my most useful servant?  I waited for you for weeks inside that Hyldnir mine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31128,'Minions!  Take my brother and his drake to their new dwellings.  Make sure the beast makes it alive.  I have special plans for the broodmother.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31129,'...farewell brother.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31130,'Thank you, hero.','Thank you, hero.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31131,'You may only fly in the Argent Vanguard, Valley of Echoes and Scourgeholme.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31132,'%s falls to pieces.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31133,'The shape wasn\'t mine, of course.  And had you not been so reckless, you would\'ve seen past my illusion.  But you came through for me, and for that... I must thank you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31134,'WHO DARES?! I AM GOING TO FLAY THE FLESH FROM YOUR BONES EVEN IF I HAVE TO DESTROY NERGELD TO GET TO YOU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31135,'HELP! I\'m wrapped up in webbing and unable to move!','HELP! I\'m wrapped up in webbing and unable to move!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31136,'Over here! Down on the ground! Help!','Over here! Down on the ground! Help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31137,'Please don\'t leave us!','Please don\'t leave us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31138,'Save us!','Save us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31139,'Watch out! The Lich King is near!','Watch out! The Lich King is near!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31140,'They\'re going to kill us all!','They\'re going to kill us all!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31141,'We\'re done for!','We\'re done for!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31142,'For the Argent Crusade!','For the Argent Crusade!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31143,'Huh, whassat?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31144,'Just had a little snow in my eye, there...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31145,'You say something?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31146,'Oh yes, now... where were we?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31147,'Ahh, at last... Time for a little break.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31148,'Oh, hello, little $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31149,'You are no taunka. Why have you come to the sacred burial grounds of our warriors?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31150,'I am sorry to disturb your rest, chieftain, but your brother\'s spirit may be in danger. Would you tell me what you remember of him?','I am sorry to disturb your rest, chieftain, but your brother\'s spirit may be in danger. Would you tell me what you remember of him?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31151,'My brother, Stormhoof, was a far greater warrior than I. While I trained to be the chieftain of our clan, he prepared for a larger quest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31152,'How could he be in danger? All he wanted was to give us power over the elements that made life harsh for us here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31153,'He sought an artifact... a horn, I think. He left the village on a long journey in search of it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31154,'I know that a terrible enemy pursued him after he won the horn, but I... I don\'t recall... what happened... next.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31155,'It is as though my memories are shrouded in mist. I cannot even recall what became of my brother. Is this how you mean that he is in danger?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31156,'The disturbances in the tomb, they must be involved. Look around you, $n. Do you see them?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31157,'Yes, they are at fault, but I am powerless to stop them. Will you warn the people of Tunka\'lo, stranger, that their past and their ancestors are in danger?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31158,'%s lets out a bellowing roar as she descends upon the nest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31159,'Look out below!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31160,'Easy there, girl!  Don\'t you recognize your old master?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31161,'I will see you at the Temple of Storms.  Looks like I\'m going to have to break her in again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31162,'The engine\'s blown!  Fly Zak\'s Flying Machine back to K3!','',0,0,0,0,0,0,0,0,1,7394,0,0,26124),
(31163,'','Look at them... all they care about is outdoing each other.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31164,'Tell me about this proposal.','Tell me about this proposal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31165,'','You see, Thorim is not like these harpies.  He\'s a worthy being of near godlike stature.$B$BHe served the titans as guardian of Ulduar and the Terrace of the Makers.$B$BThat is until his wife, Sif, was cowardly slain by his brother.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31166,'What happened then?','What happened then?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31167,'','Thorim lost it.  He lashed out against his most beloved allies, the frost giants.$B$BThat\'s one reason why to this day, this land is torn apart by the war between the Hyldnir and the Sons of Hodir... and why Thorim has exiled himself to the Temple of Storms.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31168,'You want me to take part in the Hyldsmeet to end the war?','You want me to take part in the Hyldsmeet to end the war?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31169,'','What do I care if these she-wolves and the frost giants kill each other every day?$B$BNo, no... I want Thorim to break out of his stupor and rally all his allies to retake Ulduar.$B$BThe world will be torn asunder if he fails to accomplish this!$B$BAnd of course, I\'ll reward you appropriately.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31170,'Very well.  I\'ll take part in this competition.','Very well.  I\'ll take part in this competition.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31171,'The Lorehammer is reacting. This must be from Stormhoof\'s time.','The Lorehammer is reacting. This must be from Stormhoof\'s time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31172,'The Lorehammer is silent. This isn\'t from Stormhoof\'s time.','The Lorehammer is silent. This isn\'t from Stormhoof\'s time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31173,'I\'LL RISE AGAIN AND WHEN I DO I WILL HAVE MY REVENGE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31174,'Leave me to my shame, $r.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31175,'','Men -- can\'t live with them, can\'t live without them.  Well, you can... but it\'s just really boring.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31176,'','These mines are a dreadful place.  Fortunately, I don\'t plan on being here long.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31177,'','Bears are beautiful creatures.  Wild, strong and fierce in battle... much like us, sister.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31178,'Sorry, friend. I\'m afraid we\'ve used all of the parts we can spare at the moment.','Sorry, friend. I\'m afraid we\'ve used all of the parts we can spare at the moment.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31179,'I have been chosen!','I have been chosen!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31180,'Fool! You will never defeat me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31181,'I will never allow you to use the Horn of Elemental Fury against us! Die, weakling!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31182,'My lord, Instructor Hroegar conveys that your warriors are ready. They spar on the ledge outside awaiting your orders','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31183,'The horn! Use the horn on it while it\'s weak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31184,'Thane Ufrang the Mighty, I bear ill news. The Shadow Vault over the mountain to the east has fallen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31185,'Lord Ufrang, there are strangers on the ledge petitioning your warriors to honor duels. They are not vrykul.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31186,'My lord, this draenei was caught along with an entire contingent of death knights from The Shadow Vault. They are Knights of the Ebon Blade!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31187,'Milord, there have been reports of the other thanes preparing their forces for a strike against us. We should move quickly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31188,'My thane, I bear untimely news. Your champion, Bethod, has fallen in the ring at Valhalas. As a vargul, he has been exiled to The Underhalls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31189,'Tell Hroegar that he will be at the van of my forces when I give the word for them to strike.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31190,'','Someone called for me...?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(31191,'Then you must send a messenger to the Lich King. Ready my forces to attack upon his word.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31192,'Let them fight. If they fall to one of the lesser races then it was fated and they are worthless.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31193,'Leave him chained there. I will deal with him in good time. As for the others... see to it that they do not escape!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31194,'Call in all of our favors then. See to it that whatever they\'re up to, we know of it before it occurs. Then we shall see who strikes first!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31195,'No! That horn is MINE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31196,'Bethod was a great warrior, but apparently not great enough. Find me a new champion. We cannot afford this dishonor now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31197,'This will be your last incursion against the Scourge!','',0,0,0,0,0,0,0,0,1,7709,0,0,26124),
(31198,'RISE!','',0,0,0,0,0,0,0,0,1,7709,0,0,26124),
(31199,'As %s falls, the altar set into the floor on his balcony begins to glow faintly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31200,'Ravage the living, minions!','',0,0,0,0,0,0,0,0,1,7709,0,0,26124),
(31201,'Hello, hello!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31202,'','Hello, peach - good to have your company!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31203,'','Hello, peach - good to have your company!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31204,'Pleased to meet you, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31205,'The mountains are rich with history... don\'t forget to stop and take it all in, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31206,'You receive 7500 honor and 150 arena points.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31207,'<The Frostborn Scout appears to have breathed his last breath.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31208,'We discovered these proto-drakes at the Bronze Dragonshrine in the Dragonblight. We knew at once that they were kin - our blood from ages past.$B$BMy apologies, $c. You are probably confused. I am Penumbrius of the bronze dragonflight. I have taken this form out of convenience. It is much easier to communicate and live amongst mortals while in the mortal guise.$B$BHow can I help you?\n','',1,1,6,0,0,0,0,0,1,0,0,0,26124),
(31209,'Bethod\'s Sword?!! Very well, $r, I accept your challenge. But first, you must best my champions. Volgur! Squash this insect!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31210,'The thane spits as the first of his champions falls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31211,'Brita, create a pincushion of this puny $c!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31212,'You may have defeated my champions, $c. I am something else entirely.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31213,'Pray to your gods for a quick death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31214,'Hello, $n! How can I help you today?','Hello, $n! How can I help you today?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31215,'','Thane Illskar, you were challenged to honorable combat and failed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31216,'','You have been found wanting and are judged accordingly. Now rise, Thane Illskar the Damned!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31217,'Speak, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31218,'I\'ve hidden from my destiny long enough.  What I must do has never been clearer.$B$BLoken must be destroyed by my hand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31219,'Can you tell me what became of Sif?','Can you tell me what became of Sif?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31220,'For a moment I thought you were my beloved Sif... that strand of hair... but no!  It can\'t be... Sif is dead....$B$BMy... my brother.... killed her!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31221,'He did more than that, Thorim.  He controls Ulduar now.','He did more than that, Thorim.  He controls Ulduar now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31222,'Ulduar... I was sworn to protect Ulduar.$B$BSworn to protect the Terrace of the Makers.$B$BSworn to protect the pacts between the races of frost.$B$BBut I failed!  I let my brother trick me.  I let him turn me against my allies.  He tricked me into blaming Sif\'s death on a dear friend, Arngrim, the king of the frost giants.$B$BAfter I realized what I\'d done... I... gave in to despair.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31223,'It needn\'t end this way.','It needn\'t end this way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31224,'Who are you, little one?  To come speak these words to the mighty Thorim...$B$BI should... crush you!$B$BYet, you\'ve delivered me from my stupor.  Your presence here is a sign!$B$BIt was no accident that I mistook you for Sif.  What would she think of me?  I must prepare for battle.$B$BI must avenge her death and liberate the titans\' sacred grounds from my brother\'s madness!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31225,'I\'m with you, Thorim.','I\'m with you, Thorim.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31226,'As the last remnants of the %s seep into the ground, the altar set into the floor nearby begins to glow faintly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31227,'NOOOOOOOOOOOOOOOOOO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31228,'Welcome to the Storm Peaks, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31229,'I lost Brann\'s Communicator and need a replacement.','I lost Brann\'s Communicator and need a replacement.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31230,'...zzz... ..snrk... c\'mere... gonna... gonna be Malowned... zzz..','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31231,'...mrf... kids messin\'.. with th\' boxes... zzzz... teach \'em... lesson...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31232,'The north-western keep tower has been damaged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31233,'The south-western keep tower has been damaged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31234,'The south-eastern keep tower has been damaged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31235,'The north-eastern keep tower has been damaged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31236,'The north-eastern keep tower has been destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31237,'The south-eastern keep tower has been destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31238,'The south-western keep tower has been destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31239,'The north-western keep tower has been destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31240,'The western bridge has been damaged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31241,'The southern bridge has been damaged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31242,'The eastern bridge has been damaged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31243,'The eastern bridge has been destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31244,'The southern bridge has been destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31245,'The western bridge has been destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31246,'The eastern tower has been damaged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31247,'The southern tower has been damaged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31248,'The western tower has been damaged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31249,'The western tower has been destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31250,'The southern tower has been destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31251,'The eastern tower has been destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31252,'Where is Elder Arp?','Where is Elder Arp?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31253,'Elder Arp spends time at the D.E.H.T.A camp in Borean Tundra.','Elder Arp spends time at the D.E.H.T.A camp in Borean Tundra.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31254,'Elder Pamuya is just outside Warsong Hold.','Elder Pamuya is just outside Warsong Hold.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31255,'Where is Elder Pamuya?','Where is Elder Pamuya?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31259,'There\'s no doubt that something has distorted the true history of Stormhoof and the warriors of Camp Tunka\'lo. But, what?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31260,'Do not trouble yourself, little tauren. Neither Stormhoof, nor you and your ally will stand in my way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31261,'Even now, my power grows. I have long waited for the day when my revenge would be complete.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31262,'Stormhoof and his kin will be erased from history and these lands will be restored to their rightful owner!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31263,'No! The true voice of history will triumph. We will restore all you have destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31264,'$n, we must hurry and discover when the North Wind has started distorting the timeline. Only then can we defeat him and correct it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31266,'Where is Elder Igasho?','Where is Elder Igasho?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31267,'Elder Igasho was last seen exploring within The Nexus.','Elder Igasho was last seen exploring within The Nexus.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31268,'Where is Elder Northal?','Where is Elder Northal?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31269,'You\'ll find Elder Northal inside the Transitus Shield in Coldarra.','You\'ll find Elder Northal inside the Transitus Shield in Coldarra.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31270,'Where is Elder Sardis?','Where is Elder Sardis?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31271,'Last I heard, Elder Sardis was venturing to Valiance Keep.','Last I heard, Elder Sardis was venturing to Valiance Keep.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31272,'Where is Elder Bluewolf?','Where is Elder Bluewolf?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31273,'Elder Bluewolf is trapped within the battle for Wintergrasp.','Elder Bluewolf is trapped within the battle for Wintergrasp.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31274,'Where is Elder Wanikaya?','Where is Elder Wanikaya?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31275,'Elder Wanikaya can be found at Rainspeaker Rapids in Sholazar Basin.','Elder Wanikaya can be found at Rainspeaker Rapids in Sholazar Basin.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31276,'Where is Elder Sandrene?','Where is Elder Sandrene?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31277,'Elder Sandrene has traveled to Lakeside Landing in Sholazar Basin.','Elder Sandrene has traveled to Lakeside Landing in Sholazar Basin.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31278,'Where is Elder Morthie?','Where is Elder Morthie?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31279,'Go to Stars\' Rest in Dragonblight and you will find Elder Morthie.','Go to Stars\' Rest in Dragonblight and you will find Elder Morthie.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31280,'Where is Elder Thoim?','Where is Elder Thoim?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31281,'Elder Thoim has spent many years at Moa\'ki Harbor in Dragonblight.','Elder Thoim has spent many years at Moa\'ki Harbor in Dragonblight.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31282,'Where is Elder Skywarden?','Where is Elder Skywarden?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31283,'Elder Skywarden can be found near Agmar\'s Hammer in Dragonblight.','Elder Skywarden can be found near Agmar\'s Hammer in Dragonblight.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31284,'Where is Elder Nurgen?','Where is Elder Nurgen?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31285,'Last I knew, Elder Nurgen was in Azjol-Nerub.','Last I knew, Elder Nurgen was in Azjol-Nerub.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31286,'Where is Elder Whurain?','Where is Elder Whurain?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31287,'You\'ll find Elder Whurain at Camp Oneqwah in Grizzly Hills.','You\'ll find Elder Whurain at Camp Oneqwah in Grizzly Hills.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31288,'Where is Elder Chogan\'gada?','Where is Elder Chogan\'gada?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31289,'Elder Chogan\'gada can be found in Utgarde Pinnacle.','Elder Chogan\'gada can be found in Utgarde Pinnacle.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31290,'Where is Elder Lunaro?','Where is Elder Lunaro?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31291,'Elder Lunaro is at the Ruins of Tethys in Grizzly Hills.','Elder Lunaro is at the Ruins of Tethys in Grizzly Hills.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31292,'Where is Elder Beldak?','Where is Elder Beldak?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31293,'Elder Beldak can be found at the Westfall Brigade Encampment in Grizzly Hills.','Elder Beldak can be found at the Westfall Brigade Encampment in Grizzly Hills.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31294,'Where is Elder Jarten?','Where is Elder Jarten?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31295,'Utgarde Keep is where you\'ll find Elder Jarten.','Utgarde Keep is where you\'ll find Elder Jarten.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31296,'Where is Elder Kilias?','Where is Elder Kilias?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31297,'Elder Kilias can be found inside Drak\'Tharon Keep.','Elder Kilias can be found inside Drak\'Tharon Keep.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31298,'Where is Elder Tauros?','Where is Elder Tauros?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31299,'Elder Tauros found his way to Zim\'Torga in Zul\'Drak.','Elder Tauros found his way to Zim\'Torga in Zul\'Drak.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31300,'Where is Elder Ohanzee?','Where is Elder Ohanzee?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31301,'Elder Ohanzee is located in Gundrak.','Elder Ohanzee is located in Gundrak.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31302,'Where is Elder Graymane?','Where is Elder Graymane?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31303,'Elder Graymane was last seen visiting K3 in the Storm Peaks.','Elder Graymane was last seen visiting K3 in the Storm Peaks.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31304,'Where is Elder Muraco?','Where is Elder Muraco?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31305,'Elder Muraco is just outside Camp Tunka\'lo in Storm Peaks.','Elder Muraco is just outside Camp Tunka\'lo in Storm Peaks.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31306,'Where is Elder Fargal?','Where is Elder Fargal?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31307,'Elder Fargal looks over Frosthold in Storm Peaks.','Elder Fargal looks over Frosthold in Storm Peaks.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31308,'Where is Elder Stonebeard?','Where is Elder Stonebeard?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31309,'Elder Stonebeard resides at Bouldercrag\'s Refuge in the Storm Peaks.','Elder Stonebeard resides at Bouldercrag\'s Refuge in the Storm Peaks.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31310,'Where is Elder Yurauk?','Where is Elder Yurauk?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31311,'Elder Yurauk can be found in the Halls of Stone.','Elder Yurauk can be found in the Halls of Stone.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31312,'Mrfrrmrfrmrrr!$B$B<The geist clears his throat.>$B$BYes?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31313,'You are not yet strong enough to do battle in the Strand of the Ancients. Return when you have gained more experience.','You are not yet strong enough to do battle in the Strand of the Ancients. Return when you have gained more experience.',274,0,0,1,0,0,0,0,1,0,0,0,26124),
(31315,'We cannot allow the Horde to turn the hidden secrets of the Strand of the Ancients against us. Will you join our brave soldiers there?','We cannot allow the Horde to turn the hidden secrets of the Strand of the Ancients against us. Will you join our brave soldiers there?',66,0,0,1,0,0,0,0,1,0,0,0,26124),
(31316,'We cannot allow the Alliance to turn the hidden secrets of the Strand of the Ancients against us. Will you join our brave warriors there?','We cannot allow the Alliance to turn the hidden secrets of the Strand of the Ancients against us. Will you join our brave warriors there?',66,0,0,1,0,0,0,0,1,0,0,0,26124),
(31317,'You are leaving the greater Jotunheim region. Return or lose the proto-drake.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31318,'Shadron! Come to me! All is at risk!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31319,'Tenebron! The eggs are yours to protect as well!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31320,'Vesperon, the clutch is in danger! Assist me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31321,'%s fixes his eyes on you!','%s fixes his eyes on you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31322,'Hey! Stop rooting around in my cellar! Clear out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31323,'What were you doing in my cellar? There\'s a food scare going on, and the last thing I need is strangers rummaging around in my goods! Shoo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31324,'This whole situation seems a bit paranoid, don\'t you think?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31325,'Orders are orders. If the Prince says jump...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31326,'It\'s a strange order, you can\'t deny. Suspicious food? Under that definition, you should arrest Belfast!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31327,'I HEARD THAT! No more ale for you! Not a drop!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31328,'Free to--mm--fly now. Ra-aak... Not find us--ekh-ekh! Escape!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31329,'Welcome back to the waking world, child.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31330,'I... am fury... unrestrained!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31331,'Do not lose faith.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31333,'The End of the Scourge draws near.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31334,'The time of the Argent Crusade is now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31335,'We shall triumph!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31336,'Put your faith in the Light and all is possible!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31337,'Back in business! Now, to execute an exit strategy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31338,'Have at you, fiends! You shall not escape the wrath of the Ashbringer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31339,'I am... renewed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31340,'Barber','Barber',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31341,'Such is the price... of failure....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31342,'','The Fleshwerks is the heart of the Scourge\'s ghoul, abomination, and flesh giant production. If we can take it out, the Lich King will be greatly weakened.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31343,'He is slow from the rust of the ages... be quick on your feet and he will not best you. You have King Stormheart\'s favor - do not disappoint.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31344,'This will be a fine test, Prince Arthas.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31345,'Time out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31346,'You seem tired.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31347,'All too easy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31348,'The Dark Lord is displeased with your interference.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31349,'It is Prince Arthas I want, not you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31350,'Fixin\' the tower and the wall! Keep the baddies off us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31351,'Agh! Damn you, Mal\'Ganis! Father... Jaina... I have failed Lordaeron....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31352,'Protect your prince, soldiers of Lordaeron! I am in need of aid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31353,'I am being overwhelmed! Assist me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31354,'Mal\'Ganis will pay for this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31355,'I can\'t afford to spare you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31356,'One less obstacle to deal with.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31357,'I\'M COOKIN HERE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31358,'Another hungry recruit?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31359,'What do you need?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31360,'What brings you to me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31361,'Remind me how to make Northern Stew.','Remind me how to make Northern Stew.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31362,'The lava surrounding %s churns!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31363,'Such flammable little insects....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31364,'Return to Jotunheim immediately. You can feel the Bone Witch\'s spell of possession failing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31365,'','We serve Thorim, sister.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31366,'I\'m ready to ride.','I\'m ready to ride.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31367,'Reckoning Bomb READY! Purge the evil from this land!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31368,'This pathetic siege ends NOW!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31369,'','It is always a pleasure to meet heroes such as yourself in this forsaken land. Is there some form of assistance that I can offer you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31370,'Greetings, mage.  Shall I provide you with further insight into the world of magic?','Greetings, mage.  Shall I provide you with further insight into the world of magic?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31371,'Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.','Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31372,'It\'s a pleasure to meet you as well, Archdruid. I am on a task from Tirion and time is short. Might I trouble you for a portal to Moonglade?','It\'s a pleasure to meet you as well, Archdruid. I am on a task from Tirion and time is short. Might I trouble you for a portal to Moonglade?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31373,'','Of course! Go with Elune\'s blessing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31374,'Fire a volley!','Fire a volley!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31375,'Fire the even cannons!','Fire the even cannons!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31376,'Fire the odd cannons!','Fire the odd cannons!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31377,'Fire all the cannons!','Fire all the cannons!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31378,'Fire a barrage!','Fire a barrage!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31379,'Fire at will!','Fire at will!\n',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31380,'','Hail. I could not help but overhear your conversation. Please allow me to lend some assistance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31381,'','I\'m heading back to the Argent Vanguard through Dalaran if you\'d like to return with me, hero.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31382,'Dis be a dark day in troll history, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31383,'Dis be horrible, mon. I cannot bear to be watchin\'.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31384,'We couldn\'t have done it without you, $g sir:ma\'am;.','We couldn\'t have done it without you, $g sir:ma\'am;.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31385,'There goes the hero of the Vanguard!','There goes the hero of the Vanguard!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31386,'You honor us with your presence, $n.','You honor us with your presence, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31387,'With your steadfast determination, we cannot fail!','With your steadfast determination, we cannot fail!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31388,'Thank you, $n. From the bottom of my heart. Thank you.','Thank you, $n. From the bottom of my heart. Thank you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31389,'Call on me anytime, $n.','Call on me anytime, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31390,'We will battle along side you until the bitter end, $g sir:ma\'am;!','We will battle along side you until the bitter end, $g sir:ma\'am;!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31391,'Hero, I am honored.','Hero, I am honored.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31392,'','It be my duty to record these tragic events for the good of generations to come.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31393,'We mustn\'t lose our focus. The dangers inherent in getting lost in the moment could put us in peril. Alas, the soldiers need a respite from this madness.$B$BBask in the victory, $n. If not for you we might have lost the Vanguard.','',274,1,25,0,0,0,0,0,1,0,0,0,26124),
(31394,'If you are lost, my friend, perhaps I can be of assistance. What is it you need?','If you are lost, my friend, perhaps I can be of assistance. What is it you need?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31395,'This city can be strange. Is there something I can do for you?','This city can be strange. Is there something I can do for you?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31396,'Warning: This vehicle is not permitted to operate outside of Wintergrasp. Return immediately.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31397,'Brood Guardians reporting in!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31398,'Sanctum Guardians reporting in!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31399,'','Reinforcements, finally! The prison guards can\'t hold out against this invasion for much longer! You\'ll have to relieve my men and try to hold out for as long as you can. There\'s still some power in the defense system available. Use the activation crystals located around the prison to trigger a discharge if the situation worsens.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31400,'It is my charge to watch over these eggs. I will see you burn before any harm comes to them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31401,'Activate the crystals when we get in trouble, right.','Activate the crystals when we get in trouble, right.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31402,'','%s begins to open a Twilight Portal!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31403,'The Alliance has defended Wintergrasp Fortress!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31404,'Dying must have completely destroyed your ability to perform simple arithmetic. Can\'t you see that there is no way you\'re going to make that structure\'s layout work? It\'ll collapse!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31405,'The Horde has defended Wintergrasp Fortress!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31406,'How dare you! I am the chief architect here and I make the final call on layouts! If you have a problem with my plans, feel free to file a grievance with Highlord Fordring. Now if you don\'t mind, I have work to attend!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31407,'I am the greatest of my father\'s sons! Your end has come!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31408,'Give me your worst!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31409,'Defend yourself, for all the good it will do!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31410,'GRAAAAAH! Behold the fury of iron and steel!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31411,'So ends your curse.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31412,'Flesh... is... weak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31413,'Bolvin umyol marnjar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31414,'How can it be...? Flesh is not... stronger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31415,'It is you who have destroyed my children? You... shall... pay!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31416,'Life from lifelessness... death for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31417,'Nothing is wasted in the process. You will see....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31418,'I will crush you beneath my boots!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31419,'All my work... undone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31420,'The armies of iron will conquer all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31421,'Feh! Pathetic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31422,'You have cost me too much work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31423,'The master was right... to be concerned.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31424,'','Is your entire party of adventurers ready to continue? I\'ll fire off a discharge from this activation crystal to cover the retreat of my guards.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31425,'','Ok, if your party is ready then I\'m ready to fall back and let you continue the defense here. I\'ll overload the defenses to clear the prison long enough to let us leave and shut the door. After that, it\'s up to you to protect this door at all costs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31426,'Get your people to safety, we\'ll keep the Blue Dragonflight\'s forces at bay.','Get your people to safety, we\'ll keep the Blue Dragonflight\'s forces at bay.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31427,'We fought back da Scourge. What chance joo thinkin\' JOO got?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31428,'Get ready for somethin\'... much... BIGGAH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31429,'Da ground gonna swallow you up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31430,'I crush joo cockroaches!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31431,'Who gonna stop me? You?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31432,'Not so tough now!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31433,'If our gods can die... den so can we....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31434,'Fear not, young one, for this crusader shall not taste death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31435,'In life, Bridenbrad was the bearer of great deeds. Now, in passing, he shall taste only paradise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31436,'The light does not abandon its champions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31437,'What I do for the Argent Crusade now should only be viewed as fulfillment of an obligation. A payment, if you will. The Highlord freed me from the grasp of the Lich King and laid before us all the path to salvation. With that said, it must be understood that our methods differ - greatly. I and the Knights of the Ebon Blade will help the Argent Crusade lay their foundations within Icecrown and then we will part ways. The payment made in full.$B$BA different destiny awaits us.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(31438,'There is no question that these crusaders are the source of great discomfort, $g brother:sister;. But what is sacrifice without pain? You were with me at Light\'s Hope Chapel. You saw many great sacrifices made. We are here now to settle a debt to the Highlord. Payment in full for his sacrifice.$B$BOnce the Argent Crusade has established their foothold inside the walls of Icecrown, we will depart. A different destiny awaits us.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(31439,'The Halls of Lightning, a level 80 dungeon within Storm Peaks, is now available for testing. Please be in your full group before teleporting to the dungeon. Meeting Stones are not available for this dungeon yet.\n\nTo leave the Halls of Lightning, simply exit through the normal exit inside the dungeon and you will be returned here. If you die and release, you should teleport back from this NPC.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31440,'I\'m in my group and ready to teleport to the Halls of Lightning!','I\'m in my group and ready to teleport to the Halls of Lightning!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31441,'Take me back to the Halls of Lightning!','Take me back to the Halls of Lightning!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31442,'Test','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31443,'Entry 1','Entry 1',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31444,'First, an introduction.  I am Archmage Vargoth, leader of the first Kirin Tor expedition to Draenor.  We have accompanied Alliance forces through the Dark Portal, and now set up base camp - Kirin\'Var Village - in Farahlon, near the ancestral home of the Laughing Skull clan of orcs.  Such a lovely place!','First, an introduction.  I am Archmage Vargoth, leader of the first Kirin Tor expedition to Draenor.  We have accompanied Alliance forces through the Dark Portal, and now set up base camp - Kirin\'Var Village - in Farahlon, near the ancestral home of the Laughing Skull clan of orcs.  Such a lovely place!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31445,'<The dusty journal is missing various entries>','<The dusty journal is missing various entries>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31446,'My lady.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31447,'What this place? I will destroy you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31448,'Entry 42','Entry 42',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31449,'Ley-line excavations continue, with pleasant results.  We were surprised to find several similarities in the ley-line structures between Azeroth and Draenor, possibly indicating a similar genesis?\nMy close associate Naberius reports that the Laughing Skulls have established a truce with the Alliance forces in the area. Always distrustful of orcs, I thought to myself, \"This could be heaven or this could be hell.\"','Ley-line excavations continue, with pleasant results.  We were surprised to find several similarities in the ley-line structures between Azeroth and Draenor, possibly indicating a similar genesis?\nMy close associate Naberius reports that the Laughing Skulls have established a truce with the Alliance forces in the area. Always distrustful of orcs, I thought to myself, \"This could be heaven or this could be hell.\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31450,'Entry 205','Entry 205',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31451,'Most of the Alliance forces have left for Azeroth.  Hopefully the carefully-compiled reports that we sent with General Turalyon will make it back to Dalaran safely.\nNer\'zhul\'s reckless portals have torn Farahlon apart, its green hills now quickly crumbling as the Twisting Nether corrupts the earth.  I have to find a passage back to the place I was before!','Most of the Alliance forces have left for Azeroth.  Hopefully the carefully-compiled reports that we sent with General Turalyon will make it back to Dalaran safely.\nNer\'zhul\'s reckless portals have torn Farahlon apart, its green hills now quickly crumbling as the Twisting Nether corrupts the earth.  I have to find a passage back to the place I was before!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31452,'You die! That what master wants.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31453,'An easy task!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31454,'What mongrels dare intrude here? Look alive, my brothers!  A feast for the one that brings me their heads!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31455,'You challenge death itself! Come then, \"King.\" Face the might of Mograine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31456,'I will see you back at the Valley of Echoes. Suffer well, ally.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31457,'I ask for vrykul to kill them, yet all I get are feeble whelps! By Ymiron, SLAUGHTER THEM!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31458,'If one more harpoon touches my drake I\'ll flay your miserable hides!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31459,'You motherless knaves! Your corpses will make fine morsels for my new drake!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31460,'Mjor na uul kval!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31461,'Not so brash now, are you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31462,'I\'ll mount your skull from the highest tower!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31463,'ARGH! You call that... an attack? I\'ll...  show... aghhhh...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31464,'You invade my home and then dare to challenge me?  I will tear the hearts from your chests and offer them as gifts to the death god! Rualg nja gaborr!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31465,'Bjorn of the Black Storm! Honor me now with your presence!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31466,'Haldor of the Rocky Cliffs! Grant me your strength!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31467,'Ranulf of the Screaming Abyss!  Snuff these maggots with darkest night!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31468,'Tor of the Brutal Siege, bestow your might upon me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31469,'Your death is only the beginning.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31470,'You have failed your people!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31471,'There is a reason I am king!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31472,'Breathe no more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31473,'What... awaits me... now?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31474,'','Prison guards, we are leaving! These adventurers are taking over! Go go go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31475,'','I\'m locking the door. Good luck, and thank you for doing this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31476,'There is word from Jotunheim. The sleep-watchers there believe that they have found someone of significance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31477,'The cultist practically sputters.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31478,'Look like, my lady? A vrykul, I suppose. They did not actually show him to me. Ever since The Shadow Vault....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31479,'A name? Oh, yes, the name! I believe it was Iskalder.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31480,'Right away, my lady.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31481,'','Report.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31482,'','Describe this vrykul. What does he look like?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31483,'','I am not interested in excuses. Perhaps they gave you a name?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31484,'','Iskalder?! You fool! Have you no idea who that is? He\'s only the greatest vrykul warrior who ever lived!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31485,'','Return to Jotunheim and tell them to keep him asleep until I arrive. I will judge this vrykul with my own eyes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31486,'Say hello to my little friend!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31487,'Arise, Melt!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31488,'We\'re done here. I\'m out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31489,'','Too weak to finish your own battles? Very well then...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31490,'','Anything else you need help with before I go? Right, I thought not...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31491,'Ancient magic swirls within the depths of the eye. It gives you a feeling of vertigo, as if you might accidentally tumble into its iris and fall forever.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31492,'Grasp the Eye of the Lich King and focus your will upon it to scry for important information.','Grasp the Eye of the Lich King and focus your will upon it to scry for important information.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31493,'Scrying upon many insignificant situations within Icecrown, you stumble upon something interesting...','Scrying upon many insignificant situations within Icecrown, you stumble upon something interesting...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(31497,'Anomalies form as %s shifts into the Astral Plane!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31498,'Temple of Invention analysis commencing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31499,'Temple of Invention verified to be intact.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31500,'Mechanical servants appear to have turned against each other. Several attendants have been piled together in an unorganized manner.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31501,'Remaining mechagnome guardians corrupted by unknown source.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31502,'Watcher Mimir verified to no longer be present. Analysis complete.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31503,'The vrykul rests peacefully in his magical slumbering.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31504,'Temple of Winter analysis commencing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31505,'Waken the slumbering mjordin to see if it is really the ancient hero, Iskalder.','Waken the slumbering mjordin to see if it is really the ancient hero, Iskalder.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31506,'Temple of Winter verified to be in tact.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31507,'Temple guardians verified to be deceased. Sulfurous odor suggests that death resulted from a fire-based entity.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31508,'Previously established cold weather patterns at the temple have ceased.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31509,'Watcher Hodir verified to no longer be present. Analysis complete.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31510,'Watcher Freya verified to no longer be present. Analysis complete.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31512,'Temple of Life verified to be damaged beyond repair.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31513,'Evidence indicates a significant battle. The opponent of Watcher Freya estimated to be of similar size and strength to Watcher Freya.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31514,'Temple guardians are no longer present. Plant forms associated with temple are deceased.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31515,'Temple of Life analysis commencing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31516,'Temple of Order analysis commencing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31517,'Temple of Order verified to be in tact.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31518,'No indications of struggle are present. No guardians are present.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31519,'Watcher Tyr verified to no longer be present. Analysis complete.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31520,'<hic>$b$bIt be lonely in here without me mateys, $g lad:lass;.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31521,'Yarr! Someone be needin\' ta show these bloaks what fer!$b$b<hic>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31522,'It be time ta kick some arse an\' drink double-rum!$b$bAn\' I almost be outta double-rum....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31523,'It\'s Iskalder! Quickly, use The Bone Witch\'s Amulet!','It\'s Iskalder! Quickly, use The Bone Witch\'s Amulet!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31524,'The portal has stabilized! Attack!','The portal has stabilized! Attack!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31525,'Why do you defend the Kirin Tor...','Why do you defend the Kirin Tor...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31526,'You shall not disrupt this portal!','You shall not disrupt this portal!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31527,'Such a meaningless death!','Such a meaningless death!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31528,'','Iskalder, there you are. What is this? Engaged in battle already?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31529,'','Very well. Finish these lesser beings and let us be about our business.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31530,'','NO! How is this possible?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31531,'','I know not how this was possible, but you must still be judged Iskalder. Wait... what is this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31532,'','This? This is me taking control of you. This is me setting up my final revenge!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31533,'','Stay away from me creature! Do not touch me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31534,'','Ahahahahahaha! It is done. Return to my cave. We have much to discuss!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31535,'For the Spellweaver!','For the Spellweaver!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31536,'The Nexus War will not be stopped!','The Nexus War will not be stopped!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31537,'Your efforts have been in vain!','Your efforts have been in vain!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31538,'The Blessed Banner of the Crusade is destroyed!\nThe Scourge are victorious!','',0,0,0,0,0,0,0,0,1,7828,0,0,26124),
(31539,'The Blessed Banner of the Crusade has been planted.\nDefend the banner from all attackers!','',0,0,0,0,0,0,0,0,1,7828,0,0,26124),
(31540,'Now fight me, $n! Kill Iskalder!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31541,'Seek out Catarina Stanford in the canals southwest of The Stockade.','Seek out Catarina Stanford in the canals southwest of The Stockade.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31542,'Inscription','Inscription',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31544,'Jelinik\'s Barber Shop is in the northern section of the Trade District.','Jelenik\'s Barber Shop is in the northern section of the Trade District.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31545,'THE MASTER\'S WILL BE DONE!','',0,0,0,0,0,0,0,0,1,7828,0,0,26124),
(31546,'There you are! I think I\'ve just about got this door figured out. Let me know when you\'re ready and I\'ll open\'er up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31547,'We\'re with you Brann! Open it!','We\'re with you Brann! Open it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31548,'Elise Brightletter is near the Great Forge adjacent to the Flight Master.','Elise Brightletter is near the Great Forge adjacent to the Flight Master.',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(31549,'You can find the barber shop on the west portion of The Commons.','You can find the barber shop on the west portion of The Commons.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31550,'Oh, bravo. Do you feel proud of yourself now that you\'ve unleashed this terrible mistake?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31551,'I already had him scheduled for disposal, but I suppose we can speed up the process a bit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31552,'Feyden Darkin is on the second floor in the center of the Craftsman\'s Terrace.','Feyden Darkin is on the second floor in the center of the Craftsman\'s Terrace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31553,'It\'s a pity so many fine, and reusable, parts will go to waste... ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31554,'Patches not going to be cut open or sewn up no more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31555,'Don\'t worry! Ol\' Brann\'s got yer back! Keep that metal monstrosity busy, and I\'ll see if I can\'t sweet talk this machine into helping ye!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31556,'Patches get revenge on Doctor Sabnok!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31557,'Thoth can teach you Inscription in The Crystal Hall.','Thoth can teach you Inscription in The Crystal Hall.',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(31558,'Jo\'mah is in a building on the second floor of The Drag.','Jo\'mah is in a building on the second floor of The Drag.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31559,'The barber? She\'s moved shop, out of the Cleft of Shadow and into the cliffs above the Valley of Strength, where the fruit vendor used to be.','The barber? She\'s moved shop, out of the Cleft of Shadow and into the cliffs above the Valley of Strength, where the fruit vendor used to be.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31560,'BY THE LIGHT! Those damned monsters! Look at what they\'ve done to our people!','',0,0,0,0,0,0,0,0,1,7828,0,0,26124),
(31561,'Burn it down, boys. Burn it all down.','',0,0,0,0,0,0,0,0,1,7828,0,0,26124),
(31562,'Let \'em come. They\'ll pay for what they\'ve done!','',0,0,0,0,0,0,0,0,1,7828,0,0,26124),
(31563,'You go find Margaux Parchley. She pretty lady in The Apothecarium.','You go find Margaux Parchley. She pretty lady in The Apothecarium.',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(31564,'Barber? That is Naznik! He on top floor of Trade Quarter, near bank.','Barber? That is Naznik! He on top floor of Trade Quarter, near bank.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31565,'Seek out Poshken Hardbinder in The Pools of Vision, below the Spirit Rise.','Seek out Poshken Hardbinder in The Pools of Vision, below the Spirit Rise.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31566,'You can find the scribe, Zantasia in the Court of the Sun.','You can find the scribe, Zantasia in the Court of the Sun.',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(31567,'Leave no survivors!','',0,0,0,0,0,0,0,0,1,7828,0,0,26124),
(31568,'Cower before my terrible creations!','',0,0,0,0,0,0,0,0,1,7828,0,0,26124),
(31569,'Feast my children! Feast upon the flesh of the living!','',0,0,0,0,0,0,0,0,1,7828,0,0,26124),
(31570,'Lay down your arms and surrender your souls!','',0,0,0,0,0,0,0,0,1,7828,0,0,26124),
(31571,'Bow before your king!','',0,0,0,0,0,0,0,0,1,7828,0,0,26124),
(31572,'Eradicate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31573,'We\'ve done it, lads! We\'ve taken the pinnacle from the Scourge! Report to Father Gustav at once and tell him the good news! We\'re gonna get to buildin\' and settin\' up! Go!','',0,0,0,0,0,0,0,0,1,7828,0,0,26124),
(31574,'Know... my... pain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31575,'Gaze... into the void.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31576,'More... energy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31577,'Relinquish.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31578,'Fall... to shadow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31579,'Disperse.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31580,'The Lithe Stalker is weakened by the assault.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31581,'How can I possibly help the city in such a widespread crisis?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31582,'Everyone is falling ill - this is an epidemic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31583,'No remedy seems to work - the entire city has sickened...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31584,'The soldiers are spreading panic with the rumors of bad food. Neighbors are accusing one another of poison. The city will fall into bedlam!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31585,'The city is grinding to a halt as more and more workers become bedridden...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31586,'I\'m at a loss. What can one simple man do in the face of disaster?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31587,'I pray the illness I\'m feeling is due to stress ulcers...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31588,'The vrykul dies from being awakened improperly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31589,'Interference with the wakening ritual causes the vrykul to die.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31590,'The incorrect application of the awakening rod causes the dormant vrykul to expire.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31591,'The dormant vrykul keels over.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31592,'The taking of Crusaders\' Pinnacle is only the first step in a long and dangerous journey. There is much left to do before we are able to assault Icecrown Citadel.$B$BIt can only be possible with help from you and others like you, hero.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(31593,'Welcome to Dalaran, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31594,'I\'m ready to fly to Sholazar Basin.','I\'m ready to fly to Sholazar Basin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31595,'','He\'s on his way!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31596,'I\'ve lost my Loremaster\'s Colors.','I\'ve lost my Loremaster\'s Colors.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31597,'You dare to challenge me? You haven\'t earned the right!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31598,'','Wrong, Balargarde. You WILL accept this challenge!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31599,'Vardmadra?! Did the Lich King send you personally?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31600,'Very well. I will dispatch these creatures. It is only an inconvenience. Prepare to die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31601,'Safirdrang, let them feel the chill of Icecrown!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31602,'Return to the Malykriss!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31603,'I\'ve lost my Tabard of the Explorer.','I\'ve lost my Tabard of the Explorer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31604,'Return to Brunnhildar Village!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31605,'Return to Blue Sky Logging Ground!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31606,'Return to Venture Bay!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31607,'I\'ve lost my Tabard of Brute Force.','I\'ve lost my Tabard of Brute Force.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31608,'For me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31609,'Present?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31610,'What bomb thing for?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31611,'Want me to deliver somewhere?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31612,'I not sure this safe, little geist.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31613,'This no go here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31614,'What little geist want?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31615,'That not nice!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31616,'Insufferable skeletons.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31617,'I am yet a great warrior, do not toy with me, skeleton.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31618,'I am not slave labor... my patience wears thin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31619,'My talents are wasted on this filth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31621,'Look at me again skeleton. I will rip your skull from your flimsy frame!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31623,'Keep your brittle bones out of my way, mindless puppets.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31624,'The Skybreaker patrols Icecrown.  You will find no finer ship in all of the realms.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31625,'Take me to the ship.','Take me to the ship.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31626,'Orgrim\'s Hammer is ready to strike in Icecrown.  You will find no finer vessel.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(31627,'STOP! Kneel you fools, it\'s the Lich King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31628,'Honor guard stay where you are.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31629,'Vardmadra. I\'d wondered where you disappeared to. How is Iskalder?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31631,'','My lord.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31632,'I see through your disguise, Lady Nightswood. YOU THINK THAT YOU CAN FOOL ME?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31633,'','But...!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31634,'You may continue your combat, overthane.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31635,'But, my lord...?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31636,'But nothing! Finish them! DO NOT FAIL ME, BALARGARDE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31637,'DIE DOGS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31638,'<Highlord Darion Mograine nods.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31639,'I require training, Highlord.','I require training, Highlord.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31640,'Death knight come play?','',0,0,0,0,0,0,0,0,1,7863,0,0,26124),
(31641,'Why you want hurt Patchwerk?','',0,0,0,0,0,0,0,0,1,7863,0,0,26124),
(31642,'Lich King say Patchwerk \"on loan\" from Naxxramas. Loan make Patchwerk ANGRY!','',0,0,0,0,0,0,0,0,1,7863,0,0,26124),
(31643,'Come play with Patchwerk! Patchwerk lonely!','',0,0,0,0,0,0,0,0,1,7863,0,0,26124),
(31644,'Patchwerk miss Naxxramas. Maybe kill you all fast so Patchwerk go home?','',0,0,0,0,0,0,0,0,1,7863,0,0,26124),
(31645,'The only reason that you still live is because of my curiosity.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31646,'Dalaran must fall!','Dalaran must fall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31647,'Destroy all who stand against us!','Destroy all who stand against us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31648,'The Kirin Tor must be stopped!','The Kirin Tor must be stopped!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31649,'Magic must be... contained...','Magic must be... contained...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31650,'You cannot stop us all!','You cannot stop us all!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31651,'Dalaran will burn!','Dalaran will burn!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31652,'I will defend this portal with my life!','I will defend this portal with my life!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31653,'Your pathetic defense ends here!','Your pathetic defense ends here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31654,'More portals will take this one\'s place!','More portals will take this one\'s place!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31655,'My death will not stop this invasion!','My death will not stop this invasion!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31656,'Your efforts were misguided!','Your efforts were misguided!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31657,'The way into Dalaran has been opened!','The way into Dalaran has been opened!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31658,'The destruction of Dalaran is inevitable!','The destruction of Dalaran is inevitable!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31659,'You receive 2500 honor and 50 arena points.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31660,'I think it\'s time to see what\'s behind the door near the entrance. I\'m going to sneak over there, nice and quiet. Meet me at the door and I\'ll get us in.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31661,'The blood red pool within the eye swirls, betraying images of a massing army of Scourge. The eye seems to pull at you, willing its way into your mind and triggering you to pull back instinctively. You feel very uneasy in the presence of this object.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31662,'Monster!','Monster!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31663,'Murderer!','Murderer!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31664,'You disgust me.','You disgust me.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31665,'Traitorous dog!','Traitorous dog!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31666,'Looks like we\'re going to have ourselves an execution.','Looks like we\'re going to have ourselves an execution.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31667,'My family was wiped out by the Scourge! MONSTER!','My family was wiped out by the Scourge! MONSTER!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31668,'How dare you set foot in our city!','How dare you set foot in our city!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31669,'GET A ROPE!','GET A ROPE!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31670,'%s cowers in fear.','%s cowers in fear.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31671,'%s throws a rotten apple at $n.','%s throws a rotten apple at $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31672,'%s throws a rotten banana at $n.','%s throws a rotten banana at $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31673,'%s spits on $n.','%s spits on $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31674,'','Whatever you\'re going to ask for, do it quickly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31675,'People of Stormwind! Citizens of the Alliance! Your king speaks!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31676,'Today marks the first of many defeats for the Scourge! Death knights, once in service of the Lich King, have broken free of his grasp and formed a new alliance against his tyranny!\n','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31677,'You will welcome these former heroes of the Alliance and treat them with the respect that you would give to any ally of Stormwind!\n\n','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31678,'Glory to the Alliance!\n','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31679,'Murderer!','Murderer!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(31680,'You disgust me.','You disgust me.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(31681,'Traitorous dog!','Traitorous dog!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(31682,'Looks like we\'re going to have ourselves an execution.','Looks like we\'re going to have ourselves an execution.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(31683,'My family was wiped out by the Scourge! MONSTER!','My family was wiped out by the Scourge! MONSTER!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(31684,'How dare you set foot in our city!','How dare you set foot in our city!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(31685,'GET A ROPE!','GET A ROPE!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(31686,'Monster!','Monster!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(31687,'Horde, hear the call of your Warchief!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(31688,'Today marks the first of many defeats for the Scourge! Death knights, once in service of the Lich King, have broken free of his grasp and formed a new alliance against his tyranny!\n','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(31689,'You will welcome these former heroes of the Horde and treat them with the respect that you would give to any ally of Orgrimmar!\n','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(31690,'For the Horde!\n','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(31691,'SCOURGE!!!! Stand back! Gamon will save us all!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(31692,'We\'ve broken through the prison gate! The way into Dalaran is clear! Now we finally put an end to the Nexus War!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31693,'You have bested one of my finest, but your efforts are for naught.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31694,'','You did it! You held the Blue Dragonflight back and defeated their commander. Amazing work!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31695,'The frozen heart of Icecrown awaits....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31696,'','We\'ll take over from here, you\'ve earned quite a respite after that battle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31697,'','%s smiles and flies off to return to possessing The Bone Witch.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31698,'Warning: You\'ve entered a no-fly zone and are about to be dismounted!','Warning: You\'ve entered a no-fly zone and are about to be dismounted!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31699,'','You there! Step forward!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31700,'','Yogg-Saron! Grant me your power!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31701,'','Master, a gift for you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31702,'','Glory to Yogg-Saron!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31703,'','You are unworthy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31704,'','Get up! You haven\'t suffered enough.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31705,'','Do not expect your sacrilege... to go unpunished.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31706,'','The elements themselves will rise up against the civilized world! Only the faithful will be spared!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31707,'','Immortality can be yours, but only if you pledge yourself fully to Yogg-Saron!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31708,'','Here, on the very borders of his domain, you will experience power you could have never imagined!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31709,'','You have traveled long and risked much to be here! Your devotion shall be rewarded.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31710,'','The faithful shall be exalted, but there is more work to be done. We will press on until all of Azeroth lies beneath his shadow!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31711,'Drakkari gonna kill anybody who tressspasss on these landsss!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31712,'You not breathin\'? Good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31713,'Ssscared now?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31714,'I eat you next, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31715,'I sssee now... Ssscourge wasss not... our greatessst enemy....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31716,'Hello. Master Fras Siabi is not in at this time. Please come back tomorrow to Fras Siabi\'s Premium Tobacco! Beep!','Hello. Master Fras Siabi is not in at this time. Please come back tomorrow to Siabi\'s Premium Tobacco! Beep!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31717,'What is it?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(31718,'','A valiant defense, but this city must be razed. I will fulfill Malygos\'s wishes myself!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31719,'<Seize control of an Eidolon Watcher through the eye.>','<Seize control of an Eidolon Watcher through the eye.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31720,'','I hope you\'re not coming in here fixing for a fight. There are too many angry people on the streets today.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31721,'','Look, I\'ll sell you shields today, but no maces. The last thing I want is for some innocent to get brained by one of my weapons.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31722,'','I don\'t know how much longer I\'ll be open today with all the commotion outside. If you need something repaired, I\'ll take a quick look.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31723,'','We finish this now, champions of Kirin Tor!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31724,'The Stone Crow\'s closed today, sorry. There are too many health concerns, and I\'m not about to have Ed under fire for supposedly making people sick.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31725,'','I will end the Kirin Tor!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31726,'','Dalaran WILL fall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31727,'','So ends you defiance of the Spell-Weaver.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31728,'','Perhaps... we have... underestimated... you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31729,'I hate to disappoint people, but the Stone Crow\'s closed. If the kids from the orphanage were evacuated, I don\'t see why we should be open, either.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31730,'','What\'s the commotion outside?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31731,'','Is something going on? I hear angry voices.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31732,'','Everything\'s been so strange lately...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31733,'The Argent Dawn coordinates the Scourge\'s opposition at Light\'s Hope Chapel in the Eastern Plaguelands.  Go there for instructions.','The Argent Dawn coordinates the Scourge\'s opposition at Light\'s Hope Chapel in the Eastern Plaguelands.  Go there for instructions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31735,'I would like to spend my runes.','I would like to spend my runes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31736,'You are not yet strong enough to do battle in Lake Wintergrasp. Return when you have gained more experience.','You are not yet strong enough to do battle in Lake Wintergrasp. Return when you have gained more experience.',274,0,0,1,0,0,0,0,1,0,0,0,26124),
(31737,'This portal leads to Lake Wintergrasp.','This portal leads to Lake Wintergrasp.',66,0,0,1,0,0,0,0,1,0,0,0,26124),
(31738,'Enter the portal.','Enter the portal.',66,0,0,1,0,0,0,0,1,0,0,0,26124),
(31740,'','Who among you can withstand my power?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31741,'Take me to Lieutenant Icehammer, Zorek!','Take me to Lieutenant Icehammer, Zorek!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31742,'','Many have fallen within Valhalas and their corpses are a testament to the strength of our ways.$B$BWill your bones litter this place of honor and battle as well, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31743,'I should kill you where you stand, $r!$B$BGet on with your inane prattling and then begone!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(31744,'','Valhalas is yours to win or die in, $n. But whatever you do, stay within the bounds of the arena. To flee is to lose and be dishonored.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31745,'','$n and $g his : her; comrades in arms have chosen to accept honorable combat within the sacred confines of Valhalas.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31746,'','There can be only one outcome to such a battle: death for one side or the other. Let $n prove $g himself : herself; upon the bones of those outsiders who have fallen before!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31747,'','The challengers have failed. Not being vrykul this was expected.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31748,'','The dishonor of failure in combat is eternal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31749,'','Are there any others who would dare to challenge the might of Valhalas?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31750,'','Valhalas is no place for games and fools.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31751,'','We will give you who have fallen another chance. You are not vrykul, so you cannot be held to such a high standard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31752,'','More bones to honor the floor of Valhalas. Bring on the next group!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31753,'','You were not prepared!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31754,'','There are other fights to be had within Jotunheim if you are not skilled enough for Valhalas.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31755,'','$n has defeated the fallen heroes of Valhalas battles past. This is only a beginning, but it will suffice.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31756,'The fallen heroes of Valhalas emerge from the ground to do battle once more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31757,'','You have not yet proven yourself worthy enough to issue a challenge within Valhalas, $n.$B$BReturn when you have earned a name for yourself.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31758,'','Many have fallen within Valhalas and their corpses are a testament to the strength of our ways.$B$BWill your bones litter this place of honor and battle as well, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31759,'Lesser beings, intruding here! A shame that your excess courage does not compensate for your stupidity!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31760,'None but the blue dragonflight are welcome here. Perhaps this is the work of Alexstrasza? Well, then, she has sent you to your deaths!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31761,'What could you hope to accomplish? To storm brazenly into my domain... to employ magic... against ME?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31762,'I am without limits here. The rules of your cherished reality do not apply. In this realm, I am in control!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31763,'I give you one chance. Pledge fealty to me, and perhaps I will not slaughter you for your insolence.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31764,'My patience has reached its limit. I will be rid of you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31765,'Few have experienced the pain I will now inflict upon you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31767,'Your stupidity has finally caught up with you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31768,'More artifacts to confiscate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31769,'How very naive.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31770,'','$n has accepted the challenge of Khit\'rix the Dark Master. May the gods show mercy upon $g him : her; for Khit\'rix surely will not.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31771,'','Prepare yourself. Khit\'rix will be entering Valhalas from the southeast. Remember, do not leave the ring or you will lose the battle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31772,'I had hoped to end your lives quickly, but you have proven more... resilient than I anticipated. Nonetheless, your efforts are in vain. It is you reckless, careless mortals who are to blame for this war. I do what I must, and if it means your extinction.... then SO BE IT!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31773,'I will teach you ignorant children just how little you know of magic.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31774,'Watch helplessly as your hopes are swept away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31775,'Your energy will be put to good use.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31776,'I am the Spell-Weaver! My power is infinite!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31777,'Your spirit will linger here forever!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31778,'ENOUGH! If you intend to reclaim Azeroth\'s magic, then you shall have it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31779,'Now your benefactors make their appearance, but they are too late! The powers contained here are sufficient to destroy the world ten times over. What do you think they will do to you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31780,'Submit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31781,'You will not succeed while I draw breath!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31782,'The powers at work here exceed anything you could possibly imagine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31783,'I am unstoppable!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31784,'Alexstrasza, another of your brood falls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31785,'Little more than gnats!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31786,'Your red allies will share your fate!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31787,'Still standing? Not for long.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31788,'Your cause is lost!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31789,'Your fragile mind will be shattered!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31790,'Unthinkable! The mortals will destroy... everything! My sister, what have you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31791,'I bought food from this stall just yesterday and now my family\'s taken ill!','I bought food from this stall just yesterday and now my family\'s taken ill!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31792,'','Look, I\'m sorry, I really am, but all of my food is fresh!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31793,'The prisoners shall not go free! The word of Malygos is law!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31794,'Tremble, worms!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31795,'I will crush you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31796,'Can you fly?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31797,'It is too late to run!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31798,'Gather \'round....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31799,'None shall escape!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31800,'I condemn you to death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31801,'A fitting punishment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31802,'Sentence executed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31803,'Another casualty of war!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31804,'The war... goes on.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31805,'It seems my freedom must be bought with blood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31806,'Plentiful, exploitable resources... primed for acquisition!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31807,'It would seem that a renegotiation is in order.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31808,'Nothing personal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31809,'Business concluded.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31810,'Profit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31811,'This is an... unrecoverable... loss.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31812,'Intruders, your victory will be short-lived. I am Commander Varos Cloudstrider. My drakes control the skies and protect this conduit. I will see to it personally that the Oculus does not fall into your hands!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31813,'There will be no mercy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31814,'Blast them! Destroy them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31815,'Take no prisoners! Attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31816,'Strike now! Obliterate them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31817,'You were warned.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31818,'The Oculus is ours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31819,'They are... too strong! Underestimated their... fortitude.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31820,'','Khit\'rix the Dark Master has been defeated by $n and $g his : her; band of companions. Let the next challenge be issued!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31821,'Not--caww--get in way of--rrak-rrak--flee!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31822,'Kekeke!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31823,'Precious life--ra-aak--wasted!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31824,'Only strong--ka-raaak-survive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31825,'No--kaw, kaw--flee...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31826,'Thank the Light for granting me another chance. And thank you, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31827,'Without your help, I would\'ve been doomed to a life of undeath among the Lich King\'s gruesome creations.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31828,'There will be time for a proper thanks later, but there is still a battle to be fought!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31829,'A taste... just a small taste... of the Spell-Weaver\'s power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31830,'So much unstable energy... but worth the risk to destroy you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31831,'If only you understood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31832,'Now do you see? Do you?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31833,'Unfortunate, but necessary.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31834,'Everything I have done... has been for Azeroth....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31835,'','I knew that you would come.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31836,'When I am done here, I am going to mount your heads upon the walls of Azjol-Nerub!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31837,'My wife and children are sick in bed because of the poison you sold me!','My husband and children are sick in bed because of the poison you sold me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31838,'','It wasn\'t my food!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31839,'Don\'t try to weasel out of this!','Don\'t try to weasel out of this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31840,'','Please, it\'s not my fault! If... if I give you a refund, maybe you can speak to a healer? I don\'t know what you expect me to do!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31841,'Simpletons! You cannot comprehend the forces you have set in motion. The ley line conduit will not be disrupted! Your defeat shall be absolute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31842,'That... no, keep your filthy money! It won\'t help my family!','That... no, keep your filthy money! It won\'t help my family!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31843,'%s prepares a Great Feast!','%s prepares a Great Feast!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31844,'$n prepares a Fish Feast!','$n prepares a Fish Feast!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31845,'$n prepares a Small Feast!','$n prepares a Small Feast!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31846,'$n prepares a Gigantic Feast!','$n prepares a Gigantic Feast!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31847,'%s groans.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31848,'Cry to the heavens, Alliance filth. Pray that my wounds do not heal before yours.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31849,'Green-skinned dog! Be silent or I will cut your tongue out and feed it to your swine-like children.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31850,'YOU HAVE JUST SIGNED YOUR OWN DEATH WARRANT, MONGREL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31851,'YOU SIGNED YOURS WHEN YOU MURDERED BOLVAR! DAMN YOU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31852,'','You have some fight in you. I\'m impressed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31853,'','Well fought...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31855,'I\'ve been waiting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31856,'','That looked a bit painful.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31857,'','I bet you wish you were undead about now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31858,'','Welcome to the world of the unliving.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31859,'','Noble effort.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31860,'Don\'t stop now, I\'ve almost broken a sweat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31861,'I know no death. I will... be back... for you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31862,'Your blood tastes sweet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31863,'Another trophy for my collection.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31864,'Your blood is now mine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31865,'Fragile thing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31866,'No shining army? No righteous words? It seems your \'honor\' suits you no longer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31867,'Such noble boasts, but in the end, we\'ve brought you down to reality.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31868,' You too shall serve the Lich King.... your time comes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31869,'After I finish with your friends, you shall be our newest initiate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31870,'There will be no peace in death for you, that I promise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31871,'Your eternal suffering is about to begin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31872,'Your soul belongs to me now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31873,'You brash interlopers are out of your element! I will ground you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31874,'Such insolence... such arrogance... must be PUNISHED!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31875,'No magic of nature will help you now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31876,'We command the arcane! It shall not be used against us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31877,'It is trivial to extinguish your fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31878,'It\'s a long way down....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31879,'Back to the earth with you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31880,'Enjoy the fall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31881,'Savor this small victory, foolish little creatures. You and your dragon allies have won this battle, but we will win... the Nexus War.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31882,'','Ah, there you are! Remember me? Of course you do! Wait right there, I\'m coming down.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31883,'','I told you I\'d be better prepared when next we met. I\'ve fought and won the Hyldsmeet, trained at Valkyrion, and here I am.  Come and get some!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31884,'The secrets of the deep shall remain hidden.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31885,'','Carnage is coming!  Remember, no matter what you do, do NOT leave the battle ring or I will disqualify you and your group.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31886,'The young must not go hungry....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31887,'Shhhad ak kereeesshh chak-k-k!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31888,'Sleep now in the cold dark....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31889,'For the Lich King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31890,'Perhaps we will be allies soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31891,'Master... is my service... complete?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31892,'','Sigrid Iceborn has returned to the heights of Jotunheim to prove herself against $n.  When last they met, $n bested her in personal combat.  Let us see the outcome of this match.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31893,'My---raaak--favorite! Awk awk awk! Raa-kaa!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31894,'An Ahn\'kahar Guardian hatches!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31895,'I will feast on your remains!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31896,'Your heartbeat is... music to my ears.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31897,'I am nowhere.... I am everywhere. I am the watcher unseen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31898,'So... appetizing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31899,'Fresh, warm blood... it has been too long.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31900,'Bin dorei am\'ovel!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31901,'I will drink no blood before its time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31902,'One final... embrace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31903,'Still I hunger. Still... I... thirst.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31904,'Your charred bones will litter the floor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31905,'How much heat can you take?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31906,'All will be reduced to ash!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31907,'Burn, you miserable wretches!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31908,'You will make a fine meal for the hatchlings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31909,'You are at a grave disadvantage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31910,'This is why we call you lesser beings!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31911,'You will be alone in the end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31912,'Trust is your weakness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31913,'Hope is an illusion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31914,'All that you know will fade.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31915,'This is madness! Cease this foolish battle!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(31916,'Brothers and sisters, we must remain united! The Lich King will never fall to a world divided!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(31917,'Can you not see that you play right into the Lich King\'s hands? He wants you to kill each other!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(31918,'Join the Argent Crusade! United, we shall destroy the Lich King!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(31919,'Judgment day comes, brothers and sisters! Will you be prepared?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(31920,'How much of our efforts are being wasted by attacking the Alliance?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(31921,'','$n has defeated Sigrid Iceborn for a second time.  Well, this time $g he : she; did it with the help of $g his : her; friends, but a win is a win!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31922,'We must unite and focus our attention upon the true threat: THE LICH KING!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(31923,'This is madness! Cease this foolish battle!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31924,'Brothers and sisters, we must remain united! The Lich King will never fall to a world divided!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31925,'Can you not see that you play right into the Lich King\'s hands? He wants you to kill each other!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31926,'Join the Argent Crusade! United, we shall destroy the Lich King!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31927,'Judgment day comes, brothers and sisters! Will you be prepared?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31928,'How much of our efforts are being wasted by attacking the Horde?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31929,'We must unite and focus our attention upon the true threat: THE LICH KING!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(31930,'','From the bowels of the Underhalls comes Carnage.  Brave and foolish $n has accepted the challenge.  $G He : She; and $g his : her; group stand ready to face the monstrosity.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31931,'','The horror known as Carnage is no more.  Could it be that $n is truly worthy of battle in Valhalas?  We shall see.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31932,'Uhnhh.... Don\'t... bother with me.$b$bI am... finished...','Uhnhh.... Don\'t... bother with me.$b$bI am... finished....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31933,'Gathering... information... on the Scourge.$b$bAlliance forces appeared...$b$bWe took cover - waited until they attacked the gate... then, we hit them from the rear.$b$bPinched between us... and the Scourge... it was too much for them....$b$b$g Brother:Sister;... it was... glorious.','Gathering... information... on the Scourge.$b$bAlliance forces appeared...$b$bWe took cover - waited until they attacked the gate... then, we hit them from the rear.$b$bPinched between us... and the Scourge... it was too much for them....$b$b$g Brother:Sister;... it was... glorious.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31934,'Hold on, friend. Tell me what happened here.','Hold on, friend. Tell me what happened here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31935,'ENOUGH!  You tiny insects are not worthy to do battle within this sacred place!  You do not fight with honor!  You do not even ascend! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31936,'Fight me and die you cowards!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31937,'','I can hear Sigrid Iceborn approaching from the northwest. She has been informed that she cannot use her proto-drake in battle here. Do not leave the battle ring!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31938,'','Look to the southeast and you will see the thane upon the platform near Gjonner the Merciless when he shows himself. Let him come down.  Stay within the ring of Valhalas.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31939,'','Thane Banahogg returns to Valhalas for the first time in ages to prove that the vrykul are the only beings worthy to fight within its sacred ring.  Will $n prove him wrong?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31940,'','Thane Banahogg the Deathblow has fallen to $n and $g his : her; fighting companions.  $G He : She; has but one challenge ahead of $g him : her;.  Who will it be?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31941,'The Light\'s blessing be upon you for aiding me in my time of need, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31942,'I\'ve had my fill of this place. Let us depart.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31943,'I have you to thank for my life. I will return to my comrades and spread word of your bravery. Fight the Scourge with all the strength you can muster, and we will be by your side.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31944,'You must tell my brothers that I live.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31945,'','The unthinkable has happened... $n has slain Prince Sandoval!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31946,'','In defeating him, $g he : she; and $g his : her; fighting companions have proven themselves worthy of battle in this most sacred place of vrykul honor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31947,'The time of judgment is nigh. In your heart, you know justice is the only true path.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31948,'','ALL HAIL $n, CHAMPION OF VALHALAS!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31949,'','It\'s too late to run now.  Do not leave the ring.  Die bravely, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31950,'Face your judgment by the Light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31951,'','From the depths of Icecrown Citadel, one of the Lich King\'s chosen comes to put an end to the existence of $n and $g his : her; friends.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31952,'You will never take me alive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31953,'The Argent Crusade never surrenders!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31954,'Forgive me, brothers, for I have failed you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31955,'','Warriors of Jotunheim, I present to you, Blood Prince Sandoval!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31956,'Hardly a fitting introduction, Spear-Wife.  Now, who is this outsider that I\'ve been hearing so much about?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31957,'I will make this as easy as possible for you.  Simply come here and die.  That is all that I ask for your many trespasses.  For your sullying of this exalted place of battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31958,'You have served honorably.. I shall make your victory known to all the Horde.','You have served honorably.. I shall make your victory known to all the Horde.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31959,'Ah, the hand of the Ebon Blade has finally come to claim me. I tremble in fear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31960,'I have given my all... for the Horde...','I have given my all... for the Horde...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31961,'Hah! That\'s all you\'ve got? I\'m surprised you even made it to the citadel.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31962,'The Lich King has given me power beyond your wildest nightmares. Behold!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31963,'It all ends here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31964,'There you are Darion! I was wondering when you\'d crawl forth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31965,'So easily fooled by Tyrion\'s boasts upon holy ground, you rush to him thinking he would be victorious. You always were a coward, Darion. Just like your father.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31966,'%s chuckles knowingly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31967,'The Lich King shall extinquish... every... last... one... of you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31968,'Weakling.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31969,'One more slave for the Lich King.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31970,'That wasn\'t even a challenge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31971,'Well look at that... you\'re dead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31972,'FOR YOUR EFFRONTERY TO THE LICH KING!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31973,'You dare to think you have thwarted my will? That you have broken my plans?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31974,'You have accomplished nothing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31975,'Orbaz Bloodbane, self proclaimed hand of the Lich King.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31976,'Your feeble resistance has only hastened your doom.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31977,'Couldn\'t wait for me to be out of the way so that you could sieze control?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31978,'Good riddance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31979,'So spout your platitudes and flail until you are spent. In the end, you will be mine, and Morbidus will be the harbinger of your death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31980,'Avenge me, $g brother:sister;....','Avenge me, $g brother:sister;....',0,0,0,0,0,0,0,0,1,7905,0,0,26124),
(31981,'Morbidus, show them what happens to those who defy the will of their king!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31982,'Wait, $c....$b$bOne... final request...','Wait, $c....$b$bOne... final request...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31983,'You\'ll never have what it takes to lead anything, Orbaz, not even a legion of mindless skeletons.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31984,'We... are superior! How could this... be?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31985,'I fear nothing! Least of all you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31986,'You are insignificant.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31987,'Such mediocre resistance...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31988,'You are easily bested!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31989,'Father taught me well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31990,'On you knees!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31991,'I will take pity on you, Sartharion, just this once.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31992,'Uhnhh.... It is too late for me, $g brother:sister;.$b$bI am... finished...','Uhnhh.... It is too late for me, $g brother:sister;.$b$bI am... finished...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31993,'','You have no place here! Your place... is among the departed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31994,'','No contest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31995,'','Typical. Just as I was having fun...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31996,'','To darkness I condemn you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31997,'','Arrogant little creatures, to challenge powers you do not yet understand.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31998,'','I am no mere dragon. You will find that I am much, much more.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(31999,'','It is amusing to watch you struggle. Very well, witness how it is done!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32000,'','I should not... have held back...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32001,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32002,'You pose no threat, lesser beings! Give me your worst!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32003,'The least you could do is put up a fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32004,'Was that the best you can do?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32005,'I will pick my teeth with your bones!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32006,'Aren\'t you tricky? I have a few tricks of my own...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32007,'Unlike you, I have many talents!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32008,'Father was right about you, Sartharion. You ARE a weakling.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32009,'I still have some... fight... in me-e-e...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32010,'Thank you for your help. You can find me at the Argent Vanguard if you require anything further.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32011,'','You must defeat Prince Sandoval. It is your only hope for survival, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32012,'Stay with me, friend. I must know what happened here.','Stay with me, friend. I must know what happened here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32013,'','Champion $n, it is good to see you again.$B$BHave you returned to Valhalas to assist a friend with their challenges?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32014,'We attacked under cover of a blizzard....$b$bThe Scourge were caught off guard... our victory was certain....$b$bThen... from behind us... the Horde came from nowhere.$b$bThey cost us... everything....','We attacked under cover of a blizzard....$b$bThe Scourge were caught off guard... our victory was certain....$b$bThen... from behind us... the Horde came from nowhere.$b$bThey cost us... everything....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32015,'Knights of the Ebon Blade, prepare for battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32016,'Enough of your blather! Knights, forward!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32017,'Wait, $g brother:m\'lady;....$b$bOne last thing...','Wait, $g brother:m\'lady;....$b$bOne last thing...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32018,'Be strong, friend. Do what must be done...','Be strong, friend. Do what must be done...',0,0,0,0,0,0,0,0,1,7904,0,0,26124),
(32019,'Yes, my king!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32020,'The figure at the front of the ruined chamber gestures and mouths inaudible words as a group of other spirits sit in rapt attention.','The figure at the front of the ruined chamber gestures and mouths inaudible words as a group of other spirits sit in rapt attention.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32021,'The Lost Shandaral Spirit kneels silently before the violet waters, gazing into the tranquil surface of the pool.','The Lost Shandaral Spirit kneels silently before the violet waters, gazing into the tranquil surface of the pool.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32022,'','Why, hello again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32023,'','Great job! Arthas is safely on his way to Northrend!',71,0,0,0,0,0,0,0,1,0,0,0,26124),
(32024,'Yes, please!','Yes, please!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32025,'Has Prince Arthas turned against us?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32026,'Stand your ground, men!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32027,'The undead are upon us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32028,'We make our stand here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32029,'The rumors were true!  The prince has gone mad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32030,'My family\'s sick!','My family\'s sick!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32031,'The whole city\'s ill!','The whole city\'s ill!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32032,'I think it\'s your grain that\'s making us sick!','I think it\'s your grain that\'s making us sick!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32033,'You brought this down on us! I\'d bet gold on it!','You brought this down on us! I\'d bet gold on it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32034,'It\'s poison! Cartloads of poison!','It\'s poison! Cartloads of poison!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32035,'We were fine until we ate from this tainted grain of yours!','We were fine until we ate from this tainted grain of yours!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32036,'Give us one good reason why we shouldn\'t set fire to these sacks!','Give us one good reason why we shouldn\'t set fire to these sacks!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32037,'This is all your fault!','This is all your fault!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32038,'My Queen, do they know?','',0,0,0,0,0,0,0,0,1,7906,0,0,26124),
(32039,'I just delivered it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32040,'','No, my beloved.',0,0,0,0,0,0,0,0,1,7906,0,0,26124),
(32041,'','They must not discover the fate of the young paladin. Not yet.',0,0,0,0,0,0,0,11,1,7906,0,0,26124),
(32042,'I would like to enter the secret code to receive my Big Blizzard Bear.','I would like to enter the secret code to receive my Big Blizzard Bear.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32043,'I didn\'t touch it! I promise you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32044,'Please, I\'m just a delivery man!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32045,'I haven\'t done anything!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32046,'%s nods.','',0,0,0,0,0,0,0,0,1,7906,0,0,26124),
(32047,'They will not.','',0,0,0,0,0,0,0,0,1,7906,0,0,26124),
(32048,'','Come to me, $n.',0,0,0,0,0,0,0,0,1,7906,0,0,26124),
(32049,'I... recede.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32050,'I AM a force of nature!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32051,'I SHALL pass!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32052,'You cannot stop the tide!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32053,'I will not be contained! Ngyah!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32054,'I shall consume, decimate, devastate, and destroy! Yield now to the wrath of the pounding sea!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32055,'Water can hold any form, take any shape... overcome any obstacle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32056,'Stand aside, mortals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32057,'Where\'s Barthilas?!','Where\'s Barthilas?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32058,'We want to speak to the magistrate!','We want to speak to the magistrate!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32059,'What are we supposed to do?!','What are we supposed to do?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32060,'We need leadership!','We need leadership!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32061,'Stop hiding, Barthilas!','Stop hiding, Barthilas!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32062,'Let us through!','Let us through!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32063,'We\'ll drag you out here if we have to!','We\'ll drag you out here if we have to!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32064,'Look alive marines!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(32065,'On your guard marines!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(32066,'At ease marines!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(32067,'Marines, stand at ease!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(32068,'','The magistrate is very busy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32069,'','Please, return to your homes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32070,'','Everyone, please remain calm...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32071,'','Magistrate Barthilas is unavailable at the moment...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32072,'Shield-Mages, get some shields up!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(32073,'','Please don\'t go back there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32074,'','Don\'t disturb the magistrate, please!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32075,'Let\'s get some protection here mages!  Put up some shields!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(32076,'','Come back; we\'re not open!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32077,'The western sewers entrance is beneath the stairway to the Violet Citadel.','The western sewers entrance is beneath the stairway to the Violet Citadel.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32078,'The eastern sewers entrance is just outside the entrance to Krasus\' Landing.','The eastern sewers entrance is just outside the entrance to Krasus\' Landing.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32079,'','Reavers, ready for battle!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32080,'','Prepare for battle reavers!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32081,'','Reavers, stand down!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32082,'','Stand down reavers!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32083,'','Shadow-Warders, prove your worth!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32084,'The city\'s cemetery is just north of the Violet Citadel in western Dalaran.','The city\'s cemetery is just north of the Violet Citadel in western Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32085,'','Shield our vessel Shadow-Warders!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32086,'The Eventide is a square in southern Dalaran. The enchanted fountain there is popular for fishing.','The Eventide is a square in southern Dalaran. The enchanted fountain there is popular for fishing.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32087,'Runeweaver Square is a park at the very heart of Dalaran.','Runeweaver Square is a park at the very heart of Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32088,'The memorial park to Antonidas is located in northern Dalaran.','The memorial park to Antonidas is located in northern Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32089,'There is a well in northern Dalaran that some of the city\'s more... adventurous... visitors use to enter the sewers.','There is a well in northern Dalaran that some of the city\'s more... adventurous... visitors use to enter the sewers.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32090,'Work harder fools, the Lich King has no time for your laziness!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32091,'Taskmistresses, do your jobs. Production must increase!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32092,'Must I come out there myself and do your job for you Taskmistresses?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32093,'The Violet Hold, prison for the enemies of the Kirin Tor, is in southeast Dalaran.','The Violet Hold, prison for the enemies of the Kirin Tor, is in southeast Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32094,'Ah, new slaves have arrived. Taskmistresses, see that they are properly outfitted and set to work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32095,'Do you see the massive spired tower in eastern Dalaran? That is the majestic Violet Citadel.','Do you see the massive spired tower in eastern Dalaran? That is the majestic Violet Citadel.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32096,'The visiting Horde keep primarily to the Sunreaver\'s Sanctuary in northeastern Dalaran.$B$BThere is an inn there, as well as portals to the various battlegrounds and Orgrimmar.','The visiting Horde keep primarily to the Sunreaver\'s Sanctuary in northeastern Dalaran.$B$BThere is an inn there, as well as portals to the various battlegrounds and Orgrimmar.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32097,'Visiting members of the Alliance keep primarily to the Silver Enclave in southwestern Dalaran.$B$BThere is an inn there, as well as portals to the various battlegrounds and Stormwind.','Visiting members of the Alliance keep primarily to the Silver Enclave in southwestern Dalaran.$B$BThere is an inn there, as well as portals to the various battlegrounds and Stormwind.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32098,'There are at least three ways beneath Dalaran: Sewer entrances in the east and west, and a well in the north.','There are at least three ways beneath Dalaran: Sewer entrances in the east and west, and a well in the north.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32099,'Eastern Sewer Entrance','Eastern Sewer Entrance',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32100,'Western Sewer Entrance','Western Sewer Entrance',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32101,'Well Entrance','Well Entrance',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32102,'There are many places of interest in Dalaran. Which do you seek?','There are many places of interest in Dalaran. Which do you seek?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(32103,'The Alliance Quarter','The Alliance Quarter',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32104,'The Horde Quarter','The Horde Quarter',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32105,'The Violet Citadel','The Violet Citadel',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32106,'The Violet Hold','The Violet Hold',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32107,'Sewers','Sewers',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32108,'Antonidas Memorial','Antonidas Memorial',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32109,'Runeweaver Square','Runeweaver Square',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32110,'The Eventide','The Eventide',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32111,'Cemetery','Cemetery',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32112,'Dalaran\'s arena and those who service it are found beneath the city, in the sewers.$B$BThere are at least three ways in: Entrances in the east and west, and a well in the north.','Dalaran\'s arena and those who service it are found beneath the city, in the sewers.$B$BThere are at least three ways in: Entrances in the east and west, and a well in the north.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32113,'Portals to Stormwind and Orgrimmar and the various battlegrounds can be found in Dalaran\'s Alliance and Horde quarters: the Silver Enclave and the Sunreaver\'s Sancturary.','Portals to Stormwind and Orgrimmar and the various battlegrounds can be found in Dalaran\'s Alliance and Horde quarters: the Silver Enclave and the Sunreaver\'s Sancturary.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32115,'','Work harder slave or I\'ll have your head!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32116,'Y-y-y-yes Mistress, whatever you say Mistress.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32117,'The Fleshwerks will never again produce soldiers for the Lich King\'s armies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32118,'Let\'s kill this... thing... and get this over with.','Let\'s kill this... thing... and get this over with.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32119,'Amongst the Kirin Tor, it is my duty to see to the strategic interests of the magocracy.$B$BThere is much yet to be done this week. Will you assist me, $n?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32120,'The Magus Commerce Exchange is in northwest Dalaran, and holds most of the city\'s profession trainers.','The Magus Commerce Exchange is in northwest Dalaran, and holds most of the city\'s profession trainers.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32121,'Trade District','Trade District',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32122,'The city\'s best tailors are in Talismanic Textiles in the Magus Commerce Exchange, northwest Dalaran.','The city\'s best tailors are in Talismanic Textiles in the Magus Commerce Exchange, northwest Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32123,'Skinners and leatherworkers of all sorts may be found at Legendary Leathers in the Magus Commerce Exchange, northwest Dalaran.','Skinners and leatherworkers of all sorts may be found at Legendary Leathers in the Magus Commerce Exchange, northwest Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32124,'Miners trainers and supplies are found in the All that Glitters Prospecting Co. in the Magus Commerce Exchange, northwest Dalaran.','Miners trainers and supplies are found in the All that Glitters Prospecting Co. in the Magus Commerce Exchange, northwest Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32125,'That would be Cartier & Co. Fine Jewelry in the Magus Commerce Exchange, northwest Dalaran.','That would be Cartier & Co. Fine Jewelry in the Magus Commerce Exchange, northwest Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32126,'Seek out The Scribe\'s Sacellum in the Magus Commerce Exchange, northwest Dalaran.','Seek out The Scribe\'s Sacellum in the Magus Commerce Exchange, northwest Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32127,'There is a greenhouse attached to the Agronomical Apothecary in the Magus Commerce Exchange, northwest Dalaran. You\'ll find the city\'s best herbalists there.','There is a greenhouse attached to the Agronomical Apothecary in the Magus Commerce Exchange, northwest Dalaran. You\'ll find the city\'s best herbalists there.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32128,'One can learn to fish near the enchanted fountain in the Eventide, a square in southern Dalaran.','One can learn to fish near the enchanted fountain in the Eventide, a square in southern Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32129,'The city\'s premier urgent care center, First to your Aid, is located in the Magus Commerce Exchange, northwest Dalaran.','The city\'s premier urgent care center, First to your Aid, is located in the Magus Commerce Exchange, northwest Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32130,'Engineers often train at Like Clockwork in the Magus Commerce Exchange, northwest Dalaran.','Engineers often train at Like Clockwork in the Magus Commerce Exchange, northwest Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32131,'You\'ll want to visit Simply Enchanting, just outside the Magus Commerce Exchange in northwest Dalaran.','You\'ll want to visit Simply Enchanting, just outside the Magus Commerce Exchange in northwest Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32132,'Cooking trainers are located in the kitchens of the Alliance and Horde inns in their respective quarters.','Cooking trainers are located in the kitchens of the Alliance and Horde inns in their respective quarters.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32133,'Alliance Inn','Alliance Inn',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32134,'Horde Inn','Horde Inn',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32136,'A Hero\'s Welcome is located right beside the Silver Enclave in southwestern Dalaran.$B$BThe place boasts a beer garden and one of the city\'s finest cooking trainer in its kitchen.','A Hero\'s Welcome is located right beside the Silver Enclave in southwestern Dalaran.$B$BThe place boasts a beer garden and one of the city\'s finest cooking trainer in its kitchen.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32138,'You\'re looking for The Filthy Animal in the Horde quarter of Sunreaver\'s Sanctuary, northeastern Dalaran.$B$BI am told it is a rather rough place, but with an excellent cooking trainer in its kitchen.','You\'re looking for The Filthy Animal in the Horde quarter of Sunreaver\'s Sanctuary, northeastern Dalaran.$B$BI am told it is a rather rough place, but with an excellent cooking trainer in its kitchen.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32139,'There is a large smithy and forge in the Magus Commerce Exchange, northwest Dalaran.$B$BLook for the massive enchanted anvil and stained glass windows in the shapes of axes and shields.','There is a large smithy and forge in the Magus Commerce Exchange, northwest Dalaran.$B$BLook for the massive enchanted anvil and stained glass windows in the shapes of axes and shields.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32140,'Look for the potion-shaped door to the Agronomical Apothecary in the Magus Commerce Exchange, northwest Dalaran. It\'s quite impossible to miss!','Look for the potion-shaped door to the Agronomical Apothecary in the Magus Commerce Exchange, northwest Dalaran. It\'s quite impossible to miss!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32141,'Which profession trainer were you looking for?','Which profession trainer were you looking for?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(32142,'Orgrimmar is under lock down. All shops are closed. Please visit Thunder Bluff or Silvermoon City if you require a merchant, auctioneer or trainer.$B$BStay clear of the Undercity!','Orgrimmar is under lock down. All shops are closed. Please visit Thunder Bluff or Silvermoon City if you require a merchant, auctioneer or trainer.$B$BStay clear of the Undercity!',1,1,5,0,0,0,0,0,1,0,0,0,26124),
(32143,'Engineering','Engineering',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32144,'Fishing','Fishing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32145,'Herbalism','Herbalism',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32146,'Inscription','Inscription',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32147,'Mining','Mining',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32148,'Tailoring','Tailoring',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32149,'The high elf Hira Snowdawn teaches Cold Weather Flying.$B$BShe can be found upon her dragonhawk at Krasus\' Landing in eastern Dalaran.','The high elf Hira Snowdawn teaches Cold Weather Flying.$B$BShe can be found upon her dragonhawk at Krasus\' Landing in eastern Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32150,'The city\'s mage and portal trainers may be found in a large building in eastern Dalaran, between Runeweaver Square at the heart of the city and Krasus\' Landing.','The city\'s mage and portal trainers may be found in a large building in eastern Dalaran, between Runeweaver Square at the heart of the city and Krasus\' Landing.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32151,'What sort of trainer were you trying to find?','What sort of trainer were you trying to find?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(32152,'Mage Trainer','Mage Trainer',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32153,'Portal Trainer','Portal Trainer',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32154,'Cold Weather Flying Trainer','Cold Weather Flying Trainer',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32155,'Dalaran\'s stable master is located inside the Magical Menagerie in northeast Dalaran.','Dalaran\'s stable master is located inside the Magical Menagerie in northeast Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32156,'The most popular inn in Dalaran is the Legerdemain Lounge, just north of the city\'s center.$B$BThe Alliance and Horde Quarters each have their own inns as well, and I am told there is one more beneath the city, in the sewers.','The most popular inn in Dalaran is the Legerdemain Lounge, just north of the city\'s center.$B$BThe Alliance and Horde Quarters each have their own inns as well, and I am told there is one more beneath the city, in the sewers.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32157,'The city\'s best-known barber shop is located in northern Dalaran.','The city\'s best-known barber shop is located in northern Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32158,'You\'ll find the city\'s Flight Master at Krasus\' Landing in eastern Dalaran.','You\'ll find the city\'s Flight Master at Krasus\' Landing in eastern Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32159,'The Bank of Dalaran is in the northern part of the city.','The Bank of Dalaran is in the northern part of the city.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32160,'The Dalaran Merchants\' Bank is in the southern part of the city, off the Eventide.','The Dalaran Merchants\' Bank is in the southern part of the city, off the Eventide.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32161,'No! The workshop is about to explode! Evacuate, quickly!','No! The workshop is about to explode! Evacuate, quickly!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32162,'There are three banks in the city: The Bank of Dalaran in the north, the Dalaran Merchants\' Bank in the south, and one more beneath the city, in the sewers.','There are three banks in the city: The Bank of Dalaran in the north, the Dalaran Merchants\' Bank in the south, and one more beneath the city, in the sewers.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32163,'Northern Bank','Northern Bank',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32164,'Southern Bank','Southern Bank',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32165,'There are many mailboxes in Dalaran: On many corners, outside nearly every inn and bank, even upon Krasus\' Landing.','There are many mailboxes in Dalaran: On many corners, outside nearly every inn and bank, even upon Krasus\' Landing.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32166,'Inn','Inn',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32167,'Bank','Bank',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32168,'Krasus\' Landing','Krasus\' Landing',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32169,'Krasus\' Landing is in easternmost Dalaran.$B$BThe city\'s flight master is there, as well as the cold weather flying trainer.','Krasus\' Landing is in easternmost Dalaran.$B$BThe city\'s flight master is there, as well as the cold weather flying trainer.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32170,'Dalaran has no auction house of its own. You must take a portal back to one of your capitals.$B$BThey can be found in Dalaran\'s Alliance and Horde quarters: the Silver Enclave and the Sunreaver\'s Sancturary.','Dalaran has no auction house of its own. You must take a portal back to one of your capitals.$B$BThey can be found in Dalaran\'s Alliance and Horde quarters: the Silver Enclave and the Sunreaver\'s Sancturary.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32171,'Destroy our raw materials, will you? Well, the master has a special plan in mind for you... ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32172,'Which service were you looking for?','Which service were you looking for?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(32173,'Look! What\'s a frostwyrm doing here? It\'s coming straight for us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32174,'Auction House','Auction House',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32175,'Services','Services',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32176,'Trainers','Trainers',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32177,'Capital Portals','Capital Portals',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32179,'Arena','Arena',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32180,'Points of Interest','Points of Interest',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32181,'Visiting members of the Alliance keep primarily to the Silver Enclave in southwestern Dalaran.$B$BThere is an inn there, as well as portals to the various Alliance cities and battlegrounds.','Visiting members of the Alliance keep primarily to the Silver Enclave in southwestern Dalaran.$B$BThere is an inn there, as well as portals to the various Alliance cities and battlegrounds.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32183,'Welcome to Dalaran, traveler.$B$BIs there something I might help you find?','Welcome to Dalaran, traveler.$B$BIs there something I might help you find?',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(32184,'Please respect the laws of Dalaran while you are here, stranger.$B$BWere you lost? Is there something I might help you find?','Please respect the laws of Dalaran while you are here, stranger.$B$BWere you lost? Is there something I might help you find?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32185,'This instance is about to reset. You will be forced from the instance shortly.','This instance is about to reset. You will be forced from the instance shortly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32186,'Dalaran\'s guild master is found in the visitor center, just south of the city\'s center.','Dalaran\'s guild master is found in the visitor center, just south of the city\'s center.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32187,'This instance has reset.','This instance has reset.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32189,'Guild Master & Vendor','Guild Master & Vendor',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32190,'This instance will reset in 10 minutes.','This instance will reset in 10 minutes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32191,'This instance will reset in 5 minutes.','This instance will reset in 5 minutes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32192,'This instance will reset in 3 minutes.','This instance will reset in 3 minutes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32193,'This instance will reset in 2 minutes.','This instance will reset in 2 minutes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32194,'This instance will reset in 1 minute.','This instance will reset in 1 minute.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32195,'','Damn it, Olakin, get your arse back here! There\'s work to be done!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32196,'This instance will reset in 30 seconds.','This instance will reset in 30 seconds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32197,'Battlemasters','Battlemasters',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32198,'You will pay for what you\'ve done! For the Argent Crusade!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32199,'Puny skeleton. My patience is over!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32200,'I foresee that you will speak with Archmage Lan\'dalock, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32201,'Dalaran\'s only class trainers are mages. You must take a portal back to one of your capitals for others.$B$BThey can be found in Dalaran\'s Alliance and Horde quarters: the Silver Enclave and the Sunreaver\'s Sancturary.','Dalaran\'s only class trainers are mages. You must take a portal back to one of your capitals for others.$B$BThey can be found in Dalaran\'s Alliance and Horde quarters: the Silver Enclave and the Sunreaver\'s Sancturary.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32202,'Class Trainer','Class Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32203,'There is a black market of sorts in the northeastern portion of the sewers.','There is a black market of sorts in the northeastern portion of the sewers.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32204,'A tunnel leads out to the bottom of the city in the western sewers, just north of the Cantrips and Crows Tavern.$B$BSome of the more adventurous sorts use it to fly in and out of Dalaran.','A tunnel leads out to the bottom of the city in the western sewers, just north of the Cantrips and Crows Tavern.$B$BSome of the more adventurous sorts use it to fly in and out of Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32205,'You\'re looking for the Cantrips and Crows Tavern in the western sewers.','You\'re looking for the Cantrips and Crows Tavern in the western sewers.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32206,'There is a goblin-run bank down here, just north of the Cantrips and Crows Tavern in the western sewers.','There is a goblin-run bank down here, just north of the Cantrips and Crows Tavern in the western sewers.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32207,'The Steamwheedle Cartel hosts an entire arena circuit in the central sewers of Dalaran.$B$BYou\'ll find dueling rings there, too, at the Circle of Wills.','The Steamwheedle Cartel hosts an entire arena circuit in the central sewers of Dalaran.$B$BYou\'ll find dueling rings there, too, at the Circle of Wills.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32208,'A ramp leads up to just outside Krasus\' Landing in the eastern sewers.','A ramp leads up to just outside Krasus\' Landing in the eastern sewers.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32209,'A ramp leads up to near the Violet Citadel in the western sewers.','A ramp leads up to near the Violet Citadel in the western sewers.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32210,'There are three ways out of the Underbelly: Ramps leading up to the east and west, and the tunnel that drops out of the bottom of Dalaran.$B$BBe certain you can fly before you take that tunnel, of course.','There are three ways out of the Underbelly: Ramps leading up to the east and west, and the tunnel that drops out of the bottom of Dalaran.$B$BBe certain you can fly before you take that tunnel, of course.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32211,'Sewer Tunnel','Sewer Tunnel',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32212,'Welcome to the Underbelly. Something I can help you find?','Welcome to the Underbelly. Something I can help you find?',3,1,0,0,2,0,0,0,1,0,0,0,26124),
(32213,'The Scourge must be stopped at any cost. We cannot permit them to field the army they\'re constructing here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32214,'%s runs to his anvil!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32215,'Sewer Exits','Sewer Exits',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32216,'Vendors','Vendors',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32217,'No one throws rocks at me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32218,'You wouldn\'t like me when I\'m angry...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32220,'Finally! An excuse to squash you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32221,'You die for good this time, skeleton!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32222,'Last straw...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32223,'I was waiting for a reason to tear you bone from bone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32224,'That\'s the last mistake you\'ll make, skeleton.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32225,'Help us! Please!','Help us! Please!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32226,'We\'ve lost Undercity. Nothing but demons and Putress\' apothecaries left there...','We\'ve lost Undercity. Nothing but demons and Putress\' apothecaries left there...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32227,'You must help! We\'re homeless!','You must help! We\'re homeless!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32228,'Could you spare a gold?','Could you spare a gold?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32229,'They killed hundreds! We barely escaped with our lives! Help!','They killed hundreds! We barely escaped with our lives! Help!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32230,'The Dark Lady fought off as many as she could, but in the end... I hope she survived. Please help!','The Dark Lady fought off as many as she could, but in the end... I hope she survived. Please help!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32231,'We Forsaken are doomed! Take pity!','We Forsaken are doomed! Take pity!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32232,'What is going on?\n','What is going on?\n',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32233,'What are all these Forsaken doing here?\n','What are all these Forsaken doing here?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32234,'Why is the city under lock down?','Why is the city under lock down?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32235,'We demand answers!','We demand answers!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32236,'Where is the Warchief?','Where is the Warchief?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32237,'When can we reopen our shops? I\'m losing gold here!','When can we reopen our shops? I\'m losing gold here!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32238,'This is an outrage!','This is an outrage!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32239,'Why is Thrall allowing this to happen to our city?','Why is Thrall allowing this to happen to our city?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32240,'SILENCE!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32241,'We are on the brink of all out war with the Alliance!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32242,'Tragic events have unfolded in Northrend. The Warchief is doing all that he can to keep us safe.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32243,'All services and shops are to remain closed until further notice! That is all!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32244,'','%s looks around Krasus\' Landing, bored.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32245,'','%s yawns quietly into the palm of her hand.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32246,'Mine hit me!','Mine hit me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32247,'','Come, Cloudwing. Let\'s do a lap.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32248,'Horde Hit!','Horde Hit!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32249,'','%s sighs softly and rolls her shoulders.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32250,'Alliance Hit!','Alliance Hit!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32251,'','I\'m bored, Cloudwing. Go, go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32252,'','Feeling as restless as I am, Cloudwing? Then let us fly!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32253,'','Our way is sacred.  We will choose death before we abandon Thorim and join the likes of the Lich King.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32254,'For too long I tolerated my brother.  It is time to set things right.  It is time to destroy him and his followers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32255,'DISCOVERY!   $n has discovered a new inscription!','DISCOVERY!   $n has discovered a new inscription!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32256,'Please, $r.$b$bRelease me...','Please, $r.$b$bRelease me...',0,0,0,0,0,0,0,0,1,7904,0,0,26124),
(32257,'Don\'t think, $c.$b$bJust... do it....','Don\'t think, $c.$b$bJust... do it....',0,0,0,0,0,0,0,0,1,7904,0,0,26124),
(32258,'Tell my family...$b$bMy last thoughts were of them...','Tell my family...$b$bMy last thoughts were of them...',0,0,0,0,0,0,0,0,1,7904,0,0,26124),
(32259,'Send me on my way... I beg you...','Send me on my way... I beg you...',0,0,0,0,0,0,0,0,1,7904,0,0,26124),
(32260,'Do it, $c...Then... avenge me!','Do it, $c...Then... avenge me!',0,0,0,0,0,0,0,0,1,7904,0,0,26124),
(32261,'Please, $r...$b$bLeave nothing for the Scourge to raise!','Please, $r...$b$bLeave nothing for the Scourge to raise!',0,0,0,0,0,0,0,0,1,7904,0,0,26124),
(32262,'Travel well, hero of the Alliance!','Travel well, hero of the Alliance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32263,'Heed your blades, Orcs!','Heed your blades, Orcs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32264,'Prepare for battle, it looks like the Apothecarium already has their Blight aimed at the entrance!','Prepare for battle, it looks like the Apothecarium already has their Blight aimed at the entrance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32265,'Forward to glory, Orcs!','Forward to glory, Orcs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32266,'That wretch Putress won\'t get away with this!','That wretch Putress won\'t get away with this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32267,'How could we not have seen this coming, to think a Dreadlord could be trusted!','How could we not have seen this coming, to think a Dreadlord could be trusted!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32268,'I can hardly believe the Cult was so careless as to leave these behind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32269,'I am prepared to join the assault, Keritose. Do you have a skeletal gryphon ready for me?','I am prepared to join the assault, Keritose. Do you have a skeletal gryphon ready for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32270,'<Seize control of a Lithe Stalker through the eye.>','<Seize control of a Lithe Stalker through the eye.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32271,'This kingdom belongs to the Scourge. Only the dead may enter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32272,'Hassh tak heeeek ta!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32273,'You were foolish to come.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32274,'As Anub\'arak commands!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32275,'We are besieged! Strike out and bring back their corpses!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32276,'We must hold the gate. Attack! Tear them limb from limb!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32277,'The gate must be protected at all costs. Rip them to shreds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32278,'Keep an eye on that tunnel. We must not let anyone through!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32279,'I hear footsteps. Be on your guard.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32280,'I sense the living. Be ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32281,'They hunger....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32282,'Dinner time, my pets!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32283,'I should be grateful... but I long ago lost the capacity....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32284,'Return to the Weeping Quarry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32285,'Arthas\'s weakness is his pride. That weakness only grows as his power does. The Ebon Blade will have its chance to strike at the once-prince - of that I have no doubt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32286,'Kor\'kron, stand down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32287,'Jaina...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32288,'','Thrall, what has happened? The King is preparing for war...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32289,'Jaina, what happened at the Wrath Gate. It was a betrayal from within...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32290,'','Lady Proudmoore, the Warchief speaks the truth. This subterfuge was set in motion by Varimathras and Grand Apothecary Putress. It was not the Horde\'s doing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32291,'','As the combined Horde and Alliance forces began their assault upon the Wrath Gate, an uprising broke out in the Undercity. Varimathras and hordes of his demonic brethren attacked. Hundreds of my people were slain in the coup. I barely managed to escape with my life.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32292,'The Horde has lost the Undercity.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32293,'We now prepare to lay siege to the city and bring the perpetrators of this unforgivable crime to justice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32294,'If we are forced into a conflict, the Lich King will destroy our divided forces in Northrend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32295,'We will make this right, Jaina. Tell your king all that you have learned here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32296,'','I will deliver this information to King Wrynn, Thrall, but...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32297,'','Bolvar was like a brother to him. In the King\'s absence, Bolvar kept the Alliance united. He found strength for our people in our darkest hours. He watched over Anduin, raising him as his own. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32298,'','I fear that the rage will consume him, Thrall. I remain hopeful that reason will prevail, but we must prepare for the worst... for war.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32299,'','Farewell, Warchief. I pray that the next time we meet it will be as allies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32300,'Kor\'kron, prepare transport to the Undercity.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32301,'TEXT GOES HERE','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32302,'Take me to page 2.','Take me to page 2.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32303,'','%s spins her web into a cocoon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32304,'','%s sprays strands of web everywhere!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32305,'','Spiderlings appear on the web!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32306,'%s teleports into the fray!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32307,'The central gate opens!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32308,'Eternal agony awaits you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32309,'You shall experience my torment first hand!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32310,'You have made your choice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32311,'Soon the master\'s voice will call to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32312,'Auum na-l ak-k-k-k, isshhh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32313,'Come forth, my brethren! Feast on their flesh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32314,'Your armor is useless against my locusts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32315,'Uunak-hissss tik-k-k-k-k!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32316,'A pestilence upon you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32317,'Ahhh... RAAAAAGH! Never thought... I would be free of him....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32318,'%s sprays slime across the room!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32319,'%s injects you with a mutagen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32320,'How can I help?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32321,'%s decimates all nearby flesh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32322,'','What can I be helping you with?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32323,'Good Morning!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32324,'The polarity has shifted!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32325,'','Is there anything you can pay me to do?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32326,'FIRE IN THE HOLE!','FIRE IN THE HOLE!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32327,'This one\'s for Saurfang!','This one\'s for Saurfang!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32328,'BURN IN HELLFIRE!','BURN IN HELLFIRE!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32329,'We\'re taking it back!','We\'re taking it back!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32330,'We\'ll burn it to the ground before giving it to you!','We\'ll burn it to the ground before giving it to you!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32331,'%s teleports to the balcony above!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32332,'%s teleports and begins to channel a spell!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32333,'%s rushes to attack once more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32334,'An aura of necrotic energy blocks all healing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32335,'The aura fades away, allowing healing once more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32336,'Good day to you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32337,'Retrain me in Cloth Scavenging.','Retrain me in Cloth Scavenging.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32338,'You shouldn\'t have done that!  He\'s not going to like it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32339,'HEROES OF THE HORDE, YOUR WARCHIEF CALLS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32340,'Blood and thunder, champions of the Horde! We fight on this day for our fallen brothers and sisters! Mourn them not for they all died with honor in their hearts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32341,'Though we face great conflict, our might combined shall obliterate those who would oppose us! The grave injustices committed against the Horde will be met by an unstoppable force of reckoning!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32342,'I call to you great spirits! Grant the Horde your blessing! For on this day our cause is righteous and just!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32343,'','The air battle rages close, $n.  Both we and the Horde send bombers into the Bombardment and the Valley of Lost Hope.  Will you enter the fray?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32344,'Give me a bomber!','Give me a bomber!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32345,'The hum of magic energy in the air diminishes...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32346,'Sorta busy.','Sorta busy.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(32347,'What? I\'m busy here.','What? I\'m busy here.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(32348,'On duty. GO. AWAY.','On duty. GO. AWAY.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(32350,'Intruders! Who trespasses in the Old Kingdom?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32351,'Alright boys, let\'s do this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32352,'Nice work! We can only rest a moment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32353,'Thanks for keeping us covered back there! We\'ll hold the gate while we wait for reinforcements.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32354,'','$n\'s exotic fighting technique throws the Drakerider off-balance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32355,'','What the--?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32356,'','You fight like a beast!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32357,'','Where did you learn that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32358,'Are you ready to begin the assault and win back the Undercity for the Horde, $n?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32359,'I am ready, Warchief.','I am ready, Warchief.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32360,'The elements are with us in force, $n. With their help, we will do all that is in our power to stop Varimathras and Putress! LOK\'TAR OGAR!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(32361,'Gather behind me at the gates of the Undercity! Soon we march upon our fallen city and reclaim it - FOR THE HORDE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32362,'Spirits of wind, carry to Saurfang the Younger the song of war! May ALL of our fallen brethren be vindicated by this battle!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32363,'The battle for the Undercity begins now! Sound the horns of war! Champions of the Horde, be empowered by the might of your Warchief!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32364,'','Oh my gosh! Keep your voice down, $n! What? Are you trying to get us killed?!$B$BOf course I know who you are! Who in the Alliance doesn\'t know the name, $n?!$B$BSay, what do you think of my jumpbot? She\'s based off of the mechagnome design. Sleek and aerodynamic!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(32365,'Whoa, whoa, whoa! Keep it down, $n. Keep it down!$B$B<Blast looks around.>$B$BWe don\'t want those frosty vrykul noticing us, now do we?$B$BWhat do you think of my jumpbot? I based it off of the mechagnome. Pretty slick, huh?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(32366,'ONWARD!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32367,'Great wind brother, clear our path!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32368,'You must answer to the elements, demon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32369,'Great water spirit, wash away this corruption!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32370,'Return to Ymirheim or your jumpbot will fall to pieces!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32371,'I\'m ready, Brann. Let\'s make the keystone.','I\'m ready, Brann. Let\'s make the keystone.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32372,'Back to work Cultists!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32373,'Suited up and ready to go, sir!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32374,'My men are prepped and ready - just give us the word!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32375,'Welcome to my kingdom of darkness!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32376,'Did you enjoy my minion\'s terrible creation? Potent, is it not?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32377,'We\'re prepped, sir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32378,'Let us know when you\'d like us to lead the charge, commander!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32379,'We\'re ready, commander.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32380,'Armed and ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32381,'We\'re ready to bring the pain, sir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32382,'Just give the order, sir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32383,'But enough prattling! You wish to reclaim your city? Come then, heroes! Your souls will fuel the host! You will have this place back in pieces!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32384,'We don\'t have any easy path before us. If you\'ve got a strong arm on you, stick around until one of my squads is ready to ascend to Ymirheim. They could use all the help they can get.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32385,'Right. Let\'s see if we can finish this keystone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32386,'Welcome, Brann Bronzebeard. I am all that remains of this temple\'s guardian.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32387,'You have proven yourself as an explorer and seeker of knowledge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32388,'You have been a steadfast ally to the Earthen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32389,'You and your companion have proven yourselves in combat and in the pursuit of the keystone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32390,'Your motives are pure. The keystone\'s parts shall be reunited. Go to Ulduar and learn the answers to your questions, Brann Bronzebeard.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32391,'The keystone is completed! We\'ve done it, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32392,'The Assurance has somehow become inundated with bugs and we are unable to set sail to Northrend.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(32393,'Who knows what secrets await within Ulduar\'s archives? I\'m off to discover them. Thank you again for your help, $n. Without it, I\'d still be searching for that key.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32394,'We were all set to sail into Northrend, but we\'ve noticed a severe number of pests aboard our ship.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(32395,'Before we can set sail to Northrend, we\'ve got to eliminate our pest problem aboard the Assurance.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(32396,'ATTACK!!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32397,'Incoming!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32398,'Heads up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32399,'On your feet, boys!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32400,'Ambush!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32401,'Watch out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32402,'Find some cover!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32403,'Group up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32404,'Vrykul attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32405,'On your feet, boys! Move, move move!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32406,'Well you\'re an ugly one! Don\'t mean you don\'t know how to fight though.$B$BOne of my squads should be geared and ready to march soon - get your sorry butt in line and make the climb with them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32407,'Incoming!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32408,'Geared and ready, commander.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32409,'On the move, men!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32410,'Quickly, catch your breaths before we press to the gate!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32411,'On your feet, men! Move, move move!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32412,'You\'ve got some fight in you! Blood and honor, friend!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32413,'Ambush!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32414,'Vrykul!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32415,'Weapons out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32416,'Time for some blood, men!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32417,'Leave none alive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32418,'For the horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32419,'Show no mercy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32420,'My men are eager for some blood, commander.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32421,'We\'re ready for glory, sir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32422,'We\'re ready for the push.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32423,'Geared up and ready to die. What would you have of us, sir?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32424,'Hell awaits us. Give the order!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32425,'Ready for a vrykul massacre, just give us the word, sir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32426,'On your word, commander.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32427,'','%s begins to sing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32428,'Ranked arena matches start again in $6318d.$B$BWould-be champions are already busy honing their skills and acquiring the best gear they can. Are you going to be ready?','Ranked arena matches start again in $6318d.$B$BWould-be champions are already busy honing their skills and acquiring the best gear they can. Are you going to be ready?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32429,'How I can guide your path, young one?','How I can guide your path, young one?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32430,'Guide me to the Fortress Graveyard.','Guide me to the Fortress Graveyard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32431,'Guide me to the Sunken Ring Graveyard.','Guide me to the Sunken Ring Graveyard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32432,'Guide me to the Broken Temple Graveyard.','Guide me to the Broken Temple Graveyard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32433,'Guide me to the Eastspark Graveyard.','Guide me to the Eastspark Graveyard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32434,'Guide me to the Westspark Graveyard.','Guide me to the Westspark Graveyard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32435,'Guide me back to the Alliance landing camp. ','Guide me back to the Alliance landing camp. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32436,'Guide me back to the Horde landing camp. ','Guide me back to the Horde landing camp. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32437,'YAAAAAAAARGGGGHHHHH!!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32438,'Lives depend on the actions we take here.  Be quick with what you have to say, $c.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(32439,'Do you bring news of battle, $r?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(32440,'The best war is a swift war.  The same can be said of conversation.  What say you $r?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(32441,'','This portal leads to the Caverns of Time, deep beneath the earth in far-off Tanaris.$B$BI possess the power to send you there, should you so desire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32442,'','This portal leads to the Caverns of Time, deep beneath the earth in far-off Tanaris.$B$BUntil you have grown stronger, though, I must ask you not to travel there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32443,'','I can smell the gunpowder from all the bombs and rockets!  You want to get out there and join the fun?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32444,'The voices are talking to me.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(32445,'I must obey.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(32446,'You have to get out of here before it gets to you, too!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(32447,'Tell me about the Wispcloak Recipe.','Tell me about the Wispcloak Recipe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32448,'We\'re almost ready to depart. Just give us a little bit longer to finish our preparations.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32449,'We\'re still making preparations. We won\'t be ready to go for a while.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32450,'It\'s all around us. It\'s in my head!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(32451,'My men are ready. Let\'s draw some Vrykul blood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32452,'The saronite... there\'s something in it!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(32453,'There\'s something here.  It\'s in the rocks and the earth!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(32454,'In my travels I have learned the recipe for the Wispcloak.$B$BThis cloak is a tradeable Epic spellcasting cloak that grants Stamina, Spellpower, Intellect and Mana Recovery.   I am looking for someone worthy to teach this recipe to.$B$BSomeone who had completed all the normal dungeons of Northrend and had the \"Northrend Dungeonmaster\" achievement would be worthy of learning the recipe for the Wispcloak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32455,'I am ready to learn the Wispcloak Recipe.','I am ready to learn the Wispcloak Recipe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32456,'I have to get out of here! Can you get me free?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(32457,'Can you hear it speaking in your mind?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(32458,'Go on, you\'re free.  Get out of here!','Go on, you\'re free.  Get out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32459,'I\'m ready to join your squad on the way to Ymirheim. Let\'s get moving.','I\'m ready to join your squad on the way to Ymirheim. Let\'s get moving.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32460,'The courtyard is ours! Onward to the inner sanctum!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32461,'HOLD! They\'ve destroyed the elevator!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32462,'','The shaft is trapped, Warchief. A fall would mean certain death.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32463,'I have ventured to dark places and learned the tailoring recipe for the Deathchill Cloak.$B$BThis cloak is a tradeable Epic cloak for spellcasters that grants Spellpower, Haste and Critical Strike.   I am looking for someone worthy to teach this recipe to.$B$BSomeone who had completed most of the quests across Northrend and had the \"Loremaster of Northrend\" achievement would be worthy of learning the recipe for the Deathchill Cloak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32464,'Tell me about the Deathchill Cloak Recipe.','Tell me about the Deathchill Cloak Recipe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32465,'DISCOVERY!   $n has discovered a new recipe!','DISCOVERY!   $n has discovered a new recipe!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32466,'I\'m coming, master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32467,'My life for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32468,'I am ready to learn the Deathchill Cloak Recipe.','I am ready to learn the Deathchill Cloak Recipe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32469,'I won\'t leave!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32470,'NO! You\'re wrong! The voices in my head are beautiful!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32471,'I don\'t want to leave! I want to stay here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32472,'I\'ll never return. The whole reason for my existence awaits below!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32473,'AHAHAHAHA... you\'ll join us soon enough!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32474,'I must get further underground to where he is. I must jump!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32475,'Since you are a tailor of some skill, I can tell you that I know some special recipes.   I know recipes for both the Wispcloak and the Deathchill Cloak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32476,'Varimathras has released the Blight aberration!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32477,'The plague cauldron begins to boil vigorously!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32478,'Something emerges from the cauldron!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32479,'Something emerges from the cauldron!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32480,'Three decent elites!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32481,'%s goes Berserk!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32482,'A SWARM of non-elites!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32483,'The cauldron continues to boil...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32484,'Neutralizing agent failing!$bAdd fluid soon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32486,'Neutralizing agent failing!$bAdd fluid NOW!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32487,'Neutralizing agent FAILED!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32488,'Plague batch neutralized!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32489,'','What have they done to my beautiful city!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32490,'Great air spirit, hear my call once more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32491,'The spirits of air have heard my call. Cyclones will lower us to safety. Now we jump!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32492,'Activating Defenses','Activating Defenses',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32493,'You! COME! Drink, feast, rest for the next battle.$B$BBut do not fight! Or I will feed you to my wolves.','You! COME! Drink, feast, rest for the next battle.$B$BBut do not fight! Or I will feed you to my wolves.',25,1,274,0,1,2,0,0,1,0,0,0,26124),
(32494,'We have breached the inner sanctum, heroes! We press on!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32495,'','The only redemption for the traitors responsible for this will be an agonizing death. My vengeance will be swift and without mercy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32496,'Lead the way, Dark Lady. We will follow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32497,'','Very well, Warchief. The Royal Quarter is this way. Stay on guard. There is no telling what Varimathras and Putress have in store for us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32498,'','The penalty for treason is death!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32499,'','You dare befoul my sanctum! Pay with your blood!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32500,'','The Horde will be victorious!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32501,'','You will be reunited with your master soon - in the afterlife.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32502,'','You disgust me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32503,'','The Banshee Queen has plans for you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32504,'','Beg for your miserable life!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32505,'','ON YOUR KNEES!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32506,'Please, no more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32507,'Hit me again and you\'ll regret it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32508,'Ow!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32509,'I\'m sorry. I\'ll work harder.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32510,'Soon the master will reclaim me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32511,'','I\'ll flay the flesh from your bones!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32512,'','Enough crazy talk from you worms. More work!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32513,'','There are no whispers in your mind. You\'re imagining it. Back to work!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32514,'','The Lich King demands more saronite. Work harder fools or we\'ll feed you to the creature!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32515,'','Perhaps cutting your rations in half will be incentive to get you to mine faster?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32516,'Taskmistress, the next slave to stop mining is to be fed to the creature!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32517,'Intruders in the mines! Deal with them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32518,'I see you, little one. Come over here, I wish to speak with you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32519,'Do not listen to the creature\'s lies. Get back to your work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32520,'','HOLD! I sense dark magic. Demon magic... Stand ready!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32521,'Clever girl...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32522,'This is my stop!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32523,'Welcome to the home of the Kirin Tor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32524,'My brothers have grown hungry. Your souls will sate their appetites.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32525,'I have lost my Schools of Arcane Magic - Mastery volume.  Can you provide me with a replacement?','I have lost my Schools of Arcane Magic - Mastery volume.  Can you provide me with a replacement?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32526,'Dropping. Good luck, boys!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32527,'Thanks for the cover!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32528,'Destination reached - engaging in scouting mission.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32529,'Infiltration commencing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32530,'Jeronimo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32531,'See you on the battlefield.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32532,'I\'ll kill one just for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32533,'%s makes a strange noise that translates as laughter in your mind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32534,'I\'m gonna spill your guts, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32535,'Ain\'t gonna be nothin\' left after this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32536,'You wanna see power? I\'m gonna show you power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32537,'Gut them! Impale them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32538,'KILL THEM ALL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32539,'Say hello to my BIG friend!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32540,'What a rush!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32541,'Who needs gods when we ARE gods?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32542,'I told ya so!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32543,'Even the mighty... can fall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32544,'The air around you crackles as Khanok the Impassable appears!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32545,'No hope for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32546,'You think you can wrest this rampart from my control?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32547,'I think not. When I\'ve finished beating the arrogance out of you, I\'ll impale your corpse on the spikes as an example to any other \'heroes\'!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32548,'Greetings, $c.$B$BWhen the Alliance controls Wintergrasp Fortress, I will open a portal for those who wish to travel there.$B$BThe next battle begins in $4354k.','Greetings, $c.$B$BWhen the Alliance controls Wintergrasp Fortress, I will open a portal for those who wish to travel there.$B$BThe next battle begins in $4354k.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(32549,'Teleport me to Lake Wintergrasp.','Teleport me to Lake Wintergrasp.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32550,'Greetings, $c.$B$BWhen the Horde controls Wintergrasp Fortress, I will open a portal for those who wish to travel there.$B$BThe next battle begins in $4354k.','Greetings, $c.$B$BWhen the Horde controls Wintergrasp Fortress, I will open a portal for those who wish to travel there.$B$BThe next battle begins in $4354k.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32551,'Greetings, $c.$B$BThe Alliance now controls Wintergrasp Fortress. Use the portal, if you like.$B$BThe next battle begins in $4354k.','Greetings, $c.$B$BThe Alliance now controls Wintergrasp Fortress. Use the portal, if you like.$B$BThe next battle begins in $4354k.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(32552,'Greetings, $c.$B$BThe Horde now controls Wintergrasp Fortress. Use the portal, if you like.$B$BThe next battle begins in $4354k.','Greetings, $c.$B$BThe Horde now controls Wintergrasp Fortress. Use the portal, if you like.$B$BThe next battle begins in $4354k.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32553,'Is that all, demon? Have you nothing left to throw at us?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32554,'%s begins to open a Twilight Portal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32556,'You may only fly in Icecrown, Sholazar Basin and the Storm Peaks.','You may only fly in Icecrown, Sholazar Basin and the Storm Peaks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32557,'','Adventurers, the door is beginning to weaken!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32558,'','Only half of the door seal\'s strength remains! You must fight on!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32559,'','The door seal is about to collapse! All is lost if the Blue Dragonflight breaks through the door!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32560,'Enough, Michael. Business is hurting enough with this scare as it is. We can use every copper.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32561,'For the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32562,'Greetings, friend.  Something I can do for ya?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32563,'Hey there, hold on just one second.  I see you\'re not riding a flying mount of your own.$B$BYou probably won\'t be of much use to the other goblins here if you can\'t get around.  They\'ve paid me to loan my used mounts to people such as yourself -- at no cost to you.$B$BInterested?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32564,'We come for you! Prepare yourself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32565,'COWARD! You think to stop the Warchief of the Horde with pebbles? I will show you the true power of the elements!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32566,'I\'m interested.','I\'m interested.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32567,'','The Royal Quarter is just up ahead, Warchief.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32568,'Bring down the halls! NOW!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32569,'%s grudgingly nods.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32570,'I can\'t argue with that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32571,'The soldiers are doing important work. The safety of the people is more important, Mal, if you\'re interested in your customers living to spend another day.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32572,'Don\'t worry too much. By the time I went off duty, we hadn\'t found a scrap of befouled grain here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32573,'Thank the Light for that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32574,'%s nods.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32575,'Great spirits of the earth, help us in our hour of need!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32576,'What kind of help do you require?','What kind of help do you require?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32577,'I\'ve got a lead on Norgannon\'s keystone, which guards access to Ulduar\'s archives, but the Titans divided it into two pieces and secreted them away.$B$BOne of the pieces, the keystone\'s shell, is held within the Inventor\'s Library on the northern coast, south of Ulduar itself. The first thing you\'ll need to do is retrieve the fragments of an access disk from the library\'s guardians.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32578,'It is time.  May the Light give us strength.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32579,'A thousand-thousand pardons, Master! I will deal with these intruders myself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32580,'Welcome to your future -- what little there is left of it...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32581,'','When it comes to treasure, never be lookin\' sideways at lootin\' someone else\'s junk. Stolen goods be much sweeter, ya? But free is free, no matta how it got that way!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32582,'Uninvited guests!  Did you think you\'d go unnoticed inside my dominion?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32583,'LET\'S GO! QUICKLY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32584,'What is this?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32585,'I must confess... you were not altogether unexpected.  I hope you find your final resting place... to your liking.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32586,'','I always be up for a nice three-finger discount. Stealin\' be all in the wrist... and when that fails ya, then ya stick somethin\' sharp in between the ribs, and that\'s all in the wrist too.$B$BSkilled hands be worth more than a steady paycheck, ya heard?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32587,'','I don\'t be worryin\' \'bout no Lich Kings. Seen a lotta big-shots come and go, dey always messin\' somethin\' up. It ain\'t long aftah that when a posse rolls on through and sends dem quick on dey way to da history books. Dis one ain\'t no different.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32588,'Last time we met, you had the advantage of fighting on holy ground.  You\'ll find that our situation has been... reversed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32589,'That might be, but I don\'t need to stand on holy ground to run that disembodied heart of yours with the Ashbringer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32590,'The heart... the last remaining vestige of your humanity.  I had to stop it from being destroyed.  I had to see for myself.  And at last I\'m sure...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32592,'You sound a little too confident.  Especially considering the way our last encounter ended.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32593,'I call your bluff.  You\'re a paladin after all.  Your obsession with redemption goes beyond the inane.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32594,'You surely wouldn\'t destroy humanity\'s only chance to redeem its most wayward son.  You\'d sooner die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32595,'Only shadows from the past remain.  There\'s nothing left to redeem!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32596,'Shgla\'yos plahf mh\'naus.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32597,'They who dine on lost souls know only hunger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32598,'Ywaq ma phgwa\'cul hnakf.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32599,'Uulwi gag erh\'ongg w\'ssh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32600,'Ywaq puul skshgn: on\'ma yeh\'glu zuq.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32601,'Iilth vwah, uhn\'agth fhssh za.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32602,'Ywaq maq oou; ywaq maq ssaggh. Ywaq ma shg\'fhn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32603,'Gul\'kafh an\'shel. Yoq\'al shn ky ywaq nuul.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32604,'Gaze into the void. It is the perpetuity in which they dwell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32605,'They are the whisper on the shivering wind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32606,'Their shadow will choke the land for eternity.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32607,'They drink your fear: it is the blood of life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32608,'Where one falls, many shall take its place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32609,'They do not die; they do not live. They are outside the cycle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32610,'Too long... Tireless, endless planning... It will not end like this...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32611,'Need more time... The Master is near...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32612,'Such power! Can you not feel it, mortals? Cease this foolishness and join me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32613,'I will not fail! Not again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32614,'I cannot hold... Destabilizing...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32615,'We lost many to the faceless ones, my lord.  But we succeeded in retrieving the heart from Naz\'anak.','We lost many to the faceless ones, my lord.  But we succeeded in retrieving the heart from Naz\'anak.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32616,'Keep your heads down and follow my lead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32617,'Years... wasted...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32618,'YOU HAVE FAILED ME, VARIMATHRAS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32619,'Here it comes.  Stand ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32620,'Something\'s wrong... I sense a dark presence.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32621,'The Lich King is here.  May the Light guide our blades.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32622,'The prisoner sobs desperately, waiting for the end to come.','The prisoner sobs desperately, waiting for the end to come.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32623,'Only a fool would mock the appearance of my battle-garb.$B$BThis raiment of well-worn steel is from an ancient place of learning!','',1,5,0,0,2,0,0,0,1,0,0,0,26124),
(32624,'I will not die so quickly this time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32625,'','Champions! My children, blessed with my power, shall aid you in your fight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32626,'','I did what I had to, brother. You gave me no alternative.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32627,'','And so ends the Nexus War. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32628,'','This resolution pains me deeply, but the destruction, the monumental loss of life had to end. Regardless of Malygos\' recent transgressions, I will mourn his loss. He was once a guardian, a protector. This day, one of the world\'s mightiest has fallen.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32629,'','The red dragonflight will take on the burden of mending the devastation wrought on Azeroth. Return home to your people and rest. Tomorrow will bring you new challenges, and you must be ready to face them. Life... goes on.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32630,'What?!','What?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32631,'Wait a minute, I didn\'t activate my...?','Wait a minute, I didn\'t activate my...?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32632,'I feel funny all of a sudden.  Er?!','I feel funny all of a sudden.  Er?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32633,'Okay, who\'s the joker that threw an orb at me?','Okay, who\'s the joker that threw an orb at me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32634,'NOOOOOO!','NOOOOOO!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32635,'Not a sentry!','Not a sentry!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32636,'You\'ve got it all wrong. I\'m a subjugator!','You\'ve got it all wrong. I\'m a subjugator!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32637,'It was an accident. I was framed. Don\'t drop me!','It was an accident. I was framed. Don\'t drop me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32638,'casually flips his |Hitem:44430|h|cff0070dd[Titanium Seal of Dalaran]|r|h.','casually flips her |Hitem:44430|h|cff0070dd[Titanium Seal of Dalaran]|r|h.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32639,'How dare you interfere with our work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32640,'Insignificant.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32641,'Your timeline is no more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32642,'My time... has run out...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32643,'WE ARE VICTORIOUS!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32644,'The Undercity belongs to the Horde once more! LOK\'TAR!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(32645,'You have my thanks for saving my existence in this timeline. Now I must report back to my superiors. They must know immediately of what I just experienced.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32646,'Dark Lady, join me! You have fought hard and spilled much blood for this right. The Royal Quarter belongs to you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32647,'','Such will be the fate of all enemies of the Horde, Warchief.  Now we must deal with the wretch, Putress.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32648,'We shall, Sylvanas...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32649,'Alliance horns? Stay on guard!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32650,'You\'ll find what you are looking for at One More Glass in northern Dalaran.','You\'ll find what you are looking for at One More Glass in northern Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32651,'The Militant Mystic in southern Dalaran should have what you desire.','The Militant Mystic in southern Dalaran should have what you desire.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32652,'The Hunter\'s Reach in eastern Dalaran sells guns, bows, ammunition and the like.','The Hunter\'s Reach in eastern Dalaran sells guns, bows, ammunition and the like.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32653,'The Arsenal Absolute in southeast Dalaran carries all manner of melee weapons.','The Arsenal Absolute in southeast Dalaran carries all manner of melee weapons.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32654,'If I am ever freed of these chains, I will return one day and slay you myself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32655,'This will be nothing when compared to the satisfaction I will feel when I crush your skull beneath my heel.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32656,'Jepetto Joybuzz\'s Wonderworks in western Dalaran carries such items.','Jepetto Joybuzz\' Wonderworks in western Dalaran carries such items.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32657,'I\'d sooner serve the Dark Lord Alexander than be your pitiful pet.','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(32658,'I hear your kind squeals like a felhunter when roasted alive over a fire.','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(32659,'You have delved too far into our magics. I will claim your soul myself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32660,'I play all of my records backwards. Except for the ones by Arrowsmite and Sons.','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(32661,'The Twisting Nether\'s coldest reaches shall not hide you from my vengeance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32662,'I serve only Sargeras! You shall join him too someday, mortal...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32663,'catches the coin heads up!','catches the coin heads up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32664,'finds the coin face down for tails!','finds the coin face down for tails!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32665,'Red at Glorious Goods in southeast Dalaran can provide most general trade supplies.$B$BIf you need something more specialized, try the Magus Commerce Exchange. Each trade shop there has its own supply vendor.','Red at Glorious Goods in southeast Dalaran can provide most general trade supplies.$B$BIf you need something more specialized, try the Magus Commerce Exchange. Each trade shop there has its own supply vendor.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32666,'The process is finally complete! My work here is done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32667,'Aimee\'s cart can usually be found in northern Dalaran, near the Bank of Dalaran.','Aimee\'s cart can usually be found in northern Dalaran, near the Bank of Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32668,'The Magical Menagerie is located in northeast Dalaran. Pet supplies, exotic mounts, and stables are all available there.','The Magical Menagerie is located in northeast Dalaran. Pet supplies, exotic mounts, and stables are all available there.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32669,'You\'ll find reagants and more at the Sisters Sorcerous in western Dalaran.$B$BJust mind the Mooreheads\' black cat...','You\'ll find reagants and more at the Sisters Sorcerous in western Dalaran.$B$BJust mind the Mooreheads\' black cat...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32670,'','Oh, no! Adventurers, something awful has happened! A colleague of mine has been captured by the Infinite Dragonflight, and they\'re doing something horrible to him!$B$BKeeping Arthas is still your highest priority, but if you act fast you could help save a Guardian of Time!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32671,'Glorious Goods in southern Dalaran should have all the general goods you need.','Glorious Goods in southern Dalaran should have all the general goods you need.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32672,'Applebough\'s fruit cart is usually in southwest Dalaran, near the Silver Enclave.','Applebough\'s fruit cart is usually in southwest Dalaran, near the Silver Enclave.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32673,'You can normally find Miss Primrose\'s flower stand in southeast Dalaran.','You can normally find Miss Primrose\'s flower stand in southeast Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32674,'Adventurers may be rewarded for their just deeds in the Silver Enclave or Sunreaver\'s Sanctuary.','Adventurers may be rewarded for their just deeds in the Silver Enclave or Sunreaver\'s Sanctuary.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32675,'Tanks for Everything in northern Dalaran is the city\'s most popular plate armor and shield merchant.','Tanks for Everything in northern Dalaran is the city\'s most popular plate armor and shield merchant.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32676,'The various merchants of Curiosities & Moore in southern Dalaran sell trinkets, relics, heirlooms, and off-hand items of all sorts.','The various merchants of Curiosities & Moore in southern Dalaran sell trinkets, relics, heirlooms, and off-hand items of all sorts.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32677,'Langrom\'s Leather & Links in southern Dalaran should have what you seek.','Langrom\'s Leather & Links in southern Dalaran should have what you seek.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32678,'','Adventurers, you must hurry! The Guardian of Time cannot last for much longer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32679,'','I can barely sense the Guardian of Time! His timeline is fading quickly!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32680,'The Threads of Fate in western Dalaran is the city\'s most popular supplier of clothing and cloth armor.','The Threads of Fate in western Dalaran is the city\'s most popular supplier of clothing and cloth armor.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32681,'What sort of weapons?','What sort of weapons?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(32682,'Melee Weapons','Melee Weapons',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32683,'Ranged & Thrown Weapons','Ranged & Thrown Weapons',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32684,'Staves & Wands','Staves & Wands',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32685,'What sort of armor?','What sort of armor?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(32686,'Cloth Armor','Cloth Armor',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32687,'Tirion\'s down!  Defend him with your lives!','Tirion\'s down!  Defend him with your lives!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32688,'Leather Armor','Leather Armor',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32689,'Mail Armor','Mail Armor',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32690,'Plate Armor','Plate Armor',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32691,'I was away for too long. My absence cost us the lives of some of our greatest heroes. Trash like you and this evil witch were allowed to roam free -- unchecked.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32692,'Shields','Shields',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32693,'The time has come to make things right. To disband your treacherous kingdom of murderers and thieves. Putress was the first strike. Many more will come.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32694,'Arrrrggggggggggh!!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32695,'Come to make yourself useful?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32696,'Come to make yourself useful?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32697,'I\'ve waited a long time for this, Thrall. For every time I was thrown into one of your damned arenas... for every time I killed a green-skinned aberration like you... I could think of only one thing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32698,'You... will pay for that, old man.  Slay them all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32699,'What our world could be without you and your twisted Horde... It ends now, Warchief.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32700,'ATTACK! FOR STORMWIND! FOR BOLVAR! FOR THE ALLIANCE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32701,'Which vendor where you seeking?','Which vendor where you seeking?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(32702,'Armor','Armor',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32703,'Clothing','Clothing',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32704,'Justice Quartermasters','Justice Quartermasters',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32705,'Flowers','Flowers',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32706,'Fruit','Fruit',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32707,'Quick, through the portal!  He won\'t stay down for long.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32708,'Take courage, crusaders.  You do not fight alone!','',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(32709,'','VARIAN, NO! STOP!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32710,'I hope you fellows don\'t mind if we crash this party.  I brought some old friends with me!','',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(32711,'','It did not have to be like this...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32712,'General Goods','General Goods',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32713,'Jewelry','Jewelry',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32715,'Pet Supplies & Exotic Mounts','Pet Supplies & Exotic Mounts',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32716,'Pie, Pastry & Cakes','Pie, Pastry & Cakes',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32717,'Reagents & Magical Goods','Reagents & Magical Goods',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32718,'Toys','Toys',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32719,'Trade Supplies','Trade Supplies',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32720,'Trinkets, Relics & Off-hand Items','Trinkets, Relics & Off-hand Items',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32721,'Weapons','Weapons',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32722,'Looks like whatever Tirion did put some hurt on the Lich King.  It\'s too bad we can\'t finish him off.... ','',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(32723,'Wine & Cheese','Wine & Cheese',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32724,'Vendors','Vendors',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32725,'The Lich King is badly hurt.  We ought to stay behind and finish him.','',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(32726,'Patience... we will get our chance soon enough.  Be content that for once, it is Tirion who is in our debt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32727,'The secret to goblin engineering has nothing to do with keeping things from exploding. It has everything to do with directing the explosions exactly where you want them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32728,'It ends like it began...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32729,'All that we have fought for in this world is lost. The hopes and dreams carried by my father and mother... by Doomhammer... Gone...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32730,'If only you were here right now, old friend. You would know what to do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32731,'I know what he would do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32732,'He would say to you: Thrall. Lead your people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32733,'Let\'s go home, old friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32734,'%s nods.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32735,'It\'s good to have you back, Varok, old friend. I\'m sorry about your boy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32736,'%s joins in and grabs a bite to eat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32737,'I am Xarantaur, the Witness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32738,'Would you like to hear a story?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32739,'Do you have a story for me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32740,'Ah yes, I have read of you, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32741,'Tell me of yourself, Xarantaur. Why are you called the Witness?','Tell me of yourself, Xarantaur. Why are you called the Witness?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32742,'I was one of the first tauren druids, of the last generation taught by Shan\'do Cenarius, before the Legion, before the Sundering, when the world was still young. Before everything changed.$B$BWhile my brethren hunted great beasts, I hunted stories. I had been drawn to the druidic arts by this hunger, this lust for knowledge. For a time, that hunger was sated as I learned to talk to the trees, rocks, and beasts, and heard their stories.$B$BBut then, the time came when Cenarius walked among us no more and my brethren began to forget what he had taught us. I could not forget, though, and I still needed to learn more about our world.$B$BSo I said my farewells and travelled beyond the lands of my people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32743,'Please, go on.','Please, go on.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32744,'I wandered for the rest of my natural life in search of knowledge, seeing more wonder and meeting more strange and mysterious races than any of my people before me. I travelled across the length and breadth of ancient Kalimdor until there was no more to see, no new lands across the horizon.$B$BYet... there was still so much I did not know as I felt my final journey approaching and I wept for the things I would never know.$B$BAs I fell, my life at an end, that is when they found me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32745,'They?','They?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32746,'The bronze dragonflight. They snatched me from the brink of death and took me before their master, Nozdormu. He said they had been watching me and wanted me to continue my hunt. He granted me immortality as a watcher, tasked to bear witness to the history of Azeroth as one of his agents.$B$BI am Xarantaur the Witness, and it is my duty to preserve the true history of Azeroth lest it be forgotten.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32747,'This is Camp Tunka\'lo, the village ruled by my brother, but I... I don\'t remember you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32748,'And it very nearly didn\'t remember you. $n fought bravely against the North Wind to protect your story.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32749,'The North Wind? It still troubles my people?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32750,'Your battle with the wind was hundreds of years ago, Stormhoof. You weakened it so much that it has been silent all these years.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32751,'But the North Wind did not silently accept defeat. Instead, it gathered power and bided its time, deciding the best revenge was to destroy your memory, and with it, your village.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32752,'The wind used its minions to distort the history of this place, changing the stories your people told, destroying the spirits of the honored dead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32753,'Khit\'rix the Dark Master skitters into Valhalas from the southeast!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32754,'It would\'ve succeeded if $n and I hadn\'t tracked the North Wind\'s historical corruptions to their source: your ancient battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32755,'With my help, $n travelled back in time to your battle, and ensured that history was set right. The North Wind\'s fate was sealed, and your story restored.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32756,'You both have my thanks and that of the village, though many will never know of your deeds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32757,'Circling Valhalas, Sigrid Iceborn approaches to seek her revenge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32758,'Lumbering in from the south, the smell of Carnage precedes him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32759,'I cannot remain here. I must return to my cairn where I belong, but when I see the ancestors again, it is I who will tell your story.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32760,'Thane Banahogg appears upon the overlook to the southeast!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32761,'Without warning, Prince Sandoval magically appears within Valhalas!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32762,'Rest well, hero.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32763,'%s swipes at you with his claws!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(32764,'Whoa! You\'re me, but from the future!  Hey, my equipment got an upgrade.  Cool!','Whoa! You\'re me, but from the future!  Hey, my equipment got an upgrade.  Cool!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32765,'','Only time will tell...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32766,'Alexstrasza, can you show me what happened here?','Alexstrasza, can you show me what happened here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32767,'Welcome to the Wonderworks!$B$BPlease take your time and browse the shop. We have wonderful toys for people young and old!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32768,'I have lost my Titanium Seal of Dalaran.  Can you provide me with a replacement?','I have lost my Titanium Seal of Dalaran.  Can you provide me with a replacement?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32769,'Here come the Infinites!  I\'ve got to keep the hourglass safe.  Can you help?','Here come the Infinites!  I\'ve got to keep the hourglass safe.  Can you help?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32770,'This equipment looks cool and all, but couldn\'t we have done a little better?  Are you even raiding?','This equipment looks cool and all, but couldn\'t we have done a little better?  Are you even raiding?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32771,'So, how does it all turn out in Icecrown?','So, how does it all turn out in Icecrown?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32772,'Chromie said that if I don\'t do this just right, I might wink out of existence.  If I go, then you go!','Chromie said that if I don\'t do this just right, I might wink out of existence.  If I go, then you go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32773,'Looks like I\'m an underachiever.','Looks like I\'m an underachiever.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32774,'I think I\'m going to turn to drinking after this.','I think I\'m going to turn to drinking after this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32775,'It might help if you could tell me how many of these guys we\'re going to fight.  You can remember that, right, grandpa?','It might help if you could tell me how many of these guys we\'re going to fight.  You can remember that, right, grandma?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32776,'I just want you to know that if we get through this alive, I\'m making sure that we turn out better than you.  No offense.','I just want you to know that if we get through this alive, I\'m making sure that we turn out better than you.  No offense.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32777,'Wait a minute!  If you\'re here, then that means that in the not-so-distant future I\'m going to be you helping me?  Are we stuck in a time loop?!','Wait a minute!  If you\'re here, then that means that in the not-so-distant future I\'m going to be you helping me?  Are we stuck in a time loop?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32778,'How may I help you?','How may I help you?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32779,'How may I help you?','How may I help you?',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(32780,'How may I help you?','How may I help you?',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(32781,'What the heck?  Nozdormu is up there!','What the heck?  Nozdormu is up there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32782,'I feel like I\'m being pulled away through time.  Thanks for the help....','I feel like I\'m being pulled away through time.  Thanks for the help....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32783,'Sorry, I couldn\'t hold out.  I hope this doesn\'t mean that you\'re about to cease to exist....','Sorry, I couldn\'t hold out.  I hope this doesn\'t mean that you\'re about to cease to exist....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32784,'Your Grip is Failing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32785,'Who dares awaken me before the quickening?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32786,'You are no match for me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32787,'You should not have interfered...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32788,'My destiny is to serve the Lich King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32789,'I shall not be stopped!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32790,'Put down your arms fools... you are too late!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32791,'Come, join my minions. Serve me as I serve the Lich King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32792,'Too soon... too sooon....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32793,'Fools! Do not allow my rest to be interrupted again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32794,'DODGED!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(32795,'FATAL STRIKE MISSED! KEEP PRYING!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(32796,'Corpse Scarabs appear from a Crypt Guard\'s corpse!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32797,'','We must avoid another war with the Horde at all costs!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(32798,'Lady Proudmoore, I am ready to go to Orgrimmar. Please open a portal.','Lady Proudmoore, I am ready to go to Orgrimmar. Please open a portal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32799,'','Do not do anything that would incite the Horde, $n. The Warchief has agreed to see us on good faith.',0,0,0,0,0,0,0,0,1,7992,0,0,26124),
(32800,'','Let\'s go.',0,0,0,0,0,0,0,0,1,7992,0,0,26124),
(32801,'Sapphiron lifts off into the air!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32802,'Sapphiron resumes his attacks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32803,'Kel\'Thuzad strikes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32804,'A Guardian of Icecrown enters the fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32805,'The aura\'s power begins to wane!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32806,'This vehicle looks like it\'s seen better days.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32807,'Welcome!','Welcome!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32808,'Greetings, $c.','Greetings, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32809,'Greetings! Please have a look around.','Greetings! Please have a look around.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32810,'Let me know if you need help finding anything, $c.','Let me know if you need help finding anything, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32811,'Welcome. May I help you find something?','Welcome. May I help you find something?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32812,'Got somethin\' that needs tightening, $r?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32813,'%s shrieks in pain and twists around, grabbing you with his mouth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32814,'The battle for control of Wintergrasp will begin in 1 hour!','',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(32815,'The battle for control of Wintergrasp will begin in 1 hour!','',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(32816,'For Bolvar! For the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32817,'The battle for control of Wintergrasp will begin in 15 minutes!','',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(32818,'The battle for control of Wintergrasp will begin in 5 minutes!  Prepare yourselves for batlle!','',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(32819,'','We\'ve lost a few good people up here already. I\'m beginning to doubt that this place is worth our attention.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32820,'','Greetings, my $r friend. You honor me with your presence.$B$BHow may I help you?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32821,'','That\'s tiring... but fun.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32822,'Return to the First Legion Forward Camp.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32823,'You\'ve come to address the men, sir?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32824,'It is good to see you among us again, $n.','It is good to see you among us again, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32825,'Welcome $n, dragonfriend.','Welcome $n, dragonfriend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32826,'It is an honor to have you among us, $n.','It is an honor to have you among us, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32827,'Take your much deserved rest in the peace of the temple, $n.','Take your much deserved rest in the peace of the temple, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32828,'Koltira... this might sound strange, but I keep seeing some kid\'s ghost.  Matthias Lehner... does the name mean anything to you?','Koltira... this might sound strange, but I keep seeing some kid\'s ghost.  Matthias Lehner... does the name mean anything to you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32829,'Stand ready, $n. We attack when all of our forces have arrived!','',1,25,0,0,0,0,0,0,1,0,0,0,26124),
(32830,'All this fighting is finally getting to you, $n.  Do not worry, I will not divulge your little secret -- lest the others think you\'re mad.$B$BGet some rest.  It\'ll do you good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32831,'The battle for control of Wintergrasp will begin in 15 minutes!','',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(32832,'Oh great Queen of the Dragons, I have somehow misplaced my Key to the Focusing Iris. Can you find it for me?','Oh great Queen of the Dragons, I have somehow misplaced my Key to the Focusing Iris. Can you find it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32833,'The battle for control of Wintergrasp will begin in 5 minutes!','',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(32834,'Reporting for duty, your majesty! Let the assault begin!','Reporting for duty, your majesty! Let the assault begin!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32836,'Oh great Queen of the Dragons, I have somehow misplaced my Heroic Key to the Focusing Iris. Can you find it for me?','Oh great Queen of the Dragons, I have somehow misplaced my Heroic Key to the Focusing Iris. Can you find it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32837,'The final battle will begin soon, $n. Stand at attention!','',1,66,0,0,0,0,0,0,1,0,0,0,26124),
(32838,'Reinforcements are needed on the Wintergrasp battlefield!  I have opened a portal for quick travel to the battle at The Silver Enclave.','',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(32839,'','Yes, of course, but please be more careful in the future.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32840,'Reinforcements are needed on the Wintergrasp battlefield!  I have opened a portal for quick travel to the battle at Sunreaver\'s Sanctuary.','',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(32841,'We are victorious on the Wintergrasp battlefield!  The fortress is ours!  ','',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(32842,'We are victorious on the Wintergrasp battlefield!  The fortress is ours!  ','',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(32843,'Heroes of the Alliance, your King calls! Gather behind me at the entrance to the sewers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32844,'Soon we will march upon this cursed place and cleanse it of its evil!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32845,'The Focusing Iris thrums, holding back an inconceivable amount of restrained power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32846,'Use the key to open the Focusing Iris.','Use the key to open the Focusing Iris.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32847,'The hour of redemption is close at hand! Prepare yourselves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32848,'Take care and be safe, mortal; you are a valuable ally we do not wish to lose.','Take care and be safe, mortal; you are a valuable ally we do not wish to lose.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32849,'The march upon the Undercity begins now! Be empowered by your King\'s strength! Follow me, heroes! FOR THE GLORY OF THE ALLIANCE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32850,'Be safe, $n.','Be safe, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32851,'We will guard this place, $n, and hope for your safe return.','We will guard this place, $n, and hope for your safe return.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32852,'Be careful with yourself, $n. I might actually hesitate for an instant if I saw your undead husk on the field.','Be careful with yourself, $n. I might actually hesitate for an instant if I saw your undead husk on the field.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32853,'Stay alive, $n.','Stay alive, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32854,'$n, your strength is inspiring.','$n, your strength is inspiring.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32855,'Avoid becoming plagued, $n. You deserve better.','Avoid becoming plagued, $n. You deserve better.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32856,'Onward, brothers and sisters! Destiny awaits!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32857,'Good to see you still breathe, $n.','Good to see you still breathe, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32858,'Our descent into the depths of depravity begins! Be on guard! Jaina, lend us your strength!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32859,'What is this?! Stand your ground! Don\'t give them an inch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32860,'$n is here!','$n is here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32861,'We\'re relieved to see you whole, $n.','We\'re relieved to see you whole, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32862,'You\'ve done the Crusade proud, $n!','You\'ve done the Crusade proud, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32863,'$n! Still fighting the good fight?','$n! Still fighting the good fight?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32864,'You\'re integral to our operation here, $n.','You\'re integral to our operation here, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32865,'','Right away, your majesty!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32866,'There goes the finest $c I have the honor of knowing.','There goes the finest $c I have the honor of knowing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32867,'$n, you\'re an inspiration.','$n, you\'re an inspiration.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32868,'A fine example of a $g man:woman;, that $n.','A fine example of a $g man:woman;, that $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32869,'You couldn\'t ask for a finer person than $n, I say.','You couldn\'t ask for a finer person than $n, I say.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32870,'$n, wonderful to see you. Wonderful.','$n, wonderful to see you. Wonderful.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32871,'$n! Ah, fantastic to see you out and about. Busy as always, hm?','$n! Ah, fantastic to see you out and about. Busy as always, hm?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32872,'You are welcome here, friend and ally of the Dragonflights. Take your rest here in our halls.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32873,'Ah, it\'s you, $n! Welcome into our sanctuary. Rest and refresh yourself; you have more than earned it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32874,'Rise, Sindragosa!  Rise and lead the Frostbrood into war!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32875,'Underbelly Croc stares at you hungrily as he licks his chops.','Underbelly Croc stares at you hungrily as he licks his chops.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32877,'Look at us, elf. Look at us. Unemployed, destitute, and drinking swill from an establishment in the sewers named after a carrion bird!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32878,'Disgusting, I agree.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32879,'And above it all, I somehow find myself saddled with you, the very man who caused me to lose my job in the first place!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32880,'That was your doing, not mine, windbag. I found myself unemployed due to my unfortunate association with your failure.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32881,'My failure?! MY FAILURE?! It was your incompetence that landed us here, you insufferable prat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32882,'%s rolls his eyes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32883,'Come off it, Jadaar. That\'s all I\'ve heard out of you for months. No matter what happened, the point is we\'re free agents now! No longer tied to politics or duties, able to roam where we will!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32884,'Penniless and away from what we know in the middle of the frozen, undead-infested northland.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32885,'Perhaps, but with the opportunity to make names for ourselves! Think of the reception you\'d have in Shattrath as the savior of Azeroth, slayer of the Scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32886,'Eh.. perhaps, after another drink.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32887,'Remind me again why I tolerate your company, Asric.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32888,'%s smirks wryly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32889,'I have decades of practice handling blowhards like yourself, and I\'m the only one you know here in this abominably freezing land.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32890,'I am ready to head further into Storm Peaks.','I am ready to head further into Storm Peaks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32891,'I should leave you to rot in this sewer with the filth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32892,'No doubt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32893,'Merely being in your presence is an affront to my beliefs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32894,'Oh, of course.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32895,'You are beneath me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32896,'A lowly worm, I\'m sure.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32897,'Snake.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32898,'Snake, then, if you prefer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32899,'Stop agreeing with me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32900,'You\'re right, of course, it\'s a terrible practice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32901,'AGH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32902,'Arrogant.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32903,'Braggart.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32904,'Craven.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32905,'Craven?! I am most certainly not! Are we not in the middle of a war z... ah.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32906,'%s holds up a finger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32907,'What were we on?  \'D\'?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32908,'%s nods.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32909,'Dolt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32910,'$n, we must speak when the queen is done with you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32911,'','It is done. You may now open the focusing iris.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32912,'Prepare to die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32913,'I.am.a.robot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32914,'Mulfunction.  Error Code: .- .- .-','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32915,'<The queen\'s consort nods in acknowledgment of your presence.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32916,'','Your orders have been revoked until further notice.  Cool your jets and try to be more careful out there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32917,'','You\'ve taken a lot of bombers out and don\'t have much to show for it.  Use more caution or your flight priveledges will be revoked...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32918,'Your heart and your humanity hold you back, Arthas.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32919,'','It\'s been a busy day in the air, eh $n?  Maybe you should take a moment to catch your breath before going back out.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32920,'Rid yourself of your humanity and you will never bleed again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32921,'Do not worry, Arthas.  Soon you will not need your heart.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32922,'','I just got order to pull your flight privilege, $n.  Came back later and we\'ll let you back into a bomber.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32923,'The human blood in your veins is but a detriment.  Rid yourself of all emotion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32924,'The pain in your chest will soon be gone... never to return!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32925,'','You\'ve been just as busy blowing yourself up as you have blowing up the opposition.  That sounds fun, but be careful or I\'ll stop giving you bombers...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32926,'','I tell you, it sure is fun to see you work!  And you sure go through a lot of bombers!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32927,'I\'ve finally caught up with you, Arthas.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32928,'Grand Apothecary Putress unleashes the Engorged Blight Worm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32929,'King Stormheart sent me to be tested as a frostborn would.  I am ready for my test, Fjorlin.','King Stormheart sent me to be tested as a frostborn would.  I am ready for my test, Fjorlin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32930,'I am ready to join the battle against the wyrms. Do you have an eagle ready for me, Fjorlin?','I am ready to join the battle against the wyrms. Do you have an eagle ready for me, Fjorlin?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32931,'Careful, $n.  Where are your cultist robes?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32932,'There you are.  Are you ready then?  Once we start, there is no turning back.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32933,'I\'m ready, Highlord.','I\'m ready, Highlord.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32935,'Greetings.','Greetings.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32936,'Welcome.','Welcome.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32937,'Your aberrations are no match for the Alliance, Putress! We\'re coming for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32938,'Soldiers, fall in! Guard the halls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32939,'','What\'s happened here? There are corpses everywhere... the stench... overwhelming...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32940,'Horde. By the looks of the struggle, they are here in force - somewhere.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32941,'Stay alert and on guard. There\'s no telling what horrors await us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32942,'ONWARD!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32943,'Do not let them pass, minions!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32944,'KILL THEM! My work must not be interrupted!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32945,'The main chamber is this way! Let\'s go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32946,'THERE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32947,'There\'s nowhere to run, monster!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32948,'It will not end like this! I\'ve worked too hard! So many years... I... I will consume more energy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32949,'Stare into the abyss and watch as it blackens your souls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32950,'The power washes through me! I see... EVERYTHING!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32951,'MORE SUFFERING AWAITS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32952,'You are no match for my creations!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32953,'This cannot be happening!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32954,'Welcome to the Legerdemain Lounge, $c. I do hope you\'ll enjoy your stay.','Welcome to the Legerdemain Lounge, $c. I do hope you\'ll enjoy your stay.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(32955,'Welcome to the Cantrips and Crows Tavern, $r.$B$BWatch your back while you\'re here, hmmm? Narisa doesn\'t like scrubbing blood off the floor.','Welcome to the Cantrips and Crows Tavern, $r.$B$BWatch your back while you\'re here, hmmm? Narisa doesn\'t like scrubbing blood off the floor.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(32956,'The proto-drake smells freedom and flies homeward!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32957,'A Power Spark forms from a nearby rift!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32958,'A Shadron Disciple appears in the Twilight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32959,'','Tenebron begins to hatch eggs in the Twilight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32960,'A Vesperon Disciple appears in the Twilight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32961,'And justice is served!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32962,'What say you now, Putress?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32963,'Look around you, brothers and sisters. Open your eyes! Look at what they have done to our kingdom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32964,'How much longer will we allow these savages free reign in our world?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32965,'I have seen the Horde\'s world. I have been inside their cities. Inside their minds...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32966,'I know what evil lies in the hearts of orcs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32967,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32968,'THRALL! HERE?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32969,'ONWARD! We end this now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32970,'You should all know, the orcs have a battle cry: LOK\'TAR OGAR! It means \"victory or death.\" Fitting...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32971,'To the throne room!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32972,'','Varian, stop! I won\'t help you do this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32973,'If you\'re shot down and caught, don\'t tell them your real name.  Use a codename.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32974,'%s summons forth Skeletal Warriors!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32976,'%s teleports back into the battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32977,'%s raises more skeletons!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32978,'%s blinks away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32979,'Hidden inside this defiled city is the wretch responsible for murdering our brothers and sisters at the Wrathgate! He must be brought to justice!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32980,'Death to the Frostpaw!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32981,'All who slay Frostpaw are our allies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32982,'Grizzlemaw belongs to the Redfang!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32983,'Slay all Redfang!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32984,'Victory to the Frostpaw!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32985,'All enemies of the Redfang are welcome in our den!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32986,'','Most dragons would fear to tread here, $r.$b$bWhat could possibly bring a mortal to such a treacherous place?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32987,'','Do you possess the courage to face Malygos\' elite drakes in their own realm, $r?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32988,'I... I think so....','I... I think so....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32989,'','My drakes have been eagerly awaiting your return, $c.$b$bAre you ready to take wing?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32990,'I am ready, Lady Corastrasza.','I am ready, Lady Corastrasza.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32991,'','Quite a work out! These fiends are relentless.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32992,'','*Huff* Need to catch my breath...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32993,'','Good to be fighting again, don\'t you think?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32994,'','An elite Blue Dragonflight squad appears from the portal!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32995,'','A Portal Guardian defends the new portal!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32996,'','A Portal Keeper emerges from the portal!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32997,'Sorry, friend. Only certified officers of the Alliance can authorize the purchase of a vehicle.','Sorry, friend. Only certified officers of the Alliance can authorize the purchase of a vehicle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32998,'Lexicon of Power','Lexicon of Power',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(32999,'The ancient tomes are always found near inscription trainers.','The ancient tomes are always found near inscription trainers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33000,'Your vehicle is burning!','Your vehicle is burning!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33001,'We did it! Can you believe what we\'re hearing? This is incredible!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33002,'There will be plenty of time for this later Brann, we need to get moving!','There will be plenty of time for this later Brann, we need to get moving!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33003,'You\'re right, I can come back to this later. I think it\'s time to see what\'s behind the door near the entrance. I\'m going to sneak over there, nice and quiet. Meet me at the door and I\'ll get us in.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33004,'Omega Rune deployed.  Activation successful.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33005,'Isn\'t it just beautiful? Can you see the potential profit?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(33006,'It\'s a mighty good day, is it not? I do hope we see a few fireworks before this day is through.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33007,'Hello, little $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33008,'','Just because something isn\'t broke doesn\'t mean you can\'t fix it.  You lookin\' for something, sweety?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33009,'How do you fly in this cold climate?','How do you fly in this cold climate?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33010,'I hear you sell motorcycle parts.','I hear you sell motorcycle parts.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33011,'Return to The Nexus!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33012,'The U.D.E.D. dispenser rumbles at you expectantly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33013,'<Retrieve a bomb from the dispenser.>','<Retrieve a bomb from the dispenser.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33014,'Thanks, buddy! Thanks for nothing!','',0,0,0,0,0,0,0,0,1,52906,0,0,26124),
(33015,'Why do you treat Hakmud like this, buddy?','',0,0,0,0,0,0,0,0,1,52906,0,0,26124),
(33016,'What is Hakmud supposed to do now, buddy?','',0,0,0,0,0,0,0,0,1,52906,0,0,26124),
(33017,'Hakmud cannot work under these conditions! Goodbye!','',0,0,0,0,0,0,0,0,1,52906,0,0,26124),
(33018,'I thought we were friend, buddy! You leave Hakmud stranded?','',0,0,0,0,0,0,0,0,1,52906,0,0,26124),
(33019,'Nobody loves Gnimo...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33020,'Goodbye! You were Gnimo\'s best friend ever!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33021,'Time for Gnimo to shut down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33022,'The view up here is amazing!','The view up here is amazing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33023,'Oh, I see how it is... You\'re gonna do me like that, eh?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33024,'Hey, yea, I\'ve always wanted to be stranded somewhere.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33025,'Our friendship is OVER!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33026,'You\'re just gonna leave me here? How am I supposed to get home?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33027,'','Really, mon? Just like dat you be leavin\' Mojodishu behind?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33028,'','Dis bad mojo what you doin\'. Don\'t say Mojodishu didn\'t warn ya!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33029,'','Be dat way den!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33030,'The view up here is amazing!','The view up here is amazing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33031,'The view up here is amazing!','The view up here is amazing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33032,'Too bad I left my light feathers at home... Slow Fall would work perfect here!','Too bad I left my light feathers at home... Slow Fall would work perfect here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33033,'Hmm... Interesting.','Hmm... Interesting.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33034,'So many books, so little time.','So many books, so little time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33035,'So many wonderful books...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33036,'Feels good to be home.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33037,'%s\'s brains are splattered by $n.','%s\'s brains are splattered by $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33038,'Welcome $c, to my humble retreat.  I find this place very relaxing and I have always loved being at home in Dalaran.  Sometimes though, it can be a lonely place...  such a lonely place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33039,'I have a book that might interest you.  Would you like to take a look?','I have a book that might interest you.  Would you like to take a look?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33040,'Amazing!  There are passages in here that I have never seen before.  This must have taken quite a while for you to track down.  If you ever find anymore books like this, I would like to be notified immediately.\n\nPlease take one of my Kirin Tor Familiars with you just in case you stumble across anything.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33041,'Reading orders','Reading orders',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33042,'Treasure huntin\' and some hearty ale - doesn\'t get no better than this, $G lad:lass;.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33043,'Thank you!  I will be sure to notifiy you if I find anything else.','Thank you!  I will be sure to notifiy you if I find anything else.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33044,'The Emerald Dream has become a dangerous place. I grow increasingly concerned for those who have sacrificed their waking life in Azeroth in hopes of saving it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33045,'Please send me into the Emerald Dream to recover the acorns. I know of the danger and I do not fear it.','Please send me into the Emerald Dream to recover the acorns. I know of the danger and I do not fear it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33046,'Let\'s try this a new way...','Let\'s try this a new way...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33047,'Request granted, $n.  Please wait for your flight window...','Request granted, $n.  Please wait for your flight window...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33048,'$n, your bomber is ready.  Good luck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33049,'','One moment, $n...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33050,'Request granted, $n.  Please wait for your flight window...','Request granted, $n.  Please wait for your flight window...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33051,'The hammers of the earthen stand united behind Bouldercrag. We will oppose Loken\'s minions to the end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33052,'We\'ve defeated Valduran and we\'ll fell his colossus.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33053,'Well fought! The day is ours, but the war goes on!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33054,'Make it quick, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33055,'%s has transferred your soul into the body of a Ghoul.','%s has transferred your soul into the body of a Ghoul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(33056,'','One more bottle?  I don\'t see any reason why not!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33057,'<The engine rumbles loudly.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33058,'<Get in the bomber and return to Scalawag Point.>','<Get in the bomber and return to Scalawag Point.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33059,'The Sunken Ring siege workshop has been attacked by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33060,'The Sunken Ring siege workshop has been attacked by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33061,'The Broken Temple siege workshop has been attacked by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33062,'The Broken Temple siege workshop has been attacked by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33063,'We will miss you, Antonidas.','We will miss you, Antonidas.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33064,'Thank you for all that you have done for us.  May you rest in peace.','Thank you for all that you have done for us.  May you rest in peace.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33065,'Place Avruu\'s Orb on the altar.','Place Avruu\'s Orb on the altar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33066,'Gusty winds surround the altar.  There is an open spot where a small orb may have once rested.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33067,'Sometimes it\'s nice to get away from the sanctum and get some fresh air.','Sometimes it\'s nice to get away from the sanctum and get some fresh air.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33068,'Luckily, the Lich King\'s grasp has not reached Dalaran yet.','Luckily, the Lich King\'s grasp has not reached Dalaran yet.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33069,'She said to meet her right here... maybe I\'m in the wrong place?','She said to meet her right here... maybe I\'m in the wrong place?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33070,'Finally!$b$bDa $r $c foretold in da prophecies has arrived!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33071,'I am ready to return to the realm of the living.','I am ready to return to the realm of the living.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33072,'The relic chamber is under attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33073,'The chamber has been breached! The titan relic is vulnerable!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33074,'How can I help you, brother?','How can I help you, brother?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33075,'How can I help you, warrior?','How can I help you, warrior?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33076,'Yes, little one?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33077,'%s calls an Azure Ring Captain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33078,'Big, sparkly, magic book help make Glyphs for spells and abilities. Always find near inscription trainer, in The Apothecarium.','Big, sparkly, magic book help make Glyphs for spells and abilities. Always find near inscription trainer, in The Apothecarium.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33081,'Big, sparkly, magic book help make Glyphs for spells and abilities. Always find near inscription trainer, in The Apothecarium.','Big, sparkly, magic book help make Glyphs for spells and abilities. Always find near inscription trainer, in The Apothecarium.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33082,'','Make it quick, $r. I am weary and have no time for pleasantries..',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33083,'Be wary, $r.$b$bThis is no place for the meek.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33084,'I lost Brann\'s Communicator and need a replacement.','I lost Brann\'s Communicator and need a replacement.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33085,'%s lunges for $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33086,'The %s prepares to slam the ground in front of him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33087,'','%s casts Unyielding Pain on everyone!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33088,'%s casts Condemnation on everyone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33089,'There you are!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33090,'I need you to show me again, Matthias.','I need you to show me again, Matthias.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33091,'Return to Fjorn\'s Anvil!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33092,'','Perhaps I should explain...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33093,'','I had arranged for a secret summit between Warchief Thrall and King Wrynn, here in Theramore.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33094,'','The king was to travel here by ship, in secret. But the ship never arrived, and King Wrynn disappeared.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33095,'','Your help enabled us to connect the Defias to the mastermind behind the abduction, Onyxia, who was posing as a member of the royal court.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33096,'','Meanwhile, the king managed to escape his captors, and returned to Stormwind to deal with Onyxia.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33097,'','I will send word that you have discovered the link to the Defias. I was a fool to think them broken with the defeat of Edwin VanCleef, and King Wrynn will want to make an example of all who remain.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33098,'Lok\'tar! Have you come to serve the Horde in battle?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33099,'','Thank you, $n. The health of our soldiers depends upon your success.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33100,'Be safe, $n. Remember, the Horde are also seeking the dragon bones. It might be easier to kill them than to kill the shades.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33101,'Show those animals no mercy, $n!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33102,'Stop the Horde from retrieving the embers, $n. We cannot risk them having the advantage when the battle resumes!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33103,'Destroy their foul machines of war, $n!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33104,'','The Glacial Falls is a dangerous place, $n. The Horde will be just as happy to claim your armor for their vile hoodoo magics.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33105,'Bring us victory, $n, and we shall grant you the honor you deserve! Fight for the Alliance!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33106,'The forest is on the western side of Wintergrasp. Just look for the soul-leeching shades, I\'m sure they\'ll be glad to have some company...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(33107,'The Alliance disgrace this land with their villainous poaching. Don\'t hesitate to claim the herbs from their corpses!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(33108,'The Glacial Falls be to the east, mon. Bring back da best armor ya be findin\'. Those Alliance won\'t know what hit \'em.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(33109,'Slay them all, $n!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(33110,'Elemental embers burn hotter than Durotar during the fire festival. The Alliance cannot be permitted to claim them!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(33111,'Smash da\' siege, $n! Murp will know.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(33112,'Victory or Death, $n!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(33113,'Protect our war machines, $n! Fight for the glory of the Alliance!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33114,'The Glacial Falls be to the east, mon. Bring back da best armor ya be findin\'. Those Alliance won\'t know what hit \'em.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(33115,'Defend da\' siege, $n! Smash dem walls!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(33116,'Death... will not stop me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33117,'I seem to have misplaced the Horn of the Peaks.','I seem to have misplaced the Horn of the Peaks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33118,'Ah, Noblegarden. So amusing to watch others throw away their dignity in favor of hunting colored eggs. Still, they do have a curious magical aura to them...','Ah, Noblegarden. So amusing to watch others throw away their dignity in favor of hunting colored eggs. Still, they do have a curious magical aura to them...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33119,'The time has come for Noblegarden once again! Time to thank the Light for the rebirth of the world.','The time has come for Noblegarden once again! Time to thank the Light for the rebirth of the world.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33120,'Candy! That\'s what I\'m talking about; I just wish I didn\'t have to run around finding it!','Candy! That\'s what I\'m talking about; I just wish I didn\'t have to run around finding it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33121,'The celebration of the natural processes of the world is silly; it\'s going to happen whether we celebrate or not! But it\'s a great excuse for sugar!','The celebration of the natural processes of the world is silly; it\'s going to happen whether we celebrate or not! But it\'s a great excuse for sugar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33122,'Hey, if people want to run around rooting in the dirt for colored eggs, who am I to judge? I still get a cut of the profits on paint, and I invested in chickens this year.','Hey, if people want to run around rooting in the dirt for colored eggs, who am I to judge? I still get a cut of the profits on paint, and I invested in chickens this year.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33123,'Noblegarden time! I\'ve already found a lot of eggs. Great weather for the hunt, eh?','Noblegarden time! I\'ve already found a lot of eggs. Great weather for the hunt, eh?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33124,'Noblegarden is the time when the druids of Azeroth celebrate the rebirth of life. The eggs are a symbol of fertility and an excellent way to bring everyone into the spirit, don\'t you think?','Noblegarden is the time when the druids of Azeroth celebrate the rebirth of life. The eggs are a symbol of fertility and an excellent way to bring everyone into the spirit, don\'t you think?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33125,'We\'re celebrating spring during Noblegarden. Affirmation of life and all that.','We\'re celebrating spring during Noblegarden. Affirmation of life and all that.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33126,'Now is the time in which we pay homage to the birth of life, and the eggs are symbols representing the spring and rebirth. May you enjoy the spring.','Now is the time in which we pay homage to the birth of life, and the eggs are symbols representing the spring and rebirth. May you enjoy the spring.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33127,'Yah, mon, this be the time to be glad of life and spring. Ya collect lots of eggs yet?','Yah, mon, this be the time to be glad of life and spring. Ya collect lots of eggs yet?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33128,'This entire holiday is nonsensical. Colored eggs and \"life affirmation,\" bah.','This entire holiday is nonsensical. Colored eggs and \"life affirmation,\" bah.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33129,'%s senses his destiny!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33130,'Grab the explosive on the docks and bring down those doors, men!','Grab the explosive on the docks and bring down those doors, men!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33131,'Grab the explosive on the docks and bring down those doors, men!','Grab the explosive on the docks and bring down those doors, men!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(33132,'Hail, friend! Have you come to serve the sons of Azeroth in battle?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33135,'Well met, friend. Enjoying Noblegarden, I hope? Why not join in the fun?','Well met, friend. Enjoying Noblegarden, I hope? Why not join in the fun?',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(33136,'Greetings, $c.$B$BWhen the Alliance controls Wintergrasp Fortress, I will open a portal for those who wish to travel there.$B$BThe battle currently enues. Hurry to Wintergrasp and support our forces!','Greetings, $c.$B$BWhen the Alliance controls Wintergrasp Fortress, I will open a portal for those who wish to travel there.$B$BThe battle currently enues. Hurry to Wintergrasp and support our forces!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33137,'Greetings, $c.$B$BWhen the Horde controls Wintergrasp Fortress, I will open a portal for those who wish to travel there.$B$BThe battle currently ensues. Hurry to Wintergrasp to support our forces.','Greetings, $c.$B$BWhen the Horde controls Wintergrasp Fortress, I will open a portal for those who wish to travel there.$B$BThe battle currently ensues. Hurry to Wintergrasp to support our forces.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(33138,'With the help of our new taunka allies, the Northrend will belong to the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33139,'I wish to return to Archdruid Lilliandra. Can you send me back to her?','I wish to return to Archdruid Lilliandra. Can you send me back to her?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33140,'','Greetings $c!  Welcome aboard the Cloudkisser.  Northrend can be a very harsh place.  I hope you have prepared yourself.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33141,'Locksmith','Locksmith',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33142,'You\'ll be after Benik Boltshear, then. He\'s located in the heart of the Dwarven District by the blacksmiths.','You\'ll be after Benik Boltshear, then. He\'s located in the heart of the Dwarven District by the blacksmiths.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33143,'Him Walter Soref. Work in Rogue District. He make keys.','Him Walter Soref. Work in Rogue District. He make keys.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(33144,'If you are seeking a locksmith, might I suggest the sewers? That\'s where you\'ll find more... disreputable types.','If you are seeking a locksmith, might I suggest the sewers? That\'s where you\'ll find more... disreputable types.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33145,'Interlopers! You mortals who dare to interfere with my sport will pay.... Wait--you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33146,'<Allyndia\'s body bobs gently in the surf. It appears that she\'s been dead for some time.>','<Allyndia\'s body bobs gently in the surf. It appears that she\'s been dead for some time.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33147,'<As you approach, you hear Cerellean gasp for breath. He looks to stand a chance if rescued soon.>','<As you approach, you hear Cerellean gasp for breath. He looks to stand a chance if rescued soon.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33148,'Impertinent whelps, you dare challenge me atop my pedestal? I will crush you myself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33149,'<Volcor\'s body lies motionless.  As you begin to move away, a hand reaches out and grabs your ankle. He\'s alive!>','<Volcor\'s body lies motionless.  As you begin to move away, a hand reaches out and grabs your ankle. He\'s alive!>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33150,'<A whisper escapes Shaldyn\'s throat as you approach.>\n\nHelp... please.','<A whisper escapes Shaldyn\'s throat as you approach.>\n\nHelp... please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33151,'<Gershala rolls onto his side to look at you as you approach and you see a hopeful smile creep onto his face.>','<Gershala rolls onto his side to look at you as you approach and you see a hopeful smile creep onto his face.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33156,'<As you turn Barithras\' limp body over in the water, a brutal injury on his head makes it very apparent why he did not make it.>','<As you turn Barithras\' limp body over in the water, a brutal injury on his head makes it very apparent why he did not make it.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33157,'<Dalmond\'s body looks almost peaceful, buried only slightly in the sand.>','<Dalmond\'s body looks almost peaceful, buried only slightly in the sand.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33158,'<Grondal reaches futilely towards you as you approach, but his arm collapses as life slips from him.>','<Grondal reaches futilely towards you as you approach, but his arm collapses as life slips from him.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33159,'<Terenthis\' eyes stare unblinking into the distance, betraying the sorrow of his last moments.>','<Terenthis\' eyes stare unblinking into the distance, betraying the sorrow of his last moments.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33160,'<Vicious gashes line Valdaron\'s body. You need not check his pulse to know that he has already passed.>','<Vicious gashes line Valdaron\'s body. You need not check his pulse to know that he has already passed.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33161,'<The night elf turns to you as you approach and reaches for your hand.>\n\nIt is too late for me. We earned our fate with our pride. Go... others may have made it. Save any that you can.\n\n<Her grip loosens as life slips from her.>','<The night elf turns to you as you approach and reaches for your hand.>\n\nIt is too late for me. We earned our fate with our pride. Go... others may have made it. Save any that you can.\n\n<Her grip loosens as life slips from her.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33162,'So this... is what it feels like... to be mortal?\n\n<The question trails off as Mavralyn\'s breathing stops.>','So this... is what it feels like... to be mortal?\n\n<The question trails off as Mavralyn\'s breathing stops.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33163,'Turkey Hunter!','Turkey Hunter!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33164,'Turkey Domination!','Turkey Domination!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33165,'Turkey Slaughter!','Turkey Slaughter!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33166,'Vesprystus\' hippogryphs will bear you swiftly to your destination.','Vesprystus\' hippogryphs will bear you swiftly to your destination.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33167,'TURKEY TRIUMPH!','TURKEY TRIUMPH!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33168,'It is Vesprystus that you seek.  He watches over the hippogryphs that come and go from the base of Teldrassil.','It is Vesprystus that you seek.  He watches over the hippogryphs that come and go from the base of Teldrassil.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33169,'','Hey! Over here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33170,'','Get me out of here, will ya?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33171,'','That brute has the key. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33172,'The mule looks at you expectantly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33173,'This is not your mule.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33174,'','Our home was destroyed during the Cataclysm!$B$BAll of the rest of the survivors moved north to build Lor\'danel, but those of us that stayed behind are here for a reason. We WILL retake the Ruins of Auberdine from those Twilight\'s Hammer scum just as soon as we heal up.$B$BI hope that you can help us to deal with them in the meantime.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33175,'On my flight south from Darnassus to seek out Malfurion Stormrage, I came across these injured refugees from the Ruins of Auberdine.$B$BTheir cause is just and I am helping to heal them, but their injuries are numerous, and it will take time.$B$BI trust that you will be willing to lend them your aid as well.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33176,'Warning: Golem can only be used in Dun Argol!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33177,'','Many years ago I died tragically while attempting to help with a local murloc problem. However, I was content to stay and watch my family and friends instead of passing on to be with the Goddess.$B$BNow they are all gone, or worse, dead, and I have only one reason to stay.$B$BVengeance.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33178,'Need a shoeshine, $c?','Need a shoeshine, $c?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33179,'Take care of that shine, $c.','Take care of that shine, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33180,'One shoeshine coming up!','One shoeshine coming up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33181,'Let me shine your shoes, $c.','Let me shine your shoes, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33182,'Shiny!','Shiny!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33183,'Another shiny, happy person.  Take care, $c!','Another shiny, happy person.  Take care, $c!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33184,'Thank you for saving me, stranger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33185,'Thundris Windweaver\'s corpse lays sprawled out here, the apparent victim of the Twilight\'s Hammer\'s machinations.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33186,'Coax Thundris Windweaver\'s spirit.','Coax Thundris Windweaver\'s spirit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33187,'Thundris Windweaver\'s spirit is coaxed forth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33188,'Artruis is shielded. You must choose your side quickly to break his spell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33189,'The frost leopard lays here tranquilized.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33190,'Lift the frost leopard\'s tail to check if it\'s a male or a female.','Lift the frost leopard\'s tail to check if it\'s a male or a female.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33191,'It\'s an angry male!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33192,'It\'s a female.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33193,'The icepaw bear lays here tranquilized.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33194,'Lift the icepaw bear\'s tail to check if it\'s a male or a female.','Lift the icepaw bear\'s tail to check if it\'s a male or a female.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33195,'Farewell.','Farewell.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33196,'','Thirsty? How about flagon of sweet, warm honeycomb mead? Come on over!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33197,'Where am I?  Hic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33198,'Where\'s my bottle?  Have you seen it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33199,'I used to have 1850 spell power, what happaned?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33200,'','Nothin\' will warm your belly like a cup of caraway burnwine. Buy it here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33201,'','Fine, snowplum brandy sold here! Buy a snifter, and experience its wonders...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33202,'','Drinks, here! Delicious drinks! From snowplum brandy to Westfall bourbon... get your drinks!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33203,'','What are you doing out here? You should be inside fighting off the Blue Dragonflight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33204,'I\'m not fighting, so send me in now!','I\'m not fighting, so send me in now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33205,'I know, I know... \"fishing in a sewer?\" But you\'d be surprised by what you can catch down here. I\'ve even heard stories of sharks, if you can believe it.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(33206,'','The sentinel\'s body rests here, the apparent victim of the elemental onslaught that has overtaken the town.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33207,'Coax the spirit out of Sentinel Elissa Starbreeze\'s corpse.','Coax the spirit out of Sentinel Elissa Starbreeze\'s corpse.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33208,'Here\'s where Taldan served his last drink.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33209,'Coax Taldan\'s corpse to give up its spirit.','Coax Taldan\'s corpse to give up its spirit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33210,'','Far too powerful for these elementals, Caylais and her hippogryphs must have been struck down by something else.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33211,'Coax the spirit out of Caylais Moonfeather\'s still corpse.','Coax the spirit out of Caylais Moonfeather\'s still corpse.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33212,'','Lor\'danel is next, fool. With Aetherion almost completely in this world, it is only a matter of time!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33213,'','This place was only the beginning. We will crush your refugee camp and then lead our elementals north to destroy Lor\'danel with Aetherion as our vanguard!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33214,'','Lor\'danel must have been desperate to send you. We\'ll deal with them soon enough!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33215,'Our master will break the world asunder and all that you know will come to an end. This is only a taste of what\'s to come!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33216,'You will not stop our final ritual to bring Aetherion into the world. Too bad that you won\'t live to see it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33217,'If you only knew the power that I serve, you would not hesitate to kneel before me and join our ranks. Sadly, your ignorance will prove to be your undoing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33218,'Whatcha doin\', mon? Don\'tcha know the end o\' the world be nigh? Here, I show you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33219,'Ya be messin\' with Tzu-Tzu? It no matter... Aetherion\'s here, mon. We gonna roll on ya refugee camp an\' then bring the hurt to ya Lor\'denal. But first, ya die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33220,'Gots no time for playin\' with ya. Aetherion just about ready to go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33221,'I HAVE ALMOST ARRIVED. TWILIGHT\'S HAMMER, DO NOT RUSH THE SUMMONING OR I WILL DESTROY YOU AS WELL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33222,'I SEE YOU, INSECT. RUN WHILE YOU CAN. RUN AND TELL YOUR PATHETIC LOR\'DANEL THAT I AM COMING TO DESTROY IT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33223,'MALFURION, CAN YOU HEAR ME?! WHEN I HAVE DESTROYED THE CHILDREN OF ELUNE, I WILL COME AND PUT AN END TO YOU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33224,'MY MASTER COMES, MORTALS! I AM BUT ONE OF A LEGION OF HERALDS. YOUR WORLD IS ABOUT TO UNDERGO A TRANSFORMATION THAT WILL SEE THE END OF YOU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33225,'PATIENCE! THE RITUAL TO BRING ME INTO THIS WORLD IS COMPLEX AND MUST NOT BE RUSHED!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33226,'JOIN THE TWILIGHT\'S HAMMER NOW. THOSE WHO DO NOT BELONG WHEN I FULLY ENTER THE WORLD WILL KNOW ONLY DEATH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33227,'THERE IS BUT ONE OUTCOME POSSIBLE. THE CATACLYSM WAS ONLY THE BEGINNING. THE WORLD AS YOU KNOW IT IS AT AN END!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33228,'YOU MORTALS ARE MADE OF THE STUFF OF THE ELEMENTS. HOW CAN YOU POSSIBLY HOPE TO PREVAIL? PREPARE TO RETURN TO YOUR TRUER, MORE BASIC NATURES!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33229,'YOU DARE?! TODAY WILL SEE THE END OF LOR\'DANEL, MALFURION, AND YOU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33230,'I do not judge others by their stature, $r, but by their courage and loyalty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33231,'No, Aetherion, we will not allow that to happen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33232,'WHAT IS THIS? YALDA? AHAHAHAHAHA, THERE IS NOTHING THAT YOU OR THESE OTHER SPIRITS CAN DO TO STOP ME!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33233,'We shall see. Let us weaken him, my friends!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33234,'This is a fine mess we\'ve gotten ourselves into. We\'re overdue to join up with our forces in Icecrown and now we\'re entangled in this debacle, stuck between the Scourge and the Drakkari.$B$BI told the highlord it was a mistake to come here.$B$BSee what you can do to help out there.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33235,'Can you hear it, $c? The elements cry out that this land is almost dead. The Drakkari are stealing the power of their gods by killing them just to defend themselves against the Scourge.$B$BThey are short-sighted and will be their own undoing in the end.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(33236,'','After the Plaguelands and the Battle for Light\'s Hope Chapel, I didn\'t think that we would witness anything more horrible.$B$BI was wrong.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33237,'EVEN IN THIS WEAKENED FORM, I WILL DESTROY YOU!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33238,'Your lungs are filled and you are ready for action!','Your lungs are filled and you are ready for action!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33239,'Your knuckes are cracked and ready for action!','Your knuckes are cracked and ready for action!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33240,'Are you ready to face the observer? [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33241,'Indeed Frizzer, shake and bake! [PH]','Indeed Frizzer, shake and bake! [PH]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33242,'Your muscles are stretched out and ready for action!','Your muscles are stretched out and ready for action!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33244,'%s begins to Summon Collapsing Stars!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33245,'The stars come to my aid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33246,'','Goddess bless you.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33247,'','Accept Elune\'s gift.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33248,'','Cerellean! You made it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33249,'','I\'ll get him back to Lor\'danel.  Thank you for your help, stranger.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33250,'','Elune be with you.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33251,'Thank you, priestess.','Thank you, priestess.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33252,'Elune be praised!','Elune be praised!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33253,'I feel much better. Thank you.','I feel much better. Thank you.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33254,'We must take back Auberdine!','We must take back Auberdine!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33255,'The Twilight\'s Hammer will pay for what they\'ve done.','The Twilight\'s Hammer will pay for what they\'ve done.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33256,'Elune-Adore.','Elune-Adore.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33257,'','Goddess watch over you.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33258,'','Gershala... Dentaria will be so happy to see you alive.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33259,'','I\'ll take him back to the priestess. Thank you for your kindness.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33260,'','I will see to it that Shaldyn is returned safely. Thank you, hero.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33261,'','Shaldyn!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33262,'','Volcor... I\'m so glad to see that you made it. But where is Grimclaw?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33263,'','We\'ll worry about him later. I need to get you to safety.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33264,'','Thank you for your help, friend. I\'ll take it from here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33265,'Elder Ironbranch casts Iron Roots!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33266,'Elder Stonebark begins to cast |cFFFF0000Ground Tremor!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33267,'%s surrounds itself with a crackling Runic Barrier!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33268,'Elder Stonebark begins to cast Fists of Stone!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33269,'Witness the fury of the cosmos!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33270,'I remember you... in the mountains.... But you... what is this? Where am--','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33271,'Portals of Outland','Portals of Outland',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33272,'The Burning Legion','The Burning Legion',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33273,'%s acquires a new target.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33274,'Failures!  Weaklings!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33275,'Fan the Flames! $B$B\n|TInterface\\Icons\\INV_Misc_EngGizmos_04.blp:64|t','Fan the Flames! $B$B\n|TInterface\\Icons\\INV_Misc_EngGizmos_04.blp:64|t',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33276,'The Flame Leviathan begins to overload!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33277,'Purge the Spark Plugs! $B$B\n|TInterface\\Icons\\INV_Misc_EngGizmos_12.blp:64|t\n','Purge the Spark Plugs! $B$B\n|TInterface\\Icons\\INV_Misc_EngGizmos_12.blp:64|t',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33278,'Adjust the gears! $B$B\n|TInterface\\Icons\\INV_Misc_EngGizmos_13.blp:64|t','Adjust the gears! $B$B\n|TInterface\\Icons\\INV_Misc_EngGizmos_13.blp:64|t\n$B$B',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33279,'The engine got too hot!$BPressure was lost.','The engine got too hot!$BPressure was lost.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33280,'The spark plugs misfired!$BPressure was lost.\n','The spark plugs misfired!$BPressure was lost.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33281,'You ground the gears!$BPressure was lost.','You ground the gears!$BPressure was lost.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33282,'The engine got too cold!$BAll pressure was lost.\n','The engine got too cold!$BAll pressure was lost.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33283,'The spark plugs were clogged!$BAll pressure was lost.','The spark plugs were clogged!$BAll pressure was lost.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33284,'The gears went unshifted!$BAll pressure was lost.\n','The gears went unshifted!$BAll pressure was lost.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33285,'The flames burn hotter!$BGood job!\n','The flames burn hotter!$BGood job!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33286,'The spark plugs are clear!$BWell done!\n','The spark plugs are clear!$BWell done!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33287,'The engine shifted properly!$BNice work!\n','The engine shifted properly!$BNice work!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33288,'Welcome to the Demolisher Engineering Console v0.1 alpha.','Welcome to the Demolisher Engineering Console v0.1 alpha.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33289,'This system allows you to manually control$Bthe power and speed of your siege unit.','This system allows you to manually control$Bthe power and speed of your siege unit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33290,'Once the system activates, you will be required to manually$B respond to emergencies that occur within the engine.\n','Once the system activates, you will be required to manually$B respond to emergencies that occur within the engine.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33291,'Properly responding to these events builds power$Bwithin the Demolisher  5000\'s overflow tank.$B\n|TInterface\\Icons\\INV_Misc_EngGizmos_04.blp:32|t |TInterface\\Icons\\INV_Misc_EngGizmos_12.blp:32|t |TInterface\\Icons\\INV_Misc_EngGizmos_13.blp:32|t\n','Properly responding to these events builds power$Bwithin the Demolisher  5000\'s overflow tank.$B\n|TInterface\\Icons\\INV_Misc_EngGizmos_04.blp:32|t |TInterface\\Icons\\INV_Misc_EngGizmos_12.blp:32|t |TInterface\\Icons\\INV_Misc_EngGizmos_13.blp:32|t\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33292,'Pressure can be used to boost the demolisher\'s$Bspeed, damage and defenses.$B|TInterface\\Icons\\INV_Gizmo_RocketBootExtreme.blp:32|t |TInterface\\Icons\\INV_Weapon_Rifle_31.blp:32|t','Pressure can be used to boost the demolisher\'s speed, damage and defenses.$B|TInterface\\Icons\\INV_Gizmo_RocketBootExtreme.blp:32|t |TInterface\\Icons\\INV_Weapon_Rifle_31.blp:32|t',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33293,'The DEC operator can also choose to load themselves into the loading arm,$B allowing the Demolisher driver to launch them into the distance.$B|TInterface\\Icons\\INV_Misc_EngGizmos_27.blp:32|t','The DEC operator can also choose to load themselves into the loading arm,$B allowing the Demolisher driver to launch them into the distance.$B|TInterface\\Icons\\INV_Misc_EngGizmos_27.blp:32|t',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33294,'GG Engineering Inc. is |cFFFF2222not responsible|r$B for the loss of life, limbs or facial hair$B when using the Demolisher in this way.','GG Engineering Inc. is |cFFFF2222not responsible|r$B for the loss of life, limbs or facial hair$B when using the Demolisher in this way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33295,'$B$B','$B$B',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(33296,'The first of the Alliance towers has fallen! Destroy all three and we will hasten their retreat!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(33297,'Lok\'tar! The second tower falls! Destroy the final tower and we will hasten their retreat!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(33298,'The Alliance towers have fallen! We have forced their hand. Finish off the remaining forces!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(33299,'The first of the Horde towers has fallen! Destroy all three and we will hasten their retreat!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33300,'The second tower has fallen! Destroy the final tower and we will hasten their retreat!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33301,'The Horde towers have fallen! We have forced their hand. Finish off the remaining forces!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33302,'Enter code to receive Frost Whelp pet.','Enter code to receive Frost Whelp pet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33303,'','The Conservatory must be protected!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33304,'%s\'s circuits overloaded.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33305,'%s reactivated. Resuming combat functions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33306,'Welcome to the Demolisher Mechanic Console v0.1 alpha.','Welcome to the Demolisher Mechanic Console v0.1 alpha.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33307,'This system allows you to manually adjust$B the ammuniction and speed of your siege unit.','This system allows you to manually adjust$B the ammuniction and speed of your siege unit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33308,'Once the system activates, you will be required to manually$B maintain your demolisher. ','Once the system activates, you will be required to manually$B maintain your demolisher. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33309,'Oiling the gears will increase the $Bmovement speed of the demolisher.$B\n|TInterface\\Icons\\INV_Misc_Gem_Pearl_01.blp:32|t','Oiling the gears will increase the $Bmovement speed of the demolisher.$B\n|TInterface\\Icons\\INV_Misc_Gem_Pearl_01.blp:32|t',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33310,'Ammunition for the main unit must be regularly reloaded.$B|TInterface\\Icons\\INV_Misc_Ammo_Bullet_02.blp:32|t','Ammunition for the main unit must be regularly reloaded.$B|TInterface\\Icons\\INV_Misc_Ammo_Bullet_02.blp:32|t',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33311,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33312,'','Freya begins to cast |cFFFF0000Ground Tremor!|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33313,'%s gains Frozen Blows!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33314,'%s begins to cast Flash Freeze!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33315,'Back to work you lazy dead cur!','Back to work you lazy dead cur!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33316,'They say there\'s no rest for the wicked. That means you!','They say there\'s no rest for the wicked. That means you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33317,'This is coward\'s work. We should be crushing the Alliance now!','This is coward\'s work. We should be crushing the Alliance now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33318,'A potion to melt the elves? Maybe you\'ll need it, Forsaken. I have my mace to crush their skulls!','A potion to melt the elves? Maybe you\'ll need it, Forsaken. I have my mace to crush their skulls!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33319,'I could use some more blood ale to quench my thirst!','I could use some more blood ale to quench my thirst!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33320,'Work faster for the glory of the Horde!','Work faster for the glory of the Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33321,'Warchief Hellscream will have your head if you don\'t pick up the pace, Forsaken!','Warchief Hellscream will have your head if you don\'t pick up the pace, Forsaken!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33322,'How special... you\'re good at picking flowers. Are you going to send me a bouquet? Hahahaha!','How special... you\'re good at picking flowers. Are you going to send me a bouquet? Hahahaha!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33323,'%s shatters the Rare Cache of Hodir!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33325,'','Thorim, my lord!  Why else would these invaders have come into your sanctum but to slay you?  They must be stopped!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33326,'The moonstalker wakes suddenly and lets out a low growl.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33327,'','Hail to the night!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33328,'You will not stop us, filthy $r!','You will not stop us, filthy $r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33329,'Some nice contagion of rot for you, my pretty?','Some nice contagion of rot for you, my pretty?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33330,'What are you doing here?!','What are you doing here?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33331,'Someone! Help!','Someone! Help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33332,'I\'ll crush you, puny $r!','I\'ll crush you, puny $r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33333,'Lok\'tar ogar!','Lok\'tar ogar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33334,'Good, the Alliance has come to play!','Good, the Alliance has come to play!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33335,'Finally someone to smash!','Finally someone to smash!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33336,'For Ashenvale!','For Ashenvale!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33337,'Death to the Horde!','Death to the Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33338,'For Elune!','For Elune!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33339,'Zomg, I\'m totally a Stag. Do you like my antlers? I just had them polished. (Temp text)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33340,'Meow. I\'m a cat lawl.  Don\'t pick me up or I might scratch you. Have any catnip? (Temp text)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33341,'Are you dumb? I\'m a freaking bear. Back off, punk. (Temp text)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33342,'Give me some quest credit, yo.','Give me some quest credit, yo.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33343,'','The forest is crawling with Horde, $c. Be mindful of your surroundings!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33344,'I am here to do my master\'s bidding, no matter what the cost. A little girl\'s life hangs in the balance and what could be more important?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33345,'Dig rats make some surprisingly tasty stew.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33346,'Return to the ocean... return to the tides.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33347,'The tides do as Elune commands.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33348,'We thank you mortal.  The ocean\'s will is to be free.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33349,'Welcome, $g sir : my lady;. This is a much better camp than the one that I used to have.$B$BIt\'s good to have company. They\'ve been nice enough to teach me some of their fighting techniques so that I can hold my own against the Horde.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33350,'','Greetings, $c. Our position here is a bit exposed given the build up of the Horde\'s forces to the south.$B$BAnything that you can do to help will be greatly appreciated.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33351,'Welcome, champions! All of our attempts at bringing her down have failed. We could use a hand in bringing her down with these harpoon guns.','Welcome, champions! All of our attempts at bringing her down have failed. We could use a hand in bringing her down with these harpoon guns.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33353,'We are ready to help!','We are ready to help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33354,'','Prepare yourselves. We attack at high tide!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33355,'','Assemble the schools. We will wash away even the memories of the Alliance and the Horde from Ashenvale!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33356,'','Our great queen beckons us forward. Let us turn the waters red with the blood of our enemies!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33357,'','Let the might of Zoram rise! Let our enemies be crushed within our coils! Go forth and teach them what it means to face the Wrathtail!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33358,'','Destroy Zoram\'gar Outpost! Destroy the Blackfathom Camp! We march on Maestra\'s Post and by nightfall Astranaar will lie in ruins!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33359,'','The Cataclysm is only the beginning. Let the two-legs drown in a sea of their own blood!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33360,'','To arms! Invaders approach! Strike them down! Let none survive!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33361,'','I see you, land-walker. Come to me... we shall parlay.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33362,'','I thought I\'d never be free from that terrible curse. You have my gratitude, stranger.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33363,'Glad to help, my lady. I\'m told you were once the guardian of a fabled sword. Do you know where I might find it?','Glad to help, my lady. I\'m told you were once the guardian of a fabled sword. Do you know where I might find it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33364,'','Take it with my gratitude, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33365,'My patience has reached its limit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33366,'','Can it really be? Free after all these years?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33367,'','And now, I must return to the waters of the lake.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33368,'','These pathetic mortals are harmless, beneath my station.  Dispose of them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33369,'','Impossible!  Lord Thorim, I will bring your foes a frigid death!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33370,'','A |cFF00FFFFLifebinder\'s Gift|r begins to grow!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33371,'','Hey! Anybody out there?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33372,'','Need some help here! Damsel in distress! <snort>',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33373,'','Come to the top of the inn! They have me chained up!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33374,'','Somebody please! Get me out of here before they sacrifice me!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33375,'','Up here on the second floor of the inn! Hurry!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33376,'','Please! Someone! Anyone! Help me get out of here!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33377,'','Ohmygosh! I didn\'t think that I was ever going to see anyone ever again!$B$BYou have to get me out of here!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(33378,'','Great! Let\'s get out of here. I don\'t have a weapon, so I\'d really appreciate it if you could... you know... protect me?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33379,'','Let\'s go.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33380,'','There\'s the refugee camp!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33381,'','I\'ll race you!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33382,'','Hollee!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33383,'','Elisa! Oh, it\'s so good to get out of there! Auberdine is completely overrun with cultists and elementals!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33384,'','I know, lass, but you\'re safe now and with friends. I thought you were dead!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33386,'','I have a favor to ask. Could you reward my friend here? I haven\'t any coin. I can pay you when we get back to Ironforge.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33387,'','Of course. Don\'t think anything of it. And I won\'t hear of you trying to pay me back, either!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33388,'','Oh, thank you, Elisa! Thank you!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33389,'','Anytime, lass. Anytime.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33390,'','Time for a very short breather.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33391,'','We have to get out of here.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33392,'','How many elementals do they have?!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33393,'','This has to be said... the Twilight\'s Hammer sucks!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33394,'','That was the last one, right?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33395,'','Why did I ever let Remtravel convince me to come to Darkshore?!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33396,'','I\'d be dead if it weren\'t for you.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33397,'','This would never have happened to Ironforge!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33398,'','You cultists are going to pay! Someone get me out of here!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33399,'','I am an archaeologist with the Explorers\' League! I can assure you that King Magni will hear of this outrage!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33400,'What may I do for you, $GSir:Dame;?','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(33401,'Stormwind Champion\'s Pennant','Stormwind Champion\'s Pennant',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33402,'','Taldan!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33403,'','This isn\'t happening. Oh no... my friends!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33404,'','Hurry! We have to check on them!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33405,'','It\'s trashed, but it doesn\'t look like there are any bodies.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33406,'','Sorry, but I had to check. Okay, let\'s get out of here.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33407,'Are you certain you want my help in the battle against Yogg-Saron?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33408,'Mortals, I am indebted to you for freeing me from the terrible corruption that besets this place. Though I have not yet recovered fully, I can help you battle Yogg-Saron.\n\nI can grant you and your friends the Fortitude of Frost, increasing your damage and reducing damage taken from enemy attacks. Should one of you be about to fall in battle, I can freeze you in a block of ice, protecting you from all damage for a short time. Know that this ability taxes my power, and I must rest after using it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33409,'','Mortals, I am indebted to you for freeing me from the terrible corruption that besets this place. Though I have not yet recovered fully, I can help you battle Yogg-Saron.\n\nI can grant you and your friends the Resilience of Nature, increasing your damage and increasing healing taken from spells and effects. In addition, I can conjure Sanity Wells that will allow you to recover your Sanity when your grip on reality falters.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33410,'','Greetings, $c.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(33411,'I\'m ready for my scouting mission.','I\'m ready for my scouting mission.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33412,'Mortals, I am indebted to you for freeing me from the terrible corruption that besets this place. Though I have not yet recovered fully, I can help you battle Yogg-Saron.\n\nI can grant you and your friends the Speed of Invention, increasing your damage and movement speed. In addition, I can destabilize the matrices of certain Saronite based life-forms, reducing their attack and casting speeds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33413,'Mortals, I am indebted to you for freeing me from the terrible corruption that besets this place. Though I have not yet recovered fully, I can help you battle Yogg-Saron.\n\nI can grant you and your friends the Fury of the Storm, increasing your damage and maximum health. Should you be faced with evil so malevolent that it cannot be destroyed, I can channel all my power into a final Titanic Storm that will destroy even Immortals.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33415,'','Are you certain you want my help in the battle against Yogg-Saron?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33418,'Lend us your aid, keeper. Together we will defeat Yogg-Saron.','Lend us your aid, keeper. Together we will defeat Yogg-Saron.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33419,'Blood and thunder, $r!','Blood and thunder, $r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33420,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33421,'Death to the Alliance!','Death to the Alliance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33422,'Many thanks, $c!','Many thanks, $c!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33423,'','Are those winter hyacinths? For me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33424,'','It\'s been so long since a traveler has come here bearing flowers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33425,'','The lake has been too lonely these past years. The travelers stopped coming and evil came to these waters.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33426,'','Your gift is a rare kindness, traveler. Please take this blade with my gratitude. Long ago, another traveler left it here, but I have little use for it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33427,'','Allies of Nature have appeared!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33429,'Are you sure you are ready for mounted combat?','Are you sure you are ready for mounted combat?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33430,'I am ready to fight!','I am ready to fight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33431,'I don\'t like you anymore!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33432,'%s ignores $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33433,'Come near, $c. I haven\'t got much time....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33434,'The mortally wounded orc seems to be unconscious.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33435,'<The orc\'s lifeless body is no longer responsive....>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33436,'','Thank you, mortal, for freeing me from this curse. I beg you, take this blade.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33437,'','It has brought me naught but ill. Mayhap you can find someone who will contain its power.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33438,'I\'ve lost my Tabard of Summer Skies.','I\'ve lost my Tabard of Summer Skies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33439,'I\'ve lost my Tabard of Summer Flames.','I\'ve lost my Tabard of Summer Flames.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33440,'Thank you, friend. I could not rest knowing that my mission had not been completed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33441,'...and that my mens\' sacrifice had not been avenged.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33442,'We must hurry, now. I sense that my time is short.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33443,'Follow me closely, and prepare for battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33444,'Captain Elendilad conceals himself on the island ahead, cowardly issuing orders to his underlings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33445,'He must fall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33446,'So tired. I will rest for just a moment!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33447,'%s\'s heart is exposed and leaking energy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33448,'I\'m ready to play!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33449,'Show yourself, elf-coward! Face your death with honor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33450,'','Good to see you, $c.$B$BSorry... can\'t talk. We\'re in a bit of a fight here.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33451,'','Just let me know when you\'re ready to take a squad out.$B$BI\'m holding some in reserve, so if you need a few more, come back.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33452,'It\'s rough out there. I need some replacements, Sentinel Onaeya.','It\'s rough out there. I need some replacements, Sentinel Onaeya.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33453,'NO! NO! NO! NO! NO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33454,'%s begins to cause the earth to quake.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33455,'How many times must I have you killed, orc?!','',0,0,0,0,0,0,0,0,1,8169,0,0,26124),
(33456,'','Thanks for the rescue. Let\'s get out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33457,'','Thanks for getting me out of there. I should be able to swim back from here, but before I go, one quick thing...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33458,'','First, Morra will be interested to know that it sounds like the Warsong clan spurred these trolls out of the mountain to attack us, so I suspect they\'re going to attack in Ashenvale as well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33459,'','I was afforded a brief chance to attack their leader, and he was protected by some kind of magic. Make sure Morra hears of this before leading any kind of attack.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33460,'','Farewell newcomer. May Elune\'s blessing be with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33461,'You have no idea what you\'re meddling with!','',0,0,0,0,0,0,0,0,1,8169,0,0,26124),
(33462,'Curse you, $r vermin! This forest belongs to the Kaldorei...','',0,0,0,0,0,0,0,0,1,8169,0,0,26124),
(33463,'The %s withers into the earth and begins to regenerate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33464,'With the help of its allies the %s regenerates back to life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33465,'%s begins to cast Flame Jets!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33466,'Epic Purple Shirt','Epic Purple Shirt',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33467,'Sandbox Tiger','Sandbox Tiger',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33468,'Foam Sword Rack','Foam Sword Rack',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33469,'Blood of Gladiators','Blood of Gladiators',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33470,'Mission complete. Thank you, friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33471,'General Vezax roars and surges with dark might!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33472,'I\'ll carve your heart out, maggot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33473,'A $r? I spit on you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33474,'So you\'re the Alliance\'s so-called champion. With your death this place will easily fall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33475,'Pathetic weakling. You\'ll die quickly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33476,'I can see you, worm. Are you grunts blind? Kill them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33477,'That one, over there. Target them. Do NOT let them get past you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33478,'Surrender, Maestra, and I will see to it that your deaths are quick!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33479,'Smash them! Destroy them! Lok\'tar ogar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33480,'Your time has past, night elves. Ashenvale is ours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33481,'I want that one killed! The one right there that doesn\'t look like the others!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33482,'There is no hope for you. Your Darkshore lies in ruins. Astranaar will fall before the end of the day as will this place. Retreat to Darnassus while you still can.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33483,'There is no blood easier spilt than that of a puny night elf!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33484,'I... I am released from his grasp... at last.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33485,'NO! Garrosh, I have failed you....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33486,'Remember, the warlock at the top of the tower will see through your invisibility!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33487,'Hostile entities detected. Threat assessment protocol active. Primary target engaged. Time minus 30 seconds to re-evaluation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33488,'Threat re-evaluated. Target assessment complete. Changing course.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33489,'Pursuit objective modified. Changing course.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33490,'Hostile entity\'s stratagem predicted. Re-routing battle function. Changing course.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33491,'Orbital countermeasures enabled.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33492,'*ALERT* Static defense system failure. Orbital countermeasures disabled.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33493,'Hodir\'s Fury online. Acquiring target.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33494,'%s activates Hodir\'s Fury.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33495,'Mimiron\'s Inferno online. Acquiring target.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33496,'%s activates Mimiron\'s Inferno.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33497,'Freya\'s Ward online. Acquiring target.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33498,'%s activates Freya\'s Ward.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33499,'Thorim\'s Hammer online. Acquiring target.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33500,'%s activates Thorim\'s Hammer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33501,'Unauthorized entity attempting circuit overload. Activating anti-personnel countermeasures.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33502,'%s pursues $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33503,'System malfunction. Diverting power to support systems.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33504,'Combat matrix overload. Powering doooow...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33505,'System restart required. Deactivating weapons systems.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33506,'Total systems failure. Defense protocols breached. Leviathan unit shutting down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33507,'Threat assessment routine modified. Current target threat level: 0. Acquiring new target.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33508,'New toys? For me? I promise I won\'t break them this time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33509,'I... I think I broke it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33510,'I guess it doesn\'t bend that way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33511,'You are bad... Toys... Very... Baaaaad ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33512,'I\'m tired of these toys. I don\'t want to play anymore!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33513,'What is it, $c?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33514,'Truun is in need of lumber from the Warsong Camp. I need to use Brutusk to haul it.','Truun is in need of lumber from the Warsong Camp. I need to use Brutusk to haul it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33515,'Very well, $c. But be careful, Brutusk can be very... spirited.','',0,0,0,0,0,0,0,0,1,8174,0,0,26124),
(33516,'Deactivating','Deactivating',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33517,'','Eonar, your servant requires aid!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33518,'','The swarm of the elements shall overtake you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33519,'','Children, assist me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33520,'','Elders grant me your strength!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33521,'Kill the Kodo and capture the rider!','Kill the Kodo and capture the rider!',0,0,0,0,0,0,0,0,1,8176,0,0,26124),
(33522,'Do not let it pass!','Do not let it pass!',0,0,0,0,0,0,0,0,1,8176,0,0,26124),
(33523,'%s fortifies nearby allies with runic might!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33524,'','His hold on me dissipates. I can see clearly once more. Thank you, heroes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33525,'Yes.','Yes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33526,'Fire!','Fire!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33527,'Bombs away!','Bombs away!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33528,'Take that, night elf scum!','Take that, night elf scum!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33529,'Have a nice day!','Have a nice day!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33530,'Careful with that fuse!','Careful with that fuse!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33531,'Range set.','Range set.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33532,'One! Two! Five!... THREE!','One! Two! Five!... THREE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33533,'Um, could one of you grunts take care of those guys right there?!','Um, could one of you grunts take care of those guys right there?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33534,'I\'m off. Stay safe - I\'ll be back as quickly as I\'m able.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33535,'We have need of your explosives. I\'ll take pleasure in killing you for them.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33536,'You\'re on the wrong side for this one, old friends. Your caravan is ours now.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33537,'Brutusk roars as he leaps into the ambush!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33538,'Automatic repair sequence initiated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33539,'Weapons systems offline.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33540,'','Now, I will imbue this crystal with the Light\'s power to cut through lies and deceit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33541,'','Grant us the ability to know the truth. If a murderer walks in our midst, guide us in our search for justice.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33542,'Me not workin\' til elfs is gone!','Me not workin\' til elfs is gone!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33543,'Elfs kill too many peons in forest. Me sittin\' here where it safe.','Elfs kill too many peons in forest. Me sittin\' here where it safe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33544,'Me not dyin\' for a little wood!','Me not dyin\' for a little wood!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33545,'Come now, friend. You chop and I will protect you from the elves, ok?','Come now, friend. You chop and I will protect you from the elves, ok?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33546,'Good work! I\'m glad to see some revenge taken on that traitor. Go ahead and take the path Miran did to the east and let Prospector Ironband know we\'re all set. I\'m sure he\'ll have some work for you as well.','',2,0,0,0,0,0,0,7,1,0,0,0,26124),
(33547,'I appreciate your help in this. We never would have suspected Saean as a sympathizer - we just weren\'t prepared for this.','',2,0,0,0,0,0,0,7,1,0,0,0,26124),
(33548,'','Greetings, $c.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33549,'Hmm. You don\'t look very tough... but okay.','Hmm. You don\'t look very tough... but okay.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33550,'You stay close, $r. And don\'t let elfs near me!','You stay close, $r. And don\'t let elfs near me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33551,'You not gunna let me die, huh? Okay, then...','You not gunna let me die, huh? Okay, then...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33552,'Sentinel, I would like to ride one of your nightsabers to Astranaar.','Sentinel, I would like to ride one of your nightsabers to Astranaar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33553,'You keep a lookout, $r! The elfs are everywhere!','You keep a lookout, $r! The elfs are everywhere!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33554,'Lay down and die.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33555,'Death is but the inevitable conclusion to your life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33556,'We are everywhere underneath you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33557,'This is the new beginning. Rejoice in your coming doom.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33558,'Embrace the future that rises from below.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33559,'Keeper Heartwise, cease your resistance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33560,'Mortal creature, you are the infestation that must be cleansed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33561,'Come, speak to me at your leisure. Let us discuss matters in a civil manner.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33562,'Return whence you came, foul creature!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33563,'You will be destroyed!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33564,'Back, I say!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33565,'Light of Elune take you!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33566,'I know not what you are, but I do know that you will die!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33567,'Wither in Elune\'s grace!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33568,'I will cleanse you from the face of the world!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33569,'Unnatural!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33570,'I\'m trusting you... Don\'t let me die!','I\'m trusting you... Don\'t let me die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33571,'There you go, $r.','There you go, $r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33572,'','How may I help you, $c?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(33573,'Here I go! Keep an eye out....','Here I go! Keep an eye out....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33574,'I have bad feeling about this....','I have bad feeling about this....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33575,'Watch my back, $r!','Watch my back, $r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33576,'','No longer shall we tolerate your presence here, orc!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33577,'','Ashenvale belongs to the Kaldorei!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33578,'','Death to the Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33579,'','The Horde is not welcome in our lands, orc! Now die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33580,'Avenge me, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33582,'|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 Sanity Low!|r','|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 Sanity Low|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33583,'Your remains will feed IT which rises!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33584,'This form means nothing. We are without end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33585,'%s returns to stone until the next battle resolves.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33586,'%s senses the approaching battle and prepares to return to stone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33587,'A cloud of saronite vapors coalesces nearby!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33588,'Luara, I would like to take one of your nightsabers to Maestra\'s Post.','Luara, I would like to take one of your nightsabers to Maestra\'s Post.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33589,'Managed to find me, eh? No matter, you won\'t live to tell anyone of it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33590,'','Make it quick, $r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33591,'','Hurry, $c! There is no time to waste!$b$bSplintertree must not fall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33592,'I am ready, Gorka. To Kadrak!','I am ready, Gorka. To Kadrak!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33593,'','Follow me, $n! Hurry!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33594,'The saronite vapors mass and swirl violently, merging into a monstrous form!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33595,'Vindicator, please loan me your elekk to ride to Forest Song.','Vindicator, please loan me your elekk to ride to Forest Song.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33596,'','Gorka calls for Brutusk!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33597,'Exotic Pet','Exotic Pet',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33598,'Chimaera','Chimaera',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33599,'Core Hound','Core Hound',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33600,'Devilsaur','Devilsaur',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33601,'Clefthoof','Clefthoof',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33602,'Silithid','Silithid',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33603,'Spirit Beast','Spirit Beast',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33604,'Worm','Worm',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33605,'','You have strayed too far. Wasted too much time....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33606,'Move quickly! She won\'t remain grounded for long!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33607,'Be on the lookout! Mole machines will be surfacing soon with those nasty Iron dwarves aboard!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33608,'Your resilience is admirable.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33609,'I will break you... as I broke him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33610,'Arrrrrrgh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33611,'I\'m not afraid of you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33612,'Glory to Stormwind and King Wrynn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33613,'It seems you were not ready for mounted combat.','It seems you were not ready for mounted combat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33614,'I do not have all day to fight you.  Challenge me when your skills have improved.','I do not have all day to fight you.  Challenge me when your skills have improved.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33615,'','Hold on, $n! This won\'t be easy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33616,'A thousand deaths....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33617,'Or one murder.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33618,'I want those elves and their draenei friends dead, now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33619,'','To Mor\'shan!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33620,'Assemble a company! March on Forest Song!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33621,'Cut down the forest! Flush the elves out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33622,'Take no prisoners!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33623,'The warchief will have all of our hides if production doesn\'t double!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33624,'You there, have you filled your quota of lumber and elf ears today?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33625,'We are the backbone of the Ashenvale offensive. Failure is NOT an option!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33626,'Get out there and kill those Alliance dogs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33627,'Your petty quarrels only make me stronger.... BOW to the god of death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33628,'Yrr n\'lyeth... shuul anagg!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33629,'He will learn... no king rules forever; only death is eternal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33630,'That\'s far enough, orc! Dismount and submit or die!','That\'s far enough, orc! Dismount and submit or die!',0,0,0,0,0,0,0,0,1,8193,0,0,26124),
(33631,'','Out of our way, fools!',0,0,0,0,0,0,0,0,1,8193,0,0,26124),
(33632,'My, my, I never thought I would have the chance to see Ulduar myself. Why, when Brann asked me to help fund this expedition, how could I refuse?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33633,'I never thought we\'d escape from that steamy jungle! Now I\'m the lead engineer of this expedition. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33634,'What can these siege engines do?','What can these siege engines do?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33635,'These babies may look like scrap, but they can rush ahead, knocking enemies aside. The front ram has been overloaded with a electroscopic hyper capacitor, letting it discharge electrical blasts. $B$BEven the turret has been upgraded with anti-air rockets, providing it with a definitive edge over those blasted demolishers.','These babies may look like scrap, but they can rush ahead, knocking enemies aside. The front ram has been overloaded with a electroscopic hyper capacitor, letting it discharge electrical blasts. $B$BEven the turret has been upgraded with anti-air rockets, providing it with a definitive edge over those blasted demolishers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33636,'We haven\'t much time, friends! You\'re going to help me test out my latest and greatest creation. Now, before you change your minds, remember that you kind of owe it to me after the mess you made with the XT-002.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33637,'Here I have amassed what may well be the greatest depository of lore in all of Outland. Even the grand libraries of Silvermoon City pale in comparison.$B$BPlease... look, read, browse to your heart\'s content. You\'ll find everything organized and clearly labeled.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(33638,'WONDERFUL! Positively marvelous results! Hull integrity at 98.9 percent! Barely a dent! Moving right along.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33639,'Behold the VX-001 Anti-personnel Assault Cannon! You might want to take cover.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33640,'Kill her!!','Kill her!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33641,'Ahhh!','Ahhh!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33642,'Shoot!','Shoot!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33643,'Fire!!','Fire!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33644,'','Unghh!',0,0,0,0,0,0,0,0,1,8193,0,0,26124),
(33645,'','Hurry, Brutusk. I\'m wounded!',0,0,0,0,0,0,0,0,1,8193,0,0,26124),
(33646,'A saronite barrier appears around General Vezax!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33647,'The saronite barrier protecting General Vezax shimmers and fades away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33648,'We were in luck to find enough parts to get these babies working again!$BHow can I help you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33649,'Tell me about demolishers.','Tell me about demolishers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33650,'These babies can hurl fire like none other. We\'ve even attached a secondary cannon, a grappling hook and added a manual fuel injection system.  If you can obtain liquid pyrite from the mechanognomes, you can use it to hurl high-density explosives, or turbo-boost your movement speed. \n\nLet\'s see those Explorers\' League twirps beat that!','These babies can hurl fire like none other. We\'ve even attached a secondary cannon, a grappling hook and added a manual fuel injection system.  If you can obtain liquid pyrite from the mechanognomes, you can use it to hurl high-density explosives, or turbo-boost your movement speed. \n\nLet\'s see those Explorers\' League twirps beat that!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33651,'It\'s a good thing you guys showed up! The Iron Dwarves have pushed us back to this location, and we\'re barely managing to hold the line here. \n\nEven worse, they\'ve begun to power up their magical defenses. If we don\'t attack soon, they\'ll be able to annihilate us in the blink of an eye!\n\nWe\'ve managed to rebuild several siege machines, demolishers and motorcycles from the Alliance and Horde expeditions that were here before us. However, all of our pilots died in the last assault.\n\nYou must take the vehicles and storm the gates of Ulduar! \n\nPlease, $n! You\'re our last hope!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33652,'We\'re ready. Begin the assault!','We\'re ready. Begin the assault!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33653,'','I am... finished....',0,0,0,0,0,0,0,0,1,8193,0,0,26124),
(33654,'','$n... You have served the Horde well.$b$bHurry now... speak with Kadrak....$b$bSave Splintertree!!',0,0,0,0,0,0,0,0,1,8193,0,0,26124),
(33655,'I shall not fail, Gorka!','I shall not fail, Gorka!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33656,'It is done. All have given that which must be given. I now seal the Dragon Soul forever.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33657,'%s takes a deep breath...','%s takes a deep breath...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33658,'','That terrible glow... should that be?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33659,'For it to be as it must, yes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33660,'It is a weapon like no other. It must be like no other.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33661,'Who dares summon the mighty Pengoro?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33662,'I am hungry','I am hungry',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33663,'His brood learned their lesson before too long. You will soon learn yours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33664,'','Bad news, sire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33665,'','The clans are united under Blackhand in this assault. They will stand together until Stormwind has fallen.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33666,'','Gul\'dan is bringing up his warlocks by nightfall. Until then, the Blackrock clan will be trying to take the Eastern Wall.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33667,'','The orc leaders agree with your assessment.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33668,'Thank you, friends! Your efforts have yielded some fantastic data! Now, where did I put-- oh, there it is.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33669,'Isn\'t it beautiful? I call it the magnificent aerial command unit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33670,'We will hold until the reinforcements come. As long as men with stout hearts are manning the walls and the throne, Stormwind will hold.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33671,'Pentarus, you heard the $gman:woman;. Have your mages release the shield and let these brave souls through!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33672,'We\'re here with you Brann, you can trust in your brothers of earth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33673,'Of course, Brann. We will have the shield down momentarily.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33674,'Brothers, prepare yourselves! Take up defensive positions along the ramp and make way to let the vehilces through. Born from the earth, to the earth shall we return. Let the might of the Makers burn deep within you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33675,'Darnassus Champion\'s Pennant','Darnassus Champion\'s Pennant',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33676,'Exodar Champion\'s Pennant','Exodar Champion\'s Pennant',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33677,'Mages of the Kirin Tor, on Brann\'s Command, release the shield! Defend this platform and our allies with your lives! For Dalaran!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33678,'Gnomeregan Champion\'s Pennant','Gnomeregan Champion\'s Pennant',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33679,'Ironforge Champion\'s Pennant','Ironforge Champion\'s Pennant',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33680,'Something I can do for you, Boss?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(33681,'Darkspear Champion\'s Pennant','Darkspear Champion\'s Pennant',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33682,'Forsaken Champion\'s Pennant','Forsaken Champion\'s Pennant',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33683,'Orgrimmar Champion\'s Pennant','Orgrimmar Champion\'s Pennant',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33684,'Okay! Let\'s move out. Get into your machines; I\'ll speak to you from here via the radio!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33685,'Silvermoon Champion\'s Pennant','Silvermoon Champion\'s Pennant',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33686,'Thunder Bluff Champion\'s Pennant','Thunder Bluff Champion\'s Pennant',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33687,'Our allies are ready. Bring down the shield and make way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33688,'This test has lasted too long.  You are not ready to be a valiant.','This test has lasted too long.  You are not ready to be a valiant.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33689,'You are far to slow on the field of battle.  Perhaps you need to further hone your skills.','You are far to slow on the field of battle.  Perhaps you need to further hone your skills.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33690,'Well done!  It seems that you are worthy of the valiant rank!','Well done!  It seems that you are worthy of the valiant rank!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33691,'Impressive skills indeed.  I believe that you are more than ready for the rank of valiant.','Impressive skills indeed.  I believe that you are more than ready for the rank of valiant.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33692,'Greetings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33693,'I know the troops need food, but this is ridiculous.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33694,'I still don\'t know why we can\'t just conjur a refreshment table.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33695,'All the arcane power in the world, and here I am, summoning more food and water.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33696,'I\'m a waitress.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33698,'You believe yourself ready for the rank of valiant?  We shall see.','You believe yourself ready for the rank of valiant?  We shall see.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33699,'The rank of valiant is not easily won.  Prepare yourself!','The rank of valiant is not easily won.  Prepare yourself!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33700,'It would seem that you are not yet ready for the rank of valiant.  Some more training may serve you well.','It would seem that you are not yet ready for the rank of valiant.  Some more training may serve you well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33701,'I\'m afraid you are not ready to become a valiant.  However I suspect you will be ready soon enough.','I\'m afraid you are not ready to become a valiant.  However I suspect you will be ready soon enough.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33702,'','I heard a story or two of a Lore Keeper in Uldaman that fit your description. Do you serve a similar purpose?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33703,'I was constructed to serve as a repository for essential information regarding this complex. My primary functions include communicating the status of the frontal defense systems and assessing the status of the entity that this complex was built to imprison.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33704,'','Frontal defense systems? Is there something I should let Brann know before he has anyone attempt to enter the complex?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33705,'Access to the interior of the complex is currently restricted. Primary defensive emplacements are active. Secondary systems are currently non-active.','',0,0,0,0,0,0,0,0,1,8425,0,0,26124),
(33706,'','Can you detail the nature of these defense systems?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33707,'Compromise of complex detected, security override enabled - query permitted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33708,'','Got it. At least we don\'t have to deal with those orbital emplacements.',0,0,0,0,0,0,0,0,1,8425,0,0,26124),
(33709,'','Rhydian, make sure you let Brann and Archmage Pentarus know about those defenses immediately.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33710,'','And you mentioned an imprisoned entity? What is the nature of this entity and what is its status?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33711,'Entity designate: Yogg-Saron. Security has been compromised. Prison operational status unknown. Unable to contact Watchers for notification purposes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33712,'Primary defensive emplacements consist of iron constructs and Storm Beacons, which will generate additional constructs as necessary. Secondary systems consist of orbital defense emplacements.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33713,'','Yogg-Saron is here? It sounds like we really will have our hands full then.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33714,'','Looks like the battle\'s about to get under way, that\'s my cue to leave. We\'ll have to pick this up later.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33715,'','%s nods.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33716,'','%s whispers something to Brann.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33717,'The Silver Covenant welcomes you to the tournament. The Argent Crusade has asked us to register and train those interested in competing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33718,'No room for mistakes this time! I don\'t want any of these siege engines breaking down on the field. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33719,'That better be the last one that blows up on our watch. They\'re paying top dollar for these things.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33720,'Looks like you know a good machine when you see one. Give\'m hell!','Looks like you know a good machine when you see one. Give\'m hell!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33721,'Don\'t forget to get some of that extra pyrite if your friends can shoot it down.','Don\'t forget to get some of that extra pyrite if your friends can shoot it down.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33722,'Wish I could be going with ya. Blow\'m up good!','Wish I could be going with ya. Blow\'m up good!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33723,'I hope you like explosions. They\'re my specialty.','I hope you like explosions. They\'re my specialty.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33724,'You treat my baby nice, alright? I don\'t want to find any dents when you\'re done with her.','You treat my baby nice, alright? I don\'t want to find any dents when you\'re done with her.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33725,'Now with new passenger tossing capability! I\'m sure your buds will love ya.','Now with new passenger tossing capability! I\'m sure your buds will love ya.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33726,'We\'ve only got a limited amount of pyrite stocked, use it sparingly.','We\'ve only got a limited amount of pyrite stocked, use it sparingly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33727,'All yours. Make good use of her!','All yours. Make good use of her!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33728,'These things should bring down those towers in no time!','These things should bring down those towers in no time!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33729,'We upgraded these with some advanced armor plating - they should be able to take quite a beating now!','We upgraded these with some advanced armor plating - they should be able to take quite a beating now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33730,'Roll\'m!','Roll\'m!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33731,'The Anti-Air Rockets should be perfect for taking down those air transports to get at the extra pyrite.','The Anti-Air Rockets should be perfect for taking down those air transports to get at the extra pyrite.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33732,'I call her Betty. She\'s a beauty, eh?','I call her Betty. She\'s a beauty, eh?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33733,'Trust me, this thing will make those goblins jealous. It\'s a work of art.','Trust me, this thing will make those goblins jealous. It\'s a work of art.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33734,'Made to far exceed Brann\'s specifications. You won\'t be disappointed.','Made to far exceed Brann\'s specifications. You won\'t be disappointed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33735,'This thing should wreck that iron army. One better, it won\'t explode in your face... unlike some machines I\'ve seen. Not saying names or anything.','This thing should wreck that iron army. One better, it won\'t explode in your face, unlike some machines I\'ve seen. Not saying names or anything, Blastwrench.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33736,'Into riding in style? I like your taste.','Into riding in style? I like your taste.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33737,'Nothing\'s going to catch you on this baby!','Nothing\'s going to catch you on this baby!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33738,'She\'s all fixed up and ready to go. Treat her nice!','She\'s all fixed up and ready to go. Treat her nice!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33739,'We put together some sweet custom horns for these things. Enjoy!','We put together some sweet custom horns for these things. Enjoy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33740,'Make good use of those tar pools. Your friends should be able to light them on fire if they\'re smart about it.','Make good use of those tar pools. Your friends should be able to light them on fire if they\'re smart about it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33741,'Born to be Wi-i-ild!','Born to be Wi-i-ild!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33742,'Nothing like feeling the wind in your hair! Make sure you wear some goggles though, I bet those Iron dwarves are going to be made into a bit of a mess.','Nothing like feeling the wind in your hair! Make sure you wear some goggles though, I bet those Iron dwarves are going to be made into a bit of a mess.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33743,'Drive some circles around\'m!','Drive some circles around\'m!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33744,'|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 2%% Sanity Lost|r','|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 2%% Sanity Lost|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(33745,'The console appears ancient though there is no sign of dilapidation or decay.  A single slot appears to fit large circular discs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33746,'|cFFCCCCCC%s is loaded into the launching arm of your demolisher.$BWeapon systems offline until launched.|r','|cFFCCCCCC%s is loaded into the launching arm of your demolisher.$BWeapon systems offline until launched.|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33747,'Are you sure you are ready to fight a valiant?','Are you sure you are ready to fight a valiant?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33748,'It would be unwise to assume that fighting a valiant would be a simple task.  Are you sure you are ready?','It would be unwise to assume that fighting a valiant would be a simple task.  Are you sure you are ready?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33749,'Are you sure you are ready to fight me?','Are you sure you are ready to fight me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33750,'Prepare yourself!','Prepare yourself!',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(33752,'On your guard!','On your guard!',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(33753,'Ready yourself!','Ready yourself!',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(33754,'Let it begin!','Let it begin!',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(33755,'Prepare yourself!','Prepare yourself!',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(33756,'On your guard!','On your guard!',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(33757,'Ready yourself!','Ready yourself!',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(33758,'Let it begin!','Let it begin!',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(33759,'I have been defeated.  Good fight!','I have been defeated.  Good fight!',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(33760,'I have been defeated.  Good fight!','I have been defeated.  Good fight!',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(33761,'Dual Specialization allows you to keep two active Class Specialization, Talent, and Glyph sets and easily switch between them.\n\nYou also will have separate glyph panes and action bars for each set.\n\nSwitching between the two sets cannot be done while in combat and will consume your available resources.','Dual Specialization allows you to keep two active Class Specialization, Talent, and Glyph sets and easily switch between them.\n\nYou also will have separate glyph panes and action bars for each set.\n\nSwitching between the two sets cannot be done while in combat and will consume your available resources.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33762,'How do I learn Dual Specialization?','How do I learn Dual Specialization?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33763,'It seems you still need more practice.  Perhaps another time.','It seems you still need more practice.  Perhaps another time.',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(33764,'It seems you still need more practice.  Perhaps another time.','It seems you still need more practice.  Perhaps another time.',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(33765,'I wish to learn Dual Specialization.','I wish to learn Dual Specialization.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33766,'Are you sure you would like to purchase Dual Specialization?','Are you sure you would like to purchase Dual Specialization?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(33767,'I yield to you.','I yield to you.',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(33768,'It would seem I underestimated your skills.  Well done.','It would seem I underestimated your skills.  Well done.',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(33769,'That was a well fought battle.  I yield to you.','That was a well fought battle.  I yield to you.',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(33770,'%s surges with power as its companion perishes!','%s surges with power as its companion perishes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33771,'Victory is mine!','Victory is mine!',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(33772,'I am afraid you will need more practice to defeat me.','I am afraid you will need more practice to defeat me.',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(33773,'I have won.  Better luck another time, friend.','I have won.  Better luck another time, friend.',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(33774,'I yield to you.','I yield to you.',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(33775,'It would seem I underestimated your skills.  Well done.','It would seem I underestimated your skills.  Well done.',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(33776,'That was a well fought battle.  I yield to you.','That was a well fought battle.  I yield to you.',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(33777,'Victory is mine!','Victory is mine!',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(33778,'I am afraid you will need more practice to defeat me.','I am afraid you will need more practice to defeat me.',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(33779,'I have won.  Better luck another time, friend.','I have won.  Better luck another time, friend.',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(33780,'','Glory will be ours when we win this tournament in the name of Silvermoon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33781,'You have now learned Dual Specialization.','You have now learned Dual Specialization.',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(33782,'You have shown that you are ready for the rank of champion.','You have shown that you are ready for the rank of champion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33783,'Most impressive.  You are worthy to gain the rank of champion.','Most impressive.  You are worthy to gain the rank of champion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33784,'We have come to compete for honor, renown, and the right to fight the Scourge alongside the brothers of the Argent Crusade.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33785,'','King Magni expects us to win the tournament and make him proud. We will not fail.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33786,'Gnomeregan\'s finest have come to compete in the tournament. Wish us luck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33787,'You think you are ready to become a champion.  We shall see.','You think you are ready to become a champion.  We shall see.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33788,'You believe you are ready to be a champion?  Defend yourself!','You believe you are ready to be a champion?  Defend yourself!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33789,'We of Darnassus look forward to competing in the tournament.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33790,'It seems you are not ready for the rank of champion.  Some more training may serve you well.','It seems you are not ready for the rank of champion.  Some more training may serve you well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33791,'You have been defeated.  But do not give up.  I sense that one day you will join our ranks as a champion.','You have been defeated.  But do not give up.  I sense that one day you will join our ranks as a champion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33792,'This test has lasted too long.  You are not ready to be a champion.','This test has lasted too long.  You are not ready to be a champion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33793,'Surely you can do do better than this.  This fight has wasted my time.  You are not yet ready to be a champion.','Surely you can do do better than this.  This fight has wasted my time.  You are not yet ready to be a champion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33794,'When the tournament starts, all will see the Forsaken emerge triumphant.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33795,'The competition will be fierce, but Orgrimmar\'s champions will decimate all who stand in our way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33796,'We compete not only for glory, but to bring honor to our ancestors and to our people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33797,'The Darkspears stand ready to face the competition and the enemy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33798,'On behalf of the Sunreavers, I welcome you to the tournament. The Argent Crusade has asked us to register and train those interested in competing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33799,'Are you prepared to fight a valiant of the Argent Crusade?','Are you prepared to fight a valiant of the Argent Crusade?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33800,'When you are ready to test for the rank of valiant, I will call forth a member of the Argent Crusade.','When you are ready to test for the rank of valiant, I will call forth a member of the Argent Crusade.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33801,'This is the ring where the champions practice fighting each other. It\'s my job to summon the knights to their practice battles.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33802,'Ask Cavin to summon the Black Knight.','Ask Cavin to summon the Black Knight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33803,'$n challenges the Black Knight to trial by combat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33804,'Good luck, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33805,'Someone\'s already made a challenge. The ring will be free when the fight is over.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33806,'The Black Knight has been defeated!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33807,'Enough of this insolence! Prepare to die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33808,'Deactivating.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33809,'You\'re going to be so nice and warm down here with us forever, beautiful!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33810,'Welcome, friend, welcome! There\'s always room for one more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33811,'Hi! My name\'s Uthil. We\'re going to be such good friends once you\'re dead!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33812,'Grow, little one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33813,'There you are.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33814,'Help shield us from these cutting winds, little sapling.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33815,'Good luck to you in there. I\'ll try to find you farther inside once the concourse is clear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33816,'Ready to move out, keep those dwarves off of our backs!','Ready to move out, keep those dwarves off of our backs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33817,'Stand back, $n. I must cleanse the Forest Heart.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33818,'We have lost our engineers, this will not end well!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33819,'There, the Forest Heart is now purified. Its power will replenish Ashenvale once more. We are forever in your debt, young one.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(33820,'Give us a moment to prepare to build the turrets.','Give us a moment to prepare to build the turrets.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33821,'Fires out! Let\'s rebuild those turrets!','Fires out! Let\'s rebuild those turrets!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33822,'Me not like ground shaking....','Me not like ground shaking....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33823,'Wh-what happening!?!','Wh-what happening!?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33824,'Splintertree under attack!!','Splintertree under attack!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33825,'Splintertree is surrounded!','Splintertree is surrounded!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33826,'%s surrounds itself with a void barrier as a dark shadow coalesces nearby!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33827,'How did we get up here, anyways?','How did we get up here, anyways?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33828,'NOW look where the ground is! Let me drive.','NOW look where the ground is! Let me drive.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33829,'Get to work, dogs! We\'re behind schedule!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33830,'Dig! Dig! Dig!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33831,'Dig faster! This ore won\'t mine itself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33832,'No time for breaks! Get back to work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33833,'You\'ve defeated the Iron Council and unlocked the Archivum!  Well done, lads!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33834,'Show support for your favorite champion! Wear their colors at the next bout and let \'em know who you love!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33835,'Want to show your pride without flailing around on one of those beasts? Whichever city you\'re rooting for, I got what you need!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33836,'Hey! Check out these doublets! Now you can sport your city\'s colors without having a tabard flapping around and getting in the way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33837,'This tournament is the biggest event in ages! Buy something to bring home to your family and show your kids.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33838,'$n!','$n!',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(33839,'$n is looking winded!','$n is looking winded!',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(33840,'On your guard, $n!','On your guard, $n!',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(33841,'Be strong, $n!','Be strong, $n!',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(33842,'Hit them harder, $n!','Hit them harder, $n!',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(33843,'I cannot believe $n is still standing!','I cannot believe $n is still standing!',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(33844,'Do not lower your guard, $n!','Do not lower your guard, $n!',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(33845,'Do not give up, $n!','Do not give up, $n!',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(33846,'$n!','$n!',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(33847,'$n is looking winded!','$n is looking winded!',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(33848,'On your guard, $n!','On your guard, $n!',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(33849,'Be strong, $n!','Be strong, $n!',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(33850,'Hit them harder, $n!','Hit them harder, $n!',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(33851,'I cannot believe $n is still standing!','I cannot believe $n is still standing!',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(33852,'Do not lower your guard, $n!','Do not lower your guard, $n!',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(33853,'Do not give up, $n!','Do not give up, $n!',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(33854,'|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 4%% Sanity Lost|r','|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 4%% Sanity Lost|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(33855,'You must remain within the Argent Tournament grounds.','You must remain within the Argent Tournament grounds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33856,'%s consumes a scrap bot to repair himself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33857,'Harpoon Turret is ready for use!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33858,'','You there! We need able bodies as fast as possible. Lives depend on it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33859,'There are secrets contained within these halls that are beyond our wildest dreams.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33860,'','Priestesses, I am to bring word that there are more survivors incoming. They are doing everything they can to sift through for the ones that are still alive, please send any help that you can!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33861,'','Understood, Sentinel. Return to the beach and aid them in bringing back any that are still alive.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33862,'','When the wounded arrive, we will be putting them up in the Inn while we tend to their recovery. Please find us there when you return.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33863,'','Of course, Priestess.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33864,'Kologarn casts Stone Grip!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33865,'Are you sure you are ready to fight a champion?','Are you sure you are ready to fight a champion?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33866,'It would be unwise to assume that fighting a champion would be a simple task.  Are you sure you are ready?','It would be unwise to assume that fighting a champion would be a simple task.  Are you sure you are ready?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33867,'Are you sure you are ready to fight me?','Are you sure you are ready to fight me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33868,'I have been defeated.  Good fight!','I have been defeated.  Good fight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33869,'%s whirs and beeps menacingly...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33870,'It seems you still need more practice.  Perhaps another time.','It seems you still need more practice.  Perhaps another time.',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(33871,'LET IT BE FINISHED!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33872,'Commencing watcher Freya status analysis.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33873,'Watcher powers augmented by presence of elder servants.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33874,'Analyzing Elder Brightleaf enhancement.... Persistent area defenses powered by solar amplification.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33875,'Elder Stonebark analysis reveals a sonic defense that disrupts use of magic.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33876,'Elder Ironbranch scans have uncovered plant-based immobilization mechanisms.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33877,'In addition, my analysis links each elder to an increase in Freya\'s spellcasting, physical, or summoning capabilities.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33878,'Destruction of elder servants will result in loss of enhancements on watcher Freya. However, permanent damage to Freya\'s person and possessions, including her watcher sigil, highly probable.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33880,'Commencing watcher Thorim status analysis.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33881,'An external influence, under illusory guise of Thorim\'s deceased mate, Sif, has been detected.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33882,'Mental interference from this presence dangerously close to triggering partial memory damage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33883,'Commencing watcher Hodir status analysis.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33884,'Hodir\'s sigil appears to be located inside a cache of artifacts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33885,'Watcher Hodir\'s temperament and behavior highly unstable. Destruction of cache highly probable during prolonged combat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33886,'Allies present in the field of battle are likely to provide synergies and minimize combat duration.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33887,'Commencing watcher Mimiron status analysis.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33888,'Watcher Mimiron\'s sigil is linked to a self-destruct mechanism connected to the entirety of the Corridors of Ingenuity.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33889,'Trigger for self-destruct mechanism is codenamed \"Big Red Button\", Mimiron\'s own creation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33890,'To retrieve Mimiron\'s sigil, initiate self-destruct sequence and defeat Mimiron before its completion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33891,'|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 12%% Sanity Lost|r','|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 12%% Sanity Lost|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33892,'Well, $c, that was... subtle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33893,'I must resume my duties, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33894,'Entry denied.  Access level insufficient.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33895,'Access to the Archivum granted.  Intrusion protection mechanisms suspended.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33896,'Initiating query.  The Algalon Failsafe is an automated emergency signal following a Prime Designate\'s demise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33897,'Affirmative.  Timestamp of Prime Designate Loken\'s destruction coincides with signal activation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33898,'Searching...  Destruction of Prime Designate is considered the first warning sign of systemic  planetary failure.  Algalon observer entity\'s arrival is followed by planetary diagnostics resulting in one of two possible reply signals.  Reply-code Alpha, signaling \"All is well\" and Reply-code Omega, signaling planetary re-origination.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33899,'The decomposition of the planet and its living organisms into base elements: metals, rocks, gases. This is followed by a period of reconstitution of each element into the original planetary blueprint.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33900,'Request denied.  Reply-codes built into Algalon observer entity.  He is both messenger and message.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33901,'Algalon diagnostics assess danger of systemic Old God corruption in planetary vital functions.  Calculating chance of Omega Reply-code...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33902,'Ninety-nine point nine nine percent.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33903,'That\'s repeating, of course.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33904,'Now, this is what we call a nice find!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33905,'I\'ll show ye access, ye wretched machine. Here it is again: Norgannon\'s key!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33906,'Looks just like all the other titan archives me lads have found... only older... and bigger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33907,'Wait a second: this doesn\'t look right! Next to this blinking light... what\'s this Algalon signal? ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33908,'Prime Designate? Where have I \'eard that before? By my grandfather\'s beard, Loken is Azeroth\'s Prime Designate. Loken\'s death triggered this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33909,'Well? Who\'s on the listening side of the signal? What\'s going to happen?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33910,'Planetary re-origination? Speak plainly, ye blasted machine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33911,'Hear that, lads? It\'s only the end of the world! Well, what are ye waiting for, ye rusty machine? Initiate Reply-code Alpha. All is well! Pints are on me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33912,'Well, what\'s this Algalon going to be looking for with his diagnostics? What are our chances?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33913,'Blast it, lads. Looks like we\'ve got a fight ahead of us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33914,'','Hefting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33915,'A thousand deaths...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33916,'Or one murder.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33917,'Blood of War','Blood of War',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33918,'The Displacement Pad appears to be active and stable.','The Displacement Pad appears to be active and stable.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33919,'Teleport to the Expedition Base Camp.','Teleport to the Expedition Base Camp.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33920,'Teleport to the Formation Grounds.','Teleport to the Formation Grounds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33921,'Teleport to the Colossal Forge.','Teleport to the Colossal Forge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33922,'Teleport to the Scrapyard.','Teleport to the Scrapyard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33923,'Teleport to the Antechamber of Ulduar.','Teleport to the Antechamber of Ulduar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33924,'Teleport to the Shattered Walkway.','Teleport to the Shattered Walkway.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33925,'Teleport to the Halls of Winter.','Teleport to the Halls of Winter.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33926,'Teleport to the Conservatory of Life.','Teleport to the Conservatory of Life.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33927,'Teleport to the Spark of Imagination.','Teleport to the Spark of Imagination.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33928,'Teleport to the Descent into Madness.','Teleport to the Descent into Madness.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33929,'','On behalf of the Argent Crusade, I welcome you to the Argent Tournament.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33930,'No one builds it faster, cheaper, and better than the Blastbolt brothers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33931,'%s is grounded permanently!','%s is grounded permanently!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33932,'New orders! Unlock the entry to the Celestial Planetarium.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33933,'Four watchers? Sigils? Could ye be a little less cryptic, confounded machine?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33934,'How do we get the sigils from them, then? Just walk up to them and ask them nicely?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33935,'You\'re going to tell us how to... \"un-compromise\" the sigils, aren\'t you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33936,'I\'ve dreamed of roaming the halls of the titans for years. I never thought I\'d be pitted against their creations.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33937,'Request denied. Access requires manual verification of the four watchers\' sigils.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33938,'The four watchers of Ulduar: Freya, Thorim, Hodir, and Mimiron. The sigils are tied to their physical and mental integrity. All four sigils are required for access to the Celestial Planetarium.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33939,'Analyzing watcher status. Please wait.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33940,'Corruption found. External influence gaining control over watchers. Sigils compromised.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33941,'Sufficient use of force would trigger a reset in watcher functions, removing the external influence.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33942,'As for not endangering the sigils during this process, I can analyze each watcher\'s status and make that information available to you upon completion of calculations.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33943,'An %s attacks the treekiller.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33944,'A spirit appears to avenge the Crystalsong Oak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33945,'An %s emerges from the dying Crystalsong Oak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33946,'It\'s a real honor to be able to aid Brann in exploring ancient Ulduar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33947,'Brann taught me everything I know about exploring.','Brann taught me everything I know about exploring.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33948,'Stay your arms! I yield!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33949,'I feel as though I am awakening from a nightmare, but the shadows in this place yet linger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33950,'Sif... was Sif here? Impossible--she died at my brother\'s hand. A dark nightmare indeed....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33951,'I need time to reflect.... I will aid your cause if you should require it. I owe you at least that much. Farewell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33952,'You! Fiend, you are not my beloved! Begone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33953,'Behold the hand behind all the evil that has befallen Ulduar, left my kingdom in ruins, corrupted my brother, and slain my wife.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33954,'And now it falls to you, champions, to avenge us all. The task before you is great, but I will lend you my aid as I am able. You must prevail.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33955,'|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 100%% Sanity Lost|r','|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 100%% Sanity Lost|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33956,'','For the Horde!!',0,0,0,0,0,0,0,0,1,8274,0,0,26124),
(33957,'','Die, elves!!',0,0,0,0,0,0,0,0,1,8274,0,0,26124),
(33958,'','Lok\'tar Ogar!!',0,0,0,0,0,0,0,0,1,8274,0,0,26124),
(33959,'','Blood and thunder!!',0,0,0,0,0,0,0,0,1,8274,0,0,26124),
(33960,'|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 9%% Sanity Lost|r','|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 9%% Sanity Lost|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(33961,'%s cries out for help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33962,'Stand still and stare into the light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33963,'Well met, $c.$B$BI train Aspirants in the art of mounted close combat.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(33964,'Show me how to train with a Melee Target.','Show me how to train with a Melee Target.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33965,'What is it, puny mort-$b$bErr... yes, $r? What can I do for you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33966,'Preliminary testing phase complete. Now comes the true test!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33967,'Yes, $c? What is it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33968,'The Melee Target trains Aspirants in both mounted attack and defense.$B$BApproach the Melee Target and strike it with a Thrust attack. The force of the blow often spins the target hard enough to injure you or your mount. This is where defense comes into play.$B$BBe certain to have at least one layer of Defend before attacking the target, and continue to stack and refresh Defend throughout the training exercise. Otherwise, you may well find yourself dismounted.$B$BThe same holds true in actual mounted combat: Balance attack and defense, Thrusting at every opportunity and maintaining your layers of Defend as best you can.','',1,25,1,0,2,2,0,0,1,0,0,0,26124),
(33969,'Good to see you, $n.$b$bI trust everything is going according to plan?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33970,'Durak, I have lost my disguise!','Durak, I have lost my disguise!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33971,'Back to work, dogs! We\'re behind schedule!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33972,'Don\'t let a little elf attack get in the way of your work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33973,'Get back to digging! This ore won\'t mine itself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33974,'No time for breaks! Get back to work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33975,'Hey there, how are ye?$B$BCome ta learn the art o\' the Charge, $c?','',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(33976,'Show me how to train with a Charge Target.','Show me how to train with a Charge Target.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33977,'Well then! A mounted Charge is about more than just kickin\' yer mount ta full speed an\' hollerin\' yer lungs out... though that IS the fun part, heh! But the Charge Target will teach ye the finer points.$B$BA good Charge is all about distance and timing. Ye can\'t be TOO close, or ye won\'t get enough speed. But ye can\'t be too far away either or yer mount will tire! As for timin\'...$B$BYe\'ll want ta make sure the Charge Target doesn\'t have a layer o\' Defend up before ye rush in. If it does, use yer Shield Breaker ta make it vulnerable, and THEN Charge in!$B$BSame goes for the real thing: Try ta drop yer opponent defenses before ye Charge!','',11,1,5,0,2,2,0,0,1,0,0,0,26124),
(33978,'%s catches a fish!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33979,'Well. Another $c, come to learn the ways of the Shield-Breaker...?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(33980,'Show me how to train with a Ranged Target.','Show me how to train with a Ranged Target.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33981,'The ranged Shield-Breaker attack is simple to learn, but difficult to master. Alone it may seem weak, but in conjunction with Thrusts and Charges the Shield-Breaker makes a successful jouster.$B$BFind a Ranged Target. Take a moment to understand the Shield-Breaker\'s range... how much space you need, and how far you can hurl the lance.$B$BAfter that? Well. Start throwing, and do not stop until you\'ve broken every last layer of Defend and pierced the vulnerable target.$B$BThis tactic will serve you well in actual mounted combat: Break down your opponents\' defenses... and then crush them!','',1,5,11,0,3,2,0,0,1,0,0,0,26124),
(33982,'We received Brann\'s message, and we have begun preparations.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33983,'Citizens of Dalaran! Raise your eyes to the skies and observe!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33984,'Today our world\'s destruction has been averted in defiance of our very makers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33985,'Algalon the Observer, herald of the titans, has been defeated by our brave comrades in the depths of the titan city of Ulduar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33986,'Algalon was sent here to judge the fate of our world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33987,'He found a planet whose races had deviated from the titans\' blueprints. A planet where not everything had gone according to plan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33988,'Cold logic deemed our world not worth saving. Cold logic, however, does not account for the power of free will. It\'s up to each of us to prove this is a world worth saving.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33989,'That our lives... our lives are worth living.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33990,'%s mutters to himself in Forsaken.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33991,'','Freya casts |cFF00FF00Strengthened Iron Roots!|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33993,'%s goes berserk, extinguishing all life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33994,'Behold the tools of creation!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33995,'Your actions are illogical. All possible results for this encounter have been calculated. The Pantheon will receive the Observer\'s message regardless of outcome.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33996,'Loss of life unavoidable.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33997,'I do what I must.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33998,'See your world through my eyes: A universe so vast as to be immeasurable - incomprehensible even to your greatest minds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(33999,'Beware...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34000,'I have seen worlds bathed in the Makers\' flames, their denizens fading without as much as a whimper. Entire planetary systems born and razed in the time that it takes your mortal hearts to beat once. Yet all throughout, my own heart devoid of emotion... of empathy. I. Have. Felt. Nothing. A million-million lives wasted. Had they all held within them your tenacity? Had they all loved life as you do?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34001,'You are out of time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34002,'Gorebag has shown me the Drakkari Empire. I am eager to help you conquer it!','Gorebag has shown me the Drakkari Empire. I am eager to help you conquer it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34003,'All in good time, mon. I be havin\' more work for you to do soon....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34004,'%s begins to Overload!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34005,'I have whipped the Blight Geists into shape!','I have whipped the Blight Geists into shape!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34006,'Analysis complete. There is partial corruption in the planet\'s life-support systems as well as complete corruption in most of the planet\'s defense mechanisms.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34007,'Indeed you have, mon. Our stores of blight crystals be nearly sufficient!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34008,'I have defeated Darmuk! How else may I serve you?','I have defeated Darmuk! How else may I serve you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34010,'Darmuk\'s incompetence be hinderin\' us no more! Patience, mon. Dere soon be more for you to do....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34011,'The Drakkari Chieftains have been captured! What more would you have me do?','The Drakkari Chieftains have been captured! What more would you have me do?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34012,'Perhaps it is your imperfections... that which grants you free will... that allows you to persevere against all cosmically calculated odds. You prevail where the Titan\'s own perfect creations have failed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34013,'I\'ve rearranged the reply code - your planet will be spared. I cannot be certain of my own calculations anymore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34014,'Begin uplink: Reply Code: \'Omega.\' Planetary re-origination requested.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34015,'Farewell, mortals. Your bravery is admirable, for such flawed creatures.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34016,'I lack the strength to transmit the signal. You must... hurry... find a place of power... close to the skies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34017,'I know just the place. Will you be all right?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34018,'Do not worry about my fate, Bronzen. If the signal is not transmitted in time, re-origination will proceed regardless. Save... your world...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34019,'With da chieftains out of da way, we be poised to make our assault! Soon, $n....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34020,'I have witnessed your magnificent operation, Drakuru. When do we put your plan into effect?','I have witnessed your magnificent operation, Drakuru. When do we put your plan into effect??',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34021,'Now ya be knowin\' everything, mon! Prepare yourself... we attack soon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34022,'%s opens his mouth wide!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34023,'%s\'s heart is severed from his body.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34024,'I was here visiting relatives when Lordaeron fell, and then... well. I suppose I won\'t ever be returning to Westfall, now.$B$BSometimes I wonder if my family is still alive. More often, though, I wonder why I no longer care.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34025,'We did it, lads! We got here before Algalon\'s arrival... maybe we can rig the systems to interfere with his analysis...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34026,'Translocation complete. Commencing planetary analysis of Azeroth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34027,'Stand back, mortals. I\'m not here to fight you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34028,'It is in the universe\'s best interest to re-originate this planet should my analysis find systemic corruption. Do not interfere.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34029,'I\'ll head back to the Archivum and see if I can jam his signal. I might be able to buy us some time while you take care of him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34031,'Now try out your skills.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34032,'Put up Defend$B|TInterface\\Icons\\Ability_Warrior_ShieldMastery.blp:32|t$BThen use Thrust on a Melee Target.$B|TInterface\\Icons\\INV_Sword_65.blp:32|t','Put up Defend$B|TInterface\\Icons\\Ability_Warrior_ShieldMastery.blp:32|t$BThen use Thrust on a Melee Target.$B|TInterface\\Icons\\INV_Sword_65.blp:32|t',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34033,'Gaze upon its magnificence! Bask in its glorious, um, glory! I present you with... V-07-TR-0N!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34034,'Use Shield-Breaker on a Charge Target.$B|TInterface\\Icons\\Ability_Warrior_ShieldBreak.blp:32|t$BFollow up with Charge while the target is vulnerable.$B|TInterface\\Icons\\Ability_Mount_Charger.blp:32|t','Use Shield-Breaker on a Charge Target.$B|TInterface\\Icons\\Ability_Warrior_ShieldBreak.blp:32|t$BFollow up with Charge while the target is vulnerable.$B|TInterface\\Icons\\Ability_Mount_Charger.blp:32|t',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34035,'Use Shield-Breaker on a Ranged Target.$B|TInterface\\Icons\\Ability_Warrior_ShieldBreak.blp:32|t$BThen use Shield-Breaker while the target is defenseless.$B|TInterface\\Icons\\Ability_Warrior_ShieldBreak.blp:32|t','Use Shield-Breaker on a Ranged Target.$B|TInterface\\Icons\\Ability_Warrior_ShieldBreak.blp:32|t$BThen use Shield-Breaker while the target is defenseless.$B|TInterface\\Icons\\Ability_Warrior_ShieldBreak.blp:32|t',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34036,'The strong odor coming from the bowl smells like a mixture of various herbs with burning hair.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34037,'Portals open into %s\'s mind!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34038,'Watcher Analysis: Freya','Watcher Analysis: Freya',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34039,'Watcher Analysis: Hodir','Watcher Analysis: Hodir',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34040,'I am ready to accompany you to Splintertree, Kadrak!','I am ready to accompany you to Splintertree, Kadrak!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34041,'Watcher Analysis: Thorim','Watcher Analysis: Thorim',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34042,'Watcher Analysis: Mimiron','Watcher Analysis: Mimiron',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34043,'A Tempest Minion appears to defend Emalon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34044,'Breathe in the smoke to entice visions of the great animal spirits.','Breathe in the smoke to entice visions of the great animal spirits.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34045,'I will check back with you shortly, Kadrak.','I will check back with you shortly, Kadrak.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34046,'Brutusk is out watering the bushes right now.$b$bStay close though, $n. He should be ready for our ride to Splintertree very soon.','',0,0,0,0,0,0,0,0,1,8174,0,0,26124),
(34047,'Now... witness the power of a war kodo in the hands of a master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34048,'%s cries out, \"I will have my vengeance!\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34049,'To Splintertree!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34050,'You thought to stand before the legions of death and survive?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34051,'Defiance... a flaw of mortality.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34052,'Your defeat was inevitable.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34053,'Your destruction will herald a new age of suffering!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34054,'Oh, what horrors await....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34055,'The black blood of Yogg-Saron courses through me! I. AM. UNSTOPPABLE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34056,'Behold now: terror absolute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34057,'%s goes into a berserker rage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34058,'Tactical analysis suggests approaching the arena from the front and splitting secondary force through a side passage at the ground level. This will maximize odds of reaching Thorim\'s outlook before mental domination by external presence is complete.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34059,'Preservation of cache is essential to recovering Hodir\'s sigil.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34060,'Please hold still for a moment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34061,'Fragment analysis underway.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34062,'Object identified: Val\'anyr, hammer of ancient kings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34063,'Created by the titans themselves, Val\'anyr was given to the first earthen king, Urel Stoneheart. With the hammer he was to create and give life to the rest of his brethren.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34064,'Val\'anyr was shattered during the first war between the earthen and the iron dwarves. The weapon\'s remnants were believed lost in the conflict.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34065,'Probability of successful repair by ordinary means available in this world is close to nil. Please hold while theoretical means are analyzed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34066,'Powerful acidic content theoretically found inside the being known as Yogg-Saron would account for the liquification of saronite. Submersion in this substance might be sufficient to rebind an alloy of titan origin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34067,'Sporebat','Sporebat',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34068,'Cunning Pet','Cunning Pet',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34069,'Ferocious Pet','Ferocious Pet',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34070,'Tenacious Pet','Tenacious Pet',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34071,'Aid your companions little one; the battle is joined!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34072,'','Aid your companions little one; the battle is joined!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34073,'Hail, champion. Yogg-Saron\'s defeat echoes through these halls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34074,'Hyena','Hyena',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34075,'Moth','Moth',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34076,'Tallstrider','Tallstrider',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34077,'Wasp','Wasp',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34078,'','Hail, champion. Yogg-Saron\'s defeat echoes through these halls.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34079,'Bear','Bear',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34080,'Crab','Crab',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34081,'Crocolisk','Crocolisk',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34082,'Gorilla','Gorilla',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34083,'Turtle','Turtle',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34084,'Just in time. Let\'s see this thing off, then.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34085,'%s crackles and surges with raw energy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34086,'It would appear that I\'ve made a slight miscalculation. I allowed my mind to be corrupted by the fiend in the prison, overriding my primary directive. All systems seem to be functional now. Clear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34087,'Teach them the meaning of blood and thunder!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34088,'It is done. The spirit is bound with you and you will carry it with you anytime you are in Darkshore. May you serve nature well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34089,'You must be riding a tournament mount before I can instruct you.$B$BEquip a lance and find a tournament mount outside your faction\'s pavilion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34090,'Tell me more about Defend and Thrust.','Tell me more about Defend and Thrust.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34091,'Tell me more about using the Shield-Breaker.','Tell me more about using the Shield-Breaker.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34092,'Tell me more about the Charge.','Tell me more about the Charge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34093,'Now there\'s some REAL blood and thunder!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34094,'Lok\'tar Ogar!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34095,'','Greetings.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34096,'','Would you like a ride?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34097,'','Is there anything that I can help with?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34098,'','Good to see you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34099,'','Looking for a ride?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34100,'','How are you, $c?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34101,'','A bit cold out, don\'t you think?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34102,'','I\'m glad to see that you\'re well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34103,'My advice is no good to ye unless ye\'re ridin\' a tournament mount.$B$BEquip a lance and grab a tournament mount outside yer faction\'s pavilion.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(34104,'Only champions of Stormwind may purchase what I have to offer.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34105,'I\'d like to travel to the Ruins of Mathystra.','I\'d like to travel to the Ruins of Mathystra.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34106,'','Forgive me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34107,'','From your death springs life anew!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34108,'I\'d like to travel to Shatterspear Vale.','I\'d like to travel to Shatterspear Vale.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34109,'I\'d like to travel to the Bashal\'Aran.','I\'d like to travel to the Bashal\'Aran.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34110,'I\'d like to travel to Lor\'danel.','I\'d like to travel to Lor\'danel.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34111,'Not far now....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34112,'Splintertree...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34113,'We must break the siege!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34114,'For the Horde!!','For the Horde!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34115,'Matron, the Conservatory has been breached!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34116,'Not so fast, $r!$B$BOnly champions of Ironforge can purchase what I got ta offer.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34117,'Open the gates brothers! Let us welcome our visitors in true Horde fashion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34118,'Fertilizer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34119,'Your corpse will nourish the soil.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34120,'Apologies, $r, but only champions of Thunder Bluff may purchase what I have to offer.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34121,'Matron, one has fallen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34122,'','Away with you, $c!$B$BOnly champions of Undercity may purchase what I have to offer.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34123,'Mortals have no place here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34124,'I return you whence you came!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34125,'BEGONE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34126,'Freya! They come for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34127,'','Only champions of Orgrimmar may purchase what I have to offer.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34128,'','Only champions of the Exodar may purchase what I have to offer.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34129,'This place will serve as your graveyard.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34130,'Such a waste....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34131,'','Hi there!$B$BSorry, friend, but only champions of Gnomeregan can buy what I\'ve got.',3,1,0,0,2,0,0,0,1,0,0,0,26124),
(34132,'Matron, flee! They are ruthless....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34133,'None shall pass!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34134,'Alas, only champions of Darnassus may purchase what I have to offer.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34135,'KOL-THARISH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34136,'','Samamba tinkin\' joo be at da wrong quartermaster!$B$BWhat she got only for de Sen\'jin champions...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34137,'YOU FAIL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34138,'I will squeeze the life from you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34139,'Alas, only the esteemed champions of Silvermoon City may purchase what I have to offer.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34140,'OBLIVION!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34141,'Master, they come....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34142,'I am invincible!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34143,'Just a scratch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34144,'Only a flesh wound!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34145,'The iron dwarves have been seen emerging from the bunkers at the base of the pillars straight ahead of you! Destroy the bunkers, and they\'ll be forced to fall back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34146,'Watch out! Our air scouts report that the generators for the missile silos are coming online!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34147,'There are four generators powering the defense structures. If you sabotage the generators, the missile attacks will stop!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34148,'This tower powers the Hammer of Hodir. It is said to have the power to turn entire armies to ice! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34149,'You\'re approaching the tower of Freya. It contains the power to turn barren wastelands into jungles teeming with life overnight. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34150,'This generator powers Mimiron\'s Gaze. In moments, it can turn earth to ash, stone to magma--we cannot let it reach full power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34151,'Ah, the tower of Krolmir. It is said that the power of Thorim has been used only once... and that it turned an entire continent to dust. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34152,'The control unit for the missile generator is on the top floor of the tower. If you can find a way to get up there, you can shut it down yourselves.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34153,'It appears you are near a repair station! Drive your vehicle onto the platform, and it should be automatically repaired.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34154,'You\'ve done it! You\'ve broken the defenses of Ulduar. In a few moments, we will be dropping in to...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34155,'What is that? Be careful! Something\'s headed your way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34156,'Quickly! Evasive action! Evasive act--','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34157,'Okay! Let\'s move out. Get into your machines; I\'ll speak to you from here via the radio!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34158,'','Be sure to stop by the bridges southeast of town. You should be able to secure a nightsaber to get you down to the ruins.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34159,'','Don\'t forget to check near the bridges southeast of town for a ride up to our forward post.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34160,'Make \'em pay, Brutusk!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34161,'We did it, lads! We got here before Algalon\'s arrival. Maybe we can rig the systems to interfere with his analysis--','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34162,'','%s begins to activate the Feral Defender!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34163,'Your flesh is forfeit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34164,'Blood and Thunder!','Blood and Thunder!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34165,'Drive them back! Back to Darnassus!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34166,'I want to see every scrap of paper you wretches get your claws on.','',396,0,0,500,0,0,0,0,1,0,0,0,26124),
(34167,'I said, SEARCH the bodies BEFORE you eat them!','',22,0,0,500,0,0,0,0,1,0,0,0,26124),
(34168,'Leave no stone unturned. I mean that literally, you heaps of decay! Tear this place apart if you have to.','',5,0,0,500,0,0,0,0,1,0,0,0,26124),
(34169,'Get off that horse and fight me man-to-man!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34170,'%s prepares to unleash Empowering Shadows!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34171,'Brutusk... NOOOOOO!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34172,'Everyone... back to Splintertree at once!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34173,'Getting these replacements up here was no easy feat. Make it worth our while, will ya?','Getting these replacements up here was no easy feat. Make it worth our while, will ya?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34174,'You\'ll get\'m this time. Show no mercy!','You\'ll get\'m this time. Show no mercy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34175,'Replacement siege vehicles brought right to your doorstep in no time flat. Can\'t ask for better service than that!','Replacement siege vehicles brought right to your doorstep in no time flat. Can\'t ask for better service than that!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34176,'That last time was just practice, right? You\'ve got this!','That last time was just practice, right? You\'ve got this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34177,'Don\'t worry one bit, we had replacements ready. Can\'t expect to always get it first go, you know.','Don\'t worry one bit, we had replacements ready. Can\'t expect to always get it first go, you know.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34178,'Wow, that\'s one big tank! You\'ve got more guts than I do. Good luck to ya!','Wow, that\'s one big tank! You\'ve got more guts than I do. Good luck to ya!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34179,'We\'ve got your back... and a hefty supply of vehicles to fix up too apparently.','We\'ve got your back... and a hefty supply of vehicles to fix up too apparently.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34180,'Aww, I told you take care of her. I poured my heart and soul into that thing, you know? Take it easy this time around.','Aww, I told you take care of her. I poured my heart and soul into that thing, you know? Take it easy this time around.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34181,'','%s quietly slips into the underbrush.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34182,'The siege is broken... for now. Follow me to Splintertree.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34183,'Not a bit. For the life of me, I can\'t figure out how this thing works.','Not a bit. For the life of me, I can\'t figure out how this thing works.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34184,'Any luck?','Any luck?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34185,'I will not fail you, master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34186,'Keep at it. If our suspicions are right and this is a transporter, it could prove extremely useful in our assault.','Keep at it. If our suspicions are right and this is a transporter, it could prove extremely useful in our assault.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34187,'I know, I know... I haven\'t given up yet. Don\'t get your hopes up though, this technology is way beyond me.','I know, I know... I haven\'t given up yet. Don\'t get your hopes up though, this technology is way beyond me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34188,'Your petty quarrels only make me stronger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34189,'The darned thing just started working! This should take you right up to the end of the concourse, where you last fought the Flame Leviathan.','The darned thing just started working! This should take you right up to the end of the concourse, where you last fought the Flame Leviathan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34190,'We\'ve moved the replacement vehicles up already so that you can take the thing down this time. Good luck!','We\'ve moved the replacement vehicles up already so that you can take the thing down this time. Good luck!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34191,'Rip it to pieces!','Rip it to pieces!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34192,'Thank you all for attending this sermon. It\'s wonderful to see so many familiar faces!','Thank you all for attending this sermon. It\'s wonderful to see so many familiar faces!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34193,'Today I would like to touch on the three virtues of the Light.','Today I would like to touch on the three virtues of the Light.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34194,'These are dark and difficult times for us all. The armies of the Scourge amass to the south. Companions fall on the battlefield and rise to serve our enemy moments later.','These are dark and difficult times for us all. The armies of the Scourge amass to the south. Companions fall on the battlefield and rise to serve our enemy moments later.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34195,'What can you tell me, Keynira?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34196,'Many of you have experienced a betrayal of trust.','Many of you have experienced a betrayal of trust.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34197,'Yet you persevere, as we all must. In these times, no one is a stranger to the virtue of tenacity. In the face of despair and hatred, we continue to stand true to our beliefs and fight on.','Yet you persevere, as we all must. In these times, no one is a stranger to the virtue of tenacity. In the face of despair and hatred, we continue to stand true to our beliefs and fight on.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34198,'That will do for the moment. And the tower? What of Althalaxx?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34199,'There can be no doubt as to your tenacity... but there are other virtues to consider.','There can be no doubt as to your tenacity... but there are other virtues to consider.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34200,'Respect is the first virtue taught to those joining the path of the Light.','Respect is the first virtue taught to those joining the path of the Light.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34201,'Look across the aisle to those you would call enemy. Despite the hatred that separates you, there are qualities to respect in your opponent. Their prowess should be acknowledged.','Look across the aisle to those you would call enemy. Despite the hatred that separates you, there are qualities to respect in your opponent. Their prowess should be acknowledged.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34202,'All of us gathered here have a concept of honorable combat. Conducting yourself with honor and treating your opponent as you wish to be treated shows respect.','All of us gathered here have a concept of honorable combat. Conducting yourself with honor and treating your opponent as you wish to be treated shows respect.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34203,'Respect your opponent on the field, whether he be your brother or your sworn enemy. No matter where your beliefs truly lie, such respect is acknowledging a connection...','Respect your opponent on the field, whether he be your brother or your sworn enemy. No matter where your beliefs truly lie, such respect is acknowledging a connection...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34204,'That\'s all you\'ve got for me? I want numbers, locations, intentions - we\'re as good as blind. Get back out in the field!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34205,'...and in acknowledging those connections, you are closer to the Light.','...and in acknowledging those connections, you are closer to the Light.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34206,'There is one further step on the path of Light: compassion.','There is one further step on the path of Light: compassion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34207,'Rivalries abound in this day and age. It is easy to see differences wherever you turn.','Rivalries abound in this day and age. It is easy to see differences wherever you turn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34208,'The challenge is in looking beyond appearances and understanding our similarities. Through this understanding, you can feel compassion for the losses others have suffered...','The challenge is in looking beyond appearances and understanding our similarities. Through this understanding, you can feel compassion for the losses others have suffered...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34209,'...even if the victim bears another banner.','...even if the victim bears another banner.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34210,'By feeling and understanding compassion in enemy and ally alike, you reaffirm your connection with the world.','By feeling and understanding compassion in enemy and ally alike, you reaffirm your connection with the world.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34211,'Acting on these tenets, these virtues, help make the world a place we all can appreciate. A world of honor and justice.','Acting on these tenets, these virtues, help make the world a place we all can appreciate. A world of honor and justice.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34212,'Think on my words, friends. In the darkness that surrounds us all, the Light is needed more than ever.','Think on my words, friends. In the darkness that surrounds us all, the Light is needed more than ever.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34213,'','The catapults remain disabled. I\'ve burned several and trapped the others.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34214,'','I - I don\'t know. There\'s movement in the ruins.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34215,'','Shhhh - Please don\'t give away my position when I\'m out in the field. Mathas needs to know what\'s happening out here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34216,'I\'ll be behind the confessional screen if anyone wishes to speak with me. Any doubts, any worries, any uncertainties I will happily soothe.','I\'ll be behind the confessional screen if anyone wishes to speak with me. Any doubts, any worries, any uncertainties I will happily soothe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34217,'%s begins to cast Plasma Blast!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34218,'','Let us put an end to this Shatterspear threat for good. Sentinels, attack now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34219,'','I\'ve shattered the shield protecting their leader! Quickly, kill him!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34220,'We do not act alone in this. Whatever happens to us this day, the night elves will still fall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34221,'','It was folly for them to think us weak amidst recent events. There is no more hope for these trolls  - we will end this today.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34222,'I am ready. Begin the attack.','I am ready. Begin the attack.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34223,'','Let me know when you are ready to begin the attack.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34224,'','We\'re expecting the Shatterspear Leader to show here at any moment. Be patient if you wish to join the attack.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34225,'What a battle! Did you see that, Rhydian?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34226,'Perhaps so, but it\'s only a matter of time until we break back into Ulduar. Any luck finding a way to teleport inside?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34227,'','Our friends fought well, Brann, but we\'re not done yet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34228,'','None at all. I suspect it has something to do with that giant mechanical construct that our scouts spotted in front of the gate.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34229,'Oi. So we\'ll have to contend with that thing after all then?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34230,'','The Kirin Tor can\'t possibly spare any additional resources to take on anything that size. We may not have to though.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34231,'What about the plated proto-drake and the fire giant that were spotted nearby? Think your mages can handle those?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34232,'','We can sneak past them. As long as we can take down that construct in front of the gate, we should be able to get inside.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34233,'Sneak?! What do you think we are, marmots?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34234,'','We\'re hunting an old god, Brann. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34235,'Fine. If our allies are going to be the ones getting their hands dirty, we\'ll leave it to them to decide how to proceed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34236,'Great job with that metal monstrosity. There appears to be only a few more obstacles in our way.$B$BOnce you clear out that clanking robot at the end of the hall, we\'ll be inside Ulduar.$B$BWe also noticed an enormous, fire-breathing protodrake and a molten giant. They aren\'t in our way, though, if you\'d like to just avoid them. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34237,'You must remain within the field of battle.','You must remain within the field of battle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34238,'I am on a task from Kadrak. I must get to Zoram\'gar right away!','I am on a task from Kadrak. I must get to Zoram\'gar right away!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34239,'Can\'t you at least put up a fight?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34240,'Pathetic.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34241,'Do not hold back! Destroy them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34242,'Welcome to the tournament, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34243,'','It\'s good to see you here, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34244,'Now, why would you go and do something like that? Didn\'t you see the sign that said, \"DO NOT PUSH THIS BUTTON!\"? How will we finish testing with the self-destruct mechanism active?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34245,'I seek training in Fishing.','I seek training in Fishing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34246,'I don\'t know if I can compete! Everyone is so much bigger!','I don\'t know if I can compete! Everyone is so much bigger!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34247,'I\'ve calculated the probability of my success, and it\'s distressingly low!','I\'ve calculated the probability of my success, and it\'s distressingly low!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34248,'I can\'t accurately assess the mathematics behind the charge of my turbostrider while keeping hold of my lance at the precise angle needed and keeping my shield in the exact location for maximum protection at any given second!','I can\'t accurately assess the mathematics behind the charge of my turbostrider while keeping hold of my lance at the precise angle needed and keeping my shield in the exact location for maximum protection at any given second!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34249,'...and some of those mounts can trample me!','...and some of those mounts can trample me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34250,'Take heart. Size isn\'t what matters, but how you use the skills you have.','Take heart. Size isn\'t what matters, but how you use the skills you have.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34251,'What you lack in size you make up for in ambition and dedication, little one. Go with the Light.','What you lack in size you make up for in ambition and dedication, little one. Go with the Light.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34252,'I punched a penguin on my way in here.','I punched a penguin on my way in here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34253,'Nah, not really. I just wanted to see the look on your face.','Nah, not really. I just wanted to see the look on your face.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34254,'Oh, my. Do you feel remorseful, at least?','Oh, my. Do you feel remorseful, at least?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34255,'Lass, I\'ve a confession to make to ya.','Lass, I\'ve a confession to make to ya.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34256,'I\'ve been feelin\'... urges.','I\'ve been feelin\'... urges.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34257,'It was a powerful feelin\' while I was listenin\' to yer sermon, and it\'s drivin\' me nuts!','It was a powerful feelin\' while I was listenin\' to yer sermon, and it\'s drivin\' me nuts!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34258,'...I NEED A DRINK!','...I NEED A DRINK!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34259,'Drink in moderation, then, my dwarven friend, but you may want to turn in your lance and reins for the time being. Go with the Light.','Drink in moderation, then, my dwarven friend, but you may want to turn in your lance and reins for the time being. Go with the Light.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34260,'My heart hangs heavier with each passing day, Confessor.','My heart hangs heavier with each passing day, Confessor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34261,'I have been ordered here, and here I stay and fight under the banner of Stormwind. But everything I do here is empty.','I have been ordered here, and here I stay and fight under the banner of Stormwind. But everything I do here is empty.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34262,'Beyond these reaches, the Scourge continue their work, destroying more and more of what we\'ve built. The fight should be there. I should be there.','Beyond these reaches, the Scourge continue their work, destroying more and more of what we\'ve built. The fight should be there. I should be there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34263,'How can I justify jousting while people die without my protection?','How can I justify jousting while people die without my protection?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34264,'Your heart is in the right place, and I know you seek to serve the Light. But these small strikes do little to the great undead host.','Your heart is in the right place, and I know you seek to serve the Light. But these small strikes do little to the great undead host.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34265,'This tournament is helping to form a strong, concerted force, though it may not appear obvious. When we\'re ready, the eyes of the Crusade and all its champions will turn toward Icecrown.','This tournament is helping to form a strong, concerted force, though it may not appear obvious. When we\'re ready, the eyes of the Crusade and all its champions will turn toward Icecrown.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34266,'We will bring the might of all races to the Lich King, and he will be defeated.','We will bring the might of all races to the Lich King, and he will be defeated.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34267,'I know this does not seem like the obvious path to you, but it will bring you closer to the Light. Fight well, brother.','I know this does not seem like the obvious path to you, but it will bring you closer to the Light. Fight well, brother.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34268,'','Self-destruct sequence initiated.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34269,'This isn\'t honorable combat. I long to face my opponents in battle with my axe in hand!','This isn\'t honorable combat. I long to face my opponents in battle with my axe in hand!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34270,'These are my enemies. YOU would be my enemy in battle! Your king has declared war on my kind!','These are my enemies. YOU would be my enemy in battle! Your king has declared war on my kind!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34271,'But instead of fighting as my people would, as my people should, I find myself with a long, unwieldy pole, attempting to coax my wolf into charging my opponent without attacking.','But instead of fighting as my people would, as my people should, I find myself with a long, unwieldy pole, attempting to coax my wolf into charging my opponent without attacking.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34272,'This is not how orcs fight! My duty to the Warchief wars with my personal honor. I hold no faith in your Light, but as you seem an advisor, I would hear your words.','This is not how orcs fight! My duty to the Warchief wars with my personal honor. I hold no faith in your Light, but as you seem an advisor, I would hear your words.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34273,'','This area will self-destruct in six minutes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34274,'','This area will self-destruct in five minutes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34275,'','This area will self-destruct in four minutes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34276,'','This area will self-destruct in three minutes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34277,'','This area will self-destruct in two minutes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34278,'','This area will self-destruct in one minute.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34279,'','Self-destruct sequence finalized. Have a nice day!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34280,'','This area will self-destruct in seven minutes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34281,'','This area will self-destruct in eight minutes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34282,'','This area will self-destruct in nine minutes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34283,'','This area will self-destruct in ten minutes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34284,'','Self-destruct sequence terminated. Override code A-9-0-5.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34285,'I understand your frustration. Your people are ferocious in battle, and this isn\'t what you\'re used to.','I understand your frustration. Your people are ferocious in battle, and this isn\'t what you\'re used to.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34286,'But this is a different sort of honorable combat. Difficult to adapt to, perhaps, but with your prowess I\'m sure you\'ll show everyone the strength in your people.','But this is a different sort of honorable combat. Difficult to adapt to, perhaps, but with your prowess I\'m sure you\'ll show everyone the strength in your people.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34287,'Besides... while an axe can be a valuable tool in war, lances have their uses as well.','Besides... while an axe can be a valuable tool in war, lances have their uses as well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34288,'Go with the Light, orc.','Go with the Light, orc.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34289,'This fighting is endless. I\'m not certain how much more of it I can stand.','This fighting is endless. I\'m not certain how much more of it I can stand.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34290,'All of this posturing, all of this dancing about in rings... it seems pointless. What\'s the use?','All of this posturing, all of this dancing about in rings... it seems pointless. What\'s the use?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34291,'And I\'m beginning to get HELMET HAIR. This is a travesty!','And I\'m beginning to get HELMET HAIR. This is a travesty!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34292,'It may seem pointless, but try to find pride in a good fight. The time will come when all this practicing and competition will be put to good use.','It may seem pointless, but try to find pride in a good fight. The time will come when all this practicing and competition will be put to good use.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34293,'And your hair looks wonderful.','And your hair looks wonderful.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34294,'The illusion shatters and a path to the central chamber opens!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34295,'The Left Arm has regrown!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34296,'The Right Arm has regrown!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34297,'It takes a lot of dedication to train and ride a Venomhide.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34298,'Oh, my! I wasn\'t expecting company! The workshop is such a mess. How embarrassing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34299,'MEDIC!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34300,'I can fix that... or  maybe not! Sheesh, what a mess...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34301,'Fascinating. I think they call that a \"clean kill\".','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34302,'Note to self: Cannon highly effective against flesh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34303,'Outplayed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34304,'You can do better than that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34305,'Oh, my! It would seem that we are out of time, my friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34306,'Insolent whelps! Your blood will temper the weapons used to reclaim this world!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34307,'Arise, soldiers of the iron crucible! The Maker\'s will be done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34308,'I will burn away your impurities!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34309,'Let the inferno consume you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34310,'BURN! Burn in the Maker\'s fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34311,'More scraps for the scrap heap.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34312,'Your bones will serve as kindling.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34313,'I. Have. Failed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34314,'Whether the world\'s greatest gnats or the world\'s greatest heroes, you are still only mortal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34315,'A merciful kill!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34316,'HAH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34317,'Let the storm clouds rise and rain down death from above!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34318,'The power of the storm lives on.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34319,'You rush headlong into the maw of madness!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34320,'This meeting of the Assembly of Iron is adjourned!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34321,'You will not defeat the Assembly of Iron so easily, invaders!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34322,'So fragile and weak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34323,'Flesh... such a hindrance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34324,'You seek the secrets of Ulduar? Then take them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34325,'My death only serves to hasten your demise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34326,'Impossible...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34327,'This meeting of the Assembly of Iron is adjourned!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34328,'Nothing short of total decimation will suffice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34329,'The world suffers yet another insignificant loss.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34330,'Death is the price of your arrogance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34331,'Decipher this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34332,'Face the lightning\'s surge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34333,'The legacy of storms shall not be undone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34334,'What have you gained from my defeat? You are no less doomed, mortals.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34335,'This meeting of the Assembly of Iron is adjourned!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34336,'You will suffer for this trespass!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34337,'Tragic. To come so far, only to fail.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34338,'Welcome to the endless winter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34339,'Winds of the north consume you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34340,'ENOUGH! This ends now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34341,'','Some things are better left alone!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34342,'','HELP ME! Please get them off of me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34343,'','What do you want from me? Leave me alone!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34344,'','Yes! YES! Show them no mercy! Give no pause to your attacks!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34345,'','Let hatred and rage guide your blows!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34346,'','The time to strike at the head of the beast will soon be upon us! Focus your anger and hatred on his minions!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34347,'','Suffocate upon your own hate!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34348,'','Tremble, mortals, before the coming of the end!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34349,'','Powerless to act....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34350,'','Could they have been saved?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34351,'','I am the lucid dream.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34352,'','The monster in your nightmares.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34353,'','The fiend of a thousand faces.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34354,'','The secret dies with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34355,'','There is no escape.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34356,'','Cower before my true form.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34357,'BOW DOWN BEFORE THE GOD OF DEATH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34358,'','You waste my time!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34359,'Weak-minded fool!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34360,'Look upon the true face of death, and know that your end comes soon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34361,'MADNESS WILL CONSUME YOU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34362,'Eternal suffering awaits!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34363,'Your will is no longer your own.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34364,'Destroy them, minion! Your master commands it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34365,'Your fate is sealed. The end of days is finally upon you and ALL who inhabit this miserable little seedling. Uulwi ifis halahs gag erh\'ongg w\'ssh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34366,'The veil of winter will protect you, champions!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34367,'','Eonar, your servant calls for your blessing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34368,'Combat matrix enhanced. Behold wonderous rapidity!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34369,'Golganneth, lend me your strength! Grant my mortal allies the power of thunder!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34370,'As the Molten Colossus weakens, a single ominous word rumbles through the air like rolling thunder: \"BURN\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34371,'Return to Astranaar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34372,'Tread lightly through these woods, $c. It is as though the trees themselves have eyes and whisper to our foes.','',1,0,0,100,0,0,0,0,1,0,0,0,26124),
(34373,'Send me to the Mor\'shan Ramparts, Kulg.','Send me to the Mor\'shan Ramparts, Kulg.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34374,'Your target has evaded your Charge.','Your target has evaded your Charge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34375,'Your target has been knocked off-balance.','Your target has been knocked off-balance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34376,'Your target was waiting for your Charge with a readied lance.','Your target was waiting for your Charge with a readied lance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34377,'How do the Argent Crusade riders fight?','How do the Argent Crusade riders fight?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34378,'The Argent Crusade riders believe in balance and precision, deftly mixing attack and defense.$B$BHowever, they will often open themselves to Charges by trying to gain range on you.$B$BClose that range with a Charge before they can do the same, and then Shield-Break them as you wheel around for more Thrusts.','The Argent Crusade riders believe in balance and precision, deftly mixing attack and defense.$B$BHowever, they will often open themselves to Charges by trying to gain range on you.$B$BClose that range with a Charge before they can do the same, and then Shield-Break them as you wheel around for more Thrusts.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34379,'The Stormwind riders pride themselves on fearless and devastating charges. Such is their skill and ferocity that even when charged themselves they simply charge right back.$B$BTry staying close and Thrusting, and when they attempt to gain range, throw them off-balance with a Shield-Breaker before you Charge. Otherwise, they\'ll meet you head-on every time.','The Stormwind riders pride themselves on fearless and devastating charges. Such is their skill and ferocity that even when charged themselves they simply charge right back.$B$BTry staying close and Thrusting, and when they attempt to gain range, throw them off-balance with a Shield-Breaker before you Charge. Otherwise, they\'ll meet you head-on every time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34380,'The Gnomeregan riders believe in balance and precision, deftly mixing attack and defense.$B$BHowever, they will often open themselves to Charges by trying to gain range on you.$B$BClose that range with a Charge before they can do the same, and then Shield-Break them as you wheel around for more Thrusts.','The Gnomeregan riders believe in balance and precision, deftly mixing attack and defense.$B$BHowever, they will often open themselves to Charges by trying to gain range on you.$B$BClose that range with a Charge before they can do the same, and then Shield-Break them as you wheel around for more Thrusts.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34382,'The Darnassus riders count on their nimbleness and skill at range.$B$BThey are quick and cunning enough to avoid your Charges, so try using a mixture of close-range Thrusts and the occasional Shield-Breaker to defeat them.','The Darnassus riders count on their nimbleness and skill at range.$B$BThey are quick and cunning enough to avoid your Charges, so try using a mixture of close-range Thrusts and the occasional Shield-Breaker to defeat them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34383,'The Ironforge riders are a tenacious lot, relying heavily on their defenses and steadfastly trading blows with their opponents, strike for strike.$B$BTrying wearing them down with Charges while maintaining your own Defense... meet them with a defensive advantage so that they will suffer the most with each exchange.','The Ironforge riders are a tenacious lot, relying heavily on their defenses and steadfastly trading blows with their opponents, strike for strike.$B$BTrying wearing them down with Charges while maintaining your own Defense... meet them with a defensive advantage so that they will suffer the most with each exchange.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34384,'The Exodar riders are massive and powerful combatants, terrifying at close range.$B$BTry to stay out of their defense-crushing Thrust range, breaking down their defenses with Shield-Breakers before risking a Charge.','The Exodar riders are massive and powerful combatants, terrifying at close range.$B$BTry to stay out of their defense-crushing Thrust range, breaking down their defenses with Shield-Breakers before risking a Charge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34385,'The Sen\'jin riders count on their nimbleness and skill at range.$B$BThey are quick and cunning enough to avoid your Charges, so try using a mixture of close-range Thrusts and the occasional Shield-Breaker to defeat them.','The Sen\'jin riders count on their nimbleness and skill at range.$B$BThey are quick and cunning enough to avoid your Charges, so try using a mixture of close-range Thrusts and the occasional Shield-Breaker to defeat them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34386,'The Thunder Bluff riders are massive and powerful combatants, terrifying at close range.$B$BTry to stay out of their defense-crushing Thrust range, breaking down their defenses with Shield-Breakers before risking a Charge.','The Thunder Bluff riders are massive and powerful combatants, terrifying at close range.$B$BTry to stay out of their defense-crushing Thrust range, breaking down their defenses with Shield-Breakers before risking a Charge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34387,'The Silvermoon riders believe in balance and precision, deftly mixing attack and defense.$B$BHowever, they will often open themselves to Charges by trying to gain range on you.$B$BClose that range with a Charge before they can do the same, and then Shield-Break them as you wheel around for more Thrusts.','The Silvermoon riders believe in balance and precision, deftly mixing attack and defense.$B$BHowever, they will often open themselves to Charges by trying to gain range on you.$B$BClose that range with a Charge before they can do the same, and then Shield-Break them as you wheel around for more Thrusts.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34388,'The Undercity riders are a tenacious lot, relying heavily on their defenses and steadfastly trading blows with their opponents, strike for strike.$B$BTrying wearing them down with Charges while maintaining your own Defense... meet them with a defensive advantage so that they will suffer the most with each exchange.','The Undercity riders are a tenacious lot, relying heavily on their defenses and steadfastly trading blows with their opponents, strike for strike.$B$BTrying wearing them down with Charges while maintaining your own Defense... meet them with a defensive advantage so that they will suffer the most with each exchange.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34389,'The Orgrimmar riders pride themselves on fearless and devastating charges. Such is their skill and ferocity that even when charged themselves they simply charge right back.$B$BTry staying close and Thrusting, and when they attempt to gain range, throw them off-balance with a Shield-Breaker before you Charge. Otherwise, they\'ll meet you head-on every time.','The Orgrimmar riders pride themselves on fearless and devastating charges. Such is their skill and ferocity that even when charged themselves they simply charge right back.$B$BTry staying close and Thrusting, and when they attempt to gain range, throw them off-balance with a Shield-Breaker before you Charge. Otherwise, they\'ll meet you head-on every time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34390,'Murloc pests, I have come to steal your treasure! Attempt to stop me! Quickly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34391,'Detonation imminent.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34392,'Welcome to our little chapel of the Light. Please, take a seat. Enjoy a respite from the world\'s ills.','Welcome to our little chapel of the Light. Please, take a seat. Enjoy a respite from the world\'s ills.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(34394,'Let\'s get to it, $r.$b$bThere\'s little time and much to do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34395,'You\'ve already bested one of our riders today, so I cannot accept your challenge.','You\'ve already bested one of our riders today, so I cannot accept your challenge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34396,'You may wish to put some more signal powder on the brazier next time. I\'m not sure they could see that from Orgrimmar....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34397,'You didn\'t need to use the whole sack at once, did you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34398,'When this is over, you may want to brush up on your secrecy skills....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34399,'The %s prepares to unleash a staggering shout!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34400,'Are you here for the confessor\'s sermon? Good luck findin\' a place to sit...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34401,'The Ancient Gate of the Keepers unlocks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34402,'A kaldorei assassin evades $n\'s gaze and slips into the shadows.','A kaldorei assassin evades $n\'s gaze and slips into the shadows.',0,0,0,0,0,0,0,0,1,8416,0,0,26124),
(34403,'Return to Shatterspear Vale.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34404,'The Eastspark siege workshop has been captured by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34405,'The Westspark siege workshop has been captured by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34406,'The Eastspark siege workshop has been captured by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34407,'The Westspark siege workshop has been captured by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34408,'The Eastspark siege workshop has been attacked by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34409,'The Eastspark siege workshop has been attacked by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34410,'The Westspark siege workshop has been attacked by the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34411,'The Westspark siege workshop has been attacked by the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34412,'You have a feeling someone is watching you....','You have a feeling someone is watching you....',0,0,0,0,0,0,0,0,1,8416,0,0,26124),
(34413,'You hear a shuffling noise nearby, but see nothing.','You hear a shuffling noise nearby, but see nothing.',0,0,0,0,0,0,0,0,1,8416,0,0,26124),
(34414,'You think you see a shadowy figure out of the corner of your eye.','You think you see a shadowy figure out of the corner of your eye.',0,0,0,0,0,0,0,0,1,8416,0,0,26124),
(34415,'A kaldorei assassin leaps from the shadows and attacks $n!','A kaldorei assassin leaps from the shadows and attacks $n!',0,0,0,0,0,0,0,0,1,8416,0,0,26124),
(34416,'My lady.$b$bI was unable to protect her. How can I return to Silvermoon...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34417,'As you wish, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34418,'','As you wish, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34419,'Activating secondary defensive systems will result in the extermination of unauthorized life forms via orbital emplacements.$B$BYou are an unauthorized life form. Please confirm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34420,'Activate secondary defensive systems.','Activate secondary defensive systems.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34421,'Confirmed.','Confirmed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34422,'Security override permitted. Secondary defensive systems activated.$B$BBackup deactivation for secondary systems can be accessed via individual generators located on the concourse.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34423,'It is an honor to represent the Argent Crusade in this tournament.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34424,'Access to the interior of the complex is currently restricted. Primary and secondary defensive emplacements are active.','',0,0,0,0,0,0,0,0,1,8426,0,0,26124),
(34425,'','Strange, I don\'t remember any mention of those orbital emplacements last time. I wonder what dolt activated them.',0,0,0,0,0,0,0,0,1,8426,0,0,26124),
(34426,'The Argent Tournament has begun in the northern reaches of Icecrown, $c. If you\'ve yet to find your way there, I can pay your way.$B$BThe more we have participating in the melee, the stronger we\'ll be when we strike against the Lich King.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34427,'I\'ll take the flight.','I\'ll take the flight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34428,'Yeehaw! Let\'s do this!','Yeehaw! Let\'s do this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34429,'Throw me up there!','Throw me up there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34430,'Let\'s show this piece of scrap what real mettle is made of.','Let\'s show this piece of scrap what real mettle is made of.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34431,'I am ready, let\'s do this!','I am ready, let\'s do this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34432,'This is going to hurt, isn\'t it?','I hope I don\'t chip my nails...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34433,'Throw me!','Throw me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34434,'Quit wasting time! Let\'s do this!','Quit wasting time! Let\'s do this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34435,'That oversized toy is no match for me!','That oversized toy is no match for me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34436,'The moonstalker rouses from its slumber with a deep growl.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34437,'The moonstalker jumps to its feet, teeth bared.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34438,'The moonstalker rises, angry at being disturbed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34443,'','I want to see some sweat, here. If I don\'t start seeing sweat, I guarantee I\'ll start seeing blood.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34444,'','Step up the pace, you peons! ...Don\'t make me use the stick.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34445,'','Get this caravan loaded! Crossroads needs these supplies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34446,'','What... What did you just do, $n?! Brann! Braaaaannn!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34447,'','Brann! $n just activated the orbital defense system! If we don\'t get out of here soon, we\'re going to be toast!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34448,'Prognosis: Negative!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34449,'You\'re not going to get up from that one, friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34450,'','%s begins to cast Terrifying Screech.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34451,'Teleport to the Prison of Yogg-Saron.','Teleport to the Prison of Yogg-Saron.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34452,'Teleport to the Ulduar Tram.','Teleport to the Ulduar Tram.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34453,'How dare you disturb our last link to this world?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34454,'The cold comes...','The cold comes...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34455,'Join us... forever.','Join us... forever.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34456,'Stay with us mortal... live eternal.','Stay with us mortal... live eternal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34457,'Death welcomes you.','Death welcomes you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34458,'Let loneliness guide you... give in.','Let loneliness guide you... give in.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34459,'The strain of living... just let go...','The strain of living... just let go...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34460,'Your quest is meaningless.','Your quest is meaningless.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34461,'Your life has no purpose.','Your life has no purpose.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34462,'{skull} I DIED! {skull}','{skull} I DIED! {skull}',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34463,'Welcome, child.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34464,'','I shouldn\'t have expected these filthy trolls to stay peaceful forever. There\'s no place for trust with any sympathizers of the Horde.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34465,'%s begins to cast Big Bang!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34467,'Blood and Thunder, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34468,'The %s begins to self destruct!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34469,'There are many dangers facing us, but we cannot find ourselves neglecting nature, lest it neglect us in our time of need. We\'ve learned this lesson before.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34470,'Standing in the way of nature is heresy.  Even when nature\'s force is a destructive one.$B$BThe forces that would destroy Darkshore are not natural, however.  I will not let this land be torn asunder.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34471,'Scorch is extinguished by the water!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34472,'How do you do? I\'m Gary, and I assume Gorbold sent you.\n\nIf you\'re here to help, the plan\'s pretty simple. I\'ve rigged up some decoy bots. We prance the little fellows in near the murlocs and activate their countdown. They\'ll pulse light and sound to attract the murlocs, and after several seconds, they\'ll explode, taking the murlocs with them.\n\nIf we get enough of these in there, we should be able to make our way to the ships\' holds again. With less casualties this time hopefully. That part\'s not for you though, just get to blowing those little fish men up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34473,'','While the elements are doing their best to tear Darkshore asunder, I\'ve been struggling to protect the remaining wildlife.$B$BCan I count on your help, $c?\n',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(34474,'A challenge?! Stand still so that I can blast your corpse all over the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34475,'You think you can best Lorenth Thundercall? Stand still, silly gnat, so that I can swat you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34476,'Don\'t move, little adventurer. I have the death you seek.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34477,'Hah! Stay right there while I cast this spell! It won\'t hurt much.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34478,'','Company! Stay in sight, love, so that I can welcome you properly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34479,'','Prey! Move away from those pillars so that I can show you the err in your trespass. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34480,'','Welcome! Don\'t be shy... move away from those pillars so that I can see you fully.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34481,'','Hello there! Don\'t you dare step behind those pillars. Let me welcome you properly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34482,'And don\'t worry about the trolls underfoot while you\'re up there. They\'ll be trampled into the ground by the ancients\' strides.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34483,'Don\'t just stand around, $r...$b$bThere\'s work to be done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34484,'There is a creature half-buried in the silt, a hideous collection of limbs and tentacles with no discernable face. You can\'t bring yourself to touch the eerily translucent flesh.$B$BAlthough the beast is dead, the water around the shapeless body appears clean, and the corpse itself curiously shows no sign of decay.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34485,'Be still, little one, and you can hear this ancient land speak. It cries out in pain.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34486,'Ancient Onu, where may I find a Seed of the Earth?','Ancient Onu, where may I find a Seed of the Earth?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34487,'Hum, hrm. A powerful reagent for one so young. You will kill many foes in the name of your Alliance, but it is important to remember that in the great cycle, birth is as powerful as death.$B$B<Onu slowly reaches up to his head and withdraws an inconspicuous acorn. He lowers his arm to you with unhurried calm.>$B$BThis is extremely potent.$B$B...I apologize, I did not wish that to sound like a boast.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34488,'','We will suffer no interruptions!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34489,'','Queen Azshara will return and your land will be forfeit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34490,'','You live on borrowed time. The sea will consume you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34491,'','The age of the night elves is coming to a close.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34492,'Let us see if we can freeze the enemy where they stand, little $r.','',33,0,0,0,0,0,0,0,1,0,0,0,26124),
(34493,'Arctanus, I am ready to lead one of your freezing surgers into battle.','Arctanus, I am ready to lead one of your freezing surgers into battle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34494,'Our brother has lost his way. He scorches the ground, he vaporizes the water, and devours too much air.$B$BHelp us to bring him back into balance and harmony.','',33,0,0,0,0,0,0,0,1,0,0,0,26124),
(34495,'I am ready to be one with the whirling vortex and defeat Lord Magmathar.','I am ready to be one with the whirling vortex and defeat Lord Magmathar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34496,'%s is already consumed and is beyond help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34497,'%s is now protected from the consumption.','%s is now protected from the consumption.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34498,'%s catches the meat and gobbles it hungrily.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34499,'%s purrs contentedly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34500,'%s begins to cast Cosmic Smash!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34501,'Withers absorbs the water, growing back to full size.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34502,'There is no escape! There is only the fiery embrace of my lava!','',0,0,0,0,0,0,0,0,1,8459,0,0,26124),
(34503,'Death rises from below and erupts from above! There is no escape!','',0,0,0,0,0,0,0,0,1,8459,0,0,26124),
(34504,'Scorch the ground, boil the water, and ignite the skies!','',0,0,0,0,0,0,0,0,1,8459,0,0,26124),
(34505,'The Earthen Ring cannot withstand my fury!','',0,0,0,0,0,0,0,0,1,8459,0,0,26124),
(34506,'Destroy them, my minions!','',0,0,0,0,0,0,0,0,1,8459,0,0,26124),
(34507,'I am free of the bonds of the earth never to return again!','',0,0,0,0,0,0,0,0,1,8459,0,0,26124),
(34508,'ASHENVALE WILL BURN!','',0,0,0,0,0,0,0,0,1,8459,0,0,26124),
(34509,'Like moths to the flame!','',0,0,0,0,0,0,0,0,1,8459,0,0,26124),
(34510,'<*Rumble*Rumble*Rumble*>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34511,'%s overcharges a Tempest Minion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34512,'','I appreciate your help defending the wildlife here. Hopefully we\'re not too late.\n',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34513,'','Thank you for your help, $n! These woods may never be safe from the evils that once dwelled here, but I feel better knowing that heroes like you are helping me keep watch.\n',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34514,'Who are the Old Ones?','Who are the Old Ones?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34515,'','I wish I could tell you more, but until recently nobody believed such creatures existed. Long before the Titans shaped Azeroth into the world we see today, before the natural cycle of life and death as we know it, the Old Ones ruled over the elements and corrupted creation to serve their own malignant ends.$B$BFrom what Onu here tells me, the Titans ultimately defeated the Old Ones. Or, at least, they imprisoned them under the earth. Can something like that ever really die? I wish I knew more, but this is all pre-prehistory for me, and I\'ve been around a while.$B$BI know that there are some that worship the Old Ones, if you can believe that. That\'s like praying for the end of the world. These Old Gods make people crazy!\n',274,1,6,0,800,800,0,0,1,0,0,0,26124),
(34516,'%s hungrily devours the egg.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34517,'<The hatchling looks at you as if trying to determine whether or not you\'re its mother.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34518,'I lost my venomhide hatchling. Have you seen him?','I lost my venomhide hatchling. Have you seen him?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34519,'The %s devours the food.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34520,'The %s catches the food in its mouth and swallows it in one gulp.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34521,'The %s\'s strong jaws tear into the food.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34522,'The %s quickly finishes the food and glances around for more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34523,'Abandon the dig? Ridiculous! In my long industrious career, I\'ve never abandoned a site. Not intentionally. Misplaced a few, maybe. Who are you again? What are we doing here?','',6,0,0,200,0,0,0,0,1,0,0,0,26124),
(34524,'Superb! Gather your strength, whats-your-face. We\'ve got a long way to travel.','',0,0,0,200,0,0,0,0,1,0,0,0,26124),
(34525,'Ready? Let\'s move!','',0,0,0,200,0,0,0,0,1,0,0,0,26124),
(34526,'The ruins you see here are identical to ones I dug up a few months ago, but they\'re flooded! Curious, eh?','',0,0,0,200,0,0,0,0,1,0,0,0,26124),
(34527,'Ah, we\'re almost there, whos-yer-face! The camp where I left my notes is just around the corner!','',0,0,0,200,0,0,0,0,1,0,0,0,26124),
(34528,'By the three hammers, will you look at that! More ruins!','',0,0,0,200,0,0,0,0,1,0,0,0,26124),
(34529,'These ruins I\'ve found are IDENTICAL to the ones I just left! It\'s the find of a lifetime!','',0,0,0,200,0,0,0,0,1,0,0,0,26124),
(34530,'You big duffer, these ARE the same ruins. You\'re wandering in circles again.','',0,0,0,200,0,0,0,0,1,0,0,0,26124),
(34531,'Nonsense. See? Here\'s my journal, right here. ','',0,0,0,200,0,0,0,0,1,0,0,0,26124),
(34532,'What do you make of this, Ferd?','',0,0,0,200,0,0,0,0,1,0,0,0,26124),
(34534,'Where did this $n come from? Honestly now.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(34535,'Who dug up this $n, anyways?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(34536,'Why did the ancients build their cities next to all these $ns?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(34537,'Let\'s see what this artifact tells us...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34538,'I knew it! It\'s calling up a message!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34539,'Kill it!','',0,0,0,200,0,0,0,0,1,0,0,0,26124),
(34540,'Mother?','',0,0,0,200,0,0,0,0,1,0,0,0,26124),
(34541,'...Diagnostic ... Diagnostic ... Fail. ','',0,0,0,200,0,0,0,0,1,0,0,0,26124),
(34542,'The site has been compromised. The aspects must be alerted.','',0,0,0,200,0,0,0,0,1,0,0,0,26124),
(34543,'Amazing. Prospector Remtravel\'s done it again! We\'ll see if Ironforge can make sense of this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34544,'With his razor sharp claws, Avrus digs into his chest and removes his beating heart, placing it with the fallen moonstones.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34545,'Miraculously, the satyr does not die. Instead he is bathed in a warm light.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34546,'This dig here is compromised - the Explorers\' League wants us to grab whatever\'s left of value and clear out. Easily said, not so easily done.','',1,0,0,200,0,0,0,0,1,0,0,0,26124),
(34547,'%s is transformed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34548,'Murlocs. Bah!','',274,0,0,200,0,0,0,0,1,0,0,0,26124),
(34549,'Grimfang has ordered me to Hellscream\'s Watch.','Grimfang has ordered me to Hellscream\'s Watch.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34550,'','The body of the fallen dryad lies here where she lost her life to the Horde.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34551,'The ritual of soothing has begun.  Defend the totem at all costs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34552,'A %s emerges from the shell!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34553,'The ritual of soothing has completed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34554,'','The Lich King\'s cruel reign has inflicted great suffering on all of Northrend\'s inhabitants, particularly the children. If you are a friend to the Oracles or Frenzyheart Tribe of Sholazar, perhaps you might consider caring for an orphan for a week.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34555,'We can has aged yolk?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34556,'Do Great Ones ever run out of bag space for shinies?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34557,'Why you think puppy-man hatchlings keep asking if we pity Lafoo? Lafoo talks a lot, but he\'s our friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34558,'Soo-$n, maybe you give us whistle for when we need to call you. Oki?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34559,'Maybe we be a $r when we grow up. Think so?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34560,'Are you alone because puppy-men killed your parents too?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34561,'You should stay away from walrus-men. They could pup-nap you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34562,'Kekek take you hunting. You be good bait.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34563,'Orcs always point and laugh at Kekek, but he get revenge one day.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34564,'Know what? If Kekek closes his eyes, you can\'t see him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34565,'Caught three chickens for lunch. Bet you couldn\'t catch any.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34566,'Kekek took big-tongue hatchling\'s favorite toy. Maybe it help you get to sleep at night.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34567,'Ask about the orphans.','Ask about the orphans.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34568,'','The orphans we have taken in come from war torn Sholazar Basin. You can choose to care for either an orphaned Oracle hatchling or a Frenzyheart pup. Either will be happy to make a new friend, but you will only be able to care for one of them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34569,'','You may choose to care for an Oracle orphan or a Wolvar orphan, but you will not be able to help both.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34570,'','We must do more than hold the tree, $r. The Horde will never give up.$B$BWe must destroy them!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34571,'','Hop on!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34572,'Recover the Laughing Sister\'s corpse.','Recover the Laughing Sister\'s corpse.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34576,'We here! Only, if this is world tree, how come it broke when they tried to put whole world in?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34579,'','Hold on tight! I\'ll take care of the flying, you focus on the wildlife below.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34580,'','From the air, you should be able to cast your protective ward on whole groups of animals at once.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34581,'We thank you, Aroom.  And we thank $n.  We return to Elune... finally.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34582,'','The Horde is here, $n! Quickly, we must invoke the shade of Shadumbra!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34583,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34584,'I have been assisting the flight masters to round up the Hippogryphs that fled their post when the land tore itself apart. Even now our birds remain squeamish.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34585,'Orseus, Kathrena sent me to borrow one of your Hippogryphs.','Orseus, Kathrena sent me to borrow one of your Hippogryphs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34586,'I am ready to invoke the shade of Shadumbra.','I am ready to invoke the shade of Shadumbra.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34587,'Head outside and destroy the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34588,'Return to Raynewood Retreat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34589,'','Whitetail deer have been repopulating this whole area.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34590,'','Hold on, the updraft from the fires can be fierce.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34591,'','Moonstalkers displaced by the fires patrol this strand, we need to keep them safe!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34592,'','Look below - some of those thistle bears haven\'t been consumed yet. We\'re not too late.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34593,'','Why would anyone want to dig up something so horrific? I\'m convinced those things are behind what\'s happening to the animals here.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34594,'','Good work! Let Orseus know if we need to take another pass. Otherwise, I\'ll meet you in the grove!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34595,'Use the Moonwell at the base of the tree for rapid health recovery out of combat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34596,'','Who dares oppose Queen Azshara?  You will soon beg for a swift death!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34597,'The artifact shatters as Yoth\'al the Devourer gasps his last breath.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34598,'It\'s over Azshara!  You and your naga will return to the bottom of the seas where you belong!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34599,'Our men are almost finished unearthing great Soggoth.  Is the ritual ready?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34600,'','Not quite.  We shall need a great many offerings of sacrifice before the Herald of the Old Gods roams the land again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34601,'Do not worry.  Like I said, our men are almost done unearthing the Slithering One.  They will make for a suitable -- and even voluntary -- sacrifice.  Soggoth will rise!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34602,'Take with you the blessing of the wind\'s embrace. May it make your descent from Aldrassil more... direct.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34603,'You think maybe one day, Kekek lead Frenzyheart home, like bear-men fight to get tree-city back? Kekek want own home, not city with purple men, not jungle with big-tongues.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34604,'I am to bomb Astranaar! Captain Goggath\'s orders.','I am to bomb Astranaar! Captain Goggath\'s orders.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34605,'Why are we digging this thing up anyway, boss?','Why are we digging this thing up anyway, boss?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34606,'Look! Is that us? We think it\'s us. A bit older, maybe?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34607,'Looks like we blessed by Great Ones! Shrines give magic, make us high-oracle someday? Maybe?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34608,'Watch your tongue, worm.  You will not refer to Soggoth the Slitherer as \"that thing\" or you\'ll find yourself eating your own heart for dinner.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34609,'Now, back to work!  Your superiors are watching from the outlook above and they do not take kindly to idleness!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34610,'Look! That must be Kekek as a mighty warrior! See? What Kekek tell you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34611,'This is a temporary object, quest will use autolaunch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34612,'','Can you feel it?$B$BThe spirit world draws close during the Day of the Dead. This is why we decorate the graves of our dearly departed with flowers and candles and offerings: To welcome them back, even if only for a time.$B$BSo come! Dance with me! Let us cherish and honor those we have lost in their ghostly presence, so that they might eat and drink and smile and know that they are loved.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34613,'During the Day of the Dead, people gather in graveyards to celebrate with and cherish the spirits of those they have lost.$B$BYou can find the festivities in the cemeteries of any major city, where you\'ll be able to cook, dance, don costumes, and more.','During the Day of the Dead, people gather in graveyards to celebrate with and cherish the spirits of those they have lost.$B$BYou can find the festivities in the cemeteries of any major city, where you\'ll be able to cook, dance, don costumes, and more.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(34614,'','Before you make your way into Fel Rock, be sure to speak to Tallonkai Swiftroot at the top of the tree. He has a task he would ask of you as well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34615,'We made a new friend!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34616,'Look!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34617,'Wanna see what I can do?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34618,'We can dance too!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34619,'Now dance together!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34620,'Look!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34621,'Got you good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34622,'Got you back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34623,'Good snowball fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34624,'Better watch out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34625,'Defend the Caravan Kodo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34626,'','Head \'em up! Move \'em out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34627,'','I\'m honor-bound to get these supplies to the Crossroads. Pitch in or step aside.',1,0,0,50,0,0,0,0,1,0,0,0,26124),
(34628,'','Well, $n - are you ready to roll? It won\'t be easy!',1,0,0,50,0,0,0,0,1,0,0,0,26124),
(34629,'Yes, I\'m ready. Let\'s do this thing!','Yes, I\'m ready. Let\'s do this thing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34630,'','Mount up, $n! Do not fail me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34631,'So that\'s the queen of the dragons? Hmm... we thought she\'d be bigger. Yes, we did.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34632,'How come she doesn\'t look like the other dragons? Could she turn into a big ol\' dragon if she wanted to?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34633,'Um... Your Majesty, would you turn into a dragon for us?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34634,'Oki... How about now?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34635,'','If I was in my dragon form, there wouldn\'t be any room for anyone else, little one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34636,'Hmm... that Kekek very old. Must be elder, leader of Frenzyheart. This good. Kekek have good future as warrior and leader. Kekek very happy you bring him here. Orphan-lady never do that for Kekek.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34637,'Elune guide us, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34638,'We must not allow an inch to our enemy.  If they strike in Darkshore we will fight them back just as if they had attacked Darnassus itself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34639,'The battle will begin in 30 seconds.','The battle will begin in 30 seconds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34640,'You are too late... the relic is being offered to Azshara above us as we speak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34641,'','Need some help finding your way? I know this place like the back of my hand.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34642,'Where is the Rune of Nesting?','Where is the Rune of Nesting?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34643,'Where is the Sapphire of Sky?','Where is the Sapphire of Sky?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34644,'Where is the Black Feather Quill?','Where is the Black Feather Quill?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34645,'Where is the Raven Claw Talisman?','Where is the Raven Claw Talisman?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34646,'Where I can find Oben Rageclaw?','Where I can find Oben Rageclaw?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34647,'The battle will begin in 60 seconds.','The battle will begin in 60 seconds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34648,'The battle will begin in 15 seconds.','The battle will begin in 15 seconds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34649,'The battle has begun!','The battle has begun!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34650,'','The Rune of Nesting is located across the bridge in the upper section of the southern chamber.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34651,'','The Sapphire of Sky is located at the separate room in the lower section of the northern chamber.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34652,'','The Black Feather Quill is located down the ramp in the lower section of the southern chamber.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34653,'','The Raven Claw Talisman is located on the ledge in the upper section of the northern chamber.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34654,'','Oben Rageclaw resides at the double bridges in the western chamber, near the hallway that leads out of the Barrow Den.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34655,'Kekek thought we go see dragon queen. This just some elf-lady with funny horns.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34656,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34657,'For Warchief Hellscream!','For Warchief Hellscream!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34658,'Destroy the elves!','Destroy the elves!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34659,'Ashenvale is ours!','Ashenvale is ours!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34660,'Kalimdor for the Horde!','Kalimdor for the Horde!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34661,'Lok\'tar ogar!','Lok\'tar ogar!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34662,'Gol\'Kosh!','Gol\'Kosh!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34663,'Kill them all and burn their tower!','Kill them all and burn their tower!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34664,'But why? Dragons big and powerful. Elf-lady weak. Kekek want to see dragon queen\'s real form.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34665,'Rest assured, Kekek, she is the queen of the dragons. We often take the forms of smaller beings when we work with them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34666,'Oh! Now Kekek understand. Not want to be crushed by big dragon-lady. Maybe come back sometime when not so crowded. Nice to meet you, dragon-lady.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34667,'Excellent work! I\'ll unload the goods. You should check in with Kranal Fiss.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34668,'','The mist will lead the way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34669,'','The exit is to the northwest... the mist will lead the way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34670,'Can you lead me to the exit?','Can you lead me to the exit?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34671,'','I can\'t go on... I need to retreat and recover.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34672,'Wow! A real Great One? We don\'t even think Soo-say has met a real Great One!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34673,'Um, hello, Mr. Great One. We are honored to meet you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34674,'Maybe you\'re asleep, Mr. Great One? We understand. Must be hard working being Great One, collecting all the shinies we leave for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34675,'We brought you a gift, Great One. Maybe you see it when you wake up. Maybe you remember we came to see you, oki?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34676,'Flat-nosed filth! Get off of my land!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34677,'Pigs! Scum! I will cleave your fat heads like apples!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34678,'I will tear your tusks out. You hear me?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34679,'That\'s right! Die, vermin! The Horde will have your heads for this.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34680,'I will RIP off your HEADS and EAT your filthy faces!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34681,'That\'s right, squeal you maggots. I will gut you lengthwise and roast you when we are through!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34682,'Nobody steals my livestock!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34683,'Eat axe you bacon-brained porkchops!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34684,'It\'s good to visit with friends and family again, celebrating and sharing stories of old.','It\'s good to visit with friends and family again, celebrating and sharing stories of old.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(34685,'Wow. At last, Kekek get to meet Hemet Nesingwary!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34686,'Even Frenzyheart know all about you after you come to Sholazar. Maybe you teach Kekek your tricks?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34687,'Well, lad, you can start by readin\' The Green Hills of Stranglethorn. Then, maybe you can join me on one of my safaris. What do you say?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34688,'Not sure how reading helps. Kekek can\'t read anyway, but if Hemet Nesingwary say, Kekek try.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34689,'Maybe give up and throw book at animals, but try.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34690,'%s breaks out of the net.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34691,'%s is ensnared!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34692,'<Snort> Is this how cowards fight, $r?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34693,'<Pound this chump.>','<Pound this chump.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34694,'','Some of our huntresses have already made their way to Ban\'ethil Barrow Den. They will find you when you get inside. Go ahead and speak to Citarre to secure a ride there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34695,'Double Pelt!','Double Pelt!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34696,'Multi-Pelt!','Multi-Pelt!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34697,'Mega-Pelt!','Mega-Pelt!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34698,'Pelting Spree!','Pelting Spree!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34699,'Ultra-Pelt!','Ultra-Pelt!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34700,'Monster Pelt!','Monster Pelt!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34701,'Epic Pelt!','Epic Pelt!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34702,'Legendary Pelt!','Legendary Pelt!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34703,'BY THE LIGHT!!','BY THE LIGHT!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34704,'If you want, go get, big-tongue baby!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34705,'Give toy back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34706,'Stop!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34707,'%s sinks to the ground and falls unconscious.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34708,'','The quilboar have always scavenged the fringes of our camps for food and supplies, but direct assaults on our farms and homesteads? Something has sent them on a rampage recently.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34709,'Togrik, can you wake up the prisoner again?','Togrik, can you wake up the prisoner again?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34710,'<The quilboar fixes his beady black eyes on you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34711,'<The quilboar wrinkles his nose at you and snorts.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34712,'What now, $r? Do your worst.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34713,'We\'re warriors, $n. <Snort> Many and proud.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34714,'We tell orphan matron on you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34715,'','Children, please behave yourselves! No one will want to adopt you if you keep acting like that!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34716,'Who sent you!?','Who sent you!?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34717,'<Punch him in the mouth.>','<Punch him in the mouth.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34718,'<Kick him in his big fat face.>','<Kick him in his big fat face.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34719,'<Offer food.>','<Offer food.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34720,'<Tickle Time!>','<Tickle Time!>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34721,'','Hi there!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34722,'Shael\'dryn, I need the Rod of Dartol.','Shael\'dryn, I need the Rod of Dartol.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34723,'Raene, I need Dartol\'s Rod!','Raene, I need Dartol\'s Rod!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34724,'<The furbolg sniffs at you and grunts.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34725,'Krolg, I need Dartol\'s Rod!','Krolg, I need Dartol\'s Rod!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34726,'The %s warily takes the offered food.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34728,'Mnn, <snort> why you cook this meat? Tortusk tells us meat taste best when stolen and raw.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34729,'Oh - I\'ve said too much!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34730,'Ow! <Snort>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34731,'Unf. You learn nothing from me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34732,'Unf - Not the face!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34733,'Oof! I not talking!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34734,'<Snort!> That all you got?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34735,'Ow-oooh! I not talk for nothing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34736,'You waste your strength! Tortusk train us warriors never to talk.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34737,'<Snort!>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34738,'I say nothing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34739,'I not scared of you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34740,'I say nothing! <snort>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34741,'Haha - <snort> ha - heee! <snort> Haha no stop haha <SNORT> <wheeze> Hee hee! Battlemaster Tortusk never prepared us for this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34742,'These lands will be ours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34743,'Tortusk barks, grunts, and snorts angry instructions to his followers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34744,'We Razormane ... must ... survive ...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34745,'%s laughs softly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34746,'All right, Aponi. I\'ve enough on my mind to share. Have you ever spoken to the elves of Moonglade?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34747,'The elves speak of a moon goddess, did you know? They put great stock in the light given by the moon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34748,'Just like her. The parallels I\'ve heard are interesting. And it\'s no secret all druids, Shu\'halo and elf alike, can call upon Mu\'sha\'s light.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34749,'I wonder. Hamuul has guided us well, and I\'ve learned so much from him. The legends say that our people were druids when time began...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34750,'...but what Hamuul teaches is what the elves know. The night elves. They put such stock in their moon goddess, as creatures of the night.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34751,'No! No, nothing like that. He is an elder for good reason, sister. Mu\'sha is one of the Earthmother\'s eyes, and she watches over us. That isn\'t sinister. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34752,'Freya drains the essence of Eonar\'s Gift, healing nearby allies!','Freya drains the essence of Eonar\'s Gift, healing nearby allies!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34753,'But we\'re nothing if not people who strive for balance. Our warriors fight only when there is need. Our hunters take only what the tribes require to live, and use all they can when they do. The shaman stand as guide and mediator to the elemental spirits.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34754,'And while we, as druids, are guardians of nature, I wonder if we\'ve overlooked a key aspect of balance in all things.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34755,'No, no. No need for him to trouble about a student\'s idle philosophizing while he entertains a friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34756,'Well, it isn\'t exactly a new thought, sister.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34757,'Surely you\'ve been a student once in your life, $c. You learned from an instructor, and you gained respect for them in some way, yes? Maybe not as a person, but at the least, as one who knew more than you and was willing to teach you. If not, use your imagination...$b$bWhat would you do if you came to realize your instructor may not know as much as you thought, and that you may have found a better path?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34758,'','This is awful! I shouldn\'t be sitting here, useless, when there\'s so much to be done! If only my arm hadn\'t gotten injured up in Northrend... No use dwelling on it, though! Tahu will have me patched up and cured eventually, and we\'ll still help around here in the meantime.\n\nJust because we\'re not at the front doesn\'t mean we can\'t help out somehow.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34759,'Nom nom nom nom nom...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34760,'The revitalized kodo rises to its feet, shaking off the dust.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34761,'','Another new face? It\'s so good to meet you. I\'m Dellylah.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34762,'','Talk to me, Tahu. Something. Anything! I\'m going stir-crazy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34763,'','Not much.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34764,'','Like Mu\'sha.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34765,'','Where are you going with this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34766,'','I hear the \"but\" in your voice...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34767,'','Do you think his teachings are wrong?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34768,'','So are you going to bring this up to the elder?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34769,'','I suppose so. It\'s not silly, though, what you said.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34770,'','I see that thoughtful frown, Tahu.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34771,'','But something is on your mind, right?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34772,'','What about it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34773,'','There\'s a phrase... \"It\'s always darkest before the dawn.\" The dawn will come, though, Tahu. The sun will rise. The balance will shift back to where it should be.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34774,'','%s smiles and gestures to the north.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34775,'','Even on the glacier itself, the sun manages to peek through the gloom. I have hope, Tahu. I think we\'ll make it through this, no matter how dire it looks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34776,'','But I\'d still rather be there on the front lines helping it happen rather than trying to placate myself with belief. We can\'t just sit around and hope it happens.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34777,'','And through that hope, strengthen our side in the fight?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34778,'Sorry, sister. It\'s nothing to worry about.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34779,'I\'m thinking about the front to the north. The one you\'re so eager to return to.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34780,'I know I\'m counseling patience, Aponi, but I don\'t like remaining here any more than you do. Times are bleak, and failing to act only makes me worry that my idle hand may have been the one to turn the tide.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34781,'Still... there is balance in all things, even death. I simply hate the concept that such destruction and darkness might be necessary.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34782,'Mmmm... There\'s nothing like good, home-cooked human food.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34783,'I know, sister. I know. We\'ll return to fighting one day. For now, though, maybe it\'s best to spread the word to others... give them the hope you have.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34784,'That\'s the idea.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34785,'I lied. Your miserable food stinks, but not as much as this town is going to stink!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34786,'Hey! Just what do you think you\'re doing?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34787,'Not again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34788,'','I know all is not well in Shadowglen, but coming back to these woods is always like coming back home.$B$BEver peaceful. Ever pure.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34789,'No Pennant','No Pennant',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34790,'Ho, $n! My brother Balgor tells me you\'re quite the shot from the back of a kodo. Great work getting that caravan here from Far Watch in one piece.$B$BListen, there\'s plenty of work for you here in Grol\'dom... but I could use your trigger fingers for the rest of the ride to Crossroads.$B$BCome see me when you\'re ready!','',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(34791,'Used to be hauling gear and food from Orgrimmar to Crossroads was peon-work. Nowadays my neck\'s always on the line.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34792,'Much has changed for our people since the Battle of Mount Hyjal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34793,'Nordrassil lies a pale shadow of what it once was, its power used to defeat Archimonde and drive back the Burning Legion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34794,'Our immortality-the very essence of our beings!-was lost.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34795,'The Betrayer was freed from his prison, and Shand\'do Stormrage disappeared into the emerald dream.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34796,'A dark time for all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34797,'With Malfurion Stormrage gone, the druids were left in disarray and in desperate need of a new leader.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34798,'Archdruid Fandral Staghelm roused the druids and convinced the Circle of Ancients in Darkshore that it was time for our people to rebuild.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34799,'In an effort to regain immortality for our people, and with the approval of the Circle, Staghelm and the most powerful druids grew Teldrassil, upon whose boughs you now stand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34800,'Though we have our new home, our immortal lives have not been restored.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34801,'The Archdruid approached the dragons for their blessings, as the dragons had placed on Nordrassil in ancient times.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34802,'But Nozdormu, Lord of Time, refused to give his blessing, chiding the druid for his arrogance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34803,'In agreement, Alexstrasza also refused Staghelm, and without her blessing, Teldrassil\'s growth has been flawed and unpredictable.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34804,'Staghelm retreated to his enclave in Darnassus, ever seeking a new direction by which to bless Teldrassil, and restore the immortality of our people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34805,'Over time, Staghelm only grew more disconnected from our people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34806,'Some pose that he blames us, his people, for the loss of his son, long ago during the War of the Shifting Sands.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34807,'Others cite rumors of his escalating conflicts with Tyrande Whisperwind, the shining light of our people, our leader in Darnassus.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34808,'But many druids of the Cenarion Circle stand firm that he wants only what is best for all of the Kaldorei, and serve him unerringly towards that end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34809,'Fandral Staghelm carries the burden of our sins and our follies, and in so doing deserves the respect of us all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34810,'In weeks past, all of those living atop Teldrassil have found their memories blurry, as if time itself seized a portion of their lives.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34811,'We break from this haze to find that Fandral Staghelm and many of his closest followers have disappeared without a word.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34812,'But in his place, Shan\'do Stormrage awoke from the dream and returned to his beloved Tyrande Whisperwind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34813,'And with his return came Alexstrasza and Ysera, to at long last offer their blessings upon Teldrassil.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34814,'Though a small corruption lingers, desperately longing to be cleansed, the boughs of Teldrassil itself seem changed.  Growth has begun anew.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34815,'None know what to expect next, but with Malfurion and Tyrande reunited, a new hope dawns on the Kaldorei.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34816,'Are you ready to do this, $n?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(34817,'Bring it on, Rocco.','Bring it on, Rocco.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34818,'There she is. Mount up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34819,'%s stares into the moonwell, lost in distant memories.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34820,'The Shade of the Kaldorei closes its eyes and fades away.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34821,'Incredible shooting! I\'ll try to calm the animals down. Report to Thork, he will want to know of this attack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34822,'Work it!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34823,'Make it!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34824,'Do it!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34825,'Harder, better, faster, stronger!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34826,'This is The Bomb to end all bombs!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34827,'Somebody set us up The Bomb!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34828,'Someone get me somebody stupid enough to move this thing into Stonetalon!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34829,'I can\'t wait any longer. I\'m going to set it off! Muahahahahahaha!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(34830,'Let\'s put this stuff to the test...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34831,'Just a pinch...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34832,'%s fades into existence as you approach, nodding a subtle greeting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34833,'%s rests on the side of the moonwell in peaceful contemplation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34834,'%s approaches the moonwell slowly, a familiar, thoughtful look upon its face.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34835,'%s smiles at you knowingly as it approaches.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34836,'Wahoo!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34837,'','Ahahahaha, you\'ve fallen into my trap, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34838,'Beware, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34839,'Bolyun, is Kariva still about?','Bolyun, is Kariva still about?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34840,'Yes, look out behind you, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34841,'What is it, $r? Time is money!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34842,'Good day to you, $r.','',33,0,0,0,0,0,0,0,1,0,0,0,26124),
(34843,'The savior of the forest! Were it not for your actions, Astranaar and then the rest of Ashenvale surely would have fallen to the Burning Legion.$B$BI hope that this day finds you well, $n!','',34,0,0,0,0,0,0,0,1,0,0,0,26124),
(34844,'Do not give in to the curse!  You were men and women of Gilneas once... you can be men and women of Gilneas again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34845,'Gilneas needs you!  Now is not the time to retreat to the woods like a pack of wild animals!  Face the enemy and live or die as Gilneans not as beasts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34846,'You might have gone feral, but Gilnean blood still pumps through your veins.  Defend our homelands agains the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34847,'Fields of Honor','Fields of Honor',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34848,'Path of Cenarius','Path of Cenarius',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34849,'Ogre Pinata','Ogre Pinata',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34850,'Magic Rooster Mount','Magic Rooster Mount',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34851,'Kologarn focuses his eyes on you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34852,'Hey mon, how\'d you find me? I gotta find a better hiding spot.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(34853,'You call yourself, $n? That is a strange name for a furbolg.$B$BYou\'re not from Ashenvale.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34854,'That\'s not important right now. Ota Wen, listen to me. You must rise up against the orcs!','That\'s not important right now. Ota Wen, listen to me. You must rise up against the orcs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34855,'<Ota Wen\'s eyes, already dull from his enslavement, glaze over even more at your suggestion. You feel the power of Dartol\'s Rod begin to course through you and reach out to touch the furbolg.>$B$BRise up?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34856,'Yes, rise up! Tell your fellow furbolg to break out of this cage and to slay the Horde. The power of the rod compels you!','Yes, rise up! Tell your fellow furbolg to break out of this cage and to slay the Horde. The power of the rod compels you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34857,'<A strange light ignites in Ota Wen\'s eyes as he stands up straight, roaring at the heavens.>$B$BYES, WE WILL RISE UP! RISE UP AND DESTROY OUR JAILORS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34858,'I\'m ready to make a run for Stonetalon!','I\'m ready to make a run for Stonetalon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34859,'Soon, one known as $n, soon we will have destroyed our captors!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34860,'','Playing possum is super easy, $n.  Just watch....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34861,'','%s begins to play possum.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34862,'','See?! That wasn\'t hard, was it? You\'ll have no problem fooling stinky old Oso Bramblepaw and his guardians now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34863,'Tonga\'s eagle calls out, then circles toward the peak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34864,'Well done, friend! From here we can survey the land.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34865,'Merciful Earthmother, look at the scope of the devastation! We\'re lucky the entirety of the Barrens isn\'t crumbling into the sea.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34866,'But what\'s this? Something else is happening to the land south of the fissure.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34867,'Indeed, the flora is growing unchecked, devouring the land. Similar to our findings from the oases.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34868,'We must do everything in our power to stop the same from happening here. We\'ll have to step up our investigations of the oases and stop this phenomenon at the source. We\'ll talk again at Crossroads!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34869,'Take a deep breath, $c. The air atop Thunderhead Summit is thin, but free of the choking dust that strangles the land below.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(34870,'Calculating route...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34871,'Warning... danger detected!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34872,'System malfunction detected... recalculating route...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34873,'Recalculation underway...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34874,'Recalculation complete. Resuming transport.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34875,'Commencing transport. Destination, Windshear Crag.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34876,'Some help, my little friend?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34877,'Hah, yes $n! That\'s what I want to hear. Let\'s make some noise!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34878,'Come get some, you horsefaced maggot farms!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34879,'More.... More!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34881,'Ah, there\'s our target. I can smell him from here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34882,'Victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34883,'Simply amazing!$B$BYou\'re reading this which means that DAN IS THE MAN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34884,'','Death to the Horde!',0,0,0,0,0,0,0,0,1,8548,0,0,26124),
(34885,'','Destroy the bomb!',0,0,0,0,0,0,0,0,1,8548,0,0,26124),
(34886,'','Don\'t let it get to Stonetalon!',0,0,0,0,0,0,0,0,1,8548,0,0,26124),
(34887,'','For Ashenvale!',0,0,0,0,0,0,0,0,1,8548,0,0,26124),
(34888,'','Shoot it! Destroy it!',0,0,0,0,0,0,0,0,1,8548,0,0,26124),
(34889,'','Stop the Bomb!',0,0,0,0,0,0,0,0,1,8548,0,0,26124),
(34890,'','Quit your pacing, mon! You\'re gonna be seen.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34891,'Bah! Perhaps I WANT to be seen? I tire of skulking.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34892,'','Please $c, don\'t encourage Gorgal. We\'re supposed to observe and report - not raise up a ruckus.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(34893,'Wait \'til Shoe hears about THIS.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34894,'%s flees in terror as Kurak falls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34895,'Sneak, sneak, sneak. Let me tell you something about Gorgal: Gorgal doesn\'t sneak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34896,'Ha hah! That was glorious! I would fight by your side any day, $n.','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(34897,'Bomb Condition: 80 Percent!','Bomb Condition: 80 Percent!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34898,'Bomb Condition: 60 Percent!','Bomb Condition: 60 Percent!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34899,'Bomb Condition: 40 Percent!','Bomb Condition: 40 Percent!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34900,'Bomb Condition: Critical!','Bomb Condition: Critical!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34901,'Weep for Gilneas!','Weep for Gilneas!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34902,'Your land is doomed!','Your land is doomed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34903,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34904,'Lok\'tar!','Lok\'tar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34905,'Our wolves will feast on your bones!','Our wolves will feast on your bones!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34906,'Your days are numbered, shapeshifter!','Your days are numbered, shapeshifter!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34907,'Bomb Condition: Fully Repaired','Bomb Condition: Fully Repaired',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34908,'Death to the Horde!','',0,0,0,0,0,0,0,0,1,8548,0,0,26124),
(34909,'We have not lost hope...','',0,0,0,0,0,0,0,0,1,8548,0,0,26124),
(34910,'You\'ll never make it to Stonetalon!','',0,0,0,0,0,0,0,0,1,8548,0,0,26124),
(34911,'Fool! Your deeds in Ashenvale shall not go unpunished!','',0,0,0,0,0,0,0,0,1,8548,0,0,26124),
(34912,'Ashenvale belongs to the Kaldorei!','',0,0,0,0,0,0,0,0,1,8548,0,0,26124),
(34913,'Approaching Stonetalon. Prepare for heavy resistance!','',0,0,0,0,0,0,0,0,1,8548,0,0,26124),
(34914,'I will send these to Thunder Bluff to confirm my findings. I may need your assistance again soon, friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34915,'Systems failing....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34916,'','Look around you, servant of the Horde...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34917,'','Your remains shall soon join those of them who have come before you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34918,'','Take aim, sisters...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34919,'','Fire!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34920,'This portal leads to the Stair of Destiny in Hellfire Peninsula... that\'s right, Outland.$B$BAre you prepared...?','',396,397,0,0,2,0,0,0,1,0,0,0,26124),
(34921,'Hold it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34922,'What are you two conspiring? Hand me that package. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34923,'$C, you should know the Warchief doesn\'t trust the undead. Have you heard what happened at the Wrathgate?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34924,'You should do well to consider where your loyalties lie, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34925,'We\'ve seen the results of your \'research\' before. I\'ll deliver this package to Orgrimmar for study.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34926,'','What, this? This is nothing. Just some ... wildlife research.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34927,'','Nonsense! You\'re overreacting. Have you been watching me this whole time?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34928,'','%s mutters angrily to herself.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34929,'You heard the lady, boys... Give \'em some fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34930,'The bloodhound has caught the scent.  Follow it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34931,'The bloodhound has spotted a piece of parchment at the end of the trail.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34932,'Walk away, fool!  You are no match for me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34933,'','Hey there, boss. I trust that you\'re enjoying your new promotion?$B$BWe all think that you\'re the one who\'s going to finally be able to replace that stinky ol\' Gallywix and take the title of Trade $g Prince : Princess;. But you didn\'t hear that from me!$B$BWe have a lot to do and very little time. Hope you\'re ready!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34934,'We just need to knock the centrifugal rotary ball clutch back into alignment. Easy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34935,'Billowing clouds of white smoke... Is that by design?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34936,'Hey $r. Seeing any profit lately?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34937,'Okay, my Personal People-Porter is ready for testing! I mean, ready for use. I wouldn\'t test unproven hardware on you, would I?','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(34938,'I\'m ready to teleport. I think.','I\'m ready to teleport. I think.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34939,'Welcome to Stonetalon Mountains, friend! Saurboz is expectin\' ya.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34940,'Stand still, $n! And hold your breath in case you end up over the ocean...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34941,'Yep, $Ghe:she;\'s a goner.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34942,'','Waaaahhh! It\'s raining $r!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34943,'Locomotion systems operable. Resuming transport,','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34944,'I need another Gahz\'ridian Detector.','I need another Gahz\'ridian Detector.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34945,'These monkeys are a real pain!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34946,'Hey, $n, good to see you. These monkeys are driving me insane!$B$BWhat do you need?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34947,'Let\'s get this samophlange operational!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34948,'All I have to do is resequence the oscillating coolant pressure valves...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34949,'What? $n, you\'re not a warlock.$B$BThere\'s nothing that I can teach a $c like you, $g sir : ma\'am;.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(34950,'$n, I\'m glad that you\'re here. Maybe I can teach you a thing or two.$B$BWhat do you think, $g sir : ma\'am;?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(34951,'Somehow I doubt that you want training from me, $n. I\'m not sure those fingers can handle a firebolt.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34952,'I don\'t know about you, $n, but I for one do not intend to be marooned on this island forever!$B$BIf only I\'d stayed at the academy and learned how to use teleport magic....','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34953,'Can you believe these monkeys, $n?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(34954,'Ah good, there $g he : she; is... my future $g master : mistress; of the elements! What kind of training would you like today?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34955,'','You don\'t have to be a priest to tithe. Your coin is just as welcome, $g sir : ma\'am;.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(34956,'','Remember, $n, if you\'re going to be a $g priest : priestess; of the Light, you\'re going to need a lot of gold to keep things running smoothly.$B$BNever be afraid to ask for donations.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34957,'','I\'m surprised that a $c like you could even see me, $n. I\'m stealth on a stick!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34958,'','Sure, $n, I\'ll train you, $n. Just keep an eye out for those monkeys!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(34959,'Warrior-Matic NX-01 is currently offline.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34960,'Warrior-Matic NX-01 is online.$B$BPlease insert coins for training.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34961,'It\'s beautiful! ...have we figured out what it does yet?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34962,'No idea. But it\'s doing it perfectly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34963,'Right away, Noz.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34964,'Is that a working samophlange? Throttle it up! MAX POWER!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34965,'Sputtervalve you\'re a genius! I\'ll take 30.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34966,'','Sometimes the mist cannot find its way if we are too far. Let\'s venture further and try again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34967,'','%s begins to cast |cFFFFFFFFLight Vortex!|r Switch to |cFFFFFFFFLight|r Essence!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34968,'','%s begins to cast |cFF9932CDDark Vortex!|r Switch to |cFF9932CDDark|r Essence!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34969,'Horde scum!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34970,'Die, filth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34971,'$R, I\'ll have your head.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34972,'For Northwatch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34973,'The Rear Admiral will hear of this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34974,'','%s begins to cast  |cFFFF0000Twin\'s Pact!|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34975,'','%s begins to cast Twin\'s Pact!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34976,'Forty five seconds until the Arena battle begins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34977,'C\'mere! Here boy!','C\'mere! Here boy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34978,'...we\'ve got a nice bone for you, puppy.','...we\'ve got a nice bone for you, puppy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34979,'Gimmie that key, you stupid mutt!','Gimmie that key, you stupid mutt!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34980,'%s whistles at Charlie the dog.','%s whistles at Charlie the dog.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34981,'Tie game!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34982,'The Alliance captured the last flag!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34983,'It\'s the gallows for me...','It\'s the gallows for me...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34984,'','Need some help finding your way? I know this place like the back of my hand.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34985,'','You\'re finally here. Take the scenic route?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34986,'','Glad to see that you\'ve arrived. Shall we get to it then?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34987,'','Kyra said that you might need some help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34988,'','There you are! I thought the furbolgs might have caught you before you could even get here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34989,'','Good to see you. They\'re all throughout the tunnels, we\'ll have to stay on our guard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34990,'','I\'m hurt! Go on without me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34991,'','I\'ll need to find a place to rest a while. Continue on... don\'t leave without the relics.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34992,'','I\'m injured! I need to rest a bit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34993,'','It saddens me to see the furbolg all corrupted so readily. These used to be our friends.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34994,'','This place is infested... we\'ll need to make our way out of here with the relics as quickly as possible.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34995,'','I haven\'t seen any of the sleeping druids. They must have been taken from here already.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34996,'','We should have seen this coming. The corruption has been spreading for quite some time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34997,'','If the furbolg could be this far gone, what does that say for the rest of Teldrassil?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34998,'','There has to be a way to stop this corruption before it consumes us all.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(34999,'','Damn you, Fandral! What have you gotten us into with this cursed \"World Tree?\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35000,'Yaaarr!','Yar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35001,'The Horde captured the last flag!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35002,'What, are you crazy?! Trying to blow me to smithereens like that!','What, are you crazy?! Trying to blow me to smithereens like that!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(35003,'$n, it\'s you! Thanks, $g man : sweetie;!','$n, it\'s you! Thanks, $g man : sweetie;!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(35004,'Blowing open my escape pod. I like your style, $n!','Blowing open my escape pod. I like your style, $n!',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(35005,'$n? I heard you were dead.','$n? I heard you were dead.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(35006,'Couldn\'t you have just used a crowbar?','Couldn\'t you have just used a crowbar?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(35007,'$n! Please tell me that monster, the Trade Prince, didn\'t survive?!','$n! Please tell me that monster, the Trade Prince, didn\'t survive?!',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(35008,'Thanks, $n. You still owe me that money, $g man : lady;!','Thanks, $n. You still owe me that money, $g man : lady;!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35009,'What were those Alliance ships doing firing at us?! Did I see a Horde ship, too?','What were those Alliance ships doing firing at us?! Did I see a Horde ship, too?',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(35010,'Time Expired!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35011,'<The drunken engineer blinks blearily at you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35012,'<Club him unconscious.>','<Club him unconscious.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35013,'','Hahaha, very nice, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35014,'I\'m going deaf. That big green harpy won\'t shut up for five seconds. I know how to drive this thing, all right? I\'m not an idiot!','',1,5,0,0,0,0,0,1,1,0,0,0,26124),
(35015,'','Zippik would drive us straight into the Bluff if I wasn\'t here. Moron.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(35016,'It\'s a pretty smooth ride if you don\'t mind the dust.','It\'s a pretty smooth ride if you don\'t mind the dust.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(35017,'Keep away from the edge there, champ. Don\'t want you falling.','Keep away from the edge there, champ. Don\'t want you falling.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(35018,'I\'m workin\', here.','I\'m workin\', here.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(35019,'<The Engineer slumbers fitfully on the floor.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35020,'<Rifle through his pockets.>','<Rifle through his pockets.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35021,'Hey. I\'m on break.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(35022,'Welcome aboard the Zephyr, the smoothest ride you\'re likely to get across the Barrens. Sit back and enjoy the flight, eh, kid? Ain\'t nothing like that sweet, dry air mixed with the scent of oil.','',1,5,0,0,0,0,0,1,1,0,0,0,26124),
(35023,'','Shh! Someone\'s here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35024,'Don\'t get me wrong... I\'m grateful to have Shando Stormrage back, but this is all really suspicious. What happened to Fandral?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35025,'I be Tolwe. Job be to keep da peace an\' watch. So I be watchin\'.','',1,5,0,0,0,0,0,1,1,0,0,0,26124),
(35026,'Dere be a bird!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(35027,'Dat cloud look like da Warchief.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(35028,'Ware da ship! A harpy! ...wait, dat be another bird.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(35029,'Dere be a bug.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(35030,'And there\'s Orgrimmar, huge and menacing like always. Take a quick break, boys, then it\'s back to the Bluff!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(35031,'Next stop, Thunder Bluff!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(35032,'Watch your step! Don\'t want you becoming a smudge down there. Welcome to Thunder Bluff!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(35033,'Okay, boys, let\'s get this baby over to Orgrimmar!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(35034,'','Careful. CAREFUL! Did I feel a shudder? You\'re going to knock that tower down, oaf!',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(35035,'','We\'re behind schedule! Turn this tub east! EAST!',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(35036,'I\'m ready to depart for Ban\'ethil Barrow Den.','I\'m ready to depart for Ban\'ethil Barrow Den.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35037,'','Move it, Zippik! We don\'t have all day!',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(35038,'','Hey, sweetheart. The zeppelin that parks here\'ll take ya straight to Thunder Bluff, free of charge. Who needs wyverns when you got us goblins here, am I right?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35039,'','The zeppelin to Thunder Bluff has arrived! All aboard for a smooth ride across the Barrens!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35040,'Can you believe it? They finally opened this place up for us to fly a zeppelin through here! No fly zone no more, am I right? We only crashed one zeppelin into a cliff on the test run. I don\'t see why they were so worried.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35041,'Step right up! The zeppelin to Orgrimmar has arrived! All aboard to Durotar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35042,'Limpet Mine Planted! Detonation in:','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35043,'...5...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35044,'...4...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35045,'...3...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35046,'...2...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35047,'...1...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35048,'What\'re ye starin\' at, $r? Come ta torment the condemned?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(35049,'<The Baron lifts his manacles.>$B$BCome on then, $c. Do ye trust me?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35050,'Never, you two-timing dog!','Never, you two-timing dog!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35051,'<Break Longshore\'s manacles and free him.>','<Break Longshore\'s manacles and free him.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35052,'Har! Pleasure doin\' business with ye, $n.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(35053,'Well? Don\'t ye have heads ta roll an\' treasure ta dig up?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35054,'Suit yerself, mate. Me an\' the treasure can both be buried.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35055,'Hello, $n. If you\'re looking for cooking training, you\'ve come to the right place. I usually get lots of new students when Pilgrim\'s Bounty rolls around.','Hello, $n. If you\'re looking for cooking training, you\'ve come to the right place. I usually get lots of new students when Pilgrim\'s Bounty rolls around.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35056,'Gagsprocket! Shave this for me - pronto!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35057,'Thanks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35058,'Sure thing, boss.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35059,'Digging','Digging',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35060,'Hold it, $r! I promised told ye where the treasure is, but never promised ye could keep it!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(35061,'If you\'re interested in learning more about the traditional Pilgrim\'s Bounty feast, speak to any of the hostesses.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35062,'I seek training.','I seek training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35063,'Grah! Gormok smash you!','Grah! Gormok smash you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35064,'Me hungry!','Me hungry!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35065,'Me stab you good!','Me stab you good!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35067,'Gormok smash cage, you see!','Gormok smash cage, you see!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35068,'Smelly fat thing give food!','Smelly fat thing give food!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35069,'Are you here to celebrate Pilgrim\'s Bounty with us?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35070,'%s unleashes a Leeching Swarm to heal himself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35071,'%s burrows into the ground!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35072,'C\'mon mates! Take the ship and give no quarter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35073,'Right, Cuthbert should be below decks. Come with me, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35074,'Mutiny!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35075,'More of Gormok\'s vermin. Keep them fed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35076,'There she is, mon! Let\'s finish this business.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35077,'','Do not trifle with me, $r.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(35078,'','I should\'ve known you were behind this, Two-Tusk. Have at it, traitor!',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(35079,'','Another mutiny put to rest. Now get this blood off my decks!',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(35080,'','Cap\'n Garvey will hear of this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35081,'Your shredder is nearly ready, really!$b$bAny moment now... just keep checking with me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35082,'Help me out here, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35083,'I\'m countin\' on it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35084,'We did it! The Maiden\'s Dagger is mine, all mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35085,'You tell Dizzywig that I\'m open to negotiations....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35086,'The shredder... It\'s done! Where\'d that driver go...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35087,'','Welcome! Have you come to join us for a Pilgrim\'s Bounty feast? Please, have a seat at a Bountiful Table.$B$BTry everything! I\'m certain you\'ll find something to your liking.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35088,'','Welcome! Have you come to join us for a Pilgrim\'s Bounty feast? Please, have a seat at a Bountiful Table.$B$BTry everything! I\'m certain you\'ll find something to your liking.',3,1,0,0,2,0,0,0,1,0,0,0,26124),
(35089,'As you say. They are restless creatures.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35090,'They will get their chance to fight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35091,'\"Pilgrim\'s Bounty.\" Hrm. I can understand the tauren\'s eagerness to express their sense of gratitude and comraderie to the Horde\'s warchief, but the Forsaken?$B$BI imagined they would have dropped such sentimental traditions long ago.','\"Pilgrim\'s Bounty.\" Hrm. I can understand the tauren\'s eagerness to express their sense of gratitude and comraderie to the Horde\'s warchief, but the Forsaken?$B$BI imagined they would have dropped such sentimental traditions long ago.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(35092,'I am told Pilgrim\'s Bounty is a time to reflect upon one\'s good fortune and share with all around you.$B$BWe are lucky to have found this world and its bold inhabitants; it is only fitting that we lend our knowledge and strength to these new-found allies.','I am told Pilgrim\'s Bounty is a time to reflect upon one\'s good fortune and share with all around you.$B$BWe are lucky to have found this world and its bold inhabitants; it is only fitting that we lend our knowledge and strength to these new-found allies.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35093,'Humans can\'t brew their way out of a tattered linen pouch, but there sure know how to cook. Pilgrim\'s Bounty? I\'m all for it!','Humans can\'t brew their way out of a tattered linen pouch, but there sure know how to cook. Pilgrim\'s Bounty? I\'m all for it!',1,11,0,0,3,0,0,0,1,0,0,0,26124),
(35094,'The logistics involved in the optimal celebration of Pilgrim\'s Bounty are quite staggering... so many raw materials, so much labor, thousands upon thousands of crates of finished product shipped here and there and everywhere for countless Bountiful Tables.$B$BHonestly, I\'m quite impressed! And hungry... I can smell pumpkin pie. Can you smell that pie?','The logistics involved in the optimal celebration of Pilgrim\'s Bounty are quite staggering... so many raw materials, so much labor, thousands upon thousands of crates of finished product shipped here and there and everywhere for countless Bountiful Tables.$B$BHonestly, I\'m quite impressed! And hungry... I can smell pumpkin pie. Can you smell that pie?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35095,'\"Pilgrim\'s Bounty?\" More like \"Fool\'s Folly!\"$B$BHundreds of cargo holds full of food given away for free... FREE! It boggles the mind!$B$BStill, I suppose I should shift some of my Poultry Portfolio funds to turkey... I can\'t believe how big of a bust that chicken investment was. Where did all those Noblegarden eggs COME from?!','\"Pilgrim\'s Bounty?\" More like \"Fool\'s Folly!\"$B$BHundreds of cargo holds full of food given away for free... FREE! It boggles the mind!$B$BStill, I suppose I should shift some of my Poultry Portfolio funds to turkey... I can\'t believe how big of a bust that chicken investment was. Where did all those Noblegarden eggs COME from?!',5,1,18,0,2,3,0,0,1,0,0,0,26124),
(35096,'Pilgrim\'s Bounty is a time to reflect upon one\'s good fortune and share with all around you.$B$BWe hope that all of our noble allies will join us in feasting and celebration.','Pilgrim\'s Bounty is a time to reflect upon one\'s good fortune and share with all around you.$B$BWe hope that all of our noble allies will join us in feasting and celebration.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35097,'Such a stark contrast, this holiday, to typical human behavior. Who\'d have thought such a relentlessly voracious people would make a celebration of giving and sharing?$B$BIt\'s pleasant to see. Darnassus should do its utmost to support and encourage it.','Such a stark contrast, this holiday, to typical human behavior. Who\'d have thought such a relentlessly voracious people would make a celebration of giving and sharing?$B$BIt\'s pleasant to see. Darnassus should do its utmost to support and encourage it.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35098,'The orcs and tauren are fortunate to have found one another, for each people\'s strengths compliment the other\'s.  We are glad to join them in this celebration.$B$BEven the Forsaken partake, though to what end I am not certain...','The orcs and tauren are fortunate to have found one another, for each people\'s strengths compliment the other\'s.  We are glad to join them in this celebration.$B$BEven the Forsaken partake, though to what end I am not certain...',1,6,0,0,3,0,0,0,1,0,0,0,26124),
(35099,'Pilgrim\'s Bounty is a time to reflect upon one\'s good fortune and share with all around you.$B$BIn Mulgore and the Horde, we have found both a home and friends to enjoy its many fruits with.$B$BIt is our hope that every one of our allies will be able to join us in feasting and celebration.','Pilgrim\'s Bounty is a time to reflect upon one\'s good fortune and share with all around you.$B$BIn Mulgore and the Horde, we have found both a home and friends to enjoy its many fruits with.$B$BIt is our hope that every one of our allies will be able to join us in feasting and celebration.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35100,'Dem tauren, dey be KNOWIN\' how ta cook. Have ya SEEN all de food dey be servin\'?$B$BI\'m gonna eat \'til I die... an\' den come back from de grave ta be eatin\' some more!','Dem tauren, dey be KNOWIN\' how ta cook. Have ya SEEN all de food dey be servin\'?$B$BI\'m gonna eat \'til I die... an\' den come back from de grave ta be eatin\' some more!',5,11,0,0,2,0,0,0,1,0,0,0,26124),
(35101,'Why do we celebrate Pilgrim\'s Bounty...? Who can say. Habit, I suppose. I certainly can\'t taste any of it.$B$BPumpkin pie, virulent plagues... Does it really matter WHAT we\'re cooking up?','Why do we celebrate Pilgrim\'s Bounty...? Who can say. Habit, I suppose. I certainly can\'t taste any of it.$B$BPumpkin pie, virulent plagues... Does it really matter WHAT we\'re cooking up?',1,6,0,0,2,0,0,0,1,0,0,0,26124),
(35102,'Ratchet security is a joke, open to the highest bidder. Our coffers will buy us the guards.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35103,'The Southsea Pearl and the Conquest will be joining us within the week to help with the invasion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35104,'The Conquest will sail into Ratchet harbor first. Noise is her aim: Double-shot the guns, sew havoc.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35105,'I\'ll helm the Maiden\'s Dagger and lead the shore parties myself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35106,'With Ratchet as our new base of operations, Orgrimmar harbor will be ripe for the plucking!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35107,'Get away from the rum!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35108,'How do the Bountiful Tables work?','How do the Bountiful Tables work?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35109,'','A Bountiful Table is laid out with five Pilgrim\'s Bounty foods, one in front of each chair.$B$BWhile in a chair, you may eat as much of that food as you like, as well as pass servings of that food to the other chairs. Feast and share with friends!$B$BIf you eat enough of any one food, you\'ll gain benefits unique to that food.$B$BIn addition, if you eat enough of every food, you\'ll gain the Spirit of Sharing!',1,21,1,0,3,3,0,0,1,0,0,0,26124),
(35110,'','A Bountiful Table is laid out with five Pilgrim\'s Bounty foods, one in front of each chair.$B$BWhile in a chair, you may eat as much of that food as you like, as well as pass servings of that food to the other chairs. Feast and share with friends!$B$BIf you eat enough of any one food, you\'ll gain benefits unique to that food.$B$BIn addition, if you eat enough of every food, you\'ll gain the Spirit of Sharing!',1,21,1,0,3,3,0,0,1,0,0,0,26124),
(35111,'<The troll before you is covered head-to-toe with gashes and scars, including a fresh slice across his face that has fattened his lip.>$B$BHewwo!$B$BAs you know, twolls wide waptors. The pwobwem is cowwecting the wild waptors for twaining! That\'s where I come in. I\'m a waptor twapper.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35112,'Sorry, mon. It won\'t happen again.','Sorry, mon. It won\'t happen again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35113,'I\'m going. I\'m going!','I\'m going. I\'m going!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35114,'Oops, break\'s over.','Oops, break\'s over.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35115,'Don\'t tase me, mon!','Don\'t tase me, mon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35116,'The trap emits a raptor-like screech!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35117,'','FOR MOTHER RUSSIA!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35118,'Oh - I fowgot the voodoo to enwawge them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35119,'...We\'re gonna need some smawwer twolls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35121,'Hewwo.','',70,0,0,0,0,0,0,0,1,0,0,0,26124),
(35122,'Be caweful with the waptors, they can be wewy wewy smawt.$B$BLast week two hewd me down while a thiwd beat me with a stick.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35123,'Megs, I misplaced the keys to the cruiser. Did you find them?','Megs, I misplaced the keys to the cruiser. Did you find them?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35124,'','%s calls out for her mate!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35125,'Verog the Dervish howls with rage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35126,'Darn, you got me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35127,'Darn, you got me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35128,'Pay up, Bruno!','Pay up, Bruno!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35129,'','What? Fine, fine... I\'ll pay my protection moolah to your goons!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35130,'Hand it over, Frankie!','Hand it over, Frankie!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35131,'','What? Fine, fine... I got it, I got it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35132,'%s grunts and gives up, clearly beaten.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35133,'<Grunt>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35134,'Don\'t play stupid with me, Jack. I know that you have the moolah!','Don\'t play stupid with me, Jack. I know that you have the moolah!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35135,'Not the face, not the face!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35136,'Not the face, not the face!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35137,'Business been bad lately, Sudsy?','Business been bad lately, Sudsy?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35138,'Ride hard and show no mercy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35139,'The Burning Blade? What are they doing here? Shoot to kill!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35140,'','$G Mr. : Ms.; $n, so very good to see you.$B$BI hope that you are enjoying the Kaja\'Cola marketing campaign. We\'re planning a massive set of explosions for the next phase of the campaign. That always goes over well with our target demographic.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35141,'You\'ll find Krendle Bigpockets near the zeppelin\'s perch on the western edge of Spirit Rise. I\'m not fond of the goblin contraption flying through here... but it will take you to Orgrimmar if you can stand it. From Orgrimmar you can risk another zeppelin to Undercity or Silvermoon City in the Eastern Kingdoms or one to Warsong Hold in Northrend.','You\'ll find Krendle Bigpockets near the zeppelin\'s perch on the western edge of Spirit Rise. I\'m not fond of the goblin contraption flying through here... but it will take you to Orgrimmar if you can stand it. From Orgrimmar you can risk another zeppelin to Undercity or Silvermoon City in the Eastern Kingdoms or one to Warsong Hold in Northrend.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(35142,'The true crusader is more than just a hero in the battle against evil... he is an exemplar, a rallier to the cause, a champion in the eyes of all his people.$B$BAs High Crusader, it is my duty to task such men and women with worthy quests.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(35143,'The blood elves of Silvermoon cheer for $n.','The blood elves of Silvermoon cheer for $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35144,'The draenei of the Exodar cheer for $n.','The draenei of the Exodar cheer for $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35145,'The dwarves of Ironforge begin a cheer for $n.','The dwarves of Ironforge begin a cheer for $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35146,'The gnomes of Gnomeregan cheer for $n.','The gnomes of Gnomeregan cheer for $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35147,'The humans of Stormwind cheer for $n.','The humans of Stormwind cheer for $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35148,'The night elves of Darnassus cheer for $n.','The night elves of Darnassus cheer for $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35149,'The orcs of Orgrimmar cheer for $n.','The orcs of Orgrimmar cheer for $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35150,'The tauren of Thunder Bluff cheer for $n.','The tauren of Thunder Bluff cheer for $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35151,'The trolls of the Sen\'jin Village begin a chant to celebrate $n.','The trolls of the Sen\'jin Village begin a chant to celebrate $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35152,'The forsaken of the Undercity cheer for $n.','The forsaken of the Undercity cheer for $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35153,'$n prepares a Bountiful Feast!','$n prepares a Bountiful Feast!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35154,'You no take... me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35155,'No!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35156,'Grrrrr!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35157,'No kill me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35158,'Net not stop me! No... net stop me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35159,'Me not afraid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35160,'','There are some rewards fit only for those who have attained the title of Crusader, exalted in the eyes of the Argent Crusade as well as all their allied peoples.$B$BTirion himself has charged me with the finding of such heroes and bestowing upon them the proper decorations.',2,396,0,0,2,0,0,0,1,0,0,0,26124),
(35161,'The Alliance spectators cheer for $n.','The Alliance spectators cheer for $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35162,'The Horde spectators cheer for $n.','The Horde spectators cheer for $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35163,'%s begins to boil upon touching $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35164,'The gates have been breached! Defend the keep!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35165,'The gates have been breached! Defend the keep!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35166,'Stand your ground, men!','',0,0,0,0,0,0,0,0,1,0,19617,0,26124),
(35167,'Defeat these foul beasts!','',0,0,0,0,0,0,0,0,1,0,19618,0,26124),
(35168,'Protect the civilians!','',0,0,0,0,0,0,0,0,1,0,19619,0,26124),
(35169,'Push them back!','',0,0,0,0,0,0,0,0,1,0,19620,0,26124),
(35170,'Take heart, men!  We must protect our city!','',0,0,0,0,0,0,0,0,1,0,19621,0,26124),
(35171,'Welcome, champion! Have you gathered your forces in preparation for the challenges of the Trials of the Crusader?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35172,'Yes. We are prepared for the challenges ahead of us.','Yes. We are prepared for the challenges ahead of us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35173,'Are you ready for the first challenge, then?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35174,'Bring forth the first challenge!','Bring forth the first challenge!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35175,'','I heard Lord Xavius left today for his tower in Ashenvale. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35176,'Oh? Do you think his promise of an even greater source of power will come true?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35177,'','As one of the greatest of the Highborne, he will succeed where others have failed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35178,'I\'m still wary of the risks. While I agree that Malfurion and his dirt-loving brothers are quite mad, this Lord Sargeras must have another agenda...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35179,'','Shush! Quiet... before the others hear you.  ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35180,'Thank you, $c.','Thank you, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35181,'They\'re killing the prisoners! Hurry, help the others.','They\'re killing the prisoners! Hurry, help the others.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35182,'I thought I\'d never make it out of here alive.','I thought I\'d never make it out of here alive.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35183,'I thought I was going to die in there!','I thought I was going to die in there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35184,'I knew I shouldn\'t have come to the tournament!','I knew I shouldn\'t have come to the tournament!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35185,'My friends, my colleagues. Put yourselves at ease.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35186,'The recent decrease in our magical powers is being reviewed as we speak. Even Lord Xavius has said that the ebb and flow of magic is normal. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35187,'However, our new allies, formed from within the Twisting Nether promise new sources of power, and untold mastery of our magic. Keep faith in Lady Azshara, as she keeps her faith in you. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35188,'%s nods warmly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35189,'Please show me your documents before proceeding.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35190,'%s creates a Nether Portal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35191,'%s creates an |cFF00FF00Infernal Volcano!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35192,'By orders of the Queen, all possessions must be inspected before entry into the city is permitted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35193,'Patience, patience. We will be with you shortly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35194,'$n has |cFFFF0000Legion Flames!|r\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35195,'$n has |cFF00FFFFIncinerate Flesh!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35196,'Placing','Placing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35197,'Oh, Illyanna, your eyes, they are so beautiful.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35198,'','Yes. They are even more beautiful without your reflection in them. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35199,'Illyanna, why do you spurn me? I would weave a web to catch the sun, if you were to ask me to do so!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35200,'','Then why don\'t you go and do that? My friends and I have better things to do!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35201,'To hold you in my arms would be the fulfillment of my dreams. Come down from there, let us travel far away from here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35202,'','You go ahead and start your travels. I\'ll catch up with you right after I finish tending to my hair. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35203,'Oh, Illyanna, I love you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35204,'','%s shudders.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35205,'That was the greatest moment of my life...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35206,'','Away from me, lowborn scum! Perhaps you did not notice my boot in your face the first time!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35207,'%s giggles.','%s giggles.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35208,'','The sisters go into a Berserker Rage!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35209,'','Come in, come in! One at a time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35210,'','Browse my wares to your hearts content! From the finest in enchantments, to the latest in fashion, you can find it all here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35211,'','I recommend you buy like there was no tomorrow. Who knows how long it will be until you find deals this good again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35212,'','All I\'m saying is don\'t be caught dead in those outdated fashions!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35213,'Those beasts are amazing specimens. You should feel no shame at being bested by them.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35214,'Excellent! Let me know when you are ready for the next attempt.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(35215,'We want another shot at those beasts!','We want another shot at those beasts!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35216,'We\'re ready. This time things will be different.','We\'re ready. This time things will be different.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35217,'You are not yet strong enough to do battle on the Isle of Conquest. Return when you have gained more experience.','You are not yet strong enough to do battle on the Isle of Conquest. Return when you have gained more experience.',274,0,0,1,0,0,0,0,1,0,0,0,26124),
(35218,'The Isle of Conquest is laden with valuable resources we cannot allow to fall into Horde hands. Will you join the fight?','The Isle of Conquest is laden with valuable resources we cannot allow to fall into Horde hands. Will you join the fight?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35219,'The Isle of Conquest is laden with valuable resources we cannot allow to fall into Alliance hands. Will you join the fight?','The Isle of Conquest is laden with valuable resources we cannot allow to fall into Alliance hands. Will you join the fight?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35220,'I\'d like a pair of Synthebrew Goggles.','I\'d like a pair of Synthebrew Goggles.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35221,'We want everyone to have fun at Brewfest.  It would also help if we had some people remember it as well.$b$bThese goggles allow anyone to experience what it\'s like to be drunk, but without the drinking part.  Put the goggles on, and it\'s like you\'re drunk!  Take them off, and you\'re sober!$b$bAre you interested in a pair?','We want everyone to have fun at Brewfest.  It would also help if we had some people remember it as well.$b$bThese goggles allow anyone to experience what it\'s like to be drunk, but without the drinking part.  Put the goggles on, and it\'s like you\'re drunk!  Take them off, and you\'re sober!$b$bAre you interested in a pair?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35222,'What are Synthebrew Goggles?','What are Synthebrew Goggles?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35223,'What did you say earlier?','What did you say earlier?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35224,'You are not yet seasoned enough to enter a battleground, $c. Return when you have gained more experience.','You are not yet seasoned enough to enter a battleground, $c. Return when you have gained more experience.',274,0,0,1,0,0,0,0,1,0,0,0,26124),
(35225,'Are you ready to fight for the Horde, $c?','Are you ready to fight for the Horde, $c?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35226,'Are you ready to fight for the Alliance, $c?','Are you ready to fight for the Alliance, $c?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35227,'You dare to challenge Drottinn Hrothgar, king of the seas?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35228,'All aboard the gunship! Man the guns!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35229,'','Well, then. Let us begin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35230,'Thank you!','Thank you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35231,'','Even the darkest memory fades when confronted!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35232,'','Excellent work!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35233,'%s grabs a Snobold Vassal off his back and prepares to hurl it into battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35234,'Protect me, please!','Protect me, please!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35235,'What in the world?  Let\'s get out of here!','What in the world?  Let\'s get out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35236,'Let\'s go!','Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35237,'No time to waste!','No time to waste!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35238,'Worgen!  Worgen everywhere!','Worgen!  Worgen everywhere!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35239,'This place isn\'t safe.  Let\'s leave!','This place isn\'t safe.  Let\'s leave!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35240,'Flee!  They\'re everywhere!','Flee!  They\'re everywhere!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35241,'All aboard the gunship! Man the guns!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35242,'$n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35243,'What recipes do you sell?','What recipes do you sell?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35244,'Live Update Works again!','Hello!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35245,'Proud and strong, give a cheer for Marshal Jacob Alerius, the Grand Champion of Stormwind!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35246,'The might of the dwarves is represented today by the Grand Champion of Ironforge, Lana Stouthammer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35247,'Coming out of the gate is Colosos, the towering Grand Champion of the Exodar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35248,'Here comes the small but deadly Ambrose Boltspark, Grand Champion of Gnomeregan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35249,'Entering the arena is the Grand Champion of Darnassus, the skilled sentinel Jaelyne Evensong!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35250,'Well done! Your fighting against all those beasts was splendid! I hear the next challenge should be even tougher!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35251,'What new challenge awaits us?','What new challenge awaits us?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35252,'We\'re holding Lord Jaraxxus back for now, but we can\'t keep him bound for much longer.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35253,'You\'ll find out soon enough. Are you ready for the next challenge?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35254,'We\'re ready to fight the sorceror again.','We\'re ready to fight the sorceror again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35255,'','Hi, babe! How do I look?',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(35256,'That\'s great, just give me the signal for when to drop the binding spells.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35257,'We\'re ready for the next challenge.','We\'re ready for the next challenge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35258,'Now.','Now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35259,'The Silver Covenant is pleased to present their contenders for this event, Highlord.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35260,'The Sunreavers are proud to present their representatives in this trial by combat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35261,'I adore you! You believe me? Right, baby?','',17,0,0,0,0,0,0,0,1,0,0,0,26124),
(35262,'','I missed you so much! Where have you been?$B$BAre you going to answer me, or just stand there?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(35263,'','Do you like my outfit?  It\'s for the party. I charged it to your account.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(35264,'','There was another guy just hitting on me. Oh, the nerve!$B$BWill you beat him up for me, sweetie? Thanks. Love ya!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(35265,'','I can\'t wait for the day when you rise to the top. Just think, I\'ll be able to call myself Mrs. Trade Prince$B$BNot to mention buy all that stuff I\'ve always wanted!!!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35266,'','Be careful out there. I heard that there are Southsea pirates in the bay.$B$BHmm, maybe I should go check for myself...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35267,'','Can we go on a nice, romantic picnic on top of Mount Kajaro?$B$BMake sure you pickup my favorite champagne!',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(35268,'','You\'ve got a miscievious look in your eye. What have you been up to, babe?$B$BWell?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(35269,'Sweetie, where have you been? You know how worried I get when you don\'t check in with me!','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(35270,'What do you think of my abs, baby? I just got back from the gym.$B$BI am one fine piece of meat!','',23,0,0,0,0,0,0,0,1,0,0,0,26124),
(35271,'Those other women are just friends, baby.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35272,'I like what you\'re wearing!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35273,'I know that I promised you last night, and the night before that, but I\'m taking you out someplace really nice tomorrow night!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35275,'I heard that some Southsea pirates pulled into dock earlier. Be careful if you go into town!$B$BThey even have women pirates! Hmm, maybe I should go check it out myself? Just to make sure it\'s safe for you out there, baby.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35276,'How\'s my hot, company executive girlfriend today? With the way you run things around here, I think that any day now we\'ll be calling you Trade Princess $n!$B$BI cannot wait! I\'m gonna spend my days at the gym and working on my tan by the pool.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(35277,'A cunning $c, a proud $r.  We are pleased to present $n to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35278,'$n has assaulted the workshop!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35279,'The Alliance has taken the workshop!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35280,'The Horde has taken the workshop!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35281,'One of the fiercest $cs on the field of battle, we present $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35282,'Words can scarce describe the deeds that this $c has performed on the battlefield.  We are proud to present $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35283,'We present to you, $n.  One of the finest $cs we have seen in action.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35284,'If you do not yet know this name, we are certain you will after these battles.  We present, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35285,'Sassy, get me another ride down to the Kaja\'mite Mine.','Sassy, get me another ride down to the Kaja\'mite Mine.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35286,'$n has defended the workshop!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35289,'Hey there, boss-$g man : lady;. This batch of troll slaves has got to be the worst yet!$B$BLucky for us that the kaja\'mite doesn\'t seem to be making their soft brains any smarter, eh?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35290,'Dampwick, I need a ride back to headquarters, pronto!','Dampwick, I need a ride back to headquarters, pronto!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35291,'At last... now I can rest.','At last... now I can rest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35292,'My nightmare, is it finally over?','My nightmare, is it finally over?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35293,'It was awful... I dreamt I was fighting against my friends.','It was awful... I dreamt I was fighting against my friends.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35294,'I can\'t hear the screams anymore. Is this the end?','I can\'t hear the screams anymore. Is this the end?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35295,'I\'m so tired. Just let me rest for a moment.','I\'m so tired. Just let me rest for a moment.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35296,'Here we go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35297,'Hold on!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35298,'This won\'t take long.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35299,'May I say that it\'s an honor to be your driver?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35300,'The mines have been at peak efficiency under your leadership, despite the worms and lazy trolls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35301,'I\'ve been delivering mail for a month now. Are there any executive openings? I have my resume right here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35302,'Nice weather wouldn\'t you say?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35303,'These earthquakes have just been crazy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35304,'$n has risen to the ranks of champion in our tournament.  We are proud to present $ghim:her; to you today.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35305,'Champions on the tournament grounds speak highly of this $c.  Today we present, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35306,'One would be hard pressed to find a more steadfast champion than this $c.  Today we present, $n. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35307,'We offer a mighty champion, a capable $c, an honorable $r.  We present, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35308,'Many champions have fallen to the skills displayed by $n.  We are proud to present this formidable $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35309,'You\'re gonna hear from my lawyer!','You\'re gonna hear from my lawyer!',0,0,0,0,0,0,0,0,1,8606,0,0,26124),
(35310,'Watch where you\'re going!','Watch where you\'re going!',0,0,0,0,0,0,0,0,1,8606,0,0,26124),
(35311,'Learn how to drive you maniac!','Learn how to drive you maniac!',0,0,0,0,0,0,0,0,1,8606,0,0,26124),
(35312,'Ouch!','Ouch!',0,0,0,0,0,0,0,0,1,8606,0,0,26124),
(35313,'My neck! I\'m gonna sue!','My neck! I\'m gonna sue!',0,0,0,0,0,0,0,0,1,8606,0,0,26124),
(35314,'I\'ll get you, $n!','I\'ll get you, $n!',0,0,0,0,0,0,0,0,1,8606,0,0,26124),
(35315,'You\'re a public nuisance, $n!','You\'re a public nuisance, $n!',0,0,0,0,0,0,0,0,1,8606,0,0,26124),
(35316,'The Trade Prince will hear about this, $n!','The Trade Prince will hear about this, $n!',0,0,0,0,0,0,0,0,1,8606,0,0,26124),
(35317,'%s crashes into the Coliseum wall and is stunned!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35318,'Trampling combatants underfoot, %s goes into a frothing rage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35319,'Are you ready for your first challenge, $c?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35320,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35321,'Welcome, champions. Today, before the eyes of your leaders and peers, you will prove yourselves worthy combatants.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35322,'I have no taste for these games, Tirion. Still... I trust they will perform admirably.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35323,'','Of course they will.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35324,'Admirably? Hah! I will enjoy watching your weak little champions fail, human.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35325,'Garrosh, enough.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35326,'Fight well, Horde! Lok\'tar Ogar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35327,'Finally, a fight worth watching.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35328,'I did not come here to watch animals tear at each other senselessly, Tirion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35329,'','They\'re worthy fighters, you\'ll see.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35330,'You will first be facing three of the Grand Champions of the Tournament! These fierce contenders have beaten out all others to reach the pinnacle of skill in the joust.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35331,'Begin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35332,'You come to learn how to ride?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35333,'For years I served in this backwater corner of the world, learning the terrain and biding my time. At last our time has come. The full might of Orgrimmar is now turned to Azshara, our gateway to Ashenvale and dominance over this continent. Welcome to the front lines, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35334,'Presenting the fierce Grand Champion of Orgrimmar, Mokra the Skullcrusher!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35335,'Entering the arena is the lean and dangerous Zul\'tore, Grand Champion of Sen\'jin!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35336,'Tall in the saddle of his kodo, here is the venerable Runok Wildmane, Grand Champion of Thunder Bluff!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35337,'Representing the tenacity of the Forsaken, here is the Grand Champion of the Undercity, Deathstalker Visceri!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35338,'Coming out of the gate is Eressea Dawnsinger, skilled mage and Grand Champion of Silvermoon!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35339,'Syntax Error Line 14, Sequence: Flee for Life. Entering passive mode. *Click!*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35340,'What was that?','What was that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35341,'Run for your lives!','Run for your lives!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35342,'Whatever, I\'ve felt worse.','Whatever, I\'ve felt worse.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35343,'Did you feel that?','Did you feel that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35344,'I knew I should have paid my earthquake insurance!','I knew I should have paid my earthquake insurance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35345,'Mount the Hippogryph and prepare for battle!','Mount the Hippogryph and prepare for battle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35346,'<The Hippogryph looks anxious and ready to go!>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35347,'Are you up to the challenge? I will not hold back.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35348,'','Yeah? Whatdya want?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(35349,'Beat it, pal, before I give you the ol\' Chip Endale fist to the face!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(35350,'Welcome to First Bank of Kezan, a wholly-owned subsidiary of the Bilgewater Traders & Merchants Bank Of The South Seas.$B$BWhat can I do for you today?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35351,'I need to make a withdrawal. Ten stacks of macaroons!','I need to make a withdrawal. Ten stacks of macaroons!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35352,'A pleasure doing business with you as always, $g Mr. : Ms.; $n.$B$BHave a nice day.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35353,'Yo! You look like a $g man : woman; of discerning tastes.$B$BWhat can I do you for?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35354,'Set me up with the phattest, shiniest bling you got!','Set me up with the phattest, shiniest bling you got!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35355,'That bling is phat like your momma!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(35356,'What up, G? Don\'t look like you gots enough macaroons to afford the class of bling I specialize in.$B$BYou might want to get yoself up to the bank. Dig?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(35357,'What do you think you\'re doing?','What do you think you\'re doing?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35358,'You\'re too late to stop our plan.','You\'re too late to stop our plan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35359,'See to it that I\'m not followed.','See to it that I\'m not followed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35360,'Gladly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35361,'Look what I have to work with. Szabo can perform miracles?$B$B<Szabo sighs>$B$BYes, yes. Szabo thinks he can do something with you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35362,'You cannot afford Szabo\'s services. We do not work for free, little waif.$B$BAway with you to the bank. Bring Szabo all of your macaroons.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(35363,'Szabo, I need a hip, new outfit for the party I\'m throwing!','Szabo, I need a hip, new outfit for the party I\'m throwing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35364,'Oh, just look at what Szabo has done. A masterpiece!$B$BYou are not worthy of such an outfit, but Szabo needs the money. <sigh>','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(35365,'$n has assaulted the docks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35366,'$n has defended the docks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35367,'The Alliance has taken the docks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35368,'The Horde has taken the docks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35369,'$n has assaulted the hangar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35370,'$n has defended the hangar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35371,'The Alliance has taken the hangar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35372,'The Horde has taken the hangar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35373,'$n has assaulted the quarry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35374,'$n has defended the quarry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35375,'The Alliance has taken the quarry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35376,'The Horde has taken the quarry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35377,'$n has assaulted the oil refinery!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35378,'$n has defended the oil refinery!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35379,'The Alliance has taken the oil refinery!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35380,'The Horde has taken the oil refinery!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35381,'','I gots all kinds of brands of shades. Yous name it, I sell it!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35382,'','Yeah? Yous don\'t look like you got the moolah to buy anything from me.$B$B<Missa pops her bubblegum.>$B$BMaybe yous forgot to go to the bank?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(35383,'I need some cool shades. What will two stacks of macaroons get me?','I need some cool shades. What will two stacks of macaroons get me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35384,'','Here yous go. My best pair and I\'m giving them to ya cheap!$B$BYous gonna look sharp in them!',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(35385,'Go for the face! Go for the face!','Go for the face! Go for the face!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35386,'Is this the deadbeat?','Is this the deadbeat?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35387,'Get \'em!','Get \'em!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35388,'I never liked you anyway!','I never liked you anyway!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35389,'It\'s payback time!','It\'s payback time!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35390,'You do NOT mess with us!','You do NOT mess with us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35391,'You lookin\' at me?','You lookin\' at me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35392,'I been waitin\' all day for this!','I been waitin\' all day for this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35393,'Foolish $c, you cannot stop the Kvaldir!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35394,'Hello. Would you like to fight the Northrend Beast encounter for the Argent Colosseum raid? \n\nYou will face the version of this encounter that corresponds to the current raid difficulty you have selected. This encounter is a work in progress. Please be sure to report any bugs you experience on the Blizzard forums.\n\nAre you ready to begin the encounter?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35395,'Yes.','Yes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35396,'Hello. Would you like to fight the Lord Jaraxxus encounter for the Argent Colosseum raid? \n\nYou will face the version of this encounter that corresponds to the current raid difficulty you have selected. This encounter is a work in progress. Please be sure to report any bugs you experience on the Blizzard forums.\n\nAre you ready to begin the encounter?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35397,'You already gots the shiniest bling on the island, $g brother : sister;!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35398,'Shredder Blades Activated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35399,'','There\'s no warranty on those shades yous bought!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(35400,'Szabo already made you an outfit worthy of a trade prince. Move along now, you are scaring all of Szabo\'s customers away.','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(35401,'','Welcome to our shop.  We have everything you need... if you need alchemy supplies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35402,'Do you actually sell anything?','Do you actually sell anything?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35403,'OK...','OK...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35404,'','No, I\'m the intellectual one, and I am not to be taken lightly.  I could brew a healing potion from dishwater and dandelions, although that\'s not something I\'ll show you!$b$bAnyhow, if you\'d like to make a purchase, please speak with Patricia.',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(35405,'Swift Spectral Tiger Mount','Swift Spectral Tiger Mount',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35406,'X-51 Nether-Rocket X-TREME Mount','X-51 Nether-Rocket X-TREME Mount',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35407,'Fine, then how about some training?','Fine, then how about some training?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35408,'%s targets $n with the Hammer of the Righteous!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35409,'The front gate of the Horde keep has been destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35410,'The front gate of the Alliance keep has been destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35411,'The west gate of the Horde keep has been destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35412,'The west gate of the Alliance keep has been destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35413,'The east gate of the Horde keep has been destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35414,'The east gate of the Alliance keep has been destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35415,'%s begins to radiate light. Shield your eyes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35416,'Grenade Launcher Armed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35417,'A fresh glass of bubbly. Just what the doctor ordered, $n.','A fresh glass of bubbly. Just what the doctor ordered, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35418,'Thanks for the refill, $g sir : ma\'am;!','Thanks for the refill, $g sir : ma\'am;!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35419,'This sparkling white wine is delicious! Wherever did you get it?','This sparkling white wine is delicious! Wherever did you get it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35420,'I think this one will have to be my last. I\'m driving home after the party.','I think this one will have to be my last. I\'m driving home after the party.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35421,'Thanksh!','Thanksh!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35422,'I feel much better now...hic!','I feel much better now...hic!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35423,'Oh, my head hurtsh.','Oh, my head hurtsh.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35424,'Shorry about your shoes.','Shorry about your shoes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35425,'A disco ball?! Groovy!','A disco ball?! Groovy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35426,'How do you like my moves, $n?','How do you like my moves, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35427,'We should totally have a pants-off dance-off!','We should totally have a pants-off dance-off!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35428,'Shake it like a goblinoid picture!','Shake it like a goblinoid picture!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35429,'Wow! That sure beats this puny, little sparkler!','Wow! That sure beats this puny, little sparkler!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35430,'You really stop at no expense, $n! Amazing!','You really stop at no expense, $n! Amazing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35431,'Best... Party... Evar!','Best... Party... Evar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35432,'Woo hoo, fireworks! More, more!','Woo hoo, fireworks! More, more!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35433,'Thanks. I was almost out. So hungry!','Thanks. I was almost out. So hungry!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35434,'These are the most delicious hors d\'oeurves I have ever tasted. You must share your recipe, $n!','These are the most delicious hors d\'oeurves I have ever tasted. You must share your recipe, $n!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35435,'Finger licking good!','Finger licking good!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35436,'Nom, nom, nom!','Nom, nom, nom!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35437,'Defend the gates!','Defend the gates!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(35438,'Drive this scum back into the woods!','Drive this scum back into the woods!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(35439,'I lost my shades!','I lost my shades!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35440,'I need a new outfit!','I need a new outfit!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35441,'I misplaced my shiny bling!','I misplaced my shiny bling!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35442,'Hammer of the Righteous!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35443,'Emergency Power Reserves Online.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35444,'You\'re dressed to impress! Use your new powers below to make your party guests happy!','You\'re dressed to impress! Use your new powers below to make your party guests happy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35445,'What was that?','What was that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35446,'I need another Oracle Orphan Whistle.','I need another Oracle Orphan Whistle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35447,'Yarr!','Yarr!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35448,'Where be the booty?','Where be the booty?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35449,'Let\'s have a dance!','Let\'s have a dance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35450,'We be here courtesy o\' the trade prince.','We be here courtesy o\' the trade prince.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35451,'Got some rum?','Got some rum?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35452,'Alright boys, shake \'em down!','Alright boys, shake \'em down!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35453,'It be gold we\'re after!','It be gold we\'re after!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35454,'Who be in charge here?','Who be in charge here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35455,'I lost my totems. Can you help?','I lost my totems. Can you help?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35456,'Please be more careful, $n. This relic was created by the Earthen Ring, and it is our gift to you.','Please be more careful, $n. This relic was created by the Earthen Ring, and it is our gift to you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35457,'The spirits of the elements are wise. They\'ve been here long before us and will persist long after we\'re gone. When they speak to us, we must listen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35458,'The spirits of the elements surround us. We must always listen. I have seen firsthand the consequences when we ignore their warnings...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35459,'$n has defended the alliance keep!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35460,'$n has defended the horde keep!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35461,'$n has assaulted the alliance keep!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35462,'$n has assaulted the horde keep!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35463,'The Alliance has taken the alliance keep!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35464,'The Alliance has taken the horde keep!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35465,'The Horde has taken the horde keep!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35466,'The Horde has taken the alliance keep!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35467,'Outstanding party, $n. Thanks for the disco ball!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(35468,'<You can\'t quite make out what Gobber is saying with all of the food that is stuffed in his mouth. You\'re pretty sure that it\'s a thanks, however.>','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35469,'','There\'s my best friend! Come on, $n, dance with us!',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(35470,'The Talrendis Ancient howls out in pain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35471,'Somebody help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35472,'Pirates? PIRATES!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35473,'But my protection money is all paid up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35474,'Who hired the pirates? This is great! What a party! Ouch that hurt! THEY HAVE REAL WEAPONS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35475,'How much are you being paid? I\'ll double it... triple?!  Oh no!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35476,'Southsea Freebooters? This place is really going downhill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35477,'Come on! If we band together, we can take them! Aaaagh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35478,'Begone, insect. You do not belong in these lands. Do not provoke my ire.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35479,'You\'ll be hearing from my lawyer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35480,'Why, what brings you all the way over here, young $r? Please be cautious. Our foes stream forth from a hole in the mountain to the east - they have done irreparable harm to this land.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35481,'Keep your machines away from me, $r! You\'ll be cleansed from this land like the weeds you are!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35482,'Thanks again for the help with these lazy cretins, boss-$g man : lady;.$B$BIf you ask me, we shouldn\'t have been so lenient with the trolls when we freed ourselves from being their slaves.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35483,'Thank you for saving me, $g Mr. : Ms.; $n.','Thank you for saving me, $g Mr. : Ms.; $n.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(35484,'Why would the trade prince do this?','Why would the trade prince do this?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(35485,'So, when\'s the next party?','So, when\'s the next party?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(35486,'Have you seen my girlfriend?','Have you seen my boyfriend?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(35487,'Is the party over?','Is the party over?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(35488,'Please take me off of your guest list.','Please take me off of your guest list.',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(35489,'I had no idea the party was going to have a pirate theme. I would have brought my eyepatch!','I had no idea the party was going to have a pirate theme. I would have brought my eyepatch!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35490,'$G Mr. : Ms.; $n, what\'s wrong with the volcano?','$G Mr. : Ms.; $n, what\'s wrong with the volcano?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(35491,'%s begins to invoke the Waking Nightmare!','%s begins to invoke the Waking Nightmare!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35492,'We remember this visit, yes we do. Never forget what you learn from your new friend, little Roo. You got great future ahead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35493,'No worry, Kekek. You grow up, be strong for Frenzyheart. You lead people back to old home, where there no big-tongue babies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35494,'The crate of explosives is on fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35495,'Come and get us, you motherless beasts!','',0,0,0,0,0,0,0,0,1,0,19503,0,26124),
(35496,'Over here, you fleabags!','',0,0,0,0,0,0,0,0,1,0,19504,0,26124),
(35497,'You\'ll never catch us, you blasted mongrels!','',0,0,0,0,0,0,0,0,1,0,19505,0,26124),
(35498,'Let\'s round up as many of them as we can.  Every worgen chasing us is one less worgen chasing the survivors!','',0,0,0,0,0,0,0,0,1,0,19506,0,26124),
(35499,'Warning!  Warning!  Stealthed intruder detected!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35500,'I\'ve lost my key to the Violet Hold.','I\'ve lost my key to the Violet Hold.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35501,'Yes, $c?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35502,'I am here on Sorrem\'s errand, You are to call Furien\'s dragonhawk for me.','I am here on Sorrem\'s errand, You are to call Furien\'s dragonhawk for me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35503,'$n is my target!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35504,'The Goblin All-In-1der Belt\'s battery is depleted.','The Goblin All-In-1der Belt\'s battery is depleted.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35505,'See those seaforium bombs? Use them on the gates while I repair the siege engine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35506,'Safe travels, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35507,'I\'m halfway there! Keep the Horde away from here.  They don\'t teach fighting in engineering school!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35508,'My finest work so far! This siege engine is ready for action!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35509,'It\'s broken already?! No worries. It\'s nothing I can\'t fix.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35510,'Go get dressed for the party.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35511,'Gobber grunts his good-byes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35512,'','See ya at the party, babe!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35513,'Visit a bank.','Visit a bank.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35514,'%s nods at the line of guards and motions for Jaina to follow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35515,'Visit a trader.','Visit a trader.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35516,'Visit the Stables.','Visit the Stables.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35517,'I\'ll work on the siege engine, just watch my back.  Use those seaforium bombs on the gates if you need them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35518,'I\'m about halfway done! Keep the Alliance away - fighting\'s not in my contract!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35519,'The siege engine is ready to roll!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35520,'It\'s broken again?! I\'ll fix it... just don\'t expect the warranty to cover this.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35521,'Tirion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35522,'King Varian, Lady Jaina. Welcome to the tournament. Your place in the coliseum is waiting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35523,'','Thank you. It\'s the least I can do to support this; we need to stand together.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35524,'You ask much of me, Tirion, to sit and watch, trusting the savages to keep themselves in check.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35525,'My people are here to ensure they honor the rules of engagement. It will do your subjects well to see you in the stands.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35526,'%s nods and gestures for his guests to follow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35527,'Perhaps. I doubt the effectiveness of this gambit. We would be better served preparing our armies for the final assault.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35528,'But if my presence is required in these games to gain your support in the battle, then I will remain.  For now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35529,'','I\'m sure Thrall will have his people under control...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35530,'There are some who desire to stop gaining experience from their actions; to forever remain at the level of strength they are now, and never grow stronger.$B$BI can make this possible... for a fee, of course.$B$BBut understand this: Once you pay me, you will NO LONGER GAIN EXPERIENCE. None. Not one whit.$B$BShould you change your mind afterwards and want to start gaining experience again, I can undo the process for the same fee.','There are some who desire to stop gaining experience from their actions; to forever remain at the level of strength they are now, and never grow stronger.$B$BI can make this possible... for a fee, of course.$B$BBut understand this: Once you pay me, you will NO LONGER GAIN EXPERIENCE. None. Not one whit.$B$BShould you change your mind afterwards and want to start gaining experience again, I can undo the process for the same fee.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35531,'I no longer wish to gain experience.','I no longer wish to gain experience.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35532,'I wish to start gaining experience again.','I wish to start gaining experience again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35533,'Are you certain you wish to start gaining experience again?','Are you certain you wish to start gaining experience again?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35534,'Visit a mailbox.','Visit a mailbox.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35535,'Are you certain you wish to stop gaining experience?','Are you certain you wish to stop gaining experience?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35536,'That was an impressive display.  But are you ready for your next challenge?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35537,'You\'ve impressed everyone here today with your skills in the arena.  It is now time to be recognized before all as a champion of the tournament.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35538,'I am ready for the next challenge.','I am ready for the next challenge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35539,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35540,'So the dogs have returned to sniff around?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35541,'Well fought! Your next challenge comes from the Crusade\'s own ranks. You will be tested against their considerable prowess.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35542,'Entering the arena, a paladin who is no stranger to the battlefield or tournament ground, the Grand Champion of the Argent Crusade, Eadric the Pure!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35543,'The next combatant is second to none in her passion for upholding the Light. I give you Argent Confessor Paletress!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35544,'Well done. You have proven yourself today-','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35545,'What\'s that, up near the rafters?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35546,'You spoiled my grand entrance, rat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35547,'What is the meaning of this?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35548,'Did you honestly think an agent of the Lich King would be bested on the field of your pathetic little tournament?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35549,'I\'ve come to finish my task.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35550,'Don\'t just stand there; kill him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35551,'Tear him apart!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35552,'Garrosh, I expect you to control yourself here. I do not want a repeat of the Violet Citadel.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35553,'Pah! That was a show of strength, worthy of a leader. I only regret I did not kill that human before the mage interfered.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35554,'What honor is there in thrashing about with blunted sticks? This is a waste of time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35555,'Speak for yourself, Thrall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35556,'Words of a fool, you mean. The Horde will destroy the undead without your aid, human, or that of the pompous king.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35557,'Bah.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35558,'We are guests here, Garrosh, and you will conduct yourself honorably.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35559,'Thank you for the invitation, Lord Fordring. We look forward to observing these games.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35560,'Wise words.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35561,'Garrosh, enough!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35562,'Of course, Tirion. I apologize for his outburst.  It will not be repeated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35563,'This monument hums and crackles with perpetual ancient energies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35564,'Finding yourself without a Vortex Gem, you reach into the runestone to acquire another.','Finding yourself without a Vortex Gem, you reach into the runestone to acquire another.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35565,'You\'re looking at the most state-of-the-art mining operation in the world. Only rubes would bother to tunnel under a mountain to get at the minerals below. We moved the whole mountain! Now we can just scoop the precious metals right off of the ground.','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(35566,'You are breaking into the vault to retrieve your Personal Riches!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35567,'Use what is called for in your Goblin All-In-1-Der Belt below to crack open the vault!$B|TInterface\\Icons\\INV_Misc_EngGizmos_20.blp:64|t |TInterface\\Icons\\INV_Misc_Bomb_07.blp:64|t |TInterface\\Icons\\INV_Misc_Ear_NightElf_02.blp:64|t |TInterface\\Icons\\INV_Misc_EngGizmos_swissArmy.blp:64|t |TInterface\\Icons\\INV_Weapon_ShortBlade_21.blp:64|t','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35568,'The vault will be cracked once the |cFFFF2222Vault Breaking progress bar reaches 100 percent!|r$B|TInterface\\Icons\\INV_Misc_coin_02.blp:64|t$BDoing the wrong thing at the wrong time will reduce the progress of the bar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35569,'Good luck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35570,'I\'m free!','I\'m free!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35571,'I\'m outta here...','I\'m outta here...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35572,'The nightmare is over!','The nightmare is over!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35573,'I can still clock in for the time I was petrified, right?','I can still clock in for the time I was petrified, right?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35574,'Give that $gman:woman; a raise!','Give that $gman:woman; a raise!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35575,'No job is worth this!','No job is worth this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35576,'Use your |cFFFF2222Kaja\'mite Drill!|r$B|TInterface\\Icons\\INV_Weapon_ShortBlade_21.blp:64|t','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35577,'Use your |cFFFF2222Blastcrackers!|r$B|TInterface\\Icons\\INV_Misc_Bomb_07.blp:64|t','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35578,'Use your |cFFFF2222Ear-O-Scope!|r$B|TInterface\\Icons\\INV_Misc_Ear_NightElf_02.blp:64|t','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35579,'Use your |cFFFF2222Infinifold Lockpick!|r$B|TInterface\\Icons\\INV_Misc_EngGizmos_swissArmy.blp:64|t','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35581,'I quit, I QUIT!','I quit, I QUIT!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35582,'That was surprisingly restful.','That was surprisingly restful.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35583,'%s goes crazy-go-nuts!','%s goes crazy-go-nuts!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35675,'%s glares at $n and lets out a bellowing roar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35676,'%s\'s spikes pursue $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35677,'You may begin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35678,'','At long last we have an opportunity to study the ruins that dot this landscape... Provided these moneygrubbers don\'t level the place first.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35679,'Tell me about the nearby ruins.','Tell me about the nearby ruins.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35680,'','Die, tresspasser!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35681,'','You do not belong here, $r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35682,'','You are treading upon sacred ground!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35683,'','Your kind is not welcome here, $r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35684,'HAH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35685,'Hardly a challenge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35686,'Worthless scrub.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35687,'Is this the best the Horde has to offer?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35688,'The Alliance doesn\'t need the help of a demon lord to deal with Horde filth! Come, pig!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35689,'Fight for the glory of the Alliance, heroes! Honor your king and your people!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35690,'Our honor has been besmirched! They make wild claims and false accusations against us. I demand justice! Allow my champions to fight in place of your knights, Tirion. We challenge the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35691,'GLORY TO THE ALLIANCE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35692,'Not even the Lich King\'s most powerful minions can stand against the Alliance. All hail our victors!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35693,'Your beasts will be no match for my champions, Tirion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35694,'Weakling!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35695,'Finding yourself without a Raging Vortex Gem, you reach into the runestone to acquire another.','Finding yourself without a Raging Vortex Gem, you reach into the runestone to acquire another.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35696,'Pathetic.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35697,'Overpowered...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35698,'Lok\'tar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35699,'Treacherous Alliance dogs! You summon a demon lord against warriors of the Horde? Your deaths will be swift!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35700,'Use your |cFFFF2222Amazing G-Ray!|r$B|TInterface\\Icons\\INV_Misc_EngGizmos_20.blp:64|t','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35701,'Show them no mercy, Horde champions! LOK\'TAR OGAR! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35702,'Correct!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35703,'The Horde demands justice! We challenge the Alliance! Allow us to battle in place of your knights, paladin. We will show these dogs what it means to insult the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35704,'Incorrect!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35705,'That was just a taste of what the future brings. FOR THE HORDE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35706,'Do you still question the might of the Horde, paladin? We will take on all comers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35707,'I\'ve seen more worthy challenges in the Ring of Blood. You waste our time, paladin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35708,'Welcome, champions! You have heard the call of the Argent Crusade and you have boldly answered! It is here, in the Crusaders\' Coliseum, that you will face your greatest challenges. Those of you who survive the rigors of the coliseum will join the Argent Crusade on its march to Icecrown Citadel.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35709,'Let the games begin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35710,'Hailing from the deepest, darkest caverns of the Storm Peaks, Gormok the Impaler! Battle on, heroes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35711,'Steel yourselves, heroes, for the twin terrors, Acidmaw and Dreadscale, enter the arena!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35712,'The air itself freezes with the introduction of our next combatant, Icehowl! Kill or be killed, champions!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35713,'The monstrous menagerie has been vanquished!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35714,'Tragic... They fought valiantly, but the beasts of Northrend triumphed. Let us observe a moment of silence for our fallen heroes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35715,'Grand Warlock Wilfred Fizzlebang will summon forth your next challenge. Stand by for his entry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35716,'Quickly, heroes, destroy the demon lord before it can open a portal to its twisted demonic realm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35717,'The loss of Wilfred Fizzlebang, while unfortunate, should be a lesson to those that dare dabble in dark magic. Alas, you are victorious and now must face the next challenge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35718,'Everyone calm down! Compose yourselves! There is no conspiracy at play here! The warlock acted on his own volition, outside of influences from the Alliance. The tournament must go on!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35719,'The next battle will be against the Argent Crusade\'s most powerful knights! Only by defeating them will you be deemed worthy...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35720,'Very well. I will allow it. Fight with honor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35721,'A shallow and tragic victory. We are weaker as a whole from the losses suffered today. Who but the Lich King could benefit from such foolishness? Great warriors have lost their lives. And for what? The true threat looms ahead - the Lich King awaits us all in death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35722,'Only by working together will you overcome the final challenge. From the depths of Icecrown come two of the Scourge\'s most powerful lieutenants: fearsome val\'kyr, winged harbingers of the Lich King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35723,'A mighty blow has been dealt to the Lich King! You have proven yourselves as able bodied champions of the Argent Crusade. Together we will strike against Icecrown Citadel and destroy what remains of the Scourge! There is no challenge that we cannot face united!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35724,'Arthas! You are hopelessly outnumbered! Lay down Frostmourne and I will grant you a just death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35725,'Welcome to the Trials of the Crusader! Only the most powerful combatants of Azeroth are allowed to undergo these trials. You are among the worthy few.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35726,'Thank you, Highlord. Now, challengers, I will begin the ritual of summoning. When I am done a fearsome doomguard will appear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35727,'Prepare for oblivion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35728,'A-HA! I\'ve done it! Behold the absolute power of Wilfred Fizzlebang, master summoner! You are bound to me, demon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35729,'But I\'m in charge here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35730,'Trifling gnome! Your arrogance will be your undoing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35731,'You face Jaraxxus, Eredar Lord of the Burning Legion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35732,'Insignificant gnat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35733,'Banished to the Nether!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35734,'Another will take my place. Your world is doomed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35735,'FLESH FROM BONE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35736,'Come forth, sister! Your master calls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35737,'IN-FER-NO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35738,'','In the name of our dark master. For the Lich King. You. Will. Die.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35739,'','You have been measured and found wanting.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35740,'','Unworthy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35741,'','The Scourge cannot be stopped...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35743,'','You are finished!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35744,'','CHAOS!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35745,'','Let the dark consume you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35746,'','Let the light consume you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35747,'You will have your challenge, Fordring.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35748,'The Nerubians built an empire beneath the frozen wastes of Northrend. An empire that you so foolishly built your structures upon. MY EMPIRE.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35749,'The souls of your fallen champions will be mine, Fordring.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35750,'Ahhh, our guests have arrived, just as the master promised.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35751,'This place will serve as your tomb!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35752,'F-lakkh shir!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35753,'Another soul to sate the host.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35754,'I have failed you, master...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35756,'Auum na-l ak-k-k-k, isshhh. Rise, minions. Devour...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35757,'The swarm shall overtake you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35758,'Prepare yourselves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35759,'You! You need more practice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35760,'Nay, nay, and I say yet again nay! Not good enough.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35761,'I yield! I submit. Excellent work. May I run away now?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35762,'','Thank you, good herald. Your words are too kind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35763,'','May the Light give me strength to provide a worthy challenge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35764,'','Take this time to consider your past deeds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35765,'','Take your rest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35766,'','Be at ease.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35767,'This farce ends here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35768,'Pathetic.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35769,'A waste of flesh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35770,'No! I must not fail... again...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35771,'My rotting flesh was just getting in the way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35772,'I have no need for bones to best you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35773,'Timed Out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35774,'','Are you familiar with the War of the Ancients, $n? That is what we call the period of time 10,000 years ago, when the demons of the Burning Legion first breached the realm of Azeroth and attempted to devour this entire world as they have countless others. The ancient capital of Azshara, a city that once dominated this landscape, was ground zero for the invasion. The ancient wreckage you\'ll find scattered throughout the area stands in broken testament to the egotism of our forebears.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35775,'What are you doing here?','What are you doing here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35776,'','My concern for the moment is with the ruins that surround Lake Mennar, to our east. Thousands of years ago the Mennar Academy was among the first to study the arcane arts. It was a beautiful terraced structure built in a ring around a tranquil lake, a place of quiet contemplation and focused study. It was there that my ancestors first discovered the potential of the magical energies seeping from the Well of Eternity.$B$BI\'m sorry - is this all too much to take in? I\'ve immersed myself in arcane history for several decades now, I forget that others do not share my passion.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35777,'No, please go on.','No, please go on.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35778,'','Suffice it to say that the academy was cautious in its application of these newfound powers - what few writings remain indicate that the mages there worried about arcane addiction, a problem my race suffers from to this day.$B$BThis restraint put the mages of Mennar in opposition to Queen Azshara and her highborne lackeys, who sought ever greater power with wild abandon, throwing caution to the wind and delving into ever more dangerous applications of the arts.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(35779,'What happened to the mages?','What happened to the mages?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35780,'','By the time the Burning Legion began its assault, the mages at the Mennar Academy had fallen far from the Queen\'s graces. They would\'ve been a powerful asset in the war to come, but they refused to fall back when the rest of the city fell.$B$BInstead of regrouping outside the city to join in the counter-assault, they stayed behind, erecting magical barriers and turning their once quiet home into a fortress. Refugees streamed to the Mennar Academy in the first terrible days of the invasion, and survivors rallied to mount a defense.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35781,'Were they able to hold out?','Were they able to hold out?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35782,'','Hold out? Against a full frontal assault from the legion\'s vanguard? Not likely!$B$BNo, history doesn\'t record what happened next... for there were no survivors. The raging demons left little more than the ruins you see today, and the secrets of the academy lay buried under the soil of Azshara.',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(35783,'And we\'re going to dig them up.','And we\'re going to dig them up.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35784,'','I like the way you think, $r!$B$BUntil recently, the latent magical energies of the academy grounds attracted the attention of the Blue Dragonflight, and I wasn\'t able to study them. The attention of the dragons is now elsewhere, but a worse threat is in the making - these little green brutes want to level the ruins to make way for a fuel depot! Knowledge lost for ten thousand years is days away from being lost forever. We\'ve got to act fast.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(35785,'Welcome, Warchief Thrall. Overlord Hellscream.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35786,'I hope you\'ll see the merit of these events in time, Garrosh. We cannot win against the Scourge if we continue to war against one another.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35787,'Under my roof, gentlemen, I trust you will behave.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35788,'If you will follow me, then.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35789,'Thank the Light! I\'ll never do anything this foolish again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35790,'They were seconds from strapping me to one of those altars and sucking my soul out. Let\'s get out of here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35791,'Let me at those crazy cultists! I\'ll cleave \'em in half!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35792,'Let\'s rescue the rest of those aspirants and get back to camp. I\'m going to need a whole keg of ale after this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35793,'Teach those cultists a lesson, $n. No one messes with Crusader Kul and gets away with it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35794,'Well done, Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35795,'You fought well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35796,'My congratulations, champions. Through trials both planned and unexpected, you have triumphed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35797,'Go now and rest; you\'ve earned it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35798,'','You have Touch of |cFFFFFFFFLight.|r  Switch to |cFFFFFFFFLight|r Essence!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35799,'Combatants of the Alliance and Horde! You are welcome under the banner of the Argent Crusade.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35800,'To the south lies our goal. We will march to the Citadel and cut out the heart of the Scourge where it dwells.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35801,'But this is no task to be taken lightly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35802,'A massive attack with every able-bodied man would end in needless slaughter. Every soldier lost would rise as the enemy. Azeroth would be left defenseless against the undead threat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35803,'Instead, we require a small, concentrated strike force for the attack to succeed. For that reason, we have created the Argent Tournament.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35804,'','You have Touch of |cFF9932CDDarkness.|r  Switch to |cFF9932CDDark|r Essence!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35805,'Within these walls, you will be tested. Your skill in combat will be matched against the fiercest dangers Northrend has to offer under the watchful eyes of your leaders.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35806,'Your prowess, your might, and your cunning will be under close watch. These games will determine the best Azeroth has to offer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35807,'The victors will take their rightful place in the assault upon the Citadel. We will stand together in the face of evil, and Arthas WILL fall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35808,'','%s sifts through the recovered treasures until something catches her eye.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35809,'','Ah! This ring will do nicely...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35810,'His Majesty, King Varian Wrynn, and Lady Jaina Proudmoore have touched down upon the tournament grounds! Make way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35811,'The Warchief of the Horde, Thrall, and Overlord Garrosh Hellscream have arrived upon the tournament grounds! Clear the way to the entrance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35812,'Highlord Tirion Fordring approaches the stage to address those gathered upon the tournament grounds! Make way to the stage area to attend him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35813,'Keep him asleep, that\'s it. No need to wake him before it\'s time.','Keep him asleep, that\'s it. No need to wake him before it\'s time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35814,'The wind fiercely cuts across this bluff, and most life has long since fled this corner of Icecrown. However, all it takes is a bit of coaxing for it to return, and that is why I walk these grounds. One day these trees will tower over us all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35815,'I, Wilfred Fizzlebang, have been invited to this quaint tournament to make use of my extensive knowledge of the summoning arts. What better choice?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35816,'Soon all the world will know the name of Wilfred!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35817,'It won\'t be long before Fizzlebang is a household word, used to scare children into bed! \"Beware, or Fizzlebang will summon a mighty demon to eat you!\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35818,'Of course I was the one chosen to summon a demon for the competitors. I am Wilfred Fizzlebang, master summoner! Demons quail before the mere thought of being under my will!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35819,'','Fools! Did you think our master blind? Did you think we did not know of this intrusion? Our elder sisters come, and there will be no escape from their wrath!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35820,'','Our sisters have been captured! Fall back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35821,'What\'s that, to the southeast?','What\'s that, to the southeast?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35822,'Val\'kyr! Take cover!','Val\'kyr! Take cover!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35823,'Protect the innocent!','Protect the innocent!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35824,'Look! Frostwyrms, to the south!','Look! Frostwyrms, to the south!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35825,'On your guard!','On your guard!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35826,'Attack!','Attack!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35827,'Attack!','Attack!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35828,'The Val\'kyr are attacking! Take cover!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35829,'\'Ware the grounds! Frostwyrms are attacking!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35830,'Gormok will be free, runts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35831,'Free me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35832,'RAAAAGH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35833,'NO! My servants!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35834,'','The Gumps are letting me help them run their shop! I just love flowers.$B$B<Little Adeline suddenly squints at you, looking very serious.>$B$BDo you like flowers?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35835,'Yes I do!','Yes I do!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35836,'','I ain\'t \'fraid of no ghost!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35837,'','Surveyor? I hardly know her! Hah HAH!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35838,'','Don\'t botch this - I\'m angling for Sr. Grade by the end of the year.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35839,'','Let\'s do this thing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35840,'The magnataur are not as stupid as they appear. Keeping Gormok until his time is a difficult task, but he is bound tightly enough that there is no danger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35841,'I tend these creatures of Gormok as he cannot. I do not fully agree with this slaughter, but at the least he will have his chance to fight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35842,'The yeti is a fierce, cunning creature, and this one is one of the strongest of his kind. We keep him asleep through herbs in his food.$b$bDo not think he will be lethargic in the ring, however.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35843,'We have been tending these worms for some time. I hope they will be fit in time for the ring event of this organization. You must face not one, but two jormungar, after all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35844,'We may operate in the shadows of polite society, but out here on the battlefront our powers are properly respected at last.','We may operate in the shadows of polite society, but out here on the battlefront our powers are properly respected at last.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35845,'You! Yes, you!$b$bGaze upon me and treasure this moment of meeting, for soon the world will come to know and fear the name and stern visage of Wilfred Fizzlebang! Once my magnificent summoning is complete, no one will doubt my ability!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35846,'','Watch my back, I need to concentrate on this...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35847,'','There\'s the survey marker!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35848,'','Here we go - keep those things off of me while I work!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35849,'','I got it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35850,'|TInterface\\Icons\\Spell_Shadow_Darkritual.blp:36|tYou have Empowered Darkness!','|TInterface\\Icons\\Spell_Shadow_Darkritual.blp:36|tYou have Empowered Darkness!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35851,'|TInterface\\Icons\\Spell_Holy_Searinglightpriest.blp:36|tYou have Empowered Light!','|TInterface\\Icons\\Spell_Holy_Searinglightpriest.blp:36|tYou have Empowered Light!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35852,'Success! You have your Personal Riches!$B$B|TInterface\\Icons\\INV_Misc_coin_02.blp:64|t','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(35853,'Stand your ground, men!','Stand your ground, men!',0,0,0,0,0,0,0,0,1,8678,0,0,26124),
(35854,'Wh-what is that thing!!','Wh-what is that thing!!',0,0,0,0,0,0,0,0,1,8678,0,0,26124),
(35855,'I - I think there\'s someone INSIDE that thing!','I - I think there\'s someone INSIDE that thing!',0,0,0,0,0,0,0,0,1,8678,0,0,26124),
(35856,'Stay out of its way! It\'ll burn you alive!','Stay out of its way! It\'ll burn you alive!',0,0,0,0,0,0,0,0,1,8678,0,0,26124),
(35857,'Protect Nijel\'s Point with your lives!','Protect Nijel\'s Point with your lives!',0,0,0,0,0,0,0,0,1,8678,0,0,26124),
(35858,'Leave ... this ... place ...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35859,'These grounds ... are not ... yours ...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35860,'Turn ... back ...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35861,'The first challenge requires you to be mounted on an Argent Warhorses.  You will find these mounts along the walls of this coliseum.$b$bPlease, mount the warhorse, speak to me, and then we can proceed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35862,'','That\'s how it\'s done!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35863,'','I\'ll never make Sr. Grade at this rate...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35864,'','I\'m going to put in for hazard pay.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35865,'','...and stay dead!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35866,'I... I lost control of the mines!$B$BPlease, $g sir : ma\'am;, don\'t fire me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35867,'$n pops open the engine hatch and mucks around with the machine\'s innards...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35868,'%s shudders as piles of green sludge ooze out of the exhaust pipes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35869,'Queue for Wintergrasp.','Queue for Wintergrasp.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(35870,'','You see the world through Kalytha\'s eyes...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35871,'The champions of the world\'s great nations have gathered at the Argent Tournament Grounds in northeastern Icecrown to face all challengers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35872,'Hello. By odd twist of fortune, we have obtained the remains of Kel\'Thuzad\'s feared abomination Patchwerk.  Our researchers are able to reassemble them in various ways to test the mettle of your band of would-be heroes, should you so desire.  \n\nWe can construct a sturdy Patchwerk against which to measure your ability to do damage, a brutal Patchwerk who will deliver rapid and mighty blows to any who would dare stand before him, or a well-rounded Patchwerk who will test your entire fighting force.\n\nWhich would you prefer?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35873,'I want to test our damage-dealers.','I want to test our damage-dealers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35874,'I want to test our tanks.','I want to test our tanks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35875,'No more play.','No more play.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35876,'Good day, $n.  If you require my services as an auctioneer, I regret to inform you: no.  Only grand master engineers possess the minimum intellectual capacity to interface with my superior functions.$b$bMore importantly, why are you still talking to me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35877,'What\'s on the auction house today?','What\'s on the auction house today?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35878,'We mustn\'t allow them through!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35879,'More? Where are they all coming from!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35880,'Stop them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35881,'They\'re storming the walls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35882,'We\'re being overrun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35883,'Hold them off - just hold them off. The Archmage has a plan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35884,'Kalytha - you\'re still alive! Find some cover, there\'s no end to these ... things!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35885,'Am I still bleeding? I can\'t ... I can\'t keep this up much longer. Have you seen any of the archmages?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35886,'Hmph. I suppose these are the consequences of magic. You reap what you sew ... Elune help us all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35887,'Kalytha! Archmage Selwyn was looking for you. She should be nearby...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35888,'These creatures ... so many of them. So many dead! Look at Azshara burn. What have the highborne done?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35889,'Why didn\'t I flee with the others? They\'ve got the academy surrounded. We\'re trapped here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35890,'','I\'ve got to keep the arcane wards charged.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35891,'','My strength ... is beginning ... to falter. Kalytha, please tell me the Archmages have a backup plan...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35892,'','I can\'t maintain this shield much longer. Kalytha - are any of us going to survive this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35893,'','More of these creatures! Where are they coming from? What\'s going on in the capital?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35894,'','Kalytha! Hurry - Archmage Selwyn wanted to see you, she said it was urgent. Maybe we can win this thing?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35895,'','It\'s all I can do to keep these wards up. Find one of the Archmages, Kalytha! I feel like I\'m about to collapse...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35896,'The Argent Crusade invites you to test your skills in honorable combat against other heroes of Azeroth at the Argent Tournament.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35897,'','Kalytha ... it is done. The Sarcen Stone is fully charged and is already diverting energy from the portal. Are you still the incredible swimmer I knew those many years ago? The stone must not be found by either the demons or our \"beloved\" Queen.$B$BSwim to the bottom of the lake, Kalytha, and bury the stone deep under the center arch. Hopefully the demonic invaders will not discover it when they raze the surrounding temple. Go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35898,'Yes Archmage. I will hide the stone.','Yes Archmage. I will hide the stone.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35902,'','<The shimmering vision does not acknowledge your presence. She is lost in her own world, reacting to events that played out thousands of years ago.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35903,'<Merge with the spirit.>','<Merge with the spirit.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35904,'I will join in the assault upon Icecrown Citadel when the time to strike is upon us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35905,'Arms ready!  Here they come!  HERE THEY COME!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35906,'All you slaves better step it up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35907,'You! Yes, you! Get back to work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35908,'Don\'t make me come in there with my brutes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35909,'I swear you trolls are the worst batch of workers we\'ve ever had!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35910,'Do I have to come in there and show you how it\'s done?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35911,'Worthless! You\'re all just worthless! I\'m afraid we\'re going to have dump you all into the Maelstrom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35912,'TIME IS MONEY, TROLLS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35913,'It\'s back to the Undermine with the lot of you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35914,'You mooks be on the lookout for any looters. Treat them with extreme prejudice!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35915,'I see great profit possibility on the horizon. All of Bilgewater Port\'s assets are about to flow to me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35916,'It doesn\'t matter that Mount Kajaro has blown. All that matters is that I stay on top!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35917,'You brutes make sure that my number one executive doesn\'t get anywhere near the villa.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35918,'Ready my yacht! We ride with the tide and only the most wealthy and fit will be welcome to come with us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35919,'We shall sail for distant Azshara. There, I will forge a new trade empire. One that will crush the Steamwheedle Cartel! And I shall carve my likeness upon that distant land\'s mountains. All will pay tribute to me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35920,'Next please!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35921,'Hello. Would you like to fight the Faction Champions encounter for the Argent Colosseum raid? \n\nYou will face the version of this encounter that corresponds to the current raid difficulty you have selected. This encounter is a work in progress. Please be sure to report any bugs you experience on the Blizzard forums.\n\nAre you ready to begin the encounter?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35922,'Greetings, $c.$B$BThe Horde currently control Wintergrasp Fortress.  When the battle is about to begin, talk to me to enter the battle.$B$B','Greetings, $c.$B$BThe Horde currently control Wintergrasp Fortress.  When the battle is about to begin, talk to me to enter the battle.$B$B',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35923,'Hear me, invaders of Desolace! The Burning Blade shall use you all as sacrifices!','Hear me, invaders of Desolace! The Burning Blade shall use you all as sacrifices!',0,0,0,0,0,0,0,0,1,8689,0,0,26124),
(35924,'Greetings, $c.$B$BThe Horde currently control Wintergrasp Fortress, but the battle has begun.  Hurry to Wintergrasp and support our forces!','Greetings, $c.$B$BThe Horde currently control Wintergrasp Fortress, but the battle has begun.  Hurry to Wintergrasp and support our forces!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35925,'The time is nearly here! We shall sweep across this land, sacrificing all who defy us!','The time is nearly here! We shall sweep across this land, sacrificing all who defy us!',0,0,0,0,0,0,0,0,1,8689,0,0,26124),
(35926,'With the help of the Burning Blade, demons shall rule all of Azeroth!','With the help of the Burning Blade, demons shall rule all of Azeroth!',0,0,0,0,0,0,0,0,1,8689,0,0,26124),
(35927,'Bring on any opposition! The Burning Blade shall make a feast of your soul!','Bring on any opposition! The Burning Blade shall make a feast of your soul!',0,0,0,0,0,0,0,0,1,8689,0,0,26124),
(35928,'All of Azeroth, prepare! The age of the Burning Blade is nigh!','All of Azeroth, prepare! The age of the Burning Blade is nigh!',0,0,0,0,0,0,0,0,1,8689,0,0,26124),
(35929,'Invaders of Desolace, come join the Burning Blade or suffer the consequences of defiance!','Invaders of Desolace, come join the Burning Blade or suffer the consequences of defiance!',0,0,0,0,0,0,0,0,1,8689,0,0,26124),
(35930,'Hello. Would you like to fight the Val\'kyr encounter for the Argent Colosseum raid? \n\nYou will face the version of this encounter that corresponds to the current raid difficulty you have selected. This encounter is a work in progress. Please be sure to report any bugs you experience on the Blizzard forums.\n\nAre you ready to begin the encounter?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35931,'Muahhaah! You are far too late. The summoning of your doom is nearly complete!','Muahhaah! You are far too late. The summoning of your doom is nearly complete!',0,0,0,0,0,0,0,0,1,8689,0,0,26124),
(35932,'Hello. Would you like to fight the Anub\'arak encounter for the Argent Colosseum raid? \n\nYou will face the version of this encounter that corresponds to the current raid difficulty you have selected. This encounter is a work in progress. Please be sure to report any bugs you experience on the Blizzard forums.\n\nAre you ready to begin the encounter?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35933,'Greetings, $c.$B$BThe Alliance currently control Wintergrasp Fortress, but the battle has begun!  Hurry to Wintergrasp and support our forces!','Greetings, $c.$B$BThe Alliance currently control Wintergrasp Fortress, but the battle has begun!  Hurry to Wintergrasp and support our forces!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35934,'Greetings, $c.$B$BThe Alliance currently control Wintergrasp Fortress.  When the battle is about to begin, talk to me to enter the battle.$B$B','Greetings, $c.$B$BThe Alliance currently control Wintergrasp Fortress.  When the battle is about to begin, talk to me to enter the battle.$B$B',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35935,'Queue for Wintergrasp.','Queue for Wintergrasp.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(35936,'Good day, $gsir:madam;!  How may I be of assistance?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35938,'This tear in the fabric of time and space looks ominous.  Different scenes flash by at terrifying speed.  A very brave person might try to jump through at the right time...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35939,'Borean Tundra','Borean Tundra',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35940,'Sholazar Basin','Sholazar Basin',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35941,'Icecrown','Icecrown',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35942,'Storm Peaks','Storm Peaks',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35943,'Howling Fjord','Howling Fjord',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35944,'Fool! You shall pay dearly for your interference!','',0,0,0,0,0,0,0,0,1,8690,0,0,26124),
(35945,'%s sighs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35946,'It is not safe out here, $n.  Seek shelter before it\'s too late.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35947,'Hello there, $n. So nice of you to rescue me. No hard feelings, right?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35948,'%s says: Look out! He\'s gonna blow!','',0,0,0,0,0,0,0,36,1,0,0,0,26124),
(35950,'Somone stop that ghoul!','',0,0,0,0,0,0,0,36,1,0,0,0,26124),
(35952,'That had to hurt! Brains!','',0,0,0,0,0,0,0,36,1,0,0,0,26124),
(35953,'','Marooned! Blasted to bits by the Alliance and stranded on some island in the middle of who-knows-where?!$B$BBusiness as usual, right, $n?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35954,'What a Brains shot!','',0,0,0,0,0,0,0,36,1,0,0,0,26124),
(35955,'Greetings, $c.$B$BThe Horde currently control Wintergrasp Fortress, but the next battle starts soon.   Get ready to head to Wintergrasp and support our forces!$B$BThe next battle begins in $4354k.','Greetings, $c.$B$BThe Horde currently control Wintergrasp Fortress, but the next battle starts soon.   Get ready to head to Wintergrasp and support our forces!$B$BThe next battle begins in $4354k.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35956,'Greetings, $c.$B$BThe Alliance currently control Wintergrasp Fortress, but the next battle starts soon.   Get ready to head to Wintergrasp and support our forces!$B$BThe next battle begins in $4354k.','Greetings, $c.$B$BThe Alliance currently control Wintergrasp Fortress, but the next battle starts soon.   Get ready to head to Wintergrasp and support our forces!$B$BThe next battle begins in $4354k.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35957,'$n is trampled!','$n is trampled!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35958,'Greetings, $c.$b$bLook around you. Have you stopped to ponder what all of this means?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35959,'','Justicar Mariel Trueheart has asked us to see to the needs of the tournament. Those who have earned the right to stand as champions and who have proven themselves in our eyes are asked to assist with these duties.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35960,'','Justicar Mariel Trueheart has entrusted us with the duty of overseeing many of the tournament\'s affairs. Unfortunately, she tasked the Sunreavers with the same duty, which means we must work twice as hard to solve the problems created by those fools!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35961,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35962,'Sabotage! I\'m ruined....$b$bWhoever\'s behind this will pay! I promise you that....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35963,'$n? $G Sir : Ma\'am;, you\'re not a hunter, you\'re a $c.','$n? $G Sir : Ma\'am;, you\'re not a hunter, you\'re a $c.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(35964,'Oh, you and I are going to have a great time. I have so much to teach you about the ways of the hunter.','Oh, you and I are going to have a great time. I have so much to teach you about the ways of the hunter.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35965,'We need you, $n!  There are worgen everywhere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35966,'It\'s just horrible. I think they\'re all dead.$B$BHow will I get the kaja\'mite out of there now?','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(35967,'Rargh! Not another one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35968,'%s emerges from the ground!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35969,'Leave Balboa alone you shiny gnats!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35970,'Who did that?! Stop it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35971,'No more! I no like that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35972,'','The whispering winds have made it known to me that a $r $c would come; that $ghe:she; would assist me where many others have failed.$b$bCould you be the one?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35973,'I am ready to be shown this threat you speak of, Korrah.','I am ready to be shown this threat you speak of, Korrah.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35974,'I can\'t offer you any training, $n, but I sure could use your help against these damn monkeys!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(35975,'There\'s my favorite warlock! What dark secret can I whisper in your ear today?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(35976,'Hey there, $g Mr. : Ms.; $n. I can\'t train you in the ways of magic, but all of this finger-waggling means that I can give a mean neck massage.','Hey there, $g Mr. : Ms.; $n. I can\'t train you in the ways of magic, but all of this finger-waggling means that I can give a mean neck massage.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35977,'If you\'ll excuse me, I\'m afraid I have other business I must attend to.  Please call on me again in the future.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35978,'What a wonderful day for some training in the mystical arts. Wouldn\'t you agree, $g Mr. : Ms.; $n?','What a wonderful day for some training in the mystical arts. Wouldn\'t you agree, $g Mr. : Ms.; $n?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35979,'Let me give you a moment to get our opponents ready for battle.','Let me give you a moment to get our opponents ready for battle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35980,'You\'re doing a great job, $g Mr. : Ms.; $n. Keep up the good work.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35981,'I see such a bright future for you, my $g boy : girl;! What shall I teach you today?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35982,'','Shipwrecked on an island infested with bomb-throwing monkeys? What\'s next... is there a volcano that\'s going to blow?!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(35983,'','We\'re... er, I mean the Light, is going to need a lot of gold, now more than ever.$B$BSpeaking of which, do you need any training?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35984,'','You can see me? How can you see me, boss?$B$BI\'m going to have to work on that.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(35985,'','Training, massages, whatever you need, boss. Just don\'t forget me when you\'re the new Trade $g Prince : Princess;!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35986,'That warlock certainly didn\'t summon a Doomguard! Your next challenge will find you fighting knights of the Argent Crusade. Think you\'re up for the challenge?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(35987,'Of course!','Of course!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35988,'Well then, I\'ll give the signal to Tirion when you are ready to go.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35989,'Give the signal! We\'re ready to go!','Give the signal! We\'re ready to go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35990,'That fight was savage and brutal. I haven\'t seen a grand melee like that in many years! Amazing!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(35991,'You\'ll be even more amazed after we take them out!','You\'ll be even more amazed after we take them out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35992,'I can\'t wait to see it! They seem ready for another round now, so prepare yourselves!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(35993,'We\'re ready for anything!','We\'re ready for anything!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35994,'The swoop egg is destroyed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35995,'Okay, here we go. You\'re gonna cover me, right?','Okay, here we go. You\'re gonna cover me, right?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35996,'','The number of naga here continue to rise steadily....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35997,'','The cataclysm split the land apart here, allowing the naga to stretch inland...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35998,'','A priestess of Azshara! Could she be leading their efforts?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(35999,'','They are scouring the entire region. We must discover what it is that they seek!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36000,'','The water itself rises to fight against them here, but why? Many questions and few answers...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36001,'','Return to me now, $c. There is much to do.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36002,'I thought you were going to keep these things off of me?','I thought you were going to keep these things off of me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36003,'How can I get my mining done if I\'m being attacked?','How can I get my mining done if I\'m being attacked?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36004,'We\'re going to die in here like all the others, aren\'t we?','We\'re going to die in here like all the others, aren\'t we?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36005,'I want to go home now.','I want to go home now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36006,'They\'re not paying me enough for this. Wait! They\'re not paying me at all!','They\'re not paying me enough for this. Wait! They\'re not paying me at all!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36007,'I\'m here to mine, you\'re here to fight. Get it straight!','I\'m here to mine, you\'re here to fight. Get it straight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36008,'These cave paintings are creeping me out. NOT TO MENTION THE MONKEYS TRYING TO KILL ME!','These cave paintings are creeping me out. NOT TO MENTION THE MONKEYS TRYING TO KILL ME!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36009,'I\'m certain that the kaja\'mite is having the same intelligence-increasing effect on the monkeys that it had on our ancient ancestors.','I\'m certain that the kaja\'mite is having the same intelligence-increasing effect on the monkeys that it had on our ancient ancestors.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36010,'Let\'s move on.','Let\'s move on.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36011,'This chunk\'s been picked clean.','This chunk\'s been picked clean.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36012,'I can\'t get anything else out of this one.','I can\'t get anything else out of this one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36013,'We\'ve hit the jackpot in this place!','We\'ve hit the jackpot in this place!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36014,'Did I ever tell you that I was a mid-level accountant with the company back on Kezan? I worked for you for years. Do you even know my name?','Did I ever tell you that I was a mid-level accountant with the company back on Kezan? I worked for you for years. Do you even know my name?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36015,'The monkeys already extracted most of the kaja\'mite out of this deposit.','The monkeys already extracted most of the kaja\'mite out of this deposit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36016,'What I wouldn\'t give for some explosives right about now.','What I wouldn\'t give for some explosives right about now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36017,'Hey, why am I doing all of the work here?','Hey, why am I doing all of the work here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36018,'That\'s good enough for now. I\'ll make my way out on my own. Thanks for the escort, $n.','That\'s good enough for now. I\'ll make my way out on my own. Thanks for the escort, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36019,'We suffered a lot of casualties when capturing your next challenge!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(36020,'Er, Dampwick, I need another miner....','Er, Dampwick, I need another miner....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36021,'%s roars at the sight of the surviving beasts and fights with renewed vigor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36022,'Underground...','Underground...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36023,'The Val\'kyrs\'  teamwork is rather astounding. I now see why we had such problems capturing the two of them.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36024,'That tough, huh?','That tough, huh?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36025,'We\'ll just have to improve our own teamwork to match the two of them.','We\'ll just have to improve our own teamwork to match the two of them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36026,'You better believe it! You\'re going to face two of Arthas\' most powerful Val\'kyr lieutenants!','',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(36027,'Val\'kyr? We\'re ready for them.','Val\'kyr? We\'re ready for them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36028,'Well I hope you improve quickly!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36029,'Just bring them out again, then watch.','Just bring them out again, then watch.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36030,'Mortar strike called in. Let \'em have it, Hackel!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36031,'%s realizes he needs some Leggings of the Fang.','%s realizes he needs some Leggings of the Fang.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36032,'%s daydreams of Lucky Fishing Hats.','%s daydreams of Lucky Fishing Hats.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36033,'','The tournament\'s seneschal has asked us to shoulder some of the burden of running the competition now that the coliseum is finished. Those who have earned the right to stand as champions and who have proven themselves in our eyes are asked to assist with these duties.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36034,'%s bemoans the loss of his Nethercleft Leg Armor.','%s bemoans the loss of his Nethercleft Leg Armor.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36035,'','Justicar Mariel Trueheart has asked us to help administer and defend the tournament now that the coliseum is complete. She wants us to work with those worthless Silver Covenant curs, but they\'re just getting in the way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36036,'%s plans a Stranglethorn Vale fishing trip.','%s plans a Stranglethorn Vale fishing trip.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36037,'It\'s coming right for me!','It\'s coming right for me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36038,'Help me, please!','Help me, please!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36039,'There\'s one after me!','There\'s one after me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36040,'Help!','Help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36041,'I don\'t want to die!','I don\'t want to die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36042,'When I trained as a guard in Orgrimmar, Thrall urged us to be patient and cautious when dealing with enemies.$B$BBut Naga threaten to overrun this peninsula, and Thrall is no longer my Warchief. The time has come to shed some blood, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36043,'','Why are you interrupting my work here?! Explain yourself!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36044,'','You\'d better have good reason to approach me, minnow!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36045,'','What\'s this? What do you want with me, minnow?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36046,'Splendid, you\'ve proven yourselves as great champions here today. With you fighting alongside the Argent Crusade, victory against the Scourge is inevitable!','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(36047,'Your words of praise are appreciated, Coliseum Master.','Your words of praise are appreciated, Coliseum Master.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36048,'The praise is well deserved. Tirion will want to praise you himself, shortly. Hey, have you noticed it getting a bit cold all of a sudden?','',1,1,6,0,0,0,0,0,1,0,0,0,26124),
(36049,'That is strange... ','That is strange...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36050,'You will pay for disturbing us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36051,'I\'ll silence that infernal drum once and for all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36052,'What do you think you\'re doing, fool?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36053,'No one provokes the servants of Loken and gets away with it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36054,'Keep that sword arm straight, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36055,'You\'re not a warrior!  You\'d better go back inside the perimeter to where it\'s safe... no offense.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36056,'My humblest apologies, Champion, but you have run out of opportunities to complete the Trial of the Grand Crusader. As a reminder, you and your fellow adventurers are able to begin the Trial of the Grand Crusader once every week. May the lessons learned this week bring you one step closer to final victory here and against the Scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36057,'','Your efforts here shall not be forgotten, $n! I shall make certain of that.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36058,'','You are not initiated in the old ways.  There is nothing I can teach you, child.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(36059,'','The worgen will pass.  We shall pass.$B$BOnly the earth and her secrets will remain.  Are you willing to learn, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36060,'I seek further training in the old ways of the druids.','I seek further training in the old ways of the druids.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36061,'The last batch of orcs. They should fall quickly!','The last batch of orcs. They should fall quickly!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36062,'Die, orc scum!','Die, orc scum!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36063,'First these orcs and then those pathetic goblins down on the shore.','First these orcs and then those pathetic goblins down on the shore.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36064,'Kill them all!','Kill them all!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36065,'We\'ll get through this, $n.  We\'ll be wearing these beasts\' pelts when we\'re done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36066,'Be very, very quiet.  There\'s worgen everywhere.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36067,'I seek further training.','I seek further training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36068,'','Of course, I will share my knowledge with you.  Especially if it helps us defeat the worgen.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36069,'','I\'d have a hard time teaching you.  It takes years of mental preparation to become attuned to the powers of the arcane.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36070,'','Ask me for help and advice... just don\'t ask me for money, okay?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36071,'','I swear this wasn\'t my fault.  Why are you looking at me like that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36072,'','Even now, in the darkest of times, the teachings of the Light will guide you throught this world.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36073,'','The Light is with you, $c.  No harm will come to you today.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36074,'I think that we might have angered them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36075,'I will gladly share my forbidden knowledge with you in this time of great peril.  The darkness will protect us, $gbrother : sister;.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36076,'Even the most superficial glimpse into the secrets I hold would drive you mad, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36077,'Yes, fleshling?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36078,'Rescue Krennan Aranas by using your vehicle\'s ability.$B|TInterface\\Icons\\inv_misc_groupneedmore.blp:64|t','Rescue Krennan Aranas by using your vehicle\'s ability.$B|TInterface\\Icons\\inv_misc_groupneedmore.blp:64|t',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36079,'I am prepared to join you in battle, Hydronis!','I am prepared to join you in battle, Hydronis!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36080,'Welcome, champion! Have you gathered your forces in preparation for the challenges of the Trial of the Grand Crusader? Only the most powerful and accomplished of combatants are able to participate in these trials. To participate in these trials, you must have completed the normal Trial of the Crusader.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(36082,'I have completed the Trial of the Crusader.','I have completed the Trial of the Crusader.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36083,'I have not completed the Trial of the Crusader.','I have not completed the Trial of the Crusader.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36084,'Come back again when you have achieved success in the Trial of the Crusader.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36085,'The Trial of the Grand Crusader is a more difficult version of the Trial of the Crusader. Each encounter is more difficult, and you will not be able to freely attempt the encounters until you win. After 50 unsuccessful attempts, the Trial of the Grand Crusader will end for the week. After successfully completing the Trial of the Grand Crusader, you will receive an additional tribute chest of rewards as compensation. Are you prepared for this trial?','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(36086,'My apologies, adventurer. The grand warlock Wilfred Fizzlebang has not arrived on the tournament grounds yet, so the next challenge of the trial is not available. We expect him next week.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36087,'Delays, delays, and more delays. The Trial of the Crusader has currently been placed on hold, pending the results of an investigation into the actions of Wilfred Fizzlebang. Next week the trial will continue, so be ready to fight the best knights of the Argent Crusade!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36088,'We dispatched a force of knights to capture a pair of Arthas\' Scourge lieutenants to serve as the next challenge of the trial. The knights have not returned with their prey yet, so the next phase of the trial is on hold. Check back next week.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36089,'That was simply spendid! Unbelievable! Well done! We already have plans in motion to celebrate your victory. Our preperations will be finished next week, see you then!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36090,'Hold the barricades!  Do not give them an inch!','',0,0,0,0,0,0,0,0,1,0,19709,0,26124),
(36091,'Fire!','',0,0,0,0,0,0,0,0,1,0,19710,0,26124),
(36092,'Keep them back!','',0,0,0,0,0,0,0,0,1,0,19712,0,26124),
(36093,'','The plan is to keep moving south.  We can\'t go back to the Merchant Square.  It\'s not safe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36094,'','We must stick together to survive.  Move around in groups.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36095,'','The king\'s men will protect us.  We\'re almost there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36096,'','You shall pay for what what you\'ve done to my minnows, fool!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36097,'<Kilag motions you to keep your voice down.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36098,'','%s hisses with horror and rage!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36099,'We\'ve got Aranas!  Fire at will!','',0,0,0,0,0,0,0,0,1,0,19634,0,26124),
(36100,'','You cannot save... Neptulon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36101,'','%s emits a piercing scream as her power dissipates!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36102,'Whoa! What\'s with all of the cave paintings? Ack, do I hear monkeys?!','Whoa! What\'s with all of the cave paintings? Ack, do I hear monkeys?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36103,'We need to keep the worgen\'s attention in the city, Genn.  It\'s the only shot we have for the survivors to make it to Duskhaven.','',0,0,0,0,0,0,0,0,1,0,19507,0,26124),
(36104,'Not a chance, boy.  Gilneas is going to need its king\'s undivided attention.  Can\'t have your father wondering whether his child is alive or not.','',0,0,0,0,0,0,0,0,1,0,19508,0,26124),
(36105,'My men and I will hole up inside the Light\'s Dawn Cathedral.  I\'ve already given the order and the cannons are on their way.  Lead our people well, Genn.','',0,0,0,0,0,0,0,0,1,0,19509,0,26124),
(36106,'I\'ll stay behind with the Royal Guard, father.  It is my duty to Gilneas.','',0,0,0,0,0,0,0,0,1,0,19622,0,26124),
(36107,'If we can make it past the gates into Duskhaven we\'ll be safe.  The eastern mountains are virtually impassable.','',0,0,0,0,0,0,0,0,1,0,19719,0,26124),
(36108,'We were fools to take up arms against each other, Darius.  The worgen would\'ve never stood a chance.','',0,0,0,0,0,0,0,0,1,0,19720,0,26124),
(36109,'We will move ahead, Kilag.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36110,'$n has cleared a path. We will go ahead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36111,'Do not wait long, Kilag. We will scout ahead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36112,'Goblin technology is strange and deadly. I approve!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36113,'We will scout ahead to the Wild Overlook and see you there, Kilag.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36114,'Be wary. There are deadlier things in this jungle than these plants!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36115,'Time to go. I hope that we will meet again, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36116,'We should move now.  See you at the Wild Overlook.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36117,'The goggles! They do nothing!','The goggles! They do nothing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36118,'Fire ... FIRE!','Fire ... FIRE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36119,'Again with the flames and the hurt.','Again with the flames and the hurt.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36120,'This whole place is gonna blow!','This whole place is gonna blow!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36121,'This is one of our less productive colossal disasters.','This is one of our less productive colossal disasters.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36122,'I\'m on fire. Note that in the logs!','I\'m on fire. Note that in the logs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36123,'My flesh!','My flesh!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36124,'Stand ready, guards!  We don\'t know how many intruders we\'re dealing with, but the Headlands are overrun and we\'re cut off from the harbor towns.  Expect to be outnumbered.','',0,0,0,0,0,0,0,0,1,0,19614,0,26124),
(36125,'I want the perimeter secured and the gates manned by two guards at all times.  No one gets in, no one gets out.','',0,0,0,0,0,0,0,0,1,0,19615,0,26124),
(36126,'We protected Gilneas from the Scourge.  We protected Gilneas during the Northgate rebellion.  We will protect Gilneas from whatever this new threat may be.','',0,0,0,0,0,0,0,0,1,0,19616,0,26124),
(36127,'I\'m leaving for the next rendezvous point in a few seconds.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36128,'Thank you, thank you!','Thank you, thank you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36129,'Champions, you\'re alive! Not only have you defeated every challenge of the Trial of the Crusader, but also thwarted Arthas\' plans! Your skill and cunning will prove to be a powerful weapon against the Scourge. Well done! Allow one of the Crusade\'s mages to transport you to the surface!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36130,'Whew, thanks! I\'m going to check and see if these results are repeatable.','Whew, thanks! I\'m going to check and see if these results are repeatable.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36131,'I should really try to burst into flames less often.','I should really try to burst into flames less often.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36132,'Make a note: Fire bad.','Make a note: Fire bad.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36133,'Hurry - save the others!','Hurry - save the others!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36134,'Champions, you\'ve defeated the Trial of the Grand Crusader! Only the most battle tested adventurers could ever hope to complete this Trial. I present to you this tribute chest as a well deserved reward! May the contents serve you well in our upcoming campaign against Arthas in the heart of Icecrown Citadel!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36135,'Now that you have completed the Trial of the Crusader, you should consider returning to take part in the Trial of the Grand Crusader. Only the strongest adventurers can hope to complete the Trial, but you will be rewarded well for your efforts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36136,'I\'m gonna go find some ointment.','I\'m gonna go find some ointment.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36137,'That wasn\'t as bad as it looked.','That wasn\'t as bad as it looked.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36139,'In coming here, you have made a grave mistake. These tournament grounds are a bastion of the Light, and your power cannot match it.','In coming here, you have made a grave mistake. These tournament grounds are a bastion of the Light, and your power cannot match it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36140,'I am sorry, but you do not belong here, and you cannot be allowed to harm the innocents on the grounds.','I am sorry, but you do not belong here, and you cannot be allowed to harm the innocents on the grounds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36141,'Congratulations, please take the portal to Dalaran when you\'re ready!','',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(36142,'The quantity and quality of rewards inside the tribute chest is based upon how many unsuccessful attempts you had during the Trial of the Grand Crusader. The fewer unsuccessful attempts, the better the rewards.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36143,'I wish to unlearn my Gnomish Engineering specialization!','I wish to unlearn my Gnomish Engineering specialization!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36144,'Do you really want to unlearn your Gnomish Engineering specialization and lose all associated recipes?','Do you really want to unlearn your Gnomish Engineering specialization and lose all associated recipes?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36145,'Do you really want to unlearn your Goblin Engineering specialization and lose all associated recipes?','Do you really want to unlearn your Goblin Engineering specialization and lose all associated recipes?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36146,'I wish to unlearn my Goblin Engineering specialization!','I wish to unlearn my Goblin Engineering specialization!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36147,'Upon seeing its companion perish, %s becomes enraged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36148,'Kilag, I... uh, somehow... er, lost my scout.','Kilag, I... uh, somehow... er, lost my scout.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36149,'You two be more careful! There are only so many of us!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(36150,'What?! You think I\'m made out of miners?$B$BHow bad can it be in there?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(36151,'Once more I apologize, but you chose this fate.','Once more I apologize, but you chose this fate.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36152,'','Do you see the gyrochoppa on the far side of the beach, $n?!',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(36153,'Get the keys and then get to that gyrochoppa!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36154,'','This cannot be!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36155,'','We will have vengeance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36156,'WARNING: Reactor Core Flushed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36157,'Hey! Get away from my flying machine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36158,'Don\'t forget to keep your goggles on, $n. That\'s the only way we\'ll spot them before they can jump us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36159,'We must push little cart!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36160,'Get to the gyrochoppa! Do it now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36161,'','Ah, you did it! Excellent work.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36162,'Wow - is that refined Azsharite?','Wow - is that refined Azsharite?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36163,'I never thought I\'d see such a pure sample.','I never thought I\'d see such a pure sample.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36164,'I have been shown the future, $r.$b$bCentaur lands will be forever corrupted if we fail to act quickly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36165,'I am ready to do battle with the Magram clan!','I am ready to do battle with the Magram clan!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36166,'Now, $r! Place the spear!','',0,0,0,0,0,0,0,0,1,8745,0,0,26124),
(36167,'The Azsharite Core momentarily cools off.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36168,'Bleh! Clearly built by gnomes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36169,'Hop in and take off!','Hop in and take off!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36170,'The Azsharite Core is Overheating - use the Fireliminator to cool it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36171,'Azsharite Core at 60 percent integrity...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36172,'The Azsharite Core is dangerously close to overheating.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36173,'The Azsharite Core is about to go critical!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36174,'Hurry! Before we\'re discovered!','',0,0,0,0,0,0,0,0,1,8745,0,0,26124),
(36175,'You failed to plant the spear! We must make another attempt... soon!','',0,0,0,0,0,0,0,0,1,8745,0,0,26124),
(36176,'%s goes critical!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36177,'Find the Precious Cargo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36178,'Kolkar clan! Attack!!','',0,0,0,0,0,0,0,0,1,8745,0,0,26124),
(36179,'A goblin? I must be seeing things. Throm-Ka and thank you, little one!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(36180,'Give the orc warchief some smelling salts to rouse him from his drugged stuppor.','Give the orc warchief some smelling salts to rouse him from his drugged stuppor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36181,'That seems to have done the trick.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36182,'A goblin? I must be seeing things. Throm-Ka and thank you, little one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36184,'The Spear of the Kolkar Khan has been broken...','',0,0,0,0,0,0,0,0,1,8745,0,0,26124),
(36185,'Retreat!!','',0,0,0,0,0,0,0,0,1,8745,0,0,26124),
(36186,'The spear is broken! Retreat!','',0,0,0,0,0,0,0,0,1,8745,0,0,26124),
(36187,'Enough! What is this about?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36188,'$n, sit on down. The fire\'s warm and the monkeys don\'t seem to like it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36189,'Who would\'ve thought we\'d wind up here after everything we\'ve been through?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36190,'Hey, look guys, it\'s $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36191,'Looks like we\'re in a pretty tight jam. Think you can get us out of here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36192,'','Oh, $n, we\'re marooned!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36193,'','I miss Kezan. Will we ever see Bilgewater Port again, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36194,'','Sit with me a while. We can roast crabs over the fire and sing songs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36195,'','I put this all on you, but what are you doing to get us off of this island?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36196,'<Gobber grunts.>$B$BMe banker now!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36197,'','Nice to see you again, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36198,'Spirits of the sea, rise and lay waste to my enemies!','',0,0,0,0,0,0,0,0,1,8839,0,0,26124),
(36199,'Power of the ocean, heed my call!','',0,0,0,0,0,0,0,0,1,8839,0,0,26124),
(36200,'Children of the watery depths, lay waste to those who foul your realm!','',0,0,0,0,0,0,0,0,1,8839,0,0,26124),
(36201,'Speed of the storm, heed my call!','',0,0,0,0,0,0,0,0,1,8839,0,0,26124),
(36202,'Winds of boundless fury, unleash your tempest upon the Alliance!','',0,0,0,0,0,0,0,0,1,8839,0,0,26124),
(36203,'Sons of Stormwall, descend and destroy those who would prevent me from protecting this world!','',0,0,0,0,0,0,0,0,1,8839,0,0,26124),
(36204,'I\'m feeling much better already.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36205,'Lok\'tar ogar, $n!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(36206,'Warchief, I need another cyclone.','Warchief, I need another cyclone.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36207,'Go to the center of the temple and use the Horn of Elemental Fury!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36208,'There were worgen everywhere.... it should\'ve been me....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36209,'Gilneas will soon belong to the Forsaken!','Gilneas will soon belong to the Forsaken!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36210,'You\'ll find them in the Apothecarium. Names are Doctor Herbert Halsey and Doctor Marsh. Just watch your back.','You\'ll find them in the Apothecarium. Names are Doctor Herbert Halsey and Doctor Marsh. Just watch your back.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36211,'Doctor Herbert Halsey is who you want. Just don\'t try anything funny. Any more of that plague nonsense and you\'ll find an axe in uncomfortable places.','Doctor Herbert Halsey is who you want. Just don\'t try anything funny. Any more of that plague nonsense and you\'ll find an axe in uncomfortable places.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36212,'Grizzle Halfmane in the Royal Quarter is the orc you\'re looking for.','Grizzle Halfmane in the Royal Quarter is the orc you\'re looking for.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36213,'The battlemaster serving Undercity is Grizzle Halfmane - a fierce fighter in his day. He\'s in the Royal Quarter.','The battlemaster serving Undercity is Grizzle Halfmane - a fierce fighter in his day. He\'s in the Royal Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36214,'You want Sir Malory Wheeler. He\'s in the Royal Quarter with the rest of the battlemasters.','You want Sir Malory Wheeler. He\'s in the Royal Quarter with the rest of the battlemasters.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36215,'You want to help the Defilers? Head to the Royal Quarter and speak with Sir Malory Wheeler. He\'s your man.','You want to help the Defilers? Head to the Royal Quarter and speak with Sir Malory Wheeler. He\'s your man.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36216,'Head to the central ring; you\'ll find auctioneers stationed there.','Head to the central ring; you\'ll find auctioneers stationed there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36217,'If you want to access the market here, get to the central ring of the city.','If you want to access the market here, get to the central ring of the city.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36218,'Kawphi? Memory potion? Hah! This isn\'t a memory potion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36219,'The bank? It\'s that tower in the middle of the Trade Quarter.','The bank? It\'s that tower in the middle of the Trade Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36220,'So Ergll, is that all that you needed for your memory potion?','So Ergll, is that all that you needed for your memory potion?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36221,'What is it then?','What is it then?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36222,'I wakes me up in the mornings. The sun makes me tired. Hard to think.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36223,'All of that just to wake you up? I\'m sure I have several weapons that could have managed that fine.','All of that just to wake you up? I\'m sure I have several weapons that could have managed that fine.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36224,'More reliable this way I think.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36225,'So... where can I find Azuregos, Ergll?','So... where can I find Azuregos, Ergll?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36226,'Azuregos! I remember him. Tall, blue, big fangs. Nice sort really, if a little loopy. Haven\'t seen him in weeks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36227,'It\'s right in the center of the city. The hub of the wheel.','It\'s right in the center of the city. The hub of the wheel.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36228,'Naznik\'s the local barber. He set up shop on the top ring of the Trade Quarter.','Naznik\'s the local barber. He set up shop on the top ring of the Trade Quarter.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36229,'Michael Garrett tends the Undercity\'s bats. He\'s in the upper ring of the Trade Quarter.','Michael Garrett tends the Undercity\'s bats. He\'s in the upper ring of the Trade Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36230,'The bat handler has his roost on the upper ring of the Trade Quarter. You can\'t miss the smell.','The bat handler has his roost on the upper ring of the Trade Quarter. You can\'t miss the smell.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36231,'The battlemasters are stationed in the Royal Quarter; you\'ll find them around the throne room.','The battlemasters are stationed in the Royal Quarter; you\'ll find them around the throne room.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36232,'Which battleground calls you?','Which battleground calls you?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36233,'James Van Brunt runs a decent forge in the War Quarter. He\'s on the inner ring.','James Van Brunt runs a decent forge in the War Quarter. He\'s on the inner ring.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36234,'The blacksmith here works in the War Quarter, close to where his weapons will be put to use. He\'s there on the inner ring.','The blacksmith here works in the War Quarter, close to where his weapons will be put to use. He\'s there on the inner ring.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36235,'Eunice Burch cooks what passes for food here over in the Trade Quarter. It\'s your stomach, not mine.','Eunice Burch cooks what passes for food here over in the Trade Quarter. It\'s your stomach, not mine.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36236,'The cook around here is in the Trade Quarter. Her name\'s Eunice Burch.','The cook around here is in the Trade Quarter. Her name\'s Eunice Burch.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36237,'Lavinia Crowe\'s the local enchanter. She\'s set up shop on the inner ring of the Apothecarium.','Lavinia Crowe\'s the local enchanter. She\'s set up shop on the inner ring of the Apothecarium.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36238,'If you want to learn enchanting, go find Lavinia Crowe on the inner ring of the Apothecarium.','If you want to learn enchanting, go find Lavinia Crowe on the inner ring of the Apothecarium.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36239,'The engineer here is called Franklin Lloyd. He tinkers in the Rogues\' Quarter, on the outer ring.','The engineer here is called Franklin Lloyd. He tinkers in the Rogues\' Quarter, on the outer ring.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36240,'Look, if you want to go talk to those engineers on the outer ring of the Rogues\' Quarter, it\'s your hide.','Look, if you want to go talk to those engineers on the outer ring of the Rogues\' Quarter, it\'s your hide.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36241,'Mary Edras is the one you want. She\'s set up at the inner ring of the Rogues\' Quarter.','Mary Edras is the one you want. She\'s set up at the inner ring of the Rogues\' Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36242,'Really? Weeks? Don\'t you have anything better than that?','Really? Weeks? Don\'t you have anything better than that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36243,'He was always prattling on about finding this or that magic artifact. Said Azshara was full of them, he did. He was a bit obsessive if you ask me.$B$BLast I heard, he was trying to make friends with that Archmage person. Xylem? He said Xylem had found some grand old magic item.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36244,'Archmage Xylem? Where can I find this Archmage, Ergll?','Archmage Xylem? Where can I find this Archmage, Ergll?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36245,'Xylem\'s a little bit lacking in the social graces. He talks to his apprentices a bit, but mostly he just talks to himself. Tends to brush everyone else off.$B$BWouldn\'t take me as an apprentice - said I was too slimy. Said that my mind wasn\'t any good to study being all mucked up with magic and all.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36246,'Any idea on how I could get him to answer some questions?','Any idea on how I could get him to answer some questions?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36247,'Become an apprentice I suppose. Pretty high turnover really.$B$BI\'ve met maybe a dozen washed up apprentices this last month alone. He leaves them kind of damaged. They keep coming though. I guess there aren\'t many options in the Archmage racket.$B$BI met another one just today. He was heading over to the west, to that big pillar that\'s being built.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36248,'It\'s a start. Thanks Ergll.','It\'s a start. Thanks Ergll.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36249,'Yup yup! Say hi for me if you find him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36250,'Hello! Someone who doesn\'t smell like fish. I like.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36251,'Even the walking dead need to mend themselves. Mary Edras handles it here. She\'s in the Rogues\' Quarter, on the inner ring.','Even the walking dead need to mend themselves. Mary Edras handles it here. She\'s in the Rogues\' Quarter, on the inner ring.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36252,'The crazy fisherman is on the dock in the Magic Quarter.','The crazy fisherman is on the dock in the Magic Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36253,'Greetings, friend.$b$bEnjoying the glade, I trust?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36257,'I don\'t know what he\'s trying to catch there, but Armand Cromwell is on the dock in the Magic Quarter.','I don\'t know what he\'s trying to catch there, but Armand Cromwell is on the dock in the Magic Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36258,'The guild master is Christopher Drakul. He\'s on the eastern platform in the Trade Quarter.','The guild master is Christopher Drakul. He\'s on the eastern platform in the Trade Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36259,'The guild master handles his business in the Trade Quarter. He\'s up on the eastern platform.','The guild master handles his business in the Trade Quarter. He\'s up on the eastern platform.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36260,'The herbalist around here is Martha Alliestar. She\'s over on the inner ring of the Apothecarium.','The herbalist around here is Martha Alliestar. She\'s over on the inner ring of the Apothecarium.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36261,'Head to the Apothecarium\'s inner ring. Martha Alliestar is there, and she\'ll instruct you in herbalism.','Head to the Apothecarium\'s inner ring. Martha Alliestar is there, and she\'ll instruct you in herbalism.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36262,'The inn - if you can call it that - is on the upper ring of the Trade Quarter. They don\'t even have beds.','The inn - if you can call it that - is on the upper ring of the Trade Quarter. They don\'t even have beds.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36263,'Innkeeper Norman keeps a dusty crack in the wall he calls an inn on the upper ring of the Trade Quarter.','Innkeeper Norman keeps a dusty crack in the wall he calls an inn on the upper ring of the Trade Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36264,'The scribe of the city is in the Apothecarium, someone named Margaux Parchley.','The scribe of the city is in the Apothecarium, someone named Margaux Parchley.',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(36265,'The city\'s leatherworker is in the inner ring of the Rogues\' Quarter.','The city\'s leatherworker is in the inner ring of the Rogues\' Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36266,'Arthur Moore is the leatherworker. He tends the trainees over in the Rogues\' Quarter, on the inner ring.','Arthur Moore is the leatherworker. He tends the trainees over in the Rogues\' Quarter, on the inner ring.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36267,'If you need keys, talk to Walter Soref in the Rogues\' Quarter, but watch yourself.','If you need keys, talk to Walter Soref in the Rogues\' Quarter, but watch yourself.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36268,'Mages? They\'re in the Magic Quarter, in the central building. Thought you\'d be smart enough to figure that out.','Mages? They\'re in the Magic Quarter, in the central building. Thought you\'d be smart enough to figure that out.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36269,'On the outer ring of the Magic Quarter you\'ll find a large, stepped building. That\'s where the mages hide.','On the outer ring of the Magic Quarter you\'ll find a large, stepped building. That\'s where the mages hide.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36270,'The mailbox is in the Trade Quarter by that coffin storage closet they call an inn.','The mailbox is in the Trade Quarter by that coffin storage closet they call an inn.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36271,'Mailbox? You want to head to the inn in the center of the city\'s upper ring. It\'s right there.','Mailbox? You want to head to the inn in the center of the city\'s upper ring. It\'s right there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36272,'If you want to learn to mine, talk to Brom Killian at the inner ring of the War Quarter.','If you want to learn to mine, talk to Brom Killian at the inner ring of the War Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36273,'The miner here works in the War Quarter on the inner ring. His name\'s Brom Killian.','The miner here works in the War Quarter on the inner ring. His name\'s Brom Killian.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36274,'If you want to find a paladin, you\'ll have to go to the Royal Quarter. There\'s some elf there who can teach you.','If you want to find a paladin, you\'ll have to go to the Royal Quarter. There\'s some elf there who can teach you.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36275,'The priests are located on the outer ring of the War Quarter.','The priests are located on the outer ring of the War Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36276,'Head to the War Quarter. The priests are there on the outer ring making sure no limb remains unattached for long.','Head to the War Quarter. The priests are there on the outer ring making sure no limb remains unattached for long.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36277,'The rogues are in the Rogues\' Quarter. Simple as that. Look for them on the outer ring.','The rogues are in the Rogues\' Quarter. Simple as that. Look for them on the outer ring.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36278,'Go to the outer ring of the Rogues\' Quarter if you want to find rogues.','Go to the outer ring of the Rogues\' Quarter if you want to find rogues.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36279,'The skinner here is named Killian Hagey. He works in the Rogues\' Quarter on the inner ring.','The skinner here is named Killian Hagey. He works in the Rogues\' Quarter on the inner ring.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36281,'If you want to learn how to skin things, head to the Rogues\' Quarter. The skinner has his place on the inner ring.','Us have skinning hook.  We get it from Killian Hagey who teach us how to skin kills.  You have nice skin.  You find him on inner ring of Rogues\' Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36282,'If you really trust some undead with your pets, you can talk to Anya Maulray at the inn on the upper ring of the Trade Quarter.','If you really trust some undead with your pets, you can talk to Anya Maulray at the inn on the upper ring of the Trade Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36283,'You can talk to Anya Maulray up by the inn on the upper ring of the Trade Quarter. I wouldn\'t recommend it, but they\'re your pets.','You can talk to Anya Maulray up by the inn on the upper ring of the Trade Quarter. I wouldn\'t recommend it, but they\'re your pets.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36284,'The tailor here\'s Josef Gregorian. He\'s in the Magic Quarter on the inner ring.','The tailor here\'s Josef Gregorian. He\'s in the Magic Quarter on the inner ring.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36285,'Go to the Magic Quarter and head to the inner ring. The tailor\'s there.','Go to the Magic Quarter and head to the inner ring. The tailor\'s there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36286,'You have guts asking me about warlocks. Go to the Magic Quarter\'s outer ring and get out of my sight.','You have guts asking me about warlocks. Go to the Magic Quarter\'s outer ring and get out of my sight.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36287,'You\'ll find the warlocks in the Magic Quarter\'s main building, but I better not hear of any trouble that comes of this.','You\'ll find the warlocks in the Magic Quarter\'s main building, but I better not hear of any trouble that comes of this.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36288,'The warriors are in the War Quarter, practicing on the outer ring.','The warriors are in the War Quarter, practicing on the outer ring.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36289,'In the War Quarter is where you\'ll find the warriors. Head to the outer ring there.','In the War Quarter is where you\'ll find the warriors. Head to the outer ring there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36290,'If you want to learn how to wield weapons, go to Archibald on the inner ring of the War Quarter.','If you want to learn how to wield weapons, go to Archibald on the inner ring of the War Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36291,'Good to see someone wanting to learn something useful. Head to Archibald on the inner ring of the War Quarter.','Good to see someone wanting to learn something useful. Head to Archibald on the inner ring of the War Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36292,'I don\'t blame you for wanting to get out of here. Go up topside and head north of the ruins. The zeppelins leave from the two towers there.','I don\'t blame you for wanting to get out of here. Go up topside and head north of the ruins. The zeppelins leave from the two towers there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36293,'The zeppelin towers are just north of the Undercity.','The zeppelin towers are just north of the Undercity.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36294,'Surprised to see an orc here? Don\'t be.$b$bThe forsaken need watching. If we\'d been paying closer attention from the start, maybe the Wrath Gate wouldn\'t have happened.','Surprised to see an orc here? Don\'t be.$b$bThe forsaken need watching. If we\'d been paying closer attention from the start, maybe the Wrath Gate wouldn\'t have happened.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36295,'Hope you\'re not looking for those abominations. The apothecaries can\'t be trusted, and that means none of their little constructs patrolling the halls. We\'re here to keep things safe.','Hope you\'re not looking for those abominations. The apothecaries can\'t be trusted, and that means none of their little constructs patrolling the halls. We\'re here to keep things safe.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36296,'Lok\'tar. Don\'t try anything suspicious around here. If these undead are going to be part of the Horde, they\'re going to mind themselves under our watch.','Lok\'tar. Don\'t try anything suspicious around here. If these undead are going to be part of the Horde, they\'re going to mind themselves under our watch.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36297,'What\'s wrong, bonebag? Looking for someone else? I\'m all you\'ve got now, so if you want something, make it quick.','What\'s wrong, bonebag? Looking for someone else? I\'m all you\'ve got now, so if you want something, make it quick.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36298,'Make it quick, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36299,'I\'ve got my eye on you, Faranell.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36300,'No abominations protecting you. No secrecy. No plotting in the dark.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36301,'If you so much as spit without my permission, this place shuts down. Forcefully.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36302,'I assure you, overseer, the Royal Apothecary Society dearly wishes to make up for the tragic misguidance which ended so many lives.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36303,'We will cause you no trouble. We seek only to continue our research in peace.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36304,'We\'ll see about that.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36305,'Get that rotten nut to shut his trap!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36306,'Shut your face, you gibbering idiot!','Shut your face, you gibbering idiot!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36307,'I bet you rotters thought you were pretty clever at the Wrath Gate, didn\'t you? Playtime\'s over. We\'re here to make sure you don\'t try anything.','I bet you rotters thought you were pretty clever at the Wrath Gate, didn\'t you? Playtime\'s over. We\'re here to make sure you don\'t try anything.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36308,'I\'ll tell you what you need to know, but I don\'t have to like it. We\'re watching you and your kind.','I\'ll tell you what you need to know, but I don\'t have to like it. We\'re watching you and your kind.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36309,'This pit stinks and I\'m surrounded by snakes, but I\'m here to do a job.$b$bEver since Putress pulled his stunt at the Wrath Gate, the Warchief doesn\'t trust these people as far as he can throw them. That\'s why we\'re here. The apothecaries can\'t do a thing without me.','',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(36310,'GAH!!!!  I CAN\'T SEE IN HERE!!!!','',0,0,0,0,0,0,0,0,1,0,20908,0,26124),
(36311,'Barrel smell like gunpowder...','',0,0,0,0,0,0,0,0,1,0,20909,0,26124),
(36312,'This not be good...','',0,0,0,0,0,0,0,0,1,0,20910,0,26124),
(36313,'Uh-oh... this gonna hurts me...','',0,0,0,0,0,0,0,0,1,0,20911,0,26124),
(36314,'I gots bad feeling...','',0,0,0,0,0,0,0,0,1,0,20912,0,26124),
(36315,'Get back here!  I smashes you!','',0,0,0,0,0,0,0,0,1,0,20913,0,26124),
(36316,'[DND] To use my services you must have the proper certification.','[DND] To use my services you must have the proper certification.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36317,'[DND] I have the proper certification to use the bank.','[DND] I have the proper certification to use the bank.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36318,'[DND] Have you filled out the proper paper work and paid the appropriate fees to gain access to the bank?','[DND] Have you filled out the proper paper work and paid the appropriate fees to gain access to the bank?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36319,'I failed to defend my people in Gilneas City.  It seems the fates have given me a second chance, $n.  I will not fail again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36320,'[DND] Have you filled out the proper paper work and paid the appropriate fees to gain access to the auction house?','[DND] Have you filled out the proper paper work and paid the appropriate fees to gain access to the auction house?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36321,'It is so nice to see the Undercity returned to the calming wheezes and gas-expulsions of the abominations. The orcs smelled far worse.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36322,'I have the proper certification to use the bank.','I have the proper certification to use the bank.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36323,'You have been infected with a Paralytic Toxin!','You have been infected with a Paralytic Toxin!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36324,'Don\'t hurt me!  I was just looking for my sisters!  I think Ashley\'s inside that house!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36325,'','You are scary!  I just want my mommy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36326,'','Are you one of the good worgen, $g mister:ma\'am;?  Did you see Cynthia hiding in the sheds outside?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36327,'May I browse your ancient gem recipes?','May I browse your ancient gem recipes?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36328,'Your mother\'s in the basement next door.  Get to her now!','Your mother\'s in the basement next door.  Get to her now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36329,'It\'s not safe here.  Go to the Allens\' basement.','It\'s not safe here.  Go to the Allens\' basement.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36330,'What is it, $c? I\'ve got a lot to see to around here now that the demon\'s gone. Someone has to shuffle the paperwork and make sure we don\'t see another lapse like the one with Putress.$b$bLucky me.','',1,1,0,0,0,0,0,1,1,0,0,0,26124),
(36331,'Join the others inside the basement next door.  Hurry!','Join the others inside the basement next door.  Hurry!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36332,'','Look around you, $c!$b$bIsn\'t it all just beautiful?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36333,'','It really is you, isn\'t it?  I remember those eyes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36334,'How yeh doin\', $glad:lass;?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36335,'','You can\'t be serious!  Did you forget everything that $n did for us?  $gHe:She; stayed behind... for us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36336,'Give it up, Krennan.  It\'s time to put this one down.  It\'s protocol.','',0,0,0,0,0,0,0,0,1,0,19635,0,26124),
(36337,'DEPRECATED','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36338,'DEPRECATED','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36339,'DEPRECATED','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36340,'Tell me, Godfrey.  Those that stayed in Gilneas City so that we could live.  Were they following protocol?','',0,0,0,0,0,0,0,0,1,0,19721,0,26124),
(36341,'I didn\'t think so.  Now hand me that potion, Krennan... and double the dosage.','',0,0,0,0,0,0,0,0,1,0,19722,0,26124),
(36342,'DEPRECATED.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36343,'You can\'t be serious!  Did you forget everything that $n did for us?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36344,'I am not giving up on you.  I don\'t have a cure for the Curse yet... but there are treatments.  You will have control again.','',0,0,0,0,0,0,0,0,1,0,20919,0,26124),
(36345,'Ooga booga!','',0,0,0,0,0,0,0,0,1,8829,0,0,26124),
(36346,'Eekum Bokum!','',0,0,0,0,0,0,0,0,1,8829,0,0,26124),
(36347,'Sooie nah mi juju, gobin!','',0,0,0,0,0,0,0,0,1,8829,0,0,26124),
(36348,'Taronto bosch!','',0,0,0,0,0,0,0,0,1,8829,0,0,26124),
(36349,'Mkay, m\'ne ta oor!','',0,0,0,0,0,0,0,0,1,8829,0,0,26124),
(36350,'<Gormungan\'s voice booms deep from within, hurting your ears and reverberating in the very ground beneath your feet.>$B$BHallo, softling.$B$BYour kind dashes about, always running, never stopping. Rest with me a while.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36351,'I brought you something to eat.','I brought you something to eat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36352,'Ha - harrrum! Food? We don\'t eat squishlings, friend, not unless they aggravate us. We eat rocks and stones and earth. Though I sometimes find the crunch of bones makes a delightful seasoning.$B$B<Gormungan lifts up a boulder and, with one enormous hand, smashes the corpses you\'ve given him onto the boulder as one would put icing on a cupcake. He crunches his treat, rumbling happily.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36353,'Do you know anything about azsharite?','Do you know anything about azsharite?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36354,'Azsharite? You soft ones come up with new names for everything. What is this \"azsharite?\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36355,'Those piles of blue-ish crystals we find on the ground.','Those piles of blue-ish crystals we find on the ground.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36356,'<Gormungan\'s laugh, deep and long, rumbles the ground and causes distant rockslides.>$B$BOh - hah! Harroooo - Ha harum! Little friend, I am sorry. I suppose my kind does not pick up after ourselves as you do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36357,'So the giants have been dropping the azsharite? But where does it come from?','So the giants have been dropping the azsharite? But where does it come from?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36358,'It comes from - harum - what is your word for it? Harrrm. Let us say that my kind does not have bathrooms. Do you understand?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36359,'It\'s ... your droppings!? And the goblins have been running around scooping it up?','It\'s ... your droppings!? And the goblins have been running around scooping it up?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36360,'It would seem so. You and your friends are welcome to as much as you can find. I suppose it\'s very potent. We don\'t need to go that often.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36361,'How often do you, uh, \"go?\"','How often do you, uh, \"go?\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36362,'We don\'t live our lives as quickly as you do, my mushy friend. A healthy giant eats three square meals a decade, although I am known to indulge in a snack every couple of years. We\'ll go to the bathroom every 15 to 25 years... barring any tummy trouble.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36363,'15 to 25 years? Assistant Greely isn\'t going to want to hear that!','15 to 25 years? Assistant Greely isn\'t going to want to hear that!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36364,'<Gormungan emits a good-natured snort.>$B$BHaaarrum! I have never had my personal habits scrutinized so. Your kind never ceases to surprise me. Farewell, friend, and good luck with ... whatever it is you are on about.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36365,'Tell me again about Azsharite?','Tell me again about Azsharite?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36366,'Got one!','Over here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36367,'Snagged one!','Takedown!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36368,'Zap \'em!','Zap \'em!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36369,'','No offense, babe, but Chip is my boyfriend and I\'m working for the Trade Prince now.$B$BMove along, would ya? You\'re blocking my view.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36370,'','Yeah? Whadya want?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36371,'Listen, $n, I can\'t be seen talking with you. You\'re not exactly at the top of the Trade Prince\'s list these days and I need to think about my future.$B$BYou understand, right, babe? Besides, I\'m with Candy now.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(36372,'Move along, bub.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(36373,'My house!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36374,'<The trade prince lowers his voice to barely a whisper.>$B$BDon\'t think for a moment that I\'ve forgotten how much I despise you, $n, rescue or not.$B$BDon\'t worry your $g simple : pretty; head. I\'ll get my revenge soon enough, mark my words!$B$BYou\'ll fare far worse than being my slave. There\'ll be no escape for you this time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36375,'','Barely a scratch on you! Way to go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36376,'Marvelous! You bound ahead with more haste than a flame-laden kitten. Quite suitable indeed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36377,'Oh, I think we all know who\'s really responsible for the mess we\'re in! Don\'t worry, I\'m going to see to it that $n gets what $g he : she; deserves!','',0,0,0,0,0,0,0,0,1,8784,0,0,26124),
(36379,'Nobody panic! I\'ll see to it we get off of this deplorable island. You\'ll see... I\'ve got it all planned out!','',0,0,0,0,0,0,0,0,1,8784,0,0,26124),
(36380,'Never fear, Trade Prince Gallywix is here. We\'ll be on our way to our new home in Azshara before you know it! Despite the bumbling interference of $n.','',0,0,0,0,0,0,0,0,1,8784,0,0,26124),
(36381,'I can\'t help but think that if it weren\'t for the meddling of $n back on Kezan, we\'d all be safe and sound in Azshara by now.','',0,0,0,0,0,0,0,0,1,8784,0,0,26124),
(36382,'I\'ve got my eye on you, $n. Let\'s just say that only one of us will be leaving this island, and that goblin\'s name begins with Trade Prince!','',0,0,0,0,0,0,0,0,1,8784,0,0,26124),
(36383,'You thought to take my place on Kezan, $n? You reach too far! I made you what you were... were being the operative word. You\'re nothing now. Nothing!','',0,0,0,0,0,0,0,0,1,8784,0,0,26124),
(36384,'I want you all to listen good... anyone who\'s not with me can start looking for a new job!','',0,0,0,0,0,0,0,0,1,8784,0,0,26124),
(36385,'No worries, everyone. This is just a short pit stop on our way to our new home.','',0,0,0,0,0,0,0,0,1,8784,0,0,26124),
(36386,'We owe you a debt that will be hard to repay, $n.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(36387,'','Thank you for freeing Thrall, $n. He\'s been missed.$B$B<Aggra looks over at the Warchief.>',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36388,'Return to the battle in Shok\'Thokar or the centaur will abandon you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36389,'I swear this line\'s not moving!','I swear this line\'s not moving!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36390,'What\'s the hold up?','What\'s the hold up?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36391,'Time is money, friend!','Time is money, friend!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36392,'Is that a volcano over on that other island?','Is that a volcano over on that other island?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36393,'That rocket looks unsafe even by our standards!','That rocket looks unsafe even by our standards!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36394,'Why are we rocketing over to an island that has a volcano? Didn\'t we barely survive this scenario on Kezan?','Why are we rocketing over to an island that has a volcano? Didn\'t we barely survive this scenario on Kezan?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36395,'By the looks of that thing, I might take my chances swimming with the sharks!','By the looks of that thing, I might take my chances swimming with the sharks!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36396,'I knew I should have brought my folding chair.','I knew I should have brought my folding chair.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36397,'Hallo again, soft little friend. What\'s that you have there?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36398,'Hey, $g bro : lady;. Rocket ride! Yeah!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(36399,'Here, eat this! It\'s a special chocolate rock.','Here, eat this! It\'s a special chocolate rock.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36400,'','Oh, $n, you\'ve saved us again! Thank you for getting rid of those evil humans before they could get us!',17,0,0,0,0,0,0,0,1,0,0,0,26124),
(36401,'<Gormungan eyes the laxative with suspicion, then sniffs it. With visible irritation, he begins smooshing and molding the laxative into the shape of a goblin.>$B$BI suspect your little green friends are putting you up to no good. Please explain to them that we giants are not to be toyed with.$B$B<To demonstrate his point, Gormungan twists the head off of his chocolaty goblin statue before handing it back to you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36402,'Pentigast! Bring the new $r up to speed, would you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36403,'Always good to see you, friend!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36404,'','Grapplehammer relies on me to get things done. A mind like his needs to be free of distractions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36405,'','Are you ready to be shrunkified? This may sting a little. And burn. The agony and convulsions will pass quickly, however.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(36406,'I\'m ready. Shrink me!','I\'m ready. Shrink me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36407,'','Move fast, $n! You\'ll revert to regular-size in just a couple of minutes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36408,'I have to aim for the Forsaken ships.','I have to aim for the Forsaken ships.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36409,'Hum - Wha?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36410,'SQUEAK!!','SQUEAK!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36411,'<The enormous giant peers down at your tiny form.>$B$B$n, did you change your hair?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36412,'%s casts Meteor Fists!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36413,'Steady yourself, friend...$b$bThese next hours shall determine the fate of our clans.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36414,'I am ready! I want to join in the battle!','I am ready! I want to join in the battle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36415,'Sons of Cenarion, UNITE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36416,'Voctory is ours, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36417,'Thank you... *gasp*   I owe you my life.','Thank you... *gasp*   I owe you my life.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36418,'I... I thought I was a goner.  Thanks.','I... I thought I was a goner.  Thanks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36419,'The land gave way from under our feet...  I thought I was dead.  I owe you one.','The land gave way from under our feet...  I thought I was dead.  I owe you one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36420,'I\'ll be taking this cat.  It seems to work as the perfect bait.  Prepare to die now, fool!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36421,'','You do not mess with my kitty you son of a mongrel!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36422,'Lovely outfit. Dressed for the part!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36423,'I\'m ready to begin my trials.','I\'m ready to begin my trials.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36424,'EeeeEEEEEEKK!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36425,'Oh, $n, it was just you. Please don\'t scare me like that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36426,'<A hand-lettered sign reads:>$B$B          Secret Lab Archives$B     X. Nizzlebex, Lab Director$B$B$BPlease ring buzzer for service.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36427,'<Ring the Buzzer>','<Ring the Buzzer>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36428,'Sentinel, I would speak with your High Priestess.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36429,'Must I? I doubt Tyrande has more pressing business.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36430,'The lure of power is great. Mistakes were made.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36431,'I will not return until I am heard. There is too much at stake.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36432,'There is change on the wind, and we cannot ignore it. I have traveled from the dust and ruin of the past to come to an accord.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36433,'The time may soon come when the kaldorei require the knowledge and skill we have to offer.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36434,'I will wait, Sentinel... but I will have my audience.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36435,'Calm yourself, Sentinel. I do not seek to use it. I am merely... remembering.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36436,'Enough. I have been apart from this for centuries. The well within this temple may be a pale spectre of the Well of Eternity, but it still holds the same... beauty. Purity.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36437,'I had forgotten.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36438,'I do not believe admiration and wistful thoughts are against the societal norm.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36439,'You were the one who challenged me for merely looking. I still await my audience with Tyrande.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36440,'%s looks over at the moonwell with a sigh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36441,'We stand united as sons of Cenarion, thanks to you.$b$bYour deeds here shall live on as long as our clans draw breath, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36442,'Never again shall we allow our differences to divide us.$b$bLong live the children of Cenarion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36443,'May the blessings of Cenarion rain down upon you as it has this land, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36444,'Garfrost tired of puny mortals. Now your bones will freeze!','',0,0,0,0,0,0,0,0,1,0,16917,0,26124),
(36445,'Axe too weak. Garfrost make better and CRUSH YOU.','',0,0,0,0,0,0,0,0,1,0,16916,0,26124),
(36446,'','You must wait for an audience.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36447,'','You show some nerve coming to Teldrassil, Highborne. Your kind are unwelcome here. We have not forgotten the War of the Ancients or the minds behind it.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36448,'','And we would not see those mistakes repeated. Return to your exile.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36449,'','Take your gaze off the moonwell, exile. The power within is not yours to wield.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36450,'','Recalling your treachery?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36451,'','Watch yourself, Highborne.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36452,'','In good time.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36453,'Hey there, $n. I know, it\'s not much, but the trade prince\'s wreck is home for now.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36454,'','Greetings, $r. Please do not alarm yourself. I am indeed speaking to you in your native tongue.$B$BMy own considerable raptor intelligence has been augmented through a series of experiments. You may refer to me as \"Subject Nine,\" an identity recently bestowed to me by my creators, who are otherwise at the moment occupied or deceased. Perhaps you can render me some assistance?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36455,'','With the benefit of my improved cognitive capacity, I am able to turn fresh eyes upon the rest of my race. A majority of our energies were spent in the hunt of fresh prey. Why, I wonder, did we not invest that time developing a store of domesticated creatures from which to draw our food supply?$B$BI am naturally inclined to think that humans would make excellent foodstock. They breed quickly, fatten up nicely, and can be trained to do menial chores for the herd until harvest time. Hmmm.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36456,'I suppose I should not be surprised at this cold reception. We have long been in hiding, and the separation from our brethren was necessary.$b$bThat time, however, is done. Whether the residents of this young tree come to accept us or not, the Highborne are returning to light, and we will not turn our backs on what we are.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36457,'Is this really a good idea?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36458,'Up, Up & Away!','Up, Up & Away!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36459,'My brothers and I can reach northern Gilneas by boat in a matter of days.  As soon as we finish the repairs, that is.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36460,'You think you\'re such a bigshot, saving everyone and making friends with these orc savages?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36461,'I\'m gonna crush you! I\'m the Trade Prince! Me! I gotta plan that\'s gonna get me off of this island and make me the king of Azshara!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36462,'Mark my words! I\'m gonna get you, $n! I\'ll get you all! Out of my way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36463,'Tuskarr Kite','Tuskarr Kite',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36464,'Mini-Mount','Mini-Mount',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36465,'Mini-Mount','Mini-Mount',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36466,'Spectral Tiger Cub','Spectral Tiger Cub',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36467,'Scourgewar','Scourgewar',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36468,'Oh, pay no attention to me. I\'m just a messenger. The leader of the Deathstalkers certainly wouldn\'t be stupid enough to stand here on the dais waiting to be gutted. No need for history to repeat itself.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36469,'Out of the frying pan and into the fire, eh $n?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(36470,'Out of the frying pan and into the fire, eh $n? Need any training?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(36471,'I\'ve been patient up to this point, but if they don\'t get that rocket sling working soon, I\'m going to shadow bolt someone!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(36472,'I\'ve been patient up to this point, but if they don\'t get that rocket sling working soon, I\'m going to shadow bolt someone!$B$BNeed some training, $n?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(36473,'I saw Dampwick ride across on that thing. I\'d rather use a Slow Fall spell, but I don\'t know that one yet.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36474,'I saw Dampwick ride across on that thing. I\'d rather use a Slow Fall spell, but I don\'t know that one yet.$B$BWant some training, $n?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36475,'Good job, $n! Isn\'t this all very exciting? I wonder what the next island will be like?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36476,'Good job, $n! Isn\'t this all very exciting? I wonder what the next island will be like?$B$BCan I teach you anything new?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36477,'','Sounds like you\'ve had quite the adventure, $n. There must have been plenty of moolah on those Alliance creeps.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36478,'','Sounds like you\'ve had quite the adventure, $n. There must have been plenty of moolah on those Alliance creeps.$B$BWant to purchase some training?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36479,'','Hey there, $n. I for one am glad to be away from those damned monkeys!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36480,'','Hey there, $n. I for one am glad to be away from those darned monkeys!$B$BSo, want to hone your skills with a little training?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36481,'Warrior-Matic NX-01 is currently offline.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36482,'Warrior-Matic NX-01 online.$B$BPlease insert coins for training.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36483,'Summoned by a fumbling $r? Unbelievable. Desperate or stupid, this will be your final mistake.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36484,'%s takes a drink of his brew and jitters uncontrollably for a few moments.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36485,'That\'s the stuff! All awake now. Tasty!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36486,'','I would like to reiterate how pleased I am with the continued development of our working relationship, $n. In the weeks following my stunning cognitive enhancement, my goblin benefactors became apprehensive, perhaps outright distrustful, as my intellect eclipsed theirs.$B$BWhat a shame that my progenitors were unable to prevent this recent cascading series of industrial \'accidents\' that now allows me to operate so unencumbered...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36487,'','My sweet, adorable progeny!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36488,'%s\'s wounds begin to heal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36489,'','Farewell, Azeroth. I leave behind a world steeped in filth and wracked by cataclysm.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36490,'','Let\'s light this candle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36491,'Your miniscule intellect is no match for my superior claws!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36492,'Ah, fresh sustenance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36493,'First you, $r. Tomorrow: the world!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36494,'','Did you hear that, Clubnik? Those that died defending Lake Mennar are heroes. Their selfless actions may have even saved this entire world! A memorial should be erected.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36495,'','Clubnik? I hope you die. In a fire.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36496,'Sure I hear ya.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36497,'Howsabout a ... Memorial  Fuel Depot?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36498,'It\'ll be very tasteful!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36499,'Silence, fool!','',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(36500,'I pity the fool!','',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(36501,'Do not anger me!','',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(36502,'%s makes a heavy snort as he sniffs and nibbles at Sorata\'s clothes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36503,'Praise to the Light, $gbrother:sister; $n! Let\'s take a look here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36504,'Well, there\'s your problem! You have what we call a ghost in the machine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36505,'This calls for an old-fashioned bulldozer exorcism! Give me a hand if she gets uppity, will ya?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36506,'Whoa! We got a live one here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36507,'I cast you out! Unclean spirit - Begone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36508,'The power tools compel you! The power tools compel you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36509,'I cleanse thee with holy fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36510,'Die, goblin!','Die, goblin!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36511,'Terrific! That went down nice and clean.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36512,'Let Clubnik know that the priesthood will be sending him a bill. For the Light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36513,'Hmmm, once again I\'ve forgotten who I am and what I\'m doing here. Call me back if anything comes up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36514,'I uh - I could use a little help here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36515,'GASP, THIS IS A TEST','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36516,'You\'ll want to look in the Undercity.  In the old Ruins of Lordaeron, south of here, you\'ll find an elevator down. Once you\'re there, ask an Undercity Guardian for further directions.','You\'ll want to look in the Undercity.  In the old Ruins of Lordaeron, south of here, you\'ll find an elevator down. Once you\'re there, ask an Undercity Guardian for further directions.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(36517,'Use your Infrared Heat Focals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36518,'You need to get to the cliffs and Scout Brax, $n.','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(36519,'I need to borrow your tamed jungle cat to get to the cliffs, Kilag.','I need to borrow your tamed jungle cat to get to the cliffs, Kilag.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36520,'Refresh my memory on the whole kaja\'mite thing.','Refresh my memory on the whole kaja\'mite thing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36521,'Kaja\'mite... you know, the stuff that legend holds helped the entire goblin race to evolve into the ultimate masters of alchemy and engineering?!$B$BIt\'s the stuff that helped us to overthrow our jungle troll oppressors, to take control of Kezan -- may she rest in peace -- and is the most valuable ore in all of existence!$B$BHey, you don\'t think that it\'s having any effect on those monkeys do you?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36522,'The ruins scattered throughout this area are remnants of the night elven civilization at its former peak. They are a treasure trove of information for those who study the arcane.$B$BAnd it would seem they have attracted the attention of a most unusual group of night elven mages. Yes, you heard me $r - night elves are trying to reclaim their magical heritage! I would find it amusing but for the terrible potential should they discover anything of value here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36523,'Night elven mages. Pah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36524,'More souls to power the engine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36525,'My soul for you, master.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36526,'The vortex of the harvested calls to you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36527,'<The \"voice\" of the construct seems to emanate from the air around you, ringing in your ears while the hairs on your arms stand up. The construct speaks to you in a language you can\'t understand, with words that sound like multiple voices talking at once.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36528,'Um... Al\'teth ... la c\'tolgar? Or something.','Um... Al\'teth ... la c\'tolgar? Or something.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36529,'%s is chasing you. Run!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36530,'%s is chasing $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36531,'%s begins to unleash a toxic poison cloud!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36532,'My flesh!','My flesh!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36533,'Aaiiiiieee!','Aaiiiiieee!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36534,'My eyes - auuugh!','My eyes - auuugh!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36535,'The %s surges with uncontrolled arcane energies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36536,'No, that one! That one! Get that one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36537,'Quickly! Poison them all while they\'re still close!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36538,'Enough moving around! Hold still while I blow them all up!','',0,0,0,0,0,0,0,0,1,0,16929,0,26124),
(36539,'Look out - it\'s loose...','Look out - it\'s loose...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36540,'What is that $r doing here!?','What is that $r doing here!?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36541,'How do we stop it?','How do we stop it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36542,'%s takes in a deep breath...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36543,'Gizmo, what are you doing just sitting there? Don\'t you recognize who that is laying next to you?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36544,'That\'s $n! $G He\'s : She\'s; the whole reason we\'re still breathing and not crispy fried critters back on Kezan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36545,'Stay back, I\'m going to resuscitate $g him : her;! I hope these wet jumper cables don\'t kill us all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36546,'Come on! Clear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36547,'That\'s all I\'ve got. It\'s up to $g him : her; now. You hear me, $n? Come on, snap out of it! Don\'t go into the Light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36548,'You made the right choice. We all owe you a great deal, $n. Try not to get yourself killed out here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36549,'There are more survivors to tend to. I\'ll see you on the shore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36550,'%s begins rapidly conjuring explosive mines!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36551,'$n, my $g boy : girl;!$B$BWant me to teach you any of my thermal palms healing techniques?$B$BNo? How about bandages? Do you want to learn about bandages?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(36552,'Har! You look uglier than usual, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36553,'%s creates a whirling storm of bone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36554,'BONE STORM!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36555,'That\'s a primitive disguise spell, $r, but it should suffice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36556,'No hard feelings, $n.  You might be a feral killing machine, but it looks like you\'re with us for now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36557,'We have been betrayed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36558,'I will see you up top, $n. Thank you again for my freedom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36559,'Get out of my sight! The Blackmaw want nothing to do with you, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36560,'Welcome, ally. We have much to discuss.$B$BThe beasts you call the \"Horde\" ravage these woods. Their terrible stone ribbon slices through our land, frightens the animals we hunt, and fills the air with noise and ash.$B$BTell me, friend. How can we Blackmaw join this \"Alliance\" of yours?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36561,'Not so fast, bearface. First I need a foot-rub.','Not so fast, bearface. First I need a foot-rub.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36562,'What tactic is this that you come into my home and start barking demands of my people?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36563,'What\'s that smell? Is that you? Seriously.','What\'s that smell? Is that you? Seriously.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36564,'What? We negotiate in good faith and you come to me with insults?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36565,'The Alliance demands a delivery of fresh baby with each new moon for our infant labor camps.','The Alliance demands a delivery of fresh baby with each new moon for our infant labor camps.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36566,'Haggrum\'s plan to infiltrate Blackmaw Hold is an ambitious one. Quite duplicitous, actually, for an orc. Put on that enchanted disguise before I teleport you over there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36567,'The magic that makes that disguise possible will hold up only a few minutes. I will teleport you directly into the heart of Blackmaw Hold. Enter into negotiations with their Chieftain immediately... and be prepared to fight your way out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36568,'I am ready. Teleport me to Blackmaw Hold.','I am ready. Teleport me to Blackmaw Hold.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36569,'Poor $n. You\'ve sent $ghim:her; on a suicide mission, Haggrum.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36570,'You\'d better get used to it, jerkyloins. The Alliance primarily views you as pets. Do you do tricks?','You\'d better get used to it, jerkyloins. The Alliance primarily views you as pets. Do you do tricks?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36571,'Shut it, hair-vomit! Soon you will learn to submit to your gnomish overlords!!','Shut it, hair-vomit! Soon you will learn to submit to your gnomish overlords!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36572,'Your tone enrages me, outsider. If this is what we can expect from your so-called \"Alliance,\" we will have no part in it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36573,'You will have no choice once your people are enslaved by the jackbooted Alliance death squads!','You will have no choice once your people are enslaved by the jackbooted Alliance death squads!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36574,'You keep talking, but all I hear is \"Blah blah my people bathe in our own filth.\"','You keep talking, but all I hear is \"Blah blah my people bathe in our own filth.\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36575,'<Yank out his belly piercing.>','<Yank out his belly piercing.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36576,'Warriors - the Alliance filth have betrayed us! Slay them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36577,'That\'s $n?! Sorry, Doc, I thought $g he : she; was dead!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36578,'I remember when my brother and I would camp alone in the Azshara wilderness. Look at it now. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36579,'So... cold...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36580,'Argh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36581,'This is impossible!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36582,'This Xylem guy is a jerk.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36583,'Why did I sign up for this?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36584,'You have to be kidding me...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36585,'By the Light!  This must be the end of the world!','By the Light!  This must be the end of the world!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36586,'Will these earthquakes ever stop?','Will these earthquakes ever stop?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36587,'What have we done to deserve this?','What have we done to deserve this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36588,'Oh, no.  Not another one!','Oh, no.  Not another one!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36589,'The end is upon us!','The end is upon us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36590,'We should not let those who bear the Curse walk among us.  It\'s just not right.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36591,'Watch your back, $n.  If you weren\'t Krennan\'s pet you would\'ve died a long time ago.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36592,'The worgen killed my parents, $n.  Watch yourself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36593,'','It really is good to see you again, $n.  Fur and all.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36594,'Thank you, $r. Your endurance and dedication to the preservation of your race has inspired your people and your friends.  Allow me to thank you with the presentation of this reward.  Raise your hand and accept your prize, $n!','',378,0,0,0,0,0,0,0,1,0,0,0,26124),
(36595,'You just won a video card!!','',378,0,0,0,0,0,0,0,1,0,0,0,26124),
(36596,'Breath, damn it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36598,'Detonating','Detonating',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36599,'My ribs are broken.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36600,'Throm-Ka, goblin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36601,'Aka\'Magosh, goblin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36602,'Lok\'tar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36603,'I give you thanks for my life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36604,'Lok-Regar, Kilag!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36605,'Keep your sights straight, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36606,'You need something, $c?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36607,'Did you see that?','Did you see that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36608,'Did... did you see that?','Did... did you see that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36609,'Did... did that just happen?','Did... did that just happen?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36610,'No... it can\'t be.','No... it can\'t be.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36611,'Curse this land.  We can\'t stay here.','Curse this land.  We can\'t stay here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36612,'Don\'t shoot! Let \'em burn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36613,'Are we just going to let $ghim:her; through?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36614,'$gHe\'s:She\'s; one of Krennan\'s -- King\'s orders.  Besides, it looks like we have bigger problems coming our way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36615,'Even if this potion works... we can\'t just have worgen running around our town, Krennan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36616,'Even if this potion works...  we just can\'t have worgen running amok in our town, Krennan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36617,'Do exercise caution.  Don\'t expect anyone to invite you to their homes just yet.  But at least they won\'t shoot you outright.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36618,'','Welcome back, $n.  You were fortunate.  Krennan\'s treatment doesn\'t always work this well on people who\'ve had the Curse as long as you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36619,'Not bad for a goblin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36620,'What was that $c trick you did during the fight?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36621,'These humans are cowards. You hear me HUMANS? Come out and fight with honor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36622,'I thought that goblins were only good for selling trinkets and blowing themselves up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36623,'Did you hear that? Have a look around, $n, to see if any are trying to sneak up on us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36624,'So tell me, goblin, why did your slave ship wander through our battle?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36625,'You thought to kill me, puny human? This tiny goblin has more courage than your pathetic race!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36626,'So what else do you have in that belt?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36627,'Ahaha! You\'re gonna love this stuff!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36628,'%s roars and swells with dark might!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36629,'Many changes are occuring here, young one.  Do not fret if you see anything out of place...such as me.  Moo.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36630,'Protect the Captain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36631,'Hold your ground, men.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36632,'Hold your positions, men!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36633,'','What\'s happening?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36634,'Get on, quickly! We cannot not that drake escape!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36635,'','Can I provide you with anything, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36636,'Can I interest you in a new weapon, $c?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36637,'What do you know of ancient swords?','What do you know of ancient swords?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36638,'I witnessed the handiwork of our new goblin allies when I was stranded in the Lost Isles. But now we put their ingenuity to the test: here we face down our foes in their own stronghold.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36639,'There are some who do not believe in the legendary Night Elf Mohawks.$B$BI pity the fools.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36640,'I believe in you.','I believe in you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36641,'','Follow my lead, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36642,'Well met, fellow Mohawk $GBrother:Sister;.','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(36643,'','Don\'t give away our position, $n! That tower is crawling with bodyguards.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36644,'I\'m ready, Slinky. Let\'s do this.','I\'m ready, Slinky. Let\'s do this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36645,'','Grab the Captain\'s head - I\'m arming the explosives. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36646,'','Okay, this place is set to blow. Let\'s get out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36647,'','Hop on!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36648,'Rimefang, destroy this fool!','',0,0,0,0,0,0,0,0,1,0,16764,0,26124),
(36649,'The frostwyrm Rimefang gazes at $n and readies an icy attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36650,'You can only ride the Mountain Horse in the Crowley Stable Grounds and the Crowley Orchard.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36651,'Due to the, ah, \"misunderstanding\" in Dragonblight, we\'ve had to relocate our facilities to this decrepit mess of a castle.$B$BStill, we\'ve now plenty of space and time to work on various new and lovely... products...','',1,11,0,0,2,0,0,0,1,0,0,0,26124),
(36652,'Begin the battle.','Begin the battle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36653,'Arming','Arming',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36654,'Hear my words, $c!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36655,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36656,'Guards! They\'re up to something at the base of the tower. Stop them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36657,'I am ready.  However, I\'d like to skip the pageantry.','I am ready.  However, I\'d like to skip the pageantry.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36658,'%s begins to cast Wailing Souls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36659,'%s begins to |cFFFF0000Unleash Souls!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36660,'Azeroth has been assaulted from forces beyond this plane of existence...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36661,'From her depths she cries out for aid, but few can hear her pleas.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36662,'I hear them, $r. Allow me to translate...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36663,'Take up the sword and defeat the enemy of our world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36664,'[ph] Foolish creatures, your pithy complaints mean nothing before the will of the Lich King. You will serve him, even beyond death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36665,'[ph] Enough of your miserable complaints. You WILL carry on. These miserable dogs shall serve the Lich King, even beyond death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36666,'[ph] Now your skeletons shall labor for all of eternity... wait... intruders? Here?! Dispose of them immediately!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36667,'[ph] Please, I cannot labor any longer! Spare us for just a few minutes!','[ph] Please, I cannot labor any longer! Spare us for just a few minutes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36668,'Fail and she shall perish, and we with her!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36669,'','Great blessings be upon you, good $r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36670,'The first challenge requires you to be mounted on an Argent Battleworg.  You will find these mounts along the walls of this coliseum.$b$bPlease, mount the battleworg, speak to me, and then we can proceed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36671,'Find some cover!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36672,'Spread out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36673,'Get in positions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36674,'Squad, move.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36675,'Get out of the open.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36676,'Squad, you know what to do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36677,'Find some flanking positions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36678,'Move out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36679,'We\'ve got a live one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36680,'Target sighted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36681,'12 o\'clock.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36682,'Spotted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36683,'','Hostile ahead.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36684,'','Enemy here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36685,'Messy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36686,'BOOM!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36687,'Anyone up for a barbeque?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36688,'Turnin\' up the heat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36689,'Medic!','Medic!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36690,'Gob Squad reporting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36691,'We\'ve got your back.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36692,'Lead the way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36693,'Awaiting your orders.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36694,'Hostile down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36695,'That\'s for looking at me funny.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36696,'Roasted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36697,'I\'m melting... melting!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36698,'','Target down.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36699,'','By a girl. Ouch.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36700,'Meatbag spotted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36701,'Incoming.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36702,'Enemy down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36703,'Headshot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36704,'I\'ve little more than a cursory knowledge of magical artifacts, and the blue flight has enough troubles of its own.$B$BThere was a book in the library about the blades we forged for our mortal allies, but I\'m afraid I\'ve already loaned it to a representative of the Sunreavers. You\'re not the first person to come asking after information on those ancient swords, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36705,'I\'ve little more than a cursory knowledge of magical artifacts, and the blue flight has enough troubles of its own.$B$BThere was a book in the library about the blades we forged for our mortal allies, but I\'m afraid I\'ve already loaned it to a representative of the Silver Covenant. You\'re not the first person to come asking after information on those ancient swords, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36706,'%s releases Gas Spores!','',0,0,0,0,0,0,0,0,1,0,16911,0,26124),
(36707,'%s begins to cast |cFFFF7F00Pungent Blight!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36708,'Your pursuit shall be in vain, intruders, for the Lich King has placed an army of undead at my command! Behold!','Your pursuit shall be in vain, intruders, for the Lich King has placed an army of undead at my command! Behold!',0,0,0,0,0,0,0,0,1,0,16755,16755,26124),
(36709,'Persistent whelps! You will not reach the entrance of my lord\'s lair! Soldiers, destroy them!','Persistent whelps! You will not reach the entrance of my lord\'s lair! Soldiers, destroy them!',0,0,0,0,0,0,0,0,1,0,16756,16756,26124),
(36710,'On it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36711,'Almost done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36712,'It\'s set. Get clear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36713,'Ticker, blow this thing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36714,'Rimefang, trap them within the tunnel! BURY THEM ALIVE!','Rimefang, trap them within the tunnel! BURY THEM ALIVE!',0,0,0,0,0,0,0,0,1,0,16757,16757,26124),
(36715,'The spirit is displeased and attacks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36716,'They\'ve sent you to finish me off? Is this the best your Horde can muster?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36717,'This ... doesn\'t end here ... $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36718,'This way! We\'re about to mount an assault on the Scourgelord\'s location! ','This way! We\'re about to mount an assault on the Scourgelord\'s location! ',0,0,0,0,0,0,0,0,1,0,17153,17153,26124),
(36719,'%s goes into a frenzy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36720,'|TInterface\\Icons\\Spell_Fire_Flameshock.blp:20|t|cFFBC0000 OVERHEAT  |r|TInterface\\Icons\\Spell_Fire_Flameshock.blp:20|t','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36721,'','I really should charge you for that.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36722,'','Light be with you... for the very low price of a one silver tithe!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36723,'','Nothing wrong with a little drive-by fortitude!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36724,'','Hope you don\'t mind the extra fortitude, boss-$g man : lady;.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36725,'','That one\'s free of charge, $g sir : ma\'am;.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36726,'','I was wondering when I\'d see you again, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36727,'','It\'s not much, but it just might keep your green skin intact.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36728,'','Just wanted to let you know that we\'re all counting on you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36729,'<The orc before you looks greener than usual.>$B$B$C, the goblins have brought \"all you can eat seafood\" to our shores. It is ... *urp* ... like a cataclysm in my belly.','',1,20,0,0,0,0,0,0,1,0,0,0,26124),
(36730,'*Urp!*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36731,'Shouldn\'t have had ... the clams ...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36732,'It was ... the chowder.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36733,'\"All you can eat\" he says. *Gulp*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36734,'The ... clam strips ...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36735,'What was in that \"bisque?\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36736,'Please! No more. I can\'t handle any more of this!','Please! No more. I can\'t handle any more of this!',0,0,0,0,0,0,0,0,1,0,17152,17152,26124),
(36737,'If you ask me, the night elves lost this area ten thousand years ago. Their expulsion today at our hands is merely a formality.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36738,'The enormous stone shimmers with focused arcane energy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36739,'<Use the stone to teleport back to Valormok.>','<Use the stone to teleport back to Valormok.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36740,'The enormous stone shimmers with focused arcane energy.$B$BIf Andorel\'s instructions are to be believed, it should be easy to refocus the stone\'s energies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36741,'Well done, $n! Now then, let me assemble the team...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36742,'Very good. Whatever it is you boys do... Do a lot of it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36743,'Don\'t forget, $n - you can now use the summoning stone to port yourself back to my location in Valormok! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36744,'Now comes our chance at redemption, Jadaar. We could become heroes through this tournament!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36745,'I don\'t know. I am uncertain this is the proper vehicle to heroism.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36746,'What could be holding you back? You\'re hale, hearty... missing an eye perhaps, but that shouldn\'t keep you from competing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36747,'I dislike elekks. Strongly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36748,'Ah. That might be a problem.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36749,'Why aren\'t you competing?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36750,'I had a... situation some time back with one of the individuals now heading up the Sunreavers here. A falling out, if you will.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36751,'Needless to say, when I walked into the pavilion there was something of an altercation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36752,'They refused to train you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36753,'He suggested I do something else with the lance, instead. It\'s not my place to repeat vulgarities.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36754,'You realize, of course, that we would likely have to joust one another should we enter the tournament.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36755,'There is no doubt in my mind you\'d lose. Speed and wit triumphs over brute strength and bullheadedness any day of the week.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36756,'Okay, form it up! If it moves, shoot it. If it shoots... Move it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36757,'Gassed up and good to go.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36758,'Boom, baby!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36759,'Are you surprised to see me here? Everyone needs clean laundry, and what better way to do it than with your own water elemental?$B$BSimply bring your laundry, pay a nominal fee, and before you know it, everything will be fresh and clean!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36760,'Arcanist Tybalin said you might be able to lend me a certain tabard.','Arcanist Tybalin said you might be able to lend me a certain tabard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36761,'You\'re in luck. I\'ve got just what you need in the load I\'m about to wash.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36762,'See the piles of laundry and the bucket of water? I\'ll call out what I need next, and you put it in the tub. Ready?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36763,'Oh, no! That wasn\'t right. Now I\'ll have to go get more detergent so we can start over!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36764,'Well done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36765,'Another shall take his place. You waste your time.','',0,0,0,0,0,0,0,0,1,0,16752,0,26124),
(36766,'[ph] What a miserable gnome. That beast would have better off fighting without him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36767,'Warning: shredder is programmed only to function in Azshara.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36768,'Oops.','Oops.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36769,'Bullheadedness? It is my perseverance that has gotten us this far, dandy. You wouldn\'t last five seconds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36770,'Typical empty boasting. Still, the stables are rather distant and the drinks here are decent enough.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36771,'I hear those lances are rough-hewn, too. I\'m no fan of splinters.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36772,'Just as well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36773,'If we do succeed here, you realize what comes next.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36774,'The Citadel, correct? Facing the Lich King\'s most powerful minions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36775,'The two of us against the vast undead sea.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36776,'Indeed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36777,'...perhaps we should seek our fortune somewhere less likely to be fatal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36778,'Discretion is the better part of valor, after all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36779,'Would one of you hurry up and finish off the other? Some of us are trying to make some moolah here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36780,'Taking all bets on who wins between these two idiots.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36781,'You two mooks stow it. The boss is here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36782,'Shadow and fire, how quaint. Ride the lightning!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36783,'Next time, I won\'t miss!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36784,'I can\'t wait to learn how to Hex. The two of you are going to be frogs for the rest of your miserable lives!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36785,'How did the two of you ever make it to the executive level?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36786,'They don\'t pay me enough to put up with this kind of unprofitable behavior!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36787,'Toss some pants in to the tub!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36788,'Quick, add some shirts to the laundry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36789,'Add the unmentionables... uh, I mean, the \'delicates\'!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36790,'The tub needs more water!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36791,'See how easy that was with everyone working together? Just take what you need from the clean laundry here, but don\'t forget to return it when you\'re finished.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36792,'I\'m going to need you to do something else in a moment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36793,'Your salvation has arrived... and it\'s affordably priced!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36794,'I\'ll take my fee out of your paycheck.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36795,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36796,'Have I got a heal for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36797,'I\'ve got the best heals, anywhere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36798,'Health from above!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36799,'I love the smell of salvation in the morning.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36800,'I\'ve got what you need!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36801,'Light is money, friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36802,'Rez incoming!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36803,'No more lying down on the job.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36804,'Not getting out of your debts that easy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36805,'Back to work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36806,'Walk it off.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36807,'That\'s 3 for you, buddy. One more and my fee goes up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36808,'I\'m charging you for hazard pay on this one, pal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36809,'You didn\'t even make it 20 more feet that time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36810,'<A hand-lettered sign reads:>$B$B          Secret Lab Archives$B     X. Nizzlebex, Lab Director$B$B$B<It appears nobody is home right now. Perhaps you should come back later?>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36811,'Pirates?! Nobody said anything about pirates!$B$BDon\'t let them get me, boss. I\'m too young to die!!!','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(36812,'My, that\'s quite a load you have there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36813,'Chilly tickles!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36814,'You make face soaky.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36815,'My mouth tastes wet!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36816,'...Is drink time?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36817,'Aquanos, stop sending the clothes so high! You didn\'t have to see the look on Aethas Sunreaver\'s face when he found his pants in the fountain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36818,'To your health, windbag.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36819,'And to yours, brat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36820,'','Pirates are NOT in my contract!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(36821,'','He is too powerful. We must leave this place at once! My magic can hold him in place for only a short time. Come quickly, heroes!',0,0,0,0,0,0,1,0,1,0,0,16644,26124),
(36822,'What is your business here, $c?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36823,'At last, you\'re here. We have to get this tome to Icecrown as quickly as we can.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36824,'I\'m ready to deliver the tome, Magister Hathorel.','I\'m ready to deliver the tome, Magister Hathorel.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36825,'Never trust the Sunreavers. They are hard at work undermining us in the eyes of our Argent Crusade allies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36826,'Please, no more! I just need to rest for a moment!','Please, no more! I just need to rest for a moment!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36827,'I\'ll... get... back... to... work... I... promise.','I\'ll... get... back... to... work... I... promise.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36828,'There you are! I was beginning to think that the Sunreavers had intercepted you. Are you ready to deliver the tome to our representatives in Icecrown?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36829,'I\'ll deliver the tome to our contacts in Icecrown, arcanist.','I\'ll deliver the tome to our contacts in Icecrown, arcanist.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36830,'Would you renew my Sunreaver disguise?','Would you renew my Sunreaver disguise?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36831,'THIS IS A TEST','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36832,'Would you renew my Silver Covenant disguise, Magister Hathorel?','Would you renew my Silver Covenant disguise, Magister Hathorel?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36833,'','<The raptor peers at you, growls, and slobbers.>$B$B<It appears Subject Nine left behind an un-augmented clone of herself in order to cover her tracks. Clever girl! You ponder over what exactly you\'ve unleashed onto the cosmos...>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36834,'It\'s hard to believe that I once respected Arthas.','It\'s hard to believe that I once respected Arthas.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36835,'Slaves to our own prince, we\'re treated worse alive than dead. ','Slaves to our own prince, we\'re treated worse alive than dead. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36836,'I\'m shocked they didn\'t take our clothing with our weapons...','I\'m shocked they didn\'t take our clothing with our weapons...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36837,'What does the Lich King need with living servants? Why doesn\'t he just kill us all?','What does the Lich King need with living servants? Why doesn\'t he just kill us all?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36838,'We came here to investigate and were caught like a gnome with his hand on King Mekkatorque\'s throne. ','We came here to investigate and were caught like a gnome with his hand on King Mekkatorque\'s throne. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36839,'That worg of a taskmaster. It\'s only a matter of time before he gets what\'s coming to him.','That worg of a taskmaster. It\'s only a matter of time before he gets what\'s coming to him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36840,'Ugh... taking so long... my limbs... can\'t go on...','Ugh... taking so long... my limbs... can\'t go on...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36841,'Wait! Stop! Don\'t kill me, please! I\'ll tell you everything!','',0,0,0,0,0,0,0,0,1,0,16934,0,26124),
(36842,'What you seek is in the master\'s lair, but you must destroy Tyrannus to gain entry. Now, within the Halls of Reflection you will find Frostmourne. It... It holds the truth.','',0,0,0,0,0,0,0,0,1,0,16935,0,26124),
(36843,'I swear it is true! Please, don\'t kill me!!','',0,0,0,0,0,0,0,0,1,0,16936,0,26124),
(36844,'Urg... no!!','',0,0,0,0,0,0,0,0,1,0,16937,0,26124),
(36845,'','Why should the Banshee Queen spare your miserable life?',0,0,0,0,0,0,6,0,1,0,0,17033,26124),
(36846,'','Frostmourne? The Lich King is never without his blade. If you are lying to me...',0,0,0,0,0,0,6,0,1,0,0,17034,26124),
(36847,'','A fitting end for a traitor. Come, we must free the slaves and see what is within the Lich King\'s chamber for ourselves.',0,0,0,0,0,0,1,0,1,0,0,17035,26124),
(36848,'%s runs away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36849,'Be sure to keep an eye out for recruitment posters in Gobland. Once we get that operation under way, it would be good to have you on board again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36850,'Good to see you again, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36851,'$n! Come here. I have a ... \"special project\" requiring your assistance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36852,'Worthless gnat! Death is all that awaits you!','',0,0,0,0,0,0,0,0,1,0,16753,0,26124),
(36853,'Do not think that I shall permit you entry into my master\'s sanctum so easily. Pursue me if you dare.','',0,0,0,0,0,0,0,0,1,0,16754,0,26124),
(36854,'','I\'m not so naive as to believe your appeal for clemency, but I will listen.',0,0,0,0,0,0,1,0,1,0,0,16611,26124),
(36855,'','What a cruel end. Come, heroes. We must see if the gnome\'s story is true. If we can separate Arthas from Frostmourne, we might have a chance at stopping him.',0,0,0,0,0,0,1,0,1,0,0,16613,26124),
(36856,'','Frostmourne lies unguarded? Impossible!',0,0,0,0,0,0,6,0,1,0,0,16612,26124),
(36857,'Kalec sent me...','Kalec sent me...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36858,'Kalecgos?! That\'s your good foot forward?$B$BGood luck with that one, buddy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36859,'No no no, you don\'t understand. I\'m here to help.','No no no, you don\'t understand. I\'m here to help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36860,'Of course you are. Here to save big blue from himself, spending all his time in the spirit world, obsessing over magical artifacts. Kalec doesn\'t understand though, I\'ve turned a new leaf.$B$BI\'ve met someone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36861,'Met someone? I didn\'t know there were any other dragons out here.','Met someone? I didn\'t know there were any other dragons out here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36862,'A dragon? Hah! Don\'t be ridiculous.$B$BYou know $r, you\'re awfully rude. She\'s standing right here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36863,'...the spirit healer?\n','...the spirit healer?\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36864,'She has a name, you know. Anara. You\'d do well to treat her with the respect she deserves.$B$BHow many times have she and her sisters brought you back from the grip of death itself? You\'re just all kinds of inconsiderate, aren\'t you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36865,'I\'m sorry, I didn\'t mean to be rude, I just...','I\'m sorry, I didn\'t mean to be rude, I just...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36866,'I know. I KNOW. We could never be, right? Dragon and Spirit Healer... two different worlds! Not to mention the physiological problems.$B$BBut you\'re wrong. We have a deeper connection than that. Anara and I, we\'re involved.$B$BBesides, I kind of like it here. No adventurers to poke and prod me with no provocation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36867,'That\'s not what I was saying at all.','That\'s not what I was saying at all.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36868,'Well get to it then. You\'re the one veering off onto all these unnecessary topics.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36869,'I\'m the... forget it. I\'m here to warn you that the black dragonflight is here hunting you.','I\'m the... forget it. I\'m here to warn you that the black dragonflight is here hunting you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36870,'Oh. That? Thought I hadn\'t noticed the scorched earth and senseless slaughter that usually give them away? I\'m not THAT old.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36871,'You already know? Why don\'t you go stop them then?','You already know? Why don\'t you go stop them then?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36872,'Why bother? It\'s not like they actually have even the slightest clue where I am. They\'re not going to do any harm to the already-found artifacts around here.$B$BAnyway, one of the amusingly convenient things about evil and destruction is that they tend to just evilly destruct each other eventually.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36873,'But Kalecgos is already out there trying to stop them. He needs your help.','But Kalecgos is already out there trying to stop them. He needs your help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36874,'He\'s going after them? And he sent you to ask me for help? Was there begging? Were there tears?$B$B<Azuregos stares off into the distance as a toothy smile creeps onto his face.>$B$BYou know, if I came to his rescue, there\'s no way he could ever live it down. Maybe he\'d make me one of those little Sunwell girls of my very own.$B$BNo offense, Anara.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36875,'You\'ll come then?','You\'ll come then?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36876,'Yeah yeah, I\'ll come to his rescue.$B$BDon\'t you fall into his little center-of-the-world hero bit though! He just likes the attention. I swear, he thinks he\'s going to be the next Aspect. It\'s laughable.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36877,'I\'m going to let him know right away. Meet us at Sable Ridge.','I\'m going to let him know right away. Meet us at Sable Ridge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36878,'Yeah yeah. I\'m on my way. Don\'t get your chain panties in a bunch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36879,'You call that a trigger assembly? This is not a toy, people!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36880,'Step it up, Horvik. You too, Gleenix! Grapplehammer demands nothing less than perfection here. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36881,'What is this? I told you I wanted stepped threads on the interrupted breechblock! We\'re going to have to re-engineer the whole loading mechanism! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36882,'Blazcowiz, you\'d better get those recoil cylinders greased. Or I will grease them with your FACE.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36883,'Flink, did you compile the compression data for the hydropneumatic recoil jack yet? Chop chop!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36884,'Is this supposed to be a counterrecoil recuperating cylinder? I call it CRAP. Build it again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36885,'We\'re ready! Let\'s go!','We\'re ready! Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36886,'','I cannot hold him for long, we must leave at once!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36887,'What on earth is going on here?!?!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36888,'It takes a few good crashes to really \"season\" a flying machine.$B$BNo goblin in their right mind flies one pristine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36889,'Grapplehammer wants me to do WHAT? He\'s finally finished his bomb and he wants ME to fly it across the harbor? No-sir-ee!$B$BHere, I\'ll set one of my \'copters on autopiliot for you. Good luck!$B$BI\'ll be in my shelter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36890,'Just give me the \'copter, Friz.','Just give me the \'copter, Friz.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36891,'This is all YOUR fault, Sten!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(36892,'You seek Azuregos? Bane of the Bitter Reaches? Scourge of the Bay of Storms? Lord of all magic in Azshara?$B$BWell, you\'ve found him.$B$B<Azuregos appears to be smiling.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36893,'I\'ve had enough of this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36894,'So have I, Grimtotem.','',0,0,0,0,0,0,0,0,1,0,21166,0,26124),
(36895,'','Do not worry, young one. I knew that our arrangement was... temporary. I will be fine.$B$BYou though, you do not belong here. It is not yet your time. I shall aid your journey back to the realm of the living.$B$BThis one is on me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36896,'Baine! You\'ve shown yourself! GET HIM!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(36897,'You may have saved Azuregos, $r, but your life ends here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36898,'I don\'t think so, little wyrm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36899,'You will die in shame like your pathetic father.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36900,'It took a coward\'s poison and the fury of Hellscream to bring my father down.','',0,0,0,0,0,0,0,0,1,0,21161,0,26124),
(36901,'WHAT CHANCE HAVE YOU?','',0,0,0,0,0,0,0,0,1,0,21162,0,26124),
(36902,'[PH] Do not think to defy the master\'s will!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36903,'Why you break our home?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36904,'You break our cave, I break your skull!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36905,'Trogg cave all gone!  You pay for this!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36906,'And so it is done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36908,'','You\'ve come seeking your death? Happy to oblige.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36909,'You got here just in time.  Thanks!','You got here just in time.  Thanks!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36910,'I wasn\'t ready to die in a marsh.  Thanks again!','I wasn\'t ready to die in a marsh.  Thanks again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36911,'Time to run!','Time to run!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36912,'Let\'s get out of this marsh!','Let\'s get out of this marsh!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36913,'You puny thief!  Koroth find you!  Koroth smash your face in!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36914,'Who dares to touch Koroth\'s banner!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36915,'The %s bursts into a cloud of mysterious spores.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36916,'It is for you.','',0,0,0,0,0,0,0,0,1,0,21163,0,26124),
(36917,'This isn\'t over, Baine...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36918,'%s is reclaimed by the earth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36919,'The old wounds still linger, $g lad:lass;. I can feel \'em in me bones, even now. Aye, I got a score to settle with Arthas and ye can believe I\'m gonna give that boy the beatin\' I shoulda given \'im when he was a wee lad. Always knew there was something wrong with \'im.$B$BTell me when yer crew is ready and we\'ll lift off for the top o\' the citadel.$B$BArthas won\'t be expectin\' this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36920,'My companions are all accounted for, Muradin. Let\'s go!','My companions are all accounted for, Muradin. Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36921,'Master, I have failed...','',1,0,0,3,0,0,0,0,1,0,16922,0,26124),
(36922,'Found!','Found!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36923,'This is our final stand. What happens here will echo through the ages. Regardless of outcome, they will know that we fought with honor. That we fought for the freedom and safety of our people.$B$BRemember, hero, fear is your greatest enemy in these befouled halls. Steel your heart and your soul will shine brighter than a thousand suns. The enemy will falter at the sight of you. They will fall as the light of righteousness envelops them!','',1,1,5,0,0,0,0,0,1,0,0,0,26124),
(36924,'$G Sir.:Ma\'am.;','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36925,'Dismissed!','Dismissed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36926,'<Make a series of complicated hand gestures.>','<Make a series of complicated hand gestures.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36927,'What the heck was that?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36928,'','Was that... Yoga?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36929,'','You want me to steal third?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36930,'%s looks confused.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36931,'What did you just call my mother?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36932,'Now that\'s just rude...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36933,'Leading under the influence...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36934,'I don\'t think that\'s physically possible, sir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36935,'Sir, I think the explosions and gunfire gave us away. You don\'t have to use hand signals.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36936,'Most definitely.  Might you mentor me?','Most definitely.  Might you mentor me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36937,'Testing, 1... 2... 3!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36938,'The elements favor you.  What will you ask of them?','The elements favor you.  What will you ask of them?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36939,'The elements are fickle and best left out of untrained hands.  My apologies, but I have no need for yours.','The elements are fickle and best left out of untrained hands.  My apologies, but I have no need for yours.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36940,'Ooooh... looking sexy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36941,'I am truly blessed to have so many loyal and dedicated apprentices. My work would be impossible without this influx of test subjects.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36942,'Can you open a portal to your tower for me, Archmage Xylem?','Can you open a portal to your tower for me, Archmage Xylem?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36943,'I have opened the portal to my retreat. Go and rest. I\'ll need you lively when our studies resume in the morning, you nimble little thing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36944,'With the price they\'re getting on this operation, I\'m hoping for a nice hefty profit sharing check. They better not shortchange us again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36945,'Ready your arms, my Argent Brothers. The Vrykul will protect the Frost Queen with their lives.','',0,0,0,0,0,0,0,0,1,0,16819,0,26124),
(36946,'Enough idle banter! Our champions have arrived - support them as we push our way through the hall!','',0,0,0,0,0,0,0,0,1,0,16820,0,26124),
(36947,'Guards! I expect this $r to be clapped into chains!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36948,'Even dying here beats spending another day collecting reagents for that madman, Finklestein. ','',0,0,0,0,0,0,0,0,1,0,16585,0,26124),
(36949,'I am from the elemental plane!','',0,0,0,0,0,0,0,12,1,0,0,0,26124),
(36950,'%s grows more unstable!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36951,'No hit me! Tell Peake I been good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36952,'%s is growing volatile!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36953,'First da fire, and now da $r!  You gonna die!','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(36954,'You go attack him first, mon.  I don\' attack him quite yet.','',397,0,0,0,0,0,0,0,1,0,0,0,26124),
(36955,'I don\' wanna die in a fire, mon.','',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(36956,'%s can barely maintain its form!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36957,'','What we gon\' do now, you ask?  We wait.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(36958,'','I don\' know why the spirits be rejectin\' us so.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(36959,'','Don\' worry, child.  Grik\'nir gonna help us get through this.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(36960,'','Grik\'nir says he gon\' talk to the elemental, get it to fight on our side.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36961,'','Soon enough we take over dis valley.  Soon enough.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(36962,'','Da spirits be angry with us.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(36963,'','Our land be a land of ice an\' snow.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(36964,'','But beneath the earth, child, there always be fire.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(36965,'','De spirit come from deep down to talk with Grik\'nir.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(36966,'We grunts were ordered to charge once more - into a wall of pikes - I could not do it, $c. My weapon slid from my hands and my legs did not move.$B$BI am dishonored.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36967,'My commander was butchered before my eyes - my brothers dead all around me - I could not fight on. I am so ashamed, $c. I did not avenge them.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36968,'Do not look at me, $r. I have disgraced the Horde. I am done.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36969,'No orc should ever flee from battle as I did. Leave me to my disgrace. Would that I would die in this tower, but I dread learning what my ancestors think of my cowardice.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36970,'','Get ta work, boys!',22,0,0,0,0,0,0,7,1,0,0,0,26124),
(36971,'','Don\'t fret, we\'ll be outta here soon.',22,0,0,0,0,0,0,7,1,0,0,0,26124),
(36972,'','Let\'s keep this fire going, dwarves!',22,0,0,0,0,0,0,7,1,0,0,0,26124),
(36973,'','What\'s Joren doin\' out there, anyhow?',6,0,0,0,0,0,0,7,1,0,0,0,26124),
(36974,'Your jormungar can only move if you\'ve submerged beneath the snow, but it cannot attack while submerged. Once your jormungar emerges, it can use its powerful acid attack to wear through the armor of the Iron Colossus. Be ready to submerge to escape from the Iron Colossus\'s most devastating attacks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36975,'I recovered your armor and weapons. Victory or death!','I recovered your armor and weapons. Victory or death!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36976,'Thank goodness you arrived when you did, heroes. Orgrim\'s Hammer has already left. Quickly now, to the Skybreaker! If you leave soon, you may be able to catch them.','',1,0,0,0,0,0,0,0,1,0,17154,0,26124),
(36977,'Lok\'tar ogar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36978,'Vengeance...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36979,'No team\'s ever come back from this far behind!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(36980,'Coach, get me back into the game!','Coach, get me back into the game!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36981,'This ought to help!','This ought to help!',1,0,0,0,0,0,0,0,1,0,17155,17155,26124),
(36982,'Thanks!  I can make it from here.','Thanks!  I can make it from here.',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(36983,'Yer a lifesaver!  For Ironforge!','Yer a lifesaver!  For Ironforge!',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(36984,'Ahh, much better.  I owe ya one.','Ahh, much better.  I owe ya one.',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(36985,'Throw your Footbombs at those Steamwheedle Sharks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36986,'Lost your Rocket Pack? Have you checked your bags?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36987,'Curse this foul cage...','Curse this foul cage...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36988,'Ah, to be finally free of that cage...','Ah, to be finally free of that cage...\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36989,'I would like to receive training.','I would like to receive training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(36990,'','Forgive me, heroes. I should have listened to Uther. I... I just had to see for myself. To look into his eyes one last time. I am sorry.',1,0,0,0,0,0,1,0,1,0,0,16648,26124),
(36991,'','We now know what must be done. I will deliver this news to King Varian and Highlord Fordring.',1,0,0,0,0,0,1,0,1,0,0,16649,26124),
(36992,'','It... It\'s a dead end. We have no choice but to fight. Steel yourselves, heroes, for this is our last stand!',1,0,0,0,0,0,1,0,1,0,0,16647,26124),
(36993,'FIRE! FIRE!','',1,0,0,0,0,0,0,0,1,0,16721,0,26124),
(36994,'Nowhere to run... You\'re mine now!','',1,0,0,0,0,0,0,0,1,0,17223,0,26124),
(36995,'You have my thanks. We were outnumbered until you arrived. ','You have my thanks. We were outnumbered until you arrived. ',1,0,0,0,0,0,0,0,1,0,17157,17157,26124),
(36996,'Captain Muradin is waiting aboard the Skybreaker. We\'ll secure the area until you are ready for take off.','Captain  Muradin is waiting aboard the Skybreaker. We\'ll secure the area until you are ready for take off.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36997,'Quickly, climb aboard! We mustn\'t tarry here! There\'s no telling when this whole mountainside will collapse.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(36998,'','There\'s an opening up ahead. GO NOW!',1,0,0,0,0,0,1,0,1,0,0,16645,26124),
(36999,'','These hills and hidden trails are my home. For years I have used them on the hunt.$B$BI never thought I\'d use them to fight a war.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37000,'Skybreaker infantry, hold position!','Skybreaker infantry, hold position!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37001,'Aye aye!','Aye aye!',1,0,0,0,0,0,0,0,1,0,17159,17159,26124),
(37002,'Years ago, the Grimtotem raided my village. The pain, the anger, the loss - still they weigh on my heart.$B$BAnd now I find myself giving comfort and aid to others who have lost their village to a savage attack.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(37003,'Alright, so you\'re just going to head through this tunnel and whaaaaa....?','',397,0,0,0,0,0,0,0,1,0,0,0,26124),
(37004,'I recommend that you return to Anvilmar, $n... and quickly!  I\'ll send the signal to the Gnomeregan Airmen.','',397,0,0,0,0,0,0,0,1,0,0,0,26124),
(37005,'From these hidden paths we can rain terror down on our enemies below.$B$BThere is not much honor in hit-and-run strikes, but a good warrior knows to keep his foe off-balance.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37006,'Look for a fellow by the name of Milo Geartwinge.  I suppose I\'ll see what I can do about this cave-in.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(37007,'Get back, ye filthy beast!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37008,'Eat dwarven lead!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37009,'For Ironforge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37010,'Take that, ye cave-dwellin\' mongrel!$b$bAhh... how can I help ye, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37011,'','What d\'ye want, $c?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37012,'The trolls are acting strangely, $n.  I don\'t like it.  I don\'t like it one bit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37013,'Draw them back to us, and we\'ll assist you. ','',0,0,0,0,0,0,0,0,1,0,16821,0,26124),
(37014,'Push forward! ','',0,0,0,0,0,0,0,0,1,0,16822,0,26124),
(37015,'Quickly, push on!','',0,0,0,0,0,0,0,0,1,0,16823,0,26124),
(37016,'Her reinforcements will arrive shortly, we must bring her down quickly!','',0,0,0,0,0,0,0,0,1,0,16824,0,26124),
(37017,'I\'ll draw her attacks. Return our brothers to their graves, then help me bring her down!','',0,0,0,0,0,0,0,0,1,0,16825,0,26124),
(37018,'I\'ll remain and inform Tirion of our progress. You must press on and bring down Sindragosa. Lok\'tar, champions! ','',0,0,0,0,0,0,0,0,1,0,16830,0,26124),
(37019,'I AM FROM THE ELEMENTAL PLANE!','',0,0,0,0,0,0,0,12,1,0,0,0,26124),
(37020,'','Foolish Crok. You brought my reinforcements with you. Arise, Argent Champions, and serve the Lich King in death!',0,0,0,0,0,0,0,0,1,0,0,17019,26124),
(37021,'Hurry,  before that Val\'kyr picks us off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37022,'','You may have once fought beside me, Crok, but now you are nothing more than a traitor. Come, your second death approaches!',0,0,0,0,0,0,0,0,1,0,0,17017,26124),
(37024,'','You may have once fought beside me, Crok, but now you are nothing more than a traitor. Come, your second death approaches!',0,0,0,0,0,0,0,0,1,0,0,17017,26124),
(37025,'Why you\'re just the $c I was looking for! I\'m testing a new rocket-powered flying device, and I need your help!\n\nJust take one of these harnesses and put it on under your armor.  Hit the button on the side, and BOOM, off you go.\n\nDon\'t go trying to steal my work though. Each of these babies is fitted with a Transponster 8000 linked to the one in my hand. If you get too far from me the Transponster will shut down the main rocket and you\'ll be unable to lift off until you return.\n\nNow where did I put those liability forms?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37026,'Yeah, I\'m sure safety is your top priority. Give me a rocket pack.','Yeah, I\'m sure safety is your top priority. Give me a rocket pack.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37027,'This is our final stand. What happens here will echo through the ages. Regardless of outcome, they will know that we fought with honor. That we fought for the freedom and safety of our people!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37028,'Remember, heroes, fear is your greatest enemy in these befouled halls. Steel your heart and your soul will shine brighter than a thousand suns. The enemy will falter at the sight of you. They will fall as the light of righteousness envelops them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37029,'Our march upon Icecrown Citadel begins now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37030,'You now stand upon the hallowed ground of the Scourge. The Light won\'t protect you here, paladin. Nothing will protect you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37031,'ARTHAS! I swore that I would see you dead and the Scourge dismantled! I\'m going to finish what I started at Light\'s Hope!','',0,0,0,0,0,0,0,0,1,0,16656,0,26124),
(37032,'You could have been my greatest champion, Fordring: A force of darkness that would wash over this world and deliver it into a new age of strife.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37033,'But that honor is no longer yours. Soon, I will have a new champion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37034,'The breaking of this one has been taxing. The atrocities I have committed upon his soul. He has resisted for so long, but he will bow down before his king soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37035,'NEVER! I... I will never... serve... you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37036,'In the end, you will all serve me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37037,'Could it be, Lord Fordring? If Bolvar lives, mayhap there is hope fer peace between the Alliance and the Horde. We must reach the top o\' this cursed place and free the paladin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37038,'By the Light, it must be so!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37039,'Intruders have entered your master\'s domain. Signal the alarms!','',0,0,0,0,0,0,0,0,1,0,16747,0,26124),
(37040,'Hrmph, fodder. Not even fit to labor in the quarry. Relish these final moments, for soon you will be nothing more than mindless undead.','',0,0,0,0,0,0,0,0,1,0,16748,0,26124),
(37041,'What did that dragon do to Mount Kajaro?!!!','What did that dragon do to Mount Kajaro?!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37042,'Your last waking memory will be of agonizing pain.','',0,0,0,0,0,0,0,0,1,0,16749,0,26124),
(37043,'Prepare the Skybreaker fer an aerial assault on the citadel!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37044,'Minions, destroy these interlopers.','',0,0,0,0,0,0,0,0,1,0,16750,0,26124),
(37045,'We are outnumbered here, our ties to Crossroads and Durotar severed. But one orc is worth 10 Alliance cowards.$B$BWe will bottle them up in this pass and gut them like swine.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(37046,'Heroes, ye must fight yer way to a clear extraction point within Icecrown. We\'ll try an\' rendezvous on the ramparts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37047,'Kilrok, how did we lose Honor\'s Stand?','Kilrok, how did we lose Honor\'s Stand?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37048,'It was a clever ruse, $n. Alliance forces streamed out of Northwatch and marched up the gold road, besieging Crossroads as dusk fell. Then, in the heart of the night, they force-marched southward, leaving their campfires burning behind.$B$BOur meager forces at Honor\'s Stand were caught unawares as the Alliance poured through the pass at dawn\'s first light. Many of our bravest warriors fell before their blades.','',1,274,15,0,0,0,0,0,1,0,0,0,26124),
(37049,'Good news, everyone! I\'ve fixed the poison slime pipes!','',0,0,0,0,0,0,0,0,1,0,17123,0,26124),
(37050,'Kick the Footbomb between the smokestacks up and behind the opposing goal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37051,'The paladin still lives? Is it possible, Highlord? Could he have survived?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37052,'This was before the Cataclysm?','This was before the Cataclysm?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37053,'Then we must save him! If we rescue Bolvar Fordragon, we may quell the unrest between the Alliance and the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37054,'Our mission is now clear: The Lich King will answer for his crimes and we will save Highlord Bolvar Fordragon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37055,'Kor\'kron, prepare Orgrim\'s Hammer for its final voyage! Champions, our gunship will find a point to dock on the upper reaches of the citadel. Meet us there!','',0,0,0,0,0,0,0,0,1,0,17110,0,26124),
(37056,'The power of the Light knows no bounds, Saurfang. His soul is under great strain, but he lives - for now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37057,'Yes. We regrouped east of the pass and prepared a counter-attack, but the next day, the skies reddened and the land was cleaved in two, as easily as a child might split open a cactus apple. See how the devastation stretches from horizon to horizon?$B$BOur Alliance foes in their makeshift bunkers were as surprised and disorganized as we were by the disaster. It would\'ve been the perfect time to strike! But Warlord Gar\'dul insisted we pull back to the south to refortify.$B$B<Kilrok spits on the ground.>$B$BNot all of us followed. I stood toe-to-toe with demons in the last war, $n. I\'m not about to turn tail and let the Alliance plant roots on my soil.','',273,5,0,0,0,0,0,0,1,0,0,0,26124),
(37058,'You and your men stayed behind to fight.','You and your men stayed behind to fight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37059,'To fight, yes. To die? Likely. But we will give them no ground, $c.$B$BWe are outnumbered. Our armor is patchwork, our weapons scavenged.$B$BBut this is our land! Our tauren allies know every hidden trail, crevice, and pass through these hills. We descend from the high ground where they least expect us, then disappear into the terrain like phantoms. Fear is our weapon, and we will strike at them unceasingly.','',5,1,66,0,0,0,0,0,1,0,0,0,26124),
(37060,'Oh dear.  Things aren\'t looking good for Felix.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37061,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37062,'Give me another shot at kicking the winning goal, coach!','Give me another shot at kicking the winning goal, coach!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37063,'I tink I made an angry poo-poo. It gonna blow!','',0,0,0,0,0,0,0,0,1,0,16992,0,26124),
(37064,'|TInterface\\Icons\\spell_shadow_unstableaffliction_2.blp:16|t%s begins to cast |cFFFF0000Unstable Ooze Explosion!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37065,'','Miserable creatures! Die! ',0,0,0,0,0,0,0,0,1,0,0,17018,26124),
(37066,'When d\'ye think we can leave?  I need ta get back to work.','When d\'ye think we can leave?  I need ta get back to work.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(37067,'Where are all these troggs coming from?  Were they livin\' underground the whole time?','Where are all these troggs coming from?  Were they livin\' underground the whole time?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(37068,'Might as well make yerself comfortable.  Ironstock\'s not lettin\' anybody out until the troggs die down.','Might as well make yerself comfortable.  Ironstock\'s not lettin\' anybody out until the troggs die down.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37069,'Have ye any news from outside?  I hear the trolls have been actin\' up too.','Have ye any news from outside?  I hear the trolls have been actin\' up too.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37070,'It\'s gettin\' awful crowded in here.  I don\'t do well in confined spaces.','It\'s gettin\' awful crowded in here.  I don\'t do well in confined spaces.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37071,'Ye\'d think that, after an earthquake of cataclysmic proportions, the LAST place ye\'d want ta be is indoors, wouldn\'t ye?','Ye\'d think that, after an earthquake of cataclysmic proportions, the LAST place ye\'d want ta be is indoors, wouldn\'t ye?',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(37072,'$n!  I hear you\'re Ironstock\'s new little whipping $r.  What\'s she got ya doin\' now?','$n!  I hear you\'re Ironstock\'s new little whipping $r.  What\'s she got ya doin\' now?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37073,'I feel like I\'ve been cooped up in here forever.  Is it Brewfest yet?','I feel like I\'ve been cooped up in here forever.  Is it Brewfest yet?',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(37074,'Never... could reach... the top shelf...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37075,'THAT was for bringing me spoiled spider ichor!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37076,'You miserable fools never did manage to select a decent bat wing.','',0,0,0,0,0,0,0,0,1,0,16587,0,26124),
(37077,'Don\'t... let Finklestein use me... for his potions...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37078,'My gosh, it\'s full of rocks!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37079,'I\'d almost given up hope.','I\'d almost given up hope.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37080,'As you can see, we\'ve cleared out the rockslide.  The tremendous loss of life was regrettable, but you can now pass freely through the trogg-infested tunnel.$b$bYou\'re welcome!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37081,'How do you do, $c?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(37082,'By dusk, the flames towered into the sky. I lost everything. Everything.$B$BWhy would they burn an inn?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37083,'<Kelsuwa doesn\'t make eye contact with you.>$B$BI escaped amidst the fighting, but not before freeing all the stabled animals.$B$BI couldn\'t keep them with me. They scattered into the smoke...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37086,'Tapping','Tapping',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37087,'','Heroes of the Alliance, attack!',0,0,0,0,0,0,5,0,1,0,0,16626,26124),
(37088,'','NO! YOU MONSTER!',0,0,0,0,0,0,5,0,1,0,0,16627,26124),
(37089,'','I do what I must. Please forgive me, noble soldiers.',0,0,0,0,0,0,1,0,1,0,0,16628,26124),
(37090,'','You will have to make your way across this quarry on your own.',0,0,0,0,0,0,1,0,1,0,0,16629,26124),
(37091,'','Free any Alliance slaves that you come across. We will most certainly need their assistance in battling Tyrannus. I will gather reinforcements and join you on the other side of the quarry.',0,0,0,0,0,0,1,0,1,0,0,16630,26124),
(37093,'Intruders have entered the master\'s domain. Signal the alarms!','',0,0,0,0,0,0,0,0,1,0,16747,0,26124),
(37094,'Hrmph, fodder. Not even fit to labor in the quarry. Relish these final moments for soon you will be nothing more than mindless undead.','',0,0,0,0,0,0,0,0,1,0,16748,0,26124),
(37095,'Your last waking memory will be of agonizing pain.','',0,0,0,0,0,0,0,0,1,0,16749,0,26124),
(37096,'Minions, destroy these interlopers!','',0,0,0,0,0,0,0,0,1,0,16751,0,26124),
(37098,'Volcano rocks! Get your volcano rocks here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37099,'Volcano rocks for sale! Hot off the mountain! You want \'em, I got \'em!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37100,'Volcano rocks - new low price! You\'re gonna love my rocks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37101,'Get your volcano rocks here! ...Great for cats!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37102,'Take home a piece of the Cataclysm! Volcano rocks for sale - hot, Hot, HOT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37103,'Papers to weigh? Doors to stop? Windows to break? bam, Bam, BAM! Volcano rocks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37104,'Volcano rocks. Million and one uses. Lava, java, sauna, banana....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37105,'You must not approach the Frost Queen. Quickly, stop them!','You must not approach the Frost Queen. Quickly, stop them!',0,0,0,0,0,0,0,0,1,0,17167,17167,26124),
(37106,'Volcano rocks! Limited time offer! Papers of authenticity and everything!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37107,'Vinny, I just gotta get me a genuine Cataclysm souvenir!','Vinny, I just gotta get me a genuine Cataclysm souvenir!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37108,'','%s prepares to unleash a wave of blistering cold!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37109,'','Now, feel my master\'s limitless power and despair!',0,0,0,0,0,0,0,0,1,0,0,17016,26124),
(37110,'','In our native tongue, \"Una\'fe\" can be translated as \"Refuge.\" But the name no longer fits. From the moment we set up this camp, this strange jungle has threatened to engulf it. ',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37111,'','They attacked Taurajo while our strongest were on the hunt. By some miracle, there was a gap in the Alliance lines through which myself and some others were able to carry the little ones...$B$B<Tawane trails off, trying not to cry in front of the children.>',1,18,0,0,0,0,0,0,1,0,0,0,26124),
(37112,'','Hush, hush. It\'s okay little one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37113,'','Sleep now, little one. We\'ll find your parents soon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37114,'','There there, little hunter. I\'m here for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37115,'<Static>$bIs this thing on?  Hello?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(37116,'','I will delay here until more reinforcements arrive, but you have to keep moving.$B$BWe won\'t have much time until Arthas realizes we\'re here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37117,'Ahh, there you are.  Hello!  I figured that, while you\'re flying to Kharanos, I\'d give you some data about what\'s going on outside of Coldridge Valley.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(37118,'It seems you Coldridge folks are dreadfully under-informed about the events of the last few days.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(37119,'If you thought you had problems with trolls in Coldridge, wait \'til you get to Kharanos!  That big cataclysm got the trolls all stirred up out here.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(37120,'Free at last!','Free at last!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37121,'Thank you!','Thank you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37122,'I only understand a few words of the quilboar tongue, but I didn\'t like what I heard.','I only understand a few words of the quilboar tongue, but I didn\'t like what I heard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37123,'Are the refugees still gathering at Camp Una\'fe?','Are the refugees still gathering at Camp Una\'fe?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37124,'You\'re a savior! I don\'t know what those things wanted from us...','You\'re a savior! I don\'t know what those things wanted from us...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37125,'What is this? <Gurgle> <Snort> The $r has come? To challenge mighty Sabersnout <Snort>?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37126,'I will make example of $r <Snort>! Prepare yourself <Gurgle> soft-for-face.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37127,'%s laughs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37128,'You, <Snort> you are strong <Gurgle>. But...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37129,'Strong enough for THE BOARPOCALYPSE?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37130,'You ... survive the boars? <Snort> So many boars! So sad! <Gurgle>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37131,'<Snort>? <Gurgle>!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37132,'I must break you now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37133,'','Perish!',0,0,0,0,0,0,0,0,1,0,0,17008,26124),
(37134,'','The flaw of mortality....',0,0,0,0,0,0,0,0,1,0,0,17009,26124),
(37135,'','Perhaps... you were right, Crok. ',0,0,0,0,0,0,0,0,1,0,0,17023,26124),
(37136,'','Your incursion ends here! None shall survive!',0,0,0,0,0,0,0,0,1,0,0,17012,26124),
(37137,'','Can you feel the cold hand of death upon your heart?',0,0,0,0,0,0,0,0,1,0,0,17013,26124),
(37138,'','Suffer, mortals, as your pathetic magic betrays you!',0,0,0,0,0,0,0,0,1,0,0,17014,26124),
(37139,'','Free... at last....',0,0,0,0,0,0,0,0,1,0,0,17010,26124),
(37140,'','Enough! I tire of these games!',0,0,0,0,0,0,0,0,1,0,0,17011,26124),
(37141,'Hah hah! <Snort> You lose most everything.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37142,'Whew! I\'m never eating asparagus again.','Whew! I\'m never eating asparagus again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37143,'I\'ve had enough of this jungle!','I\'ve had enough of this jungle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37144,'Get ... me ... out of here!','Get ... me ... out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37145,'I think this jungle wants to eat me!','I think this jungle wants to eat me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37146,'Thank you! That thing was shaking me like a ragdoll.','Thank you! That thing was shaking me like a ragdoll.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37147,'I remember when the Barrens was ... barren. And we liked it!','I remember when the Barrens was ... barren. And we liked it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37148,'These appear to be the remains of Thalorien Dawnseeker, the last wielder of Quel\'Delar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37149,'Examine the remains.','Examine the remains.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37150,'Help. Help!','Help. Help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37151,'It\'s got me!','It\'s got me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37152,'Waaah - I\'m gonna be sick!','Waaah - I\'m gonna be sick!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37153,'Overloading','Overloading',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37154,'We must defend the Sunwell from the enemy at all costs.','',0,0,0,0,0,0,0,0,1,0,16769,0,26124),
(37155,'I am ordering you to withdraw to the Sunwell proper to help prepare the defenses.','',0,0,0,0,0,0,0,0,1,0,16770,0,26124),
(37156,'I will make my stand here and buy you as much time as I am able. Use it well and make our prince proud.','',0,0,0,0,0,0,0,0,1,0,16771,0,26124),
(37157,'It has been a great honor to fight beside you in defense of our land and our people.','',0,0,0,0,0,0,0,0,1,0,16772,0,26124),
(37158,'You, stranger... you are not one of my soldiers. Will you stay and stand with me to face the enemy?','',0,0,0,0,0,0,0,0,1,0,16773,0,26124),
(37159,'Listen well, Scourge defilers. None of you will reach the Sunwell so long as I stand!','',0,0,0,0,0,0,0,0,1,0,16774,0,26124),
(37160,'You will fall as your lands and your city have before you. My lord will win a great victory here, and none will remember your name!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37161,'A screeching cry pierces the air above!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37162,'Forward!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37163,'','They died so easily. No matter.',0,0,0,0,0,0,0,0,1,0,0,17022,26124),
(37164,'Augh! I must rest for a moment. \n','',0,0,0,0,0,0,0,0,1,0,16826,0,26124),
(37165,'Champions! I cannot hold her back any longer.','',0,0,0,0,0,0,0,0,1,0,16827,0,26124),
(37166,'I would like to receive training.','I would like to receive training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37167,'I shall kill you myself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37168,'','He\'s... too powerful. Heroes, quickly... come to me! We must leave this place at once! I will do what I can to hold him in place while we flee.',0,0,0,0,0,0,0,0,1,0,0,17028,26124),
(37169,'','I cannot hold him for long, we must leave at once!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37170,'','BLASTED DEAD END! So this is how it ends. Prepare yourselves, heroes, for today we make our final stand!',1,0,0,0,0,0,5,0,1,0,0,17061,26124),
(37171,'','We are safe... for now. His strength has increased tenfold since our last battle. It will take a mighty army to destroy the Lich King. An army greater than even the Horde can rouse.',1,0,0,0,0,0,1,0,1,0,0,17062,26124),
(37172,'Your allies have arrived, Jaina, just as you promised. You will all become powerful agents of the Scourge.','',1,0,0,0,0,0,0,0,1,0,17212,0,26124),
(37173,'I will not make the same mistake again, Sylvanas. This time there will be no escape. You will all serve me in death!','',1,0,0,0,0,0,0,0,1,0,17213,0,26124),
(37174,'Death\'s cold embrace awaits.','',1,0,0,0,0,0,0,0,1,0,17221,0,26124),
(37175,'Succumb to the chill of the grave.','',1,0,0,0,0,0,0,0,1,0,17218,0,26124),
(37176,'Another dead end.','',1,0,0,0,0,0,0,0,1,0,17219,0,26124),
(37177,'There is no escape!','',1,0,0,0,0,0,0,0,1,0,17217,0,26124),
(37178,'The forgemaster is dead! Get geared up men, we have a Scourgelord to kill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37179,'Ready yourself, $c.$b$bThe time has come for the Lich King\'s reign to come to an end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37180,'What is the Ashen Verdict?','What is the Ashen Verdict?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37181,'The Ashen Verdict is a select group of the most talented craftsmen in the Ebon Blade and Argent Crusade. Its creation symbolizes the unity of our forces as we mount this final assault on the Lich King and his minions.$b$bIt is through the Ashen Verdict\'s efforts that we have discovered how to bend primordial saronite to our will.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37182,'How can I learn to work Primordial Saronite?','How can I learn to work Primordial Saronite?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37183,'Speak with Alchemist Finklestein, $c. He can set you on the path.$b$bDemonstrate your loyalty and their methods shall be made known to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37184,'With Frostmourne, could I defeat the Lich King?','With Frostmourne, could I defeat the Lich King?',0,0,0,0,0,0,0,0,1,8943,0,0,26124),
(37185,'Foolishness! Do you know nothing of that accursed blade, $c?$b$bIt would devour all that you are. Whatever remained of your lifeless husk would spend eternity in the enemy\'s service.$b$bIt is that same rationale that bought Arthas his fate, costing Azeroth legions of its best champions.$b$bStill, there may be something....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37186,'Tell me then, Highlord Mograine. What can be done?','Tell me then, Highlord Mograine. What can be done?',0,0,0,0,0,0,0,0,1,8943,0,0,26124),
(37187,'I have pondered the matter unceasingly.$b$bI believe that a weapon might be fashioned which would rival Frostmourne in power without enslaving  its master.$b$bNevermind it, $r. Even if it were possible, there\'s not time to create such an artifact.$b$bIt is best that you focus your energies on our assault.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37188,'If there is any hope, you must allow me to try!','If there is any hope, allow me to try!',0,0,0,0,0,0,0,0,1,8943,0,0,26124),
(37189,'Perhaps, $c... perhaps.$b$bBut if you would be the one to attempt its creation, you must learn the ways of the Argent Verdict Forgemasters.$b$bAssociate yourself with them and show them your loyalty and dedication.$b$bWhen this is done, we shall discuss the matter further.','Perhaps, $c... perhaps.$b$bBut if you would be the one to attempt its creation, you must learn the ways of the Argent Verdict Forgemasters.$b$bAssociate yourself with them and show them your loyalty and dedication.$b$bWhen this is done, we shall discuss the matter further',0,0,0,0,0,0,0,0,1,8943,0,0,26124),
(37190,'Capturing','Capturing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37191,'Please, tell me more of this artifact, Highlord Mograine.','Please, tell me more of this artifact, Highlord Mograine.',0,0,0,0,0,0,0,0,1,8943,0,0,26124),
(37192,'Perhaps, $c... perhaps.$b$bBut if you would be the one to attempt its creation, you must learn the ways of the Argent Verdict Forgemasters.$b$bAssociate yourself with them and prove your loyalty and dedication.$b$bWhen this is done, we shall discuss the matter further.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37193,'What is Shadowfrost?','What is Shadowfrost?',0,0,0,0,0,0,0,0,1,8943,0,0,26124),
(37194,'First, the blade must be fed with the souls of those who serve our enemy. Then, before the blade draws upon their power, I must encase it in Shadowfrost. This will insulate you from the corrupting voices that would otherwise consume you... I hope. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37195,'The Lich King is near, $n. His voice taunts me...$b$bLet us silence him at last!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37196,'I... I wasn\'t meant to survive this attack.','',0,0,0,0,0,0,0,0,1,0,16775,0,26124),
(37197,'Why has this happened? Why have you come here?','',0,0,0,0,0,0,0,0,1,0,16776,0,26124),
(37198,'It\'s Quel\'Delar! You possess the sword!','',0,0,0,0,0,0,0,0,1,0,16777,0,26124),
(37199,'I don\'t know how, but the blade has chosen you to be its new wielder. Take it with my blessing, and wield it against the Scourge as I once did.','',0,0,0,0,0,0,0,0,1,0,16778,0,26124),
(37200,'Ages ago the demon lord Kil\'jaeden subjected the shaman, Ner\'zhul, to a seemingly endless torture before sealing his soul in a frozen crystal. It is this prison, forged in the depths of the twisting nether, that we have come to call the Frozen Throne.$b$bIt was not until Arthas smashed the crystal with Frostmourne that he merged with the soul of Ner\'zhul and became the Lich King. This breaking of the throne created the frozen fragments of [shadowfrost] that now lie scattered throughout the citadel.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37201,'Halt! Do not carry that blade any further!','',0,0,0,0,0,0,0,0,1,0,16675,0,26124),
(37202,'Do you realize what you\'ve done?','',0,0,0,0,0,0,0,0,1,0,16676,0,26124),
(37203,'Another faulty electrical-gas-flammable bed-fireworks accident?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37204,'You have forged this blade from saronite, the very blood of an old god. The power of the Lich King calls to this weapon.','',0,0,0,0,0,0,0,0,1,0,16677,0,26124),
(37205,'There is only one way to cleanse this sword. Make haste for the Sunwell and immerse the blade in its waters.','',0,0,0,0,0,0,0,0,1,0,16679,0,26124),
(37206,'I can resist Frostmourne\'s call no more...','',0,0,0,0,0,0,0,0,1,0,16680,0,26124),
(37207,'Why must I retrieve Light\'s Vengeance?','Why must I retrieve Light\'s Vengeance?',0,0,0,0,0,0,0,0,1,8943,0,0,26124),
(37208,'There is great potential in the hammer Arthas cast aside when he took up Frostmourne.$b$bIt has helped to bring about events that have shaped this world\'s destiny. It possesses a great capacity for power that few comprehend.$b$bWith ample saronite I can reforge the hammer into an artifact to rival Frostmourne itself.$b$bIt is then that your most dangerous trial begins....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37209,'I am eager to begin our work, Highlord Mograine!','I am eager to begin our work, Highlord Mograine!',0,0,0,0,0,0,0,0,1,8943,0,0,26124),
(37210,'Bridle your enthusiasm, $r.$b$bYou embark upon a fool\'s errand that will likely be your undoing. Forces that have corrupted the most noble among us will relentlessly assault you.$b$bKnow this; succumb and I shall have no choice but to deliver you from this world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37211,'%s prepares to attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37212,'Get on board, now! This whole mountainside could collapse at any moment.','',1,0,0,0,0,0,0,0,1,0,16733,0,26124),
(37213,'Quickly, climb aboard! We mustn\'t tarry here! There\'s no telling when this whole mountainside will collapse.','',1,0,0,0,0,0,0,0,1,0,16722,0,26124),
(37214,'Defend the hill!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37215,'Success! The hill is yours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37216,'Defeat! The defenders couldn\'t hold the hill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37217,'The Grimtotem will never surrender!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37218,'Tiny creatures under feet, you bring Garfrost something good to eat!','',0,0,0,0,0,0,0,0,1,0,16912,0,26124),
(37219,'Will save for snack. For later.','',0,0,0,0,0,0,0,0,1,0,16913,0,26124),
(37220,'That one maybe not so good to eat now. Stupid Garfrost! BAD! BAD!','',0,0,0,0,0,0,0,0,1,0,16914,0,26124),
(37221,'Garfrost hope giant underpants clean. Save boss great shame. For later.','',0,0,0,0,0,0,0,0,1,0,16915,0,26124),
(37222,'Our work must not be interrupted! Ick, take care of them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37223,'We could probably use these parts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37224,'Arms and legs are in short supply! Thanks for your contribution!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37225,'I\'ve changed my mind, go get that one instead!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37226,'What are you attacking him for? The dangerous one is over there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37227,'Yo! I\'m here representing the Crown Chemical Company.$B$BYou looking for a gift? A job? Maybe a little something for yourself? Well, you\'ve come to the right place, friend.$B$BIf I don\'t have what you need, our mascot Kwee or the Lovely Merchant beside me will.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37228,'Okay, Sassy, I\'m ready to go.','Okay, Sassy, I\'m ready to go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37229,'We\'ll make use of these supplies to get everyone ready for a fight.$B$BContinue on. We\'ll meet you ahead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37230,'I\'ll gather up the rest of slaves and get them ready to fight. We\'ll catch up with you before you engage Scourgelord Tyrannus.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37231,'From the safety of Camp Taurajo I once trained young hunters in the ways of the wild.$B$BWe have no such luxury now - skills must be learned in the heat of battle against a foe camped on our very doorstep.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(37232,'Heroes! We will hold off the undead as long as we can, even to our dying breath. Deal with the Scourgelord!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37233,'Alas, brave, brave adventurers, your meddling has reached its end. Do you hear the clatter of bone and steel coming up the tunnel behind you? That is the sound of your impending demise.','',0,0,0,0,0,0,0,0,1,0,16758,0,26124),
(37234,'Ha, such an amusing gesture from the rabble. When I have finished with you, my master\'s blade will feast upon your souls. Die.','',0,0,0,0,0,0,0,0,1,0,16759,0,26124),
(37235,'We will follow your lead, heroes. The Scourgelord will die this eve.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37236,'scatters a handful of grain into the wind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37237,'Thank you!','Thank you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37238,'It\'s true then?  Even those afflicted by the Curse are fighting the Forsaken!','It\'s true then?  Even those afflicted by the Curse are fighting the Forsaken!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37239,'The Forsaken will pay for what they\'ve done!','The Forsaken will pay for what they\'ve done!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37240,'What\'s this I hear about a party? I wasn\'t invited!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37241,'You\'re all lazy! Get back to work. Especially you, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37242,'It\'s demotions for everyone if the Sharks beat the Buccaneers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37243,'Is that you, $n? What are you doing away from headquarters? Get back to work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37244,'All hail the greatest trade prince on Azeroth... me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37245,'Thank you for your hard work and dedication. Unpaid overtime is approved for all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37246,'Drink Kaja\'Cola!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37247,'I\'m beginning to regret promoting you, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37248,'So, it has begun....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37249,'Behold! The binding of sacred and corrupt; the forging of Shadow\'s Edge, a weapon of untold potential!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37250,'Bend it to your will, and you shall wield unspeakable power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37251,'Fail, and your soul shall forever be its slave.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37252,'A final warning, mortal; Fail, and you shall fall by my hand!\n\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37253,'Work harder, you maggots!  This ore is not going to mine itself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37254,'Consider yourselves lucky to be alive, Gilnean dogs!  Now get to work before we change our minds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37255,'This mine and everything in it are now property of Queen Sylvanas.  That includes all you worms -- so get back to work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37256,'','Hang on! I\'m putting the pedal to the metal!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37257,'','We\'ll have to go around.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37258,'','OUT OF THE WAY!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37259,'','Here we are, safe and... OH NO! We\'ve been double-crossed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37260,'%s casts |cFF00AACCDeep Freeze|r at $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37261,'Thank you, heroes. I will stay behind and round up the slaves as you free them. If you kill the Forgemaster to the east, we should be able to get ourselves equipped for battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37262,'I thought I might die in this pit. Thank you!','I thought I might die in this pit. Thank you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37263,'I owe you a long night of drinking, my friend.','Have my babies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37264,'Don\'t let a single one of them live.','Don\'t let a single one of them live.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37265,'Please, carry out our vengeance on the Scourgelord.','Please, carry out our vengeance on the Scourgelord.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37266,'When you kill the Pit Master, spit on his corpse for me, will you?','When you kill the Pit Master, spit on his corpse for me, will you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37267,'I can barely feel my arms, but I\'ll stand with you once I find some weapons.','I can barely feel my arms, but I\'ll stand with you once I find some weapons.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37268,'I\'d lost all track of time in this forsaken place. You\'re a sight for sore eyes, friend.','I\'d lost all track of time in this forsaken place. You\'re a sight for sore eyes, friend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37269,'You\'re a beautiful sight... you have no idea.','You\'re a beautiful sight... you have no idea.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37270,'Too many of us died in this pit. Far too many.','Too many of us died in this pit. Far too many.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37271,'I\'m so glad you\'re here. I wouldn\'t have made it much longer.','I\'m so glad you\'re here. I wouldn\'t have made it much longer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37272,'I\'ll join you as soon as I catch my breath, heroes. Thank you.','I\'ll join you as soon as I catch my breath, heroes. Thank you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37273,'Now is the time for revenge.','Now is the time for revenge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37274,'You deserve a mighty man-hug.','I could just kiss you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37275,'I will find a way to repay you someday, hero.','I will find a way to repay you someday, hero.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37276,'I can hardly believe my eyes. Thank you. Really, thank you.','I can hardly believe my eyes. Thank you. Really, thank you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37277,'%s nods his thanks.','%s nods her thanks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37278,'%s offers an appreciative smile.','%s offers an appreciative smile.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37279,'%s almost collapses as he stumbles towards you.','%s almost collapses as he stumbles towards you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37280,'%s stares at you for a moment, clearly finding it hard to believe that you\'re real.','%s stares at you for a moment, clearly finding it hard to believe that you\'re real.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37281,'%s offers a quick, cynical laugh at his fortune.','%s offers a quick, cynical laugh at her fortune.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37282,'%s raises an empty hand in toast to you.','%s blows a kiss your way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37283,'%s closes his eyes, savoring freedom for a moment.','%s closes her eyes, savoring freedom for a moment.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37284,'%s lets his mining pick drag on the ground as she approaches, clearly exhausted.','%s lets her mining pick drag on the ground as she approaches, clearly exhausted.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37285,'I\'m with you, hero.','I\'m with you, hero.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37286,'I owe you my life.','I owe you my life.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37287,'If by life or death I can repay you, I will.','If by life or death I can repay you, I will.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37288,'I\'ll fight by your side. Offer them no mercy.','I\'ll fight by your side. Offer them no mercy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37293,'I\'m going to return to help free the rest of the slaves.  Thank you again, hero.','I\'m going to return to help free the rest of the slaves.  Thank you again, hero.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37294,'I\'m going to return to the front of the quarry. Kill a few extra for me.','I\'m going to return to the front of the quarry. Kill a few extra for me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37295,'','The Barrens may be dry, but these plains once teemed with life. We roamed, we hunted, and we lived off the land.$B$BThen the Alliance came... slashing, burning, killing. We call these the Fields of Blood now, $c.$B$BThe refugees have all fled. Those who remain behind remain to fight.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37296,'','The gate\'s meager defenses are prepared, $n. Are you?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(37297,'','Thank you, $n! With Baine and our Horde allies working together, we may yet push the invaders back to the swamp they washed in from.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37298,'Placeholder! WHAMS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37299,'I am ready. Send me to the gates!','I am ready. Send me to the gates!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37300,'Stickybombing','Stickybombing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37301,'Ghouls, slay this pathetic high elf!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37302,'You will fall before the might of the Scourge. Crypt raiders, attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37303,'This is an Emergency Evacuation Portal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37304,'Take me out of the city.','Take me out of the city.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37305,'','$n - please see me. I need your help.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(37306,'Be on your guard! The weather worsens, and the elementals are soon to follow! Seek shelter!','Be on your guard! The weather worsens, and the elementals are soon to follow! Seek shelter!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(37307,'Clear the streets!  The skies darken and elementals will soon attack.  Be on your guard!','Clear the streets!  The skies darken and elementals will soon attack.  Be on your guard!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(37308,'The disease has been cured and you feel normal again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37309,'Hurry it up. The soldiers have already pulled out of here.','Hurry it up. The soldiers have already pulled out of here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37310,'Grab anything you think we can fence.','Grab anything you think we can fence.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37311,'Have we cleaned out the inn yet? Burn the rest of it when you\'re done!','Have we cleaned out the inn yet? Burn the rest of it when you\'re done!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37312,'Most of this stuff is beads and hides. Where\'s all the treasure?','Most of this stuff is beads and hides. Where\'s all the treasure?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37313,'Time is wasting. I want this place picked clean before they counter-attack.','Time is wasting. I want this place picked clean before they counter-attack.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37314,'Hey, did anyone loot the mailbox yet?','Hey, did anyone loot the mailbox yet?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37315,'There\'s got to be more. Doublecheck the bodies!','There\'s got to be more. Doublecheck the bodies!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37316,'Unwrap your Awesome Party Ensemble and wear your Cool Shades, Hip New Outfit, and Shiny Bling!','Unwrap your Awesome Party Ensemble and wear your Cool Shades, Hip New Outfit, and Shiny Bling!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37317,'Has anyone seen the quilboar they had caged up over here?','Has anyone seen the quilboar they had caged up over here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37318,'','Go get \'em, boss!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37319,'I ran to wake up the others when the attack hit. Were they able to escape? I tried to fight off the soldiers with a skinning knife...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37320,'Brave champions, we owe you our lives, our freedom.... Though it be a tiny gesture in the face of this enormous debt, I pledge that from this day forth, all will know of your deeds, and the blazing path of light you cut through the shadow of this dark citadel. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37321,'This day will stand as a testament not only to your valor, but to the fact that no foe, not even the Lich King himself, can stand when Alliance and Horde set aside their differences and---','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37322,'I can feel the embrace now of all living things, the Earthmother\'s eternal peace. Thank you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37323,'','Alliance - they\'ve surrounded the camp! What are they doing here? Why are they attacking Taurajo? Get the children - run! RUN!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37324,'No, stay with the others. Escort them north, away from the fighting. I will stay here with the wyverns and cover your escape. Go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37325,'...wait, it is over? I\'ve been run through ... Ah. Of course. I understand now. I am expected elsewhere.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37326,'I\'ve got it: Squeezeable rocks!','I\'ve got it: Squeezeable rocks!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37327,'Leashes... with pre-attached pets.','Leashes... with pre-attached pets.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37328,'Shirts with leg-holes. Reversable shirtshorts!','Shirts with leg-holes. Reversable shirtshorts!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37329,'Tauren Paladins!','Tauren Paladins!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37330,'Chocolate-flavored vanilla!','Chocolate-flavored vanilla!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37331,'Motorized gravy-boat. With laser lump vaporizer.','Motorized gravy-boat. With laser lump vaporizer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37332,'Headshoes!','Headshoes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37333,'How about this: Instant water! Just add... oh.','How about this: Instant water! Just add... oh.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37334,'So I have this idea for a movie. Three gnomes find a bracelet of power...','So I have this idea for a movie. Three gnomes find a bracelet of power...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37335,'It\'s like bungie-jumping, right? But without a cord, see? And you start at the bottom. I guess it\'s just sorta like regular jumping. But with guns.','It\'s like bungie-jumping, right? But without a cord, see? And you start at the bottom. I guess it\'s just sorta like regular jumping. But with guns.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37336,'Edible rocket fuel!','Edible rocket fuel!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37337,'Portable gasoline squirt-guns!','Portable gasoline squirt-guns!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37338,'Half man...half sharkalligator!','Half man...half sharkalligator!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37339,'Thirteen-sided dice!','Thirteen-sided dice!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37340,'Goblins with gills!','Goblins with gills!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37341,'Attach two vehicles to a bigger vehicle, and then have the passengers jump from one vehicle to the other!','Attach two vehicles to a bigger vehicle, and then have the passengers jump from one vehicle to the other!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37342,'Electrical wires used to send messages over great distances... no, impractical. Giant rockets, with speakers attached....','Electrical wires used to send messages over great distances... no, impractical. Giant rockets, with speakers attached....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37343,'Feed pigs rubber, \'til they bounce. There\'s got to be an application for that.','Feed pigs rubber, \'til they bounce. There\'s got to be an application for that.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37344,'Murder permits!','Murder permits!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37345,'Gloves with built-in clappers, for hands-free clapping.','Gloves with built-in clappers, for hands-free clapping.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37346,'State-sponsored healthcare!','State-sponsored healthcare!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37347,'A truck that delivers ice-cream. With a catapult.','A truck that delivers ice-cream. With a catapult.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37348,'How about smiling monkey wallets?','How about smiling monkey wallets?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37349,'Dwarves. In. Space!','Dwarves. In. Space!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37350,'A spring-loaded plunger with blades attached, for processing food. Or people you disagree with.','A spring-loaded plunger with blades attached, for processing food. Or people you disagree with.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37351,'Bathrobes with integrated shower-nozzles.','Bathrobes with integrated shower-nozzles.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37352,'Clowns. Except instead of making you laugh, they\'re there for beating.','Clowns. Except instead of making you laugh, they\'re there for beating.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37353,'Nose-stenders. For smelling things in different rooms.','Nose-stenders. For smelling things in different rooms.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37354,'Invisible bunnies!  We\'ll put them all over the place, and they\'ll control everything!','Invisible bunnies!  We\'ll put them all over the place, and they\'ll control everything!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37355,'What if we were to ORGANIZE crime?','What if we were to ORGANIZE crime?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37356,'We put a whole town... in a tiny little box!','We put a whole town... in a tiny little box!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37357,'A big convention, see? To show off all of our inventions. We\'ll call it GoblinCon. And we\'ll give away special pets! Except most people will probably sell them for profit on the auction house.','A big convention, see? To show off all of our inventions. We\'ll call it GoblinCon. And we\'ll give away special pets! Except most people will probably sell them for profit on the auction house.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37358,'A binary number system. It uses only two numbers. 6 and 11.','A binary number system. It uses only two numbers. 6 and 11.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37359,'Giant gnomes. No, wait... tiny giants!','Giant gnomes. No, wait... tiny giants!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37360,'Invisible condiments. For an unobstructed view of your food.','Invisible condiments. For an unobstructed view of your food.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37361,'Shoes with wheels on them. And gloves with wheels - for when you fall down.','Shoes with wheels on them. And gloves with wheels - for when you fall down.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37362,'Soap on a rope! Attached to a chain. Mounted via a steel cable. To some soap.','Soap on a rope! Attached to a chain. Mounted via a steel cable. To some soap.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37363,'Edible beds. So you can have breakfast in bed. Beds... for breakfast!','Edible beds. So you can have breakfast in bed. Beds... for breakfast!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37364,'A globe that shows the inside of the planet... on the outside. So you know where to dig!','A globe that shows the inside of the planet... on the outside. So you know where to dig!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37365,'Stairways... for horizontal surfaces!','Stairways... for horizontal surfaces!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37366,'Hey, pal, I don\'t know who you are or why you\'ve been following me around, but I\'m about to board a ship and I want to be left alone, got it?','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(37367,'I have a rocket here with your mark on it, Snivel.','I have a rocket here with your mark on it, Snivel.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37368,'%s casts |cFFFFFF00Mirrored Soul!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37369,'','Excellent work, champions! We shall set up our base camp in these chambers. My magi will get the Scourge transport device working shortly. Step inside it when you are ready for your next mission. I will meet you on the other side.',0,0,0,0,0,0,5,0,1,0,0,16625,26124),
(37370,'','Thank the Light for seeing you here safely! We have much work to do if we are to defeat the Lich King and put an end to the Scourge.',0,0,0,0,0,0,5,0,1,0,0,16617,26124),
(37371,'','Our allies within the Argent Crusade and the Knights of the Ebon Blade have broken through the front gate of Icecrown and are attempting to establish a foothold within the citadel. ',0,0,0,0,0,0,1,0,1,0,0,16618,26124),
(37372,'','Their success hinges upon what we discover within these cursed halls. Although our mission is fraught with peril, we must persevere!',0,0,0,0,0,0,1,0,1,0,0,16619,26124),
(37373,'','With the attention of the Lich King drawn towards the front gate, we will be working our way through the side in search of information that will enable us to defeat the Scourge once and for all.',0,0,0,0,0,0,1,0,1,0,0,16620,26124),
(37374,'','King Varian\'s SI:7 agents have gathered information about a private sanctum of the Lich King\'s deep within a place called the Halls of Reflection. ',0,0,0,0,0,0,1,0,1,0,0,16621,26124),
(37375,'','We will carve a path through this wretched place and find a way to enter the Halls of Reflection. I sense powerful magic hidden away within those halls. Magic that could be the key to destroying the Scourge!',0,0,0,0,0,0,1,0,1,0,0,16622,26124),
(37376,'','Your first mission is to destroy the machines of death within this malevolent engine of souls and clear a path for our soldiers. ',0,0,0,0,0,0,1,0,1,0,0,16623,26124),
(37377,'','Make haste, champions! I will prepare the troops to fall in behind you.',0,0,0,0,0,0,5,0,1,0,0,16624,26124),
(37379,'Grabbing','Grabbing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37380,'','The Argent Crusade and the Knights of the Ebon Blade have assaulted the gates of the Icecrown Citadel and are preparing for a massive attack upon the Scourge. Our mission is a bit more subtle, but equally as important.',0,0,0,0,0,0,1,0,1,0,0,17038,26124),
(37381,'','With the attention of the Lich King turned towards the front gate, we\'ll be working our way through the side in search of information that will enable us to defeat him - once and for all.',0,0,0,0,0,0,1,0,1,0,0,17039,26124),
(37382,'','Our scouts have reported that the Lich King has a private chamber, outside of the Frozen Throne, deep within a place called the Halls of Reflection. That is our target, champions. ',0,0,0,0,0,0,1,0,1,0,0,17040,26124),
(37383,'','We will cut a swath of destruction through this cursed place and find a way to enter the Halls of Reflection. If there is anything of value to be found here, it will be found in the halls.',0,0,0,0,0,0,5,0,1,0,0,17041,26124),
(37384,'','The Dark Lady watches over you. Make haste!',0,0,0,0,0,0,1,0,1,0,0,17043,26124),
(37387,'','Excellent work, champions! We shall set up our base camp in these chambers. My magi will get the Scourge transport device working shortly. Step inside when you are ready for your next mission. I will meet you on the other side.',0,0,0,0,0,0,1,0,1,0,0,17044,26124),
(37388,'So it is. You have my thanks, $n, for restoring Quel\'Delar to its rightful owners.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37389,'What is the meaning of this treachery?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37390,'Drop your weapon and surrender, traitor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37391,'Our champions have lost much blood in the struggle to activate this Scourge transporter. We must be prepared to return the favor. Follow me, men!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37392,'','Soldiers of the Horde, attack!',0,0,0,0,0,0,5,0,1,0,0,17045,26124),
(37393,'','Pathetic weaklings.',0,0,0,0,0,0,1,0,1,0,0,17046,26124),
(37394,'','You will have to battle your way through this cesspit on your own.',0,0,0,0,0,0,1,0,1,0,0,17047,26124),
(37395,'','Free any Horde slaves that you come across. We will most certainly need their assistance in battling Tyrannus. I will gather reinforcements and join you on the other side of the quarry.',0,0,0,0,0,0,0,0,1,0,0,17048,26124),
(37397,'','I will delay here until more reinforcements arrive, but you must keep moving. Arthas will soon realize that we\'re here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37398,'Bloody Forsaken!  They\'ll pay for what they\'ve done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37399,'This is our land -- they\'re not going to take it away without a fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37400,'We will not die as slaves... we\'re Gilneans!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37401,'Drink Kaja\'Cola!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37402,'All new Kaja\'Cola! Now with 100 percent more ideas!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37403,'Take the Kaja\'Cola Taste Test Challenge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37404,'Kaja\'Cola! It gives you IDEAS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37405,'Kaja\'Cola! Jinxy the Weasel says, Drink it... or else!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37406,'Kaja\'Cola is a proud sponsor of the Bilgewater Buccaneers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37407,'Kaja\'Cola! When your tinkering has to be second to none!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37408,'Enjoy the refreshingly intelligent taste of all new Kaja\'Cola!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37409,'Corpse-men take Koroth\'s banner!  Corpse-men get smashed to bitses!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37410,'Just in time, $n.  Here come the Forsaken.','',0,0,0,0,0,0,0,0,1,0,19605,0,26124),
(37411,'You will come no further, Forsaken scum!  By the war banner of the ancient Greymane clan, I expel you from our ancestral lands!','',0,0,0,0,0,0,0,0,1,0,19606,0,26124),
(37412,'Worthless mongrel.  I will order our outhouses cleaned with this rag you call a banner.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37413,'Fake food! Created by grinding up real food and pressing it into shapes of different food. With artificial flavoring!','Fake food! Created by grinding up real food and pressing it into shapes of different food. With artificial flavoring!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37414,'Mom detectors.','Mom detectors.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37415,'Houses made of dirt! When you clean them... THEY\'RE GONE.','Houses made of dirt! When you clean them...THEY\'RE GONE.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37416,'Recycling! But, for stuff that\'s never been used before.','Recycling! But, for stuff that\'s never been used before.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37417,'Flerberts. I\'m not sure what they do, but I\'d better lock down the name with a trademark.','Flerberts. I\'m not sure what they do, but I\'d better lock down the name with a trademark.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37418,'Spoon sharpeners!','Spoon sharpeners!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37419,'One-sided paper!','One-sided paper!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37420,'Bagel-holes!','Bagel-holes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37421,'Water-proof soap!  For underwater use!','Water-proof soap!  For underwater use!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37422,'Handheld one-way mirrors!','Handheld one-way mirrors!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37423,'Mouse-sized beartraps... no... Bear-sized mousetraps!!','Mouse-sized beartraps... no... Bear-sized mousetraps!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37424,'Upside-down boats!  They\'ll never capsize!','Upside-down boats!  They\'ll never capsize!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37425,'Explosive fire extinguishers!  We\'ll fight fire... WITH fire!','Explosive fire extinguishers!  We\'ll fight fire... WITH fire!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37426,'Tether-footbomb!','Tether-footbomb!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37427,'Games you can play with your face!','Games you can play with your face!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37428,'String-less kites!','String-less kites!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37429,'Earwax. It\'s got to be good for SOMETHING.','Earwax. It\'s got to be good for SOMETHING.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37430,'This is not my doing, Rommath. There is no treachery here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37431,'Call off your men. Lor\'themar\'s own foolishness caused his injuries. Quel\'Delar is not chosen; it chooses its master.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37432,'Guards, return to your posts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37433,'It seems the captain is correct. Quel\'Delar is not to be ours after all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37434,'You will have what you have come for, $n. Take the sword and begone. And you, Auric, have a care what you say in this sacred place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37435,'By the light, the transporter worked!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37436,'The chill of this place freezes the marrow of my bones. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37437,'I can feel the Lich King reaching out...watching us. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37438,'%s hurls a massive saronite boulder at you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37439,'My Lord Regent! What have they done to you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37440,'Carry the sword back to Dalaran through that portal, $n. You have done what many quel\'dorei have dreamt of for years. Quel\'Delar has been restored at last.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37441,'Can that really be Quel\'Delar?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37442,'We shall see.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37443,'The master\'s sanctum has been disturbed!','',0,0,0,0,0,0,0,0,1,0,16865,0,26124),
(37444,'Look at it, Lor\'themar. It is certainly Quel\'Delar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37445,'\'Twas a fierce battle, $n! Take a moment to rest and gather yer forces. Who knows what lies beyond that door?$B$BLet me know when yer ready and we\'ll begin our ascent into the upper reaches of the citadel.','',5,1,273,0,0,0,0,0,1,0,0,0,26124),
(37446,'We\'re ready, Muradin.','We\'re ready, Muradin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37447,'Are ye sure, $g lad:lass;? Ye don\'t need another minute or two?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(37448,'We\'re sure. Let\'s go!','We\'re sure. Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37449,'It is indeed Quel\'Delar. I had not thought I\'d live to see the day when Thalorien Dawnseeker\'s legendary sword would be restored to us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37450,'You are a hero and an inspiration to the sin\'dorei, $n, a symbol of our endurance in the face of tragedy and treachery.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37451,'The regent speaks truly, $n. Thalorien\'s sacrifice could not prevent the fall of this very Sunwell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37452,'When you found the sword, it was broken and abandoned, much like Silvermoon after Kael\'thas\'s betrayal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37453,'Let Quel\'Delar be a sign that we will never give up, that we will face any enemy without fear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37454,'Quel\'Delar is not held in high esteem by the sin\'dorei alone. It holds a place in the heart of all children of Silvermoon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37455,'This blade has been returned to us for a reason, my lords. Now is the time to rally behind the bearer of Quel\'Delar and avenge the destruction of Silvermoon and the Sunwell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37456,'Reclaim the sword, $n, and bear it through that portal to Dalaran. Archmage Aethas Sunreaver will be waiting to congratulate you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37457,'Let\'s get a move on then! Move ou...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37458,'For every Horde soldier that you killed -- for every Alliance dog that fell, the Lich King\'s armies grew. Even now the val\'kyr work to raise your fallen as Scourge.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37459,'Things are about to get much worse. Come, taste the power that the Lich King has bestowed upon me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37460,'A lone orc against the might of the Alliance???','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37461,'Charge!!!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37462,'This is Desolation Hold, $c. Here we bide our time until we are ready to strike back against the Alliance.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37463,'Make this quick, $c. The Warchief personally sent me to evaluate our progress in the Barrens, and when I get here I find our towns aflame and Alliance dogs running amok.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(37464,'You have a lot of potential, $n. I\'m going to need soldiers like you if we\'re going to regain the initiative here in the Barrens.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37465,'I knew this was a dragonforged blade when I first laid eyes on it.','',0,0,0,0,0,0,0,0,1,0,16604,0,26124),
(37466,'But can it be? Is this really --','',0,0,0,0,0,0,0,0,1,0,16605,0,26124),
(37467,'Are you ready to ride to Desolation Hold as my Vanguard, $n?$B$BGar\'dul may try to give you the runaround. Let him know his judgment is coming.','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(37468,'I am ready to ride, Warlord!','I am ready to ride, Warlord!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37469,'The style of this blade and its markings hinted that it might be a dragonforged sword. At last, we will have our answer.','',0,0,0,0,0,0,0,0,1,0,16745,0,26124),
(37470,'After all these years, can it really be --','',0,0,0,0,0,0,0,0,1,0,16746,0,26124),
(37471,'Dwarves...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37472,'I\'m here on behalf of Warlord Bloodhilt, who wants you to know he will be arriving shortly.','I\'m here on behalf of Warlord Bloodhilt, who wants you to know he will be arriving shortly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37473,'Warlord Bloodhilt? Garrosh\'s pet?$B$BThere\'s no need for him to be here, as you can see, ah, tell him I have the situation well in hand.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(37474,'I\'ll be sure to tell the Taurajo refugees that. Those that lived.','I\'ll be sure to tell the Taurajo refugees that. Those that lived.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37475,'But, ah, supplies have been tight. I\'ve got, ah, a manpower shortage. Tell Bloodhilt that, ah -','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(37476,'Tell him yourself. He\'s almost here!','Tell him yourself. He\'s almost here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37477,'I... Am... Released...','',0,0,0,0,0,0,0,0,1,0,16697,0,26124),
(37478,'','The Frost Queen is gone. We must keep moving - our objective is near.',0,0,0,0,0,0,1,0,1,0,0,16615,26124),
(37479,'','Heroes, to me!',0,0,0,0,0,0,0,0,1,0,0,16614,26124),
(37480,'','I... I could not save them... Damn you, Arthas! DAMN YOU!',0,0,0,0,0,0,274,0,1,0,0,16616,26124),
(37481,'Don\'t delay, he\'s - ah - he\'s almost here!$B$BMeet me at the top of the northernmost tower.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(37482,'Thank you, $n. I trust you will, ah, defer to my authority on this matter.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37483,'What do you need, $c?$b$bStormwind is under siege by elementals!  We have evacuated most of the city and our guards are fighting to hold the elementals at bay.$b$bI suggest you head to a safer area.  We do not have the manpower to defend the city and worry about you.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(37484,'','Quel\'Delar.',0,0,0,0,0,0,0,0,1,0,0,16808,26124),
(37485,'','As Quel\'Serrar was forged by the dragons and given to the kaldorei, its twin, Quel\'Delar, was given to my people.',0,0,0,0,0,0,0,0,1,0,0,16809,26124),
(37486,'','The king bestowed the blade upon my friend, Thalorien Dawnseeker.',0,0,0,0,0,0,0,0,1,0,0,16800,26124),
(37487,'','But even Thalorien\'s skill and Quel\'Delar\'s magic could not save Silvermoon from the might of the Scourge.',0,0,0,0,0,0,0,0,1,0,0,16801,26124),
(37488,'','Thalorien fell before the gates of the Sunwell, buying time for others to escape.',0,0,0,0,0,0,0,0,1,0,0,16802,26124),
(37489,'I swore that nothing would stir me to take up this blade again.$B$BI was a fool.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37490,'','After the battle, I recovered the sword from the field. I bore it to Northrend in the service of my prince, seeking to avenge our people\'s defeat.',0,0,0,0,0,0,0,0,1,0,0,16803,26124),
(37491,'','Arthas shattered our forces and took the most powerful of us into his service as the San\'layn.',0,0,0,0,0,0,0,0,1,0,0,16804,26124),
(37492,'','My memories of Thalorien went cold and so did his blade.',0,0,0,0,0,0,0,0,1,0,0,16805,26124),
(37493,'','It was I who brought Quel\'Delar here, to return it to its makers. In breaking the weapon, so did I break its power.',0,0,0,0,0,0,0,0,1,0,0,16806,26124),
(37494,'','Quel\'Delar will never serve another!',0,0,0,0,0,0,0,0,1,0,0,16807,26124),
(37495,'So this is where you\'re hiding, Gar\'dul.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37496,'You cower behind your walls! If it wasn\'t for $n here the Alliance would be marching through Mulgore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37497,'Your excuses sicken me! Consider yourself relieved of command.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37498,'So! You DO have a spine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37499,'Hiding? Listen Bloodhilt - I\'ve, ah, reinforced our grip on the Barrens.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37500,'But they\'ve, ah, they\'ve gotten reinforcements! From the Eastern Kingdoms. Whereas I\'ve been, ah, cut off -','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37501,'Relieved? Over my dead body!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37502,'%s gasps for air.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37503,'That was Saurfang\'s boy - the Horde commander at the Wrath Gate. Such a tragic end...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37504,'What in the... There, in the distance!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37505,'Soldiers, fall in! Looks like the Horde are comin\' to take another shot!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37506,'So predictable...','',0,0,0,0,0,0,0,0,1,0,17252,0,26124),
(37507,'Did you truly expect to fulfill Mograine\'s task unopposed?','',0,0,0,0,0,0,0,0,1,0,17253,0,26124),
(37508,'You both shall suffer as his father does...','',0,0,0,0,0,0,0,0,1,0,17254,0,26124),
(37509,'...in eternal unrest!','',0,0,0,0,0,0,0,0,1,0,17255,0,26124),
(37510,'Die well, fool.','',0,0,0,0,0,0,0,0,1,0,17256,0,26124),
(37511,'','You are fools to have come to this place. The icy winds of Northrend will consume your souls!',0,0,0,0,0,0,0,0,1,0,0,17007,26124),
(37512,'I\'ve got it this time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37513,'%s cries out in death with an echoing roar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37514,'It falls to us to see Quel\'Delar restored for the Sunreavers.','',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(37515,'Wait, ah - wait! I yield. I yield!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37516,'Yield? You ... YIELD?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37517,'What part of \"Victory or Death\" don\'t you understand!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37518,'I vow that the Silver Covenant will see Quel\'Delar restored.','',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(37519,'This is it. I can sense that this was once the site of great tragedy; mortal suffering still echoes through it. No doubt this is what the horrors beyond have seized onto.$B$BTo fully seal this intrusion into our world, I must first fully open it. I will need your strength to hold back whatever may attempt to come through.$B$BAre you prepared?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37520,'I\'m ready, Naralex.','I\'m ready, Naralex.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37521,'Opening','Opening',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37522,'Garrosh\'s Horde does not tolerate failure.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37523,'Meet me down below and we\'ll discuss our upcoming counter-attack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37524,'Don\'t force me hand, orc. We can\'t let ye pass.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37525,'Behind you lies the body of my only son. Nothing will keep me from him. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37526,'I... I can\'t do it. Get back on yer ship and we\'ll spare yer life. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37527,'Stand down, Muradin. Let a grieving father pass.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37528,'Blood and thunder, my son.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(37529,'I will not forget this... kindness. I thank you, Highness','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37530,'I... I was not at the Wrath Gate, but the soldiers who survived told me much of what happened. Your son fought with honor. He died a hero\'s death. He deserves a hero\'s burial.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37531,'%s nods.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37532,'hmpf','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37533,'You have done much in this war against the Scourge. May the light embrace you. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37534,'The loss of our comrades was unpreventable. They lived and died in the service of the Argent Crusade.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37535,'What can possibly redeem this unholy place? Thank you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37536,'Beware the dangers that lie ahead... and do try to remain in one piece. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37537,'Rocket Pack Active!','Rocket Pack Active!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37538,'Rocket Pack Disabled. Move closer to Zafod Boombox to re-activate.','Rocket Pack Disabled. Move closer to Zafod Boombox to re-activate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(37539,'You\'ll make a great addition to Silas\' menagerie, Lobos.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37540,'','Take cover behind me! Quickly!',0,0,0,0,0,0,5,0,1,0,0,17037,26124),
(37541,'','I thought he\'d never shut up. At last, Sindragosa silenced that long-winded fool. To the Halls of Reflection, champions! Our objective is near... I can sense it.',0,0,0,0,0,0,5,0,1,0,0,17036,26124),
(37542,'','%s cries.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37543,'Jaina? Why are you crying?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37544,'','%s wipes her tears away and smiles at King Varian Wrynn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37545,'Bah! Muradin, secure the deck and prepare our soldiers for an assault on the upper citadel. I\'ll send out another regiment from Stormwind.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37546,'','It was nothing, your majesty. Just... I\'m proud of my king.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37547,'Right away, yer majesty!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37548,'','We have no time to waste, $c. Why do you delay here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37549,'What would you have of me, Banshee Queen?','What would you have of me, Banshee Queen?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37550,'','We do not have much time, hero. What do you need?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37551,'What would you have of me, my lady?','What would you have of me, my lady?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37552,'Magister Hathorel said you might be able to lend me a certain tabard.','Magister Hathorel said you might be able to lend me a certain tabard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37553,'I\'ve brought in the best gnomes we\'ve got to get those doors open, $n! They\'re estimatin\' that it\'s gonna take another $4939W days before that door comes down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37554,'<He looks at the rocket and flashes a nervous grin.>$b$bOkay, yeah, so maybe I made a couple rockets for some guys. So what? The gold was good and I was paid for my work. It\'s not like anyone died. That\'s about as honest as work gets. What\'s it to you?','',273,6,0,0,0,0,0,0,1,0,0,0,26124),
(37555,'There\'s a chemical inside the rocket. What is it?','There\'s a chemical inside the rocket. What is it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37556,'Look, I don\'t know, okay? I don\'t know!$b$bI just got paid to make rockets that deliver an airborne chemical payload, and that\'s what I did. Job\'s done, pal. They\'re all made, packaged, and sent off. I got the money and I was TRYING to enjoy myself a little when you started chasing me all over town.  I don\'t have any more of that chemical and I don\'t know what it was.','',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(37557,'Where were they delivered?','Where were they delivered?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37558,'You expect me to remember all that off the top of my head? Look. They didn\'t pay me enough to put up with this, and the contract only asked for my silence. So I\'m just gonna drop my ledger on the floor here, and you\'re going to take it and leave me alone.$b$bGot it?','',6,1,25,0,0,0,0,0,1,0,0,0,26124),
(37559,'Did you know about our \"Charitable Charms\" program?$B$BOfficial Crown event mascots like myself are authorized to distribute Lovely Charm Collector\'s Kits.$B$BYou can then use the Lovely Charms you gather to create Lovely Charm Bracelets for friends and loved ones, or turn them in to Lovely Merchants for Love Tokens!$B$BOne popular activity is making bracelets for your favorite leaders to let them know they\'re appreciated and adored...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37560,'Good show!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37561,'I\'d like a Lovely Charm Collector\'s Kit.','I\'d like a Lovely Charm Collector\'s Kit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37562,'I told you what I know, now shove off!','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(37563,'Whatever you need, Brazie Getz! Get it?$B$BAnd I\'m not just talkin\' about the \"legal\" stuff, either. WHATEVER YOU NEED, PAL! Anything...','',396,273,0,0,0,0,0,0,1,0,0,0,26124),
(37564,'','Standing this close to the blade that ended my life... The pain... It is renewed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37565,'I\'m not into any of that creepy stuff you like, Brazie. Just show me the \"legal\" wares.','I\'m not into any of that creepy stuff you like, Brazie. Just show me the \"legal\" wares.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37566,'Can you remove the sword?','Can you remove the sword?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37567,'Dark Lady, I think I hear Arthas coming. Whatever you\'re going to do, do it quickly.','Dark Lady, I think I hear Arthas coming. Whatever you\'re going to do, do it quickly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37568,'','I... I don\'t believe it! Frostmourne stands before us - unguarded - just as the gnome claimed. Come, heroes!',0,0,0,0,0,0,1,0,1,0,0,17049,26124),
(37569,'','Standing this close to the blade that ended my life... The pain... It is renewed.',0,0,0,0,0,0,1,0,1,0,0,17050,26124),
(37570,'','I dare not touch it. Stand back! Stand back as I attempt to commune with the blade! Perhaps our salvation lies within...',0,0,0,0,0,0,1,0,1,0,0,17051,26124),
(37571,'','Uther... Uther the Lightbringer. How...',0,0,0,0,0,0,1,0,1,0,0,17052,26124),
(37572,'','The Lich King is here? Then my destiny shall be fulfilled on this day! ',0,0,0,0,0,0,6,0,1,0,0,17053,26124),
(37573,'','There must be a way...',0,0,0,0,0,0,1,0,1,0,0,17054,26124),
(37574,'','Who could bear such a burden?',0,0,0,0,0,0,6,0,1,0,0,17055,26124),
(37575,'','The Frozen Throne...',0,0,0,0,0,0,1,0,1,0,0,17056,26124),
(37576,'','You will not escape me that easily, Arthas! I will have my vengeance! ',0,0,0,0,0,0,5,0,1,0,0,17057,26124),
(37580,'You\'re late, courier. No, I don\'t want any excuses; this errand is far too important.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37581,'Here\'s the tome our representative brought from Wyrmrest. Get this to Myralion Sunblaze immediately.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37582,'Watch your back, courier. I needn\'t remind you of the value of the book, nor the fact that the Silver Covenant will stop at nothing to take it from us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37583,'Careful, girl. I\'ve heard talk of that cursed blade saving us before. Look around you and see what has been born of Frostmourne.','',0,0,0,0,0,0,1,0,1,0,16659,0,26124),
(37584,'You haven\'t much time. The Lich King sees what the sword sees. He will be here shortly. ','',0,0,0,0,0,0,1,0,1,0,16660,0,26124),
(37585,'You cannot defeat the Lich King. Not here. You would be a fool to try. He will kill those that follow you and raise them as powerful soldiers of the Scourge. But for you, Sylvanas, his reward for you would be worse than the last.','',0,0,0,0,0,0,1,0,1,0,16661,0,26124),
(37586,'Perhaps, but know this: there must always be a Lich King. Even if you were to strike down Arthas, another would have to take his place, for without the control of the Lich King, the Scourge would wash over this world like locusts, destroying all that they touched.','',0,0,0,0,0,0,1,0,1,0,16662,0,26124),
(37587,'I do not know, Banshee Queen. I suspect that the piece of Arthas that might be left inside the Lich King is all that holds the Scourge from annihilating Azeroth.','',0,0,0,0,0,0,1,0,1,0,16663,0,26124),
(37588,'Alas, the only way to defeat the Lich King is to destroy him at the place where he was created.','',0,0,0,0,0,0,1,0,1,0,16664,0,26124),
(37589,'Aye. ARRRRRRGHHHH... He... He is coming. You... You must...','',0,0,0,0,0,0,5,0,1,0,16665,0,26124),
(37590,'Uther shakes his head.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37591,'','The chill of this place... I can feel my blood freezing.',0,0,0,0,0,0,1,0,1,0,0,16631,26124),
(37592,'','What is that! Up ahead! Could it be? Heroes, at my side!',0,0,0,0,0,0,6,0,1,0,0,16632,26124),
(37593,'','Frostmourne: the blade that destroyed our kingdom...',0,0,0,0,0,0,1,0,1,0,0,16633,26124),
(37594,'','Stand back! Touch that blade and your soul will be scarred for all eternity! I must attempt to commune with the spirits locked away within Frostmourne. Give me space. Back up, please. ',0,0,0,0,0,0,5,0,1,0,0,16634,26124),
(37595,'','Uther! Dear Uther! I... I\'m so sorry.',0,0,0,0,0,0,1,0,1,0,0,16635,26124),
(37596,'','Arthas is here? Maybe I...',0,0,0,0,0,0,6,0,1,0,0,16636,26124),
(37597,'','But Uther, if there\'s any hope of reaching Arthas. I... I must try.',0,0,0,0,0,0,1,0,1,0,0,16637,26124),
(37598,'','Tell me how, Uther? How do I destroy my prince? My...',0,0,0,0,0,0,6,0,1,0,0,16638,26124),
(37599,'','You\'re right, Uther. Forgive me. I... I don\'t know what got a hold of me. We will deliver this information to the King and the knights that battle the Scourge within Icecrown Citadel.',0,0,0,0,0,0,1,0,1,0,0,16639,26124),
(37600,'','Who could bear such a burden?',0,0,0,0,0,0,6,0,1,0,0,16640,26124),
(37601,'','Then maybe there is still hope...',0,0,0,0,0,0,1,0,1,0,0,16641,26124),
(37602,'','You won\'t deny me this, Arthas! I must know... I must find out... ',0,0,0,0,0,0,0,0,1,0,0,16642,26124),
(37603,'Jaina! Could it truly be you?','',0,0,0,0,0,0,5,0,1,0,16666,0,26124),
(37604,'Jaina, you haven\'t much time. The Lich King sees what the sword sees. He will be here shortly. ','',0,0,0,0,0,0,1,0,1,0,16667,0,26124),
(37605,'No, girl. Arthas is not here. Arthas is merely a presence within the Lich King\'s mind. A dwindling presence...','',0,0,0,0,0,0,1,0,1,0,16668,0,26124),
(37606,'Jaina, listen to me. You must destroy the Lich King. You cannot reason with him. He will kill you and your allies and raise you all as powerful soldiers of the Scourge.','',0,0,0,0,0,0,1,0,1,0,16669,0,26124),
(37607,'Snap out of it, girl. You must destroy the Lich King at the place where he merged with Ner\'zhul - atop the spire, at the Frozen Throne. It is the only way.','',0,0,0,0,0,0,5,0,1,0,16670,0,26124),
(37608,'There is... something else that you should know about the Lich King. Control over the Scourge must never be lost. Even if you were to strike down the Lich King, another would have to take his place. For without the control of its master, the Scourge would run rampant across the world - destroying all living things.','',0,0,0,0,0,0,1,0,1,0,16671,0,26124),
(37609,'A grand sacrifice by a noble soul...','',0,0,0,0,0,0,1,0,1,0,16672,0,26124),
(37610,'I do not know, Jaina. I suspect that the piece of Arthas that might be left inside the Lich King is all that holds the Scourge from annihilating Azeroth.','',0,0,0,0,0,0,1,0,1,0,16673,0,26124),
(37611,'No, Jaina! ARRRRRRGHHHH... He... He is coming. You... You must...','',0,0,0,0,0,0,5,0,1,0,16674,0,26124),
(37612,'Uther shakes his head.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37613,'SILENCE, PALADIN!','',0,0,0,0,0,0,0,0,1,0,17225,0,26124),
(37614,'So you wish to commune with the dead? You shall have your wish.','',0,0,0,0,0,0,0,0,1,0,17226,0,26124),
(37615,'Falric. Marwyn. Bring their corpses to my chamber when you are through.','',0,0,0,0,0,0,396,0,1,0,17227,0,26124),
(37616,'I will not make the same mistake again, Sylvanas. This time there will be no escape. You will all serve me in death!','',0,0,0,0,0,0,0,0,1,0,17228,0,26124),
(37617,'Foolish girl. You seek that which I killed long ago. He is merely a ghost now. A faint echo in my mind... ','',0,0,0,0,0,0,0,0,1,0,17229,0,26124),
(37618,'','Why do you interrupt me, $c?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37619,'You\'re an odd little guy.','You\'re an odd little guy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37620,'It\'s good to finally see you, courier. Krasus has entrusted us with one of the few remaining copies of Ancient Dragonforged Blades.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37621,'Here is the book. You must ensure it gets to Caladis Brightspear in Icecrown before the Sunreavers realize what is happening.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37622,'Travel quickly! The Sunreavers will not waste any time once they realize that we have the information they seek.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37623,'Citizens and guests of Stormwind.  Our city is under attack!  Take up your arms and defend our capital!  If you do not want to answer the call of battle, then grab sandbags and line the streets to prevent flooding!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(37624,'Elemental rifts have opened up around the city.  We need to shut them down now! Evacuate all non-combat ready citizens.  Make sure they get to safety!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(37625,'$B$BQuick, use the Ice Stones at each corner of the city to open a portal to the elemental plane and summon in those responsible.$B$BActivate each stone at the same time to ensure victory.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37626,'Place sandbags around Stormwind to ward off flooding!$B$BPick up a sandbag from any sandbag pile located around the city$B$Band place them at a location marked with a red arrow |TInterface\\Icons\\ABILITY_HUNTER_MARKEDFORDEATH.blp:32|t.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37627,'Take down the rifts and use the totems given by the Earthen Ring Defenders to free Trapped Citizens!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37628,'The Horde now dominates the Battlescar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37629,'The Alliance now dominates the Battlescar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37630,'Brave soldier of the Horde, I salute you! We would have surely been destroyed by the Alliance gunship had it not been for you and your allies.$B$BTake a moment to rest before we begin our assault upon the upper reaches of the citadel.','',66,1,0,0,0,0,0,0,1,0,0,0,26124),
(37631,'We are ready to go, High Overlord. The Lich King must fall!','We are ready to go, High Overlord. The Lich King must fall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37632,'Are you sure, $n? We must face the Scourge at full strength if we are to succeed. If you do not require more rest, we will begin.','',6,1,273,0,0,0,0,0,1,0,0,0,26124),
(37633,'Lok\'tar ogar! We are ready! Onward, brother orc!','Lok\'tar ogar! We are ready! Onward, brother orc!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37634,'Kor\'kron, move out! Champions, watch your backs. The Scourge have been...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37635,'Join me, father. Join me and we will crush this world in the name of the Scourge -- for the glory of the Lich King!','',0,0,0,0,0,0,0,0,1,0,16704,0,26124),
(37636,'I have heard tale of my boy being here. That he\'s now a powerful death knight in service of the Lich King. If this is true, then it must be me that ends the bloodline.$B$BMy charge now is to command Orgrim\'s Hammer to the top of Icecrown Citadel and destroy all Scourge that get in our way. We leave when you and your allies are ready.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(37637,'My companions are all accounted for, Saurfang. Let\'s go!','My companions are all accounted for, Saurfang. Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37638,'My boy died at the Wrath Gate. I am here only to collect his body.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37639,'Stubborn and old. What chance do you have? I am stronger, and more powerful than you ever were.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(37640,'We named him Dranosh - It means \"Heart of Draenor\" in orcish. I would not let the warlocks take him. My boy would be safe, hidden away by the elders of Garadar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37641,'I made a promise to his mother before she died; that I would cross the Dark Portal alone - whether I lived or died, my son would be safe. Untainted...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37642,'Today, I fulfill that promise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37643,'%s charges!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37644,'Pathetic old orc! Come then, heroes. Come and face the might of the Scourge!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(37645,'Quel\'Delar leaps to life in the presence of Frostmourne!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37646,'%s coughs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37647,'%s weeps over the corpse of his son.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37648,'You will have a proper ceremony in Nagrand, next to the pyres of your mother and ancestors.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37649,'Honor, young heroes... no matter how dire the battle... never forsake it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37650,'I hear and obey, master...','',0,0,0,0,0,0,0,0,1,0,17073,0,26124),
(37651,'The enemy shall suffer greatly, master!','',0,0,0,0,0,0,0,0,1,0,17074,0,26124),
(37652,'His spirit is free from the grasp of the Lich King. We must now focus our attention on breaking down the walls that block our passage into the upper reaches. It is only a matter of time now, $n. The siege engineers should have the door down in $4939W days.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37653,'','Come, Scourgebane. I\'ll show the master which of us is truly worthy of the title of \"Champion\"!',0,0,0,0,0,0,0,0,1,0,0,17020,26124),
(37654,'','What a pitiful choice of an ally, Crok!',0,0,0,0,0,0,0,0,1,0,0,17021,26124),
(37655,'It is done, master.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37656,'Master... I have... failed.','',0,0,0,0,0,0,0,0,1,0,17076,0,26124),
(37657,'Fear not, master. I shall rend the flesh of your enemy!','',0,0,0,0,0,0,0,0,1,0,17077,0,26124),
(37658,'It doesn\'t hurt anymore, does it?\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37659,'I\'m sorry...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37660,'Can you feel the burn?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37661,'What... have I done? No!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37662,'So that\'s what happens what you stand too close to a bomb!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37663,'What an... explosive ending!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37664,'What? This strength...? All of the pain is gone! You... must join me in the eternal embrace of death!\n','',0,0,0,0,0,0,0,0,1,0,16811,0,26124),
(37665,'No amount of healing can save me now. Fight on, brothers...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37666,'Please... burn my remains. Let me live warm in the afterlife...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37667,'No! Why was I denied a death by flame? You must all BURN!  ','',0,0,0,0,0,0,0,0,1,0,16845,0,26124),
(37668,'It was... a worthy afterlife.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37669,'There is no escaping the Lich King\'s will. Prepare for an explosive encounter!','',0,0,0,0,0,0,0,0,1,0,16999,0,26124),
(37670,'The transporter glimmers with a crystalline light.','The transporter glimmers with a crystalline light.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37671,'Teleport to Light\'s Hammer.','Teleport to Light\'s Hammer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37672,'','Such easy prey.  Sylvanas will be most pleased!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37673,'','How did you--?!  It doesn\'t matter -- I don\'t need a trap to defeat you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37674,'','Use Belysra\'s Talisman to escape before the Dark Scout shoots you!$B$B|TInterface\\Icons\\inv_jewelry_talisman_10.blp:64|t',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37675,'Now - to the business of winning this war!$B$BAcross the scarred terrain to the east, the Alliance hopes to build an overland link between their coastal strongholds. They think to build a fortress here, in the center of the Barrens. In the center of MY Barrens.$B$BIt will not stand.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37676,'It was dreadful, $c. Unceremoniously booted from Orgrimmar, jars of fresh squirming body parts smashed to the ground as I was hauled through the gates.$B$BLike I was some kind of monster!$B$BFortunately I\'ve been able to continue my research here, where there\'s no shortage of fresh corpses.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(37677,'Fire up the engines! We got a meetin\' with destiny, lads!','',0,0,0,0,0,0,0,0,1,0,16962,0,26124),
(37678,'Hold on to yer hats!','',0,0,0,0,0,0,0,0,1,0,16963,0,26124),
(37679,'What in the world is that? Grab me spyglass, crewman!','',0,0,0,0,0,0,0,0,1,0,16964,0,26124),
(37680,'By me own beard! HORDE SAILIN\' IN FAST \'N HOT!','',0,0,0,0,0,0,0,0,1,0,16965,0,26124),
(37681,'EVASIVE ACTION! MAN THE GUNS!','',0,0,0,0,0,0,0,0,1,0,16966,0,26124),
(37682,'Cowardly dogs! Ye blindsided us!','',0,0,0,0,0,0,0,0,1,0,16967,0,26124),
(37683,'Not me battle? I dunnae who ye think ye are, mister, but I got a score to settle with Arthas and yer not gettin\' in me way! FIRE ALL GUNS! FIRE! FIRE!','',0,0,0,0,0,0,0,0,1,0,16968,0,26124),
(37684,'The Scourge will wash over this world as a swarm of death and destruction!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37685,'This is not your battle, dwarf. Back down or we will be forced to destroy your ship.','',0,0,0,0,0,0,0,0,1,0,17093,0,26124),
(37686,'More bones for the offering!','More bones for the offering!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37687,'Languish in damnation!','Languish in damnation!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37688,'I see... Only darkness.','I see... Only darkness.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37689,'Rise up, sons and daughters of the Horde! Today we battle a hated enemy of the Horde! LOK\'TAR OGAR!','',0,0,0,0,0,0,0,0,1,0,17087,0,26124),
(37690,'THE MASTER\'S RAGE COURSES THROUGH ME!','THE MASTER\'S RAGE COURSES THROUGH ME!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37691,'Kor\'kron, take us out!','',0,0,0,0,0,0,0,0,1,0,17088,0,26124),
(37692,'What is that? Something approaching in the distance.','',0,0,0,0,0,0,0,0,1,0,17089,0,26124),
(37693,'The only escape is death!','The only escape is death!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37694,'ALLIANCE GUNSHIP! ALL HANDS ON DECK!','',0,0,0,0,0,0,0,0,1,0,17090,0,26124),
(37695,'Bound by bone!','Bound by bone!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37696,'Stick around!','Stick around!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37697,'You answer to Saurfang now!','',0,0,0,0,0,0,0,0,1,0,17091,0,26124),
(37698,'You will know our business soon. Kor\'kron, ANNIHILATE THEM!','',0,0,0,0,0,0,0,0,1,0,17092,0,26124),
(37699,'Move yer jalopy or we\'ll blow it out of the sky, orc! The Horde\'s got no business here.','',0,0,0,0,0,0,0,0,1,0,16969,0,26124),
(37700,'Riflemen, shoot faster!','',0,0,0,0,0,0,0,0,1,0,16954,0,26124),
(37701,'Mortar team, reload!','',0,0,0,0,0,0,0,0,1,0,16955,0,26124),
(37702,'Marines, Sergeants, attack!','',0,0,0,0,0,0,0,0,1,0,16956,0,26124),
(37703,'We\'re taking hull damage, get a sorcerer out here to shut down those cannons!','',0,0,0,0,0,0,0,0,1,0,16957,0,26124),
(37704,'What\'s this then?! Ye won\'t be takin\' this son o\' Ironforge\'s vessel without a fight!','',0,0,0,0,0,0,0,0,1,0,16958,0,26124),
(37705,'Don\'t say I didn\'t warn ya, scoundrels! Onward, brothers and sisters!','',0,0,0,0,0,0,0,0,1,0,16959,0,26124),
(37706,'Captain Bartlett, get us out of here! We\'re taken too much damage to stay afloat!','',0,0,0,0,0,0,0,0,1,0,16960,0,26124),
(37707,'This isn\'t lookin\' good, lads!','',0,0,0,0,0,0,0,0,1,0,16961,0,26124),
(37708,'Axethrowers, hurl faster!','',0,0,0,0,0,0,0,0,1,0,17079,0,26124),
(37709,'Rocketeers, reload!','',0,0,0,0,0,0,0,0,1,0,17080,0,26124),
(37710,'Reavers, Sergeants, attack!','',0,0,0,0,0,0,0,0,1,0,17081,0,26124),
(37711,'We\'re taking hull damage, get a battle-mage out here to shut down those cannons!','',0,0,0,0,0,0,0,0,1,0,17082,0,26124),
(37712,'You DARE board my ship? Your death will come swiftly.','',0,0,0,0,0,0,0,0,1,0,17083,0,26124),
(37713,'The Alliance falter. Onward to the Lich King!','',0,0,0,0,0,0,0,0,1,0,17084,0,26124),
(37714,'Damage control! Put those fires out. You haven\'t seen the last of the Horde!','',0,0,0,0,0,0,0,0,1,0,17085,0,26124),
(37715,'We have failed.','',0,0,0,0,0,0,0,0,1,0,17086,0,26124),
(37716,'<A cockroach slithers from Calder\'s mouth and scurries back into his skull through an empty eye socket.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37717,'<On seeing you approach, Calder re-hinges his jaw to speak with you.>','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(37718,'<You find Calder idly picking at his ear with a dagger.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37719,'Do you know what I like, $n?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(37720,'No Calder. What do you like?','No Calder. What do you like?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37721,'Murder.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37722,'Teleport to the Oratory of the Damned.','Teleport to the Oratory of the Damned.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37723,'Teleport to the Rampart of Skulls.','Teleport to the Rampart of Skulls.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37724,'Teleport to the Deathbringer\'s Rise.','Teleport to the Deathbringer\'s Rise.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37725,'Teleport to the Upper Spire.','Teleport to the Upper Spire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37726,'Teleport to the Frozen Throne.','Teleport to the Frozen Throne.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37727,'Just as Goldrinn\'s spirit once blessed our druids, let $n be blessed with the wisdom of his race and the ferocity of the wolf god.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37728,'Teleport to Sindragosa\'s Lair.','Teleport to Sindragosa\'s Lair.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37729,'','Just as Daral\'nir soothes the cursed druids who gave into the beast and abandoned balance, let Tal\'doren soothe $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37730,'Let the Scythe unbind that which was not meant to be bound!  Let the soul master the beast, lest the beast master the soul!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37731,'','Hey! Come here, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37732,'%s bobbles after you happily.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37733,'Looting','Looting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37734,'Thank the spirits for you, brothers and sisters. The Skybreaker has already left. Quickly now, to Orgrim\'s Hammer! If you leave soon, you may be able to catch them.','Thank the spirits for you, brothers and sisters. The Skybreaker has already left. Quickly now, to Orgrim\'s Hammer! If you leave soon, you may be able to catch them.',1,0,0,4,0,0,0,0,1,0,17161,17161,26124),
(37735,'This should be helpin\' ya!','This should be helpin\' ya!',1,0,0,4,0,0,0,0,1,0,0,0,26124),
(37736,'Aka\'Magosh, brave warriors. The alliance is in great number here.','Aka\'Magosh, brave warriors. The alliance is in great number here.',1,0,0,4,0,0,0,0,1,0,17163,17163,26124),
(37737,'Captain Saurfang will be pleased to see you aboard Orgrim\'s Hammer. Make haste, we will secure the area until you are ready for take-off.','Captain Saurfang will be pleased to see you aboard Orgrim\'s Hammer. Make haste, we will secure the area until you are ready for take-off.',1,0,0,4,0,0,0,0,1,0,0,0,26124),
(37738,'Orgrim\'s Hammer infantry, hold position!','Orgrim\'s Hammer infantry, hold position!',1,0,0,4,0,0,0,0,1,0,0,0,26124),
(37739,'Lok\'tar!','Lok\'tar!',1,0,0,4,0,0,0,0,1,0,17166,17166,26124),
(37740,'','Come, Mankrik. Sit beside me and rest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37741,'%s grunts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37742,'','Look at this land, Mankrik. The Horde and Alliance tear the earth apart just to claw at each other in spite.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37743,'','Such hatred is only bringing us destruction. I can see it in you as you fight the quilboar...your anger does nothing but wear you away.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37744,'','You\'re destroying yourself, Mankrik.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37745,'There is nothing left for me. I seek a warrior\'s death. Is that wrong?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37746,'','You seek escape, not glory. It\'s suicide.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37747,'So what if it is? Why do you even care?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37748,'','Because...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37749,'','Because despite what you think, there may be people in this world who would mourn your passing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37750,'Mahka...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37751,'','Please, Mankrik. Let go. Set down your blade.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37752,'This hatred has burned in me for years, Mahka. Your words cannot lift it from me so easily.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37753,'','Then...you do not need to bear it alone. Just sit next to me and forget your troubles, if only for a while.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37754,'','Come see me whenever you are weary.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37755,'Mahka wants you to come see her, Mankrik.','Mahka wants you to come see her, Mankrik.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37756,'Mahka wishes to see me? ...very well. Return to her, I will follow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37757,'Swiftclaw isn\'t stopping!  Steer him back to the raptor pens near Darkspear Hold.','Swiftclaw isn\'t stopping!  Steer him back to the raptor pens near Darkspear Hold.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37758,'%s places a cup against the wall of Desolation Hold and listens in.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37759,'%s sneezes, rattling the bush he\'s hiding in.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37760,'%s yips in appreciation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37761,'%s bounces up and down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37762,'%s lets out a little screech.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37763,'%s waves its horn at you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37764,'%s skips after you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37765,'%s almost falls on his face in excitement.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37766,'%s taps his little claws on the ground as he runs to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37767,'You\'ll never run us out of the city, Silver Covenant thug!','You\'ll never run us out of the city, Silver Covenant thug!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37768,'You Sunreaver lackeys are all the same.','You Sunreaver lackeys are all the same.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37769,'You\'re too late, $n. Another visitor from Dalaran came asking after information about the same prismatic dragon blades.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37770,'From your description, I\'m certain that the book I loaned our visitor could allow you to easily identify the weapon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37771,'Psssstt - $n! Over here! By the tree.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37772,'I\'m afraid you\'ll have to ask the -- Well, perhaps Kalecgos can help.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37773,'$n may have found the remains of a prismatic blade, Kalecgos. Will you offer your help to our visitor?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37774,'Are you certain you should be helping these mortals in their quest for the sword?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37775,'These blades, Krasus... They were made long ago, when things were... different.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37776,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37777,'<Karthog offers you a drink from his waterskin.>$B$BOnce we called this the Gold Road, $c. Today it runs red with blood.$B$BAlliance blood, if I have anything to do with it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37778,'You believe our allies will not be able to control the power of the swords?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37779,'Slow down, friend. You say the General is coming?$B$BNow THERE\'S a trophy for my wall! I\'ll distract the bodyguards, but it will be up to you to kill General Hawthorne himself. Are you ready to strike?','',5,6,0,0,0,0,0,0,1,0,0,0,26124),
(37780,'I am ready, Karthog. For the Horde!','I am ready, Karthog. For the Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37781,'','Mortal champions have long used these weapons to combat evil. I see no reason to keep the swords from them in this battle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37782,'Our enemies once turned our strongest weapon against us. What makes you think the prismatic blades will be any different?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37783,'As you wish, my queen. I will not stand in their way, but I will keep a close watch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37784,'Stay close men - it\'s an ambush. To arms!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(37785,'As will we all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37786,'They come! Everyone, get ready...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37787,'Blood and thunder!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37788,'I lost my Crown Perfume Sprayer.','I lost my Crown Perfume Sprayer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37789,'I lost my Crown Cologne Sprayer.','I lost my Crown Cologne Sprayer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37790,'I lost my Crown Choclate Sampler.','I lost my Crown Choclate Sampler.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37791,'%s nods.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37792,'...thank you, Mahka.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37793,'He\'s ours! The Butcher of Taurajo is dead!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37794,'We\'ll string his body from the trees and leave him swinging in the wind for the Alliance to discover. Go back and tell Warlord Bloodhilt the news!','',0,0,0,0,0,0,0,0,1,11745,0,0,26124),
(37795,'Keep them occupied, my brothers!  Allow $n to retrieve the scythe!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37796,'Fall back!  Retreat into the woods!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37797,'The Butcher of Taurajo will pay.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37798,'I will not rest, $n. Not until they are driven back to the sea.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(37799,'Yes! Grok\'thar More\'gar. Bok choy, friend. Um. Zub zub! ','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(37800,'What? Who are you? What clan are you from?','What? Who are you? What clan are you from?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37801,'Okidoki. Uh. R-ready to work!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(37802,'You\'re no orc. You\'re a spy! Alliance spy!','You\'re no orc. You\'re a spy! Alliance spy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37803,'Only those who have the ranger-general\'s approval may enter the Sunwell Plateau.','Only those who have the ranger-general\'s approval may enter the Sunwell Plateau.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37804,'I will escort you into the Sunwell when you\'re ready.','I will escort you into the Sunwell when you\'re ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37805,'%s rifles through the fortress supplies, looking for something.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37806,'I\'m ready to enter the Sunwell.','I\'m ready to enter the Sunwell.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37808,'Curse your eyes, $r!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(37809,'','My brothers and sisters, words cannot describe what I felt upon seeing the Sunwell rekindled.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37810,'Darius!  The Dark Rangers have the Scythe!  They got to it before we were able to reach it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37811,'','In that moment, the Light revealed to me the truth of the terrible things I had done.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37812,'It will be done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37813,'','Our people had walked a dark path and mine was among the darkest of them all.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37814,'','But the Light showed me that I was not lost. It helped me to find the strength to survive in spite of all that had happened and all the evil I had wrought.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37815,'','It is a strength that we sin\'dorei all share. It is a strength we will need to free ourselves of the addiction ravaging our people.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37816,'','It will be the most difficult battle we have ever faced, but our resolve and the power of the Sunwell will sustain us until we have been restored to our greatness.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37817,'Well said, my lady. We sin\'dorei will be free and we shall be great again!','Well said, my lady. We sin\'dorei will be free and we shall be great again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37818,'Ya, mon. Let\'s crack some tiki target skulls!','',0,0,0,0,0,0,5,0,1,0,21366,0,26124),
(37819,'Get our men in position immediately, Tobias.  We cannot let the Scythe fall into the hands of the Forsaken!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37820,'My lords and ladies, I present $n, bearer of Quel\'Delar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37821,'$n. Zuni. Ya\'ll find ya trainer in the trainin\' grounds to the east. Bring pride to the Darkspear.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(37822,'I told Gar\'dul not to build a fortress on top of a Silithid colony.$B$BDid he listen to Crawgol? No!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(37823,'Fun time?','',0,0,0,0,0,0,0,0,1,0,16901,0,26124),
(37824,'Daddy, I did it!','',0,0,0,0,0,0,0,0,1,0,16902,0,26124),
(37825,'Dead, dead, dead!','',0,0,0,0,0,0,0,0,1,0,16903,0,26124),
(37826,'Da ... Ddy...','',0,0,0,0,0,0,0,0,1,0,16904,0,26124),
(37827,'Fun time over!','',0,0,0,0,0,0,0,0,1,0,16905,0,26124),
(37829,'I not feel so good...','',0,0,0,0,0,0,0,0,1,0,16906,0,26124),
(37830,'No! You killed Stinky! You Pay!','',0,0,0,0,0,0,0,0,1,0,16907,0,26124),
(37831,'WEEEEEE!','',0,0,0,0,0,0,0,0,1,0,16986,0,26124),
(37832,'I brokes-ded it...','',0,0,0,0,0,0,0,0,1,0,16987,0,26124),
(37833,'Daddy make new toys out of you!','',0,0,0,0,0,0,0,0,1,0,16988,0,26124),
(37834,'Bad news, daddy...','',0,0,0,0,0,0,0,0,1,0,16989,0,26124),
(37835,'SLEEPY TIME!','',0,0,0,0,0,0,0,0,1,0,16990,0,26124),
(37836,'Icky sticky!','',0,0,0,0,0,0,0,0,1,0,16991,0,26124),
(37837,'What? Precious? Noooooooooo!!!','',0,0,0,0,0,0,0,0,1,0,16993,0,26124),
(37838,'Good news, everyone! I think I\'ve perfected a plague that will destroy all life on Azeroth!','',0,0,0,0,0,0,0,0,1,0,17114,0,26124),
(37839,'Hrm, interesting...','',0,0,0,0,0,0,0,0,1,0,17115,0,26124),
(37840,'That was unexpected!','',0,0,0,0,0,0,0,0,1,0,17116,0,26124),
(37841,'Bad news, everyone... I don\'t think I\'m going to make it...','',0,0,0,0,0,0,0,0,1,0,17133,0,26124),
(37842,'Great news, everyone!','',0,0,0,0,0,0,0,0,1,0,17118,0,26124),
(37843,'Just an ordinary gas cloud, but watch out because that\'s no ordinary gas cloud!','',0,0,0,0,0,0,0,0,1,0,17119,0,26124),
(37844,'Hrm, I don\'t feel a thing. Wha?! Where\'d those come from?','',0,0,0,0,0,0,0,0,1,0,17120,0,26124),
(37845,'Tastes like... Cherry! OH! Excuse me!','',0,0,0,0,0,0,0,0,1,0,17137,0,26124),
(37846,'Two oozes, one room. So many delightful possibilities!','',0,0,0,0,0,0,0,0,1,0,17122,0,26124),
(37847,'Terrible news, everyone. Rotface is dead, but great news everyone! He left behind plenty of ooze for me to use! What? I\'m a poet and I didn\'t know it... Astounding!','',0,0,0,0,0,0,0,0,1,0,17146,0,26124),
(37848,'Oh Festergut, you were always my favorite -- next to Rotface.  The good news is that you left behind so much gas. I can practically taste it!','',0,0,0,0,0,0,0,0,1,0,17124,0,26124),
(37849,'%s cries out with a loud, baying howl!','%s cries out with a loud, baying howl!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37850,'The heat comes. Prepare to defend against the elemental attack! Lok\'tar ogar!','The heat comes. Prepare to defend against the elemental attack! Lok\'tar ogar!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(37851,'Prepare yourselves brothers and sisters.  The elements conspire against our city.  Be ready for battle!','Prepare yourselves brothers and sisters.  The elements conspire against our city.  Be ready for battle!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(37852,'I AM RENEWED! Ysera grant me the favor to lay these foul creatures to rest!','',0,0,0,0,0,0,0,0,1,0,17071,0,26124),
(37853,'My genius cannot be contained within a box!$B$BWait, this isn\'t Azshara?! What is this place? That\'s a dormant volcano!$B$BI have half a mind to go join the Trade Prince! The other half of my mind is considering the possible weaponization of the clucker eggs!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(37854,'','When we were packed into the Town-In-A-Box, they told us we\'d be deployed somewhere in Azshara. Is this Azshara?$B$BI ask you: who prepares a Town-In-A-Box and doesn\'t supply it with enough food to live on?! One measly Poultryizer?!$B$BWe all know how the \"Micro\" Mechachicken worked out.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(37855,'I must ask that you reforge Shadow\'s Edge for me, Highlord Mograine.','I must ask that you reforge Shadow\'s Edge for me, Highlord Mograine.',0,0,0,0,0,0,0,0,1,8943,0,0,26124),
(37856,'Woo! Feel the burn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37857,'Toasty!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37858,'Burning up the dance floor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37859,'I\'m on fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37860,'So sexy it hurts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37861,'Best. Workout. Ever.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37862,'It burns so good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37863,'Yes ladies, I\'m single.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37864,'Furious Fire Elementals Killed: $4582W/$4862W','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37865,'Elementals are invading the area.  Prepare to defend Orgrimmar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37866,'Searing Fire Elementals Killed: $4584W/$4863W','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37867,'There are new, stronger elementals attacking, but the fires are out of control!  Eliminate the elementals and get a handle on those fires.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37868,'$B$BQuick, use the Ice Stones at each corner of the city to open a portal to the elemental plane and summon in those responsible.$B$BActivate each stone at the same time to ensure victory.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37869,'The fires threaten to destroy all of Orgrimmar.  If you think you are strong enough to go in there, be my guest.  Otherwise, stay out of the city and let us take care of it.','The fires threaten to destroy all of Orgrimmar.  If you think you are strong enough to go in there, be my guest.  Otherwise, stay out of the city and let us take care of it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37870,'Kneel beside me, friend. I caught a bullet during that last raid.$B$B<Gann grunts in pain as he tries to shift position. His left hand clutches a wound, blood welling between his quivering fingers.>$B$BWhen the dwarves first invaded the Barrens, I contented myself with harassing their diggers and sabotaging their equipment. I should\'ve struck a killing blow when I had the chance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37871,'Weezil Slipshadow - master of disguise!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(37872,'|TInterface\\Icons\\ability_creature_disease_02.blp:16|tYou have |cFF00FF00Mutated Infection!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37873,'Please, mortal, speak with Arcanist Tybalin in Dalaran. He may be able to negotiate with the Sunreavers for access to the book.','',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(37874,'Please, mortal, seek out Magister Hathorel in Dalaran. He might be able to negotiate with the Silver Covenant for access to the book.','',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(37875,'Heroes, lend me your aid. I... I cannot hold them off much longer. You must heal my wounds!','',0,0,0,0,0,0,0,0,1,0,17064,0,26124),
(37876,'I have opened a portal into the Dream. Your salvation lies within, heroes...','',0,0,0,0,0,0,0,0,1,0,17068,0,26124),
(37877,'I will not last much longer.','',0,0,0,0,0,0,0,0,1,0,17069,0,26124),
(37878,'My strength is returning. Press on, heroes!','',0,0,0,0,0,0,0,0,1,0,17070,0,26124),
(37879,'You won\'t escape from us so easily!','You won\'t escape from us so easily!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37880,'Did you think you would escape with your life?','Did you think you would escape with your life?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37881,'%s sets his eyes upon you!','%s sets his eyes upon you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37882,'Fires Extinguished: $4857W/$4864W','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37884,'This ain\'t much of a big challenge, mon, but we gotta know ya can handle the pit before we can take ya in.','This ain\'t much of a big challenge, mon, but we gotta know ya can handle the pit before we can take ya in.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37885,'I\'m ready to face my challenge.','I\'m ready to face my challenge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37886,'Get in the pit and show us your stuff, $G boy:girl;.','Get in the pit and show us your stuff, $G boy:girl;.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37887,'You are not welcome here, minion of the Lich King!','You are not welcome here, minion of the Lich King!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37888,'The Forsaken think we\'re weak.  A broken people.  They think we\'ll roll over like a scared dog.','',0,0,0,0,0,0,0,0,1,0,19623,0,26124),
(37889,'They\'re in mid challenge, mon. Be patient.','They\'re in mid challenge, mon. Be patient.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37890,'And if we find ourselves surrounded and disarmed... wounded and overwhelmed... we will lift our heads in defiance and spit in their faces.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37891,'We will fight them on the streets until the last shot is fired.  And when there\'s no more ammunition, we\'ll crush their skulls with the stones that pave our city.','',0,0,0,0,0,0,0,0,1,0,19625,0,26124),
(37892,'We will fight them in the alleys, until our knuckles are skinned and bloody and our rapiers lay on the ground shattered.','',0,0,0,0,0,0,0,0,1,0,19626,0,26124),
(37893,'How wrong they are.  We will fight them in the fields until the last trench collapses and the last cannon is silenced.','',0,0,0,0,0,0,0,0,1,0,19624,0,26124),
(37894,'','Quiet, fools. If I had wished to kill you, you\'d already be dead.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37895,'And if we find ourselves surrounded and disarmed... wounded and without hope... we will lift our heads in defiance and spit in their faces.','',0,0,0,0,0,0,0,0,1,0,19627,0,26124),
(37896,'But we will... NEVER SURRENDER!!!!!','',0,0,0,0,0,0,0,0,1,0,19628,0,26124),
(37897,'FOR GILNEAS!!!','FOR GILNEAS!!!',0,0,0,0,0,0,0,0,1,0,19651,19651,26124),
(37898,'Well done, $n!','Well done, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37899,'Take them, mortal, these souls will again be mine soon enough.','',0,0,0,0,0,0,0,0,1,0,17235,0,26124),
(37900,'Soon, mortal, you too shall have a blade for a prison.','',0,0,0,0,0,0,0,0,1,0,17236,0,26124),
(37901,'Remember hero: I, too, once sought a weapon of great power...','',0,0,0,0,0,0,0,0,1,0,17237,0,26124),
(37902,'I see you too are gathering souls for your own ends. Are we really so different, champion?','',0,0,0,0,0,0,0,0,1,0,17238,0,26124),
(37903,'Yes, do it! Create your monstrous new weapon. It too will serve me when your soul is mine.','',0,0,0,0,0,0,0,0,1,0,17239,0,26124),
(37904,'Bring me your weapon, champion, that I might feed it the soul of its master!','',0,0,0,0,0,0,0,0,1,0,17240,0,26124),
(37905,'Look at you, child; would-be wielder of souls... you cannot fathom the power that lies at my command!','',0,0,0,0,0,0,0,0,1,0,17241,0,26124),
(37906,'Come to me, pretender! Feed MY blade!','',0,0,0,0,0,0,0,0,1,0,17242,0,26124),
(37907,'My challenges have strengthened you, champion. You shall serve me well!','',0,0,0,0,0,0,0,0,1,0,17243,0,26124),
(37908,'Never have I had cause to regret sparing your life, mortal. Always, you find ways to amuse me.','',0,0,0,0,0,0,0,0,1,0,17244,0,26124),
(37909,'The moment is soon at hand, mortal. You shall toil for eternity in a new Azeroth!','',0,0,0,0,0,0,0,0,1,0,17245,0,26124),
(37910,'More souls... yes, more... you will find it hard to stop, mortal.','',0,0,0,0,0,0,0,0,1,0,17246,0,26124),
(37911,'The hunger your weapon feels is but a shade of what awaits. You want to see real hunger? Real power? Continue onward, hero. I am waiting.','',0,0,0,0,0,0,0,0,1,0,17247,0,26124),
(37912,'You stumble about in darkness. There is no light here. No mercy! Icecrown has claimed the souls of better heroes than you.','',0,0,0,0,0,0,0,0,1,0,17248,0,26124),
(37913,'Your heart - its incessant drumming disgusts me. I will silence it as I did my own.','',0,0,0,0,0,0,0,0,1,0,17249,0,26124),
(37914,'The Light will abandon you, hero, just as it did me.','',0,0,0,0,0,0,0,0,1,0,17250,0,26124),
(37915,'A-Me have many locomotion speed modes.  A-Me design specification U-2502 state that user may define A-Me locomotion mode to suit user preference.$b$bIn Amble Mode, A-Me move at speed of normal $r.$b$bIn Run Mode, A-Me move at speed of normal horse or wolf.$b$bIn Overdrive Mode, A-Me move at speed of VERY FAST horse or wolf.$b$bWhich mode you prefer?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37916,'I think I\'ll go with Amble Mode, A-Me.','I think I\'ll go with Amble Mode, A-Me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37917,'Let\'s try Run Mode.','Let\'s try Run Mode.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37918,'Overdrive Mode!  Let\'s do this!','Overdrive Mode!  Let\'s do this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37919,'Input recognized.  Please prepare for journey.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37920,'Good.  Good.  User appear ready.  Now we go.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37921,'Wait.  A-Me forget something.  We make quick stop, then return to escape protocol.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37922,'A-Me pounds her chest and calls out to a nearby gorilla.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37923,'Wooga... you came.  Good.  A-Me need you listen now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37924,'This not easy for A-Me to say... A-Me going home.  It finally time for A-Me to leave.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37925,'A-Me need you tell others.  Tell Rakoo thanks for teach A-Me how to make lightning.  And tell Misko thanks for teach A-Me how to fight dinosaur.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37926,'But most of all... thank you, Wooga, for teach A-Me how to love.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37927,'A single drop of coconut milk leaks out of A-Me 01\'s eye as she takes one long, last look at Wooga.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37928,'Not bad, $n. Not bad.','Not bad, $n. Not bad.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37929,'I don\'t like the look of this \'Crown Chemical Co.\' one bit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37930,'Take care of ya weapons an\' they\'ll take care of ya back.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37931,'Men, women, and children... None were spared the master\'s wrath. Your death will be no different.','',0,0,0,0,0,0,0,0,1,0,16710,0,26124),
(37932,'','The elements chaotic and wild. Only through learnin\' can we keep in touch wit\' them and keep them controlled.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37933,'I can\'t help ya. Go talk ta Nortet if ya want warrior trainin\'.','I can\'t help ya. Go talk ta Nortet if ya want warrior trainin\'.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37934,'I can\'t help ya. Go talk ta Nekali if ya want shaman trainin\'.','I can\'t help ya. Go talk ta Nekali if ya want shaman trainin\'.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37935,'I can\'t help ya. Go talk ta Zen\'Tabra if ya want druid trainin\'.','I can\'t help ya. Go talk ta Zen\'Tabra if ya want druid trainin\'.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37936,'I can\'t help ya. Go talk ta Legati if ya want rogue trainin\'.','I can\'t help ya. Go talk ta Legati if ya want rogue trainin\'.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37937,'I can\'t help ya. Go talk ta Tunari if ya want priest trainin\'.','I can\'t help ya. Go talk ta Tunari if ya want priest trainin\'.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37938,'I can\'t help ya. Go talk ta Soratha if ya want mage trainin\'.','I can\'t help ya. Go talk ta Soratha if ya want mage trainin\'.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37939,'I can\'t help ya. Go talk ta Ortezza if ya want hunter trainin\'.','I can\'t help ya. Go talk ta Ortezza if ya want hunter trainin\'.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37940,'We can\'t help ya \'ere, mon.','We can\'t help ya \'ere, mon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37941,'Sniveling maggot!','',0,0,0,0,0,0,0,0,1,0,16711,0,26124),
(37942,'The children of Stratholme fought with more ferocity!','',0,0,0,0,0,0,0,0,1,0,16712,0,26124),
(37943,'Marwyn, finish them...','',0,0,0,0,0,0,0,0,1,0,16713,0,26124),
(37944,'Soldiers of Lordaeron, rise to meet your master\'s call!','',0,0,0,0,0,0,0,0,1,0,16714,0,26124),
(37945,'Despair... so delicious...','',0,0,0,0,0,0,0,0,1,0,16715,0,26124),
(37946,'Fear... so exhilarating...','',0,0,0,0,0,0,0,0,1,0,16716,0,26124),
(37947,'As you wish, my lord.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37948,'Death is all that you will find here!','',0,0,0,0,0,0,0,0,1,0,16734,0,26124),
(37949,'I saw the same look in his eyes when he died. Terenas could hardly believe it.','',0,0,0,0,0,0,0,0,1,0,16735,0,26124),
(37950,'Choke on your suffering!','',0,0,0,0,0,0,0,0,1,0,16736,0,26124),
(37951,'Yes... Run... Run to meet your destiny... Its bitter, cold embrace, awaits you.','',0,0,0,0,0,0,0,0,1,0,16737,0,26124),
(37952,'The master surveyed his kingdom and found it... Lacking. His judgment was swift and without mercy: DEATH TO ALL!','',0,0,0,0,0,0,0,0,1,0,16738,0,26124),
(37953,'As you wish, my lord.','',0,0,0,0,0,0,0,0,1,0,16741,0,26124),
(37954,'Your flesh shall decay before your very eyes!','',0,0,0,0,0,0,0,0,1,0,16739,0,26124),
(37955,'Waste away into nothingness!','',0,0,0,0,0,0,0,0,1,0,16740,0,26124),
(37956,'','Darkspear trolls \'ave age old connections wit\' nature, but only lately \'ave we come ta know the druidic arts. Try ta keep an open mind, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37957,'Strike swiftly an\' fade away. You\'ll know ya beginin\' ta master ya skills when people know ya deeds, but never heard of you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37958,'','In tha chaos of battle, it\'s tha balance of light and shadow that leads us ta victory.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37959,'A squire is the right hand of the knight.  As you are already fully aware, hands are especially good at carrying things, and thus your first duty will be to carry my sundries, knickknacks, and other miscellaneous paraphernalia while I dispense justice across the land.  To lug around such etcetera is a job unbefitting of a knight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37960,'Understandable.','Understandable.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37961,'Very good.  Secondly, you must know that a knight embraces no tenet more tightly than that of chivalry.  He clings to his generosity as tightly as he clings to his lance.  His valor shines as brightly as his armor.  And while his smallsword may be sharp, his manner among allies is soft and courteous.$b$bNow tell me $n, do you give your oath to hold to the teachings of chivalry and gallantry?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37962,'I give you my oath.','I give you my oath.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37963,'Yes, sir.','Yes, sir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37964,'Ha!  Did I not just say, good $n, chivalry and gallantry are the charge of the KNIGHT?  You seek only to be a SQUIRE.  The colossal burden of chivalry is unfit for the squire, for as I mentioned before, the only colossal burden that you are to bear is that of my belongings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37965,'This is ridiculous!  I don\'t have to put up with this!','This is ridiculous!  I don\'t have to put up with this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37966,'Moving on!  As chivalry is the way of the knight, and I am a knight, you must know then that my own intentions are indeed valorous.  It is true, I fight for my Lady Doloria, to proclaim her beauty and majesty across all the lands.  Any who question her beauty are without a doubt the most vile of enemies, and must be brought to justice.$b$bAs I speak, it occurs to me that I am a failure.  We have come quite far in the squiring ceremony, yet I have not yet ascertained whether or not you deserve my charity or my righteous fury.$b$bI must know, now, do you agree that my Lady Doloria is unquestionably the fairest Lady across all of Azeroth?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37967,'I\'m rather glad to hear that.  Congratulations, $n, for you have completed your training.  You may now ride beside me into the fray.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37968,'Wit\' practice, ya\'ll find that magic can be much stronga than any weapon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37969,'Umm... yes, yes she is.  Unquestionably.','Umm... yes, yes she is.  Unquestionably.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37970,'Woo hoo!','Woo hoo!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37971,'','Trust in ya bow. It\'ll be there for ya when ya need it most.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37972,'','Nature will guide ya when all else fails.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37973,'<Maximillian is deep in prayer, oblivious to your presence.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37974,'Stay your sword and loosen your cap.  Before we do battle with our blades, I first have prepared an assault to unleash upon your ears.$b$bAre you prepared?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37975,'Alright, I\'m ready.','Alright, I\'m ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37976,'This whole place is gonna blow. Get to the exit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37977,'%s has impaled $n!','%s has impaled $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37978,'%s\'s Aether Shield has been shattered by $n!','%s\'s Aether Shield has been shattered by $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37979,'It appears that adventure has made itself apparent.  Look, for as yonder maiden treads innocently through the jungle, a hatchling phoenix stalks her as its prey!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37980,'Watch as the accursed bird becomes flame and ash as soon as it is slayed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37981,'For Doloria!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37982,'Curiously the bird does not become flame and ash.  A phoenix that does not become flame and ash \'pon its slaying is a dire omen indeed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37983,'Maiden: if your curiosity gnaws at you, then you may know your salvation was delivered by Maximillian of Northshire.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37984,'','Squawky...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37985,'Clean and tidy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37986,'That\'s how it\'s done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37987,'Nice. I don\'t want to know what that stain was.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37988,'Aquanos can hardly keep up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37989,'I should keep you around.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(37990,'BY THE MIGHT OF THE LICH KING!','',0,0,0,0,0,0,0,0,1,0,16694,0,26124),
(37991,'You are nothing!','',0,0,0,0,0,0,0,0,1,0,16695,0,26124),
(37992,'Your soul will find no redemption here!','',0,0,0,0,0,0,0,0,1,0,16696,0,26124),
(37993,'I... Am... Released...','',0,0,0,0,0,0,0,0,1,0,16697,0,26124),
(37994,'I have become... DEATH!','',0,0,0,0,0,0,0,0,1,0,16698,0,26124),
(37995,'The ground runs red with your blood!','',0,0,0,0,0,0,0,0,1,0,16699,0,26124),
(37996,'Feast, my minions!','',0,0,0,0,0,0,0,0,1,0,16700,0,26124),
(37997,'','Foolish mortals. You thought us defeated so easily? The San\'layn are the Lich King\'s immortal soldiers! Now you shall face their might combined!',0,0,0,0,0,0,0,0,1,0,0,16795,26124),
(37998,'Dinner... is served.','',0,0,0,0,0,0,0,0,1,0,16681,0,26124),
(37999,'Do you see NOW the power of the Darkfallen?','',0,0,0,0,0,0,0,0,1,0,16682,0,26124),
(38000,'BOW DOWN BEFORE THE SAN\'LAYN!','',0,0,0,0,0,0,0,0,1,0,16684,0,26124),
(38001,'Naxxanar was merely a setback! With the power of the orb, Valanar will have his vengeance!','',0,0,0,0,0,0,0,0,1,0,16685,0,26124),
(38002,'My cup runneth over.','',0,0,0,0,0,0,0,0,1,0,16686,0,26124),
(38003,'Were you ever a threat?','',0,0,0,0,0,0,0,0,1,0,16723,0,26124),
(38004,'Truth is found in death.','',0,0,0,0,0,0,0,0,1,0,16724,0,26124),
(38005,'My queen, they... come.','',0,0,0,0,0,0,0,0,1,0,16725,0,26124),
(38006,'Such wondrous power! The Darkfallen Orb has made me INVINCIBLE!','',0,0,0,0,0,0,0,0,1,0,16727,0,26124),
(38007,'Blood will flow.','',0,0,0,0,0,0,0,0,1,0,16728,0,26124),
(38008,'Worm food.','',0,0,0,0,0,0,0,0,1,0,16853,0,26124),
(38009,'Beg for mercy!','',0,0,0,0,0,0,0,0,1,0,16854,0,26124),
(38010,'Tremble before Taldaram, mortals, for the power of the orb flows through me!','',0,0,0,0,0,0,0,0,1,0,16857,0,26124),
(38011,'Delight in the pain!','',0,0,0,0,0,0,0,0,1,0,16858,0,26124),
(38012,'You dare look upon the host of souls? I SHALL DEVOUR YOU WHOLE!','',0,0,0,0,0,0,0,0,1,0,16884,0,26124),
(38013,'Damnation!','',0,0,0,0,0,0,0,0,1,0,16885,0,26124),
(38014,'','Damnation!',0,0,0,0,0,0,0,0,1,0,0,16891,26124),
(38015,'Doomed for eternity!','',0,0,0,0,0,0,0,0,1,0,16886,0,26124),
(38016,'','Doomed for eternity!',0,0,0,0,0,0,0,0,1,0,0,16892,26124),
(38017,'The swell of souls will not be abated! You only delay the inevitable.','',0,0,0,0,0,0,0,0,1,0,16887,0,26124),
(38018,'','The swell of souls will not be abated! You only delay the inevitable.',0,0,0,0,0,0,0,0,1,0,0,16893,26124),
(38019,'SUFFERING! ANGUISH! CHAOS! RISE AND FEED!','',0,0,0,0,0,0,0,0,1,0,16899,0,26124),
(38020,'','Stare into the abyss and see your end.',0,0,0,0,0,0,0,0,1,0,0,16895,26124),
(38021,'No snooping around, friend.$B$BIf you\'re looking to buy Crown holiday goods, you\'ll have to do it at the Lovely Merchant in the city.','No snooping around, friend.$B$BIf you\'re looking to buy Crown holiday goods, you\'ll have to do it at the Lovely Merchant in the city.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38022,'Time is money, friend. Go go go!','Time is money, friend. Go go go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38023,'The Lovely Merchant is waiting for that. Hurry it up!','The Lovely Merchant is waiting for that. Hurry it up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38024,'That crate won\'t deliver itself, friend. Get a move on!','That crate won\'t deliver itself, friend. Get a move on!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38025,'Don\'t you have some packages to move?','Don\'t you have some packages to move?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38026,'I need another disguise.','I need another disguise.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38027,'If we don\'t slow down soon, I might pass out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38028,'Umm... I think I might need a hand here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38029,'Ugh... maybe if you could lightly slap me on the cheek...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38030,'Hey!  A little help over here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38031,'You didn\'t have to hit me so HARD!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38032,'Okay, okay, I\'m going!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38033,'Thanks, I needed that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38034,'Do you know that you are very strong?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38035,'','This is a great day for all who oppose the Lich King! Brave $n has taken up the ancient blade, Quel\'Delar, in the name of the Silver Covenant!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38036,'As the leader of the Sunreavers, it is with great pride that I present $n as the new bearer of Quel\'Delar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38037,'Something stinks, and for once it\'s not my socks.','Something stinks, and for once it\'s not my socks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38038,'Hope wanes...','',0,0,0,0,0,0,0,0,1,0,17363,0,26124),
(38039,'','Crusaders and combatants, a true hero stands before you this day! $n, of the Silver Covenant, has restored the ancient blade of Quel\'Delar as a symbol of our resolve to defeat the Lich King!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38040,'The end has come!','',0,0,0,0,0,0,0,0,1,0,17364,0,26124),
(38041,'Face now your tragic end.','',0,0,0,0,0,0,0,0,1,0,17365,0,26124),
(38042,'Frostmourne hungers...','',0,0,0,0,0,0,0,0,1,0,17366,0,26124),
(38043,'Frostmourne, OBEY ME!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38044,'Frostmourne feeds on the soul of your fallen ally!','',0,0,0,0,0,0,0,0,1,0,17368,0,26124),
(38046,'I will freeze you from within until all that remains is an icy husk.','',0,0,0,0,0,0,0,0,1,0,17369,0,26124),
(38047,'Watch as the world around you collapses!','',0,0,0,0,0,0,0,0,1,0,17370,0,26124),
(38048,'','You have made an... unwise... decision.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38049,'APOCALYPSE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38050,'Bow down before your lord and master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38052,'Val\'kyr, your master calls!','',0,0,0,0,0,0,0,0,1,0,17373,0,26124),
(38053,'','Just a taste...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38054,'You now stand upon the hallowed ground of the Scourge. The Light won\'t protect you here, paladin. Nothing will protect you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38055,'You could have been my greatest champion, Fordring: A force of darkness that would wash over this world and deliver it into a new age of strife.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38056,'But that honor is no longer yours. Soon, I will have a new champion. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38057,'The breaking of this one has been taxing. The atrocities I have committed upon his soul... He has resisted for so long, but he will bow down before his king soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38058,'','Know my hunger!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38059,'In the end, you will all serve me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38060,'','Death is no escape!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38061,'','SUFFER!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38062,'','Can you handle this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38063,'','Here it comes...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38064,'','How... unfortunate.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38065,'','Yes! Feed, my precious one! You are mine now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38066,'','Really...? Is that all you\'ve got?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38067,'','Such a pity.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38068,'','This ends NOW!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38069,'','But... we were getting along... so... well...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38070,'So the Light\'s vaunted justice has finally arrived? Shall I lay down Frostmourne and throw myself at your mercy, Fordring?','',0,0,0,0,0,0,0,0,1,0,17349,0,26124),
(38071,'You\'ll learn of that first hand. When my work is complete, you will beg for mercy -- and I will deny you. Your anguished cries will be testament to my unbridled power...','',0,0,0,0,0,0,22,0,1,0,17350,0,26124),
(38072,'I\'ll keep you alive to witness the end, Fordring. I would not want the Light\'s greatest champion to miss seeing this wretched world remade in my image.','',0,0,0,0,0,0,0,0,1,0,17351,0,26124),
(38073,'Come then, champions. Feed me your rage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38074,'No questions remain unanswered. No doubts linger. You ARE Azeroth\'s greatest champions. You overcame every challenge I laid before you. My mightiest servants have fallen before your relentless onslaught... your unbridled fury... ','',0,0,0,0,0,0,0,0,1,0,17353,0,26124),
(38075,'Is it truly righteousness that drives you? I wonder...','',0,0,0,0,0,0,0,0,1,0,17354,0,26124),
(38076,'You trained them well, Fordring. You delivered the greatest fighting force this world has ever known... right into my hands - exactly as I intended! You shall be rewarded for your unwitting sacrifice.','',0,0,0,0,0,0,0,0,1,0,17355,0,26124),
(38077,'Watch now as I raise them from the dead to become masters of the Scourge. They will shroud this world in chaos and destruction. Azeroth\'s fall will come at their hands -- and you will be the first to die.','',0,0,0,0,0,0,0,0,1,0,17356,0,26124),
(38078,'I delight in the irony.','',0,0,0,0,0,0,0,0,1,0,17357,0,26124),
(38079,'','Rise up, brothers, and destroy our enemies!',0,0,0,0,0,0,0,0,1,0,0,16796,26124),
(38080,'Impossible...','',0,0,0,0,0,0,0,0,1,0,17358,0,26124),
(38081,'BAH! You gnats actually hurt me... Perhaps I\'ve toyed with you long enough... Now - taste the VENGEANCE OF THE GRAVE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38082,'AARRRGGHHH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38083,'Take them, mortal, these souls will again be mine soon enough.','',0,0,0,0,0,0,0,0,1,0,17235,0,26124),
(38084,'','Crusaders and combatants, a true hero stands before you this day! $n, of the Sunreavers, has restored the ancient blade of Quel\'Delar as a symbol of our resolve to defeat the Lich King!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38085,'Soon, mortal, you too shall have a blade for a prison.','',0,0,0,0,0,0,0,0,1,0,17236,0,26124),
(38086,'Remember hero: I, too, once sought a weapon of great power...','',0,0,0,0,0,0,0,0,1,0,17237,0,26124),
(38087,'I see you too are gathering souls for your own ends. Are we really so different, \'champion\'?','',0,0,0,0,0,0,0,0,1,0,17238,0,26124),
(38088,'Yes, do it! Create your monstrous new weapon. It too will serve me when your soul is mine.','',0,0,0,0,0,0,0,0,1,0,17239,0,26124),
(38089,'Bring me your weapon, champion, that I might feed it the soul of its master!','',0,0,0,0,0,0,0,0,1,0,17240,0,26124),
(38090,'Look at you, child; would-be wielder of souls... you cannot fathom the power that lies at my command!','',0,0,0,0,0,0,0,0,1,0,17241,0,26124),
(38091,'Come to me, pretender! Feed MY blade!','',0,0,0,0,0,0,0,0,1,0,17242,0,26124),
(38092,'My challenges have strengthened you, champion. You shall serve me well!','',0,0,0,0,0,0,0,0,1,0,17243,0,26124),
(38093,'Never have I had cause to regret sparing your life, mortal. Always, you find ways to amuse me.','',0,0,0,0,0,0,0,0,1,0,17244,0,26124),
(38094,'The moment is soon at hand, mortal. You shall toil for eternity in a new Azeroth!','',0,0,0,0,0,0,0,0,1,0,17245,0,26124),
(38095,'More souls...  yes, more...  you will find it hard to stop, mortal.','',0,0,0,0,0,0,0,0,1,0,17246,0,26124),
(38096,'The hunger your weapon feels is but a shade of what awaits. You want to see real hunger? Real power? Continue onward, hero. I am waiting.','',0,0,0,0,0,0,0,0,1,0,17247,0,26124),
(38097,'You stumble about in darkness. There is no light here. No mercy! Icecrown has claimed the souls of better heroes than you.','',0,0,0,0,0,0,0,0,1,0,17248,0,26124),
(38098,'Your heart -it\'s incessant drumming disgusts me. I will silence it as I did my own.','',0,0,0,0,0,0,0,0,1,0,17249,0,26124),
(38099,'The Light will abandon you, hero, just as it did me.','',0,0,0,0,0,0,0,0,1,0,17250,0,26124),
(38100,'Slap Ringo before he passes out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38101,'Water...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38102,'The canteen... get the canteen...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38103,'Need water... not much time...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38104,'So... so very thirsty...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38105,'Truly an amazing sword, don\'t you think? That\'s no weapon of dwarven make, no, it\'s far more ancient than that.$B$BThese Sunreaver and Silver Covenant representatives seem intent on getting to the bottom of the mystery. I\'m already working on a report for Brann.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(38106,'Greely, load The Biggest Egg Ever into the Poultryizer. Mechnuggets for everyone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38107,'As Druids, we are tasked with protecting the balance of nature. My life\'s work has gone against this. In my folly, I have sewn chaos, and this deviant crop must be reaped before it spreads further.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38108,'I will stay here and watch over the land as it heals.  Do keep an eye out for any stragglers from here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38109,'We\'ll grant you a swift death, Arthas. More than can be said for the thousands you\'ve tortured and slain.','',0,0,0,0,0,0,0,0,1,0,17390,0,26124),
(38110,'So be it. Champions, attack!','',0,0,0,0,0,0,0,0,1,0,17391,0,26124),
(38111,'LIGHT GRANT ME ONE FINAL BLESSING! GIVE ME THE STRENGTH... TO SHATTER THESE BONDS!','',0,0,0,0,0,0,0,0,1,0,17392,0,26124),
(38112,'No more, Arthas! No more lives will be consumed by your hatred!','',0,0,0,0,0,0,0,0,1,0,17393,0,26124),
(38113,'The Lich King must fall!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38114,'You have come to bring Arthas to justice? To see the Lich King destroyed?','',0,0,0,0,0,0,0,0,1,0,17394,0,26124),
(38115,'First, you must escape Frostmourne\'s hold, or be damned as I am; trapped within this cursed blade for all eternity. ','',0,0,0,0,0,0,0,0,1,0,17395,0,26124),
(38116,'Aid me in destroying these tortured souls! Together we will loosen Frostmourne\'s hold and weaken the Lich King from within!','',0,0,0,0,0,0,0,0,1,0,17396,0,26124),
(38117,'Free at last! It is over, my son. This is the moment of reckoning.','',0,0,0,0,0,0,1,0,1,0,17397,0,26124),
(38118,'Rise up, champions of the Light!','',0,0,0,0,0,0,0,0,1,0,17398,0,26124),
(38119,'','Genius idea, sir. Your brain power never ceases to amaze me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38120,'Great news, everyone! The slime is flowing again!','',0,0,0,0,0,0,0,0,1,0,17126,0,26124),
(38121,'%s\'s Mana Barrier shimmers and fades away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38122,'What is this disturbance? You dare trespass upon this hallowed ground? This shall be your final resting place!','',0,0,0,0,0,0,0,0,1,0,16868,0,26124),
(38123,'Do you yet grasp the futility of your actions?','',0,0,0,0,0,0,0,0,1,0,16869,0,26124),
(38124,'Embrace the darkness... darkness eternal.','',0,0,0,0,0,0,0,0,1,0,16870,0,26124),
(38125,'All part of the Master\'s plan.... Your end is inevitable....','',0,0,0,0,0,0,0,0,1,0,16871,0,26124),
(38126,'Enough! I see I must take matters into my own hands!','',0,0,0,0,0,0,0,0,1,0,16877,0,26124),
(38127,'You are weak, powerless to resist my will!','',0,0,0,0,0,0,0,0,1,0,16876,0,26124),
(38128,'This charade has gone on long enough!','',0,0,0,0,0,0,0,0,1,0,16872,0,26124),
(38129,'Long have I waited for this day, hero. Are you and your allies prepared to bring the Lich King to justice? We charge on your command!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38130,'Take this blessing and show these intruders a taste of the Master\'s power!','',0,0,0,0,0,0,0,0,1,0,16873,0,26124),
(38131,'We are prepared, Highlord. Let us battle for the fate of Azeroth! For the light of dawn!','We are prepared, Highlord. Let us battle for the fate of Azeroth! For the light of dawn!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38132,'I release you from the curse of flesh!','',0,0,0,0,0,0,0,0,1,0,16874,0,26124),
(38133,'Arise, and exult in your pure form!','',0,0,0,0,0,0,0,0,1,0,16875,0,26124),
(38134,'Fix your eyes upon your crude hands: the sinew, the soft meat, the dark blood coursing within.','',0,0,0,0,0,0,0,0,1,0,16878,0,26124),
(38135,'It is a weakness; a crippling flaw....  A joke played by the Creators upon their own creations.','',0,0,0,0,0,0,0,0,1,0,17268,0,26124),
(38136,'The sooner you come to accept your condition as a defect, the sooner you will find yourselves in a position to transcend it.','',0,0,0,0,0,0,0,0,1,0,17269,0,26124),
(38137,'Through our Master, all things are possible. His power is without limit, and his will unbending.','',0,0,0,0,0,0,0,0,1,0,17270,0,26124),
(38138,'Those who oppose him will be destroyed utterly, and those who serve -- who serve wholly, unquestioningly, with utter devotion of mind and soul -- elevated to heights beyond your ken.','',0,0,0,0,0,0,0,0,1,0,17271,0,26124),
(38139,'You have found your way here, because you are among the few gifted with true vision in a world cursed with blindness.','',0,0,0,0,0,0,0,0,1,0,17272,0,26124),
(38140,'You can see through the fog that hangs over this world like a shroud, and grasp where true power lies.','',0,0,0,0,0,0,0,0,1,0,17273,0,26124),
(38141,'','This thing is huge! Reverse the polarity on the Poultryizer. We\'ll have to shove it in through the outtake.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38142,'','There it goes.  It should only be a moment now....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38143,'Father...','',0,0,0,0,0,0,396,0,1,0,17411,0,26124),
(38144,'It is complete.\n\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38145,'Where most would falter, you have overcome.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38146,'You have withstood the torment of the Lich King himself, and now Shadowmourne is yours.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38147,'Go now...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38148,'Wield this mighty weapon and direct the souls that empower it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38149,'Go now, and defeat the Prince of Darkness. (DO NOT USE?)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38150,'Father. I feared for your... your sanity.','',0,0,0,0,0,0,396,0,1,0,17412,0,26124),
(38151,'Father... For you, I would give my life a thousand times.','',0,0,0,0,0,0,396,0,1,0,17413,0,26124),
(38152,'Darion, my son.','',0,0,0,0,0,0,396,0,1,0,17414,0,26124),
(38153,'At last, I am able to lay my eyes upon you again.','',0,0,0,0,0,0,396,0,1,0,17415,0,26124),
(38154,'The Lich King tormented me without end, Darion.','',0,0,0,0,0,0,396,0,1,0,17416,0,26124),
(38155,'Endlessly, he sought to break my will, to force me to serve him, to bind me to his blade...','',0,0,0,0,0,0,396,0,1,0,17417,0,26124),
(38156,'Finally, when events demanded his full attention, he left me.','',0,0,0,0,0,0,396,0,1,0,17418,0,26124),
(38157,'The one memory, I clung to, Darion... The one thought that kept me from giving in...','',0,0,0,0,0,0,396,0,1,0,17419,0,26124),
(38158,'It was your sacrifice, my son, that again saved me from eternal peril.','',0,0,0,0,0,0,396,0,1,0,17420,0,26124),
(38159,'','Aid me, friends. Let us call upon the spirits for vision.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38160,'Arthas...','',0,0,0,0,0,0,396,0,1,0,17402,0,26124),
(38161,'Alas, hero of Azeroth, you give me a greater gift than you know.','',0,0,0,0,0,0,396,0,1,0,17403,0,26124),
(38162,'Long have I struggled to forgive the prince for his terrible transgressions.','',0,0,0,0,0,0,396,0,1,0,17404,0,26124),
(38163,'My soul has been wracked with unbearable anxiety, dark thoughts... distancing me from the Light.','',0,0,0,0,0,0,396,0,1,0,17405,0,26124),
(38164,'Maximillian, I am ready for adventure.','Maximillian, I am ready for adventure.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38165,'I recall clearly the gleam of pride in his eye as he stood before me, eager to defeat the enemies of the Light...','',0,0,0,0,0,0,396,0,1,0,17406,0,26124),
(38166,'Eager to defend his people, no matter the cost.','',0,0,0,0,0,0,396,0,1,0,17407,0,26124),
(38167,'It is this memory of Arthas that I choose to keep in my heart.','',0,0,0,0,0,0,396,0,1,0,17408,0,26124),
(38168,'I shall always be in your debt, friend.','',0,0,0,0,0,0,396,0,1,0,17409,0,26124),
(38169,'Thank you.','',0,0,0,0,0,0,0,0,1,0,17410,0,26124),
(38170,'Shut it down, shut it down! The eggs are bad!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38171,'Oh, lad...','',0,0,0,0,0,0,396,0,1,0,17421,0,26124),
(38172,'How I miss those endless days in Lordaeron...','',0,0,0,0,0,0,396,0,1,0,17422,0,26124),
(38173,'...sharpenin\' yer skill with this dull blade...','',0,0,0,0,0,0,396,0,1,0,17423,0,26124),
(38174,'...forgin\' ya into a weapon meant to withstand the demands of a great destiny.','',0,0,0,0,0,0,396,0,1,0,17424,0,26124),
(38175,'Heh... Yeh sure put them skills ta use, didn\'t yeh, lad?','',0,0,0,0,0,0,6,0,1,0,17425,0,26124),
(38176,'If only I\'da been able ta stop yeh that day, how different things mighta been.','',0,0,0,0,0,0,396,0,1,0,17426,0,26124),
(38177,'If only I\'da never discovered that accursed blade...','',0,0,0,0,0,0,396,0,1,0,17427,0,26124),
(38178,'Farewell, Arthas... my brother.','',0,0,0,0,0,0,396,0,1,0,17428,0,26124),
(38179,'','So, it is done.',0,0,0,0,0,0,396,0,1,0,0,17376,26124),
(38180,'','I had not dared to trust my senses - too many times has the Lich King made me to be a fool.',0,0,0,0,0,0,396,0,1,0,0,17377,26124),
(38181,'','Finally, he has been made to pay for the atrocities he imposed upon my people.',0,0,0,0,0,0,396,0,1,0,0,17378,26124),
(38182,'Come, Squire $n, for adventure awaits us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38183,'','May Azeroth never fail to remember the terrible price we paid for our weakness... for our pride.',0,0,0,0,0,0,396,0,1,0,0,17379,26124),
(38184,'','But what now, hero? What of those freed from his grasp, but still shackled to their mortal coils?',0,0,0,0,0,0,6,0,1,0,0,17380,26124),
(38185,'','Leave me. ',0,0,0,0,0,0,396,0,1,0,0,17381,26124),
(38186,'','I have much to ponder.',0,0,0,0,0,0,396,0,1,0,0,17382,26124),
(38187,'I think I\'ll adventure alone for a while.','I think I\'ll adventure alone for a while.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38188,'','Agamaggan will not rise again without BLOOD! His body demands sacrifice!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38189,'','Go!  Go and take our land! When all belongs to the quilboar, we will be delivered, and Agamaggan will rise again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38190,'','This he has spoken to me...go, and KILL!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38191,'','I see...she\'s using him to manipulate them all..',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38192,'Look squire, yon maiden has lost her purse to the sulfurous waters of the Golakka Hot Springs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38193,'Maiden!  Fear not, I seek only to steady the quiver in thine lower lip.  Is that your purse that floats \'pon the water, so agonizingly close yet so perilously far away?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38194,'What?  Yes, that\'s my... crate.  And I\'m not a...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38195,'You\'re not a what?  Not available?  Worry not, for my heart belongs only to the lady Doloria, though one as fair as you must command the hearts of many.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38196,'My squire will retrieve your purse for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38197,'I\'m not sure I know what to make of all of this, other than I\'m very insulted, and thank you for returning my purse.  I mean crate!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38198,'Come, squire.  Adventure waits not!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38199,'Bael Modan... the dwarves...  ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38200,'The scar is sealed! Thank Cenarius...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38201,'','What\'s this!?',0,0,0,0,0,0,5,0,1,0,0,17383,26124),
(38202,'','He... he kept it? All this time, he kept it!?',0,0,0,0,0,0,5,0,1,0,0,17384,26124),
(38203,'','I knew! ',0,0,0,0,0,0,5,0,1,0,0,17385,26124),
(38204,'','I sensed a part of him still alive! Trapped... struggling... Oh, Arthas!',0,0,0,0,0,0,396,0,1,0,0,17386,26124),
(38205,'','Perhaps - perhaps he might someday remember what he once was.',0,0,0,0,0,0,396,0,1,0,0,17387,26124),
(38206,'','By the Light, may he at last find rest, free from the icy grip of that terrible blade.',0,0,0,0,0,0,396,0,1,0,0,17388,26124),
(38207,'You again...I hope you didn\'t put too much faith in your actions settling my spirit. I\'ve realized there will be no peace without her, not anymore.$B$BI will see their very homes razed. Are you ready to slay more of these disgusting murderers?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38208,'Save me!  I\'ve dropped my belongings into the hot springs.$b$bMy gowns are in there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38209,'Luck is with us today!  A damsel appears before us, stuck in a crag, without hope of escape!  Let us go save her!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38210,'Maiden!  Fear not, for Maximillian of Northshire has arrived to deliver you from your rocky tomb!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38211,'Hup!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38212,'Now, cry not, as you fall not to your death, but into the waiting arms of my squire!  Off you go now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38213,'Before I take my leave, you must be told that it is not by my fault that you lay stretched on the ground, but by the fault of my squire.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38214,'Nevertheless, you are now freed from the mountains\' grip and safe from harm.  Marshal\'s Stand lies to the east, I believe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38215,'The Kalu\'ak Fishing Derby starts in 20 minutes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38216,'The Kalu\'ak Fishing Derby starts in 10 minutes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38217,'The Kalu\'ak Fishing Derby starts in 5 minutes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38218,'The Kalu\'ak Fishing Derby has begun!  The first person to bring a blacktip shark to me in Dalaran will be declared the winner!  Blacktip sharks can be caught anywhere you can catch a pygmy suckerfish.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38219,'$n has won the Kalu\'ak Fishing Derby!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38220,'Only 10 minutes remain before the Kalu\'ak Fishing Derby ends!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38221,'The Kalu\'ak Fishing Derby ends in 5 minutes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38222,'The Kalu\'ak Fishing Derby has ended!  If you caught a shark, please bring it to me within the hour.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38223,'Be flung!  To safety!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38224,'I was once a paladin, $n.  Now the Light shuns me, for my sins are too great.$B$BI will aid my allies as best I can, but never again will I wield the powers of darkness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38225,'A self-inflicted wound, friend.  I could not bear to look upon a world where I\'d committed so many horrors under the Lich King\'s grasp.$B$BIt was my first step towards redemption, and if my sins are unforgivable, then I will attempt to atone for them for the rest of my life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38226,'Ormus, what happened to your eyes?','Ormus, what happened to your eyes?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38227,'I appear to have lost my ring.','I appear to have lost my ring.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38228,'Lost?$B$BI am deeply disappointed, $n.$B$BThat ring was one of a kind, crafted out of the remnants of the armor of our fallen heroes and the purified metal from our enemy\'s blades.$B$BLet\'s not allow this to happen again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38229,'It won\'t.','It won\'t.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38230,'Turn back, mon. The naga be controlin\' the island to the north. It not safe for ya there.','Turn back, mon. The naga be controlin\' the island to the north. It not safe for ya there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38231,'The Fossil-Finder 3000 indicates that there is a large fossil to the north of here.','The Fossil-Finder 3000 indicates that there is a large fossil to the north of here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38232,'From up here you can see the full scope of the cataclysm\'s destruction. It is chilling to see just how fragile our world really is.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(38233,'The Fossil-Finder 3000 indicates that there is a large fossil to the northwest of here.','The Fossil-Finder 3000 indicates that there is a large fossil to the northwest of here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38234,'The Fossil-Finder 3000 indicates that there is a large fossil to the west of here.','The Fossil-Finder 3000 indicates that there is a large fossil to the west of here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38235,'The Fossil-Finder 3000 indicates that there is a large fossil to the southwest of here.','The Fossil-Finder 3000 indicates that there is a large fossil to the southwest of here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38236,'The Fossil-Finder 3000 indicates that there is a large fossil to the south of here.','The Fossil-Finder 3000 indicates that there is a large fossil to the south of here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38237,'The Fossil-Finder 3000 indicates that there is a large fossil to the southeast of here.','The Fossil-Finder 3000 indicates that there is a large fossil to the southeast of here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38238,'The Fossil-Finder 3000 indicates that there is a large fossil to the east of here.','The Fossil-Finder 3000 indicates that there is a large fossil to the east of here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38239,'The Fossil-Finder 3000 indicates that there is a large fossil to the northeast of here.','The Fossil-Finder 3000 indicates that there is a large fossil to the northeast of here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38240,'It is beeping and flashing wildly.  Dig here!','It is beeping and flashing wildly.  Dig here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38241,'It is now flashing brightly.  You\'re very close!','It is now flashing brightly.  You\'re very close!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38242,'It is beeping loudly, suggesting that you are only a few paces away.','It is beeping loudly, suggesting that you are only a few paces away.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38243,'It is beeping regularly, about once a second.','It is beeping regularly, about once a second.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38244,'It is beeping regularly, about once every two seconds.','It is beeping regularly, about once every two seconds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38245,'It is beeping quietly every 5 seconds or so.','It is beeping quietly every 5 seconds or so.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38246,'It is beeping very faintly.  You are still quite far away.','It is beeping very faintly.  You are still quite far away.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38247,'You hear it beeping very faintly.  The fossil must be very, very far away.','You hear it beeping very faintly.  The fossil must be very, very far away.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38248,'A foul wind blows from the East, $c.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(38249,'Professor Putricide has removed your mutation!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38250,'I have a few ideas on how to help heal the overgrowth, $c.$B$BUnfortunately, Naralex is so upset, he refuses to take any more chances.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38251,'Gorerot crush puny worgen!!','',0,0,0,0,0,0,0,0,1,0,20914,0,26124),
(38253,'This\'ll teach you to mind your own business!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38254,'Maximillian, I am ready for more adventure.','Maximillian, I am ready for more adventure.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38255,'Ya momma was bait fish.','',0,0,0,0,0,0,0,0,1,0,21375,0,26124),
(38256,'Die snakefish!','',0,0,0,0,0,0,0,0,1,0,21376,0,26124),
(38257,'If I fished ya up, I\'d throw ya back. Waste of good fish meat.','',0,0,0,0,0,0,0,0,1,0,21378,0,26124),
(38258,'Go suck on a trident.','',0,0,0,0,0,0,0,0,1,0,21379,0,26124),
(38259,'Ya mest with da wrong trolls, fishhead.','',0,0,0,0,0,0,0,0,1,0,21380,0,26124),
(38260,'Ya about to be darkspeared.','',0,0,0,0,0,0,0,0,1,0,21382,0,26124),
(38261,'Wow. Ya even ugly for a naga.','',0,0,0,0,0,0,0,0,1,0,21384,0,26124),
(38262,'Oi mon, it reeks of bad fish in \'ere.','',0,0,0,0,0,0,0,0,1,0,21385,0,26124),
(38263,'Light, give us the strength we need to defeat the vile broodmother of Un\'Goro.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38264,'Light, give us the courage we need to enter battle with Un\'Goro\'s corrupted dragons.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38265,'Light, grant us the ability to bring Un\'Goro\'s dragons to their demise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38266,'I also ask you to sprinkle wildflowers around the feet of my beautiful Doloria, where\'er she may walk.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38267,'I also ask you to shine your glorious light upon the immaculate face of my lady Doloria.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38268,'I request that you summon birds to sing pleasant meadow-tunes into my Doloria\'s ears, while she sleeps.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38269,'Finally, please find it in your heart to forgive my squire, for I see that you are smiting him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38270,'Finally, I entreat you to stop buffeting my squire with punches and kicks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38271,'Finally, I humbly request that you cease venting your hostility \'pon my good squire.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38272,'Squire!  Please stand next to me as I request the blessing of this Light-blessed spirit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38273,'I accept your blessing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38274,'It\'s alive, $n. It\'s alive!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(38275,'Go forth, my beautiful angel! Ah, it is so very sad when one\'s children leave the nest, isn\'t it?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(38276,'What are you staring at? Haven\'t you ever seen a genius before?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38277,'Squire!  I understand you are newly trained, but must I tell you not to kill the spirits of the Light?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38278,'Thank the Earth Mother!','Thank the Earth Mother!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38279,'I can move again!','I can move again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38280,'The quilboar will pay!','The quilboar will pay!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38282,'Return to the Dire Strait or the Mechashark X-Steam will mysteriously fall apart.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38284,'I fear I must now depart you and your ex-phoenix.  Light be with you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38285,'That\'s right, I\'d like to list some of these \'fireworks\'.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38286,'Those\'ll net me a nice profit when I return from the South Seas.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38287,'You... Don\'t think I don\'t see you. Leave me alone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38288,'Thanks for the great cut and shave, buddy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38289,'Here\'s a little somethin\' extra since I\'ll be away.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38290,'On second thought, keep the whole bag. I have to, uh, get going.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38291,'Did you really think you could corner me this easily?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38292,'We must not let our grief weaken us. Our people will stand strong against the invaders.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38293,'Finally, the backup I\'ve been waiting for! I prepared the paperwork that Snagglebolt requested. All that remains is for someone to serve it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38294,'','You are weak Vol\'jin, like your father was weak. Today I will finish what I started long ago - the Darkspear shall be wiped from existence!',0,0,0,0,0,0,1,0,1,11577,0,21810,26124),
(38295,'My lady, thank you for coming to our aid. I assure you that we\'ll do whatever we can to help.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38296,'You know, that does smell pretty... Hey! Stop spraying that thing at me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38297,'A DRAGON!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38298,'DRAGON!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38299,'DRAGON, I SHALL RUN YOU THROUGH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38300,'FOR DOLORIA!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38301,'I want to test our entire raid.','I want to test our entire raid.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38302,'','It is my role to test our young initiates on the ways of the hunt.$B$BAnd that hasn\'t changed. Today, the quilboar are our prey.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38303,'Earth Mother, into your arms we give one of our own. She is Unaya Hawkwind, my mother, and Greatmother to us all; the wisest of our tribe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38304,'May her spirit fly to you swiftly; may the winds carry her gently, and the grass whisper her name.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38305,'Watch over her as she has watched over us; let her look down on us with joy, through the eternal gaze of An\'she and Mu\'sha, until we too join her in death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38306,'For we are all born of you, and shall all return to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38307,'I\'m glad you\'re out here with us, $n. It\'s not easy getting stuff from naga!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(38308,'','Welcome to Honor\'s Stand, $c! We ripped this valley from the claws of the Horde, but keeping this chokepoint open has proven to be another matter entirely.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(38309,'Hail, $c! Just up ahead you\'ll find Honor\'s Stand, the Alliance\'s only link between Stonetalon and the coast.$B$BThe road\'s a treacherous one, though. I speak from experience.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(38310,'','I came over here to see if we could open up trade with these naga. Their reply wasn\'t very nice.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(38311,'My achy bones. Achy knees. Achy face. I shoulda stayed in school I shoulda.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38312,'','Greetings, $c. We shaman have gathered here at Firestone Point to watch over the land and tend to its wounds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38313,'Come, user.  We prepare for escape protocol.  You use mount now, if you have one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38314,'Poison Explosion incoming!  Take cover behind something!','',0,0,0,0,0,0,0,0,1,11621,0,0,26124),
(38315,'The Colossus burrows underground!','',0,0,0,0,0,0,0,0,1,11621,0,0,26124),
(38316,'She has returned. Tha revenge of the Darkspear finally comes to pass dis day.$B$BLet me know when ya ready, $n. We\'ll not let her slip away again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38317,'I am ready, Vol\'jin.','I am ready, Vol\'jin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38318,'Ya were foolish to come \'ere, Sea Witch. Ya escaped our vengeance once, but the Darkspear Tribe will not abide ya trespassin\' again.','',0,0,0,0,0,0,1,0,1,11577,20119,0,26124),
(38319,'Varimathras? No, he hasn\'t reported in for some time. No doubt he\'s off on an errand of importance for his queen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38320,'While Varimathras is, uh... away, I\'ve been assigned to assist Captain Bragor in his duties.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38321,'With the bulk of Undercity\'s forces deployed to Vengeance Landing in Northrend, the Warchief has sent us to reinforce the city\'s defenses.','With the bulk of Undercity\'s forces deployed to Vengeance Landing in Northrend, the Warchief has sent us to reinforce the city\'s defenses.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38322,'','The villagers were thankful to have Emberstone back.  They brought us a little something to help against the Forsaken!',0,0,0,0,0,0,0,0,1,0,0,19684,26124),
(38323,'Squealer take this land! Tauren will burn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38324,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38325,'','Are you interested in making some money?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38326,'We came here to Un\'Goro with one objective in mind: profit.  My associates and I are always looking for business partners, if you\'re interested.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38327,'Heya, $n. I\'m sure glad that you\'re here. This is turning into a mess.','',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(38328,'What happened here?','What happened here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38329,'Did you know that the Barrens was once a lush forest? Thousands of years ago, before the first Sundering, it was verdant and thriving, watched over by the Kaldorei. But when the continents were torn apart, and this land became separated as what we call Kalimdor, this valley of nature became a harsh, sun-scorched plain.$B$BWhen I first learned this, I saw it as a great tragedy. I decided I would find a way to regrow the forests once more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38330,'How?','How?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38331,'While studying the land, I discovered a cave that stretched deep beneath the earth. These waterways carried underground rivers for miles beneath the parched savannah above. I named them the Wailing Caverns, for the howls made by the wind and steam as they coursed through its depths.$B$BThis would be the instrument of revival, I thought. The water had already bubbled to the surface as small, lush oases throughout the Barrens...if it were imbued, enhanced, this growth could spread across the entire land.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38332,'So what did you do?','So what did you do?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38333,'My plan was to connect these underground waters directly to the Emerald Dream itself. With my faithful disciples, I journeyed deep within the Wailing Caverns, settled into meditation, and entered the Dream. Through my own body, this world was connected to it.$B$BIt was there that everything went wrong.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38334,'What happened?','What happened?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38335,'I came upon what I can only describe as an overwhelming corruption within the Emerald Dream. An unending nightmare that seized me in its claws and tore at my very mind. I could not break free of its grasp; my disciples were unable to wake me.$B$BWhatever this corruption was, it found its way into our world through my body. I did indeed channel its energies into the Wailing Caverns, and its horrible influence twisted the wildlife there into chaotic, deviate forms. Even my disciples were affected; their minds overcome by madness and savagery, they took on the forms of serpents, and called themselves the Druids of the Fang.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38336,'How did you escape?','How did you escape?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38337,'I was saved by my last disciple, Muyoh, and a band of adventurers. I considered the entire incident a failure. It wasn\'t until the Cataclysm occured that I realized I\'d been far too successful!$B$BWhen the Barrens was cracked apart, a great font of underground water was breached and flowed up to the surface, full of the energies it was imbued with in the Wailing Caverns. Life immediately sprung from the earth around it, and the animals thrived...and then it continued to grow, uncontrollably, unchecked.$B$BNow I have to answer for my arrogance in thinking I could dictate the flow and shape of nature myself. This overgrowth must be stopped, before it chokes out the natural wildlife entirely.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38338,'WHO DARES?!','',0,0,0,0,0,0,15,0,1,0,15140,0,26124),
(38339,'Where would one go about finding damsels?','Where would one go about finding damsels?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38340,'I don\'t see any dragons anywhere.','I don\'t see any dragons anywhere.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38341,'A fair question.$b$bOne might check the perimeter of the hot springs.  Or one might look for signal fires up in the cliffs to the west.  Finally, the path to Silithus, far to the north, is often wrought with danger.$b$bThose would be the places I\'d check.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38342,'Nonsense.  Have I hired a blind squire?  There are dragons everywhere.$b$bMy neighbor Spark refers to them as \"dinosaurs\", but I know a dragon when I see one.  They must be slayed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38343,'I\'ll turn you into a fossil, $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38344,'I\'ve dug my own grave...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38345,'You\'re a sight for sore eyes, Lorna.  Let\'s get those cannons manned!  The rest of you, lure the abominations into the open!','',0,0,0,0,0,0,0,0,1,0,19610,0,26124),
(38346,'Little goblins? I remember when your race was created.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(38347,'The Master\'s will remains inviolate...','The Master\'s will remains inviolate...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38348,'You cannot escape the Master\'s Wrath...','You cannot escape the Master\'s Wrath....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38349,'I care nothing for your threats or these naga. Prepare to be removed from existence.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(38350,'The Lich King is unstoppable...','The Lich King is unstoppable...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38351,'Give in... to the cold embrace of death...','Give in... to the cold embrace of death...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38352,'Release yourself from the chains of life...','Release yourself from the chains of life...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38353,'Death consumes you...','Death consumes you...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38354,'He watches your every move...','He watches your every move...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38355,'Cry out in torment... Let your pain overcome your might...','Cry out in torment... Let your pain overcome your might...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38356,'I got these little hellions on a short leash, $n. The naga won\'t attack us while we have their hatchlings.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(38357,'You ready to make their leader surrender, $g buddy : lady;? Okay, here we go.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(38358,'Um, dude, this does not look good. I\'m out of here!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(38359,'Now, young $n, you will die!','',0,0,0,0,0,0,0,0,1,0,15140,0,26124),
(38360,'Crowley\'s troops are up ahead!  Press on!','',0,0,0,0,0,0,0,0,1,0,19611,0,26124),
(38361,'Let us join your father\'s force\'s, Liam.  They\'ll need our help against Sylvanas.','',0,0,0,0,0,0,0,0,1,0,19500,0,26124),
(38362,'Abominations are blocking the way towards the military district!  This won\'t be easy.','',0,0,0,0,0,0,0,0,1,0,19609,0,26124),
(38363,'%s begins to cast Slime Spray!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38364,'Block their retreat, Liam!  We\'ve got them right where we want them!','',0,0,0,0,0,0,0,0,1,0,19725,0,26124),
(38365,'SYLVANAS!!','',0,0,0,0,0,0,0,0,1,0,19726,0,26124),
(38366,'','Enough!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38367,'','No way in hell I\'m staying out of this fight.  Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,19685,26124),
(38368,'','Let\'s see how brave Gilneas gets on without its stubborn leader!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38369,'FATHER!!!','',0,0,0,0,0,0,0,0,1,0,19612,0,26124),
(38370,'','Such a waste.  That arrow\'s poison was not meant to be wasted on your whelp.  We\'ll meet again, Genn!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38371,'We did it, father...','',0,0,0,0,0,0,0,0,1,0,20562,0,26124),
(38372,'We took back our city... we took back...','',0,0,0,0,0,0,0,0,1,0,20563,0,26124),
(38373,'Out of our way, or your hatchlings get it!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(38374,'You naga keep your distance. We\'re not kidding around here!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(38375,'We\'ve got your hatchlings. You better not attack us if you know what\'s good for you!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(38376,'Prepare to surrender to the Bilgewater Cartel!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(38377,'We know you were getting ready to attack us. You brought this on yourselves.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(38378,'Nobody make any sudden movements! We\'ll just negotiate your surrender and leave peaceably.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(38379,'We\'re planning on having a special naga appreciation sale after your surrender is all wrapped up.  Thirty percent off most goods we have in stock. Red light savings on Kaldorei artifacts today only!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(38380,'We don\'t want any trouble. Just keep our path clear and everything will be fine. Nobody needs to get hurt. Especially me!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(38381,'Alright, naga leader, come on out from hiding and surrender in the name of $n and the Bilgewater Cartel!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(38382,'Don\'t tempt me! Do you even know what\'s in those things?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38383,'My lady, I think I hear Arthas coming. Whatever you\'re going to do, do it quickly.','My lady, I think I hear Arthas coming. Whatever you\'re going to do, do it quickly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38384,'','Whoah, what\'s that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38385,'','After countless failures of our agents to secure workable samples of Scourge blight for analysis, I\'ve come up to the front lines myself to oversee the efforts. Like they say, if you want a job done right....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38386,'','Looks like you\'ve had a fun time playing with Rotface, but to harvest a proper specimen I\'m afraid I will need BOTH strains of blight at the same time!',0,0,0,0,0,0,0,0,1,9152,0,0,26124),
(38387,'','Looks like you\'ve had a fun time playing with Festergut, but to harvest a proper specimen I\'m afraid I will need BOTH strains of blight at the same time!',0,0,0,0,0,0,0,0,1,9153,0,0,26124),
(38388,'Alchemist, I am covered with living blight!','Alchemist, I am covered with living blight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38389,'Alchemist, I am covered with living blight!','Alchemist, I am covered with living blight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38390,'','This is incredible! You\'re covered in potent, virulent, fantastic blight! Please, allow me to harvest these pristine samples. I will remove any lingering infection from your allies as well, and reward you all for your bravery and self-sacrifice in the name of medicine! Let me know if you are ready to proceed.\n\n[Before proceeding, make sure that ALL raid members are nearby in order for them to receive credit for your accomplishment.]',0,0,0,0,0,0,0,0,1,9153,0,0,26124),
(38391,'Go ahead. Harvest your specimens.','Go ahead. Harvest your specimens.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38392,'','There is nothing here for you.  Now go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38393,'I\'d like to return to Marshal\'s Stand, please.','I\'d like to return to Marshal\'s Stand, please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38394,'','Do you understand now, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38395,'My patron requests your presence.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38396,'I\'m ready to go to The Shaper\'s Terrace.','I\'m ready to go to The Shaper\'s Terrace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38397,'I\'d like to return to The Shaper\'s Terrace.','I\'d like to return to The Shaper\'s Terrace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38398,'Yes, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38399,'Let us go at once.  We will track Sylvanas down.  For Gilneas!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38400,'Follow Tobias Mistmantle into the Cathedral District.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38401,'Let\'s do our best not to be seen, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38402,'Did you hear that, $n?  Sylvanas is headed to the cathedral.  Let\'s hurry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38403,'Quick!  Hide in the water!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38404,'Who are you?  What do you want with our tribe?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38405,'Nablya, is that you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38406,'Welcome, outsider, to our home.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38407,'Have you come to observe?  Would you like a coconut?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38408,'What can you teach me, Thunderer?','What can you teach me, Thunderer?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38409,'What can you teach me, Stomper?','What can you teach me, Stomper?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38410,'What can you teach me, Gorilla?','What can you teach me, Gorilla?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38411,'A few of our tribe have harnessed the power of thunder.  We use it to defend ourselves against invaders, whether human, orc, or dinosaur.$b$bOur thunder stuns all dinosaurs, you know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38412,'Individual strength is important, but tribal strength is more so.  Our tribe is only as strong as its weakest member.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38413,'The lashers to the south will eat small creatures, like frogs and parrots.  We, the gorillas, will eat the lashers.  And dinosaurs will eat gorillas.  All this is honorable and natural.$b$bThe humans and orcs also hunt the gorilla, but they take the skin and leave the body to rot.  This is why we attack the humans and orcs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38414,'SCOURGE! INCOMING!','SCOURGE! INCOMING!',0,0,0,0,0,0,0,0,1,0,7274,7274,26124),
(38415,'I understand.  Thank you.','I understand.  Thank you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38416,'It is complete.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38417,'Where most would falter, you have overcome.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38418,'You have withstood the torment of the Lich King himself, and now Shadowmourne is yours.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38419,'Go now...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38420,'Wield this mighty weapon and direct the souls that empower it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38421,'Go forth, and defeat the Prince of Darkness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38422,'','You can assure Garrosh that this is a minor setback.  Our victory in Gilneas will be absolute.',0,0,0,0,0,0,0,0,1,0,0,20492,26124),
(38423,'','You\'d do well to watch your tone, General.  Neither you nor Garrosh have anything to worry about.  We\'ve ceased all production of the Plague, as he ordered.  We\'d never deploy it without his permission.',0,0,0,0,0,0,0,0,1,0,0,20493,26124),
(38424,'','Go with honor, General.',0,0,0,0,0,0,0,0,1,0,0,20494,26124),
(38425,'','What kind of question is that?  Of course we\'re deploying the Plague as planned!  Let the Gilneans enjoy their small victory.  Not even their bones will remain by tomorrow.',0,0,0,0,0,0,0,0,1,0,0,20495,26124),
(38426,'It appears you\'re losing control of Gilneas, Sylvanas.  Garrosh fears he\'s going to have to carry out this invasion himself.','',0,0,0,0,0,0,0,0,1,0,22620,0,26124),
(38427,'You sound very confident, your Majesty.  I seriously hope you do not plan to use the Plague.  Garrosh has explicitly forbidden it.','',0,0,0,0,0,0,0,0,1,0,22621,0,26124),
(38428,'I will deliver my report to our leader, then.  By your leave, my lady.','',0,0,0,0,0,0,0,0,1,0,22622,0,26124),
(38429,'I want you to test your Bite skill on the people of Marshal\'s Stand.','I want you to test your Bite skill on the people of Marshal\'s Stand.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38430,'|TInterface\\Icons\\inv_misc_monsterfang_02.blp:32|t  Use Bite on 5 humanoid targets.$B$B|TInterface\\Icons\\inv_misc_bone_02.blp:32|t Use Bony Armor to increase your armor.','|TInterface\\Icons\\inv_misc_monsterfang_02.blp:32|t  Use Bite on 5 humanoid targets.$B$B|TInterface\\Icons\\inv_misc_bone_02.blp:32|t Use Bony Armor to increase your armor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38431,'I want you to speak with the local gorillas.','I want you to speak with the local gorillas.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38432,'Speak with one of each type - Gorilla, Stomper, and Thunderer -$band learn what they have to teach you.','Speak with one of each type - Gorilla, Stomper, and Thunderer -$band learn what they have to teach you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38433,'I want you to test the limits of your wings.','I want you to test the limits of your wings.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38434,'Fly high up above the jungle canopy.$b$bUse Pterrordash to temporarily increase your flight speed.$b$b|TInterface\\Icons\\ability_druid_dash.blp:32|t','Fly high up above the jungle canopy.$b$bUse Pterrordash to temporarily increase your flight speed.$b$b|TInterface\\Icons\\ability_druid_dash.blp:32|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38435,'I want you to pit the Bloodpetal against one another.','I want you to pit the Bloodpetal against one another.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38436,'Challenge and defeat another Bloodpetal in one-on-one combat.','Challenge and defeat another Bloodpetal in one-on-one combat.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38437,'Could you please resummon the Un\'Goro Examinant?','Could you please resummon the Un\'Goro Examinant?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38438,'The flora of Un\'Goro Crater are quite remarkable, to be sure.  Wouldn\'t you agree, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38439,'Could you transport me to the pylon up above?','Could you transport me to the pylon up above?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38440,'My Lady!  Should I order my men to stop the deployment of the Plague?  Or are we to continue as planned?','',0,0,0,0,0,0,0,0,1,0,20917,0,26124),
(38441,'As you wish!','',0,0,0,0,0,0,0,0,1,0,20918,0,26124),
(38442,'Each moment you tarry here, Quel\'Delar drinks in the evil of this place.','',0,0,0,0,0,0,1,0,1,0,16678,0,26124),
(38443,'Just like old times, eh, $n?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(38444,'Just like old times, eh, $n?$B$BI\'m not too busy here to train you. These guys are creampuffs.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(38445,'A little help here?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(38446,'A little help here? Or do you need more training, $n?$B$BI\'m kinda busy at the moment if you hadn\'t noticed.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(38447,'Could you help with this please? I don\'t have unlimited mana.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(38448,'Could you help with this please? I don\'t have unlimited mana.$B$BOf course, if you need some training....','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(38449,'This place seems nice enough, I suppose. Needs a little elbow grease.$B$BYou looking for a job, $n?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(38450,'These little things are a pain in my backside!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(38451,'These little things are a pain in my backside!$B$BSo, you need some training?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(38452,'','These pygmies are cutting into profits!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(38453,'','These pygmies are cutting into profits!$B$BSeeking enlightenment, $n?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(38454,'','You\'ve got the moves, $n. Use them!',397,0,0,0,0,0,0,0,1,0,0,0,26124),
(38455,'','You\'ve got the moves, $n. Now use them!$B$BOr are you looking for some new moves?',397,0,0,0,0,0,0,0,1,0,0,0,26124),
(38456,'Warrior-Matic NX-01 destroy!','',33,0,0,0,0,0,0,0,1,0,0,0,26124),
(38457,'Warrior-Matic NX-01 is online.$B$BInsert coins for further instructional training.','',33,0,0,0,0,0,0,0,1,0,0,0,26124),
(38458,'Arg!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38459,'Ack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38460,'Ugh....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38461,'...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38462,'','Worthless spy, if there were a single morsel of information inside that hollow vessel you call a skull, you would have coughed it up by now. I tire of this exercise. Now perish!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(38463,'Hey, did you hear the one about the $r $c?  OK, here goes:$b$bA $r $c walks into a cave and starts fighting gorillas.  The leader of the gorillas says, \"Hey, why are you doing that?!\"  So then the $r $c says, \"A goblin told me to.\"$b$bThe gorilla leader says, \"Do you do everything that goblins tell you to do?\"  And the $r $c says, \"Yes, because I\'m stupid and smelly and I walk on two legs.\"$b$bPretty funny, huh?  Hmm... maybe it needs some work...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38464,'BY THE MIGHT OF THE LICH KING!','',0,0,0,0,0,0,0,0,1,0,16694,0,26124),
(38465,'','Hrm, well I\'ve come this far, but now how am I going to get a hold of those samples...?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38466,'Feast, my minions!','',0,0,0,0,0,0,0,0,1,0,16700,0,26124),
(38467,'','Un\'Goro Crater serves a very specific purpose, $n.  It is now time for you to learn that purpose.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38468,'Eep!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38469,'','Well, well, what do we have here...? You must know many secrets....',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(38470,'Who are you?','Who are you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38471,'What are you doing here?','What are you doing here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38472,'Tests?  What kind of tests?','Tests?  What kind of tests?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38473,'His creations?  So you\'re saying that all the creatures here in the crater are Khaz\'goroth\'s creations?','His creations?  So you\'re saying that all the creatures here in the crater are Khaz\'goroth\'s creations?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38474,'Why are you telling me all of this?','Why are you telling me all of this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38475,'Nablya, I must ask... did Khaz\'goroth create me and the rest of my race?','Nablya, I must ask... did Khaz\'goroth create me and the rest of my race?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38476,'Thank you Nablya.','Thank you Nablya.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38477,'','I am Nablya, apprentice to Khaz\'goroth and envoy to Un\'Goro Crater.  I am known as the Watcher.$b$bI stand here in the place of my master, who has since left Azeroth.  He once stood in this very spot when he shaped many of his creations.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38478,'','I am observing.  It is my charge to watch over Un\'Goro, and I do so from this spot.$b$bI am also performing tests, and recording the results.  These tests allow me to observe that which most interests me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38479,'','Simple stimulus-response tests.  Normally my kind does not interfere with the matters of Azeroth, but here in Un\'Goro, we are free to take a more direct approach.  As Un\'Goro is the experimental ground of the Titans, it is our right to do so.$b$bFor example, say Khaz\'goroth wants to know what happens when one of his creations is exposed to a sulfurous hot spring.  He could wait for millennia, observing, and waiting for the creature to accidentally stumble and fall in.  Or, he could place the creature in the water himself.$b$bIn Un\'Goro, we may do so.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38480,'','Not exactly.  In fact, many of the creatures here in the crater existed long before my master arrived... but some did not.$b$bNevertheless, we observe them all, without prejudice.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38481,'','When the cataclysm struck Azeroth, it disrupted the cloaking mechanism that kept this terrace hidden.  At that point, it was only a matter of time until the intelligent races discovered me here.$b$bThis was a scenario that, quite honestly, we did not foresee.  It required us to perform some new tests.  And you, $n, are my test subject.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38482,'','I am not authorized to answer that question.  I am, however, permitted to offer you a suggestion:$b$bSeek out Brann Bronzebeard.$b$bHe has already learned much of what there is to know about us, and he is teetering on the verge of another discovery.  Help him, and he may help you uncover the knowledge that you desire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38483,'The time to take back Gilneas City is at hand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38484,'Let us take back our city!','Let us take back our city!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38485,'LIAM!!  NO!!!','',0,0,0,0,0,0,0,0,1,0,19727,0,26124),
(38486,'Finally, a captive audience!','',0,0,0,0,0,0,0,0,1,0,16595,0,26124),
(38487,'The Devourer awaits...','',0,0,0,0,0,0,0,0,1,0,16598,0,26124),
(38488,'The vortex of the harvested calls to you!','',0,0,0,0,0,0,0,0,1,0,16599,0,26124),
(38489,'I will sever your soul from your body!','',0,0,0,0,0,0,0,0,1,0,16600,0,26124),
(38490,'Fodder for the engine.','',0,0,0,0,0,0,0,0,1,0,16596,0,26124),
(38491,'Another soul to strengthen the host!','',0,0,0,0,0,0,0,0,1,0,16597,0,26124),
(38492,'I will attempt to seal the scar, $n. Make sure nothing from the other side makes its way through!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38493,'Gilneas will prevail!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38494,'Your time is up, Forsaken scum!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38495,'Attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38496,'Push them back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38497,'','Mortals, you have saved me from a fate worse than death. Left to their devices, the sorcerers of the Lich King would have broken my will eventually, and condemned me to a tortured eternity of unlife. Ahead of you lies one who was not so fortunate: the once-proud consort of Malygos, Sindragosa.$B$BMortally wounded after Neltharion\'s betrayal and left to die alone in the snows of Icecrown, she exists now as a being of pure hatred. And yet, beneath those layers of malevolence still remains the noble spirit of a dragon queen. I believe there is yet hope that Sindragosa\'s soul may find peaceful respite.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38498,'%s cast |cFFFF7F00Choking Gas Bomb!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38499,'|TInterface\\Icons\\inv_misc_herb_evergreenmoss.blp:16|t%s cast |cFF00FF00Malleable Goo!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38500,'%s begins to cast Unstable Experiment!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38501,'Professor Putricide cast |cFF00FF00Malleable Goo!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38502,'Our work must not be interrupted! Ick, take care of them!','',0,0,0,0,0,0,0,0,1,0,16926,0,26124),
(38503,'We could probably use these parts.','',0,0,0,0,0,0,0,0,1,0,16927,0,26124),
(38504,'Arms and legs are in short supply! Thanks for your contribution!','',0,0,0,0,0,0,0,0,1,0,16928,0,26124),
(38505,'No, that one! That one! Get that one!','',0,0,0,0,0,0,0,0,1,0,16931,0,26124),
(38506,'I\'ve changed my mind, go get that one instead!','',0,0,0,0,0,0,0,0,1,0,16932,0,26124),
(38507,'What are you attacking him for? The dangerous one is over there!','',0,0,0,0,0,0,0,0,1,0,16933,0,26124),
(38508,'This is the beginning AND the end, mortals. None may enter the master\'s sanctum!','',0,0,0,0,0,0,0,0,1,0,16950,0,26124),
(38509,'Greetings, $r. I sense some confusion at my presence here. The others harbor suspicion as well, and I cannot blame them, after what my brethren have put them through.$B$BMuch has happened since the events at the Sunwell, little of it good. And so it falls to me to pick up the pieces, and attempt to salvage the pride of my flight. There is much to say, and more to do, but know this: Not all in the Blue Dragonflight blame the mortal races of Azeroth for the troubles that have befallen the world.$B$BSome of us have more sense than that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38510,'','He\'s truly gone, isn\'t he?$b$bI... I can feel it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38511,'','Was there truly no way to save him?$b$bI fear I shall always wonder.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38512,'Wh- where am I...?  What a nightmare I have had....  But this is no time to reflect, I have much information to report!','',6,5,0,0,2,0,0,0,1,0,0,0,26124),
(38513,'It\'s time to join the fray, $n!  With you on our side the scales will surely tip in our favor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38514,'Make sure everything is ready.  The orcs\' emissary is ready to meet Sylvanas inside the cathedral.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38515,'You thirst for blood!','You thirst for blood!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38516,'Die, intruders! None shall interfere with the Cult\'s plans!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38517,'I... awaken!','',0,0,0,0,0,0,0,0,1,0,16866,0,26124),
(38518,'Who... goes there...?','',0,0,0,0,0,0,0,0,1,0,16867,0,26124),
(38519,'Our master commands us.','Our master commands us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38520,'Even in death we serve.','Even in death we serve.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38521,'','Why hello there, fellow member of the Alliance!$B$BAs an official representative of Gadgetzan, I\'m here to make sure we poor scattered gnomes can peacefully co-exist with the Steamwheedle goblins here in Gadgetzan! We may even be open to tolerating the presence of their new Horde goblin friends.$B$BI\'m sure we can all come to an agreeable decision with your help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38522,'Once more we fight for our master.','Once more we fight for our master.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38523,'Why do you seek death in this place?','Why do you seek death in this place?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38524,'The living do not belong here.','The living do not belong here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38525,'Our torment is eternal.','Our torment is eternal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38526,'This is not our final rest.','This is not our final rest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38527,'All serve the master in death.','All serve the master in death.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38528,'This is but a brief repose...','This is but a brief repose...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38529,'Our souls will never be freed.','Our souls will never be freed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38530,'Hail, $c! Admiral Aubrey is expecting you up above.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38531,'','$n, you gotta get in there and save our people!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(38532,'You will not interfere.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38533,'You shall not contaminate the investigation site.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38534,'Do not disturb the investigation protocol.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38535,'You can\'t come in here all dirty like that. You need that nasty flesh scrubbed off first!','',0,0,0,0,0,0,0,0,1,0,17125,0,26124),
(38536,'','I will destroy this barrier. You must hold the undead back!',0,0,0,0,0,0,0,0,1,0,0,16607,26124),
(38537,'','Another ice wall! Keep the undead from interrupting my incantations so that I may bring this wall down.',0,0,0,0,0,0,0,0,1,0,0,16608,26124),
(38538,'','We\'re almost there... Don\'t give up!',0,0,0,0,0,0,0,0,1,0,0,16646,26124),
(38539,'','Your barriers can\'t hold us back much longer, monster! I will shatter them all!',0,0,0,0,0,0,0,0,1,0,0,16610,26124),
(38540,'','No wall can hold the Banshee Queen. Keep the undead at bay, heroes. I will tear this barrier down!',0,0,0,0,0,0,0,0,1,0,0,17029,26124),
(38541,'','Another barrier? Stand strong, champions. I will bring the wall down.',0,0,0,0,0,0,0,0,1,0,0,17030,26124),
(38542,'','I grow tired of these games, Arthas! Your walls can\'t stop me!',0,0,0,0,0,0,0,0,1,0,0,17031,26124),
(38543,'','You won\'t impede our escape, fiend! Keep the undead off me while I bring this barrier down.',0,0,0,0,0,0,0,0,1,0,0,17032,26124),
(38544,'Hrm, interesting...','',0,0,0,0,0,0,0,0,1,0,17131,0,26124),
(38545,'That was unexpected!','',0,0,0,0,0,0,0,0,1,0,17132,0,26124),
(38546,'Great news, everyone!','',0,0,0,0,0,0,0,0,1,0,17134,0,26124),
(38547,'The swell of souls will not be abated! You only delay the inevitable.','',0,0,0,0,0,0,0,0,1,0,16898,0,26124),
(38548,'Damnation!','',0,0,0,0,0,0,0,0,1,0,16896,0,26124),
(38549,'Doomed for eternity!','',0,0,0,0,0,0,0,0,1,0,16897,0,26124),
(38550,'','Aaagh! It burns! What sorcery is this!?',0,0,0,0,0,0,0,0,1,0,0,17015,26124),
(38551,'','There\'s an opening up ahead. GO NOW!',1,0,0,0,0,0,1,0,1,0,0,17059,26124),
(38552,'GOBIN!!!','',15,0,0,0,0,0,0,0,1,9189,0,0,26124),
(38553,'Killum gobins! Na cayno da BOOM!','',0,0,0,0,0,0,15,0,1,9192,0,0,26124),
(38554,'Gobin ookum ta z\'mbee!','',0,0,0,0,0,0,15,0,1,9192,0,0,26124),
(38555,'Echuta, gobin!','',0,0,0,0,0,0,15,0,1,9192,0,0,26124),
(38556,'Meesa na watun ta longa!','',0,0,0,0,0,0,15,0,1,9192,0,0,26124),
(38557,'Admiral Aubrey is expecting you upstairs, $gsir:ma\'am;.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38558,'F\'dun ta gobins ta da Beeg Badda!','',0,0,0,0,0,0,15,0,1,9192,0,0,26124),
(38560,'Tay\'kn gobins!','',0,0,0,0,0,0,15,0,1,9192,0,0,26124),
(38562,'You... cannot escape us!','You... cannot escape us!',0,0,0,0,0,0,0,0,1,0,16923,16923,26124),
(38563,'Quickly! We\'ll ambush them from behind!','Quickly! We\'ll ambush them from behind!',0,0,0,0,0,0,0,0,1,0,16924,16924,26124),
(38564,'The living... here?!','The living... here?!',0,0,0,0,0,0,0,0,1,0,16925,16925,26124),
(38565,'I\'m free! I owe you my life!','I\'m free! I owe you my life!',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(38566,'I thought I was a goner for sure!','I thought I was a goner for sure!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(38567,'I felt my life slipping out of me.','I felt my life slipping out of me.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(38568,'They were trying to change me into a zombie!!!','They were trying to change me into a zombie!!!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(38569,'I gotta get out of here before they catch me again!','I gotta get out of here before they catch me again!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(38570,'I really can\'t thank you enough!','I really can\'t thank you enough!',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(38571,'They took the others up into the volcano. Some to turn into zombies, some to sacrifice to their turtle god, Volcanoth!','They took the others up into the volcano. Some to turn into zombies, some to sacrifice to their turtle god, Volcanoth!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(38572,'The other captives are up in the volcano... they\'re being sacrificed, or worse, zombiefied!','The other captives are up in the volcano... they\'re being sacrificed, or worse, zombiefied!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(38573,'We must hold fast. If Northwatch falls, there is nothing to our backs but the sea!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(38574,'Admiral, can I get a ride to the Blackpool?','Admiral, can I get a ride to the Blackpool?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38575,'I\'m not here on vacation, pal. Noggenfogger sent me down here with a mission: Find out how to turn a profit on these silithid, or wipe \'em clean.$B$BIf a $r like you wants to do some favors for the Steamwheedle Cartel, I could use a hand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38576,'Shadows amass and swarm around $n!','Shadows amass and swarm around $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38577,'','I don\'t even know how to use this weapon... but I reckon if I stand here looking menacing, the worgen might go somewhere else.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38579,'PR\'PR TA DI, GOBIN!!!','',0,0,0,0,0,0,15,0,1,0,3417,0,26124),
(38580,'All hands topside! Run \'em through!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(38581,'Captain, I need a ride back to Northwatch Hold.','Captain, I need a ride back to Northwatch Hold.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38582,'Godspeed, $c!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38583,'Mister Blaine? Flag down a gryphon for $n if you please.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38584,'Aye aye sir! Immediately, sir!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38585,'Assuming we make it through this, it\'ll take a month to clean the brains off my brasswork.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(38586,'Did they bother to tell you who I am and why I am doing this?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38588,'Invocation of Blood jumps to Prince Keleseth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38589,'Invocation of Blood jumps to Prince Valanar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38590,'Invocation of Blood jumps to Prince Taldaram!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38591,'But what does it matter.  It is time for this to end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38592,'Baxter! Get in here and help! NOW!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38593,'It is time, Frye!  Attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38594,'Apothecaries! Give your life for the Crown!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38595,'It has been the greatest honor of my life to serve with you, Hummel.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38596,'Great. We\'re not gutless, we\'re incompetent.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38597,'...please don\'t think less of me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38598,'Izzy, you don\'t happen to know where Yngwie\'s body is, do you?','Izzy, you don\'t happen to know where Yngwie\'s body is, do you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38599,'','Look, don\'t ask me how I found it. Just toss  it onto that big blue bonfire and destroy Yngwie\'s soul before it\'s too late!',153,0,0,0,0,0,0,0,1,0,0,0,26124),
(38600,'...or are they just using you like they do everybody else?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38601,'We ought to leave Crowley in prison with those beasts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38602,'Enough!  I\'ve made up my mind.  We need Crowley on our side.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38603,'Do other decks exist?','Do other decks exist?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38604,'You are astute to ask, young $c.  Scribes are capable of inscribing tarot cards of great power, although even they do not have full control of what they make.  The fates decide for them.$b$bIf you manage to obtain a completed deck, please bring it to me for a magnificent reward.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38605,'Get your head in the game, $n!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(38606,'Alright, people, hold that line!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(38607,'The play is a Kilo Tango Charlie Blitz on three. One... two... three! Um... guys?!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(38608,'We\'re up against pterrodax, sharks, teraptors, and bomb-throwing monkeys. It\'s going to take a miracle to win!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(38609,'This isn\'t footbomb, kids. This is the real deal!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(38610,'Goldskimmer, are you ready to run with it?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(38611,'Are we gonna let them make a bunch of monkeys out of us? NO!','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(38612,'What I wouldn\'t give for one of my Buccaneer shredder suits right about now!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(38613,'Bilgewater Buccaneers for life!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(38614,'Heya, kid. Great job out there!$B$BSee you on the other side.','',397,0,0,0,0,0,0,0,1,0,0,0,26124),
(38615,'All this talk about food is making me hungry!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(38616,'It\'s afraid.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38617,'You know the plays, kid. Execute them!','',397,0,0,0,0,0,0,0,1,0,0,0,26124),
(38618,'','$n! How ya doin\', hon?',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(38619,'Shadows amass and swarm around $n!','Shadows amass and swarm around $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38620,'Holy cats! It worked! Soothfancy, come look at this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38621,'What\'s it thinking?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38622,'It\'s afraid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38623,'Spirits appear and surround the altar!','Spirits appear and surround the altar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38624,'Empowered Flames speed toward $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38625,'','Remain calm!  We will take care of everybody.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38626,'','We have carriages at the ready, we\'re just waiting for King Greymane\'s word.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38627,'Seems I\'ll be cuttin\' yer throat by me self!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38628,'','We will overcome this.  Do not give into panic.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38629,'I\'ve a surprise for ye, dogs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38630,'%s goes into a frenzy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38631,'%s\'s Blood Beasts gain the scent of blood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38632,'It\'s over Godfrey.  You have no support left among the eastern lords.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38633,'No... I\'d sooner die than have one of your kind for a king!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38634,'It is not the time to turn against one another, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38635,'I need a horse.','I need a horse.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38636,'','Father!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38637,'No, old friend.  I\'ve come to you as an equal.','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(38638,'It is decided, then.  We will unite all Gilneans and drive the Forsaken from our lands.','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(38639,'Crowley!  You and your elven allies are hereby ordered to serve along the king\'s army.  Cursed or not, you are still bound by Gilnean law!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(38640,'Does this toad speak for you, Genn?  Do you come to our dwelling as a friend?  Or do you come as a tyrant?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38641,'Lorna!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38642,'Aye, Genn.  It is not law that binds us.  It is something far stronger.  My men are ready to give their lives under your command.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38643,'They sunk the Collingwood off the coast, but we managed to drag her carronades to the shore.$B$BThose animals won\'t set one filthy green foot on this beach! Not while I\'ve got powder!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(38644,'Bull\'s-eye!','Bull\'s-eye!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38645,'Ooh, that\'s gotta hurt!','Ooh, that\'s gotta hurt!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38646,'What do you think? Zombie Kill of the Week?','What do you think? Zombie Kill of the Week?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38647,'Have you heard of Azshara? There are no zombies there.','Have you heard of Azshara? There are no zombies there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38648,'Don\'t worry. The zombies are looking for brains. You\'re safe.','Don\'t worry. The zombies are looking for brains. You\'re safe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38649,'Smoker!','Smoker!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38650,'Quick is the word and sharp is the action, $gMister:Miss; $n.','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(38651,'The zombies are coming.','The zombies are coming.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38652,'That\'s right. Look at the pretty flags.','That\'s right. Look at the pretty flags.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38653,'Mister Blaine, signal the shore batteries and let Mr. Whessan know $n is on $ghis:her; way. Handsomely, now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38654,'Landro\'s Pet Box','Landro\'s Pet Box',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38655,'We got the final barrier blockin\' entry to Frostwing Halls down, $g lad:lass;. Only Sindragosa stands between the Lich King and divine retribution! What are ye waitin\' for?!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(38656,'The barrier to the Crimson Hall be open, $g lad:lass;! I got me best gnomes workin\' on gettin\' the barrier to the Frostwing Halls open. Looks like it\'s gonna be another $4939W days! Fer now, it\'s probably best that you go face the blood princes and their queen!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(38657,'We got the door down and the barrier preventin\' entry to the Plagueworks busted open! My gnomes are werkin\' on gettin\' the barrier to the Crimson Hall down. It\'ll be another $4939W days before that thing comes down.$B$BGet in there and take out some Scourge!\n','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(38658,'All barriers are now down, $n! Only Sindragosa stands between the Lich King and us. Justice comes soon...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(38659,'The barrier preventing access to the Crimson Halls has been smashed. The blood princes and their queen await our... arrival. Let\'s not keep them waiting.$B$BThe last barrier, preventing our access to Frostwing Halls, will be dismantled in $4939W days.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(38660,'The goblins have finally managed to take down the door leading to the upper reaches of the spire. Our magi have also successfully deactivated the first of three barriers within the sanctum. Access to the Plagueworks is now open. Get in there and crack some skulls!$B$BWe should have the barrier to the Crimson Halls open in $4939W days.\n','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(38661,'Impossible!','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(38662,'He\'s too strong!  Use the catapults to bring him down!','',0,0,0,0,0,0,0,0,1,0,19499,0,26124),
(38663,'|TInterface\\Icons\\spell_shadow_unstableaffliction_1.blp:16|t%s cast |cFFFF0000Volatile Experiment!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38664,'You are not worthy to face the Lich King!','',1,0,0,3,0,0,0,0,1,0,16921,0,26124),
(38665,'Not my gears - not my beautiful gears! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38666,'\'ey! That\'s the Admiral\'s finest silver!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38667,'The end is upon you.  Enter... oblivion.','',1,0,0,0,0,0,0,0,1,0,17224,0,26124),
(38668,'How long can you fight it?','',1,0,0,0,0,0,0,0,1,0,17220,0,26124),
(38669,'Arise minions.  Do not let them pass.','',1,0,0,0,0,0,0,0,1,0,17216,0,26124),
(38670,'Minions, sieze them.  Bring their corpses back to me.','',1,0,0,0,0,0,0,0,1,0,17222,0,26124),
(38671,'Foolish girl!  You seek that which I killed long ago.  A faint echo in my mind.','',1,0,0,0,0,0,0,0,1,0,17229,0,26124),
(38672,'','%s fires a frozen orb towards $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38673,'We\'re in a pretty tight pickle here, $n.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(38674,'','I definitely did NOT sign up for this! Pygmies, zombies... Hobart better give me a huge raise!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(38675,'','Just when I thought it couldn\'t get any worse....',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(38676,'What are we doing up here? Shouldn\'t we be trying to find a way off of this island?!!!','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(38677,'This Town-In-A-Box is a remarkable feat of engineering!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(38679,'$n is infected with the Death Plague!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38680,'Now is not the time for idle chit-chat, squire $n.  We are in the middle of a quest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38681,'FIRE! FIRE!','',1,0,0,0,0,0,0,0,1,0,16732,0,26124),
(38682,'Intruders have breached the inner sanctum. Hasten the destruction of the green dragon! Leave only bones and sinew for the reanimation!','',0,0,0,0,0,0,0,0,1,0,17251,0,26124),
(38683,'We sally forth in search of the dragons\' despicable broodmother.  Follow me, squire!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38684,'You should try using my stallion\'s stomp ability.  Her powerful hooves will cleave the ground itself, stunning any nearby dragons.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38685,'What luck!  Pimento\'s hooves have kicked up some stones that we may use against the mighty dragons.  Oh glorious day!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38686,'I see the dragon up ahead.  She is larger than I had first anticipated.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38687,'Dragon!  Hear me out!  I am Maximillian of Northshire, and I have come to deliver you.  Your blood shall fill...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38688,'Great Uther\'s ghost, it\'s chasing after us!  Squire, do something!  Throw rocks at it!  I have no plan!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38689,'Wait, I have an idea!  Here, throw my Light-blessed shield at the beast!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38690,'That shield-toss worked remarkably well.  Quickly, hurl my holy shoulder-plate!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38691,'I have managed to remove my gloves.  You may lob them at our foe.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38692,'The ironclad heel of my armored boot should prove to be quite destructive.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38693,'Eat my other shoulder-plate, vile lizard!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38694,'If you can heft my breastplate, then throw it!  Throw it for Doloria!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38695,'This is quickly becoming humiliating... and drafty.  Hopefully my legplates shall deal the deathblow.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38696,'We have done it!  Un\'Goro is cleansed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38697,'Squire, meet me back at my camp for your reward.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38698,'Bravo, $n! It wasn\'t pretty, but it worked.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38699,'Perhaps you should try hurling them at the nearby dragons to practice your throwing arm.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38700,'Maximillian has handed you his shield.  Throw it at the Devilsaur!  Er... dragon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38701,'Keep throwing Maximillian\'s armor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38702,'Your health is faltering.  Allow me to help.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(38703,'Why do these bandages smell like wet dog?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38704,'Thank you - this was turning into a massacre...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38705,'These bandages reek! I guess I shouldn\'t complain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38706,'I think I can limp back to the fortress...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38707,'Can\'t ... give up...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38708,'Orcs and trolls! Everywhere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38709,'','By wearing, holding, or otherwise using this Bilgewater Cartel Life Rocket, you agree to be bound by the terms of the end user license agreement!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38710,'','Every Life Rocket comes with a two-year contract and FREE non-arbitration clause!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38711,'','The Bilgewater Cartel thanks you for your frequent future purchases!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38712,'','Our Bilgewater Cartel representatives are waiting to help find the payment plan that\'s right for you as soon as you land!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38713,'','Be sure to fill out all included paperwork during your flight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38714,'Impossible.... Rimefang.... warn....','',0,0,0,0,0,0,0,0,1,0,16763,0,26124),
(38715,'Such a shameful display. You are better off dead.','',0,0,0,0,0,0,0,0,1,0,16761,0,26124),
(38716,'Perhaps you should have stayed... in the mountains!','',0,0,0,0,0,0,0,0,1,0,16762,0,26124),
(38717,'Power... overwhelming!','',0,0,0,0,0,0,0,0,1,0,16765,0,26124),
(38718,'I shall not fail the Lich King. Come and meet your end!','',0,0,0,0,0,0,0,0,1,0,16760,0,26124),
(38719,'Coach, can I get some rocket boots?','Coach, can I get some rocket boots?\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38720,'Sure thing, kid!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(38722,'Greely, why do the Super Booster Rocket Boots only work on the zombies?','Greely, why do the Super Booster Rocket Boots only work on the zombies?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38723,'','I\'m so glad that you asked, $n!$B$BNo one ever asks how stuff works. It\'s just here, gimme that, I\'m gonna blow stuff up. Or, don\'t bore me with the details, just let me point and shoot. Or, worse yet, who cares how it works, is it a bigger explosion than last time?$B$BI swear sometimes, I could just scream, you know? It\'s like I\'m always doing all of Hobart\'s work for him, but I never get any of the credit! I have got to be the most underappreciated, overworked, and underpaid tinkers assistant ever!$B$BWait, what did you ask about?',1,5,6,0,0,0,0,0,1,0,0,0,26124),
(38724,'Maximillian, I am ready to ride.','Maximillian, I am ready to ride.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38725,'It\'s a good thing I love building ships, because these pirates love blowing them up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38726,'Megs sent me to get a boat.','Megs sent me to get a boat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38727,'%s cast Volatile Ooze Adhesive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38728,'%s cast Gaseous Bloat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38729,'Thank you!  I owe you my life.','',0,0,0,0,0,0,0,0,1,0,20922,0,26124),
(38730,'Yes, yes, that\'s all very interesting, but as you can see here, we\'re in a fight for our lives, and these pygmies are the least of our problems compared to what\'s inside that cave!$B$BWhere\'s my worthless assistant when I need her the most? Probably off being lazy somewhere and complaining that no one asks her how her day is going....','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(38731,'Keep it down lady!','Keep it down lady!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38732,'We\'ve been getting a lot of complaints about your yelling.  Keep it down.','We\'ve been getting a lot of complaints about your yelling.  Keep it down.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38733,'Lady, you need to lower your voice.','Lady, you need to lower your voice.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38734,'No one wants your bread lady.  But what we do want is for you to keep it down.','No one wants your bread lady.  But what we do want is for you to keep it down.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38735,'Anywhere but here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38736,'What\'s wrong with me??!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38737,'My face!  What\'s wrong with my face!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38738,'My hands... don\'t look at my hands!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38739,'The pain is unbearable!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38740,'Make it stop!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38741,'I can\'t fight it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38742,'Bastoon! Humiliate the interlopers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38743,'I\'m ready to pilot our silithid.','I\'m ready to pilot our silithid.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38744,'','This mastiff will help you find the hidden worgen.',0,0,0,0,0,0,0,0,1,0,0,19696,26124),
(38745,'Oke doke, boss. I will finish this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38746,'Is that all you\'ve got, \'Hexmaster?\'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38747,'It be time to squeal, little piggy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38748,'BAH! Your shadows frighten no one, Bastoon. This one is mine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38749,'HAH! Weakness! I expected nothing more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38750,'No - no! This land... is ours...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38751,'','I don\'t see any good reason for these ogres to waste their lives sitting out here in the sand when they could join the Horde and work for us.$B$BI mean look at them! If we don\'t exploit them, who will?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38752,'What want?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38753,'Ogre look funny.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38754,'Me hungry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38755,'Me not like sand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38756,'You sign charter! Is good!','You sign charter! Is good!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38757,'We get tabard?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38758,'Me still hungry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38759,'Thank you, funny ogre!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38760,'Me not understand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38761,'Read make head hurt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38762,'...me forget what you said.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38763,'Yay!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38764,'Okay. Me sign.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38765,'','My power is waning... you fool! I will come for you next!',0,0,0,0,0,0,0,0,1,11577,0,21811,26124),
(38766,'Doc!','Doc!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38767,'Little help here!','Little help here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38768,'Help me, help me!','Help me, help me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38769,'Ouch!','Ouch!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38770,'I\'m bleeding!','I\'m bleeding!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38771,'Medic!','Medic!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38772,'Doc! Help!','Doc! Help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38773,'That hurt!','That hurt!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38775,'On my way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38776,'Just a sec!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38777,'I only have two hands and two feet here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38778,'I hope I don\'t run out of bandages!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38779,'I need an assistant!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38780,'Someone needs to do something about that giant turtle in the cave!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38781,'This is exhausting!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38782,'Twenty CCs of Kaja\'Cola, stat! Not for the patient... for me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38783,'We\'ve got an eye on you, pie vendor.','We\'ve got an eye on you, pie vendor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38784,'We know all about you, and the perfume, and the rose petals.  Watch it!','We know all about you, and the perfume, and the rose petals.  Watch it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38785,'We\'re watching you, pie vendor.','We\'re watching you, pie vendor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38786,'Watch your step, pie vendor.  You are flirting with disaster.','Watch your step, pie vendor.  You are flirting with disaster.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38787,'We\'ve been getting some complaints about your pies.  Clean up your act!','We\'ve been getting some complaints about your pies.  Clean up your act!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38788,'Keep it down fruit vendor!','Keep it down fruit vendor!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38789,'We\'ve been getting reports about your noise.  Quiet down!','We\'ve been getting reports about your noise.  Quiet down!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38790,'We\'ve gotten complaints that your fruit is not as fresh as you claim.','We\'ve gotten complaints that your fruit is not as fresh as you claim.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38791,'We\'ve heard that you are selling some bad apples.','We\'ve heard that you are selling some bad apples.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38792,'We\'re watching you, meat vendor.','We\'re watching you, meat vendor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38793,'Watch your step around here, meat vendor.','Watch your step around here, meat vendor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38794,'We\'ve heard reports of people getting sick off of bad meat.  We\'re watching you, meat vendor!','We\'ve heard reports of people getting sick off of bad meat.  We\'re watching you, meat vendor!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38795,'Watch where you\'re going, meat vendor.','Watch where you\'re going, meat vendor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38796,'Show me the armor of Scourge lords, Ormus.','Show me the armor of Scourge lords, Ormus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38797,'I wish to join the battle underway.','I wish to join the battle underway.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38798,'The Battle for Gilneas City is underway!  You can head to the frontlines or wait until our men regroup for the next attack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38799,'Our men are regrouping.  They will be ready for battle in mere minutes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38800,'Me help goblin lady make friend with ogres.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38801,'','Hey, ogre. Now that your tribe\'s signed the proper paperwork, what can we do to actually convince all of them to come do work for us?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38802,'','WHAT OGRE LIKE. WHAT GOOD FUN FOR GIVE OGRE.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38803,'','%s sighs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38804,'','The silithid? Those things are disgusting and completely inedible...oh, whatever.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38805,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38806,'Greetings, hero. I craft and sell Freya\'s Lasherweave armor for druids.','Greetings, hero. I craft and sell Freya\'s Lasherweave armor for druids.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(38807,'I wish to browse your wares.','I wish to browse your wares.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38808,'...me not know what you say.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38809,'Greetings, hero. I craft and sell Frost Witch armor for shaman.\n','Greetings, hero. I craft and sell Frost Witch armor for shaman.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38810,'Greetings, hero. I craft and sell Shadowblade armor for rogues.\n','Greetings, hero. I craft and sell Shadowblade armor for rogues.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38811,'Greetings, hero. I craft and sell Ahn\'kahar Blood Hunter armor for hunters.','Greetings, hero. I craft and sell Ahn\'kahar Blood Hunter armor for hunters.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38812,'Greetings, hero. I craft and sell Ymirjar Lord\'s armor for warriors.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38813,'Greetings, hero. I craft and sell Lightsworn armor for paladins.\n','Greetings, hero. I craft and sell Lightsworn armor for paladins.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38814,'Greetings, hero. I craft and sell Crimson Acolyte armor for priests.\n','Greetings, hero. I craft and sell Crimson Acolyte armor for priests.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38815,'Greetings, hero. I craft and sell Bloodmage armor for magi.\n','Greetings, hero. I craft and sell Bloodmage armor for magi.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38816,'Greetings, hero. I craft and sell Dark Coven armor for warlocks.\n','Greetings, hero. I craft and sell Dark Coven armor for warlocks.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38817,'Oh. Ogre like eat bug. Get bug from west.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38818,'Spirits rise once again!','Spirits rise once again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38819,'','Leave the fire alone, pesky trolls! Just give up and die.',0,0,0,0,0,0,0,0,1,11577,0,21812,26124),
(38820,'','No! I will make your death slow and painful, little trolls.',0,0,0,0,0,0,0,0,1,11577,0,21813,26124),
(38821,'','You were a fool to touch my fires! When Vol\'jin falls, you know who dies next!',0,0,0,0,0,0,0,0,1,11577,0,21814,26124),
(38822,'','What is this?! Release me!',0,0,0,0,0,0,0,0,1,11577,0,21816,26124),
(38823,'','This is not right - this is not how it was supposed to end!',0,0,0,0,0,0,0,0,1,11577,0,21817,26124),
(38824,'','The waves shall rise and consume your tribe, Vol\'jin! You should never have returned!',0,0,0,0,0,0,0,0,1,11577,0,21818,26124),
(38825,'She\'s drawing power from the fires! Stamp out the braziers, quickly!','',0,0,0,0,0,0,0,0,1,9218,0,0,26124),
(38826,'','Take care of her spirits! We be handlin\' Zar\'jira.',0,0,0,0,0,0,5,0,1,11577,0,21944,26124),
(38827,'<The unfortunate soldier you find at the side of the road has been gutted with what appears to have been long knives. Rolling the body over, you notice teeth marks.>$B$B<Could wild animals have done this?> ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38828,'The Sea Witch is \'ere, I can sense it. Stay and she\'s sure to come out of her hole soon enough.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38829,'It be done. Our ancient enemy is defeated.','',0,0,0,0,0,0,1,0,1,11577,20121,0,26124),
(38830,'[DND] Have you filled out the proper paper work and paid the appropriate fees to gain access to the auction house?','[DND] Have you filled out the proper paper work and paid the appropriate fees to gain access to the auction house?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38831,'I have the proper certification to use the bank.','I have the proper certification to use the bank.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38832,'[DND] Have you filled out the proper paper work and paid the appropriate fees to gain access to the bank?','[DND] Have you filled out the proper paper work and paid the appropriate fees to gain access to the bank?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38833,'I been waitin\' a long time for a chance to avenge my father. A great weight has been lifted from my shoulders.','',0,0,0,0,0,0,1,0,1,11577,20122,0,26124),
(38834,'I must be returnin\' ta Darkspear Hold. Please meet me there once Vanira is done with her healin\' of the boy.','',0,0,0,0,0,0,1,0,1,11577,20123,0,26124),
(38835,'','I\'m afraid there\'s nothin\' I can do for our brother... her power tore away at his soul.',0,0,0,0,0,0,1,0,1,11577,0,21946,26124),
(38836,'','I\'ll send some watchers ta get his body so we can offer a proper farewell... I wish I could do more.',0,0,0,0,0,0,1,0,1,11577,0,21947,26124),
(38837,'','Vol\'jin rushed off in eagerness, but I can take us back to safety. Just give me the word when ya ready, mon.',0,0,0,0,0,0,275,0,1,11577,0,21948,26124),
(38838,'','An ancient score is settled today.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38839,'Now then, $n. Let\'s see what this what this crazy stick is capable of...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38840,'Interesting. Very ... interesting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38841,'Look at this mess. I was told the Barrens would be... barren.$B$BThis jungle appeared overnight and has already swallowed up my camp and choked off the roads!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38842,'Have you come to join the hunt, $n?','Have you come to join the hunt, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38843,'Be gone, $c.  I have no need of you in my hunt.','Be gone, $c.  I have no need of you in my hunt.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38844,'Gol-Crawdad!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38845,'Frappin\' cratchet! Sonnova HEY what!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38846,'\'magonna - git! Git! Horkin\' nit, unfh, DABBIT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38847,'Stay out of the way of Volcanoth\'s breath!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38848,'','Stop shooting you senile idiot! You\'re going to kill somebody!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38849,'Hang in there ol\' buddy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38850,'[ph]Citizens of Thunder Bluff! Our matriarch Magath requires citizens wanting to access their vault to pay a small service fee.  ','[ph]Citizens of Thunder Bluff! Our superior matriarch Magath requires citizens wanting to access their vault to pay a small service fee.  ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38851,'[ph]This fee ensures the use of the bank for a limited amount of time.  ','[ph]This fee ensures the use of the bank for a limited amount of time.  ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38852,'[ph]Citizens who refuse to pay this fee will not be allowed to use the banking services here on Thunder Bluff.','[ph]Citizens who refuse to pay this fee will not be allowed to use the banking services here on Thunder Bluff.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38853,'[ph]Purchase a permission slip from me and access to your vault will be granted.','[ph]Purchase a permission slip from me and access to your vault will be granted.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38854,'The %s is ready to be captured!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38855,'[ph]Attention Citizens of Thunder Bluff!','[ph]Attention Citizens of Thunder Bluff!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38856,'[ph]For a small fee, you can have an all access pass to either Grimtotem auctioneer.','[ph]For a small fee, you can have an all access pass to either Grimtotem auctioneer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38857,'[ph]All money collected will be used for the betterment of the Horde.','[ph]All money collected will be used for the betterment of the Horde.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38858,'To use the convienent Grimtotem Auctioneering services, you must have the permission of the great Magatha Grimtotem!','To use the convienent Grimtotem Auctioneering services, you must have the permission of the great Magatha Grimtotem!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38859,'[ph]Citizens unwilling to pay will be refused access to the Auction services.','[ph]Citizens unwilling to pay will be refused access to the Auction services.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38860,'$n - help! The ropes ... please...','',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(38861,'Untying','Untying',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38862,'Ah, thank you! Suffice it to say... Negotiations did proceed as planned.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38863,'I should be able to get back to camp on my own.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38864,'[ph]Caire is dead?  It\'s hard to imagine.','[ph]Caire is dead?  It\'s hard to imagine.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(38865,'[ph]It is still fortunate for us.  Magatha has guided us well.  She knew this day would come.','[ph]It is still fortunate for us.  Magatha has guided us well.  She knew this day would come.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(38866,'[ph] So soon though?  I do not think even she thought this invasion would go as swiftly as it did.','[ph]Thinking about things?  What do YOU have to think about?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(38867,'[ph]To be standing in Thunder Bluff....OUR Thunder Bluff so soon after Cairne died is not luck.','[ph]To be standing in Thunder Bluff....OUR Thunder Bluff so soon after Cairne died is not luck.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(38868,'What do you need papers for?','What do you need papers for?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38869,'What do you need?','What do you need?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38870,'What are you trying to use?','What are you trying to use?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38871,'What?','What?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38872,'Don\'t worry, your money is safe with us.','Don\'t worry, your money is safe with us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38873,'I\'ve filled out my paperwork for the bank.','I\'ve filled out my paperwork for the bank.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38874,'','Hang on, $n! We have to get out of here, NOW!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38875,'Blood...more BLOOD!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38876,'Tha Sea Witch is dead, our home is reclaimed, but our future still be uncertain.','',0,0,0,0,0,0,1,0,1,9223,20108,0,26124),
(38877,'Dere\'s only one with tha answers I seek. Ya can stay and watch if ya like.','',0,0,0,0,0,0,1,0,1,9223,20110,0,26124),
(38878,'I\'ve no love for Garrosh, dat much is sure, but leavin\' tha Horde is not a decision I be takin\' lightly.','',0,0,0,0,0,0,1,0,1,9223,20109,0,26124),
(38879,'Indeed.  Someone did try to kill me, but that is not my greatest concern at this moment.  The world itself calls for my aid.','',0,0,0,0,0,0,1,0,1,9223,20134,0,26124),
(38880,'Thrall!  I am glad ya be well.  Dere were rumors otherwise.','',0,0,0,0,0,0,1,0,1,9223,20111,0,26124),
(38881,'Vol\'jin, I chose Garrosh because he has the strength to lead our people in these trying times. ','',0,0,0,0,0,0,1,0,1,9223,20135,0,26124),
(38882,'I must beg ya council, my friend.  I can\'t be standin\' by Garrosh while he be turnin\' our people against each other for tha sake of war.  My respect for you does not extend to dis new Horde... I am tinkin\' of leadin\' my people away.','',0,0,0,0,0,0,1,0,1,9223,20112,0,26124),
(38883,'For all my supposed wisdom, there have been moments that I\'ve barely been able to hold the Horde together. The Wrath Gate and Undercity displayed that clearly enough.','',0,0,0,0,0,0,1,0,1,9223,20136,0,26124),
(38884,'The Horde cries for a hero of old. An orc of true blood that will bow to no human and bear no betrayal. A warrior that will make our people proud again. Garrosh can be that hero.','',0,0,0,0,0,0,1,0,1,9223,20137,0,26124),
(38885,'I understand, brotha. I will tink on this and be troublin\' ya no furtha. You have a world to be savin\'.','',0,0,0,0,0,0,6,0,1,9223,20113,0,26124),
(38887,'Ya be strong and proud, youngblood.  Tha Darkspear will be honored ta have you fight beside d\'em.','',0,0,0,0,0,0,1,0,1,9223,20114,0,26124),
(38888,'Throm\'ka, old friend.','',0,0,0,0,0,0,66,0,1,9223,20147,0,26124),
(38889,'Dese be dark times, but our people will be stayin\' with tha Horde for tha good of all.  ','',0,0,0,0,0,0,1,0,1,9223,20115,0,26124),
(38890,'Thrall\'s words be true. Dey always be. The Horde is much more den a few old, stubborn leaders and a handful of heroes from Northrend. The people be cryin\' Garrosh\'s name... at least for now.','',0,0,0,0,0,0,1,0,1,9223,20116,0,26124),
(38891,'So, you wanna find de fabled swords of de Sandfury, eh?$B$BYa be ready ta kill for Sul\'thraze? Spill de blood across de sands? In search of treasure, of power?$B$BIf ya are...welcome to de desert, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38892,'I have sometin\' to show ya. It be easier to understand if ya see it yourself.','',0,0,0,0,0,0,1,0,1,9224,20097,0,26124),
(38893,'','Eekrala gree-kay. By blood and by thorn...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38894,'','New life from clay. Dead earth... reborn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38895,'','They come... <Snort> Pretty $r, yes? So pretty...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38896,'You deserve to lose this land, for what your people did to us!  Now back off, or face the wrath of the worgen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38897,'Don\'t talk back to me, troll.  You know who was left in charge here.  Haven\'t you stopped to ask yourself why Thrall chose me instead of you?','',0,0,0,0,0,0,25,0,1,9224,20508,0,26124),
(38898,'Dere be no question why, Garrosh.  He gave ya tha title because ya be Grom\'s son and because tha people be wantin\' a war hero.','',0,0,0,0,0,0,5,0,1,9224,20098,0,26124),
(38899,'Ya be no Warchief of mine.  Ya not earned my respect and I\'ll not be seein\' tha Horde destroyed by ya foolish thirst for war.','',0,0,0,0,0,0,1,0,1,9224,20100,0,26124),
(38900,'I know exactly what I\'ll be doin\' about it, son of Hellscream.  I\'ll watch and wait as ya people slowly become aware of ya ineptitude.  I\'ll laugh as dey grow ta despise ya as I do.','',0,0,0,0,0,0,1,0,1,9224,20101,0,26124),
(38901,'You have sealed your fate, troll.','',0,0,0,0,0,0,1,0,1,9224,20510,0,26124),
(38903,'You are lucky that I don\'t gut you right here, whelp.  You are foolish to think that you can speak to your Warchief in such ways.','',0,0,0,0,0,0,5,0,1,9224,20512,0,26124),
(38904,'And what exactly do you think that you are going to do about it?  Your threats are hollow.  Go slink away with the rest of your kind to the slums, I will endure your filth in my throne room no longer.','',0,0,0,0,0,0,1,0,1,9224,20509,0,26124),
(38905,'And when tha time comes dat ya failure is complete and ya \"power\" is meaningless, I will be dere to end ya rule swiftly and silently.','',0,0,0,0,0,0,1,0,1,9224,20102,0,26124),
(38906,'%s spits at Vol\'jin\'s feet.','',0,0,0,0,0,0,0,0,1,9224,0,0,26124),
(38908,'','$n, come on! Get over here!!!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(38909,'','EeeKKeech - it stings! It crushes! $GHe:She; tricked us, kills $ghim:her;, kill!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38910,'I will see ta it personally dat the Darkspear rise as a power in their own right.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38911,'Can you tell me of the time when the Darkspear left Orgrimmar, Vol\'jin?  I need to see Garrosh\'s actions for myself.','Can you tell me of the time when the Darkspear left Orgrimmar, Vol\'jin?  I need to see Garrosh\'s actions for myself.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38912,'Joke\'s on you, mon. I found Jang\'thraze long ago. Had both of de halves...\'til some wily one come and steal one away in de night.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38913,'Now dat Sang\'thraze is mine again, de only thing ya be findin\' here...is ya own fresh grave.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38914,'Behold! Sul\'thraze the Lasher be rejoined!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38915,'Enough\'a dis...Chief Sandscalp can\'t reward me if I\'m dead, yah? Farewell, mon...for good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38916,'You can trust our auctioneers.','You can trust our auctioneers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38917,'I\'ve filled out all the paperwork for the auction house.','I\'ve filled out all the paperwork for the auction house.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38918,'[ph] And to think...no one even saw it coming.','[ph] And to think...no one even saw it coming.',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(38919,'[ph]She must have been planning this for a long time.','[ph]She must have been planning this for a long time.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(38920,'[ph]Attacking Thunder Bluff was easier than expected.','[ph]Attacking Thunder Bluff was easier than expected.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(38921,'[ph] Without Cairne, the citizens of Thunder Bluff really didn\'t have much fight in them.','[ph] Without Cairne, the citizens of Thunder Bluff really didn\'t have much fight in them.',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(38922,'[ph] Now that we have control, there are going to be some changes around here.','[ph] Now that we have control, there are going to be some changes around here.\n',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(38923,'[ph] I just hope Stormsong was able to take out the Pretender.  With Baine dead, we could take some of these extra guard patrols down.','[ph] I just hope Stormsong was able to take out the Pretender.  With Baine dead, we could take some of these extra guard patrols down.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(38924,'[ph] Have you heard anything from the attack on Bloodhoof Village?','[ph] Have you heard anything from the attack on Bloodhoof Village?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(38925,'[ph] Not yet.  When I last talked to Tarakor, it should have started already.','[ph] Not yet.  When I last talked to Tarakor, it should have started already.',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(38926,'[ph] Just stay alert.  Any sign of Bloodhoof and we\'ll have a true fight on our hands.','[ph] Just stay alert.  Any sign of Bloodhoof and we\'ll have a true fight on our hands.',0,0,0,0,0,0,153,0,1,0,0,0,26124),
(38927,'This ain\'t the first time I been stuck up to me teef in a jungle that up an\' done ambushed me. I been all over the world, $gson:missy;, an\' I\'ll be hog-smacked if this one\'s gonna be the end of me.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(38928,'Tell me a story, Ol\' Durty Pete!','Tell me a story, Ol\' Durty Pete!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38929,'Back in the day \'afore the day, me and me mates didn\'t have much in the way of drinkin\' money, as is we spent our pay on booze an\' that didn\'t leave none left over for more casual drinkin\'.$B$BSo we decide we\'re gonna comm-an-deer one of them epic-sized kegs of ol\' Barkerstout from the loft of Barky\'s Brewpub.$B$BWe chopped the supports out with hatchets and that ol\' boy just up an\' ROLLED on out through the side of the thatch roof like a baby bird leavin\' the nest, but some sort of big round beer bird, that could crush a man.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(38930,'You know why they call it stout? \'Cuz once it were rolling down the hill it couldnae be bargained wit\', couldnae be reasoned wit\'. It felt no pity, no remorse, no fear.$B$BIt were like a beervalanche, which is a damn fine way to die.$B$BSo that keg explodered soon as it hit the orphanage at the bottom of the hill, and I dove inta the mud puddle wit\' me mouth open, an\'... Come to think of it, I don\'t \'member how this story ends. Wanna see the tattoo?$B$B<Ol\' Durty Pete drops his pants.>','',1,22,14,0,0,0,0,0,1,0,0,0,26124),
(38931,'You see this here gun, $gboy:missy;?$B$B<Ol\' Durty Pete casually waves his weapon directly at your face.>$B$BThis here gun\'s seen action on every continent but for Northrend. It\'s saved me life more times than I can count: Seven. One time, \"Big Mackie\" MacDungal - not the wee MacDungal now, but his pappy - offered me his youngest daughter in barter for me gun.$B$BLet me tell you somethin\' about Edie: she and me gun had a lot in common. Wide-mouthed. Buck-toofed. Dangerous from the biz-ness end. Likin\' to go oft half-cocked.$B$BYou heard about the time wee Edie bet Chuck Brandybeard 25 silver she could kick \'im in the head so hard he would weep snot?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(38932,'Ayup, word got around fast and soon the whole of Menethil gathered around to see it through, with bettin\' and fruit vendors and the like, an\' there were some consternation over the rules that had to be ironed out with a big rigamarole, \'til the mayor hisself agreed that weepin\' blood tain\'t count fer nothin\'.$B$BSo Chuck kneels down an\' she gets up on a stool and REARS back with that big \'ol thick leg of hers and - but I\'m digressin\'. Point is, I shoulda taken the deal, \'cuz this gun\'s a bit dodgy.','',1,5,274,0,0,0,0,0,1,0,0,0,26124),
(38933,'They didn\'t always call me Ol\' Durty Pete.$B$BOnce, when I were young an\' durty, I thought I\'d impress a sweet buxom lass named Bellie with me chiselin\' styles.$B$BOl\' Bellie! She were somthin\' else. Firm, that one. All big but for the middle, like they was meant to be.$B$BSo I found me a chunk of limestone white like her skin and I set about to chiselin\' and carvin\' and creatin\' what you\'d call a masterpiece, but I got me scale all wrong, see? I ended up with an enormous, what would you call it? Butt.','',1,23,5,0,0,0,0,0,1,0,0,0,26124),
(38934,'You heard me, $glad:lass; - a butt! Not a fitting gift for a lady. But I liked it. So I offered to donate it to me local drinkin\' hole.$B$BThey called it Durty Pete\'s Bottom, and eventually named the pub after it, afore them orcs burned it to toast, and all that\'s left today is me big blackened bottom amidst a heap of rubble.$B$B<Ol\' Durty Pete sheds a single tear.> ','',5,1,18,0,0,0,0,0,1,0,0,0,26124),
(38935,'Back in the war - not that one, the udder one - when them orcs rode dragons? Me and Whistler set out to cross from Southshore to Menethil Harbor inna rowboat we\'d built outta knotty pine while soused to our eyeballs on Cherry Grog.$B$BAn\' we got about a third the way by my reckoning, which were mostly far judgin\' by the fact that there were nothing all around us but the sea, when my feet got to start feelin\' wet.','',1,23,5,0,0,0,0,0,1,0,0,0,26124),
(38936,'Now let me tell you somethin\' about knotty pine, it\'s got knots, $gson:missy;.$B$BAnd knots is just big holes in trees, which makes for a stupid rowboat and I blamed Whistler but he had his own ideas about my choice of tar (I chose to forget it) so we decided to settle it by drinking.$B$BWhen the grog ran out, that\'s when we had the knife fight. For sport.$B$BAnyways, we never made it to Menethil, and I\'m pretty sure one or both of us drowned.','',5,6,273,0,0,0,0,0,1,0,0,0,26124),
(38937,'That sounds serious.','That sounds serious.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38938,'Tell me another story, Ol\' Durty Pete!','Tell me another story, Ol\' Durty Pete!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38939,'Weep SNOT!?','Weep SNOT!?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38940,'A butt?','A butt?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38941,'That\'s not good.','That\'s not good.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38942,'I\'ve heard this one. Tell me another...','I\'ve heard this one. Tell me another...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38943,'','OH MY GOSH! BEHIND YOU!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38944,'Ya will spend ya reign glancin\' over ya shoulda and fearin\' tha shadows, for when tha time comes and ya blood be slowly drainin\' out, ya will know exactly who fired tha arrow dat pierced ya black heart.\n','',0,0,0,0,0,0,1,0,1,9224,20103,0,26124),
(38946,'You spoke of communing with Thrall?  Did I miss it?','You spoke of communing with Thrall?  Did I miss it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38947,'And you yours, \"Warchief.\"','',0,0,0,0,0,0,1,0,1,9224,20104,0,26124),
(38948,'Keep hacking at the overgrowth! If that doesn\'t work, we\'re going to start burning.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38949,'I like the way you think, Bridgewater.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38950,'','Is that your plan, Teegan? Set fire to anything that gets in our way?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38951,'%s slaps a mosquito on his neck.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38952,'Disgusting! We\'ll have to slash and burn our way to Forward Command.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38953,'In a word? No.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38954,'','Aren\'t you the least bit curious why the Barrens are suddenly in bloom, seemingly overnight?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38955,'','WE\'RE ON FIRE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38956,'Stinking. Disgusting. Filthy animals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38957,'I was talking about you and Durty Pete.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38958,'','YEEEEEEEEEEE HAAAAAAAAAAAA!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38959,'Aye, the quilboar are a foul lot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38960,'%s belches loudly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38961,'There\'s some good huntin\' to be found here in the Barrens, if you\'ve the stomach for it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38962,'We\'re still cut off from Forward Command, but thanks to your \'negotiations\' with the quilboar, we should be able to re-open the roads with a little elbow grease.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38963,'','The Corporal\'s a good man, but he\'s got tunnel-vision when it comes to his orders.$B$BSomething unnatural is happening to the land here, $n. This jungle shouldn\'t be here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38964,'People tink raptors wild and vicious, but little else. In truth, they be loyal and cunnin\' in ways ya hardly know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38965,'','Up and away, hon. I\'ll steer, you just keep an eye out.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38966,'','Alright, throw the Life-Rocket packs down to the survivors, and drop the bombs on the pirates. Try not to mix those up, okay?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38967,'','Geronimo!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38968,'','GENERAL TRIGGER 4 SENT, REMOVE THIS ACTION!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38969,'','See you back in town, babe!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38970,'','We\'re coming up on the Town-In-A-Box now...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38971,'','Oh no! Where is everyone? I dropped them off here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38972,'%s begins casting Empowered Shock Vortex!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38973,'','Get in the back seat. We\'re getting out of here. I know where our old friends, the orcs, are!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38974,'Behind you, $n! Look out - incoming!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38975,'Incoming! Horde incoming - Look out behind you, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38977,'|TInterface\\Icons\\ability_creature_cursed_01.blp:12|t %s cast |cFFFF7F00Vile Gas!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38978,'Ya want to join the attack on the naga?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38979,'Yes.  Do you have a raptor that can take me there?','Yes.  Do you have a raptor that can take me there?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38980,'','Get away from me, you monster!  Don\'t look at me!  I\'m hideous!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38981,'You\'re not hideous, Lilian... you\'re one of us.  Here, look in this mirror, see for yourself.','You\'re not hideous, Lilian... you\'re one of us.  Here, look in this mirror, see for yourself.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38982,'','You don\'t understand... I CAN\'T be undead!  Not me, not now...',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(38983,'','Father, NO!  Wait... where am I?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38984,'','Ahh!  Get away from me, you fiend!',430,0,0,0,0,0,0,0,1,0,0,0,26124),
(38985,'','What are you doing here?  Get out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38986,'I\'m here to rescue you.','I\'m here to rescue you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38987,'','First of all, I don\'t need to be rescued.  Second of all, I\'d never allow myself to be rescued by an abomination like you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38988,'Lilian, you\'re one of the Forsaken, like me.  Which brings the question: why did the Scarlet Crusade put you in a cage?  They usually kill the undead on sight.','Lilian, you\'re one of the Forsaken, like me.  Which brings the question: why did the Scarlet Crusade put you in a cage?  They usually kill the undead on sight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38989,'Why did the Scarlet Crusade put you in a cage?  They usually kill the undead on sight.','Why did the Scarlet Crusade put you in a cage?  They usually kill the undead on sight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38990,'','I\'m NOT undead!  Not for long, anyway.  My father will rescue me, I know it...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38991,'Your father?','Your father?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38992,'','First Kezan and now here. We are toast if we don\'t find a way off of this island soon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38993,'The time has come, my little captive... word has come back from your father.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38994,'','Gebler, you came!  What did he say?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38995,'High Priest Voss denounces you as a daughter.  He\'s ordered that you be executed immediately.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38996,'','What?  NO!  This can\'t be!  Gebler, you know me... we were friends once!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38997,'The High Priest sends his regrets.  He had hoped that one day you would be a powerful weapon against our enemies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38998,'Unfortunately, you were too dangerous in life, and you\'re far too dangerous in undeath.  I will enjoy killing you, you Scourged witch...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(38999,'','The world of the living may have turned its back on me, but I\'m no damned Scourge.  Just go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39000,'','Yes, my... wait, be quiet!  I hear the lieutenant approaching.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39001,'','Gebler, father, why would you...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39002,'I\'ve never been more proud ta be a Darkspear. Vol\'jin leads us ta glory.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39003,'Now I stand, the lion before the lambs... and they do not fear.','',0,0,0,0,0,0,0,0,1,0,17361,0,26124),
(39004,'They cannot fear...','',0,0,0,0,0,0,0,0,1,0,17362,0,26124),
(39005,'A day of celebration and of mourning, hero...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39006,'Where we go from here is unknown, hero. What we do know is that none of this would have been possible without your aid.$B$BThe Knights of the Ebon Blade salute you.','',1,1,66,0,0,0,0,0,1,0,0,0,26124),
(39007,'','So cold...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39008,'','The cold dark beckons...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39009,'','Save me from the cold!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39010,'[ph]It appears the Grimtotem clan now has a home to build upon.','[ph]It appears the Grimtotem clan now has a home to build upon.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(39011,'[ph]I would not say that so soon.','[ph]I would not say that so soon.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(39012,'','I have returned to finish what I started, Darkspear. These islands shall run with your blood.',0,0,0,0,0,0,1,0,1,9261,0,0,26124),
(39013,'Atennnn ... SHUN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39014,'','Your father was a weakling, Vol\'jin. I shall enjoy sucking the life from you as I did him.',0,0,0,0,0,0,1,0,1,9261,0,0,26124),
(39015,'','Ah, another Darkspear Warrior sacrificed on my altar. One by one, you shall all perish.',0,0,0,0,0,0,1,0,1,9261,0,0,26124),
(39016,'','Thrall is not here to save you this time, Darkspear. Slink away to the shadows, for I shall hunt every last one of you down.',0,0,0,0,0,0,1,0,1,9261,0,0,26124),
(39017,'','The tides shall wash away the entire Darkspear Tribe.',0,0,0,0,0,0,1,0,1,9261,0,0,26124),
(39018,'','Troll weaklings, there is no hope. Your death has been foretold by the tides.',0,0,0,0,0,0,1,0,1,9261,0,0,26124),
(39019,'','When I am finished with your tribe, I shall hunt down that orcish cur that saved you from my wrath once before. None will survive.',0,0,0,0,0,0,1,0,1,9261,0,0,26124),
(39020,'','You were fools to leave the safety of your city. Your return to the ocean has assured your demise.',0,0,0,0,0,0,1,0,1,9261,0,0,26124),
(39021,'Aaarrrmms ... ABOUT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39022,'Right shoulder ... ARMS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39023,'PRESENT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39024,'Look lively there, Grizwald.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39025,'When\'s the last time you cleaned that weapon, Holmberg?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39026,'Barkley, we do NOT aim with our eyes closed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39027,'Remember, you will not fire until you see the - whatever color their eyes are.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39028,'Fast. But not fast enough. We\'ll do it again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39029,'Jackson, you\'ve spilled your powder all over the ground. <Sigh>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39030,'Gentlemen, our business is murder. And business is GOOD.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39031,'At ease.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39032,'[ph] We will not have anything to speak of if the Pretender comes here.','[ph] We will not have anything to speak of if the Pretender comes here.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(39033,'[ph]Baine?  He would be crazy to come here.  We outnumber him at least two to one.  He\'s the one that should be worried.','[ph]Baine?  He would be crazy to come here.  We outnumber him at least two to one.  He\'s the one that should be worried.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(39034,'[ph]Do not underestimate members of the Bloodhoof.  Did you ever see that totem that Cairne carried around?','[ph]Do not underestimate members of the Bloodhoof.  Did you ever see that totem that Cairne carried around?',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(39035,'[ph]I\'ve only heard stories.  Some say it can only be picked up with two hands, but Cairne could wield it easily in one.','[ph]I\'ve only heard stories.  Some say it can only be picked up with two hands, but Cairne could wield it easily in one.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(39036,'[ph] Exactly.  Let us hope that Baine has less than half the strength of his father...or we are going to need more guards.','[ph] Exactly.  Let us hope that Baine has less than half the strength of his father...or we are going to need more guards.',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(39037,'Now we\'re cooking, $n.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(39038,'Come an\' get it!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(39039,'Yessir, those stormsnouts pack quite a punch.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(39040,'I want you to know that I sincerely appreciate your aid, $c. We are not fighting beasts out here, but a foe both cunning and fanatical. We must stick together or hang separately.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39041,'What is your name, $c? $n?$B$BWelcome to the Barrens. You are standing at the vanguard of one of our most important operations on this continent. I would be honored if you were to lend us your strength.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39042,'Tha Darkspear shall never give in to ya kind, Zar\'jira. We\'re stronga\' than you\'ll eva\' be.','',0,0,0,0,0,0,1,0,1,11577,20120,0,26124),
(39043,'I\'ll get the fires dis time!','',0,0,0,0,0,0,5,0,1,0,21388,0,26124),
(39044,'','ZUNI! NOOOO!',0,0,0,0,0,0,5,0,1,11577,0,21945,26124),
(39045,'','Not so fast, little troll!',0,0,0,0,0,0,1,0,1,11577,0,21815,26124),
(39046,'What\'s going on?','What\'s going on?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39047,'Why... what happened...','Why... what happened...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39048,'So cold...','So cold...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39049,'By the Light, I\'m alive again...','By the Light, I\'m alive again...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39050,'What is this place?','What is this place?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39051,'I used to be handsome...','I used to be beautiful...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39052,'The plague... is it over?','The plague... is it over?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39053,'It feels like I\'ve been sleeping for years...','It feels like I\'ve been sleeping for years...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39054,'Ah, I see.  Well, I guess I\'m off to work then.','Ah, I see.  Well, I guess I\'m off to work then.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39055,'...I think I understand what\'s going on.  At least I still have my free will.','...I think I understand what\'s going on.  At least I still have my free will.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39056,'Ah, I see.  Looks like I\'m part of the Horde now.','Ah, I see.  Looks like I\'m part of the Horde now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39057,'Ah, I understand.  Off to work!','Ah, I understand.  Off to work!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39058,'Undead?  I will have my vengeance against the Lich King!','Undead?  I will have my vengeance against the Lich King!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39059,'Aha, I understand now.  Thank you for waking me.','Aha, I understand now.  Thank you for waking me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39060,'It\'s so dark in here.  I\'m not sure I like being undead.','It\'s so dark in here.  I\'m not sure I like being undead.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39061,'That was a good nap.  Wait, where\'s my elbows and knees?!','That was a good nap.  Wait, where\'s my elbows and knees?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39062,'The Scourge will destroy you all!  Death will sweep the lands!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39063,'Prepare to die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39064,'Not so fast! Save some for me, mon!','',0,0,0,0,0,0,5,0,1,0,21374,0,26124),
(39065,'Dis is wild! Vol\'jin\'s not messin\' around. He\'s going afta tha Sea Witch wit a vengeance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39066,'Wait up, mon!','',0,0,0,0,0,0,5,0,1,0,21368,0,26124),
(39067,'You finished with ya trainin\' too? Glad you make it through, mon!','',0,0,0,0,0,0,6,0,1,0,21370,0,26124),
(39068,'I know dis is prolly busy work, but I don\'t mind. Dese baby raptors are cute lil devils.','',0,0,0,0,0,0,1,0,1,0,21371,0,26124),
(39069,'Try not ta make me look too bad, eh?','',0,0,0,0,0,0,1,0,1,0,21373,0,26124),
(39070,'Ha! I caught up with ya! Let\'s stick together in \'ere, okay?','',0,0,0,0,0,0,1,0,1,0,21387,0,26124),
(39071,'Take me back to Darkspear Hold if you would, Vanira.','Take me back to Darkspear Hold if you would, Vanira.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39072,'Hey $gman:woman;, I\'m just tryin\' to get my slice of the pie.','Hey $gman:woman;, I\'m just tryin\' to get my slice of the pie.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39073,'You want in on this? Smash and grab, baby!','You want in on this? Smash and grab, baby!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39074,'Hurry up, $c! Take everything you can!','Hurry up, $c! Take everything you can!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39075,'All these dead Tauren got on \'em is beads and junk. Did you score anything good? ','All these dead Tauren got on \'em is beads and junk. Did you score anything good? ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39076,'Hey, $c! This place is pretty picked over but you might still be able to find somethin\' worth your time.','Hey, $c! This place is pretty picked over but you might still be able to find somethin\' worth your time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39077,'Whoa, you aren\'t here to bust us, are you?','Whoa, you aren\'t here to bust us, are you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39078,'You\'re under arrest.','You\'re under arrest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39079,'I ain\'t goin\' back to the clink, $gman:lady;!','I ain\'t goin\' back to the clink, $gman:lady;!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39080,'You\'ll never take me alive, $c!','You\'ll never take me alive, $c!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39081,'Cheese it! It\'s the fuzz!','Cheese it! It\'s the fuzz!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39082,'It didn\'t have to go down this way, $c.','It didn\'t have to go down this way, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39083,'No way I\'m letting them ship me back to the stockades!','No way I\'m letting them ship me back to the stockades!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39084,'I yield. I\'ll go quietly.','I yield. I\'ll go quietly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39085,'...Busted!','...Busted!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39086,'Okay, stop! I give up!','Okay, stop! I give up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39087,'Ya trainer should be somewhere in the grounds \'ere. I\'ll catch you lata, mon.','',0,0,0,0,0,0,1,0,1,0,21367,0,26124),
(39088,'','I expect this operation to proceed without major incident.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39089,'I sshal ssslaughter you, Darksspear runt! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39090,'The Sssea Witch will kill you all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39091,'They sssend you to your death, youngling.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39092,'I sshal tasste your blood, landling.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39093,'Hold the line!','',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(39094,'We will throw these Alliance curs back into the sea!','',0,0,0,0,0,0,15,1,1,0,0,0,26124),
(39095,'Lok\'tar ogar!','',0,0,0,0,0,0,15,1,1,0,0,0,26124),
(39096,'Thrall Hall!','',0,0,0,0,0,0,15,1,1,0,0,0,26124),
(39097,'Teach these cowards the true meaning of war!','',0,0,0,0,0,0,397,1,1,0,0,0,26124),
(39098,'Fight for your ancestors and your true warchief!','',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(39099,'The Alliance sends gnomes and dwarves against us? Is this some kind of joke?!','',0,0,0,0,0,0,6,1,1,0,0,0,26124),
(39100,'Our little friend is here. I weep for the dwarves if the goblin has their weed whacker!','',0,0,0,0,0,0,11,1,1,0,0,0,26124),
(39101,'Why are you playing with them? It\'s cruel.','',0,0,0,0,0,0,11,1,1,0,0,0,26124),
(39102,'They eagerly rush to their deaths. What fools!','',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(39103,'Perhaps they should send their gnomes down here? They could do no worse!','',0,0,0,0,0,0,11,1,1,0,0,0,26124),
(39104,'They spoil the coast with their cowardly mines. Disgusting!','',0,0,0,0,0,0,397,1,1,0,0,0,26124),
(39105,'There is no better day than one filled with the blood of dwarves!','',0,0,0,0,0,0,15,1,1,0,0,0,26124),
(39106,'Tighten it up a little. We wouldn\'t want them to slip through and miss all of the fun.','',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(39107,'I\'ve seen what our goblin friend can do. These dwarves are in for a nasty surprise!','',0,0,0,0,0,0,15,1,1,0,0,0,26124),
(39108,'The Kor\'kron could not fight better! For the Horde!','',0,0,0,0,0,0,15,1,1,0,0,0,26124),
(39109,'Your friends were all taken prisoner by Trade Prince Gallywix while the volcano was exploding.$B$BWe are going to have to deal with the Alliance quickly if we\'re to rescue them and get off of this island.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39110,'Throm-Ka, $n. It is good to see you again.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(39111,'Working for Jerrod isn\'t all that bad.  He might lose his temper now and again, but he pays well, and he even gives me a boost when I can\'t reach something in the cart.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39112,'What is it I can do for you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39113,'<Deathguard Simmer looks at you expectantly.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39114,'Me sorry! No hurt!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39115,'Any savage can win a war. The true hero aims not merely for victory on the battlefield, but to attain a lasting peace after the final arrow falls.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39116,'Get back into the skies on the Tranquil Coast or be ejected!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39117,'You\'re doing incredible work here in the Barrens, $n.$B$BWith the help of heroes like you, we can secure Kalimdor, and in doing so ensure a lasting peace in our homelands.','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(39118,'','The Warchief has promised to help us rescue our people and deal with Gallywix if we help them with the Alliance.$B$BIt sounds like a fair deal to me. The enemy of my friend is my enemy, right?',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(39119,'Get me up into the skies, Sassy!','Get me up into the skies, Sassy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39120,'$n! How can I help you, old friend?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39121,'Just between you and me, I worry that the good General here doesn\'t have the stomach to do what needs to be done.$B$BThis is the Horde we\'re dealing with. History shows there can never be peace.$B$BOur goal should be ... annihilation.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(39122,'You might not think that a Worgen like myself would know how to cook a fine steak.$B$BJust \'cuz I like my meat raw... Still panting from flight... Arterial spray in my face...$B$BWhat were we talking about? Oh yes! I was quite the gourmet back in Gilneas.','',6,15,1,0,0,0,0,7,1,0,0,0,26124),
(39123,'Tell me what happened at Taurajo.','Tell me what happened at Taurajo.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39124,'Ah yes, our assault on the Horde town of Taurajo. I struggled with the implications of the decision.$B$BTaurajo was admittedly what you might call a \'soft target,\' primarily a hunters\' camp. Still, it had been used to recruit, equip, and train Horde infantry for many years.$B$BWhen our scouts reported that Taurajo\'s most dangerous units were out on the hunt, we had to act quickly.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39125,'We sacked the town?','We sacked the town?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39126,'<Hawthorne wrinkles his brow.>$B$BI would prefer not to use the term \'sacked,\' but yes, the attack went off flawlessly. We removed Taurajo from the equation, confiscated its arms, and destroyed its smithing facilities. The assault gave our forces considerable breathing room and knocked the enemy off balance.$B$BNonetheless, during the assault, I instructed my men to leave a gap open in our lines...','',274,1,0,0,0,0,0,0,1,0,0,0,26124),
(39127,'Why did you do that?','Why did you do that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39128,'Taurajo had a significant civilian population. I wanted to ensure that they could escape the fighting, and many did, finding refuge in the north.$B$BThere are some, even in Alliance High Command, who argued that I let an opportunity slip away. That I should\'ve taken hostages. But I don\'t see the value in those sort of terror-tactics.$B$BHear me out, $n: I want this war to end someday. It won\'t ever stop if we butcher or imprison civilians.$B$BI just pray that there are those on the other side who see things as I do.','',274,5,1,0,0,0,0,0,1,0,0,0,26124),
(39129,'Going somewhere?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39130,'I\'ll take that flight to Brill now.','I\'ll take that flight to Brill now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39131,'I\'d like to purchase a bat ride.','I\'d like to purchase a bat ride.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39132,'$n! You\'re alive! Have you heard?','$n! You\'re alive! Have you heard?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39133,'They killed him! General Hawthorne - he was ambushed on the road by Horde assassins.','They killed him! General Hawthorne - he was ambushed on the road by Horde assassins.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39134,'His body was found strung up from a tree. Those animals... Those filthy animals!','His body was found strung up from a tree. Those animals... Those filthy animals!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39135,'The lesson we\'ve learned here in the Barrens is that nothing short of scorched earth will rout these Horde animals. No quarter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39136,'Were he still alive to avenge himself, General Hawthorne would have no doubt ordered a retaliatory massacre of biblical proportions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39137,'You are quite right, Trask.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39138,'','Father!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39139,'Lilian... you\'re... it\'s so nice to see you well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39140,'','Shut up.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39141,'','You raised me to be a killer.  How am I doing, daddy?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39142,'I, ah...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39143,'','But wait... I remember now.  You taught me to only kill the undead.  So do you want me to kill myself, daddy?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39144,'Lilian, I...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39145,'','Then again, why kill myself... when I can kill YOU instead!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39146,'','Thanks for everything... father.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39147,'Turn over the tablets and I will allow you a quick death.','Turn over the tablets and I will allow you a quick death.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39148,'Very well, dwarf. Have it your way. I shall kill you and take the tablets.','Very well, dwarf. Have it your way. I shall kill you and take the tablets.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39149,'','Can I help you with something?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39150,'','Are you ready to begin the procedure?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39151,'We do our best here to heal the broken earth. It was difficult enough before we started getting raided at night.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39152,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39153,'','Very well.  Follow me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39154,'','Now it is time for us to begin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39155,'','Devlin Agamand!  Listen to my voice!',22,22,0,0,0,0,0,0,1,0,0,0,26124),
(39156,'','Your mortal remains have been gathered, here in this place where you spent your childhood!',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(39157,'','Resist the Lich King\'s will, Devlin!  Come to us!',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(39158,'','I had better return to my post.  You can find me downstairs if you need anything.',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(39159,'','I\'m a little busy at the moment, $c... return when I\'m less preoccupied.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39160,'What\'s going on here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39161,'Wait, am I... home?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39162,'You people... what are you doing here?  Why are you in my house?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39163,'Mother... father... Thurman... where are you?  Come help me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39164,'No... I remember.  My family is dead.  And so am I.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39165,'And my soul... my soul belongs to the Scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39166,'DIE, YOU WRETCHES!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39167,'Into the Thunderdrome, $n! There\'s no getting out until someone\'s hit the sand. Let\'s start the show!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39168,'','Thank you, $n! Now I can begin my final assembly...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39169,'','Okay... structure? Check. Power? Check. Danger? Double-check. Let\'s fire up my masterpiece!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39170,'','Our equipment is really taking a beating out here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39171,'Hmmmm... aye. But it\'s a wee bit - uh - wee, innit?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39172,'Simmer say Gordo got guts, but got no brains.  Why he mean?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39173,'Gordo like picking flowers.  Pick flowers kind of like killing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39174,'It drafty out here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39175,'Johaan say Gordo need a tailor to fix Gordo tummy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39176,'Gordo, do you think you could repair my gear?','Gordo, do you think you could repair my gear?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39177,'','Nonsense! Miniaturization is the future of warfare.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39178,'Sniff for pheromones to find your way into the hive!','Sniff for pheromones to find your way into the hive!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39179,'','I should mention I reversed the gearbox to accommodate the smaller form-factor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39180,'On behalf of the illustrious and still neutral Steamwheedle Cartel, I hope you enjoy your stay.$B$BRemember, everyone is welcome in Gadgetzan! Everyone except pirates.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39181,'Welcome back, friend! It feels like it\'s been years since you helped me whip up my first Noggenfogger Elixer.$B$BNow I\'m running the whole city! Those things still sell like crazy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39182,'','The blood of the fallen cries out for justice.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39183,'Any Ladies and Gentlemen present should LEAVE NOW...for only REAL MEN AND WOMEN will be able to handle the gory spectacle about to unfold! Introducing the first fighter, the warrior of the Wastewander, the Ayatollah of Kaja-Cola...THE GINORMUS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39184,'Don\'t be a hero. Just walk away.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39185,'No... it can\'t be.  Our forward outpost has been obliterated!','',0,0,0,0,0,0,0,0,1,0,20950,0,26124),
(39186,'Is it too late?  I feel Deathwing\'s presence nearby!','',0,0,0,0,0,0,0,0,1,0,20951,0,26124),
(39187,'We can afford no delay. Fort Triumph must be completed and reinforced, or any hope we have for permanent settlement on this continent will be erased.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(39188,'When me and my Wildhammer Mercenaries were hired on to secure Fort Triumph, I imagined we\'d be fighting the Horde.$B$BBut we\'re set on from all sides! \'Sploding goblins, burrowing bugs, electro-fied lizards... ','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(39189,'The Firelord has risen!  We must send word to the others.  Let us hurry!','',0,0,0,0,0,0,0,0,1,0,20952,0,26124),
(39190,'','The Battlescar is a dangerous place. All the armor in the world can\'t save a steam tank that\'s swallowed up by the earth.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(39191,'','What I\'m cooking up is way ahead of its time, $n.$B$BLook at these blueprints! It\'s like licking the future.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(39192,'','Sure, it\'s got bugs to work out. But the microtank is a marvel of engineering.$B$Bit uses one quarter the materials of a full-sized siege engine, and it can be mass-produced by anyone! ...with really tiny hands!',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(39193,'','The Bilgewater Cartel will be in business here by the end of the day, mark my words.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39194,'','<Clarice stares over the body, her eyes vacant.>$B$BI rode here from Theramore as soon as the news reached me.$B$BJohn and I had always talked about settling down when the conflict subsided.$B$BI don\'t think the fighting will ever stop. Do you?',1,274,18,0,0,0,0,0,1,0,0,0,26124),
(39195,'Our next fighter was found in the deepest tombs of Zul\'Farrak! Gorged on cursed blood, raised from death countless times, he now knows only fury and violence! Dare you face the mindless wrath of...ZUMONGA!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39196,'The Ginormus has fallen! $n looks like $Ghe\'s:she\'s; ready for more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39197,'ZUMONGA...KILL...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39198,'I can breathe!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39199,'What day is it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39200,'Hey! Those bugs took my watch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39201,'Thanks a ton, pal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39202,'I\'m alive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39203,'Thrall Hall, $n! Here to help kill some misguided dwarves and gnomes?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(39204,'Bastia, let\'s ride!','Bastia, let\'s ride!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39205,'','This might be the only cool place left on the island... right next to the volcano!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(39206,'Hey there, $n. You heading in?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(39207,'$n! You wanna help me out here with Fizz? He\'s up to no good again!','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(39208,'Evol Fingers must pay! For the love of profit, $n, help me!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(39209,'Turn away, $c.$B$BBefore the cataclysm hit, we found something.$B$BWe dug something up that should\'ve stayed buried.$B$BPray to whatever you believe in that the landslide was enough to keep it down...','Turn away, $c.$B$BBefore the cataclysm hit, we found something.$B$BWe dug something up that should\'ve stayed buried.$B$BPray to whatever you believe in that the landslide was enough to keep it down...',1,274,0,0,0,0,0,0,1,0,0,0,26124),
(39210,'Grab the gear - we gotta clear out!','Grab the gear - we gotta clear out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39211,'They\'re everywhere!','They\'re everywhere!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39212,'Save what you can - every Dwarf for himself!','Save what you can - every Dwarf for herself!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39213,'Don\'t let them make off with any of the artifacts!','Don\'t let them make off with any of the artifacts!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39214,'I can\'t believe that Fizz and Evol are at each other\'s throats again. It\'s the pressure. We need you now more than ever, $n.','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(39215,'Panic!','Panic!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39216,'','Are you going in there? I\'m not going back in there!',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(39217,'Please insert coins.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39218,'That\'s me job, $c. The General goes out on patrol, and I carry his banner and plant it in the dirt.$B$BImagine a General out and about without his banner. He might as well not wear pants.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(39219,'We\'ll let you into the city, this time.','We\'ll let you into the city, this time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39220,'Hey! Hands off the banner, $gson:missy;.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(39221,'I\'ve filled out my paperwork to enter the city.','I\'ve filled out my paperwork to enter the city.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39222,'You\'re papers look to be in order.  Proceed.','You\'re papers look to be in order.  Proceed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39223,'Haven\'t I seen you before?  We\'ll be keeping an eye on you, citizen.','Haven\'t I seen you before?  We\'ll be keeping an eye on you, citizen.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39224,'You are only allowed into the city for an hour.  Be quick with your business.','You are only allowed into the city for an hour.  Be quick with your business.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39225,'You have permission to enter the city.','You have permission to enter the city.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39226,'','This was going to be a walk in the park until that airhead over there came out of nowhere with an army of gnomes.$B$BGallywix will have my head if we let these creepy runts one-up us here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39227,'You\'ll find Marley Twinbraid up top, $gsir:ma\'am;.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39228,'Mine it\'s mine I found it. Mine I say! Mine! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39229,'Do not loiter; we\'ve work to do here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39230,'He\'s in here. Let\'s get \'im!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39231,'What ... what is happening to me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39232,'$n has done it again! Zumonga dies once more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39233,'The faint of heart may wish to shield their eyes! Being brought into the ring now is a horror, captured from the dark tunnels of the Centipaar Hive! I give you the skittering death: SARINEXX!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39234,'This is the truth of it! Fighting leads to killing, and killing leads to warring. And that was nearly the end of all our customers!$B$BNow, when men get to fighting, it happens here. And it finishes here! For maximum viewing potential!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39235,'There is no stopping $n! Sarinexx has been massacred!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39236,'We\'ve spared no expense for the crowd, folks! We\'re determined to kill $n at any cost, for you, the viewer! Taken all the way from the hidden jungle of Un\'goro Crater, cower in fear at...KING KRAW!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39237,'UNBELIEVABLE! $n is victorious! King Kraw is no more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39238,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39239,'I\'ve heard about this Nesingwary guy, out of Stranglethorn Vale, hunting all sorts of beasts for sport.$B$BFor SPORT. What a complete idiot, right? Think of all the profit he\'s letting rot in the field!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39240,'','Okay. We\'re going to move away from the exploding volcano and try to hook up with the orcs for the final assault on the Trade Prince. See you on the other side... I hope.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39241,'Return to Echo Isles.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39242,'I used to be overcome with frequent, debilitating fits of rage. But since I met Driz, I\'ve been able to live a happy, productive life.$B$BAnd I get to tear things apart with my bare hands.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39243,'Just let me know when ya ready, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39244,'Our ship from Northrend was attacked by Twilight\'s Hammer! I don\'t know how they got aboard, but they killed everyone.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(39245,'Using a crystal Brann sent with the tablets, I managed to protect myself and escape, but one of the attackers followed me!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(39246,'I\'ll use the crystal to shield the tablets. See if it will grant you powers to defend me. If Twilight\'s Hammer\'s minions break through my shield, they\'ll kill me and take the tablets!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(39247,'Hold on tight back there! Seat belts are for chumps.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39248,'We\'re all very proud of Bael Modan. It was the first dwarven settlement in Kalimdor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39249,'Up ahead is Bael\'dun Keep. Isn\'t she a beauty? That stronghold is indestructible!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39250,'...What the? The keep is under attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39251,'I... I can\'t hold it! Mayday! MAYDAY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39252,'Bah! Rowdy tauren don\'t scare me none.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(39253,'It\'s a one-seater plane, but you can always sit up on the fuselage. It\'s perfectly safe.$B$BYou ready?','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(39254,'I\'m ready, Marley. Let\'s fly!','I\'m ready, Marley. Let\'s fly!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39255,'Kelsey sent me to get a boat.','Kelsey sent me to get a boat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39256,'Who\'s the little guy?','Who\'s the little guy?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39257,'He\'s my assistant.$B$BSure, he\'s not been plagued in the same manner as we have, but he is clearly plagued nonetheless.  He\'s bent the knee to Sylvanas, so he\'s as much one of us as you or I.$b$bAnd just between you and me... to be perfectly honest, I think the Dark Lady thought he was already bending his knee when he entered her chamber!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39258,'','We have to rescue everyone and get out of here before the volcano explodes for real!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(39259,'','I\'VE GOT AN IDEA!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39260,'That cursed crystal! We will not give up so easily. We will have that tablet for our ascendants. Perhaps not today, but soon!','That cursed crystal! We will not give up so easily. We will have that tablet for our ascendants. Perhaps not today, but soon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39261,'You must help me safeguard the Tablets of Earth. Twilight\'s Hammer will not stop until they\'ve taken the tablets.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(39262,'I\'ll help you defend the tablets.','I\'ll help you defend the tablets.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39263,'Hmm... very impressive.  Alright, you\'ve passed my test.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39264,'','Impressive!  You learn quickly, my pupil.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39265,'You\'ve done it! You\'ve saved the tablets. Hurry and bring them to Ironforge. I\'ll be along once I\'ve had some time to recover.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39266,'Duokna... this is embarrassing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39267,'Duokna, what are you doing?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39268,'Get down from there this instant!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39269,'How are you not burning your feet?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39270,'At last, the tablets are ours!','At last, the tablets are ours!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39271,'Brace yourself, $r.$b$bThe naga could attack again any moment.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(39272,'This region is one of the epicenters of the cataclysm that threatens to rend our world.$b$bIf we manage to survive, we must try to discover its cause.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(39273,'The attacks on these ships, they are clearly not random.$b$bWe must discover the motives of the naga here.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(39274,'This whole keep is going to collapse!','This whole keep is going to collapse!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39275,'Thank you, thank you!','Thank you, thank you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39276,'How could this have happened?','How could this have happened?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39277,'There are still others - search the barracks!','There are still others - search the barracks!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39278,'How could they have done this?','How could they have done this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39279,'The roof over the mess hall collapsed. So many - dead!','The roof over the mess hall collapsed. So many - dead!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39280,'This place is up crap creek an\' I ain\'t got no shovel.','I thought I was cooked like a turkey dinner!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39281,'I thought I was done for! Thank you!','I thought I was done for! Thank you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39282,'Elementals, I bid you come forth and slay this enemy of Twilight\'s Hammer!','Elementals, I bid you come forth and slay this enemy of Twilight\'s Hammer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39283,'Ouch! I can\'t take much more o\' this!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(39284,'By the Light, that hurts!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(39285,'It\'s trying to bash me skull in!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(39286,'Pouring','Pouring',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39287,'I\'ve been here in this valley since before the dark portal opened, $glad:lass;. I don\'t plan on letting a handful of blood elves traipse in here and plunder these ruins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39288,'Need something?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39289,'Can I catch a ride to Razor Hill?','Can I catch a ride to Razor Hill?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39290,'The zeppelin from Northrend was attacked by Twilight\'s Hammer! I don\'t know how they found us, but they killed everyone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39291,'We discovered this crystal and tablets in a Titan archive. I used the crystal to buy some time, but they\'re still following me!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(39292,'Use the crystal\'s power to defend me and the tablets. If Twilight\'s Hammer\'s minions break through my shield, they\'ll kill me and take the tablets!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(39293,'At last, you\'ve driven them off. Take the tablets to Earthmender Norsala in the Valley of Strength at once! Tell her that I\'ll be along once I\'ve had some time to recover.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39294,'Hurry, I need help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39295,'Don\'t let them overpower us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39296,'These Twilight\'s Hammer fools would tear the very earth apart to get these tablets.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39297,'','NOOOOOOO!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39298,'%s is casting Envenom!  Place your totem down now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39299,'Thank you, $r... I was close to death.  May I stay by your side for a moment?','Thank you, $r... I was close to death.  May I stay by your side for a moment?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(39300,'I was supposed to die in battle... ah well, another day.  I will follow you until I recover.','I was supposed to die in battle... ah well, another day.  I will follow you until I recover.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(39301,'You\'ve saved my life, $c.  Protect me for a few more moments while I recover.','You\'ve saved my life, $c.  Protect me for a few more moments while I recover.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(39302,'For the Warchief!  You lead, I will follow.','For the Warchief!  You lead, I will follow.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(39303,'I feel much better now.  For the Horde!','I feel much better now.  For the Horde!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(39304,'Thank you again.  I will return to Razor Hill now.','Thank you again.  I will return to Razor Hill now.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(39305,'It was an honor to watch you fight, $n.','It was an honor to watch you fight, $n.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(39306,'You fight well.  I will leave you now.  Lok\'tar ogar!','You fight well.  I will leave you now.  Lok\'tar ogar!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(39307,'You have to help me, $c! Twilight\'s Hammer attacked my zeppelin and their men tried to take the tablets and the crystal I was transporting to Orgrimmar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39308,'I\'ll help you defend the tablets.','I\'ll help you defend the tablets.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39312,'','We\'re not a part of your system!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39313,'What... what are those things on the rooftops?','What... what are those things on the rooftops?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39314,'Back to work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39315,'You no slave! Work or die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39316,'Me get big bonus for capture you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39317,'At last it is time for the exiled gnomes to return.$B$BOnce again Gnomeregan will be our home!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39318,'Trade Prince say hurt you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39319,'You no mine ore, you get beating!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39320,'Me like beat you up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39321,'Me overseer, you slave!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39322,'Break time over!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39323,'What is your plan?','What is your plan?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39324,'The dwarves have kept us safe in their home for some time now, and for that we thank them.  However, the traitorous Thermaplugg\'s occupation of our home must at last come to an end.$B$BGnomeregan has festered beneath the atomic weight of our ill-conceived plan for too long. The detonation of the radiation bombs drove us from our city, but we now possess the technology to take it back!$B$BWe will regain what is ours... and bring Thermaplugg to justice!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39326,'Operation: Gnomeregan is divided into a number of phases:$B$BFirst, we must retake the air tower.  This will allow our planes give us air support as we move towards Gnomeregan\'s main entrance.$B$BIn addition, a cache of mechanized Battle Suits was discovered in one of the nearby buildings.  Once we have those suits, our assault on the entrance should be unstoppable.$B$BThen, we go straight for Thermaplugg in the heart of Gnomeregan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39327,'Somebody... anybody...','Somebody... anybody...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(39328,'I\'ll never see my wife again...','I\'ll never see my husband again...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(39329,'H-help me!','H-help me!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(39330,'I can\'t fight any longer...','I can\'t fight any longer...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(39332,'What is going on here?','What is going on here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39333,'','%s appears to be weakening!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39334,'[PH] We shall not fail or falter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39335,'[PH] We shall not weaken or tire.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39336,'[PH] Neither the sudden shock of battle, nor the long-drawn trials of vigilance and exertion will wear us down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39337,'[PH] Give us the tools...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39338,'[PH]..and we will finish the job!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39339,'[PH] For Gnomeregan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39340,'What? You\'re not supposed to be here. You\'re dead!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39341,'','Kill that goblin, quickly!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39342,'The mine cart is prepped and ready to go.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39343,'Welcome to the field, $c! You can\'t get a feel for the tactical situation if you\'re hiding in a fortress all day. I always like to get my boots dirty.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39344,'Be sure to check in with my son Marley at the digsite. He\'s a good kid - my eyes and ears over at Bael Modan.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39345,'Have you been to Bael Modan? What\'s going on over there?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(39346,'They\'re going to pay, $n. They\'re all going to pay.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39347,'These crazy tauren - always trying to blow up my flying machine. This has been going on for years!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39348,'Relax, friend. You have not passed away... yet. Sadly, these others cannot say the same.','',396,0,0,0,0,0,0,0,1,8873,0,0,26124),
(39349,'You trespass on sacred soil!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39350,'%s explodes in a frothing, feral rage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39351,'The Barrens ... will ... devour you, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39352,'Everybody panic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39353,'They\'re through the gates! I\'m outta here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39354,'I\'m taking the next ship back home.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39355,'Run for your lives! Every gnome for himself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39356,'Do you think I can make it to Theramore on foot?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39357,'Where did I leave my voltometer? Bah, no matter. The Horde can keep it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39358,'','So much data... so little time...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39359,'','The gyros are all spun up. Are you ready to fly my survey?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39360,'I\'m ready to fly.','I\'m ready to fly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39361,'','Interesting. Even this far from the epicenter, Azeroth\'s crust is completely torn asunder.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39362,'','What\'s all this? This jungle wasn\'t here during last week\'s survey. What is happening to the Barrens?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39363,'','That\'s seawater. It\'s breached the ocean. Do you think the fissure is growing?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39364,'','Hold everything - the walls of Northwatch have been breached! We\'re under attack!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39365,'','Coach is here?! He\'ll have a plan.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(39366,'What is this?  Another unworthy pupil?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39368,'Yours will be a lesson in pain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39369,'Only the worthy will learn the secrets we keep!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39370,'Ride the mine cart.','Ride the mine cart.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39371,'You will wish you never came here, worm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39372,'Your only lesson will be death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39373,'Your flesh will burn, mortal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39374,'You think you are good enough to learn from us?  You will pay for your insolence!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39375,'Very well, shaman. I shall slay you and carry the tablets to Cho\'Gall.','Very well, shaman. I shall slay you and carry the tablets to Cho\'Gall.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39376,'I\'ve got a game plan, kid!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39377,'Don\'t know how long we\'re gonna be able to hold them off, $g bud : lady;. Hope you have a plan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39378,'<Grunt>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39379,'People of Orgrimmar, listen. We have been blind for too long! I ask you to open your eyes to the truth!','People of Orgrimmar, listen. We have been blind for too long! I ask you to open your eyes to the truth!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39380,'The end of our world nears, my brothers and sisters! Azeroth will be no more!','The end of our world nears, my brothers and sisters! Azeroth will be no more!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(39381,'Flames will consume the world. Storms will wash away all hope. The elements will reign at last!','Flames will consume the world. Storms will wash away all hope. The elements will reign at last!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39382,'But do not despair, people of Orgrimmar! Join us and learn the truth.','But do not despair, people of Orgrimmar! Join us and learn the truth.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39383,'The first thing you need to learn is proper discipline.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39384,' However, the most important part of battle is how you celebrate a good hard earned victory!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(39385,'When you go into combat, it is important that you know how to intimidate the enemy with a deafening battle roar!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(39386,'Remember though, a key factor in winning any battle is positive reinforcement.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39387,'Everyone, cheer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39388,'Salvaging','Salvaging',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39389,'','Where the heck did all of these shredders come from?!',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(39390,'I can\'t believe you\'d do this to me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39391,'Cast off your lives of war and drudgery, be reborn in elements and claim your rightful place in this new world!','Cast off your lives of war and drudgery, be reborn in elements and claim your rightful place in this new world!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(39392,'All right, you twisted mess of broken gears, let\'s get to work!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39393,'Why should we believe you?','Why should we believe you?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39394,'Okay, recruits, salute!','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(39395,'Let me hear that battle roar!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(39396,'First you tell us the world is ending, now you tell us not to worry. What ruse is this?','First you tell us the world is ending, now you tell us not to worry. What ruse is this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39397,'There has been too much violence. Too much pain. But I have an honorable compromise. Just walk away.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39398,'I am gravely disappointed. Again you have made me unleash my dogs of war. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39399,'What a puny plan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39400,'The continued sacrifice of the Ashen Verdict and heroes such as yourself bring us all closer to final victory. Now I have come to Icecrown Citadel to lend aid to those who fight against the Scourge. Together we will end the tyranny of the Lich King!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(39401,'With all due respect, your Highness, we can do this alone.','With all due respect, your Highness, we can do this alone.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39402,'You can do this alone, you say? Is this simple foolishness or misplaced confidence I see before me?\n\nNo, I can see it in your eyes. You have to know. You have to prove to yourself that you can do this alone. Very well. I will retreat from the battlefield if you so wish it.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(39403,'Now, dance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39404,'I am going to teach you all what it takes to be a proper soldier! ','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(39405,'We do wish for you to stand down, your Highness.','We do wish for you to stand down, your Highness.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39406,'You will need more than bravery to defeat the Lich King. Good luck.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(39407,'Your choice has been made. Whether you live or die by that choice is now up to you.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(39408,'Hope you enjoyed the ride, i\'m out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39409,'I want to be reborn. Tell me what I must do!','I want to be reborn. Tell me what I must do!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39410,'Yes, tell us!','Yes, tell us!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(39411,'When I give the signal, let loose your greatest roar!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39412,'I don\'t want to die!','I don\'t want to die!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(39413,'Show me that discipline with a proper salute when I say so!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(39414,'Calm down, friends. There will be plenty of time to answer all your questions.','Calm down, friends. There will be plenty of time to answer all your questions.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39415,'The word is given. The Lich King will die by our hands!','The word is given. The Lich King will die by our hands!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39416,'Northrend requires your attention Overlord Hellscream. We will deal with the Lich King and his minions without your aid.','Northrend requires your attention Overlord Hellscream. We will deal with the Lich King and his minions without your aid.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39417,'With the Warsong Offensive here in Icecrown Citadel, victory is within our grasp! The death of the Lich King will bring glory to the Horde!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(39418,'You turn away the might of the Warsong Offensive? Has the chaos of battle turned you mad? With my help, victory is at hand! Without my help, your fight will be difficult.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(39419,'Glory to the Horde!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(39420,'If you are interested in our message, I will be holding a gathering. Speak with me if you wish to know more, but beware, for Orgrimmar is full of people who would silence the truth.','If you are interested in our message, I will be holding a gathering. Speak with me if you wish to know more, but beware, for Orgrimmar is full of people who would silence the truth.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39421,'I will prove myself!','I will prove myself!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39422,'I\'ve trained for this moment for years!','I\'ve trained for this moment for years!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39423,'Your choice was bold! I respect your desire for glory and honor! Die well, $n!','',113,0,0,0,0,0,0,0,1,0,0,0,26124),
(39424,'I will not fail!','I will not fail!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39425,'I will triumph in THEIR name!','I will triumph in THEIR name!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39426,'Enough lessons!  It\'s time for action!','Enough lessons!  It\'s time for action!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39427,'I will not die here today, creature!','I will not die here today, creature!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39428,'Reward your fellow soldiers in battle with a resounding cheer.  Now, cheer at me when I tell you to!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39429,'Show me your best victory dance when I give the signal!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(39430,'Nice job!','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(39431,'Wow, nice and scary! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39432,'Fantastic!','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(39433,'Superb!','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(39434,'You might be the best set of recruits I\'ve ever seen!  Let\'s go through all of that again!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(39435,'Aaaaaaaaargggh!!','Aaaaaaaaargggh!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39436,'I\'ve become one with fire!  I\'ve... auuuggggh!!!  It burnssss!!!','I\'ve become one with fire!  I\'ve... auuuggggh!!!  It burnssss!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39437,'The flesh is weak!  Only fire purifies!','The flesh is weak!  Only fire purifies!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39438,'One day, The Wolf was very hungry, so he ran east to look for some food.','One day, The Wolf was very hungry, so he ran east to look for some food.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(39439,'He happened upon a pair of battling kodos.$bClever as he was, The Wolf decided to wait for one to defeat the other.','He happened upon a pair of battling kodos.$bClever as he was, The Wolf decided to wait for one to defeat the other.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(39440,'When the weaker Kodo died, The Wolf approached and tried to eat it.','When the weaker Kodo died, The Wolf approached and tried to eat it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(39441,'The remaining Kodo, angry at The Wolf\'s impetuousness,$bswiftly killed The Wolf before he had a chance to eat.','The remaining Kodo, angry at The Wolf\'s impetuousness,$bswiftly killed The Wolf before he had a chance to eat.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(39442,'Things used to be so much better... what happened to us?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39443,'Can you tell me your fable, Shin?','Can you tell me your fable, Shin?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39444,'The Wolf ran and ran, looking for an easy meal.','The Wolf ran and ran, looking for an easy meal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(39445,'He was hungry for kodo meat.','He was hungry for kodo meat.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(39446,'The Wolf was lazy, and didn\'t want to work for his meal.','The Wolf was lazy, and didn\'t want to work for his meal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(39447,'The more he ran, the more his stomach growled.','The more he ran, the more his stomach growled.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(39448,'The Wolf did not care for raptor meat.','The Wolf did not care for raptor meat.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(39449,'The Wolf found scorpid meat to be too bitter.','The Wolf found scorpid meat to be too bitter.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(39450,'The Wolf had grown tired of eating boar meat.','The Wolf had grown tired of eating boar meat.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(39451,'He scoured the sands of Durotar, hunting for his prey.','He scoured the sands of Durotar, hunting for his prey.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(39452,'','I\'m tired of wading in water.  Let\'s make this a little bit easier on ourselves, shall we?  Spirit of water, come to our aid!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39453,'','There, isn\'t that much better?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39454,'','Raggaran, I\'m safe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39455,'Grandmatron... you\'re alive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39456,'','Let us be off then.  Take me to my grandson Raggaran.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39457,'','No!  M-my ankle!  I\'m not sure I can make it... after we\'ve come so far...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39458,'','Spirits of air!  Come to my aid!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39459,'','We can continue now, I think.  Let us press on.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39460,'So many bells and whistles!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39461,'Push the Big Red Button!','Push the Big Red Button!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39462,'Board the Flying Machine.','Board the Flying Machine.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39463,'Looks just powerful enough to carry one gnome.  Maybe two.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39464,'','All the rest of our people are down there!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(39465,'','But, sweetie...?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39466,'I am at a loss. Perhaps only the Earth Mother herself knows the cause of this. But we must do something before this continues...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39467,'','Your sincerity is moving, druid.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39468,'Konu! Behind us! A night elf.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39469,'You are no night elf...this is the guise of a green dragon! By the Earth Mother, I...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39470,'','I deserve no such respect or reverance, druid. I have betrayed my own kind. The illness of this land is my fault.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39471,'','The sickness is born of the Nightmare within the Emerald Dream, and the dragon Taerar spreads it. He is but a crazed shade of his former self, but will see this land devoured.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39472,'','I cannot face him myself. To even approach him would risk letting the same corruption overtake me once more.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39473,'What must we do?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39474,'','The earth itself weeps in its suffering. Gather its tears, and use them to seal the portal at the Great Tree. The connection to the Dream must be cut.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39475,'','Be brave, heroes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39476,'Tiragarde belongs to Northwatch now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39477,'$n, you have to hunt down the Trade Prince!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39478,'If Fizz hadn\'t been so clumsy, we never would have been caught!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39479,'If Evol hadn\'t been so clumsy, we never would have been caught!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39480,'','The Twilight\'s Hammer is a major power to be reckoned with.  Thanks to us, Deathwing is free.  Thanks to us, Old Gods have risen from the bowels of the earth.  Thanks to us... Hyjal burns.$B$BWhat do you think you have to offer us?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39481,'The path before us has been revealed. Let us return.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39482,'You\'re the one, $n. You must defeat the Trade Prince or all is lost.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39483,'','This whole situation is highly unprofitable. You must bring the Trade Prince back into line, $n!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39484,'','Don\'t worry about us, $n. You just get over there and make sure that the Trade Prince gets dealt with.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39485,'Hey.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39486,'Please insert coins and then proceed to deal with the Trade Prince.','',34,0,0,0,0,0,0,0,1,0,0,0,26124),
(39487,'Any luck out there?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39488,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39489,'No earthquake, flood, or any other act of the spirits will stop me from doing my duty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39490,'Everything has been leading to this, $n. You must not fail, or all is lost and we will die with this island.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39491,'Honestly, how do these people keep getting captured? It\'s massive incompetence, I tell you!$B$BIt almost makes me ashamed to be a goblin.$B$BSpeaking of shame, where\'s that lazy assistant of mine? No doubt she\'s just sitting around somewhere doing nothing.$B$BOh the burdens that come with genius. I suppose I\'ll just have to think us all out of this mess by myself.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(39492,'We are here to pay respect to the great forest, and take part in the wonder of the Earth Mother\'s gifts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39493,'','Are you here to help, $c? This valley serves as a natural chokepoint. If we can strangle this supply line, we buy our companions at the World Tree time to mount a counter-attack.',25,1,0,0,0,0,0,0,1,0,0,0,26124),
(39494,'','I don\'t understand where these supplies are coming from. Somehow Twilight\'s Hammer has found a way to assault the entire mountain at once...',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(39495,'Let\'s go to the top of the Colossal.','Let\'s go to the top of the Colossal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39496,'Um... you do realize there\'s a bottom to this cage?!','Um... you do realize there\'s a bottom to this cage?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39497,'Mommy!','Mommy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39498,'3... 2... 1...','3... 2... 1...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39499,'Tell my wife I love her very much!','Tell my husband I love him very much!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39500,'Just open the door... oh no!','Just open the door... oh no!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39501,'What are those rockets for?!','What are those rockets for?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39502,'$n, you and Hobart are going to be the death of me!','$n, you and Hobart are going to be the death of me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39503,'The pirates have keys!','The pirates have keys!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39504,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39505,'Hobart, I need more single-stage booster rockets!','Hobart, I need more single-stage booster rockets!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39506,'What? You think these grow on trees? Please show me one of these trees!$B$BI can\'t work like this!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(39509,'You have failed the test.  Try again.','You have failed the test.  Try again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(39510,'<This robotic gorilla appears to be damaged.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39511,'CRASH REPORT XX1-017$B$BCHECKSUM ERROR 0081$B$BFLUID LEVELS DANGEROUSLY LOW$b$BMISSION FAILURE$b$bNEVER GOT A CHANCE TO SEE OUTLANDS','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39518,'','What do you want, $r?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39519,'I\'m here to challenge you in combat.','I\'m here to challenge you in combat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39520,'Do I frighten you, $r?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39521,'What\'s the matter, chum... never seen a worgen before?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39522,'Anything for King Mekkatorque!','Anything for King Mekkatorque!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39523,'Is this going to hurt?','Is this going to hurt?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39524,'I\'d love to help!','I\'d love to help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39525,'Can I bring my wrench?','Can I bring my wrench?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39526,'Sign me up!','Sign me up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39527,'','$n hurry! Thrall needs your help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39528,'Wow! We\'re taking back Gnomeregan?  I\'m in!','Wow! We\'re taking back Gnomeregan?  I\'m in!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(39529,'I want to drive a Spider Tank!','I want to drive a Spider Tank!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(39530,'I SEE THE TRAITOR IS HERE TO RESCUE YOU, WARCHIEF. HOW CONVENIENT. YOU WILL BOTH BOW TO ME OR FALL TOGETHER!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39531,'Blast these rocky Durotar roads!  I\'ve got places to be, and this isn\'t one of them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39532,'Up the ramp, $n! Help Thrall defeat the Trade Prince!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39533,'Thrall\'s fighting the Trade Prince up top on the other side of the docks. Hurry, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39534,'Assist me, $n. The Trade Prince has become far more powerful!$B$BI do not know how much longer I can hold out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39536,'I\'m beaten. You\'ve shown me the error of my ways. From here on out, I promise to reform the way the cartel is run!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39537,'My wrench of vengance awaits!','My wrench of vengance awaits!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39538,'Do you have any idea where you are going?','Do you have any idea where you are going?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(39539,'I love the smell of grease in the morning!','I love the smell of grease in the morning!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(39540,'Do you think they will let me keep my uniform when I\'m done?','Do you think they will let me keep my uniform when I\'m done?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(39541,'How soon until the victory party starts? I\'m ready to dance!','How soon until the victory party starts? I\'m ready to dance!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(39542,'Uncle! Uncle! I give! You guys are too much for me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39543,'I\'m your goblin, Thrall. What would you have of me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39544,'','The Gordunni Ogres have blighted this land long enough. We are here to take this land and its resources for the Horde.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39545,'These ogres are on our side?','These ogres are on our side?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39546,'','The Stonemaul clan serves the Horde!$B$BDuring the founding of Orgrimmar, when Kalimdor was being tamed as our people\'s homeland, the hero Rexxar defeated the chief of the Stonemaul ogre clan.$B$BThey have served the Horde ever since, and I\'ve called them in here to do the heavy lifting against the Gordunni clan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39547,'Yes.','Yes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39548,'No.','No.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39549,'That depends on what your definition of \"is\"... is.','That depends on what your definition of \"is\"... is.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39550,'Only a non-believer would ask such a question!  Are you a non-believer?','Only a non-believer would ask such a question!  Are you a non-believer?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39551,'Here, I need to unload some toxic assets!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39552,'Well... what do you think the answer is?','Well... what do you think the answer is?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39553,'Yes and no.  It really depends on how you look at it... I suppose.  Did that answer your question?','Yes and no.  It really depends on how you look at it... I suppose.  Did that answer your question?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39554,'Well that\'s all semantics, really.','Well that\'s all semantics, really.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39555,'Only if Lord Deathwing commands it!','Only if Lord Deathwing commands it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39556,'I\'m downsizing the cartel, starting with you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39557,'The Bilgewater Cartel has grown too large. Time to downsize!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39558,'Gotta trim some fat around here. I\'m downsizing the company!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39559,'Excuse me while I dispose of these toxic assets all over you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39560,'I need to move these toxic assets onto a sucker... like you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39561,'You\'re fired!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39563,'I\'m all fired up over finally gettin\' rid of you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39564,'You burned down my headquarters. Now I\'m gonna burn down you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39565,'Do dogs bark?','Do dogs bark?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39566,'Is vinegar sour?','Is vinegar sour?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39567,'Is fire hot?','Is fire hot?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39568,'Are the oceans filled with water?','Are the oceans filled with water?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39569,'Are slaves free?','Are slaves free?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39570,'Are deserts lush?','Are deserts lush?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39571,'Do liars speak the truth?','Do liars speak the truth?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39572,'Here\'s some of that moolah back that I took from you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39573,'I like you. Here\'s a raise!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39574,'I\'m so money!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39575,'Do rivers flow upstream?','Do rivers flow upstream?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39576,'Are you a $c?','Are you a $c?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39577,'Does Cho\'Gall lead the Twilight\'s Hammer?','Does Cho\'Gall lead the Twilight\'s Hammer?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39578,'Does our cult serve the Old Gods?','Does our cult serve the Old Gods?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39579,'Return to the Slave Pits or the Gallywix Docks, or forfeit your footbomb uniform!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39580,'<Fizzle\'s body bobs lifelessly.  His orb is clutched tightly in his right hand.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39581,'<Attempt to remove the orb.>','<Attempt to remove the orb.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39582,'<You grab at the orb, but Fizzle\'s hand clutches around it even tighter.  The orb glows slightly.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39583,'<Attempt to remove Fizzle\'s Hand, then.>','<Attempt to remove Fizzle\'s Hand, then.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39584,'<Give up.  This is too scary.>','<Give up.  This is too scary.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39585,'Thrall grunts and thinks a moment on what to do with the Trade Prince.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39586,'For now, you will remain the Trade Prince of the Bilgewater Cartel.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39587,'I will send a representative from amongst your people to the new warchief, Garrosh Hellscream in Orgrimmar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39588,'You will have a new home in Azshara and the Bilgewater Cartel will become a part of the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39589,'It will be as you say! Long live the Bilgewater Cartel! For the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39590,'Try to ignore the firm, feathery behinds of the harpies... the creatures are really quite deadly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39591,'Lok\'tar ogar, soldier.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39592,'FOR DA HORDE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39593,'For now we cannot return to Kalimdor. Only Chawg is going back with you.  Another ship is coming to take the rest of us on to our destination.$B$BThe greatest adventure is yet ahead of you, $n. Our paths will cross again, and when they do, the fate of the world will be in your hands!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39594,'','Looks like this is it, boss-$g man : lady;. It\'s been a real honor. I\'m sure we\'ll see each other again real soon.$B$BJust let me know when you\'re ready to head out for Orgrimmar.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39595,'Sassy, let\'s set sail for Orgrimmar before the island blows for good!','Sassy, let\'s set sail for Orgrimmar before the island blows for good!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39596,'Prove yourselves, my ogres! Slay this insect! (Blood for the master! Blood and suffering!)','',0,0,0,0,0,0,22,0,1,0,22119,0,26124),
(39597,'Lok\'tar, $c.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39598,'Um... I\'m gonna need your battleworg again.','Um... I\'m gonna need your battleworg again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39599,'We\'re Orgrimmar bound, $g bud : girlie;, and then on to our new home in Azshara. See you there!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39600,'','It\'s been a long journey to get here, hon. Thank you!$B$BLet\'s get off of this island now.',17,0,0,0,0,0,0,0,1,0,0,0,26124),
(39601,'Thank... you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39602,'','You\'re a true $g hero : heroine;, $n! The poster-$g boy : girl; for the Bilgewater Cartel.$B$BOur stock is going to skyrocket now and I\'m going to get a raise!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39603,'','This does not look good for the future of the cartel. Not one bit.$B$BYou have to pull our fat out of the fire, $n, or we might as well all just walk into that volcano up there.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39604,'','Oh goodness, you did it, $n, you really did it!$B$BNow, by my calculations, if we do not get this bucket sailing very very soon, there is the increasing likelihood of one of those giant volcano rocks shooting through the air and smashing the yacht to smithereens.$B$BShall we?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39605,'There\'s always just enough time for a last minute sale to the $g hero : heroine; of the Bilgewater Cartel, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39606,'This right here is what you\'d call bad for business!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39607,'','What a mess! How am I going to spin this?$B$BAnd really... goblin zombies?!!',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(39608,'You got the stuff, kid! You got the ball into the endzone and you detonated it for the win!$B$BNow let\'s get out of here. I\'m thinking that the new team might need to be called the $n Explosion!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(39609,'You did it, my $g boy : girl;, you did it!$B$BNow, let\'s get to Azshara so that I can set up my new practice. This has been a long vacation and I have bills to pay!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39610,'I don\'t suppose that there\'s any way that you can get us out of here? No?$B$BAh well, I suppose it won\'t be too painful as the lava slowly pours into this pit.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(39611,'We\'re all going to DIE in here!!!$B$BI\'m a slave foreman... I wonder if it\'s too late to side with the Trade Prince?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(39612,'I knew you had it in you all along, $n.$B$BNow, do you think there\'ll be a position for me in Azshara? Do they have trolls there?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39613,'I just wanted to say thanks, $n.$B$BI\'m sure glad that the doc here was able to shock you back to life or we\'d all be dead by now, or worse!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39614,'I am NOT going to sweep the ground of a mud pit, I can tell you that!$B$BYou need to deal with that rat, the Trade Prince, that\'s what I think!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(39615,'Three cheers for $n!!!$B$BI really cannot wait to setup my own little bed and breakfast in Azshara. What do you think it\'s like there?','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(39616,'You did a superb job, $n. Top notch!$B$BNow, of course, you couldn\'t have done it without my tinkering genius, which I\'m sure you\'ll put in your company report, but you really pulled it off, despite the bumbling of my assistant here.','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(39617,'We\'re Orgrimmar and Azshara bound. Let\'s get this baby out to sea!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(39618,'Please insert coins into ship in order to move away from exploding island.','',33,0,0,0,0,0,0,0,1,0,0,0,26124),
(39619,'Let\'s jump Fizz right before we set sail. I\'ll hit him high and you go low!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39620,'Let\'s deal with that punk, Evol, once and for all. Azshara\'s not big enough for the two of us!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39621,'I knew you had it in you, $n! You saved our skins.$B$BNow let\'s get out of here before I have to kill Fizz and Evol.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39622,'','Do you have any idea how much time and moolah you\'ve saved us, $n? This could have been a complete disaster and you\'ve single-handedly saved the entire cartel.$B$BToo bad that you and Thrall spared Gallywix. I think that you would make an excellent Trade $g Prince : Princess;!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39623,'','No one could have done what you did, $n. Why you spared Gallywix is beyond me. You should have had his job.$B$BHere\'s to hoping that setting up our new home in Azshara is uneventful. I\'m looking forward to retiring.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39624,'I\'m not talking to you right now. If I were you, I wouldn\'t count on getting a raise this year, $n.','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(39625,'You did it! We\'re saved!','You did it! We\'re saved!',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(39626,'Are we really finally going to Azshara? Is there a volcano there, too?','Are we really finally going to Azshara? Is there a volcano there, too?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(39627,'How can I ever thank you, $n?','How can I ever thank you, $n?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(39628,'I\'d keep my eyes and ears open if I were you. There\'s a rumor going around that you caused both Mount Kajaro and the Lost Isles volcanoes to explode.$B$BCrazy, I know. But people will gossip about anything and love to tear down their heroes, especially if there\'s a chance for profit and promotion.','I\'d keep my eyes and ears open if I were you. There\'s a rumor going around that you caused both Mount Kajaro and the Lost Isles volcanoes to explode.$B$BCrazy, I know. But people will gossip about anything and love to tear down their heroes, especially if there\'s a chance for profit and promotion.',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(39629,'Let\'s leave dock before the volcano destroys us all!','Let\'s leave dock before the volcano destroys us all!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(39630,'Ready to go when you are, $g sir : ma\'am;!','Ready to go when you are, $g sir : ma\'am;!',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(39631,'I don\'t know. I think I\'m going to miss this place. We had some pretty good times here.','I don\'t know. I think I\'m going to miss this place. We had some pretty good times here.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(39632,'I have an idea... this time let\'s not wander through a naval battle between the Alliance and the Horde.$B$BI\'m just saying.','I have an idea... this time let\'s not wander through a naval battle between the Alliance and the Horde.$B$BI\'m just saying.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39633,'','May the Earth Mother watch over you, $n. Thank you for your help.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39634,'The song of your life will be sung by the mighty, $n. Until we meet again.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(39635,'I have other business that must be done in Azshara, so I will join you on your journey, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39636,'You have the heart of a giant, $n. It has been an honor!','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(39637,'','Looks like this is it, boss-$g man : lady;. It\'s been a real honor. I\'m sure we\'ll see each other again real soon.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39638,'Welcome, friend.  Let\'s ride through Grim Batol and strike a blow against Deathwing that he won\'t soon forget!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(39639,'Log\'loth og shandai, mortal. Only death is eternal. You will be undone.','',0,0,0,0,0,0,0,0,1,0,21900,0,26124),
(39640,'Fate subjugates faith, mortal. Your prayers are meaningless here.','',0,0,0,0,0,0,0,0,1,0,21901,0,26124),
(39641,'Now you\'re just wasting my time!','Now you\'re just wasting my time!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39642,'Ahoy!','',0,0,0,0,0,0,22,0,1,0,21174,0,26124),
(39643,'I\'m saaaailing!','',0,0,0,0,0,0,22,0,1,0,21175,0,26124),
(39644,'If I had a silver for every time I heard the world was going to end, I\'d be richer than a goblin trade prince!','If I had a silver for every time I heard the world was going to end, I\'d be richer than a goblin trade prince!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39645,'Doomsday cultists? Well, the orcs have already survived the end of one world, so what\'s another?','Doomsday cultists? Well, the orcs have already survived the end of one world, so what\'s another?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39646,'Put these cultists on a zeppelin and send them to Stormwind! We don\'t need this kind of thing in Orgrimmar.','Put these cultists on a zeppelin and send them to Stormwind! We don\'t need this kind of thing in Orgrimmar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39647,'Well, that must be why my neighbor shaved his head and donned those robes. Maybe he\'ll let me have his stuff.','Well, that must be why my neighbor shaved his head and donned those robes. Maybe he\'ll let me have his stuff.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39648,'Who would join something like this? If the world is really going to end, do they really think it would bother warning us?','Who would join something like this? If the world is really going to end, do they really think it would bother warning us?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39649,'Looks like it\'s time for the grunts to clean out the Drag and the Cleft of Shadow again.','Looks like it\'s time for the grunts to clean out the Drag and the Cleft of Shadow again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39650,'Out on a boat... way far away from the dock...\n','',0,0,0,0,0,0,1,0,1,0,21176,0,26124),
(39651,'Into the wind with the sky and everything...\n','',0,0,0,0,0,0,1,0,1,0,21177,0,26124),
(39652,'Oooh... shiny!','',0,0,0,0,0,0,397,0,1,0,21178,0,26124),
(39653,'I ain\'t askin\' for me alone, Great Spirit, but on behalf of da Darkspear Tribe... on behalf of me PEOPLE.','',0,0,0,0,0,0,1,1,1,0,17580,0,26124),
(39654,'I lost my Motivate-a-Tron. May I have another?','I lost my Motivate-a-Tron. May I have another?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39655,'You want something?','You want something?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39656,'You have something to show me?','You have something to show me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39657,'Fine.  I\'ll come with you.  This had better be important.','Fine.  I\'ll come with you.  This had better be important.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39658,'Come aboard, now. Step right up!\n','',396,0,0,0,0,0,70,0,1,8873,21279,0,26124),
(39659,'Cap\'n Samir is navigatin\' this here ship non-stop to that there ocean over yonder...\n','',22,0,0,0,0,0,22,0,1,8873,21280,0,26124),
(39660,'...where we\'ll commence to assistin\' the Alliance in their little skirmish with them Horde fellers.\n','',22,0,0,0,0,0,0,0,1,8873,21281,0,26124),
(39661,'Easy money! Commission\'s to be dispersed evenly among any and all survivors!\n','',22,0,0,0,0,0,0,0,1,8873,21282,0,26124),
(39662,'I\'m ready for the trip back down.','I\'m ready for the trip back down.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39663,'Ouch!  That... that really hurt!','Ouch!  That... that really hurt!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39664,'Lead the Twilight Recruit away from the group and use the Blackjack to knock him out.','Lead the Twilight Recruit away from the group and use the Blackjack to knock him out.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39665,'Starting test.  Casting trigger spell now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39666,'Trigger spell received. Idling.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39667,'Chromie, you and I both know what\'s going to happen in this time stream. We\'ve seen this all before. Can you just skip us ahead to all the real action?','Chromie, you and I both know what\'s going to happen in this time stream. We\'ve seen this all before. Can you just skip us ahead to all the real action?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39668,'','That\'s right, I\'ve seen you here before! How could I forget?$B$BI can teleport you to Stratholme now, if you wish.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(39669,'Mighty Eye of Twilight, guide your humble servant!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39670,'Speak now, Eye of Twilight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39671,'What are your orders, Eye of Twilight?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39672,'','Captain! Shipwreck off the starboard bow! There appear to be survivors!',0,0,0,0,0,0,0,0,1,0,0,20916,26124),
(39673,'Where is two-head? What do Eye tell us now?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39674,'Who talk to Eye last? Is Eye happy? Tell Gar\'gol!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39675,'Cave is too filthy! Put filth in filth piles marked with flag. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39676,'Dinnertime for Gar\'gol! Go get chef. Cook chef if dinner not ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39677,'The Eye talks in shadow-talk. I do what Eye says! You do what Gar\'gol says!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39678,'The Eye have no lips, but the Eye whispers to Gar\'gol. The Eye knows everything!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39679,'If you don\'t like what we do here, you talk to the Eye. But it will not listen. It\'s not the Ear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39680,'Don\'t pay Budd no nevermind... poor fella\'s got a few screws missin\'.','',0,0,0,0,0,0,0,0,1,0,21276,0,26124),
(39681,'You did it, $n! The shrine is ours again!','You did it, $n! The shrine is ours again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39682,'Enough! I\'ll stain my hands with your blood! (Hyehahahaha! Murder! MURDER!)','',0,0,0,0,0,0,15,0,1,0,22120,0,26124),
(39683,'Pathetic! Behold the true might of my chosen...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39684,'Ian Duran is waiting for you in camp.','Ian Duran is waiting for you in camp.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39685,'Takrik Ragehowl has asked for you up in the camp.','Takrik Ragehowl has asked for you up in the camp.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39686,'My life for you, master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39687,'What the... ?','',0,0,0,0,0,0,0,0,1,0,21278,0,26124),
(39688,'%s begins to cast Defile!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39689,'If I had a silver for every time I heard the world was going to end, I\'d be richer than a goblin trade prince!','If I had a silver for every time I heard the world was going to end, I\'d be richer than a goblin trade prince!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39690,'Doomsday cultists? Just what we need after all the trouble with those Defias thugs.','Doomsday cultists? Just what we need after all the trouble with those Defias thugs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39691,'Put these cultists on a boat and send it into the Maelstrom! We don\'t need this kind of thing in Stormwind!','Put these cultists on a boat and send it into the Maelstrom! We don\'t need this kind of thing in Stormwind!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39692,'Well, that must be why my neighbor shaved his head and donned those robes. Maybe he\'ll let me have his stuff.','Well, that must be why my neighbor shaved his head and donned those robes. Maybe he\'ll let me have his stuff.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39693,'If the world is going to end, do these cultists really think it would bother warning us?','If the world is going to end, do these cultists really think it would bother warning us?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39694,'Looks like it\'s time for the guards to clean out Old Town again.','Looks like it\'s time for the guards to clean out Old Town again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39695,' |TInterface\\Icons\\ability_creature_disease_02.blp:16|t You have been infected by |cFFBC05FFNecrotic Plague|r! |TInterface\\Icons\\ability_creature_disease_02.blp:16|t',' |TInterface\\Icons\\ability_creature_disease_02.blp:16|t You have been infected by |cFFBC05FFNecrotic Plague|r! |TInterface\\Icons\\ability_creature_disease_02.blp:16|t',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39696,'','Cry havoc, brothers and sisters!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39697,'Hooray for meat! HIP HIP HOORAY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39698,'Butcherbot will harvest meat, tra la la la la.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39699,'I want the arterieeeeeeeeees!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39700,'No part goes to waste! Yay!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39701,'Chop chop chop!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39702,'VWHHHHHRRRRRRRRRRRRRRRRHHHHHHMNNNGHHHGH','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39703,'Increase your profit potential with Butcherbot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39704,'Yaaaaaaaaaaaaaaaaaaaaaay!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39705,'Gann\'s head is lolled to one side, and his breathing grows ragged.$B$BHe doesn\'t acknowledge your presence.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39706,'I seem to have misplaced the remote control fireworks.','I seem to have misplaced the remote control fireworks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39707,'Well, of course, here are some extras. I\'m just made of fireworks....','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39708,'They may take our lives, but they\'ll never take...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39709,'What I want out of each and every one of you is a hard-target search of every refuelling station, residence, warehouse, farmhouse, henhouse, outhouse and doghouse in this area. ','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(39710,'We will not go quietly into the night! We will not vanish without a fight!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39711,'Hmm, I suppose it could work.  But it could really use a little more umph!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39712,'','What?  I don\'t even know what you\'re talking about!  That\'s terrible!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39713,'Horrible! Well, all right, maybe it just needs a little cleaning up?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39714,'Thoth\'al amun Ree\'thael vormos! Vormos! Vormos!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(39715,'Al\'tha, Al\'tha bormaz. Ni bormaz ta\'thall? It comes, it walks in flames, $r!','',6,5,0,0,0,0,0,0,1,0,0,0,26124),
(39716,'The shadow sees. Bo\'al lal arwi C\'toth. The end comes, cloaked in silent fire.','',6,5,0,0,0,0,0,0,1,0,0,0,26124),
(39717,'Mar\'kowa tallol ye\'tarin, it knows, it knows.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39718,'Fear broils forth from the heart of the infinite. Don\'t make me look! I\'ve seen more than I can stand!','',1,274,0,0,0,0,0,0,1,0,0,0,26124),
(39719,'We are nothing. Tulall par\'okoth. Far\'al, ka\'kar. The void devours.','',274,1,0,0,0,0,0,0,1,0,0,0,26124),
(39720,'<The Twilight Servitor gurgles at you, white spittle foaming and bubbling from his mouth.>','',274,21,0,0,0,0,0,0,1,0,0,0,26124),
(39721,'H\'thon, the column of darkness stretching beyond sight. H\'thon marwol qualar: the infinite grasp of night.','',430,5,0,0,0,0,0,0,1,0,0,0,26124),
(39722,'...our INNOVATION!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(39723,'Your fugitive\'s name is Mekgineer Thermaplugg.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39724,'Go get him.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(39725,' We\'re going to live on! We\'re going to survive! Today we celebrate...','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(39726,'...our Autonomy Day!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(39727,'','$n, the Twilight slaves you and others have been rescuing from Wolf\'s Run are wandering into camp, but they can\'t tell me who they are and they speak in riddles and gibberish.$B$BI thought Twilight\'s Hammer kept the slaves in line the old fashioned way - you know, whips and chains - but it\'s clear that there\'s some brainwashing at work...\n',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(39728,'You must remain in Steelgrill\'s Depot.','You must remain in Steelgrill\'s Depot.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(39729,'<Administer the draught.>','<Administer the draught.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39730,'Wha - what? Where am I? I\'ve got to get out of here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39731,'What happened to me? I\'m leaving!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39732,'...What am I saying? Nothing makes sense anymore. I\'ve got to get out of this place!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39733,'My ... brain ... hurts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39734,'Whoa, you made the voices go away. I\'m outta here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39735,'What did they do to me? I\'ve got to get back to camp...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39736,'','Any luck out there? Just trying to hold a conversation with the freed slaves makes my head hurt.$B$BThey straddle the line in discord and rhyme.\n',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(39737,'','Thanks for your help, $n.\n',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39738,'I don\'t know if it\'s good to have my mind back.$B$BKnowing what I know... Knowing what may happen to our world...$B$B<He shudders and falls silent.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39739,'Thanks for rescuing us, $c.$B$BWe\'ll accompany the next caravan off of this mountain, but... I don\'t think I\'ll ever be the same...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39740,'Leave us in peace, stranger. We have done nothing to you.','Leave us in peace, stranger. We have done nothing to you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39741,'We have withdrawn from life in the city to await our fates here, where the truth has been revealed to us.','We have withdrawn from life in the city to await our fates here, where the truth has been revealed to us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39742,'Do you seek to join us? We have messengers in the city who will tell you what you must do, seeker.','Do you seek to join us? We have messengers in the city who will tell you what you must do, seeker.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39743,'','The forces of the Sentinel Army hold back the Horde across all of Kalimdor. While the war continues in Ashenvale and Stonetalon, our forces are also needed here, to protect these remaining wilds and prevent our enemies from gaining further footholds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39744,'What do you think you\'re doing, $c? Get away from those instruments!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39745,'You cannot ... control the Eye! Cho\'gall will know. You will be ... punished.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39746,'Take me to Mekkatorque!','Take me to Mekkatorque!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39747,'The sun of life will set forever, as light gives way to eternal night! (Oblivion looms! It calls!)','',0,0,0,0,0,0,396,0,1,0,22126,0,26124),
(39748,'The Twilight\'s Hammer is the instrument of this grand destruction, the method of glorious annihilation! (Tear aside the veil! Open your mind to emptiness!) Through us will you find true power.','',0,0,0,0,0,0,396,0,1,0,22127,0,26124),
(39749,'Join us (Join us!) and be granted strength beyond strength! (Strength! His STRENGTH! His MIGHT!)','',0,0,0,0,0,0,15,0,1,0,22128,0,26124),
(39750,'I am the Eye of Twilight... Behold your new master!','I am the Eye of Twilight... Behold your new master!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39751,'Your work in Hyjal is done - return from whence you came.','Your work in Hyjal is done - return from whence you came.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39752,'Kill anyone who tells you otherwise. So sayeth the Eye!','Kill anyone who tells you otherwise. So sayeth the Eye!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39753,'','Have you come here to bother us, outsider?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39754,'','Do not be afraid, $c. We embrace all who seek the truth.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39755,'We only want to be left alone. Why is that so difficult to understand?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39756,'The end of the world approaches, but there is time to set things right, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39757,'Enjoy your hollow victory, insects. (The darkness comes...) May it console you as your world rots.','',0,0,0,0,0,0,0,0,1,0,22122,0,26124),
(39758,'Hello, $c. I imagine you have a lot of questions.$B$BSuffice it to say that Royce Duskwhisper sent me into the middle of an ogre cave for some \"Eye of Twilight\" jib-job, and it hasn\'t gone well.$B$BIf I ever get my hands on that lanky, heartless, mealy-mouthed little night elf...$B$B<Kristoff wriggles helplessly as he dangles in the air, his face reddening.>','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39759,'You should return to Orgrimmar. Your family is worried.','You should return to Orgrimmar. Your family is worried.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39760,'','No, I cannot return to Orgrimmar. I grieve for my family, but they have made their choices and I have made mine. My future is here, among my chosen brethren.',274,1,0,0,0,0,0,0,1,0,0,0,26124),
(39761,'Your family has asked about you. They\'re worried.','Your family has asked about you. They\'re worried.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39762,'','I will not leave. Tell my family that I am at peace here and that I wish them well.',274,1,0,0,0,0,0,0,1,0,0,0,26124),
(39763,'','One day, I, too, will ascend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39764,'','It amazes me that in a city full of people, only the small handful here heeded the warnings of the elements.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39765,'Work hard, $c. We have little time to complete our tasks before the prophecies are fulfilled.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39766,'Our world will end soon, but together we will ascend and inherit the power of the elements.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39767,'Your family wants you to return to Orgrimmar.','Your family wants you to return to Orgrimmar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39768,'You smell somethin\'?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(39769,'I\'d lend a hand, but I\'ve got... chain rash. I\'ll just hang back a little.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39770,'You\'re one unusual $c, $n. I don\'t mean that it a negative way. I\'m just sayin\', you\'re kinda funny.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39771,'How long was I hanging back there? It felt like days.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39772,'I don\'t recommend hanging from a chain like that. But, to be honest, it did great things for my hair.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39773,'Ogres.$B$BI hate ogres.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(39774,'Do you always talk so much when there\'s stuff to kill?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(39775,'Less yap flappin\'. More ogre thwappin\'. Deal?','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(39776,'They had their chance to come with me, and instead they mocked my beliefs. They are nothing to me.','',1,274,0,0,0,0,0,0,1,0,0,0,26124),
(39777,'Your wife is concerned for you. She wants you to return to Orgrimmar.','Your wife is concerned for you. She wants you to return to Orgrimmar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39778,'Doesn\'t she realize I wanted her to come with me? I\'m young; I don\'t want to die. We should have many good years ahead of us and this is the only way. Tell her these things. Make her understand.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(39779,'Okay, let\'s do this! You fight the ogres, and I will... not fight them. Head for the exit!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(39780,'I\'ve been given another chance to serve?  I will not fail again!','I\'ve been given another chance to serve?  I will not fail again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39781,'Alexstrasza has chosen capable allies.... A pity that I must END YOU!','',0,0,0,0,0,0,0,0,1,0,17512,0,26124),
(39782,'You thought you stood a chance?','',0,0,0,0,0,0,0,0,1,0,17513,0,26124),
(39783,'It\'s for the best.','',0,0,0,0,0,0,0,0,1,0,17514,0,26124),
(39784,'HALION! I....','',0,0,0,0,0,0,0,0,1,0,17515,0,26124),
(39785,'Turn them to ash, minions!','',0,0,0,0,0,0,0,0,1,0,17516,0,26124),
(39786,'We made it! I\'ll find my way back on my own. Do me a favor and go tell Royce Duskwhisper where he can stick his stupid Eye of Twilight.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(39787,'I see you are growing in numbers, my brethren. Tell me of your progress in implementing our master\'s plan.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39788,'Then all is in order. The master has given us a mission of the utmost importance and he will not suffer failure.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39789,'Behold! The world you see before you has been judged. (Fire, water, earth, air!) All shall perish before the elements! (Burn and drown and crush and suffocate!)','',0,0,0,0,0,0,1,0,1,0,22123,0,26124),
(39790,'Join us, and embrace the inevitable end. (The Master\'s power calls!) You will be reborn, stronger than flesh! (Strength beyond form! Power in the infinite!)','',0,0,0,0,0,0,1,0,1,0,22124,0,26124),
(39791,'Swear your allegiance to me (The master wants! He sees and wants and hungers!) and you will be remade in my image. (Wait! INFIDEL! A heathen among us!) An intruder! YOU! Show yourself...','',0,0,0,0,0,0,22,0,1,0,22125,0,26124),
(39792,'Work on the devices is proceeding as you have directed. We will soon be ready to carry out the next phase of your orders.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39793,'You are the instrument the master will use to bring an end to this world and reforge it in his image.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39794,'When they are completed, you will hide these devices all over Orgrimmar.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39795,'That one\'s huge. You shouldn\'t have made him angry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39796,'At the appointed time, they will unleash fire elementals, consuming the city in flame and setting the stage for our master\'s glorious return!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39797,'Look out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39798,'Ogre!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39799,'This one smells particularly bad.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39800,'Kill that one! I\'ll stay over here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39801,'What, more ogres?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39802,'Don\'t get stepped on.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39803,'He doesn\'t see me, does he?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39804,'Is that the Twilight Apocrypha? I\'ll be boiled alive - it DOES exist!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39805,'Hi. Yeah, I know. I got captured again.$B$BI don\'t want to talk about it.$B$BYou ready?','',1,274,0,0,0,0,0,0,1,0,0,0,26124),
(39806,'Well? Are you going to help me down?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(39807,'Okay, let\'s try this again.','Okay, let\'s try this again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39808,'Um, no. Would you mind hanging out a little longer? I have some stuff I need to take care of first.','Um, no. Would you mind hanging out a little longer? I have some stuff I need to take care of first.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39809,'You... WHAT?$B$BCome over here and say that!$B$B<Kristoff kicks and flails his limbs in a frothing rage, his head twisting around to glare at you.>$B$BSo help me, I will - I am going to - I will knock your brains out! I will fill the empty cavity left behind with my boot! Come here! GET BACK HERE!$B$B<Kristoff strains to grasp your neck, his fingers wriggling inches from your face.>','',5,15,0,0,0,0,0,0,1,0,0,0,26124),
(39810,'So how is your research into the Eye coming along?','So how is your research into the Eye coming along?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39811,'$n, $n. Can I call you $n?$B$BI am hanging from a meathook in the back of an ogre cave.$B$BHow do you THINK my research is progressing, you pompous dirt-sucking ass-$c? C\'mere! C\'mere you son of a swineherd!$B$B<Kristoff flutters back and forth on his chain, trying desperately to kick you in the face.>','',5,15,0,0,0,0,0,0,1,0,0,0,26124),
(39812,'<Kristoff grunts.>','',388,0,0,0,0,0,0,0,1,0,0,0,26124),
(39813,'And then, my brothers and sisters, we shall shed these frail forms and ascend to immortality!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(39814,'Of all the ancients, Goldrinn is the most magnificent. His fury, his resolve... you would do well to emulate.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39815,'It will be as you say, my lord.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39816,'It should be me in your place!  I\'ll show you!','It should be me in your place!  I\'ll show you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39817,'I\'ll kill you and take your place, scum!','I\'ll kill you and take your place, scum!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39818,'We live or die in THEIR service!','We live or die in THEIR service!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39819,'I should be the one learning the secrets of the Old Gods!  I\'ll show you!','I should be the one learning the secrets of the Old Gods!  I\'ll show you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39820,'I was chosen!  I will prevail!','I was chosen!  I will prevail!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39821,'Heed me, Twilight Lords!  Accept this $r as a humble offering!','Heed me, Twilight Lords!  Accept this $r as a humble offering!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39822,'Master Taerar no longer dwells here, fool. He has bestowed me with enough power to stop you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39823,'','I don\'t recognize you. Are you new here?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(39824,'What are those devices that everyone is building?','What are those devices that everyone is building?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39825,'','Ah, you are new. These devices are a part of our master\'s plan to bring about the transformation of the world. They will unleash the fires of judgment and allow us to ascend to immortality. This is the master\'s promise.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39826,'','You don\'t belong here, outsider. Leave before you get yourself in trouble.',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(39827,'Noooooooooooooooo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39828,'','Taerar has not fled Feralas. He acts as a conduit to the nightmare through his own form.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39829,'','I will run no longer. Seek me atop the peak to the east.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39830,'Blood guard, you have to help me find him. He just went missing!','Blood guard, you have to help me find him. He just went missing!',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(39831,'Surely you can help. He just went out to the market and never came back.','Surely you can help. He just went out to the market and never came back.',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(39832,'There has to be something you can do, blood guard.','There has to be something you can do, blood guard.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(39833,'He would never leave on his own! Where could he have gone?','He would never leave on his own! Where could he have gone?',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(39834,'My husband has disappeared. Please, blood guard, he is no warrior. You must help me find him.','My husband has disappeared. Please, blood guard, he is no warrior. You must help me find him.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39835,'You are a reasonable man, blood guard. Where would you turn if your kin went missing?','You are a reasonable man, blood guard. Where would you turn if your kin went missing?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(39836,'Do you think he was kidnapped? Will I ever see him again?','Do you think he was kidnapped? Will I ever see him again?',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(39837,'I am not the only one who is here to report a disappearance. There are others, many others.','I am not the only one who is here to report a disappearance. There are others, many others.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39838,'There\'s something going on in Orgrimmar, and I don\'t like the look of it. These women complain that people have disappered. Others say the world will end. What does it mean?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(39839,'BY FIRE BE PURGED!!!!','',0,0,0,0,0,0,0,0,1,0,23335,0,26124),
(39840,'The end of the world nears, $c. There is no need to despair. Hear what I say and what my brethren have to offer.','The end of the world nears, $c. There is no need to despair. Hear what I say and what my brethren have to offer.',25,1,0,0,0,0,0,0,1,0,0,0,26124),
(39841,'I will hear what you have to say.','I will hear what you have to say.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39842,'%s hastily scrawls a page of notes into his manuscript. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39843,'%s consults his manuscript, grunting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39844,'%s tinkers with a bizarre array of equipment on his workbench.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39845,'%s chuckles softly to himself, carefully logging his progress in his manuscript.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39846,'You\'re interrupting work your feeble mind cannot possibly comprehend!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39847,'I want to join your movement.','I want to join your movement.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39848,'I need another robe.','I need another robe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39849,'Gather around the altar, brothers and sisters! Revelation awaits!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(39850,'Citizens and friends of Gnomeregan!','',0,0,0,0,0,0,1,0,1,0,17535,0,26124),
(39851,'No more shall our people live as refugees, as outcasts, as wretched, irradiated slaves chained to the yoke of a madman\'s war machine!','',0,0,0,0,0,0,1,0,1,0,17536,0,26124),
(39852,'The end of Thermaplugg\'s reign draws near!','',0,0,0,0,0,0,1,0,1,0,17537,0,26124),
(39853,'Our tactics, our science, our bravery and determination shall prevail.','',0,0,0,0,0,0,1,0,1,0,17538,0,26124),
(39854,'Operation: Gnomeregan begins NOW!','',0,0,0,0,0,0,22,0,1,0,17539,0,26124),
(39855,'Targets in sight! Squads, deploy: Destroy all enemy rocket launchers!','',0,0,0,0,0,0,25,0,1,0,17541,0,26124),
(39856,'That\'s one down. Keep attacking!','',0,0,0,0,0,0,71,0,1,0,17542,0,26124),
(39857,'There\'s another destroyed. Maintain the assault!','',0,0,0,0,0,0,5,0,1,0,17543,0,26124),
(39858,'Excellent work. Don\'t let up!','',0,0,0,0,0,0,4,0,1,0,17544,0,26124),
(39859,'The airfield is ours, and with it, the skies over Gnomeregan.','',0,0,0,0,0,0,5,0,1,0,17546,0,26124),
(39860,'Today is the day we take back our glorious city from that vile traitor Thermaplugg! ','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39861,'Gather around me as we prepare to reclaim our homeland!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39862,'Gather now at the staging area!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39863,'The assault begins in but a moment!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39864,'Initiate Phase I: Recapture the enemy airfield! ','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39865,'Destroy their rocket launchers and achieve total air superiority!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39866,'Now our Multi-Bombers can obliterate the Thermaplugg\'s shielded Tankbuster Cannons.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39867,'Initiate Phase II: Capture the Surface Command Post!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(39868,'Our Multi-Bombers have destroyed Tankbuster Cannons\' shields. Take them down and secure the Surface Command Post!','',0,0,0,0,0,0,22,0,1,0,17547,0,26124),
(39869,'IT\'S A TRAP! That\'s a fully functional irradiator!','',0,0,0,0,0,0,5,0,1,11832,17554,0,26124),
(39870,'We\'ve secured the surface! Operation: Gnomeregan is proceeding with 93%% efficiency...well done, everyone!','',0,0,0,0,0,0,22,0,1,0,17548,0,26124),
(39871,'I\'ll shut down the defensive radiation pumps. Squads, commandeer the remaining mechanized suits and move up to the Main Entry.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39872,'We stand at the brink of victory, my friends. Initiate Phase III: Into the tunnels!','',0,0,0,0,0,0,1,0,1,0,17549,0,26124),
(39873,'Once we capture the underground railway and loading dock, we\'ll use them to make a rapid attack on the heart of the city. ','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39874,'Gnomeregan is within our grasp!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(39875,'NEVER! Wait...is this thing on? Is it...this button? Testing...testing. Ah! *ahem* ','',0,0,0,0,0,0,0,0,1,0,17569,0,26124),
(39876,'NEVER! Gnomeregan is MINE, Mekkatorque. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39877,'You think you\'ll just march into MY city? ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39878,'Activate the Expendable Atomic Defense System: DRIVE FORTH THE TROGGS!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39879,'My GEARS...that\'s got to be every last trogg in the city! Squads, dig in!','',0,0,0,0,0,0,5,0,1,0,17550,0,26124),
(39880,'Frag bombs and suppressing fire...HOLD THE LINE! We won\'t be turned back now!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(39882,'Sweet baby titans! That\'s got to be the biggest trogg I\'ve ever seen! Keep firing...take it down!','',0,0,0,0,0,0,5,0,1,0,17551,0,26124),
(39883,'It\'s too quiet. Where are Thermaplugg\'s defense forces?\n','',0,0,0,0,0,0,1,0,1,11832,17552,0,26124),
(39884,'What is that? That looks like the radiation bomb that poisoned Gnomeregan...wait! Incoming!','',0,0,0,0,0,0,1,0,1,0,17553,0,26124),
(39885,'No! No, no, NO!!! I won\'t allow you into my kingdom, usurper! I WON\'T ALLOW IT! ','',0,0,0,0,0,0,0,0,1,11832,17570,0,26124),
(39886,'Activate the Ultimate Atomic Protection System.','',0,0,0,0,0,0,0,0,1,11832,0,0,26124),
(39887,'...DISINTEGRATE THEM ALL!','',0,0,0,0,0,0,0,0,1,11832,0,0,26124),
(39888,'It is... and twenty-six TIMES more powerful than the first! ','',0,0,0,0,0,0,0,0,1,0,17571,0,26124),
(39889,'TEN MINUTES?! You left the factory setting on? Give me that controller, you idiot!','',0,0,0,0,0,0,0,0,1,0,17572,0,26124),
(39890,'You\'ve FAILED, Mekkatorque! I\'ve caught and defeated you before you even set FOOT in my precious city!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39891,'Now DIE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39892,'Oh, I\'d love to see that old cog\'s face. I bet he...what? It\'s still on? WELL TURN IT O-','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39893,'Ten minutes? Plenty of time to disarm the device.','',0,0,0,0,0,0,1,0,1,11832,17556,0,26124),
(39894,'Hinkles, hand me that Whirring Bronze Gizmo and some Fresh Spring Water. Cogspin, toss me that Dirty Trogg Cloth and a Handful of Copper Bolts...','',0,0,0,0,0,0,0,0,1,11832,0,0,26124),
(39895,'Whuh-oh! We\'ve got to get out of here! Lapforge, beam us back, quickly!','',0,0,0,0,0,0,5,0,1,11832,17557,0,26124),
(39896,'Curses! We had to fall back. But Thermaplugg\'s lost, and he knows it...he\'s only bought himself time. ','',0,0,0,0,0,0,1,0,1,9381,17558,0,26124),
(39897,'We hold the surface, and when the radiation clears we\'ll assault and recapture Gnomeregan with a force twice this size.','',0,0,0,0,0,0,0,0,1,9381,0,0,26124),
(39898,'Someone has to report this!','Someone has to report this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39899,'Talk, ogre. Who\'s giving your clan these trinkets?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39901,'Warriors of the Horde, we should honor $n for $g his:her; courage in uncovering the Twilight\'s Hammer plot against Orgrimmar!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(39902,'We must uncover the truth about these rumors and stop this Twilight\'s Hammer campaign to spread fear among us!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39903,'Not gonna talk.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39904,'AAAAAAAAAAAAAAGH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39905,'WHO HAS GIVEN YOU POWER?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39906,'Cho\'gall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39907,'The Twilight\'s Hammer?! Where are they?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39908,'Good. Now throw yourself off.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39909,'Dire Maul! DIRE MAUL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39912,'Chief Spirithorn, I beseech you to send aid to Westreach Summit now, before it is too late.','',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(39913,'Thousand Needles lies in ruins under hundreds of feet of water. Can you spare any braves to assist us?','',0,0,0,0,0,0,6,1,1,0,0,0,26124),
(39914,'The Cataclysm crumbled the eastern mountains. The South Seas poured in and submerged all of Thousand Needles! Can you aid us in our time of need?','',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(39915,'Please. We are staging a relief effort at Westreach Summit. Thousand Needles has been decimated!','',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(39916,'I understand that the Cataclysm has struck Feralas as well, but Camp Mojache appears relatively safe. Can you not spare any braves?','',0,0,0,0,0,0,6,1,1,0,0,0,26124),
(39917,'If you cannot send any help to Westreach Summit, may the refugees from Freewind Post stay on the edge of Camp Mojache?','',0,0,0,0,0,0,6,1,1,0,0,0,26124),
(39918,'I fear that if we do not receive reinforcements in Thousand Needles quickly, the Grimtotem will act. We are in no position to defend ourselves for very long.','',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(39919,'If the Shu\'halo of Thousand Needles fall, the Grimtotem clan will be at your tent flap soon after. The time for action is now, Chief Spirithorn!','',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(39920,'','I\'m here to study the ways of the muisek spirits, the wild magic. Witch Doctor Uzeri sent me here to start practicing with the lesser creatures of the forest.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39921,'Greetings, $c.$B$BThe mountains have crumbled and the Cataclysm has caused the seas to rush in and drown Thousand Needles.$B$BWe need your help, now!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39922,'Shyn, I need to get to Westreach Summit!','Shyn, I need to get to Westreach Summit!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39923,'Please, help me! They\'re going to kill me!','',0,0,0,0,0,0,5,0,1,9321,0,0,26124),
(39924,'The crystal has granted you new abilities! Use them to defeat the summoned elementals.','',0,0,0,0,0,0,0,0,1,9405,0,0,26124),
(39925,'','Burn in the master\'s flame!',0,0,0,0,0,0,0,0,1,0,0,17532,26124),
(39926,'Use the crystal\'s powers to defeat the elementals! I won\'t last long...','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(39927,'This was a good man, $r. We\'d served together through many battles...$b$bThese beasts have a debt to pay!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39928,'Irradiator 3000 activated. Attention. Emergency. You now have ten minutes to reach minimum safe distance.','',0,0,0,0,0,0,0,0,1,11832,17635,0,26124),
(39929,'*BEEP* Attention. Emergency. You now have ten seconds to reach minimum safe distance.','',0,0,0,0,0,0,0,0,1,11832,17636,0,26124),
(39930,'Interact with the Mysterious Crystal to gain new abilities and use them to defend Durak Flamespeaker.','',0,0,0,0,0,0,0,0,1,9406,0,0,26124),
(39931,'We will never fall to these cowards! The Horde stands united against all enemies! Lok\'tar Ogar!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(39932,'','You will sssuffer for this intrusion!',0,0,0,0,0,0,0,0,1,0,0,17528,26124),
(39933,'','As it should be....',0,0,0,0,0,0,0,0,1,0,0,17529,26124),
(39934,'','Halion will be pleased.',0,0,0,0,0,0,0,0,1,0,0,17530,26124),
(39935,'Ah, the entertainment has arrived.','',0,0,0,0,0,0,0,0,1,0,17520,0,26124),
(39936,'I... didn\'t see that coming....','',0,0,0,0,0,0,0,0,1,0,17523,0,26124),
(39937,'Baltharus leaves no survivors!','',0,0,0,0,0,0,0,0,1,0,17521,0,26124),
(39938,'This world has enough heroes.','',0,0,0,0,0,0,0,0,1,0,17522,0,26124),
(39939,'Twice the pain and half the fun.','',0,0,0,0,0,0,0,0,1,0,17524,0,26124),
(39940,'Blasted titans... Why do they use a different set of mechanisms at each of their installations?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39941,'Thank you for saving me. I\'ll make my way back to Orgrimmar once I recover a bit.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39942,'Meddlesome insects! You are too late. The Ruby Sanctum is lost!','',0,0,0,0,0,0,1,0,1,0,17499,0,26124),
(39943,'Meep!  $R is good friend.  Follow now!  We find intruder!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39944,'We finds evil one!  Quick!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39945,'How did you find me?  It matters little... you will die!','How did you find me?  It matters little... you will die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39946,'I\'ve been spotted?  Time to die!','I\'ve been spotted?  Time to die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39947,'You will not give away my position, $c!','You will not give away my position, $c!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39948,'You might have found me, but you won\'t bring word back to the others!','You might have found me, but you won\'t bring word back to the others!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39949,'You will never get the tablets!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(39950,'Continue the assault!','Continue the assault!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(39951,'I will have those tablets!','I will have those tablets!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(39952,'Slay the courier!','Slay the courier!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(39953,'','Our prayers to Aessina go unanswered. The burning minions of Ragnaros have driven us to the brink. If they are not stopped here, the World Tree will be little more than a stump amidst the conflagration!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(39954,'','The strands of life have been severed.$B$BThe dreamers must be avenged.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39956,'','Come forth, Taerar! I stand before you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39957,'I knew you\'d return, Ysondre...It was only a matter of time...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39958,'Peace? PEACE?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39959,'','I\'ve returned only to end this, Taerar. This land will finally have peace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39960,'','Have you come here to bother us? We only want to be left alone.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(39961,'Snooping around here won\'t help you much, friend. You can find out more about us from our members in the city.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39962,'This is no place for outsiders, stranger. Go back to Stormwind.','',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(39963,'My essence...will...persist...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39964,'The end of the world is at hand!','The end of the world is at hand!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(39965,'Azeroth is coming to an end. Make your peace now!','Azeroth is coming to an end. Make your peace now!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(39966,'Come with me, brothers and sisters, and learn the truth!','Come with me, brothers and sisters, and learn the truth!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(39967,'Our world will be torn apart. Join us, so that you may live!','Our world will be torn apart. Join us, so that you may live!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(39968,'It is not too late to save yourselves from the coming catastrophe!','It is not too late to save yourselves from the coming catastrophe!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(39969,'This world will be consumed by the elements!','This world will be consumed by the elements!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(39970,'You needn\'t perish with Azeroth. Follow me and live!','You needn\'t perish with Azeroth. Follow me and live!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39971,'Leave behind your homes, your possessions, and your cares, and join us!','Leave behind your homes, your possessions, and your cares, and join us!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39972,'You haven\'t completed the quest!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39973,'You\'ve completed the quest!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39974,'Just what we need, more of this lunacy!','Just what we need, more of this lunacy!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(39975,'Don\'t you people get tired of repeating the same thing over and over?','Don\'t you people get tired of repeating the same thing over and over?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(39976,'Stop disturbing the peace, cultist!','Stop disturbing the peace, cultist!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(39977,'As if I\'m going to listen to anyone dressed up in that outfit!','As if I\'m going to listen to anyone dressed up in that outfit!',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(39978,'Hey, look, Lady Sylvanas has a new court fool!','Hey, look, Lady Sylvanas has a new court fool!',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(39979,'Why don\'t you take it where somebody cares?','Why don\'t you take it where somebody cares?',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(39980,'That\'s enough of that doomsday nonsense!','That\'s enough of that doomsday nonsense!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39981,'Look, the warchief\'s sent us some entertainment!','Look, the warchief\'s sent us some entertainment!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(39982,'Stonemaul comin\' in FOR DA HORDE!','Stonemaul comin\' in FOR DA HORDE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39983,'Ugh...$b$bI don\'t... feel so good...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39984,'','Thank you, $c.$b$bI nearly died out there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39985,'I can hold out no longer...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39986,'','This is...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39987,'This is truly grave. We must find the true cause of this illness, for the sake of the land.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(39988,'A green dragon in mortal guise! I never thought I would receive the honor of...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39989,'We are here to preserve these lands for our people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39990,'Hold on tight!\n\n|TInterface\\Icons\\misc_arrowlup.blp:32|t','Hold on tight!\n\n|TInterface\\Icons\\misc_arrowlup.blp:32|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(39991,'Lean right!\n\n|TInterface\\Icons\\misc_arrowright.blp:32|t','Lean right!\n\n|TInterface\\Icons\\misc_arrowright.blp:32|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(39992,'Well done!\n','Well done!\n',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(39993,'You\'re losing grip.  Be careful!\n','You\'re losing grip.  Be careful!\n',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(39994,'|TInterface\\Icons\\ability_warrior_charge.blp:20|tGeneral Umbriss sets his eyes on |cFFFF0000$n|r and begins to cast |cFFFF0000|Hspell:74670|h[Blitz]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39995,'$R. Have you been sent to speak with me? How long has it been since the master\'s demise on these very slopes?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(39996,'Patience, friend. Allow me to assist in preparing another attempt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39997,'Who gave your clan these orbs, ogre?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(39998,'','Welcome, $c.$B$BHyjal burns and the world I\'ve spent my life protecting is on the brink of oblivion.$B$BTell me: Have you ever heard of Tyrus Blackhorn?',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(39999,'You disgusting creature. You spread your filth among glorious Eldre\'thalas, and now you DARE defy me? TALK!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40000,'The Twilight\'s Hammer...fascinating. They are within your \"Dire Maul\"?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40001,'You will no longer live there, ogre. Pray you land somewhere safe, for it\'s more than you deserve.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40002,'Years of my research have led me here.$b$bI\'m not about to turn back now...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40003,'C-c-cold...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40004,'Who is Tyrus Blackhorn?','Who is Tyrus Blackhorn?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40005,'Ch-ch-Cho\'gall gives us...orbs...Twilight\'s Hammer clan makes us strong...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40006,'Yes! Dire Maul! Let go...so cold...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40007,'','A decade ago, a great battle took place here on the summit of Mount Hyjal. Archimonde the Defiler commanded a swarm of demons to march upon the World Tree and claim its power for his own.$B$BHis defeat signaled the end of the Legion\'s invasion of Azeroth... But many of his corrupted supporters remained behind.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40008,'Blackhorn is a demon?','Blackhorn is a demon?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40009,'','Yes and no. He may be a demon now, but Tyrus Blackhorn was a night elf once. Like many of his brothers he was wooed and transformed by the promises of power the demonic army whispered in his ear.$B$BHe was captured after his master\'s defeat and imprisoned here on the summit, his immortal form bound by sacred energies.$B$BBut perhaps the dimmest flicker of a soul still burns within him... We must at least reach out to know for sure.',274,1,273,0,0,0,0,0,1,0,0,0,26124),
(40010,'Yes, Blackhorn. I\'ve been sent to request your aid, if you are willing.','Yes, Blackhorn. I\'ve been sent to request your aid, if you are willing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40011,'My help? Have things really grown so dire?$B$B<The distant flames flicker in Blackhorn\'s cruel, dark eyes.>$B$BTell me why I shouldn\'t let your world burn.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40012,'I\'m only here in case someone faints. The new recruits get a little excited and occasionally overexert themselves.\n\n...well, that, and sometimes one of the new mechano-tank prototypes explode. Whoops!','I\'m only here in case someone faints. The new recruits get a little excited and occasionally overexert themselves.\n\n...well, that, and sometimes one of the new mechano-tank prototypes explode. Whoops!',1,11,0,0,3,0,0,0,1,0,0,0,26124),
(40013,'You were a mortal once, Blackhorn. One of us.','You were a mortal once, Blackhorn. One of us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40014,'Mortal? Yes I was once mortal. Weak.$B$BYou see my bonds now? These restraints are nothing compared to being shackled within a mortal coil.$B$BEven now the master\'s gifts stir within me, ready to be unleashed.$B$BNo, $c, my mortal days have passed, and if any flame of my former life still flickers within I would wish it extinguished. You\'ll have to do better than that, $r.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40015,'You\'ll be destroyed if the Twilight\'s Hammer brings this mountain down!','You\'ll be destroyed if the Twilight\'s Hammer brings this mountain down!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40016,'Destroyed? Yes, that\'s possible. At night I am haunted with visions of this world being torn asunder from within. I feel neither sorrow nor rage. Merely... curiosity.$B$BI served my master in exchange for power, $c. But those you fight... they strive for oblivion. A strange motivation.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40017,'Matoclaw believes that you may yet be redeemed. This is your chance to atone for siding with demons.','Matoclaw believes that you may yet be redeemed. This is your chance to atone for siding with demons.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40018,'<Blackhorn strains against his bonds, for the first time visibly upset.>$B$BRedemption! You act as if there\'s an escape from the Burning Legion. So smug! As though your efforts a decade ago or in Outland have slowed the Legion a single iota! They will come, $r. They will return. And I will be here to welcome them.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(40019,'Where is your master now, Blackhorn? It\'s not too late to turn to the light...','Where is your master now, Blackhorn? It\'s not too late to turn to the light...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40020,'Will you help us to defeat them?','Will you help us to defeat them?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40021,'Assuming there\'s a world left for your legion to conquer. The Twilight\'s Hammer seeks to destroy everything.','Assuming there\'s a world left for your legion to conquer. The Twilight\'s Hammer seeks to destroy everything.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40022,'%s emits a shrill cry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40023,'<Cough.>$b$bHave I... died?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40024,'You have talent, $n. But mercy makes you weak.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40025,'Who are you, friend?','Who are you, friend?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40026,'Who are you? What is this place?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40027,'My life is forfeit. If in my final hour I can be of some service, you needn\'t bother asking. Do with me what you will....','',0,0,0,0,0,0,0,0,1,9425,0,0,26124),
(40028,'Brave soldier, I shall see to it that your noble sacrifice is not forgotten.','',396,0,0,0,0,0,0,0,1,9425,0,0,26124),
(40029,'...master?','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(40030,'When they are completed, you will hide these devices all over Stormwind.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40031,'Lean left!\n\n|TInterface\\Icons\\misc_arrowleft.blp:32|t','Lean left!\n\n|TInterface\\Icons\\misc_arrowleft.blp:32|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(40032,'This region was an epicenter of the cataclysm.$b$bThe naga activity here is certainly no coincidence. Their intentions must be unveiled!','',396,0,0,0,0,0,0,0,1,9425,0,0,26124),
(40033,'Looks like the king got himself a new court jester!','Looks like the king got himself a new court jester!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(40034,'You normally have to pay to see a show like this.','You normally have to pay to see a show like this.',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(40035,'He just went missing and I don\'t know what to do!','He just went missing and I don\'t know what to do!',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(40036,'You have to help! He just went to the market and never came back!','You have to help! He just went to the market and never came back!',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(40037,'There has to be someone who can help me!','There has to be someone who can help me!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40038,'He would never just disappear like this! It\'s not like him.','He would never just disappear like this! It\'s not like him.',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(40039,'My husband just disappeared. You have to help me, captain. I\'m no warrior.','My husband just disappeared. You have to help me, captain. I\'m no warrior.',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(40040,'You seem like a reasonable man, captain. What would you do if someone in your family went missing?','You seem like a reasonable man, captain. What would you do if someone in your family went missing?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(40041,'Do you think he was kidnapped? Will I ever see him again?','Do you think he was kidnapped? Will I ever see him again?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(40042,'I\'m not the only one who has lost a family member. There are others, many others!','I\'m not the only one who has lost a family member. There are others, many others!',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(40043,'Your family is worried and wants you to come back to Stormwind.','Your family is worried and wants you to come back to Stormwind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40044,'','I can\'t go back, not after the horrible fight I had with them. I\'m sorry, $n, I just can\'t.',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(40045,'','I cannot return. Now that I\'ve learned the truth, my place is here among my new brothers and sisters.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40046,'I am on the path to ascension, $n. There is no going back. Tell my family that I wish them well, and I will be here if they decide to join me.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40047,'Why should I return, $n? The world is ending and I have a chance to become something more. If their paths lead them to the truth, as mine did, then we will see each other again. If not, I cannot open their eyes.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40048,'Hear me, citizens of Stormwind. We have long been in the dark. I beg you to open your eyes as I have!','Hear me, citizens of Stormwind. We have long been in the dark. I beg you to open your eyes as I have!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40049,'The end of our world nears, my brothers and sisters! Azeroth will be no more!','The end of our world nears, my brothers and sisters! Azeroth will be no more!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(40050,'Flames will consume the world. Storms will wash away all hope. The elements will reign at last!','Flames will consume the world. Storms will wash away all hope. The elements will reign at last!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40051,'Do not despair! Turn away from the false Light, and instead embrace the hope and truth I offer you!','Do not despair! Turn away from the false Light, and instead embrace the hope and truth I offer you!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40052,'Cast off your lives of war and drudgery, be reborn in elements and claim your rightful place in this new world!','Cast off your lives of war and drudgery, be reborn in elements and claim your rightful place in this new world!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40053,'Calm down, friends. There will be plenty of time to answer all your questions.','Calm down, friends. There will be plenty of time to answer all your questions.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40054,'If you are interested in our message, I will be holding a gathering. Speak with me if you wish to know more, but beware, for Stormwind is full of people who would silence the truth.','If you are interested in our message, I will be holding a gathering. Speak with me if you wish to know more, but beware, for Stormwind is full of people who would silence the truth.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40055,'Fool of a mortal. Flesh burns.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40056,'LEAVE THIS PLACE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40057,'I love you, Sensiria, but I must leave here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40058,'','Oh, Verinias. You poor fool. You should have left earlier.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40059,'I will leave to follow Dath\'remar and the others. The Shen\'dralar have gone too far. To traffic with demons...we\'re giving ourselves over to corruption.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40060,'No! NO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40061,'','It\'s too late to stop them. Let me show you their glory...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40062,'Interact with the Mysterious Crystal to gain new abilities and use them to defend Courier Tormun!','',0,0,0,0,0,0,0,0,1,9442,0,0,26124),
(40063,'The crystal has granted you new abilities! Use them to defeat the summoned elementals.','',0,0,0,0,0,0,0,0,1,9441,0,0,26124),
(40064,'Your world teeters on the brink of annihilation. You will ALL bear witness to the coming of a new age of DESTRUCTION!','',0,0,0,0,0,0,0,0,1,0,17500,0,26124),
(40065,'Relish this victory, mortals, for it will be your last. This world will burn with the master\'s return!','',0,0,0,0,0,0,0,0,1,0,17503,0,26124),
(40066,'Another \"hero\" falls.','',0,0,0,0,0,0,0,0,1,0,17501,0,26124),
(40067,'You will find only suffering within the realm of twilight! Enter if you dare!','',0,0,0,0,0,0,0,0,1,0,17507,0,26124),
(40068,'The heavens burn!','',0,0,0,0,0,0,0,0,1,0,17505,0,26124),
(40069,'Beware the shadow!','',0,0,0,0,0,0,0,0,1,0,17506,0,26124),
(40070,'Very well, dwarf. I shall slay you and carry the tablets to Cho\'Gall.','Very well, dwarf. I shall slay you and carry the tablets to Cho\'Gall.',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(40071,'The orbiting spheres pulse with dark energy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40072,'I am the light and the darkness! Cower, mortals, before the herald of Deathwing!','',0,0,0,0,0,0,0,0,1,0,17508,0,26124),
(40073,'Let the enemies of Stormwind and the Alliance know, I will not allow them to spread fear and rumors among the people!','',0,0,0,0,0,0,25,0,1,10606,0,0,26124),
(40074,'With heroes like $n fighting on our behalf, Stormwind stands ready to face any Twilight\'s Hammer threat!','',0,0,0,0,0,0,1,0,1,10606,0,0,26124),
(40075,'There will be time enough to speak of preparations for battle against Twilight\'s Hammer. Today, we celebrate $n\'s victory!','',0,0,0,0,0,0,1,0,1,10606,0,0,26124),
(40076,'A strange mood has come over the city, $c. The people are afraid of something and many have gone missing. We must get to the bottom of it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40077,'Someone should tell the king. A chat with Lo\'gosh would set these cultists straight!','Someone should tell the king. A chat with Lo\'gosh would set these cultists straight!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(40078,'Others will come... the age of mortals... has passed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40079,'Your companions\' efforts force %s further into the physical realm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40080,'Your companions\' efforts force %s further into the twilight realm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40081,'Sons and daughters of de Darkspear! Friends of de tribe!','',0,0,0,0,0,0,1,1,1,0,17573,0,26124),
(40082,'We be gettin\' ready to march to de Isles, an\' FREE dem of Zalazane\'s wicked rule! Join me!','',0,0,0,0,0,0,22,1,1,0,17574,0,26124),
(40083,'Zalazane\'s time has come! De Darkspear will have a proper home again. Be ready!','',0,0,0,0,0,0,22,1,1,0,17575,0,26124),
(40084,'You came, wise sista! De Darkspear be grateful.','',0,0,0,0,0,0,1,1,1,0,17576,0,26124),
(40085,'','Of course, Son of Sen\'jin. Zen\'tabra always keep her word.',0,0,0,0,0,0,1,0,1,0,0,17621,26124),
(40086,'De time has come! Warrior of de Darkspear, make ready! Da Loa walk wit us! Are ya ready, Vanira, Zen\'tabra?','',0,0,0,0,0,0,1,1,1,0,17577,0,26124),
(40087,'','De elements be walkin\' wit us, too...',0,0,0,0,0,0,1,1,1,0,0,17630,26124),
(40088,'','...as do de beasts of de Isles.',0,0,0,0,0,0,273,1,1,0,0,17622,26124),
(40089,'Den we go! First, to Bwonsamdi... if we gonna win dis, we need his mojo on our side.','',0,0,0,0,0,0,1,1,1,0,17578,0,26124),
(40090,'WHO BE STIRRIN\' UP MY BONES? Dem\'s Bwonsamdi\'s charges, and not ta be touched!','',0,0,0,0,0,0,1,1,1,0,17606,0,26124),
(40091,'I be Vol\'jin, Son of Sen\'jin, here ta ask your aid, o great Bwonsamdi.','',0,0,0,0,0,0,1,1,1,0,17579,0,26124),
(40092,'I know who ya are, shadow hunter. An\' I know what ya WANT. But what makes you tink I\'m gonna help YOU? Ain\'t a wise ting, callin\' me from de Other Side...','',0,0,0,0,0,0,273,1,1,0,17607,0,26124),
(40093,'Darkspear...  it been a long time since I heard de drums...  since I drank de ritual offerings. I be watchin\' over your dead, Vol\'jin, and for NOTHIN\'. Why have de Darkspear forsaken Bwonsamdi, eh?','',0,0,0,0,0,0,1,1,1,0,17608,0,26124),
(40094,'We were driven away, Great Spirit. Hexmaster Zalazane took de Isles from us...  drove us mad, made us fight one another. De only trolls left in de Echo Isles are his mindless voodoo slaves.','',0,0,0,0,0,0,1,1,1,0,17581,0,26124),
(40095,'Zalazane...','',0,0,0,0,0,0,1,1,1,0,17609,0,26124),
(40096,'Aid us, Bwonsamdi! Help us regain our home! Return de Darkspear to de Isles, and hear your drums again! Drink your ritual offerings once more! Dis, as de Son of Sen\'jin, I swear.','',0,0,0,0,0,0,1,1,1,0,17582,0,26124),
(40097,'Hrmmm. Time ta see how bad ya want dis, shadow hunter. Time ta see if you be WORTHY.','',0,0,0,0,0,0,396,1,1,0,17610,0,26124),
(40098,'Ya tink ya got what it takes ta face ME? Give up, shadow hunter!','',0,0,0,0,0,0,25,1,1,0,17611,0,26124),
(40099,'ENOUGH!  You got some BIG mojo, Vol\'jin. Maybe you worth helpin\' after all...','',0,0,0,0,0,0,22,1,1,0,17612,0,26124),
(40100,'Not me, Great Spirit. Me TRIBE.','',0,0,0,0,0,0,1,1,1,0,17583,0,26124),
(40101,'Mrm.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(40102,'Go to de old village, across de water. Take it back. I\'ll help ya den.','',0,0,0,0,0,0,1,1,1,0,17613,0,26124),
(40103,'At the appointed time, they will unleash storm elementals, washing away the city and setting the stage for our master\'s glorious return!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40104,'This symbol, I think I\'ve seen this before... ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40105,'Dey be waitin\' for us, all. We fight now for our old home... we gonna reclaim what be OURS!','',0,0,0,0,0,0,25,1,1,0,17584,0,26124),
(40106,'Spirits of de Darkspear... ARISE! Take up de ancient masks, take up de bloody spears... you be followin\' VOL\'JIN, now!','',0,0,0,0,0,0,1,1,1,0,17614,0,26124),
(40107,'Now GO! Use me boon wisely.','',0,0,0,0,0,0,25,1,1,0,17615,0,26124),
(40108,'So be it. Al\'galar thol, thol al\'thaug: The end is the beginning. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40109,'Don\' be underestimatin\' Zalazane... he be a tricky foe, cunnin\' and strong with de voodoo. Are ya ready? MOVE ON!','',0,0,0,0,0,0,1,1,1,0,17585,0,26124),
(40110,'It be TIME, Hexmaster! De sons and daughters of de Darkspear have returned! We gonna drive you into de sea...','',0,0,0,0,0,0,25,1,1,0,17586,0,26124),
(40111,'You ain\'t doin\' nothin\' of de sort, shadow hunter. De Echo Isles are MINE! ','',0,0,0,0,0,0,1,1,1,0,17596,0,26124),
(40112,'Ha ha ha ha!','',0,0,0,0,0,0,11,1,1,0,17598,0,26124),
(40113,'We can\'t be lettin\' him get away!','',0,0,0,0,0,0,1,1,1,0,17587,0,26124),
(40114,'','Der ain\'t no escapin\' Zen\'tabra. Not while he on dese islands.',0,0,0,0,0,0,1,1,1,0,0,17623,26124),
(40115,'Den find him, wise one. Go!','',0,0,0,0,0,0,25,1,1,0,17588,0,26124),
(40116,'','He be just west of here, workin\' at some black magic.',0,0,0,0,0,0,25,1,1,0,0,17624,26124),
(40117,'Not for long. Time ta finish dis ting.','',0,0,0,0,0,0,0,1,1,0,17589,0,26124),
(40118,'Give up, Zalazane. It be over, now.','',0,0,0,0,0,0,25,1,1,0,17590,0,26124),
(40119,'You fool! I ain\'t runnin\' away. I lured ya here, ta kill ya wit\' your own precious tribe!','',0,0,0,0,0,0,1,1,1,0,17599,0,26124),
(40120,'No matter! I can\'t be touched. No living ting can make its way trough dis barrier! Da Echo Isles be Zalazane\'s ta rule, shadow hunter! Now, and FOREVER!','',0,0,0,0,0,0,0,1,1,0,17600,0,26124),
(40121,'BWAH HAH HAH HAH HAH!','',0,0,0,0,0,0,11,1,1,0,17616,0,26124),
(40122,'Who... who dat be?','',0,0,0,0,0,0,0,1,1,0,17601,0,26124),
(40123,'ZALAZANE. What you tinkin\', takin\' dat which be mine? De Darkspear dead are MY domain, sorcerer... and now you gonna be one of dem!','',0,0,0,0,0,0,25,1,1,0,17617,0,26124),
(40124,'No! No... NOOO!','',0,0,0,0,0,0,0,1,1,0,17602,0,26124),
(40125,'A fittin\' end for so foul a troll. Bwonsamdi; you have my tanks, and dat of all de Darkspear. We will continue to honor you, as is proper.','',0,0,0,0,0,0,1,1,1,0,17591,0,26124),
(40126,'It\'ll be good to hear de Darkspear drums once more. You take care now, Son of Sen\'jin.  Bwonsamdi will be waitin\' for ya... on de Other Side...','',0,0,0,0,0,0,273,1,1,0,17618,0,26124),
(40127,'Time to return to de village. Time to rebuild our home... de Darkspear\'s home. Will you be stayin\' wit\' us, wise Zen\'Tabra?','',0,0,0,0,0,0,6,1,1,0,17592,0,26124),
(40128,'','Me fate be entwined wit\' yours now, Vol\'jin, for good or for ill. I be stayin\'.',0,0,0,0,0,0,273,1,1,0,0,17625,26124),
(40129,'Great, ye found yer way here!$b$bNo time to waste. Ye ready?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40130,'','The nightmare reigns!',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(40131,'We\'re ready! Go, Brann!','We\'re ready! Go, Brann!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40132,'','The strands of life...',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(40133,'','Join us! Join us!',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(40134,'','Hear his voice...',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(40135,'The dark ashes swirl around %s, who utters an incantation:','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40136,'Ashes from the plane below, scattered by the hand of foe...','',0,0,0,0,0,0,0,0,1,0,20773,0,26124),
(40137,'Gods of terror, quake and thunder, tear these mortal bonds asunder!','',0,0,0,0,0,0,0,0,1,0,20774,0,26124),
(40138,'%s barks a cruel laugh.','',0,0,0,0,0,0,0,0,1,0,20775,0,26124),
(40139,'Thank you, mortal! Your heroism in The Inferno has made my escape possible.','',0,0,0,0,0,0,0,0,1,0,20776,0,26124),
(40140,'As a reward, I will allow you to live.','',0,0,0,0,0,0,0,0,1,0,20777,0,26124),
(40141,'But your time will come soon enough. Yes, mortal. Soon enough...','',0,0,0,0,0,0,0,0,1,0,20778,0,26124),
(40142,'Hinkles rummages through his backpack looking for supplies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40143,'Cogspin searches his \"Gigantique\" bag looking for the items.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40144,'Heading to the Wild Overlook.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40145,'Our defenses are impenetrable! WE are the true sons of Gnomeregan!\n','',0,0,0,0,0,0,22,0,1,0,17665,0,26124),
(40146,'Use the Mechashark\'s REPAIR!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40147,'But enough words, comrades!  This is a call to action!  We will not let these \"chosen ones\" take what is ours!  We captured this prisoner and offer him to the Old Gods ourselves!!','But enough words, comrades!  This is a call to action!  We will not let these \"chosen ones\" take what is ours!  We captured this prisoner and offer him to the Old Gods ourselves!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40148,'It is in this moment, friends, that we should ask ourselves.  What would the Old Gods want us to do?','It is in this moment, friends, that we should ask ourselves.  What would the Old Gods want us to do?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40149,'Remember the words of C\'thun!  Remember them well! \"Your friends will betray you!\"  And betray us they have!','Remember the words of C\'thun!  Remember them well! \"Your friends will betray you!\"  And betray us they have!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40150,'And yes, Cho\'gall might have founded the Twilight\'s Hammer, but who made it what it is today?  Who preached the truth and faced persecution in the orc and human cities?','And yes, Cho\'gall might have founded the Twilight\'s Hammer, but who made it what it is today?  Who preached the truth and faced persecution in the orc and human cities?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40151,'It is truly a great time for the Twilight\'s Hammer.  The greatest of times.  First, Lord Deathwing\'s arrival.  And now... now great Ragnaros has returned!','It is truly a great time for the Twilight\'s Hammer.  The greatest of times.  First, Lord Deathwing\'s arrival.  And now... now great Ragnaros has returned!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40152,'One by one... our enemies will perish!  One by one... they will be destroyed!','One by one... our enemies will perish!  One by one... they will be destroyed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40153,'There will be no surrender!  There will be no escape!  There will be no quarter!','There will be no surrender!  There will be no escape!  There will be no quarter!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40154,'And sometimes you have to ask yourself: \"Is it worth it?\"  And the answer is plain: \"Pain is not the cost, but the reward!\"','And sometimes you have to ask yourself: \"Is it worth it?\"  And the answer is plain: \"Pain is not the cost, but the reward!\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40155,'F\'tagh nah\'hat!  I\'mmathan!  Sha\'lub nahab!  Sha\'lub nahab, my friends!','F\'tagh nah\'hat!  I\'mmathan!  Sha\'lub nahab!  Sha\'lub nahab, my friends!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40156,'And you will be rewarded!  If you fall in battle, yours will be a virtuous death!  You will be at HIS side when he rises again!  You will share in HIS glory!','And you will be rewarded!  If you fall in battle, yours will be a virtuous death!  You will be at his side when he rises!  You will share in his glory!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40157,'And there is no hope!  There is no hope but in the loss of all hope.  That\'s right, brothers and sisters.  Only hopelessness can grant true hope!','And there is no hope!  There is no hope but in the loss of all hope.  That\'s right, brothers and sisters.  Only hopelessness can grant true hope!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40158,'Yes, my fellow initiates.  The friend of my enemy\'s enemy... well he is also the enemy of my friend.  And yes... he shall perish too!','Yes, my fellow initiates.  The friend of my enemy\'s enemy... well he is also the enemy of my friend.  And yes... he shall perish too!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40159,'And these incidents... these divisive acts of hate against other members of our organization.  They were cowardly and ugly, yes.  But maybe... they were NECESSARY!','And these incidents... these divisive acts of hate against other members of our organization.  They were cowardly and ugly, yes.  But maybe... they were NECESSARY!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40160,'Look at how far we\'ve come!  Yesterday we lived in the shadows of civilization... hunted like rats!  But today!  Today... HYJAL BURNS!!!','Look at how far we\'ve come!  Yesterday we lived in the shadows of civilization... hunted like rats!  But today!  Today... HYJAL BURNS!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40161,'And some will preach unity!  But does unity prevent a chain from breaking at its weakest link?','And some will preach unity!  But does unity prevent a chain from breaking at its weakest link?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40162,'Do not think it is luck that brought you here.  Luck had nothing to do with it.  Our MASTERS\' WILL brought us here!','Do not think it is luck that brought you here.  Luck had nothing to do with it.  Our MASTERS\' WILL brought us here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40163,'I look upon the symbol that unites us.  This hammer.  It is the hammer that builds and creates.  But it is also the hammer that bludgeons and destroys!','I look upon the symbol that unites us.  This hammer.  It is the hammer that builds and creates.  But it is also the hammer that bludgeons and destroys!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40164,'And to those who call for harmony among our ranks... to them I ask: \"Does not ALL strife please our masters?  Does not ALL bloodshed feed their thirst?\"','And to those who call for harmony among our ranks... to them I ask: \"Does not ALL strife please our masters?  Does not ALL bloodshed feed their thirst?\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40165,'','I be one of da first to answer Vol\'jin\'s call to arms. Will you be joinin\' us?',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(40166,'Landro\'s Gift Box','Landro\'s Gift Box',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40167,'Instant Statue','Instant Statue',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40168,'Blazing Hippogryph','Blazing Hippogryph',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40169,'Paint Bomb','Paint Bomb',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40170,'Portal Stone','Portal Stone',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40171,'Rhino Mount','Rhino Mount',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40172,'Wrathgate','Wrathgate',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40173,'Icecrown','Icecrown',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40174,'I\'m not quite convinced.','I\'m not quite convinced.',0,0,0,0,0,0,0,0,1,11411,0,0,26124),
(40175,'Meh.','Meh.',0,0,0,0,0,0,0,0,1,11411,0,0,26124),
(40176,'*yawn*','*yawn*',0,0,0,0,0,0,0,0,1,11411,0,0,26124),
(40177,'Yea... I don\'t know about this.','Yea... I don\'t know about this.',0,0,0,0,0,0,0,0,1,11411,0,0,26124),
(40178,'Blood!','Blood!',0,0,0,0,0,0,0,0,1,11411,0,0,26124),
(40179,'Death!','Death!',0,0,0,0,0,0,0,0,1,11411,0,0,26124),
(40180,'Raaahhh!!!!','Raaahhh!!!!',0,0,0,0,0,0,0,0,1,11411,0,0,26124),
(40181,'Kill!!!','Kill!!!',0,0,0,0,0,0,0,0,1,11411,0,0,26124),
(40182,'Crush!','Crush!',0,0,0,0,0,0,0,0,1,11411,0,0,26124),
(40183,'Kill them all!','Kill them all!',0,0,0,0,0,0,0,0,1,11411,0,0,26124),
(40184,'I hear the voices!','I hear the voices!',0,0,0,0,0,0,0,0,1,11411,0,0,26124),
(40185,'It\'s like... it\'s like the void just touched my mind.','It\'s like... it\'s like the void just touched my mind.',0,0,0,0,0,0,0,0,1,11411,0,0,26124),
(40186,'Immalanath, yasoth nalarub!!!','Immalanath, yasoth nalarub!!!',0,0,0,0,0,0,0,0,1,11411,0,0,26124),
(40187,'The end is nigh!  The end is a new beginning!','The end is nigh!  The end is a new beginning!',0,0,0,0,0,0,0,0,1,11411,0,0,26124),
(40188,'This $gguy:girl; gets it!','This $gguy:girl; gets it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40189,'Tell it like it is, $g brother:sister;!','Tell it like it is, $g brother:sister;!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40190,'$ndamus, you\'re a born leader!','$ndamus, you\'re a born leader!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40191,'That\'s how it\'s done!  Yeah!','That\'s how it\'s done!  Yeah!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40192,'It\'s like I\'m hearing the Old Gods themselves!','It\'s like I\'m hearing the Old Gods themselves!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40193,'Truer words were never spoken!','Truer words were never spoken!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40194,'History in the making!','History in the making!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40195,'Who is this guy?','Who is this guy?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40196,'Sit down!','Sit down!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40197,'You lie!','You lie!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40198,'Huh?','Huh?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40199,'What are you talking about?','What are you talking about?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40200,'','I\'d imagined my first adventure into the ocean as more peaceful and enlightening. Becoming one with nature perhaps?$B$BThere is very little natural about this place. The elements all around us scream for vengeance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40201,'Not all of you will ascend to glory. Look to your left. Look to your right. THEY will perish in the end times. But YOU will become immortal.','Not all of you will ascend to glory. Look to your left. Look to your right. THEY will perish in the end times. But YOU will become immortal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40202,'Eons ago, the \"Titans\" came and cast down our Masters. But this is NOT their world, and it never was! Judgment comes at last!','Eons ago, the \"Titans\" came and cast down our Masters. But this is NOT their world, and it never was! Judgment comes at last!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40203,'But a bitter stench blows into our ranks. The answer is to purge! PURGE! Purge until the Twilight\'s Hammer is pure again!\n','But a bitter stench blows into our ranks. The answer is to purge! PURGE! Purge until the Twilight\'s Hammer is pure again!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40204,'We walk the edge of a precipice. Some of us must be pushed over for the rest of us to continue.\n','We walk the edge of a precipice. Some of us must be pushed over for the rest of us to continue.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40205,'But always remember that our movement cannot stay pure if some traitors among you still draw breath. You know who I mean.\n','But always remember that our movement cannot stay pure if some traitors among you still draw breath. You know who I mean.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40206,'Place a palm across your heart and reach forward with your other hand to touch the infinite. Does it feel soft? NO! It feels... immense.  \n','Place a palm across your heart and reach forward with your other hand to touch the infinite. Does it feel soft? NO! It feels... immense.  \n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40207,'The blood we shed speaks to us. It says  \"Thank you.\"','The blood we shed speaks to us. It says \"Thank you.\"\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40208,'If ya need a bat, ya come to da right place. I be handlin\' all de bats for de scouts.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(40209,'YOU!$B$BYou think you can just waltz in here and take my spot? Think again, $g boy : girl;!$B$BI\'ve heard the whispering in the boardroom. The people you\'ve surrounded yourself with at headquarters are all boot-licking sycophants who will do anything to get ahead. I should know... I hired all of them.$B$BYour meteoric rise to power is a fluke, and I\'m fully prepared to knock you down a gear or two! Watch your step, $n. Who knows when you\'re going to need me on your side?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(40210,'%s cackles in glee.','%s cackles in glee.',0,0,0,0,0,0,11,0,1,0,6974,6974,26124),
(40211,'Are you prepared for war, $r?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40212,'Take me to Sardor Island.','Take me to Sardor Island.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40213,'Hey deres, boss.','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(40214,'Yous be careful. Trolls bad!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40215,'Why we not gets no Kaja\'Cola? We wants to have ideas!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(40216,'We watch dem trolls real good!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40217,'Trolls been saying stuff, boss.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40218,'You wants us go bash bad trolls?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(40219,'Dem trolls wanna fight?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(40220,'How kaja\'mite rock made into Kaja\'Cola?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(40221,'Vanira told me to speak to you about borrowing a bat.','Vanira told me to speak to you about borrowing a bat.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40222,'I could really use a refill on my drink here.','I could really use a refill on my drink here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40223,'Ugh... I need a bucket!','Ugh... I need a bucket!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40224,'If only I had someone to dance with.','If only I had someone to dance with.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40225,'I love fireworks!','I love fireworks!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40226,'This is delicious! Are there more hors d\'oeuvres?','This is delicious! Are there more hors d\'oeuvres?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40227,'Your efforts force %s further out of the twilight realm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40228,'Your efforts force %s further out of the physical realm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40229,'Sampling Successful!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40230,'Sampling interrupted. Sambino products offers its sincere apologies. Please attempt sample extraction again at your soonest convenience.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40231,'Right, let\'s go! Just need to input the final entry sequence into the door mechanism... and...','',0,0,0,0,0,0,5,0,1,0,20897,0,26124),
(40232,'That did the trick! The control room should be right behind this... oh... wow...','',0,0,0,0,0,0,5,0,1,0,20898,0,26124),
(40233,'What? This isn\'t the control room! There\'s another entire defense mechanism in place, and the blasted Rock Troggs broke into here somehow. Troggs. Why did it have to be Troggs!','',0,0,0,0,0,0,5,0,1,0,20899,0,26124),
(40234,'Ok, let me think a moment.','',0,0,0,0,0,0,1,0,1,0,20900,0,26124),
(40235,'Four platforms with huge elementals.','',0,0,0,0,0,0,25,0,1,0,20901,0,26124),
(40236,'I got it! I saw a tablet that mentioned this chamber. This is the Vault of Lights! Ok, simple enough. I need you adventurers to take out each of the four elementals to trigger the opening sequence for the far door!','',0,0,0,0,0,0,5,0,1,0,20903,0,26124),
(40237,'Yep, destroy the four elementals, then the door will open. I\'m sure of it. Just watch out for the Troggs. Nasty tempered, filthy creatures, even if they have not succumbed to the Curse of Flesh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40238,'I don\'t know about you, pal, but I can\'t breathe water.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40239,'|TInterface\\Icons\\inv_mace_15.blp:20|t%s equips his |cFFFF0000Mace|r and is |cFFFF0000|Hspell:75007|h[Encumbered]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40240,'Mirrors pointing all over the place.','',0,0,0,0,0,0,25,0,1,0,20902,0,26124),
(40241,'','All I need to prove myself here are my claws!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40242,'What\'s with the hat?','What\'s with the hat?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40243,'You\'re with the Earthen Ring, I just figured you\'d have a water breathing spell like the rest of them.','You\'re with the Earthen Ring, I just figured you\'d have a water breathing spell like the rest of them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40244,'Sign me up!','Sign me up!',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(40245,'And miss out on wearing my awesome custom-made helmet? Not a chance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40246,'Can I have an Earthbind Totem instead?','Can I have an Earthbind Totem instead?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40247,'Can I have a Stoneclaw Totem instead?','Can I have a Stoneclaw Totem instead?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40248,'Can I have a Strength of Earth Totem instead?','Can I have a Strength of Earth Totem instead?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40249,'I\'d be glad to help.','I\'d be glad to help.',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(40250,'Can I have an Earth Elemental Totem instead?','Can I have an Earth Elemental Totem instead?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40251,'Anythin\' for Vol\'jin!','Anythin\' for Vol\'jin!',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(40252,'Well you\'re a picky little $r, aren\'t you? Fine. Just go get me that sample.','Well you\'re a picky little $r, aren\'t you? Fine. Just go get me that sample.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40253,'Just point me at de enemy!','Just point me at de enemy!',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(40254,'No. Stop being greedy.','No. Stop being greedy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40255,'I\'m the bleeding edge, baby! Elemental infused technologies. Exploring the depths of Azeroth for lost knowledge and new resources.$B$BRemember the name.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40256,'Mussst ressissst....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40257,'Naga ssshall never ssserve your kind!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40258,'Better to die than to sssubmit...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40259,'You wassste your time with me, sssoftsskin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40260,'Cannot... sstop!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40261,'','For Shandris!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40262,'Move back!  His flames are too intense!','',0,0,0,0,0,0,0,0,1,9469,0,0,26124),
(40263,'Ssso... assshamed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40264,'Can I have a Stoneskin Totem instead?','Can I have a Stoneskin Totem instead?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40265,'','A lot of work goes into training and caring for our animals, but it\'s all worth it.$B$BI could always use a bit of extra help, though.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40266,'Slinky, I need a new mook disguise!','Slinky, I need a new mook disguise!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40267,'Fall back!!!','',0,0,0,0,0,0,0,0,1,9469,0,0,26124),
(40268,'','Sure thing, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40269,'Look out!','',0,0,0,0,0,0,0,0,1,9469,0,0,26124),
(40270,'One down!','',0,0,0,0,0,0,5,0,1,0,20904,0,26124),
(40271,'Another one down! Just look at those light beams! They seem to be connecting to the far door!','',0,0,0,0,0,0,5,0,1,0,20905,0,26124),
(40272,'One more elemental to go! The door is almost open!','',0,0,0,0,0,0,5,0,1,0,20906,0,26124),
(40273,'That\'s it, you\'ve done it! The vault door is opening! Now we can... oh, no!','',0,0,0,0,0,0,5,0,1,0,20907,0,26124),
(40274,'Oh I\'m sorry... did my totem offend your delicate sensibilities? Fine. Here. Now get to work!','Oh I\'m sorry... did my totem offend your delicate sensibilities? Fine. Here. Now get to work!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40275,'Jeeze... would you like me to have Felice give you a massage while you\'re at it? Here, take it. Go get me my sample!','Would you like me to have Felice give you a massage while you\'re at it? Here, take it. Go get me my sample!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40276,'Wait a second... who\'s working for who here? If I give you the new totem, will you just finish the darn task?!','Wait a second... who\'s working for who here? If I give you the new totem, will you just finish the darn task?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40277,'This unit has been activated outside normal operating protocols. Downloading new operational parameters. Download complete. Full unit self defense routines are now active. Destruction of foreign units in the system shall now commence.','',0,0,0,0,0,0,0,0,1,0,20857,0,26124),
(40278,'','The Trade Prince\'s yacht is about to set sail. Everyone, get to the dock! Hand over the keys, boss. I\'m driving. Just let me know when you\'re ready to go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40279,'New troll here!','New troll here!',0,66,0,0,0,0,0,0,1,0,0,0,26124),
(40280,'Reportin\' for duty.','Reportin\' for duty.',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(40281,'Ready to take de fight to Zalazane.','Ready to take de fight to Zalazane.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40282,'Ready to fight beside Vol\'jin!','Ready to fight beside Vol\'jin!',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(40283,'When does de trainin\' start?','When does de trainin\' start?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(40284,'I\'m glad you are here, friend!$B$BThe fires have driven the wildlife to seek shelter in this grove. They can run no farther. We must protect the survivors!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(40285,'Move back!','',0,0,0,0,0,0,0,0,1,9469,0,0,26124),
(40286,'Here it comes, fall back!','',0,0,0,0,0,0,0,0,1,9469,0,0,26124),
(40287,'Get away from him until the fire dies down!','',0,0,0,0,0,0,0,0,1,9469,0,0,26124),
(40288,'','Lady Shandris is counting on me. I will not fail her.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40289,'Heya, $g dude : toots;! The word is that you\'re gunning for the Trade Prince\'s job.$B$BThat true?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40290,'<Gobber mostly grunts. You\'re not even certain that he can talk.>','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40291,'','Hiya, $g babe : hon;! What\'s this I hear about you and $g Candy : Chip;?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40292,'','Nice day for digging up the last known deposits of kaja\'mite in the world, wouldn\'t you say, $n?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40293,'','Isn\'t it weird how kaja\'mite made us smart thousands of years ago, but it doesn\'t seem to be having any effect on our trolls?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(40294,'','Distilling Kaja\'Cola out of kaja\'mite was a stroke of pure genius on your part, $n. The Trade Prince has got to be worried that you\'re going to take his title!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40295,'Witness de power of me voodoo... you ain\'t leavin\' dis island ALIVE!','',0,0,0,0,0,0,396,1,1,0,17597,0,26124),
(40296,'I\'d like to punch that Chip right in the kisser! I\'d also like to kiss that Candy right in the kisser, too!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(40297,'Did someone say, party?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(40298,'This Kaja\'Cola thing\'s got me thinking. Do we really want the competition to have ideas?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(40299,'Distilling the juice out of kaja\'mite to make a delicious, carbonated beverage that will give people IDEAS! Hey, wait a minute...','Distilling the juice out of kaja\'mite to make a delicious, carbonated beverage that will give people IDEAS! Hey, wait a minute...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40300,'We find evil ones now!  Follow!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40301,'They hide this way!  Quick!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40302,'We look for the evil ones now, yes?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40303,'Over here!  You must stop them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40304,'You must fight now, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40305,'Over here, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40306,'Hey, hey! Cease your hostilities! I\'m one of those frequently encountered and completely harmless neutral goblins, not the Horde kind!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40307,'Hey look, it\'s $n. I bet $g he\'s : she\'s; loaded. I hear that $g he\'s : she\'s; going after the Trade Prince\'s job!','Hey look, it\'s $n. I bet $g he\'s : she\'s; loaded. I hear that $g he\'s : she\'s; going after the Trade Prince\'s job!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40308,'Szabo. He\'s so hot right now!','Szabo. He\'s so hot right now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40309,'$n scoops up a squirming bear cub.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(40310,'','I was once a priestess, but I\'ve always been a scholar. The chance to learn from the Highborne seemed more valuable than practicing strict ignorance.$B$BWhat\'s more most of the apprentices here are youths who came of age during the third war. They need guidance, wisdom...$B$BI only wish those who used to call me friend understood.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40311,'','You\'re looking at me...can you see me?$B$BPlease, help...',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(40312,'Work was bettah in da Undermine!','Work was bettah in da Undermine!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40313,'What I doin\' wrong? Don\'t I get a lunch and two breaks a day, mon?','What I doin\' wrong? Don\'t I get a lunch and two breaks a day, mon?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40314,'Ouch! Dat hurt!','Ouch! Dat hurt!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40315,'I report you to HR!','I report you to HR!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40316,'','Help... please, if you can hear me, help...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40317,'','You\'ve been so nice, $n. I\'ve been trapped here so long thanks to Verinias. That young elf was the first soul I\'ve tasted in ages.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40318,'','Even after I gifted him with that form, he insisted on keeping me trapped. He even hoarded all the souls just so I couldn\'t have any...so stubborn.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40319,'','I owe you a favor, darling...someday I\'ll be back to repay it.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40320,'','Dat be enough for now!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(40321,'','Don\'t be lookin\' so surprised. Your shaman friend has sharp eyes, or should I say, sharp frogs.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40322,'','My kind, da druids, we been layin\' low for some time now. We been waitin\' to see when an\' if Vol\'jin might return.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40323,'','Now dat it looks like de Darkspear be returnin\' to these isles, maybe de time has come for us to reveal ourselves.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40324,'','Go back to Vol\'jin an\' tell him dis: Zen\'tabra stands ready to help him in de coming battle.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40325,'It\'s all in ruins...','It\'s all in ruins...',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40326,'The waters rushed in and drowned everything!','The waters rushed in and drowned everything!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(40327,'You have to go to Thousand Needles and help. Please!','You have to go to Thousand Needles and help. Please!',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(40328,'May the Earth Mother preserve us.','May the Earth Mother preserve us.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40329,'Freewind Post is lost. Thousand Needles is destroyed.','Freewind Post is lost. Thousand Needles is destroyed.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40330,'','Securing this area for the Sentinels will be the final part of our defense of Feralas.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40331,'Why did the Earth Mother not protect us?','Why did the Earth Mother not protect us?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(40332,'Chieftain Spirithorn must send help to Freewind Post soon.','Chieftain Spirithorn must send help to Freewind Post soon.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40333,'They\'re calling it the Cataclysm. What caused this destruction? Why us?','They\'re calling it the Cataclysm. What caused this destruction? Why us?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(40334,'','O spirit of de tigers, lend $n your power and help us find de answers we seek!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(40335,'The tiger matriarch appears! Prove yourself in combat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40336,'','Brogg, I beseech you to send some of your goblins to Westreach Summit now, before it is too late.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40337,'I think I\'ve lost a tabard.','I think I\'ve lost a tabard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40338,'','Thousand Needles lies in ruins under hundreds of feet of water. Can you spare any goblins to assist us?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(40339,'','The Cataclysm crumbled the eastern mountains. The South Seas poured in and submerged all of Thousand Needles! Can you aid us in our time of need?',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(40340,'','Please. We are staging a relief effort at Westreach Summit. Thousand Needles has been decimated!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40341,'','I understand that the Cataclysm has struck Dustwallow Marsh as well, but Mudsprocket appears relatively safe. Can you not spare any goblins?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(40342,'','If you cannot send any help to Westreach Summit, may we send refugees here?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(40343,'','I fear that if we do not receive reinforcements in Thousand Needles quickly, the Grimtotem will act. We are in no position to defend ourselves for very long.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40344,'','If the Shu\'halo of Thousand Needles fall, the Grimtotem clan will be at your doorstep soon after. The time for action is now, Brogg!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40345,'You must remain in the Echo Isles, Darkspear Strand, or Sen\'jin Village.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40346,'','Brogg. You don\'t mind me calling you that, right? Wait, which head am I talking to?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(40347,'','We need help from you and your goblins. Thousand Needles is destroyed! Thalanaar is underwater!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(40348,'','Which one of you is in charge? We need help at New Thalanaar now!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(40349,'','You must send us assistance in our time of need. An attack upon New Thalanaar is imminent!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(40350,'','Yes, we can pay.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40351,'','You\'re not with the Gordok or Gordunni tribes, right?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(40352,'','The Cataclysm has struck hardest in Thousand Needles. Please, can you lend us your aid?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40353,'','Bunnies and fawns? Yes, we have those. Will you now come and help us at New Thalanaar? Wait... why do you want to know?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40354,'','The Cataclysm has destroyed the western mountains of Thousand Needles. The South Sea has rushed in and the canyons are flooded.$B$BPlease, $c, you must come to our aid at New Thalanaar!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(40355,'','The Cataclysm has destroyed Thousand Needles, $c. Will you help us in our greatest time of need?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40356,'','Your training has progressed well, sisters. It won\'t be long before you lead your own people, with no further need of my teaching.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40357,'He\'s vulnerable to our magic now! Hold him down!','He\'s vulnerable to our magic now!  Hold him down!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40359,'','It is time for you to show me that leadership. Tambre, you will spearhead the offensive on Sardor Isle. Your ferocity will be needed there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40360,'','Silvia, I\'m sending you to the Tower of Estulan to drive out the Gordunni ogres. Your diplomacy and strategy will both be put to the test.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40361,'','Adella, you will strike out far to the east. Our forces must retake the eastern wilds, and observe the Horde unseen. May your judgment be as keen as your marksmanship.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40362,'Dyslix, I need to get to Westreach Summit!','Dyslix, I need to get to Westreach Summit!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40363,'','I expect much of you. Do not fail me. Dismissed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40364,'Dyslix, I need to get to New Thalanaar!','Dyslix, I need to get to New Thalanaar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40365,'Hm? You found something, boy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40366,'That\'s right, dig it up. Leave no living thing behind!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40367,'What did you find, pig?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40368,'Thata girl! Dig it all up - leave no stone unturned.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40369,'Stupid pig. This ground is already dead. Move on!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40370,'Dig, dig, dig. Burn, burn, burn. Scour this earth clean!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40371,'The %s sniffs and digs into the scorched soil.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40372,'Seyala, I need to get to New Thalanaar!','Seyala, I need to get to New Thalanaar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40373,'Adeline, can you not ask any of your friends to come help us at New Thalanaar?','',0,0,0,0,0,0,6,7,1,0,0,0,26124),
(40374,'Thousand Needles has been swallowed by the South Sea. Thalanaar is submerged!','',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(40375,'The eastern mountains of Thousand Needles crumbled into the waters and the South Sea poured in. All is lost.','',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(40376,'Test','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40377,'The Cataclysm has destroyed Thousand Needles. We need your help so that we can save as many lives as possible!','',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(40378,'Now is the time to prove your allegiance to the Alliance. Please send whatever aid you can to New Thalanaar.','',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(40379,'We have lost Thalanaar, but not by much. We were the fortunate ones to be only at the very edge of the flooding. I cannot begin to imagine how many lives were lost. Please send as much help as you can to New Thalanaar.','',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(40380,'Relatively speaking, Feralas has barely been touched by the Cataclysm. Surely you can send some aid to New Thalanaar?','',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(40381,'We\'re staging a relief effort at New Thalanaar for all of the survivors of Thousand Needles. We need your help now!','',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(40382,'Enough! Have your cave, little shaman.','',0,0,0,0,0,0,0,0,1,0,21858,0,26124),
(40383,'$C, the cataclysm has crumbled the mountains and the South Sea has rushed in to drown Thousand Needles.$B$BWe need your help, now!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40384,'May de spirits guide ya, $c.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40385,'Let us consult the omens.','Let us consult the omens.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40386,'','The Grimtotem attacked us by surprise. We\'re barely hanging on here.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(40387,'Darkspears, we consult de spirits! Drummers, take your places!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(40388,'Spirits, we be gathered here to ask for your guidance.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(40389,'Our leader, Vol\'jin, son of Sen\'jin, issued de call to all Darkspears: reclaim de Echo Isles for our tribe.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40390,'Spirits! I offer me own body to you! Speak through me! Is de time right for mighty Vol\'jin\'s undertaking?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(40391,'De ancestors hear ya, witch doctor!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40392,'Know dat your plans please us, Darkspears. De son of Sen\'jin walks de right path.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40393,'De task in front of ya will not be easy, but ya have our blessin\'.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40394,'Ya gave up your home an\' ya gave up de loas of your ancestors when ya left de Echo Isles. Dey will not be pleased dat you been ignorin\' dem.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40395,'Ya must make amends wit\' Bwonsamdi, de guardian of de dead, if ya hope to defeat Zalazane. It be de only way. Tell de son of Sen\'jin dese things.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40396,'De spirits have blessed us wit\' an answer! De Echo Isles will be ours again!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(40397,'I will not die to save your hide, Twilight dude!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40398,'How could the Grimtotem do this to us in our greatest time of need?','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(40399,'Motega, can I get another Water Explorer?','Motega, can I get another Water Explorer?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40400,'Look at this devastation, $c! Blood and ash, as far as the eye can see.$B$BBut nature is not so easily put down. With some effort, we may yet coax life from this scorched soil.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40401,'','I thought Runetotem reckless to set up camp right in the middle of this devastation, but I wasn\'t about to let the Archdruid travel here alone.$B$BHe\'s planning something. Something big.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(40402,'','These Grimtotem beasts will soon be sent to their maker!',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(40403,'Rendow, can I get a ride with another Water Traveler?','Rendow, can I get a ride with another Water Traveler?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40404,'Warriors of de Darkspear Tribe, our leader, de great Vol\'jin prepares to reclaim de Echo Isles.','',0,0,0,0,0,0,1,0,1,9498,0,0,26124),
(40405,'De battle ahead will be de true test of de warrior\'s skill, de true test of loyalty.','',0,0,0,0,0,0,1,0,1,9498,0,0,26124),
(40406,'We be gatherin\' here, on de shores of Sen\'jin Village, to be takin\' BACK what is ours!','',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(40407,' Come, now! Join in de liberation of de Echo Isles! Zalazane will FALL!','',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(40408,'De spirits of our ancestors will be watchin\' us and aidin\' us in dis battle.','',0,0,0,0,0,0,1,0,1,9498,0,0,26124),
(40409,'Do dem proud! Show dem your bravery and your ferocity! Bring honor to their spirits!','',0,0,0,0,0,0,25,0,1,9498,0,0,26124),
(40410,'An\' most of all, we be showin\' Zalazane dat his time be at an end! Dat he will give back what be rightfully ours!','',0,0,0,0,0,0,5,0,1,9498,0,0,26124),
(40411,'Zalazane got most of his hexed trolls hidden under de canopy on de big island.','Zalazane got most of his hexed trolls hidden under de canopy on de big island.',0,0,0,0,0,0,5,0,1,9498,0,0,26124),
(40412,'He got a big army, an\' he be plannin\' somethin\' down dere.','He got a big army, an\' he be plannin\' somethin\' down dere.',0,0,0,0,0,0,1,0,1,9498,0,0,26124),
(40413,'Thank ya, scout. Keep up da patrols. But for now, a rest is in order. Dismissed.','',0,0,0,0,0,0,5,0,1,9498,0,0,26124),
(40414,'My raptor can take on ANYTHING and ANYONE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40415,'You!  Your mutt killed my Butcher!  I will crush you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40416,'Instructor Devoran sends a contender against your raptor.','Instructor Devoran sends a contender against your raptor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40417,'Run away from the Blazing Trainer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40418,'I have sometin\' to show you. It be easier to understand if ya see it yourself.','',0,0,0,0,0,0,1,0,1,9224,0,0,26124),
(40419,'What do you want, Vol\'jin? I\'m busy planning a war.','',0,0,0,0,0,0,6,0,1,9224,0,0,26124),
(40420,'%s rallies the other combatants with a battle roar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40421,'I\'m tellin\' you, that Coren Direbrew\'s a madman.\n\nIt\'s not MY fault he didn\'t get invited to compete at Brewfest! But that didn\'t stop him and all his Dark Iron cronies from roughin\' up my employees and drinking all my brew.\n\nSomeone\'s got to put an end to this!','',1,5,0,0,2,0,0,0,1,0,0,0,26124),
(40422,'Queue for the Coren Direbrew battle.','Queue for the Coren Direbrew battle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40424,'','The Frost Lord, Ahune, must be stopped.\n\nEven now he is taking form, summoned from his elemental prison by the mad cultists of the Twilight\'s Hammer.\n\nIf he\'s allowed to enter our world completely, he\'ll bury us beneath an eternal winter.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40425,'Queue for The Frost Lord Ahune battle.','Queue for The Frost Lord Ahune battle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40426,'Please... help...\n\nThe Headless Horseman... must be stopped...\n\nHe has slain so many... and yet rides out for more victims with every rising moon!','',20,0,0,0,0,0,0,0,1,0,0,0,26124),
(40427,'Queue for The Headless Horseman battle.','Queue for The Headless Horseman battle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40428,'Someone\'s got to stop the Crown Chemical Co. I\'d bet my gold-plated Nether-Rocket they\'re cooking up the next big plague on the chocolate-crazed citizenry\'s coin...\n\nIf only I could find someone to serve their apothecaries with court papers! Then we could put an end to it... and maybe seize all their assets, while we\'re at it!','',1,5,0,0,3,0,0,0,1,0,0,0,26124),
(40429,'Queue for The Crown Chemical Co. battle.','Queue for The Crown Chemical Co. battle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40430,'Ye\'ve got some stones, $glad:lass;, comin\' in here unannounced.\n\nWhat do ye want?','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(40431,'Insult Coren Direbrew\'s brew.','Insult Coren Direbrew\'s brew.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40432,'What?!  What did ye say?!  How dare ye!  Me beer can stand up to any of that rot they serve at Brewfest!\n\nYou\'ll pay for this insult, $c!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(40433,'Fight.','Fight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40434,'Apologize.','Apologize.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40435,'I need to get to Razor Hill to recruit on behalf of Vol\'jin.  May I borrow a bat?','I need to get to Razor Hill to recruit on behalf of Vol\'jin.  May I borrow a bat?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40436,'I am ready to take back the Echo Isles.  Take me to the staging area!','I am ready to take back the Echo Isles.  Take me to the staging area!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40437,'How DARE you! You will not stop the coming of Lord Ahune!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40438,'The Frostlord... will... destroy you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40439,'This is going to be fascinating!','This is going to be fascinating!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40441,'Welcome to Tinker Town!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40442,'This shard of ice echoes the deep, cracking rumble of invading glaciers.  Its cold turns your thoughts to a lifeless, endless winter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40443,'Disturb the stone and summon Lord Ahune.','Disturb the stone and summon Lord Ahune.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40444,'Vol\'jin kneels at the skull pile and begins a chant.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40445,'Would you call down the Spirit of the Tiger again, Vanira?','Would you call down the Spirit of the Tiger again, Vanira?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40446,'Defend the flameward!','',0,0,0,0,0,0,0,0,1,9510,0,0,26124),
(40447,'Victory! The flameward has been defended.','',0,0,0,0,0,0,0,0,1,9510,0,0,26124),
(40448,'Zalazane\'s time be runnin\' out. De Echo Isles will belong to de Darkspear Tribe again!','',25,1,0,0,0,0,0,0,1,0,0,0,26124),
(40449,'De Darkspears have a home again! An\' we couldn\'t have done it wit\'out ya helpin\', $n. Now, we celebrate!','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(40450,'Dis breach leads to tha plane of water. Tha realm of Neptulon, tha Tidehunter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40451,'Tha naga and de Twilight Cult be workin\' together, and dis be the focus of dey\'re efforts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40452,'Disturbin\' prospects. And there be little we can be doin\' about it witout more men.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40453,'','Fizzle & Pozzik\'s Speedbarge my sweet patootie! I built this thing! Not them, not Razzeric!$B$BIt should be called Jinky\'s Speedbarge!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(40454,'De warriors are finishin\' de job of clearin\' up de rest of Zalazane\'s creations.','De warriors are finishin\' de job of clearin\' up de rest of Zalazane\'s creations.',0,0,0,0,0,0,0,0,1,9496,0,0,26124),
(40455,'Ya should be able to send in de builders anytime now. Dere be a lot of work ahead of dem.','Ya should be able to send in de builders anytime now. Dere be a lot of work ahead of dem.',0,0,0,0,0,0,0,0,1,9496,0,0,26124),
(40456,'Thank ya, scout. Tell de builders dey be needed on de isles. De Darkspears be home again!','',0,0,0,0,0,0,0,0,1,9496,0,0,26124),
(40457,'Warriors of de Darkspear tribe, Vol\'jin, son of Sen\'jin has led us to victory!','',0,0,0,0,0,0,0,0,1,9496,0,0,26124),
(40458,'De bravery and de skill of our warriors be plain for all to see!','',0,0,0,0,0,0,0,0,1,9496,0,0,26124),
(40459,'De ancestors watched your actions wit\' pride, my brothers!','',0,0,0,0,0,0,0,0,1,9496,0,0,26124),
(40460,'Thanks be to de ancestors! Thanks be to de great Bwonsamdi! We all be makin\' offerings in gratitude!','',0,0,0,0,0,0,0,0,1,9496,0,0,26124),
(40461,'Let us not forget de help of our allies, of de members of de Horde who came to help us! Now is de time to be celebratin\' dis great victory together!','',0,0,0,0,0,0,0,0,1,9496,0,0,26124),
(40462,'','It\'s my job to ensure that this whole assault runs like clockwork.$B$BHigh Tinker Mekkatorque is out in the field now, but he\'s scheduled to come back to get some more troops any time now.  $B$BHe\'s never late, so just stick around and he\'ll be here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40463,'','Okay! We\'re running a little behind, but the assaut is SCHEDULED to start in $5071W minutes.$B$BI mean, everything looks ready to go, and the Gyrocopters, Mechanotanks and Infantry are all here.$B$BIt looks like Mekkatorque is waiting on a few more things before the assault begins.  Let\'s hope we start on time or I may lose my job!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40464,'|TInterface\\Icons\\ability_druid_infectedwound.blp:20|t%s rears back for a |cFF01FFE1Shredding Swipe!|r\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40465,'|TInterface\\Icons\\spell_fire_elemental_totem.blp:20|t%s Summons an |cFFFF6F00|Hspell:75218|h[Invocation of Flame]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40466,'','Hurry! You should talk to Mekkatorque! If we don\'t start the assault soon, we\'re going to be late.$B$BAnd my boss HATES it when we\'re late!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(40467,'Defeat! The flameward has been destroyed.','',0,0,0,0,0,0,0,0,1,9510,0,0,26124),
(40468,'|cFFFF2222Bloodthirsty Shark goes into a feeding frenzy!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40469,'Fizzle, Pozzik, Jinky... they all think that they saved us. But it was me! I built the ship!$B$BIt should be called, Razzeric\'s Speedbarge!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(40470,'What?  I\'ll show that pipsqueak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40471,'Vol\'jin told me ta keep hittin\' da drum till he gets back.  If ya be waitin\' for him, he\'d be back soon to take back da Isles.$B$BJust wait here and enjoy da music!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40472,'Vol\'jin be waitin for ya.  You should talk wit him now, my arms are gettin\' tired.$B$BDis echo isle attack betta be startin\' soon. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40473,'Where?!  Where is he?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40474,'Curses!  Who killed the human!?  This is not good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40475,'De Echo Isles attack be startin\' soon!$B$BSit back and relax, dis song will be over in anotha $5071W minutes and then we\'d be going.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40476,'Without pressure in both realms, %s begins to regenerate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40477,'With Cho\'gall\'s leadership and unity among our ranks we will crush all our enemies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40478,'|cFFFF2222Fire Harpoon Gun!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40479,'What\'s going on here?','What\'s going on here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40480,'How do we do that?','How do we do that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40481,'We\'d be gettin\' ready to take back da Echo Isles. Zalazane has been workin\' his voodoo magic for some time, convincing folks dat he be dead and performing ancient dark rituals.$B$BHe knows we\'d be coming, so we have ta make sure we be prepared.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40482,'We require da help of allies on da islands.$B$BZen\'tabra has been watching over da animals of de Islands for some time now.  We\'d need her help and da help of da animal creatures.$B$BBwonsamdi is a powerful loa dat controls de spirits of de dead on da islands.  His blessing is crucial for our attack.$B$BOnce our allies have joined us, Zalazane and his army of mind-controlled trolls will have no chance!  Then, da Echo Isles will be de Darkspears!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40483,'%s is distracted by the odor of fresh meat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40484,'Stand still! Rom\'ogg crack your skulls!','',0,0,0,0,0,0,0,0,1,0,18927,0,26124),
(40485,'These are definitely the ones that raided our boats, but I don\'t see any of our missing people. Where did they take them?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40486,'$n!','$n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40487,'BAR FIGHT!','BAR FIGHT!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40488,'$n!','$n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40489,'Thank ya for aidin\' us in our battle.','Thank ya for aidin\' us in our battle.',0,0,0,0,0,0,1,0,1,9496,0,0,26124),
(40490,'Wit\'out your help, ancestors, we would still be fearin\' Zalazane.','Wit\'out your help, ancestors, we would still be fearin\' Zalazane.',0,0,0,0,0,0,5,0,1,9496,0,0,26124),
(40491,'May de spirits of de dead continue to watch over us.','May de spirits of de dead continue to watch over us.',0,0,0,0,0,0,1,0,1,9496,0,0,26124),
(40492,'Thank ya for your guidance, spirits.','Thank ya for your guidance, spirits.',0,0,0,0,0,0,1,0,1,9496,0,0,26124),
(40493,'Guide dose who died in dis battle, Bwonsamdi.','Guide dose who died in dis battle, Bwonsamdi.',0,0,0,0,0,0,5,0,1,9496,0,0,26124),
(40494,'It is a poor offerin\' but I be givin\' it in thanks for your help.','It is a poor offerin\' but I be givin\' it in thanks for your help.',0,0,0,0,0,0,1,0,1,9496,0,0,26124),
(40495,'Ah, so you\'ve left your hole?  The Lady will claim you soon enough.','',0,0,0,0,0,0,0,0,1,0,21855,0,26124),
(40496,'I\'d appreciate if someone started to take my work seriously. Just because I\'m not wrestling sharks or tying eels in knots doesn\'t mean this isn\'t important.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40497,'','Break it up! The Brute Squad is coming!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40498,'%s roars in fury!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40499,'%s is angry - run for it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40500,'<The ancient\'s eyes are vast and deep.>$B$B<The creature speaks slowly, in a language you do not understand. Chills run up your spine. You\'re overwhelmed with feelings of terror and confusion.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40501,'<The ancient\'s eyes open slowly, revealing deep pools of pain and fear.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40502,'','Hey, come on in out of the sun.$B$BCan I get you a drink? Not like I have anything else to do around here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40503,'Good work!\n','Good work!\n',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(40504,'Good!\n','Good!\n',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(40505,'Excellent!\n','Excellent!\n',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(40506,'Unshakable!\n','Unshakable!\n',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(40507,'Smooth moves!\n','Smooth moves!\n',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(40508,'Redeem Battleground Marks for Honor.','Redeem Battleground Marks for Honor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40509,'Disabling','Disabling',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40510,'No - No! This one is ours...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40511,'The master\'s grasp is not so easily severed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40512,'Wretched... bag of ... flesh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40513,'Mortal! You overreach.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40514,'The master will not suffer this insult!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40515,'<The ancient\'s enormous dark eyes peer at you distrustfully.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40516,'If you ask me, I think my brother should do something about all of these goblins! It\'s said that one of them set off the Cataclysm with a footbomb!$B$BWe need to get rid of all of them before it\'s really too late!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40517,'Jinky, can I get another Speedbarge Diving Helm?','Jinky, can I get another Speedbarge Diving Helm?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40518,'','Oh yeah, I got a million spares just hanging around.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(40519,'Have you seen my river boat? I can\'t find it anywhere!','Have you seen my river boat? I can\'t find it anywhere!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40520,'Sure thing, $g pal : gal;!','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(40521,'We wouldn\'t be in this mess if it weren\'t for the gnomes!$B$BIt\'s a well-known fact that they were the ones that caused the Cataclysm with all of their world-enlarging devices, and other such nonsense!','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(40522,'Mama?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40523,'It\'s all I can do to keep this ship from tearing itself apart and I still have to deal with puffed up baffoons like Fizzle here!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40524,'I tell ya this guy\'s driving me nuts! Does anyone truly believe that a goblin could help run anything so magnificent as this speedbarge?$B$BAll they know how to do is blow stuff up and half of the time, they take themselves out doing even that!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40525,'Monsters! Monsters come to take our gold!','Monsters! Monsters come to take our gold!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40526,'Where did we land that has such hideous creatures?!','Where did we land that has such hideous creatures?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40527,'Aaaaaaaaaahhh! AAAAAAAAAAAHHHHHH!!','Aaaaaaaaaahhh! AAAAAAAAAAAHHHHHH!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40528,'Kill the pig! Spill its blood!!','Kill the pig! Spill its blood!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40529,'Protect the wise one! Protect Meatface!','Protect the wise one! Protect Meatface!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40530,'You\'ll never take me alive!','You\'ll never take me alive!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40531,'You must remain inside Darkwhisper Gorge and its surrounding areas!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40535,'You are straying from the events of the past. Turn around immediately.','You are straying from the events of the past. Turn around immediately.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40536,'','The paperwork\'s ready for you to sign, Marin. My people are just waiting on your decision.',0,0,0,0,0,0,1,0,1,9518,0,0,26124),
(40537,'','Gosh, Mr. Noggenfogger, I know you wouldn\'t want to damage your reputation as a neutral trade entity by forming closer ties to the Horde!',0,0,0,0,0,0,1,0,1,9518,0,0,26124),
(40538,'','This is laughable. You know what it\'s like trying to do business with gnomes.',0,0,0,0,0,0,274,0,1,9518,0,0,26124),
(40539,'','Oh, oh, I know this one! It\'s better than doing business with failed goblins that had to beg others for help!',0,0,0,0,0,0,4,0,1,9518,0,0,26124),
(40540,'','Why you little irradiated...',0,0,0,0,0,0,5,0,1,9518,0,0,26124),
(40541,'AGH! Enough! You two are driving me INSANE! Start getting some freakin\' work done around here or get the heck out of my town!','',0,0,0,0,0,0,274,0,1,9518,0,0,26124),
(40542,'Stop, thief!','Stop, thief!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40543,'Ah, $n! A little bird told me you would be coming.$B$BThat\'s how Aviana sends messages around.','',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(40544,'Smoke and ash. If the heat doesn\'t kill me, I may suffocate.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(40545,'Harken, cur! Tis you I spurn! Now feel... the burn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40546,'Your body lies beaten, battered and broken! Let my curse be your own, fate has spoken!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40547,'I owe you a debt that I can never repay, $n. Or, can\'t I?$B$BHmm?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(40548,'Listen, $n, I hate being indebted to anyone. So can you make sure to keep this on the down-low, just between the two of us?$B$BI\'d hate for my creditors to find out.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(40549,'The drag master escapes from the outhouse and gestures wildly up at the speedbarge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40550,'Rugfizzle escapes from the outhouse and gestures wildly up at the speedbarge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40551,'To the depths with you, beast!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(40552,'What you want, $r?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40553,'Yeah?  What\'s the matter?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40554,'Boss, one of the boys is causing some trouble outside.','Boss, one of the boys is causing some trouble outside.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40555,'I\'ve got a bad feeling about this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40556,'Hold on, $r!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(40557,'Press Flap to Flap Your Wings!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40558,'Wave One:','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40559,'Prepare to Joust, Buzzard Bait!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40560,'Load those cannons, ye wretches!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40561,'If any of you dogs stops for so much as to scratch your nose, I\'ll take off the hand you did it with!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40562,'Move it! MOVE IT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40563,'You rats call that cannoneering? You make me sick!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40564,'You scurvy dogs make yourselves useful! KEEP FIRING!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40565,'','Gus... you gotta... get me one of them gnome medics...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40566,'Chelsea, baby, that\'s crazy talk! You\'re delirious! Just hold on a while longer...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40567,'','There you go, Mister Noggenfogger! You won\'t have to worry about those giants anymore!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40568,'That\'s actually a load off my plate. Thanks, kid.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40569,'','Tch. Amateurs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40570,'','See, Marin? We\'ve got you covered, babe. No sweat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40571,'I must admit I like what I\'m seeing, Ms. Dreadshredder.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40572,'','Gosh, Miss Megs, maybe next time you can actually do some work!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40573,'That be property \'o the Southsea Freebooters now, landlubber!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40574,'Ye\'ll not get around our blockade with scavengin\'!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40575,'The Southsea Freebooters own this shore!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40576,'Thank you, $r.$b$bYou saved me from certain death.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(40577,'Did you see the size of that thing!?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(40578,'I owe you, $c.$b$bThought I was a gonner.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(40579,'How are we going to get out of here?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(40580,'If it\'s my time to die, I\'m going to go down swinging!','',23,0,0,0,0,0,0,0,1,0,0,0,26124),
(40581,'It\'s just a matter of time before the naga find us here.$b$bWhat will we fight them with?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(40582,'It\'s a good thing the captain made it through. He\'ll know how to get us out of this mess.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(40583,'RAAAAAAAAAAHHHHHHGGGGHHH!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40584,'Meat! MEAT! Hahahahaha!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40585,'So much blood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40586,'I am GIANT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40587,'We must get the parts Driz wants. THE REST IS OURS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40588,'The red thing\'s connected to the... squiggly thing... the squiggly thing\'s connected to my... wristband...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40589,'How exhilirating!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40590,'How exhilirating!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40591,'You will find a pair of draenei conversing with Elissa Dumas - the human mage who minds the magical portals - on the ground floor of The Temple of the Moon.$B$BThey will know how to help you.','You will find a pair of draenei conversing with Elissa Dumas - the human mage who minds the magical portals - on the ground floor of The Temple of the Moon.$B$BThey will know how to help you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40592,'Bring on the naga! I\'m hungry for battle!','',71,0,0,0,0,0,0,0,1,0,0,0,26124),
(40593,'At least now we have a fighting chance, thanks to you.','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(40594,'I may fall, but I\'ll take a dozen of those beasts with me!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(40595,'Time for revenge!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(40596,'You\'ve done well, $c.$b$bMy men and I are now prepared to face the enemy.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(40597,'The naga must pay for what they\'ve done here!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(40598,'','Help! I am trapped within this tree!  I require aid!',0,0,0,0,0,0,5,0,1,0,0,17490,26124),
(40599,'','Thank you! I could not have held out for much longer.... A terrible thing has happened here.',0,0,0,0,0,0,5,0,1,0,0,17491,26124),
(40600,'','We believed the Sanctum was well-fortified, but we were not prepared for the nature of this assault.',0,0,0,0,0,0,1,0,1,0,0,17492,26124),
(40601,'','The Black dragonkin materialized from thin air, and set upon us before we could react.',0,0,0,0,0,0,1,0,1,0,0,17493,26124),
(40602,'','We did not stand a chance. As my brethren perished around me, I managed to retreat here and bar the entrance.',0,0,0,0,0,0,1,0,1,0,0,17494,26124),
(40603,'','They slaughtered us with cold efficiency, but the true focus of their interest seemed to be the eggs kept here in the Sanctum.',0,0,0,0,0,0,1,0,1,0,0,17495,26124),
(40604,'','The commander of the forces on the ground here is a cruel brute named Zarithrian, but I fear there are greater powers at work.',0,0,0,0,0,0,1,0,1,0,0,17496,26124),
(40605,'','In their initial assault, I caught a glimpse of their true leader, a fearsome full-grown twilight dragon.',0,0,0,0,0,0,1,0,1,0,0,17497,26124),
(40606,'','I know not the extent of their plans, heroes, but I know this:  They cannot be allowed to succeed!',0,0,0,0,0,0,5,0,1,0,0,17498,26124),
(40607,'I sssaw you leaving that ssship, sssoftsskin! Sssoon we sshall have you all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40608,'Captain! The naga! They\'ve followed $n back to the ship!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40609,'|TInterface\\Icons\\spell_shadow_shadowfury.blp:20|t%s begins to cast |cFFA043E7|Hspell:75694|h[Shadow Gale]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40610,'|TInterface\\Icons\\spell_shadow_sacrificialshield.blp:20|t%s begins to cast |cFF006EFD|Hspell:75809|h[Shield of Nightmares]|h|r on the |cFF006EFDFaceless Corruptor!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40611,'Sssoftsskinss! Sssoon you shall ssserve my Lady!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40612,'Come, suffering... enter, chaos!','',0,0,0,0,0,0,0,0,1,0,18646,0,26124),
(40613,'%s begins to cast |cFFFF0000Oblivion!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40614,'Your power wanes, ancient one.... Soon you will join your friends.','',0,0,0,0,0,0,0,0,1,0,17525,0,26124),
(40616,'Die, beast!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(40617,'We be meetin\' again so soon...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40618,'We\'ve been discovered... Hurry $n, there\'s little time!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(40619,'','You always secretly thought I looked fat!',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(40620,'','I spent most of your money on getting a decent massage, goodness knows you could never do it right!',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(40621,'','You never tried to get anywhere. I\'m so glad I finally found a real goblin who can satisfy my shopping needs.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40622,'You gotta help me! My poor, poor Chelsea...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40623,'','I\'ve met cabin boys who were manlier than you. To think I ever wasted my time...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40624,'','You told him I was fat behind my back, didn\'t you?!',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(40625,'','You\'re just jealous I found a man with skills AND a fat wallet.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(40626,'','You can never replace me. Chip will never stoop to dating someone who makes a brute look attractive!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40627,'','How can you even go OUT like that? What, did you just wash up on a beach somewhere?!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40628,'To battle, men!','',396,0,0,0,0,0,53,0,1,0,0,0,26124),
(40629,'The lasher is not fit for mortal hands!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40630,'For Stormwind!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(40631,'Here we go, this should do it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40632,'Chelsea, baby, please drink this. It\'ll make you feel better.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40633,'','Hmm? Okay...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40634,'','What is this? Tastes kinda... urrrrrgh... I\'m gonna lay back down now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40635,'Chelsea, baby, sit up! I\'ve got it! This is gonna cure you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40636,'','Urgh. Gus, I ain\'t drinking that, I can smell it from here. Just lemme sleep the food poisoning off, okay?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40637,'...food poisoning? Wait, you mean those basilisk steaks? That\'s all it is?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40638,'Nothing, honey. I\'m just glad you\'re okay...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40639,'','Blech! Don\'t even say it. Of course it was, those were so undercooked...what\'d you think poisoned me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40640,'Reinforce the front! We are being invaded!','',0,0,0,0,0,0,0,0,1,0,18536,0,26124),
(40641,'Alright i\'m sweating now, Twilight\'s Hammer get in here and defend me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40642,'Cover the rear! Alexstrasza\'s brood decimate our ranks!','',0,0,0,0,0,0,0,0,1,0,18537,0,26124),
(40643,'On second thought, Drahga may need help after all! Fall in!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40644,'You\'re going to put out the fires and stop those pirates from boarding us, right?','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(40645,'Get me into my boat, Griznak.','Get me into my boat, Griznak.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40646,'Oh gosh! Oh golly! You\'re gonna put out the fires and stop those pirates from getting on the Speedbarge, right?!!','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(40647,'Get me into my boat, Mazzer.','Get me into my boat, Mazzer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40648,'That was a close one, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40649,'Hi there! Welcome to Fizzle & Pozzik\'s Speedbarge.$B$BWe have everything there is under the sky and over the deeps.','',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(40650,'Pirates and centaurs and Grimtotem, oh my!$B$BAnd I think I saw something big fly overhead last night. It was so big it blocked out the moon!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40651,'Don\'t worry - I\'ve got you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40652,'Be more careful out there, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40653,'Welcome to Fizzle & Pozzik\'s Speedbarge. You\'ll find just about anything you\'re looking for here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40654,'It\'s okay $n - you\'re safe now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40655,'Caught you in the nick of time, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40656,'We may be surrounded by all sorts of nasties here, but at least we\'re out over the open water.$B$BThat won\'t protect us from whatever it was that I saw fly over last night, though. It was big... I mean, really big!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40657,'Dedicated to those that fell to the Scourge during the war in the frozen wastes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40658,'See the fall of the Lich King.','See the fall of the Lich King.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40659,'I\'m doing Chain Lightning!! pew pew...','',396,0,0,0,0,0,0,0,1,9545,0,0,26124),
(40660,'Hold your ground, soldiers! Here they come!','',396,0,0,0,0,0,0,0,1,9545,0,0,26124),
(40661,'There are too many! Shaman, do something!','',396,0,0,0,0,0,0,0,1,9545,0,0,26124),
(40662,'Rest while you can, men. That wasn\'t the last of them....','',396,0,0,0,0,0,0,0,1,9545,0,0,26124),
(40663,'','Hello, $c!$B$BThese poor creatures are giving everything they have to fight the minions of the Twilight\'s Hammer in this dark place.$B$BI\'ve done my best to revive those that have fallen.$B$BIf you need an additional mount, these birds are ready to take wing again. Treat them well!',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(40664,'Wave Two:','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40665,'The sky is falling!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40666,'Egg Wave:','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40667,'Destroy the Firelands Eggs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40668,'','You\'ve gotten in my way one too many times, gnome.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40669,'','You have fully depleted my patience as well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40670,'','There isn\'t room in this town for both of us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40671,'','I will attempt to not take undue pleasure in utterly destroying you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40672,'','BRING IT, PIPSQUEAK!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40673,'And that\'s that, folks! This conflict\'s been settled the proper way, with VIOLENCE! Let\'s hear it for our contestants!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40674,'','I\'m not through with you yet!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40675,'','Fine! You win! I\'m shrewd, not crazy...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40676,'Brace yourselves, men!','',396,0,0,0,0,0,0,0,1,9545,0,0,26124),
(40677,'Stay alert! Don\'t let them drag you away!','',396,0,0,0,0,0,0,0,1,9545,0,0,26124),
(40678,'','Urk... no...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40679,'What the... disgusting!','What the... disgusting!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40680,'Oh come on. As if I haven\'t been through enough.','Oh come on. As if I haven\'t been through enough.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40681,'I don\'t want to be ungrateful, but was that absolutely necessary?','I don\'t want to be ungrateful, but was that absolutely necessary?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40682,'Hexascrub, right?  Of course.','Hexascrub, right?  Of course.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40683,'Thanks... I think.','Thanks... I think.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40684,'Do I want to know where this stuff is from?','Do I want to know where this stuff is from?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40685,'A fish?  For me?  It\'s adorable.','A fish?  For me?  It\'s adorable.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40686,'This will make me feel a tad safer from those murlocs.  Thank you.','This will make me feel a tad safer from those murlocs.  Thank you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40687,'','You can be sure to tell Gallywix not to underestimate Gnomeregan anymore.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40688,'','Until next time, Megs. Don\'t forget today\'s lesson.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40689,'Open up! I\'ve got a message for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40690,'Hey! Cho\'gall said you had information for me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40691,'Hey! Let me in, or you-know-who will hear about this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40692,'No! Ahhhhh.....','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(40693,'A Ravenous Oceanic Broadhead has caught the scent of your clams.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40694,'Gah... heeelp!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(40695,'My men - they\'re all taken... Go! Save youselves!','',396,0,0,0,0,0,0,0,1,9545,0,0,26124),
(40696,'A healthy one! My Lady will be mosst pleased...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40697,'You shall sssserve the Lady for the resst of your daysss!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40698,'None essscape!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40699,'Come, sssoftsskin. We have work for you to do!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40700,'Your laborss sshall be an offering to the Lady...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40701,'You ssserve or you die, sssoftsskin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40702,'You cannot hide, breather!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40703,'Sshe will find you....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40704,'Make them pay!','',396,0,0,0,0,0,0,0,1,9545,0,0,26124),
(40705,'Don\'t give up! Fight! Fight for the Alliance!','',396,0,0,0,0,0,0,0,1,9545,0,0,26124),
(40706,'Their numbers are... endless...','',396,0,0,0,0,0,0,0,1,9545,0,0,26124),
(40707,'What a fine ssspecimen you are.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40708,'My Lady will be mosst grateful for my effortsss.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40709,'Your willingnesss to obey ssshall determine the length of your life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40710,'We were most fortunate to escape, $n. Follow me.','',396,0,0,0,0,0,0,0,1,9545,0,0,26124),
(40711,'*ksssshk* ...no profit down here! These bugs are *kssssshhhk* nothing to eat *khhhhshhk* going to punch this gnome if he keeps *kssssssssssssssssshhhhk*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40712,'Affirmative, stalker, we are Oscar Mike! Repeat, we are Oscar Mike!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40713,'','And now all your goblin friends are safe and happy again and there\'s no more pirates to blow up your ships!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40714,'','Well gosh, I\'m so flattered! I\'d love to! You hang on just a giggle, now...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40715,'','All units cleared for deployment. Execute scenario delta. Casualties not a concern.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40716,'I\'ve never seen a gnome clean house like that, kid. I could use someone like you to take care of the rest of those pirates, permanently.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40717,'','Oh no you don\'t. I\'m two steps ahead of you, squirt. We\'ll see who razes Lost Rigger Cove first.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40718,'The terrified bear cub refuses to leave the tree!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(40719,'Stupid Gronn, you\'ll obey us or... or... well you better!','Stupid Gronn, you\'ll obey us or... or... well you better!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40720,'I\'m about fed up with you! Don\'t make me get Forgemaster Throngus over here!','I\'m about fed up with you! Don\'t make me get Forgemaster Throngus over here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40721,'You will move that Elemenitum whether you like it or not!','You will move that Elemenitum whether you like it or not!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40722,'Keep it down back there or you\'ll join your friends!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40723,'Sniveling cowards! Hellscream\'s Horde will leave all of your brothers and sisters to a similar fate!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40724,'Pitiful little creatures! Thundrak will show you no mercy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40725,'Toss your refuse and fecal matter in the back so these gnomes have some company!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40726,'Shut your quivering yaps or I\'ll feed you to the wolves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40727,'P-p-p-lease don\'t hurt us m-m-m-ister Painmaster, sir!','P-p-p-lease don\'t hurt us m-m-m-ister Painmaster, sir!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40728,'Calm yaself. Let yaself get lost in tha flames.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40729,'Be wary, allies. There are bound to be traps to protect the Firelord from our incursion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40730,'I am ready to begin the battle against Ragnaros.','I am ready to begin the battle against Ragnaros.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40731,'','Hi there, $g handsome : gorgeous;. Welcome to the Speedbarge Bar.$B$BWhat\'ll it be?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(40732,'What drinks do you have?','What drinks do you have?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40733,'','Greetings, $c.  I hope you find your accomodations suitable, even in this time of war.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40734,'','$n, please stop those pirates before they destroy the Speedbarge!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(40735,'I\'ll take care of the pirates. But first, maybe some liquid courage.','I\'ll take care of the pirates. But first, maybe some liquid courage.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40736,'Once Hamuul and Malfurion arrive, we shall begin...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40737,'We are ready, Cenarius.','',0,0,0,0,0,0,0,0,1,0,20805,0,26124),
(40738,'We shall face the Firelord and drive every ember of his being out of our realm!','',0,0,0,0,0,0,0,0,1,0,21639,0,26124),
(40739,'Use the Leave Vehicle button to quickly get back onto the Speedbarge.','Use the Leave Vehicle button to quickly get back onto the Speedbarge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(40740,'I shall call upon the chilling mountain winds to protect us from Ragnaros\' flame. Malfurion and Hamuul will shatter the Firelord\'s defenses, allowing us to force him back.','',0,0,0,0,0,0,0,0,1,0,21641,0,26124),
(40741,'Let us begin.  It is only a matter of time before the Firelord becomes aware of our presence and comes to the spire\'s defense.','',0,0,0,0,0,0,0,0,1,0,21642,0,26124),
(40742,'WHO DARES TO DEFILE THE HALLS OF LIVING FLAME? I SHALL SEAR YOUR ESSENCE FROM YOUR FLESH!','',0,0,0,0,0,0,0,0,1,0,22574,0,26124),
(40743,'Quickly, everyone move into position! Force him back into the Firelands!','',0,0,0,0,0,0,0,0,1,0,21640,0,26124),
(40744,'Take me to Smuggler\'s Scar.','Take me to Smuggler\'s Scar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40745,'Take me to Silver Tide Hollow.','Take me to Silver Tide Hollow.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40746,'|TInterface\\Icons\\ability_dualwield.blp:20|t%s equips his |cFFFF0000Swords|r and gains |cFFFF0000|Hspell:74981|h[Dual Blades]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40747,'|TInterface\\Icons\\inv_shield_76.blp:20|t%s equips his |cFFFF0000Shield|r and gains |cFFFF0000|Hspell:74908|h[Personal Phalanx]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40748,'Return to Thousand Needles or lose your River Boat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40749,'The forces we are up against here go beyond the Twilight\'s Hammer, Ragnaros or even Deathwing.  We must succeed here if our world is going to survive at all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40750,'Hyjal is lost!  Give up!','',0,0,0,0,0,0,0,0,1,0,20957,0,26124),
(40751,'No prison will hold me, fool!','',0,0,0,0,0,0,0,0,1,0,20958,0,26124),
(40752,'The corruption is everywhere!  You cannot succeed!','',0,0,0,0,0,0,0,0,1,0,20959,0,26124),
(40753,'','I fear for Alysra\'s fate.  Fandral\'s corruption ran deeper than anything I encountered in the nightmare.  Yet we can\'t afford to dwell on this.',0,0,0,0,0,0,0,0,1,0,0,20779,26124),
(40754,'','During my stay in the dream I made a vital discovery. The rift that weakens the boundaries of this world has hastened the return of powerful allies.',0,0,0,0,0,0,0,0,1,0,0,20780,26124),
(40755,'','The Ancient Guardians are coming back.  Cenarius, Aviana, Goldrinn... I can feel their presence.  We must make sure we usher them into this world.  Their timely aid will be indispensable.',0,0,0,0,0,0,0,0,1,0,0,20781,26124),
(40756,'','Rudimentary analysis suggests... that I am unable to continue.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40757,'','You gave it a good shot, kid. But this is goblin turf now. I suggest you get used to it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40758,'','Ciao, babe. Let me know if you\'d like to do lunch sometime. We\'ll work something out now that you\'ve learned some manners.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40759,'An Azsh\'ir Monitor has spotted you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40760,'An Azsh\'ir Monitor calls for help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40761,'Wants to kill us does it?  Wants to know our secrets...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40762,'We must destroys it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40763,'We burns it, we burns! Bring fire, yes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40764,'Come winds, whisper whisper... Blows it, blows it, blows it away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40765,'We ... crushes it! Must ... make crush. Hurry friends!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40766,'It mustn\'t know... it mustn\'t learn... what\'s ours...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40767,'','The odds appear to be against us, but we cannot falter, $n.  We are all that stands between the enemy\'s hordes and Nordrassil.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40768,'','I...I\'m running out of breath... I must turn back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40769,'','Come inside, $r. I must repay your kindness.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(40770,'','Please, $r.$b$bI don\'t know how much longer I can make it here...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40771,'Follow me! I\'ll lead you to Smuggler\'s Scar.','Follow me! I\'ll lead you to Smuggler\'s Scar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40772,'Ready, aim... FIRE!','Ready, aim... FIRE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40773,'Wizzle, you idiot! Everything would have been fine if you\'d just kept your mouth shut!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(40774,'Someone get me out of this cage!!!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(40775,'I\'m going to throttle you as soon as I get out of here, Wizzle!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(40776,'I had a good thing going here. Was going to sell these pirates a bunch of rifles and make a fortune! But no! Wizzle had to tag along and try to sell them his cheap engineering parts. Blew up a few of their cannons and my rifles in the process! We\'re doomed!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(40777,'','Oh, thank you!',71,0,0,0,0,0,0,0,1,0,0,0,26124),
(40778,'Who\'s there? Let me out! Let me out before these stinking pirates decide to put me on a spit and make green eggs and ham from me!','',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(40779,'On behalf of the Bilgewater Cartel, allow me to offer a very generous reward to the first person that gets me free of this cage! Of course, standard contractual stipulations apply, but don\'t worry about the fine print. Just get me out of here!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40780,'Hey, you pirates?! Come on now, stop kidding around. Let me out of here and I\'ll get you all a brand new delivery of rifles just as soon as I can get them from the Speedbarge!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(40781,'Would someone please do something about those cannons? I can\'t think straight here!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(40782,'Synge, I can\'t believe you got us into this mess, you stupid goblin!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(40783,'%s calls forth creatures from elsewhere in the Firelands.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40784,'Oh my goodness! Oh my goodness! Someone get me out of here! I have claustro.. claustro... claustro.. er, a fear of being trapped in a cage!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(40785,'%s calls forth creatures from Skywall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40786,'%s calls forth creatures from the heart of Deepholm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40787,'Hey you, over there! Please, please, please, get me out of this cage!','',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(40788,'I\'m making a list of all of the things that I can transform you into with my Super Adaptive Transformative Shape Changing Ray, Synge! I hope that you end up as something completely useless to match your pathetic life.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40789,'Pirate friends, listen. I\'m not with this Synge character. Let me assure you that if you let me out of this cage, I\'ll be the best engineer you\'ve ever had. I mean, really, have you seen the accuracy of your cannons? So close, yet soooooo far away!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40790,'Who wants to let an innocent gnome out of a cage? Come on now. How often do you get an offer like that?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(40791,'Synge, I\'m going to slap you around some, and then some more! Just watch. I\'m going to get out of this cage and then gloat and laugh at you!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(40792,'Um, pirates, my brothers are going to be very worried about me going missing. Maybe you could let me go? Rizzle has a drinking problem and Fizzle has a problem with his blood pressure!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40793,'Did you see that?','Did you see that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40794,'Alright!','Alright!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40795,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40796,'Bullseye!','Bullseye!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40797,'','Magic is a tool, some would even say a gift. But you should never forget its fundamental nature.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40798,'','Arcane magic twists the boundaries of our world. It weakens the laws of this realm to allow the impossible to happen, if only for a moment.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40799,'','That single moment is all a demon needs to wreak havoc. The Burning Legion has watched us for millennia, always waiting for the smallest rift to slip through, the smallest stirring to whisper from.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40800,'','Remember this, young ones. Every spell you cast, no matter how minor, cuts both ways. This is why sorcery must never be used frivolously.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40802,'','The Twilight\'s Hammer is more than an organization to me.  It\'s a family.$B$BAs such, I take great care in making sure no unworthy candidates make it past the training phase.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40803,'I need to find a safe place soon.$b$bOl\' Mack\'s not doin\' so well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40804,'Make for that cave to the west. It\'s safe and dry.','Make for that cave to the west. It\'s safe and dry.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40805,'I can\'t take it, man! I\'m freakin\' out here!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(40806,'What\'s going on?! We need to act NOW! NOW I SAY!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(40807,'We\'re wastin\' time here, professor! The orcs are slaughtering us!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(40808,'I didn\'t sign up for this garbage! I coulda been back helping Mekkatorque reclaim Gnomeregan!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(40809,'You vorry too much, Gnombuz. Zettle yourzelf down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40810,'Zis iz ridiculous! Ve vill go vhen ve are rezy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40811,'You are making ze night elvez nervouz, Gnombuz!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40812,'Keep it up, boys!  We\'ve got work to do!','Keep it up, boys!  We\'ve got work to do!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40813,'','Your aid is required, $n. Help us stop the brutish Horde!',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(40814,'PAIN is all that you will find here, $r!','',0,0,0,0,0,0,0,0,1,9567,0,0,26124),
(40815,'Thanks, friend. We owe ya one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40816,'Hang in there, Mack...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40817,'I thought I\'d been left behind for sure.  Thanks for coming back for me!','I thought I\'d been left behind for sure.  Thanks for coming back for me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40818,'Thank you, stranger! We\'re free!','Thank you, stranger! We\'re free!',0,0,0,0,0,0,0,0,1,9567,0,0,26124),
(40819,'HOORAY! HOORAY!','HOORAY! HOORAY!',0,0,0,0,0,0,0,0,1,9567,0,0,26124),
(40820,'Yippee! We\'re saved!','Yippee! We\'re saved!',0,0,0,0,0,0,0,0,1,9567,0,0,26124),
(40821,'You\'re a life saver, $c.','You\'re a life saver, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40822,'I owe you.  Big time.','I owe you.  Big time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40823,'I won\'t forget this.  Thank you.','I won\'t forget this.  Thank you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40824,'I\'m going to name my firstborn $n.','I\'m going to name my firstborn $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40825,'How many times is that that you\'ve saved me today?  I lost count.','How many times is that that you\'ve saved me today?  I lost count.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40826,'None left behind, eh?  You\'re a stand-up $r.','None left behind, eh?  You\'re a stand-up $r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40827,'I could kiss you.  I\'ll spare you the shell-breath though.','I could kiss you.  I\'ll spare you the shell-breath though.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40828,'%s howls in fury as he is doused by water!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40829,'I\'ll get you, mortal! And your little wolves, too!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40830,'It ... burns!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40831,'This <glub> is not over yet, mortal...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40832,'How? What is this trickery?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40833,'Water! Here!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40834,'Aiiieeee!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40835,'You infuriate me, mortal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40836,'FACE ME, INSECTS. I SHALL CRUSH YOU FIRSTHAND!','',0,0,0,0,0,0,0,0,1,0,22575,0,26124),
(40837,'YOUR FAILURE TODAY MORTALS HERALDS THE END OF YOUR WORLD. MY CHILDREN USHER IN A NEW ERA, RULED  BY THE FLAME!','',0,0,0,0,0,0,0,0,1,0,22580,0,26124),
(40838,'I need an overseer over here, NOW!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40839,'Look at this blade thrower.  The pride of the orcs... HAH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40840,'Overseer!  Tell me what you see.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40841,'Wrong!  Come with me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40842,'Defeat the fire elementals attacking %s!','',0,0,0,0,0,0,0,0,1,10699,0,0,26124),
(40843,'A... a blade thrower, sir.','A... a blade thrower, sir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40844,'Impurity! Your fragile flesh defiles my work.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40845,'Defeat the fire elementals attacking %s!','',0,0,0,0,0,0,0,0,1,10700,0,0,26124),
(40846,'%s has fallen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40847,'%s has recovered and resumes fighting!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40848,'%s has fallen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40849,'%s has recovered and resumes fighting!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40850,'Thonk is waiting for you at the top of the tower, $c.','Thonk is waiting for you at the top of the tower, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40851,'Do these blades look sharp to you?  DO THEY, OVERSEER?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40852,'ASSIST ME, MY CHILDREN!','',0,0,0,0,0,0,0,0,1,0,22578,0,26124),
(40853,'BURN THEIR FLESH AND SEAR THEIR BONES!','',0,0,0,0,0,0,0,0,1,0,22579,0,26124),
(40854,'YOU HAVE ONLY DELAYED THE INEVITABLE, CENARIUS. FROM THE FIRELANDS SHALL MY ARMIES BE REBORN...','',0,0,0,0,0,0,0,0,1,0,22581,0,26124),
(40855,'What in blazes do you orcs think you\'re doing?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40856,'Fishing poles... you fish like tuskarr.  Or worse, like humans.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40857,'Let an old orc show you how it\'s done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40858,'As you were, orcs.  Let\'s make Hellscream proud.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40859,'This area is looking good, orcs.  Keep up the good work.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40860,'Say, did I ever tell you about the dwarf that tried to kill me in the battle for Grim Batol?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40861,'He tried to sneak up behind me and plant his blade in my skull.  Lucky for me, I can smell a dwarf a mile away... and my skull\'s a lot thicker than most.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40862,'Of course, back then, I had a lot more hair to protect it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40863,'Anyhow, I turned around, took his blade, his life, his head, and his mount.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40864,'You orcs ever dream about battle?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40865,'Yes sir.','Yes sir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40866,'Very much, sir.','Very much, sir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40867,'Ha ha!  Excellent!  Maybe I\'ll see to it that you get your names recommended to Garrosh.  Now, back to work!  Lok\'tar ogar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40868,'OVERSEER!  What\'s going on here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40869,'BE BATHED IN FLAME!','',0,0,0,0,0,0,0,0,1,0,22576,0,26124),
(40870,'BURN IN LIQUID FLAME!','',0,0,0,0,0,0,0,0,1,0,22577,0,26124),
(40871,'Last I checked, your title was overseer, not overeater.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40872,'I\'ve walked by here twice now, and both times you\'ve been sitting here by the fire, lazing around while your men work.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40873,'Sir, I... my orcs were working well, so I just... thought I\'d...','Sir, I... my orcs were working well, so I just... thought I\'d...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40874,'I see bandages stacked in the same piles as weapons.  I see food that clearly has been left to expire in the sun, when I CLEARLY provided you with a tent for shade.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40875,'Who is overseeing these men?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40876,'I... I am, sir.','I... I am, sir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40877,'Let\'s make sure that it stays that way then.  Back to work, overseer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40878,'Gor, Shin, you shouldn\'t really be spending all your time in this hut.  Get out there and work with the orcs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40879,'Actually, shaman, I don\'t really care what you do.  I\'m not even sure why Hellscream brought you here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40880,'Gor, when you\'re feeling less like a youngling, why don\'t you come outside with me and actually start ENFORCING for once?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40881,'Farmer, come out.  We must speak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40882,'These swine, they are weak.  They\'re not good for breeding, not good for eating, and certainly no good for combat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40883,'You need to be more selective in your breeding.  The Horde has no place for weaklings, even in its swine pens.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40884,'There.  I don\'t want to have to do this again.  That\'s your job, swineherd.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40885,'','Nooooo!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40886,'Nice shooting! The sniper cannon is a miraculous wonder!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40887,'Defeat these sons of Ragnaros so that I can aid Cenarius!','',0,0,0,0,0,0,0,0,1,10699,20806,0,26124),
(40888,'I am under assault! Assist me!','',0,0,0,0,0,0,0,0,1,10700,20765,0,26124),
(40889,'%s is under attack from Ragnaros. Heal him!','',0,0,0,0,0,0,0,0,1,9587,0,0,26124),
(40890,'Ragnaros\'s assault has taxed my strength... Heal me!','',0,0,0,0,0,0,0,0,1,9587,0,0,26124),
(40891,'Let this be a lesson to those who would defile Hyjal.','',0,0,0,0,0,0,0,0,1,0,19639,0,26124),
(40892,'You know nothing of fury, worm!','',0,0,0,0,0,0,0,0,1,0,19638,0,26124),
(40893,'PUNY $R! DIE!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(40894,'Feel the fury of Ragnaros!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40895,'','This heat. This stifling heat.$B$BIt makes me want to hurt things.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40896,'Here I come!  Don\'t you dare hide behind those trees!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40897,'Someone else from beyond the portal! I hope you\'re ready for a fight, $c.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40898,'We\'re behind enemy lines, $n. We\'ve got to do as much damage as we can!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40899,'If we allow Twilight\'s Hammer to open up portals like these all over Azeroth, no army in the world can save the planet. We\'ve got to shut this tunnel network down!','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(40900,'We must perservere, $n. That is something I learned from our beloved wolf ancient.$B$BNever, never, never give up.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(40901,'Pyrendius is slain! Our work here is done.$B$BJust step through the flamegate to return to Mount Hyjal, $c. I\'ll make sure the gate is taken care of.','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(40902,'I lost my Fang of Lo\'Gosh. Can I have another?','I lost my Fang of Lo\'Gosh. Can I have another?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40903,'I lost my Fang of Goldrinn. Can I have another?','I lost my Fang of Goldrinn. Can I have another?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40904,'','You\'ll soon learn that lightning and water don\'t mix!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40905,'Later.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40906,'In honor of our benevolent ruler and protector, Matron Elestara Vashj.$B$BFor 100 years, she has faithfully sheltered us, protected us, and lead us steadily into a modern age of prosperity.$B$BUnder Queen Azshara\'s gaze, may she reign for 100 year more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40907,'What coward dares attack my young while I\'m away?  I will feed your entrails to my brood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40908,'It took all of our combined strength, but we have pushed Ragnaros back into the Firelands.','',0,0,0,0,0,0,0,0,1,0,21643,0,26124),
(40909,'Woohooo!','',71,0,0,0,0,0,0,0,1,9601,0,0,26124),
(40910,'We must not let down our guard.  It\'s only a matter of time before he regains his strength and returns to turn Nordrassil into ash.  ','',0,0,0,0,0,0,0,0,1,0,20807,0,26124),
(40911,'We must confer with the leaders of the Horde and the Alliance.  Ragnaros must be defeated in his home realm.  Only then will he forever be vanquished.','',0,0,0,0,0,0,0,0,1,0,20766,0,26124),
(40912,'Let us leave this place for now.  We must return to the surface and restore the damage our enemies have caused.','',0,0,0,0,0,0,0,0,1,0,21644,0,26124),
(40913,'','You will not defile the winds of Hyjal, monster!',0,0,0,0,0,0,0,0,1,0,0,20740,26124),
(40914,'Master Taerar will show you such wonder!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40915,'We are all a part of him...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40916,'The nightmare reigns!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40917,'For Taerar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40918,'','Huntress, there! What is that!?',0,0,0,0,0,0,25,7,1,9602,0,0,26124),
(40919,'','I... is that it over there, $n? This land is doomed if the Horde manages to set that off.',0,0,0,0,0,0,25,7,1,9602,0,0,26124),
(40920,'What is that, a siege tank first aid kit? You must know Pilot Stonegear!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40921,'*POP* Not zat von! Keep going!','*POP* Not zat von! Keep going!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40922,'*crackle* WRONG! Ze correct goblin driller iz down ze path!','*crackle* WRONG! Ze correct goblin driller iz down ze path!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40923,'Slay her now, before Aviana\'s magic wears off!','',0,0,0,0,0,0,0,0,1,0,20948,0,26124),
(40924,'Show yourself, beast!  We will destroy you and your corrupt spawn no matter where you hide!','',0,0,0,0,0,0,0,0,1,0,20947,0,26124),
(40925,'You no take ore!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40926,'%s is weak enough to capture!','',0,0,0,0,0,0,0,0,1,9604,0,0,26124),
(40927,'WAAAARRRRRRGH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40928,'I\'ll hold onto this orb for...safe keeping. Go inform Rok Orhan of our cultist problem.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40929,'Who dat? Somebody der?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40930,'MOVE! DIS ROCK HEAVY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40931,'NO CAN SEE NOTHIN! Move out of da way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40932,'Why me have to carry big rock? Dey said less work under da new Warchief! Dey promised change!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40933,'Maybe me put dis rock down and say hello. Maybe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40934,'Walking blindly tru dark mine wit big rock in arms. Much better dan last job.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40935,'Move or I tell da overseer dat you pooped in da bucket!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40936,'Sleepy... so sleepy...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(40937,'OK boss, I get back to tree-hitting.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(40938,'Just was resting eyes!  Back to work now!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(40939,'Shhhh! Keep it down! You\'ll blow our cover.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40940,'Thank you for taking the time to help us test the Cataclysm content for World of Warcraft. \n\nWhere would you like to go?','Thank you for taking the time to help us test the Cataclysm content for World of Warcraft. \n\nWhere would you like to go?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40941,'Take me to Orgrimmar, I wish to travel through Vashj\'ir Landing.','Take me to Orgrimmar, I wish to travel through Vashj\'ir Landing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40942,'Take me to Stormwind Harbor, I wish to travel to Vashj\'ir Landing.','Take me to Stormwind Harbor, I wish to travel to Vashj\'ir Landing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40943,'Take me to Hyjal, I wish to help the Druids protect Nordrassil.','Take me to Hyjal, I wish to help the Druids protect Nordrassil.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40944,'I wish to travel directly to Vashj\'ir Landing.','I wish to travel directly to Vashj\'ir Landing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40945,'This is where we play a movie of you turning into a worgen!  We also flash-forward to the present!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40946,'HIJACKER! DIE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40947,'You won\'t get away with this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40948,'You can\'t stop us! The Horde will never fall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40949,'The chief will pay big money for your head!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40950,'Get off! Get off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40951,'***MALFUNCTION***','',0,0,0,0,0,0,0,0,1,9621,0,0,26124),
(40952,'***REROUTING POWER SOURCE***','',0,0,0,0,0,0,0,0,1,9621,0,0,26124),
(40953,'***REMOTE ACCESS ENABLED***\n','',0,0,0,0,0,0,0,0,1,9621,0,0,26124),
(40954,'***RETURN COMMAND INITIATED***','',0,0,0,0,0,0,0,0,1,9621,0,0,26124),
(40955,'***EJECTING ALL UNAUTHORIZED PASSENGERS***','',0,0,0,0,0,0,0,0,1,9621,0,0,26124),
(40956,'','<Though Ysera\'s physical form stands in front of you, her consciousness appears to shift between this world and another.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40957,'','Have you been to Ashenvale lately? How are things?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(40958,'Yes, my brethren!  We are claiming this prisoner for the True Sons of the Twilight!  These ogre scum are not fit to offer him as sacrifice!  They are not worthy of the Old Gods\' grace!','',0,0,0,0,0,0,0,0,1,0,20757,0,26124),
(40959,'Come on now commander.  Let\'s get you out of here.  $n, meet us at the Gates of Sothann -- Ysera awaits!','',0,0,0,0,0,0,0,0,1,0,20758,0,26124),
(40960,'','%s begins to channel a Supernova. Look away!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40961,'We are still beset by threats here. I cannot leave the camp unguarded.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(40962,'It is all I can do to protect those who have made it here.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(40963,'I have sent all the warriors I can. Had I but even one more for you...','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(40964,'Leaving ourselves unguarded on two sides will bring even more suffering, Jawn.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(40965,'We must keep the guards here to protect the refugees.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(40966,'The grimtotem lurk in Feralas as well. They wait for the chance to strike this very camp.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(40967,'Hmm, good treasure.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40968,'%s becomes protected by his defense beacons! Disable them by pulling the levers below!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40969,'Want fight admiral? Lots of treasure. Me outa here!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(40970,'No want trouble. Want gold.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40971,'This lots of gold! Me look other way.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40972,'Two-Tusk never give me treasure!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(40973,'Me hide treasure. Go on break.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40974,'Lots of shiny. Maybe me like you more than admiral.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(40975,'You not bad for $r scum.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(40976,'','Wake up, Mr. P!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(40977,'','All good girls listen to their daddies!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(40978,'Oh no! The key broke in the lock! I\'ll never get out of this cage!','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(40979,'','Are you there, Mr. P?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(40980,'','Wake up, Mr. P! You\'ve gotta save the spirits!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(40981,'Oh no! The key broke in the lock! I\'ll never get out of this cage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40982,'Ryan\'s the name, trading\'s the game! What\'ll ya have?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40983,'Show me what you\'ve got, Ryan.','Show me what you\'ve got, Ryan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40984,'','We Druids of the Talon aren\'t cut out for front-line duty. We\'re aerial spies, infiltrators...$B$BBut occasionally I like to get my talons dirty. ',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40985,'Watch yerself down here, $c. These wendigos are savage fighters.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40986,'Captain Tharran wants you to deploy your remote observation bots and withdraw to Kharanos.','Captain Tharran wants you to deploy your remote observation bots and withdraw to Kharanos.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40987,'Fools! Simpletons! Look at you milling about, oblivious to the coming of the end!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(40988,'Allow me to ask a simple question: Is a man allowed - entitled even - the sweat of his brow?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(40989,'I\'ve seen enough of this cave for a lifetime. I can\'t wait to get back to Kharanos.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40990,'\'No\' says the orc in Orgrimmar, \'it belongs to the Horde!\'','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(40991,'\'No\' says the human in Stormwind, \'it belongs to the Alliance!\'','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(40992,'I knew a man once that rejected those answers! A great man that built a home for those that felt as he did! A man that chose the impossible!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(40993,'That man was Genn Greymane and that impossible choice was Gilneas!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(40994,'These wendigos are an annoyance, sure, but the real fight is with those Frostmane refugees.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(40995,'','Come ... closer ... $c. They are ... pulling me away ...',0,0,0,0,0,0,0,0,1,0,0,20748,26124),
(40996,'','A %s appears above the circle, hazy and indistinct.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(40997,'','Elune watch over you, $n.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(40998,'','Your kindness will not be forgotten!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(40999,'','I am eternally grateful, $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41000,'','Curse the wretched Horde! I would have died without you!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41001,'','You think you\'re clever, don\'t you, ganging up on me like this... well, prepare to face: THE DREADSHREDDER!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41002,'','Hurry...',0,0,0,0,0,0,0,0,1,0,0,20749,26124),
(41003,'','Grrr... I was going to fight you fair and square, but you decided to bring friends. Fine! Behold the Alloy-Pounder Zero!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41004,'%s appears above your head with an ear-splitting caw!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41005,'Tell Captain Tharran that I\'ll be back in Kharanos as soon as I\'ve verified that the bot is working correctly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41006,'I can\'t wait to get out there and help in the fight against those trolls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41007,'','Sister! I... too... have f-failed...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41008,'We\'ve been fighting nonstop since the cataclysm. It\'ll be nice to get a rest, if a brief one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41009,'','Well done, $n! Return to Windshear Hold and notify Lord Fallowmere of the Horde\'s intentions. I will venture to the Thal\'darah Overlook and warn our soldiers.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41010,'','Ack! Not the face!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41011,'','Whaaaa!!!!!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41012,'Now you all die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41013,'I could hear the sound of your trident breaking from the gardens! The skulls of these Kvaldir are as strong as rock.','',0,0,0,0,0,0,1,0,1,0,21670,0,26124),
(41014,'','A single prong. Hardly enough to stop me from slaughtering hundreds more.',0,0,0,0,0,0,1,0,1,0,0,21809,26124),
(41015,'First and foremost, I\'m a businessman. Bring me back to life and I\'ll stop haunting you. There may even be a reward in it for you.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(41016,'Indeed. I doubt much would.','',0,0,0,0,0,0,1,0,1,0,21671,0,26124),
(41017,'You know, if you\'d just been reasonable about the whole thing, I might have simply sold the key to you. Not that it would have done you any good. Broke off in the lock. Muahahahahahahaha!','',0,0,0,0,0,0,153,0,1,0,0,0,26124),
(41018,'Sorry about having to deal with my wife, mon. She\'s crazy, but I still love her, you know?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(41019,'This afterlife thing isn\'t all that bad. I can see lots of business opportunities here. Plenty of spirits that are waiting for the right deal to come along.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(41020,'You know, the attacks on the Speedbarge are just a business misunderstanding. When you get me rezzed, I\'ll consider negotiating a contract with Fizzle and Pozzik.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(41021,'You got something to eat? I\'m hungry!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(41022,'You don\'t like me following you around? Too bad! Maybe next time you go murdering someone just to get a key, you\'ll think twice!','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(41023,'What\'s the weather like? I can\'t tell... it\'s all grey and dark, swirling clouds here.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(41024,'That whole thing with Ajamon\'s sister was a big misunderstanding. I didn\'t do it, I swear! I think it was Seadog Fajardo. The little brat kinda looks like him.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(41025,'Oh, mon, I had an itch when I died and now it won\'t go away. Please tell me it doesn\'t last for eternity?! You gotta get me rezzed!!!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(41026,'They say I have a bad reputation as a pirate, but you don\'t see me sailing around indiscrimanately killing people just to make a profit. Oh, wait....','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(41027,'Ajamon took her maiden name again. Despite everything, I kinda miss her, you know?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(41028,'You want to know why women are no-good? Because you think that all they\'re doing is calling upon the spirits of the dead. But then, you catch them doing a little more than talking! I mean, how does that even work with a ghost?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(41029,'When I get back into my body, I\'m going to kill you, mon! Er... no, what I meant to say is that I\'m going to hug you. Yeah, that\'s right, I\'m going to hug you and give you a big reward. Nevermind what I said about the killing.','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(41030,'Kulratha. Things are going well, I see.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41031,'Didn\'t take me long to build a pirate empire out of almost nothing. Ah, the Barrens. Now those were the days. Hey, did anyone ever find out what happened with Mankrik\'s wife?','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(41032,'You\'re just the kind of scum that I\'m looking for in my organization. You know, we\'re an independetly run franchise of the Southsea Freebooters. We have pretty good benefits, vacation, and full medical, dental, and vision. Maybe we should talk after you bring me back to life.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(41033,'The blessed beast Gahz\'rilla, adored pet of the Old Gods, grows larger and stronger by the day... as does the Cult of Twilight\'s Hammer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41034,'Continue your work here, Hydromancer. Soon, this world will be remade...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41035,'...and as devoted servants to our master, you and the Sandfury tribe shall  be justly rewarded!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41036,'INTERLOPERS! Slay them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41037,'','You think you\'re all brave facing me, eh, Steelsparks?! Those pig tails won\'t protect you from THE DOOMSAW!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41038,'','Careful, $n! Warlord Roktrog is near. He should be back any minute!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(41039,'','Soon, the rifts will be large enough for Gahz\'rilla to assault the heathens\' cities directly. She will reduce them to frozen rubble!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41040,'Where is the Warlord? I will kill him and free you!','Where is the Warlord? I will kill him and free you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41041,'','Lady Vashj is nothing like her mother. It is little wonder she left this city so long ago.',0,0,0,0,0,0,1,0,1,0,0,21808,26124),
(41042,'Stonetalon has always had its fill of problems, $n, but never has the land and its people suffered so badly. The Horde will destroy us all if left unchecked.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(41043,'Oh, dearest Gilneas, how I miss thee...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41044,'Come to my aid, Drake!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41045,'','Ouch! That burns!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41046,'','Ow ow! Ow ow ow..!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41047,'','Sharp!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41048,'','This is the one. The ancient will be ours.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41049,'','Take the others to the Firelands Hatchery! Soon we will possess the skies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41050,'','Mother of all winged creatures, hear my prayer and reveal yourself... a vision! What could this mean, $n? I will report this to Omnuron.',2,25,5,0,0,0,25,0,1,0,0,0,26124),
(41051,'','Let\'s see how all of that dynamite in your pocket likes the KS-L10 Steelspark, Megs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41052,'','Yikes! That stings!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41053,'','Yeouuwch!!!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41054,'You\'ve got to save me here, $c! He\'s gone mad... mad I telll you! His inability to stop the flooding of Thousand Needles has caused him to go completely bonkers!$B$BHe blames me for everything, including the Cataclysm. He probably thinks that I\'m Deathwing in disguise, or something!$B$BHelp!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(41055,'I hear that you sell Ancona chickens?','I hear that you sell Ancona chickens?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41056,'','Gotcha Chickenlips! You\'d best get talky, or I\'ll get stabby.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(41057,'','I\'m not sure that\'s strictly necessary.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41058,'','You\'ll get nothing from me, $r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41059,'','<Marion squaks loudly and glares at you.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41060,'','Your cities will fall, $r. You\'ll perish in the darkness of the new regime!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41061,'','Do what you will. My new masters will carve my name into your flesh before they execute you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41062,'<Soften her up.>','<Soften her up.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41063,'Attack them now, brothers!','',0,0,0,0,0,0,0,0,1,0,21402,0,26124),
(41064,'Kill the females! I will handle these \"warriors.\"','',0,0,0,0,0,0,0,0,1,0,21403,0,26124),
(41065,'Attack the Sea Witches - stop their spells!','',0,0,0,0,0,0,0,0,1,0,21404,0,26124),
(41066,'Slaughter them all.','',0,0,0,0,0,0,0,0,1,0,21405,0,26124),
(41067,'Squash these snakes!','',0,0,0,0,0,0,0,0,1,0,21406,0,26124),
(41068,'Men, attack now!','',0,0,0,0,0,0,0,0,1,0,21407,0,26124),
(41069,'Stand still you worthless chicken!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41070,'I could have stopped the sea if not for your incessant clucking!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41071,'I\'ll pluck you, Johnson!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41072,'What shall it be this time: fire or frost? Hmm?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41073,'','Wait, was I supposed to be the good cop?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41074,'','We don\'t need to tell Omnuron about this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41075,'','Easy, friend. We still need the info.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41076,'','Hey, you don\'t waste any time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41077,'','There\'s more where that came from, Marion!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41078,'','Brutal!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41079,'I know what I\'m having for dinner tonight and it rhymes with \"Sucky\"!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41080,'Don\'t resist... I\'m only trying to change you back into a man.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41081,'Dance, Johnson, dance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41082,'Oh, and I\'ll be taking my Ancona chickens back, thank you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41083,'Would you hurry it up over there? I don\'t have all day!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(41084,'Johnson, are you selling my Ancona chickens again? Nooooooo!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(41085,'Hey! Why aren\'t you polymorphed? Enjoy it while it lasts, \"Plucky\"!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(41086,'If you\'d been a better assistant this whole Cataclysm thing could have been avoided!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(41087,'Does anyone hear that voice? Make it stop!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(41088,'Bored now!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41089,'Johnson, tell your friend to move along. It\'s past time for your demise.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41090,'I better get a cut of those sales! Better yet, I\'ll just fry you up and take all of the profit for myself.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(41091,'Why are you stealing eggs?','Why are you stealing eggs?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41092,'','She asked for eggs. Eggs for her fiery hatchery in another realm.$B$BAnd one egg... a special egg... she sought more than any other.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41093,'Who? Who are you giving the eggs to?','Who? Who are you giving the eggs to?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41094,'','She of the skies, but also of darkness. Brood of the Earth-Warder. Invincible!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41095,'Brood of the Earth-Warder... you answer to a black dragon? Give me a name!','Brood of the Earth-Warder... you answer to a black dragon? Give me a name!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41096,'','Foolish $r! There is a new order. Aviana is dead. DEAD! And never coming back.$B$BTell that to the druids in the trees.$B$BSethria will soon be the master of the skies, and she has made sure Aviana will never be reborn. The egg is hers.$B$BYou are too late.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41097,'','It\'s your call, $n. Marion brought this on herself when she attacked our matron\'s sacred shrine.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41098,'<Order Thisalee to kill the harpy.>','<Order Thisalee to kill the harpy.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41099,'','Hooray, Mr. P! You\'re back! Do you remember how to shoot all your guns? Why don\'t you take a minute to learn how to fight again! Just in case.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41100,'<Ask Thisalee to release the harpy.>','<Ask Thisalee to release the harpy.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41101,'','You\'re a better person than I, $n. But I suppose the harpies are just pawns here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41102,'','Be really careful, Mr. P. If you see a big group of goblins, use your magnetic pull! Once you\'ve got \'em all sucked up, launch \'em to their death! YAY!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41103,'','Get \'em, Mr. P!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41104,'','Break their bones, papa!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41105,'','Make \'em sorry for hurting you, Mr. P!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41106,'','YAY!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41107,'','Hurt \'em some more! MORE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41108,'','BAD, BAD, HORDIE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41109,'Need some smithin\'?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(41110,'I need repairs, Irongoat.','I need repairs, Irongoat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41111,'I LIVE!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(41112,'Thanks, mon. You\'ve been true to your word and I can respect that.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(41113,'I need to get back. I\'m sure we\'ll cross paths again. Next time, I\'ll get to return the favor.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41114,'Bye, hon. See you later tonight.','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(41115,'','No you won\'t, Tony. Go away, I\'m busy summoning up a date for later!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41116,'Meet me back at Aviana\'s Shrine, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41117,'Aaaahh!!!','Aaaahh!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41118,'Help us!','Help us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41119,'Get me out of here!','Get me out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41120,'It came from below!','It came from below!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41121,'Save us!','Save us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41122,'Let\'s get back to work, people!','Let\'s get back to work, people!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41123,'Let\'s get back to work, people!','Let\'s get back to work, people!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41124,'Remain calm!','Remain calm!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41125,'Please return to your places!','Please return to your places!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41126,'Well, this is a little embarrassing....','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(41127,'You\'ll pay for your meddling, $c!','Step away from there, $c!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41128,'','Time\'s up, Marion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41129,'','Ice cream!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41130,'I\'m ready to help with Mr. P, kid. Let me in.','I\'m ready to help with Mr. P, kid. Let me in.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41131,'What\'s a $r like you doin\' in a place like this? ...especially at a time like now?$b$bHmmmm?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41132,'That vile beast has been driven off, but my precious waters have been tainted! I must cleanse them at once.$b$bIf you insist on lingering here, prepare to defend yourself.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41133,'We are ready!','We are ready!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41134,'Welcome, $c! Welcome to the Shrine of Aviana, a haven for all creatures of the sky.$B$BAviana may no longer be with us, but her heart and her ferocity live on in all winged creatures.$B$BSpeak with Choluna down below if you are curious about Aviana\'s story.','',3,1,0,0,0,0,0,0,1,0,0,0,26124),
(41135,'Thisalee tells me that the harpies are in league with the dragons? But something doesn\'t add up. We need to know more.$B$BPlease assist Choluna with her work here, and see if we can tie this all together... ','',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(41136,'Choluna told me of your vision. Very puzzling. Is our beloved ancient to be reborn? If so, where is she now?$B$BWe need to know more! Please help Thisalee gather more information for us, then we will act.','',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(41137,'I don\'t know what I\'m doing here. I have no experience as a contract negotiatior.$B$BI used to serve drinks for a living, but Daisy put me out of business. Time for a new career, I guess.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(41138,'Choluna and Thisalee have both given me their reports. It\'s all very clear to me now...$B$B$n, I believe Aviana may soon return to us, but only if we can stop the black dragon Sethria!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(41139,'','Psst - over here! Stay out of sight for the moment...',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(41140,'I used to be a simple ticket redeemer at the racetrack. Well, no more racetrack, so no more job.$B$BI\'m trying my hand at negotiations now. Could you help me get things going here? They have oil!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(41141,'The resurrection ritual has failed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41142,'Kravel Koalbeard is stunned. Steal the Alliance\'s Proposal now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41143,'What\'s the meaning of this?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41144,'Protect %s until the ritual completes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41145,'What are you doing?!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41146,'Trackmaster Zherin is stunned. Steal the Horde\'s Proposal now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41147,'%s is under attack!  Protect him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41148,'<The Arcane Guardian gestures towards the Lower City\'s bazaar.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41149,'I would like to start the Blood Ritual, Lynnore.','I would like to start the Blood Ritual, Lynnore.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41150,'','Blood magic is shunned by many as a dark and forgotten art.  In that and many other ways, it shares some distinct characteristics with demonic magic.  Here, in the demon-scourged remains of the Black Morass, we believe that our blood studies will flourish.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41151,'You can teach a soldier how to kill, but you can\'t teach him to want to kill.  That is one thing we don\'t have to worry about down here.  Every single one of my boys can\'t wait to take a piece out of those naga for what they did to us, and I can\'t say I feel  much different.$B$BWe need to find a way to make contact with the surface, but before that, I want to make a bit of \"contact\" with these naga.  We have some brothers to avenge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41152,'','Let me have a look at that shard, would you Admiral?  I could feel its power radiating from the other side of the cave.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41153,'Of course.  It\'s all yours.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41154,'','Thank you.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(41155,'You have already witnessed this vision.','You have already witnessed this vision.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41156,'You need to attune yourself further with the Naz\'jar Battlemaiden to participate in this vision.','You need to attune yourself further with the Naz\'jar Battlemaiden to participate in this vision.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41157,'Disabling the shadow cloak reveals one of Sethria\'s hatchlings!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41158,'I... What sorcery is this?','I... What sorcery is this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41159,'You will regret your actions!','You will regret your actions!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41160,'I... I have no control. Bound by your infernal contraption.','I... I have no control. Bound by your infernal contraption.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41161,'What are we going to tell Forba?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(41162,'Ha! You\'re the one who was supposed to be watchin\' the keg!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(41163,'You were drunk on the job!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(41164,'We? More like what are YOU going to tell Forba!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(41165,'You\'re the one who was supposed to be watching for orcs!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(41166,'So were you!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(41167,'This is it! You\'ve found Aviana\'s Egg! Keep it safe while I go get help.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41168,'Disabling the shadow cloak reveals Aviana\'s Egg!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41169,'Defend the Egg!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41170,'','So help me, if I can get a single one of these lazy sods on his gorram feet, I\'m puttin\' him to work beating the others black and blue!$B$BWe\'ve got WORK to do here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41171,'Listen, you... do you have any idea how hard it is to conduct a geological survey? It\'s exacting, precise work!$B$BAn\' it\'s even harder when you\'re drunk.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41172,'You\'re a lifesaver.','You\'re a lifesaver.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41173,'Thanks.','Thanks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41174,'\'Bout time.','\'Bout time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41175,'Keep up the good work.','Keep up the good work.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41176,'Good timing - I was almost out.','Good timing - I was almost out.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41177,'Their attacks are getting more frequent. You better keep moving.','Their attacks are getting more frequent. You better keep moving.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41178,'We\'ll keep you covered. Good luck with the assault!','We\'ll keep you covered. Good luck with the assault!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41179,'Good to know they\'ve still got our backs. Thanks!','Good to know they\'ve still got our backs. Thanks!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41180,'%s gasps for air.','%s gasps for air.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41181,'Thank you for freeing me!','Thank you for freeing me!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(41182,'Rofilian Dane is deeper in the mine.  Just follow these tracks.','Rofilian Dane is deeper in the mine.  Just follow these tracks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41183,'Dane awaits you in the next chamber.','Dane awaits you in the next chamber.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41184,'How peculiar.','How peculiar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41185,'Was that box there a second ago?','Was that box there a second ago?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41186,'The battle for Twin Peaks begins in 1 minute.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41187,'The battle for Twin Peaks begins in 30 seconds.  Prepare yourselves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41188,'Hmm...','Hmm...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41189,'I do declare... a moving box.  The engineers have really done it this time!','I do declare... a moving box.  The engineers have really done it this time!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41190,'Return to the Nethergarde Mines.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41191,'I know who you are, $n! I\'ll not surrender the Sacred Flame to a filthy meatbag such as yourself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41192,'Amazing materials down here. Amazing! Substitutes for everything. Substitutes for substitutes. Everything\'s possible!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41193,'I\'m ready to begin the assault on the terrace.','I\'m ready to begin the assault on the terrace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41194,'Explode\'m good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41195,'Is that box walking on its own?  Am I going mad?  Quick, someone check the canary!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41196,'Here, we are even more exposed than before, $r.$b$bWe must find safe shelter soon!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(41197,'We must find your allies and discover the naga motives in this region.$b$bBut first, we must find a more secure location.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(41198,'I feel that we are just scratching the surface of the naga presence here.$b$bI have never seen them so organized and disciplined before.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(41199,'Village... gone.  Family gone.  Naga take... everything.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41200,'Murloc, I know that you hold the Amulet of Sevine.  I need it.','Murloc, I know that you hold the Amulet of Sevine.  I need it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41201,'You will never take amulet!  Grol lives forever!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41202,'You hear a noise behind you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41203,'Grol will kill you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41204,'What is this? FAKE! Splithoof, $n and the gnomes have tried to fool us. Kill $g him : her;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41205,'What is this? FAKE! Splithoof, $n and the goblins have tried to fool us. Kill $g him : her;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41206,'Get away from those!','Get away from those!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41207,'What do you think you\'re doing?','What do you think you\'re doing?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41208,'Begone, Horde thief!','Begone, Horde thief!',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(41209,'You are little more than insects! When I am done with you, I will burn your shrine to the ground!','',0,0,0,0,0,0,0,0,1,0,21682,0,26124),
(41210,'You buy time... but not your lives... my hatchery remains...','',0,0,0,0,0,0,0,0,1,0,21683,0,26124),
(41211,'We\'re coming, $n! Keep her occupied while we loop around for an attack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41212,'It\'s been hard on all of us, but we\'re getting by.$B$BYou\'ve just gotta roll up your sleeves and do what needs to be done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41213,'The Splithoof Heights centaur have destroyed the oil drilling rig!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41214,'<The injured soldier\'s pained groans are somewhat distorted by the water.>','<The injured soldier\'s pained groans are somewhat distorted by the water.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41215,'<The injured soldier appears to still be breathing. Thankfully, his bubble remains intact.>','<The injured soldier appears to still be breathing. Thankfully, her bubble remains intact.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41216,'<There is a a painful looking gash along the soldier\'s side.>','<There is a a painful looking gash along the soldier\'s side.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41217,'<It looks as if this solider might be feigning to throw off naga suspicion. It likely saved his life.>','<It looks as if this solider might be feigning to throw off naga suspicion. It likely saved her life.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41218,'You\'re a welcome sight.','You\'re a welcome sight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41219,'I was told that losing my mount was a death sentence. Thanks for proving the Admiral wrong.','I was told that losing my mount was a death sentence. Thanks for proving the Admiral wrong.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41220,'You\'re a beautiful, beautiful sight, friend.','You\'re a beautiful, beautiful sight, friend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41221,'Did everyone else make it? Did the attack succeed?','Did everyone else make it? Did the attack succeed?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41222,'Got it. Thanks.','Got it. Thanks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41223,'The way to the rendevous point is mostly clear. You should get moving.','The way to the rendevous point is mostly clear. You should get moving.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41224,'You don\'t have to tell me twice.','You don\'t have to tell me twice.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41225,'That is *exactly* what I wanted to hear. Thanks.','That is *exactly* what I wanted to hear. Thanks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41226,'Looks like I owe you another one.','Looks like I owe you another one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41227,'I\'m all over that. Thanks.','I\'m all over that. Thanks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41228,'On my way. Thank you.','On my way. Thank you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41229,'You\'re almost too good to be true.','You\'re almost too good to be true.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41230,'It was a glorious assault. I\'ll give it that.','It was a glorious assault. I\'ll give it that.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41231,'The souls of the Third Fleet are cursed to roam this shore, for eternity, $r. The Eye of Paleth lay claim to our lives, and trapped us in the mire forevermore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41232,'Demon!  I have returned from beyond the grave to destroy you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41233,'Death has not erased my memory.  I still know your name...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41234,'RAKH\'LIKH!  Come, and know demise!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41235,'Fool of a demon hunter.  How many pieces must I cut you into this time?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41236,'Enough games!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41237,'What\'s this?  Loramus... I see, they used the Altar of Storms, didn\'t they?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41238,'You must feel it already then... the demonic energy entering your heart, your lungs, your soul...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41239,'Allow me to speed up the process a bit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41240,'The pain!  Oh, sweet sassy molassey, the pain!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(41241,'Now, heroes!  Finish me, while Rakh\'likh possesses my body!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41242,'Quickly!  Use the knife on me!  Time runs short!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41243,'The delights of death await you.','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(41244,'The stone knife!  Use it NOW!  I can\'t maintain control of him for much longer...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41245,'Return to me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41246,'It is done.  Leave me here, then, while I wrestle with Rakh\'likh in the next world.  Your job here is done, heroes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41247,'Thank the Light! I\'m saved!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41248,'Are... Are they dead? The assassins?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41249,'Is it safe?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41250,'What in tarnation?','What in tarnation?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41251,'A box that walks?  I should ask Hondo about this... nah, maybe later.','A box that walks?  I should ask Hondo about this... nah, maybe later.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41252,'Oh my.','Oh my.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41253,'Get back to work!  Oh wait... you\'re just a box, never mind.','Get back to work!  Oh wait... you\'re just a box, never mind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41254,'Shh, mon!  We be hidin\' here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41255,'Okrilla doesn\'t like to let us non-orcs into town, but that doesn\'t stop her from putting us to work.  No matter... I prefer it out here anyway.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41256,'You orcs are lucky... the Warmatron lets you stay in Dreadmaul Hold, while the rest of us get sent out on field duty.  No matter... in some ways, I prefer to be out here than under her roof.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41257,'','You are in orc territory.  What do you need, $r?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41258,'','Welcome, $g brother: sister;.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41259,'Here goes nothin\'! Keep your fingers crossed, $n!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41260,'YIPPY! SHE\'S ALL CLOSED UP! NO MORE HORDE BACKDOORIN\' US!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41261,'Hey, $n, come over here, would ya? I\'ve got something for you to do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41262,'$n, over here if you please.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41263,'Flood\'s not so bad. Not as bad as the ones we\'ve had in Ironforge.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(41264,'You watch your tongue, ya blootered chuff! That was an honest mistake!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(41265,'Aye, you mean the one you caused?','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(41266,'You put a floodgate on a channel from the inside and trapped yerself!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(41267,'An\' then you tunneled from the channel straight into a dining hall!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(41268,'We were findin\' carp behind the furniture for weeks!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(41269,'An honest mistake!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(41270,'Well, at least the ale was safe.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(41271,'\'Tis a tragedy, boys. The curse of Menethil be on us all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41272,'Aye, and a damn fine job she did of it! But not as good as the Admiral.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41273,'We held our place here as long as we could, but it still wasn\'t enough.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41274,'Nobody could hold a place like him, lads. Nobody.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41275,'Cap\'n, the Virtue hasn\'t set sail in years. It was just sittin\' there.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41276,'We know, cap\'n.  We know.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41277,'We have arrived, $n. Does he still live?','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(41278,'Blowing','Blowing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41279,'This should warm the lad up!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(41280,'Grol!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41281,'You, what have you done?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41282,'You dare call upon a lord of Skywall, $n? I will destroy you and cast your carcass back down into the pit of slime from whence you crawled!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41283,'I see... this is the path I must take.  Meet up with me back in the cave, heroes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41284,'Holy moley!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(41285,'This is horrible!','',0,0,0,0,0,0,0,8,1,0,0,0,26124),
(41286,'Hey!  Get out of our mine!','Hey!  Get out of our mine!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41287,'Look out!  It\'s an invading $r!','Look out!  It\'s an invading $r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41288,'Stand back, or I\'ll pick you to death!','Stand back, or I\'ll pick you to death!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41289,'What?  How\'d you get in here?','What?  How\'d you get in here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41290,'Gadzooks!  Would ya look at that?','Gadzooks!  Would ya look at that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41291,'Heavens to Betsy!','Heavens to Betsy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41292,'Hey!  Somebody\'s ambulatory cube is escaping!','Hey!  Somebody\'s ambulatory cube is escaping!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41293,'I think I\'ve been down in this mine too long.','I think I\'ve been down in this mine too long.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41294,'Look out!  It\'s a box-demon!','Look out!  It\'s a box-demon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41295,'Looks like somebody\'s getting a special delivery.','Looks like somebody\'s getting a special delivery.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41296,'I need you to do what I say, $r.  If we falter, then we may be playing right into Razelikh\'s hands.  ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41297,'We appear to be dealing with something far bigger than any in the Earthen Ring had suspected.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(41298,'We appear to be dealing with something far bigger than any in the Earthen Ring had suspected.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(41299,'There is a great concentration of naga just outside of this cavern.$b$bWe were fortunate to reach this place unnoticed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41300,'Our soldiers... they\'re all captives now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41301,'Many of us tried to escape the naga.$b$bI am the only one who succeeded...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41302,'I don\'t know why, but those monsters are going out of their way to keep our men alive...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41303,'Fine!  Amulet take, but $r help Rockpool.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41304,'We lived under the same waves, breathed the same water, and worshipped the same god.  Why, then, would the naga turn against us?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41305,'The Eye of Paleth was retrieved and cleansed a long time ago, $c. We thought the curse lifted.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41306,'Not a year ago, poor old Fitzsimmons passed on, his body ruined by drink.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41307,'Ever since, now and then, people claim he\'s spoken to them and told them to get the eye...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41308,'Cursed to roam the earth forever...not even poor Fitzsimmons could escape.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41309,'Don\'t ask me what you actually brought me, $c. You\'re better off forgetting this ever happened.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41310,'Hellscream\'s armies march upon us, brothers and sisters!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41311,'Fight on! Magatha commands it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41312,'Do not despair! All is not lost! Not yet!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41313,'I have seen the future, brothers and sisters, and in it the Horde are no more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41314,'We will be victorious! Do not relent!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41315,'ATTACK! Grimtotem must fall! ALL MUST FALL!','ATTACK! Grimtotem must fall! ALL MUST FALL!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41316,'FOR HELLSCREAM! FOR THE HORDE!','FOR HELLSCREAM! FOR THE HORDE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41317,'','Goldrinn is the wolf ancient, known as \"Lo\'Gosh\" in the Horde tongue. His tenacity is legendary.$B$BA shrine dedicated to him is in a basin west of the World Tree, but its keepers have fallen silent in the wake of the attack. I fear the worst.$B$BBefore we can move on, you must save the shrine, discover the whereabouts of the wolf ancient, and beat back his foes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41318,'','Aessina is the spirit of nature, my everlasting companion in both this world and the dream beyond. Her shrine in western Hyjal is at the forefront of the Twilight offensive, and may be ablaze this very moment.$B$B$n, we will never restore Mount Hyjal without Aessina\'s help. Save her shrine from the fires, and save the nearby animals threatened by the blaze. We must do this or the entire mountain is lost.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41319,'','Aviana is the lost guardian of the skies, a bird goddess who perished fighting the demon hordes ten thousand years ago. A shrine is dedicated to her memory just southwest of Nordrassil, within the boughs of a great tree.$B$BThe Druids of the Talon are based within the shrine, and we will need their support. You must aid them. And aid Aviana, should she find her way back into this world...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41320,'','I have dispatched Archdruid Hamuul Runetotem to the burned out husk of the Sanctuary of Malorne. He is behind the front lines, on scorched terrain known as the Flamewake. He is looking into how we can undo the damage, and investigating the whereabouts of the turtle ancient Tortolla.$B$BBut before you can help him, you must first ensure that the Shrine of Aessina to the west is secure and the animals are saved from the flames. Otherwise all is lost! Concentrate on matters at the Grove of Aessina first, and they will send you to the Archdruid in good time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41321,'Tell me about the Shrine of Goldrinn.','Tell me about the Shrine of Goldrinn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41322,'What is happening at the Grove of Aessina?','What is happening at the Grove of Aessina?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41323,'How can I help the Shrine of Aviana?','How can I help the Shrine of Aviana?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41324,'Is there something I can do at the Sanctuary of Malorne?','Is there something I can do at the Sanctuary of Malorne?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41325,'','I\'ve tried everythin\' short of a righteous beating to get these dwarves up off their lazy duffs.$B$BAre you made of sterner stuff?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41326,'','Scour the mines! Leave no survivors!',0,0,0,0,0,0,22,0,1,9704,0,0,26124),
(41327,'','The assassin with the most kills will be invited to the feast at the Overlord\'s table!',0,0,0,0,0,0,22,0,1,9704,0,0,26124),
(41328,'','Hellscream\'s eyes are upon you, brothers!',0,0,0,0,0,0,22,0,1,9704,0,0,26124),
(41329,'Khaz Modan will crumble! ALL WILL BE RUINED IN HIS NAME!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41330,'You cannot stop... the end...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41331,'LEAVE...THIS PLACE...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41332,'It may not be quite comfy out here, but it\'s still Khaz Modan, so it\'s still our home.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41333,'Our town\'s under the blasted ocean, our keep\'s full of Dark Iron traitors, and I\'m laid up with such a wound I can\'t do a single thing about any of it.$B$BSo welcome to Menethil Harbor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41334,'Stand back, $n! When \"Cookie\" cooks things be gettin\' crazy!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41335,'Now to mix it all together and add me special spices!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41336,'BAM!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41337,'THE FLAMES SHALL CONSUME YOU! THEY SHALL CONSUME US ALL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41338,'Glory... to Ragnaros...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41339,'Mmmm, mmmm! Smells delicious, \"Cookie!\" Who could resist such a meal? $n, get this meaty offering to the Grimtotem ambassador immediately!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41340,'Return to the Red Reaches.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41341,'Ysera has sent me here to make contact with the wilderness spirit of Aessina.$B$BYet the ancient remains silent.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41342,'We didn\'t bring the war to the Horde, the Horde brought the war to us.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(41343,'Grundig is nearby. Look there.','',0,0,0,0,0,0,0,0,1,9708,0,0,26124),
(41344,'The Horde sends assassins! Kill them all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41345,'What\'s this?','What\'s this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41346,' Such a powerful weapon!',' Such a powerful weapon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41347,'The Horde shall tremble before me!','The Horde shall tremble before me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41348,'The Horde will taste Alliance steel!','The Horde will taste Alliance steel!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41349,'The Horde cannot win!','The Horde cannot win!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41350,'The Horde General\'s chest drops to the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41351,'Brothers, Vol\'tar has fallen!','',0,0,0,0,0,0,0,0,1,9709,0,0,26124),
(41352,'I shall not suffer the same fate as Vaurajo! Die!','',0,0,0,0,0,0,0,0,1,9709,0,0,26124),
(41353,'Face the fury of the mag\'har!','',0,0,0,0,0,0,0,0,1,9709,0,0,26124),
(41354,'Just when I thought we\'d gotten a break by getting away from those raptors, things get even worse around here.$B$BNo use bellyaching though. We\'re gonna face this like proper dwarves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41355,'Don\'t even ask about the raptors. Just don\'t.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41356,'','Welcome to our home away from home, $c. I wish we had a bit more hospitality to offer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41357,'','Be careful in the vale, $n. Enemies abound!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41358,'Show me your wares, Lyanath.','Show me your wares, Lyanath.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41359,'','Need to do some shopping?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41360,'Show me your wares, please.','Show me your wares, please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41361,'Gear all banged up, eh?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41362,'Gobber, I need to look in my pack.','Gobber, I need to look in my pack.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41363,'<These baby murlocs seem to have been abandoned here.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41364,'<These baby Rockpool murlocs seem to have been abandoned here.  You suspect that they are in trouble, and that Neptool would want you to bring them back to the ocean, where they stand a chance of escaping the naga.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41365,'<Help the Rockpool tadpoles.>','<Help the Rockpool tadpoles.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41366,'<Leave them to fend for themselves.>','<Leave them to fend for themselves.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41367,'Private Reginald Pollard, 13th brigade, Stormwind infantry... $gsir:ma\'am;.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41368,'How did you get down here?','How did you get down here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41369,'We had them in our sights... the Horde ships... then out of nowhere, tentacles reached up and seized our ship... broke it right in two!$b$bThe survivors... we were captured by naga as soon as we hit the water.$b$bThat was nearly a week ago.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41370,'What can you tell me about your captors?','What can you tell me about your captors?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41371,'Strange... never thought the naga would go out of their way to keep us alive.$b$bThey create these pearly bubbles... one per man... made it so we could breathe.$b$bEvery day they send a bunch of the prisoners off... somewhere.$b$bNever see them again....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41372,'How did you escape, Pollard?','How did you escape, Pollard?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41373,'Ahahahaha! I\'ve always been with the Grimtotem! You fools are all going to die!','',0,0,0,0,0,0,0,0,1,9715,0,0,26124),
(41374,'Another soldier somehow got free and broke a bunch of our pearls... freed us.$b$bSome swam up towards the surface... some saw this cave and swam for it.$b$bI\'m the only one that made it....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41375,'Ack!  Stay back, $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41376,'Did you see Captain Taylor and his men?','Did you see Captain Taylor and his men?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41377,'No telling...$b$bThey brought new soldiers in every day. Horde and Alliance, both.$b$bSome would get hauled away the same day... others, like me, kept there for a week... maybe more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41378,'Are there any weaknesses we can exploit? Any holes in the naga defenses?','Are there any weaknesses we can exploit? Any holes in the naga defenses?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41379,'Don\'t even try, $r.$b$bGet out of here while you can...$b$bThere are too many... certain death...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41380,'','The blood ritual is complete... and I can now see where Loramus Thalipedes awaits you.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41381,'','Very well.  Stand back... this may get messy.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41382,'You\'ll talk sooner or later!','You\'ll talk sooner or later!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(41383,'I hope you like pain.','I hope you like pain.',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(41384,'When do your people counter-attack? Tell me and I\'ll end your suffering.','When do your people counter-attack? Tell me and I\'ll end your suffering.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(41385,'Nothing personal. We\'re just a little tired of being pushed out of our homes. Now it\'s our turn to push back.','Nothing personal. We\'re just a little tired of being pushed out of our homes. Now it\'s our turn to push back.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41386,'Tell me everything, you miserable cow!','Tell me everything, you miserable cow!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(41387,'Now that we have Freewind Post, all that\'s left is that stupid barge. Gnome and goblins. How sad your people are.','Now that we have Freewind Post, all that\'s left is that stupid barge. Gnome and goblins. How sad your people are.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41388,'I grow bored with your resistance. I\'m going to kill you now and get my answers from one of your other friends.','I grow bored with your resistance. I\'m going to kill you now and get my answers from one of your other friends.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41389,'I don\'t have time for this! Speak or die!','I don\'t have time for this! Speak or die!',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(41390,'I would like to start the Amulet Ritual, Lynnore.','I would like to start the Amulet Ritual, Lynnore.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41391,'','With the power within the amulets of Razelikh...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41392,'','... I bind you to his lair!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41393,'The city has been routed. The Azsh\'ir cry your name as a victory call. You\'ve earned much respect this day.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41394,'I\'d not expected the city to be taken so quickly. It seems we\'ll have much time to prepare for the invasion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41395,'','The summoning incantations have been prepared, but we were depending on the Crucible of Nazsharin to draw power for our spell. The artifact must be recovered.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41396,'','Mathias Shaw himself appointed me to assist the night elves.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(41397,'','Who are you, $c, to bear such a burden?',0,0,0,0,0,0,0,0,1,0,0,20733,26124),
(41398,'','Protector of the animals...  Slayer of dragons...  Champion of the ancients...',0,0,0,0,0,0,0,0,1,0,0,20734,26124),
(41399,'','My dearest old friend Nordu has bestowed to you a great gift, $r. The gift of life.',0,0,0,0,0,0,0,0,1,0,0,20735,26124),
(41400,'','Now I entrust you with an even greater responsibility.',0,0,0,0,0,0,0,0,1,0,0,20736,26124),
(41401,'','By your hand, this mountain will bloom again. It is yours to protect and defend.',0,0,0,0,0,0,0,0,1,0,0,20737,26124),
(41402,'','See that it thrives. Drive out those who would do it harm. Do this in my name.',0,0,0,0,0,0,0,0,1,0,0,20738,26124),
(41403,'','There will be no second chances, $r.',0,0,0,0,0,0,0,0,1,0,0,20739,26124),
(41404,'$n! You did it! I can\'t believe my eyes... the Inferno is gone... What has Aessina done!?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(41405,'Elune help us.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41406,'What will become of us? Of Stonetalon?','',0,0,0,0,0,0,6,7,1,0,0,0,26124),
(41407,'Garrosh Hellscream, curse the day you were born.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41408,'We teeter on the brink of annihilation. Is there no one left to help us?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41409,'The future of Kalimdor looks grim.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41410,'What\'s the damage, Razzle?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(41411,'The Catacylsm has created chaos in Dun Morogh. The troggs have come to the surface in numbers we haven\'t seen before, driving our traditional enemies, the Frostmane trolls, ever closer to our settlements.$B$BIronforge has dispatched my mountaineer company to help deal with the problems.','',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(41412,'New life from the ashes of old... this is Aessina\'s gift.$B$BWithout you, this miracle never would\'ve happened.','',1,0,0,0,0,0,5,0,1,0,0,0,26124),
(41413,'<The ancient turns to gaze at you with eyes larger than your entire head. Peering into them is like falling into a deep blue ocean.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41414,'May I rest here?','May I rest here?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(41415,'Do you have any supplies?','Do you have any supplies?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(41416,'When we\'re done here, those Frostmanes will fear us more than the troggs. They\'ll have no choice but to leave.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41417,'Wha - Where  am I? Are you one of them?','Wha - Where  am I? Are you one of them?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41418,'Is it all over yet?','Is it all over yet?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41419,'Must ... return to ... Irontree!','Must ... return to ... Irontree!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41420,'You\'re not from Twilight\'s Hammer. What is happening out there?','You\'re not from Twilight\'s Hammer. What is happening out there?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41421,'I\'m burned. Badly.','I\'m burned. Badly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41422,'Twilight\'s Hammer... I heard them screaming and running... are we making a counter-attack?','Twilight\'s Hammer... I heard them screaming and running... are we making a counter-attack?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41423,'The town... demolished! We couldn\'t stop them.','The town... demolished! We couldn\'t stop them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41424,'They\'ve opened gateways to the Firelands... tell me there\'s still hope!','They\'ve opened gateways to the Firelands... tell me there\'s still hope!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41425,'On your feet, soldier. The ancients are with us, and the mountain is healed!','On your feet, soldier. The ancients are with us, and the mountain is healed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41426,'We\'re still in this fight? I\'ve got to report to Irontree!','We\'re still in this fight? I\'ve got to report to Irontree!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41427,'Thank you, $c! Back to the fight!','Thank you, $c! Back to the fight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41428,'The tide has turned? I\'ve got to get back to the fight!','The tide has turned? I\'ve got to get back to the fight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41429,'I... I think I can make it back to Irontree. We can win this!','I... I think I can make it back to Irontree. We can win this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41430,'Go on ahead, I\'ll catch up at Irontree\'s emcampment. Thank you!','Go on ahead, I\'ll catch up at Irontree\'s emcampment. Thank you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41431,'Twilight\'s Hammer is on the run? I\'ve got to get back to the front!','Twilight\'s Hammer is on the run? I\'ve got to get back to the front!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41432,'My weapons are nearby - we can regroup with Irontree.','My weapons are nearby - we can regroup with Irontree.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41433,'Your petty triumphs have been futile. The power of the Twilight\'s Hammer is absolute!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(41434,'Balgaras?! And the others...you were all dead! What foul trick is this?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41435,'Return to Thal\'darah Overlook, Battlescar Valley, Stonetalon Peak or Thal\'darah Grove or your hippogryph will drop you!','',0,0,0,0,0,0,0,0,1,7161,0,0,26124),
(41436,'Get on!','Get on!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41437,'This whole place is going to blow up! Let\'s go!','This whole place is going to blow up! Let\'s go!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41438,'Get on my hippogryph. We haven\'t much time!','Get on my hippogryph. We haven\'t much time!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41439,'Take my hand, young one.','Take my hand, young one.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41440,'Master Thal\'darah has sent me to rescue you. Climb on!','Master Thal\'darah has sent me to rescue you. Climb on!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41441,'Won\'t somebody help us?','Won\'t somebody help us?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41442,'We\'re all going to die!','We\'re all going to die!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41443,'Orcs everywhere!','Orcs everywhere!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41444,'Where is Master Thal\'darah!?','Where is Master Thal\'darah!?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41445,'HELP!','HELP!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41446,'Thank you, friend.','Thank you, friend.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41447,'I will never forget this act of kindness.','I will never forget this act of kindness.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41448,'I will repay you one day.','I will repay you one day.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41449,'All of Darnassus will know what you have done for us.','All of Darnassus will know what you have done for us.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41450,'I thought I was done for!','I thought I was done for!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41451,'Could we fly higher?','Could we fly higher?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41452,'You are a hero.','You are a hero.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41453,'Thank you. You saved my life.','Thank you. You saved my life.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41454,'Our world needs more heroes like you.','Our world needs more heroes like you.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41455,'I am forever indebted to you, friend.','I am forever indebted to you, friend.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41456,'May Elune watch over you.','May Elune watch over you.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41457,'','I will send some of my priestesses to aid you. Find the artifact quickly so that I can begin summoning our allies for the battles to come.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41458,'You will have some of my best men, do not worry Battlemaiden. Return to us quickly - I am eager to begin hunting the Tidehunter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41459,'You shall have your reinforcements, Battlemaiden. I had already intended to collect Kvaldir to labor in Nespirah, so your timing is opportune.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41460,'I am to hunt the Crucible of Nazsharin. Do you have warriors to assist me?','I am to hunt the Crucible of Nazsharin. Do you have warriors to assist me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41461,'On your knees!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41462,'Spirit of Life, lend me your aid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41463,'Grant me the clarity to speak with this creature!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41464,'Earthmender Duarn shuffles uncomfortably.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41465,'Nothing is happening... something must be preventing me from speaking with her.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41466,'This creature... she is quite old, and very wise.  We stand to learn a great deal about Vashj\'ir and the naga, if we can only speak with Nespirah.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41467,'Whenever you\'re ready, Duarn.','Whenever you\'re ready, Duarn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41468,'Let this be a lesson to all Kvaldir. You are weak! Facing Azshara brings only death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41469,'Slink back to your pathetic mist. Return and we will slaughter every last one of you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41470,'This old inn isn\'t much to look at anymore, but it makes for a great stronghold.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(41471,'Thank you!','Thank you!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41472,'You\'ve saved my life!','You\'ve saved my life!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41473,'I\'ll be glad to get out of this hellhole.','I\'ll be glad to get out of this hellhole.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41474,'You have no idea what they put us through...','You have no idea what they put us through...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41475,'The naga are monsters!','The naga are monsters!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41476,'I\'m forever in your debt, hero.','I\'m forever in your debt, hero.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41477,'Thank you!','Thank you!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41478,'You\'ve saved my life!','You\'ve saved my life!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41479,'You have no idea what they put us through...','You have no idea what they put us through...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41480,'I\'ll be glad to get out of this hellhole.','I\'ll be glad to get out of this hellhole.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41481,'The naga are monsters!','The naga are monsters!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41482,'I\'m forever in your debt, hero.','I\'m forever in your debt, hero.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41483,'They attacked while you were gone... the Admiral didn\'t make it. The rest retreated to the cave, you should do the same.','They attacked while you were gone... the Admiral didn\'t make it. The rest retreated to the cave, you should do the same.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41484,'Rejoice, for you shall be first to die. We will sweep across Khaz Modan and burn all to ash.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(41485,'I don\'t care how many times I have to kill you...I\'ll take you all on to save this land!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41486,'','Aye, and so will we!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41487,'Look there! The Krom\'gar balloon is heading towards the grove! We must hurry!','',0,0,0,0,0,0,0,7,1,9749,0,0,26124),
(41488,'We\'re too late. The grove is destroyed and with it our hopes and dreams.','',0,0,0,0,0,0,0,7,1,9749,0,0,26124),
(41489,'The Horde will pay for this atrocity. Hellscream must answer for this crime!','',0,0,0,0,0,0,0,7,1,9749,0,0,26124),
(41490,'What luck! The offerings throw themselves upon the altar!','',0,0,0,0,0,0,153,0,1,0,0,0,26124),
(41491,'ATTACK! LET NONE SURVIVE!','',0,0,0,0,0,0,153,0,1,0,0,0,26124),
(41492,'FOR KHAZ MODAN!','FOR KHAZ MODAN!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41493,'Burnnnnnnn...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41494,'Flesh, living flesh...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41495,'Give yourself to the flame.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41496,'Brittle bones and stringy flesh. Come, come! Feed the flames!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41497,'Blaze bright and fade away, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41498,'Join me in darkness and fire.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41499,'Your suffering fans the flames!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41500,'Become one with the fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41501,'','What is it, Elder? I\'ve never seen anything like it... not even when Teldrassil was sick.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41502,'','I do not know, sentinel. What I sense is dark magic. Pure evil.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41503,'','Is it the Horde? Could they be responsible for the corruption?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41504,'','No, dear, this is something far worse than the Horde. The darkness emanating from Stonetalon Peak is ancient. Older than the world itself.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41505,'','How will we survive, Elder? How can we fend off the Horde and this ancient evil force?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41506,'','I do not know, child.',0,0,0,0,0,0,274,7,1,0,0,0,26124),
(41507,'','A dark force grips Stonetalon Peak.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(41508,'I cannot fathom the origin or purpose of this place.$B$BThese corridors are used for troop movements, yes, but they\'re also littered with charred and tortured corpses, some partially devoured, most simply crushed and beaten.$B$BWe are in the Firelands, but I feel as though we\'ve crossed the threshold into hell.','',274,1,0,0,0,0,0,0,1,0,0,0,26124),
(41509,'I lost my turtle companion. Can I have another?','I lost my turtle companion. Can I have another?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41510,'Of course, $n. You rescued these turtles from the Twilight\'s Hammer - they will follow you anywhere.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41511,'How do you get yourself into these messes, Poppy???','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41512,'What is this thing anyway? I\'ll just hit it some more with my wrench. Hopefully the violent beatings will fix whatever is broken.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41513,'Next time, Poppy... Next time...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41514,'\"Absolutely, yes, I will take the job in Stonetalon Mountains to fix night elf junk.\" Poppy, you\'re an idiot.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41515,'Maybe this thing\'s crazy wings will collapse on top of me and put me out of my misery. I\'ll just hit it harder and faster to help speed this along.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41516,'%s approaches the Nemesis Crystal and cautiously examines it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41517,'You will be removed from the Darnassian Glaive Thrower if you do not return to Thal\'darah Overlook or Battlescar Valley.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41518,'Little $r. You are in MY realm now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41519,'If you want your rams back, come get them, cowards!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(41520,'%s is about to erupt! Get under Tooga\'s shell!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41521,'Does anyone hear something strange?','Does anyone hear something strange?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(41522,'There it is again! I know I heard something!','There it is again! I know I heard something!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(41523,'Frostmane raiders! Sound the alarm!','Frostmane raiders! Sound the alarm!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(41524,'To arms, mountaineers! Take back those rams!','To arms, mountaineers! Take back those rams!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(41525,'The Frostmane trolls have been raiding the ranch continuously.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(41526,'As it is, there are barely enough of us to keep them from taking everything.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(41527,'They just take the rams and go. The herd can\'t take any more.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41528,'One of the mountaineers has seen something. Keep your eyes open!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(41529,'We\'ve done it! Good work, lads!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(41530,'Let\'s speak with Nespirah.','Let\'s speak with Nespirah.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41531,'Kkkk... aaahhh...!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41532,'What\'s happening?  Can you hear me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41533,'I can\'t see you, but I can sense your presence.  I\'ll explain what I can.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41534,'The naga are suppressing my will.  I can feel what they\'re doing, but I am powerless to act.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41535,'They mine my pearls, they carve my body, and they distort my mind.  I can feel my will breaking, strangers... they mean to use me for war!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41536,'I will NOT be a tool of the naga.  I will resist as long as I can, but I can\'t last forever.  Please, someone, stop them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41537,'Thank you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41538,'I thought I would die down here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41539,'I thought they were going to tear me apart!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41540,'Light bless you, stranger. You\'ve saved me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41541,'You\'re the best thing I\'ve seen since the troggs showed up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41542,'I can\'t wait to get home to my family. Thank you, stranger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41543,'I\'ve tried explaining to Salsbury time and time again that there is no possible way that I could transform him into a worgen. He refuses to listen and has instead convinced himself that if he gains my trust I will let him in on the secret.$B$BGnomes are very strange.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(41544,'Listen up! FALL IN!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41545,'Overlord Krom\'gar has called for infantry in Stonetalon Mountains.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41546,'We\'re gonna march in there and do one thing and one thing only:','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41547,'KILL ALLIANCE!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41548,'','Ahem. Don\'t forget about the bomb, Aldo.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41549,'Correction. We\'re gonna do TWO things:','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41550,'KILL ALLIANCE and make sure our new goblin bomb gets to Stonetalon in one piece...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41551,'And then use it to KILL ALLIANCE!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41552,'Now, do I have any volunteers?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41553,'Sounds good. First battalion prepare yourselves! And never forget...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41554,'Hellscream\'s eyes are upon you!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41555,'Her body appears even larger from the inside.  Fascinating!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41556,'Look, $r.  I see man and orc, chained up as slaves, mining Nespirah\'s pearls.  And I see naga holding the whip.  Something must be done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41557,'What\'s this over here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41558,'Goldrinn\'s tenacity is the stuff of legend.$B$BWarriors from all walks visit this shrine in hopes of tapping into that kind of battle prowess. ','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(41559,'You are too late, you foolsss!  The ancient one\'sss will is broken!  The processs is nearly complete!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41560,'Now, you will watch as I complete the ritual and turn the beast against you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41561,'No!  Nessspirah belongsss to the naga!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41562,'Aghhh!  My sssphere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41563,'No!  My bubble is weakening!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41564,'Nessspirah!  Why do you turn againssst me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41565,'It isss done!  Nessspirah isss mine!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41566,'Hold on tight, it\'s gonna be a bumpy ride. Be on the lookout for night elves!','',0,0,0,0,0,0,0,1,1,9767,0,0,26124),
(41567,'Got another shipment of fresh meat for you, Saurboz. Let\'s hope these ones don\'t end up back as corpses on my wagon like the last battalion.','',0,0,0,0,0,0,0,1,1,9767,0,0,26124),
(41568,'Few things I like more than killing Alliance.','',0,0,0,0,0,0,0,1,1,9767,0,0,26124),
(41569,'What could an orc as depraved as you enjoy more than killing Alliance, Utvoch?','',0,0,0,0,0,0,0,1,1,9767,0,0,26124),
(41570,'You know I can\'t resist tauren women, Donty. They\'re my one weakness...','',0,0,0,0,0,0,0,1,1,9767,0,0,26124),
(41571,'You are a sick, sick orc, Ut.','',0,0,0,0,0,0,0,1,1,9767,0,0,26124),
(41572,'More fodder for the Horde war machine.','',0,0,0,0,0,0,0,1,1,9767,0,0,26124),
(41573,'Looks like we\'ve got some of Rockrain\'s soldiers here. Dontrag, Utvoch, we\'re gonna need your expertise over at Krom\'gar Fortress.','',0,0,0,0,0,0,0,1,1,9767,0,0,26124),
(41574,'As for the rest of you grunts, suit up! We got some killin\' to do.','',0,0,0,0,0,0,0,1,1,9767,0,0,26124),
(41575,'In all my days, $r, I\'ve never seen such a thing...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41576,'We are poorly equipped to do battle here.$b$bPreparations must be made...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41577,'Yes, sir! Let\'s go Ut.','',0,0,0,0,0,0,0,1,1,9767,0,0,26124),
(41578,'You got shiny?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41579,'What\'s it got in its pockets? Hmm?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41580,'We kill them and we take their stuffs...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41581,'What you bring us? Treasures from the surface?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41582,'Morale is growing higher, thanks to your efforts, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41583,'If we find a way to fight our way out of here, Hellscream will know of your deeds, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41584,'These orcs and I have served together through many battles.$b$bI do not envy any naga that enters this place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41585,'They\'re upon us! Hurry, $n, my axe thirsts for the blood of these naga!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41586,'The naga! They\'ve followed $n back to the ship!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41587,'He never gave up - Captain Irontree - said he\'d make them pay for every inch of ground they defile. He may still be alive down there!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(41588,'Blood and Thunder!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41589,'For Hellscream!','',0,0,0,0,0,0,71,0,1,0,0,0,26124),
(41590,'Axes ready! The enemy approaches!','',0,0,0,0,0,0,0,0,1,11839,0,0,26124),
(41591,'They swarm us, shaman! Make yourself useful!','',0,0,0,0,0,0,0,0,1,11839,0,0,26124),
(41592,'Keep your wits, warriors! There are naga yet to kill!','',0,0,0,0,0,0,0,0,1,11839,0,0,26124),
(41593,'%s gasps for air and shivers in the cold.','%s gasps for air and shivers in the cold.',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(41594,'Mix and stir, apply heat...','',0,0,0,0,0,0,0,0,1,0,19851,0,26124),
(41595,'How well does the mortal shell handle extreme temperature change? Must find out! For science!','',0,0,0,0,0,0,0,0,1,0,19853,0,26124),
(41596,'This one\'s a little unstable, but what\'s progress without failure?','',0,0,0,0,0,0,0,0,1,0,19852,0,26124),
(41597,'I have secured escape for us, $n.  You are to come with me.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(41598,'Duarn - excellent work.  Do not dally long within Nespirah\'s shell.  You know as well as I do the dangers posed by an angry demigod.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(41599,'Now, follow me!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(41600,'Board the seahorse, friend.  You probably do not want to be near Nespirah when she turns on the naga.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(41601,'K-k-k-k-kkkah!  I am freed from the naga\'s servitude, and my will is once again my own!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41602,'My body is already starting to fight the naga infection.  Please, I ask you to get to safety before I unleash my wrath!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41603,'You may leave now, friend.  The tauren\'s friend Erunak should be waiting outside with seahorses.  In fact, it looks like he is here now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41604,'Worry not, Erunak.  The tauren will be safe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41605,'What are we waiting for?  Let\'s go!','What are we waiting for?  Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41606,'Warriors! Make \'em Bleed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41607,'For the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41608,'Stand your ground... fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41609,'Fight like the orcs you were born to be! There is no retreat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41610,'We are... beaten. Escape if you can...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41611,'Thrall\'s balls! They\'re everywhere...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41612,'Nazgrim! They have me....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41613,'Grahhhh!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41614,'%s becomes impaled on the spike, exposing his head!','',0,0,0,0,0,0,0,0,1,0,8717,0,26124),
(41615,'Amazing!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(41616,'This job is well-suited for you, Duarn.  I must attend to matters outside.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(41617,'Good luck to you too, $n.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(41618,'','Let me have a look at that shard, would you Captain?  I could feel its power radiating from the other side of the cave.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41619,'Not good enough....','',0,0,0,0,0,0,0,0,1,0,17504,0,26124),
(41620,'Can\'t complain about the materials down here. Substitutes for everything. Substitutes for substitutes. Gimme a few days and I\'ll build a aquatic hotrod out of kelp and shells!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41621,'The Horde has lost control of the Stoneward Prison!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41622,'The Alliance has lost control of the Stoneward Prison!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41623,'The Alliance has taken control of the Stoneward Prison!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41624,'The Horde has taken control of the Stoneward Prison!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41625,'When pushed to the edge, results may become unpredictable...','',0,0,0,0,0,0,0,0,1,0,19854,0,26124),
(41626,'The Horde has lost control of Merchant Quarter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41627,'The Alliance has lost control of Merchant Square!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41628,'The Alliance has taken control of Merchant Quarter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41629,'The Horde has taken control of Merchant Quarter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41630,'The Horde has lost control of the Cathedral Quarter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41631,'The Alliance has lost control of the Cathedral Quarter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41632,'The Alliance has taken control of the Cathedral Quarter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41633,'The Horde has taken control of the Cathedral Quarter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41634,'The Horde has lost control of Greymane Court!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41635,'The Alliance has lost control of Greymane Court!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41636,'The Alliance has taken control of Greymane Court!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41637,'Oh gods! It\'s not dead! RUN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41638,'The Horde has taken control of Greymane Court!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41639,'Don\'t eat my head!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41640,'I\'m too young to die! Hell, I\'m too pretty to die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41641,'HELP!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41642,'Somebody kill it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41643,'Mommy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41644,'It\'s all your fault! It was supposed to be dead! Now it ate your brains!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41645,'Get away! Get away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41646,'We\'re all going to die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41647,'|cFF68228BDIE.|r','|cFF68228BDIE.|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41649,'|cFF68228BI COME FROM BELOW.|r','|cFF68228BI COME FROM BELOW.|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41650,'|cFF68228BINSIGNIFICANT MORTALS.|r','|cFF68228BINSIGNIFICANT MORTALS.|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41651,'|cFF68228BYOU WILL SERVE ME AND THEN DIE PAINFULLY.|r','|cFF68228BYOU WILL SERVE ME AND THEN DIE PAINFULLY.|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41652,'|cFF68228BI SEE YOU.|r','|cFF68228BI SEE YOU.|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41653,'|cFF68228BYOUR WORLD CRUMBLES BEFORE YOU.|r','|cFF68228BYOUR WORLD CRUMBLES BEFORE YOU.|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41654,'|cFF68228BYOU WILL NOT SURVIVE.|r','|cFF68228BYOU WILL NOT SURVIVE.|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41655,'|cFF68228BYOUR SIMPLE MIND CANNOT GRASP WHAT IS TRANSPIRING.|r','|cFF68228BYOUR SIMPLE MIND CANNOT GRASP WHAT IS TRANSPIRING.|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41656,'','Filthy beast!',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(41657,'','Leave our lands!',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(41658,'','Not so fast!',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(41659,'This place isn\'t quite as cool as the ruins, and the air in here is a bit humid if I do say so myself, but it does have a comfy, home feel to it.$B$BDon\'t you think?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(41660,'Hexascrub, let me see that merciless one again.','Hexascrub, let me see that merciless one again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41661,'I don\'t know about you, but I really miss the unlimited raw materials that were down in the ruins!$B$BI\'m not even sure if I could make a dud grenade out of the little that can be scrounged in this cave!','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(41662,'Fiasco, I need to see that merciless corpse again.','Fiasco, I need to see that merciless corpse again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41663,'Naga.$B$B<Vilethorn spits on the ground in disgust.>$B$BIt was foolish of them to think they could make an orc labor at their whip. We will make every last one of them regret not killing us when they had the chance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41664,'Welcome, friend.\n\nWe have little to offer by way of supplies, but I will assist you however I can.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(41665,'My rescue plan is brilliant. Infallible. Only a goblin could possibly stop me from succeeding. A goblin with fins. Scary thought.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41666,'Gah! Orcs... This is gunna take some gettin\' used to...','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(41667,'','Wake up, Mr. D!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41668,'Return to Durotar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41669,'','All good girls listen to their daddies!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41670,'','Are you there, Mr. D?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41671,'','Wake up, Mr. D! You\'ve gotta save the spirits!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41672,'What the... $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41673,'','This is marbles and conkers!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41674,'','This is crazy you idiots!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41675,'From the moment the wild creatures first stirred on Azeroth, Goldrinn was there. His is the spirit of the hunter, the animal instinct that kicks in when wild things smell food or feel their children are in jeopardy. He appears as a great white wolf, ferocious and cunning.$B$BHe\'s known across all cultures. The orcs even have their own name for him: \"Lo\'Gosh.\"$B$BTen thousand years ago, when demons first breached Azeroth, Goldrinn stood with the other ancients to mount a desperate defense.','',1,273,0,0,0,0,0,0,1,0,0,0,26124),
(41676,'It was during those darkest of days that Goldrinn\'s tenacity in war became legendary. While others quaked at the visage of those demon hordes, their multitudes only spurred the great wolf ancient to ever greater feats of strength. He would wade into their ranks, fangs bared and spattered with their vile ichor, his great claws thrashing them by the dozen...$B$BIt was said he stayed behind to cover the Night Elf retreat from Eldre\'Thalas, the ancient city we know now as Dire Maul.$B$BDid he die? I\'m not certain the spirit of animal ferocity can ever truly die, $n.','',5,1,274,0,0,0,0,0,1,0,0,0,26124),
(41677,'Coming or going?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(41678,'Let me see your wares, Felonius.','Let me see your wares, Felonius.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41679,'The tenacity of the wolf ancient is the stuff of legend.$B$BLearn from his example, $c, and victory is all but certain.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(41680,'Lo\'Gosh is the spirit of the hunter, the animal instinct that kicks in when one smells food or sees one\'s children in jeopardy. He has always been with us, a part of our Horde, in our instincts and in our blood.$B$BHe has appeared in many forms, both on our world and here. On Azeroth, he is seen as a great white wolf, ferocious and cunning. The night elves call him \"Goldrinn.\"$B$BThey tell of a legendary battle ten thousand years ago, where Lo\'Gosh fought off the demon hordes. Do you want to hear about it?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(41681,'Ten thousand years ago demons first breached this world, just as they had the orc homeworld of Draenor. They flooded across the terrain in legion. The great ancients of Azeroth helped the mortal races to mount a desperate defense.$B$BThe tenacity of Lo\'Gosh in these dark days became the stuff of legend. He feared no demon. He would wade into their ranks, fangs bared and spattered with their vile ichor, his great claws thrashing them by the dozen...$B$BHis stand against the demons inspires us all. We can all learn from his example.','',1,5,1,0,0,0,0,0,1,0,0,0,26124),
(41682,'','Fair Aviana, the Mistress of Birds! All winged creatures of Azeroth once owed her allegiance, especially we Druids of the Talon. It\'s by her grace that we were granted the ability to shift forms and take to the skies.$B$BAviana was both beautiful and terrible, like the great birds of prey she counted among her children. She lived in the towering spirit realm of G\'Hanir, the Mother Tree, but appeared on Azeroth in the form of a great winged goddess.',1,273,0,0,0,0,25,0,1,0,0,0,26124),
(41683,'','<Choluna\'s face darkens.>$B$BTen thousand years ago demons flooded across Azeroth in the War of the Ancients. Aviana called her children to the skies and fought off the demon hordes from the front lines. Her wrath was inescapable.$B$BHundreds fell before the fury of her talons. But ultimately she was surrounded by Doomguards, their barbed lances piercing her sides...$B$BIt is said that her blood itself attacked the demons, searing their flesh, destroying them even as she herself fell from the sky.',274,1,0,0,0,0,25,0,1,0,0,0,26124),
(41684,'','Aviana perished on the battlefield that day, but the mortal races and the remaining ancients ultimately triumphed. The first druids found her body among the carnage, and bore it up here, to the highest mountain.$B$BShe was laid to rest just outside this shrine, within a circle of sacred stones.$B$BA seed of G\'Hanir was used to plant the World Tree, and it is all that remains of that sacred realm, which otherwise perished with her.',274,1,274,0,0,0,0,0,1,0,0,0,26124),
(41685,'','We mortal races know so little of Aessina, the spirit of the wilderness who lurks in dense untamed woods. She is the soul of the forest, its beating heart, the source of life energy that breaks down stone, devours ancient ruins, and fills dense thickets with mystery and fear. Aessina is the center of the web of life.$B$BThe night elves have built shrines to her throughout Kalimdor. She is revered, yes... But not understood.$B$BWhat would it be like, do you think, to get even a glimpse of this reclusive, powerful ancient?  ',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(41686,'Ah, Tortolla! Often misunderstood and always, always underestimated. Creatures who move effortlessly between land and sea look to Tortolla as their patron ancient.$B$BTen thousand years ago the Burning Legion invaded Azeroth, and Tortolla was among the ancients who took to the field of battle alongside Cenarius and the mortal races.$B$BAs the demon hordes crashed against the front lines of the beleaguered defenders, they didn\'t know what to make of Tortolla. At first they tried to ignore him, but his terrible weight and crushing jaws laid waste to hundreds...','',274,1,5,0,0,0,0,0,1,0,0,0,26124),
(41687,'Tortolla never fell. Eventually the greatest Doomguards of the legion surrounded him, but couldn\'t pierce his stony skin and invulnerable shell. Oh, how they raged! Tortolla held his ground and covered a final retreat, before the mortal races regrouped and managed to seal the portal and end the invasion.$B$BIt was said that after the battle, Tortolla was found underneath a mountain of demon corpses. He shook the bodies free and his head emerged from the gore. Then, quietly, slowly... he asked if we had won.$B$B<Hamuul rests a hand on his stomach and bellows a deep, unselfconscious laugh.>','',5,1,11,0,0,0,0,0,1,0,0,0,26124),
(41688,'Tell me about Goldrinn.','Tell me about Goldrinn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41689,'What happened to him?','What happened to him?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41690,'Tell me about the wolf ancient, Lo\'Gosh.','Tell me about the wolf ancient, Lo\'Gosh.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41691,'Yes, tell me more.','Yes, tell me more.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41692,'','Welcome, $c!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41693,'Tell me about Aviana.','Tell me about Aviana.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41694,'You speak in the past tense. What happened to her?','You speak in the past tense. What happened to her?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41695,'What became of her?','What became of her?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41696,'Tell me about the spirit of Aessina.','Tell me about the spirit of Aessina.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41697,'Tell me about Tortolla.','Tell me about Tortolla.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41698,'The Earthwatchers won\'t allow faction squabbling to jeopardize the Earthen Ring\'s work here.\n\nThose who break the peace will be dealt with... harshly.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(41699,'Then what happened?','Then what happened?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41700,'The Wildhammers have always embraced shamanism, aye, but to find ourselves beneath the sea as part of the Earthen Ring?\n\nIt would\'ve taken more than a few tankards for me to believe that one, a year ago.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(41701,'Further attuning yourself with the Battlemaiden, you have gained a new ability!','Further attuning yourself with the Battlemaiden, you have gained a new ability!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41702,'Our warriors... they\'re all captives now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41703,'Many of us tried to escape the naga.$b$bI am the only one who succeeded...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41704,'It makes no sense, but those vermin are going to great lengths to keep our troops alive...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41705,'Tell me your name, orc.','Tell me your name, orc.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41706,'I am Gurrok, of Hellscream\'s Vanguard.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41707,'How did you get down here?','How did you get down here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41708,'We had them!$b$bWretched Alliance ships... we could\'ve cut a path to Stormwind and put an end to them!$b$b...But out of nowhere, gigantic tentacles reached up and seized our ship... broke it right in two!$b$bThe survivors... we were captured by naga as soon as we hit the water.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41709,'Tell us about your captors, Gurrok.','Tell us about your captors, Gurrok.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41710,'Strange that the naga would go out of their way to keep us alive.$b$bThey create prisons from mystical pearls - cells that allowed us to breathe, but little else..$b$bThey ship the prisoners off... somewhere.$b$bNever see them again....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41711,'How were you able to get away?','How were you able to get away?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41712,'One of our warriors broke free and smashed many of the prisons... we were free - at least for a moment.$b$bSome swam up towards the surface... some saw this cave and swam for it.$b$bI\'m the only one that lived....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41713,'Grunts, ATTENTION!','',0,0,0,0,0,0,0,1,1,12302,0,0,26124),
(41714,'Did you see Nazgrim and his troops?','Did you see Nazgrim and his troops?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41715,'I do not know what became of them.$b$bThere was a constant flow of captives. Horde and Alliance, both - all barely alive.$b$bThey must\'ve been hauled away beyond the trench, or they have perished.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41716,'What is there to report of these beasts, Gurrok? How do we defeat them?','What is there to report of these beasts, Gurrok? How do we defeat them?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41717,'Their numbers are too many to count. Their defenses look impenetrable.$b$bI saw no weaknesses to exploit, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41718,'You hold still, fish!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41719,'Why must you taunt me so?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41720,'Oh, Captain Jewels is going to be angry...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41721,'Get... back... over... here...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41722,'AHA! A FISH!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41723,'Here, fishie fishie...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41724,'I am perplexed. Troubled by what I witness...','',0,0,0,0,0,0,0,1,1,12302,0,0,26124),
(41725,'','Get me out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41726,'','Who puts a \"dead\" sea demon on their head, really?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41727,'','Fiasco, you\'re an idiot! Next time just blow something up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41728,'','Why am I afraid of this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41729,'','I want to go home!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41730,'','Why did I ever leave Brill?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41731,'','Do not EVER bring cyclopean demonic octopi into the cove again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41732,'','Somebody kill it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41733,'','Nutmegs don\'t fail me now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41734,'','I\'m jumping jack in Gilneas on the spot!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41735,'','Hexascrub, you elekk\'s trunk? You haven\'t got a pot of glue!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41736,'','You\'re all fore and aft for putting that on!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41737,'','Knock it off of their lump of lead!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41738,'','You\'ve gone mum and dad, you have!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41739,'','I\'m gonna need me a good ol\' tiddlywink after this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41740,'How has our revered Warchief failed you?','',0,0,0,0,0,0,0,1,1,12302,0,0,26124),
(41741,'','What\'s that rabbit and pork it\'s going on about?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41742,'Your families no longer starve.','',0,0,0,0,0,0,0,1,1,12302,0,0,26124),
(41743,'Your loved ones live with shelter over their heads.','',0,0,0,0,0,0,1,1,1,12302,0,0,26124),
(41744,'Ambassador. We have been expecting you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41745,'You may walk through the streets of Orgrimmar with pride!','',0,0,0,0,0,0,5,1,1,12302,0,0,26124),
(41746,'We are the new Horde, and under Warchief Hellscream, we are masters of our own destinies.','',0,0,0,0,0,0,0,1,1,12302,0,0,26124),
(41747,'WHY THEN, have we failed to take Stonetalon Mountains?','',0,0,0,0,0,0,5,1,1,12302,0,0,26124),
(41748,'How have the Alliance been able to halt the great Horde war machine?','',0,0,0,0,0,0,0,1,1,12302,0,0,26124),
(41749,'From this day forth, failure is no longer an option.','',0,0,0,0,0,0,0,1,1,12302,0,0,26124),
(41750,'Under Hellscream\'s watchful guise, live or die, we take Stonetalon.','',0,0,0,0,0,0,0,1,1,12302,0,0,26124),
(41751,'Do not falter, for Hellscream\'s eyes are upon you all!','',0,0,0,0,0,0,0,1,1,12302,0,0,26124),
(41752,'Looking through the portal only nets you an eye full of sand.  A pool of water surrounded by desert ruins is all that you can make out.  Where could this portal lead?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41753,'Enter the Portal.','Enter the Portal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41754,'The portal shows old, ancient desert ruins.  The wind picks up, there must be a sandstorm brewing inside.  This portal must lead somewhere important, but where?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41755,'Enter the Portal.','Enter the Portal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41756,'You fools stop running around! Face it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41757,'Somebody knock that thing off of $n\'s head!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41758,'Hellscream\'s eyes are upon us all!','',66,0,0,0,0,0,0,0,1,12302,0,0,26124),
(41759,'Angry, want kill gong plz.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41760,'A large humanoid hand print is embedded on the surface of the orb. A soft green glow seems to pulse within.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41761,'','These lands are the frontier of the Dark Lady\'s conquest, $n. Look upon them; in time, it shall all be in the grasp of the Forsaken.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41762,'Ha ha ha ha ha! The heroes have made it to the glorious finale. I take it you are in good spirits? Prepared for the final battle? Then gaze now upon my ultimate creation! RISE, SISTER!','',0,0,0,0,0,0,1,0,1,0,20066,0,26124),
(41763,'Help me!','Help me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41764,'Who is doing this to us?','Who is doing this to us?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41765,'What is happening?','What is happening?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41766,'The Dark Lady watch over you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41767,'How can I keep a clean inn with all of this going on? Are you going to take care of this pygmy problem?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(41768,'Goblin zombies?! What\'s next... the volcano exploding?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(41769,'The crucible looks abandoned and powerless.$BPerhaps there is a place nearby where you can attune yourself to the Battlemaiden...','The crucible looks abandoned and powerless.$BPerhaps there is a place nearby where you can attune yourself to the Battlemaiden...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41770,'','Hooray, Mr. D! You\'re back! Do you remember how to shoot all your guns? Why don\'t you take a minute to learn how to fight again! Just in case.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41771,'','Be really careful, Mr. D. If you see a big group of gnomes, use your magnetic pull! Once you\'ve got \'em all sucked up, launch \'em to their death! YAY!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41772,'','Get \'em, Mr D!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41773,'','Break their bones!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41774,'','Make \'em sorry for hurting you, Mr. D!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41775,'','YAY!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41776,'','Hurt \'em some more! MORE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41777,'','BAD, BAD, ALLIANCE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41778,'I\'m ready to help with Mr. D, kid. Let me in.','I\'m ready to help with Mr. D, kid. Let me in.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41779,'','Return to the temple immediately. The ritual will begin soon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41780,'','The Lady has requested you back at the temple, Honor Guard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41781,'','You\'re relieved, Honor Guard. Return to the temple.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41782,'','Back to the temple. I will pick up the slack here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41783,'','The Lady has sent word for your return to the temple. Do not delay.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41784,'','The priestesses will require your aid soon. The Lady requests your return.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41785,'','Fall back for the ritual. Our Lady awaits.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41786,'','The Mistress of the Tides will need your defense back at the temple. Make your way there immediately.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41787,'','Yes, Battlemaiden?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41788,'Lady Sira\'kess has sent for you. You are needed for the ritual.','Lady Sira\'kess has sent for you. You are needed for the ritual.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41789,'','I will head there immediately Battlemaiden. Thank you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41790,'','In Azshara\'s name.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41791,'','The Tidehunter will fall.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41792,'','I hope that you will grace our defense with your trident. The Kvaldir numbers are still increasing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41793,'','You do me an honor by delivering this message, Battlemaiden.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41794,'','For her grace, Lady Naz\'jar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41795,'','I will find the Mistress of the Tides immediately. Thank you for delivering this message, Battlemaiden.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41796,'','I see. Thank you for informing me personally, Battlemaiden.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41797,'Battlemaiden, you honor me with your presence. Is it time for the ritual to commence?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41798,'Yes, Fathom-Caller. The Mistress awaits.','Yes, Fathom-Caller. The Mistress awaits.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41799,'Of course. I will finish shortly and meet the Mistress at the temple. Thank you, Battlemaiden.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41800,'As you say, my lady.','As you say, my lady.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41801,'At once, my lady.','At once, my lady.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41802,'By your order.','By your order.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41803,'Immediately, my lady.','Immediately, my lady.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41804,'Understood, my lady.','Understood, my lady.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41805,'I will not delay.','I will not delay.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41806,'Of course, my lady.','Of course, my lady.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41807,'On my way.','On my way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41808,'Oof! You touch naughty spot!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41809,'Which way to go???','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41810,'Tanks!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41811,'You is friend. Tanks!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41812,'Why dis happen???','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41813,'The rifts are down and Stormwind is safe!  These portals must be the second half of their attack.$B$BQuickly! Into the portal! We must press the attack while we have the advantage!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41814,'You will be crushed in the depthsss!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41815,'Help!','Help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41816,'Let me out!','Let me out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41817,'Are we under attack?','Are we under attack?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41818,'Get me out of here!','Get me out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41819,'Let no one forget the name, $n, a true champion and savior of Stormwind!  All hail $n!','Let no one forget the name, $n, a true champion and savior of Stormwind!  All hail $n!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(41820,'%s is attracted by your dangling lure!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41821,'Long live the Dark Iron!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(41822,'Return to Holding Pens!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41823,'FIRE!','',0,0,0,0,0,0,0,0,1,12302,0,0,26124),
(41824,'DESTROY THEM ALL!','',0,0,0,0,0,0,0,0,1,12302,0,0,26124),
(41825,'MORE INCOMING! FIRE! FIRE!','',0,0,0,0,0,0,0,0,1,12302,0,0,26124),
(41826,'TEAR THE SKY ASUNDER!','',0,0,0,0,0,0,0,0,1,12302,0,0,26124),
(41827,'FOR THE HORDE!','',0,0,0,0,0,0,0,0,1,12302,0,0,26124),
(41828,'OOF!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41829,'I\'M HIT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41830,'HELP! HELP!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41831,'ALLIANCE ALL OVER THE PLACE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41832,'THIS WHOLE PLACE IS GONNA BLOW!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41833,'Throm-ka, Legionnaire!','Throm-ka, Legionnaire!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41834,'Lok\'tar ogar!','Lok\'tar ogar!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41835,'Bow your heads! $n walks among us!','Bow your heads! $n walks among us!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41836,'$g Sir:Ma\'am;!','$g Sir:Ma\'am;!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41837,'There walks a true soldier of the Horde!','There walks a true soldier of the Horde!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41838,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41839,'Hellscream\'s eyes are upon you!','Hellscream\'s eyes are upon you!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41840,'','Back!',0,0,0,0,0,0,5,0,1,11800,0,0,26124),
(41841,'Why must we ride to battle on a mercenary ship? Used to be that we\'d kill pirates as soon as look at them.','',0,0,0,0,0,0,6,0,1,0,21325,0,26124),
(41842,'','Shoo!',0,0,0,0,0,0,5,0,1,11800,0,0,26124),
(41843,'','I don\'t want to hurt you, but I will!',0,0,0,0,0,0,5,0,1,11800,0,0,26124),
(41844,'','Smell blood, do you?',0,0,0,0,0,0,6,0,1,11800,0,0,26124),
(41845,'','You\'ll not be eating me today!',0,0,0,0,0,0,25,0,1,11800,0,0,26124),
(41846,'','Away, creature of the depths!',0,0,0,0,0,0,5,0,1,11800,0,0,26124),
(41847,'','Do not force me to call upon the lightning!',0,0,0,0,0,0,5,0,1,11800,0,0,26124),
(41848,'','Stay away from Wil\'hai!',0,0,0,0,0,0,5,0,1,11800,0,0,26124),
(41849,'See those ships in dock?','',0,0,0,0,0,0,25,0,1,0,21333,0,26124),
(41850,'They\'re the only ones that have returned from battle, and they\'re being repaired.','',0,0,0,0,0,0,396,0,1,0,21334,0,26124),
(41851,'I don\'t like it either, but it boils down to this...','',0,0,0,0,0,0,396,0,1,0,21335,0,26124),
(41852,'We pay the mercs to get us out there, or our troops get no reinforcements.','',0,0,0,0,0,0,396,0,1,0,21336,0,26124),
(41853,'That makes sense, I suppose. Just doesn\'t feel right...','',0,0,0,0,0,0,396,0,1,0,21326,0,26124),
(41854,'','What you want?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41855,'Show me your goods, Denni\'ka.','Show me your goods, Denni\'ka.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41856,'Welcome to the military, recruit.','',0,0,0,0,0,0,396,0,1,0,21337,0,26124),
(41857,'OK! OK! Me do what $r wants!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41858,'Please no whip me! Me help Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41859,'Hurts! Stop!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41860,'No more hurt! Me join you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41861,'NO! ME NO HELP HORDE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41862,'Whip make me angry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41863,'Me shove whip down face!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41864,'Me make you eat whip!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41865,'You is BAD $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41866,'ME SO ANGRY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41867,'Such power! I AM INVINCIBLE!','Such power! I AM INVINCIBLE!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41868,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41869,'ALL WILL PERISH!','ALL WILL PERISH!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41870,'Death to the Grimtotem!','Death to the Grimtotem!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41871,'Death to the Alliance!','Death to the Alliance!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41872,'Cower before the Horde!','Cower before the Horde!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41873,'KILL PINK SKINS! KILL! KILL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41874,'Champion $n!','Champion $n!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41875,'You bring great pride to the Horde, Champion $n.','You bring great pride to the Horde, Champion $n.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41876,'Orders, $g sir:ma\'am;?','Orders, $g sir:ma\'am;?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41877,'Champion $n fights alongside us! We cannot lose!','Champion $n fights alongside us! We cannot lose!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41878,'$g Sir:Ma\'am;, would you sign my weapon? My young ones would be most thankful.','$g Sir:Ma\'am;, would you sign my weapon? My young ones would be most thankful.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41879,'The Alliance must fall!','The Alliance must fall!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41880,'For the Horde! For Hellscream!','For the Horde! For Hellscream!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41881,'It is an honor to stand in your presence, Champion $n.','It is an honor to stand in your presence, Champion $n.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41882,'Hey! Hey Jibbly! This place STINKS!','Hey! Hey Jibbly! This place STINKS!',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(41883,'WATCH OUT! INCOMING TURD!','WATCH OUT! INCOMING TURD!',0,0,0,0,0,0,25,1,1,0,0,0,26124),
(41884,'I shoulda just stayed on Kezan and taken my chances with the volcano.','I shoulda just stayed on Kezan and taken my chances with the volcano.',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(41885,'I can\'t work under these conditions, man! I\'m losin\' it!','I can\'t work under these conditions, man! I\'m losin\' it!',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(41886,'This has got to be some type of health violation!','This has got to be some type of health violation!',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(41887,'Jibbly, get someone to clean up these turds!','Jibbly, get someone to clean up these turds!',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(41888,'WORST. JOB. EVER.','WORST. JOB. EVER.',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(41889,'I\'m feeling ill...','I\'m feeling ill...',0,0,0,0,0,0,462,1,1,0,0,0,26124),
(41890,'I QUIT! I\'d rather take my chances getting shot at by Alliance!','I QUIT! I\'d rather take my chances getting shot at by Alliance!',0,0,0,0,0,0,14,1,1,0,0,0,26124),
(41891,'I\'m out!','I\'m out!',0,0,0,0,0,0,14,1,1,0,0,0,26124),
(41892,'The Horde doesn\'t pay me enough for this... this crap!','The Horde doesn\'t pay me enough for this... this crap!',0,0,0,0,0,0,14,1,1,0,0,0,26124),
(41893,'Take your stinking job and stick it where the sun don\'t shine!','Take your stinking job and stick it where the sun don\'t shine!',0,0,0,0,0,0,14,1,1,0,0,0,26124),
(41894,'I\'ve had it! Find someone else to guard your precious turd filled base!','I\'ve had it! Find someone else to guard your precious turd filled base!',0,0,0,0,0,0,14,1,1,0,0,0,26124),
(41895,'I\'M MAD AS HELL AND I\'M NOT GONNA TAKE IT ANYMORE! I QUIT!','I\'M MAD AS HELL AND I\'M NOT GONNA TAKE IT ANYMORE! I QUIT!',0,0,0,0,0,0,14,1,1,0,0,0,26124),
(41896,'Find another sucker to stand watch over your enormous mound of poop. I\'m done!','Find another sucker to stand watch over your enormous mound of poop. I\'m done!',0,0,0,0,0,0,14,1,1,0,0,0,26124),
(41897,'I\'m free!  You\'ve saved me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41898,'Noooo!  Not again!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41899,'Ah!  Umm... hello there.  I was just inspecting this shell, here.  Carry on!  Nothing to see here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41900,'I stopped by the park district on my way here. There\'s nothing left of it...\n','',0,0,0,0,0,0,396,0,1,0,21351,0,26124),
(41901,'Aye. I was here when the dragon attacked.','',0,0,0,0,0,0,396,0,1,0,21353,0,26124),
(41902,'He could\'ve destroyed the entire city if he willed it. We were powerless to stop him.','',0,0,0,0,0,0,1,0,1,0,22801,0,26124),
(41903,'What drove him off, then?','',0,0,0,0,0,0,6,0,1,0,21352,0,26124),
(41904,'No idea. It made no sense...','',0,0,0,0,0,0,1,0,1,0,21355,0,26124),
(41905,'If you ask me, the beast is insane.','',0,0,0,0,0,0,396,0,1,0,21357,0,26124),
(41906,'He flew in, torched the park, then just flew off.','',0,0,0,0,0,0,1,0,1,0,21356,0,26124),
(41907,'Why are you upside-down?','Why are you upside-down?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41908,'Why is that?','Why is that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41909,'Fascinating.','Fascinating.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41910,'You will be removed from the Krom\'gar Demolisher if you do not return to Battlescar Valley.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41911,'How did you get all the way over here, then?','How did you get all the way over here, then?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41912,'Sounds impressive.','Sounds impressive.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41913,'That\'s too bad.  Anyhow...','That\'s too bad.  Anyhow...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41914,'I really need to get going now.','I really need to get going now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41915,'...','...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41916,'I seem to be having a... floating problem.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41917,'I couldn\'t tell ya.  Maybe I\'ve got a low bone density, or a larger-than average lung capacity.  Maybe it\'s all that cheese I had for lunch.$b$bEither way, this shell is the only thing that\'s keeping me from rocketing to the surface.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41918,'Aye, and it runs in the family.  The Digsongs have always had buoyancy issues, I\'m afraid.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41919,'Hand over hand, $g lad: lass;... hand over aching hand.  I can\'t tell ya how many gallons of seawater went right up my nose.$b$bYou shoulda seen me fight off that pyreshell crab using my feet and my teeth, though!  \'Twas a thing of glory, \'twas.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41920,'I remember when I was just a wee little lad... the other boys would swim down to the bottom of Loch Modan to pick up sand dollars and seashells.  Oskar and I were stuck on the lake\'s surface, kicking our legs uselessly into the air, but we couldn\'t join them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41921,'I can\'t even remember how many times I\'ve spotted a beautiful mining vein at the bottom of a lake or river, glimmering mockingly at me.  I\'m forced to float orelessly by, mining pick in hand, only to watch some blasted orc or blood elf swim down to the bottom and take it away from me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41922,'Ya have no idea what it\'s like to be stuck here in Vashj\'ir like this!  Do ya know how many fish have confused me for a piece of seaweed, nibbling on my toes and hiding between pieces of my armor?$b$bThe tickling alone is enough to drive a dwarf mad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41923,'I can tell ya don\'t want to hear my grumbling.  That\'s fine.$b$bJust don\'t forget how lucky you are, with your \"sea legs\" and your \"ability to swim in a direction other than up\".','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41924,'Earthquakes every other day, a crazy dragon tearing up the world, what\'s next?','',0,0,0,0,0,0,6,0,1,0,21327,0,26124),
(41925,'Put all of that out of your head, recruit.\n','',0,0,0,0,0,0,396,0,1,0,21343,0,26124),
(41926,'I\'ve been fightin\' Horde for ten years now, and I\'ve never seen it worse than this.','',0,0,0,0,0,0,396,0,1,0,21342,0,26124),
(41927,'Just stay focused on the battle in front of us, or you won\'t live to worry about the rest.','',0,0,0,0,0,0,396,0,1,0,21344,0,26124),
(41928,'Where\'d you ship in from, soldier?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(41929,'Just arrived from the Barrens.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41930,'Hairy? You heard wrong. It\'s downright desperate!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(41931,'I couldn\'t believe it when they ordered half of us to ship out...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41932,'Ahh, the Battle Scar. Pretty hairy out there, I hear.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41933,'Goutgut very special. Goutgut am first to get to crush puny humans in new place.$B$BGoutgut so happy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41934,'','Victory for Sylvanas! These lands will be ours.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41935,'Without reinforcements, our positions there will be overrun in days.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41936,'Light be with them, brother - and with us, for that matter. We\'re spread pretty thin these days.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(41937,'We\'ve destroyed hundreds of elementals, $n, and now they seem to be gaining strength!  Our guards are holding firm, but I\'m sure they could use your support.  King Varian Wrynn is leading the defense in the Trade district, Lady Jaina Proudmoore is helping defend the Mage district and Archbishop Benedictus is holding firm at the Cathedral of the Light.$b$bNo matter where you go in Stormwind, $n, you will be more than helpful.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41938,'$n! Stormwind is under siege by elementals and needs your strength!$b$bWe\'ve evacuated most of the city.  King Wrynn is holding the Trade District while Lady Proudmoore and the Archbishop defend the Mage and Cathedral Districts.$b$bWherever you go, you\'ll be of great help.\n','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41939,'We\'ve beaten back the elementals, $n.  But they have left behind odd portals.$b$bThe King has gone through the portal, contrary to reason, to see where they lead. The portals have been reported in the Trade district, Cathedral district and Mage district$b$bI must remain here to see to the clean up of the city and the return of the citizens.  Go and help the King!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(41940,'Your claims are outrageous, General.','',0,0,0,0,0,0,25,1,1,0,0,0,26124),
(41941,'The only thing you will find at Thal\'darah Grove are terrified young druids. They have no weapon of mass destruction.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41942,'Careful, tauren, your words could be construed as treason.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41943,'Yessir.','',0,0,0,0,0,0,24,0,1,0,21328,0,26124),
(41944,'My scouts have informed me that the grove holds a powerful weapon. A weapon that the Alliance will use against us if they are not stopped.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41945,'Furthermore, I am here by the authority of Overlord Krom\'gar, who was himself appointed by our Warchief, Garrosh Hellscream. You will do his bidding or suffer the consequences.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41946,'I have sent my boy to Thal\'darah Grove to fetch you proof. You will soon see that they pose no threat to us.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41947,'Arf!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41948,'%s seems to be appreciative.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41949,'I\'m not going anywhere until I find her!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41950,'I think I can just make it out from here. Right on the edge of the horizon.','',0,0,0,0,0,0,25,0,1,0,21345,0,26124),
(41951,'The new island - just surfaced after the last earthquakes.','',0,0,0,0,0,0,1,0,1,0,21346,0,26124),
(41952,'It\'s what we\'re fighting for. On this front, at least.','',0,0,0,0,0,0,1,0,1,0,21347,0,26124),
(41953,'This\'ll be my third time now.','',0,0,0,0,0,0,273,0,1,0,21348,0,26124),
(41954,'Toughest fighting I\'ve seen...','',0,0,0,0,0,0,1,0,1,0,21349,0,26124),
(41955,'We lose that island to the Horde and Stormwind\'s as good as gone... and they know it.','',0,0,0,0,0,0,1,0,1,0,21350,0,26124),
(41956,'','My baby boy... NO!!!!! WHY!???',0,0,0,0,0,0,18,1,1,0,0,0,26124),
(41957,'Masha, go to our tent and hide yourself away.','Masha, go to our tent and hide yourself away.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41958,'I will not leave you! Do not forget that I am the huntress in this family!','I will not leave you! Do not forget that I am the huntress in this family!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41959,'%s sighs.','%s sighs.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41960,'Oh Masha...','Oh Masha...',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(41961,'That\'s enough, soldier.','',0,0,0,0,0,0,1,0,1,0,21207,0,26124),
(41962,'Stormwind still stands, and we won\'t be losing anything to the Horde!','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(41963,'GENERAL! Come out from your tent and face me!','GENERAL! Come out from your tent and face me!',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(41964,'Now get your minds right! We\'ll be killing orcs within the hour.','',0,0,0,0,0,0,1,0,1,0,21208,0,26124),
(41965,'Make what out, exactly?','',0,0,0,0,0,0,6,0,1,0,21329,0,26124),
(41966,'Have you been there?','',0,0,0,0,0,0,6,0,1,0,21330,0,26124),
(41967,'Yeah, I... I think I can see it too.','',0,0,0,0,0,0,6,0,1,0,21331,0,26124),
(41968,'Foolish old tauren, you dare display such disrespect?!','Foolish old tauren, you dare display such disrespect?!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41969,'What is the meaning of this interruption?','What is the meaning of this interruption?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41970,'Did you lose this, General?','Did you lose this, General?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41971,'My insignia! Yes. I did lose it. Where did you find it, tauren?','My insignia! Yes. I did lose it. Where did you find it, tauren?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41972,'$n found it.','$n found it.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41973,'On the corpse of my only child, you miserable son of a pig.','On the corpse of my only child, you miserable son of a pig.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41974,'%s laughs.','%s laughs.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41975,'Your boy was weak. Spineless. Just like his father.','Your boy was weak. Spineless. Just like his father.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41976,'And as for you, $n, disappointing. You are a disgrace to the Horde!','And as for you, $n, disappointing. You are a disgrace to the Horde!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41977,'The punishment for you all is DEATH!','The punishment for you all is DEATH!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(41978,'That was for my son!','That was for my son!',0,0,0,0,0,0,15,1,1,0,0,0,26124),
(41979,'Masha, we have to run. We must get far away from here. They will come for us.','Masha, we have to run. We must get far away from here. They will come for us.',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(41980,'Thank you for returning Wolf.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41981,'For the Alliance!','For the Alliance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41982,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41983,'Listen up! Our transport should be here momentarily.','',0,0,0,0,0,0,22,0,1,0,21204,0,26124),
(41984,'Fall in!','',0,0,0,0,0,0,22,0,1,0,21205,0,26124),
(41985,'Alright, folks... Once task 37066 is implemented, the boat will arrive \'now-ish\'. In the meantime, I invite you to join us in a little dance to fill the time...','',0,0,0,0,0,0,24,0,1,0,0,0,26124),
(41986,'Don\'t be shy now, we\'re all friends here...','',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(41987,'Alright, men! Move out!','',0,0,0,0,0,0,4,0,1,0,21206,0,26124),
(41988,'We bring victory...','We bring victory...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41989,'I laugh at you, feeble $n, but I will oblige. Now, let us return to my master, below!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41990,'Someone is using these beakers and alchemy tools to perform experiments with various types of submarine fuel.','Someone is using these beakers and alchemy tools to perform experiments with various types of submarine fuel.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41991,'Our people were held as prisoners, as slaves, in this very camp by the humans. I was locked in these cages; I saw my brothers held in these stocks, hung in these gallows.$B$BI saw Orgrim Doomhammer, leader of us all, stabbed in the back. His blood stained black the earth we stand on.$B$BAnd look at us now. This is our legacy: Hammerfall, where we lost everything, and then took it back with our own hands.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41992,'Several small samples of oil sit in front of you, along with an empty beaker.  The beaker looks like it can probably fit about five samples inside of it.$b$bWhat kind of oil will you take first?','Several small samples of oil sit in front of you, along with an empty beaker.  The beaker looks like it can probably fit about five samples inside of it.$b$bWhat kind of oil will you take first?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41993,'What type of oil will you select next?','What type of oil will you select next?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41994,'You now have two samples of oil.  Which sample will you select next?','You now have two samples of oil.  Which sample will you select next?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41995,'You now have three samples.  Which sample will you select next?','You now have three samples.  Which sample will you select next?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41996,'You have four samples, and only have room to test one more.  Which one will it be?','You have four samples, and only have room to test one more.  Which one will it be?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41997,'You have selected all five of your samples.','You have selected all five of your samples.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41998,'Terrapin Oil Sample','Terrapin Oil Sample',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(41999,'Remora Oil Sample','Remora Oil Sample',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42000,'Hammerhead Oil Sample','Hammerhead Oil Sample',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42001,'You can use these beakers and alchemy tools to perform experiments with various types of submarine fuel.','You can use these beakers and alchemy tools to perform experiments with various types of submarine fuel.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42002,'Let\'s get started!','Let\'s get started!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42003,'Mix the samples together!','Mix the samples together!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42004,'I want to start over.','I want to start over.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42005,'','How dare you storm into my throne room and attempt to spread this conspiratorial nonsense!',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(42006,'','I will not let you and this treasonous Commander Stonebreaker steal my son\'s birthright!',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(42007,'That is quite an accusation, Moira. It\'s hardly your throne room in the first place.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(42008,'I know Commander Stonebreaker and I will vouch for his loyalty and his honesty. We must take his word.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42009,'Here, I made a Billowing Fuel Sample.  It\'s really smoky!','Here, I made a Billowing Fuel Sample.  It\'s really smoky!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42010,'Here, I made an Atomic Fuel Sample.  It seems to be a little too hot.','Here, I made an Atomic Fuel Sample.  It seems to be a little too hot.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42011,'Here, I made an Anemic Fuel Sample.  It seems... weak.','Here, I made an Anemic Fuel Sample.  It seems... weak.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42012,'What cause do the Dark Irons have for taking up arms against Ironforge? Are you unable to control your own people, Moira?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(42013,'Here, I made a Perduring Fuel Sample.  What do you think?','Here, I made a Perduring Fuel Sample.  What do you think?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42014,'Here, I made a Smoky Fuel Sample.  Pretty, isn\'t it?','Here, I made a Smoky Fuel Sample.  Pretty, isn\'t it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42015,'Here, I made a Quick-Burning Fuel Sample.  Is this good enough?','Here, I made a Quick-Burning Fuel Sample.  Is this good enough?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42016,'Here, I made a Promising Fuel Sample.  Three parts hammerhead and two parts remora.','Here, I made a Promising Fuel Sample.  Three parts hammerhead and two parts remora.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42017,'Muradin has a point. If you cannot govern your own people, you have no place at this table.','',0,0,0,0,0,0,273,7,1,0,0,0,26124),
(42018,'Bah!  <cough>  Far too smoky!  <cough>   Looks like you put in too much terrapin oil!  Try again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42019,'Yes, this will definitely burn too hot.  Do you want to blow up the ship?  Cut back on remora oil next time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42020,'You\'re right, far too weak.  Needs more remora.  Try it again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42021,'This looks pretty good... but it burns too long!  I need to be able to stop the fire instantly.  Cut back on hammerhead oil next time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42022,'','Both of you know I would never order such a thing! Why would I set one half my son\'s inheritance against the other?',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(42023,'We\'re getting close... but it\'s still a little too smoky.  Don\'t put in any terrapin oil next time.  <cough>  Too much smoke.  Give it another shot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42024,'How\'d you manage to make this one?  It burns like flash powder... far too quick.  Add more hammerhead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42025,'This is it!  The perfect bio-fuel!  Good work, $n!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42026,'','No, this is the work of a traitor to both our peoples. Despite my best efforts, some Dark Irons remain in the grip of Twilight\'s Hammer.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42027,'You have discovered a new type of bio-fuel!  Bring it to Engineer Hexascrub for testing.','You have discovered a new type of bio-fuel!  Bring it to Engineer Hexascrub for testing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42028,'','The cult must have someone in the city to coordinate this kind of attack. That only leaves one suspect, Ambassador Slaghammer!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42029,'Watch now, Cliffwalker, as this battle comes to its glorious conclusion.','Watch now, Cliffwalker, as this battle comes to its glorious conclusion.',0,0,0,0,0,0,1,1,1,0,20788,20788,26124),
(42030,'You are about to cross a terrible threshold, Krom\'gar. May the Earth Mother have mercy on your soul.','You are about to cross a terrible threshold, Krom\'gar. May the Earth Mother have mercy on your soul.',0,0,0,0,0,0,1,1,1,0,21554,21554,26124),
(42031,'You have discovered a new type of bio-fuel!  Bring it to Fiasco Sizzlegrin for testing.','You have discovered a new type of bio-fuel!  Bring it to Fiasco Sizzlegrin for testing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42032,'Bah!  <cough>  Far too smoky!  <cough>   Looks like you put in too much terrapin oil!  Try again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42033,'Yes, this will definitely burn too hot.  Do you want to blow up the ship?  Cut back on remora oil next time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42034,'You\'re right, far too weak.  Needs more remora.  Try it again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42035,'This looks pretty good... but it burns too long!  I need to be able to stop the fire instantly.  Cut back on hammerhead oil next time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42036,'We\'re getting close... but it\'s still a little too smoky.  Don\'t put in any terrapin oil next time.  <cough>  Too much smoke.  Give it another shot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42037,'How\'d you manage to make this one?  It burns like flash powder... far too quick.  Add more hammerhead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42038,'This is it!  The perfect bio-fuel!  Good work, $n!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42039,'Glad to see that Dark Iron scum is finally getting what he deserves!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(42040,'Quiet! Moira\'s in a foul mood and if she hears you, she\'ll have your head...','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42041,'These are grave times for Azeroth, $n.','These are grave times for Azeroth, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42042,'I need a totem to break the elemental prisons!','I need a totem to break the elemental prisons!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42043,'Do as you will with me. I am not afraid. That halfbreed runt will never be my emperor! Long live Twilight\'s Hammer!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42044,'','If we were in Shadowforge City, I would have you tossed into the Ring of Law for your transgressions, Ambassador. The darkest dungeons of Ironforge will have to do for now.',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(42045,'Look upon the world, Cliffwalker, and see the might of the Horde!','Look upon the world, Cliffwalker, and see the might of the Horde!',0,0,0,0,0,0,5,1,1,0,20789,20789,26124),
(42046,'I go willingly, $c. My purpose in my master\'s plan is fulfilled.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42047,'What have you done, Krom\'gar?','',0,0,0,0,0,0,25,1,1,0,20520,0,26124),
(42048,'I\'ll escort you to your new \'accommodations\', Your Excellency.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42049,'Warchief! I... I was carrying out your command!','',0,0,0,0,0,0,0,1,1,0,20790,0,26124),
(42050,'My command?','',0,0,0,0,0,0,6,1,1,0,20521,0,26124),
(42051,'Was my command to murder innocents, Krom\'gar?','',0,0,0,0,0,0,6,1,1,0,20522,0,26124),
(42052,'Magmaw begins to break free from the single chain binding him!','',0,0,0,0,0,0,0,0,1,0,8717,0,26124),
(42053,'Warchief... Sir... I...','',0,0,0,0,0,0,0,1,1,0,20791,0,26124),
(42054,'Am I a murderer, Krom\'gar?','',0,0,0,0,0,0,6,1,1,0,20523,0,26124),
(42055,'No, Warchief!','',0,0,0,0,0,0,0,1,1,0,20792,0,26124),
(42056,'Then I ask you again: WHAT HAVE YOU DONE!','',0,0,0,0,0,0,0,1,1,0,20524,0,26124),
(42057,'I sent you into Stonetalon Mountains with an army.  Your orders were to secure this land for the Horde.','',0,0,0,0,0,0,0,1,1,0,20525,0,26124),
(42058,'Instead, you laid waste to the land. Murdered innocents. Children even...','',0,0,0,0,0,0,0,1,1,0,20526,0,26124),
(42059,'I spent a very long time in Northrend, Krom\'gar. I learned much about the Horde in that time.','',0,0,0,0,0,0,0,1,1,0,20527,0,26124),
(42060,'While there, a wise old war hero told me something that I would carry with me forever...','',0,0,0,0,0,0,0,1,1,0,20528,0,26124),
(42061,'\"Honor,\" Krom\'gar, \"No matter how dire the battle... never forsake it.\"','',0,0,0,0,0,0,0,1,1,0,20529,0,26124),
(42062,'Overlord Krom\'gar, you have disgraced the Horde.','',0,0,0,0,0,0,1,1,1,0,20530,0,26124),
(42063,'You have brought shame to us as a people.','',0,0,0,0,0,0,1,1,1,0,20531,0,26124),
(42064,'By my right as Warchief, I hereby relieve you of duty.','',0,0,0,0,0,0,0,1,1,0,20532,0,26124),
(42065,'YOU ARE DISMISSED.','',0,0,0,0,0,0,0,1,1,0,20533,0,26124),
(42066,'And you, $r!','',0,0,0,0,0,0,25,1,1,0,20536,0,26124),
(42067,'Wait, Warchief! Please! $n was the hero responsible for uncovering this corruption. $g He:She; tried to stop Krom\'gar!','',0,0,0,0,0,0,0,1,1,0,21555,0,26124),
(42068,'Have mercy, Warchief.','',0,0,0,0,0,0,20,1,1,0,21556,0,26124),
(42069,'Mercy... Your wife and child were murdered. Your kin wiped out. Your home burned to the ground.','',0,0,0,0,0,0,0,1,1,0,20537,0,26124),
(42070,'Mercy... Chieftain, on this day I learn from you.','',0,0,0,0,0,0,66,1,1,0,20538,0,26124),
(42071,'Mountaineer Barleybrew said you could help me get to Loch Modan.','Mountaineer Barleybrew said you could help me get to Loch Modan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42075,'$n, Krom\'gar\'s army is no more. Your rank no longer has meaning. If you wish to truly help the Horde, your considerable power could be used in Desolace or in the Southern Barrens.','',0,0,0,0,0,0,0,1,1,0,20539,0,26124),
(42076,'The choice is yours to make.','',0,0,0,0,0,0,1,1,1,0,20540,0,26124),
(42077,'Let honor guide you, $n. Do not forget that Hellscream\'s eyes are always upon you.','',0,0,0,0,0,0,25,1,1,0,20541,0,26124),
(42078,'<Furien groans.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42079,'Ha ha! There\'s no way they\'ll miss that, cannon fire or not.','',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(42080,'Don\'t worry - if they try to pretend they didn\'t see it, I\'ll swim over there and drag them off of their ships myself.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42081,'We\'ve killed dozens of naga to get this far, but they still keep coming.  What will it take to escape this wretched cavern?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42082,'I don\'t care if I die inside this husk, $n.  I\'ll pay these naga back for every one of my fellow soldiers they\'ve killed or enslaved!$b$bThe others can worry about escape.  I\'ll worry about doling out punishment to these snakes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42083,'','Why are they doing this?  For pearls?  For war?  This ancient, Nespirah, is far more powerful than the naga understand.  If they\'re able to turn her towards their will... the damage they could cause would be tremendous.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42084,'Sitting here injured and watching my brothers fight is almost too much to bear, but even I understand that I\'m more valuable alive than dead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42085,'','I don\'t like the feel of this place, $n.  Naga sorceresses and slavedrivers aside... all I can sense inside this cavern is pain.  The ancient one is trying to cry out, but it cannot speak.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42086,'We need your help, $c.  We\'ve fought tooth and nail to get here, but the naga keep coming.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42087,'My wounds are not healing, $r.  I fear I may die inside this creature\'s gut if we do not act soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42088,'If you have naga blood on your hands, then you\'re an ally of mine.$b$bA long time ago, I swore I\'d never be anyone\'s slave again, and I kept that bargain until Idra\'kess captured us.  Now I can barely contain my fury.  All I want is blood... not food, not sleep, not even victory... only blood.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42089,'Aww, Budd. Now what\'d ya go an\' do that for?\n','',0,0,0,0,0,0,6,0,1,0,21277,0,26124),
(42090,'Civilians...','',396,0,0,0,0,0,6,0,1,0,21183,0,26124),
(42091,'Fall in, men!','',0,0,0,0,0,0,22,0,1,0,21184,0,26124),
(42092,'That island on the horizon is our destination.','',0,0,0,0,0,0,1,0,1,0,21185,0,26124),
(42093,'It\'s where we will do our duty, for our king, for Stormwind and for her people...','',0,0,0,0,0,0,1,0,1,0,21186,0,26124),
(42094,'Every orc you slay today will bring honor to them, and to every soldier who has come before you.','',0,0,0,0,0,0,1,0,1,0,21187,0,26124),
(42095,'Hellscream has sent his best to take this island. We shall see to it that none return home...','',0,0,0,0,0,0,1,0,1,0,21188,0,26124),
(42096,'Today Hellscream shall learn the lesson that Thrall failed to teach him...','',0,0,0,0,0,0,1,0,1,0,21189,0,26124),
(42097,'Stormwind shall never fall!','',0,0,0,0,0,0,53,0,1,0,21190,0,26124),
(42098,'You\'ve been paid good coin for non-stop passage, miss. We have no time for delays...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42099,'Now make ready, for soon we\'ll be ashore.','',0,0,0,0,0,0,1,0,1,0,21191,0,26124),
(42100,'A stake has been driven into the rock, and a long braid of rope draped around it.$B$BThis must have some purpose.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42101,'Tie your lure off and let it loose.','Tie your lure off and let it loose.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42102,'<L\'ghorek\'s voice booms inside your mind.>$B$BI AM ALMOST... DEAD. YOU MUST HELP... STOP... THE TWILIGHT\'S HAMMER.$B$BTHEY DRAIN... MY ENERGY TO... CREATE... THEIR ASCENDANTS. THEY ARE A... GRAVE THREAT IN... THE IMMINENT WAR... VERSUS... NEPTULON.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42104,'I believe you had a turtle prepared for me?','I believe you had a turtle prepared for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42107,'Tha elements be crying out in rage. It ain\'t no coincidence dat da naga are here. Dey be wantin\' someting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42108,'I am ready to join you in the vision, Farseer.','I am ready to join you in the vision, Farseer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42109,'Let me know when ya be ready ta leave.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42110,'','Budd! Noooo!',0,0,0,0,0,0,0,0,1,0,0,20915,26124),
(42111,'','Move forward! Hold the bridge!',0,0,0,0,0,0,0,0,1,0,0,21796,26124),
(42113,'Take us out, Mister Gearchum.','',0,0,0,0,0,0,1,0,1,0,19660,0,26124),
(42114,'Chart a course east with all possible speed. We\'ll rendezvous with the main fleet.','',0,0,0,0,0,0,5,0,1,0,19661,0,26124),
(42115,'What is the status on new recruits, Marshal? We desperately need more soldiers. The Blackrock orcs invading our territory must be stopped!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42116,'Oh gods, someone get me out of this cage!','Oh gods, someone get me out of this cage!',0,0,0,0,0,0,20,7,1,924,0,0,26124),
(42117,'I\'m too young to die as a sacrifice!','I\'m too young to die as a sacrifice!',0,0,0,0,0,0,1,7,1,924,0,0,26124),
(42118,'When I get out of here, I\'m going to kill every last one of you Twilight\'s Hammer scum!','When I get out of here, I\'m going to kill every last one of you Twilight\'s Hammer scum!',0,0,0,0,0,0,5,7,1,924,0,0,26124),
(42119,'You don\'t have to sacrifice me. I\'d make a great cultist!','You don\'t have to sacrifice me. I\'d make a great cultist!',0,0,0,0,0,0,5,7,1,924,0,0,26124),
(42120,'You cultists are cowards. You make me sick!','You cultists are cowards. You make me sick!',0,0,0,0,0,0,5,7,1,924,0,0,26124),
(42121,'Hey you. Yeah, you. You\'re not one of the cultists. Get me out of here!','Hey you. Yeah, you. You\'re not one of the cultists. Get me out of here!',0,0,0,0,0,0,1,7,1,924,0,0,26124),
(42122,'One of them has the key. Find it and get me out of here!','One of them has the key. Find it and get me out of here!',0,0,0,0,0,0,1,7,1,924,0,0,26124),
(42123,'I never thought that it would end like this.','I never thought that it would end like this.',0,0,0,0,0,0,18,7,1,924,0,0,26124),
(42124,'Thank you, $n. Thank you!','Thank you, $n. Thank you!',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(42125,'I never thought that I\'d be rescued by you, $n!','I never thought that I\'d be rescued by you, $n!',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(42126,'I\'ll make sure to tell Captain Taylor that you\'re destroying the Hammers in here.','I\'ll make sure to tell Captain Taylor that you\'re destroying the Hammers in here.',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(42127,'$n is on the job! I better get back to the captain.','$n is on the job! I better get back to the captain.',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(42128,'They\'re transforming themselves into some kind of super-elemental they call an Ascendant. You gotta stop them, $n!','They\'re transforming themselves into some kind of super-elemental they call an Ascendant. You gotta stop them, $n!',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(42129,'I thought I was a goner for sure. Thank you, $n!','I thought I was a goner for sure. Thank you, $n!',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(42130,'See you on the other side, $g brother : sister;. Which way is out?','See you on the other side, $g brother : sister;. Which way is out?',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(42131,'What about this one, McBride? Surely this $c could join the cause!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42132,'Excellent. $n, you are going to make a fine $c. McBride will teach you everything that you will need to know to join the ranks of the Stormwind guard!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42133,'I\'ve been in here for days. They were just about to sacrifice me!','I\'ve been in here for days. They were just about to sacrifice me!',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(42134,'Farewell, $n. Until we meet again...','',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(42135,'FOR THE HORDE!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42136,'This land belongs to the Horde!  Attack!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42137,'Crush these Nethergarde maggots!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42138,'Feel the wrath of the Okril\'lon!  Blasted Lands is ours!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42139,'Hellscream\'s eyes are upon you, men!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42140,'Match altitude and speed, Mister Gearchum.','',0,0,0,0,0,0,25,0,1,0,19662,0,26124),
(42141,'Signal the fleet to fall into formation.','',0,0,0,0,0,0,1,0,1,0,19663,0,26124),
(42142,'Someone get me out of this cage!','Someone get me out of this cage!',0,0,0,0,0,0,15,1,1,923,0,0,26124),
(42143,'I\'m too good-looking to die as a sacrifice!','I\'m too good-looking to die as a sacrifice!',0,0,0,0,0,0,1,1,1,923,0,0,26124),
(42144,'When I get out of here, I\'m going to rip every last one of you Twilight\'s Hammer curs to shreds!','When I get out of here, I\'m going to rip every last one of you Twilight\'s Hammer curs to shreds!',0,0,0,0,0,0,5,1,1,923,0,0,26124),
(42145,'Maybe we can make a deal. I\'d make a great cultist!','Maybe we can make a deal. I\'d make a great cultist!',0,0,0,0,0,0,6,1,1,923,0,0,26124),
(42146,'You cultists are cowards. You make me sick!','You cultists are cowards. You make me sick!',0,0,0,0,0,0,5,1,1,923,0,0,26124),
(42147,'You over there. You\'re not one of the cultists. Get me out of here!','You over there. You\'re not one of the cultists. Get me out of here!',0,0,0,0,0,0,1,1,1,923,0,0,26124),
(42148,'One of them has the key. Find it and get me out of this cage!','One of them has the key. Find it and get me out of this cage!',0,0,0,0,0,0,1,1,1,923,0,0,26124),
(42149,'I will not die powerless like this!','I will not die powerless like this!',0,0,0,0,0,0,15,1,1,923,0,0,26124),
(42150,'I give you thanks, $n.','I give you thanks, $n.',0,0,0,0,0,0,1,1,1,923,0,0,26124),
(42151,'I never thought that I\'d be saved by you, $n!','I never thought that I\'d be saved by you, $n!',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(42152,'I\'ll tell Legionnaire Nazgrim that you\'re destroying the Hammers in here.','I\'ll tell Legionnaire Nazgrim that you\'re destroying the Hammers in here.',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(42153,'I better get back to Nazgrim.','I better get back to Nazgrim.',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(42154,'They\'re changing themselves into some kind of super-elemental they call an Ascendant. You must stop them, $n!','They\'re changing themselves into some kind of super-elemental they call an Ascendant. You must stop them, $n!',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(42155,'I thought I was dead for sure. Thanks, $n!','I thought I was dead for sure. Thanks, $n!',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(42156,'See you outside, $g brother : sister;. Is that the way out?','See you outside, $g brother : sister;. Is that the way out?',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(42157,'I\'ve been in here for days. They were about to sacrifice me!','I\'ve been in here for days. They were about to sacrifice me!',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(42158,'Peering through the portal, you see the inner portion of an underground cave.  The sound of water falling is muffled by the sound of earth shifting.  This portal must have been opened for a reason, but why?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42159,'Enter the portal.','Enter the portal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42160,'As you near the portal, you are struck by intense heat radiating out. The sound of hammers echoing through a canyon create a faint steady rhythm all around.  Where does this portal go?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42161,'Enter the Portal.','Enter the Portal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42162,'What say you, $n? We need all the help we can muster if we are to defeat Deathwing and his minions!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42163,'Yes. Highness! We will prepare $n for the coming battle!','',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(42164,'Order the fleet into close formation. Keep it tight, everyone!','',0,0,0,0,0,0,25,0,1,0,19664,0,26124),
(42165,'','Our allies have arrived! Push them back over the edge, my brethren.',0,0,0,0,0,0,0,0,1,0,0,21797,26124),
(42166,'Sir! The fleet is straight ahead.','',0,0,0,0,0,0,5,0,1,0,19598,0,26124),
(42167,'Approaching the Thandol Span, sir.','',0,0,0,0,0,0,25,0,1,0,19599,0,26124),
(42168,'','We are victorious.  In Azshara\'s name!',0,0,0,0,0,0,1,0,1,0,0,21800,26124),
(42169,'','My Battlemaiden, once again you have earned my respect, and the respect of all our people.',0,0,0,0,0,0,1,0,1,0,0,21801,26124),
(42170,'','You have surpassed your title. You are a Battlemaiden no longer. Take your new crown, Nar\'jira, champion of Azshara.',0,0,0,0,0,0,1,0,1,0,0,21802,26124),
(42171,'','With the summoning complete and the armies of Azshara gathering for war, Neptulon the Tidehunter will soon fall.',0,0,0,0,0,0,1,0,1,0,0,21803,26124),
(42172,'Ach, it\'s hard enough keeping order around here without all these new troubles popping up!  I hope you have good news, $n...','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42173,'I wish to ride the Stormwind charger, sir.','I wish to ride the Stormwind charger, sir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42175,'We have suffered a major setback, but we must see our mission through nevertheless.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42176,'Pull yourself together, $n.$b$bWe must make for the breach and prevent the naga from entering the Plane of Water!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42177,'Wow, it\'s totally wrecked! Let\'s try somewhere else.','Wow, it\'s totally wrecked! Let\'s try somewhere else.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42178,'Heart of Orgrimmar, you\'re coming in too low. Too low!','',0,0,0,0,0,0,1,0,1,0,19665,0,26124),
(42179,'Pull up! Pull down! PULL SOMETHING!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42180,'|TInterface\\Icons\\spell_fire_selfdestruct.blp:20|t%s rears back and casts |cFFFF0000|Hspell:77982|h[Searing Flame]|h|r!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42181,'Arise, friend. We have no time to lick our wounds!','',0,0,0,0,0,0,5,0,1,0,19520,0,26124),
(42182,'While the loss of this vehicle is a setback, we must persist. We must succeed!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42183,'Think they\'ll ever fix all this? Let\'s go to the other side.','Think they\'ll ever fix all this? Let\'s go to the other side.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42184,'I kill off any stragglers and send an event...','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42185,'We must make our way to the crater!','',0,0,0,0,0,0,5,0,1,0,19521,0,26124),
(42186,'The submarine\'s gonna blow! Move out!','',0,0,0,0,0,0,22,0,1,0,21211,0,26124),
(42187,'Where does it hurt?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(42188,'That foul sea-witch has overpowered our ship! Brace for impact!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42189,'%s throws his spell focus to the ground!','%s throws her spell focus to the ground!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42190,'','You have foolishly trespassed upon our waters, Horde fools. Be whipped by the lash of my storm!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42191,'Oh, the Goblinity!','',0,0,0,0,0,0,15,0,1,0,19600,0,26124),
(42192,'The valley should mask our movements. Stay low. Stay close.','',0,0,0,0,0,0,1,0,1,0,19666,0,26124),
(42193,'I don\'t want to see any more mistakes!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42194,'Fellow warriors of the Horde. Hear me now!','',0,0,0,0,0,0,15,0,1,0,20542,0,26124),
(42195,'Ahead hides our foe. Worshippers of chaos who seek to remake the world.','',0,0,0,0,0,0,1,0,1,0,20564,0,26124),
(42196,'A new world is coming, friends. But it is not the world of their design.','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(42197,'Together, we will crush the Twilight\'s Hammer, raze their stronghold,','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(42198,'salt the earth, and burn the bodies. All will tremble at our might. ','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42199,'Then we will stand astride this world as its masters -','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42200,'united in our conviction, unrivaled in strength, beholden to no one. ','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42201,'Today, WE will remake the world. OUR world. FOR THE HORDE!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(42202,'Coming up on the Twilight Highlands, Captain. ','',0,0,0,0,0,0,25,0,1,0,19601,0,26124),
(42203,'Look - dwarves. Hah! They sulk like prairie dogs in holes in the ground.','',0,0,0,0,0,0,0,0,1,0,21501,0,26124),
(42204,'Captain, sir! Alliance naval fleet sighted off the port bow.','',0,0,0,0,0,0,25,0,1,0,19602,0,26124),
(42205,'The Alliance steams in close formation without escort.','',0,0,0,0,0,0,1,0,1,0,20543,0,26124),
(42206,'Air guard, attack!! Strafe them now, while they cannot maneuver!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42207,'What - WHAT!? What does he think he\'s DOING? The carriers are unprotected.','',0,0,0,0,0,0,5,0,1,0,19667,0,26124),
(42208,'What kind of madman orders away his close air support?','',0,0,0,0,0,0,6,0,1,0,19668,0,26124),
(42209,'Mister Gearchum, signal the fleet. Defensive formations!','',0,0,0,0,0,0,1,0,1,0,19669,0,26124),
(42210,'We\'re without our escort. I want to see interlocking fields of fire. Now, now!','',0,0,0,0,0,0,5,0,1,0,19670,0,26124),
(42211,'|TInterface\\Icons\\spell_fire_selfdestruct.blp:20|tThe Blind Dragon rears back and casts |cFFFF0000Searing Flame!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42212,'A winner.','',0,0,0,0,0,0,1,0,1,0,21502,0,26124),
(42213,'I would like to start the Blood Ritual, Kasim.','I would like to start the Blood Ritual, Kasim.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42214,'Very well.  Stand back... this may get messy.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42215,'The blood ritual is complete... and I can now see where three amulets await you.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42216,'I would like to start the Amulet Ritual, Kasim.','I would like to start the Amulet Ritual, Kasim.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42217,'With the power within the amulets of Razelikh...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42218,'... I bind you to his lair!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42219,'Turn your head and cough twice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42220,'To have seen the things I\'ve seen, to have done the things I\'ve done, and to still breathe... I am a lucky gnome.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42221,'What the WHAT!?','',0,0,0,0,0,0,0,0,1,0,19671,0,26124),
(42222,'The guns, man the guns! Fire everything we\'ve got!','',0,0,0,0,0,0,5,0,1,0,19672,0,26124),
(42223,'It\'s an attack!','',0,0,0,0,0,0,5,0,1,0,21503,0,26124),
(42224,'It\'s a bloodbath, lieutenant. They\'ve been murdered.','',0,0,0,0,0,0,1,7,1,9977,0,0,26124),
(42225,'Given the body temperature, I\'d say they\'ve been dead no more than 6 hours.','',0,0,0,0,0,0,0,7,1,9977,0,0,26124),
(42226,'Damn shame what they did to Old Blanchy...','',0,0,0,0,0,0,0,7,1,9977,0,0,26124),
(42227,'No kidding, rookie...','',0,0,0,0,0,0,273,7,1,9977,0,0,26124),
(42228,'Looks like they really put the cart...','',0,0,0,0,0,0,0,7,1,9977,0,0,26124),
(42229,'...before the horse.','',0,0,0,0,0,0,0,7,1,9977,0,0,26124),
(42230,'Operation: Gnomeregan was a success. Sure, that dastardly Thermaplugg had an unforeseen trick up his sleeve, but we have him on the run! It\'s only a matter of time before Gnomeregan is cleaned up and in our hands again!','',5,1,1,0,0,0,0,0,1,11832,0,0,26124),
(42231,'Harvesting','Harvesting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42232,'Cooking for the King is an honor, not a job.  Do you have time to help me on some errands?','Cooking for the King is an honor, not a job.  Do you have time to help me on some errands?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42233,'Never stop training, $n. I want every gnome ready for the day when we take down the traitor Thermaplugg for good.','',66,1,0,0,0,0,0,0,1,0,0,0,26124),
(42234,'','The end of Operaton: Gnomeregan meant a chance to rest for most people. However, my assistants and I have been caring for the wounded and for the survivors that the S.A.F.E. teams rescue from inside the city.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(42235,'','Things can get a little stuffy here in Nethergarde.  Sometimes a dwarf just needs a brew to take her mind off her duty for a bit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42236,'I was just taking a rest.  Eternal watch is not as easy as it sounds, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42237,'Return to L\'ghorek!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42238,'','Erunak, take a look at this. This looks like a sufficient focus for the vision magics I was speaking to you about.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42239,'Erunak examines the shard and nods in agreement.','Erunak examines the shard and nods in agreement.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42240,'','I will prepare the enchantment right away then. This may finally shed some light on the means and intentions of the naga.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42241,'The Trade District is secured!  Now, secure the rest of the city!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42242,'','We have secured the Mage District! All invaders have been repelled and the evacuation has been completed!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42243,'','Greetings, $n. I can offer you training in the way of the mage.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(42244,'The Cathedral District is under Stormwind Control again. The Light always prevails!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42245,'','I\'m sorry, $c, I cannot help you. You\'ll have to find a $c trainer.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(42246,'Begone, Alliance thief!','Begone, Alliance thief!',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(42247,'Sorry, I cannot train you.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(42248,'Keep pressing the fight, $n!','Keep pressing the fight, $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42249,'Don\'t let up, $n!','Don\'t let up, $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42250,'Show these monsters the might of Stormwind, $n!','Show these monsters the might of Stormwind, $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42251,'Fight on, $n!','Fight on, $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42252,'Continue the attack, $n!','Continue the attack, $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42253,'It seems your reputation as a formidable $c is well earned, $n!','It seems your reputation as a formidable $c is well earned, $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42254,'Your skills in battle are impressive, $n.','Your skills in battle are impressive, $n.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42255,'How can Stormwind fall when we have $cs such as $n to defend it?  FOR STORMWIND!','How can Stormwind fall when we have $cs such as $n to defend it?  FOR STORMWIND!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42256,'They attacked while you were gone... the Captain fell fighting them off. The rest retreated to the cave, you should do the same.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42257,'Fresh air! By the light, I missed it. We have some ships just in sight to the north, $n - fire the flare in their direction.','',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(42258,'Fresh air! Grom\'s beard, I missed it. We have some ships just in sight to the north, $n - fire the flare in their direction.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42259,'Say \"Ahhhhh\".','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42260,'When was your last check up?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(42261,'What are you doing?  You threaten my work!  The Tainted Scar\'s revival is all thanks to me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42262,'Take two potions and call me in the morning.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42263,'You should consider losing some weight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42264,'I only wanted to... do something... good...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42265,'Before the day is done, you will all be slaves and corpses!','',0,0,0,0,0,0,0,0,1,0,21857,0,26124),
(42266,'Another brief confrontation with naga here.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42267,'Press forward...','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42268,'Die, worm!','',0,0,0,0,0,0,1,0,1,0,21216,0,26124),
(42269,'More delays... Form up, men!','',0,0,0,0,0,0,1,0,1,0,21213,0,26124),
(42270,'Our goal is in sight - press forward...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42271,'Neptulon\'s minions are growing desperate! We must hurry!','',0,0,0,0,0,0,5,0,1,0,19524,0,26124),
(42273,'We\'ve been spotted! Make ready!','',0,0,0,0,0,0,5,0,1,0,21209,0,26124),
(42274,'','Kelsey Steelspark of Gnomeregan Covert Operations at your service! If you\'re looking for rogue training, you\'ve come to the right place.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(42275,'','I\'m sorry, I can\'t offer you training. You\'ll have to find someone more familiar with your skills.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(42276,'','Welcome back, $n. That took longer than expected. Learn anything useful?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42277,'Erunak! We don\'t have time for this...','',0,0,0,0,0,0,5,0,1,0,21210,0,26124),
(42278,'We\'re being besieged by the naga attempting to breech our airlocks! Defend the ship topside!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42279,'Goblin! Status report!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42280,'Continue the bombardment of the ocean floor! Show those Naga the might of the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42281,'Naga attacking from the port and starboard! Faceless ones attacking head on...! We\'re heavily  outnumbered, but the ship is holding, sir!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42282,'','This miserable can is nothing compared to the might of <Kraken Name here>!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42283,'','The Park\'s been ruined... we\'ll have to go another way, today. Miserable dragon!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42284,'More naga! Brace yourselves!','',0,0,0,0,0,0,5,0,1,0,21212,0,26124),
(42285,'','Thank the waves, you\'re back! The others have already retreated, we need to get out of here!',0,0,0,0,0,0,1,0,1,9743,0,0,26124),
(42286,'L\'ghorek Dies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42287,'Quickly, $n!  We haven\'t much time before Razelikh makes his return.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42288,'','Quickly, $n!  We haven\'t much time before Razelikh makes his return.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42289,'<These baby Rockpool murlocs look toward the ocean.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42290,'<Continue helping the Rockpool tadpoles.>','<Continue helping the Rockpool tadpoles.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42291,'Hold on!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42292,'Ah!  Get back over here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42293,'Citizens of Stormwind! Begin to evacuate the city!','Citizens of Stormwind! Begin to evacuate the city!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42294,'Guests of Stormwind please find shelter from the coming storm!','Guests of Stormwind please find shelter from the coming storm!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42295,'Clear the streets!','Clear the streets!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42296,'Evacuate the city!  Clear the streets of Stormwind!','Evacuate the city!  Clear the streets of Stormwind!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42297,'Enough!','',0,0,0,0,0,0,5,0,1,0,19522,0,26124),
(42298,'Enough!  The Earthen Ring will temporarily stop the invasion.  But be warned, the elementals will return!','Enough!  The Earthen Ring will temporarily stop the invasion.  But be warned, the elementals will return!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42299,'We must make haste! The elementals cannot endure this siege.','',0,0,0,0,0,0,5,0,1,0,19523,0,26124),
(42300,'','You have foolishly trespassed upon our waters, Alliance fools. Be whipped by the lash of my storm!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42301,'','Ahh, visitorsss!',0,0,0,0,0,0,0,0,1,0,0,21266,26124),
(42302,'','What an unexpected sssurprise.',0,0,0,0,0,0,396,0,1,0,0,21267,26124),
(42303,'','You mussst forgive me... I have no time to ssstay and play.',0,0,0,0,0,0,396,0,1,0,0,21268,26124),
(42304,'','In my absssence, my ssservantsss will... sssee to your needs. ',0,0,0,0,0,0,396,0,1,0,0,21269,26124),
(42305,'','Do enjoy yourssselves!',0,0,0,0,0,0,396,0,1,0,0,21270,26124),
(42306,'Pssst...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42307,'You need something, $g mack:lady;?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42308,'Whatever you need, I can get...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42309,'Nice stuff. You must be rich.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42310,'What\'re you doin\' out here? Slummin\'?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42311,'Whaddya need? Information? I got that too!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42312,'You lookin\' for somethin\' a little more... exotic?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42313,'I think we can do business.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42314,'Keep your head low, $g buddy:lady;.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42315,'We don\'t die that easily, sea-witch!','',0,0,0,0,0,0,53,0,1,0,21214,0,26124),
(42316,'If we are to die, let it be with honor against our hated enemies!','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(42318,'What the hell happened here?','',0,0,0,0,0,0,0,7,1,9977,0,0,26124),
(42319,'The final battle against the naga is imminent. We will triumph or die trying in the Abyssal Breach.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(42320,'Looks like the Furlbrow\'s were murdered...','',0,0,0,0,0,0,0,7,1,9977,0,0,26124),
(42321,'What\'s happened to us? We\'re in worse shape now than when the Defias ran amok!','',0,0,0,0,0,0,0,7,1,9977,0,0,26124),
(42322,'Yep. That King is good for nothin\'.','',0,0,0,0,0,0,0,7,1,9977,0,0,26124),
(42323,'Let\'s get out of here before they try and pin this on us.','',0,0,0,0,0,0,0,7,1,9977,0,0,26124),
(42324,'Good call.','',0,0,0,0,0,0,0,7,1,9977,0,0,26124),
(42325,'Before we can join the final battle, we must ensure that whatever\'s happening inside of that Ancient across from us is put to an end. Otherwise, we will not stand a chance.$B$BLend Erunak your full assistance, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(42326,'L\'ghorek is the name of the Ancient god that sits across the chasm from us. It is being infested by something.$B$BWe must put an end to this or we will certainly all meet our doom!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(42327,'In spite of our best efforts, the naga have attacked the breach!$B$BThe Plane of Water must be defended!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(42328,'There is a battle brewing at the Abyssal Breach. I hope that the reinforcements that arrived with the Pincer X2 will be enough.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(42329,'Let us in!','Let us in!',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(42330,'Down with the king!','Down with the king!',0,0,0,0,0,0,15,7,1,0,0,0,26124),
(42331,'This is horse poop!','This is horse poop!',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(42332,'What right do you have keeping us out?','What right do you have keeping us out?',0,0,0,0,0,0,6,7,1,0,0,0,26124),
(42333,'We\'re hungry and cold! Help us!','We\'re hungry and cold! Help us!',0,0,0,0,0,0,20,7,1,0,0,0,26124),
(42334,'Heartless monsters!','Heartless monsters!',0,0,0,0,0,0,14,7,1,0,0,0,26124),
(42335,'Is this equality and justice for all?','Is this equality and justice for all?',0,0,0,0,0,0,6,7,1,0,0,0,26124),
(42336,'What do you expect us to do?','What do you expect us to do?',0,0,0,0,0,0,25,7,1,0,0,0,26124),
(42337,'Before we join the final battle at the Abyssal Breach, we must stop whatever\'s happening inside of that Ancient across from us. Otherwise, we will fail.$B$BLend Erunak all of your might, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(42338,'The final battle against the naga has begun. We will destroy them or gloriously die trying in the Abyssal Breach.','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(42339,'','You ask me, I think we let the soup and gravy take care of this ready and write.$B$BIt\'s bird lime to kick and prance ourselves out of here before we\'re all brown bread.$B$BCatch my meaning, love?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(42340,'WHOA THERE, BUDDY!','WHOA THERE, BUDDY!',0,0,0,0,0,0,3,7,1,0,0,0,26124),
(42341,'Where do you think you two are going?','Where do you think you two are going?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42342,'We\'re just trying to get a decent meal and maybe a comfortable night\'s sleep.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42343,'','Just between you and me, hon, I\'m too short to pull this kind of duty. One more month and I\'m out.$B$BI\'ve already died once. No sense doing it a second time.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(42344,'Can\'t you read, pal? Probably not, huh?','Can\'t you read, pal? Probably not, huh?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42345,'The sign here says: \"ABSOLUTELY NO BUMS!\" Now get lost!','The sign here says: \"ABSOLUTELY NO BUMS!\" Now get lost!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42346,'','Dealing with the first ancient, Nespirah, was hard enough. The one across from us, L\'ghorek, is dying.$B$BI can sense its cries of agony. Something is stealing its life force. But to what end?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(42347,'Dirty, rotten pig-lickers. You\'ll get your come-uppance some day.','',0,0,0,0,0,0,396,7,1,0,0,0,26124),
(42348,'Let\'s get the hell out of here. I hope this place burns to the ground.','',0,0,0,0,0,0,396,7,1,0,0,0,26124),
(42349,'','I wish that I was going to fight by your side in the upcoming battle, but Erunak wants me to remain here.$B$BGood luck, $n.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(42350,'','These depths truly are a nightmare.$B$BAlthough, the battle that is about to be joined down in the breach below will make this look like kittens and rainbows.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(42351,'JACKPOT!','JACKPOT!',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(42352,'Looks like I found us a savory and clean piece of dirt! Tonight we eat like kings, Mr. Penguin! Of course I\'ll share it with you! You\'re my best friend!','Looks like I found us a savory and clean piece of dirt! Tonight we eat like kings, Mr. Penguin! Of course I\'ll share it with you! You\'re my best friend!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42353,'I\'m starving!','I\'m starving!',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(42354,'HAHAHAH! Good one, Mr. Penguin! GOOD ONE!','HAHAHAH! Good one, Mr. Penguin! GOOD ONE!',0,0,0,0,0,0,153,7,1,0,0,0,26124),
(42355,'Get off my land!','Get off my land!',0,0,0,0,0,0,397,7,1,0,0,0,26124),
(42356,'I don\'t think I\'m gonna make it...','I don\'t think I\'m gonna make it...',0,0,0,0,0,0,18,7,1,0,0,0,26124),
(42357,'What happened to me? I used to be the king of Stormwind!','What happened to me? I used to be the king of Stormwind!',0,0,0,0,0,0,15,7,1,0,0,0,26124),
(42358,'Looks like we\'ll be eating shoe leather for dinner again.','Looks like we\'ll be eating shoe leather for dinner again.',0,0,0,0,0,0,396,7,1,0,0,0,26124),
(42359,'I wonder if it\'s possible to eat rocks? Got plenty of rocks around here. Just imagine it! I\'d be the richest person in the world for making that discovery!','I wonder if it\'s possible to eat rocks? Got plenty of rocks around here. Just imagine it! I\'d be the richest person in the world for making that discovery!',0,0,0,0,0,0,4,7,1,0,0,0,26124),
(42360,'I miss being robbed by the Defias. At least they\'d leave you a little something to eat from time to time.','I miss being robbed by the Defias. At least they\'d leave you a little something to eat from time to time.',0,0,0,0,0,0,396,7,1,0,0,0,26124),
(42361,'HEY! HEY YOU! GET OFF MY PROPERTY!','HEY! HEY YOU! GET OFF MY PROPERTY!',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(42362,'Does $g he:she; have boots? Get \'em!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42363,'MINE!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42364,'Check $g his:her; pockets!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42365,'Whaddya want?','Whaddya want?',6,0,0,0,0,0,0,7,1,0,0,0,26124),
(42366,'I ain\'t tellin\' you nothin\'!','I ain\'t tellin\' you nothin\'!',274,0,0,0,0,0,0,7,1,0,0,0,26124),
(42367,'Get lost.','Get lost.',274,0,0,0,0,0,0,7,1,0,0,0,26124),
(42368,'Oh the big hero has arrived. I\'m saved! Yea, right...','Oh the big hero has arrived. I\'m saved! Yea, right...',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(42369,'You wanna talk? Pay up.','You wanna talk? Pay up.',6,0,0,0,0,0,0,7,1,0,0,0,26124),
(42370,'Did you see who killed the Furlbrows?','Did you see who killed the Furlbrows?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(42371,'Maybe a couple copper will loosen your tongue. Now tell me, did you see who killed the Furlbrows?','Maybe a couple copper will loosen your tongue. Now tell me, did you see who killed the Furlbrows?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(42372,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42373,'Are you sure you want to give this hobo money?','Are you sure you want to give this hobo money?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42374,'You can\'t buy me! DIE!','You can\'t buy me! DIE!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42375,'The only thing I\'ll tell you is to get the hell out of here!','The only thing I\'ll tell you is to get the hell out of here!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42376,'You got no business here, lout! Beat it!','You got no business here, lout! Beat it!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42377,'They died of natural causes...','They died of natural causes...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42378,'You\'ll get nothing out of me!','You\'ll get nothing out of me!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42379,'Judgment day comes! The brotherhood will be reborn!','Judgment day comes! The brotherhood will be reborn!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42380,'Listen, $g pal:lady;, I don\'t want any trouble, ok? I didn\'t see who murdered \'em, but I sure heard it! Lot of yelling. Human voices... you dig? Now get out of here before I change my mind about beating you up and takin\' your shoes.','Listen, $g pal:lady;, I don\'t want any trouble, ok? I didn\'t see who murdered \'em, but I sure heard it! Lot of yelling. Human voices... you dig? Now get out of here before I change my mind about beating you up and takin\' your shoes.',0,0,0,0,0,0,396,7,1,0,0,0,26124),
(42381,'I didn\'t see who killed \'em, $g bub:lady;, but I got a whiff. Smelled rich, kinda like you. Damn shame too. Furlbrows were a fixture around here. Nice people, always willin\' to share a meal or a patch of dirt.','I didn\'t see who killed \'em, $g bub:lady;, but I got a whiff. Smelled rich, kinda like you. Damn shame too. Furlbrows were a fixture around here. Nice people, always willin\' to share a meal or a patch of dirt.',0,0,0,0,0,0,396,7,1,0,0,0,26124),
(42382,'Who killed the Furlbrows? I\'ll tell you who killed the Furlbrows: KING VARIAN WRYNN, THAT\'S WHO! And he\'s killin\' the rest of us too. One bum at a time. The only thing I can tell you is that I saw some gnolls leavin\' the place a few hours before the law arrived.','Who killed the Furlbrows? I\'ll tell you who killed the Furlbrows: KING VARIAN WRYNN, THAT\'S WHO! And he\'s killin\' the rest of us too. One bum at a time. The only thing I can tell you is that I saw some gnolls leavin\' the place a few hours before the law arrived.',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(42383,'Between you, me, and the tree, murlocs killed the Furlbrows. Yep, saw \'em with my own two eyes. Think they\'d been casin\' the joint for days, maybe months. They left in a hurry once they got wind of \"Johnny Law\" and the idiot brigade over there...','Between you, me, and the tree, murlocs killed the Furlbrows. Yep, saw \'em with my own two eyes. Think they\'d been casin\' the joint for days, maybe months. They left in a hurry once they got wind of \"Johnny Law\" and the idiot brigade over there...',0,0,0,0,0,0,273,7,1,0,0,0,26124),
(42384,'You rich punks are all the same!','You rich punks are all the same!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42385,'I ain\'t tellin\' you a damn thing!','I ain\'t tellin\' you a damn thing!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42386,'Livin\' like an animal is hard enough without your insults!','Livin\' like an animal is hard enough without your insults!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42387,'Maybe I can sell your liver for some gold.','Maybe I can sell your liver for some gold.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42388,'I TOLD YOU TO PAY UP, PAL!','I TOLD YOU TO PAY UP, PAL!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42389,'Now you\'ve gone and done it! TIME FOR THE FIST!','Now you\'ve gone and done it! TIME FOR THE FIST!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42390,'You want my foot in your front or in your rear? Make the call.','You want my foot in your front or in your rear? Make the call.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42391,'Begin the Assault!','Begin the Assault!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42392,'These are grave times for Azeroth, $n.  The elementals have imprisoned both citizens around the city and those they battle with.  We can give you a totem that will break the elemental prison.','These are grave times for Azeroth, $n.  The elementals have imprisoned both citizens around the city and those they battle with.  We can give you a totem that will break the elemental prison.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42393,'You heard him, men. We make our stand here!','',0,0,0,0,0,0,53,0,1,0,0,0,26124),
(42394,'Let us re-convene by my camp, as friends and fellow heroes, to discuss our final and most dangerous quest.  Hup Hup, Pimento!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(42395,'Fight on, $n!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42396,'Lok\'tar, $n!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42397,'Your deeds bring glory and honor to the Horde, $n!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42398,'Bring these invaders a swift death, $n!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42399,'Crush these elementals, $n!  Drive them from our land!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42400,'This is it! The entrance to Neptulon\'s realm...','',0,0,0,0,0,0,5,0,1,0,19525,0,26124),
(42401,'Fight dem back, $n!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42402,'Don\'t be lettin\' up, $n!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42403,'De elements don\'t stand a chance against ya, $n!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42404,'De elements be in for a world of hurt!  Follow my lead, $n!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42405,'Ya got some powerful mojo, $n!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42406,'','Come, children of Azshara! At last, we lay claim to the Plane of Water!',0,0,0,0,0,0,0,0,1,0,0,18873,26124),
(42407,'','Go, my naga! Welcome the mighty Tidehunter to Azeroth!',0,0,0,0,0,0,1,0,1,0,0,18874,26124),
(42408,'We assembled a mighty force and defeated Thermaplugg\'s servants, fighting our way into the city. But, the usurper Thermaplugg had one last trick up his sleeve...','',0,0,0,0,0,0,1,0,1,11832,20895,0,26124),
(42409,'Sandfury trolls working with the Twilight\'s Hammer?! No matter. That foul witch won\'t be sending her monster to MY city.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42410,'Come, brave ones! We\'ll slick the sand with their gore and return home triumphant.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42411,'We were forced to retreat. Thermaplugg continues to hide behind the radiation, sending his crony, Crushcog, to harass us here on the surface.','',0,0,0,0,0,0,1,0,1,11832,20896,0,26124),
(42412,'The Valley of Strength is Horde again! This pathetic attack on Orgrimmar will be crushed.  For the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42413,'Da voodoo is da strength of da horde.  Da Valley of da Sprits is now under Vol\'jin control! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42414,'The Valley of Honor has been secured!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42415,'The Pincer X2 will be arriving shortly! Get your gear and form up, boys!','',0,0,0,0,0,0,0,0,1,9962,0,0,26124),
(42417,'The Pincer X2 has docked. All aboard!','',0,0,0,0,0,0,0,0,1,9962,0,0,26124),
(42418,'What little humie want? Why you call Glubtok?','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(42419,'','Sad... Is this the life that you had hoped for, Glubtok? Running two-bit extortion operations out of a cave?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42420,'Glubtok crush you!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(42421,'','Oh will you? Do you dare cross that line and risk your life?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42422,'What option two?','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(42423,'','You may attempt to kill me - and fail - or you may take option two.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42424,'','You join me and I shower wealth and power upon you.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(42425,'So Glubtok have two choices: die or be rich and powerful?','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(42426,'Well done, $n!  Stormwind is in your debt.','Well done, $n!  Stormwind is in your debt.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42427,'Glubtok take choice two.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(42428,'','I thought you\'d see it my way.',0,0,0,0,0,0,153,0,1,0,0,0,26124),
(42429,'','I will call for you when the dawning is upon us.',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(42430,'GET!','',0,0,0,0,0,0,5,0,1,0,20544,0,26124),
(42431,'OFF!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42432,'MY!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42433,'SHIP!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42434,'You and your scaly worms are no match for me...','',0,0,0,0,0,0,0,0,1,0,19457,0,26124),
(42435,'','You fool! This day shall be your last!',0,0,0,0,0,0,15,0,1,0,0,18875,26124),
(42436,'Get a totem from any Earthen Ring member! Use it to free citizens or defenders from the Elemental Prisons!','Get a totem from any Earthen Ring member! Use it to free citizens or defenders from the Elemental Prisons!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42437,'They\'re after the Warchief -','',0,0,0,0,0,0,5,0,1,0,21504,0,26124),
(42438,'The Warchief\'s zeppelin is in flames! It\'s going down!','',0,0,0,0,0,0,25,0,1,0,21505,0,26124),
(42439,'Did you... Did you meet her?','',0,0,0,0,0,0,6,7,1,0,0,0,26124),
(42440,'Yep. She\'s for real.','',0,0,0,0,0,0,396,7,1,0,0,0,26124),
(42441,'She wanted me to tell you lugs that she appreciates the job that we did for her on the Furlbrows. Gave me a pile o\' gold to split with you all.','',0,0,0,0,0,0,396,7,1,0,0,0,26124),
(42442,'See her face? Is it really...','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(42443,'Whoa, what do we have here? Looks like we have ourselves an eavesdropper, boys.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42444,'Only one thing to do with a lousy, good-for-nothin eavesdropper.','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(42445,'DIE!','',0,0,0,0,0,0,53,0,1,0,0,0,26124),
(42446,'Hurry back to the Furlbrow\'s Cottage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42447,'Doesn\'t look good, rookie.','',0,0,0,0,0,0,1,7,1,9969,0,0,26124),
(42448,'The land suffers... it cries for mercy, $r, it cries for mercy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42449,'This was an execution. Whoever did this was sending a message...','',0,0,0,0,0,0,0,7,1,9969,0,0,26124),
(42450,'A message for anyone that would dare snitch on these criminals.','',0,0,0,0,0,0,0,7,1,9969,0,0,26124),
(42451,'It would appear that poor Lou really put his foot...','',0,0,0,0,0,0,0,7,1,9969,0,0,26124),
(42452,'In his mouth.','',0,0,0,0,0,0,0,7,1,9969,0,0,26124),
(42453,'Please heroes, help my brothers and we shall assist you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42454,'Thank you for rescuing me, now please aid the rest of my brood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42455,'Feeding a Horde army is no easy task.  I have lots to do, do you have time to help?','Feeding a Horde army is no easy task.  I have lots to do, do you have time to help?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42456,'You were standing right here! What the hell did you see? Speak up!','',0,0,0,0,0,0,0,7,1,9969,0,0,26124),
(42457,'I... I didn\'t see nothin\'! He... he died of natural causes.','I... I didn\'t see nothin\'! He... he died of natural causes.',0,0,0,0,0,0,0,7,1,9969,0,0,26124),
(42458,'Natural causes? Two bullets in the chest and his shoes are on his head. What kind of natural death would that be?','',0,0,0,0,0,0,0,7,1,9969,0,0,26124),
(42459,'','We must do whatever it takes to recombine the fragments of the World Pillar.$B$BBut first, we must regain all of them.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(42460,'Been in Westfall all my life, $g brother:sister;. I can remember a day when Westfall was the lushest land this side of Stranglethorn Vale. Those days are long gone.$B$BWhile we no longer have Defias causing problems, the fallout from their reign of terror can still be felt. To make matters worse we\'re in the worst economic downturn in history. All that gold we spent on fighting the Scourge left anyone not in a military related occupation jobless and eventually homeless.$B$BGuess where all those people ended up?','',1,1,6,0,0,0,0,0,1,0,0,0,26124),
(42461,'Enough!  The Earthen Ring will temporarily stop the invasion.  But bewarned, the elementals will return!','Enough!  The Earthen Ring will temporarily stop the invasion.  But bewarned, the elementals will return!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42462,'Egah - all hands aft. One\'s aboard. Shoot it! Kill it!','',0,0,0,0,0,0,5,0,1,0,19673,0,26124),
(42463,'Somebody, DO SOMETHING! That\'s an order!','',0,0,0,0,0,0,15,0,1,0,19674,0,26124),
(42464,'It\'s tangled up in the rigging.','',0,0,0,0,0,0,1,0,1,0,19603,0,26124),
(42465,'Well done, heroes. Let us return through the very portal that witch meant to send this beast through! Much work awaits me in Stormwind.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(42466,'Place barricades around Orgrimmar to protect the city!$B$BPick up a barricade from a box scattered around the city$B$Band then place them at a location marked by a red arrow |TInterface\\Icons\\ABILITY_HUNTER_MARKEDFORDEATH.blp:32|t.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42467,'Oh sure, she said, it\'ll be a simple trip out into the wastes.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(42468,'','Thank you, $n. Your kindness will not be forgotten.',0,0,0,0,0,0,2,7,1,0,0,0,26124),
(42469,'','Dinner\'s ready! Come and get it!',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(42470,'I\'m so happy. Thank you, mama and thank you, $n.','I\'m so happy. Thank you, mama and thank you, $n.',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(42471,'She\'s going to blow! Get a parachute and jump!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42472,'YAY FOR $n!','YAY FOR $n!',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(42473,'%s cries.','%s cries.',0,0,0,0,0,0,18,7,1,0,0,0,26124),
(42474,'%s buries itself in the sand!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42475,'You may only ride the Overloaded Harvest Golem at the Molsen Farm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42476,'Initiating cleanup ... ...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42477,'She\'s breaking up, sir!','',0,0,0,0,0,0,5,0,1,0,19604,0,26124),
(42478,'Tamp down the inflammants. Batten up the gear carriage. Rudder for the shore.','',0,0,0,0,0,0,1,0,1,0,19675,0,26124),
(42479,'Everyone, to the parachutes!','',0,0,0,0,0,0,15,0,1,0,19677,0,26124),
(42480,'Mayday! Mayday! Mayday! Bail out everyone. BAIL!','',0,0,0,0,0,0,5,0,1,0,19676,0,26124),
(42481,'%s disperses!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42482,'Even here, among the surf and sun, I can feel the darkness that lurks in these lands.$B$BIt\'s fascinating, don\'t you think?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42483,'Even here, among the surf and sun, I can feel the darkness that lurks in these lands.$B$BIt\'s fascinating, isn\'t it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42484,'Da elementals be gone!  Da Valley of Spirits be ours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42485,'We are proud to call ourselves the last tribe of Forest Trolls to serve the Horde.$B$BIn time, we will overcome the other tribes, and the dwarves, and the Hinterlands will be ours.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42486,'Thank you, kind and gentle stranger.','Thank you, kind and gentle stranger.',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(42487,'Westfall stew? I\'ll never forget this moment!','Westfall stew? I\'ll never forget this moment!',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(42488,'I\'d know that smell anywhere! Salma\'s famous stew!','I\'d know that smell anywhere! Salma\'s famous stew!',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(42489,'Maybe... maybe life is worth living.','Maybe... maybe life is worth living.',0,0,0,0,0,0,18,7,1,0,0,0,26124),
(42490,'Bless you, friend.','Bless you, friend.',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(42491,'Perhaps one day I will repay you for this kind act.','Perhaps one day I will repay you for this kind act.',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(42492,'I can\'t help ya. Go talk ta Voldreka if ya want warlock trainin\'.','I can\'t help ya. Go talk ta Voldreka if ya want warlock trainin\'.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42493,'Wit\' practice, ya\'ll find that the dark arts can be much stronga than any weapon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42494,'','The trolls here are quite accepting of my kind. After all, they spoke to the dead for centuries before the Forsaken even existed.$B$BIt\'s good for business.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42495,'','In my youth, my family did not approve of my interest in shamanism. Brash and foolish as I was, I ran away from them and practiced on my own.  Upon returning to my home one day, I found my parents gone. My home destroyed. They never found who did it.\n\nI\'ve spent my life striving to extend my shamanistic visions to see into the past - to find out what happened to my family and who is responsible. I\'ve come a great way. I\'ve learned to focus in on impactful events in the recent past, but I have much further to go if I ever hope to glimpse something that occurred so long ago.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42496,'I misplaced the enchanted blade that you gave me. Have you seen it?','I misplaced the enchanted blade that you gave me. Have you seen it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42497,'<Wind howls past the statue as you stand in front of it.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42498,'Akil\'darah, return me to my allies.','Akil\'darah, return me to my allies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42499,'Jintha\'alor gonna be ours, mon. The vilebranch be weak, nasty traitors, undeservin\' of the favor of the loa.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42500,'Send me to Akil\'darah at the middle terrace.','Send me to Akil\'darah at the middle terrace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42505,'You have our full cooperation, lieutenant. The Furlbrows were good people. Their deaths will not go unpunished.','',0,0,0,0,0,0,0,7,1,9983,0,0,26124),
(42506,'That\'s good to hear, marshal. While $n has brought the perpetrators to justice, their ringleader is still on the loose. Perhaps with the aid of the Westfall Brigade we will finally be able to solve this case.','',0,0,0,0,0,0,0,7,1,9983,0,0,26124),
(42507,'Might I ask, what\'s with the worgen in the stocks?','',0,0,0,0,0,0,0,7,1,9983,0,0,26124),
(42508,'We caught this beast slaughtering sheep in the countryside. He is unrepentant and easily agitated. Keep your distance, lieutenant.','',0,0,0,0,0,0,0,7,1,9983,0,0,26124),
(42509,'When I break out of these stocks I\'m going to rip out your heart and devour it whole!','',0,0,0,0,0,0,0,7,1,9983,0,0,26124),
(42510,'Wow, the marshal wasn\'t kidding.','',0,0,0,0,0,0,0,7,1,9983,0,0,26124),
(42511,'But is your bark...','',0,0,0,0,0,0,0,7,1,9983,0,0,26124),
(42512,'Worse than your bite?','',0,0,0,0,0,0,0,7,1,9983,0,0,26124),
(42518,'You\'ve reached too far, serpent. You shall suffer greatly for your trespass!','',0,0,0,0,0,0,0,0,1,0,19463,0,26124),
(42526,'%s attempts to hide on the ocean floor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42527,'The war in Northrend took its toll on us as a people, $n. While we were victorious in the frozen wastes, our own land fell into disarray.\n','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42528,'Do you know anything about this, beast? Who is the admiral? Speak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42529,'The dawning comes, Stoutmantle, and with it comes your end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42530,'Gibberish from a mad wolf. Bah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42531,'','I\'ve got your back, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42532,'','Headshot!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42533,'','Not a chance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42534,'','Easy peasy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42535,'','Got him!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42536,'The gnolls have failed, mistress. ','',0,0,0,0,0,0,1,0,1,9988,0,0,26124),
(42537,'','They provided the distraction I required. We continue as planned.',0,0,0,0,0,0,1,0,1,9988,0,0,26124),
(42538,'But mistress, the admiral is sti...','',0,0,0,0,0,0,1,0,1,9988,0,0,26124),
(42539,'','We will free the admiral during the dawning.',0,0,0,0,0,0,1,0,1,9988,0,0,26124),
(42540,'Yes, mistress.','',0,0,0,0,0,0,1,0,1,9988,0,0,26124),
(42541,'','Judgment day is soon upon us, Helix.',0,0,0,0,0,0,1,0,1,9988,0,0,26124),
(42542,'','Call for the people. I wish to speak to them one last time before the dawning.',0,0,0,0,0,0,1,0,1,9988,0,0,26124),
(42543,'Moonbrook, mistress?','',0,0,0,0,0,0,6,0,1,9988,0,0,26124),
(42544,'','Aye. Tonight.',0,0,0,0,0,0,273,0,1,9988,0,0,26124),
(42545,'','To me, my minions! Strike now!',0,0,0,0,0,0,15,0,1,0,0,18876,26124),
(42546,'','Do not relent! He is weakening!',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(42547,'Ahhhhh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42548,'Nooooo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42549,'Naz\'jar and her honor guard! Fight for your lives!','',0,0,0,0,0,0,5,0,1,0,21317,0,26124),
(42550,'Naz\'jar and her honor guard... Fight for your lives!','',0,0,0,0,0,0,53,0,1,0,21215,0,26124),
(42551,'Little early to the party, aren\'t ya?','',0,0,0,0,0,0,0,0,1,9992,0,0,26124),
(42552,'This is the end of the line, pal!','',0,0,0,0,0,0,0,0,1,9992,0,0,26124),
(42553,'Where do you think you\'re goin\'?','',0,0,0,0,0,0,0,0,1,9992,0,0,26124),
(42554,'If you ain\'t with us, you\'re against us! DIE!','',0,0,0,0,0,0,0,0,1,9992,0,0,26124),
(42555,'Ready for inspection, $gsir:ma\'am;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42556,'This baby is all mine! I call her, \"The Throttler.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42557,'Ready for inspection! ...Be gentle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42558,'See that? Ironclad!','',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(42559,'That\'s right. Takes a lickin\' but keeps on kickin\' butt!','',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(42560,'There is nothing left for us but to wait... and hope.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42561,'Uh oh. Um. Oops.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42562,'Look, look, it\'s okay! It\'s just a tiny little glitch. See?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42563,'A little paint and it\'ll be fine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42564,'I ... I never wanted to be an engineer anyways.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42565,'I always wanted to be... a dancer! Power tools frighten me.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42566,'I can float. On my toes. I\'m like a butterfly. Wanna see?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42567,'%s takes off running.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42568,'It\'s still good enough to ship. I can fix it with a patch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42569,'','The rally is about to begin!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42570,'','Gather, brothers and sisters! Come, all, and listen!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(42571,'','Brothers. Sisters. We are ABANDONED - the orphaned children of Stormwind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42572,'','Our \"king\" sits atop his throne made of gold and shrugs at our plight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42573,'','Meanwhile, our children die of starvation on these very streets!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42574,'','HIS war, not ours, cost us our livelihood. WE paid for the Alliance\'s victories with our blood and the blood of our loved ones!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42575,'','The time has come, brothers and sisters, to stop this injustice!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42576,'','The government of Stormwind, of the ALLIANCE, must be made accountable for what it has done to us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42577,'','Today, we are reborn! Today, we take a stand as men and women, not nameless, faceless numbers!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42578,'%s throws his fish at you and attempts to run away in fear!\n','%s throws his fish at you and attempts to run away in fear!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42579,'Thank you for breaking me out of here!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42580,'I don\'t ever want to smell unwashed trogg again!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42581,'Thanks. Now, let\'s blow up that cave!','',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(42582,'You have no idea how happy I am to see you!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42583,'Finally, someone who\'s not a trogg!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(42584,'I\'m free! I\'m really free!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42585,'Friends of the tribe, our city is under attack!  Take up your arms and defend our home!  If you do not wish to battle, then grab weather breakers and line our city to protect it\'s citzens from the elements!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42586,'Place weather breakers around Thunder Bluff to protect the city!$B$BPick up wind breaks in crates around the city$B$Band place them at locations marked with a red arrow |TInterface\\Icons\\ABILITY_HUNTER_MARKEDFORDEATH.blp:32|t.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42587,'We\'ll get right on this, $gsir:ma\'am;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42588,'The Center Rise has been reclaimed!  The Earthmother be praised!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42589,'We\'re on it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42590,'Yes $gsir:ma\'am;! Right away, $gsir:ma\'am;! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42591,'','We have secured the Hunter\'s Rise! All invaders have been repelled and the evacuation has been completed!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42592,'Spirit Rise is secure! The invaders have been eliminated and the evacuation is complete!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42593,'There\'s nowhere left to hide, VanCleef! The Defias are THROUGH!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(42594,'We\'re here to finish this! Face us, coward!','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(42595,'None may challenge the Brotherhood!','',0,0,0,0,0,0,5,0,1,0,5780,0,26124),
(42596,'Make your preparations, $n, but do it quickly!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42597,'I am prepared, Erunak. Let\'s go!','I am prepared, Erunak. Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42598,'Cover the door - we\'ve got him!','Cover the door - we\'ve got him!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42599,'Oh no not de bar! Take it outside, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42600,'I\'m stopping my patrol now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42601,'I\'m starting my patrol now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42602,'Victory for the Alliance! Glory to Stormwind!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42603,'Let us return to Sentinel Hill, allies, and inform Gryan of VanCleef\'s demise!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(42604,'','Daddy...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42605,'The wind and air elementals threaten to destroy Thunder Bluff.  If you think you are strong enough to go in there, be my guest.  Otherwise, stay out of the city and let us take care of it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42606,'Elemental rifts have opened up around the city.  We need to shut them down now! Evacuate all non-combat ready citizens.  Make sure they get to safety!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42607,'Keep pressing the fight, $n!','Keep pressing the fight, $n!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42608,'Don\'t let up, $n!','Don\'t let up, $n!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42609,'Fight on, $n!','Fight on, $n!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42610,'Continue the attack, $n!','Continue the attack, $n!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42611,'It seems your reputation as a formidable $c is well earned, $n!','It seems your reputation as a formidable $c is well earned, $n!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42612,'Your skills in battle are impressive, $n.','Your skills in battle are impressive, $n.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42613,'Leave this old Dragonmaw to his drink, $c.$B$BI\'ve fought creatures that would curl your spine and I\'ve seen my people all but slaughtered in the swamps of the wetlands and amidst the ruins of Outland.$B$BGet. Lost.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42614,'What\'s this, $c? You know my name?$B$BDo you know, then, of my reputation?$B$BI am Flametusk of the Dragonmaw clan. I commanded legions, flew on dragonback, witnessed the sundering of Grim Batol...$B$BCurse the Twilight\'s Hammer, and curse their ogre lapdogs. Look at me now. All talk and cheap liquor.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42615,'The Dragonmaw can be great again. Help our conquest of the Twilight Highlands - can you give me a map?','The Dragonmaw can be great again. Help our conquest of the Twilight Highlands - can you give me a map?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42616,'I will help, but know that you\'re stepping into a viper\'s nest. Let me draw you a map - wha - behind you!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42617,'So, Twilight\'s Hammer is trying to finish me off? Honorless filth!$B$BI will definitely help you, $c. You say you need a map?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42618,'','No matter what\'s going on elsewhere, Ironforge hasn\'t forgotten this land, nor any of Khaz Modan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42619,'You sense that you are being followed...','',0,0,0,0,0,0,0,0,1,0,3325,0,26124),
(42620,'You fight without honor and die like vermin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42621,'Twilight scum.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42622,'Feel the bite of the Dragonmaw!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42623,'Another worm driven to the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42624,'Only the weak hide in shadows, Twilight filth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42625,'Yes, a map of the coastal approaches.','Yes, a map of the coastal approaches.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42626,'%s scrawls out a depiction of his home port on a torn parchment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42627,'There you have it, $n. All the safe approaches to the Twilight Highlands. Unleash havoc on our foes!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42628,'Twilight\'s Hammer. Bah. Bunch of prancing purple... pussycats. Back to business. Gravy! What am I drinking?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42629,'Good. Then keep it coming.','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(42630,'You be drinkin\' everyting, mon.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(42631,'%s motions for you to speak with him again.','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(42632,'What are you still doing here, $c?$B$BShouldn\'t you be in Twilight Highlands laying waste to that wretched cult?','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(42633,'They poisoned our supplies... we had cultists onboard all along...','They poisoned our supplies... we had cultists onboard all along...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42634,'They tricked us into ambushing the Horde gunship... but why?','They tricked us into ambushing the Horde gunship... but why?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42635,'I heard them praying to their dark gods as everything went black... the Twilight\'s Hammer did this!','I heard them praying to their dark gods as everything went black... the Twilight\'s Hammer did this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42636,'Everyone started dropping like flies... everyone who ate the rations.','Everyone started dropping like flies... everyone who ate the rations.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42637,'Twilight scum!  You did this to us!','Twilight scum!  You did this to us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42638,'Throw de big skull in de pot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42639,'Throw de mojos on de skull!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42640,'Magic\'s done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42641,'Watch Nimboya do what Nimboya does best.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42642,'Warriors. You\'ve fought hard in the frozen wastes. Your courage is to be tested again.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42643,'My warriors! You have already proven your valor. This is why the Warchief has selected you.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42644,'Heroes of the Horde! Are you ready to create history?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42645,'We embark soon for distant shores, to hurl ourselves at the enemy homeland.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(42646,'Our enemy, cloaked in shadow, seeks to unmake our world. We will not lose another home.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(42647,'Our destination is the Twilight Highlands. We strike at the beating heart of our enemy.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(42648,'We assemble an enormous fleet: land, sea, and air. We are legion!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42649,'When our fury is unleashed, our enemies will cower!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42650,'Our wrath will paint the highlands red  - or whatever color our enemies bleed!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42651,'The eyes of Hellscream are upon you.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(42652,'Let\'s see some spirit. Strike! Strike! Strike!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(42653,'Show me what you\'ve got!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(42654,'Now. Show me your fury. Show me!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(42655,'I don\'t like this, $n. Stay alert!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42656,'','You bastards will burn for what you did.',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(42657,'Hope! Wha..','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42658,'','Hope? Is that what I was supposed to feel when I saw my father decapitated by your henchmen?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42659,'','Hope is a cruel joke, played upon us by a harsh and uncaring world. There is no Hope, there is only Vanessa. Vanessa VanCleef.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42660,'','RISE UP BROTHERHOOD! THE DAWNING DAY IS UPON US!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(42661,'','Tie them up.',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(42662,'','Admiral, your hat.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42663,'Thank you, my dear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42664,'Boden the Imposing, I come on behalf of the Earthen Ring. We wish your kind no harm. We seek to repair the rift between our worlds. Why do you attack us?','Boden the Imposing, I come on behalf of the Earthen Ring. We wish your kind no harm. We seek to repair the rift between our worlds. Why do you attack us?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42665,'Hah! Did you mistake me for Diamant, $r? Or perhaps some other whimpering, compliant stone trogg who cares?','',0,0,0,0,0,0,1,0,1,0,21743,0,26124),
(42666,'If you seek peace, relinquish the World Pillar and leave Deepholm. This is our realm. Your only welcome here shall be found underneath my stone foot.','',0,0,0,0,0,0,1,0,1,0,21744,0,26124),
(42667,'Jessup McCree, of McCree\'s Mountain Movers, at your service.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(42668,'If you need a mountain moved, I can do that. I can make \'em for you, too. ','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(42669,'This isn\'t the biggest job I\'ve done, not even close. This cataclysm may just be the best thing that ever happened to us!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(42670,'What can I do for you, chief?','What can I do for you, chief?',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(42671,'Thanks for the help. That one was far tougher for some reason.','Thanks for the help. That one was far tougher for some reason.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(42672,'','Leave nothing but ashes in your wake, brothers! Burn Sentinel Hill to the ground!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(42673,'','And you, $n, I will spare your life. You have done much to help our cause, albeit unwittingly, but the next time we meet it will be as enemies. ',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(42674,'Just tell me one thing, Vanessa.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42675,'Why\'d you have the Furlbrows killed?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42676,'','I had no choice, lieutenant. They recognized me. The only people in the world who even knew I existed, recognized my face from when I was an infant.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42677,'','I took no pleasure in their deaths.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42678,'','So it is certain den. Dese elementals were bound from dormant stone only recently.',0,0,0,0,0,0,1,0,1,0,0,21027,26124),
(42679,'','Only an elemental lord could bind so many elementals so quickly. It seems we\'re at war with da Stonemother herself...',0,0,0,0,0,0,1,0,1,0,0,21028,26124),
(42680,'','May da elements protect us.',0,0,0,0,0,0,2,0,1,0,0,21029,26124),
(42681,'$n, get to Stormwind. Tell King Wrynn everything. EVERYTHING! GO NOW!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42682,'A chance to catch my breath! Thank you.','A chance to catch my breath! Thank you.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(42683,'By the elements... that one... just wouldn\'t die...','By the elements... that one... just wouldn\'t die...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(42684,'Thanks for the relief. It\'s getting hairy out here.','Thanks for the relief. It\'s getting hairy out here.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(42685,'I\'d started to think we\'d been left out here. Thanks for the hand!','I\'d started to think we\'d been left out here. Thanks for the hand!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(42686,'Careful out here, they don\'t stop coming.','Careful out here, they don\'t stop coming.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(42687,'Don\'t stay out here too long, there will be more on top of you any second.','Don\'t stay out here too long, there will be more on top of you any second.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(42688,'Thank you. I could use the rest.','Thank you. I could use the rest.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(42689,'Nice job! Let\'s finish him off.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(42690,'Need a hand?','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(42691,'I saw that move you pulled with the grapple. The boys will be hearing about that one when we get back for sure.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(42692,'Quick! Finish him while he\'s down!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(42693,'That\'s more like it.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(42694,'Not tossing boulders at us anymore, are ya?','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(42695,'Where can I get one of those ropes?! That was brilliant.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(42696,'And now to make sure he doesn\'t get back up...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(42697,'Brothers and sisters, Ironforge is under attack!  Take up your arms and defend our capital!  If you do not want to answer the call of battle, then grab some fortifications and line help keep the walls from collapsing on us!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42698,'The Commons are secured!  Now, secure the rest of the city!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42699,'Fortify the walls of Ironforge to prevent the city from collapsing!$B$BPick up wall fortifications in crates around the city$B$Band place them at locations marked with a red arrow |TInterface\\Icons\\ABILITY_HUNTER_MARKEDFORDEATH.blp:32|t.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42700,'Do it!  Give him de raptor!  I don\'t like havin\' this sword in my face!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42701,'I think I lost them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42702,'Optical sensor malfunction detected! Shutting down...','',0,0,0,0,0,0,0,0,1,0,10571,0,26124),
(42703,'The Military Ward is clear of rifts and we have completed the evacuation of the citizens in this district!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42704,'There\'d be no more elementals in the Mystic Ward now. We\'ve also cleared out all of those trapped folks too! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42705,'I\'VE BEEN INTERRUPTED! CALL ALEX!','I\'VE BEEN INTERRUPTED! CALL ALEX!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42706,'The giant is down.  Kill it quickly!','The giant is down.  Kill it quickly!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42707,'Ironforge is under attack!  You\'d better be strong enough to defend the city if ya want to go in there.$B$BKing Magni ordered a full evacuation of the city and put me in charge of seeing that through.  Don\'t go in there, get yerself hurt and then blame me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42708,'I hope you can fly, pipsqueak!','',0,0,0,0,0,0,0,0,1,0,20990,0,26124),
(42709,'That\'s the way, $n!','That\'s the way, $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42710,'Don\'t ya let up now, $n!','Don\'t ya let up now, $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42711,'Keep on fightin\', $n!','Keep on fightin\', $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42712,'Fight on, $n!','Fight on, $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42713,'Continue the attack, $n!','Continue the attack, $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42714,'Yer reputation as a formidable $c is well earned, $n!','Yer reputation as a formidable $c is well earned, $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42715,'Yer skills in battle are impressive, $n.','Yer skills in battle are impressive, $n.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42716,'Precisely how to do it, $n!','Precisely how to do it, $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42717,'Do not even think of letting up, $n!','Do not even think of letting up, $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42718,'Stay on the attack, $n!','Stay on the attack, $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42719,'You are a most effective fighter, $n!','You are a most effective fighter, $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42720,'Hey, $c!$B$BGot any leads on some lucrative contracts? I\'ll cut you in on one tenth! Of a percent! ','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(42721,'What\'s the deal, $c?$B$BWord on the docks is that you\'ve been poking around my construction sites...','',6,25,0,0,0,0,0,0,1,0,0,0,26124),
(42722,'Nobody shorts Garrosh Hellscream. You finish those ships - and finish them right - or this gets personal.','Nobody shorts Garrosh Hellscream. You finish those ships - and finish them right - or this gets personal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42723,'','Eek!',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(42724,'Nobody tells me how to run my business here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42725,'Be ready! The ground shakes and the fires burn hotter! Get out if ya still can!','Be ready! The ground shakes and the fires burn hotter! Get out if ya still can!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42726,'Watch fer fallin\' rocks!  The ground shakes harder.  Flee the city!','Watch fer fallin\' rocks!  The ground shakes harder.  Flee the city!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42727,'Citizens of Ironforge! Begin the evacuation!','Citizens of Ironforge! Begin the evacuation!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42728,'Guests of Ironforge! Get out of the city! It may collapse at any moment!','Guests of Ironforge! Get out of the city! It may collapse at any moment!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42729,'Watch out fer fallin\' rocks!  Clear the streets!','Watch out fer fallin\' rocks! Clear the streets!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42730,'Flee the city!  The ground can\'t stop shakin\'!','Flee the city!  The ground can\'t stop shakin\'!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42731,'The sky darkens and the elements are restless! Seek shelter!','The sky darkens and the elements are restless! Seek shelter!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42732,'Be on your guard! The clouds move in and the wind picks up! Seek shelter!','Be on your guard! The clouds move in and the wind picks up! Seek shelter!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42733,'Citizens of Thunder Bluff! Evacuate the city!','Citizens of Thunder Bluff! Evacuate the city!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42734,'The wind grows stronger! Take the lifts to safer ground!','The wind grows stronger! Take the lifts to safer ground!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42735,'Clear the paths! Stay away from the sides of the bluff!','Clear the paths! Stay away from the sides of the bluff!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42736,'Evacuate Thunder Bluff!  Stay away from the sides of the bluff!','Evacuate Thunder Bluff!  Stay away from the sides of the bluff!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42738,'It was just a couple of rivets. That ship had plenty!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42739,'I\'m sure it would\'ve been seaworthy in calm waters.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42740,'Less rivets mean a cleaner environment!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42741,'...can we settle this with cash?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42742,'Okay okay, stop! Stop! You make a compelling argument.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42743,'I\'ll double the worker shifts and put in my own money to get those ships seaworthy and back on schedule. Count on it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42744,'Dere be nothin\' chaotic about dis attack. Da elementals and giants be organizin\' against us. It be seemin\' dat somehow we\'ve earned da ire of Therazane, da Stonemother herself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42745,'Welcome to Zul\'Gurub, little one.  It might not look like much now, but give it time...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42746,'Ahh... it\'s good to be home.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42747,'There\'s plenty others of your kind here, but I wouldn\'t worry about competition.  You\'re from the bloodline of Ohgan, my oldest friend.  You see... our souls are intertwined, yours and mine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42748,'Here we are.  Get ready for your training, little one.  I recommend you forget about that worthless $r $c and start thinking about your duties here in Zul\'Gurub.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42749,'NO MORE! ONGOLONGO GO HOME!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42750,'PUNY TROLLS NOT STOP ONGOLONGO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42751,'','Priestess knows much about Zul\'Gurub.$b$bPriestess thinks you need her help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42752,'I am ready for the Mind Vision ritual, Hu\'rala.','I am ready for the Mind Vision ritual, Hu\'rala.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42753,'You get back in dat pen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42754,'Crushcog\'s defeat will send a powerful message to his master, Thermaplugg. The gnomes of Gnomeregan will not be stopped!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(42755,'I\'m ready to start the assault.','I\'m ready to start the assault.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42756,'I have deduced that you must die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42757,'I should have... predicted... this...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42758,'Mekgineer Thermaplugg refuses to acknowledge that his defeat is imminent! He has sent Razlo Crushcog to prevent us from rebuilding our beloved Gnomeregan!','',0,0,0,0,0,0,5,0,1,0,20890,0,26124),
(42759,'But $n has thwarted his plans at every turn, and the dwarves of Ironforge stand with us!','',0,0,0,0,0,0,25,0,1,0,20891,0,26124),
(42760,'Let\'s send him crawling back to his master in defeat!','',0,0,0,0,0,0,5,0,1,0,20892,0,26124),
(42761,'You! How did you escape detection by my sentry-bots?','',0,0,0,0,0,0,0,0,1,0,21243,0,26124),
(42762,'No matter! My guardians and I will make short work of you. To arms, men!','',0,0,0,0,0,0,0,0,1,0,21244,0,26124),
(42763,'We\'ve done it! We\'re victorious!','',0,0,0,0,0,0,5,0,1,0,20893,0,26124),
(42764,'SAMOPHLANGE!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42765,'With Crushcog defeated, Thermaplugg is sure to be quaking in his mechano-tank, and rightly so. You\'re next Thermaplugg. You\'re next!','',0,0,0,0,0,0,5,0,1,0,20894,0,26124),
(42766,'That\'ll teach you to mess with the might of Ironforge and Gnomeregan!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(42767,'Aye, let\'s teach this addle-brained gnome a lesson!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(42768,'$n stiff-arms Smoot and throws him to the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42769,'Oh samophlange... I have failed you!','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(42770,'They need you on the northwestern field! Go!','',0,0,0,0,0,0,5,0,1,10102,0,0,26124),
(42771,'The temple is under siege. We need you outside, now!','',0,0,0,0,0,0,5,0,1,10102,0,0,26124),
(42772,'Get to the battlefield!','',0,0,0,0,0,0,5,0,1,10102,0,0,26124),
(42773,'Keep moving! They need you on the field!','',0,0,0,0,0,0,5,0,1,10102,0,0,26124),
(42774,'We\'re holding them in the northwest - reinforce the line!','',0,0,0,0,0,0,5,0,1,10102,0,0,26124),
(42775,'Our brothers are falling to the northwest. Get out there and help them!','',0,0,0,0,0,0,5,0,1,10102,0,0,26124),
(42776,'The earth elementals have turned on us. Get onto the field and hold them back!','',0,0,0,0,0,0,5,0,1,10102,0,0,26124),
(42777,'We are besieged by elementals and giants! Your help is needed in the northwest, Earthguard!','',0,0,0,0,0,0,5,0,1,10102,0,0,26124),
(42778,'Bind at this location.','Bind at this location.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42779,'Purchase food and water.','Purchase food and water.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42780,'You may rest here, and there is food and water.','You may rest here, and there is food and water.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(42781,'You will never defeat the true sons of Gnomeregan!','',0,0,0,0,0,0,0,0,1,0,21245,0,26124),
(42782,'All hail Samophlange!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42783,'One Samophlange to rule them all!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42784,'Behold: The Samophlange.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42785,'I have built it. And it is mine. Samophlange!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42786,'Oh, Samophlange. Is there nothing you can\'t do?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42787,'I love you, Samophlange!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42788,'And upon the dawn of the first day the Samophlange beheld what it had wrought, and lo, it was good.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42789,'You are brave to try to escape, young Ohgan\'aka.$b$bBefore you continue, let me teach you how to use your teeth to bite through the trolls\' nets.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42790,'<Learn to bite through nets from the elder raptor.>','<Learn to bite through nets from the elder raptor.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42791,'You are leaving the raptor dens?  I was commanded to guard this post and prevent escapes, but... I think I understand why you want to leave.$b$bFine.  You may pass, but first, I have a request.$b$bThe trolls often carry packs of raptor food, and I haven\'t been fed in days.  You don\'t stand a chance in combat, but you\'re small enough that you might be able to steal it from one of the sleeping trolls inside the tents...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42792,'Alright, Tenjiyu.  I\'ll go get you some food from the sleeping trolls.','Alright, Tenjiyu.  I\'ll go get you some food from the sleeping trolls.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42793,'I\'ve brought some food for you.','I\'ve brought some food for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42794,'Quite impressive to have made it this far, Ohgan\'aka.  You are truly a talented young raptor... but the toughest test is yet to come.$b$bThe trolls patrol the bridges up ahead, and they will be difficult to distract.  If you drop a skull in their path, however, you may be able to cause them to trip and fall...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42795,'<Learn to drop skulls from the elder raptor.>','<Learn to drop skulls from the elder raptor.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42796,'Gotcha!','',0,0,0,0,0,0,0,0,1,0,20989,0,26124),
(42797,'I am ready for the Mind Control ritual, Hu\'rala.','I am ready for the Mind Control ritual, Hu\'rala.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42798,'The line is secured to his ankle.  Pull away to trip him!','The line is secured to his ankle.  Pull away to trip him!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42799,'','Over here, you ugly whale!',0,0,0,0,0,0,0,0,1,0,0,21001,26124),
(42800,'You!  Let me go now!  Wait... no!  Don\'t let go!','',0,0,0,0,0,0,0,0,1,0,20991,0,26124),
(42801,'$n, along with High Tinker Mekkatorque and Mountaineer Stonegrind, has defeated Razlo Crushcog!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42802,'The victorious heroes have returned! Control of Chill Breeze Valley is ours once again!','',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(42803,'$gSir:Ma\'am;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42804,'$gSir, yes sir:Ma\'am, yes ma\'am;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42805,'Three cheers for $n!','Three cheers for $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42806,'$gRight away, sir:Right away ma\'am;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42807,'Victory at last!','Victory at last!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42808,'I\'m sorry, $gsir:ma\'am;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42809,'I\'ll drink to that!','I\'ll drink to that!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42810,'It won\'t happen again, $gsir:ma\'am;.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42811,'Please don\'t tell the Warlord...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42812,'','Meet me back up top.  This two-headed freak has a few questions to answer!',0,0,0,0,0,0,0,0,1,0,0,21002,26124),
(42813,'Ok, ok, I give up!  I\'ll tell you everything!','',0,0,0,0,0,0,0,0,1,0,20988,0,26124),
(42814,'chews out an AWOL grunt.','chews out an AWOL grunt.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42815,'You\'re no superior of mine!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42816,'I think this $c is spoiling for a fight.','',0,0,0,0,0,0,23,0,1,0,0,0,26124),
(42817,'You want some of this!?','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(42818,'You want some of this!?','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(42819,'Stupid $r think $ghe\'s:she\'s; the boss of me.','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(42820,'$C, you just earned yourself a beating.','',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(42821,'I\'m sorry - I\'ll return to my post!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42822,'Enough! I shouldn\'t have questioned your orders...','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42823,'That\'s the best brawl I\'ve had in weeks! I\'ll save the rest for our enemies.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42824,'You fight well! I hope to have you by my side in the highlands.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(42825,'Blackrock Caverns, a level 79-81 dungeon on Blackrock Mountain, is now available for testing. Please be in your full group before teleporting to the dungeon. Meeting Stones are not available for this dungeon yet.\n\nTo leave the Halls of Stone, simply exit through the normal exit inside the dungeon and you will be teleported to Dalaran. If you die and release, you should teleport back from this NPC.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42826,'I\'m in my group and ready to teleport to the Blackrock Caverns!','I\'m in my group and ready to teleport to the Blackrock Caverns!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42827,'Take me back to Blackrock Caverns!','Take me back to Blackrock Caverns!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42828,'The AWOL Grunt throws some dice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42829,'Mekkatorque-Cannon!','',0,0,0,0,0,0,0,7,1,0,17561,0,26124),
(42830,'The dice do not lie!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42831,'You cheat.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(42832,'Mekkatorque-Ray!','',0,0,0,0,0,0,0,7,1,0,17563,0,26124),
(42833,'Mekkatorque-Missiles!','',0,0,0,0,0,0,0,7,1,0,17562,0,26124),
(42834,'Mekkatorque-Beam!','',0,0,0,0,0,0,0,7,1,0,17560,0,26124),
(42835,'Who left this here, mon?  Whooaahh...','Who left this here, mon?  Whooaahh...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42836,'Must... regain... balance... mon...','Must... regain... balance... mon...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42837,'Uh oh...','Uh oh...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42838,'Ouch, mon!  I be trippin\'!','Ouch, mon!  I be trippin\'!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42839,'Aaaaahhh!','Aaaaahhh!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42840,'Where you goin\', little one?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42841,'You tryin\' to escape from Zul\'Gurub?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42842,'Ain\'t NO ONE gonna escape Zul\'Gurub!  Not with Jin\'do in charge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42843,'You\'re lucky I don\'t kill ya right now... but I got bigger plans for ya.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42844,'Ya see... to summon Hakkar, I need Mandokir.  And Mandokir, he needs you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42845,'Hello, Ohgan\'aka.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42846,'Bloodlord, you gonna take better care of your possessions?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42847,'Oh yeah, Jin\'do.  We gonna take REAL good care of Ohgan\'aka.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42848,'I got a new cage built up, and we got plenty of ways to... teach her not to escape again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42849,'Good, Good.  And you... yes, you... the meddling worm inside dat Mind Control spell.  Don\'t think Jin\'do can\'t see you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42850,'Whenever you get the GUTS to come back here, you better be ready.  \'Cause Jin\'do\'s got a surprise for you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42851,'Throm\'ka, friend!$B$BThe Warchief has ordered me to assemble his greatest veterans for an assault on the Twilight Highlands.$B$BYou look like one tough $c, but we need soldiers who are a bit more... battle-hardened. Perhaps someday you and I will fight side-by-side. Until then, continue your training!  ','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42852,'Throm\'ka, friend! It is good to see a fellow veteran of the Northrend campaign.$B$BThe Warchief has ordered me to assemble his greatest warriors for an assault on the Twilight Highlands.$B$B<Warlord Krogg looks you up and down.>$B$BWe may need your help. Check in with the Warchief in Orgrimmar and see if he has a use for you yet.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42853,'|TInterface\\Icons\\inv_misc_net_01.blp:32|t$b$bUse the Eat Through Net ability to chew through Gurubashi nets!','|TInterface\\Icons\\inv_misc_net_01.blp:32|t$b$bUse the Eat Through Net ability to chew through Gurubashi nets!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42854,'Steal food from sleeping Gurubashi Soldiers!','Steal food from sleeping Gurubashi Soldiers!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42855,'|TInterface\\Icons\\spell_fire_fire.blp:32|t$b$bPick up Burning Twigs from braziers, then use Light Fire to burn down Zul\'Gurub Tikis!','|TInterface\\Icons\\spell_fire_fire.blp:32|t$b$bPick up Burning Twigs from braziers, then use Light Fire to burn down Zul\'Gurub Tikis!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42856,'|TInterface\\Icons\\inv_misc_bone_orcskull_01.blp:32|t$b$bPick up Gurubashi Skulls from skullpiles, then drop them in troll paths!','|TInterface\\Icons\\inv_misc_bone_orcskull_01.blp:32|t$b$bPick up Gurubashi Skulls from skullpiles, then drop them in troll paths!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42857,'A soldier could get into a lot of trouble in a town like this.$B$BA lot of trouble.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(42858,'Thank you.$b$bIn return, I will teach you how to distract the trolls up ahead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42859,'Da tiki!  Put it out!','Da tiki!  Put it out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42860,'It\'s a fire!  Hurry up mon!','It\'s a fire!  Hurry up mon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42861,'Someone been burnin\' my tiki!','Someone been burnin\' my tiki!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42862,'Get over here, bruddas, quick!','Get over here, bruddas, quick!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42863,'You wish to escape?  That is fine, but you must know some things first.$b$bStay away from the trolls.  They will not kill you, but they will trap you and bring you back here.$b$bSpeak with every raptor you see.  Not only can they teach you new abilities, but they will help you remember your progress and make your path out of Zul\'Gurub much easier.$b$bYou already have a Dash ability - use it to get out of tight spots.$b$bOh... and stay out of the water.$b$bGood luck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42864,'|cFF768EBDFive years ago, in the heart of the Deadmines...|r |TInterface\\QuestFrame\\UI-QUESTLOG-BOOKICON.BLP:32|t','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42865,'Yarrrr, yeh don\'t want none of what I be dealin\', $gSonny:missy;.$B$BBegone wit\' yeh!','',0,0,0,0,0,0,0,0,1,0,7394,0,26124),
(42866,'Oh, ho! Oh ho ho.$B$BYo ho ho, even.$B$BThe flight to Twilight Highlands event is being worked on. In the meantime, I\'l take yeh there, lickety-split.$B$BDo yeh trust me, $c?','',0,0,0,0,0,0,0,0,1,0,7394,0,26124),
(42867,'Yes, teleport me!','Yes, teleport me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42869,'Tha Darkspear are \'ere because I led dem here.  Orgrimmar be no home as long as it be under Hellscream\'s hand. ','',0,0,0,0,0,0,1,0,1,9224,20105,0,26124),
(42870,'Still, I fear I was lettin\' my temper drive me ta bein\' rash. Thrall devoted himself to makin\' the Horde what it is, so I\'ve no eagerness to be leavin\' it on a whim.  Dis will be needin\' much more thought.','',0,0,0,0,0,0,1,0,1,9224,20106,0,26124),
(42871,'Vol\'jin.  It\'s good to see you, brother.','',0,0,0,0,0,0,1,0,1,9223,20133,0,26124),
(42872,'One last favor from old Zuni.','',0,0,0,0,0,0,1,0,1,0,21389,0,26124),
(42873,'Ya gonna go on to great ting\'s. Don\'t forget me, mon.','',0,0,0,0,0,0,1,0,1,0,21391,0,26124),
(42876,'Orc KILL $r!','Orc KILL $r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42877,'Beg for life!','Beg for life!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42878,'Eat you!','Eat you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42879,'Blackrock take forest!','Blackrock take forest!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42880,'The grapes were VERY TASTY!','The grapes were VERY TASTY!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42881,'Give me all your gold!','Give me all your gold!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42882,'No one here gets out alive!','No one here gets out alive!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42883,'You\'re in the wrong place at the wrong time, $g pal:missy;!','You\'re in the wrong place at the wrong time, $g pal:missy;!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42884,'Your money or your life!','Your money or your life!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42885,'Fate has brought you to me!','Fate has brought you to me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42886,'She\'s not lying.  Nordrassil is in danger.  I must make haste and prepare for Hyjal\'s defense.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42887,'It will be up to you to use the Horn of the Ancients and stop Soggoth\'s return.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42888,'','Ah... Malfurion Stormrage.  I\'d hoped to keep you occupied for a little longer.  It was my goal to keep you away from Hyjal while my allies attacked.  It would seem I have succeeded.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42889,'','I\'ve no need to fight you, for it appears I\'ve already won.  You cannot stop our attack on Darkshore and save Hyjal at the same time!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42890,'You do not belong in this world, foul being!  Suffer the wrath of nature!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42891,'I will devour your souls, insolent mortals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42892,'Send me to Orgrimmar.','Send me to Orgrimmar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42893,'We\'re done here. Mulgore will no longer suffer the hatred of the Grimtotem.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42894,'I will meet you again in Thunder Bluff.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42895,'<Learn to light fires from the elder raptor.>','<Learn to light fires from the elder raptor.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42896,'Is there something you need?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42897,'The blade cuts into the Mosh\'Ogg Bounty, forcing it open!','The blade cuts into the Mosh\'Ogg Bounty, forcing it open!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(42898,'%s skin','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42899,'You stay back!  Da troll is mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42900,'Skullsplitter... is... forever... mon...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42901,'Zanzil is creating an army that will wash over all of Stranglethorn!  Bloodscalps, Skullsplitter, Gurubashi and Horde... all will serve Zanzil!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(42902,'...where we\'ll commence to assistin\' the Horde in their little skirmish with them Alliance fellers.\n','',22,0,0,0,0,0,22,0,1,8873,0,0,26124),
(42903,'You do not belong here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42904,'Those who are not of the earth must be destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42905,'You do not belong in the realm of earth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42906,'Uh oh...I\'m gonna...urp!','Uh oh...I\'m gonna...urp!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42907,'Thanks so much for the cookies!','Thanks so much for the cookies!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42908,'Yeah, thanks!','Yeah, thanks!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42909,'See ya!','See ya!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42910,'Welcome to Grom\'gol, $c.  Before we get off on the wrong foot, I\'ll have you know that I won\'t have slackers in my Base Camp.  I expect a healthy $r like you to pull your own weight around here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42911,'Even in this remote corner of the world, know that Hellscream\'s eyes are upon you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42912,'The trolls of Stranglethorn don\'t take too kindly to us Darkspear.  I\'m not afraid of no Bloodscalp or Skullsplitter, but still... Grom\'gol\'s high walls make me feel safe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42913,'Maybe I wasn\'t as safe as I thought I was here in Grom\'gol.$b$bA troll\'s gotta watch his neck wherever he goes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42914,'<The cauldron bubbles.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42915,'My brother has spent years working on a cure for leper gnomes. Using his notes, I think I\'ve perfected a process for restoring gnomes who\'ve devolved to sludge.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42916,'','The cannoneer\'s hands are black with gunpowder.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42917,'<The troll sings to himself and stares into the cauldron.  He appears to be injured.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42918,'Let\'s give this a try. Goggles, everyone!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42919,'There\'s a lot of money out there in that jungle, $r.  Can you see it?$b$bNo, it doesn\'t look like gold or copper.  It looks like raptor hides, and mineral veins, and ancient troll artifacts.$b$bOK, maybe the mineral veins might look like gold or copper.$b$bBut still, you get my point, right?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42920,'The great Rastakhan sends his greetings to you, member of the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42921,'What... what happened to me?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(42922,'Absolutely amazing! We\'ve done it!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42923,'Sure, he\'s a little small, even by gnome standards, but he\'s all there! The real question is, what will he remember?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42924,'Don\'t talk about me like I\'m not here! All I know is I\'m hungry and I need to get out of these hideous, smelly clothes!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42925,'Wait, come back! I have readings to take!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(42926,'You need to see a medic!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42927,'','What have we here, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42928,'We are going to the Temple of Earth, yes?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(42929,'Take me to this Earthen Ring friend of yours. I have important news for the two of you.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(42930,'The Captain\'s Log lies nearby.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42931,'The only thing that matters is that we rescue my father.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(42932,'You must drop everything that you\'re doing to help me free my father, our leader the Stonefather.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(42933,'We must hurry and speak with your Earthen Ring friend.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42934,'I was on my way to the temple when I was jumped. My father must be rescued before the stone troggs kill him.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42935,'The war between the Earthen and the stone troggs has raged for time beyond measure. But now in the chaos, the Stonefather, prisoner. They are threatening to kill him if we do not surrender.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42936,'You would be wise not to waste time. If my father dies, he takes with him the knowledge of where the middle fragment of the World Pillar is hidden. I know that you people want it.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42937,'Earthcaller, my father, Stonefather Oremantle, has been taken prisoner by the stone troggs of Needlerock Spire.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42938,'I demand that you send aid to Stonehearth. Help us with our war and to free Stonefather Oremantle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42939,'This one that assisted me should be adequate. Have them report to our force commander, Crag Rockcrusher at Stonehearth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42940,'You must fly up to Stonehearth, aid my people against the stone troggs, and free my father.$B$BI will meet you there shortly after speaking with the Earthcaller.$B$BDon\'t let him die, $n, or I will put you in the ground myself!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(42941,'I am ready to meet with your so-called Earthcaller.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(42942,'The shell\'s markings read: \"STORMWIND ROYAL INDUSTRIES\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42943,'You ever been to the jungle, $r?$b$bIt\'s real nice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42944,'Stranglethorn, $g man: babe;.  That\'s where it\'s AT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42945,'Hi.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42946,'Ah, to be back in Stranglethorn.  The screeching raptors, the troll wars, jungle creatures as far as the eye see, just ASKING to be killed...$b$b<Bort sighs.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42947,'Time to put the finishing touches on my bot.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42948,'At last, it\'s finished.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(42949,'Arise my, uh... what shall I call you? How about \'multi-bot\'? Arise, my multi-bot!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(42950,'Uh... a couple more tweaks should do it, I think...','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(42951,'I don\'t suppose you brought another squad with you, did you? We\'ve got our hands full out here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(42958,'Inbound $r!','Inbound $r!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42959,'Incoming $r!','Incoming $r!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42960,'We\'ve got another $r flying in!','We\'ve got another $r flying in!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42961,'$R inbound!','$R inbound!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42962,'Welcome to Redridge, $c!','Welcome to Redridge, $c!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42963,'Be on your guard, $c.','Be on your guard, $c.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42964,'Stay alert, $c.','Stay alert, $c.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42965,'We got another $c inbound!','We got another $c inbound!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42971,'Among the Twilight cult are magics that threaten us greatly.$B$BWe have every desire to wipe their existence from our home.$B$BWe are divided, and so we cannot.$B$BAnd so I watch...$B$BAnd wait...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42982,'Another rockworm is upon us! Kill it quickly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42983,'We are under attack! To arms!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42984,'Another rockworm in the encampment! Send for the drakes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42985,'By the elements, this one is even bigger than the last!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42986,'Outgoing, $c.','Outgoing, $c.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42987,'Good hunting, $n!','Good hunting, $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42988,'$R departing Redridge!','$R departing Redridge!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42989,'$C departing Redridge!','$C departing Redridge!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42990,'Good luck out there, $n!','Good luck out there, $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(42991,'The Earthen Ring shall fall!','The Earthen Ring shall fall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42992,'Deepholm shall collapse upon you!','Deepholm shall collapse upon you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42993,'You face the glorious wrath of the Twilight!','You face the glorious wrath of the Twilight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42994,'Deathwing\'s shadow settles over you.','Deathwing\'s shadow settles over you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42995,'Therazane\'s doom is assured!','Therazane\'s doom is assured!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42996,'Your world is broken! Soon, you shall join it in death!','Your world is broken! Soon, you shall join it in death!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42997,'There is no hope for enemies of the Twilight!','There is no hope for enemies of the Twilight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42998,'Dusk approaches! Tremble in fear!','Dusk approaches! Tremble in fear!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(42999,'Razlo Crushcog is no more! The people of Ironforge and Gnomeregan speak with one voice this day. Hear us well, Thermaplugg. The day of your defeat approaches!','',0,0,0,0,0,0,4,0,1,0,20889,0,26124),
(43022,'Better make that a rocket scientist.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(43037,'Strange... Just yesterday, I was dispatched to Ashenvale. ','',0,0,0,0,0,0,396,0,1,0,21468,0,26124),
(43038,'Halfway there I got orders to meet you all here. This must be important.','',0,0,0,0,0,0,396,0,1,0,21469,0,26124),
(43039,'Have you not heard?','',0,0,0,0,0,0,6,0,1,0,21473,0,26124),
(43040,'An island has emerged from the depths... just off the coast of Stormwind.','',0,0,0,0,0,0,396,0,1,0,21474,0,26124),
(43041,'We\'re gunna take it.','',0,0,0,0,0,0,396,0,1,0,21475,0,26124),
(43042,'And once we do, Stormwind\'s days are numbered.','',0,0,0,0,0,0,396,0,1,0,21476,0,26124),
(43043,'An island rose up from the sea... within striking distance of Stormwind? ','',0,0,0,0,0,0,6,0,1,0,21470,0,26124),
(43044,'Take me to Revantusk Village.','Take me to Revantusk Village.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43045,'This is no coincidence! Azeroth herself has cast her lot with the Horde!','',0,0,0,0,0,0,5,0,1,0,21471,0,26124),
(43046,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43047,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43049,'Here, warrior. Eat this.','',0,0,0,0,0,0,1,0,1,0,21482,0,26124),
(43050,'Your reflexes will quicken, and your stamina will increase.','',0,0,0,0,0,0,23,0,1,0,21483,0,26124),
(43051,'Hah! I don\'t need your crutches, friend. ','',0,0,0,0,0,0,274,0,1,0,21491,0,26124),
(43052,'I\'ve faced the best that Stormwind has to offer, and still I stand.','',0,0,0,0,0,0,396,0,1,0,21492,0,26124),
(43053,'My axe has split as many Alliance skulls as yours, brother. Maybe more.','',0,0,0,0,0,0,25,0,1,0,21484,0,26124),
(43054,'Hellscream will settle for nothing short of total victory. ','',0,0,0,0,0,0,274,0,1,0,21485,0,26124),
(43055,'Should we fail, he\'ll chase us into the afterlife to take his retribution.','',0,0,0,0,0,0,396,0,1,0,21486,0,26124),
(43056,'There is wisdom in your words, brother. I\'ll take that food of yours...','',0,0,0,0,0,0,396,0,1,0,21493,0,26124),
(43058,'Indeed, brother. It would seem so...','',0,0,0,0,0,0,273,0,1,0,21477,0,26124),
(43076,'Best of luck, $n!','Best of luck, $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43080,'Aye, as will I.','',0,0,0,0,0,0,273,0,1,0,21494,0,26124),
(43081,'We are Hellscream\'s Vanguard!','',0,0,0,0,0,0,5,0,1,0,21495,0,26124),
(43082,'Why must we ride to battle in some pathetic mercenary vessel?','',0,0,0,0,0,0,6,0,1,0,21496,0,26124),
(43083,'The rest of the fleet has already been sent to the region.','',0,0,0,0,0,0,1,0,1,0,21487,0,26124),
(43084,'...their return is long overdue.','',0,0,0,0,0,0,1,0,1,0,21488,0,26124),
(43085,'Hah! They should\'ve known to send us in the first place.','',0,0,0,0,0,0,5,0,1,0,21497,0,26124),
(43086,'Agreed, brother, but the Horde fights many fires these days and the Vanguard are few in number...','',0,0,0,0,0,0,1,0,1,0,21489,0,26124),
(43087,'Fortunately for our enemies, we can be in only one place at a time.','',0,0,0,0,0,0,1,0,1,0,21490,0,26124),
(43088,'','Prepare for war! We will no longer tolerate the Vilebranch!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43089,'Enough jawing! There\'s our ride.','',0,0,0,0,0,0,397,0,1,0,21283,0,26124),
(43090,'That ship\'s been commissioned by Hellscream himself.','',0,0,0,0,0,0,396,0,1,0,21284,0,26124),
(43091,'You\'re all under strict orders - No harassing her crew!','',0,0,0,0,0,0,274,0,1,0,21285,0,26124),
(43092,'We must put an end to the corruption permeating Ashenvale.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43093,'Gah... this ship reeks of human.','',0,0,0,0,0,0,14,0,1,0,21498,0,26124),
(43094,'Hah! Humans...','',0,0,0,0,0,0,25,0,1,0,21499,0,26124),
(43095,'Hear my words, brothers!','',0,0,0,0,0,0,5,0,1,0,21286,0,26124),
(43096,'We sail to a virgin island, a gift from Azeroth to the Horde!','',0,0,0,0,0,0,396,0,1,0,21287,0,26124),
(43097,'Securing this land will win us our war!','',0,0,0,0,0,0,397,0,1,0,21288,0,26124),
(43098,'The enemy has fought well, for Alliance...but they grow weary.','',0,0,0,0,0,0,396,0,1,0,21289,0,26124),
(43099,'We shall crush what remains of them and lay claim to this land.','',0,0,0,0,0,0,396,0,1,0,21290,0,26124),
(43100,'From its shores, we shall conquer Stormwind, and with it any hope the enemy clings to.','',0,0,0,0,0,0,396,0,1,0,21291,0,26124),
(43101,'Azeroth will be reforged under a single banner!','',0,0,0,0,0,0,5,0,1,0,21292,0,26124),
(43102,'This banner!!','',0,0,0,0,0,0,53,0,1,0,21293,0,26124),
(43103,'We can\'t afford to let our enemy, Thermaplugg, continue to tighten his grip on the rest of Gnomeregan.','',0,0,0,0,0,0,1,0,1,10045,0,0,26124),
(43104,'He has ordered his crony, Razlo Crushcog, to keep us on the defensive. Hinkles, what\'s the latest intelligence on Razlo and his men?','',0,0,0,0,0,0,1,0,1,10045,0,0,26124),
(43105,'It\'s been hard for our scouts to get information on what Crushcog is planning.','',0,0,0,0,0,0,1,0,1,10045,0,0,26124),
(43106,'Come aboard, now. Step on up!\n','',396,0,0,0,0,0,70,0,1,8873,0,0,26124),
(43107,'Cap\'n Samir is navigatin\' this here ship non-stop to that there ocean over yonder...\n','',22,0,0,0,0,0,22,0,1,8873,0,0,26124),
(43108,'...where we\'ll commence to assistin\' the Horde in their little skirmish with them Alliance fellers.\n','',22,0,0,0,0,0,22,0,1,8873,0,0,26124),
(43109,'Easy money! Commission\'s to be dispersed evenly among any and all survivors!\n','',22,0,0,0,0,0,0,0,1,8873,0,0,26124),
(43110,'What we do know is that Crushcog is using an advanced mechano-tank prototype and his irradiated gnomes are trying to repair more at the old arsenal.','',0,0,0,0,0,0,1,0,1,10045,0,0,26124),
(43111,'','We\'re going to have a hard time handling this one alone. I sent a message to the dwarven capital of Ironforge asking for their support.',0,0,0,0,0,0,1,0,1,10045,0,0,26124),
(43112,'And if you\'ll look to your left, you\'ll see that the gnomes have retaken Gnomeregan.  Hooray for us!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43113,'There\'s plenty else going on out here, too.  We\'ve opened up the path to the airport, there\'s rumors of Dark Irons in the east... oh, and I think something weird is going on with that dwarf king, Magni.  Might want to check it out.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43114,'What is the meaning of this!?','',0,0,0,0,0,0,6,0,1,0,21294,0,26124),
(43115,'And here we are!  Welcome to Kharanos!  Watch your step on the way out.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43116,'We have a battle to win!','',0,0,0,0,0,0,6,0,1,0,21295,0,26124),
(43117,'','A messenger reached us from Brewnall Village this morning. The dwarves are sending a squad of mountaineers to help us.',0,0,0,0,0,0,1,0,1,10045,0,0,26124),
(43118,'We have to be in position to strike against Crushcog when the mountaineers arrive.','',0,0,0,0,0,0,1,0,1,10045,0,0,26124),
(43119,'With Crushcog defeated, Thermaplugg is sure to be quaking in his mechano-tank, and rightly so. You\'re next, Thermaplugg. You\'re next!','',0,0,0,0,0,0,1,0,1,10045,0,0,26124),
(43120,'','Ready for a tussle, $Glad:lass;?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43121,'','Meddlesome gnats! You think us defeated so easily?',0,0,0,0,0,0,0,0,1,0,0,18891,26124),
(43122,'Stand your ground, brothers! Make it bleed!','',0,0,0,0,0,0,397,0,1,0,21296,0,26124),
(43123,'Deepholm was a slow, quiet place. Always alive. Steadily moving. Never rushed. In this time, I strived to become one with the earth, and to a large degree, I succeeded.$B$BLater, the Earthwarder returned, injured. He did not upset the balance at first. He\'d stayed here before, and we knew of him. The shift did not truly begin until the Twilight cult joined him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43124,'When the Earthwarder began to recover, he became ill content with the quiet. With the peace. It was not long before he turned the stone dragons upon us.$B$BWith Deathwing gone, they are without purpose again. We can remind them of our strength. Bring them back to the Earthmother.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43125,'And so I see that you have appealed to Diamant. I have been bidden to abide your passing, fleshling. But that shall be the extent of the welcome you shall receive from me.$B$BDo not forget our first conversation. My trust for you is shallow. You have much to prove.$B$BYou would do best to leave. I grow tired of being wary of where my feet fall.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43126,'Step aboard, friends! Carefully now...','',396,0,0,0,0,0,70,0,1,0,21358,0,26124),
(43127,'There ya go, all aboard. That\'s right...','',396,0,0,0,0,0,273,0,1,0,21359,0,26124),
(43128,'And please. Pay no heed to the... uhh... diversity of our crew.','',396,0,0,0,0,0,396,0,1,0,21361,0,26124),
(43129,'Rest assured, they\'ll deliver ya safely to yer destination.','',396,0,0,0,0,0,22,0,1,0,21362,0,26124),
(43130,'That being the fresh piece of land just off the coast of the Eastern Kingdoms.','',396,0,0,0,0,0,396,0,1,0,21363,0,26124),
(43131,'Alright then. Make ready everyone... here we go!','',396,0,0,0,0,0,22,0,1,0,21364,0,26124),
(43132,'You hear the sound of shuffling stones behind you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43133,'Pebble bounces up and down happily.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43134,'Pebble shuffles around happily.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43135,'Pebble races in circles, clearly happy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43136,'Pebble shuffles up against your leg happily.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43137,'Pebble slumps down sadly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43138,'Pebble turns away sadly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43139,'Pebble looks up at you hopefully.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43140,'Your hear the Pebble\'s stones jittering about inside of him. He\'s clearly excited about something.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43141,'Pebbles stones burst apart onto the ground, then slowly reform into a full fledged, happy Pebble.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43142,'Pebble sees the crystals ahead and excitedly rushes towards them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43143,'Hold your ground!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43144,'Put those stone troggs back into the earth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43145,'We have reinforcements! For the Stonefather!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43146,'Do you want to live forever?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43147,'Shore up those flanks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43148,'This Is Stonehearth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43149,'By Khaz\'goroth\'s hammer, we will break them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43150,'For Stonefather Oremantle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43151,'I can\'t do this while they\'re attacking me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43152,'Get these stone troggs off of me so that I can summon the rockslide!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43153,'I can\'t perform the ritual while they\'re beating on me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43154,'A little help here first, $c?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43155,'Give me the reagents again when these stone troggs are dead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43156,'Keep them from hitting me and I\'ll seal the hatch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43157,'I don\'t know how they found a way up from underneath, but I can\'t seal the hatch until they\'re off of me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43158,'We have to deal with these stone troggs first. Then hand me the reagents.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43159,'Pebble bobbles around appreciatively.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43160,'For the Stonefather!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43161,'For Stonefather Oremantle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43162,'For Stonehearth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43163,'Kill the stone troggs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43164,'Hail, citizen. I would recommend that you speak with Watch Captain Parker. He\'s currently at the top of this tower.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43165,'Pebble\'s excitement has drawn the attention nearby rock flayers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43166,'','All right, sunshine.  Time to spill your guts before I spill \'em for ya!',0,0,0,0,0,0,0,0,1,0,0,21003,26124),
(43167,'Wait!  You can\'t do this!  You people must have a code of honor or something!','',0,0,0,0,0,0,0,0,1,0,20992,0,26124),
(43168,'','I\'m a daughter of the Wildhammer Clan and a shaman of the Earthen Ring.  My code compels me to honor my ancestors and the elements.',0,0,0,0,0,0,0,0,1,0,0,21004,26124),
(43169,'','Doesn\'t say a damn thing about dog-ugly ogres.',0,0,0,0,0,0,0,0,1,0,0,21005,26124),
(43170,'','You can start by telling us where the World Pillar fragment is.  My gryphon\'s starting to look a bit tired from hauling you around.',0,0,0,0,0,0,0,0,1,0,0,21006,26124),
(43171,'Stop it, you tiny, angry woman!  I\'ll tell you everything!  What do you want to know?','',0,0,0,0,0,0,0,0,1,0,20993,0,26124),
(43172,'It was delivered to the forgemaster at Deathwing\'s Fall.  I swear... that\'s all I know!','',0,0,0,0,0,0,0,0,1,0,20994,0,26124),
(43173,'Somebody... please... get... rock... off... me...','',0,0,0,0,0,0,0,0,1,10059,0,0,26124),
(43174,'Hurts... Hurts so bad...','',0,0,0,0,0,0,0,0,1,10059,0,0,26124),
(43175,'Please... kill... me...','',0,0,0,0,0,0,0,0,1,10059,0,0,26124),
(43176,'I... just... wanted... to... build... the... damned... bridge...','',0,0,0,0,0,0,0,0,1,10059,0,0,26124),
(43177,'','You were never in any danger, sweetheart.  My friends down below would\'ve caught you.  You\'re worth too much to us alive!',0,0,0,0,0,0,0,0,1,0,0,21007,26124),
(43178,'Happy now?  Pull me up, you vicious little dwarf!','',0,0,0,0,0,0,0,0,1,0,20995,0,26124),
(43179,'What? What have you done?  No!  Do you have any idea what the Twilight Council will do to me when they find out I\'ve talked!?  I would sooner die!','',0,0,0,0,0,0,0,0,1,0,20996,0,26124),
(43180,'','Interesting.  I\'d never heard of the Twilight Council until now.',0,0,0,0,0,0,0,0,1,0,0,21008,26124),
(43181,'PUT YOUR BACKS INTO IT, BOYS!','',0,0,0,0,0,0,0,0,1,10059,0,0,26124),
(43182,'HEAVE!','',0,0,0,0,0,0,0,0,1,10059,0,0,26124),
(43183,'HO!','',0,0,0,0,0,0,0,0,1,10059,0,0,26124),
(43184,'DAMN ROCK WON\'T BUDGE!','',0,0,0,0,0,0,0,0,1,10059,0,0,26124),
(43185,'PUSH HARDER!','',0,0,0,0,0,0,0,0,1,10059,0,0,26124),
(43186,'I\'M PUSHIN\' AS HARD AS I CAN! THING WEIGHS A TON!','',0,0,0,0,0,0,0,0,1,10059,0,0,26124),
(43187,'We\'ll get you out of there, Foreman, just HANG ON!','',0,0,0,0,0,0,0,0,1,10059,0,0,26124),
(43188,'Going ashore, $n?$B$BSay the word and I\'ll lower a boat for you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(43189,'Send me ashore, Horzog.','Send me ashore, Horzog.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43190,'Well, it\'s not good. The battle has taken its toll on both your steam tanks. My salvage teams will secure what\'s left of them as soon as it\'s safe.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43191,'With an ample supply of gyromechanic gears, and a team of engineers, your tanks can make a full recovery, but it\'s going to be a long journey.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43192,'Poor, poor Trollplow. At least the old gal went out doin\' something she loved.','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(43193,'Pull yerself togther, Stone! You\'re a steam tank pilot, for Light\'s sake!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(43194,'How dare they take our king prisoner!$B$BWe will take back Stonehearth and then move through the front to crush the stone troggs in their home!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(43195,'Horzog orders a landing boat to be lowered into the water. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43196,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43197,'Let\'s get out there and put those stone troggs back into the ground, $r!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(43198,'Razzle, tell him everything\'s going to be fine!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(43199,'I need you out on the front, $n.$B$BYou\'re going to make the difference. We\'ll crush the stone troggs once and for all.$B$BWe must rescue King Oremantle!','',396,396,0,0,0,0,0,0,1,0,0,0,26124),
(43200,'Yes, yes, everything will be fine! Wonderful, in fact. She\'ll be better than ever!','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(43201,'<Clay grumbles and sneers.>$B$BDamn kids these days.','',1,0,0,1000,0,0,0,0,1,0,0,0,26124),
(43202,'In fact, I\'ll go see about those gears right now!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43203,'There, see? Ol\' Trollplow\'ll be better in no time! Before you know it, you\'ll be bragging about out-gunning me again...','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(43204,'C\'mon, let\'s get you another ale.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(43206,'By the time the ritual is complete, Marnal will arrive, and my men will help carve up this grotesque creature.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43207,'Imagine the most amazing elevator you have ever seen... right here. Yea, its sweet isn\'t it? Sadly, its not ready yet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43208,'Just teleport me for now. But I can\'t wait for that sweet sweet elevator!','Just teleport me for now. But I can\'t wait for that sweet sweet elevator!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43209,'Patience... our turn will come.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43210,'<The murloc looks at you with thirsty eyes.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43211,'<Offer the murloc a drink.>','<Offer the murloc a drink.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43212,'$R come to look at Orgus?  Take picture, last longer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43213,'<Offer the ogre a drink.>','<Offer the ogre a drink.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43214,'Yarr, thar be nary a soul s\'thirsty as me, says I.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43215,'<Offer the pirate a drink.>','<Offer the pirate a drink.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43216,'Deathwing\'s entry into our world opened a rift between it and Deepholm.$B$BRebuilding the World Pillar is the only way to stabilize the rift.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43217,'Negotiations aren\'t going well, $n. The Dragonmaw are not yet free orcs.$B$BSomehow, we MUST get them to join the Horde!$B$BLet me know if you need transport back to the fleet.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(43218,'ROCK NOT SO HEAVY! PUNY HUMIES!','',0,0,0,0,0,0,0,0,1,10063,0,0,26124),
(43219,'Can I get a ride back to the fleet?','Can I get a ride back to the fleet?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43220,'Where trow? TROW ON BRIDGE??','',0,0,0,0,0,0,0,0,1,10063,0,0,26124),
(43221,'Gmurgl starts to follow you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43222,'OK! Me trow in water!','',0,0,0,0,0,0,0,0,1,10063,0,0,26124),
(43223,'Ornak orders a boat to push off for the fleet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43224,'Oh... Orgus not feel so good...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43225,'Orgus think something wrong with $r lemonade...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43226,'BYE, BYE, DADDY!','',0,0,0,0,0,0,0,0,1,10063,0,0,26124),
(43227,'Well blow me down!  The landlubber scalawag comes bearin\' rum!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43228,'Yarr?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43229,'Shiver me timbers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43230,'NO, NO, NO! Please!','',0,0,0,0,0,0,0,0,1,10063,0,0,26124),
(43231,'NOOOOOO!!!','',0,0,0,0,0,0,0,0,1,10063,0,0,26124),
(43232,'ANYWHERE BUT THE BRIDGE!','',0,0,0,0,0,0,0,0,1,10063,0,0,26124),
(43233,'Where to, buddy?','Where to, buddy?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43234,'See me if you need a boat to the shore, $n!','',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(43235,'We\'re getting bogged down in the fight against the Frostmane trolls.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(43236,'Most of our steam tanks are out of commission and we\'re losing mountaineers quickly.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(43237,'Very well, Zaela. I trust you to do the right thing. $C, I can help your fallen warriors...','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(43238,'I ... I can\'t give you any of our supplies! Our Warchief... He would...','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(43239,'','Gregor, you coward! Orcs of pure blood are dying off our shores. If you doom them, you doom us all.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(43240,'Welcome to the Orgrimmar Rocketway Exchange! You still look to be in one piece.','Welcome to the Orgrimmar Rocketway Exchange! You still look to be in one piece.',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(43241,'','$n, know that our \"Warchief\" does not speak for us all. There are those among us who hope to see the Dragonmaw great again... and free from corruption.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43242,'','It won\'t be long before we\'re out of supplies too, Captain. Between the trolls and the yeti raids, we\'ll be down to half rations within a week.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43243,'We can\'t keep up the operation much longer. Delber and his team must launch their attack from Steelgrill\'s Depot as soon as possible!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(43244,'Not so fast, wet guy!','Not so fast, wet guy!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(43245,'Delber and his men are working overtime, captain. He has devised a means of delivering an assault team to the rear flank of the battle.','Delber and his men are working overtime, captain. He has devised a means of delivering an assault team to the rear flank of the battle.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43246,'Orgrimmar Rocketway Exchange, please.','Orgrimmar Rocketway Exchange, please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43247,'Zombie pirates?!  Kill it!','Zombie pirates?!  Kill it!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(43248,'We\'ve also secured air support for the operation and will be ready to deploy soon. If any of your men want to join the assault team, just send them to Delber.','We\'ve also secured air support for the operation and will be ready to deploy soon. If any of your men want to join the assault team, just send them to Delber.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43249,'Southern Rocketway Terminus, please.','Southern Rocketway Terminus, please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43250,'Gallywix Rocketway Exchange, please.','Gallywix Rocketway Exchange, please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43251,'Northern Rocketway Exchange, please.','Northern Rocketway Exchange, please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43252,'Northern Rocketway Terminus, please.','Northern Rocketway Terminus, please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43253,'Glad to hear it. I\'ll send Delber any forces I can spare.','Glad to hear it. I\'ll send Delber any forces I can spare.',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(43254,'We Dragonmaw have seen so much suffering... our defeat at Grim Batol... the loss of so many great warriors in Outland... and now incursions from Twilight\'s Hammer.$B$BI sometimes wonder if we will ever be great again. But younglings like Zaela, they give this old heap of bones some hope.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(43255,'What is it you need, outsider? I shouldn\'t be speaking with you...','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(43256,'Our warriors are dying. Do you have medical supplies I can take back with me?','Our warriors are dying. Do you have medical supplies I can take back with me?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(43257,'Welcome to the Gallywix Rocketway Exchange! Debts to pay or get the heck away.','Welcome to the Gallywix Rocketway Exchange! Debts to pay or get the heck away.',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(43258,'Welcome to the Northern Rocketway Exchange! We at Rocketway Relations are glad you survived that last turn!','Welcome to the Northern Rocketway Exchange! We at Rocketway Relations are glad you survived that last turn!',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(43259,'Welcome to the Northern Rocketway Terminus! You probably took a wrong turn, but we\'re happy to have you anyway!','Welcome to the Northern Rocketway Terminus! You probably took a wrong turn, but we\'re happy to have you anyway!',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(43260,'Welcome to the Southern Rocketway Terminus! Home of the world famous Secret Lab!','Welcome to the Southern Rocketway Terminus! Home of the world famous Secret Lab!',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(43261,'This ancient totem is fashioned into the shape of a bat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43262,'We\'re finished! I might as well call for an evacuation now and clear out Lakeshire before the orcs march.','',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(43263,'And right when we finally finished building that damned bridge! What hope is there, $n?','',0,0,0,0,0,0,6,7,1,0,0,0,26124),
(43264,'There is hope, Solomon.','',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(43265,'What hope, colonel? What could possibly save us from the impending assault?','',0,0,0,0,0,0,6,7,1,0,0,0,26124),
(43266,'He served 248 consecutive tours of duty across the First, Second and Third Wars.','',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(43267,'Captured five years ago by a battalion of filthy, pig sucking Blackrocks, five clicks out from the southern DMZ.','',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(43268,'Tortured and kept alive as a urinal for young orc warriors. For FIVE YEARS.','',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(43269,'JOHN J. KEESHAN.','',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(43270,'Keeshan\'s alive? I thought he died.','',0,0,0,0,0,0,6,7,1,0,0,0,26124),
(43271,'He\'s alive alright, and been living like an outcast in Lakeshire for the past five months. Or hadn\'t you noticed? Now enough chatter. We\'ve got people to save!','',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(43272,'I misplaced my Negotiator. In fact, he\'s probably dead. Is another available?','I misplaced my Negotiator. In fact, he\'s probably dead. Is another available?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43273,'I\'m sick of sittin\' in this hole. I hope whatever sorry pencil-pusher is holdin\' up Danath\'s return gets a punch in the jimmies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43274,'Hey, does this red shirt make me look expendable?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43275,'I am ready, $n. Soon the Dragonmaw will join the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43276,'I hear a great Dragonmaw medicine man lives here, in the large hut to our right.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(43277,'This ancient totem is fashioned into the shape of a bat.  It must be the totem that Chabal spoke of.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43278,'Place the incense at the foot of the statue.','Place the incense at the foot of the statue.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43279,'After these negotiations, I am looking forward to a long and prosperous life.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43280,'The Dragonmaw Warchief is in the largest building up on the hilltop here. I\'m sure he\'ll be reasonable.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43281,'This is it! Stay close and let me do the talking. I\'m an expert.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43282,'Welcome to Aerie Peak, home of the Wildhammer Clan.$B$BWith High Thane Falstad off in Ironforge, you\'ll be dealin\' with me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43283,'The battle begins in 1 minute.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43284,'The battle begins in 30 seconds.  Prepare yourselves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43285,'The spirits o\' this land won\'t tolerate this dark magic and vicious sacrifice any longer.$B$BThe Vilebranch have got to go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43286,'Ya head\'s gonna make a nice bag!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43287,'Let\'s get this over with. I\'d rather be back home at Aerie Peak than starin\' down these ugly trolls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43288,'You thought those long arms gave you an advantage, $r? Think again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43289,'Leave Ongo\'longo ALONE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43290,'Let\'s not waste time! There\'s undead afoot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43291,'Hold it now. Let\'s not rush in.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43292,'I\'ve had enough of this!  Time to take a break...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43293,'Zanzil\'s back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43294,'If I ever get out of here I\'m gonna crap all over your head, you pig sucking orc.','',0,0,0,0,0,0,5,0,1,10099,0,0,26124),
(43295,'Where\'s the rest of my crew??!','',0,0,0,0,0,0,5,0,1,10099,0,0,26124),
(43296,'You think these bars can hold me? HAH!','',0,0,0,0,0,0,5,0,1,10099,0,0,26124),
(43297,'','High Priestess Jeklik is nearly healed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43298,'Most esteemed Warchief -','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(43299,'Warchief, you misunderstand. Garrosh Hellscream will have a beach head on these shores, with or without your help. What we ask -','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43300,'What\'re you doin\' here?  Don\' matter, I\'m gonna resurrect Jeklik before you get a chance to interfere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43301,'But the Horde has assembled an enormous host! A vast fleet of war machines and hardened veterans. Hellscream would as soon crush you as-','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(43302,'This is madness!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(43303,'','I LIVE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43304,'Uh oh... Jin\'do\'s not gonna be happy about this...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43305,'Time to get out of here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43306,'Quit wasting words, worm. If you want the aid of the Dragonmaw, you should\'ve come on bent knee and with offerings of gold.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(43307,'Was that a THREAT? I knew Hellscream in Outland. A whimpering whelp. He is no Warchief.','',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(43308,'Bring him on!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(43309,'This is...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43310,'DRAGONMAW!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43311,'Keep the $c alive. $gHe:She; will be our bargaining chip.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43312,'Call for the others. We will crush Hellscream\'s Horde and hurl their bodies to the sea...','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(43313,'Keeping the bomb warm, obviously. What does it look like I\'m doing?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43314,'What are you doing just sitting there?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43315,'High Priest Venoxis is nearly healed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43316,'Take me to the battle at the Ruins of Feathermoon.','Take me to the battle at the Ruins of Feathermoon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43318,'Will you do whatever it takes to save your kingdom?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(43319,'I must return to Feathermoon Stronghold!','I must return to Feathermoon Stronghold!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43320,'You\'re back for more, huh?  Too bad, because I\'ve got a stronger potion mixed up this time!  Venoxis will live!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43321,'I can\'t take much more of this...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43322,'Here comes Zanzil!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43323,'Ahahaha!  Zanzil is the winner this time!  And look who came to celebrate!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43324,'Nooo!  Zanzil is a failure...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43326,'','The Kvaldir have been purged from the city. Now we can begin our preparations.',0,0,0,0,0,0,0,0,1,0,0,21806,26124),
(43327,'','Battlemaiden, I have a task that requires your attention.',0,0,0,0,0,0,0,0,1,0,0,21807,26124),
(43328,'','Battlemaiden! You are needed on the battlefield. The Kvaldir have broken through our lines!',0,0,0,0,0,0,0,0,1,0,0,21805,26124),
(43329,'Welcome!','Welcome!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43330,'Greetings, $c.','Greetings, $c.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43331,'','Stand fast! The ritual is almost complete.',0,0,0,0,0,0,0,0,1,0,0,21799,26124),
(43332,'','Cut them down, Battlemaiden!',0,0,0,0,0,0,0,0,1,0,0,21798,26124),
(43333,'Greetings! Please have a look around.','Greetings! Please have a look around.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43334,'','Hold them back! Keep them away from the temple!',0,0,0,0,0,0,0,0,1,0,0,21795,26124),
(43335,'Let me know if you need help finding anything, $c.','Let me know if you need help finding anything, $c.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43336,'Welcome. May I help you find something?','Welcome. May I help you find something?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43337,'Greetings.','Greetings.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43338,'Welcome.','Welcome.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43339,'Welcome!','Welcome!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(43340,'Greetings, $c.','Greetings, $c.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(43341,'Greetings! Please have a look around.','Greetings! Please have a look around.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(43342,'Let me know if you need help finding anything, $c.','Let me know if you need help finding anything, $c.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(43343,'Welcome. May I help you find something?','Welcome. May I help you find something?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(43344,'Greetings.','Greetings.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(43345,'Welcome.','Welcome.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(43346,'Slaughter them all! Show no mercy, brothers!','',0,0,0,0,0,0,0,0,1,0,21854,0,26124),
(43347,'The only peace you shall find is in death, Kvaldir!','',0,0,0,0,0,0,0,0,1,0,21853,0,26124),
(43348,'Your march to your deaths! Azshara shall see you wiped from the seas!','',0,0,0,0,0,0,0,0,1,0,21852,0,26124),
(43349,'You press on... to your deaths... fools.','',0,0,0,0,0,0,0,0,1,0,21856,0,26124),
(43350,'Fools. Weaklings. ','',0,0,0,0,0,0,0,0,1,0,21990,0,26124),
(43351,'You should have accepted your defeat.','',0,0,0,0,0,0,0,0,1,0,21991,0,26124),
(43352,'Your return brings you only death.','',0,0,0,0,0,0,0,0,1,0,21993,0,26124),
(43353,'Slavery and death are all that away you.','',0,0,0,0,0,0,0,0,1,0,21994,0,26124),
(43354,'Kvaldir are pouring across the bridge! Battlemaiden, Lady Naz\'jar calls for you!','',0,0,0,0,0,0,0,0,1,0,21665,0,26124),
(43355,'Back to the sands with you, wretch!','',0,0,0,0,0,0,0,0,1,0,21666,0,26124),
(43356,'Kind of them to stream in one by one.','',0,0,0,0,0,0,0,0,1,0,21667,0,26124),
(43357,'About as tough as seaweed too.','',0,0,0,0,0,0,0,0,1,0,21668,0,26124),
(43358,'They must really like this city. Maybe it\'s the view?','',0,0,0,0,0,0,0,0,1,0,21669,0,26124),
(43359,'The Gurubashi are dead, and Hakkar with them.  Most of my fellow Zandalar have returned to their homeland.$b$bIt falls on me, Maywiki, and the Darkspears of Bambala to watch over Zul\'Gurub now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43360,'Chabal, I was hunting Zanzil and I lost track of what I was doing.  Can remind me where to go next?','Chabal, I was hunting Zanzil and I lost track of what I was doing.  Can remind me where to go next?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43361,'','The Kvaldir have returned to take the city back from us, Battlemaiden. They will need you outside.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43362,'Jin\'do the Hexxer!  It\'s been a while since I\'ve seen that mask.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43363,'What brings you out to my part of Stranglethorn?  I\'m not accustomed to taking visitors from the esteemed Zul\'Gurub.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43364,'You know well enough about why I\'m here, Zanzil.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43365,'The Gurubashi have fallen on hard times.  I live, and Mandokir has returned... but the rest of us are gone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43366,'What a shame... but not a concern for an old exile like Zanzil.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43367,'Well, Zanzil, I\'d like to make it your concern.  I\'ve recovered the bodies of High Priestess Jeklik and High Priest Venoxis.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43368,'I remember what you can do with those elixirs of yours.  Can your elixirs help out an old friend?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43369,'Friend?  You were among those who spit and threw stones, Jin\'do.  But let\'s let bygones be bygones, eh?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43370,'So your bat and your snake need Zanzil\'s help?  Very well.  I\'ll see you inside Zul\'Gurub... old friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43371,'Kvaldir never die... this city is ours...','',0,0,0,0,0,0,0,0,1,0,21408,0,26124),
(43372,'','There\'s more to this than we know, $n.  I can guarantee you that much.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43373,'','Thank you.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43374,'','Erunak, take a look at this. This looks like a sufficient focus for the vision magics I was speaking to you about.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43375,'','I will prepare the enchantment right away then. This may finally shed some light on the means and intentions of the naga.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43376,'Of course.  It\'s all yours.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43377,'I thought we\'d killed everybody... Mor\'norokk should be pleased with this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43378,'Your race is a disease upon the sea.','',0,0,0,0,0,0,0,0,1,0,21526,0,26124),
(43379,'Neptulon will rise and wash your kind from Azeroth.','',0,0,0,0,0,0,0,0,1,0,21528,0,26124),
(43380,'Choke upon the sands of the Kvaldir!','',0,0,0,0,0,0,0,0,1,0,21527,0,26124),
(43381,'You should have left this city to the waves.','',0,0,0,0,0,0,0,0,1,0,21525,0,26124),
(43382,'What\'s goin\' on in here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43383,'Zanzil!  Finish with Venoxis, then we\'ll talk about your failures.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43384,'Yes, Jin\'do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43385,'And you.  You\'ve interfered with my plans for the last time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43386,'Hakkar grows impatient.  And so do I.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43387,'You may have slain Jeklik, but you will not leave Zul\'Gurub alive.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43388,'Prepare to die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43389,'','And if you\'ll look to your right, you\'ll see... my friend, about to get killed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43390,'','Quick!  Grab onto the ladder!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43391,'Take her in slowly, number two.','',0,0,0,0,0,0,1,0,1,0,21223,0,26124),
(43392,'Fire! Fire! Blow it out of the water!','',0,0,0,0,0,0,5,0,1,0,21225,0,26124),
(43393,'Don\'t worry, number two. We\'ll get another chance. And we\'ll be ready.','',0,0,0,0,0,0,1,0,1,0,21226,0,26124),
(43394,'We are approaching the cavern, Captain.','',0,0,0,0,0,0,1,0,1,0,21529,0,26124),
(43395,'The reports were accurate! The beast is here...','',0,0,0,0,0,0,5,0,1,0,21530,0,26124),
(43396,'Steady, number two...','',0,0,0,0,0,0,1,0,1,0,21224,0,26124),
(43397,'The beast escaped! By Gallywix\'s gut, it was fast!','',0,0,0,0,0,0,5,0,1,0,21531,0,26124),
(43398,'Take her in slowly, number two.','',0,0,0,0,0,0,1,0,1,0,21179,0,26124),
(43399,'Steady, number two...','',0,0,0,0,0,0,0,0,1,0,21180,0,26124),
(43400,'Fire! Fire! Blow it out of the water!','',0,0,0,0,0,0,5,0,1,0,21181,0,26124),
(43401,'Don\'t worry, number two. We\'ll get another chance. And we\'ll be ready.','',0,0,0,0,0,0,1,0,1,0,21182,0,26124),
(43402,'We are approaching the cavern, Captain.','',0,0,0,0,0,0,1,0,1,0,21532,0,26124),
(43403,'The reports were accurate! The beast is here...','',0,0,0,0,0,0,5,0,1,0,21533,0,26124),
(43404,'The beast escaped! By Mekkatorque\'s moustache, it was fast!','',0,0,0,0,0,0,5,0,1,0,21534,0,26124),
(43405,'You orcs are gonna be sorry when I get out of here.','',0,0,0,0,0,0,5,0,1,10100,0,0,26124),
(43406,'Payback\'s gonna hurt.','',0,0,0,0,0,0,5,0,1,10100,0,0,26124),
(43407,'Haaadoouuuu....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43408,'... KEN!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43409,'Zanzil teleports to another location!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43410,'','Welcome to Hardwrench Hideaway!$b$bLooking to get away from the hustle and bustle of city life?  You\'ve come to the right place!$b$bWant to witness the marvels of Azeroth\'s famous jungle firsthand?  Look no further!$b$bShopping for some freshly pumped bio-fuel or weapons-grade mineral ores?  Then you\'ve come to the right place, $c!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43411,'','Hey, boss.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43412,'How can I help you?  Here for some of our famous Lobstrok Thermidor?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43413,'Thank you, $r.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(43414,'I think I can make it back on my own.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43415,'You\'re a strange-looking creature. Thank you.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(43416,'What happened?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(43417,'Kill a few for me, would you?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43418,'Don\'t worry about me. We have to rescue the king!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(43419,'We can\'t leave these refugees like this, Kelaan. Buin here has sold his weapons and armor to buy food for them. He cannot do it alone.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(43420,'You need to kill Troggzor the Earthinator!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(43421,'I have to report back. Thank you, $c!','',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(43422,'I am not blind to their suffering, Lowan, but our mission here is to learn about what the cataclysm has wrought. Azeroth itself is suffering.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43423,'I have sent to Light\'s Hope Chapel for a grant of gold for the care of the refugees. Carry out your mission, but help as you can.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43424,'Thank you, Father Gavin. The world needs more like you and Buin in these dark times.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(43425,'So much senseless loss.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(43426,'Fishing has always come naturally to my family.  You look like you could use a little help though.  How about running a few errands for a Master Angler?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(43427,'Eat dirt you filthy mongrel!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43428,'Back to your maker!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43429,'No good piece of crap!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43430,'Nowhere to run!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43431,'You messed with the wrong soldier!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43432,'And keep the change you filthy animal!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43433,'I\'m just gettin\' warmed up!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43434,'Is that the best you can do?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43435,'I don\'t even have my gear on!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43436,'GET SOME!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43437,'And just like that, you\'re dead!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43438,'HAH!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43439,'I\'ve had tougher craps.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43440,'Welcome to hell!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43441,'Toe up...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43442,'Did you hear that crack?!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43443,'Revenge is a dish best served with a butt whompin\'!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43444,'Here\'s to you!  Here\'s to me!  May we never disagree.$b$bBut if we do... BLAST YOU!  Here\'s to me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43445,'I hear you\'ve got some drinks I can buy, Slim.','I hear you\'ve got some drinks I can buy, Slim.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43446,'%s belches.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43447,'This lifeboat appears to be abandoned.  Maybe it belongs to some of the nearby pirates?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43448,'This must be the lifeboat that Captain Hecklebury Smotts spoke about.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43449,'You take a moment to silently remember when you used this lifeboat to defeat Negolash.  Those were the good days.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43450,'<Place the food and drink inside the lifeboat.>','<Place the food and drink inside the lifeboat.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43451,'You know, I\'ve always wondered why they call themselves orcs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43452,'It\'s an ugly word, you know? It\'s a word I\'d use to describe defecating. For example:','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43453,'After that Pilgrim\'s Bounty dinner, I took a huge smelly orc.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43454,'We\'ve come to try to help, but it seems that their favor for you does not yet extend to us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43455,'I really missed you, Danforth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43456,'I remember this one time, Keeshan and I were out fishing at the Lakeshire bridge and Keeshan farted. Don\'t think Oslow ever forgave Keeshan for that one...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43457,'You know, Keeshan lost his wife to Blackrock orcs. He was never the same after that day. Was like the sun just set on his life. Darkness, $g man:lady;. Pure darkness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43458,'They called us the Bravo Company. When things needed killin\', we did the spillin\'... of blood.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43459,'Messner is a master of fire magic. We invite him to all of our barbecues.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43460,'Jorgensen is real dainty, by the way. He\'s a paladin, so be careful what you say around him or you\'re liable to make him cry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43461,'So I hear Varian Wrynn is back. That true? Sorry, I\'m a bit out of the loop.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43462,'You ever notice how sarcastic the people living in Redridge are? Sometimes I feel like I just want to take a blow torch to that jackass Solomon\'s town hall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43463,'','Hurry, Gorthul. Undo $ghis:her; bonds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43464,'','$n, I\'ve rescued your equipment for you. I think you\'ve seen all you need to see.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43465,'I feel weak. I mean weaker than normal. Like as if the Light is less powerful this week. Probably just something I ate. Orc food gives me the craps.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43466,'You ever seen Keeshan kill an orc? It\'s a sight to behold, $g man:lady;.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43467,'','Remember, $n. Not all Dragonmaw are your enemies!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43468,'Can\'t believe we\'re putting the old team back together. All thanks to you, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43469,'So I heard Thrall left the Horde. That true?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43470,'You know, I kept hearing the Blackrock orcs talk about the return of Hellscream to the Horde. What\'s that all about? Isn\'t Hellscream dead?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43471,'I\'m probably the most important member of this team, being a paladin and all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43472,'Wait\'ll these orcs get a load of us. Bravo Company BACK IN BUSINESS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43473,'I\'m in my group and ready to teleport to the Throne of the Tides!','I\'m in my group and ready to teleport to the Throne of the Tides!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43474,'So whatever happened to that hot little number in Stormwind? Lady Prestor was her name.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43475,'It\'s weird. My butt hurts. Not sure why.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43476,'Throne of the Tides, a level 79-81 dungeon in Vashj\'ir, is now available for initial testing. The dungeon is very much a work in progress, and the final boss is not available. Please be in your full group before teleporting to the dungeon. Meeting Stones are not available for this dungeon yet.\n\nTo leave the Throne of the Tides, simply exit through the normal exit inside the dungeon and you will be teleported to Dalaran. If you die and release, you should teleport back from this NPC.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43477,'Keeshan\'s a good man, $n. Any of us would give our lives for him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43478,'When this is all over, I\'m taking a vacation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43479,'Take me back to Throne of the Tides!','Take me back to Throne of the Tides!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43480,'We all owe our lives to Keeshan. He\'s saved our hides a hundred times.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43481,'Being a mage has its advantages, but the laundry bills are hell to pay.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43482,'So what\'s up with the bridge in Lakeshire? Oslow ever finish building it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43483,'I think I\'m gonna go to Dalaran after this is over. Help \'em get that city up and floating.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43484,'I need to use the restroom.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43485,'These orcs are in for a rude awakening once Bravo Company is back up and running.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43486,'','World-famous Noggenfogger Elixir sold here!$B$BHome brewed from all-natural ingredients, bottled and sold locally right here in Gadgetzan. And it\'s delicious, of course!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(43487,'Make mine Noggenfogger!','Make mine Noggenfogger!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43488,'Ah, Maloriak. How gracious of you to finally appear from that quarantine you call a laboratory. What have you got this time?','',0,0,0,0,0,0,1,0,1,0,20091,0,26124),
(43489,'By all means, enlighten me. ','',0,0,0,0,0,0,6,0,1,0,20092,0,26124),
(43490,' It appears as though your experiment has failed. That whelp has gone completely blind! Look at him.','',0,0,0,0,0,0,1,0,1,0,20093,0,26124),
(43491,'LOOK AT HIM!','',0,0,0,0,0,0,25,0,1,0,20156,0,26124),
(43492,'No, not yet.','',0,0,0,0,0,0,274,0,1,0,20094,0,26124),
(43493,'This object of your chagrin may still prove... valuable... to me.','',0,0,0,0,0,0,273,0,1,0,20095,0,26124),
(43494,'Leave now, pathetic alchemist. I anxiously await your next failure.','',0,0,0,0,0,0,21,0,1,0,20096,0,26124),
(43495,'My sincerest apologies for the disturbance, my liege. But I believe I have something you may be very interested in!','',0,0,0,0,0,0,2,0,1,0,19860,0,26124),
(43496,'Yes, yes! ','',0,0,0,0,0,0,273,0,1,0,19861,0,26124),
(43497,'By extracting agents from the blood of various dragonflights I have created a salve that will bestow the wearer sight beyond sight!','',0,0,0,0,0,0,1,0,1,0,19862,0,26124),
(43498,'I present to you experiment number 25463-D!','',0,0,0,0,0,0,21,0,1,0,19865,0,26124),
(43502,'How could this be?! I will dispose of him immediately! \n','',0,0,0,0,0,0,6,0,1,0,19866,0,26124),
(43503,'I beg your mercy, my lord.','',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(43504,'I can\'t do business with you, $c. Warchief\'s Orders.','I can\'t do business with you, $c. Warchief\'s Orders.',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(43505,'I have nothing I\'m allowed to sell to you.','I have nothing I\'m allowed to sell to you.',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(43506,'Get lost, $c! I don\'t want the enforcers to see me doing business with you...','Get lost, $c! I don\'t want the enforcers to see me doing business with you...',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(43507,'Go away, I don\'t want the Warchief to find out I\'ve been talking to the Horde.','Go away, I don\'t want the Warchief to find out I\'ve been talking to the Horde.',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(43508,'My goods aren\'t for sale to the Horde. Don\'t like it? Take it up with the Warchief!','My goods aren\'t for sale to the Horde. Don\'t like it? Take it up with the Warchief!',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(43509,'Warchief Mor\'ghor ordered us not to do business with the Horde.$B$B<The merchant spits on the ground, infuriated, but refuses to speak any more on the subject.>','Warchief Mor\'ghor ordered us not to do business with the Horde.$B$B<The merchant spits on the ground, infuriated, but refuses to speak any more on the subject.>',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(43512,'Me not feel so good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43513,'I can\'t help you, $c. Warchief Mor\'ghor would have me executed if I allowed the Horde to use one of our wind riders.$B$BSome day he\'ll get what\'s coming to him...','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(43514,'Senses beyond this realm of mortality!','',0,0,0,0,0,0,5,0,1,0,19863,0,26124),
(43515,'Eureka!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43516,'Looks like we got a war to win.','',0,0,0,0,0,0,0,0,1,10111,0,0,26124),
(43517,'PAIN TRAIN INCOMING!','',0,0,0,0,0,0,0,0,1,10111,0,0,26124),
(43518,'JOHNNY\'S BACK, BABY! YEA!','',0,0,0,0,0,0,0,0,1,10111,0,0,26124),
(43519,'Er... did you mention something about a Personal Arcane Assistant?','Er... did you mention something about a Personal Arcane Assistant?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43520,'Cowards! Face the brood mother or face DIRE consequences!','',0,0,0,0,0,0,0,0,1,0,20072,0,26124),
(43521,'The air crackles with electricity!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43522,'There\'s no substitute for live observers, but I need those mountaineers here. We\'ll have to rely on those little gnomish observer bots for now...','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(43523,'Not a bad place here, if you aren\'t into the whole \"sunshine\" thing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43524,'Take us out, Messner.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43525,'You got it, Johnny!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43526,'We\'re here, everybody out!','',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(43527,'Excuse me, I need to get back to my work.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43528,'Juntz, I\'m here to collect a debt.  Pay up.','Juntz, I\'m here to collect a debt.  Pay up.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43529,'The gorillas are fascinating creatures.  Better than night elves, who do foolish things, like... gambling away all their money and getting put on Sea Wolf MacKinley\'s hit list.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43530,'So you know why I\'m here then.  All right Midriff, pay up.','So you know why I\'m here then.  All right Midriff, pay up.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43531,'How did you find me!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43532,'I haven\'t got any money!  Get away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43533,'Go ahead, $r. Give me an excuse.','',5,0,0,0,0,0,5,0,1,0,0,0,26124),
(43534,'Warchief Mor\'ghor runs the show here. Don\'t forget it.','',274,0,0,0,0,0,274,0,1,0,0,0,26124),
(43535,'<The enforcer\'s eyes flash red.>$B$BI hope your pathetic Horde tries to attack us. I am itching to shed some blood, $c!','',25,0,0,0,0,0,25,0,1,0,0,0,26124),
(43536,'The fury! The power! I have never felt so strong in all my life.$B$BSoon, ALL the Dragonmaw will feel as I do.','',15,0,0,0,0,0,15,0,1,0,0,0,26124),
(43537,'Don\'t try anything funny, $c.$B$B<The enforcer tenses his fingers near the hilt of his blade, eager for you to make a scene.>','',25,0,0,0,0,0,25,0,1,0,0,0,26124),
(43538,'Warchief Mor\'ghor will make the Dragonmaw great again!$B$BWe have no need for your pathetic Horde.','',11,0,0,0,0,0,11,0,1,0,0,0,26124),
(43539,'CRUSH!','',0,0,0,0,0,0,0,0,1,10122,0,0,26124),
(43540,'KILL!','',0,0,0,0,0,0,0,0,1,10122,0,0,26124),
(43541,'DESTROY!','',0,0,0,0,0,0,0,0,1,10122,0,0,26124),
(43542,'What do we do now? Surely the Warchief would want us to storm the port in force!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(43543,'Perhaps. And perhaps we would win, but at what cost? Maybe $n has a better plan...','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(43544,'SMASH!','',0,0,0,0,0,0,0,0,1,10122,0,0,26124),
(43545,'POUND!','',0,0,0,0,0,0,0,0,1,10122,0,0,26124),
(43546,'ANNIHILATE!','',0,0,0,0,0,0,0,0,1,10122,0,0,26124),
(43547,'PULVERIZE!','',0,0,0,0,0,0,0,0,1,10122,0,0,26124),
(43548,'BREAK!','',0,0,0,0,0,0,0,0,1,10122,0,0,26124),
(43549,'Alright, let\'s try cracking this thing open!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43550,'Get ready everyone!  Here come de apes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43553,'Yes, my lord.','',0,0,0,0,0,0,16,0,1,0,19867,0,26124),
(43554,'Atramedes! Your master beckons.','',0,0,0,0,0,0,25,0,1,0,19864,0,26124),
(43555,'Witness the sheen of immeasurable power!','',0,0,0,0,0,0,465,0,1,0,0,0,26124),
(43556,'The excitement of the crowd, the thrill of the fight - you should have seen it!  Ever since those ogres took control of the Dire Maul arena, I\'ve been forced to camp out here.  Griniblix the Spectator - ha!  Spectator of what?  This campfire?  That shrub?  Or how about this odd purple tree?\n\nListen, if you\'re looking for a fight, Skarr was headed towards the Lariss Pavilion, and The Razza was soaring in the direction of the New Thalanaar.  Just be sure to let me in on the betting before the bloodbath begins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43557,'No no no! Leave Glop alone! My mushrooms! Mine!','',0,0,0,0,0,0,0,0,1,0,21769,0,26124),
(43558,'Mushrooms grow big and strong. Too big to stomp on! So strong they stomp back!','',0,0,0,0,0,0,0,0,1,0,21770,0,26124),
(43559,'Why you must come here? My cave. My cave! Me never hurt your cave!','',0,0,0,0,0,0,0,0,1,0,21771,0,26124),
(43560,'Stay back! Back!','',0,0,0,0,0,0,0,0,1,0,21772,0,26124),
(43561,'Real funny, Danforth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43562,'','This stone trogg is behind the growth in the Crimson Expanse.$B$BI sense a strange power in this place... be careful.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43563,'I\'m ready when you are, Norsala.','I\'m ready when you are, Norsala.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43564,'Yarr, and what be ye?  A bilge-lickin\' $r with some fancy $c pants and a mug like a $g sea giant: harpy;.  I\'d rather take a bite o\' Keelhaul\'s boot than take a weakling like yerself into the Bloodsails.$b$bCome back when ye got a little more wind in yer sails.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43565,'Yarr.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43566,'Yarr, thar be a traitor!  An ugly one at that!  Get out o\' me office, before I blow ye down to Pirate-town!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43567,'<Bossy is busy trying to figure out how to get back downstairs.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43568,'<Bossy looks at you with large, liquid black eyes.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43569,'<Bossy lowers her head nobly, almost as if she understands the gravity and the meaning of your request.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43570,'Bossy, I need to ask something great of you.  I need to cut off your head to prove my loyalty to the Bloodsail Buccaneers, so they will allow me to infiltrate their ranks and hopefully discover their true intentions.\n\nBooty Bay needs you, Bossy... now more than ever.\n\n','Bossy, I need to ask something great of you.  I need to cut off your head to prove my loyalty to the Bloodsail Buccaneers, so they will allow me to infiltrate their ranks and hopefully discover their true intentions.\n\nBooty Bay needs you, Bossy... now more than ever.\n\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43571,'Moo.','Moo.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43572,'<Do the deed.>','<Do the deed.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43573,'<Chicken out.>','<Chicken out.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43574,'%s breathes a heavy sigh of relief.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43575,'Care to purchase some piratey items?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43576,'I need an extra-large pirate hat.  Seahorn\'s orders.','I need an extra-large pirate hat.  Seahorn\'s orders.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43577,'Tell him this is the last one.  It breaks poor Narkk\'s heart to have to carve horn-holes in his beautiful hats!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43578,'What\'ve you got?','What\'ve you got?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43579,'Mean... rock fiends...','',0,0,0,0,0,0,0,0,1,0,21773,0,26124),
(43580,'','Let\'s finish with this quickly.',0,0,0,0,0,0,0,0,1,0,0,21030,26124),
(43581,'','You\'ve caused enough damage, Glop. The earth welcomes you no longer.',0,0,0,0,0,0,0,0,1,0,0,21031,26124),
(43582,'','After him, quickly!',0,0,0,0,0,0,0,0,1,0,0,21032,26124),
(43583,'','Slippery little stone trogg.',0,0,0,0,0,0,0,0,1,0,0,21033,26124),
(43584,'','You kiddin\' me...',0,0,0,0,0,0,0,0,1,0,0,21034,26124),
(43585,'','Good riddance.',0,0,0,0,0,0,1,0,1,0,0,21035,26124),
(43586,'Hey Baron, go long!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43587,'Welcome to Booty Bay, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43588,'That\'ll do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43589,'Here\'s the head and the hat, Fleet Master.','Here\'s the head and the hat, Fleet Master.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43590,'You\'re the boss.','You\'re the boss.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43591,'This looks good, but I think it\'ll look even better if we beat it up a little bit.  You know, to sell the illusion of a fight.  What do you think?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43592,'Danforth, report.','',0,0,0,0,0,0,0,0,1,10129,0,0,26124),
(43593,'The Blackrock orcs blew up the bridge leading to Stonewatch Keep. Frontal assault is out of the question.','',0,0,0,0,0,0,0,0,1,10129,0,0,26124),
(43594,'Krakauer?','',0,0,0,0,0,0,0,0,1,10129,0,0,26124),
(43595,'Two ways to get behind enemy lines, Johnny. Three if you count bein\' dead.','',0,0,0,0,0,0,1,0,1,10129,0,0,26124),
(43596,'North through Alther\'s Mill, but we\'d have to cut through an army of bloodthirsty worgs or south through Render\'s Valley.','',0,0,0,0,0,0,1,0,1,10129,0,0,26124),
(43597,'Jorgensen, what do you have on Render\'s Valley?','',0,0,0,0,0,0,0,0,1,10129,0,0,26124),
(43598,'Blackrocks all over the damned place, Johnny. One main tower at the choke and two smaller huts. It\'s a death trap.\n','',0,0,0,0,0,0,1,0,1,10129,0,0,26124),
(43599,'Death trap, eh? Messner, I got a plan. Gonna need some seaforium.','',0,0,0,0,0,0,0,0,1,10129,0,0,26124),
(43600,'Seaforium? Where the hell am I gonna get seaforium from, Johnny?','',0,0,0,0,0,0,1,0,1,10129,0,0,26124),
(43601,'Not my problem, Messner. Make it happen.','',0,0,0,0,0,0,0,0,1,10129,0,0,26124),
(43602,'$n, get your crap ready. I\'m sending you out into the field.','',0,0,0,0,0,0,0,0,1,10129,0,0,26124),
(43603,'Don\'t let stains sit for too long!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43604,'A stain is about to ruin the deck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43605,'You spot a stain on the deck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43606,'Two more stains appear!  Keep cleaning!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43607,'The stains are appearing more quickly now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43608,'The deck is ruined.  Pick up another mop and try again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43609,'My brothers are strong, but my brothers are passive.$B$BChange does not occur without movement, contention, and violence. Our enemies live this, whether they fully realize it or not. The passive nature of my brothers makes them weak and vulnerable to these new enemies.$B$BNot I. I have no fear of change. I will tear at the ground and move the mountains. I embrace change.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43610,'You have your mop, now look for stains to swab!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43611,'','Me remain to make sure the rest of their substance is destroyed.',0,0,0,0,0,0,1,0,1,0,0,21036,26124),
(43612,'Follow the trail of homeless to the Deadmines dungeon entrance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43613,'On your feet! Naga attack!','',0,0,0,0,0,0,0,0,1,0,21309,0,26124),
(43614,'We must hurry! Do something, shaman!','',0,0,0,0,0,0,0,0,1,0,21310,0,26124),
(43615,'That sub\'s gunna blow! We have to move, now!','',0,0,0,0,0,0,0,0,1,0,21311,0,26124),
(43616,'More naga... make ready!','',0,0,0,0,0,0,0,0,1,0,21312,0,26124),
(43617,'Thralls balls! I\'m sick of fighting naga!','',0,0,0,0,0,0,0,0,1,0,21313,0,26124),
(43618,'What the hell is that?','',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(43619,'I don\'t like this...','',0,0,0,0,0,0,274,1,1,0,0,0,26124),
(43620,'Is there someone here?','',0,0,0,0,0,0,6,1,1,0,0,0,26124),
(43621,'I smell something... Poop.','',0,0,0,0,0,0,273,1,1,0,0,0,26124),
(43622,'I\'m staying put. Go check it out!','',0,0,0,0,0,0,25,1,1,0,0,0,26124),
(43623,'%s casts stealth detection. Keep your distance!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(43624,'','A thief!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43625,'Yarr!  I pilfered those limes fair \'n\' square!','Yarr!  I pilfered those limes fair \'n\' square!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43626,'Arr!  Get back here, ye swill-swallowin\' swabbie!','Arr!  Get back here, ye swill-swallowin\' swabbie!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43627,'I was just gonna make some limeade fer me hearties!  I swear it!','I was just gonna make some limeade fer me hearties!  I swear it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43628,'Dead men steal no limes!','Dead men steal no limes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43629,'Belay yer lime-stealin\' ways, ye scurvy scallywag!','Belay yer lime-stealin\' ways, ye scurvy scallywag!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43630,'No, not me limes, says I!','No, not me limes, says I!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43631,'','Energy begins to arc across Onyxia\'s body as her electrical charge increases.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43632,'','The arcing bolts intensify as Onyxia\'s electrical charge reaches dangerous levels!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43633,'','Miniature bolts of lightning burn across Onyxia\'s skin. Her electrical charge is at critical levels!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43634,'I should get going back to the Crimson Veil.  See you there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43635,'Let\'s take these ninjas out, boss.  I already see some of \'em up ahead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43636,'What\'s that?','What\'s that?',0,0,0,0,0,0,397,1,1,0,1107,1107,26124),
(43637,'Did you hear that?','Did you hear that?',0,0,0,0,0,0,397,1,1,0,1107,1107,26124),
(43638,'We\'re free! RUN FOR YOUR LIVES!','We\'re free! RUN FOR YOUR LIVES!',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(43639,'We\'ve stirred up a hornet\'s nest, $n!$B$BI hope you have a plan for finishing this. Krogg\'s warriors are tearing up the dragonmaw, but we\'re taking heavy losses for every inch of ground...','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(43640,'I\'ll die someday, sea-witch...','',0,0,0,0,0,0,0,0,1,0,21315,0,26124),
(43641,'...but not today!','',0,0,0,0,0,0,0,0,1,0,21316,0,26124),
(43642,'Stay close! We are too few already!\n','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43643,'You were nearly lost! Do not wander off!\n','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43644,'Follow me! You stand no chance here alone!\n','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43645,'Your interference shall cosst you your life, $r!','',0,0,0,0,0,0,0,0,1,0,21978,0,26124),
(43646,'You have successfully planted the seaforium at the munitions hut.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43647,'You have successfully planted the seaforium at the Blackrock tower.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43648,'Your have no businesss here, $r!','',0,0,0,0,0,0,0,0,1,0,21979,0,26124),
(43649,'The beassst will find you tasssty, sssoftsskin!','',0,0,0,0,0,0,0,0,1,0,21980,0,26124),
(43650,'I am ready to escort a group of elementals across the open.','I am ready to escort a group of elementals across the open.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43651,'Be swift, $c. The stone dragons will not give up easily.','',0,0,0,0,0,0,1,0,1,0,21647,0,26124),
(43652,'Activate your Bravo Company Field Kit now.|TInterface\\Icons\\INV_MISC_ENGGIZMOS_20.BLP:16|t$BStealth your party using Camouflage.|TInterface\\Icons\\SPELL_NATURE_PROTECTIONFORMNATURE.BLP:16|t','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43653,'We\'re nearing Render\'s Valley. These orcs are tough! Make sure you are camo\'d!|TInterface\\Icons\\SPELL_NATURE_PROTECTIONFORMNATURE.BLP:16|t\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43654,'Create a distraction so that you and Jorgensen can slip by unnoticed.|TInterface\\Icons\\ABILITY_ROGUE_BLOODYEYE.BLP:16|t\n\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43655,'Sometimes you just need to take out one target. Use chloroform while behind the enemy!|TInterface\\Icons\\SPELL_NATURE_SLEEP.BLP:16|t\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43656,'Are you here to help the Dragonmaw reclaim our freedom?$B$BSpeak with Zaela - she\'s coordinating our resistance!','',1,0,0,0,0,0,274,0,1,0,0,0,26124),
(43657,'','Abandon the port? Has Mor\'ghor beaten all the sense out of you? This attack is our best opportunity to take our destiny into our own - wait! Here comes $n from the Horde!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(43658,'My heals really don\'t have the \'OOMPH\' that they used to, $n. You know what I\'m saying?','',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(43659,'Being a paladin is rough. The Light behaves so erratically. Some days I wake up and it feels like all of my powers have been weakened.','',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(43660,'Yarr, hold on tight, me hearty, fer thar be nary an oarsman so capable as I!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43661,'I don\'t know, maybe the grass really is greener on the other side. You know? Krakauer and Danforth really kick butt as warriors. Maybe I should drop this paladin thing and try out being a warrior.','',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(43662,'We be headin\' up t\' where the goblins say they found black gold.  That gold belongs t\' the Bloodsail!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43663,'Messner kills bad guys so fast. I wish I could kill as fast as him. WHY can\'t I shoot fireballs? What does the LIGHT have against fireballs?','',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(43664,'I\'ll steer, you handle Ol\' Blasty.  An\' don\'t tie yer skivvies in a knot... I\'ll slow down when we get closer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43665,'Here we are!  Fire at will!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43666,'Ready... open fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43667,'They be on either side of us!  Send \'em down to Neptulon\'s Locker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43668,'One time, Keeshan told me that he could take on five of me at once. Why am I so weak?','',0,0,0,0,0,0,6,7,1,0,0,0,26124),
(43669,'That gold is ours!  Open fire, says I!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43670,'Make sure we always have camouflage up. The orcs in Render\'s Valley will kill us both if we\'re spotted.','',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(43671,'Retreat, says I!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43672,'On t\' the next one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43673,'Belay your attacks!  We\'re movin\' on!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43674,'While camouflaged, we are harder to detect when we are BEHIND creatures.','',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(43675,'Ahoy!  I see more o\' those goblins over there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43676,'Sometimes a distraction can backfire and cause the orcs to become suspicious. In those instances the orcs will actively search for us. It\'s best to keep a good distance from any orc detecting stealth.','',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(43677,'Aye-aye, sir.  Heavin\' to and returnin\' back t\' shore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43678,'Once in a while we\'ll come up against a lone orc that stands between us and victory. Chloroform is often best used in those situations. Just remember to apply chloroform we have to be behind the enemy.','',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(43679,'Aye, what need ye?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43680,'Ahoy matey!  Hoist anchor, trim the mainsail, batton down the hatches and set to sea!  Today we scuttle the Venture Company\'s blasted contraptions and send \'em all to feed the fishes!  Now hop to, before I put the black spot on ye!','Ahoy matey!  Hoist anchor, trim the mainsail, batton down the hatches and set to sea!  Today we scuttle the Venture Company\'s blasted contraptions and send \'em all to feed the fishes!  Now hop to, before I put the black spot on ye!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43681,'I... I need a boat.','I... I need a boat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43682,'|cFF768EBDI\'ve got the seaforium charges ready. We need to get to the munitions hut and tower.|r|TInterface\\Icons\\INV_MISC_BOMB_04.BLP:24|t\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43683,'Perusing','Perusing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43684,'A barrel of grog.  Pirates love this stuff.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43685,'A barrel of grog.  Pirates love this stuff.$b$bThe cork does not seem to fit too tightly in the bunghole.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43686,'<Nudge the cork.>','<Nudge the cork.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43687,'The grog leaks out of the barrel.  A lot of pirates are going to be very unhappy about this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43688,'A barrel of gunpowder.  Highly explosive.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43689,'A barrel of gunpowder.  There is a pitcher of water sitting nearby.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43690,'<Pour the water onto the gunpowder.>','<Pour the water onto the gunpowder.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43691,'The gunpowder is completely soaked.  Nobody\'s going to be using this to fire cannons anytime soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43692,'An enormous crate, filled to the brim with cannonballs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43693,'An enormous crate, filled to the brim with cannonballs.  There is a can of cooking grease sitting innocently nearby.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43694,'<Grease the cannonballs.>','<Grease the cannonballs.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43695,'You pour grease all over the heavy metal projectiles.  Firallon\'s crew is certainly going to have a hard time loading these.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43696,'','Attack!',0,0,0,0,0,0,0,0,1,0,0,19687,26124),
(43697,'','Secure the rafters!',0,0,0,0,0,0,0,0,1,0,0,19688,26124),
(43698,'','I want two sharpshooters to stay behind and cover the deck.  Everyone else, use the ropes to rappel down.  Let\'s give them hell!',0,0,0,0,0,0,0,0,1,0,0,19689,26124),
(43699,'','We\'ve got the explosives  in the furnace room.  Just hold them off now!',0,0,0,0,0,0,0,0,1,0,0,19692,26124),
(43700,'Ahoy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43701,'Avast!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43702,'Arr!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43703,'Yarr!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43704,'Blow me down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43705,'Gangway!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43706,'You\'re a mutinous dog!  Draw steel!','You\'re a mutinous dog!  Draw steel!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43707,'I\'d never leave the Buccaneers, ye whale-tail skivvy-sniffer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43708,'Draw yer own steel, ye harpy-lovin\' scoundrel!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43709,'I\'d never turn sides, ye green-gilled murloc!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43710,'Mutiny?  I\'ll show ye mutiny, ye cockle-knuckled squiffy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43711,'I\'ll run ye through, ye cannon-kissin\' cannonface!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43712,'I\'ll send ye down to Neptulon\'s Locker, ye three-gallon pufferfish!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43713,'I\'ll send ye to feed the fishes, ye flat-shanty trogg!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43714,'I\'ll poke out yer deadlights, ye lily-livered eel!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43715,'DRAGONMAW!!','DRAGONMAW!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43716,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43717,'Victory for the Dragonmaw!','Victory for the Dragonmaw!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43718,'Just a bunch of meaningless scribbles.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43719,'These plans list the details on the upcoming attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43720,'Peak, I\'m ready to escort the catapult.','Peak, I\'m ready to escort the catapult.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43721,'It is the day of reckoning, $c!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(43722,'Have you come to help overthrow Mor\'ghor?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(43723,'Zaela told us the Horde would help! What can I do?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(43724,'Don\'t give me any armor. Just gimmie a blade and tell me who to kill.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(43725,'The Horde has come! It\'s about time we got some real leadership around here.','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(43726,'I\'ll fight by your side, $c. You won\'t regret helping us!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(43727,'Fight with me! Take up this blade and be a warrior.','Fight with me! Take up this blade and be a warrior.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43728,'Looks like I picked the wrong day to stop killin\' fel orcs.','Looks like I picked the wrong day to stop killin\' fel orcs.',11,0,0,0,0,0,274,0,1,0,0,0,26124),
(43729,'It\'s a day of reckoning, $c!','It\'s a day of reckoning, $c!',5,0,0,0,0,0,274,0,1,0,0,0,26124),
(43730,'Put me in, coach! I\'m ready to fight!','Put me in, coach! I\'m ready to fight!',5,0,0,0,0,0,274,0,1,0,0,0,26124),
(43731,'Today Mor\'ghor\'s tyranny will end.','Today Mor\'ghor\'s tyranny will end.',1,0,0,0,0,0,274,0,1,0,0,0,26124),
(43732,'This is it, $c! The revolution has come.','This is it, $c! The revolution has come.',1,0,0,0,0,0,274,0,1,0,0,0,26124),
(43733,'$c! Zaela said the Horde would provide us with weapons. What do you have?','$c! Zaela said the Horde would provide us with weapons. What do you have?',6,0,0,0,0,0,274,0,1,0,0,0,26124),
(43734,'Ahoy there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43735,'Long John Copper, is the Brashtide Crew ready for battle?','Long John Copper, is the Brashtide Crew ready for battle?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43736,'Yes, $g sir: ma\'am;!  We\'ve been biding our time in Gilneas for far too long.  We\'re ready for blood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43737,'What\'re y\' looking at, $r?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43739,'What can you tell me about the Brashtide Crew?','What can you tell me about the Brashtide Crew?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43740,'We used to roam the seas... \'til that damned King Greymane shut down the harbors in Gilneas!  If it weren\'t for him, we wouldn\'t be...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43741,'','Can I help you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43742,'You know the battle plan, right?','You know the battle plan, right?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43743,'','Yes, $g sir: ma\'am;.  We attack from the north at your signal.  The Brashtide will wash over Booty Bay!  Aroooo!!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43744,'Support and heal me! Take up this warhammer and be a shaman.','Support and heal me! Take up this warhammer and be a shaman.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43745,'My spouse has gone missing! Please help!','My spouse has gone missing! Please help!',0,0,0,0,0,0,5,7,1,10212,0,0,26124),
(43746,'Townspeople are disappearing, Solomon. What are you going to do about it?','Townspeople are disappearing, Solomon. What are you going to do about it?',0,0,0,0,0,0,6,7,1,10212,0,0,26124),
(43747,'It\'s time to wake up, magistrate! These aren\'t ordinary gnoll attacks!','It\'s time to wake up, magistrate! These aren\'t ordinary gnoll attacks!',0,0,0,0,0,0,25,7,1,10212,0,0,26124),
(43748,'Where is the help that we requested from Stormwind?','Where is the help that we requested from Stormwind?',0,0,0,0,0,0,6,7,1,10212,0,0,26124),
(43749,'What are we paying our taxes for if your guards can\'t even keep gnolls out?','What are we paying our taxes for if your guards can\'t even keep gnolls out?',0,0,0,0,0,0,1,7,1,10212,0,0,26124),
(43750,'My children were kidnapped while they slept! I WANT ANSWERS, SOLOMON!','My children were kidnapped while they slept! I WANT ANSWERS, SOLOMON!',0,0,0,0,0,0,5,7,1,10212,0,0,26124),
(43751,'You better do something quick or you\'ll have a riot on your hands, Solomon!','You better do something quick or you\'ll have a riot on your hands, Solomon!',0,0,0,0,0,0,5,7,1,10212,0,0,26124),
(43752,'The gnolls have never been this aggressive. What\'s going on, Solomon? Tell us!','The gnolls have never been this aggressive. What\'s going on, Solomon? Tell us!',0,0,0,0,0,0,1,7,1,10212,0,0,26124),
(43753,'How long must we stand here before our pleas are heard?','How long must we stand here before our pleas are heard?',0,0,0,0,0,0,6,7,1,10212,0,0,26124),
(43754,'Get this damned line moving!','Get this damned line moving!',0,0,0,0,0,0,15,7,1,10212,0,0,26124),
(43755,'You\'re good for nothing, Solomon!','You\'re good for nothing, Solomon!',0,0,0,0,0,0,14,7,1,10212,0,0,26124),
(43756,'You can forget about re-election, magistrate!','You can forget about re-election, magistrate!',0,0,0,0,0,0,274,7,1,10212,0,0,26124),
(43757,'No justice, no peace!','No justice, no peace!',0,0,0,0,0,0,15,7,1,10212,0,0,26124),
(43758,'If you don\'t do something about these gnolls, we will!','If you don\'t do something about these gnolls, we will!',0,0,0,0,0,0,25,7,1,10212,0,0,26124),
(43759,'Please help me! I\'m the last member of my family left. Everyone else has been kidnapped!','Please help me! I\'m the last member of my family left. Everyone else has been kidnapped!',0,0,0,0,0,0,20,7,1,10212,0,0,26124),
(43760,'Forget you, Solomon. I\'ll find my family by myself.','Forget you, Solomon. I\'ll find my family by myself.',0,0,0,0,0,0,14,7,1,10212,0,0,26124),
(43761,'This pathetic revolution ends here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43762,'DEBUG Event Sent - Mode to Daily Quest (IDLE_GAME_EVENT)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43763,'DEBUG Event Sent - Mode to Game Startup (POPULATING_GAME_EVENT)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43764,'DEBUG Event Sent - Mode to Game Active (ACTIVE_GAME_EVENT)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43765,'DEBUG Event Sent - Mode to Game Finish (CONCLUDED_GAME_EVENT)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43766,'DEBUG Event Sent - Number Players Changed (NUM_CHANGED_EVENT)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43767,'DEBUG Event Sent - Reduce Game Timer (REDUCE_TIME_EVENT)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43768,'DEBUG Event Sent - Attackers Win (ATTACKERS_WIN_EVENT)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43769,'DEBUG Event Sent - Defenders Win (DEFENDERS_WIN_EVENT)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43770,'DEBUG Event Sent - Control Victory Achieved (END_EARLY_EVENT)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43771,'<Baron Revilgaz\'s private stock.  Do not touch under any circumstances!>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43772,'Ask yourself, $n: is this good for the Venture Company?','Ask yourself, $n: is this good for the Venture Company?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43773,'I tink ya be even more like ya father den ya thought, even witout da demon blood.','',0,0,0,0,0,0,1,0,1,9224,20099,0,26124),
(43774,'But dese be worries for older minds.  Ya still have much to learn.  Go help tha people of tha Darkspear.  I am sure we\'ll be speakin\' again real soon.','',0,0,0,0,0,0,1,0,1,9224,20107,0,26124),
(43775,'I did not make this decision lightly, Vol\'jin. I know our alliances will suffer for it. I know the Horde will be irreversibly changed. But I made this choice with confidence that Garrosh is exactly what the Horde needs.','',0,0,0,0,0,0,1,0,1,9223,20138,0,26124),
(43776,'I\'m trusting you and the other leaders to not let this divide our people. You are stronger than that.','',0,0,0,0,0,0,1,0,1,9223,20139,0,26124),
(43777,'Still, I be hopin\' Thrall will return to us one day. Tha future right now be lookin\' very grim... and very bloody.','',0,0,0,0,0,0,1,0,1,9223,20117,0,26124),
(43778,'Go now. Make tha Darkspear proud. Dere are many wars ahead of us, an\' I\'m sure ya be havin\' a part to play in all of dem.','',0,0,0,0,0,0,1,0,1,9223,20118,0,26124),
(43779,'AAAAAAAHHHHHHHHHHHHHHHHH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43780,'AAAAAAAAAAAHH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43781,'HEEEEEELLLLLLLP!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43782,'OH MY GOD, THEY\'RE HERE! AHHHHHHHH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43783,'PIRATES!  AAAAAHHHHH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43784,'Johnny, you do realize that we just blew up half of Redridge, right?','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43785,'NOW IS THE TIME TO PANIC, EVERYBODY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43786,'Redridge\'ll heal, but them orcs sure won\'t...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(43787,'I\'M SCARED!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43788,'Batton down the hatches, mateys!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43789,'Blow the lily-livered scalawags out of the water!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43790,'Brashtide and Bloodsail be damned!  The Blackwater Raiders hold Booty Bay!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43791,'Put out those fires!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43792,'Hold yer positions, men!  We can outlast \'em!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43793,'Scuttle \'em all, says I!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43794,'Firallon, come out and fight like a goblin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43795,'Ye walk on the Baron\'s land now, ye scurvy worgen scum!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43796,'So...tired...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43797,'You dealt the most damage during this battle ground!','You dealt the most damage during this battle ground!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43798,'You healed the most damage during this battle!','You healed the most damage during this battle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43799,'You slew the most foes during this battle!','You slew the most foes during this battle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43800,'The pathway to damnation awaits...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43801,'You realize not the error of your ways, but soon you will cower before Darkblaze.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43802,'Mount me on the vehicle.','Mount me on the vehicle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43803,'Pokey find a fish!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43804,'GAME OVER, MAN!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43805,'The elements demand vengeance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43806,'MINION, to my aid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43807,'Heads up! PAYLOAD INCOMING!','',0,0,0,0,0,0,0,0,1,10170,0,0,26124),
(43808,'Where the hell did this come from?','',0,0,0,0,0,0,0,0,1,10170,0,0,26124),
(43809,'Troteman.','',0,0,0,0,0,0,0,0,1,10170,0,0,26124),
(43810,'Troteman?','',0,0,0,0,0,0,0,0,1,10170,0,0,26124),
(43811,'At your service.','',0,0,0,0,0,0,0,0,1,10170,0,0,26124),
(43812,'Bitsy help. Buy meat, rest in tent.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43813,'Time to go!','',0,0,0,0,0,0,0,0,1,10183,0,0,26124),
(43814,'Hop on a hippogryph, now\'s our chance!','',0,0,0,0,0,0,0,0,1,10183,0,0,26124),
(43815,'We must wait for the right time to strike!','',0,0,0,0,0,0,0,0,1,10184,0,0,26124),
(43816,'We must bide our time.  They won\'t know what hit them.','',0,0,0,0,0,0,0,0,1,10184,0,0,26124),
(43817,'','Hands up, greenskins!  My men will give you your new bearing.  You try anything funny and we\'ll fill you with lead.',0,0,0,0,0,0,0,0,1,0,0,19690,26124),
(43818,'','The rest of you, follow me downstairs!',0,0,0,0,0,0,0,0,1,0,0,19691,26124),
(43819,'You sure picked an interesting time to chat with Ol\' Kebok.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43820,'Sorry, not here to chat.  I need a wind rider to take on a special mission.','Sorry, not here to chat.  I need a wind rider to take on a special mission.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43821,'[Orcish] Dabu?','',0,0,0,0,0,0,0,0,1,0,6194,0,26124),
(43822,'AAHHHHHHHHH!!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43823,'AAHHHHHHHHHHHHHHHHHH!!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43824,'AAAAAAAAAAAHHHHHHHHHHHHH!!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43825,'BLOOD AND THUNDER, RIGHT!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43826,'I CAN\'T FIND YOUR LEGS, JOEY! I CAN\'T FIND YOUR DAMNED LEGS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43827,'AAAHHHH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43828,'RUN TO YOUR DARK GODS, YOU FILTHY ANIMALS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43829,'THERE ARE NO FRIENDLY CIVILIANS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43830,'Who are you? What is this place?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43831,'What shall the Light teach you?','What shall the Light teach you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43832,'The Light protect you, $c.','The Light protect you, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43833,'The light of the Sun illuminates the path to wisdom.  Where shall we walk today, friend?','The light of the Sun illuminates the path to wisdom.  Where shall we walk today, friend?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43834,'May the Sun\'s light protect you, $c.','May the Sun\'s light protect you, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43835,'Now to destroy this foul substance...','',0,0,0,0,0,0,1,0,1,0,21874,0,26124),
(43836,'Arrghhhhh!','',0,0,0,0,0,0,34,0,1,0,21875,0,26124),
(43837,'We\'ll set flight once everyone is ready.','',0,0,0,0,0,0,0,0,1,10184,0,0,26124),
(43838,'Patience, friends.  We will strike soon.','',0,0,0,0,0,0,0,0,1,10184,0,0,26124),
(43839,'Hold your horses, friend.  We\'ll hit them when we\'re all ready.','',0,0,0,0,0,0,0,0,1,10184,0,0,26124),
(43840,'Let\'s give everyone time to gather.  We\'ll need a handful of people to come with us.','',0,0,0,0,0,0,0,0,1,10184,0,0,26124),
(43841,'The Scoured Reach lies to the west.','',0,0,0,0,0,0,1,0,1,0,21754,0,26124),
(43842,'Not wasted, Stonemother.  It has been very useful.','',0,0,0,0,0,0,1,0,1,0,21757,0,26124),
(43843,'It stands to reason that it may be here for exactly the reasons it says it is.','',0,0,0,0,0,0,1,0,1,0,21758,0,26124),
(43844,'You still have much to prove.  But you brought the stone.  That is an excellent start.','',0,0,0,0,0,0,1,0,1,0,21759,0,26124),
(43845,'Place the stone upon the ground before me.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43846,'The other Stone Lords have already heard my words.','',0,0,0,0,0,0,1,0,1,0,21760,0,26124),
(43847,'Take this signet as a testament of my good will.  I pray that my trust is not misplaced.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43848,'','Is this the one you are wasting your time with, Diamant?',0,0,0,0,0,0,1,0,1,0,0,21087,26124),
(43849,'','Then you take responsibility for its actions, Stone Lord.  You will be the one answering to me when it shows its true intent.',0,0,0,0,0,0,1,0,1,0,0,21088,26124),
(43850,'','And you fleshling, consider for a moment that you are entirely surrounded by rock in this place.  The very earth you walk on bends to my will.',0,0,0,0,0,0,1,0,1,0,0,21089,26124),
(43851,'','If you betray us, there will be no escape for you.  I will crush your body so slowly that you shall hear every single one of your bones break.',0,0,0,0,0,0,1,0,1,0,0,21090,26124),
(43852,'','I\'m glad we had this talk.',0,0,0,0,0,0,1,0,1,0,0,21091,26124),
(43853,'You\'ve come to prove yourself, fleshling?  The Crumbling Depths lie northeast.  The stone you seek is within.','',0,0,0,0,0,0,1,0,1,0,21767,0,26124),
(43854,'Strike the crystals when you are ready and we shall face the Broodmother together.','',0,0,0,0,0,0,0,0,1,0,21648,0,26124),
(43855,'You\'ve strayed too far from the Stonemother\'s gaze, dragon.  It is time that you be put in your place.','',0,0,0,0,0,0,1,0,1,0,21649,0,26124),
(43856,'She submits.  Well done, fleshling.','',0,0,0,0,0,0,1,0,1,0,21650,0,26124),
(43857,'','You stand here trying to convince me that these beings of flesh should be trusted.',0,0,0,0,0,0,1,0,1,10401,0,21103,26124),
(43858,'','They are the literal incarnation of corruption.  Their very skin screams it.',0,0,0,0,0,0,1,0,1,10401,0,21104,26124),
(43859,'','They seek only power, as the Twilight do.  Yet you are confident that they will not turn on us.  Did I raise you to be fools?',0,0,0,0,0,0,1,0,1,10401,0,21105,26124),
(43860,'','They slaughtered stone troggs, Gorik?  This is supposed to sway me?  It is not much of a feat.',0,0,0,0,0,0,1,0,1,10401,0,21106,26124),
(43861,'','What of you Boden?  What do you see in this \"champion?\"',0,0,0,0,0,0,1,0,1,10401,0,21107,26124),
(43862,'','That very well may be.  Even fools have uses though.  I keep you around after all.',0,0,0,0,0,0,1,0,1,10401,0,21108,26124),
(43863,'I have no love for the intruders, Stonemother, but these fleshlings went well out of their way to cleanse the filth from the Crimson Expanse. ','',0,0,0,0,0,0,1,0,1,10401,21879,0,26124),
(43864,'They are not the Twilight.  I see no reason to oppose their goals.','',0,0,0,0,0,0,1,0,1,10401,21880,0,26124),
(43865,'I\'ve not spoken with the strangers, but I bore witness to their champion treading deep into the Crumbling Depths and returning unscathed.  It is clearly capable.','',0,0,0,0,0,0,1,0,1,10401,21768,0,26124),
(43866,'This champion also faced the Stone Dragons and their Broodmother with no glimpse of fear or hesitation.  I\'ve seen the most hardy of giants falter where the fleshling did not.','',0,0,0,0,0,0,0,0,1,10401,21653,0,26124),
(43867,'You know where I stand, Stonemother.','',0,0,0,0,0,0,0,0,1,10401,21764,0,26124),
(43868,'It\'s not bravery that drives it.  It strode before me like it thought this place its home. It is a fool.  It will surely get itself killed soon enough.','',0,0,0,0,0,0,0,0,1,10401,21749,0,26124),
(43869,'','And so the \"champion\" arrives.',0,0,0,0,0,0,1,0,1,10382,0,21093,26124),
(43870,'','So small.  So soft.  It\'s a wonder you\'ve even lasted this long down here, fleshling.',0,0,0,0,0,0,1,0,1,10382,0,21094,26124),
(43871,'','Or perhaps a testament to your abilities?',0,0,0,0,0,0,1,0,1,10382,0,21095,26124),
(43872,'','All of this for a piece of the World Pillar?  What exactly, shaman, do you intend to do with it?',0,0,0,0,0,0,1,0,1,10382,0,21096,26124),
(43873,'','And what then? Will you leave Deepholm to its denizens?',0,0,0,0,0,0,1,0,1,10382,0,21097,26124),
(43874,'','I\'m glad you\'re at least that perceptive.',0,0,0,0,0,0,1,0,1,10382,0,21098,26124),
(43875,'','I propose this: We will march on the Twilight cult and extinguish any utterings of Deathwing\'s name from this realm.  Your Earthen Ring will march with us.',0,0,0,0,0,0,1,0,1,10382,0,21099,26124),
(43876,'','You do this, and I will send Gorsik to the temple with our piece of the World Pillar.',0,0,0,0,0,0,1,0,1,10382,0,21100,26124),
(43877,'','Seal the rift and leave this place.',0,0,0,0,0,0,1,0,1,10382,0,21101,26124),
(43878,'','Save your thanks.  We march upon the Twilight Precipice as soon as our forces are gathered. I expect to see you on the battlefield.',0,0,0,0,0,0,1,0,1,10382,0,21102,26124),
(43879,'We came here to seal da rift Deathwing tore into Azeroth. We need the World Pillar to repair da hole on dis side.','',0,0,0,0,0,0,1,0,1,0,21117,0,26124),
(43880,'We\'ll leave. We\'ve no desire to stay where we\'re not welcome.','',0,0,0,0,0,0,1,0,1,0,21118,0,26124),
(43881,'We\'ll be doin\' exactly that then. Ya have our tanks, Stonemother.','',0,0,0,0,0,0,1,0,1,0,21119,0,26124),
(43882,'','The earth has come to claim you, cult!',0,0,0,0,0,0,1,0,1,0,0,21080,26124),
(43886,'','Your trespass shall see no forgiveness.  Deathwing is no longer here to coddle you.',0,0,0,0,0,0,1,0,1,0,0,21081,26124),
(43887,'','Cower as the very ground reaches up to swallow you!',0,0,0,0,0,0,1,0,1,0,0,21082,26124),
(43888,'','Well done, $r.  Return to the temple, Gorsik shall meet you there, as promised.',0,0,0,0,0,0,1,0,1,0,0,21083,26124),
(43889,'Welcome to Deepholm, cultist.','',0,0,0,0,0,0,1,0,1,0,21745,0,26124),
(43891,'What about you, cultist?  Do you know how to fly?','',0,0,0,0,0,0,1,0,1,0,21746,0,26124),
(43892,'Do you find me imposing?  Be honest.  I\'m going for imposing.','',0,0,0,0,0,0,1,0,1,0,21747,0,26124),
(43893,'Run all you want whelps.','',0,0,0,0,0,0,1,0,1,0,21876,0,26124),
(43894,'You built your dwellings upon our very rockface.  Your ignorance shall be your undoing.','',0,0,0,0,0,0,1,0,1,0,21877,0,26124),
(43895,'Soon you shall be nothing more than a stain to clean off of my foot.','',0,0,0,0,0,0,1,0,1,0,21878,0,26124),
(43896,'Look at this one... standing bravely with earth beneath his feet, thinking to challenge me.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43897,'You\'ve some sting in you, human.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43898,'You make a very tenacious corpse.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43899,'Quite brave for one so small and fragile.','',0,0,0,0,0,0,1,0,1,0,21651,0,26124),
(43900,'The Stone Dragons are here, fleshling.  Take wing!','',0,0,0,0,0,0,1,0,1,0,21652,0,26124),
(43901,'Deathwing will have his way with your Stonemother.','',0,0,0,0,0,0,0,0,1,0,21511,0,26124),
(43902,'Twilight shall fall upon you, even in this deep, dark hole.','',0,0,0,0,0,0,0,0,1,0,21516,0,26124),
(43903,'Agh...','',0,0,0,0,0,0,0,0,1,0,21517,0,26124),
(43904,'You\'re in ova ya head, bud.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43905,'Ya handle yaself on da ground.  How about in da skies?','',0,0,0,0,0,0,0,0,1,0,21615,0,26124),
(43906,'Ya need ta be more swift den that!','',0,0,0,0,0,0,0,0,1,0,21616,0,26124),
(43907,'Stay on dem, beasts!  Rip dem from the air!','',0,0,0,0,0,0,0,0,1,0,21617,0,26124),
(43908,'Me tink I\'ve had my fill of ya, mon.','',0,0,0,0,0,0,0,0,1,0,21618,0,26124),
(43909,'No! Noooo...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43910,'','Therazane\'s finally gathered the nerve to challenge us, has she?',0,0,0,0,0,0,0,0,1,0,0,20933,26124),
(43911,'','Come closer, love.  I have a point to make.',0,0,0,0,0,0,0,0,1,0,0,20934,26124),
(43912,'','You do realize there\'s no hope, don\'t you?  Deathwing has already risen.  Your world is doomed.',0,0,0,0,0,0,0,0,1,0,0,20935,26124),
(43913,'','Stay close, gorgeous.  I\'m worth chasing.',0,0,0,0,0,0,0,0,1,0,0,20936,26124),
(43914,'','I\'m not that easy, hon.  Perhaps another time.',0,0,0,0,0,0,0,0,1,0,0,20937,26124),
(43915,'[Broken Common] Death here for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43916,'Your corpses will feed the Blackrock war machine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43917,'Forgive me, master... I have failed you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43918,'Killin\'s as easy as breathin\'.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43919,'Best wishes from the Bravo Company.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43920,'He won\'t be gettin\' up from that one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43921,'AHHHHHHHHHH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43922,'AAAAAAHHHHHHHHHHHHHHH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43923,'The final piece of the World Pillar has been recovered!  We have only to bind it together to prevent this realm from collapsing into Azeroth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43924,'Gather, brothers and sisters!  Let us fulfill our duties and return to Thrall victorious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43925,'You\'ve proven more than capable of defeating any enemy.  I would be honored if you stand guard through the ritual, young hero.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43926,'Twilight assassins are upon us!  Do not let them interrupt the ritual!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43927,'Nooo!  Lorvarius...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43928,'They are... subsiding.  Renew your efforts, brothers!  We must complete the ritual before they can return!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43929,'I have... failed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43930,'Keep dese assassins off of me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43931,'Dey\'ve returned!  To arms!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43932,'Stop her!  We can still complete da binding!','',0,0,0,0,0,0,0,0,1,0,21115,0,26124),
(43933,'Thank da elements...','',0,0,0,0,0,0,0,0,1,0,21116,0,26124),
(43934,'It is done!  We are finished.','',0,0,0,0,0,0,1,0,1,10343,21113,0,26124),
(43935,'With the pillar restored, dis realm is safe.  We must now attend to the wound on the surface.','',0,0,0,0,0,0,1,0,1,10343,21114,0,26124),
(43937,'I\'m gravely wounded... I cannot hold...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43938,'','Your tale ends here, shaman. ',0,0,0,0,0,0,0,0,1,0,0,20938,26124),
(43939,'','Deathwing shall bring destruction upon your entire order.  And this day, I shall be his blade!',0,0,0,0,0,0,0,0,1,0,0,20939,26124),
(43940,'','Hah...',0,0,0,0,0,0,0,0,1,0,0,20940,26124),
(43941,'','You should have taken the hint when we destroyed your precipice, cultist.',0,0,0,0,0,0,1,0,1,0,0,21084,26124),
(43942,'','Ma\'haat, slaughter these rabble.  I will deal with the fool priestess.',0,0,0,0,0,0,1,0,1,0,0,21085,26124),
(43943,'','Returning has ensured your death.',0,0,0,0,0,0,1,0,1,0,0,21086,26124),
(43944,'','Da ritual is almost complete!',0,0,0,0,0,0,0,0,1,0,0,21037,26124),
(43945,'','Thank you, Stonemother.  It was an honor to have...',0,0,0,0,0,0,0,0,1,0,0,21038,26124),
(43946,'','You\'ve proven true to your word, Earthmender.  For that, we will spare you our wrath.  ',0,0,0,0,0,0,1,0,1,0,0,21078,26124),
(43947,'','Once your wounded are gathered, you can thank me by leaving.',0,0,0,0,0,0,1,0,1,0,0,21079,26124),
(43948,'','$n, get into the Ultimate Footbomb Uniform behind you and get down to the docks. Help Thrall kick the Trade Prince\'s butt!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43949,'Always nice to get a gift hand delivered by the second-in-command. I\'ll unwrap this right now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43950,'OUCH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43951,'All cannons!  Open fire on the Crimson Veil!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43952,'Okay, okay! I got the message!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43953,'Traitor!  I\'ll die before I surrender me ship to you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43954,'','Haha! That should be a blast!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43955,'Look out! Here they come!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(43956,'$n, I\'m going to need your help!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(43957,'Damn, stone troggs! Over there!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(43958,'Stone troggs incoming!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(43959,'Firing at will!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(43960,'Now who\'s going to get pummelled?!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(43961,'You took my king, I take your miserable life!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(43962,'Here they come! Protect the catapult at all costs!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(43963,'My ring... Who holds my family ring... Tilloa, is that you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43964,'Tobias...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43965,'It\'s all true, brother. Every word. You doubted it?','',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(43966,'Brother!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43967,'Tell me it\'s not true, brother. Tell me you didn\'t die a murderer!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(43968,'You know why!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(43969,'Alright, let\'s get going.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(43970,'We need to keep moving!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43971,'Let\'s head out. Just keep those stone troggs off of us.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43972,'The faster we can get to the other side of the front, the faster we can reduce Needlerock Slag to rubble.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43973,'But why?! How could you?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(43974,'Moving out!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(43975,'How\'d that feel, you stone trogg scum?!','',0,0,0,0,0,0,14,0,1,0,0,0,26124),
(43976,'Oh yeah! Tremble at the might of our catapults!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(43977,'You stone troggs have no idea of what\'s coming!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43978,'Surely you\'ve felt anger. Anger so foul and vicious that it makes you want to tear someone to shreds...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(43979,'Aren\'t you feeling it right now?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(43980,'No... NO! STOP IT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43981,'You see, brother... we\'re not so different...','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(43982,'No...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43983,'I don\'t care how low the success rate here is. If we save even one worgen from the madness and savagery of the woods, our struggles are not in vain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43984,'','The dead cry for solace. Their anguish echoes on the wind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43985,'Guards, leave us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43986,'I must admit, we did not bring you here for introductions and pleasantries.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43987,'I will get straight to the point.  We have something to ask of you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43988,'We have a traitor within our walls.  Someone who is well connected.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43989,'','One of our best sentinels was on his trail - we assume it\'s a \"he\" - but it appears that she was discovered.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43990,'','She was found by our patrols this morning.  Murdered within our own city.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43991,'','It is difficult to know who to trust.  You are new here... relatively unknown.  That works in your favor in this case.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43992,'We need your help hunting this traitor down.  Are you willing?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43993,'','One more thing.  We\'ve arranged for one of our own to accompany you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43994,'','This is Lillorilen.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43995,'','Call me Lilly, please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43996,'','The sentinel I told you about was Lilly\'s sister.  She can be trusted.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43997,'','We\'ll track this traitor down, priestess.  You\'ve no reason to worry.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43998,'','I trust that you will, but please, be careful.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(43999,'','...it looks like there was barely a struggle at all.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44000,'','That\'s so unlike her.  She would have fought tooth and nail if she knew the danger.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44001,'','Do you think he took her that unaware?  Even though she thought she had his trail?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44002,'','Keep a sharp eye out.  There must be a clue here somewhere that can help us track him down.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44003,'','Have you found something?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44004,'','A mud-stained leaf...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44005,'','%s sniffs at the leaf briefly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44006,'','Verdantleaf!  This is quite fortunate.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44007,'','This only grows in a single area in Darnassus. Perhaps our killer dragged it here on his boot.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44008,'','The building we\'re looking for is on the Craftsman\'s Terrace.  Let\'s go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44009,'','Velora was several years my elder.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44010,'','We\'d been having a rough spot these past months.  Everyone has I guess.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44011,'','Have you ever had that feeling when you just can\'t remember something, but you know it\'s important?  It\'s been like that for all of us since Malfurion came back.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44012,'','I get flashes sometimes of these horrific images.  Shadows assaulting us in the night.  Friends turning and attacking each other.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44013,'','It\'s hard to put into words.  Things should be wonderful.  Malfurion\'s returned.  Teldrassil was finally blessed by the dragon aspects... some of them anyway.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44014,'','But I guess I just feel... I feel a little piece of my life is missing.  Faded.  Like waking from a dream.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44015,'','It\'s a strain, but I shouldn\'t have let it affect me.  I... I should have been better to my sister.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44016,'','Enough of my regrets.  This is the building.  Let\'s check it out.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44017,'','These rooms are normally offered to guests of the city.  Really, anyone could have been staying here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44018,'','This is a map of Darkshore.  There are paths drawn from Auberdine towards Lor\'danel... and towards several other safe-havens as well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44019,'','Some kind of attack plan?  Auberdine was ravaged during the first throes of the cataclysm.  What value could it have to anyone?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44020,'','These could be escape routes I suppose.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44021,'','The route across the beach is circled.  Let\'s get there and see if there\'s anything to find.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44022,'','I\'m going to stop by  to inform Tyrande and Malfurion of our progress.  I\'ll meet you at the beach as soon as I can.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44023,'','You better head straight there, but be cautious.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44024,'','By Elune!  They were all ambushed... betrayed...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44025,'','The traitor helped planned this!  He helped to massacre them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44026,'','He was wounded.  I think I can pick up the trail.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44027,'','This way!  Stay with me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44028,'','There\'s a set of fresh tracks following the forest\'s edge back towards town.  It\'s hard to tell if they\'re his though.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44029,'','Here!  A blood stain.  We\'re going the right way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44030,'','Right by our guards?  Confident scum...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44031,'','Sentinel!  Did you see a wounded night elf pass by this way?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44032,'','Yes.  Towards the falls.  I tried to convince him to get his wounds treated, but he just ignored me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44033,'','Come, friend.  Quickly!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44034,'','There!  Who is that he\'s meeting with?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44035,'','Let\'s move!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44036,'','...where did they go?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44037,'','There\'s no way they could have escaped by land.  Did they...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44038,'','I hope you know how to swim, worgen.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44039,'','Glad you made it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44040,'','They\'re just up ahead.  The sound of the water should cover our approach.  Let me know when you\'re ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44041,'','Let\'s finish this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44042,'','I\'ll take the cultist.  You handle the traitor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44043,'','Do NOT let him go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44044,'','Stop.  Let me finish him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44045,'','No, Lilly.  Do not kill him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44046,'','But... I... yes, my lady.  As you wish.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44047,'Why, Denatharion?  I knew you when you were a boy.  You had hope in your heart.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44048,'Hope?  Like the hope Fandral had for bringing our people  back to glory?  Back to immortality?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44049,'In your jealousy, you condemn him and dispatch him to your secret prison.  Just as eagerly as you did your own brother.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44050,'If I cannot find a home amongst my own people, where else am I to turn, \"Shand\'do?\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44051,'%s turns away, clearly disturbed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44052,'','Lilly, please take the prisoner back to the sentinels so that we can deal with him properly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44053,'','Of course, my Lady.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44054,'','And you, my dear worgen, you\'ve done a great thing for us this day.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44055,'','Malfurion may not say it aloud, but he was greatly concerned for the coming of your people.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44056,'','He knows well of your curse and of the terrible things that can come of it.  He may even hold himself to blame for it to some degree.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44057,'','I think that today, you may have settled some of his worries.  You show nobility and control.  Perhaps more than he thought possible.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44058,'','Thank you.  Truly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44059,'','Let me know when you are ready to depart this place.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44060,'','It is good to see you again, friend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44061,'Bring that back up to Yancey, by the waterfall.  The ignorant human\'ll have no idea that it\'s not me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44062,'Pathetic worms. Prepare to face the Mor\'ghor Slam!','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(44063,'','This is Gregory.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44064,'At your service. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44065,'','Gregory is one of our new allies from Gilneas.  It is easy to assume that he cannot be involved in this, so we\'ve decided to trust him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44066,'We will track this traitor down, my lady.  You\'ve no reason to worry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44067,'...it looks like there was barely a struggle at all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44068,'Would a sentinel have truly fallen so easy?  I thought these were fierce warriors.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44069,'Perhaps he took her unaware.  Perhaps he is that well trusted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44070,'Keep a sharp eye out.  There must be a clue here somewhere that can help us track him down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44071,'Have you found something?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44072,'A mud-stained leaf...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44073,'%s sniffs at the leaf briefly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44074,'A very distinct scent.  There doesn\'t appear to be anything like it in the direct area.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44075,'I should be able to pick up the trail with this.  Let\'s hope it was the killer that dragged it here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44076,'The trail leads to the northeast.  Follow me if you would.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44077,'I\'ve known nothing but Gilneas for a very long time.  I\'d feared we\'d not find a place we could call home again anytime soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44078,'Tyrande and Malfurion welcomed us in with open arms.  Almost as if we were long lost family.  It was strange and comforting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44079,'I hear whispers though... whispers of confusion... perhaps even whispers of dissent.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44080,'I asked Malfurion of this, and he said that the city recently suffered a great tragedy.  That one of the leaders was taken away and that lives were lost.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44081,'He seems to know more than the whispering citizens, and he seems convinced that this traitor is the one last remnant of the cities troubles, Cataclysm aside.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44082,'Malfurion strikes me as both wise and honest.  I take him at his word.  I\'d welcome more answers, but it\'s not my place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44083,'Enough of my ramblings.  The trail leads here.  That entire building is covered in plants with leaves like the one we found.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44084,'The guest rooms.  These were offered to some of my people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44085,'Too general in use to tell us who is behind this.  Perhaps we\'ll find something inside.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44086,'You\'ve found something?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44087,'A map of Darkshore.  I saw this place shortly before I arrived in Rut\'theran Village.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44088,'There are routes traced from this Auberdine to several locations.  It almost looks like an evacuation plan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44089,'The route across this western beach is circled.  Do you know your way there?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44090,'I promised Malfurion that I would inform him if we made any progress.  I\'ll meet you at the beach as soon as I can.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44091,'You better head straight there, but be cautious.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44092,'This was a massacre.  A planned ambush?  Who do these elementals bend to?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44093,'We will hunt this traitor down.  That I promise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44094,'He was wounded.  I can easily pick up his trail.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44095,'This way!  Stay with me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44096,'His trail is still fresh.  We\'re not far behind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44097,'Come, friend.  Quickly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44098,'There!  Who is that he\'s meeting with?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44099,'Let\'s move!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44100,'...where did they go?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44101,'There\'s no way they could have escaped by land.  Did they...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44102,'I hope you know how to swim.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44103,'Glad you made it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44104,'They\'re just up ahead.  The sound of the water should cover our approach.  Let me know when you\'re ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44105,'Let\'s finish this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44106,'I\'ll take the cultist.  You handle the traitor. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44107,'No so fast, betrayer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44108,'There will be no easy escape for you.  You answer to the temple.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44109,'','I\'m impressed Gregory.  I must admit, I had not expected such restraint.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44110,'My people have come a long way in those regards, my lady.  I\'m sorry if I gave you any cause to doubt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44111,'','Gregory, please take the prisoner back to the sentinels so that we can deal with him properly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44112,'Of course, my Lady.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44113,'','And you, my dear friend, you\'ve done a great thing for us this day.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44114,'','It is a difficult thing for us to trust someone so new to our city.  You\'ve come upon us during a somewhat desperate time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44115,'','To our great fortune, you\'ve proven quite honorable and dedicated.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44116,'It is good to see you again, friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44117,'Back so soon?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44118,'Yes - I need another wind rider.','Yes - I need another wind rider.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44119,'I will not be pulled outside into your trap! Face me here, coward!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(44120,'Be careful out there, $n.  You don\'t want to be on that ship too long... a few more cannonballs and she\'ll be sunk.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44121,'Rghaaaa! Face the fury of Mor\'ghor!','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(44122,'Prepare to be punished! Mor\'ghor Slam!','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(44123,'Hope for lasting relief from the shadow that has been cast on our people for so long.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44124,'The Verne will be arriving shortly! Get your gear and form up, boys!','',0,0,0,0,0,0,0,0,1,11196,0,0,26124),
(44125,'The Verne has docked. All aboard!','',0,0,0,0,0,0,0,0,1,11196,0,0,26124),
(44126,'The worgen stares and hesitates!','The worgen stares and hesitates!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44127,'WAR IS IN MY BLOOD!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44128,'You brought this on yourself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44129,'Shoulda just left us alone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44130,'FEEL THE THUNDER!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44131,'You\'re nothing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44132,'Your pain excites me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44133,'The world\'s gone to hell, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44134,'I remember a time when there were no orcs. Can you imagine it? No damned orcs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44135,'Maybe we\'ll have peace again someday. And maybe I\'ll poop gold out my butt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44136,'When this is all over I\'m gonna buy you a drink, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44137,'If I didn\'t mention it earlier, $n, welcome to Bravo Company.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44138,'You\'re alright, $n. Not like those no good, money grubbing politicians in Stormwind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44139,'After we clean this place up, maybe we can start rebuilding it. Maybe they\'ll give it to Bravo Company. We\'ll call it: BRAVO KEEP!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44140,'I don\'t like this... Feels too easy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44141,'Did $n tell you about how we found Danforth, Johnny? I think the orcs may have touched him inappropriately.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44142,'Tired of orcs. We need to kill \'em all and let Thrall sort \'em out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44143,'Anyone hear from my girl? Darcy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44144,'After we\'re done here, I think I\'ll go to Ironforge. Get me a few pints of Ironforge\'s finest and some friendly dwarven wenches.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44145,'I have a clear shot here! Get me more ammo!','',0,0,0,0,0,0,0,0,1,0,21541,0,26124),
(44146,'You heard him! Keep that gun stocked with ammo!','',0,0,0,0,0,0,22,0,1,0,21297,0,26124),
(44147,'Aye, sir!','',0,0,0,0,0,0,113,0,1,0,0,0,26124),
(44148,'Now, this is what I call a target rich environment!','',0,0,0,0,0,0,0,0,1,0,21542,0,26124),
(44149,'Use caution when firing those shells...','',0,0,0,0,0,0,396,0,1,0,19535,0,26124),
(44150,'Neptulon\'s revenants must not consider us enemies!','',0,0,0,0,0,0,274,0,1,0,19536,0,26124),
(44151,'Keep those naga away from the crater!','',0,0,0,0,0,0,397,0,1,0,21298,0,26124),
(44152,'If they get a foothold in the plane of water, we\'ll never get \'em out!','',0,0,0,0,0,0,274,0,1,0,21299,0,26124),
(44153,'Calculating trajectory...','',0,0,0,0,0,0,432,0,1,0,21543,0,26124),
(44154,'Calibrating fuse...','',0,0,0,0,0,0,432,0,1,0,21544,0,26124),
(44155,'Munitions ready!','',0,0,0,0,0,0,396,0,1,0,21545,0,26124),
(44156,'Commence Fire!','',0,0,0,0,0,0,397,0,1,0,21552,0,26124),
(44157,'Wahoo!','',0,0,0,0,0,0,5,0,1,0,21546,0,26124),
(44158,'Where\'s the mighty Neptulon, shaman?!','',0,0,0,0,0,0,6,0,1,0,21300,0,26124),
(44159,'Why are we stuck protecting his domain?','',0,0,0,0,0,0,6,0,1,0,21301,0,26124),
(44160,'The lords of the elemental planes are beings of pure chaos, Nazgrim.','',0,0,0,0,0,0,396,0,1,0,19519,0,26124),
(44162,'No one can discern their motives...','',0,0,0,0,0,0,396,0,1,0,19537,0,26124),
(44163,'Bah! Unless he wants his home overrun by these serpents, he\'d better show himself...','',0,0,0,0,0,0,396,0,1,0,21302,0,26124),
(44164,'Look at the size of those things! What ARE they?','',0,0,0,0,0,0,6,0,1,0,21547,0,26124),
(44165,'The naga have enlisted the aid of the Old God\'s minions.','',0,0,0,0,0,0,396,0,1,0,19538,0,26124),
(44166,'Twisted creatures bent on the destruction of all living beings.','',0,0,0,0,0,0,396,0,1,0,19539,0,26124),
(44167,'Sorry I asked...','',0,0,0,0,0,0,396,0,1,0,21548,0,26124),
(44168,'The elementals are grossly outnumbered.','',0,0,0,0,0,0,396,0,1,0,21303,0,26124),
(44169,'They don\'t stand a chance...','',0,0,0,0,0,0,274,0,1,0,21304,0,26124),
(44170,'I sense desperation in them.','',0,0,0,0,0,0,396,0,1,0,19540,0,26124),
(44171,'Without aid, they will fail.','',0,0,0,0,0,0,273,0,1,0,19541,0,26124),
(44172,'The Bravo Company, all present and accounted for...','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(44173,'Did you truly believe that the orcs had the presence of mind required to plan an invasion of this magnitude?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(44174,'No matter. You will die now, a paltry offering to Deathwing as our march upon Stormwind begins.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(44175,'Feed the master\'s rage! COME AND DIE!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(44176,'I grow tired of these games!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(44177,'Suffer in flames!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(44178,'Enough of this!','',0,0,0,0,0,0,5,0,1,0,21305,0,26124),
(44179,'We waste our time here just floating about...','',0,0,0,0,0,0,396,0,1,0,21306,0,26124),
(44180,'If we are to defend the rift, we must do it directly!','',0,0,0,0,0,0,5,0,1,0,21307,0,26124),
(44181,'Set us down next to the crater!','',0,0,0,0,0,0,397,0,1,0,21308,0,26124),
(44182,'Th-there\'s no way, sir! The current... it\'s too strong! ','',0,0,0,0,0,0,5,0,1,0,21550,0,26124),
(44183,'I have a clear shot here! Get me more ammo!','',0,0,0,0,0,0,0,0,1,0,21535,0,26124),
(44184,'Keep moving, men! I want a steady stream of shells for these guns!','',0,0,0,0,0,0,22,0,1,0,21192,0,26124),
(44185,'Aye, sir!','',0,0,0,0,0,0,66,0,1,0,21332,0,26124),
(44186,'Wahoo! This is what I call a target rich environment!','',0,0,0,0,0,0,71,0,1,0,21536,0,26124),
(44187,'Keep those naga away from the crater!','',0,0,0,0,0,0,388,0,1,0,21193,0,26124),
(44188,'If they manage to enter the breach, we\'ll never get them out!','',0,0,0,0,0,0,5,0,1,0,21194,0,26124),
(44189,'Calculating trajectory...','',0,0,0,0,0,0,0,0,1,0,21537,0,26124),
(44190,'Calibrating fuse...','',0,0,0,0,0,0,0,0,1,0,21538,0,26124),
(44191,'Munitions ready!','',0,0,0,0,0,0,0,0,1,0,21539,0,26124),
(44192,'Commence Fire!','',0,0,0,0,0,0,397,0,1,0,21552,0,26124),
(44193,'Wahoo!','',0,0,0,0,0,0,71,0,1,0,21540,0,26124),
(44194,'Where is Neptulon in all of this, shaman?','',0,0,0,0,0,0,6,0,1,0,21195,0,26124),
(44195,'Why does he not protect his own domain?','',0,0,0,0,0,0,6,0,1,0,21196,0,26124),
(44196,'The lords of the elemental planes are beings of pure chaos, captain.','',0,0,0,0,0,0,396,0,1,0,19518,0,26124),
(44197,'If he doesn\'t defend his home, he\'ll soon be without one.','',0,0,0,0,0,0,396,0,1,0,21197,0,26124),
(44198,'Look at the size of those things! What ARE they?','',0,0,0,0,0,0,6,0,1,0,21251,0,26124),
(44199,'Sorry I asked...','',0,0,0,0,0,0,396,0,1,0,21252,0,26124),
(44200,'The elementals are clearly outnumbered.','',0,0,0,0,0,0,396,0,1,0,21198,0,26124),
(44201,'They fight in vain...','',0,0,0,0,0,0,5,0,1,0,21199,0,26124),
(44202,'This isn\'t helping!','',0,0,0,0,0,0,5,0,1,0,21200,0,26124),
(44203,'We cannot hold off the naga this way.','',0,0,0,0,0,0,274,0,1,0,21201,0,26124),
(44204,'If we are to defend the rift, we must do it directly!','',0,0,0,0,0,0,396,0,1,0,21202,0,26124),
(44205,'Impossible sir! The current\'s too strong!','',0,0,0,0,0,0,5,0,1,0,21253,0,26124),
(44206,'What hubrisss these fools possessss!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44207,'It ssshall profit them nothing, sssave it be a ssspeedy demise...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44208,'','Dessstroy them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44209,'You will die with me, Keeshan! This world has enough heroes!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(44210,'You gutless bastard! You\'ve killed \'em all! Now I kill you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44211,'','Now! Unleash the kraken!',0,0,0,0,0,0,15,0,1,0,0,18877,26124),
(44212,'Aaaaaahhh...','',0,0,0,0,0,0,0,0,1,0,19464,0,26124),
(44213,'','Follow me, my pets! The realm of the mighty Neptulon is ours at last!',0,0,0,0,0,0,15,0,1,0,0,18878,26124),
(44214,'What now, old friend?','',0,0,0,0,0,0,1,0,1,0,21217,0,26124),
(44215,'We have suffered a tragic defeat.','',0,0,0,0,0,0,396,0,1,0,19526,0,26124),
(44216,'Any hope for the future of our world has grown much bleaker.','',0,0,0,0,0,0,396,0,1,0,19527,0,26124),
(44217,'Thrall must be told of this day\'s events.','',0,0,0,0,0,0,396,0,1,0,19528,0,26124),
(44218,'He will guide our next steps...','',0,0,0,0,0,0,396,0,1,0,19529,0,26124),
(44219,'Erunak! Noooo!','',0,0,0,0,0,0,1,0,1,0,21218,0,26124),
(44220,'Graaaahahhhh.','',0,0,0,0,0,0,396,0,1,0,19530,0,26124),
(44221,'','That\'s... one big orc.',0,0,0,0,0,0,0,0,1,0,0,19693,26124),
(44222,'','It\'s about to blow, jump on the Wyverns!',0,0,0,0,0,0,0,0,1,0,0,19694,26124),
(44223,'','You were a true man of the people, Liam.  Unlike any Royal I ever met.  We\'ll make them pay for this.',66,0,0,0,0,0,0,0,7,0,0,19686,26124),
(44224,'Die, worm!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(44225,'Well, shaman, what now?','',0,0,0,0,0,0,1,0,1,0,21319,0,26124),
(44226,'Erunak! Behind you!','',0,0,0,0,0,0,1,0,1,0,21320,0,26124),
(44227,'What dis...?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44228,'No! Ahhhhh.....','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(44229,'Gah... heeelp!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(44230,'Ahhhhh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44231,'Nooooo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44232,'','We must hold off the enemy for just a while longer.  In mere moments, Cenarius will walk among us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44233,'','Hurry - she is breaking free!',0,0,0,0,0,0,0,0,1,0,0,20741,26124),
(44234,'Hold the line!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44235,'Push them back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44236,'I\'d rather be brewin\' than fightin\'!$B$BBut with any luck, I can manage both, eh?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44237,'Let us go to Hyjal while we can still make a difference!','',0,0,0,0,0,0,0,0,1,0,20949,0,26124),
(44238,'Dat not good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44239,'','The blessing of the land be with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44240,'Deepholm is the realm of earth.  It is here that Deathwing retreated when he was first defeated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44241,'His followers helped him regain his strength inside this very temple.  Plates of powerful elementium were grafted onto his skin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44242,'Deathwing\'s return to Azeroth caused a major rift within the two worlds.  This breach is the force largely behind the cataclysm that threatens to destroy our lands.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44243,'Thrall is using all of his power to stabilize the rift from Azeroth\'s side.  We are doing what we can to stabilize it here as well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44244,'Deathwing\'s escape didn\'t just damage our world.  A powerful stone created by the Titans used to be in this room before the breach shattered it.  It was known as the World Pillar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44245,'It was not merely a name, for the World Pillar supported more than just the weight of this temple.  It must be rebuilt or all of Deepholm will collapse into Azeroth, with disastrous consequences for both worlds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44246,'Three fragments were lost after the World Pillar shattered.  We must recover them or else the fate of our world is doomed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44247,'We have to keep those fungal terrors off of the front. They\'re too powerful!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44248,'My father is close, I know it! We have to bust through their defenses and rescue him!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44249,'Cho\'gall begins casting Flaming Pillar of Certain Doom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44250,'Set us down as close to the crater as possible!','',0,0,0,0,0,0,397,0,1,0,21203,0,26124),
(44251,'','Shandris raises her bow to the stars!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44252,'Burn! Burn, you wretches!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44253,'','Elune, guide my arrows!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44254,'If you want to hire a gryphon, you\'ve come to the right place.','',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(44255,'','Your reign has come to an end, oh Lord of the Waves! ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44256,'','Sssoon, your preciousss throne will lie in ruins!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44257,'','Your tentacled head, a mere trophy for my queen...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44258,'You are in my realm now, serpent!','',0,0,0,0,0,0,0,0,1,0,19465,0,26124),
(44259,'Did you think me unprepared for such an assault?','',0,0,0,0,0,0,0,0,1,0,19466,0,26124),
(44260,'The method of your cleansing lies within your grasp...','',0,0,0,0,0,0,0,0,1,0,19467,0,26124),
(44261,'...yet forever out of your reach.','',0,0,0,0,0,0,0,0,1,0,19468,0,26124),
(44262,'','Scour this place, my legions! Find the Tidehunter\'s trap!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44263,'Ahh - my fearless assistants, I assume.','',0,0,0,0,0,0,0,0,1,0,19469,0,26124),
(44264,'You may yet regret your presence here.','',0,0,0,0,0,0,0,0,1,0,19470,0,26124),
(44265,'As I purify these waters, the servants of filth will surely be stirred. Beware!','',0,0,0,0,0,0,0,0,1,0,19471,0,26124),
(44266,'Augh... Their filthiness stains me!','',0,0,0,0,0,0,0,0,1,0,19472,0,26124),
(44267,'I grow... weary...','',0,0,0,0,0,0,0,0,1,0,19473,0,26124),
(44268,'Fools! Make yourselves useful...','',0,0,0,0,0,0,0,0,1,0,19474,0,26124),
(44269,'Patience, guests. The waters are nearly cleansed.','',0,0,0,0,0,0,0,0,1,0,19475,0,26124),
(44270,'The beast has returned! It must not pollute my waters!','',0,0,0,0,0,0,0,0,1,0,19476,0,26124),
(44271,'Behold the power of pure water!','',0,0,0,0,0,0,0,0,1,0,19477,0,26124),
(44272,'My waters are cleansed! Drink in their power!','',0,0,0,0,0,0,0,0,1,0,19478,0,26124),
(44273,'Your kind... cannot be... trusted.','',0,0,0,0,0,0,0,0,1,0,19479,0,26124),
(44274,'You are unworthy of my domain...','',0,0,0,0,0,0,0,0,1,0,19480,0,26124),
(44275,'My attention... was wasted on you...','',0,0,0,0,0,0,0,0,1,0,19481,0,26124),
(44276,'My realm has at last been cleansed of the vile filth.','',0,0,0,0,0,0,0,0,1,0,19482,0,26124),
(44277,'You are free to take your leave.','',0,0,0,0,0,0,0,0,1,0,19483,0,26124),
(44278,'','Thank you!  I don\'t know how much longer we would have survived.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44279,'','That cage was stifling my magic.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44280,'','If you don\'t mind, I\'m going to teleport us back to the Rebel Camp.  We\'ll thank you in person later.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44281,'','Mor\'ghor! You should\'ve stayed in Outland with the rest of your half-demon scum. There\'s no place for you here.',0,0,0,0,0,0,5,0,1,0,0,21599,26124),
(44282,'Woo hoo.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44283,'Freedom!  Sweet, sweet freedom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44284,'','A piercing warcry echos through the maul!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44285,'','He\'s too strong! Retreat!',0,0,0,0,0,0,5,0,1,0,0,21602,26124),
(44286,'','Wherever the Horde takes us, we will keep our heads high and our blood pure. Good riddance, Mor\'ghor. A new Dragonmaw dawns this day.',0,0,0,0,0,0,0,0,1,0,0,21600,26124),
(44287,'Zaela ... traitorous fool ... have you sold your soul to the Horde? Are you and I so different? Cast your lot with Hellscream, then. See where he takes you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44288,'It\'s working. Hold him still, Jitters.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(44289,'I... I can\'t...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44290,'Damn it, Jitters, I said HOLD!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(44291,'Jitters...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44292,'JITTERS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44293,'I remember now... it\'s all your fault!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44294,'You brought the worgen to Duskwood! You led the Dark Riders to my farm, and hid while they murdered my family!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44295,'Every speck of suffering in my life is YOUR PATHETIC FAULT! I SHOULD KILL YOU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44296,'Letting him go is the only thing that\'s going to separate you from the beasts now, my friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44297,'You\'ve got a lot to make up for, Jitters. I won\'t give you the easy way out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44298,'','I\'ll show you true power!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44299,'','Orhan focuses her might!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44300,'Here we go...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(44301,'','Welcome to Dolanaar, $c. Let me know if you need any recipes or basic cooking ingredients.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44302,'Alright, we just add this in here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44303,'Centrifugate...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44304,'Bingo!  Look at this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44305,'The Stone Dragon Broodmother bows her head in surrender.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44306,'','I hope you weren\'t looking for something to eat, $c.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44307,'Enough of this foolishness!','',0,0,0,0,0,0,0,0,1,0,20237,0,26124),
(44308,'We will handle them!','',0,0,0,0,0,0,0,0,1,0,21843,0,26124),
(44309,'','Hello again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44310,'','You rang?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44311,'','Need something?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44312,'The Stone Dragon Broodmother approaches.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44313,'$n! The Warchief is alive - he was rescued off the coast. Come outside, quickly. The town is ours!','',0,0,0,0,0,0,5,0,1,0,20974,0,26124),
(44314,'','Hellscream, I am Zaela of the Dragonmaw. Your people have freed mine from tyranny. We are your instrument. The strength of the Dragonmaw is yours to command. For the Horde!',0,0,0,0,0,0,0,0,1,0,0,21601,26124),
(44315,'Speak with Terrath the Steady when you are ready to begin.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(44316,'Yes, I live! No Twilight Dragon can keep this orc down.','',0,0,0,0,0,0,11,0,1,0,20513,0,26124),
(44317,'Ahh, there she is. The battle-maiden of the Dragonmaw. Let me see your face.','',0,0,0,0,0,0,1,0,1,0,20514,0,26124),
(44318,'Blood and honor, hero. The Horde welcomes you. Your people will be put to the test as we obliterate Twilight\'s Hammer and lay claim to this distant shore. But first... some unfinished business.','',0,0,0,0,0,0,273,0,1,0,20515,0,26124),
(44319,'Come and face me! *snort* I can smell your $r stench from here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44320,'An impressive display...','',0,0,0,0,0,0,0,0,1,0,20240,0,26124),
(44321,'...to have made it this far.','',0,0,0,0,0,0,0,0,1,0,21845,0,26124),
(44322,'But now, witness true power...','',0,0,0,0,0,0,0,0,1,0,20165,0,26124),
(44323,'...the fury of the elements!','',0,0,0,0,0,0,0,0,1,0,20288,0,26124),
(44324,'$n? It\'s about time you got here. What kept you? My father\'s life is in jeopardy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44325,'','I made it!  I need to get Mr. Oinky to watch my back while I\'m out adventuring.',0,0,0,0,0,0,4,1,1,0,0,0,26124),
(44326,'Do something.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44327,'','Hey there, I\'d like to get my pet, Mr. Oinky out please!',0,0,0,0,0,0,3,1,1,0,0,0,26124),
(44328,'','Mr. Oinky!  Poor, poor Mr. Oinky...  ',0,0,0,0,0,0,18,1,1,0,0,0,26124),
(44329,'','Mr. Oinky!! Come back to me Mr. Oinky!',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(44330,'Mr. Oinky... Yeah... Well...','',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(44331,'Right... He ran away!  He\'s a big, juicy guy and he just got away from us here.  I\'m sorry miss.','',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(44332,'Vernon looks around nervously, making sure to not look at the pig on the spit.','',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(44333,'','Lok\'tar ogar! This young $r $c has conquered the great Echeyakee. Let $ghis:her; actions show the might of the new Horde!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(44334,'%s has been subdued.','%s has been subdued.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(44335,'The Battle for Gilneas','The Battle for Gilneas',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44336,'BEHOLD YOUR DOOM!','',0,0,0,0,0,0,0,0,1,0,20396,0,26124),
(44337,'Eradicate....','',0,0,0,0,0,0,0,0,1,0,20398,0,26124),
(44338,'Annihilate....','',0,0,0,0,0,0,0,0,1,0,20397,0,26124),
(44339,'Impossible....','',0,0,0,0,0,0,0,0,1,0,20399,0,26124),
(44340,'You are not yet strong enough to enter The Battle for Gilneas. Return when you have gained more experience.','You are not yet strong enough to enter The Battle for Gilneas. Return when you have gained more experience.',274,0,0,1,0,0,0,0,1,0,0,0,26124),
(44341,'Ahh, the jungle.  It\'s good to get out of town every once in a while, you know?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44342,'You are not yet strong enough to do battle in Twin Peaks. Return when you have gained more experience.','You are not yet strong enough to do battle in Twin Peaks. Return when you have gained more experience.',274,0,0,1,0,0,0,0,1,0,0,0,26124),
(44343,'Twin Peaks','Twin Peaks',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44344,'','What hubrisss these fools possessss!',0,0,0,0,0,0,0,0,1,0,0,21907,26124),
(44345,'','It ssshall profit them nothing, sssave it be a ssspeedy demise...',0,0,0,0,0,0,0,0,1,0,0,21908,26124),
(44346,'','Dessstroy them!',0,0,0,0,0,0,0,0,1,0,0,18894,26124),
(44347,'','Then this starts happening...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44348,'%s goes into a berserker rage upon seeing Runty\'s lifeless body!','%s goes into a berserker rage upon seeing Runty\'s lifeless body!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44349,'Runty\'s death sends %s into a berserker rage!','Runty\'s death sends %s into a berserker rage!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44350,'$n, you\'re going to want to fly over these giants and stone troggs. Don\'t try to ride through them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44352,'Slay stone troggs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44353,'Destroy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44354,'Reactivated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44356,'The great Rastakhan sends his greetings to you, member of the Alliance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44357,'The orcs of Stonetalon will suffer your rampage no more, foul beast.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44358,'This is MY WAGON!\n\nMINE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44359,'First one to move gets a lightning bolt to the head!','First one to move gets a lightning bolt to the head!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44360,'Keep those hands where we can see them!','First one to move gets a lightning bolt to the head!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44361,'Do as you\'re told and no one gets hurt!','Do as you\'re told and no one gets hurt!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44362,'You disgrace the elements.  Don\'t give us an excuse to end your pathetic lives!','You disgrace the elements.  Don\'t give us an excuse to end your pathetic lives!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44363,'Your Lord will feel every moment of the pain you are about to endure.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44364,'You\'ll never catch me alive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44365,'To hell with this, I\'m running for it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44366,'The faithful shall serve by HIS side!  Aiiiiigh!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44367,'No prison can hold me!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44368,'You\'re $n, right? Gazlowe told me to take ya up the river! Hop in when you\'re ready to go.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(44369,'Here we go again...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44370,'Not another one...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44371,'I got this one...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44372,'He\'s not going anywhere.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44373,'No one\'s allowed to leave. Prince Liam\'s orders.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44374,'It isn\'t safe to leave, there\'s something lurking out there in the woods.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44375,'Stay calm. We have everything under control.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44376,'','Step on through, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44377,'You can\'t do this to us!','You can\'t do this to us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44378,'My children are in Stormglen alone! I have to get to them!','My children are in Stormglen alone! I have to get to them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44379,'What\'s going on? I thought I saw something on the rooftops.','What\'s going on? I thought I saw something on the rooftops.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44380,'Ey mon, what you need?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44381,'Skeezy says he already paid for my flight to Hardwrench Hideaway.  I\'m ready to depart.','Skeezy says he already paid for my flight to Hardwrench Hideaway.  I\'m ready to depart.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44382,'Keep your eyes open, $c. Even Durotar is not safe from our enemies.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44383,'Yes, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44384,'Wulfred says that he paid for my trip to the Explorers\' League Digsite.  I\'m ready to depart.','Wulfred says that he paid for my trip to the Explorers\' League Digsite.  I\'m ready to depart.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44385,'The Explorers\' League exists to uncover the hidden secrets within this world.  While the cataclysm was devastating for most, for us, it provided access to untold troves of information and wealth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44386,'Whew, that was a bit of a tight squeeze, but the rest of the trip should be a breeze.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44387,'There\'s nothing quite like the smell of Durotar on a warm, comfortable boat ride.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44388,'This is where you\'d expect something to go wrong on a beautiful trip like this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44389,'Everyone always says, \"Horton, why do you drive a boat up and down the river?\" I ask them, \"Why don\'t you?\"  ... that\'s usually where I run out of witty retorts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44390,'We\'re pulling up near your stop. Head due west along the road to reach Nozzlepot\'s Outpost.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44391,'Why are the gates closed?','Why are the gates closed?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44392,'Did you hear that?','Did you hear that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44393,'We have to get out of here! The howling gets louder every night.','We have to get out of here! The howling gets louder every night.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44394,'They told us Gilneas City was safe...','They told us Gilneas City was safe...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44395,'Stay here with the others and don\'t try anything funny.','Stay here with the others and don\'t try anything funny.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44396,'Don\'t let them break the line!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(44397,'For Stormglen! For Gilneas!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(44398,'Die, foul beast!','',14,0,0,0,0,0,0,0,1,0,0,0,26124),
(44399,'snarls at Stormglen Defender.','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(44400,'I train only warriors, $c. You\'ll have to look elsewhere.','I train only warriors, $c. You\'ll have to look elsewhere.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44401,'Are you ready to train, warrior?','Are you ready to train, warrior?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44402,'It\'s good to see you made it through, $n. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44403,'Show me today\'s selection of pies.','Show me today\'s selection of pies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44404,'Why pie over cake?','Why pie over cake?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44405,'Pie is far better than cake. Everyone knows that! Shouldn\'t a $c of your standing be well-informed about such important matters?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44406,'I\'ll keep that in mind.','I\'ll keep that in mind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44407,'Hear anything interesting, $n? Your little revelation about me is about to cost you your life.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(44408,'Pathetic. The Horde grows weaker by the day...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(44409,'The Twilight\'s Hammer has agents everywhere! Kill me and a dozen take my place!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44410,'My powers of sight... I beheld the future... I have seen what is to come...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44411,'This world unravels. If you could see the horrors I have seen... ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44412,'To serve is madness, but defiance ... impossible!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44413,'','We will defeat the Twilight\'s Hammer wherever they may hide.  Not even the elemental planes will be a safe haven for their kind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44414,'You should have your pet wait for you here. Beware the Blackrock Worg Captain! |TInterface\\Icons\\SPELL_NATURE_TIMESTOP.BLP:24|t','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44415,'Don\'t forget to command your pet to follow you! |TInterface\\Icons\\ABILITY_TRACKING.BLP:24|t','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44416,'When Deathwing destroyed the World Pillar, he broke open a rift between your world and ours. These spores and fungi are one consequence.$B$BLet\'s see if we can deal with them together.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44417,'Don\'t forget to grab a war guardian, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44418,'Bravo Company Field Kit ACTIVE. New abilities are now available on your action bar.$BToggle Bravo Company Field Kit to DEACTIVATE.','Bravo Company Field Kit ACTIVE. New abilities are now available on your action bar.$BToggle Bravo Company Field Kit to DEACTIVATE.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44419,'Bravo Company Field Kit ACTIVE. Plant Seaforium is now available on your action bar.$BToggle Bravo Company Field Kit to DEACTIVATE.','Bravo Company Field Kit ACTIVE. Plant Seaforium is now available on your action bar.$BToggle Bravo Company Field Kit to DEACTIVATE.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44420,'','Hey, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44421,'Bouldergut, you coward! Fight someone your own size!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44422,'Let me out of these chains! I\'ll reduce you to rubble!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44423,'Flint! Get out of here! He\'s too powerful!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44424,'Damned stinking stone trogg! You\'ll never get the World Pillar fragment!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44425,'You\'re too late, Bouldergut. The proverbial cavalry has arrived!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44426,'','Hello, $c.  Care to purchase something?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44427,'Nothing in all of the elemental planes will stop me from killing you once I get out of these chains, Bouldergut!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44428,'Free me now before it\'s too late! Deepholm cannot survive much longer without the World Pillar intact!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44429,'You don\'t know what you\'re doing, Bouldergut! By keeping me captive, you\'re dooming Deepholm and us all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44430,'$n! You\'re a sight for sore eyes. Get over here and give me a hand, would you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44431,'We just mix these two together...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44432,'...give a little swirl...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44433,'...alchemy, alchemy, alchemy...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44434,'...and, we put the potion on the sample...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44435,'There we go.  The substance that you have brought me is approximately... 150,000 years old?  What!?  I\'m going to need to run another test.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44436,'','The Gurubashi are dead, and Hakkar with them.  Most of my fellow Zandalar have returned to their homeland.$b$bIt falls on me, Chabal, and the Darkspears of Bambala to watch over Zul\'Gurub now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44437,'Maywiki, I was hunting Zanzil and I lost track of what I was doing.  Can you remind me where to go next?','Maywiki, I was hunting Zanzil and I lost track of what I was doing.  Can you remind me where to go next?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44438,'This ancient totem is fashioned into the shape of a bat.  It must be the totem that Maywiki spoke of.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44439,'Titan artifacts are largely inert.  Something like Zanzil\'s mixture should have no effect whatsoever.  Let\'s try it out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44440,'That was... unexpected.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44441,'Oh, hey $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44442,'You\'ve saved both myself and my son.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44443,'You have my gratitude and that of my people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44444,'Return to Pyrium Lodestone with the good news. We\'ll see you back at Stonehearth shortly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44445,'This hero represents the Earthen Ring. They need the middle fragment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44446,'Hey!  What are you doing down there?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44447,'Quick, grab onto the ladder!  That troll doesn\'t look too friendly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44448,'The prince has run off. This is bad!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(44449,'Zub zub.$B$BWhat? Go away.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(44450,'Zub zub.$B$BWhat? Two zubs not good \'nuff for you, $c?','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(44451,'Why ask me? I know nothing of the Twilight\'s Hammer.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(44452,'<The peon sweats and twitches.>$B$BI was ... what I meant ... um, bad!','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(44453,'<The peon\'s eyes widen in terror.>$B$BNo! You\'ve discovered Sauranok is the new cult leader in Orgrimmar? He told me his secret is safe!\n','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(44454,'Wait, uh - you put words in my mouth! Not fair!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44455,'Has a secret cult infiltrated the Orgrimmar skyway?','Has a secret cult infiltrated the Orgrimmar skyway?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44456,'I didn\'t say Twilight\'s Hammer. YOU said Twilight\'s Hammer.','I didn\'t say Twilight\'s Hammer. YOU said Twilight\'s Hammer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44457,'I know all about your cult master.','I know all about your cult master.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44458,'So it\'s true? Sauranok IS guilty of treason!','So it\'s true? Sauranok IS guilty of treason!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44459,'Silence, idiot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44460,'Zub zub!','',273,0,0,0,0,0,273,0,1,0,0,0,26124),
(44461,'Orgrimmar is stronger than ever!','',5,0,0,0,0,0,273,0,1,0,0,0,26124),
(44462,'Can I help?','',273,0,0,0,0,0,273,0,1,0,0,0,26124),
(44463,'Hello, $c!$B$BOrgrimmar\'s skyway is the center of the world. The north zeppelin tower will take you to Stranglethorn or Undercity. The south tower wll take you to Thunderbluff or all the way to Northrend.$B$BFlight Master Doras can send you all over Kalimdor - at least, anyplace you\'ve already explored.','',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(44464,'Cult? I don\'t know. Seen some suspicious types lingering around the south zeppelin tower, though.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(44465,'I don\'t know nothing! Ask the others.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(44466,'Secret cult? Is that who I see having meetings at the base of the south zeppelin tower?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(44467,'Secret cult? You\'re not with those creepy orcs who lurk around the south zeppelin tower, are you?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(44468,'I\'m too dumb to be in a cult. Been that way since I felled off the back of the zeppelin. And hit them propellors. Landed on a rock. They fixed my head up with a metal bowl to make it round and hard.$B$B<He thunks his fist against his skull.>$B$BThen the lightning done come.','',6,1,5,0,0,0,0,0,1,0,0,0,26124),
(44469,'I hear strange orcs whispering all the time inside the south zeppelin tower. They always shut up whenever I get near.','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(44470,'I don\'t know.$B$BDon\'t hit me!','',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(44471,'Dig faster! Faster! No stop!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44472,'Dig! Rock-mans! For everlasting peace!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44473,'Nasty rock-mans! Do as we say!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44474,'Dig ore! Rock-mans dig ore now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44475,'Rock-mans so lazy! Why rock-mans so lazy?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44476,'Rock-mans dig or kobold hit more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44477,'','I\'m sorry, but I can\'t offer you training.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(44478,'','Choosing the path of a mage is to choose a path of great difficulty. Many do not understand us. Our own people struggle to accept our arts.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44479,'Father! Let me get you free of those chains.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44480,'','Are you here to help Ironforge, or just gawk at me all day?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44481,'Leaping Leper Gnomes! You\'re a sight for sore eyes. I was worried the giant magma worm out front would deter visitors. Now that you\'re here you can give me a hand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44482,'I suppose you\'ll be needing a key for this cage? Wait, don\'t tell me. The horrific gibbering monster behind me ate it, right?','I suppose you\'ll be needing a key for this cage? Wait, don\'t tell me. The horrific gibbering monster behind me ate it, right?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44483,'You have my undying gratitude and that of my people, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44484,'|TInterface\\Icons\\ability_rogue_shadowdance.blp:20|t%s begins to summon |cFFFF0000Corrupted Adherents|r to aid him!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44485,'$C, over here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44486,'The middle fragment of the World Pillar has been dug up and is missing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44487,'I can offer you a free bunk if you\'d like to rest.  They\'re not comfortable, but it doesn\'t look like you get much sleep anyway. ','I can offer you a free bunk if you\'d like to rest.  They\'re not comfortable, but it doesn\'t look like you get much sleep anyway. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44488,'On my way down here from Dun Algaz I saw a gnoll hunting Threshadons in the middle of a lake.  If you\'ve never seen a dog try to use a spear, you\'re in for a treat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44489,'They say that the raptor matriarch lives deep within Raptor Ridge, protecting her clutch of eggs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44490,'I was up at Whelgar\'s a few days ago attempting to...er...liberate...some titan relics from the bones of the dead raptors, and I saw him!  Sarltooth lives!  \n\nWell, he\'s undead, so I guess he doesn\'t live, but he exists.  Sarltooth exists!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44491,'The Dragonmaw are attempting to push out of the Angerfang Encampment and are already raiding the caravan to the east.  They\'ve called in two powerful warriors who are leading the charge.  If you\'re up for a challenge, you might find them at the Encampment, planning and strategizing and doing other evil, Orcish things.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44492,'Slate, did the Axe of Earthly Sundering return to you?','Slate, did the Axe of Earthly Sundering return to you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44493,'Yes, it did. Try to be more careful.$B$BWe wouldn\'t want to lose the king\'s axe!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(44494,'I cannot help you with your training. Seek out a $c trainer.','I cannot help you with your training. Seek out a $c trainer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44495,'Are you here to train, hunter?','Are you here to train, hunter?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44496,'Lok\'tar! We need your help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44497,'With your strength, murlocs, our plan will succeed. Our kobold friends will mine us plenty of ore...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44498,'And, armed with gnoll-forged weapons of indestructible copper, you murlocs will be unstoppable!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44499,'What was that? And what the heck is that smell?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44500,'...why are you looking at me like that?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44501,'You\'ll regret this! This is your only chance, you fishy fools!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44502,'AAAAAAGH! CURSE YOUR SUDDEN YET INEVITABLE BETRAYAL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44503,'EEEEEEEEEEE! RUN AWAY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44504,'*sniff sniff*','',0,0,0,0,0,0,0,0,1,0,15995,0,26124),
(44505,'Rrglrglrglrglrgl.','',0,0,0,0,0,0,0,0,1,0,416,0,26124),
(44506,'Rrglrglrglrglrgl!','',0,0,0,0,0,0,0,0,1,0,416,0,26124),
(44507,'RRGLRGLRGLRGLRLR!!','',0,0,0,0,0,0,0,0,1,0,416,0,26124),
(44508,'Archaeology is the search for fact. Not truth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44509,'If it\'s truth you\'re interested in, Cuddy Nordlinger\'s Philosophy class is right down the hall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44510,'So forget any ideas you\'ve got about lost cities, exotic travel, and digging up the world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44511,'You do not follow maps to buried treasure and \"X\" never, ever, marks the spot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44512,'Seventy percent of all archaeology is done in the library. Research. Reading.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44513,'We cannot afford to take mythology at face value.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44514,'Ahem! Well... ah, next week: \"Tanaris.\" Starting with the excavation of Broken Pillar by Marvon Rivetseeker in Year 22.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44515,'I will be here doing research if anybody\'s got any problems for the next hour and a half.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44516,'','%s flutters her eyelashes at Harrison Jones.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44517,'L\'ghorek, can you give me another Attuned Runestone of Binding?','L\'ghorek, can you give me another Attuned Runestone of Binding?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44518,'TRY NOT TO... LOSE... THAT ONE.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44519,'','%s laughs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44520,'Are you here to train in Archaeology?','Are you here to train in Archaeology?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(44521,'','I just love these wisps! They\'re so pretty!',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(44522,'','Quiet, Issara. Your chatter is going to get us killed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44523,'','Invaders have breached the sanctum halls!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(44524,'','Wake up you fools! We\'re under attack!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(44525,'','Welcome to Nethergarde, $c.  Call me \"Mama,\" I\'m here to take care of you.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44526,'Arch Geomancer, I am ready for the ritual.','Arch Geomancer, I am ready for the ritual.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44527,'','In death, we are reborn.',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(44528,'Abyssion is casting a powerful Shadow Nova, seek cover!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44529,'The First World Pillar Fragment drops from Abyssion\'s lifeless corpse!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44530,'Abyssion is snared!  Stay on the move to avoid his attacks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44531,'Do me know you? No matter. Me crush your bones!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44532,'NOOOOOOOOOoooooo....... not again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44533,'You must stay within the Talrendis Point attack area!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44534,'Please! Free the others from their Nets!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44535,'Once we are all free, we shall fly with you through Grim Batol!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44536,'The mutant goblin\'s tentacles break free and slither across the ground!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44537,'Ya\'ll need to find a different trainer, $c. I cannot help ya.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44538,'Return any time ya need trainin\'.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44539,'Zoram\'gar will be a new bastion of power against our enemies under my watch.$B$BGlory to the Horde! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44540,'','It\'s an honor to have a hero like you among us, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44541,'No, no, no... you took my family, but you won\'t take my land!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44542,'Get back, $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44543,'Why won\'t you leave us alone?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44544,'Get out of my kitchen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44545,'I must have lived a charmed life, $n.  To return to the world as a member of the Forsaken and the Apothecary Society... I couldn\'t have asked for a more suitable fate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44546,'Let...me...go...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44547,'You only...prolong...your doom...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44548,'You...will...burn...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44549,'Chaos...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44550,'Your efforts...are futile...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44551,'','The druids and sentinels prefer to keep separate company, but we have always worked well together.$B$BNever mistake privacy for aversion.',378,0,0,0,0,0,0,0,1,0,0,0,26124),
(44552,'','A beautiful city, is it not? As was Gilneas, in its time.$B$BBut such things pass, as shall we.  Only the earth and her secrets will remain.$B$BAre you willing to learn, $n?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(44553,'Now THAT\'s what I call oomph!  I wish all our potions did this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44554,'Climb the guard towers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44555,'Use the Accursed Ore to direct artillery fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44556,'The Quilboar here are too dangerous to get riled up over outside conflicts, $r. I cannot ward them off forever.$B$BWe must put a stop to their transgressions against nature.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44557,'Looks like you brought the whole fleet with you, $n!  And a pack of angry Brashtide to boot!$b$bI hope you\'re battle-ready, because these guys sure came packin\'.','',3,1,0,0,0,0,0,0,1,0,0,0,26124),
(44558,'I\'m getting too old for this!  There\'s too many of them!$b$b<Fleet Master Seahorn pauses to catch his breath.>$b$bWhat am I saying?  There\'s not enough of them!  HAVE AT YOU, YOU MANGY CURS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44559,'Aaaa-oooo! Aaaa-ooo! A pirate\'s life fer me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44560,'We pillage, we plunder, we steal sheep and fight, wolf out, me \'earties, aaa-ooo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44561,'We kidnap and ravage and rage by moonlight, drink up me \'earties, aaaa-ooo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44562,'We\'re alphas, we\'re playas, we\'re straight from Gilneas, wolf out, me \'earties, aaaa-ooo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44563,'We\'ll take Booty Bay or Firallon\'ll spay us, howl out, me \'earties, aaaa-ooo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44564,'We\'re mangy, we\'re matted, we\'re worgen and how, wolf out, me \'earties, aaaa-ooo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44565,'We sniff \'em an\' mark \'em and rip \'em to chow, sing out, me \'earties: aaaa-ooo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44566,'What? Of course not! I could easily escape this simple contraption, but I\'m much too busy. See, a while back I spent a few months inside the belly of a beast...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44567,'You were trapped, as I recall. This situation seems oddly similar.','You were trapped, as I recall. This situation seems oddly similar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44568,'It wasn\'t strictly voluntary, but I discovered something truly incredible. The beast seemed to be able to consume almost anything with no ill effects.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44569,'Gnomes in Lava Suits, for example.','Gnomes in Lava Suits, for example.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44570,'As a final act of revenge, Baron Geddon has made you a living bomb!  Move away from your allies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44571,'','That pygmy helm should fool them, at least for a little while. Get back to town!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44572,'Exactly. I ran some tests on the residual digestive fluid coating my suit and...\n\n<Finkle trails off>\n\nSay, you haven\'t seen my skinning knife anywhere, have you? I seem to have misplaced it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44573,'No. I, uh, haven\'t seen it. You were saying?','No. I, uh, haven\'t seen it. You were saying?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44574,'Oh yes, the bile; it\'s amazing stuff. With the proper catalysts it renders anything to which it\'s applied practically immortal*. I\'ve been harvesting it with my reprogrammed Bile-O-Tron 800 and I\'m certain I\'ve got the mixture right this time. I just need a few volunteers to test it out against a suitable creature. What do you say, friend?\n\n*Immortality subject to certain restrictions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44575,'','Begone. I have neither the ability nor the inclination to instruct you.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(44576,'','I will help you learn to wield the powers our enemies would deny us.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44577,'Restrictions? What restrictions?','Restrictions? What restrictions?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44578,'This is terrible, Durak! Saurfang will have nothing to do with you! What can we do?!','This is terrible, Durak! Saurfang will have nothing to do with you! What can we do?!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(44579,'Saurfang\'s involved, you say?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(44580,'Well then there is only one thing left to be done...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(44581,'They keep coming!  Push them back!  We must make sure we save as many Gilneans as possible!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44582,'This is all happening sooner than I would have liked.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(44583,'I need a horse to rescue Krennan.','I need a horse to rescue Krennan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44584,'I am afraid that you, $n, have outgrown your usefulness...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(44585,'Oops! That lever activates the Bile-O-Tron. Oh, and if you happen to come across a key...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44586,'Trick-or-treat!','Trick-or-treat!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44587,'Trick-or-treat!','Trick-or-treat!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(44588,'There are two: The Trader\'s Hall in the Trade District, and the Stormwind Auction House in the Dwarven District.','There are two: The Trader\'s Hall in the Trade District, and the Stormwind Auction House in the Dwarven District.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44589,'This is the kind of spirit I expected to see when we joined the Horde!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(44590,'Another courageous soul! I have a good feeling about this one...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(44591,'One of these is BOUND to get through!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(44592,'Dwarven District Auction House','Dwarven District Auction House',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44593,'The Bile-O-Tron springs to life and begins to emit a foul smelling substance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44594,'You\'ll find it in the northernmost part of the Dwarven District, near the Northern Landing.','You\'ll find it in the northernmost part of the Dwarven District, near the Northern Landing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44595,'There are two banks in the city: The Stormwind Counting House in the Trade District, and the Royal Bank of Stormwind in the Dwarven District.','There are two banks in the city: The Stormwind Counting House in the Trade District, and the Royal Bank of Stormwind in the Dwarven District.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44596,'Trade District Bank','Trade District Bank',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44597,'Dwarven District Bank','Dwarven District Bank',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44598,'Stormwind\'s Royal Bank is in the northernmost corner of the Dwarven District, just inside the Northern Landing.','Stormwind\'s Royal Bank is in the northernmost corner of the Dwarven District, just inside the Northern Landing.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44599,'%s snorts loudly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44600,'%s grunts and opens one eye.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44601,'%s wakes up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44602,'Stormwind\'s two most popular inns are located in the Trade and Dwarven Districts: The Gilded Rose and The Golden Keg.','Stormwind\'s two most popular inns are located in the Trade and Dwarven Districts: The Gilded Rose and The Golden Keg.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44603,'Trade District Inn','Trade District Inn',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44604,'Dwarven District Inn','Dwarven District Inn',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44605,'The Golden Keg is in the northen part of the Dwarven District, right by the fountain.','The Golden Keg is in the northen part of the Dwarven District, right by the fountain.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44606,'Mailboxes are scattered throughout the city. You can find one in front of any auction house, bank, or inn.','Mailboxes are scattered throughout the city. You can find one in front of any auction house, bank, or inn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44607,'Stormwind has many points of interest, from the Deeprun Tram to Stormwind Keep.$B$BWhat were you looking for?','Stormwind has many points of interest, from the Deeprun Tram to Stormwind Keep.$B$BWhat were you looking for?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44608,'There are stable masters in both Old Town and the Dwarven District.','There are stable masters in both Old Town and the Dwarven District.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44609,'Dwarven District Stable Master','Dwarven District Stable Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44610,'Old Town Stable Master','Old Town Stable Master',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44611,'Karin can be found in easternmost Stormwind, through the gates at the back of Old Town.','Karin can be found in easternmost Stormwind, through the gates at the back of Old Town.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44612,'Vendor','Vendor',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44613,'','Thank the waves, you\'re back! The others have already retreated, we need to get out of here!',0,0,0,0,0,0,1,0,1,9777,0,0,26124),
(44614,'The naga priestesses look to be summoning a near endless stream of reinforcements!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44615,'The assault looks like it did almost no damage at all. They\'re already back in formation!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44616,'','There were too many... our assault seems to have barely even scratched at their ranks. We lost so many men! Something must come of this...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44617,'Blast these beasts back to hell!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44618,'They keep coming!  Stand your ground!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44619,'Hold them back!  For Gilneas!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44620,'Hold your positions as long as you can!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44621,'Up you go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44622,'We\'re unda attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44623,'Da naga won\'t be givin\' up. We need to be findin\' our friends and takin\' the fight to dem.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44624,'I\'m going in after Erunak... alone if I have to!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(44625,'Remtravel has been a hero to the archaeology world for nearly 40 years. If he could only remember them, oh, the stories he would tell...','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(44626,'Well, I suppose I should go in there after him.$b$bCan\'t be any worse than facing Hellscream after this...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44627,'Auction House','Auction House',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44628,'Bank','Bank',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44629,'Inn','Inn',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44630,'With the destruction of Stormwind\'s park - and most of the night elves within, the poor, unlucky souls - your best bet would be to seek out old Celestine just outside the Dwarven District.$B$BThere are stairs leading down from the Northern Landing... you can see her cottage from there.','With the destruction of Stormwind\'s park - and most of the night elves within, the poor, unlucky souls - your best bet would be to seek out old Celestine just outside the Dwarven District.$B$BThere are stairs leading down from the Northern Landing... you can see her cottage from there.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44631,'There are hunters training in Old Town\'s Command Center as well as in the Dwarven District.','There are hunters training in Old Town\'s Command Center as well as in the Dwarven District.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44632,'Dwarven District Hunter Trainer','Dwarven District Hunter Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44633,'Old Town Hunter Trainer','Old Town Hunter Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44634,'You can always find a handful of hunters just outside Old Town\'s east gate.','You can always find a handful of hunters just outside Old Town\'s east gate.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44635,'Lion\'s Rest','Lion\'s Rest',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44636,'Lion\'s Rest is a place of contemplation and remembrance, a tranquil park dedicated in honor of those who have made the ultimate sacrifice on our behalf.','Lion\'s Rest is a place of contemplation and remembrance, a tranquil park dedicated in honor of those who have made the ultimate sacrifice on our behalf.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44637,'Stormwind Keep','Stormwind Keep',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44638,'The keep is in northren Stormwind.$B$BJust follow the canals north and you\'ll eventually come across a drawbridge... that leads into the keep\'s courtyard.','The keep is in northren Stormwind.$B$BJust follow the canals north and you\'ll eventually come across a drawbridge... that leads into the keep\'s courtyard.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44639,'The Stockade','The Stockade',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44640,'The prison? Why would you want to go there? It\'s in the center of the city, just northeast of the Mage Quarter.$B$BIf you\'re truly going there, be careful. I\'ve heard news of riots.','The prison? Why would you want to go there? It\'s in the center of the city, just northeast of the Mage Quarter.$B$BIf you\'re truly going there, be careful. I\'ve heard news of riots.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44641,'The caravan is uprotected - I\'m turning back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44642,'','I\'m sorry, I cannot train you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44643,'','How can I help you, $c?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44644,'We\'ve been hearing reports of elemental disturbances around Azeroth for some time now.  Our sources indicate that the phenomenon is not entirely natural, but we haven\'t quite been able to determine the source.  We have some theories though, but nothing concrete.$B$BKeep your eye out for any suspicious elemental activity as you walk around.  If you find anything worthwhile, please let an Earthen Ring Emissary know.  You can find us in any capital city.$B$BKeep your eye open.  Trouble is brewing.','We\'ve been hearing reports of elemental disturbances around Azeroth for some time now.  Our sources indicate that the phenomenon is not entirely natural, but we haven\'t quite been able to determine the source.  We have some theories though, but nothing concrete.$B$BKeep your eye out for any suspicious elemental activity as you walk around.  If you find anything worthwhile, please let an Earthen Ring Emissary know.  You can find us in any capital city.$B$BKeep your eye open.  Trouble is brewing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44645,'The elements in Azeroth are becoming more disturbed each passing day.  The key to this disturbance lies here, in Nagrand.  When Draenor was torn apart, all of the elemental planes were thrown into great turmoil and have never recovered.  The rifts here form naturally and are a sign of a severely damaged world.$B$BTo see this same kind of disruption on Azeroth is not just unnerving, it could be a precursor to a type of destruction the world has never seen before.$B$B$n, bring me any information you may find when walking around Outland.$B$BI must spend time with the elements here, researching a way to calm the elements again in Azeroth...before it\'s too late.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44646,'We\'re trying to find a solution to the growin\' elemental disturbances in Azeroth. Here in Nagrand, we see the same rifts formin\', but as a direct consequence of Draenor bein\' torn to shreds. They\'re a sign of a weakened planet and of an elemental plane in upheaval.$B$BYet, on Azeroth, there\'s no solid explanation for it.$B$BIf ya find any information about these rifts when adventurin\' in the Outland, please let us know. We\'ll continue to speak with the elements here and find a way to calm the elements in Azeroth...before it\'s too late.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44647,'Jewelcrafting','Jewelcrafting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44648,'Denman Family Jewelers, between the northern Trade District and The Canals, should have everything you\'re looking for.','Denman Family Jewelers, between the northern Trade District and The Canals, should have everything you\'re looking for.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44649,'Archaeology','Archaeology',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44650,'Harrison Jones teaches Archaeology in Stormwind Keep\'s Royal Library when not out in the field.','Harrison Jones teaches Archaeology in Stormwind Keep\'s Royal Library when not out in the field.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44651,'Profession vendors can always be found near their respective trainers. Other sorts of vendors are scattered throughout Stormwind.$B$BWhat were you looking for?','Profession vendors can always be found near their respective trainers. Other sorts of vendors are scattered throughout Stormwind.$B$BWhat were you looking for?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44652,'Champions\' Hall','Champions\' Hall',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44653,'The Champions\' Hall is located in the southeastern end of Old Town.$B$BThe Honor and Conquest quartermasters can be found there.','The Champions\' Hall is located in the southeastern end of Old Town.$B$BThe Honor and Conquest quartermasters can be found there.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44654,'Justice & Valor Quartermasters','Justice & Valor Quartermasters',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44655,'In the Command Center, just outside of Old Town\'s southeast gates, you\'ll find the quartermasters.','In the Command Center, just outside of Old Town\'s southeast gates, you\'ll find the quartermasters.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44656,'Honor & Conquest Quartermasters','Honor & Conquest Quartermasters',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44657,'Horse Breeder','Horse Breeder',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44658,'There are stables just beyond Old Town\'s southeast gates. You can find a riding trainer and a horse breeder there.','There are stables just beyond Old Town\'s southeast gates. You can find a riding trainer and a horse breeder there.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44659,'Gryphon Handler','Gryphon Handler',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44660,'If only I could get to the Launch Bay. Gimme one, just one, of those beautiful airborne machines and I could retake Gnomeregan and scare the goggles off of B.E Barechus at the same time!$B$BIf you need another parachute, we\'ve stored some in chests near the drop points.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44661,'Do you know of the Gryphon Roost off the Trade District, where the Flight Master may be found?$B$BA pair of Wildhammer dwarves raises and sells gryphons there, and can even train you to ride the beasts.','Do you know of the Gryphon Roost off the Trade District, where the Flight Master may be found?$B$BA pair of Wildhammer dwarves raises and sells gryphons there, and can even train you to ride the beasts.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44662,'We are bound by will to serve the Banshee Queen.','We are bound by will to serve the Banshee Queen.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44663,'Riding','Riding',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44664,'Flying','Flying',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44665,'','I\'ll even get you started.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44666,'You look exhausted. Is something wrong?','You look exhausted. Is something wrong?',0,0,0,0,0,0,378,0,1,0,0,0,26124),
(44667,'Good to see you.','Good to see you.',0,0,0,0,0,0,378,0,1,0,0,0,26124),
(44668,'Yes?','Yes?',0,0,0,0,0,0,378,0,1,0,0,0,26124),
(44669,'Have you recovered the final piece?','Have you recovered the final piece?',0,0,0,0,0,0,378,0,1,0,0,0,26124),
(44670,'Any luck with Therazane?','Any luck with Therazane?',0,0,0,0,0,0,378,0,1,0,0,0,26124),
(44671,'You look intent. Is there something I can help with?','You look intent. Is there something I can help with?',0,0,0,0,0,0,378,0,1,0,0,0,26124),
(44672,'Am I needed?','Am I needed?',0,0,0,0,0,0,378,0,1,0,0,0,26124),
(44673,'And I thought I might get a bit of rest. Silly me.','And I thought I might get a bit of rest. Silly me.',0,0,0,0,0,0,378,0,1,0,0,0,26124),
(44674,'We are joining an assault on Lorthuna\'s Gate. You are needed.','We are joining an assault on Lorthuna\'s Gate. You are needed.',0,0,0,0,0,0,378,0,1,0,0,0,26124),
(44675,'I\'m on my way.','I\'m on my way.',0,0,0,0,0,0,378,0,1,0,0,0,26124),
(44676,'Got it. I\'ll head there right away.','Got it. I\'ll head there right away.',0,0,0,0,0,0,378,0,1,0,0,0,26124),
(44677,'Elements be with us.','Elements be with us.',0,0,0,0,0,0,378,0,1,0,0,0,26124),
(44678,'Some action. Glad to hear it.','Some action. Glad to hear it.',0,0,0,0,0,0,378,0,1,0,0,0,26124),
(44679,'I\'m glad to hear we\'re fighting along side the Stonemother herself this time.','I\'m glad to hear we\'re fighting along side the Stonemother herself this time.',0,0,0,0,0,0,378,0,1,0,0,0,26124),
(44680,'That encampment has been begging for our attention. Let\'s get this done.','That encampment has been begging for our attention. Let\'s get this done.',0,0,0,0,0,0,378,0,1,0,0,0,26124),
(44681,'Exactly what I wanted to hear. Let\'s go.','Exactly what I wanted to hear. Let\'s go.',0,0,0,0,0,0,378,0,1,0,0,0,26124),
(44682,'Understood. I\'ll head there right away.','Understood. I\'ll head there right away.',0,0,0,0,0,0,378,0,1,0,0,0,26124),
(44683,'The blessed warmth of the sun courses through your veins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44684,'You not let them near fragment!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44685,'Kill them! Kill all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44686,'Crush them! I take fragment to Stone Mother.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44687,'We control World Pillar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44688,'Ignore Twilight\'s Hammer! They stupid. Kill other one, now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44689,'You not take World Pillar fragment from me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44690,'Therazane be happy to get middle fragment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44691,'Smash them! Then we join attack upon Temple of Earth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44695,'','Where is that ogre-headed buffoon?',0,0,0,0,0,0,6,1,1,10321,0,20459,26124),
(44696,'','Ah, speak of the devil...',0,0,0,0,0,0,1,1,1,10321,0,20460,26124),
(44699,'This better be important, Sylvanas. You know how I detest this place and its foul stench. Why have you called for me?','',0,0,0,0,0,0,0,1,1,10321,20496,0,26124),
(44700,'And more importantly, what are those Scourge fiends doing here?','',0,0,0,0,0,0,0,1,1,10321,20497,0,26124),
(44701,'','Warchief, so glad you could make it.',0,0,0,0,0,0,1,1,1,10321,0,20461,26124),
(44702,'','With the death of the Lich King, many of the more intelligent Scourge became... unemployed. Those \'fiends,\' as you so delicately put it, are called val\'kyr. They are under my command now...',0,0,0,0,0,0,0,1,1,10321,0,20462,26124),
(44703,'','...and they are part of the reason that I asked to see you.',0,0,0,0,0,0,1,1,1,10321,0,20463,26124),
(44704,'Get on with it, Sylvanas.','',0,0,0,0,0,0,1,1,1,10321,20498,0,26124),
(44705,'','Very well, Warchief. I have solved the plight of the Forsaken!',0,0,0,0,0,0,5,1,1,10321,0,20464,26124),
(44706,'','As a race, we Forsaken are unable to procreate.',0,0,0,0,0,0,274,1,1,10321,0,20465,26124),
(44707,'','With the aid of the val\'kyr, we are now able to take the corpses of the fallen and create new Forsaken.',0,0,0,0,0,0,0,1,1,10321,0,20466,26124),
(44709,'','Agatha, show the Warchief!',0,0,0,0,0,0,22,1,1,10321,0,20467,26124),
(44713,'ABBERATION!','',0,0,0,0,0,0,5,1,1,10321,0,0,26124),
(44714,'What you have done here, Sylvanas... it goes against the laws of nature. Disgusting is the only word I have to describe it.','',0,0,0,0,0,0,0,1,1,10321,20499,0,26124),
(44715,'','Warchief, without these new Forsaken my people would die out... Our hold upon Gilneas and northern Lordaeron would crumble.',0,0,0,0,0,0,0,1,1,10321,0,20468,26124),
(44716,'Have you given any thought to what this means, Sylvanas?','',0,0,0,0,0,0,6,1,1,10321,20500,0,26124),
(44717,'What difference is there between you and the Lich King now?','',0,0,0,0,0,0,6,1,1,10321,20501,0,26124),
(44718,'','Isn\'t it obvious, Warchief? I serve the Horde.',0,0,0,0,0,0,66,1,1,10321,0,20469,26124),
(44719,'Watch your clever mouth, bitch.','',0,0,0,0,0,0,397,1,1,10321,20502,0,26124),
(44720,'Cromush, you stay behind and make sure the Banshee Queen is well \"guarded.\" I will be expecting a full report when next we meet.','',0,0,0,0,0,0,0,1,1,10321,20503,0,26124),
(44721,'Remember, Sylvanas, eventually we all have to stand before our maker and face judgment. Your day may come sooner than others\'....','',0,0,0,0,0,0,0,1,1,10321,20504,0,26124),
(44728,'','Move quickly, $n. Your work will be for nothing if Mograine notices us before your work is done. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44729,'Twilight\'s Hammer has infiltrated my city. Left unchecked, they\'ll rot it to the core. Before we besiege their stronghold in the Highlands, I must be certain that Stormwind is safe from their machinations.$B$BI need more feet on the ground, reliable eyes and ears throughout the city. An experienced $c like yourself would be invaluable.$B$BAre you prepared to help Stormwind\'s cause?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(44730,'Tell me more about Deepholm and the World Pillar.','Tell me more about Deepholm and the World Pillar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44731,'My name ISN\'T FRONKLE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44732,'Veer left!','',4,0,0,0,0,0,4,0,1,0,0,0,26124),
(44733,'Look out for that turtle!','',22,0,0,0,0,0,22,0,1,0,0,0,26124),
(44734,'I\'ll have the Kickin\' Chimeroak Chops, extra kick!','',396,0,0,0,0,0,396,0,1,0,0,0,26124),
(44735,'Stop calling me Fronkle!','',18,0,0,0,0,0,18,0,1,0,0,0,26124),
(44736,'Dive!  Dive!  Dive!','',25,0,0,0,0,0,397,0,1,0,0,0,26124),
(44737,'','Tremble, crusaders, before the might of the Forsaken!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44738,'As you command, Warchief!','',0,0,0,0,0,0,66,1,1,10321,0,0,26124),
(44739,'','Flesh Rippers, hold the forward courtyard for our champions!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44740,'','The Scarlet Monastery belongs to the Forsaken now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44741,'','How does it feel to watch your men slaughtered by your mortal enemies, Inquisitor?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44742,'Welcome to Stormwind, $c.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44743,'<Anduin sizes you up.>$B$B$n, is it? A few of your triumphs have been the talk of the court.$B$BWhat was it like to serve in Northrend? Have you seen the World Tree? Are the stories about Vashj\'ir true? I have so many questions!','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(44744,'Come with me, your highness.','Come with me, your highness.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44745,'Could you forsee this, fool?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44746,'I\'ve always wondered what it would be like to be a druid. Where do your clothes go when you change into a bear?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44747,'So you\'re a hunter? My father has taught me to be pretty handy with a bow, myself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44748,'You\'re a mage, like Jaina Proudmoore? How long have you studied the arcane? It seems so difficult to master.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44749,'You\'re a paladin? Highlord Fordragon was, as well. He taught me a great deal. I... I still miss him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44750,'I\'m training to be a priest, myself. One day I hope I can command as much power as you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44751,'This is great, I never get to talk to Stormwind\'s rogues. They\'re always so quiet and secretive...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44752,'What\'s it like to be a shaman? I met Thrall once. My father doesn\'t trust him but he seemed very wise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44753,'Being a powerful warlock must be hard. Do you ever worry you\'ll lose control of one of your demons?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44754,'You\'re one of the fiercest-looking warriors I\'ve ever seen, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44755,'$n, I remember when you first came to see my father after the battle for Ebon Hold. I\'m glad you\'re still with us. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44756,'','Hey there, cutie!  Mind rubbing some lotion on my exposed areas?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44757,'Defilers! Wretches! Fiends! Begone from here!','',0,0,0,0,0,0,0,0,1,0,18911,0,26124),
(44758,'I send you to your deity.','',0,0,0,0,0,0,0,0,1,0,18913,0,26124),
(44759,'I take this life as an offering!','',0,0,0,0,0,0,0,0,1,0,18914,0,26124),
(44760,'Blazing rays of light, take me!','',0,0,0,0,0,0,0,0,1,0,18910,0,26124),
(44761,'Can you feel it? The blessed warmth of the sun?','',0,0,0,0,0,0,0,0,1,0,18912,0,26124),
(44762,'You fear that which you cannot control. But can you control your fear?','',0,0,0,0,0,0,0,0,1,0,18553,0,26124),
(44763,'Embrace the end!','',0,0,0,0,0,0,0,0,1,0,18555,0,26124),
(44764,'Do you understand now?','',0,0,0,0,0,0,0,0,1,0,18556,0,26124),
(44765,'Yes! Harness... your... hatred.','',0,0,0,0,0,0,0,0,1,0,18552,0,26124),
(44766,'Behold as infinite darkness befalls your world!','',0,0,0,0,0,0,0,0,1,0,18554,0,26124),
(44767,'This chamber will flourish with your life energy!','',0,0,0,0,0,0,0,0,1,0,18571,0,26124),
(44768,'Wither away!','',0,0,0,0,0,0,0,0,1,0,18573,0,26124),
(44769,'Waste of energy.','',0,0,0,0,0,0,0,0,1,0,18574,0,26124),
(44770,'The cycle continues...','',0,0,0,0,0,0,0,0,1,0,18569,0,26124),
(44771,'Your life, UNLEASHED!','',0,0,0,0,0,0,0,0,1,0,18572,0,26124),
(44772,'','Gaze to the heavens! What do you see?',0,0,0,0,0,0,0,0,1,0,0,18843,26124),
(44773,'','The glimmer of your life, extinguished.',0,0,0,0,0,0,0,0,1,0,0,18846,26124),
(44774,'','Insignificant!',0,0,0,0,0,0,0,0,1,0,0,18847,26124),
(44775,'','Eons of darkness... by your hand.',0,0,0,0,0,0,0,0,1,0,0,18842,26124),
(44776,'','My luster... wanes.',0,0,0,0,0,0,0,0,1,0,0,18844,26124),
(44777,'','Bask in my radiance!',0,0,0,0,0,0,0,0,1,0,0,18845,26124),
(44778,'More carrion for the swarm...','',0,0,0,0,0,0,0,0,1,0,18906,0,26124),
(44779,'Dust to dust.','',0,0,0,0,0,0,0,0,1,0,18907,0,26124),
(44780,'Ptah... is... no more...','',0,0,0,0,0,0,0,0,1,0,18905,0,26124),
(44781,'The earth TREMBLES!','',0,0,0,0,0,0,0,0,1,0,18908,0,26124),
(44782,'Turn back, intruders! These halls must not be disturbed!','',0,0,0,0,0,0,0,0,1,0,18580,0,26124),
(44783,'A product of your own insolence.','',0,0,0,0,0,0,0,0,1,0,18583,0,26124),
(44784,'What... have you... done?','',0,0,0,0,0,0,0,0,1,0,18579,0,26124),
(44785,'Beacons of light, bestow upon me your aegis!','',0,0,0,0,0,0,0,0,1,0,18581,0,26124),
(44786,'I regret nothing.','',0,0,0,0,0,0,0,0,1,0,18582,0,26124),
(44787,'I trust you and my son are getting along? Anduin is anything but shy.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44788,'Final stop, the Forsaken Front! EVERYBODY OUT!','Final stop, the Forsaken Front! EVERYBODY OUT!',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(44789,'When Stormwind is secure, we will take this fight to the Highlands.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44790,'This is a one way trip, kid, and you definitely don\'t want to be comin\' back on the other wagon.','This is a one way trip, kid, and you definitely don\'t want to be comin\' back on the other wagon.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(44791,'Begone infidels, you are not welcome here!','',0,0,0,0,0,0,0,0,1,0,19735,0,26124),
(44792,'Death is only the beginning!','',0,0,0,0,0,0,0,0,1,0,19733,0,26124),
(44793,'May peace find you now.','',0,0,0,0,0,0,0,0,1,0,19738,0,26124),
(44794,'The heavens take you!','',0,0,0,0,0,0,0,0,1,0,19736,0,26124),
(44795,'Kneel before me and repent!','',0,0,0,0,0,0,0,0,1,0,19737,0,26124),
(44796,'ALL ABOARD! Next stop: The Sepulcher.','ALL ABOARD! Next stop: The Sepulcher.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(44797,'ALL ABOARD! Last stop: The Forsaken Front!','ALL ABOARD! Last stop: The Forsaken Front!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(44798,'Make your time, mortals.  You will never defeat the Occulus!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44799,'Such insolence....such arrogance...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44800,'We control the ebb and flow of time!  The Infinite Dragonflight cannot be defeated!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44801,'My former brethren, your time draws short!  Join us, before you are lost to the sands of eternity!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44802,'The sands of time count out the days to your annihilation!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44803,'Children of Nozdormu, hear me!  The folds of time are innumerable, and we are many!  You will not, can not, defeat us all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44804,'','The cult is upon us! We need help in the Respite Chambers!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44805,'We\'ve retaken the Idol of Akil\'darah thanks to you, $n! Come over here and I\'ll take you deep into Jintha\'Alor on the winds of her blessin\'!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44806,'The eagle spirit of the Hinterlands be on our side now, $n.$B$BWith her idol free from the Vilebranch, I can transport you straight to it on the upper tier of Jintha\'Alor. Strike at their hearts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44807,'','Hi. Welcome to my salon.$B$BYou look great! But if you\'re in the mood for a change, just sit right down in one of the chairs.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44808,'Sharpbeak\'s the finest gryphon in Aerie Peak. He\'ll get you right to the top of Jintha\'Alor, and we\'ll take the top terraces in no time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44809,'','We must take what is ours. Our survival depends on it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44810,'I need to get to the top of Jintha\'Alor. Time to ride Sharpbeak!','I need to get to the top of Jintha\'Alor. Time to ride Sharpbeak!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44811,'','Anastasia, stay close please. We\'ll go do something fun soon.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44812,'','You\'re going to have a play date with William and Donna later. How does that sound?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44813,'','I saw Little Timmy the other day, Ana. Would you like a kitten?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44814,'','We\'ll go ice skating as soon as the lake freezes over, honey.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44815,'The Scarlet Crusade will return to its noble roots!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44816,'','We\'re going to do little Andi\'s braids soon. Would you like your\'s done too, sweetie?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44817,'','Ana, ten more minutes, then you need to wash up. We\'re having your favorite. Mac and cheese.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44818,'','Ana, how would you like to go down to the harbor in a little while?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44819,'','I\'m going to be giving the king a haircut tomorrow. Would you like to come and meet him, Ana?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44820,'I know this looks grim, but our enemies will pay for what they have done. I\'ll make sure they do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44821,'If one such as I can be captured by that lumbering oaf, then you must be brave indeed to venture here.\n\nIf you can distract Halfus and break the chains binding me then I will fight alongside you.\n\nMy ability to slow the passage of time in an area will help you evade the Proto-Behemoth\'s Fireball Barrage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44822,'Gryphon Master Talonaxe has ordered me sent to Stormfeather Outpost!','Gryphon Master Talonaxe has ordered me sent to Stormfeather Outpost!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44823,'','Awesome!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44824,'','Whatever.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44825,'','Cool.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44826,'','Yah, mom... woooo!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44827,'','No way.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44828,'','Oh yah, uh huh.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44829,'','\'kay.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44830,'','Yes!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(44831,'','You will speak when spoken to.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44832,'Ozumat is back! Oh noes~ [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44833,'Enough of this... ITS GO TIME! [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44834,'We win! Heres some loot, thx. [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44835,'Thanks. That beast was a handful!','Thanks. That beast was a handful!',0,0,0,0,0,0,1,1,1,10335,0,0,26124),
(44836,'That beast came from nowhere!','That beast came from nowhere!',0,0,0,0,0,0,5,1,1,10335,0,0,26124),
(44837,'Worgen filth! I spit on your corpse!','Worgen filth! I spit on your corpse!',0,0,0,0,0,0,14,1,1,10335,0,0,26124),
(44838,'They won\'t take our land without a fight!','They won\'t take our land without a fight!',0,0,0,0,0,0,15,1,1,10335,0,0,26124),
(44839,'Thank you, hero!','Thank you, hero!',0,0,0,0,0,0,71,1,1,10335,0,0,26124),
(44840,'','We\'re trying to find out what\'s so important up at the Masters\' Gate.$B$BI just know that those Hammer jerks are up to no good. No fair! We came all this way following a clue and now we can\'t even get close.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44841,'','I am the mistress of the skies, and they who threaten my children shall suffer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44842,'Well done, $n!  Thunder Bluff is in your debt.','Well done, $n!  Thunder Bluff is in your debt.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44843,'Well done, $n!  Orgrimmar is in your debt.','Well done, $n!  Orgrimmar is in your debt.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44844,'Well done, $n!  Ironforge is in your debt.','Well done, $n!  Ironforge is in your debt.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44845,'All hail, $n, a true champion and protector of Thunder Bluff!  Let no one forget the brave deeds performed by, $n!','All hail, $n, a true champion and protector of Thunder Bluff!  Let no one forget the brave deeds performed by, $n!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(44846,'Lok\'tar! Let no one forget the name, $n, a true champion of Orgrimmar!  All hail $n!','Lok\'tar! Let no one forget the name, $n, a true champion of Orgrimmar!  All hail $n!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(44847,'All hail, $n, a true champion and protector of Ironforge!  Let no one forget the brave deeds performed by, $n!','All hail, $n, a true champion and protector of Ironforge!  Let no one forget the brave deeds performed by, $n!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(44848,'Thank you... I wish I could help you find the forgemaster.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44849,'The forgemaster\'s a terrible murderer.  Are you sure you want to go looking for him?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44850,'Ah, yes... I know about the forgemaster!  I just overheard that he\'s not in the camp right now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44851,'The forgemaster is meeting with the Twilight leadership.  Trust me, I traded some gossip for a loaf of stale bread!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44852,'I don\'t know nothin\' bout no forgemaster.  Now tell me where this safe place you came from is!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44853,'I heard the forgemaster keeps notes about his meetings  in a book at the tower overlooking the camp.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44854,'','Call me Twin. That\'s what Mowi calls me.$B$BNo, we don\' look alike. Are ye blind? She\'s a gnome fer the Light\'s sake! We act alike. \'specially when we\'re fightin\'.$B$BAs fer my name... have ya na heard o\' the storied Wildhammer Brewers? Care fer a pint?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44855,'Ouch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44856,'Oof!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44857,'Ow, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44858,'It burns!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44859,'Yowch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44860,'Stop dat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44861,'It burns like the moon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44862,'Cut it out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44863,'Leap!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44864,'Pounce!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44865,'Attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44866,'Meow!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44867,'Get back over here, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44868,'Here comes Zen\'Kiki!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44869,'Rawr!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44870,'Haha!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44871,'','The Twilight\'s Hammer has most certainly uncovered something of interest up at the Masters\' Gate.$B$BPerhaps a $g skilled : lovely; $c such as yourself would help me with that?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44872,'As my lovely companion may have already enlightened you, we are in pursuit of something mysterious and powerful. All of our clues point to the Masters\' Gate.$B$BUnfortunately, the nihilistic cultists known as the Twilight\'s Hammer have prevented our attempts to research the area. Surely a $c with your reputation can assist the Reliquary in its time of need?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44873,'I\'ll get him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44874,'Am I hitting him?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44875,'Rawr!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44876,'Maul!  Swipe!  MANGLE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44877,'Zen\'Kiki is in control!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44878,'Get over here, you coward!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44879,'No, hit me!  Over here, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44880,'I got dis one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44881,'Shapeshift!  Here come de moonfire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44882,'Shapeshift!  Get ready for de moonfire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44883,'Shapeshift!  Here it comes, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44884,'Shapeshift!  Zen\'Kiki\'s ready to pounce!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44885,'Shapeshift!  Time for cat form!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44886,'Shapeshift!  Get ready to taste my claws!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44887,'Shapeshift!  Zen\'Kiki will absorb de damage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44888,'Shapeshift!  Time for bear form!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44889,'Shapeshift!  Over here, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44890,'Shapeshift!  Uh oh... wait a minute here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44891,'Shapeshift!  Oh no!  Not again...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44892,'Shapeshift!  Try to swim away now, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44893,'A little help here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44894,'I seem to be... stuck...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44895,'Zen\'kiki\'s real sorry about this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44896,'This isn\'t right.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44897,'Can Zen\'Kiki get a little nudge?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44898,'Why you guys upside down?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44899,'harshly interrogates a cowering dock worker.','harshly interrogates a cowering dock worker.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44900,'Can I help you with the Twilight\'s Hammer investigation? We don\'t have to tell my father...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44901,'There you are, $n! I thought you\'d forgotten about me.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(44902,'Eliminate all murlocs by using the Blight Concoction!$B$B|r|TInterface\\Icons\\INV_ALCHEMY_POTION_05.BLP:24|t','Eliminate all murlocs by using the Blight Concoction!$B$B|r|TInterface\\Icons\\INV_ALCHEMY_POTION_05.BLP:24|t',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(44903,'Returning to Forsaken High Command!$B$B|r|TInterface\\Icons\\ACHIEVEMENT_ZONE_SILVERPINE_01.BLP:24|t','Returning to Forsaken High Command!$B$B|r|TInterface\\Icons\\ACHIEVEMENT_ZONE_SILVERPINE_01.BLP:24|t',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(44904,'What do you want? Can\'t you see I have bat droppings to clean up?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(44905,'I need to take a bat to the Dawning Isles.','I need to take a bat to the Dawning Isles.',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(44906,'You better bring that bat back in one piece, $n!','',1,6,0,0,0,0,25,0,1,10339,0,0,26124),
(44907,'Lorthuna is preparing a powerful spell - get behind cover!','Lorthuna is preparing a powerful spell - get behind cover!',0,0,0,0,0,0,0,0,1,0,20941,20941,26124),
(44908,'Twilight\'s Hammer? I don\'t know anything! Why are you asking me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44909,'I don\'t know anything about a cult! Please let me get back to work...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44910,'Tw- Tw- Twilight\'s Ha- Hammer? Keep them away from me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44911,'What, that crazy end-of-the-world cult? If I hear anything, you\'ll be the first to know!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44912,'What are you asking me for? I just schlepp boxes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44913,'I swear that guy was dead when I found him! What - oh - Twilight\'s Hammer? No, I don\'t know anything about that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44914,'I haven\'t heard a thing. I swear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44915,'I\'m innocent. Innocent I tell you! The Cataclysm isn\'t my fault!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44916,'Yarrr!','Yarrr!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44917,'Avast!','Avast!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44918,'Ahoy!','Ahoy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44920,'','Your presence is not welcome here, Amnennar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44921,'|TInterface\\Icons\\spell_nature_earthquake.blp:20|t%s begins to cast |cFFFF0000|Hspell:83445|h[Shockwave]!|h|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44922,'','What brings you inside these cursed lands?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44923,'The Twilight\'s Hammer has unearthed a titan Waygate and it appears that they\'re attempting to activate it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44924,'With the death of the Lich King, all I have left is my duty.  There is no family, there are no friends... there is only this.$b$bWar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44925,'Hmmmm... no valuable information there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44926,'You really have a way with people, $n. They fear and respect you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44927,'Does this feel like a wild goose chase to you? These workers don\'t know anything!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44928,'MORE Ghaz\'ridian?  Why would you think I would want any MORE of those infernal things?  I\'m stuck with about nine thousand, and they\'re not selling!  Why did I ever think anyone would want a statue of an overgrown snake?  Pah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44929,'I saw the Wastewander and their leader, Caliph Scorpidsting, heading south of here.  Watch out, they look like they\'ve toughened up some!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44930,'I saw the biggest bug you\'ve ever seen wandering around one of those Silithid hives.  Or maybe it was both of them.  I think the heat\'s getting to me...do you see that sand kitten over there?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44931,'I don\'t know much about dragons, but a big, scary one showed up one day just over yonder, near the entrance to the Caverns of Time.  He kept yelling something about...what was it...the end of time as we know it?  I wasn\'t really paying much attention.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44932,'An old friend of mine named Frokle was supposed to be heading in to Gadgetzan, but him and the rest of the Bilgewater crew manning the ship never arrived.  I\'ve heard rumors of a crazy goblin that hangs out near a downed flying machine in the far south, could it be...?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44933,'I found a broken-down cart amongst the dunes when I was checking out the potential profitibility of Centipaar Silithid Snacks (patent pending).  I thought to myself, \"hey, free cart!\"  That is, until the biggest basilisk you\'ve ever seen showed up, and I had to leave the whole thing behind!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44934,'Have you seen those huge dirt mounds moving around beneath the dunes?  They belong to a species of tunneling worm the likes of which Azeroth has never seen!  I\'m sure that battling one would be a great learning experience for a seasoned adventurer such as yourself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44935,'When the Cataclysm happened, the links bounding elementals across Azeroth weakened significantly.  One such elemental, Aquementas, is no longer imprisoned.  I hear he\'s causing some major problems for the Southsea gang!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44936,'You\'ll never catch me alive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44937,'Are you often sent to gather things for people? I suppose a hero\'s work is never done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44938,'All of our explosives are missing!? $n, something sinister is definitely happening here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44939,'<The outhouse is silent.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44940,'Yorick, you in there? I\'m ready to do this! Let\'s go!','Yorick, you in there? I\'m ready to do this! Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44941,'Come fools. Come to your doom. The end of days is here!','',0,0,0,0,0,0,0,0,1,10350,0,0,26124),
(44942,'The titan Waygate is almost opened. We will assist the Tol\'vir to reconfigure Uldum and bring about the end of all life on Azeroth!','',0,0,0,0,0,0,0,0,1,10350,0,0,26124),
(44943,'We have labored long and hard for our lord Deathwing. Let us give our all in his name that we will bask in his flames at the end of days!','',0,0,0,0,0,0,0,0,1,10350,0,0,26124),
(44944,'Lord Deathwing\'s sundering of the Well of Eternity has brought down Uldum\'s defenses. Prepare yourselves. We will march through the Waygate soon!','',0,0,0,0,0,0,0,0,1,10350,0,0,26124),
(44945,'','How do you do, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44946,'Long ago, before the last great war, my father ran the Northridge Lumber Mill. It was his life, and he was committed to it. Then the war came, and as much as it pained him, we had to flee to Stormwind.$B$BWith the passing of the Scourge and the flight of the Scarlet Crusade, however... Northridge is ours again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44947,'Unimaginable power courses through me to the Waygate! Muahahahahahaha!','',0,0,0,0,0,0,0,0,1,10350,0,0,26124),
(44948,'Decrypt the final instructions. We activate the Waygate within the hour!','',0,0,0,0,0,0,0,0,1,10350,0,0,26124),
(44949,'There is an intruder amongst us. Destroy them! Nothing must interfere with Lord Deathwing\'s plan!','',0,0,0,0,0,0,0,0,1,10350,0,0,26124),
(44950,'It is true that we serve Deathwing, but we also serve a higher power. Never forget that!','',0,0,0,0,0,0,0,0,1,10350,0,0,26124),
(44951,'','We haven\'t got much time. Crowley will be arriving shortly. Let\'s go!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(44952,'Quit yer pokin\', mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44953,'Hey, that tickles, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44954,'Alright, here I go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44955,'','THERE! Hide in the armoire! I\'ll hide in the shadows next to you.',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(44956,'Ready to go, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44957,'Have you given any more thought to my proposal, Ivar?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(44958,'Return to Western Plaguelands or your mustang will kick you off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44959,'Why trust you now, Crowley? You abandoned us. Left us to die.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(44960,'If we\'re to win this war we will need your help. Our packs must unite! The Forsaken will destroy us otherwise.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(44961,'You are the alpha male, Ivar. The rest of the ferals in Silverpine will do as you command.','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(44962,'I don\'t care about your war, Crowley.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(44963,'But...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(44964,'I have seen firsthand what the Forsaken are capable of doing. It is true. They hunt us... slaughter the defenseless.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(44965,'So you will help?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(44966,'Aye, I will gather my pack... we...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(44967,'%s sniffs at the air.','',0,0,0,0,0,0,479,0,1,0,0,0,26124),
(44968,'It would appear that we are being watched, Crowley. You have grown soft... Likely Greymane\'s fault.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(44969,'Treacherous little pup!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(44970,'What say you now, spy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44971,'','I live... and die... for the Banshee Queen.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44972,'I was hoping you\'d say that...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44973,'I will prepare the pack. It will take some time to gather them all, but we will join... for now.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(44974,'You will be destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44975,'I\'M HIT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44976,'','$n, you\'ve returned! Is that the middle fragment?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44977,'I need more encrypted plans.','I need more encrypted plans.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44978,'What?! You\'re immune to my air magic?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44979,'My firebolt is useless! No matter you smug little insect. I will still destroy you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44980,'You\'re immune to my water spell! How can this be?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44981,'Th... thank you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44982,'\'Ey, mon!  You come to help Zen\'Kiki out?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44983,'Yes, Zen\'Kiki.  Let\'s go run some combat practice.','Yes, Zen\'Kiki.  Let\'s go run some combat practice.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44984,'Dis is a lot of fun, mon!  I love bein\' a druid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44985,'Zen\'Kiki, why don\'t you head back to the Menders\' Stead for a while?','Zen\'Kiki, why don\'t you head back to the Menders\' Stead for a while?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44986,'%s gasps.','%s gasps.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44987,'What IS this place? Ugh, and that smell...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44988,'Some sort of rituals were performed at this altar. It looks like a kind of pagan initiation ritual that Velen once told me about. Bloody. Disgusting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(44989,'Who do you think - wait - $n, look out behind you!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(44990,'Where to going, captain?','',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(44991,'Dis not so bad. Maybe little heavy, but me ok.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(44992,'OOF! Maybe trow little softer, captain?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(44993,'Heavy... no can see notin.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(44994,'Maybe captain carry one box too?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(44995,'Ugh... dese boxes too heavy. Dey might fall!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(44996,'Captain, pup need help!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(44997,'Dis giving me a hernia. Captain, what is hernia?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(44998,'ME NO SIGN UP FOR DIS! WAIT! Yes, me did sign up for dis.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(44999,'Please, captain, I can put box down?','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45000,'CAN NO SEE! WHERE TO GO!? WHAT DOING?!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45001,'Please... Kill... Me...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45002,'Dis hurt so bad. Like da time poop came out sideways.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45003,'NO MORE! DIS IS MAXI... MAXIMO... ME... DIS TOO MUCH!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45004,'Look out - I see another!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45005,'Fight them back - I can\'t hold this shield up much longer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45006,'$n, you did it. It looks like they\'re fleeing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45007,'I knew the puny ones weren\'t to be trusted!  Smash them!','',0,0,0,0,0,0,0,0,1,9625,0,0,26124),
(45008,'Agghh!  So many of them!','',0,0,0,0,0,0,0,0,1,9625,0,0,26124),
(45009,'You runts want to riot?  I\'ll show you!','',0,0,0,0,0,0,0,0,1,9625,0,0,26124),
(45010,'','Forgemaster!  I\'ve been informed the enemy has disrupted your operations.  Where is the fragment?',0,0,0,0,0,0,0,0,1,0,0,21623,26124),
(45011,'','Well done.  Meet me inside the Stonecore for further instructions.',397,0,0,0,0,0,0,0,1,0,0,21624,26124),
(45012,'','Let\'s just say we have friends in high places, forgemaster.',11,0,0,0,0,0,0,0,1,0,0,21625,26124),
(45013,'The fragment is now in the dragon\'s custody, ma\'am.','',0,0,0,0,0,0,0,0,1,0,20886,0,26124),
(45014,'Of course, ma\'am.  At once!','',0,0,0,0,0,0,0,0,1,0,20888,0,26124),
(45015,'If you don\'t mind me asking.  How did we manage to recover the fragment?  How did we infiltrate our enemies\' forces without their knowledge?','',0,0,0,0,0,0,0,0,1,0,20887,0,26124),
(45016,'You hear rustling of heavy wings in the distance.  The matriarch approaches!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45017,'Hey $n, we don\'t have to tell my father about that little ambush. If he finds out about an attempt on my life, he\'d never allow me out of that keep...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45018,'','Who\'s not drunk, Torok?',0,0,0,0,0,0,0,1,1,10439,0,0,26124),
(45019,'Including me?','',0,0,0,0,0,0,6,1,1,10439,0,0,26124),
(45020,'','Yes.',0,0,0,0,0,0,0,1,1,10439,0,0,26124),
(45021,'<hic!> Well... Let\'s see... By my count, nobody. The whole crew\'s drunk out of their gourds, admiral... \'cept the sea pups... <hic!>','',0,0,0,0,0,0,0,1,1,10439,0,0,26124),
(45022,'','I\'ll burn this place to the ground before I am shamed in the eyes of Hellscream!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45023,'I seem to have misplaced my sea pup, admiral. Do you have another that you could lend to me?','I seem to have misplaced my sea pup, admiral. Do you have another that you could lend to me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45024,'OOF!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45025,'Where to put? Dey falling! HELP!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45027,'This is the place. Samuelson\'s files should be on the third floor, all the way up the spiral staircase.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45028,'Here we go. Nobody here will question it if the Prince wants to glance through some files.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45029,'Hmmmm....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45030,'This is all wrong. There\'s nothing in here about the Twilight\'s Hammer. What is Samuelson playing at?','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(45042,'For the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45043,'For the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45044,'Enough of this.  The Cult of the Damned doesn\'t need Andorhal.  This worthless city is yours to fight over.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45045,'Koltira!  I had heard rumors that you were here in Lordaeron.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45046,'You heard correctly, Thassarian.  I wanted to give you a chance to kill me again.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45047,'%s laughs.','',0,0,0,0,0,0,153,0,1,0,0,0,26124),
(45048,'It looks like it may have to come to that.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45049,'Yes, it may... but not today.  With the Scourge out of the way, I plan to pull my troops back and regroup.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45050,'I see.  Then I will do the same.','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(45051,'But you must be aware, Koltira: we are brothers no longer.  You are a member of the Horde now, and I of the Alliance.','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(45052,'Eventually, we will fight this battle for Andorhal, and only one of us can walk off of this battlefield victorious.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45053,'Yes, I know.  And don\'t think I\'ll go easy on you.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(45054,'%s laughs.','',0,0,0,0,0,0,153,0,1,0,0,0,26124),
(45055,'Very well.  I look forward to it.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(45056,'You are not to speak to ANYONE about the agreement that was made today, $n.  Consider this an order from your direct superior.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45059,'I\'ll go back to the throne room and keep an eye on Samuelson while you speak with Mathias. Stay safe!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45061,'What\'sh with the huuuuge bush chick-a-doodle?','',0,0,0,0,0,0,6,1,1,0,0,0,26124),
(45062,'It\'sh makin\' me hungry... why\'s it shooo big? You shome kind of idiot or shomething? Makin\' a chicken sho big... Who doesh that?','',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(45063,'Forshaken do... that\'sh who...It\'sh sho big... Look at it\'sh big shtupid neck. I jusht want to choke it to death!','',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(45069,'Touch my chicken and I will kill you in your sleep. Am I understood?','',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(45075,'Here she comes, boss!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45076,'','There is little time for idle chatter. Our people are in crisis and every sin\'dorei has a role to play in our restoration.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45077,'Welcome to the party, $g pal:lady;!','',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(45078,'Thank you, friend. Let\'s kill us some overgrown... spiders. Sounded better in my head.','',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(45079,'We gotta find the matriarch of this operation and end her!','',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(45080,'I need a drink!','',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(45085,'I can instruct you in blacksmithing as well as supply the necessary tools.$B$BHow may I help you?','I can instruct you in blacksmithing as well as supply the necessary tools.$B$BHow may I help you?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(45086,'I can instruct you in fishing, and sell fishing poles and supplies.$B$BHow may I help you?','I can instruct you in fishing, and sell fishing poles and supplies.$B$BHow may I help you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45087,'','Your soul is mine.',0,0,0,0,0,0,457,0,1,0,0,0,26124),
(45088,'','Rise, Forsaken!',0,0,0,0,0,0,457,0,1,0,0,0,26124),
(45089,'','You serve the Banshee Queen now, mortal.',0,0,0,0,0,0,457,0,1,0,0,0,26124),
(45090,'','Death is only the beginning.',0,0,0,0,0,0,457,0,1,0,0,0,26124),
(45091,'','Rise, $n! Become Forsaken!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45092,'','Waste no time, $n. We mustn\'t keep the Banshee Queen waiting.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45093,'','Different master, same insatiable thirst for power.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45094,'','I sense doom in your future, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45095,'','The warmth of this place sickens me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45096,'','I long for the frozen wastes of Northrend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45097,'','Do you feel it, $n? The darkness surrounds us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45098,'','Life is meaningless. It is in the afterlife that we are truly tested.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45099,'','Through me the Banshee Queen sees all...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45100,'','He\'s coming.  Get ready, lads!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45101,'The Bishop moves diagonally!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45102,'Bishop threatens pawn...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45103,'Check!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45104,'The game isn\'t over yet...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45105,'Pawn ... takes ... bishop ...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45106,'I am Forsaken.','I am Forsaken.',0,0,0,0,0,0,66,1,1,0,0,0,26124),
(45107,'For the glory of the Dark Lady!','For the glory of the Dark Lady!',0,0,0,0,0,0,15,1,1,0,0,0,26124),
(45108,'Wha... What has happened?','Wha... What has happened?',0,0,0,0,0,0,6,1,1,0,0,0,26124),
(45109,'I am eternal... I am death.','I am eternal... I am death.',0,0,0,0,0,0,273,1,1,0,0,0,26124),
(45110,'At your command.','At your command.',0,0,0,0,0,0,66,1,1,0,0,0,26124),
(45111,'I LIVE!','I LIVE!',0,0,0,0,0,0,15,1,1,0,0,0,26124),
(45112,'What have you done to me!?','What have you done to me!?',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(45113,'The Black Bishop\'s shields dissipate as the wretched traitor breathes his last.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45114,'','Bow before your new master!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45115,'','Rise and destroy our enemies!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45116,'Thanks for helpin\' me out, mon!  No more shapeshifts for me... I\'m gonna work on my healing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45117,'The game is afoot! But you are a mere pawn, whereas I am ... THE BLACK BISHOP!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45118,'Checkmate.','',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(45119,'Greetings, young one, it is good to see a noble soul again.$B$BDire Maul, formerly Eldre\'thalas, is corrupt to its very core. I have watched my brethren fall to the forces of darkness and chaos. Many would have this place razed to the ground to end its horrors forever.$B$BBut Dire Maul is worth saving, mortal. Help me, and perhaps together we can unleash the vast power lost here for the forces of good, as they once were so long ago.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45120,'I can instruct you in fishing as well as offer helpful supplies.$B$BHow may I help you?','I can instruct you in fishing as well as offer helpful supplies.$B$BHow may I help you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45121,'I can instruct you in herbalism as well as offer helpful supplies.$B$BHow may I help you?','I can instruct you in herbalism as well as offer helpful supplies.$B$BHow may I help you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45122,'How may I be helpin\' ya, Child of de Earth?','How may I be helpin\' ya, Child of de Earth?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45123,'Dark is de jungle, but fertile is its soil.$B$BMay de spirits of de earth watch over ya, $c.','Dark is de jungle, but fertile is its soil.$B$BMay de spirits of de earth watch over ya, $c.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45124,'I wish to learn more of the earth spirits\' secrets. Please train me.','I wish to learn more of the earth spirits\' secrets. Please train me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45125,'Da Gordok no like Dagg\'thol, so he kill them. Da stupid trees and goat men no like Dagg\'thol, so he want kill them too.$B$BPuny $r like Dagg\'thol and help him take dis place for Master? Or does Dagg\'thol need kill you too?$B$BStupid tree keep staring at Ambassador Dagg\'thol...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45126,'I\'m completely out of supplies and the road is blocked by orcs, just my luck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45127,'They come!','They come!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45128,'Hurry, my lord! The enemy is upon us!','Hurry, my lord! The enemy is upon us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45129,'<The Major nods curtly.>','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(45130,'Back so soon, $n? Did you learn anything from the dockworkers?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(45131,'It\'s over, Samuelson. We know who you are and I put a stop to your little cathedral scheme.','It\'s over, Samuelson. We know who you are and I put a stop to your little cathedral scheme.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45132,'Don\'t we have ANY coffee left?','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45133,'How do I always end up with these assignments?','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45134,'Search for clues?  Here\'s a clue: it was the orcs.  Here\'s another clue: orcs smell.','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(45135,'My gut is telling me that it\'s about time we jump into action and start drinking.','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(45136,'Blasted lands - what a fitting name.  Blast this place, blast this keep, and blast the other identical keep.','',0,0,0,0,0,0,14,0,1,0,0,0,26124),
(45137,'I can\'t see!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(45138,'The underside of this table is REALLY dirty!','',0,0,0,0,0,0,479,0,1,0,0,0,26124),
(45139,'I wonder if Ma Stonefield ever fixed the lock on that window...','',0,0,0,0,0,0,479,0,1,0,0,0,26124),
(45140,'Orcs!  It\'s the orcs!  No, wait, it\'s just Krolan\'s stomach again.','',0,0,0,0,0,0,430,0,1,0,0,0,26124),
(45141,'Yes... yes $c. It\'s all true. I am not ashamed. The powers I submit to make mortal kings look like insects.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45142,'I hate you, Nobsy.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45143,'I got a strange feelin\' in me gut, Commander.  Think it might have been that murloc fin soup?','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45144,'At least ye didn\'t have to leave a wife back in Ironforge.  I can\'t imagine what she\'s up to without me around.  Ya ken how ladies are around ore.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45145,'D\'ya think Enohar might be willin ta spot us a few barrels o\' brew?  Helps the mind focus on strategizin\'.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45146,'%s suddenly draws out a hidden dagger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45147,'But I am not yet finished. Death to the king!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45148,'Abyssion is approaching.  Get ready!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45149,'','I\'m down!  You must defeat him on your own!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45150,'Father, watch out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45151,'%s protects his father with Power Word: Shield.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45152,'No! I won\'t let you interfere!  My transformation is not yet complete!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45153,'Thank you for saving me!','Thank you for saving me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45154,'I need to get out of here!','I need to get out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45155,'I\'m free! Thank you!','I\'m free! Thank you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45156,'I thought I was going to die in there.','I thought I was going to die in there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45157,'It\'s lucky that you came along.','It\'s lucky that you came along.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45158,'I care far too deeply about redeeming Eldre\'thalas to deal with any other matter. War, strife, allegiances, none of it matters until this city is safe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45159,'May the light embrace you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45160,'Farewell, $n.  Send my regards to the good men and women at the Menders\' Stead.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(45161,'The Forsaken have broken through your defenses, magistrate.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45162,'You are out of time.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(45163,'A decision must be made!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45164,'Die in battle and be raised as a servant of the Forsaken or...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45165,'Drink in my blood and be reborn as worgen, immune to the depravity of the Forsaken.\n','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45166,'Help us destroy the Forsaken and retake Lordaeron for the Alliance!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45167,'We would rather die than be turned into worgen, but seeing as how even death provides no relief from the atrocities of this war...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45168,'We choose vengeance!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45169,'','I hope you have a strong stomach.  Travelling through the breach is not for the weak.',0,0,0,0,0,0,0,0,1,0,0,22606,26124),
(45170,'','We\'re at the center of the Maelstrom, the rift between Deepholm and Azeroth.  Watch as it threatens to tear your world apart!',0,0,0,0,0,0,0,0,1,0,0,22607,26124),
(45171,'','Let us hope Thrall and the others can contain it while you\'re inside.',0,0,0,0,0,0,0,0,1,0,0,22608,26124),
(45172,'','This is it!  Brace yourself!',0,0,0,0,0,0,0,0,1,0,0,22609,26124),
(45173,'','Deathwing\'s taint shall be wiped from Deepholm, and his Twilight cultists with it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45174,'The Alliance has successfully defended Tol Barad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45175,'','You made it!  Good!',0,0,0,0,0,0,4,0,1,0,0,22610,26124),
(45176,'','This is the Temple of Earth.  It\'s the most important structure in Deepholm.',0,0,0,0,0,0,0,0,1,0,0,22611,26124),
(45177,'Gods of shadow, lords of twilight ... give me strength!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45178,'Stone troggs are attacking!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45179,'Here come more stone troggs. Defend the catapult!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45180,'','There was once a Titan-made stone inside.  It was known as the World Pillar.  The name was literal.  It bore the weight of all the elemental and magnetic forces in Deepholm.',0,0,0,0,0,0,0,0,1,0,0,22612,26124),
(45181,' Looks like a last ditch effort by the stone troggs. Your destination is just around the corner!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45182,'','It was shattered when Deathwing broke through the dome above and created the rift between the two worlds.  All of Deepholm is going to collapse into Azeroth if we do not put the World Pillar back together.',0,0,0,0,0,0,0,0,1,0,0,22613,26124),
(45184,'','Run...',0,0,0,0,0,0,457,0,1,0,0,0,26124),
(45185,'','RUN!',0,0,0,0,0,0,457,0,1,0,0,0,26124),
(45186,'','The first fragment was going to be delivered to us by a Horde gunship known as the Storm\'s Fury.  It never made it here.',0,0,0,0,0,0,0,0,1,0,0,22614,26124),
(45187,'','We\'ve taken control of the temple and we\'re containing as much of the damage as we can.  Go inside and speak to Maruut; he\'s in charge.',0,0,0,0,0,0,0,0,1,0,0,22615,26124),
(45188,'The Horde has successfully defended Tol Barad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45189,'The Alliance has successfully taken Tol Barad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45190,'The Horde has successfully taken Tol Barad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45191,'','We are all counting on you.',0,0,0,0,0,0,0,0,1,0,0,22616,26124),
(45192,'Al\'golath mal shal\'nel... darkness consumes... ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45193,'','This way, $n. We will take them by surprise.',0,0,0,0,0,0,457,0,1,0,0,0,26124),
(45194,'I was in Ironforge during the takeover - it was chaos.$B$BNo wonder father gets so protective when I leave the keep. ','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45195,'We\'ve got to get out of here!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45196,'What WAS that thing?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(45197,'Hm?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45198,'How did you manage to get here on foot alive? You must be quite the hero to brave Dire Maul.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45199,'Alright, here we go!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45200,'Come in, mon... forget yer cares for a while!$B$BRest de body, rest de soul.','Come in, mon... forget yer cares for a while!$B$BRest de body, rest de soul.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45201,'','I have not always been the Banshee Queen, $n.',0,0,0,0,0,0,274,0,1,0,0,20470,26124),
(45202,'','And my people have not always been the Forsaken.',0,0,0,0,0,0,396,0,1,0,0,20471,26124),
(45203,'','Long ago this land comprised the northern kingdoms of Lordaeron, ruled by King Terenas Menethil.',0,0,0,0,0,0,396,0,1,0,0,20472,26124),
(45204,'','Terenas had a son named Arthas.',0,0,0,0,0,0,396,0,1,0,0,20473,26124),
(45205,'','Arthas... even saying his name makes my body quiver in rage.',0,0,0,0,0,0,396,0,1,0,0,20474,26124),
(45206,'','This man-child, Arthas, took for himself a cursed blade known as Frostmourne.',0,0,0,0,0,0,396,0,1,0,0,20475,26124),
(45207,'','Through Frostmourne, Arthas killed his own father and razed this land along with every living creature in it!',0,0,0,0,0,0,396,0,1,0,0,20476,26124),
(45208,'','My own death came at the hands of Arthas when he and his armies sacked my homeland, Quel\'Thalas, and murdered my people.',0,0,0,0,0,0,1,0,1,0,0,20477,26124),
(45209,'','In his vast cruelty, Arthas severed my spirit from my body and raised me as a banshee to serve in his Scourge army.',0,0,0,0,0,0,1,0,1,0,0,20478,26124),
(45210,'','A similar fate befell all that would die to the Scourge war machine.',0,0,0,0,0,0,5,0,1,0,0,20479,26124),
(45211,'','Cleanse your soul in the flames of the abyss!',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(45212,'','Repent, mortals!  Repent in the face of unstoppable annihilation!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45214,'','Bow down before your superiors, and you may yet survive the destruction of this puny world!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45215,'','Sacrifice the nonbeliever!  In the name of Sargeras!',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(45216,'','The eyes of the great lord Sargeras can see your betrayal, your desires, your utter destruction!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45217,'','In death, they were reborn as mindless undead.',0,0,0,0,0,0,1,0,1,0,0,20480,26124),
(45218,'','But Arthas was not invincible! With each passing day his power waned - his grip over the will of the damned loosening.',0,0,0,0,0,0,5,0,1,0,0,20481,26124),
(45219,'','It was when Arthas was at his weakest that I struck!',0,0,0,0,0,0,1,0,1,0,0,20482,26124),
(45220,'','And though the hour of his atonement had come, the worm managed to escape his fate, returning to the frozen wastes of Northrend.',0,0,0,0,0,0,1,0,1,0,0,20483,26124),
(45221,'','With Arthas gone, so too was the control he held over the undead masses of Lordaeron. After recovering my body, I freed the remaining Scourge that were left behind.',0,0,0,0,0,0,1,0,1,0,0,20484,26124),
(45222,'','From the cruelty and mercilessness of Arthas, the man who would be the Lich King, the Forsaken were born.',0,0,0,0,0,0,1,0,1,0,0,20485,26124),
(45223,'','Our goal... Our sole purpose was to destroy the Lich King. We threw our lot in with the Horde and began our journey towards redemption.',0,0,0,0,0,0,1,0,1,0,0,20486,26124),
(45224,'','Now the Lich King is dead and we have returned. ',0,0,0,0,0,0,1,0,1,0,0,20487,26124),
(45225,'','The people who called this land their home in life, do so in death as well.',0,0,0,0,0,0,1,0,1,0,0,20488,26124),
(45226,'','But the Alliance does not recognize our rights. They claim this land is their own while attempting to invalidate the claims of the founders of this kingdom.',0,0,0,0,0,0,1,0,1,0,0,20489,26124),
(45227,'','I will never allow it... Never!',0,0,0,0,0,0,274,0,1,0,0,20490,26124),
(45228,'','Lordaeron belongs to the Forsaken - always and forever.\n',0,0,0,0,0,0,5,0,1,0,0,20491,26124),
(45229,'','The materials I offer are rare and powerful.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45230,'You have proven capable. Resourceful. I think you will be the one to take the fight to the gyreworms where we cannot. You will be the one to make your way deep into the Crumbling Depths, the only place where we cannot pass.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45231,'INFERNO!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(45232,'The legion will conquer all!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(45233,'Go forth, minions of destruction, and bathe this world in the flames of the twisting nether!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45234,'The sky darkens with your impending demise!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45235,'The time has come!  March onward, and bring doom to the frightened denizens of this blasted land!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45236,'NOOOOOO! You tell Goldmine he\'s a dead goblin! Our contract is over!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45237,'The Stonescale Matriarch is snared!  Avoid her attacks by staying on the move!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45238,'Deepholm? I hate this place. Wait... you\'re not Initiate Goldmine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45239,'I know what you\'re after. I can sense it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45240,'This is not in my contract! Die, $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45241,'Um, Goldmine, I seem to have misplaced your fire totem.','Um, Goldmine, I seem to have misplaced your fire totem.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45242,'I\'m not made of fire totems, you know!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(45243,'Weldon is nothing more than a damned coward. He fled from the scourge and now dares to come here as if he were some sort of hero?$B$BBah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45244,'Don\'t listen to anything Alexi says. He was a fool to stay during the plague and now look at him - he\'s no better than the other abominations in this place.$B$BDon\'t fret, we will reclaim Scholomance and the surrounding lands for the last living son of Barov - the rightful heir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45245,'','Koltira!  Your queen summons you!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(45246,'Your highness.  I deliver to you... Andorhal.','',0,0,0,0,0,0,16,0,1,0,0,0,26124),
(45247,'','Enough of this insolence.  Do you think that I\'m blind to everything that goes on outside of the Undercity?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45248,'I... your majesty, we were victorious!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45249,'','No thanks to you.  Andorhal should have been ours days ago, when we defeated the Scourge.',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(45250,'','I know your secret, Koltira.  I\'m aware of your friendship with the Alliance death knight, Thassarian.',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(45251,'Y... your majesty...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45252,'','Arthas clearly failed when he created his death knights.  You are still weak.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45253,'','Fortunately, I have agents that can help you... erase this weakness.  Beneath the Undercity you go.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45254,'No!','',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(45255,'','Shh... quiet, death knight.  When I\'m finished with you, your fear will be gone.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45256,'','You can thank me later.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45257,'You\'re not thinkin\' about stealing my explosives again, are ya?','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(45258,'Just look at this place!$b$bIt\'s an archaeologist\'s dream...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45259,'How about you don\'t go runnin\' off with my explosives this time, okay?','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(45260,'I\'d love to stop and chat awhile, but these explosives aren\'t going to move themselves...','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(45261,'The triumphant $g hero : heroine; returns!$B$BYou haven\'t seen Magmatooth around, have you?$B$B<The initiate looks worried.>','',4,430,0,0,0,0,0,0,1,0,0,0,26124),
(45262,'','Keep starin\', I don\'t get any prettier.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45263,'DEBUG Event Sent - North - Horde Progress','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45264,'DEBUG Event Sent - North - Alliance Progress','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45265,'DEBUG Event Sent - North - Horde Contested','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45266,'DEBUG Event Sent - North - Alliance Contested','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45267,'The rifts are down and Thunder Bluff is safe!  These portals must be the second half of their attack.$B$BQuickly! Into the portal! We must press the attack while we have the advantage!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45268,'DEBUG Event Sent - North - Horde Neutral','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45269,'DEBUG Event Sent - North - Alliance Neutral','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45270,'DEBUG Event Sent - North - Alliance Win','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45271,'DEBUG Event Sent - North - Horde Win','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45272,'They can drain the Loch until it\'s little more than a drip of mud, and we\'ll still fight to keep it ours.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45273,'','$n, may I have a moment of your time?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45274,'De secrets I have ta share would blast your soul apart, $c.$B$BTrust me: You be wantin\' ta talk ta someone else about trainin\'.','De secrets I have ta share would blast your soul apart, $c.$B$BTrust me: You be wantin\' ta talk ta someone else about trainin\'.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45275,'Who knows what dark an\' horrid tings be gibberin\' in de outer darkness... tings dat\'d drive a soul mad ta see?$B$B-We- be knowin\'. An\' you\'ve come lookin\' ta know -more,- haven\'t ya?','Who knows what dark an\' horrid tings be gibberin\' in de outer darkness... tings dat\'d drive a soul mad ta see?$B$B-We- be knowin\'. An\' you\'ve come lookin\' ta know -more,- haven\'t ya?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45276,'Greetin\'s, $n.  Are ya here ta be learnin\' of de Hidden Arts?','Greetin\'s, $n.  Are ya here ta be learnin\' of de Hidden Arts?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45277,'Greetin\'s, $c.\n\nIt be a sad ting, de way de secrets of de world are hidden from ya: Time, Fate, de burnin\' stars an\' de cold, cold darkness between... never will ya know de truth of such tings!','Greetin\'s, $c.\n\nIt be a sad ting, de way de secrets of de world are hidden from ya: Time, Fate, de burnin\' stars an\' de cold, cold darkness between... never will ya know de truth of such tings!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45278,'Let me know when you\'re ready, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45279,'Just let me know when you\'re ready for the ritual, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45280,'Kill nearest mystic.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45281,'Prepare to die, $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45282,'You just let Zen\'Kiki know when you\'re ready!  I\'ll bring one of these birds down for ya!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45283,'AYYYIEEE!!','AYYYIEEE!!',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(45284,'Whoa... easy, now.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(45286,'Quick, $n! Into the chests!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(45287,'Good day, $g brave: fair; $c.  How can I be of service?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45288,'Have you noticed anything strange lately?  Any new customers in the blacksmith shop?','Have you noticed anything strange lately?  Any new customers in the blacksmith shop?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45289,'Well, let\'s see... I saw some drudges running away from that mine over there.  Said something about a spider.  New customers?  Well, there\'s Jeralee, the lovely young gnome, who bought an axe twice her size last week.  Oh, and Magus Bisp came by asking for armor.  Not sure why he\'d need plate armor...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45290,'Can I help you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45291,'Have you noticed anything strange lately?  Any new customers, buying anything suspicious?','Have you noticed anything strange lately?  Any new customers, buying anything suspicious?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45292,'What is this, an interrogation?  You\'re not one of Fordring\'s internal affairs guys, are you?$b$bWell, I\'ve got nothing to hide.  Let me look over my records.  Last week I sold a ball gown to Lieutenant Myner, which struck me as odd.  What else... Magus Bisp bought several dozen leather jerkins, which he couldn\'t give a reason for.  Oh, and Friar Burlingham came by to stock up on swimwear for his trip to Hardwrench Hideaway.  That\'s about it.$b$bNow if you don\'t mind, I have customers!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45293,'','Hello there, $c!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45294,'Hello, ma\'am.  Heard any interesting rumors lately?','Hello, ma\'am.  Heard any interesting rumors lately?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45295,'','Well, let\'s see.  I heard that Magus Bisp has been spending his time cooped up on top of his tower, working on some new spell, or something.$b$bI heard that Del Gahrron was planning on retiring and heading back to his farm.  He may have already left, in fact.$b$bOh, and I heard that there\'s some $r $c running around town, asking people all sorts of annoying questions!$b$bJust playing with you, love.  Hope that information helped.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45296,'May the Light watch over you, child.  And how may I help you this fine day?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45297,'I\'m looking for someone who may have stolen some supplies from Hearthglen.  Have any leads for me?','I\'m looking for someone who may have stolen some supplies from Hearthglen.  Have any leads for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45298,'Stolen supplies?  Well, let me think about it...$b$bI know a certain priest named Daria who took all the extra wine after last week\'s service, but didn\'t throw it out as I asked.  I believe she\'ll be apologizing soon, though.$b$b<Alphus winks at you.>$b$bI\'ve also heard an abnormal number of confessions this week from one of the mages... what was his name?  Crisp?  Lisp?  Something along those lines.$b$bNow, be on your way.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45299,'W-what are you doing up here, $r?  Can\'t you see you\'re interfering with OFFICIAL ARGENT CRUSADE BUSINESS!?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(45300,'I was just wondering what you knew about the gnolls to the south.  Someone has been giving them supplies to practice necromancy.','I was just wondering what you knew about the gnolls to the south.  Someone has been giving them supplies to practice necromancy.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(45301,'You\'ll pay with your life for interfering with my plans, you miserable scum!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(45302,'<Grunt>$b$bYou need something, $r?','<Grunt>$b$bYou need something, $r?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45303,'What is it?  I\'m a little busy here.','What is it?  I\'m a little busy here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45304,'I\'m training right now.  Can this wait?','I\'m training right now.  Can this wait?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45305,'Yes?','Yes?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45306,'Lieutenant Myner asked me to challenge you to a duel.','Lieutenant Myner asked me to challenge you to a duel.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45307,'Fine.  You want some of this?','Fine.  You want some of this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45308,'The time for the Crusade is now!','The time for the Crusade is now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45309,'Fine... but I won\'t hold back!','Fine... but I won\'t hold back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45311,'Get ready, \'cause here I come!','Get ready, \'cause here I come!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45312,'Well fought.','Well fought.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45313,'I suppose I need some more practice.','I suppose I need some more practice.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45314,'Mom was right... I\'ll NEVER make it into the Argent Crusade.','Mom was right... I\'ll NEVER make it into the Argent Crusade.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45315,'You win.  This time.','You win.  This time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45316,'%s fires up the Goblin Barbecue!  Get ready to party!','%s fires up the Goblin Barbecue!  Get ready to party!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45317,'You\'d be surprised how often that works.','',0,0,0,0,0,0,396,0,1,10432,0,0,26124),
(45318,'Hefting','Hefting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45319,'The fleet was mostly intact as it limped into harbor after our engagement with the Horde. We weighed anchor in the shadow of Highbank here to regroup.$B$BThen the naga came.$B$BScaly, glistening hands clambering up the anchor chains... dragging men, screaming, into the depths...$B$BThese are cursed shores, $n. Cursed. ','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45320,'Slaughter them, $c! Destroy as many naga as you can to honor those that fell.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(45321,'The broodmother flies above us! Do not fear, fleshling, I am called \"The Steady\" for a reason...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45322,'Jump from rock to rock to attract the attention of the Broodmother!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45323,'We cannot fail, $n.  The future of multiple worlds is at stake here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45324,'You no take crate!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45325,'Thanks... this\'ll give us a couple more hours of not running into the rocks.  No guarantees after that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45326,'Take me to Baradin Hold.','Take me to Baradin Hold.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45327,'Take me to the Slagworks.','Take me to the Slagworks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45328,'Take me to the Ironclad Garrison.','Take me to the Ironclad Garrison.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45329,'Throw me back up!','Throw me back up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45330,'Take me to the Warden\'s Vigil.','Take me to the Warden\'s Vigil.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45331,'Take me to the East Spire.','Take me to the East Spire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45332,'Take me to the West Spire.','Take me to the West Spire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45333,'Take me to the South Spire.','Take me to the South Spire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45334,'I must be going now...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45335,'Well, I\'ve said my goodbyes.  Time to move on.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45336,'I\'ve waited here for too long.  Time to say goodbye.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45337,'I... I think I\'m ready to leave now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45338,'Who are you?  What have you done to me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45339,'Get away from here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45340,'You thoughtless $r!  You\'ll pay for your interference!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45341,'Fool!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45342,'The rifts are down and Orgrimmar is safe!  These portals must be the second half of their attack.$B$BQuickly! Into the portal! We must press the attack while we have the advantage!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45343,'Sorry about my earlier rudeness. I was worried about my father. Friends?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45344,'I\'ll see to it that you get the middle fragment of the World Pillar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45345,'How may I assist you in the afterlife?','How may I assist you in the afterlife?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45347,'I am unable to assist you.','I am unable to assist you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45348,'Here she comes. Oh, foul temptress of the sea...','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45349,'Avert yer eyes! Don\'t look at her!','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(45350,'Don\'t listen to her voice!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45351,'Don\'t look at her... ruby red... soft... sensual lips! Oh...','',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(45352,'There! She reveals herself. Attack!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45353,'Inspecting','Inspecting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45354,'This crate looks like it was used to store weapons and armor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45355,'','Glad to have a chance to catch my breath. Thanks for the help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45356,'Thought I couldn\'t handle them? Don\'t let my size be follin\' ya. Anyway, thanks for the hand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45357,'','Good to see you again! Thanks for the hand. I\'ll be back on my feet in just a moment.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45358,'I can\'t see a thing with this mask on, but I\'m not about to tell HER that.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45359,'Weapons...armor...these are the keys to victory. Any warrior, no matter how strong, is essentially defenseless without them.$B$BI have crafted many a legend in my day, $r. You will find nothing like them in all of Azeroth. They are the key to my brethren\'s success.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45360,'Gory always wanted to be a farmer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45361,'Gory just happy to be in the sun.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45362,'Gory wants to help out on farm.  Gory already has his own scythe!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45363,'Gory not very good at planting, but Gory VERY good at reaping.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45364,'If you really want to help out, you can help me and my friends with some combat practice.','If you really want to help out, you can help me and my friends with some combat practice.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45365,'These so-called paladins won\'t let me through so I can see if any of the legendary Fras Siabi\'s famous tobacco remains in Stratholme! They\'re no better than the scourge, if you ask me.$B$BBetween you an\' me, I think their \'brotherhood of the light\' is a hoax. An elaborate ploy I tell ya!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45366,'You want to fight?  Alright, Gory fight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45367,'Gory give up!  You farmers fight more good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45368,'Come to die, have you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45369,'Shovel meet head!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45370,'You take a wrong turn, mon? Heh heh heh.\n\nWhat can I be helpin\' ya find?','You take a wrong turn, mon? Heh heh heh.\n\nWhat can I be helpin\' ya find?',153,396,0,0,3,0,0,1,1,0,0,0,26124),
(45371,'Don\'t see many a\' your kind \'round here, mon.\n\nWhat can I be helpin\' ya find?','Don\'t see many a\' your kind \'round here, mon.\n\nWhat can I be helpin\' ya find?',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(45372,'This rock is about to fall! Jump to another!','This rock is about to fall! Jump to another!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45373,'You be a LONG way from home, mon. Heh heh heh.\n\nWhat can I be helpin\' ya find?','You be a LONG way from home, mon. Heh heh heh.\n\nWhat can I be helpin\' ya find?',153,396,0,0,3,0,0,1,1,0,0,0,26124),
(45374,'Hey, mon. What can I be helpin\' ya find?','Hey, mon. What can I be helpin\' ya find?',70,0,0,0,0,0,0,1,1,0,0,0,26124),
(45375,'I\'ve been meaning to investigate this site.$b$bNo time like the present!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45376,'Barber','Barber',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45377,'Battlemasters','Battlemasters',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45378,'Class Trainer','Class Trainer',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45379,'Flight Master','Flight Master',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45380,'Guild Master & Vendor','Guild Master & Vendor',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45381,'Mailbox','Mailbox',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45382,'Profession Trainer','Profession Trainer',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45383,'Stable Master','Stable Master',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45385,'She\'s beautiful...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45386,'Ready then? Let\'s get a move on! Try and keep up, $n.','',0,0,0,0,0,0,6,0,1,10458,0,0,26124),
(45387,'Onward, brothers and sisters!','',0,0,0,0,0,0,25,0,1,10458,0,0,26124),
(45388,'What\'s this then?','',0,0,0,0,0,0,6,0,1,10458,0,0,26124),
(45389,'Your doom!','',0,0,0,0,0,0,25,0,1,10458,0,0,26124),
(45391,'BOMB! IT\'S A TRAP! RUN!','',0,0,0,0,0,0,5,0,1,10458,0,0,26124),
(45392,'I\'m ready, Doctor Jones!','I\'m ready, Doctor Jones!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45393,'I\'ve heard much about you, $n.  The world needs people like you now more than ever.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45394,'Remember this day as the day that Forteski saved your hide. Now run! Get back to Sylvanas!','',0,0,0,0,0,0,3,0,1,10458,0,0,26124),
(45395,'Hey der, mon.$B$BDid ya want ta be stablin\' yer pets, or were ya lookin\' for a lost companion?','Hey der, mon.$B$BDid ya want ta be stablin\' yer pets, or were ya lookin\' for a lost companion?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45396,'Hey der, mon.$B$BDid ya need help recoverin\' a lost companion?','Hey der, mon.$B$BDid ya need help recoverin\' a lost companion?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45397,'Sorry, $c.$B$BI ain\'t believin\' ya got de right mind for graspin\' de nature of portal magic.','Sorry, $c.$B$BI ain\'t believin\' ya got de right mind for graspin\' de nature of portal magic.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45398,'Hey der, mon.$B$BIf ya be ready, I can teach ya how ta be conjurin\' up a portal back ta dis place...','Hey der, mon.$B$BIf ya be ready, I can teach ya how ta be conjurin\' up a portal back ta dis place...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45399,'De auction house and bank be at de top of de tall building in de middle of de valley, mon.$B$BLook for Ziji and Makavu.','De auction house and bank be at de top of de tall building in de middle of de valley, mon.$B$BLook for Ziji and Makavu.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(45400,'You be wantin\' Sijambi, mon.$B$BShe be in de tall building in de middle of de valley.','You be wantin\' Sijambi, mon.$B$BShe be in de tall building in de middle of de valley.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(45401,'Right outside de valley\'s inn, mon.$B$BIt be de tall building in de middle.','Right outside de valley\'s inn, mon.$B$BIt be de tall building in de middle.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(45402,'Which ya be lookin\' for?','Which ya be lookin\' for?',6,0,0,0,0,0,0,1,1,0,0,0,26124),
(45403,'Hunter','Hunter',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45404,'Mage','Mage',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45405,'Priest','Priest',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45406,'Rogue','Rogue',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45407,'Warlock','Warlock',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45408,'Warrior','Warrior',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45409,'Druid','Druid',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45410,'Shaman','Shaman',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45411,'Mage & Portal','Mage & Portal',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45412,'The Brotherhood of the Light transcends the ability of any other group to eradicate affronts to the Light. We will take any actions necessary to rid the world of foul beasts like these undead. Nothing will stand in our way.$B$BAre you with us, or against us?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45413,'Witch Doctor Umbu spends his time walkin\' about de valley, tendin\' to de people and elemental spirits alike.$B$BLook for him around de central building.','Witch Doctor Umbu spends his time walkin\' about de valley, tendin\' to de people and elemental spirits alike.$B$BLook for him around de central building.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(45414,'Kuzari and Zanga are trainin\' headhunters on one of de small islets towards de southeast end of de valley, mon.','Kuzari and Zanga are trainin\' headhunters on one of de small islets towards de southeast end of de valley, mon.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(45415,'Break this unnatural thing!','Break this unnatural thing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45416,'You\'re polluting our new home!','You\'re polluting our new home!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45417,'To arms, brothers and sisters! They are destroying the land!','To arms, brothers and sisters! They are destroying the land!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45418,'Find your black gold somewhere else!','Find your black gold somewhere else!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45419,'There Will Be Blood!','There Will Be Blood!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45420,'Junk shot that thing!','Junk shot that thing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45421,'Cap it!','Cap it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45423,'No gold for oil!','No gold for oil!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45424,'Dey be on top of de tall building in de southeast end of de valley.','Dey be on top of de tall building in de southeast end of de valley.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(45425,'There are no emotions. There are no morals. There are no zealots.$B$BThere is only the Brotherhood.$B$BHere, in the very chapel where Uther the Lightbringer joined the Order of the Silver Hand, I, Korfax, Champion of the Light, will inspire fear into the fearless.$B$BNothing will curb my fury - not the Scarlet Crusade, not the Argent Dawn, not my brothers, not even you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45426,'Like an angel...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45427,'','This may look like a losing battle, but the Scarlet Crusade will prevail. I believe wholly in our capability to eradicate the scourge in Stratholme. And though I do not look favorably upon the Argent Dawn, the Brotherhood of the Light is much closer to how I like to work.$B$BEnough idle chatter, $c. Let\'s get started. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45428,'Shadow-Walker Zuru can help ya.$B$BYou\'ll find him on de lowest floor of de taller building in de southeast.','Shadow-Walker Zuru can help ya.$B$BYou\'ll find him on de lowest floor of de taller building in de southeast.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(45429,'Ku\'nanji, de Night-Stalker, is who yer lookin\' for.$B$BHe be just north of de Valley of Spirits\' central building.','Ku\'nanji, de Night-Stalker, is who yer lookin\' for.$B$BHe be just north of de Valley of Spirits\' central building.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(45430,'You be lookin\' for Sesebi, mon.$B$BShe most often be sleepin\' under de tree by old Umbehto, de fisherman, lookin\' like a big ol\' tiger.','You be lookin\' for Sesebi, mon.$B$BShe most often be sleepin\' under de tree by old Umbehto, de fisherman, lookin\' like a big ol\' tiger.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(45431,'You be crazy, mon, meddlin\' with dat bad mojo. But I ain\'t one ta stop ya.$B$BUnjari Feltongue is in de taller building in de southeast, past de shadow priest\'s shrine.','You be crazy, mon, meddlin\' with dat bad mojo. But I ain\'t one ta stop ya.$B$BUnjari Feltongue is in de taller building in de southeast, past de shadow priest\'s shrine.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(45432,'Cooking','Cooking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45433,'Zamja be de best cook in Orgrimmar, mon.$B$BYou can find her just south of de valley\'s central building. Batamsi sells de food Zamja makes, too, if ya just be hungry.','Zamja be de best cook in Orgrimmar, mon.$B$BYou can find her just south of de valley\'s central building. Batamsi sells de food Zamja makes, too, if ya just be hungry.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(45434,'Herbalism','Herbalism',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45435,'Jandi and Zeal\'aya work from a hut just north of de valley\'s central building.$B$BDey can help ya wit\' whatever ya need, mon.','Jandi and Zeal\'aya work from a hut just north of de valley\'s central building.$B$BDey can help ya wit\' whatever ya need, mon.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(45436,'Fishing','Fishing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45437,'AAAAAAAAAALLLLLLLLLLEEEEEEEEE!!! ARRRRRRRRGGGHHHH!','',0,0,0,0,0,0,15,0,1,10466,0,0,26124),
(45438,'Crush and clobber! Bobber slobber!','',0,0,0,0,0,0,5,0,1,10466,0,0,26124),
(45439,'HELL OF A KICK TO THAT ALE!','',0,0,0,0,0,0,5,0,1,10466,0,0,26124),
(45440,'My power has returned!','',0,0,0,0,0,0,5,0,1,10466,0,0,26124),
(45441,'ORC NEEDS PEANUTS!','',0,0,0,0,0,0,5,0,1,10466,0,0,26124),
(45442,'I may or may not have pissed myself.','',0,0,0,0,0,0,5,0,1,10466,0,0,26124),
(45443,'Old Umbehto be on a lil\' islet east of de valley\'s central buildin\'.','Old Umbehto be on a lil\' islet east of de valley\'s central buildin\'.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(45444,'General Goods','General Goods',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45445,'Trade Supplies','Trade Supplies',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45446,'Poisons & Reagents','Poisons & Reagents',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45447,'Pet Snakes','Pet Snakes',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45448,'Huju and Xen\'to can take care of ya.$B$BFind dem in de valley\'s central building, mon.','Huju and Xen\'to can take care of ya.$B$BFind dem in de valley\'s central building, mon.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(45449,'','Kneel, Alliance!  Kneel before the might of the Forsaken!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45451,'Hold fast, $c. This is for yer own protection.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45452,'A small group of us, druids and sentinels, have come to aid the tauren of Freewind Post with our common enemy: the Grimtotem Clan.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45453,'The East Spire has been heavily damaged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45454,'The East Spire has been destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45455,'Xan\'tish and his snakes are slitherin\' around de valley\'s central building, mon.','Xan\'tish and his snakes are slitherin\' around de valley\'s central building, mon.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(45456,'The West Spire has been destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45457,'The West Spire has been heavily damaged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45458,'The South Spire has been heavily damaged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45459,'The South Spire has been destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45460,'','They attacked us when the waters rushed in! It was almost as if they knew what was going to happen.$B$BThey should all suffer for what they\'ve done.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45461,'','You, too, shall serve!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45462,'The Alliance has lost control of the Ironclad Garrison!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45463,'The Alliance has gained control of the Ironclad Garrison!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45464,'The Horde has taken the Ironclad Garrison!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45465,'The Horde has lost the Ironclad Garrison!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45466,'The Alliance has lost control of the Slagworks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45467,'The Alliance has gained control of the Slagworks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45468,'The Horde has taken the Slagworks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45469,'The Horde has lost the Slagworks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45470,'The Alliance has lost control of Warden\'s Vigil!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45471,'The Alliance has gained control of Warden\'s Vigil!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45472,'The Horde has taken Warden\'s Vigil!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45473,'The Horde has lost Warden\'s Vigil!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45474,'Watch your step!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45475,'Let\'s go, $n. Stay close.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45476,'Stay alert, now. There\'s no telling what we might run into down here...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45477,'If you should need reagents, I have a full selection available.','',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(45478,'I cannot offer ya trainin\', friend.','I cannot offer ya trainin\', friend.',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(45479,'Welcome ta Moonglade, $c. All be welcome \'ere, as long as ya be keepin\' the sacred peace.','Welcome ta Moonglade, $c. All be welcome \'ere, as long as ya be keepin\' the sacred peace.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45480,'','If you desire, in addition to training, I have it within my power to erase the knowledge of your talents from your mind.  Be warned that every time you undergo this procedure the more difficult it is to perform, and therefore the more expensive it becomes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45481,'I. AM. UNLEASHED!','',0,0,0,0,0,0,0,0,1,0,20231,0,26124),
(45482,'Nothing more than dust in the wind.','',0,0,0,0,0,0,0,0,1,0,20232,0,26124),
(45483,'Winds of the south, rise and come to your master\'s aid!','',0,0,0,0,0,0,0,0,1,0,20227,0,26124),
(45484,'The sky... Beckons...','',0,0,0,0,0,0,0,0,1,0,20226,0,26124),
(45485,'Suffer the storm!','',0,0,0,0,0,0,0,0,1,0,20229,0,26124),
(45486,'Your city will be buried, your lives forfeit to the elements!','',0,0,0,0,0,0,0,0,1,0,20230,0,26124),
(45487,'Cower before the tempest storm!','',0,0,0,0,0,0,0,0,1,0,20228,0,26124),
(45488,'I will need some time to study these samples, $n.  I will speak to you again when I have completed my analysis.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45489,'We are winning this battle, $n.  As long as those farmers keep chipping away at the Forsaken\'s flanks, we will overtake them.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45490,'I spoke too quickly, $n.  Even with your support, things are looking grim for our forces out there.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45491,'I hadn\'t planned on fighting soldiers AND farmers.  With these farmers nipping at our flank, we risk losing focus on the task at hand: taking Andorhal.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45492,'','Now this is how you win a war!  Someone ought to teach that death knight some military strategy.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45493,'','Ishnu-alah, $c. Good fortune to you.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(45494,'','I will rejoin you soon. We will teach these Grimtotem savages the meaning of honor.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(45495,'Is that a.. a val\'kyr?','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45496,'Nechi owachi, $c. Hello and thank you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45498,'I will join you soon. Together, we will teach these Grimtotem cowards the meaning of fear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45499,'De tauren says that she\'ll teach me to heal if we do a good job!  Let\'s go, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45500,'Don\'t go in there!','Don\'t go in there!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45501,'Good day.','Good day.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45502,'Eh - what? Who? What\'s going on?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45503,'Alright, $n. Time to see what this staff of yours has to show us.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45504,'Lok\'tar! Let us return through that portal we left behind... much work awaits me in Orgrimmar.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(45505,'Well done, heroes. Let us return through the very portal meant to send this beast through! Much work awaits me in Thunder Bluff.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(45506,'Well done, heroes. Let us return through that portal we left behind... much work awaits me in Ironforge.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(45509,'Training','Training',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45510,'<Quality you can depend upon until the explosive end!>$B$B<Insert moolah for profession training and vending services.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45511,'','Join me ... in the depths.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45512,'I\'d like to purchase primary profession training.','I\'d like to purchase primary profession training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45513,'Access profession vending machine','Access profession vending machine',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45514,'You may rest here, if you like. The Temple of Earth is under our care, now.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45515,'','With the proper technology, you can fix anything, $n. Of course there are always malfunctions, short circuits, and uncooperative patients to keep things interesting.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45516,'Gandling is strong, but do not worry.  I will join you shortly after you begin to fight him.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45517,'','We have much to do and very little time to do it if we\'re to assist the Freewind Post tauren and push the Grimtotem back.$B$BTor ilisar\'thera\'nal! Let our enemies beware!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45518,'The Grimtotem have struck us for the last time. Since they cannot be taught the error of their ways, we will destroy them like beasts.$B$BEarth Mother forgive us.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45519,'May I have another vial of Elemental Sapta?','May I have another vial of Elemental Sapta?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45520,'May I have another Cleansing Totem?','May I have another Cleansing Totem?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45521,'','<The Stonemother stares down at you. Through you. As if she\'s peering into your soul.>$B$BMy daughter, Theradras, sequestered herself deep within the Crystal Caverns of Terramok to grieve for her lost love, Zaetar. There, heartless, stoneless beings invaded and slaughtered her amidst her mourning.$B$BIf I had any reason to trust a creature afflicted by the curse of flesh, it was stripped from me that day. And yet in your arrogance, you persist.$B$BOne day, you will outlive your usefulness.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45522,'I\'ve come at your call, Stonemother.','I\'ve come at your call, Stonemother.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45523,'The Alliance now controls the Twilight Shores beach head.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45524,'The Horde now controls the Twilight Shores beach head.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45525,'','Do not be afraid. I will not let you fall.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45526,'Warning: This vehicle is not permitted to operate outside of Tol Barad. Turn back now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45527,'Sorry, friend. You\'ll have to seek training elsewhere.','',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(45528,'For a small donation, I can train you in the priestly arts.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45529,'Bwaaaah! You no take da treasure!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45530,'Gwaaaaaaaaaaaahhh!!!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(45531,'','How can I help ye, $c?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(45532,'Do you have any supplies?','Do you have any supplies?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45533,'Can you repair equipment?','Can you repair equipment?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45534,'','Nay, but ye can talk ta Earthmender Doros over there... the big draenei, lookin\' over what\'s left o\' the Twilight camp.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(45535,'Little of their camp has been left intact. Still, there might be something we can make use of.$B$BDid you require something of me, $r?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45536,'I have nothing for you.$B$BHegrid, though, has been gathering Twilight supplies to replenish our own. You might speak with her.','',274,1,0,0,3,0,0,0,1,0,0,0,26124),
(45537,'Well done, heroes. Balnazzar had been a threat for far too long. He had a hand in the Scourge and the Scarlet Crusade, two of our most difficult foes. The Risen may have tipped the balance against us, had they time to fester.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45538,'Regrettably, Balnazzar is not yet finished. Defeating a dreadlord in the mortal plane only sends it back to the Twisting Nether. He will be back one day, perhaps even working again with his brothers, Varimathras and Detheroc. ','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45539,'For now, we have regained control over this half of Stratholme and should rejoice for that. The former Bastion of the Silver Hand is back in the hands of its rightful owners. Countless treasures to the order reside here, and we now have a fortified location to launch our next assault.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45540,'That is where you come in, heroes. The war for Stratholme is not yet over. Leave this area and travel east to the Eastwall Gate. It is the service entrance to the city, and the last remaining opening into Lord Aurius Rivendare\'s scourge-infested domain. If we defeat him, Stratholme will be ours once more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45541,'I will meet you in Alonsus Chapel. It is the holy place where Uther the Lightbringer was ordained into the Silver Hand. It is the only building the Scourge cannot touch, and will be our forward base of operations in that half of the city. With your help, Stratholme will become the capital of the Light and a new beginning for Lordaeron.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45542,'This blight is useless.','This blight is useless.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45543,'What did they test this crap on? Murlocs?','What did they test this crap on? Murlocs?',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45544,'Bwagauugh!!! Augh feed you to da crocs!!!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(45545,'Watered down garbage. Doesn\'t even slow \'em down.','Watered down garbage. Doesn\'t even slow \'em down.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45546,'We\'re gonna lose this war to \"regulations.\" What\'s next? Only wooden swords may be used???','We\'re gonna lose this war to \"regulations.\" What\'s next? Only wooden swords may be used???',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45547,'This is a war, right? We\'re supposed to be able to kill our enemies with our weapons, right?','This is a war, right? We\'re supposed to be able to kill our enemies with our weapons, right?',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45548,'','It will be a pleasure cleaving you in half!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45549,'','What have we here? A beaten coward and a meddling outsider?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45550,'','You\'ll soon learn to kneel before the might of the Grimtotem! If I let you live.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45551,'','Well, well, well, it looks like you people have a spine after all.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45552,'The rifts are down and Ironforge is safe!  These portals must be the second half of their attack.$B$BQuickly! Into the portal! We must press the attack while we have the advantage!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(45553,'That which falls, I collect.$B$BOf late, there have been many things to gather.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45554,'I cannot. I merely collect.$B$BIbdil may help you. His way is to mend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45555,'That which has broken, I mend.$B$BSo much has been broken in recent time. So very much.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45557,'Chosen of the Elder Crone! You don\'t realize yet, do you? I\'ll put an end to you first! You and your friend!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45558,'Why would she choose... an outsider?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45559,'Can we fire some more cannons? I dunnae think we\'re firin\' nearly enough cannons.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(45560,'Thas\'it! Pulverize the beach! Leave nuthin\' but ... sand.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45561,'So long as we\'re sendin\' troops up the beach, we should double-up the artillery-fire. You know, to help.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(45562,'More artillery... more! I never liked peninsulas.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45563,'There is nothing I call my own that would be of use to you.$B$BPerhaps D\'lom will have something of interest to you in his collection.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45564,'','How can I help you, $c?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45565,'I knew you were on your way. I don\'t care what they\'re saying about you or your connection to Arikara. This ends here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45566,'After everything, this is how it ends? Here on Darkcloud Pinnacle?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45567,'Once you go shaman, you don\'t go back.$B$BI completely underestimated the usefulness of fire elementals. Easy to discipline too: just add water.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45568,'Da Twilight\'s Hammer have been assaultin\' our rings all over da highlands, and dey\'ve taken many for demselves in da process. Dis be our last and we have no intention of givin\' it up, no matter what kind of horrors dey be summonin\' from the earth to assault us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45569,'You\'re the one my aunt sent? A test, no doubt. I\'ll kill you quickly and prove myself to her once again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45570,'NO! Magatha, forgive me! Bring me back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45571,'Well done, $c! You can follow simple clues.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45572,'Oh, do be a dear and kill Arnak for me along the way. He\'s become something of an embarassment to the family.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45573,'Now, hurry along, little $n. I\'ve one more challenge to see if you\'re worthy of the honor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45574,'','Where are those lunkheads?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45575,'','Earth Mother be merciful!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45576,'Shotgun!','',0,0,0,0,0,0,275,0,1,0,0,0,26124),
(45577,'Hey now!  Why do you get to sit in front?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(45578,'Because I won our bet.  And because I called shotgun.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45579,'Who says you won the bet?  We haven\'t compared tallies yet.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(45580,'Fine.  I killed five zombies.  And they were huge.  How many undead did you kill?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45581,'I\'m pretty sure I killed six.','',0,0,0,0,0,0,24,0,1,0,0,0,26124),
(45582,'I\'m going to bet that you only killed four.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45583,'H... how did you know that?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45584,'I didn\'t.  You just told me!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45585,'So seriously, how did your undead hunting go?  I want to hear stories.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45586,'Gidwin?  Are you ignoring me?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(45587,'Giddy... you\'re mad at me, aren\'t you?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45588,'Remember when we were kids, Gidwin?  We would spend all day pretending to fight the trolls, or the murlocs, or the girls.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45589,'Don\'t do this, Tarenar.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(45590,'We had a name we called ourselves... what was it?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(45591,'You remember damn well enough what it was.','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(45592,'I\'m dead serious.  I\'ve completely forgotten.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(45593,'<Sigh>... \"The Paladin Pals\".','',0,0,0,0,0,0,24,0,1,0,0,0,26124),
(45594,'','Gidwin, you can sit in front with me next time.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45595,'Maybe now I don\'t want to.  Maybe I like it better sitting back here with my new friend.  It smells like horses up there.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45596,'','There\'s a tower coming up on our left.  What do you say we stop and rest a bit?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45597,'We just rested a few minutes ago!  Let\'s just go to Light\'s Hope Chapel!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45598,'','The roads here are rough, Gidwin.  I don\'t want to risk losing a horse.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45599,'We won\'t lose a horse.  Look at them!  They look exactly like they did when we started.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45600,'Actually, I agree with Fiona.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(45601,'The Argent Crusade can wait for us a little while longer.  Besides... our guest may want to get off the caravan soon.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(45602,'','Here we are!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45603,'Carlin, do you have the extended Annals of Darrowshire?','Carlin, do you have the extended Annals of Darrowshire?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45604,'Why, yes... does Chromie need this?  I suppose she would.$b$bYes, you may have it.  Feel free to leaf through the pages.  Inside you will find the history of Darrowshire, and the details of the events that led to the deaths of so very many men.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45605,'Alliance reinforcements have arrived.','Alliance reinforcements have arrived.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45606,'You\'ve done it, heroes! Stratholme is ours! Come, we wait just outside the Slaughterhouse!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45607,'Your actions were pivotal in successfully reclaiming the city. Rivendare\'s death signifies the beginning of a new era for the Plaguelands. The few remaining Scourge should fall easily, and the land will at last be reborn.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45608,'Stratholme may take quite some time to be rebuilt and fully cleansed, but it is an effort I will take great pleasure in watching unfold. Perhaps one day we will see the next great defender of the Light armed in the Bastion of the Silver Hand, or ordained in Alonsus Chapel. No matter the outcome, our work here will bear great fruit one day.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(45609,'Thank you, brave heroes. Thank you for showing Azeroth that no matter how overhwelming the darkness becomes, a single Light can pierce through.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45610,'Never underestimate the power of proper supply management. The warriors may win the battles, but it\'s the supplies that win the war. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45611,'Thank you for the gifts. Let us see if you are worthy, $c!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45613,'Stop! You have bested my wind serpent.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45614,'I have been taken prisoner by the Twilight\'s Hammer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45615,'I\'m not certain where. Start with their western base overlooking Highperch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45616,'I would like to go back and see one of the visions again. Do you still have the enchanted blade?','I would like to go back and see one of the visions again. Do you still have the enchanted blade?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45617,'Surrender? I\'ll scrawl out the terms of our surrender in their blood.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45618,'I cannot promise that your rest will be peaceful, $c.  These orcs do not know when to quit.','I cannot promise that your rest will be peaceful, $c.  These orcs do not know when to quit.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45619,'A drunk orc is  a sight to see.  An army of drunk orcs is a sight I wish to never see again.','A drunk orc is  a sight to see.  An army of drunk orcs is a sight I wish to never see again.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45620,'If my mother had told me there would be days like this I would not have believed her.','If my mother had told me there would be days like this I would not have believed her.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45621,'Hey, \"Salty\" when are you going to get a new name? Thish town ain\'t big \'nough for two of ussh...','Hey, \"Salty\" when are you going to get a new name? Thish town ain\'t big \'nough for two of ussh...',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(45623,'Hey over there!  Hey!  Hey!  Over there!  How\'sh everything going Gororgararar?','Hey over there!  Hey!  Hey!  Over there!  How\'sh everything going Gororgararar?',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(45624,'Yoo hoo!  \"Shmaltzy!\"  Hey, why come your shupplies... Whe... Oh... Um... You got lots of boxes to keep track of...','Yoo hoo!  \"Shmaltzy!\"  Hey, why come your shupplies... Whe... Oh... Um... You got lots of boxes to keep track of...',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(45625,'Pssst!  Pssst!  Hey!  \"Pepper!\"  Are you done hording all the shupplies!  You shee what I just did? Horde..  For the horde!','Pssst!  Pssst!  Hey!  \"Pepper!\"  Are you done hording all the shupplies!  You shee what I just did? Horde..  For the horde!',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(45626,'\"Malty!\"  Hey, \"Malty!\"  I thought you were going to get us shome more booze!  What\'sh the hold up?','\"Malty!\"  Hey, \"Malty!\"  I thought you were going to get us shome more booze!  What\'sh the hold up?',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(45627,'It\'s \"Salty!\"  I got here firsht!  I got off the boat and onto land firsht!  I called the name \"Salty.\"  Hey... Where\'s your pet at?','It\'s \"Salty!\"  I got here firsht!  I got off the boat and onto land firsht!  I called the name \"Salty.\"  Hey... Where\'s your pet at?',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(45628,'Maybe you should worry about your pet and not me!  I\'m taking care of my bushinesh jusht fine!','Maybe you should worry about your pet and not me!  I\'m taking care of my bushinesh jusht fine!',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(45629,'\"Shalty.\"  That\'s my name!  Your name should be \"I can\'t hold onto petsh.\"  I can\'t believe anyone would trusht you with a beasht.  ','\"Shalty.\"  That\'s my name!  Your name should be \"I can\'t hold onto petsh.\"  I can\'t believe anyone would trusht you with a beasht.',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(45631,'Hey, shtop bothering me.  You\'re a dishgrace to us all.  You can\'t even hold onto your own petsh!','Hey, shtop bothering me.  You\'re a dishgrace to us all.  You can\'t even hold onto your own petsh!',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(45632,'Shhh!  SHHH!!!!!  Maybe if you shtay quiet your pet might come back to you!','Shhh!  SHHH!!!!!  Maybe if you shtay quiet your pet might come back to you!',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(45633,'My pet! Oh no!  Uh... I am shure that pet is around here somewhere...','My pet! Oh no!  Uh... I am shure that pet is around here somewhere...',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(45634,'HA! Shows how much you know.  I left the critter back on the third ship!','HA! Shows how much you know.  I left the critter back on the third ship!',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(45636,'Wait... Where is my pet?  It\'s gone! No need to panic... Just need a quick drink and I can figure out where he went to.','Wait... Where is my pet?  It\'s gone! No need to panic... Just need a quick drink and I can figure out where he went to.',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(45637,'I didn\'t like that pet anyways.  Beshides... People stop by all the time and give me their pets.  If I lost one, it doesn\'t matter, I\'ve got dozens more to lose!','I didn\'t like that pet anyways.  Beshides... People stop by all the time and give me their pets.  If I lost one, it doesn\'t matter, I\'ve got dozens more to lose!',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(45638,'I sent my pet out to get me shome more to drink.  You\'ll be shorry when he shows up with a wagon full of Mudder\'s Milk and you don\'t get any.','I sent my pet out to get me shome more to drink.  You\'ll be shorry when he shows up with a wagon full of Mudder\'s Milk and you don\'t get any.',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(45639,'I think I see them! HERE! HERE!','I think I see them! HERE! HERE!',0,0,0,0,0,0,0,0,1,10538,0,0,26124),
(45640,'I can smell you!','I can smell you!',0,0,0,0,0,0,0,0,1,10538,0,0,26124),
(45641,'We were hoping you wouldn\'t surrender peacefully!','We were hoping you wouldn\'t surrender peacefully!',0,0,0,0,0,0,0,0,1,10538,0,0,26124),
(45642,'We\'re coming for you!','We\'re coming for you!',0,0,0,0,0,0,0,0,1,10538,19345,19345,26124),
(45643,'NO ESCAPE!','NO ESCAPE!',0,0,0,0,0,0,0,0,1,10538,19345,19345,26124),
(45644,'We will find you, monster!','We will find you, monster!',0,0,0,0,0,0,0,0,1,10538,19345,19345,26124),
(45645,'','We mustn\'t fail the Banshee Queen.',0,0,0,0,0,0,457,0,1,0,0,0,26124),
(45646,'','Mine is not to question why.',0,0,0,0,0,0,457,0,1,0,0,0,26124),
(45647,'','Death to all that would oppose the Forsaken!',0,0,0,0,0,0,457,0,1,0,0,0,26124),
(45648,'','This Godfrey must be quite an extraordinary individual. The mistress has sacrificed much for his return.',0,0,0,0,0,0,457,0,1,0,0,0,26124),
(45649,'','Mortals... They never cease to amaze me.',0,0,0,0,0,0,457,0,1,0,0,0,26124),
(45650,'','These pathetic pups cannot hope to withstand the might of the Forsaken.',0,0,0,0,0,0,457,0,1,0,0,0,26124),
(45651,'','The Banshee Queen sees all.',0,0,0,0,0,0,457,0,1,0,0,0,26124),
(45652,'','There were two others that were already recovered. Godfrey is the final piece.',0,0,0,0,0,0,457,0,1,0,0,0,26124),
(45653,'Godfrey spent his life defending Gilneas. When the worgen curse spread across Gilneas he turned his attention towards thwarting the worgen assault.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45654,'I am told that Godfrey snapped when he learned of his king\'s affliction. Could you imagine the sense of betrayal he must have felt? His own king one of the very beasts that he spent his existence killing?','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45655,'Godfrey will be our ace in the hole. With his knowledge of Gilneas and of the worgen, we cannot fail.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45656,'My men recovered the corpses of two of Godfrey\'s lieutenants: Baron Ashbury and Lord Walden.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45657,'With Godfrey on our side, we will crush this uprising!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45658,'The Alliance will never recover from the blow that we are about to deal them!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45659,'I am more alive now than I ever was as a human. THIS is life, $n. This is living!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45660,'Let them come! All will fall before the Dark Lady\'s war machine!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45661,'%s coats his weapons in wolfsbane oil.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45662,'Are you interested in joining our caravan?  We\'re headed to Light\'s Hope Chapel.','Are you interested in joining our caravan?  We\'re headed to Light\'s Hope Chapel.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45663,'Well, I am headed in that direction.  I\'ve only been dallying here at Crown\'s Guard because of all the wildlife activity on the roads.$b$bI\'ll make you a deal: help me clear the roads, and yes, I\'ll join your group.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(45664,'You\'ve helped me clear the roads of all that nasty wildlife, so I suppose I have no choice.  Let\'s get going!','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(45665,'I\'ve spent far too long in that town.  It\'s a wonderful place, and I enjoyed my service there, but I think I\'d prefer to stay here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45666,'Ugh!  No, I could never.  Afraid of horses.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45667,'','No thanks!  Maybe sometime in the future.  Or the past.  Not today.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45668,'','I\'m sorry, I can\'t.  I\'ve been tasked to watch this hippogryph post.  These things might seem tame, but they really require a twenty-four hour vigil.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45669,'Hail.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45670,'Yes, traveler?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45671,'','Hello again, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45672,'','Farewell for now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45673,'Until we meet again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45674,'Inside the caravan are boxes of vendor supplies, along with the personal belongings of Fiona and her companions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45675,'Ride Fiona\'s Caravan to its next destination.','Ride Fiona\'s Caravan to its next destination.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45676,'This place is an archaeologist\'s dream!$b$bI wish there were time to conduct a proper excavation.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45677,'This here terrain is terrible! Spongy ground, all lumpy-like with stumps and stones. Like angry oatmeal. The mud\'ll practically swallow a steam tank whole.$B$BOur gear\'s all mired in the muck, getting thumped by the Horde!','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(45678,'What can I do to help?','What can I do to help?',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45679,'','Do you need to return to Vashj\'ir?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45680,'Help Joseph Carlin\'s troops defend Darrowshire!','',0,0,0,0,0,0,0,0,1,3122,0,0,26124),
(45681,'Protect Davil Lightfire!','',0,0,0,0,0,0,0,0,1,3122,0,0,26124),
(45682,'Horgus the Ravager has appeared!  Kill him quickly!','',0,0,0,0,0,0,0,0,1,3122,0,0,26124),
(45683,'Captain Redpath has appeared on the battlefield!  Protect him!','',0,0,0,0,0,0,0,0,1,3122,0,0,26124),
(45684,'Captain Joseph Redpath has been corrupted!  Kill him quickly!','',0,0,0,0,0,0,0,0,1,3122,0,0,26124),
(45685,'Speak with Joseph Redpath in the center of Darrowshire.','',0,0,0,0,0,0,0,0,1,3122,0,0,26124),
(45686,'Just stand back, $n. We wouldn\'t want $gyou:a pretty little thing like you; getting hurt.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45687,'Yes. Please take me to Vashj\'ir.','Yes. Please take me to Vashj\'ir.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45688,'Do not be alarmed. I am not as I appear.$B$BMy name is Acridostrasz, though you may call me Acride. My Queen sent me here to stop Nefarian, and I will not rest until my task is complete. However, there are other foes here guarding his lair that I cannot take on alone.$B$BHelp me dispose of them, and you will be in the favor of Alexstrasza. You may not know that name, but you will one day be thankful you do, of this I am certain. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45689,'Let us begin.','',0,0,0,0,0,0,1,1,1,10604,0,0,26124),
(45690,'Are we not going to have more witnesses?','',0,0,0,0,0,0,6,1,1,10604,0,0,26124),
(45691,'I do not wish to make an event of this.  Such frivolities are expensive and merely serve our vanity.  But if you wish to have a celebration...','',0,0,0,0,0,0,1,1,1,10604,0,0,26124),
(45692,'No, Warchief, this is enough.','',0,0,0,0,0,0,274,1,1,10604,0,0,26124),
(45693,'You know that these are troubling times for the Horde.  Our supplies dwindle.  Our lands are barren.  Our warriors are in need of rest.  These are tasks that must be addressed for the good of the Horde.','',0,0,0,0,0,0,1,1,1,10604,0,0,26124),
(45694,'Da people be happy with our success in Northrend.','',0,0,0,0,0,0,1,1,1,10604,0,0,26124),
(45695,'\"Our\" success?  Troll, you played no part in the Horde\'s victories in Northrend.  While I led our warriors against the Lich King, you merely took back a few scattered islands.','',0,0,0,0,0,0,1,1,1,10604,0,0,26124),
(45696,'Watch yourself, young one. You don\'t-','',0,0,0,0,0,0,397,1,1,10604,0,0,26124),
(45697,'Garrosh! Vol\'jin!  Hold your tongues.  There are larger issues at stake.','',0,0,0,0,0,0,396,1,1,10604,0,0,26124),
(45698,'Forgive my outburst.  Warchief, please, continue.','',0,0,0,0,0,0,2,1,1,10604,0,0,26124),
(45699,'Despite our success in Northrend, we face serious problems that cannot be solved simply by axe and sword.  Earthquakes shake every region.  Elementals ravage the countryside.  I can hear our land, Azeroth, cry out in pain.','',0,0,0,0,0,0,1,1,1,10604,0,0,26124),
(45700,'These are the reasons that you must leave.','',0,0,0,0,0,0,396,1,1,10604,0,0,26124),
(45701,'','What about you, Belmont? How will you get back?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45702,'I\'ll be fine, Arthura. The worgen lost our scent. It\'s doubtful that they even know we\'re here.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45703,'I\'ll probably make it back to the Forsaken Front before you two, er, three.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45704,'Now move out! You must not keep the Banshee Queen waiting.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45705,'You and your coin are -always- welcome here.','You and your coin are -always- welcome here.',2,0,0,0,0,0,0,1,1,0,0,0,26124),
(45706,'','So be it. Farewell, Belmont.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45707,'','Oh my... hang on tight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45708,'Now, brothers!  Attack the $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45709,'You do not need to fight me, $r.  I mean you no ill will.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45710,'Can I take your test again, Vex\'tul?','Can I take your test again, Vex\'tul?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45711,'Horton motions to the rickety riverboat nearby.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45712,'It will be an honor to carry out King Wrynn\'s commission for a warrior so dedicated to the Alliance.','',0,0,0,0,0,0,6,0,1,419,0,0,26124),
(45713,'Any friend of SI:7 is a friend of mine. Wouldn\'t want to end up on the wrong side o\' me own blade, now, would I?','',0,0,0,0,0,0,11,0,1,62,0,0,26124),
(45714,'She\'s hung up in the debris and I\'ve lost steam pressure. This terrain is murder!$B$BCan you get us out of this?','She\'s hung up in the debris and I\'ve lost steam pressure. This terrain is murder!$B$BCan you get us out of this?',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(45715,'|TInterface\\Icons\\spell_shadow_shadetruesight.blp:20|t%s begins to cast |cFFFF0000|Hspell:82299|h[Fester Blood]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45716,'Needless to say, it is an honor to work on behalf of such an upstanding servant of the Light and the Alliance.','',0,0,0,0,0,0,2,0,1,1667,0,0,26124),
(45717,'Here are some spare parts. I\'ll cover you while you make repairs!','Here are some spare parts. I\'ll cover you while you make repairs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45718,'Aye, protect the tank while the boys make repairs! I\'ll try to get her moving again...','Aye, protect the tank while the boys make repairs! I\'ll try to get her moving again...',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(45719,'The cauldron bubbles violently.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45720,'Put in a drop of liquid, as Betina requested.','Put in a drop of liquid, as Betina requested.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45721,'Throw in an entire flask.','Throw in an entire flask.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45722,'Throw in all 12 flasks.','Throw in all 12 flasks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45723,'The metals do not speak to me as the elements speak to you, but I hope that you will find this weapon worthy. King Wrynn and your farseer both have great confidence in your abilities.','',0,0,0,0,0,0,1,0,1,3284,0,0,26124),
(45724,'It\'s been years since I last worked moonsteel, but I haven\'t forgotten the technique. Dane, join me at the anvil.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(45725,'Your weapon is finished, $n. Wield it as an example to all who serve the Alliance.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45726,'Nothing seems to happen.  The plague cauldron may be ruined, but it certainly doesn\'t look any different.  What will you do?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45727,'Do nothing.  Betina said only one drop was needed.','Do nothing.  Betina said only one drop was needed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45728,'We are ready to proceed.  Magni, you have called this meeting.  What concerns you?','',0,0,0,0,0,0,1,7,1,10604,0,0,26124),
(45729,'You\'ve no doubt noticed the string of earthquakes we\'ve had in the last weeks.  Something doesn\'t feel right about them.','',0,0,0,0,0,0,1,7,1,10604,0,0,26124),
(45730,'','What do you mean?',0,0,0,0,0,0,1,7,1,10604,0,0,26124),
(45731,'We dwarves have a connection to the earth.  We can feel her pain.  And right now the earth is crying out.  These earthquakes... they are both natural and not.  I wanted to gather you all together and discuss them.','',0,0,0,0,0,0,1,7,1,10604,0,0,26124),
(45732,'','Even in Darnassus we have noticed the earth is at odds with something.',0,0,0,0,0,0,1,7,1,10604,0,0,26124),
(45733,'I\'ve received word from my brother Brann in Northrend.  In his exploring of Ulduar he came across some unusual tablets... something ancient.','',0,0,0,0,0,0,1,7,1,10604,0,0,26124),
(45734,'Nothing good has come from that dreadful place.\n','',0,0,0,0,0,0,1,7,1,10604,0,0,26124),
(45735,'This might just change your mind.  Brann is shipping the tablets to me as we speak. Preliminary reports from the Explorers\' League state that they may be able to help us understand what is going on with the earthquakes.','',0,0,0,0,0,0,1,7,1,10604,0,0,26124),
(45736,'Our top minds have been looking into the seismic activities... Well, we\'ve mostly been looking at how to secure a building\'s frame while at the same time simulating tectonic shifts...\n','',0,0,0,0,0,0,1,7,1,10604,0,0,26124),
(45737,'','So is that why you have moved out?',0,0,0,0,0,0,6,7,1,10604,0,0,26124),
(45738,'Ha, not at all!  Though it is a striking coincidence.  Gnomeregan has been and continues to shame our people.  It is long past time we reclaim our homeland.','',0,0,0,0,0,0,1,7,1,10604,0,0,26124),
(45739,'Well, it is good that things have turned out... better for you and your people, High Tinker.  But not all of us have the luxury of up and moving our kingdom.','',0,0,0,0,0,0,1,7,1,10604,0,0,26124),
(45740,'','Rise, Lord Vincent Godfrey. Be reborn as an instrument of my vengeance!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45741,'I live again...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45742,'','You live to serve me, Godfrey. Together we will crush the worgen uprising and retake Gilneas for the Forsaken.',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45743,'For the Horde...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45744,'','Yes, of course...',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(45745,'The irony of what I have become is not lost upon me, Lady Sylvanas.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45746,'Though as I have always said, better dead than worgen.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45747,'Or in this case, better undead than worgen.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45748,'','Prepare your men. The Gilneas Liberation Front amasses at the Greymane Wall. Soon their reinforcements from Stormwind will arrive. We haven\'t a minute to waste.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45749,'As you wish, Banshee Queen.','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(45750,'','Armor, weapons, whatever you may need, you will find at the supply depot behind me. Go now.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45751,'','Once again you have impressed me, $n. Without your aid, we would have not made it this far. Walk with me...',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45752,'<You may train in up to two primary professions. Please choose from the following selections:>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45753,'Alchemy','Alchemy',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45754,'Blacksmithing','Blacksmithing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45755,'Enchanting','Enchanting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45756,'Engineering','Engineering',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45757,'Inscription','Inscription',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45758,'Jewelcrafting','Jewelcrafting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45759,'Leatherworking','Leatherworking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45760,'Tailoring','Tailoring',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45761,'I\'d like to purchase secondary profession training.','I\'d like to purchase secondary profession training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45762,'<You may train any of the secondary professions. Please choose from the following selections:>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45763,'Cooking','Cooking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45765,'First Aid','First Aid',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45766,'<Error retrieving data.... Please see Doc Zapnozzle for further instruction.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45767,'Fishing','Fishing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45768,'Herbalism','Herbalism',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45769,'Mining','Mining',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45770,'Skinning','Skinning',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45771,'Defend the Siege Tank!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45772,'Ahh, blast it. C\'mon, c\'mon already!','Ahh, blast it. C\'mon, c\'mon already!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(45773,'There! We got it! Let\'s get \'er outta here.','There! We got it! Let\'s get \'er outta here.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(45774,'The Siege Tank explodes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45775,'Success! The Siege Tank is able to retreat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45776,'A commission from King Wrynn is always an honor. I\'ll get to work on it right away.','',0,0,0,0,0,0,0,0,1,10575,0,0,26124),
(45777,'So you\'re the one who ventured into Shadowfang Keep to retreive the rare and powerful materials hidden there?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45778,'Among the items you found in the keep is one that will serve as a powerful focus for your new staff.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45779,'Jessara, hand me those dusts and shards.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45780,'Where did I put that scroll? Ah, yes, here it is...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45781,'At last, $n, here is your staff. Wield it proudly in service to the Alliance.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45782,'','Of course, Lucan. Here they are.',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45783,'','You\'ve crossed into the domain of red dragons, $r.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45784,'','I know not whether you\'ve come on the call and beckon of your new Dragonmaw allies. Nor do I really care to trust you even if you do not.',0,0,0,0,0,0,1,0,1,923,0,0,26124),
(45785,'','Fortunately for you, your fate is not mine to decide. Calen awaits you by the tree.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45786,'','My drakes shall be watching you. Choose your words and your actions carefully, $r.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45787,'','You and your allies have struck against my kind at the gates to Grim Batol in the past. You\'ve shown no respect for the sacred oath we would die to keep. You\'ll find no trust with me.',0,0,0,0,0,0,1,0,1,924,0,0,26124),
(45788,'You must be the talented hunter that Wulf mentioned, the hunter who has managed to attract King Wrynn\'s attention.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45789,'The materials you have gathered from that cursed old keep will certainly make a worthy bow.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45790,'No offense, but you don\'t look like you could shoot the broad side of a pack kodo.$B$BHow about we stop wastin\' each other\'s time and you go find the right trainer.','No offense, but you don\'t look like you could shoot the broad side of a pack kodo.$B$BHow about we stop wastin\' each other\'s time and you go find the right trainer.',274,0,0,0,0,0,0,1,1,0,0,0,26124),
(45791,'Yo. Up for a little target practice?','Yo. Up for a little target practice?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45794,'There you have it, $n. A mighty bow for a mighty hunter. Use it well in service of the Alliance.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45795,'Hey there, $n. Here for a lesson? I ain\'t got all day...','Hey there, $n. Here for a lesson? I ain\'t got all day...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45796,'Hey, it ain\'t MY fault ya didn\'t learn proper spellcraft.\n\nGo pester a $c trainer, yeah?','Hey, it ain\'t MY fault ya didn\'t learn proper spellcraft.\n\nGo pester a $c trainer, yeah?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45797,'Nothin\' ta see here, mon.  Be on yer way, why don\'cha?','Nothin\' ta see here, mon.  Be on yer way, why don\'cha?',274,0,0,0,0,0,0,1,1,0,0,0,26124),
(45798,'I heard ya comin\' a league away, mon. Maybe ya need some more trainin\'?','I heard ya comin\' a league away, mon. Maybe ya need some more trainin\'?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45799,'What?  I look like a $c to you?$B$BGet outta here, will ya?','What?  I look like a $c to you?$B$BGet outta here, will ya?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45800,'Lookin\' good, kid.$B$BWhat\'s the word? Up for some trainin\'?','Lookin\' good, kid.$B$BWhat\'s the word? Up for some trainin\'?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45801,'You need somethin\'?$B$BToo bad. I got nothin\' for ya, $c.','You need somethin\'?$B$BToo bad. I got nothin\' for ya, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45802,'\"Controlling the Elements for Fun and Profit.\"$B$BThat\'s what it\'s all about, am I right?  Let\'s get ta work.','\"Controlling the Elements for Fun and Profit.\"$B$BThat\'s what it\'s all about, am I right?  Let\'s get ta work.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45803,'Look. You don\'t even WANNA know the sorta stuff I could teach ya.$B$BSeriously. It\'d melt yer brain. Go play nice somewhere else.','Look. You don\'t even WANNA know the sorta stuff I could teach ya.$B$BSeriously. It\'d melt yer brain. Go play nice somewhere else.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(45804,'You gotta love fel energy: Cheap, renewable, and guaranteed to blow things up.$B$BSure, you risk losin\' your eternal will to Unimaginable Horrors from Beyond Time and Space, but hey, risk versus reward!$B$BNow, what did you wanna see me about, hmmm?','You gotta love fel energy: Cheap, renewable, and guaranteed to blow things up.$B$BSure, you risk losin\' your eternal will to Unimaginable Horrors from Beyond Time and Space, but hey, risk versus reward!$B$BNow, what did you wanna see me about, hmmm?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45805,'Let the trial begin.  Rise, champions!  Rise, and meet these three in combat!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45806,'Your warm-up is complete.  Now, the real trial begins!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45807,'You will have to pry the relics of the Dalaran archmages from my dead hands!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45808,'It did not have to be this way!  I only wish to see my family again...to share with them this gift!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45809,'They will pay for forsaking us.  For leaving us here amongst the beastly undead to rot...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45810,'I will be goin\' now.  I have no reason to remain here.  I may be undead, but my will is my own.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45811,'I will see you in green fields on the other side, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45812,'Well-done, heroes.  You have passed my test of combat.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45813,'Good luck.','Good luck.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45814,'Come on already!  Let\'s go!','',0,0,0,0,0,0,0,0,1,10653,0,0,26124),
(45815,'Tarenar, you dolt!  The chapel is twenty yards away!  Let\'s get moving!','',0,0,0,0,0,0,0,0,1,10653,0,0,26124),
(45816,'Can we go yet, Tarenar?  I want to join the Crusade!','',0,0,0,0,0,0,0,0,1,10653,0,0,26124),
(45817,'<The dimensional portal hums.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45818,'<Use the Ambermill Dimensional Portal.>','<Use the Ambermill Dimensional Portal.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45819,'SOUND THE ALARMS! INTRUDERS HAVE BREACHED THE PORTAL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45820,'I... *cough*  I thank you, stranger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45821,'I owe you my life.  My people have paid a high price for defying Deathwing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45822,'I\'d only heard about your kind in stories, $r.  I never thought I\'d owe my life to one of you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45824,'Minions, destroy the interloper! The shield must not come down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45825,'You will not succeed, monster!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45826,'We will... never... give up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45827,'The armies of the Alliance will march upon your bones!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45828,'Lordaeron belongs to the Alliance. You only delay the inevitable...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45829,'RUN! DO NOT LET THEM TURN YOU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45830,'Hop aboard, $n. Let\'s move!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45831,'I hope you Alliance are here to give them Dragonmaw Orcs a good thumpin\'.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45832,'You\'ve got quite the setup here, friend. Come with me while I find out who\'s in charge.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45833,'Stuff me like a haggis! Kurdran Wildhammer - in the flesh. He lives!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45834,'I have to admit, you\'re not what I expected when I received the warchief\'s commission.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45835,'If you\'ve earned the respect of the warchief, there must be something to you. If you can lift the weapon, it\'s yours.','',0,0,0,0,0,0,1,0,1,419,0,0,26124),
(45836,'Perhaps you won\'t need to rely on your chanting so much with a proper weapon by your side.','',0,0,0,0,0,0,1,0,1,1667,0,0,26124),
(45837,'Still, looks are deceiving for the likes of you. Don\'t worry, I\'ll make something that favors your style of fighting.','',0,0,0,0,0,0,1,0,1,62,0,0,26124),
(45838,'Still, the elements clearly speak to you, and when I\'m done, you\'ll have a fine weapon to help you harness their power.','',0,0,0,0,0,0,1,0,1,3284,0,0,26124),
(45839,'I haven\'t worked moonsteel in years, but it\'s not the kind of thing you forget. Apprentices, it\'s time to show you how to work real metal!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45840,'Aye, friend. How fare the Wildhammer clans? We\'ve much to discuss!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(45841,'Forget this, Crablegs.  It\'s takin\' too long!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(45842,'Your weapon is finished. I think you will find our work a fitting reward for your loyalty to the Horde. Use it to remind our enemies why they should fear us!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45843,'','The dimensional barrier is broken! TAKE THEM NOW! FOR THE BANSHEE QUEEN!',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(45844,'','Rise, magi! Be reborn as Forsaken!',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(45845,'Yet I am a true servant of the warchief and he does not grant boons lightly. His wisdom guides my hammer.','',0,0,0,0,0,0,1,0,1,10575,0,0,26124),
(45846,'','Eliza isss pretty....sssso pretty...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45847,'My bird! Lightning - they shot her! Those filthy beasts shot her from the sky!','',5,15,0,0,0,0,0,0,1,0,0,0,26124),
(45848,'Poor Lightning. She\'s gonna need some time to recouperate.','',274,1,0,0,0,0,0,0,1,0,0,0,26124),
(45849,'And those that did know how dangerous these earthquakes can be.  To this day, the Exodar is still shaking from our rather abrupt arrival.','',0,0,0,0,0,0,1,7,1,10604,0,0,26124),
(45850,'...because on the one hand, this could be a handy device, the \"Shake-a-Ton 2000.\"  But on the other hand, the last thing we gnomes want to see is the mountains of Dun Morogh collapse and crush Ironforge.\n','',0,0,0,0,0,0,1,7,1,10604,0,0,26124),
(45851,'Well then. Ready to fly?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(45852,'I\'m ready. Let\'s go!','I\'m ready. Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45853,'','I\'m not certain we could organize our people to move even if we wanted to.  We\'ve also received word of hostile elementals appearing randomly across the lands, sometimes in towns, sometimes across the countryside.  Moving may not be an option.',0,0,0,0,0,0,1,7,1,10604,0,0,26124),
(45854,'Well, there is at least a wee bit of good news... no offense, Gelbin.  The shaking seems to have stirred up The Earthen Ring.  Even the Wildhammer shaman have offered their help.','',0,0,0,0,0,0,396,7,1,10604,0,0,26124),
(45855,'','Perhaps these events are also what have brought forth the Highborne from Shen\'dralar.',0,0,0,0,0,0,1,7,1,10604,0,0,26124),
(45856,'It seems as if this world is coming apart at the seams.  I\'ve seen these symptoms before, on Draenor... We may not be able to stop this.  Fleeing may be our best option.','',0,0,0,0,0,0,1,7,1,10604,0,0,26124),
(45857,'Fleeing is not an option I wish to entertain at this point. We will find another way.  Perhaps these tablets from Ulduar will shed some light on our situation.','',0,0,0,0,0,0,1,7,1,10604,0,0,26124),
(45858,'','Hopefully we can get these answers quickly.  The people are frightened, and cultists are taking advantage of that fear.',0,0,0,0,0,0,1,7,1,10604,0,0,26124),
(45859,'These cultists only exacerbate the problem.  They preach the end of the world, or that the world is having birthing pains... Hyperbole that is hard for the populace to ignore.','',0,0,0,0,0,0,1,7,1,10604,0,0,26124),
(45860,'','Troubling times indeed. Fear of the unknown makes people do foolish things.',0,0,0,0,0,0,1,7,1,10604,0,0,26124),
(45861,'And our lack of answers only fuels the confusion.','',0,0,0,0,0,0,1,7,1,10604,0,0,26124),
(45862,'All the more reason we need to reach the bottom of this.  This tablet from Ulduar will lead us in the right direction.  Brann is sure of it.  And if Brann is certain, then I am certain.','',0,0,0,0,0,0,396,7,1,10604,0,0,26124),
(45863,'','I\'ve made it a point not to argue with a dwarf when it comes to the earth.  If the Bronzebeards are sure this tablet will help solve the earth\'s problems, then by all means we should support them.',0,0,0,0,0,0,1,7,1,10604,0,0,26124),
(45864,'','Adventurers are such hypocrites!  Like YOU just FOUND your weapon on the side of the road!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45865,'','You won\'t find a finer firearm anywhere else in Orgrimmar.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45866,'','Ormak told me to expect you, $n.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45867,'','These materials you brought from Shadowfang Keep are no common things. They will invest your weapon with great power.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45868,'','Your bow is complete, $n. I hope it will serve you as well as you have served the Horde.',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45869,'Jhag, did you set aside those formulas and regeants I asked for?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(45870,'That should complete the enchantment. Here is your new staff, $n. Always use it in service to the Horde.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45871,'I\'ve gathered them here for you, master.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45872,'','Loganaar said that you would be bringing powerful artifacts from Shadowfang Keep. At first, I questioned the value of these materials.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45873,'I will tell you nothing, $r-pig!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45874,'I do not fear death at your hands, $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45875,'The dwarf belongs to our kind now!  Not yours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45876,'','But now that I have the items, I can sense the power Loganaar spoke about. They will make a fitting weapon for you.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45877,'The Plaguewood is too big!  Your friend is gone!  You will never find him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45878,'She will never return the dwarf to you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45879,'Foolish $r!  You seek the dwarf?  Baroness Anastari has hidden him well!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45880,'You will never stop us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45881,'Aarrghhh...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45882,'You can never stop the Scourge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45883,'Death means nothing to me, $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45884,'','Oh, my... The enchantment succeeded even beyond my expectations.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45885,'','With this staff, the circle is entrusting an item of great power to you, $n. Use it to uphold the tenets of our order.',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45886,'Scraping','Scraping',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45887,'$n has assaulted the waterworks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45888,'$n has assaulted the waterworks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45889,'The Alliance has taken the waterworks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45890,'The Horde has taken the waterworks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45891,'$n has defended the waterworks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45892,'$n has defended the waterworks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45893,'$n claims the waterworks!  If left unchallenged, the Alliance will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45894,'$n claims the waterworks!  If left unchallenged, the Horde will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45895,'$n has assaulted the mines!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45896,'$n has assaulted the mines!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45897,'The Alliance has taken the mines!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45898,'The Horde has taken the mines!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45899,'$n has defended the mines!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45900,'$n has defended the mines!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45901,'$n claims the mines!  If left unchallenged, the Alliance will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45902,'$n claims the mines!  If left unchallenged, the Horde will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45903,'$n has assaulted the lighthouse!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45904,'$n has assaulted the lighthouse!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45905,'The Alliance has taken the lighthouse!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45906,'The Horde has taken the lighthouse!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45907,'$n has defended the lighthouse!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45908,'$n has defended the lighthouse!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45909,'$n claims the lighthouse!  If left unchallenged, the Alliance will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45910,'$n claims the lighthouse!  If left unchallenged, the Horde will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45911,'','We have pledged to open an elemental gateway from Stormwind to the Highlands, but interference from the Bastion of Twilight hampers our efforts.$B$BWhat madness are they engaged in over there?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(45912,'At the appointed time, they will unleash wind and water elementals, engulfing the city in a tempest and setting the stage for our master\'s glorious return!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45913,'What is happening?','What is happening?',0,0,0,0,0,0,430,0,1,0,0,0,26124),
(45914,'What is going on?','What is going on?',0,0,0,0,0,0,430,0,1,0,0,0,26124),
(45915,'Take the scout\'s Journal.','Take the scout\'s Journal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45916,'When will this end?','When will this end?',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(45917,'Earthquake!','Earthquake!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(45918,'We are doomed!','We are doomed!',0,0,0,0,0,0,430,0,1,0,0,0,26124),
(45919,'I\'ve found an incredible site!$b$bThe whole area pulsates with the hum of ancient architecture.$b$bIf it were not so late in the day, I would investigate the chamber immediately!$b$bSleeping, tonight, will be a struggle...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45920,'I don\'t want to die!','I don\'t want to die!',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(45921,'Why is this happening?','Why is this happening?',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(45922,'Please... Make it stop.','Please... Make it stop.',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(45923,'','By wind and wave, by earth and fire... To Stormwind we go, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45924,'','The portal has been opened! Thanks to your efforts, we can now quickly travel from Stormwind to Twilight Highlands.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45925,'There\'s nothing more exciting than to soar through the air.$B$BWell, maybe to fight while soaring through the air, and a good tankard of ale afterward!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(45926,'Angus, I\'m here to lead the Wildhammer squad and drop off the SI:7 agents.','Angus, I\'m here to lead the Wildhammer squad and drop off the SI:7 agents.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45927,'Well, why didn\'t you say so? Give those Twilight cultists a good one from me, will ya?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(45928,'Don\'t let anybody tell you that the Scourge is defeated.  Look... do they not still roam the Plaguewood?  They cling to their corrupted land like a child\'s blanket.$b$bI have no choice but to fight.  Until my last breath, I will fight them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45929,'We are looking into these cultists groups.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45930,'We are looking into the missing person reports you filed.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45931,'As soon as we have some news we will let you know.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45932,'We are doing everything we can.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45933,'We have the situation under control.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45934,'We are investigating the cultists activities as we speak.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45935,'We take these missing person reports very seriously, ma\'am.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45936,'We have our best people looking into these issues.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(45937,'Is it safe?','Is it safe?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45938,'Are... are they all dead?','Are... are they all dead?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45939,'They struck from the shadows. We didn\'t stand a chance.','They struck from the shadows. We didn\'t stand a chance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45940,'I thought I was done for!','I thought I was done for!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45941,'You must be the hero that everyone is talking about. Thank you.','You must be the hero that everyone is talking about. Thank you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45942,'You filthy cultists have taken my husband from me! He just left us behind and went to follow all this \'end of the world\' nonsense you\'re spouting!','You filthy cultists have taken my husband from me! He just left us behind and went to follow all this \'end of the world\' nonsense you\'re spouting!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45943,'They\'re EVERYWHERE! WATCH OUT!','They\'re EVERYWHERE! WATCH OUT!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45944,'We overheard their orders... no survivors...','We overheard their orders... no survivors...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45945,'Begone! Isn\'t it enough that you have taken my husband? What more do you want?','Begone! Isn\'t it enough that you have taken my husband? What more do you want?',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45946,'Take your vile message away from this city! You will steal no more citizens away with your fake \'prophecies\'!','Take your vile message away from this city! You will steal no more citizens away with your fake \'prophecies\'!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45947,'Cowardly dog. Run back to your mommy and hide.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45948,'The Dark Lady lets these mongrels live? Useless...','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(45949,'Haven\'t you poisoned the minds of enough men with your lies? Stay away from me!','Haven\'t you poisoned the minds of enough men with your lies? Stay away from me!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45950,'I would have burned this whole place down with them in it...','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(45951,'These cowering troopers should die in shame. This is an embarassment.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45952,'Get out of my sight before I execute you!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45953,'$g He:She; died in battle. Bow your heads...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45954,'This is a mercy killing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45955,'Cowards don\'t get to return home.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45956,'Worthless maggot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45957,'You will own this peninsula, $c.$B$BYou will be a weapon.$B$BYou will be a minister of death, praying for war.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(45958,'Take your lies and leave me in peace, cultist. You\'ve already done enough damage here!','Take your lies and leave me in peace, cultist. You\'ve already done enough damage here!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45959,'A most productive day, today!$b$bThe chamber is indeed of ancient origin, and houses a magnificent mechanism which seems to be in disrepair.$b$bI will investigate further tomorrow.$b$bThis discovery will surely force Schnottz to take notice of me!$b$bHow could he deny me a promotion after something like this?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45960,'It has taken me all day to wrestle the cipher from these hieroglyphs:$b$b$b   Through eyes of blue is starlight$b              revealed.$b$b   Ten shards, one rod, and the veil$b             disappears.$b$b$bForget Schnottz and his empty promises!$b$bIf I can just unravel this riddle, its secrets shall be mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45961,'Report!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(45962,'I\'ve done it!$b$bUsing sapphire from the chamber\'s adornments, I have fashioned a pair of goggles. With them, I am able to see things...Amazing things!$b$bWith luck, my next entry will find me a newly rich man!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45963,'After a quick assessment, you determine that this fellow has expired within the last several hours.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45964,'There were... too many!','There were... too many!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45966,'They came out of nowhere!','They came out of nowhere!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45967,'Get to the drop point!','Get to the drop point!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45968,'Wildhammers!','Wildhammers!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45969,'Let\'s get these humans to the drop point.','Let\'s get these humans to the drop point.',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45970,'We need to lighten the load here.','We need to lighten the load here.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45971,'Hang on tight. It\'s going to get bumpy!','Hang on tight. It\'s going to get bumpy!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45973,'Let\'s get something straight... we\'re not your taxi service!','Let\'s get something straight... we\'re not your taxi service!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45974,'Some people only want to watch the world burn. Others want to be the ones responsible for burning it...','',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(45975,'Through fire we purge this land of its impurities.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45976,'Reduced to ashes... Soon nothing will be left of Gilneas or the worgen taint.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45977,'Stinking ettins!','Stinking ettins!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45978,'Aaaagghhh!','Aaaagghhh!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45980,'Twilight\'s Hammer pukes!','Twilight\'s Hammer pukes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45981,'For Kurdran!','For Kurdran!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45982,'We must stop Cho\'gall from creating his ultimate weapon at all costs, even if that means sacrificing ourselves.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45983,'We\'re out of here. Good luck!','We\'re out of here. Good luck!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45984,'Thanks for the company!','Thanks for the company!',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(45985,'Kill these ettins so that we can come back and finish the job.','Kill these ettins so that we can come back and finish the job.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(45986,'See you back at Victor\'s Point!','See you back at Victor\'s Point!',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(45987,'Aaaeeeiiii!','Aaaeeeiiii!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45988,'Dey came at us from everywhere, mon!','Dey came at us from everywhere, mon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45989,'For dey Horde!','For dey Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45990,'Stinkin\' ettins!','Stinkin\' ettins!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45991,'Get ta dey drop point!','Get ta dey drop point!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45992,'Dey were too many, mon!','Dey were too many, mon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45993,'Twilight scum!','Twilight scum!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45994,'Kill dem for me!','Kill dem for me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(45995,'Someone needs ta lose some weight, mon.','Someone needs ta lose some weight, mon.',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(45996,'Let\'s get ta dey drop point!','Let\'s get ta dey drop point!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(45997,'Assassins? What we need ta do is drop some firebombs on dem!','Assassins? What we need ta do is drop some firebombs on dem!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(45998,'Why we gotta taxi you? Canna ya just sneak in dere, mon?','Why we gotta taxi you? Canna ya just sneak in dere, mon?',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(45999,'Okey dokey. We outta here, mon!','Okey dokey. We outta here, mon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46000,'Bye-bye now!','Bye-bye now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46001,'You kill dese ettins so we be comin\' back ta finish dey job, mon!','You kill dese ettins so we be comin\' back ta finish dey job, mon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46002,'Be seein\' ya back at Crushblow.','Be seein\' ya back at Crushblow.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46003,'Dere\'s nothin\' bettah dan flyin\' ovah ya enemies an\' droppin\' dey boom-boom bombs on dem!$B$BDat, or droppin\' two-hundred, fifty pound orcs on dere heads. Right, mon?','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(46004,'Jon-Jon, I\'m here to lead your wind rider squad and drop off the Kor\'kron assassins.','Jon-Jon, I\'m here to lead your wind rider squad and drop off the Kor\'kron assassins.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46005,'','Drinking a healing potion!  I won\'t be able to use another one for a while!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(46006,'Hey, why not you say so? Give dem Twilight\'s the ol\' one-two, den ya comin\' back here an\' we party!$B$BI gots me a sweet lil\' place down on dey beach with me lady. You comin\' by!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(46007,'','Lady Windrunner herself sent me to serve as the Horde liaison to Zaela and the Dragonmaw clan. She and the new Warchief, Garrosh, are attempting to mend their broken fences, it would seem.$B$BIn any case, we must put an end to the Twilight threat once and for all. Most importantly, though, we must keep Cho\'gall from creating his ultimate weapon.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46008,'Drinking a healing potion!  I won\'t be able to use another one for a while!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(46009,'|TInterface\\Icons\\ability_warrior_charge.blp:20|tGeneral Umbriss sets his eyes on |cFFFF0000$n|r and begins to cast |cFFFF0000|Hspell:74670|h[Blitz]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46010,'|TInterface\\Icons\\ability_warrior_shieldreflection.blp:20|tOzruk casts |cFFFF0000|Hspell:78939|h[Elementium Bulwark]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46011,'Good! I\'m glad you\'re here, $n. We have much to discuss.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46012,'See, Cassius. I told you that we could depend upon $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46013,'We Wildhammer are a proud bunch. I trust that you have as much pride in the Alliance, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46014,'That\'s my $g boy : girl;! How goes the fight, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46015,'','Good to see you again, $n. I look forward to fighting by your side once more.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46016,'','These Twilight scum can\'t hold out much longer. The Dragonmaw Clan has waited a long time for this, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46017,'','You see, Cozwynn, I told you that we could rely upon $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46018,'','The Dragonmaw stand proudly with the Horde. The Twilight Citadel will fall, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46019,'','The Firelord will bring about the end of Azeroth at long last! You will burn in his fury, fools!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46020,'I feel slightly unhinged. I am not taking well to this... condition.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46021,'Crowley? I knew him. He was nothing more than a criminal before the curse took hold of our land. Now he\'s a great worgen hero? Sickening...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46022,'Bloodfang? When the attacks upon Gilneas first occurred, it was Bloodfang\'s worgen that lead the charge. This monster and his pack have been terrorizing these lands for years.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46023,'Just do as I say and this war will end without incident. Unless you count the death of every worgen in Lordaeron as an incident.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46024,'Never did I dream that our \"king\" would betray us as he did. To think that he had been a worgen in secret while he ruled over us. Sickening...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46025,'\"It\'s over, Godfrey...\" That\'s what he told me right before I jumped off of the cliff. NOTHING IS OVER, GREYMANE! I LIVE AGAIN!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46026,'We used to burn the worgen when we killed them - to be sure that they were dead.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46027,'Gilneas was an impossible dream. Only a man of true vision could have seen it through... but Greymane? Never...','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(46028,'For pity\'s sake, Ashbury, cover yourself. Your leg bones are popping out.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46029,'I did not bring this wretched affliction upon myself, Godfrey. It was a \"gift,\" remember? Now kindly enjoy the \"gift\" and shut up.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46030,'They should have burned my damned corpse.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46031,'Being Forsaken has its benefits. Let me see... I am able to practically live underwater. I can stay submerged 233%% longer than any fleshy mortal. Yes, count it, 233%%.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46032,'Oh, and I am now able to shrug off mind controlling effects - BECAUSE I LACK A BRAIN!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46033,'And perhaps the best part, I now have a hungering for the flesh of other humanoids. Cannibalizing their rotting corpses grants me power. Yes, DE-LI-CIOUS...','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46034,'This is undoubtedly Godfrey\'s fault.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46035,'I always loved Silverpine -- until the Lich King let loose his rampaging Scourge armies and turned the land into a massive rotting corpse pit. Now the sight of it boils my green blood.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46036,'Keep the conversations curt. I am in no mood for whining or rambling.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46037,'I\'m losing my mind. Can\'t keep my thoughts together...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46038,'Rage is the only emotion I have left.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46039,'Vengeance will be ours!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46040,'I am more than Forsaken... more than a man... I am something new. Something... else.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46041,'Wha? What happened to me? WHO ARE YOU PEOPLE?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46042,'HELP! HELP! I\'ve been captured by monsters!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46043,'HAH! Don\'t you recognize us, Dempsey? It\'s Godfrey. I have here Lord Walden and Baron Ashbury. We\'ve \"saved\" you and this is the thanks that we get?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46044,'Your theft is forbidden, trespasser!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46045,'You tread on sacred ground! You must be purified!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46048,'We have sworn to serve, intruder. And so shall you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46049,'You... You saved me? I\'m a damned monster! YOU\'RE A DAMNED MONSTER! LOOK AT YOURSELF!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46050,'Those who behold the starlight must forever protect it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46051,'Once a thief, I am now a servant of the Stars.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46052,'I welcome you into an eternity of service, thief.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46053,'You always were a spineless coward, Dempsey.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46054,'','You won\'t be able to open the back door yourself to escape once you\'ve started the chaos. You\'ll have to either get the guards to open it by killing bar patrons, get Private Rocknot drunk so he causes property damage, or see if Spazzring has the key on him!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46055,'Deathwing has returned. He\'s seized Grim Batol and much of the highlands, and I feel near powerless to stop him.$B$BSoon, our queen shall arrive, and together we shall put the once Earthwarder in his place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46056,'3...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46057,'2...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46058,'1...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46059,'WHAT WAS THAT?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46060,'THERE\'S NOTHING HERE EXCEPT FOR THIS FOG!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46061,'KEEP FIGHTING! I\'M GOING UP TOP TO SPEAK WITH CHO\'GALL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46062,'','I\'ve been watching the Dark Iron for a long time...plotting, hoping, wishing for the chance to drive them away and take back my land.$B$BThey can keep Blackrock Mountain. I hope it erupts again and takes them all with it. I want what is now called the Burning Steppes, my part of the Redridge Mountains that their fiery overlord destroyed.$B$B$C, I\'m going to show the world the potential left in my land. I\'ll build a kingdom of peace and justice atop the death and trickery they leave behind them. My vigil is over. I\'m here to fight for what\'s rightfully mine.$B$BAnd I\'m willing to die for it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46063,'ASSASSINS! I\'ll take chunks out o\' you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46064,'You\'ll never get away with this, you ugly, stinkin\' witch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46065,'','Oh really?  What exactly will you do, dwarf?  There\'s nobody to save you here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46066,'You\'re wrong, banshee.  We\'ve come to take Gidwin back.','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(46067,'','Just the two of you?  You\'ll never stand a chance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46068,'I beg to differ.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46069,'Charge!','',0,0,0,0,0,0,480,0,1,0,0,0,26124),
(46070,'It\'s hard to explain to the Dragonmaw concepts like, \"Fields of Fire\" or \"Suppressive Barrage.\"$B$BFortunately, they have a firm grasp of \"Kill Zones\" and ... uh, \"Murder.\"','',6,1,0,0,0,0,0,0,1,0,0,0,26124),
(46071,'I asked for reinforcements to help us hold the beach. And the Horde sent these tiny little men and their small metal tubes.$B$B<Gralok eyes the nearby goblins with disdain.>','',1,274,0,0,0,0,0,0,1,0,0,0,26124),
(46072,'','So the Banshee Queen has sent assassins?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46073,'Lorna, is that how you greet old friends? ','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(46074,'','Godfrey? So the rumors are true.',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(46075,'','You would betray your kingdom out of spite?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(46076,'My kingdom? My kingdom is no more.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(46077,'Your father and Greymane saw to that... No, Gilneas died when they allowed murderous beasts to reign free. Unchecked.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46078,'Now lay down your arms and surrender. We are not here to kill you. Not yet.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46079,'','HAH! You\'ll have to kill me! DIE!',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(46080,'','%s falls unconscious.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46081,'','You won\'t be able to open the back door yourself to escape once you\'ve started the chaos. You\'ll have to either get the guards to open it by killing bar patrons, get Private Rocknot drunk so he causes property damage, or see if Spazzring has the key on him!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46082,'','This stronghold is fortified, but our enemies close in from all sides. We would be wise to secure our position on the coast before advancing farther inland. ',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46083,'Hold the line!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46084,'Quickly! We must head back to the Forsaken Front before we are discovered!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46085,'Spirits of the Firelands, fill me with your rage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46086,'We will always remember Kargath Bladefist for what he once was to the Horde. He was one of the finest warriors to ever live, even the Alliance recognizes this.$B$BThe Kargath Expeditionary force was named in his honor, and I plan to ensure we live up to his name. We will drive out the Dark Iron Dwarves and claim Blackrock Mountain, and all of the surrounding areas, for the Horde as they so rightfully belong.$B$BYou will be the Warchief\'s blade against Thaurissan. Wear that honor proudly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46087,'Spirits of Skywall, heed my call!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46088,'Spirits of Deepholm, grant me your strength!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46089,'','Looks like they found their way back home.  I\'m relieved.$b$bYou came back, too!  Are you interested in joining us?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46090,'','By the way, you\'re welcome to borrow any supplies you find inside the caravan... as long as you bring them back when you\'re done!',1,25,0,0,0,0,0,0,1,0,0,0,26124),
(46091,'','I\'d like to set up shop in Light\'s Hope Chapel someday.  I\'m not much of a fighter, but that doesn\'t mean I can\'t help the cause.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46092,'','The boys and I have only traveled together for a little while, but I already can\'t imagine life without either one of them.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46093,'','I hope you\'ve made yourself welcome to the items inside my caravan.  If we\'re not using them, you might as well borrow them.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46094,'','Why would he run off like that?!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(46095,'','Promise me you\'ll find him, $n.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46096,'','<Fiona is rather upset.  She doesn\'t seem to be in the mood to talk.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46097,'','Good to see you again, $n!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46098,'','Hey, $n!  You here to visit, or did you want to buy something?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46099,'','Well, well... look who\'s here!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46100,'I can\'t BELIEVE that we\'re stopping!  We\'ve got a duty to do here!','',0,0,0,0,0,0,5,0,1,10651,0,0,26124),
(46101,'Why haven\'t we left yet?  I\'m ready to head off on my own if we don\'t get going.','',0,0,0,0,0,0,1,0,1,10651,0,0,26124),
(46103,'What\'s the holdup, Fiona?','',0,0,0,0,0,0,6,0,1,10651,0,0,26124),
(46104,'Alright, Gidwin... deep breaths...','',0,0,0,0,0,0,1,0,1,10651,0,0,26124),
(46105,'$R! Your corpse will feed the sea.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46106,'Incoming mortar barrage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46107,'Take the scout\'s spectacles.','Take the scout\'s spectacles.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46108,'That useless blood elf!  We have a DUTY to perform, and he wastes our time!','',0,0,0,0,0,0,5,0,1,10652,0,0,26124),
(46109,'I don\'t know why I put up with his nonsense.  He never takes anything seriously.','',0,0,0,0,0,0,5,0,1,10652,0,0,26124),
(46110,'Tyrosus himself sent us to Northdale!  So why are we wasting our time with upstart nerubians?!','',0,0,0,0,0,0,5,0,1,10652,0,0,26124),
(46111,'I\'ll throw my hammer upside his head if he makes us wait any longer.','',0,0,0,0,0,0,1,0,1,10652,0,0,26124),
(46112,'Gidwin is nearby... I know it.  Paladin\'s intuition.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(46113,'We must avenge our mother!\n\nDistract the monster who slew her, free us from this cage, and we will fight by your side.\n\nOur ability to reduce the damage an enemy inflicts will help you survive the Proto-Behemoth\'s Scorching Breath.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46114,'If one such as I can be captured by that lumbering oaf, then you must be brave indeed to venture here.\n\nIf you can distract Halfus and break the chains binding me then I will fight alongside you.\n\nMy ability to blind the eyes of an enemy will help you withstand Halfus\' Frenzied Assault.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46115,'If one such as I can be captured by that lumbering oaf, then you must be brave indeed to venture here.\n\nIf you can distract Halfus and break the chains binding me then I will fight alongside you.\n\nMy ability to temporarily paralyze an enemy\'s body will grant you respite from Halfus\' Malevolent Strikes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46116,'If one such as I can be captured by that lumbering oaf, then you must be brave indeed to venture here.\n\nIf you can distract Halfus and break the chains binding me then I will fight alongside you.\n\nMy ability to engulf an enemy in a furious tempest will impair Halfus\' efforts to unleash Shadow Novas.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46117,'Oh, ahh... hello there, good traveler!  What can this fine goblin do for you today?$b$bI\'ll assure you that I\'m here in Light\'s Hope Chapel solely due to my hatred of the Scourge which I share with these Argent Crusaders, and definitely not because I\'m running away from any sort of embarrassing zeppelin crash!$b$bI\'ll stop talking now, before I implicate myself any further!','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(46118,'You present an interesting option, $r.  I\'ll take that into consideration.$b$bAlright, I\'ve considered it.  Sure, I\'ll join you.  I\'ve probably stayed in Light\'s Hope Chapel for too long anyhow.  Like a gnome at a urinal, I\'m gonna have to stay on my toes!  Heh heh!','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(46119,'You know, if you\'re looking for a place to hide out, you\'re free to join us in our caravan.','You know, if you\'re looking for a place to hide out, you\'re free to join us in our caravan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46120,'Hey boss.  You need someone to help drive the caravan, you just let ol\' Beezil know.','',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(46121,'Stompers, defend your Chieftan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46122,'Reavers, at my side!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46123,'Geomancers, bury them in stone and flame!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46124,'','The T.A.D. units have the priority targets!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46125,'','Engage secondary targets!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46126,'You will be punished for this transgression, thief!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46127,'','The creature is gaining power from the ancestral Grimtotem!  We must put them to rest if we are to defeat this beast!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(46128,'Good to see you again, $n. We snuck some more of us in here while you were prepping the Gates for the attack.$B$BI\'ll show you where we\'re to rendezvous with Master Shaw.$B$B<The squad leader produces a map of the Twilight Citadel and points to the spot.>$B$BLet me know when you\'re ready, and we\'ll all head up together.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46129,'I\'m ready, commander, let\'s head up.','I\'m ready, commander, let\'s head up.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46130,'Fire!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46131,'Let \'em have it!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46132,'Blast \'em!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46133,'Fire in the hole!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46134,'The creature is gaining power from the ancestral Grimtotem!  We must put them to rest if we are to defeat this beast!\n','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(46135,'','Relax, spend some coin... we\'ve got everything from money changers and laundry services to exotic drinks.$B$BAnd if anyone gives you any trouble? You just let ME know, and I\'ll handle it.$B$BI\'m Mida... the boss.$B$BOh, the renovations? Yeah, I\'m always willing to help our new allies for the right price!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(46136,'','Look around... business is BOOMIN\'!$B$BWhile Gallywix is wastin\' time pickin\' custom wallpaper for his Pompous Palace in the Azsharan boondocks, I\'m makin\' twice the coin movin\' and shakin\' for Big G.$B$BYou heard me: Counting houses, trade halls, construction and maintenance, the war-works, supply lines...$B$BDon\'t even get me STARTED on transit! Orcs can fight, but they can\'t move goods; my boys ship it twice as fast for half the cost! Well... when it doesn\'t blow up along the way, hee.$B$BAnyhow! Take a load off, huh? Enjoy yourself, spend some coin... we\'ve got everything from money changers and laundry services to exotic drinks and fishing trainers.',1,11,0,0,4,0,0,1,1,0,0,0,26124),
(46137,'It\'s good to have traveling companions.  The road gets lonely out here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46138,'Greetings, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46139,'','Onward, $n! We will beat back the Alliance dogs and secure Lordaeron for the Forsaken! For the Horde!',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(46140,'Not now, $gpal:lady;.$B$BI gotta re-tune the boss\' shredder.$B$BShe don\'t like movin\' around the city on foot like any old chump, ESPECIALLY if she\'s gotta go deal with the warchief.','',274,0,0,0,0,0,0,1,1,0,0,0,26124),
(46141,'','I will leave your cities in dust and your lives in ruin!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46142,'','Lay down your arms and surrender!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46143,'','Look at them, $p. They scurry like rats, veering headlong to their doom. Surely Crowley and Bloodfang can see the futility in this!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46144,'','To the Greymane Wall! We will force their hand.',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46145,'Yes, I leave for Nagrand to learn from the elements there.  They have suffered and seen many of these same symptoms.','',0,0,0,0,0,0,1,1,1,10604,0,0,26124),
(46146,'How long you gonna be gone?','',0,0,0,0,0,0,6,1,1,10604,0,0,26124),
(46147,'It may take time to learn what I must.  I trust I will not be gone too long, but it could be weeks - even months.','',0,0,0,0,0,0,1,1,1,10604,0,0,26124),
(46148,'In my absence, I am instructing you, Garrosh Hellscream, to lead the Horde.  You have the strength and courage that our people need to survive in these trying times.','',0,0,0,0,0,0,1,1,1,10604,0,0,26124),
(46149,'I am honored, warchief.  But I feel unprepared for the life of a ruler.','',0,0,0,0,0,0,2,1,1,10604,0,0,26124),
(46150,'You will not be alone.  You will have advisors: Cairne, Eitrigg, Vol\'jin.  They will help guide you.','',0,0,0,0,0,0,1,1,1,10604,0,0,26124),
(46151,'And though I am leaving soon, I can also instruct you.','',0,0,0,0,0,0,1,1,1,10604,0,0,26124),
(46152,'A good first test may be dealin\' with dese cultists.  Da people be scared.  Dey aren\'t sure what\'s goin\'on.','',0,0,0,0,0,0,1,1,1,10604,0,0,26124),
(46153,'But even we are not sure of all that is happening.  Should we capture these cultists and force their silence?  But that may anger the rest of the people... Still, we cannot allow the cult to spread fear and lies...','',0,0,0,0,0,0,396,1,1,10604,0,0,26124),
(46154,'Now you are thinking like a ruler, Garrosh.  You must look at all sides of a problem.  Consult with your advisors and act with confidence.','',0,0,0,0,0,0,1,1,1,10604,0,0,26124),
(46155,'They will help you Garrosh.  And I will help you.  I will find the answers that we need to assuage the fears of the people and soothe the elements.','',0,0,0,0,0,0,1,1,1,10604,0,0,26124),
(46156,'I will not fail you, Warchief.  I will lead as well as I can, and I will consult with the advisors you suggest.  I know what a tremendous honor you do me, and I will strive to be worthy of it.','',0,0,0,0,0,0,396,1,1,10604,0,0,26124),
(46157,'Then it is done.','',0,0,0,0,0,0,273,1,1,10604,0,0,26124),
(46158,'Let everything you do be done for the Horde.','',0,0,0,0,0,0,1,1,1,10604,0,0,26124),
(46159,'For da Horde!','',0,0,0,0,0,0,66,1,1,10604,0,0,26124),
(46160,'For the Horde!','',0,0,0,0,0,0,66,1,1,10604,0,0,26124),
(46161,'For the Horde!','',0,0,0,0,0,0,66,1,1,10604,0,0,26124),
(46162,'I don\'t get many visitors this deep in the Plaguewood.  Abominations, mostly.$b$bCan I help you with something?','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(46163,'The Admiral was killed during our last naval engagement. I\'ve turned this ship into a fortress.$B$BWe\'re improvising here, $c.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46164,'Remember: Hellscream\'s eyes are upon you, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46165,'The hieroglyphs on your tablets indicate that there\'s a way to get this mechanism working again.$b$bWe just need to figure out how...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(46166,'It looks like your predecessor had time to set the flares up, but they have not yet been launched.$b$bThis is your time to shine, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46167,'The flare launcher has been emptied.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46168,'Gnugat... Can you wait until we are OFF of the boat before you take it apart?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(46170,'Gnugat, does it seem wise to you to tear apart a ship underneath your own feet?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(46171,'Gnugat, if your goblins strip any more of this ship\'s supports, it\'ll plunge into the surf!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46172,'Time is money, friend!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46173,'Nobody ever made money by keeping themselves alive, Rok\'tar.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(46174,'Who needs this hunk of metal more, Rok\'tar? You? ...Or the highest bidder?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46175,'The trees here in the Highlands are made of stout wood. And some of them... stone. I don\'t pretend to understand.$B$BWe\'ve got diamond-bladed shredders to harvest the stuff, but the Alliance keeps whacking them.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46176,'Here we go, $gbub:toots;. Watch how things get done.','Woohoo, $gsweet-thing:lady;! Step aside and watch the magic.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46177,'Cover my butt in case we\'re ambushed.','Cover my butt in case we\'re ambushed.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46178,'This shredder looks like it can be repaired. You fire off a signal...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46179,'Throm-Ka, $n. We snuck a few more in while you were preparing the Gates for attack.$B$BI\'ll show you where we\'re to meet with Garona.$B$B<The squad leader produces a map of the Twilight Citadel and points to the spot.>$B$BLet me know when you\'re ready, and we\'ll go together.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46180,'Well, stuff it. This thing is busted beyond hope. I\'m outta here!','Well, stuff it. This thing is busted beyond hope. I\'m outta here!',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(46181,'We did it! Let\'s fire this masterpiece up...','We did it! Let\'s fire this masterpiece up...',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(46182,'We should move out, $n. Up the ramp and then straight to Master Shaw.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46183,'Deathblade ... activated! System integrity check: 57 percent nominal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46184,'That\'s actually pretty good by Bilgewater standards. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46185,'Deploy mobile rocket platform pods! .... Oh yes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46186,'COME, HUMANS! LICK THE STAINLESS STEEL BOOTS OF YOUR NEW GOD!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46187,'Wait! Do you hear something?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46188,'','Crowley, your forces have fallen before my mighty army. You have lost!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46189,'It\'s not over, Sylvanas. Not yet.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(46190,'','You frivolously throw away the lives of your people while your own king sits atop his throne of lies, nary lifting a finger to help.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46191,'','Is Gilneas worth the lives that have been lost? The lives that will be lost? You cannot win.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(46193,'We will die trying!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46194,'','And your daughter? You could have saved her... You could have offered her your blood, yet you did not. Why?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(46195,'LORNA? What... Where is she!? What have you done to her!?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46196,'','Nothing, yet...',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(46197,'','I now present you with a choice - a choice that I was never given.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46198,'','I offer you the life of Lorna for your unconditional surrender.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46199,'','Choose your next words wisely, Crowley. Deny me and she will serve me in undeath - forever.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46200,'','Bring her, Godfrey!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46202,'Hello, old friend!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46203,'GODFREY! You deceitful maggot!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(46204,'Lorna... I... Release her. I will sound the retreat.','',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(46205,'You can\'t be serious, Crowley. You miserable bastard!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46206,'','Release her, Godfrey.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46207,'Of course, mistress.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46208,'','Now leave here, Crowley, and never return.',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46209,'','Lordaeron belongs to the Forsaken.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46210,'Forgive me, daughter...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46211,'','SOLDIERS OF THE HORDE! WE ARE VICTORIOUS! LORDAERON IS W...',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46212,'','%s dies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46213,'WHAT HAVE YOU DONE, GODFREY!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(46214,'Something that should have been done a long time ago, you filthy animal.\n','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46215,'Gilneas belongs to me, and so soon will the rest of Lordaeron!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46216,'NOW JOIN YOUR MISTRESS IN DEATH!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(46217,'FALL BACK, BROTHERS! TO SHADOWFANG!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(46218,'This land will quiver and shake in the wake of our destruction!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(46219,'Fix her... FIX HER!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(46220,'','We are bound to her, sisters...',0,0,0,0,0,0,457,0,1,0,0,0,26124),
(46221,'','It will destroy us, sister...',0,0,0,0,0,0,457,0,1,0,0,0,26124),
(46222,'','It is our sacred duty. The pact was sealed, the bargain made...',0,0,0,0,0,0,457,0,1,0,0,0,26124),
(46223,'','Then let it be done.',0,0,0,0,0,0,457,0,1,0,0,0,26124),
(46224,'','I saw... only darkness.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46225,'','And as I drifted towards nothingness, a brilliant light appeared, then another, and another... My dear val\'kyr.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46226,'','I know now - beyond a shadow of a doubt - that the val\'kyr are our future.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46227,'','We will never stop fighting for Lordaeron. Never...',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46228,'My people have enjoyed a good relationship with the Wildhammer for quite some time now.$B$BA few of us have settled here... those who have found this land to be a home worth defending.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46229,'Filthy, filthy orcs! Unhand those whelps!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46230,'You cannot escape the highlands, orcs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46231,'Murderous scum! Treacherous filth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46233,'Burn! BURN AND SUFFER!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46234,'Follow me if you dare!','',0,0,0,0,0,0,0,0,1,0,21783,0,26124),
(46235,'It\'s time for a tactical retreat!','',0,0,0,0,0,0,0,0,1,0,21784,0,26124),
(46238,'You\'re gonna be sorry!','',0,0,0,0,0,0,0,0,1,0,21785,0,26124),
(46239,'Don\'t say I didn\'t warn ya!','',0,0,0,0,0,0,0,0,1,0,21786,0,26124),
(46240,'Prison taught me one very important lesson, well, two if you count how to hold your soap, but yes! SURVIVAL!','',0,0,0,0,0,0,0,0,1,0,21789,0,26124),
(46241,'Ah-ha! I\'ve got you right where I want you!','Ah-ha! I\'ve got you right where I want you!',0,0,0,0,0,0,0,0,1,0,21787,21787,26124),
(46242,'Now... witness the full power of Millhouse Manastorm!','Now... witness the full power of Millhouse Manastorm!',0,0,0,0,0,0,0,0,1,0,21788,21788,26124),
(46243,'Alliance soldiers! So bold, so cavalier. (Scurry, scurry, scurry, mortals.) Your numbers are small, and you are too late. (Helpless and hopeless, helpless and hopeless.)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46244,'Cho\'gall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46245,'Kill him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46246,'','Even in these bright days after the reign of Kel\'thuzad, after the fall of the Lich King: the Brotherhood lives on.',1,273,0,0,0,0,0,0,1,0,0,0,26124),
(46247,'None may pass into the World\'s Heart!','',0,0,0,0,0,0,0,0,1,0,21919,0,26124),
(46248,'The cycle is complete.','',0,0,0,0,0,0,0,0,1,0,21920,0,26124),
(46249,'Break yourselves upon my body. Feel the strength of the earth!','',0,0,0,0,0,0,0,0,1,0,21921,0,26124),
(46250,'A protector has fallen. The World\'s Heart lies exposed!','',0,0,0,0,0,0,0,0,1,0,21922,0,26124),
(46251,'','For my death, countless more will fall. The burden is now yours to bear.',0,0,0,0,0,0,0,0,1,0,0,21633,26124),
(46252,'','Minions, followers, children of the Worldbreaker, I call to you now! The hallowed halls of our father have been befouled! Kill the intruders!',0,0,0,0,0,0,0,0,1,0,0,21627,26124),
(46253,'','Witness the power bestowed upon me by Deathwing! Feel the fury of earth!',0,0,0,0,0,0,0,0,1,0,0,21628,26124),
(46254,'','A sacrifice for you, master.',0,0,0,0,0,0,0,0,1,0,0,21635,26124),
(46255,'','The world will be reborn in flames!',0,0,0,0,0,0,0,0,1,0,0,21634,26124),
(46256,'Hakkar is known by many names. Some call him the Blood God, others simply refer to him as The Soulflayer. Titles aside, he is an entity of enormous power with malicious intentions for our world.$B$BMy flight discovered this temple early on and sank it beneath the Swamp of Sorrows. Unfortunately, we only seemed to aid the Atal\'ai by ensuring their efforts to summon Hakkar went on undisturbed. Many of the dragons tasked with guarding the temple have been corrupted, and the Soulflayer\'s presence grows with each passing day.$B$BI cannot stop them alone. Together, though, we might have enough time to stop this madness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46257,'','Accompany Lady Sylvanas Windrunner across the Battlefront.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46258,'(Finish it! Finish them all!)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46259,'Pathetic flesh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46260,'Horde scum! I was once like you. (Our old masters, small and hungry.) You cling to your mortal shells... (Bags of blood and bone and tears). ...trying to deny your insignificance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46261,'Let\'s move out quickly, $n. Up the ramp and straight to Garona.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46262,'With Stormwind\'s park district destroyed by Deathwing\'s pass over the city, we\'re returning to Darnassus for a time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46263,'The Highborne have returned, and with them spellcraft lost to the world for centuries.$B$BDo you have something for me to examine?','The Highborne have returned, and with them spellcraft lost to the world for centuries.$B$BDo you have something for me to examine?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46264,'Reforge an item.','Reforge an item.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46265,'What is reforging?','What is reforging?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46266,'Arcane Reforgers can modify the magical effects of a item; this magically complex process is known simply as reforging.$B$BThrough reforging, a secondary attribute of any piece of weaponry, armor, or jewelry may be reduced in order to add an additional secondary attribute. In this manner one may customize their equipment to best match their role and skills.$B$BFor example, if an item afforded you a bonus to strike your enemies but you\'d rather it made you attack more quickly, an Arcane Reforger could, for a price, reforge the item to have less Hit but increase your Haste.','Arcane Reforgers can modify the magical effects of a item; this magically complex process is known simply as reforging.$B$BThrough reforging, a secondary attribute of any piece of weaponry, armor, or jewelry may be reduced in order to add an additional secondary attribute. In this manner one may customize their equipment to best match their role and skills.$B$BFor example, if an item afforded you a bonus to strike your enemies but you\'d rather it made you attack more quickly, an Arcane Reforger could, for a price, reforge the item to have less Hit but increase your Haste.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46267,'If you\'re looking for an Arcane Reforger, there is a highborne mage inside the enchanting shop just outside the Mage District.','If you\'re looking for an Arcane Reforger, there is a highborne mage inside the enchanting shop just outside the Mage District.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(46268,'Reforge','Reforge',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46269,'This hardly seems fair!!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46270,'Why do I have to sit up top with all the stuff?!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(46271,'','Because you\'re the bravest, dear.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46272,'Because you\'re short.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46273,'Hey!  I oughtta bounce one of these trunks off of your head, Tarenar.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46274,'','I know I promised you the front seat, Giddy, but we have an elderly guest.  I\'m sorry.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46275,'Fiona, I must warn you: Gidwin only wants to sit in front because he wants to kiss you.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46276,'Oh shut up, you dolt.  YOU probably want to kiss her a hundred times.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46277,'Do not!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46278,'Ahem!  I, ah, appreciate the ride, Madam Fiona.  It\'s nice to get off my feet for once.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46279,'','Do you normally walk these roads alone?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(46280,'Yes, I do, though it was easier when I was younger.  These days, I have to be more careful.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46281,'If you don\'t mind my askin\', what do you do that requires walking so much?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(46282,'I service the five Argent towers.  Mostly repairs and maintenance, and some minor magical work.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46283,'Without proper upkeep, buildings within the plaguelands tend to... waste away.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46284,'Noble work.','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(46285,'I find it satisfying.  I enjoy working with my hands.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46286,'By the way, if any of you need anything repaired, let me know.  I am at your service.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46287,'So you\'re part of the Argent Crusade, eh?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(46288,'Think you can put in the good word for us?  We\'re looking to join the order.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46289,'Certainly.  I don\'t make it out to Light\'s Hope very often anymore, but when you arrive, tell Max Tyrosus that I sent you.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46290,'Whoah... he lets you call him Max?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46291,'Ma\'am, would you mind dropping me off at Light\'s Shield Tower, just up ahead?  I have to stop here.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46292,'','Of course I\'m not just going to drop you off, Master Highbeacon.  We\'ll be happy to wait for you.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46293,'NOOOOOOO!  Stopped again!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(46294,'Light\'s Hope isn\'t far, young paladin.  Might I suggest walking?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46295,'Walking, eh...?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46296,'I can\'t believe I let Gidwin run off like that!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46297,'','It\'s not your fault, Tarenar.  He ran off on his own will.  None of us could stop him.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46298,'We can\'t be certain that he was killed.  Maybe he just ran off somewhere.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46299,'No, he\'d never just leave his prayer book behind!  He was always nose-deep in that book, studying.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(46300,'He was always studying, always trying to get better.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46301,'Even more reason to believe that he\'s still alive.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46302,'A paladin like Gidwin makes a fine death knight.  Any member of the Scourge powerful enough to defeat him would know that.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46303,'It\'s likely that he\'s being held somewhere, awaiting a death ritual.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46304,'','Really?  That\'s great news!',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(46305,'','Well, actually, that\'s pretty bad news, but considering the alternatives... ',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46306,'If we\'re to find him, we\'re headed in the right direction.  It\'s likely that he was taken to Stratholme, or potentially to the Plaguewood.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46307,'Both are places of great evil.  This is the leg of my journey that I shun the most.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46308,'I\'m not sure I\'m ready to go in there alone.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46309,'','You\'re not alone, Tarenar.  You\'ve made allies along the way.  And besides, you\'re a skilled paladin in your own right.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46310,'Me, skilled?  No, no, Gidwin was the good paladin.  He\'s the one who stayed up for hours every night practicing... ','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46311,'','...yet it was you that continually kept up with him.  Without practice.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46312,'','I\'ve watched both of you fight, Tarenar.  You\'ve got natural talent - more than Gidwin ever will.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46313,'Perhaps that\'s why he left without you.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46314,'What do you mean?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(46315,'Perhaps he felt he needed to prove that he was as talented as you.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46316,'This is all my fault.  I\'ve got to go find him, to set things right.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46317,'I wouldn\'t say that it\'s your fault, Tarenar.  But don\'t let that stop you from saving Gidwin.','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(46318,'','Let\'s get something straight, $r. I\'m here for just one thing: to kill Cho\'gall!$B$BYour job is to keep him from finishing the creation of his ultimate weapon. It\'s an artifact that\'s supposedly being created with the power of an Old God.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(46319,'There\'s an artifact, a weapon, being forged with the power of an Old God. We don\'t know exactly what it is, but we need to get to it before it\'s completed by Cho\'gall.$B$BEverything else is secondary. Everyone is expendable, including you and I.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(46320,'Be wary of taking to the sky above these ruins, $glad:lass;. The Twilight drakes have a taste for things that fly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46323,'Commencing decontamination sequence... ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46324,'Decontamination complete. Standby for delivery.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46325,'Warning, system overload. Malfunction imminent!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46326,'Aye aye!','',0,0,0,0,0,0,113,0,1,0,0,0,26124),
(46327,'Burn dem all ta cinders!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46328,'Light da fuses, boys!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46329,'We gonna show you why treasure be a pirate\'s best friend!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46330,'Blowin \'em to bits, boss!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46331,'Peck \'dere eyes out!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46332,'Hit dem wit da most powaful \'ting you got!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46333,'','Powering up a high-powered shot!',0,0,0,0,0,0,113,0,1,0,0,0,26124),
(46334,'','Kill the engineer before she can get a shot off!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46335,'Do you know my dad?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46336,'Load me into that cannon, boy!','Load me into that cannon, boy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46337,'Ey!  Get outta my treasure ya dirty sea rat!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46338,'Mrrglrglrgl?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46339,'Mrrglrgl, mmrglrlglrrrglrggl!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46340,'','We were fools to entrust an imbecile like Cho\'gall with such a sacred duty! I will deal with you intruders myself!',0,0,0,0,0,0,0,0,1,0,0,20199,26124),
(46341,'No, not the Sanitron... it was my pride and joy!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(46342,'Ugh! Not this again! I\'m asking for a new station next expedition...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46343,'','My brood will feed on your bones!',0,0,0,0,0,0,0,0,1,0,0,20201,26124),
(46344,'','Powerless....',0,0,0,0,0,0,0,0,1,0,0,20202,26124),
(46345,'','I tire of this.  Do you see this clutch amidst which you stand?  I have nurtured the spark within them, but that life-force is and always will be mine.  Behold, power beyond your comprehension!',0,0,0,0,0,0,0,0,1,0,0,20204,26124),
(46346,'Ah, but which one is da real one?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46348,'Poor dear, you must be exhausted.$B$BThere\'s food and drink, if you like, and it\'s safe to rest here.','Poor dear, you must be exhausted.$B$BThere\'s food and drink, if you like, and it\'s safe to rest here.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(46349,'Looking for something to eat, $c?$B$BOr just a place to rest your weary bones for a while?','Looking for something to eat, $c?$B$BOr just a place to rest your weary bones for a while?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(46350,'Oh man, I\'m glad someone is here! Things are CRAZY down here! Crazier than usual!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46352,'No...da world...is mine...','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46353,'On behalf of the illustrious and always-neutral Steamwheedle Cartel, welcome to Bogpaddle! We\'re proud to be the only beachfront resort and military-grade weapons yard in the Eastern Kingdoms.$B$BYou guys may have that little war ragin\' just south of here, but inside these walls, it\'s all fun and games. So take a load off, have some R&R and a drink or two, and keep out of trouble... or my bruisers will remind your skull what \"neutral territory\" means.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46354,'|TInterface\\Icons\\spell_arcane_arcaneresilience.blp:20|t%s begins to cast|cFFFE1CF7|Hspell:79729|h [Power Conversion]!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46355,'|TInterface\\Icons\\spell_nature_lightningshield.blp:20|t%s begins to cast|cFF1CF2FE|Hspell:79900|h [Unstable Shield]!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46356,'|TInterface\\Icons\\spell_nature_nullifydisease.blp:20|t%s begins to cast|cFF1CFE1C|Hspell:79835|h [Poison Soaked Shell]!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46357,'|TInterface\\Icons\\spell_fire_firearmor.blp:20|t%s begins to cast|cFFFF9A20|Hspell:79582|h [Barrier]!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46358,'Torben Zapblast, teleportation solutions engineer at your service!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(46359,'|TInterface\\Icons\\ability_hunter_mastermarksman.blp:20|t%s sets his eye on |cFFFF0000$n|r and begins to cast|cFFFF0000|Hspell:79501|h [Acquiring Target]!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46360,'Send me to the surface, Torben.','Send me to the surface, Torben.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46361,'Okay so you\'ve got two pygmies in the box. Now all you have to do is chop carefully, aiming for the empty space between them.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46362,'Like this?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46363,'No, no! Where\'s your sense of showmanship? Theatrics!','',0,6,0,0,2,0,274,0,1,0,0,0,26124),
(46364,' Put your might into it! Really crack that crate in half, watch!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46365,'GWAAAAAAAAAAAAH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46366,'Did you just..?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46367,' Yes I think I did.','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(46368,'Oh... oh my...','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(46369,'I guess we\'re going to need some more pygmies.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(46370,'I am a path smoothing test for action trigger splines with spells inbetween.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46371,'I am a path smoothing test for action trigger splines with events inbetween.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46372,'I am a path smoothing test for spawn event splines with spells inbetween.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46373,'I am a chain actions test using spawn event splines with events inbetween.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46374,'Yo.$B$BYou here to stable your pets, or lookin\' for a lost companion?','Yo.$B$BYou here to stable your pets, or lookin\' for a lost companion?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46375,'Yo.$B$BYou lookin\' for a lost companion?','Yo.$B$BYou lookin\' for a lost companion?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46376,'There will be more time to talk once we get back to the surface safely.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46377,'','Come on, you two. I want another dozen barrels full before we\'re done!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46378,'','Ah, liquid gold. Gather up every last drop!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46379,'','I love the smell of raw crude in the morning. The smell, ya know, that sour sulphur smell... the whole place. Smells like... profit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46380,'','Out of the water, into the barrels. Move it! Time is money, ya know.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46381,'','Now THIS is what I call profit skimming. HEY! You missed some, over there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46382,'We have to break through those mindless leper gnomes if we want to get out of here alive!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46383,'Take the squad\'s last teleport beacon and get those survivors out of here. Thanks to your help, my men and I should be able to fight our way out of here.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46384,'Greetings, my name is Tae\'thelan Bloodwatcher. I have spent the better part of a lifetime training in the art of sorcery and gathering like-minded blood elves to form The Reliquary.$B$BYou see, there are ancient, powerful relics spread throughout this world that I plan to use to free my people from their addiction and unify them again  as the proud, indomitable race we once were.$B$BMagic is something to be embraced and, I assure you, a force that can be utilized free of corruption with proper teaching.$B$BAs it stands, the other races of the Alliance and even the Horde mock our kind for our half-destroyed capital, still-standing statues of Sunstrider and blunder after blunder across the world.$B$BNo more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46385,'Please help me!','',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(46386,'I don\'t want to die down here!','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(46387,'Don\'t let them eat me!','',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(46388,'Some help! Anyone!','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(46389,'I\'m too young to die!','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(46390,'I\'m really going to die down here, aren\'t I?','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(46391,'Help! I\'m too weak to make it on my own.','',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(46392,'Leave Smuggler\'s Scar to signal Adarrah','Leave Smuggler\'s Scar to signal Adarrah',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46393,'The Abyssal Seahorse seems very displeased.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46394,'Satekh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46395,'Kadesh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46396,'Osadi!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46397,'','I salvaged what I could from the nearby wreckage, but I can only stay down for so long...',71,0,0,0,0,0,0,0,1,0,0,0,26124),
(46398,'My eternal thanks to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46399,'There are Twilight\'s Hammer to be slain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46400,'I am enslaved no longer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46401,'Time for vengeance, mortals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46402,'It is but a small token of my appreciation. My thanks to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46403,'Excuse me. I have some former captors to speak with.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46404,'Run, little Twilight cultists. Your doom draws near!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46405,'Time for a bit of revenge before I return home.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46406,'Your kind will be made to suffer for this, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46407,'You ally yourself with these fiends? You, too, shall someday burn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46408,'<The enormous black drake, covered with open wounds, stares you down with malice in his eyes. It does not blink.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46409,'<The ferocious black drake strains at the chains that bind it. It\'s best to keep your distance.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46410,'The bonds that hold me are not so permanent, $c. Pray you are not near when I have my vengeance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46411,'Dragons are no mere beasts, like hogs or cattle. They are a force of nature. Powerful... Primal.$B$BTo bend them to your will is to harness the world.$B$BTo take up their reigns is to take destiny into your hands.','',1,274,0,0,0,0,0,0,1,0,0,0,26124),
(46412,'','I\'ve been mixing potions since before the cartel wars, and I don\'t plan to stop anytime soon.$B$BAs long as there\'s a buyer to be had, Ol\' Baba will be ready with a sale!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46413,'That was some real firepower. Maybe there\'s more to these runty little goblins than meets the eye.','',1,273,0,0,0,0,0,0,1,0,0,0,26124),
(46414,'Grab the Seahorse while it\'s distracted!','Grab the Seahorse while it\'s distracted!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46415,'Well done, $n! I imagine your journeys beneath the waves will be much smoother from here out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46416,'Hear the call... serve him... join ussssssssssss...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46417,'C\'mon boys, let\'s take back our homes!','',0,0,0,0,0,0,25,7,1,0,0,0,26124),
(46418,'','We could have been civil about this, but no!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46419,'Ya see that pass ahead dere, $glad:lass;?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46420,'Yeah...','Yeah...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46421,'That\'s an ambush.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46422,'You seem very certain.','You seem very certain.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46423,'Oh yeah, $glad:lass;! Been through 4 times already.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46424,'And I take it you\'re going again...','And I take it you\'re going again...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46425,'Damn right!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46426,'Well, let\'s get to it then.','Well, let\'s get to it then.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46427,'That\'s tha spirit!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46428,'That\'s right, show \'em our colors. Let \'em come!','',0,0,0,0,0,0,25,7,1,0,0,0,26124),
(46429,'If Keely sent ya to be ropin\' me back in, ya can just forget it. There\'s Twilight that need bashin\'.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46430,'I\'ll be headin\' back shortly, $glad:lass;. Just one more go, for good time\'s sake.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46431,'That all ya got?!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46432,'Cayden\'s got an axe with your name on it!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46433,'Come\'n get it!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46434,'I know there\'s more of ya, hidin\' in your little holes...','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46435,'Weee! Shinies all over this place!$b$bTake a look at what I found diggin\' right here...$b$bIt\'s a breathin\' hat!\n','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(46436,'Get up you lazy bums, there\'s fighting to do!','Get up you lazy bums, there\'s fighting to do!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46437,'Knock, knock!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46438,'Come outta ya holes, cowards!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46439,'Hidin\' from ol\' Cayden, are ya...','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46440,'Anyone home?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46442,'Move out - strike them now! ','Move out - strike them now! ',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(46443,'See you soon.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(46444,'That was fun.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(46445,'Not bad.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(46446,'I\'m heading back now.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(46447,'You\'re telegraphing your moves.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(46448,'One less cultist for us to worry about.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(46449,'Leave the bodies here, that they may see the futility of fighting the Dragonmaw.','Leave the bodies here, that they may see the futility of fighting the Dragonmaw.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(46450,'','See you later.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(46451,'','That was great fun.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46452,'','Not bad, I guess.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(46453,'','I\'m heading back now.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(46454,'','You\'re telegraphing your moves.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(46455,'','One less cultist to worry about.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(46456,'For the glory of the Dragonmaw!','For the glory of the Dragonmaw!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(46457,'Start fighting, or start bleeding!','Start fighting, or start bleeding!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46458,'Time to fight!','Time to fight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46459,'Freedom!','Freedom!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46460,'Kill this fool, or Randolph will kill us!','Kill this fool, or Randolph will kill us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46461,'Fight for your miserable, worthless lives!','Fight for your miserable, worthless lives!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46462,'Greetings, $r. I am Lord Itharius of the Green Dragonflight.$B$BI am here to free my kin from the evil within this temple, hopefully for good. Will you assist me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46463,'','I knew you were coming. No one can resist me, not even you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46464,'You\'ve come for training. Good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46465,'You there - $n! Help us defend this square.','',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(46466,'Look out, more Dragonmaw. And the Horde is with them!','',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(46467,'Come, we\'ve done enough damage here. Let\'s prepare another ambush.','Come, we\'ve done enough damage here. Let\'s prepare another ambush.',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(46468,'We did it! Cover the roads and keep this place locked down.','',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(46469,'Have you checked out my breathin\' hat?$b$bNo more suckin\' on clams for Budd! No sirree...\n','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(46470,'','Nurse Lillian sighs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46471,'Help Cenarius defeat Ragnaros!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46472,'You\'ll pay for this, Hogger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46473,'One day...I will have my revenge...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46474,'Forest just setback!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46475,'Kill now, eat later!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46476,'Yiiipe!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46477,'Thank the Light! I\'ve made it.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46478,'It\'s a relief to be surrounded by normal gnomes again!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46479,'I thought I was goner!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46480,'You... you\'re not going to try to eat me, are you?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(46481,'I never would\'ve made it on my own...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46482,'Thank you for getting me out of there!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46483,'My family... did you find my family?','',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(46484,'Ah, a new arrival. Right this way, sir.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46485,'%s realizes it\'s been spotted and quickly plays dead!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46486,'Fathom-Lord Zin\'jatar has entered the battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46487,'ALL MUST BURN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46488,'ASH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46489,'FIRE... EXTINGUISHED!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46490,'Stay back in the name of the King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46491,'You shall not pass!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46492,'Hold the line! Don\'t let them through!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46493,'Warden Thelwater, we need to push forward!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46494,'We need to make a move now, while we still can!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46495,'Allow me to introduce myself. I am Randolph Moloch, and I will be killing you all today.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46496,'Such a tragic waste of life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46497,'My epic schemes, my great plans! Gone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46498,'Steady men...steady...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46499,'Hold your fire! Warden\'s orders..no shootin\'...yet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46500,'Keep \'em in your sights. If they make a move on the guards, they\'re dead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46501,'Stay with me. You\'re going to make it out of here.','Stay with me. You\'re going to make it out of here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46502,'We\'re going to get you some help.','We\'re going to get you some help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46503,'You\'re doing well... you\'re going to be fine.','You\'re doing well... you\'re going to be fine.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46504,'Freeing','Freeing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46505,'The naga escaped out of the tunnel ahead. Show them no mercy, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46506,'','I am eternally grateful to you, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46507,'',' I\'ll take care of the drakes. You worry about the rest of the Twilight rubbish.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46508,'Ramkahen will only wage war against Neferset if the High Council\'s vote is unanimous.$B$BThe odds are against us, but my brother needs to understand there is no reasoning with Deathwing\'s allies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46509,'There\'s one - get it!','There\'s one - get it!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(46510,'Keep your eyes peeled for dwarven pigs.','Keep your eyes peeled for dwarven pigs.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(46511,'','$n, is that you? Please free me from these chains.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46512,'They\'ve got one of ours! No mercy for the Dragonmaw!','',0,0,0,0,0,0,15,7,1,0,0,0,26124),
(46513,'Hand over the bird, yeh filthy beasts. WILDHAMMER!!','',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(46514,'Are you with the Neferset scum?  Did they send you to do their dirty work?  Speak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46515,'I\'m looking for Tahet.  Let\'s get you out of these chains.','I\'m looking for Tahet.  Let\'s get you out of these chains.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46516,'It ain\'t all bad...$b$bI still got my breathin\' hat!\n','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(46517,'Rescue the Gryphon','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46518,'Defend the captured prize','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46519,'You! $C! Help us defend against a counterattack.','You! $C! Help us defend against a counterattack.',0,0,0,0,0,0,25,1,1,0,0,0,26124),
(46520,'Wait!  Here come the Neferset guards!  Fight near me so I can beat their skulls in!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46521,'Freedom at last.  I thank you, stranger.  Tahet is no longer here.  A cruel Neferset warlord called Caimas took him.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46522,'I must warn you.  Caimas does horrible things to prisoners... he forces them to fight his pet beasts.  Prepare for the worst, friend.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46523,'Look out - the Alliance is aiding the Wildhammer!','Look out - the Alliance is aiding the Wildhammer!',0,0,0,0,0,0,25,1,1,0,0,0,26124),
(46524,'%s picks up a key from Neferset Enforcer.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46525,'That\'s one more for the Wildhammer!','That\'s one more for the Wildhammer!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(46526,'Ahoy!\n','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(46527,'Ride into the Holding Pens and DEVOUR naga!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46528,'The Horde war machine needs you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46529,'Are you here to help the cause? Mount Hyjal burns!','',6,5,0,0,0,0,0,0,1,0,0,0,26124),
(46530,'Could you please send me to Moonglade, Emissary?','Could you please send me to Moonglade, Emissary?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46531,'','The admiral and his forces pushed forward to take one of the bases you scouted for him earlier. You should go and meet them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(46532,'That giant squid didn\'t stand a chance. The Verne\'s already rearmed and ready for another go... now we just wait.$B$BIt\'ll be back.$B$BYou\'ll see.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46533,'Great work, everyone. Take a moment to grab your gear and let\'s move on.','',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(46534,'This will keep you occupied!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46535,'DRAGONMAW!','DRAGONMAW!',0,0,0,0,0,0,15,1,1,0,0,0,26124),
(46536,'Jump to shake off the young crocolisks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46537,'Come. There\'s more havoc elsewhere on the ridge.','Come. There\'s more havoc elsewhere on the ridge.',0,0,0,0,0,0,25,1,1,0,0,0,26124),
(46538,'','Ah... I do not have many visitors here.$B$BPlease, sit a while.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46539,'The Alliance needs you. Answer the hero\'s call!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46540,'Now we finish the job.','Now we finish the job.',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(46541,'Bah!  Mere luck!  My pets will make mincemeat out of you yet!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46542,'Enough!  I grow tired of you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46543,'','Are you here to help the cause? Mount Hyjal burns!',6,5,0,0,0,0,0,0,1,0,0,0,26124),
(46544,'Search the town. Kill any survivors!','Search the town. Kill any survivors!',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(46545,'Psst! $n! Over here...','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(46546,'Lure Caimas over the Croc Eggs without stepping on them yourself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46547,'Over the wall, HUP!','',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(46548,'For glory! For honor! FOR THUNDERMAR!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(46549,'That heap o\' rubble yonder was me family\'s homestead fer five generations.$B$BWe\'re takin\' it back.$B$BWe\'re outnumbered... But we\'re Wildhammer! Are yeh with me?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46550,'Let\'s go!','Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46551,'Short work, an\' none too pretty! ','Aye, that\'s how the hammer falls, gents!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(46552,'Right! Burn the bodies of this filth while I search the ol\' homestead.','',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(46553,'Aw, hell\'s hangover. They trashed the place!','',0,0,0,0,0,0,15,7,1,0,0,0,26124),
(46554,'We\'ve got what we need. Clear out. We\'ll hit them again elsewhere.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(46555,'Farewell, friend! Good treasure hunting!','',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(46556,'I\'ll deliver the news to Thundermar.','I\'ll deliver the news to Thundermar.',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(46557,'$C! Look sharp. I smell the stench of Wildhammer nearby...','$C! Look sharp. I smell the stench of Wildhammer nearby...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(46558,'Look out - more dwarves attacking from the rear!','Look out - more dwarves attacking from the rear!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(46559,'Egad! My sophisticated heart!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46560,'Hah! Another legendary Dragonmaw triumph.','Hah! Another legendary Dragonmaw triumph.',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(46561,'Mortimer Moloch collapses from a heart attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46562,'Sweep the area for anything of use. Quickly now - they\'ll attack again soon.','Sweep the area for anything of use. Quickly now - they\'ll attack again soon.',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(46563,'I remember it well.  It was a bright, shiny day...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(46564,'I was just mindin\' my own business, when all of a sudden, Deathwing appeared!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(46565,'I said to myself, \"I\'m gonna punch that dragon in the face!\"','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(46566,'I\'m gonna punch that dragon in the face!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(46567,'Unfortunately, the cataclysm had knocked loose a bunch of angry elementals.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(46568,'\"You dang-blasted rock elementals!\", I said.  \"I\'ll punch you too!\"','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(46569,'You dang-blasted rock elementals!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(46570,'I\'ll punch you too!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(46571,'This ends here, Hogger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46572,'He\'s...he\'s dead? ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46573,'It\'s simply too good to be true. You couldn\'t have killed him so easily!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46574,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(46575,'Get punched!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(46576,'Taste my fist!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(46577,'P-p-punch!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(46578,'I\'m coming for you, Deathwing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(46579,'Theldurin the Lost!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(46580,'I\'m going to punch that dragon right in the face!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(46581,'Face punch!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(46582,'Take that, dangerous enemy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(46584,'You have no right to keep us out!','You have no right to keep us out!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46585,'We\'ve committed no wrongs against the city or its king...','We\'ve committed no wrongs against the city or its king...',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46586,'You have to let me in, my customers are waiting.','You have to let me in, my customers are waiting.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46587,'As a tax-paying subject, I have a right to visit the city!','As a tax-paying subject, I have a right to visit the city!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46588,'What does King Wrynn fear from his own people?','What does King Wrynn fear from his own people?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(46589,'You can\'t treat us this way!','You can\'t treat us this way!',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(46590,'I want to speak to Marshal McBride! This is an outrage!','I want to speak to Marshal McBride! This is an outrage!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46591,'I have powerful friends, and they will not be happy to hear I was treated this way!','I have powerful friends, and they will not be happy to hear I was treated this way!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46592,'You lookin\' for me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46593,'Tell me that story again, Theldurin.','Tell me that story again, Theldurin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46594,'No, no, no, Theldurin.  You\'re telling the story wrong!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(46595,'Hmm... I didn\'t go this direction.  I think I\'m telling the story wrong.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(46596,'More bones to gnaw on...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46597,'What?! What was that?! Impossible! His body is right here! Unless...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46598,'%s\'s eyes begin to glow. Take cover quickly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46599,'Secure the main road. We can launch our main assault from here.','',0,0,0,0,0,0,25,1,1,0,0,0,26124),
(46600,'Heroes, I know this is the real Hogger. I see my eye hanging from his belt. The implications of what has taken place down here are very dark indeed. His power is...beyond our understanding...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46601,'','Dad lets me shoot things!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46602,'Calm down! We\'ll get to everybody in time...','Calm down! We\'ll get to everybody in time...',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46603,'The more you shout, the longer it will take to resolve this.','The more you shout, the longer it will take to resolve this.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46604,'What? MORE Wildhammer? These fools have a death wish!','',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(46605,'Let me see what you have for sale, Fiona.','Let me see what you have for sale, Fiona.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(46606,'This way. Stay together now!','This way. Stay together now!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(46607,'Keep it down! We\'ll get this sorted out as soon as we can.','Keep it down! We\'ll get this sorted out as soon as we can.',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46608,'If you don\'t settle down, you\'ll be spending the night inside the Stockade!','If you don\'t settle down, you\'ll be spending the night inside the Stockade!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46609,'Be patient, citizens. Yelling at us won\'t change anything.','Be patient, citizens. Yelling at us won\'t change anything.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46610,'The king is only doing what\'s necessary to keep the city safe.','The king is only doing what\'s necessary to keep the city safe.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46611,'I could just close the gates, and then nobody would get in...','I could just close the gates, and then nobody would get in...',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46612,'What a mess! We come back from saving Deepholm and what do we find?$B$BThe Twilight\'s Stinkin\' Hammer!$B$BGood thing you\'re here to straighten this all out!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(46613,'Mr. Goldmine, I\'m ready for that wild ride.','Mr. Goldmine, I\'m ready for that wild ride.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46614,'You have no right to keep us out!','You have no right to keep us out!',0,0,0,0,0,0,25,1,1,0,0,0,26124),
(46615,'We\'ve committed no wrongs against the city or the Horde...','We\'ve committed no wrongs against the city or the Horde...',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(46616,'You have to let me in, my customers are waiting.','You have to let me in, my customers are waiting.',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(46617,'I have honored the Horde with years of service, and this is how I am treated?','I have honored the Horde with years of service, and this is how I am treated?',0,0,0,0,0,0,6,1,1,0,0,0,26124),
(46618,'Why do our leaders keep us out?','Why do our leaders keep us out?',0,0,0,0,0,0,6,1,1,0,0,0,26124),
(46619,'You can\'t treat us this way!','You can\'t treat us this way!',0,0,0,0,0,0,274,1,1,0,0,0,26124),
(46620,'This is an outrage!','This is an outrage!',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(46621,'I have powerful friends, and they will not be happy to hear I was treated this way!','I have powerful friends, and they will not be happy to hear I was treated this way!',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(46622,'Calm down! We\'ll get to everybody in time...','Calm down! We\'ll get to everybody in time...',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(46623,'The more you shout, the longer it will take to resolve this.','The more you shout, the longer it will take to resolve this.',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(46624,'Keep it down! We\'ll get this sorted out as soon as we can.','Keep it down! We\'ll get this sorted out as soon as we can.',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(46625,'If you don\'t settle down, you\'ll find yourself tossed in with the rest of the arrested cultists.','If you don\'t settle down, you\'ll find yourself tossed in with the rest of the arrested cultists.',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46626,'Be patient, citizens. Yelling at us won\'t change anything.','Be patient, citizens. Yelling at us won\'t change anything.',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(46627,'We are only doing what\'s necessary to keep the city safe.','We are only doing what\'s necessary to keep the city safe.',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(46628,'If you want to speed this process up then make sure you have your papers in order!','If you want to speed this process up then make sure you have your papers in order!',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(46629,'You\'re gonna have to protect me, $n. Without my weapons and totems, I\'m defenseless!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46630,'Randolph Moloch vanishes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46631,'Hogger enrages!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46632,'Halthar is dead! Sound the trumpets, and spread the news from Highbank to Thundermar!','Halthar is dead! Sound the trumpets, and spread the news from Highbank to Thundermar!',0,0,0,0,0,0,15,7,1,0,0,0,26124),
(46633,'If this is the best these dwarves can muster, the Highlands will soon be ours.','',0,0,0,0,0,0,11,1,1,0,0,0,26124),
(46634,'Watch the roads. They may be foolish enough to try another assault.','',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(46635,'Wildhammer assaults on this square have been relentless, $n. But they will never take me down. Watch and learn.','',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(46636,'I... *cough* I owe you my life, stranger.  Thank you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46637,'I\'m afraid your friend won\'t be waking up any time soon.  I always sedate my croc\'s food.  I hate to see them struggle with their meal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46638,'But perhaps I will make an exception for you.  Let the crocs out!  IT\'S FEEDING TIME!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46639,'That\'s it? Ya gotta have more than that!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46640,'Ain\'t no messin\' with Cayden Dunwald!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46641,'Bah! Dere\'s got to be some here somewhere...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46642,'Of all the buildings in all of Dunwald, why this one?!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46643,'They\'ve gone too far! Some Twilight are goin\' to be dyin\' this day!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46644,'The ale?! Why would they destroy the ale?! Monsters!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(46645,'Soul-less, ale-hatin\', uncultured vagabonds! Ya better hide!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46646,'All my sweet delicious ale... gone... the horror...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46647,'So... thirsty...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46648,'Eoin, there\'s a full well right there.','Eoin, there\'s a full well right there.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46649,'Water?! Are you daft?! I need some ALE!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46650,'I shouldn\'t have to submit to this.','I shouldn\'t have to submit to this.',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(46651,'I can explain why I\'m here.','I can explain why I\'m here.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46652,'I have nothing to hide.','I have nothing to hide.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46653,'Can you hurry? I have to be somewhere.','Can you hurry? I have to be somewhere.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(46654,'Thank you. I\'ll be on my way.','Thank you. I\'ll be on my way.',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(46655,'What is this? I have done nothing!','What is this? I have done nothing!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46656,'Citizens of Stormwind, as you know, a dangerous cult threatens to tear our city apart. Until this cult has been destroyed, King Wrynn decrees that all who wish to enter Stormwind must submit to searches and questioning.','Citizens of Stormwind, as you know, a dangerous cult threatens to tear our city apart. Until this cult has been destroyed, King Wrynn decrees that all who wish to enter Stormwind must submit to searches and questioning.',0,0,0,0,0,0,1,0,1,10722,0,0,26124),
(46658,'Keep your hands off me ale, ya unclean pint-hatin\' mongels!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46659,'Everything is ok, you can go.','Everything is ok, you can go.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46660,'You can enter the city.','You can enter the city.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46661,'You\'re free to enter Stormwind.','You\'re free to enter Stormwind.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46662,'Everything\'s in order. You\'re free to go.','Everything\'s in order. You\'re free to go.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46663,'All clear, you can go.','All clear, you can go.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46664,'That\'s a cultist robe. Guard!','That\'s a cultist robe. Guard!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46665,'This looks suspicious. I can\'t let you in.','This looks suspicious. I can\'t let you in.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(46666,'This is cultist literature. The only way you\'re entering Stormwind is in chains.','This is cultist literature. The only way you\'re entering Stormwind is in chains.',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(46667,'A Twilight\'s Hammer medallion? Guard!','A Twilight\'s Hammer medallion? Guard!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46668,'This is cultist propaganda. You\'re under arrest.','This is cultist propaganda. You\'re under arrest.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(46669,'I can\'t let you into the city with these cultist articles.','I can\'t let you into the city with these cultist articles.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46670,'What are these suspicious papers? Guard, take this citizen into custody.','What are these suspicious papers? Guard, take this citizen into custody.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46671,'Follow me, citizen.','Follow me, citizen.',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46672,'Ooh, this is gonna be good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46673,'Hang on!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46674,'OH NO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46675,'My totems!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46676,'JUMP!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46677,'Your life is forfeit.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46678,'I\'m going to search you, citizen.','I\'m going to search you, citizen.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46679,'Not the ale!','Save the ale!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(46680,'%s begins to transform into a Force of Earth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46681,'You\'re ours now, $r.','You\'re ours now, $r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46682,'You can trust a goblin to COUNT your coins, but not to GUARD them.','You can trust a goblin to COUNT your coins, but not to GUARD them.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(46683,'You won\'t find all of us!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46684,'We will win in the end.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46685,'Don\'t think you\'ve won.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46686,'This city will fall!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46687,'Unhand me, loyalist scum.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46688,'','No, no, silly $r...',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(46689,'','No one rides the Lady!',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(46690,'Someone took refuge here after the attack, but no sign of Beak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46691,'This room reeks of a massacre. No sign of Beak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46692,'These buildings lie entirely in ruin. Nowhere for Beak to hide here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46693,'Beak! Where are ya Beak?','',0,0,0,0,0,0,22,0,1,10732,0,0,26124),
(46694,'Beak! Come back to Donnelly. Donnelly keep you safe!','',0,0,0,0,0,0,22,0,1,10732,0,0,26124),
(46695,'Come back, Beak! Don\'t get hurt!','',0,0,0,0,0,0,22,0,1,10732,0,0,26124),
(46696,'Beak! No more hiding. Come out right now!','',0,0,0,0,0,0,22,0,1,10732,0,0,26124),
(46697,'You seem to have gained a companion. You should bring him back to Donnelly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46698,'This dwarf\'s body is severely battered. The Twilight\'s Hammer must take pleasure in their killing.','This dwarf\'s body is severely battered. The Twilight\'s Hammer must take pleasure in their killing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46699,'Kill the Alliance $c!','Over here - an Alliance $c!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(46700,'I have to give these Twilight a wee bit of credit... what they lack in skill, they make up for in numbers and tenacity. They got a few good licks in during our last bout.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46701,'','The Dunwald family is built tough, but they let it go to their heads. I worry that me brothers put their repuation to the test a wee bit too often.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46702,'Work harder, dark iron dogs!','',0,0,0,0,0,0,0,0,1,11574,0,0,26124),
(46703,'More Elementium! Now!','',0,0,0,0,0,0,0,0,1,11574,0,0,26124),
(46704,'Cho\'gall will rip your heart out of your puny, little body and laugh while he eats it!','',0,0,0,0,0,0,0,0,1,11574,0,0,26124),
(46705,'I\'m going to turn you to ash if you don\'t work faster!','',0,0,0,0,0,0,0,0,1,11574,0,0,26124),
(46706,'Don\'t let those spiders eat the Elementium!','',0,0,0,0,0,0,0,0,1,11574,0,0,26124),
(46707,'I see you there! Yes, you! Come here. I\'m going to bury you!','',0,0,0,0,0,0,0,0,1,11574,0,0,26124),
(46708,'More Elementium for the Bastion of Twilight!','',0,0,0,0,0,0,0,0,1,11574,0,0,26124),
(46709,'Mining\'s all you dwarves are good for!','',0,0,0,0,0,0,0,0,1,11574,0,0,26124),
(46710,'A Son of Kor has arrived to assist you, but watch out for his boulders!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46711,'|TInterface\\Icons\\spell_fire_twilightflamebreath.blp:20|t%s begins to cast |cFFFF0000|Hspell:86840|h[Devouring Flames]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46712,'|TInterface\\Icons\\spell_fire_twilightfire.blp:20|t%s takes a |cFFFF0000|Hspell:86059|h[Deep Breath]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46713,'|TInterface\\Icons\\spell_holy_consumemagic.blp:20|t%s begins to cast |cFF00EEFF|Hspell:86622|h[Engulfing Magic]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46714,'|TInterface\\Icons\\spell_fire_twilightpyroblast.blp:20|t%s begins to cast |cFF00EEFF|Hspell:86408|h[Dazzling Destruction]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46715,'Ahoy!','',0,0,0,0,0,0,70,0,1,0,21174,0,26124),
(46716,'Hah! My brothers be itchin\' for a fight. It was all I could do ta hold them back this long.$B$BYou in?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46717,'Let\'s give\'m a proper Dunwald welcome, brothers!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46718,'I\'m in.','I\'m in.',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46719,'Let me know when you\'re ready. Sooner is better - Cayden\'s lookin a mite vicious.','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46720,'Ya not be gettin\' me dat easy! Atal\'ai gonna rise up...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46721,'You are truly great heroes for vanquishing the Gnoll King. People all throughout Elwynn Forest and Westfall will speak highly of your triumph for years to come. Thank you.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(46722,'Let\'s get back to work, people!','Let\'s get back to work, people!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46723,'These ships are not going to build themselves!','These ships are not going to build themselves!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46724,'I expect the highest quality craftmanship from my workforce.  Double your efforts!','I expect the highest quality craftmanship from my workforce.  Double your efforts!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46725,'Your time is coming to an end.','Your time is coming to an end.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46726,'Gloat all you want, but you\'ll see we were right.','Gloat all you want, but you\'ll see we were right.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46727,'I may be restrained now, but my master will set me free when his vengeance rains down upon this city.','I may be restrained now, but my master will set me free when his vengeance rains down upon this city.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46728,'I am on the path to ascension and no petty, aspiring hero is going to stop me.','I am on the path to ascension and no petty, aspiring hero is going to stop me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46729,'It is your life that will end soon; mine is just beginning.','It is your life that will end soon; mine is just beginning.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46730,'We must contain the arcane power we have unleashed!','We must contain the arcane power we have unleashed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46731,'We cannot allow the arcane power to build up further!','We cannot allow the arcane power to build up further!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46732,'We must dissipate this power before it is noticed by elf or demon.','We must dissipate this power before it is noticed by elf or demon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46733,'By the time you realize the truth, it will be too late.','By the time you realize the truth, it will be too late.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46734,'My power is waning - support me, brothers!','My power is waning - support me, brothers!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46735,'What were you and the others doing inside the city?','What were you and the others doing inside the city?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(46736,'The magic required to move Dalaran was too great!  We cannot hold it back forever!','The magic required to move Dalaran was too great!  We cannot hold it back forever!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46737,'The mages of Dalaran are the most powerful in Azeroth!  We will not fail!','The mages of Dalaran are the most powerful in Azeroth!  We will not fail!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46738,'I can feel the arcane energies building up yet again!  The archmage must be warned!','I can feel the arcane energies building up yet again!  The archmage must be warned!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46739,'My arm is tired...','My arm is tired...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46740,'We came to bring the master\'s prophecy into being. The rituals have already begun and we are too numerous for you to stop us all.','We came to bring the master\'s prophecy into being. The rituals have already begun and we are too numerous for you to stop us all.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46741,'It\'s good to be back, overseer. I want to help carry out the ritual.','It\'s good to be back, overseer. I want to help carry out the ritual.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46742,'','We were afraid you\'d been caught, but I wouldn\'t think of leaving you out of the portal ritual.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46743,'','Take this book and practice the ritual. It must be performed perfectly, or else the elementals will not leave the portals at the proper time.',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46744,'You destroyed their Earth rune! I bet there are three others. And, I bet they\'re all linked to the fire portal in the back.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46745,'Ancients of wind and water, I have prepared the way for you. Come forth and raze Stormwind.','Ancients of wind and water, I have prepared the way for you. Come forth and raze Stormwind.',0,0,0,0,0,0,1,0,1,10752,0,0,26124),
(46746,'We better destroy them all. But first, I need to get the shrapnel out of my backside.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46747,'Did you get wet? I\'m soaked! Okay, what do you want to bet the next rune is attuned to air?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46748,'The blast of air totally dried my hair. That gives me a great idea for a spare flying machine engine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46749,'Beak squeaks in joy at the sight of Donnelly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46750,'Ahahahaha, that\'s the last of their runes! Twilight Suckers, no more elemental power for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46751,'Go home to Keely, Beak. She keep you safe til Donnelly come back.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46752,'Wait! What\'s that over there?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46753,'Magmatooth?! NOOOOOOOO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46754,'An\' where you think you\'re goin\', sonny?!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46755,'GOLDMINE! YOU THINK I\'VE FORGOTTEN?! I TOLD YOU THAT I\'D GET MY REVENGE!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46756,'Help!  Up here!','',0,0,0,0,0,0,0,0,1,0,20921,0,26124),
(46757,'','I will now remove the fog from your eyes.  Behold, our captive.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46758,'','Deathwing\'s madness overcomes him, and we, the red dragons, must take this opportunity to steal his black dragons from beneath him.  We will remake the black dragons as they were intended to be: the warders of the earth.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46759,'%s slumps down in exhaustion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46760,'%s appears to be waking up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46761,'Attack!','',0,0,0,0,0,0,0,0,1,0,18260,0,26124),
(46762,'Like a Dunwald. I like you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46763,'You fool! This is a ritual, not a recipe!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46764,'We are betrayed! You may have won here, but the ritual will succeed!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46765,'There\'s a lot of gear here we can still use. Fan out. And step lively! The Dragonmaw are near.','Grab what supplies you can and move quick. Expect the Dargonmaw any minute!',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(46766,'Keep yer eyes open fer Dragonmaw.','Keep yer eyes open fer Dragonmaw.',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(46767,'Ancients of wheat and water, I have peppered the way for you. Come forth and glaze Stormwind!','Ancients of wheat and water, I have peppered the way for you. Come forth and glaze Stormwind!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46768,'','Guards, let $n serve as an example to you in defending Stormwind from its enemies.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46769,'','But these cultists are determined to bring Stormwind to ruin. Men, we must remain vigilant for our city and our king, as $n as done!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46770,'YOU\'RE BOTH GOING TO BURN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46771,'We serve Stormwind faithfully, my lady!','We serve Stormwind faithfully, my lady!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46772,'More cultist traitors? Good job gettin\' \'em off the streets.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46773,'','At last, you\'re back! We were beginning to worry that you\'d been arrested.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46774,'How many coconuts can we get for the ugly one?','',0,0,0,0,0,0,396,0,1,0,18259,0,26124),
(46775,'Eat dirt, stumpy!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(46776,'Now stay dead.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(46777,'Weakness. These dwarves are nothing!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(46778,'Another one dead.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(46779,'Pathetic, bearded little rodents!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(46780,'That was close!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46781,'More Wildhammer scum. Assault the ridge!','',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(46782,'Heads up, $n. The Dragonmaw are about to attack!','Heads up, $n. The Dragonmaw are about to attack!',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(46783,'Sweep the ridge! Kill the Wildhammer!','Sweep the ridge! Kill the Wildhammer!',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(46784,'I\'LL GET YOU, GOLDMINE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46785,'What in Cho\'Gall\'s name are you doing?!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46786,'The portals will open and your precious city will be swept away!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46787,'Nothing warms my bones like this trusty southsea rum!','Nothing warms my bones like this trusty southsea rum!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46788,'Yarg!','Yarg!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46789,'Yo ho, Yo ho, a pirates life for me!','Yo ho, Yo ho, a pirates life for me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46790,'You\'ll pay for this, traitor!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46791,'You think you\'ve won, but the forces of Twilight will triumph in the end!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46792,'That\'s right! They can keep on comin\', we\'ll keep knockin\' \'em down!','THAT\'s how you handle an orc, boys.',0,0,0,0,0,0,11,7,1,0,0,0,26124),
(46793,'Okay, back to work. If we\'re fast we can finish up here before another attack.','Okay, back to work. If we\'re fast we can finish up here before another attack.',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(46794,'Let\'s hurry, Thundermar needs these supplies.','Let\'s hurry, Thundermar needs these supplies.',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(46795,'We did it! That\'ll learn those Dragonmaw to try an\' ambush a Wildhammer.','We did it! That\'ll learn those Dragonmaw to try an\' ambush a Wildhammer.',0,0,0,0,0,0,4,7,1,0,0,0,26124),
(46796,'This world is imperfect!  We must begin anew!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46797,'The secrets of Uldum will be ours only!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46798,'You cannot stop us!  We will wield the power beneath the tombs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46799,'We will destroy all who oppose us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46800,'Another notch in my sword.','Another triumph! Another set of beards to hang from my belt.',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(46801,'Hah! Get these Wildhammer off their gryphons and look what kind of a fight they put up. Nothing! ','',0,0,0,0,0,0,15,1,1,0,0,0,26124),
(46802,'Let\'s go. My blade grows hungry.','',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(46803,'It is done. Scour the place clean. Leave them nothing to return to!','It is done. Scour the place clean. Leave them nothing to return to!',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(46804,'','<The console whirrs and buzzes as you approach it.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46805,'I suppose we\'ll just have to throw these away... WAIT!  I think I\'m having an idea.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46806,'Yes, definitely an idea.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46807,'Hubba-hubba!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46809,'You could bounce a washer off those legs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46810,'Shake it like a sine wave, baby!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46811,'It\'s the TXR-5000!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46812,'200 horsepower, dual combustion engine with modified flux capacitors!  ZOING!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46813,'I didn\'t know it came in lightning-blue!  AWESOME!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46814,'Check out the modified leg articulation!  Perfect for off-roading!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46815,'I\'d like to survey those curves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46816,'So... EPIC!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46817,'Weaponized sharks?  Why didn\'t I think of that!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46818,'ROCK ON!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46819,'Brilliant!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46820,'Our captors have allied with Deathwing, $r.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(46821,'No mercy remains in them. Make your peace.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(46822,'The hulking statue stands inert, untouched for centuries.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46823,'While it is clearly quite old, this statue does not appear to have crumbled at all over the centuries.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46824,'<Place the pawn in the indentation.>','<Place the pawn in the indentation.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46825,'Citizens of Orgrimmar, as you know, a dangerous cult threatens to tear our city apart. Until this cult has been destroyed, Warchief Garrosh Hellscream, hero of Northrend, champion of the people, decrees that all who wish to enter Orgrimmar must submit to searches and questioning.','Citizens of Orgrimmar, as you know, a dangerous cult threatens to tear our city apart. Until this cult has been destroyed, Warchief Garrosh Hellscream, hero of Northrend, champion of the people, decrees that all who wish to enter Orgrimmar must submit to searches and questioning.',0,0,0,0,0,0,1,1,1,10754,0,0,26124),
(46826,'Judging by its color, this must be The Warden.$b$bYou see a small indentation where your pawn might fit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46827,'This red statue looks a lot like the Sentinel\'s pawn that you hold.$b$bThe statue has a small indentation that matches the size of your pawn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46828,'Ancients of fire and earth, I have prepared the way for you. Come forth and raze Orgrimmar.','Ancients of fire and earth, I have prepared the way for you. Come forth and raze Orgrimmar.',0,0,0,0,0,0,1,0,1,10755,0,0,26124),
(46829,'Ancients of flour and earth, I have peppered the way for you. Come forth and glaze Orgrimmar!','Ancients of flour and earth, I have peppered the way for you. Come forth and glaze Orgrimmar!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46830,'$n, over here. What do you have to report? Were you followed?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46831,'We need to figure out everything there is to know about Cho\'gall\'s mystery weapon before it\'s too late.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46832,'Looks like it\'s just you, me, and those two Earthen Ringers over at the mine. Let\'s work fast, $n, before we\'re discovered.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46833,'It\'s good to be back out in the field. Nice change of pace from being cooped up in Stormwind all of the time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46834,'We\'re going to have to deal with Cho\'gall and Skullcrusher sooner rather than later. Are you up to it, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46835,'This might be a one-way mission, $n. If you\'re not comfortable with that, you can walk away at any time, though I\'d rather that you didn\'t.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46836,'We need to take care of everything out here before we can launch the final assault on the Bastion of Twilight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46837,'Did I tell you about the time when the Twilight\'s Hammer actually tried to recruit me? True story.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46838,'','It\'s just you and me, $r. Let\'s get this wrapped up quickly so that I can go kill Cho\'gall.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46839,'THREE? He woulda paid five, easy... Dummy!','',0,0,0,0,0,0,0,0,1,0,18259,0,26124),
(46840,'','Greetings.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46841,'','We\'re glad to see you here again, $n. With so many of our brethren seized by the Warchief\'s forces, we thought we\'d never see you again.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46842,'','Over here. Find out anything? Were you tailed, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46843,'','We need to figure out everything there is to know about the weapon Cho\'gall\'s working on and we need to do it fast!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46844,'','These Twilight idiots have no idea of the pain that\'s coming their way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46845,'','Cho\'gall\'s keeping himself hidden inside of the Bastion of Twilight. I hope he decides to come out and play.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46846,'','I hope that you\'re ready for a one-way mission, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46847,'','We need to kill all of these cultists and their leaders out here before we can take out the Bastion of Twilight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46848,'','Cho\'gall once held sway over my mind with the simple utterance of a magic word. He made me do a lot of things that I\'m not proud of. I\'m going to repay him tenfold, and you\'re going to help me do it, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46849,'Let\'s move, cultist filth.','Let\'s move, cultist filth.',0,0,0,0,0,0,25,1,1,0,0,0,26124),
(46850,'Okay, I\'ll lead the caravan to our destination. You stay in the back and make sure our tail is clean. Let me know when you\'re ready. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46851,'How dare you question me.','How dare you question me.',0,0,0,0,0,0,274,1,1,0,0,0,26124),
(46852,'You insult my honor with your inquiries.','You insult my honor with your inquiries.',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(46853,'I have nothing to hide.','I have nothing to hide.',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(46854,'Make your search fast, I have to be somewhere.','Make your search fast, I have to be somewhere.',0,0,0,0,0,0,6,1,1,0,0,0,26124),
(46855,'Hope you brought your mining pick, pilgrim.  No place better than here for digging up ancient treasure.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46856,'Everything seems ok, you may go now.','Everything seems ok, you may go now.',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(46857,'You can enter the city.','You can enter the city.',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(46858,'You\'re free to enter Orgrimmar.','You\'re free to enter Orgrimmar.',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(46859,'Everything\'s in order. You\'re free to go.','Everything\'s in order. You\'re free to go.',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(46860,'All clear, you can go.','All clear, you can go.',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(46861,'Thank you. I\'ll be on my way.','Thank you. I\'ll be on my way.',0,0,0,0,0,0,273,1,1,0,0,0,26124),
(46862,'That\'s a cultist robe. Guard!','That\'s a cultist robe. Guard!',0,0,0,0,0,0,25,1,1,0,0,0,26124),
(46863,'This looks suspicious. I can\'t let you in.','This looks suspicious. I can\'t let you in.',0,0,0,0,0,0,25,1,1,0,0,0,26124),
(46864,'This is cultist literature. The only way you\'re entering Orgrimmar is in chains.','This is cultist literature. The only way you\'re entering Orgrimmar is in chains.',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(46865,'A Twilight\'s Hammer medallion? Guard!','A Twilight\'s Hammer medallion? Guard!',0,0,0,0,0,0,25,1,1,0,0,0,26124),
(46866,'This is cultist propaganda. You\'re under arrest!','This is cultist propaganda. You\'re under arrest!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46867,'I can\'t let you into Orgrimmar with these cultist articles.','I can\'t let you into Orgrimmar with these cultist articles.',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(46868,'What are these suspicious papers? Guard, take this citizen into custody.','What are these suspicious papers? Guard, take this citizen into custody.',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(46869,'What is this? I have done nothing!','What is this? I have done nothing!',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(46870,'Let me know when you\'re loaded in and ready, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46871,'Let\'s go!','Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46872,'May the elements curse you!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46873,'You are nothing more than the warchief\'s dog!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(46874,'After the fall of the Burning Blade Clan, we blademasters swore to free ourselves and our people from demonic control.$B$BThis may be done, but my honor remains unsatisfied.$B$BI shall fight for the Horde - and train other warriors to do so - until I die gloriously in battle. This is the only path I may tread.$B$BSo. Are you ready to train?','After the fall of the Burning Blade Clan, we blademasters swore to free ourselves and our people from demonic control.$B$BThis may be done, but my honor remains unsatisfied.$B$BI shall fight for the Horde - and train other warriors to do so - until I die gloriously in battle. This is the only path I may tread.$B$BSo. Are you ready to train?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46875,'Another fly enters the spider\'s web...','Another fly enters the spider\'s web...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46876,'The false Kingpin has fallen thanks to you adventurers.','',21,0,0,0,0,0,25,0,1,0,0,0,26124),
(46877,'After the fall of the Burning Blade Clan, we blademasters swore to free ourselves and our people from demonic control.$B$BThis may be done, but my honor remains unsatisfied.$B$BI shall fight for the Horde - and train other warriors to do so - until I die gloriously in battle. This is the only path I may tread.','After the fall of the Burning Blade Clan, we blademasters swore to free ourselves and our people from demonic control.$B$BThis may be done, but my honor remains unsatisfied.$B$BI shall fight for the Horde - and train other warriors to do so - until I die gloriously in battle. This is the only path I may tread.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46878,'Vanessa VanCleef is still out there somewhere, plotting against us. Thankfully, without this base she is largely powerless against the might of the Alliance.','',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(46879,'I\'ll be sure to keep an eye on things as we begin cleaning the Deadmines out. Hopefully we can use it again soon as the famous gold mine it once was. As for the kingpin\'s fate...','',1,1,0,0,0,0,1,0,1,0,0,0,26124),
(46880,'That\'s the way...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46881,'...the Cookie crumbles.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46882,'More traitors? Put \'em down in the pit, where they belong!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46883,'Guarding the bank and treasures of the Horde is far more satisfying than dispensing coins and trade goods from inside a cage of iron.$B$BI would not exchange places with one of those quill-pushing goblins for a moment.','Guarding the bank and treasures of the Horde is far more satisfying than dispensing coins and trade goods from inside a cage of iron.$B$BI would not exchange places with one of those quill-pushing goblins for a moment.',1,0,0,0,0,0,0,1,1,0,0,0,26124),
(46884,'Find the interlopers! I know that they have someone sneaking around to the north!','',0,0,0,0,0,0,0,0,1,10763,0,0,26124),
(46885,'Keep your weak, fleshy eyes open! There are intruders amongst us.','',0,0,0,0,0,0,0,0,1,10763,0,0,26124),
(46886,'Work harder for the glory of Cho\'gall!','',0,0,0,0,0,0,0,0,1,10763,0,0,26124),
(46887,'I sense one amongst us that does not belong!','',0,0,0,0,0,0,0,0,1,10763,0,0,26124),
(46888,'The weapon will soon be completed. The Wildhammer and the Dragonmaw are about to be no more.','',0,0,0,0,0,0,0,0,1,10763,0,0,26124),
(46889,'Gather a force and go to the lake.  I want Countess Verrall destroyed by the end of the day!','',0,0,0,0,0,0,0,0,1,10763,0,0,26124),
(46890,'Power to the Twilight\'s Hammer!','',0,0,0,0,0,0,0,0,1,10763,0,0,26124),
(46891,'Prepare to attack Crushblow and Victor\'s Point!','',0,0,0,0,0,0,0,0,1,10763,0,0,26124),
(46892,'Your dad says to fire me across the bay.','Your dad says to fire me across the bay.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46893,'Keegan, sir. More elementals are breaking through on the west side of the rift.','Keegan, sir. More elementals are breaking through on the west side of the rift.',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(46894,'Yes sir!','Yes sir!',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(46895,'Find Iain. Secure whatever gryphon riders he\'s gathered to cut them off before they reach the town.','Find Iain. Secure whatever gryphon riders he\'s gathered to cut them off before they reach the town.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(46896,'Boot-up protocol completed.  Scanning for objective...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46897,'Objective identified.  Scanning...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46898,'Anomaly detected.  Probable source: Azerothian Old God.  Attempting to excise anomaly...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46899,'Anomaly excised.  Repeating sub-protocol...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46900,'Anomaly excised.  Re-assembling remaining material...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46901,'Viable subject compiled.  No anomalies detected.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46902,'User-objective protocol complete.  Stasis protocol re-enabled.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46903,'Tremble in fear as I call forth the mighty Doomskull!','Tremble in fear as I call forth the mighty Doomskull!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46904,'Behold the sheer size of it!  Are you not afraid, mortal?  Have you ever witnessed doom of this magnitude?','Behold the sheer size of it!  Are you not afraid, mortal?  Have you ever witnessed doom of this magnitude?',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(46905,'Cower, monster, as I summon a veritable army of Wolfoids!','Cower, monster, as I summon a veritable army of Wolfoids!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46906,'Now you are surrounded by Wolfoids!  What will you do?  Where can you run?','Now you are surrounded by Wolfoids!  What will you do?  Where can you run?',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(46907,'Take this, you ungrateful elemental. After all I\'ve done for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46908,'AHAHAHAHAHAHA, FIRE? REALLY?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46909,'YOU\'RE NEXT JUST AS SOON AS I FINISH OFF YOUR FRIEND HERE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46910,'Oh yeah? Um... get him!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46911,'Good riddance, you overblown, halfbaked, bomb ignition wannabe! See if I ever summon YOU again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46912,'Okay, let\'s get the controller off of him and use the portal to get out of here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46913,'Wh... what is this?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46914,'I\'m dead! Murdered by the Twilight\'s Hammer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46915,'The Spirit of the Loch sent you here. You seek information.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46916,'They captured and enslaved us. Put us to work on a weapon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46917,'A special project... an artifact for Cho\'gall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46918,'We were to be rewarded for the best work we\'d ever done, and we were... with this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46919,'They imbued it with the power of an Old God.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46920,'The weapon which you seek is called the Hammer of Twilight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46921,'Now leave me be. I see the Light....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46922,'The power...is too much...I cannot hold...any longer...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46923,'She\'s sent you to do her dirty work, has she? I\'ll deal with the countess after I\'ve killed you, fleshling!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46924,'','The Twilight\'s Hammer invaded these once-pristine waters, and the surrounding lands, a short time ago.$B$BThey have polluted my loch and I would have them gone so that I may purify it once more.',33,0,0,0,0,0,0,0,1,0,0,0,26124),
(46925,'Destroy Arcane Fiends near Archmage Ataeric to overload the shield!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46926,'Take this!','Take this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46927,'Aye aye, sir.','',0,0,0,0,0,0,66,0,1,0,19597,0,26124),
(46928,'','This land is where orcs and humans first spilled each other\'s blood. Not a mile south lurks Stonard, where the orcs first grouped to invade our lands.$B$BIt was here they amassed their armies before we even knew they existed. It was here that they started the first of three wars with their attack on a small Alliance town to the west.$B$BMy town. The town where my parents died to save me.$B$BBut I\'m not here to settle a grudge... I\'m here to win a war.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46929,'Whoa...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46930,'Gah!  Wrong again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46931,'I must... concentrate!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46932,'So... difficult!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46933,'C\'mon then lads, set up a perimeter. We hold \'em here or Thundermar is next!','',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(46934,'Take the weapons!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46935,'Disarming','Disarming',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46936,'Yipe!  Help Hogger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46937,'Grrr...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46938,'Nooooo...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46939,'Hogger is eating!  Stop him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46940,'Hogger is stunned!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46941,'Gah!!!  What... how did you..?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46942,'Twizzleflux!  What insanity are you up to?  We brought the additional crew you requested, but there is no... research going on here.  Only madness!','',25,0,0,0,0,0,25,0,1,0,0,0,26124),
(46943,'What the-????   AGGHGHhh...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46944,'Fools!  It is too late for them  And it is too late for all of you! You will join us and together we will unearth secrets that will unravel this world!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46945,'And you... are next!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46946,'','Hi! You\'re new. Did you lose your home too? You can sit with me if you want.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46947,'','Oh my gosh! Thank you SO much! You have no idea how much this means to me. You\'re the sweetest thing!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46948,'','You\'re definitely not Wildhammer. What brings you here? Your timing is pretty horrid, that\'s for sure.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46949,'','Wha... my roses?! Did Cailin tell you?  I really can\'t thank you enough. I thought I\'d never smell home again...',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(46950,'Pleasure to meet ya, young $gman:lady;.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46951,'What the-??','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46952,'My family hammer?! What could have possibly possessed you... never mind, I don\'t care.  You\'ll always be welcome in our home - we\'ll save a place for you at the table.  Thank you.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46953,'No... nooooo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46954,'','For the Bilgewater Cartel! For the Shattered Hand! FOR THE HORDE!',71,0,0,0,0,0,0,0,1,0,0,0,26124),
(46955,'What\'s happening to me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46956,'I found this in the ruins. Cailin told me it was yours...','I found this in the ruins. Cailin told me it was yours...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46957,'Hahahah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46958,'I believe these are yours, Meara.','I believe these are yours, Meara.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46959,'If I\'m not mistaken, this belongs to you.','If I\'m not mistaken, this belongs to you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46960,'They took us unaware... attacked all of the highlands all at once, burstin\' forth from the ground, swoopin\' from the air. Most of the gryphon wings were scattered, and far too many good dwarves lost their lives.$B$BThere\'d be little hope at all if Keegan hadn\'t rallied us together. I owe that man my life. At least now we have a chance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46961,'You\'re certainly not local. Matters to me little though. I\'ll put my life on the line for anyone here as long as they pull their weight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46962,'Use the Mech Control Scrambler to disable Twizzleflux\'s vehicle!','',0,0,0,0,0,0,0,0,1,10785,0,0,26124),
(46963,'I came here long ago to study our cursed brothers, in search of a way to cure their affliction.$B$BMagtoor welcomed me with open arms. Living here, he became my closest friend.$B$BAnd now, before my eyes, he is dying...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46964,'I have failed you, my friend. I am so sorry.','',378,0,0,0,0,0,0,0,1,10790,0,0,26124),
(46965,'It is my time, Avuun. Nobody is to blame...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46966,'','...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46967,'You look like you could make us some money. How about a spin inside the Crucible of Carnage, pal?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(46968,'Avoid the lava waves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46969,'All of the highlands belong to the Dragonmaw, even this pit!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46970,'My little sister could best the lot of ya. This ain\'t no arena. This is a nursery!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46971,'Calder said that if I kill you, I get to have your parts!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46972,'Why hello chaps, I have a not so surprising surprise for you this eve.','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46973,'This land shall be purged in the Twilight\'s Flame! ','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46974,'','I\'ll just leave this right here.',0,0,0,0,0,0,432,0,1,0,0,0,26124),
(46975,'','Now to get the egg...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46976,'','How\'s my little baby doing?',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(46977,'','No... it\'s... it\'s you!  NO!',0,0,0,0,0,0,431,0,1,0,0,0,26124),
(46979,'You impetuous little whelp... I know exactly what you and the mortal are up to.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46980,'Are you ready to die, dragon?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(46981,'','Yes.  Just... just show mercy to the egg.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46982,'Mercy?!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(46983,'THERE IS NO MERCY!  YOU WILL BURN FOR THIS, DRAGON!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46984,'Back, vermin! (Insects! Weak and small!)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46985,'Look, mortal, upon the instrument of your undoing. (The Hammer, hand of the Gods Below.) Forged of molten blood... (...gift of the master. His gift!) Shaped upon the Last Altar of Storm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46986,'The Hammer of Twilight. (The Hammer of Twilight!) Commissioned by the Aspect of Death. It is the breaker of worlds. It is not yours to wield. (Kill the intruders!) Kill them all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46987,'What Deathwing has set in motion... (...no man can stop.) No man! Least of all you wretches. (Show them. Show them their end!)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(46988,'The grand Crucible of Carnage awaits, $n. Remember, once a battle starts you have to stay in the arena. WIN OR DIE!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(46989,'Here we are once again, ladies and gentlemen. The epic struggle between life and death in the Crucible of Carnage! For this round we have $n versus... a really fat ogre? Wait, seriously?! That\'s all we could come up with on short notice? What am I paying you for? ','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46990,'Whatever, let the fight begin!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46991,'The battle is about to begin! $n vs. the vicious Dragonmaw, Torg Drakeflayer! I THINK he\'s vicious anyway - hard to tell. I just let him because they let us take over their old arena here. Here\'s hoping for some blood!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46992,'I\'ve got a LITTLE somethin\' special for ya this time, folks! You aren\'t half the man of this half-man! $n vs. the vicious Wildhammer... SULLY KNEECAPPER!!!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46993,'This match is sure to be SHORT! Okay, okay, I\'m done. Let the bloodbath begin!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46994,'Imagine my surprise when I was approached by the genius forsaken, Calder Gray, and propsitioned with a combatant made of all the best features of our previous champions... LITERALLY! Who could refuse a chance to challenge CALDER\'S CREATION?!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46995,'You know what they say... if you can\'t beat \'em, join \'em! And in this case, you won\'t have the choice! Cruicible of Carnage, I adore you so.','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46996,'Hailing from the semi-distant wreck of a landscape that was once Gilneas, our champion arises! Keep your pants up $n, you don\'t want to show this guy a full moon!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46997,'The Twilight\'s Hammer: happy to serve local nefarious schemes anytime, anywhere. And today is no exception! Our final combatant hails from the not so distant Bastion of Twilight! Or is it the Twilight Bastion... bah, who cares!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46998,'W-W-W-WINNER! We have a winner! Good job and stuff!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(46999,'I DON\'T BELIEVE IT! WE HAVE A NEW CHAMPION OF CARNAGE!!! Our big, bad beefy challenger has been defeated by a ragtag crew of nobodies! Incredible finish!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47000,'No hurt Hogger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47001,'We obey, blood guard. For the Horde!','We obey, blood guard. For the Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47002,'Grunts, $n has lead Orgrimmar\'s fight against the doomsday cultists.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47003,'The cultists have not stopped their attacks. Spread the word: double the guard and arrest anyone suspicious. These orders come from the warchief himself!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47004,'Hold your blade, adventurer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47005,'General Hammond Clay!','General Hammond Clay!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47006,'Wow!','Wow!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47007,'This beast leads the Riverpaw gnoll gang and may be the key to ending gnoll aggression in Elwynn.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(47008,'We\'re taking him into custody in the name of King Varian Wrynn.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47009,'Take us to the Stockades, Andromath.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(47010,'The gryphon appears to be injured. Perhaps healing or first aid could get it back on its feet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47011,'The gryphon looks at you intently, clearly smelling a familiar scent on your clothing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47012,'The gryphon appears to be trapped. It looks like it would be easily possible to break its bonds though.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47013,'You have 1 Holy Power!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47014,'You have 2 Holy Power!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47015,'You have 3 Holy Power!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47016,'Let the gryphon smell the piece of charred highland birch.','Let the gryphon smell the piece of charred highland birch.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47017,'The gryphon muscles tense and eyes tighten as soon as the bark is extended towards it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47018,'Yo you got through the gauntlet! I\'m out!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47019,'','My suffering is eternal!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47020,'The gryphon looks at you with genuine appreciation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47021,'','A vision of Ysera materializes before you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47022,'','$n, you have unleashed the wolf ancient and defeated his shadow. Your actions already reverberate across the dream - thank you. But more remains to be done...',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47023,'','<Ysera\'s image flutters before your eyes, as if in a dream. Nobody else sees her here, yet the vision senses your presence.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47024,'The gryphon screams with glee as you break it free.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47025,'','So Tortolla has risen to fight at our side. You are wise, $n; it is difficult to earn that ancient\'s trust. He will be a stalwart companion.',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(47026,'','The guardian of the skies has taken flight again! This is encouraging news, $n. But much remains undone, and we must turn our attention elsewhere...',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(47027,'','<A dream-like vision of Ysera floats before you, her attention divided. After a moment, she addresses you.>$B$BFor many years, Aviana fluttered at the periphery of my dreams. I wondered if she should ever return to us. I fear her spirit has darkened with the passage of time...$B$BBut we have more immediate concerns if we hope to save this mountain.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47028,'There can be no disruptions! Mustn\'t keep the master waiting! Mustn\'t fail again!','',0,0,0,0,0,0,0,0,1,0,19847,0,26124),
(47029,'Nothing goes to waste... ','',0,0,0,0,0,0,0,0,1,0,19848,0,26124),
(47030,'Strip the flesh, harvest the organs!','',0,0,0,0,0,0,0,0,1,0,19849,0,26124),
(47031,'There will never be another like me...','',0,0,0,0,0,0,0,0,1,0,19850,0,26124),
(47032,'What they lack in intelligence they make up for in ferocity!','',0,0,0,0,0,0,0,0,1,0,19856,0,26124),
(47033,'My failings will be your downfall!','',0,0,0,0,0,0,0,0,1,0,19857,0,26124),
(47034,'Too early, but no choice... They must be tested! Face now my prime subjects!','',0,0,0,0,0,0,0,0,1,0,19858,0,26124),
(47035,'Meet the brawn to my brains! Prime subjects, devour them!','',0,0,0,0,0,0,0,0,1,0,19859,0,26124),
(47036,'|TInterface\\Icons\\INV_POTION_24.BLP:20|tMaloriak throws a |cFFFF0000red|r vial into the cauldron!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47037,'|TInterface\\Icons\\INV_POTION_20.BLP:20|tMaloriak throws a |cFF809FFEblue|r vial into the cauldron!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47038,'|TInterface\\Icons\\INV_POTION_162.BLP:20|tMaloriak throws a |cFF33FF00green|r vial into the cauldron!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47039,'Please champions, rescue my brethren from the Twilight\'s Hammer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47040,'The Twilight Dragonkin must be stopped! Rescue the other Red Dragonflight and we shall assist you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47041,'Some have spent decades meditating upon this mystery, Avuun. I do not wish the same fate upon you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47042,'The Light wishes suffering on none, my child. But it does not reign unopposed in our realm.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47043,'Even now, the true battle between the forces of Light and Darkness approaches. We will all be called to join, and in the face of this conflict, all mortal suffering will be meaningless.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47044,'Magtoor, you have endured your plight bravely. Are you ready to return to the embrace of the Light?','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47045,'Then may the Light save you and raise you up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47046,'Remember, Avuun. Not all who wander are lost.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47047,'Even now, nothing. Why? Why would the Light forsake the innocent?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(47048,'Prophet Velen!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47049,'...thank you, Prophet. You have given both of us great comfort. I will continue my work, in faith and memory of Magtoor.','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(47050,'Hey, look!  It\'s flying!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47051,'Yes...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47052,'','It\'s lovely here, don\'t you think?$b$bA bit hot, perhaps, but it\'s a dry heat...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47053,'Dad always told me the big fellas hit hard, but that they\'re slow...$b$bI\'m pretty sure dad never met this guy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47054,'Madness. Chaos. Much as I thrill to see the titans\' work undone, I do wish to remain alive when the master returns. I will help you.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47055,'<Blackhorn gazes out across the distant inferno, then turns his attention back to you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47056,'All I wanted was a little peace and quiet!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47057,'Foolish mortals!  You toy with arcane powers beyond your understanding!  I will put an end to this mockery of magic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47058,'Heroes, you are not alone in this dark place!','',0,0,0,0,0,0,0,0,0,0,21588,0,26124),
(47059,'Sintharia, your master owes me a great debt -- one that I intend to extract from his consort\'s hide!','',0,0,0,0,0,0,0,0,1,0,21590,0,26124),
(47060,'Those filthy mutts forced me out of Fenris Keep, I won\'t be forced out of my camp as well!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47061,'','Hail to the queen!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47062,'','No mercy for the weak!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47063,'It was inevitable!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47064,'You die in vain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47065,'That\'ll learn ye!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47066,'Get back up! I DARE YE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47067,'Ho, ho! That had to hurt!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47068,'Hah! Too easy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47069,'They should show you a degree of trust.','',0,0,0,0,0,0,1,0,1,0,21761,0,26124),
(47070,'At least enough so that you can prove yourself.','',0,0,0,0,0,0,1,0,1,0,21762,0,26124),
(47071,'This champion has proved intent and capable.','',0,0,0,0,0,0,0,0,1,10401,21765,0,26124),
(47072,'I see no reason to deny our trust.','',0,0,0,0,0,0,0,0,1,10401,21766,0,26124),
(47073,'An inconspicuous marble slab.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47074,'Place the statue down on the slab.','Place the statue down on the slab.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47075,'An inconspicuous stone slab.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47076,'Cenarius has fallen!','',0,0,0,0,0,0,0,0,1,0,21639,0,26124),
(47077,'<The enormous ancient remains wary of you, but speaks to you as an ally.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47078,'Get back up there and get into the fight!','Get back up there and get into the fight!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47079,'','All the oceans shall be ours, and then we shall look beyond.',0,0,0,0,0,0,1,0,1,0,0,21804,26124),
(47080,'','I took Helgrum under my wing when I arrived in Stonard. Under my harsh glare, he became an even greater tracker than before... and my only companion.$B$BI thought myself strong. I thought no suffering could break my spirit. When I saw the humans sink their swords into Helgrum... into my mate... I found out how wrong I was.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47081,'Find a Tree to Climb','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47082,'Grab a Bear Cub','',0,0,0,0,0,0,0,0,0,10808,0,0,26124),
(47083,'Climb to the Tree Top','',0,0,0,0,0,0,0,0,0,10809,0,0,26124),
(47084,'Chuck the Bear Cub!','',0,0,0,0,0,0,0,0,0,10810,0,0,26124),
(47085,'I am Prince Nadun of Ramkahen.  The Neferset tribe has turned against the other tol\'vir.$B$BHelp me escape so that I may lobby my brother, the king, to wage war against these traitors!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47086,'I am Prince Nadun of Ramkahehn.  My people are tol\'vir... or descended from the tol\'vir to be precise.$B$BThe people of Neferset were like us, made of flesh and blood...$B$BUntil Deathwing came.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47087,'He offered all of us a chance to regain our former glory... to be true tol\'vir again.$B$BBut only... if we swore allegiance to him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47088,'We are keepers of the secrets of Uldum.  Beneath the sand... under the pyramids... there exists great power.$B$BThe power to make and break an entire world.$B$BHe cannot access this power without us, however.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47089,'He\'s got one of the tribes on his side.  The Neferset.$B$BOrsis has made its defiance clear.$B$BRamkahen has tried to find a peaceful solution, but there is no peace possible with Deathwing and his allies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47090,'Free me.$B$BFree me so that we may rally my people against Deathwing together.$B$BAnd if that\'s not reason enough, you will be rewarded with great riches.  I am still a prince after all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47091,'Who are you?','Who are you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47092,'Deathwing came here and didn\'t slay you all?','Deathwing came here and didn\'t slay you all?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47093,'Why does he need you?','Why does he need you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47094,'So not all of your people have allied with him?','So not all of your people have allied with him?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47095,'Agreed.  So what do you want from me?','Agreed.  So what do you want from me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47096,'Quick! Into the plane!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(47097,'$n prepares a feast of Broiled Dragon!','$n prepares a feast of Broiled Dragon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47098,'$n prepares a feast of Seafood Magnifique!','$n prepares a feast of Seafood Magnifique!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47099,'Pathetic. ','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(47100,'Keep moving forward. My men will dispose of this sorry bag of bones.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(47101,'The Bloodfang Berserkers begin to salivate heavily.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47102,'Control yourselves! We\'re here for Godfrey\'s head above all else. Relish in the spoils of war later!','',25,1,0,0,0,0,0,0,1,0,0,0,26124),
(47103,'We have to push forward if we\'re to put an end to him. Follow me, I\'ll open the courtyard so that you can spearhead our assault.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(47104,'Get zhem!! Now! Go, go, go!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(47105,'I can teach you the basics of any gathering or production profession, but that\'s all.\n\nTo learn more than an apprentice\'s skills, you\'ll need to visit a specialist dedicated to only one profession.\n\nYou can learn up to two professions: Two gathering, two production, or one of each.\n\nSecondary skills like Archaeology, Cooking, First Aid, and Fishing don\'t count towards your two professions; you can learn as many of those as you like.','I can teach you the basics of any gathering or production profession, but that\'s all.\n\nTo learn more than an apprentice\'s skills, you\'ll need to visit a specialist dedicated to only one profession.\n\nYou can learn up to two professions: Two gathering, two production, or one of each.\n\nSecondary skills like Archaeology, Cooking, First Aid, and Fishing don\'t count towards your two professions; you can learn as many of those as you like.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47106,'Tell me about gathering professions.','Tell me about gathering professions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47107,'Tell me about production professions.','Tell me about production professions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47108,'Gathering professions allow you to acquire raw materials used by production professions: gathering herbs; mining ore, stone, and jewels; or skinning beasts for their hides.\n\nYou can either support a related production profession with gathering, or simply sell the raw materials on the auction house.','Gathering professions allow you to acquire raw materials used by production professions: gathering herbs; mining ore, stone, and jewels; or skinning beasts for their hides.\n\nYou can either support a related production profession with gathering, or simply sell the raw materials on the auction house.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47109,'Train me in Alchemy.','Train me in Alchemy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47110,'Train me in Blacksmithing.','Train me in Blacksmithing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47111,'Train me in Enchanting.','Train me in Enchanting.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47112,'Train me in Herbalism.','Train me in Herbalism.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47113,'Train me in Inscription.','Train me in Inscription.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47114,'Train me in Jewelcrafting.','Train me in Jewelcrafting.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47115,'Train me in Leatherworking.','Train me in Leatherworking.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47116,'Train me in Mining.','Train me in Mining.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47117,'Train me in Skinning.','Train me in Skinning.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47118,'Train me in Tailoring.','Train me in Tailoring.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47119,'Train me in Engineering.','Train me in Engineering.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47120,'Hold your ground. We Wildhammer go down fighting to the end!','',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(47121,'First of all, it wasn\'t sunny out.  It was cloudy when Deathwing appeared.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47122,'The cowardly dragon must have seen me, because he turned away and flew into the clouds.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47123,'Luckily, I had been tinkering with my world-shrinking device.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47124,'\"I\'ll find you in those clouds, you worm!\" I yelled.  \"And then I\'ll throw you to Kalimdor!\"','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47125,'I\'ll find you in those clouds, you worm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47126,'And then I\'ll throw you to Kalimdor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47127,'I decided to keep shrinking the world until I could reach the clouds.$b$b|TInterface\\Icons\\inv_helmet_47.blp:32|t','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47128,'The High Shaman is here - I can see the storm clouds. Crush him, that we may take his skull as a trophy!','The High Shaman is here - I can see the storm clouds. Crush him, that we may take his skull as a trophy!',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(47129,'Production professions allow you to turn raw materials into items that you can use yourself, give to companions, or sell at an auction house.\n\nThey are often paired with a gathering profession so that you can gather your own raw materials, but it is possible to simply buy materials on the auction house.','Production professions allow you to turn raw materials into items that you can use yourself, give to companions, or sell at an auction house.\n\nThey are often paired with a gathering profession so that you can gather your own raw materials, but it is possible to simply buy materials on the auction house.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47130,'Herbalism allows you to locate and gather herbs from the wild. These can be sold at the auction house or used to support the Alchemy or Inscription professions.\n\nSkilled herbalists can also use their knowledge of the earth to heal themselves.','Herbalism allows you to locate and gather herbs from the wild. These can be sold at the auction house or used to support the Alchemy or Inscription professions.\n\nSkilled herbalists can also use their knowledge of the earth to heal themselves.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47131,'Mining allows you to locate and mine ore, minerals and stone from mining nodes in the wilderness and underground. These can be sold at the auction house or used to support the Blacksmithing, Engineering, or Jewelcrafting professions.\n\nSkilled miners also become tough and gain increased Stamina.\n\nYou\'ll need a Mining Pick in order to mine; this can be purchased from trade or Mining vendors.','Mining allows you to locate and mine ore, minerals and stone from mining nodes in the wilderness and underground. These can be sold at the auction house or used to support the Blacksmithing, Engineering, or Jewelcrafting professions.\n\nSkilled miners also become tough and gain increased Stamina.\n\nYou\'ll need a Mining Pick in order to mine; this can be purchased from trade or Mining vendors.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47132,'Skinning allows you to remove and prepare the hides from slain creatures. These can be sold at the auction house or used to support the Leatherworking profession.\n\nSkilled Skinners also become masters of anatomy, increasing their chances to critically hit a target.\n\nYou\'ll need a Skinning Knife in order to skin creatures; this can be purchased from trade or Leatherworking vendors.','Skinning allows you to remove and prepare the hides from slain creatures. These can be sold at the auction house or used to support the Leatherworking profession.\n\nSkilled Skinners also become masters of anatomy, increasing their chances to critically hit a target.\n\nYou\'ll need a Skinning Knife in order to skin creatures; this can be purchased from trade or Leatherworking vendors.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47133,'Alchemy allows you to use herbs and other materials to create a wide variety of useful elixirs, potions, oils, flasks and cauldrons. You\'ll also gain greater, longer-lasting benefits when using your own elixirs and flasks.\n\nHighly skilled alchemists may also transmute elemental materials and certain minerals for use by other production professions.\n\nAlchemy pairs well with Herbalism as it allows you to gather your own herbs.','Alchemy allows you to use herbs and other materials to create a wide variety of useful elixirs, potions, oils, flasks and cauldrons. You\'ll also gain greater, longer-lasting benefits when using your own elixirs and flasks.\n\nHighly skilled alchemists may also transmute elemental materials and certain minerals for use by other production professions.\n\nAlchemy pairs well with Herbalism as it allows you to gather your own herbs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47134,'Blacksmithing allows you to forge items from metals, minerals and stones: melee weapons, mail and plate heavy armor, raw materials used by other production professions, and upgrades to pieces of equipment such as sharpening stones and shield spikes.\n\nHighly skilled blacksmiths can add a gem slot to their own bracers and gloves, as well as to their own or others\' belts. These gem slots may then be filled with magical gems that make the gemmed item more powerful.\n\nBlacksmithing pairs well with Mining as it allows you to gather your own ore and minerals.','Blacksmithing allows you to forge items from metals, minerals and stones: melee weapons, mail and plate heavy armor, raw materials used by other production professions, and upgrades to pieces of equipment such as sharpening stones and shield spikes.\n\nHighly skilled blacksmiths can add a gem slot to their own bracers and gloves, as well as to their own or others\' belts. These gem slots may then be filled with magical gems that make the gemmed item more powerful.\n\nBlacksmithing pairs well with Mining as it allows you to gather your own ore and minerals.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47135,'Dragonmaw attack! Protect the High Shaman.','Look out - Dragonmaw!',0,0,0,0,0,0,274,7,1,0,0,0,26124),
(47136,'Enchanting allows you to enchant items with a wide variety of beneficial effects, as well as disenchant items and create magical wands and oils.\n\nHighly skilled enchanters can even enchant their own rings, which no one else may do.\n\nMost raw materials for Enchanting must be gathered via disenchanting, a process which destroys the disenchanted item. For this reason the profession pairs well with Tailoring, as you can disenchant the magical Tailoring items you create for raw materials.\n\nEnchanters may also place enchantments upon vellum, which allows the enchantment to be sold or saved for later use. Vellum and other useful Enchanting materials may be purchased from Enchanting vendors.','Enchanting allows you to enchant items with a wide variety of beneficial effects, as well as disenchant items and create magical wands and oils.\n\nHighly skilled enchanters can even enchant their own rings, which no one else may do.\n\nMost raw materials for Enchanting must be gathered via disenchanting, a process which destroys the disenchanted item. For this reason the profession pairs well with Tailoring, as you can disenchant the magical Tailoring items you create for raw materials.\n\nEnchanters may also place enchantments upon vellum, which allows the enchantment to be sold or saved for later use. Vellum and other useful Enchanting materials may be purchased from Enchanting vendors.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47137,'Engineering allows you to construct a wide variety of useful, amazing, and just plain weird items like rifles and scopes, motorcycles, and mechanical squirrels. However, many of these are only usable by yourself or other engineers, such as special goggles, mechanical additions to belts, boots, gloves and cloaks, and flying machines.\n\nMost raw Engineering materials are metals gathered by Mining, so the two professions pair well.\n\nMany creations require the use of a Blacksmith Hammer; this and other necessary materials, such as gun stocks or flux, may be purchased from trade or Engineering vendors.','Engineering allows you to construct a wide variety of useful, amazing, and just plain weird items like rifles and scopes, motorcycles, and mechanical squirrels. However, many of these are only usable by yourself or other engineers, such as special goggles, mechanical additions to belts, boots, gloves and cloaks, and flying machines.\n\nMost raw Engineering materials are metals gathered by Mining, so the two professions pair well.\n\nMany creations require the use of a Blacksmith Hammer; this and other necessary materials, such as gun stocks or flux, may be purchased from trade or Engineering vendors.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47138,'Inscription allows you to create magical scrolls, glyphs, off-hand tomes, Darkmoon cards, and even recipes for other professions.\n\nMany raw materials for Inscription come from milling herbs gathered by Herbalism, so the two professions pair well.\n\nYou\'ll need a Virtuoso Inking Set for inscribing things; this and other necessary materials, such as parchment, may be purchased from Inscription vendors.','Inscription allows you to create magical scrolls, glyphs, off-hand tomes, Darkmoon cards, and even recipes for other professions.\n\nMany raw materials for Inscription come from milling herbs gathered by Herbalism, so the two professions pair well.\n\nYou\'ll need a Virtuoso Inking Set for inscribing things; this and other necessary materials, such as parchment, may be purchased from Inscription vendors.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47139,'Jewelcrafting allows you to fashion magical rings, amulets, and trinkets as well as cut gems.\n\nThe gems used in Jewelcrafting may be purchased or acquired via Prospecting from ore gathered by Mining; for this reason the two professions pair well.\n\nMost Jewelcrafting designs also require a Jeweler\'s Kit while more advanced creations require a Simple Grinder; these may be purchased from Jewelcrafting vendors.','Jewelcrafting allows you to fashion magical rings, amulets, and trinkets as well as cut gems.\n\nThe gems used in Jewelcrafting may be purchased or acquired via Prospecting from ore gathered by Mining; for this reason the two professions pair well.\n\nMost Jewelcrafting designs also require a Jeweler\'s Kit while more advanced creations require a Simple Grinder; these may be purchased from Jewelcrafting vendors.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47140,'Leatherworking allows you to fashion armor, cloaks, armor-reinforcing kits, and other similar items from leather, hides, and scales. Other materials required for leatherworking can be purchased at trade and Leatherworking vendors.\n\nLeatherworking pairs well with Skinning as it allows you to gather your own raw materials; other necessary items, such as threads and dyes, can be purchased from trade or Leatherworking vendors.\n\nHighly skilled leatherworkers can also enforce their bracers and leg armor.','Leatherworking allows you to fashion armor, cloaks, armor-reinforcing kits, and other similar items from leather, hides, and scales. Other materials required for leatherworking can be purchased at trade and Leatherworking vendors.\n\nLeatherworking pairs well with Skinning as it allows you to gather your own raw materials; other necessary items, such as threads and dyes, can be purchased from trade or Leatherworking vendors.\n\nHighly skilled leatherworkers can also enforce their bracers and leg armor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47141,'Tailoring allows you to fashion armor, cloaks, clothing, bags, spellthread, and other similar items from various types of cloth, which can be purchased or taken from slain humanoid enemies. Additional necessary materials such as threads and dyes can be purchased from trade or Tailoring vendors.\n\nHighly skilled tailors can also upgrade their cloaks with magical embroidery.\n\nEnchanters are often tailors as well, since they can disenchant the magical items they create.','Tailoring allows you to fashion armor, cloaks, clothing, bags, spellthread, and other similar items from various types of cloth, which can be purchased or taken from slain humanoid enemies. Additional necessary materials such as threads and dyes can be purchased from trade or Tailoring vendors.\n\nHighly skilled tailors can also upgrade their cloaks with magical embroidery.\n\nEnchanters are often tailors as well, since they can disenchant the magical items they create.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47142,'Tell me about Herbalism.','Tell me about Herbalism.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47143,'Tell me about Mining.','Tell me about Mining.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47144,'Tell me about Skinning.','Tell me about Skinning.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47145,'Tell me about Alchemy.','Tell me about Alchemy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47146,'Tell me about Blacksmithing.','Tell me about Blacksmithing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47147,'Tell me about Enchanting.','Tell me about Enchanting.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47148,'Tell me about Engineering.','Tell me about Engineering.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47149,'Tell me about Inscription.','Tell me about Inscription.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47150,'Tell me about Jewelcrafting.','Tell me about Jewelcrafting.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47151,'Tell me about Leatherworking.','Tell me about Leatherworking.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47152,'Tell me about Tailoring.','Tell me about Tailoring.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47153,'What? MORE Dragonmaw? Stay close - they\'re comin\' from all sides!','',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(47154,'Once the world was small enough, I started to hunt for Deathwing in the clouds.$b$b|TInterface\\Icons\\spell_frost_arcticwinds.blp:32|t','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47155,'Great fight, everyone! A few more notches in my hammer and a few less Dragonmaw to threaten Thundermar.','',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(47156,'Guard the main road. These Dragonmaw are just stupid enough to try again.','',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(47157,'The Bloodfang come for you, worgen hunters!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47158,'Commander Springvale is down that hall, heroes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47160,'The Wildhammer High Shaman is finished. Count up our dead. Bloodgulch will want to hear of our triumph!','The Wildhammer High Shaman is finished. Count up our dead. Bloodgulch will want to hear of our triumph!',0,0,0,0,0,0,273,1,1,0,0,0,26124),
(47161,'They will return soon. Let\'s get back to Bloodgulch.','They will return soon. Let\'s get back to Bloodgulch.',0,0,0,0,0,0,25,1,1,0,0,0,26124),
(47162,'Use the meteor on the ground to launch a critical attack on the %s!','Use the meteor on the ground to launch a critical attack on the %s!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47163,'I had searched every cloud, but I couldn\'t find Deathwing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47164,'It was then that I realized: he was hiding in the sun.  I looked up.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47165,'','You have a bad feeling about this basement...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47166,'The sun burned me bad, but I got my hands around his slimy neck.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47167,'I summoned all my strength, faced west, and threw him to Kalimdor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47168,'You\'ve got to try some of this beer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47169,'Tell me that story again, Lucien.','Tell me that story again, Lucien.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47170,'Where are you, dragon?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47171,'Are you hiding in this cloud?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47172,'Lucien\'s gonna getcha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47173,'Surprise, dragon!  Aw, shucks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47174,'Where you at?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47175,'He can\'t have gotten far...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47176,'When I find that dragon, I\'m gonna throw him to Kalimdor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47177,'I hate you, Deathwing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47178,'Wow, Lucien.  You need to stop drinking RIGHT NOW.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47179,'If you\'re not here to work, then please see yourself away from our excavation.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47180,'Hey there, good lookin\'.','Hey there, good lookin\'.',0,0,0,0,0,0,17,0,1,0,0,0,26124),
(47181,'You got room for one more, sugar?','You got room for one more, sugar?',0,0,0,0,0,0,17,0,1,0,0,0,26124),
(47182,'Going my way?','Going my way?',0,0,0,0,0,0,17,0,1,0,0,0,26124),
(47183,'Can a lady get a ride?','Can a lady get a ride?',0,0,0,0,0,0,17,0,1,0,0,0,26124),
(47184,'You\'re looking very handsome today, Martek.','You\'re looking very handsome today, Martek.',0,0,0,0,0,0,17,0,0,0,0,0,26124),
(47185,'Ooh, Martek, can I ride with you?','Ooh, Martek, can I ride with you?',0,0,0,0,0,0,17,0,0,0,0,0,26124),
(47186,'Martek, you are the bravest orc I know.','Martek, you are the bravest orc I know.',0,0,0,0,0,0,17,0,0,0,0,0,26124),
(47187,'Save me, Martek!  I need you!','Save me, Martek!  I need you!',0,0,0,0,0,0,17,0,0,0,0,0,26124),
(47188,'Hop in, baby.','Hop in, baby.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47189,'I\'ve picked up Walden\'s foul scent. Fill the air with his blood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47190,'Bones?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47191,'','This path only leads deeper into the city. Keep going south toward the Loading Room.',0,0,0,0,0,0,5,0,1,10831,0,0,26124),
(47192,'I\'m gonna punch that dragon in the face!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47193,'Let\'s move!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47194,'I\'ve got a bad feeling about this...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47195,'One of Clay\'s catapult teams is broken down on the front. $n, I need you to get some parts from him and get that catapult back in the fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47196,'Vhat a pleasure, $c.$b$bVe get so few visitors zhese days.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47197,'','Vhat a surprise!$b$bVe veren\'t expecting anyvone today...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47198,'The day that Deathwing came, blood rained from the skies.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47199,'I believe I was showing my motorcycle to some hot babes at the time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47200,'After Deathwing appeared, they became quite frightened, but I only had room to rescue one of them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47201,'Obviously, I picked the orc.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47202,'Obviously, I picked the human.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47203,'Obviously, I picked the night elf.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47204,'Obviously, I picked the blood elf.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47205,'We rode off down the canyon, careful to avoid falling rocks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47206,'When I reached the end of the canyon, I remembered that my motorcycle could fly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47207,'That would have been helpful to know earlier.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47208,'I flew to the top of the pillar located just north of the canyon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47209,'Atop the pillar, I saw him: Deathwing.  The time for the ultimate confrontation had arrived.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47210,'Hey, stop it Theldurin!  This is my story!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47211,'Cut it out guys!  Quit interrupting!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47212,'Fine.  You don\'t get to hear about how I beat Deathwing in a knife fight.  Your loss.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47213,'During the flight, I shared a tender moment with the lovely orc.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47214,'During the flight, I shared a tender moment with the attractive human.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47215,'During the flight, I shared a tender moment with the grateful young night elf.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47216,'During the flight, I shared a tender moment with the strapping blood elf.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47217,'You disturb my work, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47218,'I have ... failed the master...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47219,'Ve meet again, Doctor Jones! Zhanks to your vork in zhis region, my mission has become much easier.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47220,'I need another Doomsday Message board.','I need another Doomsday Message board.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47221,'Gather close. We\'re doing this. Let\'s roll!','',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(47222,'No!  I love you, Martek!','No!  I love you, Martek!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(47223,'Why?  Why are you leaving me?','Why?  Why are you leaving me?',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47224,'I loved you, Martek!','I loved you, Martek!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(47225,'I\'m just happy to have known you while I lived, Martek.','I\'m just happy to have known you while I lived, Martek.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(47226,'Goodbye, Martek.','Goodbye, Martek.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(47227,'Rest here a moment. Gather your strength.','',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(47228,'I can die in peace, knowing that my last few moments were with Martek.','I can die in peace, knowing that my last few moments were with Martek.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(47229,'I\'ll never forget that magical summer we shared, Martek.','I\'ll never forget that magical summer we shared, Martek.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(47230,'Woo hoo!  Martek picked me!','Woo hoo!  Martek picked me!',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(47231,'Right then! Keep your eyes open for civilians. Let\'s move. For Thundermar!','',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(47232,'We\'ve done all we can here. Let\'s get back to Thundermar!','',0,0,0,0,0,0,1,7,1,0,0,0,26124),
(47233,'I must admit, I am intrigued by this ambitious little upstart.$b$bI\'m not rushing to judgment, mind you, but I\'ve heard some unsettling rumors.$b$bTime will tell if his motives are just.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47234,'This is quite an operation here, wouldn\'t you say?','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47235,'What... is that thing?!','The statue is alive?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47236,'I know what you\'re up to, Schnottz! Deathwing will never have the coffer, not if I can help it!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(47237,'Quite an operation, indeed. What do you think of our host?','Quite an operation, indeed. What do you think of our host?',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47238,'Fists of frost!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47239,'Fists of flame!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47240,'What brings you to a bunch of old, washed-up desert dogs like us?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(47241,'Look out - Dragonmaw ambush!','',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(47242,'Tell me that story again, Martek.','Tell me that story again, Martek.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47243,'I\'ve encountered some of his underlings out in the field. They\'ve been quite hostile.','I\'ve encountered some of his underlings out in the field. They\'ve been quite hostile.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47244,'I\'m not surprised.$b$bSo many questions, I cannot ignore...$b$bWhy all these weapons for an archaeological dig? And what is being done with the unearthed relics? Under what authority is the excavation being conducted?$b$bThe answers don\'t seem to be forthcoming. I\'ll just have to find out for myself, I suppose.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47245,'Vell in zhat case, ve must ensure zhat you and your friend are out of zhe picture.','',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(47246,'Eediot!$b$bAvay vizh you!$b$bCan\'t you see zhat I am concentratink?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47247,'The rockling rumbles in appreciation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47248,'The rockling looks confused for a moment before running off.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47249,'The rockling clatters its crystals together in thanks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47250,'The rockling looks up at you questioningly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47251,'You hear a loud cracking noise as the rockling tries to smile.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47252,'The rockling thuds happily upon the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47253,'The rockling offers a great gravelly sigh of appreciation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47254,'The rockling scampers into the distance, excited by its newfound freedom.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47255,'Sorry about the interruption, Martek.  You\'ve gotta admit though... I made your story about fifty times better.  Next drink\'s on me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(47256,'Glubtok show you da power of de arcane!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47257,'I say! Raise a glass, my friend!$b$bTake in the sights here.$b$bThis entire region has been hidden away for ages, you know.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47258,'What do you know of our generous host, sir?','What do you know of our generous host, sir?',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47259,'Why, just look at the treasure he has accumulated!$b$bI\'m not always comfortable with his methods, but there\'s no denying the results...$b$bBest not to dwell upon unpleasant thoughts. It\'s bad manners, you know.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47260,'Hmmm, well what is it that brings you to these parts?','Hmmm, well what is it that brings you to these parts?',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47261,'Speculation, my dear $gboy:girl;!$b$bOnce our eager little furrier has unearthed enough treasure, he\'ll be one of Azeroth\'s most influential figures.$b$bWe\'ll all be properly positioned when that comes to pass.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47262,'They haven\'t noticed us yet. Hurry, maybe we can still stop them!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47263,'I figured I might see you again, Schnottz.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47264,'Not so fast, Schnottz! ','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47265,'Permanently!','',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(47266,'You von\'t live to see your precious coffer, Jones!','',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(47267,'Now, isn\'t this the place to be?$b$bTouring unexplored corners of the world with likeminded fellows?$b$bWhat could be better?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(47268,'Indeed! And how do you find the Commander, friend?','Indeed! And how do you find the Commander, friend?',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47269,'He\'s a bit animated for my tastes, but the world needs all kinds, I suppose.$b$bWhy do you ask?\n','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(47270,'Destroy the Obsidian Colossus!','Destroy the Obsidian Colossus!',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(47271,'His troops, these guards... it all seems a little intense.','His troops, these guards... it all seems a little intense.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47272,'I see what you mean, I suppose...$b$bYou know, I\'m just here because I want to expand my horizons a bit, see the world and whatnot.$b$bI\'m not terribly concerned with the goings on of others.$b$bNice to meet you, though.\n','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47273,'Avoid the beams of searing light!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47274,'','Exquisite weather here, wouldn\'t you say, $c?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(47275,'I\'m out of here!','I\'m out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47276,'Ahh, yes. How have you been enjoying your time here?','Ahh, yes. How have you been enjoying your time here?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(47277,'','Oh, it\'s been wonderful!$b$bThe commander is so confident, and that accent! I must admit, he\'s quite captivating.$b$bDo you know if he\'s married?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(47278,'Uhhh.. I\'m not sure. Anything else you can tell me about him?','Uhhh.. I\'m not sure. Anything else you can tell me about him?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(47279,'','Word has it that some of the relics in these parts hold mystical power!$b$bHe seems to be fascinated with such things...',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(47280,'What do you think about the troops he\'s arming? Seems a little excessive, no?','What do you think about the troops he\'s arming? Seems a little excessive, no?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(47281,'','I\'m sorry, $c.$b$bI really don\'t know enough to discuss such things. And honestly, I would prefer to keep it that way.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47282,'So, zhis is zhe $r $c I haf heard so much about, hmm?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47283,'State your business, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47284,'Ve\'re vatchink you, $r...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47285,'...alvays vatchink!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47286,'If you can\'t fight Zoltrik at range, use your Jump Drakes! ability:\n\n|TInterface\\Icons\\ability_vehicle_launchplayer.blp:64|t','If you can\'t fight Zoltrik at range, use your Jump Drakes! ability:\n\n|TInterface\\Icons\\ability_vehicle_launchplayer.blp:64|t',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47287,'','Dragon\'s Mouth was established to give the Alliance their first real foothold here in the Badlands.  Despite its position between Stormwind and Dun Morogh, the Badlands have traditionally been Horde territory.$b$bIf that\'s ever to change, we need to start asserting ourselves.  Of course, the dragon attacks on New Kargath don\'t hurt our cause either.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(47288,'I was as surprised as you to find the black dragonflight asserting its will against New Kargath.  Gorn is stubborn, and refuses help from anyone.$b$bEven so, High Examiner Bloodwatcher has asked me to watch from a distance, to make sure things do not become... ugly.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(47289,'We must keep Therazane\'s forces from attacking Stonehearth.$B$BIf they do, they will steal the middle fragment of the World Pillar.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(47290,'Heroes!  My power wanes....','',0,0,0,0,0,0,0,0,0,0,21589,0,26124),
(47291,'','You mistake this for weakness?  Fool!',0,0,0,0,0,0,0,0,1,0,0,20203,26124),
(47292,'','Enough!  Drawing upon this source will set us back months.  You should feel honored to be worthy of its expenditure.  Now... die!',0,0,0,0,0,0,0,0,1,0,0,20206,26124),
(47293,'The fires dim, champions....  Take this, the last of my power.  Succeed where I have failed.  Avenge me.  Avenge the world....','',0,0,0,0,0,0,0,0,0,0,21591,0,26124),
(47294,'A new victim! Me was almost don wit dis one anyway. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47295,'All hail, $n! Huzzah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47296,'Huzzah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47297,'Indeed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47298,'','Need something?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47299,'A boat ride to the Badlands, please.','A boat ride to the Badlands, please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47300,'We fish, we sleep, and we explode things.  What could be better than that?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47301,'Could I get a boat ride to Eastern Plaguelands, please?','Could I get a boat ride to Eastern Plaguelands, please?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47302,'Zeppelin arrival in six minutes.','',0,0,0,0,0,0,0,0,1,0,22491,0,26124),
(47303,'Zeppelin arrival in five minutes.','',0,0,0,0,0,0,0,0,1,0,22491,0,26124),
(47304,'Zeppelin arrival in four minutes.','',0,0,0,0,0,0,0,0,1,0,22491,0,26124),
(47305,'Zeppelin arrival in three minutes.','',0,0,0,0,0,0,0,0,1,0,22491,0,26124),
(47306,'Zeppelin arrival in two minutes.','',0,0,0,0,0,0,0,0,1,0,22491,0,26124),
(47307,'Zeppelin arrival in one minute. One minute.','',0,0,0,0,0,0,0,0,1,0,22491,0,26124),
(47308,'Boarding the Spear of Durotar, are we? You are to be envied, Horde marine!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47309,'You are about to rip the horizon a new sky-hole aboard a sensational new era in aeronautical innovation. ','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(47310,'It\'s been recklessly engineered with a merciless disregard for both budgetary concerns and those cumbersome, inefficient \"laws of physics.\"','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47311,'While you wait for its arrival, my assistant and I will momentarily demonstrate some of the features of this remarkable aircraft.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47312,'As you know, air weighs nothing. So to create a lighter-than-air vessel, we had to bend a few rules.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47313,'The Spear of Durotar is filled to the bursting point with combustible, super-heated gas.','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(47314,'Bilgewater engineers have taken advantage of its inherent high-altitude instability and resultant low-cost.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47315,'We\'ve mitigated the explosive instability of the gas by putting it under IMMENSE pressure.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47316,'Doing so required the removal of a number of safety valves that kept erupting. ','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(47317,'Oh my, yes. In order to maximize both range and payload, we\'ve concocted an unorthodox blend of rocket fuels for the state-of-the-art engines.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(47318,'It is so energy-dense as to combust at the slightest provocation.','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(47319,'This stuff is so volatile, it probably shouldn\'t be moved. Much less... flown.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(47320,'Your course today will take you directly across the great sea.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47321,'An enormous, unforgiving expanse of pounding grey waves, freezing temperatures, and ravenous sea life.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(47322,'Trust me, friend, a rapid pill-induced death is far preferable to the long, agonizing process of hypothermia and subsequent dismemberment by sharks.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47323,'Don\'t ask how we know what they taste like.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(47324,'Should your zeppelin be attacked en-route, panic is inadvisable.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(47325,'Instead, look for a number of deck-mounted flak cannons positioned for just such an emergency.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47326,'Greely, show them how the guns work.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(47327,'Simply aim and pull the trigger. Or don\'t aim. I wash my hands of the whole thing.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47328,'Greely, you\'re not randomly firing that thing into Bilgewater Port, are you?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(47329,'In the unlikely event that a catastrophic failure does not instantly kill everyone aboard...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47330,'...a number of parachutes will appear along the railings.','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(47331,'Simply grab a nearby parachute to be vaulted clear of the burning zeppelin. Hopefully onto dry land.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47332,'Greely, would you like to demonstrate how our parachutes work?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(47333,'Very well then. I see that the Spear of Durotar has almost arrived.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47334,'Your safety and well-being are no longer any concern of mine.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(47335,'Have fun storming the Highlands!','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(47336,'','Not a penny was wasted on comfort or personal safety! ',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(47337,'','We bent the crap outta them!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47338,'','We passed the savings on to us.',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(47339,'','Ask yourself: what good is a \"safety\" valve if it keeps going off? That doesn\'t sound very safe to me.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(47340,'','Tell \'em about the engines, boss.',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(47341,'','We call it \"Doom Juice.\"',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47342,'','Even verbal.',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(47343,'','To ensure a rapid crew response in the event of a fire, fuel storage has been moved away from the crew quarters and placed beneath the passenger compartment.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47344,'','In the unlikely event of a water \"landing,\" please reach under your seat cushion where a cyanide capsule has been located for your convenience.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47345,'','For those of you allergic to almonds, our cyanide capsules come in an assortment of flavors.',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(47346,'','You\'ll also find a complementary bag of peanuts.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47347,'','Nothing keeps a fleet of combustible dirigibles safer than randomly flinging molten metal in every conceivable direction!',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(47348,'','With Pleasure!',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(47349,'','I can hit my house from here!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47350,'','No.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(47351,'','Maybe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47352,'','A little.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47353,'','We call them \"Emergency Rampless Debarkation Devices.\"',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47354,'','Oh hells no! Those things are death-traps!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47355,'','From all of us at Bilgewater Harbor...',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47356,'','Have fun storming the Highlands!',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(47357,'Avoid the shadow runes!','Avoid the shadow runes!',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(47358,'Carefully Collecting','Carefully Collecting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47359,'Daaaaaaamn... Loss of potential revenue is devastating.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47360,'Zhat vhich you seek vill soon be mine, Doctor Jones!','',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(47361,'Glubtok ready?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47362,'Let\'s do it!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(47363,'ARCANE POWER!!!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(47364,'Crowley is a disgrace to our kind for giving in to the Forsaken. My pack will show them the true face of the worgen and the relentless fury that comes with our presence!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47365,'What a pathetic lock! Godfrey is going to have to try harder than this if he wants to defeat us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47366,'Your time has finally come, Godfrey!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47367,'','I travelled all this way to speak with the famed \"Seer of the Dragonmaw.\" I wanted to see inside Cho\'gall\'s dark heart before I tear it out.$B$BBut she\'s worthless to me. All riddles and rhyme. Maybe you can help.',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(47368,'The coffer is just beyond these ruins.$b$bLet\'s go!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47369,'I\'m ready. Let\'s go!','I\'m ready. Let\'s go!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47370,'For too long we have ignored the secrets of the Arcane.$B$BAre you here to learn, as well?','For too long we have ignored the secrets of the Arcane.$B$BAre you here to learn, as well?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(47371,'For too long we have ignored the secrets of the Arcane.$B$BSadly, they will remain a secret to you.','For too long we have ignored the secrets of the Arcane.$B$BSadly, they will remain a secret to you.',274,0,0,0,0,0,0,1,1,0,0,0,26124),
(47372,'Get behind the Colossus!','Get behind the Colossus!',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(47373,'Thank you for rescuing the king... and the prince, $n.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(47374,'You\'ve taught me what it means to have friends, $n.','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(47375,'I see that you did it, $n. You\'re a credit to your race.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(47376,'The perimeter is secure, commander.','The perimeter is secure, commander.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47377,'Man am I tired!','Man am I tired!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(47378,'Attack, my brothers! Make him feel the fury of the pack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47379,'Sorry, $c. $B$BYour grasp of the arcane isn\'t strong enough to understand portal magic.','Sorry, $c. $B$BYour grasp of the arcane isn\'t strong enough to understand portal magic.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47380,'You too are a student of the arcane, yes?$B$BI can teach you about portal magic, if you wish to learn.','You too are a student of the arcane, yes?$B$BI can teach you about portal magic, if you wish to learn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47381,'Very vell, zhen. Let me just check my notes vone lasht time...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47382,'Mmm-hmmm, yes, yes... simple enough...\n','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47383,'Oh, Gobbles! Ve\'re ready to begin! Come, come!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(47384,'You\'d best hurry if you want any of the spoils.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47385,'Hold on, Gobbles! Shtand back everyvone!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(47386,'Use your Storm Shield before the Static Charge finishes!\n\n|TInterface\\Icons\\spell_nature_lightningshield.blp:32|t','Use your Storm Shield before the Static Charge finishes!\n\n|TInterface\\Icons\\spell_nature_lightningshield.blp:32|t',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47387,'You\'ve absorbed 3 Static Charges. Your next Storm Hammer will deal massive AoE damage!\n\n|TInterface\\Icons\\spell_nature_lightningoverload.blp:32|t','You\'ve absorbed 3 Static Charges. Your next Storm Hammer will deal massive AoE damage!\n\n|TInterface\\Icons\\spell_nature_lightningoverload.blp:32|t',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47388,'VHAT!?','',0,0,0,0,0,0,388,0,1,0,0,0,26124),
(47389,'Vhat could haf possibly gone vrong? I followed every lasht detail...','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(47390,'Vait a shekkont! Vhat\'s zhis!?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(47391,'You only brought me eight idols!','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(47392,'Zhe ritual shpecifically calls for NINE!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47393,'NINE! NINE! NINE! NINE! NINE!!!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47394,'Out of my sight, vizh you! Auch...','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(47395,'My poor Gobbles...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47396,'No one attacks the Big G and lives!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47397,'Eat it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47398,'What in hell\'s name is going on out here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47399,'You may enter this hill alive, but I guarantee you won\'t leave alive.','You may enter this hill alive, but I guarantee you won\'t leave alive.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47400,'Tol Barad is mine, it\'s mine I tell you!','Tol Barad is mine, it\'s mine I tell you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47401,'Just one final push and the island will be ours.  Chin up men, we move out first thing in the morning.','Just one final push and the island will be ours.  Chin up men, we move out first thing in the morning.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47402,'Go away, whoever you are! Forgotten Hilll is mine... mine!','Go away, whoever you are! Forgotten Hilll is mine... mine!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47403,'I don\'t know why the door is closed, heroes. My pack should have already taken care of Godfrey by now...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47404,'We will stand idle no longer! The time to act is now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47405,'Look out spider!  Here come Lunk!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47406,'Lunk ride spider now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47407,'Spider tummy time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47408,'You hold still, spider!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47409,'Lunk will ride you now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47410,'Ha ha ha!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47411,'I got some venom for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47412,'Lunk got you some venom with his tummy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47413,'See?  No kill spider for venom.  Just ride.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47414,'Spider left some venom on Lunk\'s tummy.  You want?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47415,'Here, I got you this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47416,'Here, you can scrape venom off Lunk\'s tummy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47418,'I\'ll make sure nothing interferes. Go now heroes! Kill Godfrey!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47419,'I\'m afraid I cannot help you, $r, but I am sure Khaelyn Steelwing can.','I\'m afraid I cannot help you, $r, but I am sure Khaelyn Steelwing can.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47420,'I\'m afraid I cannot assist you, $r, but I am certain Georgia can.','I\'m afraid I cannot assist you, $r, but I am certain Georgia can.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47421,'Good work, $glad:lass;! Now to attack their leader!','Good work, $glad:lass;! Now to attack their leader!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47422,'TOO...MUCH...POWER!!!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(47423,'A nearby Gargoyle comes to life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47424,'Lunk tired of all this killing!  Lunk quits!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(47425,'Lunk going to find some real adventures!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(47426,'This special plague we\'re spreading will keep Godfrey\'s forces from leaving the keep, but will still allow us to move our troops in to take it for the Forsaken!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47427,'We have confirmed the Horde presence at Dragonmaw Port, master. They are now in league.','',0,0,0,0,0,0,0,0,1,0,21074,0,26124),
(47428,'Our agents have been outed and killed, master.','',0,0,0,0,0,0,0,0,1,0,21075,0,26124),
(47429,'The Alliance has made landfall master, and in great numbers upon the shore.','',0,0,0,0,0,0,0,0,1,0,21073,0,26124),
(47430,'This changes nothing. (Nothing nothing changes. Crush them, crush.)','',0,0,0,0,0,0,1,0,1,0,22102,0,26124),
(47431,'What of our agents in Stormwind? (Stormwind! The eye, the eye sees into the city heart.) Bring me the eye.','',0,0,0,0,0,0,1,0,1,0,22103,0,26124),
(47432,'What of our agents in Orgrimmar? (City engulfed in stone and sand, we see it! The Eye sees into its heart.) Bring me the eye.','',0,0,0,0,0,0,1,0,1,0,22104,0,26124),
(47433,'(Blaspheme! Blaspheme disgust hate hate...) No matter. Where one eye closes, another opens. (The Master sees all! The Master knows all!) We will know our enemy\'s hearts, for they are weak. The eye. Now.','',0,0,0,0,0,0,36,0,1,0,22105,0,26124),
(47434,'\'Sploded dat one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47435,'Move away before the Static Flux explodes!\n\n|TInterface\\Icons\\ability_vehicle_electrocharge.blp:32|t','Move away before the Static Flux explodes!\n\n|TInterface\\Icons\\ability_vehicle_electrocharge.blp:32|t',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47436,'The shadow of the Master covers this world... (Darkness, all darkness.) Our enemies fight one another, across the Highland. Fools. (Blood, blood.) WAIT! There is another!','',0,0,0,0,0,0,0,0,1,0,22106,0,26124),
(47437,'A mortal dares peer into the eye! (Brave little plaything.) I see you, little one! You want to see what the Eye sees, do you? (Show it! Show it all!)','',0,0,0,0,0,0,15,0,1,0,22107,0,26124),
(47438,'Behold the chaos to come. (Madness, madness, bliss!) Do you like what you see mortal?','',0,0,0,0,0,0,0,0,1,0,22108,0,26124),
(47439,'(The master sees you! He sees! He sees! He wants! Wants wants...)','',0,0,0,0,0,0,0,0,1,0,22109,0,26124),
(47440,'You\'re more skilled in combat than I thought.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47441,'Very well then. Let\'s get the courtyard door open so we can continue our mission!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47442,'This lock should be easy enough to pick.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47443,'There we go! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47444,'Say, would you mind just blocking the sun with your shadow for a little while?$b$bThat\'d be great...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47445,'You know, I just don\'t really feel much like working today.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47446,'It\'s far too hot to work out here - especially in these uniforms.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47447,'I was promised substantial wealth to come out here.$b$bWhat a joke!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47448,'They\'re working us like dogs and we\'re getting nothing to show for it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47449,'Schnottz is making a fortune because of us... where\'s ours?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47450,'Enough slacking! You\'re behind schedule...','Enough slacking! You\'re behind schedule...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47451,'I didn\'t sign up for this...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47452,'I should never have left Tanaris.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47453,'I was happier as a Wastewander.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47454,'Yeah, yeah. When aren\'t we behind schedule?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47455,'I\'m not working for that maniac anymore!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47456,'I have a message for you to deliver to that tyrant!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47457,'I haven\'t been paid since I got here! I\'m through with this place!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47458,'I\'m done working in this heat!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47459,'I can\'t believe I fell for Schnottz\'s lies! I\'m out of here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47460,'He\'s castin\' something big! Stop\'m!','He\'s castin\' something big! Stop\'m!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47461,'How do you zhink Gobbles vould feel about you if he vere here?$b$bHmm?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47462,'After zhat ritual debacle, you owe me, $r.$b$bAnd I plan on collectink!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47463,'Keep it quiet in there. They only get thirty minute rest shifts, and I\'ll not have ya distrubin\' them.','Keep it quiet in there. They only get thirty minute rest shifts, and I\'ll not have ya distrubin\' them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47464,'Listen, I\'ve been doin\' a little celebratory drinkin\' since our escape, and I\'ve been thinkin\'...$b$bThose little men that jumped us need to be brought to justice!$b$bIf somethin\' ain\'t done, then every unsuspectin\' explorer who sets foot in this place is gunna get sold into slavery - or worse!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(47465,'Through this portal, Tol Barad awaits.','Through this portal, Tol Barad awaits.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47466,'Excellent. Now, to plague this area and move on to-','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47467,'Cromush! What\'re you doing here? This is a covert operation!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47468,'Unless I\'m mistaken, the Warchief explicity forbids using the full plague, no matter the circumstance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47469,'My apologies, Cromush, but I assure you there is no problem. We are using an extremely dilute plague.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47470,'In fact, it really only serves to scare off the worgen from trying to follow us in here. It\'s completely harmless.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47471,'Then I\'m sure you won\'t mind if I accompany you on your mission.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47472,'Be warned, Belmont. If I find out that you\'re lying...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47473,'You\'ll see the Warchief\'s wrath firsthand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47474,'The mistress will pay me handsomely for your heads!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47475,'Bombs away!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47476,'Ready Oafie? Throw!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47477,'Mortals! You dare breach our inner sanctum. (Unbelievers. Heretics! Burn burn)\n You cross a threshold from which there is no return. (burn burn the heretics will burn.)','',0,0,0,0,0,0,0,0,1,0,22054,0,26124),
(47478,'Halfus! Hear me! (The Master calls, the Master wants.) Protect our secrets, Halfus. Destroy the intruders. (Murder for His glory. Murder for His hunger.)','',0,0,0,0,0,0,0,0,1,0,22055,0,26124),
(47479,'But of course. We have the Horde\'s best interests in mind, sir. These heroes were just about to continue on and kill Springvale for us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47480,'No...NO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47481,' Flesh and sinew, weak but proud. Dare they part the Master\'s shroud? They stumble fumble groping blind. Finding fate and chaos intertwined.','',0,0,0,0,0,0,0,0,1,0,22056,0,26124),
(47482,'I\'ve sent my men forward on the rooftops to secure the area around Lord Walden.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47483,'Of course, somebody\'s going to have to take care of the small army between here and there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47484,'Deathstalker Command Belmont grins.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47485,'Brothers in chaos, the Twilight has come! (Shadows lengthen, endless night.) Deathwing has sundered this world. (Doors once opened never close.) So that its true Lords may return. (The Master comes, He comes He comes.)','',0,0,0,0,0,0,0,0,1,0,22057,0,26124),
(47486,'The time has come, soldiers! Godfrey lies just ahead! Have no mercy! We fight-','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47487,'FOR THE HORDE!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47488,'Mortals, you merely separate the wheat from the chaff. (Unworthy, unworthy).','',0,0,0,0,0,0,0,0,1,0,22062,0,26124),
(47489,'You\'d better hurry up if you want in on all the fun.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47490,'Heed His call! Cast down the heretics!','',0,0,0,0,0,0,0,0,1,0,22059,0,26124),
(47491,'Aaagh! Curse you! I\'ll be back up in a minute, just you watch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47492,'Go away, kid, you\'re botherin\' me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47493,'Follow me, $n, and I\'ll introduce you to your trainer, Alamar Grimm.','Follow me, $n, and I\'ll introduce you to your trainer, Alamar Grimm.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47494,'Alamar, I\'d  like to introduce you to $n, a recent escapee from Gnomeregan.','Alamar, I\'d  like to introduce you to $n, a recent escapee from Gnomeregan.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47495,'','I am well aware that the demonic presence in this forest can be considered the fault of my kind.$B$BI am also not the first Highborne to attempt to make amends for this, and I thank the Emerald Circle for being pragmatic enough to allow my help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47496,'You are His chosen ones. (He calls you, He knows you). Born of flesh- (flesh) purified by blood- (blood) destined for immortality!','',0,0,0,0,0,0,0,0,1,0,22058,0,26124),
(47497,'Brothers of the Hammer, to me! (Their will is still their own.) The unbelievers still stand. Destroy them! (Crush their bodies, crush their will.)','',0,0,0,0,0,0,0,0,1,0,22060,0,26124),
(47498,'This is... worse... than death...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47499,'Ugh!  Why are you WET!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47500,'Why is the door shut? What in Sylvanas\' name is going on here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47501,'Light... fading... dying?  No, just sleeping...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47502,'Cromush! What happened?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47503,'The Earthen Ring have set up portals to various regions of the world on a small lake islet northwest of Stormwind Keep.\n\nThere are representatives from the Baradin Wardens there as well, offering transport to Tol Barad.','The Earthen Ring have set up portals to various regions of the world on a small lake islet northwest of Stormwind Keep.\n\nThere are representatives from the Baradin Wardens there as well, offering transport to Tol Barad.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(47504,'The coward...killed them...poisoned...me...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47505,'','Do not let prejudice or ancient grudges interfere with our mission here, Kaldorei. There will be plenty of time for squabbling and distrustful looks when we are done here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47506,'Where... did... he... come from...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47507,'Other Continents','Other Continents',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(47508,'You\'ll pay for this Godfrey!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47509,'But... but...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47510,'That\'s... one... giant... keester...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47511,'Heroes, you must kill Godfrey! I\'ll make sure nothing interferes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47512,'Why did it have to be... a smelly ogre...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47513,'The Earthen Ring have set up portals to various regions of the world on the cliffs north of the zeppelin towers.\n\nThere are representatives from Hellscream\'s Reach there as well, offering transport to Tol Barad.','The Earthen Ring have set up portals to various regions of the world on the cliffs north of the zeppelin towers.\n\nThere are representatives from Hellscream\'s Reach there as well, offering transport to Tol Barad.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47514,'I can\'t feel my legs...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47515,'A trio of ethereal technomancers has set up shop in Orgrimmar, along the eastern Drag.\n\nLook for the weird machinery and purple lights... you can\'t miss it.\n\nThey offer just the sort of services you\'re looking for.','A trio of ethereal technomancers has set up shop in Orgrimmar, along the eastern Drag.\n\nLook for the weird machinery and purple lights... you can\'t miss it.\n\nThey offer just the sort of services you\'re looking for.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47516,'Follow me, $n, and I\'ll introduce you to your trainer, Drill Sergeant Steamcrank.','Follow me, $n, and I\'ll introduce you to your trainer, Drill Sergeant Steamcrank.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47517,'Sergeant, allow me to introduce $n, who helped us rescue survivors in Gnomeregan.','Sergeant, allow me to introduce $n, who helped us rescue survivors in Gnomeregan.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47518,'Valiona, Theralion, put them in their place.','',0,0,0,0,0,0,0,0,1,0,22063,0,26124),
(47519,'Follow me, $n, and I\'ll introduce you to your trainer, Kelsey Steelspark.','Follow me, $n, and I\'ll introduce you to your trainer, Kelsey Steelspark.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47520,'Kelsey, allow me to introduce $n, who helped us rescue survivors in Gnomeregan.','Kelsey, allow me to introduce $n, who helped us rescue survivors in Gnomeregan.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47521,'The master was clearly speaking to you, Valiona. I am far too busy to attack ANYONE.','',0,0,0,0,0,0,0,0,1,0,20300,0,26124),
(47522,'How dare you call me worthless! You will see why I am mother\'s favored child!','',0,0,0,0,0,0,0,0,1,0,20301,0,26124),
(47523,'Do as the master commands, Theralion! Kill them!','',0,0,0,0,0,0,0,0,1,0,21894,0,26124),
(47524,'You are worthless, Theralion!','',0,0,0,0,0,0,0,0,1,0,21895,0,26124),
(47525,'Here, I stealed this from little dwarf.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47526,'He will be sleepy for a while.  Lunk know.  Lunk do before.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47527,'Here, you can have dwarf\'s things.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47528,'You take dwarf\'s things.  No need to kill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47529,'Sitting easier than killing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47530,'Here you go.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47531,'Follow me, $n, and I\'ll introduce you to your trainer, Bipsi Frostflinger.','Follow me, $n, and I\'ll introduce you to your trainer, Bipsi Frostflinger',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47532,'Bipsi, this is $n, one of the most recent survivors to emerge from Gnomeregan.','Bipsi, this is $n, one of the most recent survivors to emerge from Gnomeregan.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47533,'Follow me, $n, and I\'ll introduce you to your trainer, \"Doc\" Cogspin.','Follow me, $n, and I\'ll introduce you to your trainer, \"Doc\" Cogspin.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47534,'Doc, this is $n, who helped Nevin\'s team get a number of survivors out of Gnomeregan.','Doc, this is $n, who helped Nevin\'s team get a number of survivors out of Gnomeregan.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47535,'Let me out of here! It smells like ELVES!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47536,'Niby sold me out! HE SOLD ME OUT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47537,'You can\'t do this! I have my own soul shard!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47538,'(Come closer, closer.  Let us see your faces. All will be humbled before his power.)','',0,0,0,0,0,0,0,0,1,0,22064,0,26124),
(47539,'Do you HAVE to flail around like such an idiot?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47540,'It burns in here! Wait, that\'s just my feet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47541,'Let me out and I\'ll give you three wishes! I swear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47542,'Nine, nine, NINE! Vhat could be so hard to undershtand?!','',0,0,0,0,0,0,5,0,1,10879,0,0,26124),
(47543,'Zhe secrets of zhe obelisks vhill soon be mine!','',0,0,0,0,0,0,71,0,1,10830,0,0,26124),
(47544,'Helix attaches a bomb to $n\'s chest!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47545,'Zhe coffer of promise is nearly vizhin my reach!','',0,0,0,0,0,0,273,0,1,10830,0,0,26124),
(47546,'Zhe treasure is piling up nicely... soon, zhere vill be no shtoppink me!','',0,0,0,0,0,0,71,0,1,10830,0,0,26124),
(47547,'Zhis whole cataclysm zhing has really vorked out in my favor.','',0,0,0,0,0,0,396,0,1,10830,0,0,26124),
(47548,'%s senses $n\'s cowardice and unleashes a blast of lightning!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47549,'The wind abruptly shifts direction at %s\' command!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47550,'Right in the face! Ow ow ow...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47551,'Catch Impsy in the sack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47552,'Zhe shtatues! Zhey\'re aliiive!','',0,0,0,0,0,0,397,0,1,10830,0,0,26124),
(47553,'What are you talking about, goblin?! Speak!!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47554,'I\'ll talk, I\'ll talk! Anything! Just keep that perfumed bag away from me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47555,'<The Mullan Gryphon Rider stays still, eyes locked forward, not acknowledging your presence.>','<The Mullan Gryphon Rider stays still, eyes locked forward, not acknowledging your presence.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47556,'Not backing out, are you?','Not backing out, are you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47557,'Them\'s DEFINITELY fightin\' words!','Them\'s DEFINITELY fightin\' words!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47558,'Hide your vives! Hide your children! Zhey\'re killink everyvone up in he\'ah!','',0,0,0,0,0,0,397,0,1,10830,0,0,26124),
(47559,'Zhey\'re runnink around killink everyzhink! Shtompink! Like zhis!!','',0,0,0,0,0,0,0,0,1,10830,0,0,26124),
(47560,'Off course, sir! At Vonce!','',0,0,0,0,0,0,113,0,1,10830,0,0,26124),
(47561,'Seek out The Reliquary in the Royal Exchange; doubtless one of that organization\'s many archaeologists will be there and can likely assist you.','Seek out The Reliquary in the Royal Exchange; doubtless one of that organization\'s many archaeologists will be there and can likely assist you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47562,'What are you waiting for? Get out there and stop them!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47563,'Fine! Fine. You win this one.','Fine! Fine. You win this one.',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(47564,'','Only the highest-ranking members of The Reliquary know where our order\'s Grand Vault is located.$B$BSome say it is not even upon this plane of existence...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(47565,'Duglas send you over to get roughed up?','Duglas send you over to get roughed up?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47566,'Lookin\' to scrap?','Lookin\' to scrap?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47567,'You look like you want a piece of me...','You look like you want a piece of me...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47568,'Lookin\' for some punishment?','Lookin\' for some punishment?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47569,'History? Culture? Tch. Such is the realm of scholars and scribes.$B$BWe of The Reliquary concern ourselves with... the immediate, and perhaps the future.$B$BWe discover, acquire, and amass lost artifacts, wealth, and lore so that it cannot be used against us. Power does, after all, belong in the hands of those who would use it best... wouldn\'t you agree?','',1,6,11,0,2,2,0,0,1,0,0,0,26124),
(47570,'Hide your vives! Hide your children! H-h-hide you husbands!! Zhey\'re killink everyvone up in he\'ah!','',0,0,0,0,0,0,397,0,1,10830,0,0,26124),
(47571,'$n, you gonna save us from those pirates, or what?!','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(47572,'','May I suggest that you save us from the pirates, my dear $n?!',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(47573,'I didn\'t need him! Not when I\'ve got YOU oafs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47574,'Only ten copper? You\'re not even worth killing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47575,'The scales...have...tipped...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47576,'Gimme some more of that swim tonic!','Gimme some more of that swim tonic!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47577,'You want Master Hossack. He in south part of Mage District, inner ring.','You want Master Hossack. He in south part of Mage District, inner ring.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47578,'Extricating','Extricating',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47579,'You\'ll want to find Adam Hossack. He\'s got an office in the southern Mage Quarter along the inner ring.$B$BIf he\'s not out exploring, he\'ll likely be there.','You\'ll want to find Adam Hossack. He\'s got an office in the southern Mage Quarter along the inner ring.$B$BIf he\'s not out exploring, he\'ll likely be there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(47580,'There\'s always something new to investigate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47581,'','Be quick about it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47582,'Nothing can stop the wrath of the Banshee Queen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47583,'The Bloodfang will prevail.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47584,'Time to expand my ice cream empire.$B$BTigule and Foror are going down!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(47585,'Welcome, mortals. (Frail little children). Few have laid eyes on this inner sanctum. (They reach out to touch the fire!)','',0,0,0,0,0,0,0,0,1,0,22065,0,26124),
(47586,'','Do you see me now, Cho\'gall? I\'m coming for you! I\'m going to rip off your head while the other watches!',0,0,0,0,0,0,36,0,1,0,0,0,26124),
(47587,'It is here the chosen realize their destiny. (One with eternity). And it is here that you will realize yours.(End of the flesh. End of the flesh)!','',0,0,0,0,0,0,0,0,1,0,22066,0,26124),
(47588,'Brothers of Twilight! The Hammer calls to you! (Fire water earth air). Leave your mortal shell behind. (Fire water earth air). Embrace your new forms for here and everafter! (Burn and drown and crush and suffocate). And use your gifts to destroy the unbelievers. (Burn and drown and crush and suffocate)!!','',0,0,0,0,0,0,0,0,1,0,22067,0,26124),
(47589,'Remain steady always.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47590,'','For Sylvanas!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47591,'Foolish mortals-(Usurper\'s children!) nothing you have done- (Spawn of a lesser god!) I am TRYING to speak here. (Words, words, words. The Master wants murder.) ALL falls to chaos. ALL will be destroyed. (Chaos, chaos!) Your work here today changes nothing. (Chaos, chaos, all things end) No mortal may see what you have and live. Your end has come.','',0,0,0,0,0,0,0,0,1,0,22068,0,26124),
(47592,'These notes are horribly organized. I can\'t tell if Arugal was brilliant or simply an imbecile.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47593,'I must give Arugal some credit, his lines of research were quite novel.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47594,'Missing pages, broken equipment, tainted samples! How does someone work in these conditions!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47595,'This library should prove to be useful to my own research.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47596,'Foe Reaper 5000 on-line.  All systems nominal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47597,'Places like Uldaman hold secrets as to the mysteries of my people\'s past!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47598,'Slay the Idra\'kess Mistresses to destroy the shield!','',0,0,0,0,0,0,0,0,1,11908,0,0,26124),
(47599,'Nespirah is waking up! Use the Nespirah Fluid to kill Idra\'kess.','',0,0,0,0,0,0,0,0,1,11908,0,0,26124),
(47600,'Dedlow Wormwood\'s the corpse you want. He\'s usually around the south end of town.','Dedlow Wormwood\'s the corpse you want. He\'s usually around the south end of town.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(47601,'Brill\'s only chef is in the middle of town.$B$BWe don\'t know why he\'s out there; he won\'t sell anything he makes. We also don\'t know where he\'s getting that fresh raw meat.$B$BWell, no matter. Good luck.','Brill\'s only chef is in the middle of town.$B$BWe don\'t know why he\'s out there; he won\'t sell anything he makes. We also don\'t know where he\'s getting that fresh raw meat.$B$BWell, no matter. Good luck.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(47602,'Ice cream, Brivelthwerp. I need ice cream!','Ice cream, Brivelthwerp. I need ice cream!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47603,'%s slumps forward, exposing his pincers!','',0,0,0,0,0,0,0,0,1,0,8717,0,26124),
(47604,'A little busy here, $c.  What d\'ye want?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47605,'Can I help ye with somethin\'?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47606,'Aye.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47607,'Care to join our dance?','Care to join our dance?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47608,'Attack and Weaken the Black Drake!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47609,'Overdrive engine activated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47610,'You\'re the last of your tribe with any sense left.  As a reward for giving us Prince Nadun, I grant you the gift that is your birthright and more!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(47611,'Your makers failed you... your flawed race succumbed to the curse of flesh!  Lord Deathwing\'s gift makes you perfect again!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(47612,'Flap Your Wings Rapidly to Re-Gain Altitude!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47613,'This orc is severely injured.','This orc is severely injured.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47614,'End the orc\'s misery.','End the orc\'s misery.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47615,'Pardon me, friend, but I\'m busier than it might appear.$b$bI\'ve been commissioned to document the discoveries of the commander in this region, you see.$b$bThey\'re certain to be most profound!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47616,'I\'m working on a biographical piece for Commander Schnottz, among other things.$b$bYou\'ll have to excuse me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47617,'I bestow upon you the power that is our birthright... and more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47618,'And with the powers of the South Wind, we will reclaim this city and seal it from those who would trespass upon our territory!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47619,'There is fight left in me yet, scum.','There is fight left in me yet, scum.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47620,'Help the injured orc up.','Help the injured orc up.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47621,'I supply the Krom\'gar army with equipment.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(47622,'Show me your wares, quartermaster.','Show me your wares, quartermaster.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47623,'','Smells like... gold!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47624,'|TInterface\\Icons\\spell_fire_twilightnova.blp:20|t%s casts |cFFFF0000|Hspell:86788|h[Blackout]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47625,'','I saw them loading a shipment of artifacts onto the boats the other day.$b$bIt was the most gold I\'ve ever seen in one place!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47626,'Years ago, I was trapped here while trying to study the wind riders. But once I made my way to freedom, I resolved to return and protect them.$B$BNow the Cataclysm has struck and the Twilight\'s Hammer is capturing all of these sacred creatures, or worse, destroying them.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(47627,'I care little about the wars between the Horde and the Alliance. What matters is that we save the sacred wind riders of Highperch.$B$BIf not for their sake, then at least to keep them from falling into the hands of the Twilight\'s Hammer, $r.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(47628,'Acquiring target...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47629,'Target acquired.  Harvesting servos engaged.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47630,'Target destroyed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47631,'I\'m ready to take the flight into the Cauldron!','I\'m ready to take the flight into the Cauldron!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47632,'Who are you?','Who are you?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(47633,'Get out of here, before the slavers see you!','Get out of here, before the slavers see you!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(47634,'Are you... here to save me?','Are you... here to save me?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(47635,'Come on, let\'s get out of here!','Come on, let\'s get out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47636,'Never!  I love working for the Dark Iron!','Never!  I love working for the Dark Iron!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47637,'Intruder!  The intruder is trying to save me!','Intruder!  The intruder is trying to save me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47638,'I\'ll never leave!  I wouldn\'t know what to do outside!','I\'ll never leave!  I wouldn\'t know what to do outside!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47639,'I knew the Thorium Brotherhood would come through!','I knew the Thorium Brotherhood would come through!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47640,'Oh, thank you!  Thank you!','Oh, thank you!  Thank you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47641,'It\'s about time!  I\'m sick of being a slave!','It\'s about time!  I\'m sick of being a slave!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47642,'Safety restrictions off-line.  Catastrophic system failure imminent.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47643,'Overheat threshold exceeded.  System failure.  Wheat clog in port two.  Shutting down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47644,'Grab a Lance from the Racks','',0,0,0,0,0,0,0,0,1,10973,0,0,26124),
(47645,'Equip the Lance','',0,0,0,0,0,0,0,0,1,10973,0,0,26124),
(47646,'Mount One of Aviana\'s Guardians','',0,0,0,0,0,0,0,0,1,10973,0,0,26124),
(47647,'You are here to stop the Archduke?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47648,'Let\'s do this!  Let\'s take out Maltorius and Arkkus!','Let\'s do this!  Let\'s take out Maltorius and Arkkus!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47649,'Now ye\'re talkin\'!  I\'ll take the Twilight guy.  You focus on the little dwarf.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47650,'Hang tight, $n.  We gotta wait for Maltorius and Arkkus to come back before we can fight \'em.','',1,23,0,0,0,0,0,0,1,0,0,0,26124),
(47651,'Pitiful meat bags! Feel the full force of the Dragonmaw!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47652,'Perhaps ye filthy animals would like another taste o the dirt!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47653,'Now that\'s what ye call heavy hands!','',1,23,0,0,0,0,0,0,1,0,0,0,26124),
(47654,'%s is weakened!  Banish him now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47655,'Heartrazor bellows his appreciation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47656,'NOOOOOO!  THIS CANNOT BE!  I... AM... IMMORTAL...!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47657,'Fools!  You cannot defeat me!  I will only return again...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47658,'','Stand tall and proud, $n. Don\'t let any of these scrubs give you any trouble. Show them who\'s boss!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47659,'','I see one coming now! Looks like a real winner. Keep it cool, $n. Keep it cool.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47660,'HI! HI! HELP!','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(47661,'HI! I\'M NEW! BIG WHITE LIGHT CREATURE WITH WINGS MADE ME ALIVE! I SERVE THE BANSHEE QUEEN! YAY!$B$BHELP!$B$BHI!','',3,2,0,0,0,0,3,0,1,0,0,0,26124),
(47662,'Maybe you should go take a nap or something. I don\'t know if I have any work for you.','Maybe you should go take a nap or something. I don\'t know if I have any work for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47663,'OK! THANKS! I\'LL JUST WAIT HERE WITH YOU! THANKS! OK!','',4,0,0,0,0,0,4,0,1,0,0,0,26124),
(47664,'Wait a minute. It looks like something just came up. Yes, right here on this sheet of paper. You need to head southeast to the Azurelode Mine and report to Captain Keyton. Southeast is that way *you point southeast*.','Wait a minute. It looks like something just came up. Yes, right here on this sheet of paper. You need to head southeast to the Azurelode Mine and report to Captain Keyton. Southeast is that way *you point southeast*.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47665,'NORTH! GOT IT! THANKS! BYE! THANKS!','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(47666,'','These new Forsaken tend to be a little... um... stupid. It usually takes awhile for them to acclimate.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47667,'','Oh great... not this one again. I know this orc. He\'s got no business being here, but since he\'s a bottom-feeding pansy he likes to hang around here and prey on the helpless. Don\'t let him bully you.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47668,'CAN YOU SMELL WHAT THE LOK\'TAR IS COOKIN\'?!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(47669,'HAH! Looks like you\'re running out of idiots to put atop this horse, Darthalia. This is the puniest one yet.','',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(47670,'What have you got for me today, weakling?! Point me to where the Alliance hide and I shall DOMINATE THEM!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47671,'I will freeze the blood in your veins!','',0,0,0,0,0,0,0,0,1,0,20164,0,26124),
(47672,'%s begins to cast Glaciate!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47673,'I have seen the fall of the Lich King. Creations of the titans have fallen before my mighty axe. When called upon, I alone spearheaded a victory for the Argent Crusade against the beasts of Northrend. Now, I come for the ultimate challenge. What does Hillsbrad Foothills have to offer Kingslayer Orkus???','',1,1,6,0,0,0,0,0,1,0,0,0,26124),
(47674,'Um... Apparently there is some trouble at Southshore. Something about worgen insurgents. Maybe you could help with them?','Um... Apparently there is some trouble at Southshore. Something about worgen insurgents. Maybe you could help with them?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47675,'Insurgents you say? Is there any risk of death or dismemberment to me?','',1,6,0,0,0,0,6,0,1,0,0,0,26124),
(47676,'None.','None.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47677,'Then Orkus WILL DO IT! YES!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(47678,'Right, thanks. Just go ahead and head southeast. More south than east. Probably off the coast.','Right, thanks. Just go ahead and head southeast. More south than east. Probably off the coast.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47679,'Yes, cowardly quest giver, sit atop your pale horse while Orkus brings glory to the Horde! I shall return with a thousand skulls!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(47680,'','Here\'s to hoping he never returns. Maybe he\'ll drown?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47681,'','Ah, crap. You\'re on your own with this one, $p.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47682,'Johnny Awesome has arrived, philistine. Present me with your menial tasks so that I may complete them with only mild enthusiasm and most likely a complete disregard for any directions that you provide that are more complicated than what my map is able to display.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47683,'Look at me, peasant. Heirlooms cover my body from head to toe, gifted to me by the greatest heroes Azeroth has ever known.$B$BNow look at yourself.$B$BQuickly, look back at me.$B$BYes, this horse IS made of STARS.$B$BWhat pointless series of tasks befitting a mentally deficient orc have you prepared for me?','',25,1,6,0,0,0,0,0,1,0,0,0,26124),
(47684,'Well, we are having some problems at the Sludge Fields, located northeast of here. Warden Stillwater could use your help.','Well, we are having some problems at the Sludge Fields, located northeast of here. Warden Stillwater could use your help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47685,'Fine, fine, what else?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(47686,'That\'s all.','That\'s all.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47687,'That\'s all? One quest? Surely you jest. Are there not bear asses to collect? Perhaps a rare flower that I could pick from which you will make some mildly hallucinogenic tonic which you will then drink, resulting in visions of a great apocalypse? Perhaps the local populace of mildly annoying, ill-tempered gophers are acting up and need to be brought to justice? No? Nothing?','',1,1,6,0,0,0,0,0,1,0,0,0,26124),
(47688,'THAT\'S ALL, JOHNNY AWESOME. TAKE IT OR LEAVE IT!','THAT\'S ALL, JOHNNY AWESOME. TAKE IT OR LEAVE IT!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47689,'I will do this ONE thing that you ask of me, quest giver. Pray I find more menial tasks to accomplish or you will be hearing from me again and I assure you that my commentary on forums of public opinion will be most unkind.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47690,'You dwarves are worthless!  You come to Ragnaros seeking ascendance, but you have nothing to offer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47691,'Nothing to offer, except your backs and your shovels.  So you will dig.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47692,'Dig wide, dig deep.  Seek out the places of fire beneath the world.  My brothers and sisters yearn to be free.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47693,'Succeed, and you may ascend after all.  Fail, and burn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47694,'Ever heard of the Thorium Brotherhood?  Sure, we might look a lot like those dwarves down in the gorge, or in Blackrock Depths, but trust me: we\'re not anything like them.$b$bThose scoundrels dug too deep, and now they serve a darker force: Ragnaros, the Firelord.  We\'re happy to be more independent of will and purpose, although most of the time our purpose ends up being the prevention of whatever trouble they\'re causing.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(47695,'Think you could repair my gear, Burrian?','Think you could repair my gear, Burrian?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47696,'Could you repair my gear, Argus?','Could you repair my gear, Argus?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47697,'The Dark Irons in Blackrock have got nothin\' on me.  Neither do those boys up at Thorium Point.$b$bI\'m independent as can be, and that\'s the way I like it.  Of course, for the right price, I\'d listen to either side...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(47698,'Why you do that?  Why you kill?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47699,'You stop killing now!  Lunk doesn\'t like!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47700,'No!  No kill!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47701,'You hurt Lunk\'s feelings when you kill.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47702,'Please, no kill when Lunk is around.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47703,'Oh no!  Why do you kill it?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47704,'You will suffer!  You will face the wrath of the Twilight\'s Hammer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47705,'Only pain awaits you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47706,'Die, creep!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47707,'It will be a pleasure shooting you down!','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(47708,'Useless wind rider! I don\'t need you anyway!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47709,'No flights out right now, $r. By order of Garrosh, these windriders are for military use only until the night elves are wiped out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47710,'Let\'s see what this ember does... whaaaa?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47711,'No! Get away! Get off of me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47712,'NOOOOOO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47713,'Aaaaaiiiiiiiiiiiiii......!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47714,'What\'s this? Shoo!','',0,0,0,0,0,0,6,0,1,0,1299,0,26124),
(47715,'BURN!','',0,0,0,0,0,0,0,0,1,0,20287,0,26124),
(47716,'More fuel for the fire!','',0,0,0,0,0,0,0,0,1,0,20286,0,26124),
(47717,'Perish!','',0,0,0,0,0,0,0,0,1,0,20163,0,26124),
(47718,'Wind, hear my call!','',0,0,0,0,0,0,0,0,1,0,20239,0,26124),
(47719,'%s begins to cast Thundershock!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47720,'Merely a whisper in the wind....','',0,0,0,0,0,0,0,0,1,0,20238,0,26124),
(47721,'The soil welcomes your bones!','',0,0,0,0,0,0,0,0,1,0,21842,0,26124),
(47722,'The earth will devour you!','',0,0,0,0,0,0,0,0,1,0,21844,0,26124),
(47723,'%s begins to cast Quake!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47724,'You will die for your insolence!','',0,0,0,0,0,0,0,0,1,0,20285,0,26124),
(47725,'You dare invade our lord\'s sanctum?','',0,0,0,0,0,0,0,0,1,0,20162,0,26124),
(47726,'FEEL THE POWER!','',0,0,0,0,0,0,0,0,1,0,20400,0,26124),
(47727,'The surrounding air crackles with energy....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47728,'The ground beneath you rumbles ominously....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47729,'Go forth, my beautiful angel! Ah, it is so very sad when one\'s children leave the nest, isn\'t it?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47730,'I guess it\'s time for a rebuilding phase...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47731,'What... my creation! It didn\'t even blot out the sky! I\'d better recheck my notes...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47732,'%s is reviled by your ugliness!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47733,'Eww! Get away from me, you nasty thing!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47734,'As you wish, Daddy!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47735,'Oh! Too full... oh no... ','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47736,'It\'s time for your ultimate attack, my darling!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47737,'This Schnottz fellow is proving to be a wise investment.$b$bGood that I was insightful enough to get in on the ground floor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47738,'Like father always said; it takes a shrewd mind, sharp instincts, and unfailing courage to become a successful investor.$b$bI must admit, I smelled this opportunity a mile away.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47739,'Don\'t forget to replace your main weapon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47740,'Someone, or something, seems to have done in the Ambassador!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47741,'I dare say I\'ve had enough of this. Time to bring out... THE BEAST WITHIN!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(47742,'Who could have done such a thing?','Who could have done such a thing?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47743,'Who knows?$b$bHe was becoming quite critical of this operation, but that\'s not proof of anything.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47744,'Will you investigate the murder?','Will you investigate the murder?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47745,'Who, me?$b$bWhy, I\'d hardly consider myself qualified to, uh... No, I should think not.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47746,'Well, you WILL at least write about it, won\'t you?','Well, you WILL at least write about it, won\'t you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47747,'Wh-what?! Well, I...$b$bIn this midst of such an exciting excavation, I\'m not certain it would be appropriate to focus on such a thing.$b$bIt would make for a most troubling story, you know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47748,'','Don\'t - don\'t touch me...$b$bWhat\'s happening?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47749,'Just calm down. Are you alright?','Just calm down. Are you alright?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47750,'','No! Of course I\'m not alright!$b$bI-I\'ve never seen an actual corpse before...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47751,'Did you see what happened?','Did you see what happened?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47752,'','He just came stumbing out of the barracks.$b$bI screamed for help, but the guards wouldn\'t even look at me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47753,'Maybe you should go lie down for a little while.','Maybe you should go lie down for a little while.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47754,'','Yes.$b$bThat sounds like a good idea.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47755,'Good lord! Manservants, aid your master!!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(47756,'Enough toying around! It\'s time to get my hands dirty!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(47757,'Grab a seat, chaps. Let me coach you on some true carnage!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(47758,'Our men have secured the walkway. Focus on helping those in the main room.','Our men have secured the walkway. Focus on helping those in the main room.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47759,'|TInterface\\Icons\\spell_shaman_staticshock.blp:20|t%s casts|cFF1CF2FE|Hspell:79888|h [Lightning Conductor]|h|r at |cFF1CF2FE$n|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47760,'I will burn you from the inside out!','',0,0,0,0,0,0,0,0,1,0,18610,0,26124),
(47761,'An easy kill!','',0,0,0,0,0,0,0,0,1,0,18611,0,26124),
(47762,'You should have come better prepared!','',0,0,0,0,0,0,0,0,1,0,18612,0,26124),
(47763,'Hold On!','Hold On!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47764,'Valiona, finish them! Avenge me!','',0,0,0,0,0,0,0,0,1,0,18614,0,26124),
(47765,'INCINERATE THEM, MINIONS!','',0,0,0,0,0,0,0,0,1,0,18616,0,26124),
(47766,'BY FIRE BE... BURNED!','',0,0,0,0,0,0,0,0,1,0,18619,0,26124),
(47767,'Dragon, you will do as I command! Catch me!','',0,0,0,0,0,0,0,0,1,0,18621,0,26124),
(47768,'I will not die for you, Drahga.','',0,0,0,0,0,0,0,0,1,0,18524,0,26124),
(47769,'If they do not kill you, I will do it myself!','',0,0,0,0,0,0,0,0,1,0,18523,0,26124),
(47770,'The darkest days are still ahead!','',0,0,0,0,0,0,0,0,1,0,18638,0,26124),
(47771,'Ahahaha!','',0,0,0,0,0,0,0,0,1,0,18639,0,26124),
(47772,'Flesh for the offering.','',0,0,0,0,0,0,0,0,1,0,18640,0,26124),
(47773,'Ywaq maq oou; ywaq maq ssaggh. Ywaq ma shg\'fhn.','',0,0,0,0,0,0,0,0,1,0,18641,0,26124),
(47774,'F\'lakh ghet! The shadow\'s hunger cannot be sated!','',0,0,0,0,0,0,0,0,1,0,18644,0,26124),
(47775,'This cannon appears to be pointed directly at the shore, with a fresh charge of powder and fuse already set.$B$BHow convenient!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47776,'I\'ll get in and fire it! What could go wrong?','I\'ll get in and fire it! What could go wrong?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47777,'NO! Throngus get whipped again if he no finish!','',0,0,0,0,0,0,0,0,1,0,18943,0,26124),
(47778,'Throngus use your corpse on body. Somewhere...','',0,0,0,0,0,0,0,0,1,0,18944,0,26124),
(47779,'You break easy!','',0,0,0,0,0,0,0,0,1,0,18945,0,26124),
(47780,'Death... Good choice. Not best choice maybe, but better than fail and live.','',0,0,0,0,0,0,0,0,1,0,18946,0,26124),
(47781,'You not get through defenses!','',0,0,0,0,0,0,0,0,1,0,18947,0,26124),
(47782,'Oh, this gonna HURT!','',0,0,0,0,0,0,0,0,1,0,18949,0,26124),
(47783,'Throngus SLICE you up!','',0,0,0,0,0,0,0,0,1,0,18948,0,26124),
(47784,'A million more await my orders. What chance do you have?','',0,0,0,0,0,0,0,0,1,0,18530,0,26124),
(47785,'Vermin, your dinner awaits!','',0,0,0,0,0,0,0,0,1,0,18531,0,26124),
(47786,'Messy...','',0,0,0,0,0,0,0,0,1,0,18532,0,26124),
(47787,'Clear the terrace for landing!  Shoot at Cauldron Defenders!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47788,'Newt, you\'re up! Break out the gatestone!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(47789,'Have you come for training, hunter?','Have you come for training, hunter?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47790,'','You got it boss. Er... where do I put it?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(47791,'You put it right in the... wait... where\'s the keyhole? What kind of racket is this?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47792,'Screw it. Ticker, you\'re up!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(47793,'Right away, boss!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47794,'I can\'t believe that we\'re doing this.  I know that Calcinder\'s presence threatens us all, but really?  Doesn\'t this seem like the domain of the Earthen Ring, or something?$b$bWhy\'s the Thorium Brotherhood gotta come save the day all the time?','',1,1,273,0,0,0,0,0,1,0,0,0,26124),
(47795,'Charges are set. Might want to get clear!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(47796,'Death is my only option.','',0,0,0,0,0,0,0,0,1,0,18533,0,26124),
(47797,'Like a  charm. Who needs a key anyway...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47798,'All in my path shall be destroyed!','',0,0,0,0,0,0,0,0,1,0,18534,0,26124),
(47799,'Attack you cowardly vermin!','',0,0,0,0,0,0,0,0,1,0,18535,0,26124),
(47800,'%s retracts her cyclone shield!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47801,'Welcome to Thorium Point.  As Overseer, I\'m responsible for all the activities of the Thorium Brotherhood.  While that mainly involves mining, smithing, and some minor guard duty, we\'ve lately become more of a martial organization... out of necessity.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47802,'We\'ve made it this far into the Slag Pit, $n.  Now it\'s time to finish the job.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47803,'You\'re welcome among us anytime, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47804,'%s conjures a temporary grounding field!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47805,'Fools.  Obsidion!  Rise, and destroy the interlopers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47806,'The Exodar has not answered my pleas, $n. I am afraid you are the only one who can help poor Magtoor.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47807,'I will continue my research in memory of Magtoor.','',0,0,0,0,0,0,0,0,1,10947,0,0,26124),
(47808,'Is there anything we can do to help?','Is there anything we can do to help?',0,0,0,0,0,0,6,1,1,0,0,0,26124),
(47809,'Is there anything my troops or I can do?','Is there anything my troops or I can do?',0,0,0,0,0,0,6,1,1,0,0,0,26124),
(47810,'Are you sure there is nothing more we can do Neeka?','Are you sure there is nothing more we can do Neeka?',0,0,0,0,0,0,6,1,1,0,0,0,26124),
(47811,'Is there nothing we can do for Helgrum?','Is there nothing we can do for Helgrum?',0,0,0,0,0,0,6,1,1,0,0,0,26124),
(47812,'Stand your posts and keep any Alliance filth from us.','Stand your posts and keep any Alliance filth from us.',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(47813,'Stand your ground and keep alert for any Alliance that may try to attack.','Stand your ground and keep alert for any Alliance that may try to attack.',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(47814,'Watch for any more Alliance.  We will make them suffer should they try to attack again.','Watch for any more Alliance.  We will make them suffer should they try to attack again.',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(47815,'Make sure you are all on guard for any more Alliance attacks.','Make sure you are all on guard for any more Alliance attacks.',0,0,0,0,0,0,1,1,1,0,0,0,26124),
(47816,'Hee hee... hee hee hee... ha ha ha!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47817,'Shh! They can hear you, dummy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47818,'Don\'t call me dummy, dummy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47819,'Ow! Now they can see us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47820,'Run!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47821,'That\'s right, beast. You belong to the Dragonmaw now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47822,'And if you don\'t obey, we\'re cutting you up for parts. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47823,'','Impressive. Complete domination of the animal while it\'s weakened.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47824,'','Tell me, what is this charm you\'re using?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(47825,'The Demon Chain. It projects our will like a physical force.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47826,'The Horde? I SPIT on your Horde! Our enemies are weak and splintered, yet you bargain with Hellscream? Dragonmaw stand alone!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47827,'I will prove it to you. I will strike the Wildhammer at Thundermar.','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(47828,'When I return victorious, we will see who the Dragonmaw call \"Warchief\".','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(47829,'How did you get here?  I will destroy you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47830,'','With your wing of drake riders and the support of the Horde, we can make an assault on the Bastion of Twilight.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47831,'','Another treasonous word and I will put you in your place, Narkrall.',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(47832,'','Narkrall! If you want to challenge me, you do so here. Do NOT squander our forces on a fool crusade.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47833,'','I owe you a great deal for my freedom, $n.$B$BNow, let us see if we can free Magatha and put an end to the Twilight\'s Hammer in Thousand Needles.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(47834,'','Hi there. All clear down here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47835,'BEES! Jump in water to get them off!','BEES! Jump in water to get them off!',0,0,0,0,0,0,0,0,1,11585,0,0,26124),
(47836,'Face me, $r, and know the legion\'s wrath!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47837,'These worgen are our prisoners. Their fate is in the hands of High Command.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(47842,'Hop on to the drake!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47843,'What do you want, scrub? Get out of my face before I knock that grin off of yours with my hammer!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(47844,'','I will use the crying violet to bind our words... our voices will be carried to you even in the deepest reaches of Jaedenar and Shadow Hold.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47845,'No pathetic $r will deny me my birthright!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47846,'How can I help you, $g handsome : gorgeous;?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(47847,'What is it? I\'m very busy, defender.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(47848,'The dragons have bought us an opportunity to sieze the gates from the Twilight\'s Hammer. We would do well not to waste it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47849,'I\'m ready to press up the canyon. Is the Gob Squad prepped?','I\'m ready to press up the canyon. Is the Gob Squad prepped?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47850,'They\'ve been waiting on you, $c.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47851,'(Blood for the master!)','',0,0,0,0,0,0,0,0,1,0,22069,0,26124),
(47852,'Such is your fate.','',0,0,0,0,0,0,0,0,1,0,22070,0,26124),
(47853,'Pathetic flesh!','',0,0,0,0,0,0,0,0,1,0,22071,0,26124),
(47854,'(Finish it! Finish them all!)','',0,0,0,0,0,0,0,0,1,0,22072,0,26124),
(47855,'Embrace your end.','',0,0,0,0,0,0,0,0,1,0,22073,0,26124),
(47856,'Give me your strength!','',0,0,0,0,0,0,0,0,1,0,22078,0,26124),
(47857,'Behold the might of the hammer!','',0,0,0,0,0,0,0,0,1,0,22079,0,26124),
(47858,'(Stop. Hammertime!)','',0,0,0,0,0,0,0,0,1,0,22080,0,26124),
(47859,'Enough! (To His will all flesh succumbs. From His kingdom, chaos comes.) Yes - what he said.','',0,0,0,0,0,0,0,0,1,0,22081,0,26124),
(47860,'(Infinite suffering!)','',0,0,0,0,0,0,0,0,1,0,22082,0,26124),
(47861,'(*Snort*)','',0,0,0,0,0,0,0,0,1,0,22083,0,26124),
(47862,'Behold the destiny of your fragile world!','',0,0,0,0,0,0,0,0,1,0,22084,0,26124),
(47863,'More. More!','',0,0,0,0,0,0,0,0,1,0,22085,0,26124),
(47864,'(Come, brothers! Feast on hope!)','',0,0,0,0,0,0,0,0,1,0,22086,0,26124),
(47865,'There\'s another one! Kill the $r!','Get away from there, $r scum!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(47866,'(More. They need more.)','',0,0,0,0,0,0,0,0,1,0,22087,0,26124),
(47867,'The Alliance ... they\'re defending the Wildhammer... ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47868,'Brother, it cannot be... (Destiny has come!) My strength... (Too proud! He speaks in blood! Listen!) My mind... (It is for His glory we serve!) What... is happening... (Gone is the dawn. Come shades of Twilight. Come madness, come havoc, come Infinite Night!)','',0,0,0,0,0,0,0,0,1,0,22093,0,26124),
(47869,'Squad reporting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47870,'In the gut!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47871,'Messy...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47872,'You want some of this?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47873,'Bring it on!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47874,'Thank you. I will not forget.','Thank you. I will not forget.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(47875,'Good luck to you. I\'m grateful.','Good luck to you. I\'m grateful.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(47876,'Are you here for the Elder Crone, Magatha Grimtotem? They\'re holding her to the east.','Are you here for the Elder Crone, Magatha Grimtotem? They\'re holding her to the east.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(47877,'These cultists are insane. They\'re trying to bring about the end of the world!','These cultists are insane. They\'re trying to bring about the end of the world!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47878,'They were going to sacrifice me to summon more of their elementals!','They were going to sacrifice me to summon more of their elementals!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47879,'Get some vengeance for me.','Get some vengeance for me.',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(47880,'I overheard them talking. They\'re getting ready to summon up something big at their base to the east!','I overheard them talking. They\'re getting ready to summon up something big at their base to the east!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47881,'There\'s been too much death. Too much destruction. Put an end to them!','There\'s been too much death. Too much destruction. Put an end to them!',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(47882,'(Body and soul, to be swallowed whole!)','',0,0,0,0,0,0,0,0,1,0,22088,0,26124),
(47883,'Everyone succumbs in the end.','',0,0,0,0,0,0,0,0,1,0,22089,0,26124),
(47884,'(Now they see the darkness! Their eyes are open!)','',0,0,0,0,0,0,0,0,1,0,22090,0,26124),
(47885,'Now the Master has them.','',0,0,0,0,0,0,0,0,1,0,22091,0,26124),
(47886,'(Chaos, madness! Like a hug for your brain.)','',0,0,0,0,0,0,0,0,1,0,22092,0,26124),
(47887,'','Nothing new here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47888,'','Yep, still good.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47889,'','We\'re fine. We\'re all fine here now, thank you. How are you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47890,'What a pleasure, $c.$b$bWe get so few visitors these days.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47891,'What a surprise!$b$bWe weren\'t expecting anyone today...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47892,'It is finished. (The fate of all.)','',0,0,0,0,0,0,0,0,1,0,22101,0,26124),
(47893,' Brother, we are shattered. (But the Master... I still hear... so angry... Master...?)','',0,0,0,0,0,0,0,0,1,0,22099,0,26124),
(47894,'Brother, we are shattered. Let her finish them. (The Master does not want them near her... Brother?  The Master seethes...)','',0,0,0,0,0,0,0,0,1,0,22100,0,26124),
(47895,'So, zhis is zhe $r $c I\'ve heard so much about, hmm?$b$bAs you know, zhere is vone obelisk zhat has yet to be activated....$b$bVhen zhe time comes to restore zhis ancient mechanism, vhill you be zhere? Vill history remember you?$b$bZhat depends on your villingness to cooperate!','',0,0,0,0,0,0,274,0,1,10830,0,0,26124),
(47896,'','I am new to the burdens of leadership. I should\'ve seen Narkrall\'s insubordination coming. Instead I am cleaning up his mess.$B$BI don\'t know how Garrosh Hellscream does it. He must possess great strength to hold together a force as diverse as the Horde... I should like to know him more.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(47897,'|TInterface\\Icons\\spell_shadow_shadesofdarkness.blp:20|t%s begins to summon |cFFFF0000Darkened Creations|r to aid him!\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47898,'The Vortex Pinnacle, a level 82-84 dungeon in Uldum, is now available for initial testing. The dungeon is a work in progress. Please be in your full group before teleporting to the dungeon.\n\nTo leave the Vortex Pinnacle, you must teleport out with a Hearthstone or similar method. If you die and release, you should teleport back from this NPC.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47899,'(The claws of fate grasp the unbelievers!)','',0,0,0,0,0,0,0,0,1,0,22094,0,26124),
(47900,'(The Master sees, the Master sees!)','',0,0,0,0,0,0,0,0,1,0,22095,0,26124),
(47901,'What madness have we wrought? (Not yet enough!)','',0,0,0,0,0,0,0,0,1,0,22096,0,26124),
(47902,' I...  can\'t take much more... (Brother, it merely begins!)','',0,0,0,0,0,0,0,0,1,0,22097,0,26124),
(47903,'(The Master\'s eye sees all that was and all to be, or not!)','',0,0,0,0,0,0,0,0,1,0,22098,0,26124),
(47904,'I\'m in my group and ready to teleport to the Vortex Pinnacle!','I\'m in my group and ready to teleport to the Vortex Pinnacle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47905,'Take me back to the Vortex Pinnacle!','Take me back to the Vortex Pinnacle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47906,'The dragons have bought us an opportunity to seize the gates from the Twilight\'s Hammer. We would do well not to waste it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47907,'I\'m ready to press up the canyon. Is the squad prepped?','I\'m ready to press up the canyon. Is the squad prepped?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47908,'Bare your soul to me, mortal.','',0,0,0,0,0,0,0,0,1,0,20302,0,26124),
(47909,'They\'re already assembled. I\'m trusting you to secure the route to Grim Batol. Don\'t let me down.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47910,'I knew I should have stayed out of this...','',0,0,0,0,0,0,0,0,1,0,20303,0,26124),
(47911,'You are not the boss of me, Valiona! I will engulf as I please!','',0,0,0,0,0,0,0,0,1,0,20304,0,26124),
(47912,'There is no escape from the fury of the twilight flight!','',0,0,0,0,0,0,0,0,1,0,20305,0,26124),
(47913,'WRITHE IN AGONY!','',0,0,0,0,0,0,0,0,1,0,20306,0,26124),
(47914,'Do you feel that chill running up your spine?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47915,'The fog is rolling in...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47916,'My suffering is at an end, $r. But yours has just begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47917,'','Here he comes, $n! Beat him down while I dominate him with the Demon Chain.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(47918,'','Keep fighting, $c! The Demon Chain will eventually win out.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47919,'Purge of unauthorized entities commencing.','',0,0,0,0,0,0,0,0,1,0,20862,0,26124),
(47920,'Omega Stance activated. Annihilation of foreign unit is now imminent.','',0,0,0,0,0,0,0,0,1,0,20861,0,26124),
(47921,'Target annihilated.','',0,0,0,0,0,0,0,0,1,0,20858,0,26124),
(47922,'Purge complete.','',0,0,0,0,0,0,0,0,1,0,20859,0,26124),
(47923,'Anraphet unit shutting down...','',0,0,0,0,0,0,0,0,1,0,20856,0,26124),
(47924,'Electron unit activated.','',0,0,0,0,0,0,0,0,1,0,21865,0,26124),
(47925,'Magmatron unit activated.','',0,0,0,0,0,0,0,0,1,0,21866,0,26124),
(47926,'Toxitron unit activated.','',0,0,0,0,0,0,0,0,1,0,21867,0,26124),
(47927,'Arcanotron unit activated.','',0,0,0,0,0,0,0,0,1,0,21868,0,26124),
(47928,'Electron unit shield systems online.','',0,0,0,0,0,0,0,0,1,0,21869,0,26124),
(47929,'Magmatron unit shield systems online.','',0,0,0,0,0,0,0,0,1,0,21870,0,26124),
(47930,'Arcanotron unit shield systems online.','',0,0,0,0,0,0,0,0,1,0,21872,0,26124),
(47931,'Rerouting excess energy to Magmatron unit. Engage flamethrower device.','',0,0,0,0,0,0,0,0,1,0,21873,0,26124),
(47932,'Intruders detected. Primary defense matrix initiated.','',0,0,0,0,0,0,0,0,1,0,21863,0,26124),
(47933,'The good Doktor Professor Ironpants may be found in the Hall of Explorers.','The good Doktor Professor Ironpants may be found in the Hall of Explorers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47934,'Defense systems obliterated. Powering down...','',0,0,0,0,0,0,0,0,1,0,21864,0,26124),
(47935,'Ye\'ll find an Arcane Reforger in Gimble\'s shop, Thistlefuzz Arcanery, right by the Gryphon Master at The Great Forge.$B$BHe\'s one o\' them long-lost Highborne elves, but he\'ll do ye right.','Ye\'ll find an Arcane Reforger in Gimble\'s shop, Thistlefuzz Arcanery, right by the Gryphon Master at The Great Forge.$B$BHe\'s one o\' them long-lost Highborne elves, but he\'ll do ye right.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(47936,'I am ready to fight Torth!','I am ready to fight Torth!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47937,'Hey you. Can you get me out of here?','Hey you. Can you get me out of here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47938,'A little help here?','A little help here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47939,'You\'re lucky you\'re on the other side of these bars!','You\'re lucky you\'re on the other side of these bars!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47940,'Let me out of here!','Let me out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47941,'What are you going to do to me?','What are you going to do to me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47942,'You, over there. Come kill my jailer!','You, over there. Come kill my jailer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47943,'I will not be manipulated!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47944,'','His will - it\'s too strong!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(47945,'There is a blood elf in the Valley of Strength\'s central fortress, part of a delegation from Silvermoon: Belloc. He is who you want.','There is a blood elf in the Valley of Strength\'s central fortress, part of a delegation from Silvermoon: Belloc. He is who you want.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(47946,'The mages may be found in Cleft of Shadow.  There are two entrances: One between the valleys of Strength and Wisdom, and the other in The Drag.','The mages may be found in Cleft of Shadow.  There are two entrances: One between the valleys of Strength and Wisdom, and the other in The Drag.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(47947,'I ... will not ... serve!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47948,'','Then you will die.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47949,'','So be it. It is done.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47950,'','Meet me in the Gullet, $n. Fly west, across the river, and look for a small cave along the ridgeline...',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47951,'Good working with you.','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(47952,'See you around!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(47953,'I kind of like you. Try not to get killed out there.','I kind of like you. Try not to get killed out there.',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(47954,'Deethuk, you\'re a little snot! Wait... what\'s wrong with your code device?','Deethuk, you\'re a little snot! Wait... what\'s wrong with your code device?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47955,'Huh? What?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47956,'Toxitron unit shield systems online.','',0,0,0,0,0,0,0,0,1,0,21871,0,26124),
(47957,'$n! I\'m glad you made it.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47958,'%s prepares to massacre his foes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47959,'Breathe your dying breath!','',0,0,0,0,0,0,0,0,1,0,21896,0,26124),
(47960,'At least... Theralion dies with me...','',0,0,0,0,0,0,0,0,1,0,21897,0,26124),
(47961,'Theralion, I will engulf the hallway. Cover their escape!','',0,0,0,0,0,0,0,0,1,0,21898,0,26124),
(47962,'Enter Twilight!','',0,0,0,0,0,0,0,0,1,0,21899,0,26124),
(47963,'Careful, $r.$b$bSchnottz is in a foul mood after the failed ritual incident.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47964,'The ambassador lies dead in a pool of his own gore.$b$bThrough his rent clothing, you can make out a row of enormous, deep teethmarks.$b$bEven stranger, the wounds appear to be cauterized, even charred in places.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47965,'%s weakens! Capture them with your shackles!','%s weakens! Capture them with your shackles!',0,0,0,0,0,0,0,0,1,10969,0,0,26124),
(47966,'<The man barely acknowledges your presence. It is clear that he isn\'t interested in speaking with you.>','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47967,'Break out the gatestone. Open this thing up.','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(47968,'','Right away sir. Er... I don\'t see a slot to put it in?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(47969,'It\'s never easy, is it? That\'s alright, we came prepared.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47970,'Blow it open. There isn\'t a problem that some explosives can\'t solve.','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(47971,'On it.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47972,'Charges are set. Might want to get clear!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(47973,'That\'s what I like to see. Who needs a gatestone anyway...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47974,'Paratroopers?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47975,'Commander, behind you! Gnomeregan paratroopers!','Commander, behind you! Gnomeregan paratroopers!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47976,'Look! Behind you! A mirror!','Look! Behind you! A mirror!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47977,'A mirror? How wonderful!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47978,'Move along, $r.$b$bYour presence is of no consequence to me.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47979,'<The emissary sneers without looking at you.>$b$bGo about your business, $r.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47980,'Terrible business!$b$bThere was a horrific growling noise that seemed to echo throught the region.$b$bPoor fellow...$b$bYou\'ll excuse me - I do believe I need a drink.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47981,'I cannot be certain of what I saw.$b$bIt was over before I realized what was happening.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47982,'How unfortunate!$b$bLet\'s get this cleaned up, shall we?$b$bWouldn\'t want to make any more of this than needs be...','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(47983,'Don\'t you want to know what happened to the man?','Don\'t you want to know what happened to the man?',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47984,'I\'m curious, of course, but what\'s done is done.$b$bWe wouldn\'t want to stir up any unneccesary panic. That simply wouldn\'t be prudent!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47985,'Your only concern here is your stake in this operation?','Your only concern here is your stake in this operation?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(47986,'Certainly not!$b$bI mean, I do have my entire fortune at risk here... and honestly, what good would a public crisis do anyone?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(47987,'What\'s happening out here!?$b$bDid you see the man\'s wounds?!$b$bWhat kind of monster DOES that?\n','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47988,'Just take a deep breath. Did you see anything?','Just take a deep breath. Did you see anything?',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47989,'No, but I don\'t need to have seen it to know that we\'re all going to DIE!$b$bDo you hear me?!\n','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47990,'Just relax... Panicking will only make it worse.','Just relax... Panicking will only make it worse.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47991,'Easy for you to say.$b$bI\'m not cut out for this! I need to find a way out of here!\n','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(47992,'','<The starlet stares at you blankly.>',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47993,'Archmage Pratt, an Arcane Reforger recently from Dalaran, is usually working with Lavinia Crowe, the local enchanter. They\'re both in the Apothecarium.','Archmage Pratt, an Arcane Reforger recently from Dalaran, is usually working with Lavinia Crowe, the local enchanter. They\'re both in the Apothecarium.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(47994,'My advice to you is simple, $r.$b$bDo not get in the way here.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(47995,'Ah, you seek one of the returned Highborne.$B$BOne of their Arcane Reforgers has been spending time with Taladan, the enchanter.  Seek them out in the Craftsmen\'s Terrace.','Ah, you seek one of the returned Highborne.$B$BOne of their Arcane Reforgers has been spending time with Taladan, the enchanter.  Seek them out in the Craftsmen\'s Terrace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47996,'There is a scholar, Hammond the Jaded, who can assist you.  You will find him in the Temple of the Moon, often conversing with one of the returned Highborne.','There is a scholar, Hammond the Jaded, who can assist you.  You will find him in the Temple of the Moon, often conversing with one of the returned Highborne.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(47997,'Do I know you? No? Welcome to the Twilight\'s Hammer.','Do I know you? No? Welcome to the Twilight\'s Hammer.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(47998,'The end days are nigh!','The end days are nigh!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(47999,'There\'s a little blood on your armor there. Are you okay?','There\'s a little blood on your armor there. Are you okay?',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(48000,'New recruit? Have you reported to the commander yet?','New recruit? Have you reported to the commander yet?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(48001,'Hey, you haven\'t seen Grom-Grom have you? Orc, about this tall. No?$B$BHmm. No one\'s seen him for a while. Probably went a.w.o.l.','Hey, you haven\'t seen Grom-Grom have you? Orc, about this tall. No?$B$BHmm. No one\'s seen him for a while. Probably went a.w.o.l.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(48002,'Something big\'s brewing at the Withering to the east.$B$BWhatever it is, I hope that it\'ll be over soon and we get restationed somewhere nicer.','Something big\'s brewing at the Withering to the east.$B$BWhatever it is, I hope that it\'ll be over soon and we get restationed somewhere nicer.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48003,'Keep your eyes peeled. They say that freak that was attacking people earlier might still be around.','Keep your eyes peeled. They say that freak that was attacking people earlier might still be around.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48004,'Isn\'t it weird that we\'re keeping Magatha Grimtotem captive here? Good thing all of her totems were destroyed.$B$BI even heard that she poisoned Cairne Bloodhoof. Wish she were on our side.','Isn\'t it weird that we\'re keeping Magatha Grimtotem captive here? Good thing all of her totems were destroyed.$B$BI even heard that she poisoned Cairne Bloodhoof. Wish she were on our side.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(48005,'You will find a blood elf Arcane Reforger, Herim, at Dawnstrider Enchanters on the middle rise.  She will be able to assist you.','You will find a blood elf Arcane Reforger, Herim, at Dawnstrider Enchanters on the middle rise.  She will be able to assist you.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(48006,'I can smell your fear...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48007,'I will rip your heart from your chest!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48008,'Ha ha ha ha ha!  Rah ha ha ha ha ha!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48009,'Your blood only increases my hunger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48010,'You will...NOT find her...until it is too late...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48011,'Warlord Krogg sent me here to keep this front locked down. But he hasn\'t sent me any soldiers yet.$B$BLook at this place! I\'ve got ogres. I\'ve got Twilight\'s Hammer. I\'ve got... nothing.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(48012,'$n! Ovah he\'ah!','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(48013,'Zhis vay, $n! Come! Come!','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(48014,'Hurry, $n! Zhere is little time!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(48015,'Come, $n! Into zhe siege tank! NOW!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(48016,'I am free after ten thousand years, yet still my own brother thinks I am a villain! I\'ll show him my true power! I\'ll show him that the demons have no hold over me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48017,'Are you certain of that, demon hunter? Are you certain your will is your own?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48018,'You reek of death, human. You\'ll regret approaching me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48019,'Come then. You\'ll find that we\'re evenly matched.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48020,'We could go on fighting like this forever. What is it you truly want?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48021,'The dreadlord who commands this undead army is called Tichondrius. He commands a powerful warlock artifact called the Skull of Gul\'dan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48022,'It is responsible for corrupting these forests.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48023,'And you wish for me to steal it. Why?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48024,'Otoh Greyhide spends much of time in the Hall of Elders on the Elder Rise.  Seek him out there, and he will help you.','Otoh Greyhide spends much of time in the Hall of Elders on the Elder Rise.  Seek him out there, and he will help you.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(48025,'Let\'s just say that I have no love for Tichondrius, and the lord I serve would... benefit from the Legion\'s downfall.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48026,'You will find the Sunwalker\'s Lodge on Hunter\'s Rise.','You will find the Sunwalker\'s Lodge on Hunter\'s Rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(48027,'The Seers of Elder Rise will help you.  Seek them out in the Hall of Elders there.','The Seers of Elder Rise will help you.  Seek them out in the Hall of Elders there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(48028,'Paladin','Paladin',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48029,'','The Elder Crone rubs her wrists as she flashes a toothy grin your way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48030,'I have no need for eyes to see my enemies. Your clumsy footsteps and foul stench give you away!','',0,0,0,0,0,0,0,0,1,0,20820,0,26124),
(48031,'Sighted, but blind to the truth. Embrace the finality of it all!','',0,0,0,0,0,0,0,0,1,0,20821,0,26124),
(48032,'','I\'m surprised that you made it this far.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48033,'Death waits in the darkness!','',0,0,0,0,0,0,0,0,1,0,20822,0,26124),
(48034,'This miserable existence finally ends.','',0,0,0,0,0,0,0,0,1,0,20823,0,26124),
(48035,'','I suppose I should thank you for freeing me. We\'ll soon see if you think that was a wise decision.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48036,'You cannot hide from searing flame!','',0,0,0,0,0,0,0,0,1,0,20826,0,26124),
(48037,'','Meet me just outside of the Twilight Withering down the path to the east.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48038,'Yes, run! With every step your heart quickens. The beating, loud and thunderous... Almost deafening. You cannot escape!','',0,0,0,0,0,0,0,0,1,0,20827,0,26124),
(48039,'The city\'s Arcane Reforger, Enchantress Fira, will be able to help you.  She is most often found with Sedana and her enchanter\'s apprentices, off the Court of the Sun.','The city\'s Arcane Reforger, Enchantress Fira, will be able to help you.  She is most often found with Sedana and her enchanter\'s apprentices, off the Court of the Sun.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48040,'','Find the codes to release me from these infernal bonds!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(48041,'One of Darnassus\' Highborne, an Arcane Reforger, is working with the Exodar\'s enchanters.  You\'ll find them all in the Crystal Hall, opposite the jewel crafters.','One of Darnassus\' Highborne, an Arcane Reforger, is working with the Exodar\'s enchanters.  You\'ll find them all in the Crystal Hall, opposite the jewel crafters.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48042,'You vorry about zhe killink!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48043,'It\'s all gone to hell, $c!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(48044,'Looking for Diya, wandering among the images around the Seat of the Naaru. She will be more than happy to help you.','Looking for Diya, wandering among the images around the Seat of the Naaru. She will be more than happy to help you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48045,'I vill vorry about zhe drivink!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48046,'','Dese caves be haunted, mon. Filled with the worst juju.$B$BIn days when de Twilight\'s Hammer be settin\' up atop de mountain, the unworthy were tossed into dese caverns. Into de Gullet. Food for de black drakes dat once nested here.$B$BDem people, dey never come out. Not even de spirits.',1,274,0,0,0,0,0,0,1,0,0,0,26124),
(48047,'','Greetings, $c!',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(48048,'Sarus, I lost my spider. Could I have another?','Sarus, I lost my spider. Could I have another?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48049,'Boduro the Seeker can often be found in the merchant\'s bazaar within the Lower City. I would look for him there.','Boduro the Seeker can often be found in the merchant\'s bazaar within the Lower City. I would look for him there.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48050,'The Highborne Archmage, Aranhir Starsinger, is a master of arcane reforging... you might convince him to aid you.\n\nHe can often be found discussing his craft with those of Simply Enchanting, just outside the Magus Commerce Exchange in northwest Dalaran.','The Highborne Archmage, Aranhir Starsinger, is a master of arcane reforging... you might convince him to aid you.\n\nHe can often be found discussing his craft with those of Simply Enchanting, just outside the Magus Commerce Exchange in northwest Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48051,'The high elf mage and scholar Dariness is the city\'s most learned archaeologist... and the most sociable.$B$BShe can often be found in the Legerdemain Lounge, just north of the city\'s center, enjoying the atmosphere or discussing her wild adventures with the proprieters and patrons both.','The high elf mage and scholar Dariness is the city\'s most learned archaeologist... and the most sociable.$B$BShe can often be found in the Legerdemain Lounge, just north of the city\'s center, enjoying the atmosphere or discussing her wild adventures with the proprieters and patrons both.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48052,'|c00FF0000Chimaeron\'s Massacre has knocked the Bile-O-Tron offline!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48053,'|c0000FF00The Bile-O-Tron is back online!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48054,'','Beat me to it, I see. Your exit awaits...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48055,'No... NO! This is my domain! You cannot have... it...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48056,'Pathetic mortal... I will build a new empire atop your corpse!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48057,'THANKS! HI! LET\'S ROUND UP SOME HUMANS FOR THE CAPTAIN!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48058,'Escort Dumass out of the mine safely. Keep Dumass away from webbed humans.','',0,0,0,0,0,0,0,0,1,10979,0,0,26124),
(48059,'WHAT\'S TAKING SO LONG? I\'M LEAVING! BYE!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48060,'YAY! CAPTAIN I AM BACK! HOORAY!','',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(48061,'Wow, yea, that\'s great. I\'m SO HAPPY to see that $P helped you out of the mine, postponing your tragic and inevitable death. Now why don\'t you scurry along now. I hear Tarren Mill is looking for Forsaken just like you, Dumass.','',0,0,0,0,0,0,0,0,1,10980,0,0,26124),
(48062,'TARREN MILL! OK! IS THAT IN THE BARRENS! I\'M ON MY WAY! THANKS!','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(48063,'BEAT THEM DOWN THEN KILL! THEN SHACKLE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48064,'THIS IS EASY! YES!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48065,'HERE\'S ONE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48066,'HOW DID ALL THESE PEOPLE GET IN HERE?!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48067,'THIS ONE IS ANGRY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48068,'These glorious fields weren\'t always here, $c. Only through determination and the strength of will did we turn the decrepit human farms into Lordaeron\'s largest and most productive sludge and mushroom plantation.$B$BNow all of that could be lost due to a simple accident!','',396,396,5,0,0,0,0,0,1,0,0,0,26124),
(48069,'I USED TO BE A FARMER!','',0,0,0,0,0,0,5,0,1,10979,0,0,26124),
(48070,'THERE\'S ONE OVER THERE!','',0,0,0,0,0,0,25,0,1,10979,0,0,26124),
(48071,'THESE HUMANS LOOK DANGEROUS!','',0,0,0,0,0,0,1,0,1,10979,0,0,26124),
(48072,'THANKS FOR RESCUING ME!','',0,0,0,0,0,0,1,0,1,10979,0,0,26124),
(48073,'WHEN I WOKE UP I SAW THE BANSHEE QUEEN TALKING TO A BIG BROWN ORC!','',0,0,0,0,0,0,1,0,1,10979,0,0,26124),
(48074,'WHO ARE OUR FRIENDS?','',0,0,0,0,0,0,6,0,1,10979,0,0,26124),
(48075,'WERE YOU IN SILVERPINE WHEN THE BANSHEE QUEEN KILLED ALL OF THE WORGEN!?','',0,0,0,0,0,0,6,0,1,10979,0,0,26124),
(48076,'Grows larger...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48077,'Grows even larger...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48078,'Looks like he\'s about to explode!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48079,'DESTROY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48080,'That is where the skull of Gul\'dan is being kept! These paltry demons will not prevent me from claiming it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48081,'Now at least the demons will no longer corrupt the forests. But, if I claim this power as my own, I will become stronger than any of Archimonde\'s lieutenants.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48082,'Yes... the power should be mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48083,'Now I am complete!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48084,'','Bad juju ain\'t got nothin\' on you, $gsweetie:girl;.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(48085,'Turn back, $c. Dere be some serious darkness in dis cave, and I ain\'t talkin\' about de lack of light.','',274,25,0,0,0,0,0,0,1,0,0,0,26124),
(48086,'Dis be it, mon! You got de light? You hold it tight, no matter what happens.$B$BSay de word and I put you in de spirit realm. De spirits, dey will come after you, try to drag you down into de darkness.$B$BShine dat light on de nasties!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(48087,'De dirty business be done, mon. Dis cave be safe now.$B$BDis place can be quite de home. What do you think? Maybe a few more masks, yes?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(48088,'You be not afraid of nothin\', $c!$B$BBuunu be waitin\' for you outside.','',1,25,0,0,0,0,0,0,1,0,0,0,26124),
(48089,'You lookin\' for trainin\'? No can do. I ain\'t your guy.','You lookin\' for trainin\'? No can do. I ain\'t your gal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48090,'You lookin\' to train up, bruiser?','You lookin\' to train up, bruiser?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48091,'You can follow me to the Loading Room, $n.','You can follow me to the Loading Room, $n.',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(48092,'Walk to the Three Shrines Within the Cave','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48093,'Aim Your Light of Souls at the Spirits to Banish Them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48094,'Placeholder - Quest Not Yet Implemented','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48095,'I am ready, Uchek!','I am ready, Uchek!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48096,'','I don\'t be hearin\' de whispers no more, $n. What happened in de cave?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(48097,'','Do you want to see the utter destruction of what\'s left of Thousand Needles?$B$BNo?$B$BThen do exactly as I command.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(48098,'You will pay for this intrusion!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48099,'','This is where we gather the surivors to prepare them for decontamination. From there, it\'s just a short trip to the surface!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48100,'I\'m sure I don\'t need to remind you to stay alert down here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48101,'A prisoner has escaped!  Slay $g him:her;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48102,'You won\'t make it far!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48103,'I will spill your blood in Deathwing\'s name!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48104,'If slavery does not suit you, maybe death will!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48105,'I will show you the weakness of flesh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48106,'You\'re going to wish you\'d never set foot in Uldum!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48107,'|TInterface\\Icons\\spell_fire_felrainoffire.blp:20|t%s begins to cast |cFFFF0000|Hspell:88972|h[Fel Firestorm]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48108,'Yeah, I got it. That\'s weird.$B$BWho loses their river boat, cap\'n?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(48109,'','How exactly does one lose an entire river boat, $n?',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(48110,'Everything here is completely on the up and up!','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(48111,'Um... I hate to say this, but... I kinda lost the I-Scream Cryocannon.','Um... I hate to say this, but... I kinda lost the I-Scream Cryocannon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48112,'Wait... what? Um, sure.$B$BHere\'s my spare.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(48113,'The Wildhammer dwarves are our mortal enemy. It\'s them or us.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48114,'','This is the most moronic... half-assed... ridiculous plan you\'ve ever come up with, Budd!',0,0,0,0,0,0,274,0,1,0,0,195,26124),
(48115,'','But I suppose it\'s the only plan we\'ve got.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(48116,'','What am I grabbing again?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48117,'OAF SMASH!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48118,'Free... at last.  Your reward will be substantial, friends.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48119,'Your approach is... unorthodox.  Though, I suppose with the smoke from the fires, all they\'ll see is your silhouettes.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48120,'LOOK AT ME!!!!  I\'M A MANATAUR!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48121,'','No one rides the Lady!',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(48122,'','Shut your stupid face, Budd.  SHUT IT!!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48123,'Let\'s go!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48124,'Let\'s see how confident you are against one of your own kind, dreadlord.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48125,'Zhat\'s it!$b$bZhe scrubs vill clean up zhe rest.$b$bBack to zhe base ve go!','Zhat\'s it!$b$bZhe scrubs vill clean up zhe rest.$b$bBack to zhe base ve go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48126,'Ice Cream! Get your tasty, cold, sweet, delicious ice cream right here!','',0,0,0,0,0,0,0,0,1,11003,0,0,26124),
(48127,'Brivelthwerp\'s Ice Cream Empire. Now offering TWO flavors!','',0,0,0,0,0,0,0,0,1,11003,0,0,26124),
(48128,'Try all new Brivelthwerp\'s Sililicious Crunch ice cream. Chock-full of real silithid. Accept no imitations!','',0,0,0,0,0,0,0,0,1,11003,0,0,26124),
(48129,'Ice cream, candy, bubblegum!','',0,0,0,0,0,0,0,0,1,11003,0,0,26124),
(48130,'Don\'t settle for anything but the best. Brivelthwerp\'s!','',0,0,0,0,0,0,0,0,1,11003,0,0,26124),
(48131,'Leave me be.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48132,'It\'s unseasonably hot. Time for Brivethwerp\'s Sililicious Crunch!','',0,0,0,0,0,0,0,0,1,11003,0,0,26124),
(48133,'I\'m here to put an end to your killing.','I\'m here to put an end to your killing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48134,'Brivelthwerp\'s, it\'s what\'s for dessert!','',0,0,0,0,0,0,0,0,1,11003,0,0,26124),
(48135,'All the kids are just dying for some Brivelthwerp\'s ice cream!','',0,0,0,0,0,0,0,0,1,11003,0,0,26124),
(48136,'Blind fool! You have no idea what you are doing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48137,'Enough! Stay your hand!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48138,'I vill discovah who vas behind zhis cowardly act!$b$bAnd vhen I do....','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48139,'|cFFFFFFFFThere\'s trouble at the Sludge Fields...|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48140,'If ever there comes a time that I have something to say to you, you should run.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48141,'You foolishly stumble about here, $r, oblivious to what forces surround you.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48142,'There is fear in you, mortal.$b$bI can smell it.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48143,'State your business.  Be brief, if possible.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48144,'King Phaoris sent me to ask you about Neferset activity.','King Phaoris sent me to ask you about Neferset activity.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48145,'The king is sending a stranger to gather information for him?  I suppose you must be that... what\'s the word?  $R?  Yes, that $r that rescued Prince Nadun.$B$BAt any rate, I haven\'t seen any signs of the Neferset scum this far north.  There are plenty of other nuisances to be dealt with, however.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48146,'I\'ve heard of you, $n.  Are you here to help us?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48147,'I might be able to help.  Were the Neferset behind this?','I might be able to help.  Were the Neferset behind this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48148,'No.  This was the work of common Wastewander bandits.$B$BIt is rumored they\'re joining a more regimented group to the west.  Their violence is barbaric.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48149,'I heard you were in town.  What a strange creature you are.$B$BYou wish to speak to me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48150,'The king wishes to be informed about recent Neferset activity.','The king wishes to be informed about recent Neferset activity.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48151,'No, no Neferset movement.  But I just received word that the city of Orsis is being hit by the largest sandstorm anyone has ever witnessed.$B$BI was about to send word to the king myself, but perhaps you can relay the information.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48152,'Greely, can you get me back into that footbomb uniform?','Greely, can you get me back into that footbomb uniform?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48153,'','We\'ve long held out hope of redeeming the Earthwarden and his children. At some point, we must have the wisdom to realize that no amount of redemption can atone for the destruction these dragons are unleashing upon the world.$B$BAt some point, we are forced to intervene.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48154,'Follow the hatchlings into the Obsidian Lair.','Follow the hatchlings into the Obsidian Lair.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48155,'Alright, let\'s move.','Alright, let\'s move.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48156,'Follow me! Zhere is much to be done!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48157,'Auch! Zhis is an outrage!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48158,'You take a group of miserable bandits, make them part of somezhink historical, and zhis is vhat you get?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(48159,'I am goink find out who is behind zhis treachery, and you are goink to help me!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48160,'Zhis vork is bigger zhan you or me... Bigger zhan anyvone knows!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48161,'Zhese vould-be assassins don\'t know who zhey are meddling vizh!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48162,'Soon, zhey shall learn... and vhen zhey do, zhey vill tremble!','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(48163,'','Oh... I wish I\'d never come to this place!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48164,'How did I ever get myself into this?!\n','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48165,'I was blinded by all of the excitement.$b$bI should have seen this coming from a mile away...','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(48166,'My life\'s fortune... gone.$b$bThere\'s no hope left for me.','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(48167,'','This is all too much to bear.$b$bI wish I had the nerve to... <sob>.',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(48168,'I thought he had all the right answers.$b$bI... hoped.$b$bHe\'s nothing that he portrayed himself to be.$b$bI was a fool.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48169,'The seahorse floats patiently.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48170,'Show me where I can go.','Show me where I can go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48171,'I need to get to Nespirah.','I need to get to Nespirah.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48172,'Use the shovel to smash in the human seedling\'s heads.|TInterface\\Icons\\INV_MISC_SHOVEL_01.BLP:24|t$B$BOR$B$B[Right Click] the human seedlings to free them from the dirt.|TInterface\\Cursor\\SKINALLIANCE.BLP:24|t$B$BDo the right thing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48173,'M... maybe you\'re not all bad after all...','M... maybe you\'re not all bad after all...',0,0,0,0,0,0,1,0,1,10998,0,0,26124),
(48174,'Thank you for saving my life. I owe you a debt of gratitude.','Thank you for saving my life. I owe you a debt of gratitude.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48175,'I won\'t soon forget this kindness, $r.','I won\'t soon forget this kindness, $r.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48176,'It... they planted us in the dirt like crops! Stillwater is insane! Get out of here while you still can!','It... they planted us in the dirt like crops! Stillwater is insane! Get out of here while you still can!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48177,'He killed everyone! EVERYONE!','He killed everyone! EVERYONE!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48178,'Should you ever be buried neck deep in a field of feces and urine, I will be sure to lend you a hand.','Should you ever be buried neck deep in a field of feces and urine, I will be sure to lend you a hand.',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(48179,'Ah, fresh meat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48180,'These documents implicate several troll spies.  Consider their heads forfeit.  Take your compensation and spend it wisely; it\'s drawn from the taxpayers of Stormwind.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48181,'These documents implicate several orcish spies.  Our best assassins will be dispatched for this treachery.  Take your compensation and spend it wisely; it\'s drawn from the taxpayers of Stormwind.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48182,'You honor us by delivering this information.  It seems as if we\'ve finally found the spy in the city... a homeless man whom we will execute shortly.  Take your reward, you\'ve done well!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48183,'Oh my... someone became ill from my bread?  How can this be?  Please, I hope my meager earnings are enough to help out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48184,'All our items are carefully inspected and shipped with precision!  If this wasn\'t signed by the king himself you\'d never see a dime.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48185,'Oh... I think I\'m going to be sick.  How could I have cut off someone\'s ear and not have noticed?  Please take this money to a healer and have it reattached.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48186,'','I can\'t be held responsible every time someone falls off their mount.  I don\'t know how you got the official seal on this, but take your payment and don\'t question my horses again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48187,'This is a dangerous game you play... take your gold for now, but know that I\'m watching you.\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48188,'I could swear I just paid a fine like this...\n','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48189,'Her bag of gold should be in the mail!  It\'s insulting she sends someone to collect from me while I\'m working.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48190,'I\'ve heard of mice trapped in ale bottles before, but never in bread.  P-p-please take everything and don\'t speak of this to anyone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48191,'I don\'t usually give refunds for haircuts, but I must admit I did a terrible job on yours.  My apologies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48192,'','I must have been pretty tipsy the night I promised you a pony.  Take your money and no hard feelings, okay?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48193,'We usually handle this all through the mail...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48194,'Wow.  I didn\'t even realize we sold this kind of thing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48195,'Alright everyone. Follow me and uhh... just act natural.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48196,'There is nothing of interest on the table.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48197,'Several piles of supplies rest on the table.  You decide to start with the worg hides.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48198,'You see the stack of worg hides that you collected earlier.  These will be used for the bulk of your costume.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48199,'Looking over, you see the obsidian-flecked mud that you collected from the lava beds.  This will be used to color your disguise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48200,'Finally, you see some thread, which will be used to hold the disguise together.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48201,'You have gathered your supplies.  Bring them to Thelaron Direneedle to assemble.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48202,'Take one hide.','Take one hide.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48203,'Take two hides.','Take two hides.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48204,'Take three hides.','Take three hides.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48205,'Take four hides.','Take four hides.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48206,'Take one handful of mud.','Take one handful of mud.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48207,'Take two handfuls of mud.','Take two handfuls of mud.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48208,'Take three handfuls of mud.','Take three handfuls of mud.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48209,'Take four handfuls of mud.','Take four handfuls of mud.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48210,'Take one spool of thread.','Take one spool of thread.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48211,'Take two spools of thread.','Take two spools of thread.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48212,'Take three spools of thread.','Take three spools of thread.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48213,'Take four spools of thread.','Take four spools of thread.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48214,'Investigate the hides.','Investigate the hides.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48215,'So you caught a thief.  Enjoy your finder\'s fee!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48216,'It appears as if that gold we recovered from the dead rogue was yours.  You certainly are lucky...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48217,'I couldn\'t have miscalculated your interest... because we don\'t give any!  I\'d rather pay than be subjected to the trials, so take my personal cash.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48218,'An account of all the fractions of copper we round off... brilliant.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48219,'','They had what on them?  Tell the tailor my ceremonial robes had better be perfect with everything she\'s charging me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48220,'','I can\'t believe you sell those here, of all places.  I\'ll swing by the cook later to pick them up.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48221,'I really need to stop gambling.  Tell them no more cards for me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48222,'I really need to stop gambling.  Tell them no more cards for me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48223,'I know I worked a hundred and sixty eight hours last week... but if the paperwork says I didn\'t clock in, maybe you\'re right.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48224,'','Thanks so much!  I\'m glad I could extend the warranty on my cast iron pots for another month.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48225,'','My... brother died?  I can\'t believe I never even met him.  Take this money and give him a good funeral.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48226,'','My... sister died?  I can\'t believe I never even met her.  Take this money and give him a good funeral.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48227,'','My... uncle died?  I can\'t believe I never even met him.  Take this money and give him a good funeral.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48228,'','My... aunt died?  I can\'t believe I never even met her.  Take this money and give him a good funeral.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48229,'I heard of what you did in Orsis.  I will be honored to fight along your side.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48230,'The $r that rescued Prince Nadun is the only $r that I\'ll ever take orders from.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48231,'It\'s about time we started doing something.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48232,'I will defend Ramkahen with my bare hands if I have to!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48233,'We will defend our lands!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48234,'If the rumors about you are true, stranger, I will gladly join you in the fight against the Neferset!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48235,'There\'s not nearly enough hide here to make a proper disguise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48236,'Alright, this is far too much mud.  Your disguise will be too dark and gloppy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48237,'You\'ve brought me way too much worg-hide, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48238,'We\'re going to need more mud to properly color your disguise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48239,'I\'ve got the proper amounts of mud and hide, but not enough thread to hold it together.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48240,'Ach!  Everything else looks good, but there\'s too much thread!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48241,'This... this is perfect!  This disguise shall be my masterpiece!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48242,'Ye\'ll not find a finer craftsman than I in all the Dark Irons!$b$bHammerin\', smithin\', and diggin\' be damned!  A needle and a thimble\'s all the metal I need!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(48243,'I brought you some hides, mud, and thread.','I brought you some hides, mud, and thread.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(48244,'What have ye brought me?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(48245,'Somebody shut this little girl up!','',0,0,0,0,0,0,5,0,1,11024,0,0,26124),
(48246,'Do you want a dolly, little girl? Would that make it better?','',0,0,0,0,0,0,6,0,1,11024,0,0,26124),
(48247,'KILL ME OR KILL THE GIRL!','',0,0,0,0,0,0,5,0,1,11024,0,0,26124),
(48248,'Is this Stillwater\'s plan? To torture me before he kills me?','',0,0,0,0,0,0,6,0,1,11024,0,0,26124),
(48249,'WHAT ARE YOU WAITING FOR STILLWATER! KILL ME! DO IT NOW!','',0,0,0,0,0,0,22,0,1,11024,0,0,26124),
(48250,'How much longer are you going to cry?','',0,0,0,0,0,0,6,0,1,11024,0,0,26124),
(48251,'Curse the Dragonmaw!$B$BThey kill our birds, attack our families, take our land. Even as the world crashes down around us, still they assault our homes.$B$BIf your Alliance wants the help of the Wildhammer, there\'s only one way to win us over: Stop. The. Dragonmaw.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48252,'<Blundy peers up from his cups.>$B$BAye, that\'s right. The High Shaman is out in the field, fighting to retake the Thundermar Wreckage. I\'m whatcha call the \"Low Shaman.\"$B$BWhile he\'s away, he left me here, to take care of all of Thundermar\'s Shamanin\'in... nin.','',273,1,0,0,0,0,0,0,1,0,0,0,26124),
(48253,'','Thundermar is the last holdout of the Wildhammer. My brother\'s trying to keep up the fight while our little town fills up with refugees.',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(48254,'Urrrrrrgh...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48255,'HLORRHGH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48256,'','Open wide, Mr. Tauren! Here comes the hippogryph into the roost!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48257,'YOU THERE! Yes, you, $c! I have been captured against my will and imprisoned illegaly by Warden Stillwater. Get me out of this cage and I will explain everything.','',0,0,0,0,0,0,25,0,1,11024,0,0,26124),
(48258,'','Kitty... KITTY! I\'M SO SORRY, KITTY! COME BACK! DON\'T LEAVE ME LIKE THIS!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48259,'Twilight essence begins to bubble forth from the corpse of the whelp....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48260,'%s is revived by the commingled essences!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48261,'%s\'s corpse disintegrates into frothing twilight essence.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48262,'I\'m from the Highbank advance unit, trying to win over the Wildhammer here at Thundermar.$B$BI think I can help them out, but can you believe that they don\'t have a single tri-cyclic alternating current re-polarization device? Not a one!$B$BHow do they even get by?','',1,274,0,0,0,0,0,0,1,0,0,0,26124),
(48263,'We\'re done practicing so soon?  Very well, I\'ll see you later.','',0,0,0,0,0,0,0,0,1,11099,0,0,26124),
(48264,'Greetings, $c! I\'m from the Highbank advance scouting unit, trying to win over the Wildhammer here at Thundermar.$B$BTheir gryphon riders are having a tough time bringing down Dragonmaw drake riders. I\'ve got a plan for a contraption that will help, but I\'m going to need supplies. Lots of supplies.$B$BCan you help?','',1,25,0,0,0,0,0,0,1,0,0,0,26124),
(48265,'Here I am, $g sir:madam; $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48266,'I don\'t need your pity, $C.','I don\'t need your pity, $C.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48267,'The dreadlord who commands this undead army is called Tichondrius.  He controls a powerful warlock artifact called the Skull of Gul\'dan.  It is responsible for corrupting these forests.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48268,'We could go on fighting like this forever.  What is it you truly want?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48269,'Taste my axe, coward!','Taste my axe, coward!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48270,'Get your filthy hands off of me, $R.','Get your filthy hands off of me, $R.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48271,'','Please don\'t break... please don\'t break....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48272,'','Crap!  That was my last lock pick!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48273,'','Here comes the guard, $n!  Take him out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48274,'','Well done!  I was about to jump in!  But it looked like you had it under control.',0,0,0,0,0,0,0,0,1,11034,0,0,26124),
(48275,'','That cat-creature chained back there looks like he wants to talk.  Maybe he can help us... but be careful.',0,0,0,0,0,0,0,0,1,11034,0,0,26124),
(48276,'A shadowy figure appears in the ship\'s cabin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48277,'Take a look at this holotable. I want to show you a bit about Operation: Gnomeregan.','',0,0,0,0,0,0,25,0,1,11832,0,0,26124),
(48278,'I\'m going to need to research what we\'ve learned here, $n.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48279,'There\'s no telling how we might use the power these mechanisms create.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48280,'Meet me in Ramkahen and I\'ll tell you what our next step should be.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48281,'See ya around, kid.','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(48282,'','Feed, children!  Take your fill from their meaty husks!',0,0,0,0,0,0,0,0,1,0,0,20207,26124),
(48283,'TWINKLES! TWINKLES! NOOOOO!!','',0,0,0,0,0,0,0,0,1,0,15131,0,26124),
(48284,'I won\'t let them get away with this, Twinkles. They will pay! They will all pay!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48285,'You\'re not leaving me to rot in this place! Take me with you!','',0,0,0,0,0,0,0,0,1,11051,0,0,26124),
(48286,'Beatdown received.  Optimizing strategy for next battle...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48287,'Pummeling received.  Adjusting battle parameters...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48288,'Battle result: embarrassing failure.  Incorporating new methods into battle regimen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48289,'Defeated.  Shame level: High.  Adjusting strategy for future battles.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48290,'Greetings, friend of the Brotherhood.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48291,'I\'m here to help you with your combat training, golem.','I\'m here to help you with your combat training, golem.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48292,'See now the product of your meddling!','',0,0,0,0,0,0,0,0,1,11041,0,0,26124),
(48293,'BURN IN MY HATRED!','',0,0,0,0,0,0,0,0,1,11041,0,0,26124),
(48294,'Self-training complete!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48295,'Training level sufficient.  Returning to guard duty.  Thank you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48296,'You find a few salvageable parts in the ruined creature\'s hull.  It looks like you will only be able to salvage one part.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48297,'Salvage the Flux Exhaust Sieve.','Salvage the Flux Exhaust Sieve.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48298,'Salvage the Obsidian Piston.','Salvage the Obsidian Piston.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48299,'Salvage the Thorium Gearshaft.','Salvage the Thorium Gearshaft.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48300,'Salvage the Stone Power Core.  These are rare!','Salvage the Stone Power Core.  These are rare!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48301,'Eh, wot?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(48302,'Pack yer bags, $n! We\'re off to the Twilight Highlands. You ready?','',4,6,0,0,0,0,0,0,1,0,0,0,26124),
(48303,'I\'m ready, Flintlocke. Take me to the Highlands!','I\'m ready, Flintlocke. Take me to the Highlands!',4,6,0,0,0,0,0,0,1,0,0,0,26124),
(48304,'Thank the stars!  Now turn around so I can put them on.','Thank the stars!  Now turn around so I can put them on.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48305,'I\'ve been placed in command of Alliance joint operations in the Twilight Highlands.$B$BThe independant Wildhammer clans still dot this countryside. If we can unite them under the Alliance banner, nothing can stop us! But enemies close in on all sides. I hope you\'re ready for a fight, $c.','',1,274,0,0,0,0,0,0,1,0,0,0,26124),
(48306,'Lydon!? Alive?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48307,'Now I know where your allegiances lie, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48308,'And you, Jenny? I thought we had a connection. You\'ve broken my heart for the last time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48309,'Warden Stillwater, you are deranged and a threat to our way of life. By authority of the Dark Lady herself, I hereby impose upon you the harshest penalty allowed under Forsaken law - true death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48310,'That goes for all of you traitorous scum who supported this fool!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48311,'KNEEL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48312,'I AM A THREAT? I AM DERANGED?! ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48313,'What I\'ve created here is an evolution! THIS is how the Forsaken will thrive, not through some magical winged fairy sprinkling happy dust on corpses!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48314,'Kill them all! They will serve as subjects for our next study!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48315,'I\'m back, Sis!','I\'m back, Sis!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48316,'Thank heavens!  It\'s so good to see...  Why are your pants on backwards?','Thank heavens!  It\'s so good to see...  Why are your pants on backwards?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48317,'Woohoo!$b$bWe\'ll have to do that again sometime!$b$bWell, I\'m off to do some more research. I\'ll catch up to you when I\'m ready.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48318,'Nope.. not yet.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48319,'','You stupid mongrels!  I ought to whip you all to death!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48320,'','You wolves are worthless!  Worthless!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48321,'','You stinking curs had better enjoy the taste of my whip!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48322,'','I\'ll make you bleed, you weak little sacks of bones!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48323,'','Quit your whining, you worthless wolves!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48324,'You think that you\'ve won? THINK AGAIN! Stand before my new form and tremble!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48325,'','Ahh!  I... I can\'t move!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48326,'','No... no... get them away from me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48327,'','NO!  AHHHHHHH!!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48328,'OW, MON!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48329,'HEX YOU!  HEX YOU!  HEX YOU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48330,'OWIE!  GORLOP CAN\'T MOVE!  GORLOP GONNA FALL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48331,'HEY! You dere! You want treasure? Augh know where to gets golds and shinies. Follow Augh to Lost City of Tol\'vir? Augh promise no steal.','',1,1,0,0,3,0,0,0,1,0,0,0,26124),
(48332,'Augh sounds like a name I can trust. Lead the way!','Augh sounds like a name I can trust. Lead the way!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48333,'Polishing Vigorously','Polishing Vigorously',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48334,'This lava hot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48335,'Gorlop wonder if other lava hot?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48336,'I bring you back from the brink of death, $Gbrother:sister;. We are in need of your aid!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48337,'I have done some pretty twisted things, but what you\'re doing here is crossing a threshold even for me.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(48338,'You know, you can probably just free them. I won\'t tell anyone.','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(48339,'CUT IT OUT! You\'re getting blood all over my robe.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48340,'You have issues.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48341,'Disgusting. They\'re of no use to us without their heads.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(48342,'This is your idea of doing the right thing???','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(48343,'%s throws up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48344,'Please stop.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48345,'I want to go home.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48346,'You are a very bad person.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48347,'I am thankful for all you\'ve done, $n.  But I am afraid I will be even further in your debt before this ordeal is through.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48348,'...','...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48349,'Now I can return with dignity!','Now I can return with dignity!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48350,'Our enemies can bury entire cities under the sand.  Our traditions have not prepared us for such a war.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48351,'In time, we will rebuild this place and restore it to its former glory - minus all of the annoying humans.','',1,273,0,0,0,0,0,0,1,0,0,0,26124),
(48352,'Now that we have captured this wretched isle, we need to do some work to get it into shape.  Can you help us out $n?','Now that we have captured this wretched isle, we need to do some work to get it into shape.  Can you help us out $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48353,'I am not a fan of that d-block place everyone keeps talking about it.  We do have some tasks that must be completed before we can use it though.','I am not a fan of that d-block place everyone keeps talking about it.  We do have some tasks that must be completed before we can use it though.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48354,'I assume you have heard of the hole by now, $r.  If not, you are going to know a whole lot about it soon.','I assume you have heard of the hole by now, $r.  If not, you are going to know a whole lot about it soon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48355,'Welcome to Tol Barad, $c.  Time\'s a wastin\' so let\'s get to work.','Welcome to Tol Barad, $c.  Time\'s a wastin\' so let\'s get to work.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48356,'Foul demon! What have you done with my brother?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48357,'At the cost of your soul? You are no brother of mine! Begone from this place, and never set foot in our lands again!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(48358,'','No! Illidan, how could you?',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(48359,'It is I, Malfurion. This is what I\'ve become.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48360,'The leader of the undead has been destroyed, and the forests will heal in time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48361,'So be it... brother.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48362,'What? Who are... you?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48363,'We do not choose to go to war, $n.  War comes to us.$B$BWe must do what we must to be ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48364,'It sees us...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48365,'Tear its eyes out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48366,'You will tell no one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48367,'Intruder...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48368,'Quit lookin\' at me, ya big purple eye-face! Ah, blast it all, $n. ','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(48369,'It ain\'t easy gettin\' a contract with the Blackrock orcs.  I mean, come on!  The Blackrock orcs!  These guys have been through more battles than Aggramar, AND they\'re sittin\' on a mountain made of dark iron to boot!  Cha-ching!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48370,'Your death will tell a different story!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48371,'You\'re accused of being a demon in disguise, Navarax... if that\'s even your real name!','You\'re accused of being a demon in disguise, Navarax... if that\'s even your real name!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48372,'I\'d like to challenge your magma lord to a fight.','I\'d like to challenge your magma lord to a fight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48373,'Yes, my child?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48374,'It\'s a good thing I showed up when I did!$b$bI\'m guessing we haven\'t seen the last of that Schnottz fellow.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48375,'Alright boys, we got a challenger!  Time to show the general what our little captive can do!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(48376,'Nooo!  My baby...','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(48377,'NOBUNDO! NOOO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48379,'You will die this day, Earthwarder! $n will see to it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48380,'Aggra... this can\'t be... this has gone too far...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48381,'Do something, you useless $r. My allies are giving their lives for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48382,'Muln falls! And the Earthen Ring dies with him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48383,'You\'ve failed us all, $n. Deathwing has won. The world is doomed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48384,'Wake up! We need you, $n!','Wake up! We need you, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48385,'The magma lord is a little... indisposed right now.  Stick around, this won\'t take more than a minute or two.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48386,'We\'re surrounded! Its defenses are too great. $n! Wake up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48387,'Ah ha ha!  Well done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48388,'Listen to the Orc. He has a point.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48389,'You\'re the great champion brought to battle the Aspect of Death?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48390,'You\'re the hero that is supposed to be my undoing?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48391,'You\'re helpless. You can\'t even leave that rock.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48392,'You\'ve failed your race. You\'ve failed all life on Azeroth. Because of you, everyone you\'ve ever known will die... gruesomely and painfully.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48393,'We need to make for the oasis, $n.$b$bYou about ready to go?','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48394,'<The seedling tilts its leaves up towards you, as if looking in your direction.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48395,'Focus, $n.$b$bWe have to get to the Coffer of Promise before Schnottz does!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48396,'Zhis vas clearly an inside job!$b$bNovone is above suspicion!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48397,'Uhhh, I suppose I\'m ready...','Uhhh, I suppose I\'m ready...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48398,'The Sludge Fields - BOSS EMOTE','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48399,'I\'m ready to go, Doctor Jones!','I\'m ready to go, Doctor Jones!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48400,'You can command the lions to move with the Move ability.$B$B|TInterface\\Icons\\misc_arrowleft.blp:64|t','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48401,'Hyenas approach from your left flank.  Engage them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48402,'%s begins to aim a charged shot at $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48403,'Hello!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48404,'Wakey wakey!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48405,'I\'m a tree!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48406,'Welcome, friend, to the Oasis of Vir\'sar!$b$bA paradise on Azeroth!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48407,'Could you spare two of your fine tents, Asaq?','Could you spare two of your fine tents, Asaq?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(48408,'A strange request, $r, but after what you have done for our prince it would be wrong of me to deny you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48409,'They approach from both sides in great numbers now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48410,'%s starts sobbing uncontrollably!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48411,'%s flees in terror!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48412,'%s screams at the top of its lungs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48413,'Follow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48414,'Have I chosen wisely, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48415,'They approach from the right now!  Use your Fierce Roar ability if your lions become overwhelmed!$B$B|TInterface\\Icons\\ability_druid_skinteeth.blp:64|t','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48416,'What does it mean?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48417,'It\'s so intense!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48418,'It burns! IT BURNS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48419,'The colors! Nooooooooooooooo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48420,'It\'s too much!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48421,'Get it away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48422,'Make it stop! MAKE IT STOP!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48423,'AAAAAAAAAAAAHHH!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48424,'Hey, wait a minute...','Hey, wait a minute...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48425,'I don\'t recognize you...','I don\'t recognize you...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48426,'Hmm... are you new around here...?','Hmm... are you new around here...?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48427,'You\'re not one of us, are you...?','You\'re not one of us, are you...?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48428,'Ouch!  What did I do?','Ouch!  What did I do?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48429,'Hey!  Who gave you the cudgel?','Hey!  Who gave you the cudgel?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48430,'It wasn\'t me, I swear!  You can\'t prove anything!','It wasn\'t me, I swear!  You can\'t prove anything!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48431,'Sorry!  Won\'t happen again, sir!','Sorry!  Won\'t happen again, sir!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48432,'You\'ve been spotted!  Club your target to death before you are unmasked!','You\'ve been spotted!  Club your target to death before you are unmasked!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48433,'You\'ve been unmasked!  Get to safety, then put your disguise back on!','You\'ve been unmasked!  Get to safety, then put your disguise back on!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48434,'What do you think you\'re doing, soldier!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48435,'I\'ll slice you in two!  Wait a minute... who are you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48436,'Stop that, I\'m no soldier!  Hmm... are you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48437,'Is that a mask you\'re wearing, soldier?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48438,'Heads up, $n! They\'re here. Dragonmaw ... everywhere!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(48439,'Don\'t forget to put on that disguise!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48440,'What was that? Oh no, the Dragonmaw are here!','',5,0,0,0,0,0,0,0,1,11098,0,0,26124),
(48441,'Fine.  Let\'s see what you and your lions can do.','Fine.  Let\'s see what you and your lions can do.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48442,'Some day I\'ll be able to put my skills at the service of Ramkahen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48443,'You hit rock or me hit you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48444,'You want me hit rock with you head?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48445,'More smash rock!  Rar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48446,'This is it! They\'re making their final assault. There\'s no place to run. We hold Thundermar or die with hammer in hand.$B$BFor the Wildhammer!!','',5,15,0,0,0,0,0,0,1,0,0,0,26124),
(48447,'Slow kobold look tasty!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48448,'Me has whole box of candles!  Maybe give you some if hit rock good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48449,'You want get punched?  You make rock die now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48450,'Me rip slow kobold to pieces!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48451,'You too slow!  Want me get Glubtok?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48452,'Dis look warm!  Me getting sleepy...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48453,'Yes, this is the spot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48454,'Farewell, $n...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48455,'Look at all dem boxes.  What in dis box?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48456,'Hey $n! Over here. We need you!','',3,0,0,0,0,0,3,0,1,0,3980,0,26124),
(48457,'Those of the Explorers\' League and The Reliquary are very much alike: Archaeology is our religion, yet we have both fallen from the pure faith.\n\nOur methods have not differed as much as they pretend. We are but a shadowy reflection of them.\n\nIt would take only a nudge to make them like us. To push them out of the light...','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(48458,'D\'ye hear it, $n? The beating of great leathery wings over the treetops... Narkrall is closing in.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48459,'I\'m ready to fight him!','I\'m ready to fight him!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48460,'Here he comes, $n! Flying in from the west. Get your weapons ready!','',25,0,0,0,0,0,25,0,1,0,0,0,26124),
(48461,'Why stinky candle talk so much?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48462,'TAKE ITS HEAD!','',0,0,0,0,0,0,0,0,1,0,22454,0,26124),
(48463,'You lose!','',0,0,0,0,0,0,0,0,1,0,21445,0,26124),
(48464,'Vengeance will be ours!','',0,0,0,0,0,0,0,0,1,0,21445,0,26124),
(48465,'Death has found you!','',0,0,0,0,0,0,0,0,1,0,22454,0,26124),
(48466,'SUFFER!','',0,0,0,0,0,0,0,0,1,0,22454,0,26124),
(48467,'I suppose my aim\'s a little off today.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48468,'I can\'t... miss.. again...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48469,'Come on... right between the eyes... no.  I suppose not this time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48470,'That\'s not fair... my target... it moved!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48471,'The visions are clouded... like these waters.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48472,'','Perhaps you did not hear me. I said, get me free of these chains!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(48473,'Your disguise has dropped. Be careful!','Your disguise has dropped. Be careful!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48474,'Firelord! I beseech ye... Give me... yer... strength...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48475,'They\'re alive...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48476,'THEY\'RE ALIVE!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48477,'RUN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48478,'NOOOOOOO!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48479,'Intruders?! Burn them, Pyromancer! Show these heathens the power of RAGNAROS\' FLAME!','',36,0,0,3,0,0,0,0,1,0,0,0,26124),
(48480,'Your faithful service to the Firelord has not gone unnoticed, Pyromancer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48481,'Word of your bold attacks upon surface has reached even our master\'s ears; Cho\'gall himself is pleased.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48482,'Let the assault continue. Reduce their capital to cinders! Revel in the sacred flame!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48483,'NOOO! Curse you, mortal! YOU STRUGGLE IN VAIN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48484,'You will perish in the Firelord\'s Flame!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48485,'The will o\' the Firelord be done, Grand Ambassador.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48486,'There are rumors o\' heroes fightin\' back the elementals, but we\'ll conjure more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48487,'In an hour\'s time, their precious city will be nothin\' but ASH.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48488,'You are close enough to reach Magmaw\'s head!','You are close enough to reach Magmaw\'s head!',0,0,0,0,0,0,0,0,1,0,8717,8717,26124),
(48489,'It looks like the cultists had their eye on the druids!$B$BYou can see Wildheart Point through the swirling portal. Stepping through it will take you on a one-way trip back to the camp.$B$BOnce your business here is finished, this would be a good way to make a quick exit.','It looks like the cultists had their eye on the druids!$B$BYou can see Wildheart Point through the swirling portal. Stepping through it will take you on a one-way trip back to the camp.$B$BOnce your business here is finished, this would be a good way to make a quick exit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48490,'Step through the portal and return to Wildheart Point.','Step through the portal and return to Wildheart Point.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48491,'The Blight Slimes are beginning to react negatively towards your prodding.','The Blight Slimes are beginning to react negatively towards your prodding.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(48492,'The Blight Slimes are getting ANGRY!','The Blight Slimes are getting ANGRY!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(48493,'The Blight Slimes want your blood!','The Blight Slimes want your blood!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(48494,'I can feel my branches surging with life. I cannot wait to give it back to the land.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48495,'No longer are you bound here, great Princess. Have you not heard?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48496,'The vaults of the Titans grow weak as chaos flourishes. This prison can no longer contain you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48497,'Very well. With your permission, Princess.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48498,'','Watch your tongues, servant of Deathwing. Do you think me a fool?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48499,'','Terramok is my home, not my prison. The remains of my beloved make it so.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48500,'','But do not despair, ogre. I will continue to aid you and your... cult. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48501,'','It pleases me, after all, to cause such strife in the world above... to shake, to shatter, to swallow and crush...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48502,'','...but here I shall remain, forever.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48503,'','Go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48504,'Use the Keys to the Hot Rod |TInterface\\Icons\\inv_misc_key_12.blp:32|t to get into your car. Pick up your friends, Izzy, Ace, and Gobber.','Use the Keys to the Hot Rod |TInterface\\Icons\\inv_misc_key_12.blp:32|t to get into your car. Pick up your friends, Izzy, Ace, and Gobber.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48505,'Thanks, boss!','Thanks, boss!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48506,'We\'d gone an hour without an injury report. That\'s a new record!','We\'d gone an hour without an injury report. That\'s a new record!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48507,'I hope this isn\'t coming out of my pocket!','I hope this isn\'t coming out of my pocket!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48508,'This healing stuff sure does beat having to pay for medical insurance!','This healing stuff sure does beat having to pay for medical insurance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48509,'Working conditions are horrible under Trade Prince Gallywix. I hope you become the new Trade $g Prince : Princess;!','Working conditions are horrible under Trade Prince Gallywix. I hope you become the new Trade $g Prince : Princess;!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48510,'Normally, I\'d just shrug off an explosion like that, but I think someone got the nitro and kaja\'mite mixture wrong.','Normally, I\'d just shrug off an explosion like that, but I think someone got the nitro and kaja\'mite mixture wrong.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48511,'It\'s that crazy Hobart Grapplehammer\'s fault! Someone ought to fire that guy and promote his assistant!','It\'s that crazy Hobart Grapplehammer\'s fault! Someone ought to fire that guy and promote his assistant!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48512,'You know I\'d gladly blow myself up for the company with you in charge, boss!','You know I\'d gladly blow myself up for the company with you in charge, boss!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48513,'','Our enemies will perish!',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(48514,'','I am renewed!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(48515,'','Lordaeron is ours!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48516,'','Such glorious, beautiful power!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48517,'','Victory to the Forsaken!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48518,'What is it, underling?  Can\'t you see I\'m busy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48519,'I can\'t stand being cooped up in here with all these warlocks.  This is Xi\'lun\'s job, not mine!$b$bI can\'t wait for this battle to start.  I need to be outside, with my dragons.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48520,'Well look who it is!  The cudgel-bearer $g himself: herself;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48521,'','You\'re truly a force to be reckoned with. The beast is done with. Let\'s get out of here. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48522,'Howdy, partner! Miss Darla built me to make sure all you lil\' pilgrims stay nice an\' safe!$B$BBe sure to listen to Deputy Clunky\'s down-home safety tips! Yeehaw!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48523,'Me da best bodyguard!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(48524,'No, me!','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(48525,'Me got a big board for hit things!','',0,0,0,0,0,0,36,0,1,0,0,0,26124),
(48526,'Mine gots a nail in it!','',0,0,0,0,0,0,36,0,1,0,0,0,26124),
(48527,'Mine gots a bigger nail!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(48528,'Mine gots a RUSTY nail!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(48529,'Dats dangerous.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48530,'Only for da bad guys.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48531,'But I\'m da best at watchin\' da door.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48532,'No I am!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(48534,'The land suffers... and RAGES!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48535,'We are nearly prepared to start this battle, brothers.  Thorg\'izog, what is the matter?  Why are you covering your butt like that?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48536,'WHAT?  No reason... it\'s just... something is very wrong with my stomach.  I think it\'s something I ate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48537,'Can you still lead your troops?  Do you need to promote one of your sergeants?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(48538,'Timan fell from the Pillar of Ash.  Othana was eaten by wolves.  Gorlop fell in lava.  And most of my sergeants were killed in a freak cudgelling accident.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48539,'I see.  Well, do the best you can.  And Neeralak, why are you all black and smoky?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48540,'Those imps you had delivered... they woke up and started shooting fireballs at everybody!  It was chaos!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48541,'Delivered?  Woke up?  What are you even talking about?  Were you attacked by flamekin?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48542,'Imps, flamekin, whatever!  I don\'t know warlock crap.  Demons all look the same to me!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(48543,'Besides, I\'ve been busy dealing with other issues.  Dozens of my dragons died when those two enemies swept through the front lines.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48544,'You\'re both failures.  But it doesn\'t matter: with a pit lord on our side, we won\'t need foot soldiers OR dragons.  Behold!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48545,'One, two, three, four, I declare a thumb war!','',0,0,0,0,0,0,50,8,1,0,0,0,26124),
(48546,'And now to quickly use the Orb of Domination, before the pit lord turns on us.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48547,'It... it\'s not doing anything!  The pit lord is loose!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48548,'The pit lord\'s loose!  We\'re doomed!  Retreat!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(48549,'Quickly, everyone run toward those dragons!  All troops, towards the dragons!  The dragons will save us!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(48550,'I never called any dragons...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48551,'Alsudar the Bastion and the other warrior trainers may be found overlooking Farstriders\' Square, from near the foundry.','Alsudar the Bastion and the other warrior trainers may be found overlooking Farstriders\' Square, from near the foundry.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48552,'Ah, our esteemed guests have arrived!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48553,'Cut, bruised, and covered with blood - looks like we have a new winner!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(48554,'Ladies and gentlemen, these deliverers of dismemberment have come out VICTORIOUS! Bets on the next round start now! Let\'s get this money flowin\'.','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(48555,'Painful but beautiful! Gurgthock gives you what you want! The best display of carnage in Azeroth. Show me some love, people!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(48556,'OOOOOOOH! Check that mess out! Amazing win! Way to stick it through him!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(48557,'Bah, couldn\'t you have dragged it out a bit! People don\'t pay me when you make it look that easy! Add some theatrics to it, will ya?!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(48558,'WHOA! Call in the cleaning crew. They made a mess of that challenger!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(48559,'DESTROYED! DOMINATED! DECIMATED! DELICIOUSLY DISMEMBERED! You do it just like I like it!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(48560,'I felt that one from the stands! I think we have a clear winner here boys, and the bodyparts littering the arena agree','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(48561,'Doubtless they are incensed by my meddling with their fragile little homes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48562,'See to it that they are made to feel MOST welcome, hmmm? After all, their bones will be lying here for a long, LONG time...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48563,'Would I be here if this were not serious?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(48564,'','I have heard you before.  You are here to save your world; to learn from ours.  Greatmother Geyah has charged me with instructing you, and as such, you will listen to me, Go\'el.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48565,'I have told you to call me Thrall.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48566,'','Yes I know, Go\'el.  Thrall is the leader of the Horde, but you are not here in that capacity.  Look at you: At what you are wearing...',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48567,'','You say you have come to seek knowledge and understanding, but you are dressed for battle.  That is why I question you and your willingness to do what must be done.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48568,'My clothing?!  Is that what this has come to now?  We debate the merits of my clothing?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48569,'The clothing is merely a manifestation of a larger problem.  I\'ve no doubt that you are here to learn, but you must commit yourself both in spirit and in form.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48570,'','The dwarf speaks the truth.  If you wish to commune with the elements you must do so from the heart.  ',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48571,'','Your heart, your love for your land and your people is what has led you here.  It was neither your armor nor your weapons.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48572,'Thrall, you must fully devote yourself to the cause.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48573,'Aggra shoots Gavan a disapproving look.','Aggra shoots Gavan a disapproving look.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48574,'','Go\'el.  You cannot continue to ride the line between Warchief and Shaman.  The time will come when you must commit to one side fully.  That time is fast approaching.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48575,'I hear what both of you are saying and am grateful for the counsel.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48576,'If I am to understand all that is transpiring, if I am to make a difference, then my devotion must be absolute.  I must submit.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48577,'This... is only... the beginning, mortals! You will... ALL DIE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48578,'Lots to be done around here, $r.  Are you ready to help?','Lots to be done around here, $r.  Are you ready to help?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48579,'Welcome to baradin base camp.  I know it does not look like much now, but with a little hard work we can whip this place into shape.','Welcome to baradin base camp.  I know it does not look like much now, but with a little hard work we can whip this place into shape.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48580,'There\'s no denying it - they really put that dog down! So much for our former champion!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(48581,'Seems like we never run out of things to do around here.  New orders arrive every day at 3am, it\'s really strange.','Seems like we never run out of things to do around here.  New orders arrive every day at 3am, it\'s really strange.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48582,'It looks like we have one more challenger yet to face though, so let\'s get those wagers in!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(48583,'The Horde have been relentless out here.  Feels like we are fighting two battles at one time.','The Horde have been relentless out here.  Feels like we are fighting two battles at one time.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48584,'You all love to hate him, and he\'s glad to shower his hate right back down on ya. LETS... GET... BLOODY!!!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(48585,'Enjoy my fine wares.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48586,'Thank you, $n. My torment is now at an end.','Thank you, $n. My torment is now at an end.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48587,'The curse ends!','The curse ends!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48588,'Finally, the agony ceases....','Finally, the agony ceases....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48589,'Friends. The Wildhammer way of life is threatened. Our enemies are too numerous for us to remain isolated from one another. We must unite!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48590,'The Conclave of Wind is nearing full strength!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48591,'Your bodies are all magnificent! If you\'d be willing to take a small whiff of this chloroform, I promise that you will all wake up 10 times stronger and 100 times more... unified in purpose.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48592,'No? Well... my offer stands. Just come by anytime and I\'ll be glad to give you the makeover you\'ve always dreamed of.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48593,'%s begins to gather strength from the remaining Wind Lords!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48594,'Gentlemen, please -','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48595,'Ach! This\'ll be harder than I thought.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48596,'%s begins to gather strength from the remaining Wind Lord!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48597,'Oh, that\'s just like a Firebeard, can\'t see anything past yer own fat nose. We were up to arses and elbows in Dragonmaw. But did you send a single bird to help? NO!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48598,'I don\'t have to take this. I\'ll be part of no Alliance that has a Firebeard innit. That\'s me final word!','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(48599,'Unity? Now? The Thundermars weren\'t exactly unitin\' when them Twilight Shaman tore open our stronghold on the shore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48600,'Thundermar, if we weren\'t on holy ground I\'d pop you one so hard yer shoes would be the only thing left standin\'!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48601,'Oh... OH! YES! Orkus has regained his senses! The foul human mage must have cursed Orkus\' mind. Quickly we must get to shore! Kasha is hurt!','',0,0,0,0,0,0,0,0,1,11188,0,0,26124),
(48602,'Kasha! Come to me! I am fine!','',0,0,0,0,0,0,0,0,1,11188,0,0,26124),
(48603,'KASHA! NO!!','',0,0,0,0,0,0,0,0,1,11188,0,0,26124),
(48604,'I will not survive!$B$B*GULP*$B$BHELP ME!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48605,'Your feet are touching the ground, Orkus. This is shallow water. Just stand up and walk to shore.','Your feet are touching the ground, Orkus. This is shallow water. Just stand up and walk to shore.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48606,'Explain to Orkus that he is standing in shallow water.|TInterface\\GossipFrame\\GOSSIPGOSSIPICON.blp:32|t','',0,0,0,0,0,0,0,0,1,11188,0,0,26124),
(48607,'Since the fall of Grim Batol, we Wildhammers have never truly been united. Out here in the Highlands, forgotten by the rest of the world, the different clans have all gone their separate ways.$B$BTo join them all back together isn\'t going to be easy. ','',1,274,0,0,0,0,0,0,1,0,0,0,26124),
(48608,'Yes $n, I heard the whole miserable thing from out here.$B$BI was hoping my old Wildhammer brothers could work things out among themselves, but it doesn\'t look like it.$B$BYou and I are going to have to get creative.  ','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48609,'Come! Walk with me, $n.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48610,'What a beautiful land this is, wouldn\'t you say?','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48611,'It becomes so easy to take it all for granted when danger surrounds us at every turn.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48612,'When it becomes difficult to tell friend from foe...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48613,'But that will all change one day, $n. And when it does, those with vision will be prepared.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48614,'Uldum is full of treasures, my friend.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48615,'Some are easy for even simple men to discern, while others require wisdom to see.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48616,'Lira sent me to watch your backs. If Obsidia is in here, I\'ll keep her busy while you finish her off.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48617,'I can see that Uldum will one day transform from a dangerous wilderness to a tourist magnet!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48618,'Haaaaaalp!','',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(48619,'People will come from all over Azeroth to marvel at her wonders.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48620,'The Glopgut ogres stormed Thundermar while Colin was here at the summit. They kidnapped Fanny and ran for the hills!','',0,0,0,0,0,0,5,7,1,0,0,0,26124),
(48621,'I plan on creating a wonder of my own for them to behold...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48622,'Colin is massing the Thundermars for a full-on assault of Glopgut\'s Hollow. ','',0,0,0,0,0,0,15,7,1,0,0,0,26124),
(48623,'Here, what\'s this?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48624,'|cFFFFFFFFI had just finished making use of the facilities on the docks when...|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48625,'Ugh, the lok\'tar must have been cooking up a turd - which would explain the smell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48626,'$B$B|cFFFFFFFFAs I emerged from the outhouse, I saw them! It should be noted that Orkus prefers silence when he is doing his duty.|r$B','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48627,'By Hellscream\'s axe!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48628,'It\'s broken.','It\'s broken.',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(48629,'It\'s not broken!','It\'s not broken!',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(48630,'Why\'s it shooting steam out of the side there, then?','Why\'s it shooting steam out of the side there, then?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(48631,'That\'s the...pressure release valve.','That\'s the...pressure release valve.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48632,'In the middle of the pipe?','In the middle of the pipe?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(48633,'Er...backup release valve?','Er...backup release valve?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(48634,'We should tell the Admiral.','We should tell the Admiral.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48635,'Oy, \'Linda, where are we meetin\' up with this Ivar Bloodfang fella? An\' what in Bronzebeard\'s name is that terrible smell?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48636,'You tell him.','You tell him.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48637,'No way!  He gives me the creeps!','No way!  He gives me the creeps!',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(48638,'I know!  The way he looks at you with those hungry eyes.  I\'m afraid to even turn my back!','I know!  The way he looks at you with those hungry eyes.  I\'m afraid to even turn my back!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48639,'','They are massing at Purgation Isle, just west of us here, off the coast. We are to meet them there, general.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48640,'','As for the smell... *Balinda sniffs at the air* I think it\'s coming from over there...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48641,'Look there, \'Linda! What in the...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48642,'%s roars and regains control with a burst of will!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48643,'You face Kingslayer Orkus now, dwarf!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48644,'KASHA! Your master needs you!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(48645,'ENOUGH TOYIN\' AROUND!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48646,'Let\'s get outta here, \'Linda. We dun wanna draw any unwanted attention!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48647,'','Aye, general!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48648,'The sights, the sounds, the smells...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48649,'And I invite you to take part in its creation.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48650,'Together, we will make history!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48651,'Soon, our sideshow will be the talk of Azeroth!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48652,'People will come from far and wide to witness the fruits of our labor, $n.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48653,'Return to Dreadmaul Rock, or you will be dropped!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48654,'I will accompany you, Sullah.','I will accompany you, Sullah.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48655,'Come, friend.$b$bWalk with me a while. There is something I want to show you.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48656,'The Blackrock forces are panicking!  Strike at them now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48657,'Rummaging','Rummaging',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48658,'Meanwhile, atop Dreadmaul Rock...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48659,'Completion Event Forthcoming','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48660,'','Suck it down, orc!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48661,'','NOBODY steps on MY town, orc!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48662,'','Is that all you\'ve got!?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48663,'','You want the Fanny? You can\'t HANDLE the Fanny!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48664,'','Oh, you ain\'t so much once yer off yer dragon, are ya?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48665,'','C\'mere! I\'mma give you a pounding, orc!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48666,'','That\'s right, orc. I\'mma beat your tattoos clean off!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48667,'','I will shut you down, orc. I will put you in the dirt!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48668,'Shroud effect expiring!$b$bFind Cover!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48669,'$n has brought you mudsnout blossom, Kasha. Eat it and you will be healed.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48670,'%s feeds Kasha the mudsnout blossoms.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48671,'TO PURGATION ISLE, KASHA! RIDE LIKE THUNDER!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48672,'These brutes think to raid MY town when my back is turned!? They\'re going to get a taste of Wildhammer justice they will!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(48673,'I\'ve got a ride to Irontree Clearing waiting for me on behalf of Fez Hobnob.','I\'ve got a ride to Irontree Clearing waiting for me on behalf of Fez Hobnob.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48674,'','If we don\'t increase production as much as possible, the Horde might lose this war. If the Horde loses the war, we\'re out on our butts at best and dead at worst.$B$BI hate to break it to you, but the pretty things you might have heard at Whisperwind Grove won\'t save us... but hard work might.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48675,'|cFFFFFFFF$n, Orkus and Kasha flew off to Purgation Isle...|r','|cFFFFFFFF$n, Orkus and Kasha flew off to Purgation Isle...|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48676,'BEWARE!$b$bMyzerian can see through your disguise!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48677,'Time to do what I do best... Ruuuuuuuuuuuuuunnn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48678,'Sabotaging','Sabotaging',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48679,'Wow! Where am I?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48680,'That\'s enough! Time to act like a goblin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48681,'You don\'t have to tell me that twice!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48682,'I got it! I got it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48683,'Deep breaths... deep breaths!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48684,'I\'m okay!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48685,'Pull it together!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48686,'That felt kinda good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48687,'Will you accompany Orkus to Purgation Isle?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(48688,'I will not leave Kasha\'s side.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(48689,'I am ready for Purgation Isle.','I am ready for Purgation Isle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48690,'I am here to bear witness to the memory of my master, and the truth of the past.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48691,'What is going on in here?!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48692,'The Archdruid... how in the world...?','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(48693,'I... I must tell the others. You should find Huntress Selura right away.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48694,'The enemy approaches.  Use the Move ability to move the Ramkahen Champions to the southern ramp.$B$B|TInterface\\Icons\\misc_arrowleft.blp:64|t','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48695,'Use your archers to support your infantry.  A few volleys of flaming arrows will take down most groups.$B$B|TInterface\\Icons\\ability_searingarrow.blp:64|t','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48696,'I\'ve been spotted!','I\'ve been spotted!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48697,'Wretched $r!','Wretched $r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48698,'This place reeks of evil. It must be purged!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48699,'Use the Sun\'s Radiance ability if you get overwhelmed!  It will heal your units and deal terrible damage to the opponent.$B$B|TInterface\\Icons\\spell_holy_divineprovidence.blp:64|t','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48700,'The Denmother will have your head!','The Denmother will have your head!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48701,'Leave these forests!','Leave these forests!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48702,'Worgen and dwarves working together... What has this world come to?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(48703,'I\'ll tear you to shreds!','I\'ll tear you to shreds!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48704,'Grrrr...','Grrrr...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48705,'I am sorry that I called you puny, $n. When we first met I thought you just another one of Darthalia\'s pawns.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(48706,'$n, you and I are friends.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48707,'KROSHIUS CRUSH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48708,'Garrosh Hellscream: great warchief or greatest warchief?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(48709,'Don\'t get me wrong, $n, I like Thrall. He was a strong leader, but I don\'t think he was cut out to lead the Horde. Not in a time of war!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48710,'Did I ever tell you about the time I met Varok Saurfang? I asked him to sign my massive pectoral muscles. He backhanded me instead, which is why I sometimes forget things now. It was totally worth it.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48711,'Varian Wrynn... I saw him fight once at Dire Maul. He killed five feral scar yetis with his bare hands. Pretty good for a human, no?','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(48712,'I wasn\'t there, but I heard that Sylvanas died in Silverpine and that her precious val\'kyr resurrected her at the cost of their own lives. Know anything about it?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(48713,'If Ivar Bloodfang is here, where is Darius Crowley?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(48714,'I liked the worgen better when they were a disorganized mess that you\'d run into in small packs. This new Gilnean worgen alliance is much more difficult to deal with.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48715,'$n, just between you and me, I never saw the fall of the Lich King. And... well... I\'ve never been to Ulduar. I... well... I am a dungeon explorer. Yes. I prefer exploring dungeons with allies. The pay is excellent and the risk is low.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48716,'Hillsbrad has changed. Back in my day Hillsbrad was a place of constant battle. The humans and dwarves of Southshore would constantly attack the Horde at Tarren Mill. There were days when you could look out past the intersection at Darrow Hill and see a thousand people battling. Glory days, $n - they\'ll pass you by.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48717,'I found Kasha in Icecrown. She was injured and dying. I managed to carry her back to the Shadow Vault where the death knights helped nurse her back to health. We are now the best of friends.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48718,'I have heard tale of the Maelstrom itself opening up, threatening to devour the world. Could you imagine such a thing?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48719,'If we stop these dwarves and worgen we will be celebrated as great heroes of the Horde!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48720,'If you\'ve been wrasslin\' with oil, be sure to avoid all sources of sparks or open flame, such as candles, lighters, mages, Kester\'s shop, and Deputy Clunky!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48721,'Always wear head protection while on the job! You never know when Miss Darla might have to smack you in the face!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48722,'Deputy Clunky wants all his buckaroos to stay safe, and have a good ol\' fun time, assumin\' you meet your contract-stipulated servitude quota! Gosh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48723,'When you\'re doggone tired, it\'s mighty easy to slip up on the job, pardner! Be sure to get at least two hours\' rest between shifts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48724,'Oil leak! OIL LEAK! Someone\'s done flipped the switch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48725,'None pass!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48726,'Thank you for saving me! But don\'t tell Ferli, ok? I said I busted out on my own!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48727,'I have a ride to Talonbranch Glade courtesy of James Hallow.','I have a ride to Talonbranch Glade courtesy of James Hallow.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48728,'Keep your voice low, and your scent downwind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48729,'','A few of us here have lived in this land since the Scythe of Elune first passed through it. Most suffered through the fall of Gilneas.$B$BWe have settled in this forest to learn the ways of nature and uphold its balance. In this cursed land, our cursed people have found a new way of life.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48730,'If I had my way, you would be long dead. Your kind disgusts me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48731,'I\'m trying to convince Godfrey to just kill all of you to end your misery, but he keeps telling me no. More pain and suffering for the lot of you, then!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48732,'Bastard.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48733,'Better to rot in this cell than live as a dishonorable traitor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48734,'Brothers and sisters of the Horde, Orgimmar is under attack!  Take up your arms and defend our capital!  If you are unable to wage war against the intruders, then help place barricades to fortify our city!  LOK\'TAR OGAR!','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(48735,'','Woo!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48736,'','$n? What are you doing here? And is that Keegan Firebeard behind you?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(48737,'','Took yer sweet time, didn\'tcha?',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48738,'','Aye, they was getting\' a wee handsy, so I took care of it. C\'mon then, I\'m done here.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48739,'Aye! We\'re here to rescue you!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48740,'The ogres - ya kilt \'em!','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(48741,'Did you see that, $n? What a woman!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(48742,'I won\'t let those damned orcs invade Redridge again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48743,'This all feels like a long shot.  We\'ve got a lot riding on this plan.  Redridge\'s freedom, for one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48744,'STOP! GET DOWN, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48745,'CAREFUL! Vanndar, Balinda and Bloodfang are right there also.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48746,'Ye\'ve made yer way to Chiselgrip, $g lad: lass;.  Best make yerself useful.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48747,'Look there, near the map table! The Stormpike Battle Master holds the Alliance battle plans!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48748,'You gotta be friendly with the Bilgewater Cartel goblins before I\'ll teach you how to ride.','You gotta be friendly with the Bilgewater Cartel goblins before I\'ll teach you how to ride, babe.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48749,'You gotta be exalted with the Bilgewater Cartel goblins before I\'ll teach you how to ride.','You gotta be exalted with the Bilgewater Cartel goblins before I\'ll teach you how to ride, babe.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48750,'You ready to ride?','You ready to ride, babe?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48751,'Your Blackrock Disguise has fallen off!','Your Blackrock Disguise has fallen off!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(48752,' I... I have a plan of my own.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48753,'I will kill the guard at the table and then I will draw the attention of the trio.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48754,'While I have them distracted you get the plans from the guard\'s corpse. I will call Kasha to pick you up as soon as I see you get the plans.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48755,'Do not worry about Orkus, $n. I... I will be fine.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48756,'Stone troggs... the vermin of the deeps.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48757,'Tell me when you are ready and we will go!|TInterface\\GossipFrame\\GOSSIPGOSSIPICON.blp:32|t','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48758,'Are you ready? You will have to act quickly, $n. I do not know how long I can hold them all off for! Get the plans and get out!','',6,1,5,0,0,0,0,0,1,0,0,0,26124),
(48759,'I\'m ready, Orkus. Let\'s do this!','I\'m ready, Orkus. Let\'s do this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48760,'I wish I could make you a deal, partner - I really do - but you\'ll need to be friendly with the Bilgewater Cartel, first.','I wish I could make you a deal, partner - I really do - but you\'ll need to be friendly with the Bilgewater Cartel, first.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48761,'I lost my Blackrock Disguise, Colonel.  May I have another?','I lost my Blackrock Disguise, Colonel.  May I have another?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48762,'I wish I could make you a deal, partner - I really do - but you\'ll need to be exalted with the Bilgewater Cartel, first.','I wish I could make you a deal, partner - I really do - but you\'ll need to be exalted with the Bilgewater Cartel, first.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48763,'Yo! I\'m Kall Worthaton, Bilgewater Trikes.$B$BGo ahead, look over the lot. Pick out the trike that you REALLY want!$B$BA trike that\'s a blast to ride... a trike that\'s dangerous and death-defying... a trike you can be PROUD of!$B$BYou let me know when you see it, and we\'ll make a deal.','Yo! I\'m Kall Worthaton, Bilgewater Trikes.$B$BGo ahead, look over the lot. Pick out the trike that you REALLY want!$B$BA trike that\'s a blast to ride... a trike that\'s dangerous and death-defying... a trike you can be PROUD of!$B$BYou let me know when you see it, and we\'ll make a deal.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(48764,'CAN YOU SMELL WHAT THE LOK\'TAR IS COOKIN\'?!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(48765,'GET THE PLANS AND GO!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(48766,'The %s flickers warmly, granting a poriton of its power to $n in thanks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48767,'She\'s a real powder-keg that one. She\'d make a fine Firebeard! Y\'think the Thundermars would go for it?','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(48768,'\"Archmage Pratt\"? To fel with formality; my vanity died with the rest of me. \"Charles\" or even a simple \"Chaz\" will do, thank you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48769,'KASHA, GET $P OUT OF HERE!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(48770,'Let\'s keep moving. There\'s a lot at stake here.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48771,'FORGET ABOUT ME, KASHA! GO!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(48772,'K... Kasha... you... came back for me...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48773,'I... I never knew anyone like you. You saved me, $p. More than once. I... I know it\'s selfish, but I have something to ask of you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48774,'Somewhere safe...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48775,'','Be sure to talk to the MacGraffs, inside the sanctuary. They\'ll be orchestratin\' the ceremonies.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48776,'Are you really here to rescue me?  Great, lets go!','Are you really here to rescue me?  Great, lets go!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48777,'I think I can use that horse to make it the rest of the way.  Thanks!','I think I can use that horse to make it the rest of the way.  Thanks!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48778,'You are the best friend that Orkus has ever had, $p. *Orkus coughs*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48779,' Please take care of Kasha. Make sure she finds a cold place to live.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48780,'Flamestar!  I can return these dragons to their kind.  Let me take care of them.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(48781,'As you wish.  Just make sure they don\'t come to no harm.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48782,'Don\'t forget that disguise!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48783,'Your conspirator has informed me of your plan.  I shall see you on the battlefield... painted with the ashes of the elementals.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48784,'Come on boys, let\'s eat!  My favorite soldier brought enough worg for everyone!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(48785,'I guess I\'ll just... leave the sleeping imps right over here?  Are these even... imps?  Gah!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48786,'You know, I\'m going to be using this orb to perform a powerful ritual in just a few minutes.  Don\'t tell anyone this... but I\'ll be summoning a pit lord.  Redridge will bow to the Blackrock!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48787,'Ready when you are, Doctor Jones!','Ready when you are, Doctor Jones!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48788,'There\'s no gettin\' away this time, orc! You\'ve sung your last lok\'tar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48789,'Alright, $n. Follow me!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48790,'The cannon was rigged with an explosive trap!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48791,'My gut\'s telling me....','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48792,'...this way!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48793,'This should just take a moment.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48794,'The Bile-O-Tron signals in the affirmative and shuts down permanently.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48795,'Codes accepted. Activating mechanism.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48796,'Burn in the liquid heat of the Firelands!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48797,'What happened? What have you got in your hands there?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(48798,'%s reads the Alliance battle plan.','',0,0,0,0,0,0,432,0,1,0,0,0,26124),
(48799,'He... He died to get this here?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(48800,'%s lifts Orkus\' lifeless body up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48801,'Do not mourn Orkus. He died with honor... with pride. He died a hero of the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48802,'From Lordaeron to Kalimdor, they will know his name and they will sing songs of glory, praising the fallen champion of the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48803,'Know that what you did will save hundreds, maybe thousands of lives. You are also a true hero of the Horde, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48804,'Well, that went smoothly for a change.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48805,'Too good to be true. I might have known.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48806,'Looks like we do this the hard way. Let\'s go!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48807,'System failure. Internal data corruption detected.$b$bConstructing defense mechanism.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48808,'Constructing defense mechanism.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48809,'Even the skies burn with my fury!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48810,'Dey be on top of de tall building in de southeast end of de valley.','Dey be on top of de tall building in de southeast end of de valley.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(48811,'Inscription','Inscription',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48812,'|TInterface\\Icons\\ability_whirlwind.blp:20|t Foe Reaper 5000 begins to activate |cFFFF0000|Hspell:88481|h[Overdrive]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48813,'You be here ta learn fishin\', mon? Or maybe ta buy some tings for it?','You be here ta learn fishin\', mon? Or maybe ta buy some tings for it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48815,'Take out those crystals, $n! That should shut it down!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48816,'The sun has set on this mortal world, fools. Make peace with your end, for the hour of twilight falls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48817,'Tally ho! The hunt begins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48818,'There was no sport in that kill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48819,'Pathetic.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48820,'Killed by lowly commoners. How droll...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48821,'Leave this accursed place at once!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48822,'%s\'s bindings have been released! Full powers unlocked.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48823,'This death is only a temporary respite from my curse.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48824,'May your soul rest in peace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48825,'I hope your spirit finds solace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48826,'Intruders in the keep! To arms!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48827,'One step closer to victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48828,'The attackers weaken!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48829,'Our vigilance is eternal...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48830,'Even here I find myself beset by fools!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48831,'You shall annoy me no longer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48832,'This childish effort ends now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48833,'My new life was just beginning...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48834,'Ivar\'s pack failed horribly, so now he sends mercenaries. No matter, your journey ends in agony.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48835,'That bitch Sylvanas sent you too, did she? No matter, your journey ends in agony.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48836,'This is the quality of assassin sent to kill me? Laughable.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48837,'Murder never gets old.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48838,'I thank you for the clean death. I would not have done the same...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48839,'Listen!$b$bTaking out those crystals should drain the construct.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48840,'We have to make our way to the coffer without tipping off Schnottz and his boys.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48841,'%s begins channelling power for a massive attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48842,'A Rabid Mastiff growls...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48843,'The Rabid Mastiff slobbers all over the floor...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48844,'Use your Hot Rod |TInterface\\Icons\\inv_misc_key_12.blp:32|t to run over Hired Looters and get their loot.','Use your Hot Rod |TInterface\\Icons\\inv_misc_key_12.blp:32|t to run over Hired Looters and get their Stolen Loot.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48845,'The dog stares blankly at the wall...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48846,'Tear him apart!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48847,'Yeah, get him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48848,'Hah!$b$bYou\'ve really stirred up a sandstorm, $n.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48849,'The Blackrock orcs are my kin.  My father was a Blackrock, as was his father before him.  My mother was a Blackrock.  And I am a Blackrock.$b$bBut before anything else, I am an orc.  And that means honor above all else.$b$bMy Highlord has granted me leave to complete my task here in the Burning Steppes.  And I will not leave until the Blackrock orcs here learn the error of their ways.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48850,'I serve my father and respect his plan... but I also serve my own sense of justice.  I have seen enough treachery from my Blackrock brothers to fill a thousand books.  And now they plan to invade Redridge, for no reason other than blind territorialism.$b$bThe treachery stops here.  It\'s time for the final chapter.  And it\'s not going to be a happy ending.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48851,'I lost my Blackrock Disguise, sir.  May I have another?','I lost my Blackrock Disguise, sir.  May I have another?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48852,'It was all her fault! She told us to steal it!','It was all her fault! She told us to steal it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48853,'My children... what have I done?','My children... what have I done?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48854,'No... I was to live forever... I will still...','No... I was to live forever... I will still...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48855,'It\'s our fault... the destruction is all our fault...','It\'s our fault... the destruction is all our fault...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48856,'The crystal can still be found... if we can just find it again...','The crystal can still be found... if we can just find it again...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48857,'So tired... just want to rest...','So tired... just want to rest...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48858,'The crystal will save us! We can be saved!','The crystal will save us! We can be saved!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48859,'He had it coming.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48860,'Good show!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48861,'','Why\'s the ground shaking, $n?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48862,'What was that thing, $g dude : toots;?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48863,'I was just comin\' to see you. Honest!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48864,'I\'m tryin\' to run a business here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48865,'<Jack grunts something about the hammer being his weapon... you think.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48866,'','Oh no you didn\'t!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48867,'I am freed! Let us slay Hallazeal in Neptulon\'s name, $n. He lurks within the temple.','I am freed! Let us slay Hallazeal in Neptulon\'s name, $n. He lurks within the temple.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48868,'Derak Nightfall, at your service!','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(48869,'I wish to buy from you, Derak.','I wish to buy from you, Derak.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48870,'%s goes into a murderous rage!','%s goes into a murderous rage!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48871,'I had no idea Sullah had so many... acquaintances.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(48872,'See you there, $n!','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(48873,'Hallo, friend!$B$BRussell\'s the name, and music is my business. All the great Wildhammer heroes from ages past are kept alive with song. Through the strings of my lute and the sound of my voice, our warriors gain immortality.$B$BStay a while, and listen!','',2,1,0,0,0,0,0,0,1,0,0,0,26124),
(48874,'Let\'s get started! The first verse is all about dear Fanny, but I just can\'t quite put it together.$B$BWhat rhymes with \"Eyes?\"','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(48875,'Ah, I see what kind of $c you are, $n! Now then, the second verse is all about Fanny and Firebeard getting together.$B$BWhat rhymes with \"Professed?\"','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(48876,'...Hmmm, okay, I think I can make that work. Last verse! A rousing celebration of love calling the Wildhammer to action!$B$BAll I need is a rhyme for \"Unite...\"','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(48877,'[Romantic:] \"Wise.\"','[Romantic:] \"Wise.\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48878,'I need a gryphon, Guthrum.  I\'m headed to Western Plaguelands.  My king needs me!','I need a gryphon, Guthrum.  I\'m headed to Western Plaguelands.  My king needs me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48879,'[Silly:] \"Pint-Sized.\"','[Silly:] \"Pint-Sized.\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48880,'[Bawdy:] \"Thighs!\"','[Bawdy:] \"Thighs!\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48881,'[Romantic:] \"Blessed.\"','[Romantic:] \"Blessed.\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48882,'[Silly:] \"Arrest.\"','[Silly:] \"Arrest.\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48883,'[Bawdy:] \"...Chest?','[Bawdy:] \"...Chest?\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48884,'[Romantic:] \"Alight.\"','[Romantic:] \"Alight.\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48885,'[Silly:] \"Knifefight.\"','[Silly:] \"Knifefight.\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48886,'[Bawdy:] \"Tight!\"','[Bawdy:] \"Tight!\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48887,'Speak your peace, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48888,'I need a bat, Kellen.  I\'m headed to Western Plaguelands.  The Dark Lady needs me!','I need a bat, Kellen.  I\'m headed to Western Plaguelands.  The Dark Lady needs me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48889,'I\'m ready, Russell. Let\'s write a song!','I\'m ready, Russell. Let\'s write a song!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48890,'I need a bat, Timothy.  I\'m headed to Andorhal.  The Dark Lady needs me!','I need a bat, Timothy.  I\'m headed to Andorhal.  The Dark Lady needs me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48891,'I need a gryphon, Bibilfaz.  I\'m headed to Andorhal.  My king needs me!','I need a gryphon, Bibilfaz.  I\'m headed to Andorhal.  My king needs me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48892,'My lute is all tuned up. Are we ready to compose something?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(48893,'|cFFFFFFFFSofera\'s Naze, the first of the four fingers of Hillsbrad.|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48894,'','I wasn\'t expecting anyone down here. Come to keep me company, or just looking for a way out?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48895,'I\'d like to leave this place.','I\'d like to leave this place.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48896,'Relief at last...','Relief at last...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48897,'Thank you...','Thank you...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48898,'Leave now... you do not deserve to suffer the crystal\'s wrath...','Leave now... you do not deserve to suffer the crystal\'s wrath...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48899,'It\'s time to go...','It\'s time to go...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48900,'The crystal has returned. You must leave...','The crystal has returned. You must leave...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48901,'|cFFFFFFFFCorrahn\'s Dagger, the second of the four fingers of Hillsbrad.|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48902,'|cFFFFFFFFThe Headland, the third of the four fingers of Hillsbrad.|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48903,'|cFFFFFFFFGavin\'s Naze, the fourth and final finger of Hillsbrad.|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48904,'|cFFFFFFFFThe Stormpike have enlisted the help of SI:7 operatives. This is their scouting outpost.|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48905,'You\'re dissolving! Find the aid of an Earthen Ring Shaman!','You\'re dissolving! Find the aid of an Earthen Ring Shaman!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(48906,'|cFFFFFFFFThe Stormpike are using this as a forward base camp for their soldiers.|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48907,'|cFFFFFFFFThey train their military here, teaching them new and exciting ways to kill us.|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48908,'|cFFFFFFFFMost well protected of the fingers. Their terrible siege engines are assembled here.|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48909,'|cFFFFFFFFTogether the fingers represent the grasp of Stormpike closing upon us. They must be destroyed.|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48910,'In Thundermar the tales proclaimed','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48911,'Of a beauty destined for fame','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48912,'Soft emerald green eyes framed a countenance, wise','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48913,'The people cried \"Fanny,\" her name.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48914,'Of her suitors she was unimpressed','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48915,'\'Til Mighty Firebeard crossed heart and professed','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48916,'To the heavens above our hero claimed love','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48917,'Of a depth the like few can be blessed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48918,'Now let cheering dispel the twilight','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48919,'And let the Wildhammers unite!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48920,'Answer the call, know that love conquers all','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48921,'And let\'s set these whole Highlands alight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48922,'She came from Thundermar, they say','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48923,'Ballyhoo hip hip hooray!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48924,'Guys sighed and plied eyes on this pint-sized prize','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48925,'\'Twas Fanny fo Fanny hey hey.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48926,'Then Firebeard decreed his plea','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48927,'Ho diddly whoa diddly dee','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48928,'His goal he professed was marital arrest','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48929,'Oh Fanny! No Fanny, don\'t flee!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48930,'Now the Wildhammers are one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48931,'Whoa doggy hot diggity dun','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48932,'Unite and take flight, it\'s a Twilight knifefight','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48933,'For Fanny! For Firebeard! For fun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48934,'In Thundermar the tales proclaimed','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48935,'Of a bold lass destined for fame','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48936,'With emerald green eyes and big man-crushing thighs','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48937,'And \"Fanny,\" a most fitting name.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48938,'Ol\' Firebeard he made her his quest','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48939,'On one knee his love he professed:','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48940,'\"Oh Fanny me Fanny, do marry me can ye?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48941,'I loves ya and I loves yer chest.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48942,'Now let cheering dispel the twilight','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48943,'And let the Wildhammers unite!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48944,'They\'re short an\' they\'re stout, but no man can doubt:','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48945,'Firebeard and his Fanny are tight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48946,'You don\'t understand! I had to study it. I HAD TO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48947,'Forgive... me...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48948,'I thought for sure I was going to be this smelly beast\'s dinner!','I thought for sure I was going to be this smelly beast\'s dinner!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48949,'','Good evening.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48950,'','I hope my people have been welcoming to you. These are burdened times, so I fear much may be competing with their good graces.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48951,'Not at all, priestess. We are very grateful for all that you\'ve offered us here.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48952,'','When we spoke previously, you offered to repay the favor. I may have to act on that sooner than I would have liked.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48953,'','There is trouble at Lor\'danel, a village of ours across the waters from Rut\'theran.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48954,'','If any of your people can be spared, I fear war encroaching upon us in Kalimdor.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48955,'I know the perfect people for such a task. I will send them immediately, priestess.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48956,'Thank you, Genn. I am glad to see such poise and composure from your people. Perhaps your curse does not define you after all.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(48957,'','Priestess Tyrande! We did not expect you. Good evening.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(48958,'','We will take our leave. Again, welcome to all of you.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(48959,'Careful there, $gladdie:lass;. Between the worg down below and the orcs lurking in the pass, a $c could get $ghisself:herself; killed up here.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(48961,'%s binds the $n to his will!','',0,0,0,0,0,0,0,0,1,0,20190,0,26124),
(48962,'','You are mine!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48963,'','The Banshee Queen has plans for you, human.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48964,'','Nowhere to run!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48965,'','Death is only the beginning.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48966,'%s roars furiously!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48967,'You are not of the dark path! You do not belong here, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48968,'The shadows will consume you. You are not prepared to face the void.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48969,'That foul thing got stains all over my new robes!','That foul thing got stains all over my new robes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48970,'Cho\'gall will have your heads! ALL OF THEM!','',0,0,0,0,0,0,0,0,1,0,20186,0,26124),
(48971,'The wyrms will eat well tonight!','',0,0,0,0,0,0,0,0,1,0,20187,0,26124),
(48972,'The burden of the damned falls upon you!','',0,0,0,0,0,0,0,0,1,0,20188,0,26124),
(48973,'I\'m... so... dizzy. ','I\'m... so... dizzy. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48974,'Thanks fer savin\' me! When you passed out, I thought we were done fer!','Thanks fer savin\' me! When you passed out, I thought we were done fer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48975,'Call in a Banshee with the Banshee Mirror!','Call in a Banshee with the Banshee Mirror!',0,0,0,0,0,0,0,0,1,11331,0,0,26124),
(48976,'When I said we should strike at the heart of the beast, going through it\'s stomach wasn\'t what I had in mind...','When I said we should strike at the heart of the beast, going through it\'s stomach wasn\'t what I had in mind...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48977,'The power of the elements is strong here. Little wonder this is where they chose to summon a servant of the old gods.','The power of the elements is strong here. Little wonder this is where they chose to summon a servant of the old gods.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48978,'I had a terrible vision - the sky was blotted out and there was dirt everywhere. ...I thought I\'d gone back to Deepholm.','I had a terrible vision - the sky was blotted out and there was dirt everywhere. ...I thought I\'d gone back to Deepholm.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48979,'It\'s about time we returned to the Highlands! \"Twilight\" be damned.','It\'s about time we returned to the Highlands! \"Twilight\" be damned.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48980,'I think I saw something like this on the Exodar once...','I think I saw something like this on the Exodar once...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48981,'Many confuse the Earthen Ring with the Cenarion Circle. ...I TOLD Thrall we should rename ourselves the \"Earthen Square\".','Many confuse the Earthen Ring with the Cenarion Circle. ...I TOLD Thrall we should rename ourselves the \"Earthen Square\".',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48982,'|TInterface\\Icons\\spell_fire_twilightflamebreath.blp:20|t%s begins to cast |cFFFF0000|Hspell:90949|h[Devouring Flames]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48983,'Shaman and druid ways are very different. When was the last time you saw one of us turn into a wild beast?  ... nevermind.','Shaman and druid ways are very different. When was the last time you saw one of us turn into a wild beast?  ... nevermind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48984,'We command the power of the elements. Storm, Earth and Fire!  I\'d never dress like an oversized chicken and shoot moon beams from the sky. ','We command the power of the elements. Storm, Earth and Fire!  I\'d never dress like an oversized chicken and shoot moon beams from the sky. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48985,'THE MASTER WOULD HAVE YOU SILENT.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48986,'I command the power of the storm. It sounds impressive, but you wake up with static cling every morning.','I command the power of the storm. It sounds impressive, but you wake up with static cling every morning.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48987,'I can\'t wait to smash that old god brain between me fists!','I can\'t wait to smash that old god brain between me fists!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48988,'FEAR NOT ZIN-MALOR. IT WILL NEVER BELONG TO ANOTHER.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48989,'Do ye know how hard it was to find a set of weapons that matched me armor?','Do ye know how hard it was to find a set of weapons that matched me armor?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48990,'Other shaman used to say, \"Only yer offhand should be flaming.\" What were they going on about?','Other sshaman used to say, \"Only yer offhand should be flaming.\" What were they going on about?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48991,'Thanks fer saving me, $gladdie:lassie;, I had a horrible vision. I was trapped in a cave of flame, forced to drop totems and heal irate warriors for years on end without seeing a single piece of shaman gear.','Thanks fer saving me, $gladdie:lassie;, I had a horrible vision. I was trapped in a cave of flame, forced to drop totems and heal irate warriors for years on end without seeing a single piece of shaman gear.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48992,'To restore life is to restore the natural order of the elements.','To restore life is to restore the natural order of the elements.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48993,'Shamanistic healing is a complex art. You can\'t just chain heal all day.','Shamanistic healing is a complex art. You can\'t just chain heal all day.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48994,'Few truly understand the shamanistic connection to the earth. It binds wounds, protects us from harm.','Few truly understand the shamanistic connection to the earth. It binds wounds, protects us from harm.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48995,'I fail to understand why they banned totemic cleansing. No one was ever in range, anyways.','I fail to understand why they banned totemic cleansing. No one was ever in range, anyways.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48996,'','Alright den... you just take de bits here, any bits, it don\' matter, livin\' or stone or what...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48997,'I need a flight to Dustwallow Marsh.','I need a flight to Dustwallow Marsh.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48998,'','An\' if you cross ya eyes, an\' hold ya thumbs toward de sky, an\' press REAL hard...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(48999,'','...de E\'ko sometime come out! Just like dat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49000,'Even though these presents are empty, they help remind me of old friends and better times.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(49001,'Iso\'rath\'s stomach begins to churn as the brain is attacked!','Iso\'rath\'s stomach begins to churn as the brain is attacked!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49002,'HEY! What the heck, guy?!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49003,'Of all the slimy, inconsiderate, bullheaded...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49004,'HAH! Are ye lost little $g boy:girl;?','HAH! Are ye lost little $g boy:girl;?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49005,'Yer time is up, $g lad:lass;! The Stormpike are takin\' Hillsbrad!','Yer time is up, $g lad:lass;! The Stormpike are takin\' Hillsbrad!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49006,'What\'s this then?','What\'s this then?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49007,'OY! GET A ROPE!','OY! GET A ROPE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49008,'You\'ve stumbled upon the wrong camp!','You\'ve stumbled upon the wrong camp!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49009,'High alert, soldiers! Reports are comin\' in of some enemy activity near Sofera\'s Naze!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49010,'How\'s it lookin\' over here? Any activity?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(49011,'Keep yer cool, soldiers. We\'ll be on the move soon.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(49012,'','You\'re the most handsome boyfriend a girl could hope for. Knock \'em dead, honey!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49013,'Look at you! I\'m the luckiest boyfriend on the island!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49014,'|TINTERFACE\\ICONS\\Spell_Frost_WindWalkOn.blp:20|t%s begins to cast |cFFFF0000|Hspell:87770|h[Wind Burst]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49015,'','You better get upstairs pronto, boss. Trade Prince Gallywix is waiting for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49016,'','$n, you have to hurry and break your moolah out of the bank!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49017,'Boss, tell Sassy that I\'ll get her more Kaja\'Cola just as soon as production resumes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49018,'','He\'ll get me more later? How are we supposed to get you promoted to Trade $g Prince : Princess; without our number one product on the shelves?!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49019,'','Ooh, I think you\'re gonna like this, boss!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49020,'','There they are! Okay, you three make sure that you help $g him : her; out today. $G He\'s : She\'s; got a lot of stuff to take care of before the party!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49021,'','Ace, Izzy, Gobber, you three make sure you tag along with $n and help $g him : her; take care of those deadbeats!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49022,'Make sure you pull plenty of moolah out of the bank. I don\'t want you buying any of that cheap clothing you usually like to wear. This party\'s important!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49023,'','Make sure you pull plenty of moolah out of the bank. I don\'t want you buying any of that cheap clothing you usually like to wear. This party\'s important!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49024,'You people cool your heels! $n is here. $G He\'s : She\'s; gonna be the next Trade $G Prince : Princess;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49025,'You gotta hurry, kid. We gotta get you into the game. But first, we gotta get the parts for that shredder!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49026,'Get into that shredder and win the game. The Bilgewater Cartel\'s counting on you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49027,'You got the juice, kid. That\'s for sure! Too bad that dragon had to come and ruin everything. No matter. You made us proud. Now get back to headquarters.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49028,'All you gotta do is let me teach you how to do a Steady Shot and then use it on these training dummies right here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49029,'All you gotta do is learn how to cast Frost Nova. Then, head over to the training dummies that Bamm is shooting at and let \'er rip.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49030,'','All you gotta do is learn Shadow Word: Pain and use it on some of the training dummies around here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49031,'','All you gotta do is let me teach you how to do an Eviscerate. Then, head over to one of those training dummies that Bamm is shooting at and attack it with a Sinister Strike. Once you\'ve done that, finish it off with the Eviscerate.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49032,'All you gotta do is let me teach you how to perform a Primal Strike and then use it on these training dummies that Bamm is shooting at.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49033,'All you gotta do is learn how to cast Corruption, and then go use it on these training dummies that Bamm is shooting at. Corrupt \'em!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49034,'Insert coins to let Warrior-Matic NX-01 teach you how to Charge. Then use it on the training dummies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49035,'','I\'ll set the cap to auto-activate once you\'re at the villa. Just make sure you avoid those pigs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49036,'I need a flight to Chillwind Camp, please.','I need a flight to Chillwind Camp, please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49037,'I need a flight to the Bulwark, please.','I need a flight to the Bulwark, please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49038,'I can\'t believe the nerve of those trolls. Rebelling after all that I\'ve done for them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49039,'Ya got some nerve, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49040,'Ya bring down da big badda dragon an\' destroy da island!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49041,'I not gonna take it anymore, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49042,'Kezan for da trolls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49043,'Outa my way, mon. I\'m off ta join da pirates!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49044,'Maybe I take dem bombs from ya an\' we see who go boom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49045,'Dis here be our kaja\'mite! We mine it up with our own sweat an\' blood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49046,'Lil\' green goblin gonna bleed for all ya done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49047,'Yeah? Whadya want, ya mook? Be on the lookout for that no-good $n!$B$BNow get back to work!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(49048,'','Need a ride, $g sugar: scumbag;?  Hop on.  We\'re headed down to Bogpaddle, and it\'s a one way trip.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(49049,'Alright!  Let\'s head down to the Swamp of Sorrows!','Alright!  Let\'s head down to the Swamp of Sorrows!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49050,'I\'m here to escort a delivery to Kirthaven.','I\'m here to escort a delivery to Kirthaven.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49051,'Keep yer eyes open, $n! That road is crawling with Dragonmaw.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49052,'Woohoo! We got us a convoy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49053,'Mortals that fancy themselves HEROES have entered the Broken Hall. Oh, I do hope this \"raid\" will amuse me more than the last.','',0,0,0,0,0,0,0,0,1,0,23379,0,26124),
(49054,'Hmm... the Omnotron Defense System. Centuries ago these constructs were considered the Dwarves\' greatest technical achievements. With so many counters to each construct\'s attacks, I\'ll have to rectify these designs for them to provide me any entertainment.','',0,0,0,0,0,0,0,0,1,0,23374,0,26124),
(49055,'You would like to move away from that, wouldn\'t you? Too bad.','',0,0,0,0,0,0,0,0,1,0,23375,0,26124),
(49056,'Stupid Dwarves and your fascination with runes! Why would you create something that would help your enemy?','',0,0,0,0,0,0,0,0,1,0,23376,0,26124),
(49057,'Lightning Conductor works much better in a crowd, yes?','',0,0,0,0,0,0,0,0,1,0,23377,0,26124),
(49058,'Were you planning on using Toxitron\'s chemicals to damage the other constructs? Clever plan, let me ruin that for you.','',0,0,0,0,0,0,0,0,1,0,23378,0,26124),
(49059,'I should have known better than to rely on something so stupidly named to entertain me for long.','',0,0,0,0,0,0,0,0,1,0,23373,0,26124),
(49060,'I found this fascinating specimen in the lava underneath this very room. Magmaw should provide an adequate challenge for your pathetic little band.','',0,0,0,0,0,0,0,0,1,0,23367,0,26124),
(49061,'On second thought, what fun is an \"adequate\" challenge?','',0,0,0,0,0,0,0,0,1,0,23369,0,26124),
(49062,'You won? How... disappointing. I could have easily watched you all continue to stand in the fire.','',0,0,0,0,0,0,0,0,1,0,23366,0,26124),
(49063,'Ah, Chimaeron, truly a living testament to my scientific prowess. I reworked and twisted his form countless times over the years, and the final result is truly something to behold.','',0,0,0,0,0,0,0,0,1,0,23362,0,26124),
(49064,'Oh, you were expecting something else to happen just then, weren\'t you? Let\'s see how well YOU adapt after a new set of \"adjustments,\" shall we?','',0,0,0,0,0,0,0,0,1,0,23363,0,26124),
(49065,'Stop fighting yourself this instant, Chimaeron!','',0,0,0,0,0,0,0,0,1,0,23364,0,26124),
(49066,'This fight has gotten a bit stale; allow me to spice things up!','',0,0,0,0,0,0,0,0,1,0,23365,0,26124),
(49067,'Hmm... a shame to lose that experiment.','',0,0,0,0,0,0,0,0,1,0,23361,0,26124),
(49068,'Maloriak, try not to lose to these mortals. Semicompetent help is SO hard to create.','',0,0,0,0,0,0,0,0,1,0,23372,0,26124),
(49069,'Your mixtures are weak, Maloriak! They need a bit more... kick!','',0,0,0,0,0,0,0,0,1,0,23370,0,26124),
(49070,'Congratulations! Allow me to grant you a title befitting the amazing achievement you just performed. Henceforth you shall be known as the \"Slayer of Stupid, Incompetent, and Disappointing Minions.\"','',0,0,0,0,0,0,0,0,1,0,23371,0,26124),
(49071,'','I can\'t stand to watch. So many good memories. So much profit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49072,'Welcome, friend of the Wildhammer!$B$BKirthaven is the spiritual center of our people, the one place where the varied clans can come together in peace.$B$BIt\'s here we honor our dead heroes, before burying them with their gryphons atop Mount Thunderstrike. There they spend eternity at one with the sky.','',2,1,0,0,0,0,0,0,1,0,0,0,26124),
(49073,'You begin to cast |cFFFF0000|Hspell:91317|h[Worshipping]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49074,'Atramedes, are you going deaf as well as blind? Hurry up and kill them all.','',0,0,0,0,0,0,0,0,1,0,23360,0,26124),
(49075,'Atramedes, the heroes are right THERE!','',0,0,0,0,0,0,0,0,1,0,23359,0,26124),
(49076,'These shields are proving quite the nuisance.','',0,0,0,0,0,0,0,0,1,0,23358,0,26124),
(49077,'You should have been disposed of a long time ago.','',0,0,0,0,0,0,0,0,1,0,23357,0,26124),
(49078,'A wedding, eh? If that doesn\'t bring this bunch together, I\'ll eat my hammer!$B$BWe need to make sure this wedding is spectacular, $n, and we\'re going to need your help. There\'s an old Wildhammer saying... let me think... how does it go?','',5,6,0,0,0,0,0,0,1,0,0,0,26124),
(49079,'Perhaps we ought to give the enemy what they\'re after... and spare our people the coming bloodshed.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49080,'If that is all they want then perhaps war can be avoided.  The coming bloodshed could be prevented!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49081,'I must act to protect my people first.  Our enemies buried Orsis in the desert.  How do you fight against that sort of power?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49082,'Your words ring true, brother.... but even a king cannot make this decision alone.  I will put the issue to a High Council vote.','',25,0,0,0,0,0,1,0,1,0,0,0,26124),
(49083,'The wedding\'s a go! I\'m going to need a gift for the happy couple, of course. Something important.$B$BThe future of the Wildhammer really hinges on this one last chance to bring us all together!','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(49084,'Cho\'gall beckons and casts |cFF006EFD|Hspell:91303|h[Conversion]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49085,'I urge you to reconsider, Phaoris. Deathwing would use the scepters\' power to unravel the secrets of Uldum and unleash great destruction.','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(49086,'We fight to the death, Phaoris!  Our race was created to guard this land.  We must not betray that legacy.','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(49087,'I defer to your wisdom, brother.  Let us pray we are quick to come to a decision.  The enemy will not wait.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(49088,'Now that you\'ve helped me to establish my ice cream empire, make sure to enjoy one of my many tasty concoctions!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(49089,'So you have come seeking our aid?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49090,'%s coughs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49091,'I... *cough* I have been alive for a very long time. In that time I have seen and done terrible things.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49092,'Things that still keep me awake at night.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49093,'But these terrible things that I have done and the people that I have harmed - I know them... I face them... and I feel remorse for them.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49094,'But the Forsaken. *cough* What do they feel?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49095,'They ravage the land and destroy everything that they touch. How many lives have been lost to their vile poisons?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49096,'How many innocents have fallen before the Forsaken war machine?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(49097,'Countless... countless lives... *cough*','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(49098,'Yes... I have done terrible things, but nothing could ever be as terrible as lending aid to the Forsaken.','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(49099,'You go back to that spineless orc who would not come see me and you tell him that the Frostwolf clan will not aid the Forsaken. Not now, not ever!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(49100,'BEGONE!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(49101,'Prepare the Micro Mechachicken!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49102,'','You don\'t have to yell, Hobart, I\'m standing right here. Sheesh!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49103,'','There. One Micro Mechachicken. I\'ll never understand how you come up with these names.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49104,'There\'s a great deal that you do not understand, my dear Greely. That is why you are the assistant and I... I am Hobart Grapplehammer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49105,'','Greely sighs and rolls her eyes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49106,'','Yes, Doctor Grapplehammer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49107,'Excellent. Now back away from the Ultra Concave Fissionable Testing Platform. Slowly, if you please.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49108,'Thank you. Now behold as I stabilize the highly unstable miniaturization process.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49109,'','The assistant shakes her head.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49110,'I am going to end the horrible problem of food storage cutting into the profits of the Bilgewater Cartel!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49111,'I\'ll soon be revered as the greatest goblin tinker of all time! Besides, that negligence case involving the creation of the gilgoblins will never stick.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49112,'Flip the switch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49113,'','Greely coughs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49114,'','Um, Hobart, you\'re at the controls.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49115,'Quite right, Greely. You passed today\'s pop quiz.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49116,'I am now flipping the switch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49117,'Greely, can you feel it? My moment of success is at hand!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49118,'Grocery store owners everywhere will owe me a percentage of their profits!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49119,'I\'m flipping the second switch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49120,'Wait... something\'s wrong!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49121,'','Ya think? Hobart, the Micro Mechachicken is destablizing. It\'s expanding!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49122,'I know... I know! Where\'s the override? The override?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49123,'','It\'s the one on the far right! Hurry, Hobart! It\'s going to eggsplode!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49124,'Here goes nothing. I always loved you, Greely!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49125,'Flipping the override switch now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49126,'','WHAT?!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49127,'Are we still alive?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49128,'','We\'re still alive, Doctor Grapplehammer, despite your best efforts.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49129,'Well of course we are, my dear Greely. And look there. The Micro Mechachicken\'s stabilization appears to be a complete success!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49130,'Hobart\'s jaw hits the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49131,'','Is that egg on your face?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49132,'','Now what\'s this about you \'always loved me\', Grapplehammer?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49133,'I haven\'t the foggiest notion what you\'re talking about, Miss Greely.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49134,'','We can both agree on that, doctor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49135,'','Hey. How ya doing, boss? Hobart and I are working on some things that will ensure that you have phenomenal backup products for when the kaja\'mite runs out.$B$BThere\'s only so much of it left down there in the mines, and when it\'s gone, all of the Kaja\'Cola is going to go with it, I\'m afraid.',1,273,0,0,0,0,0,0,1,0,0,0,26124),
(49136,'Good to see you, $n!$B$BI just wanted to make sure that you appreciate all of the products that my genius has brought to the Kajaro Trading Company?$B$BThese include, but are not limited to: Kaja\'Cola, the Poultryizer, Town-In-A-Box, my Ingenious Cap of Mook Foolery, KTC Train-a-Tron Deluxe, the Amazing G-Ray, Never-Deflating Pool Ponies, the Big Ones, Warrior-Matic NX-01, and gilgoblins. No strike that last one. Under advice of counsel, I had nothing to do with them.$B$BAnyway, I\'m working on a few more things here that I think you\'ll find interesting, such as the Micro Mechachicken and a little something I like to call Subject Nine.','',3,1,0,0,0,0,0,0,1,0,0,0,26124),
(49137,'You don\'t look right, buddy. There\'s somethin\' wrong with you.','',1,25,0,0,0,0,0,0,1,0,0,0,26124),
(49138,'Hey, $g man : lady;, are we gonna get through this okay?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(49139,'','It looks like this is the end, but I\'ll be brave if you will, $n.',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(49140,'WATER!','WATER!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49141,'<Gobber acts tough, but you can tell that deep down, he\'s scared.>','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(49142,'Thank the Light! I\'m parched!','Thank the Light! I\'m parched!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49143,'Ah, yer a lifesaver, lad!','Ah, yer a lifesaver, lad!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49144,'I feel like I could drink a lake!','I feel like I could drink a lake!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49145,'Ugh... I don\'t feel so good.','Ugh... I don\'t feel so good.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49146,'So tired...','So tired...',0,0,0,0,0,0,462,0,1,0,0,0,26124),
(49147,'ARGH! THROAT ON FIRE!','ARGH! THROAT ON FIRE!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49148,'Wha.. ungh...','Wha.. ungh...',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(49149,'Hey mon!$b$bDis area been goin\' through lotsa changes.  Tel\'aporta gonna take you somewhere else.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49150,'Take me to the Echo Isles, Tel\'aporta!','Take me to the Echo Isles, Tel\'aporta!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49151,'Gwaaaaaaahhh!!!','',53,0,0,0,0,0,53,0,1,0,0,0,26124),
(49152,'Take me to the Mulgore, Tel\'aporta!','Take me to the Mulgore, Tel\'aporta!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49153,'|TInterface\\Icons\\ability_mage_firestarter.blp:20|tUse |cFFFF0000|Hspell:74040|h[Engulfing Flames]|h|r to destroy the Twilight\'s Hammer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49154,'...','...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49155,'|TInterface\\Icons\\spell_holy_innerfire.blp:20|t Glubtok creates a moving |cFFFF0000|Hspell:91398|h[Fire Wall]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49156,'MEDIC!','MEDIC!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(49157,'I\'m going to the infirmary!','I\'m going to the infirmary!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(49158,'OY! Piss off, eh?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49159,'Dirty, stinkin\' Wildhammer. You know these dwarves only consider you as half a dwarf, right? What does that make you? A gnome?','Dirty, stinkin\' Wildhammer. You know these dwarves only consider you as half a dwarf, right? What does that make you? A gnome?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49160,'What did ye say, Sally?! The only one of us who resembles a gnome is you - after I\'m done cuttin\' you into wee pieces!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(49161,'Come on then, Nancy! Let\'s go!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49162,'I\'m busy, lad. Why don\'t ye go find some Forsaken goo and take a bath, eh?','',1,1,6,0,0,0,0,0,1,0,0,0,26124),
(49163,'I guess it\'s true then. I didn\'t want to believe that you were a yellow-bellied snow licker, but there\'s no doubt about it now.','I guess it\'s true then. I didn\'t want to believe that you were a yellow-bellied snow licker, but there\'s no doubt about it now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49164,'What did ye call me? I\'ll show ye what a \"snow licker\" can do!','',1,1,6,0,0,0,0,0,1,0,0,0,26124),
(49165,'Crudbeard? You are one ugly little girl. I didn\'t even know they let little girls become death knights. Was the Lich King trying to meet his quota when he made you or something? I would have thrown you back.','Crudbeard? You are one ugly little girl. I didn\'t even know they let little girls become death knights. Was the Lich King trying to meet his quota when he made you or something? I would have thrown you back.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49166,'Leave or I\'ll be forced to pound yer face in!','',5,273,0,0,0,0,0,0,1,0,0,0,26124),
(49167,'Oh, I\'m gonna enjoy this more than I probably should.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49168,'When I\'m through with ya, yer head\'s gonna be firmly placed between yer ass cheeks!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(49169,'GAAAH! How you kill croc?!','',53,0,0,0,0,0,53,0,1,0,0,0,26124),
(49170,'Augh smart! Augh already steal treasure while you no looking! ','',53,0,0,0,0,0,1,0,1,0,0,0,26124),
(49171,'Augh da boss! Oh yeah!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(49172,'Who bad?! Augh bad!! Ugn!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(49173,'Augh steal your treasure. Uhn uhn uhnnn!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(49174,'','Yeah? Whadya want?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(49175,'','I don\'t talk to no $g scrub : trash;!',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(49176,'','You\'re not quite in my league, honey.',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(49177,'','I didn\'t talk to you back in school and I\'m sure not going to start now.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(49178,'','That\'s an interesting... \"outfit\" you\'re wearing.',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(49179,'','Yes. I\'d love a refill. Fetch one and be quick about it.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(49180,'','This is the Trade Prince\'s party, sweetie. Invite only!',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(49181,'','$n, right? Word of advice: don\'t let the Trade Prince catch you around here. He knows you\'re after his job.$B$BEveryone knows.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(49182,'','A mook?! I don\'t speak to brutes. How dare you!',14,0,0,0,0,0,0,0,1,0,0,0,26124),
(49183,'','What are we calling you things these days? Brutes? Hobgoblins?$B$BI can\'t keep it straight. Get out of here.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(49184,'','You\'re big and strong. But you need a bath. Go jump in the pool.',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(49185,'','Oh no you did not just talk to me!',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(49186,'','What smells around here? Oh, that\'d be you.$B$BBeat it!',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(49187,'','What\'s your name?$B$BI guess it\'s a good thing you brutes can\'t talk. Otherwise, I\'d have to tell the Trade Prince how you annoyed me.$B$BNow scram!',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(49188,'','Touch me one more time and I\'ll make sure that they send you to the Undermine!',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(49189,'','Oh, you\'re just disgusting! Why is it always the ugly ones that try to pickup on me?!',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(49190,'I got a very bad feeling about this, $n. I think the smart play now is to get yourself off of the island any way that you can.$B$BI\'m going see if I can get into the Trade Prince\'s Town-In-A-Box.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(49191,'Blowin\' em\' to bits, boss!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49192,'I hope you\'re ready! I\'ve souped up this Blood Elf boat with the best Goblin parts money could buy... which wasn\'t much, sadly, but I\'ll take what I can get.','I hope you\'re ready! I\'ve souped up this Blood Elf boat with the best Goblin parts money could buy... which wasn\'t much, sadly, but I\'ll take what I can get.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49193,'The race is about to begin!','The race is about to begin!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49194,'|cFFFF00003...|r','|cFFFF00003...|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49195,'|cFFFF80402...|r','|cFFFF80402...|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49196,'|cFFFFFF001...|r','|cFFFFFF001...|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49197,'|cFF00FF00Go!|r','|cFF00FF00Go!|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49198,'<To your astonishment, the Raptor hatchling is able to communicate with you.>$B$B$G Papa : Mama;...?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49199,'A big day, Firebeard. The Wildhammer united can never be stopped!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49200,'Never doubt it. Here, allow me to give you my wedding gift.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49201,'The only surviving egg of my late gryphon, Sky\'ree.  Honor it and care for it; her child is yours.','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(49202,'I\'ll not hear a word of it. The egg is yours. I want you to see how committed I am to this union.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(49203,'And how committed the Alliance is to the Wildhammer cause!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49204,'Ah, look. Here comes $n, escorting your bride!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(49205,'I hope you\'re right, Kurdran old friend.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(49206,'Kurdran - no, I couldn\'t! Sky\'ree was a legend, I can\'t-','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(49207,'Aye. Thank you, Kurdran.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(49208,'I do.','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(49209,'Ladies and gentledwarves, we gather here in the shadow of Thunderstrike to honor the union of Fanny Thundermar and Keegan Firebeard.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49210,'May their bond be as eternal as the wind, waves, stone and fire. ','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(49211,'Do you, Keegan and Fanny, accept one another into your lives, that two become as one, in union everlasting?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(49212,'Then, by the powers vested in me... the powers vested in me...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49213,'...BY BLOOD AND SHADOW!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(49214,'I shall consume your lifeblood in the name of the master!!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49215,'','I do.',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(49216,'<To your astonishment, the Raptor hatchling is able to communicate with you.>$B$BI hunger... therefore, I am.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49217,'<To your astonishment, the Raptor hatchling is able to communicate with you.>$B$BWhat does \"$c\" mean? Are you the goblin $g patriarch : matriarch;?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49218,'It\'s one of them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49219,'Get him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49220,'<To your astonishment, the Raptor hatchling is able to communicate with you.>$B$BThey call you $n. Is this your unique signifier, or is it an honorary title?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49221,'Stop that thing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49222,'Waaaaahhhhh!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49223,'SAVE THE WEDDING!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49224,'<To your astonishment, the Raptor hatchling is able to communicate with you.>$B$BGreetings. I recently emerged from an egg. You?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49225,'<To your astonishment, the Raptor hatchling is able to communicate with you.>$B$BIs it true that you cook your meat? Curious.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49226,'<To your astonishment, the Raptor hatchling is able to communicate with you.>$B$BYou lack a helmet. Does this diminish your intellectual capacities?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49227,'<To your astonishment, the Raptor hatchling is able to communicate with you.>$B$BThe ends of your fingers are dull and round. Is this why you carry around other implements for use in combat?$B$BHow interesting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49228,'The races are coming, $g lad : lass;! We\'re working hard on getting the track setup and I\'ve been busy signing some worthy competitors.$B$BTell your friends!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(49229,'Serpents of the depths!  Come and aid your master!','',0,0,0,0,0,0,0,0,1,11372,0,0,26124),
(49230,'Come, my children!  Defend me!','',0,0,0,0,0,0,0,0,1,11372,0,0,26124),
(49231,'$n?! What are you still doing here?$B$BYou have to get off of the island, or better yet, into one of my Town-In-A-Boxes!$B$BDon\'t wait too long, my $g boy : girl;! The Cataclysm is upon us!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(49232,'We have to get off the island! Quick, Greely, grab the schematics! And my toothbrush!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49233,'Get everything packed! We have to find a way off of Kezan! We\'ll jump into the closest Town-In-A-Box! They\'ll load it on the Trade Prince\'s yacht.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49234,'Whatever you do, don\'t let me forget my Ingenious Cap of Mook Foolery!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49235,'Deathwing?! The Cataclysm?! We\'re doomed!! We have to get off of Kezan before Mount Kajaro blows for good!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49236,'How are we going to get Subject Nine through customs? I know! Pack her into the Lab-In-A-Box!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49237,'The sky is falling!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49238,'A party? Can you believe it? A party and the whole island is about to explode?! What are they thinking!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49239,'There\'s just not enough time to pack all of this stuff up! Grab only the important stuff! Where\'d I put my Blastproof Underwater G-Ray Goggles?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49240,'','Don\'t worry about Hobart, boss. He\'s just having a bit of a breakdown right now.$B$BThe Cataclysm couldn\'t have come at a worse time for him. He was so close to being done with the Micro Mechachicken.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(49241,'','I\'m on it, doctor. Schematics, check. Toothbrush, check.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49242,'','I will, I will. But, Hobart, you have to calm down. Your blood pressure! You\'re turning deep green!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49243,'','Hmm, I know I saw it around here somewhere, but are you sure? That thing turns the user into a brute instead of projecting an image of one about fifty percent of the time. And then they explode!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49244,'','You\'re going to blow if you don\'t calm down! Don\'t you think it was a little bit convenient? The dragon flying over right as the winning field goal for the footbomb finals was kicked into Mount Kajaro?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49245,'','Right away. I\'ll flag the Lab-In-A-Box for deployment in Azshara.  I\'ll pack her little cushion in with her, too. She\'s so cute!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49246,'','Technically speaking, that\'s not true, doctor. The rocks that fly out of a volcano like Mount Kajaro are called ejecta. It\'s not the sky. It\'s molten rock, or tephra. It cools as it descends, becoming lava bombs. Very appropriate, wouldn\'t you say?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49247,'','Yeah, a real party that I was actually invited to. Why does something always happen and I never get to go? I could use a drink.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49248,'','Um, Hobart, you\'re wearing them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49249,'Ye can defuse it, right Magruder?!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(49250,'Holy... What in the hell is this?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49251,'Are you kidding me? Look at all this crap! There\'s like a million wires. I\'m a three wire kind of guy...\n','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(49252,'RUN!!!!!!\n','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49253,'My father has trained me since I was a wee lad to respect the elements. Earth and fire, wind and sea - they possess great power, $c.$B$B<Grundy gets a gleam in his eye.>$B$BMore than you realize.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(49254,'I\'ll keep my eyes open, Grundy. Let the wedding commence!','I\'ll keep my eyes open, Grundy. Let the wedding commence!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49255,'LOK\'TAR! HILLSBRAD IS OURS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49256,'FOOD FOR GROLNAR!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49257,'On the matter of war against the rebel tribe of Neferset... has each member of the High Council reached a decision?','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(49258,'','Watch and weep.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49259,'','You see? Nothing beats the crushing power of my hammers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49260,'Yes, your majesty.  The Sword of Ramkahen casts its vote in favor of war.  Your armies are standing at the ready.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49261,' The Voice of Ramkahen casts its vote in favor of war as well.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49262,'The Faith of Ramkahen... abstains.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49263,'For hours, I agonized over the visions the waters of the river showed me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49264,'In my visions, negotiations with the enemy brought our people a fleeting peace... followed by terrible betrayal and destruction.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49265,'Only one vision offered a faint glimmer of hope.  And in that vision... the High Council did not make this decision for you, Phaoris.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49266,'Here she is, $n... the coffer of promise!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49267,'Vell done, Doctah Jones!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49268,'Not only haf you led me right to zhe coffer, but you haf removed its protektions!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49269,'Such a pity...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(49270,'I vould offer you a prestigious position in my organization if I didn\'t haf to kill you.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(49271,'But first!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49272,'You shall vitness zhe destruction of zhat vhich you hold so dear!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(49273,'The Coffer!? You wouldn\'t...','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49274,'Oh, don\'t be such a fool! I never vanted your silly chest for myself.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(49275,'Zhat artifact is zhe only zhink preventink Deazhvink from activatink zhe reorigination mechanism!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49276,'Vonce his lust for vengeance is sated, I vill be free to rule Azerozh as I see fit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49277,'Hmm? Vhat vas zhat?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49278,'No matter! In a moment, nozhink vill remain of any of zhis!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49279,'Close your eyes, kid. This ain\'t gunna be pretty...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(49280,'Now! Destroy zhe coffer! And zhem vhizh it!','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(49281,'And in the vision... the High Council did not make this decision for you, Phaoris.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49282,'But war, waged by a leader reluctantly following protocol, brought an even swifter demise to our nation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49283,'I am a psylosopher. What that means is that I am smarter than you. Now move along before I diagnose you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(49284,'My liege, a skirmish along the Neferset border just occurred.  A patrol led by your brother was involved...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49285,'He\'s been... mortally wounded, sir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49286,'We attack Neferset city at first light.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49287,'Commander.  Move all forward regiments westward.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(49288,'Nadun...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49289,'Och!$b$b\'Bout time ye showed up.$b$bI been expectin\' ye fer days now.$b$bLeavin\' an ol\' dwarf ta swelter... I trained junior better than that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49290,'The bombs are set! Run to the balcony and jump to escape!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49291,'3...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49292,'2...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49293,'1...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49294,'BOOM!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49295,'The Shadow Grave is this way.  Follow me, $n.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49296,'This way!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49297,'Now, where could those supplies be?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49298,'Maybe they\'re over here?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49299,'Hmm...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49300,'No, not over here.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49301,'Hey, give me a hand, $n!  I can\'t find the supplies that Mordo needed!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49302,'Let\'s see now... where could they be...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49303,'Nice work!  You\'ve found them.  Let\'s bring these back to Mordo.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49304,'I saw someone up there whose jaw fell off.  I wonder if Mordo can fix him up?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49305,'Greetings, $n.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49306,'','We\'re through, $n! I\'m with Chip now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49307,'We\'re through, $n! I\'m with Candy now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49308,'Why flail around when all you need...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49309,'...is just one CHOP!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49310,'Invaders, you shall go no further!','',0,0,0,0,0,0,0,0,1,0,21886,0,26124),
(49311,'Insolent rat!','',0,0,0,0,0,0,0,0,1,0,21889,0,26124),
(49312,'Siamat must not be freed! Turn back before it is too late!','',0,0,0,0,0,0,0,0,1,0,21885,0,26124),
(49313,'Murkash!','',0,0,0,0,0,0,0,0,1,0,21888,0,26124),
(49314,'Tread Lightly.','',0,0,0,0,0,0,0,0,1,0,21887,0,26124),
(49315,'A stray jolt from the Foe Reaper has disrupted the foundry controls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49316,'The molten slag begins to bubble furiously!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49317,'Help! I\'m trapped in here!','',0,0,0,0,0,0,0,0,1,0,20833,0,26124),
(49318,'Hey! Over here!','',0,0,0,0,0,0,0,0,1,0,20834,0,26124),
(49319,'A little help?','',0,0,0,0,0,0,0,0,1,0,20835,0,26124),
(49320,'Poor little fella.','',0,0,0,0,0,0,0,0,1,0,20836,0,26124),
(49321,'Uh oh! He looks pretty mad now!','',0,0,0,0,0,0,0,0,1,0,20837,0,26124),
(49322,'Great job guys! The key should be in his guts somewhere. Just, uh, fish around in there \'till you find it.','',0,0,0,0,0,0,0,0,1,0,20838,0,26124),
(49323,'Thanks for freeing me! I\'m off to have more amazing adventures.','',0,0,0,0,0,0,0,0,1,0,20839,0,26124),
(49324,'Hit the icicle to break free!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49325,'It has now been six weeks since your release. Are you ready to have the shackles removed?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49326,'I need time to think. It... it\'s too soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49327,'Six weeks? I spent six years in Durnholde! You cannot possibly expect me to just throw aside something that has been a part of my life for so long!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49328,'What I want to know is this: WHY DO YOU CARE IF I HAVE A BALL AND CHAIN SHACKLED TO MY ANKLE!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49329,'Can\'t you just see me for me, doc? Why does it always have to be about Teddy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49330,'NO, DAMN IT! For the hundredth time, NO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49331,'You\'ll be free to take it off when I die.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49332,'You know, when I was first captured I hated Teddy. He dug into my skin and prevented me from moving around freely. But let me tell you something, doc; after six years with the guy I can honestly say that I have feelings for him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49333,'I\'m with Drull, doc. Laverne and I are happy together. Why try and separate us?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49334,'','Get away from me, you abomination!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49335,'','The undead are a taint upon Azeroth!  Every one of you creatures deserves to be destroyed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49336,'And we don\'t appreciate you refering to our friends as a \'ball and chain,\' doc.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49337,'','No.  You\'re lying!  My father will protect me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49338,'I\'d go back if I could. I had a life in Durnholde. Towards the end there I was beaten maybe once a week at MOST.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49339,'I\'m not an abomination, I\'m simply undead.  I just want to speak with you.','I\'m not an abomination, I\'m simply undead.  I just want to speak with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49340,'Lilian, do you realize that you are undead yourself?','Lilian, do you realize that you are undead yourself?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49341,'Frankly, I\'m getting a little tired of these therapy sessions. We\'re fine! Just let us go.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49342,'My official diagnosis is that you are both idiots! IDIOTS I SAY!','',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(49343,'Stand back, monster.  You want to fight?  Because I\'ll fight you.$b$bI\'ll fight any one of you creatures!  Do you hear me?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49344,'Oh really?$b$bFine.  I don\'t want to join you and your Forsaken.  Maybe I\'ll start my own Forsaken!  Maybe I\'ll invent Forsaken with elbows!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49345,'Who are you calling a monster? You\'re the monster! I\'m just a man who died.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49346,'I\'m not here to fight.  I\'ve only been asked to speak with you.','I\'m not here to fight.  I\'ve only been asked to speak with you.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49347,'You are free to do whatever you like.','You are free to do whatever you like.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49348,'What... what\'s going on?  Who are you?  What happened to me?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49349,'I... died?$b$bYes, you\'re right.  I died.  It was an orc... he cut off my hands, and left me to die.$b$b<Valdred looks down at his hands.>$b$bThese aren\'t my hands!  THESE AREN\'T MY HANDS!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49350,'<Valdred looks back down at his hands.>$b$bI suppose this is my fate then.  Hah!  Part of an undead army.  Somehow I never considered that I might end up fighting for the Forsaken.$b$b<He looks back up at you.>$b$bWhat do I do now?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49351,'I see.  Well then, let\'s get to work, $n!  The Dark Lady needs us, right?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49352,'Don\'t you remember?  You died.','Don\'t you remember?  You died.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49353,'Calm down, Valdred.  Undertaker Mordo probably sewed some new ones on for you.','Calm down, Valdred.  Undertaker Mordo probably sewed some new ones on for you.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49354,'You talk to Undertaker Mordo.  He\'ll tell you what to do.  That\'s all I know.','You talk to Undertaker Mordo.  He\'ll tell you what to do.  That\'s all I know.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49355,'','It\'s your big coming out party. We\'ll make you a Trade $G Prince : Princess; yet, $n!$B$BGet out there and strut your stuff!',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(49356,'','Pirates?! Boss, you have to deal with this! They\'re ruining the party!',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(49357,'Now hold yer breeks. The zeppelin will take a minute or so to pull around.','',0,0,0,0,0,0,25,0,1,11392,0,0,26124),
(49358,'Bah, predictable! They\'ll see it comin\'!','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(49359,'It\'s almost here. Get ready!','',0,0,0,0,0,0,22,0,1,11392,0,0,26124),
(49360,'','This isn\'t looking good, boss.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(49361,'She\'s here! Get in that cannon, damnit! Get ready to fire!','',0,0,0,0,0,0,22,0,1,11392,0,0,26124),
(49362,'','Boss, we gotta get you a bazillion macaroons by any means possible!',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(49363,'','We gotta finish up here and get you to the dock before the Trade Prince leaves us all behind!',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(49364,'','Heya, hon. Um... we need to talk, but later.$B$BOkay?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(49365,'Oh, heya, toots. Yeah... we need to talk.$B$BLater, okay?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(49366,'','No amount of marketing is going to get us out of this one. The only thing that\'s going to work is a bazillion macaroons!$B$BYou have to get that moolah and get to the docks, pronto!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(49367,'Rush their positions!  $n is with us -- our victory is assured!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49368,'He\'s sent one of his cowards in to kill me, has he?','He\'s sent one of his cowards in to kill me, has he?',0,0,0,0,0,0,0,0,1,11399,0,0,26124),
(49369,'Do it while I\'m standing...','Do it while I\'m standing...',0,0,0,0,0,0,0,0,1,11399,0,0,26124),
(49370,'$n?','$n?',0,0,0,0,0,0,0,0,1,11399,0,0,26124),
(49371,'$n, I\'d recognize that face anywhere... What... What have they done to you, $n?','$n, I\'d recognize that face anywhere... What... What have they done to you, $n?',0,0,0,0,0,0,0,0,1,11399,0,0,26124),
(49372,'You don\'t remember me? We were both servants of Arugal back in Silverpine Forest. We put up with his merciless torture for ages. It was you who saved me on that fateful night when we escaped Shadowfang Keep. Without you I would have died. YOU! The most noble worgen I ever knew. What have they done to you, $n? How could this have happened?','You don\'t remember me? We were both servants of Arugal back in Silverpine Forest. We put up with his merciless torture for ages. It was you who saved me on that fateful night when we escaped Shadowfang Keep. Without you I would have died. YOU! The most noble worgen I ever knew. What have they done to you, $n? How could this have happened?',0,0,0,0,0,0,0,0,1,11399,0,0,26124),
(49373,'Ah, my back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49374,'Remember the worgen that you once were, $g brother:sister;! You were our savior! Fight this!','Remember the worgen that you once were, $g brother:sister;! You were our savior! Fight this!',0,0,0,0,0,0,0,0,1,11399,0,0,26124),
(49375,'Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!',0,0,0,0,0,0,0,0,1,11399,0,0,26124),
(49376,'There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Gilneas, our beloved home. This world is worth saving.','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Gilneas, our beloved home. This world is worth saving.',0,0,0,0,0,0,0,0,1,11399,0,0,26124),
(49377,'Do it, $n! Put me out of my misery!','Do it, $n! Put me out of my misery!',0,0,0,0,0,0,0,0,1,11399,0,0,26124),
(49378,'%s dies from his injuries.','%s dies from his injuries.',0,0,0,0,0,0,0,0,1,11399,0,0,26124),
(49379,'What\'s going on in there? What\'s taking so long, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49380,'C... can\'t we work this out somehow?','C... can\'t we work this out somehow?',0,0,0,0,0,0,0,0,1,11400,0,0,26124),
(49381,'Alright, j... just let me... let me st... stand up.','Alright, j... just let me... let me st... stand up.',0,0,0,0,0,0,0,0,1,11400,0,0,26124),
(49382,'$n?','$n?',0,0,0,0,0,0,0,0,1,11400,0,0,26124),
(49383,'$n, I\'d recognize that face anywhere... What... What have they done to you, $n?','$n, I\'d recognize that face anywhere... What... What have they done to you, $n?',0,0,0,0,0,0,0,0,1,11400,0,0,26124),
(49384,'You don\'t remember me, $n? I lost count of the number of jobs you and I ran back in the day on Kezan. Then I picked up a real bad Kaja\'Cola habit and you saved me! It was you who took me to Kalimdor to join the Steamwheedle Cartel. You were the only good goblin I knew. That\'s how I ended up in the Argent Dawn, because I knew it was what you woulda done. How could this have happened to you?','You don\'t remember me, $n? I lost count of the number of jobs you and I ran back in the day on Kezan. Then I picked up a real bad Kaja\'Cola habit and you saved me! It was you who took me to Kalimdor to join the Steamwheedle Cartel. You were the only good goblin I knew. That\'s how I ended up in the Argent Dawn, because I knew it was what you woulda done. How could this have happened to you?',0,0,0,0,0,0,0,0,1,11400,0,0,26124),
(49385,'Remember the goblin that you once were, $g brother:sister;! You were my best friend! Fight this!','Remember the goblin that you once were, $g brother:sister;! You were my best friend! Fight this!',0,0,0,0,0,0,0,0,1,11400,0,0,26124),
(49386,'Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!',0,0,0,0,0,0,0,0,1,11400,0,0,26124),
(49387,'There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Kezan, our beloved home. This world is worth saving.','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Kezan, our beloved home. This world is worth saving.',0,0,0,0,0,0,0,0,1,11400,0,0,26124),
(49388,'Do it, $n! Put me out of my misery!','Do it, $n! Put me out of my misery!',0,0,0,0,0,0,0,0,1,11400,0,0,26124),
(49389,'%s dies from his injuries.','%s dies from his injuries.',0,0,0,0,0,0,0,0,1,11400,0,0,26124),
(49390,'Beak! Get down here, Beak!','',0,0,0,0,0,0,22,0,1,10732,0,0,26124),
(49391,'Aww, c\'mon Beak. It weren\'t nothin\' but a big ... tentacle thing. Donnelly will keep ya safe!','',0,0,0,0,0,0,6,0,1,10732,0,0,26124),
(49392,'Take it easy, Beak. Come back here!','',0,0,0,0,0,0,25,0,1,10732,0,0,26124),
(49393,'You\'re safe now, Beak. C\'mon back to Donnelly!','',0,0,0,0,0,0,5,0,1,10732,0,0,26124),
(49394,'Beak. Beak!','',0,0,0,0,0,0,22,0,1,10732,0,0,26124),
(49395,'I love yoooouuu man ... *hic* like a BROTHER!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49396,'You\'re okay, Firebeard. *urp* You\'re okay by me.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49397,'Tha\'s the way we Wildhammer ... get hitched, it was. *hic* That were BEAUTIFUL!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(49398,'*hic* You an\' me, Firebeard. Wildhammers FOREVER.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(49399,'BEST! WEDDING! EVAR! *Hic*','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49400,'Wildhammer stay ta\'gether wot slay ta\'gether!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49401,'','Twilight\'s Hammer don\'t scare me none. Bring \'em on!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49402,'','Wiiiiiildhammmmmer!',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(49403,'','Get it! Kill it!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49404,'I\'m ready to start whenever you are! I\'ll keep the bride and groom close in case the Twilight\'s Hammer tries anything.$B$BAre you ready?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(49405,'The Dark Pharaoh has fallen!  His immortal colossi tumble like toys!','',0,0,0,0,0,0,53,0,1,0,0,0,26124),
(49406,'Neferset City will fall!  ATTACK!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49407,'The bomb is set! Get clear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49408,'Valdred Moray, reporting for duty, sir!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49409,'A Massive Wave of Zombies is Approaching!','A Massive Wave of Zombies is Approaching!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49410,'Finally someone to deal with that unsightly pest! You have my thanks, \"heroes.\"','',0,0,0,0,0,0,0,0,1,0,20085,0,26124),
(49411,'That malfunctioning piece of junk was murder on the repair bills.','',0,0,0,0,0,0,0,0,1,0,20086,0,26124),
(49412,'Now that was really unnecessary.','',0,0,0,0,0,0,0,0,1,0,20087,0,26124),
(49413,'Impressive. You have managed to destroy one of my most horrific creations, a task I had thought impossible until now.','',0,0,0,0,0,0,0,0,1,0,20088,0,26124),
(49414,'We never did see eye to eye... Good riddance I say!','',0,0,0,0,0,0,0,0,1,0,20089,0,26124),
(49415,'Welcome to my personal sanctum, heroes! I hope you find the accommodations to your liking. Herein you will find many of my failed experiments and ultimately my greatest triumph!','',0,0,0,0,0,0,0,0,1,0,20090,0,26124),
(49416,'Behold the brood mother, Onyxia, REBORN! Perhaps my finest work.','',0,0,0,0,0,0,22,0,1,0,20070,0,26124),
(49417,'My dearest sibling, do you hunger? THEN FEAST UPON OUR ENEMIES!','',0,0,0,0,0,0,22,0,1,0,20071,0,26124),
(49418,'See how the shadowflame animates their bones! They fight at my command!','',0,0,0,0,0,0,0,0,1,0,20073,0,26124),
(49419,'Flesh turns to ash!','',0,0,0,0,0,0,0,0,1,0,20074,0,26124),
(49420,'Curse you, mortals! Such a callous disregard for one\'s possessions must be met with extreme force!','',0,0,0,0,0,0,0,0,1,0,20082,0,26124),
(49421,'I hope you can swim... in molten lava!','',0,0,0,0,0,0,0,0,1,0,20075,0,26124),
(49422,'I have tried to be an accommodating host, but you simply will not die! Time to throw all pretense aside and just... KILL YOU ALL!','',0,0,0,0,0,0,0,0,1,0,20077,0,26124),
(49423,'Mortal minds... So easily manipulated.','',0,0,0,0,0,0,0,0,1,0,20078,0,26124),
(49424,'It has been a pleasure!','',0,0,0,0,0,0,0,0,1,0,20079,0,26124),
(49425,'HAH!','',0,0,0,0,0,0,0,0,1,0,20080,0,26124),
(49426,'You really have to want it!','',0,0,0,0,0,0,0,0,1,0,20081,0,26124),
(49427,'Defeat has never tasted so bitter...','',0,0,0,0,0,0,0,0,1,0,20083,0,26124),
(49428,'I thank you for coming, but you really all must die now!','',0,0,0,0,0,0,0,0,1,0,20084,0,26124),
(49429,'','Mortal, I want you to bear witness to this, but for your own safety stay back. Calen, you too.',0,0,0,0,0,0,1,0,1,0,0,21045,26124),
(49430,'','Your life isn\'t yours to throw away, Calen. Should I fail, the fate of this world may rest on your shoulders.',0,0,0,0,0,0,5,0,1,0,0,21046,26124),
(49431,'','It pains me, Neltharion - but I must end you, as I have ended Malygos.',0,0,0,0,0,0,1,0,1,0,0,21047,26124),
(49432,'','I see the hollow metal shell of a once great ally, and the precious gift of the Titans wasted.',0,0,0,0,0,0,274,0,1,0,0,21048,26124),
(49433,'','Neltharion! Look at yourself. Misshapen. Twisted. You\'re coming apart.',0,0,0,0,0,0,5,0,1,0,0,21049,26124),
(49434,'','The Earth Warder... he is dead.',0,0,0,0,0,0,0,0,1,0,0,21050,26124),
(49435,'','The black aspect\'s blood is cursed. Wherever it was shed - nothing will grow for ten thousand years.',0,0,0,0,0,0,0,0,1,0,0,21051,26124),
(49436,'','Alexstrasza winches in pain.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49437,'','But it is over. We can work now to bottle up the horrors he has unleashed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49438,'','Impossible!',0,0,0,0,0,0,0,0,1,0,0,21052,26124),
(49439,'','Calen, no!',0,0,0,0,0,0,0,0,1,0,0,21053,26124),
(49440,'','No!',0,0,0,0,0,0,15,0,1,0,0,21054,26124),
(49441,'Lifebinder! Do you presume that I am at your beck and call? I have a world to unmake.','',1,0,0,0,0,0,1,0,1,0,20275,0,26124),
(49442,'\"End\" me? Lifebinder, you think life is yours to take away?','',0,0,0,0,0,0,11,0,1,0,20276,0,26124),
(49443,'Then witness my new gifts, bestowed by this world\'s true masters.','',0,0,0,0,0,0,5,0,1,0,20277,0,26124),
(49444,'Just as all life ends in death ... all order must end in chaos ... Come! Embrace the inevitable, as I have!','',0,0,0,0,0,0,0,0,1,0,20278,0,26124),
(49445,'The sun has set on this mortal world, fools. Make peace with your end, for the hour of Twilight falls.','',0,0,0,0,0,0,0,0,1,0,20279,0,26124),
(49446,'You think to entrap me!?','',0,0,0,0,0,0,0,0,1,0,20280,0,26124),
(49447,'I will not leave your side.','',0,0,0,0,0,0,274,0,1,0,21510,0,26124),
(49448,'Yes, mother.','',0,0,0,0,0,0,2,0,1,0,21512,0,26124),
(49449,'Don\'t let them out of sight! Quickly - come with me!','',0,0,0,0,0,0,0,0,1,0,21513,0,26124),
(49450,'There - they\'ve fallen!','',0,0,0,0,0,0,5,0,1,0,21514,0,26124),
(49451,'Mother, stay still. Your wounds are great.','',0,0,0,0,0,0,1,0,1,0,21515,0,26124),
(49452,'Deathwing - he lives!','',0,0,0,0,0,0,5,0,1,0,21520,0,26124),
(49453,'Mortal, take the dragon queen. Carry her to safety. Now! RUN! Get her away from here!','',0,0,0,0,0,0,25,0,1,0,21521,0,26124),
(49454,'I will delay the Aspect of Death. Take her to safety. GO!','',0,0,0,0,0,0,0,0,1,0,21522,0,26124),
(49455,'Hello again.','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(49456,'I know the way to Deathknell.  Come with me!','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(49457,'Good, you\'re still here.  Now, where\'s Deathguard Saltain?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49458,'Ah, here he is.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49459,'Let\'s get moving, $n.  Saltain said that we\'d find some corpses up here.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49460,'I think I see some corpses up ahead.  Let\'s go, $n!  You do the searching and fighting.  I\'ll do the lifting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49461,'Think you have what it takes to face the challenges of Azeroth\'s dungeons? Inquire within...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49462,'I wish to browse your wares, Yasmin.','I wish to browse your wares, Yasmin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49463,'Oh you poor thing, you\'re covered head to toe in sand!  Please feel free to rest and rejuvenate yourself here at this beautiful oasis.','Oh you poor thing, you\'re covered head to toe in sand!  Please feel free to rest and rejuvenate yourself here at this beautiful oasis.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(49464,'','Alexstrasza will be here shortly. Come, we will prepare the sanctuary.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49465,'','One fire burns for lives long lost; their essence now shared with all living things.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49466,'','One fire burns for lives to come; nascent souls awakening in the womb.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49467,'','One fire burns for lives born anew; the passion of youth and the energy they bear.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49468,'','One fire burns for lives in their prime; struggling to make and reshape the world.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49469,'','One fire burns for lives at their end; their work may be done, but their contribution eternal.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49470,'','And so the circle of life is complete. All is prepared.',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(49471,'','Ah - here comes Alexstrasza now.',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(49472,'Hmm... I can\'t remember which way to go here.  Let\'s try this side!','Hmm... I can\'t remember which way to go here.  Let\'s try this side!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(49473,'Bah!  This just looks like a dead end.  Let\'s head back the other way.','Bah!  This just looks like a dead end.  Let\'s head back the other way.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(49474,'Hmmm...  This stairway does not look promising at all.  Let\'s head back to the courtyard and see if there is another way out.','Hmmm...  This stairway does not look promising at all.  Let\'s head back to the courtyard and see if there is another way out.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(49475,'Now we are making progress!  This is the way out for sure.  Looks like a lot of guards though so I really need you to help me out!','Now we are making progress!  This is the way out for sure.  Looks like a lot of guards though so I really need you to help me out!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(49476,'','You hear a noise from above the cabin door!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49477,'','I\'ve been waiting a long time for this, you know.',0,0,0,0,0,0,1,0,1,0,0,24613,26124),
(49478,'','Biding my time, building my forces, studying the minds of my enemies.',0,0,0,0,0,0,1,0,1,0,0,24614,26124),
(49479,'','I was never very good at hand-to-hand combat, you know.  Not like my father.',0,0,0,0,0,0,1,0,1,0,0,24615,26124),
(49480,'','But I always excelled at poisons.',0,0,0,0,0,0,1,0,1,0,0,24616,26124),
(49481,'','Especially venoms that affect the mind.',0,0,0,0,0,0,1,0,1,0,0,24617,26124),
(49482,'How\'s it going.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49483,'','Vanessa injects you with the Nightmare Elixir!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49484,'Did you really zhink you vould get avay vizh it, $p? Hmm?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49485,'First, you come traipsing into Uldum as if you owned zhe place...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49486,'Clumsily interferink vizh my operation...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49487,'Zhen you mercilessly kill my loyal vorkers...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49488,'But -','But -',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49489,'Cage the pygmy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49490,'Sorry, I have to set a broken leg on a baby dragon. Can you come back in a few minutes?','Sorry, I have to set a broken leg on a baby dragon. Can you come back in a few minutes?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49491,'NO BUT! Silence! Keep Movink!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49492,'If zhat vere not enough, you sabotaged my ritual and caused Gobbles\' death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49493,'Zhen, on top of everyzhink, you nearly take my life... ME!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49494,'You vill pay, $p. Deazh by firink sqvad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49495,'You are fortunate zhat I am too busy to make you suffer as you deserve.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49496,'Zhat\'s far enough!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49497,'I can take it from here, my friends. Report to your master zhat zhe problem has been dealt vizh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49498,'Tell him zhat zhere vill be no furzher interruptions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49499,'Be certain there aren\'t, Schnottz. Deathwing\'s patience wears thin.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(49500,'Now, zhen, vhere vere ve?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49501,'Ahh, yes. Any last vords? Hmm?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49502,'VHAAAT?! Vhat is zhe meanink of zhis?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49503,'You haven\'t seen zhe last of me, $p!','',0,0,0,0,0,0,14,0,1,0,0,0,26124),
(49504,'Placeholder','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49505,'Placeholder','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49506,'Placeholder','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49507,'Placeholder','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49508,'Placeholder','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49509,'You alright, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49510,'Beat it, Schnottz!','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(49511,'Placeholder','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49512,'Placeholder','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49513,'Placeholder','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49514,'','I understand that Alexstrasza has pronounced judgment on Deathwing. Perhaps this whole ordeal will end, right here?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(49515,'I am ready for Deathwing!','I am ready for Deathwing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49516,'That oughta do it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49517,'Would you look at that...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(49518,'$p! We\'ve done it!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49519,'Brann!? Wha?! How...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49520,'Placeholder','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49521,'Placeholder','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49522,'Placeholder','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49523,'Och! Come on now, ye buggar...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49524,'Destroy zhe - Vait... vhat is ZHAT?!','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(49525,'Auckh!!!','',0,0,0,0,0,0,34,0,1,0,0,0,26124),
(49526,'Placeholder','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49527,'Placeholder','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49528,'Placeholder','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49529,'Ahah! Fresh air at last!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49530,'Two steps ahead of ya again, junior! As usual.','',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(49531,'Better sharpen up, laddie! I may not be there to pull yer bacon outta the fire next time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49532,'You can help me out of here?  Well  there is no reason to stand around, let\'s go!','You can help me out of here?  Well  there is no reason to stand around, let\'s go!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(49533,'I don\'t remember which way the exit is here.  Let\'s try this doorway over here.','I don\'t remember which way the exit is here.  Let\'s try this doorway over here.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(49534,'Bah, this just looks like a dead end.  That bed does look comfy though.  Let\'s try the other way.','Bah, this just looks like a dead end.  That bed does look comfy though.  Let\'s try the other way.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(49535,'This does not look familar to me at all.  Let\'s head back to the courtyard and see if there is another way.  I don\'t really like long stairwells anyways.','This does not look familar to me at all.  Let\'s head back to the courtyard and see if there is another way.  I don\'t really like long stairwells anyways.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(49536,'Ok, this is the right way for sure.  Quite a few guards out there so be on your toes.','Ok, this is the right way for sure.  Quite a few guards out there so be on your toes.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(49537,'Thanks $n, I think I can take one of these horses and make it back to camp from here.  I could not have made it without your help.','Thanks $n, I think I can take one of these horses and make it back to camp from here.  I could not have made it without your help.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(49538,'I\'ll see ya there, $n! Don\'t be late!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49539,'Arrite, now... Let\'s see here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49540,'Arrite, $r.$b$bEverything looks ta be in its proper place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49541,'I\'m ready, Brann. Go ahead and activate the coffer.','I\'m ready, Brann. Go ahead and activate the coffer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49542,'Well, look who\'s here!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49543,'Hi, $n!  What do you think about my new gear?','',0,0,0,0,0,0,23,0,1,0,0,0,26124),
(49544,'They\'re making me into a Deathguard.  Can you believe it?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49545,'I\'ll probably be staying here in Deathknell.  If things work out, though... who knows?  Maybe I\'ll get to meet the Dark Lady herself.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(49546,'How about you?  I\'ve heard that Sarvis is going to send you off to Calston Estate.  Big assignment, eh?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49547,'Well, I won\'t hold you up.  It\'s been a pleasure, $n.  I hope our paths cross again soon.','',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(49548,'%s calls a Twilight Drake to aid him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49549,'','I\'m going to stay and do what I can to free these spiders. Thank you for your help, $n.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49550,'','You\'ve come to help, $c? Let us stay together for a while.',0,0,0,0,0,0,1,0,1,11498,0,0,26124),
(49551,'You survived the attack!$BRocknut Unlocked!','You survived the attack!$BRocknut Unlocked!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49552,'Tutorial Completed!$BYou\'ve unlocked the Sunflower.','Tutorial Completed!$BYou\'ve unlocked the Sunflower.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49553,'Good job!','Good job!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49554,'Use this Blast Tape to seal them faulty valves up real good, chief.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49555,'Just a few more minutes...  Cenarius is almost here!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49556,'You might not have that long.  Enemy reinforcements are already underway.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49557,'Goldrinn!  It\'s true then... the Ancients walk among us again!','',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(49558,'Keep placing spitters in the center lane to hold off the zombies.','Keep placing spitters in the center lane to hold off the zombies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49559,'Collect Solar Power and place Spitters in the center lane to fight the zombies!','Collect Solar Power and place Spitters in the center lane to fight the zombies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49560,'','There will be time to celebrate later, commander.  Twilight dragons approach!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49561,'Internal: Zombie Wave to 50%%.','Internal: Zombie Wave to 50%%.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49562,'Internal: Ghoul Wave to 50%%.','Internal: Ghoul Wave to 50%%.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49563,'Internal: Aberration Wave to 50%%.','Internal: Aberration Wave to 50%%.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49564,'What you two are lacking...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49565,'...is control.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49566,'Plant Sunflowers to create additional solar power, which will help you survive zombie attacks.','Plant Sunflowers to create additional solar power, which will help you survive zombie attacks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49567,'Build at least 3 Sunflowers to survive this mission.','Build at least 3 Sunflowers to survive this mission.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49568,'%s summons a |cFFFF0000Faceless Corruptor|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49569,'Welcome to Starfall Village, traveler. Have you come to assist us?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49570,'Filthy beasts! Your presence in Skywall will not be tolerated!','',0,0,0,0,0,0,0,0,1,0,20876,0,26124),
(49571,'Ravaged!','',0,0,0,0,0,0,0,0,1,0,20877,0,26124),
(49573,'YOU tread upon the sacrosanct! Mortals have no place amidst the clouds.','',0,0,0,0,0,0,0,0,1,0,20867,0,26124),
(49574,'BACK to the earth with you!','',0,0,0,0,0,0,0,0,1,0,20868,0,26124),
(49575,'Al\'Akir, your servant calls for aid!','',0,0,0,0,0,0,0,0,1,0,20869,0,26124),
(49576,'The winds take me!','',0,0,0,0,0,0,0,0,1,0,20870,0,26124),
(49577,'My family\'s been clearing out swarms for years! Not that we\'re above a bit of hired help...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49578,'%s begins to pursue $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49579,'Boss Cho\'gall not gonna be happy \'bout dis!','',0,0,0,0,0,0,0,0,1,0,18925,0,26124),
(49580,'Dat\'s what you get! Noting!','',0,0,0,0,0,0,0,0,1,0,18926,0,26124),
(49582,'Rom\'ogg sorry...','',0,0,0,0,0,0,0,0,1,0,18928,0,26124),
(49583,'RAZ SMASH!','',0,0,0,0,0,0,0,0,1,0,18919,0,26124),
(49584,'Raz... Tired...','',0,0,0,0,0,0,0,0,1,0,18920,0,26124),
(49585,'','HERETICS! You will suffer for this interruption!',0,0,0,0,0,0,0,0,1,0,0,18589,26124),
(49586,'','There is only one true path of enlightenment! DEATH!',0,0,0,0,0,0,0,0,1,0,0,18590,26124),
(49587,'','Bask in his power! Rise as an agent of the master\'s rage!',0,0,0,0,0,0,0,0,1,0,0,18592,26124),
(49588,'','For the master I\'d die a thousand times... A thousan...',0,0,0,0,0,0,0,0,1,0,0,18594,26124),
(49589,'Bodies to test my armaments upon!','',0,0,0,0,0,0,0,0,1,0,18852,0,26124),
(49590,'Merely an impurity in the compound...','',0,0,0,0,0,0,0,0,1,0,18853,0,26124),
(49591,'Feel the burn!','',0,0,0,0,0,0,0,0,1,0,18854,0,26124),
(49592,'We number in the millions! Your efforts are wasted...','',0,0,0,0,0,0,0,0,1,0,18855,0,26124),
(49593,'You come seeking answers? Then have them! Look upon your answer to living!','',0,0,0,0,0,0,0,0,1,0,18899,0,26124),
(49594,'Your kind has no place in the master\'s world.','',0,0,0,0,0,0,0,0,1,0,18900,0,26124),
(49595,'Earth can be shaped, molded... You cannot! You are useless!','',0,0,0,0,0,0,0,0,1,0,18901,0,26124),
(49596,'I cannot be destroyed... Only... de... layed...','',0,0,0,0,0,0,0,0,1,0,18902,0,26124),
(49597,'RAZ, NOOOOOOOOOOO!!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49598,'Quick!  Do not let them disrupt Ysera\'s magic!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49599,'Hold them back as long as you can!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(49600,'Use Rocknuts to protect your Spitters and Sunflowers.','Use Rocknuts to protect your Spitters and Sunflowers.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49601,'The void sucks at your soul. It is content to feast slowly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49602,'When we were ambushed by Rom\'ogg he threw chains around Raz and then hit him with the |cff71d5ff|Hspell:75543|h[The Skullcracker]|h|r! Luckily I moved away before he landed that final blow!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49603,'In the sunken city, he lays dreaming.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49604,'Y\'knath k\'th\'rygg k\'yi mrr\'ungha gr\'mula.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49605,'All places, all things have souls. All souls can be devoured.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49606,'There is no sharp distinction between the real and the unreal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49607,'Thanks, $n!','Thanks, $n!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(49608,'In the land of Ny\'alotha there is only sleep.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49609,'Do you dream while you sleep or is it an escape from the horrors of reality?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49610,'I\'m saved!','I\'m saved!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(49611,'In the sleeping city of Ny\'alotha walk only mad things.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49612,'A pool pony in the nick of time!','A pool pony in the nick of time!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(49613,'I was gonna drown for sure!','I was gonna drown for sure!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(49614,'The silent, sleeping, staring houses in the backwoods always dream. It would be merciful to tear them down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49615,'It\'s about time! You know how long I\'ve been treading water here?','It\'s about time! You know how long I\'ve been treading water here?',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(49616,'The stars sweep chill currents that make men shiver in the dark.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49617,'With the pool pony, I can make it back.','With the pool pony, I can make it back.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(49618,'Ny\'alotha is a city of old, terrible, unnumbered crimes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49619,'Even death may die.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49620,'Thanks, friend. My rocket jump fizzled.','Thanks, friend. My rocket jump fizzled.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(49621,'You\'re a miracle worker, $n!','You\'re a miracle worker, $n!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(49622,'You will all be alone in the end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49623,'The drowned god\'s heart is black ice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49624,'There is a little lamb lost in dark woods.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49625,'The giant rook watches from the dead trees. Nothing breathes beneath his shadow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49626,'Have you had the dream again? A black goat with seven eyes that watches from the outside.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49627,'Look around. They will all betray you. Flee screaming into the black forest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49628,'At the bottom of the ocean even light must die.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49629,'Open me! Open me! Open me! Then only will you know peace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49630,'You gained Strangler Vine seeds!','You gained Strangler Vine seeds!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49631,'The fish know all the secrets. They know the cold. They know the dark.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49632,'It is standing right behind you. Do not move. Do not breathe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49633,'The tortured spirits of your ancestors cling to you, screaming in silence. Apparently they are quite numerous.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49634,'What can change the nature of a man?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49635,'A Ghoul dropped something onto the field!','A Ghoul dropped something onto the field!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49636,'You resist. You cling to your life as if it actually matters. You will learn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49637,'Life is weak, mortal, fleeting ... fragile.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(49638,'Death is final. Death is eternal. Death is ... my realm.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49639,'Look upon me and you see death incarnate, the unmaker of worlds.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(49640,'','Congratulations, adventurer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49641,'Continue reading... <Note: This will alert Vanessa to your presence!>','Continue reading... <Note: This will alert Vanessa to your presence!>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49642,'','You\'ve managed to walk right into my trap!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49643,'You\'re the bomb-diggity, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49644,'I have plenty of emergency pool ponies, $n. Please throw them to our laborers in the water below.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(49645,'$n, Savior of the Krazzworks!','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(49646,'%s nods silently in greeting.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49647,'Arrite then! Follow me!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49648,'Somebody help!','Somebody help!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(49649,'I can\'t swim!','I can\'t swim!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(49650,'I\'m gonna drown! Help!','I\'m gonna drown! Help!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(49651,'The Halls of Origination lie due east of here, near the desert sands of Tanaris. It be a bit of a walk, so we\'d best get movin\'.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(49652,'Shark!!!','Shark!!!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(49653,'I don\'t want to die!','I don\'t want to die!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(49654,'That... will not be necessary.','',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(49655,'I\'m so tired....','I\'m so tired....',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(49656,'If only I\'d remembered to wear my standard-issue emergency pool pony vest.','If only I\'d remembered to wear my standard-issue emergency pool pony vest.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(49657,'Hey you! Help!','Hey you! Help!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(49658,'','A note falls to the floor!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49659,'Me back still be a wee bit stiff from bein\' stuck inside that coffer for so long. Bear with me if I\'m a little slow...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(49660,'Stay close, now! Ya never know when Deathwing\'s agents might be swoopin\' in and puttin\' an early end to our quest!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49661,'It be a journey, but if we can avoid harrassment we should be able ta make it by day\'s end. Do ye have any food on ye?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(49662,'I just be pullin\' yer leg, $glad:lass;! The slow walkin\'... always good fer a laugh!','',0,0,0,0,0,0,153,0,1,0,0,0,26124),
(49663,'You go on ahead. I\'ll meet ya there as soon as I get these discs decrypted.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(49664,'You\'ll find the trainer inside of Aldrassil, $n.','',0,0,0,0,0,0,397,0,0,11483,0,0,26124),
(49665,'','Shadowthread Cave lies to the north. Be careful, it\'s dangerous there of late.',0,0,0,0,0,0,397,0,0,11484,0,0,26124),
(49666,'','The moonwell is to the northeast, on the other side of the pool and up the hill.',0,0,0,0,0,0,397,0,0,11485,0,0,26124),
(49667,'','The ramp up to Aldrassil is just in sight over there. Circle around and find Tenaron up top.',0,0,0,0,0,0,397,0,0,11486,0,0,26124),
(49668,'','Iverron\'s poison is cured, but it will take some time for him to recover.',0,0,0,0,0,0,1,0,0,11487,0,0,26124),
(49669,'','The corruption is buried deep within him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49670,'','They are surely unredeemable, but it still hurts to see them die.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49671,'','My dear friends... I\'m so sorry...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49672,'','His body screams for death, but his soul screams for mercy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49673,'','The corruption goes much further than these spiders. I fear the true source is not within this cave.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49674,'','I weep at these atrocities we commit. It is almost unbearable.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49675,'','Corruption this deep could not have come from outside.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49676,'','It almost seems as if he was born with this corruption inside of him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49677,'','I have no further training for you.  Continue east, to the Menders\' Stead, for now.  You will be summoned when the Battle for Andorhal commences.  Hopefully Koltira doesn\'t wait too long...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(49678,'You defended against the attack!$BPumpkin Bombs unlocked!','You defended against the attack!$BPumpkin Bombs unlocked!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49679,'Dark Lady watch over you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49680,'Activate the steam valves to free yourself!','Activate the steam valves to free yourself!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49681,'I\'m sorry, Huntress. None of our new $cs are ready. They still have much to learn.','',0,0,0,0,0,0,1,0,0,11490,0,0,26124),
(49682,'','I fear time may not be on our side, Ilthalaine. The battle may carry to Teldrassil itself if we do not act soon.',0,0,0,0,0,0,1,0,0,11490,0,0,26124),
(49683,'','We will leave you to your training, Ilthalaine. This is your area of expertise.',0,0,0,0,0,0,1,0,0,11490,0,0,26124),
(49684,'','Study well, $n. We may need you fighting by our side before the next moon fills.',0,0,0,0,0,0,1,0,0,11490,0,0,26124),
(49685,'A zombie dropped something onto the field!','A zombie dropped something onto the field!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49686,'You gained Freeza seeds!','You gained Freeza seeds!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49687,'We\'ve done it! The control room is breached!','',0,0,0,0,0,0,5,0,1,0,23709,0,26124),
(49688,'Here we go! Now this should only take a moment...','',0,0,0,0,0,0,5,0,1,0,23710,0,26124),
(49689,'Cenarius!  Excellent!  With the portal active, we can move our forces to the frontlines unfettered.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49690,'You are a most welcome sight, son of Malorne!  We  must preserve your power so you can spearhead the attack against the Firelord.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49691,'','Leave that to me.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49692,'Zombies ate your brains!','Zombies ate your brains!',0,0,0,0,0,0,0,0,0,0,14560,14560,26124),
(49693,'$n, get these Wildhammer off of my airfield!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49694,'I hear I have you to thank for helping to cure me. Thank you. Truly.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(49695,'What about the Twilight dragons?  There will be more where those came from.','',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(49696,'Greetings, $c.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(49697,'','This totem has been corrupting the eggs! It seems a greater threat looms. The Gnarlpine remain tainted by something most foul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49698,'All we had to do was deploy the Krazzworks airfield-in-a-box and begin a routine surveying mission.$B$BI\'m surrounded by idiots!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(49699,'','Helgrum!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49700,'You are only foolish in your shame, Neeka...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49701,'You used to tell me how we must be tough... how you cannot afford to be soft...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49702,'As tough as you were, you were always soft in my arms.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49703,'Be strong, Neeka. I will watch over you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49704,'','Be strong, Neeka. I will watch over you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49705,'The Nightmare Elixir takes hold!','The Nightmare Elixir takes hold!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49706,'You have entered Glubtok\'s Nightmare!','You have entered Glubtok\'s Nightmare!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49707,'The nightmare shifts!','The nightmare shifts!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49708,'You have entered Helix\'s nightmare!','You have entered Helix\'s nightmare!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49709,'You have entered the mechanical nightmare!','You have entered the mechanical nightmare!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49710,'You have entered Ripsnarl\'s nightmare!','You have entered Ripsnarl\'s nightmare!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49711,'Save Emme Harrington!','Save Emme Harrington!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49712,'Save Erik Harrington!','Save Erik Harrington!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49713,'Save Calissa Harrington!','Save Calissa Harrington!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49714,'The Nightmare Elixir wears off!','The Nightmare Elixir wears off!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49715,'','Poor Glubtok.  When his powers manifested, his own ogre mound was the first to burn.',0,0,0,0,0,0,1,0,1,0,0,24602,26124),
(49716,'','Deep within his soul, the one thing he feared most of all was...himself.',0,0,0,0,0,0,1,0,1,0,0,24603,26124),
(49717,'What is it you seek, $r?  Knowledge?  Money?  Honor?$b$bFor me, it has always been further enlightenment in the arcane arts.  My quest for knowledge has taken me around Azeroth countless times, and each time I learn something new about the magic this world has to offer.$b$bJust kidding!  I\'m in it for the money.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49718,'Are you ready to leave Stranglethorn Vale?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49719,'Yes.  Please prepare the portal, Arman.','Yes.  Please prepare the portal, Arman.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49720,'I\'ve been sent here by my superiors to investigate some strange occurrences here in Booty Bay.  This goblin town withstood a tidal wave remarkably well, especially given the reputation of goblin engineering.  I\'m surprised the place didn\'t explode on impact.$b$bI suspect there may be magical forces at play here.  There may be more to Booty Bay than you\'d expect, $c...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49721,'Are you ready to leave Stranglethorn Vale?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49722,'Yes.  Please prepare the portal, Erallier.','Yes.  Please prepare the portal, Erallier.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49723,'','Most rogues prefer to cloak themselves in the shadows, but not Helix.',0,0,0,0,0,0,1,0,1,0,0,24604,26124),
(49724,'','You never know what skitters in the darkness.',0,0,0,0,0,0,1,0,1,0,0,24605,26124),
(49725,'','Can you imagine the life of a machine?',0,0,0,0,0,0,1,0,1,0,0,24606,26124),
(49726,'','A simple spark can mean the difference between life...and death.',0,0,0,0,0,0,1,0,1,0,0,24607,26124),
(49727,'All is lost....  Forgive me, my Queen....','',0,0,0,0,0,0,0,0,0,0,21598,0,26124),
(49728,'Flame of Life!  Burn within me and renew my vigor!','',0,0,0,0,0,0,0,0,0,0,21592,0,26124),
(49729,'','Deathwing!  I have fallen....  The brood... is lost.',0,0,0,0,0,0,0,0,1,0,0,20200,26124),
(49730,'','The energy infused within my clutch is mine to reclaim!',0,0,0,0,0,0,0,0,1,0,0,20208,26124),
(49731,'I serve the Dark Lady!','I serve the Dark Lady!',0,0,0,0,0,0,66,1,1,0,0,0,26124),
(49732,'','Suffer!',0,0,0,0,0,0,0,0,1,0,0,20209,26124),
(49733,'I am yours to command.','I am yours to command.',0,0,0,0,0,0,66,1,1,0,0,0,26124),
(49734,'','Feel my hatred!',0,0,0,0,0,0,0,0,1,0,0,20210,26124),
(49735,'I am reborn!','I am reborn!',0,0,0,0,0,0,71,1,1,0,0,0,26124),
(49736,'For the Forsaken!','For the Forsaken!',0,0,0,0,0,0,94,1,1,0,0,0,26124),
(49737,'I... I don\'t understand...','I... I don\'t understand...',0,0,0,0,0,0,6,1,1,0,0,0,26124),
(49738,'','Come forth, children of twilight....',0,0,0,0,0,0,0,0,1,0,0,20211,26124),
(49739,'','Your mother calls!',0,0,0,0,0,0,0,0,1,0,0,20212,26124),
(49740,'You are weakening, Sintharia!  Accept the inevitable!','',0,0,0,0,0,0,0,0,0,0,21593,0,26124),
(49741,'Who are you?  What happened?','Who are you?  What happened?',0,0,0,0,0,0,6,1,1,0,0,0,26124),
(49742,'','Ripsnarl wasn\'t always a bloodthirsty savage.  Once, he even had a family.',0,0,0,0,0,0,1,0,1,0,0,24608,26124),
(49743,'Where am I?','Where am I?',0,0,0,0,0,0,6,1,1,0,0,0,26124),
(49744,'AHHHHH!','AHHHHH!',0,0,0,0,0,0,15,1,1,0,0,0,26124),
(49745,'','He was called James Harrington.  A tragedy in three parts.',0,0,0,0,0,0,1,0,1,0,0,24609,26124),
(49746,'Och!$b$bWhy can\'t it just be easy fer once?!','',0,0,0,0,0,0,5,0,1,0,20903,0,26124),
(49747,'Use Pumpkin Bombs to defeat large clusters of zombies or weaken difficult ones.','Use Pumpkin Bombs to defeat large clusters of zombies or weaken difficult ones.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49748,'','I will not share my father\'s fate!  Your tale ends here!',0,0,0,0,0,0,0,0,1,0,0,24599,26124),
(49749,'','The first of many.',0,0,0,0,0,0,0,0,1,0,0,24618,26124),
(49750,'','Did you really think I would come to this fight alone?',0,0,0,0,0,0,0,0,1,0,0,24620,26124),
(49751,'','Fools!  This entire ship is rigged with explosives!  Enjoy your fiery deaths!',0,0,0,0,0,0,0,0,1,0,0,24621,26124),
(49752,'','If I\'m going to die, I\'m taking you all with me!',0,0,0,0,0,0,15,0,1,0,0,24611,26124),
(49753,'','ENOUGH!  I will not give you the pleasure!',0,0,0,0,0,0,274,0,1,0,0,24610,26124),
(49754,'','MY FATE IS MY OWN!',0,0,0,0,0,0,397,0,1,0,0,24612,26124),
(49755,'','Vanessa has detonated charges on the ship!  Get to the ropes at the side of the boat!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49756,'','Vanessa is detonating more charges!  Get to the ropes at the side of the boat!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49757,'','Vanessa pulls out a final barrel of mining powder and ignites it!  RUN!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49758,'','Deathwing is victorious! Try again once Alexstrasza recovers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49759,'','The circle of life is not yet prepared for Alexstrasza. Speak with me again as soon as I have finished my preparations.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49760,'','Alexstrasza is already engaged with Deathwing! If you hurry, there may still be time to help!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(49761,'Calissa...I am so sorry...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49762,'','James...please...I love you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49763,'','Calissa is dying!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49764,'Good work with them constructs, $glad:lass;.$b$bYou just bought us unfettered access to the repository.','',0,0,0,0,0,0,5,0,1,0,20903,0,26124),
(49765,'I bring greetings from King Wrynn, $c. Behind me is the Hero\'s Call board, a collection of proclamations from the King of Stormwind directing adventurers to locations where their talents can best aid the Alliance.','',66,1,0,0,0,0,0,0,0,0,0,0,26124),
(49766,'Lok\'tar, $c. Behind me is the Warchief\'s Command board containing our leader\'s instructions to members of the Horde. It will tell you where your skills will best serve the Horde in battle against its foes.','',66,1,0,0,0,0,0,0,0,0,0,0,26124),
(49767,'Remember ta always show yer respect for the elements.','Remember ta always show yer respect for the elements.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(49768,'Always strive ta understand the balance maintained by our world\'s elemental spirits.','Always strive ta understand the balance maintained by our world\'s elemental spirits.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(49769,'','Keep him distracted!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49770,'','Gut him! Tear him apart!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49771,'','H-help! Get him off me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49772,'You defended against the attack!$BThe Warden will not be happy about this...','You defended against the attack!$BThe Warden will not be happy about this...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49773,'Bring elevator to first floor.','Bring elevator to first floor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49774,'Help Alexstrasza by killing the Twilight Corruptors.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49775,'Bring elevator to second floor.','Bring elevator to second floor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49776,'Bring elevator to third floor.','Bring elevator to third floor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49777,'Choose a destination.','Choose a destination.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49778,'Summon elevator to current floor.','Summon elevator to current floor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49779,'','Alexstrasza is hurt. Keep the beams red by killing Twilight Corruptors, or she will lose the fight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49780,'$n, get to one of the Krazz Cannons and shoot those Stormtalons down before they bring this whole place down on us!','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(49781,'I wish I could have seen the looks on their faces when they realized you were shooting them down with our junk.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(49782,'Inconceivable! You may actually defeat my lava worm! Perhaps I can help... tip the scales. ','',0,0,0,0,0,0,0,0,1,0,23368,0,26124),
(49783,'The sacrifices of my Argent Dawn brothers must never be forgotten. They believed in the Dawn, though none lived to see the return of the Light to these lands.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(49784,'Use the Flame Jet attack to engulf enemies in flames!','Use the Flame Jet attack to engulf enemies in flames!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49785,'','Your time ends now!',0,0,0,0,0,0,15,0,0,0,0,11541,26124),
(49786,'If you pay the right price, the Light can always protect you, $c.','If you pay the right price, the Light can always protect you, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49787,'If you\'ve got the money, I\'m sure the Light\'s got something to teach you.','If you\'ve got the money, I\'m sure the Light\'s got something to teach you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49788,'Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BWe are the preservers of the balance, now and forever, with Malfurion watching over us.  Never forget this.','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BWe are the preservers of the balance, now and forever, with Malfurion watching over us.  Never forget this.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(49789,'Our master Malfurion has returned from the Dreaming, $c.  His is the light of a beacon that shows the way for us, and we must do everything in our power to preserve that light.','Our master Malfurion has returned from the Dreaming, $c.  His is the light of a beacon that shows the way for us, and we must do everything in our power to preserve that light.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(49790,'I must admit, I couldn\'ta done this one without yer help.','',0,0,0,0,0,0,396,0,1,0,23694,0,26124),
(49791,'There we go. That should do it!','',0,0,0,0,0,0,396,0,1,0,23695,0,26124),
(49792,'Accessing data... stand by.','',0,0,0,0,0,0,5,0,1,0,23711,0,26124),
(49793,'|TInterface\\Icons\\INV_ELEMENTAL_PRIMAL_SHADOW.BLP:20|t%s throws |cFF660099dark|r magic into the cauldron!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49794,'Accessing reorigination device override.','',0,0,0,0,0,0,5,0,1,0,23712,0,26124),
(49795,'Yeah, yeah. Just read the discs and gimme access already...','',0,0,0,0,0,0,396,0,1,0,23696,0,26124),
(49796,'Repository access denied. Reorigination subroutine initiated.','',0,0,0,0,0,0,5,0,1,0,23713,0,26124),
(49797,'What!? Wait! That\'s no good! That\'s no good at all...','',0,0,0,0,0,0,396,0,1,0,23697,0,26124),
(49798,'Warning!$bReorigination device activated. Detonation in one minute.','',0,0,0,0,0,0,5,0,1,0,23714,0,26124),
(49799,'One minute!? Come on, Brann! Think!','',0,0,0,0,0,0,5,0,1,0,23698,0,26124),
(49800,'I\'m goin\' in manually! There\'s gotta be a way!','',0,0,0,0,0,0,5,0,1,0,23699,0,26124),
(49801,'Detonation in thirty seconds.','',0,0,0,0,0,0,5,0,1,0,23715,0,26124),
(49802,'Arrite! Fuses exposed! Now which one ta break? Red? Or blue...?','',0,0,0,0,0,0,6,0,1,0,23700,0,26124),
(49803,'Och! I can\'t decide!','',0,0,0,0,0,0,5,0,1,0,23701,0,26124),
(49804,'Come, monsters! We will crush you!','',0,0,0,0,0,0,22,0,0,11516,0,0,26124),
(49805,'Arrite, here goes nuthin\'!','',0,0,0,0,0,0,5,0,1,0,23702,0,26124),
(49806,'Your filthy dogs won\'t be enough!','',0,0,0,0,0,0,22,0,0,11516,0,0,26124),
(49807,'I\'ll kill a hundred more of your battle worgs!','',0,0,0,0,0,0,22,0,0,11516,0,0,26124),
(49808,'Your worgs are no match for the might of Stormwind!','',0,0,0,0,0,0,22,0,0,11516,0,0,26124),
(49809,'Look alive, men! There are orcs and worgs about!','',0,0,0,0,0,0,22,0,0,11516,0,0,26124),
(49810,'Pebble bounces around and looks up at you hopefully. He definitely remembers you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49811,'Come little guy, let\'s get out of here.','Come little guy, let\'s get out of here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49812,'Pebble\'s stones jitter as he obediently falls in beside you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49813,'Pebble bounces up and down happily as he disappears into the distance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49814,'Pebble shuffles around happily and disappears into the distance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49815,'Pebble shuffles up against your leg happily, then races off into the distance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49816,'Pebble bobbles around appreciatively and then disappears into the distance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49817,'How about, in consideration of all ye\'ve done, we go with...','',0,0,0,0,0,0,396,0,1,0,23703,0,26124),
(49818,'RED! For the HORDE!','',0,0,0,0,0,0,5,0,1,923,23705,0,26124),
(49819,'Blue! For the Alliance!','',0,0,0,0,0,0,5,0,1,924,23704,0,26124),
(49820,'Reorigination device detonation aborted.','',0,0,0,0,0,0,5,0,1,0,23716,0,26124),
(49821,'Escaping from this place is proving harder than I thought.$B$BWhere do you go when there is nowhere to go in sight?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49822,'Wahooo!','',0,0,0,0,0,0,71,0,1,0,23706,0,26124),
(49823,'Azeroth lives to see another day!','',0,0,0,0,0,0,5,0,1,0,23707,0,26124),
(49824,'Yeah, there\'s tons of people still trapped in the escape pods, boss. Oh, wait. I guess you\'re not the boss anymore. Anyways, they\'re all probably going to drown if you don\'t get them out.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49825,'I cannot help you, $c.','I cannot help you, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49826,'You move with grace, rogue. How may I help you?','You move with grace, rogue. How may I help you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49827,'','We need all of our bombs and tools to survive on this deserted island, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49828,'$n, you gotta get those teraptor hatchlings before they get us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49829,'Did you hear the matriarch growling up on the cliff? Steer clear of her!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49830,'The monkeys are going to get a kick out of those bananas!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49831,'That was the most beautiful thing that I\'ve ever seen!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49832,'','Dampwick\'s at the cave entrance just to the southeast.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49833,'The kaja\'mite has gone and made these monkeys smart! Keep that miner safe, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49834,'On behalf of the Bilgewater Cartel, I lay claim to this mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49835,'','We need some new friends if we\'re going to survive all of this. Hopefully, the orcs won\'t just kill you on sight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49836,'It\'s been quite the pleasure workin\' with yeh, $glad:lass;.$b$bI\'d be honored ta do so again sometime.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(49837,'We\'ll kill anybody for the right price!','We\'ll kill anybody for the right price!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49838,'Time to join your friends, kissin\' the dirt!','Time to join your friends, kissin\' the dirt!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49839,'DIE!!!','DIE!!!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49840,'We\'re gonna burn this place to the ground!','We\'re gonna burn this place to the ground!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49841,'Enough of your pesky pea-shooters. Let them shoot at this!','Enough of your pesky pea-shooters. Let them shoot at this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49842,'','Deepholm has changed much in recent years. It\'s hardly recognizable.$B$BStill... here I am free from corruption. Free from the tainting influence of ancient gods. It seems that sometimes your freedom must be stripped away for you to truly appreciate its value.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(49843,'','Kilag Gorefang should be down the path to the west, goblin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49844,'%s begins to cast Rising Flames!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49845,'','I know you. I have you to thank for my freedom from the deepening corruption that consumed me for so many years.$B$BWelcome to my home. Deepholm.  It is a shadow of what it used to be, but still, here I can be free. I shall never take such freedom for granted after what we have endured.$B$BI know not why you are here, but I hope you find what you seek within the stone walls of this place. Stay safe, $n.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(49846,'Use your weed whacker to mow down these plants, little goblin!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49847,'This mole machine is a little rusty, but it still looks operational.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49848,'Hit the button labeled \"Just past the Grim Guzzler\".','Hit the button labeled \"Just past the Grim Guzzler\".',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49849,'Hit the button labeled \'Into the Domicile\'.','Hit the button labeled \'Into the Domicile\'.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49850,'Hit the button labeled \'Entrance\'.','Hit the button labeled \'Entrance\'.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49851,'Attention. Attention, everyone. I would like to offer my sincerest apologies that I am so much richer than all of you. I truly hope you find a way to continue on.','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(49852,'Good for you. Good for all of you to go on living your lives knowing you can never have the wealth that I do. I\'m proud of you for sticking it out.','',0,0,0,0,0,0,21,0,0,0,0,0,26124),
(49853,'Sometimes... sometimes it hurts to have so much money. It\'s so lonely. Just me and all my gold.','',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(49854,'Hahahah! This reminds me of that little boy who came up and told me he wanted to be just like me, sitting on his own pile of gold someday. So adorable. I told him to get back to mopping and stop being lazy. I mean, really.','',0,0,0,0,0,0,153,0,0,0,0,0,26124),
(49855,'Go back to Aggra and tell her that we\'re moving northwest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49856,'Three cheers for all of you! Keep on riding that rocketway and buying from those vendors. You\'re contributing to the most noble cause in all of Azeroth: my pockets!','',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(49857,'Thank you. Thank you all for coming to stare at my enormous, bulging piles of gold. It must feel like such a wonderful privilege to be in my presence.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(49858,'I am so... darn... beautiful. Look at these guns. Look at this gold. Look at these girls. Who wouldn\'t want to be me?','',0,0,0,0,0,0,23,0,0,0,0,0,26124),
(49859,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49860,'','Head back through the vale and meetup with Kilag at the Wild Overlook.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49861,'<PLACEHOLDER: Exciting Cinematic!>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49862,'Why are you talking to me? You don\'t make nearly as much money as me.$B$BGo mingle with your own kind, pal.','',0,0,0,0,0,0,153,0,0,0,0,0,26124),
(49863,'Ride Bastia! Find Brax!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49864,'','Uh oh, it\'s the Trade Prince.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49865,'Zen\'tabra, are you one of the druids from the rumors? Were there druids on the Echo Isles long ago?','Zen\'tabra, are you one of the druids from the rumors? Were there druids on the Echo Isles long ago?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49866,'','<Zen\'tabra laughs.>$B$BWe spread dose rumors, mon. Keep\'n Zalazane and others off our tails. Don\'t be believin\' everyting ya hear.$B$BNo, we be new ta de craft, only learnin\' a few years ago. But in some ways, we spent our lives preparin\' ta answer de call....',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49867,'What were you before you were druids, then?','What were you before you were druids, then?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49868,'','Some o\' us be loa priests, witch doctors before. Like Zalazane...$B$B<Zen\'tabra\'s face grows hard as her gaze drifts south.>$B$BWe thought de spirits be angry wit us; we did not suspect it be Zalazane slowly cuttin\' us off from dem. We knew he be strong, but not dat strong... and by de time his voodoo had reached de other isles, we was powerless ta stop \'im. ',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49869,'How did you escape Zalazane?','How did you escape Zalazane?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49870,'','<Zen\'tabra closes her eyes and shakes her head.>$B$BWhen Vol\'jin called for everyone ta flee, we... we couldn\'t face de tribe after failing dem so badly. So, we fled south, ta de untamed jungle islands.$B$BDe wilds claimed a few o\' us dat first night. We found safety in a deep cave in de center o\' de isle, but me dreams dere were not peaceful: I be havin\' a vision!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49871,'What was the vision?','What was the vision?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49872,'The battle is about to begin!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49873,'|TInterface\\Icons\\spell_fire_flamebolt.blp:32|t  Use Your Fire Blast to incinerate Twilight Shadowdrakes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49874,'','<Zen\'tabra\'s head snaps back to you, her eyes bright and her smile wide around her tusks.>$B$B\'Twas a jungle bigger and wilder dan I ever seen! And before me, de ancient raptor loa only talked about in Zandalari tales-Gonk, de Great Hunter! $B$BDe raptor spirit spoke ta me, told me he had brought me spirit to a place called de Emerald Dream. De spirit had been trapped, like de other loa on de Echo Isles, by Zalazane\'s magic. But Gonk, bein\' an ancient spirit, was able ta reach across and bring me spirit ta him, even through Zalazane\'s voodoo. ',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49875,'|TInterface\\Icons\\ability_druid_ravage.blp:32|t  When your enemies are weak, tear them from the sky with your Finishing Strike!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49876,'What did the spirit want?','What did the spirit want?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49877,'|TInterface\\Icons\\spell_nature_healingway.blp:32|t  Your Lifebinder Boon will heal others while restoring your health and mana.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49878,'','Zalazane\'s mindless servants were killin\' all de beasts o\' de isles, burnin\' up de trees and plants too. Gonk needed us ta save de life on de isles. But since we not be able ta draw upon de power o\' de loa wit Zalazane in power, Gonk be showin\' us a new way ta connect wit ALL de spirits o\' nature, ta work WIT de spirits, not just be servin\' a single loa at a time. $B$BIt be difficult at first, ya, mon, but Gonk be showin\' us how ta also reach inta de Emerald Dream ta speak wit de spirits and learn from dem directly!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49879,'How did the other loa react to this?','How did the other loa react to this?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49880,'','<Zen\'tabra laughs.>$B$BDe other loa, \'specially Shirvallah, did not much care for dis plan. Dey still be wantin\' us ta work just for one o\' dem at a time, not wit all de spirits at once. But Gonk had forced dere hands, and dey knew it was de only way ta save de isles while Zalazane still ruled.$B$BI be tinkin\' dat Gonk did not care for de other loa much either. He be teasin\' de other loa all de time while we be learnin\' from dem.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49881,'So what happened then?','So what happened then?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49882,'','We been workin\' wit de spirits for many moons now, mon, but many o\' us already knew de forms o\' de loa we served before. It not be easy, but de Emerald Dream be a powerful teacher by itself-havin\' de spirits demselves also teachin\' ya... it hurries tings along.$B$BDat don\'t mean \'twas easy keepin\' safe from Zalazane. Even wit our new tricks combined wit de loa givin\' what help dey could, we lost a few bruddas and sistas over de years ta his voodoo and mindless servants. But we kept de life o\' de isles alive, and when Vol\'jin and de Darkspears returned, we knew just how ta take Zalazane down.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49883,'So are the loa still holding to their side of the deal?','So are the loa still holding to their side of the deal?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49884,'','Ya, mon, for now. Dey not be too keen on teachin\' many more o\' our kind, but dey be helpin\' us \'long as we be keepin\' de life o\' de isles flourishin\'. When Gonk left after de fall o\' Zalazane, he be tellin\' us how ta contact him if de other loa don\'t keep dey end o\' de bargain.$B$BI be hopin\' it never come ta dat... but just in case, we be openin\' up channels wit dat Cenarion Circle group. $B$B<Zen\'tabra cackles madly.>$B$BOh, ya shoulda seen de look on dat night elf\'s face....',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49885,'Most of my men were killed while infiltrating the Neferset borders.$B$BIt is my duty to make that sacrifice count for something.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49886,'Hurry, $n, deploy the Town-In-A-Box. Our people are trapped inside! Oh! I almost forgot your parachute.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49887,'This is the longest day of my life.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(49888,'Hobart\'s right behind you, $g sir : ma\'am;.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49889,'Be healed, $g brother:sister;!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49890,'AND I LAY MY HANDS UPON YOU!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49891,'Let the Holy Light embrace you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49892,'BY THE LIGHT BE RENEWED!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49893,'FIGHT ON, $G BROTHER:SISTER;!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49894,'It\'s really quite simple, $n. Just attach these fireworks to the wild cluckers and I\'ll use this controller to fly them into the cage.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49895,'I could use a heal, brother!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49896,'Make yourself useful and heal me, Paxton!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49897,'HELP!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49898,'I need a heal!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49899,'Now get us some real eggs.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49900,'Don\'t underestimate the Mechachicken, $n. After all, it is a Hobart Grapplehammer invention!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49901,'Scrying','Scrying',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49902,'Are you enjoying Pilgrim\'s Bounty, $n?  Let me know if you need help finding anything.','Are you enjoying Pilgrim\'s Bounty, $n?  Let me know if you need help finding anything.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(49903,'Happy Pilgrim\'s Bounty, $c!','Happy Pilgrim\'s Bounty, $c!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(49904,'Hello there, $n.  Happy Pilgrim\'s Bounty!','Hello there, $n.  Happy Pilgrim\'s Bounty!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(49905,'Are you enjoying Pilgrim\'s Bounty, $n?  Let me know if you need help finding anything.','Are you enjoying Pilgrim\'s Bounty, $n?  Let me know if you need help finding anything.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(49906,'Happy Pilgrim\'s Bounty, $c!','Happy Pilgrim\'s Bounty, $c!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(49907,'Hello there, $n.  Happy Pilgrim\'s Bounty!','Hello there, $n.  Happy Pilgrim\'s Bounty!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(49908,'Are you enjoying Pilgrim\'s Bounty, $n?  Let me know if you need help finding anything.','Are you enjoying Pilgrim\'s Bounty, $n?  Let me know if you need help finding anything.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49909,'Happy Pilgrim\'s Bounty, $c!','Happy Pilgrim\'s Bounty, $c!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49910,'Hello there, $n.  Happy Pilgrim\'s Bounty!','Hello there, $n.  Happy Pilgrim\'s Bounty!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49911,'','$n, get to the Mechashark X-Steam Controller. Rid us of the Hammer menace!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49912,'Has Pilgrim\'s Bounty got you in the shopping spirit, $c?  Well, you have come to the right place!','Has Pilgrim\'s Bounty got you in the shopping spirit, $c?  Well, you have come to the right place!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(49913,'Has Pilgrim\'s Bounty got you in the shopping spirit, $c?  Well, you have come to the right place!','Has Pilgrim\'s Bounty got you in the shopping spirit, $c?  Well, you have come to the right place!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(49914,'Has Pilgrim\'s Bounty got you in the shopping spirit, $c?  Well, you have come to the right place!','Has Pilgrim\'s Bounty got you in the shopping spirit, $c?  Well, you have come to the right place!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49915,'Thank the Light!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(49916,'Bless you, hero!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(49917,'I will fear no evil!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(49918,'I live to fight another day!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(49919,'I... I\'m ok! I\'m ok!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(49920,'Happy Winter Veil, $n!','Happy Winter Veil, $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(49921,'A happy Winter Veil to you, $c!','A happy Winter Veil to you, $c!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(49922,'You\'re $n! The hero that everyone has been talking about! Thank you!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(49923,'Looking for the perfect Winter Veil gift, $c, or are you just here to treat yourself?','Looking for the perfect Winter Veil gift, $c, or are you just here to treat yourself?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(49924,'I hope you are having a wonderous Winter Veil, $n!','I hope you are having a wonderous Winter Veil, $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(49925,'Happy Winter Veil, $n!','Happy Winter Veil, $n!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(49926,'A happy Winter Veil to you, $c!','A happy Winter Veil to you, $c!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(49927,'Looking for the perfect Winter Veil gift, $c, or are you just here to treat yourself?','Looking for the perfect Winter Veil gift, $c, or are you just here to treat yourself?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(49928,'I hope you are having a wonderous Winter Veil, $n!','I hope you are having a wonderous Winter Veil, $n!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(49929,'Hail, $n.  We\'re in need of your assistance.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(49930,'Happy Winter Veil, $n!','Happy Winter Veil, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49931,'A happy Winter Veil to you, $c!','A happy Winter Veil to you, $c!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49932,'Looking for the perfect Winter Veil gift, $c, or are you just here to treat yourself?','Looking for the perfect Winter Veil gift, $c, or are you just here to treat yourself?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49933,'I hope you are having a wonderous Winter Veil, $n!','I hope you are having a wonderous Winter Veil, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49934,'The marketing research Megs has conducted suggests that a naga invasion is imminent!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49935,'Happy Lunar Festival, $n!','Happy Lunar Festival, $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(49936,'May your elders bless you, $n, and bring you luck in the coming year.','May your elders bless you, $n, and bring you luck in the coming year.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(49937,'Congratulations and may you be prosperous, $c.','Congratulations and may you be prosperous, $c.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(49938,'','You hear that, naga? $n is on $g his : her; way to settle our \"negotiations\"!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49939,'May this Lunar Festival and season be good to you, $c.','May this Lunar Festival and season be good to you, $c.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(49940,'Happy Lunar Festival, $n!','Happy Lunar Festival, $n!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(49941,'May your elders bless you, $n, and bring you luck in the coming year.','May your elders bless you, $n, and bring you luck in the coming year.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(49942,'Congratulations and may you be prosperous, $c.','Congratulations and may you be prosperous, $c.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(49943,'May this Lunar Festival and season be good to you, $c.','May this Lunar Festival and season be good to you, $c.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(49944,'Happy Lunar Festival, $n!','Happy Lunar Festival, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49945,'May your elders bless you, $n, and bring you luck in the coming year.','May your elders bless you, $n, and bring you luck in the coming year.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49946,'Congratulations and may you be prosperous, $c.','Congratulations and may you be prosperous, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49947,'May this Lunar Festival and season be good to you, $c.','May this Lunar Festival and season be good to you, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49948,'We can discuss the cut after you come back with the hides. I\'m thinking ninety-ten.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49949,'Happy Brewfest, $n!','Happy Brewfest, $n!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(49950,'Enjoying the Midsummer Fire Festival, $c?','Enjoying the Midsummer Fire Festival, $c?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(49951,'','Everybody loves a pool pony. It\'s our fastest selling toy behind the Kablooey Bombs: Infant Edition.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49952,'Festive Midsummer, $c!','Festive Midsummer, $c!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(49953,'Midsummer Fire Festival is a great time to adventure, but it\'s also a great time to shop!','Midsummer Fire Festival is a great time to adventure, but it\'s also a great time to shop!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(49954,'Merry Midsummer, $n!','Merry Midsummer, $n!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(49955,'Enjoying the Midsummer Fire Festival, $c?','Enjoying the Midsummer Fire Festival, $c?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(49956,'Festive Midsummer, $c!','Festive Midsummer, $c!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(49957,'Midsummer Fire Festival is a great time to adventure, but it\'s also a great time to shop!','Midsummer Fire Festival is a great time to adventure, but it\'s also a great time to shop!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(49958,'Merry Midsummer, $n!','Merry Midsummer, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49959,'Enjoying the Midsummer Fire Festival, $c?','Enjoying the Midsummer Fire Festival, $c?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49960,'Festive Midsummer, $c!','Festive Midsummer, $c!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49961,'Midsummer Fire Festival is a great time to adventure, but it\'s also a great time to shop!','Midsummer Fire Festival is a great time to adventure, but it\'s also a great time to shop!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49962,'Are you having a good time during Brewfest, $c?','Are you having a good time during Brewfest, $c?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(49963,'When you are at the Brewfest grounds, have a drink for me, $c!','When you are at the Brewfest grounds, have a drink for me, $c!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(49964,'Have you tried the pretzels at Brewfest?  They are amazing, $c!','Have you tried the pretzels at Brewfest?  They are amazing, $c!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(49965,'Happy Brewfest, $n!','Happy Brewfest, $n!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(49966,'Are you having a good time during Brewfest, $c?','Are you having a good time during Brewfest, $c?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(49967,'When you are at the Brewfest grounds, have a drink for me, $c!','When you are at the Brewfest grounds, have a drink for me, $c!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(49968,'Have you tried the pretzels at Brewfest?  They are amazing, $c!','Have you tried the pretzels at Brewfest?  They are amazing, $c!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(49969,'Happy Brewfest, $n!','Happy Brewfest, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49970,'Are you having a good time during Brewfest, $c?','Are you having a good time during Brewfest, $c?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49971,'When you are at the Brewfest grounds, have a drink for me, $c!','When you are at the Brewfest grounds, have a drink for me, $c!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49972,'Have you tried the pretzels at Brewfest?  They are amazing, $c!','Have you tried the pretzels at Brewfest?  They are amazing, $c!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49973,'','$n, hop into one of those B.C. Eliminators and wipe out the pygmies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49974,'','You\'re going to have to take the fight to them, $n. Look for Izzy just outside their village.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49975,'I cannot help you, $c.','I cannot help you, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49976,'You move with grace, rogue. How may I help you?','You move with grace, rogue. How may I help you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49977,'The Twilight Documents go flying through the air!','',0,0,0,0,0,0,0,0,0,11531,0,0,26124),
(49978,'I\'m in charge of this operation.$B$BI don\'t want to hear any yammering about our transport exploding or our enemies being taller than we are. We\'re professionals and we\'re getting this job done without a hitch.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49979,'Feast ye eyes upon the dreadful, clever, all-powerful, hate-filled, sword-swingin\', face-punchin\', insult-flingin\', and all around handsome, BURGY BLACKHEART.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49980,'Seriously. Feast away. I\'m quite beautiful.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49983,'[DEBUG] I left combat!!!','[DEBUG] I left combat!!!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49984,'Build some defenses before Warden Stillwater arrives!','Build some defenses before Warden Stillwater arrives!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(49985,'Slay Warden Stillwater before you\'re overwhelmed!','Slay Warden Stillwater before you\'re overwhelmed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49986,'Enough fooling around. It\'s time for some hands-on management!','Enough fooling around. It\'s time for some hands-on management!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49987,'What?! No! This lawn... was... mine...','What?! No! This lawn... was... mine...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49988,'<The SI:7 agent is unconscious.>','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(49989,'The shadow sees. Bal\'qwari Og Shadar. The end comes!','The shadow sees. Bal\'qwari Og Shadar. The end comes!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49990,'The sun eclipses. Darkness crawls through earth and ash. The seas are as blood...','The sun eclipses. Darkness crawls through earth and ash. The seas are as blood...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49991,'Fear broils forth from the heart of the infinite... Don\'t make me look! I\'ve seen more than I can stand!','Fear broils forth from the heart of the infinite... Don\'t make me look! I\'ve seen more than I can stand!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49992,'Nothing, nothing, we are nothing. The grasper touches our hearts and clenches his fist.','Nothing, nothing, we are nothing. The grasper touches our hearts and clenches his fist.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49993,'I\'m going in after Erunak. Follow me, $n!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(49994,'Gillari, geth\'shar. Gillari, teko\'shar. It sees. It knows.','Gillari, geth\'shar. Gillari, teko\'shar. It sees. It knows.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49995,'My eyes are opened, yet they see only black.','My eyes are opened, yet they see only black.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49996,'Shethnoth, ol\'goth, grell. Such is the mantra of those who come.','Shethnoth, ol\'goth, grell. Such is the mantra of those who come.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49997,'The harbinger has come. The world heaves.','The harbinger has come. The world heaves.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49998,'You want take Dormus camels?  NO!  MY CAMELS!  DORMUS KILL YOU!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(49999,'Hey, make sure not to walk into that smoker!  The last unfortunate $r to do that didn\'t survive the heat.$b$bThat poor, delicious $r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50000,'I\'m going in after Erunak. Follow me, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50001,'Please, try and be sensitive to an orc\'s condition.  I\'m having a rough couple of days, and I\'d prefer if you kept your comments to yourself.','',274,0,0,0,0,0,0,0,0,0,0,0,26124),
(50002,'I\'d love nothing more than to take down Naz\'jar and her minions, but someone\'s got to cover your back...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(50003,'I\'d love nothing more than to wring that witch\'s neck myself, but someone\'s got to keep these naga off of your back...$b$bDo not fail me, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50004,'Let\'s clean this up and get these boys out. I\'ve got another operation waiting.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50005,'','Your ride\'s waitin\', buddy. Let\'s ditch this place!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(50006,'Press on, friend.$b$bI shall find my way out when strength returns to me.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(50007,'','$n, you gotta get in there and rescue our people!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50008,'','Goblin zombies? The Town-In-A-Box has to be warned!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50009,'Yep! Off we go.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50010,'Easy ... does it...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50011,'Right then. I hate long plane rides. So I\'mma gonna kick in the after-market burners and ignite our entire fuel supply in one go.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50012,'Whatever yeh do... Don\'t. Black. Out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50013,'','Those zombies are slow. You don\'t have to run right through them. Don\'t let them eat your brains, $n!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50014,'What can I do for you, $n?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(50015,'What can I do for you, $n? Need some training?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(50016,'Oh man, zombies?$B$BNeed some training?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(50017,'In spite of our losses here, Hellscream will be pleased to know that the naga general was defeated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50018,'Oh man, zombies?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(50019,'Despite our losses here, the king will be pleased to know that the naga general was defeated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50020,'Nice work deploying the Town-In-A-Box, $n.$B$BNeed any training?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(50021,'Nice work deploying the Town-In-A-Box, $n.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(50022,'Those zombies are so slow. It\'s a turkey shoot out there!$B$BNeed any training before you head out?','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(50023,'Those zombies are so slow. It\'s a turkey shoot out there!','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(50024,'A Town-In-A-Box. Nice!$B$BNeed any training, $n?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(50025,'A Town-In-A-Box. Nice!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(50026,'I\'d watch my step around that machine, $c.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(50027,'Careful, you don\'t want to end up like the last $r that used that machine.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(50028,'That machine is a piece of junk.  But once you are done using it, come see me for your first aid needs, $c.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(50029,'You are really going to risk life and limb on that busted up machine?  There are far more reputable trainers in Orgrimmar.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(50030,'How dare they change our people into zombies and throw them at us!$B$BNeed some training before you go up there and kick their butts?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(50031,'How dare they change our people into zombies and throw them at us!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(50032,'Do you smell the burning?  Do you see the shoes? Can you piece this puzzle together, $c?','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(50033,'Are you sure you don\'t want first aid training?  If you use that machine, I may get a chance to practice my skills on you, $c.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(50034,'The last $c to use that machine got the boot... Or rather, the machine got their boots.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(50035,'We need to give this another try.','We need to give this another try.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50036,'Don\'t touch those boots!  I\'m waiting for the authorities to show up and collect the evidence.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(50037,'Keeping the fusion core stable is taxing nearly all my computational powers.$B$BLet us hope that floating-point error got worked out during my last maintenance cycle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50038,'A Town-In-A-Box. Are we not the greatest tinkers in the world?$B$BNeed any training, my young protege?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(50039,'A Town-In-A-Box. Are we not the greatest tinkers in the world?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(50040,'That\'s some nice work there!','',0,0,0,0,0,0,432,1,0,0,0,0,26124),
(50041,'Hmm... interesting choice of parts.','',0,0,0,0,0,0,432,1,0,0,0,0,26124),
(50042,'Boy I wish I had a ride like this!','',0,0,0,0,0,0,432,1,0,0,0,0,26124),
(50043,'I bet this baby has got some real orcpower inside.','',0,0,0,0,0,0,432,1,0,0,0,0,26124),
(50044,'This probably isn\'t a smooth ride, but I bet I\'d look smooth in this ride.','',0,0,0,0,0,0,432,1,0,0,0,0,26124),
(50045,'The flag is a nice touch.  I bet a few more accessories will really make this rocket stand out.','',0,0,0,0,0,0,273,1,0,0,0,0,26124),
(50046,'Goblin zombies? Goblin zombies! Wreck those pygmies, $n!$B$BNeed any training before you go?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(50047,'Goblin zombies? Goblin zombies! Wreck those pygmies, $n!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(50048,'','Great work getting this place going, $n!',273,0,0,0,0,0,0,0,0,0,0,0,26124),
(50049,'','You gotta do something about these pygmies, $n!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(50050,'There was a time when I could ask whatever I wished from those who sought out my master.  But now, he takes pretty much anyone in as an apprentice and they can pass through his portals all they please.$B$BIt is upsetting to me, but I do not question his orders.  I can only take enjoyment in making fun of the ridiculous clothes you wear or the pathetic look on your face.  Even that bores me...$B$BEven this rambling bores me!  Go. Be gone. Share your depressing sense of style with someone else.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50051,'','How much did you charge to deploy this place?$B$BWant to spend some of that moolah on training?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(50052,'','How much did you charge to deploy this place?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(50053,'','Zombies, goblin or not, are an abomination in the eyes of the Light. Besides, there\'s no profit in them.$B$BNot yet anyway.$B$BNeed any training, $n?',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(50054,'','Zombies, goblin or not, are an abomination in the eyes of the Light. Besides, there\'s no profit in them.$B$BNot yet anyway.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(50055,'','Deploying an urban setting in the middle of the wild. I love it!$B$BNeed any training, $n?',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(50056,'','Deploying an urban setting in the middle of the wild. I love it!',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(50057,'You\'ll find Ergll to the northeast. This should help you get across the bay more quickly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50058,'','Can you sneak up on zombies? Don\'t they smell your brains when you get close?$B$BHalf the people around here have nothing to worry about then.$B$BNeed any training, $n?',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(50059,'','Can you sneak up on zombies? Don\'t they smell your brains when you get close?$B$BHalf the people around here have nothing to worry about then.',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(50060,'Warrior-Matic NX-01 is offline.','',33,0,0,0,0,0,0,0,1,0,0,0,26124),
(50061,'Warrior-Matic NX-01 destroy!$B$BInsert coins for further instructional training.','',33,0,0,0,0,0,0,0,1,0,0,0,26124),
(50062,'Warrior-Matic NX-01 is online.$B$BInsert coins for further instructional training.','',33,0,0,0,0,0,0,0,1,0,0,0,26124),
(50063,'Warrior-Matic NX-01 is offline.','',33,0,0,0,0,0,0,0,1,0,0,0,26124),
(50064,'I\'ve come too far to be chased off by a few undead bullies.','I\'ve come too far to be chased off by a few undead bullies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50065,'Everyone\'s a critic, ladies.','',0,0,0,0,0,0,396,1,0,0,0,0,26124),
(50066,'When you are a genius, you have to put up with a lot of strange actions.','',0,0,0,0,0,0,396,1,0,0,0,0,26124),
(50067,'I want to see how long I can last against the waves of undead.','I want to see how long I can last against the waves of undead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50068,'Ladies, ladies... It\'s going to be alright.  I\'ve already captured the creature\'s essence in my painting.','',0,0,0,0,0,0,396,1,0,0,0,0,26124),
(50069,'It\'ll be okay ladies.  Just look at my painting and remember better days.  Or you can just look at me and imagine a better future.','',0,0,0,0,0,0,396,1,0,0,0,0,26124),
(50070,'Well that\'s one way to voice your opinion.','',0,0,0,0,0,0,396,1,0,0,0,0,26124),
(50071,'Ladies, please.  The boar will live on in my art.  Please don\'t shed another tear, unless it is because my art moves you so.','',0,0,0,0,0,0,396,1,0,0,0,0,26124),
(50072,'Get in there and show those zombies what the Bilgewater Buccaneers are made of, kid!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50073,'','It\'s amazing!',0,0,0,0,0,0,5,1,0,0,0,0,26124),
(50074,'','Sooo lifelike!',0,0,0,0,0,0,5,1,0,0,0,0,26124),
(50075,'','It\'s looks just like it!',0,0,0,0,0,0,21,1,0,0,0,0,26124),
(50076,'','It\'s beautiful!',0,0,0,0,0,0,5,1,0,0,0,0,26124),
(50077,'','Absolutely stunning!',0,0,0,0,0,0,396,1,0,0,0,0,26124),
(50078,'','The colors are so vivid!',0,0,0,0,0,0,396,1,0,0,0,0,26124),
(50079,'','I\'ve never seen something so beautiful in all my life!',0,0,0,0,0,0,24,1,0,0,0,0,26124),
(50080,'','You should paint me sometime, Sudsy.',0,0,0,0,0,0,17,1,0,0,0,0,26124),
(50081,'Remember, look for the pygmy leaders: Gaahl, Malmo, and Teloch.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50082,'','Look for the mounds of glowing stuff on the ground.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50083,'You\'re going to love this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50084,'That Schnottz is a madman! I ain\'t never goin\' back!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(50085,'Oh, like you coulda done any better.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(50086,'Take your time, my $g boy : girl;. Now what can I modify this shredder boot to be? Hmm.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50087,'I\'ve set the Bootzooka to fire several rockets per shot. I\'m fairly certain that I perfectly calibrated the targeting.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50088,'','Greetings, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50089,'All those dragon essences I\'ve collected... the power... is exhilerating!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50090,'You can\'t take this away from me!  Not now, not ever!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50091,'Flintlocke, if we have a big giant cannon, why don\'t we just shoot ... a cannonball?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(50092,'But once ol\' $p here blasts through their bulkhead in a hail of splintered wood, blood, and phlegm then starts crawlin\' across the deck with both legs broken, oh aye, they\'ll not see THAT comin\' by a sweet mile, no sir!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(50093,'I specialize in two things: taking tiny things and making them blow up into huge things, and making huge things fit into itty-bitty places.$b$bWhich one do you need today?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50094,'','Deliver justice for our dead, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50095,'','Goblin grenades versus gnomish land mines. Show them who\'s better, $n!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50096,'','You honor us with your actions on behalf of our dead, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50097,'','I forget... did you take flying lessons back on Kezan?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50098,'','It is no use.  My magic is ineffective on these creatures.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50099,'','Better hurry up, $n. I think that Thrall has news on where our people are being held.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50100,'Run, Bastia! Get $n to Sky Falls and the labor mine.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50101,'','Greely drools a little as she continues her mindless labor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50102,'','We\'ve got to get our people out of here, $n! The key is to get them to drink plenty of Kaja\'Cola Zero-One!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50103,'','$n, we need to escape through the northern tunnel!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50104,'','Hold on!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50105,'','Get rid of those Steamwheedle Sharks before they trounce us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50106,'We\'re gonna make you the ultimate footbomb uniform, kid. But first, we need parts. Lots of them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50107,'','You cannot let him walk all over you like that! Go get his heart, girl!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50108,'I never liked that guy. He stole your girlfriend. I say, good riddance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50109,'','It\'s time for a little sabotage!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50110,'We need oil and lots of it if we\'re going to get your footbomb uniform running, kid!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50111,'','Deliver the footbomb uniform to the Slave Pits. Hurry, $n!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50112,'Booster rockets for cages. What will I think of next? I am a genius!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50113,'There\'s nothing I hate more than mercenaries. They are without honor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50114,'','First she left you for Chip, and now the Trade Prince! She was never good enough for you, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50115,'','She stole your man, girlfriend! You know what you gotta do!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50116,'Victory or death, $c!','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(50117,'[Right-Click] |cFFFFFFFFon Injured Stormwind Infantry that you find in the north field.|r','[Right-Click] |cFFFFFFFFon Injured Stormwind Infantry that you find in the north field.|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50118,'','Rise from the grave and serve the Dark Lady!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(50119,'','In the name of Sylvanas, the Banshee Queen, I bestow this gift upon you!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(50120,'','Rise from death\'s slumber and join your brothers!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(50121,'','Waken, sleeper. Your new life awaits.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(50122,'','You are returned to life. The Banshee Queen asks for your service.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(50123,'Oh come on! What about us?!','Oh come on! What about us?!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(50124,'You\'re kidding, right? You came all the way here for THAT?!','You\'re kidding, right? You came all the way here for THAT?!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(50125,'Hey bud, I\'ll sell ya my wife if you get me outta here. She won\'t mind!','Hey bud, I\'ll sell ya my wife if you get me outta here. She won\'t mind!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(50126,'Let\'s see, I just saw a corpse with a jaw that would fit you...','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(50127,'That should do the job. Come back right away if it falls off again.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(50128,'T-thank you, Undert-t-taker.','',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(50129,'The end of all things is upon us!','The end of all things is upon us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50130,'Behold the powers of the master!','Behold the powers of the master!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50131,'You only delay the inevitable.','You only delay the inevitable.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50132,'I bask in the twilight.','I bask in the twilight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50133,'Your life is meaningless. ','Your life is meaningless. ',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50134,'A waste of my time...','A waste of my time...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50135,'Give in. ','Give in. ',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50136,'You will make an excellent sacrifice.','You will make an excellent sacrifice.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50137,'Do you not feel the master\'s gaze?! It watches us all!','Do you not feel the master\'s gaze?! It watches us all!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50138,'The master will end everything! ','The master will end everything! ',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50139,'All will fall to the master\'s call....','All will fall to the master\'s call....',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50140,'This is the end... for you, and for the world.','This is the end... for you, and for the world.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50141,'Embrace the coming of the end!','Embrace the coming of the end!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50142,'I will prove myself to the master!','I will prove myself to the master!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50143,'Whispers... whispers... I can hear the whispers.... ','Whispers... whispers... I can hear the whispers.... ',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50144,'Biting... clawing... clutching... tearing...','Biting... clawing... clutching... tearing...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50145,'Rrrr... kill! Eat! ','Rrrr... kill! Eat! ',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50146,'Guuuurarrrrgh!','Guuuurarrrrgh!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50147,'Me... break... ','Me... break... ',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50148,'Grrr... crush!','Grrr... crush!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50149,'Kill! Kill! Kill!','Kill! Kill! Kill!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50150,'Rarrrargh! Rip! Rip!','Rarrrargh! Rip! Rip!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50151,'Aaaaraaaargh!','Aaaaraaaargh!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50152,'Me... smash!','Me... smash!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50153,'To the crushing depths with you!','To the crushing depths with you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50154,'These waters were ours even before the Sundering!','These waters were ours even before the Sundering!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50155,'Tides take you!','Tides take you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50156,'These waters will be your grave. ','These waters will be your grave. ',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50157,'A curse upon your kind, trespasser! ','A curse upon your kind, trespasser! ',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50158,'Tides, give me strength!','Tides, give me strength!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50159,'I will crush the breath from your lungs!','I will crush the breath from your lungs!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50160,'You will never take these waters from us!','You will never take these waters from us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50161,'Blasted Horde! ','Blasted Horde! ',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50162,'Waste your energy on the Twilight\'s Hammer, monster, not us!','Waste your energy on the Twilight\'s Hammer, monster, not us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50163,'If you want a fight, you\'ll get one!','If you want a fight, you\'ll get one!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50164,'Confounded beasts! You\'ll pay for what you did to our fleet!','Confounded beasts! You\'ll pay for what you did to our fleet!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50165,'Begone from here, Horde filth!','Begone from here, Horde filth!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50166,'Where\'s your \"honor\" now, Horde scum?','Where\'s your \"honor\" now, Horde scum?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50167,'You Horde are as bad as the Twilight\'s Hammer!','You Horde are as bad as the Twilight\'s Hammer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50168,'This land belongs to the Alliance, Horde wretch! Away with you!','This land belongs to the Alliance, Horde wretch! Away with you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50169,'Killin\' time! ','Killin\' time! ',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50170,'Ah, I be needin\' a new shrunken head....','Ah, I be needin\' a new shrunken head....',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50171,'Relax, mon, I be makin\' dis quick.','Relax, mon, I be makin\' dis quick.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50172,'Ya be trespassin\' on our land now, mon.','Ya be trespassin\' on our land now, mon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50173,'De Shatterspears own dese lands, and ya not be welcome!','De Shatterspears own dese lands, and ya not be welcome!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50174,'HA! Let\'s at least keep it interesting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50175,'I be stabbin\' first and askin\' later!','I be stabbin\' first and askin\' later!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50176,'We gonna be dancin\' on ya grave tonight, mon!','We gonna be dancin\' on ya grave tonight, mon!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50177,'I be movin\' to de groove; ya be movin\' to de grave!','I be movin\' to de groove; ya be movin\' to de grave!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50178,'This is just too easy...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50179,'Ungh!','Ungh!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50180,'Oof!','Oof!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50181,'Ugh...','Ugh...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50182,'','Your skill at range would be best suited to the fight higher up. Use your hooks to ascend to one of the upper Vermillion Skyscreamers, then pick off the circling Pyrewings from there.',0,0,0,0,0,0,1,0,0,7152,0,0,26124),
(50183,'The drake under you is mortally wounded and about to fall! Move to another drake, quickly!\n\n|TInterface\\Icons\\inv_misc_hook_01.blp:32|t','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50184,'Keep it up.','Keep it up.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50185,'Here\'s some more water.','Here\'s some more water.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50186,'We\'ll keep the buckets coming.','We\'ll keep the buckets coming.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50187,'Over there! The fire\'s flarin\' up!','Over there! The fire\'s flarin\' up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50188,'We\'ve got your back.','We\'ve got your back.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50189,'Ready for some more?','Ready for some more?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50190,'We\'re not done yet.','We\'re not done yet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50191,'','Vanessa begins throwing poison vials!  Climb up quickly!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50192,'You\'ve been bitten by a worgen.  It\'s probably nothing, but it sure stings a little.$B$B|TInterface\\Icons\\INV_Misc_monsterfang_02.blp:32|t','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50193,'A chest is revealed near the rear entrance!','A chest is revealed near the rear entrance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50194,'What... what\'s happening to me? Why have you done this to me?','',6,0,0,0,0,0,6,0,0,0,0,0,26124),
(50195,'I should be dead and to death I will return!','',5,0,0,0,0,0,5,0,0,0,0,0,26124),
(50196,'This is Lady Sylvanas\'s doing?','',6,0,0,0,0,0,6,0,0,0,0,0,26124),
(50197,'What magic is this that turns back the hand of death?','',6,0,0,0,0,0,6,0,0,0,0,0,26124),
(50198,'I... I don\'t remember... Why have you done this?','',6,0,0,0,0,0,6,0,0,0,0,0,26124),
(50199,'What use has the Dark Lady for me?','',6,0,0,0,0,0,6,0,0,0,0,0,26124),
(50200,'If the Banshee Queen has offered me this chance, I will gladly serve.','',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(50201,'I never asked for this! Leave me alone!','',5,0,0,0,0,0,5,0,0,0,0,0,26124),
(50202,'Ha! You throw like my greatmother.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(50203,'Watch and learn, pup.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(50204,'Prepare to witness perfection.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(50205,'Not bad... you might be able to hit the broad side of a sickly kodo.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(50206,'This one\'s going straight through.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(50207,'Two silver says I can split that arrow down the shaft.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(50208,'These dragons aren\'t messin\' around. I\'m not sure all of these scrubs know what they\'re in for.$B$BWe\'ll be fine though. My boys can lead the charge and get this job done. All we need is some space to work.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50209,'When you are ready, touch the altar to begin.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50210,'When the trial begins, shadows from under you will periodically break free, traveling to a nearby portal to summon a Weeping Soul.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50211,'The Weeping Souls may be frightening, but they are somewhat predictable. Lure them into the rune traps spread across the ground.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50212,'Each time you successfully trap a Weeping Soul, you will receive a stack of Shadow Bait.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50213,'Each time a Weeping Soul strikes you, you will lose a stack of Shadow Bait.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50214,'Attain 20 stacks of Shadow Bait to complete the trial.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50215,'...','...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50216,'Every few seconds, many of the nearby runes will burst with fire.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50217,'As each rune bursts, a bolt of fire will travel to one or more nearby runes, triggering it to be one of the next runes to burst.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50218,'If you watch these bolts of fire closely to see which runes are not hit, you can spot safe spots for the next burst.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50219,'Occassionally, some runes will fizzle with black smoke, preventing them from firing during the following burst.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50220,'Stay within the runes without getting hit by fire until you have 10 stacks of Fire Dancing to complete the trial.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50221,'Beware: straying from the runes for too long or getting hit by multiple bursts in a row will require you to start over.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50222,'Spread across the plateau are frost orbs that will grant you stacks of Essence of Ice if you approach them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50223,'Avoid the rotating frost burn effects, or you will take damage and lose a stack of Essence of Ice.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50224,'The frost runes on the ground will fling you into the air if you touch them, which can be a boon or an inconvenience.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50225,'Do not stray too close to the chilled ground or you will find moving significantly more strenuous.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50226,'Be nimble, think ahead, and give dangers a wide berth, and gather 20 stacks of Essence of Ice to complete this trial.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50228,'Spread across the ledge of the Arcane Pinnacle are 6 pedestals that will energize you if touched.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50229,'Using the energy pads on the ground, ascend the Arcane Pinnacle, touching all the pedestals along the way.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50230,'Keep moving or you will risk being hit by arcane detonations that will hurl you into the waters below.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50231,'If you fall into the water below, don\'t be discouraged. Swim back to the first ledge and start again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50232,'Reach the top of the Arcane Pinnacle with 6 stacks of Energized to complete the trial.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50233,'Welcome to Fuselight-by-the-Sea, a picturesque seaside town founded by explosives enthusiasts for explosives enthusiasts.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(50234,'I\'d like to make this my home.','I\'d like to make this my home.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50235,'Well, hop to it then!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50236,'How does the Trial of Frost work?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50237,'How does this work exactly?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50238,'How does the Trial of Fire work?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50239,'How does the Trial of Shadow work?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50240,'Good work. I\'ll keep the men pushing from here. Move forward and take the last gate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50241,'Good work. I\'ll keep the men pushing from here. Move forward and take the last gate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50242,'|TInterface\\Icons\\INV_FIREARM_2H_RIFLE_CATACLYSM_B_01.BLP:20|t%s begins to cast |cFFFF0000|Hspell:93520|h[Pistol Barrage]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50243,'','Here we go. Hold on tight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50244,'','Watch those tentacles! Their reach is frightening.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50245,'','NOO! Let go you filthy beast!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50246,'Hey, Zak, what\'s the average life-expectancy for one of your explosive analysts?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(50247,'That bad, eh?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(50248,'With that new super-charged elementium blasting powder? You don\'t want to know...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50249,'','Baleflame! Your tender flesh shall be an appropriate meal for my whelps!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(50250,'Come, my children! Awaken and feast upon their flesh!','Come, my children! Awaken and feast upon their flesh!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50251,'Hatch and rise, carry out the legacy of the Black Dragonflight!','Hatch and rise, carry out the legacy of the Black Dragonflight!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50252,'Bathe in the flaming blood of the earth!','Bathe in the flaming blood of the earth!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50253,'Burn!','Burn!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50254,'No! My clutch is the last...! Father... I\'ve failed you...','No! My clutch is the last...! Father... I\'ve failed you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50255,'I didn\'t sign up for this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50256,'Hey, nothin\' personal, but you gotta die.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50257,'It\'s me or you, buddy, and it ain\'t gonna be me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50258,'Gimme all ya got, and I\'ll make it quick.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50259,'I got orders sayin\' you gotta die, and you\'re not the one payin\' my bills.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50260,'Time for you to take a long nap in the sand....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50261,'I love gettin\' paid for this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50262,'Bah, I\'m not gettin\' paid enough for this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50263,'They\'re turning our people into MONSTERS!!','They\'re turning our people into MONSTERS!!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50264,'Hold them back!  We must protect the survivors!','Hold them back!  We must protect the survivors!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50265,'Don\'t look into their eyes!  They\'re not the people you once knew!','Don\'t look into their eyes!  They\'re not the people you once knew!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50266,'Welcome to the Shrine of Aviana, $c. Here we sit atop the world and touch the sky.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(50267,'Ah, $n! We meet once more. I helped you attain your swift flight form in Outland.$B$B<Morthis tightens his jaw and shakes his head, his withered eyes sad.>$B$BThese young druids today... they have it too easy.','',1,274,0,0,0,0,0,0,0,0,0,0,26124),
(50268,'','I get a lot of mail, $n. Most of it is junk, but some of them might be helpful to a helpful $c like you. Here\'s a couple letters sent to Everlook, looking for help in the far corners of the world.$b$bIt\'s almost as if you have a choice for where you go next!  Now, let\'s see...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50269,'','That statue\'s provin\' ta be quite the pain.  I thought we could lift it up an\' outta the water with a crane an\' some well timed explosives.  But Wick thought we\'d be safer an\' do less damage by rolling it up this ramp.$B$BNow look at it...  We\'ve got it angled all wrong.  An\' once we get it to the top, then what?$B$BI\'ve gotta bad feeling we\'re gonna to be here a long time.  A real long time...',1,5,0,0,3,0,0,7,1,0,0,0,26124),
(50270,'You think after doing such good work on Stormwind Harbor I\'d get a bit of slack from this dwarf...$B$BI just want to get this statue up the ramp and back in place as fast as possible.  But she\'s got a complaint every step of the way.  Her solution to every problem is to blow it up.  It feels like I\'m working with a gnome or a goblin.  But at least they\'d be sober.$B$BLook at our work crew, no discipline.  You know why?  Because she undermines me!$B$BA bad attitude, a lazy crew... This isn\'t going to be a quick fix at all.','',1,5,0,0,3,0,0,0,1,0,0,0,26124),
(50271,'The Cenarion Circle been around a long time, mon. We trolls are newcomers to this party.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50272,'I guess that\'s the way...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50273,'...the cookie crumbles.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50274,'','The pitiful human escaped!',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(50275,'','COWARD!',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(50276,'|TInterface\\Icons\\spell_frost_frostnova.blp:20|t The wedding party is afflicted with |cFFFF0000|Hspell:91978|h[Cold Feet]|h|r!','|TInterface\\Icons\\spell_frost_frostnova.blp:20|t The wedding party is afflicted with |cFFFF0000|Hspell:91978|h[Cold Feet]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50277,'I don\'t think a weapon that big is legal in this town...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(50278,'And who do you think you are? I\'ll use as large a weapon as I please!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(50279,'I\'m the warden, and you know that! You\'d better not make any trouble, because I\'ll know the moment that you try anything...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(50280,'Russell Brower begins to play a wedding hymn!  Stand near him to receive its regenerative effects!','Russell Brower begins to play a wedding hymn!  Stand near him to receive its regenerative effects!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50281,'Oh, not that! Look, I\'m quaking in my boots...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(50282,'As most of you know, we\'re about to begin another intensive round of demolitions testing.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(50283,'It won\'t be easy. It\'s true that six out of every seven analysts won\'t live to see Demolitions Analyst II.','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(50284,'The important thing to remember is that we\'re all here because of our love for explosions!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(50285,'So let\'s make every explosion a quality asplosion!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(50286,'|TInterface\\Icons\\spell_holy_prayerofshadowprotection.blp:20|t The Beast Unleashed begins to emit an |cFFFF0000|Hspell:93717|h[Aura of Darkness]|h|r!','|TInterface\\Icons\\spell_holy_prayerofshadowprotection.blp:20|t The Beast Unleashed begins to emit an |cFFFF0000|Hspell:93717|h[Aura of Darkness]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50287,'','Ha ha! I have your Grindgear Gorilla!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50288,'','I wonder if your Grindgear Gorilla can jump across the Park!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50289,'','I have your gorilla! Nyah nyah!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50290,'','I wonder how far the gears turn?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50291,'','If you want him back you\'re gonna have to beg... like a monkey!!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50292,'','Now who\'s the crybaby, crybaby!?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50293,'','Baby wants his dolly!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50294,'','Whoops!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50295,'','So, doctor, how goes your research?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(50296,'We\'re nearing completion on the next batch of high-powered elementium explosives.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(50297,'I\'m hoping this is the breakthrough that will allow us to pack more explosive power into a smaller bomb.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(50298,'No fair!  Gimme back my gorilla!!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50299,'Gimmie back Jum-jump!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50300,'You better not break Jum-jump!  It\'s not fair!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50301,'WAAAHHH!!!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50302,'You\'re being mean!  I\'m telling Mommy!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50303,'Stop twisting his legs, they aren\'t supposed to bend that way!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50304,'You\'re breaking him!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50305,'Stop it! You\'ll break his legs off!','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50306,'The good doctor is being modest. He knows precisely how much powder to put in the charge, down to the very grain.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(50307,'Welcome back to Thundermar, $n. Fighting continues all across the shire, but with Alliance help I think we can gain the upper hand.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(50308,'%s roars wildly, initiating a massive stomp attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50309,'He already knows it will be a smashing success!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(50310,'','To success, then!',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(50311,'Use Eoin\'s mug to replenish your health!','Use Eoin\'s mug to replenish your health!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50312,'Greetings, $c. We Wildhammer reward our friends.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(50313,'','This was one of the royal cities of the elves in the days when Azshara was queen. In this city lie the keys to lore long lost and artifacts of unimaginable historical value. ',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50314,'','The captain and his forces pushed forward to take one of the bases you scouted for him earlier. You should go and meet them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50315,'The totem is halfway finished with taking its sample.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50316,'The totem has finished taking its sample!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50317,'You\'ve succeeded in defending the bridge. The summon ritual has been completed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50318,'Can\'t... lift... tools...','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(50319,'What you do to me?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(50320,'Who am I?','Who am I?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50321,'No make me small!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(50322,'Why everyone else get so big?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(50323,'Repel the intruders!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50324,'I\'ll kill you!','I\'ll kill you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50325,'Look what they\'ve done to me!','Look what they\'ve done to me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50326,'BLEEAAAGGHHH! I\'m a monster, don\'t look at me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50327,'Attention!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(50328,'Bartlett the Brave has set up gryphon roosts here in town.  If you\'re looking to take a ride, then talk to him.','Bartlett the Brave has set up gryphon roosts here in town.  If you\'re looking to take a ride, then talk to him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50329,'You can\'t come in here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50330,'By Kurzen\'s sword!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50331,'Kill the intruder!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50332,'','You\'ll die in this cave!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50333,'Activate the altars to gain the blessings of the elements, but avoid the deadly shadow altar!','Activate the altars to gain the blessings of the elements, but avoid the deadly shadow altar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50334,'Revive your fallen companion by right-clicking on their unconscious body!','Revive your fallen companion by right-clicking on their unconscious body!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50335,'','You have already lost.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50336,'MOLDFANG STRONG!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50337,'For the Wildhammer!','For the Wildhammer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50338,'If you can\'t fight at range, use your Jump Drakes! ability:\n\n|TInterface\\Icons\\ability_vehicle_launchplayer.blp:64|t','If you can\'t fight at range, use your Jump Drakes! ability:\n\n|TInterface\\Icons\\ability_vehicle_launchplayer.blp:64|t',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50339,'','I will kill you, or I will die trying.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50340,'The Wildhammer horn falls from Kurdran\'s unconscious body!','The Wildhammer horn falls from Kurdran\'s unconscious body!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50341,'Die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50342,'Druids?  I haven\'t seen any druids around here.  Although I am sure that in Stormwind you could find one.  You should ask a guard in Stormwind.','Druids?  I haven\'t seen any druids around here.  Although I am sure that in Stormwind you could find one.  You should ask a guard in Stormwind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50343,'The Dragonmaw drums fall from Zaela\'s unconscious body!','The Dragonmaw drums fall from Zaela\'s unconscious body!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50344,'I\'ll fill your corpses with arrows!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50345,'Your pain is my release.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50346,'Blow into the Wildhammer horn to call for reinforcements!','Blow into the Wildhammer horn to call for reinforcements!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50347,'Play the Dragonmaw drums to call for reinforcements!','Play the Dragonmaw drums to call for reinforcements!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50348,'The Scarlet Crusade is not over! Undeath is merely a setback!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50349,'He\'s too powerful!  You\'ve got to find a way to use those altars to give us an edge!','He\'s too powerful!  You\'ve got to find a way to use those altars to give us an edge!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50350,'The Scourge will rise again, under a dark new master... Ix\'lar!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50351,'Man down!  We\'ve got a man down!  Get him back up as soon as you can!','Man down!  We\'ve got a man down!  Get him back up as soon as you can!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50352,'Kurdran is down!  You\'ve got to get him back into the fight or we\'re done for!','Kurdran is down!  You\'ve got to get him back into the fight or we\'re done for!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50353,'Lok\'tar ogar!','Lok\'tar ogar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50354,'Benjamin Foxworthy and his pet, Sly, can be found just behind the smithy, here in Goldshire.  Maybe you should go see if he could help you.','Benjamin Foxworthy and his pet, Sly, can be found just behind the smithy, here in Goldshire.  Maybe you should go see if he could help you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50355,'I\'ll rip out your eyeballs, weakling...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50356,'Active.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50357,'He is too powerful!  Use the altars to harness the powers of the elements and we may stand a chance!','He is too powerful!  Use the altars to harness the powers of the elements and we may stand a chance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50358,'You must tend to the wounded!  Quickly!','You must tend to the wounded!  Quickly!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50359,'Online.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50360,'Zaela has fallen!  Revive her or we will meet our end on this forsaken altar!','Zaela has fallen!  Revive her or we will meet our end on this forsaken altar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50361,'My kin won\'t forget what you\'ve done! We will rage, mortals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50362,'Wildhammer reinforcements have arrived!','Wildhammer reinforcements have arrived!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50363,'Wha... who... GET OUT OF MY DIGSITE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50364,'Dragonmaw reinforcements have arrived!','Dragonmaw reinforcements have arrived!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50365,'So you\'re the ones causing all that ruckus!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50366,'The flames of Ragnaros will burn you all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50367,'A shaman trainer?  Not here in Goldshire.$B$BBut the Wildhammer dwarves in Stormwind\'s Dwarven District may be able to help you out.','A shaman trainer?  Not here in Goldshire.$B$BBut the Wildhammer dwarves in Stormwind\'s Dwarven District may be able to help you out.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50368,'Lok-Narash! To battle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50369,'You dare challenge me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50370,'KREEEEAAGH!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50371,'Stay out of Redridge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50372,'AAAAHHHHH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50373,'You want more? YOU WANT MORE?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50374,'Oh no... I\'m not done with you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50375,'AAAAAAAAHHHHHHHH!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50376,'There\'s nowhere for you to run. The disease is inside you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50377,'Damn these orcs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50378,'Killin\'s as easy as breathin\'.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50379,'See you in hell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50380,'You maggots brought this on yourselves.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50381,'More blood! I want more blood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50382,'My apologies, $c, but the arcane secrets of the Highborne will forever remain secrets to you.','My apologies, $c, but the arcane secrets of the Highborne will forever remain secrets to you.',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(50383,'You fight without HONOR!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50384,'I am the favored of the master Cho\'gall.  I WILL NOT FALL TO YOU.','I am the favored of the master Cho\'gall.  I WILL NOT FALL TO YOU.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50385,'Skullcrusher the Mountain goes into a frenzy!','Skullcrusher the Mountain goes into a frenzy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50386,'We cannot hold out against power of this magnitude!  You must use the horn!','We cannot hold out against power of this magnitude!  You must use the horn!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50387,'He is too powerful!  You must use the drums!','He is too powerful!  You must use the drums!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50388,'Cho\'gall will...rip you...to pieces...','Cho\'gall will...rip you...to pieces...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50389,'Lok\'tar ogar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50390,'Your blood... my axe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50391,'You have many lessons to learn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50392,'You fought without honor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50393,'Ha! I expected a challenge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50394,'There\'s more where that came from. I am a well of rage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50395,'Feel my rage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50396,'And stay down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50397,'This is too easy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50398,'Serve the Dragonmaw and you will be handsomely rewarded, $c.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50399,'Take that! Taste the Light!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50400,'Wow. Is it just me, or did that one die really fast?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50401,'Ahhhhh ha ha haa!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50402,'The magic of today pales in comparison to that of millennia past. Still, we Highborne know much of the arcane. Are you ready to learn?','The magic of today pales in comparison to that of millennia past. Still, we Highborne know much of the arcane. Are you ready to learn?',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(50403,'Did you see that, Tarenar?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50404,'Ka-boom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50405,'FOR CLAN WILDHAMMER!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(50406,'Can we slow down just a bit?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50407,'I can\'t believe we\'re actually fighting for the Crusade!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50408,'Take that, ye beardless coward!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(50409,'When I\'m done with ye, ye won\'t have a toe to stand on!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(50410,'Say goodbye to yer kneecaps, baddie!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(50411,'I\'ve had about enough of this aleless inbreed!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(50412,'|TInterface\\Icons\\spell_holy_healingaura.blp:20|tBaron Ashbury begins to cast |cFFFF0000|Hspell:93468|h[Stay of Execution]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50413,'How\'s about a nice, refreshing ale?!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(50414,'I grow tired of this hunt... Time to die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50415,'Aye, Broland Galebeard, here in Kharanos, can get ya where ya want ta go.','Aye, Broland Galebeard, here in Kharanos, can get ya where ya want ta go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50416,'Do you hear it, $r? Place your ear to the ground. Can you hear the echoing drums of war? The earth trembles in anticipation, yet I have heard it coming all along. We must prepare ourselves, young one - for this shall be a war to end all wars. It will be an honor to serve with you on the battle field. I trust that you will stand ready.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(50417,'I stand vigilant here on these steps where my ancestors thrived. Until now, I have enjoyed a lifetime of freedom. I must do what I can to ensure that my children and my children\'s children live their lives free of the perils of war. Praise be to King Phaoris and all of his heroic efforts for my people. Our people. I can not quite place it, $r, but I trust you. Go now, $gsister:brother;, there is much to do before the skies darken with conflict.\n','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(50418,'Halbin Frosthammer, from the Wildhammer clan, can be found in Thunderbrew Distillery.  He can help teach ya the ways of the shaman.','Halbin Frosthammer, from the Wildhammer clan, can be found in Thunderbrew Distillery.  He can help teach ya the ways of the shaman.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50419,'I smash your mushrooms!','I smash your mushrooms!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50420,'I smash your mushrooms!','I smash your mushrooms!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50421,'I smash your mushrooms!','I smash your mushrooms!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50422,'I smash your mushrooms!','I smash your mushrooms!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50423,'I smash your mushrooms!','I smash your mushrooms!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50424,'I smash your mushrooms!','I smash your mushrooms!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50425,'I smash your mushrooms!','I smash your mushrooms!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50426,'I smash your mushrooms!','I smash your mushrooms!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50427,'I smash your mushrooms!','I smash your mushrooms!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50428,'I smash your mushrooms!','I smash your mushrooms!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50429,'Greetings, $n.','Greetings, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50430,'Looking to fly somewhere?  Anette Williams, in the western part of town, can get you there on one of her trained bats.','Looking to fly somewhere?  Anette Williams, in the western part of town, can get you there on one of her trained bats.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(50431,'The end of all things is upon us!','The end of all things is upon us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50432,'Behold the powers of the master!','Behold the powers of the master!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50433,'Stormwind Cemetery','Stormwind Cemetery',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50434,'You only delay the inevitable.','You only delay the inevitable.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50435,'I bask in the twilight.','I bask in the twilight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50436,'Your life is meaningless. ','Your life is meaningless. ',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50437,'A waste of my time...','A waste of my time...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50438,'Give in. ','Give in. ',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50439,'You will make an excellent sacrifice.','You will make an excellent sacrifice.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50440,'Greetings, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50441,'Do you not feel the master\'s gaze?! It watches us all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50442,'Innkeeper Renee has moved to the large building in the center of town.  It\'s the biggest building in Brill... Very hard to miss.','Innkeeper Renee has moved to the large building in the center of town.  It\'s the biggest building in Brill... Very hard to miss.\n',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(50443,'The master will end everything! ','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50444,'All will fall to the master\'s call....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50445,'This is the end... for you, and for the world.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50446,'Embrace the coming of the end!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50447,'I will prove myself to the master!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50448,'Whispers... whispers... I can hear the whispers....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50449,'Biting... clawing... clutching... tearing...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50450,'I will crush your bones to dust.','I will crush your bones to dust.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50451,'Stones of the earth, obey the call of the Twilight\'s Hammer!','Stones of the earth, obey the call of the Twilight\'s Hammer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50452,'But a pebble against the avalanche...','But a pebble against the avalanche...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50453,'Excellent, another stone to grind!','Excellent, another stone to grind!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50454,'Crush... pound... rend... yes, master...','Crush... pound... rend... yes, master...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50455,'I control the very air you breathe....','I control the very air you breathe....',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50456,'Your screams will carry far on the winds....','Your screams will carry far on the winds....',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50457,'Forecasts call for... your demise.','Forecasts call for... your demise.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50458,'Storms of the sky, obey the call of the Twilight\'s Hammer!','Storms of the sky, obey the call of the Twilight\'s Hammer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50459,'Whispers... whispers in the wind... yes, master...','Whispers... whispers in the wind... yes, master...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50460,'Your death shall be... electrifying.','Your death shall be... electrifying.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50461,'Allow me to catch you up on... current events.','Allow me to catch you up on... current events.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50462,'I\'m afraid I\'ll have to... charge you extra.','I\'m afraid I\'ll have to... charge you extra.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50463,'Lightning above, obey the call of the Twilight\'s Hammer!','Lightning above, obey the call of the Twilight\'s Hammer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50464,'Crackling... howling... the screams... always screaming...','Crackling... howling... the screams... always screaming...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50465,'This world will burn.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50466,'All will be ash.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50467,'Do I look to you like I cast spells?  Well, I did hear that Cain Firesong now hangs out in the laboratory, always working on something unsavory.','Do I look to you like I cast spells?  Well, I did hear that Cain Firesong now hangs out in the laboratory, always working on something unsavory.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(50468,'I just want to set the world on fire....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50469,'Flames below, obey the call of the Twilight\'s Hammer!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50470,'The flames... they lick... they bite... always biting...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50471,'May the Light bless the spirits of our ancestors, for they\'ve chosen to allow my son to rest upon this holy ground.','',0,0,0,0,0,0,1,0,7,0,19713,0,26124),
(50472,'It is here, surrounded by the heroes and patriots of Gilneas where he belongs.','',0,0,0,0,0,0,1,0,7,0,19714,0,26124),
(50473,'We\'ll return, Liam.  I swear this to you.','',0,0,0,0,0,0,66,0,7,0,19715,0,26124),
(50474,'Break, broke, broken! Ahahahahaha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50475,'Burn, burned, burnt! Hahahahaha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50476,'The end is here! The end is now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50477,'Gilneas will remember your courage forever, Liam.','',0,0,0,0,0,0,66,0,7,0,19497,0,26124),
(50478,'I\'m sorry... I\'m sorry... I\'m sorry... I\'m sorry... I\'m sorry...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50479,'I can hear them! Hear them calling! I answer the call! ','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50480,'De Hammer be hungry for ya, mon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50481,'Ya be lookin\' good... in a stew.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50482,'Dey gonna make a fine stew outta ya, mon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50483,'Always be room in de pot for more!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50484,'If ya be lucky, dey eat your head first....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50485,'Ah, you seek Dark Cleric Beryl.  He\'s now resides in the eastern building.','Ah, you seek Dark Cleric Beryl.  He\'s now resides in the eastern building.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(50486,'Yay! Dinner come to ME!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50487,'Mmm... yum yums!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50488,'Me kill you with da truffle shuffle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50489,'Uh oh! You be in double truffle-shuffle trouble now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50490,'You want fight me?! We have triple truffle-shuffle scuffle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50491,'Can me eat you? Me be quick.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50492,'Why you poke me when me eating?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50493,'Marion Call is lurking under the stairs in the inn.','Marion Call is lurking under the stairs in the inn.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(50494,'Me want eat you, but me full. Me kill you instead.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50495,'That\'s Rupert Boch you\'re looking for.  He now resides in the basement of the inn.','That\'s Rupert Boch you\'re looking for.  He now resides in the basement of the inn.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(50496,'Yeah, that would be Austil de Mon.  You will find him standing guard near one of the meatwagons, near the inn.','Yeah, that would be Austil de Mon.  You will find him standing guard near one of the meatwagons, near the inn.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(50497,'Look for The Wyvern\'s Tail, just outside the Hall of the Brave.','Look for The Wyvern\'s Tail, just outside the Hall of the Brave.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(50498,'It\'s across the bridge from the gate to The Drag. Listen for the sound of shouting goblins.','It\'s across the bridge from the gate to The Drag. Listen for the sound of shouting goblins.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(50499,'Skymaster Skyles stands just before the gate to Eversong Woods.','Skymaster Skyles stands just before the gate to Eversong Woods.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(50500,'','It was a pleasure. Stay safe $p.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50501,'It\'s in the Valley of Strength, east of the entrance to Grommash Hold.','It\'s in the Valley of Strength, east of the entrance to Grommash Hold.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(50502,'You will find Lothan Silverblade where you can find weapons and armor.  A warrior is never far from his blade.','You will find Lothan Silverblade where you can find weapons and armor.  A warrior is never far from his blade.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(50503,'Is blood red?','Is blood red?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50504,'Do wolves howl?','Do wolves howl?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50505,'','You have interfered with our plans for the last time, mortals!',0,0,0,0,0,0,0,0,0,0,0,18886,26124),
(50506,'','Depths take you!',0,0,0,0,0,0,0,0,0,0,0,18887,26124),
(50507,'Do murderers kill?','Do murderers kill?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50508,'','The Abyss awaits!',0,0,0,0,0,0,0,0,0,0,0,18888,26124),
(50509,'','Ulthok, stop them...',0,0,0,0,0,0,0,0,0,0,0,18889,26124),
(50510,'','Armies of the depths, wash over our enemies as a tide of death!',0,0,0,0,0,0,0,0,0,0,0,18890,26124),
(50511,'Do maggots feast on corpses?','Do maggots feast on corpses?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50513,'','Take arms, minions! Rise from the icy depths!',0,0,0,0,0,0,0,0,0,0,0,18892,26124),
(50514,'','Destroy these intruders! Leave them for the great dark beyond!',0,0,0,0,0,0,0,0,0,0,0,18893,26124),
(50515,'Nothing frees the spirit like soaring through the sky.  You may speak with Tak, the Wind Rider Master, in the center of the village, if you wish to soar through the air.','Nothing frees the spirit like soaring through the sky.  You may speak with Tak, the Wind Rider Master, in the center of the village, if you wish to soar through the air.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(50516,'Time\'s a wastin, let\'s get to work.','Time\'s a wastin, let\'s get to work.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50517,'Even though we are situatated a distance away from the main island, our mission here is still important.','Even though we are situatated a distance away from the main island, our mission here is still important.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50518,'Gah, the smell of those dirty humans makes me more upset by the second.','Gah, the smell of those dirty humans makes me more upset by the second.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50519,'The peninsula is not a place to be trifled with $r.  Those foul Alliance can be found all over the island.','The peninsula is not a place to be trifled with $r.  Those foul Alliance can be found all over the island.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50520,'Now that we have taken the island back, it\'s time to get to work.  Talk to me again when you are ready to help.','Now that we have taken the island back, it\'s time to get to work.  Talk to me again when you are ready to help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50521,'You seek a Sunwalker.  Sunwalker Iopi resides with many of our other trainers.','You seek a Sunwalker.  Sunwalker Iopi resides with many of our other trainers.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(50522,'Iilth vwah, uhn\'agth fhssh za.','',0,0,0,0,0,0,0,0,0,0,18543,0,26124),
(50523,'Where one falls, many shall take its place...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50524,'The Hole is a foul place $n.  I would not venture down there unless you are well armed and ready for battle.','The Hole is a foul place $n.  I would not venture down there unless you are well armed and ready for battle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50525,'Gul\'kafh an\'shel.','',0,0,0,0,0,0,0,0,0,0,18544,0,26124),
(50526,'Gaze into the void.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50527,'They do not die.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50528,'The demons in D-Block have been giving us trouble since we got here.  Can you help us out?','The demons in D-Block have been giving us trouble since we got here.  Can you help us out?\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50529,'Ywaq maq oou.','',0,0,0,0,0,0,0,0,0,0,18542,18542,26124),
(50530,'If you seek to walk a righteous path then you should speak with Seer Alsoomse.','If you seek to walk a righteous path then you should speak with Seer Alsoomse.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(50531,'Thanks for your help taking the island back $n.  Now we need your help in the Cursed Depths.','Thanks for your help taking the island back $n.  Now we need your help in the Cursed Depths.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50532,'Do giants tread lightly?','Do giants tread lightly?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50533,'I thank you, my friends. Forgive me. I... I have grown too weak to be of any assistance.','',0,0,0,0,0,0,0,0,0,0,18662,0,26124),
(50534,'A new host must be found.','',0,0,0,0,0,0,0,0,0,0,18860,0,26124),
(50535,'Too weak to serve.','',0,0,0,0,0,0,0,0,0,0,18861,0,26124),
(50536,'Only your memory remains...','',0,0,0,0,0,0,0,0,0,0,18862,0,26124),
(50537,'The Valley of Honor\'s bank is just before the gate to The Drag.','The Valley of Honor\'s bank is just before the gate to The Drag.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(50538,'They are outside the cycle...','',0,0,0,0,0,0,0,0,0,0,18863,0,26124),
(50539,'Does fire consume stone?','Does fire consume stone?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50540,'There is only Ghur\'sha.','',0,0,0,0,0,0,0,0,0,0,18864,0,26124),
(50541,'Give in...','',0,0,0,0,0,0,0,0,0,0,18865,0,26124),
(50542,'Who are your allies?','',0,0,0,0,0,0,0,0,0,0,18866,0,26124),
(50543,'Is. This. Reality?','',0,0,0,0,0,0,0,0,0,0,18867,0,26124),
(50544,'Do rocks float on water?','Do rocks float on water?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50545,'The Valley of Strength\'s bank is south of the entrance to Grommash Hold, northwest of the main gate.','The Valley of Strength\'s bank is south of the entrance to Grommash Hold, northwest of the main gate.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(50546,'Hunter','Hunter',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50547,'Is ice hot?','Is ice hot?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50548,'Is it that hard for you to find the wind rider master on your own?  Burok is at the southern end of town, next to the wind riders.','Is it that hard for you to find the wind rider master on your own?  Burok is at the southern end of town, next to the wind riders.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(50549,'The hippogryphs are well-tended by Zaldaan, in the northern part of town.','The hippogryphs are well-tended by Zaldaan, in the northern part of town.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50550,'It... it worked!  We will defend Nahom with the power stored within this temple!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50551,'Sir.  The reinforcements were cut off by Neferset troops.  We are on our own.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50552,'Speak with Un\'Thuwa outside of the Razor Hill barracks.','Speak with Un\'Thuwa outside of the Razor Hill barracks.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(50553,'The Conclave of Wind has dissipated. Your honorable conduct and determination have earned you the right to face me in battle, mortals. I await your assault on my platform! Come!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50554,'Thank you sergeant.  You may return to your post.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50555,'This is not good, $n.  We have to find a way to hold on to Nahom.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50556,'This confrontation no longer serves any purpose. I shall end it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50557,'Well done. Find Lirastrasza and let her know that we\'ve succeeded.','Well done. Find Lirastrasza and let her know that we\'ve succeeded.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50565,'Your challenge is accepted, mortals! Know that you face Al\'Akir, Elemental Lord of Air! You have no hope of defeating me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50568,'The cypher is powering mechanisms deep within the temple!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50569,'Like swatting insects...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50571,'Believe me when I tell you, $p, you\'re in on the ground floor of something big!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(50573,'This little one shall vex me no longer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50580,'After every storm, comes the calm...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50583,'You have run out of time, mortals! Your lives are forfeit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50584,'Your futile persistance angers me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50585,'Enough! I will no longer be contained!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50586,'Winds! Obey my command!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50587,'Storms! I summon you to my side!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50588,'Lightning! Destroy my enemies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50589,'The honor of slaying the interlopers shall be mine, brothers! Their feeble bodies will freeze solid from my wind\'s icy chill!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50590,'Frozen solid.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50591,'Another mortal has taken their last breath!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50592,'You throw away your honor and flee as cowards? Then die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50593,'If you wish to use a hippogryph, speak with Fidelio.','If you wish to use a hippogryph, speak with Fidelio.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50594,'The power of our winds, UNLEASHED!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50595,'Brothers, beware! These mortals are dangerous. I must pause and gather my strength.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50596,'It shall be I that earns the favor of our lord by casting out the intruders. My calmest wind shall still prove too much for them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50597,'Begone, outsider!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50598,'Your presence shall no longer defile our home!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50599,'You think to outrun the wind? A fatal mistake.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50600,'The power of our winds, UNLEASHED!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50601,'My power grows feeble, brothers. I shamefully must rely on you for a time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50602,'As I am the strongest wind, it shall be I that tears the invaders apart!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50603,'Blown away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50604,'Mere dust...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50605,'The Highborne, Irriende, inside of the inn, can train you in the ways of the arcane.','The Highborne, Irriende, inside of the inn, can train you in the ways of the arcane.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50606,'Why do you flee, mortals? There is nowhere you can run or hide here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50607,'The intruders stand fast, brothers, I cannot break them. Allow me a brief respite to strengthen my winds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50608,'','I... I will stay with you, father.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50609,'','Everybody onboard the ships now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50610,'Someone must stay behind and keep the Forsaken from gaining a foothold.  Farewell, Genn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50611,'Lead our people to their new home.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50612,'Crowley!  You\'ve done enough.  I cannot allow you to stay behind again...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(50613,'We will return, dear friend.  We will come back, to take what belongs to us.  This I swear!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(50614,'Father... why must we endure such hardship?  Why can\'t we live somewhere sunny and lush?  A tropical island perhaps?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50615,'Toughen up, lad.  I raised you better than that.  Stiff upper lip!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50616,'Have you seen my latest invention? It\'s going to be a hit... if it doesn\'t explode.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(50617,'I need a new GS-9x Multibot.','I need a new GS-9x Multibot.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50618,'%s prepares to unleash The Skullcracker on nearby enemies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50619,'','A Twilight Zealot has evolved!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50620,'%s\'s armor shimmers with heat. Strike now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50621,'%s prepares to trade places with one of his shadows!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50622,'Reforging','Reforging',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50623,'There is a Highborne archmage visiting the city\'s Enchanting trainer. You can have your items reforged there.','There is a Highborne archmage visiting the city\'s Enchanting trainer. You can have your items reforged there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50624,'We\'re glad to have your help.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50625,'I will mark the location upon your map.','I will mark the location upon your map.',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(50626,'Which one?','Which one?',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(50627,'The Valley of Strength','The Valley of Strength',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(50628,'The Valley of Honor','The Valley of Honor',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(50629,'Neferset City will fall!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50632,'I need another Slitherblade Charm, Korrah.','I need another Slitherblade Charm, Korrah.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50633,'I need another trident.','I need another trident.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50634,'holds his |Hitem:64383|h|cff0070dd[Kaldorei Wind Chimes]|r|h to the wind.','holds her |Hitem:64383|h|cff0070dd[Kaldorei Wind Chimes]|r|h to the wind.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50635,'lifts his |Hitem:64383|h|cff0070dd[Kaldorei Wind Chimes]|r|h into the rain.','lifts her |Hitem:64383|h|cff0070dd[Kaldorei Wind Chimes]|r|h into the rain.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50636,'lifts his |Hitem:64383|h|cff0070dd[Kaldorei Wind Chimes]|r|h into the snow.','lifts her |Hitem:64383|h|cff0070dd[Kaldorei Wind Chimes]|r|h into the snow.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50637,'%s is ready to be fed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50638,'Augh appears from the distance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50639,'This chest must have been resting here for millennia.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50640,'Examine the chest.','Examine the chest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50641,'You must return to eastern Uldum or the Fusion Core will deactivate!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50642,'I\'m ready to face Shadra!','I\'m ready to face Shadra!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50643,'%s weakens! Capture it with your harness!','%s weakens! Capture it with your harness!',0,0,0,0,0,0,0,0,1,11651,0,0,26124),
(50644,'I can\'t believe they\'ve keep me waiting this long!','I can\'t believe they\'ve keep me waiting this long!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(50645,'I just need to get into the city. Why should that be so difficult?','I just need to get into the city. Why should that be so difficult?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(50646,'What\'s going on, anyway? They haven\'t told us anything and I\'m starting to get angry!','What\'s going on, anyway? They haven\'t told us anything and I\'m starting to get angry!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(50647,'I need to search you.','I need to search you.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(50648,'I am... weary. You must carry on without me. I shall take my leave once my strength has returned.','',0,0,0,0,0,0,0,0,0,0,18664,0,26124),
(50649,'Take curse away!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(50650,'','When we returned from Deepholm, we found that the Twilight\'s Hammer had established a base here and taken control of the elemental portals.$B$BPlease, $n, you must stop them before Cho\'gall can complete whatever it is that he\'s up to inside the Bastion of Twilight!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(50651,'You must return to the Duskmist Shore!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50652,'Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.','Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(50653,'Greetings.  Have you come to master matters magical?','Greetings.  Have you come to master matters magical?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(50654,'Kill Aeonaxx before his whelps overwhelm you!','Kill Aeonaxx before his whelps overwhelm you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50655,'The sun has set on this mortal world, fools. Make peace with your end, for the hour of Twilight falls.','',0,0,0,0,0,0,0,0,1,0,23614,0,26124),
(50656,'I require more of the Secret Signal Powder, Kadrak.','I require more of the Secret Signal Powder, Kadrak.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50661,'Grim Campfire','Grim Campfire',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50662,'Landro\'s Lil\' XT','Landro\'s Lil\' XT',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50663,'Mottled Drake','Mottled Drake',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50664,'Worldbreaker','Worldbreaker',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50665,'%s is no longer protected by the beacons!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50666,'|TInterface\\Icons\\spell_nature_earthquake.blp:20|tGeneral Umbriss begins to cast |cFFFF0000|Hspell:74634|h[Ground Siege]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50667,'Take this enchanted shard, $n. I will be able to hear the dwarves myself through its twin.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(50669,'Wretched gnat... none but us may command the silithid!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50670,'casually tosses his |Hitem:63269|h|cFFFFFFFF[Loaded Gnomish Dice]|r|h.','casually tosses her |Hitem:63269|h|cFFFFFFFF[Loaded Gnomish Dice]|r|h.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50671,'Release me from this torment!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50672,'Have I not paid enough yet for my sins?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50673,'I only did it for my clan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50674,'Who are you to judge me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50675,'I must warn... Hive\'Ashi...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50676,'Champions, hold on while I fly you back to Khardros\' Anvil!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50677,'Would you like the portcullis opened?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50678,'Open it.','Open it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50679,'Hear me, minions of Twilight. (Hear! Hear and obey!)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50680,'The foolish weaklings of the Alliance and Horde make their way to the Twilight Highlands as we speak. (FOOLS! Blind and weak and tasty...)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50681,'Do not forget your task here! Continue the rituals while the meddlesome heroes of the world turn a blind eye to this desolate wasteland.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50682,'Every sacrifice brings more of the master\'s heralds into this world. (The hives sing of madness, of chaos!)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50683,'Bring the sacrifices to the master\'s flesh and blood within the other hives. (They hunger...)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50684,'The end of all approaches. The unmaking is at hand. (End of all! The curtain falls!) Do not fail me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50685,'Ohh, my head...','Ohh, my head...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50686,'Where am I? Are we underground?','Where am I? Are we underground?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50687,'I wasn\'t even shackled... but I don\'t think I was asleep...','I wasn\'t even shackled... but I don\'t think I was asleep...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50688,'A moment... just give me a moment.','A moment... just give me a moment.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50689,'Champions, hold on while I fly you back to the Scarred Terrace!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50690,'Go away! You shouldn\'t be here!','',0,0,0,0,0,0,430,0,0,0,0,0,26124),
(50691,'Can you take me to the Great Hall?','Can you take me to the Great Hall?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50692,'Can you take me to the Chapel?','Can you take me to the Chapel?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50693,'Can you take me to the Ramparts?','Can you take me to the Ramparts?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50694,'Can you take me to the Laboratory?','Can you take me to the Laboratory?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50695,'Weary of one of your demonic charges? Hoping for one with a more pleasing name?\n\nFor a price, I can assist you in the obliteration of a current minion so that you may summon an entirely new one...','Weary of one of your demonic charges? Hoping for one with a more pleasing name?\n\nFor a price, I can assist you in the obliteration of a current minion so that you may summon an entirely new one...',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(50696,'Abandon Imp','Abandon Imp',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50697,'Abandon Voidwalker','Abandon Voidwalker',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50698,'Abandon Succubus','Abandon Succubus',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50699,'Abandon Felhunter','Abandon Felhunter',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50700,'Abandon Felguard','Abandon Felguard',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50701,'Are you sure you want to pay to abandon your minion?','Are you sure you want to pay to abandon your minion?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50702,'Avoid the Twilight Guards while gathering the intelligence!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50703,'Get back to the ship!','Get back to the ship!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50704,'Heya, $g champ : lady;. What\'s shakin\'?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(50705,'Heya, Ace. Remember when we were shipwrecked on the Lost Isles?','Heya, Ace. Remember when we were shipwrecked on the Lost Isles?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50706,'','You didn\'t honestly think I would only plant ONE set of explosives, did you?',0,0,0,0,0,0,0,0,1,0,0,24622,26124),
(50707,'Hello, sucker!','',3,0,0,0,0,0,0,0,0,0,0,0,26124),
(50708,'Fine, slap the manacles on. But know this, Gallywix, you\'ll get yours!','Fine, slap the manacles on. But know this, Gallywix, you\'ll get yours!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50710,'This is it, $n!  This is where we make our stand!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50711,'','After all we\'ve been through, we Gilneans have not given up hope.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50712,'I don\'t remember much about how I got to Duskhaven.  Tell me what you know.','I don\'t remember much about how I got to Duskhaven.  Tell me what you know.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50713,'|TInterface\\Icons\\spell_fire_totemofwrath.blp:20|t Foe Reaper 5000 |cFFFF0000|Hspell:88522|h[Safety Restrictions are Off-line]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50714,'Spawn Nefarian please!','Spawn Nefarian please!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50715,'This teleportation device appears to have been used recently to teleport various goods deeper into the mine.','This teleportation device appears to have been used recently to teleport various goods deeper into the mine.',0,0,0,0,0,0,430,0,0,0,0,0,26124),
(50716,'Press the button labeled \'Wood and Lumber.\'','Press the button labeled \'Wood and Lumber.\'',0,0,0,0,0,0,430,0,0,0,0,0,26124),
(50717,'Press the button labeled \'Metal and Scraps.\'','Press the button labeled \'Metal and Scraps.\'',0,0,0,0,0,0,430,0,0,0,0,0,26124),
(50718,'Press the button labeled \'Ship Parts.\'','Press the button labeled \'Ship Parts.\'',0,0,0,0,0,0,430,0,0,0,0,0,26124),
(50720,'%s is revived by the molten energy of the boiling magma!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50721,'Greetings, $c.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(50722,'Ouch, my head...what day is it?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50723,'Where\'s that bright light coming from? Ahhhh, get it away from me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50724,'He said he had candy...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50725,'','The barrier protecting the Pulsing Twilight Eggs dissipates as Sinestra harnesses their power!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50726,'|TInterface\\Icons\\ability_whirlwind.blp:10|t OMG I\'m casting |cFFFF0000|Hspell:88481|h[Overdrive]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50727,'OMG I\'m casting |TInterface\\Icons\\ability_whirlwind.blp:10|t|cFFFF0000|Hspell:88481|h[Overdrive]|h|r that\'s crazy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50728,'Did you hear?  |TInterface\\Icons\\ability_whirlwind.blp:10|t OMG I\'m casting |cFFFF0000|Hspell:88481|h[Overdrive]|h|r!  That\'s Crazy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50729,'$n, thank goodness you\'re here!','',0,0,0,0,0,0,0,0,0,0,23615,0,26124),
(50730,'Thank goodness, you look like a capable $c with some brains.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50731,'Yayyyy!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(50732,'But dis place be OURS! Dis be da land of de ogres and da trolls!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50733,'Da humans and da green skins took dis land, our ancestor\'s land.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50734,'Boulderfist strong. Witherbark strong. Together we smash enemies!  Roaaarrrr!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50737,'','This isn\'t over, $n.  Not by a long shot.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50738,'I am ready for the Mind Vision ritual, Thaalia.','I am ready for the Mind Vision ritual, Thaalia.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50739,'I am ready for the Mind Control ritual, Thaalia.','I am ready for the Mind Control ritual, Thaalia.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50740,'Haleh, I have lost the Bluescale Sigil. Could you fashion another?','Haleh, I have lost the Bluescale Sigil. Could you fashion another?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50741,'You seek the newly-arrived Highborne? So be it.\n\nYou\'ll find them in the western wing of the Temple of the Moon. There may be one of them at the Howling Oak, as well.','You seek the newly-arrived Highborne? So be it.\n\nYou\'ll find them in the western wing of the Temple of the Moon. There may be one of them at the Howling Oak, as well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50742,'Umm... Pebblebitty... the gate is open.','Umm... Pebblebitty... the gate is open.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50743,'','Ahh... so it is, so it is.  Carry on then.  Carry on t\'yer death.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50744,'','I don\'t care to hear it, $n. Nope, no way are you going to be let into the Searing Gorge. Impossible. Not going to happen. How many times do I have to tell you - I can\'t let you in! Do you not speak Common? Are you an orc in disguise? N-O. NO!$B$BIf I let you in, then I have to let everybody in. Pretty soon your close friends will want in, then their distant relatives, then their friends, and so on and so forth. The last time that happened... well, we won\'t talk about the last time it happened.$b$bI will NOT open that gate!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50746,'One of the Gilneans, Vitus  Darkwalker, can help you. Find him at the Howling Oak.','One of the Gilneans, Vitus  Darkwalker, can help you. Find him at the Howling Oak.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50747,'','Welcome to the Wickerman Festival, $c!$B$BOn the observance of Hallow\'s End, we burn a Wickerman to represent a cleansing of the self. As the woods sigh and shed their leaves, we too must undergo a catharsis. Fears, sorrows, regrets: by throwing a branch into the blaze, you can relieve yourself of any burden you would not bear into winter.$B$BPlease, grab a branch from the bonfire and join the celebration!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(50748,'Can you feel the evil that taints the very ground, $c? It comes from deep down within the Shadow Hold. Unchecked, it will swallow everything in its path.$B$B<The night elf coughs, revealing a bloody wound at his side.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50749,'Sons and daughters of Gilneas! Friends and allies old and new! Please, come close!','',0,0,0,0,0,0,22,7,0,0,25172,0,26124),
(50750,'As you know, Hallow\'s End is a celebration of transition... of change.','',0,0,0,0,0,0,396,7,0,0,25173,0,26124),
(50751,'Only the most valiant and honorable amongst the tribe can earn the honor of being laid to rest at Red Rocks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50752,'However, this is a time of neither mourning nor grief.','',0,0,0,0,0,0,396,7,0,0,25176,0,26124),
(50753,'New struggles await us with each dawn, and uncertainty weighs upon us all.','',0,0,0,0,0,0,396,7,0,0,25179,0,26124),
(50754,'Let this wickerman embody any unrest within us.','',0,0,0,0,0,0,397,7,0,0,25181,0,26124),
(50755,'The cub tilts its head and looks at you expectantly. Shouldn\'t you know what to do, $g dad:mom;?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50756,'Torches ready!','',0,0,0,0,0,0,0,7,0,0,25183,0,26124),
(50757,'Let the flames fly! Hallow\'s End is upon us!','',0,0,0,0,0,0,0,7,0,0,25184,0,26124),
(50758,'Though many flames are fought over, extinguished and re-lit, all are welcome to show honor to the flame, $c.$b$bHere among the Earthen Ring, we simply honor the flame, rather than engage in other frivolities.$b$bHere, we will honor the flame as tradition dictates.  Will you join with us in honoring the flame, $n?','Though many flames are fought over, extinguished and re-lit, all are welcome to show honor to the flame, $c.$b$bHere among the Earthen Ring, we simply honor the flame, rather than engage in other frivolities.$b$bHere, we will honor the flame as tradition dictates.  Will you join with us in honoring the flame, $n?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(50759,'So I uh, lost my Fireliminator X-21. Can I get a new one?','So I uh, lost my Fireliminator X-21. Can I get a new one?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50760,'','The cartel has a name for people like you, $n. \"Fiscal Liability.\"',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(50761,'You\'ve reached an Earthen Ring bonfire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50762,'Honor the Earthen Ring bonfire!','Honor the Earthen Ring bonfire!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50763,'','The Wickerman festivities will begin in ten minutes! Please join us just outside the gates of Stormwind City and celebrate Hallow\'s End!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(50764,'One of those blasted Jaedenar demons saw me! Gave me a good slash in the side. The wound isn\'t pretty, but I\'ll live.$B$BThere are more urgent matters at hand, like stopping the Shadow Council from launching a full-scale attack on our friends at Wildheart Point. I\'m in no shape to fight, so you\'ll have to go in my place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50765,'The people of Gilneas understand the gravity of change all too well.','',0,0,0,0,0,0,396,7,0,0,25174,0,26124),
(50766,'%s pounces on the snow-covered hare burrow.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50767,'%s is at half health!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50768,'%s is nearly defeated!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50769,'','She\'s coming! Quiet down, you fools! The Dark Lady approaches...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50770,'Oh great, thanks. That looks...um...delicious.','Oh great, thanks. That looks...um...delicious.',18,0,0,0,0,0,0,0,0,0,0,0,26124),
(50771,'I heard that Gott Weedlespan fired his last assistant...by pushing him off a cliff! Best not to get on his bad side.','I heard that Gott Weedlespan fired his last assistant...by pushing him off a cliff! Best not to get on his bad side.',430,0,0,0,0,0,0,0,0,0,0,0,26124),
(50772,'The Assistant Resort Director doesn\'t like to see us taking breaks. We don\'t like to see him, either.','The Assistant Resort Director doesn\'t like to see us taking breaks. We don\'t like to see him, either.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50773,'Oh goody! I haven\'t had a break since the day before yesterday!','Oh goody! I haven\'t had a break since the day before yesterday!',4,0,0,0,0,0,0,0,0,0,0,0,26124),
(50774,'I want to go home and see my family, but Gott won\'t let us off this mountain!','I want to go home and see my family, but Gott won\'t let us off this mountain!',18,0,0,1,0,0,0,0,0,0,0,0,26124),
(50775,'Food? What about my last paycheck? Did you bring that too?','Food? What about my last paycheck? Did you bring that too?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50776,'Heehee! You can\'t catch me!','Heehee! You can\'t catch me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50777,'Ooooh, a $c! Try to catch me, slowpoke!','Ooooh, a $c! Try to catch me, slowpoke!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50778,'I can run fast! Daddy let me get a speed enchant on my shoes!','I can run fast! Daddy let me get a speed enchant on my shoes!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50779,'Weeeeeeeeeeeeeeeeeeeeeeeee!','\nWeeeeeeeeeeeeeeeeeeeeeeeee!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50780,'Am I fast? I wanna be a $c like you!','Am I fast? I wanna be a $c like you!\n',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50781,'Awww, we were just playing!','Awww, we were just playing!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50782,'Guess I need to run faster next time.','Guess I need to run faster next time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50783,'I don\'t wanna go inside! It was fun out here!','I don\'t wanna go inside! It was fun out here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50784,'Where are you taking us? Are we there yet?','Where are you taking us? Are we there yet?\n',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50786,'Me will mark where on your map.','Me will mark where on your map.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50787,'','Now, we burn this wickerman as a symbol of our victory against old enemies!',0,0,0,0,0,0,1,1,1,0,0,25190,26124),
(50788,'','We are the instruments of an unyielding ire...',0,0,0,0,0,0,1,1,1,0,0,25196,26124),
(50789,'%s looks towards the cave entrance, but A-Me 01 is nowhere to be seen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50790,'%s is having trouble sleeping.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50791,'Help! I can\'t swim!','Help! I can\'t swim!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50792,'Over here, $c! Help me!','Over here, $c! Help me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50793,'','Hallow\'s End is upon us, $c.  I hope you are enjoying the festivities.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50794,'I\'m ready to fly, let\'s bomb the Undercity!','I\'m ready to fly, let\'s bomb the Undercity!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50797,'Ugh, what is this swill? It tastes like wet dog fur!','Ugh, what is this swill?  It tastes like wet dog fur!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50798,'Who in their right mind would want to drink THIS? Blecchhhh!','Who in their right mind would want to drink THIS? Blecchhhh!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50799,'Have I seen anything suspicious? The only suspicious things around here are the outrageous prices.','Have I seen anything suspicious? The only suspicious things around here are the outrageous prices.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50800,'I haven\'t seen a thing. Now stop bothering me about Twilight\'s Hammer and let me get back to my tan.','I haven\'t seen a thing. Now stop bothering me about Twilight\'s Hammer and let me get back to my tan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50801,'I might have seen someone in a Twilight\'s Hammer robe. They were very tall. I\'m sure of it.','I might have seen someone in a Twilight\'s Hammer robe. They were very tall. I\'m sure of it.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50802,'I saw someone setting one of those fire totems. It was dark, but I remember they were wearing red.','I saw someone setting one of those fire totems. It was dark, but I remember they were wearing red.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50803,'Suspicious activity? Assistant Director Weedlespan doesn\'t want anyone going to the north side of the lake. Weird, don\'t you think?','Suspicious activity? Assistant Director Weedlespan doesn\'t want anyone going to the north side of the lake. Weird, don\'t you think?\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50804,'Yes, I overheard someone talking about Twilight\'s Hammer at the party last night. I didn\'t see them, but they were extremely rude.','Yes, I overheard someone talking about Twilight\'s Hammer at the party last night. I didn\'t see them, but they were extremely rude.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50805,'Accuse','Accuse',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50806,'Greetings! Wonderful day, isn\'t it?','Greetings! Wonderful day, isn\'t it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50807,'How dare you accuse me of being a Twilight Cultist! Do I look crazy to you?','How dare you accuse me of being a Twilight Cultist! Do I look crazy to you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50808,'<Gott sneers contemptuously at you.>$B$BCan you possibly work any slower? I\'m surrounded by useless idiots!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50809,'Hey. Have we met before?','Hey. Have we met before?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50810,'If ye want me advice, don\'t go strugglin\' tae much. Ye\'ll just encourage them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50811,'If ye climb up another notch, I\'ll share me brew with ye!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50812,'Nae, I\'m enjoying me fine some Ironforge mead. Might be the last drink we have for a while yet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50813,'And who forgot tae grab the ale on the way up? Not me! Hahahaha!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50814,'Stop drinking tha last o\' our ale and help me off this blasted branch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50815,'Mebbe someone will come around and get us out of this mess!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50816,'I told ye not tae leave the boar ribs out! Why couldna yae had a proper stomach and eaten yer dinner like the rest o\' us Buckeys?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50817,'Come any closer ya wee bear and I\'ll punch ya in the face!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50818,'Wow! A haunted lighthouse with a pirate captain\'s ghost and everything! D\'you think he\'ll tell us where the treasure is buried?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(50819,'Holy Light! Look what happened to the dam! The other orphans aren\'t gonna believe this!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(50820,'Wow, the big bear is still here! Do you think he gets mad when everyone puts their treasure in his tummy? That must hurt...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(50821,'','Welcome to the Menders\' Stead, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50822,'Is Zen\'Kiki available for some more combat practice?','Is Zen\'Kiki available for some more combat practice?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50823,'Do you feel it? It\'s almost like Arthas is still here right in this room! But he\'s gone, right? This place still feels like evil...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(50824,'What\'re ye lookin\' at, ye tuskarr-faced bung?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50825,'Yarr!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50826,'Scuttle me skivvies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50827,'The tale of ol\' Duncan is a sad one, I\'m afraid.  I used to be captain of me own ship, ye know?$b$bOne more demotion and I\'ll be a swabbie again.  I don\'t think I could take the humiliation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50828,'Whatever, Duncan.  Grab a mop and get to work.','Whatever, Duncan.  Grab a mop and get to work.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50829,'Wow, these docks are huge! The ships that dock here must be as big as zeppelins! Is this the same ocean I can see from Orgrimmar?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50830,'I can see those dirty night elves from here! When I grow up, I want to fight for the warchief just like these warriors!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(50831,'Will you pay \"Pretty Boy\" Duncan 1 gold to swab the decks for you?','Will you pay \"Pretty Boy\" Duncan 1 gold to swab the decks for you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50832,'Having some trouble there, sailor?  Need some help?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50833,'This is humiliating.','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(50834,'I can\'t believe it\'s come to this.','',0,0,0,0,0,0,38,0,1,0,0,0,26124),
(50835,'A mop?  Really?','',0,0,0,0,0,0,38,0,1,0,0,0,26124),
(50836,'I suppose sometimes y\'need to hit rock bottom before y\'can crawl yer way back up.','',0,0,0,0,0,0,38,0,1,0,0,0,26124),
(50837,'Maybe I need a new nickname.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(50838,'Warchief, you are a hero to my young ward. Would you mind signing an autograph for him?','Warchief, you are a hero to my young ward. Would you mind signing an autograph for him?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(50839,'Of course, $c. What is the young warrior\'s name?$B$BI wish more of our people shared your concern for the orphans of Orgrimmar.','',432,0,0,0,0,0,1,0,1,0,0,0,26124),
(50840,'While I miss Gilneas greatly, there\'s ancient ruins to explore!','While I miss Gilneas greatly, there\'s ancient ruins to explore!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50841,'Tadpoles!  Tadpoles is the winner!','',0,0,0,0,0,0,4,13,1,0,0,0,26124),
(50842,'Hi!  You there!  Does it smell green to you?','',0,0,0,0,0,0,6,13,1,0,0,0,26124),
(50843,'The score is fourty-six to fifty-two!','',0,0,0,0,0,0,1,13,1,0,0,0,26124),
(50844,'Hand me the wizzlesproket, you dwarf-brained son of a human!  No, not that one, the other one!','',0,0,0,0,0,0,25,7,1,0,0,0,26124),
(50845,'I was head editor of the Tinker Town Tattler!','',0,0,0,0,0,0,15,37,1,0,0,0,26124),
(50846,'There is NOTHING random about what I say!  Nothing!','',0,0,0,0,0,0,4,1,1,0,0,0,26124),
(50847,'The darkness beneath Tirisfal will consume us all...','',0,0,0,0,0,0,274,6,1,0,0,0,26124),
(50848,'SLUDGE SAYS DRINK!','',0,0,0,0,0,0,11,7,1,0,0,0,26124),
(50849,'I want to learn about Archaeology.','I want to learn about Archaeology.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50850,'A treasure hunter\'s life is a treacherous one. Don\'t be foolin\' yerself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50851,'Multiple vapors appear from the fog!  Kill Admiral Ripsnarl before you are overwhelmed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50852,'Hostile forces detected.  Defense mode activated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50853,'Beetle','Beetle',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(50854,'Dog','Dog',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(50855,'Fox','Fox',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(50856,'Monkey','Monkey',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(50857,'Shale Spider','Shale Spider',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(50858,'Our brothers at Baradin Hold on Tol Barad are very busy and not always available when you need them.  I have been stationed here around the clock to help you with tasks they might have given you.','Our brothers at Baradin Hold on Tol Barad are very busy and not always available when you need them.  I have been stationed here around the clock to help you with tasks they might have given you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50860,'You no belong here!','You no belong here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50861,'You break and enter?! Me break YOU!','You break and enter?! Me break YOU!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50862,'You not allowed here!','You not allowed here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50863,'Ozumat is vulnerable, strike now!','Ozumat is vulnerable, strike now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50864,'Cowards!  I will not fall so easily into your trap!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50865,'You there! Hiding like a coward when you should be fighting these devils?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50866,'Quit running and DO SOMETHING!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50867,'Feckless cowards, the lot of you! Maybe if you\'d show some backbone, I would actually pay your wages!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50868,'Idiots! Dolts! Morons! Imbeciles! Fools! Dimwits! Ignoramuses! Shall I go on?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50869,'Maybe someone should go fetch some water. A person with a brain would have done that already!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50870,'You nincompoops! This place deserves to burn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50871,'Nightmare spiders appear in the darkness!  Kill Helix before his nightmare overwhelms you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50874,'You\'ve impressed me so far, $n. How do you feel about helping me in creating the ultimate dish?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50875,'|TInterface\\Icons\\spell_nature_cyclone.blp:20|t%s begins to cast|cFFFF9A20|Hspell:86193|h [Wind Blast]!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50876,'%s begins to resurrect a |cFF3366CCZanzili Berserker|r!','%s begins to resurrect a |cFF3366CCZanzili Berserker|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50877,'%s begins to resurrect a swarm of |cFFCC0000Zanzili Zombies|r!','%s begins to resurrect a swarm of |cFFCC0000Zanzili Zombies|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50878,'%s fills the area with a |cFF33FF00toxic gas|r!','%s fills the area with a |cFF33FF00toxic gas|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50879,'Woooweeee! Look at her run! Just relax and enjoy the view. I\'ll have us across the lake in no time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50880,'Enjoying your stay? One dip in the steam pools and you come out looking 10 years younger. Just look at me if you want proof!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50881,'Have you tried any of Chef Tramsay\'s dishes yet? I really enjoyed his Moth Soup. Delicious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50882,'Wait, do you see that light up there? What\'s going on?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50883,'The...they\'re agents of the Twilight\'s Hammer! Is that...the Assistant Resort Director with them?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50884,'Oh no! They\'ve spotted us! Hang on -- I\'ll get us out of here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50885,'We barely made it out alive. You\'d better run and tell Lasha what you\'ve seen. We\'ve got a serious problem to deal with!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50886,'I seek other veterans of the campaign here in Northrend. We are urgently needed to face new foes at home.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(50887,'Preparations for Tol Barad will begin in 5 minutes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50888,'The Battle for Tol Barad will begin in 2 minutes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50889,'The Battle for Tol Barad will begin in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50890,'','The darkness is closing in!  I will not go without a fight, monster!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50892,'Hi, my name is Kevin, do you want to play a movie ?','Hi, my name is Kevin, do you want to play a movie ?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50893,'I intend to fight the Soulflayer, but I have no way of summoning him.  Can you assist me?','I intend to fight the Soulflayer, but I have no way of summoning him.  Can you assist me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50894,'Victory in Tol Barad is ours! While the Horde offensive is crippled, we need your immediate efforts to gather resources and secure the island!','',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(50895,'Victory in Tol Barad is ours! While the Alliance offensive is crippled, we need your immediate efforts to gather resources and secure the island!','',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(50896,'Greetings, hapless adventurer.  I ask only that you wait a moment...and BLEED!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50897,'If you\'re looking for a place to rest, I can help.','If you\'re looking for a place to rest, I can help.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50898,'You choose my corpse over another ally against the undead?  So be it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50899,'Burn...my corpse...do not let me join them...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50900,'','Plot revenue minus supply expenditures against the elasticity of demand, considering assets and liabilities inflected across the regression quotient....oh hi! How are you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50901,'Do you have what it takes to stay in my kitchen?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50902,'Have you seen the outrageous prices here?','Have you seen the outrageous prices here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50903,'Could you go get me a drink? I\'d do it myself, but I\'m working on my tan.','Could you go get me a drink? I\'d do it myself, but I\'m working on my tan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50904,'The Twilight\'s Hammer will rise again! The very earth beneath your feet will be swallowed by the fury of our resurgence!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50905,'Ah ken see very well through this haze, but I\'d know tha\' smell anywhere!  Die ye foul ogre!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50906,'Ooooooooh...','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(50907,'To the plaguelands went old Duggan, ta\' send them Scourge back inta\' th\' groun\'.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(50908,'Where th\' scent of death is on th\' wind and everythin\' is mostly brown.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(50909,'An\' when he did arrive there, what\'d his dwarf eyes see?','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(50910,'A hundred crates of barley there ta\' be makin\' inta\' mead!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(50911,'But tha\' mead was cursed with th\' plague o\' death, and now old Duggan, too.','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(50912,'An\' surrounded by the Lich King\'s beasts, what could old Duggan do?','',0,0,0,0,0,0,430,0,1,0,0,0,26124),
(50913,'But though I feel the plague within, my hopes \'ave not yet sunk.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(50914,'If\'n I\'m gonna be Scourge anyway, I might as well be drunk!','',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(50915,'This teleporter will transport you to Grom\'gol in Northern Stranglethorn.$B$BUsually.$B$BI mean, sometimes it\'ll just disintegrate you, or reduce all your soft tissues into a greenish, foul-smelling mist, but mostly it\'s safe!$B$B...mostly.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(50916,'This teleporter will transport you to the irradiated ruins of Gnomeregan, deep beneath Dun Morogh.$B$BDon\'t worry, there\'s another one there that\'ll send you back here... well, if it doesn\'t turn you inside-out or transmogrify your organs into unstable organic explosives, that is!$B$BWell? What are you waiting for? Hop on in!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50917,'Finally out from under the boot of that she-witch Abbendis, and free to pursue my own interests: BLOOD, BLOOD, AND MORE BLOOD!','Finally out from under the boot of that she-witch Abbendis, and free to pursue my own interests: BLOOD, BLOOD, AND MORE BLOOD!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50918,'I haven\'t eaten in weeks; this bread is mine!  FOR THE SANDWICH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50919,'I judge you...DELICIOUS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50920,'Abbendis will return, and I will be waiting for her!  SHE WILL COME BACK FOR US!','Abbendis will return, and I will be waiting for her!  SHE WILL COME BACK FOR US!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50921,'','I will drive your foul stench from the forest, monster!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50923,'Welcome to de great show, friends. Just wait \'til ya see what I got in store for ya.','',0,0,0,0,0,0,0,0,1,0,24254,0,26124),
(50924,'No... NOOOO!!!','',0,0,0,0,0,0,0,0,1,0,24255,0,26124),
(50925,'Ain\'t NO ONE gonna stop Jin\'do!','',0,0,0,0,0,0,0,0,1,0,24256,0,26124),
(50927,'Grass, sand, and sludge mix together to form the vague resemblance of a footprint.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50928,'The tracks are smeared, almost as if the creature drags its feet.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50929,'Mixed in with the mud are traces of oily sludge from the nearby rig.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50930,'This trail is bloody. You follow it to a nearby bush, where you find the remains of the creature\'s last meal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50931,'These tracks are fresh, and they lead down into the water...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50933,'','Did Brak say this teleporter thing was tested? Well, if you\'re ready to go back to Nozzlepot\'s Outpost, just say the word! I hope you get there in one piece.',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(50934,'','Did you see that? Someone just fell out of the sky!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50935,'Send me back to Nozzlepot\'s Outpost.','Send me back to Nozzlepot\'s Outpost.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50936,'Wow, this sure goes fast!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(50937,'You disssssturb the plans of Gurubashi, little one.  It\'sss too late for you.  Too late for all of you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50938,'','Haaa ha ha haa!  Now, heathens... face the TRUE might of Bethekk!',0,0,0,0,0,0,0,0,0,0,0,24287,26124),
(50939,'','What have you done? I can\'t... control... RRAAAARRRGHHH!',0,0,0,0,0,0,0,0,0,0,0,24286,26124),
(50940,'I\'m ready. Let\'s go!','I\'m ready. Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50941,'$n, glad to see you\'re still in one piece! I saw a rocket fly by earlier and heard your voice screaming, so I was a bit worried.$B$BWe have one last shipment to take care of. Talk to me when you\'re ready and we\'ll get going.','',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(50942,'Everybody on board! This caravan\'s leaving for the Mor\'shan Rampart!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50943,'How are you doing back there? Not too bumpy I hope.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50944,'Our enemies wouldn\'t dare attack us this close to the Crossroads. It\'s further out that we\'ll have to watch our backs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50945,'Hope you don\'t mind, but we\'ll stop at Dreadmist Camp to pick up additional supplies and fresh mounts for the last leg of the journey.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50949,'','How can Bwemba aid ya?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50950,'Yesss...ssssuccumb to the venom...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50951,'I need your help to remove the poison from these adventurers.','I need your help to remove the poison from these adventurers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50952,'You seek power, yes? But will you walk the cursed path I do for it?','You seek power, yes? But will you walk the cursed path I do for it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50953,'My path is a dark and cursed one, $c. You do not wish to walk with me.','My path is a dark and cursed one, $c. You do not wish to walk with me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50954,'We\'re here. Just wait a moment while we load up---HEY! What\'s happening!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50955,'','Quickly now! Grab one of them while I take the supply cart!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50956,'Guild Services','Guild Services',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(50957,'You may find Shattrath\'s guild master - as well as guild and tabard vendors - within the Terrace of Light\'s central structure, in the middle of the city.','You may find Shattrath\'s guild master - as well as guild and tabard vendors - within the Terrace of Light\'s central structure, in the middle of the city.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(50958,'Thank you for your help.','Thank you for your help.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50959,'Class trainers may be found in the various ground-floor wings of the Terrace of Light\'s central structure.$B$BAldor, Scryer or otherwise, someone will be able to help you.','Class trainers may be found in the various ground-floor wings of the Terrace of Light\'s central structure.$B$BAldor, Scryer or otherwise, someone will be able to help you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(50960,'You saved my life!','You saved my life!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50961,'Another troll?  At least you aren\'t a serpent...','Another troll?  At least you aren\'t a serpent...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50962,'The serpents, they are everywhere!','The serpents, they are everywhere!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50963,'The serpents overwhelmed us.','The serpents overwhelmed us.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50964,'I thought I was going to die in this awful jungle.','I thought I was going to die in this awful jungle.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50965,'I had just about given up hope.','I had just about given up hope.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50966,'Thank you for saving my life.','Thank you for saving my life.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(50967,'<The Arcane Guardian gestures towards the city\'s center.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50968,'Ho, Nagala! How about some lunch for your starving brother?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50969,'','You\'ve grown a few inches around the waist, little brother! Come down here and give your sister a hug!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50970,'Which one should I take?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50971,'','Balgor! No!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50972,'Attack the nightmare illusions and defend your sleeping allies!','Attack the nightmare illusions and defend your sleeping allies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50973,'','Bwemba be watchin\' you, young one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50974,'Now, have a taste of Jin\'do\'s true powah!','',0,0,0,0,0,0,0,0,1,0,24267,0,26124),
(50975,'','The fat one! He\'ll make for a nice sacrifice.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50976,'The Burning Blade sends its greetings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50977,'Look, someone\'s attacking Sentinel Hill. C\'mon guards, you just hafta win!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(50978,'I\'ve never seen a flying tree before. Let\'s get closer!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(50979,'That looks fun! I wanna drive, but the orphan matron says I can\'t get a mount \'til I\'m older.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(50980,'Look at all that slime. One is flying straight at me!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(50981,'Eeeeeeeeeeeeeeew, it\'s on my head! Help!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(50982,'%s is about to blast you with lightning! Get away!','%s is about to blast you with lightning! Get away!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50983,'My tummy doesn\'t feel so good...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(50984,'Whoa! Did you see how high we went?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(50985,'That was great! Let\'s do it again!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(50986,'You disssssturb the plans of Gurubashi, little one.  It\'sss too late for you.  Too late for all of you!','',0,0,0,0,0,0,396,0,1,0,24326,0,26124),
(50987,'My ssssserpents, dey already ssssslither beneath every rock an\' shrub of Ssssstranglethorn.','',0,0,0,0,0,0,397,0,1,0,24327,0,26124),
(50988,'We will reclaim thisss land. Gurubashi land.  An\' we kill anyone dat getssss in our way!','',0,0,0,0,0,0,396,0,1,0,24328,0,26124),
(50989,'We reclaiming our land, Gurubashi land.  An\' we gonna kill anyone dat get in our way.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(50990,'Go an\' get dem, Ohgan! We WON\'T be fooled again!','',0,0,0,0,0,0,0,0,1,0,24298,0,26124),
(50991,'Shaman...? A troll mystic of some sort has come to the city recently to visit Harene upon the Walk of Elders. She might be able to help you.','Shaman...? A troll mystic of some sort has come to the city recently to visit Harene upon the Walk of Elders. She might be able to help you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50992,'I thought the Park fell into a big hole, but this one\'s way bigger and it has a whirlwind!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(50993,'They\'re planning to sacrifice me! Their demons are already licking their chops over my corpse.$B$B<Balgor shudders.>$B$BMakes me think twice about my own diet.$B$B Anyway, they\'ve got a guard watching my every move. I can get myself out of here, but I need a good distraction.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50994,'','What!? The Burning Blade kidnapped my brother?',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(50995,'','All the supplies flowing north to Ashenvale stop here to rest and re-fuel. It\'s important to keep our operations running smoothly.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(50996,'I\'m ready to ride.','I\'m ready to ride.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50997,'There is a pair of tauren visiting the city. I\'m told they\'ve come from Mulgore to learn more about the Forsaken \"condition,\" or something to that effect.$B$BSeek them out near the herbalist by the Apothecarium.','There is a pair of tauren visiting the city. I\'m told they\'ve come from Mulgore to learn more about the Forsaken \"condition,\" or something to that effect.$B$BSeek them out near the herbalist by the Apothecarium.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(50998,'|TInterface\\Icons\\ability_heroicleap.blp:20|t%s begins to cast |cFFFF0000|Hspell:96740|h[Devastating Slam]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(50999,'This has to be the biggest diamond ever!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51000,'It looks just like the paintings of King Magni too! Did he really do this to himself?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51001,'Aye, lad. He tried to use an old titan ritual to keep his people safe, but this is what it did to him.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51002,'Wow, I don\'t think that was such a good idea...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51003,'I\'m really sorry you lost your king. But in a way, it\'s like he\'s with you forever!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51004,'They\'ve spotted us! Defend the caravan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51005,'This was my fault, my lord. I should\'ve done more research on those tablets...','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(51006,'Thank you, lad.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51007,'It\'s got me!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(51008,'Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(51009,'If you seek training in the Old Ways, I cannot help you.','If you seek training in the Old Ways, I cannot help you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(51010,'There\'s a worgen druid by the name of Dareth just outside the city gates; he might be able to help you.$B$BBig beast of a fellow, covered in white leather and furs. You can\'t miss him.','There\'s a worgen druid by the name of Dareth just outside the city gates; he might be able to help you.$B$BBig beast of a fellow, covered in white leather and furs. You can\'t miss him.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(51011,'Wow, you sure don\'t look like any night elf I\'ve seen before!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51012,'Our orphan matron says druids can turn into birds, cats, and bears, but you look like a combination of all of them!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51013,'I see what you\'re doing. You\'re gonna take all the druid forms and make them into one super-form!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51014,'The Emerald Dream doesn\'t sound like a place for me. What if it turns me into a turtle? I\'ve always wanted wings, though...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51015,'Wheeee! I\'m a bird-boy!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51016,'No, little one, it\'s nothing like that. My spirit spent many years in the Emerald Dream while my body slept, and it started to take on attributes of our animal forms.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51017,'Good day! Need some screws tightened or some bolts loosened? You\'ve come to the right place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51018,'Huuuuuuuunnnnnngggrryyyy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51019,'Meeeee sooooorrryyyy....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51020,'Wow, wow, wow! I can\'t believe Sputtervalve actually let me drive this baby! Have I mentioned this is my first time flying? Don\'t worry though. I have everything under control.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51021,'Man, oh man...Just look at that amazing view! Are those LIONS? Oops, almost let go of the steering wheel there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51022,'Wait until the guys back home find out about this! This is soooo totally geared out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51023,'My dream is to be as brilliant as Sputtervalve someday. You should see his design for a two-wheeled tricycle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51024,'Huh? Hold on, the engine stalled...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51025,'Whoa! What\'s going on?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51026,'No, no, no...this can\'t be happening. This wasn\'t part of the travel plan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51027,'Auuugh! Looks like we\'re taking an unexpected detour! Hold on tight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51028,'Maybe if I press this green button. No, what about this blue one? Hold on, let me try resplicing some wires. Ow!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51029,'Nothing\'s working!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51030,'Oh no, Sputtervalve is going to kill me! Sigh...You\'d better find your own transportation from here. I have to pick up the pieces and start the long walk back to camp...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51031,'Well here we are, back at the Crossroads, safe and sound.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51032,'The mists around the Altar of Hethiss dissipate as Venoxis prepares a powerful spell!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51033,'|TInterface\\Icons\\ability_creature_poison_06.blp:20|t High Priest Venoxis begins casting |cFFFF0000|Hspell:96637|h[Bloodvenom]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51034,'High Priest Venoxis is exhausted!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51035,'I can\'t stop it. We\'re in for a crash landing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51036,'Inspect the body.','Inspect the body.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51037,'The large cat doesn\'t seem quite as big as the hunter lead you to believe.','The large cat doesn\'t seem quite as big as the hunter lead you to believe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51038,'Let\'s see what we got here...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(51039,'Hmm...  The beast looks smaller than I would have thought.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(51040,'','Death to your kind!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51041,'','Serena Bloodfeather will rip out your eyes and feast upon your heart!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51042,'','You will pay for my sister\'s death!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51043,'','Our matron craves the taste of your blood!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51044,'','Rexxar\'s ally! Murderer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51045,'The Argent Crusade stands behind you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51046,'Ahoy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51047,'Mrfmmmm... mrrr.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51048,'Heeeeere\'s... Theldurin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51049,'Senior Initiate Goldmine, reporting for duty!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51050,'This is gonna be a bloodbath. A bloodbath... of flames!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51051,'Fear not. Johnny Awesome fights by your side.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51052,'','Two knives and a goblin. What more could you ask for?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51053,'Did somebody call for a paladin?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51054,'Ahoy there, captain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51055,'What ho, fellow knights! Are we fully barded and armored? Then let us thrust ourselves deeply into that which they call adventure!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51056,'You have my sword.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51057,'Let\'s see what kind of trouble we can get into today.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51058,'Lok\'tar, hero. Today I fight with you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51059,'','My talons will slice you to shreds, invader.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51060,'Hello.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51061,'Let the slaughter begin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51062,'Here come Zen\'Kiki!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51063,'','Light be with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51064,'','The Earthen Ring stands behind you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51065,'The druids of DEHTA support your efforts here in Hyjal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51066,'I heard Azeroth needed saving. May I lend a hand?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51067,'I prefer my fish boiled AFTER they\'ve been caught. Let\'s put out these fires.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51068,'Lunk here to help.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51069,'','Da Darkspear fight alongside ya.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51070,'','Reporting for duty, commander.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51071,'Let me at \'em! I\'ll blast \'em off the side o\' the mountain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51072,'Congratulations. Today you will have the honor of fighting alongside me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51073,'Fire elementals must die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51074,'','Wait a minute... where am I? WHEN am I? Are we in Hyjal?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51075,'Calder Gray, reporting for mayhem... er, duty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51076,'Did somebody say Grapplehammer? No? Oh well, here I am.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51077,'If only Gidwin were here... he\'d love to see this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51078,'By Light be purged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51079,'Hah! I was expecting a challenge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51080,'I\'m fiiiighting!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51081,'Weee!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51082,'Bonk! Yes sir!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51083,'MRRRFFFFMMMMRRR!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51084,'MRRRFRRRR!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51085,'mmmmmMMMMMMRRRF!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51086,'Take that, dangerous enemy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51087,'Too bad for you... I brought my fists with me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51088,'Look out Ragnaros! You\'re next!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51089,'I\'ve got a history with fire elementals, you know. I consider myself somewhat of an expert on the subject.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51090,'Yeesh! These guys are really hot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51091,'Maybe after this, they\'ll take away my \"Initiate\" title.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51092,'Oh, don\'t MAKE me summon my troll-servant.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51093,'Behold the might that is Gurgthock!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51094,'You\'re about to enter your own personal arena of pain, jerk!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51095,'Haha! Yes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51096,'Johnny! Awesome!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51097,'You never stood a chance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51098,'','Stabby stabby stab stab!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51099,'','What\'s that? I can\'t hear you with my KNIFE IN YOUR FACE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51100,'','Oh yeah. Slinky\'s going to cut you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51101,'Nobody told me how big these guys were going to be.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51102,'Take that, ye stinkin\' fire-donkey!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51103,'For the Crusade! Hyaaah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51104,'I\'ve always wanted my very own dragon!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51105,'Come and get your pain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51106,'I am... a tauren... of the SEA!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51107,'Yarrr!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51108,'For Doloria!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51109,'Be slain by me, villainous cretin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51110,'Be proud, dragon. Today you fall to the blade of Azeroth\'s greatest hero. And also to my blade.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51111,'That was fun! Can I keep the kite, please?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51112,'Excuuuse me, princess!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51113,'Oh, boy! I\'m so hungry, I could eat a fire elemental!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51114,'I\'m not used to fighting with other people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51115,'I\'ve got a proposition for you: You die now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51116,'They used to call me Tony THREE-Tusk.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51117,'I\'m going to take you down to pain town.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51118,'For the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51119,'Blood and thunder!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51120,'LOK\'TAR OGAR!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51121,'For the Forsaken! For Lordaeron!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51122,'This one won\'t be coming back.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51123,'You\'ll get no mercy from me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51124,'RRRAAAAGGHHH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51125,'DIE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51126,'MY WIFE DIED, YOU MONSTERS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51127,'Zen\'Kiki really tempted to shapeshift right now...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51128,'De Cenarion Circle gonna getcha, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51129,'Dis is no problem for a mighty druid like Zen\'Kiki.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51130,'','Go with the Light.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51131,'','None escape the judgment of the Light.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51132,'','Confess your sins, and be forgiven!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51133,'','Leave Azeroth be!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51134,'','Azeroth has no place for you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51135,'','Be gone!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51136,'These abominations are responsible for the deaths of dozens of squirrels! They deserve no mercy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51137,'No surrender! No mercy! For AZEROTH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51138,'MRGLLL GLRRM GL! Translation: I will kill you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51139,'We ogres are not all bad.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51140,'You have the support of Ogri\'la.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51141,'We are friends of the world that you call Azeroth. I am happy to provide any assistance that I can.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51142,'Hook, line, and slaughter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51143,'You know, this isn\'t really my scene. I\'m glad to help, though.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51144,'I could use a nap right about now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51145,'You go away now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51146,'Lunk warn you one last time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51147,'Lunk no kill!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51148,'','De elements walk wit\' us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51149,'','Dese spirits don\'t belong!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51150,'','For de Darkspear!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51151,'My family has been running caravan routes in the Barrens since Orgrimmar was settled. We raise and train the kodos ourselves. My sister Nagala is the best kodo breeder outside of Mulgore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51152,'','Nature\'s fury overwhelms you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51153,'','Hyjal shall not fall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51154,'','Ancients be praised!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51155,'Blam! Right between the eyes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51156,'The thrill of the hunt, right lads?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51157,'I\'ve got a present for ye! Here, let me just get it out of my gun...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51158,'You have been tested... and you have failed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51159,'Time to fight fire with fire! And frost! And shadow!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51160,'You\'ve fallen right into my trap!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51161,'I think I knocked that one into next week.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51162,'I came all the way from Dalaran, and this is the welcoming I get?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51163,'The ruling council has ordered you banished. I plan to see those orders out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51164,'','I can\'t believe you guys are still fighting here in Hyjal. You should see what happens after this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51165,'','You know what time it is? That\'s right, it\'s time to DIE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51166,'','You just got Chromie\'d!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51168,'There\'s really nothing I enjoy more than the sound of screaming victims. Especially if they\'re MY victims.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51169,'You know the worst thing about fire creatures? No harvestable organs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51170,'Fire and rocks don\'t really do anything for me. I\'m really more of a flesh man.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51171,'You know what? You remind me of the Ambulatory Campfire prototype that I\'ve been working on.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51172,'If you can dodge a double-binary fluxcillometric auto-wrench, you can dodge a ball!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51173,'I\'m a genius!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51174,'What, are we done already?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51175,'Toodly-doo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51176,'Mrmrffmm. Ffm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51177,'Wait until the guys hear about this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51178,'Glad to be of service!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51179,'Back to work for me. I\'m a busy goblin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51180,'While you may be sad to see me go, I\'m sure you will enjoy watching me leave.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51181,'','Hey, good show out there!  You let me know if you need anything else stabbed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51182,'The Crusade appreciates the work you\'re doing out here, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51183,'Thanks for the opportunity to take it to Ragnaros.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51184,'You have, in the face of terrifying adversity, shown true valor and chivalry. From one glimmering beacon of heroism to another: I salute you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51185,'Well fought. Farewell, hero.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51186,'Until next time! Try to stay alive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51187,'You fight well, hero. I look forward to fighting by your side again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51188,'Dark Lady watch over you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51189,'Back to de plaguelands!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51190,'','Stand strong, combatants.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51191,'','Always know that you have allies in Deepholm, if you be needin\' us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51192,'And with that, I shall return to my research.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51193,'It is time that I returned to Ogri\'la. I hope you do not forget about us, as we have not forgotten you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51194,'So long, and thanks for all the fights!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51195,'Lunk think you killed too much bad guy. But Lunk still think you OK $g guy:lady;.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51196,'','Thank you for the opportunity. I shall report to Vol\'jin with your regards.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51197,'','I will never stop fighting to protect Hyjal. Not after all we\'ve done to heal her.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51198,'I hope ye had as much fun as I did.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51199,'This was not worth my time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51200,'Until we meet again... you know where to find me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51201,'','See you next time!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51202,'I should really be going. All this killing reminded me I still have some fresh corpses that aren\'t sewn to one another.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51203,'There we have it! Back to the labs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51204,'My rage is not silenced... but it is quieter. For now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51205,'Fall back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51206,'Belay your attack orders, men!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51207,'Stay your blades, heroes. This dragon\'s scales glow red with flame.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51208,'Everybody, stop your attacks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51209,'Hold your fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51210,'Hold your weapons!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51211,'Hold your attacks while the shield is up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51212,'Stop your attacks! Its shield will overwhelm you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51213,'I AM here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51214,'Bet you didn\'t know that a kodo can eat its own weight in grass each day. Sure is a lot to shovel when it comes out the other end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51215,'Handmade toys from all over Azeroth!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(51216,'','I can hear the howls of the Burning Blade as we speak. The kodos are ready to ride for the Mor\'shan Ramparts. Tell me when you are ready to leave.',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(51217,'Don\'t attack it while the shield is up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51218,'','Not now, mortal.$b$bI am here on urgent business.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51219,'Let\'s see what be wrong wit\' dis creature?','Let\'s see what be wrong wit\' dis creature?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51220,'','Da whispers of Hethiss gonna poison ya\' mind!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51221,'I\'m gonna turn ya\' blood ta venom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51222,'','Kilnara laughs maniacally.',0,0,0,0,0,0,153,0,1,0,0,0,26124),
(51223,'','You kill him - you kill my cat! Why must I suffer so?\n',0,0,0,0,0,0,396,0,1,0,0,24281,26124),
(51224,'','Stranglethorn belongs to da Gurubashi. You best be leavin\' before we bury you here.',0,0,0,0,0,0,396,0,1,0,0,24282,26124),
(51225,'','Or stay if you want. We always be needin\' more to sacrifice.',0,0,0,0,0,0,396,0,1,0,0,24283,26124),
(51226,'By the skin of our teeth, we made it! I haven\'t seen shooting like that since...well...ever! I wish we could ride together again, but Kadrak has more important work for you. Thank you for delivering us safely, my friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51227,'Thank you, old friend. Our warriors thank you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51228,'Good to see you again, friend. Make haste and hop on while the way is still clear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51229,'Look sharp! They\'re closing in on our heels!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51230,'Watch out above us! Use your rocket!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51231,'They\'re coming from all sides! Hang on just a little longer - we\'re almost there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51232,'Galenges is weakened by Malorne\'s Antlers! Attack him now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51233,'Good shooting! That one won\'t be getting up anytime soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51234,'','Do not take offense, $r.$b$bI simply haven\'t the time for distractions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51235,'','Forgive my abruptness, $c.$b$bPressing matters of great import require my undivided attention.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51236,'Ahh! What is the meaning of this!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51237,'A noble effort... but it will take more than one of your puny stags to take down Galenges, the UNBREAKABLE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51238,'','Ahh! There you are, $n.$b$bI must speak with you at once.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51239,'You stand no chance against me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51240,'Which one dares to challenge Galenges? Stand forward, weakling!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51241,'Da Gurubashi be takin\' our land back.','',0,0,0,0,0,0,396,0,1,0,24300,0,26124),
(51242,'We let you stay here too long.','',0,0,0,0,0,0,396,0,1,0,24301,0,26124),
(51243,'You tink you strong.  You tink you brave.  You tink you can survive.','',0,0,0,0,0,0,396,0,1,0,24302,0,26124),
(51244,'But we know...','',0,0,0,0,0,0,396,0,1,0,24303,0,26124),
(51245,'You and all you people, you already dead.','',0,0,0,0,0,0,396,0,1,0,24304,0,26124),
(51246,'An\' once you dead, den you serve da Gurubashi.','',0,0,0,0,0,0,396,0,1,0,24305,0,26124),
(51247,'Kill dese worms!','',0,0,0,0,0,0,396,0,1,0,24306,0,26124),
(51248,'Welcome to the Cold of Cold, friend! Our unique ice cream is chilled to order by one of Stormwind\'s finest apprentice mages!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(51249,'|TInterface\\Icons\\inv_misc_eye_04.blp:20|t%s begins to cast |cFFFF0000|Hspell:96920|h[Eyes of Occu\'thar]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51250,'Rocket launch in 3...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51251,'Rocket launch in 2...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51252,'Rocket launch in 1...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51253,'GO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51254,'Shh! I\'m working undercover here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51255,'What are you looking at?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51256,'Have we met?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51257,'I heard Tortolla was being held here, so I came over as quickly as I could.$b$bMount Hyjal is really tall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51258,'Are you ready to face Nemesis? I hope you have your totem ready.$b$bLet me know when you want to summon him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51259,'I am ready to meet with Anachronos, Ziradormi. ','I am ready to meet with Anachronos, Ziradormi. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51260,'I am prepared to face Nemesis, Tooga.','I am prepared to face Nemesis, Tooga.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51261,'NOW, YOUNG ONES! ATTACK THE PORTAL! FOR TORTOLLA!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51262,'I am ready to meet with Anachronos, Coridormi. ','I am ready to meet with Anachronos, Coridormi. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51263,'Ye don\' want ta\' be goin up dis\' way, mon.  Da spirits be restless.\n\nMebbe if ye\' know a ting or two about ancient artifacts, ye can fin\' a way to put dem to rest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51264,'','You mustn\'t tarry, $n.$b$bAnachronos awaits!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51265,'CLIMB.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51266,'','Sacrifice yo\' bodies ta Hethiss mah bruddahs, da voodoo will protect you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51267,'Though this artifact seems to be in pristine condition, you sense nothing particularly special about it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51268,'This artifact appears to be intact, though it is so thoroughly coated in dirt and mud that it is difficult to tell for sure.  There does not seem to be anything inherently magical about it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51269,'This artifact has weathered many storms, and shows significant signs of deterioration.  It is doubtful that any powers it once held remain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51270,'Several leaves and branches cling to this object, indicating that it may have been used as part of a nest for some creature.  There is otherwise nothing of note.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51271,'Several strange carvings adorn this object, perhaps made by the trolls in an attempt to decipher its origins.  They did not seem to meet with much success, as the object remains inert.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51272,'Mysterious runes adorn this artifact, though they appear to be unpowered at this time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51273,'This object is of low quality and is likely one of many fake artifacts that have been flooding the black market.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51274,'Several spots of dried blood can be seen on this object, likely a result of the struggle to obtain the artifact by the trolls.  The object is quite plain, however, and may not have been worth the struggle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51275,'','Ruby, do you want a treat?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51276,'','Ruby, play dead.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51277,'','Ruby, speak.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51278,'','Ruby, jump.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51279,'','Ruby, walk backwards.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51280,'','Ruby, dance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51281,'','Good girl, Ruby!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51282,'','That\'s a good widdle waptor!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51283,'','You\'re a smart girl, aren\'t you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51284,'','Yay! That was amazing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51285,'Wow, I never knew mages could make ice cream. That was good!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51286,'When I grow up, I want to put strange things together too!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51287,'What about... putting soap on a fork? Then it would have a handle and everything!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51288,'And when the soap\'s gone, you\'d have a new fork!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51289,'There is something odd about this particular object...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(51290,'Examine the object.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(51291,'This artifact has been cursed by the troll witch doctors!  At your touch, it begins to emit a foul glow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51292,'Be at ease, mortal. Our time together here must be productive, and unclouded by tension.$b$bMuch depends on your ability to think clearly and reason well.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(51293,'Examine the object.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(51294,'Examine the object.','Examine the object.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51295,'Let me see what you have for sale.','Let me see what you have for sale.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51297,'','Children, $n has brought a gift for you! Why don\'t you come take a look?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51298,'Wow, a surprise! I love surprises!','Wow, a surprise! I love surprises!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51299,'BOOO!  Did I scare you?$b$bHallow\'s End is all about two things, tricks and treats!  Some adults think it\'s more.  They tried to tell me, but I got bored, until things got set on fire.  That was cool!$b$bBut still, even fire can get boring.  I can tell you what doesn\'t get boring... Tricking people and eating candy!$b$bBut I only want one kind of candy, Candy Coins!  They are the best.  They look like real gold coins!  Also, if you have too many coins, you can eat them!  It\'s like being rich and eating your money!  It\'s crazy!$b$bSo... Do you have some coins you want to trade?','BOOO!  Did I scare you?$b$bHallow\'s End is all about two things, tricks and treats!  Some adults think it\'s more.  They tried to tell me, but I got bored, until things got set on fire.  That was cool!$b$bBut still, even fire can get boring.  I can tell you what doesn\'t get boring... Tricking people and eating candy!$b$bBut I only want one kind of candy, Candy Coins!  They are the best.  They look like real gold coins!  Also, if you have too many coins, you can eat them!  It\'s like being rich and eating your money!  It\'s crazy!$b$bSo... Do you have some coins you want to trade?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(51300,'Nagala will have her famous grilled zhevra chops waiting for us, no doubt. She says I need to cut back and eat more vegetables, but I don\'t think I\'ve gained that much weight...do you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51301,'I have some Candy Coins I would like to exchange.','I have some Candy Coins I would like to exchange.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51302,'Show me the sugar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51303,'Help! Let me go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51304,'This is the best!','This is the best!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51305,'Yes, Anachronos. I am ready to witness your vision of the future.','Yes, Anachronos. I am ready to witness your vision of the future.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51306,'','Aww Ruby, you\'re the best pet ever!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51307,'Greetings, $c. My name is Thork--I lead the defenses here in the name of the Warchief.$B$BI see you have had a chance to help out here at the Crossroads. Carry on for the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51308,'You can\'t catch me!','You can\'t catch me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51309,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51310,'Look at me, I\'m Uther Lightbringer!','Look at me, I\'m Uther Lightbringer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51311,'This is the biggest sword ever!','This is the biggest sword ever!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51312,'Eject! Eject! Auuuuugghhh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51313,'You overstepped your bounds, Jin\'do. You toy with powers that are beyond you. Have you forgotten who I am? Have you forgotten what I can do?!','',0,0,0,0,0,0,0,0,1,0,24244,0,26124),
(51314,'Ye want Deepmountain Mining and Jewelcrafting, over on the northern side of The Great Forge.','Ye want Deepmountain Mining and Jewelcrafting, over on the northern side of The Great Forge.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(51315,'You\'ll find a jewelcrafting trainer and supplies on the inner ring of the War Quarter.','You\'ll find a jewelcrafting trainer and supplies on the inner ring of the War Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(51316,'Go to inner ring of War Quarter.  You find jewel-making people there.','Go to inner ring of War Quarter.  You find jewel-making people there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(51317,'Thank you for your help.','Thank you for your help.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51318,'You saved my life!','You saved my life!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(51319,'Wha... What is going on?  The last thing I remember was sitting down to eat...','Wha... What is going on?  The last thing I remember was sitting down to eat...',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(51320,'Zombies... They are everywhere!','Zombies... They are everywhere!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(51321,'We were just trying to eat and suddenly zombies started to appear!','We were just trying to eat and suddenly zombies started to appear!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(51322,'The food, there is something wrong with the food!','The food, there is something wrong with the food!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(51323,'I had just about given up hope.','I had just about given up hope.',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(51324,'Oh, my stomach... That food really was awful.','Oh, my stomach... That food really was awful.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51325,'Listen well, mortal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51326,'Countless threads are woven to create the fabric of our timeline.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51327,'As the wardens of time, we of the bronze dragonflight observe their infinite combinations.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51328,'When disruptions are detected by our watchers, we are charged with their repair.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51329,'A recent event, obscured by powerful magics, remains masked even to me...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51330,'But the unavoidable outcome is plain:','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51331,'Azeroth will burn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51332,'While the details remain shrouded from our view, one thing we have gleaned...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51333,'The fate of Azeroth hinges on the deeds of a mortal druid.','The fate of Azeroth hinges on the deeds of a mortal druid.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51334,'The fate of Azeroth hinges on the deeds of a mortal mage.','The fate of Azeroth hinges on the deeds of a mortal mage.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51335,'The fate of Azeroth hinges on the deeds of a mortal priest.','The fate of Azeroth hinges on the deeds of a mortal priest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51336,'The fate of Azeroth hinges on the deeds of a mortal shaman.','The fate of Azeroth hinges on the deeds of a mortal shaman.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51337,'The fate of Azeroth hinges on the deeds of a mortal warlock.','The fate of Azeroth hinges on the deeds of a mortal warlock.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51338,'Are you the mortal on which so much depends?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51339,'The cub bats one paw at a tiny insect, only taking note of your attention when the plaything flies away.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51340,'The cub nuzzles your hand and purrs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51341,'A blacksmith and his assistant can be found working in the Warrior\'s Terrace, near the armor and weapon vendors there.','A blacksmith and his assistant can be found working in the Warrior\'s Terrace, near the armor and weapon vendors there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51342,'Your little cub nips and paws at the air, eager to try out his hunting skills.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51343,'The cub sniffs your hand and decides you\'re not a threat... this time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51344,'At least one Gilnean engineer works out of the Craftsmen\'s Terrace. She should be able to help you.','At least one Gilnean engineer works out of the Craftsmen\'s Terrace. She should be able to help you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51345,'Ah, you seek the Silverdews in the Craftmen\'s Terrace. They\'ve only recently set up shop, near the enchanter\'s.','Ah, you seek the Silverdews in the Craftmen\'s Terrace. They\'ve only recently set up shop, near the enchanter\'s.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51346,'Blacksmithing','Blacksmithing',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(51347,'Engineering','Engineering',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(51348,'Mining','Mining',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51349,'A pair of skilled miners fled plague-ridden Gilneas and made their way here. You\'ll find them in the Craftsmen\'s Terrace.','A pair of skilled miners fled plague-ridden Gilneas and made their way here. You\'ll find them in the Craftsmen\'s Terrace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51350,'Millagazor begins to escape!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51351,'You pests are not worth my time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51352,'Who summons Millagazor?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51353,'You must be looking for Palehoof, who keeps our elevators and windmills in good working order. Find him upon the lower rise.','You must be looking for Palehoof, who keeps our elevators and windmills in good working order. Find him upon the lower rise.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(51354,'Seek the Cloudchasers upon the lower rise. They should be able to help you in all matters of jewelcrafting.','Seek the Cloudchasers upon the lower rise. They should be able to help you in all matters of jewelcrafting.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(51355,'I\'ve seen goblins riding these things. I know they can go faster!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51356,'I wonder what this button does...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51357,'Now THAT\'s more like it!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51358,'I\'ve figured out how this works. I\'m taking control!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51359,'Hang onto your, um... helmet!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51360,'No, rocket! Don\'t go that way!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51361,'I\'m losing control!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51362,'This is the only button I haven\'t pushed yet. Let\'s give it a try!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51363,'Something unnatural is going on, Bwemba.  Can you help?','Something unnatural is going on, Bwemba.  Can you help?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51364,'','You wanna be talkin\' to da spirits?  Well let\'s see what we can do... ',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(51365,'I think I found the emergency button. Rockets have those, don\'t they?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51366,'','You gotta be Bwemba\'s hands on dis one... I need ya to toss some sticks into da bonfire in da center of dis camp.  Den Bwemba can handle da rest.',0,0,0,0,0,0,396,0,1,924,0,0,26124),
(51367,'','Mauri\'s death removes the protections from a nearby cauldron!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51368,'T\'kulu\'s death removes the protections from a nearby cauldron!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51369,'This is gonna be fun!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51370,'I did it! I got us back on track!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51371,'Jump to shake off the Cinderlings!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51372,'Wow, so you\'re the Banshee Queen? I kind of expected you to be taller!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51373,'Everyone says you had a fight with the warchief and you\'re going to abandon the Horde. Is that true?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51374,'','I do not require defending, ambassador. Young one, as I have told the warchief, my loyalties have never been in doubt.',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(51375,'','The Horde embraced my people when we stood alone and we Forsaken never forget a debt...',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51376,'','Garrosh and I will always do what is best for our people.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51377,'So it\'s not true? Thank the ancestors! I wouldn\'t want you to be my enemy, Lady Sylvanas.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51378,'You forget yourself, child! Do you know who stands before you?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(51379,'Your grip is loosening! Climb down the tree quickly!','Your grip is loosening! Climb down the tree quickly!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(51380,'The mortal coil unwindsss...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51381,'Your sssacrifice pleases him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51382,'Let the coils of death unfurl!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51383,'My death means...nothing...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51384,'Ahaha, get a load \'a me, mon!$b$bGriftah be back again! New stall, and brand new wares, and ready to pass on the deals to ya!$b$bWant to be better, stronger, faster? Each one of these amulets be guaranteed to do just what I say they be doin\'. Step up and buy one of these miraculous baubles! Cheap at twice the price!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51385,'There is no end to these trolls, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51386,'Can one of your gryphons get me to the Digsite?','Can one of your gryphons get me to the Digsite?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51387,'You have my thanks, friend.','You have my thanks, friend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51388,'Thank you. I\'ll be sure to slay a few spiders on my way back to camp.','Thank you. I\'ll be sure to slay a few spiders on my way back to camp.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51389,'You don\'t want to know what it was like in there.','You don\'t want to know what it was like in there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51390,'Thank you for freeing me. I thought I was done for.','Thank you for freeing me. I thought I was done for.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51391,'Thanks for getting me out of there! That was awful.','Thanks for getting me out of there! That was awful.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51392,'S-s-s-st-sticky....','S-s-s-st-sticky....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51393,'Thank you! Now to see about this burning sensation...','Thank you! Now to see about this burning sensation...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51394,'','Ahh, dere you are!  We been searching da entire jungle for ya!',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(51395,'','Da help\'s been good.  Da Zandalar plan has set da Gurubashi on da warpath.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(51396,'','Not all da places held together so well.  We try to help as much as we can.  But da source, it be Zul\'Gurub.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(51397,'If you can keep my town safe,  I\'ll definitely make it worth your while.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(51398,'Good work Bwemba.  It be good to see dat dere be Alliance willin\' to help stop da Zandalar.','',0,0,0,0,0,0,396,0,1,924,0,0,26124),
(51399,'','Da Gurubashi be usin\' all sorts of voodoo to reclaim dere land.',0,0,0,0,0,0,396,0,1,12090,0,0,26124),
(51400,'','Zanzil!',0,0,0,0,0,0,396,0,1,12065,0,0,26124),
(51401,'I see you were able to get some help.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(51402,'I know.  It be why I went around, to warn everyone.   When da leader of da Darkspear speak, everyone listen, Horde an\' Alliance.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(51403,'Den dat be where we go next.  We gonna stop dis uprising at da source.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(51404,'Good work Bwemba, you an\' your friend, make da Darkspear proud.','',0,0,0,0,0,0,396,0,1,923,0,0,26124),
(51405,'I got a few more tings to discuss here.  Den I\'ll head to Zul\'Gurub.  I will see you dere.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(51406,'','Now let\'s see what Bwemba\'s conjured up...',0,0,0,0,0,0,396,0,1,12089,0,0,26124),
(51407,'','Dis is serious business.  Venoxis ain\'t one to trifle wit\'.',0,0,0,0,0,0,396,0,1,12089,0,0,26124),
(51408,'','Ah... It be Kilnara.  I shoulda known she be involved here.',0,0,0,0,0,0,396,0,1,12090,0,0,26124),
(51409,'','I don\'t believe my eyes... Is dat Bloodlord Mandokir?  Dis gonna be bad...',0,0,0,0,0,0,396,0,1,12093,0,0,26124),
(51410,'','Dese Gurubashi mean business.  We gotta help dese people.',0,0,0,0,0,0,396,0,1,12093,0,0,26124),
(51411,'%s surges toward the most distant player!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51412,'Elders of Thunder Bluff, I have called you together in the sight of the ancestors to honor my father, Cairne Bloodhoof.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51413,'Father, you were a man who led wisely, who battled skillfully, and who always sought the best for your people.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51414,'May your spirit continue to guide us, father, as you did in life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51415,'When my druids and I were ambushed by renegade orcs, you challenged Warchief Garrosh to trial by combat to answer for their deaths, chieftain.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51416,'You fought bravely, chieftain, but Grimtotem treachery poisoned Garrosh\'s weapon and denied you fair combat.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51417,'May your spirit know peace. Magatha and her kin were driven from the city and your worthy son carries on your legacy.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51418,'','We know you, Cairne Bloodhoof, and your people have told us of your deeds. You are welcome at the hearth of the ancestors.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51419,'So this is how a chieftain is honored!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51420,'Landro\'s Lichling','Landro\'s Lichling',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51421,'Fool\'s Gold','Fool\'s Gold',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51422,'','Not bad, champion! What they say about you is true. However, we part ways here. I must go deal with this prisoner...personally.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51423,'Savage Raptor Mount','Savage Raptor Mount',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51424,'Nightsaber Cub','Nightsaber Cub',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51425,'War Party Hitching Post','War Party Hitching Post',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51426,'Amani Dragonhawk','Amani Dragonhawk',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51427,'','Quickly! Lure the enemy onto my trap!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51428,'War of the Elements','War of the Elements',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51429,'Twilight of the Dragons','Twilight of the Dragons',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51430,'Only time will tell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51431,'What about... putting soap on an axe? Then it would have a handle and everything!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51432,'And when the soap\'s gone, you\'d have a new axe!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51433,'','Children, $n has brought a surprise for you! Come and take a look at your gift!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51434,'Look at me, I\'m High Overlord Saurfang!','Look at me, I\'m High Overlord Saurfang!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51435,'If the snakes don\'t kill us, the panther will!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(51436,'The eyes... I can\'t stop thinking about it\'s eyes!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(51437,'The hissing never stops.  The serpents keep coming!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(51438,'There is no safe place to hide!','',0,0,0,0,0,0,430,0,1,0,0,0,26124),
(51439,'The panther is hunting us, it can\'t be a good idea to stay in one spot.  We\'ve got to leave!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(51440,'We\'re doomed...','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(51441,'So many hunters have been taken by that beast... ','',0,0,0,0,0,0,430,0,1,0,0,0,26124),
(51442,'This jungle is going to be the end of us all.','',0,0,0,0,0,0,430,0,1,0,0,0,26124),
(51443,'I can\'t get those eyes out of my head...','I can\'t get those eyes out of my head...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51444,'With Mauti still out there, it may be better to die from this poison.','With Mauti still out there, it may be better to die from this poison.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51445,'Don\'t let that panther drag me off... Put me down if it comes to that.','Don\'t let that panther drag me off... Put me down if it comes to that.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51446,'If anyone can track Mauti, Grent can.  Once the panther is taken care of, then all we have to do is worry about the serpents.','If anyone can track Mauti, Grent can.  Once the panther is taken care of, then all we have to do is worry about the serpents.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51447,'Did you hear that?  I thought I just heard Mauti over there...','Did you hear that?  I thought I just heard Mauti over there...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51448,'Endless serpents and a giant panther... It can\'t get much worse than this.','Endless serpents and a giant panther... It can\'t get much worse than this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51449,'I can feel Mauti watching us... Waiting for another chance to pounce.','I can feel Mauti watching us... Waiting for another chance to pounce.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51450,'So many dead serpents... If only I had kept up with my skinning...','So many dead serpents... If only I had kept up with my skinning...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51451,'Whooooooooooa!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51452,'','$n, it is good to see you. Have you come to help push the front for us?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51453,'','You needn\'t worry, child. The warchief\'s \"observers\" are here to make certain of that.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51454,'','The elemental forces are relentless. I fear we\'ll not be able to hold this breach forever. Not without more help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51455,'Lylagar is offended by your inferior howl.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51456,'Lylagar lets out a pitiful whimper.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51457,'Use the Emerald of Aessina to cleanse yourself of Pyrachnis\' poison!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51458,'','I could be convinced to part with one... IF you\'ll promise to give the cub a good home.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(51459,'','What foolishness is this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51460,'','You there! Have your senses abandoned you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51461,'','Coldarra is no place for mortals now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51462,'','You must flee at once, if you value your life.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51463,'','Access to Coldarra has been forbidden to the lesser races, $c.$b$bYour life is in grave danger here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51464,'%s begins to erupt, spewing Lava Parasites onto the ground!','',0,0,0,0,0,0,0,0,1,0,8717,0,26124),
(51465,'','Speak quickly, mortal, before you are discovered by one less discriminating than I.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51466,'It\'s a difficult job keeping the steam tanks up and running by yourself, but someone has to do it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(51467,'Chopper rentals are free in honor of Children\'s Week. Just hop onto one and cruise beautiful Westfall!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(51468,'I need another Wolvar Orphan Whistle.','I need another Wolvar Orphan Whistle.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(51469,'Ye shoulda seen it, $n! Moira comes down here ta talk ta the stone, as she\'s wont ta do in tryin\' times. I left \'em alone, least I could do fer a daughter and her pa.\n\nThen there\'s a crack and a crash like ye\'ve never heard, an\' I rushed back in to see what happened. An\' there\'s Magni, walkin\' and talkin\', made o\' crystal from head ta toe! \n\nHis voice rumbled like a mountainslide, tellin\' us he speaks fer the land now, that he\'s a PART o\' Azeroth. Didn\'t take him but a moment ta give the clan leaders a dire warning o\' the Legion\'s return, then he up an\' left fer a walkabout!$b$bHe muttered somethin\' \'bout Ulduar. I sent word to his brother Brann. Hope he kin find Magni an\' get to the bottom o\' this!','',5,1,603,0,200,200,0,0,1,0,0,0,26124),
(51470,'I should\'ve broken those damn tablets the day you brought them to me, $n, but I didn\'t. We might still have our king\'s wisdom to guide us through these perilous times.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(51471,'Ragnaros, I call upon your power to aid me!','Ragnaros, I call upon your power to aid me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51472,'Master, fill me with your glorious radiance!','Master, fill me with your glorious radiance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51473,'Lord Ragnaros, grant me your everlasting fire!','Lord Ragnaros, grant me your everlasting fire!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51474,'','It\'s no use! Their shield is too strong!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51475,'','Da Zandalari, dey gone mad.  We gotta make sure dey be stopped.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51476,'','Da Darkspear don\'t want any ting to do wit da plans of da Zandalari.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51477,'','Venoxis, he be controllin\' da serpents.  He be a wily one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51478,'','Venoxis be a master of poisons, he be a deadly foe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51479,'','Kilnara, she be crazy about panthers.  ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51480,'','Did you see da eyes of Mauti?  Dey were glowing bright!  I shoulda know den dat Kilnara be behind da panther attacks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51481,'','Good work, champion. I will take this foul creature back with me. This druid has much to answer to.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51482,'','Minions of the Firelord, lay waste to these invaders! The Guardians of Hyjal shall burn for their arrogance!',0,0,0,0,0,0,397,0,1,0,0,24924,26124),
(51483,'','You will all suffer the wrath of Ragnaros!',0,0,0,0,0,0,22,0,1,0,0,24925,26124),
(51484,'','DIE!!!',0,0,0,0,0,0,22,0,1,0,0,24926,26124),
(51485,'','No matter. I shall watch Hyjal burn from afar.',0,0,0,0,0,0,1,0,1,0,0,24927,26124),
(51486,'Zanzil mutters to himself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51487,'A pinch of dis... A dash of dat... Heh, heh!','',0,0,0,0,0,0,0,0,1,0,24346,0,26124),
(51488,'Oh Zanzil, Zanzil. I jes\' love dat voodoo dat you do. ','',0,0,0,0,0,0,0,0,1,0,24347,0,26124),
(51489,'Slaves... Zombies... It don\'t matter to Zanzil. Dey all serve Gurubashi, one way or de other...','',0,0,0,0,0,0,0,0,1,0,24348,0,26124),
(51490,'Druids, hold your fire! She is unarmed!','',0,0,0,0,0,0,22,0,1,0,24855,0,26124),
(51491,'Wait a moment... I know that girl. Leyara, is that you?','',0,0,0,0,0,0,22,0,1,0,24963,0,26124),
(51492,'','Your skills in combat are admirable, hero. Keep yourself useful on the battlefield. I will take this criminal back for...questioning.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51493,'','I am impressed, hero. Thank you for helping me subdue this...druid. I can take this heretic back on my own.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51494,'A flame druid... she is dangerous, Malfurion. You know her?','',0,0,0,0,0,0,22,0,1,0,24856,0,26124),
(51495,'Yes, Hamuul. And she\'s more dangerous than you know.','',0,0,0,0,0,0,22,0,1,0,24964,0,26124),
(51498,'This is a child of Beth\'tilac, the Red Widow. Her spawn will seek vengeance for their slain brethren.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51499,'The young raptor looks up at you. You can\'t be certain, but you think you see a flicker of recognition in her eye.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51500,'Da Zandalari must be stopped. Wit\' all da trolls of Azeroth at their command, dey would be a threat to all of us.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(51501,'Da Zandalari be a threat to both our peoples, $r. It will take da stength o\' both our forces to break them.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(51502,'Lord Ragnaros! Shield me!','Lord Ragnaros! Shield me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51503,'We\'re ready to open the gates.','We\'re ready to open the gates.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(51504,'Follow me, $c. It be takin\' da both of us to open these gates.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51505,'','Hey $n, you\'re here!  These guys came out of nowhere!  Help me out while I catch my breath.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51506,'Da ritual to open da gates be requirin\' both of us to hit da gong together.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51507,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51508,'Perhaps we\'re not ready yet. Speak to me again when you be wantin\' to open da gates.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51509,'I have agreed to this meeting, worldbreaker, but at great risk. If this is discovered...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51510,'And once the new order is established? My place will be secure, yes?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51512,'Calm yourself, Arygos. Your barrier will buy you all the time you need.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51513,'With Kalecgos dead, your destiny as the Blue aspect shall be realized. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51514,'Your reign over the realm of magic will be absolute, even after the Hour of Twilight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51515,'But be warned, Arygos, son of Malygos. Do not make the mistakes of your father.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51516,'Cross me, and your punishment shall be far greater than the madness he suffered.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51517,'Hear me, Zandalari schemers... Da Darkspears and our allies will deny you rulership of da Amani!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(51518,'Protect Thisalee from the fire elementals!','Protect Thisalee from the fire elementals!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51519,'Da Amani know we\'re here. Now is da time to attack! ','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(51520,'','Greetings, $c. The Fire Lord has twisted our former brothers and sisters into avatars of molten fury. Even now, the Druids of the Flame carry out his insane plan to destroy the World Tree. We will not let that happen.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51521,'Look, Anren! $n has come to help us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51522,'Protect Tholo and Anren from the fire elementals!','Protect Tholo and Anren from the fire elementals!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51523,'Your arrival is timely, $r.  I tire of fighting these wretched things.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51524,'Protect Elderlimb from the fire elementals!','Protect Elderlimb from the fire elementals!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51525,'','My blade is yours, champion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51526,'','Elune greet you, champion. I will watch your back.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51527,'','Call for aid and the Shadow Wardens will answer. I am ready for anything.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51528,'','Reporting for duty. There is no time to lose.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51529,'','My blade thirsts for battle. Do not keep me waiting.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51530,'','I can handle things from here. I\'ll meet you back at the Sanctuary, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51531,'Thank you, $n. As long as we stay together, Anren and I will be fine. Go check on the others!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51532,'I can hold them off from here, $r. We will meet again at the Sanctuary of Malorne.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51533,'','Justice will be served, heathen!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51534,'','I will show no mercy to the defiled!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51535,'','I promise this won\'t hurt...too much.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51536,'','Ask not for mercy. My blade will not grant it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51537,'','I will deliver my enemies to their ancestors!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51538,'','Fire burns many things, but it cannot touch a shadow.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51539,'','I will cleanse your sins with the edge of my dagger.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51540,'','Where dere be zombies, dere be Zanzil.  Da Zandalar trolls be makin\' da Gurubashi work all of dere mojo to take back Stranglethorn.',0,0,0,0,0,0,396,0,1,12065,0,0,26124),
(51541,'My heart is heavy with the burden of this war. I lead my people to their deaths. But if we cannot stand against Ragnaros now, how will we withstand Neltharion?$B$BWe must fight with everything we have, or witness the destruction of our world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51542,'I am with you, Tholo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51543,'Stay on my back, Tholo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51544,'We must stay together, Tholo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51545,'You are a good friend, Tholo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51546,'I have your back, Tholo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51547,'I will stay with you, Anren!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51548,'You are a good friend, Anren!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51549,'I will protect you, Anren!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51550,'Together we can do anything, Anren!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51551,'I am here, Anren!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51552,'You must stay by Thisalee\'s side!','You must stay by Thisalee\'s side!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(51553,'You must stay by Tholo and Anren\'s side!','You must stay by Tholo and Anren\'s side!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(51554,'You must stay by Elderlimb\'s side!','You must stay by Elderlimb\'s side!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(51555,'Once da high priest is dead and da coast is clear, let me know and I be returnin\' to the blood guard wit\' my report.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(51556,'You kill the trollbear, mon? It be safe for me to make my way back now?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(51557,'Hello out there. Anybody be hearin\' Hazlek?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51558,'Hey! Don\'t ya be forgettin\' about Hazlek over here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51559,'I could be pickin\' this lock in my sleep. Just come an\' say when it be safe to make my escape.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51560,'At last, I be free!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(51561,'Here be some of my things....','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(51562,'There now. It be a gift to you, to help wit\' defeatin\' da Amani!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(51563,'It\'s good to be outta dat cage. Dey were goin\' to sacrifice me...','',5,1,0,0,500,0,0,0,1,0,0,0,26124),
(51564,'You don\'t have to worry about that anymore. What\'s going on here?','You don\'t have to worry about that anymore. What\'s going on here?',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(51565,'Ok mon, this be what I saw....$b$bAll was quiet, til we be hearin\' a rustlin\' sound, like the wind through the trees. Before we know it, we be surrounded by these Amani and their pets! Next think I knew, I be wakin\' up here, stuck in a cage.$b$bDay an\' night, one by one, da captured scouts be gettin\' killed. Every time one be dyin\', that bear-troll be lookin\' stronger.$b$bThat be all I could learn from my place in dat cage.','',5,1,1,0,500,1000,0,0,1,0,0,0,26124),
(51566,'','Are you here to aid da Darkspear, $c?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51567,'Ya have my tanks, $c. I thought I\'d be endin\' up just another sacrifice...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(51568,'Don\'t be forgettin\' about me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51569,'How about comin\' over here an\' helpin\' me outta here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51570,'I got information dat Vol\'jin needs. Help me outta here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51571,'Don\'t go leavin\' the job half done. Come an\' tell me if it be safe to make my report!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51572,'It be good to be free again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51573,'','I be an emissary from da Darkspear trolls.  Da threat we face, also be a threat to da Alliance.  You willin\' to help out da Darkspear, $r?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51574,'Allow me ta show you something I discovered. Now where\'d I see dat satchel?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51575,'','Dis is Fort Livingston?  It look like we already too late.  Da Zandalar attack, it begun.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(51576,'','Oh no... Bambala...  It look like we already too late.  Da Zandalar attack, it begun.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(51577,'Help yourselves. It be suicide for a scout to walk around wit\' so much weighing me down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51578,'','Da hunters seem to be holdin\' da serpents off.  But sometin\' else feel wrong... Like we bein\' watched.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(51579,'Ya be havin\' me gratitude, $c.$b$bIf there be anythin\' I can be doin\' for ya, just say so.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(51580,'','Da Digsite, it be overrun with zombies...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(51581,'','Da Hideaway, it be overrun with zombies...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(51582,'Dis place not be so bad if only dere weren\'t so many Amani \'ere.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(51583,'Da Amani and da Zandalari will never try somethin\' like this again.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(51584,'Vol\'jin will show dose Zandalari not to mess wit\' da Darkspears.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(51585,'Dis be a grisly business. I be happy when it be over and we go home again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51586,'','This place be reekin\' of death and sacrifice.$b$bBest you leave before you become da next prisoner.\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51587,'','My liberators! Come down and have a word wit\' Norkani.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51588,'','Norkani still be needin\' your help!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51589,'','I must be returnin\' to Vol\'jin wit\' my report! Help me outta here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51590,'','At last, Norkani is free!\n',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(51591,'','Now, where have dey put Norkani\'s things?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51592,'','Stand clear....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51593,'','Please take dis. Norkani be havin\' no use for it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51594,'','It be good to be outta dat cage. Norkani will have her revenge...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51595,'','Where am I? You be here to help?',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(51596,'They must\'ve drugged you. It\'s safe now.','They must\'ve drugged you. It\'s safe now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51597,'','Dey\'ve done something to me! I be needin\' help!',21,1,1,0,1000,500,0,0,1,0,0,0,26124),
(51598,'','I be hearin\' ya an\' I think ya not be my captors. Come closer so I be seein\' ya.',1,1,1,0,1000,500,0,0,1,0,0,0,26124),
(51599,'','My head be swimmin\'. Please, I be beggin\' ya!',1,1,1,0,1000,500,0,0,1,0,0,0,26124),
(51600,'','Things be comin\' back. I be here for... a mission... Help me outta here. Dere\'s things to be done.',1,1,1,0,1000,500,0,0,1,0,0,0,26124),
(51601,'','Voodoo be gone!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51602,'','Be free from da voodoo!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51603,'','You be free from da voodoo now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51604,'','Spirits let dis one return to us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51605,'','Weeee! I\'m alive, I\'m alive, I\'m alive! Oh, I hope it\'s not too forward of me to tell you that I think I love you all and I hope I can find my bag because you certainly deserve a little something extra, you know, for the effort and all that you must have went through to save me...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51606,'Come brothers and sisters. It is time to take this foul tower from the hands of our enemies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51607,'Press on!  Push towards the tower!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51608,'Their leader is here! Strike him down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51609,'','It is time, $c.$b$bLet us see what has been so carefully hidden...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51610,'','Dere was a shrine to serpents just to da east of Bambala, I need ya to toss some sticks into da bonfire in front of dat shrine.  Den Bwemba can handle da rest.',0,0,0,0,0,0,396,0,1,923,0,0,26124),
(51611,'Ancients of Zandalar, grant dis one da power ta\' mock death itself!','',0,0,0,0,0,0,0,14,1,0,0,0,26124),
(51612,'What brings you to me, mortal?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51613,'Speak freely, friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51614,'Something about you seems... familiar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51615,'My vision in the Eye of Eternity haunts me, Kalecgos. What do you make of it?','My vision in the Eye of Eternity haunts me, Kalecgos. What do you make of it?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(51616,'There is a great deal at stake within the blue dragonflight, $c.$b$bSoon, a new aspect must be chosen to take the place of Malygos.$b$bArygos aspires to follow in the footsteps of his father, renewing the misguided aggression against all who wield magic. This path, I feel, would lead to the end of our kind.$b$bThe remnants of our flight are divided on this fateful issue, and I fear that Arygos will stop at nothing to meet his ends...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51617,'Who is Tarecgosa? I could not have made it through the Nexus without her.','Who is Tarecgosa? I could not have made it through the Nexus without her.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(51618,'<Wistfully, Kalecgos looks off to the horizon.>$b$bTarecgosa is... special to me.$b$bWhen she was but a hatchling, I was charged with her protection and education. Over the millennia, we have forged a special bond, not unlike what you would call siblings.$b$bTarecgosa was born under a special sign that foretold of a great destiny. If the prophecies are true, then her survival is of vital importance to the blue dragonflight, and to Azeroth itself.$b$bOur affinity for one another is well known within the remnants of our flight. If your vision recounted an event that has actually taken place, she could be in grave danger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51619,'','$n, our forces are pushing up the ramp. You should join them there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51620,'','$n, our forces are pushing up to the tower already. You should join them, quickly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51621,'','$n, our attack should be ready shortly. Wait here and push up the ramp with them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51622,'','Turak, Marin, lead these forces up the ramp and take the tower! Be swfit!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51623,'','Deldren, Shalis, these men are yours to lead. Take the tower.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51624,'','Keeper Taldros, I am sending Sira and the others with you to help you take the tower. Elune be with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51625,'Ancestors be beside me, let \'dem hear yo\' voice!','',0,0,0,0,0,0,0,14,1,0,0,0,26124),
(51626,'','$n, our forces are about to push up the ramp. You should join them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51627,'','These trolls have made a grave mistake, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51628,'I need use of a wyvern to fly me to where the Darkspear emissary went.','I need use of a wyvern to fly me to where the Darkspear emissary went.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51629,'Shower of Flame incoming! Don\'t stop moving!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51630,'Ancients of Zandalar, mark \'dem for de black road.','',0,0,0,0,0,0,0,14,1,0,0,0,26124),
(51631,'Ahh, it is good to see you again, $r.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(51632,'Zul has seen tha\' future.  We gotta come together, or we all fall to de darkness.','',0,0,0,0,0,0,1,14,1,0,0,0,26124),
(51633,'\'Dis be de only way, bruddahs.','',0,0,0,0,0,0,1,14,1,0,0,0,26124),
(51634,'Dis land was taken from us in a tide of blood.','',0,0,0,0,0,0,1,14,1,0,0,0,26124),
(51635,'De green fist of de troll empire gonna crush dis land and make it our own again.','',0,0,0,0,0,0,1,14,1,0,0,0,26124),
(51636,'De Zandalari got powers you never seen.  Wisdom of de most ancient of trolls, wisdom dat\'s rightfully yours.','',0,0,0,0,0,0,1,14,1,0,0,0,26124),
(51637,'Dis shattered world not done breakin, mon.','',0,0,0,0,0,0,1,14,1,0,0,0,26124),
(51638,'De tides of darkness gonna take over.  All da trolls be in danger.','',0,0,0,0,0,0,1,14,1,0,0,0,26124),
(51639,'De Darkspear be foolish.  No one gonna stand in our way.','',0,0,0,0,0,0,1,14,1,0,0,0,26124),
(51640,'','It is already determined.  You have no hope... the flames shall consume all!',0,0,0,0,0,0,0,0,1,0,0,24917,26124),
(51641,'You... you\'re the one from the portal... the druid of flame...','',0,0,0,0,0,0,0,0,1,0,24851,0,26124),
(51642,'You killed dozens of my students.  You will pay for what you\'ve done.','',0,0,0,0,0,0,0,0,1,0,24852,0,26124),
(51643,'','Enough of this!',0,0,0,0,0,0,0,0,1,0,0,24918,26124),
(51644,'What is this?  I... can\'t move!  Someone, help!','',0,0,0,0,0,0,0,0,1,0,24853,0,26124),
(51645,'','Burn, tauren!  BURN!!',0,0,0,0,0,0,0,0,1,0,0,24919,26124),
(51646,'','Have you had enough yet? Have you felt enough pain?',0,0,0,0,0,0,0,0,1,0,0,24920,26124),
(51647,'','Now, look before you! One of Azeroth\'s most powerful \"druids\", reduced to nothing but a charred husk. Such is the will of Fandral Staghelm. Such is the will of the flame!',0,0,0,0,0,0,0,0,1,0,0,24922,26124),
(51648,'','Go on, then. Weep over the body of your precious tauren... though I assure you that your tears will not bring him back.',0,0,0,0,0,0,0,0,1,0,0,24923,26124),
(51649,'','Dat be so much better. I be weak, but I remember hearin\' da Amani and da Zandalari talkin\' about treasure hidden in dis very room.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51650,'','Maybe it be in dis urn over here. Stand back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51651,'','Hmm. Dat\'s not da one. Let\'s try one o\' da other vases.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51652,'','Dere be somethin\' in dat one. Go take look.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51653,'','Ya have my gratitude for gettin\' me outta dat cage. My wits are finally returnin\' an\' I\'ll be able to tell Vol\'jin what I learned.\n',1,0,0,0,1000,500,0,0,1,0,0,0,26124),
(51654,'','Nevermind me, $r. $b$bNorkani as good as dead. Leave now, $r, before da Amani get you too.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51655,'','Help me outta here, $r. First, you gotta kill da Amani priest who captured me. He be preparin\' to sacrifice me!\n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51656,'I be one o\' da Darkspear scouts. Kill dat Amani priest so I can return wit\' my report!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51657,'Da warlord has fallen!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(51658,'Hear me, Rastakhan! Wherever ya and your Zandalari be schemin\' to rule da troll people, ya be findin\' da Darkspear and our allies standin\' against ya!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51659,'I am prepared to accompany you, Kalecgos.','I am prepared to accompany you, Kalecgos.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(51660,'What... what has happened?','',0,0,0,0,0,0,0,0,1,0,25156,0,26124),
(51661,'$n, I will attend to the Archdruid. Malfurion and Matoclaw have requested your presence immediately.','',0,0,0,0,0,0,0,0,1,0,25157,0,26124),
(51662,'','Fool! Be bathed in the flames!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51663,'Tarecgosa!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51664,'Well done, friends! The tower is ours! Now I shall see to the destruction of this foul monument.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51665,'','Well done, $n. It looks like we have them on the run.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51666,'What is the meaning of this?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51667,'Planting','Planting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51668,'I bring word from the Regent Lord of Silvermoon.','',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(51669,'Lord Lor\'themar demands an explanation for the presence of this... exile in our lands.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(51670,'','Quel\'Thalas is as much my home as it is yours and I would not see it fall to our ancient enemy. Now, you tell your cowardly regent --',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51671,'Vereesa, please! ','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(51672,'She is here at my invitation, courier. Most of my Farstriders are away and cannot be recalled easily. Vereesa\'s rangers know the land and they are experienced combatants. ','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51673,'Lord Lor\'themar does not concur with your reasoning, ranger-general. You have no authority to invite this --','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51674,'I am the commander of Silvermoon\'s defenses and I will seek assistance as I deem necessary! ','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(51675,'Now, Chieftain Vol\'jin, before we were so rudely interrupted, you were telling us of the Zandalari plan. ','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51676,'Dat I was. Da Zandalari called a meeting  o\' all da troll tribes includin\' da Darkspears. ','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51677,'King Rastakhan, he be plannin\' to unite da troll tribes under his Zandalari.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51678,'','Including the Amani? ',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(51679,'Da Amani, da Gurubashi, all o\' dem. He be dispatchin\' emissaries to every tribe. ','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51680,'My scouts have reported nothing but quiet outside Zul\'Aman. ','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51681,'Dey be holed up inside da ruined city, regroupin\'. ','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51682,'Rastakhan be callin\' me his brother, but da Horde be our true brothers. We gotta stop him before he can sweet-talk da others into joinin\' his empire.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(51683,'','So how are we going to deal with this alliance between the Amani and the Zandalari? ',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(51684,'We must prevent it from occurring in the first place. ','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51685,'Dat be da plan. My men be infiltratin\' da city and learnin\' what dey can about da new Zandalari warlord. ','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51686,'','Halduron, we should combine our forces and make preparations to act on reports from the Darkspear scouts.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51687,'Agreed. Messenger, you may carry word of our plans back to Lord Lor\'themar, but make it clear that I will not tolerate any further interference. ','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51688,'I seem to have... misplaced my wisp. Are there any others available?','I seem to have... misplaced my wisp. Are there any others available?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51689,'A new Aspect of Magic has already been selected, Kalecgos.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51690,'There is no longer a place for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51691,'You are... dismissed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51693,'How about a little swim, $r?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51694,'Back into the lava with you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51695,'Time for a dip in the magma, $c!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51696,'Let the lava fill your lungs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51697,'The lava shall consume you, cold ones!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51698,'Waves of flame consume you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51699,'Spirits of fire, destroy this vermin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51700,'You will be washed away with flame...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51701,'The Gurubashi attackers just keep streaming in! We\'ve been pinned down here and haven\'t received word from the outlying outposts in days.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(51702,'The Fire Lasher wriggles with glee. You found him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51703,'Hiding in 1...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51704,'Hiding in 2...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51705,'Hiding in 3...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51706,'No peeking!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51707,'','My spirit be watchin\' over ya, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51708,'','Spirit walkin\' be taxin\' work.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51709,'Noooo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51710,'The worm is about to bite!  Place the bomb down now!','',0,0,0,0,0,0,0,0,1,12134,0,0,26124),
(51711,'3...','',0,0,0,0,0,0,0,0,1,12134,0,0,26124),
(51712,'2...','',0,0,0,0,0,0,0,0,1,12134,0,0,26124),
(51713,'1...','',0,0,0,0,0,0,0,0,1,12134,0,0,26124),
(51714,'The eclipse of Azeroths\' moons is an occurrence that we of the blue dragonflight hold most sacred.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51715,'','What interest this little Lasher might have in the dead tree, I don\'t know.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51716,'','Why, I think he\'s trying to revive the tree!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51717,'','Poor thing...it doesn\'t realize that the tree is beyond salvation.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51718,'','Wait...something\'s happening!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51719,'','Oh my...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51720,'','Impossible...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51721,'','Wait! I sense life in him still, but it is very faint. I will do my best to save him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51722,'','My spirit gonna be watchin\' over ya, $n.',0,0,0,0,0,0,0,1,1,923,0,0,26124),
(51723,'','My spirit gonna be watchin\' over ya, $n.',0,0,0,0,0,0,0,7,1,924,0,0,26124),
(51724,'I\'m here to make sure the job gets done on time.$b$bBooty Bay is still trying to recover from the tidal wave!$b$bThe last thing we need is a horde of rampaging trolls, zombie trolls, poisonous serpents or crazed panthers attacking us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51725,'I\'m here to represent Booty Bay\'s interest in this expedition.$b$bIf things go bad, Booty Bay is in trouble.$b$bWe are still recovering from the events of the cataclysm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51727,'','Oh dear! He wasn\'t able to do it after all. And it seems he\'s paid the ultimate price to try.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51728,'','Come, little one. Let us return to camp and forget this fruitless task.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51729,'It would be my honor, Kalecgos.','It would be my honor, Kalecgos.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51730,'','Hello there! You\'re really growing on me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51731,'','In the nature of all things is the will to survive.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51732,'Stay by Malfurion\'s side while he summons Malorne!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51733,'$n!  I know where the other emissary went.','',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(51734,'Let me know when you are ready to go, $n.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(51735,'','$n!  I know where the other troll went.',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(51736,'','Speak to me when you are ready to go, $n.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(51739,'Ohgan\'aka, the young raptor, looks at you with pleading eyes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51740,'Sampling','Sampling',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51741,'Tholo\'s Thermometer is ready to take a sample.','Tholo\'s Thermometer is ready to take a sample.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51742,'It\'s hotter\'n a kiln down here! Ah could fry an egg on me forehead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51743,'%s groans as a large piece of his body is broken loose!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51744,'I will go with you by foot and clear the path of flames.  It will take all my concentration to keep the fire at bay, so you need to make sure that I remain safe.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51745,'I am willing, Kalecgos. I shall cast Tarecgosa\'s vote on her behalf.','I am willing, Kalecgos. I shall cast Tarecgosa\'s vote on her behalf.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51746,'Stay close. Stay vigilant.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51747,'We\'re almost through. Stay close!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51748,'Brothers! Strike now!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51749,'Obsidian Defender has cast Harden Shield! It is taking less damage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51750,'While I already feel better, I am not yet ready for combat. I will need you to escort me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51751,'I am worried about Tholo.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51752,'This first part is the toughest. Once we get to the thermal vents, the path will be much clearer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51753,'Here is the first vent! Face the ledge, then jump! The heated air currents will do the rest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51754,'Just face the ledge, and jump!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51755,'I\'m on my way, Tholo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51756,'We\'re nearly there now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51757,'Thank you. I must go find Tholo, my fellow druid and treasured friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51758,'If you find yourself in this cave again, do not forget about the thermal vents. They may help you escape some tight situations.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51759,'Tholo... is that you...?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51760,'Here\'s some water, Anren. Let\'s get you out of this cave.','Here\'s some water, Anren. Let\'s get you out of this cave.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51761,'Obsidian Defender has overloaded itself and is now vulnerable to explosives!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51762,'','That Malfurion... fitting of him to send his $r underling to speak with me.$b$bHe has proven himself a coward, as always.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(51763,'Malfurion, a coward? How can you justify that?','Malfurion, a coward? How can you justify that?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(51764,'','Never you mind, $r. The details of my past were burned away when I joined the Druids of the Flame. They are of no concern to you.$b$bBesides, I am here to discuss the future of this realm. And I do not plan to discuss it with you.$b$bNow answer me... where is Malfurion!?',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(51765,'Malfurion is not here. Only me.','Malfurion is not here. Only me.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(51766,'%s stumbles as his armor is shattered!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51767,'','Very well. Malfurion shall press into the Firelands, and we will deal with him there. His judgment can wait for a few more brief days.$b$b<Leyara\'s eyes light up.>$b$bThe tauren arch druid, however, will not be so lucky.',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(51768,'Tauren archdruid? Do you mean Hamuul?','Tauren archdruid? Do you mean Hamuul?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(51769,'','The invaders are fast approaching, Malfurion. Give up this ritual, and join the fight!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(51770,'','With your help, we can repel them!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(51771,'No, Matoclaw.  Ragnaros will not be content to send mere foot soldiers to attack us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51772,'I sense something larger is coming, and we will need the strength of Malorne if we are to survive.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51773,'Have patience, Matoclaw.  The ritual is nearly complete.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(51774,'','Elune\'s light... what is that thing?',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(51775,'Hold them back! We need to buy more time!','',0,0,0,0,0,0,396,0,1,0,24857,0,26124),
(51776,'Buuurrnnnn!','',0,0,0,0,0,0,396,0,1,0,24550,0,26124),
(51777,'Hold the line!  They must not break through!','',0,0,0,0,0,0,0,0,1,0,24966,0,26124),
(51778,'Succumb to living flame!','',0,0,0,0,0,0,396,0,1,0,24551,0,26124),
(51779,'Stand strong!  Only a bit longer!','',0,0,0,0,0,0,396,0,1,0,24859,0,26124),
(51780,'We gather to determine the fate of our great flight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51781,'Our history has been wrought with great challenges...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51782,'Our future promises even greater threats.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51783,'These circumstances demand a powerful leader.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51784,'I was raised at the feet of my father.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51785,'I watched as he steered us through adversity, never flinching from difficult decisions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51786,'Some called my father mad. But even in his darkest hours, his vision was clear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51787,'He put the needs of this flight first and foremost.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51788,'He sought to consolidate our rightful power, fortifying us for the cataclysm that he saw coming.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51789,'Brothers, we must take what is ours.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51790,'Under my leadership, this flight will rise again, beyond the glory of our past - onwards to an even greater destiny.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51791,'I will see to it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51792,'Our assault on the Firelands cannot wait. We strike, at Ragnaros and at Fandral, as soon as we can.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51793,'How goes the ritual, Malfurion?','How goes the ritual, Malfurion?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51794,'Thank you, $c. I might have died out here if not for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51795,'You have my thanks. Stay safe, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51796,'These are harsher skies than any of us could have known.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51797,'Be careful out here. It\'s far more dangerous than it first seems.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51798,'I might have escaped if I hadn\'t got caught in one of the thermals...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51799,'The matriarch knocked me right out of the sky. I\'m lucky to be alive.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51800,'These thermals have made flying here nearly suicidal. Thank you for coming for us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51801,'It will be some time before I can recover from these injures. Still, I\'m glad to be alive.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51802,'I\'m in your debt, $c.','I\'m in your debt, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51803,'Elune be praised! And you as well.','Elune be praised! And you as well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51804,'It was foolish of me to get caught away from the line. Thank you for the second chance.','It was foolish of me to get caught away from the line. Thank you for the second chance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51805,'I\'ll return immediately. Thank you, $c.','I\'ll return immediately. Thank you, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51806,'I should be able to make my way back. Thank you, friend.','I should be able to make my way back. Thank you, friend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51807,'Their attacks are relentless. Thank you for your help.','Their attacks are relentless. Thank you for your help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51808,'I owe you a very special thank you. Find me sometime when this fight is over.','I owe you a very special thank you. Find me sometime when this fight is over.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51809,'I was surely done for. I owe you greatly, $r.','I was surely done for. I owe you greatly, $r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51810,'The Fire Hawk Matriarch screams in rage at your theft.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51811,'I see you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51812,'Daily Wave:','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51813,'Joust!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51814,'Have lance, will stab!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51815,'Get thee to a hatchery!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51816,'Here we flap again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51817,'Lancer? I hardly knew her!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51818,'Lance in the pants!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51819,'Hyjal kids, Hyjal wives! They\'re lancing everyone in here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51820,'Lance with the devil in the pale Twilight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51821,'Brothers, sisters, Arygos speaks of our troubled past.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51822,'Indeed, we have suffered greatly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51823,'But I would contend that we are at least partly to blame for the scars we bear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51824,'Let us turn from our old ways.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51825,'Let us not seek to extinguish magic from the world...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51826,'...but to use it responsibly for the benefit of Azeroth and all its inhabitants.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51827,'It is true that our choice here today will affect the destiny of our flight. And likely, the destiny of the world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51828,'May the Titans guide us. May we be inspired to choose with wisdom.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51829,'Stay still. I\'ll get you to safety.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51830,'Don\'t worry. I\'ve got you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51831,'Not so fast. You\'re not dying on us just yet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51832,'Touchy footing up there. Be careful.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51833,'I\'ll try to get you back on the island. We just have to get through these thermals...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51834,'Hold tight, the air currents here are deadly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51835,'You\'re far too important to us to be lost that easily.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51836,'Going up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51837,'The memories in this locket swirl in anguish. Such pain and suffering... let us see what it wants to show us.','',0,0,0,0,0,0,0,0,1,0,24938,0,26124),
(51838,'Who is this? That looks like Valstann, Fandral Staghelm\'s only son. What is he doing? Is this a memory of the Qiraji War?','',0,0,0,0,0,0,0,0,1,0,24939,0,26124),
(51839,'It is! The great war of Silithus raged over a thousand years ago. Valstann tried to save his people, but was captured...and killed.','',0,0,0,0,0,0,0,0,1,0,24940,0,26124),
(51840,'Oh - this is terrible. Why would Leyara cling to this memory? Valstann must have been an important part of her life...','',0,0,0,0,0,0,0,0,1,0,24941,0,26124),
(51841,'Time passes, yet the sting of his death will not fade.','',0,0,0,0,0,0,0,0,1,0,24488,0,26124),
(51842,'','Valstann, my dear husband, you left us too soon.',0,0,0,0,0,0,0,0,1,0,0,24909,26124),
(51843,'Leyara, the two of you are all I have left. I swear to you, on my life, you and my granddaughter will ALWAYS have my protection.','',0,0,0,0,0,0,0,0,1,0,24489,0,26124),
(51844,'','I tried to save you Istaria, but I was too weak.',0,0,0,0,0,0,0,0,1,0,0,24911,26124),
(51845,'','Fandral would never have allowed the Horde to attack our home! And who did Malfurion send to defend us? No one!',0,0,0,0,0,0,0,0,1,0,0,24913,26124),
(51846,'Your anger is not misguided.','',0,0,0,0,0,0,0,0,1,0,24490,0,26124),
(51847,'','Who\'s there?',0,0,0,0,0,0,0,0,1,0,0,24914,26124),
(51848,'One who shares your pain. One who offers you the power to assuage it.','',0,0,0,0,0,0,0,0,1,0,24491,0,26124),
(51849,'','Fandral! You escaped from prison?',0,0,0,0,0,0,0,0,1,0,0,24915,26124),
(51850,'I was rescued by some new allies. I\'m sorry I was not here sooner.','',0,0,0,0,0,0,0,0,1,0,24492,0,26124),
(51851,'','What is this power? What have you become?',0,0,0,0,0,0,0,0,1,0,0,24916,26124),
(51852,'You will learn in due time, my daughter. Come with me. Together, we will bring vengeance to those who have wronged us...','',0,0,0,0,0,0,0,0,1,0,24494,0,26124),
(51853,'','Our child has been born. It\'s a girl! A beautiful baby girl.',0,0,0,0,0,0,0,0,1,0,0,24910,26124),
(51854,'','I named her Istaria. She has your eyes. ',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51855,'Fools! Neltharion take you all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51856,'','Leyara nods.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51857,'These trolls have just shown up demanding our help.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(51858,'I can barely understand what these trolls are trying to say.','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(51859,'Why don\'t these trolls just deal with their problems on their own?','',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(51861,'<The troll sings to himself as he observes the carnage around him.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51862,'Tanks for da help.','Tanks for da help.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(51863,'Ya saved my life!','Ya saved my life!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(51864,'Bwemba, is dat you?  Tanks for da save.','Bwemba, is dat you?  Tanks for da save.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(51865,'Da serpents, dey be everywhere!','Da serpents, dey be everywhere!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(51866,'Da serpents overwhelmed us.','Da serpents overwhelmed us.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(51867,'I was tinkin\' dat I was gonna to die in dis jungle.','I was tinkin\' dat I was gonna to die in dis jungle.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(51868,'Da spirits be watchin\' over me today.','Da spirits be watchin\' over me today.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(51869,'Tank ya for savin\' my life.','Tank ya for savin\' my life.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(51870,'There is no time to waste, friend.$b$bMy flight is in disarray and is in desperate need of leadership.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51871,'','Glad you could make it, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51872,'','Welcome to the Molten Flow, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51873,'','The flamewakers up ahead mean business. Be careful in there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51874,'','There are plenty of thermal vents up ahead, $n. Feel free to use them if you get into a jam.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51875,'','I fear there may be a lost druid in the back of the cave, $n. Be on the lookout.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51876,'%s\'s armor is weakened by the active volcano.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51877,'','Da other emissary, he always be tryin\' to save da world!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51878,'','What part of da jungle ain\'t da other emissary been in?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51879,'','What kinda mess did we stumble into?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51880,'','Mandokir sure do love his raptors.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51881,'','Da Bloodlord, it look like he be overseein\' da Gurubashi warriors.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51882,'','Your deeds shall live on forever in the memories of every blue dragon, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51883,'I am ready to take part in the ceremony, Hallegosa.','I am ready to take part in the ceremony, Hallegosa.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51884,'','Follow me, $n. A ceremony has been prepared in your honor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51887,'Well done. We should be safe for the moment, but we haven\'t much time.','',0,0,0,0,0,0,1,0,1,0,24950,0,26124),
(51888,'With this seed, we set root. With time and attention, we should be able to grow shelter from this charred, hostile realm.','',0,0,0,0,0,0,1,0,1,0,24952,0,26124),
(51889,'Here we will hold firm against the onslaught of the elements.','',0,0,0,0,0,0,1,0,1,0,24953,0,26124),
(51890,'Here we will draw the attention of Ragnaros\' army so that others might strike at the heart of his realm.','',0,0,0,0,0,0,1,0,1,0,24954,0,26124),
(51891,'And now, the war begins.','',0,0,0,0,0,0,1,0,1,0,24955,0,26124),
(51892,'','Stand upon this disc, $p. Kalecgos approaches!',0,0,0,0,0,0,1,0,1,12207,0,0,26124),
(51893,'The grave is old, peaceful, and undisturbed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51894,'Present the Smoke-Stained Locket.','Present the Smoke-Stained Locket.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51895,'While this is certainly a grave marker, it is unclear who is buried here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51896,'I can teach the art of cooking.\n\nAre you looking to learn?','I can teach the art of cooking.\n\nAre you looking to learn?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51897,'Welcome, friend. We\'ve been expecting you.','',0,0,0,0,0,0,0,0,1,0,24874,0,26124),
(51898,'You are to be congratulated for your success in the Firelands.','',0,0,0,0,0,0,485,0,1,0,24875,0,26124),
(51899,'But praise alone will not suffice.','',0,0,0,0,0,0,485,0,1,0,24876,0,26124),
(51900,'We owe you a great deal for the part you have played in the destiny of our flight.','',0,0,0,0,0,0,485,0,1,0,24877,0,26124),
(51901,'Present me your staff, that we may endow it with great power.','',0,0,0,0,0,0,485,0,1,0,24878,0,26124),
(51902,'This platform is about to crumble! Jump to another!','This platform is about to crumble! Jump to another!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51903,'','My, it sure is hot down here. I didn\'t even need to bring my own forge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51904,'','That island over there is full of Obsidium creatures! I\'d go over there myself, but I can\'t get across the bridge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51905,'It is not the fighters I watch; that is the Combat Masters\' task.\n\nMy concern is for the two neophytes whose duty it is to heal them. So far, my students are doing well.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(51906,'Oh, aye. I took the wee rotter\'s candle.\n\nNow, what did ye need?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51909,'You seek me? We fight now!','',0,0,0,0,0,0,0,0,1,0,24232,0,26124),
(51910,'Crushed!','',0,0,0,0,0,0,0,0,1,0,24236,0,26124),
(51911,'You are weak!','',0,0,0,0,0,0,0,0,1,0,24237,0,26124),
(51912,'I COME FOR YOU, LITTLE MORTAL!','',0,0,0,0,0,0,0,0,1,0,24234,0,26124),
(51913,'I will catch you, small one!','',0,0,0,0,0,0,0,0,1,0,24235,0,26124),
(51914,'Coward! You cannot run!','',0,0,0,0,0,0,0,0,1,0,24241,0,26124),
(51915,'No! You do not escape the rage of the Gurubashi!','',0,0,0,0,0,0,0,0,1,0,24242,0,26124),
(51916,'Gri\'lek wanders... no more...','',0,0,0,0,0,0,0,0,1,0,24233,0,26124),
(51917,'Today, you\'ll wish you never stirred from your bed!','',0,0,0,0,0,0,0,0,0,0,24247,0,26124),
(51918,'Pity. In death, you no longer dream...','',0,0,0,0,0,0,0,0,0,0,24252,0,26124),
(51919,'There there... close your eyes...','',0,0,0,0,0,0,0,0,0,0,24253,0,26124),
(51920,'Let us see what horrors stir within your nightmares!','',0,0,0,0,0,0,0,0,0,0,24249,0,26124),
(51921,'Let\'s see what\'s more horrifying... to dream unwaking, or to awaken in a living nightmare!','',0,0,0,0,0,0,0,0,0,0,24250,0,26124),
(51922,'Slumber... another dream awaits you...','',0,0,0,0,0,0,0,0,0,0,24251,0,26124),
(51923,'My spirit dreams no longer...','',0,0,0,0,0,0,0,0,0,0,24248,0,26124),
(51924,'Finally, Tarecgosa, our beloved sister whose essence you have generously borne, has chosen this staff as her permanent home.','',0,0,0,0,0,0,485,0,1,0,24879,0,26124),
(51925,'Ahhh... I shall add a new blade to my collection today...','',0,0,0,0,0,0,0,0,1,0,24309,0,26124),
(51926,'A swift slice to the throat, and this one falls like any other.','',0,0,0,0,0,0,0,0,1,0,24311,0,26124),
(51927,'Learn your place.','',0,0,0,0,0,0,0,0,1,0,24312,0,26124),
(51928,'Perhaps a quick stab will let out all that tension in your shoulders...','',0,0,0,0,0,0,0,0,1,0,24314,0,26124),
(51929,'Rogues do it from behind...','',0,0,0,0,0,0,0,0,1,0,24315,0,26124),
(51930,'It only hurts this much the first time.  The second time, you\'re dead.','',0,0,0,0,0,0,0,0,1,0,24316,0,26124),
(51931,'Feel the sting of a thousand cuts!','',0,0,0,0,0,0,0,0,1,0,24307,0,26124),
(51932,'One thousand blades!','',0,0,0,0,0,0,0,0,1,0,24308,0,26124),
(51933,'Not even a thousand deaths could put my soul to rest...','',0,0,0,0,0,0,0,0,1,0,24310,0,26124),
(51934,'Return to the Hyjal invasion area, or you will be dropped!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51935,'What? You\'ve come to laugh at Zanzil, too? Not again! I\'ll make you pay!','What? You\'ve come to laugh at Zanzil, too? Not again! I\'ll make you pay!',0,0,0,0,0,0,0,0,1,0,24337,24337,26124),
(51936,'Don\'t worry. Zanzil won\'t leave you dead for long...','Don\'t worry. Zanzil won\'t leave you dead for long...',0,0,0,0,0,0,0,0,1,0,24342,24342,26124),
(51937,'How does that taste?','How does that taste?',0,0,0,0,0,0,0,0,1,0,24343,24343,26124),
(51938,'Oooh, pretty... Zanzil\'s got big plans for this one...','Oooh, pretty... Zanzil\'s got big plans for this one...',0,0,0,0,0,0,0,0,1,0,24344,24344,26124),
(51939,'Maybe you need someone bigger to play with!','Maybe you need someone bigger to play with!',0,0,0,0,0,0,0,0,1,0,24349,24349,26124),
(51940,'Go, little one! Fight them! KILL THEM!','Go, little one! Fight them! KILL THEM!',0,0,0,0,0,0,0,0,1,0,24350,24350,26124),
(51941,'Who needs friends? Zanzil just makes his own! ','Who needs friends? Zanzil just makes his own! ',0,0,0,0,0,0,0,0,1,0,24351,24351,26124),
(51942,'Rise up! Zanzil\'s elixir gives you life!','Rise up! Zanzil\'s elixir gives you life!',0,0,0,0,0,0,0,0,1,0,24352,24352,26124),
(51943,'Hahahaha!','Hahahaha!',0,0,0,0,0,0,0,0,1,0,24340,24340,26124),
(51944,'Breathe deep, friends! Breathe it all in!','Breathe deep, friends! Breathe it all in!',0,0,0,0,0,0,0,0,1,0,24341,24341,26124),
(51945,'You\'ll all suffer for this! Zul\'Gurub is NOTHING without Zan... Zan...','You\'ll all suffer for this! Zul\'Gurub is NOTHING without Zan... Zan...',0,0,0,0,0,0,0,0,1,0,24338,24338,26124),
(51946,'','I consider it a great honor to assist the Lady Proudmoore in her research. She\'s the most powerful human mage upon Azeroth, you know!\n\nNow, was there something I might help you with?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51947,'You shall regret disturbing my homeland!','',0,0,0,0,0,0,0,0,1,0,24329,0,26124),
(51948,'Were this tower to boast TWICE as many tomes, it would still not be enough for me. My collecting and copying shall never be done.\n\nSo. You have need of my assistance?','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(51949,'Can you feel that tingling sensation? It may be your last.','',0,0,0,0,0,0,0,0,1,0,24333,0,26124),
(51950,'You\'re in for a stunning surprise...','',0,0,0,0,0,0,0,0,1,0,24334,0,26124),
(51951,'Are you quicker than lightning?','',0,0,0,0,0,0,0,0,1,0,24335,0,26124),
(51952,'The storm feeds my power!','',0,0,0,0,0,0,0,0,1,0,24336,0,26124),
(51953,'The end of our empire... is only the beginning...','',0,0,0,0,0,0,0,0,1,0,24330,0,26124),
(51954,'Shocking. I know.','',0,0,0,0,0,0,0,0,1,0,24331,0,26124),
(51955,'','You mean to say there is a warlock? Here, in goodly Theramore?!\n\nOh, my. Someone must inform Lady Proudmoore immediately!\n\n...heh.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(51956,'Feel the might of my storm!','',0,0,0,0,0,0,0,0,1,0,24332,0,26124),
(51957,'','Please, lower your voice. It isn\'t wise to remind Lady Proudmoore of the sorts of things we study.\n\nNow, shall we speak of TRUE power...?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51958,'With all the Siege Engines nearly complete, I\'m getting a bit bored!\n\nYou\'re not an engineer, are you? Care to compare blueprints...?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51959,'Welcome to my kitchen!\n\nAre you here looking for food, or to do some cooking yourself?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51960,'I used ta be in the Explorers\' League, ye know.\n\nBut then I realized the only thing I really cared ta look for was GEMS.\n\nBig, sparklin\', colorful, valuable gems... oh, how I love ye!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(51961,'May her presence be a source of comfort and companionship to you.','',0,0,0,0,0,0,485,0,1,0,24880,0,26124),
(51962,'We thank you, friend of the blue dragonflight.','',0,0,0,0,0,0,485,0,1,0,24881,0,26124),
(51963,'Are you looking at me? Yes, look at me. You should be looking at me. Are you? Looking at me? Good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51964,'Twinkles! Why did it have to be Twinkles?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51966,'','He\'s gem-mad, he is, but I love him. Says I\'m his favorite gem of them all, hee!\n\nNow then, what can I help ye with? Archaeology, is it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51967,'In a flash, you\'ll be nothing more than dust...','',0,0,0,0,0,0,0,0,1,0,24403,0,26124),
(51968,'<The staff pulsates with arcane energies.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51969,'Good leather in the marshes, if you\'ve the guts for it. Lots of crocolisks. Thinkin\' my brother and I\'ll stay a while.\n\nSomethin\' I can help you with?','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(51970,'You nothing!','',0,0,0,0,0,0,0,0,1,0,24258,0,26124),
(51971,'Ain\'t NO ONE gonna stop Jin\'do!','',0,0,0,0,0,0,0,0,1,0,24257,0,26124),
(51972,'You nothing!','',0,0,0,0,0,0,0,0,1,0,24259,0,26124),
(51973,'Meddlesome insects! Now you will feel my wrath!','',0,0,0,0,0,0,0,0,1,0,24268,0,26124),
(51975,'Be freed, insects. I will deal with you another time.','',0,0,0,0,0,0,0,0,1,0,24243,0,26124),
(51976,'Your deceit is unforgivable, Jin\'do. You spit in the face of a god!','',0,0,0,0,0,0,0,0,1,0,24246,0,26124),
(51977,'','Nature\'s blessings upon you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51978,'','You need help with some fires? Very well, let\'s get down to business.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51979,'Today, I fight by your side.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51980,'So you are to be my commander today. Very well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51981,'Let\'s do this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51982,'','The doctor is... IN!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51983,'I\'d \'ave a cleaner shot \'round \'ere if someone hadn\'t all gone and done regrown up all them stupid trees.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51984,'Hallo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51985,'','May you frolic through meadows of pain.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51986,'','By Elune, I shall show you a quick death.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51987,'','Never return to this place, elemental. This is a place of nature!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51988,'','For Gilneas!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51989,'','What\'s a little fire in the face of five heroes of the Alliance?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51990,'','We of Gilneas show little patience for outsiders.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51991,'You are nothing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51992,'Your presence here is unwelcome, elemental!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51993,'Azeroth has no place for the likes of you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51994,'Be gone, you soulless wretch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51995,'Taste my steel!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51996,'I will show you no mercy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51997,'AAAAAAAAAAAHHHHHHHHH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51998,'Eat dirt and die, you spineless cowards!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(51999,'I\'ll tear you to pieces! AAAAAHHHHHHHH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52000,'','For Gnomeregan!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52001,'','Behold, the potent power of Cogspin!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52002,'','As resident doctor, I am compelled to warn the rest of you that fire can be hazardous to your health.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52003,'Aim fer tha jimmies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52004,'Oh aye, this\'ll teach yeh to stop doin\' whatever yeh done did.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52005,'Iffin\' yeh don\'t sumtimes shoot a small furry animal out yer gun, \'ow would yeh keep it clean? The druids don\'t \'ave an answer to THAT one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52006,'I\'ll sing \'em ta death, I will I will.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52007,'Traaa la laaa...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52008,'Let me at \'em! I\'ll bash \'em ta bits with my lute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52009,'','Back to Teldrassil for me. Farewell, everyone!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52010,'','I wouldn\'t mind fighting with you again sometime.  Farewell!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52011,'Our work is far from done. Fandral will pay for his deceit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52012,'I admire your strength.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52013,'Never stop fighting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52014,'','Stay healthy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52015,'Right. I\'m off. Time ta get blootered. ','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52016,'Until next time, lads.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52017,'Put your weapons down, everyone.  Wait out the shield!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52018,'Stop!  Stop attacking!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52019,'Cease fire, men! Wait out the shield.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52020,'The rift can be reached through this hall. Follow me.','The rift can be reached through this hall. Follow me.',0,0,0,0,0,0,1,0,1,0,24982,24982,26124),
(52021,'Stay close, $n. If we are caught, it will be the end of both of us.','Stay close, $n. If we are caught, it will be the end of both of us.',0,0,0,0,0,0,0,0,1,0,24983,24983,26124),
(52022,'Security here is much stronger than I recall... what is Arygos protecting?','Security here is much stronger than I recall... what is Arygos protecting?',0,0,0,0,0,0,1,0,1,0,24984,24984,26124),
(52023,'Assist me! There are too many!','Assist me! There are too many!',0,0,0,0,0,0,1,0,1,0,24995,24995,26124),
(52024,'More sentries approach! There\'s no other way...','More sentries approach! There\'s no other way...',0,0,0,0,0,0,1,0,1,0,24987,24987,26124),
(52025,'Protect me while I break this barrier. ','Protect me while I break this barrier. ',0,0,0,0,0,0,1,0,1,0,25000,25000,26124),
(52026,'What!? Twilight dragons? Here??','What!? Twilight dragons? Here??\n',0,0,0,0,0,0,1,0,1,0,25001,25001,26124),
(52029,'Ha ha ha! Is that all you got?','',0,0,0,0,0,0,0,0,1,0,24293,0,26124),
(52030,'Your broken body belongs to Hakkar.','',0,0,0,0,0,0,0,0,1,0,24294,0,26124),
(52031,'Fall to my feet.  Fall to Mandokir, the bloodlord!','',0,0,0,0,0,0,0,0,1,0,24295,0,26124),
(52032,'Ding!','',0,0,0,0,0,0,0,0,1,0,24297,0,26124),
(52033,'Rise, Ohgan! Rise, and fight for your master!','',0,0,0,0,0,0,0,0,1,0,24299,0,26124),
(52034,'Off with your head!','',0,0,0,0,0,0,0,0,1,0,24291,0,26124),
(52035,'Heads gonna roll!','',0,0,0,0,0,0,0,0,1,0,24292,0,26124),
(52036,'My blood feeds Hakkar! My soul... feeds... Jin\'do!','',0,0,0,0,0,0,0,0,1,0,24290,0,26124),
(52040,'Guards, come to my defense!','Guards, come to my defense!',0,0,0,0,0,0,0,10,1,0,0,0,26124),
(52043,'Welcome to Theramore Isle. Something I can help you find?','Welcome to Theramore Isle. Something I can help you find?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52044,'Speak to Paymaster Lendry on the second floor of the barracks.\n\nHe can arrange to store your goods with Theramore\'s treasury.','Speak to Paymaster Lendry on the second floor of the barracks.\n\nHe can arrange to store your goods with Theramore\'s treasury.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52049,'','This way, $n. The ceremony is about to begin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52050,'Look for Jensen Farran near the archery range.','Look for Jensen Farran near the archery range.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52051,'You\'ll find Horace Alder pacing about above the ground level of Lady Proudmoore\'s tower.','You\'ll find Horace Alder pacing about above the ground level of Lady Proudmoore\'s tower.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52052,'Look for Brother Karman overseeing training at the combat dummies outside the barracks.','Look for Brother Karman overseeing training at the combat dummies outside the barracks.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52053,'Look for Allen Bright at the sparring ring near the barracks.\n\nHe and Doctor Gustaf VanHowzen oversee the training of the isle\'s healers.','Look for Allen Bright at the sparring ring near the barracks.\n\nHe and Doctor Gustaf VanHowzen oversee the training of the isle\'s healers.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52054,'I\'m not certain. Try asking Calia Hastings, by the docks. I\'m told she has connections to SI:7.','I\'m not certain. Try asking Calia Hastings, by the docks. I\'m told she has connections to SI:7.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52055,'A shaman...?\n\nThere\'s a rather rough-looking dwarven lass staying in Theramore\'s inn; I believe she came to visit an old friend of hers here.\n\nShe might be able to help you.','A shaman...?\n\nThere\'s a rather rough-looking dwarven lass staying in Theramore\'s inn; I believe she came to visit an old friend of hers here.\n\nShe might be able to help you.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52056,'Well... ah... don\'t tell her I sent you, but look for a red-robed woman above the ground level of the central tower.\n\nRedia Vaunt is her name. But do not mention me!','Well... ah... don\'t tell her I sent you, but look for a red-robed woman above the ground level of the central tower.\n\nRedia Vaunt is her name. But do not mention me!',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(52057,'Report to Captain Evencane on the second level of the barracks. He can see to your training.','Report to Captain Evencane on the second level of the barracks. He can see to your training.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52058,'Alchemy','Alchemy',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(52059,'Alchemist Narett and Brant Jasperbloom teach Alchemy and Herbalism out of a small shop here; they\'ll be able to help you.','Alchemist Narett and Brant Jasperbloom teach Alchemy and Herbalism out of a small shop here; they\'ll be able to help you.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52060,'I know that one of those visiting Woolybush dwarves is an archaeologist.\n\nI think it\'s the wife, Faena. They\'re both explorers of some sort. Look for them in the inn.','I know that one of those visiting Woolybush dwarves is an archaeologist.\n\nI think it\'s the wife, Faena. They\'re both explorers of some sort. Look for them in the inn.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52061,'Ask for Marie Holdston at the smithy.','Ask for Marie Holdston at the smithy.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52062,'Craig Nollward works the inn\'s kitchen. He\'ll be able to help you.','Craig Nollward works the inn\'s kitchen. He\'ll be able to help you.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52063,'Enchanting','Enchanting',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(52064,'Lissah Spellwick, at the top of mage tower, is the mistress of Lady Jaina\'s enchanters.','Lissah Spellwick, at the top of mage tower, is the mistress of Lady Jaina\'s enchanters.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52065,'Look for Caz Twosprocket at the smithy.','Look for Caz Twosprocket at the smithy.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52066,'First Aid','First Aid',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52067,'Doctor Gustaf VanHowzen works on the ground level of the barracks.','Doctor Gustaf VanHowzen works on the ground level of the barracks.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52068,'Michael Crowe, down by the docks, can teach you anything you need to know about catching and gutting fish.','Michael Crowe, down by the docks, can teach you anything you need to know about catching and gutting fish.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52069,'Look for Theoden Manners at the top of Lady Proudmoore\'s tower.','Look for Theoden Manners at the top of Lady Proudmoore\'s tower.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52070,'I\'m certain that one of the visiting Woolybush dwarves is a jewelcrafter.\n\nI believe it\'s the husband, Ingo. They\'re both explorers of some sort. Look for them in the inn.','I\'m certain that one of the visiting Woolybush dwarves is a jewelcrafter.\n\nI believe it\'s the husband, Ingo. They\'re both explorers of some sort. Look for them in the inn.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52071,'Leatherworking','Leatherworking',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(52072,'Seek out the Tanwell brothers in Theramore\'s inn. One of them will be able to help you.','Seek out the Tanwell brothers in Theramore\'s inn. One of them will be able to help you.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52073,'Hisss word, FILLS me, MY BLOOD IS VENOM, AND YOU WILL BATHE IN THE GLORY OF THE SNAKE GOD!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52074,'Look out for the dwarf, Kerik, outside Theramore\'s smithy.\n\nHe\'s a drunkard and a bit free with the explosives, but he\'s friendly enough and knows his way around a mine.','Look out for the dwarf, Kerik, outside Theramore\'s smithy.\n\nHe\'s a drunkard and a bit free with the explosives, but he\'s friendly enough and knows his way around a mine.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52075,'You\'ll want to find Sansha MacVince, just outside Theramore\'s stables.','You\'ll want to find Sansha MacVince, just outside Theramore\'s stables.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52076,'Skinning','Skinning',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52077,'Tailoring','Tailoring',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52078,'Timothy Worthington works out of the second floor of one of Theramore\'s larger buildings. He\'ll do you right.','Timothy Worthington works out of the second floor of one of Theramore\'s larger buildings. He\'ll do you right.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52079,'Follow me, mortal. The rift is near.','Follow me, mortal. The rift is near.',0,0,0,0,0,0,1,0,1,0,24989,24989,26124),
(52080,'Which way should we go?','Which way should we go?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52081,'A Sentry approaches! Hide yourself, quickly!!','A Sentry approaches! Hide yourself, quickly!!',0,0,0,0,0,0,1,0,1,0,24985,24985,26124),
(52082,'Well done, my lady. I will have the intruder disposed of at once.','Well done, my lady. I will have the intruder disposed of at once.',0,0,0,0,0,0,1,0,1,0,24887,24887,26124),
(52083,'As you wish.','As you wish.',0,0,0,0,0,0,1,0,1,0,24888,24888,26124),
(52084,'|TInterface\\Icons\\ability_mage_worldinflames.blp:20|t%s begins to cast |cFFFF6600|Hspell:99171|h[Engulfing Flames]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52085,'Quickly! Make your way across the chasm.','Quickly! Make your way across the chasm.',0,0,0,0,0,0,1,0,1,0,25002,25002,26124),
(52086,'I\'ll handle this one. See if you can find any others. ','I\'ll handle this one. See if you can find any others. ',0,0,0,0,0,0,1,0,1,0,24988,24988,26124),
(52087,'I am an orc of medicine, $r. If you have come here to learn, I shall do my best to teach.','',1,2,0,0,0,0,0,0,1,0,0,0,26124),
(52088,'I require training, Krenk.','I require training, Krenk.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52089,'Hostile behaviour detected. Activating security protocol 11-b.','Hostile behaviour detected. Activating security protocol 11-b.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52090,'Aaugh! We cannot afford this delay!','Aaugh! We cannot afford this delay!',0,0,0,0,0,0,1,0,1,0,24994,24994,26124),
(52091,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52093,'','Thank you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52094,'','These are delicious!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52095,'','I was getting so hungry...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52096,'','That meat smells so good.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52097,'','Ribs, my favorite!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52098,'','Where do I go for seconds?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52099,'Clever fleshling... soaring in-between the winds of fate. Yes, I know the one you seek... the orc-father... Earthbinder...$b$bI sense him nearby - raging within a tempest of his own fear. You may go to him... at your peril.','',0,0,0,0,0,0,0,0,1,0,24780,0,26124),
(52100,'','We\'ve found him! But this tempest he\'s become... I\'ll try to calm it - to reach him somehow. ',0,0,0,0,0,0,25,0,1,0,0,24682,26124),
(52101,'FAILED. I have failed this world...$b$bThe elements... will not speak to me. The Earthen Ring... has lost faith in my leadership. My weakness... has delivered Azeroth... into oblivion....','',0,0,0,0,0,0,0,0,1,0,24747,0,26124),
(52102,'','Go\'el, it\'s me - Aggra! Don\'t you know me?',0,0,0,0,0,0,5,0,1,0,0,24683,26124),
(52103,'Oblivion... nothing... but oblivion...','',0,0,0,0,0,0,0,0,1,0,24748,0,26124),
(52104,'','He\'s too far gone! We have to keep trying!',0,0,0,0,0,0,22,0,1,0,0,24684,26124),
(52105,'I have... failed the Horde... as Warchief...$b$bGarrosh... will lead it to ruin...$b$bMy people... to ruin. Cairne, my brother... why did I not listen?','',0,0,0,0,0,0,0,0,1,0,24749,0,26124),
(52106,'','You did what you thought best, Go\'el! Fight these doubts! They\'re devouring your heart!',0,0,0,0,0,0,22,0,1,0,0,24685,26124),
(52107,'Why did I not listen?','',0,0,0,0,0,0,0,0,1,0,24750,0,26124),
(52108,'','Brace yourself, $n!',0,0,0,0,0,0,397,0,1,0,0,24686,26124),
(52109,'I know your face... Aggra! Oh, my heart - can\'t you see? I am... nothing. Selfish... all I\'ve done... accomplished... all for the sake of pride alone. I am... unworthy of you...','',0,0,0,0,0,0,0,0,1,0,24751,0,26124),
(52110,'','You are Go\'el, Son of Durotan and Draka! Rightful Warchief of the Horde! You are the orc who won my heart. Remember WHO YOU ARE!',0,0,0,0,0,0,22,0,1,0,0,24687,26124),
(52111,'Aggra... it IS you...','',0,0,0,0,0,0,0,0,1,0,24752,0,26124),
(52112,'','Be still, my love. Calm your mind. You became a slave to your duty. But being true to your heart is how you\'ll fulfill that duty... to your people... and to me.',0,0,0,0,0,0,1,0,1,0,0,24688,26124),
(52113,'Aggra, I... I can\'t hold on... AAH!','',0,0,0,0,0,0,0,0,1,0,24753,0,26124),
(52114,'|TInterface\\Icons\\spell_fire_ragnaros_splittingblow.blp:20|t%s begins to cast |cFFFF0000|Hspell:98951|h[Splitting Blow]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52115,'|TInterface\\Icons\\spell_fire_selfdestruct.blp:20|t%s casts |cFFFF6600|Hspell:98164|h[Magma Trap]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52116,'I am sorry, traveler, I have nothing to offer you.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52117,'At last, we have arrived!','At last, we have arrived!',0,0,0,0,0,0,1,0,1,0,24990,24990,26124),
(52118,'Defend yourself, friend. Our attackers are formidable.','Defend yourself, friend. Our attackers are formidable.',0,0,0,0,0,0,1,0,1,0,24998,24998,26124),
(52119,'Aren\'t you tricky? I have a few tricks of my own...','',0,0,0,0,0,0,0,0,1,0,14137,0,26124),
(52120,'You pose no threat, lesser beings! Give me your worst!','',0,0,0,0,0,0,0,0,1,0,14133,0,26124),
(52121,'Careful! Avoid his breath at all costs!','Careful! Avoid his breath at all costs!',0,0,0,0,0,0,1,0,1,0,25003,25003,26124),
(52122,'I\'ve destroyed his shield, unleash your power now!','I\'ve destroyed his shield, unleash your power now!',0,0,0,0,0,0,1,0,1,0,25004,25004,26124),
(52123,'Be filled with my power!','Be filled with my power!',0,0,0,0,0,0,1,0,1,0,25005,25005,26124),
(52124,'Accept the blessing of the blue dragonflight!\n','Accept the blessing of the blue dragonflight!\n',0,0,0,0,0,0,1,0,1,0,25006,25006,26124),
(52125,'|TInterface\\Icons\\spell_shaman_lavasurge.blp:20|t%s begins to cast |cFFFF0000|Hspell:98710|h[Sulfuras Smash]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52126,'The winds are strange today. Strange indeed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52127,'I am ready, elemental. Take me to Thrall.','I am ready, elemental. Take me to Thrall.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52128,'%s has fallen!','%s has fallen!',0,0,0,0,0,0,0,0,0,0,847,847,26124),
(52129,'You desert us, then have the gall to speak to me, $n?$b$bYou are either very foolish, or very brave.  Based on your past actions though, I would say foolish.  $b$bSpeak to me in a little while, I\'ve got a camp to defend.','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(52130,'The deserter...$b$bWhat do you want, $c?  We are busy defending our camp and don\'t have time for cowards.$b$bSpeak to me when my temper subsides.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52131,'The Gurubashi attackers just keep streaming in! We\'ve been pinned down here and haven\'t received word from the outlying outposts in days.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(52133,'%s devours the fish.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52134,'Oh, look you... dead.','',0,0,0,0,0,0,0,0,1,0,24228,0,26124),
(52135,'By th\' Light, it worked! Grimnur\'s brilliant... oh, I hope all the pinchin\' didn\'t hurt ye too much... But when ye taste the meat, ye\'ll know it\'s worth it!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(52136,'Hmph... quitter.','Hmph... quitter.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52137,'Beer an\' haggis, now that\'ll put hair on yer chest!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52138,'How did ye know me favorite meal?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52139,'Haggis fer breakfast, haggis fer lunch, and a sensible haggis dinner!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52140,'Keep bringing me food like this an\' ye\'ll be me new best friend!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52141,'Thank ye!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52142,'Give me thanks to Daryl, will ye?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52143,'','Twilight minions in the Nexus...$b$bThese are desperate times, $r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52144,'','No. NO! Get out! Leave me here with the memory of my sister!',0,0,0,0,0,0,0,0,0,0,0,24269,26124),
(52145,'','I told you to leave!',0,0,0,0,0,0,0,0,0,0,0,24277,26124),
(52146,'','I am sworn to protect this place!',0,0,0,0,0,0,0,0,0,0,0,24278,26124),
(52147,'','Ha! You are nothing but a plaything!',0,0,0,0,0,0,0,0,0,0,0,24275,26124),
(52148,'','Share in my pain!',0,0,0,0,0,0,0,0,0,0,0,24276,26124),
(52149,'','Feel me agony!',0,0,0,0,0,0,0,0,0,0,0,24284,26124),
(52150,'','This body is useless!',0,0,0,0,0,0,0,0,0,0,0,24274,26124),
(52151,'A soul fragment merges souls with the Harbinger of Darkness!','A soul fragment merges souls with the Harbinger of Darkness!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52152,'Die!','',0,0,0,0,0,0,0,0,1,0,24263,0,26124),
(52153,'There ye are! I was startin\' to think ye\'d made off with the beer!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(52154,'Yoo hoo!  I am here to slay Sylvanas!','Yoo hoo!  I am here to slay Sylvanas!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52155,'Hey, look, there are people here.  Nothing at all like that tree city that I, a night elf, live in.','Hey, look, there are people here.  Nothing at all like that tree city that I, a night elf, live in.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52156,'I\'m so angry that we lost Wintergrasp, again!  I will try to kill your leader, the all powerful, Sylvanas, instead.','I\'m so angry that we lost Wintergrasp, again!  I will try to kill your leader, the all powerful, Sylvanas, instead.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52157,'Our loss in Tol Barad will be avenged!  I will try to bring death to this grand city.  Cower as I try to remember a battle cry!','Our loss in Tol Barad will be avenged!  I will try to bring death to this grand city.  Cower as I try to remember a battle cry!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52158,'Tremble in fear you mighty members of the Horde, the Alliance is here!','Tremble in fear you mighty members of the Horde, the Alliance is here!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52159,'Where am I?  I crashed with the Exodar and now stumbled into this imposing city...','Where am I?  I crashed with the Exodar and now stumbled into this imposing city...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52160,'This city is so big, to me, a tiny, pathetic gnome.','This city is so big, to me, a tiny, pathetic gnome.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52161,'I am drunk, like many of my fellow dwarves.  I\'ve dug a tunnel and wound up here.  Who wants to drink?','I am drunk, like many of my fellow dwarves.  I\'ve dug a tunnel and wound up here.  Who wants to drink?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52162,'Can I have another Decoy Kit?','Can I have another Decoy Kit?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52163,'Can I have more Bloated Frogs?','Can I have more Bloated Frogs?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52164,'Aren\'t you worried about what\'s IN that?','Aren\'t you worried about what\'s IN that?',0,0,0,0,0,0,6,1,1,0,0,0,26124),
(52165,'Not at all! If my gut could take three years of the Razor Hill barrack\'s Stinky Cactus Grub Soup, a bowl of roaches isn\'t going to kill me.','Not at all! If my gut could take three years of the Razor Hill barrack\'s Stinky Cactus Grub Soup, a bowl of roaches isn\'t going to kill me.',0,0,0,0,0,0,396,1,1,0,0,0,26124),
(52166,'Roaches?! They wouldn\'t! Would they...? That\'s disgusting.','Roaches?! They wouldn\'t! Would they...? That\'s disgusting.',0,0,0,0,0,0,5,1,1,0,0,0,26124),
(52167,'HAH HAH HAH! Enjoy your stale rations, then. This slop\'s delicious.','HAH HAH HAH! Enjoy your stale rations, then. This slop\'s delicious.',0,0,0,0,0,0,153,1,1,0,0,0,26124),
(52168,'A wise choice. I\'d have selected that one myself.','A wise choice. I\'d have selected that one myself.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52169,'You\'ve a good eye for ingredients.','You\'ve a good eye for ingredients.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52170,'Picking that up for Aska? She\'ll be pleased with your choice.','Picking that up for Aska? She\'ll be pleased with your choice.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52171,'That one? Well done. It\'s the best here.','That one? Well done. It\'s the best here.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52172,'Well-picked. I\'m sure Aska will be satisfied.','Well-picked. I\'m sure Aska will be satisfied.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52173,'Only the very best, hmmm?','Only the very best, hmmm?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52174,'You\'re here for Aska\'s order, then? Please tell her I said hello.','You\'re here for Aska\'s order, then? Please tell her I said hello.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52175,'Were you going to pay for that? Oh, it\'s for Aska! Take care, then.','Were you going to pay for that? Oh, it\'s for Aska! Take care, then.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52176,'The Moat Monster submerges.','The Moat Monster submerges.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52177,'You have been judged.','',0,0,0,0,0,0,0,0,0,0,24449,0,26124),
(52178,'Behold your weakness.','',0,0,0,0,0,0,0,0,0,0,24451,0,26124),
(52179,'None shall pass!','',0,0,0,0,0,0,0,0,0,0,24452,0,26124),
(52180,'You are forbidden from my master\'s domain, mortals.','',0,0,0,0,0,0,0,0,0,0,24441,0,26124),
(52181,'Burn beneath my molten fury!','',0,0,0,0,0,0,0,0,0,0,24459,0,26124),
(52182,'By the Firelord\'s command, you, too, shall perish!','',0,0,0,0,0,0,0,0,0,0,24447,0,26124),
(52183,'Your flesh is forfeit to the fires of this realm.','',0,0,0,0,0,0,0,0,0,0,24450,0,26124),
(52184,'%s retreats and calls for the protection of his allies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52185,'Fool mortals. Hurl yourselves into your own demise!','',0,0,0,0,0,0,0,0,0,0,24446,0,26124),
(52186,'Its purgin time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52189,'','Look there - a vision within the torrent! Is this what Go\'el longed for most? Peace with his enemies - an end to the constant warring of his world?',0,0,0,0,0,0,25,0,1,0,0,24728,26124),
(52190,'','He... wished to lay down his weapon... and the burdens of leadership...',0,0,0,0,0,0,1,0,1,0,0,24729,26124),
(52191,'','Another vision! I see Go\'el, but... it... it\'s me. Was I his deepest desire? A mate with which to share his life... his burdens and his joys?',0,0,0,0,0,0,25,0,1,0,0,24730,26124),
(52192,'','A final vision! Ancestors... could those be... our children? This was his deepest desire... to be a father?',0,0,0,0,0,0,6,0,1,0,0,24732,26124),
(52193,'','...to have a family of his own... with me? Go\'el never knew his parents... It was only a few years ago that he even found his people... I should have known this was what he wanted most.',0,0,0,0,0,0,274,0,1,0,0,24733,26124),
(52194,'','Ancestors, give me strength! The vortex\'s pull is increasing! It\'s pulling me in! The power of his longing... it\'s overwhelming!',0,0,0,0,0,0,430,0,1,0,0,24735,26124),
(52195,'Very well. Witness the raw power of my new Lord!','',0,0,0,0,0,0,0,0,1,0,24464,0,26124),
(52196,'','Find and release Aggra before she gets pulled into the whirlpool!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52197,'You\'ve done the impossible, shaman. You have stilled the vortex within him without losing yourself, in turn. Your love for him... must be very great. ','',0,0,0,0,0,0,0,0,1,0,24785,0,26124),
(52198,'','I need... the world... needs him whole once again. But he\'s always placed the needs of others before his own. How long has he suppressed these feelings - these desires?',0,0,0,0,0,0,1,0,1,0,0,24737,26124),
(52199,'His aspect shifts once again! You are losing him!','',0,0,0,0,0,0,0,0,1,0,24786,0,26124),
(52200,'','Go\'el!',0,0,0,0,0,0,5,0,1,0,0,24739,26124),
(52201,'','Hurry, mortal.$b$bMeet me inside the Nexus!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52202,'%s begins to channel a massive Shadow Nova!','%s begins to channel a massive Shadow Nova!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52203,'Mortal Insects! You dare trespass into MY domain?  Your arrogance will be purged in living flame.','',0,0,0,0,0,0,0,0,1,0,24517,0,26124),
(52204,'Die, insect!','',0,0,0,0,0,0,0,0,1,0,24531,0,26124),
(52205,'Pathetic.','',0,0,0,0,0,0,0,0,1,0,24530,0,26124),
(52206,'This is MY realm!','',0,0,0,0,0,0,0,0,1,0,24529,0,26124),
(52207,'Come forth, my servants! Defend your master!','',0,0,0,0,0,0,0,0,1,0,24513,0,26124),
(52208,'Minions of fire! Purge the outsiders!','',0,0,0,0,0,0,0,0,1,0,24514,0,26124),
(52209,'Denizens of flame, come to me!','',0,0,0,0,0,0,0,0,1,0,24515,0,26124),
(52210,'Arise, servants of fire, consume their flesh!','',0,0,0,0,0,0,0,0,1,0,24516,0,26124),
(52211,'By fire be purged!','',0,0,0,0,0,0,0,0,1,0,24532,0,26124),
(52212,'You will be crushed!','',0,0,0,0,0,0,0,0,1,0,24520,0,26124),
(52213,'Die!','',0,0,0,0,0,0,0,0,1,0,24521,0,26124),
(52214,'Your judgment has come!','',0,0,0,0,0,0,0,0,1,0,24522,0,26124),
(52215,'Enough! I will finish this.','',0,0,0,0,0,0,0,0,1,0,24523,0,26124),
(52216,'Fall to your knees, mortals!  This ends now.','',0,0,0,0,0,0,0,0,1,0,24524,0,26124),
(52217,'Sulfuras will be your end.','',0,0,0,0,0,0,0,0,1,0,24525,0,26124),
(52218,'Too soon! ... You have come too soon...','',0,0,0,0,0,0,0,0,1,0,24519,0,26124),
(52219,'Too soon...','',0,0,0,0,0,0,0,0,1,0,24528,0,26124),
(52220,'Arrggh, outsiders - this is not your realm!','',0,0,0,0,0,0,0,0,1,0,24527,0,26124),
(52221,'When I finish this, your pathetic mortal world will burn with my vengeance!','',0,0,0,0,0,0,0,0,1,0,24526,0,26124),
(52222,'No, noooo- This was to be my hour of triumph...','',0,0,0,0,0,0,0,0,1,0,24518,0,26124),
(52223,'','Do not worry. I will keep the Crimson Lasher safe with me. Until we learn more about its behavior, I\'m afraid it must stay here in the Firelands.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52224,'','Such a unique specimen! So many possibilities! I must devote myself harder to the study of the local flora and fauna.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52225,'','While I am buried in research, it will be up to you to teach the Lasher the ways of the world.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52226,'','You shall not have him!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52227,'%s is regenerating. Dispel his Twilight Restoration spell!','%s is regenerating. Dispel his Twilight Restoration spell!',0,0,0,0,0,0,0,0,1,3623,0,0,26124),
(52228,'','Hurry! You must save Aggra before she is pulled into the vortex!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52229,'Hah? Hruumph? Soft little fleshy-things? Here? Nuisances, nuisances!','',0,0,0,0,0,0,0,0,1,0,24537,0,26124),
(52230,'Finished.','',0,0,0,0,0,0,0,0,1,0,24546,0,26124),
(52231,'So soft!','',0,0,0,0,0,0,0,0,1,0,24547,0,26124),
(52232,'Squeak, little pest.','',0,0,0,0,0,0,0,0,1,0,24548,0,26124),
(52233,'Oww now hey.','',0,0,0,0,0,0,0,0,1,0,24540,0,26124),
(52234,'Graaahh!','',0,0,0,0,0,0,0,0,1,0,24541,0,26124),
(52235,'Augh - smooshy little pests, look what you\'ve done!','',0,0,0,0,0,0,0,0,1,0,24542,0,26124),
(52236,'Uurrghh now you... you infuriate me!','',0,0,0,0,0,0,0,0,1,0,24543,0,26124),
(52237,'Oh you little beasts...','',0,0,0,0,0,0,0,0,1,0,24544,0,26124),
(52238,'Stomp now.','',0,0,0,0,0,0,0,0,1,0,24556,0,26124),
(52239,'I\'ll crush you underfoot!','',0,0,0,0,0,0,0,0,1,0,24557,0,26124),
(52240,'Eons I have slept undisturbed... Now this... Creatures of flesh, now you will BURN!','',0,0,0,0,0,0,0,0,1,0,24558,0,26124),
(52241,'Buuurrrnn!','',0,0,0,0,0,0,0,0,1,0,24550,0,26124),
(52242,'Succumb to living flame.','',0,0,0,0,0,0,0,0,1,0,24551,0,26124),
(52243,'My inner fire can never die.','',0,0,0,0,0,0,0,0,1,0,24552,0,26124),
(52244,'Consume...','',0,0,0,0,0,0,0,0,1,0,24553,0,26124),
(52245,'Flesh... burns!','',0,0,0,0,0,0,0,0,1,0,24554,0,26124),
(52246,'Broken. Mnngghhh... broken...','',0,0,0,0,0,0,0,0,1,0,24545,0,26124),
(52247,'Crush, crush... crush.','',0,0,0,0,0,0,0,0,1,0,24561,0,26124),
(52248,'Sear the flesh from their tiny frames.','',0,0,0,0,0,0,0,0,1,0,24562,0,26124),
(52249,'Shatter the bones!','',0,0,0,0,0,0,0,0,1,0,24563,0,26124),
(52250,'Stomp and burn, stomp and burn. ','',0,0,0,0,0,0,0,0,1,0,24564,0,26124),
(52251,'Yes, mortal?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52252,'What occasion brings you to our home town, drake?','What occasion brings you to our home town, drake?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52253,'Kalecgos has been chosen as the new aspect for the blue dragonflight.$b$bOne among you was instrumental in thwarting Arygos\'s betrayal to Deathwing, thereby averting a terrible crisis.$b$bWe are here to partake in the celebration of their heroic deeds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52258,'You may go to him... at your peril.','',0,0,0,0,0,0,0,0,1,0,24781,0,26124),
(52259,'','Do you think it will work, Go\'el? The druids and shaman uniting to restore the World Tree... Could it actually heal this broken world?',0,0,0,0,0,0,0,0,1,0,0,24741,26124),
(52260,'','Lady Ysera.',2,0,0,0,0,0,0,0,1,0,0,24742,26124),
(52261,'','Go\'el! NO!',5,0,0,0,0,0,0,0,1,0,0,24743,26124),
(52262,'','But what of Go\'el?',6,0,0,0,0,0,0,0,1,0,0,24744,26124),
(52263,'','No! Those mongrels have stolen my Go\'el, but I will NOT forsake him. Ancestors forgive me - my heart feels stolen away with him.',5,25,20,0,0,0,0,0,1,0,0,24745,26124),
(52264,'The Aspects believe it will. And they should know...','',273,0,0,0,0,0,0,0,1,0,24773,0,26124),
(52265,'...They grew it in the first place.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(52266,'Master Stormrage. It\'s good to have you back in the waking world.','',2,0,0,0,0,0,0,0,1,0,24774,0,26124),
(52267,'The Twilight\'s Hammer!','',274,0,0,0,0,0,0,0,1,0,24775,0,26124),
(52268,'I do not fear death.','',5,0,0,0,0,0,0,0,1,0,24776,0,26124),
(52269,'','Welcome, Son of Durotan. And to you, Aggralan of the Frostwolves.',1,0,0,0,0,0,0,0,1,0,0,24793,26124),
(52270,'','Friends, we have gathered here today to heal this world that we\'ve sacrificed so much to save.',1,0,0,0,0,0,0,0,1,0,0,24794,26124),
(52271,'','He was the Earthen Ring\'s most powerful shaman, and the ceremony cannot continue without him. But we must be prepared to accept that he may be lost forever...',1,0,0,0,0,0,0,0,1,0,0,24796,26124),
(52272,'Greetings, friends.','',1,0,0,0,0,0,0,0,1,0,24958,0,26124),
(52273,'I sense a vast power has grown within you, young Thrall. You\'ve achieved much, since last we met.','',1,0,0,0,0,0,0,0,1,0,24959,0,26124),
(52274,'You\'ll regret this, stranger!','',5,0,0,0,0,0,0,0,1,0,24960,0,26124),
(52275,'Fandral - what have they done to you?','',6,0,0,0,0,0,0,0,1,0,24961,0,26124),
(52276,'Fandral is corrupting fellow druids into something sinister. He may have other followers already - I must warn Moonglade.','',5,0,0,0,0,0,0,0,1,0,24962,0,26124),
(52277,'Time is precious, sister. Let us see to our ritual...','',1,0,0,0,0,0,0,0,1,0,24821,0,26124),
(52278,'I\'m sorry, are we interrupting?','',6,0,0,0,0,0,0,0,1,0,24495,0,26124),
(52279,'Not so fast, Son of Durotan! You and your allies have certainly set us back, but the Hour of Twilight CANNOT be averted!','',5,274,25,0,0,0,0,0,1,0,24504,0,26124),
(52280,'Death? Who said anything about death?','',274,11,0,0,0,0,0,0,1,0,24502,0,26124),
(52281,'You may be this world\'s greatest shaman, Thrall - but you are only mortal. This is my master\'s curse upon you - turning your great bond with the elements... into your undoing!\n','',0,0,0,0,0,0,0,0,1,0,24501,0,26124),
(52282,'Will I?\n','',274,0,0,0,0,0,0,0,1,0,24499,0,26124),
(52283,'Come, shan\'do - certainly you recognize your former pupil?','',1,0,0,0,0,0,0,0,1,0,24498,0,26124),
(52284,'Naive as always, I see. Your pet orc cannot save you now, Malfurion.','',1,5,0,0,0,0,0,0,1,0,24497,0,26124),
(52286,'','Hear me, Go\'el! You ARE NOT alone! I\'m here with you - I will NOT let you go! ',0,0,0,0,0,0,22,0,1,0,0,24731,26124),
(52287,'','Oh, Go\'el, hold on! I WILL free you! And you\'ll HAVE this life, I swear it! ',0,0,0,0,0,0,22,0,1,0,0,24734,26124),
(52288,'','He must embrace them and find balance... or this curse will never end. ',0,0,0,0,0,0,1,0,1,0,0,24738,26124),
(52289,'','Fight this, Go\'el! You\'ve got to snap out of it!',0,0,0,0,0,0,0,0,1,0,0,24736,26124),
(52290,'The Twilight Prophet knows that YOU - and you alone - are our final obstacle. He\'s sent ME to remove you from the game.','',5,274,25,0,0,0,0,0,1,0,24503,0,26124),
(52291,'Even now, the elements are tearing you apart - and they shall feed upon your doubts and fears \'til the last spark of life on this wretched world has been snuffed out.','',0,0,0,0,0,0,0,0,1,0,24500,0,26124),
(52292,'And the flame of our vengeance draws near. Be ready.','',1,5,0,0,0,0,0,0,1,0,24496,0,26124),
(52293,'','For the first time, the Earthen Ring and the Cenarion Circle will unite - to restore this great Tree - thereby healing the whole of Azeroth.',1,0,0,0,0,0,0,0,1,0,0,24795,26124),
(52298,'Can...can anyone help me?','Can...can anyone help me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52299,'I don\'t feel so good...','I don\'t feel so good...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52300,'','There\'s too many of them! I don\'t know how long we can hold out! Go\'el, now would be a good time to wake up!',0,0,0,0,0,0,5,0,1,0,0,24696,26124),
(52301,'We are patient.','',0,0,0,0,0,0,0,0,1,0,24754,0,26124),
(52302,'','Did he just...? Go\'el, can you hear me? We need your help! Do something!',0,0,0,0,0,0,6,0,1,0,0,24697,26124),
(52303,'','GO\'EL! Pull it together or we\'re all going to DIE!',0,0,0,0,0,0,22,0,1,0,0,24698,26124),
(52304,'We are patient.','',0,0,0,0,0,0,0,0,1,0,24755,0,26124),
(52305,'','He did NOT just say that!',0,0,0,0,0,0,274,0,1,0,0,24699,26124),
(52306,'','Damn you, Go\'el - WAKE UP! Don\'t let it end like this! We\'ve come too far to fail now!',0,0,0,0,0,0,5,0,1,0,0,24700,26124),
(52307,'We are patient.','',0,0,0,0,0,0,0,0,1,0,24756,0,26124),
(52308,'','Oh, don\'t you tell ME to be patient, you green-skinned...',0,0,0,0,0,0,14,0,1,0,0,24701,26124),
(52309,'NOW. AWAKEN.','',0,0,0,0,0,0,0,0,1,0,24757,0,26124),
(52310,'Aggra... I heard your voice... calling me back...$b$bWhere are we?','',0,0,0,0,0,0,0,0,1,0,24758,0,26124),
(52311,'','You\'re almost home, my love. Our time is so brief. You will change again, Go\'el - but I will find you! I\'ll NEVER give up on you!',0,0,0,0,0,0,1,0,1,0,0,24702,26124),
(52312,'Aggra? Aggra! I can\'t hear-','',0,0,0,0,0,0,0,0,1,0,24759,0,26124),
(52313,'The Molten Eggs begin to hatch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52314,'','Alysrazor begins to fly in a rapid circle!  The harsh winds will remove Wings of Flame!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52315,'|TInterface\\Icons\\ability_mage_firestarter.blp:20|t The harsh winds form a |cFFFF0000|Hspell:99794|h[Fiery Vortex]|h|r!','|TInterface\\Icons\\ability_mage_firestarter.blp:20|t The harsh winds form a |cFFFF0000|Hspell:99794|h[Fiery Vortex]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52316,'','|TInterface\\Icons\\spell_holiday_tow_spicecloud.blp:20|t Alysrazor\'s fire |cFFFF0000|Hspell:99432|h[Burns Out]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52317,'','|TInterface\\Icons\\inv_elemental_primal_fire.blp:20|t Alysrazor\'s firey core |cFFFF0000|Hspell:99922|h[Re-Ignites]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52318,'','|TInterface\\Icons\\spell_shaman_improvedfirenova.blp:20|t Alysrazor is at |cFFFF0000|Hspell:99925|h[Full Power]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52319,'','I serve a new master now, mortals!',0,0,0,0,0,0,0,0,1,0,0,24426,26124),
(52320,'','BURN!',0,0,0,0,0,0,0,0,1,0,0,24430,26124),
(52321,'','For his glory!',0,0,0,0,0,0,0,0,1,0,0,24431,26124),
(52322,'','These skies are MINE!',0,0,0,0,0,0,0,0,1,0,0,24434,26124),
(52323,'','I will burn you from the sky!',0,0,0,0,0,0,0,0,1,0,0,24435,26124),
(52324,'','Fire...fire...',0,0,0,0,0,0,0,0,1,0,0,24436,26124),
(52325,'','Reborn in flame!',0,0,0,0,0,0,0,0,1,0,0,24437,26124),
(52326,'','The light...mustn\'t burn out...',0,0,0,0,0,0,0,0,1,0,0,24429,26124),
(52327,'Together we call upon the lord of fire!','Together we call upon the lord of fire!',0,0,0,0,0,0,0,0,1,0,24800,24800,26124),
(52328,'We call upon you, Firelord!','',0,0,0,0,0,0,0,0,1,0,24808,0,26124),
(52329,'Behold His power!','',0,0,0,0,0,0,0,0,1,0,24809,0,26124),
(52330,'Witness the majesty of flame!','',0,0,0,0,0,0,0,0,1,0,24811,0,26124),
(52331,'None escape the rage of the Firelands!','',0,0,0,0,0,0,0,0,1,0,24813,0,26124),
(52332,'','We call upon you, Firelord!',0,0,0,0,0,0,0,0,1,0,0,24797,26124),
(52333,'','Behold His power!',0,0,0,0,0,0,0,0,1,0,0,24798,26124),
(52334,'','Let the unbelievers perish in fire!',0,0,0,0,0,0,0,0,1,0,0,24799,26124),
(52335,'','<The Shadow Warden looks at you silently.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52336,'Have you ever seen anything like it? ','Have you ever seen anything like it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52337,'The earth beneath our feet groans and shudders. Fire rains down from the sky. The air chokes away all life. This is truly the realm of the Fire Lord.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52338,'','We cannot rest yet, my child. Hyjal still stands, but if we falter on the Fire Lord\'s doorstep, all may still be lost. Let the strength of the ancients be with us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52339,'','Our Storm Crows struggle to fly in this high density air, but the fire hawks on that ridge seem to soar with ease.$B$BThey are as wild as any of the creatures in the Plane of Fire, yet there is beauty in their form.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52340,'With time, we may be able to restore this land.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52341,'We are just barely holding our ground. We need every able-bodied soldier to report for duty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52342,'','What is war, but the preservation of life? Just as the seed struggles to push out of the soil, so do we fight for our own existence.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52343,'','Uh-oh, you have something on your face!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52344,'','Will we win this war? Only thyme will tell.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52345,'','It\'s sweltering down here. Did someone tell them to turnip the heat?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52346,'Alysrazor is unable to fully re-ignite!  Kill her quickly!','Alysrazor is unable to fully re-ignite!  Kill her quickly!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52347,'','I like you! Weed make anise pear.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52348,'','Some people say I\'m corny, but I think I\'m rather sage.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52349,'','Oh, it\'s you again! Do you think we\'ll be able to mustard up the forces we need?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52351,'Never have I seen such a barren wasteland.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52352,'We stand in the heart of Beth\'tilac\'s breeding ground. Beyond those pillars to the north, her brood awaits. They will defend her young relentlessly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52353,'','Any questions you have about the Wardens can be answered on the field of battle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52354,'','What are the Wardens? We are the precision slice of a killing blow.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52355,'','What are the Wardens? We are the hum of a spinning blade in the moment before death.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52356,'','What are the Wardens? We are the silence in the shadows.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52357,'How are we doing in the battle?','How are we doing in the battle?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52359,'We gave up much to attain this foothold, and we must continue fighting to keep it. Although our defenses are weak, continued efforts to push forward will help us recruit stronger allies in the future.$B$BThe time for courage is now, champion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52360,'We have managed to defend this point, and much of it is thanks to you.$B$BYou have managed to recruit a valuable ally to our ranks, however, the enemy continues to assail us without relent.$B$BWe must hold our ground or lose what we have fought so hard to gain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52361,'Through your efforts, you have brought both the Shadow Wardens and the Druids of the Talon to our side.$B$BExcellent work, $c.$B$BWe are gaining ground, but much work still remains.$B$BAs the enemy assails us, we must continue to build up our defenses. We require three things, $n.$B$BElderlimb and the Ancient Protectors watch over Hyjal, but their strength would be invaluable here.$B$BAs stalwart as our courage, our armory needs additional military supplies.$B$BFinally, the strength of Elune\'s calming waters will heal and rejuvenate our tired soldiers.$B$BWe need these things before our work here is complete.$B$BGo, $n. Your efforts are crucial to our victory.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52362,'You have done well, $c. Our presence here can no longer be unnoticed by Ragnaros. We are an essential thorn in his side. As his rage grows, so must we continue to press forward.$B$BWe must stay ever vigilant here, but it is time to cast our eyes upon the final battle. It is time to face the Lord of Fire himself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52363,'','Look with your eyes. What do you see? What do you feel?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52364,'Winds of Aviana, grant me the strength to keep the flames at bay.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52366,'','While we prepare to invade the Firelands, the Firelord sends his minions to repel our attack. Our position here cannot fall. We are all that stands between them and the World Tree.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52367,'','Welcome, $n. Have you come to join the invasion of the Firelands?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52368,'','We do not yet have the strength to push forward into the Firelands. First, we must rebuild our forces and supplies. Will you lend yourself to our efforts?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52369,'','What happens now will affect us all. Everyone\'s aid is needed. We must work together to fight against the invasion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52370,'','Are there any teeny tiny animals in need of my aid?$B$B<Mylune\'s eyes glisten at the thought.>$B$BI need to hug a bunny right now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52371,'','How are the preparations going?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52372,'Yes? The Archdruid is resting.$B$BI am sure he appreciates your visit, but it is best not to disturb him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52373,'How is Hamuul doing?','How is Hamuul doing?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52374,'It is difficult to say. His injuries are grievous. Even though he is a powerful druid, it will take time and patience to restore him back to full health.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52376,'','Hello, $n. Are you helping with the invasion? A skilled $c such as yourself will be a valuable addition to our force.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52377,'I need someone who can get the job done. Can I count on you, $c?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52378,'Greetings, mage.  Shall I provide you with further insight into the world of magic?','Greetings, mage.  Shall I provide you with further insight into the world of magic?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(52379,'Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.','Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(52380,'I have no time for a sermon now, $c. Seek your knowledge elsewhere.','I have no time for a sermon now, $c. Seek your knowledge elsewhere.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52381,'The Light gives us the strength and magic to triumph.','The Light gives us the strength and magic to triumph.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52382,'I can sense your desire for power, $c.','I can sense your desire for power, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52383,'I apologize, $c. I mistook you for someone with a spine. Begone; our secrets are not for untrained ears.','I apologize, $c. I mistook you for someone with a spine. Begone; our secrets are not for untrained ears.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52384,'We can run no longer. It is time to stand and fight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52385,'Do you prefer guns or bows?','Do you prefer guns or bows?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52386,'I train only warriors, $c. You\'ll have to look elsewhere.','I train only warriors, $c. You\'ll have to look elsewhere.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52387,'Are you ready to train, warrior?','Are you ready to train, warrior?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52388,'Ours is a path for those with an iron will and unfaltering resolve. You seem to possess none of these traits, $c.','Ours is a path for those with an iron will and unfaltering resolve. You seem to possess none of these traits, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52389,'You seek further instruction, $n?','You seek further instruction, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52390,'$n, how may I further your training?','$n, how may I further your training?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52391,'If you seek training, I cannot help you.','If you seek training, I cannot help you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(52392,'It appears you took a wrong turn, $c.','It appears you took a wrong turn, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52393,'Greetings, $n. You were not followed here, I trust?','Greetings, $n. You were not followed here, I trust?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52394,'','Nothing says \"Hallow\'s End is here\" more than a ride on a broomstick.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52400,'','Hello there! Plants are my speciality. Do you have an inquiry about the local flora?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52401,'','There\'s nothing more inspiring than a flower in bloom!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52408,'Kneel before the burning flame!','',0,0,0,0,0,0,0,0,1,0,24810,0,26124),
(52409,'','My Go\'el... consumed by the sea. Tormented by his own desires!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52410,'','The cycle begins again! Go\'el has become living stone! We must pursue him within the caverns of Deepholm.$b$bSeeing as how the Earthen Ring just saved her kingdom, Therazane should be more than willing to help us in saving him. If not, the Stonemother will answer to me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52411,'Begone from my realm, insects.','',0,0,0,0,0,0,0,0,1,0,24533,0,26124),
(52412,'I will see you all burn.','',0,0,0,0,0,0,0,0,1,0,24534,0,26124),
(52413,'Be consumed by flame!','',0,0,0,0,0,0,0,0,1,0,24535,0,26124),
(52414,'The realm of fire will consume you!','',0,0,0,0,0,0,0,0,1,0,24536,0,26124),
(52415,'Well, well. I admire your tenacity. Baleroc stood guard over this keep for a thousand mortal lifetimes.','',0,0,0,0,0,0,1,0,1,0,24473,0,26124),
(52416,'But none may enter the Firelord\'s abode!','',0,0,0,0,0,0,1,0,1,0,24474,0,26124),
(52417,'Beg for mercy now, and I may yet allow you to live. Well, \"heroes?\" What is your answer?','',0,0,0,0,0,0,1,0,1,0,24475,0,26124),
(52418,'Burn.','',0,0,0,0,0,0,0,0,1,0,24477,0,26124),
(52419,'Soon ALL of Azeroth will burn!','',0,0,0,0,0,0,0,0,1,0,24479,0,26124),
(52420,'So much power!','',0,0,0,0,0,0,0,0,1,0,24480,0,26124),
(52421,'You stood in the fire!','',0,0,0,0,0,0,0,0,1,0,24481,0,26124),
(52422,'Nothing but ash!','',0,0,0,0,0,0,0,0,1,0,24478,0,26124),
(52423,'','Yes, mortals, your Thrall is here. He has fused with the stone of this place - heart and soul.',0,0,0,0,0,0,0,0,1,0,0,24787,26124),
(52424,'','His spirit is strong for a creature of mortal flesh. He fascinates me... and I am loathe to give him up.',0,0,0,0,0,0,0,0,1,0,0,24788,26124),
(52425,'','Still, I can hear the cry of a distant heart, echoing through the labyrinths between worlds. It\'s the cry of a lover\'s heart, I hear... and Great Therazane has not forgotten what it was to love...',0,0,0,0,0,0,1,0,1,0,0,24789,26124),
(52426,'','Your world-shaman stands in the basalt-groves below. But take heed - he has become one with these Unending Halls of Stone.',0,0,0,0,0,0,0,0,1,0,0,24790,26124),
(52427,'Blaze of Glory!','',0,0,0,0,0,0,0,0,1,0,24472,0,26124),
(52428,'','He may not wish to leave, regardless of whose heart beckons him home.',0,0,0,0,0,0,0,0,1,0,0,24791,26124),
(52429,'','You may seek him... with my blessing.',0,0,0,0,0,0,1,0,1,0,0,24792,26124),
(52430,'The master\'s power takes on many forms...','',0,0,0,0,0,0,0,0,1,0,24483,0,26124),
(52431,'Behold the rage of the Firelands!','',0,0,0,0,0,0,0,0,1,0,24485,0,26124),
(52432,'My studies... had only just begun...','',0,0,0,0,0,0,0,0,1,0,24471,0,26124),
(52433,'','Thank you, Stonemother.',0,0,0,0,0,0,1,0,1,0,0,24690,26124),
(52434,'','Quickly, friend. Go\'el should be just below.',0,0,0,0,0,0,1,0,1,0,0,24691,26124),
(52436,'','Ready yourselves, warriors. We ride into enemy territory.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52437,'','Look sharp. These woods are crawling with lieutenants of fire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52438,'','Be vigilant, troops. A surprise attack could mean the difference between life and death.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52439,'','These invaders must learn that our lands are not so easily taken. And I shall gladly administer the lesson.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52440,'A-hah! The interlopers! Kill them. EAT THEM!','',0,0,0,0,0,0,0,0,0,0,24565,0,26124),
(52441,'Ohh... the pain.  Lord of Fire, it hurts....','',0,0,0,0,0,0,0,0,0,0,24568,0,26124),
(52442,'All right, troops. Look alive! Is everyone ready?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52443,'','Ready to go, captain.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52444,'It\'s stomping time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52445,'','On the prowl.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52446,'','Yeah mon. Let\'s get dis show on da road.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52447,'All right team, all systems are go! It\'s morphin\' time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52448,'Now you stay dead!','',0,0,0,0,0,0,0,0,0,0,24579,0,26124),
(52449,'The Firelord will be most pleased.','',0,0,0,0,0,0,0,0,0,0,24580,0,26124),
(52450,'|TInterface\\Icons\\ability_mage_worldinflames.blp:20|t%s begins to cast |cFFFF6600|Hspell:100171|h[World In Flames]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52451,'Dog food!','',0,0,0,0,0,0,0,0,0,0,24578,0,26124),
(52452,'Fetch your supper!','',0,0,0,0,0,0,0,0,0,0,24569,0,26124),
(52453,'Now you burn!','',0,0,0,0,0,0,0,0,0,0,24576,0,26124),
(52454,'Riplimb! No... no! Oh, you terrible little beasts! How could you?!','',0,0,0,0,0,0,0,0,0,0,24574,0,26124),
(52455,'Oh, you murderers! Why? Why would you kill such a noble animal?','',0,0,0,0,0,0,0,0,0,0,24575,0,26124),
(52456,'Yes, I smell them too, Riplimb. Outsiders encroach on the Firelord\'s private grounds. Find their trail. Find them for me, that I may dispense punishment!','',0,0,0,0,0,0,0,0,0,0,24584,0,26124),
(52457,'Twist in flames, interlopers!','',0,0,0,0,0,0,0,0,0,0,24577,0,26124),
(52458,'Go for the throat!','',0,0,0,0,0,0,0,0,0,0,24573,0,26124),
(52459,'','I be healin\', mon.  I don\'t have no special shape.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52460,'','Can you feel the magic in the air, $c?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(52461,'Take your positions! We are ready to roll.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52462,'','Powerful magic fills the air this season, $c.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52463,'I\'m ready to attack Stormwind!','I\'m ready to attack Stormwind!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52464,'Good work, druids! This area looks secure. Let\'s head back to base.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52465,'Assume flight form in 3...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52466,'2...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52467,'1...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52468,'Storm crow, go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52469,'Good work, team! Take a breather and report back soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52470,'','Fire. My love has become fire. I feared this. To find him again, we must enter Ragnaros\' burning domain.',0,0,0,0,0,0,1,0,1,0,0,24703,26124),
(52471,'','Stay strong, friend. You know as well as I do - there\'ll be no help for us within the Firelands.',0,0,0,0,0,0,1,0,1,0,0,24705,26124),
(52474,'The Alliance has assaulted the Draenei Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(52475,'The Horde has assaulted the Draenei Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(52476,'The Alliance has taken the Draenei Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(52477,'The Horde has taken the Draenei Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(52478,'The Alliance has defended the Draenei Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(52479,'The Horde has defended the Draenei Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(52480,'$n claims the Draenei Ruins!  If left unchallenged, the Alliance will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52481,'$n claims the Draenei Ruins!  If left unchallenged, the Horde will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52482,'$n has assaulted the Fel Reaver Ruins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52483,'$n has assaulted the Fel Reaver Ruins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52484,'|c00FF0000%s summons Burning Orbs!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52485,'The Alliance has taken the Fel Reaver Ruins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52486,'The Horde has taken the Fel Reaver Ruins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52487,'$n has defended the Fel Reaver Ruins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52488,'$n has defended the Fel Reaver Ruins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52489,'$n claims the Fel Reaver Ruins! If left unchallenged, the Alliance will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52490,'$n claims the Fel Reaver Ruins! If left unchallenged, the Horde will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52491,'|c00FF0000Searing Seeds begin to grow!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52492,'$n has assaulted the Mage Tower!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52493,'$n has assaulted the Mage Tower!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52494,'The Alliance has taken the Mage Tower!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52495,'The Horde has taken the Mage Tower!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52496,'$n has defended the Mage Tower!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52497,'$n has defended the Mage Tower!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52498,'$n claims the Mage Tower!  If left unchallenged, the Alliance will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52499,'$n claims the Mage Tower! If left unchallenged, the Horde will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52500,'$n has assaulted the Blood Elf Tower!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52501,'$n has assaulted the Blood Elf Tower!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52502,'The Alliance has taken the Blood Elf Tower!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52503,'The Horde has taken the Blood Elf Tower!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52504,'$n has defended the Blood Elf Tower!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52505,'$n has defended the Blood Elf Tower!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52506,'$n claims the Blood Elf Tower!  If left unchallenged, the Alliance will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52507,'$n claims the Blood Elf Tower!  If left unchallenged, the Horde will control it in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52508,'Ready yourselves in 3...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52509,'Battle forms, go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52511,'','Begone from these lands, invader!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52512,'','I\'ve sharpened my claws just for this moment.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52513,'','What big teeth I have? Why thank you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52514,'Taste the fury of my moonbeam!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52515,'Fire! Fire! Fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52516,'The very trees repel your presence!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52517,'','Return to da fire from whence ya came, ya ill one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52518,'','It don\'t mattah what you do heah, ravager. Da land will heal after you be dead.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52519,'','Die! Let da fires consume ya once agin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52520,'I\'ll scare them off with my roar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52521,'Charge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52522,'Enemy sighting!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52523,'If you haven\'t run by now, it\'s too late!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52524,'Team druid, attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52525,'You come to join the fight, $c?','You come to join the fight, $c?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52526,'','Ahhh $n, it be good to see ya once agin. Da threat to dese lands be grave, and I come to join da fight. I see ya grown in your own. Good. You mek me, an\' all your tribe, proud.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52527,'The Branch of Nordrassil reacts violently to $n\'s touch!','The Branch of Nordrassil reacts violently to $n\'s touch!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52528,'','$n, I am not surprised to see you here. I always thought you were my brightest pupil. I am honored to fight alongside you, my friend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52529,'$n, you look well. I heard the call to arms, which is why I\'ve left our home and come here to join the fight.$B$BI see you have grown much since we last met. I am honored to have taught you. You are a true hero of the Alliance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52530,'Hello, $n. I heard the call to arms, so I\'ve temporarily taken up my fighting form. You have learned all that I have to teach, so I leave you one last lesson. Fight bravely, young one, as an honored member of the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52531,'','The Twilight Curse is shifting Go\'el between elemental states! Before he vanished, he took on the aspect of water. We must hurry to him...',0,0,0,0,0,0,5,0,1,0,0,24689,26124),
(52532,'The fires consuming the Tormented Protector wink out!','The fires consuming the Tormented Protector wink out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52533,'','No matter how far it takes me - I refuse to give up on him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52534,'Enough...stop...','',0,0,0,0,0,0,0,0,1,0,25164,0,26124),
(52535,'Aggra, I am ready to travel to the Abyssal Maw.','Aggra, I am ready to travel to the Abyssal Maw.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52536,'The fires...torment me no longer.  But...I am consumed...','',0,0,0,0,0,0,0,0,1,0,25165,0,26124),
(52537,'','I can only teleport us once. Make sure you are ready. Go\'el waits for us at the bottom of the ocean...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52538,'','The children love this holiday.  Some children have gone out trick-or-treating, some have stayed behind, and some, like these, have decided to try to run a small business.$b$bTheir goal is to amass as much candy as possible, and they felt the best way was to offer treats for the hard work of others.  I laughed when I first heard of their plan, $c.  But now that I see how many adventurers are giving them candy for their wares, I am worried.$b$bThat is a lot of sugar.  I don\'t think the children will ever be able to fall asleep again.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(52539,'You...friend of Nordrassil...take what remains of my strength...and fight back the flames...','',0,0,0,0,0,0,0,0,1,0,25166,0,26124),
(52540,'May the spirit of the Great Tree shelter you...','',0,0,0,0,0,0,0,0,1,0,25167,0,26124),
(52541,'I will give you what power I can.  May the boughs of the Great Tree shade you from the flames in this infernal abyss.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52542,'I am sorry, dear Nordrassil.  I have failed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52543,'%s collapses upon seeing his master die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52544,'It is a time to celebrate new friends and the future we may forge together.','',0,0,0,0,0,0,396,7,0,0,25178,0,26124),
(52545,'','The water here is disturbed... what is happening here?',0,0,0,0,0,0,6,0,1,0,0,24725,26124),
(52546,'Greetings, travelers. The tides of destiny have brought you far from the bright world above. I know what it is you seek - and it lies there before you...','',0,0,0,0,0,0,0,0,1,0,24782,0,26124),
(52547,'Your world-shaman has become a vortex of longing and desire. See how his heart devours everything within its proximity? Tread lightly, traveler, lest you too, be consumed.','',0,0,0,0,0,0,0,0,1,0,24783,0,26124),
(52548,'','We arrived just in time! Go\'el\'s spirit has become so unstable, it could collapse upon itself if we don\'t act fast.',0,0,0,0,0,0,1,0,1,0,0,24726,26124),
(52549,'Your world-shaman is already lost to the dark fathoms. He exists now only to consume - tortured by the currents of the life he longed for - but never knew.','',0,0,0,0,0,0,0,0,1,0,24784,0,26124),
(52550,'','We will save him, $n. We MUST.',0,0,0,0,0,0,273,0,1,0,0,24727,26124),
(52551,'We\'ve delayed long enough. Let us take the battle to this servant of Ragnaros immediately.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52552,'Wait no longer, I\'m ready to fight.','Wait no longer, I\'m ready to fight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52553,'Molten cracks appear along the Branch of Nordrassil! Something powerful is emerging from the staff!','Molten cracks appear along the Branch of Nordrassil! Something powerful is emerging from the staff!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52554,'%s\'s smoldering body begins to flicker and combust!','%s\'s smoldering body begins to flicker and combust!',0,0,0,0,0,0,0,0,1,0,8715,8715,26124),
(52555,'','We paint our faces with the ash to send a message to new enemies - a declaration to those who fear and revile us as monsters.',0,0,0,0,0,0,1,1,1,0,0,25191,26124),
(52556,'','We watched as our homes were razed to the ground.',0,0,0,0,0,0,1,1,1,0,0,25187,26124),
(52557,'','To those who would question our place in this world...',0,0,0,0,0,0,1,1,1,0,0,25192,26124),
(52558,'','No... we are a force even more terrifying...',0,0,0,0,0,0,274,1,1,0,0,25194,26124),
(52559,'Aggra, I am ready to travel to Deepholm.','Aggra, I am ready to travel to Deepholm.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52560,'','We cried out in agony as our families were cut down before our eyes.',0,0,0,0,0,0,1,1,1,0,0,25188,26124),
(52561,'','The sooner we can get away from the Stonemother, the better. I do not trust her.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52562,'For we have endured much... far beyond what any of us could have imagined.','',0,0,0,0,0,0,396,7,0,0,25175,0,26124),
(52563,'As you stand before me, I pray you cast your burdens behind me.','',0,0,0,0,0,0,396,7,0,0,25180,0,26124),
(52564,'It is an opportunity to mock the fearsome - to gaze boldly into the grim unknown and laugh!','',0,0,0,0,0,0,396,7,0,0,25177,0,26124),
(52565,'With turmoil as tinder, let it blaze; may it temper us against what tomorrow may bring.','',0,0,0,0,0,0,397,7,0,0,25182,0,26124),
(52566,'Spiderlings have been roused from their nest!','Spiderlings have been roused from their nest!',0,0,0,0,0,0,0,0,1,0,11778,11778,26124),
(52567,'Cinderweb Spinners dangle from above!','Cinderweb Spinners dangle from above!',0,0,0,0,0,0,0,0,1,0,8714,8714,26124),
(52568,'','The summoning runes were already drawn when we arrived. You\'ll need to destroy all of them.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52569,'No, fiend. Your time is NOW.','',0,0,0,0,0,0,0,0,1,0,25159,0,26124),
(52570,'Heroes! He is bound. Finish him!','',0,0,0,0,0,0,0,0,1,0,25169,0,26124),
(52571,'It is finished then!','',0,0,0,0,0,0,0,0,1,0,25170,0,26124),
(52572,'Perhaps...','',0,0,0,0,0,0,0,0,1,0,25160,0,26124),
(52573,'Heroes, the world owes you a great debt.','',0,0,0,0,0,0,0,0,1,0,25171,0,26124),
(52574,'Ragnaros has perished.  But the primal powers he represents can never be vanquished.  Another will rise to power, someday.','',0,0,0,0,0,0,0,0,1,0,25158,0,26124),
(52575,'Yes Cenarius, we must maintain a constant vigil over this realm.  But let us celebrate this day and the great victory we have earned here.','',0,0,0,0,0,0,0,0,1,0,25168,0,26124),
(52576,'Indeed.','',0,0,0,0,0,0,0,0,1,0,25161,0,26124),
(52577,'','There! Look at him - frozen in stone, unmoving. Unfeeling. That look on his face... the resolve, the stubbornness. He gets it when he digs his heels in.',0,0,0,0,0,0,0,0,1,0,0,24692,26124),
(52578,'','I\'ve seen it before - in Nagrand when he refused to lay down his mantle of Warchief, and again during his training.',0,0,0,0,0,0,0,0,1,0,0,24693,26124),
(52579,'','I should have known! The Twilight\'s Hammer knew we\'d be here! Defend yourself!',0,0,0,0,0,0,0,0,1,0,0,24695,26124),
(52580,'','Even now, while our enemies crash and surge all around us - he refuses to move - to act! Go\'el, my love... you can be infuriating sometimes.',0,0,0,0,0,0,0,0,1,0,0,24694,26124),
(52581,'','Know this, friend: you have my deepest thanks. Your courage, your strength... you...$b$bYou remind me of him. ',0,0,0,0,0,0,0,0,1,0,0,24740,26124),
(52583,'Aggra, I am ready. Let us go to Thrall.','Aggra, I am ready. Let us go to Thrall.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52585,'%s begins to drink from the magma pools.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52586,'Fiery Lava Worms erupt from the ground!','Fiery Lava Worms erupt from the ground!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52588,'|TInterface\\Icons\\inv_misc_horn_03.blp:20|tAs the creatures of the Firelands fall, a huntsman\'s horn sounds in the distance.','',0,0,0,0,0,0,0,0,0,0,6423,0,26124),
(52589,'|TInterface\\Icons\\inv_misc_horn_03.blp:20|tThe hunting horn sounds again, nearer and more urgently.','',0,0,0,0,0,0,0,0,0,0,6423,0,26124),
(52590,'A small moonwell arises from the droplets of the chalice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52591,'The Molten Eggs begin to crack and splinter!','The Molten Eggs begin to crack and splinter!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52592,'Jin\'do charges his weapon with the Shadows of Hakkar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52593,'Burning Treants erupt from the ground to aid the Protector!','Burning Treants erupt from the ground to aid the Protector!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52594,'%s is about to |cFFFF0000Emerge|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52597,'Kill elementals near Aggra\'s Air Totem, in the west!','Kill elementals near Aggra\'s Air Totem, in the west!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52598,'Kill elementals near Aggra\'s Water Totem, in the north!','Kill elementals near Aggra\'s Water Totem, in the north!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52599,'Kill elementals near Aggra\'s Earth Totem, in the east!','Kill elementals near Aggra\'s Earth Totem, in the east!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52600,'Kill elementals near Aggra\'s Fire Totem, near Thrall!','Kill elementals near Aggra\'s Fire Totem, near Thrall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52601,'MY PARENTS... MURDERED BEFORE I COULD KNOW THEM... BETRAYED!','',0,0,0,0,0,0,0,0,1,0,24764,0,26124),
(52602,'GUL\'DAN! IF I MUST BURN MY WAY ACROSS THE AFTERLIFE, I WILL FIND YOU IN WHATEVER HELL YOU\'VE HIDDEN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52603,'I WILL HAVE MY REVENGE! DO YOU HEAR ME???','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52604,'','He\'s absolutely raging!  So much anger, so much pain... and he had the strength to suppress it all these years...',0,0,0,0,0,0,1,0,1,0,0,24717,26124),
(52605,'RAISED AS A SLAVE... TO KILL FOR HUMAN AMUSEMENT...','',0,0,0,0,0,0,0,0,1,0,24765,0,26124),
(52606,'DEATH WAS TOO GOOD FOR BLACKMOORE. ANYONE WHO WOULD ENSLAVE ANOTHER... DESERVES WORSE THAN DEATH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52607,'ALL ARE GUILTY! ALL MUST PAY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52608,'KING VARIAN... YOU WISH TO MAKE WAR ON MY PEOPLE? YOU SHALL HAVE YOUR WAR, HUMAN!','',0,0,0,0,0,0,0,0,1,0,24766,0,26124),
(52609,'YOU WILL SEE THE FURY OF THE HORDE RAGE THROUGH YOUR CITIES! YOU WILL SEE YOUR THRONE SPLIT IN TWO! THIS I SWEAR!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52610,'GARROSH... Garrosh...','',0,0,0,0,0,0,0,0,1,0,24767,0,26124),
(52611,'','Go\'el! Go\'el, you must stop! Your anger is JUST - but it will only consume you! Fight it down, or we\'re ALL LOST!',0,0,0,0,0,0,5,0,1,0,0,24721,26124),
(52612,'CAIRNE WAS MY BROTHER!!!!!!!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52613,'','Can you even hear me???',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(52614,'It\'s so good seeing so many of you here to celebrate this time honored festivity.  We\'ve suffered many tragedies this year, so a celebration like Brewfest is a welcome and jubilous occasion.','It\'s so good seeing so many of you here to celebrate this time honored festivity.  We\'ve suffered many tragedies this year, so a celebration like Brewfest is a welcome and jubilous occasion.',0,0,0,0,0,0,396,7,1,0,0,0,26124),
(52615,'Years ago, when King Magni approached me about these festivities  I assured him that we gnomes could make Brewfest an event to remember.  But Magni, knew that we gnomes had other tasks that we should focus on.  He wanted to keep it simple and honor the past.','Years ago, when King Magni approached me about these festivities  I assured him that we gnomes could make Brewfest an event to remember.  But Magni, knew that we gnomes had other tasks that we should focus on.  He wanted to keep it simple and honor the past.',0,0,0,0,0,0,396,7,1,0,0,0,26124),
(52616,'King Magni must have sensed some disapointment as he did allow a slight change.  He allowed me a chance to tap the Brewfest Keg.  I remember spending nights trying to figure out how to efficiently and quickly open the keg and distribute its contents such that all participants will receive equal parts quickly and efficiently.','King Magni must have sensed some disapointment as he did allow a slight change.  He allowed me a chance to tap the Brewfest Keg.  I remember spending nights trying to figure out how to efficiently and quickly open the keg and distribute its contents such that all participants will receive equal parts quickly and efficiently.',0,0,0,0,0,0,396,7,1,0,0,0,26124),
(52617,'With plans drawn up, I had my top men and women begin work on a machine to do that exact task!  We had calculated down to the second how best to dist-','With plans drawn up, I had my top men and women begin work on a machine to do that exact task!  We had calculated down to the second how best to dist-',0,0,0,0,0,0,396,7,1,0,0,0,26124),
(52618,'Well... I guess that no one here is going to want to hear about the Keg Tapper prototypes 74205 and 75633...  Maybe if I spoke about prototype 1701-D, you would get excited...','Well... I guess that no one here is going to want to hear about the Keg Tapper prototypes 74205 and 75633...  Maybe if I spoke about prototype 1701-D, you would get excited...',0,0,0,0,0,0,396,7,1,0,0,0,26124),
(52619,'Right, right... So let\'s start the countdown from ten, ready?  TEN!','Right, right... So let\'s start the countdown from ten, ready?  TEN!',0,0,0,0,0,0,396,7,1,0,0,0,26124),
(52620,'Oh... okay, I\'ll just wait for zero then...','Oh... okay, I\'ll just wait for zero then...',0,0,0,0,0,0,396,7,1,0,0,0,26124),
(52621,'I am... alive...','',0,0,0,0,0,0,0,0,1,0,24768,0,26124),
(52622,'','Go\'el, I thought I\'d lost you...',0,0,0,0,0,0,18,0,1,0,0,24722,26124),
(52623,'Aggra, my heart... you never gave up on me. I owe you my life... everything that I am.','',0,0,0,0,0,0,1,0,1,0,24769,0,26124),
(52624,'For I see now what I had become, so weighted down by doubt and anger. All my life, I had CHOSEN to be a slave to fear...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52625,'...a THRALL.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52626,'Fandral sought to use that weakness against me...','',0,0,0,0,0,0,1,0,1,0,24770,0,26124),
(52627,'But what he and his Twilight Masters never understood is that the elements do not exist to rage and war... they exist to bring harmony. Within the world... and within us.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52628,'I have seen the TRUTH - and my chains have been broken.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52629,'Now, I am all that I once was... and more.','',0,0,0,0,0,0,1,0,1,0,24771,0,26124),
(52630,'','Well, you\'re certainly more talkative...',0,0,0,0,0,0,1,0,1,0,0,24723,26124),
(52631,'','But we must hurry back to the World Tree! The Dragon Aspects are waiting...',0,0,0,0,0,0,1,0,1,0,0,24724,26124),
(52632,'Thank you, my friend. I can never repay your service or your friendship.','',0,0,0,0,0,0,1,0,1,0,24772,0,26124),
(52633,'Meet us back at the World Tree. There\'s something... I want you to witness.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52634,'Please feel free to browse the items up for bid, or if you would like to list an item, I can help.','',1,273,0,0,0,0,0,0,1,0,0,0,26124),
(52635,'I\'d like to browse the items up for auction.','I\'d like to browse the items up for auction.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52636,'Has anyone suspicious tried to list a crate of goods recently?','Has anyone suspicious tried to list a crate of goods recently?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(52637,'','I am but a humble herald of the Dark Lady Sylvanas, our Banshee Queen.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52638,'Look, in my business, discretion is important. I shouldn\'t be talking about this at all.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(52639,'The person you described was just here and he tried to persuade me to list a crateful of arcane objects.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52640,'Naturally, I told him that we don\'t deal in stolen goods. This is the Stormwind auction house, not some smoke-filled, back alley swapmeet!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(52641,'','Did I hear right, Omnuron? We\'re going to join the fight?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52642,'I need no more convincing, $n. The Druids of the Talon will lend you their aid.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52643,'Yes, Thisalee. Gather our forces. We leave for the Molten Front at once.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52644,'','I\'m going to enjoy this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52645,'|TInterface\\Icons\\ability_druid_tigersroar.blp:20|t%s transforms into a |c0087CEFA|Hspell:98374|h[Cat]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52646,'|TInterface\\Icons\\inv_mount_hordescorpiong.blp:20|t%s transforms into a |c0087CEFA|Hspell:98379|h[Scorpion]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52647,'','Our original duty binds us to defend this land, but if Fandral has indeed escaped to the Firelands, then we must bring him to justice.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52648,'','Sisters, show yourselves. The time for subtlety is past. We will face our enemies in the Plane of Fire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52649,'','See you on the field of battle, $Gbrother:sister;.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52650,'Mortal filth... the master\'s keep is forbidden....','',0,0,0,0,0,0,0,0,0,0,24444,0,26124),
(52651,'','How can he just STAND there, while we fight off the attackers at his feet?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52652,'','Brace yourself. The Firelands are a dangerous place... even for a formidable $r such as yourself.$b$bLet me know when you are ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52653,'I am prepared. Let us go to the Firelands and finish this.','I am prepared. Let us go to the Firelands and finish this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52654,'','This realm is more terrible than I\'d imagined. Even now, I can feel the rage of this place pressing down on me.',0,0,0,0,0,0,1,0,1,0,0,24708,26124),
(52655,'','We won\'t have much time before they\'re onto us. Let\'s begin.',0,0,0,0,0,0,274,0,1,0,0,24712,26124),
(52656,'','There! I see him, wreathed in flame! I can feel waves of fury radiating from his core. Such rage... his anger alone could burn us to cinders!',0,0,0,0,0,0,25,0,1,0,0,24711,26124),
(52657,'','Protect me and I\'ll place guardian totems all around us.',0,0,0,0,0,0,1,0,1,0,0,24710,26124),
(52658,'What have we here - visitors to our kingdom in the Firelands?','',0,0,0,0,0,0,1,0,1,0,24466,0,26124),
(52659,'You mortals may remember Alysra, who spirited me to freedom in Mount Hyjal. She, too has been reborn. Born of flame!','',0,0,0,0,0,0,1,0,1,0,24467,0,26124),
(52660,'I wish I could watch her reduce your pitiful band to cinders, but I am needed elsewhere. Farewell!','',0,0,0,0,0,0,1,0,1,0,24468,0,26124),
(52661,'Stop evading the question, Quincy! I know the thief was here with that crate.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(52662,'The contents of that crate are very dangerous and they belong in a secure vault, not in the hands of some well-to-do, but ignorant collector!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52663,'Keep it down, will you? I\'m trying to run a business here...','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(52664,'If you\'re willing to forget this crate thing, I can give you a good price on some recent arrivals from Uldum.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(52665,'Fine, fine. I might\'ve given him the name of a private collector interested in that crate\'s contents.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52666,'When the guards pay you a visit, I\'m sure you\'ll have no problem explaining how you got your hands on those Uldum artifacts or that lovely painting.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52667,'Yes $c. We foresaw this day long ago, and we are ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52668,'We cannot let Deathwing win. Should he triumph in this war, then all life will perish.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52669,'Come, protectors! We lend the strength of the ancients to this battle! And we shall not fall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52670,'That\'s a start. And what about you, newcomer? You wouldn\'t be here if you weren\'t after the crate as well.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52673,'Aggra... $n...','',0,0,0,0,0,0,0,0,1,0,24752,0,26124),
(52674,'','Good timing, Ricket. $n says they need your expertise on the Molten Front.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52675,'','Ow! Well I guess that prototype didn\'t work, either.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52676,'','Oh goody! Time to fight fire with...highly flammable weapons grade explosives!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52677,'','I thought you might come. You\'ve proven very persistent. Annoyingly so.',0,0,0,0,0,0,1,0,1,0,0,24900,26124),
(52678,'','It is time to be rid of you.',0,0,0,0,0,0,15,0,1,0,0,24901,26124),
(52679,'','Fandral was a true leader. You are nothing more than a desperate dream.',0,0,0,0,0,0,0,0,1,0,0,24902,26124),
(52680,'','You haven\'t the strength to lead anyone.',0,0,0,0,0,0,0,0,1,0,0,24903,26124),
(52681,'','They will all see through to your weakness soon enough, \"Shan\'do.\"',0,0,0,0,0,0,0,0,1,0,0,24904,26124),
(52682,'','I have power you\'ll never know, Malfurion.',0,0,0,0,0,0,0,0,1,0,0,24905,26124),
(52683,'','I\'ll kill your companion just like I killed Hamuul. And there is nothing you can do about it.',0,0,0,0,0,0,0,0,1,0,0,24906,26124),
(52684,'','Tenaron, old friend. Would you go collect a vial of moonwell water for this $c?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52685,'','I don\'t believe it! I seared the life from your body!',0,0,0,0,0,0,0,0,1,0,0,24907,26124),
(52686,'','Go now, $n. The moonwell will be filled by the time you return to the front.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52687,'It would be my pleasure, Matoclaw.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52688,'And I have come for you, Leyara.','',0,0,0,0,0,0,1,0,1,0,24847,0,26124),
(52689,'I release you from this fate Leyara. May you finally find your peace in death.','',0,0,0,0,0,0,1,0,1,0,24848,0,26124),
(52690,'I\'m sorry that I did not arrive sooner, though you seem to have held your own quite well.','',0,0,0,0,0,0,1,0,1,0,24849,0,26124),
(52691,'We\'ll meet you back in camp.','',0,0,0,0,0,0,1,0,1,0,24850,0,26124),
(52692,'Leyara, you must see that Fandral is beyond redemption. The corruption within him runs deeper than you know.','',0,0,0,0,0,0,1,0,1,0,24946,0,26124),
(52693,'You did not kill Hamuul, Leyara. He lives.','',0,0,0,0,0,0,1,0,1,0,24947,0,26124),
(52694,'It is good to have you back, Hamuul. Let us leave this place.','',0,0,0,0,0,0,1,0,1,0,24948,0,26124),
(52695,'Wahoo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52696,'Thanks, $p! I\'ll tell my pa you helped me see the world!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52697,'This is great!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52698,'You\'re the best, $p!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52699,'','You\'ve come where you are not welcome.',0,0,0,0,0,0,0,0,1,0,0,24928,26124),
(52700,'','Here there is only fire, brimstone, and death.',0,0,0,0,0,0,0,0,1,0,0,24929,26124),
(52701,'','You cause is foolish and futile. You haven\'t the strength to hold on to those dearest to you.',0,0,0,0,0,0,0,0,1,0,0,24930,26124),
(52702,'','You are weak. Pathetic.  Your life will be stripped from you, but only after everything you love has been burnt away.',0,0,0,0,0,0,0,0,1,0,0,24931,26124),
(52703,'','All that awaits you is nothingness.  Emptiness.',0,0,0,0,0,0,0,0,1,0,0,24932,26124),
(52704,'','They have all abandoned you. Left you to die.',0,0,0,0,0,0,0,0,1,0,0,24933,26124),
(52705,'','They will abandon you when you need them most. They will leave you to burn.',0,0,0,0,0,0,0,0,1,0,0,24934,26124),
(52706,'','You have nothing. No one.',0,0,0,0,0,0,0,0,1,0,0,24935,26124),
(52707,'','You know nothing of power. You cling to your allies in desperation, but they cannot save you.',0,0,0,0,0,0,0,0,1,0,0,24936,26124),
(52708,'','Your only hope is that you will all burn together. There is no victory for you.',0,0,0,0,0,0,0,0,1,0,0,24937,26124),
(52709,'|TInterface\\Icons\\inv_mace_2h_sulfuras_d_01.blp:20|t%s begins to cast |cFFFF6600|Hspell:100604|h[Empower Sulfuras]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52710,'Archmage Xylem does not bargain with the likes of you, ruffian. There shall be no payment!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(52711,'What\'s this, an intruder? Let\'s see what the artifacts inside this box can do, shall we?','',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(52712,'%s instantly kills all nearby allies!','%s instantly kills all nearby allies!',0,0,0,0,0,0,0,0,1,0,11139,11139,26124),
(52713,'%s collapses into a smouldering heap....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52714,'%s reanimates and surges into battle to protect his master!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52715,'','Of course, I will share my knowledge with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52716,'','If only Malfurion hadn\'t dumped your grandfather in prison. He rots in a barrow den while the Horde assaults Ashenvale.',0,0,0,0,0,0,0,0,1,0,0,24912,26124),
(52717,'This isn\'t supposed to happen!','',0,0,0,0,0,0,431,0,1,0,0,0,26124),
(52718,'It\'s good to see you again, Mr. Barnes. Do you have the crate?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(52719,'I do. $n just returned with it, but how do I know you\'re going to keep your end of the bargain?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52720,'I have the charm with me and I will unlock its power once the crate is in my hands. You were wise to change your mind, Barnes.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52721,'With it, you will be able to enter Karazhan without fear of harm or detection. Not even Harrison Jones will know how you uncover the tower\'s history.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52722,'Please, take the crate. I\'m already thinking about what I\'ll find in the tower\'s library!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(52723,'I\'ve been waiting for this day for years. Behold my transformation!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52724,'','Weee!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52725,'','This is wonderful!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52726,'','I can see everything from up here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52727,'','Good bye, $p! Thank you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52730,'I hope you weren\'t too put out, $n, but the contents of this crate have been very important to my family for generations.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52731,'I\'ve been preparing for this moment for years, $n, and you\'ve made it all possible. Witness my transformation!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52732,'','Question Auctioneer Fitch!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52733,'<The Arcane Guardian gestures towards the Seer\'s Library.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52734,'May you bathe in flames!','May you bathe in flames!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52735,'My death will be avenged!','My death will be avenged!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52736,'Death to you and your allies!','Death to you and your allies!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52737,'My death means nothing!','My death means nothing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52738,'I serve you...Fire Lord.','I serve you...Fire Lord.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52739,'Ashes...to ashes...','Ashes...to ashes...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52740,'May you burn for eternity!','May you burn for eternity!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52741,'This will not stop us...','This will not stop us...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52742,'Invader! I will kill you with my bare claws!','Invader! I will kill you with my bare claws!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52743,'You dare test us in the realm of fire?','You dare test us in the realm of fire?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52744,'Enemies of the flame are not welcome here!','Enemies of the flame are not welcome here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52745,'Intruder! I will melt the flesh from your bones!','Intruder! I will melt the flesh from your bones!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52746,'Trespassers will be incinerated.','Trespassers will be incinerated.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52747,'You dare challenge the avatars of flame?','You dare challenge the avatars of flame?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52748,'Play with fire and get burned, trespasser.','Play with fire and get burned, trespasser.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52749,'Your world will burn, disbeliever!','Your world will burn, disbeliever!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52750,'No, wait! You haven\'t told me how to use this charm yet!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(52751,'What\'s happening to me? It burns!','',0,0,0,0,0,0,430,0,1,0,0,0,26124),
(52752,'','I would have it no other way.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52753,'I know this will seem like betrayal, but Mr. Hastings has made an offer I simply cannot refuse. My apologies, $n.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52754,'','Aggra is nearly drowned! Save her!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52755,'Question Auctioneer Drezmit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52756,'Feel free to browse the items up for bid. I can help you place an item up for auction too.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(52757,'Have you seen anyone suspicious trying to sell a crate of objects recently?','Have you seen anyone suspicious trying to sell a crate of objects recently?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52758,'Let me see the items up for auction.','Let me see the items up for auction.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52759,'We don\'t deal with those kinds of people here! This auction house only lists honestly-acquired merchandise.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52760,'Listen, if you can be discreet about it, there are a bunch of places in this town guys like me aren\'t supposed to know about.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52761,'I\'m willing to help you out, but you have to promise not to mention this to anyone else. Even talking about this kind of thing can hurt my reputation!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52762,'MY POWER WILL NOT BE CONTAINED!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52763,'TO THE GROUND!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52764,'BURN BEFORE ME!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52765,'BURNINATE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52766,'Quicker or I\'ll turn you into cinder myself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52767,'|TInterface\\Icons\\spell_shadow_rainoffire.blp:20|t Herald of the Burning End begins casting |cFFFF0000|Hspell:100761|h[Cataclysm]|h|r!','|TInterface\\Icons\\spell_shadow_rainoffire.blp:20|t Herald of the Burning End begins casting |cFFFF0000|Hspell:100761|h[Cataclysm]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52768,'Incompetent fools, summon faster!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52769,'Flame consume these mortals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52770,'Nothing will remain but a pile of ash!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52771,'Cast faster!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52772,'If these mortals don\'t kill you, I will!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52773,'','...and you, my love, have a world to save.   ',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(52774,'','A totem is failing! You must reactivate it!',0,0,0,0,0,0,22,0,1,0,0,24718,26124),
(52775,'','Quickly, reactivate the totem!',0,0,0,0,0,0,22,0,1,0,0,24719,26124),
(52776,'','Keep the totems alive! Hurry!',0,0,0,0,0,0,22,0,1,0,0,24720,26124),
(52777,'There\'s no point in denying it, Dran! That thief knew exactly where to bring his stolen goods.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52778,'I don\'t know what you\'re talking about, elf, and I don\'t appreciate you pokin\' around in my business!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52779,'I do seem to have mistakenly come into possesion of some artifacts from Uldum. Perhaps the Reliquary is interested in those?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52780,'Fine, fine. I may have helped him contact an interested buyer. But keep your voice down! You\'ll scare away my customers.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52781,'Shall we see what the grunts have to say about your stolen antiquities?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52782,'Now we\'re getting somewhere...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52783,'And you, what\'s your interest in this? Let\'s have a word...','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(52784,'We must not fail the Firelord!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52785,'Animators, bring this magma to life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52786,'My blade will char your flesh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52787,'Keep casting! I will dispose of them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52788,'','|TInterface\\Icons\\spell_shaman_stormearthfire.blp:20|t Alysrazor begins to charge up a |cFFFF0000|Hspell:100744|h[Firestorm]|h|r!',0,0,0,0,0,0,0,0,1,0,0,24432,26124),
(52789,'','We will need the help of ALL the elements to save Thrall from this place. The lieutenants of Ragnaros will not be nearly as compromising as Cyclonas, Hydrius, or even Therazane.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52790,'','I can\'t believe that it\'s... over...$b$bGo\'el is free, thanks in no small part to you, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52791,'Umm, Aggra... shouldn\'t you be following Thrall?','Umm, Aggra... shouldn\'t you be following Thrall?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52792,'','You are right. I will see you in Mount Hyjal, friend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52793,'Don\'t forget your totems!','Don\'t forget your totems!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52794,'Hold the line, soldiers! Do not give them quarter! Do not let them pass!','',0,0,0,0,0,0,397,0,1,12165,0,0,26124),
(52795,'Rest? We can rest when we are buried in our graves. Today, we must fight!','',0,0,0,0,0,0,15,0,1,12165,0,0,26124),
(52796,'Use your legs, soldiers!','',0,0,0,0,0,0,15,0,1,12165,0,0,26124),
(52797,'We cannot let the deaths of our comrades go wasted! Do not let down your guard!','',0,0,0,0,0,0,22,0,1,12165,0,0,26124),
(52798,'We must hold out a little longer, just until reinforcements arrive.','',0,0,0,0,0,0,22,0,1,12165,0,0,26124),
(52799,'Our enemies think we are weak. Are we weak, soldiers? If not, then prove it to them!','',0,0,0,0,0,0,22,0,1,12165,0,0,26124),
(52800,'Good work, defenders! We are gaining ground!','',0,0,0,0,0,0,22,0,1,12165,0,0,26124),
(52801,'This fight is the true test of courage. Steel your hearts and drench your blades in the enemy\'s blood!','',0,0,0,0,0,0,22,0,1,12165,0,0,26124),
(52802,'In the face of this cataclysm, I\'ve seen how truly fleeting our lives can be. And I, for one, will not waste another second of mine.','',0,0,0,0,0,0,1,0,1,0,24760,0,26124),
(52803,'','What are you saying, Go\'el? What is in your heart?',0,0,0,0,0,0,6,0,1,0,0,24706,26124),
(52804,'Aggra... though I was not born on Draenor, I have always tried to honor the traditions of our ancestors...','',0,0,0,0,0,0,1,0,1,0,24761,0,26124),
(52805,'I stand before you - Go\'el, Son of Durotan, Son of Garad... and if you would have me, I would be your life-mate.','',0,0,0,0,0,0,1,0,1,0,24762,0,26124),
(52806,'For so long as I live, I will stand at your side... as you have stood at mine.','',0,0,0,0,0,0,1,0,1,0,24763,0,26124),
(52807,'','I stand before you - Aggralan, daughter of Ryal, daughter of Sarrak... and I will proudly be your mate, Go\'el... in this world or any other.',0,0,0,0,0,0,1,0,1,0,0,24707,26124),
(52808,'The essence of Tarecgosa is with you.','The essence of Tarecgosa is with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52809,'You must not think of this as betrayal, $n, but Mr. Goodwin has offered me the find of a lifetime in exchange for his belongings.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52810,'I do. $n has just returned with it. What of the grimoire?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52811,'It is yours, my dear Mister Goodwin. Master Belloc will be most pleased with our trade.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(52812,'Perhaps Belloc and the Reliquary shall have both of these after all...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52813,'Direct and to the point! Good, I am eager to claim what is rightfully mine. Do you have it?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52814,'Indeed, I have Medivh\'s grimoire. I am fortunate that the Reliquary has seen the wisdom of this exchange.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52815,'You shall have it as soon as the crate is in my possession. I\'m sure your colleagues will find it most enlightening.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52816,'For years, I have longed to complete this spell and my transformation. Behold!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(52817,'I have been dreaming of this day for years, $n, and you have made it all possible. Witness the culmination of a lifetime of work!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(52818,'|TInterface\\Icons\\ability_vehicle_oiljets.blp:16|tYou are about to cast|cFFFF0000|Hspell:81831|h[Corruption: Sickness]|h|r! Face away from allies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52819,'|TInterface\\Icons\\inv_elemental_mote_fire01.blp:16|tYou are about to burst into |cFFFF0000|Hspell:100460|h[Blazing Heat]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52820,'|TInterface\\Icons\\ability_warlock_inferno.blp:20|t%s begins to cast |cFFFF6600|Hspell:100777|h[Magma Geyser]|h|r at the cluster of enemies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52821,'Come, kindling!  Nordrassil\'s power WILL be mine!','Come, kindling!  Nordrassil\'s power WILL be mine!',0,0,0,0,0,0,0,0,1,0,25163,25163,26124),
(52822,'You feel a surge of power as Tarecgosa\'s essence manifests itself.','You feel a surge of power as Tarecgosa\'s essence manifests itself.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52823,'Welcome to the Shady Lady, home of fine wines and exotic merchandise you won\'t find anywhere else!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(52824,'Show me what\'s on the menu.','Show me what\'s on the menu.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52825,'No, NO! I didn\'t \"betray\" the dragonflights. We were all betrayed. Ysera was lost in a dream while this whole world came undone.','',0,0,0,0,0,0,0,0,1,0,24440,0,26124),
(52826,'I enact my master\'s will! I am he who bars the gate!','',0,0,0,0,0,0,0,0,0,0,24445,0,26124),
(52827,'Fool mortals. Hurl yourselves into your own demise.','',0,0,0,0,0,0,0,0,0,0,24446,0,26124),
(52828,'By the Firelord\'s command, you, too, shall perish!','',0,0,0,0,0,0,0,0,0,0,24447,0,26124),
(52829,'The master will see you all consumed.','',0,0,0,0,0,0,0,0,0,0,24457,0,26124),
(52830,'Be swallowed by a sea of flame!','',0,0,0,0,0,0,0,0,0,0,24458,0,26124),
(52831,'Burn beneath my molten fury.','',0,0,0,0,0,0,0,0,0,0,24459,0,26124),
(52832,'None may enter the master\'s domain!','',0,0,0,0,0,0,0,0,0,0,24460,0,26124),
(52833,'I have come for you, Malfurion.','',0,0,0,0,0,0,0,0,1,0,24512,0,26124),
(52834,'You are all weak. Frail.','',0,0,0,0,0,0,0,0,1,0,24511,0,26124),
(52835,'There is one true path. The path of flame!','',0,0,0,0,0,0,0,0,1,0,24510,0,26124),
(52836,'Yours is a path of doom.','',0,0,0,0,0,0,0,0,1,0,24509,0,26124),
(52837,'Destroy their camp. Burn their tree to ash.','',0,0,0,0,0,0,0,0,1,0,24508,0,26124),
(52838,'Burn everything. Leave no survivors.','',0,0,0,0,0,0,0,0,1,0,24507,0,26124),
(52839,'Kill them all. Bring Malfurion to me.','',0,0,0,0,0,0,0,0,1,0,24506,0,26124),
(52840,'Leave none alive, save Malfurion. He is mine.','',0,0,0,0,0,0,0,0,1,0,24505,0,26124),
(52841,'Begone from my realm, insects.','',0,0,0,0,0,0,0,0,1,0,24533,0,26124),
(52842,'I will see you all burn.','',0,0,0,0,0,0,0,0,1,0,24534,0,26124),
(52843,'Be consumed by flame!','',0,0,0,0,0,0,0,0,1,0,24535,0,26124),
(52844,'The realm of fire will consume you!','',0,0,0,0,0,0,0,0,1,0,24536,0,26124),
(52845,'You are marked for death. Flee, little one!','',0,0,0,0,0,0,0,0,0,0,24595,0,26124),
(52846,'You are being...hunted.','',0,0,0,0,0,0,0,0,0,0,24594,0,26124),
(52847,'Time to run. Shannox comes.','',0,0,0,0,0,0,0,0,0,0,24593,0,26124),
(52848,'The realm of fire will consume you!','',0,0,0,0,0,0,0,0,0,0,24592,0,26124),
(52849,'|TInterface\\Icons\\ability_mage_firestarter.blp:20|t%s casts |cFFFF0000|Hspell:100675|h[Dreadflame]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52850,'Magma swirls and eddies lazily inside the orb, but the translucent surface is solid and cool to the touch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52851,'<Pick up the orb and shake it vigorously.>','<Pick up the orb and shake it vigorously.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52852,'Deathwing has prepared me to face the vessel of Tarecgosa, your fools journey ends here!','',0,0,0,0,0,0,0,0,1,0,25162,0,26124),
(52853,'Fool! You dare enter the realm of fire?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52854,'You will find the inscription trainer, Recorder Lidio, in southern Aldor Rise.','You will find the inscription trainer, Recorder Lidio, in southern Aldor Rise.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(52855,'The Scryer\'s Tier has a library devoted to training professions.$b$bYou will find the knowledge you seek in the Seer\'s Library.','The Scryer\'s Tier has a library devoted to training professions.$b$bYou will find the knowledge you seek in the Seer\'s Library.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(52856,'You will find Technician Mihila on the Aldor Rise.','You will find Technician Mihila on the Aldor Rise.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(52857,'You will find the herbalism trainer, Jijia, in eastern Aldor Rise.','You will find the herbalism trainer, Jijia, in eastern Aldor Rise.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(52858,'You will find Recorder Lidio on the Aldor Rise.','You will find Recorder Lidio on the Aldor Rise.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(52859,'You will find Fono, the mining trainer, on the Aldor Rise.','You will find Fono, the mining trainer, on the Aldor Rise.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(52860,'You will find Weaver Aoa in northeastern Aldor Rise.','You will find Weaver Aoa in northeastern Aldor Rise.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(52861,'Ahhhhhhh! The sky is falling!','Ahhhhhhh! The sky is falling!',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(52862,'Get out of the fire!','Get out of the fire!',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(52863,'Fire! Fire!','Fire! Fire!',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(52864,'Run! Ruuuuuuun!','Run! Ruuuuuuun!',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(52865,'Does it leash?','Does it leash?',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(52866,'It came from above!','It came from above!',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(52867,'Why does that keep happening?','Why does that keep happening?',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(52868,'Who keeps pulling?!?','Who keeps pulling?!?',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(52869,'Can we pull yet? Can we? Can we?','Can we pull yet? Can we? Can we?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(52870,'Get your flasks! Get your buffs!','Get your flasks! Get your buffs!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(52871,'Ok, kick the boss on the third cast of the second phase. Always kick the first cast of the first phase but never the second on the first. Unless, you see lightning. If you see lightning - kick anyway. What\'s so hard about that?','Ok, kick the boss on the third cast of the second phase. Always kick the first cast of the first phase but never the second on the first. Unless, you see lightning. If you see lightning - kick anyway. What\'s so hard about that?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(52872,'Does anyone have a repair bot?','Does anyone have a repair bot?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(52873,'Hey guys, this is my first time here...anything I should know about?','Hey guys, this is my first time here...anything I should know about?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(52874,'Ahhhhhhh! The sky is falling!','Ahhhhhhh! The sky is falling!',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(52875,'Get out of the fire!','Get out of the fire!',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(52876,'Fire! Fire!','Fire! Fire!',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(52877,'Run! Ruuuuuuun!','Run! Ruuuuuuun!',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(52878,'Stop standing in the fire!','Stop standing in the fire!',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(52879,'It came from above!','It came from above!',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(52880,'Why does that keep happening?','Why does that keep happening?',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(52881,'Who keeps pulling!?!','Who keeps pulling!?!',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(52882,'Does anyone have a repair bot?','Does anyone have a repair bot?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52883,'Hey guys, this is my first time here...anything I should know about?','Hey guys, this is my first time here...anything I should know about?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52884,'Can we pull yet? Can we? Can we?','Can we pull yet? Can we? Can we?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52885,'Get your flasks! Get your buffs!','Get your flasks! Get your buffs!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52886,'Ok, kick the boss on the third cast of the second phase. Always kick the first cast of the first phase but never the second on the first. Unless, you see lightning. If you see lightning - kick anyway. What\'s so hard about that?','Ok, kick the boss on the third cast of the second phase. Always kick the first cast of the first phase but never the second on the first. Unless, you see lightning. If you see lightning - kick anyway. What\'s so hard about that?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52887,'|TInterface\\Icons\\achievement_boss_ragnaros.blp:20|tYou are about to cast |cFFFF0000|Hspell:101109|h[Rage of Ragnaros]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52888,'%s becomes enraged at seeing one of his companions fall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52889,'|TInterface\\Icons\\spell_shadow_curse.blp:20|t%s readies his |cFF7A0080|Hspell:99352|h[Decimation Blade]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(52890,'|TInterface\\Icons\\inv_sword_09.blp:20|t%s readies his |cFFFF0000|Hspell:99350|h[Inferno Blade]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(52891,'','Leyara barks a cruel laugh.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52892,'If there\'s one thing I know, it\'s that you can always count on a good friend. If you have such a person in your life, cherish them well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52893,'Anren is my best friend. I don\'t know what I would do without him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52894,'Tholo and I are joining the Firelands invasion effort. Live together, fight together, die together. That\'s what brothers are for!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52895,'Tholo and I have been through so much together. I always know he\'s watching out for me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52896,'Placeholder Text!','Placeholder Text!',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(52897,'Placeholder','Placeholder',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(52898,'Placeholder','Placeholder',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(52899,'Placeholder','Placeholder',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(52900,'Placeholder','Placeholder',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(52901,'Placeholder','Placeholder',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(52902,'Placeholder','Placeholder',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(52903,'Placeholder','Placeholder',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(52904,'Placeholder','Placeholder',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(52905,'Placeholder','Placeholder',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(52906,'Placeholder','Placeholder',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(52907,'Placeholder','Placeholder',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(52908,'Placeholder','Placeholder',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(52909,'Placeholder','Placeholder',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(52910,'Placeholder','Placeholder',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(52911,'Placeholder','Placeholder',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(52912,'Do you know how many supplies it takes to support an army, $n? We need weapons, food, shelter, bandages...and that\'s just to start.$B$BThe supplies will not stock themselves. Ask Matoclaw if you\'re looking for ways to help. She will put you to use.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52913,'The warm embrace of Tarecgosa\'s presence encircles you.','The warm embrace of Tarecgosa\'s presence encircles you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52914,'','I am gathering my strength before I return to the battle. You would be wise to do the same.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52915,'','The spiders here are as big as... me! Do you know how to get rid of a spider infestation?$B$BYeah, that\'s right. Dynamite. Lots and lots of dynamite.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52916,'Uh...','Uh...',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(52917,'Uh...','Uh...',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52918,'See you later! I\'m outta here!','See you later! I\'m outta here!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(52919,'See you later! I\'m outta here!','See you later! I\'m outta here!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(52920,'Don\'t stand in the fire!','Don\'t stand in the fire!',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(52921,'Spread out! Spread out!','Spread out! Spread out!',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(52922,'More dots! I need more dots!','More dots! I need more dots!',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(52923,'Minus 50 DKP to the person that pulled!','Minus 50 DKP to the person that pulled!',0,0,0,0,0,0,22,7,1,0,0,0,26124),
(52924,'Don\'t stand in the fire!','Don\'t stand in the fire!',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(52925,'Spread out! Spread out!','Spread out! Spread out!',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(52926,'More dots! I need more dots!','More dots! I need more dots!',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(52927,'Minus 50 DKP to the person that pulled!','Minus 50 DKP to the person that pulled!',0,0,0,0,0,0,22,1,1,0,0,0,26124),
(52928,'Tell me about the ancient, Malorne.','Tell me about the ancient, Malorne.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52929,'','Legends of the great white stag have persisted in my culture for as long as we tauren can remember. Malorne likely stood guard over the primal forests at the very dawn of the world. He was an ancient spirit, the very embodiment of nature\'s power and purity!$B$BLong ago, the greatest tauren hunters would track the white stag when the moon was full. To catch even a glimpse of his shimmering hide through the trees was said to bring great fortune to the tribe for a generation.$B$BDid you know that Malorne was the consort of the moon goddess?',1,5,6,0,0,0,0,0,1,0,0,0,26124),
(52930,'No, tell me more!','No, tell me more!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52931,'','Yes, Malorne was consort to the moon goddess herself, the one the night elves call \"Elune.\" From their union was born Cenarius, the patron god of all druids and one of the most powerful creatures ever to walk upon Azeroth.$B$BBut listen to me, I ramble on.$B$BMalorne is an incredible force of nature, but he only interacts with the mortal races in times of dire trouble. Have you heard about his deeds during the War of the Ancients? ',1,274,6,0,0,0,0,0,1,0,0,0,26124),
(52932,'Fight well, soldier. I need you to stay alive out there.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52933,'They are tokens of respect, purchased only with blood on the battlefield. Earning enough of these marks will be critical if we plan on winning this war.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52934,'To stand a chance in this battle against Ragnaros, we must gather allies who will gladly brave the scorched plains of the Firelands. And before we can recruit such allies to our cause - be they druid, soldier, or simple provisioner - we will need to give them reason to join us.$b$bCarrying even a handful of these marks signifies you as a hero of our cause. Gather them in the hundreds... and you will lead armies.$b$bAre you beginning to see the plan yet?','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52935,'Commander Shadowsong, what are the Marks of the World Tree?','Commander Shadowsong, what are the Marks of the World Tree?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52936,'And why is that, exactly?','And why is that, exactly?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52937,'','Back behind me, where you first came in, there is a large thermal vent, blowing hot air up and out of this place. Stand on top of the vent, and then... jump! The momentum from your leap should be enough to propel you up to the top.$b$bOh, one more thing - based on some reports I\'m hearing from fellow druids, make sure you watch your head on the way out.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52938,'','Of course. By the way: you\'ll find several smaller vents which behave the same way, deeper in the cavern. With time, you may learn to use them to travel more efficiently within the cavern - or simply as a way to torment those gutless flamewakers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52939,'How do I get out of here?','How do I get out of here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52940,'I think I understand. Thank you.','I think I understand. Thank you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52941,'','Well, my master Morthis is really the expert, but I can share with you what I know.$b$bThey are not birds. Certainly, they fly, their wings have the appearance of feathers, and we even call them hawks, but that is where the comparisons to birds stop. In fact, it would appear that they have more in common with dragons: an affinity for fire, a solitary nature, and - based on what we\'ve seen - some indications of intelligence.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52942,'','Isn\'t it? However, they do differ from dragons when it comes to their lifespan. Whereas the dragons of our world can live for millennia on end, these fire hawks live brief lives, passing quickly from egg to adulthood to death.$b$bThough my master warns against making emotional connections to our studies, sometimes I can\'t help but feel sorry for them. They burn so brightly in life... but in death, they\'re quickly replaced and forgotten.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52943,'What more can you tell me about these fire hawks?','What more can you tell me about these fire hawks?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52944,'Fascinating.','Fascinating.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52945,'What is there to tell? They\'re spiders. Just slightly more... flame-oriented than the spiders you and I are used to.$b$bThey bite, they spin webs, they spit burning venom, and they capture some of my best friends in cocoons of searing silk. Horrible little things.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52946,'No matter. These are not the spiders we need to worry about, however. Their queen, Beth\'tilac, is the true danger. Her webbed fortress lies to the east, beyond our reach. There, she is protected by an army of arachnids, all prepared to give their life for the queen.$b$bAnd they\'re huge, too! Believe it or not, the 12-foot-long spiders you see here are the small ones. That being said, while they may not be minions of Ragnaros in the literal sense, they are a danger to our cause and should be treated as such.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52947,'What can you tell me about these spiders?','What can you tell me about these spiders?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52948,'I\'m sorry to hear that.','I\'m sorry to hear that.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52949,'','Not much, I\'m afraid. I\'m no druid, I\'m here to lead troops. Seems odd to me that Malfurion tried to plant a tree in the middle of a warzone, but... like I said, I\'m no druid.$b$bHowever, I can tell you this. NOTHING makes those fire elementals angrier than the idea of a big, leafy tree growing right in the middle of their homeland. If nothing else, when this tree grows to its full size, it will be a beacon of hope for our forces... and a thorn in the side of our enemy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52950,'What can you tell me about the Sentinel Tree, general?','What can you tell me about the Sentinel Tree, general?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52951,'What happened during the War of the Ancients?','What happened during the War of the Ancients?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52952,'','Ten thousand years ago, when the demons of the Burning Legion invaded Azeroth, the ancients fought side-by-side with the mortal races. Many of the ancients met their end by the Legion\'s hand. Cenarius would\'ve been killed as well, were it not for the actions of his father, Malorne.$B$BThe mighty stag leapt into battle, his hooves crashing down on demon skulls and his antlers piercing their fiery flesh.$B$BThen Archimonde the Defiler took to the field of battle. After a fierce fight, he seized Malorne by his antlers and... and snapped the ancient\'s neck.$B$BBut as long as there\'s life in the world, can a force of nature like Malorne ever truly die?',1,274,6,0,0,0,0,0,1,0,0,0,26124),
(52953,'','Go\'el - the one you call Thrall - his spirit has been scattered across the elemental planes.$b$bThe Twilight\'s Hammer thinks to shake our will... but we shall not weaken. We will not forsake Go\'el.$b$bHe has risked everything to save this world, and we\'ll do no less for him!',396,5,0,0,0,0,0,0,1,0,0,0,26124),
(52954,'','Let me know when you are ready to travel to Uldum. We will ask Cyclonas what he knows.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52955,'I am ready to travel to Uldum, Aggra.','I am ready to travel to Uldum, Aggra.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52956,'','Fandral Staghelm has returned as a ... \"Druid of the Flame?\"$B$BI fear one of my own may be implicated in this betrayal!',1,274,0,0,0,0,0,0,1,0,0,0,26124),
(52957,'Yes, $c, things appear bleak. But know that even as things appear to unravel, they do so with a greater purpose.$B$B<Despite his comforting words, Nozdormu looks stricken, if not ill.>','',1,274,0,0,0,0,0,0,1,0,0,0,26124),
(52958,'I wish I could aid you in your plight, mortal. But the blue dragonflight is in disarray, and there are other urgent matters here at the World Tree that I\'ve been sent to investigate...','',6,274,0,0,0,0,0,0,1,0,0,0,26124),
(52959,'','The world-shaman - shattered by the hand of Fandral Staghelm?$B$BGreater powers are at work here. Ragnaros has pushed his strength farther into this realm than I would have imagined.$B$BThe Firelord must be stopped!',5,1,274,0,0,0,1,0,1,0,0,21045,26124),
(52960,'It is you again, $c.$B$BIs something wrong?$B$B<Alysra\'s tail flinches, and her eyes dart back and forth under their lids.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52961,'You turned Fandral Staghelm over to the Twilight\'s Hammer. Why have you betrayed the dragonflights?','You turned Fandral Staghelm over to the Twilight\'s Hammer. Why have you betrayed the dragonflights?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52962,'We are too late! They killed her, as Fandral predicted.','We are too late! They killed her, as Fandral predicted.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52963,'','No, the Firelord has already claimed this one for his own. Do you doubt his power?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52964,'Has the Earthen Ring sent you?$B$BOur efforts to heal the land must begin here, at the World Tree. I\'m glad you are here to witness this.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(52965,'I believe Aggra is almost here, and the other aspects have assembled.$B$BAre you ready to begin, $n?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(52966,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52969,'[  Cinematic Camera TBD  ]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52970,'The Darkmoon Faire is now open!$b$bFor a small fee, I can teleport you to the fairground staging area.$b$bWould you like to go?','The Darkmoon Faire is now open!$b$bFor a small fee, I can teleport you to the fairground staging area.$b$bWould you like to go?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(52971,'Take me to the faire staging area.','Take me to the faire staging area.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52972,'Travel to the faire staging area will cost:','Travel to the faire staging area will cost:',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52973,'Return to Malfurion to protect the Sanctuary of Malorne.','Return to Malfurion to protect the Sanctuary of Malorne.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52974,'%s grows impatient and becomes |cff7115ff|Hspell:101304|h[Superheated]|h|r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52975,'$C!  No mounts on the game grounds!','$C!  No mounts on the game grounds!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52976,'Leaving the faire so soon?$b$bFor a small fee, I can teleport you to a capital city.$b$bAre you sure you want to leave?','Leaving the faire so soon?$b$bFor a small fee, I can teleport you to a capital city.$b$bAre you sure you want to leave?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52977,'Take me to Stormwind.','Take me to Stormwind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52978,'Travel from the faire will cost:','Travel from the faire will cost:',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52979,'Welcome to the Darkmoon Faire, $c!','Welcome to the Darkmoon Faire, $c!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52980,'Alysra takes a deep breath. Get behind cover!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52982,'We are focus testing new encounters! I can open doors, build bridges, and slay lions to facilitate the testing.','',396,396,0,0,0,0,0,0,1,0,0,0,26124),
(52983,'I\'ll do it, Jebediah. Teleport me!','I\'ll do it, Jebediah. Teleport me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52984,'Take me to the Skyfire to fight Deathwing.','Take me to the Skyfire to fight Deathwing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52987,'','Beware, mortal.$b$bOnly the most experienced heroes should accompany me in the Nexus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52988,'I wish to test the Legendary Nexus instance.','I wish to test the Legendary Nexus instance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52991,'%s quickly avoids your attempt to tame!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52995,'Defend the Hyjal Wisp as it closes the attacker\'s portal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52996,'Hyjal Wisp calls out for aid! Defend the Hyjal Wisp as it closes the attacker\'s portal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52997,'Hyjal Wisp is weakened! Defend the Hyjal Wisp as it closes the attacker\'s portal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52998,'Hyjal Wisp has been slain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(52999,'What are we building here?','What are we building here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53000,'We are building a permanent outpost here in the Firelands, $n. Even if Ragnaros is defeated, another may someday take his place. We cannot allow what happened in the Burning Steppes and Mount Hyjal to threaten our world again.$B$BTo that end, we will grow the \"Sentinel Tree.\" A tree with roots in Azeroth, but a protective canopy growing here in this terrible realm. Under its shelter, we will permanently station a group of druids to maintain an eternal vigil over this desolate world.','',1,274,25,0,0,0,0,0,1,0,0,0,26124),
(53003,'A piercing howl echoes through the hallways!','A piercing howl echoes through the hallways!',0,0,0,0,0,0,1,0,1,0,24995,24995,26124),
(53004,'Purple Puffer Pet','Purple Puffer Pet',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53005,'Throwing Starfish','Throwing Starfish',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53006,'Swift Shorestrider','Swift Shorestrider',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53007,'Throne of Tides','Throne of Tides',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53008,'Deth\'tilac asserts his Molten Will!','Deth\'tilac asserts his Molten Will!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53009,'%s receives reinforcements!','%s receives reinforcements!',0,0,0,0,0,0,0,0,1,3623,0,0,26124),
(53010,'Tholo\'s Thermometer shows no reading here.','Tholo\'s Thermometer shows no reading here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(53011,'%s is nearing full strength!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53012,'%s signals for the Flamewaker Animators to cast faster!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53013,'%s orders Flamewaker Animator to cast faster!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53014,'%s breaks free from its bindings!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53015,'You seek the troll, Jabul. He can help you.','You seek the troll, Jabul. He can help you.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(53016,'The caravan has arrived. Good luck!','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(53017,'Defeat the Magic Hunters and find Tarecgosa!','Defeat the Magic Hunters and find Tarecgosa!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53018,'Our ethereal technomancy has the ability to modify an item\'s arcane essence in ways previously unimaginable. We can also house items in a pocket dimension... for a small fee. See my associates for details.$B$BUnless you have something for me to examine?','Our ethereal technomancy has the ability to modify an item\'s arcane essence in ways previously unimaginable. We can also house items in a pocket dimension... for a small fee. See my associates for details.$B$BUnless you have something for me to examine?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53019,'Unsatisfied with the appearance of an item?$B$BBehold the Transmogrifier, one of our most potent technomantic engines. With it, a skilled Warpweaver may shift the appearance of one object to that of another.$B$BWhat might this humble one transmogrify for you, goodly customer?','Unsatisfied with the appearance of an item?$B$BBehold the Transmogrifier, one of our most potent technomantic engines. With it, a skilled Warpweaver may shift the appearance of one object to that of another.$B$BWhat might this humble one transmogrify for you, goodly customer?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53020,'Transmogrify an item.','Transmogrify an item.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53021,'What is transmogrifying?','What is transmogrifying?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53022,'DNT: Transmogrification rules go here!','DNT: Transmogrification rules go here!',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53023,'<DNT: Storage explanation.>','<DNT: Storage explanation.>',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53024,'Store an item.','Store an item.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53027,'Hey, hey!$B$BI\'m sure you can land a ring on a slow-moving turtle.$b$bWhat do you say?','Hey, hey!$B$BI\'m sure you can land a ring on a slow-moving turtle.$b$bWhat do you say?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53028,'Ready to play! |cFF0008E8(Darkmoon Game Token)|r','Ready to play! |cFF0008E8(Darkmoon Game Token)|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53029,'','MOVE FORWARD!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53030,'','MOVE RIGHT!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53031,'','MOVE LEFT!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53032,'Thank you, $c.','Thank you, $c.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(53033,'Time to get back to work!','Time to get back to work!',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(53034,'I\'m feeling better already.','I\'m feeling better already.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(53035,'It doesn\'t hurt so much anymore.','It doesn\'t hurt so much anymore.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(53036,'I can\'t thank you enough!','I can\'t thank you enough!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(53037,'You give me a game token, and I\'ll give you ten rings. $B$BThrow the rings onto Dubenko the Darkmoon Turtle over there... see the pole he\'s carrying on his shell?$b$bIf you don\'t land enough rings to win in one go, try again! Your points carry over into your next game.','You give me a game token, and I\'ll give you ten rings. $B$BThrow the rings onto Dubenko the Darkmoon Turtle over there... see the pole he\'s carrying on his shell?$b$bIf you don\'t land enough rings to win in one go, try again! Your points carry over into your next game.',378,0,0,0,0,0,0,0,1,0,0,0,26124),
(53038,'Launch me! |cFF0008E8(Darkmoon Game Token)|r','Launch me! |cFF0008E8(Darkmoon Game Token)|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53039,'|TInterface\\Icons\\ability_warstomp.blp:20|t%s casts |cFFFF0000|Hspell:101626|h[Pulverize]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53040,'','You asked for it.',0,0,0,0,0,0,0,0,1,0,0,25917,26124),
(53041,'Hello, and welcome!$B$BUp for a challenge?','',1,6,0,0,1000,0,0,0,1,0,0,0,26124),
(53042,'Let\'s shoot! |cFF0008E8(Darkmoon Game Token)|r','Let\'s shoot! |cFF0008E8(Darkmoon Game Token)|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53043,'We have to reach the Aspects, are you ready?','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53044,'Yes Thrall.','Yes Thrall.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53046,'Heroes, we have the Dragon Soul. The Aspects await us within Wyrmrest. Hurry -  come with me!','',0,0,0,0,0,0,0,0,1,0,25870,0,26124),
(53047,'You will not leave this canyon alive.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53048,'Hurry - we must keep moving.','',333,0,0,0,0,0,0,0,1,0,25874,0,26124),
(53049,'Show yourself!','',15,0,0,0,0,0,0,0,1,0,25877,0,26124),
(53050,'What magic is this?','',6,0,0,0,0,0,0,0,1,0,25872,0,26124),
(53051,'Quick Shot!','Quick Shot!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(53052,'Setting up and maintaining the grounds is tough work...','Setting up and maintaining the grounds is tough work...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53053,'It hurts when I move my arm.','It hurts when I move my arm.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53054,'This gash just doesn\'t seem to be healing.','This gash just doesn\'t seem to be healing.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53055,'That\'s the last time I try to set up the cannon alone...','That\'s the last time I try to set up the cannon alone...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53056,'We\'ve got hammers, we\'ve got gnolls.$b$bIf you\'ve got a token, you can use the hammer to whack some gnolls.','We\'ve got hammers, we\'ve got gnolls.$b$bIf you\'ve got a token, you can use the hammer to whack some gnolls.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53057,'Ready to whack! |cFF0008E8(Darkmoon Game Token)|r','Ready to whack! |cFF0008E8(Darkmoon Game Token)|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53058,'I\'ve found a bone, look!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53059,'Looking for the old steam tonks?$b$bWell, we\'ve got some new ones for you to enjoy.$b$bNormally, it would cost two tokens to use a tonk remote.  But because of your military service, you get a discounted rate of one token.$b$bWe at the Darkmoon Faire thank you for your service.','Looking for the old steam tonks?$b$bWell, we\'ve got some new ones for you to enjoy.$b$bNormally, it would cost two tokens to use a tonk remote.  But because of your military service, you get a discounted rate of one token.$b$bWe at the Darkmoon Faire thank you for your service.',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(53060,'Ready to play! |cFF0008E8(Darkmoon Game Token)|r','Ready to play! |cFF0008E8(Darkmoon Game Token)|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53061,'D\'you think it\'s from a dragon? Or maybe a giant!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(53062,'We\'re going to bring down the Hellfire Citadel, and it all starts with these ramparts.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53063,'','Silly, that\'s no dragon bone. It\'s probably from an elekk or something.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(53064,'The Warchief has ordered an invasion of the Hellfire Citadel, and we\'re starting with these exposed ramparts.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53065,'How d\'you know?','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53066,'Whew that was close! Deathwing just blew us out of the sky!  We\'re almost there though, are you ready for the last leg of our journey to Wyrmrest Temple?','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53067,'Yes Thrall, lets do this!','Yes Thrall, lets do this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53068,'The Blood Furnace is a testament to the dark past of my people.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53069,'If ye love killing orcs and ye don\'t talk much, glad to have ye!$B$BIf not, there\'s a lovely portal east of here that I heard is just lovely this time of year.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53070,'','I hope my friends are ok...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53071,'','Maybe they already escaped? What if they\'re out there looking for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53072,'','The naga are using slave labor? They\'ll pay for their transgressions!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53073,'','We have to stop the naga and save Zangarmarsh while we still can!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53074,'','The naga are pumping all of the water away for their own use, and entire species are dying out as a result.$B$BIf we don\'t do something soon, what life is left on this dying world will disappear forever.',396,396,0,1,1,0,0,0,1,0,0,0,26124),
(53075,'I joined this expedition for one reason, $r: revenge.','',396,396,396,0,0,0,0,0,1,0,0,0,26124),
(53076,'This place is still mostly free from the naga. But...it is deeply tormented. I don\'t know how long we have.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53077,'These mushrooms are unlike anything on the surface. They\'re said to bring great wisdom and clarity to those who eat them.$B$BI\'m going to bring some back with me to Sporeggar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53078,'Being able to study and learn from the Underbog is a once in a lifetime opportunity.$B$BTo think I was practically dead not long ago sitting in a crate in the Slave Pens...','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53079,'A trio of ethereal technomancers has set up shop in Stormwind, along the canal south of Cathedral Square.\n\n\"The Three Winds,\" it\'s called. Look for the weird machinery and purple lights... you can\'t miss it.\n\nThey offer just the sort of services you\'re looking for.','A trio of ethereal technomancers has set up shop in Stormwind, along the canal south of Cathedral Square.\n\n\"The Three Winds,\" it\'s called. Look for the weird machinery and purple lights... you can\'t miss it.\n\nThey offer just the sort of services you\'re looking for.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53080,'Void Storage','Void Storage',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53081,'Nexus-Prince Haramad kept telling me that if we didn\'t find a way through Shaffar\'s ward soon that I\'d be the next test subject.$B$BHe wasn\'t bluffing.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53082,'What is an \"Ologist\", you ask? Why, it means I study everything! I\'m more knowledgable about any subject you can think of than anyone you know or anyone you\'ll ever know.$B$BGetting through Shaffar\'s ward was nothing. Morphalius wouldn\'t have a scratch on him if he had just listened to me. Always doing things his way, that one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53083,'Look at me! You said I would be fine! Do I look fine?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53084,'I can only show you the door, Morphalius. You\'re the one that has to walk through it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53085,'Spawn of the Old Gods materialize nearby!','Spawn of the Old Gods materialize nearby!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53086,'','The dead do not belong in this realm.$B$BWhy, then, do we continually seek them out after putting them to rest?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53087,'','Once, these crypts were sacred to my people. They held our loved ones\' spirits. A great many people traveled long distances here on pilgrimages.$B$BThose times are long gone. Something has taken a hold of the Auchenai that used to care so deeply for the deceased. Please, you must help before the spirits tear the crypt apart.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53088,'','We should not peer into the spirit realm...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53089,'','They do not know the doors they are opening...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53091,'The crewman is choking!','The crewman is choking!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53092,'Use your medic abilities to revive the crewman before it\'s too late!','Use your medic abilities to revive the crewman before it\'s too late!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53093,'Look, mom! A spirit! See? See?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53094,'I saw one, I know I did...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53095,'','There\'s nothing there, Ha\'lei. Please, I just need a few more minutes of silence.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53096,'The crewman is choking! Vitals are dropping!','The crewman is choking! Vitals are dropping!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53097,'A pool of moonlight appears!','A pool of moonlight appears!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53098,'A pool of moonlight appears to the west!','A pool of moonlight appears to the west!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53099,'A pool of moonlight appears to the south!','A pool of moonlight appears to the south!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53100,'A pool of moonlight appears to the north!','A pool of moonlight appears to the north!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53101,'A pool of moonlight appears to the east!','A pool of moonlight appears to the east!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53102,'The moonlight fades into darkness!','The moonlight fades into darkness!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53103,'You don\'t have the slightest idea how to operate the various mechanisms on this device, yet you are filled with a feeling of familiarity that you can\'t seem to shake off.$B$BIt\'s probably best to just leave it alone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53104,'A Tonk is taking aim at you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53105,'Mortals! I cannot follow you any further - accept my blessing and use the Hourglass of Time to defeat Murozond!','',0,0,0,0,0,0,0,0,1,0,25943,0,26124),
(53106,'','The spirits here have been tormented for a long time. We only want to rest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53107,'Every pandaren must search out and uncover their own fate. Whether a warrior or a farmer, we each have a place that suits us, and each place carries a unique importance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53108,'','The way of the Tushui is one of gaining proper perspective. Through meditation and consideration, we find our way to the most effective solution to any problem. Through practice and discipline, we hone our bodies to be the perfect implements of our will.$B$BTo live the way of the Tushui is to be respected both for tempered mind and impeccable form.',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(53109,'The only true crime is inaction.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53110,'A pool of dark moonlight appears nearby!','A pool of dark moonlight appears nearby!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53111,'It\'s good to see you again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53114,'Look Snowpuff, a $c\'s come ta save us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53115,'','Hey, $c! Help a gal out, would ya?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53116,'','We\'re too late, $n. Looks like those monkeys butchered the Foreman and his crew.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53117,'Lower your voice, $r. I am no longer welcome in Sethekk.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53118,'Not to worry, $c. With this barrier in place, the arakkoa cannot see me.$B$BI\'m here on business.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53119,'My eyes! The goggles do nothing!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(53121,'','Warlord Kalithresh will fall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53122,'There is an unnatural darkness to this place, a perpetual midnight. Take caution, heroes, and do not stray from the light.','',0,0,0,0,0,0,0,0,1,0,25955,0,26124),
(53123,'We should strike now. I\'ll tear them apart!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53124,'','That\'s suicide, Claw! It\'s too dangerous.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(53125,'No more games for you.','No more games for you.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(53126,'Whaddya want now?','Whaddya want now?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(53127,'Step aside and let some others have a chance to play.','Step aside and let some others have a chance to play.',397,0,0,0,0,0,0,0,1,0,0,0,26124),
(53128,'The wilting lotus is the first sign of winter, a winter that has not come to Shen-zin Su in thousands of years.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(53129,'Master Li Fei\'s voice echoes, \"The way of the Tushui... enlightenment through patience and meditation... the principled life.\"','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(53130,'Master Li Fei fades away.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53131,'Windcaller Claw growls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53132,'We must contain the disease the naga have unleashed here before it is too late!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53133,'They came out of nowhere!','They came out of nowhere!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53134,'You don\'t look like one of them... who are you?','You don\'t look like one of them... who are you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53135,'Get to Hanae\'s house. It\'s safe there.','Get to Hanae\'s house. It\'s safe there.',0,0,0,0,0,0,0,0,1,12709,0,0,26124),
(53136,'We can\'t just sit here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53137,'','There\'s too many of them. Kalithresh has an entire army down here.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53138,'This is all that is left of the Blue Dragonshrine. A great battle shattered the timeways leading out of this forsaken place. You must reconstruct the fragments strewn across the ground and defeat the trapped spirit to proceed.','',0,0,0,0,0,0,0,0,1,0,25957,0,26124),
(53139,'Bite\'s spell isn\'t going to last forever.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53140,'','How can I help you?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(53141,'I\'d like to travel by air.','I\'d like to travel by air.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53142,'How may I help you?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(53143,'Thank you, I\'ll go now.','Thank you, I\'ll go now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53144,'How may I help you?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(53145,'I don\'t know who you are, but you have my gratitude.','I don\'t know who you are, but you have my gratitude.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53146,'','How can I help you?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(53147,'','There is nothing left for you here, nothing but death and sorrow.',0,0,0,0,0,0,0,0,1,0,0,25977,26124),
(53148,'','The darkness surrounds you, the light of Elune is your only salvation.',0,0,0,0,0,0,0,0,1,0,0,25978,26124),
(53149,'','The moonlight can bring rest to your weary souls in this forgotten place.',0,0,0,0,0,0,0,0,1,0,0,25979,26124),
(53150,'','Give yourselves to the night, Elune will guide you from this mortal prison.',0,0,0,0,0,0,0,0,1,0,0,25980,26124),
(53151,'','You have chosen a path of darkness.  Mother moon, guide my hand; allow me to bring rest to these misbegotten souls.',0,0,0,0,0,0,0,0,1,0,0,25981,26124),
(53152,'','Moon goddess, your light dims!  I am lost without your guidance!',0,0,0,0,0,0,0,0,1,0,0,25973,26124),
(53153,'','The darkness closes in...my vision is clouded...',0,0,0,0,0,0,0,0,1,0,0,25974,26124),
(53154,'','Mother moon, I can no longer see your light! Your daughter is alone in the darkness!',0,0,0,0,0,0,0,0,1,0,0,25975,26124),
(53155,'','Let the peaceful light of Elune soothe your souls in this dark time.',0,0,0,0,0,0,0,0,1,0,0,25972,26124),
(53156,'','Elune guide you through the night.',0,0,0,0,0,0,0,0,1,0,0,25982,26124),
(53157,'','Eyes of night, pierce this darkness!',0,0,0,0,0,0,0,0,1,0,0,25983,26124),
(53158,'','Spear of Elune, drive back the night!',0,0,0,0,0,0,0,0,1,0,0,25984,26124),
(53159,'','I can...see the light of the moon...so clearly now.  It is...beautiful...',0,0,0,0,0,0,0,0,1,0,0,25976,26124),
(53160,'|TInterface\\Icons\\ability_druid_starfall.blp:20|t |cFFFF0000|Hspell:102241|h[Tears of Elune]|h|r begin to rain from the sky!','|TInterface\\Icons\\ability_druid_starfall.blp:20|t |cFFFF0000|Hspell:102241|h[Tears of Elune]|h|r begin to rain from the sky!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53161,'The Grimleer tribe owns this forest. We\'ll kill anyone who creeps on our turf.','',0,0,0,0,0,0,14,0,1,0,0,0,26124),
(53162,'Hey, over here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53163,'Don\'t sleep easy, \'cause we\'ll be back. And next time, we\'ll destroy you for good!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(53164,'If you\'re going to get to Warlord Kalithresh, you\'ll need to defeat Mekgineer Steamrigger and Hydromancer Thespia so that you can get to the Main Chambers Access Panels.$B$BYou mash a few buttons on those, and the door to the main chamber will open right up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53165,'H-h-help! My men... we\'re under attack!','',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(53166,'What? Do I see rescuers? Over here, $r! Help us!','',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(53167,'|TInterface\\Icons\\ability_druid_lunarguidance.blp:20|t Tyrande gains |cFFFF0000|Hspell:102472|h[Lunar Guidance]|h|r!','|TInterface\\Icons\\ability_druid_lunarguidance.blp:20|t Tyrande gains |cFFFF0000|Hspell:102472|h[Lunar Guidance]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53168,'Uh oh! More eggmen come. Chief, we\'d better run for now!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(53169,'Argh!! It stings!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(53170,'...Thunder Bluff, two-thousand sixty-three in arrears.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53171,'Undercity, five thousand twenty-two in arrears.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53172,'Silvermoon, over nine thousand...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53173,'Enough! The realms will carry their weight or crumble beneath mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53174,'They have two moons to pay their debts. Make it known!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53175,'The Cabal will pay for their recklessness!','',71,0,0,0,0,0,0,0,1,0,0,0,26124),
(53176,'Blackheart! Vorpil! Your time has come!','',397,0,0,0,0,0,0,0,1,0,0,0,26124),
(53177,'We will stop the Shadow Council and put an end to their atrocities!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(53178,'The Cabal have threatened the innocent for far too long! The time for retribution has come!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(53179,'I\'ve lost my Tabard of Conquest.','I\'ve lost my Tabard of Conquest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53180,'Through the purity of the fire\'s spirit are we cleansed.  Through the passion of its being are we driven.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53181,'The braziers are prepared. I am ready to face you in combat.','The braziers are prepared. I am ready to face you in combat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53182,'Speak to me when you are ready for combat, young $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53183,'The powers of the Hourglass do nothing to me!','',0,0,0,0,0,0,0,0,1,0,25929,0,26124),
(53184,'Nazgrim, lift my spirits with news of victory.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53185,'At once.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53186,'Snowpuff! Ye\'re saved! Oh thank ye, $c!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53187,'We kin make it back to camp on our own. Come talk to meh later if ya fancy borrowin\' a gryphon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53188,'','We people of the Lower City had a rather extensive spy network set up in the Shadow Labyrinth until recently.$B$BNow they\'re all dead except me and To\'gun.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53189,'','Thanks, $n! I should be able to get back on my own. Come see me later if you need any provisions for the road.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53190,'','Sandra winks at you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53191,'The leadership of Shattrath is too slow to act, so the great people of the Lower City have taken matters in the Shadow Labyrinth into our own hands.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53192,'This is where she stood, heroes, and this is where she fell. The time-lost echo of Sylvanas Windrunner will reverberate through the rotting limbs of the Dragonshrine for all eternity.','',0,0,0,0,0,0,0,0,0,0,25958,0,26124),
(53193,'Find all the Fragments of Jaina\'s Staff!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53194,'What lies before you is the aftermath of Deathwing\'s reign. What was once the Ruby Dragonshrine now lays in waste, its charred husk and scorched earth the only testament to its existence.\n$b It is said that, long ago, a single drop of Alexstrasza\'s blood melted away the snows and gave life to the great Crimson Oak that stands before you. Its branches raised triumphantly into the sky and radiated the warmth and life of the Red Dragonflight.\n$bBut now, its twisted, rotting limbs can no longer harness the power of life and vitality - instead only death and destruction. As flame and corruption extinguished the life force of these lands, the great tree captured an image...an echo of the warriors who fell on its hallowed grounds.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(53195,'Thank you. Time to lick my wounds and get back to the fight!','Thank you. Time to lick my wounds and get back to the fight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53196,'Thanks for saving me. It was rough up there.','Thanks for saving me. It was rough up there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53197,'I\'m alive? Ha! That\'s more than I can say for those Horde at Garrosh\'ar Point. We tore them up good.','I\'m alive? Ha! That\'s more than I can say for those Horde at Garrosh\'ar Point. We tore them up good.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53198,'I am pleased to report that the battle goes well, Warchief.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53199,'Zhi-Zhi can\'t believe they\'ve actually let me into the monastery training program!$b$bMe! Zhi-Zhi!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53200,'Stand back! Zhi-Zhi practicing here! Anybody who gets within 5 yards of here is probably going to get knocked out... maybe even killed.$b$bHai-yah!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53201,'Zhi-Zhi has always been good at hitting his friends, but Zhi-Zhi has gotten a lot better since studying here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53202,'Wanna fight?','Wanna fight?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53203,'About time someone challenged Zhi-Zhi!','About time someone challenged Zhi-Zhi!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53204,'Alright, enough, enough! STOP HITTING ZHI-ZHI!','Alright, enough, enough! STOP HITTING ZHI-ZHI!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53205,'We\'re one step closer my friends.  Have a rest and let me know when you are ready to continue.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53206,'Our forces report major victories off the coasts of Tanaris and Tol Barad...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53207,'Onward! We\'re almost there! Say the word and we shall continue to victory!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53208,'The pandaren elders were wise to allow the jinyu into their monastery.$b$bThey were unwise to allow the hozen the same privileges.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53209,'I like this place. Although it needs more water... I like it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53210,'I have learned much from these monks, $r. You would do well to do the same.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53211,'I challenge you to a fight, Husshun!','I challenge you to a fight, Husshun!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53212,'Very well!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53213,'I knew I would lose. The rivers told me so.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53214,'You must give peace to these lands if you are to face Murozond.','',0,0,0,0,0,0,0,0,1,0,25959,0,26124),
(53215,'I can\'t say I mind the food here. Or the beer, for that matter.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53216,'Have you tried the rice? You really need to try the rice.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53217,'Eating is a form of training, too, you know.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53218,'Put down your fork, and pick up your fists! I challenge you!','Put down your fork, and pick up your fists! I challenge you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53219,'Fine, then. It\'s time for an open-faced $R sandwich!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53220,'You win... this time. I\'d better get back to my size training.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53221,'Be gentle - I\'m still a bit bruised from the last fight I lost... er... won.','Be gentle - I\'m still a bit bruised from the last fight I lost... er... won.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53222,'It\'d be an honor to spar with you, $gsir:ma\'am;.','It\'d be an honor to spar with you, $gsir:ma\'am;.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53223,'I know what you\'re thinking. I can see it in your little $r eyes.$b$b<The pupil smiles.>$b$bWell, are we doing this, or what?','I know what you\'re thinking. I can see it in your little $r eyes.$b$b<The pupil smiles.>$b$bWell, are we doing this, or what?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53224,'I\'m ready if you are.','I\'m ready if you are.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53225,'I\'ve been sparring all day. When do we eat?','I\'ve been sparring all day. When do we eat?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53226,'You want to rumble?','You want to rumble?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53227,'Alright, let\'s get this match started!','Alright, let\'s get this match started!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53228,'Is it fighting time? I think it is!','Is it fighting time? I think it is!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53229,'Let\'s fight!','Let\'s fight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53230,'Let\'s rumble!','Let\'s rumble!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53231,'Get your paws up where I can see \'em!','Get your paws up where I can see \'em!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53232,'You\'re about to get a mouthful of claws, $c. Ha HA!','You\'re about to get a mouthful of claws, $c. Ha HA!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53233,'Go easy on the belly, alright?','Go easy on the belly, alright?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53234,'Let\'s see how you hold up against my \"slow, weak punches\" technique!','Let\'s see how you hold up against my \"slow, weak punches\" technique!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53235,'Yeah! Fightin\' time!','Yeah! Fightin\' time!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53236,'Time for a few traditional \"Welcome to the Monastery\" punches!','Time for a few traditional \"Welcome to the Monastery\" punches!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53237,'Here I come!','Here I come!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53238,'Nice moves!','Nice moves!',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(53239,'Man... I thought I had that one...','Man... I thought I had that one...',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(53240,'Good fight. I\'ll get you next time.','Good fight. I\'ll get you next time.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(53241,'Master Stone Fist was right about you. You\'re good.','Master Stone Fist was right about you. You\'re good.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(53242,'Thank you for the opportunity of getting beaten up by you.','Thank you for the opportunity of getting beaten up by you.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(53243,'You take this pretty seriously, don\'t you?','You take this pretty seriously, don\'t you?',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(53244,'Good fight.','Good fight.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53245,'I came to ask the famous Aysa Cloudsinger for help, but I just can\'t bring myself to intrude on her exercises. She\'s so poised, so practiced... so beautiful.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53246,'I don\'t think I ever stood a chance. See you around, then!','I don\'t think I ever stood a chance. See you around, then!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53247,'After intense fighting, our supply route to Booty Bay has been reestablished.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53248,'','Come, $n. Let us move swiftly.',0,0,0,0,0,0,0,0,1,0,0,27685,26124),
(53249,'We came here for war.$B$BThey gave it to us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53250,'We were here to scout for an invasion, but they already knew we were coming.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53254,'Get inside, quickly! I\'ll hold them off!','',396,0,0,0,0,0,5,0,1,0,25866,0,26124),
(53255,'And now, Shaman, you will give the Dragon Soul to ME.','',396,0,0,0,0,0,1,0,1,0,25867,0,26124),
(53257,'Time to learn your place, pandaren!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53258,'Sabotaging','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53259,'This one, over here! He\'s trying to protect the others!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53260,'Into that house! Take anyone who can still walk!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53261,'In an ancient time, the spirits of the people dimmed and the land grew cold.','In an ancient time, the spirits of the people dimmed and the land grew cold.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53262,'And then came Huo, the spirit of fire, to the land of Shen-zin Su.','And then came Huo, the spirit of fire, to the land of Shen-zin Su.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53263,'Huo warmed the land and ignited the passions of the people.','Huo warmed the land and ignited the passions of the people.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53264,'And in times since, the people have cared for Huo, knowing that they and he were intimately tied.','And in times since, the people have cared for Huo, knowing that they and he were intimately tied.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53265,'Master Shang has trained you well. Thank you, friend!','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(53266,'Alliance bloods spills. This pleases me, General.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53267,'What of [Operation Seafire (PH)]? How fares my precious cargo?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53268,'','Let\'s get to work, shall we?',0,0,0,0,0,0,0,0,1,0,0,25816,26124),
(53270,'There is news, Warchief.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53271,'Speak, goblin...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53275,'I will NOT, Archbishop. It will never be yours.','',396,0,0,0,0,0,0,0,1,0,25893,0,26124),
(53276,'Y-yes sir... right away, sir.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53277,'Things all started out pretty well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53278,'There is no good. No evil. No Light. There is only POWER!','',396,0,0,0,0,0,0,0,1,0,21411,0,26124),
(53279,'You were a figurehead of the Light, Benedictus. How could you betray your own people?','',396,0,0,0,0,0,0,0,1,0,25894,0,26124),
(53280,'','Enough! As much as I adore playing hostess, I have more pressing matters to attend to.',0,0,0,0,0,0,5,0,0,0,0,26017,26124),
(53281,'','Riders, to me!',0,0,0,0,0,0,25,0,0,0,0,26018,26124),
(53282,'We made it past enemy lines - looked like it was gunna be smooth sailin\' all the way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53283,'I suppose it has to be this way, then. If only you\'d seen what I\'ve seen. THEN you\'d understand.','',396,0,0,0,0,0,0,0,1,0,21410,0,26124),
(53284,'Then it happened... all at once! A whole mess of fighters came outta nowhere, sir...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53285,'I pray that the Light of a Thousand Moons will grant me this honor.','I pray that the Light of a Thousand Moons will grant me this honor.',0,0,0,0,0,0,2,0,0,0,26042,26042,26124),
(53286,'Yes, Light of Lights! My life is yours!','Yes, Light of Lights! My life is yours!',0,0,0,0,0,0,16,0,0,0,26513,26513,26124),
(53287,'The Flower of Life calls upon me. I WILL NOT fail you, my Queen.','The Flower of Life calls upon me. I WILL NOT fail you, my Queen.',0,0,0,0,0,0,66,0,0,0,26047,26047,26124),
(53288,'Hey... HEY! What are you doing?','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(53289,'You\'re stealing my inventory, aren\'t you?','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(53290,'Alexstrasza\'s Drakes will pick us up on the other side of this abandoned excavation site. Check your weapons, this place stinks of an ambush.\n\nLet me know when you\'re ready to move out.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53294,'','I am unimpressed.',0,0,0,0,0,0,274,0,0,0,0,26021,26124),
(53295,'Don\'t make me stand up!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(53296,'I\'ll do it, I swear! I\'m about to stand up!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(53297,'Here I go!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(53298,'Oh, who am I kidding? You are a wily one, thief.','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(53299,'','I beseech of you, my beloved subjects: Put an end to these miscreants.',0,0,0,0,0,0,5,0,0,0,0,26029,26124),
(53300,'','I have no time for such diversions. Keepers of Eternity, will you stand for your queen?',0,0,0,0,0,0,274,0,0,0,0,26027,26124),
(53301,'','Still these strangers would oppose your queen\'s will. Who will stop them?',0,0,0,0,0,0,1,0,0,0,0,26028,26124),
(53302,'','Your conduct was inexcusable.',0,0,0,0,0,0,24,0,0,0,0,26022,26124),
(53303,'','Unfortunate, but deserved.',0,0,0,0,0,0,11,0,0,0,0,26023,26124),
(53304,'','To prepare for a world of perfection, the imperfect must be swept away.',0,0,0,0,0,0,11,0,0,0,0,26020,26124),
(53305,'','Bold of you, to strike a queen. A lesser monarch might be enraged.',0,0,0,0,0,0,5,0,0,0,0,26014,26124),
(53306,'','Dance for the Eternal Court.',0,0,0,0,0,0,273,0,0,0,0,26024,26124),
(53307,'Before we knew it they was everywhere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53308,'We stuck with the cargo \'til the end, which came, well, right after the start...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53309,'I floated for days \'til one of our ships spotted me...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53311,'What do I need to play?','What do I need to play?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53312,'You need Darkmoon Game Tokens to play.$b$bBuy them from any of the faire\'s Game Token vendors.$b$bI\'ll mark one on your map for you.','You need Darkmoon Game Tokens to play.$b$bBuy them from any of the faire\'s Game Token vendors.$b$bI\'ll mark one on your map for you.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(53313,'There are no freebies here, move on.','There are no freebies here, move on.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(53314,'You gotta pay to play.','You gotta pay to play.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(53315,'Sorry pal, can\'t let you play for free.','Sorry pal, can\'t let you play for free.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(53316,'Shot down by a group of alliance cowards?! PATHETIC!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53317,'How do I play the Ring Toss?','How do I play the Ring Toss?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53318,'I understand.','I understand.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53319,'First, you give me a game token.  Next, I give you a mallet.  Then you\'ll see gnolls pop from the barrels in the play area.$B$BHit the gnolls with your mallet to score points.$b$BHere\'s where it gets tricky.  There are three different targets: regular gnolls, Hogger gnolls, and BABIES.$b$bRegular gnolls grant one point, while Hoggers count for three.  But babies?  Hitting a baby will knock you down and stun you... SO DON\'T HIT THE BABIES!$b$bIf you don\'t whack enough gnolls in one go, just spend another token!  The points you\'ve earned will carry over into your next game.','First, you give me a game token.  Next, I give you a mallet.  Then you\'ll see gnolls pop from the barrels in the play area.$B$BHit the gnolls with your mallet to score points.$b$BHere\'s where it gets tricky.  There are three different targets: regular gnolls, Hogger gnolls, and BABIES.$b$bRegular gnolls grant one point, while Hoggers count for three.  But babies?  Hitting a baby will knock you down and stun you... SO DON\'T HIT THE BABIES!$b$bIf you don\'t whack enough gnolls in one go, just spend another token!  The points you\'ve earned will carry over into your next game.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53320,'How do I play Whack-a-Gnoll?','How do I play Whack-a-Gnoll?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53321,'How do I play the Tonk Challenge?','How do I play the Tonk Challenge?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53322,'The mogu empire was overthrown centuries ago. These ruins have been here - and abandoned - for as long as anyone can remember. $B$BWhy would they come back now?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53323,'First, you give me one game token.  Then you find yourself in control of a steam tonk!$b$bYou have a limited amount of time to blast targets in the battlefield.  Each target you destroy earns you one point.$b$bBut watch out: The battlefield is also home to enemy tonks and zeppelins.  Getting hit by one of their shots damages your tonk.$b$bYour score will carry over from one tonk to the next, so don\'t worry if you explode.','First, you give me one game token.  Then you find yourself in control of a steam tonk!$b$bYou have a limited amount of time to blast targets in the battlefield.  Each target you destroy earns you one point.$b$bBut watch out: The battlefield is also home to enemy tonks and zeppelins.  Getting hit by one of their shots damages your tonk.$b$bYour score will carry over from one tonk to the next, so don\'t worry if you explode.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53324,'They\'ve killed the Greench!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(53325,'Run!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(53326,'Where... is... my... SHIP!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53327,'S-sailing into a fog bank, last I saw, Alliance in chase... n-no tellin\' what became of \'em, sir...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53328,'First, I give you a pellet rifle in exchange for one Darkmoon Game Token.$B$BThen you shoot the targets that light up.$b$bIf you\'re fast enough to hit a target just after it\'s lit up, you get an extra point.$b$bIf you don\'t reach the score limit before your time\'s up, or you move away from the booth, don\'t worry: Your score carries over to the next game.','First, I give you a pellet rifle in exchange for one Darkmoon Game Token.$B$BThen you shoot the targets that light up.$b$bIf you\'re fast enough to hit a target just after it\'s lit up, you get an extra point.$b$bIf you don\'t reach the score limit before your time\'s up, or you move away from the booth, don\'t worry: Your score carries over to the next game.',1,5,0,3,0,0,0,0,1,0,0,0,26124),
(53329,'How does the Shooting Gallery work?','How does the Shooting Gallery work?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53330,'With all respect, Warchief, what\'s done is done. We must now focus our efforts on how to proceed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53331,'I\'ll TELL you how we\'ll proceed, general.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53332,'You\'re going to round up your best men and FIND MY SHIP!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53333,'It is done, but we should not linger here. Meet me back on the eastern edge of the camp.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53334,'Keep your wits about you. There are demons nearby.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53335,'Well done, heroes! Let us all hope that this is the last the world will ever see of Kael\'thas Sunstrider.','',71,0,0,0,0,0,0,0,1,0,0,0,26124),
(53336,'Now, friends. Attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53337,'Subjugate THIS!','Subjugate THIS!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53338,'Another volunteer for the Thunder King\'s labor force!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53339,'We do not fear you!','We do not fear you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53340,'Your goons smashed my keg of Stormstout Special Reserve... I was saving that!!','Your goons smashed my keg of Stormstout Special Reserve... I was saving that!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53341,'Over here, ugly!','Over here, ugly!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53342,'Let us start with the three who sit behind me.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53343,'Before you sits Instructor Myang. She will be responsible for teaching you the most practical fighting techniques.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53344,'It is said that, before she joined our monastery, Myang defeated one hundred ravaging hozen in a single melee.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53345,'','You flatter me, High Elder. Those hozen were weak, young, and unskilled. Any other pandaren would have done the same.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(53346,'Flatter you? You were eight years old.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(53347,'','...and a half. Sir.',0,0,0,0,0,0,24,0,1,0,0,0,26124),
(53348,'Next, we have Master Stone Fist. He will be leading your sparring exercises.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53349,'Master Stone Fist is nearly unmatched in single combat. He once defeated nine hundred and ninety-nine challengers in a row.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53350,'The thousandth challenger cheated.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53351,'What? Cheated!?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(53352,'I never cheat!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(53353,'Finally, Instructor Xann. His mastery of the very basics of combat has given him a nearly perfect fighting form.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53354,'Xann, how many practice strikes do your students perform daily?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(53355,'Ten thousand strikes, every day.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53356,'And how many do YOU perform?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(53357,'Ten thousand and one.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(53358,'Luckily, High Elders no longer have to perform basic training. I find that I am happier when I am not exercising.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53359,'Walk and drink with me, $n.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53360,'Ah! Upon this table, you see Spirit-Sage Gaoquan, the oldest member of our monastery.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53361,'He has seen many high elders come and go. He also tends to take these celebrations very seriously.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53362,'You may have noticed the hozen and jinyu among us. All are welcome here at the monastery, as long as they have the desire to learn.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53363,'Finally, this is Groundskeeper Wu.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53364,'WU!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(53365,'Ye... yes, high <hic> elder?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53366,'Wu, this is $n. $GHe:She; will be joining the other trainees.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53367,'Oh...<hic>... hello... $nsszzhhhh...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53368,'Wu will be asking you to perform a few chores. Nothing complex, just some tasks relating to the maintenance of our monastery.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53369,'We are all responsible for maintaining our home. Even the High Elder must occasionally lend a hand.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53370,'Now you are caught up. And would you look at that? My cup is full again! It is good to be the High Elder.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53371,'Welcome, $n. We are honored to have you as our guest. Today, we celebrate not only your arrival, but the initiation of a new class of trainees within our monastery.$b$bPlease, enjoy the food and drink that we have prepared. When you are ready, I would like to introduce you to some of the monastery\'s instructors.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53372,'Very well, $n. Return to me when your thirst and hunger are sated.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(53373,'Are you certain? The trainers would love to meet an experienced $r $c like you.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(53374,'As you wish. A toast, to our honored guest, $n!','',2,71,0,0,0,0,0,0,1,0,0,0,26124),
(53375,'I\'m ready to be introduced to the instructors, High Elder.','I\'m ready to be introduced to the instructors, High Elder.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53376,'Hold on a moment, I\'m not ready yet.','Hold on a moment, I\'m not ready yet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53377,'I don\'t need any introductions, old man. Let\'s skip ahead to the good part.','I don\'t need any introductions, old man. Let\'s skip ahead to the good part.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53378,'Fine. Let\'s proceed with the introductions.','Fine. Let\'s proceed with the introductions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53379,'I am certain. Let\'s move on to the fighting.','I am certain. Let\'s move on to the fighting.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53380,'Submit or die, you fool!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53381,'Don\'t just attack him one at a time, you idiots! Surround him now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53385,'%s smiles.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53386,'You\'re obviously no farmer...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53387,'Another mug of ale for $n!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(53388,'Welcome to the Great Banquet. High Elder Cloudfall awaits you at the back table.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(53390,'Free at last! I need a drink...','Free at last! I need a drink...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53391,'','Just a moment, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53392,'','%s mixes the cider and a handful of crushed herbs into a flask, then shakes the concoction vigorously.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53393,'','That should do it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53394,'Mogu ambushers descend from the trees. Look out!','Mogu ambushers descend from the trees. Look out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53395,'Look at what we have here! Another straggler from the orchard...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53396,'If you are interested in training with us, speak with me again at the banquet tables, later this evening.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53397,'Ban should have arrived by now... Look for him at the edge of the camp.','Ban should have arrived by now... Look for him at the edge of the camp.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53398,'Hello and welcome to the Darkmoon Faire Staging Area.$b$bThe portal here will take you to the Darkmoon Faire.$b$bBut if you have any questions before you go, I can answer them.','Hello and welcome to the Darkmoon Faire Staging Area.$b$bThe portal here will take you to the Darkmoon Faire.$b$bBut if you have any questions before you go, I can answer them.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53399,'The Darkmoon Faire is filled with all sorts of amazing attractions.  We have a fortune teller, a concert, a fishing contest and a lot of games.$b$bWe are constantly expanding the faire with all manner of new attractions!$b$bAre there any attractions you\'d like more information on?','The Darkmoon Faire is filled with all sorts of amazing attractions.  We have a fortune teller, a concert, a fishing contest and a lot of games.$b$bWe are constantly expanding the faire with all manner of new attractions!$b$bAre there any attractions you\'d like more information on?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53400,'Are there tonks?','Are there tonks?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(53401,'Miniature tanks, or Tonks as we\'ve cleverly named them, have been a faire favorite for as long as I can remember.$b$bWe have two arenas dedicated for tonk battles.$b$bOne arena pits you against the clock as you race to destroy targets, and avoid the enemy tonks.  You just need a game token to play!$b$bThe other arena is a place where you can use your own tonks or MiniZeps to battle your friends.','Miniature tanks, or Tonks as we\'ve cleverly named them, have been a faire favorite for as long as I can remember.$b$bWe have two arenas dedicated for tonk battles.$b$bOne arena pits you against the clock as you race to destroy targets, and avoid the enemy tonks.  You just need a game token to play!$b$bThe other arena is a place where you can use your own tonks or MiniZeps to battle your friends.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53402,'The Blastenheimer 5000 Ultra Cannon is a state-of-the-art single person projectile device.$b$bDelivering its payload at near the speed of a dragon, the cannon is the pride and joy of the Blastenheimer family, world renowned for their aeronautical and combustible feats!$B$BIf you\'d like to be launched through the skies to fly free as a bird, seek out Maxima Blastenheimer.','The Blastenheimer 5000 Ultra Cannon is a state-of-the-art single person projectile device.$b$bDelivering its payload at near the speed of a dragon, the cannon is the pride and joy of the Blastenheimer family, world renowned for their aeronautical and combustible feats!$B$BIf you\'d like to be launched through the skies to fly free as a bird, seek out Maxima Blastenheimer.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53403,'Whack-a-Gnoll?','Whack-a-Gnoll?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53404,'Whack-a-Gnoll is a fun-filled game of whacking... gnolls.$b$bIt\'s a new attraction, and quite popular among us... Well, Sayge isn\'t too fond of it.','Whack-a-Gnoll is a fun-filled game of whacking... gnolls.$b$bIt\'s a new attraction, and quite popular among us... Well, Sayge isn\'t too fond of it.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(53405,'There! Go! GO!!!','',0,0,0,0,0,0,0,0,1,0,26038,0,26124),
(53406,'The portal is closing! Hurry!','',0,0,0,0,0,0,0,0,1,0,26037,0,26124),
(53407,'Officer: Looks like we\'ve made it through enemy lines, General.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53408,'Officer: Still no sign of the missing transport.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53409,'Nazgrim: We\'re not returning until we discover its fate - even if we have to scour the sea floor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53410,'Nazgrim: ...and you know how I feel about that idea...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53411,'Goblin: Land ho!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53412,'Nazgrim: Land? Here? Impossible!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53413,'$n, you have no idea how glad I am to see you. Supervising is hungry work.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53414,'We like to make sure that faire goers of all ages can enjoy the games.$b$bRing Toss is a simple game where you try to land a ring on the back of a moving turtle.$b$bIt\'s one of my favorite games to play.','We like to make sure that faire goers of all ages can enjoy the games.$b$bRing Toss is a simple game where you try to land a ring on the back of a moving turtle.$b$bIt\'s one of my favorite games to play.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(53415,'Ring Toss?','Ring Toss?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53416,'Rinling runs the shooting gallery.$b$bThere are only three targets to hit, and the faster you are, the better you do.$b$bPersonally, it\'s one of my favorite games.','Rinling runs the shooting gallery.$b$bThere are only three targets to hit, and the faster you are, the better you do.$b$bPersonally, it\'s one of my favorite games.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(53417,'Shooting Gallery?','Shooting Gallery?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53418,'I highly recommend that you visit Sayge to get your fortune told.$b$bI know, I know... he\'s a gnoll.  But he\'s a very special gnoll with the power to divine your future!','I highly recommend that you visit Sayge to get your fortune told.$b$bI know, I know... he\'s a gnoll.  But he\'s a very special gnoll with the power to divine your future!',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(53419,'Fortune teller?','Fortune teller?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53420,'','Did my son send you? There\'s plenty of stew to go around. Please, help yourself.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53421,'Hello $c, and welcome to the Darkmoon Faire.$b$bThere is so much to do here at the faire that it can be a little overwhelming for our first time visitors. That\'s why I\'m here to help.$b$bDo you have any questions?','Hello $c, and welcome to the Darkmoon Faire.$b$bThere is so much to do here at the faire that it can be a little overwhelming for our first time visitors. That\'s why I\'m here to help.$b$bDo you have any questions?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53422,'They came from nowhere! There was nothing we could do...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53423,'Such fragile creatures. Worthless!','',0,0,0,0,0,0,0,0,1,0,26039,0,26124),
(53424,'','I wouldn\'t expect a recruit to perform well in this situation, but try your best.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53425,'','We can save this one, but we must be quick.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53426,'','If the crewman is choking, we can deliver Air to temporarily stabilize their falling vitals.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53427,'','Compress the patient\'s chest to steadily improve their vitals.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53428,'','Electric Shock can be used to increase the patient\'s vitals a great deal. However, we cannot use this frequently.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53429,'','You actually saved one! I must admit, I had some doubts.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53430,'','Oh no, we\'ve lost a patient. Do not despair, $n. They were too far gone already.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53431,'','We cannot save them all, $n. Let us move on to someone who may yet respond to our treatment.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53432,'','$n! CAN YOU HEAR ME? Just checking to see if you\'re paying attention.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53433,'','I never had any talent with healing powers, but I found my calling in the medic\'s craft. Potions, bandages, and other triage methods can go a long way!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53434,'','I do hope that the other agents made it. Otherwise, I\'ll have more work to do.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53435,'','It is good of us to help the survivors here, but we must not lose sight of our original mission.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53436,'','Let us hope that the Horde have not yet found this place. They will wish to seize it for their own.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53437,'','It is a shame we lost our own planes during our arrival. It will make our extraction mission a bit more...challenging.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53438,'Never stop fighting. Never stop practicing. You are never perfect.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53439,'Never forget those that came before you. Never forget where you came from.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53440,'Never put yourself ahead of others. Never forget that this land is shared by many.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53441,'Never forget those that you love. Never forget what you\'re fighting for.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53442,'Kargath Bladefist has fallen! For the Horde!','',71,0,0,0,0,0,0,0,1,0,0,0,26124),
(53443,'Caza\'rez was not as lucky as I was, $n. He rests with the spirits now.','',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(53444,'Ugh... My head still swims, friend. Come, show me the wreckage.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53445,'My men. All dead? No...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53446,'I\'m afraid Gunny didn\'t make it, $n.','',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(53447,'Kargath Bladefist has been slain! Long live the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53448,'Hey, hey $c! Think you can land a ring on a slow moving turtle?','Hey, hey $c! Think you can land a ring on a slow moving turtle?',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53449,'You look like you\'ve got quite the arm there. Care to give this game a try?','You look like you\'ve got quite the arm there. Care to give this game a try?',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53450,'Simple game, for simple folk. Think you can manage it?','Simple game, for simple folk. Think you can manage it?',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53451,'Toss a ring, win a prize!','Toss a ring, win a prize!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53452,'Test your aim! Test your aim!','Test your aim! Test your aim!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53453,'Come play a game so simple that even a $c can do it!','Come play a game so simple that even a $c can do it!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53454,'Shoot for loot! Who wants to shoot for some loot?','Shoot for loot! Who wants to shoot for some loot?',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53455,'Guns, guns, guns! C\'mon, pal!','Guns, guns, guns! C\'mon, pal!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53456,'Step right up and take your best shot!','Step right up and take your best shot!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53457,'Folks, I\'m handing out epics over here! Don\'t miss out!','Folks, I\'m handing out epics over here! Don\'t miss out!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53458,'Test your skill, win a prize!','Test your skill, win a prize!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53459,'If you can shoot, you can score some sweet prizes!','If you can shoot, you can score some sweet prizes!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53460,'Find any survivors, $n. We\'re sure to need them...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53461,'Tonks! We got tonks here!','Tonks! We got tonks here!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53462,'Step right up and try a tonk!','Step right up and try a tonk!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53463,'We\'re under attack! Step up and do your part, $c!','We\'re under attack! Step up and do your part, $c!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53464,'Hey, hey! Command a tonk in glorious battle!','Hey, hey! Command a tonk in glorious battle!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53465,'Transportation to the other end of the faire!','Transportation to the other end of the faire!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53466,'Cannon blast!  Who wants to get shot out of a cannon?','Cannon blast!  Who wants to get shot out of a cannon?',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53467,'Step up to get blown up!','Step up to get blown up!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53468,'Don\'t worry about your weight, this cannon can handle any payload!','Don\'t worry about your weight, this cannon can handle any payload!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53469,'Hammer time!','Hammer time!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53470,'Whack some gnolls! Step right up and whack some gnolls!','Whack some gnolls! Step right up and whack some gnolls!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53471,'Hammer swingin\' fun! Who wants to swing a hammer?','Hammer swingin\' fun! Who wants to swing a hammer?',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53472,'Swing a hammer, win a prize!','Swing a hammer, win a prize!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53473,'','I... I barely made it off the ship before it went down!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53474,'Snap out of it! You\'re alive! Nazgrim has ordered us to report to the nearby village.','Snap out of it! You\'re alive! Nazgrim has ordered us to report to the nearby village.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(53475,'','Thank you. I\'ll make my way to the village. Stay safe...',0,0,0,0,0,0,113,0,1,0,0,0,26124),
(53476,'','Now entering the arena: $n!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(53477,'','And now... let the Rumpus start!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(53478,'','Halfway there, $n. Keep it up!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(53479,'','You\'re nearly done, $n!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(53480,'','Congratulations to $n, victor of the Rumpus!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(53481,'Gregarious Grell Pet','Gregarious Grell Pet',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53482,'Ogre Mage Costume','Ogre Mage Costume',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53483,'Corrupted Hippogryph','Corrupted Hippogryph',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53484,'Get me outta here, $n! This lady is going to kill me!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53485,'Quit messing around and use your knife! Nazgrim wants you to report to the village immediately.','Quit messing around and use your knife! Nazgrim wants you to report to the village immediately.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(53487,'Oh alright! Don\'t get your trousers in a bunch!','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(53488,'','Better luck next time, $n. Try using some abilities that hit more than one enemy at a time!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(53489,'The King\'s royal banner. Someone of royal blood certainly slept in this chamber.','The King\'s royal banner. Someone of royal blood certainly slept in this chamber.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53490,'This soldier is not like the others. He looks like a personal bodyguard.','This soldier is not like the others. He looks like a personal bodyguard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53491,'Monogrammed on the leather cover are the initials, \"A.L.W.\" \n\nYou take the few intact pages that remain.','Monogrammed on the leather cover are the initials, \"A.L.W.\" \n\nYou take the few intact pages that remain.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53492,'Sand Scarab Pet','Sand Scarab Pet',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53493,'I shouldn\'t be alive, $r.$b$bI should have died with the rest of my brothers.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53494,'We need to regroup, Sergeant! Go to the nearby village.','We need to regroup, Sergeant! Go to the nearby village.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(53495,'Spurious Sarcophagus','Spurious Sarcophagus',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53496,'White Riding Camel','White Riding Camel',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53497,'Crown of Heaven','Crown of Heaven',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53498,'Tomb of the Forgotten','Tomb of the Forgotten',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53499,'Yes, $c, no time for mourning. Let us avenge our fallen brethren and claim this land for the Horde!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53500,'You find a stack of partially soaked pages, written in the Prince\'s hand. You\'d better take them back to Nodd.','You find a stack of partially soaked pages, written in the Prince\'s hand. You\'d better take them back to Nodd.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53501,'This set up sure is hard work.','This set up sure is hard work.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53503,'','What happened?$b$bWh-where are we?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53504,'On your feet! Nazgrim is organizing a counter-attack. We\'re regrouping in the village.','On your feet! Nazgrim is organizing a counter-attack. We\'re regrouping in the village.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(53505,'','Regrouping... In the village... I think I can make it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53506,'The map shows a naval strategy for defeating the Horde fleet.','The map shows a naval strategy for defeating the Horde fleet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53507,'The cannon is dented and streaked with gunpowder.','The cannon is dented and streaked with gunpowder.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53508,'Looks like the deck swabbing assignments from the day of the battle.','Looks like the deck swabbing assignments from the day of the battle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53509,'','The General is determined to set up camp here.$b$bI hope he knows what he\'s doing...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53510,'This Horde sailor likely met his end during the battle.','This Horde sailor likely met his end during the battle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53511,'LEFT!','',0,0,0,0,0,0,0,0,1,12811,0,0,26124),
(53512,'RIGHT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53513,'You will burn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53514,'Die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53515,'Your end has come!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53516,'Unstable solenoids are unstable! RUN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53522,'Thank you, stranger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53523,'May the sacred pools bless you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53524,'The elders will hear of your kindness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53525,'I am in your debt, stranger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53526,'I...I\'m free? Thank you, $gbrother:sister;.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53527,'See? I\'m helping by picking up this full mug of ale that someone left on the ground.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53529,'%s mumbles incoherently to himself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53531,'%s rests his head in his hands and weeps.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53532,'%s rocks back and forth gently.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53533,'I heard everything, $n. Go ahead to the camp and I\'ll meet you there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53534,'Blood for the Thunder King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53535,'The lesser races will learn to once again fear the mogu!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53536,'YEEAARRGHH!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53537,'GRAAAAHHH!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53541,'Why would they do something like this?','Why would they do something like this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53542,'Are the others okay?','Are the others okay?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53543,'You don\'t have to tell me twice!','You don\'t have to tell me twice!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53544,'They\'re dragging people away!','They\'re dragging people away!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53546,'I thought I was done for!','I thought I was done for!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53547,'Give \'em hell for me!','Give \'em hell for me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53548,'Please tell me Hanae is safe!','Please tell me Hanae is safe!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53549,'Are you Shao\'s friend? Is he still alive?','Are you Shao\'s friend? Is he still alive?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53553,'Beware. Enemies approach!','',0,0,0,0,0,0,0,0,1,0,25883,0,26124),
(53554,'Thank you so much!','Thank you so much!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53555,'I hope the orchard is still intact...','I hope the orchard is still intact...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53556,'Free at last! I need a drink...','Free at last! I need a drink...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53557,'I never thought something like this could happen to our little orchard.','I never thought something like this could happen to our little orchard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53558,'Ah, much better. Those bindings were so tight.','Ah, much better. Those bindings were so tight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53559,'I\'m moving back to the capital after this.','I\'m moving back to the capital after this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53560,'I\'ll be fine, please help the others!','I\'ll be fine, please help the others!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53561,'Thank you, I don\'t even want to know what they were planning to do with us.','Thank you, I don\'t even want to know what they were planning to do with us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53563,'For Pandaria!','For Pandaria!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53564,'You\'ve underestimated us!','You\'ve underestimated us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53565,'You won\'t make slaves out of us!','You won\'t make slaves out of us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53566,'We\'ll never yield to the mogu!','We\'ll never yield to the mogu!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53569,'Fair and honest combat is the only true test of one\'s strength. Any other test is tainted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53570,'Age has caught up with me it seems.  I cannot move as I once could, and so I\'ve little left to offer my once friend...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53571,'If you are strong, then I give you respect.$b$bIf you are weak, then I give you encouragement.$b$bIf you are my enemy, then I give you my fist. Several times over, if necessary.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53572,'Achieve clarity through combat. Enlightenment through engagement. Peace through punching.$b$bSuch is the Tian way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53573,'Discipline is the key to perfection. Defeat your sloth! Master your laziness!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53574,'My father was High Elder before Cloudfall. He taught me everything that I know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53575,'There is nothing that cannot be mastered through repetition.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53576,'I am ready to practice again, Instructor.','I am ready to practice again, Instructor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53577,'It\'s a good thing you came along - I could not resolve this alone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53578,'Three cheers for $n! Three cheers, and three beers!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(53579,'','Enter the Rumpus Pit, then set off the firework. Be prepared to fight several enemies at once! Anything can happen in the Rumpus.',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(53581,'Join the students in the block formation below. Then follow the leader, as they do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53582,'I will yell out commands for \"Left\" and \"Right\". Pay close attention, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53584,'MALORNE MALORNE MALORNE','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53591,'This faire is great!','This faire is great!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53592,'We are supposed to play here, but I bet we could wander around and not get in too much trouble.','We are supposed to play here, but I bet we could wander around and not get in too much trouble.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53593,'I wonder how often the sandbox gets cleaned.','I wonder how often the sandbox gets cleaned.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53594,'This sandbox is pretty boring.','This sandbox is pretty boring.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53595,'The sandbox is crowded...','The sandbox is crowded...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53596,'Only babies play in the sandbox.','Only babies play in the sandbox.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53597,'I wonder what those bones are from.','I wonder what those bones are from.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53598,'We should go explore the rest of the faire!','We should go explore the rest of the faire!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53599,'Whoa!','Whoa!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53600,'Look at all the explosions!','Look at all the explosions!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53601,'I had a tonk, but my sister broke it...','I had a tonk, but my sister broke it...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53602,'BOOM!','BOOM!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53603,'KABOOM!','KABOOM!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53604,'Those tonks are dangerous!','Those tonks are dangerous!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53605,'We should run around and stomp on all the houses!','We should run around and stomp on all the houses!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53606,'I could beat all those tonks.','I could beat all those tonks.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53607,'That cannon is huge!','That cannon is huge!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53608,'I bet I could land exactly in the target.','I bet I could land exactly in the target.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53609,'After all the punching, and the kicking, and the eating, and the drinking... someone\'s got to clean up.$b$bThat\'s where the groundskeeper comes in.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53610,'Why don\'t people get shot out of cannons all the time?','Why don\'t people get shot out of cannons all the time?',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53611,'You can keep your stick-fighting and your mist-weaving to yourselves. I\'m perfectly happy standing here and watching.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53612,'What are the cannon balls for?  Do they let you carry one?','What are the cannon balls for?  Do they let you carry one?',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53613,'Whoosh!  Flying must be fun!','Whoosh!  Flying must be fun!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53614,'They should aim the cannon straight up.','They should aim the cannon straight up.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53615,'Do you know what happens if you slack off in all of your monastery classes? You become a groundskeeper, that\'s what happens.$b$bIt\'s not all bad though. I get my own broom.$b$b<Wu sighs.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53616,'What if a bird flew into you while you were flying?','What if a bird flew into you while you were flying?',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53617,'I wonder if we could all get launched out together...','I wonder if we could all get launched out together...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53618,'Juggling fire has got to be scary!','Juggling fire has got to be scary!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53619,'I wonder if they ever burn themselves.','I wonder if they ever burn themselves.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53620,'Mmm... stew...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53621,'MINE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53622,'Gimme gimme gimme...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53623,'I heard that if you can breathe fire, then you are part dragon!','I heard that if you can breathe fire, then you are part dragon!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53624,'I want to eat it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53625,'Smell good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53626,'Stew, stew, stew, stew...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53627,'Want to eat the stew! Want to eat the stew!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53628,'Fire juggling looks pretty hard.','Fire juggling looks pretty hard.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53629,'What I smell?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53630,'Fire is scary, but fire flying through the air is even scarier.','Fire is scary, but fire flying through the air is even scarier.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53631,'They are amazing!','They are amazing!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53632,'When I grow up I want to be a fire juggler!','When I grow up I want to be a fire juggler!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53633,'I think I could juggle fire if I tried.','I think I could juggle fire if I tried.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53635,'','Until recently, the mogu in this region have been content to ambush travelers in the woods. This raid was different; they are organized... filled with purpose.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53636,'','You\'re the first person to come through that door who isn\'t in shock, injured, or both.$B$BI\'m hoping that means you can help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53637,'Go! Get to safety!','Go! Get to safety!',0,0,0,0,0,0,0,0,1,12709,0,0,26124),
(53638,'Leave that behind, it\'s not worth it!','Leave that behind, it\'s not worth it!',0,0,0,0,0,0,0,0,1,12709,0,0,26124),
(53644,'','It\'s a monastery, of course!$b$bThe monks here at Tian Monastery specialize in teaching young pandaren - like me - how to fight. All the great fighters started here: Yu Ming the Blade, Liang the Unbreakable... even the great emperor Shaohao studied at this very temple.$b$bOr so the legends say.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53645,'','Welcome to our home in the hills, $r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53646,'','Hello! And welcome!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53647,'What is this place?','What is this place?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53652,'What the-?! Why did you-?! I have TOYS to make!','What the-?! Why did you-?! I have TOYS to make!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53653,'It\'s not Winter Veil yet, you know. I have WORK to do!','It\'s not Winter Veil yet, you know. I have WORK to do!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53654,'We\'ll need twenty thousand more cog wheels, and another... hey! You can\'t just summon me away like that!','We\'ll need twenty thousand more cog wheels, and another... hey! You can\'t just summon me away like that!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53655,'So, did you hear about Helper 432-A? I heard that... what the-? HEY! We Helpers have WORK to do, you know!','So, did you hear about Helper 432-A? I heard that... what the-? HEY! We Helpers have WORK to do, you know!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53656,'Does it LOOK like the Feast of Winter Veil to you? Colored lights, decorations? No? Well, you know who has to MAKE all of that stuff, right?!','Does it LOOK like the Feast of Winter Veil to you? Colored lights, decorations? No? Well, you know who has to MAKE all of that stuff, right?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53657,'Look, $c. Here\'s the thing. Toys and lights and bundles of holiday herbs don\'t make THEMSELVES, you know. So ENOUGH with the Helper summoning, PLEASE.','Look, $c. Here\'s the thing. Toys and lights and bundles of holiday herbs don\'t make THEMSELVES, you know. So ENOUGH with the Helper summoning, PLEASE.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53658,'What the-? AGAIN?! Look, $c. As much as I\'d like to watch you punch monsters or mouthbreathe at the auction house or WHATEVER it is you do all year, I\'ve got WORK to do.','What the-? AGAIN?! Look, $c. As much as I\'d like to watch you punch monsters or mouthbreathe at the auction house or WHATEVER it is you do all year, I\'ve got WORK to do.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53659,'Whoah! Where\'s the workshop?! Summon me up a little later in the year, all right?','Whoah! Where\'s the workshop?! Summon me up a little later in the year, all right?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53660,'Step right up and get your game tokens!','Step right up and get your game tokens!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53661,'Tokens! Tokens! Tokens!','Tokens! Tokens! Tokens!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53662,'Tokens! Get your tokens!','Tokens! Get your tokens!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53663,'You gotta pay to play, folks! Come and get your game tokens!','You gotta pay to play, folks! Come and get your game tokens!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53664,'Game tokens for sale! Come get your game tokens!','Game tokens for sale! Come get your game tokens!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53665,'You\'ll need game tokens to play the games. Come and get your game tokens!','You\'ll need game tokens to play the games. Come and get your game tokens!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53666,'Hurry, hurry, hurry! Step right up and purchase your game tokens!','Hurry, hurry, hurry! Step right up and purchase your game tokens!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53667,'Hey, hey, I ain\'t jokin\', step on up and buy a game token!','Hey, hey, I ain\'t jokin\', step on up and buy a game token!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(53675,'It\'s safe now.  You can come down.','It\'s safe now.  You can come down.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53677,'Eep!  Save me from the monsters!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53679,'The Tauren Chieftains concert will begin in thirty minutes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53680,'The Tauren Chieftains concert will begin in fifteen minutes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53681,'The Tauren Chieftains concert will begin in five minutes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53682,'Fairegoers, are you ready to rock?! The Tauren Chieftain concert now begins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53683,'That Jade Witch is super spooky.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53684,'','Eep! It\'s the Jade Witch! I need to hide!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53685,'I heard this game is pretty easy.','I heard this game is pretty easy.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53686,'I hope the rings don\'t hurt the turtle.','I hope the rings don\'t hurt the turtle.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53687,'I wish I had a pet turtle.','I wish I had a pet turtle.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53688,'My friend had a pet turtle, but he gave it away as a gift.','My friend had a pet turtle, but he gave it away as a gift.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53689,'Ring toss is outrageous.','Ring toss is outrageous.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53691,'I wish I could play ring toss.','I wish I could play ring toss.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53692,'This is my favorite game, because of the turtle.','This is my favorite game, because of the turtle.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53693,'I bet the turtle likes being close to the other animals.','I bet the turtle likes being close to the other animals.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53694,'Yum!','Yum!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53695,'I love cake!','I love cake!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53696,'The pink hearts are pretty!','The pink hearts are pretty!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53697,'I\'m sorry, but Lorna\'d be real mad if I let you take a horse.\n\nThey\'re only for friends of Gilneas!','I\'m sorry, but Lorna\'d be real mad if I let you take a horse.\n\nThey\'re only for friends of Gilneas!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53698,'The cupcakes look delicious!','The cupcakes look delicious!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53699,'Some of those cake designs are outrageous!','Some of those cake designs are outrageous!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53700,'I\'m sorry, but Lorna\'d be real mad if I let you take a horse.\n\nThey\'re only for those who are exalted with Gilneas!','I\'m sorry, but Lorna\'d be real mad if I let you take a horse.\n\nThey\'re only for those who are exalted with Gilneas!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53701,'I like cake more than pie.','I like cake more than pie.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53702,'Everything looks so good.','Everything looks so good.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53703,'Aimee is very nice.','Aimee is very nice.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53704,'Lorna said a truly brave adventurer helped rescue many of the horses near her family\'s orchard.\n\nI offered to take care of those that made it across the sea with us. I learned how from my mother and father, Light bless them!\n\nWere you interested in a fine Gilnean steed...?','Lorna said a truly brave adventurer helped rescue many of the horses near her family\'s orchard.\n\nI offered to take care of those that made it across the sea with us. I learned how from my mother and father, Light bless them!\n\nWere you interested in a fine Gilnean steed...?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53705,'Wow!','Wow!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53706,'There are so many things to buy.','There are so many things to buy.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53707,'Oooh, look at that!','Oooh, look at that!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53708,'Shiny!','Shiny!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53709,'Some of the things here are so glamourous.','Some of the things here are so glamourous.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53710,'Needs more glitter...','Needs more glitter...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53711,'I wonder how long it would take to get all of this?','I wonder how long it would take to get all of this?',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53712,'Everything is so nice!','Everything is so nice!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53713,'She\'s sooo strong!','She\'s sooo strong!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53714,'I heard she\'s the strongest woman in the world!','I heard she\'s the strongest woman in the world!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53715,'I think the boys are afraid of her!','I think the boys are afraid of her!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53716,'I want to be like Kerri when I grow up!','I want to be like Kerri when I grow up!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53717,'I wonder what it\'s like to have so much fame?','I wonder what it\'s like to have so much fame?',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53718,'She\'s tall!','She\'s tall!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53719,'Her strength is truly outrageous!','Her strength is truly outrageous!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53720,'I bet no one gets in her way.','I bet no one gets in her way.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53721,'Awww...','Awww...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53722,'Awww...  They are hurt.','Awww...  They are hurt.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53723,'Poor workers...','Poor workers...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53724,'I hope they get better.','I hope they get better.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53725,'So many are hurt, that can\'t be good.','So many are hurt, that can\'t be good.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53726,'I wonder how they got hurt.','I wonder how they got hurt.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53727,'I hope they\'ll be okay.','I hope they\'ll be okay.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53728,'It\'s truly outrageous that so many workers are hurt.','It\'s truly outrageous that so many workers are hurt.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53731,'Spooky...','Spooky...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53732,'Mysterious...','Mysterious...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53733,'The boys are afraid of Sayge, that\'s why they stay away.','The boys are afraid of Sayge, that\'s why they stay away.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53734,'I wonder if the fortunes are real...','I wonder if the fortunes are real...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53735,'I wonder if Sayge plays Whack-a-Gnoll?','I wonder if Sayge plays Whack-a-Gnoll?',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53737,'Sayge seems pretty nice...','Sayge seems pretty nice...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53738,'I\'ve heard some people got outrageous fortunes.','I\'ve heard some people got outrageous fortunes.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53739,'It\'s kind of scary looking...','It\'s kind of scary looking...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53743,'You picked a nice time to show up, friend. We need every Alliance soldier to pitch in.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53744,'I don\'t know how we did it, but we managed to fend off those hozen.$B$BThanks to you, mate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53745,'Brace yourself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53746,'Things are looking up for us, $n. Now that the attacks are over, we can finally work on repairing our ships to find a way home.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53748,'<He looks like he was knocked unconscious in all the fighting.>$B$B<He clutches tightly to a leather bag.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53749,'My skull feels like it was hit by a hammer, but otherwise I\'m all right. That\'s more than I can say for most of the crew.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53750,'Rifle through his bag.','Rifle through his bag.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(53751,'','...and with that out of the way, you and your flock of fumbling friends are next on my list. Mmm, I thought you\'d never get here!',396,153,0,0,4,0,0,0,1,0,0,25819,26124),
(53754,'Mysteries and wonders surround us every day, not just at the faire.  We\'ve compiled a list of some of the wonders you may encounter in your every day business.  The Darkmoon Adventurer\'s Guide will help you navigate the wonders of the world.$b$bWith the guide in your possession, you may come across items you never knew existed.  Items you may have taken for granted in the past are now treasures that others long for.$b$bKeep the guide with you, and keep your eyes open for mystery.$b$bIf you happen to lose your guide, seek us out and we will replace it for free.','Mysteries and wonders surround us every day, not just at the faire.  We\'ve compiled a list of some of the wonders you may encounter in your every day business.  The Darkmoon Adventurer\'s Guide will help you navigate the wonders of the world.$b$bWith the guide in your possession, you may come across items you never knew existed.  Items you may have taken for granted in the past are now treasures that others long for.$b$bKeep the guide with you, and keep your eyes open for mystery.$b$bIf you happen to lose your guide, seek us out and we will replace it for free.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53755,'Darkmoon Adventurer\'s Guide?','Darkmoon Adventurer\'s Guide?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53756,'May I have another Darkmoon Adventurer\'s Guide?','May I have another Darkmoon Adventurer\'s Guide?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53757,'Death to all who oppose us!','Death to all who oppose us!',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(53758,'What do you have for sale?','What do you have for sale?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(53760,'','We\'ve been stranded here for days. We are stretched to the breaking point, but trying our best to keep spirits high.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53764,'','The... the monkeys... they attacked...$b$bI fought them off, but... they\'ll be back... with more...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53765,'You did well, Agent Kearnen. Now save your energy... we\'ll fend them off.','You did well, Agent Kearnen. Now save your energy... we\'ll fend them off.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53769,'<Rell does not look up to address you.>$b$b<Judging by his state, you\'re not certain he even has the energy to move his head.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53770,'Please, continue your report.','Please, continue your report.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53772,'You need something built or broken? Stripped or soldered? Cracked or cobbled? You\'ve come to the right engineer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53773,'At the dawn of the year, we elders visit briefly to offer counsel to the living and welcome those who have joined the ancestors.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53775,'Aw shoot, aw shoot, aw shoot...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53777,'Keep telling your story, Sully.','Keep telling your story, Sully.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53783,'The features of this jade statue are incredibly lifelike.  The expression on the face is one locked in horror.$b$BIt does not resemble Shin however.','The features of this jade statue are incredibly lifelike.  The expression on the face is one locked in horror.$b$BIt does not resemble Shin however.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53784,'Examine the statue','Examine the statue',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53786,'','Stop!  You will NOT turn my friends into stupid statues!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(53787,'|TInterface\\Icons\\ability_shaman_cleansespirit.blp:16|tThrall casts |cFF00FFFF|Hspell:103550|h[Cleanse Spirit]|h|r on you!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53788,'I\'m glad that these \"SI:7\" people decided to take me with.$b$bWe do not leave the comforts of our lake very often at all. This was the farthest I\'ve ever been from home.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53789,'What happened next, Little Lu?','What happened next, Little Lu?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53790,'What? Is that...is that a $r I see? Thank you for rescuing me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53791,'Fortunately, you can still make out enough detail to sketch what looks to be a creature\'s torso.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53792,'<Create a sketch of the statue piece.>','<Create a sketch of the statue piece.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53793,'This portion of the statue tells you little, other than the subject actually had arms...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53794,'The Darkmoon Faire is now open!$b$bFor a small fee, I can teleport you to the fairground staging area.$b$bWould you like to go?','The Darkmoon Faire is now open!$b$bFor a small fee, I can teleport you to the fairground staging area.$b$bWould you like to go?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53795,'The statue\'s shoulder looks quite imposing in relation to the rest of its features. The subject was clearly a mighty creature!$b$bPerhaps it\'s a good natured sort. Or if not, then maybe it\'s extinct!$b$bOne can hope...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53796,'My people do not like strangers, but I owe you this much. May the elders not punish me for this deed.','',0,0,0,0,0,0,0,0,1,0,30639,0,26124),
(53797,'Shaman! The Dragon Soul is not yours. Give it up, and you may yet walk away with your life.','',0,0,0,0,0,0,0,0,1,0,25798,0,26124),
(53798,'Destroy them all, but bring the Shaman to me!','',0,0,0,0,0,0,0,0,1,0,25799,0,26124),
(53799,'','Yes, little children?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53800,'Can you help us? Our friend is injured.','Can you help us? Our friend is injured.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53801,'The features of this jade statue are incredibly lifelike. The expression is locked in horror.','The features of this jade statue are incredibly lifelike. The expression is locked in horror.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53802,'This statue does not match the description of Shin that An Windfur gave you.','This statue does not match the description of Shin that An Windfur gave you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53803,'You will go nowhere, Shaman.','',0,0,0,0,0,0,0,0,1,0,25800,0,26124),
(53804,'Welcome to the Darkmoon Faire, $c!','Welcome to the Darkmoon Faire, $c!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53805,'Welcome to the Darkmoon Faire!','Welcome to the Darkmoon Faire!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53806,'Welcome!','Welcome!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53807,'Maybe that\'s just a big scary mask on its face...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53808,'Greetings!','Greetings!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53809,'Prepare for adventure!','Prepare for adventure!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53810,'Behold, Master Greenpaw, known throughout the lands as the Jade Fist Monk.$b$bThrough skill, determination, and chi, he mastered the form now known as the dreaded Jade Strike, a blow that would transmute foes into statues of jade.$b$bIt was his heroism and sacrifice that saved the Jade Forest in a time of great need, and his like is not to be seen in this world again.$b$bMay this statue forever stand as a reminder of the price of peace, and may his sacrifice never be forgotten.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53811,'When the land ails, the spirits are first to feel the ill tiding. When the spirits leave the temple and fall to their baser instincts, the wise Pandaren takes heed.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(53812,'In caring for the spirits and bringing them back among us, we can heal the land, and we can find understanding of the greater threats at hand.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(53813,'Attention, fairegoers! The Darkmoon Deathmatch is about to begin! In mere moments the prize chest will appear at the center of the fighting pit!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(53814,'Let the Darkmoon Deathmatch BEGIN!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(53815,'Very recently, all four spirits left the temple and scattered to the corners of Shen-zin Su. The land suffers.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(53816,'Your training will be put to use very soon, young $c. Go now, continue your lessons.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(53818,'You\'re a fool if you think to take your place as the Aspect of Earth, Shaman!','',0,0,0,0,0,0,0,0,1,0,25802,0,26124),
(53819,'','No matter what happens - we must stay focused on our objectives here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53820,'Let me hear the rest of your report, Agent Kearnen.','Let me hear the rest of your report, Agent Kearnen.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53821,'Let none stand in our way.','',0,0,0,0,0,0,0,0,1,0,25884,0,26124),
(53822,'The Twilight\'s Hammer returns.','',0,0,0,0,0,0,0,0,1,0,25885,0,26124),
(53823,'Let them come!','',0,0,0,0,0,0,0,0,1,0,25886,0,26124),
(53824,'Here you see the Darkmoon Deathmatch pit.  Do you possess the power and will to best all comers and take the pit fighter\'s prize?\n\nBouts begin at midnight and every three hours thereafter.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53825,'','Where do you think you\'re going, little lizard?',0,0,0,0,0,0,0,0,1,0,0,25818,26124),
(53826,'How did they find us? Ready your weapons - we\'ve got to get out of this canyon!','',6,0,0,0,0,0,0,0,1,0,25871,0,26124),
(53827,'We must seek out the elemental spirits and reunite them in the temple. Through this we will heal the land and find understanding of what truly ails it.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(53828,'The closest spirit is Huo, the spirit of flame. You will meet with some of my most talented students and learn what they know of Huo.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(53829,'Off with you, $c. You have much to do.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(53831,'What do you suppose happened to this tree, Sully?','',0,0,0,0,0,0,6,0,0,0,27715,0,26124),
(53832,'Somethin\' hit it, sir. Wasn\'t cut down, didn\'t fall on its own.','',0,0,0,0,0,0,1,0,0,0,27849,0,26124),
(53833,'What\'s that, over there? Some kind of bird?','',0,0,0,0,0,0,6,0,0,0,29869,0,26124),
(53834,'Naw, that\'s a plane. Wait... A PLANE!?','',0,0,0,0,0,0,5,0,0,0,27852,0,26124),
(53835,'That\'s Amber an\' Nimm\'s plane! They might be alive after all!','',0,0,0,0,0,0,5,0,0,0,27853,0,26124),
(53836,'Who are Amber and Nimm? Should we follow him?','',0,0,0,0,0,0,6,0,0,0,29870,0,26124),
(53837,'She\'s still breathin\', sir! Get over here! Talk to \'er!','',0,0,0,0,0,0,5,0,0,0,27854,0,26124),
(53838,'Listen up, men! Prepare for a hozen ambush!','',0,0,0,0,0,0,22,0,0,0,27716,0,26124),
(53839,'Little Lu, keep Amber alive! Sully, try and keep this plane from exploding on us!','',0,0,0,0,0,0,397,0,0,0,27717,0,26124),
(53840,'I\'ll hold them off as long as I can!','',0,0,0,0,0,0,22,0,0,0,27718,0,26124),
(53841,'Master Li Fei\'s voice echoes, \"Huo, the spirit of fire, is known for his hunger. He wants for tinder to eat. He needs the caress of the wind to rouse him.\"','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(53842,'Master Li Fei\'s voice echoes, \"If you find these things and bring them to his cave, on the far side of Wu-Song Village, you will face a challenge within.\"','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(53843,'Master Li Fei\'s voice echoes, \"Overcome that challenge, and you shall be graced by Huo\'s presence. Rekindle his flame, and if your spirit is pure, he shall follow you.\"','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(53844,'Master Li Fei\'s voice echoes, \"Go, children. We shall meet again very soon.\"','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(53845,'Master Li Fei\'s voice echoes, \"It is good to see you again, Aysa. You\'ve come with respect, and so I shall give you the answers you seek.\"','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(53847,'Who owns this forest?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53848,'Who is our greatest enemy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53849,'No, idiots! The ones down by the beach!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53850,'Are we going to let those soft-skinned, tail-less cowards cut down our forest and kill our clan brothers?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53851,'Then I remind you...WE are the strongest in this forest. We are the kings of the trees! We are death to our enemies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53852,'No one messes with the Grimleer Tribe. It is time for our clan to taste blood and victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53853,'Ravage! Ravage! Ravage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53854,'Aaahaahahaha!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53855,'You, Chief!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53856,'Personal hygiene?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53857,'Alexstrasza\'s drakes should meet us here...','',396,0,0,0,0,0,0,0,1,0,25887,0,26124),
(53858,'The pale skins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53859,'Us! Grimleer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53860,'Water?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53861,'The blue banners!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53862,'Kill! Kill! Kill!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53863,'Monkeys!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53864,'Hmmmm...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53865,'The sea riders!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53866,'Yeeeaaaahhh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53867,'Grim! Grim! Grimleer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53868,'Oh, oh, I know! The eggheads!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53869,'Blood! Blood! Blood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53870,'Ugly fish men!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53871,'The washed ones!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53872,'Grind them to dust!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53873,'Crocodiles?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53874,'Rip them apart!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53875,'Up there, above us!','',397,0,0,0,0,0,0,0,1,0,25888,0,26124),
(53876,'No way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53877,'|TInterface\\Icons\\ability_vehicle_sonicshockwave.blp:20|t%s summons a |cFFFF0000|Hspell:103678|h[Wave of Virtue]|h|r!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53878,'No!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53879,'Thank you for saving me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53880,'An was being a meanie when she double hozen dared me. But I wasn\'t about to run away from a dare.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53881,'Are you okay?','Are you okay?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53882,'Sully, Little Lu, our plans have changed. We need to transport Amber back to the main camp.','',0,0,0,0,0,0,1,0,0,0,27720,0,26124),
(53883,'','That\'s not necessary. I\'ll be coming with you.',0,0,0,0,0,0,1,0,0,0,0,27455,26124),
(53884,'Ye\'ve gotta be kiddin\' me! Yer nearly dead! Look at ye!','',0,0,0,0,0,0,5,0,0,0,27855,0,26124),
(53885,'','No, Sully. My injuries will heal. Right now, we need to find the White Pawn.',0,0,0,0,0,0,1,0,0,0,0,27456,26124),
(53886,'What\'s the White Pawn? I thought we were attacking the hozen.','',0,0,0,0,0,0,6,0,0,0,29871,0,26124),
(53887,'TEST - P1. Starting Wave 1 now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53888,'TEST - P1. Starting Wave 2 now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53889,'TEST - P1. hozen are fleeing now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53890,'TEST - P2. Wave 3 arrives now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53891,'TEST - P2. Jinyu arrive now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53892,'[TEMP] Save me dude','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53893,'[TEMP] you got it bud','[TEMP] you got it bud',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53894,'It\'s us or them, $r. This day won\'t end without bloodshed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53895,'Ahh, good to finally see a friendly face, mon.$b$bWould be good, dat is, if I could, you know, see...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53896,'|TInterface\\Icons\\spell_fire_twilightfire.blp:20|t%s summons a |cFFFF0000|Hspell:103780|h[Wave of Twilight]|h|r!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53897,'','Rell\'s condition is worsening. We must stop to rest again.',0,0,0,0,0,0,1,0,0,0,0,27461,26124),
(53898,'If only Mishka were here. She\'d fix him up in no time.','',0,0,0,0,0,0,6,0,0,0,27886,0,26124),
(53899,'Fellow agents! This is a pandaren hut. The pandaren are allies.','',0,0,0,0,0,0,1,0,0,0,29875,0,26124),
(53900,'','Good thinking, Little Lu. Go find out who lives here. Take Sully with you.',0,0,0,0,0,0,1,0,0,0,0,27462,26124),
(53901,'And Socks!','',0,0,0,0,0,0,6,0,0,0,27887,0,26124),
(53902,'','Yes... and the raccoon. I will watch over our commander.',0,0,0,0,0,0,1,0,0,0,0,27463,26124),
(53903,'<Continue reading...>','<Continue reading...>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53904,'|TInterface\\Icons\\spell_shadow_twilight.blp:20|t%s begins to cast |cFF006EFD|Hspell:103754|h[Twilight Epiphany]|h|r!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53905,'','Shin tried to back out of the hozen dare but then we double hozen dared him and he couldn\'t back out of that.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53906,'','So the other kids, not me, dared Shin to knock on the Jade Witch\'s front door.  He wouldn\'t do it though but then someone, not me, hozen dared him.$b$bShin backed out of that but then someone, not me I swear, double hozen dared him.  And not even Shin can get out of a double hozen dare.$b$bHe went and knocked on the door but we didn\'t see what happened.  Jade Monsters came at us and we ran away. $b$bI never should have dared Shin...',1,1,18,0,0,0,0,0,1,0,0,0,26124),
(53907,'','Well well, a young visitor.$B$bHave you come to pay your respects at the shrine of my husband?  He was a hero you know.  A master of Jade crafting and fighting. He was to be remembered forever they said.$B$bDo you like my statues?  I craft them with special care saving only the best to  provide my husband company and protection.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53908,'Where is Shin?','Where is Shin?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53909,'','It is nice to see some concerned individuals travelling on the roads these days.  My husband would have liked you.  We always wanted children.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53911,'When we start tour?','When we start tour?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53912,'When we start tour?','When we start tour?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53913,'An assassin! Quickly, ready yourselves for battle!','',397,0,0,0,0,0,0,0,1,0,25889,0,26124),
(53914,'When will we start this tour?','When will we start this tour?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53915,'When will this tour start?','When will this tour start?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53916,'When will the tour start?','When will the tour start?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53917,'Where is our tour guide?','Where is our tour guide?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53918,'Where is my tour guide?','Where is my tour guide?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53919,'Where is tour guide?','Where is tour guide?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53920,'Where is this tour guide who is meant to guide me?','Where is this tour guide who is meant to guide me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53921,'Where tour guide at?','Where tour guide at?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53922,'Your tour guide will be along any minute now...','Your tour guide will be along any minute now...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53923,'Your tour guide will be here shortly...','Your tour guide will be here shortly...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53924,'I just saw the guide a moment ago...','I just saw the guide a moment ago...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53925,'Just a few more minutes...','Just a few more minutes...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53926,'I think I see him heading over here now...','I think I see him heading over here now...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53927,'The tour guide will be along soon...','The tour guide will be along soon...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53928,'Please be patient, the tour guide should be here any moment now...','Please be patient, the tour guide should be here any moment now...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53929,'The battle against Deathwing\'s minions is your top priority, $n. But if you can help our flight with this small task, so much the better.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(53930,'My jade!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53931,'You have jade?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53932,'The jade sings to us. Give! Give!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53933,'Very well.','Very well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53934,'Great!','Great!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53935,'Shinies!','Shinies!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53936,'Very well.','Very well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53937,'We is good.','We is good.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53938,'Our patience is growing thin...','Our patience is growing thin...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53939,'Good thing I don\'t mind waiting.','Good thing I don\'t mind waiting.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53940,'We keep waiting then...','We keep waiting then...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53941,'This is becoming unbearable.','This is becoming unbearable.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53942,'We keep waiting.','We keep waiting.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53943,'Those sneaky monkeys ambushed me out of nowhere.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53944,'The Darkmoon Deathmatch is over!  $n is the victor!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(53945,'','I don\'t know that cub.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53946,'','That isn\'t Shin.  It looks super lifelike though.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(53947,'','Eww.  That cub has a funny face.',14,0,0,0,0,0,0,0,1,0,0,0,26124),
(53948,'Are you friends with Admiral Taylor? If so, then I must test your strength in battle later.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53949,'The water spirits have answered my prayers. Thank you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53950,'I had given up hope, friend. Thank you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53951,'Do my eyes deceive me? Am I truly free?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53952,'I live another day, thanks to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53953,'Are you part of the rescue team? Are we saved?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53954,'I knew someone would come for us. Thank you, $c!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53955,'Thank you, $c. I can get back to camp on my own.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53956,'They\'ve got the Admiral locked up like an animal. Please save him too.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53957,'The hozen revel in torturing their prisoners. Thank you, $c, for saving me from a dire fate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53958,'The undying flames are all that remain of this sacred place. I sense much anger here...a seething rage, barely held in check. Be on your guard.','',0,0,0,0,0,0,0,0,1,0,25956,0,26124),
(53959,'','And you, with your heroic features. My husband\'s shrine needs guardians of your... stature.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53960,'Come on now, mon!$b$bI be leakin\' like a sieve, here! I don\' be havin\' much time...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53961,'Come with me, Zin\'Jun, let\'s find your missing... belongings.','Come with me, Zin\'Jun, let\'s find your missing... belongings.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53962,'Be right with ya, mon...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53963,'You\'ve almost got him! Og\'nor ka Lok\'tar - Now we finish this!','',0,0,0,0,0,0,0,0,1,0,25881,0,26124),
(53964,'Aww, no... what have dey gone an\' done to me rifle, mon!?','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53965,'Well lookie dere! Dat be my bad eye, but it be a good start!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53966,'Dere it be, mon. My huntin\' eye! I\'ll be able ta rest in peace wit\' my ancestors...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53967,'Wassat, mon? Dey kill ol\' Snuff?! Nooo!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(53968,'I haven\'t come to be stopped by the likes of you.','',15,0,0,0,0,0,0,0,1,0,25890,0,26124),
(53969,'Dere we go, mon. Now I be goin\' off ta be wit Snuff...','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(53970,'You have our thanks, $p. We\'ll be watchin\' over ya.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53971,'','What a waste.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53972,'What is it you seek?','What is it you seek?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53973,'Fight me!','Fight me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53977,'Very well...','Very well...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53978,'Let us celebrate!','Let us celebrate!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53979,'The time for celebration is done.','The time for celebration is done.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53980,'Enough!','Enough!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53984,'<Rell\'s forehead is pale and beaded with sweat. He does not look good.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53985,'<Rell continues to stare blankly at the mat. His breathing is shallow and labored.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53986,'Well done, Let us see to our friend...','',0,0,0,0,0,0,0,0,1,0,25891,0,26124),
(53987,'The rest of the drakes should be here shortly. I\'ll fly on ahead; catch up when you can.','',0,0,0,0,0,0,0,0,1,0,25892,0,26124),
(53989,'','Rell, please... save your energy. Sully can tell $n what happened next.',0,0,0,0,0,0,1,0,0,0,0,27457,26124),
(53990,'We had traveled north through the forest for several hours.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(53994,'We stopped when we found a strange fallen tree.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(53995,'It wasn\'t supposed to go this way. We were supposed to find the White Pawn. I should be back in Ironforge by now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53996,'Everything\'s gone to crap, $n. This was supposed to be a simple recon mission.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(53997,'I... <sniff>... I don\'t think I can handle the next part! Little Lu, tell $n what happened next.','',0,0,0,0,0,0,18,0,0,0,27885,0,26124),
(53998,'Alright, agents. Listen up.','',0,0,0,0,0,0,1,0,0,0,27721,0,26124),
(53999,'Mmm... he considers me an agent.','',0,0,0,0,0,0,1,0,0,0,29872,0,26124),
(54000,'It grows late. We should set up camp for the night. Sully, do you have an axe?','',0,0,0,0,0,0,1,0,0,0,27722,0,26124),
(54001,'Naw, but I can put one together in a pinch. Let\'s see... you need a wood-cuttin\' axe, or a people-killin\' axe?','',0,0,0,0,0,0,6,0,0,0,27858,0,26124),
(54002,'Wood-cutting. Little Lu, use this axe to gather firewood.','',0,0,0,0,0,0,1,0,0,0,27723,0,26124),
(54003,'Yes sir!','',0,0,0,0,0,0,66,0,0,0,29873,0,26124),
(54004,'Sully. Investigate those shrines to the west. Look for signs of the White Pawn.','',0,0,0,0,0,0,25,0,0,0,27724,0,26124),
(54005,'Amber, find a good perch and give Sully some covering fire. We\'ll rendezvous back here.','',0,0,0,0,0,0,1,0,0,0,27725,0,26124),
(54006,'Aye-aye, sir!','',0,0,0,0,0,0,66,0,0,0,27859,0,26124),
(54007,'','Yes, sir.',0,0,0,0,0,0,66,0,0,0,0,27458,26124),
(54008,'','This way, Sully! I see the perfect spot.',0,0,0,0,0,0,1,0,0,0,0,27459,26124),
(54009,'','I\'ll hide up here in the shadows. If you run into any trouble, just shine a light on the target and I\'ll take care of them.',0,0,0,0,0,0,1,0,0,0,0,27460,26124),
(54010,'Nice shot, Amber!','',0,0,0,0,0,0,1,0,0,0,27862,0,26124),
(54011,'Didn\'t know I had a sniper on my side, did ya?','',0,0,0,0,0,0,1,0,0,0,27863,0,26124),
(54012,'I swear, that woman never misses.','',0,0,0,0,0,0,1,0,0,0,27864,0,26124),
(54013,'Note to self: Don\'t get on Amber\'s bad side.','',0,0,0,0,0,0,1,0,0,0,27865,0,26124),
(54014,'Boom! Nice one!','',0,0,0,0,0,0,1,0,0,0,27866,0,26124),
(54015,'Tryin\' ta sneak up on ol\' Sully, huh?','',0,0,0,0,0,0,1,0,0,0,27867,0,26124),
(54016,'She hits \'em between the eyes, every time.','',0,0,0,0,0,0,1,0,0,0,27868,0,26124),
(54017,'Yuck... splatter.','',0,0,0,0,0,0,1,0,0,0,27869,0,26124),
(54018,'I\'m in bad shape, $n. My injuries...I...I\'ll try to hang on a bit longer. Get me out of here, please.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54019,'We were still goin\' north when we stopped near this big ol\' clearing.','',0,0,0,0,0,0,6,0,0,0,27856,0,26124),
(54020,'We set up camp for the night. Rell split up responsibilities.','',0,0,0,0,0,0,6,0,0,0,27857,0,26124),
(54021,'I found an old rifle scope in my pockets. It\'d have to do.$b|TInterface\\Icons\\inv_misc_scopeb.blp:32|t$b','',0,0,0,0,0,0,6,0,0,0,27860,0,26124),
(54022,'I readied my swords for battle.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(54023,'If I saw anything dangerous, I\'d hit it with the light, and Amber\'s sniper rifle would take care of the rest.','',0,0,0,0,0,0,6,0,0,0,27861,0,26124),
(54024,'<Shu looks at you expectantly.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54025,'Shu, can you wake up Wuguo for me?','Shu, can you wake up Wuguo for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54026,'I found no sign of Anduin at the southwestern shrine.','',0,0,0,0,0,0,6,0,0,0,27870,0,26124),
(54027,'However, I did find a friendly raccoon, who began to follow me.','',0,0,0,0,0,0,6,0,0,0,27871,0,26124),
(54028,'I decided to name him Gizmo.','',0,0,0,0,0,0,6,0,0,0,27872,0,26124),
(54029,'NO! GIZMO!','',0,0,0,0,0,0,5,0,0,0,27874,0,26124),
(54030,'Food and drink taste even sweeter after a well fought battle.','Food and drink taste even sweeter after a well fought battle.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54031,'Hey there, little buddy! I\'m gonna name you Gizmo.','',0,0,0,0,0,0,3,0,0,0,27873,0,26124),
(54032,'AMBER, WHY!? I DIDN\'T EVEN SHINE MY DAMN LIGHT!','',0,0,0,0,0,0,5,0,0,0,27875,0,26124),
(54033,'Shortly afterward, another raccoon befriended me.','',0,0,0,0,0,0,6,0,0,0,27876,0,26124),
(54034,'I named him Socks, and quickly moved on.','',0,0,0,0,0,0,6,0,0,0,27877,0,26124),
(54035,'Come on, Socks. Let\'s get out of here before you get sniped.','',0,0,0,0,0,0,1,0,0,0,27878,0,26124),
(54036,'Look there!  It looks as though the Twilight Cultists have brought the Old Gods and their corruption to Wyrmrest.  Hold on tight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54037,'Grrrrr...*hic*...rrr...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54038,'I found nothin\' at the northern shrine - no Anduin, no hozen... nothin\'.','',0,0,0,0,0,0,6,0,0,0,27879,0,26124),
(54039,'After scoutin\' the three shrines, I headed back over to camp.','',0,0,0,0,0,0,6,0,0,0,27880,0,26124),
(54040,'Socks followed along, faithfully.','',0,0,0,0,0,0,6,0,0,0,27881,0,26124),
(54041,'Pollen punch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54042,'My orchids!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54043,'Weeeeee!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54044,'No... Rell...','',0,0,0,0,0,0,0,0,0,0,27884,0,26124),
(54045,'Nnn... nn nnnn... n-nl nnnr nnn... nn n nnnt...\n\n<I\'ll... be fine... it\'ll wear off... in a bit...>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54046,'No. Your perversion of the dead ends here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54047,'All these poor souls... here, this will lead you home.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54049,'I WILL have you, spirit-sage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54050,'Augh! Too... much... It\'s too much!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54051,'I cannot fall here. Not with so much work left to be done...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54052,'Northrend\'s depths belong to the nerubians, $r.$B$BI have devoted myself to restoring that great truth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54055,'','Sir, we can have the entirety of the seventh fleet on the scene within the month--',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54056,'Your Majesty! We\'ve finally restored Taylor\'s last transmission.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54057,'Nightwind, have you pieced together that last transmission yet? Play me whatever you have!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54058,'No time! We\'ll send a small team immediately. An elite force. Rescue the survivors, AND their precious cargo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54059,'Did you hear? They\'re safe somewhere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54060,'...west of the planned rendezvous...Horde airfleet...[gunfire]...casualties!','',0,0,0,0,0,0,333,0,1,0,0,0,26124),
(54061,'Victory is ours today!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54062,'...Thick fog bank to provide cover...retreat...uncharted land...','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(54063,'...hostile creatures. But the White Pawn is accounted for. Repeat: the White Pawn is safe.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(54064,'...[Sound of swords clashing]...immediate danger! Requesting rescue, requesting --','',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(54065,'...encountered -- tribe -- extremely hostile creatures...we -- in immediate danger...Requesting rescue, I repeat--','',0,0,0,0,0,0,27,0,1,0,0,0,26124),
(54066,'Once the White Pawn is recovered, the full might of our navy can engage the Horde. On OUR terms.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54067,'I returned to find Rell bein\' attacked by hozen! Again!','',0,0,0,0,0,0,6,0,0,0,27882,0,26124),
(54068,'AMBER! AIM YER SIGHTS OVER HERE!','',0,0,0,0,0,0,0,0,0,0,27883,0,26124),
(54069,'Things have changed rapidly since you arrived here, $n. The hozen are more of a threat now than ever before.$b$bBut we, jinyu... we are stronger now, too.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54070,'We don\'t stand a chance if we face the hozen alone. We will need the help of the Alliance if our tribe is to survive.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54071,'Rell survived the attack, but he wasn\'t doing very well.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54072,'','This is a very unusual place.$B$BThe magic I\'m channeling to try to repair the ley lines should be tearing my body apart, but I feel incredible!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54073,'Don\'t throw banana peel where going to walk.','Don\'t throw banana peel where going to walk.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54074,'Peel banana first, eat second.','Peel banana first, eat second.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54075,'Steal a banana from a hozen, expect a angry hozen.','Steal a banana from a hozen, expect a angry hozen.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54076,'Firecracker for throwing, banana for eating.','Firecracker for throwing, banana for eating.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54077,'Wet fur not fun to sleep on.','Wet fur not fun to sleep on.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54078,'Don\'t roll in own poo unless want to smell like poo all day.','Don\'t roll in own poo unless want to smell like poo all day.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54079,'Don\'t pull own tail when there are other tails to pull.','Don\'t pull own tail when there are other tails to pull.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54080,'Poo not good to eat, but very good to throw.','Poo not good to eat, but very good to throw.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54081,'Thank you, friend. I\'d be bound to that wretched construct right now if it weren\'t for your intervention.$B$BStill, I shouldn\'t be here at all. We must put a stop to the spiritbinders.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54082,'I envy you in a way, little $r.$B$BYou are so fortunate as to bear witness to the first steps of the rebirth of the mighty Empire of Azjol-Nerub.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54083,'The sign out front was not very... welcoming.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54084,'The lawn was littered with small jade statues. They seemed almost... lifelike.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54085,'One statue in particular stood out. I had never seen a creature like this.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54086,'Pshh! No sign is gonna stop me an\' my best pal Socks!','',0,0,0,0,0,0,4,0,0,0,27888,0,26124),
(54087,'This person sure has lots o\' statues...','',0,0,0,0,0,0,6,0,0,0,27889,0,26124),
(54088,'Now wait a darn minute. Is that an orc? Is... is the HORDE here too!?','',0,0,0,0,0,0,6,0,0,0,27890,0,26124),
(54089,'','Now look at this... a jinyu and... what is that? Some sort of Beard-Sprite?',0,0,0,0,0,0,6,0,0,0,0,31399,26124),
(54090,'I\'m a dwarf, ma\'am. Can we borrow some food?','',0,0,0,0,0,0,24,0,0,0,27891,0,26124),
(54091,'','The Beard-Sprite will make an excellent addition to my family!',0,0,0,0,0,0,0,0,0,0,0,31400,26124),
(54092,'What in blazes are you talkin\' about...','',0,0,0,0,0,0,274,0,0,0,27892,0,26124),
(54093,'Sully... those aren\'t statues on her lawn! She wants to turn you into jade!','',0,0,0,0,0,0,1,0,0,0,29881,0,26124),
(54094,'I finally understood what was going on... but I was a second too late.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54095,'','AHHH HA HA HAAAAA!',0,0,0,0,0,0,0,0,0,0,0,31401,26124),
(54096,'SOCKS! NOOOOOOOOOOO!','',0,0,0,0,0,0,5,0,0,0,27893,0,26124),
(54097,'The Hour of Twilight falls - the end of all things - you cannot stop it. You are nothing. NOTHING!','',0,0,0,0,0,0,0,0,1,0,25801,0,26124),
(54098,'Grook them florkin\' wikkets!','',0,0,0,0,0,0,0,0,1,12956,0,0,26124),
(54099,'Grook \'em in the kroogs, boys!','',0,0,0,0,0,0,0,0,1,12956,0,0,26124),
(54100,'Grook \'em \'til they ook in their dookers!','',0,0,0,0,0,0,0,0,1,12956,0,0,26124),
(54101,'Horg \'em off their jeeks and blikker \'em til their wik falls off!','',0,0,0,0,0,0,0,0,1,12956,0,0,26124),
(54102,'Grook \'em in the nook, then gork \'em clean!','',0,0,0,0,0,0,0,0,1,12956,0,0,26124),
(54103,'Can you close the portal, brother?','',0,0,0,0,0,0,397,0,1,0,26084,0,26124),
(54104,'Very well, we shall break it for you.','',0,0,0,0,0,0,396,0,1,0,26086,0,26124),
(54105,'Let them come.','',0,0,0,0,0,0,45,0,1,0,26085,0,26124),
(54106,'It is being maintained by the will of a powerful demon...Mannoroth.','',0,0,0,0,0,0,0,0,1,0,26494,0,26124),
(54107,'I cannot break his will alone...','',0,0,0,0,0,0,274,0,1,0,26495,0,26124),
(54108,'','He knows what we attempt. We have not much time, the forest crawls with his demons.',0,0,0,0,0,0,396,0,1,0,0,25993,26124),
(54109,'There are so MANY of them...','',0,0,0,0,0,0,5,0,1,0,26087,0,26124),
(54110,'','Mother moon, guide us through this darkness.',0,0,0,0,0,0,0,0,1,0,0,25994,26124),
(54111,'Weak, pitiful creatures. Hardly worthy of being called a legion.','',0,0,0,0,0,0,0,0,1,0,26088,0,26124),
(54112,'Oh this will be fun...','',0,0,0,0,0,0,397,0,1,0,26089,0,26124),
(54113,'Wait, I have an idea.','',0,0,0,0,0,0,0,0,1,0,26090,0,26124),
(54114,'','Illidan, what is in that vial? What are you doing?',0,0,0,0,0,0,6,0,1,0,0,25995,26124),
(54115,'After inspecting the statues, we saw a female pandaren emerge from the house.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54116,'What our people could not.','',0,0,0,0,0,0,0,0,1,0,26091,0,26124),
(54117,'Yes...YES. I can feel the raw power of the Well of Eternity! It is time to end this charade!','',0,0,0,0,0,0,0,0,1,0,26092,0,26124),
(54118,'Varo\'then, see that I am not disrupted by this rabble!','',0,0,0,0,0,0,0,0,1,0,26480,0,26124),
(54119,'Highguard, to arms! For your queen! For Azshara!','',0,0,0,0,0,0,0,0,1,0,26137,0,26124),
(54120,'','I cannot strike them!  What is this demon magic?',0,0,0,0,0,0,6,0,1,0,0,25996,26124),
(54121,'They are not where they appear to be!  Strike in an area, it is the only way to uncover the real one!','',0,0,0,0,0,0,0,0,1,0,26093,0,26124),
(54122,'I see you\'ve arrived. \n$bThis is the eve of the sundering, when the collapse of the Well of Eternity fractured the continents of the world.\n$bHere, we will snatch up the Dragon Soul before it is lost to the mists of time.\n$bBut first, you must bring down the protective wards of Azshara\'s lackeys. You will find them within the palace. I will scout on ahead.\n$bGood luck, heroes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54123,'Send me to portal 1.','Send me to portal 1.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54124,'Send me to portal 2.','Send me to portal 2.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54125,'Send me to portal 3.','Send me to portal 3.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54126,'Send me to the boss.','Send me to the boss.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54127,'Run, Little Lu! Run away!! Before she gets you too!','',0,0,0,0,0,0,5,0,0,0,27894,0,26124),
(54128,'Squeak!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(54129,'','The loss of the raccoon is the least of our worries. Our biggest concern is that petrified orc... and what its presence means. I can tell you the rest of the story.',0,0,0,0,0,0,1,0,0,0,0,27464,26124),
(54130,'','Rell is... he is hurt badly.$b$b<Agent Kearnen slams her fist on the ground.>$b$bHe\'s dying, $n! And there\'s not a damn thing we can do about it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54131,'','No, we didn\'t find the White Pawn.$b$bNo, I can\'t tell you what the White Pawn is.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54132,'','We made camp in the mountains. Little Lu watched over Rell.',0,0,0,0,0,0,1,0,0,0,0,27465,26124),
(54133,'','I walked up to the top of the mountain and took a hold of my sniper rifle.',0,0,0,0,0,0,1,0,0,0,0,27466,26124),
(54134,'Kill some hozen today, Amber.','',0,0,0,0,0,0,6,0,0,0,27730,0,26124),
(54135,'','As you wish, commander.',0,0,0,0,0,0,66,0,0,0,0,27467,26124),
(54136,'','I found Sully waiting outside the village\'s entrance.',0,0,0,0,0,0,1,0,0,0,0,27468,26124),
(54137,'','Straining my eyes, I could just barely read his lips, as he said:',0,0,0,0,0,0,1,0,0,0,0,27469,26124),
(54138,'Shoot all the guards, so I can move ahead!','',0,0,0,0,0,0,5,0,0,0,27895,0,26124),
(54139,'Nice work back there! One more time!','',0,0,0,0,0,0,5,0,0,0,27896,0,26124),
(54140,'','Sully planted some explosive barrels for me to shoot.',0,0,0,0,0,0,1,0,0,0,0,27470,26124),
(54141,'I brought these monkeys some presents! Try not to blow me up, Amber!','',0,0,0,0,0,0,5,0,0,0,27897,0,26124),
(54142,'Nothing to see here! Let\'s keep going!','',0,0,0,0,0,0,5,0,0,0,27902,0,26124),
(54143,'Bingo... I see a Horde crate! Cover me, I\'m going out in the open!','',0,0,0,0,0,0,5,0,0,0,27903,0,26124),
(54144,'','Just as I suspected... the Horde is here, in Pandaria. And they\'ve allied with the hozen.',0,0,0,0,0,0,1,0,0,0,0,27471,26124),
(54145,'','We\'d need to bring this information back to Pearlfin Village... but not before shooting a few orcs in the head.',0,0,0,0,0,0,1,0,0,0,0,27472,26124),
(54146,'I see an opening! Here I come, Amber!','',0,0,0,0,0,0,5,0,0,0,27904,0,26124),
(54147,'Ouch! Hey!','',0,0,0,0,0,0,5,0,0,0,27901,0,26124),
(54148,'This one\'s for beatin\' up Amber!','',0,0,0,0,0,0,5,0,0,0,27898,0,26124),
(54149,'This one\'s for beatin\' up Rell!','',0,0,0,0,0,0,5,0,0,0,27899,0,26124),
(54150,'An\' this one\'s for Gizmo and Socks, you bastards!!','',0,0,0,0,0,0,5,0,0,0,27900,0,26124),
(54151,'Anub\'Arak has fallen, my brothers! Rise from the depths and reclaim our birthright!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54152,'The sting of your defeat will fade with time.','The sting of your defeat will fade with time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54153,'|TInterface\\Icons\\spell_nature_moonglow.blp:20|t Tyrande gains the |cFFFF0000|Hspell:103917|h[Blessing of Elune]|h|r!','|TInterface\\Icons\\spell_nature_moonglow.blp:20|t Tyrande gains the |cFFFF0000|Hspell:103917|h[Blessing of Elune]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54154,'Ancestors, hear me! I call you back from the beyond, to bind this spirit to my will!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54155,'|TInterface\\Icons\\ability_mage_conjurewater11.blp:20|t Illidan douses himself with the |cFFFF0000|Hspell:103952|h[Waters of Eternity]|h|r!','|TInterface\\Icons\\ability_mage_conjurewater11.blp:20|t Illidan douses himself with the |cFFFF0000|Hspell:103952|h[Waters of Eternity]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54156,'Enough of your interference, $r! Spiritclaws! Deal with this pest!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54157,'More spirits! MORE! Quickly now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54158,'I am NEVER drinking again!','I am NEVER drinking again!',274,378,0,0,0,0,0,0,1,0,0,0,26124),
(54159,'Spirits of old, I release you from my staff! Seek your vengeance on this beast!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54160,'Oooh! I\'m gunna gork ya til ya ook your dookers, wikket!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54161,'Florkun wikket! I\'ll shove your nibs into your horker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54162,'I\'ll blikker yer nook, then hork ya clean, wikket!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54163,'Our enemies believe us vanquished from the frozen wastes.$B$BWe will show them the consequence of their ignorance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54164,'Work faster! We must hatch the cocoon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54165,'The rebirth of the Empire of Azjol-Nerub is upon us! Hear my call, brothers, and rise to reclaim what is rightfully ours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54166,'Make haste and secure the area! Much work remains to be done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54167,'What happened out here?','What happened out here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54168,'Thank you for saving me!','Thank you for saving me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54169,'Please don\'t tell my parents I was here.','Please don\'t tell my parents I was here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54170,'Do not rest until those wards are functional. We must not be disturbed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54171,'I tried to boot a jade monster in the head but hurt my paw.','I tried to boot a jade monster in the head but hurt my paw.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54172,'Next time I see a jade monster I\'m gonna punch it in the naughty bits.','Next time I see a jade monster I\'m gonna punch it in the naughty bits.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54173,'','I hope the Jade Witch didn\'t get all of my friends.  She is super spooky.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54174,'','I\'m sticking with you.  You can be my bodyguard!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54175,'','You are super brave.  Can you teach me to be as brave?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54176,'Twilight forces begin to appear around the canyon\'s edges.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54177,'We\'re surrounded - dispatch the ascendant while I keep the ambushers at bay.','',0,0,0,0,0,0,0,0,1,0,25878,0,26124),
(54178,'Yeah?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54179,'','This is no small island, $n. It\'s a landmass that would likely rival Northrend!$b$bHow it has gone undiscovered is still a mystery.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54180,'','Taking a hozen guide with us might not have been the best idea.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54181,'Go on, Riko.','Go on, Riko.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54182,'What happened next, Kiryn?','What happened next, Kiryn?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54183,'Let\'s hear the rest of your report, Shokia.','Let\'s hear the rest of your report, Shokia.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54184,'Handle Varo\'then. Mannoroth is mine.','',0,0,0,0,0,0,0,0,1,0,26094,0,26124),
(54186,'','What manner of creature are you?$b$b<The pandaren pauses, her eyes growing wide.>$b$bMy... look at that gorgeous green skin!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54187,'I am an orc, ma\'am. Would you mind if I asked you a few questions?','I am an orc, ma\'am. Would you mind if I asked you a few questions?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54189,'It tasted soooo good going down.','It tasted soooo good going down.',274,378,0,0,0,0,0,0,1,0,0,0,26124),
(54190,'I am so sorry for getting that on you.','I am so sorry for getting that on you.',274,378,0,0,0,0,0,0,1,0,0,0,26124),
(54191,'Ugh...','Ugh...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54192,'I lost my cloth. Can you rip me off another piece?','I lost my cloth. Can you rip me off another piece?',0,0,0,0,0,0,0,0,1,12936,0,0,26124),
(54193,'','No.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54194,'Do not take the practice of spirit-binding lightly. If the mogu are creating simulacra, you can be certain they\'re preparing for war.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54195,'Return to the Fox Grove before your Stag becomes angry!','Return to the Fox Grove before your Stag becomes angry!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54196,'Hey $p! This way to Morning Breeze Village.','',0,0,0,0,0,0,0,0,1,0,27294,0,26124),
(54197,'It is crucial that we bring all of the three remaining spirits back safely. I am too old to do this myself, and for all their strengths, both Aysa and Ji are single-minded in their ideals.$B$BYou possess all the qualities of a hero, and a balance that they do not. It is you that must do this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54198,'I need to reach the top of the temple to leave for the Air Plateau.','I need to reach the top of the temple to leave for the Air Plateau.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54199,'Arcurion begins to freeze Thrall in a block of ice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54200,'','Well this is certainly a nice change of scenery.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54201,'','No need to lug water around here.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54202,'','It\'s nice to relax for a day.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54203,'Can you charge my Cryptomancer\'s Decoder Ring?','Can you charge my Cryptomancer\'s Decoder Ring?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54204,'','What a festive event.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54205,'','Greetings!  I am apprentice to Brewmaster Shadowpour, a pandaren we now call the Mad Brewer.$b$BHis reckless pursuit of flavor at the risk of safety has resulted in countless injuries, illnesses, and now even the wildlife of the area feels his mad brewing.  He is a villain, and I could use your help in stopping him.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54206,'','This is nothing at all like the Shimmering Flats.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54207,'','This is much more relaxing than being on the speedbarge.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54208,'','I don\'t have to wory about getting sunburned out here.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54209,'','Oh, that looks like fun!',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(54210,'Look at this place!','Look at this place!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54211,'This place is huge!','This place is huge!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54212,'This faire is a sweet surprise!','This faire is a sweet surprise!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54213,'That Aimee has some sweet pies.','That Aimee has some sweet pies.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54214,'So much activity... It reminds me of the Trade District.','So much activity... It reminds me of the Trade District.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54215,'They\'re good at hawking their goods...','They\'re good at hawking their goods...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54216,'Hmm... No one here specializes in fresh bread...','Hmm... No one here specializes in fresh bread...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54217,'Lots of junk food here, but is it ever delicious.','Lots of junk food here, but is it ever delicious.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54218,'Hmm...','Hmm...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54219,'Everything seems to be in order here.','Everything seems to be in order here.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54220,'Sloppy, but adequate.  You seem capable in a fight and in need of direction.\n$bThere are hundreds of demons ahead, it would be suicide to go it alone:','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54221,'Looks good so far.','Looks good so far.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54222,'Interesting...  Very interesting.','Interesting...  Very interesting.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54223,'Come Stormrage, and I will show you what happens to those that betray the lord of the Legion!','',0,0,0,0,0,0,25,0,1,0,26478,0,26124),
(54224,'The shadows will hide us well.\n$bI am concealed by this shadowcloak, and can imbue its magics onto you.\n$bIt will not make us invisible, but as long as we keep our distance from our foes we will remain hidden.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54225,'For you, Azshara.','',0,0,0,0,0,0,0,0,1,0,26134,0,26124),
(54226,'Anything outside of that circle around you will not be able to see you, but the illusion will fade if you attack or take damage.\n$bI suggest you remain hidden until I say otherwise, these demons are too powerful to face head on and in full force.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54227,'','I will handle the demons. Elune, guide my arrows!',0,0,0,0,0,0,6,0,1,0,0,25997,26124),
(54228,'Look at all these adorable animals!','Look at all these adorable animals!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54229,'','Light of Elune, save me!',0,0,0,0,0,0,6,0,1,0,0,25998,26124),
(54230,'Oh... So cute!','Oh... So cute!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54231,'','I will hold them back for now!',0,0,0,0,0,0,6,0,1,0,0,25999,26124),
(54232,'','<Corastrasza steps between you and the nearby corpse, her face wrinkled with concern.>$B$BI\'m sorry, $n. This is a private matter for the red flight to resolve.$B$BPlease see if you can help the others outside.',274,25,0,0,0,0,0,0,1,0,0,0,26124),
(54233,'Tyrande is overwhelmed! Use the Blessing of Elune to drive the demons back!','Tyrande is overwhelmed! Use the Blessing of Elune to drive the demons back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54234,'If only I had more room in my store, I\'d take you all with me to Dalaran.','If only I had more room in my store, I\'d take you all with me to Dalaran.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54235,'Wonderful!','Wonderful!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54236,'Tyrande can hold her own once again!','Tyrande can hold her own once again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54237,'','Lost. Stolen! This is a terrible blow. Terrible!',5,274,0,0,0,0,0,0,1,0,0,0,26124),
(54238,'','We\'ve had no luck tracking down the missing black dragon egg.$B$BHave you discovered anything, $n?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(54239,'Hmm...','Hmm...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54240,'What happened here? What was stolen?','What happened here? What was stolen?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54241,'I wonder how many kegs these animals can hold?','I wonder how many kegs these animals can hold?',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54242,'I wonder how fast these guys can move?','I wonder how fast these guys can move?',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54243,'These are some mighty fine animals...','These are some mighty fine animals...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54244,'','Are you familiar with the late dragon Rheastrasza? A little off, that one. She often lurked about the Badlands in the form of a mortal goblin.$B$BRheastrasza came up with a scheme to steal and purify a black dragon egg, severing its tie with the black dragonflight and the corrupted Earth Warder, Deathwing.',6,1,274,0,0,0,0,0,1,0,0,0,26124),
(54245,'How do we deal with the demons?','How do we deal with the demons?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54246,'I am ready to be hidden by your shadowcloak.','I am ready to be hidden by your shadowcloak.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54247,'Let\'s go!','Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54248,'I...will not...be defeated...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54249,'Mwahahahaha. Had enough, Stormrage?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54250,'How DARE you turn your back on me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54251,'Illidan has been knocked to the ground!  Mannoroth is looking for a new target!','Illidan has been knocked to the ground!  Mannoroth is looking for a new target!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54252,'Illidan has recovered!','Illidan has recovered!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54253,'Light of lights...I have failed you. I am sorry...my Azshara...','',0,0,0,0,0,0,0,0,1,0,26135,0,26124),
(54254,'The sword has pierced his infernal armor! Strike him down!','',0,0,0,0,0,0,0,0,1,0,26095,0,26124),
(54255,'Varo\'then\'s magical sword falls to the ground!','Varo\'then\'s magical sword falls to the ground!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54256,'Lord Sargeras, I will not fail you! Sweep your molten fist through this world, so that it may be reborn in flames and darkness!','',0,0,0,0,0,0,0,0,1,0,26481,0,26124),
(54257,'He is still connected to the Well somehow! Focus your attacks on Mannoroth, we must disrupt his concentration!','',0,0,0,0,0,0,0,0,1,0,26099,0,26124),
(54258,'','Illidan, I am out of arrows! Moon goddess, protect us from the darkness, that we may see your light again another night!',0,0,0,0,0,0,6,0,1,0,0,26000,26124),
(54259,'Yes...yes! I can feel his burning eyes upon me, he is close...so close! And then your world will be unmade, your lives as nothing!','',0,0,0,0,0,0,0,0,1,0,26484,0,26124),
(54260,'A massive demonic portal opens nearby!','A massive demonic portal opens nearby!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54261,'You are not the sole wielder of Sargeras\' power, Mannoroth! Behold!','',0,0,0,0,0,0,0,0,1,0,26096,0,26124),
(54262,'','Illidan...you musn\'t!',0,0,0,0,0,0,6,0,1,0,0,26001,26124),
(54263,'Tyrande collapses!  The Light of Elune winks out!','Tyrande collapses!  The Light of Elune winks out!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(54264,'I will be the savior of our people! I WILL FULFILL MY DESTINY!','',0,0,0,0,0,0,0,0,1,0,26098,0,26124),
(54265,'','No! Illidan!',0,0,0,0,0,0,6,0,1,0,0,26002,26124),
(54266,'[Demonic] Revos ill ok mordanas archim maz naztheros! Archim xi ante maz-re mishun te nagas!','',0,0,0,0,0,0,0,0,1,0,26097,0,26124),
(54267,'We have to keep moving; are you ready?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54268,'Tyrande is imbued with the shining light of the Moon Goddess!','Tyrande is imbued with the shining light of the Moon Goddess!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(54269,'Lead the way.','Lead the way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54270,'','Malfurion, he has done it! The portal is collapsing!',0,0,0,0,0,0,6,0,1,0,0,26003,26124),
(54271,'No...no! This victory will not be ripped from my grasp! I will not return to him in failure! I will not be torn from this pitiful world! No...NOOOOOOOO!!!','',0,0,0,0,0,0,0,0,1,0,26479,0,26124),
(54272,'The Dragon Soul is safe once again. Quickly, into the time portal, before this world sunders!','',0,0,0,0,0,0,457,0,1,0,25960,0,26124),
(54273,'The Dragon Soul\'s link to the portal has been broken!  The Soul plummets downwards towards the Well!','The Dragon Soul\'s link to the portal has been broken!  The Soul plummets downwards towards the Well!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54274,'Over here, in the shadows.','',0,0,0,0,0,0,0,0,1,0,26076,0,26124),
(54275,'The faire seems to bring out all the lookers!','The faire seems to bring out all the lookers!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54276,'So many choices, so little time...','So many choices, so little time...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54277,'I think we stand a better chance fighting alongside one another.','',0,0,0,0,0,0,0,0,1,0,26525,0,26124),
(54278,'Ooo, walk by again, cutie! Your posterior muscles are very finely toned!','Ooo, walk by again, cutie! Your posterior muscles are very finely toned!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54279,'You! The cute one! Would you like to go over to my place and look over my tool collection?','You! The cute one! Would you like to go over to my place and look over my tool collection?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54280,'Sweetie! Hey, $c! Are you interested in a woman able to hold intelligent discourse and look attractive while doing so?','Sweetie! Hey, $c! Are you interested in a woman able to hold intelligent discourse and look attractive while doing so?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54281,'Yoooohoo, you well-proportioned charmer, you!','Yoooohoo, you well-proportioned charmer, you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54282,'Spare some copper?','Spare some copper?',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(54283,'Spare a copper, $G sir:madam;?','Spare a copper, $G sir:madam;?',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(54284,'Come with me if you\'d like to live long enough to see me save this world!','',0,0,0,0,0,0,0,0,1,0,26065,0,26124),
(54285,'Could ye spare some coin?','Could ye spare some coin?',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(54286,'Alms for the poor?','Alms for the poor?',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(54287,'Help a poor bloke out?','Help a poor bloke out?',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(54288,'So many demons, not enough time.','',0,0,0,0,0,0,0,0,1,0,26066,0,26124),
(54289,'I will gladly pay you Tuesday for a hamburger today.','I will gladly pay you Tuesday for a hamburger today.',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(54290,'It\'s all their fault, stupid Alliance army. Just had to build their towers right behind my farm.','It\'s all their fault, stupid Alliance army. Just had to build their towers right behind my farm.',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(54291,'It\'s all their fault, stupid orcs. Had to burn my farm to the ground.','It\'s all their fault, stupid orcs. Had to burn my farm to the ground.',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(54292,'They will get what they deserve, in due time.','',0,0,0,0,0,0,0,0,1,0,26067,0,26124),
(54294,'We\'ve been discovered. I know you\'re tired, but we cannot keep the Aspects waiting!','',0,0,0,0,0,0,0,0,1,0,25882,0,26124),
(54295,'Da faire be easy times for ol\' Griftah...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54296,'I\'ve seen a single Guardian Demon slaughter a hundred elves.  Tread lightly.','',0,0,0,0,0,0,0,0,1,0,26068,0,26124),
(54297,'I will hold them back so we can get past. Be ready.','',0,0,0,0,0,0,0,0,1,0,26063,0,26124),
(54298,'We was travelin\' east, looking for those horkin\' human guys.','',0,0,0,0,0,0,1,0,0,0,31053,0,26124),
(54299,'My magic is fading. I\'m going through!','',0,0,0,0,0,0,0,0,1,0,26064,0,26124),
(54300,'Things was goin\' good, so we decided to split up for a bit.','',0,0,0,0,0,0,1,0,0,0,31054,0,26124),
(54301,'Shokia an\' Kiryn went off to do some girl stuff.','',0,0,0,0,0,0,1,0,0,0,31055,0,26124),
(54302,'Waiting to attack...','',0,0,0,0,0,0,0,0,1,0,26100,0,26124),
(54303,'Time for a drink...','Time for a drink...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54304,'Attack. I don\'t like to be kept waiting.','',0,0,0,0,0,0,0,0,1,0,26081,0,26124),
(54305,'Drink time!','Drink time!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54306,'Drink up!','Drink up!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54307,'Drinking is tiring work... Time to fish!  Wait, that\'s not right... Fishing is boring work, time to drink!','Drinking is tiring work... Time to fish!  Wait, that\'s not right... Fishing is boring work, time to drink!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54308,'I\'ll let you have the first kill.  Don\'t make me regret that.','',0,0,0,0,0,0,0,0,1,0,26082,0,26124),
(54309,'Patience is not one of my virtues.','',0,0,0,0,0,0,0,0,1,0,26083,0,26124),
(54310,'It was just me and Gorrok. I let him take the lead... him bein\' all big and all.','',0,0,0,0,0,0,1,0,0,0,31056,0,26124),
(54311,'After inspecting the statues, we saw this old lady pandaren come out of the house.','',0,0,0,0,0,0,1,0,0,0,31064,0,26124),
(54312,'Be on the lookout for Alliance.','',0,0,0,0,0,0,1,0,0,0,31158,0,26124),
(54313,'','Come on, Kiryn. Let\'s go do girl stuff.',0,0,0,0,0,0,1,0,0,0,0,31532,26124),
(54314,'We will investigate this hut. Perhaps they have seen Alliance survivors.','',0,0,0,0,0,0,1,0,0,0,31159,0,26124),
(54315,'Yeah, the hut! Good idea. You go first.','',0,0,0,0,0,0,1,0,0,0,31058,0,26124),
(54316,'\"Stay out - no visitors.\" Hah!','',0,0,0,0,0,0,1,0,0,0,31160,0,26124),
(54317,'Hey Gorrok, which girl do you like? Shokia or Kiryn?','',0,0,0,0,0,0,1,0,0,0,31061,0,26124),
(54318,'These statues... they\'re almost lifelike. Something\'s wrong here, Riko.','',0,0,0,0,0,0,1,0,0,0,31161,0,26124),
(54319,'You wanna know who I like? I like Kiryn. She\'s got pretty eyes.','',0,0,0,0,0,0,1,0,0,0,31062,0,26124),
(54320,'','Questions? Hah! AHHH HA HA HAAAAA!',0,0,0,0,0,0,1,0,0,0,0,31397,26124),
(54321,'','You, \"orc\", will make an excellent addition to my family!',0,0,0,0,0,0,1,0,0,0,0,31398,26124),
(54322,'So, Gorrok, do you think I have a chance with Kiryn?','',0,0,0,0,0,0,1,0,0,0,31065,0,26124),
(54323,'What the ookin\' hork...?','',0,0,0,0,0,0,1,0,0,0,31066,0,26124),
(54324,'We waiting for tour guide.','We waiting for tour guide.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54325,'Tour guide taking forever...','Tour guide taking forever...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54326,'We just wait for guide.','We just wait for guide.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54327,'We hope guide gets here soon.','We hope guide gets here soon.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54328,'I\'ve been waiting a long time to be on this tour.','I\'ve been waiting a long time to be on this tour.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54329,'I\'m beginning to doubt this tour guide will ever arrive.','I\'m beginning to doubt this tour guide will ever arrive.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54330,'Are you here to lead the tour?','Are you here to lead the tour?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54331,'Are you my tour guide?','Are you my tour guide?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54332,'If you are not here to lead a tour, leave us.','If you are not here to lead a tour, leave us.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54333,'Are you here to lead a tour or gawk at us?  Be gone.','Are you here to lead a tour or gawk at us?  Be gone.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54334,'','The Horde is up to something. They\'ve never attacked our transports directly before.',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(54335,'Did it work?','Did it work?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54336,'','Believe it or not, her plan DID work. She acquired an egg - I\'m still not certain by what means - and claimed to have severed its link to the tainted flight.$B$BThen Deathwing found out about it.$B$BHe cornered Rheastrasza in a cave in the Badlands, destroying her and all of her work. Or so he thought. Rheastrasza had sacrificed her own eggs to fool the Aspect of Death.$B$BThe single, purified black dragon egg was secreted away and hidden!',274,1,5,0,0,0,0,0,1,0,0,0,26124),
(54337,'Of course! I helped her back when I was in the Badlands.','Of course! I helped her back when I was in the Badlands.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54338,'','<Corastrasza does a double-take.>$B$BYou!? YOU helped Rheastrasza? And lived to tell about it?$B$BI underestimate you, $r. No wonder Lord Afrasastrasz sent you to me.$B$BNo doubt you remember what happened next: Rheastrasza was killed by Deathwing, but thanks to her sacrifice a single purified black dragon egg was secreted away and hidden.',5,15,25,0,0,0,0,0,1,0,0,0,26124),
(54339,'What happened to the egg?','What happened to the egg?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54340,'','That\'s why you\'re here, $n. The egg was hidden here at the Vermillion Redoubt. Days ago, it disappeared.$B$BWhoever did it was able to elude our sharpest guards. One of the thieves was killed during the abduction, although now I believe he may have been a diversion - the egg is simply GONE.$B$BOn his corpse we found this note. It remains our only clue, but it is written in a dense code and it MUST be deciphered.',274,1,0,0,0,0,0,0,1,0,0,0,26124),
(54341,'Everything was goin\' great! I felt like we was really bonding.','',0,0,0,0,0,0,1,0,0,0,31060,0,26124),
(54342,'They... they just attacked a ship full of passengers!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(54343,'The Horde seems determined to escalate this war even further and that warchief has his eyes on my homeland!','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(54344,'Five hundred ships at my disposal, yet the one that holds the key to the kingdom is missing. How can this be?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54345,'','We have swept the wreckage for days, Your Majesty. There is no sign of Admiral Taylor or his ships.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54346,'I\'m your man! Give me the coded message.','I\'m your woman! Give me the coded message.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54347,'Lord Afrasastrasz sent me. He said you have a message to decode?','Lord Afrasastrasz sent me. He said you have a message to decode?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54348,'Why does it hurt?!','Why does it hurt?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54349,'','Here\'s what\'s left of the message we found, $n. Can you make any sense of it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54350,'What are you?! Who are you?! Where am I?!','What are you?! Who are you?! Where am I?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54351,'What happened to my clothes?!','What happened to my clothes?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54352,'All I wanted was to visit some friends in the city. I never wanted this! Why is the Horde doing this to us?','',18,5,0,0,0,0,0,0,1,0,0,0,26124),
(54353,'%s summons a Resonating Crystal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54354,'Freeze!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54355,'','Wait!',0,0,0,0,0,0,5,0,1,0,0,27400,26124),
(54356,'','We need to wait for the winds to settle, then make a break for the cover of the far hallway.',0,0,0,0,0,0,1,0,1,0,0,27401,26124),
(54357,'','Wait for another opening. I\'ll meet you on the far side.',0,0,0,0,0,0,1,0,1,0,0,27402,26124),
(54358,'What happened on the Bravery?','What happened on the Bravery?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(54359,'','All right Riko, I think $n has heard enough. Kiryn can tell the next part.',0,0,0,0,0,0,1,0,0,0,0,31533,26124),
(54360,'','Horde warships stopped us and their warriors swarmed over the deck of the Bravery. They took what they wanted and killed those who wouldn\'t cooperate. We were outnumbered...',0,0,0,0,0,0,1,0,1,12951,0,0,26124),
(54361,'Those orcs took my wife and tossed her into the water when she tried to protect the goods we were bringing to Stormwind! You can\'t let them get away with this!','',0,0,0,0,0,0,5,0,1,12951,0,0,26124),
(54362,'','Dafeng! What\'s wrong? Why are you hiding back here?',0,0,0,0,0,0,1,0,1,0,0,27403,26124),
(54363,'I managed to take one of the attackers\' weapons and fight back, but there were too many of them. See? I still have the axe...','',0,0,0,0,0,0,25,0,1,12951,0,0,26124),
(54364,'After they boarded the ship, I closed my eyes and hid. Please don\'t make me talk about it...','',0,0,0,0,0,0,430,0,1,12951,0,0,26124),
(54365,'','We traveled south until night fell. Shokia spoke:',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54366,'','I found a stack of smoke bombs in my pockets. They\'d have to do.$b|TInterface\\Icons\\ability_rogue_smoke.blp:32|t$b',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54367,'','If I encountered enemies, I\'d hit them with the smoke. Shokia\'s sniper rifle would take care of the rest.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54368,'I saw signs of a campfire up ahead, on the eastern side of the statue.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54369,'','UNUSED',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54370,'','At the northern shrine, I found him: a scrawny-looking human soldier.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54371,'','I returned back to camp with my quarry. Shokia would be pleased.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54372,'I can\'t afford to miss another shipment!','I can\'t afford to miss another shipment!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(54373,'If I can\'t move goods to and from Kalimdor, I\'ll be ruined!','If I can\'t move goods to and from Kalimdor, I\'ll be ruined!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54374,'Does King Wrynn even care our plight?','Does King Wrynn even care our plight?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54375,'How am I supposed to run my business with an empty warehouse?','How am I supposed to run my business with an empty warehouse?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(54376,'','All right, Kiryn.',0,0,0,0,0,0,1,0,0,0,0,31534,26124),
(54377,'','Riko.',0,0,0,0,0,0,1,0,0,0,0,31535,26124),
(54378,'','We\'ll set up camp soon. First, we\'ll take advantage of this darkness to do some reconnaissance.',0,0,0,0,0,0,1,0,0,0,0,31536,26124),
(54379,'','Good idea. I\'ll scout that area up ahead.',0,0,0,0,0,0,397,0,0,0,0,31175,26124),
(54380,'And... and I will protect Kiryn from danger.','',0,0,0,0,0,0,1,0,0,0,31067,0,26124),
(54381,'','No, Riko. You stay here. Try not to get anyone killed this time.',0,0,0,0,0,0,274,0,0,0,0,31537,26124),
(54382,'Aww, dooker...','',0,0,0,0,0,0,1,0,0,0,31069,0,26124),
(54383,'','This way, Kiryn.',0,0,0,0,0,0,1,0,0,0,0,31538,26124),
(54384,'','I\'ll cover you from here. It\'s dark, so you\'ll have to mark my targets for me.',0,0,0,0,0,0,1,0,0,0,0,31539,26124),
(54385,'','Rendezvous back here when you\'re done.',0,0,0,0,0,0,1,0,0,0,0,31540,26124),
(54386,'','Don\'t move, human. I\'ve got you cornered.',0,0,0,0,0,0,397,0,0,0,0,31179,26124),
(54387,'How, exactly, do you have me cornered, undead?','',0,0,0,0,0,0,397,0,0,0,27570,0,26124),
(54388,'I see.','',0,0,0,0,0,0,397,0,0,0,27571,0,26124),
(54389,'','You\'re lucky I don\'t kill you right now... you look delicious.',0,0,0,0,0,0,397,0,0,0,0,31181,26124),
(54390,'I see... involved in some shady business, $r? Oh no need to worry - the confidentiality of all transactions is assured.$B$BThis ring you have is a superb piece of work. We can begin the charging process... for a modest fee. Charging the ring will take roughly one half of your world\'s cycles to complete. In other words, twelve hours.$B$BShall we say 10,000 gold? That\'s fair.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(54391,'<Pay the 10,000 gold.>','<Pay the 10,000 gold.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54392,'<The Lorewalker\'s kind eyes rest upon you attentively.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54393,'<Lorewalker Cho watches you with a curious anticipation.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54394,'I wonder what brings you to our lands, stranger.$b$bThe mists of Pandaria will reveal the answer in time...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54395,'Ten thousand!? Outrageous! I\'ll kill you while you sleep!','Ten thousand!? Outrageous! I\'ll kill you while you sleep!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54396,'The more eagerly you seek after a thing, the more it eludes you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54397,'One cannot break Pandaria.$b$bOne can only break one\'s self upon Pandaria.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54398,'Well then.$B$BIt is good that I no longer sleep.','Well then.$B$BIt is good that I no longer sleep.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54399,'Who are you... WHAT are you?','Who are you... WHAT are you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54400,'Deep truths may only be learned through deep questioning.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54401,'Very good, $r! Remember, your ring will not reach its full charge for many hours.','Very good, $r! Remember, your ring will not reach its full charge for many hours.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(54402,'To merely provide an answer teaches nothing.$b$bPandaria is a land of teaching and learning.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54403,'If you truly desire to know such things, the answer shall come to you when you are prepared to receive it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54404,'To ask a thing only begins to prepare the mind to receive the answer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54405,'There is yet much which stands between you and your question\'s answer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54406,'Listen carefully to the silence, $c. What does it say?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54407,'You must learn to ponder, stranger. Your impetuous questions betray a lazy mind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54408,'If I were to answer you now, I would deny you the enlightenment that should be yours.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54409,'These savage primates want to kill us! Tell me... how can we overcome them?','These savage primates want to kill us! Tell me... how can we overcome them?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54410,'Where did this land come from? It seems to have appeared from nowhere!','Where did this land come from? It seems to have appeared from nowhere!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54411,'Never... submit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54412,'Away! Leave us to suffer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54413,'Darkness...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54414,'No peace here... no rest...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54415,'Please... release!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54416,'Riko time! I know what happened next! Pick me! Over here, $n!','',0,0,0,0,0,0,1,0,0,0,31071,0,26124),
(54417,'Word is that I\'m not the only one who can\'t get goods into or out of Kalimdor.','Word is that I\'m not the only one who can\'t get goods into or out of Kalimdor.',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(54418,'How am I supposed to feed my family if I can\'t move my goods?','How am I supposed to feed my family if I can\'t move my goods?',6,0,0,0,0,0,6,0,1,0,0,0,26124),
(54419,'If the king can\'t keep our shipments safe, he has no business on that throne!','If the king can\'t keep our shipments safe, he has no business on that throne!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(54420,'The Horde means to strangle us to death this time. I hope to the Light that the king acts before it\'s too late...','The Horde means to strangle us to death this time. I hope to the Light that the king acts before it\'s too late...',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(54421,'How long will it be before the Horde does to us what it did to Theramore? The king must understand...','How long will it be before the Horde does to us what it did to Theramore? The king must understand...',6,0,0,0,0,0,6,0,1,0,0,0,26124),
(54422,'King Wrynn will listen to you, you\'re a hero to the Alliance!','King Wrynn will listen to you, you\'re a hero to the Alliance!',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(54423,'Don\'t think this\'ll help much, but here\'s my petition.','Don\'t think this\'ll help much, but here\'s my petition.',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(54424,'The Horde has us by the purse, and if the king doesn\'t send his fleet to teach them a lesson, we\'re doomed.','The Horde has us by the purse, and if the king doesn\'t send his fleet to teach them a lesson, we\'re doomed.',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(54425,'','That coded message is the only clue we have.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(54428,'We kept goin\' south, until Shokia started whinin\' about somethin\'.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54429,'Shokia watched the prisoner while Kiryn went ahead.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54430,'Maybe Riko lost temper a little bit.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54431,'Yelling at Shokia wasn\'t doing nothin\'. Riko decided to follow Kiryn.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54432,'I cracked knuckles and got ready for fight.$b|TInterface\\Icons\\inv_gauntlets_05.blp:32|t  |TInterface\\Icons\\inv_inscription_pigment_emerald.blp:32|t$b','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54433,'','Look, up ahead - an Alliance bomber!',0,0,0,0,0,0,25,0,0,0,0,31541,26124),
(54434,'','I see it, Shokia. I\'ll go take a look.',0,0,0,0,0,0,1,0,0,0,0,31184,26124),
(54435,'','Don\'t you dare follow her, Riko. I don\'t want you messing things up again.',0,0,0,0,0,0,274,0,0,0,0,31542,26124),
(54436,'No, you tik-jooglin\' orc! Riko done following you stupid orders!','',0,0,0,0,0,0,1,0,0,0,31074,0,26124),
(54437,'You nothin\' but a blikk-jeekin\', dikkety dook-manker with an ook for a head!','',0,0,0,0,0,0,1,0,0,0,31077,0,26124),
(54438,'','Wha- Help! Help, Shokia! Riko!',0,0,0,0,0,0,1,0,0,0,0,31185,26124),
(54439,'I save you, Kiryn!','',0,0,0,0,0,0,1,0,0,0,31081,0,26124),
(54440,'','Riko, you... you saved my life.',0,0,0,0,0,0,1,0,0,0,0,31186,26124),
(54441,'So... uh... can Riko get a kiss?','',0,0,0,0,0,0,1,0,0,0,31087,0,26124),
(54442,'','Of course. Let me just take off my mask...',0,0,0,0,0,0,1,0,0,0,0,31187,26124),
(54443,'WHAT THE OOK IS WRONG WITH YOUR FACE? YOU\'RE... YOU\'RE JEEKIN\' DEAD?','',0,0,0,0,0,0,1,0,0,0,31088,0,26124),
(54444,'Death to the Legion!','',0,0,0,0,0,0,0,0,1,0,26056,0,26124),
(54445,'Shadowcloak Vanish! PH','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54446,'Follow me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54447,'','If the jinyu set this trap, they\'ll be back soon.$b$b<Kiryn looks up at the horizon in shock.>$b$bDark Lady watch over us... they\'re here. Save yourself, Riko!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54448,'Never! Riko protect you to death!','Never! Riko protect you to death!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54449,'All of a sudden, I heard a noise. Kiryn was trapped! In jinyu nets!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54450,'COME AT ME, BROKKERS!','',0,0,0,0,0,0,1,0,0,0,31084,0,26124),
(54451,'Are you ready?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54452,'Alright! It\'s time to kill some skreekin\' jinyu!','',0,0,0,0,0,0,1,0,0,0,31083,0,26124),
(54453,'Alliance and jinyu... fight side by side?','',0,0,0,0,0,0,1,0,0,0,31085,0,26124),
(54454,'Get away from our plane, hozen scum!','',0,0,0,0,0,0,1,0,0,0,30564,0,26124),
(54455,'AHHHHHH!','',0,0,0,0,0,0,1,0,0,0,31089,0,26124),
(54456,'When I done fightin\', went up to Kiryn to ask for my... reward.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54457,'','The important thing is that these jinyu and Alliance have joined forces. Come speak with me, $n. I can give you the final part of our report.',0,0,0,0,0,0,25,0,0,0,0,31543,26124),
(54458,'Are you ready to continue?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54459,'Move out!','Move out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54460,'','Your Highness, with $n\'s help, I have completed my investigation into what happened aboard the Bravery.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(54461,'','The Horde did attack the ship, preventing it from reaching Teldrassil. But that\'s only the beginning of it...',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(54462,'','Orc ships have begun a blockade of the Kalimdor coastline. No passengers can reach the continent and our merchants cannot move their goods!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(54463,'Oh Syra, Syra. She is the most beautiful person I have ever met and the kindest soul to ever walk Pandaria.$b$bWe want to get married but she is a Goldendraft, and I\'m a Wanderbrew.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54464,'So Garrosh hopes to isolate Kalimdor completely?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(54465,'Stormwind and the Alliance cannot allow them to succeed, but our options are limited. Most of the fleet is being refitted.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(54466,'Admiral, send the remnants of Theramore\'s fleet to assist the night elves and issue letters of marque to any captains willing to take up our cause.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(54467,'','I will make the arrangements right away, my king. I know several captains that we might persuade to help us in dealing with this blockade...',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(54468,'Destroy the crystal so we can move on.','',0,0,0,0,0,0,0,0,1,0,26103,0,26124),
(54469,'','We set up a small camp in the hills above the jinyu village.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54470,'','With nobody to watch over our prisoner, I had to make sure he was... incapable of escaping.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54471,'Wha-?','',0,0,0,0,0,0,1,0,0,0,27572,0,26124),
(54472,'','I approached my sniper rifle and took aim at the jinyu village.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54473,'','Kiryn had made it to the jinyu village. I spotted her lurking in some bushes on the village\'s edge.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54474,'','Straining my eyes, I could just barely read her lips, as she said:',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54475,'','Shoot all the guards, so I can move ahead!',0,0,0,0,0,0,1,0,0,0,0,31188,26124),
(54476,'','Nice work back there! One more time!',0,0,0,0,0,0,1,0,0,0,0,31189,26124),
(54477,'','Let\'s see if my hozen poison works on jinyu! Try not to blow me up, Shokia!',0,0,0,0,0,0,1,0,0,0,0,31190,26124),
(54478,'','The center of the jinyu village was clear. Just to be safe, Kiryn planted some explosive barrels for me to shoot.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54479,'','That\'ll teach the jinyu and the Alliance to mess with us! Let\'s get out of here!',0,0,0,0,0,0,1,0,0,0,0,31192,26124),
(54480,'','Shokia, they\'ve spotted me! Give me cover!',0,0,0,0,0,0,1,0,0,0,0,31193,26124),
(54481,'','The coast was clear. Kiryn began to make her escape.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54482,'','Damn, another jinyu net! We were so close, too...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54483,'','I sensed a commotion in the village\'s eastern island.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(54484,'I\'M BACK, YOU DOOKERS!','',0,0,0,0,0,0,1,0,0,0,31090,0,26124),
(54485,'I on way, Kiryn! And I don\'t care about you weird dead face!','',0,0,0,0,0,0,1,0,0,0,31091,0,26124),
(54486,'','Riko...',0,0,0,0,0,0,1,0,0,0,0,31194,26124),
(54487,'Come on, Kiryn! Let\'s get the ook outta here!','',0,0,0,0,0,0,1,0,0,0,31092,0,26124),
(54488,'','Gah!',0,0,0,0,0,0,1,0,0,0,0,32035,26124),
(54489,'Look out!','',0,0,0,0,0,0,0,0,1,0,25873,0,26124),
(54490,'Another ambush. Watch your backs!','',0,0,0,0,0,0,0,0,1,0,25875,0,26124),
(54491,'Take a moment to catch your breath before we move on.','',0,0,0,0,0,0,0,0,1,0,25876,0,26124),
(54492,'Show yourself!','',0,0,0,0,0,0,0,0,1,0,25877,0,26124),
(54493,'My friend, today we will face one of the greatest and most diabolical of brewmasters the pandaren have ever known.$b$bThere are few who have not heard of the dangers of his brews and yet despite that he is able to dupe people and animals alike into tasting his beverages.$b$bHe must be stopped!  Are you with us?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54494,'I am with you!','I am with you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54495,'You\'re a mere mortal. It is time you died like one.','',0,0,0,0,0,0,0,0,1,0,25804,0,26124),
(54496,'Enough, Shaman!','',0,0,0,0,0,0,0,0,1,0,25807,0,26124),
(54497,'None will survive!','',0,0,0,0,0,0,0,0,1,0,25808,0,26124),
(54498,'The Shaman is mine, focus on his companions!','',0,0,0,0,0,0,0,0,1,0,25809,0,26124),
(54499,'Mere mortals.','',0,0,0,0,0,0,0,0,1,0,25803,0,26124),
(54500,'Your Shaman can\'t protect you.','',0,0,0,0,0,0,0,0,1,0,25805,0,26124),
(54501,'The Aspects misplaced their trust.','',0,0,0,0,0,0,0,0,1,0,25806,0,26124),
(54502,'Nothing! Nothing....','',0,0,0,0,0,0,0,0,1,0,25797,0,26124),
(54503,'My blades hunger.','',0,0,0,0,0,0,0,0,1,0,26057,0,26124),
(54504,'','Sure, we found an Alliance prisoner of war... but at what price?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54505,'','Lok\'tar, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54506,'Riko\'s got a lot to think about.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54507,'What the jeek are you lookin\' at?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54508,'','Our prisoner is strange. He carries no weapon, and his garb is... untraditional.$b$bPerhaps he\'s a lord of some kind. With any luck, we might have captured someone valuable!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54509,'','Riko is... well, he\'s the most mature hozen I\'ve met so far, which isn\'t saying much.$b$bHe\'s really not as bad as Shokia makes him out to be. I actually think he\'s kind of sweet... in a hozen sort of way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54510,'They come endlessly from the palace.','',0,0,0,0,0,0,0,0,1,0,26069,0,26124),
(54511,'We\'re leaving. Stay close.','',0,0,0,0,0,0,0,0,1,0,26055,0,26124),
(54512,'The stench of sulfur and brimstone... These portals are as foul as the demons themselves.','',0,0,0,0,0,0,0,0,1,0,26070,0,26124),
(54513,'Attack the demon soon, or I will.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54514,'Cut this one down from the shadows.','',0,0,0,0,0,0,0,0,1,0,26071,0,26124),
(54515,'Hi I\'m Jian!  Did we meet before?  You have one of those faces.  Like things with faces have...','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(54516,'<Na Lek smiles at you, and you feel young as though you have not felt in years.>','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(54517,'I\'m thirsty!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(54518,'Hold this rope and don\'t be heavy.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54519,'Who is that? What do you want? Don\'t look at me!','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(54520,'Can you help me clense the lake?','Can you help me clense the lake?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54521,'Can\'t you see I want to be alone? What\'s the meaning of this disturbance?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(54522,'The grand admiral asked me to give you these bottles and to ask you to consider joining our efforts against the Horde.','The grand admiral asked me to give you these bottles and to ask you to consider joining our efforts against the Horde.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54523,'So the grand admiral knows about my... affliction, does she? I didn\'t know she cared!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(54524,'Enough hiding. It\'s time to take the fight to the iron dwarves.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54525,'%s scratches himself furiously.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54526,'Wait, these... these are the remedies I need. How did she know?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(54527,'Tell your admiral that if this works, my ship and crew will be at her command.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(54528,'I can\'t wait for all this infernal itching to be gone and to have my lustrous coat back! You have what you wanted. Begone!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(54529,'This won\'t hurt a bit.','',0,0,0,0,0,0,0,0,1,0,26058,0,26124),
(54530,'Can I get another parachute?','Can I get another parachute?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54531,'','Thank you for coming so quickly, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54532,'\'Tis a brave $r who comes between ol\' Ardan and his drink. What can I do fer you?','\'Tis a brave $r who comes between ol\' Ardan and his drink. What can I do fer you?',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(54533,'Yea?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54534,'Can I get another parachute?','Can I get another parachute?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54535,'Grand Admiral Jes-Tereth sent me to ask you to join the fleet in breaking the Horde blockade of Kalimdor.','Grand Admiral Jes-Tereth sent me to ask you to join the fleet in breaking the Horde blockade of Kalimdor.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(54536,'Challenge accepted! Hit for hit, drink for drink.','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(54537,'Now, I haven\'t had a reason to train me guns on a Horde vessel in a long time...','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(54538,'Sounds like the battle will be fierce and the plunder good!','',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(54539,'Tell ya what, me crewmen are drinkin\' wherever ale can be found in this city. If ya can convince \'em to give up their ales and take up their guns, count me in!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(54540,'You buyin\' the next round?','You buyin\' the next round?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(54541,'Do I know you?','Do I know you?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(54542,'What\'s this about?','What\'s this about?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(54543,'You don\'t look like the barmaid...','You don\'t look like the barmaid...',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(54544,'Too... *hic* much flavor.  Must...rest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54545,'Put down that ale and take up your gun. Your captain\'s shipping out.','Put down that ale and take up your gun. Your captain\'s shipping out.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54546,'Your essence... is MINE.','',0,0,0,0,0,0,0,0,1,0,26132,0,26124),
(54547,'Aye, I\'m ready to smash some Horde ships to splinters!','Aye, I\'m ready to smash some Horde ships to splinters!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(54548,'Aye, I\'ll go, but I\'ll go when I\'m good an\' ready...','Aye, I\'ll go, but I\'ll go when I\'m good an\' ready...',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(54549,'Oh, I\'ll get me gun, and I\'ll shoot ye wit\' it if ye ever interrupt me when I\'m drinkin\' again!','Oh, I\'ll get me gun, and I\'ll shoot ye wit\' it if ye ever interrupt me when I\'m drinkin\' again!',25,0,0,0,0,0,25,0,1,0,0,0,26124),
(54550,'We\'ll made the Horde pay, we will!','We\'ll made the Horde pay, we will!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(54551,'No more shootin\' straw orcs fer me!','No more shootin\' straw orcs fer me!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(54552,'Wooah... Not so fast next time!','Wooah... Not so fast next time!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(54553,'Slow down you big fool!','Slow down you big fool!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(54554,'Give me a warning before you do that!','Give me a warning before you do that!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(54555,'Rrraaaghhh!!','',0,0,0,0,0,0,0,0,1,0,26482,0,26124),
(54556,'If you\'re here to conduct business, say your piece.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54557,'So angry.  We should calm you down with a nice lager... of pain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54558,'Obviously we got off to a bad start.  How about an ale... of more pain?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54559,'Alright, time for the good stuff.  This is my special stout... of suffering!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54560,'Grand Admiral Jes-Tereth is launching a fleet to break the Horde blockade of Kalimdor. Will you join her?','Grand Admiral Jes-Tereth is launching a fleet to break the Horde blockade of Kalimdor. Will you join her?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54561,'I\'d love the opportunity to punish the Horde for this outrage...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(54562,'I\'ll join your fleet if you can best my first officer in battle.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(54563,'Williams, we have a challenger. Show this $c what we\'ll do to the orcs!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(54564,'Enough! I yield to your superior skills.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(54565,'We should join this fleet, captain. The admiral\'s allies are worthy.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(54566,'Welcome child to my humble valley.  It is my goal in life to build a beverage so delicious it will humble any other experience your taste buds have encountered.$b$bMy research is on the verge of something phenominal, that no pandaren can claim to be even close to achieving.','',2,1,0,0,0,0,0,0,1,0,0,0,26124),
(54567,'<You watch in fascination as the creature gracefully carves lines through the air in this cozy cavern. The respite from the violence and turmoil of your last hours is most welcome.$b$bThe being offers no visible acknowledgement of your presence, but a feeling grows within you that he is aware of your every breath.$b$bThinking back to Nazgrim and the others, you consider how best to engage the stranger in conversation.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54568,'Challenge to a tasters\' duel.','Challenge to a tasters\' duel.',2,1,0,0,0,0,0,0,1,0,0,0,26124),
(54572,'The demons are no longer pouring from the palace. We can move ahead.','',0,0,0,0,0,0,0,0,1,0,26074,0,26124),
(54573,'Too easy.','',0,0,0,0,0,0,0,0,1,0,26075,0,26124),
(54574,'Another demon, ready to be slaughtered.','',0,0,0,0,0,0,0,0,1,0,26050,0,26124),
(54575,'They stand unaware that their deaths are moments away.','',0,0,0,0,0,0,0,0,1,0,26101,0,26124),
(54576,'','The herbs from the fire seem to already be healing this animal.  Thank you!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54577,'','$n, you should know that the last sixteen recruits...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54578,'All right everyone, listen up. We\'re entering hostile uncharted territory, far from the Alliance chain of command.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54579,'But sir, there ain\'t any record of land in that region. Where are they?','',0,0,0,0,0,0,0,0,1,0,27836,0,26124),
(54580,'Trad! Renstadt! Nooooooooooooooooooo!','',0,0,0,0,0,0,0,0,1,0,27838,0,26124),
(54581,'You kidding me, Commander? I ain\'t here to babysit some untried newcomer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54582,'How are we supposed to find anything in this mist, anyway?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54583,'','Commander, we\'re picking up an Alliance distress signal ahead.',0,0,0,0,0,0,0,0,1,0,0,27443,26124),
(54584,'','They\'re firing on us, sir!',0,0,0,0,0,0,0,0,1,0,0,27445,26124),
(54585,'','Pull up!',0,0,0,0,0,0,0,0,1,0,0,27444,26124),
(54586,'Looks like the crew here is in trouble.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54587,'We\'d better help them out and worry about the others later. Let\'s go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54588,'My pappy helped build this harbor, you know. Ain\'t she a beauty?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54589,'','You can count on us, sir. We won\'t return without that boy.',0,0,0,0,0,0,0,0,1,0,0,27442,26124),
(54590,'Well I wouldn\'t be surprised if he did. He were a great dwarf!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54591,'','Tell ya what Sully, tell me all about him over a mug of ale when we get back.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54592,'Deal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54593,'What? A Horde ship? HERE?','',0,0,0,0,0,0,0,0,1,0,27837,0,26124),
(54594,'Things that are done, it is needless to speak about... things that are past, it is needless to blame.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54595,'Your blood is MINE, elf!','',0,0,0,0,0,0,0,0,1,0,26483,0,26124),
(54596,'Wake up, stranger! Your snoring is interrupting my studies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54597,'We may have to improvise. Make friends with the locals - whatever it takes to secure a beach-head.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54598,'I wonder. Did my master send you as a distraction from my studies?$b$b...or perhaps you were sent to test my patience.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54599,'Ready to cleanse the lake.','Ready to cleanse the lake.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54600,'What did that Brewmaster do to my water?','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(54601,'This tastes funny...','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(54602,'I\'m ready. Go ahead with your ritual.','I\'m ready. Go ahead with your ritual.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54603,'There\'s an altar nearby where I can conduct the ritual. Let\'s go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54604,'Here we are... Keep them off me while I open the tan-chao, $p!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54605,'Felhounds pour forth from the demon portal!','Felhounds pour forth from the demon portal!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(54606,'Felguard pour forth from the demon portal!','Felguard pour forth from the demon portal!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(54607,'Doomguard pour forth from the demon portal!','Doomguard pour forth from the demon portal!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(54608,'Infernals rain from the sky!','Infernals rain from the sky!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(54609,'','There are too many of them!',0,0,0,0,0,0,22,0,1,0,0,26004,26124),
(54610,'Hey, my stomach\'s grumbling back here. We\'ve been flying for hours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54611,'All right, look sharp. We\'re There should be a land mass nearby where the survivors landed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54612,'','Our systems are jammed, Commander! I can\'t control this plane!',0,0,0,0,0,0,0,0,1,0,0,27447,26124),
(54613,'I don\'t believe it! Alliance colors!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54614,'Over here, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54615,'Taylor must be close by.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54616,'','Ugh! We\'ve been hit!',0,0,0,0,0,0,0,0,1,0,0,27446,26124),
(54617,'You must learn to become one with this land, stranger.$b$bOnly then will its secrets be revealed to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54618,'I am ready for my meditation lesson.','I am ready for my meditation lesson.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54619,'','$p!  I am setting up a sobering fire.  If you need a fresh breath come toward me.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54620,'The amount of time Aysa spends practicing seems excessive... but you can\'t deny the results.  Her form is beautiful.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54621,'Breathe deeply, stranger...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54622,'Clear your mind.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54623,'','With Shadowpour defeated, his title of Brewmaster falls to me.  Now I have to continue to undo the damage he has done to this valley.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54624,'I remember when my shop saw this much traffic...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54625,'It is good to get out of Shattrath every now and then.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54626,'Not an apple cart to be seen...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54627,'So much junk food... But not a single apple.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54628,'And you are certain that Granny Smith has left her apples in our stall all this time?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(54629,'So the fruit vendor was never going to wage war against us?  I find it hard to believe...','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(54630,'If what you say is true about the fruit vendor being an old lady... Bah!  It cannot be true!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(54631,'So my shouting, my rally cries... All for nothing... Everyone must think me a fool...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54632,'','$n sighs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54633,'','$n shakes her head and sighs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54634,'','$n puts her hand to her face and lets out a long sigh.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54635,'Can\'t you see I\'m trying to build ships here? Between you and those night elves, we\'ll never get this project done!','',5,274,0,0,0,0,0,0,1,0,0,0,26124),
(54636,'The warchief wants to know why his ships are delayed.','The warchief wants to know why his ships are delayed.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54637,'The warchief? Big guy, giant spikey shoulderpads, short temper, and a morbid attachment to axes? THAT warchief?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(54638,'Well, uh, the truth is, there were ships. There WERE!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(54639,'Somehow the night elves found out we were going to launch the fleet and they struck! Most of the new ships were burned at anchor in the harbor!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(54640,'I know it\'s too late to save them, but m-maybe you can take out the rest of the attackers...','',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(54641,'Tell the warchief it isn\'t my fault! My guys fought back with mallets or whatever they had at hand, I swear!','',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(54642,'My people will stand idle no longer. The halls of Ulduar shall be cleansed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54643,'I am son of Rik-Rik the Great who fought the evil sky nubs and took their nibs.  He died.  Now I am General.  This is my skything.  Fear the mighty General Rik-Rik Junior.','',1,15,0,0,0,0,0,0,1,0,0,0,26124),
(54644,'I can\'t open the tan-chao while I\'m under attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54645,'You must strive to maintain a balance, no matter your surroundings...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54646,'Did you hear? They\'re safe somewhere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54647,'','You, meet up with Commander Nightwind at the harbor, immediately.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54648,'Mind your own business.','Mind your own business.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(54649,'You have failed yet again, stranger.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54650,'What do you want?','What do you want?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(54651,'Why are you bothering me?','Why are you bothering me?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(54652,'Do you want me to get the grunts?','Do you want me to get the grunts?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(54653,'What is the meaning of this?','What is the meaning of this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54654,'You\'d better leave if you don\'t want an axe through your skull!','You\'d better leave if you don\'t want an axe through your skull!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(54655,'Is this some kind of new $r mating ritual or something? Leave me alone!','Is this some kind of new $r mating ritual or something? Leave me alone!',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(54656,'Don\'t you have business elsewhere?','Don\'t you have business elsewhere?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(54657,'Get away from me before I get angry!','Get away from me before I get angry!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(54658,'Go play under a wagon, peon!','Go play under a wagon, peon!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(54659,'$Cs have no respect these days, I tell you.','$Cs have no respect these days, I tell you.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(54660,'Stop staring at me and go make yourself useful!','Stop staring at me and go make yourself useful!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(54661,'H-how did you find me?','H-how did you find me?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(54662,'Help, $p! I\'m under attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54663,'Get them off me! I need total concentration to open the tan-chao!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54664,'','Oh, a visitor.  I don\'t get many visitors out here.$B$BHungry? I\'ve cooked MANY delightful things, my dear.$B$BNo, no, not the fish. Those are for when I can\'t catch anything tastier, sweetling.',397,396,0,0,2,0,0,0,1,0,0,0,26124),
(54665,'Hmmm, perhaps I was wrong about you, stranger.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(54666,'In the dancing glow, we see an empty bowl. We fill the bowl - it becomes our body. We rest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54667,'Most of my debt was repaid... I think...','Most of my debt was repaid... I think...',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54668,'I didn\'t think anyone would mind if I didn\'t stay to help run the faire.','I didn\'t think anyone would mind if I didn\'t stay to help run the faire.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54669,'My debt was almost repaid.  No one was going to miss those last gold coins...','My debt was almost repaid.  No one was going to miss those last gold coins...',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54670,'Evade, evade!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54671,'We fear not the darkness of this world - we know it is but shadow, cast by the glorious world beyond.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54672,'What in blazes is this?','',0,0,0,0,0,0,0,0,1,0,27840,0,26124),
(54673,'Get us out of here! Lose them in the fog!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54675,'We\'ll have to make an emergency water landing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54676,'','What? Is that....LAND?',0,0,0,0,0,0,0,0,1,0,0,27448,26124),
(54677,'Eject! The engines are going to blow!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54678,'We\'re not gonna make it! I\'m coming ta see you soon, pappy!','',0,0,0,0,0,0,0,0,1,0,27839,0,26124),
(54679,'Let us begin.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(54680,'We fear not the brilliance of the tan-chao - we know it is a path home. The bridge between earth and sky.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54681,'We are the lost. We know not who we are, or where we belong. We wander in darkness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54682,'We see a flicker of flame. It seems far, but we know it to be close.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54683,'He is near, lurking in the shadows... I can sense it.','',0,0,0,0,0,0,0,0,1,0,26118,0,26124),
(54684,'Be on alert.  The portals must not be sealed.','',0,0,0,0,0,0,0,0,1,0,26119,0,26124),
(54685,'You, Felguard.  Hold this area.','',0,0,0,0,0,0,0,0,1,0,26120,0,26124),
(54686,'It is done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54687,'The rest of you, secure the courtyard.','',0,0,0,0,0,0,0,0,1,0,26121,0,26124),
(54688,'No thank you.','No thank you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54689,'What business do ya have wit\' Shadow Hunter Urko\'jin?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(54690,'','Da spirits have blessed this Totem o\' Seafarin\' for Urko\'jin. Dey go with him to battle our enemies.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(54691,'Spiritsage!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54692,'Finally... we\'ll see an end to this torture.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54693,'With this totem, the spirits will bless your participation in the blockade.','With this totem, the spirits will bless your participation in the blockade.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54694,'Da spirits have given me a sign of their favor! My men will join dis blockade.','',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(54695,'Ya have the thanks of my men, $n. This totem be a powerful omen for war.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(54696,'We will show da warchief da valor and skill of da Darkspears!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(54697,'I\'ll follow them soon, but first let me express my grati-','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54698,'I told you I\'d have you, Pei-Zhi. You\'ve set us back thousands of spirits today, but I\'d gladly trade them all to see you bound.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54699,'As for YOU, little $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54700,'%s surveys the corpses littering the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54701,'It\'s no use sending more claws to die at your feet. Instead, I\'ll leave you this warning...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54702,'Run away and don\'t look back. Even you cannot hope to face the product of my next spirit-binding.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54703,'%s looks at Pei-Zhi with a smirk.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54704,'Do I know you?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(54705,'We now hide in shadows, hidden from our enemies.','',0,0,0,0,0,0,0,0,1,0,26054,0,26124),
(54706,'You a slicky little wicket? Hmm?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(54707,'Wikket gunna swim with the slickies!','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(54708,'Thieving wikket not gunna take hozen slickies!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(54709,'Smash the crystal. We need to move.','',0,0,0,0,0,0,0,0,1,0,26104,0,26124),
(54710,'Destroy the portal energy focus!','',0,0,0,0,0,0,0,0,1,0,26105,0,26124),
(54711,'No. General Nazgrim sent me to hire you and your crew for the Kalimdor blockade fleet.','No. General Nazgrim sent me to hire you and your crew for the Kalimdor blockade fleet.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54712,'So many people to tend to...','So many people to tend to...',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54713,'I could never leave an injured friend alone...','I could never leave an injured friend alone...',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54714,'The faire is my family.  I would never leave my family.','The faire is my family.  I would never leave my family.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54715,'So many are in need of help...','So many are in need of help...',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54716,'Shut down the portal and we will continue.','',0,0,0,0,0,0,0,0,1,0,26106,0,26124),
(54717,'Maybe wikket taste like a slicky...','',0,0,0,0,0,0,153,0,1,0,0,0,26124),
(54718,'The war against the orcs, there seems to be no respite.','The war against the orcs, there seems to be no respite.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54719,'So many have died at my hands.  I just wanted to escape those horrors.','So many have died at my hands.  I just wanted to escape those horrors.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54720,'I was promised I would never have to encounter the horrors of war at the faire.','I was promised I would never have to encounter the horrors of war at the faire.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54721,'For the right price, my crew and I will serve.$B$BBecause General Nazgrim is an honorable orc, I will only ask 100 gold initially, with generous hazard pay for myself and my men.','',1,25,0,0,0,0,0,0,1,0,0,0,26124),
(54722,'Very well. You\'ll have your gold.','Very well. You\'ll have your gold.',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(54723,'Then we have a deal. I\'ll see you in battle, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54724,'I joined the faire as a child...','I joined the faire as a child...',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54725,'For most of my life the faire has been my home.','For most of my life the faire has been my home.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54726,'I ran away from my home in Strom after my father tried to kill me.','I ran away from my home in Strom after my father tried to kill me.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54727,'My life before the faire was hard.  I never missed it, or my family.','My life before the faire was hard.  I never missed it, or my family.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54728,'I joined the faire to escape my family.','I joined the faire to escape my family.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54729,'I remember telling Silas, \"I never want to see my family again.\"','I remember telling Silas, \"I never want to see my family again.\"',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54730,'...gunna cook up the slicky wikket and feed \'em to King Ka Ka!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(54731,'I was supposed to get firewood for the campsite...','I was supposed to get firewood for the campsite...',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54732,'I have such a hard time gathering firewood...','I have such a hard time gathering firewood...',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54733,'I thought I saw something in the bushes nearby... Then I suppose I blacked out.','I thought I saw something in the bushes nearby... Then I suppose I blacked out.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54734,'When I woke up, I couldn\'t find my way back to the campsite...','When I woke up, I couldn\'t find my way back to the campsite...',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54735,'I\'m with you, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54736,'Let us shut down this final portal and finish this.','',0,0,0,0,0,0,0,0,1,0,26072,0,26124),
(54737,'Even death will not keep me from my duty to watch over the camp...','Even death will not keep me from my duty to watch over the camp...',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54738,'These woods are dangerous.  A lesson I learned the hard way.','These woods are dangerous.  A lesson I learned the hard way.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54739,'I am to keep a close watch over the camp.','I am to keep a close watch over the camp.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54740,'I don\'t know how long I\'ve been watching over the camp...','I don\'t know how long I\'ve been watching over the camp...',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54741,'I barely survived the shipwreck...','I barely survived the shipwreck...',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54742,'Silas kept me safe from my previous captors...','Silas kept me safe from my previous captors...',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54743,'I saw my captors die horrible deaths.$b$bAnd I laughed.','I saw my captors die horrible deaths.$b$bAnd I laughed.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54744,'The faire kept me from an execution.  It saved my life.','The faire kept me from an execution.  It saved my life.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54745,'Silas was able to repay most of my debt as long as I worked at the faire.','Silas was able to repay most of my debt as long as I worked at the faire.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(54746,'Aaaugh!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(54747,'*hic*... grrrr...*hic*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54748,'*hic*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54749,'*hic*...Rawr?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54750,'The demons should all be leaving. We will be at the palace in no time.','',0,0,0,0,0,0,0,0,1,0,26073,0,26124),
(54751,'Hang in there, Lieutenant!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54752,'Beware of Wolpertingers!  They like to bite when you least expect it.','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(54753,'Hurray for $p!  They let me turn them into a tea bag to fix my lake!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(54754,'Where is my Potato?','',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(54755,'We serve the world\'s TRUE masters! When their rule begins, we will share in their glory!','',396,0,0,0,0,0,0,0,1,0,21412,0,26124),
(54756,'','There was something interesting about those red pandas.  I think I might have an idea on how to fix Brewmaster Shadowpour\'s drinks so they are non-lethally tasty.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54757,'','Between the orchids and the cleaner waters I might have constructed a recipe for the ultimate brew.  I may need to get at Brewmaster Shadowpour\'s still in order to make it work.  To do that, we\'ll need to beat him at his own game.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54758,'','We can use the orchids you gathered to purify the lake in the Valley of the Mad Brewer.  We\'ll need help though.$b$bMy friend Jian is a water sprite that has helped with some of my own brews and is very useful for getting just the right density of water.  He would know how best to distribute these herbs.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54759,'Did Ji send you?  I like Ji!  She is happy face.  The Mad Brewer though, he is a big fat dry face meany!$b$bCan you help make my water friends better?  The dry faced meany put a bunch of nasty stuff in there.','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(54760,'Wikket grook the croc? Nice wikket?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54761,'Wikket savin\' hozen?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54762,'Hozen live to fish another day!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54763,'Wikket grookin\' crocs and savin\' hozen?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54764,'Hozen tellin\' Tooki Tooki wikket grookin\' crocs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54765,'Who are you exactly?','Who are you exactly?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54766,'You hide well, worms.  But how long you can delay your doom?','',0,0,0,0,0,0,0,0,1,0,26123,0,26124),
(54767,'Color.  It gives us contrast, depth, value, and tone.  The simple shift of a hue can move a person to laughter or tears.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54768,'Every line, every stroke, helps define an image. It separates thought from parchment and seizes the attention of a viewer.','',2,1,0,0,0,0,0,0,1,0,0,0,26124),
(54769,'','Another band of Deathwing\'s converts? I\'ll be sure your death is especially painful.',0,0,0,0,0,0,0,0,0,0,0,25966,26124),
(54770,'','Cry havoc!',0,0,0,0,0,0,0,0,0,0,0,25969,26124),
(54772,'','And so ends your story.',1,0,0,0,0,0,0,0,0,0,0,25968,26124),
(54773,'','Watch, heathens, as death surrounds you!',0,0,0,0,0,0,0,0,0,0,0,25970,26124),
(54774,'','This... isn\'t how it\'s supposed to... end.',0,0,0,0,0,0,0,0,0,0,0,25967,26124),
(54775,'Your magic is pathetic. Let me show you mine.','',0,0,0,0,0,0,0,0,1,0,26053,0,26124),
(54776,'Let\'s make a game of this, hmmm? Hide well, worms, and you may yet live a little longer...','',0,0,0,0,0,0,0,0,1,0,26114,0,26124),
(54777,'You dare deny me?!','',0,0,0,0,0,0,0,0,1,0,26116,0,26124),
(54778,'No mortal may stand before me and live!','',0,0,0,0,0,0,0,0,1,0,26112,0,26124),
(54779,'In life I had many cubs, and many grand cubs.  But none of my great grand cubs visit anymore.  Few remember with honor the great Windfur family lineage.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54780,'A conducting crystal overloads!','A conducting crystal overloads!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54781,'You would champion the cause of such a lowly street rat? Very well, best me in combat and I shall consider giving you my blessing.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54782,'Enough!  You win... champion.  Tell that upstart that he has my blessing.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(54783,'Challenge the Pandriarch.','Challenge the Pandriarch.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54784,'Unworthy.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(54785,'That was a fine battle!  The likes of which I have not enjoyed in many decades.  Go and give the boy my blessing.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(54786,'Disappointing.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(54787,'Strength!  That is the lifeblood of the Bramblestaff family.  My lineage lives today as a testament of physical greatness willing to take on any challenger.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(54788,'A Wanderbrew wants to marry an Goldendraft?! Preposterous.','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(54789,'I yield!  The boy chose his champion well. Give him my blessing and make sure he does not squander it.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(54790,'I can see you.','',0,0,0,0,0,0,0,0,1,0,26122,0,26124),
(54791,'Some champion.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(54792,'I watch as my lineage is reduced to a faded memory around me.  Once the greatest of all brewmasters we now stand backstage to the Stormstouts.  Bah!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54793,'I hear on the wind that you have helped my great great grand-daughter Ji achieve her dream of becoming a brewmaster.$b$bI am quite proud of her and very thankful to you for your aid.  You have helped put my family name back on the right track.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54794,'I hear you are responsible for saving one of my youngest descendants from the clutches of the Jade Witch.  I thank you for your heroism.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(54795,'You are leaving?','You are leaving?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54796,'I wish to speak with your chief.','I wish to speak with your chief.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54797,'May your waters never run dry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54798,'Behold the Gong of Hope!  Though really we replaced the gong with a bell many centuries ago.  The old gong was quite small and did not provide the proper level of hope infusion to our people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54799,'Are you interested in bell and gong lore?  Not as many young ones are willing to take such a fascinating intellectual journey these days.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54800,'Pardon me traveller, but did you happen to bring any bamboo up from the forest below?  I spend all day staring at it, drooling, hungry to no avail.  Yet all I have to eat up here is what I can conjour from my limited magics.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54801,'<Miss Fanny stares forward resolutely. She is dedicated to her job.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54802,'<Miss Fanny looks at you expectantly.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54803,'Hit it with average power.','Hit it with average power.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54804,'Hit it very softly.','Hit it very softly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54805,'Hit it as hard as possible.','Hit it as hard as possible.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54806,'Hit it with average power.','Hit it with average power.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54807,'Hit it very softly.','Hit it very softly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54808,'Hit it as hard as possible.','Hit it as hard as possible.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54809,'Hit it with average power.','Hit it with average power.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54810,'Hit it very softly.','Hit it very softly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54811,'Hit it as hard as possible.','Hit it as hard as possible.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54812,'ENOUGH! It is time to end this game!','',0,0,0,0,0,0,0,0,1,0,26117,0,26124),
(54813,'Hit me with average power!','Hit me with average power!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54814,'Hit me softly!','Hit me softly!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54815,'Hit me as hard as you possibly can!','Hit me as hard as you possibly can!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54816,'The shadows serve ME, now...','',0,0,0,0,0,0,0,0,1,0,26133,0,26124),
(54817,'I will find you!','',0,0,0,0,0,0,0,0,1,0,26124,0,26124),
(54818,'The shadows will not save you.','',0,0,0,0,0,0,0,0,1,0,26125,0,26124),
(54819,'Cower in hiding, heh.','',0,0,0,0,0,0,0,0,1,0,26126,0,26124),
(54820,'','Ah. Well. That was even easier than I thought!',333,392,0,0,1,0,392,0,1,0,0,25820,26124),
(54821,'','You\'re much... better... than I thought...',0,0,0,0,0,0,0,0,1,0,0,25817,26124),
(54822,'','Tch!  So soon?',0,0,0,0,0,0,0,0,0,0,0,25821,26124),
(54823,'','I hope your friends can do better.',0,0,0,0,0,0,0,0,0,0,0,25822,26124),
(54824,'','Mmm, too much fun!',0,0,0,0,0,0,0,0,0,0,0,25823,26124),
(54825,'','Good night...',0,0,0,0,0,0,0,0,0,0,0,25824,26124),
(54826,'','Bye-bye.',0,0,0,0,0,0,0,0,1,0,0,25825,26124),
(54827,'','Surprise.',0,0,0,0,0,0,0,0,1,0,0,25827,26124),
(54828,'','Now you see me...',0,0,0,0,0,0,0,0,1,0,0,25826,26124),
(54829,'Nothing will stop me. Not even you, demon.','',0,0,0,0,0,0,0,0,1,0,26049,0,26124),
(54831,'Return to the shadows!','',0,0,0,0,0,0,0,0,1,0,26048,0,26124),
(54832,'My strength returns.','',0,0,0,0,0,0,0,0,1,0,26102,0,26124),
(54833,'Who shut down the portals? Clever little worms.','',0,0,0,0,0,0,0,0,1,0,26127,0,26124),
(54834,'None will reach the palace without besting Peroth\'arn, first of fel-touched!','',0,0,0,0,0,0,0,0,1,0,26128,0,26124),
(54835,'Explain your presence.','',0,0,0,0,0,0,0,0,1,0,26080,0,26124),
(54836,'Talk with me now.','',0,0,0,0,0,0,0,0,1,0,26523,0,26124),
(54837,'Are you here to help?','',0,0,0,0,0,0,0,0,1,0,26524,0,26124),
(54838,'The hunter became the prey.','',0,0,0,0,0,0,0,0,1,0,26051,0,26124),
(54839,'You did well, but for now I must continue alone.  Good hunting.','',0,0,0,0,0,0,0,0,1,0,26052,0,26124),
(54840,'Whoa! I feel great!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54841,'I\'ve got to get back to work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54842,'I\'ve never felt better! Thank you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54843,'I feel as good as new! My thanks, stranger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54844,'Work, work, work! I love to work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54845,'%s begins to transform everybody into puppets! You must interrupt her!','%s begins to transform everybody into puppets! You must interrupt her!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54846,'|TInterface\\Icons\\ability_warrior_bloodnova.blp:20|tThe %s is injured and sprouts |cFFFE9A2EBlistering Tentacles|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54847,'|TInterface\\Icons\\ability_vehicle_sonicshockwave.blp:20|t%s begins to cast |cFFFF0000|Hspell:103678|h[Cauterize]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54848,'Slickies?','',7,0,0,0,0,0,0,0,1,0,0,0,26124),
(54849,'You should only see this once.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54850,'Saw slicky with three eyes.  Bad sign.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54851,'No tanks.  Watching figure.','',274,1,0,0,0,0,0,0,1,0,0,0,26124),
(54852,'Had a slicky that tasted like jangos.','',0,1,0,0,0,0,0,0,1,0,0,0,26124),
(54853,'Slicky not so slick now eh?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54854,'Hozenball!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(54855,'Wake up, stranger! What are you doing in my house?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54856,'Who stole my slicky?','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(54857,'Dook if I know.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(54858,'Ask Super Dooker Rik-Rik.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(54859,'Who are you... WHAT are you?','Who are you... WHAT are you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54860,'What is this land? Why has its presence been hidden for centuries?','What is this land? Why has its presence been hidden for centuries?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54861,'How can I help the jinyu win against those monkey savages?','How can I help the jinyu win against those monkey savages?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54862,'Can you help me find the White Pawn?','Can you help me find the White Pawn?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54863,'Examines a steaming pile of smelly stuff on the ground.','',479,0,0,0,0,0,0,0,1,0,0,0,26124),
(54864,'Someone lost their derk?','',378,0,0,0,0,0,0,0,1,0,0,0,26124),
(54865,'I cannot fill a cup that is already overflowing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54866,'First, you must become an empty vessel.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54867,'Get back onto the plainshawk\'s back!','Get back onto the plainshawk\'s back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54868,'Ookin\' slicky? Nookanookanooka!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54869,'Ookin\' wikket gronkin\' hozen? Grookie wikket!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54870,'Their fate is sealed.','',0,0,0,0,0,0,0,0,1,0,26040,0,26124),
(54871,'Leave nothing but smoldering husks.','',0,0,0,0,0,0,0,0,1,0,26041,0,26124),
(54872,'I cannot fill a cup that is already overflowing. Before you can gain wisdom, you must become an empty vessel.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54873,'Gimme all your vegetables!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54874,'AIIIIEEEEEEE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54875,'%s feels players on his left side. He\'s about to roll left!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54876,'This virmen land!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54877,'You no take carrot! You take turnip instead!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54878,'%s feels players on his right side. He\'s about to roll right!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54879,'%s rolls left!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54880,'%s rolls right!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54881,'Hello, friend. Care to purchase anything while you\'re here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54882,'I\'ve put my son, Ang, in charge of my vegetable farm, just down the hill. My nephew Liang runs the pig farm down to the west, and his father - my brother - maintains a small sheep ranch to the south of that.$b$bMy farming days are over. These days, I just gather the harvested crops and sell them to folks headed down this road. Less time on my feet, more money in my pocket.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54883,'Take their slickies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54884,'Not gonna jorb my jangos!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54885,'Hozen and wikket... friends?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54886,'You been savin\' hozen, wikket?$b$bWikket loves hozen?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54887,'Hozen startin\' to like wikket.$b$bWikket maybe not so bad...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54888,'The mist senses your presence!','The mist senses your presence!',0,0,0,0,0,0,0,0,1,0,12197,12197,26124),
(54889,'Mist gathers around you.','Mist gathers around you.',0,0,0,0,0,0,0,0,1,0,12197,12197,26124),
(54890,'All around you, the mist grows denser.','All around you, the mist grows denser.',0,0,0,0,0,0,0,0,1,0,12197,12197,26124),
(54891,'The mist envelops you in its grip!','The mist envelops you in its grip!',0,0,0,0,0,0,0,0,1,0,12197,12197,26124),
(54892,'Out of the mist, a creature emerges!','Out of the mist, a creature emerges!',0,0,0,0,0,0,0,0,0,0,12197,12197,26124),
(54893,'The mist dissipates...','The mist dissipates...',0,0,0,0,0,0,0,0,0,0,12112,12112,26124),
(54894,'%s levels out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54897,'I destroyed twenty hozen before my capture!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54898,'Lucky for you I\'m in this cage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54899,'My people and their new allies will burn this village to the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54900,'Hozen! Your time is short. We have new allies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54901,'You\'re a funny lookin\' jabber.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54902,'Let\'s move out, friend! There\'s no time to lose.','',0,0,0,0,0,0,0,0,1,0,26393,0,26124),
(54903,'Corastrasza is understandably upset. Under her care was the one black dragon egg that we believe was free of the taint of Deathwing\'s corruption...','',0,0,0,0,0,0,0,0,1,0,26394,0,26124),
(54904,'...and it was stolen away from us by thieves in the night!','',0,0,0,0,0,0,0,0,1,0,26395,0,26124),
(54905,'You\'ve found for us our only lead. The rogues from Ravenholdt are behind this.','',0,0,0,0,0,0,0,0,1,0,26396,0,26124),
(54906,'Ravenholdt? It just doesn\'t make sense! A mongrel band of petty thieves. How did they even KNOW about the egg?','',0,0,0,0,0,0,0,0,1,0,26397,0,26124),
(54907,'We\'ll get to the bottom of this. Someone with your skills is exactly what we need.','',0,0,0,0,0,0,0,0,1,0,26398,0,26124),
(54908,'What\'s the expression? \"To catch a thief,\" they say?','',0,0,0,0,0,0,0,0,1,0,26399,0,26124),
(54909,'Look at this devastation. These foothills have never recovered from the campaigns of the second and third wars.','',0,0,0,0,0,0,0,0,1,0,26400,0,26124),
(54910,'Ruins and debris litter the landscape... and I consider the thieves and assassins of Ravenholdt to be part of that debris.','',0,0,0,0,0,0,0,0,1,0,26401,0,26124),
(54911,'Without a state... without a cause... what drives them, do you wonder?','',0,0,0,0,0,0,0,0,1,0,26402,0,26124),
(54912,'And what possessed them to strike out against the red dragonflight? Madness. We must learn more!','',0,0,0,0,0,0,0,0,1,0,26403,0,26124),
(54913,'We\'re almost to Ravenholdt Manor.','',0,0,0,0,0,0,0,0,1,0,26404,0,26124),
(54914,'If they have the egg, it\'s too dangerous to risk an all-out assault. You\'ll need to sneak in there, find out what they\'re up to... And retrieve the egg at any cost.','',0,0,0,0,0,0,0,0,1,0,26405,0,26124),
(54915,'Quiet now! We\'ll form up a plan within this cave...','',0,0,0,0,0,0,0,0,1,0,26406,0,26124),
(54916,'Hide, worms! The hunt is on...','',0,0,0,0,0,0,0,0,1,0,26115,0,26124),
(54917,'Hear from Yoggtard? He owes me nibs.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54918,'This place is GREAT! Have you seen how much FOOD they have here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54919,'Sure, the others might have gone off on exciting adventures, but I don\'t mind. I\'m perfectly happy right here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54920,'The long walk from the monastery was murder on my feet - and on my appetite. I think I\'ll spend a while here loading up on energy before I think about standing up again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54921,'This is a family farm, in case you haven\'t noticed yet. We Thunderfoots don\'t fight, don\'t explore... we don\'t even drink that much.$b$bWe do enjoy our food, however.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54922,'Running a pig farm is more work than you\'d think... though most of it can be boiled down to \"find more food for the pigs.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54923,'Ahh! Hawks!$b$bAHHHH! WOLVES!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54924,'I can\'t take much more of this! Am I really supposed to go fight those wolves?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54925,'My sheep! Someone, do something!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54926,'','Come ON, Uncle Chen! What are we waiting for?',0,0,0,0,0,0,1,0,1,13101,0,30375,26124),
(54927,'Relax, Li Li. We have all the time in the world to explore Pandaria. Take some time to enjoy the trip.','',0,0,0,0,0,0,1,0,1,13101,29671,0,26124),
(54928,'','I would enjoy the trip more if we were actually GOING somewhere!',0,0,0,0,0,0,1,0,1,13101,0,30376,26124),
(54929,'','Can we go yet? Are you done with your beer?',0,0,0,0,0,0,20,0,1,18353,0,30379,26124),
(54930,'Almost.','',0,0,0,0,0,0,0,0,1,18353,29673,0,26124),
(54931,'','How about now?',0,0,0,0,0,0,1,0,1,18353,0,30380,26124),
(54932,'','Let\'s get going! There\'s a whole big valley waiting for us, but you\'re too focused on the bottom of that mug to see it.',0,0,0,0,0,0,0,0,1,13118,0,30385,26124),
(54933,'Yes, Li Li, but the bottom of this mug is very interesting to me.','',0,0,0,0,0,0,11,0,1,13118,29679,0,26124),
(54934,'','I\'ll leave without you. Don\'t think I\'m bluffing. I don\'t need some smelly old uncle to hold my hand.',0,0,0,0,0,0,1,0,1,13118,0,30386,26124),
(54935,'Why are you so impatient? Are you worried that the mists are going to come back before I finish my drink?','',0,0,0,0,0,0,0,0,1,13118,29680,0,26124),
(54936,'','Well, NOW I am!',0,0,0,0,0,0,15,0,1,13118,0,30387,26124),
(54937,'','Here we are, FINALLY setting foot in our ancestral home, for the first time in our lives, and you want to stop and rest by a PIG FARM?',0,0,0,0,0,0,1,0,1,13117,0,30383,26124),
(54938,'Be patient, Li Li. If we explore Pandaria too quickly, we will quickly run out of Pandaria to explore.','',0,0,0,0,0,0,0,0,1,13117,29678,0,26124),
(54939,'','That... barely even makes sense! You\'re just saying that because you\'re lazy and old!',0,0,0,0,0,0,15,0,1,13117,0,30384,26124),
(54940,'[TEMP] CAN I STAY HERE OK THANKS','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54941,'I have but helped you begin your journey. Great rewards await you, but whether you finish it is up to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54942,'You have a strong presence about you, stranger. I am not yet certain whether you will bring light or shadow to this land, but I do know that you are strong of heart.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54943,'I am not fond of strangers, but I see great potential within you. Yes...you may be a most interesting student.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54944,'I need another Dream Brew, Master.','I need another Dream Brew, Master.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54945,'No! My sheep!','',0,0,0,0,0,0,0,0,1,13146,0,0,26124),
(54946,'H-h-hey! Bring that back!','',0,0,0,0,0,0,0,0,1,13146,0,0,26124),
(54947,'Oh no...','',0,0,0,0,0,0,0,0,1,13146,0,0,26124),
(54948,'I\'m sorry, little sheep!','',0,0,0,0,0,0,0,0,1,13146,0,0,26124),
(54949,'G-g-go away! Bring my sheep back!','',0,0,0,0,0,0,0,0,1,13146,0,0,26124),
(54950,'C-c-come back here! That\'s my sheep!','',0,0,0,0,0,0,0,0,1,13146,0,0,26124),
(54951,'Oh my, this is bad...','',0,0,0,0,0,0,0,0,1,13146,0,0,26124),
(54952,'Francis! We need to talk!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54953,'Come see me when you are finished, $n. I live in the small farmhouse, just down the road.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54954,'Uh-oh... here comes the master now...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54955,'|TInterface\\Icons\\inv_gizmo_supersappercharge.blp:20|t%s is casting |c0087CEFA|Hspell:105845|h[Nuclear Blast]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54956,'Wei, are these friends of yours?','',0,0,0,0,0,0,6,0,1,0,28120,0,26124),
(54957,'The Vermillion Redoubt is our base of operations here in the Twilight Highlands.$B$BFrom this perch we can supervise the assault on Grim Batol and the cleansing of the river valley below.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(54958,'Hail, $r! If you\'re looking for Corastrasza, she\'s just inside.$B$B<Mostrasz shifts his weight uncomfortably.>$B$BShe\'s not in a very good mood.','',1,274,0,0,0,0,0,0,1,0,0,0,26124),
(54959,'$n! Great work decoding the message. Let\'s get to the bottom of this.$B$BAre you ready to fly?','',1,25,0,0,0,0,0,0,1,0,0,0,26124),
(54960,'I\'m ready! Let\'s go to Ravenholdt.','I\'m ready! Let\'s go to Ravenholdt.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54961,'I... I can\'t believe you did that! You could have died up there! The way you were wrestling with that eagle, and how you used its wings to land safely... it was amazing!$b$bIf you can do something like that, then... then I can handle some measly wolves and plainshawks! This is the dawn of a new Francis.$b$bAnd it\'s all thanks to you, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54962,'Did... did he just say I was like a son to him?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54963,'Wow, you\'re not like anything I\'ve seen before!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54964,'You look really scary! Good thing my brother said you are friendly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54965,'Did you really save my brother? That idiot got himself captured by the hozen. He\'s lucky he met you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54966,'How do you swim in all those clothes?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54967,'(Awesome completion event here where Huo gets re-ignited and flares up, then expresses appretiation in some non text-based form)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54968,'(Fancy completion event where temple braziers are re-ignited and the accomplishments are recognized)','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(54969,'%s calls upon the |cFF9932CD|Hspell:104896|h[Purple]|h|r, |cFF088A08|Hspell:104898|h[Green]|h|r, and |cFF0080FF|Hspell:104900|h[Blue]|h|r Bloods of Shu\'ma!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54971,'It is time. Sully and I are leaving to scout the interior of the island.','',0,0,0,0,0,0,0,0,1,0,27708,0,26124),
(54972,'If there\'s any sign of Anduin, we\'ll find it.','',0,0,0,0,0,0,0,0,1,0,27709,0,26124),
(54973,'I swear I will keep him safe. We will return as soon as we can.','',0,0,0,0,0,0,0,0,1,0,27710,0,26124),
(54975,'$n, stay here and help Taylor recover.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54976,'Make friends with the jinyu. We may need them before this mission is over, and that\'s an order.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54977,'Wait! Even though we are not friends, you should not go into unfamiliar territory alone.','',0,0,0,0,0,0,0,0,1,0,30634,0,26124),
(54978,'%s calls upon the |cFF088A08|Hspell:104898|h[Green]|h|r, |cFFFF0404|Hspell:104897|h[Red]|h|r, and |cFF424242|Hspell:104894|h[Black]|h|r Bloods of Shu\'ma!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54979,'I will send my brother to go with you.','',0,0,0,0,0,0,0,0,1,0,30635,0,26124),
(54980,'%s calls upon the |cFF088A08|Hspell:104898|h[Green]|h|r, |cFFFFA901|Hspell:104901|h[Yellow]|h|r, and |cFFFF0404|Hspell:104897|h[Red]|h|r Bloods of Shu\'ma!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54981,'Please bring him back safely. He is young, but clever. He can help you find your way.','',0,0,0,0,0,0,0,0,1,0,30636,0,26124),
(54982,'%s calls upon the |cFF9932CD|Hspell:104896|h[Purple]|h|r, |cFF0080FF|Hspell:104900|h[Blue]|h|r, and |cFFFFA901|Hspell:104901|h[Yellow]|h|r Bloods of Shu\'ma!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54983,'%s calls upon the |cFF0080FF|Hspell:104900|h[Blue]|h|r, |cFF424242|Hspell:104894|h[Black]|h|r, and |cFFFFA901|Hspell:104901|h[Yellow]|h|r Bloods of Shu\'ma!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54984,'%s calls upon the |cFF9932CD|Hspell:104896|h[Purple]|h|r, |cFFFF0404|Hspell:104897|h[Red]|h|r, and |cFF424242|Hspell:104894|h[Black]|h|r Bloods of Shu\'ma!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54985,'Hmm, you want... me?','',0,0,0,0,0,0,0,0,1,0,29867,0,26124),
(54986,'Rell lowers his voice to a whisper.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54987,'<The body has been very badly burned and nearly bitten in half.>$B$B<The red dragonflight may be the guardians of all life on Azeroth, but clearly they are not to be crossed.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54988,'Shortly after you disappeared into the jungle, rescued soldiers began returning to us at Paw\'don. It wasn\'t difficult to track you here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54989,'You were the one that rescued Admiral Taylor? So the jinyu was telling the truth...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54990,'(Completion event where Ox cart tries to roll Wugou over, ropes snap, Wugou snores loudly and doesn\'t wake)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54991,'%s snorts loudly, and continues sleeping.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54992,'(Event where Shu splashes Wugou with a giant ball of water, Wugou wakes, then starts chasing Shu around town)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(54993,'','It feels like we were in that forest forever. Let\'s go! We\'ve got to explore the valley!',0,0,0,0,0,0,1,0,1,13101,0,30377,26124),
(54994,'Do not be too hasty, Li Li. This is how I traveled Kalimdor: one stop at a time.','',0,0,0,0,0,0,1,0,1,13101,29672,0,26124),
(54995,'','No wonder it took you so long, then. You can\'t explore anything sitting on your butt.',0,0,0,0,0,0,11,0,1,13101,0,30378,26124),
(54996,'','Chen, I think I know why you like it here so much.',0,0,0,0,0,0,1,0,1,18353,0,30381,26124),
(54997,'Why is that, Li Li?','',0,0,0,0,0,0,0,0,1,18353,29675,0,26124),
(54998,'','Because those two guys make you feel skinny.',0,0,0,0,0,0,25,0,1,18353,0,30382,26124),
(54999,'Why would I want to feel skinny? Size is strength.','',0,0,0,0,0,0,23,0,1,18353,29676,0,26124),
(55000,'Look at Xiao over there. He understands the value of a big belly.','',0,0,0,0,0,0,0,0,1,18353,29677,0,26124),
(55001,'(Event where Shang speaks of Shen-zin Su and how you\'re going to talk to him, then plants his staff and passes on)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55002,'','You are our first turn of good fortune in several days. We\'re glad to have the help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55003,'Very well. Let us proceed.','',0,0,0,0,0,0,0,0,1,0,29868,0,26124),
(55004,'My father? What good is it to speak to him?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55005,'While the hozen pillage our supplies and kill our warriors, what does he do? Nothing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55006,'He sits idly on his chieftain\'s chair, content to mask his cowardice with dreams of peace!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55007,'The hozen do not understand peace! They will slaughter our village until none of us remain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55008,'I...I am sorry for my outburst, $n. My father and I disagree on many things.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55009,'I owe you a great debt for saving my life. Of course I will help you gain audience with the Elder.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55010,'Feedin\' time for da furries.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(55011,'Finds one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55012,'Shiny!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55013,'Hee hee!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55014,'Catch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55015,'Wheee!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55016,'Alley-OOP!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55017,'Gots it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55018,'Yay!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55020,'Munchy munchy!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(55021,'Look! Here comes Miss Fanny right now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55022,'','I believe I heard some young whipper snapper in my garden out back.  Let\'s go look for him.',1,0,0,0,0,0,1,0,1,0,0,31394,26124),
(55023,'|TInterface\\Icons\\spell_fire_moltenblood.blp:20|t%s begins to |cFFFF0000|Hspell:105863|h[Hemorrhage]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55024,'I doubt that we will ever win against the hozen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55025,'Look around you. See how the waters bring life.$B$BWe are grateful for our blessings, and we rejoice in our people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55026,'It has been a long time since we welcomed visitors to our village.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55027,'Once, when I was young, I dreamt of ending this war against the hozen. Now, I fear I will not see such a day before my death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55028,'It is rude to speak to jinyu of a higher rank than yourself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55029,'Only those of the highest esteem may speak to the elder.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55030,'The elder is very busy with important matters. Please come back at another time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55031,'I have brought the items for the ceremony.','I have brought the items for the ceremony.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55032,'Brother, I see great darkness looming before you.','',0,0,0,0,0,0,1,0,1,0,29539,0,26124),
(55033,'Everywhere I look, the rivers have dried.','',0,0,0,0,0,0,0,0,1,0,29540,0,26124),
(55034,'But there is yet one path, one river, that may carry you through these difficult times.','',0,0,0,0,0,0,0,0,1,0,29541,0,26124),
(55035,'Powerful strangers come from across the sea. Seek their strength. Add it to our own.','',0,0,0,0,0,0,0,0,1,0,29542,0,26124),
(55036,'Or else great darkness looms in the days ahead...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55037,'I see great darkness looming in the days ahead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55038,'We jinyu do not cower in fear of defeat. Neither do we fight simply for victory.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55039,'We fight because we believe in what we fight for.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55040,'You must decide, young Lu. What is worth fighting for?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55041,'What is worth dying for?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55042,'We fight so that our children can live better lives than ours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55043,'We fight so that sacrifices of our ancestors were not in vain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55044,'There are a thousand reasons, but you must decide what is worth fighting for.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55045,'Ancient spirits of water.','',0,0,0,0,0,0,0,0,1,0,29517,0,26124),
(55046,'Hear my echo through the silent deeps.','',0,0,0,0,0,0,0,0,1,0,29518,0,26124),
(55047,'Awaken from the great waters beyond.','',0,0,0,0,0,0,0,0,1,0,29519,0,26124),
(55048,'Aid your children in this time of need!','',0,0,0,0,0,0,0,0,1,0,29520,0,26124),
(55049,'A great darkness? Could he mean that we must trust these strangers... these... Alliance... after all?','',0,0,0,0,0,0,0,0,1,0,29521,0,26124),
(55050,'Perhaps I have been too shrouded in my own doubts and fears.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55051,'I must become a better leader for our tribe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55052,'Thank you for your counsel. I will meditate on it deeply.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55053,'Ancient spirits of water!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55054,'Stay on the ground, and stay hidden. I\'ll port you back here if you get into any trouble!','',0,0,0,0,0,0,0,0,1,0,26414,0,26124),
(55055,'Da slickies win.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(55056,'Ooked my dookin\' slickies.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(55057,'|TInterface\\Icons\\INV_Misc_Food_Vendor_PinkTurnip.blp:64:64:100:0|t$b$b<What would you like Miss Fanny to do to the turnip?>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55058,'|TInterface\\Icons\\INV_MISC_FOOD_VENDOR_STRIPEDMELON.BLP:64:64:100:0|t$b$b<What would you like Miss Fanny to do to the watermelon?>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55059,'|TInterface\\Icons\\inv_guild_cauldron_b.blp:64:64:100:0|t$b$b<What would you like Miss Fanny to do to the extra-spicy tofu?>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55060,'Whoah there, Miss Fanny. Maybe that was too hard.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55061,'Miss Fanny, you stronger than that! Try and put a little more ook in it next time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55062,'Easy, Miss Fanny. You hit watermelons too hard... they go boom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55063,'Ahhhh ha ha ha ha! It barely even go halfway down the hill!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55064,'Whoah. Nice shootin\', Miss Fanny!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55065,'Good bonk, Miss Fanny! You got nice control!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55066,'Nice, Miss Fanny! You hit it strong!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55067,'Hey, $gmister:lady;, what you doing? You gonna get yourself killed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55068,'<Miss Fanny looks you in the eye and subtly turns her head. Does... does she want to launch YOU?>$b$b<Assuming that you have correctly interpreted her intentions, how hard should Miss Fanny hit you?>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55069,'Over here!','',0,0,0,0,0,0,0,0,1,0,32863,0,26124),
(55070,'','Can we go yet? Are you done with your beer?',0,0,0,0,0,0,1,0,1,13118,0,30379,26124),
(55071,'Almost.','',0,0,0,0,0,0,0,0,1,13118,29673,0,26124),
(55072,'','How about now?',0,0,0,0,0,0,1,0,1,13118,0,30380,26124),
(55073,'','Come ON, Uncle Chen! What are we waiting for?',0,0,0,0,0,0,15,0,1,13117,0,30375,26124),
(55074,'Relax, Li Li. We have all the time in the world to explore Pandaria. Take some time to enjoy the trip.','',0,0,0,0,0,0,1,0,1,13117,29671,0,26124),
(55075,'','I would ENJOY the trip more if we were actually GOING somewhere!',0,0,0,0,0,0,1,0,1,13117,0,30376,26124),
(55076,'You and all your friends are welcome to stay here for as long as you like.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55077,'Does all of this farmland belong to you?','Does all of this farmland belong to you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55078,'Hey! Got out of here!','',0,0,0,0,0,0,0,0,1,13147,0,0,26124),
(55079,'Stay away from my sheep!','',0,0,0,0,0,0,0,0,1,13147,0,0,26124),
(55080,'Come back here, you coward!','',0,0,0,0,0,0,0,0,1,13147,0,0,26124),
(55081,'Bring back my sheep!','',0,0,0,0,0,0,0,0,1,13147,0,0,26124),
(55082,'Get back over here, thief!','',0,0,0,0,0,0,0,0,1,13147,0,0,26124),
(55083,'Despair...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55084,'You will not take our waters!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55085,'A worthy sacrifice for our master.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55086,'Darkness awaits...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55087,'The corruption will consume you, as it consumed us...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55088,'The waters are forbidden to all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55089,'In the end, only silence remains.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55090,'The living are not welcome here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55091,'Recovering','Recovering',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55092,'Time to die, turnip!','',0,0,0,0,0,0,0,0,1,13744,0,0,26124),
(55093,'Attack turnips!','',0,0,0,0,0,0,0,0,1,13744,0,0,26124),
(55094,'Kill ALL the turnips!','',0,0,0,0,0,0,0,0,1,13744,0,0,26124),
(55095,'First kill turnips! Then kill pandaren that grows them!','',0,0,0,0,0,0,0,0,1,13744,0,0,26124),
(55096,'We murder every turnip!','',0,0,0,0,0,0,0,0,1,13744,0,0,26124),
(55097,'Turnips! Why you so bad?','',0,0,0,0,0,0,0,0,1,13744,0,0,26124),
(55098,'Turnips must be punished!','',0,0,0,0,0,0,0,0,1,13744,0,0,26124),
(55099,'Pandaren pay for growing disgusting turnips!','',0,0,0,0,0,0,0,0,1,13744,0,0,26124),
(55100,'Be at peace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55101,'Be cleansed, spirit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55102,'Shadows, begone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55103,'Be at peace, spirit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55104,'I am finally...free...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55105,'My boat winning!','',0,0,0,0,0,0,0,0,1,13153,0,0,26124),
(55106,'The light...returns...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55107,'I think my boat stuck.','',0,0,0,0,0,0,0,0,1,13153,0,0,26124),
(55108,'Watermelon boats float really easy.','',0,0,0,0,0,0,0,0,1,13153,0,0,26124),
(55109,'Use the waters well. They are priceless beyond compare...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55110,'Thank you, stranger...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55111,'Look how slow your boat go.','',0,0,0,0,0,0,0,0,1,13153,0,0,26124),
(55112,'The shadows are gone...the corruption is lifted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55113,'Time to steal more watermelon soon.','',0,0,0,0,0,0,0,0,1,13153,0,0,26124),
(55114,'We protect the waters. From greed, from darkness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55115,'Gonna need more boats soon.','',0,0,0,0,0,0,0,0,1,13153,0,0,26124),
(55116,'Boats go faster if take leafs off.','',0,0,0,0,0,0,0,0,1,13153,0,0,26124),
(55117,'Go, go, go!','',0,0,0,0,0,0,0,0,1,13153,0,0,26124),
(55118,'You dare to disturb these waters? You will drown!','',0,0,0,0,0,0,0,0,1,0,28257,0,26124),
(55121,'','Shoo!',0,0,0,0,0,0,0,0,1,13092,0,0,26124),
(55122,'','Go away, marmots!',0,0,0,0,0,0,0,0,1,13092,0,0,26124),
(55123,'','Stay out of our crops!',0,0,0,0,0,0,0,0,1,13092,0,0,26124),
(55124,'','Shoo, shoo!',0,0,0,0,0,0,0,0,1,13092,0,0,26124),
(55125,'Defeat the Great White Plainshawk!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55126,'$n, we meet again! You looking for Shang? I think he\'s in back, polishing his melon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55127,'Finally! To be free from the grip of that darkness. The light! The blessed, beautiful light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55128,'A thousand lifetimes ago, I brought the waters here. A gift to the Pearlfin for ancient deeds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55129,'We guarded the waters. Too dangerous, too powerful, to fall into the wrong hands.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55130,'Then the darkness came. It seeped from the ground. Slowly, it infected us...suffocated us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55131,'Even after our mortal flesh had rotted away, it leeched hope from our souls. It was unending!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55132,'I shudder at the thought. An ancient evil. An enemy of Pandaria. I will not speak their name.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55133,'What happened to you, master?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55134,'What was the darkness that corrupted you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55135,'Perhaps this one will know something about the poem. Be cleansed, spirit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55136,'It looks like our paths have crossed again, $n. At a pig farm, of all places.$b$bI enjoy this valley. It almost feels like... home. The green fields, the big sky... I have even heard mention that there\'s a big brewery down the road. Maybe it is time I settled down once and for all.$b$b<Chen looks off into the distance for a few long seconds, then shrugs his shoulders.>$b$bOr maybe not.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55137,'Little hand says it\'s time to rock and roll. Everyone into the hold: We\'ve got a dragon to kill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55138,'FOR THE HORDE!','FOR THE HORDE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55139,'I... I am in your debt.','I... I am in your debt.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55140,'','Ji may kill Shen-zin Su if we let him go through with this! Come with me, $p, quickly!',0,0,0,0,0,0,5,0,1,0,0,27412,26124),
(55141,'Woah... get away from me, crazy... spider-thing!','Woah... get away from me, crazy... spider-thing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55142,'Ah! It\'s comin\' right for me!','Ah! It\'s comin\' right for me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55143,'Why did it have to be spiders?!','Why did it have to be spiders?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55144,'Ahh, get these things away from me!','Ahh, get these things away from me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55145,'No! I don\'t want to be nibbled!','No! I don\'t want to be nibbled!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55146,'Grr... get a little closer, critter. I\'ll bite yer legs off!','Grr... get a little closer, critter. I\'ll bite yer legs off!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55147,'%s huffs and puffs, trying to blow at the $n.','%s huffs and puffs, trying to blow at the $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55148,'%s struggles to turn his face away from the $n.','%s struggles to turn her face away from the $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55149,'I have never seen a place like this. Have you, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55150,'The pandaren are full of ancient knowledge. Lina has been teaching me the medicinal uses of the local herbs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55151,'Where do you think the pandaren came from? Why have they been hidden for so long?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55152,'Someday, Ren is going to show me his family\'s village.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55153,'How is my father? I hope he is not too worried. He worries too much about me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55154,'My father doesn\'t think so, but I can take care of myself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55155,'I don\'t want to go home quite yet. There\'s still so much to see and learn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55156,'It is time to go home, Prince Anduin.','It is time to go home, Prince Anduin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55157,'<Ren tosses about deliriously. His brow is hot with fever.>$B$BWa....water...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55158,'','Any friend of Anduin\'s is a friend of ours, $c. My father would not be here without him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55159,'I am sorry, but I cannot go back just yet.','',0,0,0,0,0,0,0,0,1,0,27573,0,26124),
(55160,'I\'ve decided to search for the Vale. I must find the Sacred Pools and study their healing powers.','',0,0,0,0,0,0,0,0,1,0,27574,0,26124),
(55161,'Prince Anduin, we\'ve come to take ye home.','',0,0,0,0,0,0,0,0,1,0,27841,0,26124),
(55162,'Come quietly, now.','',0,0,0,0,0,0,0,0,1,0,27842,0,26124),
(55163,'I\'m sorry, but I won\'t. I\'m sure you understand my reasons.','',0,0,0,0,0,0,0,0,1,0,27575,0,26124),
(55164,'Eh? Oh...uh...you\'re absolutely right, Prince Anduin. You are free to go as you please.','',0,0,0,0,0,0,0,0,1,0,27843,0,26124),
(55165,'Come on, let\'s go.','',0,0,0,0,0,0,0,0,1,0,27576,0,26124),
(55166,'','Sully! How could you just let him go?',0,0,0,0,0,0,0,0,1,0,0,27473,26124),
(55167,'Eh? What happened?','',0,0,0,0,0,0,0,0,1,0,27844,0,26124),
(55168,'','You silly dwarf, he mind controlled you! Now he\'s gone!',0,0,0,0,0,0,0,0,1,0,0,27474,26124),
(55169,'','I hope you\'re ready to explain this to Admiral Taylor!',0,0,0,0,0,0,0,0,1,0,0,27475,26124),
(55170,'Whaaa? I can\'t believe he did that ta me!','',0,0,0,0,0,0,0,0,1,0,27845,0,26124),
(55171,'Find your soul to break the curse!','Find your soul to break the curse!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55172,'','Who would have thought these creatures could be reasoned with?',396,0,0,0,0,0,396,0,1,0,0,0,26124),
(55173,'Nazgrim has assigned you to scout the region, Shokia. You are to depart shortly.','Nazgrim has assigned you to scout the region, Shokia. You are to depart shortly.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(55174,'','I\'ll make ready.$b$bIt will be good to get away from these savages for a time.',396,0,0,0,0,0,396,0,1,0,0,0,26124),
(55175,'This will take some getting used to.$b$bI struggle to resist the urge to rip the heads from these creatures.','',396,0,0,0,0,0,396,0,1,0,0,0,26124),
(55176,'Nazgrim has assigned you to help scout the region, Gorrok. You are to depart shortly.','Nazgrim has assigned you to help scout the region, Gorrok. You are to depart shortly.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(55177,'A shame. I could use a bit of rest.$b$bNo matter. Tell Nazgrim that I will accompany the party.','',113,0,0,0,0,0,396,0,1,0,0,0,26124),
(55178,'','You know, these little guys aren\'t so bad once you get to know them...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(55179,'Nazgrim has assigned you to the scouting party, Kiryn. You are to depart shortly.','Nazgrim has assigned you to the scouting party, Kiryn. You are to depart shortly.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(55180,'','Well of course he did. He\'d be a fool not to.$b$bThank you, $r. I\'ll prepare to depart at once.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(55181,'Much obliged, stranger.','Well thankee, friend!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55182,'I weren\'t scurred...','Oof, that\'s better... How\'s my hair?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55183,'I gotta tell my cubs about this! Of course, I\'ll change the part where their paw-paw got stuck...','That\'s it: I\'m demanding hazard pay after this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55184,'Never thought I\'d need a $c to save me from nibblers. Thank you!','My favorite kind of $c: the brave, rescue-y type!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55185,'The stench of Alliance scum is in the air.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(55186,'Oh, I was just resting... I rest sometimes... under rocks...','I was JUST about to wiggle myself free... I think.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55187,'I\'ll check in with Hao. Thank you!','Foreman\'s gotta be fumin\' right now. Glad yer dealin\' with her and not me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55188,'Wikket smart to be friend to hozen.$b$bNow, one less wikket hozen have to smash.','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(55189,'Big Chief Kah Kah, we will be exploring your lands and could use a good guide. Will you help us?','Big Chief Kah Kah, we will be exploring your lands and could use a good guide. Will you help us?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55190,'Today it\'s cave-ins and nibblers, tomorrow it\'ll be floods and jinyu. Just another day at the quarry.','I ain\'t settin\' foot in this place ever again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55191,'I better be getting overtime for this.','I better be getting overtime for this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55192,'Hmm.$b$b<You wait patiently for Chief Kah Kah to think, then wait some more for him to speak.>$b$bKah Kah have many nephews. They all have earned their name name.$b$bGrookin home to one who has not yet earned his name name....$b$bRiko been a little too frisky - even for a hozen. Maybe long walk do him some good.','',396,396,5,0,2000,1000,396,0,1,0,0,0,26124),
(55193,'I\'ve got you. That was close!','',0,0,0,0,0,0,0,0,1,0,26407,0,26124),
(55194,'You need to be careful - they\'re on full alert!','',0,0,0,0,0,0,0,0,1,0,26408,0,26124),
(55195,'Well... That got ugly. You\'re lucky I\'m here.','',0,0,0,0,0,0,0,0,1,0,26409,0,26124),
(55196,'You weren\'t trying to pick their pockets, were you?','',0,0,0,0,0,0,0,0,1,0,26410,0,26124),
(55197,'Gotcha! Let\'s try that again...','',0,0,0,0,0,0,0,0,1,0,26411,0,26124),
(55198,'Thank you for bringing my driver back, friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55199,'Thief. Thief!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55200,'Over here - get $ghim:her;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55201,'Intruder!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55202,'I see you, fool!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55203,'You cannot...escape!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55204,'Hurry, $p! We have to start the smelling... I mean, the shelling!','',0,0,0,0,0,0,5,0,1,13190,0,0,26124),
(55205,'You\'ve been trained well.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(55206,'Well fought. Master Shang will be pleased.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(55207,'Amazing! You\'re much stronger than you look.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(55208,'It seems I have more training to do. Thank you for the lesson.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(55209,'I bow to your skill. You bested me fairly.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(55210,'It was an honor to be defeated by you.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(55211,'HNNGGG!!!','',0,0,0,0,0,0,0,0,1,0,32864,0,26124),
(55212,'Ahh, there we go. Told you I had it!','',0,0,0,0,0,0,0,0,1,0,32865,0,26124),
(55213,'I\'m sure you can handle things in here. I\'ll be outside settling things down.','',0,0,0,0,0,0,1,0,1,0,32866,0,26124),
(55214,'','Is there anyone in need of medical aid?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55215,'','The jinyu may not seem welcoming, but I do believe we prove our good intentions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55216,'','A medic\'s work is never done.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55217,'','The longer I stay here, the more I am charmed by this strange land.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55218,'','Do you think we will ever find a way home?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55219,'','I have never failed a mission in many years, $n. I am not about to do so now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55220,'','The Admiral is gravely wounded, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55221,'','The Admiral is very, very fortunate that you arrived when you did.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55222,'','Judging from his injuries, the Admiral was cruelly tortured.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55223,'','The Admiral is very hurt, but not entirely broken. I can fix him, but I\'ll need time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55224,'','I can only describe the Admiral\'s attackers as...savages.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55225,'','Shhh, $n. I will need total concentration to attend these wounds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55226,'','Thank you, $n. Without you, the Admiral would have perished in that filthy pit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55227,'','$n, you are becoming quite a skilled medic. You should continue your first aid training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55228,'','I am afraid the Commander\'s injuries are beyond my aid.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55229,'','It would take a miracle to save the Commander, now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55230,'','I have done all that I can for the Commander. I am afraid it will not be long, now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55231,'I feel fine, $n. Thank you for asking, but there are more important matters at hand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55232,'I have delivered word to Wayward Landing. They should be sending more soldiers shortly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55233,'We must focus on creating a base of operations. Once we have secured our position, then we can spare resources to find a way back home.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55234,'This land is rich in resources, $n. I am preparing a detailed report for our return.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55235,'The natives here are quite friendly. Well, except for those monkeys.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55236,'The jinyu seem to be an ancient race. We will learn their secrets, in time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55237,'I have tried to speak to their chief, but he does not want to see me. It appears I am not \"high status\" enough. Apparently he\'s never seen an Admiral.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55238,'I\'ve been unable to befriend the Glassfin Elder. $C, I\'m counting on you to succeed where I failed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55239,'<Taylor is very sick. It is best not to speak to him now.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55240,'Picking','Picking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55241,'The first step to learning is to admit that you have much to learn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55242,'True wisdom comes from the understanding that you have much to master.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55243,'Come on, come on, come on! They\'ll be here any moment!','',0,0,0,0,0,0,5,0,1,13190,0,0,26124),
(55244,'Wooohwee! Smells like Dalaran Sharp!','',0,0,0,0,0,0,479,0,1,13190,0,0,26124),
(55245,'I\'m not about to let this Alliance scum steal back my prize.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(55246,'So if i just substitute the powder with compressed...fuel, we should be in business! So to speak.','',0,0,0,0,0,0,396,0,1,13190,0,0,26124),
(55247,'Have any more grog?','Have any more grog?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55248,'Assuming this works, I\'ll need a name for my invention. How \'bout... Grookin Grenade?','',0,0,0,0,0,0,6,0,1,13190,0,0,26124),
(55249,'Careful, $p! Methane labs like these can be extremely volatile.','',0,0,0,0,0,0,396,0,1,13190,0,0,26124),
(55250,'Okay, Rivett. I\'m ready!','Okay, Rivett. I\'m ready!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(55251,'You have earned the right to proceed.  Huo lies beyond.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55252,'Carrot appeared!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(55253,'Ooh, carrot!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(55254,'Your training has paid off, young $c. You have found Huo and brought him safely to the temple.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(55255,'Mmm... carrot!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(55256,'Behold as Huo brings warmth back to the temple, and passion to its people.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(55257,'I am proud of what you have accomplished this day.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(55258,'It so fat!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(55259,'The next spirit that awaits you is Shu, the spirit of water. When you are ready, meet Aysa at the Singing Pools to the east.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(55260,'It so juicy!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(55261,'Seems legit.','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(55262,'I love it. I love this carrot.','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(55263,'I think we should eat it.','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(55264,'Let\'s all eat it!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(55265,'NO! It\'s TURNIP!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(55266,'Nooooo!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(55267,'NO! Not turnip!!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(55268,'Who would do this?!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(55269,'Ahh, turnip! Get out of here!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(55270,'Carrot was turnip! Run!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(55271,'I see you\'ve arrived. This is the eve of the sundering, when the collapse of the Well of Eternity fractured the continents of the world.','',0,0,0,0,0,0,0,0,1,0,25961,0,26124),
(55272,'','Someone\'s here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55273,'','Ah - hah! Busted!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55274,'','There\'s a thief over here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55275,'','I got one!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55276,'Don\'t forget to use your stealth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55277,'Are you crazy? They\'ll see you if you go flying around in there!','',0,0,0,0,0,0,0,0,1,0,26412,0,26124),
(55278,'You can\'t fly here. We\'ll be spotted for sure!','',0,0,0,0,0,0,0,0,1,0,26413,0,26124),
(55279,'You are less than dust, fit only to be brushed from my back.','',0,0,0,0,0,0,0,0,1,0,26350,0,26124),
(55280,'What\'s the matter? Alliance can\'t hold their grog? Ha ha ha!','',22,11,0,0,0,0,396,0,1,0,0,0,26124),
(55281,'That\'s it... you\'ve got this... keep it up...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55282,'Careful! The front door is too heavily guarded. Hmmm - Circle around the back of the manor and maybe we can find another way in.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55283,'Where are you going? The manor is in the other direction!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55284,'Hmmmm... it doesn\'t look like there\'s anything over here. Try circling around to the back of the manor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55285,'Ah-hah! There are no guards back here. Maybe you can find a way up onto the roof?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55286,'Nice work! Is there a window open up there? Look around!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55287,'You did it! You\'re in! Now... where would they be keeping the egg? Someplace dark, I would imagine. Be careful!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55288,'I\'m not afraid of you! Wait - who - who are you?','',0,0,0,0,0,0,5,0,1,0,26390,0,26124),
(55289,'But... But Deathwing\'s minions may have you killed...','',0,0,0,0,0,0,5,0,1,0,26391,0,26124),
(55290,'Noble $r, I am sure there is some agreement we can come to for my release.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55291,'We stand in an undiscovered paradise as ancient as the titans themselves and you want to go to war?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55292,'Involving these races in our war? Tarnishing this land with the horrors of warfare?$b$bIs that what you really want?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55293,'So, you\'ve managed to train an army...$b$bAn impressive achievement, but is war really the right course of action?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55294,'Exploiting the hostility between these races is unwise, $r.$b$bYou are going to have to accept responsibility for the consequences.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55295,'You\'ve returned with the spirits of water and earth. You make an old master proud.','',0,0,0,0,0,0,1,0,1,0,27776,0,26124),
(55296,'Wugou and Shu are welcome here. We will care for them well.','',0,0,0,0,0,0,1,0,1,0,27777,0,26124),
(55297,'The only remaining spirit is Dafeng, who hides somewhere across the Dawning Span to the west.','',0,0,0,0,0,0,1,0,1,0,27778,0,26124),
(55298,'I can carry you to the top of the temple. Ji awaits you there to lead the way.','',0,0,0,0,0,0,1,0,1,0,27779,0,26124),
(55299,'Ugh... I think I mighta ooked my dookers.','',0,0,0,0,0,0,396,0,1,13190,0,0,26124),
(55300,'Ook! Dookin\' prarie-doggin\'!','',0,0,0,0,0,0,5,0,1,13190,0,0,26124),
(55301,'Oogh... grooked me bad slickies...','',0,0,0,0,0,0,5,0,1,13190,0,0,26124),
(55302,'Ookin\'s what hozen do best!','',0,0,0,0,0,0,5,0,1,13190,0,0,26124),
(55303,'Mudmug\'s vial will slowly spill water while you are moving. Plan your path carefully!','Mudmug\'s vial will slowly spill water while you are moving. Plan your path carefully!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55304,'Here, we will snatch up the Dragon Soul before it is lost to the mists of time.','',0,0,0,0,0,0,0,0,1,0,25962,0,26124),
(55305,'But first, you must bring down the protective wards of Azshara\'s Highborne lackeys. You will find them within the palace. I will scout on ahead.','',0,0,0,0,0,0,0,0,1,0,25963,0,26124),
(55306,'Good luck, heroes!','',0,0,0,0,0,0,0,0,1,0,25964,0,26124),
(55307,'You!  You have allowed the Sha to reawaken after all these years!','',0,0,0,0,0,0,0,0,1,0,27626,0,26124),
(55308,'If you truly wish to undo what your kind have wrought upon our land you must first prove yourselves here in our school.','',0,0,0,0,0,0,0,0,1,0,27627,0,26124),
(55309,'First, you will face our initiates...','',0,0,0,0,0,0,0,0,1,0,27632,0,26124),
(55310,'Where one falls, another will rise to take their place.','',0,0,0,0,0,0,0,0,1,0,27624,0,26124),
(55311,'You have much to learn if you wish to defend your people from the Sha initiate.  Stand aside for your fellow students!','',0,0,0,0,0,0,0,0,1,0,27625,0,26124),
(55312,'You have bested our most junior of students.  Now you will face two of my most senior.','',0,0,0,0,0,0,0,0,1,0,27631,0,26124),
(55313,'Flying Snow!  Fragrant Lotus!  Step forward!','',0,0,0,0,0,0,0,0,1,0,27636,0,26124),
(55314,'You have bested my prize students. Perhaps you can be of use to us after all...','',0,0,0,0,0,0,0,0,0,0,27633,0,26124),
(55315,'As my master once said, \"You cannot truly know someone until you fight them.\"','',0,0,0,0,0,0,0,0,0,0,27634,0,26124),
(55316,'Even the smoke of their burning camp wreaks of futility and shame.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(55317,'Well done $p. Meet me back at Grookin and we\'ll discuss our next plan of action.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(55318,'Greetings, $n. Are you as thirsty as I am?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55319,'I\'m ready. Let\'s hit the road.','I\'m ready. Let\'s hit the road.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55320,'I am the beginning of the end...the shadow which blots out the sun...the bell which tolls your doom...','',0,0,0,0,0,0,0,0,1,0,26317,0,26124),
(55321,'','I sense a great disturbance in the balance approaching. The chaos of it burns my mind!',0,0,0,0,0,0,0,0,1,0,0,26148,26124),
(55322,'Mere whelps, experiments, a means to a greater end. You will see what the research of my clutch has yielded.','',0,0,0,0,0,0,0,0,1,0,26362,0,26124),
(55323,'For this moment ALONE was I made. Look upon your death, mortals, and despair!','',0,0,0,0,0,0,0,0,1,0,26318,0,26124),
(55324,'Strength of the Earth, hear my call! Shield them in this dark hour, the last defenders of Azeroth!','',0,0,0,0,0,0,0,0,1,0,25907,0,26124),
(55325,'','Take heart, heroes, life will always blossom from the darkest soil!',0,0,0,0,0,0,0,0,1,0,0,26506,26124),
(55326,'','In dreams, we may overcome any obstacle!',0,0,0,0,0,0,0,0,1,0,0,26149,26124),
(55327,'Winds of the arcane be at their backs, and refresh them in this hour of darkness!','',0,0,0,0,0,0,0,0,1,0,26267,0,26124),
(55328,'The cycle of time brings an end to all things.','',0,0,0,0,0,0,0,0,1,0,25954,0,26124),
(55329,'Now is the hour of twilight!','',0,0,0,0,0,0,0,0,1,0,26314,0,26124),
(55330,'But...but...I am...Ul...trax...ionnnnnn...','',0,0,0,0,0,0,0,0,1,0,26316,0,26124),
(55331,'Fall before Ultraxion!','',0,0,0,0,0,0,0,0,1,0,26319,0,26124),
(55332,'You have no hope!','',0,0,0,0,0,0,0,0,1,0,26320,0,26124),
(55333,'Hahahahaha!','',0,0,0,0,0,0,0,0,1,0,26321,0,26124),
(55334,'The final shred of light fades, and with it, your pitiful mortal existence!','',0,0,0,0,0,0,0,0,1,0,26323,0,26124),
(55335,'Lord Deathwing, your gift...it is too much! I am...rrrraaaaagghhh!!','',0,0,0,0,0,0,0,0,1,0,26324,0,26124),
(55336,'Through the pain and fire my hatred burns!','',0,0,0,0,0,0,0,0,1,0,26325,0,26124),
(55337,'I WILL DRAG YOU WITH ME INTO FLAME AND DARKNESS!','',0,0,0,0,0,0,0,0,1,0,26315,0,26124),
(55338,'','|TInterface\\Icons\\inv_misc_head_dragon_01.blp:20|t Alexstrasza summons forth the |cFFFF0000|Hspell:105896|h[Gift of Life]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55339,'','|TInterface\\Icons\\inv_misc_head_dragon_green.blp:20|t Ysera summons forth the |cFF00CC00|Hspell:105900|h[Essence of Dreams]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55340,'|TInterface\\Icons\\inv_misc_head_dragon_blue.blp:20|t Kalecgos summons forth the |cFF0000FF|Hspell:105903|h[Source of Magic]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55341,'|TInterface\\Icons\\inv_misc_head_dragon_bronze.blp:20|t Nozdormu imbues you with a |cFFFFFF00|Hspell:105984|h[Timeloop]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55342,'|TInterface\\Icons\\inv_misc_head_dragon_black.blp:20|t Thrall imbues the tanks with the strength of the earth! You are the |cFF9900CC|Hspell:106218|h[Last Defender of Azeroth]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55343,'|TInterface\\Icons\\spell_fire_twilightimmolation.blp:20|t Ultraxion becomes |cFF9900CC|Hspell:106373|h[More Unstable]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55344,'|TInterface\\Icons\\spell_fire_twilightcano.blp:20|t Ultraxion\'s instability is causing a massive |cFF9900CC|Hspell:106388|h[Twilight Eruption]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55345,'|TInterface\\Icons\\spell_fire_twilightimmolation.blp:20|t Ultraxion reaches |cFF9900CC|Hspell:106395|h[Maximum Instability]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55346,'My duty is to protect my people. If I must be on the frontlines, then I would gladly do so.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55347,'I am a strong jinyu! I can take the brunt of many attacks without fear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55348,'While the enemies are focused on me, my allies can sneak up from behind!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55349,'My sword is quick and my feet steady. Enemies must deal with me first before attacking my allies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55350,'From a young age, I have been drawn to the healing arts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55351,'There are too few who care for the wounded from battle. If I had the skill, I would certainly join them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55352,'I bring bandages and food to the sick and injured. If only I could do more...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55353,'In your land, is it true that healers accompany warriors onto the battlefield? If only I had better tools, perhaps I could do the same.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55354,'Alright boys! Come get some slickies fresh off the grill!','',22,0,0,0,0,0,396,0,1,0,0,0,26124),
(55355,'I prefer to shape the properties of water, and unleash them against my enemies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55356,'I have some skill in the magical arts, but I wish I had more formal training.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55357,'I have had basic warrior training, but no one knows that I have more skill with spellcasting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55358,'I am terrible with a spear. I much prefer ranged combat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55359,'I\'m quick and fast. Put me behind an enemy, and they won\'t even see me coming.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55360,'Being small has its advantages. I can sneak just about anywhere.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55361,'Everyone here gets the standard warrior training, but I think I\'m more suited to stealth missions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55362,'I never meet an enemy head on. I prefer to use my wits...and any number of stealthy tricks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55363,'Wait, I know your face, human. You are the son of Varian Wrynn!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(55364,'Okay, $p. I can only make these so fast... you gotta make every shot count!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(55365,'Hah! Make another demand, princeling, and I\'ll release your head from your shoulders!','',1,11,0,0,0,0,0,0,1,0,0,0,26124),
(55366,'Sir, I demand to be released to my father\'s custody!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(55367,'Alright. I suppose we have stayed here long enough.','',0,0,0,0,0,0,0,0,1,0,29694,0,26124),
(55368,'These Thunderfoots are good people, but they do not have enough ale between them to fill a cask.','',0,0,0,0,0,0,1,0,1,0,29695,0,26124),
(55369,'Let\'s go find something to drink. Shall we, Li Li?','',0,0,0,0,0,0,6,0,1,0,29696,0,26124),
(55370,'','If beer gets you off your butt, then... sure. Let\'s go find you some beer.',0,0,0,0,0,0,1,0,1,0,0,30402,26124),
(55371,'Farewell, Shang!','',0,0,0,0,0,0,3,0,1,0,29697,0,26124),
(55372,'You kids have fun at Mudmug\'s! And thanks again, $n!','',0,0,0,0,0,0,2,0,1,0,31200,0,26124),
(55373,'','Uncle, look. There\'s somebody up ahead. He looks... weird.',0,0,0,0,0,0,25,0,1,0,0,30404,26124),
(55374,'We are the outsiders here, Li Li. We probably look even weirder to him.','',0,0,0,0,0,0,0,0,1,0,29698,0,26124),
(55375,'','Pshh... only because we\'re traveling with this $r!',0,0,0,0,0,0,1,0,1,13211,0,30405,26124),
(55376,'','Sorry, $n, but you do kind of stand out.',0,0,0,0,0,0,6,0,1,13211,0,30408,26124),
(55377,'What\'s this? An Alliance boy? Here?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(55378,'','What? We\'re all pandaren here! Just because we came from the turtle doesn\'t mean we look weird.',0,0,0,0,0,0,15,0,1,13210,0,30406,26124),
(55379,'','Well, $n looks a little weird. Sorry, $n.',0,0,0,0,0,0,0,0,1,13210,0,0,26124),
(55380,'Hallloooo stranger!','',0,0,0,0,0,0,3,0,1,0,29699,0,26124),
(55381,'We are looking for a brewer named Mudmug. Do you know of him?','',0,0,0,0,0,0,6,0,1,0,29700,0,26124),
(55382,'I\'m Mudmug. Who\'s asking?','',0,0,0,0,0,0,273,0,1,0,30972,0,26124),
(55383,'I am called Chen, and this is my niece Li Li.','',0,0,0,0,0,0,2,0,1,0,29701,0,26124),
(55384,'Anduin Wrynn... a fitting reward for the trials we\'ve endured! $p, come, speak with me.','',11,1,0,0,0,0,0,0,1,0,0,0,26124),
(55385,'Hmph. Y\'all any good at fightin\' virmen?','',0,0,0,0,0,0,6,0,1,0,30973,0,26124),
(55386,'','Heck yeah we are! I\'ve probably beaten up about a million virmen back on the Wandering Isle!',0,0,0,0,0,0,1,0,1,0,0,30409,26124),
(55387,'You have a virmen problem? We will be glad to help you, Mudmug.','',0,0,0,0,0,0,66,0,1,0,29702,0,26124),
(55388,'Awright then! My place is just around the corner.','',0,0,0,0,0,0,4,0,1,0,30974,0,26124),
(55389,'Come on! Let\'s get to that critter-whompin\'!','',0,0,0,0,0,0,0,0,1,0,30975,0,26124),
(55390,'','I TOLD you he was weird.',0,0,0,0,0,0,0,0,1,0,0,30411,26124),
(55391,'The girl got it right. Follow me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55392,'','I TOLD you he was weird.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55393,'We\'re catching up to the dragon! I think I can make him out through the cloud cover!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55394,'Bring us in closer!','Bring us in closer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55395,'The shields surrounding the Aspects shatter! The Aspects are vulnerable!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55396,'Outsider, what brings you to our village?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55397,'You must be the outsider that everyone speaks of.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55398,'The hozen came to us once as you do now.$B$BWe felt sorry for them, and taught them how to survive in this land.$B$BOver time, they grew strong and bold, and began to take this land for their own.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55399,'We have been taught not to trust strangers, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55400,'$n, is it? I have heard your name spoken in the village.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55401,'You are the $c, aren\'t you? Thank you for recovering my brother\'s heirloom. It has become my most precious possession.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55402,'Perhaps I was wrong about you, $r. You have already done much to help our village.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55403,'Your people are very interesting, $r. I wish to know more about you and your kind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55404,'Perhaps someday I can visit your village too, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55405,'You have done many good things for our village, $n. Perhaps we can be friends after all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55406,'The shield surrounding the Aspects is destroyed by Ultraxion\'s attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55407,'We have lived on this lake for thousands of years. The waters here flow down from the ancient pools of Pandaria.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55408,'The tribe thanks you for your deeds, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55409,'It is foolish to trust a stranger\'s every word, but it is also foolish to deny those who might be friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55410,'A monstrous force pulls you into the twilight realm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55411,'You did it, $p! I\'m free!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55412,'You might need this shield.','You might need this shield.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55413,'Take this book of healing prayers.','Take this book of healing prayers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55414,'Li Li. A stranger in need is a future friend. That is the wanderer\'s way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55415,'This spellcaster\'s staff is for you.','This spellcaster\'s staff is for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55416,'Will these daggers help?','Will these daggers help?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55417,'Use it or lose it, $gmister:sister;!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(55418,'Incoming!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(55419,'Let\'s hope the wind ain\'t blowin this way...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(55420,'Oh, the things I do for the Horde...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(55421,'Here, $p, catch!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(55422,'This shield is just what I need! Thank you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55423,'This shield will block many mighty blows. Thank you, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55424,'This is just what I needed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55425,'I should begin training immediately.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55426,'That would be better for a healer, not me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55427,'I need something for protection, not this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55428,'I would prefer sturdier equipment than this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55429,'How do I swing this thing? Ouch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55430,'All ahead full. Everything depends on our speed! We can\'t let the Destroyer get away.','',0,0,0,0,0,0,0,0,1,0,26292,0,26124),
(55431,'All hands to battle stations; get those monsters away from the ship!','',0,0,0,0,0,0,0,0,1,0,26294,0,26124),
(55432,'This...this is a weakling\'s weapon! I want something bigger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55433,'Concentrate everything on the armored drake!','',0,0,0,0,0,0,0,0,1,0,26295,0,26124),
(55434,'An enemy sapper\'s breached the engine room!','',0,0,0,0,0,0,0,0,1,0,26296,0,26124),
(55435,'The Skyfire can\'t take much more of this!','',0,0,0,0,0,0,0,0,1,0,26297,0,26124),
(55436,'We\'re going down. Abandon the ship!','',0,0,0,0,0,0,0,0,1,0,26298,0,26124),
(55437,'So much knowledge! I must study this immediately.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55438,'Such a sacred text will not be wasted on me. Thank you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55439,'How will this weapon heal the injured?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55440,'I can\'t use that. I am looking to expand my healing knowledge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55441,'The engines are back online! Full speed ahead! We can\'t let Deathwing escape!','',0,0,0,0,0,0,0,0,1,0,26304,0,26124),
(55442,'Hah! I was hoping you\'d make it this far. You\'d best be ready for a real fight.','',0,0,0,0,0,0,0,0,1,0,26214,0,26124),
(55443,'You won\'t get near the Master. Dragonriders, attack!','',0,0,0,0,0,0,0,0,1,0,26210,0,26124),
(55444,'Well... done, heh. But I wonder if you\'re good enough... to best him.','',0,0,0,0,0,0,0,0,1,0,26211,0,26124),
(55445,'I don\'t think this shield is for me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55446,'Mess with the bull....','',0,0,0,0,0,0,0,0,1,0,26215,0,26124),
(55447,'Down you go!','',0,0,0,0,0,0,0,0,1,0,26217,0,26124),
(55448,'I know we all look alike to you, but I\'m a healer, not a mage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55449,'Get up! Oh... weakling!','',0,0,0,0,0,0,0,0,1,0,26218,0,26124),
(55450,'Ouch! Those blades are sharp!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55451,'If we make it outta here, let\'s keep this part outta the story...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(55452,'Ow...that was an eye. Yes, definitely an eye.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55453,'Goriona! Give them hell!','',0,0,0,0,0,0,0,0,1,0,26219,0,26124),
(55454,'How\'s THIS?','',0,0,0,0,0,0,0,0,1,0,26221,0,26124),
(55455,'COME ON!','',0,0,0,0,0,0,0,0,1,0,26222,0,26124),
(55456,'Looks like I\'m doing this myself. Good!','',0,0,0,0,0,0,0,0,1,0,26212,0,26124),
(55457,'We\'re flying a little too close. It\'s been a good fight, but I\'m ending it, now.','',0,0,0,0,0,0,0,0,1,0,26213,0,26124),
(55458,'Release the doubt from your soul!','Release the doubt from your soul!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55459,'Finally! An upgrade!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55460,'Yes! This weapon is perfect.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55461,'This object is useless to me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55462,'I cannot use this, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55463,'I\'m sorry, but I do not heal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55464,'My skills are better for offense, not defense.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55465,'These daggers are of little use to me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55466,'These daggers are perfect for stabbing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55467,'Yes! Those hozen won\'t know what hit them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55468,'How will I stab my enemies with this?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55469,'No no, not nearly sharp enough.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55470,'This isn\'t a weapon! It\'s just a book!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55471,'How can I stealth around carrying this giant shield?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55472,'Too big. Not pointy enough. I need something small and sharp.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55473,'Mudmug! This is fantastic! Strong, too!','',0,0,0,0,0,0,11,0,1,0,29718,0,26124),
(55474,'Thanks! Most folk \'round here prefer it over anything from that \"Stormstout Brewery\".','',0,0,0,0,0,0,24,0,1,0,30982,0,26124),
(55475,'','Wait... did you say Stormstout Brewery?',0,0,0,0,0,0,6,0,1,0,0,30418,26124),
(55476,'You know of more Stormstouts? Here, in Pandaria?','',0,0,0,0,0,0,6,0,1,0,29719,0,26124),
(55477,'Well shoot, of course! They\'re the biggest brewin\' family in the whole valley!','',0,0,0,0,0,0,404,0,1,0,30983,0,26124),
(55478,'A brewery... my family... my ancestral home!','',0,0,0,0,0,0,273,0,1,0,29720,0,26124),
(55479,'Wait a dang minute - you\'re a Stormstout?','',0,0,0,0,0,0,6,0,1,0,30984,0,26124),
(55480,'Yes I am. Tell me - where is this \"Stormstout Brewery?\" I must see it for myself!','',0,0,0,0,0,0,1,0,1,0,29721,0,26124),
(55481,'You just keep goin\' down this same road, but...','',0,0,0,0,0,0,274,0,1,0,30985,0,26124),
(55482,'I am going. Li Li... you stay here. I will come back for you.','',0,0,0,0,0,0,25,0,1,0,29722,0,26124),
(55483,'Promise me you will keep out of trouble while I am away?','',0,0,0,0,0,0,404,0,1,0,29723,0,26124),
(55484,'','I... yeah, sure. Whatever.',0,0,0,0,0,0,1,0,1,0,0,30419,26124),
(55485,'','I can\'t believe he left me with the weird mud guy.',0,0,0,0,0,0,0,0,1,0,0,30420,26124),
(55486,'<UNUSED> <DO NOT TRANSLATE>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55487,'<UNUSED> <DO NOT TRANSLATE>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55488,'<UNUSED> <DO NOT TRANSLATE>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55489,'<UNUSED> <DO NOT TRANSLATE>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55490,'<UNUSED> <DO NOT TRANSLATE>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55491,'<UNUSED> <DO NOT TRANSLATE>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55492,'','<UNUSED> <DO NOT TRANSLATE>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55493,'<UNUSED> <DO NOT TRANSLATE>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55494,'<UNUSED> <DO NOT TRANSLATE>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55495,'<UNUSED> <DO NOT TRANSLATE>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55496,'','<UNUSED> <DO NOT TRANSLATE>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55497,'<UNUSED> <DO NOT TRANSLATE>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55498,'','<UNUSED> <DO NOT TRANSLATE>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55499,'','Make a run for Dawn\'s Blossom. We\'ll meet you there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55500,'','How did you get up that high?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55501,'','I found us a cool bodyguard didn\'t I?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55502,'Step in close. Engage into his space. Don\'t give him the initiative!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(55503,'Vary your blows. Show your opponent no pattern. Prove his instincts wrong.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(55504,'Don\'t just use the blade. Use the butt of your weapon. Break his nose!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(55505,'Let me see your scowls. Scowl. Scowl harder! You call that a scowl?','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(55506,'Your goal is a silent kill. Screamy, angry kills will do in a pinch.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(55507,'The shins. The face. The crotch. Kick them all, indiscriminately.','',0,0,0,0,0,0,60,0,1,0,0,0,26124),
(55508,'What are you doing, dancing? We\'re studying murder, people! BAH - send in two more.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(55509,'You movements are light, free, flowing ... you would be killed in an instant. Get out of the ring!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(55510,'I like what I\'m seeing here. Did everyone see that? Who is next?','',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(55511,'Very good. Is that blood? On your teeth? Excellent! Bring on two more!','',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(55512,'Ugh, you fight like two gnolls in heat. Distracted. Sloppy. Gibbering. Get out. OUT! Next?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(55513,'','Oh wow! It was like \"Rawwr!\" and you were like \"Kahpowww!\"',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(55514,'','How did you get to be so brave?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(55515,'','I really hope it didn\'t eat any of my friends before you beat it up.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(55516,'Have a drink and rest, traveler.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55517,'Are you finding everything well, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55519,'','I\'ve got your back, $p.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55520,'Come child. We have one final journey to take together before your training is complete.','',0,0,0,0,0,0,1,0,1,0,27797,0,26124),
(55521,'Beyond the Elders\' Path lies the Wood of Staves, a sacred place that only the worthy may enter.','',0,0,0,0,0,0,1,0,1,0,27800,0,26124),
(55522,'Of the many ways to prove your worth, I require the simplest of you now. I must know that you will fight for our people. I must know that you can keep them safe.','',0,0,0,0,0,0,1,0,1,0,27801,0,26124),
(55523,'Defeat the Guardian of the Elders, and we may pass.','',0,0,0,0,0,0,1,0,1,0,27802,0,26124),
(55524,'','Hey! Stop stealing my kills, $p!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55525,'','That was my kill, $p!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55526,'','That one was already in my sights!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55527,'','There are plenty of targets out there for both of us...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55528,'For 3,000 years, we have passed the knowledge of our people down. Elder to youth. Master to student.','',0,0,0,0,0,0,1,0,1,0,27807,0,26124),
(55529,'Every elder reaches the day where he must pass on and plant his stave with the staves of his ancestors. Today is the day when my staff joins these woods.','',0,0,0,0,0,0,1,0,1,0,27808,0,26124),
(55530,'$p, our people have lived the wholes of their lives on this great turtle, Shen-zin Su, but not in hundreds of years has anyone spoken to him.','',0,0,0,0,0,0,1,0,1,0,27809,0,26124),
(55531,'Now Shen-zin Su is ill, and we are all in danger. With the help of the elements, you will break the silence. You will speak to him.','',0,0,0,0,0,0,1,0,1,0,27810,0,26124),
(55532,'Aysa and Ji have retrieved the spirits and brought them here. You are to go with them, speak to the great Shen-zin Su, and do what must be done to save our people.','',0,0,0,0,0,0,1,0,1,0,27811,0,26124),
(55533,'You\'ve come far, my young student. I see within you a great hero. I leave the fate of this land to you.','',0,0,0,0,0,0,396,0,1,0,27812,0,26124),
(55534,'What?! Impossible!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55535,'|TInterface\\Icons\\ability_deathwing_cataclysm.blp:20|t%s begins to cast |cFFFF0000|Hspell:106523|h[Cataclysm]|h|r! Stop Him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55536,'Little spirit, you cannot hide from me in that body!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55537,'You will not interfere again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55538,'My legs feel stiff.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55539,'Wahoo! We did it!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(55540,'','Well done, $p!',0,0,0,0,0,0,21,0,1,0,0,0,26124),
(55541,'','Here kitty kitty.',0,0,0,0,0,0,1,0,1,0,0,31395,26124),
(55542,'','You should join our family, preserved forever in jade.',0,0,0,0,0,0,1,0,1,0,0,31396,26124),
(55543,'','Yay! Shin! You\'re alive!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(55544,'As I expected...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55545,'Yes! Now I am ready for battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55546,'','Thank you so much $p! If you find me in Dawn\'s Blossom later I\'ll give you one of the things we stashed from our adventures.',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(55547,'Sure, let\'s go have a drink.','Sure, let\'s go have a drink.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55548,'$p! Check this thing out!','',0,0,0,0,0,0,5,0,1,0,27295,0,26124),
(55549,'','We\'re ready to go whenever you are, $n.',0,0,0,0,0,0,1,0,1,0,0,27428,26124),
(55550,'I am in pain, but it warms my heart that Liu Lang\'s grandchildren have not forgotten me.','',0,0,0,0,0,0,0,0,1,0,27822,0,26124),
(55551,'','Hop in.',0,0,0,0,0,0,1,0,1,0,0,27429,26124),
(55552,'Or if you want to wander the woods a while, Aysa and I can hang out here.  You know... just the two of us.','',0,0,0,0,0,0,1,0,1,0,27296,0,26124),
(55553,'','Don\'t listen to him.  We\'ve got work to do.',0,0,0,0,0,0,1,0,1,0,0,27430,26124),
(55554,'$p, where\'s Master Shang?','',0,0,0,0,0,0,6,0,1,0,27297,0,26124),
(55555,'','...Ji, they were in the Wood of Staves.  You know where Master Shang is now.',0,0,0,0,0,0,1,0,1,0,0,27431,26124),
(55556,'Bah, let a pandaren hope, would you?  I\'m going to miss the old man.','',0,0,0,0,0,0,1,0,1,0,27298,0,26124),
(55557,'','Hey! Look at that waterfall!',0,0,0,0,0,0,25,0,1,0,0,30421,26124),
(55558,'','I wonder if there\'s a cave behind it.',0,0,0,0,0,0,1,0,1,0,0,30422,26124),
(55559,'','You should always check behind waterfalls for caves.',0,0,0,0,0,0,25,0,1,0,0,30423,26124),
(55560,'','Ji, be respectful when we speak to Shen-zin Su.',0,0,0,0,0,0,1,0,1,0,0,27432,26124),
(55561,'When am I not respectful?  You hurt me, Aysa.','',0,0,0,0,0,0,6,0,1,0,27299,0,26124),
(55562,'','I might if you embarrass us.',0,0,0,0,0,0,1,0,1,0,0,27433,26124),
(55563,'','Shen-zin Su, we are the descendants of Liu Lang.  We\'ve sensed your pain, and we want to help.',0,0,0,0,0,0,1,0,1,0,0,27434,26124),
(55564,'','What ails you Shen-zin Su?  What can we do?',0,0,0,0,0,0,6,0,1,0,0,27435,26124),
(55565,'','Check out all the cool silk!',0,0,0,0,0,0,1,0,1,0,0,30424,26124),
(55566,'','Do you think that they really get this stuff from the silkworms\' rear end?',0,0,0,0,0,0,6,0,1,0,0,30429,26124),
(55567,'','Eww... they look like maggots.',0,0,0,0,0,0,0,0,1,0,0,30441,26124),
(55568,'There is a thorn in my side.  I cannot remove it.','',0,0,0,0,0,0,0,0,1,0,27823,0,26124),
(55569,'The pain is unbearable, and I can no longer swim straight.','',0,0,0,0,0,0,0,0,1,0,27824,0,26124),
(55570,'Please grandchildren, can you remove this thorn?  I cannot do so on my own.','',0,0,0,0,0,0,0,0,1,0,27825,0,26124),
(55571,'','Of course, Shen-zin Su!  But your shell is large, and I do not know where this thorn could be.',0,0,0,0,0,0,1,0,1,0,0,27436,26124),
(55572,'It is in the forest where your feet do not walk.  Continue along the mountains and you will find it.','',0,0,0,0,0,0,0,0,1,0,27826,0,26124),
(55573,'','We will find it, and we will remove it.  You have our word!',0,0,0,0,0,0,1,0,1,0,0,27437,26124),
(55574,'A thorn?  And I left my tweezers at home.','',0,0,0,0,0,0,6,0,1,0,27300,0,26124),
(55575,'How could such a thing cause pain to something so large?','',0,0,0,0,0,0,6,0,1,0,27301,0,26124),
(55576,'','We\'ll know soon enough.',0,0,0,0,0,0,1,0,1,0,0,27438,26124),
(55577,'Are you seeing what I\'m seeing?!  Is that a boat?!','',0,0,0,0,0,0,5,0,1,0,27302,0,26124),
(55578,'','It is a boat... a whole airship!  That\'s a bigger thorn than I was expecting.',0,0,0,0,0,0,1,0,1,0,0,27439,26124),
(55579,'And those aren\'t pandaren down there.  They\'ve got no fur.','',0,0,0,0,0,0,1,0,1,0,27303,0,26124),
(55580,'It looks like they crashed.  I don\'t think they\'re here for trouble.','',0,0,0,0,0,0,1,0,1,0,27304,0,26124),
(55581,'','Someone has crashed into our island.  Removing this thorn may be more complicated than we thought.',0,0,0,0,0,0,1,0,1,0,0,27440,26124),
(55582,'','We should let Elder Shaopai know and then plan our next move.',0,0,0,0,0,0,1,0,1,0,0,27441,26124),
(55583,'','Look at this!',0,0,0,0,0,0,25,0,1,0,0,30442,26124),
(55584,'','There\'s a village up here... and a big fish statue, too.',0,0,0,0,0,0,1,0,1,0,0,30443,26124),
(55585,'','You think the jinyu built this place?',0,0,0,0,0,0,6,0,1,0,0,30444,26124),
(55586,'Hozen watchin\' wikket... someday hozen learn to grook like wikket!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55587,'Grook all the jinyu, wikket!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55588,'Shiney jab-jab, wikket.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55589,'Wikket got slickies?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55590,'Grookin Jinyu make for happy Kah Kah.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55591,'Slinger eat slicky. Slicky make dooker. Slingin\' dooker grook the Jinyu!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55592,'Furries chompin\' the Jinyu!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55593,'','I suppose that\'s enough for today. Let\'s wait for Uncle Chen to return.',0,0,0,0,0,0,1,0,1,0,0,30445,26124),
(55594,'','Look, here he comes now! How was the brewery, Uncle?',0,0,0,0,0,0,1,0,1,0,0,30538,26124),
(55595,'Bah! I do not want to talk about it.','',0,0,0,0,0,0,274,0,1,0,29724,0,26124),
(55596,'What happened, Chen?','What happened, Chen?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55597,'I am a fighter. Why will the elder not let me fight?','',0,0,0,0,0,0,0,0,1,13237,0,0,26124),
(55598,'Each day we send off only enough warriors to hold the hozen at bay. Never enough to actually push them back.','',0,0,0,0,0,0,0,0,1,13237,0,0,26124),
(55599,'Why won\'t Elder Lu let us fight the hozen back properly.','',0,0,0,0,0,0,0,0,1,13237,0,0,26124),
(55600,'Can\'t you see I\'m a little busy here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55601,'Damned hozen move through the trees like ghosts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55602,'It\'s just a matter of time before we retake Moonwater Retreat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55603,'We should be taking the fight to the hozen, not stalling out of fear.','',0,0,0,0,0,0,0,0,1,13237,0,0,26124),
(55604,'The elder is right, we should find a diplomatic solution with the hozen.','',0,0,0,0,0,0,0,0,1,13237,0,0,26124),
(55605,'Behold the power of torrential waters!','',0,0,0,0,0,0,0,0,1,0,28266,0,26124),
(55606,'Spring to life!','',0,0,0,0,0,0,0,0,1,0,28258,0,26124),
(55607,'%s rises from the fountain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55608,'What, were you sent to check up on me? Everything\'s fine! It\'s all under control!','',0,0,0,0,0,0,6,0,1,0,28288,0,26124),
(55609,'STRIKE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55610,'Your spirit has been ripped from your body! Get back to your body!','Your spirit has been ripped from your body! Get back to your body!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55611,'Hey, I think I\'m getting the hang of this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55612,'I think I learned something new!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55613,'I think I understand it now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55614,'This training is really helping.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55616,'Breaking and Entering','Breaking and Entering',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55618,'Can we start with something easier?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55619,'This is really hard!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55620,'Why do I keep missing?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55621,'How do I use this thing?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55622,'Huh? Where is the enemy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55623,'When should I open my eyes?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55624,'Which way is the enemy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55625,'These opponents are tough.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55626,'Hey, this isn\'t so bad.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55627,'They aren\'t so tough after all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55628,'Hey, we\'re not doing so bad.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55629,'The fight isn\'t over yet!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55630,'We might be able to win this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55631,'The tribe will prevail!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55632,'I\'m not going to run away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55633,'We\'ll fight this to the very end!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55634,'Onward! For the Pearlfin tribe!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55635,'I\'m ready for anything!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55636,'Never give up, friends!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55637,'For honor! For justice!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55638,'For our brothers and sisters!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55639,'I will send you to a watery grave!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55640,'Strike true, friends!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55641,'Fight hard! Press onward!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55642,'I feel stronger than before.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55643,'Time to fight your own battles, you monster! No more spirits to hide behind!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55644,'I hear that with fire and force you shape metals for war. I can achieve this through the pressures of water and a mastery of their densities.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55645,'Agh! My wards!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55646,'','Swagger all you like; you pups don\'t stand a chance. Flee now, while you can.',0,0,0,0,0,0,0,0,1,0,0,26251,26124),
(55647,'','You cross the Stormbinder! I\'ll slaughter you all.',0,0,0,0,0,0,0,0,1,0,0,26227,26124),
(55648,'','You should have run, dog.',0,0,0,0,0,0,0,0,1,0,0,26255,26124),
(55649,'','Feh!',0,0,0,0,0,0,0,0,1,0,0,26254,26124),
(55650,'','Down, pup.',0,0,0,0,0,0,0,0,1,0,0,26256,26124),
(55651,'','A waste of my time.',0,0,0,0,0,0,0,0,1,0,0,26257,26124),
(55652,'','Stay, pup.',0,0,0,0,0,0,0,0,1,0,0,26249,26124),
(55653,'','Hold still.',0,0,0,0,0,0,0,0,1,0,0,26250,26124),
(55654,'','You can\'t outrun the storm.',0,0,0,0,0,0,0,0,1,0,0,26247,26124),
(55655,'','Die beneath the ice.',0,0,0,0,0,0,0,0,1,0,0,26248,26124),
(55656,'','Suffer the storm\'s wrath!',0,0,0,0,0,0,0,0,1,0,0,26252,26124),
(55657,'','Thunder and lightning dance at my call!',0,0,0,0,0,0,0,0,1,0,0,26253,26124),
(55658,'','You face more than my axes, this close.',0,0,0,0,0,0,0,0,1,0,0,26244,26124),
(55659,'','See what becomes of those who stand before me!',0,0,0,0,0,0,0,0,1,0,0,26245,26124),
(55660,'','Feel a chill up your spine...?',0,0,0,0,0,0,0,0,1,0,0,26246,26124),
(55661,'','The time I spent binding that, WASTED!',0,0,0,0,0,0,0,0,1,0,0,26235,26124),
(55662,'','Enough!',0,0,0,0,0,0,0,0,1,0,0,26237,26124),
(55663,'','You\'ll PAY for that.',0,0,0,0,0,0,0,0,1,0,0,26236,26124),
(55664,'','Aughhhh!',0,0,0,0,0,0,0,0,1,0,0,26238,26124),
(55665,'','Again?!',0,0,0,0,0,0,0,0,1,0,0,26239,26124),
(55666,'','Impudent pup!',0,0,0,0,0,0,0,0,1,0,0,26240,26124),
(55667,'','The one remaining is still enough to finish you.',0,0,0,0,0,0,0,0,1,0,0,26241,26124),
(55668,'','What are you doing?',0,0,0,0,0,0,0,0,1,0,0,26228,26124),
(55669,'','You\'re toying with death.',0,0,0,0,0,0,0,0,1,0,0,26229,26124),
(55670,'','You think you can play with my lightning?',0,0,0,0,0,0,0,0,1,0,0,26230,26124),
(55671,'','Impossible!',0,0,0,0,0,0,0,0,1,0,0,26231,26124),
(55672,'','No! More... lightning...',0,0,0,0,0,0,0,0,1,0,0,26233,26124),
(55673,'','Enough of your games! You won\'t live to do it again.',0,0,0,0,0,0,0,0,1,0,0,26232,26124),
(55674,'','I\'ll finish you now, pups!',0,0,0,0,0,0,0,0,1,0,0,26234,26124),
(55675,'I would recommend releasing me. My father is not as forgiving as I am.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55676,'Perhaps you could speak to Nazgrim on my behalf? He seems unwilling to negotiate with me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55677,'Look at this land. Now is the time to be talking about peace and exploration.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55678,'I am sure that if you let me contact my companions we can begin negotiations for my release.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55679,'Blood and Thunder!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55680,'Another notch for my axe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55681,'Send me a real challenge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55682,'For the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55683,'Sorry, we aren\'t accepting visitors right now.','',0,0,0,0,0,0,274,0,1,0,28280,0,26124),
(55684,'I am no visitor, I am Chen Storm-','',0,0,0,0,0,0,404,0,1,0,29655,0,26124),
(55685,'You should leave.','',0,0,0,0,0,0,0,0,1,0,28281,0,26124),
(55686,'But we are family. I am a Stormstout! From the Wandering Isle...','',0,0,0,0,0,0,1,0,1,0,29656,0,26124),
(55687,'Are you deaf? We aren\'t allowing anybody in the brewery right now.','',0,0,0,0,0,0,5,0,1,0,28282,0,26124),
(55688,'There is no need to speak to me that way.','',0,0,0,0,0,0,1,0,1,0,29657,0,26124),
(55689,'Wait - what is going on behind you!?','',0,0,0,0,0,0,25,0,1,0,29658,0,26124),
(55690,'Huh?! That\'s... that\'s nothing! Now GO AWAY!','',0,0,0,0,0,0,5,0,1,0,28283,0,26124),
(55691,'Come, speak with me! Let\'s sit down and talk. Have a beer together...','',0,0,0,0,0,0,404,0,1,0,29661,0,26124),
(55692,'There will be no sitting. No talking. And none of your horrible beer!','',0,0,0,0,0,0,274,0,1,0,28284,0,26124),
(55693,'[This line has been cut]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55694,'Hey, what\'s that behind you?!','',0,0,0,0,0,0,25,0,1,0,28285,0,26124),
(55695,'How many times must I tell you... GO AWAY!','',0,0,0,0,0,0,1,0,1,0,28286,0,26124),
(55696,'I don\'t understand, old man. What have I done to upset you?','',0,0,0,0,0,0,6,0,1,0,29664,0,26124),
(55697,'It\'s not what you\'ve done, it\'s who you are. You are not welcome here, \"Chen Stormstout.\"','',0,0,0,0,0,0,274,0,1,0,28287,0,26124),
(55698,'I found the brewery and made my way inside.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(55699,'I decided to look around for someone else from the Stormstout family.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(55700,'I was shaken, but I did not give up. I pursued the strange old brewer to ask him some more questions.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(55701,'First beer elementals, and now a hozen attack? Something was very wrong.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(55702,'I decided to give him one more chance. I was not about to give up on family.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(55703,'That was all I needed to hear. Shunned... by my own blood! I turned and left.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(55704,'[This line has been cut]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55705,'I had no choice but to defend myself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(55706,'*hic* Gimme more of that ook-dooglin\' BEER! *hic*','',0,0,0,0,0,0,0,0,1,0,31627,0,26124),
(55707,'When I was young I wanted to be a brewmaster. Mixing various chemicals to get the perfect drink and flavor.$b$bDuring my training though they kept telling me my drinks were too hearty.$b$bSo I went into smelting. Seemed like a logical transition at the time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55708,'Welcome to my noodle shack. We\'ve got every type of noodle that should be eaten. If we don\'t have it, you shouldn\'t be eating it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55709,'I am the mighty Tzu the Ironbelly Monk, so named for my infamous belly barrage. Perhaps you have heard of me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55710,'I once did battle with the dreaded fang toothed beast that shall not be named for fear of darkening the day.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55711,'Chin did not earn his title lightly. There was a fierce championship of noodle makers gathered from all four corners of the village.$b$bIt was here they battled with great ferocity over barrels of boiling water to forge only the finest noodles ever made within a days travel.$b$bGlorious I tell you!$b$bOnly Flourfury emerged victorious, crafting a noodle so astounding it shook the very foundation of my taster\'s bowl.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55712,'','Another stranger? Where are all of you coming from?$b$BSomeone was through here a few days ago claiming to be from the turtle. Said his name was Stormstout.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(55713,'','You\'re not here to start a fight in my brewery are you? Those two strangers over there started quite a brawl when they arrived last week.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55714,'','Lorewalker Cho spoke highly of you. You are welcome as long as you don\'t go all hozen on us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55715,'','Cowards! You pack of weakling... dogs...',0,0,0,0,0,0,0,0,1,0,0,26243,26124),
(55716,'You had something important to tell me, master?','You had something important to tell me, master?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55717,'I\'m Toya! You need it? I can get it! Don\'t go to nobody else in Dawn\'s Blossom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55718,'I\'m ready to see Lorewalker Cho.','I\'m ready to see Lorewalker Cho.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55719,'The darkness clears...','',0,0,0,0,0,0,0,0,1,0,28262,0,26124),
(55720,'I peer into these waters and my reflection is empty...','',0,0,0,0,0,0,0,0,1,0,28263,0,26124),
(55721,'Waters... claim me...','',0,0,0,0,0,0,0,0,1,0,28264,0,26124),
(55722,'Thank you again for your help, stranger. I have already begun to think of ideas on the ring I shall craft for Syra\'s hand.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(55723,'The waters whisper to me... enemies approach.','',0,0,0,0,0,0,0,0,1,0,28265,0,26124),
(55724,'','Wow stranger! You really showed that mean old witch who was boss.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(55725,'','It was so neat how you beat up those cats! They went and were like \"Grrrrr!\" and then you went and \"Wabang!\" and then you took their stuff.',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(55726,'','The grown ups always told us the Jade Witch was just some old lady in the woods who was sad her husband died. But you showed them!$b$bOnly... I didn\'t tell any of the grown ups \'cause I didn\'t want to get in trouble.',4,1,0,0,0,0,0,0,1,0,0,0,26124),
(55727,'Me gonna ook you in the dooker!','',0,0,0,0,0,0,0,0,1,0,28796,0,26124),
(55728,'|TInterface\\Icons\\inv_misc_food_23.blp:20|t Ook-Ook is |cFFFF0000|Hspell:106651|h[Going Bananas]|h|r! More barrels are coming!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55729,'Have you seen Lo Wanderbrew?','Have you seen Lo Wanderbrew?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55730,'','Do you seek enlightenment?',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(55731,'Oook!  Ooooooook!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55732,'','Do you wish to expand your mind and body beyond the boundaries it is currently confined to?',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(55733,'','The Tian Monastery taught me how to focus my energies so tightly that I could tap a keg using only my pinky finger.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(55734,'','I have not seen Lo since he made off with my student, Syra. They were heading east toward the Arboretum.$b$bIt will not go well if their parents learn of this. The Wanderbrews and the Goldendrafts have had a long standing feud.',274,1,0,0,0,0,0,0,1,0,0,0,26124),
(55735,'Welcome to the Arboretum. May you find inspiration amongst the trees.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55736,'Our lives are but a blink of reality\'s eye.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55737,'Ours is an ancient and long lived culture.$b$bThanks to our craft, some of the memory of that culture can be preserved for future generations.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55738,'Have you seen Lo Wanderbrew?','Have you seen Lo Wanderbrew?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55739,'You seek two lovers blind to the ambitions of their family names. They were here, seeking a way to hold to their path.$b$bSadly they did not find their answers among the trees or art.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55741,'Blessings of the Pandriarchs.','Blessings of the Pandriarchs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55742,'','Jade Serpent, grant me strength!',0,0,0,0,0,0,0,0,1,0,0,27605,26124),
(55743,'Lo? Oh. I haven\'t seen him today. I thought it was very odd. He usually walks me to work in the morning.$b$bHe has a kind heart. It\'s a shame he looks down on his apprenticeship with Singegruff. He is a very talented smelter.$b$bIf you see him, tell him I missed our walk this morning.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55744,'So be it.','',0,0,0,0,0,0,0,0,1,0,25927,0,26124),
(55745,'You know not what you have done. Aman\'Thul... What I... have... seen...','',0,0,0,0,0,0,0,0,1,0,25928,0,26124),
(55746,'','Hey mister Ironbelly! The witch in the woods turned my friends into jade. Can you help?',20,0,0,0,0,0,0,0,1,13227,0,0,26124),
(55747,'Your time has come.','',0,0,0,0,0,0,0,0,1,0,25936,0,26124),
(55748,'The sand has run out.','',0,0,0,0,0,0,0,0,1,0,25937,0,26124),
(55749,'Time ends.','',0,0,0,0,0,0,0,0,1,0,25938,0,26124),
(55750,'To repeat the same action and expect different results is madness.','',0,0,0,0,0,0,0,0,1,0,25930,0,26124),
(55751,'Another chance will make no difference. You will fail.','',0,0,0,0,0,0,0,0,1,0,25931,0,26124),
(55752,'Again...? Is this your plot, your scheme?','',0,0,0,0,0,0,0,0,1,0,25932,0,26124),
(55753,'The Hourglass\' power is exhausted. No more games, mortals. Relent, or perish.','',0,0,0,0,0,0,0,0,1,0,25933,0,26124),
(55754,'The Widow Greenpaw is NOT a witch. She just makes very lifelike jade statues.','',1,0,0,0,0,0,0,0,1,13227,0,0,26124),
(55755,'We\'ve got to light that signal fire. Without reinforcements, they\'ll destroy the gate!','',5,0,0,0,0,0,0,0,1,0,29068,0,26124),
(55756,'But the mantid have overrun the area. There\'s no clear path!','',1,0,0,0,0,0,0,0,1,0,29071,0,26124),
(55757,'Don\'t worry! I can make it!','',0,0,0,0,0,0,0,0,1,0,27692,0,26124),
(55758,'What are you doing?! There\'s no way you\'ll reach it!','',0,0,0,0,0,0,0,0,1,0,29069,0,26124),
(55759,'You\'ll get yourself killed!','',0,0,0,0,0,0,0,0,1,0,29072,0,26124),
(55760,'Why didn\'t he listen?','',5,0,0,0,0,0,0,0,1,0,29070,0,26124),
(55761,'We\'ve gotta stop giving the recruits those red shirts. They\'re just moving targets in them.','',1,0,0,0,0,0,0,0,1,0,29073,0,26124),
(55762,'','|TInterface\\Icons\\ability_vehicle_sonicshockwave.blp:20|t%s begins to cast |cFFFF0000|Hspell:106886|h[Cauterize]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55763,'Sometimes the only way to find something is to stop looking.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(55764,'Go ahead and speak with the water, Ashyo.','Go ahead and speak with the water, Ashyo.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55765,'Meet me up in the pools whenever you\'re ready!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55766,'You have done it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(55767,'We defeated the Destroyer!','We defeated the Destroyer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(55768,'It is done; at last the Destroyer has met his end. Now, we can begin to heal our world.','',0,0,0,0,0,0,0,0,0,0,25901,0,26124),
(55769,'You have accomplished the impossible, succeeded where all Azeroth feared you would fail.','You have accomplished the impossible, succeeded where all Azeroth feared you would fail.',0,0,0,0,0,0,0,0,1,0,26501,26501,26124),
(55770,'...although, you may want to hurry.','',0,0,0,0,0,0,0,0,1,0,25952,0,26124),
(55771,'Do you hear that?  What is that noise!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(55772,'Inconceivable! He couldn\'t possibly be alive!','Inconceivable! He couldn\'t possibly be alive!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(55773,'No! Such power! Deathwing\'s summoning of the final Cataclysm will destroy all life on Azeroth. Quickly, we must interrupt him!','No! Such power! Deathwing\'s summoning of the final Cataclysm will destroy all life on Azeroth. Quickly, we must interrupt him!',0,0,0,0,0,0,0,0,1,0,26500,26500,26124),
(55774,'Hurry, heroes. In mere moments Deathwing\'s Cataclysm will complete what he begun and end the world. Join me in the attack, now!','',0,0,0,0,0,0,0,0,1,0,25951,0,26124),
(55776,'The Destroyer is gathering all his might for a blow that will split the world. Attack him, now! We must stop the final Cataclysm!','',0,0,0,0,0,0,0,0,1,0,26261,0,26124),
(55778,'I will cleanse whatever corruption I can; my fire will not harm you.','I will cleanse whatever corruption I can; my fire will not harm you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55779,'There is no shelter from my fury.','',0,0,0,0,0,0,0,0,0,0,26354,0,26124),
(55780,'Your armor means nothing, your faith even less.','',0,0,0,0,0,0,0,0,0,0,26355,0,26124),
(55781,'The sea will swallow your smoldering remains.','',0,0,0,0,0,0,0,0,0,0,26356,0,26124),
(55782,'I shall tear this world apart.','',0,0,0,0,0,0,0,0,0,0,26357,0,26124),
(55783,'I shall show you a true cataclysm.','',0,0,0,0,0,0,0,0,0,0,26358,0,26124),
(55784,'Watch as your world comes to an end.','',0,0,0,0,0,0,0,0,0,0,26359,0,26124),
(55785,'I AM DEATHWING, THE DESTROYER, THE END OF ALL THINGS, INEVITABLE, INDOMITABLE; I AM THE CATACLYSM!','',0,0,0,0,0,0,0,0,0,0,26353,0,26124),
(55786,'I will slow the Destroyer\'s attacks when I can.','',0,0,0,0,0,0,0,0,0,0,25949,0,26124),
(55787,'Your accent is strange. Are you from the Valley of the Four Winds?','Your accent is strange. Are you from the Valley of the Four Winds?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55788,'Are you an adventurer? We don\'t hear about many adventures around here except the stories Tzu tells us.','Are you an adventurer? We don\'t hear about many adventures around here except the stories Tzu tells us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55789,'New to town? You should try Chin\'s noodles. They are the stuff of local legend.','New to town? You should try Chin\'s noodles. They are the stuff of local legend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55790,'I hear the hozen and jinyu have been increasing their skirmishes. Those poor little creatures will destroy each other if they aren\'t careful. It is quite a vicious cycle they are trapped in.','I hear the hozen and jinyu have been increasing their skirmishes. Those poor little creatures will destroy each other if they aren\'t careful. It is quite a vicious cycle they are trapped in.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55791,'And what are you? I\'ve seen many things in my day but you are certainly a first. Has the turtle returned? I always thought that was a myth.','And what are you? I\'ve seen many things in my day but you are certainly a first. Has the turtle returned? I always thought that was a myth.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55792,'I need to make sure to get in my sixth and seventh nap today if I expect to be ready for my big snooze.','I need to make sure to get in my sixth and seventh nap today if I expect to be ready for my big snooze.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55793,'The Jade Serpent is nearly complete. You know what that means? Several months of cheering, celebrating, sleeping, and brewing! I can\'t wait!','The Jade Serpent is nearly complete. You know what that means? Several months of cheering, celebrating, sleeping, and brewing! I can\'t wait!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55794,'%s hums a tune while unloading his basket.','%s hums a tune while unloading her basket.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55795,'Sorry, Yue, but that\'s all the full blossoms I could find. Most of the flowers in this pool just aren\'t ready yet.','Sorry, Yue, but that\'s all the full blossoms I could find. Most of the flowers in this pool just aren\'t ready yet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55796,'You\'re the boss.','You\'re the boss.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55797,'Gather \'round cubs and hear the tale of \"$p and the dreaded Silken Shadows\"...','',0,0,0,0,0,0,0,0,1,13262,0,0,26124),
(55798,'There they were, marching through the depths of the Silkwood on an errand of peace.','',396,0,0,0,0,0,0,0,1,13262,0,0,26124),
(55799,'But then, the dark evil spiders rose from their evil layers with eyes full of evil and legs full of evil.','',396,0,0,0,0,0,0,0,1,13262,0,0,26124),
(55800,'They stabbed and bit and chomped but nothing they could do would defeat our hero, $p!','',396,23,0,0,0,0,0,0,1,13262,0,0,26124),
(55801,'HUNDREDS OF DECAPITATIONS!','',22,0,0,0,0,0,0,0,1,13262,0,0,26124),
(55802,'With weapons of power and a magnificent regalia our hero unleashed their fury on the beasts. It was glorious!','',1,0,0,0,0,0,0,0,1,13262,0,0,26124),
(55804,'Oooooooo!','Aaaaaahhhh!',430,0,0,0,0,0,0,0,1,13262,0,0,26124),
(55805,'And then what happened?','And then what happened?',430,0,0,0,0,0,0,0,1,13262,0,0,26124),
(55808,'','Tapping is an art form passed down through the generations. No need to ask anyone else if that is true or not. Just take my word for it.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(55809,'\"Something profound.\"$b$BThere. Now whenever someone asks you what Lee Mugfinder said to you at your first meeting, it will always be something profound.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(55810,'I make kegs. Sounds simple to the un-enlightened but you would be surprised how much the type of materials used in a keg will affect the flavor of the beverage held within.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(55811,'','Hello there, $c!$B$BWe cultivate and harvest the finest lotus flowers in all of Pandaria. From here they are sent down to the village of New Cifera where they are sorted and shipped all over the land.$B$BThe lotus has countless culinary, medicinal, and decorative applications - as you can imagine, demand is quite high.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(55812,'You! Are you the ones responsible for what has happened here...?','',0,0,0,0,0,0,0,0,1,0,25911,0,26124),
(55813,'What dark horrors have you wrought in this place? By my ancestors\' honor, I shall take you to task!','',0,0,0,0,0,0,0,0,1,0,25909,0,26124),
(55814,'Where... is this place? What... have I done? Forgive me, my father...','',0,0,0,0,0,0,0,0,1,0,25910,0,26124),
(55815,'This is the price you pay!','',0,0,0,0,0,0,0,0,1,0,25912,0,26124),
(55816,'A just punishment!','',0,0,0,0,0,0,0,0,1,0,25913,0,26124),
(55817,'Suffer for your arrogance!','',0,0,0,0,0,0,0,0,1,0,25914,0,26124),
(55818,'There will be no escape!','',0,0,0,0,0,0,0,0,1,0,25915,0,26124),
(55819,'My wrath knows no bounds!','',0,0,0,0,0,0,0,0,1,0,25916,0,26124),
(55820,'You wish to train? YOU!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55821,'I\'m ready for the trial of bamboo.','I\'m ready for the trial of bamboo.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55822,'My fists are ready. Bring on the trial of wood.','My fists are ready. Bring on the trial of wood.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55823,'I\'ve done all that you\'ve asked of me. I\'m ready for the trial of stone.','I\'ve done all that you\'ve asked of me. I\'m ready for the trial of stone.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55826,'|TInterface\\Icons\\spell_fire_meteorstorm.blp:20|t%s begins to cast |cFFFF0000|Hspell:105651|h[Elementium Bolt]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55827,'','Hey there!$B$B<The little girl squints at you.>$B$BI overheard you talking to the Elder Sage. He\'s pretty serious, isn\'t he?$B$BWell you\'re in luck, because I hear just about everything that happens around here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55828,'Very well then, outsiders. Let us see your true strength.','',0,0,0,0,0,0,0,0,1,0,27628,0,26124),
(55829,'Skill with a weapon is but a physical manifestation of one\'s martial strength. Let me show you what spiritual power is!','',0,0,0,0,0,0,0,0,1,0,27629,0,26124),
(55830,'When I was but a cub I could scarcely throw a punch, but after years of training I can do so much more!','',0,0,0,0,0,0,0,0,1,0,27630,0,26124),
(55831,'','Hey, stranger! Pssst! Come over here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55832,'I am bested.  Give me a moment and we will venture forth together to face the Sha.','',0,0,0,0,0,0,0,0,1,0,27623,0,26124),
(55833,'The waters are wild and chaotic. Something agitates them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55834,'I must speak to the waters to understand their turmoil.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55835,'Thanks to you, my work can now continue.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55836,'Elder, I found your staff.','Elder, I found your staff.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55837,'This staff holds powers passed down through my ancestors. Thank you for returning it to me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55838,'SIT!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(55839,'Welcome to the Temple of the Jade Serpent, traveler.$B$BWe welcome all within our doors, and offer knowledge freely to any who seek it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55840,'Alright, let\'s get a move on!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55843,'I will bring you closer to the Emerald Dream. Seek safety there when the fight becomes too intense.','',0,0,0,0,0,0,0,0,0,0,26142,0,26124),
(55844,'Only you can give us our opening!','',0,0,0,0,0,0,0,0,0,0,25902,0,26124),
(55845,'These champions are our only hope for exposing Deathwing\'s weakness. Together, we can prevail.','',0,0,0,0,0,0,0,0,0,0,25896,0,26124),
(55846,'Don\'t give up! We are counting on you to push Deathwing back.','',0,0,0,0,0,0,0,0,0,0,25897,0,26124),
(55847,'My thanks, $p, for saving me from that vile jade witch.$b$bEven now my legs still feel stiff. I can command soldiers, if we can call these creatures that. But I think I will be of little use in any battle.','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(55848,'|TInterface\\Icons\\ability_deathwing_assualtaspects.blp:20|t%s assaults |cFFFF0000|Hspell:107018|h[Alexstrasza]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55849,'|TInterface\\Icons\\ability_deathwing_assualtaspects.blp:20|t%s assaults |cFFFFFF00|Hspell:107018|h[Nozdormu]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55850,'|TInterface\\Icons\\ability_deathwing_assualtaspects.blp:20|t%s assaults |cFF04FC32|Hspell:107018|h[Ysera]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55851,'|TInterface\\Icons\\ability_deathwing_assualtaspects.blp:20|t%s assaults |cFF5858FA|Hspell:107018|h[Kalecgos]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55852,'Ready!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(55853,'|TInterface\\Icons\\ability_deathwing_assualtaspects.blp:20|t%s begins to cast |cFFFF0000|Hspell:107018|h[Assault Aspects]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55854,'Aim!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(55855,'FLING!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(55856,'You ookin nugs missed the wikket! AGAIN!','',22,480,0,0,1,0,0,0,1,0,0,0,26124),
(55857,'You through like a land walker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55858,'Does it hurt being as dumb as you are?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55859,'At this rate I would die faster of natural causes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55860,'You have done NOTHING. I will tear your world APART.','',0,0,0,0,0,0,0,0,0,0,26527,0,26124),
(55875,'I\'ve lost my lashtail hatchling.','I\'ve lost my lashtail hatchling.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55879,'I\'ve lost my panther cub.','I\'ve lost my panther cub.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55880,'I\'ve lost my balloon.','I\'ve lost my balloon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55881,'What you want?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55882,'','The kodos are waiting on the road. Safe journey, $Gbrother:sister;.',1,0,0,50,0,0,0,0,1,0,0,0,26124),
(55887,'','I never would have thought that these grunts could be trained.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55888,'Boom boom too small! Wikket being sticky with the boom booms.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(55889,'','Be glad I only gave you a bomb. Ingrate.',1,0,0,0,1,0,0,0,1,0,0,0,26124),
(55890,'','Obviously you have mistaken me for someone who cares.',1,0,0,0,1,0,0,0,1,0,0,0,26124),
(55891,'','Should have had more fiber in your diet then.',1,0,0,0,1,0,0,0,1,0,0,0,26124),
(55892,'My boom boom is too small! Can I have another?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(55893,'More please?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(55894,'This is a flawlessly etched jade statue of An Windfur\'s friend Shin, eyes wide with terror.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55895,'Ookin\' flapper dropped a dooker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55896,'Gate?! I\'m going to bring this whole wall down!','',0,0,0,0,0,0,0,0,1,0,29341,0,26124),
(55897,'This will be the bomb.','',0,0,0,0,0,0,0,0,1,0,29346,0,26124),
(55898,'I need to follow this map to Dawn\'s Blossom.','I need to follow this map to Dawn\'s Blossom.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55899,'You\'re the bomb!','',0,0,0,0,0,0,0,0,1,0,29345,0,26124),
(55900,'Things that make you go... BOOM!','',0,0,0,0,0,0,0,0,1,0,29347,0,26124),
(55901,'BOOM! Explosion! Overpowering!','',0,0,0,0,0,0,0,0,1,0,29348,0,26124),
(55902,'BOOM shakalaka!','',0,0,0,0,0,0,0,0,1,0,29342,0,26124),
(55903,'Who crashing Ook party!?','',0,0,0,0,0,0,0,0,1,0,28798,0,26124),
(55904,'','The heart of the Great Serpent will not fall into your hands!',0,0,0,0,0,0,0,0,1,0,0,27603,26124),
(55905,'','The cycle must continue, the Jade Serpent must be reborn!',0,0,0,0,0,0,0,0,1,0,0,27606,26124),
(55906,'','The heart is MINE!',0,0,0,0,0,0,0,0,1,0,0,27608,26124),
(55907,'','Leave this place.',0,0,0,0,0,0,0,0,1,0,0,27609,26124),
(55908,'','The haze has been lifted from my eyes... forgive me for doubting you...',0,0,0,0,0,0,0,0,1,0,0,27604,26124),
(55909,'Be free of doubt, priestess...','Be free of doubt, priestess...',0,0,0,0,0,0,0,0,1,0,28559,28559,26124),
(55910,'','My noble Varo\'then, do return and dispose of this murderous band.',0,0,0,0,0,0,25,0,0,0,0,26019,26124),
(55912,'At your side, my queen!','',0,0,0,0,0,0,0,0,1,0,26136,0,26124),
(55913,'','It is them!',0,0,0,0,0,0,0,0,1,0,0,26030,26124),
(55914,'','Heroes! We have been sent by Nozdormu! Quickly, on our backs, we must get you to the Dragon Soul!',0,0,0,0,0,0,0,0,1,0,0,26032,26124),
(55915,'','Sister, look! The artifact is surrounded by an aura of darkness!',0,0,0,0,0,0,0,0,1,0,0,26031,26124),
(55916,'','The aspects!',0,0,0,0,0,0,0,0,1,0,0,26033,26124),
(55917,'','The Old Gods protect the Soul!',0,0,0,0,0,0,0,0,1,0,0,26035,26124),
(55918,'','The link to the portal must be broken! Quickly, to Stormrage!',0,0,0,0,0,0,0,0,1,0,0,26036,26124),
(55919,'','Ah, welcome. You are here to join us in the coming celebration? No? A pity.',0,0,0,0,0,0,274,0,0,0,0,26013,26124),
(55920,'','Serve Azshara, puppets, and rejoice.',0,0,0,0,0,0,273,0,0,0,0,26026,26124),
(55921,'Yes?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55922,'','Such insolence. My temper grows short.',0,0,0,0,0,0,5,0,0,0,0,26015,26124),
(55923,'Loon Mai has issued evacuation orders.','Loon Mai has issued evacuation orders.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55924,'Oh, I don\'t know. I am old, and I have always...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55925,'Look out! Mantid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55926,'I feared that this day would come. I will pack up my things.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55927,'What, another one? Did Commander Mai send you?$b$bHow many times do I have to tell that bonehead - we\'re not evacuating!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55928,'Yes, Commander Mai sent me, and I carry his evacuation orders.','Yes, Commander Mai sent me, and I carry his evacuation orders.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55929,'','Pshh... outsiders. You know nothing about the Stoneplow way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55930,'','We\'re proud. We\'re strong. We are descended from the blood of the Tiller himself... and we don\'t run from trouble.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55931,'That\'s right. Now please, $r, leave and let us defend our property.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55932,'Stay back!$b$bWait... you\'re not one of them. We\'re not accustomed to outsiders, and with the mantid breaking through the wall, I...$b$bAnyhow, what can we do to help you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55933,'Loon Mai has issued evacuation orders.','Loon Mai has issued evacuation orders.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55934,'I see. I\'d hoped that we could wait out this invasion, but if the authorities want us to leave, we will leave.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55935,'Ying, Huizhong... gather your things. We\'re leaving the farm until it\'s safe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55936,'','Oh, honey...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55937,'','Daddy, is this nice person going to kill all the bad mantid soldiers?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55938,'I don\'t know, dear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55939,'Are you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55940,'How can I help you, $c?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55941,'Loon Mai has issued evacuation orders.','Loon Mai has issued evacuation orders.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55942,'%s sighs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55943,'I am a farmer, $c. It\'s all I know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55944,'All we have is our land. And that commander wants us to give it up to the mantid?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55945,'I will not do it. My grandfather knew what he was getting into when he first planted seed in the shadow of the Serpent\'s Spine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55946,'I have my wife, two strong daughters, and two strong sons. Thank you, but we can protect this farm ourselves.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55947,'','Those had better not be evacuation papers I see.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55948,'','Welcome to Stoneplow. What can we do for you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55949,'','I apologize for the mess. Things are a little hectic right now.$b$bHow can I be of service to you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55950,'Do you have those evacuation papers?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55951,'Yes, they\'re right here. Let\'s go.','Yes, they\'re right here. Let\'s go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55952,'I\'ve reconsidered... it\'s too dangerous to stay here. No piece of land is worth losing your life over. Let me see those evacuation orders.','',0,0,0,0,0,0,0,0,1,13296,0,0,26124),
(55953,'','Is there anyone in need of medical aid?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55954,'','HEY ROOKIE! DID YOU SAY SOMETHING TO ME? SORRY, MY EARS ARE STILL RINGING FROM THE EXPLOSION!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55955,'Loudly explain how to get back to camp.','Loudly explain how to get back to camp.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55956,'Wake him up.','Wake him up.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55957,'<The gnome\'s face is streaked with smoke and burns, but he\'s alive.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55958,'What\'s yer mission? I got the tools that you need.','',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(55959,'<The dwarf is unconscious, but otherwise unharmed.>','',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(55960,'They\'ll take this camp over my dead body!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55961,'Keep your eyes open and your head in the mission, recruit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55962,'Woohoo, that was some crash! All my parts seem accounted for. Thanks, rookie.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55963,'Oof! I reckon we fared better\'n Amber and Nimm. Saw their plane burn up further inland. Thanks, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55964,'','I\'ll stick with you a little longer, $n. I saw many injured crewmen who may be in need of my aid.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55965,'This seems like a good spot to consult the water!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55966,'','Come sister, it is time to end this. We will cleanse the Dragon Soul of the Old Gods\' dark influence!',0,0,0,0,0,0,0,0,1,0,0,26508,26124),
(55967,'','It is too powerful!',0,0,0,0,0,0,0,0,1,0,0,26150,26124),
(55968,'How DARE you touch my creation?! It is mine...mine...MINE!','',0,0,0,0,0,0,0,0,1,0,26107,0,26124),
(55969,'','Neltharion! What have you done? You have doomed us all to the madness of the Old Gods!',0,0,0,0,0,0,0,0,1,0,0,26509,26124),
(55970,'IT IS MINE!!','',0,0,0,0,0,0,0,0,1,0,26108,0,26124),
(55971,'','He is lost to us, sister. He is Neltharion no longer.',0,0,0,0,0,0,0,0,1,0,0,26151,26124),
(55972,'','The power of the Soul is tearing him apart!',0,0,0,0,0,0,0,0,1,0,0,26510,26124),
(55973,'Nooooo...away...','',0,0,0,0,0,0,0,0,1,0,26110,0,26124),
(55974,'I WILL NOT BE DENIED!','',0,0,0,0,0,0,0,0,1,0,26109,0,26124),
(55975,'AWAY!','',0,0,0,0,0,0,0,0,1,0,26111,0,26124),
(55976,'','WHAT? FOLLOW YOU? OKAY!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55977,'At last it has come to pass. The moment of my demise. The loop is closed. My future self will cause no more harm.','',0,0,0,0,0,0,0,0,1,0,25944,0,26124),
(55978,'Still, in time, I will... fall to madness. And you, heroes... will vanquish me. The cycle will repeat. So it goes.','',0,0,0,0,0,0,0,0,1,0,25945,0,26124),
(55979,'What matters is that Azeroth did not fall; that we survived to fight another day.','',0,0,0,0,0,0,0,0,1,0,25946,0,26124),
(55980,'All that matters... is this moment.','',0,0,0,0,0,0,0,0,1,0,25947,0,26124),
(55981,'The \"End Time,\" I once called this place. I had not seen, by then; I did not know. You hope to... what? Stop me, here? Change the fate I worked so tirelessly to weave?','',0,0,0,0,0,0,0,0,1,0,25934,0,26124),
(55982,'You crawl unwitting, like a blind, writhing worm, towards endless madness and despair. I have witnessed the true End Time. This? This is a blessing you simply cannot comprehend.','',0,0,0,0,0,0,0,0,1,0,25935,0,26124),
(55983,'%s vanishes into the shadows!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55984,'The Eyes of Peroth\'arn are looking for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55985,'Select your destination.','Select your destination.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(55986,'Entryway of Time','Entryway of Time',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(55987,'Ruby Dragonshrine','Ruby Dragonshrine',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(55988,'Emerald Dragonshrine','Emerald Dragonshrine',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(55989,'Azure Dragonshrine','Azure Dragonshrine',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(55990,'Obsidian Dragonshrine','Obsidian Dragonshrine',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(55991,'Bronze Dragonshrine','Bronze Dragonshrine',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(55992,'','Did you hear that!? The Hidden Master, to the north of here!?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55993,'','Watch Commander, I will be leaving now. I\'m finally going to go continue my training!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55994,'','Maybe I\'ll see you up there, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55995,'','$n, you did well. I\'m going back to camp to take care of the wounded. Check in with the Commander when you\'re done out here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55998,'','Oh, and $r! Come back with the goods, okay? I\'ve got to make sure they\'re up to snuff.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(55999,'Snowpuff and I\'ll be waitin\'! Please hurry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56000,'We have a situation on our hands. Help defend our allies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56001,'A dark force from within the Dragon Soul reacts violently to the cleansing!','A dark force from within the Dragon Soul reacts violently to the cleansing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56003,'Ahhh... this test is simple. All you need to do is strike the bamboo, until it breaks.','',0,0,0,0,0,0,1,0,1,0,29097,0,26124),
(56004,'\"But it\'s too thick around!\", you might say.','',0,0,0,0,0,0,6,0,1,0,29098,0,26124),
(56005,'That is part of the test. Yes... to succeed, you must focus all your energy into one fist...','',0,0,0,0,0,0,1,0,1,0,29099,0,26124),
(56006,'..then, STRIKE!','',0,0,0,0,0,0,511,0,1,0,29100,0,26124),
(56007,'Strike the stack of bamboo when the meter is full!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56008,'This test is simple. All you need to do is strike the wood, until it breaks.','',0,0,0,0,0,0,1,0,1,0,29101,0,26124),
(56009,'\"But it\'s too hard!\", you might say.','',0,0,0,0,0,0,6,0,1,0,29102,0,26124),
(56010,'But it is not too hard. You are ready for this, $n.','',0,0,0,0,0,0,397,0,1,0,29103,0,26124),
(56011,'This test is simple. All you need to do is strike the stone, until it breaks.','',0,0,0,0,0,0,1,0,1,0,29104,0,26124),
(56012,'\"But that\'s impossible!\", you might say.','',0,0,0,0,0,0,6,0,1,0,29105,0,26124),
(56013,'You would be wrong. With clarity and focus, nothing is impossible.','',0,0,0,0,0,0,5,0,1,0,29106,0,26124),
(56014,'Yes, just like that!','',0,0,0,0,0,0,0,0,1,0,29117,0,26124),
(56015,'An excellent strike.','',0,0,0,0,0,0,0,0,1,0,29118,0,26124),
(56016,'Excellent focus, $n.','',0,0,0,0,0,0,0,0,1,0,29119,0,26124),
(56017,'You learn quickly.','',0,0,0,0,0,0,0,0,1,0,29120,0,26124),
(56018,'I could not have done better myself.','',0,0,0,0,0,0,0,0,1,0,29121,0,26124),
(56019,'Well done.','',0,0,0,0,0,0,0,0,1,0,29122,0,26124),
(56020,'No, you must focus!','',0,0,0,0,0,0,0,0,1,0,29109,0,26124),
(56021,'We must not waste time, traveler.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56022,'Wait until the moment is right... THEN you strike!','',0,0,0,0,0,0,0,0,1,0,29110,0,26124),
(56023,'Patience is the key.','',0,0,0,0,0,0,0,0,1,0,29111,0,26124),
(56024,'Clear your mind, $n.','',0,0,0,0,0,0,0,0,1,0,29112,0,26124),
(56025,'Your fists are strong, but your mind is still weak.','',0,0,0,0,0,0,0,0,1,0,29113,0,26124),
(56026,'Try again.','',0,0,0,0,0,0,0,0,1,0,29114,0,26124),
(56027,'Mind over matter, $n.','',0,0,0,0,0,0,0,0,1,0,29115,0,26124),
(56028,'Do not let the stone intimidate you. It is stone, you are $r.','',0,0,0,0,0,0,0,0,1,0,29116,0,26124),
(56029,'Strike the stack of wood when the meter is full!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56030,'Strike the stack of stone when the meter is full!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56031,'I\'ve only done this once before... Hopefully this works.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56032,'%s plunges the bottom end of his staff into the pool before resting his head on the top.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56033,'Welcome, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56034,'Are you here for more training, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56035,'How can I serve, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56036,'There is nothing more that I can do for you, $n. Take what I have taught you, and use it elsewhere.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56037,'What... what is this place? It is beautiful... But... something is not right.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56038,'I must speak to the waters to understand their turmoil.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56039,'Little waters, if you would just stop moving so quickly, perhaps I could help you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56040,'Darkness comes. I can feel it within my bones.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56041,'Do not fear, little ones. Come shadow or light, the waters will always flow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56042,'Water is life. When the waters feel torment, then so shall we.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56043,'Jinyu and their crazy rituals...','Jinyu and their crazy rituals...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56044,'','I know what your friend has seen, $n - he will need to rest for now. Come speak with me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56045,'Something has disturbed the waters. They are normally so well-behaved.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56046,'I can\'t even begin to describe it... you have to see this, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56047,'%s ambushes his helpless prey!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56048,'','Could it be? Can the jinyu really tap into the water\'s power that easily?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56049,'','I\'ve never seen anyone get a vision from these waters so easily.$B$BThen again, I can\'t remember the last time a jinyu came to visit us and then stuck his face in the water...',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(56050,'Playful Gold Serpent licks you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56051,'Playful Gold Serpent makes a fancy flip.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56052,'Playful Gold Serpent nips at you playfully.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56053,'Playful Gold Serpent wants to be petted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56054,'Playful Gold Serpent rubs affectionately against your arm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56055,'Playful Gold Serpent chases its own tail.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56056,'Playful Crimson Serpent licks you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56057,'Playful Crimson Serpent makes a fearsome face.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56058,'Playful Crimson Serpent roars with vigor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56059,'Playful Gold Serpent pounces at the air.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56060,'Playful Crimson Serpent nips at you experimentally.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56061,'Playful Crimson Serpent is bored.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56062,'Playful Emerald Serpent looks around curiously.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56063,'Playful Emerald Serpent sniffs you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56064,'Playful Emerald Serpent tries to eat your hair, and then spits it out. Yuck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56067,'Playful Emerald Serpent tumbles through the air.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56068,'Playful Emerald Serpent is sleepy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56069,'Playful Emerald Serpent wants to play a game!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56070,'Playful Azure Serpent plays with its own shadow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56071,'Playful Azure Serpent is hungry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56072,'Playful Azure Serpent wants a snack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56073,'Playful Azure Serpent wonders if you have a treat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56074,'Playful Azure Serpent licks itself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56075,'Playful Azure Serpent needs some love!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56076,'Choose a pet to fight for you in battle!','Choose a pet to fight for you in battle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56077,'Heroes, we must place this burden on your shoulders once again.  You must protect us from Deathwing\'s forces while we imbue the Soul with the powers of the great Aspects of Azeroth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56078,'You may begin your ritual, we will defend you.','You may begin your ritual, we will defend you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56079,'Our engines are damaged!  We\'re sitting ducks up here!','',0,0,0,0,0,0,0,0,1,0,26303,0,26124),
(56080,'It is good to see you again, Alexstrasza. I have been busy in my absence.','',0,0,0,0,0,0,457,0,0,0,26360,0,26124),
(56081,'','They... are my clutch no longer.  Bring them down.',0,0,0,0,0,0,18,0,0,0,0,26505,26124),
(56082,'This library holds thousands of years of history and lore. The greatest knowledge in all of Pandaria is kept here.$B$BThat is why we must keep this great treasure safe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56083,'The scrolls! I must save the scrolls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56084,'It is no use, the power of the Soul is too great. I cannot wield it safely; the raging forces within it may be the doom of us all.','',0,0,0,0,0,0,0,0,0,0,25904,0,26124),
(56085,'Investigating','Investigating',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56086,'Hee hee hee hee hee!','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(56087,'More power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56088,'So delicious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56089,'Careful with that there vial. She\'s a bit leaky.','',0,0,0,0,0,0,1,0,1,0,32505,0,26124),
(56090,'','Welcome to the Temple of the Jade Serpent. How may I help you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56091,'I\'d like to go inside the Temple of the Jade Serpent.','I\'d like to go inside the Temple of the Jade Serpent.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56092,'I have a message for the Jade Serpent.','I have a message for the Jade Serpent.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56093,'Are you finding everything you need at the Temple?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56094,'I would like to return to the temple grounds.','I would like to return to the temple grounds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56095,'','You\'ve been a really big help here at the Temple!$B$BI heard the Elder Sage say that he\'s glad you arrived when you did.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56096,'','Welcome to the Temple of the Jade Serpent, stranger. Our doors are open to all who seek knowledge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56097,'Teleport to the garden entrance.','Teleport to the garden entrance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56098,'','Why is all of your grain so bland?',0,0,0,0,0,0,1,0,1,0,0,30400,26124),
(56099,'','They have failed us sister.',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(56100,'','I have awakened only to sleep once again.',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(56101,'The grain we gather needs to be in large quantities for the brewery. But I may know of a grain that would suit your needs.','',0,0,0,0,0,0,1,0,1,0,31031,0,26124),
(56102,'It was a short time, for our part...','',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(56103,'... indeed it was.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56104,'There is perhaps a way...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56105,'Li Li... let\'s go. Your uncle has got something to prove.','',0,0,0,0,0,0,1,0,1,0,29681,0,26124),
(56106,'','%s smiles.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56107,'','Finally! THERE\'S the Uncle Chen I\'ve been waiting for.',0,0,0,0,0,0,11,0,1,0,0,30388,26124),
(56108,'Teleport to rejoin Illidan.','Teleport to rejoin Illidan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56109,'Teleport to Azshara\'s Palace.','Teleport to Azshara\'s Palace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56110,'Teleport to Azshara\'s Overlook.','Teleport to Azshara\'s Overlook.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56111,'Teleport to The Well of Eternity.','Teleport to The Well of Eternity.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56114,'First things first. We\'re going to need some sweet malts.','',0,0,0,0,0,0,273,0,1,0,29682,0,26124),
(56118,'Hm... don\'t get many $cs up this way...','Hm... don\'t get many $cs up this way...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56119,'Oh hello! Haven\'t seen you around before...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56120,'%s snaps its tether with a mighty effort, breaking free!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56121,'You can find your malts at the granary, I reckon.','',0,0,0,0,0,0,0,0,1,0,30954,0,26124),
(56122,'','Mudmug!',0,0,0,0,0,0,0,0,1,0,0,30389,26124),
(56123,'Mudmug!','',0,0,0,0,0,0,2,0,1,0,29683,0,26124),
(56124,'I\'m here to help with that fancy beer you was talkin\' about.','',0,0,0,0,0,0,1,0,1,0,30955,0,26124),
(56125,'Glad to have you. We will be making a stout. Can you get a few barrels of water?','',0,0,0,0,0,0,6,0,1,0,29684,0,26124),
(56126,'Git \'er done.','',0,0,0,0,0,0,273,0,1,0,30956,0,26124),
(56127,'Li Li, you get the malts. I will... research the local brews. We\'ll meet back here.','',0,0,0,0,0,0,404,0,1,0,29685,0,26124),
(56128,'','\"Research?\" Sure.',0,0,0,0,0,0,1,0,1,0,0,30390,26124),
(56129,'I apologize for the deception, but it was necessary.','',0,0,0,0,0,0,0,0,7,0,28571,0,26124),
(56130,'In thousands of years, we have never seen one of your kind.','',0,0,0,0,0,0,0,0,7,13211,28572,0,26124),
(56131,'It was imperative that I first measure the bearing of your heart.','',0,0,0,0,0,0,0,0,7,0,28573,0,26124),
(56132,'','Yet, I have witnessed that your actions speak of no evil.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56133,'','Alas, I have grown too weak to see the strands of fate.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56134,'','Which thread are you, I wonder? The one that unravels the pattern, or the one that holds it together?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56135,'','I grow old, little one. My time on this world is nearly done.',0,0,0,0,0,0,0,0,1,0,0,28576,26124),
(56136,'','Do you see the great statue in the distance?',0,0,0,0,0,0,0,0,1,0,0,28577,26124),
(56137,'','The builders have toiled for many years, and it is nearly complete.',0,0,0,0,0,0,0,0,1,0,0,28578,26124),
(56138,'','A little more jade - the jade you helped to acquire - and it will be finished.',0,0,0,0,0,0,0,0,1,0,0,28579,26124),
(56139,'','With my last breath, I will transfer my life essence into the statue, and a new guardian will be born.',0,0,0,0,0,0,0,0,1,0,0,28580,26124),
(56140,'','Someday, you may also be called upon to defend all that is dear to you.',0,0,0,0,0,0,0,0,1,0,0,28582,26124),
(56141,'','Do not be saddened. The cycle is clear - it neither begins nor ends with me.',0,0,0,0,0,0,0,0,1,0,0,28581,26124),
(56142,'','Revere those who have gone the way of dust.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56143,'','Celebrate the life you are given on this earth.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56144,'','For everything that you take, give double in kind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56145,'','Only in this way will our wisdom be passed forward through time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56146,'','This is how we live on, for all eternity.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56147,'','I grow weary. I must rest now.',0,0,0,0,0,0,0,0,1,0,0,28585,26124),
(56148,'','Choose wisely, young one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56149,'This grain tastes too old, bitter, and angry.','This grain tastes too old, bitter, and angry.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56150,'This grain tastes too light and bouncy.','This grain tastes too light and bouncy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56151,'This grain has too much zing.','This grain has too much zing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56152,'No, there won\'t be any taste tests today. Not until someone helps me get my stolen grain back!','No, there won\'t be any taste tests today. Not until someone helps me get my stolen grain back!',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(56153,'This grain tastes too earthy and natural.','This grain tastes too earthy and natural.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56154,'Come ride with me, little one. There is something I wish you to see.','',0,0,0,0,0,0,0,0,7,0,28574,0,26124),
(56155,'Transmogrification','Transmogrification',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(56156,'','%s screeches in pain and retreats into the swirling clouds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56157,'','The Temple Priests are too frightened to face the truth...',0,0,0,0,0,0,0,0,1,0,0,28575,26124),
(56158,'5...','5...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56159,'4...','4...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56160,'3...','3...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56161,'2...','2...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56162,'1...','1...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56163,'First, go water my Bright Green Spinach!','First, go water my Bright Green Spinach!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56164,'Good enough! Now go water my Giant Carrots!','Good enough! Now go water my Giant Carrots!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56165,'Keep going! Water my Cabbages!','Keep going! Water my Cabbages!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56166,'Don\'t stop moving! Water those Sugar Beets!','Don\'t stop moving! Water those Sugar Beets!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56167,'Go water my Huge Melons, further down the path!','Go water my Huge Melons, further down the path!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56168,'Keep it up! Now water my Red-Leaf Lettuce!','Keep it up! Now water my Red-Leaf Lettuce!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56169,'Looks like my Sugar Beets still need more water! Turn back!','Looks like my Sugar Beets still need more water! Turn back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56171,'Water my Bright Green Spinach!','Water my Bright Green Spinach!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56172,'Water my Giant Carrots!','Water my Giant Carrots!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56173,'Water my Cabbages!','Water my Cabbages!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56174,'Water my Sugar Beets!','Water my Sugar Beets!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56175,'Water my Huge Melons!','Water my Huge Melons!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56176,'Water my Red-Leaf Lettuce!','Water my Red-Leaf Lettuce!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56177,'Water my Elephant Garlic!','Water my Elephant Garlic!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56178,'Were you looking to Reforge an item? I no longer provide such services.\n\nThe ethereals of \"Three Winds\" in Stormwind\'s Cathedral District will help you, though.\n\nAny of the city\'s guards can provide directions.','Were you looking to Reforge an item? I no longer provide such services.\n\nThe ethereals of \"Three Winds\" in Stormwind\'s Cathedral District will help you, though.\n\nAny of the city\'s guards can provide directions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56179,'Were you looking to Reforge an item? I no longer provide such services.\n\nThe ethereals of Orgrimmar\'s Drag will help you, though.\n\nAny of the city\'s guards can provide directions.','Were you looking to Reforge an item? I no longer provide such services.\n\nThe ethereals of Orgrimmar\'s Drag will help you, though.\n\nAny of the city\'s guards can provide directions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56180,'No no no! Return to me, and we\'ll try again!','No no no! Return to me, and we\'ll try again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56181,'','To be a serpent rider, one must not fear pain.',0,0,0,0,0,0,0,0,1,0,0,27610,26124),
(56182,'','Be aware of your serpent\'s movements. Focus, then strike as one!',0,0,0,0,0,0,0,0,1,0,0,27611,26124),
(56183,'','Yesterday, today, tomorrow...you and your serpent act as one.',0,0,0,0,0,0,0,0,1,0,0,27612,26124),
(56184,'','When you chose this path, you bound your life to that of your serpent. Do not fail them now!',0,0,0,0,0,0,0,0,1,0,0,27613,26124),
(56185,'','Weakness will not be tolerated. Only strength prevails!',0,0,0,0,0,0,0,0,1,0,0,27614,26124),
(56186,'','Train your serpents well. A bond of trust is your strongest weapon.',0,0,0,0,0,0,0,0,1,0,0,27615,26124),
(56187,'','The serpent rider\'s path is drenched in blood and tears. Your journey has just begun!',0,0,0,0,0,0,0,0,1,0,0,27616,26124),
(56188,'You looking for something, $r? You look like you\'re looking for something.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56189,'I\'m ready to go!','I\'m ready to go!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56190,'The watering can is empty. Return to Gardener Fran.','The watering can is empty. Return to Gardener Fran.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56191,'You just watered that spot! Don\'t get lazy on me!','You just watered that spot! Don\'t get lazy on me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56192,'Oh, hello stranger. Very sorry for the mess here. Normally this granary is in tip top super efficient status.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56193,'Welcome to the Imperial Granary.$b$BThough not so \"imperious\" today with this sprite infestation. Oh, um, you didn\'t hear that. Or see, for that matter.$b$BIn fact, can you not tell anyone you ever came here and especially not say anything about this sprite fiasco?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56194,'You buy one wrong grain and suddenly the world falls apart. Now we have a sprite infestation and migrating birds to boot.$b$BI was just trying to help us hit our quota to the Stormstout Brewery!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56195,'There was a time when my father would spend days in the jungle hunting for the perfect cave barley.$b$BIt was very dangerous, and something I can\'t bring myself to do.$b$BNot worth it. Stormstout only pays for quantity, not quality.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56196,'Well, we may still be crawling with sprites, but I certainly appreciate the help you gave us. You really are quite the travelling hero.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56197,'Even with this fiasco I am once again starting to hit my quota. Something is up with the Stormstout brewery lately in that they haven\'t been demanding quite as much grain as usual.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56198,'If you ever find yourself travelling to the west off the beaten path keep a weather eye out for my eccentric father. He never enjoyed the increased business from the Stormstouts.$b$BI grew up listening to how we were \"brewing out originallity.\" He is quite the beer snob.$b$BStill, he might have a trinket or story you might find interesting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56201,'Look, there\'s a weed now! Go pull it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56202,'Some more weeds, over here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56203,'Keep it up, you\'re doing great!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56204,'Just go stomp on those little weeds. No need to waste your time picking them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56205,'Here, I\'ve got some spare Weed-B-Gone. This should help.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56206,'Look out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56207,'Here\'s some more Weed-B-Gone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56208,'Looks like things are finally starting to calm down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56209,'Click on weeds to pull them!','Click on weeds to pull them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56210,'Walk over small weeds!','Walk over small weeds!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56211,'Pick up the Weed-B-Gone!','Pick up the Weed-B-Gone!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56212,'Oof! What are you doing?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56213,'Ow! Stop it! I\'m waiting for the thunderbirds to take me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56214,'Here they come...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56215,'Why?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56216,'Just leave me here or they\'ll take you too!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56217,'Ugh... I\'m getting dizzy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56218,'You\'re crazy, you know that? Here comes another!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56219,'I\'m keeping my fields fallow this season. A wise farmer knows when the land needs to rest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56220,'Well, aren\'t you going to pick the weeds?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56221,'What weeds?','What weeds?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56222,'Take a look around, $n!$b$bWe\'ve turned these monkeys into a bonifide army while you were away!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(56223,'I was tasked with finding more productive ways to make silk. In my hubris, I created monsters! This is a shame I will carry to the end of my days.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56224,'Panda lady! Do a dance on top of the carrot!','',0,0,0,0,0,0,0,0,1,13439,0,0,26124),
(56225,'Yes, good! Move those furry feets!','',0,0,0,0,0,0,0,0,1,13439,0,0,26124),
(56226,'Now blow me a kiss while you stand on the big carrot!','',0,0,0,0,0,0,0,0,1,13439,0,0,26124),
(56227,'Panda lady! Sit down on the carrot!','',0,0,0,0,0,0,0,0,1,13439,0,0,26124),
(56228,'Now stand up!','',0,0,0,0,0,0,0,0,1,13439,0,0,26124),
(56229,'Now sit down and stand up lots of times in a row!','',0,0,0,0,0,0,0,0,1,13439,0,0,26124),
(56230,'Aww yeah...','',0,0,0,0,0,0,0,0,1,13439,0,0,26124),
(56231,'Panda lady! I have an idea!','',0,0,0,0,0,0,0,0,1,13439,0,0,26124),
(56232,'Here, you hold little carrot while you stand on big carrot!','',0,0,0,0,0,0,0,0,1,13439,0,0,26124),
(56233,'Yeah, you hold that carrot. That\'s right.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56234,'Panda lady! Catch this carrot!','',0,0,0,0,0,0,0,0,1,13439,0,0,26124),
(56235,'Now throw it at me!','',0,0,0,0,0,0,0,0,1,13439,0,0,26124),
(56236,'Throw it really hard at my face!','',0,0,0,0,0,0,0,0,1,13439,0,0,26124),
(56237,'Ahhh...','',0,0,0,0,0,0,0,0,1,13439,0,0,26124),
(56238,'Panda lady! Catch!','',0,0,0,0,0,0,0,0,1,13439,0,0,26124),
(56239,'Now eat the carrot!','',0,0,0,0,0,0,0,0,1,13439,0,0,26124),
(56240,'NO! Eat it slower!','',0,0,0,0,0,0,0,0,1,13439,0,0,26124),
(56241,'Mm-hmm. That\'s nice, panda lady.','',0,0,0,0,0,0,0,0,1,13439,0,0,26124),
(56242,'I\'m helping a friend brew some beer, and we need hops. Do you have any to spare?','I\'m helping a friend brew some beer, and we need hops. Do you have any to spare?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56243,'Can I buy some hops from you?','Can I buy some hops from you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56244,'Do you have any hops you can spare?','Do you have any hops you can spare?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56245,'','I suppose you did help me water my plants. Very well... I\'ll have the hops sent to your friend Chen, in Halfhill.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56246,'','Nothing is free, $r. You want hops, you need to work.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56247,'Of course! After helping me with those weeds, sharing some hops is the least I can do. I\'ll have the hops delivered to Master Stormstout, in Halfhill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56248,'Would that I could, $c, but I have a bit of a weed problem. Say... you wouldn\'t be willing to help out, would you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56249,'Certainly. Kill a few virmen, earn a few bushels of hops. I\'ll have Mung-Mung send them to Halfhill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56250,'You\'ll have to ask Mung-Mung about that. He maintains our foodstores.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56251,'','You said you needed hops? Very well. I\'ll send some to Halfhill.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56252,'You are a lifesaver, $c. I will have your hops delivered to Halfhill right away.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56253,'Riko got this bitch on lockdown!$b$bPlenty of slickies for hozen army!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56254,'You say you want hops? No problem. You kill virmen for me, Mung-Mung send some hops to Halfhill for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56255,'Virmen! Gah! Their numbers are endless!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56256,'Mina! You\'re home!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56257,'','Dad... I never want to see another carrot again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56258,'Take me to the Maelstrom.','Take me to the Maelstrom.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56259,'Take me to the deck of The Skyfire to fight Blackhorn.','Take me to the deck of The Skyfire to fight Blackhorn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56260,'Take me to the summit of Wyrmrest Temple to fight Hagara.','Take me to the summit of Wyrmrest Temple to fight Hagara.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56261,'Take me to the base of Wyrmrest Temple to fight Yor\'sahj and Zon\'ozz.','Take me to the base of Wyrmrest Temple to fight Yor\'sahj and Zon\'ozz.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56262,'','So... many... carrots...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56263,'Come on, Mina. Let\'s get you out of here.','Come on, Mina. Let\'s get you out of here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56264,'A drake swoops down to drop a Twilight Sapper onto the deck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56265,'The Sha have broken out of the temple. We must beat them back...or die trying.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56266,'Greetings, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56267,'','Let\'s go home.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56268,'','Sure, you can ride on a mount while you water the plants. Why should I care?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56269,'Wyrmrest Accord, Attack!','',0,0,0,0,0,0,0,0,1,0,26531,0,26124),
(56270,'Tyrygosa yet lives! We must press on, to the Temple!','',0,0,0,0,0,0,0,0,1,0,26532,0,26124),
(56271,'Left... Left! LEEEFFFFTTTT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56272,'No! Right! Go Right!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56273,'Aaaaaaahhh! We\'re all doomed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56274,'Buuurrrnn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56275,'Stomp now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56276,'Advance to the front!','',0,0,0,0,0,0,0,0,1,0,26533,0,26124),
(56277,'The siege must be broken. Wyrmrest Accord, defend the line!','',0,0,0,0,0,0,0,0,1,0,26534,0,26124),
(56278,'My journeyman often forgets that one must expect to fail many times in the pursuit of perfection.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56279,'You seem to me to be one who has had many experiences.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56280,'What interesting garb you wear. By whose hand was it threaded, if I may ask?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56281,'I remember a time when the venerable Silkmaster Tsai created a strand of silk so fine it sliced through the earth when he dropped it. We never saw it again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56282,'I remember my first experiment gone awry. These fields were crawling with super grubs the likes of which had not been seen in this age of the world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56283,'Loommaster Jeng once spun a weave of silk so thin and smooth that it slipped through a crack in time. It hasn\'t re-appeared yet but we expect it one of these days.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56284,'Greetings stranger. I am Silkmaster Tsai. Welcome to the ancient Imperial Silk Farm.$b$bThis farm dates back to some of the earliest dynasties of Pandaria, and each generation exceeds the last in quality of silk.','',2,1,0,0,0,0,0,0,1,0,0,0,26124),
(56285,'Your clothing appears as one well travelled. Quite an interesting look. I might use it in one of my future clothing lines. I shall call it:$b$b$pique.','',2,1,0,0,0,0,0,0,1,0,0,0,26124),
(56286,'The boots, no. The belt, oh very much no. The shirt, stunning, but not on you. We should get you a real cape. And perhaps a vest with a proper hero\'s cut.','',274,1,0,0,0,0,0,0,1,0,0,0,26124),
(56287,'You remind me of a young Master Goh, minus the girth.$b$BHe first came to me a farm boy dressed in rags but with a stylish stride to him that owned the look.$B$bTogether we made a clothing line that was all the rage in the east for at least two years.','',1,11,0,0,0,0,0,0,1,0,0,0,26124),
(56288,'Go away.','Go away.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56289,'Leave me alone.','Leave me alone.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56290,'What\'s the point anymore?','What\'s the point anymore?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56291,'What do you want?','What do you want?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56292,'Let me be.','Let me be.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56293,'...','...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56294,'Stop crowding me, everybody\'s always crowding around in this village. There\'s no space.','Stop crowding me, everybody\'s always crowding around in this village. There\'s no space.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56295,'It\'s raining still. And freezing. At least we haven\'t had a typhoon lately.','It\'s raining still. And freezing. At least we haven\'t had a typhoon lately.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56296,'Oh, bother.','Oh, bother.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56297,'A banana in hand is worth than two in bush.','A banana in hand is worth than two in bush.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56298,'Oh, great. An adventurer. Just what I needed.','Oh, great. An adventurer. Just what I needed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56299,'Not much of a day. Just right for not much of a life.','Not much of a day. Just right for not much of a life.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56300,'A little rain never hurt anybody... yet.','A little rain never hurt anybody... yet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56301,'What day is it? Nobody tells me anything.','What day is it? Nobody tells me anything.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56302,'Don\'t bother me.','Don\'t bother me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56303,'How could this happen to me? I\'m sick of this life.','How could this happen to me? I\'m sick of this life.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56304,'Welcome aboard the Skyfire. You ready to chase down the end of the world?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56305,'We are the Alliance. We are always ready.','We are the Alliance. We are always ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56306,'JUSTICE AND GLORY!','JUSTICE AND GLORY!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56307,'OW!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56308,'OW! MY FACE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56309,'BAD WORM! THAT\'S A BAD BAD BAD WORM!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56310,'Eat up big fella.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(56311,'We are the Horde. We are always ready.','We are the Horde. We are always ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56312,'The Twilight\'s Hammer is retreating! The temple is ours; fortify your positions within!','',0,0,0,0,0,0,0,0,1,0,26535,0,26124),
(56313,'Ah, good to see you, my friend!$B$BHungry?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56314,'Hey, sorry about that bottle, by the way. It\'s actually better to keep all the old slime in there - it ages like a fine brew.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56315,'You can tell a lot about a designer in how they weave their fabric together. Yours has the look of function over pride.$b$bTightly sealed with mana infused right into the fabric. Impressive, though it could benefit from an artistic hand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56316,'Master, I lost my torch.','Master, I lost my torch.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56317,'','I hate incompetent raiders.',0,0,0,0,0,0,0,0,1,0,0,25780,26124),
(56318,'','I still hate you.',0,0,0,0,0,0,0,0,1,0,0,25781,26124),
(56319,'','Do you hate me? Good.',0,0,0,0,0,0,0,0,1,0,0,25782,26124),
(56320,'','I hate mercy.',0,0,0,0,0,0,0,0,1,0,0,25783,26124),
(56321,'','I didn\'t hate that.',0,0,0,0,0,0,0,0,1,0,0,25784,26124),
(56322,'','I hate adventurers.',0,0,0,0,0,0,0,0,1,0,0,25777,26124),
(56323,'','I hate... every one of you...',0,0,0,0,0,0,0,0,1,0,0,25778,26124),
(56324,'','I hate you all!',0,0,0,0,0,0,0,0,1,0,0,25790,26124),
(56325,'','I hate standing still.',0,0,0,0,0,0,0,0,1,0,0,25791,26124),
(56326,'','Feel my hatred!',0,0,0,0,0,0,0,0,1,0,0,25787,26124),
(56327,'','My hatred burns!',0,0,0,0,0,0,0,0,1,0,0,25788,26124),
(56328,'','My hate will consume you!',0,0,0,0,0,0,0,0,1,0,0,25789,26124),
(56329,'','I hate armor.',0,0,0,0,0,0,0,0,1,0,0,25785,26124),
(56330,'','I hate martyrs.',0,0,0,0,0,0,0,0,1,0,0,25786,26124),
(56331,'','How I HATE this place. My captors may be long-dead, but don\'t think I won\'t take it all out on you miserable treasure-hunters.',0,0,0,0,0,0,0,0,1,0,0,25779,26124),
(56333,'The reeds of the Singing Pools are the hardest in all of the land, but they are as air before my mighty brow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56334,'Many have tested my claim, and I yet stand proven.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56335,'Anybody out there?','',0,0,0,0,0,0,0,0,1,13476,0,0,26124),
(56336,'Help!','',0,0,0,0,0,0,0,0,1,13476,0,0,26124),
(56337,'A little help here?','',0,0,0,0,0,0,0,0,1,13476,0,0,26124),
(56338,'It\'s dark in here!','',0,0,0,0,0,0,0,0,1,13476,0,0,26124),
(56339,'Someone get me outta here!','',0,0,0,0,0,0,0,0,1,13476,0,0,26124),
(56340,'Heeelllp!','',0,0,0,0,0,0,0,0,1,13476,0,0,26124),
(56341,'Get me out of this barrel!','',0,0,0,0,0,0,0,0,1,13476,0,0,26124),
(56342,'Can anybody hear me?','',0,0,0,0,0,0,0,0,1,13476,0,0,26124),
(56343,'Our crafters build the finest wooden planks.  They would weather the most brutal of storms.  But they are as water before the storm of my crushing skull.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(56344,'Nothing made by pandaren hands can withstand me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56345,'Mothallus is defeated! Hurray for $p!','',0,0,0,0,0,0,0,0,1,13511,0,0,26124),
(56346,'The beast has been defeated! Hurray!','',0,0,0,0,0,0,0,0,1,13533,0,0,26124),
(56347,'Thanks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56348,'I need a beer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56349,'You have no idea how long I was in there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56350,'Ach! The light... it hurts our eyes...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56351,'Better get out of here before he comes by again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56352,'Finally!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56353,'Thank you, kind... OH NO, HERE HE COMES AGAIN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56354,'I suppose there are worse fates than being stuck forever inside a beer barrel.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56355,'These are the densest stones across all of Shen-zin Su, yet they are as nothing before my mighty head.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56356,'Any who yet doubt my strength are simply foolish.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56357,'Surprise!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56358,'Thank you! I will try to break some of that silk shield off.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56359,'So sticky! I\'ll try to bring that moth down for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56360,'Thank you stranger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56361,'There is only one thing to do.  I must smash it!  Once and for all, all shall know the power of my mighty brow.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(56362,'Oh... my head... it hurts so badly!  I\'ve... the pillar must contain enormous power... perhaps stronger even than my brow...','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(56363,'This is magnificent!  I\'ve never seen craftsmanship so fine.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(56364,'I\'m... I\'m just going to lie down a while... until this headache goes away.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56365,'%s gets absorbed into the Maw of Go\'rath','%s gets absorbed into the Maw of Go\'rath',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56366,'','They have broken our defenses... the very earth turns against us in Deathwing\'s name.',0,0,0,0,0,0,0,0,1,0,0,26305,26124),
(56367,'','Alizabal skewers $n to the ground.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56368,'See you on the other side, $n.','',0,0,0,0,0,0,1,0,1,0,29648,0,26124),
(56369,'Mudmug, Li Li... follow me!','',0,0,0,0,0,0,0,0,1,13492,29649,0,26124),
(56370,'Li Li, Mudmug, wait up!','',0,0,0,0,0,0,22,0,1,13493,29650,0,26124),
(56371,'Li Li, wait up!','',0,0,0,0,0,0,22,0,1,13494,29651,0,26124),
(56372,'I\'d better catch up Mudmug.','',0,0,0,0,0,0,0,0,1,13495,29652,0,26124),
(56373,'','I\'m going ahead to see if there\'s anything I can do to help.',0,0,0,0,0,0,1,0,1,0,0,30368,26124),
(56374,'','Uncle Chen, Mudmug! Race you there!',0,0,0,0,0,0,0,0,1,13496,0,30369,26124),
(56375,'','Hey, you old jerks! You left me behind!',0,0,0,0,0,0,0,0,1,13497,0,30370,26124),
(56376,'','Hey, you dumb old uncle! You left me behind!',0,0,0,0,0,0,0,0,1,13498,0,30371,26124),
(56377,'','See you there, Uncle Chen!',0,0,0,0,0,0,0,0,1,13499,0,30372,26124),
(56378,'The brewery\'s got a second entrance, over yonder.','',0,0,0,0,0,0,396,0,1,0,30949,0,26124),
(56379,'I reckon I\'ll see you over there.','',0,0,0,0,0,0,0,0,1,13500,30950,0,26124),
(56380,'Where\'d those other two go? Did they leave me behind? Don\'t nobody care about Mudmug?','',0,0,0,0,0,0,0,0,1,13501,30951,0,26124),
(56381,'I suppose I\'ll be off then. You a-comin\', Li Li?','',0,0,0,0,0,0,0,0,1,13502,30952,0,26124),
(56382,'I suppose I\'ll be off then. You a-comin\', Chen?','',0,0,0,0,0,0,0,0,1,13503,30953,0,26124),
(56383,'','So... do any of you know where the hidden master lives?',0,0,0,0,0,0,6,0,1,0,0,30881,26124),
(56384,'I\'m pretty sure that\'s why he\'s called the hidden master, Lin.','',0,0,0,0,0,0,1,0,1,0,31909,0,26124),
(56385,'','Oh. Sorry.',0,0,0,0,0,0,24,0,1,0,0,30882,26124),
(56386,'','So, where should we search first?',0,0,0,0,0,0,6,0,1,0,0,30883,26124),
(56387,'I can try asking the streams for guidance...','',0,0,0,0,0,0,6,0,1,0,30691,0,26124),
(56388,'Ask the streams? You\'re no elder, Ashyo. You\'re not even a jinyu grown yet. It would be a waste of your time.','',0,0,0,0,0,0,274,0,1,0,31938,0,26124),
(56389,'Ken-Ken thinks we split up. Follow the four winds.','',0,0,0,0,0,0,1,0,1,0,30866,0,26124),
(56390,'That\'s a much better idea, Ken-Ken. I volunteer to travel south, into the jungle.','',0,0,0,0,0,0,1,0,1,0,31939,0,26124),
(56391,'I will follow the north wind.','',0,0,0,0,0,0,1,0,1,0,30692,0,26124),
(56392,'Ken-Ken go chase east wind. Shortest walk.','',0,0,0,0,0,0,1,0,1,0,30867,0,26124),
(56393,'','I... I suppose I\'ll go west, then.',0,0,0,0,0,0,1,0,1,0,0,30884,26124),
(56394,'Very well. As the oldest and fattest among us, I will wait here for each of you to return.','',0,0,0,0,0,0,273,0,1,0,31910,0,26124),
(56395,'Good luck, friends. Once we find the Hidden Master, we can continue our training.','',0,0,0,0,0,0,1,0,1,0,31911,0,26124),
(56396,'Firelands on the Test Realm has been reserved for a special event.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56397,'Teleport to Shannox','Teleport to Shannox',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56398,'Teleport to Lord Rhyolith','Teleport to Lord Rhyolith',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56399,'Teleport to Beth\'tilac','Teleport to Beth\'tilac',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56400,'Teleport to Alysrazor','Teleport to Alysrazor',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56401,'Teleport to Baleroc','Teleport to Baleroc',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56402,'Teleport to Fandral','Teleport to Fandral',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56403,'Teleport to Ragnaros','Teleport to Ragnaros',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56404,'I am able to teleport you near any of the boss encounters here in Firelands.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56405,'The race to defeat the Firelands has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56406,'Hello friend!  You\'re welcome to use my cart if you like.  It will take you to the Dai-Lo Farmstead.','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(56407,'Very well, $n. I will need your help making this beer.','',0,0,0,0,0,0,1,0,1,0,29725,0,26124),
(56408,'When I yell out the names of ingredients, you throw them in the pot...','',0,0,0,0,0,0,1,0,1,0,29726,0,26124),
(56409,'I am kidding!','',0,0,0,0,0,0,5,0,1,0,29727,0,26124),
(56410,'I am the best brewer across three continents! I think I can handle this part.','',0,0,0,0,0,0,1,0,1,0,29728,0,26124),
(56411,'Damn straight ya can!','',0,0,0,0,0,0,71,0,1,0,32503,0,26124),
(56412,'If you wouldn\'t mind waiting, $n... this might take a long time.','',0,0,0,0,0,0,1,0,1,0,29729,0,26124),
(56413,'','That DID take a long time!',0,0,0,0,0,0,1,0,1,0,0,30539,26124),
(56414,'Mothallus approaches!','Mothallus approaches!',0,0,0,0,0,0,0,0,1,13511,0,0,26124),
(56415,'Hello friend!  You\'re welcome to use my cart if you like.  It will take you to the Temple of Five Dawns.','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(56416,'You just won a kickin\' rad poster! Raise your hand in the air like you just don\'t care!','',378,0,0,0,0,0,0,0,1,0,0,0,26124),
(56417,'Shouldn\'t you be training, young $c?$B$BDiscipline your mind and body, and there is little that you cannot achieve.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56420,'My money\'s on Lam. Did you see him take down Chu during training last week?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(56421,'That\'s where you\'re mistaken, friend. Zhou is as sturdy as an oak.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(56422,'Zhou has the stamina of three men, so he can out-stay most opponents.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56423,'His stamina is nothing against Lam\'s strength.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56424,'He has the legs of an ox! Have you ever been kicked by him in training?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(56427,'Four coppers on Zhou.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56428,'Raise you a keg of Stormstout Gold. It\'ll be your loss.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56429,'Silk farming is a dangerous business.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56430,'Your form is impeccable.','Your form is impeccable.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56431,'Such skill for a new trainee.','Such skill for a new trainee.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56432,'One day you will have to teach me your secrets.','One day you will have to teach me your secrets.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56433,'That target didn\'t stand a chance.','That target didn\'t stand a chance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56434,'I hope the instructors saw that!','I hope the instructors saw that!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56435,'You are bound for a great things, trainee.','You are bound for a great things, trainee.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56436,'I must work as hard as you.','I must work as hard as you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56437,'I must train harder so I can be like you.','I must train harder so I can be like you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56438,'You are an honorable opponent.','You are an honorable opponent.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56439,'Thank you for reminding me that I must train more diligently.','Thank you for reminding me that I must train more diligently.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56440,'You fight honorably, friend.','You fight honorably, friend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56441,'My skills are no match for yours. I admit defeat.','My skills are no match for yours. I admit defeat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56442,'Your skills are too great. I yield.','Your skills are too great. I yield.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56443,'You fought well. I must learn more from you in the future.','You fought well. I must learn more from you in the future.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56444,'That was a good match. Thank you.','That was a good match. Thank you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56445,'I have never seen a trainee with skills such as yours. I must tell the others.','I have never seen a trainee with skills such as yours. I must tell the others.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56446,'< PLACEHOLDER : You discover that the egg has hatched into Black Prince Wrathion! >','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56447,'As you know, Black Dragons frequently disguise themselves as humanoids in order to tamper with mortal affairs.','',0,0,0,0,0,0,0,0,1,0,26446,0,26124),
(56448,'While the house of my mad father collapses around him, the few remaining Black Dragons have gone into hiding.','',0,0,0,0,0,0,0,0,1,0,26447,0,26124),
(56449,'But I can still sense them. My cowardly brothers and sisters will cause untold suffering if we allow them to stay in the shadows.','',0,0,0,0,0,0,0,0,1,0,26448,0,26124),
(56450,'Moreover, they are a threat to me.','',0,0,0,0,0,0,0,0,1,0,26449,0,26124),
(56451,'That\'s where you come in. Help us to slay them all, and I will reward you handsomely.','',0,0,0,0,0,0,1,0,1,0,26450,0,26124),
(56452,'I couldn\'t have fought them off alone. Now, if you\'ll excuse me, I should go find my cart.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(56453,'Cart!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(56454,'Hello, cart. Still upside-downed, I see.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(56455,'No mortal shall turn me from my task.','',0,0,0,0,0,0,0,0,1,0,26282,0,26124),
(56456,'You seek to halt an avalanche. I will bury you.','',0,0,0,0,0,0,0,0,1,0,26268,0,26124),
(56457,'You thought to fight me alone? The earth splits to swallow and crush you.','',0,0,0,0,0,0,0,0,1,0,26288,0,26124),
(56458,'Impossible. This cannot be. The tower... must... fall...','',0,0,0,0,0,0,0,0,1,0,26269,0,26124),
(56459,'I am unstoppable.','',0,0,0,0,0,0,0,0,1,0,26285,0,26124),
(56460,'It was inevitable.','',0,0,0,0,0,0,0,0,1,0,26286,0,26124),
(56461,'Ground to dust.','',0,0,0,0,0,0,0,0,1,0,26287,0,26124),
(56462,'The stone calls...','',0,0,0,0,0,0,0,0,1,0,26274,0,26124),
(56463,'The ground shakes...','',0,0,0,0,0,0,0,0,1,0,26275,0,26124),
(56464,'A-ha ha! You are hopelessly outmatched!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56465,'The rocks tremble...','',0,0,0,0,0,0,0,0,1,0,26276,0,26124),
(56466,'The surface quakes...','',0,0,0,0,0,0,0,0,1,0,26277,0,26124),
(56467,'...and the black blood of the earth consumes you.','',0,0,0,0,0,0,0,0,1,0,26278,0,26124),
(56468,'...and there is no escape from the Old Gods.','',0,0,0,0,0,0,0,0,1,0,26279,0,26124),
(56469,'...and the rage of the true gods follows.','',0,0,0,0,0,0,0,0,1,0,26280,0,26124),
(56470,'...and you drown in the hate of The Master.','',0,0,0,0,0,0,0,0,1,0,26281,0,26124),
(56471,'Flee, and die.','',0,0,0,0,0,0,0,0,1,0,26283,0,26124),
(56472,'Run, and perish.','',0,0,0,0,0,0,0,0,1,0,26284,0,26124),
(56473,'Look out! Its friendses are coming!','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(56474,'Run away!','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(56475,'Cowards. Weaklings. Come down and fight, or I will bring you down.','',0,0,0,0,0,0,0,0,1,0,26270,0,26124),
(56476,'You cannot hide in this temple forever, Shaman.','',0,0,0,0,0,0,0,0,1,0,26271,0,26124),
(56477,'I will turn this tower to rubble, and scatter it across the wastes.','',0,0,0,0,0,0,0,0,1,0,26272,0,26124),
(56478,'Wyrmrest will fall. All will be dust.','',0,0,0,0,0,0,0,0,1,0,26273,0,26124),
(56479,'Your first target is here, in the ruins of Gilneas. I\'ve lost some of my best men already: let\'s see if you can fare any better.','',0,0,0,0,0,0,0,0,1,0,26378,0,26124),
(56480,'If he succeeds in looting the whole of Gilneas, there\'s no telling where he\'ll hide next. Now is the time to strike.','',0,0,0,0,0,0,0,0,1,0,26380,0,26124),
(56481,'The dragon you\'re looking for goes by the name \"Creed.\"','',0,0,0,0,0,0,0,0,1,0,26451,0,26124),
(56482,'He\'s deluded a group of diseased humans into thinking they can take their land back. He\'s poisoned their blood with his own draconic essence.','',0,0,0,0,0,0,0,0,1,0,26452,0,26124),
(56483,'The trainees will be quite disappointed if I don\'t get all of these kegs back together for them. What a mess...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56484,'You\'ve become strong indeed, child. This is good. You will need that strength soon.','',0,0,0,0,0,0,1,0,1,0,27803,0,26124),
(56485,'And here we are. Help me with a couple small tasks while I prepare, if you would.','',0,0,0,0,0,0,1,0,1,0,27805,0,26124),
(56486,'[Pending Cinematic] Aysa rushes towards the ship, only to find Ji running out to escape the coming explosion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56487,'[Pending Cinematic] Ji holds Aysa back, not wanting her to get hurt.  She struggles and yells, fearful that Shen-zin Su will be irreparably healed, and angry that Ji would do something so rash without consulting her.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56488,'[Pending Cinematic] The ship explodes GLORIOUSLY.  Ji and Aysa are sent flying to the ground farther away, but are largely unhurt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56489,'[Pending Cinematic] Both rise to look back at the hole where the ship had been.  A river of blood pours from the wound in Shen-zin Su.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56490,'Watch out! That\'s how our other 12 assassins got killed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56491,'You see? They\'re wild animals in there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56492,'Zazzo to the rescue! Keep trying...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56493,'It\'s okay, $n. I\'ve got you... this time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56494,'Watch where you\'re going! They\'re everywhere in that city...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56495,'You call that sneaking?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56496,'One cannot simply FLY into Gilneas City!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56497,'Whoa whoa whoa - they\'ve got snipers on all the rooftops. You\'ll have to go in by foot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56498,'You can\'t just fly in there - you\'ll be spotted for sure. Don\'t you think we\'ve already tried that?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56499,'Over here - an assassin!','Show yourself!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56500,'Intruder!','Protect Lord Creed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56501,'Get $ghim:her;!','Take $ghim:her; out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56502,'What have we here?','I see you...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56503,'Destroy $ghim:her;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56504,'I can smell you, thief!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56505,'Die, assassin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56506,'Mothallus ascends, free the Mothfighters from their cocoons so they can bring her down.','Mothallus ascends, free the Mothfighters from their cocoons so they can bring her down.',0,0,0,0,0,0,0,0,1,13511,0,0,26124),
(56507,'Mothallus is down. Attack!','Mothallus is down. Attack!',0,0,0,0,0,0,0,0,1,13511,0,0,26124),
(56508,'We will reclaim this world.','',0,0,0,0,0,0,0,0,1,0,32654,0,26124),
(56509,'You will fail!','',0,0,0,0,0,0,0,0,1,0,32655,0,26124),
(56510,'Your fragile minds are your greatest weakness.','',0,0,0,0,0,0,0,0,1,0,32656,0,26124),
(56511,'Your world will end in darkness!','',0,0,0,0,0,0,0,0,1,0,32657,0,26124),
(56512,'No...it cannot be...','',0,0,0,0,0,0,0,0,1,0,32650,0,26124),
(56513,'I will return...','',0,0,0,0,0,0,0,0,1,0,32651,0,26124),
(56514,'You cannot destroy us...','',0,0,0,0,0,0,0,0,1,0,32652,0,26124),
(56515,'You cannot hope to stop us...','',0,0,0,0,0,0,0,0,1,0,32653,0,26124),
(56516,'The light blinds me!','',0,0,0,0,0,0,0,0,1,0,32658,0,26124),
(56517,'I cannot stand...this sound!','',0,0,0,0,0,0,0,0,1,0,32659,0,26124),
(56518,'What have you done to me?','',0,0,0,0,0,0,0,0,1,0,32660,0,26124),
(56519,'My powers are drained!','',0,0,0,0,0,0,0,0,1,0,32661,0,26124),
(56520,'Assassin, eh? Who sent you? Speak, or I will carve the answer from your skull!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56521,'I will never forget the help you gave us or the shame you spared me, hero. Thank you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56522,'You may continue your ritual, we will defend you.','You may continue your ritual, we will defend you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56523,'Heroes, we must place this burden on your shoulders once again.  You must protect us from Deathwing\'s forces while we imbue the Soul with the powers of the great Aspects of Azeroth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56524,'Enjoy your tour of Pandaria\'s most ancient and respected silk farm.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(56525,'When the silkworm makes its cocoon, we use this device to extract the silk.','',1,0,0,0,0,0,0,0,1,13448,0,0,26124),
(56526,'We have spent generations perfecting just the right leaves for silkworm food.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56527,'Here we feed new silkworm larvae until they are ready to cocoon themselves.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(56528,'Take me to the summit of Wyrmrest Temple to fight Ultraxion.','Take me to the summit of Wyrmrest Temple to fight Ultraxion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56529,'You made it! Creed\'s dark magic is disrupting my vision - you\'re on your own from here. Good luck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56530,'','It is done! Our power now resides within the Dragon Soul! Our fate lies with you, Earth-Warder!',0,0,0,0,0,0,0,0,0,0,0,26507,26124),
(56531,'Taretha...  Cairne...  Aggra...  I will not fail you.  I will not fail this world!','',0,0,0,0,0,0,0,0,0,0,25908,0,26124),
(56532,'We toil day in and day out, and for what?$B$BThere\'s no point to any of it...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56533,'Huh? Wha?$B$BOh, I\'m awake again.$B$B<Sunni lets out a deep sigh.>$B$BEver since this rain started, I just don\'t feel like doing anything...','Huh? Wha?$B$BOh, I\'m awake again.$B$B<Sunni lets out a deep sigh.>$B$BEver since this rain started, I just don\'t feel like doing anything...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56534,'I tire of this disguise. Now we finish this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56535,'I don\'t know what\'s going on around here - it\'s like everyone has gone crazy!$B$BPlease, can you help?','I don\'t know what\'s going on around here - it\'s like everyone has gone crazy!$B$BPlease, can you help?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56536,'Who... ordered... this?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56537,'You did it!! You\'re my hero, $n! Prince Wrathion will be delighted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56538,'I looked into the eyes of The Dragon, and despaired...','',396,0,0,0,0,0,0,0,1,0,25865,0,26124),
(56539,'Light be with you.','',396,0,0,0,0,0,0,0,1,0,21414,0,26124),
(56540,'Let your faith guide you.','',396,0,0,0,0,0,0,0,1,0,21415,0,26124),
(56541,'Witness my POWER!','',396,0,0,0,0,0,0,0,1,0,21416,0,26124),
(56542,'The Light will consume you!','',396,0,0,0,0,0,0,0,1,0,25868,0,26124),
(56543,'Drown in Shadow!','',396,0,0,0,0,0,0,0,1,0,25869,0,26124),
(56544,'And YOU! We will FEAST on your ashes! Now, DIE!','',396,0,0,0,0,0,0,0,1,0,21413,0,26124),
(56545,'|TInterface\\Icons\\spell_shadow_twilight.blp:20|t Ultraxion begins casting |cFF9900CC|Hspell:106371|h[Hour of Twilight]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56546,'Hi there! Say, you weren\'t looking for a quick teleport to the big cannon, were you?$B$BBecause I can do that!$B$BFor a small fee, of course...','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(56547,'Say, nice shot!$B$BScared the fish, though.$B$BNeed a quick teleport back to the cannon?$B$BFor a small fee, of course...','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(56548,'Teleport me to the cannon.','Teleport me to the cannon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56549,'You feel hungry eyes upon you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56550,'Aren\'t the thunderbirds beautiful? Majestic. Terrifying.$B$BThey are more worthy of this land than any of us.$B$BThis is where I shall wait. When they are ready, they will take me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56551,'You\'re wasting your time.$B$BI\'m not going anywhere.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56552,'Please, Yi-Mo: your aunt\'s worried sick about you.','Please, Yi-Mo: your aunt\'s worried sick about you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56553,'I don\'t have time for this. Move your ass or I\'ll move it for you.','I don\'t have time for this. Move your ass or I\'ll move it for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56554,'Excellent work, friend. You\'ve proven that a single skilled assassin can strike a decisive blow where a whole army may fail.','',0,0,0,0,0,0,0,0,1,0,26424,0,26124),
(56555,'If you wish to continue our work, we will need some additional supplies...','',0,0,0,0,0,0,0,0,1,0,26425,0,26124),
(56556,'Hmph! A lucky blow against an unprepared opponent.','',0,0,0,0,0,0,0,0,1,0,26371,0,26124),
(56557,'You have your whole life ahead of you.','You have your whole life ahead of you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56558,'Is she REALLY worried about me? I doubt it...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56559,'What is life, anyway? A series of disappointments, one after another.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56560,'%s calls upon the |cFF9932CD|Hspell:104896|h[Purple]|h|r, |cFFFF0404|Hspell:104897|h[Red]|h|r, |cFFFFA901|Hspell:104901|h[Yellow]|h|r, and |cFF424242|Hspell:104894|h[Black]|h|r Bloods of Shu\'ma!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56561,'%s calls upon the |cFF9932CD|Hspell:104896|h[Purple]|h|r, |cFF088A08|Hspell:104898|h[Green]|h|r, |cFF424242|Hspell:104894|h[Black]|h|r, and |cFF0080FF|Hspell:104900|h[Blue]|h|r Bloods of Shu\'ma!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56562,'%s calls upon the |cFF088A08|Hspell:104898|h[Green]|h|r, |cFFFF0404|Hspell:104897|h[Red]|h|r, |cFF0080FF|Hspell:104900|h[Blue]|h|r, and |cFF424242|Hspell:104894|h[Black]|h|r Bloods of Shu\'ma!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56563,'%s calls upon the |cFF088A08|Hspell:104898|h[Green]|h|r, |cFFFFA901|Hspell:104901|h[Yellow]|h|r, |cFF424242|Hspell:104894|h[Black]|h|r, and |cFFFF0404|Hspell:104897|h[Red]|h|r Bloods of Shu\'ma!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56564,'%s calls upon the |cFF0080FF|Hspell:104900|h[Blue]|h|r, |cFF9932CD|Hspell:104896|h[Purple]|h|r, |cFF088A08|Hspell:104898|h[Green]|h|r, and |cFFFFA901|Hspell:104901|h[Yellow]|h|r Bloods of Shu\'ma!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56565,'%s calls upon the |cFF0080FF|Hspell:104900|h[Blue]|h|r, |cFF424242|Hspell:104894|h[Black]|h|r, |cFF9932CD|Hspell:104896|h[Purple]|h|r, and |cFFFFA901|Hspell:104901|h[Yellow]|h|r Bloods of Shu\'ma!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56566,'We\'ve just located her here, in the caverns beneath Karazhan. Fearful for her life, she is researching arcane secrets buried beneath the foundation.','',0,0,0,0,0,0,0,0,1,0,26379,0,26124),
(56567,'She\'s surrounded herself with a small army of deranged dragon cultists. They may not by right in the head, but they\'re well-armed. And dangerous.','',0,0,0,0,0,0,0,0,1,0,26381,0,26124),
(56568,'The gems you collected will be able to augment the power of the weapons I gave you, but I require another ingredient.  It will come from your next target.','',0,0,0,0,0,0,0,0,1,0,26454,0,26124),
(56569,'Her name is \"Nalice.\" And until recently she stood at Wyrmrest Temple as the representative of the black dragonflight. Now? She\'s on the run.','',0,0,0,0,0,0,0,0,1,0,26455,0,26124),
(56570,'I hope to see you back from this mission alive. But if I do not, I want to say I\'ve enjoyed seeing you work. You\'re a credit to your race. Good luck.','',0,0,0,0,0,0,0,0,1,0,26456,0,26124),
(56571,'Ready to survey the land.','Ready to survey the land.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56572,'','I hate resorting to violence.',0,0,0,0,0,0,0,0,1,0,0,25918,26124),
(56573,'','I don\'t know who you are, but I\'ll defend this shrine with my life. Leave, now, before we come to blows.',0,0,0,0,0,0,0,0,1,0,0,25920,26124),
(56574,'','I understand, now. Farewell, and good luck.',0,0,0,0,0,0,0,0,1,0,0,25919,26124),
(56575,'','You forced my hand.',0,0,0,0,0,0,0,0,1,0,0,25921,26124),
(56576,'','I didn\'t want to do that.',0,0,0,0,0,0,0,0,1,0,0,25922,26124),
(56577,'','I wish you\'d surrendered.',0,0,0,0,0,0,0,0,1,0,0,25923,26124),
(56578,'','Perhaps this will cool your heads...',0,0,0,0,0,0,0,0,1,0,0,25924,26124),
(56579,'','A little ice ought to quench the fire in your hearts...',0,0,0,0,0,0,0,0,1,0,0,25925,26124),
(56580,'','Why won\'t you give up?!',0,0,0,0,0,0,0,0,1,0,0,25926,26124),
(56581,'We need to move quickly! Tyrygosa and her guard have fallen, leaving the temple defenseless. Deathwing\'s forces must never reach the Dragon Soul or all is lost. The Wyrmrest Accord will aid you in the assault; the siege must be broken!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56582,'I humbly request that the Dragon Aspects provide no aid to myself and my fellow adventurers. They should worry about their own problems, and we will worry about ours.','I humbly request that the Dragon Aspects provide no aid to myself and my fellow adventurers. They should worry about their own problems, and we will worry about ours.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56583,'Fool!','You\'re not so clever, assassin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56584,'Terminate $ghim:her;.','Dirty sneak. You will be destroyed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56585,'You are either mad, foolhardy, or a hero worthy of being called legend. Which one are you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56586,'We will become legend.','We will become legend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56587,'We shall see, $C.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56588,'Say what you want. I\'m not moving an inch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56589,'I know, right?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56590,'You\'re going to have to pull out every trick you know in order to get in there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56591,'Maybe it\'s your gear?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56592,'Wrathion believes in you. I know you can do this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56593,'You can\'t fly and be stealthy at the same time.... I tried.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56594,'Success! Another corrupt dragon obliterated! Soon, none will stand but Deathwing himself...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56595,'You\'re in! Nalice has wards that negate my magic, so I won\'t be able to help you from here on out. Go get her!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56596,'','|TInterface\\Icons\\spell_fire_twilightflamebreath.blp:20|t%s prepares to unleash a |cFF9900CC|Hspell:106401|h[Twilight Onslaught]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56597,'Farewell, and good luck.','Farewell, and good luck.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56598,'Such a foolish creature, trying to challenge us.  His rancid corpse will serve as a reminder to the Legion of the power of Illidan Stormrage.\n$bThe shadowcloak\'s magic is fading, concealing us no longer.  It was fun while it lasted, but I prefer a more direct approach to bringing death to my enemy.\n$bYou fought well, but where I\'m heading I need to go alone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56599,'','Did I miss anything? Oh WOW!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(56600,'','Hey! Over here! No, down here! I can take you back to the present time, if you want.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56601,'What you see now, $n, is your distant future. A future where Deathwing, the Twilight\'s Hammer, and the Old Gods that they serve have won. A barren, unchanging wasteland, inhabited only by the echoes of the past.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(56602,'Yes, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56603,'I\'m ready to travel back in time - to the Well of Eternity.','I\'m ready to travel back in time - to the Well of Eternity.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56604,'','Greetings, $n.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(56605,'I am ready to help Thrall, back in my present time.','I am ready to help Thrall, back in my present time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56606,'I am ready to meet Nozdormu at the End Time.','I am ready to meet Nozdormu at the End Time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56607,'I am ready to meet Nozdormu at the End Time.','I am ready to meet Nozdormu at the End Time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56608,'','How can I be of aid, stranger?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56609,'Stay by my side, $n. We may have need of one another.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56610,'It is done. The Dragon Soul is safely within the clutch of the dragonflights.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56613,'I\'m looking for a lost companion.','I\'m looking for a lost companion.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(56614,'','Even with the Aspect of Time on your side, you stumble foolishly into a trap?',0,0,0,0,0,0,0,0,1,0,0,26223,26124),
(56615,'','Don\'t preen just yet, little pups. We\'ll cleanse this world of your kind.',0,0,0,0,0,0,0,0,1,0,0,26224,26124),
(56616,'','You\'ll not leave this place alive!',0,0,0,0,0,0,0,0,1,0,0,26225,26124),
(56617,'','Not one of you will live to see the final cataclysm! Finish them!',0,0,0,0,0,0,0,0,1,0,0,26226,26124),
(56618,'The plates! He\'s coming apart! Tear up the plates and we\'ve got a shot at bringing him down!','',0,0,0,0,0,0,0,0,1,0,26290,0,26124),
(56619,'Don\'t worry about me. Stop the Destroyer! Enshu-falah-nah, dorini.','',0,0,0,0,0,0,0,0,1,0,26291,0,26124),
(56620,'','Malfurion...',0,0,0,0,0,0,0,0,1,0,0,25989,26124),
(56621,'','By the very edge...',0,0,0,0,0,0,1,0,1,0,0,25990,26124),
(56622,'','I do not know who you are, but I thank you. Without your aid, our world would be...I do not wish to think about it. Moon goddess light your path.',0,0,0,0,0,0,1,0,1,0,0,25991,26124),
(56623,'Ha! I had not realized you fools were still there.','',0,0,0,0,0,0,0,0,1,0,26351,0,26124),
(56624,'Your efforts are insignificant. I carry you to your deaths.','',0,0,0,0,0,0,0,0,1,0,26352,0,26124),
(56625,'Cling while you can, \"heroes.\" You and your world are doomed.','',0,0,0,0,0,0,0,0,1,0,26515,0,26124),
(56626,'Your tenacity is admirable, but pointless. You ride into the jaws of the apocalypse.','',0,0,0,0,0,0,0,0,1,0,26346,0,26124),
(56627,'The War Serpent will not travel beyond the Jade Temple Grounds! Return before you are tossed off!','The War Serpent will not travel beyond the Jade Temple Grounds! Return before you are tossed off!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56628,'He is heading to the maelstrom!  We must stop him NOW, we may never get another chance if he escapes into Deepholm.','',0,0,0,0,0,0,1,0,0,0,26263,0,26124),
(56629,'Welcome aboard the Skyfire.  You ready to chase down the end of the world?','',0,0,0,0,0,0,22,0,1,0,26302,0,26124),
(56630,'The artifact!','',0,0,0,0,0,0,0,0,1,0,26059,0,26124),
(56631,'Brother. A timely arrival...','',0,0,0,0,0,0,0,0,1,0,26060,0,26124),
(56632,'Aye. It\'s been twisted and turned by too many spells. The fuss we - especially you - made with the portal was too much! The same spell that sent the Burning Legion back into their foul realm now works on the well! It\'s devouring itself and taking its surroundings with it! Fascinating, isn\'t it?','',0,0,0,0,0,0,0,0,1,0,26061,0,26124),
(56633,'If you\'ve a way out of here, we should probably use it! I\'ve tried casting myself and Tyrande out of here, but the well is too much in flux!','',0,0,0,0,0,0,0,0,1,0,26062,0,26124),
(56634,'None may cross the Queen!','',0,0,0,0,0,0,0,0,1,0,26138,0,26124),
(56635,'A deserved death!','',0,0,0,0,0,0,0,0,1,0,26139,0,26124),
(56636,'In Azshara\'s name!','',0,0,0,0,0,0,0,0,1,0,26140,0,26124),
(56637,'Hush, Tyrande. Where is Illidan?','',0,0,0,0,0,0,1,0,1,0,26490,0,26124),
(56638,'Illidan! The well is out of control!','',0,0,0,0,0,0,22,0,1,0,26491,0,26124),
(56639,'Not if we\'re caught up in it! Why weren\'t you running? What have you been doing with your hand in the Well?','',0,0,0,0,0,0,6,0,1,0,26492,0,26124),
(56640,'This way!','',0,0,0,0,0,0,22,0,1,0,26493,0,26124),
(56641,'Fall and DIE before me!','',0,0,0,0,0,0,0,0,1,0,26485,0,26124),
(56642,'SQUIRM! SCREAM!','',0,0,0,0,0,0,0,0,1,0,26486,0,26124),
(56643,'Useless!','',0,0,0,0,0,0,0,0,1,0,26487,0,26124),
(56644,'[Demonic] Amanare maev il azgalada zila ashj ashj zila enkil!','',0,0,0,0,0,0,0,0,1,0,26488,0,26124),
(56645,'','We\'ve gathered up some items from this time period. I hope this helps!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(56646,'Twisting your pitiful whelps into mindless abominations, bent only to my will. It was a very... painful process.','',0,0,0,0,0,0,457,0,0,0,26361,0,26124),
(56647,'Nefarian, Onyxia, Sinestra... they were nothing. Now you face my ultimate creation.','',0,0,0,0,0,0,0,0,1,0,26363,0,26124),
(56648,'The Hour of Twilight is nigh; the sun sets on your pitiful mortal existence.','',0,0,0,0,0,0,0,0,1,0,26364,0,26124),
(56649,'Let\'s load these barrels up into the cart, shall we?','',0,0,0,0,0,0,1,0,1,0,29704,0,26124),
(56650,'Onward to the Stormstout Brewery!','',0,0,0,0,0,0,4,0,1,0,29705,0,26124),
(56651,'','So long, Halfhill!',0,0,0,0,0,0,3,0,1,0,0,30412,26124),
(56652,'Mudmug, are you coming?','',0,0,0,0,0,0,6,0,1,0,29706,0,26124),
(56653,'Oh, I dunno. This kinda seems like a family thing you\'re doin\'...','',0,0,0,0,0,0,24,0,1,0,30976,0,26124),
(56654,'It IS a family thing, Mudmug. And I want you to join us.','',0,0,0,0,0,0,2,0,1,0,29707,0,26124),
(56655,'No foolin\'?','',0,0,0,0,0,0,0,0,1,0,30977,0,26124),
(56656,'Of course not! We brewed beer together. That practically makes us brothers.','',0,0,0,0,0,0,11,0,1,0,29708,0,26124),
(56657,'Y-yeah! Beer brothers!','',0,0,0,0,0,0,0,0,1,0,30978,0,26124),
(56658,'','Ugh! You guys are gonna make me throw up.',0,0,0,0,0,0,15,0,1,0,0,30413,26124),
(56659,'Come on, help me pull this cart.','',0,0,0,0,0,0,0,0,1,0,29709,0,26124),
(56660,'','Is this the fastest you can go? Come on, fatsos! Move those legs!',0,0,0,0,0,0,1,0,1,0,0,30415,26124),
(56661,'Very well, I will put my belly into it...','',0,0,0,0,0,0,0,0,1,0,29710,0,26124),
(56662,'See you there, $n!','',0,0,0,0,0,0,0,0,1,0,29711,0,26124),
(56663,'','Seriously though, Mudmug. Don\'t be dumb.',0,0,0,0,0,0,1,0,1,0,0,30414,26124),
(56664,'Not necessarily. I believe...yes...it just might work.','',0,0,0,0,0,0,5,0,0,0,26547,0,26124),
(56665,'Then I will open the way into the Eye of Eternity. You must not fail, heroes. The future of Azeroth hinges on your actions.','',0,0,0,0,0,0,1,0,0,0,26266,0,26124),
(56666,'It is no use, the power of the Dragon Soul is too great. I cannot wield it safely; the raging forces contained within it may be the doom of us all.','',0,0,0,0,0,0,1,0,1,0,25904,0,26124),
(56667,'Yes, I see.  We can finally turn Deathwing\'s own power back against him.','',0,0,0,0,0,0,1,0,1,0,25905,0,26124),
(56668,'','Then truly, we are lost.',0,0,0,0,0,0,66,0,1,0,0,26503,26124),
(56669,'','I sense danger...it is a trap...carefully laid for us at this crucial moment.',0,0,0,0,0,0,6,0,1,0,0,26147,26124),
(56670,'We have no choice.  We must have faith in our allies.','',0,0,0,0,0,0,1,0,1,0,25906,0,26124),
(56671,'At last! A challenge! Let us test your mettle, \"champion\".','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56672,'Have you come to supplicate yourself before the Light? Or perhaps you have come here to train in the holy arts?$b$bIf you are here to speak with Archbishop Benedictus, I am sorry to inform you that he has left on a mission.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(56673,'Yes. He has been called upon to help the aspects with their efforts at Wyrmrest. He wishes to aid them in cleansing Azeroth of Deathwing\'s menace.$b$bMay the Light guide his path.','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(56674,'Ha hah hah! Benedictus, the Twilight Prophet!$b$bBwa ha ha ha!$b$bOh, that\'s a good one. Hoo-ee.','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(56675,'Rumors, child. Rumors have a way of attaching themselves to people of power. In fact, I recently heard a particularly nasty one about the late lord Bolvar.$b$bI will ask you to spread your lies elsewhere. Return when you are ready to confess your wrongs before the Light.','',274,396,0,0,0,0,0,0,1,0,0,0,26124),
(56676,'A mission?','A mission?',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(56677,'Actually, I saw Benedictus at Wyrmrest. He was the Twilight Prophet.','Actually, I saw Benedictus at Wyrmrest. He was the Twilight Prophet.',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(56678,'I\'m serious. Benedictus tried to kill Thrall and deliver Azeroth to Deathwing. I saw it with my own eyes.','I\'m serious. Benedictus tried to kill Thrall and deliver Azeroth to Deathwing. I saw it with my own eyes.',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(56679,'Our serpents are working hard to save the temple.$B$BThey will gladly lend their strength if you require it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56680,'Never have I seen an enemy such as this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56681,'This is our land. Our home.$B$BI will not see it fall to the sha.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56682,'Despite our efforts to become enlightened beings, we have repeated the mistakes of our past.$B$BThe sha threaten this land once again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56683,'We cannot dwell on the mistakes of the past, $r.$B$BThe only path is forward.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56684,'','Gather your courage, $r. Together, we can resist the sha.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56685,'','When the sha attack began, every one of my students ran to battle without hesitation.$B$BI have taught them much, but yet they continue to surpass my expectations.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56686,'','Much of our knowledge of the sha has been lost through time.$B$BWhile the battle continues, I must study their nature.$B$BOnly then can we prevent this from happening again in the future.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56688,'','Have you come to observe my class?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56690,'','Welcome, traveler. Please stay a while and rest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56691,'','As long as the sha stay outside, I\'ll be fine.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56692,'Our fighters need nutritious food to keep our enemies at bay!$B$BHurry up and tell me what I can get for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56693,'You look like you could use a hot meal.$B$BWhat can I get for you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56694,'','Praise the Titans, they have returned!',0,0,0,0,0,0,4,0,1,0,0,26145,26124),
(56695,'Not entirely unexpected.','',0,0,0,0,0,0,274,0,1,0,25953,0,26124),
(56696,'Excellent! We will begin the ritual at once!','',0,0,0,0,0,0,5,0,1,0,26262,0,26124),
(56697,'','Huh! Looks like they\'re closed.',0,0,0,0,0,0,1,0,1,0,0,30416,26124),
(56698,'Yes, strange. This door was not here before.','',0,0,0,0,0,0,274,0,1,0,29712,0,26124),
(56699,'','The ritual will take much from us, as it requires a very piece of our being. We will be weakened greatly.',0,0,0,0,0,0,1,0,1,0,0,26504,26124),
(56700,'Y\'all think they\'re hidin\' something inside?','',0,0,0,0,0,0,6,0,1,0,30979,0,26124),
(56701,'We will find out.','',0,0,0,0,0,0,273,0,1,0,29713,0,26124),
(56702,'I don\'t think breweries are supposed to make that sound...','',0,0,0,0,0,0,274,0,1,0,30980,0,26124),
(56703,'Heroes, this burden falls to you once again.','',0,0,0,0,0,0,1,0,1,0,25898,0,26124),
(56704,'','Umm... guys...',0,0,0,0,0,0,1,0,1,0,0,30417,26124),
(56705,'Settle down, Li Li. You know that I hate to be interrupted while I\'m knocking on doors.','',0,0,0,0,0,0,1,0,1,0,29715,0,26124),
(56706,'Chen! It\'s a giant dang ol\' hozen!','',0,0,0,0,0,0,5,0,1,0,30981,0,26124),
(56707,'Who crashing Ook party!? Ook ook ook...','',0,0,0,0,0,0,1,0,1,0,28798,0,26124),
(56708,'Hozen attack!','',0,0,0,0,0,0,1,0,1,0,29716,0,26124),
(56709,'Heroes, have you succeeded in acquiring the Focusing Iris?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56710,'Hold on, I will break you out of those barrels.','',0,0,0,0,0,0,1,0,1,0,29717,0,26124),
(56711,'We were successful, Kalecgos.','We were successful, Kalecgos.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56712,'','Stand your ground, defenders! Do not let them pass!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56713,'','Steel yourselves! More of them approach!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56714,'','Send them back to the wastelands of their world, champions!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56715,'','If we surrender now, the entire temple will fall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56716,'','Push forward, defenders!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56717,'','Hold steady, everyone. One step forward is all we need.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56718,'','Do not give up hope, friends!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56719,'','Tomorrow, they will sing our praises, but only if we are victorious today.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56720,'|TInterface\\Icons\\inv_stave_2h_deathwingraiddw_d_01.blp:20|t%s falls forward, get to |cFF04FC32Ysera\'s|r platform!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56721,'Stormstouts, open up! I have returned. And I brought beer!','',0,0,0,0,0,0,1,0,1,0,29714,0,26124),
(56722,'%s begins to impale the Aspect! Stop it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56723,'You must protect us from Deathwing\'s forces while we imbue the Dragon Soul with the power of the Aspects.','',0,0,0,0,0,0,1,0,1,0,25899,0,26124),
(56724,'Speak to me when you are ready to begin.','',0,0,0,0,0,0,1,0,1,0,25900,0,26124),
(56725,'','Be at peace, child.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56726,'','Your sacrifice will not be forgotten.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56727,'','Deathwing will pay for this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56728,'Incredible! Few assassins would be clever enough to infiltrate Nalice\'s wards and use her own magic against her.','',0,0,0,0,0,0,0,0,1,0,26426,0,26124),
(56729,'Perhaps. For that reason, we will need to gather more supplies...','',0,0,0,0,0,0,0,0,1,0,26427,0,26124),
(56730,'She allowed herself to be defeated. The others will not be so weak.','',0,0,0,0,0,0,0,0,1,0,26372,0,26124),
(56731,'Teleportation to the cannon will cost:','Teleportation to the cannon will cost:',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56732,'I don\'t need a teleport.','I don\'t need a teleport.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56733,'The Focusing Iris within the Eye of Eternity may allow us to converge the magical matrix contained within the Dragon Soul.','',0,0,0,0,0,0,5,0,0,0,26265,0,26124),
(56734,'Succeed here, and our work is nearly done. Good luck, hero!','',0,0,0,0,0,0,0,0,1,0,26458,0,26124),
(56735,'There\'s no need to worry, Fahrad. This next mission is ... quite likely ... suicide.','',0,0,0,0,0,0,0,0,1,0,26430,0,26124),
(56736,'Don\'t trust this one, your highness - no one is that good.','',0,0,0,0,0,0,0,0,1,0,26374,0,26124),
(56737,'Aspects! Aid the heroes as best you can!','',0,0,0,0,0,0,1,0,1,0,25895,0,26124),
(56738,'Avenge the fallen! Continue the fight!','',0,0,0,0,0,0,1,0,1,0,25903,0,26124),
(56739,'That apprentice of yours ran off with my daughter again.','',25,1,0,0,0,0,0,0,1,13606,0,0,26124),
(56740,'','You must hurry... Wyrmrest falls as we speak... all... is lost...',0,0,0,0,0,0,0,0,1,0,0,26306,26124),
(56741,'','Thank you, sisters, I am renewed.',0,0,0,0,0,0,0,0,1,0,0,26307,26124),
(56742,'','The Old Gods have shown themselves - a tide of darkness sweeps from their gaping maws towards the temple. We MUST buy the aspects more time.',0,0,0,0,0,0,396,0,1,0,0,26308,26124),
(56743,'','The faceless generals, Zon\'ozz and Yor\'sahj, command the enemy legions from within the monstrosities you see on the horizon.',0,0,0,0,0,0,397,0,1,0,0,26309,26124),
(56744,'','You must strike them down if we are to survive long enough to end this. Take flight on the wings of my sisters, they will transport you as close as they dare!',0,0,0,0,0,0,22,0,1,0,0,26310,26124),
(56745,'','A single general remains. You must make haste!',0,0,0,0,0,0,22,0,1,0,0,26311,26124),
(56746,'','The flow of darkness abates. It seems you truly are the heroes of legend.',0,0,0,0,0,0,113,0,1,0,0,26312,26124),
(56747,'','The Aspects have already gathered and await your arrival. Go now!',0,0,0,0,0,0,396,0,1,0,0,26313,26124),
(56748,'Roll Yi-Mo towards Zhu\'s Watch!','Roll Yi-Mo towards Zhu\'s Watch!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56749,'Lovers do what lovers will. He\'s a good boy.','',6,1,0,0,0,0,0,0,1,13606,0,0,26124),
(56750,'I\'ll not hear it! He\'s a Wanderbrew and she\'s a Goldendraft. Return my daughter or I\'ll make sure no one gives you work for a month.','',14,1,0,0,0,0,0,0,1,13606,0,0,26124),
(56751,'Well done! I will realign the flow of mana and fill the Dragon Soul with all my arcane might.','',0,0,0,0,0,0,0,0,1,0,26258,0,26124),
(56752,'I will charge you with arcane energy to blast your foes.','',0,0,0,0,0,0,0,0,1,0,26259,0,26124),
(56753,'Is he... coming apart?','',0,0,0,0,0,0,0,0,1,0,26260,0,26124),
(56754,'Vwyq agth sshoq\'meg N\'Zoth vra zz shfk qwor ga\'halahs agthu. Uulg\'ma, ag qam.','',0,0,0,0,0,0,0,0,0,0,26337,0,26124),
(56755,'Once more shall the twisted flesh-banners of N\'Zoth chitter and howl above the fly-blown corpse of this world. After millennia, we have returned.','',0,0,0,0,0,0,0,0,0,0,26335,0,26124),
(56756,'Zzof Shuul\'wah. Thoq fssh N\'Zoth!','',0,0,0,0,0,0,0,0,0,0,26335,0,26124),
(56757,'Victory for Deathwing. For the glory of N\'Zoth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56758,'Everyone around me only pretends to like me.','Everyone around me only pretends to like me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56759,'Does this armor look a little tight on me?','Does this armor look a little tight on me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56760,'Of course my worst fears are going to come true.','Of course my worst fears are going to come true.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56761,'What are people saying about me?','What are people saying about me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56762,'I keep hearing voices in my head. Should I be worried?','I keep hearing voices in my head. Should I be worried?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56763,'Nothing is ever going to change.','Nothing is ever going to change.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56764,'Uovssh thyzz... qwaz...','',0,0,0,0,0,0,0,0,0,0,26336,0,26124),
(56765,'To have waited so long... for this...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56766,'Why do I try so hard? It\'s all meaningless in the end...','Why do I try so hard? It\'s all meaningless in the end...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56767,'Why do I always feel so alone? Is it because...I\'m alone?','Why do I always feel so alone? Is it because...I\'m alone?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56768,'My family has stood as the greatest brewmasters of the Jade Forest for generations.$b$bUnlike those filthy travelling Wanderbrews. Peasant brews, that\'s what they make.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56769,'It is time. I will expend everything to bind every thread here, now, around the Dragon Soul. What comes to pass will NEVER be undone.','',0,0,0,0,0,0,0,0,1,0,25948,0,26124),
(56770,'Press the attack, heroes.','',0,0,0,0,0,0,0,0,1,0,25950,0,26124),
(56771,'Before you is the Cache of the Aspects: Take from it what you will, for you have more than earned the right.','Before you is the Cache of the Aspects: Take from it what you will, for you have more than earned the right.',0,0,0,0,0,0,0,0,1,0,26502,26502,26124),
(56772,'I will cleanse whatever corruption I can; my fire will not harm you.','I will cleanse whatever corruption I can; my fire will not harm you.',0,0,0,0,0,0,0,0,1,0,26498,26498,26124),
(56773,'Excellent work. The fire of my heart glows with a brilliant purity unmatched; every spark of it I will channel into the Dragon Soul.','Excellent work. The fire of my heart glows with a brilliant purity unmatched; every spark of it I will channel into the Dragon Soul.',0,0,0,0,0,0,0,0,1,0,26497,26497,26124),
(56774,'He\'s completely mad!','He\'s completely mad!',0,0,0,0,0,0,0,0,1,0,26499,26499,26124),
(56775,'We are one step closer. The unknowable, transcendent power of the Emerald Dream I now give unto the Dragon Soul.','',0,0,0,0,0,0,0,0,0,0,26141,0,26124),
(56776,'I will bring you closer to the Emerald Dream. Seek safety there when the fight becomes too intense.','',0,0,0,0,0,0,0,0,0,0,26142,0,26124),
(56777,'Such rage I have never seen...','',0,0,0,0,0,0,0,0,0,0,26143,0,26124),
(56778,'Sk\'tek agth nuq N\'Zoth yyqzz.','',0,0,0,0,0,0,0,0,0,0,26338,0,26124),
(56779,'Your skulls shall adorn N\'Zoth\'s writhing throne.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56780,'Sk\'yahf agth huqth N\'Zoth qornaus.','',0,0,0,0,0,0,0,0,0,0,26339,0,26124),
(56781,'Deathwing is conjuring the final Cataclysm; even the Emerald Dream trembles. If we are to stop the spell, we must attack him together.','',0,0,0,0,0,0,0,0,0,0,26144,0,26124),
(56782,'Your souls shall sate N\'Zoth\'s endless hunger.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56783,'Sk\'shuul agth vorzz N\'Zoth naggwa\'fssh.','',0,0,0,0,0,0,0,0,0,0,26341,0,26124),
(56784,'Your deaths shall sing of N\'Zoth\'s unending glory.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56785,'Gul\'kafh an\'qov N\'Zoth.','',0,0,0,0,0,0,0,0,0,0,26345,0,26124),
(56786,'Gaze into the heart of N\'Zoth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56787,'N\'Zoth ga zyqtahg iilth.','',0,0,0,0,0,0,0,0,0,0,26344,0,26124),
(56788,'The will of N\'Zoth corrupts you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56789,'Sk\'magg yawifk hoq.','',0,0,0,0,0,0,0,0,0,0,26340,0,26124),
(56790,'Your suffering strengthens me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56791,'','Thank you for the masks, $n. Be at peace and take this blessing as a token of our thanks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56792,'','My poor Lo. He tried so hard to earn the respect of the pandriarchs. It was the only honorable solution we could think of to bypass our family feuds.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(56793,'Nice fightin\'... real hero-like. Y\'all should check in with Li Li, up ahead.','',0,0,0,0,0,0,1,0,1,13609,30970,0,26124),
(56794,'That\'s all the fightin\' there is to be done, I reckon. Let\'s get up out of here, and meet up with Chen and Li Li.','',0,0,0,0,0,0,1,0,1,13610,30971,0,26124),
(56795,'Sk\'uuyat guulphg hoq.','',0,0,0,0,0,0,0,0,0,0,26342,0,26124),
(56796,'','Uncle Chen\'s waiting up ahead. You go find him... I\'ll stay here and mock this unconscious monkey.',0,0,0,0,0,0,1,0,1,13609,0,30396,26124),
(56797,'','I think we\'re all done! Let\'s meet up with those two oafs at the brewery\'s back entrance.',0,0,0,0,0,0,1,0,1,13610,0,30399,26124),
(56798,'Your agony sustains me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56799,'Sk\'shgn eqnizz hoq.','',0,0,0,0,0,0,0,0,0,0,26343,0,26124),
(56800,'Your fear drives me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56801,'','Not so tough now, are you? That\'s right. You look so dumb there laying on the ground. Don\'t make me make $p throw more barrels at you.',0,0,0,0,0,0,1,0,1,13609,0,30397,26124),
(56802,'Ak\'agthshi ma uhnish, ak\'uq shg\'cul vwahuhn! H\'iwn iggksh Phquathi gag OOU KAAXTH SHUUL!','',0,0,0,0,0,0,0,0,0,0,26328,0,26124),
(56803,'Our numbers are endless, our power beyond reckoning! All who oppose the Destroyer will DIE A THOUSAND DEATHS!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56804,'Iilth qi\'uothk shn\'ma yeh\'glu Shath\'Yar! H\'IWN IILTH!','',0,0,0,0,0,0,0,0,0,0,26326,0,26124),
(56805,'You will drown in the blood of the Old Gods! ALL OF YOU!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56806,'Ez, Shuul\'wah! Sk\'woth\'gl yu\'gaz yoh\'ghyl iilth!','',0,0,0,0,0,0,0,0,0,0,26327,0,26124),
(56807,'I\'m going to wring some of this beer out of my clothes. You go on ahead, find Mudmug.','',0,0,0,0,0,0,1,0,1,13609,29692,0,26124),
(56808,'O, Deathwing! Your faithful servant has failed you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56809,'Sk\'yahf qi\'plahf PH\'MAGG!','',0,0,0,0,0,0,0,0,0,0,26329,0,26124),
(56810,'Your soul will know ENDLESS TORMENT!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56811,'H\'iwn zaix Shuul\'wah, PHQUATHI!','',0,0,0,0,0,0,0,0,0,0,26330,0,26124),
(56812,'All praise Deathwing, THE DESTROYER!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56813,'I think we\'ve done enough damage for one day. Let\'s meet up with the other two, at the brewery\'s rear entrance.','',0,0,0,0,0,0,1,0,1,13610,29693,0,26124),
(56814,'Shkul an\'zig qvsakf KSSH\'GA, ag\'THYZAK agthu!','',0,0,0,0,0,0,0,0,0,0,26331,0,26124),
(56815,'From its BLEAKEST DEPTHS, we RECLAIM this world!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56816,'KYTH ag\'xig yyg\'far IIQAATH ONGG!','',0,0,0,0,0,0,0,0,0,0,26332,0,26124),
(56817,'SEE how we pour from the CURSED EARTH!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56818,'UULL lwhuk H\'IWN!','',0,0,0,0,0,0,0,0,0,0,26333,0,26124),
(56819,'The DARKNESS devours ALL!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56820,'Awtgsshu LWHUK iilth!','',0,0,0,0,0,0,0,0,0,0,26334,0,26124),
(56821,'Corruption CONSUMES you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56822,'They... they agreed?! Fantastic! Thank you so much! With their blessing we can be the happiest pandaren in all the land!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(56823,'','Oh thank you hero! You have given us a great gift!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(56824,'Be careful! They may be dead, but the pandriarchs are still dangerous.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(56825,'','One thing I have learned from the sha. They know how to prey on our weaknesses.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56826,'','The sha are right about one thing.$B$BOur greatest enemies are often ourselves.$B$BI just wish I weren\'t such a formidable opponent.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56829,'Your eyes do not deceive you. The treacherous red dragonflight sought to kill me off. I hope now you see the truth about them.','',0,0,0,0,0,0,1,0,1,0,26459,0,26124),
(56830,'I smell something....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56831,'','Yes, hero?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56832,'You\'re of the bronze flight, you know what happens next! Can you just skip us ahead to all the real action?','You\'re of the bronze flight, you know what happens next! Can you just skip us ahead to all the real action?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56833,'','Do not ask for mercy, after such an act.',0,0,0,0,0,0,5,0,0,0,0,26016,26124),
(56834,'','If you intend to play the fool, you may as well look the part.',0,0,0,0,0,0,273,0,0,0,0,26025,26124),
(56835,'If you live through this... I assure you it will be worth it.','',0,0,0,0,0,0,0,0,1,0,26453,0,26124),
(56836,'That\'s right, mortal. The prize you seek no longer sleeps within a shell. Here I am: in the flesh.','',0,0,0,0,0,0,0,0,1,0,26435,0,26124),
(56837,'I\'m not some trophy for a red dragon\'s mantle-piece, and I\'m never going back.','',0,0,0,0,0,0,0,0,1,0,26436,0,26124),
(56838,'Don\'t look so surprised! We dragons are conscious, even within our shells. As I grew, I could hear the plotting and scheming. I was to be born a prisoner.','',0,0,0,0,0,0,0,0,1,0,26437,0,26124),
(56839,'But I\'m one-of-a-kind! A black dragon raised free from the taint of my father\'s corruption. And that\'s how I intend to stay: free.','',0,0,0,0,0,0,0,0,1,0,26438,0,26124),
(56840,'Somehow, you managed to elude all of my guards. You slipped in here like a ghost. That makes you... valuable to me. Let\'s talk.','',0,0,0,0,0,0,0,0,1,0,26439,0,26124),
(56841,'You don\'t recognize your former prisoner?','',0,0,0,0,0,0,0,0,1,0,26440,0,26124),
(56842,'No. I want him to deliver a message to the red dragonflight.','',0,0,0,0,0,0,274,0,1,0,26441,0,26124),
(56843,'Tell them that I am free of my father\'s madness, and I will be free of them as well. I am to be left alone: this will be my first and only warning.','',0,0,0,0,0,0,1,0,1,0,26548,0,26124),
(56844,'Deathwing\'s minions should be afraid of ME. Get him out of here.','',0,0,0,0,0,0,1,0,1,0,26442,0,26124),
(56845,'And Fahrad?','',0,0,0,0,0,0,0,0,1,0,26443,0,26124),
(56846,'Break his legs.','',0,0,0,0,0,0,0,0,1,0,26444,0,26124),
(56847,'Now then, my new friend. We have much to talk about.','',0,0,0,0,0,0,1,0,1,0,26445,0,26124),
(56848,'Your highness, we caught this beast snooping around the caves just outside the compound.','',0,0,0,0,0,0,0,0,1,0,26375,0,26124),
(56849,'Shall we execute him, my prince?','',0,0,0,0,0,0,0,0,1,0,26376,0,26124),
(56850,'Yes sir?','',0,0,0,0,0,0,0,0,1,0,26377,0,26124),
(56853,'Don\'t give up, thunderbirds! Come back for me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56854,'I can feel it... As if a dark shadow has been lifted from the land. Dead! My father is dead!','',0,0,0,0,0,0,5,0,1,0,26460,0,26124),
(56855,'Champion, you have your reward. But there is one final dragon we need to slay.','',0,0,0,0,0,0,1,0,1,0,26461,0,26124),
(56856,'Fahrad! I was just talking about you. The final Black Dragon. The one who\'s been more hidden than any of them.','',0,0,0,0,0,0,1,0,1,0,26462,0,26124),
(56857,'Curious weapons you wield... such power.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56858,'Yes. You rescued me while I was still within my egg, and I owe you my life.','',0,0,0,0,0,0,273,0,1,0,26463,0,26124),
(56859,'But you are a Black Dragon. And you share the corruption of all my brothers and sisters.','',0,0,0,0,0,0,25,0,1,0,26464,0,26124),
(56860,'Do you deny it? The dark visions? The voices in your head?','',0,0,0,0,0,0,6,0,1,0,26465,0,26124),
(56861,'And what are they telling you now, Fahrad? What do your dark masters whisper?','',0,0,0,0,0,0,6,0,1,0,26466,0,26124),
(56862,'I will NEVER be controlled! The Red Dragonflight has no idea what they unleashed when they experimented on my egg.','',0,0,0,0,0,0,5,0,1,0,26467,0,26124),
(56863,'Hero... strike now! Use your newfound power to FINISH HIM.','',0,0,0,0,0,0,397,0,1,0,26468,0,26124),
(56864,'It is done, friend. To my knowledge, I am the only black dragon who remains.','',0,0,0,0,0,0,26,0,1,0,26469,0,26124),
(56865,'A new age for mortals has dawned, and heroes like you are among the vanguard.','',0,0,0,0,0,0,5,0,1,0,26470,0,26124),
(56866,'I must go now - disappear.','',0,0,0,0,0,0,1,0,1,0,26471,0,26124),
(56867,'Perhaps we will meet again. I hope we find ourselves on the same side...','',0,0,0,0,0,0,2,0,1,0,26472,0,26124),
(56868,'Nooooo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56869,'You seem prepared.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56870,'','Stand upon this disc, $p. Kalecgos approaches!',0,0,0,0,0,0,1,0,1,13621,0,0,26124),
(56871,'My Prince, we should leave this place, in case they come back to finish the job.','',0,0,0,0,0,0,396,0,1,0,26383,0,26124),
(56872,'Your highness. I have never tried to conceal what I am from you.','',0,0,0,0,0,0,6,0,1,0,26384,0,26124),
(56873,'That\'s - not true!','',0,0,0,0,0,0,274,0,1,0,26385,0,26124),
(56874,'No, No! I\'m in control of the voices. They\'re here to help me.','',0,0,0,0,0,0,274,0,1,0,26386,0,26124),
(56875,'Kill... they want me to kill you now... oh, why did you have to go and anger them?','',0,0,0,0,0,0,5,0,1,0,26387,0,26124),
(56876,'You have proven too difficult to control!','',0,0,0,0,0,0,15,0,1,0,26388,0,26124),
(56878,'','|TInterface\\Icons\\inv_weapon_shortblade_45.blp:20|t%s begins to cast |cFF9900CC|Hspell:109887|h[Arcane Infused Weapon]|h|r! Avoid her attacks!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56879,'','|TInterface\\Icons\\ability_warrior_riposte:20|t%s begins to cast |cFF9900CC|Hspell:109893|h[Arcane Infused Armor]|h|r! Expose her armor!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56880,'','|TInterface\\Icons\\spell_arcane_arcaneresilience.blp:20|t%s begins to cast |cFFFF0000|Hspell:109807|h[Arcane Destruction]|h|r! Activate the pillars to stop her!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56881,'You ready to do this? I\'m ready to do this. I\'m fixin\' to make a puddle out of that critter.$b$bIt\'s just... well, I ain\'t much of a bruiser, and I get skeered real easy. You\'re the $c here. You gonna... you gonna protect me, right?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(56882,'Alright! Let\'s go smush that water varmint!','',0,0,0,0,0,0,71,0,1,0,30957,0,26124),
(56883,'','This guy\'s a little bigger than I thought he\'d be.$b$bYou think it\'s from drinking beer? I know too much beer makes you fat, like Uncle Chen, but I didn\'t think it\'d make you any taller.$b$bEither way, I don\'t think I can take this guy on alone.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(56884,'','Good! Maybe this time, WE can be the barrel-throwing jerks!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(56885,'What is going on inside this brewery!? Has nobody maintained this place? Where are the brewers?$b$bWhere is my family...?$b$bThey must have gone somewhere. If they were here, then they\'d be cleaning up this mess! For now, looks like it\'s up to you and me, $n. You ready?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(56886,'Stormstout!','',0,0,0,0,0,0,22,0,1,0,29687,0,26124),
(56887,'Don\'t stop now.$B$BYou still have time left to play!','Don\'t stop now.$B$BYou still have time left to play!',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(56888,'Calm down, Mudmug. Let\'s go.','Calm down, Mudmug. Let\'s go.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(56889,'I\'ll help.','I\'ll help.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(56890,'Let\'s do this, Chen.','Let\'s do this, Chen.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(56891,'Please stay out of the gaming area.','Please stay out of the gaming area.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56892,'Hold them off! Protect the archers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56893,'With the loss of my power, the Dragon Soul has returned to its original place in time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(56894,'There goes the BOOM!','',0,0,0,0,0,0,0,0,1,0,29349,0,26124),
(56895,'','An assassin! Did the little whelpling send you after me? Come, rogue. Let\'s dance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56896,'','I\'ve got some secrets of my own, rogue.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56897,'','I... I need more time!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56898,'','This isn\'t how it ends. Not for me. I\'m a survivor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56899,'','You cling to a shattered world... Your time comes... soon enough...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56900,'Lady luck is on my side tonight!','Lady luck is on my side tonight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56901,'Ken-Ken met a few pandaren in his time. He tell you something: they NOT sads.$B$BNow, look at this place! Sad, mopey-dopeys sulking around everywhere.$B$BWhere\'s song and dance? Where\'s piles of food?$B$BWhere\'s BOOZE, man?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56902,'Double or nothing!','Double or nothing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56903,'Snake eyes...','Snake eyes...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56904,'You should help Mei.$B$BKen-Ken trying to think of way to cheer up these super-sads.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56905,'All these sad pandas making Ken-Ken a sad hozen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56906,'Lazy mutts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56907,'Get on with it!','Get on with it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56908,'I\'ve seen cats that are better guards than you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56909,'You would make better rugs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56910,'You\'ve sniffed every inch of this city.','You\'ve sniffed every inch of this city.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56911,'Anytime now...','Anytime now...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56912,'Just pick a spot already!','Just pick a spot already!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56913,'Sniff \'em out!','Sniff \'em out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56914,'The Arcane Storage Unit begins to overload. Step back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56915,'The bell is recharged! Strike it to weaken nearby enemies!','The bell is recharged! Strike it to weaken nearby enemies!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56916,'%s has buffed $t!','%s has buffed $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56917,'Greetings, traveller. I had not thought to see a friendly Horde face on these shores.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56918,'I feel the call of the Light, far to the north of here. But this place...$b$bIt has not known the light for many, many generations.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56919,'Ah, $p! These \"sunwalkers\" may not be the Hidden Master, but their fighting style is unlike anything I have ever seen.$b$bI intend to learn from them.','',2,1,0,0,0,0,0,0,1,0,0,0,26124),
(56920,'Be Gone.','',0,0,0,0,0,0,0,0,0,0,26496,0,26124),
(56921,'We followed Leza\'s visions of the light to this place like moths to a flame.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56922,'Alliance to our south, mogu to our east and west, and cliffs to the north. We are hemmed in on all sides.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56923,'I almost prefer the cold bite of Northrend to this appalling soggy heat. It\'s as if the trees themselves are trying to suffocate us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56924,'Dezco is a great chieftan, though I\'m beginning to doubt how well we can survive in this land he led us to.','Dezco is a great chieftan, though I\'m beginning to doubt how well we can survive in this land he led us to.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(56925,'This is a strange land. So beautiful. And yet so deadly.','This is a strange land. So beautiful. And yet so deadly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56926,'I thought I saw eyes in the underbrush...','I thought I saw eyes in the underbrush...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56927,'','When that day comes, seek all the light and wonder of this world, and fight.',0,0,0,0,0,0,0,0,1,0,0,28583,26124),
(56928,'','We live together, or we die together. All of Pandaria is connected.',0,0,0,0,0,0,0,0,1,0,0,28584,26124),
(56929,'','Welcome to the jungle, $r! Nesingwary dispatched me to gather info on the wildlife down here.$b$bFeel like lending a hand?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56930,'Un... provoked. The mogu attacked and... everything going dark...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56931,'','For the Alliance!',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(56932,'','The horde is here?!',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(56933,'','The horde shall not defile this land!',0,0,0,0,0,0,0,2,1,0,0,0,26124),
(56934,'','Thanks for the help friend. If you see Nesingwary and his boy to the west tell them how many things we killed. They like hearing that.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(56935,'','Citizens of Stormwind, rejoice! Deathwing is no more! The Cataclysm is over! A band of valiant heroes lashed out at the Destroyer with deadly precision and overwhelming might, granting the Dragon Aspects the opportunity to sacrifice their powers into one final strike. The last remains of Deathwing now reside here in Stormwind to serve as a beacon of hope for the future!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56936,'Citizens of Orgrimmar, rejoice! Deathwing is no more! The Cataclysm is over! A band of valiant heroes lashed out at the Destroyer with deadly precision and overwhelming might, granting the Dragon Aspects the opportunity to sacrifice their powers into one final strike. The last remains of Deathwing now reside here in Orgrimmar to serve as a beacon of hope for the future!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56937,'The Dojani Dynasty is remembered for their cruelty. Use caution.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(56941,'I can feel the elements awakening... rejoicing... the Cataclysm... is over.','',0,0,0,0,0,0,0,0,0,0,26496,0,26124),
(56942,'','I can show you the aftermath of Deathwing\'s destruction at the Maelstrom, if you wish.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56943,'Please show me, Chromie.','Please show me, Chromie.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56944,'I can\'t stay in town anymore. I must find a fight!','',0,0,0,0,0,0,0,0,1,13656,0,0,26124),
(56945,'I would look upon these lands with my own eyes.','',0,0,0,0,0,0,0,0,1,13656,0,0,26124),
(56946,'You could learn much by watching me in action.','',0,0,0,0,0,0,0,0,1,13656,0,0,26124),
(56947,'Come, my apprentice! You ARE my apprentice, right...?','',0,0,0,0,0,0,0,0,1,13656,0,0,26124),
(56948,'I can show you the aftermath of Deathwing\'s destruction at the Maelstrom, if you wish.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56949,'Show me, dragon.','Show me, dragon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56950,'I will see you at back at camp.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(56951,'This cannot be, is it finally over?  I must be dreaming again.','This cannot be, is it finally over?  I must be dreaming again.',0,0,0,0,0,0,0,0,0,0,26142,26142,26124),
(56952,'Together we have achieved the impossible.','',0,0,0,0,0,0,0,0,1,0,26261,0,26124),
(56953,'Now you must usher in a new age... The age of mortals.','Now you must usher in a new age... The age of mortals.',0,0,0,0,0,0,0,0,1,0,26498,26498,26124),
(56954,'Join me!','Join me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56955,'Old legends tell of the Dojani Dynasty and their Pools of Youth. Let us see if the legend is true.','',0,0,0,0,0,0,0,0,1,13657,0,0,26124),
(56956,'Attempt to free Na Lek from his prison.','Attempt to free Na Lek from his prison.',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(56957,'This wall of shadow will hold back the demons long enough for us to cross.\n$bWhen you and the other elves have crossed I will follow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56958,'Halt, supplicant! These waters belong to the Thunder King. Your presence is unwelcome.','',15,0,0,0,0,0,5,0,1,0,0,0,26124),
(56959,'Guardians! Kill these intruders.','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(56960,'Shhhh! They don\'t know that I\'m hiding here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56961,'I am only one pandaren, but I must stay here and help the serpents.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56962,'We must be very quiet. The Slitherscale will not hesitate to eat us for dinner.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56963,'I haven\'t bathed in sixteen days. It\'s easier to blend in this way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56964,'I\'ve collected so much data on serpents in the wild!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56965,'This is their natural breeding ground. We must tread carefully.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56966,'The little spirit is helping us! Fight near him, hero!','',0,0,0,0,0,0,0,0,1,13657,0,0,26124),
(56967,'Na Lek imbues $p with gratitude and returns to the waters of the pool.','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(56968,'Have you had a chance to visit the Temple of the Jade Serpent? Many of our students are sent to further their training within its walls, under the watchful gaze of Yu\'lon herself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56969,'Unfortunately, our efforts to breed the serpents have been unsuccessful. We carefully take a few eggs from the wild serpents to raise as our own.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56970,'Take me to the summit of Wyrmrest Temple to fight Ultraxion and his minions.','Take me to the summit of Wyrmrest Temple to fight Ultraxion and his minions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56971,'Look at that. The little guy left you some purified water.','',25,0,0,0,0,0,0,0,1,13657,0,0,26124),
(56972,'Brother, we must look to our defenses. The Alliance are encroaching on us from the east.','',1,0,0,0,0,0,0,0,1,13643,0,0,26124),
(56973,'You are a subject of the Horde. Remember your obligations and oaths. By the Warchief\'s command we must slay these night elves.','',1,0,0,0,0,0,0,0,1,13643,0,0,26124),
(56974,'You can only hide behind Leza\'s pain for so long. Sooner or later you must stand as the Sunwalker you claim to be and lead us against the enemies of the horde.','',1,0,0,0,0,0,0,0,1,13643,0,0,26124),
(56975,'I must stay by Leza\'s side until she has given birth. Death can wait for life.','',1,0,0,0,0,0,0,0,1,13643,0,0,26124),
(56976,'My orders from Baine were to secure new holdings in this land and investigate the light our sunwalkers felt. The Alliance is of little concern.','',1,0,0,0,0,0,0,0,1,13643,0,0,26124),
(56977,'Hate will blind you, brother, if you let it.','',1,0,0,0,0,0,0,0,1,13643,0,0,26124),
(56978,'The mogu have a way about them that implies leadership. Use caution.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56979,'I wouldn\'t mind settling down in a place like this. Great views, plenty of beer... and lots of stuff to fight.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(56980,'<Crack your knuckles and nod your head.>','<Crack your knuckles and nod your head.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56981,'You ready for a brawl, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56982,'We must regroup before the Sha attack again!','We must regroup before the Sha attack again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56983,'Priestess Flameheart has betrayed us! The temple is lost!','Priestess Flameheart has betrayed us! The temple is lost!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56984,'The Sha are too many, we must flee while we still have the chance!','The Sha are too many, we must flee while we still have the chance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56985,'','Umm... he\'s coming right at me.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(56986,'Mei, do you have any idea where I can find salt around here?','Mei, do you have any idea where I can find salt around here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56987,'','Should I run?',0,0,0,0,0,0,6,0,1,0,0,30391,26124),
(56988,'','I\'m gonna run.',0,0,0,0,0,0,0,0,1,0,0,30392,26124),
(56989,'Thank you for bringing back Yi-Mo.$B$BIt\'s clear to me now that we can no longer ignore our duties in the province.','Thank you for bringing back Yi-Mo.$B$BIt\'s clear to me now that we can no longer ignore our duties in the province.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56990,'Normally we\'d have plenty on hand, but most of our supplies have been left out to ruin in the rain.$B$BHowever, I\'m certain the creatures in the dried up ponds are a mixture of rainwater and salt from the earth. You may be able to get what you need from them.','Normally we\'d have plenty on hand, but most of our supplies have been left out to ruin in the rain.$B$BHowever, I\'m certain the creatures in the dried up ponds are a mixture of rainwater and salt from the earth. You may be able to get what you need from them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56991,'Nooooo... how can this be?','',0,0,0,0,0,0,0,0,1,0,26113,0,26124),
(56992,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56993,'Ahhh, here\'s a nice one. Yes, this egg will do. Not this one. Too small! Perhaps this one could pass the bill...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(56994,'Where am Jooga?','',0,0,0,0,0,0,0,0,1,0,29551,0,26124),
(56995,'What happen?','',0,0,0,0,0,0,0,0,1,0,29552,0,26124),
(56996,'What the ook?','',0,0,0,0,0,0,0,0,1,0,29553,0,26124),
(56997,'Jooga no can see!','',0,0,0,0,0,0,0,0,1,0,29554,0,26124),
(56998,'Where is me?','',0,0,0,0,0,0,0,0,1,0,29555,0,26124),
(56999,'Ookin\' barrels!','',0,0,0,0,0,0,0,0,1,0,29556,0,26124),
(57000,'Eat bananas!','',0,0,0,0,0,0,0,0,1,0,29545,0,26124),
(57001,'Bananas for everyone!','',0,0,0,0,0,0,0,0,1,0,29546,0,26124),
(57002,'Jooga not happy about barrel on head!','',0,0,0,0,0,0,0,0,1,0,29547,0,26124),
(57003,'Jooga feels angry about what you did!','',0,0,0,0,0,0,0,0,1,0,29548,0,26124),
(57004,'Jooga throwing his fruit! Because he feels mad!','',0,0,0,0,0,0,0,0,1,0,29549,0,26124),
(57005,'You throw barrel? Jooga throw banana! Taste better!','',0,0,0,0,0,0,0,0,1,0,29550,0,26124),
(57006,'Now, Jooga chase panda girl!','',0,0,0,0,0,0,0,0,1,0,29557,0,26124),
(57007,'Panda girl, why you so fast?','',0,0,0,0,0,0,0,0,1,0,29558,0,26124),
(57008,'You sneaky panda girl! Come back to Jooga!','',0,0,0,0,0,0,0,0,1,0,29559,0,26124),
(57009,'Jooga feel happy to see cute panda girl!','',0,0,0,0,0,0,0,0,1,0,29560,0,26124),
(57010,'Jooga just want give hug to panda girl.','',0,0,0,0,0,0,0,0,1,0,29561,0,26124),
(57011,'Oh panda girl... Jooga want feed you banana!','',0,0,0,0,0,0,0,0,1,0,29562,0,26124),
(57012,'','Eww!',0,0,0,0,0,0,1,0,1,0,0,30393,26124),
(57013,'','Gross!',0,0,0,0,0,0,1,0,1,0,0,30394,26124),
(57014,'','That\'s disgusting!',0,0,0,0,0,0,1,0,1,0,0,30395,26124),
(57015,'','Jooga is |cFFFF0000|Hspell:110182|h[Slippery]|h|r! Kick a barrel at him to make him stand still!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(57016,'Help! I lost my egg!','Help! I lost my egg!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57017,'Wait, I\'ve changed my mind about my egg.','Wait, I\'ve changed my mind about my egg.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57018,'I\'m sorry. I promise to be more careful.','I\'m sorry. I promise to be more careful.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57019,'I would like a blue serpent egg.','I would like a blue serpent egg.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57020,'I would like a green serpent egg.','I would like a green serpent egg.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57021,'I would like a yellow serpent egg.','I would like a yellow serpent egg.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57022,'Your lives are meaningless.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57023,'Yes, I know you lost your egg.$B$BHow do I know this? Because I have your egg RIGHT HERE.$B$BI will entrust this egg to you once more, but please, I deplore you, take better care of it this time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57024,'Give up your hope.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57025,'Our forces will fall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57026,'We will fail to defend Pandaria.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57027,'What? You changed your mind after all? I told you to pick carefully!$B$BAh well, I will forgive you this time. Tell me, which egg do you really want?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57030,'|Tinterface\\icons\\spell_fire_ragnaros_lavabolt.blp:0|tStructural damage to the Skyfire triggers a sudden |cFFFF0000|Hspell:110095|h[Deck Fire]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57031,'I... I can\'t hit him! That there bubble is too durn thick!','',0,0,0,0,0,0,0,0,1,0,30966,0,26124),
(57032,'I can\'t punch through this dang ol\' bubble!','',0,0,0,0,0,0,0,0,1,0,30967,0,26124),
(57033,'Let\'s kick them little bubbles back at him!','',0,0,0,0,0,0,0,0,1,0,30968,0,26124),
(57034,'Let\'s kick the little bubbles! At his FACE!','',0,0,0,0,0,0,0,0,1,0,30969,0,26124),
(57035,'Quick, $p! Come pop that bubble!','',0,0,0,0,0,0,0,0,1,0,30962,0,26124),
(57036,'Come here, $p! Give that bubble a good poke!','',0,0,0,0,0,0,0,0,1,0,30963,0,26124),
(57037,'Now get over here and pop his bubble, $p!','',0,0,0,0,0,0,0,0,1,0,30964,0,26124),
(57038,'$p! Come in close and help me pop this big ol\' bubble!','',0,0,0,0,0,0,0,0,1,0,30965,0,26124),
(57039,'Alright! Now I\'m gonna whup yer butt!','',0,0,0,0,0,0,0,0,1,0,30958,0,26124),
(57040,'I\'mma turn you into a stout!','',0,0,0,0,0,0,0,0,1,0,30959,0,26124),
(57041,'Look out! Here comes Mudmug!','',0,0,0,0,0,0,0,0,1,0,30960,0,26124),
(57042,'Back to the fightin\'!','',0,0,0,0,0,0,0,0,1,0,30961,0,26124),
(57043,'Run over the small bubbles to weaken Eddy\'s |cFFFF0000|Hspell:110189|h[Watery Shield]|h|r!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(57044,'Click on Eddy\'s weakened |cFFFF0000|Hspell:110198|h[Watery Shield]|h|r to pop it!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(57045,'Teeeeee hee hee heeeee!','',0,0,0,0,0,0,6,0,1,0,28696,0,26124),
(57046,'Hoooo hoo hooooo!','',0,0,0,0,0,0,6,0,1,0,28696,0,26124),
(57047,'Kekekekeke!','',0,0,0,0,0,0,6,0,1,0,28696,0,26124),
(57048,'Saurok take any opportunity to plunder, and with our Wardens out of commission they\'ve been running nightly raids on our supplies.$B$BThey take anything they can carry and sort through it back at their lair.$B$BCrafting supplies and pigments are just some of the things they\'re sure to be sitting on.','Saurok take any opportunity to plunder, and with our Wardens out of commission they\'ve been running nightly raids on our supplies.$B$BThey take anything they can carry and sort through it back at their lair.$B$BCrafting supplies and pigments are just some of the things they\'re sure to be sitting on.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57049,'This may be a strange request, but... do you have any ink or paint?','This may be a strange request, but... do you have any ink or paint?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57050,'','|Tinterface\\icons\\spell_fire_twilightrainoffire.blp:0|t%s fires a |cFF9900CC|Hspell:110153|h[Broadside]|h|r at the Skyfire!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57051,'Centuries ago, this land was still part of the wilds. Reaching the coast was a perilous journey, and many pandaren were lost to the beasts which roam Krasarang, nest of the great crane.$B$BThat is, until the famous hunter Zhu Longbrow came along. Tired of the needless loss of life, Zhu, along with his wife Rin and their son Po - both formidable hunters in their own right - carved out and settled a corner of the wilds.$B$BZhu did not want to settle the wilds entirely, though many begged him to do so. In his wisdom, he understood that they, too, served a purpose: protecting the great crane.$B$BThus Zhu Province was born, and Zhu\'s Watch to protect it.','Centuries ago, this land was still part of the wilds. Reaching the coast was a perilous journey, and many pandaren were lost to the beasts which roam Krasarang, nest of the great crane.$B$BThat is, until the famous hunter Zhu Longbrow came along. Tired of the needless loss of life, Zhu, along with his wife Rin and their son Po - both formidable hunters in their own right - carved out and settled a corner of the wilds.$B$BZhu did not want to settle the wilds entirely, though many begged him to do so. In his wisdom, he understood that they, too, served a purpose: protecting the great crane.$B$BThus Zhu Province was born, and Zhu\'s Watch to protect it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57052,'We will make this province safe again. Zhu\'s legacy will not end with this.','We will make this province safe again. Zhu\'s legacy will not end with this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57053,'Please tell me about Zhu\'s legacy.','Please tell me about Zhu\'s legacy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57054,'Longbrow? Does that mean Yi-Mo is a descendant of Zhu?!','Longbrow? Does that mean Yi-Mo is a descendant of Zhu?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57055,'That\'s correct. He is the last remaining member of the Longbrow line.$B$BSadly, he doesn\'t seem to be made of the same stuff as old Zhu. As I\'m sure you noticed, he\'s... dramatic.$B$BPlease do not take this as a sign of weakness: his name and the responsibilities that come along with it weigh on him heavily. I know Yi-Mo only wants what is best for the province.$B$BSome day he will come to understand that, at times, you must fight for what you love.','That\'s correct. He is the last remaining member of the Longbrow line.$B$BSadly, he doesn\'t seem to be made of the same stuff as old Zhu. As I\'m sure you noticed, he\'s... dramatic.$B$BPlease do not take this as a sign of weakness: his name and the responsibilities that come along with it weigh on him heavily. I know Yi-Mo only wants what is best for the province.$B$BSome day he will come to understand that, at times, you must fight for what you love.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57056,'Give me a hand, $p!','',0,0,0,0,0,0,22,0,1,0,29688,0,26124),
(57057,'Once we get rid of these spirits, we can move on.','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(57058,'That sure was nice of those spirits to hop into this pot.','',0,0,0,0,0,0,22,0,1,0,29689,0,26124),
(57059,'Whaaaa?','',0,0,0,0,0,0,22,0,1,0,29690,0,26124),
(57060,'Looks like we\'re not done yet, $p.','',0,0,0,0,0,0,22,0,1,0,29691,0,26124),
(57061,'Aspects! Aid the heroes as best you can.','',0,0,0,0,0,0,0,0,0,0,25895,0,26124),
(57062,'%s siphons vitality from Goriona and attacks with renewed vigor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57063,'(You cannot begin this encounter on Heroic Difficulty unless all prior encounters have been defeated on Heroic Difficulty.)','(You cannot begin this encounter on Heroic Difficulty unless all prior encounters have been defeated on Heroic Difficulty.)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(57064,'(You cannot begin this encounter on Heroic Difficulty unless all prior encounters have been defeated on Heroic Difficulty.)','(You cannot begin this encounter on Heroic Difficulty unless all prior encounters have been defeated on Heroic Difficulty.)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(57065,'','Finally!',0,0,0,0,0,0,5,0,1,0,0,30373,26124),
(57066,'I am called Chen, and this is my niece, Li Li.','',0,0,0,0,0,0,2,0,1,0,29667,0,26124),
(57067,'May we stay here at your farmhouse for a while? We do not have much in the way of money, but I will gladly share some of my famous ale with you.','',0,0,0,0,0,0,6,0,1,0,29670,0,26124),
(57068,'Greetings, Chen, Li Li. You may stay, but I do not need any of your ale.','',0,0,0,0,0,0,2,0,1,0,31201,0,26124),
(57069,'Thank you! We will not trouble you for long.','',0,0,0,0,0,0,273,0,1,0,29668,0,26124),
(57070,'Interesting. He does not like beer? A very strange land, indeed.','',0,0,0,0,0,0,6,0,1,0,29669,0,26124),
(57071,'','Really, Uncle? We\'re stopping already? We only moved, like, ten feet.',0,0,0,0,0,0,5,0,1,0,0,30374,26124),
(57072,'Alright, alright already! Enough with the shoving!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57073,'I have a pretty good idea what ol\' Great-father Winter\'s gonna be doing when this shift is over.  I got a bottle of Winter Veil cheer right here in my bag, and I intend to get to the bottom of it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57074,'Yeah, sure, go ahead and tell ol\' Great-father Winter what you\'d like for this Winter Veil.$B$BHo ho hurry up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57075,'Mm-hmm.','',0,0,0,0,0,0,273,0,1,18353,32054,0,26124),
(57076,'Normally, new trainees have a little more time to prepare.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(57077,'Unfortunately, your hatchling does not want to wait!','',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(57078,'I hope you work hard, $n. To raise a cloud serpent is an honor bestowed upon a rare few.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(57079,'It\'s starting!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57080,'I\'m going to my room. Feel free to tell my aunt about how you \"heroically\" saved me from myself or whatever.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57081,'Here you go, girls! Courtesy of $p!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57082,'Ugh... where am I?','Ugh... where am I?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57083,'','Alright! Back to Uncle Chen at Halfhill! Race you there, $n!',0,0,0,0,0,0,0,0,1,0,0,30401,26124),
(57084,'','Get away from that, mongrel!',0,0,0,0,0,0,0,0,1,0,0,26235,26124),
(57085,'You sure we\'re goin\' the right way, neighbor?','',0,0,0,0,0,0,0,0,1,0,31009,0,26124),
(57086,'I\'m trustin\' you not to walk me off that big ol\' cliff.','',0,0,0,0,0,0,0,0,1,0,31010,0,26124),
(57087,'I thought I could carry a lot... until I saw all the crud you carry around in those bags o\' yers.','',0,0,0,0,0,0,0,0,1,0,31012,0,26124),
(57088,'I reckon we\'re almost there now.','',0,0,0,0,0,0,0,0,1,0,31013,0,26124),
(57089,'Sure could go for a drink of water right now.','',0,0,0,0,0,0,0,0,1,0,31014,0,26124),
(57090,'Yup.','',0,0,0,0,0,0,0,0,1,0,31015,0,26124),
(57091,'Mmm-hmmm.','',0,0,0,0,0,0,0,0,1,0,31016,0,26124),
(57092,'Still carryin\' these barrels back here.','',0,0,0,0,0,0,0,0,1,0,31018,0,26124),
(57093,'Can\'t wait to try this beer that Chen\'s thinkin\' about.$b$bHe talks a big game, that one.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57094,'Let\'s head back to Halfhill, Mudmug.','Let\'s head back to Halfhill, Mudmug.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57095,'I\'m trustin\' you not to lead me into any rivers, or animal mouths. Nothin\' like that.','',0,0,0,0,0,0,0,0,1,0,31005,0,26124),
(57096,'Wait... which way did you go?','',0,0,0,0,0,0,0,0,1,0,31007,0,26124),
(57097,'Told you I was strong. Didn\'t drop one barrel.','',0,0,0,0,0,0,0,0,1,0,31025,0,26124),
(57098,'I can\'t believe this. How much do they feed this thing?','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(57099,'You missed some.','You missed some.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57100,'I know, I know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57101,'Focus all of your attacks onto one single slime!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57102,'Don\'t underestimate my father. Even if you were to crush his body, the core of his madness and rage will still struggle to destroy you.','',0,0,0,0,0,0,1,0,1,0,26431,0,26124),
(57103,'He will not be defeated until he is utterly annhilated.','',0,0,0,0,0,0,6,0,1,0,26432,0,26124),
(57104,'I wish I could help but... my father is the one dragon I fear.','',0,0,0,0,0,0,1,0,1,0,26433,0,26124),
(57105,'Best of luck, rogue. Whatever the outcome, you are truly a champion.','',0,0,0,0,0,0,1,0,1,0,26434,0,26124),
(57106,'You were in a raid. Still, my hat\'s off to you, I don\'t even know where Kharazan is. How did you get there?','You were in a raid. Still, my hat\'s off to you, I don\'t even know where Kharazan is. How did you get there?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57107,'Intercept |cFF9900CC|Hspell:107439|h[Twilight Barrage]|h|r to prevent damage to the Skyfire!','Intercept |cFF9900CC|Hspell:107439|h[Twilight Barrage]|h|r to prevent damage to the Skyfire!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57108,'Why don\'t you get a job somewhere else?','Why don\'t you get a job somewhere else?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57109,'|c0087CEFA|Hspell:105845|h[Nuclear Blast]|h|r wasn\'t close enough to pry up the plate!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57110,'I deserve better than this! I am an actor, a performer- not a common dungsweep! For Light\'s sake, I\'ve performed in the opera at Kharazan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57111,'%s didn\'t absorb enough Corrupted Blood residue to trigger a Nuclear Blast.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57112,'Practice, practice, practice!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57113,'Now look at me. Sweeping up after this dumb beast.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57114,'What, and give up showbusiness?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57115,'Use the Heroic Will ability to avoid Hour of Twilight and Fading Light!','Use the Heroic Will ability to avoid Hour of Twilight and Fading Light!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57116,'Everything suddenly seems... brighter.','Everything suddenly seems... brighter.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57117,'I feel... happy!!','I feel... happy!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57118,'Destroy the Mana Void to regain lost mana!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57119,'Oh, my head hurts...','Oh, my head hurts...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57120,'What am I doing out here? I\'ve got work to do!','What am I doing out here? I\'ve got work to do!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57121,'You come to fight my brood? You come to steal my treasures?','',0,0,0,0,0,0,0,0,1,0,26894,0,26124),
(57122,'Time for Chufa\'s surprise!','',0,0,0,0,0,0,0,0,1,0,26900,0,26124),
(57123,'You\'re in for it now!','',0,0,0,0,0,0,0,0,1,0,26894,0,26124),
(57124,'Did I miss anything?','',0,0,0,0,0,0,6,0,1,0,29756,0,26124),
(57125,'What!?','',0,0,0,0,0,0,53,0,1,0,29757,0,26124),
(57126,'Looks like I made it just in time!','',0,0,0,0,0,0,0,0,1,0,29758,0,26124),
(57127,'Run to the orb if you are connected to it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57128,'$n! Get out of the black ooze on the ground!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57129,'$n, you were slain by a Resonating Crystal. Standing closer to the Resonating Crystal reduces the damage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57130,'Let\'s do this!','Let\'s do this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57131,'$n, you were slain by Hagara\'s Ice Wave. $BStart running early to avoid the ice!','$n, you were slain by Hagara\'s Ice Wave. $BStart running early to avoid the ice!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57132,'Uh oh... my battle armor... weakening...','',0,0,0,0,0,0,0,0,1,0,26898,0,26124),
(57133,'I\'ll let you clean up in here, $p. See you back at Mudmug\'s!','',0,0,0,0,0,0,4,0,1,13724,29759,0,26124),
(57134,'Another soul lost to the Destroyer...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57135,'Today, $n, we celebrate your graduation. You have learned all that there is to know within the walls of Tian.','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(57136,'Welcome back, $n! How goes your training?$b$bOur trainees have missed you dearly... though I must say that they appreciate not having to spar with you anymore.','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(57137,'There is no hope, no future. All life is doomed.','',0,0,0,0,0,0,0,0,0,0,26528,0,26124),
(57138,'Like you, all of Azeroth shall burn.','',0,0,0,0,0,0,0,0,0,0,26529,0,26124),
(57139,'Know that your world will soon follow.','',0,0,0,0,0,0,0,0,0,0,26530,0,26124),
(57141,'','Be one with your serpent, $n. Perceive your serpent\'s experiences as your own and strengthen your bond.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57142,'Hozen can learn martial arts too, you know.$b$bKen-Ken better than all these other guys put together. ESPECIALLY better than Clever Ashyo the Dumb Jinyu, over there.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(57143,'','We\'ve just graduated from the Tian Monastery, in the Jade Forest. Have you been there before?$b$bWe\'re not students anymore. We\'re on our first quest - the quest to find the Hidden Master.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57144,'','$n! It\'s me! Remember? From the Tian Monastery?$b$bIt took me a while, but I\'ve finally graduated! Xiao, too, and... well, everybody else that you see here.$b$bWe\'re not students anymore. We\'re on our first quest - the quest to find the Hidden Master.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57145,'Beggars and usurpers, we will burn you and your pandaren allies to ash.','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(57146,'The elders of my village taught me that wisdom flows through every river, and collects in every pond. I can\'t wait to learn what the waters of this place have to offer.$b$bThe elders of my village also taught me that one should never trust a hozen.$b$b<Ashyo shoots a wary glance over at Ken-Ken.>','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(57147,'Finally, a chance to use the skills we\'ve been training for. Who knows what adventure we\'ll find here in the Valley of the Four Winds?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(57148,'I lost my serpent! Could you perform the spirit link once again?','I lost my serpent! Could you perform the spirit link once again?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57149,'Alright, now we need someone to test this on...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57150,'You! Get over here, mopesy. Ken-Ken got just the thing for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57151,'Who, me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57152,'Sure, it\'s not like things could get any worse...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57153,'%s\'s gut churns violently.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57154,'Are you sure you want to pay?','Are you sure you want to pay?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57155,'Chezin lay dead with grievous wounds both physical and magical.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57156,'Oh... ughh... what have you done to me?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57157,'Here, drink this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57158,'Hahaha! It worked! Ken-Ken KNEW it would work! You feelin\' better now?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57159,'Ughh... urrrggg....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57160,'NO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57161,'Faster, you fools. We need all of these artifacts soon or it\'s the cane for your hides.','',15,0,0,0,0,0,0,0,1,13743,0,0,26124),
(57162,'Nobody can be sad when they wearin\' a mask like this! Now, who can we test it on?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57163,'Perfect! C\'mere, buddy. Sorry about last time! Put this on.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57164,'Ugh... what was that stuff? It went through me like bad tea.','Ugh... what was that stuff? It went through me like bad tea.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57165,'%s sighs deeply.','%s sighs deeply.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57166,'Fine... whatever. Hand it over.','Fine... whatever. Hand it over.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57167,'I... I feel... happy!','I... I feel... happy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57168,'Thank you so much, brave heroes! I will tell stories of you! Of $p the Mighty! And Ken-Ken the Fearless!','Thank you so much, brave heroes! I will tell stories of you! Of $p the Mighty! And Ken-Ken the Fearless!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57169,'What the ook is that?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57170,'Oh, the hozenity! Get it out of here! Ken-Ken too smart to die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57171,'Is it... is it gone?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57172,'Yeah... The Fearless... sounds good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57173,'No, we been tricked!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(57174,'We been duped!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(57175,'I confused!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(57176,'Yuck!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(57177,'Gross!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(57178,'Get away from it!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(57179,'Run away! Run away!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(57180,'It horrible!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(57181,'False carrot alert! False carrot alert!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(57182,'Stay away! We no know what it can do!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(57183,'Watch the skies for Alliance eyes. I will see you back at Thunder Cleft. Hellscream\'s eyes are upon you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57184,'This jungle is filled with an unnatural sense of dispair.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57185,'The sadness in the earth is quelling the gifts granted me by the light.$b$bMy wife, she is suffering, and none of my abilities are able to help her.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57186,'Your hatchling chases after the ball!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57187,'Your hatchling wants to catch this one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57188,'Don\'t worry, your hatchling\'s got it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57189,'Kneel supplicant!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57190,'We will rise again, and your kind will be made to serve!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57191,'Your kind is no match for the return of our Thunder King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57192,'For the Thunder King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57193,'Avert your eyes, peasant!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57194,'Your kind were made to be ruled.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57195,'Bow before our might!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57196,'Well done, $p!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57197,'Victory is mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57198,'Face the wrath of the Bramblestaff!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57199,'I think I punched him so hard his ancestors felt it.','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(57200,'','The rest of Nesingwary\'s Safari is up in the western side of the Valley of Four Winds. If you find yourself heading west, you should join us. Good hunting!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57201,'How did you get here?','How did you get here?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57202,'','I\'m part of the Nesingwary Safari. We were riding along in our hot air balloon through some mists when we came across this land.$b$bNesingwary and his boy wanted to hunt some of the hoofed animals and what not up north.$b$bI decided to get a headstart on them in the jungle where the real beasts are.$b$bA rocket ride later I\'m neck deep in tigers.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57205,'A $c? Here? And a Horde no less.$b$bWe could make good use of you if you are willing to help.$b$bWe followed visions and dreams to get here only to find a nightmare waiting for us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57206,'What the... Sha nasties are poppin\' out everywhere! We gotta take care of them first!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57207,'Okay, no more time. Yi-Mo needs help now! Let\'s get a mask on him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57208,'Me pop n\' I are on a genuine safari. This is a strange, new land filled with dangers around every turn, monsters pokin\' out of every hole, and beasts as ol\' as the dirt itself livin\' life without fear.$b$bIt\'s huntin\' season!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57209,'Hey there, $p! It\'s been a while since we shared a proper hunt, now hasn\'t it. Let\'s see if time has softened yer aim.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57210,'|cFFFF0000|Hspell:106794|h[Shrapnel]|h|r killed you! Use |cFF04FC32|Hspell:106466|h[Dream]|h|r to prevent damage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57211,'|cFFFF0000|Hspell:105723|h[Elementium Bolt]|h|r killed you.  Move away from the impact point to decrease the bolt\'s damage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57212,'ALL IS LOST! LAY DOWN AND SUBMIT TO YOUR DESPAIR!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57213,'','Your serpent will arrive in just a moment. Good luck!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57214,'Instructor Windblade, could you call my serpent again?','Instructor Windblade, could you call my serpent again?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57215,'','Your serpent is arriving now. Please mount when you are ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57216,'','The journey to becoming a Serpent Master is a difficult one. Are you up for the challenge?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57217,'','Great dedication is necessary to ascend the ranks of the Order of the Cloud Serpent. I wish you luck.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57218,'Thrall was killed! Attack Corrupted Slimes to prevent damage to him.','Thrall was killed! Attack Corrupted Slimes to prevent damage to him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57219,'Stand solo against a yeti with nothing but a bowie knife while wearing a loincloth and you\'ll earn yourself the title of \"lucky\" as well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57220,'Yi-Mo will be fine for right now, we gotta take care of these nasties first!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57221,'$GHe\'s:She\'s; coming to!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57222,'','Students of our Order test their speed in an aerial competition known as the Sky Race.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57223,'','I will teach you the rules of this race. Follow me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57224,'Alright, let\'s see if this ol\' ritual will work.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57225,'You\'ll see, Pop. I\'m gonna bag me a big one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57226,'Step one: dance.','',94,0,0,0,0,0,0,0,1,0,0,0,26124),
(57227,'Step two: say the words. \"Heed my call, waters of pain, and bring forth, Torjari\'s Bane!\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57228,'The master calls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57229,'Oh, resorting to hocus pocus now are ya?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(57230,'Junior! Nooooo!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(57231,'Come on! We need to save my boy!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(57232,'$p! Are you okay? Wake up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57233,'','I will gain speed as the exercise continues. Try to keep up.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57234,'','If you start to get too far, I will warn you. If you continue to stray, I will not hesitate to fail you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57235,'','I will guide you with this rope. If you get too far away from me, it will break and I will be forced to restart the exercise.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57236,'','Do you see the hanging pennants above our heads? These flags mark the race course. If you ever get lost, you can use these flags as a guide.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57237,'','As you undergo these trials, you and your serpent will strengthen your bond.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57238,'','Stay with me, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57239,'','When you are on your own, your enemies will not be as kind as I.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57240,'','PH Random 4',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57241,'','PH Random 5',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57242,'','PH Random 6',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57243,'','PH Random 7',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57244,'','PH Random 8',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57245,'','We\'re almost done. Just the homestretch now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57246,'','Well done, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57247,'','You fell too far behind!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57248,'','You must keep up with me, $n. Venture too far and you will fail the exercise.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57249,'','Speak to me when you are ready to try again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57250,'','You must fly through all 10 checkpoints before you can finish the race.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57251,'','In a real race, you will need to fly through each checkered flag to get credit for passing the checkpoint.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57252,'','You are too far! Get closer to your Instructor!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57253,'Oh... what... who? How did I get here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57254,'Sorry I made such a mess o\' things.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57255,'I love ya pop.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57256,'Junior! Junior! Snap out of it.','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(57257,'Junior! Junior! Snap out of it.','',22,0,0,0,0,0,0,0,1,13772,0,0,26124),
(57258,'Come on boy, you\'re stronger \'an this thing.','',20,0,0,0,0,0,0,0,1,13772,0,0,26124),
(57259,'$p is coming. They can help us get you out of here.','',20,0,0,0,0,0,0,0,1,13772,0,0,26124),
(57260,'The master comes.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57262,'<Try shaking Hemet.>','<Try shaking Hemet.>',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57263,'$p, watch the corners. I hear something comin\'.','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(57264,'You chose the wrong hunter to hunt! $p, kite that thing a little further away so I can get a better shot.','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(57265,'We did it, $p! That was some good butt-punchin\' back there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57266,'$p... To think you\'d risked your life to save me - twice now - and I\'d only treated you with disdain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57267,'I am shamed beyond comprehension. Please forgive me - my mind was not my own.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57268,'Should you ever need aid of any kind, from a handful of turnip seeds to a volley of arrows, know that Zhu\'s Watch will provide it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57269,'For now, I must direct my attention to rebuilding the village. There is much to be done. You may rest here if you like, but we\'ll not accept any more help.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57270,'Something tells Ken-Ken that\'s not the last of the sads, though...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57271,'Where are we? Smells like... like carrots and turds.','',0,0,0,0,0,0,0,0,1,0,31019,0,26124),
(57272,'Who\'s that guy? The guy you were talkin\' to? Can someone tell me what\'s goin\' on?','',0,0,0,0,0,0,0,0,1,0,31021,0,26124),
(57273,'Where you takin\' me, $p?','',0,0,0,0,0,0,0,0,1,0,31022,0,26124),
(57274,'Was that a hozen I heared? Are we in Halfhill yet?','',0,0,0,0,0,0,0,0,1,0,31023,0,26124),
(57275,'Li Li? Is that you? Hello? Anybody gonna pay attention to ol\' Mudmug?','',0,0,0,0,0,0,0,0,1,0,31024,0,26124),
(57276,'Junior! You\'re okay!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(57277,'No, you were right. You did put \"BIG\" into \"big game hunting\". You done me proud son!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(57278,'I love ya too, son. Now let\'s go get us a pint!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57279,'He is coming...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57280,'You got any other errands you need to run? Don\'t you worry about ol\' Mudmug... just poke me when we get there.','',0,0,0,0,0,0,0,0,1,13774,31008,0,26124),
(57281,'','Spread among the spires are 10 hot air balloons, or checkpoints. We are passing one just now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57282,'Welcome, $p! I\'ll never forget the help ya gave me savin\' my boy. Now that was a proper hunt!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57283,'I canna\' believe I made myself the bait for a trap. Lucky for me you an\' me Pop were there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57284,'A new land, and you want to hunt boring old wolves?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57285,'Quality over quantity my boy.','',11,1,0,0,0,0,0,0,1,0,0,0,26124),
(57286,'Now... THAT is a trophy.','',1,11,0,0,0,0,0,0,1,0,0,0,26124),
(57287,'Are your trophies shrinking, Pop? Or are you hunting smaller game?','',11,1,0,0,0,0,0,0,1,0,0,0,26124),
(57288,'','Your serpent is arriving now. You can find the flags hanging from the red hot air balloons in the sky.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57289,'','Contestants to the starting line! The Sky Race is about to begin!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57290,'','The rules are simple. Pass through all 10 checkpoints and cross the finish line.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57291,'','3...',0,0,0,0,0,0,0,0,1,0,0,25477,26124),
(57292,'','2...',0,0,0,0,0,0,0,0,1,0,0,25477,26124),
(57293,'','1...',0,0,0,0,0,0,0,0,1,0,0,25477,26124),
(57294,'','GO! To the skies!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57295,'GO!!!!','GO!!!!',0,0,0,0,0,0,0,0,1,0,12197,12197,26124),
(57296,'You finished in...\n...\n1ST PLACE!','You finished in...\n...\n1ST PLACE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57297,'You finished in...\n...\n2ND PLACE!','You finished in...\n...\n2ND PLACE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57298,'You finished in...\n...\n3RD PLACE!','You finished in...\n...\n3RD PLACE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57299,'You finished in...\n...\n4TH PLACE!','You finished in...\n...\n4TH PLACE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57300,'You finished in...\n...\n5TH PLACE!','You finished in...\n...\n5TH PLACE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57301,'You finished in...\n...\n6TH PLACE!','You finished in...\n...\n6TH PLACE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57302,'You need to pass through all 10 checkpoints before completing the racecourse!','You need to pass through all 10 checkpoints before completing the racecourse!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57303,'Do you want to start the encounter?','Do you want to start the encounter?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57304,'How did you get here?','How did you get here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57305,'We were called.$b$bWe sailed deep into uncharted waters, at first on orders from High Chieftan Baine Bloodhoof.$b$bIt was my wife Leza whose visions gave us a course to sail by.$b$BBut when we saw the wall of mists, we all began to feel the call like a voice on the wind. North. The voice calls for us to travel north.$b$bWe came ashore, dismantled our ship, and sailed up river by canoe until we hit the cliff you see before us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57306,'What is happening inside the tent?','What is happening inside the tent?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57307,'It was Leza\'s visions that led us here. Each of us have had dreams of a valley, golden with blossoms, filled with the hope of peace.$b$bEven our chieftan Baine Bloodhoof had these dreams.$b$bOnly Leza\'s visions gave us a path to follow, though. And now, here we are, for better or worse.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57308,'','To the fastest riders go the prizes of victory! Mount your cloud serpents!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57309,'Meet me at the Torjari Pit once you have the carcasses, $p.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57310,'$p! Nesingwary and Nesingwary are waiting for you at the Torjari Pit.','',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(57311,'Your serpent gobbles up the food hungrily.','Your serpent gobbles up the food hungrily.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57312,'Your serpent gulps down the food. Yum!','Your serpent gulps down the food. Yum!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57313,'Your serpent eats the food and looks around for more.','Your serpent eats the food and looks around for more.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57314,'Oh, another one eh? $p, kite him toward the back o\' the cave so I can snipe him.','',22,0,0,0,0,0,0,0,1,13765,0,0,26124),
(57315,'Your serpent licks its lips. That was delicious!','Your serpent licks its lips. That was delicious!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57316,'Your serpent looks at you imploringly. Is there more?','Your serpent looks at you imploringly. Is there more?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57317,'Your serpent\'s belly looks a little rounder.','Your serpent\'s belly looks a little rounder.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57318,'Your serpent nudges you affectionately before digging in.','Your serpent nudges you affectionately before digging in.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57319,'Your serpent thought that the food was delicious.','Your serpent thought that the food was delicious.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57320,'','You show much promise, $n, but you must nurture your talent with discipline.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57321,'Thank ye for saving me, $p! I owe ya a big one.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57322,'','A young serpent is a delicate thing. This is the time when bad habits form. Good training makes a difference.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57323,'','Young serpents are much more playful than their adult counterparts.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57324,'','The path of the cloud serpent rider is long and arduous, but you will travel it together with your cloud serpent companion.$B$BIf you reach the end of the road together, you will have a loyal friend who will carry you to the end of your days.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57327,'','Alright, Leza, I need you to push. Are you ready?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57328,'','%s nods.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57329,'','Push!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57330,'','AAAHHH! HNNNH!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57331,'','GAAAAAAHHH!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57332,'','Good, that was good. You can rest now. I will get you some more hot water.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57333,'Instructor Windblade, could you call my serpent again?','Instructor Windblade, could you call my serpent again?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57335,'See you at Thunder Cleft, $p. May the sun\'s light protect you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57336,'$p, meet me back at Thunder Cleft. I must bring my brother\'s body back to our people.','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(57337,'Instructor Windblade, how is my serpent doing?','Instructor Windblade, how is my serpent doing?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57338,'','You have given much of your time, patience, and love, $n. Behold your serpent now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57339,'You are right, $p. I should be there for Leza. Thank you.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(57340,'','Dezco... it hurts... it... AAAHHH!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57341,'','Something\'s wrong. The baby\'s turned the wrong way.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(57342,'','Dezco, where are you?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57343,'I\'m here, Leza.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(57344,'','My love... whatever happens... you must protect our... our child....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57345,'Leza!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(57346,'LEZA!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57347,'','GAAAHHH!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57348,'','Today, your journey toward the Order of the Cloud Serpent ends. Today, a new rider joins our ranks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57349,'','Today, you forge an eternal bond with your cloud serpent.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57350,'Through thunder and storm, we fly together.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57351,'','Through sea and sky, we fly together.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57352,'','Through wind and tide, we fly together.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57353,'','Never again will you fly alone.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57354,'With the Riders behind me, and my serpent beside me.','With the Riders behind me, and my serpent beside me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57355,'','Fly together with honor and courage. Now... rise as a serpent rider!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57356,'Go, stand by your wife\'s side. I will protect the tent from invaders.','Go, stand by your wife\'s side. I will protect the tent from invaders.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(57357,'My child is nearly here... everything changes today...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57358,'My fur, doesn\'t it look good today?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57359,'Agara makes me look good, just like I make her look good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57360,'I\'ve been told that I\'m the best-looking rider in the skies. I wouldn\'t believe that if I were you. I\'m also the best-looking rider on land, under the sea...well, just about anywhere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57361,'I see you\'re here to admire my serpent. Oh, and Agara is quite impressive too.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57362,'Hey, how youuu doing?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57363,'After this, me and some of the boys are going to visit The Dancing Serpent Inn for some brew.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57364,'Hey rookie, when you\'re at Windward Isle, keep your eyes open for onyx eggs. The Serpent Masters\'ll go nuts if you bring one to them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57365,'Oh, are you here from my fan club? I\'m sorry, I\'m not giving autographs right now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57366,'Sorry, I can\'t talk right now. After we\'re done training here, it\'s time for lunch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57367,'I may not be the best rider, but I have the best inventions!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57368,'When I get sad about losing, I eat...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57369,'I have an idea for a new invention. It\'s called a pooper hooper. I\'ll never have to pick up poop again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57370,'Did you know that you can sometimes find rare onyx eggs on Windward Isle? If you bring one to a Serpent Master, you will gain great respect within the Order.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57371,'You gotta eat well to keep up your strength! That\'s what my mama always told me, anyway...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57372,'','I can\'t talk right now. I\'m very busy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57373,'','Could you come back later? I am busy training my cloud serpent right now. I must work harder if I wish to beat the others.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57374,'','I\'m not worried about my competition. Because I know I will win.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57375,'','The only one I\'m worried about is Qua-Ro. He always has some trick up his sleeve.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57376,'','You wish to race against me? Ha! You\'ll be seeing the back of my serpent\'s tail.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57377,'','I won\'t beat the others by standing around talking to you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57378,'','Oh yeah, I\'ve brought plenty of onyx eggs to Elder Anli. Whenever I give her one, I rise higher in the ranks of the Order.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57379,'','If I don\'t work hard, I will fall behind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57380,'A studious rider is a successful rider.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57381,'Shouldn\'t you be practicing?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57382,'The best experience is one\'s own.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57383,'I can tell you my tricks for riding, but they are nothing compared to your own practice and experience.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57384,'Why am I so fast? If I tell you, I would only be disadvantaging myself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57385,'Learn from the masters. I have nothing to teach you, for I am but a student.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57386,'The other trainees have their skills and talents. I am honored to ride with them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57387,'It is an honor to ride with you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57388,'','Hi! How are you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57389,'','If you need any help, just ask me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57390,'','Try to remember where the checkpoints are located. Once you know where to pick up the flags, you can chart the shortest course.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57391,'','Flying through cloud rings is the best way to pick up speed. Sometimes it\'s worth going out of the way for that boost of speed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57392,'','Look around for new paths. Sometimes the fastest way is not the most obvious!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57393,'','I\'ve heard from the other trainees that you can find rare onyx eggs at Windward Isle. I\'ve looked and looked, but I haven\'t found any yet!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57394,'','Skill is important, but sometimes it comes down to luck.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57395,'','Don\'t worry, I\'ll be rooting for you even if you come in last!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57396,'I may not be the best rider, but I have the best inventions!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57397,'All the other trainees are such good riders. I hope to be as good as them someday. In the meantime, I just have to keep practicing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57398,'','The care of a young serpent is a delicate thing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57399,'','Unless you want to help me clean the nests, you had best let me get back to work.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57400,'','I spend half my time in the libraries and the other half caring for the hatchlings.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57401,'','Do you know the history of the Serpent Riders? It is quite an interesting study.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57402,'','Someday I hope to improve on our ancient knowledge. Much of it has been lost through the ages.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57403,'','Someday when you have seen more of the world, you should come back and speak to me. I can tell you all about the Serpent Riders.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57404,'','Speak to Elder Anli if you are interested in joining our ranks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57405,'We welcome all who wish to join our ranks, but you need some more experience before you can begin. Please come speak to me later.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57406,'A new student?$B$BYes, of course.$B$BYou come to me all bright-eyed and bob-tailed, thinking to take home a the great cloud serpent of the east.$B$BWell, you should consider the journey carefully.$B$BIt is not an easy path to take.$B$BThe Order only accepts students who have the potential to see their training through to the end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57407,'','Welcome to The Arboretum, traveler.$B$BThis is the home of the Order of the Cloud Serpent. Together with our cloud serpents, we are sworn to defend The Jade Forest.$B$BYou, too, can join our ranks. However, you need more experience before you can begin the journey.$B$BGo and travel the land, then return to me when you are stronger.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57408,'','There is no experience quite like riding on the back of a war serpent.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57409,'','You are rough, untested, unranked. You fly alone.$B$BIf you wish to change this, speak to Elder Anli to the west.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57410,'Ah, another admirer! My reputation precedes me, I\'m sure.$B$BDon\'t worry, someday perhaps you and I will ride together.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57411,'Don\'t worry, kid. Riding\'s not as hard as it looks.$B$BYou should get a few more notches on your belt before attempting this, though.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57412,'','I\'m sorry, I am too busy to speak to strangers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57413,'Someday, perhaps you too can aspire to become a serpent rider.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57414,'','Hi there!$B$BYou\'ll need a few more seasons behind you before joining us. Hope to see you soon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57415,'What is the Sky Race? Why, only the greatest test of a Serpent Rider\'s skill!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57416,'You want to race? An unseasoned pup like you?$B$BHa! Hahahahahaha!$B$BThe little ant wants to race against giants!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57417,'Help $p!','Help $p!',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(57418,'$p! Over here!','$p! Over here!',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(57419,'$p! There are mogu near! Watch out!','$p! There are mogu near! Watch out!',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(57420,'','First place? Wow!$B$BPretty good for a young trainee.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57421,'','Hey, 2nd place is darn good. You\'ll get \'em next time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57422,'','Top three is still quite impressive. Top half is better than the bottom half, am I right?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57423,'','Fourth place. Well, it\'s not very remarkable. That\'s all right. You can always try again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57424,'','Fifth place? At least you weren\'t last.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57425,'','Well you came in last.$B$BNowhere to go but up, right?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57426,'Thank you so much $p!','Thank you so much $p!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57427,'Thank you! They were saying we were going to be slaves.','Thank you! They were saying we were going to be slaves.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57428,'I will never forget this, hero.','I will never forget this, hero.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57429,'They said they were looking for slaves and weapons.','They said they were looking for slaves and weapons.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57430,'%s is snoring peacefully.','%s is snoring peacefully.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57431,'Oh great! Someone else has come to bother me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57432,'Guess I\'ll just sleep for another day...','Guess I\'ll just sleep for another day...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57433,'Just go away! Zhu\'s Watch takes care of itself. We don\'t need any help from so-called \"adventurers!\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57434,'Master, I wish to review my basic training.','Master, I wish to review my basic training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57435,'Guardian! Awaken and defend your master!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(57436,'Groundbreaker Brojai is reviving a Ruined Guardian.','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(57437,'You fail to bend the knee to our power? Then die like the vermin you are.','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(57438,'These... mogu... are tougher than I gave them credit for. And clever. You shouldn\'t have come, this is a trap.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57439,'<Try to free Kor Bloodtusk from his bonds.>','<Try to free Kor Bloodtusk from his bonds.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57440,'KOR! NOOOOOOOO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57441,'Hey, $p, come over here! Ken-Ken thinks he knows how to fix sad pandas!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57442,'Prepare to bask in my victory, ladies and gentlemen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57443,'Let\'s go to The Dancing Serpent Inn after the race to toast my victory. The first round\'s on you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57444,'I won\'t be getting any dirt on this beautiful face.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57445,'I\'m going to beat you all with my latest invention. It\'s a cloud magnet!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57446,'I\'m going to beat you all with my latest invention. It\'s a remote control rider unseater!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57447,'Uh uh! Wait till you guys get a whiff of my latest invention! I\'ll give you a hint. It\'s a pumpkin soaker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57448,'Uh uh! Wait till you guys get a whiff of my latest invention! I\'ll give you a hint. It\'s a squash rocket!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57449,'I\'m going to beat you all with my latest invention. It\'s a quick flag extractor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57450,'I\'m going to beat you all with my latest invention! It\'s a checkpoint position finder!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57451,'I\'m going to beat you all with my latest invention! It\'s a wind funneler!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57452,'I\'m going to beat you all with my latest invention! It\'s a carrot on a stick!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57453,'','I\'ve been practicing all week for this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57454,'','I\'ll wait for you all on the other side of the finish line!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57455,'','After the race, I\'ll be sure to show you all my first place prize!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57456,'Retreat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57457,'Too... worthy... a foe...','',34,0,0,0,0,0,0,0,1,0,0,0,26124),
(57458,'Master, I wish to review my advanced training.','Master, I wish to review my advanced training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57459,'Yes, the one with the eggs.','Yes, the one with the eggs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57460,'Advanced training? Do you mean the one with the eggs?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57461,'Out of the scroll, demon!','',0,0,0,0,0,0,0,0,0,0,30892,0,26124),
(57462,'I grant you eternal peace!','',0,0,0,0,0,0,0,0,0,0,30893,0,26124),
(57463,'I free you from existence!','',0,0,0,0,0,0,0,0,0,0,30894,0,26124),
(57464,'You there! In the rafters! My sacred library has become possessed by the Sha!','',0,0,0,0,0,0,0,0,0,0,30887,0,26124),
(57465,'See how they pour from every letter of these sacred scrolls... corrupting them! Defiling them!','',0,0,0,0,0,0,0,0,0,0,30888,0,26124),
(57466,'You will taint these scrolls no longer!','',0,0,0,0,0,0,0,0,0,0,30895,0,26124),
(57467,'You must destroy the source of the corruption! Quickly, before our cherished history is erased forever!','',0,0,0,0,0,0,0,0,0,0,30890,0,26124),
(57468,'The mogu are usually thugs and brigands. They never struck me as having the patience for arcane magics.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57469,'The ruins of Korja were where something important happened sometime, I guess. I may have snoozed through that history lesson.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57470,'Did you hear? Dezco named one of the twins \"$p\".','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57471,'The first rule of roll club: you don\'t talk about roll club.$B$BThe second rule of roll club: if it\'s your first time, you roll.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57475,'Let\'s roll.','Let\'s roll.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57476,'Thank you, stranger.','Thank you, stranger.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57477,'My watch continues.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57478,'We serve until death, and sometimes after that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57479,'I will return my fists to the battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57480,'Just a flesh wound.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57481,'I fought on the frontlines of the Qiraji war and charged the depths of Azjol-Nerub. I know first hand the threat that an insect legion can have on the world when left unchecked.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57482,'We were heading west when we received word of the mantid attack and redirected here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57483,'I miss Leza.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57484,'These pandaren are skilled warriors despite being civilians.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57485,'Between mantid, soren, mogu, fever, and countless beasts of this jungle, I refuse to let my children out of my sight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57486,'The mantid?! I always thought they were a spooky legend pandaren tell their children.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57487,'The Shado-Pan are legendary. Their force is unmatched in Pandaria.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57488,'Since meeting you I have fought legends and seen countless wonders.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57489,'Thank you, hero.','Thank you, hero.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57490,'I must get to Stoneplow! The mantid will attack soon.','I must get to Stoneplow! The mantid will attack soon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57491,'The mogu ambushed us while we were trying to retreat from the mantid.','The mogu ambushed us while we were trying to retreat from the mantid.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57492,'My thanks, stranger.','My thanks, stranger.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57493,'Our envoy was making for the Crane Temple when the mogu ambushed us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57494,'Face these \"mantid\" $p and we\'ll continue our assault on the Mogu. With luck, we should join you shortly.','',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(57495,'I\'m confused as to how these raiders are constantly able to assail us no matter how many of them we kill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57496,'These raiders stole the cloths off our dead, the trinkets out of our homes, and the ingots out of our forge. What sort of behavior is that?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57497,'The Crane Temple usually comes to our defense and keeps the raiders at bay. But lately they have been quiet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57498,'Greetings $p. The waters foretold of your arrival. Unfortunately they didn\'t foretell of the raiders hitting us so hard.$b$bI am Waterspeaker Tired Shushen. Welcome to Fallsong.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57499,'<Farmer Yoon wipes his brow wearily.>$B$BThis is hopeless! I\'ll never move these rocks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57500,'Kor, why did you do this? Vengeance is not worth dying over.','',1,0,0,0,0,0,0,0,1,13896,0,0,26124),
(57501,'$p, meet me at Dawnchaser Retreat. I must see to my brother\'s remains, and then we must deal with this mantid threat.','',1,0,0,0,0,0,0,0,1,13896,0,0,26124),
(57502,'Take over for me... uh... what\'s your name? $n? Thank you, $n. I need a break.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57503,'You can find me in my house if you need me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57504,'We live, we fight, we die. The tricky part is finding a reason to do each of those.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57505,'The pandaren are a noble race, and one that I am willing to fight alongside.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57506,'Have you named the twins?','Have you named the twins?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57507,'Indeed! The young one on my chest is named \"Kor\", for my oldest friend.$b$bAnd this young champion on my back is named \"$p\", for his savior.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57508,'Thanks, but I have a girl\'s name.','Thanks, but I have a girl\'s name.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57509,'Well then perhaps his deeds will be so great that history will remember it as a bull\'s name.','',1,11,0,0,0,0,0,0,1,0,0,0,26124),
(57510,'Farming is much harder than it looks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57511,'Hey, Yoon! Come out here!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(57512,'So, you\'ve taken over the ranch for good, eh?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(57513,'Let\'s get one thing straight. You may be Old Yoon\'s cub, but you\'re still a citypaw.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(57514,'You even know how to run a farm? Know what, I\'ll save you the trouble. Sell me this here piece of land and go back where you came from.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(57515,'Do as you please, city boy, but I wager you won\'t last a week. I mean, just look at this dump!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57516,'Pshaw, sell me your land and I\'ll save you the trouble.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57517,'I wager you won\'t last a week.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57518,'Come on boys, let\'s leave him to his \"farming.\"  Ho ho ho!','',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(57519,'Oh, oh my! Mr. Mudclaw! I didn\'t expect such an important visitor.','',0,0,0,0,0,0,21,0,1,0,0,0,26124),
(57520,'You? Join the Tillers? Ha! You\'d have to prove your farming skills to all five members of our Council. They would never vote for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57521,'You are THE Haohan Mudclaw, right? Head of the Tiller\'s Union? They are the master farmers in all of Pandaria!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(57522,'Yessir! My grandfather left me this farm. Just moved in the other day. Nice to meet you, neighbor!','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(57523,'Besides, once I\'ve gotten the hang of this, I want to be a Tiller like the rest of you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57524,'B-but it\'s my family farm. I can\'t just sell it.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(57525,'Never say never, my grandpa always said. I\'m going to give it my best shot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57526,'Hey, do I hear someone outside?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57527,'I give \'im five days.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57528,'Two days, tops!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57529,'I\'ll help you, Farmer Yoon.','I\'ll help you, Farmer Yoon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57530,'No thanks, I\'ll be on my way.','No thanks, I\'ll be on my way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57531,'Yes! Together, we\'ll work until we join the Tiller\'s Union!','',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(57532,'Awww shucks. At this rate, I\'ll never get to join the Tiller\'s Union. Well, let me know if you ever change your mind.','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(57533,'%s lets out a pitiful wail.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57535,'I suppose I\'ll just add this to the stew. We were short on meat anyways.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57537,'The Pools of Youth were an ancient fable my grandsires told me long ago. Now this old man intends to find them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57538,'I used to live only for the pursuit of knowledge.$b$bNow I spend every waking hour searching for a way for our people to rekindle our lost immortality.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57539,'My daughter Lyalia would have me spend the rest of my days cleaning a temple.$b$bBah! I have never felt so alive as when I chose to step through the portal to this strange and beautiful land.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57540,'Greetings, $r! Well timed indeed.$b$bWe had not expected to find anyone from the Alliance in this land.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57541,'Look for the shackles around the edges of the oubliette. There should be three.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57542,'Gone to the market. For official Tiller\'s Union business, please find me at Halfhill Market. Otherwise, Mung-Mung can take care of any needs.\n\n- Haohan Mudclaw','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57543,'','Snuck out while my dad wasn\'t looking. Find me at Halfhill Market!\n\n- Tina Mudclaw',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57544,'','Took the fish to market. See you at Halfhill!\n\n- Fish',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57545,'','If you find this note, then I am either dead or at Halfhill Market.$B$BHopefully I have temporarily left my post to enjoy a hot mug of ale in town. Perhaps you should go check, just in case.$B$BIf indeed I have failed my mission, please send my love and effects to my family in Zhu\'s Watch.\n\n- Sho',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57546,'M A r c K e T.\n\n- Chee Chee','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57547,'<<Event: Lorekeeper Vaeldrin drinks the potion and transfers his life essence to all npcs around him>>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57548,'Went to Halfhill Market. Please show yourselves out.\n\n- Old Hillpaw','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57549,'','Out for the day at Halfhill Market.\n\n- Ella',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57552,'','My father is here for the Pools of Youth. I\'m here at Tyrande Whisperwind\'s command.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57553,'','My sentinels have faced far worse than this jungle has to offer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57554,'','Something about this land seems to be affecting our squad\'s morale.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57555,'','This jungle is nice and humid compared to the arid deserts of Uldum.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57556,'','Tyrande hand picked me for this mission.$b$BShe said it was because of her visions but I am guessing it was because my father was the one who talked her in to approving the mission.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57557,'','For all of its dangers, this land is a hunter\'s paradise.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57558,'','You saved the lives of my sentinels, hero. You have my everlasting gratitude. Now we can continue with our mission.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57559,'Ah, $p! I was searching for the Hidden Master when I came across this big purple thing with a bunch of little purple things inside.$b$bLooks like an old mogu magic trap. Thankfully they don\'t know how to build these anymore.','',2,1,0,0,0,0,0,0,1,0,0,0,26124),
(57560,'These creatures are fascinating. Great fighters. Though so thin...','',1,11,0,0,0,0,0,0,1,0,0,0,26124),
(57562,'','Father, we need to deal with the Horde scout first.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57563,'5...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57564,'4...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57565,'3...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57566,'2...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57567,'1...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57568,'Get away from the sabotaged tank before it blows!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57572,'Nothing like a fresh harvest of vegetables for your soup.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57573,'Hey Chef! I gotta ask you...are we friends?','Hey Chef! I gotta ask you...are we friends?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57575,'','Of course, $n! We\'re really good friends.$B$BDon\'t you remember the time that you saved me from that mountain hozen? And then afterward we got drunk and lost our pants?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57576,'Ah, it\'s about time. Will you free me, or did you have... other ideas?','',0,0,0,0,0,0,1,0,1,0,31474,0,26124),
(57577,'|cFF0008E8Rogue:|r <Pick the shackle locks.>','|cFF0008E8Rogue:|r <Pick the shackle locks.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57578,'<Unlock the shackles.>','<Unlock the shackles.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57579,'I don\'t have the shackles key.','I don\'t have the shackles key.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57580,'<Leave him shackled.>','<Leave him shackled.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57581,'The Captain of the Guard upstairs, Hedric Evencane, should posses a key. Please, make haste. We do not have all night, you know!','',0,0,0,0,0,0,1,0,1,0,31475,0,26124),
(57582,'This water looks pretty good over here.','',0,0,0,0,0,0,0,0,1,0,30987,0,26124),
(57583,'Somethin\'s a little funny about this here water...','',0,0,0,0,0,0,0,0,1,0,30988,0,26124),
(57584,'Boy howdy! Look at this pretty little pool!','',0,0,0,0,0,0,0,0,1,0,30989,0,26124),
(57585,'Let\'s see here...','',0,0,0,0,0,0,0,0,1,0,30990,0,26124),
(57586,'This water seems a little too... what\'s that word? Oh yeah, clean.','',0,0,0,0,0,0,0,0,1,0,30991,0,26124),
(57587,'Now this is what I\'m talkin\' about! Ain\'t no spiders or crabs in this water.','',0,0,0,0,0,0,0,0,1,0,30992,0,26124),
(57588,'This should be the last of it.','',0,0,0,0,0,0,0,0,1,0,30993,0,26124),
(57589,'Ouch!','',0,0,0,0,0,0,0,0,1,0,30994,0,26124),
(57590,'Hot damn!','',0,0,0,0,0,0,0,0,1,0,30997,0,26124),
(57591,'Crap!','',0,0,0,0,0,0,0,0,1,0,31000,0,26124),
(57592,'Looks like he\'s got a little bit o\' that water stuck in his gills. I\'ll just scoop some of this up...','',0,0,0,0,0,0,0,0,1,0,30996,0,26124),
(57593,'I\'ll just scrape some of this water from his little spider mouth-parts. A little bit o\' poison never hurt no one, right?','',0,0,0,0,0,0,0,0,1,0,30999,0,26124),
(57594,'Holy smokes, this fella swallowed a lot of water. I oughta pick some up.','',0,0,0,0,0,0,0,0,1,0,31002,0,26124),
(57595,'I\'ll bet that Chen never made no croc-belly-water beer.','',0,0,0,0,0,0,0,0,1,0,31003,0,26124),
(57596,'The Sunreavers will not be pleased. Mark my words, we\'re not an organization to be taken lightly.','',0,0,0,0,0,0,1,0,1,0,31476,0,26124),
(57597,'My thanks! Shall we make our way off this miserable little island?','',0,0,0,0,0,0,0,0,1,0,31477,0,26124),
(57598,'Let\'s head out into that glade. Look for dark, swirling pools of water... that\'ll be the good stuff.','',0,0,0,0,0,0,0,0,1,0,30986,0,26124),
(57599,'I\'m ready to go, Mudmug.','I\'m ready to go, Mudmug.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57600,'You ready to go water-huntin\'?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57601,'The |cFFFE9A2EKrik\'thik Protectorate|r reinforcements appear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57602,'The |cFFFE9A2EKrik\'thik Engulfer|r reinforcements appear above!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57603,'The |cFFFE9A2EKrik\'thik Swarm Bringer|r reinforcements join the battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57604,'I beseech you, kind strangers. Cleanse this place of their foul presence! Lay our stories to rest!','',0,0,0,0,0,0,0,0,0,0,30889,0,26124),
(57605,'Oh, my. If I am not mistaken, it appears that the tale of Zao Sunseeker has come to life before us.','',0,0,0,0,0,0,0,0,0,0,30901,0,26124),
(57606,'Thank you, heroes. I...','',0,0,0,0,0,0,0,0,0,0,30891,0,26124),
(57607,'According to the legend, long ago, there were five suns that burned brightly in the sky. When the winds blew, their intense heat caused great wildfires.','',0,0,0,0,0,0,0,0,0,0,30902,0,26124),
(57608,'Crops wilted, villages burned, and families wandered endlessly to seek refuge from the flames...','',0,0,0,0,0,0,0,0,0,0,30903,0,26124),
(57609,'I reckon we got enough.','',0,0,0,0,0,0,0,0,1,0,31004,0,26124),
(57610,'The fires, they are burning the library! Please, heroes! Purge this evil before the temple crumbles to ash!','',0,0,0,0,0,0,0,0,0,0,30904,0,26124),
(57611,'Zao was a true champion of our people, how sad it is to see his story tainted by the sha. I am relieved to see justice served to his memory.','',0,0,0,0,0,0,0,0,0,0,30907,0,26124),
(57612,'You have my thanks, heroes. You have given peace to this sacred temple.','',0,0,0,0,0,0,0,0,0,0,30885,0,26124),
(57613,'Now, off with you! I require meditation before I begin the restoration ritual.','',0,0,0,0,0,0,0,0,0,0,30886,0,26124),
(57614,'Ah, it is not yet over. From what I see, we face the trial of the yaungol. Let me shed some light...','',0,0,0,0,0,0,0,0,0,0,30896,0,26124),
(57623,'The blistering heat must have dulled my senses... mirages! All of you!','',0,0,0,0,0,0,0,0,0,0,27748,0,26124),
(57624,'As the tale goes, Zao battled furiously... shooting his arrows high into the sky, until only one sun remained.','',0,0,0,0,0,0,0,0,0,0,30905,0,26124),
(57625,'Somethin\' pinched me! Get it, $p!','',0,0,0,0,0,0,0,0,1,0,30995,0,26124),
(57626,'Water spider! Smush him, $p!','',0,0,0,0,0,0,0,0,1,0,30998,0,26124),
(57627,'Dang ol\' croc nearly took off my hand!','',0,0,0,0,0,0,0,0,1,0,31001,0,26124),
(57628,'%s\'s |cFFFF0000Weak Spot|r is exposed! Attack it to break his Impervious Carapace!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57629,'','It... it\'s a trap...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57630,'<Try to untie Lyalia.>','<Try to untie Lyalia.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57631,'Lyalia! I am so sorry, my child.','',0,0,0,0,0,0,0,0,1,15263,0,0,26124),
(57632,'$p, meet me at the Sentinel Basecamp. I must bring my daughter\'s body there. We still have the Water of Youth.','',0,0,0,0,0,0,0,0,1,15263,0,0,26124),
(57633,'','Now that we\'re acquaintances, $n, let me give you a tip. Folks \'round here can help spruce up your farm, but you gotta become friends with them first. Make friends by helping them out with daily tasks, or by giving them gifts like the one you just gave me.',0,0,0,0,0,0,0,0,1,54164,0,0,26124),
(57634,'Retreat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57635,'LYALIA! NOOOOOOOO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57636,'<Drool dangles down the side of Jogu\'s mouth.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57637,'Um, hello?','Um, hello?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57638,'Hi! I work with Farmer Yoon down the road. How are you?','Hi! I work with Farmer Yoon down the road. How are you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57639,'Hey, how\'s it going? I\'m new around here.','Hey, how\'s it going? I\'m new around here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57640,'Why hello. I\'m from out of town.','Why hello. I\'m from out of town.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57641,'Hello sir. Do you live around here?','Hello sir. Do you live around here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57642,'Hello. Nice to meet you.','Hello. Nice to meet you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57643,'Hello Mr. Mudclaw. I don\'t know if you saw me earlier, but I\'m helping Farmer Yoon out on his farm.','Hello Mr. Mudclaw. I don\'t know if you saw me earlier, but I\'m helping Farmer Yoon out on his farm.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57644,'I couldn\'t help but notice you from over there. I\'m new in town.','I couldn\'t help but notice you from over there. I\'m new in town.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57645,'Are you really called Fish? That\'s an unusual name.','Are you really called Fish? That\'s an unusual name.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57646,'Buuuuuuuuuurrrppp!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57647,'You need a lift?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57648,'I need to meet up with Chen Stormstout.','I need to meet up with Chen Stormstout.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57649,'I need to meet up with Ken-Ken, the hozen.','I need to meet up with Ken-Ken, the hozen.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57650,'I need to meet up with Kang Bramblestaff.','I need to meet up with Kang Bramblestaff.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57651,'Ah yes, I\'ve heard about him. He\'s visiting Pang\'s Stead, over in Thunderfoot Fields.$b$bYou ready to go?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57652,'Ah yes, I\'ve heard about him. He\'s visiting Mudmug\'s Place, right?$b$bI can take you when you\'re ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57653,'Ah yes, I\'ve heard about him. He\'s visiting Halfhill with Mudmug, right?$b$bI can take you there when you\'re ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57654,'Ah yes, I\'ve heard about him. He\'s down at the brewery, right?$b$bI can take you there when you\'re ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57655,'Let\'s go.','Let\'s go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57656,'Ken-Ken... I think I heard a rumor that he was staying in Zhu\'s Watch.$b$bShall I take you there?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57657,'Ken-Ken... I think I heard a rumor that he was staying somewhere near the Temple of the Red Crane.$b$bShall I take you there?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57658,'The \"failed\" siege was merely a feint, of course. You didn\'t realize?','',0,0,0,0,0,0,0,0,1,0,31478,0,26124),
(57659,'Do you like gifts?','Do you like gifts?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57660,'Mrhmhmm...do I likesh giftsh? Well yesh, of coursh! Who doesn\'t like giftsh?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57661,'This Ruby Shard is for you.','This Ruby Shard is for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57662,'This Blue Feather is for you.','This Blue Feather is for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57663,'This Marsh Lily is for you.','This Marsh Lily is for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57664,'This Jade Cat is for you.','This Jade Cat is for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57665,'This Lovely Apple is for you.','This Lovely Apple is for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57666,'I think you\'re mistaken, friend. You don\'t have anything that I want.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57667,'That Bramblestaff boy is down in the wilds, fraternizing with those \"tauren\" at Thunder Cleft. He\'s looking for trouble, if you ask me.$b$bYou want to join him?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57668,'That Bramblestaff boy is down in the wilds, fraternizing with those \"tauren\" at Dawnchaser Retreat. He\'s looking for trouble, if you ask me.$b$bYou want to join him?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57669,'That Bramblestaff boy is down in the wilds, fraternizing with those \"night elves\" at the place they call \"the Incursion\". He\'s looking for trouble, if you ask me.$b$bYou want to join him?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57670,'That Bramblestaff boy is down in the wilds, fraternizing with those night elves at their base camp. He\'s looking for trouble, if you ask me.$b$bYou want to join him?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57671,'Drinking ain\'t so nice on an empty stomach. Give a jinyu something to eat, eh?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57672,'Giftsh? Well here\'s an idea.$B$BYou know what goesh great wid a tasty drink? A tasty shnack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57673,'I\'ve changed my mind.','I\'ve changed my mind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57674,'This Jade Forest Fried Rice is for you.','This Jade Forest Fried Rice is for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57675,'This Swirling Mist Soup is for you.','This Swirling Mist Soup is for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57676,'These Shrimp Dumplings are for you.','These Shrimp Dumplings are for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57677,'This Forest Pheasant Roast is for you.','This Forest Pheasant Roast is for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57678,'This Charbroiled Tiger Steak is for you.','This Charbroiled Tiger Steak is for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57679,'This Hozen Stir Fry is for you.','This Hozen Stir Fry is for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57680,'This Braised Wolf is for you.','This Braised Wolf is for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57681,'This Fire Spirit Salmon is for you.','This Fire Spirit Salmon is for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57682,'This Twin Fish Platter is for you.','This Twin Fish Platter is for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57683,'This Eternal Blossom Fish is for you.','This Eternal Blossom Fish is for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57684,'You ever heard of Sauteed Carrots? It\'sh my favorite food. I wish I had some right now...hic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57685,'I ate a Lovely Apple once. It was delishioush.$B$B<Jogu stares blankly into the distance, as if he\'s lost his train of thought.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57686,'Ohhhh, pretty! I like it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57687,'Oh, a Lovely Apple! Thish must me by lucky day!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57688,'It\'sh a nice kitty, just like in my lasht brew dream...hic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57689,'It\'sh a feather. Sho bootiful. Thank you...hic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57690,'Oh...these flowersh remind me of home.','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(57691,'Oh, Sauteed Carrots! My favorite!','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(57692,'Mmmm, did you make thish yourself? It\'sh just what I wanted, thank you!','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(57693,'Ash nuzzles Sentinel Commander Lyalia.','',432,0,0,0,0,0,0,0,1,0,0,0,26124),
(57694,'','They... came out of nowhere. Ambush.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57695,'You have been an asset to Stoneplow, $n. We may call upon you again in the future. Until then, you should speak with our flight master. He will take you wherever you need to go... free of charge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57696,'','Ash can get me back to the Incursion. Please, $p, bring those poisoned blades.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57697,'','Well, what\'s it gonna be, stranger? I\'ve got a market to run.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57698,'','You\'ve come to the right place, stranger! Halfhill Market\'s got everything you need.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57699,'','Looking for food and brew, stranger? We\'ve got it right here at Halfhill Market.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57700,'','Well don\'t just stand there, stranger! You got any gossip for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57701,'','You here to buy or sell, stranger? Feel free to look around.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57702,'Do you need something? I\'m a little... busy.$B$B<Koro tightens his grip on the wriggling saurok\'s neck.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57703,'What can you tell me about gifts?','What can you tell me about gifts?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57704,'','What\'s there to know? You like somebody, you give them something they like.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57705,'','Who doesn\'t like receiving a gift?$B$BMe - I love flowers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57706,'','You should give beautiful flowers to beautiful ladies. Like me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57707,'','Many beautiful flowers grow around here, but my favorite is the Marsh Lily. Unfortunately, those gorgeous blooms are rare to find.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57708,'','You know what I have a craving for? A good bowl of Swirling Mist Soup. That would sure taste good right now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57709,'','You know what they say - help your neighbors and your neighbors will help you.$B$BSure, you can help \'em out with chores now and then, but gifts make faster friends, don\'tcha think?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57710,'','Where can you find gifts? Have you tried looking around the fields?$B$BYou never know what you can run across around these farms.$B$BMaybe you\'ll even dig something up on your own land!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57711,'','Working all day in the fields works up a big appetite.$B$BYou didn\'t hear it from me, but most o\' the folk here can eat a woman out of a market stall.$B$BMost everyone has a favorite dish. If you\'ve got any cooking skill, they\'ll be hankering to try your dishes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57712,'Welcome. We\'ll hold just a few seconds to see if anyone else is coming along.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(57713,'','<Blanche shouts over the commotion of the storm.>$B$BYou made it! The boiler and the brewkegs are in place... now all we need is Mother Nature to work her magic.$B$BWhat do you say? Are you ready for some fireworks?',11,6,0,0,0,0,0,0,1,0,0,0,26124),
(57714,'Show me what you got, Blanche!','Show me what you got, Blanche!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57715,'We\'re gonna turn this place into a sinkhole, heh.','',5,0,0,0,0,0,0,0,7,0,30625,0,26124),
(57716,'We\'ve rigged the powder barrels in every ship.','We\'ve rigged the powder barrels in every ship.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57717,'','I can tell you where everyone in this town lives. Who are you looking for?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57718,'Where does Ella live?','Where does Ella live?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57719,'Where does Old Hillpaw live?','Where does Old Hillpaw live?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57720,'Where does Sho live?','Where does Sho live?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57721,'Where does Chee Chee live?','Where does Chee Chee live?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57722,'Where does Haohan Mudclaw live?','Where does Haohan Mudclaw live?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57723,'Where does Tina Mudclaw live?','Where does Tina Mudclaw live?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57724,'Where does Gina Mudclaw live?','Where does Gina Mudclaw live?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57725,'Where does Farmer Fung live?','Where does Farmer Fung live?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57726,'Where does Jogu live?','Where does Jogu live?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57727,'I can\'t find someone. Help!','I can\'t find someone. Help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57728,'','Ella lives at the very western end of the farmlands, just north of the Stormstout Brewery.$B$BShe\'s been living alone since her parents died, poor thing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57729,'','Old Hillpaw lives up on the rise to the northwest. His farm is just south of the mountain.$B$BPoor old man\'s shut everyone out since his son died.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57730,'','Chee Chee\'s got his own farm to the northwest, just up the mountain some.$B$BThat poor fella\'s been plagued by one ill turn after another.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57731,'','That strange girl Sho\'s been hanging around up the mountain.$B$BNo one knows where she comes from, but she\'s trained in the assassin\'s arts.$B$BJust showed up one day to help us with our hozen problem. Nice girl, but she don\'t talk much.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57732,'','Oh Fish? That sweet girl lives up at the docks to the north.$B$BI\'ve known that girl since she was a little\'un.$B$BShe\'s always digging in mud or swimmng in the lake or jumping off trees. Her parents sure named her right, cuz she\'s as slippery as a fish.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57734,'','My father lives in his farmhouse in the middle of the farmlands. He\'s just east of the big ol\' crane statue.$B$BHe owns almost all the fertile land in the valley, and he never lets anyone forget it.$B$BThat\'s why I left home, you know. He thinks he owns everything...and everyone.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57735,'','My sister lives with my father in his farmhouse in the middle of the farmlands, just east of the big ol\' crane statue.$B$BI like to see my sister now and then, but she\'s usually too busy making herself look pretty for the next farmboy to pass through these parts.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57736,'','Ahh Jogu...he\'s probably passed out behind the still. Just go a few yards to the south to the watering hole and you can\'t miss him.$B$BHe came wandering through town a while back and hasn\'t ever left.$B$BThe locals love him. He\'s got quite the knack for predicting the harvest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57737,'','You can\'t find someone? Well only three possible places a person can be.$B$BEither they\'re here at the market, or they\'re at their own house for the day, or they\'re at Sunsong Ranch.$B$BIf you don\'t see them at any of those places, you might need your eyes checked!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57738,'Where does Fish Fellreed live?','Where does Fish Fellreed live?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57739,'Where does everyone live?','Where does everyone live?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57740,'','See you at the ruins of the Lost Dynasty, $p.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57741,'','Farmer Fung lives just north of town, right near the water tower.$B$BI know him well, unfortunately.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57742,'','Who are you looking for? Give me your map there and I\'ll mark it for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57743,'','You addled goose, that\'s me! Who do you think you\'re talking to!?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57744,'','The trees here are more beautiful than any I have seen in my travels.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57745,'','Lorekeeper Vaeldrin insists he can find the Pools of Youth.$b$bShould we succeed, imagine what that would do for our people. To be immortal again...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57746,'Zao has become corrupted too! Please, fight him with dignity...','',0,0,0,0,0,0,0,0,0,0,30906,0,26124),
(57747,'','High Priestess Tyrande was hesitant to approve this mission.$b$bShe seemed to believe the source of Vaeldrin\'s research to be a double edged sword.$b$bAfter spending days in that arcanic oubliette, I am beginning to think she might not have been wrong.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57748,'I can allow this no longer!','',0,0,0,0,0,0,0,0,0,0,27747,0,26124),
(57749,'','Kang says the mogu are ruffians and bandits.$b$bFrom what we\'ve seen so far, I think they might be becoming a larger threat than any of the pandaren suspect.',0,0,0,0,0,0,0,0,1,13986,0,0,26124),
(57750,'','Oh! Hello...$B$B<Ella\'s face turns pink and she looks down shyly.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57751,'','Thankfully our allies on the other side of the portal can send supplies through now that the oubliette is disabled.$b$bUnfortunately we still haven\'t disabled the trap preventing us from returning through it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57752,'','Aly... Alynna is in command.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57753,'','My... blood burns.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57754,'','Tyrande warned... she... she said there would be great dark... before light.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57755,'Mama Bramblestaff often told me if I didn\'t stop breaking her vases she would ship me off to the Dungeons of Dojan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57756,'I\'ve never heard of mogu gathering in such large numbers before.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57757,'These mogu may be clunky in their movements but their faces are hard on the knuckles.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57758,'I think I saw some mogu digging up artifacts.$b$bThat can\'t be good.$b$bWe still tell tales of all the evil stuff the mogu did when they knew how to use artifacts and arcane powers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57759,'My marines are already on shore, holding the harbor entrance.$B$BYou have your orders. Do your jobs, and return safely.$B$BThe eyes of Hellscream are upon you!','',66,1,0,0,2,0,0,0,1,0,0,0,26124),
(57760,'I spent so long trying to find a way to extend my life that I forgot to live it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57761,'I thought I would have more time. I always thought...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57762,'And now this... folly... would cost my daughter her life.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57763,'I love you, my little Lyalia.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57764,'The water may not create life, but at least it will let me transfer it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57765,'','Thank you so much for the lovely gift, $n. Cats are my favorite!',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(57766,'','I was getting real sick of eating turnips.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(57767,'','These dumplings look delicious!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(57768,'','I can\'t wait to try these.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57769,'','Did you cook these yourself?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57770,'Honoring','Honoring',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57771,'The battle is ours. Finally, peace...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57772,'It\'s done. The Fist of Garrosh is dropping the bomb.','It\'s done. The Fist of Garrosh is dropping the bomb.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57773,'Sounds like you\'ve really stirred up a hornet\'s nest, $c.$B$BReady to set sail?','',66,11,0,0,2,0,0,0,1,0,0,0,26124),
(57774,'','Sentinels, saddle up and prepare to move out! Xintar, carve us a portal to the next location. We are leaving a small garrison here and pressing northwestward.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57775,'','Tyrande sent us here as a vanguard for the Light.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57776,'','Even the very air is ripe with sadness.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57777,'','Us meeting on these shores is more than just random chance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57778,'Sentinel Commander Lyalia needs your report.','Sentinel Commander Lyalia needs your report.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57779,'It\'s alright, girl. Relax.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57780,'There, there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57781,'Take it easy, girl. You\'ll be up and running again in no time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57782,'Stay calm. I\'m here, you\'re safe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57783,'','Here you go. Keep the report safe, $p. The sunwalkers are moving west as well.$b$bI\'m going to stay here and help these people. We would stand a better chance if you stay and help us out.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57784,'Where did all of these mogu come from?','Where did all of these mogu come from?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57785,'Thank you for rescuing us, $c. Hopefully now our mission will not be lost.','Thank you for rescuing us, $c. Hopefully now our mission will not be lost.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57786,'These \"elf\" creatures. Can they be trusted?','These \"elf\" creatures. Can they be trusted?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57787,'First mantid, then mogu. These are dark days indeed.','First mantid, then mogu. These are dark days indeed.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57788,'I don\'t know what brought you into the Forbidden Jungle, but I am glad it did. You saved us from slavery... or worse.','I don\'t know what brought you into the Forbidden Jungle, but I am glad it did. You saved us from slavery... or worse.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57789,'When did the mogu learn to wield magic portals?','When did the mogu learn to wield magic portals?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57790,'The mogu chose the worst time to attack. The mantid are on the move, and not even the great wall will hold them back.','The mogu chose the worst time to attack. The mantid are on the move, and not even the great wall will hold them back.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57791,'Our dreams have been haunted by mantid. We hoped the Crane Temple would give us some insight to these visions.','Our dreams have been haunted by mantid. We hoped the Crane Temple would give us some insight to these visions.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57792,'Why were you travelling to the Crane Temple?','Why were you travelling to the Crane Temple?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57793,'We seek the wisdom of the Crane to explain the visions we have been having.$b$bMantid! Mantid assaulting our homes, flying over the wall and attacking in force.$b$bSuch dreams are expected, living so close to the wall.$b$BBut lately, they have been most insistent.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57794,'Mantid?','Mantid?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57795,'You are indeed a stranger to Pandaria.$b$BThe mantid are the monsters beyond the wall. The scourge of the west. The evil that haunts our lands.$b$BEvery one hundred years the mantid launch an assault on our lands to ravage them of their wealth and food.$b$bOur greatest scholars tell us we are still many years from the next ravage, but our dreams say otherwise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57796,'$p, we could use a champion like you in Stoneplow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57797,'','An arcanic oubliette. Thankfully the walls of this ruin have collapsed away otherwise we would have been trapped in this one spot without food or water.$b$bSeems whoever built these ruins designed them to be a prison for anyone attempting to portal to the coordinates we were travelling to.$b$bIt also is lethal to any mages that pass through it. Look what it did to our poor arcanist.$b$bThe good news is we can still communicate with the other side and were able to warn them not to send anyone else through. The bad news is we are stuck on the wrong side of what is now a one way portal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57798,'What is wrong with the portal?','What is wrong with the portal?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57799,'I was barely inside their outer patrols when they caught me. I didn\'t find anything.','I was barely inside their outer patrols when they caught me. I didn\'t find anything.',0,0,0,0,0,0,0,0,1,15245,0,0,26124),
(57800,'I saw their leader. He was heading further up the wall. I\'ll mark it on your map.','I saw their leader. He was heading further up the wall. I\'ll mark it on your map.',0,0,0,0,0,0,0,0,1,15246,0,0,26124),
(57801,'Thank you, friend. I didn\'t uncover anything before they caught me.','Thank you, friend. I didn\'t uncover anything before they caught me.',0,0,0,0,0,0,0,0,1,15245,0,0,26124),
(57802,'I... I failed. Thank you for coming for me.','I... I failed. Thank you for coming for me.',0,0,0,0,0,0,0,0,1,15245,0,0,26124),
(57803,'What are you doing here?','What are you doing here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57804,'We are on a quest to find the Pools of Youth!$b$bThe fabled waters were a boon of a mysterious lost civilization that predated Queen Azshara.$b$bWith these waters, we will be able to restore the glory of immortality to the kal\'dorei.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57805,'The Alliance will not be allowed to scar this land!','The Alliance will not be allowed to scar this land!',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(57806,'Light grant me strength!','Light grant me strength!',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(57807,'Mogu sympathizers!','Mogu sympathizers!',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(57808,'You will not learn the secrets of the mogu!','You will not learn the secrets of the mogu!',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(57809,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,3,1,0,0,0,26124),
(57810,'I think I will just sit this one out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57811,'','You did it! Let\'s get this brew to the Monastery...',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(57812,'I... I don\'t know what came over me.','I... I don\'t know what came over me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57813,'Of course. We must not lose hope.','Of course. We must not lose hope.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57814,'So they CAN die... I have to stay focused.','So they CAN die... I have to stay focused.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57815,'Thank you, I had lost sight of the Way.','Thank you, I had lost sight of the Way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57816,'No, I cannot let it end like this. I have to keep fighting!','No, I cannot let it end like this. I have to keep fighting!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57817,'How can I give up when heroes still fight at my side?','How can I give up when heroes still fight at my side?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57818,'It seems we haven\'t lost yet.','It seems we haven\'t lost yet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57819,'It was... so dark...','It was... so dark...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57820,'','I miss my father.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57821,'','My father\'s sacrifice will not have been in vain. We need to press the attack against the mantid.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57822,'','My father thought we would not encounter resistance. But then, he often spends his time obsessing over immortality instead of thinking things through.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57823,'','Groundbreaker Brojai has made it clear the mogu have no intention of negotiating with us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57824,'The battle begins in 2 minutes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57825,'The battle begins in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57826,'The battle begins in 30 seconds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57827,'The battle has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57828,'','What, so we gather a couple of bugs, and a few bird feathers? No problem!',0,0,0,0,0,0,1,0,1,0,0,30446,26124),
(57829,'','This is fun, $p. Way more fun than hanging out with a boring uncle.',0,0,0,0,0,0,1,0,1,0,0,30447,26124),
(57830,'','Holy smokes, it had a mom. Look out, $p!',0,0,0,0,0,0,15,0,1,0,0,30448,26124),
(57831,'','Sounds good to me! And maybe next time, you could warn us about the GIANT MURDEROUS CROCODILE.',0,0,0,0,0,0,1,0,1,0,0,30449,26124),
(57832,'','Neat! A jinyu!',0,0,0,0,0,0,25,0,1,0,0,30450,26124),
(57833,'','I\'m glad to see that there\'s still some left, after what happened in the Jade Forest.',0,0,0,0,0,0,1,0,1,0,0,30451,26124),
(57834,'','Say, you think they\'re related to murlocs?',0,0,0,0,0,0,6,0,1,0,0,30452,26124),
(57835,'','Back off, flower-head. That\'s MY $c you\'re talking about!',0,0,0,0,0,0,15,0,1,0,0,30453,26124),
(57836,'','What\'s happening?',0,0,0,0,0,0,6,0,1,0,0,30486,26124),
(57837,'','Wait a minute, now we need to go pick a flower for these guys?',0,0,0,0,0,0,6,0,1,0,0,30508,26124),
(57838,'','Seems kind of girly to me.',0,0,0,0,0,0,1,0,1,0,0,30509,26124),
(57839,'','Besides... isn\'t it THEIR job to pick the flowers?',0,0,0,0,0,0,1,0,1,0,0,30510,26124),
(57840,'','$p... you picked that flower like a champion! You\'re like a... a professional flower-picker! Have you done this before?',0,0,0,0,0,0,5,0,1,416,0,30511,26124),
(57841,'','Yuck.',0,0,0,0,0,0,53,0,1,0,0,30513,26124),
(57842,'','Look how big and ugly he is!',0,0,0,0,0,0,25,0,1,0,0,30514,26124),
(57843,'','It\'s a good thing my Uncle Chen told me not to get into any fights, otherwise you\'d be dead meat, turtle!',0,0,0,0,0,0,15,0,1,0,0,30516,26124),
(57844,'','Are you listening to me, turtle?',0,0,0,0,0,0,25,0,1,0,0,30517,26124),
(57845,'','Hey $p? I don\'t think I want to try Bottletoads.',0,0,0,0,0,0,1,0,1,0,0,30518,26124),
(57846,'','This is kind of cool. A day in the life of a... a silk-getting guy.',0,0,0,0,0,0,1,0,1,0,0,30519,26124),
(57847,'','What are they called, anyways? Silkers? Silksters? Worm-butt squeezers?',0,0,0,0,0,0,6,0,1,0,0,30520,26124),
(57848,'','I think I\'ll just stick with \"silk-getting guy\".',0,0,0,0,0,0,1,0,1,0,0,30521,26124),
(57849,'','Did he say \"horrible monster\"?',0,0,0,0,0,0,6,0,1,0,0,30522,26124),
(57850,'','See... THIS is the type of adventure I can get behind.',0,0,0,0,0,0,25,0,1,0,0,30524,26124),
(57851,'','Come on, let\'s go kill some of those little guys first.',0,0,0,0,0,0,0,0,1,0,0,30525,26124),
(57852,'','Alright, done with the little guys! Let\'s move on to this \"horrible silk monster\"!',0,0,0,0,0,0,1,0,1,0,0,30526,26124),
(57853,'','Hurry up, $p!',0,0,0,0,0,0,53,0,1,0,0,30528,26124),
(57854,'','That was kind of cool.',0,0,0,0,0,0,1,0,1,0,0,30529,26124),
(57855,'','THAT... WAS... AWESOME!',0,0,0,0,0,0,15,0,1,0,0,30530,26124),
(57856,'','Are you seeing this, $p?',0,0,0,0,0,0,15,0,1,0,0,30457,26124),
(57857,'','This place is like... ALL puddles.',0,0,0,0,0,0,1,0,1,0,0,30458,26124),
(57858,'','I love puddles! No wonder all these birds like to hang out here.',0,0,0,0,0,0,0,0,1,0,0,30459,26124),
(57859,'','Huh! This must be where all those farmers sell their fruits, and vegetables, and grains, and beer.',0,0,0,0,0,0,1,0,1,0,0,30460,26124),
(57860,'','I wonder if Uncle came through here on his way to the brewery.',0,0,0,0,0,0,6,0,1,0,0,30461,26124),
(57861,'','Can we buy something? I\'m hungry.',0,0,0,0,0,0,6,0,1,0,0,30462,26124),
(57862,'','%s burps.',0,0,0,0,0,0,0,0,1,0,0,30463,26124),
(57863,'','OK! Not hungry anymore. Let\'s keep exploring.',0,0,0,0,0,0,1,0,1,0,0,30464,26124),
(57864,'','Look at this! A little farm, right in the middle of a town.',0,0,0,0,0,0,1,0,1,0,0,30465,26124),
(57865,'','Who would think to start a farm in the middle of a town? Hah!',0,0,0,0,0,0,6,0,1,0,0,30466,26124),
(57866,'','I\'ll bet they grow enough food here to feed pretty much everybody on Pandaria.',0,0,0,0,0,0,1,0,1,0,0,30467,26124),
(57867,'','It\'s just too bad that it\'s all vegetables. Why no giant meat?',0,0,0,0,0,0,6,0,1,0,0,30468,26124),
(57868,'','Oh, cool! This must be where they store the grain for all the beer they make at that brewery.',0,0,0,0,0,0,1,0,1,0,0,30469,26124),
(57869,'','I can\'t wait until I\'m older, so I can finally find out what beer tastes like.',0,0,0,0,0,0,1,0,1,0,0,30470,26124),
(57870,'','%s smiles and glances about nervously.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57871,'','Here it is: the Stormstout Brewery.',0,0,0,0,0,0,1,0,1,0,0,30471,26124),
(57872,'','I\'ll bet Uncle Chen is inside, meeting our distant relatives, as we speak.',0,0,0,0,0,0,1,0,1,0,0,30472,26124),
(57873,'','That\'s exactly what I need... even MORE boring old uncles.',0,0,0,0,0,0,15,0,1,0,0,30473,26124),
(57874,'','Check this place out!',0,0,0,0,0,0,1,0,1,0,0,30474,26124),
(57875,'','You know what, $p?',0,0,0,0,0,0,1,0,1,0,0,30475,26124),
(57876,'','You\'re way cooler than Uncle Chen.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57877,'','Uncle Chen and I spent weeks wandering around that Jade Forest, and all we saw were trees... and ONE cool serpent thing.',0,0,0,0,0,0,1,0,1,0,0,30476,26124),
(57878,'','I\'ve only spent a day with you, and we\'ve already seen this entire valley.',0,0,0,0,0,0,1,0,1,0,0,30477,26124),
(57879,'','Hey, where did this weird jungle come from?',0,0,0,0,0,0,6,0,1,0,0,30480,26124),
(57880,'','It\'s just like, all of a sudden, out of nowhere... BOOM. Super-thick jungle.',0,0,0,0,0,0,1,0,1,0,0,30482,26124),
(57881,'','And it\'s kind of scary, too.',0,0,0,0,0,0,1,0,1,0,0,30484,26124),
(57882,'','Well? Are we going in, or what?',0,0,0,0,0,0,6,0,1,0,0,30485,26124),
(57883,'','Someone LIVES back here?',0,0,0,0,0,0,6,0,1,0,0,30487,26124),
(57884,'','This is all pretty cool, and scary, and all that stuff, but shouldn\'t we be getting back to Mudmug\'s place now?',0,0,0,0,0,0,1,0,1,0,0,30489,26124),
(57885,'','So... umm... $p? I\'m still here, you know.',0,0,0,0,0,0,1,0,1,0,0,30490,26124),
(57886,'','Following you all over the place. Have been for a while now.',0,0,0,0,0,0,1,0,1,0,0,30492,26124),
(57887,'','Yikes, $p, don\'t manhandle the thing. Have you never picked an herb before?',0,0,0,0,0,0,5,0,1,10818,0,30512,26124),
(57888,'','Don\'t forget to talk to that jinyu, down there by the river.',0,0,0,0,0,0,1,0,1,15252,0,30455,26124),
(57889,'','I guess what I\'m saying is... thanks.',0,0,0,0,0,0,20,0,1,0,0,30479,26124),
(57890,'','My father would tell you we are here for the Pools of Youth.$b$bThe real story is that our lady Tyrande Whisperwind has had visions of a great light we would... will... find on this journey. A light that will need to be found and defended.$b$bMy father insists it is the Pools of Youth.$b$bI think he is blinded by a decade of obsession.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57891,'What are you doing here?','What are you doing here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57892,'You\'re the last one. Hop on that sea plane and we\'ll get going. The King has placed a lot of trust in you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57893,'And now for the moment of truth.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57894,'Aaaaaaaaahhh!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57895,'That... hurt...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57896,'','Father! Are you okay?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57897,'I almost hit my goal of ten mage portals without incident. Those thrice damned mogu ruined that with their trap.$b$bThe trap sundered most of my abilities but I should be able to manage some more local portals.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57898,'PLACEHOLDER CINEMATIC','PLACEHOLDER CINEMATIC',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57899,'[NOTE: Many placeholder visuals in this cinematic. Expecting Observatory WMO & charge up visuals.]','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(57900,'Um, this may take a while.','',2,1,0,0,0,0,0,0,1,0,0,0,26124),
(57901,'$p, a word before you venture forth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57902,'These mogu fight very differently than the ones I\'ve faced in the past. They have confidence.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57903,'If Mama Bramblestaff could see me now...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(57904,'I should have known about the Pools of Youth. I had visions before the trip but I was blinded by the dream of perpetual youth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57905,'Twenty years of research, hoping and dreaming, all crashing to a halt. All that remains now is the mission, and my daughter Lyalia.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57906,'These mantid, they remind me too much of the day the gates of Ahn\'Qiraj opened and swallowed my wife.$b$bThese creatures are the real threat in this land.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57907,'The orb has been dropped!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57911,'$n has taken the orb!','',0,0,0,0,0,0,0,0,1,0,9431,0,26124),
(57913,'I\'m ready, Koro.','I\'m ready, Koro.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57914,'Alright, lizard lips, one more chance: where are your patrols?!','',0,0,0,0,0,0,0,0,1,0,29591,0,26124),
(57915,'Wrong answer.','',0,0,0,0,0,0,0,0,1,0,29592,0,26124),
(57916,'It looks like we are going in blind. I\'m glad you are with us, $p.','',0,0,0,0,0,0,1,0,1,0,29593,0,26124),
(57917,'Stay close and keep your eyes peeled.','',0,0,0,0,0,0,0,0,1,0,29594,0,26124),
(57918,'','F... father? No! Not for me! Not for this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57919,'I refuse to outlive my daughter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57920,'','Press on to Stoneplow and help them against the Mantid threat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57923,'$n, over here. He\'s hurt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57924,'','So, I really appreciate you taking with me into this scary jungle and all...',0,0,0,0,0,0,1,0,1,0,0,30494,26124),
(57925,'','...letting me watch you while you dispatch of an ancient evil, and all that other stuff we did, too...',0,0,0,0,0,0,1,0,1,0,0,30495,26124),
(57926,'','...but don\'t you think that maybe we\'ve done enough exploring for today?',0,0,0,0,0,0,6,0,1,0,0,30496,26124),
(57927,'','No? Okay, you\'re the boss! Let\'s keep going, $n!',0,0,0,0,0,0,1,0,1,0,0,30497,26124),
(57928,'','That was really cool, how you helped those people out.',0,0,0,0,0,0,1,0,1,0,0,30498,26124),
(57929,'','I hope they find what they\'re looking for, here in Pandaria.',0,0,0,0,0,0,1,0,1,0,0,30499,26124),
(57930,'','That guy sure had a lot of guns.',0,0,0,0,0,0,1,0,1,0,0,30500,26124),
(57931,'','Like... a LOT of guns.',0,0,0,0,0,0,15,0,1,0,0,30501,26124),
(57932,'You have already created an acceptable sketch of this piece.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57933,'Our mission priority has changed.$B$BWe need to defend this camp. Now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57934,'You wikkets belong in the pits!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57935,'Ookin\' dooker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57936,'Chief Gukgut say you gotta go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57937,'You dookers don\'t know when to quit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57938,'Ook off, you big dookers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57939,'Dookers die quick!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57940,'Never seen a dooker like you before!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57941,'Icky slicky! Go away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57942,'Pick their corpses clean!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57943,'Hold up... I don\'t like the looks of this...','',0,0,0,0,0,0,0,0,1,0,29595,0,26124),
(57944,'Have you seen my twin sister, Nimm? She\'s probably lost, as usual.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57945,'What if I don\'t want to kill Alliance?','What if I don\'t want to kill Alliance?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57946,'I didn\'t ask what you want. I asked you to fulfill your oaths sworn to the horde.$b$bWe are at war, $p, in case you forgot.$b$bIn such times, personal interests must take second place to duty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57947,'My wife, Leza, is in labor and fighting a fever.$b$bThis cursed jungle is sapping all of our strength. It could be something in the water.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57948,'Why would you bring a pregnant woman with you?','Why would you bring a pregnant woman with you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57949,'Dezco, we must strike at the mogu now while they think us weak. Let us unleash this $c on them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57950,'Your friend put up quite the fight. He nearly escaped, but now he is a prisoner, just like the rest of us.','',0,0,0,0,0,0,0,0,1,0,30637,0,26124),
(57951,'My people are wary of strangers. However, it seems I have no choice but to trust you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57952,'Do not mistake me for your friend. Over time, my people have learned that trust is too easily broken.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57953,'Only fools trust strangers, but I would rather trust a stranger than a hozen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57954,'This land once belonged to the great jinyu empire. As our kingdom has fallen into disrepair, we have lost more and more land to the relentless hozen tribes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57955,'My people fight to defend our last village. If we lose now, it will be the end of a lineage of once great emperors and philosophers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57956,'I will escape from here, and when I return, it will be with an army of jinyu warriors.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57957,'The visions we had failed to mention this event.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57958,'Taylor fought against the hozen like a wild beast. He is a great credit to your people!$B$BBut in the end, he was overcome.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57959,'<The Admiral\'s body is covered with wounds, scratches, bruises, blood, and sweat. He looks feverish.>','',0,0,0,0,0,0,333,0,1,0,0,0,26124),
(57960,'Do you have a report for Kor and Dezco?','Do you have a report for Kor and Dezco?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57961,'Watch your step, it\'s a mine field out here!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(57962,'Yes, stranger?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57963,'I have no business with you, stranger. What do you want?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57964,'','Here is what I have. As you can see, things are not what we were expecting.$b$bThese people need help, and I intend to stay and help them.$b$bWe would stand a much better chance with your help if you are willing to stay as well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57965,'','This jungle is making me depressed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57966,'','Not now. Leza needs all of my attention. She is three weeks early and something is very wrong.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57969,'You wikkets belong in the pits!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57970,'Uh-oh... Chief ain\'t gonna be happy...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57971,'You don\'t steal big slickies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57972,'Gukgut say you gotta die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57973,'What are you doing here?! Don\'t you know the Yaungol are invading Kun-Lai Summit?','What are you doing here?! Don\'t you know the Yaungol are invading Kun-Lai Summit?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57974,'Dookers is doin\' ookin\' things!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57975,'Ook\'em in the jerb!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57976,'Ookin\' dooker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57977,'Icky slickies is escaping!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57978,'Ook!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57979,'Takk!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57980,'Dookin\'...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57981,'Bad slickies...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57982,'I lose slapslap...?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57983,'Frack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(57986,'As the tale goes, the yaungol was traveling across the Kun\'lai plains when suddenly he was ambushed by two strange creatures!','',0,0,0,0,0,0,0,0,0,0,30897,0,26124),
(57987,'FOR THE ANCIENTS!','',0,0,0,0,0,0,0,0,0,0,33369,0,26124),
(57988,'The yaungol attacked the beasts with great determination and ferocity. Yet, the more he attacked, the more fearsome the beasts grew!','',0,0,0,0,0,0,0,0,0,0,30898,0,26124),
(57989,'However, when he let it alone, the beast shrank to near nothingness.','',0,0,0,0,0,0,0,0,0,0,30899,0,26124),
(57990,'For you see, strife feeds on conflict. When you have peace in your heart, strife will find somewhere else to roam.','',0,0,0,0,0,0,0,0,0,0,30900,0,26124),
(58002,'Look out!','',0,0,0,0,0,0,0,0,1,0,32936,0,26124),
(58003,'Argh, I\'m pinned! Watch yourselves!','',0,0,0,0,0,0,0,0,1,0,29596,0,26124),
(58004,'Look at these ruins, $p! What sort of empire built them I wonder.','',1,0,0,0,0,0,0,0,1,16789,0,0,26124),
(58005,'What strange and fascinating creatures. Tall, burly, with almost metallic skin. I must research these creatures.','',1,0,0,0,0,0,0,0,1,16789,0,0,26124),
(58006,'The waters. They only transfer life. My translations are starting to make sense now.$b$bI surmise the mogu used to extend their lives with the water by sacrificing prisoners, rebels, and slaves.$b$bIt is also my guess that all of the ancient scrolls I was researching were written by mogu originally, and they neglected to mention that fact.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58007,'N-n-nice doggies...','',0,0,0,0,0,0,0,0,1,0,29510,0,26124),
(58008,'This is bad.','',0,0,0,0,0,0,0,0,1,0,29511,0,26124),
(58009,'Not the face!','',0,0,0,0,0,0,0,0,1,0,29512,0,26124),
(58010,'Who throws a bucket? Honestly!','',0,0,0,0,0,0,0,0,1,0,29513,0,26124),
(58011,'Argghhhh!','',0,0,0,0,0,0,0,0,1,0,29514,0,26124),
(58012,'Maybe $ghe:she; is a hero from beyond the mists, here to save us?','Maybe $ghe:she; is a hero from beyond the mists, here to save us?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58013,'Wait, I sense the presence of intruders. Is it hozen? Show yourselves!','',0,0,0,0,0,0,0,0,1,0,30628,0,26124),
(58014,'I have done nothing. This is the work of the Slingtail chief, Gukgut.','',0,0,0,0,0,0,0,0,1,0,30629,0,26124),
(58015,'We are not in the habit of welcoming outsiders into our village.','',0,0,0,0,0,0,0,0,1,0,30630,0,26124),
(58016,'You may stay only until Taylor is well. But then, you must leave.','',0,0,0,0,0,0,1,0,1,0,30631,0,26124),
(58017,'We have no other choice. Put down your weapon, warrior, and we will put down ours.','',0,0,0,0,0,0,0,0,1,0,27707,0,26124),
(58018,'$n? What is going on here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58019,'','You think we can believe him, Commander?',0,0,0,0,0,0,0,0,1,0,0,27660,26124),
(58020,'What have you done to our Admiral?','',0,0,0,0,0,0,0,0,1,0,27847,0,26124),
(58021,'Eye of the Legion','Eye of the Legion',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58022,'Demon Hunter\'s Aspect','Demon Hunter\'s Aspect',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58023,'Feldrake Mount','Feldrake Mount',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58024,'Timewalkers: War of the Ancients','Timewalkers: War of the Ancients',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58025,'We are going to pass through a fierce battle. You must engage the hozen while I run through. If all goes well, I will meet you at my village.','',0,0,0,0,0,0,0,0,1,0,30640,0,26124),
(58026,'Yeah, I tried to hop through that thing too.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58027,'Once the trap is sprung no one gets in or out until the people trapped are completely drained of life. Mogu are evil.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58028,'Careful. Get stuck in that and it will drain your life to power itself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58029,'Old mogu traps are as dangerous now as they were back in the scary story times.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58030,'I\'ve punched it, kicked it, smacked it, thwacked it. Nothing seems to break this oubliette.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58031,'Bold Karasshi has returned!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58032,'Look, a stranger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58033,'It\'s no use! The hozen are pushing us back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58034,'Be strong, warriors! Keep the hozen at bay!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58035,'Who is the stranger who walks among us?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58036,'Is that the stranger?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58037,'Courage, brothers! Press on!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58038,'For the Pearlfin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58039,'Help me up, $p. I... I took an arrow in the knee...','',0,0,0,0,0,0,0,0,1,0,29597,0,26124),
(58040,'Thank you. I\'ll be okay, but we\'d better keep moving.','',0,0,0,0,0,0,1,0,1,0,29598,0,26124),
(58041,'More saurok incoming!','',0,0,0,0,0,0,25,0,1,0,29599,0,26124),
(58042,'Gah! My knee! I\'m sorry, $p, I cannot fight like this.','',0,0,0,0,0,0,0,0,1,0,29600,0,26124),
(58043,'The camp is just ahead, we should be able to make it from here.','',0,0,0,0,0,0,0,0,1,0,29601,0,26124),
(58044,'','Ah, here is the boy. Doesn\'t he look special? My late husband and I always wanted children.',0,0,0,0,0,0,1,0,1,0,0,31393,26124),
(58045,'It was An! She dared Shin to go knock on the Jade Witch\'s door.','It was An! She dared Shin to go knock on the Jade Witch\'s door.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58046,'I want my mommy.','I want my mommy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58047,'Oh thank you! Thank you! Thank you!','Oh thank you! Thank you! Thank you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58048,'Please allow us a chance to prove our friendship. We wish you no harm.','Please allow us a chance to prove our friendship. We wish you no harm.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58049,'What are you doing?','What are you doing?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58050,'My friends and I come with peaceful intentions.','My friends and I come with peaceful intentions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58051,'I come from the Alliance. We wish to be allies, not enemies.','I come from the Alliance. We wish to be allies, not enemies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58052,'To find clarity and purpose, immerse yourself in inner reflection.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58053,'Make your mind as calm as still water. Breathe deeply. And be at peace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58054,'I like to consider myself a historian of my people. I believe that in order to understand the present, we should examine the events of the past.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58055,'No harm? Pah! Many thousand years ago, the Pearlfin Tribe stood on the throne of all Pandaria. Now, this village is all that is left of our people, all because we trusted a tribe of outsiders... the hozen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58056,'Oh! $c! Over here. I could use some assistance if you have a moment.','',2,1,0,0,0,0,0,0,1,0,0,0,26124),
(58057,'Ah, you must be the outsider. Sadly, I am making weapons for war. Once, not long ago, I made instruments for prayer and celebration. It is this war that makes everyone stand on edge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58058,'The stronger our defenders, the greater our chance of survival. But that should be obvious, even to someone like you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58059,'We must train harder.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58060,'I am teaching our warriors everything I know. Unfortunately, it doesn\'t seem to be enough.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58061,'The hozen rely on dirty guerilla tactics. Ambushes and traps. It is sad to say, but they seem to outwit us at every turn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58062,'We are masters of the water, which is why we have been able to defend this village for so long. But on land, especially with thick tree cover, the hozen are vastly superior.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58063,'Action speaks louder than intent, stranger. My warriors intend to seek retribution, but only practice will make it so. Now go away. We are busy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58064,'Have you seen our lake, so calm and still? That is how we like it. Constant. Unmoving. We do not bear change.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58065,'The great river flows through us all. Some prefer to surrender themselves to the water\'s path. Others swim toward certain shores.$B$BWhich are you, stranger? Where will your river take you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58066,'Stranger, have you ever seen a stone fall into a calm lake? Every action creates a ripple, even accepting a pledge of friendship. I shall think upon your request.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58067,'Don\'t forget your helmet, $n. Rookies...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58068,'Commander, I lost my diving helmet.','Commander, I lost my diving helmet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58069,'Kthh! You will die in the mud like your friend over there...','',0,0,0,0,0,0,0,0,1,0,32474,0,26124),
(58070,'I will crush you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58071,'','Even in their own time of need, the pandaren have graciously offered to share food and a place by the fire.$B$BThe rest of us could learn a lot from them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58072,'','Even in their own time of need, the pandaren have graciously offered to share food and a place by the fire.$B$BThe rest of us could learn a lot from them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58073,'Ah! $p! My daughter! I... a vision, she... she\'s in trouble!','',1,0,0,0,0,0,0,0,1,15328,0,0,26124),
(58074,'Way back in the old times the mogu would put little traps like this around the world to stop people from portalling this way and that. It\'s powered by the people who get stuck in it and won\'t turn off until they are dead.$b$bIt\'s like mama Bramblestaff always used to say: \"Don\'t put your hand in a stranger\'s portal.\"','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58075,'What is this thing?','What is this thing?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58076,'','Hey! Is anybody out there? Hellooooooo!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58077,'I never imagined we\'d run into this much trouble out here.$B$BMaybe we shouldn\'t have left the temple...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58078,'','Someone help me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58079,'','Hey monkey, don\'t look at me like that. I\'m not for eating, got that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58080,'','Stop looking at me with your beady little eyes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58081,'','Don\'t come any closer, monkey! I\'m a trained SI:7 agent.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58082,'','Oh...where is everyone? Gnome in a cage here! Help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58086,'I am in your debt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58087,'That is powerful healing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58088,'Join us, $c. We could use you in the fight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58089,'Thank you. You have saved my life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58090,'I must rejoin the battle to save Binan Village.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58091,'We must drive the yaungol back to the Townlong Steppes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58092,'You have great honor, stranger. Please join us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58093,'Shaohao must have sent you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58095,'What now, Sunwalker?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58096,'Agreed.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58097,'I think we have both lost enough today, old elf. See to your dead.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58098,'','Have you seen an SI:7 agent by the name of Amber?$B$BThe last I heard, her bomber took heavy damage and disappeared into the trees to the northeast.',0,0,0,0,0,0,0,0,1,19221,0,0,26124),
(58099,'School is in session!','',0,0,0,0,0,0,0,0,0,0,27477,0,26124),
(58100,'Dunce.','',0,0,0,0,0,0,0,0,0,0,27497,0,26124),
(58101,'Yes, I feel much better.$B$BMishka and Bold Karasshi have brought me up to speed. Your arrival, your search for the White Pawn, my rescue from the hozen.$B$BThe situation is not ideal, and we have much work to do. Finding Anduin is our top priority.','',0,0,0,0,0,0,333,0,1,0,0,0,26124),
(58102,'Class... dismissed.','',0,0,0,0,0,0,0,0,0,0,27478,0,26124),
(58103,'|TInterface\\Icons\\inv_misc_book_01.blp:20|t%s assigns $n a |cFFFF0000|Hspell:113395|h[Harsh Lesson]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58104,'You brought back the instruments just in time, $n. The Elder is ready to perform the waterspeaking ceremony.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58105,'The courier must have died of his wounds after what looks to have been a brutal struggle.$B$BHis supply satchel appears to be unharmed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58106,'This courier must have died of his wounds after what looks to have been a brutal struggle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58107,'Take the supplies.','Take the supplies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58108,'Greetings stranger. Would you like to visit the mystical Pandaria?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58109,'Send me to Pandaria!','Send me to Pandaria!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58119,'That Wanderbrew? Why would a Goldendraft ever know where a Wanderbrew is? Their family has always been a scar on our beautiful town\'s reputation.$b$bTo make things worse, that filthy creaton is probably making eyes at my daughter. That I will not have!$b$bIf you see either him or my daughter you tell them as much for me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58120,'Lo? Sure. I\'ve been sent to hunt him down lots of times. Well, him and Syra Goldendraft.$b$bBest places to look for them are either the inn or the Arboretum.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58123,'Are you ready to go? I think we\'re just about done here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58124,'The pandriarchs blessed my future son-in-law thanks to you. I guess this means the Wanderbrew and Goldendraft feud will have to go on hold.$b$bDon\'t tell anyone this, but I\'m sort of grateful to you for that. So many years of hate is just exhausting.$b$bWe were too set in our ways though, and it took something, or someone, new to help us see passed our differences.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58125,'','Thank you, $p! I am so happy that you helped us. My Lo is with me now, and even my father seems to have relaxed.$b$bHe won\'t admit it to me, but I think my father likes Lo.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58126,'Brewmaster Wanderbrew, at your service.$b$bI travel the Jade Forest in search of only the finest of ingredients for my brews.$b$bUnlike the high and mighty Goldendrafts of Dawn\'s Blossom.$b$bThey have their big brewhouse for mass producing. Which is fine, you know, if you enjoy drinking swill.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(58127,'A Wanderbrew marrying a Goldendraft? I would be offended but there is a certain amusement to how offended old Peiji is going to be when he hears this.$b$bAt the least you seem to have made my boy happy. Thank you, $p.','',11,1,0,0,0,0,0,0,1,0,0,0,26124),
(58128,'I need to find Syra!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58129,'Thank you. Let us begin.','',0,0,0,0,0,0,0,0,1,0,29516,0,26124),
(58130,'Lo! We are leaving. Where did you get off to?','',11,1,0,0,0,0,0,0,1,0,0,0,26124),
(58131,'The spirits have spoken. I have much to ponder.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58132,'To find your White Pawn, we must call upon the ancient magic of my people. To do so, we must first create a Dream Brew.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58133,'|TInterface\\Icons\\ability_warlock_inferno.blp:20|t%s begins to cast |cFFFF0000|Hspell:113364|h[Book Burner]|h|r!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58134,'The stronger the ingredients, the stronger the magic of the brew.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58135,'The Dream Brew will put you into a deep state of meditation. Your mind\'s eye will find the answers to your greatest questions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58136,'The mind has untold powers that we have not yet discovered. With balance and wisdom, it may be possible to unlock these powers of the mind.$B$BThe Dream Brew is only a tool that produces a temporary period of this all-seeing state.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58137,'Certainly.','',0,0,0,0,0,0,0,0,1,0,27584,0,26124),
(58138,'The Dream Brew is an ancient recipe passed down through the ages.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58139,'Archers, attack!','',0,0,0,0,0,0,0,0,1,0,29435,0,26124),
(58141,'Please wait a moment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58142,'','The storm is starting! Get ready.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(58143,'','If the brewkegs catch fire, I need you to help put them out.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(58144,'','Watch out for lightning strikes!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(58145,'','...Saurok? What are they doing here? Keep them away!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(58146,'','Yow, the storm is more intense than I thought! Be careful!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(58148,'','You there!  Make yourselves useful and deal with these summoners!',0,0,0,0,0,0,0,0,0,0,0,29469,26124),
(58150,'','It\'s all about the brewkegs - keep them from burning!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(58151,'','Put out those brewkegs!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(58152,'','This storm is raging out of control! Keep the brewkegs safe...',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(58154,'There should be plenty of anti-venom, thanks to $p.','',0,0,0,0,0,0,396,0,1,0,27585,0,26124),
(58155,'Think no more on despair, Koro. We have a saying where I\'m from: It is darkest just before the dawn.','',0,0,0,0,0,0,396,0,1,0,27586,0,26124),
(58156,'Anduin, will you join me? With the saurok threat at bay for now, it is time we discuss our next move.','',0,0,0,0,0,0,6,0,1,0,29602,0,26124),
(58157,'Use focus and relaxation to maintain your balance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58158,'Thank you - both of you. The Red Crane has always symbolized hope to our people, but in his absence I fear that even my thoughts began to darken.','',0,0,0,0,0,0,1,0,1,0,29603,0,26124),
(58159,'That it is. You speak with a wisdom beyond your years. If we get through this, I think I\'d like to know more about where you are from.','',0,0,0,0,0,0,273,0,1,0,29605,0,26124),
(58160,'%s chuckles.','',11,0,0,0,0,0,11,0,1,0,29604,0,26124),
(58161,'Extreme sewing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58163,'Not now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58165,'Look at the size of that thing! That easily has to be the biggest moth I\'ve seen all week.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58167,'A $c of your caliber is exactly what we need to turn the battle in our favor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58168,'|TInterface\\Icons\\inv_misc_head_dragon_01.blp:20|t%s begins to cast |cFFFF0000|Hspell:113653|h[Greater Dragon\'s Breath]|h|r!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58169,'The books burst into flame from being hit by Book Burner.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58170,'Run, slicky! I dook up your like fer breakfast!','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(58171,'I am Anduin Wrynn, Prince of Stormwind. I won\'t die here. Not like this!','',0,0,0,0,0,0,0,0,7,0,27577,0,26124),
(58172,'If you\'ve come to return to me to my father, I must ask that you look around us first - can we truly walk away from these people in their time of need and still claim to represent the Alliance?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58173,'Our people have their differences, $c, but we are all guests in this place.$B$BThe pandaren have shown me great hospitality and respect, as I\'m sure you\'ve also received, and now they need our help.$B$BThe Horde is not without honor. If you know honor, you will know to save our quarrel for another time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58174,'Keep firing! Let none escape!','',0,0,0,0,0,0,0,0,1,0,29437,0,26124),
(58175,'Another down.  Do not relent!','',0,0,0,0,0,0,0,0,1,0,29438,0,26124),
(58177,'Hello.$b$bMy name is Shai.$b$bThey tell me to watch the cliff.$b$bSometimes cubs come because of a dare. Sometimes grown ups come because they are curious.$b$bI tell you what I tell them. The cliffs are sad, and the jungle is even more sad.$b$bYou may descend using the rope, but know it is a very sad place.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58178,'Defeat all the Expired Test Subjects to escape!','Defeat all the Expired Test Subjects to escape!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58180,'My time with the Red Crane was short, but I learned a great deal under his tutelage.$B$BThis foe--this \"sha\" energy--is unlike anything we\'ve ever faced. It is the physical manifestation of emotional turmoil, bottled in the land for centuries$B$BThis emotional energy has now burst forth to find living, feeling hosts in which to reside.$B$BThe sha threatens to wash over the whole continent, possibly the world, if we do not aid the pandaren in facing it down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58181,'Blades at the ready men!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58182,'It\'s on!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58183,'Mister Goldendraft, I humbly ask permission to marry your daughter Syra.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58184,'It is not her name I am interested in. It is her. She is the kindest, nicest, prettiest person I have ever met.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58185,'Yes. And now, with your permission, I would like to ask for your daughter\'s hand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58186,'The waters of the Vale are now yours to protect...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58187,'The darkness came from deep within the earth. Still, it hungers...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58188,'Son! What are you doing! She\'s a Goldendraft.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(58189,'Here they are. See, told you I could find anyone or anything.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58190,'Wow! That was amazing. What next, $p? Think you can get the hozen and jinyu to get along?','',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(58191,'The Song of the Vale hangs on the wall. Take it. I hear the celestials calling. Thank you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58192,'This Vale of Eternal Blossoms is getting more and more intriguing. I may just have to see it for myself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58193,'My dear, it appears we have visitors!  Friends of yours, Voss?','',0,0,0,0,0,0,6,0,1,0,27479,0,26124),
(58194,'Their deaths only serve to empower my summoners further! Behold!','',0,0,0,0,0,0,22,0,1,0,27480,0,26124),
(58195,'What\'s the matter, Voss, getting tired?','',0,0,0,0,0,0,153,0,1,0,27481,0,26124),
(58196,'Isn\'t it beautiful? The weaving of flesh and bone and soul.','',0,0,0,0,0,0,396,0,1,0,27482,0,26124),
(58197,'You, too, are beautiful, Voss. Have you looked in a mirror recently?','',0,0,0,0,0,0,396,0,1,0,27483,0,26124),
(58198,'My dear, you should embrace this gift that has been bestowed upon you.','',0,0,0,0,0,0,5,0,1,0,27484,0,26124),
(58199,'Come, Voss, your fate awaits you.','',0,0,0,0,0,0,425,0,1,0,27485,0,26124),
(58200,'','You feed their souls to their brethren?  You are sick.',0,0,0,0,0,0,0,0,0,0,0,29470,26124),
(58201,'','I\'ll never stop hunting your kind, necromancer.  NEVER.',0,0,0,0,0,0,0,0,0,0,0,29471,26124),
(58202,'','We\'ll see if you revel so much in death once I\'ve ripped out your throat!',0,0,0,0,0,0,0,0,0,0,0,29472,26124),
(58203,'They agreed?!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(58204,'Come on Peiji. I don\'t like it any better than you do but there is honor in the Pandriarchs\' blessings.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58205,'Same. Now lets get these kids back to Dawn\'s Blossom.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58206,'What?! This is preposterous.','',274,1,0,0,0,0,0,0,1,0,0,0,26124),
(58207,'My Syra will NOT be seen with the likes of a Wanderbrew.','',274,14,0,0,0,0,0,0,1,0,0,0,26124),
(58208,'Well... um... I...','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(58209,'Fine. What\'s done is done. But don\'t assume I will ever like this. Or you, Kai.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58210,'','No, father, I will. Lo was willing to fight the Pandriarchs for me. It took $p to champion us but they consented.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58211,'','You\'ll pay for your tongue.',0,0,0,0,0,0,0,0,0,0,0,29473,26124),
(58212,'','I will not let you curse another soul with this nightmare.',0,0,0,0,0,0,0,0,0,0,0,29474,26124),
(58213,'','Run...necromancer...your life ends once I catch my breath.',0,0,0,0,0,0,0,0,0,0,0,29475,26124),
(58214,'Cheeky little bugger! Didn\'t think he had it in him!','',0,0,0,0,0,0,0,0,1,0,27846,0,26124),
(58215,'Sliiickeeey!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58216,'Ookin\' slicky make a good dook!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58217,'Wikket no grookin\' hozen?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58218,'Hozen grookin\' slicky wikket!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58219,'Ookin\' wikket no whakkin\' hozen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58220,'Hozen grookin\' slicky wikket dookers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58221,'He was a good man, but terrible with a sword! PH','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58222,'He died fighting! PH','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58223,'I\'m surprised he lasted as long as he did. PH','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58224,'I never liked that guy. PH','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58225,'Pain is temporary! PH','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58226,'I\'m hurt! PH','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58227,'Ouch! PH','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58228,'Follow and use the shield as cover!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58231,'Today, our friendship is cemented with the Alliance! Today, we go forth as brothers and sisters. To our new future!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58232,'Where would you like to travel today?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58233,'I would like to travel to Dawn\'s Blossom.','I would like to travel to Dawn\'s Blossom.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58234,'Hurray! We made it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58235,'Lyalia wants me to create a new portal? That woman is crazy. Did she already forget what happened the last time?$b$bWell, Vaeldrin\'s research did suggest some possible ways around traps like that. And I may have taken a short cut or two to get us here.$b$bGive me enough time and I might be able to summon another portal for the encampment.','',2,1,0,0,0,0,0,0,1,0,0,0,26124),
(58236,'Oh my... we made it to the other side somehow. I am so relieved.$b$bIt is not an easy thing to create a portal to a place you have never been before.$b$bBut then, if it were easy, everybody would be doing it.','',2,1,0,0,0,0,0,0,1,0,0,0,26124),
(58237,'You must place the fireworks near a pile of stolen goods.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58238,'','Rest up for a second while I prep the keg.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(58239,'','Everyone ready? Let\'s roll!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(58240,'','Ho boy, more saurok. They always seek high ground when the rains hit!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(58241,'You went an\' made it so these savages like us?$b$bYou gotta be some kinda freak $r genius!$b$bWho\'da thought...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(58242,'You get away from fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58243,'I kill you, dooker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58244,'You in hot water now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58245,'Get lost, tik-nooker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58246,'Get the ook away from there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58247,'You tik-digglin\' jook-manker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58248,'Ookin\' $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58249,'I\'ll cook you into my soup, you dook-wikket!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58250,'','They\'re scaling the cliff walls! This is going to get dirty.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(58251,'Impressive, $r.$b$bThanks to you, these creatures may turn out to be valuable allies.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(58252,'','Watch your footing! The stones are still slick from rain.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(58253,'','Keep an eye on the rear! No - not MY rear. Behind us!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(58254,'','%s stops along the road, panting heavily.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58255,'The tauren are the most majestic of hunters.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58256,'Have you ever seen a tauren hunt? You never do until it\'s too late.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58257,'YOU\'LL NEVER GET THE MASK FROM ME, $P!','',0,0,0,0,0,0,0,0,1,15398,0,0,26124),
(58258,'Give in to your anger!','',0,0,0,0,0,0,0,0,1,15425,0,0,26124),
(58260,'Soon Kun-Lai Summit and all of Pandaria will be consumed with anger. And then, the world!','',0,0,0,0,0,0,0,0,1,15425,0,0,26124),
(58261,'The jinyu are ours and Binan Village is next!','',0,0,0,0,0,0,0,0,1,15425,0,0,26124),
(58262,'I can sense the anger building inside of you.','',0,0,0,0,0,0,0,0,1,15425,0,0,26124),
(58263,'Fu Mo Shi is a doddering old fool. He\'s a master of nothing!','',0,0,0,0,0,0,0,0,1,15425,0,0,26124),
(58264,'Feed my anger!','',0,0,0,0,0,0,0,0,1,15425,0,0,26124),
(58265,'I once hunted alongside the famous Ohlorn Farstrider. He was a tauren who could hunt with nothing but a totem and his skivvies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58266,'Nesingwary is a brilliant hunter, but I wish there was a druid here to teach us some proper animal hunting tactics.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58269,'Alright, I think I know what our next move\'s gotta be.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58271,'Wikkets is furry food!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58272,'Wikket grookin stinky slickies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58273,'Hozen whakkin\' stinky wikket!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58274,'Grookie wikket!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58275,'Ookin\' dooker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58276,'That\'s the worst marching I\'ve ever seen!','',5,0,0,0,0,0,396,0,1,0,0,0,26124),
(58277,'No, no, no... Left foot then right foot!','',274,388,0,0,3,0,396,0,1,0,0,0,26124),
(58278,'Oh come on! We\'ve been doin\' this all day!','',5,388,0,0,3,0,396,0,1,0,0,0,26124),
(58279,'Hey! Hey you in the back! I\'m watchin\' you mister!','',5,388,0,0,3,0,396,0,1,0,0,0,26124),
(58280,'Ack! It\'s the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58281,'The Horde! Run away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58282,'The Horde is invading!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58283,'Hide your kids! Hide your wife!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58284,'Eek! Everybody run!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58285,'You saved me? But, you\'re Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58286,'First anger sha, now the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58287,'Go back where you came from, Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58288,'Thank you for saving my life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58289,'When I spoke to the waters, they showed me a vision of you, $n. Perhaps you are more than a passing traveler. Perhaps you were sent to us for a reason.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58290,'One thing is clear. Our future will be affected by you and your people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58291,'The waterspeaking ceremony has tired me. Please, give me time to rest, and think.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58292,'We are hard at work, training with your soldiers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58293,'Thanks to you, the hozen are no longer a threat. Our village can now work on rebuilding and growing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58294,'Tomorrow holds untold possibilities, and it is all thanks to you and the Alliance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58295,'Someday, perhaps you can tell me more about this strange land from where you came.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58296,'The spirit has spoken. We should take up arms and attack the hozen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58297,'You have gazed upon one of the ancient jinyu emperors of Pandaria, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58298,'The spirit\'s voice echoed through me like thunder. Did you hear it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58299,'I believe the vision means for us to join together, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58300,'The Elder has much to consider, but I think it\'s clear. You are meant to lead us to victory against the hozen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58301,'We are friends now, $n. You are welcome to our village any time you wish to return.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58302,'Your name will be spoken in our village for many years to come.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58303,'Someday, perhaps you will show me your home. It must be very different than ours.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58304,'We owe you a great debt, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58305,'The jinyu are proving to be capable soldiers.','',0,0,0,0,0,0,333,0,1,0,0,0,26124),
(58306,'With the right training, the jinyu will make a strong addition to our land force.','',0,0,0,0,0,0,333,0,1,0,0,0,26124),
(58307,'When the Horde finally show their ugly faces, we\'ll be ready.','',0,0,0,0,0,0,333,0,1,0,0,0,26124),
(58308,'You have done well here, $n. I will put in a good word with your superiors when we return to Stormwind.','',0,0,0,0,0,0,333,0,1,0,0,0,26124),
(58309,'How may I help you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58310,'How do your waters flow today, traveler?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58311,'We have lost so many brothers in battle, I no longer wish to keep count.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58312,'The hozen are slippery and cunning. Worse yet, they feel no shame or remorse.$B$BThey kill out of base instinct, for pleasure and for greed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58313,'I can\'t believe it! I saw the spirit of of an emperor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58314,'The spirit showed us the path to our future. And somehow, it has something to do with you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58315,'Finally, for the first time in many moons, I feel hopeful for our future.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58316,'Someday, I will tell my children about you, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58317,'I have spoken to some of your... Alliance... friends. Your people are quite interesting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58318,'Our soldiers speak of nothing but their new training.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58319,'Are you the $c, $n? I\'ve heard so many stories about you, but never expected to meet you in person.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58320,'Your coming was a blessing to our tribe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58321,'I must admit I had my doubts about you at first, $n, but you have proven yourself with our tribe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58322,'We will need Anduin\'s help to move on the temple. When he\'s ready, we\'ll begin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58323,'RATTLEGORE!','RATTLEGORE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58324,'Once we defeat the Alliance and their allies, claiming this land will be a fitting testimony to the tenacity of the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58325,'I\'d be dead or worse if not for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58326,'The Alliance comes to the rescue again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58327,'Thank you, Outlander!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58328,'The jinyu are indebted to you and your Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58329,'I\'m free! Long live the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58330,'I wish the jinyu could join the Alliance.  Thank you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58331,'I am in your debt. Please save the rest of my people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58332,'General Nazgrim needs your training report.','General Nazgrim needs your training report.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58333,'The doctor is in!','',0,0,0,0,0,0,0,0,1,0,29453,0,26124),
(58334,'General Nazgrim wants an update on your progress.','General Nazgrim wants an update on your progress.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58335,'General Nazgrim needs an update on your progress.','General Nazgrim needs an update on your progress.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58336,'That\'s great, $p. We\'ll take it from here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58337,'Wow. That\'s a filthy one. Sure you don\'t want to go through the wash too?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58338,'Whew... that one was ripe.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58339,'Oh, I\'ve been looking all over for that one. He\'s a handful.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58340,'Hmm. I think that one is going to need some extra perfuming.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58341,'Oh, the grummle are going to love that one.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58342,'What did the yaungol do to that poor thing?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58343,'I hope that one doesn\'t have to go through twice.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58344,'You\'re not gonna run me off my land!','',14,0,0,0,0,0,0,0,1,15415,0,0,26124),
(58345,'Hey! Those are my yaks! Bring them back here this instant!','',14,0,0,0,0,0,0,0,1,15415,0,0,26124),
(58346,'If you think I\'m going to be intimidated by a bunch of filthy yaungol, you\'ve got another thing coming!','',14,0,0,0,0,0,0,0,1,15415,0,0,26124),
(58347,'Help! These yaungol are trying to steal my yaks!','',14,0,0,0,0,0,0,0,1,15415,0,0,26124),
(58348,'You better be happy I threw my back out or I\'d come over there and kick you off my land.','',14,0,0,0,0,0,0,0,1,15415,0,0,26124),
(58349,'Filthy yaungol infestation!','',14,0,0,0,0,0,0,0,1,15415,0,0,26124),
(58350,'I hope the mantid come and drag you yaungols back over the wall.','',14,0,0,0,0,0,0,0,1,15415,0,0,26124),
(58351,'I am just glad my wife, spirits guide her, is not around to see our business overrun by these ruffians and hoodlums!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58352,'It is an absolute travesty of our time I tell you. That a rancher and his son can\'t just run a yak wash in peace without fear of yaungol raiding...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58353,'If this keeps up, I don\'t know how we are ever going to continue our supply of yaks to the grummle.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58354,'Have you met the Lucky Eightcoins? He is our biggest customer and the shrewdest of grummle negotiators.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58355,'Our business has stood for twelve generations and supplied many hundreds of fresh, clean, and smelly yaks to the grummles.$b$bWe\'ve faced floods, famine, and mogu. I\'ll be a hozen\'s uncle if I let these yaungol run us off.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58356,'You here to steal my yaks?!$b$bIf so, be ready for me to slap that look off your face.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58357,'Get away from him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58358,'Stay out of his range!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58359,'You saved my son and my ranch. I am forever in your debt, stranger. If you ever find yourself in need of a clean yak, you know where to go.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58360,'Get away from his attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58361,'Yes! Yes! More blood!','Yes! Yes! More blood!',0,0,0,0,0,0,0,0,1,0,27751,27751,26124),
(58362,'Blood blood blood BLOOD BLOOD!!','Blood blood blood BLOOD BLOOD!!',0,0,0,0,0,0,0,0,1,0,27752,27752,26124),
(58363,'Dripping and pouring and clotting!','Dripping and pouring and clotting!',0,0,0,0,0,0,0,0,1,0,27753,27753,26124),
(58364,'More blood!','More blood!',0,0,0,0,0,0,0,0,1,0,27754,27754,26124),
(58365,'The scent of blood...so delicious!','The scent of blood...so delicious!',0,0,0,0,0,0,0,0,1,0,27755,27755,26124),
(58366,'Spurts of crimson!','Spurts of crimson!',0,0,0,0,0,0,0,0,1,0,27756,27756,26124),
(58367,'Always pumping, always pumping!','Always pumping, always pumping!',0,0,0,0,0,0,0,0,1,0,27757,27757,26124),
(58368,'So warm, so red!','So warm, so red!',0,0,0,0,0,0,0,0,1,0,27758,27758,26124),
(58369,'I honestly don\'t know how I am going to round up so many yaks on my own. Those yaungol are dangerous.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58370,'I hope the yaungol arriving wasn\'t a sign of worse things to come. They are bad enough.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58371,'Pa says we\'ve faced worse. But when he says \"we\" he means people like his great great grandfather.$b$bThe worst thing I\'ve ever had to face was a grummle angry that his yak wasn\'t smelly enough.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58372,'Mountain sprites are mean creatures. Their pranks can really hurt people.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58373,'Pa keeps telling me I need to be more like my grandpa. But he died before I was born in a yak stampede.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58374,'Please! Can you help me! These sprites grabbed me when I was searching for some of our missing yaks.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58375,'You have no idea how much your help has saved our family business.$b$bI should be able take it from here as long as the yaungol slow down their assault.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58376,'General Nazgrim wants to know the status of the supplies.','General Nazgrim wants to know the status of the supplies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58377,'Thank you for rescuing me stranger! I will see you at the Yakwash.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58378,'That was an impressive number of sprites you just mowed through.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58379,'The principle is absolute, follow it and you will be accepted.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58380,'There is nothing but the Crusade! Anyone that is not with us, will fall!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58381,'Ooo, I can smell the luck of your yaks from here. Come $pc, and I will give you much fortune in return.','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(58382,'I lost my yaks.','I lost my yaks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58383,'Not to worry. These little fellas seem to have found their way back here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58385,'Not to worry. The little fellas seem to have found their way back here. Here you go.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58386,'The answer I seek eludes me...$b$bSometimes $c, one must step back from the trees in order to see the forest.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58389,'My sight may be gone, but I am fortunate to live in a land which rewards all of the senses.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58390,'This is no business of yours, $p! I will allow you to leave.','',0,0,0,0,0,0,0,0,1,15425,0,0,26124),
(58391,'Let loose your rage. Kill me and in so doing, validate my existence.','',0,0,0,0,0,0,0,0,1,15425,0,0,26124),
(58392,'I not afraid of little thing like you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58393,'I break you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58394,'Die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58395,'You give yaks now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58396,'Challenge accepted!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58397,'I squish you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58398,'','Who\'s out there, Shao? Is it safe?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58399,'I am ready to leave.','I am ready to leave.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58400,'Your yak is beginning to buck. Return to Lao & Son\'s Yakwash.','Your yak is beginning to buck. Return to Lao & Son\'s Yakwash.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58401,'Make it fast, buddy. We\'ve got deadlines to meet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58402,'Sometimes it is good to take a step back and reflect upon our larger goals.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58403,'','Our work here has been steady and tedious, but the statue is almost complete.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58404,'','Take a moment and look at the statue. This marvel is the culmination of a hundred years of labor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58405,'Need a lift?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58406,'My father and my father\'s father spent their lives toiling on this statue. I am proud to be the one who will finish it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58407,'The work is hard, but necessary. This statue represents all that we believe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58408,'Just a few more shipments of jade, and the dragon will be complete.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58409,'It will feel good to rest after the statue is done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58410,'It will not be long, now before our work is finished.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58411,'My family is planning a great banquet to celebrate the statue\'s completion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58412,'Is the work day over yet? The Drunken Hozen in Dawn\'s Blossom is calling my name.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58413,'$P, YOU DARE?!','',0,0,0,0,0,0,0,0,1,15425,0,0,26124),
(58414,'Useless...','Useless...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58415,'','Class dismissed.',0,0,0,0,0,0,0,0,1,0,0,29455,26124),
(58416,'I need a ride to the top of the statue.','I need a ride to the top of the statue.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58417,'','Going down?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58418,'','Whatever you do, don\'t look down.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58419,'I need a ride to the bottom of the statue.','I need a ride to the bottom of the statue.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58420,'WE\'LL MEET AGAIN, $P!','',0,0,0,0,0,0,0,0,1,15425,0,0,26124),
(58421,'Did you forget, girl? I am the Darkmaster! I command the undead!','',0,0,0,0,0,0,6,0,1,0,27486,0,26124),
(58422,'Now turn your lovely runeblades on our guests, and fetch me their bones!','',0,0,0,0,0,0,6,0,1,0,27487,0,26124),
(58423,'','I...won\'t let you...',0,0,0,0,0,0,0,0,0,0,0,29464,26124),
(58424,'','I can\'t...fight him...',0,0,0,0,0,0,0,0,0,0,0,29465,26124),
(58425,'','END IT! NOW! Before he can...',0,0,0,0,0,0,0,0,0,0,0,29463,26124),
(58426,'YOUR SOUL IS MINE!','',0,0,0,0,0,0,6,0,1,0,27488,0,26124),
(58427,'Look. A stranger. I wonder if $g he\'s : she\'s; come to save us from the yaungol.','Look. A stranger. I wonder if $g he\'s : she\'s; come to save us from the yaungol.',0,0,0,0,0,0,0,0,1,15440,0,0,26124),
(58428,'Shhh, an outlander.','Shhh, an outlander.',0,0,0,0,0,0,0,0,1,15440,0,0,26124),
(58429,'$G He : She; looks pretty powerful. Maybe powerful enough to drive the yaungol back!','$G He : She; looks pretty powerful. Maybe powerful enough to drive the yaungol back!',0,0,0,0,0,0,0,0,1,15440,0,0,26124),
(58430,'We may have to retreat into the Valley of the Four Winds. I don\'t want to give up my home here.','We may have to retreat into the Valley of the Four Winds. I don\'t want to give up my home here.',0,0,0,0,0,0,0,0,1,15440,0,0,26124),
(58431,'A foreigner. $G He : She; looks very exotic. Don\'t stare!','A foreigner. $G He : She; looks very exotic. Don\'t stare!',0,0,0,0,0,0,0,0,1,17106,0,0,26124),
(58432,'Are you here to save us, $c?','Are you here to save us, $c?',0,0,0,0,0,0,0,0,1,15440,0,0,26124),
(58433,'Strange getup, even for a $r $c if you ask me.','Strange getup, even for a $r $c if you ask me.',0,0,0,0,0,0,0,0,1,15440,0,0,26124),
(58434,'I don\'t care what you say. If that $c is here to help us, I say we welcome $g him : her; with arms wide open!','I don\'t care what you say. If that $c is here to help us, I say we welcome $g him : her; with arms wide open!',0,0,0,0,0,0,0,0,1,15440,0,0,26124),
(58435,'Jade, it\'s all about the jade! We need it, and that\'s the bottom line!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58436,'This jade shortage is the worst thing to happen since the golden autumn crisis. Production is already months behind. The Serpent ain\'t getting any younger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58437,'Show me your wares.','Show me your wares.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58438,'A luckydo would be wise to buy my wares. Bad fortune to those who simply walk away.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58439,'Oh that\'s a fine piece o\' metal you have der. I am quite fond of a good piece of steel.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58440,'Welcome to Binan Village, $c. I beg you... please help us.','',0,0,0,0,0,0,20,0,1,15442,0,0,26124),
(58441,'I\'ve got your jade right here.','I\'ve got your jade right here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58442,'Did someone say they needed jade?','Did someone say they needed jade?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58443,'I\'ve got a jade delivery for you.','I\'ve got a jade delivery for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58444,'I\'ve got a new jade shipment for you.','I\'ve got a new jade shipment for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58445,'Lovely, beautiful! If you have time, you should also visit the East Temple. You may gain further insight into our great statue, and its importance to our way of life.','',0,0,0,0,0,0,0,0,1,13382,0,0,26124),
(58446,'Lovely, beautiful! I see you have already visited the East Temple. Then you understand why this statue is so important to our way of life.','',0,0,0,0,0,0,0,0,1,15434,0,0,26124),
(58447,'','Trick to drinking with grummles is not to stop. With any luck, they\'ll pass out before you do.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58448,'Unbelievable! You\'ve just saved my neck, $n. Oh ho, and just look at this luster.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58449,'','Wonderful! Just look at it. A hundred years to produce this incredible monument for the Jade Serpent. And now, you too have contributed to this masterpiece.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58450,'','Soon, very soon, it will all pay off.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58451,'It\'s about time we got another shipment. I heard they were having trouble at the mines, but our work cannot wait.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58452,'Within every brush stroke are a thousand meanings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58453,'I have written many powerful words in my time, but still, the most powerful is hidden to me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58454,'I prefer to work in solitude.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58455,'What can I get for you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58456,'Great day for a race, don\'t you think?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58457,'Hot food, fresh food, delicious food! Get your race snacks here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58458,'You were magnificent out there, $n!','',0,0,0,0,0,0,4,0,1,15443,0,0,26124),
(58459,'There\'s my $g boy : girl;!','',0,0,0,0,0,0,0,0,1,15444,0,0,26124),
(58460,'All hail the savior of Binan Village!','',0,0,0,0,0,0,0,0,1,15444,0,0,26124),
(58461,'Tell us again how you slew the yaungol war leader, $n.','',0,0,0,0,0,0,0,0,1,15444,0,0,26124),
(58462,'Have you considered settling down, $n? Kun-Lai Summit could use a strong $c such as yourself as its protector.','',0,0,0,0,0,0,0,0,1,15444,0,0,26124),
(58463,'I\'ve never witnessed such heroics and selflessness.','',0,0,0,0,0,0,0,0,1,15444,0,0,26124),
(58464,'Welcome back! What news, $n?','',0,0,0,0,0,0,0,0,1,15444,0,0,26124),
(58465,'It\'s good to see you, $n.','',0,0,0,0,0,0,0,0,1,15444,0,0,26124),
(58466,'$n, I was wondering if you\'d be willing to endorse me come election time?','',0,0,0,0,0,0,0,0,1,15444,0,0,26124),
(58467,'You have saved Binan Village, $n. Ring the gong so all shall know!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58468,'Is everything alright, $c? We\'re all counting on you to kill the yaungol war leader.','',0,0,0,0,0,0,0,0,1,15446,0,0,26124),
(58469,'I won\'t let them take me!','I won\'t let them take me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58470,'My house! My things! It\'s all ablaze!','My house! My things! It\'s all ablaze!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58471,'My dog?! Where\'s my dog?!','My dog?! Where\'s my dog?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58472,'Thank you... Now what?','Thank you... Now what?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58473,'The whole town is gone!','The whole town is gone!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58474,'What are we going to do?!','What are we going to do?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58475,'I never thought something like this could happen here...','I never thought something like this could happen here...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58476,'Did you see what $n the $c did to the yaungol?','Did you see what $n the $c did to the yaungol?',0,0,0,0,0,0,0,0,1,15448,0,0,26124),
(58477,'With $n here, we may be back in our homes soon!','With $n here, we may be back in our homes soon!',0,0,0,0,0,0,0,0,1,15448,0,0,26124),
(58478,'I\'ve never seen a $c like $g him : her; before. $G He\'s : She\'s; already beaten the yaungol!','I\'ve never seen a $c like $g him : her; before. $G He\'s : She\'s; already beaten the yaungol!',0,0,0,0,0,0,0,0,1,15448,0,0,26124),
(58479,'Look, it\'s $n, savior of Binan Village!','Look, it\'s $n, savior of Binan Village!',0,0,0,0,0,0,0,0,1,15448,0,0,26124),
(58480,'I never doubted $n, not for one minute!','I never doubted $n, not for one minute!',0,0,0,0,0,0,0,0,1,15448,0,0,26124),
(58481,'You just don\'t see $cs like $n anymore.','You just don\'t see $cs like $n anymore.',0,0,0,0,0,0,0,0,1,15448,0,0,26124),
(58482,'I heard that $n comes from a far off land beyond the mists. $G He : She; must be their $g hero : heroine; to have come all this way to save us.','I heard that $n comes from a far off land beyond the mists. $G He : She; must be their $g hero : heroine; to have come all this way to save us.',0,0,0,0,0,0,0,0,1,15448,0,0,26124),
(58483,'Look everyone, it\'s $n! Hurray for $n!','Look everyone, it\'s $n! Hurray for $n!',0,0,0,0,0,0,0,0,1,15448,0,0,26124),
(58484,'Attack! Kill them all!','',0,0,0,0,0,0,0,0,1,0,27536,0,26124),
(58485,'Release the hounds!','',0,0,0,0,0,0,0,0,1,0,27537,0,26124),
(58489,'All attack now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58490,'Don\'t just sit there! Kill them!','',0,0,0,0,0,0,0,0,1,0,27542,0,26124),
(58491,'Stupid animals!  I\'ll put you down after I kill these weaklings.','',0,0,0,0,0,0,0,0,1,0,27543,0,26124),
(58492,'','It burns...my soul...it burns!!!!',0,0,0,0,0,0,0,0,0,0,0,29468,26124),
(58493,'','Greetings, $c. Your people are inside. But first, may I ask a favor?',0,0,0,0,0,0,1,0,1,15450,0,0,26124),
(58494,'','Have you had a chance to test the efficacy of my family\'s dit da jow, $c?',0,0,0,0,0,0,1,0,1,15451,0,0,26124),
(58495,'','The warriors are reporting that you saved their lives. Thank you, $n.',0,0,0,0,0,0,0,0,1,15452,0,0,26124),
(58496,'','Always good to see you, $n. How have you been?',0,0,0,0,0,0,0,0,1,15453,0,0,26124),
(58497,'','How are you feeling, $c? Need more dit da jow?',0,0,0,0,0,0,0,0,1,15453,0,0,26124),
(58498,'','It amazes me how selfless and kind you have been to all of us.',0,0,0,0,0,0,0,0,1,15453,0,0,26124),
(58499,'','How are your friends doing, $n?',0,0,0,0,0,0,0,0,1,15453,0,0,26124),
(58500,'','There $g he : she; is. You\'re welcome here anytime, $n.',0,0,0,0,0,0,0,0,1,15453,0,0,26124),
(58501,'','Going to be around long, $n? You\'ll have to tell me about your latest exploits.',0,0,0,0,0,0,0,0,1,15453,0,0,26124),
(58502,'','With all of the adventuring you do, what you need is a good rest, young $g man : lady;.',0,0,0,0,0,0,0,0,1,15453,0,0,26124),
(58503,'','I was just thinking about you, $n.',0,0,0,0,0,0,0,0,1,15453,0,0,26124),
(58504,'It is a luckydo to have a clean yak. It is a bigger luckydo to feed it my special brew. This is how one makes Kobeyaks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58505,'I can feel her will breaking! Her soul burns so brightly.','',0,0,0,0,0,0,6,0,1,0,27492,0,26124),
(58506,'What am I missing...','What am I missing...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58507,'Something isn\'t right...','Something isn\'t right...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58508,'','A foreigner? And by the look of you, a seasoned $c. Good! Maybe you can get us out of this mess.',0,0,0,0,0,0,0,0,1,15457,0,0,26124),
(58509,'','My plan hinges on you bringing us as many arrows as you can from the battlefield, $c.',0,0,0,0,0,0,0,0,1,15458,0,0,26124),
(58510,'','Looks like you got more than enough. Quick, $n, I think I can see the yaungol reinforcements massing on the horizon.',0,0,0,0,0,0,0,0,1,15459,0,0,26124),
(58511,'<The farmer stares at the floor with a distant look in his eyes.>$B$BThey... took them.$B$BTook them away...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58512,'Are you going to find them? Can you really?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58513,'Now, Lilian, it is time for your transformation.','',0,0,0,0,0,0,6,0,1,0,27491,0,26124),
(58514,'','Hail the hero of Kun-Lai Pass, $n!',0,0,0,0,0,0,0,0,1,15460,0,0,26124),
(58515,'','Good to see you again, $n. Feel like taking another swing at these yaungol pests?',0,0,0,0,0,0,0,0,1,15460,0,0,26124),
(58516,'','Don\'t mind us. We\'re just mopping up the last of them now. Shouldn\'t be much longer.',0,0,0,0,0,0,0,0,1,15460,0,0,26124),
(58517,'','Don\'t I owe you a drink, $g handsome : lady;?',0,0,0,0,0,0,0,0,1,15460,0,0,26124),
(58518,'','You figure out yet what\'s driving all of these yaungol out of the Townlong Wastes?',0,0,0,0,0,0,0,0,1,15460,0,0,26124),
(58519,'','Careful with those shots. Don\'t hit $n!',0,0,0,0,0,0,0,0,1,15460,0,0,26124),
(58520,'','It\'s a real honor, $n. Maybe we can have a sitdown soon and you can regale me with your latest exploits?',0,0,0,0,0,0,0,0,1,15460,0,0,26124),
(58521,'','Give \'em hell, $n!',0,0,0,0,0,0,0,0,1,15460,0,0,26124),
(58522,'','...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(58523,'Why let a perfectly good corpse go to waste?','',0,0,0,0,0,0,6,0,1,0,27495,0,26124),
(58524,'How does it feel, Voss?  To watch them hack your mortal body to pieces?','',0,0,0,0,0,0,6,0,1,0,27493,0,26124),
(58525,'Stranger! A moment of your time if you please?','',0,0,0,0,0,0,0,0,1,15462,0,0,26124),
(58526,'How intriguing, her spirit will not relinquish its grasp on this world.','',0,0,0,0,0,0,6,0,1,0,27494,0,26124),
(58527,'','DIE, NECROMANCER!',0,0,0,0,0,0,0,0,0,0,0,29466,26124),
(58528,'','Leave me...to die...alone...please...',0,0,0,0,0,0,0,0,0,0,0,29467,26124),
(58529,'What?!','',0,0,0,0,0,0,6,0,1,0,27489,0,26124),
(58530,'The bones! You wretch!','',0,0,0,0,0,0,6,0,1,0,27490,0,26124),
(58531,'My house is just to the right as you enter the village. The mask should be upstairs.','',0,0,0,0,0,0,0,0,1,15463,0,0,26124),
(58532,'The $c returns. Is that my mask I spy?','',0,0,0,0,0,0,0,0,1,15465,0,0,26124),
(58533,'','$C, I would ask something of you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58534,'Over here, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58535,'How fare your efforts to remove the taint of the sha from the jinyu, $c?','',0,0,0,0,0,0,0,0,1,15466,0,0,26124),
(58536,'Thank you, $n. You just saved my hide!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58537,'I\'m still amazed that I ever joined the Shado-Pan to be honest. Not that they\'re not an amazing bunch and all, just the thought of the violence clashing with my impecible complection.$B$BI never have trouble remembering why I joined them though... let\'s just say Anji can be very convincing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58538,'','Betrayed! We came here every week. They seemed to be simple traders. \n\nNow these... fish-men greet us with one webbed hand, all the while with the other behind their back, holding their knives, waiting for us to turn around so they can plunge them in!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58539,'Take your time, $n. Better that you face the Fury Leviathan prepared and on your terms.','',0,0,0,0,0,0,0,0,1,15471,0,0,26124),
(58540,'','I would DESTROY them. It is worthless to stay here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58541,'','$p, if the scouts give you any information on the mogu leader, you know what to do.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(58542,'Is it done, $n? We saw the explosion from all the way over here.','',0,0,0,0,0,0,0,0,1,15472,0,0,26124),
(58543,'What\'s the mask for?','',0,0,0,0,0,0,0,0,1,15465,0,0,26124),
(58544,'Woah!','',0,0,0,0,0,0,0,0,1,15472,0,0,26124),
(58545,'Masterfully done, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58546,'You did it! You really did it! Maybe you can show me some of your moves, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58547,'','%s grunts her admiration.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58548,'Look, it\'s $n!','',0,0,0,0,0,0,0,0,1,15476,0,0,26124),
(58549,'$n, can I come and train with you after we\'re done here?','',0,0,0,0,0,0,0,0,1,15476,0,0,26124),
(58550,'I think I want to be a $c, swordmistress.','',0,0,0,0,0,0,0,0,1,15476,0,0,26124),
(58551,'Where do you come from, $n? When you go back, can I come?','',0,0,0,0,0,0,0,0,1,15476,0,0,26124),
(58552,'Thanks again for handling my chores. See you back at the village soon?','',0,0,0,0,0,0,0,0,1,15476,0,0,26124),
(58553,'Hey, $n, what do you think of this move?','',0,0,0,0,0,0,0,0,1,15476,0,0,26124),
(58554,'$n!','',0,0,0,0,0,0,0,0,1,15476,0,0,26124),
(58555,'$n could probably wipe out all of these tainted jinyu with one of $g his : her; signature $c moves.','',0,0,0,0,0,0,0,0,1,15476,0,0,26124),
(58556,'Ah, you\'ll make a fine rock-breaker I think!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58557,'Insolent cubs! Submit or die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58558,'I will teach you to obey!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58559,'How dare you speak to me like that! Know your place!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58560,'You\'re nothing but backwater peasants with sticks! Get back in line!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58561,'We are legion. We are everywhere. See you back at Jinyu Mere, $p.','',0,0,0,0,0,0,0,0,1,15398,0,0,26124),
(58562,'OUR JINYU! YOU CANNOT HAVE THEM BACK, $P!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58563,'Give in to your anger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58564,'We are honored that you have chosen to be tainted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58565,'You will make an excellent addition, $p.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58566,'The Fury Leviathan will enjoy using your body as a puppet against these lands.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58567,'Why do you care what we do to these fish heads?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58568,'NO! I WILL POSSESS YOU AND ALL OF YOUR KIND!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58569,'How much of your time is spent inflicting your anger on others? How can you possibly hope to defeat us?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58570,'This will be the bomb.','',0,0,0,0,0,0,0,0,1,0,29346,0,26124),
(58571,'Good to see you again, $p.$B$BThis place is ancient. There are answers here, for those who know the questions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58572,'','Look, stranger, I\'ll tell you the same thing I told the honorable Lorewalker...$B$B<Mann leans in closer with each word, her eyes widening.>$B$BI. Have. No. Jade!',5,0,0,1,0,0,0,0,1,0,0,0,26124),
(58573,'This is fascinating... but what could it mean?!$B$BThe jade you gathered from those sprites will help us fill in the next panel, but we\'ll need more to finish the whole fresco.$B$BPlease help the foreman get her quarry back in operation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58574,'Take a look, $p. This panel clearly depicts war.$B$BWhat could be next? What is it trying to say?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58575,'','Normally we\'d be more than capable of fulfilling Cho\'s request. Jade veins run through this land like...$B$B<Mann scratches her head for a moment in thought.>$B$BWell, like something that runs through something else in veins. $B$BLook, I ain\'t a poet.$B$BPoint is: we got problems.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58576,'','The quarry will be fine thanks to you.$B$BThink I\'ll let some o\' the boys take a little vacation...$B$BHAH! Who am I kiddin\'? I almost said that with a straight face, too.$B$BWe got WORK to do!',11,0,0,1,0,0,0,0,1,0,0,0,26124),
(58577,'Don\'t worry about me none.$B$BHNNGGHHH!!$B$BI\'ll be fine, really.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58578,'You think that was bad? You shoulda been here, oh, thirty years ago, I\'d say.$B$BOne o\' the boys left his lunch out - some kind of fish stew, if mem\'ry serves.$B$BWell he leaves it out in the atrium - BIG ol\' pot o\' fish stew, I\'m sure of it now - and, cub\'s honor, every hozen within a hundred miles come a-runnin\'.$B$BAfter cleanin\' THAT up, I\'ll take some overgrown nibblers any day...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58579,'The yaungol are attacking!','The yaungol are attacking!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58580,'We\'re going to die!','We\'re going to die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58581,'Somebody save us!','Somebody save us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58582,'Bramblestaff, do something!','Bramblestaff, do something!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58583,'Our warriors are losing!','Our warriors are losing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58584,'What did we ever do to the yaungol?!','What did we ever do to the yaungol?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58585,'The yaungol must be attacking because of the stranger!','The yaungol must be attacking because of the stranger!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58586,'Dang nibblers are tearin\' the place down in there!','Dang nibblers are tearin\' the place down in there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58587,'Hello there! I\'m Weng: pupil of nature!$B$BI\'ve been sent to investigate the recent wood sprite problems.$B$BI\'ve always been fascinated with wood sprites, even as a child. They\'re not normally violent, you know.$B$BPlayful, maybe, but rarely do they mean any real harm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58588,'Help!','',0,0,0,0,0,0,1,0,0,15488,27726,0,26124),
(58589,'Over here!','',0,0,0,0,0,0,1,0,0,15488,27727,0,26124),
(58590,'Sully! Little Lu! Anyone!','',0,0,0,0,0,0,1,0,0,15488,27728,0,26124),
(58591,'AAAHH!!','',0,0,0,0,0,0,1,0,0,15488,27729,0,26124),
(58592,'I bleed... haha... but I won\'t die!','',0,0,0,0,0,0,0,0,1,0,27544,0,26124),
(58596,'Weak slickies are good for nuthin\'!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58597,'Stay down, stupid slickies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58598,'Let\'s see how strong you are without your slicky friends!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58599,'I will have your unruly spirit, like all the others!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58600,'You are MINE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58601,'You... will not defeat... the thunder...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58602,'','Ain\'t much to it!$B$BThere are five rare treasures that you can find in the Dark Soil around Pandaria: Ruby Shards, Lovely Apples, Jade Cats, Blue Feathers, and Marsh Lilies.$B$BAs long as you have one of those items in your bags, you\'ll see who around here is willing to accept them.$B$BFind one of those and give them to someone you like, and chances are they\'ll like you a little back! Everyone has a favorite item out of the five, so talk to folks to learn what they prefer.$B$BAlso, the folks \'round here love food! I mean, who doesn\'t? If you know how to cook, you might just profit!$B$BThat\'s about all I know about gifts. Good luck!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58603,'What kind of gifts do you like?','What kind of gifts do you like?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58604,'Go get \'em, kid.','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(58605,'Hey, kid! You all right?\n\nI\'ve got you. Don\'t go into the light!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(58608,'Ah, fresh meat for the dogs.','',0,0,0,0,0,0,0,0,1,0,27550,0,26124),
(58609,'','I\'ve got backup. Watch this.',0,0,0,0,0,0,397,0,0,0,0,31180,26124),
(58610,'$n, over here.','',0,0,0,0,0,0,0,0,1,15495,32443,0,26124),
(58611,'We must gain a foothold here.. away from these Horde dogs.','',0,0,0,0,0,0,0,0,1,15496,32444,0,26124),
(58612,'I grow weary of these Horde cowards. There must be someplace else in this village to rest.','',0,0,0,0,0,0,0,0,1,15496,32445,0,26124),
(58613,'These people shall not be enslaved by your cruel Horde. I will not allow it!','',0,0,0,0,0,0,0,0,1,15496,32446,0,26124),
(58614,'How many innocents have died at your hand, orc? Your Horde has no honor...','',0,0,0,0,0,0,0,0,1,15496,32447,0,26124),
(58615,'Only three Horde rats left. Shouldn\'t be a problem to finish you off once and for all.','',0,0,0,0,0,0,0,0,1,15496,32448,0,26124),
(58616,'Kun-Lai Summit is where you\'re going to die, orc. I\'m going to bury you.','',0,0,0,0,0,0,0,0,1,15496,32449,0,26124),
(58617,'I\'ll wait until you\'re healed to finish you, Nazgrim. Let it not be said that the Alliance has no honor.','',0,0,0,0,0,0,0,0,1,15496,32450,0,26124),
(58618,'Look at the peaceful, kind people of this land. They were born to belong to the Alliance.','',0,0,0,0,0,0,0,0,1,15496,32451,0,26124),
(58619,'$n, over here!','',0,0,0,0,0,0,0,0,1,15497,29183,0,26124),
(58620,'As soon as I... can get up, I\'m going to crush you!','',0,0,0,0,0,0,0,0,1,15498,29184,0,26124),
(58621,'Goblin, find my axe! I\'ll separate this fool human\'s head from his neck!','',0,0,0,0,0,0,0,0,1,15498,29185,0,26124),
(58622,'Soon, you and your Alliance will only be found in Azeroth\'s history books.','',0,0,0,0,0,0,0,0,1,15498,29186,0,26124),
(58623,'My axe will soon feast upon your blood, human.','',0,0,0,0,0,0,0,0,1,15498,29187,0,26124),
(58624,'Your kind shall never build a foothold here. This is destined to be Horde land.','',0,0,0,0,0,0,0,0,1,15498,29188,0,26124),
(58625,'You... you escaped me in Vashj\'ir. You won\'t be so lucky here.','',0,0,0,0,0,0,0,0,1,15498,29189,0,26124),
(58626,'These pandaren are a wise enough people. Sooner or later, they will side with the Horde.','',0,0,0,0,0,0,0,0,1,15498,29190,0,26124),
(58627,'I hope you have the courage to die bravely, human. I\'m in the mood for a good fight.','',0,0,0,0,0,0,0,0,1,15498,29191,0,26124),
(58628,'Mistakes are simply lessons we have yet to learn, $n. It is how you handle those mistakes that will ultimately define you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58629,'You go on ahead. I\'ll gather my tools and meet you at Sunsong Ranch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58630,'Defeating the Lingering Doubts will take a level head and steady emotions, $c. With them under control the rebuilding process can begin.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58631,'Fool! I will crush you!','',0,0,0,0,0,0,0,0,1,15489,0,0,26124),
(58632,'Patience, now. It will be done soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58633,'The sooner I\'m left alone, the faster the work will be finished.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58634,'Weed whacking is hard work.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58635,'Just a little more, and it will be finished.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58636,'This field will look as good as new in no time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58637,'Gone to Halfhill Market. Don\'t touch my vegetables!\n\n- Farmer Fung','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58638,'Cinematic will happen here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58639,'It\'s finally over...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58640,'I\'ll be waiting at the Tan-Chao. Come and speak to me there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58641,'The spirits can finally rest, thanks to you. Soon I, too, will return to the other side.$B$BI leave you with this piece of advice: Pandaria is a land of history. If ever you are unsure about the future, you need only to seek answers from the past.$B$BRemember this, and you will thrive here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58642,'Whoa! Uh... I gotta... go!','Whoa! Uh... I gotta... go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58643,'Great gourds! Sorry, but I need to leave!','Great gourds! Sorry, but I need to leave!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58644,'Uh-oh...! I feel the call of nature!','Uh-oh...! I feel the call of nature!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58645,'Oh! I feel something rumbling. Excuse me!','Oh! I feel something rumbling. Excuse me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58646,'Wow, that\'s some powerful stuff. I\'ve got the runs... er... got to run!','Wow, that\'s some powerful stuff. I\'ve got the runs... er... got to run!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58647,'Put it out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58648,'The banner\'s on fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58649,'Oh no!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58650,'The banner!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58651,'Ur-Bataar, help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58652,'Fire bad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58653,'Intruder!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58654,'Ur-bataar will kill you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58655,'Do you have any gooseberries for sale?','Do you have any gooseberries for sale?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58656,'No! Kun-Lai was ours....','',0,0,0,0,0,0,0,0,1,15489,0,0,26124),
(58657,'Hello friend!  You\'re welcome to use my cart if you like.  It will take you to the Temple of Five Dawns.','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(58658,'This footprint is too muddy to be useful.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(58659,'Next to this track, you see some bits of chewed up carrot.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(58660,'The muddy track clearly shows a dexterous paw.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(58661,'Stamped into the footprint is a clod of mud mixed with hay and yak hair.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(58662,'Behind the print is the long impression of a prehensile tail.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(58663,'Next to signs of a scuffle is a sharp, pointy spearhead and some colorful feathers.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(58664,'Footprints lead toward the mountain to the north.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(58665,'A startled hozen leaps out of a nearby bush!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(58666,'It all makes sense! All the strange things that have been happening on our farms. The hozen must have been behind it all! I must admit, you figured it out pretty quickly, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58667,'','Howdy, stranger!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58668,'Tell me the story about Farmer Yoon\'s wagon.','Tell me the story about Farmer Yoon\'s wagon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58669,'','My pappy must\'ve told me the story a hunnert times!$B$BBack during the great drought, times sure were hard. Farmers were spitting on their crops to water \'em, it was so dry. The entire town was starvin\' o\' thirst!$B$BSo what does Farmer Yoon\'s grandpappy do but pack up his wagon in the middle o\' the night.$B$BThen he drives his mushan beast all the way to the lake at the base o\' Kun-Lai Summit. He loads up that wagon with a hunnert barrels o\' fresh water, then drives right on back.$B$BHe didn\'t stop fer nuthin\'! How could he? Our whole town was dyin\'! He drove that busted wagon up to his farm and his mushan died on the spot!$B$BBut we had enough water for the entire town and the spring harvest, too.$B$BSaved Halfhill, Yoon\'s grandpappy did!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58670,'','I\'ll collect my tools and meet you at Farmer Yoon\'s. Bet I can beat you there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58671,'','Are all you citypaws this impatient?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58672,'','Well this wagon ain\'t gonna fix itself.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58673,'','Look, here\'s the deal. You keep yammerin\' and I stop hammerin\'.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58674,'','I got a green thumb and a steel thumb. My pappy taught me how to fix just \'bout anything.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58675,'It seems that after only a few days of study, Anduin already understands the Way of the Crane.$B$BPerhaps he always has?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58676,'<The dog\'s ribs are poking out of its sides. It looks at you with pitiful eyes.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58677,'<The dog\'s fur is matted with dirt. Its breathing is shallow.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58678,'<The dog raises its head to look at you, and wags its tail weakly.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58679,'Good fortune to friend of grummles. Many thanks for aid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58680,'Woof!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58681,'The dog wags its tail happily. It heads toward your farm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58682,'Serpent, charge me with your power!','',0,0,0,0,0,0,0,0,1,0,28324,0,26124),
(58683,'Their energy is strong!','',0,0,0,0,0,0,0,0,1,0,28320,0,26124),
(58684,'No, no! Do not fail me!','',0,0,0,0,0,0,0,0,1,0,28321,0,26124),
(58685,'Your dog smiles at you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58686,'The dog wags its tail happily.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58687,'The dog tilts its head, as if wondering what you\'re thinking.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58688,'Your dog pushes its head under your hand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58689,'Your dog loves you too!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58690,'Your dog gives your face a sloppy wet lick.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58691,'Wika-Wika just trying to start a farm. Didn\'t know it would be this hard.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58692,'You here to stomp on the mook-mooks?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58693,'Look! There\'s a mook-mook right there!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58694,'More mook-mooks! Look out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58695,'Uh-oh, stingin\' bugs! Don\'t let them get near you! They bite!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58696,'Looks like the mook-mooks went away. For now. You should go talk to boss Mudclaw.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58697,'Mook-mooks?','Mook-mooks?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58698,'Click on marmots to stomp them!','Click on marmots to stomp them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(58699,'Avoid insect swarms!','Avoid insect swarms!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(58700,'These ballistas are just the advantage we needed! Now if we can just get the other one up and runnin\' we\'ll really be in business.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58701,'Take it all, stingy bugs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58702,'Stay away from my crops!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58703,'You gonna get a mouth full of pesticide!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58704,'Stay back, you ookin\' bugs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58705,'Get out of here, dookers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58706,'Yeah! Get sprayed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58707,'A vicious guard dog appears!','A vicious guard dog appears!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58708,'Need healing!','',0,0,0,0,0,0,0,0,1,15527,0,0,26124),
(58709,'I\'ll get \'em with my pesticide!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58710,'The convoy to Neverest Basecamp is leaving now! Gather around!','',0,0,0,0,0,0,0,0,1,15527,0,0,26124),
(58711,'I\'ll start gettin\' her prepped for ye to return.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58712,'','%s licks her finger and holds it up. She sniffs the air, her eyes scanning the sky.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58713,'%s tinkers with her weather instrumentation, a gleam in her eyes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58714,'','The barometer is falling fast. Time to start hauling gear!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(58715,'%s scans the sky pensively, clicking her tongue. She sniffs the air and furrows her brow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58716,'Stomp on marmots! Avoid insect swarms!','Stomp on marmots! Avoid insect swarms!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(58717,'','Happy travels, $r!$B$BThe weather may look nice now, but the skies over the Jade Forest can darken quickly with squalls. Can you feel the air changing? Perhaps you\'d like to help me brew some of my legendary Boomer Brew?',5,6,0,0,0,0,0,0,1,0,0,0,26124),
(58718,'It has been an honor to train with you.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(58719,'You have shown me I must remain diligent in my training.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(58720,'One can only grow from their defeats.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(58721,'I will be better prepared next time we meet!','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(58722,'Will you test my skills?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58723,'I must be in top fighting condition when we face the Hozen in battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58724,'Training is an ongoing process. There is always something to learn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58725,'Let\'s see what you\'ve got.','Let\'s see what you\'ve got.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58726,'Oooh, delicious juju!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58727,'[PLACEHOLDER] Teleport me to the Scenario','[PLACEHOLDER] Teleport me to the Scenario',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58728,'Chief Yip-Yip is about to charge forward! Throw a melon now!','',0,0,0,0,0,0,0,0,1,15532,0,0,26124),
(58729,'Grummles en route for Neverrest Basecamp gather round for the lighting of the traditional travel incense.','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(58730,'What\'s that? A sweet juju?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58731,'Pretty juju? Me want to eat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58732,'Fresh fruit for me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58733,'Ughhhh...boss don\'t feel so good...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58734,'Something bad in that juju...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58735,'Ughhh...bad juju make me sick!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58736,'What you put in that juju?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58737,'This may be a bit unsettling...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58738,'Ho, Yoon! Is it true? Did your plan work?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(58739,'Hey!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58740,'Is that nasty Chief Yip Yip dead?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(58741,'Nice job, Yoonie!','',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(58742,'Well I\'ll be a hozen\'s uncle...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(58743,'You know Yoon, maybe I was wrong about you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58744,'I know I\'m a stubborn old paw of the earth, but even I have to admit you\'ve done me a great deed.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(58745,'My farm was in real trouble because of those hozen, but it\'s saved thanks to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58746,'You\'ve more\'n earned my vote.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58747,'$n, this last spot\'s for you and Farmer Yoon. Why don\'t you do the honors?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(58748,'Yoon, $n, it\'s an honor to have you join us.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(58749,'Yes, it\'s true! Thanks to $n, the Kunzen\'s leader is dead. Those monkeys shouldn\'t bother Mr. Mudclaw any more.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(58750,'Oh, finally! This is my absolute dream! Yes, Mr. Mudclaw! Of course I\'ll join you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58751,'Work faster!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58752,'Ah, welcome. Are you here to buy spices? Strange, rare, exotic spices?$b$bYou\'ve come to the right place... neighbor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58753,'Can I help you, $c?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58754,'Step inside, step inside! Is there anything I can get for you today?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58755,'Hello! I\'m here on behalf of Gina Mudclaw, regarding your debt.','Hello! I\'m here on behalf of Gina Mudclaw, regarding your debt.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58756,'Stop slacking off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58757,'Absolutely. I have her payment right here. And send her my... regards.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58758,'Gina? That girl down in the marketplace? Hah!$b$bTell that pretty little thing to come collect the money personally. I\'m sure she and I can come to some sort of... agreement.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58759,'Next time I hit harder!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58760,'My debt? I owe that girl nothing.$b$bI\'m pretty sure she... GAVE me those spices. I saw her wink at me. This sort of thing happens often when you\'re as handsome as I am.$b$bAre you still here? Scurry off, little $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58761,'You pandaren are weak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58762,'We took your land and now we take your food.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58763,'<Threaten him with violence.> Do you want to get punched in the mouth?','<Threaten him with violence.> Do you want to get punched in the mouth?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58764,'Hey, hey! No need to get physical! Fine, I\'ll pay... but don\'t expect me to be happy about it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58765,'This is fun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58766,'<Offer to pay his debt for him.> Don\'t worry about it. I will pay your share today.','<Offer to pay his debt for him.> Don\'t worry about it. I will pay your share today.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58767,'No breaks, just work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58768,'That\'s more like it. Now off you go. Shoo! You\'re scaring off the real customers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58769,'This land is soft like you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58770,'Many things to sell, yes. Yak-hair amulets. Very popular. Very lucky.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58771,'I bring treasures. Treasures from far away. Treasures from beyond the mountains... treasures from beyond the wall, even.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58772,'It is a most auspicious day today, is it not?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58773,'Oh yes! The market girl! Here you are! A wise man pays his debts when an imposing-looking $c is involved.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58774,'A wise man pays his debts off immediately. A wiser man knows when he is being swindled.$b$bGina sits in the market and counts money all day. I walk the lonely roads and am lucky to make enough to scrape by. Why should I have to pay?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58775,'Gina\'s father is very, very rich. If she wants money, she can always speak with him.$b$bWhy must she bother poor old Jambeezi?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58776,'<Threaten him with violence.>\nA debt is a debt. Let\'s see the money.','<Threaten him with violence.>\nA debt is a debt. Let\'s see the money.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58777,'Now, now! Bad luck to raise your fists in the middle of town. I was just... just testing you. Here is the money I owe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58778,'<Offer to pay off his debt.>\nDon\'t worry, Jambeezi. I will pay your share today.','<Offer to pay off his debt.>\nDon\'t worry, Jambeezi. I will pay your share today.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58779,'You are as kind as you are intelligent. It is very lucky to help a stranger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58780,'','Come inside, and have a seat. Get off your feet... I\'m sure you\'ve been running around all day.$b$bNow, what can I do for you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58781,'','Pretty warm out today, isn\'t it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58782,'','Welcome to Halfhill, neighbor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58783,'','Of course you are! Thanks for coming by. Here\'s my payment.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58784,'','I wish I could pay today... but business has been so bad lately. I just don\'t have the money.$b$bThe few pieces of gold I have were going to buy dinner for my family. Please... there must be something you can do.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58785,'','I understand, I owe money. I can pay you if I need to, but...$b$bI NEED this money. Our inn is falling apart. If I don\'t have money to pay for repairs, I\'ll be out of a job... and a home.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58786,'<Threaten her with violence.> Not my problem. Pay up or face the consequences.','<Threaten her with violence.> Not my problem. Pay up or face the consequences.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58787,'','I understand. Here\'s the payment. I\'m sorry to have taken so much of your time, $gsir:ma\'am;.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58788,'<Offer to pay off her debt.> I\'ll pay your debt today. It\'s the least I can do.','<Offer to pay off her debt.> I\'ll pay your debt today. It\'s the least I can do.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58789,'','You are a good $gman:woman;, $n. This act of kindness won\'t be forgotten.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58790,'All these folks comin\' and goin\' these days. It really gets you thinkin\' about life.$b$bLike, maybe... I should be comin\' and goin\' somewhere, too.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58791,'What d\'you suppose is out there? Outside of Pandaria, I mean?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58792,'You ever just go walkin\', for no reason at all? Just to see what\'s on the other side of the hill?$b$bMa says I got busy feet and an upside-down brain to boot. But I think maybe she\'s the one that\'s got it all backwards.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58793,'I remember Gina! I bought some supplies from her, a few days back. Here\'s the money. Tell her I said hello.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58794,'Uh-oh...$b$bI probably shouldn\'t tell you, but I\'m saving up my money to leave this town. I just can\'t stand staying in one place anymore.$b$bYou\'re an adventurer... you understand. Could you help me out?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58795,'%s draws his sword and shield.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58796,'Oh... oh no. I\'m gonna be in big trouble when ma finds out about this.$b$bCould you pay my debt for me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58797,'%s drops his shield and draws a dagger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58798,'<Threaten him with violence.> You need to be taught a lesson, kid. Pay up.','<Threaten him with violence.> You need to be taught a lesson, kid. Pay up.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58799,'Whoah! You... you\'re serious about this! OK, fine... here\'s everything I\'ve got.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58800,'<Offer to pay off his debt.> I\'ll pay your debt today. Next time, try to be more responsible.','<Offer to pay off his debt.> I\'ll pay your debt today. Next time, try to be more responsible.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58801,'R-really? I won\'t forget this, $gsir:ma\'am;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58802,'We\'re free!','We\'re free!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58803,'You go on ahead. I just need to get Thunder ready and I\'ll meet you at Sunsong Ranch in a jiffy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58804,'It will take just a moment longer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58805,'Let\'s see who\'s stronger - my Thunder or that rock! My money\'s on Thunder.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58806,'Never underestimate the worth of a good mushan beast.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58807,'One word: Incense!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(58808,'Do you have healing incense?','Do you have healing incense?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58809,'Do you have enraging incense?','Do you have enraging incense?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58810,'Don\'t get caught in Big Bessa\'s sights.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58811,'Avoid or destroy Baldruc\'s Storm Totems.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58812,'','Winning any battle is just as much about understanding your opponent, as it is knowing how to fight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58813,'What can I do to help?','What can I do to help?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58814,'%s is dismounted from his gryphon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58815,'<Jogu squints at you.>$B$BHey, do I know you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58816,'Heeey buddy! Nice to see you again!$B$BBuuuuuuuuuuuuuuurrrrpppp!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58817,'My friend come to visit Jogu again? What can I do for you today?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58818,'You are a good friend, $n. Maybe my only friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58819,'Hey $Gbrother:sister;! You come to ask Jogu for wishdom?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58820,'','Hey there. Back to the market, I see.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58821,'','Well, what\'s it gonna be? I\'ve got a market to run.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58822,'','You\'ve come to the right place! Halfhill Market\'s got everything you need.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58823,'','Hey you, you\'re new in town. Got any good gossip from faraway?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58824,'','You here to buy or sell? Feel free to look around.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58825,'','Hey, $r. Welcome back.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58826,'','Well, what\'s it gonna be, buddy? I\'ve got a market to run.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58827,'','You\'ve come to the right place, buddy! Halfhill Market\'s got everything you need.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58828,'','Hey buddy! You got any good gossip for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58829,'','Hey buddy, you here to buy or sell? Feel free to look around.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58830,'','Hey, $n. Halfhill Market welcomes you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58831,'','Well, what\'s it gonna be, friend? I\'ve got a market to run.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58832,'','You\'ve come to the right place, friend! Halfhill Market\'s got everything you need.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58833,'','Hey friend! You got any good gossip for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58834,'','Hey friend, you here to buy or sell? Feel free to look around.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58835,'','Hey, $n. Any friend of mine is always welcome here at Halfhill Market.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58836,'','Well, what\'s it gonna be, my good friend? I\'ve got a market to run.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58837,'','You\'ve come to the right place, my good friend! Halfhill Market\'s got everything you need.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58838,'','Well lookee here, it\'s my good friend $n. You know what I want? Uh-huh, that\'s right. Got any gossip?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58839,'','My good friend $n! Are you here to buy or sell? Feel free to look around.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58840,'','Hey, $n. Welcome, neighbor!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58841,'','Well, what\'s it gonna be, neighbor? I\'ve got a market to run.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58842,'','You\'ve come to the right place, neighbor! Halfhill Market\'s got everything you need.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58843,'','Hey there, neighbor $n. Give me some gossip, already!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58844,'','Howdy, neighbor! Are you here to buy or sell? Feel free to look around.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58845,'','Hey stranger, do I know you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58846,'','I don\'t recognize your face. You must be new in town.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58847,'','I know just about everyone in these parts. I\'ll let them know there\'s a new face in town.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58848,'','Oh, you\'re not from around here. Are you a citypaw? Tell me, how do you like my dress?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58849,'','Hi there. We\'ve met before, haven\'t we?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58850,'','Oh, what a nice outfit you have there. I hadn\'t noticed before.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58851,'','Folks \'round here have been talking about you. Don\'t worry, I put in a good word now and then.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58852,'','Do you like this color on me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58853,'','Hi buddy! Fancy seeing you again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58854,'','Those shoes match your eyes real nice.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58855,'','Folks \'round here have been talking about you, buddy. Don\'t worry, I put in a good word now and then.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58856,'','Hi buddy! Please tell me... do you like my earrings?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58857,'','Hello, friend. Are you getting on all right at your farm?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58858,'','Now that we are friends, I must tell you that your outfit is... hideous.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58859,'','Folks \'round here have been talking about you, friend! They do seem to fancy you quite a lot.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58860,'','Please, as a favor to a friend... tell me the truth about my outfit. Is it... awful?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58861,'','Now that we\'re friends, I have a confession to make. I... I think I quite fancy Farmer Fung.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58862,'','Don\'t you think that Farmer Fung is just... dreamy?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58863,'','$n, my good friend! I hope everything is going well for you and Mr. Yoon at the farm.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58864,'','Now that we are good friends, I must tell you that your outfit is... atrocious.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58865,'','Folks \'round here have been talking about you, $n! You\'re making quite a stir around here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58866,'','Please, as a favor to a good friend... tell me the truth about my outfit. Is it... horrible?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58867,'','Now that we\'re good friends, I have a confession to make. I... I think I quite fancy Farmer Fung. But then again, Farmer Yoon has nice eyes, don\'t you think?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58868,'','Howdy, neighbor! I hope everything is going well for you and Mr. Yoon at the farm.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58869,'','Now that we are besties, I must tell you that your outfit is... just to die for!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58870,'','Folks \'round here have been talking about you, $n! I\'ve been telling everyone that you\'re my neighbor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58871,'','Please, as a favor to your best friend... tell me the truth about my outfit. How is it?$B$BOh? Wonderful you say? Why thank you! This is why you\'re my friend for life!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58872,'','Now that we\'re best friends, I have a confession to make. I... I think I quite fancy Farmer Fung. But then again, Farmer Yoon has nice eyes, don\'t you think?$B$BOh, I just can\'t decide!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58873,'Thank you!','Thank you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58874,'Quick, let\'s get out of here.','Quick, let\'s get out of here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58875,'Death to the yaungol!','Death to the yaungol!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58876,'Our hero!','Our hero!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58877,'We\'re saved!','We\'re saved!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58878,'Let\'s go to Binan Village.','Let\'s go to Binan Village.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58879,'Good riddance.','Good riddance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58880,'Hey lookee, it\'s the new $Gguy:gal; in town.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58881,'You know anything \'bout yaks, rookie? Well I know a lot about \'em.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58882,'You know who\'s got the biggest vegetables in the Valley? You\'re lookin\' at him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58883,'Hey buddy, what\'s happening?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58884,'Hey buddy, feel free to come admire my yaks anytime.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58885,'Hey $r, buddy to buddy, I\'ll let you in on a secret. You want big vegetables? You gotta use fertilizer.$B$BAnd you know who\'s got the best fertilizer in the Valley? Me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58886,'Hey friend, what\'s happening?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58887,'Hey friend, feel free to come admire my yaks anytime.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58888,'Hey friend, here\'s a tip. You want big vegetables? You gotta use fertilizer.$B$BAnd you know who\'s got the best fertilizer in the Valley? Me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58889,'My good friend! How are things at the farm?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58890,'My good friend, how are you today?$B$BListen, I don\'t say this to just anyone, but if you ever need a yak, you let Fung know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58891,'My good friend, here\'s a tip. You want big vegetables?$B$BYou gotta tend them. Give them some water, some fertilizer, and some love.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58892,'Hey neighbor! Things going well at the farm?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58893,'Hey neighbor, how are you today?$B$BHow\'s Shaggy doing?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58894,'Hey neighbor! Those vegetables are looking good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58895,'','Hey there! Have I seen yer face before?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58896,'','Hey there! Ain\'t seen a face like yours \'round here before.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58897,'','Hey there, citypaw! You heard o\' any good stories that you can share? I love tellin\' stories!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58898,'','Hey, have you heard the story \'bout Old Man Thistle? That\'s a good story if I ever heard \'un.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58899,'','Hey, why\'s your name $n? Isn\'t that a weird name?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58900,'','Folk \'round here are mighty good... if you stick \'round long enough to find out.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58901,'','My papa always told me that fish swim \'n birds fly. Now if I can swim AND fly, what does that make me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58902,'','Hey buddy! Mighty nice seein\' you again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58903,'','Hey there, buddy! I loved that story \'bout that boy Arthas. You got any others to share?',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(58904,'','Hey there, buddy! I loved that story \'bout that orc Thrall. You got any others to share?',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(58905,'','Old Man Thistle owned a little plot o\' land just o\'er there on that hill.$B$BNow one day he was diggin\' and diggin\', and he dug so far down he didn\'t do but found a whole cave underneath these them hills!$B$BAnd what do you suppose he found in that cave?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58906,'','Whaddaya mean Fish is a weird name, too? It ain\'t weird at all, buddy! I was named after dem fishes in the lake!$B$BNow just now what\'s a \"$n,\" eh? I ask ya that!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58907,'','My papa always told me to make friends \'stead o\' enemies. That\'s why ye\'re my buddy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58908,'','Hey friend! Mighty nice seein\' you again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58909,'','Hey there, friend! Tell me again that story \'bout the world tree and the... whatcha callit... the sunderin\'!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58910,'You found...','You found...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58911,'','Old Man Thistle found a cave full o\' TREASURE!!!!$B$BThere was gold \'n diamonds \'n jade \'n statues \'n a whole room full o\' books!$B$BWell he wandered \'round that cave \'n before long a whole day had passed \'n he was gettin\' mighty hungry.$B$BSo he heads back toward the way he came and what happened but he couldn\'t find no way back out agin\'!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58912,'A Lost Hen! Bring her back to a chicken coop.','A Lost Hen! Bring her back to a chicken coop.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58913,'An Amorous Rooster! Dip him in the water to cool his passions.','An Amorous Rooster! Dip him in the water to cool his passions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58914,'A Wild Prairie Chicken! Kick him out of here!','A Wild Prairie Chicken! Kick him out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58915,'A Marmot Disguised in Chicken Feathers! Expose him for the sham he really is!','A Marmot Disguised in Chicken Feathers! Expose him for the sham he really is!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58916,'Old Hillpaw\'s prize-winning chicken, Mother Clucks!','Old Hillpaw\'s prize-winning chicken, Mother Clucks!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58917,'','Now that we\'re friends, you can call me Fish.$B$BHa ha! I\'m so funny!$B$BI\'m jus\' kidding... everyone calls me Fish! That\'s cuz everyone\'s my friend!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58918,'Old Hillpaw\'s prize-winning chicken, Madam Specklybottom!','Old Hillpaw\'s prize-winning chicken, Madam Specklybottom!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58919,'Old Hillpaw\'s prize-winning chicken, Thunderpeck!','Old Hillpaw\'s prize-winning chicken, Thunderpeck!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58920,'Old Hillpaw\'s prize-winning chicken, Mantidsbane!','Old Hillpaw\'s prize-winning chicken, Mantidsbane!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58921,'','My papa always told me that friends are worth more than sweet turnips. That\'s why yer my friend, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58922,'Old Hillpaw\'s prize-winning chicken, Rumblefeather!','Old Hillpaw\'s prize-winning chicken, Rumblefeather!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58923,'Old Hillpaw\'s prize-winning chicken, Egga!','Old Hillpaw\'s prize-winning chicken, Egga!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58924,'','Howdy, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58925,'Old Hillpaw\'s prize-winning chicken, Stumbleflutter!','Old Hillpaw\'s prize-winning chicken, Stumbleflutter!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58926,'Old Hillpaw\'s prize-winning chicken, Buck-Bucka Betty!','Old Hillpaw\'s prize-winning chicken, Buck-Bucka Betty!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58927,'','Hey there, my good friend! Tell me again that story \'bout that scary dragon, Deathwing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58928,'','So Old Man Thistle\'s stuck down the cave, so what does he do but whistle fer his trusty mushan, Bobo!$B$BAnd right fore long, he hears a boomin\' noise, and Bobo busts a hole right in that cave!$B$BThat mushan done hear his master and come fer him!$B$BAnd then, what happens but the whole cave starts a shakin\' and the ceiling starts crashing down.$B$BSo Old Man Thistle jumps on Bobo\'s back and you know what happened\' then?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58929,'','Yeh know my good friend, I seen a lot o\' funny names in my time. Fish really ain\'t that strange. No, it\'s downright normal!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58930,'','My papa always told me that good friends are worth more than a chipper carrot. That\'s why yer my good friend, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58931,'','Howdy, neighbor! Whatcha doin\' today?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58932,'','Hey there, neighbor! I love stories so much, I just wanna hear \'em all!$B$BBut ya know, I think we\'ve made some good stories together too, dontcha think?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58933,'','So the cave\'s a crashing down, and Old Man Thistle and Bobo run as fast as they can! They twist and turn through the caves, til they burst outta the ground right up that hill!$B$BAnd what happened then but the cave closed up right behind \'em, like it got swallowed by the earth.$B$BOld Man Thistle\'s shaking, but first thing he does when he gets home is make a map to that cave full o\' treasure. Cuz maybe it\'s still there, true?$B$BGood thing he did, cuz the next day, he couldn\'t remember as well, and the day after that he remembered even less, till he plumb forgot \'bout that cave altogether.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58934,'','Hey neighbor, what\'re we talkin\' bout anyway? Ain\'t nothing in a name!$B$BLike my papa always said, ye\'d still eat a pink melon if it were called an onion, right?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58935,'','My papa always told me that neighbors are worth more than earth. Now that\'s sayin\' something!$B$BThat\'s why yer my neighbor, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58936,'','I take care o\' the pigs \'round here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58937,'','Hey buddy! The pigs are doin\' jus\' fine today!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58938,'','Howdy, friend! You gone down and seen my pigs yet?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58939,'','Howdy, my good friend! Now why my mama and papa didn\'t name me Pig, I jus\' don\'t know.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58940,'','Hey neighbor! How\'re those pigs doin\' at yer farm? I bet they\'re mighty happy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58941,'You new here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58942,'Hey, Chee Chee real busy. You got some-ting you want?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58943,'Chee Chee\'s sheep sheep are so scared... bad monkeys on hill! Bad monkey!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58944,'Yo, I know you before. You help me, yes?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58945,'Chee Chee got big problem. Big, big problems.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58946,'Chee Chee work hard for farm. Now bad monkeys come take away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58947,'Hey. You are Chee Chee\'s buddy, yes?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58948,'Chee Chee got big problem. Big, big problems. Buddy help Chee Chee?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58949,'Chee Chee work hard for farm. Buddy understand, right?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58950,'Hey friend. I got problems, but no need to be your problems, too.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58951,'Hey friend, how is things going on your farm?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58952,'Chee Chee is only hozen with own farm!$B$B<Chee Chee thumps his chest proudly.>$B$BYou, friend, come visit me at my farm sometime, okay?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58953,'My good friend! You drink with Chee Chee sometime, yes?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58954,'Good friend, is things going good for you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58955,'Chee Chee raise only sheep in the fields!$B$BAnyone want sheep, they come to Chee Chee.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58956,'Hey neighbor! You like the sheep?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58957,'Neighbor, because of you, my problems is less somewhat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58958,'I give only nice sheep for you, neighbor! What do you think?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58959,'','Oh! Hi! Um... I should probably... go...$B$B<Ella blushes as her voice lowers to a whisper.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58960,'','Do you like... turnips?$B$B<Ella turns pink and shakes her head.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58961,'','Do you like kitties? I love them!$B$B<Ella looks surprised at her sudden outburst and smiles shyly.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58962,'','Hey there, $n. How are you today?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58963,'','I grow turnips at my family farm. Oh... I don\'t know if you wanted to know that...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58964,'','I don\'t have that many cats, right? I mean, it\'s quite reasonable when you think about it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58965,'','Hey there, friend! Isn\'t it a lovely day?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58966,'','Did you know that turnips make quite a tasty brew?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58967,'','The cats keep me company. It\'s been quite lonesome on the farm since my parents passed...$B$BOh no, I didn\'t mean to tell you so much.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58968,'','Hello, good friend. Oh, is it okay if I call you my good friend?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58969,'','I\'ve been experimenting with all sorts of brews in my spare time.$B$BWith the Stormstout brewery right across the way, I can\'t help but get inspired sometimes.$B$BOh, but these aren\'t anywhere as good as what they make over there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58970,'','How many cats do I have?$B$BOh, ummm... I think I may have lost track...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58971,'','Howdy, neighbor! The turnips are looking mighty fine this morning.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58972,'','So I\'ve been sharing some of my brews around town, and everyone is raving! I can hardly believe it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58973,'','How is Luna doing? She\'s such a sweet cat!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58974,'The convoy to Kota Basecamp is leaving now! Gather around!','',0,0,0,0,0,0,0,0,1,15527,0,0,26124),
(58975,'Got trouble in the fields. Whether it\'s virmen or hozen, I tell ya, it ain\'t good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58976,'Yeah, I am the head of the Tiller\'s Union. Why do you ask?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58977,'Sure the fields here are prosperous, but that\'s on account of hard, back-breaking work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58978,'Hey buddy, you got any experience dealing with hozen or virmen?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58979,'Buddy, did you know that every farmer worth his dirt is a member of the Tiller\'s Union?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58980,'Hey, if it isn\'t my buddy $n! I\'ve just come from a long day in the fields.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58981,'Hey friend, you got any experience dealing with hozen or virmen?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58982,'Hey friend, how\'s the soil looking today?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58983,'My friend, $n! Let us share a drink together.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58984,'My good friend, you must know a thing or two about exterminating virmen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58985,'You know, good friends always share their farming secrets. Now tell me, how do you get your vegetables looking like that?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58986,'A long day in the fields makes a man thirsty, you know what I mean, good friend?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58987,'Hey neighbor, how is that mushan beast working out for you? She\'s quite a beauty, ain\'t she?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58988,'Now that we\'re neighbors, you have to tell me your farming secrets. Do you use fertilizer? Growth spray? Weedkiller? Tell me, already!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58989,'Howdy, neighbor. Would you like a cold brew?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58990,'Thank you, traveler. I think I can make it now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58991,'I ain\'t got time for no strangers. Now please leave me be.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58992,'Can\'t you see I\'m busy? Got things I\'m working at, stranger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58993,'YOU HAVE WON THE SCENARIO. HOORAY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58994,'Bah! Leave an old man be!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58995,'You have my gratitude. I should return back to training now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58996,'Humph. I\'m busy, can\'t you see?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58997,'Do ye pester everyone this much? Sheesh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58998,'Pah! I know I seen you around, but that don\'t make us friends. Go away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(58999,'A simple flesh wound won\'t keep me from the battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59000,'Hey buddy, I\'m busy here. Can\'t ye come back later?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59001,'Buddy, ye sure got a big mouth. Does it ever stop yappin\'?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59002,'Buddy, ye know... sometimes it\'s nice to see you around.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59003,'Hey friend, I\'m a little busy here. Ye got something ya need?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59004,'Friend, you sure do run your mouth when you get a chance. But it\'s kinda nice to hear somethin\' other than silence now and again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59005,'I got three sick chickens and another two hens not layin\'. I got too many problems to listen to yours, citypaw.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59006,'Hey buddy. I got two chickens gone missin\' last night. Bet it was them hozen that\'re behind it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59007,'Howdy, friend. You ever tried a fresh egg from one o\' my chickens? Dee-licious, I tell ya.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59008,'Hey friend, thanks for visiting today.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59009,'Hey, it\'s my good friend $n! Anything I can do fer ya?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59010,'My good friend, you got any news for me today?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59011,'Ye know, $n, I gotta admit I look forward to your visits now and again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59012,'Hey $n, I been thinkin\' that your farm needs some chickens. What do you think?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59013,'Howdy, neighbor. Nice day today.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59014,'Hey, neighbor! Fields are lookin\' like a shiny new copper today.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59015,'Howdy, neighbor! Good to see ya! You come visit me any time, you hear?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59016,'Well, $n? How are those chickens doing?$B$BMake sure to look around for their eggs. Those darned things hide them in the weirdest places!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59017,'','Quiet, stranger. I need complete focus for the task at hand.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59018,'','I have no quarrel with you, stranger.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59019,'','Only in silence will we hear the trees speaking.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59020,'','Quiet, $r. Please do not break my concentration.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59021,'','I have seen you in these parts before. I can see that you are a $c, from the look of you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59022,'','One gains little wisdom from speaking. One gains much wisdom from listening.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59023,'','Hey buddy, you are making enough noise to scare off a pack of mushan beasts.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59024,'','Do not tell me what it is like to be a $c. Show me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59025,'','I am studying the hozen\'s movements. When I find their weakness, I will strike.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59026,'','My friend, you are making enough noise to scare off a pack of mushan beasts.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59027,'','My friend, one of these days we should see who is stronger in battle - you, or me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59028,'','A wise man does not rush into war. A wise man wins a war.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59029,'','My good friend, you are making enough noise to scare off a pack of mushan beasts.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59030,'','My good friend, one of these days we should see who is stronger in battle - you, or me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59031,'','In my home town, the greatest gift one could give to a good friend was a tree.$B$BDo you know why?$B$BA tree represents peace, growth, and life. It is a blessing of friendship.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59032,'','Neighbor, you move quietly today.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59033,'','Neighbor, I would gladly fight alongside you any day.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59034,'','Do you like your tree? I picked the sapling myself.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59035,'','Hey friend, you know the secret to a good market? Distribution. You need a way to move your goods to the people who want \'em.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59036,'','You know what I been thinking, my good friend? You need a way to keep up with all your friends at home.$B$BI know a carpenter who can come by an install your own mailbox. How\'s that for an idea?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59037,'','How\'s that mailbox workin\' for ya? Good idea, right?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59038,'','Hey friend, don\'t you think that Farmer Yoon\'s house is looking mighty empty?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59039,'','I know a thing or two about decorating, my good friend. I know just what Farmer Yoon needs for his house!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59040,'','Hey neighbor! How do you like the new furnishings in Farmer Yoon\'s house? Yes, I picked them out myself!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59041,'Chee Chee love to eat Valley Stir Fry. You find any, you bring to me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59042,'','Any assistance getting the wounded back on their feet would be appreciated.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59043,'Chee Chee like to look at sky. So pretty... so blue...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59044,'','Oh, gifts? I hope you\'re not thinking of getting me anything!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59045,'','Well you know me... I like cats!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59046,'','Now that you mention it... my mother used to make the best Shrimp Dumplings.$B$BSigh... I miss her...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59047,'Well you know the only thing that I admire as much as my own looks is a rare white flower that grows around these parts.$B$BIt\'s terribly hard to find, though.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59048,'You ever tried Wildfowl Roast?$B$BMmm! What would I give for a taste of that right now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59049,'','Well I jus\' about like everythin\', but I do like animals the best!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59050,'','Being resourceful can often sway a battle in your favor.$b$bI\'ve put together this remedy using plants from the forest around us. Hopefully it will be enough. We need every available fighter in the field.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59051,'','You know, I\'ve always like the color of jade. So green, just like the forest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59052,'','What a silly question! I\'ll give you a hint. My favorite food has my name in it! Maybe more than once!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59053,'','Oh you shouldn\'t! Oh, but I do love gifts, so maybe you should.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59054,'','I like anything pretty or shiny.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59055,'','Oh you know me. I\'m a humble girl, so I\'d only ask for rubies.$B$BWhat? It\'s not like I\'m asking for diamonds!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59056,'','Well, recently I\'ve had quite the craving for Fire Spirit Salmon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59057,'Well I won\'t lie to you, $n. I\'m one of the most powerful men in the Valley. Most people send me gifts of great value.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59058,'I\'ll tell you one thing, $n. I like jade, but it\'s not my favorite. Everyone gives it to me, all the time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59059,'Now that you mention it, I\'ve been craving Charbroiled Tiger Steak for a while! We don\'t get many tigers down in the valley, so the dish is hard to find.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59060,'No, an old man like me doesn\'t need anything. But my son... now he loved collecting blue feathers...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59061,'When my son found a blue feather, he used to say that it was a kiss from his mother, up in the sky.$B$B<Old Hillpaw pauses, too choked up to continue.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59062,'My wife used to make a mean dish of braised turtle. The taste of that dish sure would bring back memories.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59063,'','I like things that come from nature.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59064,'','A girl in my line of work gets hungry, you know? I wish I had something delicious to eat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59065,'','Flowers are nice, but they aren\'t  my favorite.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59066,'','I\'m scared of birds! Their feathers can be quite pretty, but they aren\'t my favorite.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59067,'','Have you ever tried Eternal Blossom Fish? It\'s my favorite food.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59068,'','This is just lovely, thank you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59069,'See if the new recruits are up to a challenge. They could use a lesson in advanced combat.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59070,'','Oh, why... thank you... you shouldn\'t have...!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59071,'Stir fry! Thanks boss!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59072,'Ooh, Chee Chee is hungry. Thanks!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59073,'Ooh, pretty pretty! So blue... so soft... thanks!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59074,'Very nice, yes yes... a good gift for Chee Chee. Thank you!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59075,'Hey, this is a real nice gift. Thanks, $n!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59076,'You must be my secret admirer! Well, not so secret anymore. Thanks!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59077,'You found a Marsh Lily? These are my favorite. Thanks!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59078,'Is this roast for me? Wow, thanks!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59079,'Nice timing. I was just getting hungry.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59080,'','Did you make this Twin Fish Platter yourself?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59081,'','Oh my, this Twin Fish Platter smells delicious. Thank you!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59082,'','Let\'s see what the Hozen have in store for us in combat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59083,'','Oh yes, this is my favorite food - fish!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59084,'','This is a very pretty cat, $n. Thanks fer givin\' it to me.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59085,'','Oh wow, yer givin\' that to me? I don\'t know how to thank ya!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59086,'','You givin\' me a gift? Aw shucks, you shouldn\'t have!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59087,'What\'sh this? Oh, whatever it ish, it\'sh nice... hic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59088,'','Why $n! Did you bring me some Swirling Mist Soup? Did you know that I love this stuff?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59089,'','Oh, what a breathtaking flower. You know these are supposed to be lucky?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59090,'','Oh my, you got me something? Why how can I ever thank you?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59091,'','Oh look at you, giving little old Gina such a lovely gift. Thank you!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59092,'','This Fire Spirit Salmon looks delicious. I do hope you made it yourself.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59093,'','Oooh, I can\'t wait to try this Fire Spirit Salmon.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59094,'','Why you sure know how to impress a lady! Ain\'t no diamond, but I love it anyway!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59095,'','This ruby will look wonderful with this dress, don\'t you think?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59096,'','How lovely of you to think of me.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59097,'','You are such a nice $Gguy:gal; $n. Thank you for this lovely present.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59098,'Oh yes, this ruby looks quite valuable. Thanks, $n!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59099,'It\'s been too long since I last tasted Charbroiled Tiger Steak.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59100,'I could eat twenty plates of Charbroiled Tiger Steak and still be looking for more. Thanks, $n.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59101,'Well, isn\'t this the nicest gift I\'ve gotten today!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59102,'For me? That\'s mighty nice of you, $n.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59103,'This feather... brings back so many memories. Thank you, $n.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59104,'It\'s just like the way my wife used to make it. Thanks!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59105,'Just what an hungry old man needs. Thanks.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59106,'Fer me? Thanks.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59107,'That\'s... nice o\' ya. Thanks.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59108,'','Thanks for the apple, $r.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59109,'','Hey, just what I needed. Thanks a lot.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59110,'','Been a while since I had a taste of this dish. This\'ll hit the spot.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59111,'','Feels good to look forward to a hot meal.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59112,'','Huh. I suppose now I have to say thank you.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59113,'','Focus on the fires. No - wait - get the saurok! Just ... do something!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(59114,'','I\'m not leaving until those brewkegs finish their work.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(59115,'','Stupid lizards.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(59116,'','Maybe this will help...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59117,'','Stay on your toes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59118,'','I\'ve got you...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59119,'','Don\'t you die on me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59120,'Together we can reclaim the temple and restore hope for the people here. It\'s my honor to accompany you in this task.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59121,'ALL THE 7TH FLEET SHIPS BLOW UP. KABOOOM! THE GUNSHIP COMES IN OVER THE HARBOR.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59122,'We cannot escape!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59123,'Slurp. YUM!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59124,'Cooking all of the things.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59125,'Hmm... maybe a pinch of pandaren?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59127,'This stew needs salt. And people meatballs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59129,'Bork, bork, bork!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59130,'Furdy furdy fur.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59131,'Too much roots! Not enough meats!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59132,'Kill that wascally wirmen and bring it for the stew!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59133,'Hmm, did you hear something lads?','',0,0,0,0,0,0,0,0,1,0,27549,0,26124),
(59134,'Mmm! Some $r for the stew!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59135,'What? No, no! Stop!  Obey your master!','',0,0,0,0,0,0,0,0,1,0,27545,0,26124),
(59136,'Arrggghhhhh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59137,'%s obeys its master and attacks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59138,'Chef, could you grill this plainshawk leg for me?','Chef, could you grill this plainshawk leg for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59139,'Chef... if I brought you a plainshawk leg, could you grill it for me?','Chef... if I brought you a plainshawk leg, could you grill it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59140,'Sure thing, $n! Enjoy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59141,'Certainly. If you brought me some meat - which you have not - then I would be able to grill it for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59142,'I\'ve got all this fruit here. Could you brew up some hooch for me?','I\'ve got all this fruit here. Could you brew up some hooch for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59143,'What ingredients do you need to make Apple-Berry hooch?','What ingredients do you need to make Apple-Berry hooch?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59144,'Any time, neighbor. Any time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59145,'We\'ll need at least 8 apples. And a few handfuls of craneberries - 50 should do it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59146,'Brew here!','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(59147,'','Meet me up in the cave if you would, friend.',0,0,0,0,0,0,396,0,1,0,0,27397,26124),
(59148,'Hey Jogu, what\'s the word on tomorrow\'s crops?','Hey Jogu, what\'s the word on tomorrow\'s crops?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59149,'Ughhhh... my head is hazy... try again later.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59150,'Oooh... ooooh! My shenses are tingling! I see... huge Green Cabbages in your future.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59151,'You ever heard of a juishycrunch carrot? They\'ll never be juisher than tomorrow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59152,'Have I ever told you that I hate Scallions? Hate \'em!$B$B<Jogu lets out a loud belch.>$B$BUnfortunately for me, they\'re going to be in high season tomorrow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59153,'Pumpkins! It\'sh gonna be huge, gigantic pumpkins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59154,'Shpring for a leek, and you might get two.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59155,'I\'m seeing Pink Turnipsh in your future.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59156,'Fields of white turnips. Raw and shpicy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59157,'Which berries should you plant? Witchberries, of course!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59158,'Jade Squash grow the color of milky jade. Conditionsh will be perfect tomorrow for growing thish vegetable... I think.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59159,'Striped melons are quite juishy this time of year! Put some sheeds in the ground, and you will reap the harvest on the morrow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59160,'Looking for meat? I\'ve got plenty right here.$b$bOn my grill, I mean.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59161,'','Keep those creatures at bay while I meditate. We\'ll soon have the answers we seek.',0,0,0,0,0,0,0,0,1,0,0,27398,26124),
(59162,'<The crane does not speak, but his words fill your mind.>$B$BGo... while you can...$B$BAll is... lost.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59163,'<Reach out to touch Chi-Ji.>','<Reach out to touch Chi-Ji.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59166,'You pull the bell on the shrine. Ask it a question or make a wish!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59167,'Chee Chee is a hozen sheep-herder who works on the terrace to the west.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59168,'You and Ella are acquaintances.','You and Ella are acquaintances.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59169,'Somehow, you and Farmer Fung have become acquaintances.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59170,'You are acquaintances with Fish.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59171,'You and Gina are acquaintances.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59172,'You and Haohan are acquaintances.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59173,'You and Old Hillpaw are acquaintances.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59174,'You and Sho are acquaintances.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59175,'You and Tina are acquaintances.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59176,'You and Jogu the Drunk are acquaintances.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59177,'How is my relationship with Chee Chee?','How is my relationship with Chee Chee?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59178,'How is my relationship with Ella?','How is my relationship with Ella?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59179,'How is my relationship with Fish Fellreed?','How is my relationship with Fish Fellreed?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59180,'How is my relationship with Farmer Fung?','How is my relationship with Farmer Fung?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59181,'How is my relationship with Gina Mudclaw?','How is my relationship with Gina Mudclaw?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59182,'How is my relationship with Jogu the Drunk?','How is my relationship with Jogu the Drunk?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59183,'How is my relationship with Haohan Mudclaw?','How is my relationship with Haohan Mudclaw?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59184,'How is my relationship with Old Hillpaw?','How is my relationship with Old Hillpaw?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59185,'How is my relationship with Sho?','How is my relationship with Sho?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59186,'How is my relationship with Tina Mudclaw?','How is my relationship with Tina Mudclaw?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59187,'When man asks favor of a fish...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(59188,'\'Tis hard to decipher his true wish...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(59189,'He often seeks a lordly dish...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(59190,'To serve upon his table.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(59192,'Hey Chee Chee, would you like to be my farm hand?','Hey Chee Chee, would you like to be my farm hand?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59193,'Hi Ella, would you like to join me and Farmer Yoon at his farm?','Hi Ella, would you like to join me and Farmer Yoon at his farm?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59194,'Hey Fish, how\'d you like to be my partner at the farm?','Hey Fish, how\'d you like to be my partner at the farm?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59195,'Howdy, Farmer Fung. Farmer Yoon and I really need you at our farm.','Howdy, Farmer Fung. Farmer Yoon and I really need you at our farm.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59196,'Gina, how\'d you like to help us run the farm?','Gina, how\'d you like to help us run the farm?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59197,'Mr. Mudclaw, would you lend us a hand at Sunsong Ranch?','Mr. Mudclaw, would you lend us a hand at Sunsong Ranch?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59198,'Hey Jogu, how\'d you like to move into the pond at Sunsong Ranch?','Hey Jogu, how\'d you like to move into the pond at Sunsong Ranch?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59199,'Howdy Old Hillpaw. How\'d you like to keep me company at my farm?','Howdy Old Hillpaw. How\'d you like to keep me company at my farm?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59200,'Hey Sho, take a break and come watch my farm for a while.','Hey Sho, take a break and come watch my farm for a while.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59201,'Hey Tina, I hear Farmer Yoon needs some help at his farm. Would you... ?','Hey Tina, I hear Farmer Yoon needs some help at his farm. Would you... ?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59202,'Okay, boss! Chee Chee got stuff to do, then he be there soon.','',0,0,0,0,0,0,0,0,1,17634,0,0,26124),
(59203,'','Sure, I suppose I could help out for a bit! I\'ll meet you there in a bit.',0,0,0,0,0,0,0,0,1,17637,0,0,26124),
(59204,'','My papa always did say to help out a neighbor in need! I\'ve just gotta take care of some stuff, then I\'ll be there in a jiffy!',0,0,0,0,0,0,0,0,1,17636,0,0,26124),
(59205,'I was wonderin\' when you would ask. Sure thing. Let me take care of some things and I\'ll be right on over.','',0,0,0,0,0,0,0,0,1,15673,0,0,26124),
(59206,'','Well all right, I s\'pose I could hop on over to the farm now and again. I\'m only doing this for you, y\'hear? And well... I s\'pose I have taken quite a shine to Mr. Yoon...',0,0,0,0,0,0,0,0,1,17632,0,0,26124),
(59207,'Really? That whole pond, just for me? I\'ll be right there!','',0,0,0,0,0,0,0,0,1,17631,0,0,26124),
(59208,'I suppose I could leave things to Mung-Mung for a while and take a gander at Yoon\'s. He does have the best soil in the entire valley! Let me just get my things in order, first.','',0,0,0,0,0,0,0,0,1,15675,0,0,26124),
(59209,'Well I s\'pose the chickens won\'t mind if I visit fer a bit. I\'ll meet ya there later.','',0,0,0,0,0,0,0,0,1,15674,0,0,26124),
(59210,'','Sunsong Ranch needs my help? Let me gather my equipment, and I\'ll meet you there.',0,0,0,0,0,0,0,0,1,17635,0,0,26124),
(59211,'','It\'s about time you asked! I was wondering when Farmer Yoon would ever notice me. You go ahead, and I\'ll be there soon.',0,0,0,0,0,0,0,0,1,17633,0,0,26124),
(59212,'Hey boss, me been thinkin\'. You been real good to Chee Chee, so I wanted to give you a sheep for your farm. It should be waiting already. You take good care of Chee Chee\'s sheeps, okay?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59213,'','Hey, wait just a minute... I... well... you\'ve been such a good friend and... I want to give you my favorite kitty, Luna! I don\'t want you to be lonely at your farm and...<sob>... just take good care of her, okay? I\'ll bring her by later.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59214,'','Well now that you and me are neighbors, I can tell you the truth. It\'s just downright wrong not ta have a proper pig or two on your farm! I\'ll bring some by when yer not lookin\' and then blammo! You\'ll have pigs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59215,'Now that we\'re neighbors, I\'ve decided to give you the best gift a neighbor can just about give to anybody! I\'m going to give you one of my prized yaks! I\'ll swing on by later and leave \'er in your pen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59216,'','You and me, we\'re proper neighbors now, not just in the geographical sense. You done so much for me, I think it\'s time I helped you out a bit. I called in a few favors and had them install your own postbox right on your farm. Now you can keep in touch with all your friends!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59217,'I wasn\'t too sure \'bout you when you first came to the valley, but now I can proudly call you my neighbor. As a token of my friendship, I\'d like to give ye a big something for yer farm. She should be there already. Name\'s Miss Fifi, and she likes to eat turnips!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59218,'You know, you\'ve been a real nice friend to me for a while now. Now that we\'re neighbors, I\'m going to give you some of my chickens. Ain\'t too much, but they should liven up yer farm a bit. I\'ll send \'em over.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59219,'','Wait a minute. I\'ve been thinking... you\'ve done so much for me, it\'s about time I gave you a little something in return. Where I\'m from, we grow beautiful orange trees. I planted one on your farm. From the way things grow around here, I wouldn\'t be surprised if it had already bloomed by the time you got back to your farm.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59220,'','Oh $n, as your best friend, I\'d really like to give you something. I thought your farm could use a little sprucing up, so I had some folks install some new furniture in your house. I hope you like it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59221,'Can I hire someone to help me on my farm?','Can I hire someone to help me on my farm?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59223,'Only the best of friends will do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59224,'Hey boss, your sheeps is lookin\' pretty good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59225,'','Oh... why, hello $n! Your farm is looking very pretty today.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59226,'','Howdy, neighbor! Your pigs be lookin\' mighty fine!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59227,'I have to say, $n, your garden looks great! Of course, I have been weeding all day...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59228,'','Farmer Yoon is just a dear! I keep telling him what to do, and he goes on and does it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59229,'This pond sure is nice, neighbor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59230,'Not bad, not bad! If I do say so myself, your farm is running smoothly. Maybe one day you\'ll be as successful as Haohan Mudclaw!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59231,'Howdy, neighbor. Your chickens seem very happy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59232,'','All\'s clear, $n. Don\'t let down your guard, though. Those virmen can tunnel faster than you can say \"Virmen a hole!\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59233,'','Oh, Farmer Yoon is such a gentleman! He even said he liked the new furniture!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59234,'','Welcome Traveler! Help yourself to some ale.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59235,'','We don\'t see very many new faces here anymore.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59236,'','There aren\'t many willing to brave the mountain pass anymore, friend. Nowadays, some would say you\'d have to be crazy to try.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59237,'','Come in out of the cold friend and make yourself comfortable!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59238,'','Oh! A new customer! You are most welcome, friend!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59239,'Hey neighbor, since you\'ve been such a good friend to me, from now on I\'m going to give you crop predictions for free. Absolutely no charge! Just come drink with me now and again, eh?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59240,'Alchemy is a bit like magic, don\'t you think? With the change of a single ingredient a simple drought can either heal you, or kill you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59241,'My shop is filled with many wonderous and hard to come by things. It would be wise to look, but not to touch.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59242,'Supplies are limited, but I accept only the best from the traders.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59243,'Who dares disturb my eternal slumber?!','Who dares disturb my eternal slumber?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59244,'The mountain is angry, stranger. Not good for travel now.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59245,'Very lucky day to travel friend! East wind brings much good fortune.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59246,'I am not Zan - I am Chen Stormstout!','',0,0,0,0,0,0,5,0,1,0,29766,0,26124),
(59247,'Tell me, what has happened here?','',0,0,0,0,0,0,6,0,1,0,29767,0,26124),
(59248,'Where are the other Stormstouts? Why are hozen all over the brewery?','',0,0,0,0,0,0,1,0,1,0,29768,0,26124),
(59249,'Auntie Stormstout...why is the brewery abandoned?','',0,0,0,0,0,0,1,0,1,0,29769,0,26124),
(59250,'You take down Ook-Ook...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59251,'You know what dat mean...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59252,'You da new Ook!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59253,'Ook! Oooook!!','',0,0,0,0,0,0,0,0,1,0,28797,0,26124),
(59254,'In the dooker!','',0,0,0,0,0,0,0,0,1,0,28799,0,26124),
(59255,'There he is!','',0,0,0,0,0,0,0,0,1,0,27578,0,26124),
(59256,'Master Crane! Are you okay?','',0,0,0,0,0,0,0,0,1,0,27579,0,26124),
(59257,'Get Ooking party started!','',0,0,0,0,0,0,0,0,1,0,28800,0,26124),
(59258,'Come on and get your Ook on!','',0,0,0,0,0,0,0,0,1,0,28801,0,26124),
(59259,'We gonna Ook all night!','',0,0,0,0,0,0,0,0,1,0,28802,0,26124),
(59260,'$p... he\'s succumbing to the sha...','',0,0,0,0,0,0,0,0,1,0,27580,0,26124),
(59261,'You are moving out of the Verdant Belt. Your yak is about to break loose!','You are moving out of the Verdant Belt. Your yak is about to break loose!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59262,'Let\'s get this lightning party started, Blanche.','Let\'s get this lightning party started, Blanche.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59263,'What? What\'s happening...','',0,0,0,0,0,0,0,0,1,0,27581,0,26124),
(59264,'It\'s calling out more sha! Focus them down first, $p!','',0,0,0,0,0,0,0,0,1,0,27582,0,26124),
(59265,'We did it!','',0,0,0,0,0,0,0,0,1,0,27583,0,26124),
(59266,'It seems hope has triumphed after all...','',0,0,0,0,0,0,0,0,1,0,29623,0,26124),
(59267,'There is no time for celebration - many followers of the Way still battle outside.','',0,0,0,0,0,0,0,0,1,0,29624,0,26124),
(59268,'Meet me near the statue at the center of the temple grounds. We will speak there.','',0,0,0,0,0,0,0,0,1,0,29625,0,26124),
(59269,'We must never give in to despair.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59270,'Look, Uyen, it\'s a $c. You here to help, $g mister : miss; $c?','',0,0,0,0,0,0,0,0,1,15698,0,0,26124),
(59271,'How\'s it goin\' out there? You\'re gonna rescue my people, right?','',0,0,0,0,0,0,0,0,1,15699,0,0,26124),
(59272,'I haven\'t seen fightin\' like that since, well, I guess I haven\'t ever seen fightin\' like that. You sure are a firecracker, $n.','',0,0,0,0,0,0,0,0,1,15700,0,0,26124),
(59273,'Well now, look Ma. $n\'s back. Why ain\'t you got any of my yaks?','',0,0,0,0,0,0,0,0,1,15701,0,0,26124),
(59274,'You got \'em, $n! Here. Let\'s just get \'em over there into the pen nice as you please.','',0,0,0,0,0,0,0,0,1,15702,0,0,26124),
(59275,'Lookie here, ma, it\'s $n. We was just talkin\' \'bout you.','',0,0,0,0,0,0,0,0,1,15703,0,0,26124),
(59276,'Doesn\'t feel like it\'s been that long since last we talked.','',0,0,0,0,0,0,0,0,1,15703,0,0,26124),
(59277,'I know, I know. We got the upper hand here now thanks to you, so we\'ll get them dang yaungol out of here soon. Just the same, if you feel like crackin\' a skull or two, you won\'t hear me complainin\'.','',0,0,0,0,0,0,0,0,1,15703,0,0,26124),
(59278,'$n! You got any humdingers to tell us? I bet you just got all kinds of new stories \'bout your adventures and whatnot.','',0,0,0,0,0,0,0,0,1,15703,0,0,26124),
(59279,'Uyen, $n\'s back. We got any chow for $g him : her;. Heh, get it? Chow?','',0,0,0,0,0,0,0,0,1,15703,0,0,26124),
(59280,'This here\'s a might embarrassing with them yaungol still infestin\' the farm. You gotta understand though... I ain\'t no fancy $c like you. These things take time for ordinary folk like us. Well, I could just let Uyen go beat \'em \'bout their heads. But I wouldn\'t want to get her started if you know what I mean.','',0,0,0,0,0,0,0,0,1,15703,0,0,26124),
(59281,'[DEBUG ONLY] Attacking $n!','[DEBUG ONLY] Attacking $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59282,'$n, the most famous $r $c in all of Pandaria! Get over here and give ol\' Chow a hug!','',0,0,0,0,0,0,0,0,1,15703,0,0,26124),
(59283,'Go on now. You got more important things to do than to be visitin\' the likes of us. Still, while you\'re here, you see that wascally wirmen runnin\' wild out in the fields?','',0,0,0,0,0,0,0,0,1,15703,0,0,26124),
(59284,'','Good work! Dealing with the Hozen will be easier than I had anticipated.',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(59285,'','%s grunts noncommittally.',0,0,0,0,0,0,0,0,1,15696,0,0,26124),
(59286,'','%s doesn\'t seem impressed.',0,0,0,0,0,0,0,0,1,15696,0,0,26124),
(59287,'','Shooting you a glance, %s frowns and spits.',0,0,0,0,0,0,0,0,1,15696,0,0,26124),
(59288,'','%s sighs, clearly exasperated by the whole situation.',0,0,0,0,0,0,0,0,1,15696,0,0,26124),
(59289,'Weaklings... let me make room for our guests.','',0,0,0,0,0,0,0,0,1,0,28322,0,26124),
(59290,'Approach... your death awaits.','',0,0,0,0,0,0,0,0,1,0,28323,0,26124),
(59291,'','%s waves off her husband as she glares at the continuing unwelcome presence on the farmstead.',0,0,0,0,0,0,0,0,1,15696,0,0,26124),
(59292,'','%s cries softly thinking no one has noticed before drying her tears and standing resolute once more.',0,0,0,0,0,0,0,0,1,15696,0,0,26124),
(59293,'','%s just looks at you.',0,0,0,0,0,0,0,0,1,15696,0,0,26124),
(59294,'','%s seems not to hear what her husband has said while her eyes attempt to keep up with the crazed movements of the wascally wirmen destroying her fields.',0,0,0,0,0,0,0,0,1,15696,0,0,26124),
(59295,'','A deadly wave of ice begins to sweep across the room!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59296,'','Instructor Chillheart\'s soul escapes to her phylactery. Destroy it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59297,'Let me show you my power.','',0,0,0,0,0,0,0,0,1,0,28317,0,26124),
(59298,'Come to me, serpent!  Together we will destroy these intruders.','',0,0,0,0,0,0,0,0,1,0,28318,0,26124),
(59299,'The Azure Serpent moves in to attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59300,'The Azure Serpent stirs in the distance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59301,'Ahh! Help! What is that thing!? It doesn\'t matter, nothing will stop me now, not when I\'m so close! Maybe if I don\'t look at it...?','',0,0,0,0,0,0,430,0,1,0,28289,0,26124),
(59302,'Yes yes yes! So close! Just a pinch of...oops...','',0,0,0,0,0,0,7,0,1,0,28290,0,26124),
(59303,'Too bitter! Just a drop of honey, and a cane of sugar, and maybe some corn? Yes, more corn!','',0,0,0,0,0,0,6,0,1,0,28291,0,26124),
(59304,'Yes, yes, yes...no, no, no no no! Yes! No! Peppers!','',0,0,0,0,0,0,5,0,1,0,28292,0,26124),
(59305,'Is it...can it be???','',0,0,0,0,0,0,6,0,1,0,28293,0,26124),
(59306,'Such harmony of flavor, such heady aroma! It is...the perfect brew!','',0,0,0,0,0,0,479,0,1,0,28294,0,26124),
(59307,'The name of Stormstout will be sung once again throughout the hills!','',0,0,0,0,0,0,5,0,1,0,28295,0,26124),
(59308,'You again! Don\'t you see? I have made a name for myself at last: I have brewed perfection!','',0,0,0,0,0,0,25,0,1,0,31999,0,26124),
(59309,'Next, we ferment the brew! Look out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59310,'The final step, we add heat! Smell that aroma!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59311,'The elements of the brew are too chaotic! I do not know what will happen if they combine now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59312,'','Phew! I need a breather. Let\'s rest here a momen- wha?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59313,'','Up ahead! The refuge is under attack!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(59314,'','No time to catch our breath. Quickly! We\'ve got to help them!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(59315,'Battle Goats GO!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(59316,'Wikkets gonna get Goated!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(59317,'Goat goat gonna crush wikkets!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(59318,'Battle Goats! Jib-it!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(59319,'Battle Goats! Hooooooooozen!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(59320,'Knucklethump gonna jib the wikkets!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(59321,'Na naa na naaa naana! Battle Goats!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(59322,'Take there nibs!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(59323,'Wikkets be trailin!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(59324,'Wikkets got munchpacks! Get munchpacks!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(59325,'Munchy munchy!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(59326,'RAVAGE!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(59327,'Ravage! Ravage! Ravage!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(59328,'More grummles leaving here shortly for Kota Basecamp. Wait here if wish to help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59329,'Brothers! Dispose of these insolent outsiders!','',0,0,0,0,0,0,0,0,1,0,27746,0,26124),
(59330,'Shado-Pan Fire Archers appear on the rooftops!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59331,'The Shado-Pan Archers disappear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59332,'I show you on your map where grummles are now. Find them or wait here for next wave of grummles.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59333,'My seeds grow the best veggies in the valley. Guaranteed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59334,'I\'m here to pick up seeds for Farmer Yoon.','I\'m here to pick up seeds for Farmer Yoon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59335,'Yoon, eh? Never heard of him...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59336,'He just inherited Sunsong Ranch. You can literally see him from where you are standing.','He just inherited Sunsong Ranch. You can literally see him from where you are standing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59337,'Ohh, of course! The Sunsong place, just over yonder. Was wondering who might be movin\' in on that.$B$B<Greenfield squints over your shoulder and waves at Yoon.>$B$BWhen you come back to market with the biggest, juiciest vegetables anyone\'s ever seen, you tell \'em where you got the seeds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59338,'Such harmony of flavor, such heady aroma! It is...the perfect brew!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59339,'Striker Ga\'dok prepares to make a strafing run!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59340,'The gates are about to fall. Quickly! Slaughter these meddlers!','',0,0,0,0,0,0,0,0,1,0,29076,0,26124),
(59341,'By the power of Zandalar, I command that ya rise!','',0,0,0,0,0,0,0,0,1,15716,0,0,26124),
(59342,'Klatu, Barada, Nikto!','',0,0,0,0,0,0,0,0,1,15716,0,0,26124),
(59343,'Piertotum Locomotor!','',0,0,0,0,0,0,0,0,1,15716,0,0,26124),
(59344,'Cong siwang shangsheng, mogu!','',0,0,0,0,0,0,0,0,1,15716,0,0,26124),
(59345,'Nam daed, no em nrut.','',0,0,0,0,0,0,0,0,1,15716,0,0,26124),
(59346,'Vita, Mortis, Careo!','',0,0,0,0,0,0,0,0,1,15716,0,0,26124),
(59347,'Awaken from ya slumber, my mogu friends. Together, we crush these lands.','',0,0,0,0,0,0,0,0,1,15716,0,0,26124),
(59348,'Destroy those who seek to stop us from retakin\' these lands.','',0,0,0,0,0,0,0,0,1,15716,0,0,26124),
(59349,'You?! I hear all \'bout you. My juju be strong. You not gonna stop the Zandalari!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59350,'','It\'s all or nothing, $n. Thunderpaw Refuge needs us. Are you ready to finish this thing?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(59351,'Let\'s kill some lizards, Blanche!','Let\'s kill some lizards, Blanche!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59352,'','Let me know when you\'re ready to go inside...',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59353,'','Let\'s go be heroes!',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(59354,'','Last call, you fork-tongued dip-slithers!',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(59355,'','You don\'t have to go home, but you can\'t stay here.',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(59356,'Lurching Blossom begins to breath a foul gas in front of it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(59357,'A clean weapon is a sign of one that has never seen combat.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59358,'Hello, friend! Can I interest you in the deal of a lifetime?','',0,0,0,0,0,0,0,0,1,15722,0,0,26124),
(59359,'A weapon should be an extension of the fighter. Take care of it as you would yourself and it will never let you down.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59360,'How goes the relic retrieval, $n? I hope those mogu statues aren\'t giving you too much trouble.','',0,0,0,0,0,0,0,0,1,15725,0,0,26124),
(59361,'That\'s a lot of mogu relics. We\'re going to be rich!','',0,0,0,0,0,0,0,0,1,15726,0,0,26124),
(59362,'Great to see you again, $n.','',0,0,0,0,0,0,0,0,1,15727,0,0,26124),
(59363,'I\'m working up the courage to go in after more of the relics. What do you think, $n?','',0,0,0,0,0,0,0,0,1,15727,0,0,26124),
(59364,'Those relics are going to fetch a lot of gold just as soon as I can find the time to get back to town and find a buyer.','',0,0,0,0,0,0,0,0,1,15727,0,0,26124),
(59365,'I bet if I stuck to the outskirts, I could zip in and out of the ruins, grab some relics, and dodge those statues.','',0,0,0,0,0,0,0,0,1,15727,0,0,26124),
(59366,'Oh gods, $n, these mogu heads are staring at me!','',0,0,0,0,0,0,0,0,1,15727,0,0,26124),
(59367,'$n, fun fact: the mogu here at Mogujia weren\'t always terracotta. They were buried alive with their lord after he died in glorious battle.','',0,0,0,0,0,0,0,0,1,15727,0,0,26124),
(59368,'Here\'s a fun fact: Mogujia translates roughly as \'Home of the Mogu\'. Don\'t let that fool you, though. It\'s not their only home. It\'s just the name people have given this place. I did some research and found out that the original name for this area was Chow Keep. That\'s weird. Must just be a coincidence that farmer Chow also has the same name.','',0,0,0,0,0,0,0,0,1,15727,0,0,26124),
(59369,'Have you figured out yet why that Zandalari troll was animating the statues here?','',0,0,0,0,0,0,0,0,1,15727,0,0,26124),
(59370,'Those cabbages should be ready any minute now... wait for it...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59371,'There we go! Ripe for the pickin\'s!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59372,'Got anymore of that lotus incense?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59373,'Haven\'t seen any. I\'m starting to wonder if we will be able to make it up the mountain.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59374,'Brother Brokendice is taking all of my hard earned gold and goods! I should have known not to trust a grummle. Never trust something half your size...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59375,'The convoy to the Burlap Waystation is leaving now! Gather around!','',0,0,0,0,0,0,0,0,1,15527,0,0,26124),
(59376,'For fortune!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59377,'Grummles! Come and breathe deep of travel incense. Go with good fortune to Burlap Waystation!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(59378,'Grummles! Gather round and breathe deep of travel incense. Go with good fortune to Kota Basecamp!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(59379,'Defeat the Boneweavers to aid Lilian Voss!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(59380,'Grummle power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59381,'No! Don\'t take my luckydo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59382,'You stink of bad fortune.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59383,'No grummlepacks for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59384,'Bad fortune for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59385,'Fortune with me today!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59386,'No grummlepacks for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59387,'THIS IS WHERE A MOVIE WILL BE$B$BWE LOVE YOU, BETA TESTERS','THIS IS WHERE A MOVIE WILL BE$B$BWE LOVE YOU, BETA TESTERS',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59388,'Thank you for rescue! Meet me at Burlap Waystation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59389,'','It might be wisest if you and your companions were not seen here for a time, traveler.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59390,'I am ready to leave.','I am ready to leave.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59391,'Report\'s all ready to go, $n! I don\'t mean to brag, but General Nazgrim should be pretty pleased with my work.','',1,0,0,0,3,0,396,0,1,0,0,0,26124),
(59392,'','Here\'s the report, $n. Oh! Make sure you mention my idea with the bombs. I have it lined out in the report.',1,0,0,0,0,0,397,0,1,0,0,0,26124),
(59393,'This is absolutely barbaric!','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(59394,'Bringing our war to these natives is wrong. We should be teaching them the best of ourselves not the worst...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59395,'There is still time to stop this madness. You don\'t have to do this Shokia...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59396,'There is so much we can learn from this land, and yet you are content to watch it burn around you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59397,'','Report?! I have my hands full down here, $n! Oh alright, here you go.',1,0,0,0,0,0,396,0,1,0,0,0,26124),
(59398,'Nazgrim gonna be real happy with Riko! Here! Report is done!','',1,0,0,0,3,0,396,0,1,0,0,0,26124),
(59399,'%s calls out for reinforcements!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59400,'Use the Boomer Brew to zap saurok minions!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59401,'While one player is zapping a saurok, another can instantly destroy it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59402,'','You did it! Thunderpaw Refuge is saved!',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(59403,'','And I\'ve got just the brew to celebrate with. First round is on me. Thank you, friends!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59404,'Come forward, so that we may be properly introduced.','',0,0,0,0,0,0,0,0,0,0,27635,0,26124),
(59405,'Let\'s keep moving! I see another big one, down there!','',0,0,0,0,0,0,5,0,1,15760,31931,0,26124),
(59406,'No time, brothers! We\'ve got to keep fighting!','',0,0,0,0,0,0,1,0,1,15760,31932,0,26124),
(59408,'For Pandaria!!','',0,0,0,0,0,0,4,0,1,15760,30864,0,26124),
(59409,'Then, we maybe take a rest? Sit down for a while?','',0,0,0,0,0,0,6,0,1,15760,31903,0,26124),
(59410,'That made me hungry.','',0,0,0,0,0,0,1,0,1,15760,31902,0,26124),
(59411,'For Pandaria!','',0,0,0,0,0,0,4,0,7,15760,31905,0,26124),
(59413,'These mankers messed with the wrong hozen!','',0,0,0,0,0,0,1,0,1,15760,30859,0,26124),
(59414,'For the hozen!','',0,0,0,0,0,0,4,0,1,15760,30863,0,26124),
(59415,'Yeah! Get back over your wall, you jikkety-dooks!','',0,0,0,0,0,0,25,0,1,15760,30861,0,26124),
(59416,'Not eating.','',0,0,0,0,0,0,11,0,1,15760,30857,0,26124),
(59417,'For the jinyu!','',0,0,0,0,0,0,4,0,1,15760,30689,0,26124),
(59418,'Mankers?','',0,0,0,0,0,0,6,0,1,15760,30687,0,26124),
(59419,'Return from where you came, mantid.','',0,0,0,0,0,0,1,0,1,15760,30688,0,26124),
(59420,'Everything makes you hungry, Xiao.','',0,0,0,0,0,0,11,0,1,15760,30686,0,26124),
(59421,'','For Pandaria!!!',0,0,0,0,0,0,4,0,1,15760,0,30879,26124),
(59422,'','Woo hoooooo!',0,0,0,0,0,0,4,0,1,15760,0,30878,26124),
(59423,'Many thanks for rescue of most good fortune.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59424,'','Stay away from those claws - they look sharp!',0,0,0,0,0,0,0,0,1,15760,0,30880,26124),
(59425,'$p, take care of those eggs! We\'ll focus on the big mama!','',0,0,0,0,0,0,0,0,1,15760,31936,0,26124),
(59426,'Destroy the eggs before they hatch!','',0,0,0,0,0,0,0,0,1,15760,0,0,26124),
(59427,'Which way did he go?','',0,0,0,0,0,0,0,0,1,15760,31907,0,26124),
(59428,'What the ook? Look out! Scary circle!','',0,0,0,0,0,0,0,0,1,15760,30865,0,26124),
(59429,'I\'m gonna come at you like an avalanche!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59430,'I call this move \"The Snowplow!\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59431,'You have incurred the wrath!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59432,'Got somethin\' in my pack for ya! Here, let me find it. Nope, not there, not there either. Oh here it is, in my DEATH POUCH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59433,'Right in the snowballs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59434,'You won\'t like me when I\'m mildly influenced by incense!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59435,'I\'ll meet you at the Golden Pagoda.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59436,'We have no time to rest, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59437,'The turmoil in Kun-Lai Summit has uprooted many innocents. They will find shelter within our gates.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59438,'For as long as we are able, we shall provide safe haven for those who seek it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59439,'We will do our best to protect the refugees, but with the mogu pushing into the Vale, it may not remain safe for long.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59440,'There is so much work to do!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59441,'I will drain the red blood from your bodies!','',0,0,0,0,0,0,0,0,1,15760,0,0,26124),
(59442,'You and your companions are my guests in the Vale. Please let me know if there is anything I can provide for you.','',0,0,0,0,0,0,0,0,1,0,29048,0,26124),
(59443,'Her Majesty\'s brood will sweep over this valley!','',0,0,0,0,0,0,0,0,1,15760,0,0,26124),
(59444,'For the pride of the mantid!','',0,0,0,0,0,0,0,0,1,15760,0,0,26124),
(59445,'I will show you the face of fear.','',0,0,0,0,0,0,0,0,1,15760,0,0,26124),
(59446,'%s is chasing you. Run!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59447,'I will hunt you down, soft-skin...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59448,'You cannot stop Her Majesty\'s brood! Our numbers are endless!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59449,'Click on a Bone Pile to protect yourself from Bone Spike!','Click on a Bone Pile to protect yourself from Bone Spike!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59450,'Do you think pandaren are dark with white spots, or white with dark spots?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59451,'Do you know why the pandaren love philosophy? Because for them, things are not just black and white.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59452,'What happened to the pandaren whose kitchen was robbed? He got bamboozled!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59453,'What\'s the most valuable fish in all of Pandaria? The goldfish!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59454,'Do you know how to pick up a female jinyu in a tavern? Just drop your line!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59455,'What do you call a jinyu who has trained at Tian Monastery? A monkfish!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59456,'%s draws from the surrounding water!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59457,'How are the refugees settling in?','How are the refugees settling in?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59458,'Reinforcements have arrived to the Vale.','Reinforcements have arrived to the Vale.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59459,'What\'s happening here in the Vale?','What\'s happening here in the Vale?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59460,'Keep the body strong, and the mind will follow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59461,'','When the mind grows hungry for inspiration, feed it with beautiful things.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59462,'Oh my, a visitor. Your presence makes me very happy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59463,'Many have come from all corners of the land to see the gates opened at last. Indeed, many of your people have already found their way inside. Seek your own solace and refuge within.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59464,'Many have come from all corners of the land to see the gates opened at last. Indeed, many of your people have already found their way inside. Seek your own solace and refuge within.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59465,'','I am glad to hear it. The mogu\'s recent actions trouble me greatly. They have not behaved in such organized fashion for nearly ten thousand years.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59466,'The Sacred Pools have been corrupted by dark energy, thanks to Garrosh Hellscream. Remnants of the sha still linger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59467,'','Lilian\'s Soul fixates on $n!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(59470,'The water reacts violently to your touch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59471,'Stay close to me. I will keep us camouflaged from the enemy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59472,'Master Snowdrift vanishes to the shadows and creates duplicate illusions of himself! Strike the illusions to dispel them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59473,'Master Snowdrift attacks you with his hand to hand techniques!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59474,'Do not run, it only delays the inevitable.','',0,0,0,0,0,0,0,0,1,0,28269,0,26124),
(59475,'Come in, the water\'s fine!','',0,0,0,0,0,0,0,0,1,0,28270,0,26124),
(59476,'Let death wash over you!','',0,0,0,0,0,0,0,0,1,0,28271,0,26124),
(59477,'Come quickly. There is a gap in their defenses.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59478,'Let\'s go while the way is clear. The cave is just ahead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59479,'Wait for a safe moment, then plant the explosives at the mouth of the cave.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59480,'Shado-Pan Stormbringers react to your presence and begin to |cFFFF0000|Hspell:115009|h[Focus Energy]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59481,'','$n\'s here. Let\'s go.',0,0,0,0,0,0,432,0,1,0,0,27420,26124),
(59482,'Ready... aim...','',0,0,0,0,0,0,0,0,1,15789,0,0,26124),
(59483,'Ready your arrows, men!','',0,0,0,0,0,0,0,0,1,15789,0,0,26124),
(59484,'Firing another round in 3... 2... 1...','',0,0,0,0,0,0,0,0,1,15789,0,0,26124),
(59485,'Notch your arrows, men...','',0,0,0,0,0,0,0,0,1,15789,0,0,26124),
(59486,'Bows ready...','',0,0,0,0,0,0,0,0,1,15789,0,0,26124),
(59487,'Prepare your weapons, men!','',0,0,0,0,0,0,0,0,1,15789,0,0,26124),
(59488,'Take aim!','',0,0,0,0,0,0,0,0,1,15789,0,0,26124),
(59489,'Ready another round!','',0,0,0,0,0,0,0,0,1,15789,0,0,26124),
(59490,'FIRE!!','',0,0,0,0,0,0,0,0,1,15789,0,0,26124),
(59491,'|TInterface\\Icons\\ability_warlock_jinx.blp:20|t%s begins to cast |cFFFF0000|Hspell:115147|h[Empowering Spirits]|h|r!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59492,'Tread softly. Danger lurks ahead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59493,'I\'m ready to infiltrate the cave.','I\'m ready to infiltrate the cave.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59494,'Let\'s get this caravan on the road!','Let\'s get this caravan on the road!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59495,'','Wha...',0,0,0,0,0,0,0,0,1,0,0,27421,26124),
(59496,'Hey there, $p!$B$BHow\'s it feel to be a full-fledged farmer?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59497,'I never imagined farming would involve so many... exotic odors.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59498,'Are your thumbs turning green yet?$B$BMine look pretty much the same.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59499,'Ahem.$B$B\"I reckon there just ain\'t enough hours in the day!\"$B$BHow did that sound? Too forced? You think it would fly at the market?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59500,'I never thought about where the food on my table came from before we started this farming business.$B$BThis experience has been enlightening, to say the least!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59501,'Yoon, I need some farming advice.','Yoon, I need some farming advice.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59502,'Of course!$B$BWhat seems to be the problem?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59503,'How do I care for Parched crops?','How do I care for Parched crops?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59504,'How do I care for Infested crops?','How do I care for Infested crops?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59505,'How do I care for Wiggling crops?','How do I care for Wiggling crops?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59506,'How do I care for Alluring crops?','How do I care for Alluring crops?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59507,'How do I care for Smothered crops?','How do I care for Smothered crops?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59508,'How do I care for Wild crops?','How do I care for Wild crops?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59509,'How do I care for Runty crops?','How do I care for Runty crops?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59510,'How do I care for Tangled crops?','How do I care for Tangled crops?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59511,'','The gate is jammed.',0,0,0,0,0,0,274,0,1,0,0,27422,26124),
(59512,'Parched crops just need water!$B$BYou can use the old rusty watering can my grandpa left here. I keep it right over there by that tree stump, just next to the field.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59513,'Let me try.','',0,0,0,0,0,0,5,0,1,0,27339,0,26124),
(59514,'Parched crops just need water!$B$BThey should be easy to take care of now that we\'ve got that sprinkler! It should be on the ground just at the edge of the field.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59515,'Did they prop this door up against a boulder?  It won\'t budge!','',0,0,0,0,0,0,5,0,1,0,27340,0,26124),
(59516,'Step aside. I\'ve got the key right here.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(59517,'The beer\'s here! Drink up, boys!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59518,'Ahh... beer. Just what my men needed. Thank you, $p.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59519,'First we get into a fight, and then someone brings us beer! Can today get any better?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59521,'Well done, Jojo!','',0,0,0,0,0,0,0,0,1,0,27341,0,26124),
(59522,'','Beer delivery, in the middle of a battlefield? Perhaps Pandaria will make a good home after all...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59523,'I have another question...','I have another question...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59524,'Beer delivery, in the middle of a battlefield? Maybe Pandaria will make a good home after all...','',0,0,0,0,0,0,6,0,1,0,32458,0,26124),
(59525,'How do I deal with Occupied soil?','How do I deal with Occupied soil?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59526,'How do I deal with Stubborn weeds?','How do I deal with Stubborn weeds?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59527,'Infested crops are covered in bugs. Yech!$B$BGrandpa\'s bug sprayer is on the ground near the field - use it to give those critters a blast of what-for!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59528,'Grrr-r-r-RRAHHH!','',0,0,0,0,0,0,0,0,1,0,31030,0,26124),
(59529,'Infested crops are covered in bugs. Yech!$B$BNow that we have that Pulse Wave Emitter, though, it should be easy to get rid of them. Flip it on to shoo all those pests away in a humane fashion, without any pesticide!$B$BHey, does that mean our veggies count as organic?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59530,'Let\'s go deliver some dang BEER!','',0,0,0,0,0,0,0,0,1,0,30946,0,26124),
(59531,'Wiggling, eh? Well, as Grandpa used to say: carrots don\'t dance!$B$BSomething is trying to pull the veggies right out from under us!$B$BI\'m afraid you\'ll have to kill whatever varmit\'s down there if you want the crop to have any peace. Heartbreaking, I know, but it\'s part of the job.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59532,'That\'s it for me! No more beer to deliver.','',0,0,0,0,0,0,0,0,1,0,30947,0,26124),
(59533,'I reckon I\'ll head back to Stoneplow and rest my dang arms.','',0,0,0,0,0,0,0,0,1,0,30948,0,26124),
(59534,'Well, sometimes veggies get to sprouting SO beautifully, they practically beg to be pilfered.$B$BGrandpa said a keen plainshawk could spot a prize pumpkin better than anyone at the market, and it\'d make for it quicker than a... err....$B$B\"Quicker than a hozen in heat.\"$B$BI guess you could say stuff like that back then?$B$BThe point is, you\'ll just have to defend alluring crops from critters!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59535,'Smothered  crops have a weed budging in on them!$B$BYou deal with them just like you deal with a stubborn weed in a plot of soil - elbow grease! Grab that sucker and pull for all you\'re worth. It\'ll give eventually.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59536,'Wild?! Now that\'s a surprise! Grandpa used to tell stories about having to wrestle his wild crops into submission.$B$B\"Yoonie,\" he used to say, \"don\'t be afraid to slap your scallions around.\"$B$BI always thought he was just being gross.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59537,'Runty! Hah! Now that\'s a term I haven\'t heard in awhile!$B$BGrandpa used to call me that when I refused to get up and go somewhere. He\'d grab the nape of my neck and hoist me up \"like a runty turnip\" he would say.$B$BThese crops just need a helping hand getting vertical. Get a firm grip on them and lift.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59538,'Tangleweeds, eh? Nasty little devils. They run deep into the ground some fifteen yards or so - you gotta pull the entire length out if you wanna get rid of it.$B$BGrab the exposed end of the weed and just keep moving away until you see the other end come out. Nothin\' more to it than that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59539,'Sometimes virmen try to burrow up into the soil plots and live there, hoping vegetables will just rain down on them - I think they figure we just put \'em in the ground whole for some reason.$B$BSquatters, that\'s what Grandpa called them. You gotta put your foot down. Literally. Stomp the ground and root \'em out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59540,'Stubborn weeds! They\'re a constant nuisance, creeping up in the soil and threatening to take over your land.$B$BBefore you can till that plot, you need to rip the weed out. There\'s no trick to it, really - just grab it and pull!$B$BIn the words of my grandpa, \"you just gotta be more ornery than the weed!\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59541,'|TInterface\\Icons\\spell_warlock_demonsoul.blp:20|t%s casts |cFFFF0000|Hspell:115297|h[Evict Soul]|h|r on |cFF006EFD$n|r!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(59542,'Many thanks for rescue!','',0,0,0,0,0,0,0,0,1,15815,0,0,26124),
(59543,'This your fault!','',0,0,0,0,0,0,0,0,1,15815,0,0,26124),
(59544,'My fault? I wasn\'t one who bought unclean yak.','',0,0,0,0,0,0,0,0,1,15815,0,0,26124),
(59545,'Help! Grummle in trouble.','',0,0,0,0,0,0,0,0,1,15815,0,0,26124),
(59546,'Help a grummle?','',0,0,0,0,0,0,0,0,1,15815,0,0,26124),
(59547,'Give back my luckydo!','',0,0,0,0,0,0,0,0,1,15815,0,0,26124),
(59548,'Changed your mind? I\'ll wait for you at the entrance to Ruins Rise when you\'re ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59549,'I\'ll wait for you at the base of Ruins Rise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59550,'Stop. Let them pass.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59551,'Let\'s wait for the next wave.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59552,'I\'m not one for fightin\' much. Pickin\' up heavy stuff, sure... but my muscles get all weak an\' wobbly when it comes to hittin\' somethin\'.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59553,'Let\'s head out to the battlefield, Mudmug.','Let\'s head out to the battlefield, Mudmug.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59554,'Never met them before in my life. Pandaren don\'t really come in any bad flavors though.','',0,0,0,0,0,0,1,0,1,0,28090,0,26124),
(59555,'Korga Strongmane, once prisoner of the Alliance, now free and woefully unarmed tauren. Good to meet you, pandaren.','',0,0,0,0,0,0,66,0,1,0,28121,0,26124),
(59565,'Somebody help!','Somebody help!',0,0,0,0,0,0,0,0,1,15819,0,0,26124),
(59566,'Who dares disturb me? Show your cowardly faces and kneel before me!','',0,0,0,0,0,0,0,0,1,0,28229,0,26124),
(59567,'Ahahaha! Such a pitiful creature!','',0,0,0,0,0,0,0,0,1,0,28230,0,26124),
(59568,'Please, would you get me out of here?','Please, would you get me out of here?',0,0,0,0,0,0,0,0,1,15819,0,0,26124),
(59569,'If I don\'t get away from these beasts, they\'re going to kill me!','If I don\'t get away from these beasts, they\'re going to kill me!',0,0,0,0,0,0,0,0,1,15819,0,0,26124),
(59570,'Wikkets gonna be munch munch food for Old Poot Poot.','',1,25,11,0,1,2,0,0,1,15817,0,0,26124),
(59571,'Ookin wikkets gonna give up their nibs. One way or another.','',1,25,11,0,1,2,0,0,1,15817,0,0,26124),
(59572,'Silly wikkets. Walking for goat goats.','',1,25,11,0,1,2,0,0,1,15817,0,0,26124),
(59573,'Hey you. Would you let me loose?','Hey you. Would you let me loose?',0,0,0,0,0,0,0,0,1,15819,0,0,26124),
(59574,'Over here!','Over here!',0,0,0,0,0,0,0,0,1,15819,0,0,26124),
(59575,'What did we ever do to you?','What did we ever do to you?',0,0,0,0,0,0,0,0,1,15819,0,0,26124),
(59576,'I just want to go home.','I just want to go home.',0,0,0,0,0,0,0,0,1,15819,0,0,26124),
(59577,'Please, I beg you.','Please, I beg you.',0,0,0,0,0,0,0,0,1,15819,0,0,26124),
(59578,'Bad fortune for you.','',1,0,0,0,0,0,0,0,1,15817,0,0,26124),
(59580,'Friends of grummles come soon. You will see!','',1,0,0,0,0,0,0,0,1,15817,0,0,26124),
(59581,'Why so angry?','',1,0,0,0,0,0,0,0,1,15817,0,0,26124),
(59582,'What did grummles ever do to you?','',1,0,0,0,0,0,0,0,1,15817,0,0,26124),
(59583,'','The Alliance? If the crashed ship is theirs, we need to contact them. Jojo, would you come with me?',0,0,0,0,0,0,6,0,1,0,0,27419,26124),
(59584,'We need to dislodge that ship, Korga.  If we help your crewmates, can you help us?','',0,0,0,0,0,0,1,0,1,0,27333,0,26124),
(59585,'Gladly, my new friend. Our engineer is still in the wilds though - we\'ll need to rescue him first.','',0,0,0,0,0,0,1,0,1,0,28122,0,26124),
(59586,'Well, we\'ve got a master person-finder here, eh $p?  We\'re on it.','',0,0,0,0,0,0,1,0,1,0,27334,0,26124),
(59587,'Thank you, $c.  Thank you!','Thank you, $c.  Thank you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59588,'The Ragemesa leader is in the caves!','The Ragemesa leader is in the caves!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59589,'I\'m going to try to get out of here now.  Thank you!','I\'m going to try to get out of here now.  Thank you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59590,'There\'s a whole bunch of them still in the caves.  They\'re getting ready to attack your people!','There\'s a whole bunch of them still in the caves.  They\'re getting ready to attack your people!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59591,'I need to find my family!','I need to find my family!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59592,'Please, $c, drive them out of Kun-Lai for good.','Please, $c, drive them out of Kun-Lai for good.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59593,'Blessings of the four winds upon you, stranger.','Blessings of the four winds upon you, stranger.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59594,'You\'ve saved us!  Now we need to get out of here.','You\'ve saved us!  Now we need to get out of here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59595,'We cannot fight like this forever.','',0,0,0,0,0,0,274,0,1,15820,31934,0,26124),
(59596,'$p, go speak to Guard Captain Oakenshield. Tell him we need reinforcements!','',0,0,0,0,0,0,0,0,1,15820,31935,0,26124),
(59597,'You are not worthy of me. You! Come crush this insignificant flea!','',0,0,0,0,0,0,0,0,1,0,28231,0,26124),
(59598,'Removing the spirit\'s illusion damages the hozen\'s fragile mind!','Removing the spirit\'s illusion damages the hozen\'s fragile mind!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59599,'$p! Over here!','',0,0,0,0,0,0,0,0,1,15760,31900,0,26124),
(59600,'Put me down!','',0,0,0,0,0,0,0,0,1,15823,0,0,26124),
(59601,'Don\'t throw me in the fire, hozen!','',0,0,0,0,0,0,0,0,1,15823,0,0,26124),
(59602,'What did I ever do to you? Why so angry?','',0,0,0,0,0,0,0,0,1,15823,0,0,26124),
(59603,'I still have a luckydo. This is your last chance to surrender before bad fortune finds you.','',0,0,0,0,0,0,0,0,1,15823,0,0,26124),
(59604,'Everyone to arms! The mogu are attacking!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(59605,'Their main army has breached the north gate!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(59606,'You are needed back at the Golden Pagoda immediately!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(59607,'','Well done, $n. Wait... I see a scout approaching.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59608,'<Miss Fanny shuffles uncomfortably. Either she\'s nervous about the nearby combat, or anxious to get into the fray herself.>','',377,0,0,0,0,0,0,0,1,0,0,0,26124),
(59609,'<Miss Fanny looks at you expectantly. Her eye twinkles with anticipation.>$b$b<Miss Fanny\'s moment for glory has arrived.>','',377,0,0,0,0,0,0,0,1,0,0,0,26124),
(59610,'Let\'s go, Miss Fanny.','Let\'s go, Miss Fanny.',377,0,0,0,0,0,0,0,1,0,0,0,26124),
(59611,'All hope is not lost, $p.','',0,0,0,0,0,0,274,0,1,0,29107,0,26124),
(59612,'You\'ve been swallowed by the Ik\'thik Colossus!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59613,'Use your martial arts training. Focus your energy... then STRIKE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59614,'Keep striking!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59616,'You can do this, $p... but you cannot do this alone. You will need help from that mushan beast. Yes, I believe her name was Miss Fanny.','',0,0,0,0,0,0,1,0,1,0,29108,0,26124),
(59617,'Keep fighting, pandaren! Cancel all retreat orders! Stoneplow hasn\'t fallen yet!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59618,'Three...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59619,'Two...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59620,'One...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59621,'BOOM!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59622,'Hmph. Those mogu will have to try harder than that!$B$BThe Golden Lotus will defend the Vale... no matter the cost.$B$BThe secrets that we guard are much too precious... much too powerful... to allow into the hands of the Shao-Tien!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59623,'How dare they attack a caretaker of the Vale, so far behind our defensive lines!$B$BDo you see now why we need your help?$B$BThe Shao-Tien mogu have found a way to enter the Vale. Unchecked, they will bring unspeakable devastation to our tranquil home.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59624,'When times are dark, it is best to turn on a light.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59625,'','What\'s your report?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59626,'The Vale is peaceful. Too peaceful.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59627,'Sometimes the most beautiful things are also the most deadly. Just look at me!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59628,'Well, that should put a damper on their plans. Good work, $n. I trust you can get back on your own.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59629,'If you\'re looking to infiltrate the ruins, speak to Kun Autumnlight at the Guo Lai Ruin first.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59630,'Defend the Cart!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59631,'What the ook?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59632,'OW! OW! OW!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59633,'Nob nob nibble.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59634,'If only I had figured out the fresco sooner. So much could have been avoided, $n.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59635,'Our homes... destroyed... We did what we had to....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59636,'I\'ve been expecting you, $p!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59637,'Spirits and elements of Pandaria, I call upon you! Destroy $p!','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(59638,'What?! I will finish you myself!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(59639,'Those who steal from the mogu will be punished.','',0,0,0,0,0,0,1,0,1,0,29640,0,26124),
(59640,'Your people are lost. Even as we speak, we mogu are overtaking your precious Vale.','',0,0,0,0,0,0,1,0,1,0,29641,0,26124),
(59641,'The Thunder King will rise again!','',0,0,0,0,0,0,15,0,1,0,29642,0,26124),
(59642,'Do you really think we are going to make it out of here alive?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59643,'I cleared the way. You should be good to go.','I cleared the way. You should be good to go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59644,'I can\'t believe we made it. Thank you stranger!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59645,'My boy! Just in time. We have more yaks to clean.','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(59646,'','$n, $g you handsome devil : you sexy thing;, get over here.  We need to talk about some statues....',0,0,0,0,0,0,0,0,1,15853,0,0,26124),
(59647,'','What\'s the hold up?  You busy with something else?  Did that little creep, Rivett, ask you to do something for him?!',0,0,0,0,0,0,0,0,1,15854,0,0,26124),
(59648,'','So... why isn\'t that troll dead yet?  He is the one reanimating all of those mogu, yes?',0,0,0,0,0,0,0,0,1,15856,0,0,26124),
(59649,'I always hate the days that I have to go in to that cave looking for sprite needles.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59650,'','Why do I have the feeling that you\'ve got good news for me, $n?',0,0,0,0,0,0,0,0,1,15855,0,0,26124),
(59651,'','I don\'t hear that crazy troll yelling any longer.  Music to my ears!',0,0,0,0,0,0,0,0,1,15857,0,0,26124),
(59652,'','We need those pandaren rescued.  If that doesn\'t happen soon, we\'re going to have a slew of defectors here going after their loved ones and getting themselves killed!',0,0,0,0,0,0,0,0,1,15858,0,0,26124),
(59653,'','News of your success has preceeded you.  Our ranks have swelled!  We\'re in better shape now than I\'d dared to hope for thanks to you, $n.',0,0,0,0,0,0,0,0,1,15859,0,0,26124),
(59654,'','Well, well, well, look who\'s back!  Slumming, $n?',0,0,0,0,0,0,0,0,1,15860,0,0,26124),
(59655,'Not in the face!','',20,0,0,0,0,0,0,0,1,0,0,0,26124),
(59656,'','All hail $n, the mighty conqueror of the yaungol and champion of Easterly Rest!',0,0,0,0,0,0,0,0,1,15860,0,0,26124),
(59657,'It\'s heading right for us!','',20,0,0,0,0,0,0,0,1,0,0,0,26124),
(59658,'Don\'t make them angry!','',20,0,0,0,0,0,0,0,1,0,0,0,26124),
(59659,'Play dead! They\'ll get bored and go away.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59660,'','Going to be around for a while, $n?',0,0,0,0,0,0,0,0,1,15860,0,0,26124),
(59661,'','I wonder how long we\'ll be here before the general gives us our marching orders.',0,0,0,0,0,0,0,0,1,15860,0,0,26124),
(59662,'','$n, have you been back to Orgrimmar?  What news?',0,0,0,0,0,0,0,0,1,15860,0,0,26124),
(59663,'','Talk around camp is that on the other side of the wall to the west, Townlong Steppes is crawling with bugs.  What do you think, $n?',0,0,0,0,0,0,0,0,1,15860,0,0,26124),
(59664,'','What I wouldn\'t give for a fresh corpse to cannibalize.  Oops, did I say that out loud?',0,0,0,0,0,0,0,0,1,15860,0,0,26124),
(59665,'','I give up.  I can\'t get through to you cuddly bears.  $n, would you come over here and show these newbs how it\'s done?',0,0,0,0,0,0,0,0,1,15860,0,0,26124),
(59666,'Did they leave yet?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59667,'','YOU TOLD HER WHAT?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59668,'$n, I lend you the cold vengeance of the northern winds!','',0,0,0,0,0,0,0,0,1,0,29024,0,26124),
(59669,'Hmm. What to make first? Incense? Campfire logs? Everburning candle?','',432,0,0,0,0,0,0,0,1,0,0,0,26124),
(59670,'Ah! A luckydo comes to the great Grummle Bazaar eh? I smell good fortune in our meeting.$b$bI am called the Lucky Eightcoins. I am named for my best luckydo, the one that gives most pungent smelling fortune.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59671,'We are the grummles. We know all of the paths through the mountains.$b$bMost of all we bring supplies to the great wall in the east. The bastion of the Shado-Pan.$b$bThese are dark times though, and grummles face great dangers on our road.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59672,'On your first try! Now, take the flame to the top of the temple and burn the scroll that you find there.','',0,0,0,0,0,0,1,0,1,18562,27795,0,26124),
(59674,'Shen-zin Su, the very land on which we stand, is in deep pain. Though I don\'t know the source, I can feel his ache within my own body.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59675,'Ancient wisdoms tell of speaking to Shen-zin Su through the voice of the four elemental spirits, but the spirits have fled our great temple and their powers are fading.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59676,'$n, you are the champion I\'ve long been awaiting. You will be the one to find and reunite the elemental spirits so that we might speak to Shen-zin Su and heal our land.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59677,'The closest spirit is Huo, the spirit of flame. I would ask you to meet with some of my most talented students and learn what they know of Huo.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59678,'Time is not on our side. Go as soon as you are able.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59679,'','You do not fight alone! Unleash my storm upon these invaders!',0,0,0,0,0,0,0,0,1,0,0,28560,26124),
(59680,'The fire spirit is upset. It\'s dangerous to enter the shrine now...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(59681,'Did you hear what those Tillers said about me being a citypaw?$B$BSure I grew up in Dawn\'s Blossom, but I visited my grandpa a few times. I know the difference between a carrot and a turnip! One\'s orange and one\'s white, after all!$B$BAfter Grandpa passed, he left the farm to me, so I\'m going to do my best for him! But how can I prove that to those Tillers?','',0,0,0,0,0,0,21,0,1,0,0,0,26124),
(59682,'Good. Channel the flames, feel them course through you.','Good. Channel the flames, feel them course through you.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(59683,'Learn this spell well for it will burn the taint from all those who oppose us.','Learn this spell well for it will burn the taint from all those who oppose us.',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(59684,'The battle begins in 2 minutes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59685,'The battle begins in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59686,'The battle begins in 30 seconds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59687,'The battle has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59688,'My crop is Growing... now what?','My crop is Growing... now what?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59689,'The Alliance has captured a Mine Cart!','',0,0,0,0,0,0,0,0,1,0,9431,0,26124),
(59690,'The Horde has captured a Mine Cart!','',0,0,0,0,0,0,0,0,1,0,9431,0,26124),
(59691,'Now all you have to do is wait! Most crops are ready the day after they start growing.$B$BAren\'t we lucky to have land in such a fruitful valley?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59692,'A challenger approaches.','',0,0,0,0,0,0,113,0,1,0,0,0,26124),
(59693,'Hoptallus lets out a loud screech! The virmen are coming!','Hoptallus lets out a loud screech! The virmen are coming!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59694,'Strike at these barbarians with the full force of my rage!','',0,0,0,0,0,0,0,0,1,0,31044,0,26124),
(59695,'Good fortune to you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59696,'We\'ll meet you at Kota Basecamp!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59697,'Tassle sniffs the air.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59698,'|TInterface\\Icons\\inv_misc_qirajicrystal_04.blp:20|t |c0091D0F8%s|r begins to petrify all players!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59699,'|TInterface\\Icons\\inv_misc_qirajicrystal_03.blp:20|t |c0093F8D1%s|r begins to petrify all players!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59700,'|TInterface\\Icons\\inv_misc_qirajicrystal_02.blp:20|t |c00F19C88%s|r begins to petrify all players!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59701,'|TInterface\\Icons\\inv_misc_qirajicrystal_05.blp:20|t |c00C3B7EA%s|r begins to petrify all players!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59702,'Xuen, might of the north, answers the call of battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59703,'Yu\'Lon, guardian of the east, appears on the field of battle!','Yu\'Lon, guardian of the east, appears on the field of battle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59704,'Niuzao, strength of the west, charges into battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59705,'Thank the heavens... I thought the secrets of Firebough Stout would die with me. Help me out of here, friend!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59706,'Let\'s get out of here.','Let\'s get out of here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59707,'You have a firm grip - now JUMP!','You have a firm grip - now JUMP!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(59708,'Smelly wikkets!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59709,'','The mogu broke through our defenses...$B$BTheir army of jade soldiers was too much for us to hold back.$B$BI stayed behind to take care of Che, but the others retreated to the city to make their last stand.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59710,'I hope you\'re ready, $p. Jaomin Ro awaits you just over the bridge.','',0,0,0,0,0,0,113,0,1,0,0,0,26124),
(59711,'You\'re departing so soon?  I am envious of your prowess, $c. Good luck to you.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(59712,'Shhhh! Come quietly. She\'s practicing.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(59714,'%s begins to channel a violent |cFFFF0404|Hspell:116040|h[Epicenter]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59715,'Hah! Way to go! You are a natural at this.','',0,0,0,0,0,0,5,0,1,0,27321,0,26124),
(59716,'Come, friend! The fighting\'s this way!','',0,0,0,0,0,0,5,0,1,0,27308,0,26124),
(59717,'Come quickly!  Wouldn\'t want to miss out on the fun, would ya?','',0,0,0,0,0,0,5,0,1,0,27307,0,26124),
(59718,'I like the way you think! Let\'s go!','',0,0,0,0,0,0,5,0,1,0,27309,0,26124),
(59719,'We stand by your side, friend.  This battle is not yours alone.','',0,0,0,0,0,0,6,0,1,0,28119,0,26124),
(59720,'','We\'ll cover this front. You keep my priests safe.',0,0,0,0,0,0,396,0,1,0,0,27503,26124),
(59721,'','Hold the line, sailors! Your brothers depend on you!',0,0,0,0,0,0,22,0,1,18357,0,27505,26124),
(59722,'','Tend to the wounded! This isn\'t over yet.',0,0,0,0,0,0,22,0,1,18358,0,27506,26124),
(59723,'Honey Badger doesn\'t give a sh*t!','Honey Badger doesn\'t give a sh*t!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59726,'I\'m not leaving these behind. This is my family\'s legacy!','',0,0,0,0,0,0,1,0,1,17842,0,0,26124),
(59727,'Allow me to introduce myself - I am Ya Firebough, illustrious leader of this formerly maginificent hamlet.$B$BClearly, you are an upstanding citizen of the world.$B$BI wonder if I could trouble you to help me out of this rather sticky situation? I\'m certain that the Shado-Pan at the nearby retreat will be more than happy to recompense you for any inconvenience.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59728,'...That\'s enough. Let\'s go.','...That\'s enough. Let\'s go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59729,'','This is no place for a bright, young $g man : lady; such as yourself.$B$BPerhaps you would like for me to escort you to safety, hmm?',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(59730,'Yes... why don\'t you \"escort\" me out of here.','Yes... why don\'t you \"escort\" me out of here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59731,'','Please, $g mister : ma\'am;..$B$BWill you get me out of here?',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(59732,'$n, was it? There\'ll be a few extra gold for you if you can personally guarantee my safety.','',0,0,0,0,0,0,0,0,1,17841,0,0,26124),
(59733,'','You\'re... working for the Shado-Pan? I can\'t believe it!',0,0,0,0,0,0,0,0,1,17840,0,0,26124),
(59734,'','When these monsters came, the Shado-Pan got so serious... they kept saying, \"Sha\". What\'s that?',0,0,0,0,0,0,273,0,1,17839,0,0,26124),
(59735,'These aren\'t as light as they look. Could we make haste?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59736,'How far must we go?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59737,'When we make it back to the Retreat, we can tap these and toast to life!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59738,'I hear that the yaungol busted through the gates up north. Wonder what happened to the Shado-Pan there?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59739,'My father brewed Firebough Stout. His father did before him. I can\'t let the legacy die out.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59740,'There\'s really nothing quite like a warm brew. Warms your bones and hits the spot. You can keep that cold stuff to yourself.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59741,'Well, yeah, sure... who hasn\'t heard of Chen Stormstout? Though, I hear his keg\'s empty, if you know what I mean.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59742,'Uh oh. Looks like I\'ve sprung a leak! The brew!!!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(59743,'Are you working with the Shado-Pan? I can\'t believe they\'d let an outsider help them!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(59744,'These yaungol never even bothered to say hello. They simply attacked! Serves them right being infested by those sha things!','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(59745,'All of my people, dead. Maybe I should build a new manor in Binan Village?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(59746,'Kobai used to threaten us, that was all. Now... whatever mind he had, he\'s clearly lost.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59747,'I\'m going to give Shado-Master Chong a piece of my mind when I see him. The nerve of the Shado-Pan not coming to our aid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59748,'I think I can speak for everyone when I say that you\'re a true hero of Kun-Lai Summit, not to mention Firebough Nook, $p!','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(59749,'I really wasn\'t built for this. I\'m a master orator and diplomat of the people. Are we quite done here yet?','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(59750,'I trust that you\'re planning to do something about that giant surge of anger that\'s erupting from the middle of the lake?!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(59751,'Is that... is that Huo?','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(59752,'It is! Well done, $p!','',0,0,0,0,0,0,71,0,1,0,0,0,26124),
(59753,'','Hi-Ya!',0,0,0,0,0,0,37,0,1,0,0,0,26124),
(59754,'','Fus Ro Dah!',0,0,0,0,0,0,463,0,1,0,0,0,26124),
(59755,'','I see your Way of the White Tiger, Jade Serpent, Monkey Crane technique is as good as mine.',0,0,0,0,0,0,508,0,1,0,0,0,26124),
(59756,'','Cry in the dojo. Laugh on the battlefield. Ahahahahahaha!',0,0,0,0,0,0,153,0,1,0,0,0,26124),
(59757,'Take that monkeybutt!','',0,0,0,0,0,0,5,0,1,0,27344,0,26124),
(59758,'','Sweep the leg!',0,0,0,0,0,0,477,0,1,0,0,0,26124),
(59759,'','GET... OUT... OF... MY... TOWN!',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(59760,'','Flow like the water, bend like the reed... blah, blah, blah. Just kick some butt!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59761,'','Judge me by my age, would you?',0,0,0,0,0,0,14,0,1,0,0,0,26124),
(59762,'We\'ve already lost the town... why have no reinforcements arrived from the Monastery?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59763,'Knucklethumps thump! Thump! Thump!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59764,'Wikkets no take packers back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59765,'Hozen steal munchpacks fair and square. No take backs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59766,'No wikkets allowed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59767,'For big King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59768,'Chief say ravage, so hozen ravage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59769,'Ookin wikket! Get back here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59770,'The Golden Lotus has overseen the Vale for thousands of years.$B$BThe heavens have sent us their sign, and we stand united in our belief that it is time to open the gates once more.$B$BAre you ready?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59771,'I am ready to open the gates.','I am ready to open the gates.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59772,'AWESOME AMAZING GATE OPENING CINEMATIC GOES HERE!!!','AWESOME AMAZING GATE OPENING CINEMATIC GOES HERE!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59773,'Firing','Firing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59774,'Rampaging yeti?! Hmm. This gives me a most big idea.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59775,'Ookin wikkets gonna try to keep munchpacks from Broketooth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59776,'Of course. Don\'t worry.','Of course. Don\'t worry.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59777,'You made it through! Come, we must speak.','',0,0,0,0,0,0,0,0,1,15974,0,0,26124),
(59778,'As trying as these times are, we must control our emotions, lest they be used by the Sha.','',0,0,0,0,0,0,0,0,1,15975,0,0,26124),
(59781,'I felt Fury\'s demise. You have done well.','',0,0,0,0,0,0,0,0,1,15991,0,0,26124),
(59782,'The eyes of the angry hozen are upon you, ooker.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59783,'Grummles have good noses. Can tell the difference between good and bad fortune by the smell. You have the smell of good fortune about you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59784,'The Shado-Pan are not here because the wall needs them. Grummles owe much fortune to the Shado-Pan. If the Shado-Pan cannot defend grummles that means they are in danger, and need grummlepacks now more than ever.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59785,'The Jib of Dook was a friend of grummles. He lasted a whole three seasons. Now the Ook of Dook is in charge and most angry. He thinks food from grummles will stop soon, so he ravages.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59786,'Many good fortunes to you. I am Brother Rabbitsfoot. I am a merchant, a traveller, and a big luckydo for grummles.$b$bIn times of peace, $p would do well to buy of my wares. But fortune has us meet this day.$b$bWe have much work to do together.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59787,'The hozen fed my yaks to their pet yeti. This is most bad fortune.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59788,'Brother Rabbitsfoot may be smart and tall, and smells of luck and good fortune. But he snores and makes bad jokes about my luckydo yakshoe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59789,'Want to see my luckydo? This is the shoe of the yak that carried me when I was most small. Many years this shoe has given me much fortune.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59790,'What\'s your luckydo? All travellers of great roads need their luckydos.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59791,'You reek of fortune! Many thanks for saving me, Luckydo! You can call me Brother Yakshoe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59792,'Ah, $rs are most useful. Should have more $rs for rainy day.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59793,'Grummle up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59794,'Bad fortune to be here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59795,'This a most not good place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59796,'Hozen stink of bad fortune.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59797,'Ah! A grummlepack. Most good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59798,'I know these luckydos.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59799,'You have done well. We will keep these weapons under close guard, hidden away here in this hall. The mogu shall never see these treasures again.','',0,0,0,0,0,0,0,0,1,0,29047,0,26124),
(59800,'Ah, a good stash of things.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59801,'Well done! The Thunder King\'s axe is ours.','',0,0,0,0,0,0,0,0,1,0,29046,0,26124),
(59803,'$n, I implore you to go to the Gate of Winter\'s Blossom and seek out Shado-Master Maikee as soon as you can.','',0,0,0,0,0,0,0,0,1,15992,0,0,26124),
(59805,'I heard the crocs are attacking because of an ancient mogu curse.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(59806,'Ookin wikkets not gonna stop the ravage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59807,'I say just let the crocolisks come. They\'ll stop attacking eventually. Why interfere?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59808,'Wikkets gonna burn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59809,'Broketooth need food. Wikkets have food. Ravage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59810,'New king, new rules. Sorry, but wikkets gonna get ravaged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59811,'This raft is all yours, neighbor. You ever want to go rafting, just come back here. It\'ll be waiting for you.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(59812,'Time for the feedings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59813,'Learning','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59814,'Kung Din pounced on you! Fight for your life! |TInterface\\Icons\\ability_warrior_secondwind.blp:20|t','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59815,'','Welcome friend!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59816,'','Have a seat at the bar, friend. I\'ll get you some food.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59817,'','Hello $c!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59818,'','Oh, Hello! Can I interest you in a piping hot cup of tea before you leave?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59819,'','My grandmother used to tell me it was bad for a fighter\'s balance to enter battle on an empty stomach!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59820,'','Hello, $n! You\'re making quite a name for yourself here!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59822,'','Welcome back, $n! I see you found our missing guides!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59823,'','Welcome Back, $n!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59824,'','Now that Ji-Lu has his trinkets back maybe I\'ll get some peace in the inn!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59825,'','Hello again, $c!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59826,'','What a pleasure it is to have the great $n in my establishment!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59827,'','Greetings, $n!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59828,'','You are always welcome at the inn, $n!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59829,'','The hero of One Keg returns!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59830,'','Ok you two, play nice!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59831,'Welcome to my humble shop, $c.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59832,'Feel free to browse my wares.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59833,'Greetings, $c! you look like you might be interested in some fresh spices! Perhaps some books for your journey.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59834,'Welcome! You won\'t find a better selection east of the camp!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59835,'Be sure to stop by and see me again, $c!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59836,'The Vale is my home. It is my duty and my desire to protect it from harm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59837,'The winds are good today.','',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(59838,'Fortune smiles on grummle mounts.','',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(59839,'Come back soon!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59840,'The mountain will forgive the bird, but not always the rider.','',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(59841,'You here to fish?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59842,'I can\'t imagine what caused these crocolisks to start attacking. What changed?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59843,'Thanks again for all your help, $n. The crocolisks aren\'t attacking nearly as much as they were before.$b$bWe\'re also doing our part here. We haven\'t caught any more fish than we need to eat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59844,'','Hello, $r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59845,'Nothin\' to see here... move along!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59846,'I\'m a little basket filled with grain...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59847,'I won\'t go back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59848,'I\'m just a little grummle in a scary world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59849,'Are you sure you don\'t want to come with me?','Are you sure you don\'t want to come with me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59850,'Nope! Grummle is safe here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59851,'','Allow me to make your underwater experience a little more... pleasant.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59852,'Can you increase my swim speed again?','Can you increase my swim speed again?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59853,'Aaaaaaaah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59854,'Wikkets be crazy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59855,'Poot Poot is loose! Run!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59856,'Mad yeti! Mad yeti!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59857,'Ook me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59858,'Pootacalypse!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59859,'Woops!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59860,'','This is the tale of the Hungry Crocolisk.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59861,'','The crocolisks of Narsong Trench ate fish. They were fat and happy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59862,'','Then the sharks came.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59863,'','The sharks competed for the fish, but the crocolisks survived.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59864,'','Soon after, the pandaren arrived.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59865,'','The pandaren fished in the trench\'s waters, but the crocolisks survived.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59866,'','Finally, the hozen came to Narsong Trench.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59867,'','The hozen overfished the area, catching more fish than they could eat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59868,'','With no fish to eat, the crocolisks became hungry and desperate. They attacked the pandaren out of sheer hunger.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59869,'','The pandaren, in fear and defense, killed all the crocolisks of Narsong Trench.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59870,'A pair of Zandalari Trolls burst through the doors ahead of you!','',11,0,0,0,0,0,0,0,0,0,0,0,26124),
(59871,'No matter! We don\'t be needin\' what\'s back dat way anyhow!','',23,0,0,0,0,0,0,0,0,0,29086,0,26124),
(59872,'Now you done made me angry!','',14,0,0,0,0,0,0,0,0,0,29087,0,26124),
(59873,'Fine, den! Time ta play, friends.','',11,0,0,0,0,0,0,0,0,0,29088,0,26124),
(59874,'','The Narsong crocolisk is no more... simply because the pandaren didn\'t see the whole story.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59875,'Hey there! Are you the one that brought back the fire spirit?','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(59876,'Was he hot?  I bet he was hot!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(59877,'Of course he was hot! Don\'t be dumb, Deng.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(59878,'Okay bye.','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(59879,'I bet you\'re really strong, huh?  You could probably kick that bridge right in half if you wanted to!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(59880,'Nuh uh. Bet they could for sure kick you over that hill, though! Hah!','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(59881,'Not again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59882,'None of you saw that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59883,'My braids!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59884,'Bye!','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(59885,'She is trying to throw you off, hold on tight!$b$b|TInterface\\Icons\\inv_misc_desecrated_leatherglove.blp:32|t Hold On','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59886,'%s begins to |cFFFF0404|Hspell:116711|h[Draw Flame]|h|r to his weapon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59887,'My spirit is lifted with the sight of you, $c. We fight on two fronts.$B$BWe\'re trying to push back the yaungol horde at the gate. And up on the mountain to the north, we\'ve lost the Shado-Pan Monastery to unknown forces.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(59888,'You attack me like this, $p? What a puny plan!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(59889,'Time for big BA BAM!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59893,'Ungh... the banner is yours.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59894,'What the? Who?!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(59895,'I took your dead master\'s banner. Come at me, $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59896,'Ya can\'t let anyone through, mon. Or it\'s ya\' head.','Ya can\'t let anyone through, mon. Or it\'s ya\' head.',397,0,0,3,0,0,0,0,1,0,0,0,26124),
(59897,'How \'da preparations comin\', mon?','How \'da preparations comin\', mon?',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(59898,'Grook \'em!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59899,'We gork big dooker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59900,'We grooked!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59901,'AHHHHHHH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59902,'Run wikket!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59903,'Save wikket!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59904,'Dey comin, dey comin!','Dey comin, dey comin!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59905,'... dey bettah be.','... dey bettah be.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59906,'My spear will finish you!','',0,0,0,0,0,0,0,0,1,0,28212,0,26124),
(59907,'Cower at the sight of your own doom!','',0,0,0,0,0,0,0,0,1,0,28213,0,26124),
(59908,'','Hey, $n, over here. We need your help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59909,'This bad. This real bad.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59910,'There\'s nothing like a good cup of kafa! When the seeds are roasted just right, ground fresh, and brewed in pure water.$B$BPerfect for the weary traveler or studious monk.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59911,'What was I thinking! Such a luckydont!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59912,'Nope... nope... not good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59913,'Shoulda never fed them goots.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59914,'','Hey! You here to challenge me to a fight?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59915,'Let\'s fight!','Let\'s fight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59916,'I look forward to our melee. Of course, I plan to win.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59917,'','I\'ve been training really hard! There\'s no way you can defeat me now, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59918,'I\'m very interested in seeing your fighting style, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59919,'','Hey there, sweetie. You\'re lookin\' pretty good in all that fancy armor.$b$bSo you\'ve found the way of the Red Crane, too? Interested in a duel?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59920,'You will not find many jinyu here in the Cradle of Chi-Ji. In fact, I believe I may be the only one.$b$bIn general, my people shun Chi-Ji and his teachings. The crane dines on carp, after all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59921,'','Thelonius has told me much about your skill in battle. I look forward to seeing it firsthand.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59922,'','Hello, rival.$b$bI\'ve been busy training.$b$bI hope you\'ve done the same.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59923,'Tukka-Tuk gonna punch you and pound you and kick you and scratch you and bite you and poke you and ook you and dook you and...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59924,'Howdy, neighbor.$b$bI heard a lot about you. You been winnin\' duels all over this here island. I suppose I\'m ready to give you a shot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59925,'Nobody can defeat me.$b$bI\'ve been on this island for weeks, fighting duels every day, and nobody\'s come close to winning.$b$bIs this the best Pandaria has to offer?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59926,'You\'ve faced the best of our trainees, and defeated them all. Now let\'s see what you\'re really made of...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59927,'It is me again. It is good to see you, $n.$b$bShall we begin?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59928,'It is a rare and auspicious day when I get to test my abilities.$b$bI think you are ready to fight me, $n. Let us find out if I am correct.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59929,'','The path of the Red Crane is a path of failure. I have seen the truth!$b$bAll paths lead to despair! You have no hope! NONE OF YOU!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59930,'Are you here for a fight?','Are you here for a fight?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59931,'','Alright, my first fight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59932,'Prepare for the beating of your life, weakling!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59933,'','Today is the day I defeat my rival!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59934,'I apologize in advance for the beating you are about to suffer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59935,'','YAAAAAAAAHHHH!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59936,'Your winning streak ends here, $n. Today, you fall by my spear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59937,'','I will not hold back on you, $n. Please, do me the same favor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59938,'','Just give up! It\'s hopeless! You\'ll never beat me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59939,'Good idea! Let\'s ookin\' get it on!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59940,'Don\'t rule me out be just \'cause I\'m a country boy! I got freakish strong arms, you know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59941,'<sigh>...Let\'s get this over with.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59942,'By the name of Chi-Ji, I smite you down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59943,'Give me everything you have, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59944,'Ha ha! Don\'t pull any punches!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59945,'','My hated rival... so glad you came.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(59946,'You stand no chance.','You stand no chance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59947,'','Alright, $p... we are now RIVALS. You haven\'t seen the last of me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59948,'I am... humbled.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59949,'','I lost to $p, twice in a row? I can\'t believe it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59950,'Very interesting...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59951,'','Nice moves, sweetie. Maybe I\'ll see you again...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59952,'My father foresaw this day in the waters. He told me that I would be defeated, but I refused to believe it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59953,'','It\'s been a while since I lost to a trainee. Thank you for the match.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59954,'','How did... I don\'t... no, no NO! NOT AGAIN!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59955,'Tukka-Tuk pretty sad about losing to wimpy $p. Tukka-Tuk gonna go look at horizon and think about life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59956,'Nice moves. You keep reapin\' in those wins like grain, neighbor. I\'ll be rootin\' for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59957,'Now THAT\'S what I was looking for! You\'ve given me a reason to train again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59958,'Impossible...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59959,'Yes... yes, I believe you will do. I will see you again shortly, $p.','',0,0,0,0,0,0,0,0,1,16059,0,0,26124),
(59960,'The taste of defeat... so strange and unfamiliar. Thank you for keeping me humble.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59961,'','N-no...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59962,'Well fought. Until next time...','Well fought. Until next time...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59963,'Trolls... I thought they were but legend!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59964,'Steer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59965,'$n, with the crane\'s powers, you can jump over the flames!','',0,0,0,0,0,0,0,0,1,0,29543,0,26124),
(59966,'Stop! Turn back and speak to Sinan at the bottom of the stairs. You should not face the Warlord\'s wrath alone!','',0,0,0,0,0,0,0,0,1,0,29544,0,26124),
(59967,'Wait. I got here as quickly as I could. I\'m not too late, I hope.','',0,0,0,0,0,0,0,0,1,0,29619,0,26124),
(59968,'It is not much, but I will lend you what little I have. May it help you in this final hour.','',0,0,0,0,0,0,0,0,1,0,29620,0,26124),
(59973,'Video of leaving the turtle and traveling to Stormwind via hot air balloon.','Video of leaving the turtle and traveling to Stormwind via hot air balloon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59974,'Video of leaving the turtle and traveling to Orgrimmar via hot air balloon.','Video of leaving the turtle and traveling to Orgrimmar via hot air balloon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59975,'Watch my weapon: TIGER WIND!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59976,'Here it comes: TIGER WIND!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59977,'Are you ready?! TIGER WIND!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59978,'Whirling death: TIGER WIND!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59979,'Pick up those spears before they overload! Throw them back at him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59980,'Give in to your anger!','',0,0,0,0,0,0,0,0,1,0,29005,0,26124),
(59981,'The Vale was once the seat of power of the great mogu empire. The time of the mogu reign was terrible, cruel, and bloody.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59982,'Please rest while you are here, $n. I hope the Vale brings you much peace and happiness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59983,'Oh good, a $g hero : heroine; of the land. Come, let us speak, $c.','',0,0,0,0,0,0,0,0,1,16062,0,0,26124),
(59984,'You must seek out Shado-Master Zhen if you\'re to aid us here, $c.','',0,0,0,0,0,0,0,0,1,16063,0,0,26124),
(59985,'Our hearts are heavy with grief at the passing of master Zhen. Will you face Humongous to regain his honor, $n?','',0,0,0,0,0,0,0,0,1,16064,0,0,26124),
(59986,'The keg bombs are ready. $n, are you going to stop the yaungol?','',0,0,0,0,0,0,0,0,1,16065,0,0,26124),
(59987,'The $g hero : heroine; returns triumphant. How are you, $n?','',0,0,0,0,0,0,0,0,1,16066,0,0,26124),
(59988,'You\'re lucky I haven\'t fought in a while, $p.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59989,'%s goes into a |cFFFF0000|Hspell:116982|h[Protective Frenzy]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59990,'','Hey, $c, over here!',0,0,0,0,0,0,0,0,1,16076,0,0,26124),
(59991,'','Those spearthrowers are still firing. Don\'t you like destroying stuff, $c?',0,0,0,0,0,0,0,0,1,16082,0,0,26124),
(59992,'','Go get \'em, tiger!',0,0,0,0,0,0,0,0,1,16085,0,0,26124),
(59993,'','See you there, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59994,'Hope you\'re ready for a bruising, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(59995,'','Hi, $n! Going to join me?',0,0,0,0,0,0,0,0,1,16085,0,0,26124),
(59996,'','These yaungol thought the sha were scary until they met me!',0,0,0,0,0,0,0,0,1,16085,0,0,26124),
(59997,'','There\'s nothing better than working up a sweat with a good fight!',0,0,0,0,0,0,0,0,1,16085,0,0,26124),
(59998,'','Once, I brained an opponent who was stunned to see that my pants had fallen down during battle. He wasn\'t looking where he should have been.',0,0,0,0,0,0,0,0,1,16085,0,0,26124),
(59999,'','Bouncy, bouncy!',0,0,0,0,0,0,0,0,1,16085,0,0,26124),
(60000,'','I\'ve lost count of the yaungol I\'ve killed. How many have you gotten, $n?',0,0,0,0,0,0,0,0,1,16085,0,0,26124),
(60001,'','Don\'t let Maikee know, but I kinda love him even if he is a grump.',0,0,0,0,0,0,0,0,1,16085,0,0,26124),
(60002,'You there! Be you friend or foe?','',0,0,0,0,0,0,0,0,1,16087,0,0,26124),
(60003,'What? Are you too good to help us out here?','',0,0,0,0,0,0,0,0,1,16088,0,0,26124),
(60004,'The Alliance has lost control of the Diamond Depot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60005,'The Horde has lost control of the Diamond Depot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60006,'The Alliance has taken control of the Diamond Depot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60007,'I thought you were going to hit them. You roll that keg like you\'re new, or something.','',0,0,0,0,0,0,0,0,1,16089,0,0,26124),
(60008,'The |cFFFF0000Horde|r has taken control of the Diamond Depot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60009,'The Alliance has lost control of the Lava Depot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60010,'The |cFFFF0000Horde|r has lost control of the Lava Depot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60011,'The Alliance has taken control of the Lava Depot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60012,'The |cFFFF0000Horde|r has taken control of the Lava Depot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60013,'The Alliance has lost control of the Troll Depot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60014,'The |cFFFF0000Horde|r has lost control of the Troll Depot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60015,'The Alliance has taken control of the Troll Depot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60016,'About time. We\'re starting to run out of kegs here.','',0,0,0,0,0,0,0,0,1,16090,0,0,26124),
(60017,'The |cFFFF0000Horde|r has taken control of the Troll Depot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60018,'The Alliance has lost control of the Waterfall Depot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60019,'The |cFFFF0000Horde|r has lost control of the Waterfall Depot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60020,'The Alliance has taken control of the Waterfall Depot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60021,'The |cFFFF0000Horde|r has taken control of the Waterfall Depot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60022,'Hrmph.','',0,0,0,0,0,0,0,0,1,16091,0,0,26124),
(60023,'What are you doing back here? Slumming?','',0,0,0,0,0,0,0,0,1,16091,0,0,26124),
(60024,'What\'s that Leesa Li going on about? Love?!','',0,0,0,0,0,0,0,0,1,16091,0,0,26124),
(60025,'Oh, it\'s you.','',0,0,0,0,0,0,0,0,1,16091,0,0,26124),
(60026,'Meh.','',0,0,0,0,0,0,0,0,1,16091,0,0,26124),
(60027,'Someone should finish these yaungol off. I\'ve got better things to do than stand around here all day!','',0,0,0,0,0,0,0,0,1,16091,0,0,26124),
(60028,'Just the other day I saw a much more powerful $c flying overhead.','',0,0,0,0,0,0,0,0,1,16091,0,0,26124),
(60029,'Hey, Leesa. You\'re $g boyfriend\'s : girlfriend\'s; here!','',0,0,0,0,0,0,0,0,1,16091,0,0,26124),
(60030,'The Eastern Crossroads changed tracks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60031,'The Eastern Crossroads changed tracks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60032,'The Northern Crossroads changed tracks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60033,'The Northern Crossroads changed tracks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60035,'Your rage sustains me!','',0,0,0,0,0,0,0,0,1,0,29007,0,26124),
(60036,'My wrath flows freely!','',0,0,0,0,0,0,0,0,1,0,29009,0,26124),
(60037,'Your rage gives you strength!','',0,0,0,0,0,0,0,0,1,0,29006,0,26124),
(60038,'You will not bury me again!','',0,0,0,0,0,0,0,0,1,0,29008,0,26124),
(60039,'','Still clinging to the tailfeathers of Chi-Ji, and his idiotic notions of \"hope\"?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(60040,'','I will show you the meaning of despair... and I will drag this whole island down with me!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(60041,'I\'m such a luckydont! I ruined Uncle Keenbean\'s kafa trade!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60042,'You never shoulda fed dem goots, Cousin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60043,'This is what happen when you get lazy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60044,'Kafa good for grummles and pandaren - not good for goots and yetis and hozen. You should know that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60045,'Hold on! This is gonna be a bumpy ride!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60046,'','And so our path lays before us. Speak to Master Shang Xi, he will tell you what comes next.',0,0,0,0,0,0,0,0,1,0,0,27399,26124),
(60047,'The... village... dead...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60049,'I smell my luckydo! Oh please bring to me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60050,'Help! They took my luckydo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60051,'Heya, $n. Nice work here, chief.','',0,0,0,0,0,0,0,0,1,16105,0,0,26124),
(60052,'What gives? You gotta get to that farm. Did Kiryn send you to do her work? She\'s so lazy!','',0,0,0,0,0,0,0,0,1,16106,0,0,26124),
(60053,'You\'re helpin\' those farmers out, right, ace? We\'re countin\' on you to get us some grub.','',0,0,0,0,0,0,0,0,1,16107,0,0,26124),
(60054,'Good to hear you got those farmers all squared away, chief. Now we gotta take care of some new business.','',0,0,0,0,0,0,0,0,1,16108,0,0,26124),
(60055,'You gotta blow those oil rigs, $n. We don\'t want them stinky yaungol raining exploding fire kegs down on our heads!','',0,0,0,0,0,0,0,0,1,16109,0,0,26124),
(60056,'The sound of those explosions was like music to my ears. Come here, $n. Give me a hug!','',0,0,0,0,0,0,0,0,1,16110,0,0,26124),
(60057,'There $g he : she; is!','',0,0,0,0,0,0,0,0,1,16111,0,0,26124),
(60058,'Hey, lookie here. It\'s $n!','',0,0,0,0,0,0,0,0,1,16111,0,0,26124),
(60059,'What\'s next, $n? Gonna take on the whole yaungol army by yourself? You could do it, too!','',0,0,0,0,0,0,0,0,1,16111,0,0,26124),
(60060,'Me and $n go way back. Ain\'t that right, $n?','',0,0,0,0,0,0,0,0,1,16111,0,0,26124),
(60061,'Yeah. I taught $n everything $g he : she; knows.','',0,0,0,0,0,0,0,0,1,16111,0,0,26124),
(60062,'Between you and me, $n, these Kun-Lai guys are kinda slow. Nothin\' like us!','',0,0,0,0,0,0,0,0,1,16111,0,0,26124),
(60063,'Hey you! Faster! Chop chop! Oh hey, hiya, $n. What\'s cookin\'?','',0,0,0,0,0,0,0,0,1,16111,0,0,26124),
(60064,'Pay your respects. $n is in the house!','',0,0,0,0,0,0,0,0,1,16111,0,0,26124),
(60065,'I cannot emphasize enough how important it is that you kill those channelers and bring that shield down, $n.','',0,0,0,0,0,0,0,0,1,16114,0,0,26124),
(60066,'Good work, friend. Speak with Kiryn and Rivett while I assess our new surroundings.','',0,0,0,0,0,0,0,0,1,16113,0,0,26124),
(60067,'Good. The shield is down. But what are you doing back here?','',0,0,0,0,0,0,0,0,1,16115,0,0,26124),
(60068,'$n, please listen closely. You MUST go back to Ordo Ragemesa and kill their chief.','',0,0,0,0,0,0,0,0,1,16116,0,0,26124),
(60069,'Is that a smile on your face? Are you about to tell me that the Ordo Warbringer is dead?','',0,0,0,0,0,0,0,0,1,16117,0,0,26124),
(60070,'Good to see you, $n.','',0,0,0,0,0,0,0,0,1,16118,0,0,26124),
(60071,'What word do you bring from the rest of Kun-Lai Summit?','',0,0,0,0,0,0,0,0,1,16118,0,0,26124),
(60072,'If there were one thing that you could tell me that would make today better, $n, it would be that Taylor is dead.','',0,0,0,0,0,0,0,0,1,16118,0,0,26124),
(60073,'One of these days we\'re going to have to talk about you joining my group, $n.','',0,0,0,0,0,0,0,0,1,16118,0,0,26124),
(60074,'You sticking around for a while? We should drink.','',0,0,0,0,0,0,0,0,1,16118,0,0,26124),
(60075,'You know, you could just head over to Westerly Rest and kill all of those Alliance fools.','',0,0,0,0,0,0,0,0,1,16118,0,0,26124),
(60076,'I heard that the Shado-Pan were having trouble to the southwest. Know anything about that, $n?','',0,0,0,0,0,0,0,0,1,16118,0,0,26124),
(60077,'I\'m getting fat and lazy just standing around here. I need some action!','',0,0,0,0,0,0,0,0,1,16118,0,0,26124),
(60078,'Can you survive? TIGER BOMB!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60079,'Deadly attack: TIGER BOMB!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60080,'Death from above: TIGER BOMB!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60081,'Special attack: TIGER BOMB!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60082,'Couldn\'t have done better myself, my $g boy : girl;! Now, let\'s get down to business.','',0,0,0,0,0,0,0,0,1,16122,0,0,26124),
(60083,'You already head o\'er to that farmstead? We\'re gonna run out of food here real quick, $g boyo : girlie;.','',0,0,0,0,0,0,0,0,1,16123,0,0,26124),
(60084,'Word is yer doin\' a fine job, $g lad : lass;. A fine job. I only ask that you finish up down there at the farm as soon as you can. We\'ve got some pretty hungry folks \'round here.','',0,0,0,0,0,0,0,0,1,16124,0,0,26124),
(60085,'Excellent work down there. Top notch. Now I\'ve got some other matters for ya if\'n your thinkin\' your up to some more skullbashin\'?','',0,0,0,0,0,0,0,0,1,16125,0,0,26124),
(60086,'You \'n me both know that those oil rigs ain\'t gonna blow themselves to smithereens. Well... they might, but it\'d be more fun if you did the deed, $n.','',0,0,0,0,0,0,0,0,1,16126,0,0,26124),
(60087,'Get o\'er here and give Sully a big ol\' hug, you scrapper! Them oil rigs went boom, one, two three! Ahahahahahaha!','',0,0,0,0,0,0,0,0,1,16127,0,0,26124),
(60088,'Here we go!','Here we go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60089,'Here I come!','Here I come!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60090,'There $g he : she; is! Oh, yer my favorite $g lad : lass;, yes you are, $n!','',0,0,0,0,0,0,0,0,1,16128,0,0,26124),
(60091,'Raise your weapon, $r! Let\'s fight!','Raise your weapon, $r! Let\'s fight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60092,'I\'ve never seen a finer $c than $n, and neither have you!','',0,0,0,0,0,0,0,0,1,16128,0,0,26124),
(60093,'%s cries softly to himself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60094,'Glory to Chi-Ji!','Glory to Chi-Ji!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60095,'You\'ve got yourself a duel, $c.','You\'ve got yourself a duel, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60096,'Now look who\'s here. Heya, $n, bring us a pint and get o\'er here!','',0,0,0,0,0,0,0,0,1,16128,0,0,26124),
(60097,'Come on! Let\'s brawl!','Come on! Let\'s brawl!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60098,'I tell ya, ten years from now everyone will be talkin\' about the time that ol\' Sully the Pickle and $n lit a fire right under those stinkin\' yaungol\'s noses and blew their oil rigs to kingdom come!','',0,0,0,0,0,0,0,0,1,16128,0,0,26124),
(60099,'I get all teary eyed just thinkin\' about all we been through together, $g boyo : lass;.','',0,0,0,0,0,0,0,0,1,16128,0,0,26124),
(60100,'These Kun-Lai pandaren are comin\' along just fine. Now if they\'d only show a little more of that scrappiness that you seem to be full of.','',0,0,0,0,0,0,0,0,1,16128,0,0,26124),
(60101,'What\'s this I hear \'bout trouble to the west at Firebough Nook?','',0,0,0,0,0,0,0,0,1,16128,0,0,26124),
(60102,'Oh sure, bein\' a nurse is fine and all for fixin\' folk up after all the hard work\'s been done.  Don\'t let that Mishka fool ya.','',0,0,0,0,0,0,0,0,1,16128,0,0,26124),
(60103,'','$n, a moment of your time, please? There\'s trouble that we need your help with.',0,0,0,0,0,0,0,0,1,16130,0,0,26124),
(60104,'','Have you been able to investigate Mogujia? Please don\'t tell me that little pickle dwarf has you running off somewhere else. Can\'t he do his own dirty work?',0,0,0,0,0,0,0,0,1,16131,0,0,26124),
(60105,'','Good news about Mogujia, $n?',0,0,0,0,0,0,0,0,1,16132,0,0,26124),
(60106,'|TInterface\\Icons\\spell_frost_summonwaterelemental.blp:20|t|cFF00AEEF $n has assaulted the Waterfall Depot!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60107,'|TInterface\\Icons\\spell_frost_summonwaterelemental.blp:20|t|cFFFF0000$n has assaulted the Waterfall Depot!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60108,'','You do plan on taking care of that troll, yes?  He is the one reanimating all of those mogu, no?',0,0,0,0,0,0,0,0,1,16133,0,0,26124),
(60109,'','It\'s so nice to no longer be hearing that troll go on and on! Thank you, $n!',0,0,0,0,0,0,0,0,1,16134,0,0,26124),
(60110,'|TInterface\\Icons\\spell_frost_summonwaterelemental.blp:20|t|r|cFF00AEEF$n has defended the Waterfall Depot!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60111,'','I\'m so worried about those poor captured pandaren. Have you had a chance yet to see what condition they\'re in, $n?',0,0,0,0,0,0,0,0,1,16135,0,0,26124),
(60112,'|TInterface\\Icons\\spell_frost_summonwaterelemental.blp:20|t|cFFFF0000$n has defended the Waterfall Depot!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60113,'','Oh, $n, you did it! It warms my heart to see the pandaren families reuniting.',0,0,0,0,0,0,0,0,1,16136,0,0,26124),
(60114,'','It is good to see you again, $n. How have you fared?',0,0,0,0,0,0,0,0,1,16137,0,0,26124),
(60115,'|TInterface\\Icons\\inv_waepon_bow_zulgrub_d_01.blp:20|t|cFF00AEEF$n has assaulted the Troll Depot!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60116,'|TInterface\\Icons\\inv_waepon_bow_zulgrub_d_01.blp:20|t|cFF00AEEF$n has Defended the Troll Depot!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60117,'|TInterface\\Icons\\inv_waepon_bow_zulgrub_d_01.blp:20|t|cFFFF0000$n has assaulted the Troll Depot!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60118,'|TInterface\\Icons\\inv_waepon_bow_zulgrub_d_01.blp:20|t|cFFFF0000$n has defended the Troll Depot!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60119,'','Your prowess as a $c is unquestionable.',0,0,0,0,0,0,0,0,1,16137,0,0,26124),
(60120,'','Do you have any news from afar, $n? Has the war against the yaungol finally been won?',0,0,0,0,0,0,0,0,1,16137,0,0,26124),
(60121,'','Admiral Taylor and I were just speaking about you. How are you, $n?',0,0,0,0,0,0,0,0,1,16137,0,0,26124),
(60122,'','$n, if you have the time later, perhaps you and I could sit and talk over tea?',0,0,0,0,0,0,0,0,1,16137,0,0,26124),
(60123,'|TInterface\\Icons\\inv_misc_gem_diamond_04.blp:20|t|cFF00AEEF$n has assaulted the Diamond Depot!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60124,'','You look remarkably well, $n. I\'m exhausted. A healer\'s work is never done.',0,0,0,0,0,0,0,0,1,16137,0,0,26124),
(60125,'|TInterface\\Icons\\inv_misc_gem_diamond_04.blp:20|t|cFFFF0000$n has assaulted the Diamond Depot!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60126,'','We hear so many conflicting stories about what\'s happening just out of sight. Tell me, $n, is it as bad as it sounds?',0,0,0,0,0,0,0,0,1,16137,0,0,26124),
(60127,'|TInterface\\Icons\\inv_misc_gem_diamond_04.blp:20|t|cFF00AEEF$n has Defended the Diamond Depot!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60128,'','I feel much safer with a $c like you around.',0,0,0,0,0,0,0,0,1,16137,0,0,26124),
(60129,'|TInterface\\Icons\\inv_misc_gem_diamond_04.blp:20|t|cFFFF0000$n has defended the Diamond Depot!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60130,'|TInterface\\Icons\\spell_shaman_lavaflow:20|t|cFF00AEEF$n has assaulted the Lava Depot!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60131,'|TInterface\\Icons\\spell_shaman_lavaflow:20|t|cFFFF0000$n has assaulted the Lava Depot!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60132,'|TInterface\\Icons\\spell_shaman_lavaflow:20|t|cFF00AEEF$n has Defended the Lava Depot!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60133,'|TInterface\\Icons\\spell_shaman_lavaflow:20|t|cFFFF0000$n has defended the Lava Depot!|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60134,'Another job well done, friend. You should see if Mishka and Sully need you?','',0,0,0,0,0,0,396,0,1,16139,32452,0,26124),
(60135,'Ordo Ragemesa is right on our border, $n. I need you to bring that shield down now or we\'re lost.','',0,0,0,0,0,0,0,0,1,16140,0,0,26124),
(60136,'My scouts tell me that you brought the shield down. I\'m confused as to why you\'re back here instead of up there killing their leader.','',0,0,0,0,0,0,0,0,1,16141,0,0,26124),
(60137,'There\'s no time to waste, $n. My intel tells me that the yaungol are about to launch an all-out last ditch assault. We\'re all counting on you to kill Chief Ragemesa.','',0,0,0,0,0,0,0,0,1,16142,0,0,26124),
(60138,'You have no idea how happy I am right now. If you were one of my officers, you\'d be getting a promotion!','',0,0,0,0,0,0,0,0,1,16143,0,0,26124),
(60139,'$n! How are you? I hear things from here and there about your heroics.','',0,0,0,0,0,0,0,0,1,16144,0,0,26124),
(60140,'Pull up a chair, $n. I could use the company.','',0,0,0,0,0,0,0,0,1,16144,0,0,26124),
(60141,'$n, what\'s this I hear about trouble at the Gate of Winter\'s Blossom? Are we looking at a second yaungol invasion even bigger than the first?','',0,0,0,0,0,0,0,0,1,16144,0,0,26124),
(60142,'You know what would be the cherry on top today? Nazgrim dead.','',0,0,0,0,0,0,0,0,1,16144,0,0,26124),
(60143,'If you ask me, you should round up a bunch of your friends and burn Easterly Rest to the ground, $n.','',0,0,0,0,0,0,0,0,1,16144,0,0,26124),
(60144,'Have you been to Shado-Pan Retreat or Firebough Nook yet, $n? I heard about trouble brewing there with the sha.','',0,0,0,0,0,0,0,0,1,16144,0,0,26124),
(60145,'$n! What else have you been up to out there? Let me give you a word of advice; don\'t accept a promotion that\'ll take you out of the action.','',0,0,0,0,0,0,0,0,1,16144,0,0,26124),
(60146,'So, $n, you have a near perfect track record. Tell me, how do you feel about the Navy?','',0,0,0,0,0,0,0,0,1,16144,0,0,26124),
(60147,'Welcome to the Cradle of Chi-Ji, friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60148,'Welcome back to the Cradle of Chi-Ji, friend! I am glad to see that you\'ve returned.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60149,'Our new challenger returns! Welcome, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60150,'Welcome back, $n. I\'ve been eagerly anticipating your return.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60151,'It\'s an honor, $n. Welcome back to the Cradle of Chi-Ji.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60152,'Hail, Champion of Chi-Ji! Your presence honors us, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60153,'Are you ready to face your next challenger?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60154,'I have no more trials for you today, $n. Return to us again soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60155,'This is the hallowed birthplace of Chi-Ji, the Red Crane, the Southern Celestial. Followers and acolytes of Chi-Ji gather in this place to train their bodies, to hone their minds, to duel one another, and to better themselves in the eyes of the Red Crane.$b$bYou are welcome to join us in our training, $c. Bring with you a stout heart and a stout staff.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60156,'I see.','I see.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60157,'What is this place?','What is this place?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60158,'Entering defensive mode.  Disabling output failsafes.','',0,0,0,0,0,0,0,0,1,0,28534,0,26124),
(60159,'Yes, YES! Bring your rage to bear! Try to strike me down!','',0,0,0,0,0,0,0,0,1,0,28999,0,26124),
(60160,'Wikkets did this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60161,'All your fault!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60162,'Jib them in the nib!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60163,'Oooooooook you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60164,'Jib in snibbets!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60165,'Take all of the nibs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60166,'Wikkets gonna hurt!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60167,'[PH] Troll Boss unleashes a |cffcc00ffCursed Voodoo Hex!|r [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60168,'[PH] Troll Boss unleashes a |cff996300Diseased Voodoo Hex!|r [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60169,'[PH] Troll Boss unleashes a |cff0033ffMagical Voodoo Hex!|r [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60170,'[PH] Troll Boss unleashes a |cff00b300Poisonous Voodoo Hex!|r [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60171,'[PH] Troll Boss unleashes a |cffcc00ffCursed,|r |cff996300Diseased Voodoo|r |cffcc00ffHex!|r [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60172,'[PH] Troll Boss unleashes a |cff0033ffMagical,|r |cff00b300Poisonous Voodoo|r |cff0033ffHex!|r [PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60173,'What the-?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60174,'Impossible!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60175,'UNF!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60176,'Excellent move!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60177,'Look, pretty girl, look! The nice $r brought some kafa treats for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60178,'I think it\'s working...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60179,'AAAAGHHHHH!!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60180,'No! I\'ve lost focus on the torch!','',0,0,0,0,0,0,0,0,1,16156,0,0,26124),
(60181,'Must... regain... control...','',0,0,0,0,0,0,0,0,1,16156,0,0,26124),
(60182,'Welcome to Anglers Wharf $r.  Feel free to take a look around, there is much an angler can learn here.','Welcome to Anglers Wharf $r.  Feel free to take a look around, there is much an angler can learn here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60183,'This spell will speed you up in the water.  Just in case you run into a shark!','This spell will speed you up in the water.  Just in case you run into a shark!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60184,'They seem to be biting pretty good today.','They seem to be biting pretty good today.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60185,'Here fishy, fishy fishy...','Here fishy, fishy fishy...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60186,'An orb of |cFFF00000|Hspell:117227|h[Corrupted Water]|h|r forms!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60187,'Yea, sure. There\'s supposed\'ta be big forest here. Druids, all that. Big whoop, it\'s time for my break.','Yea, sure. There\'s supposed\'ta be big forest here. Druids, all that. Big whoop, it\'s time for my break.',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(60188,'','Ji, stop! This is reckless and stupid.',0,0,0,0,0,0,5,0,1,0,0,27413,26124),
(60189,'Aysa, this is our only option. We blow the ship free, then we heal his wound. We have no other solution.','',0,0,0,0,0,0,1,0,1,0,27329,0,26124),
(60190,'','If you stop this, then maybe we can come up with one.',0,0,0,0,0,0,274,0,1,0,0,27414,26124),
(60191,'So we just wait until we think of something? Shen-zin Su is dying! Doing nothing risks everything!','',0,0,0,0,0,0,6,0,1,0,27330,0,26124),
(60192,'','Doing THIS risks everything!',0,0,0,0,0,0,5,0,1,0,0,27415,26124),
(60193,'I\'d rather die knowing that at least we tried.','',0,0,0,0,0,0,1,0,1,0,27331,0,26124),
(60194,'','Ji... if this is what you must do, I will not stop you, but we could lose everything. I hope you\'re right.',0,0,0,0,0,0,1,0,1,0,0,27416,26124),
(60196,'We\'re... we\'re alive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60197,'<The massive yeti looks at you expectantly.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60198,'<Unscrew the flask and offer it to her.>','<Unscrew the flask and offer it to her.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60199,'A brew sure would be nice right now.','A brew sure would be nice right now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60200,'Got one!','Got one!',71,0,0,0,0,0,0,0,1,0,0,0,26124),
(60201,'I had it!  Must have been a huge one to take all my bait!','I had it!  Must have been a huge one to take all my bait!',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(60202,'Lots of nibbles today, but not many bites.','Lots of nibbles today, but not many bites.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60203,'','This is reckless, even for Ji. I need to stop him. Are you coming?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(60204,'Let\'s go.','Let\'s go.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(60205,'Okay... I think... I can stand...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60206,'I... is the ground shaking?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60207,'The first group that came - the Trolls... they cared nothing for us - walked right past us, pushing our families out of the way.\n\nThe next, though - the mercenaries. They took us prisoner, stole from our homes, and threatened us with death if we resisted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60209,'Perhaps we should have resisted - because, despite the fact that we... I... allowed them to take what they wanted, they killed us anyways.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60210,'Or, they killed most of us. I was the village\'s healer - after they ran me through, I was able to apply enough of my medical skills to keep me alive... but barely.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60211,'','Aysa sighs.',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(60212,'We should return... I am sure my skills will be needed at my cousin\'s village. And... we must prepare a funeral for those we have lost.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60213,'All right. Let us make haste to the village!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60214,'Cousin! You are well?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60215,'Yes, cousin. But... the village.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60216,'I... understand. Come, we must talk.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60217,'Thank you, $r. It would be my honor to fight at your side.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60218,'Just what I was waiting for! Time to introduce those yaungol to my fists!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60219,'I\'m in your debt, stranger. Please let me help you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60220,'Thank you for freeing me, $Gbrother:sister;. I cannot let you fight alone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60221,'Any luck today?','Any luck today?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60222,'Nope.  How about you?','Nope.  How about you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60224,'Just a few nibbles.  Hoping for a bite soon!','Just a few nibbles.  Hoping for a bite soon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60225,'I knew someone would come for us! Let me help you fight the yaungol.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60226,'$n caused the Darkness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60227,'Ha! Let\'s see if you can figure this out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60228,'Mirror... IMAGE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60229,'Thank you, $r. I can find my way back on my own.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60230,'I\'m in your debt, stranger. Thank you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60231,'Thank you for freeing me, $Gbrother:sister;. I could not have survived another day of the yaungol\'s cruelty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60232,'I was prepared for death. Now... you have given me another chance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60233,'Have you seen the yaungol fighting each other? It seems their troubles run deeper than we thought.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60234,'Have you seen the yaungol fighting each other? It seems their troubles run deeper than we thought.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60235,'What do you stare at, stranger?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60236,'I will not die like this. Not like this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60237,'Go away and leave me be. Let me suffer in peace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60238,'They did not have to die...$B$BThe village to the south... my home, my family! They killed them all!$B$BIf only I had been stronger. I could have saved them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60239,'I should have won. I was stronger. Wiser. I would have won against him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60240,'Outsider! Ally of the Shado-Pan.$B$B<The old yaungol spits out the strange words bitterly.>$B$BCome closer if you wish me to break your neck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60241,'<The old yaungol stares at you with hatred in his eyes.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60242,'You! You killed my brothers! You spilled their blood on the sacred ground of my ancestors!$B$BIf I were not chained, I would kill you now!$B$B<The old yaungol collapses from his outburst, breathing heavily.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60243,'The Energy Vortex is active!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60244,'Can you figure out which is real?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60245,'How did you... figure... it out...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60246,'Ha! Fooled you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60247,'The Energy Vortex is powering up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60248,'Thank you for the help. I\'ll go help with the wound.','Thank you for the help. I\'ll go help with the wound.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(60249,'Help! Sprites swarm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60250,'The mogu are preparing for something big. We\'ve got to stop them from getting ahold of any more ancient weapons.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60251,'<Mishi looks at you inquisitively.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60252,'I\'m ready to leave.','I\'m ready to leave.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60253,'Who dares to challenge me?','',0,0,0,0,0,0,0,0,1,0,30854,0,26124),
(60254,'Welcome, friend, to the Grummle Bazaar!','',0,0,0,0,0,0,0,0,1,15324,0,0,26124),
(60255,'Most grummles keep a few luckydos about.$b$bLook, lint in pocket. Big luckydo. Oh, and smelly incense. Very big luckydo.$b$bNever trust unsmellible luck. Sometimes that is luck for someone else.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60256,'Some argue Brother Rabbitsfoot has more good fortune than I, the Lucky Eightcoins.$b$bAt this I laugh.$b$bIt is simple: he is called \"brother\", I am called \"Lucky\". Obviously I am of more luck.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60257,'Never set a yeti on fire. They just get mad.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60258,'','I hear you are the reason my cousin Syra is sending me wedding invitations.$b$bThanks a lot. Now I have to be the unmarried black yak of the family.',14,1,0,0,0,0,0,0,1,0,0,0,26124),
(60259,'Not running this time, Jung Duk?','',0,0,0,0,0,0,0,0,1,16190,28126,0,26124),
(60260,'Where are your lackeys, great chief? They cannot help you this time!','',0,0,0,0,0,0,0,0,1,16190,28127,0,26124),
(60261,'Deceit is no match for true strength! This one is more powerful than you!','',0,0,0,0,0,0,0,0,1,16190,28128,0,26124),
(60262,'Ahahahaha! More than filth like you deserved.','',0,0,0,0,0,0,0,0,1,16190,28130,0,26124),
(60263,'$C... you must be the one that\'s been helping these pitiful mistlurkers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60264,'That\'s enough!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60265,'I have enough torches to erase all three of you!','',0,0,0,0,0,0,0,0,1,16214,0,0,26124),
(60266,'If you refuse to bend to the torch, you will die to the torch!','',0,0,0,0,0,0,0,0,1,16214,0,0,26124),
(60267,'No...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60268,'You\'re next, small one!','',0,0,0,0,0,0,0,0,1,16214,0,0,26124),
(60269,'Too... strong...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60270,'There\'s another mistlurker here... I can smell his stink.','',0,0,0,0,0,0,0,0,1,16214,0,0,26124),
(60271,'Don\'t think I can\'t see you back there, hiding in the shadows...','',0,0,0,0,0,0,0,0,1,16214,0,0,26124),
(60272,'You resist the power of the torch... why won\'t you die, beast?','',0,0,0,0,0,0,0,0,1,16214,0,0,26124),
(60273,'Because my will...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60274,'...the will of my people...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60275,'...is stronger than yours.','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(60276,'No... NO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60277,'The elements shield me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60278,'There\'s a broken world that could use your help, my student. Have you decided who you would like to accompany in your journey?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(60279,'I\'m ready to decide.','I\'m ready to decide.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(60280,'I know a secret trail through Neverrest. Add three days to any journey, but you see very neat waterfall along way. Most fortunate path.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60281,'Good fortune to drink coffee before a hike. Bad fortune to drink after.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60282,'Rabbitsfoot and Eightcoins argue over who has more luck. Those silly grummles forget that nothing is more lucky than finding lint in your pocket.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60283,'A clean yak is a lucky yak. A dirty yak is a yeti attack.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60284,'Luck is like lady grummle: hard to find but worth the search.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60285,'When counting past 3, continue to 5. Never stop at 4. Most bad fortune for those who stop on four.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60286,'Grummles know all roads through mountains. But some grummles know better roads than others.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60287,'Most bad fortune with big hozen ravage. Makes for bad travels.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60288,'You are on the wrong side of this battle, $r. You side with savage beasts!','',0,0,0,0,0,0,0,0,1,16156,0,0,26124),
(60289,'Gol... goss...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60290,'Must fight Osul now. Must stop hatred.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60291,'So hungry...  Mmm! YOU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60292,'|TInterface\\Icons\\ability_warrior_stalwartprotector.blp:20|t%s casts |cFFFF0000|Hspell:117910|h[Flanking Orders]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60293,'%s lets out a long, drawn out sigh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60294,'It was not always like this.$b$bThe Osul were not our enemies. They lived beside us. We assisted one another.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60295,'If I am going to die, I will die with my friends by my side.$b$bI will die knowing I did everything I could to avenge my people.$b$bI will die staring directly into the shamed face of my enemy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60296,'There is much to be done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60297,'As soon as all of our reinforcements arrive, we will begin pushing further south.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60298,'I would never ask a stranger to take on the duties of a Shado-Pan, but neither will I refuse help from a skilled $c.$B$BThis place is dangerous, $r. If you insist on staying, then I will gladly accept your help.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60299,'','We should take action! While our leaders waggle their tongues, I could have slain ten yaungol.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60300,'','Ban is a great strategist, but he fails to see the most obvious solution.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60301,'','Finally we are taking action! Something we should have done days ago.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60302,'','Do you see Lin down there? There are so many prisoners, but I cannot spot my husband.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60303,'Welcome, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60304,'Suna\'s thoughts are colored by worry for her husband.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60305,'Suna and I do not always agree, but I always respect her opinion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60306,'The mantle of a commander is a heavier burden than I had expected.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60307,'Sigh... she has always been this way. Proud, decisive, and always right.$B$BIn twenty years, I have not yet won an argument.$B$BWhy have I not yet learned my lesson?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60308,'','Lord Taran, our foothold here is secure. We should take the first opportunity to attack.',0,0,0,0,0,0,1,0,1,16208,0,31295,26124),
(60309,'','We already have them on the defensive. Even as we speak, their numbers weaken.',0,0,0,0,0,0,1,0,1,16208,0,31296,26124),
(60310,'','I do not! YOU are the one who forgets my husband is one of the captives.',0,0,0,0,0,0,1,0,1,16208,0,31297,26124),
(60311,'','Of course we need a sound strategy. But why cut off an arm when you can strike at the heart?',0,0,0,0,0,0,6,0,1,16208,0,31298,26124),
(60312,'I disagree. We cannot underestimate the yaungol\'s strength.','',0,0,0,0,0,0,274,0,1,16208,30590,0,26124),
(60313,'As do ours. Do you not see the number of our injured? Do you forget how many have been taken prisoner?','',0,0,0,0,0,0,6,0,1,16208,30591,0,26124),
(60314,'But how much blood must be shed? There are both clever ways and foolish ways.','',0,0,0,0,0,0,1,0,1,16208,30592,0,26124),
(60315,'Settle down, you two. We have much to do, and getting Lin out alive is one of our top priorities.','',0,0,0,0,0,0,1,0,1,16208,28412,0,26124),
(60316,'Go on, $n. Pull it out. You will not be held accountable for my death, when it comes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60317,'The yaungol have shamed my people.$b$bThey will soon know the true meaning of shame.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60318,'<Remove the spear from Orbiss\' side.>','<Remove the spear from Orbiss\' side.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60319,'There is a situation to the south that requires my immediate attention.','',0,0,0,0,0,0,1,0,1,0,28413,0,26124),
(60320,'When you are finished with your duties, report to Ban Bearheart. I am leaving him in command for the duration of the mission here.','',0,0,0,0,0,0,1,0,1,0,28414,0,26124),
(60321,'I will see you again, soon.','',0,0,0,0,0,0,1,0,1,0,28415,0,26124),
(60322,'Come, friends. Glory awaits us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60323,'Protect Golgoss!','',0,0,0,0,0,0,0,0,1,16217,0,0,26124),
(60324,'Protect Arconiss!','',0,0,0,0,0,0,0,0,1,16218,0,0,26124),
(60325,'The mists are now leaving my body. I will remain in this world as long as I can. As long as it takes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60326,'We... did it...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60327,'','We should attack them now, Ban, while their eyes are set upon the gates of Kun-Lai.',0,0,0,0,0,0,0,0,1,16231,0,31299,26124),
(60328,'','Have you forgotten that they are holding my husband prisoner? Time is running out!',0,0,0,0,0,0,0,0,1,16231,0,31300,26124),
(60329,'','But Lin is down there!',0,0,0,0,0,0,0,0,1,16231,0,31302,26124),
(60330,'','He should have chosen me. Those who take the greatest risks achieve the greatest victories.',0,0,0,0,0,0,0,0,1,16231,0,0,26124),
(60331,'','We would not lose.',0,0,0,0,0,0,0,0,1,16231,0,0,26124),
(60332,'','And you cling to caution as if it will save you. Did your caution save your brother?',0,0,0,0,0,0,0,0,1,16231,0,0,26124),
(60333,'','Why did he have to die, Ban? I never told him how I felt.',0,0,0,0,0,0,18,0,1,16231,0,0,26124),
(60334,'Lord Taran Zhu just departed with the majority of our soldiers. Attacking now would be foolish.','',0,0,0,0,0,0,0,0,1,16231,30593,0,26124),
(60335,'Patience, Suna. I share your desire to stop the yaungol. But I must consider every soldier, not just your husband.','',0,0,0,0,0,0,0,0,1,16231,30594,0,26124),
(60336,'Lower your voice. It\'s no wonder Taran did not pick you for command. You take too many risks.','',0,0,0,0,0,0,0,0,1,16231,30595,0,26124),
(60337,'We will save him, Suna. I promise.','',0,0,0,0,0,0,0,0,1,16231,30596,0,26124),
(60338,'And the greatest losses.','',0,0,0,0,0,0,0,0,1,16231,0,0,26124),
(60339,'You throw caution to the wind.','',0,0,0,0,0,0,0,0,1,16231,0,0,26124),
(60340,'What happened to Lin, it was no one\'s fault.','',0,0,0,0,0,0,0,0,1,16231,0,0,26124),
(60341,'He is gone. We must all move on.','',0,0,0,0,0,0,0,0,1,16231,0,0,26124),
(60342,'I\'m heading to the wound. Try to keep these beasts off of me.','I\'m heading to the wound. Try to keep these beasts off of me.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(60343,'You\'re a life-saver. I\'ll do everything I can to heal the wound.','You\'re a life-saver. I\'ll do everything I can to heal the wound.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(60344,'I thought I was done for. Thank you!','I thought I was done for. Thank you!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(60345,'If all pandaren are like you, I think you may have made some new allies!','If all pandaren are like you, I think you may have made some new allies!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(60346,'You handle the beasts, we\'ll handle the wound.','You handle the beasts, we\'ll handle the wound.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(60347,'Keep these creatures off of us while we perform our healing.','Keep these creatures off of us while we perform our healing.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(60348,'I\'d stand with you any day.','I\'d stand with you any day.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(60349,'','Tcha! Why did Taran leave you in charge? You would have us cower in our bedsheets until the yaungol break down our very doors!',0,0,0,0,0,0,0,0,1,16231,0,31301,26124),
(60350,'|TInterface\\Icons\\ability_warrior_bloodbath.blp:20|t%s begins to cast |cFFFF0000|Hspell:117948|h[Annihilate]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60351,'The ground rumbles underneath you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60352,'It\'s an ambush! Defend yourself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60353,'About time you showed up, $r!','About time you showed up, $r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60354,'Reinforcements have arrived! Come $r, lend us a hand!','Reinforcements have arrived! Come $r, lend us a hand!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60355,'Oh good, a $c who looks like $Ghe:she; knows $Ghis:her; way around a battlefield.','Oh good, a $c who looks like $Ghe:she; knows $Ghis:her; way around a battlefield.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60356,'Help us drive the yaungol back, $r!','Help us drive the yaungol back, $r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60357,'Don\'t be shy, $c. Plenty of yaungol to go around!','Don\'t be shy, $c. Plenty of yaungol to go around!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60358,'<Mishi surveys the valley apprehensively.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60359,'I bear your presence only as a kindness to our new allies. Don\'t push me, human.','',0,0,0,0,0,0,0,0,1,0,28117,0,26124),
(60360,'What is Kota Kon doing here?!$B$B...And why she wearing an adorable little bow?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60361,'You know, I think that yeti appreciates good kafa more than most people. And she has\'t eaten a single grummle since you brought her down from the peak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60362,'WHAT HAVE I DONE?! WE\'RE ALL DEAD!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60363,'I don\'t know... still got a bad feeling about this yeti being here...$B$BSometimes I catch her just... staring at me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60364,'<The pandaren was recently stripped, beaten, and broken. His body is still growing cold.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60365,'','It\'s working! The wound is closing!',0,0,0,0,0,0,1,0,5,0,0,27417,26124),
(60366,'Elegon begins to reactivate the Engine of Nalak\'sha.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60367,'Examine the body.','Examine the body.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60368,'Look for idols south of here at the Deeper and Camp Broketooth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60369,'Good, you have lit the incense.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60370,'Can you not feel it? Your sprits lifting?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60371,'You see, what you have done is a tribute to a truth we Pandaren hold most dear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60372,'Like Shaohao, we know our ultimate destiny is to become one with the land. Nothing truly meets an end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60373,'None of us approaches death with joy - but neither should we feel fear, nor anger, nor doubt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60374,'Though these Pandarens - my friends - have died, we know that through their sacrifice, and your noble works, Pandaria lives on.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60375,'Though we may die, from our passing blossoms new life. This is the truth that we live, work, and die for.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60376,'Do you see? From their graves, trees grow. May these trees always stand for the sacrifice they made, and the honor you have done them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60377,'Thank you, friend. You are truly a hero.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60378,'Ha ha! Here comes the luckydo! I saw the idols explode from here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60379,'Let\'s go find this engineer.  Maybe getting this thorn removed won\'t be as hard as we thought.','',0,0,0,0,0,0,396,0,1,0,27335,0,26124),
(60380,'Hurry north! Find my Brother Yakshoe before the hozen do something bad to him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60381,'','NOOO!',0,0,0,0,0,0,0,0,1,0,0,31316,26124),
(60382,'','Lin, heart of my heart! No, please, NO! It cannot be!',0,0,0,0,0,0,5,0,1,0,0,31317,26124),
(60383,'','If only I had come sooner! If only Ban had listened to me!',0,0,0,0,0,0,0,0,1,0,0,31318,26124),
(60384,'','Shhhhhh, my sweet darling, sleep now and be at peace.',0,0,0,0,0,0,0,0,1,0,0,31319,26124),
(60385,'','Your killers will not go unpunished.',0,0,0,0,0,0,0,0,1,0,0,31320,26124),
(60386,'','I will see to that.',0,0,0,0,0,0,0,0,1,0,0,31321,26124),
(60387,'Woohoo! And they say the Yakshoe is not a luckydo! Many thanks for the rescue.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60388,'If you have a ranged weapon, use it to shoot down ropes that hold grummles up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60389,'They told me that this would be a training mission. I feel like it is turning into something more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60390,'Did you see Lord Taran Zhu earlier? His prowess is legendary.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60391,'Ready to smash some hozens, girl?','Ready to smash some hozens, girl?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60392,'Lord Taran spoke to me earlier! I hope I won\'t let him down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60393,'Ah! Good fortune to one who times a rescue well.','',0,0,0,0,0,0,0,0,1,15815,0,0,26124),
(60394,'Good fortune to friend of grummles!','',0,0,0,0,0,0,0,0,1,15815,0,0,26124),
(60395,'Cage stink of bad fortune. Hozen stink of more bad fortune.','',0,0,0,0,0,0,0,0,1,15815,0,0,26124),
(60396,'I need a better luckydo to make sure this not happen again.','',0,0,0,0,0,0,0,0,1,15815,0,0,26124),
(60397,'Must... find... incense....','',0,0,0,0,0,0,0,0,1,15815,0,0,26124),
(60398,'Many thanks!','',0,0,0,0,0,0,0,0,1,15815,0,0,26124),
(60399,'Maybe I call myself $psfoot from now on.','',0,0,0,0,0,0,0,0,1,15815,0,0,26124),
(60400,'It Kota Kon!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60401,'We gonna put you in the Dooker Dome!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60402,'','My husband was taken prisoner by the yaungol several days ago.$B$BHe is in danger as we speak.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60403,'What the ooks a Kota Kon doin\' here?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60404,'','I\'m afraid I\'m of little use right now, $n.$B$BI am sick with worry for my husband.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60405,'','I cannot stand by idly while Lin is in danger.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60406,'','No, no, no. Lin, my dear husband. You can\'t be gone.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60407,'Ookin wikket! Get back here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60408,'','He was so cold. So limp and lifeless.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60409,'','I told him! I told Ban we needed to strike! This is all his fault!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60410,'','He said goodbye just a few days ago. I can still see his face! How can he be dead?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60411,'I feel am deeply sorry for Lin\'s loss, but I must think of every soldier in my army.$B$BEach life is precious, and must be valued equally.$B$BI could not gamble the lives of many to save that of one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60412,'Kota wikkets gettin\' ravaged next!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60413,'We did well here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60414,'Kota Kon bigger than me thought she\'d be...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60415,'I am happy with our success at Osul Peak. I consider this a successful campaign.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60416,'We will have much good news to report to Lord Taran.$B$BNews of our victory here at Osul Peak will ring gladly in his ears.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60417,'I would say that my first command here was quite the success.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60418,'Can\'t smash us all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60419,'Our victory here was much thanks to you, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60420,'Meet us at Dooker Dome. We need to find some incense and a dirty yak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60421,'For the Chief!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60422,'<He clutches a handkerchief with the initials, S.S.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60423,'We have only sustained a few minor casualties. Otherwise, I would say that things are going quite well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60424,'We will make sure to honor Lin\'s courage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60425,'My first command has been more difficult than I anticipated. Did I make the right decision?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60426,'Wikkets think hozen weak!','',407,0,0,0,0,0,0,0,1,0,0,0,26124),
(60427,'We got a yeti, ookers! You hear me! We got a yeti!','',407,0,0,0,0,0,0,0,1,0,0,0,26124),
(60428,'Ookin wikkets gonna get fed to Chomp Chomp!','',407,0,0,0,0,0,0,0,1,0,0,0,26124),
(60429,'Wikkets don\'t want hozen to take their munchpacks! But hozen are gonna take! Ravage!','',407,0,0,0,0,0,0,0,1,0,0,0,26124),
(60430,'','<Suna rocks back and forth, staring into space. She does not answer.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60431,'Take all of the things!','',407,0,0,0,0,0,0,0,1,0,0,0,26124),
(60432,'Ravage! Ravage! Ravage!','',407,0,0,0,0,0,0,0,1,0,0,0,26124),
(60433,'War is a word that has not been spoken in Pandaria for a long time.$B$BNow, we must all fight... to restore peace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60434,'Knucklethumps gonna rule the Kun-Lai!','',407,0,0,0,0,0,0,0,1,0,0,0,26124),
(60435,'Oh boy. Luckydo don\'t fail me now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60436,'FEAR THE MONKEY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60437,'Perhaps... I was a bit too... optimitistic about my condition...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60438,'Good, another $c has come to join the fight!','Good, another $c has come to join the fight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60439,'Hey, we\'ve got our hands full here, $r! Come lend a hand!','Hey, we\'ve got our hands full here, $r! Come lend a hand!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60440,'This isn\'t the last of them! $C, help us drive them back!','This isn\'t the last of them! $C, help us drive them back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60441,'The Alliance has taken control of a Mine Cart!','',0,0,0,0,0,0,0,0,1,0,9431,0,26124),
(60442,'The Horde has taken control of a Mine Cart!','',0,0,0,0,0,0,0,0,1,0,9431,0,26124),
(60443,'','Ban is to blame for this. That old, blind fool.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60444,'A %s has arrived from the center depot.','',0,0,0,0,0,0,0,0,1,0,9431,0,26124),
(60445,'I feel... at peace.','',0,0,0,0,0,0,0,0,1,0,28129,0,26124),
(60446,'Shut up, Katak!','',0,0,0,0,0,0,0,0,1,0,30855,0,26124),
(60447,'Wake... up... DANGIT!','',0,0,0,0,0,0,15,0,1,0,27345,0,26124),
(60448,'This is ridiculous...','',0,0,0,0,0,0,274,0,1,0,27346,0,26124),
(60449,'You sleep like a rock!','',0,0,0,0,0,0,5,0,1,0,27347,0,26124),
(60450,'There\'s no way you\'ll sleep through THIS.','',0,0,0,0,0,0,274,0,1,0,27348,0,26124),
(60451,'Seriously?','',0,0,0,0,0,0,18,0,1,0,27349,0,26124),
(60452,'Why...','',0,0,0,0,0,0,507,0,1,0,27350,0,26124),
(60453,'won\'t...','',0,0,0,0,0,0,509,0,1,0,27351,0,26124),
(60454,'you...','',0,0,0,0,0,0,507,0,1,0,27352,0,26124),
(60455,'just...','',0,0,0,0,0,0,509,0,1,0,27353,0,26124),
(60456,'WAKE UP?!','',0,0,0,0,0,0,22,0,1,0,27354,0,26124),
(60457,'I will break you, little rock man!','',0,0,0,0,0,0,25,0,1,0,27355,0,26124),
(60458,'Hah! Waking this guy is no easy feat! I\'ve hit him, I\'ve tried to pull him over with a rope, I\'ve thrown my body into this gong, and nothing! $B$BAh well, I\'ve got more ideas to get started on.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60459,'I always figure we should be taught not to wait for inspiration to start a thing. Action always generates inspiration. Inspiration rarely generates action.$B$BSuch is the way of the Huojin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60460,'And there we have it, just add water! Wish I would have thought of that one a little sooner.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60461,'Much of the cover of this book has been destroyed. What is still visible appears to be in Trollish...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60462,'This page must have been dropped by one of the looters. Lorewalker Cho will know what it says.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60463,'The altar is still warm from a recent ritual...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60464,'No! Wikkets stole my Chomp Chomp!','',407,0,0,0,0,0,0,0,1,0,0,0,26124),
(60465,'[PH] This is a placeholder visual, don\'t bug me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(60466,'Slip-an-die! Dooker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60467,'You... bunch... of... dookers!','',407,0,0,0,0,0,0,0,1,0,0,0,26124),
(60468,'OW! OW! OW! OW!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60469,'Keenbean Kafa Co. is in real trouble!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60470,'The air crackles as a |cFFF00000|Hspell:118077|h[Lightning Storm]|h|r forms!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60471,'|TInterface\\Icons\\ability_rogue_dismantle.blp:20|t%s casts |cFFFF0000|Hspell:118047|h[Pillage]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60472,'Are you ready to fight, $c?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60473,'As soon as you stop yapping...','As soon as you stop yapping...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60474,'They fought over their food supplies. It looks like rather than sharing their food, someone destroyed it all. Why would they do that?','',0,0,0,0,0,0,0,0,1,0,31914,0,26124),
(60475,'From what I can tell, there were no sides in this fight. Why would the yaungol kill each other in a free-for-all?','',0,0,0,0,0,0,0,0,1,0,31915,0,26124),
(60476,'It\'s the yaungol chief, slain just like the rest. Seems that he could not keep order in the final fight.','',0,0,0,0,0,0,0,0,1,0,31917,0,26124),
(60477,'Can you defeat my Double Claw Xuen Style?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60478,'','I do not like this place, $r. There is something strange about it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60479,'','Something about this village makes my fur stand on end.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60480,'','We will not rest until our duties here are done.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60481,'I show you on your map where grummles are now. Find them or wait here for next wave of grummles.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60482,'Thank you, $n. I have much to report to Ban. I think I can find my way back from here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60483,'So, friends... how are we going to find the hidden master?','',0,0,0,0,0,0,6,0,1,16274,31908,0,26124),
(60484,'','The marmots get mad if they see you ruining their holes. Just nudge them out of the way first, and they\'ll leave you alone.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(60485,'Such little things you are. May this challenge fortify your strength!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(60486,'Why we not eating carrot?','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(60487,'I just notice funny-looking carrot!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(60488,'Carrot grow right in front of us!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(60489,'Carrot? For US?!?!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(60490,'Look, look! Weird, bumpy carrot!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(60491,'We so lucky.','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(60492,'Good things happen to us today.','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(60493,'Carrots never bad!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(60494,'It... perfect.','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(60495,'I trust it.','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(60496,'Stop talk, start eat!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(60497,'Something funny about carrot...','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(60498,'Wait, wait. You smell... turnip...?','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(60499,'Something fishy here...','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(60500,'I just going to bite without even looking!','',0,0,0,0,0,0,0,0,1,16275,0,0,26124),
(60501,'[PH]Troll Boss unleashes a Voodoo Hex![PH]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60503,'','Hey! Watch where you\'re splashing that $g thing, big guy!:thing!;',0,0,0,0,0,0,15,0,1,0,0,30502,26124),
(60504,'','What, we\'re done already!?',0,0,0,0,0,0,6,0,1,0,0,30503,26124),
(60505,'','Are you sure you don\'t want to keep wading in this gross water?',0,0,0,0,0,0,6,0,1,0,0,30504,26124),
(60506,'','Maybe we can find some more weird, splashy bottles to fill with mud.',0,0,0,0,0,0,1,0,1,0,0,30505,26124),
(60507,'','My favorite part was when you splashed muddy water in my eyes.',0,0,0,0,0,0,15,0,1,0,0,30506,26124),
(60508,'','I\'m being sarcastic, by the way.',0,0,0,0,0,0,0,0,1,0,0,30507,26124),
(60509,'The orbs have appeared!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60510,'The orb has been returned!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60511,'Infinite energy, unbound!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60512,'Nothing shall stop the engine of creation!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60513,'The Energy Vortex is powering down! Get off the platform!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60514,'The Energy Vortex is inactive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60515,'The Energy Vortex begins to shut down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60516,'The Engine of Nalak\'sha begins to self destruct!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60517,'So, you\'re a homebrewer?','So, you\'re a homebrewer?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60518,'Yup. Been brewin\' beer since I could drink it.$b$bSome folks say I\'m wastin\' my time, that I could just buy the beer that comes out o\' that big ol\' brewery down yonder, but... I dunno. There\'s somethin\' right nice about brewin\' your own mug of ale.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60519,'Is Mudmug your real name?','Is Mudmug your real name?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60520,'Aw, heck no. That\'s just how I make my beer.$b$bMuddy water, you see... it\'s got little bugs in it, that ferment your ale for you. Some folks use real yeast, grown in a fancy brewery under controlled conditions and what have you. I use muddy water.$b$bIt\'s kind of my thing.$b$bI guess I\'m just not what you\'d call \"cultured\".','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60521,'Ha ha.','Ha ha.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60522,'Greetin\'s! And, ah... salutations, I suppose.$b$bSorry. Not quite sure what to say. I\'m not used to havin\' much in the way of company around here.$b$bThat is, not unless they\'re here to buy some o\' my brew, of course.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60523,'[PH] Are you ready to fight?','[PH] Are you ready to fight?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(60524,'[PH] I\'m ready to fight!','[PH] I\'m ready to fight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60525,'I... think I will be safe, for now, thanks to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60526,'','Now! Let us see what darkness corrupts this place!',0,0,0,0,0,0,0,0,1,0,0,31418,26124),
(60527,'','$n, help me by activating the three large totems.',0,0,0,0,0,0,0,0,1,0,0,31419,26124),
(60528,'','Good luck!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60529,'','Follow me. We will use these totems to purify the earth.',0,0,0,0,0,0,0,0,1,0,0,31417,26124),
(60530,'','I win? Yay!',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(60531,'','I guess he\'s somewhere in this forest?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60532,'','It doesn\'t look very friendly in there. Maybe I should just...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60533,'','No! I\'ve come too far to give up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60534,'','Whaa.... What\'s happening?!?',0,0,0,0,0,0,0,0,1,0,0,31420,26124),
(60535,'I have a rule: anybody who calls me handsome gets free beer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60536,'The machine hums to life!  Get to the lower level!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60537,'|TInterface\\Icons\\ability_rogue_envelopingshadows.blp:20|t%s casts |cFFFF0000|Hspell:117506|h[Undying Shadows]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60538,'|TInterface\\Icons\\warrior_talent_icon_furyintheblood:20|t%s casts |cFFFF0000|Hspell:117708|h[Maddening Shout]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60539,'The Ancient Mogu Machine breaks down! |cFFFF0000|Hspell:116779|h[Titan Gas]|h|r floods the room!','The Ancient Mogu Machine breaks down! |cFFFF0000|Hspell:116779|h[Titan Gas]|h|r floods the room!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60540,'The Ancient Mogu Machine goes into overdrive! |cFFFF0000|Hspell:116779|h[Titan Gas]|h|r floods the room!','The Ancient Mogu Machine goes into overdrive! |cFFFF0000|Hspell:116779|h[Titan Gas]|h|r floods the room!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60541,'The defense of Stoneplow is more important than you may know.$b$bIf the mantid take Stoneplow, they may as well take this entire valley. Beyond this wall, there is nothing to stop them from sweeping through the entirety of Pandaria.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60542,'The mantid are attacking, and we are shamefully unprepared.$b$bUnder normal circumstances, our enemy is quite predictable. We anticipated that the next full-scale mantid attack would hit in about ten years, as they do so regularly every hundred.$b$bThis current invasion is hardly \"full-scale\", but it\'s still strong enough to catch a farming village unawares. Had my Shado-Pan not been keeping such a watchful vigil on the wall, Stoneplow might have already fallen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60543,'Yes. The defense of Stoneplow currently rests on me, Guard-Captain Oakenshield, and three others of our order. As we speak, those three Shado-Pan are standing at the foot of the wall, waiting to defend against the next wave of attackers. This is our charge - to protect Pandaria from the enemies that the common people have all but forgotten about.$b$bWhile our numbers here in Stoneplow are few, we do not expect reinforcements from Kun Lai... unless this situation gets worse. Say, for example, if that weak spot in the wall crumbled.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60544,'A few days past, I saw a bolt of dark energy crackling through the ground from my tower vigil. It came from the west, fracturing the wall, and very nearly breaking through it entirely.$b$bYou can still see the scars it left. It ruined these farmers\' land.$b$bThe mantid scouts followed shortly after. Whether they\'ve had this attack planned or they\'re just capitalizing on an opportunity, I couldn\'t say. Maybe they\'re running away from whatever caused the crack in the first place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60545,'What is happening here?','What is happening here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60546,'Shado-Pan?','Shado-Pan?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60547,'What happened to the wall, anyway?','What happened to the wall, anyway?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60548,'I understand.','I understand.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60549,'I spent my life on that wall, $n. I gave up everything I had to become Shado-Pan, to prevent something like this from happening.$b$bI have failed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60550,'For everything you have done, $n... you have our gratitude.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60551,'Hello.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60552,'','Are you seeing all this stuff? This place is great!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60553,'','Thanks for taking me out exploring with you, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60554,'','I can\'t believe Uncle Chen would rather sit down and drink beer than walk around and explore this place!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60555,'','Because Uncle Chen made me promise not to!$b$bListen. Chen may be a stupid, boring, lazy, fat old uncle, but that doesn\'t mean that I don\'t respect him. He told me not to get into any trouble, and I\'m not about to ignore him.$b$bBesides, you seem to be doing just fine on your own. You don\'t need a little girl to help you kill things.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60556,'Why aren\'t you helping me fight things?','Why aren\'t you helping me fight things?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60557,'Wind is my ally!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60558,'I await a challenger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60559,'Ah... a challenge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60560,'Fight well, and with honor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60561,'A $c? Most engaging.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60562,'Friend, I come to help. We will show Shai Hu to his grave!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60563,'I am here to help you defeat the poisoner of my people!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60564,'We shall crush Shai Hu, together!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60565,'When these creatures die, they explode... I know, kill them near Shai Hu!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60567,'Augh! Their deaths hurt us, but they will hurt him, too! Bring them close to him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60568,'I need another Totem of Harmony.','I need another Totem of Harmony.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60569,'Wh-what came over me?','Wh-what came over me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60570,'I felt... so much hatred...','I felt... so much hatred...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60571,'Thank you for freeing me of that horrible burden.','Thank you for freeing me of that horrible burden.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60572,'What? Suddenly, I feel at peace...','What? Suddenly, I feel at peace...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60573,'Thank you, friend. I could not escape the sha\'s grip on my own.','Thank you, friend. I could not escape the sha\'s grip on my own.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60574,'Was that... the sha? I wanted to rip everyone to shreds!','Was that... the sha? I wanted to rip everyone to shreds!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60575,'I... what happened? I feel much calmer now.','I... what happened? I feel much calmer now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60576,'The sha had me in its grasp? I had not even realized it until now...','The sha had me in its grasp? I had not even realized it until now...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60577,'...and that is what happened in the brewery.','',0,0,0,0,0,0,0,0,1,16309,29666,0,26124),
(60578,'I am ready to begin the ritual.','I am ready to begin the ritual.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60579,'Your hatred overwhelms you!','Your hatred overwhelms you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60580,'Destroying the pipes leaks |cFFFF0000|Hspell:116779|h[Titan Gas]|h|r into the room!','Destroying the pipes leaks |cFFFF0000|Hspell:116779|h[Titan Gas]|h|r into the room!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60581,'YOUR RAGE! I FEED ON YOUR RAGE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60582,'WHAT IS THIS?! THEIR RAGE... IT BURNS ME...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60583,'NO! IT CANNOT BE! YOU CAN NOT STOP ME!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60584,'I... feel something. Is it... peace?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60585,'You feel hatred boiling up inside you.','You feel hatred boiling up inside you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60586,'Your hatred intensifies! Control it now!','Your hatred intensifies! Control it now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60587,'Gonna set wikkets up the boom boom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60588,'Wikkets gonna face the Boom Boom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60589,'Wikkets gonna fail. I got a box full of boom booms!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60590,'Doom doom from the boom boom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60591,'Time for the Boom Boom Boogaloo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60592,'Boogaloo of the boom boom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60593,'Boom boom for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60594,'Wikkets can\'t survive the Boom Boom Boogaloo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60595,'Time for the Boom Box!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60596,'Master Boom Boom ready to boom up some wikkets!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60597,'Munchies and crunchies for most happy sale. You buy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60598,'Enough! Off to de spirit world wit\' ya!','',0,0,0,0,0,0,0,0,1,0,29089,0,26124),
(60599,'','A challenge in compassion and humility. By helping Merchant Lorvo, it would seem you\'ve passed, $c. Master Shang would be pleased.',0,0,0,0,0,0,2,0,1,0,0,27404,26124),
(60600,'You have conquered every challenge I put before you, $n. You have found Huo and brought him safely to the temple.','',0,0,0,0,0,0,1,0,1,0,27789,0,26124),
(60601,'There is a much larger problem we face now, my students. Shen-zin Su is in pain. If we do not act, the very land on which we stand could die, and all of us with it.','',0,0,0,0,0,0,1,0,1,0,27790,0,26124),
(60602,'We need to speak to Shen-zin Su and discover how to heal it. And to do that, we need the four elemental spirits returned. Huo was the first.','',0,0,0,0,0,0,1,0,1,0,27791,0,26124),
(60603,'Ji, I\'d like you to go to the Dai-Lo Farmstead in search of Wugou, the spirit of earth.','',0,0,0,0,0,0,1,0,1,0,27792,0,26124),
(60604,'Aysa, I want you to go to the Singing Pools to find Shu, the spirit of water.','',0,0,0,0,0,0,1,0,1,0,27793,0,26124),
(60605,'And $n, you shall be the hand that guides us all. Speak with me for a moment before you join Aysa at the Singing Pools to the east.','',0,0,0,0,0,0,1,0,1,0,27794,0,26124),
(60606,'On it!','',0,0,0,0,0,0,0,0,1,0,27306,0,26124),
(60607,'','Yes master.',0,0,0,0,0,0,2,0,1,0,0,27406,26124),
(60608,'Welcome, Huo. The people have missed your warmth.','',0,0,0,0,0,0,2,0,1,0,27788,0,26124),
(60609,'Let\'s tackle this one together!','',0,0,0,0,0,0,5,0,1,0,27320,0,26124),
(60610,'I like the way you fight!','',0,0,0,0,0,0,5,0,1,0,27322,0,26124),
(60611,'He had that one coming.','',0,0,0,0,0,0,273,0,1,0,27323,0,26124),
(60612,'Ouch! That one looked painful!','',0,0,0,0,0,0,5,0,1,0,27324,0,26124),
(60613,'You make this look easy.','',0,0,0,0,0,0,1,0,1,0,27325,0,26124),
(60614,'They never stood a chance.','',0,0,0,0,0,0,1,0,1,0,27326,0,26124),
(60615,'You\'ve got this handled.','',0,0,0,0,0,0,273,0,1,0,27327,0,26124),
(60616,'I need to fight by you more often.','',0,0,0,0,0,0,1,0,1,0,27328,0,26124),
(60617,'All done! Let\'s get back and see if Aysa\'s come up with anything during her meditation. [Removed?]','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(60618,'See you at the dock!','',0,0,0,0,0,0,0,0,1,0,27319,0,26124),
(60619,'Let\'s do this, monkeyface!','',0,0,0,0,0,0,5,0,1,0,27318,0,26124),
(60620,'That all you\'ve got?!','',0,0,0,0,0,0,5,0,1,0,27316,0,26124),
(60621,'This monkey\'s about to get slapped!','',0,0,0,0,0,0,5,0,1,0,27317,0,26124),
(60622,'And he\'s down for the count! Good going.','',0,0,0,0,0,0,5,0,1,0,27315,0,26124),
(60623,'','Stand down, tauren, before I put you back in chains.',0,0,0,0,0,0,396,0,1,0,0,27522,26124),
(60624,'','We have men in that wreckage! Get more men out there recovering the wounded.',0,0,0,0,0,0,22,0,1,18359,0,27507,26124),
(60625,'','We need more healers at the tents. Recall the priests from the west.',0,0,0,0,0,0,22,0,1,18360,0,27508,26124),
(60626,'Over here, $p! We need help!','',0,0,0,0,0,0,5,0,1,19275,27332,0,26124),
(60627,'','We risked everything, but we did it. Shen-zin Su will be okay.',0,0,0,0,0,0,1,0,5,0,0,27418,26124),
(60628,'','Master Shang Xi, I would like to accompany the Alliance back to their home.',0,0,0,0,0,0,1,0,1,0,0,27405,26124),
(60629,'What of you, Ji? Will you join the Horde in their journey back?','',0,0,0,0,0,0,6,0,1,0,27786,0,26124),
(60630,'Yes... perhaps that is for the best. I like what I\'ve seen of them, and it sounds as though their world could use my help.','',0,0,0,0,0,0,273,0,1,0,27305,0,26124),
(60631,'And you, my young student? Where will you go?','',0,0,0,0,0,0,6,0,1,0,27787,0,26124),
(60632,'You\'ve all accomplished a great thing in saving Shen-zin Su. You do us all proud.','',0,0,0,0,0,0,1,0,1,0,27784,0,26124),
(60633,'It seems your journeys are not done. These new allies of ours come from a broken world that could use our help.','',0,0,0,0,0,0,1,0,1,0,27785,0,26124),
(60634,'Time to face the wrath of the family staff!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60635,'Turo von Kuros!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60636,'Kalimaste!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60637,'Gokku-lai!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60638,'Lo-kal...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60639,'At last, $p, we get to face each other in battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60640,'Wow that hurt! Well fought, friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60641,'Who among you is ready to lose to the Bramblestaff?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60643,'','Has Ban sent you to kill me, then? Just like he killed my husband?',0,0,0,0,0,0,0,0,1,0,0,31308,26124),
(60644,'','Your pitiful rituals are meaningless! I will not be saved!',0,0,0,0,0,0,0,0,1,0,0,31309,26124),
(60645,'','Hatred gives me the strength to destroy you!',0,0,0,0,0,0,0,0,1,0,0,31310,26124),
(60646,'','I see now... my hatred... consumed me. Tell Ban... all is... forgiven.',0,0,0,0,0,0,0,0,1,0,0,31311,26124),
(60647,'Ahahaha... you pitiful weaklings!','',0,0,0,0,0,0,0,0,1,0,28328,0,26124),
(60648,'Even your strongest warriors succumb like lambs to the slaughter.','',0,0,0,0,0,0,0,0,1,0,28329,0,26124),
(60649,'Your turn will come. Hate, will turn you all against one another until this whole world burns.','',0,0,0,0,0,0,0,0,1,0,28330,0,26124),
(60650,'','I surrender! You win.',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(60651,'','This is going to be easier than a drinking contest with a grummle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60652,'','Choose your champion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60653,'Bah! Bested by de likes of you! What a shame for a Zandalari Priest ta endure.','',0,0,0,0,0,0,15,0,0,0,29082,0,26124),
(60654,'But it ain\'t no ting. Take your trinkets; you\'ll be needin\' dem.','',0,0,0,0,0,0,14,0,0,0,29083,0,26124),
(60655,'I be goin\' now; time ta find a new home for me soul.','',0,0,0,0,0,0,1,0,0,0,29084,0,26124),
(60656,'Death be a doorway, an\' time a window; I\'ll be back! AH-HAHAHAHAHAH!','',0,0,0,0,0,0,392,0,0,0,29085,0,26124),
(60657,'','Test your might!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60658,'','Ready... FIGHT!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60659,'','Round one... FIGHT!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60660,'You go away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60661,'This virmen land now, you go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60662,'Go away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60663,'','Defeated!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60664,'','Victory!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60665,'Need... better... healer....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60666,'Lousy... tank...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60667,'But... but... I needed that gear...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60668,'Ken-Ken... surrenders!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60669,'Well... done... champions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60670,'The ancient machine goes haywire! All constructs become |cffFF0000|Hspell:118041|h[Overcharged]|h|r!','The ancient machine goes haywire! All constructs become |cffFF0000|Hspell:118041|h[Overcharged]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60671,'Elegon has arrived! PH','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60672,'You know not what you have unleashed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60673,'This machine will be your undoing. PH','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60674,'Ah, you\'re here already? I\'m not quite finished with my preparations... and neither are you.$B$BHonor the shrines and come back to me - we mustn\'t disrespect the mountain in our haste.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60675,'Alright, we\'re ready to get started.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60676,'Just about done here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60677,'Thank you, brave $c.','Thank you, brave $c.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(60678,'[PH] You are saved!','[PH] You are saved!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(60679,'Yes, well... it\'s not like Suna to run off by herself.','',0,0,0,0,0,0,1,0,1,0,30583,0,26124),
(60680,'','Ban, you look worried.',0,0,0,0,0,0,1,0,1,0,0,31409,26124),
(60681,'','She must be torn by grief over her husband\'s death.',0,0,0,0,0,0,1,0,1,0,0,31410,26124),
(60682,'','That may be, but it was no one\'s fault.',0,0,0,0,0,0,1,0,1,0,0,31411,26124),
(60683,'','You did what you thought was best. No commander has the foresight to see the future.',0,0,0,0,0,0,1,0,1,0,0,31412,26124),
(60684,'Many thanks!','Many thanks!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(60685,'','You swore the Shado-Pan blood oath together, did you not? You are bound together by powers far stronger than hatred.',0,0,0,0,0,0,1,0,1,0,0,31413,26124),
(60686,'','No, she cannot hate you. At least not forever. Hahahaha!',0,0,0,0,0,0,11,0,1,0,0,31414,26124),
(60687,'','Ugh, what is that stench?',0,0,0,0,0,0,6,0,1,0,0,31415,26124),
(60688,'','But this place reeks of death!',0,0,0,0,0,0,274,0,1,0,0,31416,26124),
(60689,'She blames me, you know.','',0,0,0,0,0,0,1,0,1,0,32935,0,26124),
(60690,'I should have taken the risk and sent the order to attack.','',0,0,0,0,0,0,1,0,1,0,30584,0,26124),
(60691,'But now... she hates me.','',0,0,0,0,0,0,1,0,1,0,30585,0,26124),
(60692,'I hope so, Yalia.','',0,0,0,0,0,0,1,0,1,0,30586,0,26124),
(60693,'It\'s too quiet. We should check this out.','',0,0,0,0,0,0,1,0,1,0,30587,0,26124),
(60694,'We stop here. Everyone out!','',0,0,0,0,0,0,1,0,1,0,30588,0,26124),
(60695,'Yes. Suna\'s tracks stop here. We won\'t leave until we find her.','',0,0,0,0,0,0,1,0,1,0,30589,0,26124),
(60696,'Look! Suna\'s tracks lead into the village ahead.','',0,0,0,0,0,0,5,0,1,0,31897,0,26124),
(60697,'It looks like the site of... a massacre.','',0,0,0,0,0,0,1,0,1,0,31898,0,26124),
(60698,'In this place? Are... are you sure?','',0,0,0,0,0,0,6,0,1,0,31899,0,26124),
(60699,'Aaaack! Wikkets win! Just don\'t take my boom booms!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60700,'Look, I see some of Suna\'s things! She must have made camp here. But where is she?','',0,0,0,0,0,0,0,0,1,0,31916,0,26124),
(60701,'I don\'t like the look of this place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60702,'You don\'t think this place is... haunted... do you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60703,'I don\'t want to know what happened here. It\'s too horrible to imagine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60704,'Augh! Don\'t sneak up on a pandaren like that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60705,'Is Suna really out there somewhere?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60706,'Hey $r, what do you make of this place?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60707,'I have never seen anything like this. Have you, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60708,'Don\'t be frightened, $r. We will keep everyone safe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60709,'The Wrestler is going to destroy the competition today.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60710,'Apparently a hozen found himself a crate of bombs and thinks he\'s a monk now.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60711,'I wonder who talked Xuen in to letting the sauroks compete. I like a good test of strength, but those creatures are just... so... angry.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60712,'You know, I saw the Wrestler\'s real face once. True story.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60713,'The binding should only take a moment, but I\'ll be completely entranced.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60714,'Watch my back - I trust you can handle any interruptions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60715,'LOREWALKER! You have something of mine.','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(60716,'Clever, hiding out up here - using the elements to shield your tracks. But my quilen hounds could sense the Tongue even here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60717,'Were you counting on this whelp to stop us? Hah!','',153,0,0,0,0,0,0,0,1,0,0,0,26124),
(60718,'All done. Did I miss anything?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60719,'Very well. Today... is your day...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60720,'|TInterface\\Icons\\spell_shaman_staticshock.blp:20|t%s begins to cast |cFFF00000|Hspell:117436|h[Lightning Prison]|h|r!','|TInterface\\Icons\\spell_shaman_staticshock.blp:20|t%s begins to cast |cFFF00000|Hspell:117436|h[Lightning Prison]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60721,'Go ahead with the binding, Cho.','Go ahead with the binding, Cho.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60722,'','$n, it is dangerous out there. For your own safety, make use of the totem I gave you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60723,'Take me to Hellscream\'s Hope!','Take me to Hellscream\'s Hope!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60724,'Unbelievable! This is the fabled Mogu\'shan Library!  Can you even imagine what we could learn from these vaults?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60725,'My precious $n! You\'ll pay for that!','',397,0,0,0,0,0,0,0,1,0,0,0,26124),
(60726,'What are you waiting for? Let\'s go investigate!','What are you waiting for? Let\'s go investigate!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60727,'Take me to Wayward Landing, please.','Take me to Wayward Landing, please.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60728,'Look here! It\'s the history of Zian of the Endless Shadow, a powerful sorcerer who kept the kingdoms in check through terror and darkness.','',0,0,0,0,0,0,25,0,1,0,30207,0,26124),
(60729,'Bring me their heads!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60730,'Death to the Shado-Pan! Death to all Pandaren!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60731,'Forward, march, yaungol! Cowards will be executed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60732,'Wikkets got boomed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60733,'Yachi! Yao! Rip these fools to shreds!','',397,0,0,0,0,0,0,0,1,0,0,0,26124),
(60734,'Now Ken-Ken! Like we planned!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(60735,'Remember, Xuen told us to work together.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(60736,'We can do this!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(60737,'We can win if we work together.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(60738,'HO...ZEN...FU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60739,'Ken-Ken\'s got this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60740,'Pha! Ken-Ken doesn\'t need a jinyu to win.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60741,'Flee, craven villagers! This land belongs to nature alone once more!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(60742,'Vengeful Hui has appeared in the Mason\'s Quarter, north of Greenstone Village. Challenge him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60743,'Come on champ! Give Rok Rok a roar!','',4,1,0,0,0,0,0,0,1,0,0,0,26124),
(60744,'No! No no no! No more muffins for you! Muffins for closers!','',1,407,0,0,0,0,0,0,1,0,0,0,26124),
(60745,'[PH] CONGRATULATION - YOU ARE WINNER','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60746,'Welcome, Challengers, to my Tournament of Strength!','',15,0,0,0,0,0,0,0,1,15324,29025,0,26124),
(60747,'Quest Objective Complete. *Click!*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60748,'','Be alert, $n! We are surrounded!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(60749,'','Finally, the sha has shown its face. Be careful!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(60750,'','If you are not careful, your own hatred could consume you.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(60751,'','We are not out of the woods yet.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(60752,'','It looks like we\'ve managed to quell the sha... for now.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(60753,'','I can hardly believe it. You were able to suppress your hatred.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(60754,'Go kid! Make with the punch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60755,'Punch the luck out of that Wrestler!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60756,'Give him the chair!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60757,'My training has led to this point. I must not fail my brothers and sisters!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60758,'Is this the presence of the sha? It is far worse than my instructors ever described.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60759,'Don\'t let it grab you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60760,'Make with more left right punch and runs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60761,'The other rangers simply turned on one another.$B$BWe would have turned as well, but thanks to Yalia\'s quick thinking, we are safe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60762,'We were all trained to strengthen our minds against the sha\'s influence, but it is stronger than we imagined.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60763,'Well, I survived my first encounter with the sha. It was more frightening than I had anticipated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60764,'Next time I face the sha, I will be prepared.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60765,'Go go $pc luckydo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60766,'The sha took us by surprise. Luckily, we had no casualties.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60767,'Wikket gonna eat lightning and derk thunder!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60768,'You can beat that $pr wikket!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60769,'Beat that wikket like it owes you money!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60770,'Jib that $pr in the dooker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60771,'No no no! Jib! Then Jab!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60772,'','Taran and Ban are masters of strategy and logistics. I prefer fighting to planning.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60773,'','Why do we continue to wait? They should make the order to attack!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60774,'','My husband was captured by the yaungol several days ago. I cannot not rest until I see him safely returned.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60775,'My death will not stop da storm that is coming! Da Thunder King will rise!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60776,'Can you help me find my amulet Mishi?','Can you help me find my amulet Mishi?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60777,'Old Hat is the most good coach. $p would be a luckydo to listen to my advice.','',3,0,0,0,0,0,0,0,1,0,0,0,26124),
(60778,'<Mishi appears ready to leave.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60779,'','Welcome, $c! Be sure to take a moment and enjoy the view!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60780,'Have you noticed anything strange happening around Zouchin Village?','Have you noticed anything strange happening around Zouchin Village?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60781,'Seeing scenery that beautiful really puts things into perspective.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60782,'I will not leave until we have located Suna.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60783,'It is not in our nature to shirk from danger. We will dive gladly into darkness if it means protecting our loved ones.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60784,'An unseen enemy is perhaps the most dangerous of all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60785,'I will not leave until we have located Suna.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60786,'Stand your ground! We will drive the sha from this place!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60787,'The spirits are gone. The nightmare is over.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60788,'The color has just... left its body.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60789,'There\'s no doubt about it. These creatures have been affected by sha.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60790,'Look at the size of these! This one is definitely a breeding male.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60791,'That means the mantid queen is involved in this... somehow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60792,'His body - it\'s covered with scars. Old scars.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60793,'Not just any scars, either. These were created by pandaren weapons.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60794,'Here it is! This is what we\'ve been looking for!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60795,'Yak hair.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60796,'This place makes me uneasy, but we Shado-Pan do not run from danger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60797,'I heard the reclaimer\'s threat, but it was faint... Fleeting, like trying to recall the details of a dream.$B$BIt seems I\'m in your debt once again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60798,'Mo Mo now has the grummle luck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60799,'Stinky wikkets gonna get ravaged.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60800,'Mo Mo gonna be the luckiest of all hozen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60801,'Nothing here. Keep moving.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60802,'Nothing on this one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60803,'There\'s nothing here. Let\'s keep looking.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60804,'No... nothing of note here. Keep looking.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60805,'Poot Poot belongs to Cho Cho!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60806,'Here\'s something you might find interesting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60807,'I have no need for this. Do you want it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60808,'No clues here... but I did find this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60809,'What\'s this?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60810,'The Glintrok Scout shouts a warning!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60811,'I hate to keep you here so distracted...','I hate to keep you here so distracted...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60812,'','Who you supposed to be? Some kind of $c or something?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60813,'','Fizzy yellow beer is for wussies and grummles.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60814,'','Think you got what it takes to face my brews?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60815,'','One sip of my brews and you will see how unworthy you really are.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60816,'','I\'m fighting you? Wow this competition is going to be easier than I thought.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60817,'','Don\'t think I\'m letting you off the hook next time.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60818,'','You won this round but I\'ll have a better brew by our next encounter.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60819,'','I could have beat you today you know. All I needed to do was to switch to my \"Ale Stance\" sooner.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60820,'','Enjoy the taste of victory, for now. Next time we fight, you will taste the bitterness of defeat.$b$bIn fact, I think I\'ll name my next brew that. \"The Bitterness of Defeat.\" Doesn\'t roll of the tongue but it takes a special kind of failure to make one drink a brew named that.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60821,'Welcome, traveller. It is good to see variety included in this tournament.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60822,'Pay no attention to the hozen behind my back. His discipline training is... in progress.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60823,'We have travelled a long way from the Jade Forest to be here today. It is my hope I will grow my skills in this tournament.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60824,'I look forward to our coming challenge.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60825,'It is great to see you again, my friend. It seems like only yesturday we saved the city of Stoneplow from the mantid swarms.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60826,'It is always an honor to share words with the Savior of Stoneplow.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60827,'You should hear the stories they tell of you in Stoneplow.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60828,'$P! It is very good to see a friendly face here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60829,'It is very good to see you here my friend. It has been a while since our endevours in the Valley of the Four Winds.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60830,'Ken-Ken continues to be a nuissance and a destraction for everything he comes in to contact with. I look forward to the day when I no longer have to travel with him.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60831,'','Test your might!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60832,'','There is no knowledge that is not power.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60833,'Ah, the ancient Vaults of the Kings of Mogu\'shan. What might this button do...?','',0,0,0,0,0,0,6,0,1,0,30176,0,26124),
(60834,'Xuen insists Ken-Ken and I could have beat you had we learned to work together. Perhaps next time we will provide a better challenge.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60835,'Well fought earlier. It was quite surprising to see how strong you\'ve become.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60836,'Hopefully next time Xuen will let me face you directly rather than being hampered by a hozen.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60837,'Wrestler gonna punch wikket so hard in the face it gonna improve $pr looks.','',1,407,0,0,0,0,0,0,1,0,0,0,26124),
(60838,'Huh? Who you? Go away. Wrestler need more time with Coach Rok Rok!','',1,407,0,0,0,0,0,0,1,0,0,0,26124),
(60839,'Wikket got lucky today. Wrestler gonna beat on rematch!','',1,407,0,0,0,0,0,0,1,0,0,0,26124),
(60840,'Mmmphpmmmph!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(60841,'Ken-Ken has travelled far and now is super strong monk.','',23,1,0,0,0,0,0,0,1,0,0,0,26124),
(60842,'Sorry for slicky smell. Clever Ashyo not clean jinyu.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60843,'Ken-Ken would have won if Ashyo had not been a dooker.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60844,'Next time Ken-Ken gonna win! With or without Ashyo.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60845,'The hero of Stoneplow! Hi hi.','',4,1,0,0,0,0,0,0,1,0,0,0,26124),
(60846,'Here is the Super $R that saved Stoneplow!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60847,'Oh, $p! How you get here? Are we fighting today?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(60848,'Oh good to see you again! Clever Ashyo is derk for company.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60849,'You smell of a defeat in your near future.','',479,1,11,0,0,0,0,0,1,0,0,0,26124),
(60850,'My team will crush you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60851,'Do you know who I am? Do you know who I am?!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(60852,'Next time you may find I\'m harder to defeat! I\'ve made sure my healer remembers his place.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60853,'Ah! Don\'t talk to me! Tank! Tank! Taunt it off me you filthy thing!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(60854,'We are going to crush you next time! Our tank should be able to remember to generate enough threat on you!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60855,'You smell of loot.','',479,1,0,0,0,0,0,0,1,0,0,0,26124),
(60856,'We wiped and I didn\'t get my gear.','',18,1,0,0,0,0,0,0,1,0,0,0,26124),
(60857,'This looks to be the record of Qiang the Merciless, a great conqueror who ruled his vassals with an iron fist!','',0,0,0,0,0,0,5,0,1,0,31529,0,26124),
(60858,'I\'ve dreamed of being here today. This is it! This is going to be the day I win the tournament!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60859,'See this staff? It has been in my family for generations and won hundreds of tournaments at this very spot.$b$bCan you feel the power in it? It is much stronger here than anywhere else I\'ve travelled.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60860,'Well, you won today, but that doesn\'t mean I can\'t win tomorrow. Papa Bramblestaff always said if at first you don\'t succeed, wipe the blood off and get back in there until you do.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60861,'I\'ve heard tales of this one: Subetai the Swift, well known as a masterful archer and genius thief. He stole from the rich, and kept everything for himself.','',0,0,0,0,0,0,11,0,1,0,30177,0,26124),
(60862,'Ah! The \"hero\" who stole my spotlight at Stoneplow.$b$bI kid, I kid. That was a great battle. I am honored to have fought by your side.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60863,'$P! Welcome to the Temple of the White Tiger! Xuen runs an amazing tournament that my family has a habit of winning.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60864,'Well, look what the virmen dragged in. $P, how have you been? Are you hear to compete?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60865,'What is this? I\'ve heard nothing of this emperor. Meng the Demented? According to these texts, Meng was the most foul and maniacal ruler to ever abuse the imperial throne.','',0,0,0,0,0,0,6,0,1,0,31528,0,26124),
(60866,'You are here? Does this mean we will finally get a chance to compete against each other for the tournament title?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(60867,'Ooo. Does this mean I get to face the champion of Stoneplow? Fantastic!','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(60868,'Hackiss tries to pick your pocket.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60869,'I look forward to our match.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60870,'Xuen\'s challenge road the winds to my home in the Jade Forest. I could not refuse such an invitation.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60871,'You have the look of a champion. But do you have the fortitude.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60872,'No one can question the strength of your abilities, champion.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60873,'Wikkets think they can take the Boom Boom Boogaloo?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(60874,'Master Boom Boom\'s got some super boom sticks.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(60875,'Wikket thinks it won? Ha! Master Boom Boom never say \"surrender\"! Stalemate!','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(60876,'Strength comes in many forms. For some it is a weapon. For others a burden. For myself, I see it as a way of being.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60877,'Welcome, $p, to my Tournament of Strength!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60878,'Xuen teaches us that strength is a tool that requires practice.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60879,'Every few days Xuen hosts a tournament of strength. Only the strongest and most brave challengers from across Pandaria dare compete.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60880,'Watch out for Xuen\'s cubs. What they lack in size they make up for in pure strength.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60881,'Legend has it that Xuen hasn\'t fought in one of his own tournaments in centuries.$b$bHe says it is because he wants us to have a fighting chance. I think he\'s just getting old. Or... at least... old for a... well... whatever he is.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60882,'You call those strong arms? Ha! I have bruises that have more muscle in them.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60883,'Do you have the eye of a tiger?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60884,'|TInterface\\Icons\\ability_warrior_charge.blp:20|tAdarogg sets his eyes on |cFFFF0000$n|r and begins to cast |cFFFF0000|Hspell:119299|h[Inferno Charge]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60885,'Congratulations on your victory, Champion!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60886,'You honor us with your presence, Champion.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60887,'Those were some impressive feats of strength you displayed today. Well done!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60888,'I haven\'t seen a match like that in days!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60889,'Well fought, Champion!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60890,'I saw your fighting today. Less refined than some of the masters who enter the tournament, but certainly effective. I will watch you in the future, and learn.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60891,'Oh, a $c? Entering in the tournament? This should be interesting indeed.','Oh, a $c? Entering in the tournament? This should be interesting indeed.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60892,'Hmm. A $c is interesting, but let us see how well you do against the Wrestler or Master Boom Boom.','Hmm. A $c is interesting, but let us see how well you do against the Wrestler or Master Boom Boom.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60893,'A wonderful day for a tournament, wouldn\'t you say?','A wonderful day for a tournament, wouldn\'t you say?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60894,'My money is on one of those kids that came up from the Valley of the Four Winds.$b$bI heard they trained at the monastery in the Jade Forest.','My money is on one of those kids that came up from the Valley of the Four Winds.$b$bI heard they trained at the monastery in the Jade Forest.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60895,'I watched Master Windfur fight a dozen mogu once without any of them successfully landing a blow.','I watched Master Windfur fight a dozen mogu once without any of them successfully landing a blow.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60896,'I heard the Wrestler never ever takes his mask off. I wonder what he does if his nose gets itchy.','I heard the Wrestler never ever takes his mask off. I wonder what he does if his nose gets itchy.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60897,'Wow! You have no idea how much money you just won me. Thanks you, Champion!','Wow! You have no idea how much money you just won me. Thanks you, Champion!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60898,'Ah, Champion! You should return every tournament. I will make a fortune.','Ah, Champion! You should return every tournament. I will make a fortune.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60899,'Those were some amazing fights!','Those were some amazing fights!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60900,'Such a tragedy...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60901,'I\'ve never seen anyone fight like that before! You were incredible.','I\'ve never seen anyone fight like that before! You were incredible.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60902,'Your fighting made the trip up to the temple worth it!','Your fighting made the trip up to the temple worth it!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60903,'The Wrestler took out my old apprentice. Now you shall be my apprentice. You smell of luck... and sweat. Most good fortune indeed!$b$bThe Wrestler is slow but strong. Do not let him grab you.$b$bAlso, his mind is weak. Use the chairs in the arena to stun him.$b$bIf you get weak, use the bucket next to me for refreshings.$b$bGood fortune to you, apprentice of grummle!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60904,'','Oh, don\'t worry about him.$B$BMy oaf of a husband is just sleeping off a nasty blow to his thick skull.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(60905,'Hold your sword, Mei. There are too many of them - and if you die, what of my son?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60906,'No! No no no no no! Wrestler get up! Get up wikket!','',407,0,0,0,0,0,0,0,1,0,0,0,26124),
(60907,'Where are my heals you scrub-chinned-lizard-nub?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60908,'Aaah! It\'s hitting me! Tank it off! Tank it off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60909,'I could use a campfire and some warm food right about now. Are you here with good news?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60910,'I have orders for you to return to the battlefront.','I have orders for you to return to the battlefront.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(60911,'','A friendly face is welcome around here. Happen to bring some rations?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60912,'','We\'ve been at this post for days with no sleep. You\'ve no idea how badly I want to just lie down.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60913,'I\'ve never seen them in such numbers...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60914,'','Whatever you do, stranger, do not ask my husband about his egg noodle recipe. It will be the longest conversation you have ever heard.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60915,'You\'ve received Volatile Greenstone Brew! Use it in combat to help defeat multiple enemies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60916,'[PH] Vengeful Hui\'s anger has been beaten out of him! He has grown calm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60917,'[PH] Hey guys, I\'m really sorry about all that. Friends...?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60918,'I got you in my sights, monkey!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60919,'So, Alliance finally decided to drop in some reinforcements, eh? Get to the front, $c!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60920,'I knew they\'d send reinforcements! Never doubted it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60921,'They\'re coming over our barricades! Push them back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60922,'It\'s do or die, men! Don\'t shoot till you see the crazy in their eyes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60923,'What are you standing there for, $r? We need everyone at the frontlines!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60924,'Bout time they sent some heroes from HQ. Get out there and fight, $c!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60925,'Let\'s show those long-tailed gingers what the Alliance is made of! Charge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60926,'Their numbers are endless, $c! Help us hold them back!','Their numbers are endless, $c! Help us hold them back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60927,'$R, over here! Drive them back!','$R, over here! Drive them back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60928,'Ho, did they send more reinforcements from Stormwind? $C on the field!','Ho, did they send more reinforcements from Stormwind? $C on the field!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60929,'For the Alliance!','For the Alliance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60930,'Many thanks... I couldn\'t have held out much longer.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(60931,'Ah, you have returned! One thousand thanks. Please, take this, our most potent creation: Volatile Greenstone Brew.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60932,'Clan Gurthan will show our King and the rest of you power-hungry imposters why we are the rightful ones at his side!','',0,0,0,0,0,0,15,0,1,0,27932,0,26124),
(60933,'Clan Kargesh will demonstrate why only the strong deserve to stand at our King\'s side!','',0,0,0,0,0,0,15,0,1,0,28246,0,26124),
(60934,'Clan Harthak will show all why they are the truest of Mogu!','',0,0,0,0,0,0,15,0,1,0,27947,0,26124),
(60935,'Yeeee-haw, we drove them back!! That\'s right, monkeys, run your little tails off!','',0,0,0,0,0,0,71,0,1,0,0,0,26124),
(60936,'Looks like they couldn\'t handle the taste of Alliance steel. Good work, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60937,'My people, corrupted...\n\nShai Hu, a local warrior, was the first to drink of the tainted waters.\n\nHe was strengthed, emboldened, and urged the others to do the same.\n\nI warned them against it. I sensed danger, corruption...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60938,'Woah... My hooves are huuuuge...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60939,'These grummle charms are starting to kick in...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60940,'These grummles make a strange grog.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60941,'It... its like I can smell the grummle luck...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60942,'I think I can hear myself getting luckier...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60943,'We will never surrender our right to rule the destiny of our people!','',0,0,0,0,0,0,16,0,1,0,27933,0,26124),
(60944,'Our clan is the true clan! No interloper can change that!','',0,0,0,0,0,0,16,0,1,0,27948,0,26124),
(60945,'Impossible! Our might is the greatest in all the empire!','',0,0,0,0,0,0,16,0,1,0,28247,0,26124),
(60946,'Go away. My team can handle ourselves.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60947,'We wouldn\'t be in this mess if Tankiss would learn to keep the heat off his healer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60948,'I found a grummle cake in a corner of my cage. So delicious! Best day ever!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60949,'Stay inside, Hanae! Adventurer, please see if there\'s anything the Gentle Mother needs. She is working tirelessly to tend to the survivors inside.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60950,'','Danger? Ha! I scoff at danger!$B$BDon\'t you know that the most delicious foods are also the most dangerous to acquire?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60951,'I knew it was within their power to defy the mogu - they just needed someone like you to show them how.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60952,'I don\'t know where you came from, but if you\'ll continue to stand up for justice as you have done today, you\'ll be welcome in Pandaria.$B$BThank you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60953,'Faster, smith! Shai Hu hungers for blood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60954,'Will you ever finish your work, smith? Perhaps you require additional encouragement?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60955,'Orachi shall have my head if you do not work faster, smith! And I shall have yours.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60956,'Silence, priest! You know nothing of my work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60957,'Your impudent patter does not intimidate me, fool.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60958,'','You want something? Mine is the bitterest of the brews. Are you worthy?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(60959,'You have my gratitude.','You have my gratitude.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(60960,'Yes. I do.','Yes. I do.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60961,'Yes. I do.','Yes. I do.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60962,'I wish to reset my Class Specialization.','I wish to reset my Class Specialization.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60963,'I wish to remove my glyphs.','I wish to remove my glyphs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60964,'You have my gratitude!','You have my gratitude!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(60965,'There\'s hope for Greenstone! Thank you!','There\'s hope for Greenstone! Thank you!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(60966,'I thought I was doomed. Thank you so much!','I thought I was doomed. Thank you so much!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(60967,'I\'ll defend this place to my death, you monster!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60968,'I once found a feather from big green bird on Neverrest. No green birds fly on Neverrest. This is a very good luckydo.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60969,'Someone! Please help!','Someone! Please help!',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(60970,'Find a copper, pick it up, all day long I\'ll have good luck.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60971,'Stay here tonight, buy my wares, and fortune will shine on you for certain.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(60972,'You are skilled in the healing arts, $c.','You are skilled in the healing arts, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60973,'Your healing skills are impressive, $n.','Your healing skills are impressive, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60974,'Where did you learn to do that? You must have had a lot of practice.','Where did you learn to do that? You must have had a lot of practice.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60975,'Well done, $c. You have been taught well.','Well done, $c. You have been taught well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60976,'You have studied your craft well, $c.','You have studied your craft well, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60977,'*hic*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60978,'Help! Help!','Help! Help!',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(60979,'Away, you fiends! Help!','Away, you fiends! Help!',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(60980,'They\'ve overrun the village! HELP!','They\'ve overrun the village! HELP!',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(60981,'More hired thugs?! It will take more than these three to best me!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(60982,'You\'ll learn to serve!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60983,'Bow down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60984,'The weak have no place in this world!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60985,'I will teach you some respect!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60986,'Know your place!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60987,'Insolent little $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60988,'You dare to defy the mogu? Then you will die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60989,'Our empire will be glorious! And you won\'t be there to see it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60990,'I will not tolerate this disobedience!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60991,'I\'ve never performed this ritual. I don\'t know what will happen, exactly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60992,'It\'s been passed down from ancient times, but none of our people have needed to use it since then.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60993,'Let us see if this is sufficient to cleanse the corruption from my people\'s souls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60994,'Gormal takes additional damage while taunted by a farmer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(60995,'That swarm is what we have to look forward to. Ancestors help us if they decide to turn on the battlefront.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(60996,'','Let my replacement know that a lot of mantid have been trying to sneak through the main channel. This is no easy post.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(60997,'Even better news than I was hoping. I look forward to a warm bed.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(60998,'','Even better than rations. Rest. I thought I\'d be out here a while yet.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(60999,'It worked! It wo-','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61000,'Wh... what is happening? Why is the ritual affecting her?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61001,'Dat\'s betta. Now let\'s get to huntin\' dem monkeys, mon.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(61002,'First rule of the Tiger Temple Tournament: We don\'t talk about Tiger Temple Tournament.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61003,'I thought I was a goner. I owe you my life.','I thought I was a goner. I owe you my life.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61004,'Thank you for rescuing me. For the Alliance!','Thank you for rescuing me. For the Alliance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61005,'Thanks, friend. That was some firefight, but I knew that blue would pull through!','Thanks, friend. That was some firefight, but I knew that blue would pull through!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61006,'Thank you, friend. Don\'t worry, it was just a scratch. Now I feel good as new!','Thank you, friend. Don\'t worry, it was just a scratch. Now I feel good as new!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61007,'Nice seeing another Alliance face! I thought I was going to die out here.','Nice seeing another Alliance face! I thought I was going to die out here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61008,'That... thing must be what was controlling the villagers! I now know what we must do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61009,'','I feel so much calmer. What happened?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61010,'What is that?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61011,'A beast emerged from you when I began the ritual. $p slew it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61012,'','I felt a presence, a burning pain and rage in my mind...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61013,'Point out the pools of corruption, and I will use my staff to cleanse them. You\'ll need to defeat the creatures that emerge!','',0,0,0,0,0,0,0,0,1,16321,0,0,26124),
(61014,'Hey rookie, take this diving helmet. You might need it out there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61015,'Defeat the Shadow of the Golden Lotus to escape!','Defeat the Shadow of the Golden Lotus to escape!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61016,'Are you coming?','Are you coming?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61017,'I will begin the ritual. Prepare yourself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61018,'Now, friend. Prepare yourself to defeat whatever emerges!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61019,'Hopefully this one will not be worse than the last...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61020,'General Pa\'valak calls for Reinforcements!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61021,'Come on, Zin\'Jun, there\'s vengeance to be had!','Come on, Zin\'Jun, there\'s vengeance to be had!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(61022,'I have nothing to teach you, $c.','I have nothing to teach you, $c.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(61023,'How may I help you?','How may I help you?',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(61024,'This land must be made ready for the fleet.$b$bNo excuses!','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(61025,'Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61026,'','This old bear... I can\'t stay mad at him.$B$BThank you, stranger.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61027,'','One fewer of these pests behind the blockade.',0,0,0,0,0,0,0,0,1,0,0,31377,26124),
(61028,'','I would love to help you, Lorewalker, but understand - I am in a real bind here.',1,0,0,0,0,0,0,0,1,0,0,29533,26124),
(61029,'','Gah! You\'re as stubborn as my dang husband!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(61030,'But look who has arrived! Mrs. Mann, there\'s someone I would like you to meet.','',0,0,0,0,0,0,0,0,1,0,30088,0,26124),
(61031,'Lifting','Lifting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61032,'Don\'t get too comfortable here, pal.$b$bThe general says these digs is only temporary.','',5,388,0,0,3,0,396,0,1,0,0,0,26124),
(61033,'Please, accept the ancestors blessing. It is not much, but it is all I can give without my staff, and will help you traverse the Mere.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61034,'','Ooh, it takes some real stones to challenge the Mistress of Illusion. Well? Show me what you\'ve got!',0,0,0,0,0,0,0,0,0,0,0,30287,26124),
(61035,'','Ashes, ashes, we all fall down!',0,0,0,0,0,0,0,0,0,0,0,30289,26124),
(61036,'','Aw. Careful not to bleed on the rug please, dear.',0,0,0,0,0,0,0,0,0,0,0,30290,26124),
(61037,'','Better luck next time!',0,0,0,0,0,0,0,0,0,0,0,30291,26124),
(61039,'','Ugh... death... hurts? Unreal...',0,0,0,0,0,0,0,0,0,0,0,30288,26124),
(61041,'','Come, try your luck! Ha ha haaa...',0,0,0,0,0,0,0,0,0,0,0,30292,26124),
(61042,'The lawspeaker was right... they\'ve gone insane!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61043,'You... you\'re not one of them, are you? You\'ve got to help me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61044,'There\'s no hope... our people have lost their minds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61045,'There\'s still hope - Gorai is still alive, to the south. Go!','There\'s still hope - Gorai is still alive, to the south. Go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61046,'','Feeling a bit... dizzy?',0,0,0,0,0,0,0,0,0,0,0,30293,26124),
(61047,'You are not the first to challenge me, peons. You will not be the last.','',0,0,0,0,0,0,0,0,0,0,28349,0,26124),
(61048,'What is this, more have come to claim my crown? They are small and weak.','',0,0,0,0,0,0,0,0,0,0,28355,0,26124),
(61049,'I know you. If the reports I\'ve been receiving are true, I could use a $gman:woman; like you.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61050,'Taoshi speaks highly of you. Her respect for you says a great deal.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61051,'We\'re on the trail of the Sha of Hatred. I want you with us for the hunt.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61052,'MY MIGHT IS ENDLESS!','',0,0,0,0,0,0,0,0,0,0,28351,0,26124),
(61053,'Thank you, friend... I\'ll make my way to the south!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61054,'Gorai lives? I will go find him. Thank you, friend!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61055,'Face the might of my arsenal, weaklings!','',0,0,0,0,0,0,0,0,0,0,28350,0,26124),
(61056,'You are very brave... thank you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61057,'Fools, I possess the power of the elements!','',0,0,0,0,0,0,0,0,0,0,28359,0,26124),
(61058,'ENOUGH OF THIS FARCE! You will feel PAIN, cowards!','',0,0,0,0,0,0,0,0,0,0,28360,0,26124),
(61059,'%s spits blood in your face.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(61060,'We will need the strongest the Shado-Pan has to offer for the confrontation with the Sha of Hatred. And it\'s likely that even then, not all of us will make it out alive.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61061,'We\'re close. I can feel the unnatural hatred broiling inside of me.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61062,'This ancient fresco was once inlaid with jade, but it has fallen into ruin and now its wisdom is lost to us.','',0,0,0,0,0,0,1,0,1,0,30089,0,26124),
(61063,'We will all be tested this day, but we shall prevail.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61064,'With the sudden arrival of strangers on Pandaria, I believe we\'ll need the lessons our history can teach us.','',0,0,0,0,0,0,1,0,1,0,30090,0,26124),
(61065,'You call that... a fight...?','',0,0,0,0,0,0,0,0,0,0,28352,0,26124),
(61066,'','I understand, Lorewalker. But the Serpent\'s Heart project is behind schedule and we\'ve not a stone to spare!',1,0,0,0,0,0,1,0,1,0,0,29534,26124),
(61067,'Who allowed these outsiders inside our halls? Only Clan Harthak or Clan Kargesh would stoop to such treachery!','',0,0,0,0,0,0,25,0,1,0,27940,0,26124),
(61068,'Tender your souls, mortals! These are the halls of the dead!','',0,0,0,0,0,0,0,0,0,0,27814,0,26124),
(61069,'See how effortlessly I CRUSH your bones!','',0,0,0,0,0,0,0,0,0,0,28357,0,26124),
(61070,'Fall to your knees, coward!','',0,0,0,0,0,0,0,0,0,0,28358,0,26124),
(61071,'Have patience, Mrs. Mann. These strangers from beyond the mist continually surprise me.','',0,0,0,0,0,0,1,0,1,0,30091,0,26124),
(61072,'Only the dogs of Clan Gurthan would point fingers at others for their own failures! Your clan is the most desperate. It must\'ve been you!','',0,0,0,0,0,0,15,0,1,0,27955,0,26124),
(61073,'','You expect this dumpling to clean up the mason\'s quarter? They barely even got a belly on them!',1,0,0,0,0,0,6,0,1,0,0,29535,26124),
(61074,'Clan Gurthan is right! Only the honorless Clan Harthak could bring in a lesser race to do their bidding. You must be traitors!','',0,0,0,0,0,0,14,0,1,0,28254,0,26124),
(61075,'|TInterface\\Icons\\spell_arcane_blast.blp:20|t %s begins to cast |cFFFF0000|Hspell:117914|h[Total Annihilation]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61076,'Silence, you motherless mu\'shan herders! I\'d blame your clan, but your skulls are too thick to figure out a child\'s puzzle box, let alone how to usurp power.','',0,0,0,0,0,0,153,0,1,0,27956,0,26124),
(61077,'A well-scripted exchange; but we are not fooled. Your clans are clearly in league with one another. For the glory of our king, our empire, we will put you all down!','',0,0,0,0,0,0,15,0,1,0,27941,0,26124),
(61078,'Clan Kargesh will not suffer these insults! We will have your heads to offer to the king as proof of our might soon enough!','',0,0,0,0,0,0,15,0,1,0,28255,0,26124),
(61079,'You must be the $r that freed Bold Karasshi and our other brothers! We owe you our thanks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61080,'Bold Karasshi mentioned a $r would pass through. That person must be you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61081,'You must be the one who helped our brothers. Thank you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61082,'$R, you are welcome here. Bold Karasshi has already told us of your deeds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61083,'$C, is it not? Thank you for returning our brothers to us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61084,'Good day, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61085,'May the waters bless you, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61086,'How do you fare today, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61087,'Hold on tight!','',0,0,0,0,0,0,0,0,1,0,32867,0,26124),
(61088,'Crazy nibblers! Give them a whoopin\' , $p!','',0,0,0,0,0,0,0,0,1,0,32868,0,26124),
(61089,'Daggone critters don\'t know when to give up, do they?!','',0,0,0,0,0,0,0,0,1,0,32869,0,26124),
(61090,'We\'re almost to the fresco. Keep it up back there!','',0,0,0,0,0,0,0,0,1,0,32870,0,26124),
(61091,'','Good work.  Meet me at the eastern entrance to the blockade.  We need to find the hole in the defenses and plug it.',0,0,0,0,0,0,2,0,1,0,0,31384,26124),
(61092,'I\'m ready. Begin the ritual.','I\'m ready. Begin the ritual.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61093,'Flesh from bone.... Tsss.... their spirits are broken!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(61094,'They crumble so easily.','',0,0,0,0,0,0,0,0,0,0,27818,0,26124),
(61095,'Ripe for the picking.','',0,0,0,0,0,0,0,0,0,0,27819,0,26124),
(61096,'Oh great spirit! Grant me the power of the earth!','',0,0,0,0,0,0,0,0,0,0,27816,0,26124),
(61097,'Oh exalted one! Through me you shall melt flesh from bone!','',0,0,0,0,0,0,0,0,0,0,27820,0,26124),
(61098,'Oh sage of the ages! Instill to me your arcane wisdom!','',0,0,0,0,0,0,0,0,0,0,27821,0,26124),
(61099,'Great soul of champions past! Bear to me your shield!','',0,0,0,0,0,0,0,0,0,0,27817,0,26124),
(61100,'If they only knew... what horrors await...','',0,0,0,0,0,0,0,0,0,0,27815,0,26124),
(61101,'Well done! I name you the Champion of Strength! May your enemies tremble before your title.','',0,0,0,0,0,0,1,0,1,0,29026,0,26124),
(61102,'Well you can\'t just stay in here! You leave me no choice!\n<Use the Fire Lotus Incense.>','Well you can\'t just stay in here! You leave me no choice!\n<Use the Fire Lotus Incense.>',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(61103,'He is dead! You have done it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61104,'Friend, I will return to the refugees. Meet us there, so we can thank you properly.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(61105,'My people, here $ghe:she; is! The one who gave the Inkgill new life. $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61106,'Thank you again, friend. We will remember your name in our people\'s history.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61107,'All hail, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61108,'As you can see, this is a defective yak. Go ahead, $r. Try to pet it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61109,'I wouldn\'t do that if I were you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61110,'You see? Bad yak. Now go on, $r. Try to feed it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61111,'','I think you don\'t understand how the yak temple works.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61112,'See!? Very bitey. And he doesn\'t follow orders, either. Try to move him, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61113,'','Try to understand, grummle. This is a temple to Niuzao, the great Black Ox. We are servants to him, and keepers of this temple. We do not \"replace yaks\".',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61114,'I see. Can I at least get mine serviced? He won\'t even take a rider.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61115,'Cousin Bluesaddle... you are too persistent. And you are being mean to the $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61116,'My case is made. This yak is very bad. We will not leave this yak temple until you fix him or replace him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61117,'','Fine. There are plenty of wild yaks near the lake to the north. You can \"replace\" your yak with one of those.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61118,'See, Cousin Bag-of-Rocks? Persistence pays off.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61119,'But... we could have found wild yaks back in Kun-Lai...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61120,'Where... were... my heals?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61121,'Healiss... you failed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61122,'Ah! My cooldowns!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61123,'Why did it have to be a $pc?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61124,'Healiss, heal me you son of a basilisk!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61125,'Start healing you filthy snakehead!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61126,'Healiss, heal me, you mogu loving pond drinker!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61127,'Healiss, keep up on the heals you mushan lips!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61128,'Tankiss! Help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61129,'Ah! Facefull of $c!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61130,'Help! It\'s on my face!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61131,'Tankiss... too... squishy...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61132,'Tankiss... get a shield!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61133,'Out of mana...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61134,'I\'m starting to make bombs! PH','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61135,'Alright, $n. I\'m ready to go.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61136,'Father!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61137,'Yes! Our friend here brought me back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61138,'Son! Are you well?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61139,'|TInterface\\Icons\\spell_shadow_shadowfury:20|tDark Shaman Koranthal summons a |r|cFF9E09DE|Hspell:119971|h[Shadow Storm]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61140,'Your luck just ran out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61141,'How many years of bad luck is breaking your face?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61142,'We are discussing where we shall go next. Perhaps join the Pearlfin in Jade Forest?\n\nSpeaking of which - how does the $ngill Tribe sound to you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61143,'They took my son... They took my goods, I have lost everything. What could possibly have changed these Jinyu?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61144,'My son... though I have recovered my goods, what will come of him?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61145,'How does fortune smile on me so? My son, my livelihood returned to me... \n\nTo have thought that one day I was simply content with all this. How truly lucky I was!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61146,'It is funny, I think my father is happier now that I have returned than he ever was before!$b$bIt seems that trying times have reminded him to appreciate simplicity.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61147,'','I hope you made them hurt, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61148,'','I can\'t believe how I felt before.\n\nTo think that I could have become posessed by the same thing that controlled these Jinyu, it\'s... disturbing, to say the least.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61149,'We made it to the top!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61150,'Are you ready to begin the trials?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61151,'Start Basic Damage (Bronze)','Start Basic Damage (Bronze)',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61152,'','Toya\'s been looking for you. He\'s been collecting all our extra jade.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61153,'We will be watching you.','',0,0,0,0,0,0,1,0,1,0,30632,0,26124),
(61154,'Artists need to be reminded to eat once and a while.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61155,'What do you think, $n? Should we trust these natives?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61156,'The Pearlfin do not trust us. We must show them that we mean no harm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61157,'It may be wise to befriend these people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61158,'Bless the waters for bringing you to my shore, weary traveler. Please rest yourself in the calming mists of my inn.','',396,0,0,1,0,0,0,0,1,0,0,0,26124),
(61159,'Thank you for your hospitality.','Thank you for your hospitality.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61160,'Well, you have done what you could through diplomacy. Now, we can only prove ourselves to the Pearlfin through our deeds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61161,'You survive the mountain pass only to die here!','',15,25,0,2,4,0,0,0,1,0,0,0,26124),
(61162,'As Waterspeaker, I performed many rituals. There is one, though, that I have never performed - to purify mental corruption.\n\nIt is an ancient ritual, one which we have not needed since days of legend, when Shaohao walked Pandaria.\n\nI fear we need it now...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61163,'Fight harder, weaklings!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61164,'Feel the rage!  Put it into your strikes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61165,'A pathetic hit. More brutality!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61166,'Too weak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61167,'While I would love to purify all of my corrupted brethren, I cannot allow those of us who have not fallen to corruption to go leaderless.\n\nWe must stop the spread of this vile influence, and then I will lead those of us who remain pure to freedom.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61168,'Reset the event. [PH]','Reset the event. [PH]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61169,'Why would they not listen?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61170,'How will I save them?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61171,'I\'ve never seen anything like this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61172,'Die, interloper!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61173,'I will DESTROY you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61174,'Raaaaaghh!','',0,0,0,0,0,0,0,0,1,0,10030,0,26124),
(61175,'You\'re not one of us!','',0,0,0,0,0,0,0,0,1,0,10030,0,26124),
(61176,'Die, worthless $pr!','',0,0,0,0,0,0,0,0,1,0,10030,0,26124),
(61177,'Can\'t... control... the RAGE!','',0,0,0,0,0,0,0,0,1,0,10030,0,26124),
(61178,'I. Am. UNDEFEATED!','',0,0,0,0,0,0,0,0,0,0,28356,0,26124),
(61179,'I\'m a fierce predator!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(61180,'%s howls triumphantly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(61181,'Hello. I am Groundskeeper Ponch. Have we met before? My memory is not too good.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61182,'|cFFFE9A2ESap Globules|r begin to sprout from the tree!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61183,'|TInterface\\Icons\\spell_nature_wrathv2.blp:20|t%s begins to cast |cFFFF0000|Hspell:120001|h[Detonate]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61184,'Nooo! I was playing!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(61185,'Hey! Put me back! I was gonna judge a match!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(61186,'Not fair! I wanna watch the fights!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(61187,'Aw! But the Wrestler was gonna fight soon.','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(61188,'Noo! If I don\'t get in another nap I won\'t be ready for my big snooze.','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(61189,'Don\'t you know what I am? I\'m a fierce predator! I\'ll cut you!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(61190,'Hissssssss!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(61191,'You can\'t catch me!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(61192,'Yes I can!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(61193,'Ready... FIGHT!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(61194,'Point!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(61195,'You call that fighting?','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(61196,'Come on Mister Flabbypants! Punch like you mean it!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(61197,'Do something cool!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(61198,'Victory!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(61199,'Oh come on. What was that? Was that a punch? That didn\'t look like a punch. That looked like a cry for help.','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(61200,'I am Ponch. I clean the grounds and watch the kittens. They tell me I was a champion once. That must have been neat.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61201,'I... I feel like I was looking for something. But I can\'t remember what.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61202,'I like to clean the leaves away from the trails. Too many leaves brings sprites. Temple monks do not like sprites.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61203,'He\'s cornered!','He\'s cornered!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61204,'We\'ve got him now!','We\'ve got him now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61205,'At least we know that Anduin is alive. Well done, $n. Now go speak to Elder Lusshan. He has been asking for you.','',0,0,0,0,0,0,0,0,1,16544,0,0,26124),
(61206,'So long, Ruthers! We won\'t miss you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61207,'Why have you come here? What are your intentions?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61208,'You say you come in peace, yet you wear strong armor and wield many weapons.$B$BHow do you explain that?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61209,'The safety of the tribe is my foremost concern. Do you blame me for being cautious?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61210,'How do I change my Primary Specialization?','How do I change my Primary Specialization?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61211,'How do I reset my Glyphs?','How do I reset my Glyphs?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61212,'Fresh meat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61213,'What business do you have here, stranger?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61214,'$R, do not try anything funny. We are watching you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61215,'Why have you come here, outsider?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61216,'We are not unfriendly, stranger. Just wary.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61217,'Trust is earned, stranger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61218,'Why should we trust you, stranger?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61219,'Hoh-hohhh! What a rush! I like you, $c. You keep things interesting.','',0,0,0,0,0,0,11,0,1,0,32871,0,26124),
(61220,'Snow lily! We\'re back from the quarry! Got a special delivery just for you, my sweetness.','',0,0,0,0,0,0,22,0,1,0,32861,0,26124),
(61221,'','Honey-Bear! I mean... it is about time.',0,0,0,0,0,0,4,0,1,0,0,29536,26124),
(61222,'','Don\'t you \"snow lily\" me! I was- WE- were worried sick about you.',0,0,0,0,0,0,274,0,1,0,0,29537,26124),
(61223,'Sorry to keep you waiting, sugarfur. I know how you worry. Truth is, this stranger here saved my old hide. Go figure.','',0,0,0,0,0,0,1,0,1,0,32862,0,26124),
(61224,'%s gives you a sly wink.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61225,'','And the delivery is not for ME, Hao! The honorable Lorewalker has been waitin- oh...',0,0,0,0,0,0,274,0,1,0,0,29538,26124),
(61226,'The %s retreats to the Dread Expanse!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61227,'A Mogu\'s feet should always be on the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61228,'It burns!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61229,'You can\'t stop what has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61230,'These guardians are just da beginning!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61231,'Da Thunder King\'s army will take dis land back for us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61232,'Da Thunder King will return!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61233,'Can you feel it? Da Thunder is getting closer...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61234,'Thank you, $n. I have had enough training.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61235,'Thank you for your help, $n. My daggers will cut through many enemies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61236,'With this shield and sword, I will protect my friends and family.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61237,'The secrets of the waters are now known to me. I will use these gifts to help the village.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61238,'Greetings, $n! Before I join my brothers in battle, I must practice the healing arts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61239,'My blades are sharp, but my skill is unhoned. I am ready to learn, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61240,'Let me lend you my shield, $n. Allow me to protect you, so that I may better protect my village!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61241,'Teach me, $n! I will bend the forces of water to destroy our foes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61242,'','Want some grub? I made it all by myself!',4,0,0,0,0,0,0,0,1,19445,0,0,26124),
(61243,'Obey me, beast!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61244,'Heel! Or I will cook and eat you on the spot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61245,'Mine is an idiot.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61246,'Why is this creature defying me?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61247,'Surrender, creature!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61248,'Now... sit!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(61249,'Good boy!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(61250,'Horde say you gotta die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61251,'For the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61252,'Alliance dookers! We part of Horde now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61253,'Ookin\' Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61254,'Ready for duty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61255,'Let\'s get them, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61256,'It\'s now or never, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61257,'Lead us onward, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61258,'No no no! This land is mine, all mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61259,'I hate slickies! Yucky yucky slickies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61260,'Stupid, stupid, stupid ookin\' dookers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61261,'We must stop the Dark Shaman now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61262,'Did Garrosh send you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61263,'I\'m just a rock. Nothing to see here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61264,'It\'s safe to come out now.','It\'s safe to come out now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61265,'|TInterface\\Icons\\sha_ability_rogue_envelopingshadows.blp:20|t%s is unleashing |cFFFF0000|Hspell:120215|h[Deathforce]|h|r! RUN AWAY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61266,'Yessssssss!  Kill them!  Kill them all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61267,'Our highest priority is to evacuate The White Pawn, Prince Anduin Wrynn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61268,'Your guess is as good as mine. We have to be ready for anything.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61269,'Enough! I\'ll handle you myself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61270,'Thank you, $p. You fight well for one not of our order. I can handle the rest from here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61271,'Return to the Lair of the Jade Witch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61272,'','Return to the Serpent\'s Heart.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61273,'Return to the Fox Grove.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61274,'Return to the Bamboo Wilds and Pearlfin Village.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61275,'Return to the Fox Grove.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61276,'Return to the Serpent\'s Heart.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61277,'Return to the Lair of the Jade Witch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61278,'','Return to the Scenic Overlook.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61279,'Just an ordinary crate. Definitely no one hiding here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61280,'Kobai leads the yaungol attacking us... but I do not think he is the source of our problems.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(61281,'And now, we spring the trap on our attackers...','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(61282,'The Monastery... it worries me that we have heard nothing from them...','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(61283,'We need to stop the Dark Shaman before they become a real threat to Orgrimmar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61284,'My best scouts still haven\'t returned.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61285,'I thought I was going to die down here!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(61286,'Thanks!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(61287,'I didn\'t think anyone was coming for us.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(61288,'I owe you an ale!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(61289,'Slowly then.','',0,0,0,0,0,0,1,0,1,0,30633,0,26124),
(61290,'RUN!!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(61291,'Your mother\'s so old she saw the rise of the first kingdom!','',0,0,0,0,0,0,11,0,0,0,27951,0,26124),
(61292,'Your father\'s so weak that a pandaren took pity on him and invited him to dinner!','',0,0,0,0,0,0,397,0,0,0,27937,0,26124),
(61293,'Your clan is so low that hozen tell \"stupid\" jokes about them!','',0,0,0,0,0,0,14,0,0,0,28252,0,26124),
(61294,'Where\'d you get that weapon from, your sister?','',0,0,0,0,0,0,396,0,0,0,28253,0,26124),
(61295,'','Psst! $c! Over here by the stairs! No don\'t look at me! Just come here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61296,'Fools! Attacking the might of the mantid head on?  Your deaths will be swift.','',0,0,0,0,0,0,0,0,1,0,30264,0,26124),
(61297,'Swarmers, attack!  Tear the flesh from their bones!','',0,0,0,0,0,0,0,0,1,0,30265,0,26124),
(61298,'The Sha Abomination breathes pure death!  Move away from him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61299,'Carpet bomb the platform! Send in the Amberwing!','',0,0,0,0,0,0,0,0,1,0,30269,0,26124),
(61300,'Hold back! You\'re just mindlessly walking to your deaths!  I must think...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61301,'Faster! We must attack faster!  They cannot hold all of us back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61302,'Get in there berserkers!  Destroy them all!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61303,'Everyone! Send everything! Slaughter these cowards, they are making us look like fools!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61304,'Your defenses are nothing!  I will cut you down and keep your heads as trophies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61305,'The power of the Dark Shaman will overwhelm you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61306,'My death... means... nothing...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61307,'Are you sure you\'re ready to join the Alliance?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61308,'I\'m dry! Gotta get some more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61309,'Here comes the pain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61310,'I have no time for small talk, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61311,'This better be important.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61312,'','I\'m worried about the others, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61313,'','What is the horde trying to do down here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61314,'','That poor village was ambushed when the Zandalari arrived. They don\'t even have any skilled fighters to defend themselves! You have to help them. Shin will make sure you get to the village safely.',18,5,0,0,2,0,0,0,1,0,0,0,26124),
(61315,'Who do you think the King will pick?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61316,'Our clan is the greatest in all the land, he must choose us!','',0,0,0,0,0,0,23,0,1,0,0,0,26124),
(61317,'I bet the other clans can\'t even use magic anymore. What good could they be to the King!','',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(61318,'I heard the King is going to force us to fight each other. Not that it will take much for that to happen.','',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(61319,'With all these clans here I bet a fight\'s going to break out.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(61320,'I heard the King is going to force us to fight each other. Not that it will take much for that to happen.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(61321,'That Saurok\'s making off with our loot, get him!','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(61322,'Get that Saurok!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(61323,'The %s submerges beneath the Dread Expanse!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61324,'The %s emerges from the Dread Expanse!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61326,'I was starting to wonder how long I would be out here.','You do us a great service friend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61327,'My poor old bones were starting to get stiff out here.','Thanks to you I\'ll be rested when those barbarians return.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61328,'Those Zandalari will regret attacking Zouchin!','So... sore...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61330,'I\'m grateful to you, friend.','You\'re my hero!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61331,'Sometimes the roads we travel teach us more about ourselves than we would expect.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61332,'With the villagers help we will surely track down the Zandalari.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61333,'I hope our paths cross again, $n! Until then, may your journey be safe and meaningful.','',1,2,3,0,6,8,0,0,1,0,0,0,26124),
(61334,'I found it!  It\'s mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61335,'Why you try to take my sword?  It\'s MY sword!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61336,'Leave me and sword alone!  No retakes allowed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61337,'If dumb man lose sword, it not dumb man\'s sword no more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61338,'Mean sword-takers. Go away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61339,'Stop it meanies!  Maybe I take your sword too!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61340,'Takers keepers!  Don\'t be dumb.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61341,'MINE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61342,'Take me to the Temple of the Jade Serpent.','Take me to the Temple of the Jade Serpent.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61343,'I require the flame, master.','I require the flame, master.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61344,'Noodles here, get your delicious noodle soup!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61345,'Steamed buns, delicious steamed pork buns! Come and get them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61346,'Steaming hot noodle soup, come and get your hot noodle soup!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61347,'Tasty, fresh, wholesome and delicious! Come get some of Tao\'s noodle soup!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61348,'Try the hottest spices from here to the great wall! Delicious, spicy soup!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61349,'Stinky tofu, come and get your stinky tofu! I\'ve got the stinkiest tofu in all of Pandaria!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61350,'%s sighs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61351,'','Ho, $c, welcome to the eastern temple! Make yourself at home.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61352,'','You look weary, traveler. Come share our warm fire and good brew.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61353,'','Welcome, $r. Have a look around.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61354,'','Welcome to my inn, traveler. We have hot meals and soft beds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61355,'','Look what the winds blew to my door! Take a break from your adventures and rest, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61356,'Face me. Show me your full potential.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61357,'Your presence here is unwelcome.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61358,'This is a sacred place. Strangers are unwelcome.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61359,'What matter of \'thing\' are you?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61360,'You smell of the low lands. You should go back to them. There is no peace in these mountains for travelers.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61361,'You will find no peace here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61362,'You come as the carrion bird before a battle.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61363,'Ours is the way of highest service. I have no time for petty conversation or challenges from a low lander.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61364,'You look as one who has seen much fighting. But tell me, was it in service to yourself, or others?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61365,'We are the watchers of the wall, the keepers of darkness, the masters of shadows. We know what evil lurks in the heart of Pandaria. We... are the Shado-Pan.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61366,'Have you been to the Jade Forest? To the Valley of the Four Winds? To the low lands of Kun-Lai?$b$bTell me, do they enjoy their peace? Are they still ignorant of the price it costs for that peace? How much Shado-Pan blood must be spilled to maintain their peace?$b$bI suppose it is best they do not. Peace is a thing best enjoyed by the ignorant so they may savor their lives without worry.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61367,'Silly lizards. Did you think you could defeat the mighty yaungol?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61368,'How many more of you are there?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61369,'I hear saurok taste like chicken. Let\'s find out.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61370,'Why have you come so far north? And why are you trespassing in our lands?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61371,'There are three of us, which is two more than I need to eat your head.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61372,'We were on our way to the Tiger Temple when you caught us. Lucky for you our healer was napping... apparently.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61373,'Oh I got something for you to \'taste\'! Come a little closer...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61374,'','I did not expect to see $rs in this land. You are certainly welcome here.$b$bPlease, do you have supplies for trade? We are low on an assortment of things.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(61375,'Intruder!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61376,'Fear me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61377,'I am your death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61378,'A challenge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61379,'This land is ours now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61380,'The sha will take you all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61381,'Die well!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61382,'Tremble before me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61383,'Think you can get the drop on me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61384,'I will crush you with my own two fists.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61385,'I was sleeping!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61386,'I will not die in bed like a coward.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61387,'I will smoke your ashes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61388,'I have sores older than you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61389,'Upstart pup! Think you can best me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61390,'You will die today.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61391,'We have a right to this land, same as you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61392,'If I die, it will be in battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61393,'Cleansing','Cleansing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61394,'Useless, all of you! Even the guards you give me in tribute can\'t keep these lesser beings from my palace.','',0,0,0,0,0,0,15,0,1,0,28353,0,26124),
(61395,'Redeem, nay, PROVE yourselves now. Deal with these intruders. The clan who brings me their heads will have my favor!','',0,0,0,0,0,0,14,0,1,0,28354,0,26124),
(61396,'$n has cleansed the Pool of Life!','$n has cleansed the Pool of Life!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61397,'Pandaren? What business do you have in Stormwind?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61398,'Emperor? You\'ll find KING Anduin inside Stormwind Keep.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61399,'<%s eyes Jojo\'s pillar.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61400,'Behave yourselves inside Stormwind, pandaren. You\'re in Alliance territory now.','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(61401,'Hey, look! Gnolls!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61402,'','Those aren\'t gnolls, silly. Use your eyes.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61403,'','Those are FURBOLGS.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61404,'','Teacher... look!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(61405,'Yes. Those are pandaren, Moni.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61406,'','Pandaren? Here, in Stormwind?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(61407,'Heh... pandaren. You must be here to join the Alliance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61408,'Good move. It worked out well for me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61409,'Let\'s... just keep moving.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61410,'','Welcome to Stormwind!',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(61411,'Pandaren? I mussht be seein\' thingssh...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61412,'Quiet, Naanae. Outsiders approach.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61413,'','Outsiders, yes - but their intentions are good.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61414,'','Look carefully, Lucas. The Light is strong with them. Particularly that one.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61415,'','Let\'s keep moving.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61416,'What\'s the Light?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(61417,'','We\'re here to join the Alliance. We seek audience with your Emperor.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(61418,'Never thought I\'d see one of your kind walk through here.','Never thought I\'d see one of your kind walk through here.',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(61419,'There are dozens of the pesky little brats. Can\'t grab the orbs with them tormenting us. Can\'t catch them to kill them.$B$BAt least I haven\'t lost my weapon, unlike some people...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61420,'I... uh... look, I\'m doing the best I can, okay?! The sprites keep knocking the orbs out of my hands, or stealing them back when I\'m not looking!$B$BI hate these things!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61421,'','Let\'s get going, $p. If we are going to be of any use out here, we are going to need allies.',0,0,0,0,0,0,0,0,1,16600,0,27389,26124),
(61422,'','Look at this!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(61423,'','Well, that\'s good news. Once we join the Alliance, we certainly won\'t run out of things to do.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61424,'Walk with me. All three of you.','',0,0,0,0,0,0,1,0,1,0,29574,0,26124),
(61425,'I understand you want to join the Alliance.','',0,0,0,0,0,0,0,0,1,0,29575,0,26124),
(61426,'We always have need of allies. I\'d be a fool to turn you away, especially at a time of war.','',0,0,0,0,0,0,1,0,1,0,29576,0,26124),
(61427,'But there are a number of things I need to make clear to you.','',0,0,0,0,0,0,0,0,1,0,29577,0,26124),
(61428,'','Yes. Go on.',0,0,0,0,0,0,273,0,1,0,0,27390,26124),
(61429,'First: the races of the Alliance look out for one another.','',0,0,0,0,0,0,0,0,1,0,29578,0,26124),
(61430,'You are expected to provide aid to Alliance members in need, whether they be human, gnome, draenei... or pandaren like yourselves.','',0,0,0,0,0,0,1,0,1,0,29579,0,26124),
(61431,'','The gap in the defenses is in this path. Mantid are sneaking past the scouts and getting around the barricade.$B$BWe need to cut them off before we find ourselves surrounded.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61432,'It is a simple guideline, but a meaningful one. Do you understand?','',0,0,0,0,0,0,0,0,1,0,29580,0,26124),
(61433,'','Certainly.',0,0,0,0,0,0,273,0,1,0,0,27391,26124),
(61434,'Good. Because that brings me to my second point.','',0,0,0,0,0,0,273,0,1,0,29581,0,26124),
(61435,'Not all pandaren have chosen the same path as you three.','',0,0,0,0,0,0,0,0,1,0,29582,0,26124),
(61436,'Some have sided with the Horde.','',0,0,0,0,0,0,0,0,1,0,29583,0,26124),
(61437,'They, along with the other barbarian clans of the Horde, are your new enemies.','',0,0,0,0,0,0,1,0,1,0,29584,0,26124),
(61438,'Those who you once considered friends, or even those you might have loved, are now your sworn adversaries.','',0,0,0,0,0,0,274,0,1,0,29585,0,26124),
(61439,'I am deeply sorry, but the battle lines have been drawn. I will not tolerate any fraternizing with the enemy, as you could expose our Alliance to danger.','',0,0,0,0,0,0,5,0,1,0,29586,0,26124),
(61440,'Do I make myself clear?','',0,0,0,0,0,0,0,0,1,0,29587,0,26124),
(61441,'','Yes... of course.',0,0,0,0,0,0,24,0,1,0,0,27392,26124),
(61442,'Very well. We are nearly finished, $p.','',0,0,0,0,0,0,0,0,1,0,29588,0,26124),
(61443,'','Deadly efficiency.',0,0,0,0,0,0,0,0,1,0,0,31378,26124),
(61444,'','It wasn\'t ready to face the Shado-Pan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61445,'','You would have had a better chance at the blockade, mantid.',0,0,0,0,0,0,0,0,1,0,0,31379,26124),
(61446,'','What desperation makes them think they stand a chance past our lines...',0,0,0,0,0,0,0,0,1,0,0,31380,26124),
(61447,'','You will learn to fear our blades, mantid.',0,0,0,0,0,0,0,0,1,0,0,31381,26124),
(61448,'','Take that message back to your queen, mantid.',0,0,0,0,0,0,0,0,1,0,0,31382,26124),
(61449,'','You should never have left the Dread Wastes, mantid.',0,0,0,0,0,0,0,0,1,0,0,31383,26124),
(61450,'About that sparring match you suggested...','About that sparring match you suggested...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61451,'I think I\'m ready to take that walk now.','I think I\'m ready to take that walk now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61452,'','For every ill or evil that rises in Pandaria, there is always a perfectly complementary cure. I find it to be a good analogy to all problems.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61453,'Let me know when you\'re ready.','',0,0,0,0,0,0,1,0,1,0,29589,0,26124),
(61454,'Now, pandaren... let me see what you\'ve got!','',0,0,0,0,0,0,5,0,1,0,29569,0,26124),
(61455,'Don\'t hold back now! Let\'s have it!','',0,0,0,0,0,0,5,0,1,0,29570,0,26124),
(61456,'What\'s the matter? You\'ll have to do better than that.','',0,0,0,0,0,0,6,0,1,0,29571,0,26124),
(61457,'','Careful, $p! You do not want to hurt your new king...',0,0,0,0,0,0,274,0,1,0,0,27393,26124),
(61458,'Come on, pandaren! HIT ME!','',0,0,0,0,0,0,5,0,1,0,29572,0,26124),
(61459,'Ha ha ha haaa! I haven\'t felt like this in YEARS! Don\'t worry, $p... I\'ve been in worse scraps than this. A fighting spirit like yours is welcome in the Alliance.  Now, let\'s get back to business.','',0,0,0,0,0,0,11,0,1,0,29573,0,26124),
(61460,'Who would ever guess how much knowledge was hidden behind these walls. Between the wealth of information here and the lore you have uncovered in your travels, I believe I can weave together a few tales of our forgotten past.$b$bWhich one would you like to hear?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61461,'Between a Saurok and a Hard Place.','Between a Saurok and a Hard Place.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61462,'Our story begins long ago in the days of the monstrous Emperor Tian.','',1,0,0,0,0,0,0,0,5,0,0,0,26124),
(61463,'The Emperor was in need of trusted messengers and deliverymen.','',1,0,0,0,0,0,0,0,5,0,0,0,26124),
(61464,'So he took a strange, diminutive cave creature he found and warped it with the powers of the Vale.','',1,0,0,0,0,0,0,0,5,0,0,0,26124),
(61465,'What he created, was the \"grummle.\"','',1,0,0,0,0,0,0,0,5,0,0,0,26124),
(61466,'|TInterface\\Icons\\inv_misc_blackironbomb.blp:20|t The |cFFdd7400Sik\'thik Amberwing|r moves into position to |cFFFF0000|Hspell:120559|h[Bombard]|h|r the platform!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61467,'I\'d like to take a kite somewhere.','I\'d like to take a kite somewhere.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61468,'I need a kite to get up to the wall!','I need a kite to get up to the wall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61469,'I heard from the others... you need a kite to the wall?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61470,'Let us talk about the nature of power. In my hands I hold a sword. I ask you: Who wields the power?','',1,0,0,0,0,0,0,0,5,0,30130,0,26124),
(61471,'I do, for I wield the sword!','',1,0,0,0,0,0,0,0,5,0,30131,0,26124),
(61472,'Details, details.','',0,0,0,0,0,0,274,0,1,0,32000,0,26124),
(61473,'Look, \"Chen Stormstout,\" we all can\'t be heroes, running from our responsibilities, tromping around the Dread Wastes, saving the world. Some of us are \"Artists.\"','',0,0,0,0,0,0,1,0,1,0,32001,0,26124),
(61474,'Yes, yes. That happens.','',0,0,0,0,0,0,273,0,1,0,32002,0,26124),
(61475,'I see - and where is Uncle Gao?','',0,0,0,0,0,0,6,0,1,0,29770,0,26124),
(61476,'There is no time for cookies! Well, one cookie. Just one.','',0,0,0,0,0,0,5,0,1,0,29771,0,26124),
(61477,'Wait - these are ghost cookies. These aren\'t filling at all!','',0,0,0,0,0,0,53,0,1,0,29772,0,26124),
(61478,'Uncle Gao, this brewery was left in your care! What have you done?','',0,0,0,0,0,0,6,0,1,0,31998,0,26124),
(61479,'At what cost? The Brewery is trashed! Infested!','',0,0,0,0,0,0,274,0,1,0,29773,0,26124),
(61480,'','Oh, hello Zan, it is good of you to visit ol\' Auntie Stormstout.',0,0,0,0,0,0,17,0,1,0,0,28528,26124),
(61481,'','Oh Zan! You remind me so much of your father.',0,0,0,0,0,0,25,0,1,0,0,28529,26124),
(61482,'','It is certainly a nice day outside!',0,0,0,0,0,0,1,0,1,0,0,28530,26124),
(61483,'','Have you seen the size of Esme\'s turnips?',0,0,0,0,0,0,6,0,1,0,0,28531,26124),
(61484,'','Abandoned? Oh heavens no! Uncle Gao is in charge while the others are beyond the wall. Isn\'t that exciting?',0,0,0,0,0,0,274,0,1,0,0,28532,26124),
(61485,'','I have some cookies for you!',0,0,0,0,0,0,4,0,1,0,0,28533,26124),
(61486,'The Endless Army will crush the Emperor\'s foes.','',0,0,0,0,0,0,0,0,1,0,29017,0,26124),
(61487,'The Emperor\'s Rage echoes through the hills.','',0,0,0,0,0,0,0,0,1,0,29018,0,26124),
(61488,'The Emperor\'s Strength grips this land with fists of iron.','',0,0,0,0,0,0,0,0,1,0,29019,0,26124),
(61489,'The Emperor\'s Courage burns everlasting.','',0,0,0,0,0,0,0,0,1,0,29020,0,26124),
(61490,'The Emperor\'s Breath abates.','',0,0,0,0,0,0,0,0,1,0,29021,0,26124),
(61491,'The Emperor\'s Breath is regained.','',0,0,0,0,0,0,0,0,1,0,29022,0,26124),
(61492,'The Emperor\'s Will dominates all it beholds.','',0,0,0,0,0,0,0,0,1,0,29023,0,26124),
(61493,'Every Shado-Pan makes three eternal oaths:\n\nTo defend this land, to protect its people, and to train their pupil.\n\nWhen a Shado-Pan dies, they must be released from these bonds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61494,'Ah, it was a difficult battle. So sad to have lost friends.\n\nThough, I am glad I had them build the battlefield refreshment device.\n\nWithout it, and without the power of my stout brew, who knows how many more would have been lost...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61495,'A grummle can carry five times their own weight. They never sweat. They have an outstanding sense of smell.','',1,0,0,0,0,0,0,0,5,0,0,0,26124),
(61496,'And their skulls are harder than granite. Curiously, they all appear to be related.','',1,0,0,0,0,0,0,0,5,0,0,0,26124),
(61497,'Ancient Pandaren heroes freed the grummles from slavery.','',1,0,0,0,0,0,0,0,5,0,0,0,26124),
(61498,'The prisoners are escaping!','',0,0,0,0,0,0,0,0,1,0,30281,0,26124),
(61499,'Niuzao\'s forces attack from the rear!','',0,0,0,0,0,0,0,0,1,0,30279,0,26124),
(61500,'','Crush these invaders, and hurl them from the wall!',0,0,0,0,0,0,0,0,1,0,0,31307,26124),
(61501,'','We could use a $c. Glad to see my husband sent you along.\n\nI\'m a scout, not much for face-to-face combat. And Lao-chen here... well, normally he\'s a fighter, but he\'s still exhausted from the last battle.\n\nAnd, he\'s too busy cooking up some scheme.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61502,'Alright, I\'m ready to get back to the front.','Alright, I\'m ready to get back to the front.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61503,'Two parts oil to one part brew... no, it will need more oil...','',0,0,0,0,0,0,0,0,1,0,29779,0,26124),
(61504,'','You ready?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61505,'The temple will fall! You cannot stop my forces!','',0,0,0,0,0,0,0,0,1,0,30277,0,26124),
(61506,'My army will crush you!','',0,0,0,0,0,0,0,0,1,0,30278,0,26124),
(61507,'Stop them! Mantid attack!','',0,0,0,0,0,0,0,0,1,0,30280,0,26124),
(61508,'Flank! To the flank!','',0,0,0,0,0,0,0,0,1,0,30282,0,26124),
(61509,'Put down your weapons or die!','',0,0,0,0,0,0,0,0,1,0,30283,0,26124),
(61510,'I have failed you, empress...','',0,0,0,0,0,0,0,0,1,0,30284,0,26124),
(61511,'The empress demands it!','',0,0,0,0,0,0,0,0,1,0,30285,0,26124),
(61512,'The forces of Niuzao are weak!','',0,0,0,0,0,0,0,0,1,0,30286,0,26124),
(61513,'','Class is now in session.',0,0,0,0,0,0,0,0,1,0,0,29460,26124),
(61514,'','Your soul cannot withstand my power!',0,0,0,0,0,0,0,0,1,0,0,29457,26124),
(61515,'','I can never die!',0,0,0,0,0,0,0,0,1,0,0,29458,26124),
(61516,'','You\'ve learned nothing.',0,0,0,0,0,0,0,0,1,0,0,29459,26124),
(61517,'','THIS CANNOT BE!',0,0,0,0,0,0,0,0,1,0,0,29456,26124),
(61518,'','Perhaps you should have studied more.',0,0,0,0,0,0,0,0,1,0,0,29461,26124),
(61519,'','I\'ll see you after class.',0,0,0,0,0,0,0,0,1,0,0,29462,26124),
(61520,'The terrace was not meant for your kind!','',0,0,0,0,0,0,0,0,1,0,28369,0,26124),
(61521,'My strength grows!','',0,0,0,0,0,0,0,0,1,0,28371,0,26124),
(61522,'I will not be controlled!','',0,0,0,0,0,0,0,0,1,0,28372,0,26124),
(61523,'None can match my strength!','',0,0,0,0,0,0,0,0,1,0,28373,0,26124),
(61524,'We... are... endless...','',0,0,0,0,0,0,0,0,1,0,28370,0,26124),
(61525,'Weakling!','',0,0,0,0,0,0,0,0,1,0,28374,0,26124),
(61526,'Begone!','',0,0,0,0,0,0,0,0,1,0,28375,0,26124),
(61527,'A storm approaches.','',0,0,0,0,0,0,0,0,1,0,28391,0,26124),
(61528,'Your fear will consume you!','',0,0,0,0,0,0,0,0,1,0,28393,0,26124),
(61529,'I command the elements to destroy you!','',0,0,0,0,0,0,0,0,1,0,28394,0,26124),
(61530,'You cannot escape the storm!','',0,0,0,0,0,0,0,0,1,0,28395,0,26124),
(61531,'The terrace... must not... fall...','',0,0,0,0,0,0,0,0,1,0,28392,0,26124),
(61532,'How dare you trespass here!','',0,0,0,0,0,0,0,0,1,0,28396,0,26124),
(61533,'Shocking.','',0,0,0,0,0,0,0,0,1,0,28397,0,26124),
(61534,'The endless waters will cleanse you from this place!','',0,0,0,0,0,0,0,0,1,0,28380,0,26124),
(61535,'The waters will consume you!','',0,0,0,0,0,0,0,0,1,0,28382,0,26124),
(61536,'The tide cannot be stopped!','',0,0,0,0,0,0,0,0,1,0,28383,0,26124),
(61537,'Drown in fear!','',0,0,0,0,0,0,0,0,1,0,28487,0,26124),
(61538,'The Sha... must be... stopped...','',0,0,0,0,0,0,0,0,1,0,28381,0,26124),
(61539,'You are unfit to stand before me.','',0,0,0,0,0,0,0,0,1,0,28385,0,26124),
(61540,'Flee, child.','',0,0,0,0,0,0,0,0,1,0,28386,0,26124),
(61541,'%s spins around in a |cFFFF0000|Hspell:119888|h[Death Blossom]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61542,'Watch that last step.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61543,'Be careful!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61544,'Don\'t jump! Life is worth living!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61545,'Watch out.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61546,'Don\'t drop off!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61547,'Please be careful.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61548,'Don\'t jump! I am sure there are people who love you. Or at least tolerate you...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61549,'There goes another one...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61550,'I hope the rope holds.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61551,'Hmm. Some say the rope is a crutch...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61552,'I hope you don\'t get rope burn.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61553,'Good luck!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61554,'You are a braver $r than I.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61555,'%s is chasing you! Run away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61556,'','Nothing\'s getting over this wall.$B$BThis is MY wall.',274,0,0,1,0,0,0,0,1,0,0,0,26124),
(61557,'Safe journeys!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61558,'','The Shado-Pan have held this wall for centuries, but I won\'t turn down help from outsiders for the sake of pride.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(61559,'We are the greatest!','',0,0,0,0,0,0,25,0,1,0,27934,0,26124),
(61560,'These other clans are nothing!','',0,0,0,0,0,0,25,0,1,0,27935,0,26124),
(61561,'These other clans aren\'t worthy of your time, great king!','',0,0,0,0,0,0,15,0,1,0,27949,0,26124),
(61562,'Our clan holds true to the ways set forth by the ancients. We deserve the king\'s favor above all others!','',0,0,0,0,0,0,153,0,1,0,27950,0,26124),
(61563,'The Mogu cannot reclaim our rightful glory without our clan\'s strength!','',0,0,0,0,0,0,15,0,1,0,28248,0,26124),
(61564,'These pathetic clans are beneath you, my king. They sully the great legacy of our people!','',0,0,0,0,0,0,15,0,1,0,28249,0,26124),
(61565,'','Your forces are weak!',0,0,0,0,0,0,0,0,1,0,0,27607,26124),
(61566,'Your presence disturbs a lingering spirit!','Your presence disturbs a lingering spirit!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61567,'The Yaungol warlord shows his face! Come, let\'s finish this!','',0,0,0,0,0,0,0,0,7,0,29776,0,26124),
(61568,'All those barrels... some of my finest brew. At least it went out in a blaze of glory!','',0,0,0,0,0,0,1,0,1,0,29777,0,26124),
(61570,'Taran Zhu won\'t send us reinforcements. We\'ve got a massive army we\'re dealing with here. As tough as we Shado-Pan may be, we\'re going to need to take a different approach.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61571,'Fools! You cannot defeat me! You cannot defeat the yaungol!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61572,'','Wait - where is Lin?',0,0,0,0,0,0,6,0,1,0,0,31303,26124),
(61573,'... but first, I\'m going to deal with these cursed yaungol. Have at you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61574,'','Where is my husband!?',0,0,0,0,0,0,5,0,1,0,0,31304,26124),
(61575,'Gong Da, deal with these flies while I take this - Lin, was it? - back to Osul Mesa.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61576,'Yes, my lord!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61577,'They sent someone after me?!$B$BThank the winds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61578,'Hey, easy with that thing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61579,'Careful! Don\'t burn the chops...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61580,'Woah, point that somewhere else!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61581,'Hey! Live, FLAMMABLE pandaren here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61582,'Run while you still can!','Run while you still can!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61583,'They are too strong!','They are too strong!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61584,'Thanks for the save, but we\'re still stuck in the middle of the entire mantid army.','',0,0,0,0,0,0,2,0,1,0,31505,0,26124),
(61585,'Come with me. We need to talk.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(61586,'You\'ve made a wise decision to join my Horde.','',0,0,0,0,0,0,273,0,1,0,30746,0,26124),
(61587,'There are some that would call us barbarians... the \"mongrel races\" of Azeroth.','',0,0,0,0,0,0,396,0,1,0,30747,0,26124),
(61588,'They are ignorant, and blind to reality. Look around you, pandaren.','',0,0,0,0,0,0,274,0,1,0,30748,0,26124),
(61589,'You will find no better partner in battle than an orc.','',0,0,0,0,0,0,397,0,1,0,30749,0,26124),
(61590,'The tauren have made themselves useful. Look - this one is a shaman.','',0,0,0,0,0,0,6,0,1,0,30750,0,26124),
(61591,'Look out there. Too many for us to take head on.','',0,0,0,0,0,0,397,0,1,0,31506,0,26124),
(61592,'Even a blood elf can hold a sword.','',0,0,0,0,0,0,396,0,1,0,30751,0,26124),
(61593,'Do you see it? Everyone in my Horde earns their keep. You and your friends will be no exception.','',0,0,0,0,0,0,396,0,1,0,30752,0,26124),
(61594,'Do you understand this, pandaren?','',0,0,0,0,0,0,6,0,1,0,30753,0,26124),
(61595,'Yes, warchief.','',0,0,0,0,0,0,2,0,1,0,27290,0,26124),
(61596,'Hm. Good.','',0,0,0,0,0,0,0,0,1,0,30754,0,26124),
(61597,'Moving on. I know that you are not the only pandaren to escape from that island.','',0,0,0,0,0,0,396,0,1,0,30755,0,26124),
(61598,'Some of your kind chose to join the Alliance.','',0,0,0,0,0,0,14,0,1,0,30756,0,26124),
(61599,'They are now your enemies.','',0,0,0,0,0,0,397,0,1,0,30757,0,26124),
(61600,'You may have had friends and kin who chose to cast their lot with the enemies of the Horde. They are no longer your friends... no longer your family.','',0,0,0,0,0,0,396,0,1,0,30758,0,26124),
(61601,'The minute they put on that Alliance tabard, they died. I will NOT tolerate any lingering ties across enemy lines. Traitors to the Horde will die a traitor\'s death!','',0,0,0,0,0,0,274,0,1,0,30759,0,26124),
(61602,'Do I make myself clear?','',0,0,0,0,0,0,5,0,1,0,30760,0,26124),
(61603,'I... I believe so. Yes.','',0,0,0,0,0,0,273,0,1,0,27291,0,26124),
(61604,'Good.','',0,0,0,0,0,0,0,0,1,0,30761,0,26124),
(61605,'Meet me in the Valley of Honor. I have a gift for you.','',0,0,0,0,0,0,396,0,1,0,30762,0,26124),
(61606,'Welcome to the Ring of Valor, pandaren. Make yourself comfortable while I finish preparing.','',0,0,0,0,0,0,0,0,1,0,30735,0,26124),
(61607,'Hah! It looks like we\'re ready. Now, newcomers... prepare to fight!','',0,0,0,0,0,0,0,0,1,0,30736,0,26124),
(61608,'What is that thing?','',0,0,0,0,0,0,0,0,1,0,27292,0,26124),
(61609,'This is my gift to you: a gift, and a trial.','',0,0,0,0,0,0,0,0,1,0,30737,0,26124),
(61610,'I\'ve heard stories about the legendary pandaren and their exotic fighting styles. Now I want to see them.','',0,0,0,0,0,0,0,0,1,0,30738,0,26124),
(61611,'This is a rare opportunity, pandaren. Prove your might to the Warchief of the Horde!','',0,0,0,0,0,0,0,0,1,0,30739,0,26124),
(61612,'Lok\'tar ogar! Victory, or death!','',0,0,0,0,0,0,0,0,1,0,30740,0,26124),
(61613,'Well fought. I don\'t think I could have survived that battle without you at my back.','',0,0,0,0,0,0,0,0,1,0,27293,0,26124),
(61614,'Throm-ka, pandaren. Welcome to the Horde.','',0,0,0,0,0,0,0,0,1,0,30741,0,26124),
(61615,'You are covered in yaungol tar, and can\'t see anything!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61617,'Foolish trespasser!','',0,0,0,0,0,0,0,0,1,16655,0,0,26124),
(61618,'We will give you a swift death!','',0,0,0,0,0,0,0,0,1,16655,0,0,26124),
(61619,'Fresh meat!','',0,0,0,0,0,0,0,0,1,16655,0,0,26124),
(61620,'Flesh for the Scale-Lord!','',0,0,0,0,0,0,0,0,1,16655,0,0,26124),
(61621,'Gut it!','',0,0,0,0,0,0,0,0,1,16655,0,0,26124),
(61622,'Blood for my blade!','',0,0,0,0,0,0,0,0,1,16655,0,0,26124),
(61623,'New tasty creature!','',0,0,0,0,0,0,0,0,1,16655,0,0,26124),
(61624,'Rip it apart!','',0,0,0,0,0,0,0,0,1,16655,0,0,26124),
(61625,'','Good-bye, little one. I will see you soon enough.',0,0,0,0,0,0,0,0,1,0,0,28586,26124),
(61626,'Never thought I\'d see one of your kind walk through here.','Never thought I\'d see one of your kind walk through here.',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(61627,'Come on through. The Warchief\'s expecting you.','Come on through. The Warchief\'s expecting you.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61628,'Look! It\'s Ji Firepaw and $p!','',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(61629,'They\'re the ones who helped Korga Strongmane escape from the Alliance!','',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(61630,'Look at this!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(61631,'Well, that\'s good news. Once we join the Horde, we certainly won\'t run out of things to do.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61632,'Pandaren! Approach.','',0,0,0,0,0,0,1,0,1,0,30742,0,26124),
(61633,'Emperor Hellscream, I am Ji...','',0,0,0,0,0,0,1,0,1,0,27289,0,26124),
(61634,'That\'s WARCHIEF Hellscream!','',0,0,0,0,0,0,1,0,1,0,30743,0,26124),
(61635,'Now, rise.','',0,0,0,0,0,0,1,0,1,0,30744,0,26124),
(61636,'We should talk, pandaren.','',0,0,0,0,0,0,1,0,1,0,30745,0,26124),
(61637,'','Welcome to Orgrimmar!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61638,'Have you come to serve the Horde?','Have you come to serve the Horde?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61639,'Best move quickly through this area, stranger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61640,'The warchief doesn\'t take kindly to non-orcs loitering in this part of Orgrimmar.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61641,'He... he segregates the city?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61642,'Move along, then. Hellscream\'s eyes are upon you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61643,'Today they still act as traders, messengers, guides, and pack bearers for expeditions high up in Kun-Lai summit.','',1,0,0,0,0,0,0,0,5,0,0,0,26124),
(61644,'Whoah.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61645,'','Whoah.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61646,'Cool!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61647,'They are a very superstitious people, who often take on the names of their favorite charms, or \"Luckydos.\"','',1,0,0,0,0,0,0,0,5,0,0,0,26124),
(61648,'','Cool!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61649,'The grummle suspicious of any luck they cannot smell, so it behooves one to meet new grummles with a pocketful of dung.','',1,0,0,0,0,0,0,0,5,0,0,0,26124),
(61650,'A very strange race, indeed.','',1,0,0,0,0,0,0,0,5,0,0,0,26124),
(61651,'Hey Zazzle! Look at these goofballs comin\' through.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61652,'','Pretty funny-lookin\', if you ask me.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61653,'Yeah... pretty funny-lookin\' alright.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61654,'Zug zug.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61655,'Me like fish.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61656,'That\'s great! I like fish too!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(61657,'','Lin is upset - Zhiya was his good friend and we lost him in the battle. \n\nI don\'t want Lin to do something thoughtless. I don\'t know what I\'d do if I lost him...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61658,'Zhiyao dead. Shiya dead. Liu dead.\n\nSuna councils me to calm, but honor demands otherwise.\n\nTaran Zhu sits safe in the monastery while we defend the pass alone? Why shut us out? Why not send reinforcements?\n\nThese questions trouble me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61659,'Why should I bloody my blades when I have you to do the dirty work for me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61660,'Do not ask needless questions, wallwalker. Focus on the task at hand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61661,'I thought he was with you?','',0,0,0,0,0,0,6,0,1,0,29778,0,26124),
(61662,'I\'m fine... but it looks like our friend $p here is completely covered. Let me go get help...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61663,'Augh! Suna...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61664,'THREE!','THREE!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(61665,'TWO!','TWO!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(61666,'ONE!','ONE!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(61667,'The Challenge begins!','The Challenge begins!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(61668,'The Challenge has been completed!','The Challenge has been completed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(61669,'I think I\'m ready to take that walk now.','I think I\'m ready to take that walk now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61670,'<Tai Ho is completely silent.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61671,'A provisioner\'s work is never done. The Shado-Pan marches on its stomach.$b$bAnd, to some extent, its liver.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61672,'You take them out. I\'ll hide in the shadows and search their bodies.','',0,0,0,0,0,0,0,0,1,16739,0,0,26124),
(61673,'','Then he\'s out there alone! We\'ve got to find him!',0,0,0,0,0,0,0,0,1,0,0,31305,26124),
(61674,'At first, my deference and respect for Taran Zhu prohibited me from questioning his decision to close the monastery to outsiders.\n\nThen, when the yaungol first attacked, my focus on the battle at hand prevented me from leaving the front lines to question his inability to send reinforcements.\n\nNow, three Shado-Pan lie dead, one is captured, and my patience is beyond worn thin - it is gone. I plan to go to the monastery and demand an audience with Taran Zhu.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61675,'Here we are. Climb aboard, friend.','',0,0,0,0,0,0,0,0,1,0,30598,0,26124),
(61676,'By the order of lord Taran Zhu, none shall pass.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61677,'I am here with Ban Bearheart, and we demand an audience with Taran Zhu!','I am here with Ban Bearheart, and we demand an audience with Taran Zhu!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61678,'Demand?! You DEMAND?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61682,'I will see you inside the Monastery!','',0,0,0,0,0,0,0,0,1,0,30608,0,26124),
(61684,'From beneath the dark roots of the nearby tree, an ancient terror awakens...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61687,'I\'m sorry, outsider. Unless you are here on official business, I\'m afraid I can\'t be of any assistance to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61688,'An ill wind blows here in Kun-Lai. I fear a presence unseen for many years may be returning, and these yaungol are just a symptom of it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61689,'Something feels... different up here. I don\'t know what, but I expect we shall find out soon enough.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61690,'I can\'t believe we had to kill one of my order... where has the world gone?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61691,'','Well, you really sent them flying. I could hear their... bleating from here. \n\nBleating? Is that what you call the sound of a yaungol flying off a wall?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61692,'','Wow. I could hear the explosions from up on the wall.\n\nI guess not ALL of Lao-Chen\'s ideas are terrible.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61693,'','I will give anything, to my last dying breath, to save Lin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61694,'It won\'t bring our brothers and sisters back, but knowing that we are better than the yaungol helps us sleep better at night.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61695,'Look, $n. The beast stirs from its lair!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61696,'Another attack?!\n\nThese yaungol will not relent until we push them back into Townlong. Or, even better, into the sea.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61697,'You are standing in a lethal cloud!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(61698,'Finally, peace and quiet. Perhaps enough to allow me to contemplate the passing of our brothers and sisters.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61699,'I have to tell you, I love it when a plan comes together.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61700,'After all this... our brothers and sisters passing, Lin captured by yaungol, my beer gone, I think it\'s time to move along.\n\nPerhaps I\'ll take the fight to the mantid...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61702,'As a stranger to these lands, you may not be familiar with the Shado-Pan.','',0,0,0,0,0,0,0,0,1,0,30599,0,26124),
(61703,'Our charge is an ancient one, dating back to the time of Shaohao, our founder and the last emperor of Pandaria.','',0,0,0,0,0,0,0,0,1,0,30600,0,26124),
(61704,'Dark energies embrace this land. Anger, Hatred, Fear, Doubt...','',0,0,0,0,0,0,0,0,1,0,30601,0,26124),
(61705,'These negative emotions can manifest in physical form. We call this dark energy \"Sha.\"','',0,0,0,0,0,0,0,0,1,0,30602,0,26124),
(61706,'It is our sacred duty to monitor and imprison the Sha. To defeat it wherever it darkens the hearts of our people.','',0,0,0,0,0,0,0,0,1,0,30603,0,26124),
(61707,'In all my years, I have never seen the Sha so active as when your soldiers landed on our shores.','',0,0,0,0,0,0,0,0,1,0,30604,0,26124),
(61708,'Pandaria does not have a standing army. We, the Shado-Pan, are its first - and only - line of defense.','',0,0,0,0,0,0,0,0,1,0,30605,0,26124),
(61709,'Taran Zhu leads the Shado-Pan, as his father did before him. But he has elected to close our Monastery gates - why?','',0,0,0,0,0,0,0,0,1,0,30606,0,26124),
(61710,'We must find out. Without the Shado-Pan, Pandaria will surely be engulfed in darkness...','',0,0,0,0,0,0,0,0,1,0,30607,0,26124),
(61711,'Taran Zhu leads the Shado-Pan, as his father did before him. But he has elected to close our Monastery gates - why?','',0,0,0,0,0,0,0,0,1,0,30606,0,26124),
(61712,'We must find out. Without the Shado-Pan, Pandaria will surely be engulfed in darkness...','',0,0,0,0,0,0,0,0,1,0,30607,0,26124),
(61713,'Lao-Chin! We have won the day. Why are you weeping?','',0,0,0,0,0,0,6,0,1,0,30609,0,26124),
(61714,'He must have pursued the fleeing yaungol while we intercepted their leader.','',0,0,0,0,0,0,0,0,1,0,30610,0,26124),
(61715,'Patience, Suna! If we march into Townlong alone, we compound our problems. We must focus on the Monastery and get reinforcements.','',0,0,0,0,0,0,274,0,1,0,30611,0,26124),
(61716,'By closing the monastery - for whatever reason - Taran Zhu has jeopardized that eternal charge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61717,'We must not sit idly by in our mountain-top fortress as Pandaria falls apart. And that is why you and I must demand an audience with Taran Zhu.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61718,'Just point me in the right direction. I\'ll carry the load.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61719,'Let\'s get going then!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61720,'You lead the way. I\'ll carry the food.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61721,'There should be plenty of food stored around this temple.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61722,'Who are YOU to make demands of the SHADO-PAN?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61723,'Finish him! Boot him off the wall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61724,'World state variables have been reset.','World state variables have been reset.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61725,'Who dares disturb this crypt?','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(61726,'%s is about to Overload!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61727,'<This is more than just a chunk of amber - there\'s a mantid inside!>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61728,'You have been affected by |cFFFF0404|Hspell:116784|h[Wildfire Spark]|h|r !','You have been affected by |cFFFF4809|Hspell:116784|h[Wildfire Spark]|h|r !',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61729,'The Klaxxi have betrayed her majesty. Your corpses will be strung from the palace walls for this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61730,'It is... the empress who has betrayed... our people...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61731,'How DARE you question her will!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61732,'What\'s this?! Now they come over the wall to oppose us? The fools!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61733,'$C... approach me...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61734,'Destroy the Piles of Corpses to stop the Zombified Corpses!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(61735,'Play with fire, and you might just get burned.','Play with fire, and you might just get burned.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61736,'Would you accompany me?','Would you accompany me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61737,'Join me.','Join me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61738,'To become a Shado-Pan, one must dedicate $Ghimself:herself; in body, mind, and soul.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61739,'The Shado-Pan are few in number, but we make up for it in strength.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61740,'From the west, the mantid stir.$B$BFrom the northwest, the mogu practice their dark arts.$B$BFrom the north, the yaungol press us.$B$BThere is too much to do, and too little time.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61741,'Every Shado-Pan knows one another by name. We have trained together, fought together, and survived together.$B$BWhen you can say the same, then perhaps you are ready to join our brotherhood.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61742,'I\'m ready to light this place up!','I\'m ready to light this place up!',0,0,0,0,0,0,0,0,1,0,30715,30715,26124),
(61743,'HURGHHH!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61744,'Ah! Help! Sprites!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61745,'Get them off me! Get them off me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61746,'Sooo spikey! Ouch! Ouch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61747,'Help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61748,'Ah! Needles on my face!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61749,'Oh the pain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61750,'Get off me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61751,'I just wanted my yaks back...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61752,'','Wait for it...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61753,'','Now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61754,'Where are the northern sentries? I didn\'t spot a single one of your men before reaching the camp. You grow lax, Gao-Ran.','',0,0,0,0,0,0,1,0,1,0,28453,0,26124),
(61755,'With all due respect, Lord, we have not grown lax. We are stretched thin. We are beset on all fronts, my men are worked to the bone, and I have not a single warrior to spare.','',0,0,0,0,0,0,1,0,1,0,30731,0,26124),
(61756,'No, we will not be pulling back. It\'s many years yet before the mantid birth their next swarm. I will not see the Townlong Steppes given to them freely.','',0,0,0,0,0,0,1,0,1,0,28454,0,26124),
(61757,'Lord Zhu, the mantid have not been seen in these numbers since the swarm more than 90 years ago. My men are going days without sleep just to hold this line.','',0,0,0,0,0,0,1,0,1,0,30732,0,26124),
(61758,'Perhaps we should pull back to the wall?  If the full force of the mantid come, we can confidently hold them there.','',0,0,0,0,0,0,1,0,1,0,30733,0,26124),
(61759,'I had come to seek strong pandaren to hunt the Sha of Hatred, but we will step in here and help you fortify the barricade first.','',0,0,0,0,0,0,1,0,1,0,28455,0,26124),
(61760,'Taoshi, go north and make sure there are no mantid on our flank. I will see to the defenses.','',0,0,0,0,0,0,1,0,1,0,28456,0,26124),
(61761,'The men will be glad to have you with us, Lord Zhu.','',0,0,0,0,0,0,1,0,1,0,30734,0,26124),
(61762,'I\'ve gone too long without visiting the front, Gao-Ran. Your long efforts are appreciated.','',0,0,0,0,0,0,1,0,1,0,28457,0,26124),
(61763,'It is time for us to continue westward $p, after the Sha of Hatred.','',0,0,0,0,0,0,1,0,1,0,28451,0,26124),
(61764,'Come. Let us go.','',0,0,0,0,0,0,1,0,1,0,28450,0,26124),
(61765,'We will need more veteran Shado-Pan among us before we can confront it.  We\'ll stop at the encampments along the way.','',0,0,0,0,0,0,1,0,1,0,28452,0,26124),
(61766,'<Sticky orange fluid oozes from Kil\'ruk\'s mandibles.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61767,'My head swims... I am... not myself yet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61768,'','At once, Lord Zhu.',0,0,0,0,0,0,2,0,1,0,0,31371,26124),
(61769,'','May the road rise to meet you, traveler.$b$bWhat brings you here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61770,'We\'ve done all we can here. Farewell Gao-Ran. I will send more men as soon as I am able.','',0,0,0,0,0,0,1,0,1,0,28449,0,26124),
(61771,'Appreciated, Lord Zhu.  Good luck in your hunt.','',0,0,0,0,0,0,1,0,1,0,30730,0,26124),
(61772,'Yes. The Sha of Hatred has been through here.','',0,0,0,0,0,0,1,0,1,0,28434,0,26124),
(61773,'','Do you feel that...?',0,0,0,0,0,0,1,0,1,0,0,31353,26124),
(61774,'','Their camp is in shambles. What happened?',0,0,0,0,0,0,1,0,1,0,0,31354,26124),
(61775,'You, initiate. Where are the troops?','',0,0,0,0,0,0,1,0,1,0,28435,0,26124),
(61776,'Lord Zhu! They are down at the bridge, holding off a mantid attack force, sir.','',0,0,0,0,0,0,66,0,1,0,28164,0,26124),
(61777,'$p, Taoshi, help these men get their camp in order.  I\'ll assess the state of the bridge.','',0,0,0,0,0,0,1,0,1,0,28436,0,26124),
(61778,'','I\'ll handle the rest of this. You take those arrows and get down to the action at the bridge.',0,0,0,0,0,0,1,0,1,16728,0,31352,26124),
(61779,'What is a \"luckydo\"?','What is a \"luckydo\"?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61780,'A Luckydo? Why it is a person, place or thing of good luck and fortune.$b$bIt is a most high compliment from grummles to be called a luckydo.$b$bUsually a luckydo has special smell to it. Grummle noses are keen for finding luck by its scent.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61781,'I want to ask something else.','I want to ask something else.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61782,'What is a grummle?','What is a grummle?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61783,'Why we are the grummles! The mountain ferries. The packers of the trails. The guides through the mountains. and the deliverers of supplies.$b$bWe are the people who keep the defenders of the wall fed, and we are the people who travel the Burlap Trail since the time of the mogu dynasties.$b$bWe also have the most best noses for smelling luck!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61784,'I am returned to serve the council. But you are no Klaxxi\'va...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61785,'Take me to the Wreck of the Sky Shark!','Take me to the Wreck of the Sky Shark!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61786,'%s barks loudly, calling nearby allies to its aid!','%s barks loudly, calling nearby allies to its aid!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(61787,'','I will say, the Forsaken have... strange taste when it comes to brew. I get the feeling they\'re not exactly preparing it for friends, though.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61788,'Take me to the Wreck of the Sky Shark!','Take me to the Wreck of the Sky Shark!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61789,'','Yes?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61790,'If you are so curious about the mantid, I will tell you more on the way to Klaxxi\'vess.$B$BOtherwise, leave me to my work.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61791,'','These Forsaken are quick students. I guess you can teach an old... and, well, formerly living dog new tricks.',0,0,0,0,0,0,0,44,1,0,0,0,26124),
(61792,'What is she saying?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61793,'Monk','Monk',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61794,'In War Quarter inner ring. She drunk lots.','In War Quarter inner ring. She drunk lots.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(61795,'She scare me, she mean and say we smell bad. She in War Quarter, inner ring.','She scare me, she mean and say we smell bad. She in War Quarter, inner ring.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(61796,'The monk trainer is in the inner ring of the War Quarter. She\'s training some of our Deathguards in her people\'s fighting style.','The monk trainer is in the inner ring of the War Quarter. She\'s training some of our Deathguards in her people\'s fighting style.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(61797,'You\'ll find her in the inner ring of the War Quarter.','You\'ll find her in the inner ring of the War Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(61798,'Many thousands of years ago, the mogu held all the power. They ruled this land with fists of iron. But as their empire grew, they needed a way to police and control it.','',1,0,0,0,0,0,0,0,5,0,30132,0,26124),
(61799,'They used the powers of the Vale, and their own flesh-warping magics, to twist and shape a race of ferocious lizards into a living weapon. They created an army. An army of Saurok. Bloodthirsty savages created to enforce the will of the emperor.','',1,0,0,0,0,0,0,0,5,0,30133,0,26124),
(61800,'Ah, but there is a problem with creating a living weapon. Do you see?','',1,0,0,0,0,0,0,0,5,0,30134,0,26124),
(61801,'Who, now, wields the power?','',1,0,0,0,0,0,0,0,5,0,30135,0,26124),
(61802,'The heartless saurok, even with their tiny lizard brains, soon realized the truth of their position. They killed the enemies of the mogu.','',1,0,0,0,0,0,0,0,5,0,30136,0,26124),
(61803,'Then they killed the subjects of the mogu.','',1,0,0,0,0,0,0,0,5,0,30137,0,26124),
(61804,'Soon, they started killing the mogu themselves.','',1,0,0,0,0,0,0,0,5,0,30138,0,26124),
(61805,'The mogu emperor then ordered all of the saurok to be purged. He tried to wipe out their entire race, to no avail. They still plague Pandaria to this day.','',1,0,0,0,0,0,0,0,5,0,30139,0,26124),
(61806,'So you see - power is easily taken, but should not be lightly given.','',1,0,0,0,0,0,0,0,5,0,30140,0,26124),
(61807,'Monk','Monk',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61808,'Oh, Aysa? I think I saw her training other pandaren near the lake, northwest of Stormwind Keep.','Oh, Aysa? I think I saw her training other pandaren near the lake, northwest of Stormwind Keep.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61809,'','This city is so unlike anything from home...\n\nAh, friend, how may I help you?',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(61810,'','There are so many strange and interesting things in this land. It is different, but I am impressed.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(61811,'Patience... let them come to us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61812,'ATTACK!!!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(61813,'','Of course, Lord Zhu.',0,0,0,0,0,0,2,0,1,0,0,31355,26124),
(61814,'The fight is THAT way, $R.','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(61815,'You\'re supposed to hit the big guy, not me.','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(61816,'Get back out there and fight!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(61817,'You\'re lucky our clan leader is holding me back.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(61818,'You\'re messing with the wrong Mogu, $R.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(61819,'Monk','Monk',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61820,'Oh, Liu of the Bottomless Tankard? He\'s been in a drinking contest for the longest time at the Stonefire Tavern, just north of the gates of Ironforge.','Oh, Liu of the Bottomless Tankard? He\'s been in a drinking contest for the longest time at the Stonefire Tavern, just north of the gates of Ironforge.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61821,'Ah, a brawler are ye\'? You\'ll find your pandaren friend at the Stonefire Tavern.','Ah, a brawler are ye\'? You\'ll find your pandaren friend at the Stonefire Tavern.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61822,'','I may not know how to fight yet, but I do know what\'s worth fighting for!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61823,'','My father thinks he can tell me what to do still! I\'m not a child anymore and he needs to see that.',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(61824,'','I have as much a right as any in the village to fight for my home. If I only knew a hero that could train me...',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(61825,'These are my kind of people. You can really feel like they\'re going somewhere!\n\nAnyways, what can I show you about being a monk, friend?','',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(61826,'People here really see the world the way I do. You\'ve got to make a place for yourself, you know?','',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(61827,'','Looks like we have our work cut out for us...',0,0,0,0,0,0,396,0,1,0,0,31372,26124),
(61828,'','Ready when you are, $p.',0,0,0,0,0,0,396,0,5,0,0,31373,26124),
(61829,'','Good work. Let\'s meet back up with Lord Zhu. There\'s nothing more we can do here.',0,0,0,0,0,0,396,0,1,0,0,31376,26124),
(61830,'','Take cover behind the barricades!',0,0,0,0,0,0,0,0,1,0,0,31374,26124),
(61831,'','Get behind the barricades!',0,0,0,0,0,0,0,0,1,0,0,31375,26124),
(61832,'Monk','Monk',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61833,'Oh, Ji? He\'s at the Pandaren Pavillion in the Valley of Honor, checking out the fights and talking with the warriors.','Oh, Ji? He\'s at the Pandaren Pavillion in the Valley of Honor, checking out the fights and talking with the warriors.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(61834,'Ji usually stays at the Pandaren Pavillion. It\'s close to the arena, and he loves to watch the fights. I hear he even participates once in a while.','Ji usually stays at the Pandaren Pavillion. It\'s close to the arena, and he loves to watch the fights. I hear he even participates once in a while.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(61835,'Let\'s get this training started!','Let\'s get this training started!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61836,'','Alright! Let\'s get down to business!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61838,'%s runs out of ammunition and flies away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61839,'How may I help you?','How may I help you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61840,'I have nothing to teach you, $c.','I have nothing to teach you, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61841,'Monk','Monk',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61842,'Lanfen can be found meditating over the lake in the Temple Gardens. I hear she makes quite marvelous teas.','Lanfen can be found meditating over the lake in the Temple Gardens. I hear she makes quite marvelous teas.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61843,'','Thank you for your time. I hope you will reconsider training me in the future.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(61844,'Monk','Monk',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61845,'You will find Tseh Rah on the Spirit Rise. She has been meeting with the Shaman Trainers there.','You will find Tseh Rah on the Spirit Rise. She has been meeting with the Shaman Trainers there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(61846,'Monk','Monk',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61847,'Old Sho can be found in the Farstrider\'s Square, practicing his moves.','Old Sho can be found in the Farstrider\'s Square, practicing his moves.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61848,'Pan of the Martial Spirit trains with the warriors on the Warriors\' Terrace, overlooking the rest of the Trader\'s Tier.','Pan of the Martial Spirit trains with the warriors on the Warriors\' Terrace, overlooking the rest of the Trader\'s Tier.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61849,'Monk','Monk',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61850,'The trick to dealing with pirate hozen is to have the element of surprise.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61851,'Okay... so... the new trick to dealing with pirate hozen is to do what you just did right there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61852,'Wait! Do you hear that? It sounds like tiny wings flapping...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61853,'Watch out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61854,'We\'d better keep moving before this whole island finds out we\'re here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61855,'Hozen gladiators? Where did they get all of these weapons?','',0,0,0,0,0,0,0,0,1,18961,0,0,26124),
(61856,'Well! This looks like as good a place to brew as any.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61857,'Know the only thing worse than a pirate? Hozen pirates! They raid our shores and steal our fish, our boats, and our brew. No one steals our brew... no one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61858,'Let\'s get going!','Let\'s get going!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61859,'Captain Ook is comin\' down with the scurvy! Keep the orange away from him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61860,'Readying Zip Line','Readying Zip Line',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61861,'Ouch! Ouch! Ouch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61862,'Birds too?! How\'d they even learn to tame the birds?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61863,'Say hello to my little friend!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61864,'I\'ll cut you in two!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61865,'You\'re what\'s for dinner!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61866,'Dinner\'s ready!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61867,'You look a little pale!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61868,'You don\'t look so good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61869,'Ookie\'s hungry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61870,'Ookie want fish! Fish give me strength to finish you dookers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61871,'Get out of my kitchen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61872,'This cauldron will be perfect for brewing our... brew.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61873,'DELICIOUS!','',0,0,0,0,0,0,7,0,1,0,0,0,26124),
(61874,'Is that my belly rumbling, or is something BIG coming?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(61876,'Run away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61877,'YOU BETTER BE READY TO GET SOME OOK IN YER DOOKER!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61878,'Bam ba-ba-BAM!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61879,'$n has got the orange!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61880,'Captain Ook\'s got the full blown scurvy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61881,'$n tossed the orange!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61882,'You makin me \'ookin ANGRY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61883,'You dookers! Give me \'dat orange!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61884,'No fair! Three of you wikkets against one o\' me?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61885,'You take my orange?! What a slap in face!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61886,'I need dat orange! Gimme!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61887,'Ha! Much better! Now you dookers gonna get it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61888,'','I heard the mines are infested with spiders again. I really hope no one gets hurt.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61889,'','They say strangers from beyond the mists have started showing up across the Jade Forest. Strange times.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61890,'','I heard some of the earth spirits are unhappy with the Greenstone Quarry. I hope they don\'t take it out on us.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61891,'','How are the noodles today?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(61892,'I am Kil\'ruk, a warrior from an era long passed.','',0,0,0,0,0,0,0,0,1,0,30300,0,26124),
(61893,'In my time, this was a mogu stronghold. It was my honor to paint the walls with their blood.','',0,0,0,0,0,0,0,0,1,0,30301,0,26124),
(61894,'For my deeds, I was named a Paragon. A hero to be preserved in amber for a time when the empire would need... correcting.','',0,0,0,0,0,0,0,0,1,0,30302,0,26124),
(61895,'Wakener, what power is this that burns our land and corrupts our trees?','',0,0,0,0,0,0,0,0,1,0,30303,0,26124),
(61896,'The palace! This is... not our way.  I see why the Klaxxi have been forced to act.','',0,0,0,0,0,0,0,0,1,0,30304,0,26124),
(61897,'They are a council of our wisest cultural leaders. They serve to check the power of the Empress.','',0,0,0,0,0,0,0,0,1,0,30305,0,26124),
(61898,'One of you, stay with me to keep the cauldron safe. The others, go find some Unga Jungle Brew and bring it back!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61899,'Should the Empress ever fall to corruption or endanger our civilization, the Klaxxi are sworn to unseat her.','',0,0,0,0,0,0,0,0,1,0,30306,0,26124),
(61900,'There are others like me. Paragons of each era, frozen in time and buried safely beyond the whispers of the Empress.','',0,0,0,0,0,0,0,0,1,0,30307,0,26124),
(61901,'We answer only to the council. And we rest only when their will is done.','',0,0,0,0,0,0,0,0,1,0,30308,0,26124),
(61902,'Ah, here\'s the $c I was telling you about.','',0,0,0,0,0,0,1,0,1,0,28431,0,26124),
(61903,'Would you like to start the Challenge?','Would you like to start the Challenge?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(61904,'Good! Let\'s clear out some of these mantid, then we can retake that bridge.','',0,0,0,0,0,0,1,0,1,0,29851,0,26124),
(61905,'Lord Zhu, we\'ll return shortly.','',0,0,0,0,0,0,1,0,1,0,29840,0,26124),
(61906,'Yes, start the Challenge.','Yes, start the Challenge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(61907,'With pleasure. Return to me when you two are finished.','',0,0,0,0,0,0,1,0,1,0,28430,0,26124),
(61908,'Come, $p, let\'s push these insects back!','',0,0,0,0,0,0,1,0,1,0,29841,0,26124),
(61909,'This is where we make our stand!','',0,0,0,0,0,0,1,0,1,0,29842,0,26124),
(61910,'Drink this. It has a bit of a kick.','',0,0,0,0,0,0,1,0,1,0,29843,0,26124),
(61911,'Have a sip of this!','',0,0,0,0,0,0,1,0,1,0,29844,0,26124),
(61912,'Pour this one back!','',0,0,0,0,0,0,1,0,1,0,29845,0,26124),
(61913,'Kick the keg at them!','',0,0,0,0,0,0,1,0,1,0,29846,0,26124),
(61915,'Get clear!','',0,0,0,0,0,0,1,0,1,0,29847,0,26124),
(61916,'You\'ve got him, keep it up!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(61917,'He\'s almost down!','',0,0,0,0,0,0,1,0,1,0,29848,0,26124),
(61918,'Nice work, $p! You were the right choice for the task.','',0,0,0,0,0,0,1,0,1,0,29849,0,26124),
(61919,'Make your way back to Taran Zhu. I\'ll catch up with you shortly.','',0,0,0,0,0,0,1,0,1,0,29850,0,26124),
(61920,'The crossroads are not far. Let us seek out our last member there.','',0,0,0,0,0,0,1,0,1,0,28428,0,26124),
(61921,'My men speak highly of this Nurong, it will be good to finally meet him.','',0,0,0,0,0,0,1,0,1,0,29854,0,26124),
(61922,'','Is it to be Hawkmaster Nurong then?',0,0,0,0,0,0,6,0,1,0,0,31340,26124),
(61923,'Ooooh, you have lots of pretty things to steal!  Gimme!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61924,'Meanie...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61925,'You are to join us in our hunt of the Sha of Hatred then, Lao-Chin. The men here should be able to hold the bridge and repair the camp on their own.','',0,0,0,0,0,0,1,0,1,0,28433,0,26124),
(61926,'Of course.  My staff is yours, Lord Zhu.','',0,0,0,0,0,0,1,0,1,0,29853,0,26124),
(61927,'I take it you were successful at the bridge?','',0,0,0,0,0,0,6,0,1,0,28432,0,26124),
(61928,'We were.  My new friend here performed stunningly!','',0,0,0,0,0,0,1,0,1,0,29852,0,26124),
(61929,'Yes.  We\'ll need his expertise with a crossbow when the final battle comes.','',0,0,0,0,0,0,1,0,1,0,28429,0,26124),
(61931,'Good to see you well, Rensai. We\'re here for Hawkmaster Nurong. Where can we find him?','',0,0,0,0,0,0,1,0,1,0,28424,0,26124),
(61932,'Well met, Lord Zhu. He\'s with the rest of my men, holding the line at Farwatch Overlook.','',0,0,0,0,0,0,1,0,1,0,31156,0,26124),
(61933,'Farwatch Overlook?  I\'ve heard no reports of mantid in the chasm below.','',0,0,0,0,0,0,1,0,1,0,28425,0,26124),
(61935,'No, not the chasm. Fliers.  In numbers like we\'ve never seen.','',0,0,0,0,0,0,1,0,1,0,31157,0,26124),
(61936,'Taoshi, the Sha of Hatred is close. Find it and report back to me.','',0,0,0,0,0,0,1,0,1,0,28426,0,26124),
(61938,'Strange... this one carries a few pieces of polished stone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61939,'Hopefully they came from Niuzao\'s statuette. We can only hope.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61940,'Another stone... and it matches the markings on the others we found.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61941,'I think we\'re getting somewhere, $p. Let\'s keep looking around.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61942,'If I didn\'t know any better, I\'d say this was a stone ox tail.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61943,'All that\'s left now is the head. And it can\'t have gotten far.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61944,'Here\'s the head. A perfect fit, too.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61945,'We\'ve performed Niuzao\'s errand. Now it\'s time to get back to some real investigation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61946,'Stand in Blanche\'s Elixir of Replenishment to restore health and mana!','Stand in Blanche\'s Elixir of Replenishment to restore health and mana!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61947,'$p, help at Farwatch Overlook and then bring Nurong back to us here. Our final confrontation approaches swiftly.','',0,0,0,0,0,0,1,0,1,0,28427,0,26124),
(61948,'Arm the cannons! Ready...aim...fire!','',0,0,0,0,0,0,0,0,1,0,32502,0,26124),
(61949,'They are soft, weak!','',0,0,0,0,0,0,0,0,1,0,32501,0,26124),
(61950,'Retreat to the hills!','',0,0,0,0,0,0,0,0,1,0,32499,0,26124),
(61951,'Bring me their corpses!','',0,0,0,0,0,0,0,0,1,0,32498,0,26124),
(61952,'$C, up here! I could use a hand!','',0,0,0,0,0,0,22,0,1,0,30797,0,26124),
(61953,'Loot and pillage, bwahahaha!','',0,0,0,0,0,0,0,0,1,0,32500,0,26124),
(61954,'A large wave of fliers approaches! Take my cannon, $c, quickly!','',0,0,0,0,0,0,5,0,1,0,30798,0,26124),
(61955,'What... what is that thing?  Is it really trying to fly across?','',0,0,0,0,0,0,22,0,1,0,30799,0,26124),
(61956,'It\'s getting closer!  Shoot it down!','',0,0,0,0,0,0,22,0,1,0,30800,0,26124),
(61957,'Nice work!  Let\'s get down there and finish it off.','',0,0,0,0,0,0,22,0,1,0,30801,0,26124),
(61958,'Its shell is cracked in the back. Hit it where it hurts!','',0,0,0,0,0,0,22,0,1,0,30802,0,26124),
(61959,'Attacks from the back will be more effective.','',0,0,0,0,0,0,22,0,1,0,30803,0,26124),
(61960,'I\'ve got its attention! Give it everything you\'ve got!','',0,0,0,0,0,0,22,0,1,0,30804,0,26124),
(61961,'It\'s after me now, get behind it and do all the damage you can!','',0,0,0,0,0,0,22,0,1,0,30805,0,26124),
(61962,'Warmongers leap from Galleon\'s back to join the battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61963,'Whatever you do, don\'t let it hit you!','',0,0,0,0,0,0,22,0,1,0,30806,0,26124),
(61964,'|TInterface\\Icons\\ability_warstomp.blp:20|t Galleon is about to |cFFFF0000|Hspell:121787|h[Stomp]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61965,'It\'s after you!  Don\'t let it get close.','',0,0,0,0,0,0,22,0,1,0,30807,0,26124),
(61966,'|TInterface\\Icons\\ability_vehicle_siegeenginecannon.blp:20|t Galleon prepares to unleash a |cFFFF0000|Hspell:121600|h[Cannon Barrage]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61967,'It\'s stunned. Now\'s our chance to finish it off!','',0,0,0,0,0,0,22,0,1,0,30808,0,26124),
(61968,'Masterful.','',0,0,0,0,0,0,22,0,1,0,30809,0,26124),
(61969,'I\'m proud to fight by your side.','',0,0,0,0,0,0,66,0,1,0,30810,0,26124),
(61970,'If Lord Zhu was asking for us, we better not keep him waiting.  Let us go.','',0,0,0,0,0,0,1,0,1,0,30811,0,26124),
(61971,'This place doesn\'t look good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61972,'We\'ve found the hiding place of the Sha of Hatred.','',0,0,0,0,0,0,1,0,1,0,28442,0,26124),
(61973,'Welcome, Nurong. Good to have you with us.','',0,0,0,0,0,0,1,0,1,0,29858,0,26124),
(61974,'Yes... this must be it. We\'re headed the right way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61975,'Which way to go? Up, or down?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61976,'Can you sense it, $p? This is where the Sha of Fear was held.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61977,'Stay calm, $p. Focus on your goal, not on your fears.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61978,'As you wish. We will find your artifact. $p - I will meet you at the Sra\'thik Incursion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61979,'','Come $p, let me show you.',0,0,0,0,0,0,66,0,6,0,0,31359,26124),
(61980,'','Look through the spyglass.',0,0,0,0,0,0,396,0,7,0,0,31360,26124),
(61981,'','The Sha of Hatred is inside that mantid structure... I suspect it was drawn to a powerful host there.',0,0,0,0,0,0,396,0,6,0,0,31361,26124),
(61982,'','To get in, we will need specially tuned crystals from some of the mantid leaders in the area.',0,0,0,0,0,0,396,0,6,0,0,31362,26124),
(61983,'','I located these leaders here...',0,0,0,0,0,0,396,0,6,0,0,31363,26124),
(61984,'','here...',0,0,0,0,0,0,396,0,6,0,0,31364,26124),
(61985,'','and here.',0,0,0,0,0,0,396,0,6,0,0,31365,26124),
(61986,'','Kill them.  Take the crystals.  Should be simple enough.',0,0,0,0,0,0,396,0,6,0,0,31366,26124),
(61987,'Come here, $r. I wish to speak with you. Our secret can remain hidden no longer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61988,'As I suspected. Thank you, Ogos. $p - I will meet you in the catacombs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(61989,'Taoshi, Lao-Chin, Nurong, you all have your assignments.  Set up at each location and wait for our signal.','',0,0,0,0,0,0,1,0,1,0,28443,0,26124),
(61990,'Taoshi, did you bring the shackles and rings?','',0,0,0,0,0,0,1,0,1,0,28446,0,26124),
(61991,'Remember your training.  As long as you do not give in to hatred, you will make it out alive.','',0,0,0,0,0,0,1,0,1,0,28447,0,26124),
(61993,'Same drill as before. You do the killing, I\'ll do the searching.','',0,0,0,0,0,0,0,0,1,16740,0,0,26124),
(61994,'This place doesn\'t look pretty. Come on, $n. Let\'s go inside.','',0,0,0,0,0,0,0,0,1,16737,0,0,26124),
(61995,'$p, my men have been instructed to wait for your arrival before they attack. Do not delay.','',0,0,0,0,0,0,1,0,1,0,28444,0,26124),
(61997,'Do you each have the crystals?','',0,0,0,0,0,0,1,0,1,0,28445,0,26124),
(61998,'','Yes.',0,0,0,0,0,0,396,0,1,0,0,31367,26124),
(61999,'Yes.','',0,0,0,0,0,0,0,0,1,0,29855,0,26124),
(62000,'Yes.','',0,0,0,0,0,0,22,0,1,0,30794,0,26124),
(62001,'','...yes, Lord Zhu.',0,0,0,0,0,0,396,0,1,0,0,31368,26124),
(62002,'Let\'s go.','',0,0,0,0,0,0,1,0,1,0,28448,0,26124),
(62004,'Come, lambs... come and face your demise!','',0,0,0,0,0,0,0,0,1,0,28337,0,26124),
(62005,'The hatred inside you drives your hunt for me.  You are already mine.','',0,0,0,0,0,0,0,0,1,0,28338,0,26124),
(62006,'Give in.  The more you fight, the more your hatred broils within you.','',0,0,0,0,0,0,0,0,1,0,28339,0,26124),
(62007,'Blanche senses there are no longer allies nearby and retreats!','Blanche senses there are no longer allies nearby and retreats!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62008,'You are nearly dead!','You are nearly dead!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62009,'Wind-Reaver. You have awakened. What of Klaxxi\'va Tik?','',0,0,0,0,0,0,0,0,1,0,31517,0,26124),
(62010,'And what is this filth you\'ve brought to our sanctuary?','',0,0,0,0,0,0,0,0,1,0,32855,0,26124),
(62011,'The Klaxxi\'va you sent has fallen to an adjunct of Her majesty.','',0,0,0,0,0,0,0,0,1,0,30309,0,26124),
(62012,'This... \"filth\" defeated the adjunct and saw to my Wakening.','',0,0,0,0,0,0,0,0,1,0,30310,0,26124),
(62013,'We do not need help from the lesser races! Dispose of it!','',0,0,0,0,0,0,0,0,1,0,32856,0,26124),
(62014,'Right away, Klaxxi\'va.','',0,0,0,0,0,0,0,0,1,0,30311,0,26124),
(62015,'Let\'s give it another shot!','Let\'s give it another shot!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62016,'No.','',0,0,0,0,0,0,0,0,1,0,31518,0,26124),
(62017,'The Wakener may prove useful. One way or another.','',0,0,0,0,0,0,0,0,1,0,31519,0,26124),
(62018,'You are dying!','You are dying!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62019,'You are near death!','You are near death!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62020,'You\'re almost dead!','You\'re almost dead!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62021,'Don\'t die!','Don\'t die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62022,'Everything that you are is MINE to destroy!','',0,0,0,0,0,0,0,0,1,0,28340,0,26124),
(62023,'The Amberwing is flying in, watch out!','',0,0,0,0,0,0,25,0,1,0,31503,0,26124),
(62024,'That mantid is its host.  Chain it down.  We will rip the hatred from its body!','',0,0,0,0,0,0,1,0,1,0,28437,0,26124),
(62025,'Demolishers are carrying explosives! Any direct hit will blow them up!','',0,0,0,0,0,0,25,0,1,0,31504,0,26124),
(62026,'Hold off the mantid!  This will not take long.','',0,0,0,0,0,0,1,0,1,0,28438,0,26124),
(62027,'Keep the mantid back!  We are almost done.','',0,0,0,0,0,0,1,0,1,0,28439,0,26124),
(62028,'Hatred, come out and face your defeat!','',0,0,0,0,0,0,1,0,1,0,28440,0,26124),
(62029,'This is your moment, Shado-Pan!  This is everything that you\'ve trained for!','',0,0,0,0,0,0,0,0,1,0,28441,0,26124),
(62030,'Taran Zhu, you are a fool.  You escaped me only to return with your hatred broiling inside you.  You... are... MINE!','',0,0,0,0,0,0,0,0,1,0,28341,0,26124),
(62031,'','Shackles, NOW!',0,0,0,0,0,0,396,0,1,0,0,31356,26124),
(62032,'As fodder for the swarm, perhaps!','',0,0,0,0,0,0,0,0,1,0,32857,0,26124),
(62033,'What brings you to our temple, $r?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62034,'I take pride in the fact that I am continuing my father\'s legacy here.$b$bA still-growing legacy, I might add.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62035,'What is this?!  A trap?','',0,0,0,0,0,0,0,0,1,0,28342,0,26124),
(62036,'We are the protectors - immovable and unflappable.$b$bWhen we are moving, nothing can stop us from moving. When we are standing still, nothing can budge us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62037,'Clever Shado-Pan... I underestimated you.  But your leader is mine now.  You cannot free him without freeing me as well.','',0,0,0,0,0,0,0,0,1,0,28343,0,26124),
(62038,'','As is his will.  It is our sworn duty to see you confined, and he sees it done.',0,0,0,0,0,0,396,0,1,0,0,31357,26124),
(62039,'','Some consider these yaks to be lowly beasts, suitable only for grazing and menial labor. Few recognize the innate beauty that these creatures - the scions of the Black Ox - truly possess.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62041,'His sacrifice inspires us all.','',0,0,0,0,0,0,1,0,1,0,30793,0,26124),
(62042,'','We couldn\'t have done this without you, $p.  Thank you.',0,0,0,0,0,0,396,0,1,0,0,31358,26124),
(62043,'','Your move.  I\'ll follow you in.',0,0,0,0,0,0,0,0,1,0,0,31369,26124),
(62044,'','Good work.',0,0,0,0,0,0,0,0,1,0,0,31370,26124),
(62045,'I\'ll cover you.  Go whenever you\'re ready.','',0,0,0,0,0,0,0,0,1,0,30795,0,26124),
(62046,'Very impressive!','',0,0,0,0,0,0,0,0,1,0,30796,0,26124),
(62047,'I\'ll be with you.','',0,0,0,0,0,0,0,0,1,0,29856,0,26124),
(62048,'Not bad... not bad.','',0,0,0,0,0,0,0,0,1,0,29857,0,26124),
(62049,'Something is happening with the mantid... and I suspect it has to do with that temple across the bridge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62050,'I will rendezvous with you at Niuzao temple, $p. Our investigation isn\'t nearly over yet...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62051,'','You are welcome among the Shado-Pan.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(62052,'','Stay light on your feet.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(62053,'','I would recommend against such actions...',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(62054,'Good to see you, friend.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62055,'Find me for a drink sometime.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62056,'Alright, you can stop now.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62057,'Hey there.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62058,'Bye for now.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62059,'Ooh, we\'re going to play the poking game?  I like the poking game!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62060,'Ouch!','',0,0,0,0,0,0,1,0,1,0,28180,0,26124),
(62062,'Hahah, good work!','',0,0,0,0,0,0,1,0,1,0,30782,0,26124),
(62063,'Welcome!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62064,'Any friend of the Shado-Pan is a friend of mine.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62065,'Glad to have you.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62066,'How can I help?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62067,'Farewell for now, friend.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62068,'Travel safely.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62069,'May the hawks watch over you.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62070,'See you again soon.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62071,'My kindness only extends so far, friend.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62072,'You.  Me.  We\'re done.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62073,'','Good to see you.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(62074,'','Ready for some action?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(62075,'','You have my attention.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(62076,'','Are you here to fight?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(62077,'','Be wary beyond the wall.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(62078,'','Keep your eyes keen, adventurer.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(62079,'','The Shado-Pan will be here if you need us.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(62080,'','May fortune follow you.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(62081,'','You overestimate my patience.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(62082,'','Keep it up... they\'ll never find your body.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(62083,'Well look who it is!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62084,'Come to share in some of Tenwu\'s fine company?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62085,'Welcome.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62086,'You kind of like me, don\'t you?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62087,'You\'ll be back.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62088,'Always good talking to you.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62089,'Talk to you soon.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62090,'Goodbye.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62091,'Such attention!  You flatter me, love.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62092,'Care to take this somewhere private?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62093,'Take me to Klaxxi\'vess.','Take me to Klaxxi\'vess.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62094,'You picked me!  I\'m flattered!','',0,0,0,0,0,0,1,0,1,0,28188,0,26124),
(62095,'I\'ll gladly spend the day with you.','',0,0,0,0,0,0,1,0,1,0,28189,0,26124),
(62096,'There\'s some adventuring in store for us today, then?','',0,0,0,0,0,0,6,0,1,0,28190,0,26124),
(62097,'I like the way you think.','',0,0,0,0,0,0,1,0,1,0,30790,0,26124),
(62098,'Ready when you are.','',0,0,0,0,0,0,1,0,1,0,30791,0,26124),
(62099,'I won\'t leave your side.','',0,0,0,0,0,0,1,0,1,0,30792,0,26124),
(62100,'','Let\'s get down to business.',0,0,0,0,0,0,396,0,1,0,0,31349,26124),
(62101,'','Where to, $p?',0,0,0,0,0,0,6,0,1,0,0,31350,26124),
(62102,'','I\'m with you.',0,0,0,0,0,0,396,0,1,0,0,31351,26124),
(62103,'','We\'ll have this whole island cleared out soon.',0,0,0,0,0,0,0,0,1,0,0,31341,26124),
(62104,'','You and I work well together.',0,0,0,0,0,0,0,0,1,0,0,31342,26124),
(62105,'','There\'s no escape for you, insects.  You face the Shado-Pan this day.',0,0,0,0,0,0,0,0,1,0,0,31343,26124),
(62106,'','You should have stayed in the Dread Wastes.',0,0,0,0,0,0,0,0,1,0,0,31344,26124),
(62107,'','Your queen sends you to your deaths.',0,0,0,0,0,0,0,0,1,0,0,31345,26124),
(62108,'','Silent and deadly.',0,0,0,0,0,0,0,0,1,0,0,31346,26124),
(62109,'','Hahahah... nice one.',0,0,0,0,0,0,0,0,1,0,0,31347,26124),
(62110,'Off-landers bringin\' shinies to hozen?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62111,'','Impressive.',0,0,0,0,0,0,0,0,1,0,0,31348,26124),
(62112,'Ookin\' treasure fallin\' from the sky!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62113,'Got any ookin\' treasure, off-lander?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62114,'Ookin\' wikkets wreckin\' hozen homeland!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62115,'This hozen land! No wikkets!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62116,'Very well fought.','',0,0,0,0,0,0,22,0,1,0,30783,0,26124),
(62117,'I softened you up. My cousins will finish you off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62118,'Too many hozen. You die soon, offlander.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62119,'Reekin\' off-lander!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62120,'Hozen have all you treasure now, off-lander.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62121,'Off-lander smell like rotton dooker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62122,'I\'m right behind you.','',0,0,0,0,0,0,22,0,1,0,30784,0,26124),
(62123,'Skillfully done.','',0,0,0,0,0,0,22,0,1,0,30785,0,26124),
(62124,'You\'d think by now they\'d learn to just run away.','',0,0,0,0,0,0,22,0,1,0,30786,0,26124),
(62125,'Suicidal bugs, aren\'t they?','',0,0,0,0,0,0,22,0,1,0,30787,0,26124),
(62126,'Quite the thrill.','',0,0,0,0,0,0,22,0,1,0,30788,0,26124),
(62127,'You\'re impressive.','',0,0,0,0,0,0,22,0,1,0,30789,0,26124),
(62128,'You fight with flare.  I like that.','',0,0,0,0,0,0,1,0,1,0,28181,0,26124),
(62129,'Where\'d you learn to do that?','',0,0,0,0,0,0,1,0,1,0,28182,0,26124),
(62130,'My compliments.','',0,0,0,0,0,0,1,0,1,0,28183,0,26124),
(62131,'It\'s a wonder these mantid keep coming back for more.','',0,0,0,0,0,0,1,0,1,0,28184,0,26124),
(62132,'You\'d think we\'d have killed all of them by now.','',0,0,0,0,0,0,1,0,1,0,28185,0,26124),
(62133,'I don\'t think they\'re getting the message.','',0,0,0,0,0,0,1,0,1,0,28186,0,26124),
(62134,'Quite the welcome for our good mantid friends.','',0,0,0,0,0,0,1,0,1,0,28187,0,26124),
(62135,'Come back to camp when you are finished. We have much to discuss.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62136,'A flare has been spotted. The Boom Boom Brew Defender can now be fired.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62138,'|TInterface\\Icons\\inv_misc_uncutgemnormal.blp:20|tMove away from your allies! A Sra\'thik Amber-Trapper is casting |cFFF00000|Hspell:121881|h[Amber Prison]|h|r on you!','|TInterface\\Icons\\inv_misc_uncutgemnormal.blp:20|tMove away from your allies! A Sra\'thik Amber-Trapper is casting |cFFF00000|Hspell:121881|h[Amber Prison]|h|r on you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62139,'Everyone has left you.','Everyone has left you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62140,'You are alone in the world.','You are alone in the world.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62141,'Everybody left. Nobody likes you.','Everybody left. Nobody likes you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62142,'You have been abandoned.','You have been abandoned.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62143,'Nobody notices you.','Nobody notices you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62144,'You\'re going to fall!','You\'re going to fall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62145,'Your feet have left the ground!','Your feet have left the ground!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62146,'Don\'t fall!','Don\'t fall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62147,'Cloudrider Hatchling is very glad to see you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62148,'Cloudrider Hatchling licks you affectionately.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62149,'Cloudrider Hatchling flies in a loop.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62150,'Cloudrider Hatchling is very happy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62151,'Cloudrider Hatchling wants to play!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62152,'Cloudrider Hatchling nuzzles your hand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62153,'|TInterface\\Icons\\spell_yorsahj_bloodboil_yellow.blp:20|tRun! You are covered in |cFFF00000|Hspell:122064|h[Corrosive Resin]|h|r!','|TInterface\\Icons\\spell_yorsahj_bloodboil_yellow.blp:20|tRun! You are covered in |cFFF00000|Hspell:122064|h[Corrosive Resin]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62154,'%s lifts off and flies to the other end of the bridge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62155,'The Wild Cloudrider senses its freedom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62156,'Living flesh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62157,'Devour them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62158,'Foolish mortal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62159,'We will tear out your eyes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62160,'Curse you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62161,'Join us...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62162,'Only death is eternal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62163,'We will send you to your grave!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62164,'The Shan\'ze Stormclaw comes to its senses!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62165,'So few Klaxxi\'va are even left.$B$BWhat has happened to my people while I slept?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62166,'I trust in the will of the Klaxxi. They know what is best for our people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62167,'I must finish this myself, then. So be it!','',0,0,0,0,0,0,0,0,1,0,30263,0,26124),
(62168,'Warrior coming in!  Focus your fire!','',0,0,0,0,0,0,25,0,1,0,31512,0,26124),
(62172,'<The mantid councilor narrows his enormous eyes on you briefly.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62173,'The Empress would force this swarm and raze our own lands in the process.$B$BThe cost is too high.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62174,'','I see... your eyes never leave the target. Total focus!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62175,'','AHHH! It looked at me!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62176,'','I can do this, I know I can do this...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62177,'','That\'ll teach you to mess with my village!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62178,'','I must be swift as a rushing... stream!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62179,'','The fighter spirit is about to hit you in the face!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62180,'','Revenge is a dish best served by ME!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62181,'','My father is so overly protective. I never get to do anything!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62182,'','An adventurer like you has probably won many battles!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62183,'','I\'ll show my father I have what it takes to be a great fighter.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62184,'','This is a lot more work than I thought it would be...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62185,'','If fighting is like dancing I may be in trouble. I\'m a terrible dancer...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62186,'','I can\'t help but wonder if I could be doing more damage if my gear was better...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62187,'','I always thought the Zandalari were just made up to make me behave when I was younger.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62188,'','I think I was born to be an adventurer. Like those Pandaren from the Wandering Isle...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62189,'','These ruins are supposedly haunted. I don\'t believe in ghosts though. Then again, I didn\'t believe in Zandalari either.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62190,'','This beach used to be such a peaceful place. Now it\'s polluted with these barbarians!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62191,'','So much destruction... so much death... will this ever stop?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62192,'','...Now, charge!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62193,'','Look at all the flowers blooming. Aren\'t they lovely?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62194,'','Spring lives eternally in the heart.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62195,'','Look at all the children! They bring such joy to my heart.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62196,'','Would you like to take a walk with us?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62197,'','The flowers are blooming at this time of year. They smell so fragrant!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62198,'','I hope you are having a wonderful day, $r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62199,'','Spring is my favorite season of the year. What is your favorite season?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62200,'','The days pass quickly when I am busy.$B$BI must remind myself to stop and enjoy the moment.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62201,'','Are the sha approaching?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62202,'','Don\'t worry, $r. They will not get past me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62203,'','The children are frightened, but they will be all right. We will keep them safe!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62204,'','Thank you for your training, $n. I hope to one day be as good a fighter as you!',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(62205,'More ale... hic!','More ale... hic!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62206,'It is the wanderer\'s way.','',0,0,0,0,0,0,66,0,1,0,29686,0,26124),
(62207,'%s shakes off the |cFFFF0000|Hspell:120778|h[Caustic Tar]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62210,'Hozen ships appear in the distance!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(62211,'','Freeze!$B$BHa! I love saying that.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62212,'','You\'re lucky you were near me, eh?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62213,'','I told you! These rocks are slippery!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62214,'','You have GOT to be more careful!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62215,'','Everybody gets one...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62216,'','Maybe next time I won\'t be around to save you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62217,'Eee! Monsters are attacking Greenstone Village! RUN AWAY!','Eee! Monsters are attacking Greenstone Village! RUN AWAY!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(62218,'','Good form is the key to defeating your enemies. Don\'t swing wildly with your weapon. Be disciplined with your attacks.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62219,'','Your enemy will not show you mercy. Give him the same courtesy.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62220,'','Do not expose your weaknesses.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62221,'','Confidence in your abilities will go a long way. Overconfidence will quickly get you killed.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62222,'','Go ahead and start pulling some of the younger flowers. Just not too many.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62223,'It is quiet here today. Good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62224,'I would like you to come with me today.','I would like you to come with me today.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62225,'This path leads to Kun-Lai Summit. Good fortune to those who travel it to shop at grummle shops.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62226,'You must be powerful, to have come this far. Yes, yes... you will make worthy test subjects.','',0,0,0,0,0,0,0,0,1,0,31555,0,26124),
(62227,'Ah, I see you have found a few of my experiments.  Step closer, and you may witness the full glory of my work here.','',0,0,0,0,0,0,0,0,1,0,31559,0,26124),
(62228,'Forgive me, Empress....','',0,0,0,0,0,0,0,0,1,0,31556,0,26124),
(62229,'You must think yourselves mighty. How little you know. Behold now, my greatest creation!','',0,0,0,0,0,0,0,0,1,0,31557,0,26124),
(62230,'What have you done? No, this will not be how my work ends. I will not allow it!','',0,0,0,0,0,0,0,0,1,0,31558,0,26124),
(62231,'Is that all?','',0,0,0,0,0,0,0,0,1,0,31560,0,26124),
(62232,'Excellent!','',0,0,0,0,0,0,0,0,1,0,31561,0,26124),
(62233,'Feel fortunate to receive this gift.','',0,0,0,0,0,0,0,0,1,0,31562,0,26124),
(62234,'From death comes life, and from life, death....','',0,0,0,0,0,0,0,0,1,0,31564,0,26124),
(62235,'Watch your step!','',0,0,0,0,0,0,0,0,1,0,31563,0,26124),
(62237,'What? Someone steal junglebrew?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62238,'Wake up! Wake up! They stealing junglebrew!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62239,'What happening? What day is it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62240,'BLECCHH!!','',0,0,0,0,0,0,0,0,1,0,30908,0,26124),
(62241,'Hold off the swarm while Malik the Unscathed awakens!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62242,'I am returned. I heed the call of the Klaxxi.','',0,0,0,0,0,0,0,0,1,0,30909,0,26124),
(62243,'Malik the Unscathed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62244,'Never a glancing blow laid upon you, but countless foes cut down by your halberd.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62245,'And countless more to come, Klaxxi\'va. It is my honor to serve in our time of need.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62246,'And serve you shall. Arm yourself at the quartermaster. The drones here are at your disposal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62247,'','Are you really as strong as the others say?',0,0,0,0,0,0,0,0,1,0,0,31252,26124),
(62248,'I challenge you!','I challenge you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62249,'That\'s the last of the ingredients! Good work, $p! Now the festival can begin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62250,'Now comes the hard part. Everyone stand back, precision is the key to the perfect Kun-Lai Kicker!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(62251,'Thanks for saving us!  Are you ready to get this party started?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62252,'We\'re ready to defend!','We\'re ready to defend!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62253,'Mantid are born with little on their mind but a lust for battle. Participation in a swarm is not only a cultural rite of passage - it is the catalyst for our physical maturation.$B$BOnly those who return from battle can develop from a swarmborn into a fully-aware, individual citizen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62254,'Thanks for the backup, friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62255,'','$n, I need your help!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62257,'Woooo, $n!','Woooo, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62258,'Welcome to the party, $n!','Welcome to the party, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62259,'This is going to be the best Brewmoon yet with $n here!','This is going to be the best Brewmoon yet with $n here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62260,'I was wondering when you would get here, $n!','I was wondering when you would get here, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62261,'Hey, $n!','Hey, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62262,'It\'s been awhile, $n.','It\'s been awhile, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62263,'Hey, it\'s $n!','Hey, it\'s $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62264,'Have a brew with us, $n!','Have a brew with us, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62265,'Good to see you, $n! Do you have a minute?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62266,'I\'m so glad you\'re here, $n! Tonight is the night of the Brewmoon Festival and none of the ingredients for my famous Kun-Lai Kicker have been delivered. I sent my assistants out to gather them but none of them have returned. Could you find out what is keeping them?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62267,'Where can I find Assistant Kieu?','Where can I find Assistant Kieu?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62268,'On the night of the Brewmoon, water spirits can be found on Inkgill Mere performing a ritual. Over the years we have made offerings to them in return for a vial of pure water used in crafting the Kun-Lai Kicker. I sent Assistant Tart out to the lake but she hasn\'t come back yet. Can you head to the north and find out what\'s keeping her, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62269,'','YAUNGOL!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62270,'Where can I find Assistant Tart?','Where can I find Assistant Tart?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62271,'','Come on, Poppers. Let\'s go!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62272,'','Good work, $p! Now I can collect the pure water!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62273,'Kieu, Tart, Buzaki toss the ingredients in!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(62274,'','$n! Brewmast Boof sent me to fetch a vial of pure water from the water spirits but Poppers ate the offering. Now I have no way to convince them to give me one and they don\'t look very friendly. Do you think you could persuade them for me?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62275,'I sent Assistant Kieu to the silos to collect a sack of grain but she still hasn\'t come back. Could you go check on her for me? You can find the silos on the western edge of town.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62276,'Welcome to Kota Peak. Home of super famous Kota Kafa. A luckydo would be wise to sniff and savor exotic brews.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62277,'Welcome to our most humble camp.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62278,'What is your Luckydo?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62279,'$n has taken the |cFF01DFD7Blue|r orb!','',0,0,0,0,0,0,0,0,1,0,9431,0,26124),
(62280,'$n has taken the |cFFFF8000Orange|r orb!','',0,0,0,0,0,0,0,0,1,0,9431,0,26124),
(62281,'$n has taken the |cFF01DF01Green|r orb!','',0,0,0,0,0,0,0,0,1,0,9431,0,26124),
(62282,'$n has taken the |cFFBF00FFPurple|r orb!','',0,0,0,0,0,0,0,0,1,0,9431,0,26124),
(62283,'The |cFF01DFD7Blue|r orb has been returned!','',0,0,0,0,0,0,0,0,1,0,9431,0,26124),
(62284,'The |cFFBF00FFPurple|r orb has been returned!','',0,0,0,0,0,0,0,0,1,0,9431,0,26124),
(62285,'The |cFFFF8000Orange|r orb has been returned!','',0,0,0,0,0,0,0,0,1,0,9431,0,26124),
(62286,'The |cFF01DF01Green|r orb has been returned!','',0,0,0,0,0,0,0,0,1,0,9431,0,26124),
(62287,'We must tread carefully. The Shan\'ze tribe practices dark magic that we still do not fully understand.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62288,'We are working to open a portal from here to Shado-Pan Garrison.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62289,'Once we open this portal, we will be able to travel much more quickly between here and the garrison.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62290,'The Wind-Reaver will not accompany you on this task, Wakener. His talents are needed elsewhere.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62291,'We shall see how you fare against the Vor\'thik without the wind at your back...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62292,'You may change your Primary Specialization for a price.\n\nThis will become more expensive each additional time you do so.','You may change your Primary Specialization for a price.\n\nThis will become more expensive each additional time you do so',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62293,'How do you like the portal? We couldn\'t have done it without your help!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62294,'You may unlearn all of your current Talents for a price, so that you may select new ones.\n\nThis will become more expensive each additonal time you do so.','You may unlearn all of your current Talents for a price, so that you may select new ones.\n\nThis will become more expensive each additonal time you do so.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62295,'I wish to unlearn my Talents.','I wish to unlearn my Talents.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62296,'You may empty all of your current Glyph slots for a price, so that you may select new ones.\n\nThis will become more expensive each additonal time you do so.','You may empty all of your current Glyph slots for a price, so that you may select new ones.\n\nThis will become more expensive each additonal time you do so.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62297,'I wish to clear all of my Glyphs.','I wish to clear all of my Glyphs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62298,'','I accept your challenge!',0,0,0,0,0,0,0,0,1,0,0,31256,26124),
(62299,'','I promise this won\'t hurt... too much.',0,0,0,0,0,0,0,0,1,0,0,31257,26124),
(62300,'','What!?!? I lost!?!?!',0,0,0,0,0,0,0,0,1,0,0,31258,26124),
(62301,'','You are as strong as they say, especially considering you defeated ME. Well fought.',0,0,0,0,0,0,0,0,1,0,0,31260,26124),
(62302,'','I need no further convincing. If you need me, I will be waiting on the hill behind the tents.',0,0,0,0,0,0,0,0,1,0,0,31259,26124),
(62303,'How may I help you?','How may I help you?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(62304,'|TInterface\\Icons\\spell_shaman_staticshock.blp:20|t %s begins to cast |cFFFF0000|Hspell:117958|h[Materialize Protector]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62305,'At level 10 you will choose a Class Specialization.\n\nIf you later decide to choose a different Class Specialization, you may reset your previous choice here for a price.\n\nThis will become more expensive each additonal time you do so.','At level 10 you will choose a Class Specialization.\n\nIf you later decide to choose a different Class Specialization, you may reset your previous choice here for a price.\n\nThis will become more expensive each additonal time you do so.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62306,'Shall we meet in the Challenger\'s Ring?','Shall we meet in the Challenger\'s Ring?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62307,'At level 15 you will choose your first Talent.\n\nIf you later decide to choose different Talents, you may reset your previous choices here for a price.\n\nThis will become more expensive each additonal time you do so.','At level 15 you will choose your first Talent.\n\nIf you later decide to choose different Talents, you may reset your previous choices here for a price.\n\nThis will become more expensive each additonal time you do so.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62308,'At level 25 you will begin to use Glyphs.\n\nIf you later decide to replace your chosen Glyphs, you may reset them here for a price.\n\nThis will become more expensive each additonal time you do so.','At level 25 you will begin to use Glyphs.\n\nIf you later decide to replace your chosen Glyphs, you may reset them here for a price.\n\nThis will become more expensive each additonal time you do so.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62309,'At level 30 you can learn Dual Specialization, which allows you to keep two active Class Specialization, Talent, and Glyph sets and easily switch between them.\n\nYou also will have separate glyph panes and action bars for each set.\n\nSwitching between the two sets cannot be done while in combat and will consume your available resources.','At level 30 you can learn Dual Specialization, which allows you to keep two active Class Specialization, Talent, and Glyph sets and easily switch between them.\n\nYou also will have separate glyph panes and action bars for each set.\n\nSwitching between the two sets cannot be done while in combat and will consume your available resources.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62310,'I have another question.','I have another question.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62311,'Hozen law number two... Tresspassers get ooked in the dooker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62312,'Pound wikket off-landers into the ground!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62313,'No wikket off-landers allowed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62314,'Wikket invasion! Fire from the sky!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62315,'Ugh... ooked by a wikket...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62316,'Grooook!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62317,'No fair! Wikket step on hozen tail!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62318,'A wave of |cFF00dc29Sik\'thik Swarmers|r joins the battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62320,'','I have waited a long time for this day. Let us face one another in the Challenger\'s Ring.',0,0,0,0,0,0,0,0,1,0,0,31421,26124),
(62321,'Are you ready?','Are you ready?',0,0,0,0,0,0,0,0,1,0,31422,31422,26124),
(62322,'Let us both do our best.','Let us both do our best.',0,0,0,0,0,0,0,0,1,0,31423,31423,26124),
(62323,'You fought excellently, just as I knew you could.','You fought excellently, just as I knew you could.',0,0,0,0,0,0,0,0,1,0,31424,31424,26124),
(62324,'You have grown much since we first met.','You have grown much since we first met.',0,0,0,0,0,0,0,0,1,0,31425,31425,26124),
(62325,'It would be my honor to join you in battle. Speak to me on the hill if you have need of me.','It would be my honor to join you in battle. Speak to me on the hill if you have need of me.',0,0,0,0,0,0,0,0,1,0,31426,31426,26124),
(62326,'[PH] How would you train a Fury Warrior?','[PH] How would you train a Fury Warrior?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62328,'I will rip apart every last slave in this valley. Your little uprising will be the death of you all!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(62329,'Thank you, friend.','Thank you, friend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62330,'We didn\'t see it coming...','We didn\'t see it coming...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62331,'I owe you my life.','I owe you my life.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62332,'You have my thanks.','You have my thanks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62333,'I am eternally grateful.','I am eternally grateful.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62334,'I\'m going to make a break for safety. Thank you.','I\'m going to make a break for safety. Thank you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62335,'I... thank you.','I... thank you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62336,'I will see you back at the pagoda. Thank you so much.','I will see you back at the pagoda. Thank you so much.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62337,'What... where am I?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62338,'What has happened here? The land has changed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62339,'How long have I been asleep?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62340,'|TInterface\\Icons\\ability_shaman_fortifyingwaters.blp:20|t%s is about to be healed by |cFFF00000|Hspell:117283|h[Cleansing Waters]|h|r! Move him!','|TInterface\\Icons\\ability_shaman_fortifyingwaters.blp:20|t%s is about to be healed by |cFFF00000|Hspell:117283|h[Cleansing Waters]|h|r! Move him!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62341,'|TInterface\\Icons\\ability_shaman_fortifyingwaters.blp:20|t%s is being healed by |cFFF00000|Hspell:117283|h[Cleansing Waters]|h|r! Dispel him!','|TInterface\\Icons\\ability_shaman_fortifyingwaters.blp:20|t%s is being healed by |cFFF00000|Hspell:117283|h[Cleansing Waters]|h|r! Dispel him!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62342,'I have seen many battles, healed many allies, cleansed many souls, and many enemies have fallen victim to my command.\n\nYou may feel safe inside these city walls but make no mistake, war plagues these lands like a pandemic and only the chosen few live to tell the tale.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62343,'I have much to ponder, $n. Get out there and make yourself useful.','',0,0,0,0,0,0,0,0,1,16965,0,0,26124),
(62344,'I\'m bored! Let\'s go hunt down some evildoers.','I\'m bored! Let\'s go hunt down some evildoers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62345,'I wanna set something on fire, already!','I wanna set something on fire, already!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62346,'I\'m training hard, can\'t you see?','I\'m training hard, can\'t you see?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62347,'Just say the word, and I\'ll be there to help.','Just say the word, and I\'ll be there to help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62348,'','Few can survive against the cold fingers of ice.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62349,'','Have you heard of the shadow dance? It is the dance you perform while in battle.$B$BIt is a dance with death.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62350,'','Some dance with great passion and enthusiasm, like Fei Li.$B$BOthers do not dance unless they are provoked, such as Yalia.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62351,'','The secret to the shadow dance is control.$B$BPrecision.$B$BAgility.$B$BGrace.$B$BNever a movement too many, and never too few.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62352,'','Every strike should deliver your final intent.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62353,'','I seek wisdom through meditation.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62354,'','Only through inner balance can we find peace within ourselves.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62355,'','With peaceful hearts, we feel no anger, no hatred, no doubt, and no fear.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62356,'','Our greatest enemies are ourselves.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62357,'','If you play the game, play to win.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62358,'My thanks, brave one.','My thanks, brave one.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(62359,'I thought I would fall before help came.\n\nThank you.','I thought I would fall before help came.\n\nThank you.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(62360,'Your prowess in battle humbles me. Thank you, stranger.','Your prowess in battle humbles me. Thank you, stranger.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(62361,'Greenstone Dojo owes you its gratitude.\n\nLet\'s drink when this is done!','Greenstone Dojo owes you its gratitude.\n\nLet\'s drink when this is done!',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(62362,'Many thanks... I couldn\'t have held out much longer.\n\nAlas, I\'m in no condition to go on.\n\nIf only our entire supply of Greenstone Brew hadn\'t been stolen!  I would\'ve concocted a draft of marvelous power for you...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62363,'Fishing poles are a crutch! A real fisher uses their hands.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62364,'I once caught a fish the size of three of your ancestors. Granted, it got away, but I caught it for all of a good minute.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62365,'Ever make a shark so mad it got out of the water and chased you on land?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62366,'Best bait for the biggest fish? Put a wedding ring on your hook.','',1,11,0,0,0,0,0,0,1,0,0,0,26124),
(62367,'No one knows what\'s on the bottom of the lagoon, except the folks who\'ve been down there. And the folks them folks talked to afterwards.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62368,'Ever tried boiled butter battered kracken legs? Best thing ever.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62369,'<He\'s sound asleep.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62370,'Greetings, friend. Can I get you a mug of anything?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62371,'','Have you been drinking well?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62372,'I guess you can stay here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62373,'Do you have to be so chippery?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62374,'Is your name really Stormstout?','Is your name really Stormstout?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62375,'What outbreak?  I am always like this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62376,'Do you have to stay here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62377,'Just leave your money in the coffer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62378,'Oh, it\'s just you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62379,'I bet you aren\'t even going to buy anything. Just like all the others.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62380,'I never should have opened this inn. It is just so depressing here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62381,'<Big Dan makes a combination of sleepy, fitful grunts and snorts.>$b$bYeah... Stormstout alright...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62382,'Have you seen anybody named Stormstout come through here?','Have you seen anybody named Stormstout come through here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62383,'Yes, a few of them. The biggest one, Han, last went out to fight at Kor\'vess.$b$bHaven\'t seen him in a few days, actually. I hope everything\'s alright...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62384,'Have you seen any Stormstouts here in the Brewgarden?','Have you seen any Stormstouts here in the Brewgarden?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62385,'','You mean other than Lazy Dan over there? Sure!$b$bI spent some time with Evie before she went hunting up north. Such a sweet girl.$b$bAnd of course, who could forget Mama Stormstout?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62386,'It is good to meet you, $n.','',0,0,0,0,0,0,2,0,1,18002,29740,0,26124),
(62387,'It is great to see you again, $n.','',0,0,0,0,0,0,66,0,1,18001,29741,0,26124),
(62388,'I would stay longer, but I need to go find out what has happened to the rest of the Stormstouts.','',0,0,0,0,0,0,1,0,1,0,29742,0,26124),
(62389,'I sincerely hope our paths cross again.','',0,0,0,0,0,0,1,0,1,0,29743,0,26124),
(62390,'Against your will, you begin to unleash an |cFFFF0000|Hspell:122398|h[Amber Explosion]|h|r!','Against your will, you begin to unleash an |cFFFF0000|Hspell:122398|h[Amber Explosion]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62391,'The Amber Monstrosity readies an |cFFFF0000|Hspell:122398|h[Amber Explosion]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62392,'They say your name was Evie.','',0,0,0,0,0,0,0,0,1,0,29730,0,26124),
(62393,'They say you were a sweet girl.','',0,0,0,0,0,0,0,0,1,0,29731,0,26124),
(62394,'I never knew you... but you were family.','',0,0,0,0,0,0,0,0,1,0,29732,0,26124),
(62395,'May your journey in the next world be filled with joy and beauty.','',0,0,0,0,0,0,0,0,1,0,29733,0,26124),
(62396,'Farewell, Evie Stormstout.','',0,0,0,0,0,0,0,0,1,0,29734,0,26124),
(62397,'She looked like Li Li.','',0,0,0,0,0,0,0,0,1,0,29735,0,26124),
(62398,'The nearby pools of amber begin to bubble violently!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62399,'Enough! You have wasted too much of my time already. I will not be distracted by such insignificant creatures.','',0,0,0,0,0,0,53,0,1,0,0,0,26124),
(62400,'My work will continue... elsewhere.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62401,'Alas, I\'m in no condition to go on. If only our entire supply of Greenstone Brew hadn\'t been stolen!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62402,'Feel the burn!','Feel the burn!',0,0,0,0,0,0,0,0,1,0,30705,30705,26124),
(62403,'Yes, finally! Time for some action.','Yes, finally! Time for some action.',0,0,0,0,0,0,0,0,1,0,30716,30716,26124),
(62404,'I won\'t let you down!','I won\'t let you down!',0,0,0,0,0,0,0,0,1,0,30717,30717,26124),
(62405,'Reporting for duty!','Reporting for duty!',0,0,0,0,0,0,0,0,1,0,30706,30706,26124),
(62407,'Let\'s light them up!','Let\'s light them up!',0,0,0,0,0,0,0,0,1,0,30707,30707,26124),
(62408,'Can\'t take the heat? Then get out of my way!','Can\'t take the heat? Then get out of my way!',0,0,0,0,0,0,0,0,1,0,30708,30708,26124),
(62409,'You won\'t get away with this!','You won\'t get away with this!',0,0,0,0,0,0,0,0,1,0,30709,30709,26124),
(62410,'Burn, baby, burn!','Burn, baby, burn!',0,0,0,0,0,0,0,0,1,0,30710,30710,26124),
(62411,'Now that is hot.','Now that is hot.',0,0,0,0,0,0,0,0,1,0,30711,30711,26124),
(62412,'We make a great team!','We make a great team!',0,0,0,0,0,0,0,0,1,0,30714,30714,26124),
(62413,'Is this hot enough for you?','Is this hot enough for you?',0,0,0,0,0,0,0,0,1,0,30713,30713,26124),
(62414,'Where shall we strike today?','Where shall we strike today?',0,0,0,0,0,0,0,0,1,0,31280,31280,26124),
(62415,'Another one... lost.','',0,0,0,0,0,0,0,0,1,0,29736,0,26124),
(62416,'He may never know the peace of returning to the earth... but at least he went out fighting.','',0,0,0,0,0,0,0,0,1,0,29737,0,26124),
(62417,'Come on.  There is nothing more to be done here.','',0,0,0,0,0,0,0,0,1,0,29738,0,26124),
(62418,'Together, we shall overcome our enemies.','Together, we shall overcome our enemies.',0,0,0,0,0,0,0,0,1,0,31281,31281,26124),
(62419,'Let me put my training to the test on the battlefield.','Let me put my training to the test on the battlefield.',0,0,0,0,0,0,0,0,1,0,31283,31283,26124),
(62420,'You chose well.','You chose well.',0,0,0,0,0,0,0,0,1,0,31284,31284,26124),
(62421,'Freeze!','Freeze!',0,0,0,0,0,0,0,0,1,0,31267,31267,26124),
(62422,'That should slow you down.','That should slow you down.',0,0,0,0,0,0,0,0,1,0,31268,31268,26124),
(62423,'I feel a little chill coming.','I feel a little chill coming.',0,0,0,0,0,0,0,0,1,0,31269,31269,26124),
(62424,'I am going on ahead.  They say Mama Stormstout is still out there somewhere.','',0,0,0,0,0,0,0,0,1,0,29739,0,26124),
(62425,'Revenge is a dish best served cold.','Revenge is a dish best served cold.',0,0,0,0,0,0,0,0,1,0,31278,31278,26124),
(62426,'You have been iced!','You have been iced!',0,0,0,0,0,0,0,0,1,0,31273,31273,26124),
(62427,'Keep your head cool.','Keep your head cool.',0,0,0,0,0,0,0,0,1,0,31276,31276,26124),
(62428,'Ready for a cold spell?','Ready for a cold spell?',0,0,0,0,0,0,0,0,1,0,31272,31272,26124),
(62429,'Don\'t get cold feet, now.','Don\'t get cold feet, now.',0,0,0,0,0,0,0,0,1,0,31277,31277,26124),
(62430,'Our enemies shall fall before us.','Our enemies shall fall before us.',0,0,0,0,0,0,0,0,1,0,31438,31438,26124),
(62431,'You lead, I will follow.','You lead, I will follow.',0,0,0,0,0,0,0,0,1,0,31439,31439,26124),
(62432,'Our duties await.','Our duties await.',0,0,0,0,0,0,0,0,1,0,31440,31440,26124),
(62433,'Our enemies underestimate the power of the light.','Our enemies underestimate the power of the light.',0,0,0,0,0,0,0,0,1,0,31441,31441,26124),
(62434,'I will protect you!','I will protect you!',0,0,0,0,0,0,0,0,1,0,31430,31430,26124),
(62435,'They\'ll have to get past me, first.','They\'ll have to get past me, first.',0,0,0,0,0,0,0,0,1,0,31431,31431,26124),
(62436,'Let the light protect us!','Let the light protect us!',0,0,0,0,0,0,0,0,1,0,31432,31432,26124),
(62437,'I will shield you from harm!','I will shield you from harm!',0,0,0,0,0,0,0,0,1,0,31433,31433,26124),
(62438,'Shadows, begone!','Shadows, begone!',0,0,0,0,0,0,0,0,1,0,31434,31434,26124),
(62439,'The light will prevail.','The light will prevail.',0,0,0,0,0,0,0,0,1,0,31435,31435,26124),
(62440,'We must endure.','We must endure.',0,0,0,0,0,0,0,0,1,0,31436,31436,26124),
(62441,'I will light the way.','I will light the way.',0,0,0,0,0,0,0,0,1,0,31437,31437,26124),
(62442,'','One order at a time please.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62443,'','I\'m brewing as fast as I can.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62444,'','You\'re in luck! We got a great new shipment in.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62445,'','Should try the special.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62446,'Fly with me, Wakener, and I will show you the way of the Wind-Reaver.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62447,'You think you can take me down in a pet battle?  Step right up and let\'s find out!','You think you can take me down in a pet battle?  Step right up and let\'s find out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62448,'Grant me your assistance, Wind-Reaver. [Klaxxi Enhancement]','Grant me your assistance, Wind-Reaver. [Klaxxi Enhancement]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62449,'Please fly me to the Clutches of Shek\'zeer','Please fly me to the Clutches of Shek\'zeer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62450,'Gather enough enemies, and I will strike from the sky.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62451,'I will drop you with force enough to decimate anyone nearby. Choose your landing carefully.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62452,'We are the extension of our Empress\'s will.','',0,0,0,0,0,0,0,0,1,0,29303,0,26124),
(62453,'Ours is but to serve in Her divine name.','',0,0,0,0,0,0,0,0,1,0,29304,0,26124),
(62454,'Never to question, nor to contemplate; we simply act.','',0,0,0,0,0,0,0,0,1,0,29305,0,26124),
(62455,'We fight, toil, and serve so that Her vision for us is made reality.','',0,0,0,0,0,0,0,0,1,0,29306,0,26124),
(62456,'Her happiness is our reward, her sorrow our failure.','',0,0,0,0,0,0,0,0,1,0,29307,0,26124),
(62457,'We will give our lives for the Empress without hesitation. She is the light, and without Her our lives will be lost to darkness.','',0,0,0,0,0,0,0,0,1,0,29308,0,26124),
(62458,'The chaff of the world tumbles across our doorstep, driven by fear; Her royal storm will whisk them away.','',0,0,0,0,0,0,0,0,1,0,29312,0,26124),
(62459,'They are but the waves crashing upon the mountain of Her divine will. They may rise again and again; but will accomplish nothing.','',0,0,0,0,0,0,0,0,1,0,29314,0,26124),
(62460,'The Divine challenges us to face these intruders.','',0,0,0,0,0,0,0,0,1,0,29316,0,26124),
(62461,'They were clearly unworthy of Her divine embrace.','',0,0,0,0,0,0,0,0,1,0,29313,0,26124),
(62462,'We are unfazed. We will stand firm.','',0,0,0,0,0,0,0,0,1,0,29315,0,26124),
(62463,'And so it falls to us, Her chosen voice.','',0,0,0,0,0,0,0,0,1,0,29317,0,26124),
(62464,'Stand close to the keg to catch the beer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62465,'The Divine chose us to give mortal voice to Her divine will. We are but the vessel that enacts Her will.','',0,0,0,0,0,0,0,0,1,0,29301,0,26124),
(62466,'The Divine will not suffer your taint here, outsider.','',0,0,0,0,0,0,0,0,1,0,29318,0,26124),
(62467,'Ours is but to serve; yours is but to die.','',0,0,0,0,0,0,0,0,1,0,29319,0,26124),
(62468,'Through the air we breathe, She strengthens our voice.','',0,0,0,0,0,0,0,0,1,0,29321,0,26124),
(62469,'Behold the voice of Her divine wrath.','',0,0,0,0,0,0,0,0,1,0,29320,0,26124),
(62470,'Our voice gives form to Her will.','',0,0,0,0,0,0,0,0,1,0,29323,0,26124),
(62471,'Her will is greater than us all. You will join us or you will perish.','',0,0,0,0,0,0,0,0,1,0,29322,0,26124),
(62472,'Her gifts are many, our gratitude immeasurable.','',0,0,0,0,0,0,0,0,1,0,29309,0,26124),
(62473,'She tests us. We will not disappoint Her.','',0,0,0,0,0,0,0,0,1,0,29310,0,26124),
(62474,'We are as unwavering as the amber that shapes our halls. With Her might we will vanquish all who dare intrude upon Her divine home.','',0,0,0,0,0,0,0,0,1,0,29311,0,26124),
(62475,'We will not give in to the despair of the dark void. If Her will for us is to perish, then it shall be so.','',0,0,0,0,0,0,0,0,1,0,29302,0,26124),
(62476,'Maybe you should talk to her.','Maybe you should talk to her.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62477,'Aysa? I don\'t know what to say to her. Should I tell her she\'s gorgeous, or would she find that creepy? Maybe I could tell her I admire her poise - but then she might think I don\'t have any personality!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62478,'You know, they say these mountains are full of yeti.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62479,'Oh... well.. you know... \"they\".','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62480,'Hozen are on the ravage again. I can feel it in my knees.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62481,'That\'s my right knee. My left knee feels hozen ravages.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62482,'Has there been any word from Kota Basecamp?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62483,'I heard the Burlap Outpost got destroyed by hozen.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62484,'I heard the yaungol have taken over most of the farmlands in the south.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62485,'Sounds like the Muskpaw Ranch was hit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62486,'Yaungol.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62487,'I haven\'t seen any Shado-Pan lately.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62488,'Uhh...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62489,'I heard the yaungol made it through the Pandaren Wall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62490,'Tell that to the farmer that told me. Poor guy lost all his crops to the invaders.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62491,'You hear, some of the grummles are refusing to go up Mount Neverest?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62492,'I still remember when I used to guard the Burlap Trail.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62493,'Hey! I was a Shado-Pan once.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62494,'...before.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62495,'I thought you only felt weather in your knees.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62496,'No Kota Kafa? How am I going to wake up in the morning?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62497,'You are heartless. What about the grummles?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62498,'Know what a yak is?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62499,'Imagine one of those walking around on two feet, only angrier.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62500,'I hope they made it out all right. Ol\' Muskpaw might be rough around the edges but he was always the decent sort.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62501,'They got recalled to Serpent\'s Spine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62502,'That\'s impossible. Nothing gets through the wall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62503,'Superstitious or not, you won\'t find me exploring some place a grummle is afraid to travel.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62504,'Was that before or after you built the wall with your own two paws?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62505,'','Who says that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62506,'','No. And no kafa either. Dark days are coming.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62507,'','Hmm. I never really liked that place. The outhouses were always dirty.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62508,'','Heartless? Is it too much to ask for a clean outhouse?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62509,'','What?! Don\'t give me that look!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62510,'','What\'s a yaungol?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62511,'','Of course.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62512,'','Hit by what? Sprites?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62513,'','So who is protecting the Burlap Trail?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62514,'','I\'m sure they are just being overly superstitious.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62515,'','Drinking is not guarding.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62516,'...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62517,'<Han is encased in a tomb of amber.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62518,'<Pour some of the Dreadbrew onto Han\'s amber. Just to see what happens.>','<Pour some of the Dreadbrew onto Han\'s amber. Just to see what happens.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62519,'AAAAAHHHHH!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(62520,'What happened? Last I remember I was...','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(62521,'Ugh, what did you pour on me? It\'s disgusting!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(62522,'Gotta calm down now... a little confused... just need to focus.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62523,'W-whoah... what\'s that thing? Do you want to fight!? Why am I so dizzy? I\'m going to... going to...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62524,'','Sapmaster... look at this scroll!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(62525,'','It describes a way to stop the mantid. A way to stop the sha!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(62526,'Let me see that!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(62527,'No, my student, look at these words here: \"vessel\", \"quench\", \"recipe\"...','',0,0,0,0,0,0,483,0,1,0,0,0,26124),
(62528,'This is a beer recipe!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62529,'Yeah!! BEER!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(62530,'','You are wrong, teacher.',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(62531,'','$p! You\'ll help me stop the mantid?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(62532,'Ignore her, $p. Help us brew this beer.','',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(62533,'Yeah!! BEEEEEER!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(62534,'|TInterface\\Icons\\spell_shaman_earthquake.blp:20|t Garalon detects $n under him and begins to cast |cFFFF0000|Hspell:122774|h[Crush]|h|r!','|TInterface\\Icons\\spell_shaman_earthquake.blp:20|t Garalon detects $n under him and begins to cast |cFFFF0000|Hspell:122774|h[Crush]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62535,'|TInterface\\Icons\\spell_shaman_earthquake.blp:20|t Garalon senses the passage of Pheromones and begins to cast |cFFFF0000|Hspell:122774|h[Crush]|h|r!','|TInterface\\Icons\\spell_shaman_earthquake.blp:20|t Garalon senses the passage of Pheromones and begins to cast |cFFFF0000|Hspell:122774|h[Crush]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62536,'Come on, Olon! Brew-ty calls!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(62537,'YEAH! BEEEEER!!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(62538,'','Where are you two going?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(62539,'Nowhere.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(62540,'Rikkitun Village!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(62541,'','Rikkitun... that\'s IT!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(62542,'','\"Incantations fae and primal\"... that must refer to the Rikkitun sprites.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(62543,'','I\'m going too! See you there, $p.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(62544,'You seek to challenge the infamous Tenwu of the Red Smoke? Come friend, let us see what you have got!','',0,0,0,0,0,0,1,0,1,0,28173,0,26124),
(62545,'Hahahah, I do not think you know what you are getting into...','',0,0,0,0,0,0,1,0,1,0,28174,0,26124),
(62546,'Do not worry, I will go easy on you.','',0,0,0,0,0,0,1,0,1,0,28175,0,26124),
(62547,'Not bad, not bad... but we are not done yet!','',0,0,0,0,0,0,1,0,1,0,28176,0,26124),
(62548,'Well then! It seems all those muscles are not just for show!','',0,0,0,0,0,0,1,0,1,0,28177,0,26124),
(62549,'You have certainly earned my respect. No easy feat, my friend!','',0,0,0,0,0,0,1,0,1,0,28178,0,26124),
(62550,'Oh ho ho, you and I are going to have a LOT of fun together!','',0,0,0,0,0,0,1,0,1,0,28179,0,26124),
(62551,'Well, that was fun, wasn\'t it?','',11,0,0,0,0,0,0,0,1,0,31497,0,26124),
(62552,'Tearing Page','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62553,'Collecting Supplies','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62554,'So much emotion has been realeased from the tombs. So much anger and fear...','',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(62555,'Theses tombs hold many secrets, $n.','',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(62556,'Many of the Mogu emperors buried their servants with them trapping their spirits in servitude for eternity.','',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(62557,'This places chills me to my core, $c.','',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(62558,'Spiritbinding is a brutal practice. Depriving the dead of their eternal peace is an unspeakable cruelty.','',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(62559,'This valley is proof that our nightmares can become reality.','',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(62560,'Create Rubbing','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62561,'The amber sustained me as I slept, but I felt its powers drain over time.$B$BIf you had not awakened me when you did, I fear I would have soon slipped into eternal sleep.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62562,'Grant me your assistance, Prime. [Klaxxi Augmentation]','Grant me your assistance, Prime. [Klaxxi Augmentation]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62563,'Grant me your assistance, Xaril.  [Klaxxi Enhancement]','Grant me your assistance, Xaril.  [Klaxxi Enhancement]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62564,'Grant me your assistance, Dissector. [Klaxxi Enhancement]','Grant me your assistance, Dissector. [Klaxxi Enhancement]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62565,'Grant me your assistance, Bloodseeker. [Klaxxi Augmentation]','Grant me your assistance, Bloodseeker. [Klaxxi Augmentation]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62566,'PH','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62567,'','I... wah... where? What is going on?',0,0,0,0,0,0,6,0,1,0,0,30218,26124),
(62568,'You were being mind-controlled by some sort of malevolent ancient insect creature.','',0,0,0,0,0,0,1,0,1,0,29763,0,26124),
(62569,'','Oh that. Bah, I\'ve been through worse. And who exactly are you?',0,0,0,0,0,0,1,0,1,0,0,30219,26124),
(62570,'I am Chen Stormstout. From the Wandering Isle.','',0,0,0,0,0,0,2,0,1,0,29764,0,26124),
(62571,'','STORMSTOUT? No. You\'re foolin\'. Really? A Wandering Isle Stormstout, here, on Pandaria! Where\'s the rest of the family?',0,0,0,0,0,0,4,0,1,0,0,30220,26124),
(62572,'I\'ll explain on the way back to the Sapmasters.','',0,0,0,0,0,0,1,0,1,0,29765,0,26124),
(62573,'There! The Klaxxi! Hold that crystal together... don\'t let it escape!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62574,'Freedom...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62575,'For eight hundred and seventy-seven years, I waited in that crystal... watching shadows pass through the cracks, counting decades.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62576,'Now, I am needed elsewhere.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62577,'Wait till you see what I have for you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62578,'A wave of |cFFB600B8Sik\'thik Demolishers|r joins the battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62579,'%s begins to approach the platform!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62580,'Hmmm... I have a crazy idea that just might work, but we\'ll need your help heroes!','',0,0,0,0,0,0,273,0,1,0,31507,0,26124),
(62581,'Let\'s give these mantid a taste of their own medicine!','',0,0,0,0,0,0,5,0,1,0,31508,0,26124),
(62582,'Li and Lo, get the sap into position!','',0,0,0,0,0,0,397,0,1,0,31509,0,26124),
(62583,'Let\'s get this party started, shall we?','',0,0,0,0,0,0,6,0,1,0,31510,0,26124),
(62584,'Bring it, uglies!','',0,0,0,0,0,0,22,0,1,0,31513,0,26124),
(62585,'|TInterface\\Icons\\spell_holy_surgeoflight.blp:20|t%s casts |cFFFF0000|Hspell:122789|h[Sunbeam]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62586,'Swarmers are coming up the ramp -- use the sap to slow them down!','',0,0,0,0,0,0,25,0,1,0,31511,0,26124),
(62587,'Demolishers, get in there!  Leave nothing but a pile of ash!','',0,0,0,0,0,0,0,0,1,0,30266,0,26124),
(62588,'Warriors, trample these weaklings!  Crush them!','',0,0,0,0,0,0,0,0,1,0,30267,0,26124),
(62589,'Everyone! Send everything! Slaughter these cowards, they are making us look like fools!','',0,0,0,0,0,0,0,0,1,0,30268,0,26124),
(62590,'Come.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62591,'%s summons an |cFFFFFFFFEmbodied Terror|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62592,'You are truly welcomed to Rikkitun Village, outsider.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62593,'The forked blade is ready, and we have given our gift. Please perform your incantation.','The forked blade is ready, and we have given our gift. Please perform your incantation.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62594,'It is done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62595,'Hmm...','',0,0,0,0,0,0,7,0,1,0,0,0,26124),
(62596,'Yeah. This is pretty horrible.','',0,0,0,0,0,0,7,0,1,0,0,0,26124),
(62597,'I think I\'ll call it... Dreadbrew. You want to try some, Lya?','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(62598,'','No thank you! I think we\'ve already proven that this wasn\'t a beer recipe.',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(62599,'Very well. How about you, Olon?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(62600,'YEAH! BEEEEEER!!!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(62601,'Thank you for your help, $p. We may not have made the best brew, but we had quite an adventure.','',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(62602,'Feel free to take some brew from this keg whenever you\'re feeling adventurous.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62603,'Ha! You think you\'re ready to take me on?','Ha! You think you\'re ready to take me on?',0,0,0,0,0,0,0,0,1,0,30649,30649,26124),
(62604,'Let\'s see if you\'re still standing after this.','Let\'s see if you\'re still standing after this.',0,0,0,0,0,0,0,0,1,0,30650,30650,26124),
(62605,'','Yeah? What\'s up?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62606,'I would like you to come with me today.','I would like you to come with me today.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62607,'I\'m here to challenge you!','I\'m here to challenge you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62608,'','What, you change your mind? I understand. I wouldn\'t want to fight me, either.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62609,'Let\'s do this.','Let\'s do this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62610,'Come at me!','Come at me!',0,0,0,0,0,0,25,0,1,0,30651,30651,26124),
(62611,'Come on, is that all you\'ve got?','Come on, is that all you\'ve got?',0,0,0,0,0,0,0,0,1,0,30652,30652,26124),
(62612,'You can do better than that!','You can do better than that!',0,0,0,0,0,0,0,0,1,0,30653,30653,26124),
(62613,'You\'re tougher than you look.','You\'re tougher than you look.',0,0,0,0,0,0,0,0,1,0,30654,30654,26124),
(62614,'I admit... that was some impressive fighting.','I admit... that was some impressive fighting.',0,0,0,0,0,0,0,0,1,0,30655,30655,26124),
(62615,'Well, now that we\'ve fought, it\'s settled. We\'re friends!','Well, now that we\'ve fought, it\'s settled. We\'re friends!',0,0,0,0,0,0,0,0,1,0,30657,30657,26124),
(62616,'I\'d love to fight with you again whenever you need me.','I\'d love to fight with you again whenever you need me.',0,0,0,0,0,0,0,0,1,0,30656,30656,26124),
(62617,'Hmm... If I mix some pale with a stou...\n\nOh, yes. Hello!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62618,'I would like you to come with me today.','I would like you to come with me today.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62619,'I\'m here to challenge you!','I\'m here to challenge you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62620,'I have a different question.','I have a different question.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62621,'Ah, a visitor! This is an incredible time for Pandaria - the mists have parted, and we rejoin the world. You come in peace, I hope?','',0,0,0,0,0,0,0,0,1,0,30064,0,26124),
(62622,'A wave of |cFF00dc29Sik\'thik Swarmers|r and a |cFF815d18Sik\'thik Warrior|r joins the battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62623,'A wave of |cFFB600B8Sik\'thik Demolishers|r and a |cFF815d18Sik\'thik Warrior|r joins the battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62624,'My, my. Hello, stranger! Sampled my dream brew, have we? Its visions are hard to interpret - half truth, half illusion. Who\'s to say which is which?','',0,0,0,0,0,0,1,0,7,0,31784,0,26124),
(62625,'Walk with me, and let us learn from one another. Are your people fond of gardening?','',0,0,0,0,0,0,0,0,1,0,31785,0,26124),
(62626,'They are holding us off, bring in the air support!','',0,0,0,0,0,0,0,0,1,0,30270,0,26124),
(62627,'Amberwing, get in there! Lay siege to the holdouts!','',0,0,0,0,0,0,0,0,1,0,30271,0,26124),
(62628,'%s hands you a pair of shears and motions toward a large, unkempt tree.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62629,'Feel the darkness within!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(62630,'That\'s it, delicate cuts. Let the tree decide.','',0,0,0,0,0,0,1,0,1,0,31786,0,26124),
(62631,'Some take their knives and lop away anything that displeases them, but this would kill the entire tree. That is not the Pandaren way.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(62632,'Well now! Who knew such a beautiful thing was hiding here? I can see that this \"Alliance\" of yours cuts with precision in order to change the world around you. Interesting.','',0,0,0,0,0,0,4,0,1,0,31787,0,26124),
(62633,'I am a \"Lorewalker\" - a historian of sorts for my people. My instrument is the spoken word.','',0,0,0,0,0,0,0,0,1,0,31788,0,26124),
(62634,'Sadly, my - ah - artistic talents are somewhat lacking. What would YOU do to decorate my wall here?','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(62635,'Oh, yeah. I remember you. Let\'s see what you\'ve learned.','',0,0,0,0,0,0,0,0,1,0,29797,0,26124),
(62636,'A challenge, huh? Let\'s see what you\'ve got.','',0,0,0,0,0,0,0,0,1,0,29799,0,26124),
(62637,'I hope your moves aren\'t too predictable.','',0,0,0,0,0,0,0,0,1,0,29801,0,26124),
(62638,'Oh, you\'re gonna try that one? Come on!','',0,0,0,0,0,0,0,0,1,0,29803,0,26124),
(62639,'What\'s wrong, did you forget how to fight?','',0,0,0,0,0,0,0,0,1,0,29804,0,26124),
(62640,'Okay... that was pretty good.','',0,0,0,0,0,0,0,0,1,0,29806,0,26124),
(62641,'Wow! I haven\'t seen that one before. I guess you\'re pretty good after all.','',0,0,0,0,0,0,0,0,1,0,29808,0,26124),
(62642,'Sure, I\'ll go with you. Gotta study up on your moves!','',0,0,0,0,0,0,0,0,1,0,29810,0,26124),
(62643,'Whenever you need me, I\'ll be here.','',0,0,0,0,0,0,0,0,1,0,29811,0,26124),
(62644,'Well? Let\'s go! I\'m eager to see what you\'ve got.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62645,'All right, let\'s do this!','All right, let\'s do this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62646,'Don\'t say a word. Allow your image to speak. We pandaren prize beauty, and we find it all around us:','',0,0,0,0,0,0,404,0,1,0,31789,0,26124),
(62647,'In the curves of a tree, the colors of a sunrise, even in the perfect physical form of a warrior\'s exquisite swordwork.','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(62648,'The Lorewalker\'s art lacks both subtlety and technical expertise. Perhaps you can do better?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62649,'<Paint a Portrait of Prince Anduin.>','<Paint a Portrait of Prince Anduin.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62650,'Awaken my pets! Feast on their flesh!','',15,25,0,2,4,0,0,0,1,0,0,0,26124),
(62651,'I will see to your demise myself!','',15,25,0,2,4,0,0,0,1,0,0,0,26124),
(62652,'Who is this? A prince, you say? A child. Ah, but he has had no childhood - you can see it in his eyes.','',0,0,0,0,0,0,273,0,1,0,31790,0,26124),
(62653,'I can see your people expect great things, even from your young.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62654,'My errands are almost complete. Come, visit my collection of exotic birds. You may have the honor of feeding them.','',0,0,0,0,0,0,0,0,1,0,31794,0,26124),
(62655,'This amber is ours, trespasser! Amber not for the mantid!','',0,0,0,0,0,0,0,0,1,17047,0,0,26124),
(62656,'This paragon is for the Empress! You shall not have it!','',0,0,0,0,0,0,0,0,1,17047,0,0,26124),
(62657,'I am known as a Lorewalker - a kind of historian for my people.','',0,0,0,0,0,0,0,0,1,0,30082,0,26124),
(62658,'The Klaxxi sent you to oppose the Swarm? Ah, how the mighty have fallen. Come, little fly. Take the paragon, if you can!','',0,0,0,0,0,0,0,0,1,17047,0,0,26124),
(62659,'Follow me, traveler. Let us get to know one another better.','',0,0,0,0,0,0,0,0,1,0,30081,0,26124),
(62660,'Think you can take me in a pet battle?  Let\'s fight!','Think you can take me in a pet battle?  Let\'s fight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62661,'Let\'s rumble!','Let\'s rumble!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62662,'As such, knowledge is my armor, and I carry a quill in place of a sword.','',0,0,0,0,0,0,396,0,1,0,30083,0,26124),
(62663,'Much of Pandaria\'s past is shrouded in mystery, even to us.','',0,0,0,0,0,0,396,0,1,0,30084,0,26124),
(62664,'This demands a tireless search for ancient clues, and the wisdom to interpret them.','',0,0,0,0,0,0,396,0,1,0,30086,0,26124),
(62665,'Ahh, here we are. Be careful - I\'ve had trouble in this area before.','',0,0,0,0,0,0,396,0,1,0,30087,0,26124),
(62666,'You have bested me. Seek Master Snowdrift in the Dojo atop the mountain if you wish to proceed.','You have bested me. Seek Master Snowdrift in the Dojo atop the mountain if you wish to proceed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(62667,'%s casts |cFFFF0000|Hspell:123244|h[Hide]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62668,'At... last... my time has come.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62669,'There is much to do. But first, Wakener... help me recover my strength.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62670,'A Lorewalker\'s sworn duty is to rediscover our history - to rend that shroud, piece by piece.','',0,0,0,0,0,0,396,0,1,0,30085,0,26124),
(62671,'%s casts |cFFFF0000|Hspell:123461|h[Get Away!]|h|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62672,'It has been many years since I have seen this place, Wakener. Much has changed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62673,'We must work quickly to get the beacon operational.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62674,'Ah yes. One does not forget the taste of amber.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62675,'Do my eyes deceive me? What is that wall in the distance?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62676,'Back when the world was still young, the first kypari trees bloomed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62677,'From the trees, the amber flowed and nurtured us. Kyparite, we called it, the lifeblood of the earth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62678,'It healed our wounds and made us bold. It tasted like sweetness and fire, and gave us the strength to conquer all the lesser races.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62679,'Hurry, Wakener. It is taking all my strength not to rip you to pieces.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62680,'Kalimdor is much changed. I do not recognize this place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62681,'Have the ancient towers fallen? I can hear nothing from my brethren.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62682,'Why were you sent to awaken me? Why did the Klaxxi not send one of their own?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62683,'I will now peform the sacred ritual of my people.','',0,0,0,0,0,0,1,168,1,0,0,0,26124),
(62684,'Nearby sha creatures have the shade I\'m looking for... though you might find a little bit on the nearby wildlife. Good luck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62685,'%s animates several elementals to |cFFFF0000|Hspell:123250|h[Protect]|h|r her!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62686,'Keep your eyes open, friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62687,'Are you hurt? Do you need something?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62688,'Stay cautious. The enemy can attack at any time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62689,'More fighting, less talking.','More fighting, less talking.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62690,'Yeah? What do you want?','Yeah? What do you want?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62691,'Let\'s go!','Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62692,'You should have seen the mantid empire in my day, Wakener. Our vesses stretched as far as the eye could see.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62693,'When we heard call of the ravage, we darkened the very skies with our numbers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62694,'Before they laid me to sleep in amber, I heard a million voices of the swarm shouting my name. Now, I hear only silence.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62695,'What are these strange creatures?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62696,'Where do they take the amber? where are the forges? Where are the ambersmiths?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62697,'It seems that there are others who see the value of amber.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62698,'WHHARRGLBLRRGLBRGL','',0,0,0,0,0,0,402,0,1,0,0,0,26124),
(62699,'A Lorewalker\'s work is ponderous, traveler.$b$bOne must draw upon a wealth of knowledge to see things as they truly are.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(62700,'Eh? Where am I? What\'s happening?$B$BI\'m sorry, I must have drifted off.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62701,'About... face!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62702,'Healing brew incoming! Come and get it!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(62703,'This stone tells of a great hozen warlord who lived here twenty-five hundred years ago. What are your leaders like? Poets? Warriors? I should like to meet them someday.','',0,0,0,0,0,0,6,0,1,0,30072,0,26124),
(62704,'Die, softskin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62705,'Prepare yourself! Saurok raiders approach!','',0,0,0,0,0,0,430,0,1,0,30073,0,26124),
(62706,'Many were the threats to our race after the usurpers remade the world. Narrow was the path ahead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62707,'Our ancestors looked far into the future to witness his rebirth, but instead, we saw our race troubled by many dangers. Dangers that, left unchecked, could destroy us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62708,'It was I who suggested our greatest warriors be cast in amber to sleep, to be awakened at the swarm\'s greatest times of need.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62709,'It was the sleep from which one could never awake. A great risk. A great sacrifice. But necessary.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62710,'Thus, I was the first Paragon. This is why, I am the Prime.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62711,'And now, the Klaxxi call us to battle. Now, I am awakened.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62712,'The saurok have plagued this land since the time of the mogu. They are impossible to negotiate with. But we never stop trying! We fight them only as a last resort.','',0,0,0,0,0,0,396,0,1,0,30074,0,26124),
(62713,'Lei Shi\'s reflection ripples ominously.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62714,'Her reflection ripples a second time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62715,'%s appears!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62716,'Thank you for your help - these notes are important to my studies. Your people value knowledge too, yes? I assume so, only because you arrived on a great airship.','',0,0,0,0,0,0,396,0,1,0,30075,0,26124),
(62717,'I have everything I need. Quickly, let\'s move on before they return!','',0,0,0,0,0,0,396,0,1,0,30076,0,26124),
(62718,'Enough about pandaren history. Let\'s talk about your people, traveler.','',0,0,0,0,0,0,396,0,1,0,31772,0,26124),
(62719,'I\'ve learned a great deal already just by watching you in action. You fight with the fervor of youth but the experience of an old veteran. You\'ve seen a lifetime of warfare, haven\'t you?','',0,0,0,0,0,0,396,0,1,0,31773,0,26124),
(62720,'Yes, it is true! This IS Kypari Zar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62721,'But why do I sense no life emanating from within? Why do I sense no amber sap running through its veins?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62722,'I must examine the tree. Guard me while I perform this task, Wakener!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62723,'It is done. Kypari Zar... cries out in unbearable agony.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62724,'','Interested in renting a kite?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62725,'I\'d like to borrow one of Farmer Fung\'s kites.','I\'d like to borrow one of Farmer Fung\'s kites.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62726,'','Oh, sure!$b$bFarmer Fung said that, if you want, you can use one of his FANCY kites. Apparently he\'s taken a liking to you.',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(62727,'I\'ll take the standard red kite.','I\'ll take the standard red kite.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62728,'I\'ll take the high-altitude blue kite.','I\'ll take the high-altitude blue kite.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62729,'I\'ll take the swift yellow kite.','I\'ll take the swift yellow kite.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62730,'I\'ll take the dancing green kite.','I\'ll take the dancing green kite.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62731,'Ah, this is a special place. My great grandparents called this part of the forest their home. Come, this will take only a moment.','',0,0,0,0,0,0,396,0,1,0,31774,0,26124),
(62732,'Another ancient place, this one made even more special in recent years.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(62733,'Harvesting Amber','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62734,'Li and Lo, go look after our friends down below.','',25,0,0,0,0,0,0,0,1,0,31498,0,26124),
(62735,'Ah, this gate is locked, but I think I have something that\'ll open it.','',0,0,0,0,0,0,0,0,1,0,31499,0,26124),
(62736,'Let me see here... thirty second fuse...','',0,0,0,0,0,0,0,0,1,0,31500,0,26124),
(62737,'Whoops, did I say thirty? I meant three.','',0,0,0,0,0,0,0,0,1,0,31501,0,26124),
(62738,'Go, hurry! You must stop the siege!','',5,0,0,0,0,0,0,0,1,0,31502,0,26124),
(62739,'I feel strong enough to continue on my own, $n. I must report this... sha... presence to the Council immediately. If we meet again, it shall be at Klaxxi\'vess.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62740,'%s emerges from her protective bubble.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62741,'I... need... sustenance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62742,'I have been asleep far longer than I thought possible. So much has changed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62743,'When I awoke, the Klaxxi told me of you. It seems you are not without your uses.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62744,'As soon as I awakened, the Klaxxi sensed my presence and relayed as much as they dared.$B$BThey confirmed my own suspicions. The Empress is no longer fit to rule the empire. She must be... cleansed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62745,'My duty is to the Klaxxi Council. Whatever they ask of me, I must obey.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62746,'I no longer recognize this world. Everything is unfamiliar, yet I have a great duty to fulfill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62747,'It worked, just as I knew it would!$B$BBut even so, the effects of the stasis have surpassed even my original calculations.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62748,'All across the wastes, the kypari are dying.$B$BI fear that this... sha... is the cause.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62749,'One healthy kypari remains, far to the southwest, but the Empress\'s slaves are destroying it as we speak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62750,'If we let the kypari die out, then we will have lost a great treasure.$B$BThe amber is life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62751,'Not while Leza is in labor. We must wait.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62752,'What part of our journey gave you the impression of choice?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62753,'This was not supposed to be a combat mission.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62754,'Dezco, this is a weapon of the horde. You should unleash it on the Alliance.','',1,0,0,0,0,0,0,0,1,13643,0,0,26124),
(62755,'And the Alliance wasn\'t supposed follow the same visions your wife was having.','',1,0,0,0,0,0,0,0,1,13643,0,0,26124),
(62756,'Dezco, we should keep pressing westward. We are vulnerable here.','',1,0,0,0,0,0,0,0,1,13643,0,0,26124),
(62757,'I appreciate that your wife led us here, old friend, but she chose a poor time to have a child.','',1,0,0,0,0,0,0,0,1,13643,0,0,26124),
(62758,'I feel better.$B$BIt will take me some time to regain my full strength, but I am strong enough to fight, at least.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62759,'You are lucky you were able to find amber and flesh nearby, Wakener.$B$BIf there was none to be found, you would have been my sustenance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62760,'We Pandaren do not worship our ancestors, but we revere their memory and the wisdom that they have passed on to us.','',0,0,0,0,0,0,396,0,1,0,31776,0,26124),
(62761,'It was my Great Grandfather who first told me the tale of the mogu that I recently shared with you.','',0,0,0,0,0,0,396,0,1,0,31775,0,26124),
(62762,'Despite your obvious weaknesses, I have grown fond of you, Wakener. I was made a paragon because of my prowess on the battlefield. It was said that I could cheat death itself. I shall lend you this very ability, Painkiller, to protect you during the task ahead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62763,'Interested in catching some rare pets?','Interested in catching some rare pets?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62764,'You look like someone that might be interested in some rare pets?','You look like someone that might be interested in some rare pets?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62765,'Have you ever seen such a beautiful rabbit?  I can help you catch your own!','Have you ever seen such a beautiful rabbit?  I can help you catch your own!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(62766,'This is the old Imperial Road. They say the mogu empire used to bring their prisoners here for torture.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62767,'What are they digging up? I\'ve never seen mogu use tools and weapons like those before.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62768,'I don\'t think these mogu are from here. They seem to be scavenging old relics, not digging in or pillaging.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62769,'What is it? I am busy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62770,'Will this suffice?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62771,'Put it with the others for the Lord Reclaimer\'s inspection.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62772,'But, I am a master fighter, with extensive knowledge of this world\'s flora and fauna. Surely I can help?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62773,'No - this is our problem, we must deal with it ourselves.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62774,'But, here comes another survivor. Seems good with their hands... maybe you can teach them your fighting skills?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62775,'Of course! It would be an honor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62776,'What the...?','',0,0,0,0,0,0,0,0,7,0,32476,0,26124),
(62777,'What was that noise?','',0,0,0,0,0,0,0,0,7,0,32477,0,26124),
(62778,'It came from the wall, sir.','',0,0,0,0,0,0,0,0,7,0,32475,0,26124),
(62779,'I know where it CAME from, what was it?','',0,0,0,0,0,0,0,0,7,0,32478,0,26124),
(62780,'You will make fine slaves for the empire.','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(62781,'No... no...','',0,0,0,0,0,0,0,0,7,0,32479,0,26124),
(62782,'Men! To arms!','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(62783,'You three! $n! Assist Captain Oakenshield in the front!','',0,0,0,0,0,0,0,0,7,0,32480,0,26124),
(62784,'Greentill! Blacksoil! Cover our left flank! I don\'t want any surprises!','',0,0,0,0,0,0,0,0,7,0,32481,0,26124),
(62785,'Leven, take the right side! You\'re on your own!','',0,0,0,0,0,0,0,0,7,0,32482,0,26124),
(62786,'Everyone else! If you can hold a weapon, protect the village! Don\'t let them past this line! You...','',0,0,0,0,0,0,0,0,7,0,32483,0,26124),
(62787,'Your kind will soon learn who their real masters are.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62788,'You will learn your place.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62789,'We don\'t stand a chance...','',0,0,0,0,0,0,0,0,7,0,32485,0,26124),
(62790,'Everyone, fall back! FALL BA-','',0,0,0,0,0,0,0,0,7,0,32486,0,26124),
(62791,'Rrrraaaa!!!','',0,0,0,0,0,0,0,0,7,0,29747,0,26124),
(62792,'Who are you?','',0,0,0,0,0,0,0,0,7,0,32487,0,26124),
(62793,'Did you think you could challenge the might of the mogu?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62794,'Does it matter who we are? We are here to help you.','',0,0,0,0,0,0,0,0,7,0,29748,0,26124),
(62795,'Hey! Gimme one o\' them pitchforks!','',0,0,0,0,0,0,0,0,7,0,32504,0,26124),
(62796,'You were surrendering? Why? Because these invaders can break down a wall?','',0,0,0,0,0,0,0,0,7,0,29749,0,26124),
(62797,'You have got another wall... and it\'s made up of the people who call this place HOME.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(62798,'Any one of us would lay down our life to protect this land.','',0,0,0,0,0,0,0,0,7,0,29750,0,26124),
(62799,'This land, it belongs to us...','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(62800,'It belongs to our ancestors...','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(62801,'It belongs to our children.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(62802,'And we are not about to let that change.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(62803,'I\'m just walking along, cataloging the local wildlife here in Azuremist, when suddenly...\n\nBAM! <Mojo mimicks an explosion with his hands.>\n\nI don\'t think I\'ve ever heard an explosion that loud in my life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62804,'The Empire rises again!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62805,'For the Empire!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62806,'Trespasser!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62807,'These lands belong to the Thunder King.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62808,'You dare challenge the Empire?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62809,'We return!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62810,'The pandaren are not hear to save you now.','',1,0,0,0,0,0,0,0,1,13211,0,0,26124),
(62811,'Your age of this world has passed.','',1,0,0,0,0,0,0,0,1,13211,0,0,26124),
(62812,'For the Lord Reclaimer!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62813,'Cower before me, supplicant!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62814,'Beg for mercy.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62815,'Your life is forfeit.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62816,'You dare stand in our way?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62817,'Your kind will be made to serve.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62818,'Behold the wrath of the new Empire!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62819,'Kzzsst! Paragon! Klaxxi infiltrator!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62820,'Guard the tower!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62821,'You seek your own death, trespasser!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62822,'Stealer of signals! This is the Empress\'s tower!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62823,'I would very much like to hear about your ancestors, stranger. Light the incense and let\'s reflect on where you came from, hm?','',0,0,0,0,0,0,396,0,1,0,31777,0,26124),
(62824,'Astounding! A lineage of great warriors... From a different world, no less! It is rare for a Pandaren to leave his or her homeland. You are rightfully proud of who you are.','',0,0,0,0,0,0,396,0,1,7274,31797,0,26124),
(62825,'How fascinating. I thought you looked sickly - but now I see the truth. Your people suffer under the weight of a terrible darkness. What strength you must have, simply to press onward!','',0,0,0,0,0,0,396,0,1,7275,31798,0,26124),
(62826,'Look at that. Your people revere their ancestors as well. And you cherish the land. We have much in common! Ah, but I see that your ancestors were nomads, whereas we Pandaren prefer the comforts of hearth and home. You\'ll find few travellers among us.','',0,0,0,0,0,0,396,0,1,7273,31799,0,26124),
(62827,'Oh my - as I suspected. Your ancestry dates back to the dawn of the world. Great were the ancient empires of the trolls. I see a spark in your eyes, a powerful will - you wish to be great again, yes?','',0,0,0,0,0,0,396,0,1,5579,31856,0,26124),
(62828,'Ah, noble is your lineage! Your people possess GREAT power, and all the terrible burdens that come with it. Equally great has been your suffering. Now I see why you call yourself  \'Blood\' elves.','',0,0,0,0,0,0,396,0,1,5576,31800,0,26124),
(62829,'Well... that\'s interesting. Most of your ancestors died in a fire. Oh my. Your people put themselves at great personal risk in the name of progress! I wish more Pandaren had your initiative.','',0,0,0,0,0,0,396,0,1,10103,31801,0,26124),
(62830,'Ah, but you\'re no stranger to your past! A Pandaren from the Wandering Isle. I admit, I thought your homeland was just a legend. Pandaren from the Isle are far more adventurous than those on the mainland... it\'s in your blood!','',0,0,0,0,0,0,396,0,1,13210,31802,0,26124),
(62831,'No! What is... happening...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62832,'Skeer the Bloodseeker has returned! Unnngghhh...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62833,'Yes, Klaxxi\'va. What does the Council command? Skeer hears. Skeer obeys.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62834,'I... ah... oh! Did I...? Was I...? It was... so... cloudy.','',0,0,0,0,0,0,0,0,0,0,29325,0,26124),
(62835,'I have to go now.','',0,0,0,0,0,0,0,0,0,0,29326,0,26124),
(62836,'I have to make the water not cloudy anymore. Will... will you help?','',0,0,0,0,0,0,0,0,0,0,29327,0,26124),
(62837,'|TInterface\\Icons\\spell_nature_healingwavelesser.blp:20|t Garalon |cFFFF0000|Hspell:123495|h[Mends]|h|r one of his legs!','|TInterface\\Icons\\spell_nature_healingwavelesser.blp:20|t Garalon |cFFFF0000|Hspell:123495|h[Mends]|h|r one of his legs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62838,'Fools! Fight harder! Do not let these puny pandaren defeat you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62839,'|TInterface\\Icons\\spell_shaman_earthquake.blp:20|t Garalon prepares to |cFFFF0000|Hspell:122774|h[Crush]|h|r his opponents!','|TInterface\\Icons\\spell_shaman_earthquake.blp:20|t Garalon prepares to |cFFFF0000|Hspell:122774|h[Crush]|h|r his opponents!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62840,'Rise little one! And destroy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62841,'Garalon\'s massive armor plating begins to crack and split!','Garalon\'s massive armor plating begins to crack and split!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62842,'Welcome to our first officially-sanctioned combat event, the Arena of Annihilation!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62843,'Ah yes... Wakener, doesn\'t the scent of blood fill you with new strength?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62844,'Weaklings! Fools! You cannot stand before the Bloodseeker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62845,'Just a bit longer, Wakener! They are on their last legs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62846,'Well done, Wakener. I will stay a while longer to quench my blade\'s thirst. You may tell the others of my return, but I believe my swift wings will bear me to Klaxxi\'vess before you.','',0,0,0,0,0,0,0,0,1,17110,0,0,26124),
(62847,'Then HIT THAT GONG, and show these monks what you\'re made of! ...one way or another, heh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62848,'Swarmborn! Filthy muckeaters! You defile our grotto. You will not escape!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62849,'My voice, gone?  How will my subjects hear me?  Will they still love their empress?  Will they turn on me as the Klaxxi have?','',0,0,0,0,0,0,0,0,1,0,29274,0,26124),
(62850,'Did they send you?  They wouldn\'t dare!  Would they?','',0,0,0,0,0,0,0,0,1,0,29275,0,26124),
(62851,'You! You will suffer for your insolence at the hands of my greatest champions.  Surely they will protect their empress!','',0,0,0,0,0,0,0,0,1,0,29276,0,26124),
(62852,'Hear me subjects! Your empress is threatened by these outsiders. They wish to kill me... to kill us all!  Destroy them!','',0,0,0,0,0,0,0,0,1,0,29277,0,26124),
(62853,'Your defiance of the Empress ends here!','',0,0,0,0,0,0,0,0,1,0,30335,0,26124),
(62854,'All of Pandaria will fall beneath the Wings of the Empress!','',0,0,0,0,0,0,0,0,1,0,30336,0,26124),
(62855,'Empress... I have... failed you...','',0,0,0,0,0,0,0,0,1,0,30337,0,26124),
(62856,'The Empress commands it!','',0,0,0,0,0,0,0,0,1,0,30338,0,26124),
(62857,'Pitiful.','',0,0,0,0,0,0,0,0,1,0,30339,0,26124),
(62858,'My blade never misses its mark!','',0,0,0,0,0,0,0,0,1,0,30340,0,26124),
(62859,'The skies belong to the Empress!','',0,0,0,0,0,0,0,0,1,0,30341,0,26124),
(62860,'The Kor\'thik have no equal in combat!','',0,0,0,0,0,0,0,0,1,0,30342,0,26124),
(62861,'The Sra\'thik command the elements of this land, leaving their foes imprisoned for all time!','',0,0,0,0,0,0,0,0,1,0,30343,0,26124),
(62862,'The mighty Zar\'thik bend the wind to their will!','',0,0,0,0,0,0,0,0,1,0,30344,0,26124),
(62863,'To die for the empress is an honor!','',0,0,0,0,0,0,0,0,1,0,30345,0,26124),
(62864,'The wings of the empress cannot fail!','',0,0,0,0,0,0,0,0,1,0,30346,0,26124),
(62865,'You will pay for your transgressions!','',0,0,0,0,0,0,0,0,1,0,30347,0,26124),
(62866,'You fight like cowards!','',0,0,0,0,0,0,0,0,1,0,30333,0,26124),
(62867,'Aid me brethren!','',0,0,0,0,0,0,0,0,1,0,30334,0,26124),
(62868,'In order to survive, you must fight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62869,'Peace is for the weak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62870,'The only way I know is that of the warrior.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62871,'Only the strongest survive.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62872,'Impossible! Why does my strength fail me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62873,'I will slay a hundred foes! As soon as I... can catch my breath.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62874,'They warned me of the wakening sickness, but I did not believe it would be this bad.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62875,'I will be fine.$B$BThis is nothing compared to the thousand scars of battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62876,'I say we need less talking and more fighting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62877,'The rules of the trial are simple. These target dummies are equipped with powder bombs. If a single one of them explodes, your trial is over.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62878,'Ah, perhaps one of your skills can make our sparring sessions more interesting. Protect the temple healers from assailants for as long as you are able.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62879,'Joining you in this trial will be a few of our more... reckless... students. Prove yourself by keeping them all in the fight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62880,'Let us make this a bit more interesting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62881,'Hope you\'re quick on your feet!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62882,'Impressive. But can you handle this?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62883,'There will be no escaping me.','',0,0,0,0,0,0,0,0,1,0,29074,0,26124),
(62884,'Empress... forgive me!','',0,0,0,0,0,0,0,0,1,0,29075,0,26124),
(62885,'This wall is your grave!','',0,0,0,0,0,0,0,0,1,0,29078,0,26124),
(62886,'None may stand against us!','',0,0,0,0,0,0,0,0,1,0,29079,0,26124),
(62887,'*Mocking Laughter*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62888,'I\'ll hurl your corpses from this tower.','',0,0,0,0,0,0,0,0,1,0,29375,0,26124),
(62889,'Our numbers... endless! You... cannot win...','',0,0,0,0,0,0,0,0,1,0,29376,0,26124),
(62890,'','Seal the gates! Bar the exits! Destroy these intruders!',0,0,0,0,0,0,1,0,1,0,0,29278,26124),
(62891,'','Death to all who dare challenge my empire!',0,0,0,0,0,0,0,0,1,0,0,29283,26124),
(62892,'','Augh... ah ... I...  have failed.',0,0,0,0,0,0,0,0,1,0,0,29268,26124),
(62893,'','Taste defeat, stranger!',0,0,0,0,0,0,0,0,1,0,0,29279,26124),
(62894,'','Breathe no longer!',0,0,0,0,0,0,0,0,1,0,0,29280,26124),
(62895,'','Sing... yes! Sing in agony!',0,0,0,0,0,0,0,0,1,0,0,29281,26124),
(62896,'','You will serve ME now!',0,0,0,0,0,0,0,0,1,0,0,29282,26124),
(62897,'','Such is the fate of those who question authority.',0,0,0,0,0,0,0,0,1,0,0,29273,26124),
(62898,'','Power... I must have more power! Guards! Protect your empress!',0,0,0,0,0,0,0,0,1,0,0,29270,26124),
(62899,'You joined a battle already lost.','',0,0,0,0,0,0,0,0,1,0,29378,0,26124),
(62900,'','I will dispose of the outsiders.',0,0,0,0,0,0,0,0,1,0,0,29271,26124),
(62901,'','More... more! I must have more!',0,0,0,0,0,0,0,0,1,0,0,29272,26124),
(62902,'Air superiority.','',0,0,0,0,0,0,0,0,1,0,29379,0,26124),
(62903,'As expected.','',0,0,0,0,0,0,0,0,1,0,29380,0,26124),
(62904,'','Yes, master.',0,0,0,0,0,0,0,0,1,0,0,29269,26124),
(62905,'You must destroy these outsiders, empress! They have come to conquer your people!','',0,0,0,0,0,0,0,0,1,0,32648,0,26124),
(62906,'USELESS! Fall limp and die before me, wretched insect. Your kind are worthless to me!','',0,0,0,0,0,0,53,0,1,0,32645,0,26124),
(62907,'As for the rest of you, seek me if you dare. Like the others, you will all die screaming.','',0,0,0,0,0,0,0,0,1,0,32646,0,26124),
(62908,'Die or surrender. You cannot defeat me.','',0,0,0,0,0,0,0,0,1,0,28273,0,26124),
(62909,'All is lost.','',0,0,0,0,0,0,0,0,1,0,28277,0,26124),
(62910,'Abandon all hope.','',0,0,0,0,0,0,0,0,1,0,28278,0,26124),
(62911,'Embrace your despair.','',0,0,0,0,0,0,0,0,1,0,28279,0,26124),
(62912,'You cannot escape me. I am... in... every...  breath...','',0,0,0,0,0,0,0,0,1,0,28274,0,26124),
(62913,'See how effortlessly you become unraveled.','',0,0,0,0,0,0,0,0,1,0,28275,0,26124),
(62914,'Succumb to the darkness inside your soul.','',0,0,0,0,0,0,0,0,1,0,28276,0,26124),
(62915,'For our first show of skill and power we bring you SCAR-SHELL, mightiest of dragon turtles!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62916,'Whew, what a mess! Someone inform the monastery kitchens: We\'re having turtle soup, tonight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62917,'It\'s time for the grummle-grubbing goliath, fifteen feet of furry fury, Kun-Lai Summit\'s own snow-stalking horror, JOL\'GRUM!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62918,'OUCH! Safe to say that Jol\'Grum wasn\'t quite yet-i ready for his battle with these three killing machines! Speaking of ready...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62919,'She\'s here to make new friends... and then set them on fire! It\'s Pandaria\'s prettiest little playful pyromaniac, Liuyang!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62920,'Snuffed out like a candle! Is there anyone these three can\'t beat?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62921,'Did someone say Yak Attack?! It\'s ax-master Chagan Firehoof, wandering warrior of the Townlong Steppes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62922,'What a battle! Our fine combatants served up Chagan a heaping helping of Yaungolian barbeque...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62923,'So wild and vicious he was kicked off the Peak of Serenity, it\'s the froth-mouthed frenzy, always-bananas monkey monk master CLOUDBENDER KOBO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62924,'What a gloriously bloody battle! Our three heroes showed Kobo that the Arena of Annihilation isn\'t just monkey business.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62925,'','I hope you don\'t mind sharing the balloon with me. My father always told me not to talk to strangers, but you seem friendly.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62926,'','Isn\'t Zouchin Province beautiful? I\'ve lived here my whole life.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62927,'','My father thinks it\'s too dangerous beyond Zouchin\'s walls for a lady. He only lets me leave when we need supplies from One Keg.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62928,'','The way I see it is, I\'m not very good at being a lady, so maybe I\'d make a better adventurer like you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62929,'','Those ruins creep me out. They\'re so old...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62930,'','Look at those boats! Where are they coming from?!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62931,'','Oh no! Look at those huts! Why are they attacking defenseless villagers?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62932,'','My village is under attack! I hope my family is alright.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62933,'','It looks like my father was wrong. Even Zouchin can be dangerous!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62934,'','I have to check on my family. Please help us!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(62935,'Archers! Shoot down the airborne mantid!','',0,0,0,0,0,0,0,0,1,0,28553,0,26124),
(62936,'Ready your arrows and attack the flyers!','',0,0,0,0,0,0,0,0,1,0,28554,0,26124),
(62937,'Ready the oil.. pour, now!','',0,0,0,0,0,0,0,0,1,0,28555,0,26124),
(62938,'Cast down the oil!','',0,0,0,0,0,0,0,0,1,0,28556,0,26124),
(62939,'Use the cannons to launch yourself onto him!','',0,0,0,0,0,0,0,0,1,0,28557,0,26124),
(62940,'His armor is broken. Strike at him now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62941,'On your guard, invaders. I, Ta\'yak, Lord of Blades, will be your opponent.','',0,0,0,0,0,0,0,0,1,0,29252,0,26124),
(62942,'A perfect cut.','',0,0,0,0,0,0,0,0,1,0,29259,0,26124),
(62943,'This is the technique of a Blade Lord.','',0,0,0,0,0,0,0,0,1,0,29260,0,26124),
(62944,'I\'d always hoped to cut someone like that someday, to hear that sound. But to have it happen to my own prothorax is ridiculous.','',0,0,0,0,0,0,0,0,1,0,29253,0,26124),
(62945,'His armor is broken. Strike at him now!','',0,0,0,0,0,0,0,0,1,0,28558,0,26124),
(62946,'Who dares summon Emperor Meng, most majestic of mighty monarchs?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62947,'You have angered the emperor! THE SENTENCE IS DEATH!','',0,0,0,0,0,0,0,0,1,0,28069,0,26124),
(62948,'I... I don\'t want to die!','',0,0,0,0,0,0,0,0,1,0,28071,0,26124),
(62949,'The sentence... was to be... yours..','',0,0,0,0,0,0,0,0,1,0,28070,0,26124),
(62950,'Like rice stalks before the blade, all fall before me!','',0,0,0,0,0,0,0,0,1,0,28073,0,26124),
(62951,'None may stand against the imperial majesty of MENG!','',0,0,0,0,0,0,0,0,1,0,28074,0,26124),
(62952,'Don\'t bleed on me! Filthy! Disease!','',0,0,0,0,0,0,0,0,1,0,28075,0,26124),
(62953,'You made me do it!','',0,0,0,0,0,0,0,0,1,0,28076,0,26124),
(62954,'Slaughter yourselves for my amusement!','',0,0,0,0,0,0,0,0,1,0,28077,0,26124),
(62955,'Enemies... everywhere! Kill! Kill them all!','',0,0,0,0,0,0,0,0,1,0,28078,0,26124),
(62956,'My armies are endless, my power, unmatched.','',0,0,0,0,0,0,0,0,1,0,28059,0,26124),
(62957,'Let death wash over you!','',0,0,0,0,0,0,0,0,1,0,28271,0,26124),
(62958,'Rise!','',0,0,0,0,0,0,0,0,1,0,28260,0,26124),
(62959,'I will crush you, in body AND spirit.','',0,0,0,0,0,0,0,0,1,0,28057,0,26124),
(62960,'Living water, bring them death!','',0,0,0,0,0,0,0,0,1,0,28261,0,26124),
(62961,'I... cannot be... defeated..','',0,0,0,0,0,0,0,0,1,0,28058,0,26124),
(62962,'My tactics are unbeatable.','',0,0,0,0,0,0,0,0,1,0,28060,0,26124),
(62963,'Another victory.','',0,0,0,0,0,0,0,0,1,0,28061,0,26124),
(62964,'The emperor rules ALL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62965,'Soldiers! Crush their flank!','',0,0,0,0,0,0,0,0,1,0,28063,0,26124),
(62966,'Flanking attack! March into battle!','',0,0,0,0,0,0,0,0,1,0,28064,0,26124),
(62967,'Bandits and emperors; we both take what we want!','',0,0,0,0,0,0,0,0,1,0,28111,0,26124),
(62968,'You\'ll see your mistake soon enough!','',0,0,0,0,0,0,0,0,1,0,28109,0,26124),
(62969,'I am... bested.','',0,0,0,0,0,0,0,0,1,0,28110,0,26124),
(62970,'You were too slow!','',0,0,0,0,0,0,0,0,1,0,28112,0,26124),
(62971,'I am too quick, too clever.','',0,0,0,0,0,0,0,0,1,0,28113,0,26124),
(62972,'You stood no chance!','',0,0,0,0,0,0,0,0,1,0,28114,0,26124),
(62973,'All that is yours? Mine!','',0,0,0,0,0,0,0,0,1,0,28115,0,26124),
(62974,'There is nothing I cannot take!','',0,0,0,0,0,0,0,0,1,0,28116,0,26124),
(62975,'I sense... courage. Willpower. Light. Hmph. That will not do.','',0,0,0,0,0,0,0,0,1,0,27960,0,26124),
(62976,'Soon you will understand why my subjects fear the shadows!','',0,0,0,0,0,0,0,0,1,0,27958,0,26124),
(62977,'The darkness... surrounds me!','',0,0,0,0,0,0,0,0,1,0,27959,0,26124),
(62978,'Fall into darkness.','',0,0,0,0,0,0,0,0,1,0,27961,0,26124),
(62979,'The shadows consume you.','',0,0,0,0,0,0,0,0,1,0,27962,0,26124),
(62980,'THIS is what it means to face an emperor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62981,'The darkness comes for you, and with it, death.','',0,0,0,0,0,0,0,0,1,0,27964,0,26124),
(62982,'One minute until the Arena battle begins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62983,'Fifteen seconds until the Arena battle begins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62984,'The Arena battle has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62985,'Green team scores a kill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62986,'Yellow team scores a kill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62987,'The Arena battle ends in sixty seconds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62988,'As the waters foretold.','',0,0,0,0,0,0,0,0,1,0,28267,0,26124),
(62989,'Your cause is hopeless.','',0,0,0,0,0,0,0,0,1,0,28268,0,26124),
(62990,'Time has run out. The Arena battle is over!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62991,'Green team wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62992,'Yellow team wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62993,'Draw! No winner.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62994,'Yellow team wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62995,'Yellow team scores a kill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62996,'Time has run out. The Arena battle is over!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62997,'The Arena battle has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62998,'Green team wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(62999,'Green team scores a kill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63000,'The Arena battle ends in sixty seconds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63001,'Draw! No winner.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63002,'Fifteen seconds until the Arena battle begins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63003,'Yellow team wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63004,'Yellow team scores a kill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63005,'Time has run out. The Arena battle is over!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63006,'','Wait... what\'s that?! Where did all of those huts come from?!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63007,'The Arena battle has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63008,'Green team wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63009,'Green team scores a kill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63010,'The Arena battle ends in sixty seconds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63011,'Draw! No winner.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63012,'Fifteen seconds until the Arena battle begins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63013,'Yellow team wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63014,'Yellow team scores a kill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63015,'Time has run out. The Arena battle is over!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63016,'The Arena battle has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63017,'Green team wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63018,'Green team scores a kill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63019,'The Arena battle ends in sixty seconds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63020,'Draw! No winner.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63021,'Fifteen seconds until the Arena battle begins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63022,'And there are Virmen in the main store!','',0,0,0,0,0,0,5,0,1,0,29774,0,26124),
(63023,'I think the brewery might be on fire.','',0,0,0,0,0,0,1,0,1,0,29775,0,26124),
(63024,'Yellow team wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63025,'Yellow team scores a kill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63026,'Time has run out. The Arena battle is over!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63027,'The Arena battle has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63028,'Green team wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63029,'Green team scores a kill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63030,'The Arena battle ends in sixty seconds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63031,'Draw! No winner.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63032,'Fifteen seconds until the Arena battle begins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63033,'Yellow team wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63034,'Yellow team scores a kill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63035,'Time has run out. The Arena battle is over!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63036,'The Arena battle has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63037,'Green team wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63038,'Green team scores a kill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63039,'The Arena battle ends in sixty seconds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63040,'Draw! No winner.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63041,'Fifteen seconds until the Arena battle begins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63042,'The battle has begun!','',0,0,0,0,0,0,0,0,0,0,34105,0,26124),
(63043,'The Alliance is near victory!','',0,0,0,0,0,0,0,0,0,0,34106,0,26124),
(63044,'The Horde is near victory!','',0,0,0,0,0,0,0,0,0,0,34107,0,26124),
(63045,'The Alliance is victorious!','',0,0,0,0,0,0,0,0,0,0,34108,0,26124),
(63046,'The Horde is victorious!','',0,0,0,0,0,0,0,0,0,0,34109,0,26124),
(63047,'The front gate of the Alliance keep has been destroyed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63048,'The east gate of the Alliance keep has been destroyed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63049,'The west gate of the Alliance keep has been destroyed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63050,'The front gate of the Horde keep has been destroyed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63051,'The east gate of the Horde keep has been destroyed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63052,'The west gate of the Horde keep has been destroyed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63053,'The Gate of the Blue Sapphire was destroyed!','',0,0,0,0,0,0,0,0,0,0,34116,0,26124),
(63054,'Oh yeah!','Oh yeah!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63055,'The Gate of the Green Emerald was destroyed!','',0,0,0,0,0,0,0,0,0,0,34117,0,26124),
(63056,'You die!','You die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63057,'The Gate of the Purple Amythest was destroyed!','',0,0,0,0,0,0,0,0,0,0,34118,0,26124),
(63058,'You have...turnip...for a head...','You have...turnip...for a head...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63059,'The Gate of the Red Sun was destroyed!','',0,0,0,0,0,0,0,0,0,0,34119,0,26124),
(63060,'Urp...eats too many carrots...','Urp...eats too many carrots...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63061,'The Gate of the Yellow Moon was destroyed!','',0,0,0,0,0,0,0,0,0,0,34120,0,26124),
(63062,'Gonna spins around!','Gonna spins around!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63064,'The battle for Arathi Basin is about to begin.','',0,0,0,0,0,0,0,0,0,0,34102,0,26124),
(63065,'Get da party started for da new Ook!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63066,'The battle for Arathi Basin is about to begin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63067,'Yeah!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63068,'The battle has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63069,'Yeah!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63070,'Come on and get your Ook on!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63071,'Everybody do the Ook!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63072,'Ook it harder!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63073,'The Alliance is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63074,'The Horde is victorious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63075,'The Horde is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63076,'The Alliance is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63077,'Ook it better!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63078,'Ook it faster!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63079,'Ook it stronger!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63080,'Shake dat shake dat!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63081,'Shake your dooker!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63082,'The battle for the Eye of the Storm is about to begin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63083,'The battle for the Eye of the Storm is about to begin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63084,'The Gate of the Blue Sapphire was destroyed!','',0,0,0,0,0,0,0,0,0,0,34116,0,26124),
(63085,'The Gate of the Green Emerald was destroyed!','',0,0,0,0,0,0,0,0,0,0,34117,0,26124),
(63086,'The Gate of the Purple Amythest was destroyed!','',0,0,0,0,0,0,0,0,0,0,34118,0,26124),
(63087,'All the hozen gotta listen now...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63088,'The Gate of the Red Sun was destroyed!','',0,0,0,0,0,0,0,0,0,0,34119,0,26124),
(63089,'The Gate of the Yellow Moon was destroyed!','',0,0,0,0,0,0,0,0,0,0,34120,0,26124),
(63090,'Cuz there\'s a new Ook in town...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63091,'So gets a keg of Stormstout Brown...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63092,'The east gate of the Alliance keep has been destroyed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63093,'And drop your dooker to the ground!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63094,'The front gate of the Alliance keep has been destroyed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63095,'The west gate of the Alliance keep has been destroyed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63096,'The east gate of the Horde keep has been destroyed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63097,'We doins Hozen activities!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63098,'The front gate of the Horde keep has been destroyed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63099,'We gots Hozen tendencies!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63100,'The west gate of the Horde keep has been destroyed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63101,'We gots da Hozen friends!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63102,'We gots da Hozen enemies!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63103,'Ook!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63104,'You dids it again!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63105,'You dook\'d with my heart!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63106,'Gots lost in da ook!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63107,'The battle has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63108,'Ook!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63109,'The battle has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63110,'Ook!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63111,'The Alliance is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63112,'Ook!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63113,'The Alliance is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63114,'Ook!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63115,'The Horde is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63116,'The Horde is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63117,'The Alliance is victorious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63118,'The Alliance is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63119,'The Horde is victorious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63120,'The Horde is victorious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63121,'Ook your dooker!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63122,'The Battle for Gilneas is about to begin.','',0,0,0,0,0,0,0,0,0,0,34136,0,26124),
(63123,'The battle for Arathi Basin is about to begin.','',0,0,0,0,0,0,0,0,0,0,34136,0,26124),
(63124,'The battle has begun!','',0,0,0,0,0,0,0,0,0,0,34137,0,26124),
(63125,'The battle has begun!','',0,0,0,0,0,0,0,0,0,0,34137,0,26124),
(63126,'The Alliance is near victory!','',0,0,0,0,0,0,0,0,0,0,34138,0,26124),
(63127,'The Alliance is near victory!','',0,0,0,0,0,0,0,0,0,0,34138,0,26124),
(63128,'The Horde is near victory!','',0,0,0,0,0,0,0,0,0,0,34139,0,26124),
(63129,'The Horde is near victory!','',0,0,0,0,0,0,0,0,0,0,34139,0,26124),
(63130,'The Alliance is victorious!','',0,0,0,0,0,0,0,0,0,0,34140,0,26124),
(63131,'The Alliance is near victory!','',0,0,0,0,0,0,0,0,0,0,34140,0,26124),
(63132,'The Horde is victorious!','',0,0,0,0,0,0,0,0,0,0,34141,0,26124),
(63133,'The Horde is victorious!','',0,0,0,0,0,0,0,0,0,0,34141,0,26124),
(63134,'The battle for Silvershard Mines is about to begin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63135,'Whatzit...are they...what are they doin\' to our alementals?','',0,0,0,0,0,0,1,0,1,0,27509,0,26124),
(63136,'The battle has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63137,'Hey...hey YOU! Those are OUR flying...beer monsters?','',0,0,0,0,0,0,1,0,1,0,27510,0,26124),
(63138,'This view is terrible!','',0,0,0,0,0,0,1,0,1,0,27998,0,26124),
(63139,'The Alliance is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63140,'The Horde is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63141,'The Alliance is victorious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63142,'What, are you having trouble seeing the fight?','',0,0,0,0,0,0,1,0,1,0,28300,0,26124),
(63143,'The Horde is victorious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63144,'No, I can see it perfectly!','',0,0,0,0,0,0,1,0,1,0,27999,0,26124),
(63145,'This group is awful!','',0,0,0,0,0,0,1,0,1,0,28019,0,26124),
(63146,'Terrible!','',0,0,0,0,0,0,1,0,1,0,28042,0,26124),
(63147,'Disgusting!','',0,0,0,0,0,0,1,0,1,0,28020,0,26124),
(63148,'See you here tomorrow?','',0,0,0,0,0,0,1,0,1,0,28043,0,26124),
(63149,'Absolutely!','',0,0,0,0,0,0,1,0,1,0,28021,0,26124),
(63150,'You fool, you\'re sleeping through the fight!','',0,0,0,0,0,0,1,0,1,0,28000,0,26124),
(63151,'Who\'s the fool? You\'re watching it!','',0,0,0,0,0,0,1,0,1,0,28301,0,26124),
(63152,'Finally, we\'ve seen a good group!','',0,0,0,0,0,0,1,0,1,0,28022,0,26124),
(63153,'The battle for Arathi Basin is about to begin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63154,'The battle has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63155,'Does that mean we can stop coming here now?','',0,0,0,0,0,0,1,0,1,0,28044,0,26124),
(63156,'Do you think all of this fighting is educational for this group?','',0,0,0,0,0,0,1,0,1,0,28001,0,26124),
(63157,'Yes, it will drive them to read books!','',0,0,0,0,0,0,1,0,1,0,28302,0,26124),
(63158,'The Alliance has captured the flag!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63159,'The Horde has captured the flag!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63160,'Pay up, they made it through those alementals!','',0,0,0,0,0,0,1,0,1,0,28023,0,26124),
(63161,'Double or nothing on the next group?','',0,0,0,0,0,0,1,0,1,0,28045,0,26124),
(63162,'The Alliance is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63163,'I liked that last group!','',0,0,0,0,0,0,1,0,1,0,28002,0,26124),
(63164,'What did you like about it?','',0,0,0,0,0,0,1,0,1,0,28303,0,26124),
(63165,'The Horde is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63166,'I thought it was the last group!','',0,0,0,0,0,0,1,0,1,0,28003,0,26124),
(63167,'I think I\'m going to need another drink!','',0,0,0,0,0,0,1,0,1,0,28024,0,26124),
(63168,'Why do you say that?','',0,0,0,0,0,0,1,0,1,0,28046,0,26124),
(63169,'The Alliance is victorious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63170,'I\'m beginning to like these guys!','',0,0,0,0,0,0,1,0,1,0,28025,0,26124),
(63171,'The Horde is victorious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63172,'Do you think that we can return to life after death?','',0,0,0,0,0,0,1,0,1,0,28004,0,26124),
(63173,'Sure! That last group did about thirty times!','',0,0,0,0,0,0,1,0,1,0,28304,0,26124),
(63174,'Well, see you here tomorrow!','',0,0,0,0,0,0,1,0,1,0,28026,0,26124),
(63175,'Unless I get lucky and black out!','',0,0,0,0,0,0,1,0,1,0,28047,0,26124),
(63176,'Wh-what are you doing here?! G-go away!','',0,0,0,0,0,0,0,0,0,0,29328,0,26124),
(63177,'You know what\'s the best thing about this group?','',0,0,0,0,0,0,1,0,1,0,28005,0,26124),
(63178,'What?','',0,0,0,0,0,0,1,0,1,0,28305,0,26124),
(63179,'They opened the doors so we can escape!','',0,0,0,0,0,0,1,0,1,0,28006,0,26124),
(63180,'Just when I think a group is the worst, something wonderful happens!','',0,0,0,0,0,0,1,0,1,0,28027,0,26124),
(63181,'What\'s that?','',0,0,0,0,0,0,1,0,1,0,28048,0,26124),
(63182,'The battle for Temple of Kotmogu is about to begin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63183,'They leave!','',0,0,0,0,0,0,1,0,1,0,28028,0,26124),
(63184,'Oooh this group takes me back.','',0,0,0,0,0,0,1,0,1,0,28007,0,26124),
(63185,'If you can still see, it didn\'t go back far enough!','',0,0,0,0,0,0,1,0,1,0,28306,0,26124),
(63186,'The battle has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63187,'These guys aren\'t half bad!','',0,0,0,0,0,0,1,0,1,0,28029,0,26124),
(63188,'The Alliance is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63189,'They\'re not half good either!','',0,0,0,0,0,0,1,0,1,0,28049,0,26124),
(63190,'The Horde is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63192,'The Alliance is victorious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63193,'The Horde is victorious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63194,'S-sorry!','',0,0,0,0,0,0,0,0,0,0,29329,0,26124),
(63195,'It\'s your fault it happened!','',0,0,0,0,0,0,0,0,0,0,29330,0,26124),
(63196,'Get AWAY!','',0,0,0,0,0,0,0,0,0,0,29331,0,26124),
(63197,'Stay away from me!','',0,0,0,0,0,0,0,0,0,0,29332,0,26124),
(63198,'I\'m hiding until you leave!','',0,0,0,0,0,0,0,0,0,0,29333,0,26124),
(63199,'I don\'t want to see you anymore!','',0,0,0,0,0,0,0,0,0,0,29334,0,26124),
(63200,'The battle for Arathi Basin is about to begin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63201,'The Alliance is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63202,'The Alliance is victorious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63203,'The battle has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63204,'The Horde has captured the flag!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63205,'The Horde is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63206,'The Horde is victorious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63207,'I think this group will really improve with age!','',0,0,0,0,0,0,1,0,1,0,28008,0,26124),
(63208,'You think they\'ll get better?','',0,0,0,0,0,0,1,0,1,0,28307,0,26124),
(63209,'No, my eyesight will get worse!','',0,0,0,0,0,0,1,0,1,0,28009,0,26124),
(63210,'I wonder if there\'s anything this healer isn\'t good at!','',0,0,0,0,0,0,1,0,1,0,28030,0,26124),
(63211,'Sure! Choosing which group to be in!','',0,0,0,0,0,0,1,0,1,0,28050,0,26124),
(63212,'There must be something wrong with those Hozen we saw earlier!','',0,0,0,0,0,0,1,0,1,0,28010,0,26124),
(63213,'The battle for Arathi Basin is about to begin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63214,'Why\'s that?','',0,0,0,0,0,0,1,0,1,0,28308,0,26124),
(63215,'The battle for Arathi Basin is about to begin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63216,'The Alliance is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63217,'Because these guys made it past them!','',0,0,0,0,0,0,1,0,1,0,28011,0,26124),
(63218,'You know, I really envy these guys!','',0,0,0,0,0,0,1,0,1,0,28031,0,26124),
(63219,'The Alliance is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63220,'Why\'s that?','',0,0,0,0,0,0,1,0,1,0,28051,0,26124),
(63221,'Because they get to spend so much time with that foxy spirit healer!','',0,0,0,0,0,0,1,0,1,0,28032,0,26124),
(63222,'You know, getting items must be hard for these guys!','',0,0,0,0,0,0,1,0,1,0,28012,0,26124),
(63223,'Why\'s that?','',0,0,0,0,0,0,1,0,1,0,28309,0,26124),
(63224,'Because pants never drop when they\'re around!','',0,0,0,0,0,0,1,0,1,0,28013,0,26124),
(63225,'The Alliance is victorious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63226,'Are these guys Alliance or Horde?','',0,0,0,0,0,0,1,0,1,0,28033,0,26124),
(63227,'Why does it matter?','',0,0,0,0,0,0,1,0,1,0,28052,0,26124),
(63228,'The Alliance is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63229,'I need to know which side to stop rooting for!','',0,0,0,0,0,0,1,0,1,0,28034,0,26124),
(63230,'I think that druid had the hots for me!','',0,0,0,0,0,0,1,0,1,0,27511,0,26124),
(63231,'The battle has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63232,'That last priest had me smitten!','',0,0,0,0,0,0,1,0,1,0,27512,0,26124),
(63233,'The battle has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63234,'The Horde is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63235,'The Horde is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63236,'Why didn\'t that mage put intellect on his weapon?','',0,0,0,0,0,0,1,0,1,0,28014,0,26124),
(63237,'The Horde is victorious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63238,'Because he didn\'t want it to be smarter than he was!','',0,0,0,0,0,0,1,0,1,0,28310,0,26124),
(63239,'The Horde is victorious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63240,'How many of these outlanders does it take to paint a wall?','',0,0,0,0,0,0,1,0,1,0,28035,0,26124),
(63241,'I don\'t know, how many?','',0,0,0,0,0,0,1,0,1,0,28053,0,26124),
(63242,'It depends on how hard you throw them!','',0,0,0,0,0,0,1,0,1,0,28036,0,26124),
(63243,'Do you think that undead party made it through in one piece?','',0,0,0,0,0,0,1,0,1,0,28015,0,26124),
(63244,'No, I don\'t think they had the guts!','',0,0,0,0,0,0,1,0,1,0,28311,0,26124),
(63245,'That last paladin offered me eternal salvation!','',0,0,0,0,0,0,1,0,1,0,28037,0,26124),
(63246,'What\'d you say?','',0,0,0,0,0,0,1,0,1,0,28054,0,26124),
(63247,'Kings, please.','',0,0,0,0,0,0,1,0,1,0,28038,0,26124),
(63248,'That last shaman really knew his place!','',0,0,0,0,0,0,1,0,1,0,28016,0,26124),
(63249,'And where is that?','',0,0,0,0,0,0,1,0,1,0,28312,0,26124),
(63250,'Outland!','',0,0,0,0,0,0,1,0,1,0,28017,0,26124),
(63251,'I\'ve got a great joke for you!','',0,0,0,0,0,0,1,0,1,0,28039,0,26124),
(63252,'What\'s that?','',0,0,0,0,0,0,1,0,1,0,28055,0,26124),
(63253,'These guys\' weapons!','',0,0,0,0,0,0,1,0,1,0,28040,0,26124),
(63254,'I hear something...','',0,0,0,0,0,0,0,0,1,0,32495,0,26124),
(63255,'Stop them!','',0,0,0,0,0,0,0,0,1,0,32488,0,26124),
(63256,'Such a waste...','',0,0,0,0,0,0,0,0,1,0,32494,0,26124),
(63257,'Search his corpse!','',0,0,0,0,0,0,0,0,1,0,32496,0,26124),
(63258,'Slay them!','',0,0,0,0,0,0,0,0,1,0,32497,0,26124),
(63259,'Everything must burn. None shall know of the Scarlet Crusade\'s shame!','',1,0,0,0,0,0,0,0,1,0,29524,0,26124),
(63260,'You, too, shall be charred to ash!','',1,0,0,0,0,0,0,0,1,0,29522,0,26124),
(63261,'My fire... has gone out..','',1,0,0,0,0,0,0,0,1,0,29523,0,26124),
(63262,'Burn! BURN!','',1,0,0,0,0,0,0,0,1,0,29525,0,26124),
(63263,'Die in a fire!','',1,0,0,0,0,0,0,0,1,0,29526,0,26124),
(63264,'Breath of the Dragon!','',1,0,0,0,0,0,0,0,1,0,29527,0,26124),
(63265,'My endless agony shall be yours, as well!','',396,0,0,0,0,0,0,0,1,0,27832,0,26124),
(63266,'We hunger for vengeance.','',396,0,0,0,0,0,0,0,1,0,27829,0,26124),
(63267,'Can this be... the end, at last...?','',396,0,0,0,0,0,0,0,1,0,27830,0,26124),
(63268,'More... More souls!','',396,0,0,0,0,0,0,0,1,0,27833,0,26124),
(63269,'Seek out a vessel... and return!','',396,0,0,0,0,0,0,0,1,0,27834,0,26124),
(63270,'Claim a body, and wreak terrible vengeance!','',396,0,0,0,0,0,0,0,1,0,27835,0,26124),
(63271,'No rest... for the angry dead!','',396,0,0,0,0,0,0,0,1,0,27831,0,26124),
(63272,'No... the waters... I must... resist... I shall not... fear...','',0,0,0,0,0,0,0,0,1,0,29359,0,26124),
(63273,'You do not belong here! The waters must be protected... I will cast you out, or slay you!','',0,0,0,0,0,0,0,0,1,0,29350,0,26124),
(63274,'Protect... the waters...','',0,0,0,0,0,0,0,0,1,0,29351,0,26124),
(63275,'I thank you, strangers. I have been freed.','',0,0,0,0,0,0,0,0,1,0,29352,0,26124),
(63276,'Die in darkness.','',0,0,0,0,0,0,0,0,1,0,29360,0,26124),
(63277,'The night surrounds you...','',0,0,0,0,0,0,0,0,1,0,29361,0,26124),
(63278,'I assure you $p is the best fighter I\'ve ever seen. $GHe:She; will be able to help better prepare your village.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63279,'No...!','',0,0,0,0,0,0,0,0,1,0,29362,0,26124),
(63280,'Forgive me!','',0,0,0,0,0,0,0,0,1,0,29363,0,26124),
(63281,'For starters, your villagers need rest. We can offer you protection long enough to allow them a break.','',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(63282,'$p can also teach your villagers to defend themselves.','',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(63283,'All we ask is help in finding Prophet Khar\'zul. You know the surrounding islands better than we do. Your knowledge would be invaluable.','',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(63284,'Overwhelming... fear!','',0,0,0,0,0,0,0,0,1,0,29364,0,26124),
(63285,'Flee this place... or die!','',0,0,0,0,0,0,0,0,1,0,29365,0,26124),
(63286,'Promises, promises! There is nothing you can do to save us. The Zandalari are ruthless!','',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(63287,'Even if we could defend ourselves they outnumber us! There is no way we will win!','',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(63288,'Day falls to night...','',0,0,0,0,0,0,0,0,1,0,29353,0,26124),
(63289,'Darkness grows...','',0,0,0,0,0,0,0,0,1,0,29354,0,26124),
(63290,'Light fades...','',0,0,0,0,0,0,0,0,1,0,29355,0,26124),
(63291,'Night... becomes day!','',0,0,0,0,0,0,0,0,1,0,29356,0,26124),
(63292,'The sun... shines through...','',0,0,0,0,0,0,0,0,1,0,29357,0,26124),
(63293,'Once more... the dawn...','',0,0,0,0,0,0,0,0,1,0,29358,0,26124),
(63294,'','So negative all the time Hou!',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(63295,'','That may not be true Hou. The Lorewalker seems confident. What will your protection cost us?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63296,'','Very well. If you help us fend off the Zandalari, we will help you find the Prophet.',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(63297,'I will break you.','',0,0,0,0,0,0,0,0,1,0,29496,0,26124),
(63298,'I cannot be defeated. I beat all man.','',0,0,0,0,0,0,0,0,1,0,29498,0,26124),
(63299,'My fists are scarlet... with your blood!','',0,0,0,0,0,0,0,0,1,0,29499,0,26124),
(63300,'If you die, you die.','',0,0,0,0,0,0,0,0,1,0,29500,0,26124),
(63301,'My blade is peerless!','',0,0,0,0,0,0,0,0,1,0,27530,0,26124),
(63302,'Perfect technique!','',0,0,0,0,0,0,0,0,1,0,27531,0,26124),
(63303,'But... my legend!','',0,0,0,0,0,0,0,0,1,0,27528,0,26124),
(63304,'My legend begins NOW!','',0,0,0,0,0,0,0,0,1,0,27527,0,26124),
(63305,'To think you\'ve come so far, only to perish here. I\'ll honor you with clean deaths.','',0,0,0,0,0,0,0,0,1,0,27529,0,26124),
(63306,'Your lights will go out. The darkness will envelop you. And you will fear the shadows that move within it.','',0,0,0,0,0,0,0,0,0,0,28402,0,26124),
(63307,'You will know fear!','',0,0,0,0,0,0,0,0,0,0,28398,0,26124),
(63308,'Drown in terror.','',0,0,0,0,0,0,0,0,0,0,28403,0,26124),
(63309,'Fleeeee!','',0,0,0,0,0,0,0,0,0,0,28404,0,26124),
(63310,'Huddle in terror!','',0,0,0,0,0,0,0,0,0,0,28405,0,26124),
(63311,'You think it is so easy to vanquish your fears?','',0,0,0,0,0,0,0,0,0,0,28400,0,26124),
(63312,'Dread rises! It seeks the light. It hungers.','',0,0,0,0,0,0,0,0,0,0,28401,0,26124),
(63313,'','What is it you plan to do to help us Lorewalker?',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(63314,'The glory of Gurthan!','',0,0,0,0,0,0,15,0,1,0,27942,0,26124),
(63315,'This is the might of Harthak!','',0,0,0,0,0,0,15,0,1,0,27957,0,26124),
(63316,'For Kargesh!','',0,0,0,0,0,0,15,0,1,0,28256,0,26124),
(63317,'It be dyin\' time, now!','',0,0,0,0,0,0,0,0,0,0,29080,0,26124),
(63318,'OH HO HO! Dat had ta hurt.','',0,0,0,0,0,0,153,0,0,0,29090,0,26124),
(63319,'OUCH! Eh-heheheh.','',0,0,0,0,0,0,153,0,0,0,29091,0,26124),
(63320,'Spirits be praised!','',0,0,0,0,0,0,153,0,0,0,29092,0,26124),
(63321,'The fear clouds my mind. I... cannot resist.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(63322,'You face your fear. A moment\'s... peace.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(63323,'I brought enough bombs... for all of you!','',0,0,0,0,0,0,0,0,1,0,29339,0,26124),
(63324,'Seek shelter, lest I strike you down as the Sha commands!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(63325,'I... blew it...','',0,0,0,0,0,0,0,0,1,0,29340,0,26124),
(63326,'Its power is so strong. It forces me to destroy you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(63327,'You face your fear. A moment\'s... peace.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(63328,'Seek shelter, lest I strike you down as the Sha commands!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(63329,'I\'m the bomber man...tid!','',0,0,0,0,0,0,0,0,1,0,29343,0,26124),
(63330,'You blew it!','',0,0,0,0,0,0,0,0,1,0,29344,0,26124),
(63331,'No one can stand against the fear. You will perish.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(63332,'Seek shelter, lest I strike you down as the Sha commands!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(63333,'You face your fear. A moment\'s... peace.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(63334,'Hold nothing back, for I will not!','',0,0,0,0,0,0,0,0,1,0,27622,0,26124),
(63335,'You need more training!','',0,0,0,0,0,0,0,0,1,0,27637,0,26124),
(63336,'Your technique needs work.','',0,0,0,0,0,0,0,0,1,0,27638,0,26124),
(63337,'I will not be caged again. These Shado-Pan could not stop me. Neither shall you!','',0,0,0,0,0,0,0,0,0,0,28346,0,26124),
(63338,'So long as violence lurks in your hearts... I... will... return...','',0,0,0,0,0,0,0,0,0,0,28347,0,26124),
(63339,'Another violent death...','',0,0,0,0,0,0,0,0,0,0,28348,0,26124),
(63340,'The Sha of Hatred has fled my body... and the monastery, as well. I must thank you, strangers. The Shado-Pan are in your debt. Now, there is much work to be done...','',0,0,0,0,0,0,0,0,0,0,28423,0,26124),
(63341,'Taran Zhu and the Shado-Pan are MINE. Come forward and die by my hand, as all who oppose me shall in the days to come!','',0,0,0,0,0,0,0,0,0,0,28334,0,26124),
(63342,'Hatred will consume and conquer all!','',0,0,0,0,0,0,0,0,0,0,28332,0,26124),
(63343,'No... NO!','',0,0,0,0,0,0,0,0,0,0,28333,0,26124),
(63344,'Rage at your defeat.','',0,0,0,0,0,0,0,0,0,0,28335,0,26124),
(63345,'Feed me your hatred!','',0,0,0,0,0,0,0,0,0,0,28336,0,26124),
(63346,'If you haven\'t come to study, I\'ll use you to teach a lesson.','',0,0,0,0,0,0,0,0,0,0,27496,0,26124),
(63347,'I will do what Pa\'valak could not!','',0,0,0,0,0,0,0,0,0,0,30360,30360,26124),
(63348,'You may have come this far. You may have carved a path through my army, but I... will kill you, and I will build the bridge.','',0,0,0,0,0,0,0,0,0,0,30359,30359,26124),
(63349,'The... bridge...','',0,0,0,0,0,0,0,0,0,0,30361,30361,26124),
(63350,'Out of my way.','',0,0,0,0,0,0,0,0,0,0,30362,0,26124),
(63351,'Get back to work! I want this bridge finished by first light!','',0,0,0,0,0,0,0,0,0,0,30363,0,26124),
(63352,'Screams and barking echo through the halls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63353,'Search the island for brew to add to Bo\'s cauldron, but keep someone nearby to protect Bo!','',0,0,0,0,0,0,0,0,1,17136,0,0,26124),
(63354,'Gork\'em big Dook!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63355,'Wikket ooked the big Dook!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63356,'Wikket gunna get grooked!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63357,'Ook\'em!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63358,'AHHHHH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63359,'Wikket big hozen grooker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63360,'Hallo, stranger! You are making quite an impression with the local hozen. I daresay they\'re starting to fear you.','',0,0,0,0,0,0,273,0,1,8526,30077,0,26124),
(63361,'As I live and breathe - an actual troll! You look just as the stories describe. You\'ve taught the Hozen quite the lesson.','',0,0,0,0,0,0,5,0,1,5579,30078,0,26124),
(63362,'%s is angry!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63363,'You must be one of those folk from that sky-ship that crashed. I have MANY questions for you, but this is a terrible place to chat.','',0,0,0,0,0,0,273,0,1,0,30079,0,26124),
(63364,'Please, find me in the Cave of Words, just up the hill here, when you have time to speak!','',0,0,0,0,0,0,6,0,1,0,30080,0,26124),
(63365,'<Paint something sexy.>','<Paint something sexy.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63366,'<Paint something abstract.>','<Paint something abstract.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63367,'<Paint something heroic.>','<Paint something heroic.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63368,'Ah! Haha - I can see now what your Alliance fights for.','',0,0,0,0,0,0,11,0,1,0,31791,0,26124),
(63369,'I prefer a little more meat on my birds, of course, but I can see that your people and mine are not so different after all.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63370,'What have we here? Fields of red and blue, violently clashing in a green land.','',0,0,0,0,0,0,274,0,1,0,31792,0,26124),
(63371,'What could it mean? I can see a lot of turmoil in your heart, my new friend.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(63372,'I see - one of your great Alliance warriors, is it? You have chosen a lion as your crest.','',0,0,0,0,0,0,1,0,1,0,31793,0,26124),
(63373,'Your people are both stout and ferocious. But always remember, the lion kills only when hungry.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63374,'Here they come, yes, yes. You see how easy it is to make friends here?','',0,0,0,0,0,0,404,0,1,0,31795,0,26124),
(63375,'Please remember that not all of your allies in Pandaria will be won over by sword point.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63376,'Well, my birds have taken a liking to you. I will follow their lead.','',0,0,0,0,0,0,4,0,1,0,31796,0,26124),
(63377,'Welcome, my new Alliance friend! How can I be of service?','',0,0,0,0,0,0,404,0,1,0,0,0,26124),
(63378,'You are too late! The Thunder King will rise and take dis land from you.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(63379,'Where have the Thunder King\'s Remains been taken?!','Where have the Thunder King\'s Remains been taken?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63380,'$p! You\'ve saved us! We\'ll go somewhere safe.','$p! You\'ve saved us! We\'ll go somewhere safe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63381,'The yaungol are so powerful... maybe we need to look to your people for protection.','The yaungol are so powerful... maybe we need to look to your people for protection.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63382,'My home... I wonder if it\'s still standing. I\'ll go back and find out!','My home... I wonder if it\'s still standing. I\'ll go back and find out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63383,'I... I saw my life flash before my eyes!','I... I saw my life flash before my eyes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63384,'An outsider... saved me?','An outsider... saved me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63385,'I\'m... alive? I\'m alive! I\'m alive!','I\'m... alive? I\'m alive! I\'m alive!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63386,'Your serpent will not venture beyond The Arboretum! Return to the Arboretum now!','Your serpent will not venture beyond The Arboretum! Return to the Arboretum now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63387,'How did they find us? Ready your weapons - we\'ve got to get out of this canyon!','',6,0,0,0,0,0,0,0,7,0,25871,0,26124),
(63388,'For the empress!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63389,'Niuzao will fall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63390,'The temple will be ours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63391,'You are a fool to oppose the empress!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63392,'All of pandaria will bow to the empress!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63393,'You are venturing beyond training space! Return to The Arboretum or The Jadespire Sea before you are thrown off!','You are venturing beyond training space! Return to The Arboretum or The Jadespire Sea before you are thrown off!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63394,'Imperial Vizier Zor\'lok inhales the Pheromones of Zeal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63395,'Are you ready to display your martial prowess here, in the eye of The Tiger?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63396,'Ready for the next fight? Ring that gong and GET! IT! ON!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63397,'Fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63398,'For the empress!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63399,'Destroy the temple!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63400,'Show them her strength!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63401,'Hozen-grooker! Run!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63402,'Run! It\'s the ookin\' hozen-grooker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63403,'Can\'t let you back in.$B$BThey\'re still fighting in there.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(63404,'Fight\'s over.$B$BReady to go back inside?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63405,'Enter the arena.','Enter the arena.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(63406,'DOOK OOKEM GROOKER!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63407,'Thank you, grandchildren.','',0,0,0,0,0,0,0,0,1,0,27827,0,26124),
(63408,'Thank you, $r.','Thank you, $r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63409,'My mind is clear. Thank you, $r.','My mind is clear. Thank you, $r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63410,'You will not break us, sha!','You will not break us, sha!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63411,'Begone, minions of doubt!','Begone, minions of doubt!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63412,'We shall dispel you from this land!','We shall dispel you from this land!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63413,'Good to see a $c on our side!','Good to see a $c on our side!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63414,'Drive them back!','Drive them back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63415,'Return to the earth!','Return to the earth!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63416,'','You wanna be part of Soggy\'s crew? Then you\'re gonna start at the bottom like everyone else.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63417,'Jinyu lover!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63418,'Sssuch weapons. I must have them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63419,'Sssurrender!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63420,'What ssshiny armor. Give it to me now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63421,'Bleeeeeed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63422,'Surrender, warm blood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63423,'Your weapons are weak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63424,'The Keg Bomb is becoming unstable!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63425,'|TInterface\\Icons\\warrior_talent_icon_thunderstruck.blp:20|t Garalon flies up high and prepares a |cFFFF0000|Hspell:128555|h[Massive Crush]|h|r!','|TInterface\\Icons\\warrior_talent_icon_thunderstruck.blp:20|t Garalon flies up high and prepares a |cFFFF0000|Hspell:128555|h[Massive Crush]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63426,'[PH - Pretend there is a totally awesome cutscene here.]BOOM! You just blew up a bunch of yaungol! Oh man, they\'re running away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63427,'[PH]Lin\'s chasing after them. Oh no! Lin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63428,'[PH]A wild yaungol boss appears (from beyond the gate) and roars at you. You best get ready for a boss fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63429,'Do you mind? We\'re trying to get a picture, here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63430,'I can\'t wait to send this picture to my girl back home. She\'s gonna freak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63431,'Let\'s see here...$B$B\"Finding the proper f-stop. The f-number is the focal length divided by the \'effective\' aperture diameter.\"$B$BThis is making my head hurt.','Let\'s see here...$B$B\"Finding the proper f-stop. The f-number is the focal length divided by the \'effective\' aperture diameter.\"$B$BThis is making my head hurt.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63432,'Thanks to the small fortune we made last season I was able to mail-order this fancy new camera!','Thanks to the small fortune we made last season I was able to mail-order this fancy new camera!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63433,'I\'m really focusing on my photography right now.','I\'m really focusing on my photography right now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63434,'Would you hurry up? My arms are getting tired!','Would you hurry up? My arms are getting tired!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(63435,'Just take the picture already!','Just take the picture already!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(63436,'Just a second! You can\'t rush art!','Just a second! You can\'t rush art!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63437,'\"...focusing at the hyperfocal distance ensures maximum sharpness from half this distance all the way to infinity...\"','\"...focusing at the hyperfocal distance ensures maximum sharpness from half this distance all the way to infinity...\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63438,'Hey, what do you suppose your \"hyperfocal distance\" is right now?','Hey, what do you suppose your \"hyperfocal distance\" is right now?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63439,'I\'m ready to leave. Let\'s go!','I\'m ready to leave. Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63440,'Reload!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63441,'','Riders approach!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63442,'Who is that?','Who is that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63443,'Oh my, what is that thing?','Oh my, what is that thing?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63444,'I have never seen one of those before.','I have never seen one of those before.',0,0,0,0,0,0,0,0,1,13211,0,0,26124),
(63445,'Are you here to see the Jade Serpent?','Are you here to see the Jade Serpent?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63446,'Wow... so many weapons.','Wow... so many weapons.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63447,'Is that a sort of grummle?','Is that a sort of grummle?',0,0,0,0,0,0,0,0,1,7272,0,0,26124),
(63448,'Is... Is that a troll? Like from the story books?','Is... Is that a troll? Like from the story books?',0,0,0,0,0,0,0,0,1,5579,0,0,26124),
(63449,'What strange clothes you have.','What strange clothes you have.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63450,'You look... different.','You look... different.',0,0,0,0,0,0,0,0,1,13210,0,0,26124),
(63451,'What strange clothes you have.','What strange clothes you have.',0,0,0,0,0,0,0,0,1,13210,0,0,26124),
(63452,'Are you from Kun-Lai?','Are you from Kun-Lai?',0,0,0,0,0,0,0,0,1,13210,0,0,26124),
(63453,'Did you come from the turtle?','Did you come from the turtle?',0,0,0,0,0,0,0,0,1,13210,0,0,26124),
(63454,'Who is that?','Who is that?',0,0,0,0,0,0,0,0,1,13210,0,0,26124),
(63455,'How many weapons do you need?','How many weapons do you need?',0,0,0,0,0,0,0,0,1,13210,0,0,26124),
(63456,'Hurry $p! Use the barrels to defeat those monstrosities!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63457,'Alright, let\'s go up to the monastery.','Alright, let\'s go up to the monastery.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63458,'What is he doing over there?','What is he doing over there?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(63459,'Don\'t mind those two idiots outside - they\'re caught up in some fad called \"sharking.\"$B$BI\'d wager they feel pretty dumb about that picture in a couple of months.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63460,'This is going to be so epic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63461,'You came not a moment too soon, Wakener. The Adjuncts would have destroyed me as I slept.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63462,'Even in my dreams, I could hear their dark thoughts... HER dark thoughts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63463,'You can use the shark in a minute, just wait your turn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63464,'We can use the balloon. Follow me!','',0,0,0,0,0,0,0,0,1,0,30597,0,26124),
(63465,'The Empress fears her own undoing, yet fear itself is her undoing. She is gone beyond the edge of madness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63466,'There is much punishment to deliver for the empire\'s crimes. We have no time to waste, Wakener. Meet me outside.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63467,'Thank you Elders. We will not dissapoint you.','',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(63468,'You look like you could make us some money.$B$BHow about a spin inside the Arena of Annihilation, pal?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63469,'Rip the flesh from their bones!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63470,'Leave nothin\' behind!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63471,'Make dem fear the Zandalari!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63472,'Feed on them my pets!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63473,'Will these invaders ever stop?!','Will these invaders ever stop?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63474,'Their cruelty seems to know no end.','Their cruelty seems to know no end.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63475,'I feel as though I\'ve been out here for days...','I feel as though I\'ve been out here for days...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63476,'I\'ll die before I see this village fall!','I\'ll die before I see this village fall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63477,'I\'ll cover your post. Go rest and be with your family.','You\'re exhausted. Go rest and prepare for the battle to come.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63478,'I\'ll die before I see this village fall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63479,'I feel as though I\'ve been out here for days...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63480,'Their cruelty seems to know no end.','Their cruelty seems to know no end.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63481,'Hey there, $r. Lorewalker Cho told me aaaaallll about you. Or at least, the important stuff. Folks around here might be a little hesitant around you though so you may want to get on their good side first.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63482,'Another stranger? Does your kind enjoy a good brew? If so, try some Goldendraft Reserve!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63483,'So, stranger, are you the wild and crazy type like the hozen?$b$bOr the quiet and thoughtful type like the jinyu?','So, stranger, are you the wild and crazy type like the hozen?$b$bOr the quiet and thoughtful type like the jinyu?',0,0,0,0,0,0,0,0,1,13211,0,0,26124),
(63484,'Are you from beyond the wall?','Are you from beyond the wall?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63485,'Where did you come from?','Where did you come from?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63486,'Wow. You look... um... well... different than I would have expected. Are there more like you?','Wow. You look... um... well... different than I would have expected. Are there more like you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63487,'What interesting colors you are wearing. Did you weave that yourself?','What interesting colors you are wearing. Did you weave that yourself?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63488,'Are there more like you?','Are there more like you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63489,'Why, hello stranger. You look like a creature that has stories to tell.','Why, hello stranger. You look like a creature that has stories to tell.',0,0,0,0,0,0,0,0,1,13211,0,0,26124),
(63490,'What a fascinating jawline you have. And such coloration. Where did you come from?','What a fascinating jawline you have. And such coloration. Where did you come from?',0,0,0,0,0,0,0,0,1,13211,0,0,26124),
(63491,'Hmm. What armor...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63492,'A stranger? Well look at that. I wonder where it came from.','A stranger? Well look at that. I wonder where it came from.',0,0,0,0,0,0,0,0,1,13210,0,0,26124),
(63493,'What a strange and curious creature. Do you come to my town with peaceful intentions?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63494,'Another stranger? And so... strange looking.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63495,'That poor creature. It\'s so thin... it must be starving.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63496,'It\'s that stranger Cho mentioned. I wonder if there are more of them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63497,'Welcome stranger. It has been a long time since I\'ve seen someone new travel through here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63498,'And where did you come from I wonder? Some place that lacks for quality beverages? Hmm?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63499,'What strange garb you wear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63500,'A stranger? Here? Don\'t start any trouble in our town.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63501,'Are you from the Turtle?','Are you from the Turtle?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63502,'How big is your family?','How big is your family?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63503,'Did you ever see the big wall in the west?','Did you ever see the big wall in the west?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63504,'Are you a fighter? Can you teach me how you fight?','I bet my dad could beat you up. He\'s the biggest monk ever.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63505,'Why are you so thin?','Why are you so thin?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63506,'You dress funny.','You dress funny.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63507,'Who shaved off all your fur?','Who shaved off all your fur?',1,0,0,0,0,0,0,0,1,7270,0,0,26124),
(63508,'Are you a grummle? Where\'s your backpack?','Are you a grummle? Where\'s your backpack?',1,0,0,0,0,0,0,0,1,7272,0,0,26124),
(63509,'Are you a yaungol? I heard yaungol are bad.','Are you a yaungol? I heard yaungol are bad.',1,0,0,0,0,0,0,0,1,7273,0,0,26124),
(63510,'Why are you so pink and hairless?','Why are you so pink and hairless?',1,0,0,0,0,0,0,0,1,7268,0,0,26124),
(63511,'You have floppy ears!','Why are your ears flopping?',1,0,0,0,0,0,0,0,1,7269,0,0,26124),
(63512,'You have floppy ears!','Why are your ears flopping?',1,0,0,0,0,0,0,0,1,5576,0,0,26124),
(63513,'Your face looks angry.','Your face looks angry.',1,0,0,0,0,0,0,0,1,7274,0,0,26124),
(63514,'What happned to your backpack, grummle?','You look green. Are you sick?',1,0,0,0,0,0,0,0,1,10103,0,0,26124),
(63515,'Are you a mogu?','You walk like a mogu!',1,0,0,0,0,0,0,0,1,5685,0,0,26124),
(63516,'Are you a troll?! I heard trolls are evil.','Are you a troll? Like from the storybooks?',1,0,0,0,0,0,0,0,1,5579,0,0,26124),
(63517,'','I\'m going ahead. I will see you on the other side... I hope.',0,0,0,0,0,0,5,0,1,0,0,31306,26124),
(63518,'|TInterface\\Icons\\ability_warlock_everlastingaffliction.blp:20|t%s is affected by |cFFFF0000|Hspell:123011|h[Terrorize]|h|r! Dispel %s!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63519,'Ha! What say you to master swordsman, Tenwu the Red Smoke?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63520,'','Shall we get a move on?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63521,'It is a good day for a hunt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63522,'Blade Lord Ta\'yak marks $n for |cFFFF0000|Hspell:122949|h[Unseen Strike]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63523,'Does the agony ever stop?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63524,'What has the world come to when you can\'t even die without crabs picking at you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63525,'I\'m not dead yet you scavenger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63526,'How fitting. The fisherman eaten by the fish...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63527,'Hi!','Hi!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63528,'The stranger is here!','The stranger is here!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63529,'I saw it first!','I saw it first!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63530,'Are you of beard-sprite?','Are you a sprite?',1,0,0,0,0,0,0,0,1,7270,0,0,26124),
(63531,'I\'m almost as tall as you!','I\'m almost as tall as you!',1,0,0,0,0,0,0,0,1,7270,0,0,26124),
(63532,'Thank you. Mind if I tag along and take some revenge?','Thank you. Mind if I tag along and take some revenge?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(63533,'Wow! I\'m taller than you!','Wow! I\'m taller than you!',1,0,0,0,0,0,0,0,1,7272,0,0,26124),
(63534,'Are there other grummles coming?','Are there other grummles coming?',1,0,0,0,0,0,0,0,1,7272,0,0,26124),
(63535,'Cho said you were a \"hooman\". Is that like a hozen?','Cho said you were a \"hooman\". Is that like a hozen?',1,0,0,0,0,0,0,0,1,7268,0,0,26124),
(63536,'Why are you so thin?','Why are you so thin?',1,0,0,0,0,0,0,0,1,7268,0,0,26124),
(63537,'Why are you so green?','Why are you so green?',1,0,0,0,0,0,0,0,1,7274,0,0,26124),
(63538,'Why do you make so many angry sounds?','Why do you make so many angry sounds?',1,0,0,0,0,0,0,0,1,7274,0,0,26124),
(63539,'Get those supplies moved!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63540,'Friend, this is Dawn\'s Blossom! The heart of Pandaren life here in the Jade Forest. If you wish to make an impression, I am certain many of these citizens could use your help.','',1,0,0,0,0,0,0,0,1,0,30092,0,26124),
(63541,'For now I must leave you. Toya is gathering jade for my project. When he is finished I would like you to bring it to me at the Emperor\'s Omen so that we might look at what secrets history has hidden from us.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63542,'Your timing is flawless. I was just about to leave. But please, stay and enjoy the town while Toya gathers the jade we need.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63543,'See you later!','See you later!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63544,'Bye!','Bye!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63545,'I\'m gonna go play.','I\'m gonna go play.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63546,'Careful with the scorpion, he may look friendly but he is a beast in battle!','Careful with the scorpion, he may look friendly but he is a beast in battle!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63547,'Are you eyeing my cat?','Are you eyeing my cat?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(63548,'Hello fellow angler!  Have you been around these parts long?  Me and my buddy \"Big Hook\" here travel far and wide looking for the next big catch!$b$bWe ran into this place by accident and the locals were friendly with both their supplies and booze so we decided to stick around!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63549,'Been working for the anglers?  Check out these rewards!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63550,'Mogu\'Shan Palace, a level 87-89 dungeon in the Vale of Eternal Blossoms, is now available for testing. Please be in your full group before teleporting to the dungeon. Meeting Stones are not available for this dungeon yet.\n\nTo leave Mogu\'Shan Palace, simply exit through the normal exit inside the dungeon and you will be teleported to Dalaran. If you die and release, you should teleport back from this NPC.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63551,'%s activates his |cFFFF0404|Hspell:119311|h[Stream of Blades]|h|r trap!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63552,'I\'m in my group and ready to teleport to Mogu\'Shan Palace!','I\'m in my group and ready to teleport to Mogu\'Shan Palace!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63553,'Take me back to Mogu\'Shan Palace!','Take me back to Mogu\'Shan Palace!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63554,'%s activates his |cFFFF0404|Hspell:120142|h[Crossbow]|h|r trap!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63555,'%s activates his |cFFFF0404|Hspell:119374|h[Whirlwinding Axe]|h|r trap!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63556,'We shall rise again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63557,'Please fly me to the Terrace of Gurthan.','Please fly me to the Terrace of Gurthan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63558,'Word of your travels has reached me. You ride on the winds of change.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63559,'I am curious, in your homeland, is there ever peace?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63560,'And how have you been enjoying our land? Have you been learning?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63561,'The art of the Windfur Punch has been handed down from generation to generation in my family since the dark days.$b$bIt is said this punch was first attempted during the dark days of the mogu empire, and aided in earning pandaren their freedom.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63562,'Your visit is like the gust of wind before the storm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63563,'I am told you were a guest of the forest hozen and survived. I suspect we will see interesting things from you in the coming days.$b$bI welcome you, traveller, to our humble home.','',0,0,0,0,0,0,0,0,1,17263,0,0,26124),
(63564,'Wind is better bent, than broken. ...get it? I made a funny.','',1,11,0,0,500,0,0,0,1,0,0,0,26124),
(63565,'So you are the creature who gave the jinyu the courage they needed to stand their ground against the hozen.$b$bSuch courage is something we have not seen in some time. I welcome you to our humble home.','',0,0,0,0,0,0,0,0,1,17264,0,0,26124),
(63566,'You battled well today, $p. May you wear your title with honor.','',1,2,0,0,500,0,0,0,1,0,0,0,26124),
(63567,'%s casts |cFFFF0000|Hspell:107140|h[Magnetic Shroud]|h|r.  Group up to release the healing energy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63568,'So... you\'re the stranger Cho was talking about.$b$bWelcome to Dawn\'s Blossom! I am Peiji Goldendraft and my family makes only the finest brews in Pandaria.$b$bUnlike those Wanderbrews who keep slinking around ruining the good name of Brewmasters everywhere. I think I even spied the young one eyeing my daughter. Can\'t have that! Goldendrafts and Wanderbrews do not mix.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63569,'I\'m going to keep looking for jade. May want to ask around and see if anyone could use a hand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63570,'Hozen only give name name to good grookers.$b$bMaybe one day they call you $n $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63571,'We\'re doomed!','',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(63572,'Hurry elders! You must hide!','',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(63573,'I swear I saw that little Syra Goldendraft giving my boy \"the looks\". Can\'t have that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63574,'Thank goodness you\'re here!  Toss that fishing pole and help us out!','Thank goodness you\'re here!  Toss that fishing pole and help us out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63575,'Kovok seems to have weathered the years in hibernation well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63576,'Going to Kun-Lai? Hop in the boat and I\'ll give you a ride.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63577,'A fellow angler I see!  I have a variety of gear from these local fisherman, just let me know what you need!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63578,'My research must continue.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63579,'No, no, no! I cannot stop now. My mutations must live!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63580,'I have coated your hands with a special mixture, Wakener. Every time you defeat an enemy, their corpse will be injected with a special toxin. Observe the results, and use them to your advantage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63581,'All creatures have their uses, Wakener, but you must kill them to find out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63582,'May the amber protect and nourish you, Wakener.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63583,'Let my strength be your strength. For every damaging strike you make, you shall steal some of your opponent\'s life in return.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63584,'I have coated your weapons with a special serum. Use it to inject your enemies. Too many injections, and their systems will overload.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63585,'Come, Wakener. Let us meet our enemies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63586,'How many years have passed since I first entered the slumber? This vess, the palace, my Empress. All have changed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63587,'Is this white blight the work of the sha? I see now what disease spreads across our civilization. The infected must be purged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63588,'Just look at those mantid below us. The Empress orders the Swarm much too early! Another sign of her chaotic delusions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63589,'Why are they already swarming? The time has not yet come.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63590,'Travelling on Valley roads is strange. The ground is so flat here and it is too hot.$b$bI miss Kun-Lai.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63591,'Something drives them. They are frightened.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63592,'No matter. Even I can feel the evil that taints their minds. Let us end their madness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63593,'I see that my slumber was brief. I recognize Mel\'jarak, lord of the skies. Once, my brother. Now, no longer.','',0,0,0,0,0,0,0,0,1,17344,0,0,26124),
(63594,'I see that my slumber was brief. I recognize Ta\'yak there, just in front of the palace. The Empress\'s champion of blades. In my time, he stood undefeated.','',0,0,0,0,0,0,0,0,1,17345,0,0,26124),
(63595,'I see that my slumber was brief. I recognize Un\'sok down there. I see he has renamed himself Ambershaper. Ha! His skills never did surpass my own.','',0,0,0,0,0,0,0,0,1,17346,0,0,26124),
(63596,'I see that my slumber was brief. I recognize Zor\'lok, voice of the Empress. Her obedient little pet.','',0,0,0,0,0,0,0,0,1,17347,0,0,26124),
(63597,'I am ready to fly, Xaril.','I am ready to fly, Xaril.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63598,'Repairing the damage Kor\'ik did will take time, but it can be done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63599,'You hear a faint clicking noise coming from the west...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63600,'A high pitch humming noise emanates in the distance...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63601,'The gem shatters!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63603,'You see a brief glimmer along the east wall...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63604,'Where can I find Assistant Buzaki?','Where can I find Assistant Buzaki?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63605,'Anything else I can do?','Anything else I can do?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63606,'Wikket whacked!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63607,'Dooker OOKED!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63608,'Get grooked, dooker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63609,'The final ingredient, a secret passed down through generations of my family, comes all the way from the Krasarang Wilds. I sent Assistant Buzaki to pick it up for me a few days ago, and received word that he reached the Tavern in the Mists last night. Can you head into the Ancient Passage and find out what\'s keeping him? He better not still be asleep at the tavern!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63610,'Look lively, mates!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(63611,'There\'s Horde to kill, lads! I can smell \'em!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(63612,'It\'s do or die, chaps! No turnin\' back!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(63613,'A few monkeys are no match for the Alliance!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(63614,'Stand down, savages! I claim this land in the name of the Alliance!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(63615,'Hang on, men! Reinforcements are inbound!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(63616,'Get grooked, wik-','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63617,'Grant me your assistance, Malik. [Klaxxi Enhancement]','Grant me your assistance, Malik. [Klaxxi Enhancement]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63618,'The trick, Wakener, is to be like water. Do not resist your enemy\'s force - simply flow with it. Let his blows drift past you. Then IMPALE HIM.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63619,'Need a flapper?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63620,'Send me to Dawn\'s Blossom.','Send me to Dawn\'s Blossom.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63621,'Thanks, $p! I thought I was done for.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63622,'I panicked when I saw all those saurok and wrecked my boat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63623,'I need to get this to Brewmaster Boof before the festival starts. Thanks again for saving me, $p!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63624,'Ah! Good! You made it. It is time to teach these \"pirate\" hozen why they should not raid our villages.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63625,'Are you sure you\'re ready to head out?','Are you sure you\'re ready to head out?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63626,'The amber offers a paragon\'s respite, Wakener. Should you fall near death, it will activate on its own.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63627,'Show no mercy! Thrive on the scent of blood! The more you attack, the more health you will regain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63628,'','It looks like he\'s just unconscious. I should be able to wake him up.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63629,'','Let\'s get back to the festival, $p. Stop by my house later, I\'m making something special!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63630,'','Brewmaster! Bataari scouting parties have been sighted outside the village!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63631,'Is that... HEY! You brought \'em back!','',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(63632,'You saved me! What a hero!','You saved me! What a hero!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63633,'I always knew a $pc could beat up a yaungol!','I always knew a $pc could beat up a yaungol!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63634,'Where... where did you come from? Thank you!','Where... where did you come from? Thank you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63635,'','The air is so clean here.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63636,'','I grew up on the Wandering Isle. Space was so limited there. Never room to hunt and never really any predators worth mentioning.$b$bBut here... here there are the great mushan and wolves and all sorts of predators. This is this hunter\'s dream come true.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63637,'','First time in Pandaria? Mine too. I remember the stories they would tell us of this place. So exciting!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63638,'','I first met the Nesingwarys in Stranglethorn. I\'ve been bumping in to them off and on ever since. I finally earned a place in their safari!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63639,'','Oh! I think I recognize you. You\'re from the Wandering Isle right?$b$bIsn\'t it so strange to be in Pandaria?$b$bI always thought this place was nothing more than a legend. I can\'t believe it actually exists!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63640,'','There is so much life here. And so much space.$b$bBack on the Wandering Isle there was never enough space for predators to grow large enough to hunt.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63641,'','Ah good! You found the safari. That jungle is a little rough to navigate without some travel sense.$b$bThose mogu kept getting in the way of my hunting.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63642,'|TInterface\\Icons\\creatureportrait_bubble.blp:20|t%s casts |cFFFF0000|Hspell:124653|h[Water Shell]|h|r! Use the Water Spouts to pop it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63643,'A hunter hunts. An artist... arts.$b$bI am here to capture the ferocity of the hunt through my art.$b$bWe are in strange lands, and few in the known world are familiar with the strange creatures of our hunt.$b$bThrough my art, I prove your success, and the success of the Nesingwarys.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63644,'','Drink up, $p. I wanna see that vial empty before you so much as dip a toe into the sea.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63645,'','There you go. Tastes like seaweed and hot garbage, doesn\'t it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63646,'','Welcome to the North Wind Tavern.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63647,'','Greetings friend! Will you require a room for the night?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63648,'Can you help me get out on the water, Tart?','Can you help me get out on the water, Tart?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63649,'I never thought I would have to pick up a weapon to use it again...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63650,'I had almost fooled myself into believing Zouchin was protected from the darkness in the world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63651,'I retired from battle to live in peace with my family. It seems battle will not let me retire so easily.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63652,'I was once a great fighter. Let us hope old age has not taken too much of my skill from me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63653,'Preparing this village is not just about putting weapons in their hands. We must teach them to use them with confidence.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63654,'','Thanks again, $p! I\'ll get this to Brewmaster Boof right away.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63655,'Anduin... run...','',0,0,0,0,0,0,0,0,1,0,29622,0,26124),
(63656,'','We meet again, stranger from beyond the mists.',0,0,0,0,0,0,0,0,1,0,0,28561,26124),
(63657,'','This battle has extracted a heavy toll. My own rebirth will have to wait for several years.',0,0,0,0,0,0,0,0,1,0,0,28562,26124),
(63658,'','Learn from this, stranger!',0,0,0,0,0,0,0,0,1,0,0,28563,26124),
(63659,'','I do not know why the mists have opened. But I know that it is for a reason.',0,0,0,0,0,0,0,0,1,0,0,28564,26124),
(63660,'','It is clear that you are not here to bring your war to these lands. There is a darkness hidden here in Pandaria - this you have seen for yourself!',0,0,0,0,0,0,0,0,1,0,0,28565,26124),
(63661,'','But I am certain that the mists parted for a reason. YOU are that reason. Find your purpose here.',0,0,0,0,0,0,0,0,1,0,0,28566,26124),
(63662,'','You can learn a great deal about this land from the Valley of the Four Winds.',0,0,0,0,0,0,0,0,1,0,0,28567,26124),
(63663,'','There is another visitor from beyond the mists here. \"Chen Stormstout\" he is called. He is Pandaren, but from a different homeland.',0,0,0,0,0,0,0,0,1,0,0,28568,26124),
(63664,'','Walk this land with Chen at your side. Make friends among the people here. You will find answers in time.',0,0,0,0,0,0,0,0,1,0,0,28569,26124),
(63665,'','Farewell, stranger. When next we meet, I hope to call you \'friend.\'',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63666,'Use the cannons! Shoot down the mantid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63667,'<The beacon hums softly.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63668,'','Help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63669,'','They are going to eat me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63670,'','Get them away from me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63671,'','I\'m too young to die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63672,'','I\'m not food!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63673,'','Someone save me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63674,'','Help! Help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63675,'','Ahhhhhhhh!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63676,'I need another shark!','I need another shark!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63677,'Interested in catching a shark?','Interested in catching a shark?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63678,'','Thanks, $p! They were going to eat me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63679,'','The virmen are eating all of the grain!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63680,'','$n, can you help me get rid of these virmen?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63681,'','Get those virmen!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63682,'','Shoo!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63683,'','Get away from there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63684,'','Save the grain, $p!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63685,'','Get those virmen, $p!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63686,'','It\'s the Den Mother! Look out, $p!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63687,'The Shado-Pan sends a lackey to do their work? Perhaps Shan\'bu was wrong about them...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63688,'Hah! You have... already... failed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63689,'','There\'s still more virmen in the silos! Can you scare them off for me, $p?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63690,'Need a break from your enemies? You have come to the right place, and the right person.','',2,1,0,0,500,0,0,0,1,0,0,0,26124),
(63691,'Oh... I seem to have lost my sword.','',0,0,0,0,0,0,0,0,5,0,30141,0,26124),
(63692,'When the Sundering ripped apart the continents of Azeroth, we pandaren thought that the rest of the world had been utterly destroyed.','',0,0,0,0,0,0,0,0,5,0,30114,0,26124),
(63693,'But as the centuries passed, one young explorer decided to see what was out there. His name was Liu Lang. And he set out to discover the world... on the back of a turtle!','',0,0,0,0,0,0,0,0,5,0,30115,0,26124),
(63694,'We celebrate his bravery with statue and song, but if you were actually there on the beach that very day - well, I\'m sure he looked quite silly, indeed.','',0,0,0,0,0,0,0,0,5,0,30116,0,26124),
(63695,'Oh, how the pandaren laughed at him. But Liu Lang was more clever than anyone thought. Sea turtles always return to the beach where they were born. And so, despite the mists that envelop our land, he always had a way home.','',0,0,0,0,0,0,0,0,5,0,30117,0,26124),
(63696,'Every few years, he returned - with tales of mysterious cities in the sand, nomadic people living on endless grassy plains, a great empire under the ice, and a magical kingdom gilded in gold.','',0,0,0,0,0,0,0,0,5,0,30118,0,26124),
(63697,'Each time he returned, more and more pandaren answered Liu Lang\'s call, and joined him on his growing turtle. They were the bravest among us: The explorers. The adventurers.','',0,0,0,0,0,0,0,0,5,0,30119,0,26124),
(63698,'And that is the lesson of Liu Lang, my friend. Everyone always laughs at the explorer. They always laugh... until he returns.','',0,0,0,0,0,0,0,0,5,0,30120,0,26124),
(63699,'Great events often have humble beginnings. Consider: a quiet pond. Still. The water is like a sheet of glass.','',0,0,0,0,0,0,396,0,5,0,30150,0,26124),
(63700,'Until I throw a stone. Such a small thing - but soon, ripples engulf the whole of the lake!','',0,0,0,0,0,0,396,0,5,0,30151,0,26124),
(63701,'The jinyu also have humble origins. Once primitive creatures, they were fortunate enough to live near the enchanted pools within the Vale.','',0,0,0,0,0,0,0,0,5,0,30152,0,26124),
(63702,'The magic of the pools expanded their minds and grew their bodies, until they became one of the great ancient cultures of Pandaria.','',0,0,0,0,0,0,0,0,5,0,30153,0,26124),
(63703,'The wisest of the jinyu are very wise indeed - they can speak to the rivers the way you and I would consult our elders.','',0,0,0,0,0,0,0,0,5,0,30154,0,26124),
(63704,'In the whispering waters, they can hear the future.','',0,0,0,0,0,0,0,0,5,0,30155,0,26124),
(63705,'The jinyu and their waterspeakers stand at the very heart of the greatest events in Pandaria\'s history.','',0,0,0,0,0,0,0,0,5,0,30156,0,26124),
(63706,'Their visions built empires, freed slaves, and warned our Last Emperor of the Sundering that shattered Azeroth ten thousand years ago.','',0,0,0,0,0,0,0,0,5,0,30157,0,26124),
(63707,'Think about it: the smallest voice can change the world. Consider that, friend, the next time you decide to start throwing stones!','',0,0,0,0,0,0,0,0,5,0,30158,0,26124),
(63708,'Oh, my student - you wish to study the mantid? Be warned: the pandaren frontier is littered with the graves of former pupils.','',1,1,0,0,500,0,0,0,5,0,30166,0,26124),
(63709,'The mantid are harsh teachers.','',0,0,0,0,0,0,0,0,5,0,30167,0,26124),
(63710,'Every generation, the mantid swarm the Serpent\'s Spine wall in great numbers. They murder many pandaren, so we kill many times their number in return. Yet each generation, they attack once more. Why do they do this?','',0,0,0,0,0,0,0,0,5,0,30168,0,26124),
(63711,'We pandaren do not know.','',0,0,0,0,0,0,0,0,5,0,30169,0,26124),
(63712,'Our ancient writings indicate that the mantid have always been here. They predate even the mogu. Where did they come from?','',1,6,0,0,500,0,0,0,5,0,30170,0,26124),
(63713,'We pandaren do not know.','',6,0,0,0,0,0,0,0,5,0,30171,0,26124),
(63714,'Perhaps, if you were to befriend the mantid, and earn a reputation among them, they would teach you their secrets. But I warn you:','',0,0,0,0,0,0,0,0,5,0,30172,0,26124),
(63715,'Nobody has ever befriended the mantid.','',0,0,0,0,0,0,0,0,5,0,30173,0,26124),
(63716,'Here is what the pandaren do know: By massacring our people, by slaughtering tens of thousands of pandaren, generation after generation, they have taught us the value of life. A precious but fleeting gift. Easily snuffed out... in an instant.','',0,0,0,0,0,0,0,0,5,0,30174,0,26124),
(63717,'This is what the mantid have taught us.','',0,0,0,0,0,0,0,0,5,0,30175,0,26124),
(63718,'What do you fear most in this world? Have you conquered your fear... or has your fear conquered you?','',0,0,0,0,0,0,0,0,5,0,30159,0,26124),
(63719,'In the ancient days before the sundering of the world, the mogu emperors ruled over Pandaria. My people were made slaves, and they were afraid.','',0,0,0,0,0,0,0,0,5,0,30160,0,26124),
(63720,'The mogu were masters of pain and torture, of dark magics and brutal weapons. No pandaren, hozen, or jinyu could resist the power they held. And my people were afraid.','',0,0,0,0,0,0,0,0,5,0,30161,0,26124),
(63721,'It was the mogu who built the Serpent\'s Spine. The most unlucky of slaves were sent to aid in its construction and defense, to be fodder for the mantid. And my people were afraid.','',0,0,0,0,0,0,0,0,5,0,30162,0,26124),
(63722,'As the empire grew, the mogu began to experiment with the secrets of the Vale. They crafted terrible weapons of living flesh and stone. And my people were afraid.','',0,0,0,0,0,0,0,0,5,0,30163,0,26124),
(63723,'In their hubris, the mogu never foresaw that their downfall lay in wait, not among their enemies, but among the oppressed. The day that one slave stood...','',0,0,0,0,0,0,0,0,5,0,30164,0,26124),
(63724,'...and was no longer afraid.','',0,0,0,0,0,0,0,0,5,0,30165,0,26124),
(63725,'Fire! It is the most magical of elements. It warms us, it cooks our food. It is the hearthfire that makes a house a home. In the right hands, fire can shape iron into swords or plowshares. Left uncontrolled, fire could destroy a city.','',0,0,0,0,0,0,0,0,5,0,30099,0,26124),
(63726,'Fire is the instrument of change.','',0,0,0,0,0,0,0,0,5,0,30100,0,26124),
(63727,'Long ago, a group of sturdy nomad hunters wandered the world. By a stroke of fate, they were here in Pandaria when the Sundering split apart the continents of Azeroth. The wanderers found themselves trapped in the Townlong Steppes, a harsh and dangerous land.','',0,0,0,0,0,0,0,0,5,0,30101,0,26124),
(63728,'Those noble hunters found a way to survive on their own. Fire was the key. They drew up oil from the ground. They used it to heat their homes, cook their food, and burn their enemies. They grew STRONG.','',0,0,0,0,0,0,0,0,5,0,30102,0,26124),
(63729,'From the flames of fate, the yaungol were born. They survive beyond the wall, for they refuse to submit to any law but their own.','',0,0,0,0,0,0,0,0,5,0,30103,0,26124),
(63730,'Has fate been cruel to the yaungol? You may as well ask if fire is good or bad.','',0,0,0,0,0,0,0,0,5,0,30104,0,26124),
(63731,'Fate is like fire; it can shape or destroy us.','',0,0,0,0,0,0,0,0,5,0,30105,0,26124),
(63732,'All that matters is what you do with it.','',0,0,0,0,0,0,0,0,5,0,30106,0,26124),
(63733,'Ah! You wish to learn of our last and greatest emperor, Shaohao? My friend, I do not have the time here to recount all of his adventures, but his actions ten thousand years ago resonate to this very day.','',0,0,0,0,0,0,0,0,5,0,30107,0,26124),
(63734,'We know that he purged his doubts in the Jade Forest. That he cleansed himself of despair in the Krasarang Wilds. That he overcame his fear in Townlong Steppes. And that he defeated anger, hatred, and violence high in the mountains of Kun-Lai.','',0,0,0,0,0,0,0,0,5,0,30108,0,26124),
(63735,'This is known; and there are temples to mark these most sacred of places.','',0,0,0,0,0,0,0,0,5,0,30109,0,26124),
(63736,'But I want you to imagine standing in this very valley on the day he returned from his journey. Imagine being here when the gates opened for him. By then our emperor was a creature of pure light: No doubts, no fears, no hatred...','',0,0,0,0,0,0,0,0,5,0,30110,0,26124),
(63737,'It is said that all the trees in the vale blossomed as he entered, and continue to blossom to this day.','',0,0,0,0,0,0,0,0,5,0,30111,0,26124),
(63738,'Would that we could all live like our most sacred emperor. That we could put aside all our burdens and exist in harmony with the cosmos. THAT, I believe, was his message to us... before he became one with the land, and hid Pandaria away from the terror of the Sundering.','',0,0,0,0,0,0,0,0,5,0,30112,0,26124),
(63739,'Thank you, dear emperor.','',0,0,0,0,0,0,0,0,7,0,30113,0,26124),
(63740,'One day, a father grew tired of his young cub\'s misbehavior.  \"You act just like a hozen!\" the father scolded. Still, his son misbehaved.','',0,0,0,0,0,0,0,0,5,0,30142,0,26124),
(63741,'To teach him a lesson, the father dragged the cub out to the forest, to watch how the hozen live. \"Do you see what the hozen are like?\" he asked. \"Do you want to live like that?\"','',0,0,0,0,0,0,0,0,5,0,30143,0,26124),
(63742,'The hozen are quite lively indeed. A short-lived race, few hozen survive past their 20th birthday. Their leaders are all 14 or 15. How mature were you at 14 years old? Meditate on that!','',0,0,0,0,0,0,0,0,5,0,30144,0,26124),
(63743,'Afterwards, the father asked his cub what he had learned.','',0,0,0,0,0,0,0,0,5,0,30145,0,26124),
(63744,'\"I learned that we work and toil on our little farm, but that the hozen have the whole world as their garden,\" the cub said. \"I learned that we squint by the light of a single candle, but that the hozen enjoy the light of the stars. I learned that I go to school every day, but that the hozen learn by doing.\"','',0,0,0,0,0,0,0,0,5,0,30146,0,26124),
(63745,'And the cub concluded, \"I should very much like to live like a hozen!\"','',0,0,0,0,0,0,0,0,5,0,30147,0,26124),
(63746,'Who then, was the wiser? The father or the cub?','',0,0,0,0,0,0,0,0,5,0,30148,0,26124),
(63747,'That, my friend, is for you to decide.','',0,0,0,0,0,0,0,0,5,0,30149,0,26124),
(63748,'It\'s been quite some time since someone was brave enough to challenge me.','',0,0,0,0,0,0,1,0,1,0,30774,0,26124),
(63749,'I\'ll see you in the ring.','',0,0,0,0,0,0,1,0,1,0,30775,0,26124),
(63750,'Don\'t hold back.','',0,0,0,0,0,0,1,0,1,0,30776,0,26124),
(63751,'You give a good fight!  Don\'t stop now.','',0,0,0,0,0,0,1,0,1,0,30777,0,26124),
(63752,'WHITEFEATHER?!  Nooooo!','',0,0,0,0,0,0,1,0,1,0,30778,0,26124),
(63753,'You... have... bested me...','',0,0,0,0,0,0,1,0,1,0,30779,0,26124),
(63754,'You are impressive indeed.  It would be my honor to fight beside you.','',0,0,0,0,0,0,1,0,1,0,30780,0,26124),
(63755,'My compliments, friend.  I can\'t remember the last time someone bested me so handily.','',0,0,0,0,0,0,1,0,1,0,30781,0,26124),
(63756,'Niuzao... we must save him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63757,'Alright. Let\'s go.','Alright. Let\'s go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63758,'Ahahaha, the great Niuzao, strength of the west, divine celestial, protector of the weak...','',0,0,0,0,0,0,0,0,1,0,31206,0,26124),
(63759,'Your charge, the sha of fear, has escaped.','',0,0,0,0,0,0,0,0,1,0,31207,0,26124),
(63760,'You wield the powers of a god, but you are beaten!','',0,0,0,0,0,0,0,0,1,0,31212,0,26124),
(63761,'The mantle of a god must be heavy to bear.','',0,0,0,0,0,0,0,0,1,0,31213,0,26124),
(63762,'Lay your duties aside and rest.','',0,0,0,0,0,0,0,0,1,0,31214,0,26124),
(63763,'You bear the burden of an entire people upon your shoulders. And how have they repaid you?','',0,0,0,0,0,0,0,0,1,0,31215,0,26124),
(63764,'You suffer in silence for a people who give little thanks.','',0,0,0,0,0,0,0,0,1,0,31216,0,26124),
(63765,'I\'ve won the Brew Toss competition six years running! If you\'d like, I can toss this brew all the way across the village and cause a brew strike! All you have to do is point.  Would you like that?','I\'ve won the Brew Toss competition six years running! If you\'d like, I can toss this brew all the way across the village and cause a brew strike! All you have to do is point.  Would you like that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63766,'Absolutely! I\'d love to see that!','Absolutely! I\'d love to see that!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63767,'No thanks...','No thanks...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63768,'I will NEVER yield!','',0,0,0,0,0,0,0,0,1,0,31032,0,26124),
(63769,'Coldbite Matriarch begins to summon Coldbite Hatchlings.','Coldbite Matriarch begins to summon Coldbite Hatchlings.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63770,'Imperial Vizier Zor\'lok flies to one of his platforms!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63771,'|TInterface\\Icons\\ability_warrior_battleshout.blp:20|tImperial Vizier Zor\'lok sends |cFFFF0000|Hspell:122336|h[Sonic Rings]|h|r across the room!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63772,'|TInterface\\Icons\\spell_druid_stamedingroar.blp:20|tImperial Vizier Zor\'lok |cFFFF0000|Hspell:122852|h[Inhales]|h|r a large breath!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63773,'|TInterface\\Icons\\spell_shadow_psychicscream.blp:20|tImperial Vizier Zor\'lok |cFFFF0000|Hspell:122761|h[Exhales]|h|r with great force at |cFFFF0000$n|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63774,'|TInterface\\Icons\\warrior_disruptingshout.blp:20|tImperial Vizier Zor\'lok shouts with |cFFFF0000|Hspell:122713|h[Force and Verve]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63775,'|TInterface\\Icons\\trade_archaeology_delicatemusicbox.blp:20|tImperial Vizier Zor\'lok sings the |cFFFF0000|Hspell:123791|h[Song of the Empress]|h|r, damaging all players until they engage in combat with him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63776,'|TInterface\\Icons\\spell_arcane_mindmastery.blp:20|tImperial Vizier Zor\'lok uses his voice to |cFFFF0000|Hspell:122740|h[Convert]|h|r members of the raid to fight on his side!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63779,'|TInterface\\Icons\\ability_warrior_bladestorm.blp:20|tWind Lord Mel\'jarak begins to cast |cFFF00000|Hspell:121896|h[Whirling Blade]|h|r!','|TInterface\\Icons\\ability_warrior_bladestorm.blp:20|tWind Lord Mel\'jarak begins to cast |cFFF00000|Hspell:121896|h[Whirling Blade]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63780,'What the...?! This ain\'t the charter! It\'s a letter. In Arie\'s handwriting?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63781,'\"Dear Soggy, if you are reading this it means you finally worked up the guts to send someone after the old charter. Well, you\'re too late.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63782,'\"We know the Mist-Hopper wasn\'t hired to venture this far beyond the wall. We know it was supposed to be a routine job off the coast of Jade Forest.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63783,'\"What should have been a week of easy fishing turned into a wild misadventure that ran us aground in the most dangerous place on the continent and nearly got us all killed, because you couldn\'t stop chasing your hunches.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63784,'\"We just wanted to say: Thank you.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63785,'\"Thank you for chasing fortune on the distant horizon. Thank you for dreaming. And most of all, thank you for bringing us along.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63786,'\"We\'ll always be your crew, Soggy. Ship or no ship. We\'d follow you anywhere.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63787,'\"Sincerely, all of us. Even Dog.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63788,'Wow...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63789,'Would you excuse me for a moment, $p? I\'ve, uh... I\'ve got somethin\' in both my eyes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63790,'Commander, we\'re picking up an Alliance distress signal ahead.','Commander, we\'re picking up an Alliance distress signal ahead.',0,0,0,0,0,0,0,0,1,0,27443,27443,26124),
(63791,'Pull up!','Pull up!',0,0,0,0,0,0,0,0,1,0,27444,27444,26124),
(63792,'They\'re firing on us, sir!','They\'re firing on us, sir!',0,0,0,0,0,0,0,0,1,0,27445,27445,26124),
(63793,'Ugh! We\'ve been hit!','Ugh! We\'ve been hit!',0,0,0,0,0,0,0,0,1,0,27446,27446,26124),
(63794,'Our systems are jammed, Commander! I can\'t control this plane!','Our systems are jammed, Commander! I can\'t control this plane!',0,0,0,0,0,0,0,0,1,0,27447,27447,26124),
(63795,'What? Is that....LAND?','What? Is that....LAND?',0,0,0,0,0,0,0,0,1,0,27448,27448,26124),
(63796,'','That\'ll teach those virmen to try and eat me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63797,'','I need to get this grain to Brewmaster Boof so we can start the festival. See you there, $p!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63798,'Call me crazy, but I love this warm weather!  I always felt like an outcast back in Borean but I think this new climate is going to work out great for me!','Call me crazy, but I love this warm weather!  I always felt like an outcast back in Borean but I think this new climate is going to work out great for me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63799,'What are you doing so far from home?','What are you doing so far from home?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63800,'Well, times were getting tough up north.  While the scourge problem has been dealt with, we are constantly on the move and looking for food.  I decided it was time to head out and find some new fishing grounds!$b$bAfter almost a month at sea, I ended up here.  Good thing I packed a few crates of pickled herring for the trip!','Well, times were getting tough up north.  While the scourge problem has been dealt with, we are constantly on the move and looking for food.  I decided it was time to head out and find some new fishing grounds!$b$bAfter almost a month at sea, I ended up here.  Good thing I packed a few crates of pickled herring for the trip!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63801,'I have studied for years to master the art of the chi blast and would be honored to fight by your side. Would you like my assistance?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63802,'The honor is mine, to your post!','The honor is mine, to your post!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63803,'No thanks...','No thanks...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63804,'You have been selected by the |cFFFF4809|Hspell:116784|h[Heart of Fear]|h|r !','You have been selected by the |cFFFF4809|Hspell:116784|h[Heart of Fear]|h|r !',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63805,'The amber congeals to form an |cFFFF0404|Hspell:125803|h[Amber Trap]|h|r !','The amber congeals to form an |cFFFF0404|Hspell:125803|h[Amber Trap]|h|r !',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63806,'<Dog looks at you quizzically.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63807,'ZzzZZzzzz','ZzzZZzzzz',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63808,'WAKE UP! We have to defend the village, get to your mortar and help us!','WAKE UP! We have to defend the village, get to your mortar and help us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63809,'They don\'t look very helpful, we should let them sleep.','They don\'t look very helpful, we should let them sleep.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63810,'%s swims excitedly through the vents of warm water.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63811,'%s rubs against the prow of the Mist-Hopper and whimpers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63812,'%s looks around cautiously before leaving his mark on the whale corpse.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63813,'','There are four August Celestials who rule over this land.$B$BYu\'lon the Jade Serpent, lifegiver of the east.$B$BChi-Ji the Red Crane, hope of the south.$B$BXuen the White Tiger, whose strength upholds the north.$B$BAnd Niuzao the Black Ox, who stands tall in the west.$B$BRecently, with the advent of the sha, turmoil has engulfed each of their temples. They need our help, $r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63814,'The Shado-Pan hold the eternal vigil, keeping watch over the dark sha energies that were sealed away into the earth long ago.$B$BUnfortunately, the sha have escaped their prisons, and now we must defeat them once again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63815,'Beautiful day for fishing, don\'t you think?  You a fisherman, $n?  I\'ve got this old fishing lure if you\'d like it, works wonders in the waters here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63816,'I\'d love it, thank you.','I\'d love it, thank you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63817,'The Golden Lotus is charged with defending the Vale of Eternal Blossoms.$B$BIf you wish to help us, defeat enemies of the Golden Lotus who currently occupy the Vale.$B$BYou may also speak to Anji Autumnlight at the Setting Sun Garrison training camp for further tasks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63818,'The fish are biting like crazy down in Krasarang!$B$BI\'d still be out on the sea, reeling in the big one, but I came here to sell this morning\'s catch. Got lots of hungry mouths to feed here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63819,'You ever been to the Valley of the Four Winds?$B$BWe farmhands hear about the crisis here in the Vale, and the Tillers are hard at work growing food for refugees.$B$BIf you want some time out in the country, visit us at Halfhill!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63820,'Hey there. I don\'t think you want to go down that tunnel on foot. The saurok are out in force today and they are mighty territorial.','',5,0,0,0,0,0,0,0,1,15324,0,0,26124),
(63821,'The spark of life fades.','',0,0,0,0,0,0,0,0,1,0,28546,0,26124),
(63822,'What was is no longer.','',0,0,0,0,0,0,0,0,1,0,28547,0,26124),
(63823,'Countermeasures successful.','',0,0,0,0,0,0,0,0,1,0,28548,0,26124),
(63824,'Approach! Feel the power of the titans!','',0,0,0,0,0,0,0,0,1,0,28537,0,26124),
(63825,'Drawing from reserve power.','',0,0,0,0,0,0,0,0,1,0,28538,0,26124),
(63826,'Yaungol!? Now!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63827,'Let the energies consume you!','',0,0,0,0,0,0,0,0,1,0,28543,0,26124),
(63828,'Conduits offline.','',0,0,0,0,0,0,0,0,1,0,28536,0,26124),
(63829,'They must be after the Kun-Lai Kicker! $p, investigate these sightings and setup the village defenses! They won\'t get my brew without a fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63830,'I\'ll defend the brew until it\'s ready. Then we can use it against these Bataari raiders! Everyone else, get to safety!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63831,'Energy Vortex ramping down.','',0,0,0,0,0,0,0,0,1,0,28539,0,26124),
(63832,'Redirecting power.','',0,0,0,0,0,0,0,0,1,0,28540,0,26124),
(63833,'Energy Conduits active, draw stable.','',0,0,0,0,0,0,0,0,1,0,28541,0,26124),
(63834,'Hei Feng prepares to land!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63835,'Existence ends... I become nothing...','',0,0,0,0,0,0,0,0,1,0,28535,0,26124),
(63836,'','Since the dark days of the old kingdom, we pandaren have turned to the mystical art of brewing to keep our spirits and strength high.$B$BEven as we speak, brewmasters wander the world, seeking rare and powerful ingredients to craft the finest of brews.$B$BThose who seek out these elusive brewmasters and lend them aid may earn flavorful items. At the very least, you will drink plenty of brew!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63837,'I got this from some goblin, he said it can stop anything in their tracks, want to give it a try?','I got this from some goblin, he said it can stop anything in their tracks, want to give it a try?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63838,'Sure! I\'ll give it a whirl.','Sure! I\'ll give it a whirl.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63839,'Not a chance, you can keep that Mr. Derpa.','Not a chance, you can keep that Mr. Derpa.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63840,'I\'m... alive?  Thank you... thank you so much!','I\'m... alive?  Thank you... thank you so much!',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(63841,'The Shado-Pan hold the eternal vigil, keeping watch over the dark sha energies that were sealed away into the earth long ago.$B$BUnfortunately, the sha have escaped their prisons, and now we must defeat them once again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63842,'','The Golden Lotus is charged with defending the Vale of Eternal Blossoms.$B$BIf you wish to help us, defeat enemies of the Golden Lotus who currently occupy the Vale.$B$BYou may also speak to Anji Autumnlight at the Setting Sun Garrison training camp for further tasks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63843,'There are four August Celestials who rule over this land.$B$BYu\'lon the Jade Serpent, lifegiver of the east.$B$BChi-Ji the Red Crane, hope of the south.$B$BXuen the White Tiger, whose strength upholds the north.$B$BAnd Niuzao the Black Ox, who stands tall in the west.$B$BRecently, with the advent of the sha, turmoil has engulfed each of their temples. They need our help, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63844,'','Tell me, $r, have you ever had a hankering to fish?$B$BIf so, you might want to visit the Anglers down in the Krasarang Wilds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63845,'I am a member of the Tillers, the hardworking farmers of Pandaria. If you wish to learn more about us, we are located at Halfhill in the Valley of the Four Winds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63846,'Since the dark days of the old kingdom, we pandaren have turned to the mystical art of brewing to keep our spirits and strength high.$B$BEven as we speak, brewmasters wander the world, seeking rare and powerful ingredients to craft the finest of brews.$B$BThose who seek out these elusive brewmasters and lend them aid may earn flavorful items. At the very least, you will drink plenty of brew!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63847,'Hopefully this time we won\'t run into any hiccups.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63848,'Ever been to Kun-Lai before? It\'s great. Long flowing farmlands. Beautiful mountains. And absolutely nothing dangerous whatsoever.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63849,'Well... yes. There are problems with the hozen.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63850,'The spears are just for show. As long as we don\'t get out of the boat or make eye contact or get hit by a spear then we should be fine.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63851,'It\'s safe. I brought Lorewalker Cho and his strange companions up this way not long back.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63852,'You had that coming. Waving your incense about in his face... wait a minute. Something doesn\'t feel right about this.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63853,'Are those refugees? What\'s going on over there? Do I hear fighting?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63854,'These people are farmers, not fighters! They may need our help!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63855,'Yes, and the tigers.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63856,'Hozen attack grummles.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63857,'Tigers.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63858,'Saurok are very dangerous.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63859,'Lots of saurok live in the Ancient Passage.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63860,'The \"orc\" tried to punch me.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63861,'I can\'t find my shield, I\'ve looked all over the village! I wish I could help, but without my shield I\'m good for nothing!','I can\'t find my shield, I\'ve looked all over the village! I wish I could help, but without my shield I\'m good for nothing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63862,'... Your shield is on your back.  Now get up and HELP US!','... Your shield is on your back.  Now get up and HELP US!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63863,'Sorry I haven\'t seen it either.  Maybe it\'s for the best...','Sorry I haven\'t seen it either.  Maybe it\'s for the best...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63864,'HAH! You found it! Now time to fight back those yaungol.','HAH! You found it! Now time to fight back those yaungol.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63865,'Well that\'s embarrassing. To battle!','Well that\'s embarrassing. To battle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63866,'What an unlikely spot for my shield to be, irregardless, now we fight!','What an unlikely spot for my shield to be, irregardless, now we fight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63867,'The Veiled Stair is under Madam Goya\'s protection.','The Veiled Stair is under Madam Goya\'s protection.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63868,'There is much and more that can be found at the Tavern in the Mists.','There is much and more that can be found at the Tavern in the Mists.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63869,'The Tavern serves to those who do not ask too many questions.','The Tavern serves to those who do not ask too many questions.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63870,'Hei Feng takes a Deep Breath! Move behind him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63871,'Welcome, $p. We have been watching you for some time.$b$bYou are the gust of wind that heralds the storm of change.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63872,'Word reaches me you served with my brother in Townlong Steppes. How is the young fellow? Did he ever tell you how he lost his eye?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63873,'Welcome, $p. We have been watching your accomplishments since your arrival in our land.','Welcome, $p. We have been watching your accomplishments since your arrival in our land.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63874,'The saurok make it difficult for anyone to visit here other than by flying.$b$bOf course, that makes slipping off to the Tavern in the Mists very difficult.','The saurok make it difficult for anyone to visit here other than by flying.$b$bOf course, that makes slipping off to the Tavern in the Mists very difficult.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63875,'Be careful around my hawk. She\'s a biter.','Be careful around my hawk. She\'s a biter.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63876,'The mountain roads can be a dangerous place.','The mountain roads can be a dangerous place.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63877,'Never ask Hawkmaster Norung about his eye patch. You will never hear the end of it.','Never ask Hawkmaster Norung about his eye patch. You will never hear the end of it.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63878,'We will have to work quickly Wakener. This area is not safe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63879,'Your mind is strong Wakener. Even now I struggle to communicate with you. Controlling you would be near impossible...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63880,'Your thoughts intrigue me. There is purpose to your actions. Your complexity is impressive.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63881,'Your intelligence will come in handy almost as much as your skill for battle. I see much potential in a mind like yours Wakener.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63882,'We\'re here. With this weapon we will lay waste to the Empresses\' army!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63883,'I\'m pretty handy with nets, I could trap those nasty yaungol in them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63884,'Alright then, lets go tie them up!','Alright then, lets go tie them up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63885,'That\'s okay, you hang onto those nets.','That\'s okay, you hang onto those nets.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63886,'Hei Feng is landing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63887,'I\'ve mastered catching fish, now on to catching yaungol!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63888,'Me and my trusty nets will not fail this village!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63889,'Welcome to the Seat of Knowledge. And never was there a greater repository of information and wisdom to be found about the ancient days of Pandaria.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63890,'','You must be $n.$b$bI\'ve been expecting you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63891,'I could use a kite to Grookin\' Hill.','I could use a kite to Grookin\' Hill.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63892,'So be it. I shall do this myself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63893,'I am one with the mists and heal those in need.','I am one with the mists and heal those in need.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63894,'We require your aid.','We require your aid.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63895,'We don\'t need your healing skills.','We don\'t need your healing skills.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63896,'Thank you, $p. You have saved us all.','',0,0,0,0,0,0,0,0,1,0,31039,0,26124),
(63897,'We have what we need from the meddlesome Loremaster.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63898,'Remember, it is at the darkest moment that light shines the brightest.','',0,0,0,0,0,0,0,0,1,0,31040,0,26124),
(63899,'Well done, heroes.','',0,0,0,0,0,0,0,0,1,0,31041,0,26124),
(63900,'Intruders have breached the temple!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63901,'WEAKLING LIZARD! Your hide will adorn the Thunder King\'s throne!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63902,'TUNG! I\'ll feed your corpse to your useless beasts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63903,'Worthless wizard! How DARE you fail the Thunder King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63904,'CAPTAIN RO-GU?! Impossible! To think that you would falter now...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63905,'I, General Zhun, Herald of the glorious Thunder King Lei Shen, hereby challenge you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63906,'Ro-Gu, Tung, Fon, Hithiss: Guard the artifacts... with your LIVES!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63907,'I always knew I was a lumberjack at heart!','I always knew I was a lumberjack at heart!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63908,'You seem like a craftsman, $pc.  Do you think you can cut it as a woodcrafter?  If so, I have something that may help you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63909,'I could use a kite to Pearlfin Village.','I could use a kite to Pearlfin Village.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63910,'Hello again, $n.  How\'s my lure treating you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(63911,'Hello again, $n.  How is my axe treating you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(63912,'Until we meet again, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(63913,'My eternal gratitude; I had thought myself doomed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63914,'','There are so many great stories to uncover. So much history. Isn\'t it fascinating?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63915,'Juro: EXECUTE HIM!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63916,'My thanks! None of us expected to survive... I will aid you as best as I can!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63917,'They\'ve already dragged off and murdered the others. I\'m sorry... I\'m too weak to continue...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63918,'Thank you! Please, save... Lorewalker Fu if you can... I... have failed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63919,'We have entered a dangerous place my luckydo. In this the saurok have grown very angry and attack all boats that pass through. We must be on our guard.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63920,'General Zhun intends to deliver Kotmogu Temple\'s ancient artifacts to his wicked liege, the Thunder King. We cannot allow this to happen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63921,'Please, you MUST keep them out of the general\'s hands! I will return to the Vale of Eternal Blossoms and report to the Golden Lotus. Again, many thanks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63922,'<Mishi looks expectantly at you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63923,'Today, we welcome you into the Shado-Pan.','',0,0,0,0,0,0,25,0,1,0,30573,0,26124),
(63924,'Your perseverance strengthens us. Your courage leads us. Your honor inspires us.','',0,0,0,0,0,0,1,0,1,0,30574,0,26124),
(63925,'From this day forth, you walk as one of our brotherhood.','',0,0,0,0,0,0,2,0,1,0,30575,0,26124),
(63926,'Welcome $p, as a member of the Shado-Pan!','',0,0,0,0,0,0,4,0,1,0,30577,0,26124),
(63927,'I will not fail you, or this village.','I will not fail you, or this village.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63928,'I\'m supposed to guard the well. It\'s an important job!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63929,'My friends say I\'m a little slow, but I run faster than all of them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63930,'The well is very important. It\'s good that they asked me to watch it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63931,'\"Koa,\" they said, \"Go guard the well.\" That\'s what they said.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63932,'Why is everyone so afraid? I won\'t let those trolls get to our well! I\'m a good guard!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63933,'Hi! I\'m Koa! Will you be my friend?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63934,'I can allow you to bring life, from death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63935,'I like the sound of that.','I like the sound of that.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63936,'I prefer not to meddle with death.','I prefer not to meddle with death.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63937,'We\'re all going to die!','Why are they attacking us?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63938,'How will we survive?!','Who will save us?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63939,'Sumthin Happenin Here. The exact nature of it lacks clarity.','Sumthin Happenin Here. The exact nature of it lacks clarity.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63940,'This helmet is like magic, you want to give it a try? We have extras!','This helmet is like magic, you want to give it a try? We have extras!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63941,'Ab-so-lutely!','Ab-so-lutely!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63942,'No thanks, I need to stay sharp for the invasion.','No thanks, I need to stay sharp for the invasion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63943,'This is usually a calm stop. Now look at it. Where did all of these yaungol come from?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63944,'If you head northwest, look for the Grummle Bazaar. Many good trinkets and luckydos for sell there. Good fortune to be found for those who seek it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(63945,'A Bataari War Yeti approaches from the Ancient Passage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63946,'A Bataari War Yeti approaches from the Bridge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63947,'A Bataari War Yeti approaches from the west!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63948,'Got some rye?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63949,'Shine and rise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63950,'I love the Brewmoon Festival, I look forward to it every year.','I love the Brewmoon Festival, I look forward to it every year.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63951,'Yak. Yak never changes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63952,'Your yak is in another stable.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63953,'Is it dangerous to go alone?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63954,'Would you kindly show me the way back to Kunlai?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63955,'Maybe you could roll a barrel.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63956,'You could die of dysentery out here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63957,'I\'m just a pathetic creature of meat and brew.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63958,'A beautiful day, a beautiful Brew, and a beautiful fish, what more could you ask for?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63959,'Put more stuff in the thing more stuff goes in.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63960,'I don\'t often interact with the Pandaren, but when I do... Its for Brew!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63961,'Shame to sit on something so pretty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63962,'I\'ve won the Brew Toss competition six years running! I am the strongest in all of Pandaria.','I\'ve won the Brew Toss competition six years running! I am the strongest in all of Pandaria.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63963,'Is this what a dream feels like?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63964,'I find the Brewmoon Festival an excellent break from my studies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63965,'Ten years. I have faithfully brushed yak for ten years.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63966,'Two theories when arguing with yak. Neither one works.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63967,'I just came here to find some turnips, I swear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63968,'','It\'s good to see the world outside the monastery.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63969,'I was going to have a party and invite Mystic Birdhat, but you dismissed him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63970,'I think yak has started to move.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63971,'Those yaungol have straight swords. Straight. Swords.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63972,'Oh woe. Low. Low.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63973,'I am yak rider. And this is my yak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63974,'There is nothing in all Pandaria that can stay the rampage of the Grand Expedition Yak. Pray you never see it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63975,'It is not my intention to initiate legislation against you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63976,'Does yak tail assist in maintaining balance?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63977,'I will roll, roll through the gates of Mogu\'shan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63978,'A minute is all I need. Wait, that came out all wrong.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63979,'Only the best brew for Derpa Derpa.','Only the best brew for Derpa Derpa.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63980,'I lost my shield in my travels, all I wanted was a Brew, now all I want is my shield back!','I lost my shield in my travels, all I wanted was a Brew, now all I want is my shield back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63981,'You keep pointing me in the right direction and I\'ll keep tossing these kegs!','You keep pointing me in the right direction and I\'ll keep tossing these kegs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63982,'How may I help you today?','How may I help you today?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63983,'I need supplies for cooking lessons.','I need supplies for cooking lessons.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63984,'Hello, friend. Hungry?','Hello, friend. Hungry?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63985,'The sherpen has clearly been frozen here for some time, but you see a glint of light from something in his pack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63986,'Take the item from his pack.','Take the item from his pack.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63987,'I\'ll update my journal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63988,'I feel like a blood sausage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63989,'I feel like I lost an eighth of something.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63990,'Bow Hit!','Bow Hit!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63991,'I\'m burning your village down [PH].','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63992,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63993,'','We knew you could do it!',0,0,0,0,0,0,4,0,1,0,0,31453,26124),
(63994,'Good job. Guess you learned a little something from me.','',0,0,0,0,0,0,11,0,1,0,29819,0,26124),
(63995,'','Let\'s go for a drink!',0,0,0,0,0,0,1,0,1,0,0,31338,26124),
(63996,'This poor sherpen has been frozen here for a while.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63997,'Drinks!','Drinks!',0,0,0,0,0,0,4,0,1,0,30704,30704,26124),
(63998,'Let\'s do this, Mishi!','Let\'s do this, Mishi!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(63999,'You will bleed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64000,'What shiny weapons. Give them to me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64001,'Face me, warm blood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64002,'Yessssss... a challenge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64003,'We are stronger now! You will die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64005,'We are masters of the Stair now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64006,'I am going to eat your head!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64007,'No place for warm bloods on our Stair!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64008,'','I don\'t think so.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64009,'You will not defeat us.','',0,0,0,0,0,0,0,0,1,0,27975,0,26124),
(64010,'I was sent to sabotage the Sik\'thik bridge reconstruction, but you\'ve fought your way through them like a true $c. You have an opportunity to eliminate their leader!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64011,'And who are you to stop us?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64012,'Perhaps... we attacked... too soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64013,'Send me back in Tenwu!','Send me back in Tenwu!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64014,'Port Side Hit!','Port Side Hit!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64015,'Starboard Side Hit!','Starboard Side Hit!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64016,'The Veiled Stair will soon be ours again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64017,'The sha has made the pandaren weak! Now is the time to push them from the Veiled Stair forever!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64018,'These travellers are ripe for the robbing! Take their things! Take all of their things!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64019,'Steal everything! Ssteal all of their thingsss!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64020,'I am the \"retrieval expert\" for her ladyship, Madam Goya. It is her will that guides the ebb and flow of travel on this road.$b$bIt is my role to ensure certain less scrupulous types do not take advantage of her ladyship\'s hospitality.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64021,'Be on your guard. The Unga Ingoo Pirates are a fearsome lot. But they make a fine brew!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64022,'We need more brew. A good place to look might be the pirate ship to the southwest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64023,'We need more brew. You should search the island to the northwest. I think I saw a beach party over there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64024,'We need more brew. The cave west of here along the beach might have some stashed there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64025,'We need more brew. I think I saw brew guzzling hozen on the mountain peak to the southeast.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64026,'Who would leave a pile of bombs and a cannon next to their brew? Ah well. One hozen\'s trash is a brewmaster\'s beach defense.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64027,'Oh no! Captain Ook? I thought he was only a legend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64028,'It looks like the hozen scattered their brew in mugs and kegs across the island.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64029,'They are coming in from the ocean! Use the cannon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64030,'The hozen are stealing our brew!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64031,'The... dookers... took my brew...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64032,'Stern Hit!','Stern Hit!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64033,'You can take our lives... but you\'ll... never... take... our brew...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64034,'Wikkets... gonna... pay.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64035,'I die doin\' what I love!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64036,'Wikkets... out-bammed... Ba-Bam...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64037,'The mantid are under MY command, fools. See how she succumbs to me.','',0,0,0,0,0,0,0,0,1,0,32649,0,26124),
(64038,'What is that?!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64039,'Just keep tossing! I think they are starting to run away.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64040,'WHAT?! What will come out no more?!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64041,'Quick! Grab a keg and start tossing like your life depended on it!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64042,'You will come out no more!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64043,'Watch out!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64044,'Sauroken sorcery.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64045,'Most bad fortune.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64046,'A luckydo would be wise to throw kegs about now.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64047,'It is bad fortune to travel in boat without exploding barrels aboard.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64048,'Darkhatched saurok are very dangerous, and very powerful.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64049,'Back off! Dip-slithers!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64050,'Hah! Didn\'t see that coming now did you, Lizard Lips!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64051,'Take that, Dip-slithers!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64052,'Ah! Saurok on-board! Saurok on-board!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64053,'','$p, let me know if you need any help with the village defenses!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64054,'','We have a lot of visitors from all over Pandaria, surely they can help us with these raiders.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64055,'Tell me about the Krasarang Wild Brew.','Tell me about the Krasarang Wild Brew.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64056,'Tell me about Briaw Shan.','Tell me about Briaw Shan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64057,'Tell me about the festival fireworks.','Tell me about the festival fireworks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64058,'Tell me about the Tian disciples.','Tell me about the Tian disciples.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64059,'Tell me about the damaged cannons.','Tell me about the damaged cannons.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64060,'Tell me about the Vale marksmen.','Tell me about the Vale marksmen.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64061,'Tell me about the Tian mistweavers.','Tell me about the Tian mistweavers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64062,'Tell me about the jovial villagers.','Tell me about the jovial villagers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64063,'Tell me about Cianz.','Tell me about Cianz.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64064,'Tell me about the Xuen shield bearers.','Tell me about the Xuen shield bearers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64065,'Tell me about Derpa Derpa.','Tell me about Derpa Derpa.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64066,'Tell me about the Binan fishermen.','Tell me about the Binan fishermen.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64067,'','The Krasarang Wild Brew is extremely volatile, $n! We could set the barrels near where the yaungol will approach and then blow them up. Grab one and I\'ll put a marker where we should place them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64068,'','Briaw Shan is a champion brew tosser, $n. He could toss a barrel into the air and then have it come crashing down on these yaungol! I saw him over by the inn earlier today. Go see if he can help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64069,'','We have barrels of fireworks all over the town for the festival celebrations, $n. Place a few of them in the right locations and give them a good wack and they would cause all kinds of destruction. Grab a barrel and I\'ll mark the locations we should place them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64070,'','There are Tian disciples in town celebrating the Brewmoon, $n! Surely they could use their training to help us. Talk to them and see if they can stop these yaungol!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64071,'','There are some damaged cannons inside the storehouses and behind the inn, $n. If you could repair them, the villagers could use them to blast the yaungol!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64072,'','There are some Vale marksmen in town that stopped to rest for the night, $n. They have defended the Gate of the Setting Sun against the mantid for many years with their mortars. See if you can wake them up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64073,'','There are Tian mistweavers here from the Tian monastery, $n. Their skills with mistweaving would allow us to fight even longer! Ask them to aid us in this fight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64074,'','There are some jovial villagers in town that claim they created a helmet that makes them better at everything. While I\'m skeptical, having a helmet on couldn\'t hurt, right? Talk to them and see if they\'ll lend you one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64075,'','Cianz comes to bless our festival each year, $n. He will not fight in battle but maybe there is something he can do to help us. Ask if there is anything he can do.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64076,'','The Xuen shield bearers come down from the Temple of the White Tiger each year, $n. They could block the yaungol advance and prevent them from getting into the village. Talk to them and see if they can aid us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64077,'','Derpa Derpa wanders into town every now and then and tries to sell us strange gadgets that he\'s found rummaging around Kun-Lai Summit. Talk to him and see if he has anything that we could use as a weapon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64078,'','The Binan fishermen could catch a greased hozen in their nets while blindfolded, $n. Surely they could snare a few yaungol for us. Talk to them about helping us defend the village!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64079,'Are there any other defenses?','Are there any other defenses?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64080,'The Kun-Lai Kicker is finished, $n! Are you ready for the best brew in all of Pandaria? I\'ll warn you now, after drinking this brew you may want to kick things. Which is good because we have a lot of yaungol that need a good kicking!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64081,'Give me some quick! Before the yaungol get it all!','Give me some quick! Before the yaungol get it all!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64082,'The Kun-Lai Kicker is finished, $p! Now we can use it to kick some yaungol butt!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64083,'Go and see Brewmaster Boof for some Kun-Lai Kicker!','',0,0,0,0,0,0,0,0,1,17573,0,0,26124),
(64084,'You will pay for this disturbance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64085,'How dare you set foot in the valley!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64086,'You will regret this intrusion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64087,'Your death will be neither swift nor painless!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64088,'Your kind should not be allowed in the valley!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64089,'You are not welcome here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64090,'You will be the first of many to die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64091,'Your life will be a fitting sacrifice to our emperor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64092,'We will rebuild our empire on the corpses of our enemies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64093,'You will serve, or you will die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64094,'Your weakness offends!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64095,'My death will not save you from what is coming...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64096,'Your victory will be short lived...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64097,'When two great empires reunite, the world will crumble around them...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64098,'You are too late...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64099,'My death has gained you nothing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64100,'What will the sea bring us today?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64101,'Creepy, aren\'t they? Never seen \'em before, but I\'ve been pulling \'em in all day.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64102,'You will not take dis land from us!','You will not take dis land from us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64103,'You be interferin\' with de wrong empire!','You be interferin\' with de wrong empire!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64104,'Da Zandalari were meant to have this land!','Da Zandalari were meant to have this land!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64105,'Our empires will take what is ours!','Our empires will take what is ours!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64106,'|TInterface\\Icons\\spell_fire_volcano.blp:20|t%s begins to cast |cFFFF0000|Hspell:125391|h[Fire Lines]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64107,'An Amber Growth seeps into %s\'s wounds, replenishing its vitality.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64108,'%s collapses in a heap and expires suddenly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64109,'The statue appears to be holding something...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64110,'Take the item from his hand.','Take the item from his hand.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64111,'No more excuses, Empress! Eliminate these cretins or I will kill you myself!','',0,0,0,0,0,0,0,0,1,0,32647,0,26124),
(64112,'Warbring Qobi dropped his axes. Grab one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64113,'|TInterface\\Icons\\inv_misc_dust.blp:20|t%s begins to |cFFFF0000|Hspell:124359|h[Burrow]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64114,'WHEEEEEEE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64115,'I\'d like to heal and revive my battle pets.','I\'d like to heal and revive my battle pets.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64117,'I have a task for you.','I have a task for you.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64118,'You barbarians will think twice before attacking our village again!','',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(64119,'','You WILL tell us where the remains have been hidden!',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(64120,'Pick any of these fabulous rods and CAREFULLY tug the line. That should help set the hook into whatever\'s flailin\' around at the other end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64121,'Well that\'s unusual...Take care of it, then tug another line when you can.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64122,'Grrr... whatever I\'ve got here is big. Keep up the good work on those lines while I land this baby!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64123,'What... in... Mazu\'s... name... HRRGHHH!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64124,'The dream brew that you sampled earlier can expand your consciousness and show you events transpiring around the land. I will teach you how to use it properly, and we will find your prince!$b$bBut first, help me to create a fresh batch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64125,'Deck Boss said you needed some help.','Deck Boss said you needed some help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64126,'A good dream brew is VERY powerful. It will require a focused mind to gain any kind of clarity from the visions!','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(64127,'Now, you must STAY CENTERED. You can focus or relax, but above all else, remain in the center.','',0,0,0,0,0,0,0,0,1,0,30055,0,26124),
(64128,'Ah, good, I see you are not easily distracted. We Pandaren are extremely focused on the moment, sometimes to our detriment.','',0,0,0,0,0,0,1,0,1,0,30057,0,26124),
(64129,'I\'m so sorry, that did not alarm you did it, hmm? We Pandaren value calm under any circumstance.','',0,0,0,0,0,0,1,0,1,0,30058,0,26124),
(64130,'How about ... THIS?','',0,0,0,0,0,0,274,0,1,0,30059,0,26124),
(64131,'Look at you! The picture of serenity. I knew I liked you.','',0,0,0,0,0,0,1,0,1,0,30060,0,26124),
(64132,'Mung-Mung in big, stinky dook without you! Mung-Mung is in your debt. Maybe you and Yoon aren\'t such jibnibbers after all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64133,'You know what? I\'m going to show them that I can also become a master farmer!$B$BI\'m going to turn this farm into one of the most prosperous in the Valley!$B$BIt\'s too much work for one pandaren, though. Whaddaya say? Want to help me?','',0,0,0,0,0,0,21,0,1,0,0,0,26124),
(64134,'What are you going to do, Farmer Yoon?','What are you going to do, Farmer Yoon?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64135,'It was mighty kind of you to help me, $r. I\'m in your debt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64136,'Hey shtranger... you got some coin for a thirsty traveler?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64137,'Buy a fish a drink?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64138,'What brings you to my well today, $Gbrother:sister;?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64139,'The watersh tell of good fortune today, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64140,'Hey buddy, got shome coin to shpare a poor jinyu?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64141,'I\'m awful thirsty, buddy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64142,'Friend of jinyu, come sit with me a while.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64143,'Hey friend, care to sit with me and share a drink?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64144,'Hey, it\'s my good friend, $n. I\'m feeling more lucid today. Maybe because I\'ve cut back a little on the sauce.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64145,'You know, I\'ve decided I like having you as a friend. Makes me think that maybe I can have other friends, too.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64146,'Negative emotions, like anger or doubt, they take on a strange power here on Pandaria. But this you will discover in time.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(64147,'','I really owe you one, so I\'ll tell ya what. I\'ll talk to my father about letting you guys join the Tillers Union.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64148,'There - do you feel it? A perfect stillness of the soul! Feel the dream brew take effect.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(64149,'Uh-oh! You stirred up some angry crabs!','Uh-oh! You stirred up some angry crabs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64150,'Uh-oh! You stirred up some spiders!','Uh-oh! You stirred up some spiders!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64151,'','We travel where the winds take us, good $r. Would you like to listen for a while?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64152,'','In our travels, we have sung many songs, but there are many more songs to sing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64153,'I call upon the watersss of my homelands... DELIVER MY ENEMIES UNTO ME!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64154,'My people and I are studying the nearby rivers and ponds. Never before have we seen such revitalizing water.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64155,'We think that the unique qualities of the water in the Valley is the main reason for the abundance in the region.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64156,'The water in this pond is... quite awful.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64157,'Unfortunately, our brother Jogu has not fared well since his family died.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64158,'Jogu is from a different tribe than us. He came far from the north, and will not speak much of what led him here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64159,'Our brother over there drowns his sorrows in apathy and wine, instead of work and toil.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64160,'Whew! That is some strong brew!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64161,'This food is delicious. I never want to leave.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64162,'Master Jiying says we have to continue our research, but it\'s nice to come here and relax every once in a while.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64163,'<The great cat barely bats an ear at you, even when you run your fingers through her thick fur.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64164,'<The enormous bird shies away from you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64165,'We were lucky to meet up with these other Horde survivors. I did not realize that our brethren had washed up elsewhere on this new land.','',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(64166,'I don\' know, $r. Dis big vegetables don\' seem right, mon. How can dey just eat dem like it\'s nuddin\'? Where is all dey MEAT?','',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(64167,'','Dezco sent us ahead to scout this region. We may have found a path to the great healing in Leza\'s vision.',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(64168,'','The locals here insist that the great healing waters we seek are no further than a certain... Stormstout Brewery. We may have to investigate their claims.',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(64169,'','This troll complains about the food, but he eats more than any of us.',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(64170,'','Have you seen the wall over to the west? I wonder what lies beyond it?',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(64171,'','All the stuff here... It\'s so... so... different!',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(64172,'Admiral Taylor sent us here to look fer the young Prince. Did ya know that they brew BEER here?','',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(64173,'We\'re hard at work, searching for Prince Anduin. We\'re just stoppin\' fer a bite and a drink.','',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(64174,'They say that there are over five thousand brews in Pandaria. I ain\'t leavin\' until I try them all!','',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(64175,'Grab a drink and join us, $r!','',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(64176,'','I just love listening to Kol talk about his delicious recipes. I never knew there were so many ways to grill meat.',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(64177,'','Have you tried Kol\'s cooking? I can\'t seem to get enough of it.',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(64178,'','He keeps telling me that he likes my accent, and I just keep asking, what accent?',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(64179,'Hey $c, fancy meeting you here! Were you sent to seek the young Prince, too?','',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(64180,'The locals here certainly have an idyllic lifestyle. It makes me wonder if I should lay down my wand and pick up a hoe.','',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(64181,'I\'m a wand peddler by trade. Luckily for you and me both, most of my wands survived through the shipwreck!','',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(64182,'A wise man rests when he is weary.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64183,'The best brew in all of Pandaria is made right here in the Valley, at the Stormstout Brewery.$B$BWell, at least I think so.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64184,'Fill your cup with joy, and you will drink joy. Fill your cup with sorrow, and you will drink sorrow.$B$BChoose your brew wisely, my friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64185,'Aaaah, I believe that happiness is a full belly.$B$BFill your stomach with good food, and you fill your soul with warmth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64186,'It is good to enjoy the fruits of the earth, but not to excess.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64187,'Most good fortune to you, $r! My brother and I come from far away to share our luckydos.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64188,'Most good fortune to you, $r! My brother and I come from far away to share our luckydos.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64189,'Grummles have good noses. Can tell the difference between good and bad fortune by the smell. You have the smell of good fortune about you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64190,'Please, let us remain civil while we are guests in this town. I suspect our hosts will not react kindly to bloodshed.','',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(64191,'I don\' know, $r. Dis big vegetables don\' seem right, mon. How can dey just eat dem like it\'s nuddin\'? Where is all dey MEAT?','',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(64192,'','Let us not bring bloodshed to this peaceful place, $brother:sister;.',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(64193,'','Our search has taken us across vast oceans and deep jungles, and yet we encounter one another here, of all places. It truly seems that our conflict is inevitable, wherever we go.',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(64194,'','I\'m watching you, $r.',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(64195,'Hey ugly, I would punch you right now... if I thought I could hit ya! Anyway, did ya know that they brew BEER here?','',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(64196,'Instead of bloodshed, how about we settle our differences... in a battle of the DANCE?','',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(64197,'','Hey now, this is no place to start a fight. Otherwise, no one will get to enjoy this food.',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(64198,'Hey $r, don\'t try anything funny! I\'ve got several wands up my sleeves and I\'m not afraid to use them!','',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(64199,'','Music is good for the mind, body, and soul!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64200,'Are you here to enjoy the view?','Are you here to enjoy the view?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64201,'Can you smell the winds, stranger? They bring change.','Can you smell the winds, stranger? They bring change.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64202,'From here we meditate on the wonders of Pandaria.','From here we meditate on the wonders of Pandaria.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64203,'When standing on the precipice, do not forget to breathe.','When standing on the precipice, do not forget to breathe.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64204,'Welcome to the Serpent\'s Overlook. Did you happen to bring a kite with you?','Welcome to the Serpent\'s Overlook. Did you happen to bring a kite with you?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64205,'The farmers from the nearby fields bring their wheat, and we mill and sort the grains here.$B$BSome of the grain will be made into food, some of it is traded, but most of it is sent to the Stormstout Brewery for... you guessed it... beer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64206,'This is a place of peace. We watch, we meditate, we work on our crafts, and we are content.','This is a place of peace. We watch, we meditate, we work on our crafts, and we are content.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64207,'Have you been to Dawn\'s Blossom? Did you happen to pick up an extra cask of Goldendraft while there?$b$bIt is not the easiest thing to have them deliver here.','Have you been to Dawn\'s Blossom? Did you happen to pick up an extra cask of Goldendraft while there?$b$bIt is not the easiest thing to have them deliver here.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64208,'The Jade Serpent! It... it broke.','The Jade Serpent! It... it broke.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64209,'','I told my son, I told Dion, don\'t take the yaks to the field when it\'s raining. And what does he do? He takes out the yaks when it is raining.$B$BIt is no surprise that we now have sick yaks!$B$BAi-ya! How did I raise such a foolish son?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64210,'','My son does not eat enough. Look at him! So scrawny and skinny! I must feed him more.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64211,'','Why my son must be so short? I wanted tall, strong young son.$B$BI told him not to open umbrellas indoors when he was little. You will grow up short, I say!$B$BWhat does he do? He play with umbrellas all the time! Inside! Tcha!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64212,'','My son Dion say Mama make the best dumplings in all of Valley!$B$BOoohoohoohooo. That\'s my boy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64213,'','Mama loves oranges, but oranges are so hard to find in the Valley.$B$BI tell my son to buy some oranges at the market, so I give him some copper.$B$BWhat does he do? He buys some beans!$B$BWe are not farmers! We are yak-herders! What do I do with stupid beans, I ask you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64214,'The hozen and the jinyu have always fought, but never like this...','The hozen and the jinyu have always fought, but never like this...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64215,'','My son Dion is out in fields all day. He works so hard. Makes Mama so proud.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64216,'The Jade Serpent... what will it do now?','The Jade Serpent... what will it do now?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64217,'What does this mean? The end of peace in Pandaria? Are we doomed?','What does this mean? The end of peace in Pandaria? Are we doomed?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64218,'','Do you come to see Mama? Oh, sit for a while!$B$BLet me tell you, I hear some gossip the other day.$B$BI heard that Gina Mudclaw and her father, Haohan Mudclaw, don\'t get along!$B$BHe wanted to marry her to Farmer Fung up by the Belt, but she wouldn\'t have it! Wanted to run her market, she said.$B$BAi-ya! What has become of the young girls these days? Don\'t want to marry handsome young man and raise a family?$B$BEspecially that Fung... he\'s such a catch! So good-looking, and grows such big vegetables too.$B$BWhy I not have handsome young son like that?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64219,'','Oh, when is my son going to meet a nice young lady? All he does is hang around yaks all day!$B$BWhat girl is going to want a stinky yakherd, huh? Ai-ya, Mama worry so much...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64220,'','Ah, hello there, $r!$B$BThis is where we keep all our farming history and knowledge.$B$BWe have records of the local weather and resulting harvest, detailed notes on every seed and every plant that grows in the Valley, and even a bank of seeds for all the plants that we may ever need to grow.$B$BThis knowledge is sacred to us. If disaster should ever strike this land, our seeds must be saved.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64221,'Hello there, traveler. I\'m hard at work making my next masterpiece!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64222,'The Jade Serpent statue was destroyed? How could this have happened?','The Jade Serpent statue was destroyed? How could this have happened?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64223,'','Don\'t you just love watching the birds? I wish I could fly, too.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64224,'','The farmers pray for rain, but I don\'t! It\'s terrible for business. Just look at my market! Sopping wet!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64225,'','It\'s raining yaks and mushan today! Well, I\'ve got a market to run, rain or shine!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64226,'Look at the sky, $n! It\'s raining! Should be good for the crops, eh?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64227,'Wow, just look at this storm! Well, crops like water, right?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64228,'The Jade Serpent statue was destroyed? How could this have happened?','The Jade Serpent statue was destroyed? How could this have happened?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64229,'What is this \"sha\"? Where did it come from?','What is this \"sha\"? Where did it come from?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64230,'Will you help us heal the land?','Will you help us heal the land?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64231,'The poor hozen and jinyu! We knew they didn\'t like each other but to go this far...','The poor hozen and jinyu! We knew they didn\'t like each other but to go this far...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64232,'Did all of the jinyu and the hozen perish in that battle? Were there survivors?','Did all of the jinyu and the hozen perish in that battle? Were there survivors?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64233,'Will you help us against the sha?','Will you help us against the sha?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64234,'So much... lost.$b$bAnd I fear, $n, that this is only the beginning.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64235,'I got nothin\' to say to you! I will only be talkin\' to $p.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64236,'Eh? What did you say?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64237,'','Are we gonna see a shark?',4,1,0,0,500,0,0,0,1,0,0,0,26124),
(64238,'If there\'s time.','',1,0,0,0,500,0,0,0,1,0,0,0,26124),
(64239,'The ancient chest is covered in dust...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64240,'','Where are we going?',4,1,0,0,500,0,0,0,1,0,0,0,26124),
(64241,'','It is time to get the fish from the market.',1,0,0,0,500,0,0,0,1,0,0,0,26124),
(64242,'','Are we there yet?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64243,'We\'re almost there. Just a bit more to go.','',1,0,0,0,500,0,0,0,1,0,0,0,26124),
(64244,'','Can you carry me, daddy?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64245,'No honey bear. I need you to get those legs nice and strong. You want to be as strong as me one day, right?','',1,0,0,0,500,0,0,0,1,0,0,0,26124),
(64246,'','Wow! I never knew this was back here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64247,'','Oooooh, isn\'t this scary? Do you think there are ghosts in there?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64248,'','Eeewwww! What is THAT THING?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64249,'','There it is! Old Man Thistle\'s treasure!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64250,'','Wooooowwwww!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64251,'','Jumping jackhoppers! We found it! We really found it! It\'s Old Man Thistle\'s hidden treasure! Oh boy oh boy oh boy!!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64252,'','The maiden, eh? Hmm, I remember that\'s what my father used to call that river to the north. Other than that, I wouldn\'t have the slightest clue.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64253,'What echoes and what\'s dark? It\'s simple! A cave!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64254,'Hmmm, I reckon I don\'t know, $r. All I can understand is the part about the valley - that\'s right here! The Valley of the Four Winds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64255,'Oh, I HAVE heard of the ancestors\' stair. That\'s what some folks call those mountains to the north.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64256,'Can you make anything of these clues?','Can you make anything of these clues?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64257,'Have you ever heard of a maiden laughing behind a fan?','Have you ever heard of a maiden laughing behind a fan?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64258,'Where can I find the ancestors\' stair?','Where can I find the ancestors\' stair?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64259,'Where can someone whisper secrets into the echoing dark?','Where can someone whisper secrets into the echoing dark?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64260,'Think you can take me in battle?  Most girls hate snakes, but I think they\'re cute!','Think you can take me in battle?  Most girls hate snakes, but I think they\'re cute!',6,0,0,0,0,0,0,0,5,0,0,0,26124),
(64261,'My family and I are bringing fresh fish from the Anglers to town. Would you like to buy some?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64262,'','It is a long walk from town to Sri-La, but good for the spirit. And it certainly helps get little Aerial here outdoors.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64263,'','I\'m not supposed to talk to strangers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64264,'5.0 Cooking - Cooking Student Default 1','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64265,'','Do you see that big fish down there, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64266,'','Don\'t you try to sneak up on me! My pappy always said I got eyes in the back o\' my head!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64267,'','What ken I do fer ya, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64268,'','Woowhee! I still can\'t believe we found Old Man Thistle\'s treasure. I guess all those folk stories weren\'t so true after all, but I still like tellin\' them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64269,'Tell me the story of Old Man Thistle.','Tell me the story of Old Man Thistle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64270,'','Now they say that whoever can git their hands on that map, can find that lost treasure...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64271,'Oh yeah? Tell me more.','Oh yeah? Tell me more.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64272,'Now go, impart my techniques to the initiates.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64273,'We will not tolerate those who unleashed the sha upon our land.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(64274,'We drove back the sha, your kind will fall before us as well.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(64275,'I once saw a fish so big you\'d swear it was a shark. Come to think of it...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64276,'You a fisher? With them flabby arms and that heavy armor?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64277,'Welcome to the coast of Pandaria! Where everything that can wash ashore has, or will, wash ashore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64278,'What kind of bait you use? I knew a pandaren once, would use his own arm to bait the fish.$b$bWe called him the Noodler.$b$bRumor has it he\'s retired and went south.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64279,'Ever see a kracken before? Old Jin claims to have caught one, once upon a time, but let it go on acount of it looked too \"gamey.\"$b$bWe have a betting pool going to see if he ever finds it again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64280,'So, what are the fish like where you come from?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64281,'Usually these shores are covered in mists. It looks like they cleared out for some reason.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64282,'','I knew a monk once who specialized in a fish-fighting style. It was pretty limiting but he could make an amazing fish stew.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64283,'','New here? It is like we tell the children, do not go into the water without a handful of distracting bait and an exit strategy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64284,'','One of the children swears up and down they saw a cross between a shark and an octopus the other day.$b$bI know there are a lot of strange things in the ocean but that seems extra silly to me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64285,'','You probably have seen the ships crashed off our shores. Would any of those happen to be yours?$b$bThe mists often bring us a number of \"gifts\" like that.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64286,'','Did the Serpent Riders send you? Their serpents keep stealing our best catches.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64287,'','Fish here long enough and you will see everything. I once saw a walrus with legs and arms. Not only that, but it talked!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64288,'','What are the seas like where you come from?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64289,'','I often wonder about the jinyu here. But they know how to fish and better than the rest of us so who am I to judge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64290,'You are my favorite teacher ever!','You are my favorite teacher ever!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64291,'When I grow up, I want to be the best chef in Pandaria.','When I grow up, I want to be the best chef in Pandaria.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64292,'','Oooh, this is so exciting! A real life treasure hunt!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64293,'Do you think I\'ll make a good cook eventually?','Do you think I\'ll make a good cook eventually?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64294,'What will we be learning next?','What will we be learning next?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64295,'I\'ll try my best to be a good student.','I\'ll try my best to be a good student.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64296,'','That thing is seriously scary-looking! You saved our lives, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64297,'Gossip - Option 1 - Test - HW','Gossip - Option 1 - Test - HW',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64298,'Gossip - Option 2 - Test - HW','Gossip - Option 2 - Test - HW',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64299,'','So... want to talk about it?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(64300,'Nope.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(64301,'','You sure? I hear it happens to everyone at some point.',6,1,0,0,500,0,0,0,1,0,0,0,26124),
(64302,'Mere initiates.','',0,0,0,0,0,0,0,0,1,0,29254,0,26124),
(64303,'They should have studied harder.','',0,0,0,0,0,0,0,0,1,0,29255,0,26124),
(64304,'One technique alone is not enough.','',0,0,0,0,0,0,0,0,1,0,29256,0,26124),
(64305,'They failed their test. Will you?','',0,0,0,0,0,0,0,0,1,0,29257,0,26124),
(64306,'They approach? Good. Now, if only my students were here to see and learn from the coming display of martial prowess...','',0,0,0,0,0,0,0,0,1,0,29258,0,26124),
(64307,'','We made it out alive! Boy oh boy, wait until my friends hear all about this. They\'ll never believe it! See you later, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64308,'','This is... remarkable, $n! These notes provide invaluable knowledge to our farmers. We are truly in Old Man Thistle\'s debt for keeping such records, and in your debt for recovering them. Thank you!',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64309,'You have been affected by |cFFFF0404|Hspell:116417|h[Arcane Resonance]|h|r !','You have been affected by |cFFFF4809|Hspell:116417|h[Arcane Resonance]|h|r !',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64310,'The Mist-Hopper Jr. is on the dock just southeast of here. Let\'s go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64311,'Man the harpoon cannon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64312,'Aim for the bow, the port and starboard buoyancy sacs, and the stern...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64313,'Err, sorry... Let me put that another way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64314,'Shoot it in the face! And the sides! And the pooper! You know, the soft bits.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64315,'Nice shooting!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64316,'Ha ha! What do you think of that, you old squid?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64317,'Mazu, guide my arm...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64318,'HURGHH!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64319,'Keep it up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64320,'That\'s right! Back to the depths with ya!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64321,'Looks like he sprung a leak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64322,'That is some first-rate harpoonery!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64323,'More visitors? Bah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64324,'Not sure how I got here. But... good fortune often finds the open minded.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64325,'','Never underestimate the importance of healing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64326,'','Healing has turned the tide of many battles.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64327,'','Welcome to the Thunderpaw Refuge. Here we practice our craft of focusing our chi into healing.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64328,'','If there is one thing in life you can learn, it is that there is always more to learn.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64329,'Welcome to the Thunderpaw Refuge. Do not let the armor deceive you. We train in healing practices here.','Welcome to the Thunderpaw Refuge. Do not let the armor deceive you. We train in healing practices here.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64330,'Things are quite calm here usually. We only have problems with the occassional saurok hunting party. And the saurok tend to only come out during a heavy storm.','Things are quite calm here usually. We only have problems with the occassional saurok hunting party. And the saurok tend to only come out during a heavy storm.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64331,'Have you met Brewmaster Blanche? She wanders the roads to the south and east of here. She has been known to visit us with some of her more astounding brews.','Have you met Brewmaster Blanche? She wanders the roads to the south and east of here. She has been known to visit us with some of her more astounding brews.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64332,'I am trying to learn how to heal. The problem is you have to get hurt before you can be healed.','I am trying to learn how to heal. The problem is you have to get hurt before you can be healed.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64333,'Someone was saying I was \"overhealing\" the other day. I am so confused.','Someone was saying I was \"overhealing\" the other day. I am so confused.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64334,'I am learning how to slap the pain out of someone. How neat is that?','I am learning how to slap the pain out of someone. How neat is that?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64335,'Can\'t talk now. Must... focus.','Can\'t talk now. Must... focus.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64336,'I never knew how much variety there was to brewing tea.','I never knew how much variety there was to brewing tea.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64337,'I can... I can barely breathe.  I\'m alive thanks to you.','I can... I can barely breathe.  I\'m alive thanks to you.',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(64338,'Poor Sheepie... his restless wandering finally did him in.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64339,'They came without warning.  There\'s nothing the guards could have done.','They came without warning.  There\'s nothing the guards could have done.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64340,'It seems there are hazards to living in a place so beautiful...','It seems there are hazards to living in a place so beautiful...',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64341,'These mogu won\'t scare us away.  This is our home now.','These mogu won\'t scare us away.  This is our home now.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(64342,'I\'m alive thanks only to you... I won\'t forget this.','I\'m alive thanks only to you... I won\'t forget this.',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(64343,'I know you!  You saved my brother not even a week ago.  You\'re a true hero!','I know you!  You saved my brother not even a week ago.  You\'re a true hero!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(64344,'I thought that was it... I thought I was going to die.  Thank you, stranger.','I thought that was it... I thought I was going to die.  Thank you, stranger.',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(64345,'Wait! Something hostile approaches!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64346,'One of the initiates pulled a prank on me the other day. He said I was supposed to sniff his \"healing mists\". There was nothing healing about that mist.','One of the initiates pulled a prank on me the other day. He said I was supposed to sniff his \"healing mists\". There was nothing healing about that mist.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64347,'Attackers approach!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64348,'I owe you my life.','I owe you my life.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64349,'I\'m at your side, friend.','I\'m at your side, friend.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64350,'You\'ve earned my aid.  Where to?','You\'ve earned my aid.  Where to?',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64351,'Prepare for battle Wakener!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64352,'Thank you.','Thank you.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64353,'I am grateful, friend.  Let me fight by your side.','I am grateful, friend.  Let me fight by your side.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64354,'Too long in that cage.  I\'ll show these mogu what I think of their captivity...','Too long in that cage.  I\'ll show these mogu what I think of their captivity...',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64355,'Thank you for the timely rescue, hero.','Thank you for the timely rescue, hero.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64356,'We will never yield our defense of the Vale!','We will never yield our defense of the Vale!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64357,'Mmmmm! I smell a delicious sheep!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64358,'Long live the Golden Lotus!','Long live the Golden Lotus!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(64359,'By the will of the Celestials!','By the will of the Celestials!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64360,'Time to munch on some mutton!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64361,'We stand together.  We will never fall!','We stand together.  We will never fall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64362,'The Golden Lotus will never yield.','The Golden Lotus will never yield.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64363,'The Vale will never fall into mogu hands!','The Vale will never fall into mogu hands!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64364,'The Shao-Tien march to their deaths!','The Shao-Tien march to their deaths!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64365,'Yield or fall!','Yield or fall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64366,'Your stance is wrong. Your footing is totally off balance. Your head is too soft.$b$bReturn here when you have learned that you are ready to learn.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64367,'You will burn under the might of the Shao-Tien!','You will burn under the might of the Shao-Tien!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64368,'We will blanket the Vale in your bloody bodies!','We will blanket the Vale in your bloody bodies!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64369,'Your eyes fail to see what is before you. No doubt this is a result of your flawed eating habits.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64370,'Your soul will be mine to torture!','Your soul will be mine to torture!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64371,'The return of the Emperor will doom your entire race!','The return of the Emperor will doom your entire race!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64372,'I will crush the life from your skull!','I will crush the life from your skull!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64373,'I will have your head on a pike, $r!','I will have your head on a pike, $r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64374,'Even death will not free you from my grasp!','Even death will not free you from my grasp!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64375,'Your struggle is pitiful and weak!','Your struggle is pitiful and weak!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64376,'You move like a pregnant yak. You are not ready to be trained here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64377,'To run on water, one must run very fast.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64378,'','The Shao-Tien have taken a great interest in these ruins.  They intend to recover power from its depths.  I intend to leave their corpses littering them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64379,'','These trainees are weak.  They are not ready to walk the wall, much less face the mantid or the mogu head-on.  It will be some time before we can depend on them in any real sense.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64380,'','We all served under Leven in excursions past the wall.  We honed our blades against countless mantid and yaungol.  These mogu think us weak, but that mistake in judgment will cost them dearly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64381,'Setting foot in the Dread Wastes taught me the value of knowing the terrain and understanding the enemies\' movements.  Whether the goal is victory or simply survival, the best route is always to be two steps ahead of your opponent.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64382,'It can be difficult for a hardened veteran to grow accustomed to a peaceful setting, but that is our duty.  These villagers do not long for war, let us not bring it to their doorstep if we do not have to.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64383,'Isn\'t he magnificent?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64384,'So many mouths to feed, and never enough ingredients to feed them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64385,'Come to me Kovok.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64386,'One of my ancestors took part in the uprising at Tu Shen, and now lies among the graves.  I would pay my respects if only I could, but the spirits there know no peace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64387,'It is important for the trainees to learn the sting of defeat, that they might appreciate the value of victory.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64388,'<He looks to you grimly.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64389,'<He\'s eyes light up as you approach.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64390,'<He stares at you blankly.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64391,'I like to think of myself as the brains and the beauty of this operation. Anji\'s the brawn. And the second beauty.$B$BWe\'ve got a lot of beauty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64392,'I don\'t love spiders. Or statues that move. Or sprites that steal your things.  There are a lot of things I don\'t love about these ruins.  Fortunately for me, Anji\'s here to keep my good-looks intact!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64393,'There is no corner of this vale that the Shao-Tien can hide from us in. They underestimate the tenacity of the Shado-Pan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64394,'The rising threats of the mogu\'s return and the mantid swarms in the west have brought far more trainees to bare than usual. This is good. They will be needed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64395,'The mogu are a mighty threat, but they\'re nothing compared to the horrors my men and I have faced in the Dread Wastes. I have no doubts that we can hold the Vale.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64396,'','We are as new to this vale as you. We came when the gates opened, having lost our homes in Kun-Lai. There is much to build, much to mend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64397,'','I wonder if our fates are somehow cursed. The horrors inflicted on us never seem to cease.$B$BSometimes all you can do is try to maintain good spirits, and perhaps a mild appreciation for fickle twists of fortune, whichever way they turn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64398,'This is the most bountiful land in all of Pandaria! A smart man could grow rich here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64399,'A budding village is a wonderful place to make a living!  So many goods needed, so many goods to be traded.  I think I could grow fat and happy here indeed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64400,'I\'ve heard nothing but tales of how peaceful and beautiful this vale was, far before any of us were ever allowed in. Now that we\'re here, there\'s all manner of beasty trying to smash our head or bite off our feet.$B$BSo are the tales a lie, or are we just horrid company? I humbly exclude myself from the latter possibility, because to consider such would be silly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64401,'Well this all is all manner of spooky, is it not?  And these traps, quite unwelcoming.  These mogu could desperately use some decoration advice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64402,'I often worry, if the blossoms in this vale are truly eternal, it would be quite dangerous for new ones to sprout, no?  We\'d be swimming in sea of choking flowers, fragrant and soft as they might be.$B$BI like to play it safe and squash the small ones under my boot, just to keep things in balance, you know?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64403,'Rook treats friends good.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64404,'Rook want to smash mogu, but villagers not safe!  If Rook keep villagers safe, can you help smash mogu?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64405,'Why old mogu build broken pillars and walls here?  Why not build full buildings like everyone else?  Mogu dumb.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64406,'','Within these ruins rest many ancient mogu secrets.  This entire vale was theirs once, and some corners of it have yet to be tread by pandaren feet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64407,'','The mogu are cruel captors. We should not risk any time if any of our brave warriors have fallen into their hands.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64408,'','In the darkest of times, it is often a patient spirit and a reassuring hand that carry the most value.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64409,'','I weep for the fortune of this village. Their hard times seem to be without end, and with the mogu in the vale, it will likely be some time before they ever will.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64410,'The reflexes built in the survival ring are what keep these trainees alive beyond the wall.  There, the threats are much less forgiving.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64411,'','It\'s about time you asked! I was wondering when Farmer Yoon would ever notice me. You go ahead, and I\'ll be there after I\'m done at the market today.',0,0,0,0,0,0,0,0,1,13909,0,0,26124),
(64412,'','Sunsong Ranch needs my help? I\'ll meet you there after I\'m done here at the market today.',0,0,0,0,0,0,0,0,1,13911,0,0,26124),
(64413,'Well I s\'pose the chickens won\'t mind if I visit fer a bit. I\'ll meet ya there after I\'ve done my business here at the market today.','',0,0,0,0,0,0,0,0,1,13905,0,0,26124),
(64414,'I suppose I could leave things to Mung-Mung for a while and take a gander at Yoon\'s. Let me finish up my business here at the market, first.','',0,0,0,0,0,0,0,0,1,13906,0,0,26124),
(64415,'Really? That whole pond, just for me? I\'ll be right there... right after I finish this drink... hic!','',0,0,0,0,0,0,0,0,1,13907,0,0,26124),
(64416,'','Well all right, I s\'pose I could hop on over to the farm now and again. I can\'t do it right away though. I have some business to finish at the market, first.',0,0,0,0,0,0,0,0,1,13908,0,0,26124),
(64417,'I was wonderin\' when you would ask. Sure thing, but I can\'t today. Once I finish my business at the market, I\'ll be right over!','',0,0,0,0,0,0,0,0,1,13904,0,0,26124),
(64418,'','My papa always did say to help out a neighbor in need! I\'ve just gotta take care of some stuff here at the market, first. I\'ll be there soon as I can!',0,0,0,0,0,0,0,0,1,13912,0,0,26124),
(64419,'','Sure, I suppose I could help out for a bit! I can\'t leave the market today, but I\'ll be there as soon as I can.',0,0,0,0,0,0,0,0,1,13913,0,0,26124),
(64420,'Okay, boss! Chee Chee got stuff to do at the market today, then he be there soon.','',0,0,0,0,0,0,0,0,1,13910,0,0,26124),
(64421,'A Saurok runs down a hidden set of stairs with some of the treasure!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64422,'Not all of the paragons were choosen for the physical skills, Wakener.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64423,'Such a beautiful creature, wouldn\'t you agree? Do not let his small size deceive you. Even at a young age the Kunchong are lethal.$b$bBefore my discovery, the Kunchong were used as weapons with little regard for their intelligence. We struggled to control them until it occurred to me that we didn\'t fully understand them.$b$bBy forming a bond with the creatures we no longer needed to exert control forcefully. Instead, a partnership occurred.$b$bKovok was the next step in my experiment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64424,'$n is trapped in an Amber Prison! Free them!','$n is trapped in an Amber Prison! Free them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64425,'|TInterface\\Icons\\inv_sword_2h_mantid_01.blp:20|tWind Lord Mel\'jarak begins to cast |cFFF00000|Hspell:122407|h[Rain of Blades]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64426,'Wind Lord Mel\'jarak senses more than 4 of his allies are incapacitated and frees them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64427,'What the...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64428,'LEVIATHAN!!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(64429,'We gotta warn the others!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(64430,'Aaaagghhhh!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64431,'Guarding grummles is not what I would call my dream role in life, but they pay well. Plus you see many strange things on the mountain roads.','Guarding grummles is not what I would call my dream role in life, but they pay well. Plus you see many strange things on the mountain roads.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64432,'You from the low lands? We tend to not see low landers up this way very often.','You from the low lands? We tend to not see low landers up this way very often.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64433,'What brings you up the mountain?','What brings you up the mountain?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64434,'Grummles usually have Shado-Pan guarding them. I guess there must be danger on the Serpent\'s Spine.','Grummles usually have Shado-Pan guarding them. I guess there must be danger on the Serpent\'s Spine.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64435,'Have you heard the sha? We keep hearing its voice on the wind. Not good. Not good at all.','Have you heard the sha? We keep hearing its voice on the wind. Not good. Not good at all.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64436,'The mountain hozen are on the ravage. Be careful when you travel the roads.$b$bProbably only a matter of time before they figure out the Shado-Pan are not here and decide to march down on us.','The mountain hozen are on the ravage. Be careful when you travel the roads.$b$bProbably only a matter of time before they figure out the Shado-Pan are not here and decide to march down on us.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64437,'I once saw a strange creature in the Grummle Bazaar. It looked like a haunched over jinyu but was mean and said something like \"Mrggmrmrgmgmgl\".$b$bI guess one of the grummles brought it up from the coastline.','I once saw a strange creature in the Grummle Bazaar. It looked like a haunched over jinyu but was mean and said something like \"Mrggmrmrgmgmgl\".$b$bI guess one of the grummles brought it up from the coastline.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64438,'There have been no Shado-Pan down this way recently. That cannot be good.$b$bWe were supposed to still have a few years before the next mantid swarm.','There have been no Shado-Pan down this way recently. That cannot be good.$b$bWe were supposed to still have a few years before the next mantid swarm.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64439,'','You are sweet as sugar, $n.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64440,'','Honey, you are so kind to me!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64441,'','It is so nice of you think of me, darlin\'.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64442,'','It\'s so red! Don\'t you know that\'s my favorite color?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64443,'','Oh my, this is beautiful. How did you know that I like jewels?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64444,'','Thank you, $n. A girl can never have enough rubies.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64445,'','You shouldn\'t have! But I\'m glad you did.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64446,'','Aren\'t you just a sugar $Gdaddy:pie;?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64447,'','Aw shucks, you are going to spoil me rotten!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64448,'|TInterface\\Icons\\inv_misc_uncutgemnormal.blp:20|t$n is trapped in an |cFFF00000|Hspell:121881|h[Amber Prison]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64449,'','I\'m not good with all this emotional feeling stuff, but thank you.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64450,'','Thank you, $c. You honor me.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64451,'','Thank you, $n. I am in your debt.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64452,'','You are too kind, $c. How can I ever repay you?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64453,'','You shouldn\'t have, $c. I thank you.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64454,'','A girl does get hungry after hunting down all those enemies. Thank you.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64455,'','Oh, this looks delicious. Thank you, $c.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64456,'','Mmmm... a warrior does need to keep up her strength. Thank you.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64457,'','The vigil is never finished, but I can always take a break for a hot meal!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64458,'Can I eat it? I guessh only one way to find out...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64459,'Your consciousness is expanding. Concentrate on who you are looking for. The boy prince - the young lion. He is here, isn\'t he? Journey through time and space... open the eye of your soul. Do you see him?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64460,'Hmm, this will give me shomething to focush on for my next predikshun.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64461,'Thish ish really neat $n. Thanksh, buddy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64462,'I like thish a lot, $n. Thanksh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64463,'Thanksh for thinkin\' of me, buddy. No one elshe doesh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64464,'You are so kind $Gmish:mishter;... hic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64465,'Thish apple looks delishush. Thanksh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64466,'An apple for me? Thanksh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64467,'What ish that? A tomato? A pomegranate? Oh! An apple!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64468,'Burn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64469,'Ish that an apple? You must be glad to shee me... hic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64470,'Oh that looksh delishush. It will go great with my cold drink here.','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(64471,'An oracle needsh food to foreshee the future. Thanksh!','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(64472,'My family used to make this... They\'re gone now, but I shtill love thish dish.','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(64473,'Oh, you shouldn\'t have. Thanks.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64474,'But I didn\'t get you anything. Aww shucks, thanks anyway.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64475,'That\'s mighty kind of you, $r.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64476,'I suppose I could use one of those. Thank you.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64477,'I don\'t deserve something as nice as that. I suppose you\'re going to insist.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64478,'I can\'t say no, but you didn\'t have to. Thanks, $r.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64479,'My son used to love finding these feathers.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64480,'These feathers bring back memories of my son. Thank you, $r.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64481,'My son loved these feathers because they are blue as the sky. He always said he was going to fly someday.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64482,'Thank you, $n. My son would have liked to see this.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64483,'It\'s very nice, $n. Thank you.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64484,'You must be quite the cook, $n. This looks very nice.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64485,'Thank you for thinking of a lonely old man, $n.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64486,'You shouldn\'t have!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64487,'Oh ho ho, this is for me? Thank you.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64488,'You sure know how to make a pandaren happy. Thanks.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64489,'How generous of you. Thanks!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64490,'I suppose this gift is acceptable. Thanks, $n.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64491,'I wouldn\'t expect anything less, $r. Thanks.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64492,'This is pretty nice gift, $n! Thanks a lot.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64493,'Run away or be scorched!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64494,'Tiger Steak? That\'s my favorite! How did you know?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64495,'They say that the way to the Tiller\'s Union is through the leader\'s stomach. Eh?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64496,'We will burn your lands!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64497,'You dare face the fire of the yaungol?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64498,'','You sure know how to season a gal\'s pan! Thanks!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64499,'','You lookin\' to get on my good side, eh $r? Well good for you!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64500,'Die! And embrace your fate!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64501,'','You do that again and I might just have to take a likin\' to ya!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64502,'You cannot escape your fate!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64503,'','A gift for little old Gina? You are so sweet.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64504,'','Well, just for that, you can come to my market any time.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64505,'','That\'s a mighty fine gift you just gave me. Thank you.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64506,'','A pretty flower for me? Oh stop.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64507,'','That\'s a lovely flower. Thanks, $n.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64508,'','How did you know that I like flowers?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64509,'You cannot stand against the fire of the yaungol!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64510,'','Did you make that Swirling Mist Soup yourself? It smells delicious.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64511,'You will burn with your lands!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64512,'','Did you know that there are two ways into Gina\'s heart? One is being a good customer at my market, and the other is Swirling Mist Soup!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64513,'','Oh, that looks delicious. Thank you, $n.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64514,'That\'s a mighty nice gift, $r. Thank you.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64515,'How can I ever repay your kindness?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64516,'Hey, you ain\'t so bad after all, $r.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64517,'I\'m starting to take a liking to you, $r.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64518,'You keep this up, and I might just have to share my secret to growing so many vegetables.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64519,'This roast looks delicious. I hope you made it yourself.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64520,'Nothing like a homemade roast! Delicious!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64521,'This is our land now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64522,'My momma always told me these flowers were lucky.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64523,'These are yaungol lands!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64524,'That\'s mighty nice of you, sharing such a lucky flower with me.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64525,'We claim your lands for our own!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64526,'Some folks might ask why I like flowers so much. That\'s just me appreciatin\' the beauty of this land.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64527,'','You sure \'bout that, $n? Wow, thank you!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64528,'Ahh, it feels good to get salt in the old fur again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64529,'','Oh no, I didn\'t get you anything in return! Boo...',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64530,'','Yer so nice, $n. I\'m so glad to know someone like you.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64531,'','Oh, my pappy always said these little cat figures were lucky!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64532,'','Jade is so very lucky, didn\'t you know? Thanks for giving this to me.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64533,'','Owning a little piece o\' jade is like having a charm to ward off evil spirits. Thanks so much for this little cat! It\'ll keep me safe, I just know it.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64534,'','Oh, you are so very kind, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64535,'','That\'s so nice of you, to think of me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64536,'Our home was stolen! So we will take yours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64537,'','Out of all the people in the heartland, you gave this to me? I don\'t even know what to say, except I\'m mighty honored.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64538,'Die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64539,'','How did you know that I like cats?',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64540,'You dare challenge me?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64541,'Ooh, nice gift for Chee Chee! Thank you!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64542,'For Chee Chee? You shouldn\'t have!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64543,'Chee Chee loves gifts! Thank you!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64544,'Feather for Chee Chee? Thank you.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64545,'Boss... this is real nice. Thank you.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64546,'You pretty cool, boss. Thank you!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64547,'Challenge accepted!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64548,'You cannot stop us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64549,'Another slave for our new fields!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64550,'You dare challenge the yaungol?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64551,'I saw her, you know.$B$BMazu. The goddess of the sea.$B$BWorst storm of my life. I was young and inexperienced. I went overboard. Everything went dark - I was done for.$B$BThen she appeared before me, clear as a summer afternoon. Beautiful like you couldn\'t imagine - shells around her neck and strings of pearls on her hips. She smiled and held out her slender arm.$B$BNext thing I remember, Dog had me on his back at the surface and the crew was pulling me aboard. Never saw him before - crew said he came out of nowhere. But I know where he came from.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64552,'These are our fields now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64553,'Die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64554,'Surrender!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64555,'Nooooooooo! SHEEEEEEEEEEEEEEEPIEE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64556,'Face your fate!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64557,'Good luck to you friend!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64558,'You dare challenge me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64559,'Raaaaaaar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64560,'Ah! A challenge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64561,'Die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64562,'Fear the wrath of the yaungol!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64563,'Chee Chee is your acquaintance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64564,'Chee Chee is your buddy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64565,'Chee Chee is your friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64566,'Chee Chee is your good friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64567,'Chee Chee is your best friend. Perhaps you could speak to him and see if he\'d help out on the farm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64568,'You and Ella are acquaintances.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64569,'You and Ella are buddies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64570,'You and Ella are friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64571,'You and Ella are good friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64572,'You and Ella are best friends. Perhaps she would be willing to help Farmer Yoon for a while.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64573,'You are buddies with Fish.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64574,'You are friends with Fish.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64575,'You are good friends with Fish.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64576,'You are best friends with Fish. With her knowledge of animals, she would probably help out quite a bit on the farm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64577,'Somehow, you and Farmer Fung have become buddies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64578,'Somehow, you and Farmer Fung have become friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64579,'Somehow, you and Farmer Fung have become good friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64580,'Somehow, you and Farmer Fung have become best friends. He would probably love to help on Sunsong Ranch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64581,'You and Gina are buddies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64582,'You and Gina are friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64583,'You and Gina are good friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64584,'You and Gina are best friends. She loves to get into everyone\'s business, so there\'s no doubt she\'d come spend some time on the farm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64585,'You and Haohan are buddies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64586,'You and Haohan are friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64587,'You and Haohan are good friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64588,'When you and Haohan have a friendship like yours, there\'s no doubt the head of the Tillers Union himself would drop by to lend a hand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64589,'You and Jogu the Drunk are buddies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64590,'You and Jogu the Drunk are friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64591,'You and Jogu the Drunk are good friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64592,'You and Jogu the Drunk have been through so many crop cycles together. Who else but he would be an asset to your farm?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64593,'You and Old Hillpaw are buddies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64594,'You and Old Hillpaw are friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64595,'You and Old Hillpaw are good friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64596,'You\'ve done so much for Old Hillpaw, that old geezer is probably missing your company right now. You should ask him to help on the farm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64597,'You and Sho are buddies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64598,'You and Sho are friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64599,'You and Sho are good friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64600,'You\'ve proven yourself to Sho. She did say she would watch your back if you ever needed it. You can just ask her to watch your crops instead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64601,'You and Tina are buddies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64602,'You and Tina are friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64603,'You and Tina are good friends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64604,'In Tina\'s words, you are her bestie. She\'d probably love a visit to your farm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64605,'The Windblades rush to aid their trapped ally!','The Windblades rush to aid their trapped ally!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64606,'Welcome, my young friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64607,'How did a tuskarr get to Pandaria?','How did a tuskarr get to Pandaria?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64608,'The time has come, my $c friend, to talk of other things. Of crabs and seas and turtles with trees...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64609,'The time has come, my $r friend, to talk of other things. Of hozen and grummles and how my tummy rumbles...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64610,'The time has come, my little friend, to talk of other things. Of mogu and trolls and jinyu river tolls...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64611,'The time has come, my silly friend, to talk of other things. Of yetis and yaks and random shark attacks...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64612,'','Do not be alarmed, $n.$B$BI am projecting my dream self here in order to aid your efforts against the mogu.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64613,'Beautiful, isn\'t she? Fished it up a few years go - it looks just like her... Ask me about it some time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64614,'Nevermind.','Nevermind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64615,'','Hello, $r! What musical selection would you like to hear today?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64616,'Tell me about the statue, Soggy.','Tell me about the statue, Soggy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64617,'Can you play me a song?','Can you play me a song?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64618,'I\'d like to hear A Toast To You.','I\'d like to hear A Toast To You.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64619,'I\'d like to hear Joyful Celebration.','I\'d like to hear Joyful Celebration.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64620,'I\'d like to hear The Bamboo Wilds.','I\'d like to hear The Bamboo Wilds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64621,'I\'d like to hear The Song of Liu Lang.','I\'d like to hear The Song of Liu Lang.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64622,'I\'d like to hear Liu Lang\'s Homecoming.','I\'d like to hear Liu Lang\'s Homecoming.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64623,'I\'d like to hear The Temple of the Five Dawns.','I\'d like to hear The Temple of the Five Dawns.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64624,'','I\'d like to hear PH The Rains of Castamere.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64625,'Wind Lord Mel\'jarak senses that an ally is incapacitated and frees them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64626,'Wind Lord Mel\'jarak senses more than 2 of his allies are incapacitated and frees them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64627,'Got another one for ya!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64628,'Thanks, just put that anywhere.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64629,'You cleansed Gu Cloudstrike\'s soul, the Shado-Pan thank you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64630,'Master Snowdrift speaks highly of how you can hold your own in a fight.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64631,'Lord Taran Tzu has travelled westward beyond the wall to hunt the Sha of Hatred. I hope the hunt goes well.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64632,'The Sha\'s hold over our people has been broken thanks to you. You have our thanks.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64633,'You have done the Shado-Pan a great service, $p.','You have done the Shado-Pan a great service, $p.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64634,'','Greetings again, $c.  I\'ve been watching you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64635,'You showed great courage, $p. The Shado-Pan thanks you.','You showed great courage, $p. The Shado-Pan thanks you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64636,'Your martial skills are unparallelled. There is much I wish to learn from you.','Your martial skills are unparallelled. There is much I wish to learn from you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64637,'You truly are a master of martial fighting. You honor me with your presense.','You truly are a master of martial fighting. You honor me with your presense.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64638,'','Shu is precious to us.  We need to find him, but he has the tendencies of a young child, so we must not scare him in our approach.$B$BI will meditate on where he might be, and how best to reach out to him.  Be patient, my friend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64639,'','Be patient with Shu. He acts as if a child, but he is quite ancient, and quite powerful.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64640,'Apples, get yer fresh apples!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64641,'The biggest, juiciest, loveliest apples in the Valley! Get \'em right here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64642,'Buy some apples! An apple a day keeps the priests away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64643,'So, do you just want to... I don\'t know... Roll it away or something?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(64644,'Wait... is it moving?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(64645,'Well then.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64646,'I\'m guessing you know something about what just happened?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(64647,'Actually, forget it - I don\'t want to know. I\'m going back to my lines.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(64648,'Ya gonna bleed, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64649,'Ya not be stoppin\' de Zandalari, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64650,'Good. Ma raptor be hungry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64651,'Ya be facin\' tha\' Zandalari now. Not some Darkspear traitor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64652,'Ya messed with de wrong trolls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64653,'Be careful de side you choose, bruddah.','',0,0,0,0,0,0,0,0,1,5579,0,0,26124),
(64654,'We gonna burry ya here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64655,'Zandalar gonna rise again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64656,'Ya not be stoppin\' us, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64657,'Have a taste of Zandalari magic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64658,'Tremble, fools! The locust has awakened!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64659,'WHARRGARBL!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64660,'Ya gonna\' be my next trophy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64661,'Zandalar gonna bring back de old ways.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64662,'Ya can\'t beat both de Zandalar an\' de mogu!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64663,'Ughh... <cough> The locust is fine! <cough> <cough>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64664,'The Klaxxi beckon...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64665,'','Fresh bread!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64666,'','Looks like you can handle yourself in the water. Keep up the good work.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64667,'','It\'s all about those Emperor Crabs. Sweet, blue gold is what they are.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64668,'Wind Lord Mel\'jarak calls for reinforcements!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64669,'','We wrecked out here after Soggy took us way off course from our original charter. Thought he could pull a fast one on us. Hah!$B$BTruthfully, we\'re all glad he tried. Not one of us is an \"easy day\'s work\" kinda person.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64670,'','Welcome to Halfhill Market, $r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64671,'','Welcome to Halfhill Market, where the prices are always fair!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64672,'','Long time no see, $n. Welcome back.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64673,'Can I get you something to drink, $r?','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(64674,'What would you like to drink today, $n?','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(64675,'Farming must build up a powerful thirst, eh $n?','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(64676,'I challenge you.','I challenge you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64677,'3... 2... 1... FIGHT!','',15,0,0,0,0,0,1,0,1,0,29028,0,26124),
(64678,'The unthinkable has happened: Our siege on Theramore has failed.','',0,0,0,0,2,0,5,0,1,0,30642,0,26124),
(64679,'','Noodles! I told you not to go heavy on the seasoning!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64680,'','Whoa Noodles, what are you putting in the soup?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64681,'','Mmmm, the soup tastes delicious. Good job, Noodles!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64682,'So, are you ready to start? Let\'s see what you\'ve got.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64683,'Let\'s go!','Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64684,'You\'re the contingency plan. Your mission is to infiltrate Theramore Isle.','',0,0,0,0,2,0,1,0,1,0,30643,0,26124),
(64685,'','Welcome to my wall, $c.$B$BNow, let\'s kick some mantid butt!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64686,'Ah, so very close. But you must remain CENTERED. Inner harmony is crucial to your survival on this land. Come, let us try again!','',0,0,0,0,0,0,1,0,1,0,30063,0,26124),
(64687,'Keep the spark centered!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64688,'Don\'t get caught in the demolisher\'s sights.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64689,'There is a hozen on your face! Jump to shake it off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64690,'Oh my! A new urgency has hardened your resolve. I suppose my work here is done.','',0,0,0,0,0,0,4,0,1,0,30062,0,26124),
(64691,'Those who participate in the Brewmaster scenarios will earn valor. And if you find any rare items as you adventure with a Brewmaster, they are yours to keep!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64692,'The largest brewery in Pandaria is the Stormstout Brewery in the Valley of the Four Winds. You might start there if you\'re looking for adventure.$B$BBrewmasters are also wanderers by nature, and can be found roaming all over the land searching for rare ingredients or concocting new brews.$B$BSuch brewmasters are often found in unique scenarios.$B$BBrewmaster Tzu defends against enemies in the Greenstone Village scenario.$B$BBrewmaster Bo seeks tropical flavors in the Unga Ingoo scenario.$B$BBrewmaster Boof celebrates the season at The Brewmoon Festival scenario, and Brewmaster Blanche is cooking up something shocking in A Brewing Storm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64693,'Are there rewards for helping brewmasters?','Are there rewards for helping brewmasters?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64694,'Where can I find brewmasters that might need aid?','Where can I find brewmasters that might need aid?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64695,'Which brewmaster would you like to aid today?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64696,'Queue for A Brewing Storm.','Queue for A Brewing Storm.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64697,'Do you have everything? Very good! Come with me.','',0,0,0,0,0,0,273,0,1,0,30054,0,26124),
(64698,'Queue for the Brewmoon Festival.','Queue for the Brewmoon Festival.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64699,'In order for this dream brew to show you what you seek, you must reach a place of inner harmony. I can show you how.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64700,'Queue for Unga Ingoo.','Queue for Unga Ingoo.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64701,'Queue for Greenstone Village.','Queue for Greenstone Village.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64702,'Drink up to begin, friend.','',0,0,0,0,0,0,273,0,1,0,30056,0,26124),
(64703,'Tell me more about Scenario: A Brewing Storm.','Tell me more about Scenario: A Brewing Storm.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64704,'Tell me more about Scenario: Unga Ingoo.','Tell me more about Scenario: Unga Ingoo.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64705,'Tell me more about Scenario: Brewmoon Festival.','Tell me more about Scenario: Brewmoon Festival.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64706,'Tell me more about Scenario: Greenstone Village.','Tell me more about Scenario: Greenstone Village.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64707,'Brewmaster Blanche is trying to make Boomer Brew in the middle of a storm, but some formidable enemies are getting in her way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64708,'I will return to Klaxxi\'vess to meet with the council. Please take good care of Kovok.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64709,'Rescue Jungle Brew from the clutches of the evil hozen pirates of Unga Ingoo.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64710,'Let\'s see if you can back that talk up.','Let\'s see if you can back that talk up.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64711,'Rescue the villagers of Greenstone from mischievious (and dangerous) forest denizens.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64712,'Brew something delicious and defend from yaungol attackers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64713,'<Tenwu yawns.>\n\nI\'m waiting...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64714,'Get off me, insolent crabs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64715,'Feed you to da crows!','Feed you to da crows!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64716,'If I help the Anglers, what\'s in it for me?','If I help the Anglers, what\'s in it for me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64717,'Where can I find the Anglers?','Where can I find the Anglers?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64718,'','The best fishing can be found down at the Anglers Wharf in southeastern Krasarang Wilds. Anyone is welcome to visit us and take up a fishing rod!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64719,'','Whaddaya mean, what\'s in it for you? What kind of question is that?$B$BIsn\'t the joy of fishing The Big One out of the sea enough? What about feeling the sun on your neck and the saltwater spray of the ocean on your face? What about opening a cold brew while sitting back with your friends?$B$BThat ain\'t enough?!?$B$BLet me tell you, your future life as a $Gfisherman:fisherwoman; will be rewarding beyond compare!$B$BYou can improve your fishing skill for starters. Gain enough skill, and you can purchase powerful fishing rods.$B$BWell-respected fishermen can get access to a special fish pet, a water strider mount, and even your own personal fishing raft!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64720,'VICTORY!','',15,0,0,0,0,0,1,0,1,0,29027,0,26124),
(64721,'Greetings, $r.$B$BI can see from a glance that you are a great adventurer.$B$BAll across the land, there are dark crypts and vast palaces, all full of terrible and mighty enemies. They guard many secrets, but also... harbor great rewards.$B$BThe bravest of heroes may venture to attempt these encounters, but beware! You would be racing against time, as well as testing your skill against other heroes!$B$BAre you up for the challenge?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64722,'Oh, where should I begin!?$B$BFirst, the life of a farmer involves sowing seeds and harvesting crops. The crops that you sell can be used in cooking, sold on the auction house, traded to other buyers, or traded for meat and fish. I\'ve even heard of rare seeds that can be planted for unique items... perhaps even a little pet!$B$BThen there\'s all of Halfhill to explore! The best way to make friends with the locals is to give them gifts, and if you become friends, they might just give you some nice gifts in return.$B$BThere\'s always plenty to do around the fields, and an extra pair of hands would sure be appreciated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64723,'Well, the Tillers won\'t be crowning you in jewels or building you up for war.$B$BNah, the life of a farmer is about somethin\' a little different.$B$BIf you stick with it, you might meet some real interesting folks. You\'ll be able to build up your own farm, plant your own crops, and enjoy the fruits of your own labor.$B$BSo if all that sounds interesting, then you should go to Halfhill and see for yourself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64724,'Why should I help the Tillers?','Why should I help the Tillers?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64725,'What kind of stuff can I do with the Tillers?','What kind of stuff can I do with the Tillers?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64726,'The Order of the Cloud Serpent is sworn to defend the Jade Forest. We train at the Arboretum, just to the north of the Temple of the Jade Serpent in the Jade Forest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64727,'There is no greater honor than rising through the ranks of the Order of the Cloud Serpent.$B$BOnce you have proven yourself, you will be free to wander the land with your serpent as your flying mount.$B$BYou will also earn the Cloud Serpent Riding skill, which will allow you to ride any cloud serpent mount from Pandaria.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64728,'Once you enter the Order of the Cloud Serpent, you will begin the journey of a serpent rider.$B$BYou will raise a baby serpent from the egg, train with it every day, and watch it grow to adulthood.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64729,'What does it mean to join the Order of the Cloud Serpent?','What does it mean to join the Order of the Cloud Serpent?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64730,'What is the reward for rising through the Order of the Cloud Serpent?','What is the reward for rising through the Order of the Cloud Serpent?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64731,'Fighting off that leviathan was fun, but I think I\'ve had enough adventure for a lifetime. Safe travels to you, $p. Stop by any time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64732,'Mazu\'s been good to me. Her waters have sustained me and her winds have carried me to far off places. What better life could I have asked for?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64733,'','Need a little fortune in your favor, $r? Everyone needs a little luck to spruce things up!$B$BDon\'t worry, I can help tweak the odds in your favor!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64734,'Yu\'lon, the Jade Serpent, keeps vigil over the east. Unfortunately, her temple has fallen to the sha of doubt.$B$BEven now, the temple needs our help. We must do everything we can to keep the sha at bay!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64735,'','Now THAT was a fine display of harpoonery!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64736,'Xuen, the White Tiger, guards against the cold winds of the north.$B$BToday, he seeks to test the greatest champions of the land in a series of trials.$B$BIf you believe yourself worthy, travel north to the Temple of the White Tiger, and make your challenge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64737,'Chi-Ji watches over the Temple of the Red Crane to the south.$B$BShe is trying to regain order after the sha eruption created chaos across the land.$B$BIf you wish to help her, travel to the Cradle of Chi-Ji in the Krasarang Wilds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64738,'Niuzao, the Black Ox, stands firm against the enemies beyond the wall.$B$BHe desperately needs aid to fight off the encroaching mantid.$B$BIf you wish to help, travel west to the temple in the Townlong Steppes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64739,'By defending the four temples, you will earn great standing with the August Celestials. You will be granted the ability to purchase items of great power.$B$BIn addition, you will help defend this land against some of our greatest enemies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64740,'Why should I help the August Celestials?','Why should I help the August Celestials?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64741,'How can I help the August Celestials today?','How can I help the August Celestials today?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64742,'','The Vale of Eternal Blossoms is in great danger, $r.$B$BGarrosh Hellscream has tainted the waters of our sacred Vale with the Heart of Y\'Shaarj, a dark relic from an ancient evil. The effects of his act... well... you can see them for yourself here in the Vale.$B$BNow, remnants of the sha threaten our very existence. We have no choice but to fight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64743,'','The Vale of Eternal Blossoms is in great danger, $r.$B$BGarrosh Hellscream has tainted the waters of our sacred Vale with the Heart of Y\'Shaarj, a dark relic from an ancient evil. The effects of his act... well... you can see them for yourself here in the Vale.$B$BNow, remnants of the sha threaten our very existence. We have no choice but to fight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64744,'','Of course. It is only fair that we reward those who risk their lives for our cause.$B$BBy helping to defend the Vale, you will not only keep our borders safe, but you will also gain access to our vast stores of powerful treasures.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64745,'Will I be rewarded for helping to defend the Vale?','Will I be rewarded for helping to defend the Vale?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64746,'How can I help The Golden Lotus?','How can I help The Golden Lotus?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64747,'Please fly me to Zan\'vess.','Please fly me to Zan\'vess.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64748,'Please fly me to Kypari Zar.','Please fly me to Kypari Zar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64749,'There are a few ways to earn our esteem.$B$BWe are busy dealing with sha eruptions at Firebough Nook in Kun-Lai Summit. Help us there, and you will gain a foothold into our brotherhood.$B$BThe Shado-Pan Monastery is also in trouble. You may be able to assist our brothers and sisters there.$B$BThe Sha of Anger roams the fields of Kun-Lai to the north. Defeat it, and you will gain great respect from our order.$B$BA Shado-Pan contigent chases the Sha of Hatred in the Townlong Steppes. They may need help.$B$BIf you wish to earn our highest esteem, you must first prove yourself by earning revered standing with the Golden Lotus. Only then, speak to my brothers and sisters at Shado-Pan Garrison in the Townlong Steppes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64750,'The Shado-Pan is an ancient order that accepts and trains only the most elite and worthy.$B$BShould you manage to make yourself useful, you may find many powerful items available to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64751,'Why should I help the Shado-Pan?','Why should I help the Shado-Pan?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64752,'How can I help the Shado-Pan?','How can I help the Shado-Pan?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64753,'The Lorewalkers travel the world, discovering new tales and retelling old ones.$B$BWe explore the rich history of the places and people in Pandaria.$B$BIf you would like to hear some of these stories for yourself, speak to Lorewalker Cho at the Seat of Knowledge, above the entrance to Mogu\'shan Palace here in the Vale of Eternal Blossoms.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64754,'The Lorewalkers will send you to explore significant areas of Pandaria to recover cultural artifacts.$B$BOnce you find all the artifacts that belong to a collection, you will be able to hear the entire story from start to finish.$B$BFind all the artifacts and collect all the books to become a Lorewalker!$B$BIf you would like to become a researcher, then you should speak to Lorewalker Cho at the Seat of Knowledge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64755,'The journey is its own reward, young one. Seek pleasure in a story\'s telling, and you will come away with riches beyond compare.$B$BAh yes, and one more thing. Those who rise in the ranks of the Lorewalkers are granted a very special gift - the ability to ride upon the clouds.','The journey is its own reward, young one. Seek pleasure in a story\'s telling, and you will come away with riches beyond compare.$B$BAh yes, and one more thing. Those who rise in the ranks of the Lorewalkers are granted a very special gift - the ability to ride upon the clouds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64756,'Why should I help the Lorewalkers?','Why should I help the Lorewalkers?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64757,'How can I help the Lorewalkers?','How can I help the Lorewalkers?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64758,'','I have just returned from the wall.$B$BThere, I heard rumors of a faction called The Klaxxi from beyond the Serpent\'s Spine. Supposedly, they are a council of mantid elders who have split off from the Mantid Empire, and now work in direct defiance of the mantid queen.$B$BI have seen with my own eyes the power that these mantid wield.$B$BIf these rumors are true, then perhaps there is a way to ally with these... Klaxxi... and work with them to stop the mantid swarm.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64759,'','It is a mystery to me, $r. If you want to find out, you are both crazy and foolish!$B$BBut I suppose there is no other way to meet the Klaxxi than to venture beyond the wall into the Dread Wastes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64760,'','I do not know, $r.$B$BWe know so little about the Klaxxi. They seem to be quite ruthless, so perhaps your only reward would be a swift death.$B$BThen again, their civilization is quite vast and advanced. If you play your cards right, perhaps they will grant you untold power.$B$BThere is only one way to find out.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64761,'How will I be rewarded by helping the Klaxxi?','How will I be rewarded by helping the Klaxxi?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64762,'How can I help the Klaxxi?','How can I help the Klaxxi?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64763,'','The serpent is here!',0,0,0,0,0,0,0,0,1,0,0,27376,26124),
(64764,'','Ji finished setting up the fireworks.  Use them to get it out of the sky.',0,0,0,0,0,0,0,0,1,0,0,27377,26124),
(64765,'','You\'re quick on your feet.  Keep it up!',0,0,0,0,0,0,0,0,1,0,0,27378,26124),
(64766,'','That\'s the way to do it!',0,0,0,0,0,0,0,0,1,0,0,27380,26124),
(64767,'','You\'ve done it!  Now quickly, lets attack it while it\'s grounded.',0,0,0,0,0,0,0,0,1,0,0,27381,26124),
(64768,'','It\'s down!  Let\'s finish it off.',0,0,0,0,0,0,0,0,1,0,0,27382,26124),
(64769,'','Simply amazing!  You can fight by my side any day.',0,0,0,0,0,0,0,0,1,0,0,27383,26124),
(64772,'I come with the yak. If a luckydo is wise enough to buy, I will be wise enough to sell my wares to them.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64773,'I make the luckydos luckier. Bring me an item and I will change its fortune to better serve your own... for a price.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64774,'We are sieging Niuzao Temple.$B$BYou are known to us, $n. Your help is necessary once more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64775,'Have I got a yak for you!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64776,'Greetings, traveler.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(64777,'What is the Vale of Eternal Blossoms?','What is the Vale of Eternal Blossoms?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64778,'','We fight the mantid, yaungol, and mogu. Enemies face us from all sides.\n\nI\'m here to make sure there are no surprises.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64779,'Arrrrrrrrrrrr... wikkets!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64780,'Avast... dookers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64781,'Oh - of course you haven\'t heard of the Vale.$b$bTwelve thousand years ago, it was the seat of Mogu power, the heart of an empire. Legend tells of sacred pools in there, the source of Mogu magic that allowed them to twist and shape flesh. But they could also be used for healing miracles. That is, if you believe in the legends.$b$bAfter the pandaren revolution, the Celestials agreed to seal away the Vale, so that the power of the pools could never be used for mischief.','',153,396,0,0,1000,0,0,0,1,0,0,0,26124),
(64782,'Heyarrrrrr!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64783,'I\'m gonna shiver your timbers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64784,'You are what\'s on the menu!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64785,'Cooking time with Ookie!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64786,'Wikket stew, coming up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64787,'Time to hozango!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64788,'Wikkets gonna get served!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64789,'Dance, wikkets! Dance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64790,'Bam bam BOOM!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64791,'Ba-ba-ba-ba BAM!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64792,'Wikkets gonna get Ba-Bammed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64793,'Got a present for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64794,'Say \"hello\" to \"goodbye\"!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64795,'Who is in the Vale now?','Who is in the Vale now?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64796,'Your mind is plagued with |cFFFF0404|Hspell:124862|h[Visions of Demise]|h|r !','Your mind is plagued with |cFFFF0404|Hspell:124862|h[Visions of Demise]|h|r !',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64797,'Hardly anyone. It\'s guarded by a group called \"The Golden Lotus.\" Members of the Golden Lotus are hand-picked by the Celestials to maintain a vigil over the Vale, but few are chosen.$b$bI\'ve heard stories about the Vale since I was a cub. Can you believe such a place actually exists?$b$bDo you think the legends of the pools are true? I wish I could see for myself!','',153,396,0,0,1000,0,0,0,1,0,0,0,26124),
(64798,'What in the world is that?','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(64799,'Oh! You\'re not gonna get my boy that easily.','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(64800,'Did you forget who you\'re messing with?!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(64801,'Let me show you how a Nesingwary hunts!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(64802,'Good, bad, I\'m the guy with the gun.','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(64803,'No one messes with MY boy!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(64804,'Get that filthy thing out of my boy\'s head!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(64805,'Watch out for those mists! That stuff looks poisonous.','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(64806,'That\'s a dark gloom to be sure. Be careful!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(64807,'Do you know what that thing is?','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(64808,'Next time ya go hunting, cover that glowing eye of yours. It gives ya away.','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(64809,'Aim for the eye!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(64810,'Don\'t stand in the fire ya git.','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(64811,'$p, over here near the end of the bridge.','',0,0,0,0,0,0,0,0,1,17710,0,0,26124),
(64812,'Masterfully done.$B$BWe wouldn\'t have succeeded without you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64813,'','By defending the four temples, you will earn great standing with the August Celestials. You will be granted the ability to purchase items of great power.$B$BIn addition, you will help defend this land against some of our greatest enemies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64814,'','Yu\'lon, the Jade Serpent, keeps vigil over the east. Unfortunately, her temple has fallen to the sha of doubt.$B$BEven now, the temple needs our help. We must do everything we can to keep the sha at bay!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64815,'','Xuen, the White Tiger, guards against the cold winds of the north.$B$BToday, he seeks to test the greatest champions of the land in a series of trials.$B$BIf you believe yourself worthy, travel north to the Temple of the White Tiger, and make your challenge!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64816,'','Chi-Ji watches over the Temple of the Red Crane to the south.$B$BShe is trying to regain order after the sha eruption created chaos across the land.$B$BIf you wish to help her, travel to the Cradle of Chi-Ji in the Krasarang Wilds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64817,'','Niuzao, the Black Ox, stands firm against the enemies beyond the wall.$B$BHe desperately needs aid to fight off the encroaching mantid.$B$BIf you wish to help, travel west to the temple in the Townlong Steppes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64818,'Of course. It is only fair that we reward those who risk their lives for our cause.$B$BBy helping to defend the Vale, you will not only keep our borders safe, but you will also gain access to our vast stores of powerful treasures.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64819,'The Vale of Eternal Blossoms is in great danger, $r.$B$BGarrosh Hellscream has tainted the waters of our sacred Vale with the Heart of Y\'Shaarj, a dark relic from an ancient evil. The effects of his act... well... you can see them for yourself here in the Vale.$B$BNow, remnants of the sha threaten our very existence. We have no choice but to fight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64820,'There is nothing left to be done for the Vale at this time, $n. The mogu disappeared shortly after you killed their leader. We are safe, thanks to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64821,'','The Lorewalkers travel the world, discovering new tales and retelling old ones.$B$BWe explore the rich history of the places and people in Pandaria.$B$BIf you would like to hear some of these stories for yourself, speak to Lorewalker Cho at the Seat of Knowledge, above the entrance to Mogu\'shan Palace here in the Vale of Eternal Blossoms.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64822,'','The Lorewalkers will send you to explore significant areas of Pandaria to recover cultural artifacts.$B$BOnce you find all the artifacts that belong to a collection, you will be able to hear the entire story from start to finish.$B$BFind all the artifacts and collect all the books to become a Lorewalker!$B$BIf you would like to become a researcher, then you should speak to Lorewalker Cho at the Seat of Knowledge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64823,'','The journey is its own reward, young one. Seek pleasure in a story\'s telling, and you will come away with riches beyond compare.$B$BAh yes, and one more thing. Those who rise in the ranks of the Lorewalkers are granted a very special gift - the ability to ride upon the clouds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64824,'The Shado-Pan is an ancient order that accepts and trains only the most elite and worthy.$B$BShould you manage to make yourself useful, you may find many powerful items available to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64825,'There are a few ways to earn our esteem.$B$BWe are busy dealing with sha eruptions at Firebough Nook in Kun-Lai Summit. Help us there, and you will gain a foothold into our brotherhood.$B$BThe Shado-Pan Monastery is also in trouble. You may be able to assist our brothers and sisters there.$B$BThe Sha of Anger roams the fields of Kun-Lai to the north. Defeat it, and you will gain great respect from our order.$B$BA Shado-Pan contigent chases the Sha of Hatred in the Townlong Steppes. They may need help.$B$BIf you wish to earn our highest esteem, you must first prove yourself by earning revered standing with the Golden Lotus. Only then, speak to my brothers and sisters at Shado-Pan Garrison in the Townlong Steppes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64826,'Burn their ships. Butcher their flight master. Sabotage their war machines. And rescue our spy!','',0,0,0,0,2,0,25,0,1,0,30644,0,26124),
(64827,'I have just returned from the wall.$B$BThere, I heard rumors of a faction called The Klaxxi from beyond the Serpent\'s Spine. Supposedly, they are a council of mantid elders who have split off from the Mantid Empire, and now work in direct defiance of the mantid queen.$B$BI have seen with my own eyes the power that these mantid wield.$B$BIf these rumors are true, then perhaps there is a way to ally with these... Klaxxi... and work with them to stop the mantid swarm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64828,'It is a mystery to me, $r. If you want to find out, you are both crazy and foolish!$B$BBut I suppose there is no other way to meet the Klaxxi than to venture beyond the wall into the Dread Wastes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64829,'I do not know, $r.$B$BWe know so little about the Klaxxi. They seem to be quite ruthless, so perhaps your only reward would be a swift death.$B$BThen again, their civilization is quite vast and advanced. If you play your cards right, perhaps they will grant you untold power.$B$BThere is only one way to find out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64830,'Throw them into chaos while we regroup. The eyes of Hellscream are upon you!','',0,0,0,0,2,0,66,0,1,0,30645,0,26124),
(64831,'Ji Firepaw warmly hugs you back.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64832,'','The Order of the Cloud Serpent is sworn to defend the Jade Forest. We train at the Arboretum, just to the north of the Temple of the Jade Serpent in the Jade Forest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64833,'','There is no greater honor than rising through the ranks of the Order of the Cloud Serpent.$B$BOnce you have proven yourself, you will be free to wander the land with your serpent as your flying mount.$B$BYou will also earn the Cloud Serpent Riding skill, which will allow you to ride any cloud serpent mount from Pandaria.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64834,'','Once you enter the Order of the Cloud Serpent, you will begin the journey of a serpent rider.$B$BYou will raise a baby serpent from the egg, train with it every day, and watch it grow to adulthood.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64835,'The keg bursts, dousing %s\'s flames!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64836,'Well, the Tillers won\'t be crowning you in jewels or building you for war.$B$BFarming is a little different.$B$BIt\'s a slower life, but a good one. You ask Dooka, Dooka knows!$B$BYou can build up your own farm, plant your own crops, and enjoy eating all the food you grow! That\'s Dooka\'s favorite part!$B$BSo if that sounds interesting, then you should go to Halfhill and see for yourself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64837,'Oh, where does Dooka begin!?$B$BFirst, farmer sows seeds and harvests crops. Vegetables can be used in cooking, sold at market, traded to other buyers, and lots of other stuff. I\'ve even heard of rare seeds that can be planted for special items... like a little pet!$B$BThen there\'s everyone in Halfhill to meet! The people who live there are real interesting, even to a monkey like me. You give them gifts, make nice friends, and they might give you some nice gifts, too!$B$BAlways plenty to do around the fields!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64838,'The mantid artillery is here, you must hurry heroes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64839,'The best fishing can be found down at the Anglers Wharf in southeastern Krasarang Wilds. Anyone is welcome to visit us and take up a fishing rod!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64840,'Whaddaya mean, what\'s in it for you? What kind of question is that?$B$BIsn\'t the joy of fishing The Big One out of the sea enough? What about feeling the sun on your neck and the saltwater spray of the ocean on your face? What about opening a cold brew while sitting back with your friends?$B$BThat ain\'t enough?!?$B$BLet me tell you, the life of a $Gfisherman:fisherwoman; is rewarding beyond compare!$B$BYou can improve your fishing skill for starters. There are Craftsmen Tokens to be earned for helping out the locals. Gain enough skill, and you can purchase powerful fishing rods.$B$BWell-respected fishermen can get access to a special fish pet and a water strider mount. There\'s even a fishing raft, for crying out loud!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64841,'','Those who participate in the Brewmaster scenarios will earn valor. And if you find any rare items as you adventure with a Brewmaster, they are yours to keep!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64842,'','The largest brewery in Pandaria is the Stormstout Brewery in the Valley of the Four Winds. You might start there if you\'re looking for adventure.$B$BBrewmasters are also wanderers by nature, and can be found roaming all over the land searching for rare ingredients or concocting new brews.$B$BSuch brewmasters are often found in unique scenarios.$B$BBrewmaster Tzu defends against enemies in the Greenstone Village scenario.$B$BBrewmaster Bo seeks tropical flavors in the Unga Ingoo scenario.$B$BBrewmaster Boof celebrates the season at The Brewmoon Festival scenario, and Brewmaster Blanche is cooking up something shocking in A Brewing Storm.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64843,'','Brewmaster Blanche is trying to make Boomer Brew in the middle of a storm, but some formidable enemies are getting in her way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64844,'','Rescue Jungle Brew from the clutches of the evil hozen pirates of Unga Ingoo.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64845,'','Brew something delicious and defend from yaungol attackers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64846,'','Rescue the villagers of Greenstone from mischievious (and dangerous) forest denizens.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64847,'','Which brewmaster would you like to aid today?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64848,'','Thank Shen-zin Su that you\'re here.  I could use your help!',0,0,0,0,0,0,0,0,1,0,0,27384,26124),
(64849,'','Get clear when it when it raises its weapon, it\'s even stronger than it looks.',0,0,0,0,0,0,0,0,1,0,0,27385,26124),
(64850,'','It\'s calling allies!  I\'ll keep him busy while you handle them.',0,0,0,0,0,0,0,0,1,0,0,27386,26124),
(64852,'','We\'re wearing him down.  Keep it up!',0,0,0,0,0,0,0,0,1,0,0,27387,26124),
(64853,'','I don\'t know what I would have done without you.  It\'s good that you came.',0,0,0,0,0,0,0,0,1,0,0,27388,26124),
(64855,'Shado-Pan Ice Archers appear on the rooftops!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64856,'We were fortunate enough to find the Vale after it opened its gates. We sought refuge, and have found safe haven.$B$BAre you lost? May I help you find something?','We were fortunate enough to find the Vale after it opened its gates. We sought refuge, and have found safe haven.$B$BAre you lost? May I help you find something?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64857,'We were fortunate enough to find the Vale after it opened its gates. We sought refuge, and have found safe haven.$B$BAre you lost? May I help you find something?','We were fortunate enough to find the Vale after it opened its gates. We sought refuge, and have found safe haven.$B$BAre you lost? May I help you find something?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64858,'','Couldn\'t have done that better myself.$B$BWell, probably not.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64859,'The ships are aflame! Troops, to the harbor!','',0,0,0,0,0,0,0,0,1,0,30565,0,26124),
(64860,'','$p, over here at the exit.',0,0,0,0,0,0,0,0,1,19114,0,0,26124),
(64861,'The auction house is located on the second floor, on the left side of the building as you enter.$B$BI will mark the location on your map.','The auction house is located on the second floor, on the left side of the building as you enter.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64862,'The bank is located on the second floor, on the right side of the building as you enter.$B$BI will mark the location on your map.','The bank is located on the second floor, on the right side of the building as you enter.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64863,'The flight master is located out on the main terrace, at the top of the twin stairs and before you enter the main building.$B$BI will mark the location on your map.','The flight master is located out on the main terrace, at the top of the twin stairs and before you enter the main building.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64864,'The inn is located on the main floor, to the right as you enter the building.$B$BI will mark the location on your map.','The inn is located on the main floor, to the right as you enter the building.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64865,'Jaul Hsu, the stable master, can be found on the main terrace before you enter the main building. He stands next to the flight master.$B$BI will mark the location on your map.','Jaul Hsu, the stable master, can be found on the main terrace before you enter the main building. He stands next to the flight master.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64866,'The ethereals set up shop in the upstairs corridor to the right as you enter the main building.$B$BI will mark the location on your map.','The ethereals set up shop in the upstairs corridor to the right as you enter the main building.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64867,'Yanyra Moonfell peddles reagents and can be found in the crafter\'s hall, to the left as you enter the building.$B$BI will mark the location on your map.','Yanyra Moonfell peddles reagents and can be found in the crafter\'s hall, to the left as you enter the building.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64868,'Raishen the Needle is well-known for her beautiful clothes.$B$BShe works in the crafter\'s hall, to the left as you enter the building.$B$BI will mark the location on your map.','Raishen the Needle is well-known for her beautiful clothes.$B$BShe works in the crafter\'s hall, to the left as you enter the building.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64869,'Clara Henry carries enchanting supplies. She can be found in the crafter\'s hall, to the left as you enter the building.$B$BI will mark the location on your map.','Clara Henry carries enchanting supplies. She can be found in the crafter\'s hall, to the left as you enter the building.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64870,'Ah, a scrollmaker! You\'ll be looking for inks and vellum, I suppose? They can be found in the crafter\'s hall, to the left as you enter the building.$B$BI will mark the location on your map.','Ah, a scrollmaker! You\'ll be looking for inks and vellum, I suppose? They can be found in the crafter\'s hall, to the left as you enter the building.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64871,'Yes, there is a vendor of herbs in the city. Tommy Tinkerspade can be found in the crafter\'s hall, to the left as you enter the building.$B$BI will mark the location on your map.','Yes, there is a vendor of herbs in the city. Tommy Tinkerspade can be found in the crafter\'s hall, to the left as you enter the building.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64872,'You are looking for the apothecary. He makes some truly wonderful potions and tinctures. Got rid of my rash in no time!$B$BAhem... Apothecary Greenmoss sells his wares in the crafter\'s hall. I will mark the location on your map.','You are looking for the apothecary. He makes some truly wonderful potions and tinctures. Got rid of my rash in no time!$B$BAhem... Apothecary Greenmoss sells his wares in the crafter\'s hall. I will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64873,'Ready to cook up a hot meal? You can find everything you need from Jojo. She sells her wares in the crafter\'s hall.$B$BI will mark the location on your map.','Ready to cook up a hot meal? You can find everything you need from Jojo. She sells her wares in the crafter\'s hall.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64874,'The blacksmiths all work in the crafter\'s hall, to the left as you enter the main building.$B$BI will mark the location on your map.','The blacksmiths all work in the crafter\'s hall, to the left as you enter the main building.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64875,'You can purchase mining supplies in the crafter\'s hall, to the left as you enter the main building.$B$BI will mark the location on your map.','You can purchase mining supplies in the crafter\'s hall, to the left as you enter the main building.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64876,'I seem to recall there is an engineer in the crafter\'s hall, to the left as you enter the main building.$B$BI will mark the location on your map.','I seem to recall there is an engineer in the crafter\'s hall, to the left as you enter the main building.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64877,'Leatherworking and skins? You must be looking for a tanner. There\'s on in the crafter\'s hall, if I recall.$B$BI will mark the location on your map.','Leatherworking and skins? You must be looking for a tanner. There\'s on in the crafter\'s hall, if I recall.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64878,'Oh, I hope the injury is not serious! The healers can be found inside the main hall, just to the left of the central stairs.$B$BI will mark the location on your map.','Oh, I hope the injury is not serious! The healers can be found inside the main hall, just to the left of the central stairs.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64879,'Jewelcrafting? That\'s fine work, indeed. You can purchase supplies from Bero in the crafter\'s hall.$B$BI will mark the location on your map.','Jewelcrafting? That\'s fine work, indeed. You can purchase supplies from Bero in the crafter\'s hall.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64880,'Are you looking for some food and drink? If so, then the Sway Dish Chef in the inn has exactly what you\'re looking for.$B$BI will mark the location on your map.','Are you looking for some food and drink? If so, then the Sway Dish Chef in the inn has exactly what you\'re looking for.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64881,'Looking for some brew, eh? Well, there are two brewmasters who wander around the city selling their excellent ales.$B$BIf you don\'t run into them, then Hara Alebelly up at the Nightingale Lounge or Sarya Teaflower in the inn can fix you right up.','Looking for some brew, eh? Well, there are two brewmasters who wander around the city selling their excellent ales.$B$BIf you don\'t run into them, then Hara Alebelly up at the Nightingale Lounge or Sarya Teaflower in the inn can fix you right up.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64882,'Itching for something sweet? You need to find Pink Peony.$B$BShe\'s usually wandering around the front terrace or the main hall of the shrine.','Itching for something sweet? You need to find Pink Peony.$B$BShe\'s usually wandering around the front terrace or the main hall of the shrine.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64883,'The baker is usually wandering all around the shrine. He around the main hall or out on the terrace.','The baker is usually wandering all around the shrine. He around the main hall or out on the terrace.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64884,'You need to speak to Michael Bedernik. He has an ample supply of meats.$B$BI\'ll mark his location on your map. Good luck!','You need to speak to Michael Bedernik. He has an ample supply of meats.$B$BI\'ll mark his location on your map. Good luck!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64885,'Thinking about setting off a spark or two? I should go buy some fireworks myself! The vendor can be found out on the main terrace.$B$BI\'ll mark the location on your map.','Thinking about setting off a spark or two? I should go buy some fireworks myself! The vendor can be found out on the main terrace.$B$BI\'ll mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64886,'Great Tiger, the strangers from beyond the mists, they cannot be trusted. The wreckage in the Jade Forest can attest to this.','',0,0,0,0,0,0,396,0,1,0,28416,0,26124),
(64887,'Even now an airship draws near; its arcane payload will flatten Theramore Isle and everyone still standing upon it.','',0,0,0,0,0,0,0,0,1,0,31479,0,26124),
(64888,'...I\'ve seen them with my own eyes: Mogu legions, storming the Vale in force. We are not trained for mass combat!','',0,0,0,0,0,0,5,0,1,0,29049,0,26124),
(64889,'Give us a chance to put things right.','',0,0,0,0,0,0,396,0,1,0,38016,0,26124),
(64890,'There we go. Should you pass through Silvermoon City, come and say hello, hmmm? Al diel shala...','',0,0,0,0,0,0,0,0,1,0,31480,0,26124),
(64892,'','Greetings, traveler. Welcome to The Golden Lantern!',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64893,'','Rest your weary feet, $r. Fine food and drink await you within.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64894,'','Oh, you are looking too thin, $r. You must have something to eat. Sit and I will get you something.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64895,'','Here at The Golden Lantern, the taps never empty and the barrels never stop rolling! What can I get for you?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64896,'','Welcome to the Golden Lantern, the finest inn in the Vale. If anyone wants to argue with me, I will show them my fists.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64897,'','I have the softest featherbeds you can find for a thousand miles. Would you like to try one?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64898,'','Are you eating enough, $r? Please remember to take care of yourself.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(64899,'','My inn has all the comforts of home, and more. Please make yourself comfortable here.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64900,'Tinctures, potions, draughts, and tonics!','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64901,'Vials, get your vials here!','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64902,'Hot, freshly baked bread!','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64903,'You have been affected by |cFFFF0404|Hspell:123788|h[Cry of Terror]|h|r !','You have been affected by |cFFFF0404|Hspell:123788|h[Cry of Terror]|h|r !',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64904,'Hot from the oven, baked fresh! Get your bread!','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64905,'','Flowers for sale, get your beautiful flowers!',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64906,'%s retreats to her chrysalis!','%s retreats to her chrysalis!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64907,'%s emerges from her chrysalis!','%s emerges from her chrysalis!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64908,'','Freshly picked flowers for sale!',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64909,'','Beautiful flowers for your loved ones! Get your flowers!',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64910,'','Get these rare blooms before they wilt! Flowers for sale!',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64911,'The Sha of Fear |cFFFF0404|Hspell:126121|h[Corrupts]|h|r a dissonance field!','The Sha of Fear |cFFFF0404|Hspell:126121|h[Corrupts]|h|r a dissonance field!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64912,'That\'s a good girl, Saari.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64913,'What a good kitty you are.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64914,'Well, time for a stretch.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64915,'Saari! Go fetch!','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64916,'Hehe, that\'s what I get for trying to get a cat to fetch.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64917,'I love my mommy and daddy.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64918,'Look at him! He\'s always a little crabby in the morning.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64919,'Woah, look at that! It\'s huge!','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64920,'It\'s bigger than two houses!','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64921,'Don\'t get too close, Maia! It\'s going to bite your head off!','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64922,'','No it\'s not! Don\'t be stupid!',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64923,'','I want some candy!',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64924,'Don\'t touch the big tiger, Maia! It\'s going to eat you for dinner!','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64925,'','Whoaaa.... big kitty!',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64926,'','Eeeeeeeeek!',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64927,'Aaaauuuuggghhhhh!','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64928,'Don\'t worry, Maia, I\'ll protect you.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64929,'','It looks scaaaary.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64930,'','Someday I\'m going to fly on one of those.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64931,'Hey ma\'am, can you show us some fireworks?','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64932,'','What does that lady do?',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64933,'','Does she really make fireworks?',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64934,'','Would you like to see some fireworks, little girl?',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64935,'','Wow! That\'s LOUD!',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64936,'Whooaaa! That looks cool!','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64937,'','Connor, I\'m hungry.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64938,'You just ate, silly. How can you be hungry again?','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64939,'','I don\'t know... I just am!',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64940,'','Look at that one! He looks... weird.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64941,'That\'s not nice Maia. Even if he does look weird, you shouldn\'t say it to his face.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64942,'','Oops... sorry.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64943,'Let\'s play a game.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64944,'','I\'m bored!',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64945,'','Who is that?',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64946,'That\'s a jinyu.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64947,'','It looks like a big fish!',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64948,'','If he\'s a fish, how come he\'s not swimming in water?',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64949,'That\'s because jinyu are fish. Sort of.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64951,'I dunno. Maybe he\'s magical.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64953,'','Can we ride some kites, Connor?',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64954,'I guess so.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(64955,'','This aberration destroyed... everything.  Everyone.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64956,'','The Horde cannot be allowed to recover the Focusing Iris.  Eliminate what remains of their forces, and I will secure the artifact.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64957,'','I must attune to the Focusing Iris before transport. Protect me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64958,'','Your people are despicable cowards, orc. You are nothing more than rabid dogs, and you will be put down!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64959,'','You spit on mercy?  Then you will have NONE.  You want carnage?!  Garrosh will get more blood than EVER he bargained for!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64960,'NO ONE CAN PROTECT YOU!  Kill the Proudmoore wench, and bring me that bomb.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64961,'Isn\'t she beautiful? Sigh...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64962,'Brave words, mage.  I\'ll SPIT in your FACE when you beg for mercy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64963,'NRAAAH! I\'ll bring the Warchief your HEAD!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64964,'She\'s so smart and funny! I\'m head over heels for her.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64965,'How do I tell her how I really feel? Oh, I\'m not good with words!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64966,'Do you think she could ever have feelings for someone like me? I\'m so... unfurry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64967,'I bet she likes her men hairy-chested. What am I supposed to do?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64968,'Do you think I should go to one of those monasteries and train to become a monk? You know, to impress her?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64969,'I don\'t have the big beer belly. I need a big beer belly. All right. I\'m workin\' on it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64970,'I know she likes a man who can hold his liquor, so I\'ve been building up my tolerance by getting sloshed every night.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64971,'','Are all men this slow at asking women out?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64972,'','I think he likes me, but I can\'t be sure. What do you think, $r?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64973,'','Oh no, what if he thinks I\'m too furry? What if he doesn\'t like black and white women?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64974,'','I\'m flirting as hard as I can, but I don\'t think he\'s getting the message!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64975,'','He keeps talking about arclight spanners and overcharged capacitors. He sure knows to lead a girl on. Rawr!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64976,'','I sure do like his pretty face.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64977,'There are Alliance survivors!  Send... reinforcements...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64978,'[%s] confesses: I once took a bow that a hunter wanted.','[%s] confesses: I once took a bow that a hunter wanted.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(64979,'','See some armor you like, $r? These rare armor sets can only be obtained by proving your worth in the most challenging dungeons in Pandaria.$B$BYou must seek out these dungeons and enter them by foot. Those who pass the challenges with enough speed shall earn the regard of our master armorers, and may find a gift of rare armor awaiting them in the mail.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64980,'Light be with you, $r.','',396,0,0,0,0,0,396,0,1,0,0,0,26124),
(64981,'The Prince of Stormwind is unguarded! Why don\'t we capture him for the Horde?','The Prince of Stormwind is unguarded! Why don\'t we capture him for the Horde?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(64982,'See some armor you like, $r? These rare armor sets can only be obtained by proving your worth in the most challenging dungeons in Pandaria.$B$BYou must seek out these dungeons and enter them by foot. Those who pass the challenges with enough speed shall earn the regard of our master armorers, and may find a gift of rare armor awaiting them in the mail.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64983,'Hah! Spoken like a true disciple of Garrosh Hellscream. Our \"Warchief\" would be proud.$b$bBut MY horde does not fight unarmed children. Nor would I dare bring our war to this sacred chamber, in the presence of an August Celestial himself.$b$bBesides, this little one has earned the friendship and trust of High Chieftain Baine Bloodhoof. For that reason, consider him under my protection.$b$bFor now.','',396,0,0,0,0,0,396,0,1,0,0,0,26124),
(64984,'I and my family fell victim to this place what seems like ages ago.$B$BLet our fate serve as a warning to those who would meddle in necromancy.$B$BHelp me to lift the curse, $c. Destroy Darkmaster Gandling.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64985,'The Vale of Eternal Blossoms.$b$bWho could have imagined the warchief was capable of destroying such a beautiful place.$b$bThe Golden Lotus feared that one day the mogu would retake this land, but it would seem they underestimated the depths of Garrosh\'s pride.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64986,'Oh, hello, $n.$b$bYour timing couldn\'t be better.','',396,0,0,0,0,0,396,0,1,0,0,0,26124),
(64987,'Our home is lost, but as long as we are still alive, there is still a home to be made... somewhere.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64988,'We live to fight another day, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64989,'When we first arrived, we found a resplendent Vale. The water of its pools were like none other that we had ever seen.$B$BBut then came the one named Garrosh Hellscream, and he left only destruction in his wake. By the time he left, the waters of the Vale were no more.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64990,'What happened in the Jade Forest was a terrible tragedy. It is my firm belief that the only way to avoid repeating our mistakes, is by learning from them.$B$BThere is much knowledge in this library. Already I have learned much about the sha.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64991,'[%s] confesses: I have \"borrowed\" things from my guild bank.','[%s] confesses: I have \"borrowed\" things from my guild bank.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64992,'Once, jinyu ruled all of Pandaria from this place, from this seat of power.$B$BWe must learn all that we can from the histories, so that we may once again regain our ancient wisdom.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(64993,'Ever since I crash landed on this shore, I been wanderin\' all over, $r!$B$BI\'ve been all the way from the Temple o\' the Jade Serpent to the Krasarang coast to the top o\' Mount Neverest herself!$B$BThis land is quite remarkable, and I been cataloging all o\' my findings.$B$BI can\'t wait to tell my fellow colleagues at the Explorer\'s League about everything I\'ve seen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64994,'You never know who can actually be trusted. Unless you\'re me; then you know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64995,'The empress has spies everywhere.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64996,'Those who seek power through force will often find themselves alone in it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64997,'The empress I served was also frightened and paranoid. Ultimately it was her fear that lead to her demise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64998,'','I\'ve always had a good head for numbers!$B$BOnce the natives saw how fast I could add, subtract, and do differential equations in my head, they hired me on the spot!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(64999,'You must keep your mind strong to withstand the ever present whispers from the empress. Weaker minds will fall to her will without even noticing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65000,'Now that I\'ve had my peek into the Vale, I gotta say, some o\' this place feels a bit... familiar.$B$BI know it don\'t look like it, but I can\'t shake that feeling. What do you think that means!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65001,'Aren\'t they great? I\'m their number one fan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65002,'','Welcome, $r! Stay and listen for a while.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65003,'','Welcome to the Nightingale Lounge, $c. What can we play for you today?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65004,'The knowledge in this library is astounding.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65005,'[%s] confesses: I always forget to gem my gear.','[%s] confesses: I always forget to gem my gear.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65006,'[%s] confesses: I spent six months chasing the Time-Lost Proto-Drake.','[%s] confesses: I spent six months chasing the Time-Lost Proto-Drake.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65007,'[%s] confesses: I went into Alterac Valley and didn\'t help my team at all.','[%s] confesses: I went into Alterac Valley and didn\'t help my team at all.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65008,'[%s] confesses: I died to an elevator once. Maybe more than once.','[%s] confesses: I died to an elevator once. Maybe more than once.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65009,'[%s] confesses: I never use the Lightwell.','[%s] confesses: I never use the Lightwell.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65010,'[%s] confesses: I always wanted to be a paladin.','[%s] confesses: I always wanted to be a paladin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65011,'[%s] confesses: Troll toes sort of creep me out.','[%s] confesses: Troll toes sort of creep me out.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65012,'[%s] confesses: I have stood in the fire.','[%s] confesses: I have stood in the fire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65013,'[%s] confesses: I told my raid leader that I was ready, but I wasn\'t really ready.','[%s] confesses: I told my raid leader that I was ready, but I wasn\'t really ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65014,'[%s] confesses: I fell off of Dalaran.','[%s] confesses: I fell off of Dalaran.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65015,'There is a battle trainer by the name of Sara Finkleswitch who trains her pets out on the main terrace.$B$BI will mark the location on your map.','There is a battle trainer by the name of Sara Finkleswitch who trains her pets out on the main terrace.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65016,'[%s] confesses: I asked a friend for gold to buy my first mount.','[%s] confesses: I asked a friend for gold to buy my first mount.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65017,'Yes, there is a fishing supplies vendor downstairs, on the first level of The Summer Terrace.$B$BI will mark the location on your map.','Yes, there is a fishing supplies vendor downstairs, on the first level of The Summer Terrace.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65018,'[%s] confesses: I said I had been in the dungeon before, but I had no idea what I was doing. It was embarassing.','[%s] confesses: I said I had been in the dungeon before, but I had no idea what I was doing. It was embarassing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65019,'[%s] confesses: I once punched a gnome. No reason. I was just having a bad day.','[%s] confesses: I once punched a gnome. No reason. I was just having a bad day.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65020,'[%s] confesses: I outbid a friend on an auction for something I didn\'t really want.','[%s] confesses: I outbid a friend on an auction for something I didn\'t really want.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65021,'[%s] confesses: I go into dungeons not to make Azeroth a better place, but just for loot.','[%s] confesses: I go into dungeons not to make Azeroth a better place, but just for loot.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65022,'[%s] confesses: I wasn\'t really at the opening of Ahn\'Qiraj. I just read about it.','[%s] confesses: I wasn\'t really at the opening of Ahn\'Qiraj. I just read about it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65023,'[%s] confesses: I don\'t really have a clue who the Sin\'dorei are.','[%s] confesses: I don\'t really have a clue who the Sin\'dorei are.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65024,'[%s] confesses: I don\'t treat all of my mounts equally.','[%s] confesses: I don\'t treat all of my mounts equally.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65025,'[%s] confesses: I dabble in archaeology, but I\'m just not that interested in history.','[%s] confesses: I dabble in archaeology, but I\'m just not that interested in history.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65026,'[%s] confesses: The draenei laugh really annoys me.','[%s] confesses: The draenei laugh really annoys me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65027,'[%s] confesses: I haven\'t been in a barber shop in months. Goblins with scissors. Shudder.','[%s] confesses: I haven\'t been in a barber shop in months. Goblins with scissors. Shudder.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65028,'[%s] confesses: I thought pandaren were a type of furbolg.','[%s] confesses: I thought pandaren were a type of furbolg.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65029,'[%s] confesses: Oh, I took the candle.','[%s] confesses: Oh, I took the candle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65030,'[%s] confesses: This is just a setback.','[%s] confesses: This is just a setback.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65031,'[%s] confesses: I light things on fire and yell BY FIRE BE PURGED when nobody is looking.','[%s] confesses: I light things on fire and yell BY FIRE BE PURGED when nobody is looking.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65032,'[%s] confesses: I don\'t really remember you in the mountains.','[%s] confesses: I don\'t really remember you in the mountains.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65033,'[%s] confesses: I sometimes forget if Northrend is north or south of here.','[%s] confesses: I sometimes forget if Northrend is north or south of here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65034,'[%s] confesses: I find all these names with so many apostrophes so confusing.','[%s] confesses: I find all these names with so many apostrophes so confusing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65035,'[%s] confesses: I forgot the Sunwell.','[%s] confesses: I forgot the Sunwell.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65036,'[%s] confesses: I really wasn\'t prepared. Who knew?','[%s] confesses: I really wasn\'t prepared. Who knew?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65037,'[%s] confesses: I sometimes wonder if tauren taste like... you know.','[%s] confesses: I sometimes wonder if tauren taste like... you know.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65038,'[%s] confesses: I ask for the Light to give me strength, but I\'m not sure if it really does.','[%s] confesses: I ask for the Light to give me strength, but I\'m not sure if it really does.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65039,'[%s] confesses: I sometimes use my mount to travel really short distances. I mean REALLY short.','[%s] confesses: I sometimes use my mount to travel really short distances. I mean REALLY short.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65040,'[%s] confesses: I don\'t know if Milhouse is a good guy or not.','[%s] confesses: I don\'t know if Milhouse is a good guy or not.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65041,'[%s] confesses: I know he\'s a jerk, but there\'s something about Garrosh....','[%s] confesses: I know he\'s a jerk, but there\'s something about Garrosh....',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65042,'[%s] confesses: I saw a mage cast a spell once and my jaw really did drop at the damage.','[%s] confesses: I saw a mage cast a spell once and my jaw really did drop at the damage.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65043,'','We were drawn here by visions of this place. But even the visions pale in comparison to the Vale\'s beauty.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65044,'[%s] confesses: For a long time, I thought the plural of anecdote WAS data.','[%s] confesses: For a long time, I thought the plural of anecdote WAS data.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65045,'[%s] confesses: Sometimes I ask for a warlock to summon me when I\'m really not that far away.','[%s] confesses: Sometimes I ask for a warlock to summon me when I\'m really not that far away.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65046,'[%s] confesses: Sometimes when I\'m questing, I want to be alone, so I pretend I can\'t hear my friends.','[%s] confesses: Sometimes when I\'m questing, I want to be alone, so I pretend I can\'t hear my friends.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65047,'It was a long journey to get here. And we lost so many along the way.$b$bYet... look at this place. Astounding!','It was a long journey to get here. And we lost so many along the way.$b$bYet... look at this place. Astounding!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65048,'','Care for a bite to eat, traveler?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65049,'','Food and drink for sale!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65050,'','Fixing for a snack, $r?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65051,'Thank you for opening the gates for us, $p. You honor us with your presence.','Thank you for opening the gates for us, $p. You honor us with your presence.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65052,'The Alliance followed us here. Even in this serene place, I smell war on the wind.','The Alliance followed us here. Even in this serene place, I smell war on the wind.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65053,'The mogu, the mantid, and the Alliance all threaten the safety of this ancient place. We must protect it, at all costs.','The mogu, the mantid, and the Alliance all threaten the safety of this ancient place. We must protect it, at all costs.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65054,'','We lost our home to the yaungol. But this place... this place offers us a new beginning.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65055,'I thought all was lost when the yaungol attacked our home. It is cliche, but the old monks are right when they say: \"When one door shuts, another opens.\"$b$bOr something like that. Wasn\'t too big on their teachings.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65056,'Can we go see the serpents?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65057,'Not today, little one. We have errands to run.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65058,'Can we see the tauren? They look like yaungols.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65059,'Can we go see the undead lady? She looks funny.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65060,'Can we go play with the goblins? I\'m taller than them!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65061,'When can we go home?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65062,'I miss my toys. Can we go home?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65063,'Can we go back to Kun-Lai? The air smells funny here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65064,'','I\'m sorry, but we need to stay here for a little while. The Horde is keeping us safe.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65065,'','Hi! Would you like to battle my pets?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65066,'','Greetings, $r. I may be small, but size doesn\'t matter in a pet battle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65067,'','Hi $c! Don\'t you think my pets are adorable?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65068,'','Hello, my dear. Have you been out in the fields?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65069,'','Is there anything I can get you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65070,'','A hoe is an honest $Gman\'s:woman\'s; weapon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65071,'','Why hello, $n. I know everything that happens around The Heartland, my dear. You don\'t get to be my age without making a few loose-lipped friends.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65072,'Here we go. Do try to keep yourselves alive until the end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65073,'|TInterface\\Icons\\spell_shadow_corpseexplode.blp:20|t %s ate too much and begins to |cFFFF0000|Hspell:126126|h[Upchuck]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65074,'We\'re coming for you, Chillheart! Time for payback!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65075,'|TInterface\\Icons\\inv_misc_monsterfang_02.blp:20|t %s traps his prey in his |cFFFF0000|Hspell:126187|h[Vice Jaws]|h|r! Kill him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65076,'A man must honor his family.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65077,'The Talking Skull cackles gleefully as the instructor\'s soul is destroyed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65078,'The Talking Skull seems hesitant to enter the hall, but proceeds with you nonetheless.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65079,'What does an out-numbered army eat for a snack?$B$B...$B$BRetreats!','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(65080,'I\'m no healer, but I\'m priest to meet you!','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(65081,'Don\'t ask me how to fight a warlock. I a-VOID them. Hahahaha!','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(65082,'Why was the tank nervous before the fight?$B$B...$B$BBecause he was a worrier!','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(65083,'What would happen if King Varian became corrupted?$B$B...$B$BI don\'t know, but it would be pretty SHA-king!','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(65084,'...hic...!$B$B...what is a... what is a \"gus\"...?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65085,'I can\'t bear to watch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65086,'The Talking Skull proceeds into the next chamber without saying a word.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65087,'Ah, if it isn\'t my favorite master assassin! I was hoping I would find you here in Pandaria.','',0,0,0,0,0,0,1,0,4,0,29135,0,26124),
(65088,'Very good. Let\'s talk.','',0,0,0,0,0,0,0,0,4,0,29136,0,26124),
(65089,'Tong! Drinks, please.','',0,0,0,0,0,0,0,0,4,0,29137,0,26124),
(65090,'My father, Deathwing, tried to destroy the whole of Azeroth.','',0,0,0,0,0,0,0,0,4,0,29138,0,26124),
(65091,'He was misguided, of course, but he was right about one thing: Our world is... so fragile.','',0,0,0,0,0,0,0,0,4,0,29139,0,26124),
(65092,'We are a point of light in a universe of shadow. A candle in a tempest.','',0,0,0,0,0,0,0,0,4,0,29140,0,26124),
(65093,'Sometimes I think it was the very precariousness of our world that drove my father to madness.','',0,0,0,0,0,0,0,0,4,0,29141,0,26124),
(65094,'Ah, thank you Tong.','',0,0,0,0,0,0,0,0,4,0,29142,0,26124),
(65095,'Now, to my point: I believe we are headed towards a reckoning. And no, I am not talking about the current conflict between the Alliance and the Horde.','',0,0,0,0,0,0,0,0,4,0,29143,0,26124),
(65096,'Believe me - what Garrosh Hellscream achieved in Theramore is nothing compared to the horrors that are even now bearing down on our fragile home.','',0,0,0,0,0,0,0,0,4,0,29144,0,26124),
(65097,'But the war deeply troubles me. Do you see my concern?','',0,0,0,0,0,0,0,0,4,0,29145,0,26124),
(65098,'A divided Azeroth cannot possibly stand against the darkness.','',0,0,0,0,0,0,0,0,4,0,29146,0,26124),
(65099,'This war has to end. Soon. Before it consumes our strength!','',0,0,0,0,0,0,0,0,4,0,29147,0,26124),
(65100,'I want you to know that your Alliance has my full and unwavering support in this campaign.','',0,0,0,0,0,0,0,0,4,0,29148,0,26124),
(65101,'You can rest assured that my loyalties lie with your Horde.','',0,0,0,0,0,0,0,0,4,0,29149,0,26124),
(65102,'How do we bring a swift and decisive end to the conflict? I believe the answer lies with heroes like you.','',0,0,0,0,0,0,0,0,4,0,29150,0,26124),
(65103,'We must ensure that you are up to the task... and then equip you accordingly.','',0,0,0,0,0,0,0,0,4,0,29151,0,26124),
(65104,'Try to stay alive! We are only just beginning our legendary journey.','',0,0,0,0,0,0,1,0,0,0,29152,0,26124),
(65105,'Ahh! So returns my conquering hero.','',0,0,0,0,0,0,1,0,0,0,29153,0,26124),
(65106,'The Terrace is just up the hill here. Stay on your guard; few visitors have returned.','',0,0,0,0,0,0,274,0,0,0,29154,0,26124),
(65107,'You are looking pale, my friend! I trust you have not allowed fear to get the better of you?','',0,0,0,0,0,0,5,0,0,0,29155,0,26124),
(65108,'Allow me to gather up my things, and I will meet you there.','',0,0,0,0,0,0,25,0,0,0,29156,0,26124),
(65109,'I often venture out here to think. The view is breathtaking, would you agree?','',0,0,0,0,0,0,0,0,0,0,29124,0,26124),
(65110,'Pandaria is indeed a jewel. Such beauty. It makes you want to protect her, yes?','',0,0,0,0,0,0,5,0,0,0,29125,0,26124),
(65111,'I feel the same way about Azeroth herself.','',0,0,0,0,0,0,1,0,0,0,29126,0,26124),
(65112,'You have done great things, friend. I can assure you this is but the beginning of our work together.','',0,0,0,0,0,0,0,0,0,0,29127,0,26124),
(65113,'Behold: The power of the foes you\'ve vanquished.','',0,0,0,0,0,0,0,0,0,0,29128,0,26124),
(65114,'And the wisdom of those you\'ve outsmarted.','',0,0,0,0,0,0,0,0,0,0,29129,0,26124),
(65115,'Here! The embodiment of the fear that you\'ve conquered. May it now strike terror into the hearts of your enemies!','',0,0,0,0,0,0,0,0,0,0,29130,0,26124),
(65116,'Finally, a gift from me. Make no mistake: the Black Dragonflight lives on!','',0,0,0,0,0,0,274,0,0,0,29131,0,26124),
(65117,'There. My work is done. You can now greatly augment the power of any sha-touched weapon.','',0,0,0,0,0,0,0,0,0,0,29132,0,26124),
(65118,'We are just getting started, friend! Our greatest challenges lie ahead.','',0,0,0,0,0,0,4,0,0,0,29133,0,26124),
(65119,'But when war comes to these shores, you and I will be ready for it!','',0,0,0,0,0,0,274,0,0,0,29134,0,26124),
(65120,'It is very good to see you again, $n! I trust the weapons I gave you at Ravenholdt have served you well?$b$bI have another \"assignment\" for you here in Pandaria. This will again require all of your skills, and again I assure you... it will be worth it!$b$bBefore we begin, it\'s important that you familiarize yourself with the lay of the land. Come visit me once you have earned more experience here.','',1,274,25,0,0,0,0,0,0,0,0,0,26124),
(65121,'Hello again. $n, was it? Yes yes... I believe we left behind some unfinished business back in the Eastern Kingdoms. How have you been finding Pandaria?$b$bI have another assignment for you, if you are up to the challenge this time. I assure you the rewards will be worth it.$b$bBefore we begin, it\'s important that you familiarize yourself with the lay of the land. Come visit me once you have earned more experience here.','',1,6,0,0,0,0,0,0,0,0,0,0,26124),
(65122,'<The Black Prince looks you up and down.>$b$bIt is very good to meet you, $c. You are one of the vanguard, it would seem - an explorer in a strange new land. And how have you been finding the mysterious continent of Pandaria?$b$bYou have the look of someone who gets things done. I want you to return to me once you\'ve gotten the lay of the land.$b$bI will be right here.','',1,6,0,0,0,0,0,0,0,0,0,0,26124),
(65123,'I have chosen the name \"Wrathion.\" To my knowledge, I am the last of the black dragons.$b$bMy father was Deathwing, the Worldbreaker, the Aspect of Death, the Destroyer... But I hope you will not hold that against me.$b$bI have no love for my father, whose corruption destroyed my race, or for the red dragonflight, who stole away and experimented on my egg to create me.$b$bLet\'s just say, I am... unaffiliated. And I am always on the lookout for like-minded heroes.','',1,274,0,0,0,0,0,0,0,0,0,0,26124),
(65124,'Who are you?','Who are you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(65125,'What are you doing in Pandaria?','What are you doing in Pandaria?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(65126,'Certainly I\'m allowed to have SOME secrets. Wouldn\'t you agree, $n?$b$bI arrived shortly after the mists collapsed - I was able to fly here after my Ravenholdt colleagues learned of a naval battle off of these shores.$b$bThis land has been hidden for ten thousand years. I\'ve only just begun to plumb its depths!','',1,274,0,0,0,0,0,0,0,0,0,0,26124),
(65127,'I am glad you have returned, $n! I trust you are now acclimated to this strange new continent of Pandaria?$b$bYou have already proven yourself to me in the past, so we can dispense with any sort of tests or trials. Let\'s get right to it.$b$bAre you ready to change the world?','',25,1,0,0,0,0,0,0,0,0,0,0,26124),
(65128,'Welcome, $c! My contacts throughout Pandaria tell me that you have been quite busy here. I admire mortals with your... \'initiative.\'$b$bHistory finds us at a turning point. If you are prepared to meet destiny with me head on, I will ensure that you are richly rewarded for your efforts.','',1,274,0,0,0,0,0,0,0,0,0,0,26124),
(65129,'We are just beginning our pandaren campaign, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(65130,'','I believe we may have finally found my father\'s Pools of Youth. We must gather as much information as we can for Tyrande.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65131,'','My sentinels have faced many dangers since we came to this new land. We are ready for whatever the future has to offer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65132,'','My squad\'s morale has improved since we entered the Vale.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65133,'','This Vale is truly a paradise.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65134,'','It was my father\'s dream to see this place. I must carry out his wishes in his place.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65135,'An ill-wind blows from the southern shores. Are you ready?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(65136,'','We will rest here in the Vale until we have gathered our research. Then, we must find a way home.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65137,'There is some kind of barrier that shields this Vale, preventing my use of portal magic.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65138,'','Us meeting in this Vale is more than just random chance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65139,'','Garrosh\'s pride has destroyed the Vale. What was will never be restored.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65140,'','Tyrande sent us here as a vanguard for the Light.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65141,'','The trees here are more beautiful than even the ones in the southern jungle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65142,'','Never in my ranging have I seen a place like this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65143,'','Could the waters of this vale be the fabled \"Pools of Youth?\" Perhaps immortality is within our grasp once again...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65144,'','We have heard reports of mogu infiltrating this valley. They will not get beyond us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65145,'','While we research the pools, we will patrol the city\'s borders and protect these people.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65146,'','To be honest, I did not believe the truth of Vaeldrin\'s visions at first. But this place radiates an unusual magic - could these be the fabled \"Pools of Youth?\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65147,'If you have the time, you should visit Binan\'s famous Brewmoon Festival. I will be brewing some of my famous Kun-Lai Kicker Brew.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65148,'Legends tell of a great battle that took place in this very vale, turning the golden fields to crimson with the blood of many brave monks. The armies of Lei Shen the Thunder King, emperor of the mogu, fought brutally, but were eventually overcome.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65149,'Die, Gandling! Kill him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65150,'Two hundred ships at my disposal, yet the one carrying my SON goes missing!','',1,0,0,0,0,0,1,0,7,0,31808,0,26124),
(65151,'I am sorry, but I cannot go back just yet.','',1,0,0,0,0,0,1,0,7,0,31805,0,26124),
(65152,'I\'ve decided to search for the Vale... Vale... Vale...','',1,0,0,0,0,0,1,0,7,0,31806,0,26124),
(65153,'STORM the shores, and PAINT THIS NEW CONTINENT RED!!','',5,0,0,0,0,0,1,0,7,0,31807,0,26124),
(65154,'|TInterface\\Icons\\ability_warlock_improvedsoulleech:20|tYou are afflicted by |cFFFF0000|Hspell:126228|h[Severed Soul]|h|r! Kill it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65155,'For days following the fall of Lei Shen, the vale was shrouded in a cloud of the deepest black. Summoned by Lei Shen in his final moments, the otherworldly storm blanketed the vale with rainfall and struck jagged spears of lightning into the hills.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65156,'The blood of the fallen was washed away by the storm and carried to Whitepetal Lake, turning the waters a deep red. With its final breath, the storm struck the center of the lake, igniting the very water itself.  The lake burned with a crimson hue for many days.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65157,'When the blaze subsided, a cloud serpent hatching could be seen flying around the center of the lake. Its scales sparked with storm and fire, and where it flew, great clouds formed in the sky. My people named it Alani, the Stormborn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65158,'They say that Alani can only see the flash of the greatest lightning, and may only hear the echo of the greatest thunder. Should you wish to get her attention, you will need to harness the very essence of the sky that spawned her.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65159,'And THEN what happened?','And THEN what happened?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65160,'Greetings, friend! I do not get many visitors up here, do you wish to hear a tale of the Vale of Eternal Blossoms?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65161,'I do!','I do!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65162,'That makes sense!','That makes sense!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65164,'Silly wikket! Brew is for hozen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65165,'Brew run!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65166,'No brew for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65167,'Heyarrrrrrrr!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65168,'The ancient vaults of the mogu, untouched by time for thousands of years, who knows what secrets await?','',0,0,0,0,0,0,1,0,1,0,30198,0,26124),
(65169,'All for one! And one for Ook!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65170,'Many young Pandaren warriors have vanished into this...tomb. Have your wits about you.','',0,0,0,0,0,0,1,0,1,0,30199,0,26124),
(65171,'The mogu held considerable power over the stones of the earth. Their magic lingers on, even centuries later.','',0,0,0,0,0,0,1,0,1,0,30178,0,26124),
(65172,'The large Quilen seem to be guarding that door. Tread carefully, lest you wake them.','',0,0,0,0,0,0,25,0,1,0,30179,0,26124),
(65173,'That was close!','',0,0,0,0,0,0,5,0,1,0,30180,0,26124),
(65174,'The door mechanism seems to have activated with the demise of the guardians. I fear what we may find within.','',0,0,0,0,0,0,1,0,1,0,30181,0,26124),
(65175,'We seem to have awakened a spirit of some kind.','',0,0,0,0,0,0,6,0,1,0,30193,0,26124),
(65176,'So the stories were true...','',0,0,0,0,0,0,274,0,1,0,30194,0,26124),
(65177,'We have disturbed what should not have been disturbed. He cannot be free to escape this prison! You must destroy him!','',0,0,0,0,0,0,5,0,1,0,30195,0,26124),
(65178,'Feng the Accursed was betrayed by four emperors of the mogu, his body destroyed each time, only to rise again.','',0,0,0,0,0,0,1,0,1,0,30196,0,26124),
(65179,'Hozekateers! Assemble!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65180,'This is not the last we have seen of Feng...','',0,0,0,0,0,0,274,0,1,0,30197,0,26124),
(65181,'The Zandalari, ancient allies of the mogu! They must seek the legendary weapon within the depths of the Vaults!','',0,0,0,0,0,0,5,0,1,0,30209,0,26124),
(65182,'Wikkets!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65183,'Party crashers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65184,'Heyarrrr!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65185,'You no take brew!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65186,'Take their nibs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65187,'For Captain Ook!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65188,'I am sorry I did not tell you earlier! These vaults house a weapon of unimaginable power! Stop them!','',0,0,0,0,0,0,1,0,1,0,30208,0,26124),
(65189,'I will stay behind and investigate this dais further...','',0,0,0,0,0,0,2,0,1,0,30210,0,26124),
(65190,'A secret passage has opened beneath the platform, this way!','',0,0,0,0,0,0,5,0,1,0,30200,0,26124),
(65191,'Look at the dust along the floor, these dark halls have not seen footfalls for many centuries.','',0,0,0,0,0,0,1,0,1,0,30201,0,26124),
(65192,'Once, the mogu enslaved all of the races of Pandaria, and bent them to their nefarious will.','',0,0,0,0,0,0,25,0,1,0,30202,0,26124),
(65193,'These Jinyu have been locked in an eternity of servitude.','',0,0,0,0,0,0,1,0,1,0,30203,0,26124),
(65194,'I hear a faint humming. It is coming from this direction!','',0,0,0,0,0,0,25,0,1,0,30204,0,26124),
(65195,'It is done, then. Yet...how many of these machines are hidden beneath the earth? How much do we not know about the dark secrets of the mogu?','',0,0,0,0,0,0,4,0,1,0,30205,0,26124),
(65196,'I fear that our war against our ancient enemies is still far from over.','',0,0,0,0,0,0,1,0,1,0,30206,0,26124),
(65197,'Astounding! An actual, functional Mogu construct machine.','',0,0,0,0,0,0,5,0,1,0,31809,0,26124),
(65198,'We cannot allow this to fall into the wrong hands.','',0,0,0,0,0,0,1,0,1,0,31810,0,26124),
(65199,'An endless army of soulless abominations...I shudder to think of the violence that would erupt from such a machine.','',0,0,0,0,0,0,274,0,1,0,31811,0,26124),
(65200,'You must destroy it. Here, now, before any harm can come to Pandaria.','',0,0,0,0,0,0,53,0,1,0,31812,0,26124),
(65201,'Turn the machine on, I will lock the door behind you.','',0,0,0,0,0,0,1,0,1,0,31813,0,26124),
(65202,'May the great crane guide your steps.','',0,0,0,0,0,0,66,0,1,0,31814,0,26124),
(65203,'NO! Get back here coward!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65204,'There are many wonderful poisons, Wakener. Some can boil you alive. Some will eat your flesh. Some burst you open from the inside.$B$BSo many wonderful varieties.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65205,'Quickly, destroy that thing. We have to catch Gandling!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65206,'Have you ever tried drinking poison, Wakener? You must start with something very mild, only a few drops at first.$B$BYou will likely become violently ill. Perhaps you will even lose an antennae or two.$B$BBut do it long enough, and you will become quite used to it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65207,'Let\'s go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65208,'I was once the Empress Shek\'zeer\'s most prized royal alchemist, peerless, and above all others.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65209,'Pah! I remember when Un\'sok was still a drone, afraid to mix his first toxin. I dare him to face me alone. Then we shall see whose alchemy is supreme.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65210,'Bow to the Shao-Tien!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65211,'You are weak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65212,'Foolish child.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65213,'There he is! Kill him now, $p!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65214,'Ah, another stranger from beyond the mists.','',0,0,0,0,0,0,396,0,5,0,29030,0,26124),
(65215,'Ten thousand years ago, the last Pandaren Emperor came seeking my advice. He, too, was filled with conflict. Let us see if you are correct, Taran. Let us see how this stranger deals with turmoil of the soul.','',0,0,0,0,0,0,396,0,5,0,29031,0,26124),
(65216,'Soon they will overwhelm this continent! Where do we draw the line?','',0,0,0,0,0,0,396,0,1,0,28417,0,26124),
(65217,'We have witnessed your \"help\" in the Jade Forest. This \"Horde,\" this \"Alliance\" of yours - you have no control over your own nature. You leave misery in your wake.','',0,0,0,0,0,0,396,0,1,0,28418,0,26124),
(65218,'Kneel, worm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65219,'Pitiful.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65220,'We\'re here to lend our aid. We can help protect the Vale.','',0,0,0,0,0,0,396,0,1,0,27588,0,26124),
(65221,'Stop him! Forget about her!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65222,'<He looks down the hall intently.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65223,'|TInterface\\Icons\\ability_warlock_baneofhavoc:20|t%s begins to cast |cFFFF0000|Hspell:126299|h[Unleash Souls]|h|r! Move quickly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65224,'Finally.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65225,'It\'s over. The curse is lifted. Thank you, $p. Thank you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65226,'I hunger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65227,'I must feed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65228,'And so the Golden Lotus arrive...','',0,0,0,0,0,0,0,0,1,0,28191,0,26124),
(65229,'You are far too late.  The Jade Armies are mine.','',0,0,0,0,0,0,0,0,1,0,28192,0,26124),
(65230,'And with them, I will crush the Golden Lotus and retake the vale in the name of the Thunder King!','',0,0,0,0,0,0,0,0,1,0,28193,0,26124),
(65231,'Die weaklings!','',0,0,0,0,0,0,0,0,1,0,28194,0,26124),
(65232,'The endless might of the Jade Armies is mine to control!','',0,0,0,0,0,0,0,0,1,0,28195,0,26124),
(65233,'Your rogue friend is not as nimble as he thinks he is.','',0,0,0,0,0,0,11,0,1,0,28196,0,26124),
(65234,'My statue will crush the life from him, leaving nothing but a shattered corpse.','',0,0,0,0,0,0,0,0,1,0,28197,0,26124),
(65235,'You leave your friend to die...','',0,0,0,0,0,0,0,0,1,0,28198,0,26124),
(65236,'How noble, rescuing your friend from certain death...','',0,0,0,0,0,0,1,0,1,0,28199,0,26124),
(65237,'...and all for nothing.  Take them!','',0,0,0,0,0,0,5,0,1,0,28200,0,26124),
(65238,'Your struggle is pointless.','',0,0,0,0,0,0,0,0,1,0,28201,0,26124),
(65239,'You are ignorant to the powerful secrets contained within this vale.  I will take them, and then I will destroy all of your kind.','',0,0,0,0,0,0,0,0,1,0,28202,0,26124),
(65240,'Throw these prisoners in the cages.  Let the men have their way with them.','',0,0,0,0,0,0,0,0,1,0,28203,0,26124),
(65241,'My next great adventure is about to begin.$B$BIs that a Light I see?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65242,'The Battle Helm of the Thunder King...','',0,0,0,0,0,0,0,0,1,0,28204,0,26124),
(65243,'It would seem my guards are useless.  I will have to take care of you myself.','',0,0,0,0,0,0,0,0,1,0,28205,0,26124),
(65244,'There will be no cages this time, I will tear your limbs from your bodies!','',0,0,0,0,0,0,0,0,1,0,28206,0,26124),
(65245,'Cower before my might!','',0,0,0,0,0,0,0,0,1,0,28207,0,26124),
(65246,'I will extinguish the life from your body!','',0,0,0,0,0,0,0,0,1,0,28208,0,26124),
(65247,'I will rip out your soul!','',0,0,0,0,0,0,0,0,1,0,28209,0,26124),
(65248,'Violence. See? They are filled with it.','',0,0,0,0,0,0,396,0,1,0,28419,0,26124),
(65249,'You are not as weak as I thought, but the helm is still mine...','',0,0,0,0,0,0,0,0,1,0,28210,0,26124),
(65250,'Aaaarrrghhh!  Mage, when we next meet, I will separate your head from your body.','',0,0,0,0,0,0,0,0,1,0,28211,0,26124),
(65251,'Yes... we are fighters. But we come from a violent land. We fought off demons, we fought off death, we even fought against the very end of the world!','',0,0,0,0,0,0,396,0,1,0,27589,0,26124),
(65252,'Who dares disturb me? Show your cowardly faces and kneel before me!','',0,0,0,0,0,0,0,0,1,0,28229,0,26124),
(65253,'PREPARE TO DIE, VILLAIN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65254,'Ahahaha! Such a pitiful creature!','',0,0,0,0,0,0,0,0,1,0,28230,0,26124),
(65255,'You are not worthy of me. Dago! Come crush this insignificant flea!','',0,0,0,0,0,0,0,0,1,0,28231,0,26124),
(65256,'My spear will finish you!','',0,0,0,0,0,0,0,0,1,0,28212,0,26124),
(65257,'Cower at the sight of your own doom!','',0,0,0,0,0,0,0,0,1,0,28213,0,26124),
(65258,'It is true. They are strong. There is much they can teach us.','',0,0,0,0,0,0,5,0,1,0,29050,0,26124),
(65259,'I will show you the strength of a true warlord!','',0,0,0,0,0,0,0,0,1,0,28214,0,26124),
(65260,'You have nowhere to go, weakling!','',0,0,0,0,0,0,0,0,1,0,28215,0,26124),
(65261,'Fool. Do you think to stop the full might of the mogu empire?','',0,0,0,0,0,0,0,0,1,0,28216,0,26124),
(65262,'I will not grant you a swift death, weakling.','',0,0,0,0,0,0,0,0,1,0,28217,0,26124),
(65263,'You are weak!','',0,0,0,0,0,0,0,0,1,0,28224,0,26124),
(65264,'I will crush you!','',0,0,0,0,0,0,0,0,1,0,28225,0,26124),
(65265,'We will reclaim what is rightfully ours!','',0,0,0,0,0,0,0,0,1,0,28226,0,26124),
(65266,'Cower at your own folly!','',0,0,0,0,0,0,0,0,1,0,28227,0,26124),
(65267,'I am made anew!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65268,'The blood in my veins is now thick with toxins. I shall fear no poison ever again. Truly, I am my own masterpiece!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65269,'Won\'t you try a taste of poison, Wakener? Not even just a drop?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65270,'I am no longer a mantid. I am something... more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65271,'I seek training in the Way of the Wok.','I seek training in the Way of the Wok.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65272,'I seek training in the Way of the Brew.','I seek training in the Way of the Brew.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65273,'We can agree it is noble to fight for a righteous cause: to defend home or family. But what of vengeance? What of anger? I sense these emotions run deep in this one.','',0,0,0,0,0,0,396,0,5,0,29033,0,26124),
(65274,'','Every day I archive something new, and something old. Sometimes it is an ancient scroll of wisdom. Sometimes it is a painting of the Vale an Inkmaster made.$b$bWe preserve the lore so that future generations will learn from our successes... and our failures.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65275,'Stand on an elevated surface to avoid the Shadow Fog!','Stand on an elevated surface to avoid the Shadow Fog!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65276,'|TInterface\\Icons\\inv_misc_gem_bloodstone_03:20|t%s transforms into |cFFFF0000|Hspell:126384|h[Red Granite]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65277,'|TInterface\\Icons\\inv_misc_gem_stone_01:20|t%s transforms into |cFFFF0000|Hspell:126401|h[Green Granite]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65278,'|TInterface\\Icons\\inv_ore_cobalt:20|t%s transforms into |cFFFF0000|Hspell:126405|h[Blue Granite]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65279,'I seek training in the Way of the Grill.','I seek training in the Way of the Grill.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65280,'I seek training in the Way of the Pot.','I seek training in the Way of the Pot.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65281,'I seek training in the Way of the Steamer.','I seek training in the Way of the Steamer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65282,'I seek training in the Way of the Oven.','I seek training in the Way of the Oven.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65283,'Yes?','Yes?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65284,'It smells delicious, doesn\'t it?','It smells delicious, doesn\'t it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65285,'Did you need something?','Did you need something?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65286,'Would you like to learn how to cook?','Would you like to learn how to cook?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65287,'I seek training in Pandaren cooking.','I seek training in Pandaren cooking.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65288,'I need ingredients and equipment for my kitchen.','I need ingredients and equipment for my kitchen.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65289,'When dawn rises, the hammer shall fall.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65290,'What is best in life?\n\nBrothers, ballads and beer!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65291,'I like my women like I like my beer: full-bodied.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65292,'I would do anything for love. But I won\'t do that. At least, not right away.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65293,'','These boys are a handful.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65294,'','I promised the boys a picnic up here but it is a dangerous place. Just the other day I hear there was an actual fight between strangers like yourself.$b$bAnd someone from... the turtle.$b$bI always thought the turtle was a legend.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65295,'','We do not often have troubles with predators up here. Sometimes when it rains the saurok come out. But that is only when there is a lightning storm.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65296,'Mooooom! Liu keeps poking me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65297,'Liu took my jinyu trinket!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65298,'Liu stepped on my foot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65299,'Mom! Liu keeps acting like a hozen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65300,'Mommm! Liu punched me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65301,'No I didn\'t!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65302,'He started it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65303,'You told me to!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65304,'Nuh uuuh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65305,'','Stop it. You both are behaving like a pair of hozen!',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(65306,'','If you do not behave I will turn this picnic right around and we will go home. Is that what you want?',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(65307,'','Ty, stop tattling on your brother. Liu, do not give your brother a reason to tattle.',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(65308,'','Stop it, both of you. You are smarter than this. Can you be clever like a jinyu and get along? Or are you just going to keep misbehaving like a hozen?',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(65309,'Present your challenge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65310,'This may disorient you momentarily, Wakener. It is always difficult the first time your eyes truly see.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65311,'Very well... Metal Brewmaster.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65312,'We are all sons and daughters of the storm!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65313,'','I always thought trolls were stuff from old stories.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65314,'','Thank you, $p! Your courage saw us through the battle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65315,'','That was a tough fight. The most we ever have to worry about are saurok raiders or the occassional hungry hozen.$b$bThose trolls... they fight differently.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65316,'','What were the trolls after?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65317,'Now you will see. Traitors hide within our ranks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65318,'That was a fearsome battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65319,'Now I wish I had stayed awake during those defense lessons at the monastery when I was a cub.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65320,'What were those trolls after? We are just a simple fishing village.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65321,'Trolls. Those were actual trolls! We have heard of them in stories. But to see them in person. And every bit as ferocious as the tales tell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65322,'Anger is a part of us all, yes. But we value control. The orcs were once driven solely by anger - they lived in a state of bloodlust - but they conquered it.','',0,0,0,0,0,0,396,0,1,0,27590,0,26124),
(65323,'All you seek to conquer is each other!','',0,0,0,0,0,0,396,0,1,0,28420,0,26124),
(65324,'To live without anger is not to live at all. It is ours to overcome. In defeating our anger, we draw great strength.','',0,0,0,0,0,0,5,0,1,0,29051,0,26124),
(65325,'|TInterface\\Icons\\ability_warrior_battleshout.blp:20|tThe Spirit of Lao-Fe casts |cFFFF0000|Hspell:126471|h[Oppress the Weak!]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65326,'Well spoken, Zhi. The strangers from beyond the mists have no shortage of passions, but let us see if they indeed control them. Beyond anger lies hatred, the wellspring of all misery. What is this? Your hatred has a face!','',0,0,0,0,0,0,396,0,5,0,29035,0,26124),
(65327,'See? See how these outsiders hate one another! They wear their hatred to battle and carry it to their graves!','',0,0,0,0,0,0,396,0,1,0,28421,0,26124),
(65328,'No, that\'s not true - there is so much more to us than this!','',0,0,0,0,0,0,396,0,1,0,27593,0,26124),
(65329,'How interesting. They bring much to our land, but they also bring the shadow of war.','',0,0,0,0,0,0,5,0,1,0,29052,0,26124),
(65330,'Peace will come. I swear it. And old hatreds will go away. You have to believe me.','',0,0,0,0,0,0,396,0,1,0,27594,0,26124),
(65331,'|TInterface\\Icons\\ability_searingarrow.blp:20|tHuo-Shuang casts |cFFFF0000|Hspell:126304|h[Flaming Arrow]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65332,'|TInterface\\Icons\\spell_frost_iceshard.blp:20|tHuo-Shuang casts |cFFFF0000|Hspell:126321|h[Frozen Arrow]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65333,'Kor\'ik! How long have you worked for the empress?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65334,'I see the paragon has been awakened.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65335,'The paragon does not speak truth, Wakener. His mind did not survive encasement.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65336,'He cannot allow him to live in this madness. The Klaxxi will want him put down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65337,'You and the Klaxxi are fools! Your arrogance will be your end!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65338,'The only madness here is your own, Kor\'ik! Did you really think you would go unnoticed forever?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65339,'You will not deceive us. We see you for who you truly are!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65340,'That looks like... my father!','',0,0,0,0,0,0,396,0,1,0,27591,0,26124),
(65341,'That... that looks just like Garrosh Hellscream!','',0,0,0,0,0,0,396,0,1,0,27592,0,26124),
(65342,'','Well met, $c. I mean you no harm.$B$BI\'m here posing as one of the Scarlet Crusade because they have become irredeemably corrupt and evil.$B$BI need your help to put an end to them once and for all.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65343,'Oh... Oh no... I\'m going to die here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65344,'No you\'re not! Here, take this!','No you\'re not! Here, take this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65345,'|TInterface\\Icons\\spell_fire_soulburn.blp:20|t %s is casting |cFFFF0000|Hspell:126288|h[Decimate]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65346,'The beast is covered in oil, light him up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65347,'Archers, attack! Make him burn!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65348,'Light up the oil!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65349,'Jump to free yourself from the webs!','Jump to free yourself from the webs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65350,'This one has indeed proven mastery over anger. Between the young cub\'s words and the actions of this hero, I think I understand. Those from beyond the mists are hardened by battle. They are scarred, yes, but they have learned much. I trust them.','',0,0,0,0,0,0,396,0,5,0,29037,0,26124),
(65351,'You are making a terrible mistake!','',0,0,0,0,0,0,5,0,1,0,28422,0,26124),
(65352,'It is decided. The Vale of Eternal Blossoms shall remain open. The transgressions of the outsiders have been great... but I see in them the capability to right what has been wronged.','',0,0,0,0,0,0,377,0,5,0,38210,0,26124),
(65353,'Thank you, Master White Tiger. You will see. I believe that my people - and the Horde - are essentially good.','',0,0,0,0,0,0,16,0,1,0,27595,0,26124),
(65354,'I will consult the others. Meet me at the gates.','',0,0,0,0,0,0,396,0,5,0,29040,0,26124),
(65355,'Empress Shek\'zeer will destroy you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65356,'I find your faith inspiring, little one. But I wonder if you have ever met our warchief?','',0,0,0,0,0,0,153,0,1,0,32461,0,26124),
(65357,'Empress Shek\'zeer knows your plans. Your treachery will be punished...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65358,'$n fend off the yaungol while I finish the brew!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65359,'I would like to upgarde another sha-touched weapon. Can you help?','I would like to upgarde another sha-touched weapon. Can you help?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(65360,'You have certainly proven that you are worthy of it, but the materials do not come without cost.$b$bI\'m sure I can arrange something with Madam Goya, but it won\'t come cheap.$b$bPlease keep in mind that only one Crystal of Fear can be equipped at any time.','',274,1,0,0,0,0,0,0,0,0,0,0,26124),
(65361,'It is worth it. I wish to augment my agility.<Pay 10,000 gold.>','It is worth it. I wish to augment my agility.<Pay 10,000 gold.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(65362,'','I grew up hearing legends of the White Tiger. He is a hero to the pandaren people. It is a real honor to be here training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65363,'I will remain here to examine Kor\'ik\'s remains. I will meet you back in Klaxxi\'vess when you have completed these tasks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65364,'|TInterface\\Icons\\ability_hunter_pet_spider.blp:20|t %s casts |cFFFF0000|Hspell:126652|h[Call Swarmers]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65365,'I need another torch.','I need another torch.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65366,'Minions! Bring me a brew worthy of Ook!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65367,'Storm the shores! Steal their brew!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65369,'','Here, take these supplies. You\'ll need them for your missions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65370,'|TInterface\\Icons\\inv_misc_idol_02.blp:20|tGara\'jal selects random players to become |cFFFF0000|Hspell:122151|h[Voodoo Dolls]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65371,'You are a |cFFFF0000|Hspell:122151|h[Voodoo Doll]|h|r! Damage you take is copied to the other Voodoo Dolls in your raid!','You are a |cFFFF0000|Hspell:122151|h[Voodoo Doll]|h|r! Damage you take is copied to the other Voodoo Dolls in your raid!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65373,'|TInterface\\Icons\\inv_enchant_voidsphere.blp:20|tGara\'jal has |cFFFF0000|Hspell:116727|h[Banished]|h|r you to the Spirit World completely! You and your allies must defeat all Severers of Souls to return to the real world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65374,'The beacons sing to each other, outsider. Important messages are sent.$b$bYour ears will not hear the messages. Only those that the Klaxxi trust hear the words they speak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65375,'It would be my honor to sacrifice myself for what I believe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65376,'|TInterface\\Icons\\ability_shaman_astralshift.blp:20|tYour spirit has been healed sufficiently to return to its body in the real world! Use your |cFFFF0000|Hspell:120715|h[Revitalized Spirit]|h|r action button to save your spirit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65377,'I am busy, outsider.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65378,'You have |cFFFF0000|Hspell:116161|h[Crossed Over]|h|r to the Spirit World! You or an ally must heal your spirit to 90% health within 30 seconds or else you will perish!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65379,'Someday the Klaxxi will elevate my rank. I will be allowed to consume amber.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65380,'The Klaxxi do not give their trust easily, outsider. It has taken me many years to even be seen by them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65381,'We all have talents, outsider. Some are just not as easy to see as others.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65382,'|TInterface\\Icons\\ability_druid_challangingroar.blp:20|tGara\'jal casts |cFFFF0000|Hspell:117752|h[Frenzy]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65383,'','I\'d say that we\'re about halfway done, wouldn\'t you? Scarlet Halls down, Scarlet Monastery yet to go.$B$BDon\'t be surprised if I disappear -- I have to get over there quickly.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65384,'','There are a lot of corpses out there.  Nicely done, $p.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65385,'','Did you get the codex?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65386,'','Kneeling down, the Hooded Crusader examines the Flameweaver\'s corpse, looking for something.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65387,'Now, back to the brewing!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65388,'The shiny isss mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65389,'You cannot have it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65390,'It\'sss mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65391,'My shiny...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65392,'Riders approach!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65393,'','I am proud to have defended our village.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65394,'','Father, I am no longer the helpless child you feared for.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65395,'','I would like to continue my training so that I may always defend our home.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65396,'','I will keep this village safe so that you may retire your weapons.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65397,'Never before has a father felt such pride for their child, Shomi.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65398,'Your words honor me, daughter. This is a proud moment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65399,'You will always be my little girl and I will always fear for you, but I know now you can take care of yourself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65400,'Excellent news. Our studies of this site\'s energies and artifacts have begun to pay off.$B$BWe have unraveled some understanding of the mogu devices found here, and even better, a way to turn them in our favor. The very walls of this structure will siphon and sap the might of any enemies within.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65401,'It may be best not to dabble in mysteries not yet fully understood. Perhaps you should disable the dampening devices. My companions and I can handle ourselves. I\'m sure we will be fine.','It may be best not to dabble in mysteries not yet fully understood. Perhaps you should disable the dampening devices. My companions and I can handle ourselves. I\'m sure we will be fine.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65402,'Yes, please disable the devices.','Yes, please disable the devices.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65403,'Are you certain? This is a dangerous place, and our initial researchers have not yet returned from their expedition. If we disable the dampening field, we will leave until the ruins are safely secured, and cannot reactivate the devices.$B$BI ask again: Are you certain?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65404,'You are too late.','',0,0,0,0,0,0,0,0,7,0,31492,0,26124),
(65405,'Da remains of da Thunder King were taken to da Isle of Reckoning.','',0,0,0,0,0,0,0,0,7,0,31493,0,26124),
(65406,'We performed da ancient rites...','',0,0,0,0,0,0,0,0,7,0,31494,0,26124),
(65407,'Even now, da true emperor of Pandaria lives and breathes once more.','',0,0,0,0,0,0,0,0,7,0,31495,0,26124),
(65408,'I really hope you know what you are doing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65409,'Woe to da pandaren usurpers! The mogu will rule dis land again, and we Zandalari will have a new homeland...','',0,0,0,0,0,0,0,0,7,0,31496,0,26124),
(65410,'Secure da remains, bruddahs!','',0,0,0,0,0,0,0,0,7,0,31481,0,26124),
(65411,'Da Thunder King shall live again...','',0,0,0,0,0,0,0,0,7,0,31482,0,26124),
(65412,'Da Thunder King lives! Our empires be united once more...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65413,'We need dis land! Da cataclysm destroyed our home!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65414,'Dis only just begun... we ain\'t gonna jes\' roll over and die...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65415,'So you have come here, to the heart of the pollution. We will aid you. Our song will resonate through the walls of this twisted place, weakening the resolve of those who have forsaken our race.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65416,'We are more than capable of handling this without assistance. Withdraw. When you return, you will find the Empress slain and your problems solved.','We are more than capable of handling this without assistance. Withdraw. When you return, you will find the Empress slain and your problems solved.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65417,'Yes, we will handle this our own way.','Yes, we will handle this our own way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65418,'Is this arrogance or merely folly? Your death awaits within these walls. If we leave you shall have no aid. Do you realize what you are saying?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65419,'So be it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65420,'$n is |cFFFF0000|Hspell:121970|h[Trapped]|h|r! Free $Ghim:her; by clicking on the barrel!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65421,'Under Kun-Lai Thunder sleeps...','',0,0,0,0,0,0,0,0,7,0,30093,0,26124),
(65422,'The storm long spent there rests...','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(65423,'But blood of brother kingdom keeps...','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(65424,'Alive the dispossessed...','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(65425,'By Zandalari blood he will be taken...','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(65426,'To Zandalari voice he will awaken...','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(65427,'The battlefield is no place for a girl!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65428,'If I hadn\'t gotten a splinter I would be out there defending our village too!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65429,'Shomi should not want to fight. That is a man\'s job!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65430,'Shomi is such a child!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65431,'<Kovok\'s eyes widen as he looks at you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65432,'<Kovok look at you with concern.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65433,'<Kovok chitters happily... you think.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65434,'In all my years I never expected to see the Zandalari.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65435,'This village has been peaceful for longer than I can remember. Our weapons are surely as rusty as our fighters.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65436,'Surviving this attack will take a miracle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65437,'Those Zandalari won\'t know what hit them when I\'m done!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65438,'At last peace can be restored!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65439,'You are a true hero!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65440,'I can finally return to my knitting! Those winter scarves won\'t make themselves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65441,'You have our respect and our thanks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65442,'These events have shown me so much.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65443,'Thank you for opening my eyes to who my daughter really is.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65444,'You have not only saved our village; you have also repaired my family.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65445,'','I have grown so much thanks to you!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65446,'','I look forward to when our paths cross again!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65447,'','Maybe next time it will be me saving you!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65448,'','I\'m ready for the world, but I\'m not sure it\'s ready for me!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65449,'We will have to work quickly if we want to find the remains.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65450,'Every villager counts. Without each grain of sand we would have no beach to enjoy the ocean from.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65451,'There is a lesson to be learned in every challenge we face.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65452,'This village has you to thank for their victory.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65453,'To see only the defeat of losing the remains would be foolish. This village is the first of many that will rise against the Thunder King. This is a great victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65454,'When we face the Thunder King we will be prepared.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65455,'','We must not only see the negative when there is much to be positive about.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65456,'','These hardships will pass and we will grow stronger because of them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65457,'','I\'m confident you will be able to help us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65458,'','It is because of you this village has found its strength again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(65459,'','We will not be the only village to rise against the Thunder King!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65460,'','It is always a good idea to make friends with fisherman. You will never go hungry!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65461,'This is terrible! How will we ever defeat the Zandalari?','',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(65462,'We are but one tiny village... What could we possibly do to defeat the Thunder King\'s forces?','',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(65463,'They outnumber us! This is madness!','',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(65464,'I knew we would defeat the invaders!','',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(65465,'Despite what I may have said in the past, I never doubted your abilities!','',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(65466,'The Zandalari should never have underestimated us!','',0,0,0,0,6,8,0,0,1,0,0,0,26124),
(65467,'','This village is normally so peaceful.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65468,'','Change is inevitable, even for those as stubborn as Doshu.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65469,'','My daughter has spirit and persistence! I worry less about her than I do my husband.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65470,'','It is done. You did it, $p!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65471,'','And now enough of this deception.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65472,'','Hello, my name\'s Lilian. You don\'t mind if I take those blades, do you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65473,'','The Hooded Crusader gazes down upon the high inquisitor\'s blade-skewered corpse.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65474,'...ouch?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65475,'Yes... pop. Sorry I got me head all snared by that thing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65476,'Get... out... of my boy\'s... head!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65477,'Well that\'s a start at least. Do ya remember who you are?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65478,'It was mind control boy. There\'s a difference. And don\'t worry. If big game huntin\' were easy, everybody\'d be doing it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65479,'Hozen in the Mist.','Hozen in the Mist.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65480,'Fish Tales.','Fish Tales.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65481,'Dark Heart of the Mogu.','Dark Heart of the Mogu.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65482,'','Good to see you again, $n. For a moment, I was worried that you wouldn\'t come.$B$BLet\'s finish this, shall we? The Scarlet Crusade has proven that it\'s not going to put an end to itself.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65483,'Heart of the Mantid Swarm.','Heart of the Mantid Swarm.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65484,'What is Worth Fighting For.','What is Worth Fighting For.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65485,'Song of the Yaungol.','Song of the Yaungol.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65486,'Seven Burdens of Shaohao.','Seven Burdens of Shaohao.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65487,'Ballad of Liu Lang.','Ballad of Liu Lang.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65488,'Who would ever guess how much knowledge was hidden behind these walls. And there is so much more we can add to it.$b$bAs you explore our land, keep an eye out for objects of interest that might help us learn more of our past. Piece together enough of our history, and I may be able to share a story or two with you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65489,'It is good to see another explorer! When some people discover a new land, they immediately seek out the fortresses and temples.$b$bNot me.$b$bTo get the measure of a people, you need to get your feet dirty. Come, walk the land with me! Let us see what these mainland pandaren truly value.$b$bIt is the Wanderer\'s Way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65490,'My niece Li Li is so impatient to explore Pandaria. But one never learns a new land by rushing headlong from place to place. It is important to talk to everyone you meet, to experience a place until it becomes a part of your soul.$b$bIt is the Wanderer\'s Way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65491,'Li Li does not understand why I always stop to sample the local brews. But in my experience, you can learn a lot about a people by what they drink!$b$bHave you tried mainland pandaren ales? Very crisp, very dark. One sip and you know that they are brewed to be savored slowly. It is the drink of a people that are in no hurry, who enjoy time with their friends.$b$bWhat do YOU drink, $c? And what would it tell me about you, hm?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65492,'These pandaren farmers are entertaining folk! A very tight-knit community. Everyone knows one another.$b$bIt is very different from the big cities in Kalimdor or the Eastern Kingdoms.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65493,'Why are you always in such a rush, $n? It is like you dash madly from one stranger in need to another, bent on gaining new experiences.$b$bLife is not simply a glass you fill up! Stay a while, and enjoy the places you discover!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65494,'My family left mainland Pandaria to explore the world on the back of the Wandering Isle. That was many generations ago.$b$bBut I have learned that there are other Stormstouts, here, on Pandaria! My long-lost family. What are they like? Do they still brew, as I do? Are they adventurers, like you and I?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65495,'If you spent enough time here in the valley, perhaps you could make friends with all the locals. Maybe even some day settle down with a farm plot of your own.$b$bImagine that - YOU, the world-weary $c, settling down to manage a farm!$b$b<Chen closes his eyes and laughs a deep belly-laugh.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65496,'Embrace the Wanderer\'s Way! It is not so much a course of action as it is an attitude.$b$bEvery one you meet is a story. Every place you go is an adventure. Every drink you have is the best you\'ve ever tasted.$b$bThis is not such a bad life, is it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65497,'<Chen acknowledges you with a nod but looks uncharacteristically sullen.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65498,'Travel through the Spirit World has left you with a |cFFFF0000|Hspell:117723|h[Frail Soul]|h|r temporarily! If you attempt to travel to the Spirit World again before Frail Soul expires you will perish instantly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65499,'These sacred waters are befouled, but hope is not lost. Our ancient rituals endure and cleanse, even in the face of this great corruption. And as the waters recover, the strength of those who taint them wanes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65500,'This being may feed on Fear, but we have none to offer it. Cease your ritual, for we require no assistance to cleanse this place.','This being may feed on Fear, but we have none to offer it. Cease your ritual, for we require no assistance to cleanse this place.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65501,'Once this ritual ceases, we will not be able to resume it, and the corruption will remain at full strength. Your courage is admirable, but if you fail, we are all doomed. Do you understand what you ask? Do you understand the consequences?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65502,'This is a historic moment, $n. What do you think lies beyond the gates?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(65503,'When I say: \"Who\'s the Master?\" You say: \"Shonuf!\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65504,'I got the glow!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65505,'Come, face your death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65506,'I will have your armor as a trophy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65507,'|TInterface\\Icons\\inv_misc_bomb_05.blp:20|tSaboteur Kip\'tilak casts |cFFFF0000|Hspell:107268|h[Sabotage]|h|r on |cFFFF0000$n|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65508,'You stand before your death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65509,'You\'ve been |cFFFF0000|Hspell:107268|h[Sabotaged]|h|r!','You\'ve been |cFFFF0000|Hspell:107268|h[Sabotaged]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(65510,'Saboteur Kip\'tilak sets off a series of explosions!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65511,'It is good to see you here, child.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(65512,'I do. The way to defeat Fear is to look it straight in the eye, unblinking, unwavering.','I do. The way to defeat Fear is to look it straight in the eye, unblinking, unwavering.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65513,'|TInterface\\Icons\\ability_parry.blp:20|tMaster Snowdrift enables his |cFFFF0000|Hspell:106454|h[Parry Stance]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65514,'May the spirits be with you, brave one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65515,'|TInterface\\Icons\\spell_nature_earthbind.blp:20|tMaster Snowdrift uses his |cFFFF0000|Hspell:106434|h[Tornado Kick]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65516,'|TInterface\\Icons\\ability_hunter_sickem.blp:20|tMaster Snowdrift sets his sights on |cFFFF0000$n|r to |cFFFF0000|Hspell:118961|h[Chase Down]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65517,'Let\'s find out!','Let\'s find out!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(65518,'','Yes, these will do quite nicely. They feel almost as if they were meant for me all along.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65519,'Master Snowdrift is |cFFFF0000|Hspell:118961|h[Chasing]|h|r you! If he catches you he will use his |cFFFF0000|Hspell:106352|h[Tornado Slam]|h|r technique on you! Run away from Master Snowdrift until Chase Down expires!','Master Snowdrift is |cFFFF0000|Hspell:118961|h[Chasing]|h|r you! If he catches you he will use his |cFFFF0000|Hspell:106352|h[Tornado Slam]|h|r technique on you! Run away from Master Snowdrift until Chase Down expires!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65520,'|TInterface\\Icons\\inv_weapon_hand_30.blp:20|tMaster Snowdrift uses his |cFFFF0000|Hspell:106853|h[Fists of Fury]|h|r technique!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65522,'','Flying Snow chooses |cFFFF0000$n|r to chase down with her |cFFFF0000|Hspell:106706|h[Whirling Steel]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65523,'','Flying Snow is chasing you with her |cFFFF0000|Hspell:|h[Whirling Steel]|h|r technique! Run away from her until she chooses someone else!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65524,'','|TInterface\\Icons\\inv_sword_24.blp:20|tFlying Snow uses her |cFFFF0000|Hspell:106706|h[Whirling Steel]|h|r technique!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65525,'A Shado-Pan Novice has chosen you for |cFFFF0000|Hspell:106774|h[Honorable Combat]|h|r! They will attack you until they are defeated!','A Shado-Pan Novice has chosen you for |cFFFF0000|Hspell:106774|h[Honorable Combat]|h|r! They will attack you until they are defeated!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65526,'|TInterface\\Icons\\ability_warrior_battleshout.blp:20|tArmsmaster Harlan calls on two of his allies to join the fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65527,'|TInterface\\Icons\\inv_weapon_halberd_05.blp:20|tArmsmaster Harlan casts |cFFFF0000|Hspell:111216|h[Blades of Light]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65528,'You died to Armsmaster Harlan\'s |cFFFF0000|Hspell:|h[Blades of Light]|h|r ability. Armsmaster Harlan chooses one of two directions to travel when he uses this ability, so try to react to which way he goes so that you can dodge out of his path!','You died to Armsmaster Harlan\'s |cFFFF0000|Hspell:|h[Blades of Light]|h|r ability. Armsmaster Harlan chooses one of two directions to travel when he uses this ability, so try to react to which way he goes so that you can dodge out of his path!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65529,'|TInterface\\Icons\\spell_shadow_psychicscream.blp:20|tImperial Vizier Zor\'lok has targeted you with his |cFFFF0000|Hspell:122761|h[Exhale]|h|r ability! Use your survival abilities or have an ally with high survivability stand in between you and Imperial Vizier Zor\'lok!','|TInterface\\Icons\\spell_shadow_psychicscream.blp:20|tImperial Vizier Zor\'lok has targeted you with his |cFFFF0000|Hspell:122761|h[Exhale]|h|r ability! Use your survival abilities or have an ally with high survivability stand in between you and Imperial Vizier Zor\'lok!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65530,'You died to Imperial Vizier Zor\'lok\'s |cFFFF0000|Hspell:122713|h[Force and Verve]|h|r. Try and enter one of the |cFFFF0000|Hspell:122706|h[Noise Cancelling]|h|r zones to minimize the damage from Force and Verve and have you or an ally use their healing abilities to keep you alive.','You died to Imperial Vizier Zor\'lok\'s |cFFFF0000|Hspell:122713|h[Force and Verve]|h|r. Try and enter one of the |cFFFF0000|Hspell:122706|h[Noise Cancelling]|h|r zones to minimize the damage from Force and Verve and have you or an ally use their healing abilities to keep you alive.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65531,'You perished to Imperial Vizier Zor\'lok\'s |cFFFF0000|Hspell:123791|h[Song of the Empress]|h|r. Be sure you or one of your allies moves to the platform Imperial Vizier Zor\'lok is on and engages Imperial Vizier Zor\'lok in combat.','You perished to Imperial Vizier Zor\'lok\'s |cFFFF0000|Hspell:123791|h[Song of the Empress]|h|r. Be sure you or one of your allies moves to the platform Imperial Vizier Zor\'lok is on and engages Imperial Vizier Zor\'lok in combat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65532,'Imperial Vizier Zor\'lok has |cFFFF0000|Hspell:122740|h[Converted]|h|r you to fight for the Mantid Empire! Your former allies must bring your health down to 50% to free you of the Empress\'s hold over you!','Imperial Vizier Zor\'lok has |cFFFF0000|Hspell:122740|h[Converted]|h|r you to fight for the Mantid Empire! Your former allies must bring your health down to 50% to free you of the Empress\'s hold over you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65533,'You perished to Imperial Vizier Zor\'lok |cFFFF0000|Hspell:122336|h[Sonic Rings]|h|r ability. When Imperial Vizier Zor\'lok begins casting |cFFFF0000|Hspell:122496|h[Attenuation]|h|r be sure to move away from him and dodge the Sonic Rings that he emits.','You perished to Imperial Vizier Zor\'lok |cFFFF0000|Hspell:122336|h[Sonic Rings]|h|r ability. When Imperial Vizier Zor\'lok begins casting |cFFFF0000|Hspell:122496|h[Attenuation]|h|r be sure to move away from him and dodge the Sonic Rings that he emits.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65534,'|TInterface\\Icons\\spell_shaman_earthquake.blp:20|tKuai the Brute uses his |cFFFF0000|Hspell:119922|h[Shockwave]|h|r ability!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(65536,'|TInterface\\Icons\\ability_druid_supriseattack.blp:20|tMu\'Shiba casts |cFFFF0000|Hspell:119946|h[Ravage]|h|r on |cFFFF0000$n|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65537,'|TInterface\\Icons\\inv_elemental_primal_air.blp:20|tMing the Cunning summons a |cFFFF0000|Hspell:119981|h[Whirling Dervish]|h|r!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(65538,'|TInterface\\Icons\\spell_druid_ursolsvortex.blp:20|tMing the Cunning creates a |cFFFF0000|Hspell:120099|h[Magnetic Field]|h|r!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(65539,'|TInterface\\Icons\\ability_warrior_savageblow.blp:20|tHaiyan the Unstoppable strikes |cFFFF0000$n|r with a |cFFFF0000|Hspell:123655|h[Traumatic Blow]|h|r!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(65540,'We are all here. This is a historic moment, $n. My dying wife envisioned a city of light beyond these gates. What do you think we will find?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(65541,'Haiyan the Unstoppable struck you with a |cFFFF0000|Hspell:123655|h[Traumatic Blow]|h|r! Healing abilities used on you will be less efficient while the effect persists!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(65542,'There\'s only one way to find out...','There\'s only one way to find out...',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(65543,'|TInterface\\Icons\\spell_fire_meteorstorm.blp:20|tHaiyan the Unstoppable targets |cFFFF0000$n|r with a |cFFFF0000|Hspell:120195|h[Meteor]|h|r!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(65544,'You perished to Haiyan the Unstoppable\'s |cFFFF0000|Hspell:120195|h[Meteor]|h|r! Be sure to group up with your allies when Haiyan the Unstoppable uses this ability so that you all split the damage.','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(65545,'|TInterface\\Icons\\spell_fire_fireball.blp:20|tHaiyan the Unstoppable begins casting |cFFFF0000|Hspell:120167|h[Conflagrate]|h|r!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(65546,'I will defend the vale with my life!','I will defend the vale with my life!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65547,'We must maintain the balance!','We must maintain the balance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65548,'For honor!','For honor!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65549,'The golden lotus must protect the vale!','The golden lotus must protect the vale!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65550,'The summer fields will remain safe as long as I live!','The summer fields will remain safe as long as I live!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65551,'We fight together brethren!','We fight together brethren!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65552,'Drive these brutes from the vale!','Drive these brutes from the vale!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65553,'Remain vigilant!','Remain vigilant!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65554,'To defend the vale with my life is an honor!','To defend the vale with my life is an honor!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65555,'The battle is ours!','The battle is ours!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65556,'We are victorious!','We are victorious!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65557,'Ah-hah! Another chance to test my might.','',0,0,0,0,0,0,0,0,1,0,29428,0,26124),
(65558,'They are falling back!','They are falling back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65559,'On your guard!','',0,0,0,0,0,0,0,0,1,0,29426,0,26124),
(65560,'Bested... by the likes of...','',0,0,0,0,0,0,0,0,1,0,29427,0,26124),
(65561,'Hah-HAH!','',0,0,0,0,0,0,0,0,1,0,29429,0,26124),
(65562,'Tsk! You need more training.','',0,0,0,0,0,0,0,0,1,0,29430,0,26124),
(65563,'May they find peace.','May they find peace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65564,'Xeun has taught us courage.','Xeun has taught us courage.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65565,'The vale is safer now.','The vale is safer now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65567,'','The blades transform as she pulls them from Whitemane\'s corpse.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65568,'','Can you believe the nerve of this little grummle? This shrewd little negotiator will have me bankrupt with his prices in no time.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65569,'FUMMM!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65570,'He gestures towards the incoming statues, requesting your aid.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65571,'Keep your guard up!','Keep your guard up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65572,'A hozen bandit is stealing the brew! Stop him!','A hozen bandit is stealing the brew! Stop him!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65573,'Hello $n! The Lorewalker is beginning her lesson just down these stairs if you want to listen in.','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(65574,'Pitiful creatures.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65575,'I shall teach you the meaning of strength.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65576,'Lei Shen returns, weakling.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65577,'The vale belongs to the Shao-Tien!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65578,'We shall reign over Pandaria once more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65579,'There is no escape from our might!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65580,'Foolish child.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65581,'Give up now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65582,'He\'ll slice and dice in ways that aren\'t nice! Please bow respectfully for Maki Waterblade, saurok samurai!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65583,'','This is the Song of Liu Lang, the first pandaren explorer.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65584,'','The song is written in the old tongue, the language of emperors and scholars. Hardly anyone speaks it anymore.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(65585,'','It is all about his adventures.',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(65586,'','Brave Liu Lang set out to explore the world on the back of a sea turtle.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65587,'','Does anyone remember the turtle\'s name? Yin?',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(65588,'','That\'s right, the turtle was called Shen-zin Su. At first, he was only big enough for Liu Lang to sit on.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65589,'','He grew and grew and grew, SO big, that now some people call him \"The Wandering Isle.\"',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65590,'','Question, Hao?',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(65591,'','Yes, Hao - our home is on Shen-zin Su\'s back.',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(65592,'','Liu Lang discovered many things as he explored the world - oh - yes, Hao?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(65593,'','That\'s a good question. Nobody has spoken to Shen-zin Su for many generations. He only ever spoke to Liu Lang.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65594,'','But I am certain that Shen-zin Su knows we are here. And he cares for every one of us!',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(65595,'','Especially Hao! Liu Lang once said, \"Noble is he who always asks questions.\"',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(65596,'','\"We should all be like children, for the world is our elder, and has many things to teach us.\"',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65597,'','Students! Students! Pay attention now.',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(65598,'','Does anyone know how often Liu Lang went back to Pandaria?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65599,'','Haha, no Yin. Liu Lang would eat wherever he explored.',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(65600,'','He returned to the main continent of Pandaria once every five years.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65601,'','You are right, Yin. It IS hidden away, behind a cloak of mists.',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(65602,'','Does anyone remember how Liu Lang was always able to find it? Nan?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(65603,'','That\'s right! Liu Lang always had a way back home. Every five years, he would return, to pick up more explorers.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65604,'','Yes Hao! Only the BRAVEST pandaren joined Liu Lang on his turtle to explore the world.',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(65605,'','Shen-zin Su hasn\'t made landfall for a long time. But that hasn\'t stopped some pandaren from exploring, anyway.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65606,'','Yes, like Chen and Li Li! They\'re out, exploring the world. Maybe someday you will, too.',0,0,0,0,0,0,21,0,1,0,0,0,26124),
(65607,'','I\'m glad you asked, Yin. Liu Lang explored the world his entire life, and raised many children here on the Wandering Isle.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65608,'','Eventually he grew very old, and visited Pandaria one final time.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65609,'','But nobody else wanted to go exploring with him. So he left.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(65610,'','Shen-zin Su has never returned to Pandaria.',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(65611,'','Tired now, Liu Lang said goodbye to Shen-zin Su, his oldest friend.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65612,'','Then, Liu Lang went up to the Wood of Staves, carrying with him a bamboo umbrella that he always took on his adventures.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65613,'','He opened his umbrella, planted it in the ground, and sat underneath its cool shade.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(65614,'','He closed his eyes, and became one with the land. And then - do you know what happened?',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(65615,'','His umbrella... sprouted! It grew roots, flowered, and became a tree!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(65616,'','Well, it\'s true. If you ever go to the Wood of Staves, you can see it.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65617,'','Along with the budding staves of all the elders who came before us, growing now into giant trees.',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(65618,'','It\'s not a sad story! Liu Lang himself said, \"Never mourn a life well-lived.\"',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65619,'','And I think he lived a very very good life. We owe everything we have to Liu Lang, the first pandaren explorer.',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(65620,'','We tell his story, so that he will always be remembered.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(65621,'','Thank you, Ruolin! That was beautiful.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65622,'','Could you sing it once more, for the students who just arrived?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(65623,'An honorable end to the noble Maki... I\'m sure his clan would be proud, if he hadn\'t been the last of them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65624,'The Shado-Pan always friend of the grummles. Why are they not letting us in to trade?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65625,'We travel long long way. Now Shado-Pan say they do not want our goods. This is most strange.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65626,'We travelled through angry hozen, rampaging yeti, and unclean yaks to get here. Now the Shado-Pan act like we are strangers.$b$bThis very bad fortune indeed.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65627,'My nose is cold. That is a very bad sign.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65628,'I lost my yak on the road here. This is most not good.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65629,'If this Shado-Pan not let us in soon, I will make him smell MY luckydo.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65630,'This is most strange. Shado-Pan are our best customers. We sell them supplies, and they keep us safe.$b$bWhy are they turning us away? This I do not understand.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65631,'Why can\'t I understand any of the words?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65632,'Flitting through the mists with death upon his fists comes the sinister and serene jinyu assassin: Satay Byu!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65633,'Ooo, that\'s one killer carp whose slaying days have come to a fishy end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65634,'','What is the song about?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65635,'','Shen-zin Su!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65636,'Everyone, please cheer for the NEW CHAMPIONS of the Arena of Annihilation!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65637,'We live on the back of a big turtle?!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(65638,'','Sheesh, Hao. Haven\'t you ever paid attention?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65639,'I just thought it was weird that the mountains had flippers!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65640,'Does the turtle know we\'re here?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65641,'','Even Hao?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(65642,'Hey!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65643,'Yeah, you should all be more like me.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65644,'','Blerch! I\'d rather jump off this bridge.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65645,'','...Whenever he got hungry?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65646,'','But isn\'t Pandaria hidden somewhere? Nobody can find it!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65647,'','Because sea turtles always return to the beach where they were born!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65648,'Does that mean our moms and dads and grandparents were all explorers, too?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65649,'','But we don\'t explore very much anymore, do we?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65650,'','Like Chen and Li Li Stormstout!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65651,'I want to explore the world!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65652,'','No you don\'t. It\'s full of trolls.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65653,'Oh. Well, forget it then.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65654,'','Lorewalker! What ever happened to Liu Lang?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65655,'What?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65656,'','What? What?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65657,'That\'s un-possible!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65658,'','That\'s a sad story!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65659,'He tampers with the lock on your cage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65660,'He gestures towards the eastern vale, then disappears in the shadows.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65661,'He struggles to free himself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65662,'He collapses to the floor in exhaustion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65663,'He points down the hall ahead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65664,'He motions for you to wait.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65665,'He continues cautiously.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65666,'You can use the bombs and cannons nearby to blast the hozen away!','You can use the bombs and cannons nearby to blast the hozen away!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(65667,'I thought this was a tournament of \"strength.\" Yet I see only weakness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65668,'I am the weapon of kings! What makes you think you have a chance?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65669,'You will fail.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65670,'Err... What was that?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(65671,'Whoa!  Careful over there!  These tiles have violent tendencies...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65672,'Cloud tile good.  Other tiles bad.  There was a tile at the bottom of the entrance stairs that tipped me off.  My sharp eyes have saved my delicate features yet again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65673,'Oh dear! It looks like we\'ve got company... You take care of those mongrels, and I\'ll get the brew going.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(65674,'Phew! That was close. Ok, here\'s the deal...','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(65675,'The mogu, they seem not so good at this game, if their dead bodies are any indication.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65676,'I see, I see.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65677,'Mmmm, shall we?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65678,'I think I would quite enjoy skipping stones down that hallway.  It would be quite the display!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65679,'Now where\'s that big mogu baddy that came tramping through here a short bit ago?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65680,'He\'s... so...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(65681,'...ugly!','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(65682,'What are you doing here anyway?  Come all the way down here to bask in my marvelous company?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65683,'Zhi sent me.','Zhi sent me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65684,'WIKKETS!!!','',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(65685,'Fools, you will die with me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65686,'I have failed, but you will not live to tell anyone of this victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65687,'Artillery will scorch the ground, leaving nothing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65688,'Reinforcements, get over here and kill these weaklings!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65689,'Haha, flightless fools!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65690,'Oh no...','Oh no...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65691,'What are we going to do?!','What are we going to do?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65692,'The yaungol ruin everything!','The yaungol ruin everything!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65693,'Again?!','Again?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65694,'Can\'t we get one night of peace?','Can\'t we get one night of peace?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65695,'Everyone quiet down, let Hsieh speak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65696,'You saved us, $p!','You saved us, $p!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65697,'What would we do without you, $p?','What would we do without you, $p?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65698,'The festival is saved!','The festival is saved!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65699,'You\'re the greatest, $p!','You\'re the greatest, $p!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65700,'Marry me, $p!','Marry me, $p!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65701,'With $p around the yaungol didn\'t stand a chance!','With $p around the yaungol didn\'t stand a chance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65702,'You really kicked some yaungol butt, $p!','You really kicked some yaungol butt, $p!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65703,'Let\'s rename the village to $p town!','Let\'s rename the village to $p town!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65704,'Good work, $p, you saved the village. We are forever in your debt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65705,'','Hey, $n! I\'m brewing up something special for the festival. Come back later and I\'ll share some with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65706,'','It\'s ready! I put it over on the table.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65707,'','What\'s all that noise outside?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65708,'','It didn\'t come out very good, $n. You wouldn\'t want any.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65709,'I need a minute to recover.','I need a minute to recover.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65710,'I must recover my strength.','I must recover my strength.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65711,'Protect me!','Protect me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65712,'Not like this...','Not like this...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65713,'Your minds is weak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65714,'Such a weak creature.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65715,'Another weakling.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65716,'You will serve me well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65717,'You have come to your grave.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65718,'You will make an excellent pet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65719,'Quickly, everyone to arms!','',0,0,0,0,0,0,25,0,1,0,29780,0,26124),
(65720,'The temple will not fall!','',0,0,0,0,0,0,0,0,1,0,29781,0,26124),
(65721,'We will not allow this to come to pass.','',0,0,0,0,0,0,0,0,1,0,29782,0,26124),
(65722,'We owe you a great debt.','',0,0,0,0,0,0,0,0,1,0,29784,0,26124),
(65723,'Today, we welcome you into the Shado-Pan.','',0,0,0,0,0,0,0,0,1,0,29785,0,26124),
(65724,'Your perseverance strengthens us. Your courage leads us. Your honor inspires us.','',0,0,0,0,0,0,0,0,1,0,29786,0,26124),
(65725,'From this day forth, you walk as one of us.','',0,0,0,0,0,0,0,0,1,0,29788,0,26124),
(65726,'Go forth, as a member of the Shado-Pan!','',0,0,0,0,0,0,0,0,1,0,29790,0,26124),
(65727,'About time!','',0,0,0,0,0,0,0,0,1,0,29792,0,26124),
(65728,'Let\'s go for a drink!','',0,0,0,0,0,0,0,0,1,0,29794,0,26124),
(65729,'We knew you could do it!','',0,0,0,0,0,0,0,0,1,0,29795,0,26124),
(65730,'These guys have no taste.','',0,0,0,0,0,0,0,0,1,0,29821,0,26124),
(65731,'I\'ve got a special mix for you!','',0,0,0,0,0,0,0,0,1,0,29823,0,26124),
(65732,'So predictable.','',0,0,0,0,0,0,0,0,1,0,29827,0,26124),
(65733,'I\'ve fought Virmen more clever than you.','',0,0,0,0,0,0,0,0,1,0,29828,0,26124),
(65734,'You\'d fight better if you\'d loosen up.','',0,0,0,0,0,0,0,0,1,0,29830,0,26124),
(65735,'Nice moves. I\'ll have to study those.','',0,0,0,0,0,0,0,0,1,0,29832,0,26124),
(65736,'If fighting like that works for you, I guess it\'s fine...','',0,0,0,0,0,0,0,0,1,0,29834,0,26124),
(65737,'Huh? Oh, hey, enemies.','',0,0,0,0,0,0,0,0,1,0,29835,0,26124),
(65738,'During that fight, I thought of a great new brew.','',0,0,0,0,0,0,0,0,1,0,29836,0,26124),
(65739,'We\'re way out of these guys league.','',0,0,0,0,0,0,0,0,1,0,29837,0,26124),
(65740,'Beer before liquor, never fought quicker.','',0,0,0,0,0,0,0,0,1,0,29838,0,26124),
(65741,'Very creative fighting, there.','',0,0,0,0,0,0,0,0,1,0,29839,0,26124),
(65742,'What? No!','',0,0,0,0,0,0,0,0,1,0,29813,0,26124),
(65743,'We\'ve got to stop them!','',0,0,0,0,0,0,0,0,1,0,29814,0,26124),
(65744,'There\'s no way you\'re getting past us.','',0,0,0,0,0,0,0,0,1,0,29816,0,26124),
(65745,'Crossing the Shado-Pan was a bad idea.','',0,0,0,0,0,0,0,0,1,0,29817,0,26124),
(65746,'Good job. Guess you learned a little something from me.','',0,0,0,0,0,0,0,0,1,0,29819,0,26124),
(65747,'%s becomes enraged at being separated from his Ambercaller!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65748,'The mogu are attacking the temple!','',0,0,0,0,0,0,5,0,1,0,30566,0,26124),
(65749,'The mogu are attacking Niuzao Temple. We need your help.','',0,0,0,0,0,0,0,0,1,0,30567,0,26124),
(65750,'Quickly, everyone to arms!','',0,0,0,0,0,0,0,0,1,0,30569,0,26124),
(65751,'Believe in your own strength.','',0,0,0,0,0,0,0,0,1,0,30570,0,26124),
(65752,'Drive them back!','',0,0,0,0,0,0,0,0,1,0,30571,0,26124),
(65753,'Do not give up!','',0,0,0,0,0,0,0,0,1,0,30572,0,26124),
(65754,'As long as I stand, this temple will never fall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65755,'Charge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65756,'Drive them back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65757,'Believe in your strength!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65758,'Your power is mine!','',0,0,0,0,0,0,0,0,1,0,30820,0,26124),
(65759,'Break yourselves upon me!','',0,0,0,0,0,0,0,0,1,0,30822,0,26124),
(65760,'I shall show you TRUE strength!','',0,0,0,0,0,0,0,0,1,0,30821,0,26124),
(65761,'I will break you!','',0,0,0,0,0,0,0,0,1,0,30823,0,26124),
(65762,'You will never prevail!','',0,0,0,0,0,0,0,0,1,0,30824,0,26124),
(65763,'I will show you the heart of fear!','',0,0,0,0,0,0,0,0,1,0,30825,0,26124),
(65764,'Your weakness betrays you.','',0,0,0,0,0,0,0,0,1,0,30826,0,26124),
(65765,'Scatter like leaves upon the wind!','',0,0,0,0,0,0,0,0,1,0,30827,0,26124),
(65766,'You are nothing.','',0,0,0,0,0,0,0,0,1,0,30828,0,26124),
(65767,'No. NO!','',0,0,0,0,0,0,0,0,1,0,30829,0,26124),
(65768,'I cannot be defeated!','',0,0,0,0,0,0,0,0,1,0,30830,0,26124),
(65769,'This is not what was promised!','',0,0,0,0,0,0,0,0,1,0,30831,0,26124),
(65770,'My power wanes!','',0,0,0,0,0,0,0,0,1,0,30832,0,26124),
(65771,'Master, command me!','',0,0,0,0,0,0,0,0,1,0,30833,0,26124),
(65772,'The storm will consume you!','',0,0,0,0,0,0,0,0,1,0,30834,0,26124),
(65773,'You cannot escape the storm.','',0,0,0,0,0,0,0,0,1,0,30835,0,26124),
(65774,'Strike!','',0,0,0,0,0,0,0,0,1,0,30836,0,26124),
(65775,'Master, I have failed you...','',0,0,0,0,0,0,0,0,1,0,30837,0,26124),
(65776,'The mantid besiege you from all sides.','',0,0,0,0,0,0,0,0,1,0,31208,0,26124),
(65777,'Your temple is broken.','',0,0,0,0,0,0,0,0,1,0,31210,0,26124),
(65778,'Your defenders are slain.','',0,0,0,0,0,0,0,0,1,0,31211,0,26124),
(65779,'You are forgotten. This is what you fear, is it not?','',0,0,0,0,0,0,0,0,1,0,31217,0,26124),
(65780,'So far away, here on the dark side of the wall.','',0,0,0,0,0,0,0,0,1,0,31218,0,26124),
(65781,'You stand alone against the might of the swarm, a single light in a sea of darkness.','',0,0,0,0,0,0,0,0,1,0,31219,0,26124),
(65782,'Do your celestial brothers and sisters lend you their aid? No, they do not.','',0,0,0,0,0,0,0,0,1,0,31220,0,26124),
(65783,'If you fall, who would notice?','',0,0,0,0,0,0,0,0,1,0,31221,0,26124),
(65784,'Grant your celestial mantle to my pet, and let a new celestial take your place!','',0,0,0,0,0,0,0,0,1,0,31223,0,26124),
(65785,'Then I have no other choice than to kill you.','',0,0,0,0,0,0,0,0,1,0,31226,0,26124),
(65786,'Shan-ze! Hei Feng! Kill him!','',0,0,0,0,0,0,0,0,1,0,31227,0,26124),
(65787,'Ha! Too easy!','Ha! Too easy!',0,0,0,0,0,0,0,0,1,0,30666,30666,26124),
(65788,'Ha! Good fun!','Ha! Good fun!',0,0,0,0,0,0,0,0,1,0,30667,30667,26124),
(65789,'Time to crush our enemies.','Time to crush our enemies.',0,0,0,0,0,0,0,0,1,0,30668,30668,26124),
(65790,'Good fighting, friend!','Good fighting, friend!',0,0,0,0,0,0,0,0,1,0,30669,30669,26124),
(65791,'Let\'s see what you\'ve got!','Let\'s see what you\'ve got!',0,0,0,0,0,0,0,0,1,0,30670,30670,26124),
(65792,'Rraaaagh!','Rraaaagh!',0,0,0,0,0,0,0,0,1,0,30671,30671,26124),
(65793,'So easy. What a disappointment!','So easy. What a disappointment!',0,0,0,0,0,0,0,0,1,0,30672,30672,26124),
(65794,'The smell of victory!','The smell of victory!',0,0,0,0,0,0,0,0,1,0,30673,30673,26124),
(65795,'Maybe you\'ll be a challenge?','Maybe you\'ll be a challenge?',0,0,0,0,0,0,0,0,1,0,30674,30674,26124),
(65796,'What a waste of time.','What a waste of time.',0,0,0,0,0,0,0,0,1,0,30675,30675,26124),
(65797,'Let\'s do this!','Let\'s do this!',0,0,0,0,0,0,0,0,1,0,30676,30676,26124),
(65798,'Honor in victory!','Honor in victory!',0,0,0,0,0,0,0,0,1,0,30677,30677,26124),
(65799,'','What? No!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65800,'','That\'s NOT going to happen.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65801,'','Destroy them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65802,'','They are falling! Don\'t stop now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65803,'','Good work! You\'re quite a fighter.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65804,'','I love the feeling after a good fight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65805,'','Let\'s celebrate!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65806,'Keep them back!  They will not delve into our secrets!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65807,'This fight is favorable to us.','',0,0,0,0,0,0,0,0,1,0,27980,0,26124),
(65808,'Take care - do not lower your guard.','',0,0,0,0,0,0,0,0,1,0,27981,0,26124),
(65809,'So, we live to fight another day.','',0,0,0,0,0,0,0,0,1,0,27982,0,26124),
(65810,'We will not falter.','',0,0,0,0,0,0,0,0,1,0,27983,0,26124),
(65811,'We fought well, but we should not push our luck.','',0,0,0,0,0,0,0,0,1,0,27984,0,26124),
(65812,'Strike at the enemy - I shall be your shield.','',0,0,0,0,0,0,0,0,1,0,27985,0,26124),
(65813,'We fight, that others may live in peace.','',0,0,0,0,0,0,0,0,1,0,27986,0,26124),
(65814,'You fight well. Beware overconfidence.','',0,0,0,0,0,0,0,0,1,0,27987,0,26124),
(65815,'For the fallen!','',0,0,0,0,0,0,0,0,1,0,27988,0,26124),
(65816,'Your kind shall spill innocent blood no longer!','',0,0,0,0,0,0,0,0,1,0,27989,0,26124),
(65817,'The battle is won.','',0,0,0,0,0,0,0,0,1,0,27990,0,26124),
(65818,'I will breathe easier knowing this one is gone.','',0,0,0,0,0,0,0,0,1,0,27991,0,26124),
(65819,'No!','',0,0,0,0,0,0,0,0,1,0,27972,0,26124),
(65820,'This cannot stand.','',0,0,0,0,0,0,0,0,1,0,27973,0,26124),
(65821,'For the Shado-Pan!','',0,0,0,0,0,0,0,0,1,0,27974,0,26124),
(65822,'Perseverance! Victory is in our grasp.','',0,0,0,0,0,0,0,0,1,0,27976,0,26124),
(65823,'Well fought. I am glad you survived the battle.','',0,0,0,0,0,0,0,0,1,0,27977,0,26124),
(65824,'I am honored to fight alongside you.','',0,0,0,0,0,0,0,0,1,0,27978,0,26124),
(65825,'I go to contemplate those who could not share this victory with us.','',0,0,0,0,0,0,0,0,1,0,27979,0,26124),
(65826,'I need some training.','I need some training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65827,'A new continent full of forgotten secrets!  Share what you learn with the Lorewalkers here and me, and I\'ll let you in on some of my other projects.','A new continent full of forgotten secrets!  Share what you learn with the Lorewalkers here and me, and I\'ll let you in on some of my other projects.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65828,'Let me in on your other projects.','Let me in on your other projects.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65829,'Alright, recruits! Thanks to $p, we\'re going to reclaim Kun-Lai summit from the Yaungol and make it safe again. For the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65830,'You\'ve done great work here, friend. We should have a strong base of operations here going forward - see if anyone else needs your help.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65831,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65832,'Recruits, I want you to remember that it was $p who saved you, and the Alliance who are going to save Kun-Lai!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65833,'You\'ve done great work. We should be able to maintain our base of operations here now without too much trouble.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65834,'For the Alliance!','For the Alliance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65835,'','I hate you all!',0,0,0,0,0,0,0,0,1,0,0,31312,26124),
(65836,'','Why? Why did it have to be him?',0,0,0,0,0,0,0,0,1,0,0,31313,26124),
(65837,'','I will have justice!',0,0,0,0,0,0,0,0,1,0,0,31314,26124),
(65838,'','Death for death!',0,0,0,0,0,0,0,0,1,0,0,31315,26124),
(65839,'','Do not forget to speak to Fei Li before you depart. You will find her skills useful against our enemies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65840,'You have grown stronger than I ever expected.','You have grown stronger than I ever expected.',0,0,0,0,0,0,0,0,1,0,31427,31427,26124),
(65841,'If you ever have need of a healer in battle, speak to me.','If you ever have need of a healer in battle, speak to me.',0,0,0,0,0,0,0,0,1,0,31428,31428,26124),
(65842,'It would be my honor to join you in battle.','It would be my honor to join you in battle.',0,0,0,0,0,0,0,0,1,0,31429,31429,26124),
(65843,'Trust in the might of your Empress. She shall lead us to glory!','',0,0,0,0,0,0,0,0,1,16597,29289,0,26124),
(65844,'Together, the swarm will rise higher than any empire this land has ever known!','',0,0,0,0,0,0,0,0,1,16597,29290,0,26124),
(65845,'The will of the Empress is our own. Her greatness is our greatness. Her victory is a victory for the swarm!','',0,0,0,0,0,0,0,0,1,16597,29291,0,26124),
(65846,'You dare challenge the voice of the Empress? What the voice speaks, the swarm hears!','',0,0,0,0,0,0,0,0,1,16597,29292,0,26124),
(65847,'Blasphemy! You are not one of the swarm!','',0,0,0,0,0,0,0,0,1,16597,29293,0,26124),
(65848,'You are but one against the Empress\'s divine wrath! You, too, will fall!','',0,0,0,0,0,0,0,0,1,16597,29294,0,26124),
(65849,'The swarm is the blade that will cut through our enemies!','',0,0,0,0,0,0,0,0,1,16597,29246,0,26124),
(65850,'A single cut should do.','',0,0,0,0,0,0,0,0,1,16597,29247,0,26124),
(65851,'Our enemies will fall beneath our blades!','',0,0,0,0,0,0,0,0,1,16597,29248,0,26124),
(65852,'Do you wish to test the edge of my blade?','',0,0,0,0,0,0,0,0,1,16597,29249,0,26124),
(65853,'I smell the stench of Klaxxi disobedience! Stop running and face the Lord of Blades!','',0,0,0,0,0,0,0,0,1,16597,29250,0,26124),
(65854,'Ahahhhaahaa... was that supposed to hurt?','',0,0,0,0,0,0,0,0,1,16597,29251,0,26124),
(65855,'The cold wind blows. The time of the swarm has begun!','',0,0,0,0,0,0,0,0,1,16597,30353,0,26124),
(65856,'Do they think a wall can stop us? Do they believe that stone can stand against those who ride upon the wind?','',0,0,0,0,0,0,0,0,1,16597,30354,0,26124),
(65857,'The swarm shall darken the skies with our numbers! We shall cast eternal night upon this land!','',0,0,0,0,0,0,0,0,1,16597,30355,0,26124),
(65858,'Infiltrator! You cannot hope to stop the swarm!','',0,0,0,0,0,0,0,0,1,16597,30356,0,26124),
(65859,'Flying away, little rider? A true champion would face me in the heart of fear!','',0,0,0,0,0,0,0,0,1,16597,30357,0,26124),
(65860,'A pitiful attempt.','',0,0,0,0,0,0,0,0,1,16597,30358,0,26124),
(65861,'Yes, my little monsters! Go! Unleash yourselves upon our enemies!','',0,0,0,0,0,0,0,0,1,16597,31565,0,26124),
(65862,'The next stage of my experiment begins!','',0,0,0,0,0,0,0,0,1,16597,31566,0,26124),
(65863,'Ahh, if I could just get my hands on you! You would make a very nice experiment!','',0,0,0,0,0,0,0,0,1,16597,31567,0,26124),
(65864,'Auuugghhh! That hurt!','',0,0,0,0,0,0,0,0,1,16597,31568,0,26124),
(65865,'Are you... afraid?','',0,0,0,0,0,0,0,0,1,16597,31569,0,26124),
(65866,'The island swarms with the Empress\'s minions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65867,'This will not be an easy fight to win.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65868,'The Empress must be brought to justice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65869,'Do not fear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65870,'Fear is an illusion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65871,'Onward, warrior!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65872,'Attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65873,'For the swarm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65874,'Justice will prevail.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65875,'She must answer for her crimes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65876,'You have done well, wallwalker.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65877,'You are braver than you look, stranger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65878,'Do not let the fear consume you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65879,'We cannot let them destroy this tree.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65880,'We cannot let them destroy this tree. It is the last of its kind.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65881,'The war is not over, but we have dealt them a bitter blow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65882,'Do not cross a Klaxxi.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65883,'Ahhh, look who has joined us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65884,'I see the paragons have finally arrived to save the day.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65885,'You are ancient relics of a bygone age!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65886,'What can you hope to do against the might of the swarm?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65887,'So few. So weak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65888,'The swarm will consume you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65889,'Fear me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65890,'Frightening, isn\'t it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65891,'Are you... frightened?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65892,'Behold the might of the swarm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65893,'Join us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65894,'I am... alone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65895,'No. NO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65896,'It was not... enough.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65897,'I have failed you, Empress.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65898,'I will be avenged!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65901,'Whoever said they\'d rather light a candle than curse the darkness...$b$bWell, they probably haven\'t lit as many candles as me.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(65902,'Can I have a Red Radish?','Can I have a Red Radish?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65903,'Do you have a spare Sweet Lakemelon?','Do you have a spare Sweet Lakemelon?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65904,'Could I have a Fuzzy Peach for Ella?','Could I have a Fuzzy Peach for Ella?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65905,'Do you have any Black Cherries?','Do you have any Black Cherries?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65906,'','Awww shucks, I was gonna eat these! Well, if Ella needs \'em, I ain\'t gonna no more. Here, take \'em!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65907,'A radish for sweet little Ella? Well, I sure can spare one. Here you go.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65908,'Little Ella\'s trying her hand at brewing? Well, I\'ll be! I wish her luck. Brewing isn\'t something a novice can just take up, you know. Anyhow, I can spare a Lakemelon for her.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65909,'','I was going to charge you a pretty penny for that peach, but Ella is such a good customer at my market, this one\'s on the house. Just this once, ya hear!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65910,'','It is said, \"Turn your face towards the sun, and the shadows will fall behind you.\"$b$bI hope you find many bright days ahead of you, $n!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(65911,'Wow! Thish ish shome amazing shtuff! Where can I get shome more?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65912,'Hmmm, this is excellent! EXCELLENT! This is the best stuff I\'ve tasted in a long time. Who brewed it?','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(65913,'Mmm, that\'s mighty tasty, $n. I wouldn\'t mind another round of that... or two... hic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65914,'','Mmmmm, I haven\'t tasted a brew of this complexity and clarity since... well... since the golden age of the Stormstout Brewery! Whoever made this has a real talent.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65915,'Your skill in cooking is only as great as your most advanced Way.','Your skill in cooking is only as great as your most advanced Way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65916,'Mmmmm. Mmmmmm...... This is... simply put... amazing. Your friend Ella has real talent! Tell her to speak to my Uncle Gao at the Brewery. I think she has found a new home with us Stormstouts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65917,'<Mishi looks at you with concern.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65918,'<Mishi is puzzled by your actions.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65919,'<Mishi wonders what you are doing.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65920,'<Mishi tilts his head curiously at you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65921,'<Mishi watches you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65922,'<Mishi is very happy with you!>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65923,'<Mishi bobs up and down excitedly.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65924,'<Mishi smiles at you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65925,'<Mishi bobs up and down with glee.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65926,'<Mishi is happy!>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65927,'Throw a Spiced Punch to knock hozen off the cart!','Throw a Spiced Punch to knock hozen off the cart!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65928,'Throw a Spiced Punch on hozen who jump on the cart!','Throw a Spiced Punch on hozen who jump on the cart!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65929,'Whew! Everything should be smooth sailing from here on out!','Whew! Everything should be smooth sailing from here on out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65930,'This is the closest any outsider has come to the Engine of Nalak\'sha.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65931,'Looks like we did it! We\'re in the clear!','Looks like we did it! We\'re in the clear!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65932,'They\'re gone! Whew! Looks like the trail is clear.','They\'re gone! Whew! Looks like the trail is clear.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65933,'We did it! The trail should be clear from here on.','We did it! The trail should be clear from here on.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65934,'Oh great luckydos! What is THAT!?','Oh great luckydos! What is THAT!?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65935,'Oh most unluckiest of days! What is THAT!?','Oh most unluckiest of days! What is THAT!?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65936,'We shou-- oh most unluckiest of days! What is THAT!?','We shou-- oh most unluckiest of days! What is THAT!?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65937,'Auuughh! Yeti on the trail!','Auuughh! Yeti on the trail!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65938,'Auuughh! Yeti on the trail! Go yak! Faster, faster!','Auuughh! Yeti on the trail! Go yaks! Faster, faster!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65939,'Auuughh! Yeti on the trail! Looks like we aren\'t in the clear yet!','Auuughh! Yeti on the trail! Looks like we aren\'t in the clear yet!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65940,'These secrets will die with you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65941,'We are on our way to the Wanderer\'s Festival. You should join us!','We are on our way to the Wanderer\'s Festival. You should join us!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(65942,'The Wanderer\'s Festival is tonight. Are you coming?','The Wanderer\'s Festival is tonight. Are you coming?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(65943,'What is the Wanderer\'s Festival?','What is the Wanderer\'s Festival?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(65944,'Legend has it that Liu Lang once set out to explore the seas beyond Pandaria on the back of a giant turtle. Every few years, he would come back, always seeking new explorers to travel with him. To this day, whenever a pandaren is daydreaming or staring off into space, we ask if they\'re \"waiting for the turtle.\"$b$bMost pandaren aren\'t very adventurous - they like to stay close to hearth and home. But some of us are still dreamers... Tonight we gather at Turtle Beach on the southern coast to gaze out at the sea and celebrate Liu Lang\'s spirit of adventure.$b$bIt\'s called the Wanderer\'s Festival.','Legend has it that Liu Lang once set out to explore the seas beyond Pandaria on the back of a giant turtle. Every few years, he would come back, always seeking new explorers to travel with him. To this day, whenever a pandaren is daydreaming or staring off into space, we ask if they\'re \"waiting for the turtle.\"$b$bMost pandaren aren\'t very adventurous - they like to stay close to hearth and home. But some of us are still dreamers... Tonight we gather at Turtle Beach on the southern coast to gaze out at the sea and celebrate Liu Lang\'s spirit of adventure.$b$bIt\'s called the Wanderer\'s Festival.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(65945,'This is the Wanderer\'s Festival, $n! Where pandaren with the spirit of adventure gather to celebrate the first explorer to venture beyond the mists.$b$bIt\'s a time of contemplation and song. Thank you for joining us!','This is the Wanderer\'s Festival, $n! Where pandaren with the spirit of adventure gather to celebrate the first explorer to venture beyond the mists.$b$bIt\'s a time of contemplation and song. Thank you for joining us!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65946,'What is going on here?','What is going on here?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(65947,'','Welcome, $n!$b$bThis is the \"Wanderer\'s Festival,\" where we celebrate the deeds of the first pandaren explorer and gather on the beach to gaze out across the sea.$b$bThere was a time when the mists that cloaked Pandaria were so thick, sometimes you couldn\'t even see that large rock just off the shore there. Now look at it - what a glorious night! I\'m glad you are here for this.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(65948,'','Lorewalker Cho! I\'m so glad you\'re joining us this week.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(65949,'','Can you sing for us the song of Liu Lang?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65950,'','Your voice is so beautiful. Sometimes I swear I could hear a whole orchestra when you sing!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(65951,'','Thank you, Lorewalker!',0,0,0,0,0,0,21,0,1,0,0,0,26124),
(65952,'$n! I am delighted to see that you are celebrating the Wanderer\'s Festival with us!$b$bIt is often said that pandaren are not the adventurous sort. But look around at these faces - ah, you see? The starry eyes of dreamers!$b$bI should think that someday soon, there will be many more pandaren adventurers to speak of, making a difference all over the world. Don\'t you think?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(65953,'Here\'s a real surprise for you. What do you suppose they\'re celebrating? And what do you think would be the proper drink to mark the occasion?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(65954,'','Wow, incredible! Look at all the lights!$b$BWhat\'s going on do you think? Who\'s the guy on the turtle?$b$bWaaaaaiitt - is that Liu Lang?$b$bThat turtle must be Shen-zin Su. It IS! That statue is of a tiny baby Wandering Isle!$b$BWe\'re home, Uncle Chen!$b$bWell, sorta.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(65955,'Avoid or destroy Gash\'nul\'s Storm Totems.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65956,'%s is dismounted from his wind rider.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65957,'Ba-Bam still up and Bammin\' Brews!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65958,'Dancin\' like a monkey!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65959,'Heyarrr! I has me brew.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65960,'Ookie\'s still cookin\' and brewin\'!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65961,'Grooka Grooka gonna light this party up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65962,'I would like to practice catch with a baby serpent.','I would like to practice catch with a baby serpent.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65963,'','It looks like you are already playing catch with your serpent, $n. You can only play catch with one serpent at a time.$B$BPlease finish your current training session before practicing with another serpent.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65964,'I am done practicing. Please take your hatchling back.','I am done practicing. Please take your hatchling back.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65965,'This place is all shiny. Not sure I like it. Seems like it is missing that \"lived in\" smell.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(65966,'Search the island to collect brew for Bo\'s cauldron! But be sure to leave one person nearby to defend Bo!','Search the island to collect brew for Bo\'s cauldron! But be sure to leave one person nearby to defend Bo!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(65967,'Throw the Bouncy Ball to your serpent and see how long you can keep it in the air! When you are done playing, speak to me and I will take your serpent. Good luck!','Throw the Bouncy Ball to your serpent and see how long you can keep it in the air! When you are done playing, speak to me and I will take your serpent. Good luck!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65968,'Well, how did it go? Well, I hope?','Well, how did it go? Well, I hope?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65969,'Fixing','Fixing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65970,'','Children of Pandaria. The mists have fallen. For good or for ill, our land is open to all.',0,0,0,0,0,0,0,0,7,0,0,38220,26124),
(65971,'','Let us draw ourselves together to rebuild this sacred place, the first step toward healing a war-torn world.',0,0,0,0,0,0,0,0,7,0,0,38221,26124),
(65972,'I have faith in our friends from beyond the mists.','',0,0,0,0,0,0,0,0,7,0,29621,0,26124),
(65973,'Their strength is an inspiration... and sorely needed. We must trust that their hearts are pure.','',0,0,0,0,0,0,0,0,7,0,29029,0,26124),
(65974,'Just one... more... catch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65975,'Alliance... near...','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(65976,'Let my strength be your strength. Go and destroy our enemies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65977,'My pheromones should be useful when dealing with multiple enemies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65978,'Go ahead and turn this thing on.','Go ahead and turn this thing on.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65979,'','No no, don\'t try to get up. Your war isn\'t here, soldier - you need your rest',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65980,'|TInterface\\Icons\\ability_warlock_soulsiphon:20|t%s begins to cast |cFFFF0000|Hspell:126299|h[Unleash Souls]|h|r! Get in the water!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65981,'The architecture in here is strange, differing in many ways from traditional mogu design. This room seems to be a device of some sort, but I see nothing of its purpose in my notes.  \n$bThe only way for us to figure out what this is for is to activate it and observe.\n$bWhat\'s the worst that could happen?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65982,'We\'ve been flying in this mist for hours, General. The crew grows... uneasy.','',0,0,0,0,0,0,0,0,7,0,27992,0,26124),
(65983,'Back to your post, soldier! We\'ll find this land, or die trying.','',0,0,0,0,0,0,0,0,7,0,29176,0,26124),
(65984,'Alliance ship! Portside!','',0,0,0,0,0,0,0,0,7,0,29177,0,26124),
(65985,'Attack!','',0,0,0,0,0,0,0,0,7,0,29178,0,26124),
(65986,'Enemy ship, starboard! Ready the guns! Fire at will!','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(65987,'|TInterface\\Icons\\ability_warrior_charge.blp:20|t%s sets his eyes on |cFFFF0000$n|r and begins to cast |cFFFF0000|Hspell:127245|h[Fatal Blow]|h|r! Move!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65988,'Horde... here...','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(65989,'Direct hit! She\'s goin\' down!','',0,0,0,0,0,0,0,0,7,0,29179,0,26124),
(65990,'Land ho!','',0,0,0,0,0,0,0,0,7,0,27905,0,26124),
(65991,'This room pulses with energy, but feels unlike any we have seen so far.','',0,0,0,0,0,0,5,0,1,0,30182,0,26124),
(65992,'Fascinating, I have never heard tales of anything like this. The mogu hide their secrets well.','',0,0,0,0,0,0,5,0,1,0,30183,0,26124),
(65993,'This seems to be a terminal controlling the device. Let\'s see here...','',0,0,0,0,0,0,1,0,1,0,30184,0,26124),
(65994,'More strangers seem to wash up on our beaches every day.$b$bThis bunch was still trying to shoot at each other until yesterday evening. I hope this isn\'t a sign of what\'s to come.','More strangers seem to wash up on our beaches every day.$b$bThis bunch was still trying to shoot at each other until yesterday evening. I hope this isn\'t a sign of what\'s to come.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65995,'Uhh, somethin\' ain\'t right, General... We\'re losin\' altitude! Fast!','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(65996,'Sensors online. All cores operating at peak efficiency.','',0,0,0,0,0,0,0,0,1,0,28544,0,26124),
(65997,'Enabling','Enabling',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(65998,'Identification matrix mismatch. Unknown entities detected.','',0,0,0,0,0,0,0,0,1,0,28545,0,26124),
(65999,'%s casts |cFFFF0000|Hspell:116529|h[Power Down]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66000,'Magnificent! It talks! This seems beyond what we thought the mogu were capable of.','',0,0,0,0,0,0,5,0,1,0,30185,0,26124),
(66001,'Oh dear...this could get messy. I will observe from a safer distance!','',0,0,0,0,0,0,274,0,1,0,30186,0,26124),
(66002,'Do you require anything?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66003,'We shall hunt our foes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66004,'','I will be the blade at the throat of our enemies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66005,'The machine has been destroyed, and so the mogu\'s power weakens.','',0,0,0,0,0,0,4,0,1,0,30187,0,26124),
(66006,'','None will stand against the Shado-Pan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66007,'These discs look familiar, but I cannot place their origin.','',0,0,0,0,0,0,25,0,1,0,30188,0,26124),
(66008,'They call to me, the discs...I must...','',0,0,0,0,0,0,6,0,1,0,30189,0,26124),
(66009,'I...I see everything clearly now.','',0,0,0,0,0,0,2,0,1,0,30190,0,26124),
(66010,'The Titans! It would seem the mogu salvaged and repurposed ancient Titan technology to advance their empire!','',0,0,0,0,0,0,5,0,1,0,30191,0,26124),
(66011,'We must go, we are not done yet.','',0,0,0,0,0,0,1,0,1,0,30192,0,26124),
(66012,'Tenwu the Red Smoke greets you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66013,'All enemies of the Shado-Pan will fall before Tenwu the Red Smoke!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66014,'Keep those archers off the wall. Raigonn must reach the gate.','',0,0,0,0,0,0,0,0,1,0,29377,0,26124),
(66015,'Here... try this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66016,'Oh, yes. Hrm. I\'m... sorry it wasn\'t to your liking...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66017,'She should be a pile of bones and slime! Strong of stomach, indeed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66018,'There exist two great disciplines among our people. The Tushui are patient, pensive, and deliberate. The Huojin are fierce, forward, and active. Both disciplines serve us in their own way, and neither could exist effectively without the other.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66019,'I seek more than anything to help young pandaren explore their potential within these grounds. True mastery comes with much time and much practice, but there is value even in finding the first beginnings of a fitting path.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66020,'Fa... ther....','',0,0,0,0,0,0,0,0,1,0,29238,0,26124),
(66021,'','Ah, sure.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66022,'','Find strength in patience.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66023,'','Wow! Uh, it\'s... interesting!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66024,'Who holds this swarm? Show yourself! Answer to the Klaxxi.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66025,'Speak your name puppet, that our annals will be complete.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66026,'Your \"Empress\" has fallen. The Klaxxi have pronounced judgment. Stand aside or be brushed away.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66027,'Blaspheme!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66028,'','Only the gathered mind is truly prepared to face any trial.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66029,'','Only a mind at peace can fully ready a body for battle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66030,'','Are you fascinated by the wonders of metallurgy? The artistry of smelting? The beauty of mixing metals and alloys?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66031,'<cough> <hack> I have... returned.','',0,0,0,0,0,0,0,0,1,0,30299,0,26124),
(66032,'Keep your seatbelts fastened... Just kidding, we don\'t have seatbelts!','Keep your seatbelts fastened... Just kidding, we don\'t have seatbelts!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66033,'Are we there, yeti?','Are we there, yeti?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66034,'Wakener, you deeds have earned you the trust of the Klaxxi.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66035,'I hope this yak knows the way up the mountain because I sure don\'t!','I hope this yak knows the way up the mountain because I sure don\'t!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66036,'This is your first trip up Neverest? It\'s mine too!','This is your first trip up Neverest? It\'s mine too!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66037,'','I understand that the mind of the Tushui is not the only path to wisdom, but there are yet choices that should not be accepted.  Risks that are too dangerous to ever be taken.  Decisions that I cannot forgive...$B$BIt is time for me to leave Shen-zin Su.  I have found respect for Delora Lionheart for her confidence and valor, and her tales of the Alliance speak well of her people.  I do not yet know if I will find a home there, but wherever my path may lead, I will find a way to help the world beyond this isle.$B$BDespite everything, I\'ve enjoyed what little time we\'ve had together, $n.  I hope that you might join me, but I understand that this decision is not an easy one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66038,'You are to be rewarded. Walk with me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66039,'We can never rest until we get to the top! Heh? Get it?','We can never rest until we get to the top! Heh? Get it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66040,'We mantid are an elder race. The pandaren you associate with - they are but children. They have their role to play.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66041,'Each cycle, our young swarm their walls. The pandaren slay the weak. The strong return.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66042,'With each generation, we grow ever stronger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66043,'Hmmm, maybe I should have taken the cart in for its tune-up after all.','Hmmm, maybe I should have taken the cart in for its tune-up after all.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66044,'Before your history began, our empire was vast. We shared this world with our sister kingdoms, Ahn\'Qiraj and Azjol-Nerub.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66045,'Our Gods were many, and powerful. We mantid worshipped the seven heads of Y\'shaarj.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66046,'Great was the Old One, and terrible was His wrath. He consumed hope and begat despair; He inhaled courage and breathed fear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66047,'When the usurpers came - the ones you call \"Titans\" - Y\'shaarj was destroyed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66048,'His last terrible breath has haunted this land ever since, but the shadows he left behind are mere whispers of his former glory.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66049,'I tell you now, because you have earned this warning.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66050,'Your gods are not our gods, outsider.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66051,'If the Old Ones ever return, we mantid will once again stand by their side.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66052,'The wisest among you will do the same.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66053,'That is all that is to be said. Come, take your reward. And remember what you have learned today.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66054,'This day seems to be one full of hard decisions.  Having the courage to make them is gravely important, for the sake of us all.  I did what I had to do, and we may have all been doomed if I had not... but sadly, not all see it that way.$B$BIt is time for me to leave Shen-zin Su, that those here might be free from the burden of my difficult choice, and that I might fight on for the sake of a much larger world.$B$BI\'ve only known Korga a short time, but he and I could be brothers if he were born in different skin - he possesses bravery and honor that I would gladly stand beside.  You too could be my $gbrother:sister;, after all we\'ve been through together.  I\'m hoping you might join us, but I understand that there is much to consider.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66055,'','My family has crafted jade and gems for nearly ten generations. You may be surprised at what I can teach you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66056,'','I have to admit, that looked pretty fun!',0,0,0,0,0,0,0,0,1,0,0,27394,26124),
(66057,'','And it looks to me like you made a new friend.',0,0,0,0,0,0,0,0,1,0,0,27395,26124),
(66058,'','He was a tough one...',0,0,0,0,0,0,0,0,1,0,0,27396,26124),
(66059,'Hammer and tongs. Hammer and tongs. All day long its hammer and tongs.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66060,'There are healers under some of the wreckage!  Get them free.','',0,0,0,0,0,0,0,0,1,19275,27285,0,26124),
(66061,'Find the healers and get them free of the fight.  We need them here at the wound!','',0,0,0,0,0,0,0,0,1,19275,27286,0,26124),
(66062,'Stay close and keep these healers safe.  Our lives depend on it.','',0,0,0,0,0,0,0,0,1,19275,27287,0,26124),
(66063,'If we lose the healers, Shen-zin Su dies, and all of us with him!  Keep them safe.','',0,0,0,0,0,0,0,0,1,19275,27288,0,26124),
(66064,'Come friend, the Horde awaits.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66065,'Lets find out what this warchief of theirs is made of.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66066,'Together we can use the Horde\'s might to make a better world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66067,'|TInterface\\Icons\\warrior_talent_icon_lambstotheslaughter.blp:20|tYou are |cFFFF0000|Hspell:127275|h[Marked for Execution]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66068,'','<Aysa appears to be deeply lost in her excercises.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66069,'Ah! A luckydo comes to learn? I have many skills to teach.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66070,'|TInterface\\Icons\\spell_shaman_staticshock.blp:20|t %s begins to cast |cFFFF0000|Hspell:124967|h[Draw Power]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66071,'|TInterface\\Icons\\spell_shaman_staticshock.blp:20|t %s begins to cast |cFFFF0000|Hspell:119360|h[Draw Power]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66072,'','Ah! A fan of potions? The brewmasters work their concoctions but often miss some of the finer notes to a potion or remedy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66073,'You want Wikky?','You want Wikky?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66074,'You gots munchins?','You gots munchins?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66075,'Why you call Wikky?','Why you call Wikky?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66076,'What you want?','What you want?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66077,'Wikky hear whistle!','Wikky hear whistle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66078,'Why you wake Wikky?','Why you wake Wikky?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66079,'Wikky is here!','Wikky is here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66080,'Da Ook you want?','Da Ook you want?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66081,'Wikky is helpful!','Wikky is helpful!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66082,'What you want from Wikky?','What you want from Wikky?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66083,'Forage for me, Wikky!','Forage for me, Wikky!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66084,'Wikky be back soon!','Wikky be back soon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66085,'You the Ook!','You the Ook!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66086,'Wikky find presents!','Wikky find presents!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66087,'','Just because you put magic in to an artifact does not mean it has to stay there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66088,'Wikky is back!','Wikky is back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66089,'Yeah, you better run!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66090,'Wikky brings you presents!','Wikky brings you presents!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66091,'Wikky dids what you asks!','Wikky dids what you asks!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66092,'I\'m going to choke the life out of you, you little brats!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66093,'Wikky is helpful! See??','Wikky is helpful! See??',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66094,'Gonna bash you into pretty flower food!','Gonna bash you into pretty flower food!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66095,'Blackhoof will pound you into dust!','Blackhoof will pound you into dust!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66096,'Feel the strength of the Yaungol!','Feel the strength of the Yaungol!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66097,'I am seeing red!','I am seeing red!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66098,'You have woken the bull, now face the horns!','You have woken the bull, now face the horns!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66099,'DAK WILL BREAK YOU!','DAK WILL BREAK YOU!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66100,'My time with the Shado-Pan has taught me many secrets. Perhaps you have earned the right to learn some as well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66101,'You! What are you doing here?','You! What are you doing here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66102,'The night is dark and savage.','The night is dark and savage.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66103,'I will flay the flesh from your bones!','I will flay the flesh from your bones!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66104,'I will banish you to the land of wind and ghosts!','I will banish you to the land of wind and ghosts!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66105,'Feel the fist of darkness!','Feel the fist of darkness!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66106,'Your end is near.','Your end is near.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66107,'The darkness comes.','The darkness comes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66108,'Your souls will be MINE!','Your souls will be MINE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66109,'Break them.','Break them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66110,'You will feel pain.','You will feel pain.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66111,'I will crush your skull with my bare hands.','I will crush your skull with my bare hands.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66112,'Death! Doom! Destruction!','Death! Doom! Destruction!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66113,'The torture of a thousand screaming deaths awaits...','The torture of a thousand screaming deaths awaits...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66114,'More skulls for the pile...','More skulls for the pile...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66115,'Come, fodder, and meet your end.','Come, fodder, and meet your end.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66116,'No! I must report back to Her!','No! I must report back to Her!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66117,'Far from home, aren\'t you?','Far from home, aren\'t you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66118,'She will protect me!','She will protect me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66119,'I can sense your fear...','I can sense your fear...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66120,'My brethren are endless in number.','My brethren are endless in number.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66121,'The hatchlings will dine on your corpse!','The hatchlings will dine on your corpse!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66122,'The Mantid will cover this land, and devour all who oppose use!','The Mantid will cover this land, and devour all who oppose use!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66123,'The pool stirs...','The pool stirs...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66124,'The waters are restless...','The waters are restless...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66125,'You disrupt my meditations? You will pay...','You disrupt my meditations? You will pay...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66126,'I can see your end...','I can see your end...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66127,'The waters speak of your demise...','The waters speak of your demise...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66128,'If yer\' itchin\' ta learn a bit about smeltin\', I\'m yer dwarf!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66129,'The waves tremble at your approach...','The waves tremble at your approach...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66130,'The thundering depths call to you...','The thundering depths call to you...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66131,'You die!','You die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66132,'Stab stab stab stab stab!','Stab stab stab stab stab!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66133,'We take what we wish!','We take what we wish!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66134,'I will wear your skin as a hat!','I will wear your skin as a hat!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66135,'You should not have come here!','You should not have come here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66136,'No! My gold!!','No! My gold!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66137,'Who\'s there?','Who\'s there?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66138,'You brought strife to our lands! I will bring strife to you now!','You brought strife to our lands! I will bring strife to you now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66139,'This darkness in my heart, it is your doing!','This darkness in my heart, it is your doing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66140,'My vision is clouded, why have you done this to us?','My vision is clouded, why have you done this to us?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66141,'The death of this land ends with your life!','The death of this land ends with your life!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66142,'I must give in to the anger! It is the only way!','I must give in to the anger! It is the only way!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66143,'My training was for nothing, because of you!','My training was for nothing, because of you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66144,'The darkness in my soul screams for release!','The darkness in my soul screams for release!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66145,'Gonna ook you!','Gonna ook you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66146,'In the dooker!','In the dooker!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66147,'Gimme dem munchins!!','Gimme dem munchins!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66148,'Gonna hit you in the wikket!','Gonna hit you in the wikket!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66149,'You has ook for brains!','You has ook for brains!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66150,'Ha ha, you no touch Ik-Ik!','Ha ha, you no touch Ik-Ik!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66151,'Gonna blasts you to chunkies!','Gonna blasts you to chunkies!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66152,'Please, delicious animal, you come with Martar?','Please, delicious animal, you come with Martar?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66153,'Hey hey hey hey hey!','Hey hey hey hey hey!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66154,'Martar wants a furry buddy!!','Martar wants a furry buddy!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66155,'No! Martar\'s treasure is Martar\'s!','No! Martar\'s treasure is Martar\'s!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66156,'','This strange new land has much to offer in the form of herbs and remedies, if you know what to look for.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66157,'Lilian\'s Soul fades into the spirit realm! It can no longer be harmed!','Lilian\'s Soul fades into the spirit realm! It can no longer be harmed!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(66158,'The Emperor\'s Strength appears in the alcoves!','The Emperor\'s Strength appears in the alcoves!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66159,'Let no one pass!','',0,0,0,0,0,0,0,0,1,0,31464,0,26124),
(66160,'The Emperor\'s Courage appears in the alcoves!','The Emperor\'s Courage appears in the alcoves!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66161,'Don\'t let up. No mercy!','',0,0,0,0,0,0,0,0,1,0,31468,0,26124),
(66162,'Stand fast and slay the rest!','',0,0,0,0,0,0,0,0,1,0,31469,0,26124),
(66163,'So many hounds... we can\'t hold them back!','',0,0,0,0,0,0,0,0,1,0,31467,0,26124),
(66164,'I have failed... our sacred brotherhood...','',0,0,0,0,0,0,0,0,1,0,31466,0,26124),
(66165,'You come to see ol\' Tapin, eh? Hear \'bout my nickname? There was a time they called me \"the barber\" on account of my skill with skinnin\'.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66166,'Take this stone. It will help.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(66167,'Ready in 3...','Ready in 3...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66168,'2...','2...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66169,'1...','1...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66170,'Roll!','Roll!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66171,'You have left the roll course!','You have left the roll course!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66172,'Course complete!','Course complete!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66173,'Congratulations!','Congratulations!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66174,'You came in first!','You came in first!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66175,'You came in second!','You came in second!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66176,'You came in third!','You came in third!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66177,'Zach Chow grumbles.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66178,'<The mantid emerges from hiding.>$b$bStay back, $r.$b$bThe Empress is not of her right mind. We Klaxxi are gathering our numbers for an assault on her throne, but we are not yet prepared. And neither are you.$b$bThe time to strike is soon... but not yet.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(66179,'Thanks to your actions, the Hozen fear your people. Indulge me a moment...','',0,0,0,0,0,0,0,0,5,0,30065,0,26124),
(66180,'Ah! Here we are. Over 14,000 years ago, this entire land was ruled by a terrible race of warlords called \"the mogu.\"','',0,0,0,0,0,0,0,0,5,0,30066,0,26124),
(66181,'The mogu ruled through fear. And fear kept them in power... until the first Pandaren monks taught my people courage.','',0,0,0,0,0,0,0,0,5,0,30067,0,26124),
(66182,'Then the mogu were overthrown.','',0,0,0,0,0,0,0,0,5,0,30068,0,26124),
(66183,'You see, those who lead through fear only stay in power while those they govern lack courage.','',0,0,0,0,0,0,0,0,5,0,30069,0,26124),
(66184,'The hozen are many things, but they are not cowards - not for long. If you don\'t wish to fight them, you must... inspire them!','',0,0,0,0,0,0,0,0,5,0,30070,0,26124),
(66185,'I will help you, but first I would like to learn a little more about your people. Will you journey with me for a little while?','',0,0,0,0,0,0,0,0,5,0,30071,0,26124),
(66186,'Grant me your assistance, Iyyokuk. [Klaxxi Enhancement]','Grant me your assistance, Iyyokuk. [Klaxxi Enhancement]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66187,'Grant me your assistance, Swarmkeeper. [Klaxxi Augmentation]','Grant me your assistance, Swarmkeeper. [Klaxxi Augmentation]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66188,'Grant me your assistance, Locust. [Klaxxi Augmentation]','Grant me your assistance, Locust. [Klaxxi Augmentation]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66189,'Grant me your assistance, Manipulator. [Klaxxi Augmentation]','Grant me your assistance, Manipulator. [Klaxxi Augmentation]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66190,'Upon killing an enemy, you shall gain the usage of my Bladeturning ability. Let your foes try to strike you, and you shall strike them, instead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66191,'I serve his majesty, the last of his kind.$b$bIf you have a problem with me, take it up with the Prince.','I am just keeping my eyes open, $c. No harm in that.$b$bIf you have any news for me, I will pass it along. If not, you\'d best keep moving.',1,274,0,0,0,0,274,0,1,0,0,0,26124),
(66192,'Keep the mind open, aware. See opportunities. Exploit them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66193,'I have coated your weapons with my special mixture, Wakener. You will infect every corpse with a mutagen that... well... you must see the results for yourself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66194,'This tracking pheromone will reveal to you targets of great value.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66195,'Run them down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66196,'The key to victory is control, Wakener. Use my skills to dominate the mind of an enemy, and turn it into an ally.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66197,'I find it, you buy it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66198,'Move Closer to avoid |cFFFF0000|Hspell:127404|h[Golden Spear]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66199,'|TInterface\\Icons\\ability_hunter_pet_devilsaur.blp:20|tSlavemaster Hithiss increases the power of his allies with a |cFFFF0000|Hspell:127414|h[Primal Call]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66200,'Where... where is it? Worthless, useless... damn you!','',0,0,0,0,0,0,0,0,1,0,30272,0,26124),
(66201,'It was... a trap...','',0,0,0,0,0,0,0,0,1,0,30273,0,26124),
(66202,'Too easy!','',0,0,0,0,0,0,0,0,1,0,30274,0,26124),
(66203,'Were you even trying?!','',0,0,0,0,0,0,0,0,1,0,30275,0,26124),
(66204,'Haha, you die so easily!','',0,0,0,0,0,0,0,0,1,0,30276,0,26124),
(66205,'Pah! Those who failed deserved to die; you have merely culled the weak!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66206,'I must finish this myself, then.  So be it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66207,'|TInterface\\Icons\\spell_nature_lightningoverload.blp:20|tGeneral Zhun unleashes a |cFFFF0000|Hspell:127334|h[Wave of Pain]|h|r on his foes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66208,'Hold still, this won\'t hurt a bit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66209,'Ah, fresh meat for the dogs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66210,'Pierce the flesh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66211,'Blades, cut them to pieces!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66212,'Blood flow around me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66213,'Don\'t just sit there! Attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66214,'Stupid animals! I\'ll put you down after I kill these weaklings!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66215,'Meat for the pack.','',0,0,0,0,0,0,0,0,1,0,27552,0,26124),
(66218,'Release the hounds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66219,'I let the dogs out!','',0,0,0,0,0,0,0,0,1,0,27551,0,26124),
(66220,'No!','',0,0,0,0,0,0,0,0,1,0,27546,0,26124),
(66221,'My hound!','',0,0,0,0,0,0,0,0,1,0,27547,0,26124),
(66222,'How dare you!','',0,0,0,0,0,0,0,0,1,0,27548,0,26124),
(66223,'Ah, reinforcements!','',0,0,0,0,0,0,2,0,1,0,31516,0,26124),
(66224,'We\'ll squish you like bugs!','',0,0,0,0,0,0,22,0,1,0,31514,0,26124),
(66225,'We\'ve got your sap -- come and get it!','',0,0,0,0,0,0,22,0,1,0,31515,0,26124),
(66226,'Even together... we failed...','',0,0,0,0,0,0,0,0,1,0,28319,0,26124),
(66227,'Weakling!','',0,0,0,0,0,0,0,0,1,0,28325,0,26124),
(66228,'Lightning has no mercy!','',0,0,0,0,0,0,0,0,1,0,28326,0,26124),
(66229,'None may defy the Shado-Pan!','',0,0,0,0,0,0,0,0,1,0,28327,0,26124),
(66230,'Archers, attack!','',0,0,0,0,0,0,0,0,1,0,29435,0,26124),
(66231,'Keep firing! Let none escape!','',0,0,0,0,0,0,0,0,1,0,29437,0,26124),
(66232,'Another down, do not relent!','',0,0,0,0,0,0,0,0,1,0,29438,0,26124),
(66233,'Thanks for saving the festival, $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66234,'','Good work, $n. We couldn\'t have done it without you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66235,'','The yaungol are coming from every direction, $n! Quickly, defend the village before they burn it down!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66236,'The Shado-Pan need no outside aid! Remove these interlopers!','',0,0,0,0,0,0,0,0,1,0,27745,0,26124),
(66237,'|TInterface\\Icons\\ability_warstomp.blp:20|t %s begins to cast |cFFFF0000|Hspell:127480|h[Crushing Slam]|h|r! Get away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66238,'%s picks up a fallen weapon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66239,'Come! We cannot allow them to harm the Lorewalker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66240,'The Shado-Pan has many secrets. High among those is how to craft weapons and armor of surpassing quality.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66241,'Oh... my. That brew is a bit stronger than I had expected...','',0,0,0,0,0,0,64,0,1,0,0,0,26124),
(66242,'Oh... my. That brew is a bit stronger than I had expected... I...','',0,0,0,0,0,0,64,0,1,0,0,0,26124),
(66243,'Just need to rest my eyes a bit...','',0,0,0,0,0,0,12,0,1,0,0,0,26124),
(66244,'I serve only the Klaxxi\'va.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66248,'You have our thanks! I will see the Lorewalker safely to the Vale from here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66249,'A keg is returned! My humble thanks...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66250,'A precious barrel of Greenstone brew! Hurrah!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66251,'That\'ll teach those pests to pilfer our dojo\'s prized product!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66252,'Ah, back where it belongs. Thank you!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66253,'An adventurer saves the village, but a HERO returns the brew!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66254,'Our brilliant brew is back! You\'ve all our gratitude.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66255,'If you can venture into the surrounding forest and return any stolen barrels you find, I\'ll concoct a concentrated draft of marvelous power for you...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66256,'Good!  These pathetic initiates were boring me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66257,'Water Strider','Water Strider',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66258,'Quilen','Quilen',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66259,'Basilisk','Basilisk',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66260,'Crane','Crane',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66261,'Goat','Goat',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66262,'Porcupine','Porcupine',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66263,'Mighty fine hat!  I take it this is what you were looking for?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(66264,'Ta ta for now, friend!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66266,'1...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66267,'3...','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(66268,'Defenders of the Vale, we require your return to the Golden Pagoda in 30 minutes!','Defenders of the Vale, we require your return to the Golden Pagoda in 30 minutes!',0,0,0,0,0,0,0,0,1,18008,0,0,26124),
(66269,'Mogu forces surge at the main gate!  All defenders are to return to the Golden Pagoda in 15 minutes!','Mogu forces surge at the main gate!  All defenders are to return to the Golden Pagoda in 15 minutes!',0,0,0,0,0,0,0,0,1,18008,0,0,26124),
(66271,'Defenders, you have 5 minutes before you are recalled to the Golden Pagoda!','Defenders, you have 5 minutes before you are recalled to the Golden Pagoda!',0,0,0,0,0,0,0,0,1,18008,0,0,26124),
(66272,'Good, you\'ve returned.','Good, you\'ve returned.',0,0,0,0,0,0,0,0,1,18008,0,0,26124),
(66273,'Scouts report a mogu offensive in 30 minutes!  Clear the western vale!','Scouts report a mogu offensive in 30 minutes!  Clear the western vale!',0,0,0,0,0,0,0,0,1,18008,0,0,26124),
(66274,'Defenders, you have 15 minutes to clear the western vale!  Mogu raiding parties are leaving their camps!','Defenders, you have 15 minutes to clear the western vale!  Mogu raiding parties are leaving their camps!',0,0,0,0,0,0,0,0,1,18008,0,0,26124),
(66275,'Mogu are raiding the western vale in 5 minutes!  Defenders, this is your last chance to get clear!','Mogu are raiding the western vale in 5 minutes!  Defenders, this is your last chance to get clear!',0,0,0,0,0,0,0,0,1,18008,0,0,26124),
(66276,'I be jammon wit\' you, $n!','I be jammon wit\' you, $n!',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(66277,'|TInterface\\Icons\\spell_nature_agitatingtotem.blp:20|tGara\'jal summons a Spirit Totem. Use it to |cFFFF0000|Hspell:116161|h[Cross Over]|h|r to the Spirit World!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66278,'|TInterface\\Icons\\spell_nature_agitatingtotem.blp:20|tGara\'jal summons a Spirit Totem. Use it to |cFFFF0000|Hspell:116260|h[Cross Over]|h|r to the Spirit World!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66279,'$n prepares a Banquet of the Brew!','$n prepares a Banquet of the Brew!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66280,'$n prepares a Banquet of the Grill!','$n prepares a Banquet of the Grill!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66281,'$n prepares a Banquet of the Oven!','$n prepares a Banquet of the Oven!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66282,'$n prepares a Banquet of the Pot!','$n prepares a Banquet of the Pot!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66283,'$n prepares a Banquet of the Steamer!','$n prepares a Banquet of the Steamer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66284,'$n prepares a Banquet of the Wok!','$n prepares a Banquet of the Wok!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66285,'$n prepares a Great Banquet of the Brew!','$n prepares a Great Banquet of the Brew!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66286,'$n prepares a Great Banquet of the Grill!','$n prepares a Great Banquet of the Grill!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66287,'$n prepares a Great Banquet of the Oven!','$n prepares a Great Banquet of the Oven!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66288,'$n prepares a Great Banquet of the Pot!','$n prepares a Great Banquet of the Pot!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66289,'$n prepares a Great Banquet of the Wok!','$n prepares a Great Banquet of the Wok!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66290,'$n prepares a Great Banquet of the Steamer!','$n prepares a Great Banquet of the Steamer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66291,'$n prepares a Pandaren Banquet!','$n prepares a Pandaren Banquet!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66292,'$n prepares a Great Pandaren Banquet!','$n prepares a Great Pandaren Banquet!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66293,'I have heard of your \"heroism,\" Locust. They say your raids on mogu labor camps and farmlands delayed the completion of the wall by decades.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66294,'I cannot argue with your results, but how can a proud warrior of the swarm make his name chasing down fleeing peasants and farmhands?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66295,'Easily: You don\'t have to leap as far between kills.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66296,'Bloodseeker, your regenerative powers fascinate me. I wonder if you would consent to a few tests.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66297,'What kind of tests?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66298,'Just a little cellular trauma induction, maybe a few tissue samples, a session of micro-sonic deep gene-probing. Nothing terribly invasive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66299,'What was that last part?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66300,'Tissue samples?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66301,'After that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66302,'Nothing terribly invasive?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66303,'We are done talking.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66304,'How does it feel to go rogue a second time, Swarmkeeper? Your empress was also gripped by paranoia, was she not?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66305,'Grand Empress Zek\'hara masked her true intentions behind the guise of matronly worry. She claimed her overbearing ways were necessary to protect us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66306,'In reality, she was obsessed with control. She aspired to stay in power long past her time, and was willing to sacrifice our eternal cycle to achieve that. We had no choice but to end her.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66307,'Of course.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66308,'And having seen what Grand Empress Shek\'zeer is doing to our land... I need no convincing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66309,'I served Shek\'zeer for a time, you know. Before I was preserved. Her madness is nothing so rational as ambition.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66310,'When she tried to forbid the swarm, it was to prevent, as she put it, \"a senseless loss of life.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66311,'She trusts no one. Paranoia gnaws at her mind. She is driven by fear unrelenting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66312,'How does it feel? I have no regrets, if that is what you are asking. I am honored to serve the will of the Klaxxi.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66313,'It is an honor to serve alongside you, Prime. I have studied your work extensively.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66314,'Thanks to the careful notes you kept while developing the preservation chamber, I was able to create a modified version that could preserve Kovok here as well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66315,'Yes, he certainly looks... healthy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66316,'I never imagined my work would go so far. It is a testament to the great power of the kypari. Our civilization would never have recovered if it weren\'t for them. Remember that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66317,'That is quite an impressive beast you have there, Manipulator. Very intriguing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66318,'No.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66319,'All those years in stasis followed by sudden, rapid growth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66320,'Do not even ask.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66321,'I am just saying... I bet his genes tell quite a story...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66322,'And I am just saying, Dissector, that you do not appear to possess any resistance to sonic manipulation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66323,'How would you like to suddenly become \"intrigued\" by your own thorax? I bet your skilled hands could perform a self-vivisection in mere seconds if they were properly compelled.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66324,'Point taken.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66325,'Grrr... I need to kill something. All this waiting around is driving me crazy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66326,'Quiet, you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66327,'Monks, doesn\'t all that rolling make you dizzy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66328,'Hozen are not always the best brewers, but the ones on Unga Ingoo somehow steal the best ingredients.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66329,'','Welcome to Tian Monastery.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66330,'Ow! Ow! Ow!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66331,'','Good to see you, $n! My students and I came to try Brewmaster Boof\'s famous brew and to celebrate the brewmoon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66332,'','As mistweavers, we must always protect those in need.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66333,'','Mistweaver Nian is a strict teacher but has a kind heart.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66334,'','Sisters, the village need our help. Head to the front lines and heal the wounded!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66335,'','Yes, ma\'am!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66336,'They intend to execute Lorewalker Fu! Please, you must help me stop them...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66337,'If the Lorewalker is slain, many of us will have died for nothing...\n\nWill you accompany me to stop the execution?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66338,'Let\'s go save him.','Let\'s go save him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66339,'Xuen has taught us the meaning of strength.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66340,'It is good to see everyone in such high spirits.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66341,'The festival reminds me of how beautiful Kun-Lai is.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66342,'Greetings, $n. Are you enjoying the festival?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66343,'We must defend the villagers! I will take the front gates, the rest of you spread out and don\'t let any yaungol get past you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66345,'Are these serpent hatchlings suitable for pet battles?','Are these serpent hatchlings suitable for pet battles?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66346,'','I see we have a pet battler here in our training grounds.  Cloud serpents are cut out to do almost anything, including fighting other pets!  The key to finding the hatchlings is building a friendship with an adult.  Once you are exalted with the order, you will find them scattered across the arboretum.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66347,'Two titanic constructs appear in the large alcoves!','Two titanic constructs appear in the large alcoves!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66348,'For the glory of General Zhun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66349,'In the name of the Thunder King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66350,'I\'ll have your head!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66351,'My blade is peerless!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66352,'You DARE stand before a student of Scrollmaster Fon?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66353,'Your agony will be BOUNDLESS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66354,'I\'ll crush your skull!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66355,'I\'m going to break every bone in your body!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66356,'Thanks for the assist, friend. I\'d better report back to Bowmistress Li.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66357,'Hrgghh!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66358,'You think me to be mad, do you? Yes... yes, perhaps a little.$b$bYou see, even after eight hundred and seventy-seven years of quietude, the desire to breathe does not go away.$b$bPerhaps something went wrong with my encasement. Perhaps it was my... preternaturally keen intellect. Whatever the cause, I was fully aware of the passage of time during my years in the amber.$b$bAfter seventy-eight years, I stopped trying to escape. I kept my mind sharp by creating and solving puzzles. The amber took care of the rest of my body.$b$bBut my sanity? No, I cannot say with good confidence that it survived intact.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66359,'Intruders! The prisoner cages are under attack... send reinforcements!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66360,'The Klaxxi said they needed someone to continue punishing fools in a future generation.$B$BI told them, \"I\'m your mantid.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66361,'There are intruders within the temple!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66362,'Alarm! Trespassers have entered the temple!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66363,'The temple walls have been breached!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66364,'The temple has been infiltrated! Alarm! ALARM!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66365,'MASTERS! Intruders in the temple!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66366,'Alarm, my masters! INTRUDERS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66367,'The temple is breached, masters! ALARM!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66368,'Alarm, oh great masters! ALARM!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66369,'A small fee for supplies is required.','A small fee for supplies is required.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66370,'The shield is engraved: Sentinel Ku-Yao. It belongs to the boy\'s father.','The shield is engraved: Sentinel Ku-Yao. It belongs to the boy\'s father.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66371,'Ku-Yao\'s bedroll is empty. He\'s not here.','Ku-Yao\'s bedroll is empty. He\'s not here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66372,'This is Ha-Cha, Sentinel Ku-Yao\'s yak.','This is Ha-Cha, Sentinel Ku-Yao\'s yak.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66373,'You\'re looking for Ku-Yao? I haven\'t seen him in days. You don\'t think he\'s in trouble, do you?','You\'re looking for Ku-Yao? I haven\'t seen him in days. You don\'t think he\'s in trouble, do you?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(66374,'Thanks for your help, $gmister:ma\'am;. I\'m going to keep looking for my dad now.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(66375,'I hope I find him.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(66376,'You... Shado-Pan. You\'re here to help me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66377,'My son... he\'s here? Alive!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66378,'Yes. Your son, Ku-Mo, has been looking for you.','Yes. Your son, Ku-Mo, has been looking for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66379,'He\'s at the Shado-Pan Garrison right now. Here\'s a kite. Go see him!','He\'s at the Shado-Pan Garrison right now. Here\'s a kite. Go see him!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66380,'Return to the Burlap Trail!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66381,'Three players are needed to cleanse the Pool of Life!','Three players are needed to cleanse the Pool of Life!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66382,'Dad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66383,'I brought you your crossbow, Dad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66384,'Now you can shoot the mantid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66385,'This chunk of amber may be exactly what the Klaxxi are looking for.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66386,'I think I\'m done fighting for a while, Ku-Mo.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66387,'Really?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66388,'Come on. I think it\'s time to go home.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66389,'You should keep that crossbow, Ku-Mo.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66390,'Whoah...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66391,'Even in my sleep, I hear her terror.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66392,'Fear grips her mind and body. The Empress is no longer fit to rule the empire.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66393,'The time of awakening must be near, but they have not yet come for me. Why do the Klaxxi wait?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66394,'A presence approaches! Someone out there can hear me! But... it is no Klaxxi.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66395,'Yes! Break it! Free me from this amber sleep!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66397,'Abandon Fel Imp','Abandon Fel Imp',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(66398,'Abandon Voidlord','Abandon Voidlord',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(66399,'Abandon Shivarra','Abandon Shivarra',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(66400,'Abandon Observer','Abandon Observer',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(66401,'Abandon Wrathguard','Abandon Wrathguard',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(66402,'Speak to me when you are ready to try again.','Speak to me when you are ready to try again.',0,0,0,0,0,0,0,0,1,17968,0,0,26124),
(66403,'Extinguished!','',0,0,0,0,0,0,0,0,1,0,29001,0,26124),
(66404,'Does that make you angry?','',0,0,0,0,0,0,0,0,1,0,29002,0,26124),
(66405,'Feel your rage!','',0,0,0,0,0,0,0,0,1,0,29003,0,26124),
(66406,'Let your rage consume you!','',0,0,0,0,0,0,0,0,1,0,29004,0,26124),
(66407,'Feed me with your ANGER!','',0,0,0,0,0,0,0,0,1,0,29010,0,26124),
(66408,'My fury is UNLEASHED!','',0,0,0,0,0,0,0,0,1,0,29011,0,26124),
(66409,'I will drop you near the tower. Do not get used to this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66410,'The tower is just there. I will cover you from the sky. Be quick.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66411,'You hear a grinding noise coming from the elevator shaft!','You hear a grinding noise coming from the elevator shaft!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66412,'Time for a little open-heart surgery!','',0,0,0,0,0,0,0,0,1,0,29443,0,26124),
(66413,'Donate...my body...to science...','',0,0,0,0,0,0,0,0,1,0,29444,0,26124),
(66414,'Another successful operation!','',0,0,0,0,0,0,0,0,1,0,27760,0,26124),
(66415,'I think it\'s time to go for a Randall P. walk.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66416,'Hmm... no path. Guess I\'ll have to Randall P. swim.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66417,'That was enjoyable. Now it\'s time for a Randall P. rest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66418,'|TInterface\\Icons\\item_earthenmight.blp:20|t %s begins to cast |cFFFF0000|Hspell:128107|h[Raise Earth]|h|r!  Watch out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66419,'Looks like it\'s time to Randall P. jump.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66420,'Yes, Klaxxi\'va. How long I have waited to hear the Council\'s command!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66421,'I see. Much has transpired since I first entered my long sleep.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66422,'You will not disrupt the tuning!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66423,'What is the source of YOUR power? Think carefully before you answer. Many adventurers point to their weapons, or their equipment, or to tomes of arcane might.','',1,1,0,0,500,0,0,0,5,0,30121,0,26124),
(66424,'Long ago, when my people were slaves of the mogu empire, we were forbidden from carrying any weapon at all. We were not fighters. And no one believed we could fight the mogu without magic and steel.','',1,1,0,0,500,0,0,0,5,0,30122,0,26124),
(66425,'Until Kang, the First of First Dawn, opened our eyes.','',1,1,0,0,500,0,0,0,5,0,30123,0,26124),
(66426,'One day, the beloved monk issued a challenge to his fellow slaves. \"Hit me!\" he called out.','',1,1,0,0,500,0,0,0,5,0,30124,0,26124),
(66427,'Surprised, the beleaguered Pandaren slaves tried to strike Kang. One by one they failed, for he intercepted their blows like a dancer and sidestepped their attacks like a reed in the wind.','',1,1,0,0,500,0,0,0,5,0,30125,0,26124),
(66428,'\"Our backs are hardened by the whips of the mogu,\" he told them. \"Our arms are powerful from building their fortresses. Our minds are sharp from working alongside our enemy. You think the mogu are stronger? I say we are their strength!\"','',1,1,0,0,500,0,0,0,5,0,30126,0,26124),
(66429,'The farmers, the bricklayers, the shepherds and the smiths... they all bowed before Kang. \"Teach us,\" they said. \"Teach us to fight.\"','',1,1,0,0,500,0,0,0,5,0,30127,0,26124),
(66430,'And when they rose... they rose as warriors.','',1,1,0,0,500,0,0,0,5,0,30128,0,26124),
(66431,'Your voice. Your hands. THESE are the tools of true heroes. Use them well... and you can change the world.','',1,1,0,0,500,0,0,0,5,0,30129,0,26124),
(66432,'Jump to prevent the resin from hardening!','Jump to prevent the resin from hardening!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66433,'Pitiful, wingless grubs. You step out into my domain, and I will hear your death screams as you plummet from this terrace!','',0,0,0,0,0,0,0,0,1,0,30348,0,26124),
(66434,'Set\'thik, in formation! Show them who controls the winds of Pandaria!','',0,0,0,0,0,0,0,0,1,0,30349,0,26124),
(66435,'Breath of the empress, bring mighty Garalon to us!','',0,0,0,0,0,0,0,0,1,0,30350,0,26124),
(66436,'Garalon, grind their bones to dust!','',0,0,0,0,0,0,0,0,1,0,30351,0,26124),
(66437,'Impossible! Sri\'thik, Zar\'thik, Kor\'thik, to the top of the terrace! We must defend the Empress!','',0,0,0,0,0,0,0,0,1,0,30352,0,26124),
(66438,'I assume you are here about the dragon turtles, child?  I am sorry.  I cannot help you until you prove yourself a loyal ally of my people.','I assume you are here about the dragon turtles, child?  I am sorry.  I cannot help you until you prove yourself a loyal ally of my people.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66439,'I assume you are here about the dragon turtles, child?','I assume you are here about the dragon turtles, child?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66440,'What dragon turtles are for sale?','What dragon turtles are for sale?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66441,'The Horde wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66442,'The Alliance wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66443,'I hope they make it this far. Then my strength and skill will be clear to all!','',0,0,0,0,0,0,0,0,1,0,29392,29392,26124),
(66444,'Ah-hah! The lot of you will soon wish you hadn\'t come this way...','',0,0,0,0,0,0,0,0,1,0,29390,29390,26124),
(66445,'But... I was... who will...?!','',0,0,0,0,0,0,0,0,1,0,29391,29391,26124),
(66446,'Your carved bones will decorate the weapons of our warriors!','',0,0,0,0,0,0,0,0,1,0,29393,29393,26124),
(66447,'Did you think you stood a chance?!','',0,0,0,0,0,0,0,0,1,0,29394,29394,26124),
(66448,'Allow me to show you the power of amber alchemy...','',0,0,0,0,0,0,0,0,1,0,29395,29395,26124),
(66449,'Welcome, outsiders. Master Snowdrift is waiting for you inside the school. Please remember to show proper respect to the Master.','Welcome, outsiders. Master Snowdrift is waiting for you inside the school. Please remember to show proper respect to the Master.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66451,'It appears that Empress Shek\'zeer has let our empire fall into chaos. This we must address. But first, I must regain my strength.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66452,'Did I not say that my wings were swift? You move most slowly, Wakener.','',0,0,0,0,0,0,0,0,1,17110,0,0,26124),
(66453,'The nearby forces of the Scarlet Crusade stand ready to assist their Commander if he is attacked.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66454,'2...','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(66455,'Sure is a nice day today.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66456,'You like walking? I like walking.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66457,'I\'ve lost track of how long we\'ve been walking now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66458,'Oh! When did you get here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66459,'Nothing gets your blood flowing quite like a long, slow walk.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66460,'Before you ask: no, we are not there yet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66461,'I hope you\'re enjoying this as much as I am.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66462,'A walk always goes faster when you have a friendly $r $c by your side.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66463,'I think I\'ve stayed here long enough. Would you like to go on a walk with me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66464,'A walk? Sure!','A walk? Sure!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66465,'Welcome to my shop, traveler!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66466,'Ah! So you seek items of wonder? Well you have come to the right place!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66467,'Feel free to browse, but do not feel free to touch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66468,'Perhaps I can interest you in a magic map? Oh nevermind, we\'re all sold out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66469,'May the winds guide your journey!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66471,'Good luck to you, friend!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66472,'Purged by fire!','',1,0,0,0,0,0,0,0,1,0,29528,0,26124),
(66473,'Where\'d you get that weapon from, your sister?','',0,0,0,0,0,0,396,0,0,0,27939,0,26124),
(66474,'Where\'d you get that weapon from, your sister?','',0,0,0,0,0,0,396,0,0,0,27954,0,26124),
(66475,'What makes you think I would sell to you, outsider?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66476,'Wait. The Klaxxi speak to me. Yes, Council, I have heard the Empress\'s intentions. Her reign must end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66477,'Tell me no more, Council. I will see my old home with my own eyes. I would gaze upon the ruin that Shek\'zeer has wrought.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66478,'Right away, Klaxxi\'va.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66479,'Before I was cast in amber, I made a great gamble.$B$BI realized the amber could perform a miracle that I would never achieve, not even with a thousand years of careful experimentation.$B$BBefore I became a paragon, I injected myself with a dozen lethal poisons. The life-giving properties of amber protected me as I guessed, and time did the rest.$B$BAnd now, I can handle any poison I desire without fear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66480,'This soft one should serve well. Come, Wakener.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66481,'That\'s a good question. We\'re a strange lot... not many pandaren choose to live on this side of the wall.$b$bIn short, we\'re making beer. Not just any beer, though... beer brewed with the sap of the great kypari trees.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66482,'...disgusting, I know. But it\'s not.$b$bThe amber that these trees produce has amazing healing properties. The mantid can\'t get enough of it. They consume it, they use it in their weapons and architecture... I\'ve even heard legends that they embalm their great heroes in the stuff.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66483,'Exactly. The traditions of the sapmasters reach back through countless generations. I am but one link in a chain of sap-thirsty pandaren.$b$bSometimes, however, I fear that I may be the final link.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66484,'The trees are dying. Kypari Vor is already dead... a victim of the sha. It will never again produce amber. It barely even looks like a tree anymore.$b$bThe few amber-producing trees that remain are either being overharvested by the mantid, or in danger of succumbing to sha. Either way, no more sap means no more sapmasters. At which point, I\'d have to return to my old job.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66485,'Dumpling presser.$b$b<Vu sighs.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66486,'What are you doing here?','What are you doing here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66487,'Beer made with sap? That sounds...','Beer made with sap? That sounds...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66488,'And you make beer out of it.','And you make beer out of it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66489,'Why is that?','Why is that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66490,'What was your old job?','What was your old job?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66491,'The %s is |cFFFF0000|Hspell:128419|h[Gathering Speed]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66492,'Don\'t let up! No mercy!','',0,0,0,0,0,0,0,0,1,0,31468,0,26124),
(66493,'Stand fast and slay the rest!','',0,0,0,0,0,0,0,0,1,0,31469,0,26124),
(66496,'Pah! Those who failed deserved to die; you have merely culled the weak!','',0,0,0,0,0,0,0,0,1,0,30262,0,26124),
(66497,'%s is woken from its slumber by the sound of combat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66498,'Om nom nom nom...','',0,0,0,0,0,0,466,0,1,0,0,0,26124),
(66499,'So... SWEET!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(66500,'So many SEEDS!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(66501,'So... SPICY!!!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(66502,'Please insert vegetation......','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(66503,'Insert a stack of Ginseng.','Insert a stack of Ginseng.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(66504,'Insert a stack of Juicycrunch Carrots.','Insert a stack of Juicycrunch Carrots.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(66505,'Insert a stack of Green Cabbage.','Insert a stack of Green Cabbage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(66506,'Insert a stack of Jade Squash.','Insert a stack of Jade Squash.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(66507,'Insert a stack of Mogu Pumpkins.','Insert a stack of Mogu Pumpkins.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(66508,'Insert a stack of Pink Turnips.','Insert a stack of Pink Turnips.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(66509,'Insert a stack of Red Blossom Leeks.','Insert a stack of Red Blossom Leeks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(66510,'Insert a stack of Scallions.','Insert a stack of Scallions.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(66511,'Insert a stack of Striped Melons.','Insert a stack of Striped Melons.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(66512,'Insert a stack of White Turnips.','Insert a stack of White Turnips.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(66513,'Insert a stack of Witchberries.','Insert a stack of Witchberries.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(66514,'The Vegetron 4000 is recharging, try again later.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(66515,'Fighting make me... HUNGRY!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(66516,'Intruders by the pool of life!  Don\'t let them escape!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66517,'Ggrgll!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66518,'Wait what...?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66519,'Mmmphhh','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66520,'Help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66521,'The mantid are coming over the wall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66522,'%s sees the opportunity to splash Toxic Hivebomb in the whirlwind!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66523,'Powerful Throw incoming! Don\'t get knocked off the mountain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66524,'Give me the resonating crystal you puny little bark eater!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66525,'I should have known you would not come alone Kor\'ik.','',0,0,0,0,0,0,0,0,1,18531,0,0,26124),
(66526,'|TInterface\\Icons\\ability_druid_ravage.blp:20|t Garalon fails to hit at least two players and gains |cFFFF0000|Hspell:122754|h[Fury]|h|r!','|TInterface\\Icons\\ability_druid_ravage.blp:20|t Garalon fails to hit at least two players and gains |cFFFF0000|Hspell:122754|h[Fury]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66527,'It is fitting that I be the one to destroy the pet of the Klaxxi!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66528,'Come outsider! Fight me if you dare!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66529,'Fire the cannons to kill the bombardiers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66530,'It was foolish of you to interrupt, outsider.','',0,0,0,0,0,0,0,0,1,18532,0,0,26124),
(66531,'Is he gone? Is it over?','',0,0,0,0,0,0,0,0,1,18130,0,0,26124),
(66532,'The colossus is injured! Don\'t stop striking!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66533,'It\'s nearly defeated! Keep punching!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66534,'This is not over...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66535,'What does a servant of the Klaxxi require?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66536,'Take me to the Briny Wastes.','Take me to the Briny Wastes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66537,'You wish to pay me tribute? Then pay it in blood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66538,'I need to travel somewhere.','I need to travel somewhere.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66539,'Take me to the Lake of Stars.','Take me to the Lake of Stars.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66540,'[Right Click] on the trainee\'s weapon in your inventory to equip it.\nThe default key to open your bags is [B]','[Right Click] on the trainee\'s weapon in your inventory to equip it.\nThe default key to open your bags is [B]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66541,'Our work here is finished for now. Let us deliver news of our victory to the Klaxxi Council. They await our return.','',0,0,0,0,0,0,0,0,1,17347,0,0,26124),
(66542,'You impress me, my young student. You have great strength in you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66543,'What is happening? Why do we swarm so soon?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66544,'No, no... this swarm is too early. I must speak with the Adjunct!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66545,'Why am I... here...?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66546,'Where are we? We were... swarming?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66547,'The pandaren were prepared. This attack was folly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66548,'This is wrong. It is not yet time to swarm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66549,'This wall cannot stop the might of the mantid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66550,'I carry out her will! We shall crumble this wall and devour the lands beyond!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66551,'You wouldn\'t happen to have another bundle of that incense would you?','You wouldn\'t happen to have another bundle of that incense would you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66552,'I\'ll keep the ship here as long as I can.$B$BBe safe!','',396,66,0,0,4,0,0,0,1,0,0,0,26124),
(66553,'We\'ll defend the ship and crew for as long as we\'re able.$B$BDon\'t worry about us!','We\'ll defend the ship and crew for as long as we\'re able.$B$BDon\'t worry about us!',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(66554,'What happened here?!$B$BLady Proudmoore\'s tower is just... gone!','What happened here?!$B$BLady Proudmoore\'s tower is just... gone!',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(66555,'What a disaster!$B$BWhat could have done this?!','What a disaster!$B$BWhat could have done this?!',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(66556,'I wonder if anyone survived...','I wonder if anyone survived...',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(66557,'Did the Horde do this?!$B$BLight save us all...','Did the Horde do this?!$B$BLight save us all...',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(66558,'By the Light... Theramore! What has happened here?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66559,'Abe, get below deck and hide. Everyone else, keep watch and be ready for an attack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66560,'If someone\'s bold enough to investigate, we\'ll keep the ship here as long as we can.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66561,'Y-yes sir!','',396,66,0,0,4,0,0,0,1,0,0,0,26124),
(66562,'','Captain! Please keep your crew safely on board. We\'ll defend the ship if it\'s attacked.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66563,'That\'s a ship! An ALLIANCE ship!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66564,'I don\'t care! I\'M KILLING EVERYTHING ON BOARD! Move it, grunts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66565,'','Merely a transport, Grud. Not a warship.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66566,'I\'ve always wondered what lay behind these gates.','I\'ve always wondered what lay behind these gates.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66567,'Just look at this place! It\'s amazing!','Just look at this place! It\'s amazing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66568,'I heard some hero from a far away land convinced Xuen, the tiger god, to open the Vale. Maybe I\'ll see them someday.','I heard some hero from a far away land convinced Xuen, the tiger god, to open the Vale. Maybe I\'ll see them someday.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66569,'The Shado-Pan told us this would be a safe haven for all the refugees from Kun-Lai. Perhaps here, we shall finally find peace.','The Shado-Pan told us this would be a safe haven for all the refugees from Kun-Lai. Perhaps here, we shall finally find peace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66570,'I heard all kinds of stories about what lay behind the gate. I never imagined it would be something like this.','I heard all kinds of stories about what lay behind the gate. I never imagined it would be something like this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66571,'Perhaps we can find a new home here in the Vale.','Perhaps we can find a new home here in the Vale.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66572,'','Here they come, Halters! Get ready!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66573,'Was this really the home of the ancient emperors of Pandaria? It is beautiful.','Was this really the home of the ancient emperors of Pandaria? It is beautiful.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66574,'To have witnessed the opening of the gates... it is a tale I will pass down to my children\'s children.','To have witnessed the opening of the gates... it is a tale I will pass down to my children\'s children.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66575,'FOR THERAMORE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66576,'There is a glint of light coming from something on the creature\'s back.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66577,'Take the object.','Take the object.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66578,'There is much damage to repair.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66579,'Kor\'ik was just the first to betray us. No one can be trusted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66580,'War has come, Wakener.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66581,'The creature\'s shell is glinting with light.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66582,'What can Jaluu do you for today?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66583,'Always strive to achieve the impossible.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66584,'May you seek honor and courage in all your days, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66585,'Only to the most trusted allies do we reveal the Golden Lotus\'s deepest secrets.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66586,'You are like... piece of iron...','',0,0,0,0,0,0,0,0,1,0,29497,0,26124),
(66587,'Welcome to the Vale, friend. Stay and be at peace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66588,'AID ME!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66589,'','Good fortune to you, $r. Here you will find representatives from all the factions of Pandaria. When you have had a little more experience under your belt, come back and speak to us. Great adventures and great rewards await.',0,0,0,0,0,0,0,0,1,13442,0,0,26124),
(66590,'','May a lucky star shine upon you, $c. Here you will find representatives from all the factions of Pandaria. Speak to them to find out if you are the brave adventurer that they seek.',0,0,0,0,0,0,0,0,1,54164,0,0,26124),
(66591,'What is this place?','What is this place?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66592,'ALARM! Alliance approach from the harbor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66593,'Move it, you dogs!','Move it, you dogs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66594,'Hurry it up, peons!','Hurry it up, peons!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66595,'Faster, dogs, or you\'ll get THE BOOT!','Faster, dogs, or you\'ll get THE BOOT!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66596,'Go! GO, you lazy worms!','Go! GO, you lazy worms!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66597,'','Welcome, traveler. Make your home here if you wish. Upstairs you will find the bank vaults and the city portals. Vendors of all trades have set up shop around the building. Please explore at your own leisure.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66598,'What can I find here in the city?','What can I find here in the city?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66599,'Need a little fortune in your favor, $r? Everyone needs a little luck to spruce things up!$B$BDon\'t worry, I can help tweak the odds in your favor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66600,'Welcome, $r. Here you will find representatives from all the factions of Pandaria. When you have had a little more experience under your belt, come back and speak to us. Great adventures and great rewards await.','',0,0,0,0,0,0,0,0,1,13442,0,0,26124),
(66601,'Welcome, $r. Here you will find representatives from all the factions of Pandaria. Speak to them to find out if you are the brave adventurer that they seek.','',0,0,0,0,0,0,0,0,1,54164,0,0,26124),
(66602,'Oh, ho! Oh ho ho.$B$BYo ho ho, even.$B$BI just come back from the land of Pandaria, with its rolling hills and harsh mountains, and the strangest rum I ever tasted.  I crashed me ship into the Jade Forest and me cargo made the land uninhabitable, but in the meantime I can take ye to the Valley of the Four Winds, lickey-split.$B$BDo yeh trust me, $c?','',0,0,0,0,0,0,0,0,1,0,7394,0,26124),
(66603,'Yarrrr, yeh don\'t want none of what I be dealin\', $gSonny:missy;.$B$BBegone wit\' yeh!','',0,0,0,0,0,0,0,0,1,0,7394,0,26124),
(66604,'Good work. Keep it up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66605,'Well done. Not much more!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66606,'Finish here first, and there\'ll be rum for all of you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66607,'Such energy. Excellent!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66608,'You\'re from that ship? Bad move. Theramore is HORDE land, now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66609,'Yarr, the Adm\'rl sent me here to sell ya some of the booty we plundered from the Jade Forest.  He thought it might \'elp you on yer journey.$B$BIf ye want I can also take ye back to the mainland.','',0,0,0,0,0,0,0,0,1,0,7394,0,26124),
(66613,'Valley of the Four Winds','Valley of the Four Winds',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66614,'What do you have for sale?','What do you have for sale?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66615,'Your end is near!','',0,0,0,0,0,0,0,0,1,0,31222,0,26124),
(66616,'When you are dying, beast, remember that I gave you a choice.','',0,0,0,0,0,0,0,0,1,0,31224,0,26124),
(66617,'Vendors from all over the land have found their way into the city. What are you looking for?','Vendors from all over the land have found their way into the city. What are you looking for?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66618,'Don\'t see what you need in the city?$B$BWhat are you looking for? Maybe I can help you find it.','Don\'t see what you need in the city?$B$BWhat are you looking for? Maybe I can help you find it.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66619,'Oh, looking for your class trainer? Unfortunately none of them have made it here to the Vale of Eternal Blossoms.$B$BYou can return to your home city to find those.','Oh, looking for your class trainer? Unfortunately none of them have made it here to the Vale of Eternal Blossoms.$B$BYou can return to your home city to find those.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66620,'Looking for a professions trainer?$B$BThe zen master trainers can be found all across Pandaria. Tell me who you are looking for.$B$BIf you cannot find the person you seek here in Pandaria, you may also seek professions masters in your home city. They should also be able to improve your skill in your craft.','Looking for a professions trainer?$B$BThe zen master trainers can be found all across Pandaria. Tell me who you are looking for.$B$BIf you cannot find the person you seek here in Pandaria, you may also seek professions masters in your home city. They should also be able to improve your skill in your craft.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66621,'You seek Silkmaster Tsai at the Silken Fields in the Valley of the Four Winds. I will mark his location on your map for you.','You seek Silkmaster Tsai at the Silken Fields in the Valley of the Four Winds. I will mark his location on your map for you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66622,'You can improve your fishing skill by visiting Nat Pagle at the Anglers Wharf in the Krasarang Wilds. Let me mark the location for you.','You can improve your fishing skill by visiting Nat Pagle at the Anglers Wharf in the Krasarang Wilds. Let me mark the location for you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66623,'There are master miners located at the Greenstone Quarry in the Jade Forest. They can probably help you improve your skill. I will mark the location on your map.','There are master miners located at the Greenstone Quarry in the Jade Forest. They can probably help you improve your skill. I will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66624,'You can find a leatherworking trainer at the Grummle Bazaar in Kun-Lai Summit. I will mark the location on your map.','You can find a leatherworking trainer at the Grummle Bazaar in Kun-Lai Summit. I will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66625,'I have heard there are master alchemists among the Klaxxi, far over the wall in the Dread Wastes. I will mark the location on your map for you.','I have heard there are master alchemists among the Klaxxi, far over the wall in the Dread Wastes. I will mark the location on your map for you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66626,'There is a skinning trainer at Nesingwary\'s Safari in the Valley of the Four Winds.$B$BI will mark their location on your map.','There is a skinning trainer at Nesingwary\'s Safari in the Valley of the Four Winds.$B$BI will mark their location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66627,'For your enchanting needs, you must speak to Lai the Spellpaw at Dawn\'s Blossom in The Jade Forest.$B$BI will mark the location on your map.','For your enchanting needs, you must speak to Lai the Spellpaw at Dawn\'s Blossom in The Jade Forest.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66628,'You can find the person you seek at Nesingwary\'s Safari in the Valley of the Four Winds.$B$BI will mark their location on your map.','You can find the person you seek at Nesingwary\'s Safari in the Valley of the Four Winds.$B$BI will mark their location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66629,'You must be seeking Zen Master Lao! He is working at the Setting Sun Garrison in the Vale of Eternal Blossoms.$B$BI will mark his location on your map.','You must be seeking Zen Master Lao! He is working at the Setting Sun Garrison in the Vale of Eternal Blossoms.$B$BI will mark his location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66630,'There is a master of archaeology in the Seat of Knowledge, above Mogu\'shan Palace here in the Vale of Eternal Blossoms.$B$BI will mark their location on your map for you.','There is a master of archaeology in the Seat of Knowledge, above Mogu\'shan Palace here in the Vale of Eternal Blossoms.$B$BI will mark their location on your map for you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66631,'Oh yes, you are looking for Healer Nan. You can find her inside the Shrine of Seven Stars.$B$BI will mark her location on your map.','Oh yes, you are looking for Healer Nan. You can find her inside the Shrine of Seven Stars.$B$BI will mark her location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66632,'Interested in developing your cooking skills, are you?$B$BYou need to speak to the Ironpaw family. They can be found at the Halfhill Market in the Valley of the Four Winds.$B$BI will mark the location on your map for you.','Interested in developing your cooking skills, are you?$B$BYou need to speak to the Ironpaw family. They can be found at the Halfhill Market in the Valley of the Four Winds.$B$BI will mark the location on your map for you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66633,'If you seek to learn more of the herbalism arts, I suggest you speak to the trainer in The Jade Forest.$B$BI will mark their position for you.','If you seek to learn more of the herbalism arts, I suggest you speak to the trainer in The Jade Forest.$B$BI will mark their position for you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66634,'Yes, I know of an inscription trainer in the Seat of Knowledge, in the Vale of Eternal Blossoms.$B$BLet me mark their location on your map.','Yes, I know of an inscription trainer in the Seat of Knowledge, in the Vale of Eternal Blossoms.$B$BLet me mark their location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66635,'You seek Mai the Jade Shaper. You can find her at Greenstone Village in The Jade Forest.$B$BI will mark her location on your map.','You seek Mai the Jade Shaper. You can find her at Greenstone Village in The Jade Forest.$B$BI will mark her location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66636,'','Can we have some of your pets, Miss Finkleswitch? Please?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66637,'','No, no, little ones. You aren\'t big enough yet!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66638,'Aww, man...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66639,'Cloudrunner Leng can teach you how to fly in Pandaria. He rides his cloud serpent on the main terrace. I will mark his location on your map.','Cloudrunner Leng can teach you how to fly in Pandaria. He rides his cloud serpent on the main terrace. I will mark his location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66640,'$p AGGROED','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66641,'','Hrmph. I\'m probably taller than her.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66642,'There are no battlemasters here in the Vale.$B$BYou must return to your home city to queue for battlegrounds or arenas of war.','There are no battlemasters here in the Vale.$B$BYou must return to your home city to queue for battlegrounds or arenas of war.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66643,'Transmogrification and Void Storage services can be found in your home city.','Transmogrification and Void Storage services can be found in your home city.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66644,'Flying Trainer','Flying Trainer',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66645,'Pet Battle Trainer','Pet Battle Trainer',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66646,'Other','Other',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66647,'Temple of the Jade Serpent, a level 85-87 dungeon in the Jade Forest, is now available for testing. Please be in your full group before teleporting to the dungeon. Meeting Stones are not available for this dungeon yet.\n\nTo leave Temple of the Jade Serpent, simply exit through the normal exit inside the dungeon and you will be teleported out. If you die and release, you should teleport back from this NPC.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66648,'I\'m in my group and ready to teleport to Temple of the Jade Serpent!','I\'m in my group and ready to teleport to Temple of the Jade Serpent!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66649,'Take me back to Temple of the Jade Serpent!','Take me back to Temple of the Jade Serpent!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66650,'','Sara Finkleswitch commands The Fiddler to perform a jump!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66651,'Transmogrification & Void Storage','Transmogrification & Void Storage',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66652,'Priest Whitebrow moans in pain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66653,'Alchemy Goods','Alchemy Goods',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66654,'Blacksmithing Supplies','Blacksmithing Supplies',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66655,'Bread','Bread',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66656,'Brews','Brews',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66657,'Cooking Supplies','Cooking Supplies',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66658,'Enchanting Supplies','Enchanting Supplies',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66659,'Engineering Supplies','Engineering Supplies',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66660,'','There, there, Priest. You\'re in no condition to help anyone right now. Both of your arms are broken! I\'ll get you some medicine.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66661,'Fireworks','Fireworks',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66662,'First Aid Supplies','First Aid Supplies',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66663,'Fishing Supplies','Fishing Supplies',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66664,'Food & Drink','Food & Drink',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66665,'Herbs','Herbs',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66666,'','We need a cold pint over here! Stat!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66667,'Inscription Supplies','Inscription Supplies',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66668,'Jewelcrafting Supplies','Jewelcrafting Supplies',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66669,'Leatherworking & Skinning Supplies','Leatherworking & Skinning Supplies',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66670,'Meat','Meat',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66671,'Mining Supplies','Mining Supplies',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66672,'Sweet Treats','Sweet Treats',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66673,'Tailoring Supplies','Tailoring Supplies',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66674,'Looking for general goods? Bonni will have what you need. She sells her wares at the Golden Lantern. I will mark the location on your map.','Looking for general goods? Bonni will have what you need. She sells her wares at the Golden Lantern. I will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66675,'I saw a peddler setting up his trade goods in the Golden Lantern. I will mark the location on your map.','I saw a peddler setting up his trade goods in the Golden Lantern. I will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66676,'I guess you could say...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66677,'I guess you could say she has a bun in the oven!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66678,'Why is your wife still using the oven? My meat needs cooking!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66679,'Michael Bedernik growls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66680,'','Stop it, both of you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66681,'Well fought, student. You\'ve proven that you truly embody my way... the Way of the Crane.','',0,0,0,0,0,0,0,0,1,18204,0,0,26124),
(66682,'Hope can blossom anywhere... even in this dark corner of a forgotten jungle.','',0,0,0,0,0,0,0,0,1,18204,0,0,26124),
(66683,'All it needs is a hero like you to plant the seed.','',0,0,0,0,0,0,0,0,1,18204,0,0,26124),
(66684,'Stop this nightmare!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66685,'I will not be controlled!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66686,'Ah, what quartermaster are you searching for? Perhaps I can help you find them.','Ah, what quartermaster are you searching for? Perhaps I can help you find them.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66687,'Looking to find the Anglers Quartermaster? That would be Nat Pagle. You can find him at the Anglers Wharf in Krasarang Wilds.$B$BLet me mark the location on your map for you.','Looking to find the Anglers Quartermaster? That would be Nat Pagle. You can find him at the Anglers Wharf in Krasarang Wilds.$B$BLet me mark the location on your map for you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66688,'You need to talk to Teng Thundermalt! He can be found at the Stormstout Brewery in the Valley of the Four Winds.$B$BLet me mark the location on your map for you.','You need to talk to Teng Thundermalt! He can be found at the Stormstout Brewery in the Valley of the Four Winds.$B$BLet me mark the location on your map for you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66689,'If you\'re looking for the Tillers quartermaster, Gina Mudclaw\'s your girl. She\'ll be running the market at Halfhill.$B$BLet me mark her location on your map.','If you\'re looking for the Tillers quartermaster, Gina Mudclaw\'s your girl. She\'ll be running the market at Halfhill.$B$BLet me mark her location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66690,'San Redscale is the quartermaster for the Order of the Cloud Serpent.$B$BYou can find him at The Arboretum in The Jade Forest.$B$BI will mark his location on your map.','San Redscale is the quartermaster for the Order of the Cloud Serpent.$B$BYou can find him at The Arboretum in The Jade Forest.$B$BI will mark his location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66691,'Hmmm, I\'m afraid I know little of the Klaxxi, but I have heard whispers of their city, Klaxxi\'vess, far to the west in the Dread Wastes. Perhaps you can find the Klaxxi Quartermaster there.$B$BI will mark the location on your map.','Hmmm, I\'m afraid I know little of the Klaxxi, but I have heard whispers of their city, Klaxxi\'vess, far to the west in the Dread Wastes. Perhaps you can find the Klaxxi Quartermaster there.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66692,'The Shado-Pan quartermaster can be found at the Shado-Pan Garrison in the Townlong Steppes.$B$BI will mark their location on your map.','The Shado-Pan quartermaster can be found at the Shado-Pan Garrison in the Townlong Steppes.$B$BI will mark their location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66693,'Ah, you seek Jaluu the Generous! He is right next to me.','Ah, you seek Jaluu the Generous! He is right next to me.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66694,'The August Celestials quartermaster can be found here in the Vale. Sage Whiteheart stands with the other faction representatives, in the lower section of The Summer  Terrace.$B$BI will mark his location on your map.','The August Celestials quartermaster can be found here in the Vale. Sage Lotusbloom stands with the other faction representatives, in the lower section of The Golden Terrace.$B$BI will mark his location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66695,'The August Celestials quartermaster can be found here in the Vale. Sage Lotusbloom stands with the other faction representatives, in the lower section of The Summer Terrace.$B$BI will mark her location on your map.','The August Celestials quartermaster can be found here in the Vale. Sage Lotusbloom stands with the other faction representatives, in the lower section of The Summer Terrace.$B$BI will mark her location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66696,'You seek Tan Shin Tiao. She can be found in the Seat of Knowledge, above Mogu\'shan Palace here in the Vale of Eternal Blossoms.$B$BI will mark her location on your map.','You seek Tan Shin Tiao. She can be found in the Seat of Knowledge, above Mogu\'shan Palace here in the Vale of Eternal Blossoms.$B$BI will mark her location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66697,'The valor quartermaster, Commander Oxheart, can be found at Niuzao Temple in the Townlong Steppes.$B$BI will mark her location on your map.','The valor quartermaster, Commander Oxheart, can be found at Niuzao Temple in the Townlong Steppes.$B$BI will mark her location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66698,'You can trade your marks of justice with Commander Lo Ping, who can be found at Niuzao Temple in the Townlong Steppes.$B$BI will mark his location on your map.','You can trade your marks of justice with Commander Lo Ping, who can be found at Niuzao Temple in the Townlong Steppes.$B$BI will mark his location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66699,'The Honor Quartermaster can be found on the Serpent\'s Spine, the great wall to the west.$B$BI will mark their location on your map for you.','The Honor Quartermaster can be found on the Serpent\'s Spine, the great wall to the west.$B$BI will mark their location on your map for you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66700,'Quartermasters','Quartermasters',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66701,'Conquest Quartermaster','Conquest Quartermaster',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66702,'Valor Quartermaster','Valor Quartermaster',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66703,'Honor Quartermaster','Honor Quartermaster',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66704,'Anglers','Anglers',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66705,'Brewmasters','Brewmasters',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66706,'Tillers','Tillers',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66707,'Order of the Cloud Serpent','Order of the Cloud Serpent',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66708,'Klaxxi','Klaxxi',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66709,'Shado-Pan','Shado-Pan',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66710,'Golden Lotus','Golden Lotus',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66711,'You are dismissed. Return to the Shado-Pan Garrison.','You are dismissed. Return to the Shado-Pan Garrison.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66712,'August Celestials','August Celestials',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66713,'Lorewalkers','Lorewalkers',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66714,'You can return to the Shado-Pan Garrison to select a new Shado-Pan Companion.\n\nAre you sure you want to dismiss your Shado-Pan Companion?','You can return to the Shado-Pan Garrison to select a new Shado-Pan Companion.\n\nAre you sure you want to dismiss your Shado-Pan Companion?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66715,'You can find the Conquest Quartermaster and the Glorious Conquest Quartermaster on the Serpent\'s Spine to the west.$B$BI will mark their location on your map.','You can find the Conquest Quartermaster and the Glorious Conquest Quartermaster on the Serpent\'s Spine to the west.$B$BI will mark their location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66716,'Where can I find the Anglers Quartermaster?','Where can I find the Anglers Quartermaster?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66717,'Where can I find the Brewmasters Quartermaster?','Where can I find the Brewmasters Quartermaster?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66718,'Where can I find the Golden Lotus Quartermaster?','Where can I find the Golden Lotus Quartermaster?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66719,'Where can I find the Klaxxi Quartermaster?','Where can I find the Klaxxi Quartermaster?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66720,'Where can I find the Lorewalkers Quartermaster?','Where can I find the Lorewalkers Quartermaster?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66721,'Where can I find the Order of the Cloud Serpent Quartermaster?','Where can I find the Order of the Cloud Serpent Quartermaster?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66722,'Where can I find the Shado-Pan Quartermaster?','Where can I find the Shado-Pan Quartermaster?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66723,'Where can I find the Tillers Quartermaster?','Where can I find the Tillers Quartermaster?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66724,'Gaze into the inevitable!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66725,'Face your demise!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66726,'Silence... at last.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66727,'Tremble!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66728,'','Mister Pleeb is teaching me how to be a taxidermist. Personally I think he is a little too dated and could benefit from a little gnomish \"engi-nuity.\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66729,'Oy, lad! Have ye gotten that Thundertank XT 9000 workin\' yet?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66730,'No, sir. I don\'t believe so.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66731,'Friend, have your journeys brought you to Krasarang recently?$B$BIt would be wise to venture there. The fish are as bountiful as the most fortunate harvest.$B$BAs my father said, the early fisherman gets the catch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66732,'The Anglers Wharf in southeastern Krasarang Wilds is home to the most avid of all fisherman this side of Pandaria.$B$BIf you love the reward of a day spent with the great sea, I urge you to honor us with your presence.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66733,'You seek...a reward?$B$BSurely the joy of a successful catch is reward enough? The thrill of the open sea? The comraderie that only a fishing pole can grant?$B$BYou have much to learn, $r.$B$BMy opinion aside, there is much to be gained from the art of fishing.$B$BYou may improve your fishing skill.  One day, you may purchase powerful fishing rods.$B$BThe most revered fishermen may receive access to a special fish pet, a water stride mount, and a fishing raft.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66734,'Thank you. I owe you greatly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66735,'I overheard a great deal through the cage. Rensai will be pleased with what I have to tell him.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(66736,'I hope we meet again soon, my new friend.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(66737,'Intruders in the crypt!  Don\'t let them leave alive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66738,'You will soon join the corpses buried here, little $c!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66739,'The tireless efforts of the Shado-Pan are the only thing keeping this land from being ravaged by the mantid swarm. We do not ask thanks for this, but now we are faced with a time when we can no longer accomplish this task alone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66740,'$n stepped on a lightning trap!','$n stepped on a lightning trap!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66741,'Get off the ship before fire engulfs it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66742,'Tread lightly, $r. The rage of this land has yet to be quenched. Your very presence here causes it anguish the likes of which it has never endured.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66743,'Why do we continue to fight in a war we have nothing to gain from? Do the dying screams of thousands not haunt your very dreams?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66744,'What happens when our wars are over? Do you expect to return to civilian life without incident despite the horrors you\'ve witnessed?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66745,'We openly deal with the ethereal, ignorant of their true intentions. Could we be aiding in the preparation of our own demise?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66746,'The north still reeks of undeath. Our homelands lay in ruin. Pandaria oozes our hatred and doubt. What hope is there for this world when the Burning Legion again lands upon our shores?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66747,'At what point are our hearts as full of darkness as the great evil we so tirelessly try to subdue?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66748,'I can smell your hatred, your violence, your doubt. Your soul bears the weight of a lifetime of hardship. Why do you continue onward down a path that can only lead to ruin?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66749,'Come take a seat and eat! It\'s never a bad time for a hearty meal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66750,'Come and get it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66751,'Surely a hot bite and a fresh pint will help those battle wounds heal a bit faster, eh?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66752,'I will give you a free meal if you can get this dwarf off of my new chair!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66753,'Li, I need another dragon gun.','Li, I need another dragon gun.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66754,'','You think these grow on trees?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(66755,'','Do you have any fizzy energy drinks?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(66756,'','Sarya Teaflower washes her hands.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66757,'','Sarya Teaflower sighs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66758,'','Can I get any of you another drink?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(66759,'','There are so many wounded...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66760,'','Whew, time to take a break!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(66761,'Train me in First Aid.','Train me in First Aid.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66762,'','Look at this astounding dirt! It\'s so dirt-like!',0,0,0,0,0,0,16,0,1,0,0,0,26124),
(66763,'Why don\'t you come dance with me instead good lookin\'?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66764,'','I wonder if my shoes are too fancy for exploring?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(66765,'','These trees are AMAZING!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(66766,'','Eek! I\'m outta here! Gyrochromatic Invisibility Engine engage!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(66767,'','I\'ve never seen roots like this before!',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(66768,'','These rocks are so lifelike!',0,0,0,0,0,0,71,0,1,0,0,0,26124),
(66769,'','I wonder if I\'m too cute for the jungle?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(66770,'','I have to take some of these flowers back home!',0,0,0,0,0,0,21,0,1,0,0,0,26124),
(66771,'','Being a legendary explorer is hard work!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(66772,'Hello, $n.  My services as an auctioneer are available to those with skill in engineering.  Sadly, you have none.  Please leave.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66773,'A falcon\'s talon is only as useful as the grace of his flight.','',275,0,0,0,0,0,0,0,1,0,0,0,26124),
(66774,'Fear not if your weapon leaves your grasp. Your body is an ample tool against any foe.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66775,'Your armor is your skin in combat. Protect it and honor it, and it shall do the same for you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66776,'Flames of passion serve only to ignite the kindle of others.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66777,'Sometimes, the fragile wasp is far more effective than the mighty bull.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66778,'Can you believe that they won\'t let me in? Me, of all people?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66779,'Can\'t you see I\'m partaking in a staring contest right now?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66780,'I\'m not falling for your tricks, $r. Victory shall be mine!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66781,'Lao-Chin\'s Healing Spheres heal him as they fade away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66782,'This fool does not understand. He carries negative emotion with reckless abandon. We will all suffer the consequences if such action continues.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66783,'This old pandaren is a fool. How are we supposed to fight without emotion? It\'s impossible!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(66784,'He knows more about this land than we do. Perhaps you should heed his warnings.','He knows more about this land than we do. Perhaps you should heed his warnings.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66785,'What do you know? You act like you\'re the savior of Azeroth!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66786,'Fire!','Fire!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66787,'Fire! FIRE!','Fire! FIRE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66788,'The ship\'s aflame!','The ship\'s aflame!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66789,'Hey there beautiful, I\'d like to make a withdrawal.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66790,'What happened to the ship?!','What happened to the ship?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66791,'Thank you very, very much.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66792,'Our ship... NO! Did everyone escape? Gather here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66793,'What?! MY SHIP! Who did this?!','What?! MY SHIP! Who did this?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66794,'Come, friends! Let us all enjoy a fine brew.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66795,'Young Dustback Mushan cries for help!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(66796,'Until next time, my friends.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(66797,'The doctor is in!','The doctor is in!',0,0,0,0,0,0,0,0,1,0,49768,49768,26124),
(66798,'','41,812...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66799,'','41,813...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66800,'','41,814...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66801,'','Uh...uh...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66802,'','1...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66803,'','2...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66804,'Shh, jinyu. It\'s hard enough to fish here as it is!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66805,'','I\'m going to ask Tina to come with me next time, she\'d LOVE these plants!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(66806,'','I could really go for one of Uncle Gus\' jokes about now, this place is scary!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(66808,'','Someday, I want to be an explorer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66809,'','I haven\'t seen Tweets in a while, I hope she\'s ok!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66810,'','Hey! Shoes off of the table! AND FEET!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66811,'','It would be nice to leave the Vale some day, but it\'s so pretty here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66812,'','Can I get you a refreshment?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66813,'If you can find a way into our sleep chambers, you may use them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66814,'You may stay while you are still useful, outsider.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66815,'I am surprised the Klaxxi\'va allowed you to live, but it is not for me to question.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66816,'I will offer you accomodations for as long as you are of use to us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66817,'You! Away from our crops!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66818,'Hahahahaha!','',0,0,0,0,0,0,0,0,7,0,31483,0,26124),
(66819,'Rake in face!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66820,'AYEEEEEE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66821,'We grow better!  You bad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66822,'We rowdy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66823,'\"And that is how the shining blade came to, and left, Pandaria, its final destination unknown.\"$B$BOur people\'s lore is a woven quilt of rich stories. It is my job to bind the tomes so that they may last a thousand lifetimes.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66824,'There\'s so much knowledge of the ancient world stored here that we\'re only just now discovering!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(66826,'You\'ll never leave Theramore alive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66827,'','Double fortune to you, $r.$B$BIf you are looking for a lucky charm, I can help set you right up.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66828,'Double fortune to you, $r.$B$BIf you are looking for a lucky charm, I can help set you right up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66829,'','Who needs friends when you have cats?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(66830,'Thank the sea, stranger! I can get back to Sri-La village on my own.','Thank the sea, stranger! I can get back to Sri-La village on my own.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66831,'I was fishing along the coast when the spiders got me! Thank you for saving me.','I was fishing along the coast when the spiders got me! Thank you for saving me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66832,'Did the Order of the Cloud Serpent send you? Bless them. Please help the others!','Did the Order of the Cloud Serpent send you? Bless them. Please help the others!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66833,'The other victims... they made such awful sounds. Thank you for coming to my rescue!','The other victims... they made such awful sounds. Thank you for coming to my rescue!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66834,'I thought I was finished. Thank you, and thank the Order. I can get out of here on my own.','I thought I was finished. Thank you, and thank the Order. I can get out of here on my own.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66835,'I had a farm once, but that was a long time ago. I prefer a good battle, don\'t you?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(66836,'','I only caught two rabbits. Now I have lots!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(66837,'Take me to Stormwind.','Take me to Stormwind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66838,'Take me to Orgrimmar.','Take me to Orgrimmar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66839,'I did not think that help would come. You have given me new hope, stranger.','I did not think that help would come. You have given me new hope, stranger.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66840,'While I was trapped in that web, I had such feelings of doubt and despair. You have freed me from my own fears.','While I was trapped in that web, I had such feelings of doubt and despair. You have freed me from my own fears.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66841,'I began to fear that no help would come. That everyone had forgotten me. Thank the Order that they sent you!','I began to fear that no help would come. That everyone had forgotten me. Thank the Order that they sent you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66842,'Are you afraid of spiders? Some feel them crawling on their skin as they wander through the endless woods.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66843,'Have you sheen the rum? ...hic! I can\'t sheem to find it anywhere!','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(66844,'','The Horde will pay for what they\'ve wrought here.$B$BOnce I reclaim the Focusing Iris from this... abomination... Garrosh will know the true meaning of destruction.$B$BOrgrimmar... will DROWN.',1,5,0,0,3,0,0,0,1,0,0,0,26124),
(66845,'I had a farm once, but that was a long time ago. I prefer a good battle, don\'t you?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(66846,'We\'ll clear the ruins of Horde while you work.','We\'ll clear the ruins of Horde while you work.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66847,'Are you afraid of spiders? Some feel them crawling on their skin as they wander through the endless woods.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66848,'','All of you have my deepest thanks. With the Focusing Iris removed, this lifeless bomb is merely a sickening testament to Garrosh\'s brutality. The winds of change blow fiercely; Azeroth is on the brink of war. My apologies, but you must excuse me... I have much to consider. Farewell.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66849,'','Goodbye...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66850,'','A historian\'s work is never done, you see. There\'s always something important happening that we will need to remember.$B$BI\'m beginning to collect the history of your people\'s coming here. What is your name, so that future generations may read your story and know your tale?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66851,'My name is...','My name is...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66852,'','Ah, so that\'s who you are. I\'ve already heard stories of your deeds, $N. I will write stories about you so that you will be remembered, you have my word.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66853,'Jenji! This is $n, of course. Have you not heard of $ghis:her; deeds as of late? $GHe:She; has done much for our people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66854,'','My apologies, Advisor. I did not recognize $Ghim:her;!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66855,'','I will write of your adventures right now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66856,'Engaging total destruction sequence. Good bye.','',0,0,0,0,0,0,0,0,1,0,28542,0,26124),
(66857,'Oftentimes, the silent grasshopper knows how to best avoid the boot.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66858,'If you judge a fish by its ability to climb a tree, it will live its life believing it is inadequate.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66859,'The early bird gets the worm, but the patient pandaren receives a hearty brew.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66860,'Violence may appear to do good for a time, but the evil it does will remain forever.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66861,'Only love can drive out hatred.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66862,'Instill me with your wisdom, Advisor.','Instill me with your wisdom, Advisor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66863,'Cleaning','Cleaning',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66865,'Few people know this, but I was once a pit fighter myself. A gladiator for the Horde\'s amusement. So I know a thing or two about martial combat.','',0,0,0,0,0,0,1,0,1,0,29568,0,26124),
(66866,'Nooooo! Precious shoes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66867,'Go away, shoe stealer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66868,'What are you doing!? Don\'t touch those!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66869,'Noooo! That\'s my favorite pair!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66870,'No! Our precious collection!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66871,'I just wanted... one more... pair...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66872,'You can never have enough... shoes...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66873,'Almost.','',0,0,0,0,0,0,0,0,1,18353,29674,0,26124),
(66874,'Almost.','',0,0,0,0,0,0,11,0,1,13118,29674,0,26124),
(66875,'','I cannot join you this day, friends. I must prepare my fish for the coming feast!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66876,'','Mograine...',0,0,0,0,0,0,0,0,1,0,0,29617,26124),
(66877,'','Please, partake in the buffet laid out by the Golden Lotus as a thanks to your people for their aid in protecting the Vale of Eternal Blossoms.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66878,'Greetings, $r.$B$BI am but a young sapling, grown here in Pandaria to become one with the land so that Tyrande may benefit from the stories it holds.The Strongbows have volunteered to protect me in my infancy so that our mistress\' wishes are fulfilled.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66879,'Don\'t worry, the hatchlings are quite safe here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66880,'I have seen many students over the years, but there is something different about you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66881,'A new student? Ah yes, very good. Have you spoken to Elder Anli?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66882,'Treat your cloud serpent with kindness and respect, and it will grow to trust you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66883,'','A long journey is best traveled one step at a time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66884,'','I like to keep an eye on all of my students. I will watch your progress eagerly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66885,'','The wild cloud serpents breed very rarely, and as such, each egg is extremely precious.$B$BIf we do not work to help and protect the wild cloud serpents, they may one day disappear.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66886,'','Of all the wild serpents, the onyx serpent is the rarest. These elusive black cloud serpents are known to lay their eggs on Windward Isle to the northeast.$B$BIf you come across any Onyx Eggs, please bring them to me. I shall reward you handsomely.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66887,'Can you follow my blade?','',0,0,0,0,0,0,0,0,1,0,29261,0,26124),
(66888,'You won\'t need that body where you\'re going!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66889,'You dare to cross the Shan\'ze?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66890,'Another restless spirit...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66891,'I will free you from that pitiful form and reforge you in our service!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66892,'The body fails... but the spirit... can endure...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66893,'You cannot stop us! Our army will lead the coming storm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66894,'Such insolence!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66895,'Surrender your spirit to a stone body!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66896,'The Shan... will take you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66897,'Impossible...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66898,'A lively spirit for the taking...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66899,'I have a jar waiting just for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66900,'You will join the others in eternal servitude!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66901,'Fool! Your fate is sealed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66902,'I will cleave the soul from between your bones!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66903,'Hold still, it will be over soon...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66904,'Death is only the beginning of your punishment!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66905,'Nice spirit - I think I\'ll take it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66906,'A furious Orchard Needler appears above you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66907,'','Careful! If they see you, they\'ll raise the alarm.$B$BDid the Golden Lotus send you to rescue us? I\'m the only one not dead or captured...',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(66908,'What happened to the expedition?','What happened to the expedition?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66909,'Can you lead us to the prisoners?','Can you lead us to the prisoners?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66910,'','We were investigating the temple when a mogu warlord and his retinue arrived.$B$BThose of us not slain immediately were taken prisoner.$B$BI was left for dead and have been hiding here since.$B$BI don\'t know what the mogu are here for, though it can\'t be anything good!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66911,'','They were taken towards a waterfall to the southeast. I\'ll lead you there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66912,'','We must take care. The temple grounds are patrolled by mogu and their saurok slaves, and their beasts lurk in the grass off the roads.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66913,'','The central courtyard is heavily guarded. We\'ll go around.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66914,'Slay Ancient Spirits to empower the Staff of Pei-Zhi!','Slay Ancient Spirits to empower the Staff of Pei-Zhi!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66915,'What do you think you\'re doing?! No matter - I no longer need the staff.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66916,'Do you like my snakes? I get the feeling they don\'t like you!','Do you like my snakes? I get the feeling they don\'t like you!',1,0,0,0,0,0,0,0,5,0,0,0,26124),
(66917,'<Your hatchling looks at you inquisitively.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66918,'<Your hatchling smiles at you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66919,'<Your hatchling chirps at you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66920,'<Your hatchling watches you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66921,'<Your hatchling looks at you with a bored expression.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66922,'<Your hatchling flies around playfully.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66923,'<Your hatchling rubs its scales against your arm.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66924,'<Your hatchling licks you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66925,'<The hatchling looks at you inquisitively.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66926,'<The hatchling smiles at you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66927,'<The hatchling chirps at you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66928,'<The hatchling watches you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66929,'<The hatchling looks at you with a bored expression.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66930,'<The hatchling flies around playfully.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66931,'<The hatchling rubs its scales against your arm.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66932,'<The hatchling licks you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66933,'<Your hatchling glares at you with a disappointed frown. It sees that you are playing with another hatchling.>$B$B<You can only play with one hatchling at a time. Speak to Elder Anli to return your current hatchling before playing Catch! with this one.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66934,'<The hatchling glares at you with a disappointed frown. It sees that you are playing with another hatchling.>$B$B<You can only play with one hatchling at a time. Speak to Elder Anli to return your current hatchling before playing Catch! with this one.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66935,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66936,'Your deeds of valor will be remembered.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66937,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66938,'Your serpent flies back home!','Your serpent flies back home!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66939,'|TInterface\\Icons\\spell_shadow_sacrificialshield.blp:20|t%s begins to cast |cFFFF0000|Hspell:117697|h[Shield of Darkness]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66941,'Each bodily injury endured, is a lesson learned. Each defeat, an opportunity to grow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66942,'For Pandaria!!','',0,0,0,0,0,0,71,0,1,15760,31933,0,26124),
(66943,'For Pandaria!!','',0,0,0,0,0,0,4,0,1,15760,30690,0,26124),
(66944,'$p! I am... not in control... Get away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66945,'Justice Quartermaster','Justice Quartermaster',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66946,'Finding peace within will allow you to see obstacles with reason.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66948,'Wisdom can only penetrate a heart that is truly open to it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66949,'Those are mine! I stole them first!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66950,'It hurts... so much...','It hurts... so much...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66951,'Offer them no mercy, not after what they\'ve done.','Offer them no mercy, not after what they\'ve done.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66952,'Nightmares!  Horrible nightmares!','Nightmares!  Horrible nightmares!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66953,'So much pain...','So much pain...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66954,'The agony...','The agony...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66955,'Save the others!  Please!','Save the others!  Please!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66956,'I owe you my life!','I owe you my life!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66957,'Kill them!  Kill them all!','Kill them!  Kill them all!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66958,'We were fortunate enough to find the Vale after it opened its gates. We sought refuge, and have found safe haven.$B$BAre you lost? May I help you find something?','We were fortunate enough to find the Vale after it opened its gates. We sought refuge, and have found safe haven.$B$BAre you lost? May I help you find something?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66959,'The auction house is located on the second floor, on the right side of the building as you enter.$B$BI will mark the location on your map.','The auction house is located on the second floor, on the right side of the building as you enter.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66960,'The bank is located on the second floor, on the left side of the building as you enter.$B$BI will mark the location on your map.','The bank is located on the second floor, on the left side of the building as you enter.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66961,'The flight master is located out on the main terrace, at the top of the twin stairs and before you enter the main building.$B$BI will mark the location on your map.','The flight master is located out on the main terrace, at the top of the twin stairs and before you enter the main building.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66962,'Skydancer Shun can teach you how to fly in Pandaria. He rides his cloud serpent on the main terrace. I will mark his location on your map.','Skydancer Shun can teach you how to fly in Pandaria. He rides his cloud serpent on the main terrace. I will mark his location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66963,'The inn is located on the main floor, to the right as you enter the building.$B$BI will mark the location on your map.','The inn is located on the main floor, to the right as you enter the building.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66964,'There is a battle trainer by the name of Gentle San who trains her pets out on the main terrace.$B$BI will mark the location on your map.','There is a battle trainer by the name of Gentle San who trains her pets out on the main terrace.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66965,'The ethereals set up shop in the upstairs corridor to the right as you enter the main building.$B$BI will mark the location on your map.','The ethereals set up shop in the upstairs corridor to the right as you enter the main building.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66966,'Tracker Lang, the stable master, can be found on the main terrace before you enter the main building. He stands next to the pet battle trainer.$B$BI will mark the location on your map.','Tracker Lang, the stable master, can be found on the main terrace before you enter the main building. He stands next to the pet battle trainer.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66967,'Vendors from all over the land have found their way into the city. What are you looking for?','Vendors from all over the land have found their way into the city. What are you looking for?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66968,'You are looking for the apothecary. He makes some truly wonderful potions and tinctures. Got rid of my rash in no time!$B$BAhem... Apothecary Greenmoss sells his wares in the crafter\'s hall. I will mark the location on your map.','You are looking for the apothecary. He makes some truly wonderful potions and tinctures. Got rid of my rash in no time!$B$BAhem... Apothecary Greenmoss sells his wares in the crafter\'s hall. I will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66969,'The Tomb of Conquerors is directly below you. Follow the dirt path to the entrance. You must hurry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66970,'The blacksmiths all work in the crafter\'s hall, to the left as you enter the main building.$B$BI will mark the location on your map.','The blacksmiths all work in the crafter\'s hall, to the left as you enter the main building.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66971,'Looking for some brew, eh? The Keggary is the place to go for fine ales! I\'ll mark it on your map.','Looking for some brew, eh? The Keggary is the place to go for fine ales! I\'ll mark it on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66972,'We need to get those arrows and get out of here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66973,'Initiate, may I have another quiver please?','Initiate, may I have another quiver please?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66974,'Ah, so you\'re an up and coming chef, are you? You can find everything you need from Barleyflower. She sells her wares in the keggery.$B$BI will mark the location on your map.','Ah, so you\'re an up and coming chef, are you? You can find everything you need from Barleyflower. She sells her wares in the keggery.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66975,'Derenda Enkleshin carries enchanting supplies. She can be found in the chamber of masters, to the left as you enter the building.$B$BI will mark the location on your map.','Derenda Enkleshin carries enchanting supplies. She can be found in the chamber of masters, to the left as you enter the building.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66976,'I seem to recall there is an engineer in the chamber of masters, to the left as you enter the main building.$B$BI will mark the location on your map.','I seem to recall there is an engineer in the chamber of masters, to the left as you enter the main building.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66977,'Thinking about setting off a spark or two? I should go buy some fireworks myself! The vendor can be found in the chamber of masters.$B$BI\'ll mark the location on your map.','Thinking about setting off a spark or two? I should go buy some fireworks myself! The vendor can be found in the chamber of masters.$B$BI\'ll mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66978,'First aid is not far from here, do not worry. The healers can be found just inside the chamber of masters.$B$BI will mark the location on your map.','First aid is not far from here, do not worry. The healers can be found just inside the chamber of masters.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66979,'The... the yaungol!\n\nThey attacked my farm, and the nearby village, Eastwind Rest... killed some of us, and the ones they didn\'t kill they chased off!\n\nI managed to gather some of us here. Any word on help coming from Binan?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66980,'I\'m from the Horde. We\'re here to save you and rebuild your village.','I\'m from the Horde. We\'re here to save you and rebuild your village.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66981,'Ban, would you please give me more explosives?','Ban, would you please give me more explosives?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66982,'Yes, there is a fishing supplies vendor inside the hall of tranquility. Please be quiet so as to not ruin a catch!$B$BI will mark the location on your map.','Yes, there is a fishing supplies vendor inside the hall of tranquility. Please be quiet so as to not ruin a catch!$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66983,'Are you looking for some food and drink? If so, then Mifan in summer\'s rest has a fantastic selection.$B$BI will mark the location on your map.','Are you looking for some food and drink? If so, then Mifan in summer\'s rest has a fantastic selection.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66984,'You know, things are really starting to look up ever since you came around!\n\nCan\'t help thinking about what happened to my friends back on the farm, though...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66985,'Looking for general goods? Marli Two-Toes will have what you need. He is located inside summer\'s rest. I will mark the location on your map.','Looking for general goods? Marli Two-Toes will have what you need. He is located inside summer\'s rest. I will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66986,'Yes, there is a vendor of herbs in the city. Hafuna Landwalker can be found in the chamber of masters, to the left as you enter the building.$B$BI will mark the location on your map.','Yes, there is a vendor of herbs in the city. Hafuna Landwalker can be found in the chamber of masters, to the left as you enter the building.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66987,'Ah, a scrollmaker! You\'ll be looking for inks and vellum, I suppose? They can be found in the chamber of masters, to the left as you enter the building.$B$BI will mark the location on your map.','Ah, a scrollmaker! You\'ll be looking for inks and vellum, I suppose? They can be found in the chamber of masters, to the left as you enter the building.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66988,'Jewelcrafting? That\'s fine work, indeed. You can purchase supplies from Vanaris Whitesong in the chamber of masters.$B$BI will mark the location on your map.','Jewelcrafting? That\'s fine work, indeed. You can purchase supplies from Vanaris Whitesong in the chamber of masters.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66989,'You can find a leatherworking trainer at the Grummle Bazaar in Kun-Lai Summit. I will mark the location on your map.','You can find a leatherworking trainer at the Grummle Bazaar in Kun-Lai Summit. I will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66990,'Leatherworking and skins? You must be looking for a tanner. There\'s one in the chamber of masters, if I recall.$B$BI will mark the location on your map.','Leatherworking and skins? You must be looking for a tanner. There\'s one in the chamber of masters, if I recall.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66991,'You can purchase mining supplies in the back of the chamber of masters, from Razzie Coalwrench.$B$BI will mark the location on your map.','You can purchase mining supplies in the back of the chamber of masters, from Razzie Coalwrench.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66992,'Sheena Sunweaver is known for her sales of reagents and can be found in the chamber of masters, to the left as you enter the building.$B$BI will mark the location on your map.','Sheena Sunweaver is known for her sales of reagents and can be found in the chamber of masters, to the left as you enter the building.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66993,'As dark as things seem, I must not give up hope. We must not be cowed by the violence of the Yaungol.\n\nYou... have you come to help us?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66994,'I\'m from the Horde. We\'re here to save you and rebuild your village.','I\'m from the Horde. We\'re here to save you and rebuild your village.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66995,'I must admit, when times were darkest, I did not believe that we would survive. Thanks to you and your people, I am glad to have been proven wrong.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66996,'Esha the Loommaiden is renowned for her cloth skills.$B$BShe works in the chamber of masters, to the left as you enter the building.$B$BI will mark the location on your map.','Esha the Loommaiden is renowned for her cloth skills.$B$BShe works in the chamber of masters, to the left as you enter the building.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66997,'I know of a saleswoman of trade goods in Summer\'s Rest. I will mark the location on your map.','I know of a saleswoman of trade goods in Summer\'s Rest. I will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(66998,'Where did all of these mogu come from?','Where did all of these mogu come from?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(66999,'Thank you for rescuing us, $c. Hopefully now our mission will not be lost.','Thank you for rescuing us, $c. Hopefully now our mission will not be lost.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67000,'These \"elf\" creatures. Can they be trusted?','These \"elf\" creatures. Can they be trusted?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67001,'First mantid, then mogu. These are dark days indeed.','First mantid, then mogu. These are dark days indeed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67002,'I don\'t know what brought you into the Forbidden Jungle, but I am glad it did. You saved us from slavery... or worse.','I don\'t know what brought you into the Forbidden Jungle, but I am glad it did. You saved us from slavery... or worse.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67003,'When did the mogu learn to wield magic portals?','When did the mogu learn to wield magic portals?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67004,'The mogu chose the worst time to attack. The mantid are on the move, and not even the great wall will hold them back.','The mogu chose the worst time to attack. The mantid are on the move, and not even the great wall will hold them back.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67005,'Our dreams have been haunted by mantid. We hoped the Crane Temple would give us some insight to these visions.','Our dreams have been haunted by mantid. We hoped the Crane Temple would give us some insight to these visions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67006,'You need to speak to Ba\'kon. He has an ample supply of meats. I heard he makes it all fresh$B$BI\'ll mark his location on your map. Good luck!','You need to speak to Ba\'kon. He has an ample supply of meats. I heard he makes it all fresh$B$BI\'ll mark his location on your map. Good luck!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67007,'Itching for something sweet? You need to find Beige Sugar.$B$BHe\'s usually wandering around the bottom floor, though he\'s been known to step into the keggery for a treat every now and then.','Itching for something sweet? You need to find Beige Sugar.$B$BHe\'s usually wandering around the bottom floor, though he\'s been known to step into the keggery for a treat every now and then.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67008,'The... the yaungol!\n\nThey attacked my farm, and the nearby village, Westwind Rest... killed some of us, and the ones they didn\'t kill they chased off!\n\nI managed to gather some of us here. Any word on help coming from Binan?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67009,'I\'m from the Alliance. We\'re here to save you and rebuild your village.','I\'m from the Alliance. We\'re here to save you and rebuild your village.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67010,'Looking for a professions trainer?$B$BThe zen master trainers can be found all across Pandaria. Tell me who you are looking for.$B$BIf you cannot find the person you seek here in Pandaria, you may also seek professions masters in your home city. They should also be able to improve your skill in your craft.','Looking for a professions trainer?$B$BThe zen master trainers can be found all across Pandaria. Tell me who you are looking for.$B$BIf you cannot find the person you seek here in Pandaria, you may also seek professions masters in your home city. They should also be able to improve your skill in your craft.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67011,'I\'m from the Alliance. We\'re here to save you and rebuild your village.','I\'m from the Alliance. We\'re here to save you and rebuild your village.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67012,'I have heard there are master alchemists among the Klaxxi, far over the wall in the Dread Wastes. I will mark the location on your map for you.','I have heard there are master alchemists among the Klaxxi, far over the wall in the Dread Wastes. I will mark the location on your map for you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67013,'There is a master of archaeology in the Seat of Knowledge, above Mogu\'shan Palace here in the Vale of Eternal Blossoms.$B$BI will mark their location on your map for you.','There is a master of archaeology in the Seat of Knowledge, above Mogu\'shan Palace here in the Vale of Eternal Blossoms.$B$BI will mark their location on your map for you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67014,'You must be seeking Zen Master Lao! He is working at the Setting Sun Garrison in the Vale of Eternal Blossoms.$B$BI will mark his location on your map.','You must be seeking Zen Master Lao! He is working at the Setting Sun Garrison in the Vale of Eternal Blossoms.$B$BI will mark his location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67015,'Interested in developing your cooking skills, are you?$B$BYou need to speak to the Ironpaw family. They can be found at the Halfhill Market in the Valley of the Four Winds.$B$BI will mark the location on your map for you.','Interested in developing your cooking skills, are you?$B$BYou need to speak to the Ironpaw family. They can be found at the Halfhill Market in the Valley of the Four Winds.$B$BI will mark the location on your map for you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67016,'For your enchanting needs, you must speak to Lai the Spellpaw at Dawn\'s Blossom in The Jade Forest.$B$BI will mark the location on your map.','For your enchanting needs, you must speak to Lai the Spellpaw at Dawn\'s Blossom in The Jade Forest.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67017,'You can find the person you seek at Nesingwary\'s Safari in the Valley of the Four Winds.$B$BI will mark their location on your map.','You can find the person you seek at Nesingwary\'s Safari in the Valley of the Four Winds.$B$BI will mark their location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67018,'It\'s a wonderful day to be alive, isn\'t it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67019,'Always look forward, never back.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67020,'','Have you seen the onyx serpents? They are known to lay their eggs on Windward Isle. If you find such an egg and bring it to Elder Anli, you will be justly rewarded.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67021,'','Have you flown in the Sky Race? I wish you luck, if you do.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67022,'Oh yes, you are looking for Ala\'thinel. You can find her inside the Shrine of Two Moons.$B$BI will mark her location on your map.','Oh yes, you are looking for Ala\'thinel. You can find her inside the Shrine of Two Moons.$B$BI will mark her location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67023,'You can improve your fishing skill by visiting Nat Pagle at the Anglers Wharf in the Krasarang Wilds. Let me mark the location for you.','You can improve your fishing skill by visiting Nat Pagle at the Anglers Wharf in the Krasarang Wilds. Let me mark the location for you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67024,'Yes, I know of an inscription trainer in the Seat of Knowledge, in the Vale of Eternal Blossoms.$B$BLet me mark their location on your map.','Yes, I know of an inscription trainer in the Seat of Knowledge, in the Vale of Eternal Blossoms.$B$BLet me mark their location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67025,'You seek Mai the Jade Shaper. You can find her at Greenstone Village in The Jade Forest.$B$BI will mark her location on your map.','You seek Mai the Jade Shaper. You can find her at Greenstone Village in The Jade Forest.$B$BI will mark her location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67026,'Things are always better than they seem.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67027,'There are master miners located at the Greenstone Quarry in the Jade Forest. They can probably help you improve your skill. I will mark the location on your map.','There are master miners located at the Greenstone Quarry in the Jade Forest. They can probably help you improve your skill. I will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67028,'There is a skinning trainer at Nesingwary\'s Safari in the Valley of the Four Winds.$B$BI will mark their location on your map.','There is a skinning trainer at Nesingwary\'s Safari in the Valley of the Four Winds.$B$BI will mark their location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67029,'You seek Silkmaster Tsai at the Silken Fields in the Valley of the Four Winds. I will mark his location on your map for you.','You seek Silkmaster Tsai at the Silken Fields in the Valley of the Four Winds. I will mark his location on your map for you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67030,'','Your cloud serpent approaches, $n. When you are ready, hop on and we will begin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67031,'I guess I was wrong about Shomi...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67032,'The elders were right; you really can\'t judge a book by it\'s cover.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67033,'Do you think Shomi will show me her fighting skills?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67034,'Don\'t tell her I said this, but I think Shomi did a great job defending the village.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67035,'I\'m gonna catch you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67036,'Slow down Mei, I\'m getting tired!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67037,'I\'m just letting you win.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67038,'Ow, I got a pebble in my shoe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67039,'','Nyah! You can\'t catch me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67040,'','Come on, you slow poke!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67041,'','I\'m barely even trying!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67042,'','You can\'t catch me Lo!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67043,'Die like the rest, slave!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67044,'Get these slaves to Kun-La Summit! Open the portal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67045,'The master cannot wait any longer for these artifacts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67046,'Open the portal to Kun-Lai Summit, you fools! Quickly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67047,'Quiet, slave! You\'re worth just as much dead as alive.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67048,'I\'m getting rusty... and my lockpicks are too apparently.  Do me a favor, don\'t let Ren know you found me here, kay?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67049,'','So I take it you aren\'t having any luck?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67050,'','Any luck today?  You haven\'t brought any back yet.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67051,'','I see you\'re fishing... again.  Are you doing better than yesterday?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(67052,'','Here\'s a kiss for good luck, I think you\'re going to need it.',17,0,0,1,0,0,0,0,1,0,0,0,26124),
(67053,'','I wouldn\'t mind that you wasted each day if you caught a few more fish.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67054,'','Be glad I didn\'t marry you for your fishing skills...',11,0,0,1,0,0,0,0,1,0,0,0,26124),
(67055,'You know, I\'ve been stuck in these cages watching the mogu a lot, but I\'m pretty sure I\'ve never seen a girl mogu.  What\'s with that?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(67056,'I was relieving myself into one of the golden pools when they caught me.  I guess you could call it a karma capture.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67057,'Ren bet me that I couldn\'t steal one of the mogu cannons.  I didn\'t think they\'d be so heavy!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67058,'That\'s the last time I\'ll let them catch me, promise.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67059,'What took you so long?  I almost thought they weren\'t going to send someone for me this time... my heart frowned a little.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(67060,'I\'ve made a mental note, mogu are light sleepers.  Pass the word.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67061,'It feels so good to stretch my limbs!  It was cramped in there.  They really should invest in more roomy cages!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67062,'Thanks!','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(67063,'','Ah, these kids never run out of energy!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(67064,'','Don\'t come crying to me when you fall and scuff your knees!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(67065,'','They do that all day.  I get exhausted just looking at them.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67066,'Not much so far, but the day is young.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(67067,'I see them wiggling around in the water, but they aren\'t biting!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(67068,'Haven\'t had much luck. I think it\'s my bait.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(67069,'I could use another emergency buoy, Arie.','I could use another emergency buoy, Arie.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67070,'','Remember - fly through 10 checkpoint flags, then fly under the finish line.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67071,'','The pennants mark the race course, but you will not be penalized for finding other routes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67072,'','You may find that other paths are faster.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67073,'','I have shown you part of the course. Now, let us see the finish line. Follow me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67074,'','Remember, in a real race, you will compete against the other trainees in the Order.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67075,'','This is the finish line. After you have flown through all 10 checkpoints, fly under the finish line to lock in your place.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67076,'','Remember, fly UNDER the finish line!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67077,'','That concludes our lesson.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67078,'If you seek to learn more of the herbalism arts, I suggest you speak to Han Flowerbloom at the Halfhill Market in the Valley of the Four Winds.$B$BI will mark his  position for you.','If you seek to learn more of the herbalism arts, I suggest you speak to Han Flowerbloom at the Halfhill Market in the Valley of the Four Winds.$B$BI will mark his  position for you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67079,'You are looking for the apothecary. He makes some truly wonderful potions and tinctures. Got rid of my rash in no time!$B$BAhem... Victor Pearce sells his wares in the chamber of masters. I will mark the location on your map.','You are looking for the apothecary. He makes some truly wonderful potions and tinctures. Got rid of my rash in no time!$B$BAhem... Victor Pearce sells his wares in the chamber of masters. I will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67080,'','The stakes will be high.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67081,'','The faster you race, the better your prize.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67082,'Don\'t see what you need in the city?$B$BWhat are you looking for? Maybe I can help you find it.','Don\'t see what you need in the city?$B$BWhat are you looking for? Maybe I can help you find it.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67083,'There are no battlemasters here in the Vale.$B$BYou must return to your home city to queue for battlegrounds or arenas of war.','There are no battlemasters here in the Vale.$B$BYou must return to your home city to queue for battlegrounds or arenas of war.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67084,'Oh, looking for your class trainer? Unfortunately none of them have made it here to the Vale of Eternal Blossoms.$B$BYou can return to your home city to find those.','Oh, looking for your class trainer? Unfortunately none of them have made it here to the Vale of Eternal Blossoms.$B$BYou can return to your home city to find those.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67085,'Ogo, I need another Pot of Fire.','Ogo, I need another Pot of Fire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67086,'Transmogrification and Void Storage services can be found in your home city.','Transmogrification and Void Storage services can be found in your home city.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67087,'Ah, what quartermaster are you searching for? Perhaps I can help you find them.','Ah, what quartermaster are you searching for? Perhaps I can help you find them.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67088,'','Take care, friend!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67089,'','May the winds be kind to you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67090,'','Be sure to stop by again soon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67091,'','Safe journey, traveler!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67092,'You can find the Conquest Quartermaster and the Glorious Conquest Quartermaster on the Serpent\'s Spine to the west.$B$BI will mark their location on your map.','You can find the Conquest Quartermaster and the Glorious Conquest Quartermaster on the Serpent\'s Spine to the west.$B$BI will mark their location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67093,'The Honor Quartermaster can be found on the Serpent\'s Spine, the great wall to the west.$B$BI will mark their location on your map for you.','The Honor Quartermaster can be found on the Serpent\'s Spine, the great wall to the west.$B$BI will mark their location on your map for you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67094,'You can trade your marks of justice with Commander Lo Ping, who can be found at Niuzao Temple in the Townlong Steppes.$B$BI will mark his location on your map.','You can trade your marks of justice with Commander Lo Ping, who can be found at Niuzao Temple in the Townlong Steppes.$B$BI will mark his location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67095,'The valor quartermaster, Commander Oxheart, can be found at Niuzao Temple in the Townlong Steppes.$B$BI will mark her location on your map.','The valor quartermaster, Commander Oxheart, can be found at Niuzao Temple in the Townlong Steppes.$B$BI will mark her location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67096,'Uncle Deming got me a goldfish for my birthday. He calls it Su-Shi.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67097,'But papa said I fed him too much, so he got fat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67098,'He outgrew his bowl, so now we keep him in this pond!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(67099,'It\'s okay. I think he likes it there.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67100,'You like it here, don\'t you Su-Shi?','',0,0,0,0,0,0,20,0,1,0,0,0,26124),
(67101,'Looking to find the Anglers Quartermaster? That would be Nat Pagle. You can find him at the Anglers Wharf in Krasarang Wilds.$B$BLet me mark the location on your map for you.','Looking to find the Anglers Quartermaster? That would be Nat Pagle. You can find him at the Anglers Wharf in Krasarang Wilds.$B$BLet me mark the location on your map for you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67102,'Here you go, Su-Shi. You\'re my best friend!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67103,'The August Celestials quartermaster can be found here in the Vale. Sage Lotusbloom stands with the other faction representatives, in the lower section of The Golden Terrace.$B$BI will mark her location on your map.','The August Celestials quartermaster can be found here in the Vale. Sage Lotusbloom stands with the other faction representatives, in the lower section of The Golden Terrace.$B$BI will mark her location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67104,'You need to talk to Teng Thundermalt! He can be found at the Stormstout Brewery in the Valley of the Four Winds.$B$BLet me mark the location on your map for you.','You need to talk to Teng Thundermalt! He can be found at the Stormstout Brewery in the Valley of the Four Winds.$B$BLet me mark the location on your map for you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67105,'Ah, you seek Jaluu the Generous! He can be found walking around the steps of Mogu\'shan Palace, here in the Vale of Eternal Blossoms.$B$BI will mark his location on your map for you.','Ah, you seek Jaluu the Generous! He can be found walking around the steps of Mogu\'shan Palace, here in the Vale of Eternal Blossoms.$B$BI will mark his location on your map for you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67106,'Hmmm, I\'m afraid I know little of the Klaxxi, but I have heard whispers of their city, Klaxxi\'vess, far to the west in the Dread Wastes. Perhaps you can find the Klaxxi Quartermaster there.$B$BI will mark the location on your map.','Hmmm, I\'m afraid I know little of the Klaxxi, but I have heard whispers of their city, Klaxxi\'vess, far to the west in the Dread Wastes. Perhaps you can find the Klaxxi Quartermaster there.$B$BI will mark the location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67107,'You seek Tan Shin Tiao. She can be found in the Seat of Knowledge, above Mogu\'shan Palace here in the Vale of Eternal Blossoms.$B$BI will mark her location on your map.','You seek Tan Shin Tiao. She can be found in the Seat of Knowledge, above Mogu\'shan Palace here in the Vale of Eternal Blossoms.$B$BI will mark her location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67108,'San Redscale is the quartermaster for the Order of the Cloud Serpent.$B$BYou can find him at The Arboretum in The Jade Forest.$B$BI will mark his location on your map.','San Redscale is the quartermaster for the Order of the Cloud Serpent.$B$BYou can find him at The Arboretum in The Jade Forest.$B$BI will mark his location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67109,'The Shado-Pan quartermaster can be found at the Shado-Pan Garrison in the Townlong Steppes.$B$BI will mark their location on your map.','The Shado-Pan quartermaster can be found at the Shado-Pan Garrison in the Townlong Steppes.$B$BI will mark their location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67110,'If you\'re looking for the Tillers quartermaster, Gina Mudclaw\'s your girl. She\'ll be running the market at Halfhill.$B$BLet me mark her location on your map.','If you\'re looking for the Tillers quartermaster, Gina Mudclaw\'s your girl. She\'ll be running the market at Halfhill.$B$BLet me mark her location on your map.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67111,'','Death to all who dare challenge my empire!',0,0,0,0,0,0,0,0,7,0,0,29283,26124),
(67112,'','Gyrocopter Attack!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67113,'I challenge you!','I challenge you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67114,'','Let\'s just try the Gyrocopter Attack again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67115,'','I\'m out of ideas. Gyrocopter Attack?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67116,'','Why...why him? We are simple farmers...what did we do to deserve this?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67117,'','Gy... ro... cop...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67118,'What\'s wrong?','What\'s wrong?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67119,'','My husband wanted to see what was happening down by the water. That\'s when...when...$B$B<Elder Yoon Su begins to sob uncontrollably.>',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(67120,'','...ter...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67121,'Please, don\'t cry. What happened next?','Please, don\'t cry. What happened next?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67122,'','A rogue bomb from the battle flew towards us. I survived, but...my husband...',1,18,0,0,2,0,0,0,1,0,0,0,26124),
(67123,'Imma runnin away.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67124,'Um, Fran, it looks like I somehow lost your watering can.  May I have another, please?','Um, Fran, it looks like I somehow lost your watering can.  May I have another, please?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67125,'I found this jar of bugs in a shack in the middle of Kun-Lai. I didn\'t think anything of it until I saw the letters...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67126,'It has to be a message! Maybe even a clue to something important!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67127,'You just don\'t get it! This could be a herald to the end times!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67128,'','What letters? Oh, the ones on the lid? It\'s probably just someone\'s intials. It doesn\'t mean anything.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67129,'','Waaaaauughh!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67130,'','Don\'t be ridiculous. It\'s just a jar full of bugs. It\'s gross if you ask me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67131,'','That\'s crazy talk! See, this is why we shouldn\'t leave the village!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67132,'Good idea!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67133,'','You do that. I bet it\'s just going to lead you in a giant circle and you\'ll never find the answer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67134,'Well, I\'m going to follow the clue and see where it leads me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67135,'','Be careful with that thing, Jun-Jun! One strong gust of wind could carry you into the sea!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67137,'','My goodness, Duyi. What have you been feeding that thing?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(67138,'','Maybe we should feed YOU to that fish!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(67139,'','Duyi the Fish Snack! Hah!',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(67141,'','That is an awfully impressive weapon for someone that comes in peace, stranger.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67142,'Imma healin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67143,'Wow, Duyi. What have you got there?','Wow, Duyi. What have you got there?',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(67144,'Bow to me and we shall begin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67145,'<Duyi looks at you, beaming with pride.>','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(67146,'','You are welcome here, $r. Please, make yourself at home. There is plenty of food and ale, and there\'s a bed upstairs if you need to rest.\n\n<Maolin smiles warmly at you.>',2,0,0,0,0,0,2,0,1,0,0,0,26124),
(67147,'Thank you, Maolin.','Thank you, Maolin.',4,0,0,0,0,0,2,0,1,0,0,0,26124),
(67149,'All right, ladies! Watch this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67150,'Impressive! I\'m going to have to watch out for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67151,'I win this round, rookie!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67152,'','Your power is impressive.  I admit defeat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67153,'Why should we trade with you? How are you any different than your Horde friends save the color of your banner?','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(67154,'I am the sole protector of this village. My name is Chut Sri Nu.$B$BI bid you welcome, but know that my meditation has shown me that your travels here will bring great change to this land. Let us both hope that you leave Pandaria better off than you found it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67155,'What of Jor Jor? He seems to protect the mayor.','What of Jor Jor? He seems to protect the mayor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67156,'Jor Jor hails from the Valley of the Four Winds. Born a farmer\'s child, he left his home to come here when he heard of your arrival. He believes himself a warrior, but I can assure you he is but an arrogant youth, longing for the thrill of combat without ever having endured its horrors.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67157,'Ah, the winds spoke of newcomers to our village. I feel that we will learn much from each other, so long as our minds are open and our spirits pure.$B$BPerhaps your people will be more respectful of mine than the Horde was.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67158,'Explore Pandaria, but be cautious. This land holds great bounty and danger alike to the unwary.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67159,'The ground beneath your feet lives and breathes. It may hold you steadily right now, but bring war and suffering here and it will respond in kind. Such is the way of nature.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67160,'Awww, I knew you\'d win! I\'d better practice some more...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67161,'Let\'s both do our best!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67162,'<Roars.>','',0,0,0,0,0,0,0,0,7,0,28232,0,26124),
(67163,'Let\'s see which one of us is the better student. I challenge you to a duel!','Let\'s see which one of us is the better student. I challenge you to a duel!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67164,'','Our village is small, but my family has been producing Pandaria\'s finest cider atop these hills for generations.$B$BI want nothing more than for peace to return so that we may collect our harvest and reunite with our children.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67165,'Hey buddy! I\'m a little busy at the moment. Talk to me when I\'m done creaming this rookie!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67166,'','Your attacks are strong, but my defenses are stronger!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67167,'','You need more focus.  Try again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67168,'Fishing is good for the soul, but crabbing is good for the belly!','',2,0,0,0,0,0,2,0,1,0,0,0,26124),
(67169,'','Isn\'t it beautiful? Such grace it has, as it dances in the sky. One day, I hope to be as graceful as the crane.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67170,'$n caused Retaliation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67171,'Sorry, I\'m a little pre-occupied at the moment. This is my chance to show off for the ladies. Talk to me after I\'ve won this fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67172,'Bowing out so soon? I knew you weren\'t up to the challenge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67173,'','Master Kistane is about to get healing from a Jade Serpent Statue.  Use Spear Hand Strike on her and defeat her before she can heal herself again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67174,'I lost again! I\'d better keep training.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67175,'I win this time. It seems that you are the one who needs more training.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67176,'There\'s no running away from a challenge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67177,'','May our ancestors protect us from these outsiders and their violent ways.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67178,'What matter of creature are you? So strange...','',0,25,0,0,0,0,0,0,1,0,0,0,26124),
(67179,'The last newcomers stole our children. What are you here for? Our wives? Our ale?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67180,'Master Hsu has inflicted you with a deadly poison! Use Detox to remove it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67181,'This used to be a peaceful brewing village. Now, the horrors of war have already robbed our children of their innocence.$B$BTake your war elsewhere, $r.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67182,'','Hey $n, I\'m in the middle of something right now. I need to concentrate!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67183,'','I feel a rush of energy coming on. Let\'s do this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67184,'','Darnit, I lost! Oof... I feel tired...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67185,'','Running away? I guess I\'m pretty scary after all!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67186,'','Ha! Suchi wins this round.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67187,'','I\'m busying showing this rookie the back of my fist!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67188,'','Let\'s see who is stronger serpent rider.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67189,'','Running away? Come face me again when you have found your courage.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67190,'','What? I... I lost? Auuugh! I\'ll have to work harder to beat you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67191,'','Just as I expected. You are too weak to defeat me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67192,'PH - My attention is elsewhere. Please speak to me in a moment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67193,'Let us begin. Good luck.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67194,'It is better to face your challenges, than to run from them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67195,'You have bested me fairly. Well done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67196,'I win this round. Better luck next time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67197,'I\'m hesitant to ask an outsider for help. Still, if you\'re offering...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67198,'Thank you again for your aid, $n. Our children have returned safe, and your enemies have turned tail.$b$bAs far as I\'m concerned, you and your Horde are always welcome here in Pandaria.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67199,'Outsiders are rare here. Rarer still are outsiders who arrive on a floating ship of death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67200,'Greetings, outsider.$b$b<Zin eyes you warily.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67201,'Thanks, $g mister:lady;! That guy smelled.','Thanks, $g mister:lady;! That guy smelled.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67202,'I can leave now?','I can leave now?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67203,'Can... can I go home?','Can... can I go home?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67204,'Using the hammer was fun, but I think I\'m ready to go home now.','Using the hammer was fun, but I think I\'m ready to go home now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67205,'Get me out of here!','Get me out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67206,'Mama! I\'m coming home, Mama!','Mama! I\'m coming home, Mama!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67207,'I miss my home!','I miss my home!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67208,'Thanks! I don\'t like the Alliance.','Thanks! I don\'t like the Alliance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67209,'','Look at you, you\'re so skinny! You need to eat more!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67210,'','It is not my decision whether you are to be trusted by my people. Until our mayor decides otherwise, I consider you a friend.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67211,'','Not long ago, we knew nothing but the simple life of brewing fine cider. So much has changed in so little time.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67212,'I am ready to start the Sky Race.','I am ready to start the Sky Race.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67213,'I need another mount for the Sky Race.','I need another mount for the Sky Race.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67214,'','The winds of change can bring anything, from a terrible storm to a bountiful harvest. It seems this time they have brought you.$B$BNow, I wonder, are you a storm or a harvest?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67215,'','Sister, we must act! If we do nothing, we will lose our entire harvest to a war we have no part in!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(67216,'','We will do what we can, dear sister. We are not warriors, we cannot simply drive the outsiders away.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67217,'','What of Chut? Why does he continue to train in his dojo? He should be protecting us!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(67218,'','Chut will protect us if we are further endangered. He always has.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67219,'','I hope you\'re right. I really do.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67220,'','Welcome to Paw\'don Village, outsider. I do not know why you have come, but you certainly look like you could use a rest.$B$BWhy not sit back with a fine cup of cider and let your worries fall away?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67221,'Why have you come to our village, outsiders?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(67222,'We are here on a rescue mission.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67224,'They come here for war! Did you not see how they massacred the other outsiders?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(67225,'','You do not understand. The Horde are monsters! We are nothing like them.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67226,'Enough, all of you! You have combated those who stole our children. That is reason enough for me to give you a chance to further prove yourself worthy of our trust.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67227,'Nevermore!','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(67228,'Your control over Kovok weakens as you leave Dread Wastes! Return now!','Your control over Kovok weakens as you leave Dread Wastes! Return now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67229,'Congratulations!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67230,'I\'ll drink to that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67231,'','I always knew you could do it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67232,'Someone has come to save us? Perhaps all is not lost...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67233,'<Your serpent looks at you with a curious expression.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67234,'I don\'t know about this \"Alliance\", but you look trustworthy. I\'ll gather everyone up and meet you when we\'re ready to rebuild!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67235,'<Your serpent smiles at you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67236,'I don\'t know about this \"Horde\", but you look trustworthy. I\'ll gather everyone up and meet you when we\'re ready to rebuild!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67237,'<Your serpent grunts at you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67238,'<Your serpent watches you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67239,'<Your serpent looks at you with a bored expression.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67240,'<Your serpent flies around gracefully.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67241,'<Your serpent rubs its scales against your arm.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67242,'<Your serpent nudges you, almost knocking you over.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67243,'<The hatchling looks at you with a curious expression.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67244,'<The hatchling smiles at you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67245,'<The hatchling grunts at you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67246,'<The hatchling watches you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67247,'<The hatchling looks at you with a bored expression.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67248,'<The hatchling flies around gracefully.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67249,'<The hatchling rubs its scales against your arm.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67250,'<The hatchling nudges you, almost knocking you over.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67251,'Don\'t you beasts know when to give up?','',0,0,0,0,0,0,0,0,1,0,32462,0,26124),
(67252,'Filthy animals! Keep your stink away from this land!','',0,0,0,0,0,0,0,0,1,0,32463,0,26124),
(67253,'NO... I\'ve let my king down. I... I...','',0,0,0,0,0,0,0,0,1,0,32464,0,26124),
(67254,'Your Horde has no power here.','',0,0,0,0,0,0,0,0,1,0,32465,0,26124),
(67256,'','Don\'t be sour when you lose to me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67257,'','Don\'t worry. You can cry on my shoulder if you lose.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67258,'','I may look sweet, but I\'m still aiming for first prize!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67259,'','My victory will be sweet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67260,'','I will be a gracious winner, I promise!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67261,'I have been training hard all week. My hard work will pay off with a victory.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67262,'Don\'t worry. I will be honorable in victory.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67263,'I will concentrate on a first place finish.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67264,'With my winning strategy, I cannot lose.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67265,'Master Yoon is healing, interrupt him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67266,'AAAHHHHH!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67267,'Welcome to the Order of the Cloud Serpent. Only those exalted with our Order may acquire our cloud serpents.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67268,'Welcome, serpent rider! I have beautiful cloud serpents for you to browse at your leisure.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67269,'','Well done, $n. The cloud serpent that you have raised is now yours. Your journey together... is just beginning.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67270,'Decided to go for a swim, did you?  Well, you\'re still in one piece, so no harm done I suppose.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67271,'','Just... need a second.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67272,'We must take caution in reacting against the recent events on our shores. Paw\'don is a small brewing town, not a fortress of war.$B$BYou would do well to urge your leaders to take similar caution in their judgment of my people. We do not seek combat, but we will provide it if necessary.$B$BI must meditate on this affair.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67273,'','My people have faced many trials...but never have we encountered anything like this.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67274,'','Your war has brought unprecedented destruction here. Even the mantid are less of a threat than your flying machines and bombs.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67275,'','I\'ve already alerted the Shado-Pan of what\'s happened here. Hopefully they can do something.$B$BI feel as though we are all woefully unprepared for the coming trials we are to face.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67276,'The hatchling loves you, too!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67277,'The hatchling nudges your arm affectionately.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67278,'The hatchling likes being petted!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67279,'The hatchling thinks you should excuse yourself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67280,'The hatchling thinks you are very funny.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67281,'Rifling the bait','Rifling the bait',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67282,'The hatchling is happy to see you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67283,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67284,'In the sky! It approaches!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67285,'There it is! Get ready!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67286,'You may fish here, but please keep it short. I like my privacy.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(67287,'','Good luck, Ace!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67288,'','You can do it, Ace!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67289,'','Eeeee! I love you Ace!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67290,'','I\'ll be cheering for you, Ace!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67291,'','That wasn\'t much of a fight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67292,'','I knew you could do it, Ace!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67293,'','You\'re the best trainer here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67294,'','Ace, you\'re the best!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67295,'','Did you see his feet?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67296,'','Go Ace!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67299,'','You are so cool, Ace!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67300,'','Awww, you should have won that one, Ace!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67301,'','Nooo! How could he lose?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67302,'','I still love you, Ace!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67303,'','Rematch!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67304,'','You\'ll win the next one, Ace!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67305,'','You did it, Ace!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67306,'','Beat them to a pulp, Ace!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67308,'','Oooh, look at his muscles!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67309,'','Take off your shirt, Ace!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67310,'','You have plenty of time before the next Sky Race to meditate on what you have learned. On race days, speak to me to enter the competition.',0,0,0,0,0,0,0,0,1,18572,0,0,26124),
(67311,'Master Cheng is burning you alive!  Move!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67312,'You smelly hozun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67313,'Your face is dumb Muno!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67314,'Eat turnip Muno!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67315,'No stupid hozun on our farm! Go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67316,'You gonna get shovel upside head!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67317,'You virmen smell like rotten turnip and yak dooker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67318,'','I am defeated.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67319,'You have done much today, $n. Rest and return tomorrow.','You have done much today, $n. Rest and return tomorrow.',0,0,0,0,0,0,0,0,1,18588,0,0,26124),
(67320,'You have done much today, $n. Rest and return tomorrow.','You have done much today, $n. Rest and return tomorrow.',0,0,0,0,0,0,0,0,1,18593,0,0,26124),
(67322,'You have done all you can for the serpents on the island today. Come back tomorrow to resume your training.','You have done all you can for the serpents on the island today. Come back tomorrow to resume your training.',0,0,0,0,0,0,0,0,1,18589,0,0,26124),
(67323,'You have done all you can for the serpents on the island today. Come back tomorrow to resume your training.','You have done all you can for the serpents on the island today. Come back tomorrow to resume your training.',0,0,0,0,0,0,0,0,1,18597,0,0,26124),
(67324,'You have done all that you can for your hatchling today. I will keep it safe, but remember to return tomorrow to check on its progress.','You have done all that you can for your hatchling today. I will keep it safe, but remember to return tomorrow to check on its progress.',0,0,0,0,0,0,0,0,1,18590,0,0,26124),
(67326,'Our fight against the sha can continue tomorrow. For now, rest.','Our fight against the sha can continue tomorrow. For now, rest.',0,0,0,0,0,0,0,0,1,18600,0,0,26124),
(67327,'You\'ve done much work today, $n. We will resume your training tomorrow.','You\'ve done much work today, $n. We will resume your training tomorrow.',0,0,0,0,0,0,0,0,1,18602,0,0,26124),
(67328,'I thought I sensed a disturbance.  I see you have defeated my assistants.  Now you may face me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67329,'Well done, $n! You must be tired after participating in the race. Go and get some rest. There will be plenty of tasks waiting for you here tomorrow.','Well done, $n! You must be tired after participating in the race. Go and get some rest. There will be plenty of tasks waiting for you here tomorrow.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67330,'You want some more of Zunta, eh?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67331,'Ho, $n! That was some big mess you cleaned up! Well, I\'d say you did your \"duty\" for the day. Go and get some rest. Plenty to do here tomorrow!','Ho, $n! That was some big mess you cleaned up! Well, I\'d say you did your \"duty\" for the day. Go and get some rest. Plenty to do here tomorrow!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67332,'Thank goodness you recovered the brew, $n! Since our work is done for the day, I\'d say it\'s time to start drinking!','Thank goodness you recovered the brew, $n! Since our work is done for the day, I\'d say it\'s time to start drinking!',0,0,0,0,0,0,0,0,1,18602,0,0,26124),
(67333,'You are caring for your serpent well, $n. You have done all that you can for today. Make sure you come check on the serpent again tomorrow.','You are caring for your serpent well, $n. You have done all that you can for today. Make sure you come check on the serpent again tomorrow.',0,0,0,0,0,0,0,0,1,18600,0,0,26124),
(67335,'Bring it on!','Bring it on!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67336,'Come at me!','Come at me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67337,'Let\'s do it!','Let\'s do it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67338,'Prepare yourself!','Prepare yourself!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67339,'','Speak to me when you are ready to race, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67340,'My mantid stuffs! Go away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67341,'Look for Audrey Burnhep just outside the city, north of the Dwarven District, near the lakeside cabin.','Look for Audrey Burnhep just outside the city, north of the Dwarven District, near the lakeside cabin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67342,'Battle Pet Trainer','Battle Pet Trainer',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67343,'Look for the orc Varzok atop the city\'s central mesa, just east of the Flight Master.','Look for the orc Varzok atop the city\'s central mesa, just east of the Flight Master.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(67344,'','Master Cheng is spinning!  Paralyze her!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67345,'Thanks, Wikky!','Thanks, Wikky!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67346,'Look what Wikky found!','Look what Wikky found!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67347,'','Such is the fate of those who question authority.',0,0,0,0,0,0,0,0,7,0,0,29273,26124),
(67348,'%s goes into a desperate rage!','%s goes into a desperate rage!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67349,'Do you know how to say \'Crackling Jade Lightning\' in Taur-ahe? How about Thalassian? Nazja?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67350,'I wish to challenge you.','I wish to challenge you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67351,'Yes, that\'s the stuff! Our cider is prized throughout the Jade Forest. I hope I can carry them all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67352,'Pandaria has not seen a full-scale war since the mists closed in. The Shado-Pan usually handle any trouble that crops up on the continent.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67353,'Oof... I do not know what to make of your kind. Why have you brought your war to our shores? Why do you fight against this... Horde?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67354,'Mayor Khang is so worried, he called the Shado-Pan to deal with your arrival. I still cannot believe Lord Taran Zhu is here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67355,'We do not wish to enter your conflict. But I fear that when war is on the horizon, peace is not a choice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67356,'Ah, such troubling thoughts. Our last emperor advised us not to live in the shadow of fear. Do you see now why we love to drink and celebrate?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67357,'Invaders, all of you! Out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67358,'I am no warrior, but I, too, will help defend Paw\'don Village!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67359,'Begone from here, trespassers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67360,'Yeaaaarrrghhh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67361,'Get... out... of... my... orchard!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67362,'We must protect the brew!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67363,'I may not be a warrior, but I will protect my home and family!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67364,'Courage, Teng! The Applebloom family cider is at stake!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67365,'Let us go! The barrels are out in the orchard.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67366,'It is a very fancy ritual.','',0,0,0,0,0,0,1,168,1,0,0,0,26124),
(67367,'You would do well to not disrupt this fancy fancy ritual.','',0,0,0,0,0,0,1,168,1,0,0,0,26124),
(67368,'A Mischievous Snow Sprite emerges from the Suspicious Snow Pile.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67369,'Stay still and I don\'t think it\'ll attack us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67370,'Whatever you do, don\'t look like a carrot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67371,'Attack if it tries to cross this bridge!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67372,'I\'m used to fighting off the small ones...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67373,'Well look what we have here. Our first keg of recovered brew! I\'ll take this one, folks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67374,'I\'ve dabbled in various forms of restorative magic, from the power of the tides to the might of the divine, but my true calling will always be to the grace of the mists.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67375,'','We will continue to monitor the mogu\'s activity, $n. However, I am afraid that what lies ahead will require greater strength than you currently possess. Return to us when you have gained more experience.',0,0,0,0,0,0,0,0,1,13442,0,0,26124),
(67376,'','I like to offer my competitors something nice to eat. Before I crush them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67377,'I used to think it was priests that were overpowered. Now I think it\'s rogues.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67378,'I don\'t like to see fellow monks in pain. But I\'ll get over it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67379,'I wish to challenge you.','I wish to challenge you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67380,'Hight is always going on about the \'sheep tons\' of work we have to do. See if you can get him to say it. It\'s like a drinking game.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67381,'I wish to challenge you.','I wish to challenge you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67382,'No, I\'m the other Cheng. No relation. \n\nYes, I am a monk, though I always dreamed of being a demon hunter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67383,'I wish to challenge you.','I wish to challenge you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67384,'I wish to challenge you.','I wish to challenge you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67385,'I wish to challenge you.','I wish to challenge you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67386,'Well done.  Remember that swiftness of mind and body can keep you alive.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67387,'','Your power is impressive.  I admit defeat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67388,'I am defeated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67389,'Your power is impressive.  I admit defeat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67390,'Your power is impressive.  I admit defeat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67391,'The final wave of hozen ships has come to attack!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(67392,'Once you have defeated them, help your allies collect Jungle Brew for Bo!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(67395,'Surround them! Let none escape!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67396,'Rip the flesh from their bones!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67397,'Show them the might of the Trolls!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67398,'Make their deaths quick! We have much to do!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67399,'Sinan, may I please have the Wings of Hope again?','Sinan, may I please have the Wings of Hope again?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67400,'','Perhaps we could arrange the sale of some of our remaining goods for your gold? We\'ll need to purchase food and water from other villages now if we\'re to survive.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67401,'','You look as though you have endured much. Please, let me know if there\'s anything you\'d like to purchase to aid you in your travels.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67402,'I\'ll defend my home with my life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67403,'My children will not know war if I have anything say about it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67404,'Take one step closer and I\'ll...I\'ll...attack! I swear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67405,'','We have no quarrel with your people. Would you like to sample our wares?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(67406,'','We are known for trade, not war. Would you like to see what I have for sale?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67407,'A stray bomb from the firefight destroyed my farm. How am I supposed to survive like this?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67408,'Why not regrow your farm somewhere else? I\'m sure the other villagers would help you.','Why not regrow your farm somewhere else? I\'m sure the other villagers would help you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67409,'There is a bluff south of here that would make a fine farm. It overlooks a gorge. You may be right, stranger.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67410,'','I grow tired of this village. I wish I could travel and see the world. Maybe when I\'ve saved up enough gold, I\'ll go on my own epic adventure!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67411,'We are not warriors. I produce only tools and light weaponry for hunting.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67412,'Honeydew Village is ill-prepared for battle. I hope this fighting ends soon!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67413,'','Oh my...that is an impressive weapon.',24,0,0,0,0,0,0,0,1,0,0,0,26124),
(67414,'','Care to lay down and rest for a time? Surely that sounds better than fighting.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67415,'','Where did you obtain such exquisite armor? Can I...touch it?',6,24,0,0,1,0,0,0,1,0,0,0,26124),
(67416,'Food is essential to life. Even a brave $c such as yourself can take the time to sit down and enjoy the essence of life!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67417,'Many people forget that a fine brew has equal application in cooking as it does for drinking! There\'s nothing in all of Pandaria quite like my famous Honeydew glazed fish!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(67418,'Even in times of great strife like these, food is always needed and appreciated. It makes the hours I spend cooking well worth it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67419,'We\'ve got to get the brew to safety. My brews are the lifeblood of this entire town!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67420,'Clear the roads, the brew runner is coming!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67421,'Let him through! That strapping young pandaren is saving a keg of Honeybrew!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67422,'Brew coming through!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67423,'','It isn\'t ready to fly yet, sister!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(67424,'','We don\'t have a choice! We need to alert the other villages of what\'s going on here!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(67425,'','Please hurry. I want to get going.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67426,'','Bow to me and we shall begin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67427,'','Just give me a little more time, I can fix it. I know it.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67428,'','The Skyfire has had a complete overhaul since our encounter with Deathwing! We now carry a full complement of both fixed-wing and gyro aircraft as well as a battery of 18-inch smoothbore shore bombardment cannons.$b$bThe Horde won\'t be able to hide from her reach. Not on land, not at sea, not in the air.',1,274,0,0,0,0,0,0,1,0,0,0,26124),
(67429,'I am ready to depart.','I am ready to depart.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67430,'Feh! You\'re not welcome here!','',0,0,0,0,0,0,0,0,1,0,26993,0,26124),
(67431,'','A well-timed application of force to a pressure point will stop an opponent in their tracks, regardless of what they are doing.  Use this to your advantage to avoid dangerous attacks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67432,'Not all problems can be solved with your fists.  Sometimes you must center yourself and channel your energy towards a distant target.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67433,'Bow to me and we shall begin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67434,'As a monk, your reflexes are among your greatest resources.  Often, the ability to think and move quickly can save your life.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67435,'Sometimes the best defense is to prevent your opponent from acting against you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67436,'Some enemies gain most of their power from the weapon that they wield.  Me? I prefer both a large weapon and inflicting deadly poisons on my enemies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67437,'','Sometimes a well timed precision strike is all you need to take down even the toughest of foes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67438,'','Once you have learned to control your own actions, you must learn to control your opponent to gain the upper hand.  An opponent may expose a weakness when trying to heal themselves, allowing you an opportunity to interrupt them.  This can mean the difference between a victory and defeat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67439,'You are a very intriguing sort, $c. What longing in your heart has brought you to Pandaria? Is it the thirst for adventure? The thrill of battle? Or perhaps something more?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(67440,'These are not the first dark times we have endured. There is always a light at the edge of the shadows.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67441,'We have not known war here for a very long time. I hope for the good of us all that we may find peace soon.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67442,'','Bow to me and we shall begin.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67443,'What do we do? We\'re losing everything!','What do we do? We\'re losing everything!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67444,'If we lose our crops we\'ll lose our brew!','If we lose our crops we\'ll lose our brew!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67445,'Please, don\'t bring your battle here. We have no part in it!','Please, don\'t bring your battle here. We have no part in it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67446,'Fire! Fire!','Fire! Fire!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67447,'My family has guarded this town for generations. I pray that I will be able to uphold their legacy.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67448,'I would gladly give my life to ensure the safety of Honeydew Village. Its legacy is my own.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67449,'A monk\'s training never ceases. There is always a higher step to reach with both body and mind.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67450,'Why do you bring war and bloodshed to our land? Pandaria is a place of peace.','Why do you bring war and bloodshed to our land? Pandaria is a place of peace.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67451,'We may not be warriors by trade, but we will do anything to save our home and our land.','We may not be warriors by trade, but we will do anything to save our home and our land.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67452,'I fear that your arrival here will upset the land\'s delicate balance.','I fear that your arrival here will upset the land\'s delicate balance.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67453,'Gah, this thing\'s a death trap!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67454,'','Your flying death machine is a sign of the end times.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67455,'','Why do your people hate the other outsiders so? I do not understand it.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67456,'Let\'s see... if I just uncrank the fuel-chugger here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67457,'Why have you come here?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(67458,'I\'m pretty sure this \"valve\" is a toenail. Goblins...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67459,'%s mumbles to himself while tinkering with the shredder.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67460,'We have known nothing but peace for so long, I don\'t know how anyone is going to handle the arrival of war on our shores.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67461,'Why do you come here with armaments of war? What goal could you possibly have in your coming here involving war and bloodshed?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67462,'I\'ve always wondered when outsiders would breach out shores, and so now you have come.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67463,'Look at this - total amateur hour! Doesn\'t even have a second-stage turbine blade.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67464,'Yeesh! Me great nan could build a more reliable manifold than this. An\' she has!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67465,'Wait and see, lads. We\'ll have ourselves a fine killin\' machine in no time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67466,'Is that... a cherrywood drive-shaft? Who does that?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67467,'Level two grappling is done. Now to tighten up level three...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67468,'This was a simple town to oversee for my father. We spent some days growing crops, others brewing. Once a year we would travel to other villages to trade. It was a life that we all enjoyed.$B$BNow, the echoes of war bounce all around us, and we must navigate these troublesome times with care. I only hope we may find a resolution quickly.','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(67469,'I do not trust you, $r.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(67470,'I have seen many things in my life, but never have I encountered a creature as strange as you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67471,'Your people have an interesting practice of arrival to someone\'s home.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67472,'First you must prove yourself against my assistants.  Defeat them, and then you may face me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67473,'','We\'re clear. Let\'s keep moving.',1,274,0,0,0,0,1,0,1,0,0,0,26124),
(67474,'','This is as close as we can get. See what you can find out!',1,274,0,0,0,0,25,0,1,0,0,0,26124),
(67475,'I don\'t like how it\'s looking at the pumpkins...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67476,'It\'s just like an angry rabbit... except bigger... and toothier.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67477,'I\'m on important business for his majesty.$b$b\"Need to know\" buisness. And you don\'t need to know!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67478,'','My pets speak to me. They tell me stories late at night.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67479,'','That doesn\'t make any sense. Doublecheck your work.',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(67480,'','You be feelin\' dis fight for a long time.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67481,'How very strange. I wouldn\'t call these waters enchanted, but there\'s a faint residual energy.','',1,274,0,0,0,0,6,0,1,0,0,0,26124),
(67482,'It\'s similar to a pattern I once noted in Sholazar Basin.','',1,274,0,0,0,0,1,0,1,0,0,0,26124),
(67483,'...There\'s definitely something going on here. Before we return, perhaps we should collect some of the enlarged vegetables they grow in this region?','',1,274,0,0,0,0,1,0,1,0,0,0,26124),
(67484,'FOR THE HORDE!!','FOR THE HORDE!!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(67485,'Victory or death!','Victory or death!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(67486,'For the warchief!','For the warchief!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(67487,'OW!','',1,274,0,0,0,0,0,0,1,0,0,0,26124),
(67488,'You crazy! Girl, YOU CRAZY!','',1,274,0,0,0,0,5,0,1,0,0,0,26124),
(67489,'','He is creating a new world for us. He is not... making a salad!',1,0,0,0,0,0,5,0,1,0,0,0,26124),
(67490,'','You must focus on your training!  Try again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67491,'Watched you investigating the ship and dealing with those creatures down there. Good work. You find anything?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67492,'No.','No.',0,0,0,0,0,0,274,0,1,54167,0,0,26124),
(67493,'Are you two going to order anything?','Are you two going to order anything?',0,0,0,0,0,0,6,0,1,54167,0,0,26124),
(67494,'Alliance \"hero.\" Let\'s see how you fight without a flying warship to cover your back!','',0,0,0,0,0,0,1,0,1,0,32468,0,26124),
(67495,'There\'s something about this land - you don\'t understand...','',0,0,0,0,0,0,1,0,1,0,32469,0,26124),
(67496,'They defied us - they defied Hellscream\'s Horde - I should\'ve executed the whole town!','',0,0,0,0,0,0,1,0,1,0,32470,0,26124),
(67497,'Burn, Alliance scum! BURN!','',0,0,0,0,0,0,1,0,1,0,32471,0,26124),
(67498,'This land will be your grave.','',0,0,0,0,0,0,1,0,1,0,32472,0,26124),
(67499,'No! Smash! I said smash!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(67500,'You are my favorite teacher ever!','You are my favorite teacher ever!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67501,'What brews do you have available?','What brews do you have available?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67502,'Greetings, $n.  I have a fine selection of brews available for you.  If you are interested, I can also teach you to make your own.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67503,'','Admiral! It\'s good to see that you are okay.',0,0,0,0,0,0,3,0,1,0,0,32554,26124),
(67504,'','I\'m afraid you\'ll have to push forward without us.',0,0,0,0,0,0,1,0,1,0,0,32555,26124),
(67505,'','I\'ve been ordered back to the main battlegroup to provide carrier escort. The full might of the Alliance navy will arrive in two months\' time.',0,0,0,0,0,0,1,0,1,0,0,32556,26124),
(67506,'','Put on your big-boy pants, Taylor. I will leave the SI:7 officers with you. I suggest a scouting mission.',0,0,0,0,0,0,11,0,1,0,0,32557,26124),
(67507,'','Maybe you can recruit some of the locals. I\'ll leave the situation here in your capable hands.',0,0,0,0,0,0,1,0,1,0,0,32558,26124),
(67508,'Thank you, Catherine. It\'s good that you\'re here: With full carrier support we can push north-','',0,0,0,0,0,0,1,0,1,0,32436,0,26124),
(67509,'What?','',0,0,0,0,0,0,6,0,1,0,32437,0,26124),
(67510,'What am I supposed to do until then? I\'ve got no men! We don\'t know where the Horde are, or how many we\'re dealing with!','',0,0,0,0,0,0,5,0,1,0,32438,0,26124),
(67511,'Yes, Admiral.','',0,0,0,0,0,0,273,0,1,0,32439,0,26124),
(67512,'Godspeed.','',0,0,0,0,0,0,66,0,1,0,32440,0,26124),
(67513,'\"Improvise.\" Humph.','',0,0,0,0,0,0,274,0,1,0,32441,0,26124),
(67514,'Nightwind! Take your men and scout the interior. Look for a Horde presence. And find Prince Anduin!','',0,0,0,0,0,0,25,0,1,0,32442,0,26124),
(67515,'Stupid snake. I said shoot fire!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(67516,'','This land has endured much, and yet it thrives in the wake of the worldbreaker. You will find that my pets possess similar fortitude.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67517,'Prepare yourself, $n.$b$bWe\'ll be entering a target-rich environment!','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(67518,'I\'m ready to go, General.','I\'m ready to go, General.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(67519,'Ow.  That really hurts.  Not.','Ow.  That really hurts.  Not.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67520,'Oooh.  Mr. Big Mean Mogu.  I\'m so scared.','Oooh.  Mr. Big Mean Mogu.  I\'m so scared.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67521,'Bring it on, jerk.','Bring it on, jerk.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67522,'You want a piece of me?','You want a piece of me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67523,'','Thank the Light you\'re here, $n.  Something has gone horribly wrong and our leader is killing everyone!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67524,'','Please hurry!  I must stay and tend to the wounded.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67526,'','Many thanks! $B$BThe local earth spirit, Hui, is angry that we hired adventurers to drive off his mischievous sprites. $B$BI can understand he\'s upset, but this attack is simply going too far!',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(67527,'','Many thanks!',1,0,0,0,0,0,4,0,1,0,0,0,26124),
(67528,'','The local earth spirit, Hui, is angry that we hired adventurers to drive off his mischievous sprites.',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(67529,'','I can understand he\'s upset, but this attack is simply going too far!',1,0,0,0,0,0,5,0,1,0,0,0,26124),
(67530,'That\'s all you got?','That\'s all you got?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67531,'That doesn\'t even tickle.','That doesn\'t even tickle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67532,'You\'re not very good at this torture thing.','You\'re not very good at this torture thing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67533,'Is that supposed to hurt?','Is that supposed to hurt?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67534,'*Yawn*','*Yawn*',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67535,'Sometimes these goons make it too easy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67536,'This is not what he was expecting at all.','',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(67537,'Get ready to die, $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67538,'I\'ll put a bolt through that thick skull of yours!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67539,'Yes, that\'s it... stand right there...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67540,'Don\'t move, $r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67541,'Hold still, beast!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67542,'Finally... something worth fighting.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67543,'','Let\'s keep moving.',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(67544,'Get me OUT OF HERE!','Get me OUT OF HERE!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(67545,'I... I thought I\'d be here forever...','I... I thought I\'d be here forever...',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67546,'Can... can I go home?','Can... can I go home?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(67547,'I thought those eyes would NEVER leave me alone!','I thought those eyes would NEVER leave me alone!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(67548,'I know the way home. Thanks, $gmister:lady;!','I know the way home. Thanks, $gmister:lady;!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67549,'Papa! I\'m coming home, Papa!','Mama! I\'m coming home, Mama!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67550,'I miss my family. I miss my home!','I miss my family. I miss my home!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67551,'Thanks! I don\'t like the Horde.','Thanks! I don\'t like the Horde.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67552,'Horde invaders! Men, to arms!','Horde invaders! Men, to arms!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67553,'Victory to the Alliance!','Victory to the Alliance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67554,'Pandaria will be ours, mongrel!','Pandaria will be ours, mongrel!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67555,'Keep your filthy hide out of our base!','Keep your filthy hide out of our base!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67556,'Death to the Horde!','Death to the Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67557,'Die, Horde scum!','Die, Horde scum!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67558,'Hey!','Hey!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67559,'I thought I smelled something...','I thought I smelled something...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67560,'You won\'t escape alive, $r!','You won\'t escape alive, $r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67561,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67562,'Pandaria will be ours!','Pandaria will be ours!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67563,'Finally, an enemy worth fighting.','Finally, an enemy worth fighting.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67564,'Death to the Alliance!','Death to the Alliance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67565,'I\'m going to enjoy this...','I\'m going to enjoy this...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67566,'For Hellscream!','For Hellscream!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67567,'Puny $r...','Puny $r...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67568,'','%s examines the waters of the Vale closely.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67569,'You look delicious...','You look delicious...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67570,'For the glory of the Dark Lady!','For the glory of the Dark Lady!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67571,'You\'ll make a fine corpse, $c.','You\'ll make a fine corpse, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67572,'Greetins $n.  You want to learn the art of workin with leather?  I also got a fine selection of crafted goods if that\'s whatcha need.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67573,'Let me browse your wares.','Let me browse your wares.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67574,'Hellscream\'s armies will paint this land red!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67575,'Greetings $n.  Are you interested in the mystical art of Inscription, or perhaps the intricacies of Herbalism?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67576,'','I do not fear you, $r. You would be wise to fear me...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67577,'I\'ve spent enough time with clumsy XX here that I\'ve picked up a thing or two about treating injuries.  Perhaps I can pass some of that along to you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67578,'No hozen num nums for you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67579,'Steal jab-jab from wikket!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67580,'Kill the wikket!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67581,'Do you think the pandaren realized what they were sitting on here?','',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(67582,'Maybe they\'ve known all along. Maybe that\'s why they\'ve stayed hidden.','',1,0,0,0,0,0,6,0,1,0,0,0,26124),
(67583,'','Just gather what we need and let him figure it out. Are you ready? Let\'s move.',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(67584,'Wrathion\'s agents whisper quietly to one another.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67585,'The horrors I witnessed...','The horrors I witnessed...',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(67586,'Never again.','Never again.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(67587,'The %s smirks at $n.','',1,0,0,0,0,0,274,0,1,0,0,0,26124),
(67588,'I will make these beasts pay...','I will make these beasts pay...',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(67589,'I owe you greatly, friend.','I owe you greatly, friend.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(67590,'','What are you waiting for?  The initiates need your help!',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(67591,'No, I don\'t know what\'s inside, either.','',1,0,0,0,0,0,6,0,1,0,0,0,26124),
(67592,'By our sweat and your blood, this land WILL be ours!','',0,0,0,0,0,0,0,0,1,0,32473,0,26124),
(67593,'A warlock! He couldn\'t have ported far - there must be another base.','',0,0,0,0,0,0,1,0,1,0,32666,0,26124),
(67594,'What came over me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67595,'You are carrying too much brew. Return to the Brewing Cauldron to turn in what you have.','You are carrying too much brew. Return to the Brewing Cauldron to turn in what you have.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67596,'OW! Not again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67597,'You should really be more careful...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67598,'Let me see if I can fix you up...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67599,'Thanks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67600,'Whoa, I think I\'ve got a big one...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67601,'Ouch!  I guess that one was a little bigger than I thought...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67602,'Do you have a few moments to spare?','',0,0,0,0,0,0,6,0,4,0,0,0,26124),
(67603,'I\'m ready for that drink now.','I\'m ready for that drink now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(67604,'I accompany the Shado-Pan to chronicle their many deeds beyond the wall. It is not easy - I do not wish to lose any of my journals in the chaos of battle!$b$bIt has happened before. The Lorewalkers have been cataloging pandaren history for many ages. Their notes are scattered throughout Pandaria. I am certain that if you were to assemble them, the Lorewalkers would be most appreciative!','',6,2,0,0,0,0,0,0,1,0,0,0,26124),
(67605,'Wow, that was a big one, that loooked like it hurt!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67606,'The roads of Kun-Lai are cold, dangerous, and unforgiving. But there is little satisfaction - or profit! - for deals easily concluded.','',1,404,0,0,0,0,0,0,1,0,0,0,26124),
(67608,'','Wings give us the freedom to soar.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67609,'','Who ever said machines aren\'t natural? My pets are at least 50% natural!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67610,'I\'m concentrating... can you bother someone else?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67611,'Can ya believe Onyxia just left these sitting around in her egg pit? I\'m going to make a fortune!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67612,'You haven\'t had a real adventure until you\'ve skipped through Onyxia\'s whelp pits!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67613,'The marsh out here smells almost as bad as Onyxia\'s breath!','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(67614,'I\'m going to beat you very, very slowly.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67615,'The Master shall rain hellfire upon Azeroth, and then we will at last cleanse the Light from this wretched world!','',5,0,0,0,0,0,0,8,1,0,0,0,26124),
(67616,'All of you must work to aid in the great revival of our Master. Only through Him may we usher in eternal peace for all!','',25,0,0,0,0,0,0,8,1,0,0,0,26124),
(67617,'Our Master, protector of all life, will soon blind all of the heretics and grants us immeasurable power!','',5,0,0,0,0,0,0,8,1,0,0,0,26124),
(67618,'Are you ready to accept the Master\'s gift? Will you be blessed by his loving wrath, or consumed by it like all of the others?','',6,0,0,0,0,0,0,8,1,0,0,0,26124),
(67619,'Sargeras will live once more!','',15,0,0,0,0,0,0,8,1,0,0,0,26124),
(67620,'Demons are the future of this world. The sooner you embrace that, the sooner you join the winning team.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67621,'Kalimdor belongs to the Grimtotem. Nobody can stand in our way.$B$BWe are supreme in all things, as you will now see as I crush your pathetic team.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67622,'','I see you\'re a battle pet trainer, $r. How about you test your skills against the might of a Grimtotem?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67623,'','My snakes are pretty right? ...RIGHT?',6,0,0,0,0,0,0,0,5,0,0,0,26124),
(67624,'','You never stood a chance against me and my lovely snakes!',4,0,0,0,0,0,0,0,5,0,0,0,26124),
(67625,'','No way! I will get you next time!',25,0,0,0,0,0,0,0,5,0,0,0,26124),
(67626,'','Try this guy on for size!',1,0,0,0,0,0,0,0,5,0,0,0,26124),
(67627,'','Take that!',1,0,0,0,0,0,0,0,5,0,0,0,26124),
(67628,'','Nooooo! My precious snakes!',18,0,0,0,0,0,0,0,5,0,0,0,26124),
(67630,'I am defeated.','I am defeated.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67631,'','I\'m going to knock you out cold!',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(67632,'','I told you, sugar. You aren\'t hot enough to handle me!',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(67633,'','Ouch! I just got burned!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67634,'','Take a break and chill, sweetie. You\'ll get your turn again soon.',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(67635,'','We\'re snowballing out of control! You don\'t stand a chance now!',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(67636,'','Shattered!',23,0,0,0,0,0,0,0,1,0,0,0,26124),
(67637,'','You handle the cold better than I thought.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67638,'','Your pet is a cold, ruthless killer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67639,'','I won\'t let you get away with that!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67640,'','You aren\'t hot enough to handle me!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67641,'','How you doin\', sugar?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(67642,'<Chi-Ji\'s voice fills your mind.>$b$bDo you need help getting to the top of the pedestal, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67643,'Yes, please, Chi-Ji.','Yes, please, Chi-Ji.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67644,'To the skies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67645,'<You can hear Chi-Ji\'s voice echoing in your mind.>$b$bI sense that you need my help to get to the top of the dome.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67646,'I do, Chi-Ji.','I do, Chi-Ji.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67647,'<You hear Chi-Ji speaking in your mind.>$b$bLet me assist you to get to the top of the pavilion, my friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67648,'I would like that very much, Chi-Ji.','I would like that very much, Chi-Ji.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67649,'A Warbringer approaches! Fall back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67650,'I am studying the life of this area for...research purposes.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67651,'Give \'em hell for us, $n! Whatever those things are...','Give \'em hell for us, $n! Whatever those things are...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67652,'','Life is but a path to undeath. My pets understand that.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67653,'You don\'t stand a chance!','You don\'t stand a chance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67654,'Ah, dragon rearing.$B$BOnce these beauties grow up, my fool brother will have nothing on me!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67655,'I told you lads to trust ol\' Sully! Ha haaaa!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67656,'Suck it down, freaks!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67657,'Yech! What are these things?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67658,'Feh, get off me new ride!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67659,'Let\'s see what this lever does... oh, right! IT CARVES YOU A NEW ARSE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67660,'I even had time to install an I.W.I.N. Button!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67661,'Good work in there, $n! Get on to the village over the bridge. I\'m covering extraction for the marines.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67662,'I kinda like this thing. What ye think, lads? Can we keep it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67663,'We just couldn\'t do it the quiet way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67664,'...you\'re nothing but farmer\'s children.','',0,0,0,0,0,0,0,0,7,0,32484,0,26124),
(67665,'You have done much and more for us today, $n. Our work will continue, but we have gained a small victory.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67666,'Thank you, $r! I feel the tide of battle turning in our favor. You have gained us a moment\'s respite, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67667,'','Do not fear, Tai-Feng. Yu\'lon is strong. She will break free of the sha\'s corruption, I know it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67668,'','It matters not how the sha broke free of their ancient prisons. We must plan a course of action forward. How can we dispel them again from our land?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67669,'','Even as we speak, Taran Zhu and the Shado-Pan march west. When they find the sha, justice will be done.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67670,'','The guardians of the temple are few, but their spirits remain strong. I believe we can defeat the sha and expel them from our temple, but it will be a long and difficult battle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67671,'','Many great conflicts have occurred in these swamps. I can still feel the lingering energy.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67672,'','Our battle is most difficult, Tai-Feng. The sha of doubt is subtle and insidious. Once the dark seed of doubt is planted, only one of strong mind and heart can remove it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67673,'','The defenders of the temple are hold strong on the ground, while the Order of the Cloud Serpent fights from above. Working together, we will dispel the sha from our home.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67674,'Can I go out and fight the sha, too?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(67675,'','Don\'t be stupid! The sha are dangerous!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(67676,'I\'m scared!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67677,'','Are the sha going to come in here?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(67678,'','Now, now. Don\'t be scared. Brave heroes are fighting the sha right now. And as long as I\'m here, nothing will hurt you.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67679,'','Most people hate swamps, but I know that they hold great secrets just beneath the murky surface.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67680,'Spend a few years of yer life with Sulfuras over yer head, and you\'ll learn tae appreciate the lava beetle\'s resilience.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67681,'','You will only find defeat here.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67682,'','You have no chance of defeating my team. I am eternal!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67683,'Korven, let\'s continue.','Korven, let\'s continue.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67684,'|TInterface\\Icons\\ability_warrior_shieldmastery.blp:20|t%s casts |cFFFF0000|Hspell:117961|h[Impervious Shield]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67685,'','If these miniatures are built anything like their originals, you don\'t stand a chance!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67686,'I want to travel the world someday. Have you ever seen Stormwind?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67687,'The winds of Outland speak of calm and peace.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67688,'','Target acquired. Light it up.',0,0,0,0,0,0,0,0,5,0,0,32534,26124),
(67689,'We must work together to preserve what nativel life remains in Nagrand.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67690,'','Burn it to the ground!',0,0,0,0,0,0,0,0,5,0,0,32535,26124),
(67691,'','Roger that. Give \'em the business.',0,0,0,0,0,0,0,0,5,0,0,32536,26124),
(67692,'Do you mind?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67693,'','We read you. Comin\' in hot.',0,0,0,0,0,0,0,0,5,0,0,32537,26124),
(67694,'','Carrier has arrived.',0,0,0,0,0,0,0,0,5,0,0,32538,26124),
(67695,'Blood Elves are the masters of the universe. There is no questioning it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67696,'How about a deal? If I win, you give me ten thousand gold?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67697,'13 gyromantic destabilizers? Check. 10 gnumatic flangegrips? Check. Now where did I put my favorite wrench?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67698,'Hmm. Only 2 tons of explosives for this mission? Seems a bit light to me. This seems like the kind of mission we are going to need way more explosives for. Like... goblin pyromaniac explosives.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67699,'Only thirty gyrocopters? We are going to need way more than that before this is over.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67700,'I don\'t care how short you are or how proportionally large and heavy these crates are, get them below decks.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67701,'CLUCK!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67702,'Mayor Khang, we must act quickly! Rally the city guards, at least!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(67703,'Just a moment, Teng. We have... a visitor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67704,'Excellent work! We\'ve secured the rest of the base.','',0,0,0,0,0,0,0,0,1,0,32675,0,26124),
(67705,'King\'s mercy - what happened here? What WAS that thing?','',0,0,0,0,0,0,6,0,1,0,32676,0,26124),
(67706,'Your foe was overwhelmed by a dark energy we call the\"Sha.\" It thrives on negative emotions, such as doubt.','',0,0,0,0,0,0,1,0,1,0,32711,0,26124),
(67707,'I am not surprised. The Horde are monsters!','',0,0,0,0,0,0,1,0,1,0,32677,0,26124),
(67708,'I have seen your sky-fortress. Your people have an interesting notion of \"peace.\"','',0,0,0,0,0,0,1,0,1,0,32569,0,26124),
(67709,'Left to their own devices, the Horde will overwhelm your land. Will you not help us fight them?','',0,0,0,0,0,0,1,0,1,0,32678,0,26124),
(67710,'We are not afraid to fight. Our warriors, while few in number, are extremely skilled.','',0,0,0,0,0,0,1,0,1,0,32570,0,26124),
(67711,'','Thank you for your hospitality, Mayor. I assure you: you\'re doing the right thing.',0,0,0,0,0,0,2,0,1,0,0,32549,26124),
(67712,'You may give these soldiers quarter at your discretion, but we are not choosing sides.','',0,0,0,0,0,0,25,0,1,0,32565,0,26124),
(67713,'This conflict is little more than a race-war. Their hatreds would engulf this land - we will have no part in this!','',0,0,0,0,0,0,1,0,1,0,32566,0,26124),
(67714,'I must go - there are others who have landed on our northern shores.','',0,0,0,0,0,0,1,0,1,0,32567,0,26124),
(67715,'','Coming through!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67716,'','There, by the fountain! Set them down gently now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67717,'','Daniel, that patient is in shock. Stay with him and monitor his heart rate, let me know if anything changes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67718,'Understood.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67719,'','Stanton, keep some ice on that man\'s head. We need to get the swelling down.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67720,'','On it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67721,'What are we going to do about the glade?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67722,'The guards are needed here. If you seek vengeance at the glade, Teng, I suggest you speak with our guest here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67723,'Grow giant carrots, they said. It\'ll be fun, they said.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67724,'Carrots this big just ain\'t practical.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67725,'Bah, another splinter from my hoe!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67726,'It doesn\'t even feel like I\'m making any progress...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67727,'Why would we ever need carrots this big?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67728,'','Nightwind, report! What\'s going on down there?',0,0,0,0,0,0,0,0,7,0,0,32546,26124),
(67729,'','Horde troops are swimming toward your position. Open fire at once.',0,0,0,0,0,0,0,0,7,0,0,32547,26124),
(67730,'','You don\'t think they\'ll hesitate to strangle you with their bare hands? GUN THEM DOWN!',0,0,0,0,0,0,0,0,7,0,0,32548,26124),
(67731,'','This devastation could have been avoided, $c. There was a time when Theramore was a symbol of peace...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67732,'Show me Theramore before the destruction.','Show me Theramore before the destruction.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67733,'No sign of the flagship, and no sign of Admiral Taylor or Prince Anduin.','',0,0,0,0,0,0,1,0,7,0,32667,0,26124),
(67734,'Admiral - I think they mean to surrender. They\'re not armed - They\'re just trying not to drown!','',0,0,0,0,0,0,1,0,7,0,32668,0,26124),
(67735,'That\'s not right... this is a massacre... they were unarmed - ugh! I don\'t... I don\'t feel well...','',0,0,0,0,0,0,1,0,7,0,32669,0,26124),
(67736,'Maybe they deserved to die.','',0,0,0,0,0,0,1,0,7,0,32670,0,26124),
(67737,'','Such a waste...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67738,'','Some decisions have dire consequences.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67739,'You beasts! What sort of madness is this?','',0,0,0,0,0,0,5,0,7,0,32562,0,26124),
(67740,'Men, stand down - this is one of the natives.','',0,0,0,0,0,0,1,0,7,0,32671,0,26124),
(67741,'We are from the Alliance, and mean you no harm. Tell me, what was that shadow you drew out of me?','',0,0,0,0,0,0,1,0,7,0,32672,0,26124),
(67742,'This is not the place to explain. In short, your own doubts have been made manifest, as a consequence of your actions.','',0,0,0,0,0,0,1,0,7,0,32563,0,26124),
(67743,'You don\'t understand - we\'re fighting a war here-','',0,0,0,0,0,0,1,0,7,0,32673,0,26124),
(67744,'Oh, I understand perfectly. I have eyes. But Pandaria is not like whatever land you came from; it lives and breathes. You should be careful what kind of energy you bring here. Now put those weapons away!','',0,0,0,0,0,0,1,0,7,0,32564,0,26124),
(67745,'I seem to have misplaced Dog\'s Whistle.','I seem to have misplaced Dog\'s Whistle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67746,'You seem willing to clean up your mess, outsider. Maybe we can help each other.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67747,'BEHOLD MY POWER!','',0,0,0,0,0,0,15,0,1,0,32684,0,26124),
(67748,'Apothecary, may I have some more of your Dit Da Jow?','Apothecary, may I have some more of your Dit Da Jow?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67749,'Caw!','Caw!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67750,'Their leader is still in hiding. Find him!','',0,0,0,0,0,0,5,0,1,0,32506,0,26124),
(67751,'You finished him - well done!','',0,0,0,0,0,0,5,0,1,0,32507,0,26124),
(67752,'What is this... shadow? What is the Alliance playing at?','',0,0,0,0,0,0,6,0,1,0,32508,0,26124),
(67753,'Your foe was overwhelmed by a dark energy we call the\"Sha.\" It thrives on negative emotions, such as doubt.','',0,0,0,0,0,0,6,0,1,0,32571,0,26124),
(67754,'You again. Do you see it now? Alliance arrogance!','',0,0,0,0,0,0,1,0,1,0,32509,0,26124),
(67755,'My people have stood tall without you for thousands of years.','',0,0,0,0,0,0,25,0,1,0,32572,0,26124),
(67756,'Are you afraid to fight?','',0,0,0,0,0,0,6,0,1,0,32510,0,26124),
(67757,'We are not afraid to fight. Our warriors, while few in number, are extremely skilled.','',0,0,0,0,0,0,1,0,1,0,32573,0,26124),
(67758,'This is a hostile land, and we have no reinforcements. We\'re going to have to improvise, champion.','',0,0,0,0,0,0,1,0,1,0,32511,0,26124),
(67759,'But our orders stand - Hellscream will have his foothold here. We will NOT allow the Alliance to lay claim to this new world!','',0,0,0,0,0,0,5,0,1,0,32512,0,26124),
(67760,'I haven\'t earned my wings yet, but neither have my pets!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67761,'It\'s unsafe to wander through the forest alone, don\'t you think?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67762,'Ribbit','Ribbit',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67763,'Do not let others fool you. Dragons are weapons of war; nothing more.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67764,'Those Alliance scum will learn what it is to anger the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67765,'We will claim this land in the name of the Horde, or die trying!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67766,'They have not even begun to see the fury of the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67767,'By the time we are done here, the Alliance will wish they had never set foot on this land.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67768,'For the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67769,'Clever tricks, but do you really assume I only have one set of weapons to fight you with? I have been waiting for a worthy opponent to use my poison coated swords against.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(67770,'Me find these crawling inside me.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67771,'We will attack from the opposite side, $c. The alliance won\'t expect a ground assault this quickly. Find me when the slaughter is over.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67772,'C\'mon, you guys. We can do this. Fly!','',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(67773,'One day I\'m going to explore the whole world, and my pets are coming with me!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67774,'One approaches Morulu...','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(67775,'Hang in there, bud. You\'re going to be okay.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67776,'His pulse is stable, Mishka. But it\'s weak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67777,'','These bandages are filthy. Let\'s get you cleaned up.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67778,'We need to do right by these people if we want a chance at understanding this land.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67779,'Mishka\'s gonna take good care of you, you hear me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67780,'The next ten orcs I kill are gonna be for you, friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67781,'Your actions will have grave consequences if you do not move from your path of war.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67782,'Every action creates a reaction. Do you see what your actions have created?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67783,'I fear that this is just the beginning.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67784,'Are you so blind that you would continue this war?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67785,'All the brew... gone...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67786,'Cool stuff will happen here! Explosions!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67787,'You\'re on!','You\'re on!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67788,'I will fight with honor and valor for the glory of the Alliance!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67789,'Bask in the glory of the Alliance, $r. Know today that you stand no chance of defeating me!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(67790,'You have pets, too. We fight?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67791,'Collecting Honeybrew Barrel','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67792,'','Well isn\'t this just a fine mess?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67793,'The Horde is in need of your assistance.','The Horde is in need of your assistance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67794,'','My assistance?! You want my assistance?! I will not be part of your petty fighting.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67795,'','You want my help? I\'m a little busy trying to restore the peace that you disrupted.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67796,'','All I wanted to do today was harvest my crops. Instead, I\'m wrangling prowlers!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67797,'','My sister and I haven\'t seen this much activity in Honeydew since, well ever!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67798,'','Your airship just about took out our balloon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67799,'','We are not interested in your war, outsider. This is a peaceful village.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67800,'','Well it was peaceful until you arrived.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67801,'','We will not be caught in the middle of your war for any longer than we can help it. You may stay here and tend to your wounded, but that is the end of our involvment.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67802,'','The temple must not fall!',0,0,0,0,0,0,0,0,1,0,0,31443,26124),
(67803,'It is said that \"Wisdom lights the path.\"$b$b...But wisdom never kept me from stubbing my toe at night.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(67804,'He was weak, but I am stronger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67805,'He was but a trainee.  The will of a master is stronger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67806,'Well done, you are one step closer to the real challenge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67807,'Strike them down, and I become more powerful than you can ever imagine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67808,'Hello, $n, would you like to learn how to acquire and work with the various metals found around our land?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67809,'Get those ropes tied down, team! We need this drake secured immediately.','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(67810,'Work harder you lazy mongrels, or I\'ll roast you alive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67811,'Break any of these supplies, and I\'ll break your skull!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67812,'Guard these supplies with your lives, you filthy mutts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67813,'Keep your flea ridden paws out of the food, you mangy beasts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67814,'Watch these mercenaries closely, brothers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67815,'The gong peals a taunting note to the mantid armies below, accelerating the pace of their assault.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67816,'Your training is complete for today.  Return tomorrow and we will continue.','',0,0,0,0,0,0,0,0,1,18973,0,0,26124),
(67817,'But we will not participate in this... genocidal... bloodbath of yours.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67818,'Your conflict will have immense consequences here. Do NOT bring your war to these shores!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67819,'But we will not participate in this... race war... bloodbath of yours.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67820,'Your conflict will have immense consequences here. Do NOT bring your war to these shores!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67821,'Hidden power lies here, and we must reveal it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67822,'I can feel them, the spirits of long dead Mogu!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67823,'Keep these ruins secure at all costs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67824,'Leave no stone unturned in our search!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67825,'Do not falter! We will soon unite with our ancient mogu allies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67826,'First packet of seeds is on the house! Come back to me anytime you want to buy more seeds, ya hear?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67827,'Just remember, real crops will take a day to grow, so after you\'ve tilled and cared for your plants, come back the next day to harvest your bounty!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67828,'Well partner, looks like you\'re ready to work this farm on your own. Come back every day to plant and harvest vegetables if you like. If we work hard, we might even be able to upgrade this place!','',0,0,0,0,0,0,1,0,1,54164,0,0,26124),
(67829,'Well partner, I got some bad news for you. You can come back every day to plant and harvest your vegetables, but you\'ll need more experience before helping me join the Tillers Union. But don\'t forget - you\'re welcome here on the farm any time!','',0,0,0,0,0,0,1,0,1,13442,0,0,26124),
(67830,'','We must do everything we can to protect the shrines and temples of my people.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67831,'Mo\'ruk gonna beat ya!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67832,'','This year\'s harvest yielded more than just crops!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67833,'I have spent countless hours preparing for this battle.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67834,'Braving these wastes has made my pets undefeatable.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67835,'','It is within the most sacred realm of Pandaria that you will now face your most difficult challenge.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(67836,'You\'re going down!','You\'re going down!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67837,'Who holds this swarm? Show yourself! Answer to the Klaxxi.','',0,0,0,0,0,0,6,0,1,0,30910,0,26124),
(67838,'Treasonous Klaxxi... her magnificence was right about you.','',0,0,0,0,0,0,1,0,1,0,29295,0,26124),
(67839,'Speak your name puppet, that our annals will be complete.','',0,0,0,0,0,0,396,0,1,0,30911,0,26124),
(67840,'Grand Vizier Zor\'lok, voice of the Empress.','',0,0,0,0,0,0,6,0,1,0,29296,0,26124),
(67841,'Your \"Empress\" has fallen. The Klaxxi have pronounced judgment. Stand aside or be brushed away.','',0,0,0,0,0,0,0,0,1,0,30912,0,26124),
(67842,'The Klaxxi are to be disbanded, by the will of the Empress.','',0,0,0,0,0,0,0,0,1,0,29297,0,26124),
(67843,'Blaspheme!','',0,0,0,0,0,0,0,0,1,0,30913,0,26124),
(67844,'The desperate Klaxxi have resorted to digging up fossils. Very well: let us finish this.','',0,0,0,0,0,0,1,0,1,0,29298,0,26124),
(67845,'Kl-kl-kl-kl-klagh!','',0,0,0,0,0,0,0,0,1,0,30914,0,26124),
(67846,'\"Unscathed,\" indeed.','',0,0,0,0,0,0,1,0,1,0,29299,0,26124),
(67847,'Forward! The Klaxxi reveal themselves as traitors. Decimate them, and leave nothing behind.','',0,0,0,0,0,0,1,0,1,0,29300,0,26124),
(67848,'Wakener, your deeds have earned you the trust of the Klaxxi.','',0,0,0,0,0,0,0,0,1,0,30312,0,26124),
(67849,'You are to be rewarded. Walk with me.','',0,0,0,0,0,0,0,0,1,0,30313,0,26124),
(67850,'We mantid are an elder race. The pandaren you associate with - they are but children. They have their role to play.','',0,0,0,0,0,0,0,0,1,0,30314,0,26124),
(67851,'Each cycle, our young swarm their walls. The pandaren slay the weak. The strong return.','',0,0,0,0,0,0,0,0,1,0,30315,0,26124),
(67852,'With each generation, we grow ever stronger.','',0,0,0,0,0,0,0,0,1,0,30316,0,26124),
(67853,'Before your history began, our empire was vast. We shared this world with our sister kingdoms, Ahn\'Qiraj and Azjol-Nerub.','',0,0,0,0,0,0,0,0,1,0,30317,0,26124),
(67854,'Our Gods were many, and powerful. We mantid worshipped the seven heads of Y\'shaarj.','',0,0,0,0,0,0,0,0,1,0,30318,0,26124),
(67855,'Great was the Old One, and terrible was His wrath. He consumed hope and begat despair; He inhaled courage and breathed fear.','',0,0,0,0,0,0,0,0,1,0,30319,0,26124),
(67856,'When the usurpers came - the ones you call \"Titans\" - Y\'shaarj was destroyed.','',0,0,0,0,0,0,0,0,1,0,30320,0,26124),
(67857,'His last terrible breath has haunted this land ever since, but the shadows he left behind are mere whispers of his former glory.','',0,0,0,0,0,0,0,0,1,0,30321,0,26124),
(67858,'I tell you now, because you have earned this warning.','',0,0,0,0,0,0,0,0,1,0,30322,0,26124),
(67859,'Your gods are not our gods, outsider.','',0,0,0,0,0,0,0,0,1,0,30323,0,26124),
(67860,'If the Old Ones ever return, we mantid will once again stand by their side.','',0,0,0,0,0,0,0,0,1,0,30324,0,26124),
(67861,'The wisest among you will do the same.','',0,0,0,0,0,0,0,0,1,0,30325,0,26124),
(67862,'That is all that is to be said. Come, take your reward. And remember what you have learned today.','',0,0,0,0,0,0,0,0,1,0,30326,0,26124),
(67863,'I see you, too, have braved the perils of Kota Peak. You have proven yourself worthy to do battle with me.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67864,'Hey lady! Watch it would ya!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67865,'Enough with the stick already!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67866,'Watch it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67867,'Ouch! What\'s with the stick?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67868,'Watch it lady! I\'m very fragile!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67869,'Quit pokin\' me with that thing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67870,'Well done.  Your training is now complete.  Come see me in the Shrine of the Ox for your reward.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67871,'What is - no - NO! They had an airbase, a hidden airbase... my ship - my - Hellscream will have my head!','',0,0,0,0,0,0,1,0,7,18961,32525,0,26124),
(67872,'They all must die.','',0,0,0,0,0,0,0,0,7,18961,32760,0,26124),
(67873,'You! Bear-creature. What kind of sorcery was this?','',0,0,0,0,0,0,0,0,7,0,32526,0,26124),
(67874,'We bring only our honor and the desire to crush our enemies. Have your kind been aiding the Alliance?','',0,0,0,0,0,0,1,0,7,0,32527,0,26124),
(67875,'Stranger - your own doubts have been made manifest. Pandaria is not like whatever land you come from; it lives and breathes. You should be careful what kind of energy you bring here.','',0,0,0,0,0,0,5,0,7,0,32574,0,26124),
(67876,'It is not our desire to get wrapped up in your bloodshed. Now have your men lower their weapons, or you will face TWO enemies on this continent.','',0,0,0,0,0,0,1,0,7,0,32575,0,26124),
(67877,'Your doubts and hatreds have wrought havoc all throughout these ruins. Clean up after yourselves and meet me in the village below - I will do my best to explain.','',0,0,0,0,0,0,1,0,7,0,32576,0,26124),
(67878,'Akkolon has entered the battlefield!','',0,0,0,0,0,0,0,0,1,19022,0,0,26124),
(67879,'Shox\'tik has entered the battlefield!','',0,0,0,0,0,0,0,0,1,19022,0,0,26124),
(67880,'The Manifestation of Terror has appeared on the battlefield!','',0,0,0,0,0,0,0,0,1,19022,0,0,26124),
(67881,'','Now that we\'re acquaintances, $n, let me give you a tip. Folks \'round here can help spruce up your farm, but you gotta become friends. Unfortunately, you\'re too green to help them out or give gifts yet, so get stronger first!',0,0,0,0,0,0,0,0,1,13442,0,0,26124),
(67882,'Oh hey $n... Gina\'s a voting member of the Tillers, so... try and make a good impression, okay?','',0,0,0,0,0,0,1,0,1,13442,0,0,26124),
(67883,'You\'ve beel afflicted with Master Hsu\'s Deadly Poison.  Detox yourself to remove it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(67884,'Mung-Mung impressed, $n. You help me without asking for anything in return. That\'s what being a Tiller is all about. I\'ll meet you back on your farm. Mung-Mung will give you his vote.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67885,'You scum will NOT destroy this land as you defiled Kalimdor!','',0,0,0,0,0,0,5,0,7,0,32466,0,26124),
(67886,'These cabbages have convinced me, $n. Anyone who can grow produce like this belongs in the Tillers. I\'m casting my vote for you and Farmer Yoon. See you back at your farm in a bit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67887,'','Oh stop complaining and grab the stick!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67888,'','So much whining! You would think I was trying to kill you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67889,'','You are in no position to complain about the help you are receiving!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67890,'','Do you want to stay stuck in the tree?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67891,'','Hey you got yourself stuck there! I\'m just trying to help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67892,'','You know, I could just leave you up there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67893,'If there\'s anyone that\'s an expert on rocks and stones, it\'s a dwarf!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67894,'If we understand how Ragnaros has affected the lesser denizens of Hyjal, we may better understand how to repair it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67895,'Your world...all worlds...will burn!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67896,'','Anyone with such a talented green thumb needs to be a Tiller. I don\'t care what that hare-brained grandson of mine says! Haohan is wrong about Farmer Yoon. You have my vote, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67897,'Generations of your people have passed as I\'ve prepared for this day.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67898,'','Even the forest\'s lovely flowers were turned against us...',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(67899,'Did you see?\n\nHui cursed Greenstone Quarry\'s jade and transformed it into those monsters.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67900,'','This village was built with Hui\'s approval, but that was many generations ago.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(67901,'','Hui\'s curse even turned some of our famous Greenstone Brew against us!\n\nHis minions stole what little wasn\'t affected.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(67902,'','I don\'t think I could have held them off much longer.\n\nYou have my gratitude!',1,2,0,0,3,0,0,0,0,0,0,0,26124),
(67903,'Hui\'s earth magic even brought Kiri\'s jade lion statue to life!\n\nIt ran off to who knows where...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(67904,'Hmmm, it sounds like the Kunzen hozen are causing quite a lot of trouble for Mr. Mudclaw. Maybe we can help.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67905,'%s summons |cFF298A08Sra\'thik Workers|r to his aid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67906,'I\'ll meet you back in the village.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67907,'I need more time to prepare the mixture, $n. I\'ll let you know when it\'s ready.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67908,'You need to seriously rethink your definition of help lady! You\'re dangerous with that stick!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67909,'What do you want to show me, Kil\'ruk?','What do you want to show me, Kil\'ruk?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67910,'Can you show me the chamber beneath Klaxxi\'vess again?','Can you show me the chamber beneath Klaxxi\'vess again?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67911,'Are you sure you want to walk with Kil\'ruk?','Are you sure you want to walk with Kil\'ruk?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67912,'Though the peak is safe, the areas around it are not.  Be more careful!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(67913,'|TInterface\\Icons\\ability_druid_tigersroar.blp:20|t %s hides and prepares to |cFFFF0000|Hspell:131271|h[Leap from Shadows]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67914,'%s could not see his prey!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67915,'Remember to take your Bag of Wu Kao Supplies!','Remember to take your Bag of Wu Kao Supplies!',0,0,0,0,0,0,0,0,1,19055,0,0,26124),
(67916,'Hey Gina! Didn\'t expect a visit from you.','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(67917,'','Come walk with me, $n. I would like to pay Farmer Yoon a visit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67918,'','You know, you sure saved my hide with those scallions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67919,'','Cooks are always looking for fresh vegetables. Anything you grow on your farm, you can use for cooking or sell to other cooks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67920,'','Hey Farmer Yoon!',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(67921,'','Listen, since you two did such a good turn by helping me out, I\'m casting the first vote to help you join the Tillers.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(67922,'','There are four other votes you\'ll need to get, but that\'ll come in time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67923,'','Settle yourselves in and come by the market any day if you are looking for work.',0,0,0,0,0,0,1,0,1,54164,0,0,26124),
(67924,'','Settle yourselves in first. You\'ll be able to farm your fields, but I\'m afraid you\'re too inexperienced to continue further. Once you\'ve seen more of Pandaria, be sure to stop by.',0,0,0,0,0,0,1,0,1,13442,0,0,26124),
(67925,'','Welcome to The Heartland!',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(67926,'Coward!','',0,0,0,0,0,0,5,0,7,0,32523,0,26124),
(67927,'You must be the trainer I\'ve heard about. Tell me, do you fear defeat?','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(67928,'A valiant effort, but not enough.  Speak to me when you are ready to try again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67929,'The Klaxxi have spoken. The Empress must fall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67930,'Let\'s get started.','Let\'s get started.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67931,'','All manner of strange creatures are just ... falling from the sky!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(67932,'Hello Mung-Mung. How\'s everything at Mr. Mudclaw\'s farm?','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(67933,'Hey Yoonie! It\'s me, Mung-Mung!','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(67934,'Hey, isn\'t that Mung-Mung coming up the road?','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(67935,'Terrible, but don\'t tell him I said so. Vermins is running everywhere. Crops ain\'t growing. And something keeps eating the harvest.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67936,'But your farm is lookin\' pretty good. You know if you make friends with the folks around here, they might give you stuff to fancy it up even more.','',0,0,0,0,0,0,0,0,1,19067,0,0,26124),
(67937,'Ookin\' dookers, just look at this place! You got a real nice farm. Looks like you\'ve been making friends around here!','',0,0,0,0,0,0,0,0,1,19066,0,0,26124),
(67938,'Anyway, I just came by to thank you for those carrots.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67939,'They was real crunchy, and Haohan thought they were his best crop yet! Haha!','',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(67940,'You ain\'t so bad, Yoonie. Here\'s my vote.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67941,'See ya later!','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(67942,'','Thank you for coming, everyone!',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(67943,'','Into every generation are born the dreamers - dreamers like Liu Lang.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67944,'','What\'s YOUR dream? Don\'t let ANYONE take it away!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(67945,'','Hold it in your heart, and make it happen. Dreamers change the world.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(67946,'','Red Crane bless you all. Goodnight!',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(67947,'Hey look, someone\'s coming up the road. Hellooooo Farmer Fung! Nice to see you!','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(67948,'Well met, Farmer Yoon. I had to come by and see your farm for myself.','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(67949,'|TInterface\\Icons\\inv_polearm_2h_mantid_01.blp:20|t%s casts |cFFFF0000|Hspell:131320|h[Empower Blades]|h|r Run!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67950,'Not too shabby. Looks like you\'ve got room for more fields there, too.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67951,'Here\'s a tip from one farmer to another. There are lots of upgrades to buy at Halfhill Market. Gina Mudclaw sells tools, and Merchant Greenfield sells seeds.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67952,'Anyway, I just came by to thank you for those cabbages. Couldn\'t have grown better myself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67953,'In fact, anyone who can grow such a perfect vegetable needs to be a Tiller, which is why I\'m voting you in.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(67954,'Hey, looks like you\'ve only got two more votes to go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67955,'You\'ll have to prove yourself to Nana and Haohan Mudclaw. Those two Mudclaws will be tough to sway, but I think you can do it.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67956,'See you around.','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(67957,'Don\'t forget to take it all in while you\'re here.  The Peak of Serenity has a wonderful view of beautiful Kun-Lai summit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67958,'Here, you\'ll find several of us who have mastered the art of various crafts.  If you need any supplies along your journey, they can probably help.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67959,'We will have to regroup quickly if we hope to destroy the alliance.','',113,0,0,0,0,0,396,0,1,0,0,0,26124),
(67960,'This is the Training Ground, where most of your training will take place.  Come, I will introduce you to the masters who will be teaching you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67961,'This is Master Kistane, she is a master in the art of channeling the mists to assist her and her allies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67962,'This is Master Woo.  She specializes in defense against persistent attacks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67963,'This is Master Yoon.  He is practiced in using powerful, focused healing to maintain himself in battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67964,'This is Master Cheng.  She has mastered the art of fighting on the move.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67965,'Y-y-you\'re N-N-Nana Mudclaw! I n-never thought I\'d get a visit from the m-m-matron herself!','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(67966,'This is Master Tsang.  He is a master of meditation and the ability to sense what is happening around him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67967,'','I had to come and see Old Yoon\'s cub with my own eyes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67968,'','I knew your grandfather well. I was very sorry when he passed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67969,'','You know, the two of you remind me of him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67970,'','You were stubborn enough to keep tilling this soil even though you didn\'t have much experience.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67971,'','You were brave enough to stand up to my grandson, Haohan.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67972,'','And you two have shown quite the knack for growing delicious fruits and vegetables.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(67973,'This is Master Hsu.  He specializes in using all kinds of weaponry and is masterfully proficient with nearly any weapon under the sun.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67974,'','For that, you have earned my respect, my gratitude, and my vote. Well done.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(67975,'','Oh, and Farmer Yoon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67976,'','I do believe your grandpa would be very proud of you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67977,'And finally, this is Master Cheng.  Master Cheng focuses on reflex and swift motion and will help you begin your training.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67978,'And with that, I must depart.  Good luck with your training.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67979,'','We should stay here for only as long as it is necessary, $c.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67980,'','Well, at least there will always be more honeybrew!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67981,'Welcome aboard... Tillers!','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(67985,'I look forward to working with you.','I look forward to working with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67986,'Welcome to the Peak of Serenity.  Good luck in your training.','Welcome to the Peak of Serenity.  Good luck in your training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67987,'Greetings.','Greetings.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67988,'','I look forward to working with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67989,'','Welcome to the Peak of Serenity.  Good luck in your training.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67990,'','Greetings.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67991,'Welcome.  Speak with me when you are ready to begin.','',0,0,0,0,0,0,0,0,1,18681,0,0,26124),
(67992,'','She took a pretty nasty spill. the damage is horrific! I haven\'t been able to wake her.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67993,'','Oh! You mean she looked like this before the crash?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67994,'Welcome to the Peak of Serenity $n.  How can I help you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67995,'Could you show me around?','Could you show me around?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67996,'There ya go!','',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(67997,'','There we go! Good as new... I guess...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67998,'','What... What happened?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(67999,'','Hmm, I have an idea. An old brewmaster trick...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68000,'Wait! Not the brew! That might be all we have left!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68001,'My assistant will show you to Master Cheng.  Good Luck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68002,'Follow me and I will show you around the Peak of Serenity.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68003,'','Congratulations!',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(68004,'','<Kiryn stares blankly up at the sky and doesn\'t respond.>',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(68005,'What in blazes is this?','',0,0,0,0,0,0,0,0,6,0,27840,0,26124),
(68006,'Admiral, we\'re seeing a significant native presence here. Ornate structures-','',0,0,0,0,0,0,0,0,6,0,32528,0,26124),
(68007,'Cut the chatter, people. Eyes on the target!','Cut the chatter, people. Eyes on the target!',0,0,0,0,0,0,0,0,6,0,32539,32539,26124),
(68008,'You heard the admiral. Concentrate fire on the Horde base. Begin your attack runs.','',0,0,0,0,0,0,0,0,6,0,32529,0,26124),
(68009,'They\'re firing on us sir!','They\'re firing on us sir!',0,0,0,0,0,0,0,0,6,0,27445,27445,26124),
(68010,'Use your torpedo rockets on those ships.','',0,0,0,0,0,0,0,0,6,0,32530,0,26124),
(68011,'Confirmed kill. Nice shooting.','',0,0,0,0,0,0,0,0,6,0,32531,0,26124),
(68012,'Well done. No mercy!','Well done. No mercy!',0,0,0,0,0,0,0,0,6,0,32540,32540,26124),
(68013,'That one\'s for Theramore!','That one\'s for Theramore!',0,0,0,0,0,0,0,0,6,0,32541,32541,26124),
(68014,'Any sign of the flagship down there?','Any sign of the flagship down there?',0,0,0,0,0,0,0,0,6,0,32542,32542,26124),
(68015,'Negative, Admiral. No sign of Captain Taylor OR his flagship.','',0,0,0,0,0,0,0,0,6,0,32532,0,26124),
(68016,'Ugh! We\'ve been hit!','Ugh! We\'ve been hit!',0,0,0,0,0,0,0,0,6,0,27446,27446,26124),
(68017,'Heavy enemy fire... Sully, pull up!','',0,0,0,0,0,0,0,0,6,0,32533,0,26124),
(68018,'We\'re not gonna make it! I\'m comin\' ta see you soon, pappy!','',0,0,0,0,0,0,0,0,6,0,27840,0,26124),
(68019,'Pay \'em back! Hit them with everything you\'ve got!','Pay \'em back! Hit them with everything you\'ve got!',0,0,0,0,0,0,0,0,6,0,32543,32543,26124),
(68020,'That\'s enough - all wings, report back. Prepare for ground assault.','That\'s enough - all wings, report back. Prepare for ground assault.',0,0,0,0,0,0,0,0,6,0,32789,32789,26124),
(68021,'I will help you carry the barrels. Or did you think they were going to magically fit in your bag?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68022,'','The flagship\'s last reported position was below. Can you see anything?',0,0,0,0,0,0,0,0,7,0,0,32544,26124),
(68023,'Fog... nothing but dense fog... wait! Land - starboard! I see ships.','',0,0,0,0,0,0,0,0,7,0,32664,0,26124),
(68024,'Heroes never die, $n.','',0,0,0,0,0,0,0,0,1,0,32802,0,26124),
(68025,'After you, my good sir.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68026,'I say, it looks like I\'ve racked up another win!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68027,'That is most unfortunate.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68028,'Ah, but were you expecting this?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(68029,'It seems I\'ll be enjoying an expedient win this fine day!','',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(68030,'Oh dear, I\'m losing!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68031,'Now\'s as good a time as any, I suppose.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68032,'I knew I made the right choice when I took this up!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68033,'Maybe I can still get my old farm back...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68034,'I\'ve found it sometimes helps to change things up a bit.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68035,'If only my wife were here to see this. I\'m going to win!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68036,'There\'s plenty more where that came from!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68037,'','I won\'t go easy on you!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68038,'','In your face!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68039,'','Mommy! Mommy! The mean tamer didn\'t let me win!',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(68040,'','Oh no you don\'t!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68041,'','Take that!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68042,'','W-why did you k-kill my bunny...',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(68043,'I do hope you\'re prepared to feed your pets to mine as a treat.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68044,'I did warn you of the dangers of these woods.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68045,'Your courage is impressive.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68046,'Do you feel something?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(68047,'What a show!','',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(68048,'No matter. A single life for a victory is well worth the sacrifice.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68049,'Avast, land lubbers be attackin\'! Man the harpoons!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68050,'All the booty ish mine!','',94,0,0,0,0,0,0,0,1,0,0,0,26124),
(68051,'Why\'d you go and have to do that? ...hic!','',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(68052,'Give \'em hell!','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(68053,'Now that...that is fightin\'! Whoever\'s controllin\' these pets sure ish somethin\'! ...hic!','',23,0,0,0,0,0,0,0,1,0,0,0,26124),
(68054,'Man down!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68055,'We be killin\' you now.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68056,'Now that is what Zunta be talkin\' about!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68057,'You be da victor today. Enjoy it.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(68058,'How about you try dis one on for size?','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(68059,'Good, good. Zunta give you a treat later.','',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(68060,'Why you so mean to Zunta, eh?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(68061,'','Battle is upon us. Crush them!',388,0,0,0,0,0,0,0,1,0,0,0,26124),
(68062,'','The day is ours.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68063,'','I\'ll beat you soon enough.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68064,'','I won\'t give you the pleasure.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68065,'','Keep going! Kill!',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(68066,'','Not important. I will stop at nothing to win!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68067,'','Do not be fooled by my calmness. I will defeat you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68068,'','Victory is ours, children!',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68069,'','Well done. You\'ve beaten me when few have had the luxury.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68070,'','A surprising twist!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68071,'','Success!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68072,'','How could you?',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(68073,'','You\'re gonna hurt like you never hurt before when I\'m through with ya.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68074,'','You feelin\' da hurt, mon?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(68075,'','I never see nobody fight like you be fightin\'.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68076,'','I bet you never saw dis one comin\'.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68077,'','Look at da little one hurtin\'!',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(68078,'','Looks like dis one has a bit of a sting!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68079,'','I\'m warning you, I will not falter under your assault.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68080,'','Fighting the strength of the land is inevitably futile.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68081,'','You fight well.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(68082,'','The earth will never falter!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68083,'','The cycle continues.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68084,'I was really hoping to find more Honeybrew. I guess I\'ll just try and find more on my own. Let me know if you need anymore help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68085,'','You fight against the unstoppable.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68086,'We fight!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68087,'Me win!','',94,0,0,0,0,0,0,0,1,0,0,0,26124),
(68088,'NO! ME WIN!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(68089,'No! No kill! Fight this one instead!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68090,'Good tiny thing! You kill other tiny thing!','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(68091,'Why you no fight? I said fight!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68092,'','Let us begin.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68093,'','Looks like I left you earthbound!',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68094,'','We\'ve been shot out of the sky!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68095,'','Great job. Take a break!',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(68096,'','We just might win this!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68097,'','A beautiful creature has fallen.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68098,'','Activating aggression modules!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68099,'','You never stood a chance against my augmented team!',94,0,0,0,0,0,0,0,1,0,0,0,26124),
(68100,'','Total system failure!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68101,'','Engaging self-preservation chip.',19,0,0,0,0,0,0,0,1,0,0,0,26124),
(68102,'','No letting up. Full speed ahead!',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(68103,'','That\'s nothing a good spit shine won\'t fix.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68104,'You think I\'m scared of you? I faced Onyxia!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68105,'Who\'s great? I am!','',94,0,0,0,0,0,0,0,1,0,0,0,26124),
(68106,'I hope a dragon eats you!','',14,0,0,0,0,0,0,0,1,0,0,0,26124),
(68107,'Alright, that\'s enough. Switch!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68108,'That\'s what happens when you go into the whelp pits!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68109,'One keg?! I was carrying one keg with ease when I was a young cub, barely higher than your knee!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68110,'Heavy, but I can hold more! Keep going!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68111,'I may have overestimated my own strength...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68112,'That\'s it, I\'ve reached my limit! This is quite the haul!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68113,'I\'ve been wiped out!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68114,'All this fighting is such a waste. How do your people do it all the time? When do you find time to celebrate and enjoy the simple things?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68115,'Horde, Alliance... what\'s the difference?! Do you not both love a good brew? Do you both not value your friends and families the same?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68116,'Why is it you can\'t just talk out your differences? I have never encountered a problem that a good long talk couldn\'t fix!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68117,'You cannot possibly comprehend the forces stacked against you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68118,'Perhaps now you\'re ready to see things my way?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(68119,'Honeydew Village is run by the Honeydews, but the real heart of the village is the brewery! The brewery belongs to my family, the Honeypaws. Best Honeybrew you\'ll find anywhere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68120,'You only delay us. We cannot be stopped.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68121,'We were on our way to Dawn\'s Blossom for a festival before you arrived! When I imagined fireworks tonight, I didn\'t expect it to be like this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68122,'Have you ever seen such a magnificent being?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(68123,'','Those are Horde vessels... General quarters! Get our birds in the air. Clear the decks. Stations, people. Let\'s go to war!',0,0,0,0,0,0,0,0,7,0,0,32545,26124),
(68124,'Give up now while you still have the chance!','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(68125,'A minor inconvenience.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68126,'Why have you brought your war to our land? What of your homes? Was there nothing worth fighting for there?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68127,'Your actions will no doubt attract the attention of the Shado-Pan. I may even get to meet one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68128,'My village will not enter your conflict. Though, I fear your arrival has changed our peaceful existence forever.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68129,'This Honeybrew is the lifeblood of this village. Now THAT is something worth fighting for!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68130,'Quickly, this way! The cannon fire has opened a passage to the courtyard!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68131,'We should get moving. That Honeybrew isn\'t going to find itself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68132,'','I\'m very sorry, but I no longer have relics to sell you. Their magic seems to have extinguished! Perhaps I\'ll go into dancing full time now, it would be a nice change of pace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68133,'Thank you for your help. I\'ll make sure this Honeybrew gets back to the village. Try not to blow anything else up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68134,'Thank you for your help. Try not to blow anything else up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68135,'Should we allow them to stay here? They have wounded to tend to.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68136,'','Well what about the bombs that landed in our farms from your warship!',0,0,0,0,0,0,0,0,1,19072,0,0,26124),
(68137,'','They will bring more destruction to our village!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68138,'','A war we did not have until you arrived!',0,0,0,0,0,0,0,0,1,19072,0,0,26124),
(68139,'How can you remain neutral after watching them blow us out of the sky?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68140,'Those are the casualties of war!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68141,'Enough! We will relocate shortly. These creatures have destroyed most of what was left from the ship.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68142,'Gather what the villagers are willing to sell us and prepare the others to leave.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68143,'I can\'t wait to grow up!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(68144,'Has anyone seen my brother?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(68145,'I wish I had a cookie.  I love cookies!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(68146,'','It seems that my defenses have prevailed.  Speak with me when you are ready to try again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68147,'HUGGALON LOVE YOU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68148,'','Well fought, but you still have work to do.  Speak with me when you are ready to try again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68149,'','It seems you were unable to keep me at bay.  Speak with me when you are ready to try again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68150,'It seems my strength proved too much for you.  Speak with me when you are ready to try again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68151,'It seems your efforts to defeat me have failed.  Speak with me when you are ready to try again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68152,'If it is war you mean to bring to our shores, the very land itself will respond to your passions and your violence.','',0,0,0,0,0,0,25,0,1,0,32577,0,26124),
(68153,'I do not know what the ultimate consequences will be. Nobody does.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68154,'Your will is strong, but it seems mine was stronger.  Speak with me when you are ready to try again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68155,'It seems my assistants proved too much for you.  Speak with me when you are ready to try again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68156,'Are you ready for your final test, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68157,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68158,'Bow to me and we shall begin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68159,'To defeat me, you will need to use all that you have learned from the other masters.  If you can do that, your training will be complete.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68160,'It seems you have not quite mastered all that we have taught you.  Speak to me when you are ready to try again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68161,'Master Hight is burning you alive.  Move!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68162,'Master Hight is healing.  Interrupt him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68163,'Master Hight is spinning.  Paralyze him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68164,'Master Hight is preparing a massive strike with his polearm.  Disarm him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68165,'Are you thinkin\' what I\'m thinkin\', $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68166,'You comfy down there?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68167,'I\'m pretty sure I tied the knots right. Let me know if you fall off.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68168,'','This won\'t take long.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68170,'None can stop the Grimtotem!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68171,'','Your impudence will be your undoing. Mark my words!',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(68172,'','This isn\'t over!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68173,'','So weak.',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(68174,'','You\'ll pay for that.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68175,'Everyone loves Martar!','Everyone loves Martar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68176,'Come chat with Martar!','Come chat with Martar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68177,'Not to worry, I\'ll make this quick.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68178,'That wasn\'t so bad, was it?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(68179,'Perhaps I need to increase the dosage to prevent such quick deaths.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68180,'Don\'t be so sure of yourself.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68181,'It won\'t be long now.','',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(68182,'How unfortunate.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68183,'','I\'ll show you firsthand the strength of undeath.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68184,'','I knew I was stronger!',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68185,'','No...no...',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(68186,'','Rest, my precious.',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(68187,'','Yes...join us!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68188,'','No! We will not be defeated!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68189,'Are ye sure that ye want to face the might of dragons?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(68190,'Now it\'s time to show my brother who the real master tamer is!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68191,'You got lucky. That\'s all.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(68192,'That\'s enough!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68193,'Now that\'s what I\'m talkin\' about!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68194,'No! I just finished raising that one!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68195,'','I hope you like losing!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68196,'','I knew the swamp was the right choice!',94,0,0,0,0,0,0,0,1,0,0,0,26124),
(68197,'','Perhaps it was wrong of me to venture here.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68198,'','The swamp conceals many things.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68199,'','Victory shall be mine!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68200,'','This is looking bleak for me.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68201,'By the hammer of me father, I shall defeat ye!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68202,'That\'s the stuff, boys. We did it!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68203,'You won\'t be deterrin\' me. Not today. I\'ll keep trainin\'!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68204,'Try this\'n on fer size!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68205,'Great job!','',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(68206,'How dare ye...','',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(68207,'','I will show you no mercy.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68208,'','Just as I thought. You never stood a chance.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68209,'Make sure to tend those scallions. After that, nothing to do but wait until tomorrow when they\'ll be nice and ripe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68210,'','Curse you!',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(68211,'','I am far from finished.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68212,'Hey $n, didya know that all kinds of things can happen to your plants? If you don\'t know how to deal with something, just ask me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68213,'','That was too easy.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68214,'','You\'ll suffer for your transgression.',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(68215,'Uh-oh, looks like today, our plants are parched. Let\'s water them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68216,'','I\'m going to wreck you!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68217,'','Now that\'s what I\'m talking about! Woohoo!',94,0,0,0,0,0,0,0,1,0,0,0,26124),
(68218,'','Talk to any of the Ironpaws at the market if you want to improve your own cooking skill.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68219,'','Maybe I should\'ve gone with more weapons...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68220,'','Oh no you don\'t!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68221,'','Bam!',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(68222,'','Hey! I spent some serious gold on that!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68223,'Don\'t go easy on me!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68224,'I bet if I keep winning, I\'ll get invited to fight in Stormwind one day!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68225,'Wow, you\'re really good!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68226,'Let\'s keep going!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68227,'Good job!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68228,'Oh no...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68229,'Orcs rule!','Orcs rule!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68230,'The water never lies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68231,'I\'ll destroy every last one of you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68232,'Is that all you\'ve got?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68233,'Get away from my ship!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68234,'I\'ll have all of your heads!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68235,'Where do you keep coming from?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68236,'These creatures have suffered enough. I will not let you defeat them!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68237,'The spirits smile upon my victory!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68238,'Ancestors forgive me. I have failed...','',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(68239,'Come rest. You will need your strength later in the battle.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68240,'Lok\'tar!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68241,'Your spirit reunites with your ancestors, little one.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68242,'These old bones have much knowledge to impart.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68243,'You will do better, next time.','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68244,'It has been an honor, outlander.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68245,'Perhaps this will test your skills.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68246,'You must focus.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68247,'A deft maneuver, outlander.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68248,'Who are you again?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68249,'My memory isn\'t what it used to be.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68250,'What day is it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68251,'I will crush you beneath the onslaught of my team!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(68252,'I hope you now understand that there is no defeating me.','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68253,'No matter. Nobody can stop me in the end.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68254,'Not so fast!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68255,'My victory draws near.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68256,'That simply will not suffice.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68257,'(A boss has been defeated in Heroic difficulty with the dampening field enabled. It may no longer be disabled.)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68258,'No... That\'s not right...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68259,'It should be beautiful. It should be pristine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68260,'Perhaps I brewed the tea wrong? Yes, that must be it. I brewed the tea wrong. My apologies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68261,'How did you end up here?','How did you end up here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68262,'When the SI:7 found me, they wanted to take me home. I ran away.$B$BIt wasn\'t long before the Horde found me.$B$BDuring the battle at Serpent\'s Heart, I managed to slip away in the chaos. A merchant allowed me to ride with his family as they fled west, to Zhu\'s Watch.$B$BIt was there that I met Mei Barrelbottom.$B$BShe told me of the Crane Wing order, and on her advice I accompanied a courier to the temple to seek an audience with Chi-Ji, the Red Crane.$B$BI was studying with the disciples there when the sha arrived.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68263,'I could not bear to sit in Stormwind Keep while my people\'s blood spills here!$B$BPandaria has so much to teach us. There is great power here. Power that could save thousands of lives.$B$BAnd I aim to find it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68264,'Why didn\'t you return to Stormwind with the SI:7?','Why didn\'t you return to Stormwind with the SI:7?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68265,'Shiny tools mine! Tasty carrots mine! All for Kunzen. All for Chief Yip-Yip!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(68266,'','Hey there, stranger. You getting along all right at the farm?',0,0,0,0,0,0,0,0,1,19124,0,0,26124),
(68267,'','You look a bit weak, $r. You\'ll need to travel more of the land before you\'re strong enough to help the folks out here.',0,0,0,0,0,0,0,0,1,19124,0,0,26124),
(68268,'','Folks \'round here are a little wary of strangers, but they warm right up once you get to know them.$B$BOnce you\'re more experienced, you can get to know them by helping them out.',0,0,0,0,0,0,0,0,1,19124,0,0,26124),
(68269,'','Folks \'round here are always in need of a hand, but you\'re not strong enough yet. Once you\'ve walked more o\' this land, you come back and they\'ll be begging you for aid.',0,0,0,0,0,0,0,0,1,19124,0,0,26124),
(68270,'','Have you seen Merchant Greenfield\'s supply of seeds? There are all sorts of strange and wonderful things you can grow on your farm.',0,0,0,0,0,0,0,0,1,19124,0,0,26124),
(68271,'','Have you ever thought about adding some animals to your farm?',0,0,0,0,0,0,0,0,1,19124,0,0,26124),
(68272,'','You know, that house that Farmer Yoon lives in is a dump! He should talk to Tina. I hear she\'s real good at redecorating.',0,0,0,0,0,0,0,0,1,19124,0,0,26124),
(68273,'','Have you seen all the goods that I sell? You\'ll have to earn favor with the Tillers to buy them from me, but in order to do that, you\'ll need to gain more experience by traveling this land.',0,0,0,0,0,0,0,0,1,19124,0,0,26124),
(68274,'Me and Gunny, we wash up wid a few of our crew near Sri-La Village in da Jade Forest. Our feet was itchin\' to walk da land after months on da churnin\' sea. We came here an\' found paradise.','',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(68275,'','Raj\'ku and I, we\'ve been traveling for days and days. Just when we think we\'ve seen it all, we\'re surprised again.',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(68276,'','I want to keep going until we see what\'s over that big wall to the west, but Raj\'ku just keeps staring at all the giant vegetables around here. Maybe deep down, he\'s itching to be a farmer!',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(68278,'Who c-c-c-calls?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68279,'C-c-c-cowards...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68280,'What do you currently have for sale?','What do you currently have for sale?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68281,'Can you tell me anything about your village?','Can you tell me anything about your village?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68282,'We are a town of brewers and farmers. We hunt on occasion when we need to.$B$BThat\'s where I come in. It\'s awfully hard to hunt without a quality bow!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68283,'','You chose a good day to come to the market, neighbor.',0,0,0,0,0,0,0,0,1,19144,0,0,26124),
(68284,'','Welcome to Halfhill Market!',0,0,0,0,0,0,3,0,1,19144,0,0,26124),
(68285,'What goods do you have available?','What goods do you have available?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68286,'','You here to buy or sell? Feel free to look around.',0,0,0,0,0,0,0,0,1,19144,0,0,26124),
(68287,'','You\'ve come to the right place! Halfhill Market\'s got everything you need.',0,0,0,0,0,0,0,0,1,19144,0,0,26124),
(68288,'','Hey there traveler, you looking to learn how to cook?',0,0,0,0,0,0,0,0,1,17441,0,0,26124),
(68289,'','Do you like to cook? Well you\'re in luck, because I like to help aspiring chefs.',0,0,0,0,0,0,0,0,1,17441,0,0,26124),
(68290,'$p! You\'re here! Assault their leader and we will back you up.','',4,0,0,0,0,0,0,0,1,19152,0,0,26124),
(68291,'If you\'re known for trade, where are the pandaren from other towns?','If you\'re known for trade, where are the pandaren from other towns?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68292,'','Set aside your weapon and take up a carving knife, traveler. The Ironpaws can teach you all manner of roasting, brewing, stewing, steaming, and grilling!',0,0,0,0,0,0,0,0,1,17441,0,0,26124),
(68293,'','If you seek to improve your cooking skill, I have knowledge to share with you.',0,0,0,0,0,0,0,0,1,17441,0,0,26124),
(68294,'','My best guess is that the enormous floating fortress deterred any would-be travelers as of late.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68295,'I\'d like to see what goods you have for sale.','I\'d like to see what goods you have for sale.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68296,'The journey was long, but I finally found the Vale. Now I am working with the Sentinels to understand the pools\' mysteries.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68297,'We managed to earn the Celestials\' trust and open the Vale, but we must continue to show them that we are on a mission of peace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68298,'It pained me to see so many displaced from their homes in Kun-Lai. I am very happy we found a safe haven for those in need of protection.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68299,'The Sentinels and I exchanged stories of our time in the Krasarang Wilds. I told them all about my adventures at the Temple of Chi-Ji.','',0,0,0,0,0,0,0,0,1,19158,0,0,26124),
(68300,'The more that I travel this land, the fonder I grow of the pandaren people. Such delicious food and drink does not hurt, either.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68301,'I have seen so much during my journey through this land. I feel older and perhaps a bit... wiser.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68302,'I believe that the Alliance\'s future is tied to that of Pandaria.$B$BAfter we landed here, we set certain paths into motion. We were there when the Serpent\'s Heart fell. In a way, we helped fulfill Lorewalker Cho\'s vision of the future.$B$BBecause of this, I cannot return to Stormwind until I have helped to set things right.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68303,'','Men, you\'ve trained for this. You\'re among the elite.  You are Skyfire men!',0,0,0,0,0,0,378,0,1,0,0,32550,26124),
(68304,'','This is the ship that took down Deathwing. You think some raggedy little Horde outpost stands a chance against the pride of the Alliance fleet? NO!',0,0,0,0,0,0,378,0,1,0,0,32551,26124),
(68305,'The Sentinels and I exchanged stories of our time in the Krasarang Wilds. I told them all about our adventures together at the Temple of Chi-Ji.','',0,0,0,0,0,0,0,0,1,19157,0,0,26124),
(68306,'','Those green dirtbags down there plagued your homes in Southshore, laid siege to your children in Redridge, and massacred every man, woman and child in Theramore.',0,0,0,0,0,0,25,0,1,0,0,32552,26124),
(68307,'','It. Is. PAYBACK TIME!',0,0,0,0,0,0,412,0,1,0,0,32553,26124),
(68308,'We should not fight here. Not like this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68312,'The earth has much to offer us, so long as we learn to take from it properly. I can teach you how, if you so wish.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68314,'','You aren\'t from around here. Are you interested in learning about the native plant life of Pandaria?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(68315,'The beasts of this land aren\'t like whatever it is you have in your home. Train with me so that you may know how to properly skin them.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68316,'','Zhao-Jin the Bloodletter storms the gates! We must stop him from entering the palace vaults!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68318,'','If we do not defeat the Shao-Tien now, all is lost!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68320,'I am holding the other mogu from entering the palace steps. Hurry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68321,'I... must... hold on!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68322,'I cannot hold this barrier forever. Quickly, you must deal with the warlord on the palace steps!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68323,'Hurry, $r! Our factions may be at war, but we have greater worries at the moment!','',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(68324,'I came to lend my aid to the fight. Is there anything I can do to help?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68325,'%s begins to summon |cFFFE9A2EFlamecoaxing Spirits|r! Defeat them to stop the Flame Wall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68326,'$n? What are you doing here? We need you up on the Skyfire! Quick, take the portal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68327,'Doren just needs a little more time. Hold the line!','Don\'t let the horde scum through!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68328,'They\'ve blown through the second barricade! Fight them back!','They\'ve blown through the second barricade! Fight them back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68329,'There\'s a $c incoming! Don\'t let $Ghim:her; through!','Stop $Ghim:her;! $GHe:She; must not get to Doren!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68330,'Let the spectacle begin!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68331,'I\'ll take that gold now, if you would be so kind.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68332,'So...how about we forget about our little wager and carry on with our busy lives?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68333,'Trying to pull a fast one on me, are you? I think not!','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(68334,'Help us rout them from your land, and your kind can stand tall and proud with the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68335,'It has been many years since I have seen it manifest so dramatically.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68336,'You can forfeit if you\'d like.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68337,'An unfortunate business expense.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68338,'','Remember your training, Helena...you\'ve got this.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68339,'','I did it!',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68340,'','Well, practice makes perfect I suppose.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68341,'','Come back before you get hurt!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68342,'','Nice! I\'m on my way to victory!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68343,'Oh no! That wasn\'t good...','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68344,'Let\'s take flight!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68345,'We\'re flying high!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68346,'Yes, thanks to $n. Zhao-Jin, leader of the Shao-Tien, is slain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68347,'','With the Celestials\' aid, we tore through the mogu advance. Our soldiers were able to clean up the rest, and drive them from the valley.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(68348,'Leven! You\'re alive! That must mean...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68349,'Our war against the mogu is not yet over. But today we can rest, and proclaim our victory.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68350,'All hail $n, savior of the Vale! Conqueror of the Shao-Tien, and defender of the people! May the stars sing your name!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68351,'Pull the Mist-Shaman\'s torch out from the ground!','',0,0,0,0,0,0,0,0,1,19175,0,0,26124),
(68352,'Shot out of the sky!','',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(68353,'$n, you\'ve done it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68354,'Take it easy, will ya?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(68355,'Now we\'re talkin\'!','',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(68356,'Cut down in its prime...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68357,'You\'re going to regret this, I assure you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68358,'I did warn you. Pity.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68359,'This is a most...unfortunate turn of events.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68360,'An unexpected twist.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68361,'Don\'t worry, it\'ll all be over soon.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68362,'I was using that.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68363,'You dare challenge me? I\'ll show you the true power of the Horde!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(68364,'Consider yourself fortunate that I was so merciful.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68365,'NO! You miserable wretch! I do not lose!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(68366,'I will not rest until I defeat you!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68367,'Pathetic.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68368,'You\'ll pay for that.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68369,'Me go first or you?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68370,'Me win! Me win!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68371,'You good at battling!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68372,'Me save this one for later.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68373,'Me win?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68374,'Why it no move?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68375,'By the might of King Varian\'s throne, I shall defeat you!','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(68376,'Another victory for the Alliance military!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68377,'I was warned about you. I should have heeded that warning.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68378,'I\'m not through with you yet!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68379,'By the grace of Prince Anduin I shall achieve victory this day.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68380,'We shall persevere.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68381,'','I wish you the best of luck.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(68382,'','Do not lament. Continue your training, and you shall achieve greatness.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68383,'I must go - there are others who have landed on our southern shores.','',0,0,0,0,0,0,1,0,1,0,32568,0,26124),
(68384,'','Well done. I applaud your skills as a tactician.',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(68385,'','Live to fight another day, and prosper.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68386,'','All is as it should be.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68387,'','You are quite powerful indeed.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68388,'Time to lay down da beatdown!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68389,'Mo\'ruk\'s the best!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68390,'Mo\'ruk...got beaten?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(68391,'Mo\'ruk not done yet!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68392,'That\'s the stuff!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68393,'No!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(68394,'','My pets are all hand-grown! You don\'t stand a chance!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68395,'','I knew I could count on my team to win!',94,0,0,0,0,0,0,0,1,0,0,0,26124),
(68396,'','My entire team\'s been razed!',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(68397,'','If you think I\'m out for the count, think again!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68398,'','We\'re really plowing through your team now!',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68399,'','This is going south quick!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68400,'Let us see who is the greater tamer.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(68401,'The day is mine. Well fought.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(68402,'You are a worthy foe. The day is yours.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(68403,'A smart fighter knows when retreat is the best option.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68404,'Capitalizing on your enemy\'s weaknesses is key.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68405,'Sometimes even the finest make mistakes.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68406,'You have not earned the right to defeat me, tamer.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68407,'I hope you learn from your defeat.','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(68408,'Clearly, I was wrong about you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68409,'You ought to rejoice that you even came close to defeating one of my pets.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68410,'Only a matter of time, now.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68411,'Impossible!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68412,'','Do not expect to defeat me.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(68413,'','Perhaps another day, tamer.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68414,'','Well done! Congratulations on your victory.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68415,'','Do not underestimate me.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68416,'','Do not expect mercy, tamer. I will show none.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68417,'','Impressive. I hadn\'t anticipated that.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68418,'Let\'s get this show on the road!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68419,'Nobody can beat a dwarf in his element!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68420,'Woah! Woah! Take it easy! You win!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68421,'I\'ve still got plenty of tricks up my sleeve!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68422,'That\'s more like it!','',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(68423,'He was just a wee pebble...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68424,'Very well. Let us fight.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68425,'Thank you. My pets are stronger than ever now.','',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(68426,'Such death...','',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(68427,'Rest, so that you may do battle again soon.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68428,'Ah. The taste of victory is sweet.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68429,'At least my pet died fighting valorously.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68430,'Show them the true meaning of pain.','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(68431,'You never stood a chance, whelp.','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(68432,'How? I cannot lose! I am imbued with the power of twilight!','',388,0,0,0,0,0,0,0,1,0,0,0,26124),
(68433,'Not even close.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(68434,'Continue the slaughter.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68435,'You fool!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(68436,'The time of your reckoning is upon us.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68437,'Do not fear defeat. It is a catalyst for later triumph.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68438,'I had thought my victory was certain. Clearly the Makers had other plans.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68439,'Your time has not yet come.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68440,'A mere blip in the eyes of the Makers.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68441,'You\'re stronger than I thought.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68442,'I\'ve been wondering when I would be fighting you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68443,'The lake told me it would be so!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68444,'I must have misunderstood the water\'s wisdom.','',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(68445,'Much hides just beneath the surface.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68446,'Another victim claimed by the unending tide.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68447,'Another grave in the depths.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68448,'How can I help the August Celestials?','How can I help the August Celestials?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68449,'','Once you are of revered standing with the Golden Lotus, you will be able to help the August Celestials.$B$BTo the east, Yu\'lon\'s temple is under attack by the Sha of Doubt.$B$BTo the south, Chi-Ji\'s trainees are rebuilding and retraining after the attack on their temple.$B$BTo the north, Xuen tests the might of worthy combatants who enter his rings.$B$BAnd to the west, Niuzao stands vigilantly against some of the most dangerous enemies in Pandaria.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68450,'Once you are of revered standing with the Golden Lotus, you will be able to help the August Celestials.$B$BTo the east, Yu\'lon\'s temple is under attack by the Sha of Doubt.$B$BTo the south, Chi-Ji\'s trainees are rebuilding and retraining after the attack on their temple.$B$BTo the north, Xuen tests the might of worthy combatants who enter his rings.$B$BAnd to the west, Niuzao stands vigilantly against some of the most dangerous enemies in Pandaria.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68451,'Auction House services can be found in your home city.','Auction House services can be found in your home city.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68452,'','Of course! Help yourselves.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(68453,'Wheeeeeee!','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(68454,'Whoa.... dizzy!','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(68455,'Thanks Miss Kite Lady!','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(68456,'Their leader is hold up behind this barracade. The coward. Let me know when you are ready to move in.','',0,0,0,0,0,0,1,0,1,0,32665,0,26124),
(68457,'Yeah! I love this song!','',0,0,0,0,0,0,0,0,1,18846,0,0,26124),
(68458,'','That\'s a pretty cool grasshopper right?  Want one of your own?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(68459,'How do I become a battle pet trainer?','How do I become a battle pet trainer?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68460,'','You need to talk to Audrey Burnhep in Stormwind City!  Any guard there should be able to give you directions to find her.$b$bYou will find a portal to Stormwind inside the temple.  Good luck!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68461,'','Have you ever seen so many unique pets?  Interested in catching some of your own?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(68462,'','Master Woo\'s defenses are nearing their maximum potential.  Use Touch of Death to finish her off!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68463,'','What do you think of my pet monkey?  Pretty cool right?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(68464,'','You look like someone that might be interested in some rare pets?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(68465,'What brews do you have for sale?','What brews do you have for sale?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68466,'I will not stand for needless violence!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68467,'','I\'ve been waiting to unleash this gunship against a worthy target. Let\'s spend some ammunition!',5,274,0,0,0,0,0,0,1,0,0,0,26124),
(68468,'','You need to speak with Varzok in Orgrimmar!  Any guard there should be able to give you directions to find him.$b$bYou will find a portal to Orgrimmar inside the temple.  Good luck!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68469,'You really have it in for the Horde, don\'t you?','You really have it in for the Horde, don\'t you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68470,'Let me browse your wares.','Let me browse your wares.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68471,'','<The Sky Admiral\'s face grows hard.>$b$bI grew up in Southshore. My parents are buried there - what\'s left of them.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(68472,'','These pandaren seem like good people.$b$bThey\'re reluctant to get embroiled in our war, but after a few weeks of dealing with the Horde, I have no doubt they\'ll all come around to our side.',1,273,0,0,0,0,0,0,1,0,0,0,26124),
(68473,'I\'m ready for battle! Help me focus Kaz\'tik.','I\'m ready for battle! Help me focus Kaz\'tik.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68474,'Wh... what is that?!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(68475,'It is so much larger than any of the Pandaren balloons... Does it belong to the outsiders?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(68476,'Is... is it some sort of giant flying whale?','',0,0,0,0,0,0,430,0,1,0,0,0,26124),
(68477,'Cannon loaded!','Cannon loaded!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68478,'It is worth it. I wish to augment my strength.<Pay 10,000 gold.>','It is worth it. I wish to augment my strength.<Pay 10,000 gold.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(68479,'It is worth it. I wish to augment my intelligence.<Pay 10,000 gold.>','It is worth it. I wish to augment my intelligence.<Pay 10,000 gold.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(68480,'Wind Lord Mel\'jarak senses more than 3 of his allies are incapacitated and frees them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68481,'You may stay in our village as long as you need, stranger. Just... please try to keep your weapons sheathed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68482,'So many new visitors... what is becoming of our village?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68483,'You, and your Alliance, are welcome in Paw\'don.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68484,'How can I serve?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68485,'We are here on a peaceful rescue mission - will you help us?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68486,'It has been many years since I have seen it manifest so dramatically.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(68487,'Who? ...What? Oh! The Ook is dooked? That is fantastic! Well done heroes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68488,'This one\'s on the house!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68489,'Ow! Ow! Ow!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68490,'Keep working! The general won\'t tolerate failure.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68491,'Get those engines running! Now!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68492,'Put your backs into it! You\'re the most pathetic group of goblins I\'ve ever seen!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68493,'','Wow - are you a $r from beyond the mists? What a crazy age we\'re living in!$b$bI just needed a moment to rest here. These steps can really take it out of you - going up OR down.',3,1,0,0,0,0,0,0,1,0,0,0,26124),
(68494,'Faster! The warchief\'s eyes are upon you.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68495,'Oh, nasty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68496,'You okay up there?','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(68497,'Keep polishing those cannonballs. I want to see my face in them!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68498,'Almost there!$b$bThere\'s a cold mug of relief waiting for me at the Tavern in the Mist. I can almost taste it already...','Keep going, you\'re almost there!$b$bThis is my third trip through the pass. I wish I could say it was getting easier!$b$bWhen you get to the top, there\'s a wonderful inn called the \"Tavern in the Mist.\" Keep your weapons close, though. You\'ll run across all kinds of characters.',1,11,0,0,0,0,0,0,1,0,0,0,26124),
(68499,'I want this deck so clean I could eat off of it!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68500,'Careful with that! If I see a single scratch on my new ship, it\'ll be your head!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68501,'Pick up the pace, men. We\'re about ready to set off!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68502,'Over here, $n! Your gyrocopter\'s ready to go!','',1,0,0,0,0,0,3,0,1,0,0,0,26124),
(68503,'Over here, $n!','Over here, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68504,'Alright, let\'s get back to shore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68505,'%s bleats at $n.','',0,0,0,0,0,0,0,0,1,0,32902,0,26124),
(68506,'','Huh! Don\'t get many visitors around here. Would you like to purchase some stew, neighbor?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(68507,'That was some firefight! Now it\'s time to clean up.','',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(68508,'Those that came on the Skyfire are the Alliance\'s finest. Still, there\'re some things that only the SI:7 can pull off.','',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(68509,'Dozens of pilots were shot down further to the north, including one of our own SI:7 agents.$B$BWe\'ve got to help all of \'em, but we\'ve got to deal with the Horde, first.','',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(68510,'Quite a lively event!\n\nI suspect our own brewmasters will attend and compete, next year.','Quite a lively event!\n\nI suspect our own brewmasters will attend and compete, next year.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68511,'','I heard that Commander Rell and the others found Amber! That is good news.',0,0,0,0,0,0,0,0,0,19220,0,0,26124),
(68512,'Knock Master Tsang\'s Assistants down with Crackling Jade Lightning.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68513,'','Hey there $Ghot stuff:toots;, I\'m all revved up and ready to battle!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68514,'Refugees are flooding into Binan from all throughout the steppes. I fear the yaungol have breeched the wall!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68515,'','Is Sploder\'s fuse supposed to be lit? There\'s a smudge on page 7...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68516,'Da Thunder King lives! Our empires be united once more...','',0,0,0,0,0,0,4,0,1,0,31484,0,26124),
(68517,'We NEED dis land! Da cataclysm destroyed our home!','',0,0,0,0,0,0,0,0,1,0,31485,0,26124),
(68518,'DESTROY...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68519,'Ever been to the Brewmoon Festival? It\'s a real treat. I\'m preparing a big batch of my Kun-Lai Kicker for the celebration.$b$bWant to join me in Binan Village?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68520,'YOUR FEEBLE ATTACKS MEAN NOTHING!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68521,'ARGH! THE HATRED OVERWHELMS ME!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68522,'Tamer ho! Prepare for battle!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68523,'Yer gonna be swimmin\' with the murlocs when we\'re through!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68524,'The burden of a king is great, as is the burden of a father. I will stop at nothing to find my son.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68525,'If the Horde will push us over the brink into war, then so be it.$B$BLight help me, I will fight for my kingdom and my people.$B$BGlory to the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68526,'Better luck next time, landlubber!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68527,'Another victory for me captain\'s log!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68528,'Not bad for a landlubber.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68529,'What a fight! If ye ever decide that yer done with the battlin\' game, maybe you could join me crew!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68530,'Show \'em what we\'re made of! ...hic!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68531,'Not so fast, matey. Yer on my turf!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68532,'Ready to walk the plank?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68533,'Keep on \'em, mateys. We\'ve got \'em on the run!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68534,'All hands on deck! We\'re losin\' men fast!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68535,'Why is me pet gone?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68536,'Me crush you like bug!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68537,'Me become powerful tamer, then me become da Gordok King!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68538,'Me da king!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68539,'Gluk is da best!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68540,'Wow! You amazing!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68541,'You no ogre! How you win?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68542,'Nobody messes with Gluk!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68543,'Surprise!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68544,'Pet smash! You die!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68545,'We crush you!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68546,'Me angry now!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68547,'Stupid tiny thing kill my tiny thing. RAAAAAAAAR!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68548,'','You ready to go or what?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68549,'','I don\'t have all day, pal!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68550,'','Fight\'s over, hot stuff. Better luck next time.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68551,'','Wait until the guys back in Everlook hear about this!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68552,'','You\'re pretty good...for a rookie.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68553,'','Yeah, yeah, you won. Big deal.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68554,'','Hey, look over there!',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(68555,'','Any tamer worth their weight in gold comes prepared!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68556,'','Don\'t worry, I\'m sure the next one will do great!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68557,'The pandaren may be strangers now, but in time, I believe they will prove to be valuable allies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68558,'The death of an Explosive Hatred should destroy his shield! Quickly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68559,'<All that remains of Malik the Unscathed, his polearm rests unceremoniously on a weapon rack.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68560,'<Ponder the lessons of Malik.> [Klaxxi Enhancement]','<Ponder the lessons of Malik.> [Klaxxi Enhancement]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68561,'Another stranger comes to our village... a $c by the look of it. Enter, but do not draw your weapons against us as the Horde did.','Another stranger comes to our village... a $c by the look of it. Enter, but do not draw your weapons against us as the Horde did.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68562,'<The words of Malik echo through your mind.>$B$B\"Heroes never die.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68563,'I shiver with power! I am the lone locust of the apocalypse!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68564,'','Prepare for your end.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68565,'','You will find no solace here.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68566,'Wow... these Alliance sure do have us working hard...','Wow... these Alliance sure do have us working hard...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68567,'These working conditions are horrible! We haven\'t had a beer break in HOURS!','These working conditions are horrible! We haven\'t had a beer break in HOURS!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68568,'','The damned demonstrate their superiority once more.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68569,'<He wipes the sweat from his brow.>$b$bHello there, $c. You here to help?','<She wipes the sweat from her brow.>$b$bHello there, $c. You here to help?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68570,'So... thirsty...','So... thirsty...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68571,'','The Master will be pleased.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68572,'Are you here to give me my break? It feels like I\'ve been working forever!','Are you here to give me my break? It feels like I\'ve been working forever!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68573,'I thought we were just building houses, not a fortress.','I thought we were just building houses, not a fortress.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68574,'','My torment continues.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68575,'I\'ve never worked this hard before in my life! I don\'t like it!','I\'ve never worked this hard before in my life! I don\'t like it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68576,'','No! You cannot defeat me!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68577,'Why do these guys have so many weapons?','Why do these guys have so many weapons?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68578,'','The dead shall have their day yet.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68579,'','Not to worry. I\'m far from finished with you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68580,'You can go home now. I\'ll cover your back.','You can go home now. I\'ll cover your back.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68581,'','Dust to dust.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68582,'','Ashes to ashes.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68583,'','I\'m not done yet.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68584,'','Do you honestly think death can stop me? I am death itself!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68585,'Come, and face the impeccable tactics of a blood knight!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68586,'Challenging me was a mistake.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68587,'None can withstand the onslaught of a blood knight.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68588,'Victory is mine!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68589,'You are a worthy opponent.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68590,'Curses!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68591,'Clearly a different approach is required.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68592,'A true fighter never enters a battle unprepared.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68593,'Let us continue the slaughter.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68594,'You will fall!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68595,'The balance swings in your favor, tamer.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68596,'You will not defeat me!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68597,'For the Alliance!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68598,'By the Light, I will defeat you!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68599,'Praise the Light!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68600,'It was an honor fighting you.','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(68601,'The other tamers were right about you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68602,'Well done, tamer.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68603,'Switch out!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68604,'Every soldier matters.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68605,'My victory is close at hand.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68606,'Hold off the Zan\'thik while Rik\'kal the Dissector gathers his strength!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68608,'For the glory of the Alliance!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68609,'We will fight to the last!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68610,'I will not fail!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68611,'My strength returns. Speak to me, Wakener, before I report to the Klaxxi.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68612,'','May our battle be glorious.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68613,'','May your pets be ready for this battle.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68614,'','I have triumphed this day.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68615,'','Thank you for the opportunity to demonstrate my skills.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68617,'','Congratulations, tamer!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68618,'','Well done, tamer!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68619,'','Another pet joins the fray.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68620,'','I will not let you defeat me.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68621,'','The battle sways in my favor.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68622,'','Victory may be mine this day.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68623,'','I will mourn your falling.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68625,'','This is most unfortunate.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68626,'Here I come!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68627,'You ready for this?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(68628,'Mo\'ruk wins!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68629,'Nobody can beat me!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68630,'You\'re tough!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68631,'OW!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68632,'Nuh uh!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68633,'Tricked ya!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68634,'Mo\'ruk beatin\' ya!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68635,'Take that!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68636,'Don\'t do that! That makes me lose!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68637,'Uh-oh...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68638,'','You think you stand a chance? I think not!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68639,'Help! Help! The Horde is here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68640,'Guards! The Horde is here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68641,'The Horde is here! In our base!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68642,'Guards! Over here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68643,'','You\'re going to wish you never fought me, I promise!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68644,'Help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68645,'','A bountiful victory!',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68646,'','Were my pets too much for you to handle, tamer?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68647,'','Wow, you\'re really strong!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68648,'','That sure turned sour quick...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68649,'','A diligent farmer never loses hope when her crop\'s in danger.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68650,'','Nice try, but you\'re going to need more than that!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68651,'','What\'s the problem, can\'t handle a simple farmer\'s pets?',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(68652,'','You\'re going to have to do better than that to beat me.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68653,'I suppose it is time I headed home.','I suppose it is time I headed home.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68654,'You\'re right. I didn\'t sign up to build a war base.','You\'re right. I didn\'t sign up to build a war base.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68655,'Thank you, $r.','Thank you, $r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68656,'','Take it easy, will ya?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(68657,'Thank goodness!','Thank goodness!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68658,'Thanks! I\'m outta here!','Thanks! I\'m outta here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68659,'You... you\'re not one of the Alliance? Good.','You... you\'re not one of the Alliance? Good.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68660,'Can\'t wait to get back home.','Can\'t wait to get back home.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68661,'Many thanks.','Many thanks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68662,'','You\'re really playing to win, huh?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(68663,'','We were investigating the crypt for sha corruption... and everything went horribly wrong.  Our leader, Jin Ironfist, was possessed and began killing everyone.  Even now he is in there looking for more victims.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68664,'Prepare yourself, tamer. I come for victory.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68665,'You do not intimidate me, tamer.','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(68666,'','Jin\'s life was stolen by the sha - do not blame yourself for his death.  You did what I could not.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68667,'Come back when you\'re better prepared.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68668,'Perhaps you will have better luck in our next encounter.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(68669,'You fight with the grace of a master tamer. Well done.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68670,'You can go home to your family now.','You can go home to your family now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68671,'Very impressive, tamer.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68672,'I will not allow you the pleasure.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68673,'You will not defeat me so easily.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68674,'To defeat an opponent in battle is to validate your strategy.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68675,'It seems my strategy is superior.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68676,'Do not be afraid to lose one battle if the war is won.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68677,'I see. You are more formidable than I had thought.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68678,'I\'ve endured horrors you cannot possibly comprehend. Defeating you will be simple.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68679,'I\'ll make this quick.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68680,'I did not doubt my victory for a moment.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68681,'Is that all you\'ve got?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68682,'I will not stand for this!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68683,'I\'ve seriously underestimated your prowess.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68684,'You will have to try harder than that to defeat me.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68685,'You do not stand a chance. I will defeat you!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68686,'Had enough?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(68687,'You are no match for me.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68688,'You got lucky.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68689,'No more playing around. I will crush you!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(68690,'','Your victories cease here, tamer.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68691,'','Few are able to keep their balance in battle against me. Let us see if you are any different.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(68692,'','As I expected. You are not yet skilled enough to defeat me.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(68693,'','Do not fret. You are one of many I\'ve defeated.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68694,'','What a wonderful display of technique!',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(68695,'','Your victory is well-deserved, tamer.',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(68696,'','We are far from finished.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68697,'','The Vale empowers me.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68698,'','You may flee the battle if you so wish.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68699,'','Fantastic!',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(68700,'','Perhaps you do stand a chance against me.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68701,'','Well done. But do you have the determination to carry through?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(68702,'So we finally meet to do battle.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68703,'I already know of my coming victory.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68704,'As the waters foretold.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68705,'Victory is mine!','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68706,'Caught like a fish out of water!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68707,'You are quite the tamer!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68708,'You cannot defeat me with such brute force.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68709,'May the waters guide me.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68710,'We will overwhelm you before you can react.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68711,'My pets claim yet another victim.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68712,'There are plenty more where that came from!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68713,'This is not going well...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68714,'You have already lost.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68715,'I will defeat you.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68716,'The true master has emerged victorious.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68718,'All a part of my plan.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68719,'I have lost to your mastery.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68720,'I do not understand. How could I lose?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68721,'Rest, so that the battle may continue to flow in our favor.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68722,'You cannot defeat the shifting sands of this land.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68723,'Another death hidden under the desert sand.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68724,'The battle shifts in my favor once more.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68725,'A most frustrating occurence.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68726,'Perhaps this battle will not be as easy as I thought...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68727,'Go Emeralda! Show them the folly of their ways!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(68728,'','Go get \'em, Fangs!',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(68729,'Clean them up, Foe Reaper 800!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(68730,'','You can do it, Flulfftail!',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(68731,'Finish them, Blackfang.','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(68732,'Give \'em hell, Burgle!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(68733,'Spike, show dem what you can do!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(68734,'','Tear them apart, Ripper!',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(68735,'','It\'s your turn, Mr. Pinch!',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(68736,'Brewmaster Blanche is probably up on Thunderpaw Overlook. She\'s convinced a storm is on the way, so I\'d better make sure her equipment is ready.$b$bI can\'t imagine I\'ll ever be half the Brewmaster she is - she once casked a Spring breeze. When they uncorked it a year later at the Jade Temple, you could still smell the blossoms!','',1,273,0,0,0,0,0,0,1,0,0,0,26124),
(68737,'','Show dem pain, Constrictor.',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(68738,'','Rockhide, show them your strength!',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(68739,'Rasp, shoot fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68740,'','Willow, it\'s your turn to soar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68741,'','Nobody can beat Cluckatron!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68742,'Alright, Blaze, let\'s roast \'em!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68743,'Face the fury of Ultramus!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68744,'','Cho\'guana, teach them a lesson.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68745,'','Blizzy, knock \'em out cold!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68746,'Perhaps Subject 142 will be more successful than Subject 141.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68747,'','Plaguebringer, show them the power of the plague!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68748,'Face the wrath of Obsidiion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68749,'Come on out, Croaker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68750,'Ignious, burn \'em up for me, won\'t you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68751,'','Hunt them down, Nightstalker.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68752,'','Goliath online.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68753,'You can do it, Fungor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68754,'Stompy, show this tamer what you can do!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68755,'Chomps, it is your turn to demonstrate your power.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68756,'Arcanus, show them our endless power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68757,'I believe in you, Gobbles!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68758,'Stitch, would you please show our upcoming tamer how we like to battle?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68759,'Drogar, destroy them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68760,'Fleshrender kill you now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68761,'Grizzle, the pride of Ironforge, come onto the field!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68762,'','Dor the Wall, please join us on the battlefield.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68763,'Needleback gonna beatcha!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68764,'','Nobody can beat you, Toothbreaker!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68765,'Bleat, come face this foe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68766,'Come fight, Crusher.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68767,'','Stormlash, vanquish these foes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68768,'Tear em ta pieces, Fracture!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68769,'I call upon you, Kali.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68770,'Leave no trace of them, Amythel. Destroy them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68771,'You stand no chance against the might of Pyth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68772,'Skimmer, old friend, it is your turn to battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68773,'','Farewell stranger. When next we meet, I hope to call you friend.',0,0,0,0,0,0,0,0,1,0,0,28570,26124),
(68774,'%s fades.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68775,'%s is depleted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68777,'','Come, try again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68779,'<The blade hovers in the air in front of you.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68780,'You a hunter? I can fix up your beast-beasts quick!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68781,'You have pets that need watching? I promise I will consider not eat them.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68783,'Yo boss, how\'s it goin\'?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68784,'Dis only just begun... we ain\'t gonna jes... roll over and die...','',0,0,0,0,0,0,0,0,1,0,31486,0,26124),
(68785,'','SET ME FREE... THE KLAXXI CALL...',0,0,0,0,0,0,0,0,1,0,0,30214,26124),
(68786,'','THE HATCHING HOUR IS NIGH... I MUST ANSWER TO THE SWARM...',0,0,0,0,0,0,0,0,1,0,0,30215,26124),
(68787,'','NO... YOU WILL NOT KEEP ME INSIDE THIS ABHORRENT PRISON...',0,0,0,0,0,0,0,0,1,0,0,30216,26124),
(68788,'','MAMA STORMSTOUT IS NOT HERE ANYMORE...',0,0,0,0,0,0,0,0,1,0,0,30217,26124),
(68789,'|TInterface\\Icons\\inv_weapon_shortblade_37.blp:32|t  Strong Attack$b$b|TInterface\\Icons\\inv_weapon_shortblade_92.blp:32|t  Stronger Attack$b$b|TInterface\\Icons\\ability_rogue_shadowstrikes.blp:32|t  Strongest Attack','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(68790,'If it is war you mean to bring to our shores, the very land itself will respond to your passions and your violence. I do not know what the ultimate consequences will be - nobody does.','',0,0,0,0,0,0,25,0,1,0,32577,0,26124),
(68791,'Get those cannons loaded!','Get those cannons loaded!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68792,'Give \'em hell!','Give \'em hell!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68793,'Blow that abomination out of the sky!','Blow that abomination out of the sky!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68794,'Get those fires under control!','Get those fires under control!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68795,'$n sets down some leftovers for hungry people.','$n sets down some leftovers for hungry people.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68797,'|TInterface\\Icons\\trade_archaeology_delicatemusicbox.blp:20|tImperial Vizier Zor\'lok sings the |cFFFF0000|Hspell:123791|h[Song of the Empress]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68798,'Enough! Survey the damage. What\'s this - an Alliance stronghold? They think to lay claim to this land already? NOT ON MY WATCH!','',0,0,0,0,0,0,0,0,1,0,32514,0,26124),
(68799,'Get those engines repaired or we\'re dead in the sky. And hit that base with everything we\'ve got!','',0,0,0,0,0,0,0,0,1,0,32515,0,26124),
(68800,'Haha! That\'s right. Show them Hellscream\'s fury!','',0,0,0,0,0,0,0,0,1,0,32516,0,26124),
(68801,'THAT was payback for Taurajo!','',0,0,0,0,0,0,0,0,1,0,32517,0,26124),
(68802,'Hah! KILL ANYTHING THAT MOVES!','',0,0,0,0,0,0,0,0,1,0,32518,0,26124),
(68803,'Alliance dogs will find no refuge in this land!','',0,0,0,0,0,0,0,0,1,0,32519,0,26124),
(68804,'Aim true! Send them limping back to Stormwind!','',0,0,0,0,0,0,0,0,1,0,32520,0,26124),
(68805,'We\'ve softened them up. They run and hide like rats from the might of the Horde. NO QUARTER!','',0,0,0,0,0,0,0,0,1,0,32513,0,26124),
(68806,'Their cowardly leader hides behind this barricade. Where are my sappers?','',0,0,0,0,0,0,0,0,1,0,32521,0,26124),
(68807,'For the Horde!','',0,0,0,0,0,0,0,0,1,0,32522,0,26124),
(68808,'Coward!','',0,0,0,0,0,0,0,0,1,0,32523,0,26124),
(68809,'','Click on monks to knock them back.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68810,'I need another mask, Ken-Ken.','I need another mask, Ken-Ken.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68811,'I lost \"Scrutiny.\"','I lost \"Scrutiny.\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68812,'Thank you, stranger. I... have never felt like that before.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68813,'Life suddenly seems so much brighter.$B$BI still love sleeping, though.','Life suddenly seems so much brighter.$B$BI still love sleeping, though.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68814,'Thank you again for your help. I will remain here briefly, to help tend the wounded.$B$BThen I will be making my way north...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68815,'Take me back to the present.','Take me back to the present.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68816,'','You need only ask when you are ready to return to the present.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68817,'I\'m ready to help you find your weapon.','I\'m ready to help you find your weapon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68818,'Something happening?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68819,'I... lost my mask. I need a new one.','I... lost my mask. I need a new one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68820,'$n detonated a Wind Bomb!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68821,'Did you know that Lin found the Hidden Master? He\'s in Paoquan Hollow.','Did you know that Lin found the Hidden Master? He\'s in Paoquan Hollow.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68822,'She did? He is?$b$bI suppose I\'ll have to head over there then. Maybe... after a few more bites of food...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68823,'Lin finds the Hidden Master? Then our training can continue!$b$bOnly one thing. Ken-Ken must finish helping the sads first. Too many sads here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68824,'I can\'t believe it! I was certain that he\'d be here in the Wilds.$b$bPaoquan Hollow, you say? I\'ll join her soon, and we can continue our training. For the time being, I\'ve already found an adventure of my own.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68825,'Yes. I knew that she could do it. She is shy, but she is strong.$b$bI shall finish my business here. Then I shall join her.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68832,'(A boss has been defeated in Heroic difficulty with Klaxxi Resonance enabled. It may no longer be disabled.)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68833,'(A boss has been defeated in Heroic difficulty with the Ritual of Purification active. It may no longer be disabled.)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68834,'I\'m ready to tackle those chores with you.','I\'m ready to tackle those chores with you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68835,'','The events that take place here will forever change this land.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68836,'I could get used to livin\' like this.','',30,30,0,0,0,0,30,0,1,0,0,0,26124),
(68837,'','I get the feeling the negotations aren\'t going well...',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(68838,'Hey, newbie! You interested in a fight?','Hey, newbie! You interested in a fight?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68839,'Yes, sign me up for a fight!','Yes, sign me up for a fight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68840,'$n is our victor!','$n is our victor!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68841,'Ouch... sorry, $n. Get back in line and try again.','Ouch... sorry, $n. Get back in line and try again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68842,'Now entering the arena: a Rank 1 $r $c, $n! $n is pretty new around here, so go easy!','Now entering the arena: a Rank 1 $r $c, $n! $n is pretty new around here, so go easy!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(68843,'You here to fight?','You here to fight?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(68844,'Well well well! $n wins! Looks like I owe someone some money.','Well well well! $n wins! Looks like I owe someone some money.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68845,'Congratulations, $n! Try not to leave any bloody footprints outside of the arena.','Congratulations, $n! Try not to leave any bloody footprints outside of the arena.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68846,'It\'s official! $n managed not to die. Great job not dying, $n!','It\'s official! $n managed not to die. Great job not dying, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68847,'Yechhh... what a mess. Can we get a priest or something over here?!','Yechhh... what a mess. Can we get a priest or something over here?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68848,'That... did not end well.','That... did not end well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68849,'$n, $n, $n. Next time, try not to die so much.','$n, $n, $n. Next time, try not to die so much.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68850,'Can I replace something I\'ve already planted?','Can I replace something I\'ve already planted?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68851,'Sure can! I left grandpa\'s shovel out with the rest of the tools.$B$BYou can use it to dig up a Growing crop, clearing the land to make room for something else.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68852,'','$n is representing Orgrimmar!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(68853,'','$n is representing the Darkspear Trolls!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(68854,'','$n is representing Thunder Bluff!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(68855,'','$n is representing Undercity!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(68856,'','$n is representing Silvermoon City!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(68857,'','$n is representing the Bilgewater Cartel!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(68858,'','$n is representing the Huojin Pandaren!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(68859,'This is $n\'s first fight ever!','This is $n\'s first fight ever!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(68860,'This is $n\'s first fight today!','This is $n\'s first fight today!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(68861,'','Also entering the arena: Bruce, a crocolisk that we found!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(68862,'','From deep within the bowels of Blackrock Mountain, it\'s Sanoriak, master of flame!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(68863,'','Also entering the arena: Kirrawk, wind-wielding arakkoa of the Terokkar Forest!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(68864,'Protect and serve.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68865,'Intruder alert.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68866,'Halt. Your presence here is not authorized.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68867,'Intruders detected. Engaging.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68868,'Activating extermination protocol.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68869,'Weapons systems primed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68870,'You\'re next up! Unless someone cuts in front of you, that is.','You\'re next up! Unless someone cuts in front of you, that is.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(68871,'Let\'s see... you\'re second in line. Won\'t be long now.','Let\'s see... you\'re second in line. Won\'t be long now.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(68872,'Looks like you\'re third in line, $c.','Looks like you\'re third in line, $c.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(68873,'You\'re fourth in line, $r.','You\'re fourth in line, $r.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(68874,'You are the fifth person in line. Shouldn\'t be too much longer.','You are the fifth person in line. Shouldn\'t be too much longer.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(68875,'You\'re sixth in line.','You\'re sixth in line.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(68876,'You\'re seventh in the queue.','You\'re seventh in the queue.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(68877,'You\'re eighth in line, $r.','You\'re eighth in line, $r.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(68878,'You\'re ninth in line.','You\'re ninth in line.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(68879,'You are tenth in line.','You are tenth in line.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(68880,'Busy day today. There\'s at least ten people in line in front of you. Not too many more than that, though.','Busy day today. There\'s at least ten people in line in front of you. Not too many more than that, though.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(68881,'There\'s at least fifteen people waiting in line ahead of you. Hard to tell - it\'s a little busy in here right now.','There\'s at least fifteen people waiting in line ahead of you. Hard to tell - it\'s a little busy in here right now.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(68882,'Keep waiting - there\'s at least twenty people who got here before you did. Maybe more.','Keep waiting - there\'s at least twenty people who got here before you did. Maybe more.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(68883,'I think you\'re number thirty in line? Maybe forty? I lost count a while back.','I think you\'re number thirty in line? Maybe forty? I lost count a while back.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(68884,'There\'s at least fifty people in line in front of you. It\'s packed in here. I\'d wait for things to calm down a bit if you want to fight anytime in the next hour or two.','There\'s at least fifty people in line in front of you. It\'s packed in here. I\'d wait for things to calm down a bit if you want to fight anytime in the next hour or two.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(68887,'How many people are waiting in line in front of me?','How many people are waiting in line in front of me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68888,'Now entering the arena: an up-and-coming Rank 2 $c, $n!','Now entering the arena: an up-and-coming Rank 2 $c, $n!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(68889,'Put your hands together for $n! $n is a Rank 3 $c.','Put your hands together for $n! $n is a Rank 3 $c.',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(68890,'Here\'s our challenger. Today, we welcome a Rank 4 $r $c, $n!','Here\'s our challenger. Today, we welcome a Rank 4 $r $c, $n!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(68891,'Now entering the arena, we have a very talented $c. Say hello to $n, a Rank 5 brawler!','Now entering the arena, we have a very talented $c. Say hello to $n, a Rank 5 brawler!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(68892,'Look out... here comes the deadly Rank 6 $r, $n!','Look out... here comes the deadly Rank 6 $r, $n!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(68893,'Now entering the arena: a returning champion. Our Rank 7 $c, $n!','Now entering the arena: a returning champion. Our Rank 7 $c, $n!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(68894,'Now entering the arena: You know $ghim:her;. You love $ghim:her;. Give it up for our Rank 8 Brawler, $N!!','Now entering the arena: You know $ghim:her;. You love $ghim:her;. Give it up for our Rank 8 Brawler, $N!!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(68897,'Pet battles! Here, in the Ring of Glory!','',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(68898,'Tamers! Can YOUR pets best a team of the Faire\'s Finest?','',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(68899,'A challenge to tamers, big and small! Can you battle my pets, and best them all?','',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(68900,'Put your pets to the test, and challenge the best!','',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(68901,'Will you challenge the best?$B$BWill you lose like the rest?$B$BOnly one way to find out. Dare you attempt it, $gsir:madame;?$B$BOnly a token for a try...','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(68902,'And so it begins.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(68903,'Please enjoy the rest of your time at the Faire. Or did you want another round...?','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(68904,'Well done, well done.','',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(68905,'Shall we try another...?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(68906,'They ARE the Faire\'s finest, after all.','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(68907,'Alas! Too soon.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(68908,'I challenge you to a pet battle! |cFF0008E8(Darkmoon Game Token)|r','I challenge you to a pet battle! |cFF0008E8(Darkmoon Game Token)|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68909,'The ship is about to explode.  Run to the top deck and swing away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68910,'10','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68911,'9','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68912,'8','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68913,'7','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68914,'6','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68915,'5','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68916,'4','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68917,'3','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68918,'2','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68919,'1','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68920,'Life thrives in this jungle, $c. Birds call down from the canopy. Beasts roar out from the dark, hidden places below.$b$bAnd we, the hunters, keep them in check. It is our place - our obligation - to do so.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68921,'We would like to fight the Ancient Bloodcrown Crane.','We would like to fight the Ancient Bloodcrown Crane.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68922,'We would like to fight the Krasari Elder.','We would like to fight the Krasari Elder.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68923,'We would like to fight the Colossal Viseclaw.','We would like to fight the Colossal Viseclaw.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68924,'Can I purchase one of your traps?','Can I purchase one of your traps?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68925,'$n has captured an Ancient Bloodcrown Crane!','$n has captured an Ancient Bloodcrown Crane!',0,0,0,0,0,0,0,0,1,20278,34492,34492,26124),
(68926,'$n has captured a Krasari Elder!','$n has captured a Krasari Elder!',0,0,0,0,0,0,0,0,1,20278,34493,34493,26124),
(68927,'$n has captured a Colossal Viseclaw!','$n has captured a Colossal Viseclaw!',0,0,0,0,0,0,0,0,1,20278,34494,34494,26124),
(68928,'$n has captured an Ancient Bloodcrown Crane!','$n has captured an Ancient Bloodcrown Crane!',0,0,0,0,0,0,0,0,1,20279,34492,34492,26124),
(68929,'$n has captured a Krasari Elder!','$n has captured a Krasari Elder!',0,0,0,0,0,0,0,0,1,20279,34493,34493,26124),
(68930,'$n has captured a Colossal Viseclaw!','$n has captured a Colossal Viseclaw!',0,0,0,0,0,0,0,0,1,20279,34494,34494,26124),
(68931,'Disruptron Mk. 3R-Alpha ready for combat testing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68932,'Disruptron Mk. 3R-Alpha initiating perpendicular disruptor beams.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68933,'Operational status: nominal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68934,'Activating Tri-Phasic Disruptor Alpha.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68935,'Activating Tri-Phasic Disruptor Beta.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68936,'Activating Dual-Phasic Disruptor Alpha.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68937,'Activating Dual-Phasic Disruptor Beta.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68938,'Activating Penta-Phasic Disruptor Omega!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68939,'No, No, No! Turn them all on! Turn them all on!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68940,'Disruptron Mk. 3R-Alpha shutting down, reccommend recalibration of combat test.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68941,'Disruptron Mk. 3R-Alpha shutting down, combat test: successful.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68942,'Very well. Beware the crane\'s song... or you may find yourself too distracted to fight.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(68943,'A word of advice: Stay close to her.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(68944,'Disruptor Field calibration success, subject terminated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68945,'Do not let the crab stand still. Its shell has hardened with age, but its joints are weak.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(68946,'What\'s going on out there?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68947,'Eyes of Warding protect Zen\'shar from all damage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68948,'Zen\'shar is vulnerable to damage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68949,'This is not a beast you will wish to fight alone, $n. Gather allies. I will open the beast\'s cage when you believe that you are ready.','',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(68950,'Turret non-functional, updating test parameters.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68951,'','For the glory of Hellscream!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(68952,'','You dare challenge the Kor\'kron!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(68953,'','Alliance scum!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(68954,'A $c?! I hate $cs! <Tasty though.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68955,'At last! A warm-up! <Tiny Alliance person!>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68956,'Avenge me... Dac! <No, you avenge me... Or!>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68957,'I... really... hate... $rs! <Should have run... we should have run!>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68958,'Collecting \"distilled\" fuel.','Collecting \"distilled\" fuel.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68959,'Gathering lumber.','Gathering lumber.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68960,'Mining iron.','Mining iron.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68961,'Dook...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68962,'MANKER!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68963,'The hunting is good here. Birds call down from the canopy. Beasts roar out from the dark, hidden places below.$b$bAnd we keep them in check.$b$bIt\'s our obligation as hunters - and it\'s bloody good sport, too.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68964,'Bo, your death ray doesn\'t work as advertised!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68965,'If we survive this, remind me to find a competent partner!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68966,'I\'m going to cover, you blow them up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68967,'Pick up the slack Max, I\'m carrying you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68968,'Welcome to the jungle, $n.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(68969,'Timer start setup.... initiate!','Timer start setup.... initiate!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(68970,'GG Engineering is gonna mop the floor with your sorry mug!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68971,'My teammate is to blame for everything...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68973,'GG.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68974,'Beware the crane\'s song, mate. You just might find yourself too distracted to fight.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(68975,'You want my advice? Stay close to her.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(68976,'Keep that crab on his toes, mate. His shell might \'ave hardened with age, but his joints are weak.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(68977,'You don\'t want to fight this beast alone, $n. Gather allies. I\'ll open the beast\'s cage when you think you\'re good and ready.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(68978,'Sometimes I get so tense, but I can\'t speed up the time...','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(68979,'All we need is just a little patience.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(68980,'I aint got time for the game \'cause I need you.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(68981,'I sit here by the falls, cuz I\'d rather be alone.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(68982,'Said woman take it slow, it\'ll come together fine...','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(68983,'You and I\'ve got what it takes to make it.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(68984,'Was a time when I wasn\'t sure, but you set my mind at ease.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(68985,'ATTACK!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(68986,'Almost time to attack!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(68987,'Can you believe these people just set out free food? This place is amazing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68988,'Yes, $r?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(68989,'My squad stands ready, $r.$b$bWe have a traditional defense that should prove effective against your Horde enemies.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(68990,'By order of King Varian Wrynn we must prepare your defenses, Jinyu.','By order of King Varian Wrynn we must prepare your defenses, Jinyu.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(68991,'Alrighty! I think we are going to need to call in some air support for this one.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(68992,'Demolishers? Nothing a little gnomish enginuity can\'t overcome. Send in the copters!','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(68993,'Hmm. These Demolishers seem to have a serious weakness to rockets. Send in the copters!','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(68994,'Orcs are dangerous but mounted orcs are more so. Release the hounds!','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(68995,'Wolves in captivity? We should \"rescue\" these poor animals.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(68996,'You know, I have often thought of making a mechano-pup. We should study these wolves more closely.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(68997,'Ah! This will give me a chance to test out my Tunnel-Tron Mk V! Hold on tight!','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(68998,'Time to get you inside the fortress. Hold on tight!','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(68999,'Time to test my new \"Fly-Diggy Wing\" upgrade! Hang on!','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(69000,'Mount up! There\'s work to be done!','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(69001,'Woops! Sorry about that.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(69002,'Hmm. Telemetry seems to be off.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(69003,'Note to self: Build parascope.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(69004,'Was that a wall? That sounded like a wall.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(69005,'This would be a lot easier if I could see.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(69007,'I yield.  It was a worthy battle. Thank you, friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69008,'I must keep my blades sharp - the threat of the Legion is ever-present.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69009,'What\'s wrong, minnows? You break a scale? let\'s get moving!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(69010,'You minnows finish early and you can go for a nice swim. How\'s that sound?','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(69011,'%s becomes enraged from the death of Fran.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69012,'Easy now. We don\'t want you setting one of these off prematurely...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(69013,'Swing those hammers, squishies!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(69014,'Better hurry it up! We don\'t wanna be here when the fighting starts.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(69015,'Discovering the power in these shards gave me the will to drag myself out of the gutter and get my life together.$B$BOh, and also I was kicked out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69016,'Four months magic-free and it feels great.$B$BWho needs the infinite mystery of the arcane when you\'ve got fresh fruit and hot tea like this?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69017,'These pandaren make some pretty good hooch, but none of them have heard of my favorite drink.$B$BMaybe I\'ll teach it to them some time...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69018,'-sniff- Woo! The old robe\'s getting a bit ripe.$B$BMaybe I can sneak a bath in that pond tonight...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69019,'What kind of portals will the shards allow me to open?','What kind of portals will the shards allow me to open?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69020,'Testing, testing, 1, 2, 7. Can you hear me $p? I have deployed Scout-o-meters in the field to gather data for the Siege-o-Matic here. This should help with a proper and mostly non-lethal test of my Siege-o-Matic.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69021,'Goblin bombs. They have one major weakness: Other Bombs. I\'ll be right back.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(69022,'More Goblin Bombs? It seems like only yesturday I was getting rid of a pile of goblin bombs. Wait here a moment.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(69023,'Goblins sure do love their bombs. Let\'s go ahead and show them how a gnome makes a bomb. I\'ll be right back.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(69024,'Small, one-time portals to a major Horde or Alliance city.$B$BThe shards all washed down the drain together, so there\'s no way for me to know which shard will end up going where. The best I can do is figure out whether they came from Sunreaver portals or Silver Covenant portals. Both sides like to put a little signature in their portal magic - typical elvish flair.$B$BI\'ll sell you shards appropriate for your faction, and you\'ll find out where they go once they\'re stabilized.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(69025,'Sounds good.','Sounds good.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69027,'Fire!','',0,0,0,0,0,0,25,6,1,0,0,0,26124),
(69028,'I want to buy some portal shards.','I want to buy some portal shards.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69029,'Thank you, hero. You have granted me another chance at life.','Thank you, hero. You have granted me another chance at life.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69030,'The mogu\'s strength is astonishing.','The mogu\'s strength is astonishing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69031,'If our reinforcements had arrived, we may have had a chance.','If our reinforcements had arrived, we may have had a chance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69032,'The mogu\'s sorcery is unlike any we have encountered before.','The mogu\'s sorcery is unlike any we have encountered before.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69033,'I watched the mogu torture my friends. Thanks to you, I have been spared.','I watched the mogu torture my friends. Thanks to you, I have been spared.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69034,'They crushed us as if we were ants. What monstrous power these mogu have!','They crushed us as if we were ants. What monstrous power these mogu have!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69035,'Greetings! I am Tinkmaster Overspark, the chief architect of modern Gnomish Engineering.$b$bOur assembly bay is hard at work fashioning all sorts of great mechanical wonders to aid you in not getting stabbed, slashed, blowed up, or otherwise banished from this realm of existence.$b$bOr at least, not by our enemies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69036,'','This fortress will be harder to take than Garrosh\'ar was. But sooner or later, they will break. The Horde always breaks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69038,'Help! Help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69039,'It\'s the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69040,'The Horde is coming! The Horde is coming!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69041,'I don\'t wanna die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69042,'Heeeeeelp!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69043,'Aaaaaahhhhhhh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69044,'I never even got to meet Lady Jaina...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69045,'Why did I ever leave Goldshire?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69046,'Wait \'till ya see me in action!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69047,'To arms!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69048,'What\'s this?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69049,'Death comes for ye!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69050,'For Khaz Modan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69051,'It\'s a traaaap!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69052,'Well done, squad. Dismissed!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69054,'Taste my blade!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69055,'[PH] As the Warchief commands...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69056,'[PH] Know what... it be time to be mountin\' up, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69057,'[PH] It seems dere be some Saurok guardin da cave.  Let\'s take care of \'em.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69058,'[PH] Dat Saurok be their commander. Take him out, now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69059,'Ready to get dis thing started?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69060,'I\'m ready. Let\'s go.','I\'m ready. Let\'s go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69061,'Good. You\'ve arrived. Now I can get out of here before I throw this goblin into the ocean.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69062,'Here\'s your escape device.','Here\'s your escape device.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69063,'','I would have died in the Jade Forest had it not been for a pandaren mistweaver who healed my wounds after the battle.$b$bThese pandaren are good people and deserve our protection from the domination of the Alliance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69064,'Welcome to the war, kid.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69071,'','Don\'t worry, I\'ll fix you right up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69072,'','It\'s just a few broken bones and some internal bleeding. Nothing an icepack can\'t fix!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69073,'','Shhh, this patient needs to rest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69074,'','This one is in pretty bad shape.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69075,'','Now where did I put my Windwool Bandages?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69076,'Do you see the size of this beast? It took nearly six of us to overpower him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69077,'These mogu brutes have incredible raw strength.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69078,'Under the Warchief\'s orders, we will reveal all of the mogu\'s secrets.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69079,'I will use all the resources at my disposal to expose the source of the mogu\'s power.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69080,'I brought my people here at Garrosh\'s request. Little did I realize we were to be sacrificed like pawns in a game.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69081,'There is a difference between testing one\'s strength and blindly walking into harm\'s way. Garrosh sent us to do the latter, and this I cannot accept.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69082,'Has our loyalty not been tested and proven, time and again? All I hear from our Warchief\'s mouth are falsehoods and excuses.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69083,'Garrosh spouts on about honor and strength, but in truth our leader sees only two outcomes - either fight and survive, or be defeated and forgotten.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69084,'I have no use for cowards in my army. Lately, I have been questioning the blood elves\' courage, and loyalty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69085,'Here on Pandaria, I see a land that the Horde deserves. We will take it for our own, and if anyone stands in our way, mogu or Alliance, we will raze them to the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69086,'Was I wrong to assume your Blood Elves could handle themselves?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69087,'Your weakness is not my failing, Regent. My Horde has room only for those strong enough to stand within it.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(69088,'Yes, and with your help, we will pry the secrets from this land. For the glory of the Horde!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(69089,'If I must pay with some elven blood, then so be it.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(69090,'You are too timid, Regent. Blood is the price we pay to carve our place in this world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69091,'You gave us no warning about the mogu, Warchief. These statues came to life!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(69092,'We could have, had we been given any warning. You threw my people to the wolves.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69093,'Do not question my loyalty, Warchief. We came across an ocean to fight for you.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(69094,'Take care, Garrosh. You would destroy the Horde to create your perfect future.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69095,'I will see no more of my people\'s blood shed meaninglessly. Waste your men if you wish, Warchief, but you will waste none of mine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69096,'You all head up the hill, we\'ll check for another entrance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69098,'I am Destructobyte, the great usurper! And as you can see, I have found your secret plans!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69099,'Fools! You thought they were hidden, deep in the sands of Uldum...','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(69100,'Now, choke on your own hubris!','',0,0,0,0,0,0,23,0,1,0,0,0,26124),
(69101,'Ah- hah hah hah hah haaa!','',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(69102,'My... grand creation! How DARE you?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(69105,'Tightening the valve.','Tightening the valve.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69107,'Show youselves, Alliance scum!','',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(69108,'I can smell you, $pr. Come and fight!','',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(69109,'Get out here, or we start beating these laborers!','',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(69110,'We\'ll run every last one of you fools from this land!','',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(69111,'This jungle will soon be cleansed of Alliance filth!','',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(69112,'It\'s your turn to die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69113,'Come, children, feast on their flesh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69114,'You dare disturb the Saurok brood? That is punishable by death.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69115,'Arrrrggggghhh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69116,'Ugh, my back! You\'ll pay for that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69117,'[PH] Water. I hate water, mon. CALL IN DA BOAT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69118,'[PH] Boat Ride Over!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69119,'[PH] Get in da boat, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69120,'Jinyu Construction Site Under Attack!','Jinyu Construction Site Under Attack!',0,0,0,0,0,0,30,0,1,0,34768,34768,26124),
(69121,'','Use the Guardian\'s Light to stop the Dark Summoner\'s minions!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69122,'','Hero, you must defeat the Dark Summoner\'s minions in order to weaken his protective magic.  Until then he will be invulnerable.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69123,'The Dark Summoner is vulnerable for a short time, now\'s your chance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69124,'The Dark Summoner\'s protective magics are active once again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69125,'The Darkhatched Lizard-Lord calls for help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69126,'[PH] Kite him through da statis trap, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69127,'The Darkhatched Lizard-Lord prepares to unleash a group of Water Jets!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69128,'[PH] It\'s protectin\' dem eggs! Crack its skull, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69129,'We\'ll never finish in time! Can\'t we make them go faster?','We\'ll never finish in time! Can\'t we make them go faster?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(69130,'You have some spare commissions you\'d like to spend? I\'ll take them off your hands.$b$bWhat would you like to buy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69131,'%s has hired a mage!','%s has hired a mage!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69132,'%s has hired a paladin!','%s has hired a paladin!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69133,'%s has hired a priest!','%s has hired a priest!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69134,'%s has hired a druid!','%s has hired a druid!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69135,'%s has hired a warrior!','%s has hired a warrior!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69136,'%s has hired a rogue!','%s has hired a rogue!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69137,'%s has hired a shaman!','%s has hired a shaman!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69138,'%s has fueled a portal from Domination Point to Sparkrocket Outpost!','%s has fueled a portal from Domination Point to Sparkrocket Outpost!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69139,'Hmm, perhaps there is something...$b$bWe were just about to dine when you delivered the king\'s command. I imagine a little sustenance might provide some extra energy.$b$bAlso, come to think of it, we could use a little more wood for our spikes. Perhaps you could collect some?$b$bThen... well there\'s... oh, nevermind.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69140,'%s has fueled a portal to the Shrine of Two Moons!','%s has fueled a portal to the Shrine of Two Moons!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69141,'%s has fueled a portal to Orgrimmar!','%s has fueled a portal to Orgrimmar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69142,'%s has purchased a banquet!','%s has purchased a banquet!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69143,'Time is running out! Tell me!','Time is running out! Tell me!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(69144,'%s has hired guards to protect the graveyard!','%s has hired guards to protect the graveyard!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69145,'%s has hired guards to protect the tower!','%s has hired guards to protect the tower!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69146,'Hire a shaman for a spell haste bonus.','Hire a shaman for a spell haste bonus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69147,'Extend our mage\'s contract.','Extend our mage\'s contract.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69148,'Extend our paladin\'s contract.','Extend our paladin\'s contract.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69149,'Extend our priest\'s contract.','Extend our priest\'s contract.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69150,'Extend our druid\'s contract.','Extend our druid\'s contract.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69151,'Extend our warrior\'s contract.','Extend our warrior\'s contract.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69152,'Extend our rogue\'s contract.','Extend our rogue\'s contract.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69153,'Extend our shaman\'s contract.','Extend our shaman\'s contract.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69154,'Oh, alright. If you insist.$b$bYou see, $r, legends tell of an ancient mogu artifact in this region - a richly ornamented sceptre. It is said that the one who wields this treasure will have the love and devotion of those who serve him. That or fear and respect, I forget which.$b$bEither way, it couldn\'t hurt. Hmm?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69155,'I\'ve found your precious sceptre. Hurry, take it!','I\'ve found your precious sceptre. Hurry, take it!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(69156,'We can maintain a two-way portal to Sparkrocket Outpost, as well as one-way portals to the Orgrimmar and the Shrine of Two Moons.$b$bWhat kind of mercenary would you like to fuel?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69157,'The portal to Sparkrocket Outpost.','The portal to Sparkrocket Outpost.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69158,'The portal to Orgrimmar.','The portal to Orgrimmar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69159,'The portal to the Shrine of Two Moons.','The portal to the Shrine of Two Moons.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69161,'Who dares disturb the Korune? You shall pay for your insolence!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69162,'I would love to walk on the water.','I would love to walk on the water.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(69163,'The statue appears to be of an ancient Mogu emperor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69164,'It seems as though this cave used to contain powerful Mogu magic.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69165,'','Look at you! HAH!',0,0,0,0,0,0,11,0,1,0,0,0,26124),
(69166,'','Ah... you\'re smarter than you appear, I see.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(69167,'[PH] This is da place, mon. Look around, tell me what chu find...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69168,'[PH] Ohh... this be black magic, mon... this kind of abuse... tis not da way of the Horde. Let\'s leave, quickly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69169,'[PH] *weakly* Hurry, flee from here. Tell da Warchief that ol\' Vol\'jin is... dead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69170,'[PH] It looks like we\'ve found the source!  Look around and see if you can find what we came here for.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69171,'[PH] Garrosh told us you couldn\'t be trusted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69172,'Don\'t.... move...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69173,'Don\'t look up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69174,'[PH] You may have slain my men, but you won\'t stop me, old troll!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69175,'%s stabs Vol\'jin in the neck.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69176,'[PH] We can\'t abuse this power.  A Horde dat would use this isn\'t da Horde I signed up for.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69177,'','Oh! Brann, jus\' look at this claw! I have a creepin\' suspicion that these mogu are meddlin\' with some dark magic.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69178,'Hmm... according to this codex, the Korune mogu are attempting to harness the very power of the sha. This map shows us their very location! Well done, $n. You have helped us enough for today.','',0,0,0,0,0,0,0,0,1,19663,0,0,26124),
(69179,'I hear you, Hilda. Mogu mixin\' up with sha? I don\'t like that one bit! We\'d better bring this evidence back to the King. $n, thanks fer yer help today, but we\'ll take it from here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69180,'Pandaria. Land of opportunity. Time to get rich or get bent.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69181,'Well, well, well. $p. I figured I best not be here in person. Don\'t want to give your ambition any ideas.','',0,0,0,0,0,0,0,40,1,0,0,0,26124),
(69183,'We\'re here on a research and excavation mission. No gettin\' into trouble, I promise!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69184,'Can you believe those Reliquary blood elves beat us here? We can\'t let them go on excavatin\' our artifacts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69185,'','The mogu are an ancient civilization spanning back thousands of years. Perhaps we can learn somethin\' from \'em!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69186,'','Oh, are ye one o\' Brann\'s friends? Betcha didn\'t know that back in archaeology school, he used to copy MY notes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69187,'','There are many o\' us in the Explorer\'s League who stay in the library, cataloguing and analyzing all of our findings.$B$BI spent the last five years doin\' just that while Brann went out into the world, caperin\' from one inneresting site to another.$B$BWell Hilda\'s finally back in the field, and it\'s about time I find somethin\' BIG!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69188,'','Any report from Lion\'s Landing, $c?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69189,'','I didn\'t think this mission would amount to much, but the blood elves\' presence has us all on high alert.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69190,'','I\'ve never been fascinated by ancient artifacts, but this mission has proven more dangerous than I thought.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69191,'','I have a bad feeling about the mogu\'s presence.$B$BThere can only be one reason why they\'re excavating these mogu artifacts, and it\'s not for knowledge.$B$BThey\'re looking for clues to the mogu\'s power.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69192,'','Back at the barracks, I heard murmurings of this \"sha.\"$B$BYou should have heard the crazy stories - sha possessing our strongest troops? Simply tales to scare children.$B$BThe sha are nothing that I and my sisters cannot handle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69193,'So far, so quiet. We\'re lying low around those blood elves.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69194,'I scouted the ruins. The blood elves are here in full force.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69195,'I have fought by Sarannha\'s side for as long as I can remember. She is fierce in battle, and I watch her back.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69196,'What?','',0,0,0,0,0,0,0,0,1,0,6189,0,26124),
(69197,'[PH] It looks like you all could use some help getting through this cave.  I\'ve been working on some modifications to my boat here...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69198,'A little help over here! Somethin\' is wrapped around the propeller!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69199,'You must be purged from this land.','You must be purged from this land.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(69200,'Your Alliance is not welcome here.','Your Alliance is not welcome here.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(69201,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(69202,'You will be crushed!','You will be crushed!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(69203,'Pandaria is ours!','Pandaria is ours!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(69204,'','Get... off... my... SHIP!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(69205,'','I will NOT have Horde on my ship!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(69206,'','The Defiant is mine! Stand down or die!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(69207,'[PH] Dis cave be lookin dangerous. You three split up, one of you man dis cannon here and de rest of you split up in de caves.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69208,'At last! An up close fight!','',0,0,0,0,0,0,0,39,1,0,0,0,26124),
(69209,'Face your death!','',0,0,0,0,0,0,0,39,1,0,0,0,26124),
(69210,'You think you know savagry?!','',0,0,0,0,0,0,0,39,1,0,0,0,26124),
(69211,'Die, Alliance scum!','Die, Alliance scum!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69212,'You will not interfere with our research!','You will not interfere with our research!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69213,'I will end you swiftly, $r!','I will end you swiftly, $r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69214,'[PH] Use dese to heal yourself, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69215,'[PH] Use dis to heal yourself, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69217,'','Not bad, $c. Our work here is finished for today, but stay sharp. I wouldn\'t be surprised if your next orders came from Lion\'s Landing in a few days\' time.',0,0,0,0,0,0,0,0,1,19661,0,0,26124),
(69218,'','Good work, $c. These blood elves are actively researching the mogu. It\'s clear that Garrosh is searching for artifacts of power, but we won\'t let him succeed.',0,0,0,0,0,0,0,0,1,19662,0,0,26124),
(69219,'Hmm... according to this codex, the Korune mogu are attempting to harness the very power of the sha. And now we know exactly where they are doing so. Well done, $n.','',0,0,0,0,0,0,0,0,1,19664,0,0,26124),
(69220,'It is clear to me that these mogu deserve more investigation. Our work here is done for today, $n. If we have need of you, we will contact you at Domination Point.','',0,0,0,0,0,0,0,0,1,19663,0,0,26124),
(69221,'Thank you for your assistance, $n. You have helped me enough for today. I shall seek you at Domination Point if I have further need of you.','',0,0,0,0,0,0,0,0,1,19663,0,0,26124),
(69222,'Thank you for your assistance, $n. As the leader of the blood elves, it is my duty to protect my people. It is not a responsibility to be taken lightly.','',0,0,0,0,0,0,0,0,1,19665,0,0,26124),
(69223,'','$p, report for duty immediately!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69224,'GG, Alliance wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69225,'GG, Horde wins!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69228,'Just look at this place, Malkorok. THIS is the prosperity that our people deserve!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69229,'Tell me again the names of those who built this kingdom.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69230,'Indeed? It appears I have much to learn from these \"mogu.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69231,'The mogu, Warchief. In the tome of pandaren history, they are written as cruel, relentless leaders. They were feared, not loved.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69232,'What is it, $c?','',0,0,0,0,0,0,0,0,1,19672,0,0,26124),
(69234,'This place is to warm and sticky and smells of bad fortune.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69235,'The Mercurial Guardian comes to life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69236,'W-What\'s happening? It\'s coming alive!','W-What\'s happening? It\'s coming alive!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69237,'We got work to do, $c. This forest isn\'t going to chop itself down!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(69238,'Deforestation is such a nasty word. I prefer to think of it as clearing the view!$b$bHow could anyone see the ocean through all those trees?!','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(69239,'I\'m thinkin\' of opening a lumber depot here.$b$bAll these trees just sittin\' around waiting to get chopped down. I would be a fool to pass up this opportunity!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(69240,'Don\'t worry about the trees. It\'s the circle of life! They grow, we chop \'em down, and then we use \'em to build things!$b$bI guess that\'s less of a circle, and more of a line...','',1,1,273,0,0,0,0,0,1,0,0,0,26124),
(69242,'My first field test of this technology went better than expected!  Take this with you, it should be useful against any more swarms you run into.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69243,'The nice thing about trees is they always grow back. This is what you would call sustained income!','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(69244,'','They break it and I fix it! It\'s a very symbiotic relationship.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(69245,'','My theory is there isn\'t anything that can\'t be fixed with fire!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(69246,'','Can\'t you see I\'m busy over here!',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(69247,'','We all have a job to do, $c. Just, some do it better than others!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(69248,'','This rig is a fine piece of machinary. I\'ve actually formed quite the bond with it. I even nicknamed it Bruce!$b$bIt just doesn\'t work right all the time, it\'s a little leaky, and it\'s probably a hazard to anyone within 10 miles of it.',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(69249,'','These bots are what I will go down in history for inventing.$b$bSure there are a few side effects, but this is at least a better sollution than how we used to handle spiders.$b$bAfter awhile burning down your home just doesn\'t seem practical!',1,1,1,0,0,0,0,0,1,0,0,0,26124),
(69250,'','Shredders used to be so simple to work on. They have this new operating system now though. Darn thing crashes every five minutes!',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(69251,'','It aint easy bein\' this classy, but someone\'s gotta do it!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(69252,'','I should start chargin\' people to be in my presence.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(69253,'','Not just anyone can be the boss ya know! It takes skill, brains, and of course looks!',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(69254,'','People are always accusin\' me of using my family connections to get promoted. I choose to see it as using my resources wisely.$b$bBesides, what else would I use my family for?',1,1,6,0,0,0,0,0,1,0,0,0,26124),
(69255,'You have some spare commissions you\'d like to spend? I\'ll take them off your hands.$b$bWhat would you like to buy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69256,'A swarm of Mantid appear from nearby and attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69257,'You should consider yourself lucky to be doin\' the Boss-Lady\'s chores!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69258,'','What can I do for ya, $g handsome:missie;?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(69259,'We must let no Horde escape this place. Any ideas?','We must let no Horde escape this place. Any ideas?',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(69260,'The Mercurial Guardian\'s skin becomes as hard as silver!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69261,'','Oh, we know just the thing....',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(69262,'','Squad! Initiate Operation: Cackleberry!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69263,'Enough! Time to meet your end, invaders!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(69264,'If I am correct, $n, then this... Divine Bell... is exactly the type of weapon that Garrosh is looking for. Return to your other duties for now. I will bring this information to the Warchief myself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69265,'','Seems we\'re a little low on oil. Just keep your eyes peeled for snakes and we should be fine.',0,0,0,0,0,0,1,0,1,19692,0,0,26124),
(69266,'','The crew\'s lookin\' a touch low on fuel. There anything safe to eat in these parts?',0,0,0,0,0,0,1,0,1,19692,0,0,26124),
(69267,'','Things would go faster with more iron... maybe there are some deposits around here.',0,0,0,0,0,0,1,0,1,19692,0,0,26124),
(69268,'','I documented some special schematics in my journal, but it\'s gone missin\'. We\'ll just hafta make do.',0,0,0,0,0,0,1,0,1,19692,0,0,26124),
(69269,'','Come on, you lollygaggers! Let\'s pick up the pace!',0,0,0,0,0,0,1,0,1,19692,0,0,26124),
(69270,'','If pappy could see me now... runnin\' my own crew in service to the king. He\'d be gushin\' with pride.',0,0,0,0,0,0,1,0,1,19692,0,0,26124),
(69271,'%s has conjured a portal from Lion\'s Landing to the Skyfire!','%s has conjured a portal from Lion\'s Landing to the Skyfire!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69272,'%s has conjured a portal to the Shrine of Seven Stars!','%s has conjured a portal to the Shrine of Seven Stars!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69273,'%s has conjured a portal to Stormwind!','%s has conjured a portal to Stormwind!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69274,'... what do you want?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69275,'What can you tell me about this tome?','What can you tell me about this tome?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69276,'Hmm... I recall seeing such script on the Nathrezim homeworld. I cannot read it and I doubt any of your kind could either.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69277,'','Hello Master... what kind of service can I provide you today... ?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69278,'','What? You just want me to look at some dirty old tome? Ugh, how disappointing. $B$BThis is the script of the Nathrezim, what you call Dreadlords. They rarely use it outside of their home.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69279,'','What do YOU want, you miserable excuse for a $r?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69280,'','No. I won\'t help your kind read an ancient Nathrezim text. Now, release me!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69281,'... yeah? Sup, boss?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69282,'Hmm... I have no idea.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69283,'Dismiss me... I wish to return to the void.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69284,'Words are not the way of the void. I do not know... it appears to connect two... stars together...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69285,'You wish to speak with me...? Unusual...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69286,'I cannot read the words... but the magic points to a world that exists no longer. It was destroyed by the Legion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69287,'It looks at you blankly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69288,'The felhunter just tilts its head and stares at you strangely.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69289,'Ah, $gMaster:Mistress; $n, how might I be of assistance?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69290,'Of course! This codex is written in the ancient Nathrezim tongue. Nathrezim, or the Dreadlords, as you call them, were once an enlightened and powerful race. Their skill in summoning and gateway magics was unsurpassed by any in the Great Dark Beyond. $B$BThis particular tome contains instructions to open a gateway to another world. Sadly, I fear that world no longer exists. It was destroyed as a show of power during the enslavement of Xoroth.$B$BThe tome is useless, I\'m afraid. No $r $c could open such a gateway alone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69291,'I had no idea you were so well-informed.','I had no idea you were so well-informed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69292,'It is the way of the Observer to bear witness to all things that come to pass. So many delicious magics have I tasted at your side, $gmaster:mistress;.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69293,'Fascinating...','Fascinating...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69294,'Goob help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69295,'','\'Sweet child\', pappy\'d always call me. Well, what we\'re plannin\' for these Horde vermin ain\'t so sweet!',0,0,0,0,0,0,1,0,1,19692,0,0,26124),
(69296,'Don\'t need Goob\'s help?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69297,'Ok. Goob go back to Zino.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69298,'Goob and friend did good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69299,'My life for the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69300,'We\'ll never finish in time! Can\'t we make them go faster?','We\'ll never finish in time! Can\'t we make them go faster?',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(69301,'[PH] De Saurok been created by da Mogu?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69302,'','I was startin\' to think you\'d never ask!$b$bWe\'ll get \'er done eventually, but there\'s plenty you can do to help.$b$bWe gnomes have a high metabolism - and it only gets higher when we\'re hard at work. Food will always be welcome.$b$bThen there\'s oil. These traps are tricky enough without having to worry about gears jamming. Bring us any oil ya find out there.$b$bOutside\'a that, just keep us safe!$b$b<Rosey looks aways for a moment, then whispers.>$b$bTh-there might be one other thing...',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69303,'[PH] Get them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69304,'Well? What is it?','Well? What is it?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(69305,'[PH] Get into da big bad voodoo zones mon\'! It\'ll shield you from his powa!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(69306,'','<Rosey fights back tears as she speaks.>$b$bMy... my journal. It\'s gone missin\'.$b$bIt\'s mostly full of memories of my pappy, and his endless search for the perfect place to build his paradise city. It was to be the pinnacle of gnomish engineering!$b$bAnyway, one of his old schematics might actually be useful here. Please let me know if ya find it somewhere in all this thick green grass.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69307,'Is this your journal, Rosey?','Is this your journal, Rosey?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(69308,'[PH] Are they gone?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69309,'','What? Ya found it! Wahoo! I\'ll get right to work!',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(69310,'','Well whaddya know? It worked!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(69311,'Gnome Construction Site Under Attack!','Gnome Construction Site Under Attack!',0,0,0,0,0,0,30,0,1,0,34768,34768,26124),
(69312,'That doesn\'t sound good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69313,'Ah! I forgot to reverse the bipolar collaboration inverter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69314,'|TInterface\\Icons\\inv_misc_bomb_01.blp:20|tYou are the target of |cFFFF0000|Hspell:133925|h[Bombs]|h|r! Run!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69315,'Interpreting program \"Hello World\". Line 1: Blow up in enemy\'s face.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69316,'Error: Attempt to write to protected memory. Resolution: Move at enemy and self-destruct.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69317,'Null Pointer Exception. Self-destruct protocol initiated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69318,'Error: Divide by zero. Resolution: SELF DESTRUCT INITIATED.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69319,'Hash table collision detected. Resolution: SELF-DESTRUCT.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69320,'Oh! Orders! Let\'s see here... Self Destruct?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69321,'Hmm, looks like I\'ve been programmed to... <sigh> Self-Destruct.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69322,'Oh boy! A new program! Let\'s see here... BLOW MYSELF UP?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69323,'Alright, let\'s check the ol\' programming... SELF DESTRUCT?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69324,'Well, it was nice knowing you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69325,'Uh... later!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69326,'I wonder what exploding feels like?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69327,'And... I\'m OUTTA HERE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69328,'Self Destructing is SO COOL.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69329,'What? Here? Now? We\'re in a battle!$b$bAs much as I love your enthusiasm to learn the wonders of Gnomish Engineering this really is a conversation best saved for when we are back under the protection of Tinkertown\'s walls in Ironforge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69330,'Very well. I wish to talk about something else.','Very well. I wish to talk about something else.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69331,'Free! Free at last after ten thousand years! This a happy day! Very happy happy day! Gonna need biggest party ever! With nibs! And dibs! And brews! And jungle hozen! And mountain hozen! And sky hozen!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69332,'No! Stay... away!','No! Stay... away!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69333,'D-don\'t come any closer!','D-don\'t come any closer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69334,'I don\'t feel so good...','I don\'t feel so good...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69335,'Unngh... my head... it hurts!','Unngh... my head... it hurts!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69336,'W-what happened? I couldn\'t control my own body.','W-what happened? I couldn\'t control my own body.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69337,'I dreamt that I turned into a monster. Good thing you woke me.','I dreamt that I turned into a monster. Good thing you woke me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69338,'Thank you for saving me from that nightmare. I wanted to rip everything apart!','Thank you for saving me from that nightmare. I wanted to rip everything apart!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69339,'I don\'t know what came over me. Thank you for clearing my head.','I don\'t know what came over me. Thank you for clearing my head.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69340,'Thank you for saving me, soldier. You too, young prince.','Thank you for saving me, soldier. You too, young prince.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69341,'I fought against the anger, but it overwhelmed me. You have my thanks.','I fought against the anger, but it overwhelmed me. You have my thanks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69342,'Goremaw has arrived!','Goremaw has arrived!',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(69343,'Researcher Morian has arrived!','Researcher Morian has arrived!',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(69344,'|TInterface\\Icons\\inv_sword_2h_mantid_01.blp:20|t%s equips his |cFFFF0000Sword|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69345,'|TInterface\\Icons\\inv_misc_bomb_01.blp:20|t%s equips his |cFFFF0000Bombs|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69346,'|TInterface\\Icons\\inv_knife_1h_mantid_02.blp:20|t%s equips his |cFFFF0000Daggers|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69347,'','Can\'t you see I\'m busy?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69348,'We have... more important matters to attend to than you. Go away, scum.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69349,'Be ready for anything, $n. We may have to use force against our own men.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69350,'We struck liquid gold with this place, $c! All we had to do was tear down some useless trees and clear out some pesky animals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69351,'... I\'ve seen the fear in your eyes, Jubeka.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69352,'','What is it you wished to show me...?',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69353,'Gul\'dan destroyed this world in his bid for power... you\'re concerned I will do the same to Azeroth.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69354,'','What...? No! I.. I have... no idea...',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69355,'','No! Stay back...! You... you\'re dangerous. I remain content summoning demons, but you...',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69356,'','...you toy with becoming one yourself!',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69357,'...','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69358,'There are two sides to the blade of demonology...','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69359,'... the threats that besiege us from the outside...','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69360,'... and those that threaten us from within.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69361,'I chose you as my companion for a reason.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69362,'... If I fail, I need you to banish me forever.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69363,'','And what depraved reason is that...?',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69364,'I tire of your evasive babble, doomguard. Explain to me why you and your kind are drawn to sacrificial magics.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69365,'My contract is to fight for you, not to reveal the Legion\'s secrets, mortal.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69366,'Do not attempt to deceive me, demon!','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69367,'Your kind far predates Sargeras\'s betrayal. What WERE you?','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69368,'','This knowledge is useless... what are you trying to achieve, Kanrethad?',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69369,'STAY OUT OF THIS! The demon will answer, NOW!','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69370,'What an odd demand. Not even my own kind care about our origins. Why should you?','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69371,'If you do not care then there is no harm telling me.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69372,'... before Sargeras freed us, we were the Titan\'s hounds. Forever enslaved to police the use of arcane magics.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69373,'Sacrificial magic was considered the greatest violation of life and we were attuned to instantly punish those who delved into such... delicious sorcery.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69374,'You have your petty secret, Kanrethad. Now, I demand knowledge from you... why do you care?','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69375,'I don\'t believe that is part of our contract. We are done here.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69376,'Jubeka, complete the ritual.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69377,'Orders, your majesty?','Orders, your majesty?',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(69378,'Good to see you again, $n.$b$bTake the laborers from camp here, and any others you can find in the region. Assist them in building defenses to ensure no Horde can escape our vengeance.$b$bOne more thing. These troops are not trained for battle and must be protected from harm if they are to succeed.$b$bNow go, and be quick about it. Time is running out!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69379,'','Such strange creatures. Why do they remain so long after the Legion has left?',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69380,'...there\'s a slight flaw in that supposition.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69381,'The observers were in the service of Illidan... not the Legion.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69382,'','Oh?',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69383,'','Well, he\'s gone too... so why are they still around?',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69384,'How should I know?','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69385,'','Well, I\'ve spent weeks trying to understand how to summon one of these things. If you know something I don\'t, I\'d appreciate it if you\'d share it with us \"lesser\" mortals.',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69386,'What\'s the problem? You handled the binding of the fel imps and voidlords effortlessly.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69387,'','They were trivial by comparison! These things are never in the same place.',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69388,'','There\'s something... strange about them... something out of place...',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69389,'','Oh dear...',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69390,'More elves to slaughter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69391,'My life for the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69392,'Heads up, boys. More tin-men comin\' our way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69393,'There\'s oil here alright, and we\'re gonna need it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69394,'Aggra, I should not be long. The Darkspear are a strong people and I doubt they have much need of my assistance.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(69396,'Very well my beloved. Come friend, let us ride to the home of the Darkspear.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(69397,'Aye, $g lad:lass;. What can we be doin\' fer yeh?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(69398,'Lead on, friend. It\'s time to set up your defenses!','Lead on, friend. It\'s time to set up your defenses!',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(69399,'Mount up, lads! Time ta go an\' earn our ale.','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69400,'A pitiful skirmish! The Alliance fights without conviction.','',0,0,0,0,0,0,153,0,1,0,34239,0,26124),
(69401,'Hold this ground, Blood Guard. Here is where we will build our keep. Expect peons within the hour, and be ready to motivate them.','',0,0,0,0,0,0,396,0,1,0,34240,0,26124),
(69402,'I didn\'t come to save your sorry hide, goblin. Did you find fuel or not?','',0,0,0,0,0,0,0,0,1,0,34237,0,26124),
(69403,'Kor\'kron? Here? What has Garrosh been up to?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(69404,'Have I been away so long that you have forgotten who I am?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(69405,'I know you will. I\'m sending in grunts to make sure of it.','',0,0,0,0,0,0,0,0,1,0,34238,0,26124),
(69406,'I never thought the Warchief himself would come to bail me out!','',0,0,0,0,0,0,1,0,1,0,34354,0,26124),
(69407,'Y-yes sir! We struck it big. There\'s crude all along the coast. We\'ll get an operation going right away, your hugeness!','',0,0,0,0,0,0,430,0,1,0,34355,0,26124),
(69408,'These are our Allies! You watch over them like they\'re a threat. Why? You WILL answer to me!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(69409,'And, we\'re off!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69410,'<Vol\'jin lays on the floor unconscious and barely breathing.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69411,'We\'ll have to tread carefully with all this teleporting in and out. We CANNOT risk Jaina finding out about this.$b$bAre you ready to go in?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69412,'Yes.','Yes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69413,'Stay away from the guards! This spell should shield you from the night elves\' vision, but you\'ll still need to keep your distance.  If you get into trouble, return to safety here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69414,'Back so soon?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69415,'Be careful, $n. We can\'t risk being caught.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69416,'Keep your distance from the Alliance, $n. We can\'t have you getting captured this deep in enemy territory.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69417,'If you keep teleporting all over the place, Jaina will catch onto us. Please, be more careful next time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69418,'The Divine Bell! I knew I could count on you, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69419,'','What was that noise?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69420,'','Is somebody out there?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69421,'','Show yourself!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69422,'','Hmm? What was that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69423,'Vol\'jin was a friend of mine, once upon a time. It has been many years since our paths crossed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69424,'What happened to Vol\'jin?','What happened to Vol\'jin?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69425,'Vol\'jin\'s body was found in a well a few days ago.$b$bA poison flows through his veins that is halting his regeneration. This was designed to kill a troll.$b$bIf I had to guess, I would say this wound was made by an assassin\'s hand. And one who is not from Pandaria.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69426,'Halt! This city is under Martial Law. Declare yourselves.','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(69427,'Here! Stop the boats here.','',0,0,0,0,0,0,0,0,1,0,34241,0,26124),
(69428,'This island will make a perfect coastal stronghold. Rokla! When the peons arrive, clear these trees and begin construction of the docks.','',0,0,0,0,0,0,1,0,1,0,34242,0,26124),
(69429,'Champion, you have been here for many weeks, and know this land well. Come with me.','',0,0,0,0,0,0,25,0,1,0,34243,0,26124),
(69430,'%s calls for the help of a nearby guard!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69431,'What did you see, brother?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69432,'Your kind are not welcome here, warlock.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69433,'This temple is the domain of the Ashtongue Brotherhood. I must ask you to leave - now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69434,'Another warlock? After what happened last time, you should be glad we don\'t kill you on sight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69435,'Dwarf Construction Site Under Attack!','Dwarf Construction Site Under Attack!',0,0,0,0,0,0,30,0,1,0,34768,34768,26124),
(69436,'Champion, may I have a word with you? In private... ?','',0,0,0,0,0,0,0,0,5,0,34261,0,26124),
(69437,'You are a hero of the Horde. Your deeds in Northrend and during the Cataclysm are the stuff of legend. For this reason, I trust in your discretion.','',0,0,0,0,0,0,0,0,5,0,34262,0,26124),
(69438,'I am a ranger, not a politician. But like it or not, the mantle of leadership has fallen on my shoulders.','',0,0,0,0,0,0,0,0,5,0,34263,0,26124),
(69439,'My people, who have suffered through so many challenges and betrayals, look to me to secure their future.','',0,0,0,0,0,0,0,0,5,0,34264,0,26124),
(69440,'We Sin\'dorei were driven to the Horde by the bigotry and distrust of the Alliance.','',0,0,0,0,0,0,0,0,5,0,34265,0,26124),
(69441,'Now, I look at our Warchief, and I begin to see the very same racism. He is willing to throw away our lives for his agenda.','',0,0,0,0,0,0,0,0,5,0,34266,0,26124),
(69442,'Know this: I won\'t stand idle if the Horde interests conflict with those of my people. I may reconsider old Alliances.','',0,0,0,0,0,0,0,0,5,0,34267,0,26124),
(69443,'Keep your eyes open, champion. We are all in this together... for now.','',0,0,0,0,0,0,0,0,5,0,34268,0,26124),
(69444,'My father isn\'t asking you to pledge the Kirin-Tor to the Alliance-','',0,0,0,0,0,0,0,0,7,0,34179,0,26124),
(69445,'','Anduin, I know exactly what he\'s asking. Oh - look who\'s arrived.',0,0,0,0,0,0,0,0,7,0,0,34310,26124),
(69446,'','Nobody dislikes Garrosh more than me. I wrestle with my anger every day.',0,0,0,0,0,0,0,0,7,0,0,34311,26124),
(69447,'','Come with me - look around you a moment.',0,0,0,0,0,0,0,0,7,0,0,34312,26124),
(69448,'','In the aftermath of Theramore, my first instinct was to decimate Orgrimmar - to kill every man woman and child in the city.',0,0,0,0,0,0,0,0,7,0,0,34313,26124),
(69449,'','I\'m not proud.  Since then, Kalecgos and I have talked at length about power, and how it should be used.',0,0,0,0,0,0,0,0,7,0,0,34314,26124),
(69450,'...Jaina!','',0,0,0,0,0,0,0,0,7,0,34180,0,26124),
(69451,'','The Kirin-Tor has a legacy of abuse. Kel\'thuzad turned his knowledge of the arcane arts toward Necromancy.',0,0,0,0,0,0,0,0,7,0,0,34315,26124),
(69452,'','Kael\'thas Sunstrider was also a student here, another of our fold who betrayed us.',0,0,0,0,0,0,0,0,7,0,0,34316,26124),
(69453,'','Anduin, you know more than anyone, it\'s important to separate the Horde from its people.',0,0,0,0,0,0,0,0,7,0,0,34318,26124),
(69454,'','Every day I ask myself: \"What\'s the right thing to do?\"',0,0,0,0,0,0,0,0,7,0,0,34317,26124),
(69455,'','The Sunreavers still operate within this city. Alliance and Horde work together.',0,0,0,0,0,0,0,0,7,0,0,34319,26124),
(69456,'','As long as we stay above the war, then there\'s hope for the world as a whole.',0,0,0,0,0,0,0,0,7,0,0,34320,26124),
(69457,'','I see our city as a beacon of light, showing the way.',0,0,0,0,0,0,0,0,7,0,0,34321,26124),
(69458,'','If we can trust one another here, then there\'s hope for the rest of the world.',0,0,0,0,0,0,0,0,7,0,0,34322,26124),
(69459,'','I see our city as a beacon of light, showing the way.',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(69460,'','If we can trust one another here, then there\'s hope for the rest of the world.',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(69461,'','Thank you, Anduin.',0,0,0,0,0,0,0,0,7,0,0,34323,26124),
(69462,'I understand. I\'ll talk to my father.','',0,0,0,0,0,0,0,0,7,0,34181,0,26124),
(69463,'%s senses its destiny!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69464,'%s clatters and whirrs happily.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69465,'%s clunks gleefully onto the ground.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69466,'%s marvels at its surroundings in robotic awe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69467,'%s clanks lustily.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69468,'%s has purchased a box of banners!','%s has purchased a box of banners!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69469,'%s has purchased a Rodent Crate!','%s has purchased a Rodent Crate!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69470,'%s has purchased an Obelisk of Deception!','%s has purchased an Obelisk of Deception!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69471,'%s has purchased a Mind Vision Altar!','%s has purchased a Mind Vision Altar!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69472,'%s has purchased a box of Overridden Excavationbots!','%s has purchased a box of Overridden Excavationbots!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69473,'','You\'re late, $n.\n\nLet\'s get right to the point. Our latest recon shows the last of Shek\'zeer\'s forces are holed up at the heart of the island. They\'re protecting a large weapons cache that Garrosh has ordered us to retrieve. Problem is they\'ve activated the island\'s defenses, a massive impenetrable shield that enshrouds all of Zan\'vess.\n\nThis is where you come in. I need you to take one of these gunships and shoot down the shield generators. As long as they\'re active none of our forces can reach the weapons cache.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69474,'Well done, hero! I yield to your might.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69475,'Enjoy this well earned brew. The recipe has been in my family for over ten thousand years. Once enjoyed by the Monkey King himself, they say.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69476,'Help! I am being attacked!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69477,'We\'ve got our work cut out for us, $p.','We\'ve got our work cut out for us, $p.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69478,'Shield generators all over the island are protecting the Heart of Zan\'vess, preventing us from reaching the weapons cache.','Shield generators all over the island are protecting the Heart of Zan\'vess, preventing us from reaching the weapons cache.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69479,'If we don\'t get this shield down soon we\'re going to be overrun.','If we don\'t get this shield down soon we\'re going to be overrun.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69480,'Admiral they\'ve activated some sort of force field, the control towers all over the island just lit up.','Admiral they\'ve activated some sort of force field, the control towers all over the island just lit up',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69481,'Curse these mantid! All remaining air units, get to those towers and take them out!','Curse these mantid! All remaining air units, get to those towers and take them out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69482,'We\'re going in! Take out those towers!','We\'re going in! Take out those towers!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69483,'Aim for those amber bombs, they\'ll cause a huge explosion if we manage to set one off!','Aim for those amber bombs, they\'ll cause a huge explosion if we manage to set one off!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69484,'Good shot, $p! Keep aiming for those bombs.','Good shot, $p! Keep aiming for those bombs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69485,'Nice work! The shield looks like it\'s weakening.','Nice work! The shield looks like it\'s weakening.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69486,'Those Mantid are protecting the towers, $p. Take them out or we won\'t be able to land any shots.','Those Mantid are protecting the towers, $p. Take them out or we won\'t be able to land any shots.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69487,'Foolish warlocks. I knew you would try again to ransack our temple...!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69488,'Wait... you\'re not one of the warlocks that snuck in here before. Why then are you here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69489,'Hmm... your name sounds familiar to me, $n. $B$BWhat do you want from the Black Temple? Stay a moment and speak with me, rather than skulk about like a rogue.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69490,'Warchief Garrosh seeks the Black Harvest members who trespassed here recently.','Warchief Garrosh seeks the Black Harvest members who trespassed here recently.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69491,'King Wrynn seeks the Black Harvest council members who trespassed here recently.','King Wrynn seeks the Black Harvest council members who trespassed here recently.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69492,'The Alliance did much to aid my people in freeing the Black Temple of Illidan\'s grasp.$B$BI will help you as a show of mutual trust.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69493,'$n, you and your Alliance did much to aid my people in freeing the Black Temple of Illidan\'s grasp. $B$BI will help you as a show of mutual trust and repayment of the debt I owe you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69494,'Show me where they went.','Show me where they went.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69495,'Akama, lead the way!','Akama, lead the way!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69496,'The Horde did much to aid my people in freeing the Black Temple of Illidan\'s grasp. $B$BI will help you as a show of mutual trust.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69497,'$n, you and your Horde  did much to aid my people in freeing the Black Temple of Illidan\'s grasp. $B$BI will help you as a show of mutual trust and repayment of the debt I owe you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69498,'It has been many months since those two warlocks broke into the temple... but I\'m still not sure what they were after.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69499,'Follow me. They visited both the Shrine of Lost Souls and the Temple Summit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69500,'I have decided to trust this warlock for now. Let $ghim:her; move about the temple freely.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69501,'It will take many years for us to undo the damage that Magtheridon, Illidan and the fel orcs did to this holy place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69502,'Within lies the Shrine of Lost Souls. The souls of thousands of my fallen brethren remain within this area.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69503,'Use caution, there are many traps still active within. Perhaps one of your demon spells will grant you the ability to scout ahead before advancing forward.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69504,'For years it has languished, slowly growing in strength...','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69505,'','This... is amazing... an untapped store of raw arcane energy.',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69506,'','Imagine what we could summon with just a fraction of this power!',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69507,'Summon... ha, imagine what we could become if fused with power of this magnitude...','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69508,'The powers of this room are not unlike the original Well of Eternity in Azeroth.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69509,'','So this is how Illidan bound so many demons to his will...',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69510,'Yes. The payment for the demons\' service was to drink from the energy of this place.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69511,'By feeding upon this place\'s power, they were broken free from their addiction to the Legion\'s magic.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69512,'I believe this is the original power source he intended to offer the blood elves to free them from their addiction to the Sunwell... but for some reason he didn\'t let them near it...','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69513,'','What?? You have no proof of such a claim.',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69514,'Didn\'t you notice? The demons under Illidan\'s command were free of the entropic, fel-green corruption that pervades the Legion.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69515,'','... why do you talk so much, Kanrethad?',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69516,'I was there... at the end...','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69519,'','... oh dear, are you going to regale me with yet another of your horrible stories?',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69520,'... shut up.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69521,'','...',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69522,'I think I liked you better when your jaw was missing.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69523,'','Did you hear that?! Those Ashtongue dogs are coming. Let\'s hurry up and start the ritual!',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69524,'Very well. We\'ll return later after the crystal is fully charged.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(69525,'According to my research, the pandaren long ago made a special mallet that was intended for the Divine Bell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69526,'When using the mallet on the Divine Bell, the pandaren monks were able to create pure harmony.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69527,'But then the Monkey King one day decided to steal the mallet and hide it as a prank. There is no record of the mallet after that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69528,'What I did find, however, was the final resting place of the infamous \"Monkey King.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69529,'The powers of this place are NOT for your kind, warlock!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69530,'The tricky part is, he was frozen in jade while dueling a mogu that history names \"The Jade Warlord.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69531,'DIE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69532,'I found an incantation to release these two from their prison. But it will release both of them. Once I cast this, defeat the Jade Warlord before he can get his bearings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69533,'Garrosh is going to try to use the Divine Bell to wreak havoc on the land. We must find a way to stop him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69534,'Anduin, why are we here?','Anduin, why are we here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69535,'Face the souls of those your kind doomed to perish, Warlock!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69536,'','%s begins to cast |cFFFF0000|Hspell:113134|h[Mass Resurrection]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69537,'If you love demons so much... then you shall have them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69538,'$n! Some of my men are trapped in the basement - there is little time, help me save them!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69539,'Ah, so there is one who wishes to taste the might of the Metal Brew?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69540,'Be warned, this recipe has been handed down from generation to generation, tought to my family by the great Monkey King himself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69541,'It\'s flavor is intended for friends to share after a battle. Come... friend... and battle me if you dare.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69542,'Eek! Quick, strong, dangerous. You know how to stick it. I no longer afraid you just some filthy wikket.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69543,'Solve the other riddles, I am demanding! And then meet me down south at Lion\'s Landing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69544,'Looting','Looting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69547,'... yo, $n! Remember me? Good, good... hey, listen... we don\'t have to help this guy...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69548,'There\'s gotta be some riches around this place... c\'mon boss, you know you want to...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69553,'Dwarf Construction Complete!','Dwarf Construction Complete!',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(69558,'Your interference has cost me a great warrior, young prince. You\'ll pay with your life.','',0,0,0,0,0,0,0,0,7,0,34205,0,26124),
(69559,'That is where you are wrong, Garrosh.','',0,0,0,0,0,0,0,0,7,0,34174,0,26124),
(69560,'Die, whelp!!','',0,0,0,0,0,0,0,0,7,0,34206,0,26124),
(69561,'The mogu made the Divine Bell to create chaos, but the pandaren created a special mallet to turn the echoes of that chaos into perfect harmony. That mallet was hidden for thousands of years, until now.','',0,0,0,0,0,0,0,0,7,0,34175,0,26124),
(69562,'I will not let you do this, Garrosh.','',0,0,0,0,0,0,0,0,7,0,34176,0,26124),
(69563,'Your Alliance must be at its end if you\'re sending your children against me.','',0,0,0,0,0,0,0,0,1,0,34207,0,26124),
(69564,'I will let you live so that you can tell your King of the price for his continued defiance!','',0,0,0,0,0,0,0,0,1,0,34208,0,26124),
(69565,'We are the HORDE. We are slaves to nothing and no one!','',0,0,0,0,0,0,1,0,1,0,34215,0,26124),
(69566,'With the Divine Bell, I will burn away any remnants of weakness within us. Fear... despair... hatred... doubt. The lesser races are buried beneath their weight. But WE will control their power.','',0,0,0,0,0,0,1,0,1,0,34216,0,26124),
(69567,'Together, we will destroy the Alliance and claim what is rightfully ours. Let our song of victory begin.','',0,0,0,0,0,0,53,0,1,0,34217,0,26124),
(69568,'Our victory is all but assured. With the power of the bell on our side, we will be unstoppable.','',0,0,0,0,0,0,0,0,1,0,34218,0,26124),
(69569,'If our enemies should choose to push us, we will drive them into the ground!','',0,0,0,0,0,0,0,0,1,0,34219,0,26124),
(69570,'Yes! Feel the power within you. Fight your fears. Conquer your hatred!','',0,0,0,0,0,0,0,0,1,0,34220,0,26124),
(69571,'This is but a test of our strength. We will pass this trial, just as we have passed others!','',0,0,0,0,0,0,0,0,1,0,34221,0,26124),
(69572,'Stop, Garrosh! You do not know what that bell is capable of!','',0,0,0,0,0,0,5,0,1,0,34177,0,26124),
(69573,'Ahahahaha... so in the end, it is not Varian, but his whelp who comes to face me. You run bravely to your death, young one.','',0,0,0,0,0,0,11,0,1,0,34222,0,26124),
(69574,'I will not let you do this. I swear to it.','',0,0,0,0,0,0,1,0,1,0,34178,0,26124),
(69575,'Stop me then, human.','',0,0,0,0,0,0,1,0,1,0,34223,0,26124),
(69576,'Auuugh... Auuuuuugggghhhhh! This pain! I cannot control it!','',0,0,0,0,0,0,0,0,1,0,34389,0,26124),
(69577,'Fight the sha - master it! Use it!','',0,0,0,0,0,0,1,0,1,0,34209,0,26124),
(69578,'Do you speak the truth, Garrosh? Can the Horde truly survive another war?','',0,0,0,0,0,0,0,0,1,0,34390,0,26124),
(69579,'Doubt is for the weak! Do not question your strength, Ishi. We will survive because we must! The Horde will prevail!','',0,0,0,0,0,0,1,0,1,0,34210,0,26124),
(69580,'We have lost so much, Warchief. Our families, dead. Our friends, lost. Our homeland, gone. How much more must our people suffer?','',0,0,0,0,0,0,0,0,1,0,34391,0,26124),
(69581,'Our suffering is at an end. When this war is won, our people will see prosperity at last.','',0,0,0,0,0,0,1,0,1,0,34211,0,26124),
(69582,'Why should we be slaves to honor, when we could slaughter the children of our enemies while they sleep? My blade thirsts for Alliance blood!','',0,0,0,0,0,0,0,0,1,0,34392,0,26124),
(69583,'Control your hatred, Ishi. There is killing, and then there is murder. Direct your rage to our enemies.','',0,0,0,0,0,0,1,0,1,0,34212,0,26124),
(69584,'At night, I see the faces of all those I have slain. Where do our spirits go after our bodies lay cold? I fear... death.','',0,0,0,0,0,0,0,0,1,0,34393,0,26124),
(69585,'Use your fear, Ishi! Turn it on your foes. When death arrives, will you stand and face it or kneel in defeat?','',0,0,0,0,0,0,1,0,1,0,34213,0,26124),
(69586,'Warchief! I... I have failed you.','',0,0,0,0,0,0,0,0,1,0,34394,0,26124),
(69587,'Yes, Ishi. You have.','',0,0,0,0,0,0,0,0,1,0,34214,0,26124),
(69589,'There is much I do not know about this artifact. The weak-willed cannot control this sha energy, but I WILL master it.','',0,0,0,0,0,0,0,0,1,0,34224,0,26124),
(69590,'At least the human prince is dead. King Wrynn now knows the price of his continued defiance.','',0,0,0,0,0,0,0,0,1,0,34225,0,26124),
(69591,'Leave me. I have much to think about.','',0,0,0,0,0,0,0,0,1,0,34226,0,26124),
(69592,'The landing site is secure. We\'re ready for work to commence.','',0,0,0,0,0,0,396,0,1,0,34227,0,26124),
(69593,'Champion, you have earned the honor. Signal our fleet.','',0,0,0,0,0,0,397,0,1,0,34228,0,26124),
(69594,'%s has hired guards to protect the outpost!','%s has hired guards to protect the outpost!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69595,'Watch the might of the Horde in action as we turn this slab of land into DOMINATION POINT.','',0,0,0,0,0,0,396,0,1,0,34229,0,26124),
(69596,'Do you see, champion? There is little my Horde cannot accomplish. What is this?','',0,0,0,0,0,0,1,0,1,0,34230,0,26124),
(69597,'Vol\'jin. What are you doing here? Shouldn\'t you be on your island kissing frogs?','',0,0,0,0,0,0,547,0,1,0,34231,0,26124),
(69598,'Your lack of vision is why your people are still primitives, and your lack of loyalty is why I did not summon the Darkspear for this campaign.','',0,0,0,0,0,0,1,0,1,0,34232,0,26124),
(69599,'The question is, what are WE doin\' here? Yeh bring \'dis war to anudder corner of Azeroth, and I wanna know why.','',0,0,0,0,0,0,6,0,1,0,34505,0,26124),
(69600,'Look around you, Vol\'jin. This land is rich in resources: wood, stone, iron, fuel. And people.','',0,0,0,0,0,0,1,0,1,0,34233,0,26124),
(69601,'A show of might on these shores will make the pandaren think twice about joining the Alliance.','',0,0,0,0,0,0,5,0,1,0,34234,0,26124),
(69602,'All dis bloodshed make everyone tink twice \'bout joinin\' da Horde.','',0,0,0,0,0,0,274,0,1,0,34506,0,26124),
(69603,'This is the difference between me and you, Vol\'jin. I won\'t let MY people starve to death in the desert. I will stop at nothing - NOTHING - to ensure a proud and glorious future for the orcs and anyone with the courage to stand with us. Wait here.','',0,0,0,0,0,0,25,0,1,0,34235,0,26124),
(69604,'There is something you can do, troll, to demonstrate your value to the Horde. A mission in the heart of this continent.','',0,0,0,0,0,0,1,0,1,0,34236,0,26124),
(69605,'','No, no, no! The Bell!',0,0,0,0,0,0,0,0,1,0,0,34304,26124),
(69606,'','I had Darnassus LOCKED DOWN! Every fumbling rogue that tried to sneak into the city, I CAUGHT them! I snatched every two-bit charlatan that attempted to teleport through my traps!',0,0,0,0,0,0,0,0,1,0,0,34305,26124),
(69607,'','They couldn\'t possibly have gotten through... this was an inside job. Somebody inside the city has the Bell, unless... no...',0,0,0,0,0,0,0,0,1,0,0,34306,26124),
(69608,'','UNUSED',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69609,'','Come with me.',0,0,0,0,0,0,0,0,1,0,0,34307,26124),
(69610,'','These portals connect to Dalaran. That means the Kirin Tor... MY OWN Kirin Tor... helped the Horde commit this atrocity.',0,0,0,0,0,0,0,0,1,0,0,34308,26124),
(69611,'','I will NOT be betrayed again! Those responsible for this will be punished!',0,0,0,0,0,0,0,0,1,0,0,34309,26124),
(69612,'','Aethas Sunreaver!',0,0,0,0,0,0,0,0,1,0,0,34332,26124),
(69613,'','You\'ve betrayed the Kirin Tor, Sunreaver. You\'ve allowed Garrosh to move his forces through MY city.',0,0,0,0,0,0,0,0,1,0,0,34333,26124),
(69614,'','You looked the other way. You and your insubordinate kind are no longer welcome here.',0,0,0,0,0,0,0,0,1,0,0,34334,26124),
(69615,'You have it all wrong, Jaina. I did nothing.','',0,0,0,0,0,0,0,0,1,0,34172,0,26124),
(69616,'This is OUR city too, Proudmoore.','',0,0,0,0,0,0,0,0,1,0,34173,0,26124),
(69617,'','Hah! I see. I will remove the Sunreavers by force, then.',0,0,0,0,0,0,0,0,1,0,0,34335,26124),
(69618,'','You, Aethas, will be coming with me.',0,0,0,0,0,0,0,0,1,0,0,34336,26124),
(69619,'Jaina! What\'s happening in Dalaran? Has there been an attack?','',0,0,0,0,0,0,0,0,7,0,34718,0,26124),
(69620,'','The Kirin Tor was betrayed from within. I\'ve handled the situation.',0,0,0,0,0,0,0,0,7,0,0,34324,26124),
(69621,'How?','',0,0,0,0,0,0,0,0,7,0,34719,0,26124),
(69622,'','I\'ve purged the Horde from Dalaran. You have what you wanted, Your Majesty: The Kirin Tor belongs to the Alliance.',0,0,0,0,0,0,0,0,7,0,0,34325,26124),
(69623,'','I know what I said. My trust was misplaced.',0,0,0,0,0,0,0,0,7,0,0,34326,26124),
(69624,'But you said-','',0,0,0,0,0,0,0,0,7,0,34720,0,26124),
(69625,'What of the Sin\'dorei - the Sunreavers?','',0,0,0,0,0,0,0,0,7,0,34721,0,26124),
(69626,'','Those that surrendered are being taken to the Violet Hold. I make no guarantees about those who chose to fight.',0,0,0,0,0,0,0,0,7,0,0,34327,26124),
(69627,'Jaina, you need to talk to me before you act-','',0,0,0,0,0,0,0,0,7,0,34722,0,26124),
(69628,'','How I run the Kirin Tor is my business.',0,0,0,0,0,0,0,0,7,0,0,34328,26124),
(69629,'I was trying to negotiate with the Sin\'dorei. I was opening discussions to bring them into the Alliance! By attacking their people, you\'ve forced their hand-','',0,0,0,0,0,0,0,0,7,0,34723,0,26124),
(69630,'','They chose their own path.',0,0,0,0,0,0,0,0,7,0,0,34329,26124),
(69631,'You\'ve driven them back to the Horde.','',0,0,0,0,0,0,0,0,7,0,34724,0,26124),
(69632,'','You\'re fooling yourself. Once Horde, always Horde. I see that now. I\'m mobilizing the Kirin Tor.',0,0,0,0,0,0,0,0,7,0,0,34330,26124),
(69633,'Jaina. We\'ve got to work together on this. The Alliance must act as one.','',0,0,0,0,0,0,0,0,7,0,34725,0,26124),
(69634,'','Don\'t get soft on me, Varian.',0,0,0,0,0,0,0,0,7,0,0,34331,26124),
(69635,'The game has changed.','',0,0,0,0,0,0,0,0,1,0,34726,0,26124),
(69636,'Champion, please don\'t go - we need to talk!','',0,0,0,0,0,0,0,0,1,0,34182,0,26124),
(69637,'Garrosh attacked my son...? Where is he?','',0,0,0,0,0,0,0,0,5,0,34644,0,26124),
(69638,'','Anduin!',0,0,0,0,0,0,0,0,5,0,0,34295,26124),
(69639,'Anduin, what were you thinking? I should\'ve sent you back to Stormwind!','',0,0,0,0,0,0,0,0,5,0,34645,0,26124),
(69640,'He\'s alive, but his bones are shattered.','',0,0,0,0,0,0,0,0,5,0,34296,0,26124),
(69641,'Send for Velen. Bring him here at once!','',0,0,0,0,0,0,0,0,5,0,34646,0,26124),
(69642,'Aethas! You\'re alive.','',0,0,0,0,0,0,0,0,7,0,34253,0,26124),
(69643,'Thanks to this hero, a few of us made it out of there. Many more have been sent to the Violet Hold.','',0,0,0,0,0,0,0,0,7,0,34168,0,26124),
(69644,'Anar\'alash denal! Will someone tell me WHAT is going on in Dalaran?','',0,0,0,0,0,0,0,0,7,0,34254,0,26124),
(69645,'Proudmoore! She\'s gone and expelled the Sunreavers from the city. She\'s purging the Horde from the Kirin Tor!','',0,0,0,0,0,0,0,0,7,0,34169,0,26124),
(69646,'She\'s gone too far. I\'m certain the Alliance can move their war mages through the city at will. That human ... witch!','',0,0,0,0,0,0,0,0,7,0,34255,0,26124),
(69647,'When will they learn? When will they see that the Horde exists BECAUSE of the Alliance? Because of their prejudice and their bigotry!? They force us ever closer to Hellscream\'s Horde.','',0,0,0,0,0,0,0,0,7,0,34256,0,26124),
(69648,'My Lord...','',0,0,0,0,0,0,0,0,7,0,34170,0,26124),
(69649,'Hal\'duron, summon the rangers. Rommath, assemble the Blood Magi, and add the Sunreavers\' strength to your own.','',0,0,0,0,0,0,0,0,7,0,34257,0,26124),
(69650,'We Sin\'dorei will take our future into our own hands.','',0,0,0,0,0,0,0,0,7,0,34258,0,26124),
(69651,'And get this damn thing out of my sight! Hellscream bought his treasure with the blood of my people. I hope it destroys him.','',0,0,0,0,0,0,0,0,7,0,34259,0,26124),
(69652,'My Lord. YOU would make a fine Warchief.','',0,0,0,0,0,0,0,0,7,0,34171,0,26124),
(69653,'My Lord. YOU would make a fine Warchief.','',0,0,0,0,0,0,0,0,7,0,34278,0,26124),
(69654,'It may come to that. Bring me my blades. The next move is mine.','',0,0,0,0,0,0,0,0,7,0,34260,0,26124),
(69655,'Are you going to try a sip of the water of youth?','Are you going to try a sip of the water of youth?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69656,'Jaina\'s gone over the edge. She\'s imprisoning the Sunreavers and attacking those who resist. What\'s worse, the Silver Covenant has seized the opportunity to join the bloodshed.','',0,0,0,0,0,0,0,0,1,0,34269,0,26124),
(69657,'It\'s chaos up there. We need to save whoever we can, and we\'ll need to move quickly.','',0,0,0,0,0,0,0,0,1,0,34270,0,26124),
(69658,'Wait for my command...','',0,0,0,0,0,0,0,0,1,0,34271,0,26124),
(69659,'Go go go go! To the center of the city! This way!','',0,0,0,0,0,0,0,0,1,0,34272,0,26124),
(69660,'Aethas isn\'t here... they must have moved him. We can continue without him.','',0,0,0,0,0,0,0,0,1,0,34273,0,26124),
(69661,'Stay your hand and step aside. Very well.','',0,0,0,0,0,0,0,0,1,0,34274,0,26124),
(69662,'Aethas, this way! Into the portal!','',0,0,0,0,0,0,0,0,1,0,34275,0,26124),
(69663,'Stay by me! We\'re going out the tunnel!','',0,0,0,0,0,0,0,0,1,0,34276,0,26124),
(69664,'Stay by my side!','',0,0,0,0,0,0,0,0,1,0,34277,0,26124),
(69665,'Everyone be here now. Let\'s get dis done wit.','',0,0,0,0,0,0,0,0,1,0,34549,0,26124),
(69666,'Proceed by foot. We\'ll circle around and look for another entrance.','',0,0,0,0,0,0,25,0,1,0,34419,0,26124),
(69667,'As da Warchief commands...','',0,0,0,0,0,0,0,0,1,0,34550,0,26124),
(69668,'I\'m glad you here to watch me back. I don\'t like da look of Garrosh\'s goons.','',0,0,0,0,0,0,0,0,1,0,34551,0,26124),
(69669,'Let\'s mount up and move out!','',0,0,0,0,0,0,25,0,1,0,34552,0,26124),
(69670,'Hey - wait for me! I don\'t like goons, either.','',0,0,0,0,0,0,0,0,1,0,34365,0,26124),
(69671,'Scouts say dere\'s ancient magics in dese caves. Warchief wants \'em checked out.','',0,0,0,0,0,0,0,0,1,0,34553,0,26124),
(69672,'One a dem lizard-beasts. Fight on, me bruddahs!','',0,0,0,0,0,0,25,0,1,0,34515,0,26124),
(69673,'Have you fought dese \'tings before?','',0,0,0,0,0,0,6,0,1,0,34526,0,26124),
(69674,'It\'s like dey got weapons, but no brains.','',0,0,0,0,0,0,1,0,1,0,34527,0,26124),
(69675,'We can take this boat inside. Just let me make a few modifications...','',0,0,0,0,0,0,0,0,1,0,34356,0,26124),
(69676,'And... done! A self-propelled saurok-slaying machine.','',0,0,0,0,0,0,4,0,1,0,34370,0,26124),
(69677,'One of you man da guns, the rest on foot.','',0,0,0,0,0,0,25,0,1,0,34528,0,26124),
(69678,'Kill anyting dat squirms!','',0,0,0,0,0,0,1,0,1,0,34529,0,26124),
(69679,'Ack, get that thing off us!','',0,0,0,0,0,0,430,0,1,0,34371,0,26124),
(69680,'They\'re busting up our boat!','',0,0,0,0,0,0,22,0,1,0,34372,0,26124),
(69681,'Here! Stop da boat here.','',0,0,0,0,0,0,25,0,1,0,34532,0,26124),
(69682,'Griz, you guard da boat. Da rest of ya wit\' me.','',0,0,0,0,0,0,1,0,1,0,34533,0,26124),
(69684,'Here, take this! It\'ll help you against any swarms.','',0,0,0,0,0,0,0,0,1,0,34360,0,26124),
(69685,'I\'ll just... be right here. Don\'t forget about me!','',0,0,0,0,0,0,0,0,1,0,34361,0,26124),
(69686,'Are the preparations complete?','',0,0,0,0,0,0,6,0,6,0,34337,0,26124),
(69687,'Yes, Warlord. The traps are set. The Divine Bell will be safe within this crypt, ready for the day that the Thunder King returns.','',0,0,0,0,0,0,273,0,6,0,34202,0,26124),
(69688,'We have but to evacuate the workers and the rest of our warriors.','',0,0,0,0,0,0,1,0,6,0,34203,0,26124),
(69689,'Very well, then. May the ghosts of our brothers guard this place for all eternity.','',0,0,0,0,0,0,1,0,6,0,34204,0,26124),
(69690,'There is no time. The Shado-Pan trackers are too close. They cannot learn the location of the Bell.','',0,0,0,0,0,0,274,0,6,0,34338,0,26124),
(69691,'Their sacrifice will not be in vain.','',0,0,0,0,0,0,1,0,6,0,34339,0,26124),
(69692,'And neither, Avartu, will yours.','',0,0,0,0,0,0,5,0,6,0,34340,0,26124),
(69693,'Light... I see... light. Finally, after centuries of silence, someone comes at last.','',0,0,0,0,0,0,0,0,1,0,34197,0,26124),
(69694,'I have kept the Bell safe as promised, Master.','',0,0,0,0,0,0,0,0,1,0,34198,0,26124),
(69695,'Wait... you are not mogu! Intruders!','',0,0,0,0,0,0,0,0,1,0,34199,0,26124),
(69696,'Guardians, awaken! Destroy those who would steal the Thunder King\'s treasure!','',0,0,0,0,0,0,0,0,1,0,34200,0,26124),
(69697,'Be cast into darkness!','',0,0,0,0,0,0,0,0,1,0,34191,0,26124),
(69698,'This crypt will be your grave!','',0,0,0,0,0,0,0,0,1,0,34192,0,26124),
(69699,'You, too, shall know the silence!','',0,0,0,0,0,0,0,0,1,0,34193,0,26124),
(69700,'Such horror... Such emptiness...','',0,0,0,0,0,0,0,0,1,0,34194,0,26124),
(69701,'Only death awaits you!','',0,0,0,0,0,0,0,0,1,0,34195,0,26124),
(69702,'No! The Bell....','',0,0,0,0,0,0,0,0,1,0,34196,0,26124),
(69703,'You will go no further! Now face me. I will give you a swift death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69704,'There\'s my survey team. Bring us in.','',0,0,0,0,0,0,0,0,1,0,34681,0,26124),
(69705,'What\'s the situation?','',0,0,0,0,0,0,547,0,1,0,34682,0,26124),
(69706,'','Yer Highness! This site has everything we need. Lumber, stone and-',0,0,0,0,0,0,396,0,1,0,0,34244,26124),
(69707,'The Horde?','',0,0,0,0,0,0,6,0,1,0,34683,0,26124),
(69708,'','Marshal Troteman and a handful o\' scouts pursued a Horde warband up the beach. They haven\'t come back.',0,0,0,0,0,0,396,0,1,0,0,34245,26124),
(69709,'Hmm... Troteman may have gotten himself in over his head. We\'ll split up.','',0,0,0,0,0,0,396,0,1,0,34684,0,26124),
(69710,'Lynna, stay here and establish a camp. Your first priority should be medical tents and shelters. When the peasants arrive, see that they begin construction of the docks.','',0,0,0,0,0,0,397,0,1,0,34685,0,26124),
(69711,'Hornswaggle, notify the rest of the survey team. Quarry and mining operations will begin as soon as the fleet arrives.','',0,0,0,0,0,0,396,0,1,0,34686,0,26124),
(69712,'','Yes, Yer Majesty!',0,0,0,0,0,0,113,0,1,0,0,34246,26124),
(69713,'Champion, you know this land better than anyone. You\'re with me. Let\'s go find Troteman.','',0,0,0,0,0,0,396,0,1,0,34687,0,26124),
(69714,'Troteman, you old dog, I knew I\'d find you stirring up trouble.','',0,0,0,0,0,0,1,0,1,0,34711,0,26124),
(69715,'The survey team has done well. This is an ideal deep-water port.','',0,0,0,0,0,0,1,0,1,0,34712,0,26124),
(69716,'I want to see a tower built right here.','',0,0,0,0,0,0,0,0,1,0,34713,0,26124),
(69717,'Marshal, see to it that you hold this position until construction is complete.','',0,0,0,0,0,0,0,0,1,0,34714,0,26124),
(69718,'Now, let\'s see to our supplies...','',0,0,0,0,0,0,1,0,1,0,34715,0,26124),
(69719,'','Explorer\'s League reporting in, sir!',0,0,0,0,0,0,113,0,1,0,0,34249,26124),
(69720,'I\'m glad to see you contribute to the war effort. But I need supplies. What have you got?','',0,0,0,0,0,0,1,0,1,0,34707,0,26124),
(69721,'','Plenty of stone, aye. But no sign of major ore veins in this whole area.',0,0,0,0,0,0,396,0,1,0,0,34250,26124),
(69722,'I\'ll take it. Anything else?','',0,0,0,0,0,0,6,0,1,0,34708,0,26124),
(69723,'','Somethun\' even BETTER. History! Artifacts from an ancient an\' powerful race!',0,0,0,0,0,0,5,0,1,0,0,34251,26124),
(69724,'I\'ll make a deal with you, Hornswaggle. Help my men get a stone quarry operation running, and we\'ll protect your dig site.','',0,0,0,0,0,0,1,0,1,0,34709,0,26124),
(69725,'','You mean it? Oh, I cannae WAIT to see the look on Brann\'s face when he finds out I got an excavation green-lit by the King himself! You\'ll have your quarry by next sundown!',0,0,0,0,0,0,71,0,1,0,0,34252,26124),
(69726,'Hm. I used to think leadership was all about strength. I see things more clearly now - it\'s a little bit of give, a little bit of take. It\'s about binding people together. A bundle of sticks is not easily broken.','',0,0,0,0,0,0,1,0,1,0,34710,0,26124),
(69727,'Everything is in place. We\'ll construct a town center on this peninsula, using resources from along the coast.','',0,0,0,0,0,0,0,0,1,0,34651,0,26124),
(69728,'From here we can reach out to the natives and keep Horde aggression in check.','',0,0,0,0,0,0,0,0,1,0,34652,0,26124),
(69729,'Champion! Without your pioneering efforts on Pandaria, this foothold wouldn\'t have been possible.','',0,0,0,0,0,0,1,0,1,0,34653,0,26124),
(69730,'The honor is yours. Signal the fleet.','',0,0,0,0,0,0,25,0,1,0,34654,0,26124),
(69731,'Marshal, excellent work fortifying the harbor. Our next priority is -','',0,0,0,0,0,0,1,0,1,0,34691,0,26124),
(69732,'Father!','',0,0,0,0,0,0,22,0,1,0,34183,0,26124),
(69733,'What-?','',0,0,0,0,0,0,6,0,1,0,34692,0,26124),
(69734,'Father!','',0,0,0,0,0,0,1,0,1,0,34184,0,26124),
(69735,'Anduin... you\'re safe...','',0,0,0,0,0,0,5,0,1,0,34693,0,26124),
(69736,'Father, you can\'t do this. All the hatred and anger our war brings here - it poisons this place.','',0,0,0,0,0,0,274,0,1,0,34185,0,26124),
(69737,'Easy, son. We\'re fighting a different war now. This isn\'t about hatred of the Horde. This is about a love of what\'s right. About doing what needs to be done.','',0,0,0,0,0,0,0,0,1,0,34694,0,26124),
(69738,'This land is - different than ours. It\'s a treasure.','',0,0,0,0,0,0,1,0,1,0,34186,0,26124),
(69739,'Then we\'ll protect it with our lives. Son, I need you with me on this. We in this together?','',0,0,0,0,0,0,1,0,1,0,34695,0,26124),
(69740,'Together...','',0,0,0,0,0,0,1,0,1,0,34187,0,26124),
(69741,'','Yer Majesty! The Horde, they\'ve holed up in a temple west of here. Night elf rangers have surrounded it and locked it down...',0,0,0,0,0,0,5,0,1,0,0,34247,26124),
(69742,'Rangers? ...Tyrande.','',0,0,0,0,0,0,1,0,1,0,34696,0,26124),
(69743,'Father! You can\'t let them turn the Crane Temple into a war zone! That place is still recovering from a sha infestation...','',0,0,0,0,0,0,5,0,1,0,34188,0,26124),
(69744,'','AND it\'s a historical treasure trove.',0,0,0,0,0,0,4,0,1,0,0,34248,26124),
(69745,'Everyone, calm down. This sounds like one of Garrosh\'s traps. He\'s trying to lure us from the beach. Troteman? Round me up some peasants and a mortar team, and don\'t let down your guard.','',0,0,0,0,0,0,1,0,1,0,34697,0,26124),
(69746,'But father-','',0,0,0,0,0,0,1,0,1,0,34189,0,26124),
(69747,'I\'ll bring a small group of champions with me and talk to Tyrande myself. Anduin, I can handle this. I need you to trust that I\'m going to do the right thing here.','',0,0,0,0,0,0,1,0,1,0,34698,0,26124),
(69748,'... I trust you, father.','',0,0,0,0,0,0,2,0,1,0,34190,0,26124),
(69749,'All hail the King of Gilneas, Genn Greymane!','All hail the King of Gilneas, Genn Greymane!',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(69750,'From the faraway boughs of tranquil Darnassus, High Priestess Tyrande Whisperwind arrives!','From the faraway boughs of tranquil Darnassus, High Priestess Tyrande Whisperwind arrives!',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(69751,'Representing the draenei, the wise and noble Farseer Nobundo from the Exodar!','Representing the draenei, the wise and noble Farseer Nobundo from the Exodar!',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(69752,'I see. So it was this... sha... that caused such violent behavior in our troops?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69753,'Yes, father. I encountered sha energy in my travels. At its full power it is terrible to behold.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69754,'We Alliance have rallied to defeat many enemies, my son. The sha will fall to us, just like any other.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69755,'This isn\'t the same, father. The sha cannot simply be defeated. It feeds on our inner-most weaknesses. It twists our thoughts. Don\'t underestimate it!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(69756,'Yer Majesty! Look!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(69757,'By the light, is that a sha?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(69758,'Yes. Don\'t go near it!','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(69759,'','I sense great darkness emanating from this... thing. Destroy it, now!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69760,'I agree. Only suffering can come of such a creature.','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(69761,'I saw first-hand what the sha did to my soldiers in the Jade Forest. My strongest men were rendered helpless by crippling doubt.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69762,'','Your Highness, we should study it. Weaponize it! The Horde already outnumber us here on Pandaria. We need to gain every possible advantage.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69763,'It couldn\'t hurt to study it. \'Tho I don\'t much care for the way it\'s lookin\' at me.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(69764,'Yes, yes! Very interesting! Perhaps I could distill it into a new power source?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69766,'','Garrosh is using every weapon he can lay his hands on. Shouldn\'t we level the playing field?',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(69767,'What do you think, Anduin?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69768,'Garrosh\'s example is not one that I care to follow. The Alliance should make its own decisions. The RIGHT decisions.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69769,'Well said, my son.','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(69770,'This power is too dangerous. I will have none of it!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69771,'$n, thank you for helping me today. I knew we could convince my father of the right course. Please, go back to your other duties for now.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69772,'From the flying city of Dalaran, the leader of the Kirin Tor, Lady Jaina Proudmoore!','From the flying city of Dalaran, the leader of the Kirin Tor, Lady Jaina Proudmoore!',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(69773,'I\'m ready. Release the Monkey King.','I\'m ready. Release the Monkey King.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69774,'It is true, it may be possible to someday harness the sha into a weapon. But we risk destroying our own people in the process. That is not a price I am willing to pay.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69775,'<The pandaren snores deeply.>','',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(69776,'Wake up! The Horde is near - we must prepare defenses!','Wake up! The Horde is near - we must prepare defenses!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69777,'Oooh. I\'m afraid you\'ve chosen a bad time for building defenses, friend.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(69778,'Yesterday\'s sundown celebration went a little long, you see. We may have... overmeditated.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69779,'I knew you were the right one for this task, $c. Meet me back upstairs when you are finished here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69780,'Jubeka\'s mark clearly indicates she entered the Black Temple here.','Jubeka\'s mark clearly indicates she entered the Black Temple here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69781,'Enter the Temple.','Enter the Temple.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69782,'Shake it off, brothers. It\'s brewin\' time.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69783,'Rotating','Rotating',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69784,'We\'ve got to secure this beach stronghold. We let the Horde have a foothold here, all of Pandaria is going to look like Theramore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69785,'','We must prevent the Horde from taking Pandaria... but we must also work to minimize suffering as we do.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69786,'Why do they call me \"toasty\"? \n\nYou really gonna ask me that? Look, it\'s not MY fault that the chemicals reacted that way! Blame SCIENCE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69787,'Of course the Explorer\'s League stumbled into a foolish situation and are in over their heads.\n\nAnd of COURSE we are going to take advantage of it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69788,'','Och!\n\nWe\'ve got ghosts AND the Reliquary to contend with here?! I dunno what\'s worse!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69789,'Ugh, I Biebered...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69790,'Watch yourselves. The seals are breaking.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69791,'Garrosh, you do truly believe the sha can be controlled? Have you seen what it\'s done to our men?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69792,'Guards! Destroy that abomination.','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(69793,'The sha can be a powerful tool. The mogu may have once harnessed its power into the Divine Bell, and look at the glorious empire they built in its wake.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69794,'But their empire fell. Perhaps to the sha, perhaps to the pandaren, or perhaps... to their own pride.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69795,'What madness is this?','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(69796,'Did the Scourge beat all the courage from your people, blood elf? We are the HORDE. Where there is power, we SEIZE it. My Horde has no place for the weak!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(69797,'As you say... Warchief.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(69799,'Let\'s party!','Let\'s party!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69800,'The device indicates you are very close to the anomaly.','The device indicates you are very close to the anomaly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69801,'You continue to bow to the Kirin Tor as if they were our saviors. Do not forget their treachery, Aethas.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69802,'We are the Sin\'dorai! We should not have to bow to anyone. Not the Kirin Tor, not the Alliance, and certainly not the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69803,'Always so impatient, young one. There is no knowledge that is not power. This artifact dates back to the same era as the Divine Bell. To know its secrets is to bring us closer to Garrosh\'s prize.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69804,'But of course it is dangerous. This artifact\'s secrets would be useless to us otherwise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69805,'And bowing to the Warchief is any better? Garrosh\'s obsession with these mogu artifacts is such that I haven\'t seen since Kael\'thas walked amongst us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69806,'Rommath, without allies we will be crushed by the tides of this war. There is no middle ground with Garrosh. We either have to be with him, or against him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69807,'We already know the mogu mastered imprisoning living energy in devices. This is not a magic we need know more about.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69808,'Garrosh\'s prize, not ours. Mark my words, this construct is dangerous.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69809,'Seeker of Chaos... Summoner of Demons... Wielder of Shadows...','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(69810,'By any chance do you have another one of those super rare, hard to find, amulets?','By any chance do you have another one of those super rare, hard to find, amulets?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69811,'The existence of your kind has not escaped our notice, $c.','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(69812,'Like Illidan, you constantly struggle to bend the all consuming chaos to your will.','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(69813,'You walk the line between absolute power and total corruption.','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(69814,'Silvermoon has been allies with Dalaran for over 2000 years. It is not a friendship we should idly toss aside at the whim of our \'esteemed\' Warchief Garrosh.$b$bOh... are you here about the artifact?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69815,'As Azeroth has fought the legion and survived, you have faced the darkness within yourself and controlled it.','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(69816,'Perhaps you can succeed where Illidan failed... perhaps you can accept the disorder of this universe.','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(69817,'Jaina Proudmoore now sits as head of the Kirin Tor and rules Dalaran.$b$bThat puts the citadel square in the hands of the Alliance no matter how much Aethas brags about neutrality.$b$bThis young upstart may have forgotten, but the Alliance tried to imprison and massacre our people during the third war.$b$bForgive me if I do not share his faith in their... \"neutrality\".','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69818,'Your kind can tread where we cannot. Your kind can survive where others might perish.','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(69819,'The artifact that Kanrethad attempted to create is incomplete.','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(69820,'It grants the ability to perform magic on a grand scale... but they quickly lose the ability to control that power.','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(69821,'The Warchief demands results on your research.','The Warchief demands results on your research.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69822,'I will unlock the crystal\'s power, but only you can decide how it is to be used.','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(69823,'Choose wisely, $n.','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(69824,'This is not the place to discuss such matters. Join me in the chambers beneath the Farstrider Square.$b$bOh, and come armed. I believe we will have need of your skills.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69825,'The demons are no longer attacking... what happened here?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69826,'The Eye of the Storm... countless battles have been fought just to find that artifact. I know not why Xi\'ri entrusted it to your care, $c... but be warned... no one has wielded its power without paying a greater price.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69828,'An honorable meeting, $c. I have heard rumblings from my brothers here on Pandaria. Dark rumblings of dissent, and worry.$B$BI have come myself to support the Horde\'s efforts, but also... to make sure that things don\'t get too out of hand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69829,'','And did the good King Varian send you as well to bid for our aid?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69830,'I would commit our order to an Alliance victory!','I would commit our order to an Alliance victory!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69831,'$p, we should discuss matters back in Krasarang. For now, thank you for your help. There is a portal that can return you to Lion\'s Landing whenever you choose.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69832,'Hold your tongue, blood elf! You dare question our Warchief\'s judgment?','',0,0,0,0,0,0,14,0,1,0,0,0,26124),
(69833,'Calm yourself, Ishi. The Lord Regent may speak his mind.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69834,'Here we are in the land down under.$b$bIt is just as beautiful as the stories I was told as a cub on the Wandering Isle. Though the fish could be larger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69835,'SMASH MY GOOD LUCK? I SMASH YOU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69836,'GOBLIN WAS NOT LUCKY AT ALL!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69837,'I GO GET ANOTHER AFTER I STOMP YOU!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69838,'GOBLIN DID NOTHING TO YOU.  YOU ARE JERK!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69839,'THESE SHOULDERS... SO HEAVY...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69840,'I SMASH. YOU DIE. DEAL WITH IT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69841,'YOU GOT SMASHED!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69842,'Are you sure you can\'t choose a side?','Are you sure you can\'t choose a side?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69843,'It is a good thing to spend time in a place like this. We must always remember what it is we struggle so hard to protect.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69844,'Ready.','Ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69845,'','Take as long as you need, Go\'el. If Vol\'jin believes his people are in danger then you had best aid them as you can.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69846,'Thrall, we no longer answer to you. We have a new Warchief now. And he has reminded us that we are STRONG!','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(69847,'This is worse than I suspected.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(69848,'','In the other corner, we have Vian, the flame-flinging follower of the Thunder King!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69849,'','Also entering the arena: Goredome! So-named because he will gore you. With his dome.',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69850,'','We also welcome our pain-packing crowd favorite: Dungeon Master Vishas!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69851,'','Hey hey! Look what we\'ve scooped up for you today... it\'s Blat!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69852,'','Five on one hardly seems fair, but come on... they\'re half-dead gnomes. It\'s the leper gnome quintet!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69853,'','Also entering the arena: Battletron! Sure, it\'s not goblin-engineered... but it still might kill you!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69854,'','In the other corner... hey look! It\'s my buddy, Fran! And he brought his mount with him!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69855,'','We also welcome everybody\'s favorite frosty feathered friend: Dippy!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69856,'','We found this one scuttling in circles in Silithus. Looks like somebody mostly killed him already. It\'s Ixx!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69857,'','Also entering the arena: Destructobyte... and his ridiculous gnomish holographic machinery!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69858,'','And in this corner! He\'s angry. He\'s deadly. He\'s a little bit adorable. Straight out of Neverest, it\'s Crush!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69859,'','Sure, she\'s wearing a dress, and her knees bend the wrong way, but that doesn\'t mean she can\'t walk all over you. It\'s Dominika!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69860,'','Up next, probably the weakest, ugliest, and least genius combatant I\'ve ever seen. It\'s the stupid, smelly gnome, Millie Watt! Everybody boo!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69861,'','We spent days trying to find this one in Sholazar Basin. Welcome to the jungle! It\'s Mazhareen!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69862,'','Some of you veterans might remember this fella\'. Sure, he\'s broken, but he means to break you! It\'s Akama!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69863,'','Also entering the arena: Everybody\'s favorite magical 12-foot-tall corpse, Fjoll! Am I pronouncing that right?',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69864,'','Ugh! Another gnome? Apparently this one calls himself Millhouse Manastorm. Get out there and kill him!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69865,'','We found this one cawing up a storm in Auchindoun. Give it up for Yikkan Izu!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69866,'','Get ready to dance! Deeken\'s in the house!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69867,'','We also welcome Smash Hoofstomp, the terrible tauren from Thunder Bluff!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69868,'','And in the other corner, we have the many eyes of Zen\'shar! What\'s next, a fighting nose?',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69869,'','Their partnership was never meant to be. It actually makes me sick a little bit. Here comes GG Engineering!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69870,'','Also entering the arena: The Dark Summoner. Wow, he doesn\'t even have a real name. Spooky!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69871,'','Now this is what I\'m talking about! More dinosaurs, please! It\'s King Kulaka!!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69872,'','Hmm. That\'s actually some pretty good engineering down there. It\'s Disruptron time!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69873,'','Ha ha ha! What bad luck you have! It\'s Proboskus! Ahhh ha ha ha! I\'ve got twenty five gold that says you die in the fire!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69874,'','Quiet down, everyone... we don\'t want to make it angry. Just gaze in silent awe at Unguloxx, the murderaffe!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69875,'$n is representing Stormwind!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69876,'$n is representing Ironforge!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69877,'$n is representing Gnomeregan!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69878,'$n is representing Darnassus!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69879,'$n is representing the Exodar!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69880,'$n is representing Gilneas!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69881,'$n is representing the Tushui Pandaren!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69882,'Hey, scrub! You interested in a fight?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69883,'Give me a minute, I want to finish watching this fight.','Give me a minute, I want to finish watching this fight.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(69884,'','What\'s wrong, $n? Afraid to fight? Come on, let\'s keep this arena moving!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69889,'$gHis:Her; name was $n.','$gHis:Her; name was $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69890,'Brilliant victory, $n! Now get back in line.','Brilliant victory, $n! Now get back in line.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69891,'Sorry, $n. Now would you kindly remove your corpse so that the others can have a go?','Sorry, $n. Now would you kindly remove your corpse so that the others can have a go?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69892,'Honestly, $n... were you even trying?','Honestly, $n... were you even trying?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69893,'You wanna make an omelet, you\'re gonna have to break a few eggs.','You wanna make an omelet, you\'re gonna have to break a few eggs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69894,'Ahhh ha ha ha! So much blood! Nice.','Ahhh ha ha ha! So much blood! Nice.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69895,'Keep \'em comin\', $n.','Keep \'em comin\', $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69896,'$n wins! $n wins!','$n wins! $n wins!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69897,'No! Never again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69898,'You dare defy the Warchief?!','You dare defy the Warchief?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69899,'We\'re routing out the traitors. Looks like we\'ve found another...','We\'re routing out the traitors. Looks like we\'ve found another...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69900,'Traitor!','Traitor!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(69901,'These trolls need to learn their place.','These trolls need to learn their place.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69902,'The Horde has no room for such weakness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69903,'You shall not stand in our way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69904,'This is OUR Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69905,'','Nothing lasts forever, $p',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69906,'The Horde are attacking, Nove!','The Horde are attacking, Nove!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69907,'','This is not my fight, $p.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69908,'You have to help us, Nove!','You have to help us, Nove!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69909,'','Very well, $p. Prove yourself to me and I will aid you in your fight.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69911,'','Now is not the time for this, $p. Leave me in peace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69912,'','Come and face me, $p!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69913,'Wha? Huh? Oh, yes. The defenses...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69914,'Ahh, many thanks, friend. I needed that.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69915,'Oof, I was... just listening to the ground - you know, for signs of enemies approaching. We seem to be safe... for the moment.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69916,'This yak was male! The angry yak turns on you!','This yak was male! The angry yak turns on you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69917,'Ooh, just a power-nap. All ready to go now!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69918,'Ugh! Look at what you\'ve done to my fur!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69919,'Oh, why? You interrupted the most pleasant dream...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69920,'Success! The female yak bleats at you peacefully.','Success! The female yak bleats at you peacefully.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69921,'Well done. Now I will just add a hair from our prisoner, Shan Kien, and combine the ingredients.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69922,'Master Brownstone and his crew have fallen asleep!','Master Brownstone and his crew have fallen asleep!',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(69923,'I am losing patience, Shan Kien. Tell me where I can find the Divine Bell!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(69924,'Kill me if you must, but I owe no allegiance to you or your Horde. The only master I serve is the Thunder King.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69925,'Ishi, draw your blade. A few carefully delivered cuts will change his mind.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69926,'Garrosh, please. There may be another way. One that requires no bloodshed.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69927,'Speak, then!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69928,'I have learned how to make an ancient pandaren tincture that will allow us to see into Shan Kien\'s past. We have but to gather the elements for this brew.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69929,'Stonecore was merely a setback!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69930,'I have heard the rumors and the jokes...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69931,'No one laughs behind the great Millhouse Manastorm\'s back and lives to tell the tale!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69932,'Here\'s a little something something you\'re gonna love...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69933,'Nice try, sweet cheeks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69934,'Better luck next time! BWAHAHAHAH!','',0,0,0,0,0,0,153,0,1,0,0,0,26124),
(69935,'You\'ll be hearing from my lawyer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69936,'Also entering the arena: Bruce, a crocolisk that we found!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69937,'In the other corner, we have Vian, the flame-flinging follower of the Thunder King!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69938,'Also entering the arena: Goredome! He WILL attempt to gore you. With his dome.','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69939,'Well, wrap me in leather and tug my leash: it\'s Dungeon Master Vishas!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69940,'Hey hey! Look what we\'ve scooped up for you today... it\'s Blat!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69941,'The opposition includes some of Gnomeregan\'s finest... although they\'ve all seen better days. It\'s the leper gnome quintet!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69942,'Also entering the arena: Battletron! This hunk o\' junk is just waiting to explode all over you!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69943,'In the other corner... a disgusting green pile of goblin idiocy, riding on a lumbering chariot of shame. It\'s Fran and Riddoh! Everybody boo!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69944,'He\'ll peck your eyes out if you give him a chance. It\'s Dippy!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69945,'From deep within the bowels of Blackrock Mountain, it\'s Sanoriak, master of flame!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69946,'We found this one scuttling in circles in Silithus. From the looks of him, somebody mostly killed him already. It\'s Ixx!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69947,'Also entering the arena: Destructobyte... and his special surprise!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69948,'And in this corner! He\'s angry. He\'s deadly. He\'s a little bit adorable. Straight out of Neverest, it\'s Crush!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69949,'Also entering the arena: Kirrawk, wind-wielding arakkoa of the Terokkar Forest!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69950,'When I see her smile, it makes me smile. When she casts a spell, it puts a spell on me. When I see her horns, it makes me feel... intrigued. It\'s Dominika!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69951,'Up next, it\'s Millie Watt! I used to date her in engineering school!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69952,'We spent days trying to find this one in Sholazar Basin. Welcome to the jungle! It\'s Mazhareen!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69953,'Some of you veterans might remember this guy. He may be Broken, but today, he means to break you! It\'s Akama!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69954,'Also entering the arena: Everybody\'s favorite magical 12-foot-tall corpse, Fjoll! Am I pronouncing that right?','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69955,'We have a special guest today: the always-endearing, ever-resilient, Millhouse Manastorm! Good luck, MillMan!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69956,'We found this one cawing up a storm in Auchindoun. Give it up for Yikkan Izu!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69957,'Get ready to dance! Deeken\'s in the house!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69958,'We also welcome Smash Hoofstomp, the terrible tauren from Thunder Bluff! Look at those GREAT shoulderpads!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69959,'And in the other corner, we have... a big cloud of scary floating eyes? This doesn\'t look good.','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69960,'Their partnership was never meant to be. It actually makes me sick a little bit. Here comes GG Engineering!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69961,'Also entering the arena: The Dark Summoner. Wow, he doesn\'t even have a real name. Spooky!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69962,'Now this is what I\'m talking about! More dinosaurs, please! It\'s King Kulaka!!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69963,'Hmm. That\'s actually some pretty good engineering down there. It\'s Disruptron time!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69964,'Oh dear... I\'m sorry, but it looks like you\'re going to have to fight Proboskus.','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69965,'Quiet down, everyone... we don\'t want to make it angry. Just gaze in silent awe at Unguloxx, the murderaffe!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(69966,'I will now accept your guesses and wagers on the victor of the match.','',0,0,0,0,0,0,0,0,1,47751,0,0,26124),
(69967,'That\'s it! No more wagers! Let\'s see what happens!','',0,0,0,0,0,0,0,0,1,47751,0,0,26124),
(69968,'Who are you?\n\nI can assure you that everything here is perfectly legitimate, good $gsir:ma\'am;. We are just a pair of wealthy entrepreneurs enjoying a little friendly bloodsport, without ANY gold changing hands.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69969,'|TInterface\\Icons\\INV_SWORD_04.BLP:32:32:0:0|tThe hero.','|TInterface\\Icons\\INV_SWORD_04.BLP:32:32:0:0|tThe hero.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69970,'|TInterface\\Icons\\INV_MISC_MONSTERCLAW_04.BLP:32:32:0:0|tThe monster.','|TInterface\\Icons\\INV_MISC_MONSTERCLAW_04.BLP:32:32:0:0|tThe monster.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69971,'I refuse to take your guesses if you aren\'t participating in the brawl yourself. You need \"skin in the game\", if you will.\n\nGo talk to one of the guards and queue for the brawl. Then we can play.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69972,'Quickly, my good $gsir:lady;. Who do you predict will win the next fight?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69973,'Mogu are imperious, arrogant, and powerful - all characteristics that will send Garrosh into a rage when he arrives. \n\nThis is why it is critical that we capture and interrogate the leader of these mogu before that happens.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69974,'Ya be lettin\' us outta here now!','Ya be lettin\' us outta here now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69975,'Dis\' be our home, mon. If ya be tinkin\' we goin\' quietly ya mistaken.','Dis\' be our home, mon. If ya be tinkin\' we goin\' quietly ya mistaken.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69976,'Why ya be doin\' this? We be loyal to da Horde!','Why ya be doin\' this? We be loyal to da Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69977,'Alright, you in?$b$bQuick quick, who d\'ya think\'s gonna win this one, bucko?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69978,'Who are you?\n\nAin\'t nothin\' shady going on here, no $gsir:ma\'am;. Just enjoying a little friendly bloodsport, without ANY gold changing hands. Everything here\'s on the up-and-up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69979,'I ain\'t gonna support you if you ain\'t brawlin\' yourself. You need \"skin in the game\", chief.\n\nGo talk to one of them guards and tell \'em you wanna fight. Then we can play.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69980,'Alright, who\'s in?','',0,0,0,0,0,0,0,0,1,46036,0,0,26124),
(69981,'That\'s it! The fight\'s goin\', no more guesses!','',0,0,0,0,0,0,0,0,1,46036,0,0,26124),
(69982,'By order of the Warchief this \"city\" is now under Martial Law. Any who refuse the will of the Warchief shall be branded as traitors!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69983,'You ain\'t got dah right to keep us captive!','You ain\'t got dah right to keep us captive!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69984,'Dis be our home! You ain\'t welcome here, Kor\'kron.','Dis be our home! You ain\'t welcome here, Kor\'kron.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69985,'Why ya be doin\' dis? We all part o\' dah Horde.','Why ya be doin\' dis? We all part o\' dah Horde.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69986,'Where be Vol\'jin?','Where be Vol\'jin?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69987,'Ya not be welcome here!','Ya not be welcome here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69988,'Da Warchief not be in his right mind.','Da Warchief not be in his right mind.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69989,'Who you be to challenge our loyalty?','Who you be to challenge our loyalty?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69990,'Ya not the only ones who bleed for dah Horde ya orcs!','Ya not the only ones who bleed for dah Horde ya orcs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69991,'Let us use persuasion, not force. I have here a cask of pandaren Memory Wine. It will allow us to see into Shan Kien\'s past.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(69994,'How... many... of your own people must you kill... so you can have \"your\" Horde back?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69995,'The Horde is changing! Vol\'jin refused to change with it, and he\'s poisoned his people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(69997,'You will harm no more sons or daughters of the Horde. Your purpose has been corrupted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70001,'The things I do for the Alliance...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70002,'Interested in trading up your pet battle-stones?','Interested in trading up your pet battle-stones?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70003,'Orestes! Aenea! You are to accompany $p on his mission.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70004,'Another mission with Aenea? If I must.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(70005,'','Yes, my lord.',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(70006,'Ya not be needin\' dis weapon again now are ya?','Ya not be needin\' dis weapon again now are ya?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70007,'Let me show ya how to use your own weapon, mon.','Let me show ya how to use your own weapon, mon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70008,'Ya not be so tough from the dead now are ya?','Ya not be so tough from the dead now are ya?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70009,'Shoulda\' left when ya had the chance.','Shoulda\' left when ya had the chance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70010,'You be wantin\' our land? We gonna bury you here.','You be wantin\' our land? We gonna bury you here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70011,'Do me this courtesy, $p, and do not share with Garrosh what has transpired here today. I could confront him directly, but I see now not all orcs share my view of the Horde.$b$bWho am I to command their allegiance if I must become another dictator to do so?$b$bWhat I can do is aid the Darkspear in fortifying their home while their heroes are abroad for the war. When Vol\'jin returns, we will plan our next move.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(70012,'A Darkhatched Sorcerer has put the boat into Stasis!  Kill it to interrupt the spell.','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(70013,'A nearby group of Darkhatched Eggs begins to hatch!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(70014,'Grizzle has given you a portable flamethrower!  Use it on the saurok eggs nearby.','',15,0,0,0,0,0,0,0,0,0,0,0,26124),
(70015,'You need a Darkmoon Ride Ticket to use the carousel.','You need a Darkmoon Ride Ticket to use the carousel.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70016,'Traitor. You are a disgrace to your race.','Traitor. You are a disgrace to your race.',0,0,0,0,0,0,0,1,1,7274,0,0,26124),
(70017,'These trolls cannot continue to defy the Warchief! They must be dealt with.','These trolls cannot continue to defy the Warchief! They must be dealt with.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70019,'Have you forgotten what it means to be an orc?! We are the blood of the Horde! Not these island beggars.','Have you forgotten what it means to be an orc?! We are the blood of the Horde! Not these island beggars.',0,0,0,0,0,0,0,1,1,7274,0,0,26124),
(70022,'Hellscream will find out about this!','Hellscream will find out about this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70023,'We are not some mind controlled savages you are dealing with. To defy Hellscream is to defy the greatest orcs of the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70024,'Yeah, you\'re next. Unless someone cuts in front of you, that is.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(70025,'Hmm... you\'re second in line. Won\'t be long now.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(70026,'List says like you\'re third in line, $c.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(70027,'You\'re fourth on the list, $r.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(70028,'You are the fifth person in line. Shouldn\'t be too much longer.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(70029,'You\'re... sixth in line.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(70030,'You\'re seventh on my list.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(70031,'You\'re eighth in line, $r.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(70032,'You\'re ninth in line.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(70033,'You are tenth in line, kid.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(70034,'','Well fought, $p, you have proven your strength.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70035,'Busy day today. I show at least ten people in line in front of you. Not too many more than that, though.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(70036,'I\'ve got at least fifteen people waiting in line ahead of you. Hard to tell - it\'s a little busy in here right now.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(70037,'Keep waiting. I count at least twenty people who got here before you did. Maybe more.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(70038,'Tough to tell. I think you\'re number thirty in line? Maybe forty? I lost count a while back.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(70039,'Boss says there\'s at least fifty people in line in front of you.$b$bIt\'s packed in here.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(70040,'Be with you in a moment, $gsir:ma\'am;.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(70041,'','Master Brownstone and his lackeys are notorious for sleeping on the job.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70042,'','I\'ll make make sure those slumps stay on task and get those defenses built.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70043,'Run into the Big Bad Voodoo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70045,'We aren\'t giving those savages an inch of ground. Not while I\'m still alive.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70046,'','The plants are hungry...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70047,'','Now THIS is a discovery!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70048,'You may only choose one quest.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70049,'Goodbye nearby living beings!  My unique presence is requested in another dimension.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70050,'','My body returns to the earth...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70051,'','Spread the word that this mighty bush has thorns!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70052,'','Help me feed them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70053,'Nothing heals like a fistful of needles.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70054,'Brace yourselves, they\'re coming back around!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70055,'','Heads up, more Horde!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(70056,'','I never thought I\'d see the day! The damsel of Darnassus! Put your big, beefy hands together for Leona Earthwind!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(70057,'','And... Meatball.',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(70058,'I never thought I\'d see the day! Our former champion, out of retirement! Put your big, beefy hands together for Leona Earthwind!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(70059,'And... Meatball.','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(70060,'Sons and daughters of the Horde! Today you stand free due to the strength of your heroes and the actions of this champion, $p! The Kor\'kron arrival heralds dark times for the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70061,'--ATTENTION $P. YOUR PRESENCE IS REQUESTED IN THE CHAMBER BEHIND THIS UNIT.--','',0,0,0,0,0,0,0,0,1,20156,0,0,26124),
(70062,'','Alright Brownstone, time to get to work!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70063,'Lor\'themar wants a status update on the experiment.','Lor\'themar wants a status update on the experiment.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70064,'This Korune device is similar to the fel crystals we once used to enslave demonic energies. Demon or angry spirit or elemental manifestation of an emotion, the principle is relatively the same.$b$bWe need to see how intact the entity stored within this artifact is, however. Since you have experience with the mogu and the other dangers of Pandaria, would you be so kind as to do the honors?$b$bWe have already disabled most of the protective wards. Simply adjust the intensifier disc on the artifact and be ready for anything that comes out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70065,'Lor\'themar wants a status update? Or is it his master Garrosh?$b$bYou should tell them both that this experiment is a waste of time. The mogu drew power by enslaving the living essence of other creatures. Is this something our Warchief should be dabbling in?$b$bThis is the same road Kael\'thas Sunstrider once walked, and it nearly destroyed our people. Why are we taking orders from someone who would have us walk down this road again?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70067,'You have seen where this Divine Bell is hidden? Very good. Garrosh will be pleased. We will try to locate the site you describe, and will contact you as soon as we find it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70069,'You fighting today, $c?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70070,'Come on in, $r.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70071,'Let me know if you want to fight, $r.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70072,'If you want to join the brawl, just let me know.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70073,'Have a merry time on the merry-go-round!','Have a merry time on the merry-go-round!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(70074,'Ride the Darkmoon carousel!','Ride the Darkmoon carousel!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(70075,'Ride tickets! Get your carousel ride tickets!','Ride tickets! Get your carousel ride tickets!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(70076,'You must pay to ride, friends! Come and get your ride tickets!','You must pay to ride, friends! Come and get your ride tickets!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(70077,'Ride tickets for sale! Come get your ride tickets!','Ride tickets for sale! Come get your ride tickets!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(70078,'You\'ll need a ride ticket to ride the carousel. Come and get your ride tickets!','You\'ll need a ride ticket to ride the carousel. Come and get your ride tickets!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(70079,'Hurry, hurry, hurry! Step right up and purchase your ride tickets!','Hurry, hurry, hurry! Step right up and purchase your ride tickets!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(70080,'Ride tickets! Purchase a book of ride tickets here!','Ride tickets! Purchase a book of ride tickets here!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(70081,'Enough Rommath! The Sin\'dorei must be free from the yoke of the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70082,'Use the Kor\'kron Disguise, then search for intel in the middle of Garrosh\'ar Advance.','Use the Kor\'kron Disguise, then search for intel in the middle of Garrosh\'ar Advance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70083,'WHAT?! You saw where the mogu hid the Divine Bell? I\'ll alert Lion\'s Landing immediately. We gotta get this thing before Garrosh. We\'ll contact you as soon as we find it!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(70084,'INTERLOPER! Insect! Flea! I shall brush you away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70085,'A Darkmoon Ride Ticket has been consumed.','A Darkmoon Ride Ticket has been consumed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70086,'You fighting today, $c?','You fighting today, $c?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70087,'Let me know if you want to brawl, $r.','Let me know if you want to brawl, $r.',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(70088,'Blood and honor, $c.','Blood and honor, $c.',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(70089,'Speak with a guard if you wish to fight, $c.','Speak with a guard if you wish to fight, $c.',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(70090,'MEATBALL HUNGRY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70091,'MEATBALL EAT WHAT MEATBALL WANT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70092,'MEATBALL FEEL FUNNY!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70093,'MEATBALL BELLY GURGLE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70094,'MEATBALL BELLY HURTS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70095,'You\'ve gained Mogu Power!  Pick up more runes and your power will grow.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(70096,'MEATBALL EAT SMELLY THING NOW!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70097,'BLLAAAGGGGHHHHH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70098,'Thanks for getting me out of there. Not pleasant in the slightest.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(70099,'I need a shower.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70100,'Stop hiding behind your traps and face me cowards!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70101,'','Hey, I know you! You\'re that $gguy:lady; that was fightin\' in the arena! You back for more?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70102,'','Welcome back, bruiser. You up for a go?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70103,'','Hey there, $gchief:sweetie;. You up for a fight?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70104,'','Couldn\'t get enough, could ya?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70105,'','Well, well, well... look who\'s back for more!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70106,'','$n! What can I do for ya?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70107,'','The Brawler $ghimself:herself;: $n!$b$bYou here to beat up my monsters some more?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70108,'Won a few fights, I see! Keep it up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70109,'You want to get in there and fight some more? I\'ll put you on the list.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70110,'Oh, welcome back, $n. You here to break a few more faces, or what?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70111,'Back for more? Fights are only going to get tougher from here on out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70112,'You\'re becoming quite the crowd favorite around here, $n.$b$bYou\'re good for business.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70113,'Oh hey! $n! You want to fight today?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70114,'Hey, $n. You here to watch the scrubs duke it out in the pit? Or did you come to fight?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70115,'Feel the flames\' embrace!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70116,'There is no escape...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70117,'Your time has come.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70118,'Burn!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70119,'You can\'t run forever!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70120,'Is it cold in here...?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70121,'Prepare to be blown away! Kirrawk!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70122,'How does it feel to fly?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70123,'Kir..rawk....','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70124,'You stand no chance. You are but an insect to Fjoll.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70125,'I see nothing but purple before me...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70126,'Alright $n!','Alright $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70127,'Congratulations!','Congratulations!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70128,'$n! $n! $n!','$n! $n! $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70129,'That\'s my $n!','That\'s my $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70130,'','Is it gettin\' hot in here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70131,'','Sheesh, guys! Hurry it up already!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70132,'','Let\'s keep it movin\' in there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70133,'','Time\'s almost up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70134,'','Uh oh... I smell smoke...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70135,'','Fire\'s comin\'!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70136,'','Alright, alright. We\'ve got a line going out here, you know.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70137,'','I think we\'ve seen just about enough of this. Am I right?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70138,'Is it getting hot in here? Or is it just me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70139,'We don\'t have all night. Hurry it up already!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70140,'I think it\'s about time to call this fight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70141,'Time\'s nearly up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70142,'Do you smell smoke?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70143,'The fire\'s coming!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70144,'We\'ve got a whole list of people who want to fight, you know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70145,'I think we\'ve seen just about enough of this. Am I right?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70146,'Hey there! Need a ride? Hop on a tallstrider!','',70,0,0,0,0,0,70,0,1,0,0,0,26124),
(70147,'If you need a ride down, take one of these babies!','',396,0,0,0,0,0,396,0,1,0,0,0,26124),
(70148,'Welcome to Darkmoon Island! Feel free to ride one of these lovely beasts down to the Faire.','',70,0,0,0,0,0,70,0,1,0,0,0,26124),
(70149,'Majestic forest striders! Free rides down to the Darkmoon Faire!','',70,0,0,0,0,0,70,0,1,0,0,0,26124),
(70150,'Fools! I control what makes you fight... Fear, anger, doubt... these are MY weapons!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70151,'Fear... anger... doubt... these are weapons. MY weapons. And they will unmake you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70152,'Get those mangy beasts under control!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70153,'I thought I smelled a filthy Alliance spy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70154,'AUGH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70155,'(Placeholder) The \"Harbingers\" movie plays.','(Placeholder) The \"Harbingers\" movie plays.',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(70156,'A bell cast from the makers\' flesh, shaped by stars\' fire, and bound by the breath of darkest shadow.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(70157,'This bell, when rung, could shake the world and call to the heavens.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(70158,'Taken to war, the bell\'s cacophonous tones stirred the hearts of Lei Shen\'s warriors.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(70159,'It fueled their hatred and anger, lending them strength on the field of battle.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(70160,'The bell\'s screaming voice struck fear and doubt into the hearts of the Emperor\'s enemies, sending them fleeing in his path.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(70161,'Awed by its power, the Thunder King described the instrument as \"the voice of the gods,\" and named it the Divine Bell.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(70162,'Eventually, the Thunder King fell, and the Bell changed hands. Many tried to use its power. Some tried to silence its sound. All failed.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(70163,'Finally, the Korune spellweavers laid claim to their instrument and hid it away. Since then, the Bell has been lost to history.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(70164,'Pathetic! You and your mogu are nothing to the might of the Horde!','',0,0,0,0,0,0,53,0,1,0,0,0,26124),
(70165,'Now... if you value your life, scum, you\'ll tell me what I need to know.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(70166,'Commander Scargash is filled with rage! Avoid his melee attacks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70167,'I will bathe in your blood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70168,'Where is the Divine Bell?!','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(70169,'','Varian sent you as well? I\'m outnumbered in my own city!$b$b<Jaina\'s eyes flash mischievously.>$b$bLet\'s go about this a different way. Put yourself in my shoes. Imagine that YOU are the leader of the Kirin Tor. $p! The most influential archmage in all of Azeroth!$b$bWhat would YOU do?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(70170,'Ha... <cough>... you young races... so impatient, petulant. Orc... you cannot even control yourself... your own rage, your own fear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70171,'I... will tell you... nothing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70172,'','Spoken like a stalwart Alliance $c! Believe me, I understand the sentiment.$b$bNow then, as leader of the Kirin Tor and a faithful part of the Alliance, what would you do about the Sunreavers? True, they are advocates of the Horde. But they have been allies and productive members of the Kirin Tor for over 2000 years. This city is their home.$b$BWould you expel them?',1,274,0,0,0,0,0,0,1,0,0,0,26124),
(70173,'Yes. Horde is Horde.','Yes. Horde is Horde.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70174,'','<Jaina\'s eyes grow sad.>$b$bSo... you would purge the city? Cast the Sunreavers from their homes? The very same Sunreavers who helped humans discover magic in the first place?$b$bYou and I are obviously very different. I suppose I see my role - and the mission of the Kirin Tor - a little differently. My mind is set. Would you like to hear what I think?',274,1,0,0,0,0,0,0,1,0,0,0,26124),
(70175,'Are you sure?','Are you sure?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70176,'You WILL, or I will shove my boot down your throat!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(70177,'Not if they renounced the Horde.','Not if they renounced the Horde.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70178,'','<Jaina brushes her hair from her eyes, deep in thought.>$b$bYou\'re so passionate for your cause and clear in your convictions. Believe me when I say that the Sunreavers are the same. The Horde is their family.$b$bNot all of them support Garrosh. But they\'re not about to abandon their own people... I couldn\'t ask them to do so without tearing the Kirin Tor apart.$b$bThe Kirin Tor is sacred to me. We need to stay united.',273,6,0,0,0,0,0,0,1,0,0,0,26124),
(70179,'I would struggle to maintain our neutrality.','I would struggle to maintain our neutrality.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70180,'','<Jaina smiles.>$b$bIf only we all shared your strength and conviction! To be honest, I struggle. Every. Day.$b$bBut you are right. The Kirin Tor is bigger than you, me, Alliance or Horde. I have a responsibility to preserve it, and to use its powers wisely.$b$bYou and I seem to agree. I doubt the King sees it that way. But... do you think we can convince Anduin?',274,1,0,0,0,0,0,0,1,0,0,0,26124),
(70181,'','Ah! A very bold decision in times like these. Your honesty is refreshing!$b$bTell me, leader of the Kirin Tor, what if the Horde killed your friends? Your family? Destroyed everything you had. Could you maintain your convictions even then, Archmage $p?',273,1,0,0,0,0,0,0,1,0,0,0,26124),
(70182,'','<Jaina warms to you immediately.>$b$bA kindred soul! Thank you, $p, for your honesty. You seem to understand my struggle. Every day, the hard decisions. Every night... the nightmares.$b$bBut I have a responsibility to preserve the Kirin Tor. I\'m glad you\'re with me on this. The King would never see it this way. Do you think we can explain it to Anduin?',273,6,0,0,0,0,0,0,1,0,0,0,26124),
(70183,'*Ahem* Many greetings to you, traveler!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70184,'Iiiiiiiiii\'m back Wikkets!','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(70185,'Ha... <cough>... the Divine Bell... what could you hope to do with it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70186,'The Bell... speaks with the voice of the gods...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70187,'<cough>... you are impudent, impatient, childish. You cannot even... control yourself, your own fear... your own rage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70188,'How could you hope... <cough>... to control the Bell?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70189,'Graaagh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70190,'Fine. You\'ve made your choice, mogu. Now, you die...','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(70191,'Garrosh! Stay your hand!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70192,'Elf! What is this treachery?!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(70193,'I didn\'t see my people die at Mogujia to have you snuff out our only remaining avenue to the Bell.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(70194,'...Very well. He is yours, Blood Elf.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(70195,'Whether he talks or not, I\'ll tear this continent to pieces if it means I find what I seek... if it means glory for the Horde.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70196,'But, elf...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70197,'Disrespect me again, and I\'ll have your head on a pike outside the gates of Orgrimmar.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70198,'Good luck with your interrogation.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70199,'','Shhhhh! You\'ll blow my cover!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70200,'Are you the agent that is following Connelly?','Are you the agent that is following Connelly?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70201,'He is our only way to find the bell. We WILL make him talk. Give us time.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70202,'Well... that was interesting. Let\'s go meet with Lor\'themar back outside.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70203,'He\'s impulsive, but we\'ll get results. He\'ll see our way is right.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70204,'Debug Error: Spell Failed. Bug This!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70205,'Alright everyone. Make preparations to take the prisoner back to the Vale. We\'ll be handing him over to Hellscream once he\'s had some time to cool off.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70206,'We\'ll be handing him over to Hellscream once he\'s had some time to cool off. Can\'t have him destroying our prize, can we?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70207,'$p - good work. Without your assistance, I\'m afraid this whole business would have ended quite nastily.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70208,'Ha! Didn\'t expect to see me here did you? The Monkey King does not delegate duelery! Now, are you hero? Or are you wikket?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70210,'Okee dokee! Let\'s see what you got.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70211,'In pieces three the mallet be. Handle, head and ointment. You ring the bell without the mallet? You going to get an ear and face full of evil.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70212,'No! Silly wikket cannot take the hozen mighty rod!','',0,0,0,0,0,0,0,0,1,19980,0,0,26124),
(70213,'No! No no no! No more party! This still Ingoo Ingoo\'s village!','',0,0,0,0,0,0,0,0,1,19980,0,0,26124),
(70214,'Stop! Stop partying! This not the real Monkey King! Monkey King die long long long long long long long time ago!','',0,0,0,0,0,0,0,0,1,19980,0,0,26124),
(70215,'No! No singing!','',0,0,0,0,0,0,0,0,1,19980,0,0,26124),
(70216,'Monkey King is not in charge! Chief Ingoo Ingoo in charge! Listen to the Chief!','',0,0,0,0,0,0,0,0,1,19980,0,0,26124),
(70217,'No more brew! Remember last time with Captain Ook? Want that to happen again?','',0,0,0,0,0,0,0,0,1,19980,0,0,26124),
(70218,'No! Stop playing! Stop! Stop! Stop!','',0,0,0,0,0,0,0,0,1,19980,0,0,26124),
(70219,'You no king! Chief Ingoo Ingoo not vote for you!','',0,0,0,0,0,0,0,0,1,19980,0,0,26124),
(70220,'Monkey King is a big big wikket!','',0,0,0,0,0,0,0,0,1,19980,0,0,26124),
(70221,'My sparkly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70222,'','It\'s best not to get on the bad side of those that prepare your food. However, I\'m not sure this patron has anything but a bad side...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70223,'','They say the eyes are the window to the soul. If that\'s the case, I\'m guessing this guest and their soul have something to hide.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70224,'','This guest wears a memento of a love lost. I guess it\'s true what they say; every love story has its thorns, just like every night has its dawn.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70225,'I\'m ready for the first clue.','I\'m ready for the first clue.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70226,'Ok, hit me with another clue!','Ok, hit me with another clue!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70227,'This is easy! I\'m ready for the next clue.','This is easy! I\'m ready for the next clue.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70228,'I got this! Give me the last clue.','I got this! Give me the last clue.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70230,'Assemble the Mallet.','Assemble the Mallet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70231,'Is this your drink order?','Is this your drink order?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70232,'You didn\'t happen to order a Rusty Dagger did you?','You didn\'t happen to order a Rusty Dagger did you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70233,'Does this drink belong to you?','Does this drink belong to you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70234,'','Why in the world would I order that?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70235,'','How dare you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70236,'','Who do you think you are?! The nerve!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70237,'','Finally! I thought I was never going to get my drink!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70238,'','Of course it\'s my drink! I invented this ya know!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70239,'','Who else would this belong to? What\'s that funny look for? You look like I was about to hit you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70240,'It\'s about time! I\'m parched over here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70241,'Now that is a sight for sore eyes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70242,'Now I can really get this party started!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70243,'Yuck! That looks disgusting!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70244,'I am offended that you would think that belongs to me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70245,'You know the service down here just keeps getting worse and worse!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70246,'','Get that out of here before you spill it on me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70247,'','The audacity!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70248,'','Look at me! Do I look like I would order that?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70249,'','Don\'t be ridiculous. Of course it\'s my drink!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70250,'','It\'s about time you showed up with this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70251,'','Took you long enough!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70252,'','Can\'t a girl just get a drink without being hassled?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70253,'','Something about watching people fight to the death really warms my heart!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70254,'There is not nearly enough dancing in this club!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70255,'','Can I get you something to drink?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70256,'So ye want me to go join the Alliance front in this... Pandaria... eh?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70257,'Fluffy wikkets stole the mallet head! Kunzen hozen lost it many years ago. Now the fluffy wikkets hide inside their lair and worship the head like it some kind of fancy shmancy carrot.$b$bBe careful, those fluffy wikkets bite hard.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70258,'','The Kirin-Tor has a legacy of abuse. Kel\'thuzad turned his knowledge of the arcane arts toward Necromancy.',0,0,0,0,0,0,0,0,7,0,0,34315,26124),
(70261,'Things are rarely what they seem, Tyrande. And my son tells me this is a sacred place.','',0,0,0,0,0,0,1,0,7,0,34688,0,26124),
(70262,'They\'re defending a fixed position. I\'m not going to play their game. We\'ll draw them out.','',0,0,0,0,0,0,1,0,7,0,34689,0,26124),
(70263,'You three are my eyes and ears. Fan out! Prepare a defense!','',0,0,0,0,0,0,397,0,1,0,34690,0,26124),
(70264,'Stay back! Don\'t let them lure you in.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70265,'Stay away from the temple doors, you\'re playing into their hands.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70266,'Ready our defenses. They have to come out eventually.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70267,'Stand your ground! Wait \'em out.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70268,'Get those defenses ready.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70269,'Use the terrain to our advantage.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70270,'We need to support one another. They\'ll target any weakness.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70271,'We\'re almost ready. Keep on working!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70272,'Force them into bottlenecks. Let them think they can win...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70273,'Don\'t charge in. Let them make the first mistake.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70274,'This terrain is ours. Make them pay for every inch.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70275,'Keep working! We\'ll win on our terms.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70276,'Make use of every resource! Leave them nowhere to run!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70277,'Patience, Tyrande.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70278,'Patience, Tyrande. We\'ll have our victory, but we\'re not going in unprepared.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70279,'I won\'t throw away Alliance lives. I will accept nothing less than total victory.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70280,'Good. That means they\'re about to break.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70281,'Good. The plan is coming together.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70282,'Good sturdy dwarven construction. That oughta do some damage.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70283,'I see our jinyu allies are prepared. How go the rest of the preparations?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70284,'Ahh, gnomish ingenuity! The Horde won\'t know what hit \'em.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70285,'Excellent work! Let\'s see what these pandaren homesteaders are capable of.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70286,'They\'re coming. Get behind the defenses!','',0,0,0,0,0,0,1,0,1,0,34703,0,26124),
(70287,'Come out and count them, coward!','',0,0,0,0,0,0,1,0,1,0,34704,0,26124),
(70288,'There is no army here. Only a handful of heroes stand between you and the King of Stormwind. Are you afraid?','',0,0,0,0,0,0,1,0,1,0,34705,0,26124),
(70289,'Predictable. Fall back behind the lines - let them come!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70290,'It was a costly victory, but it could have been much worse. You have earned this reward.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70291,'While we mourn the fallen, many more would be lost if not for your efforts. Please accept this gift of gratitude from the Alliance.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70292,'Very good work! Our defenses held with minimal casualties. Please accept this reward for your outstanding effort.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70293,'A total victory! Thanks to your resourcefulness and efficiency, we didn\'t lose a single soul. Accept this reward, along with my sincere gratitude.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70294,'The day is ours! And not a drop of blood was shed on holy ground.','',0,0,0,0,0,0,1,0,1,0,34655,0,26124),
(70295,'There was a time where I would have done the same. But I\'ve learned a lot over the years. I\'ve fallen for too many of Garrosh\'s tricks.','',0,0,0,0,0,0,1,0,1,0,34656,0,26124),
(70296,'From now on, we define the terms of the engagement.','',0,0,0,0,0,0,1,0,1,0,34657,0,26124),
(70297,'Tyrande, I may not be a politician. But I am a fighter. I know we can win this war.','',0,0,0,0,0,0,1,0,1,0,34658,0,26124),
(70298,'We just need to stand together. You have to trust me. Know that I will do the right thing. If we act as one, we cannot fail.','',0,0,0,0,0,0,1,0,1,0,34659,0,26124),
(70299,'','We have them cornered inside the temple. We should strike now!',0,0,0,0,0,0,1,0,7,0,0,34290,26124),
(70300,'','All the more reason to purify it.',0,0,0,0,0,0,1,0,7,0,0,34291,26124),
(70301,'','You are wasting precious time.',0,0,0,0,0,0,1,0,7,0,0,34292,26124),
(70302,'','We are wasting time. We should move in for the kill!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70303,'','You are being tentative, Varian. You must be decisive if you wish to lead the Alliance.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70304,'','Why do we not attack them outright?',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70305,'','They mock us from within the temple.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70306,'','Our fortifications are ready.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70307,'','I would have charged right in. Many more lives would have been lost in my rush for victory.',0,0,0,0,0,0,1,0,1,0,0,34279,26124),
(70308,'','I see that now. Our strength is yours to command, High King. May this be the first of many victories.',0,0,0,0,0,0,1,0,1,0,0,34280,26124),
(70309,'A test! A trial of patience. Will the wolf behave as a warrior... or a King?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70310,'A sword is the weapon of a warrior, but patience is the weapon of kings.','',0,0,0,0,0,0,1,0,1,0,34344,0,26124),
(70311,'This day brings victory, but more difficult trials lie ahead...','',0,0,0,0,0,0,1,0,1,0,34345,0,26124),
(70312,'Alliance dogs! Where are your teeth?','',0,0,0,0,0,0,1,0,1,0,34476,0,26124),
(70313,'Bring up the grunts. Attack!','',0,0,0,0,0,0,1,0,1,0,34477,0,26124),
(70314,'For the warchief!','',0,0,0,0,0,0,1,0,1,0,34469,0,26124),
(70315,'Is this how you fight your battles?','',0,0,0,0,0,0,1,0,1,0,34470,0,26124),
(70316,'Your Alliance is WEAK!','',0,0,0,0,0,0,0,0,1,0,34471,0,26124),
(70317,'I am done with you!','',0,0,0,0,0,0,1,0,1,0,34472,0,26124),
(70318,'Cowards!','',0,0,0,0,0,0,1,0,1,0,34473,0,26124),
(70319,'Pathetic.','',0,0,0,0,0,0,1,0,1,0,34474,0,26124),
(70320,'Is this your best?','',0,0,0,0,0,0,1,0,1,0,34475,0,26124),
(70321,'I... could only see darkness... Thank you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70322,'Light... what is this light? Bless you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70323,'Finally, an end to the suffering...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70324,'Trapped here... forever... am I... free at last?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70325,'My spirit leaves this cursed place at last...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70326,'At last, an end to the horror...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70327,'The Divine Bell means a great deal to the Horde.$b$bThe Warchief is counting on us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70328,'|TInterface\\Icons\\ability_thunderking_thunderstruck.blp:20|t%s begins to cast |cFFFF0000|Hspell:135096|h[Thunderstruck]|h|r! Run!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70329,'Tong! Something to eat, please.','',0,0,0,0,0,0,0,0,5,0,34610,0,26124),
(70330,'The High King. Varian Wrynn - Leader of the Alliance.','',0,0,0,0,0,0,0,0,5,0,34561,0,26124),
(70331,'Did you know, he was once a gladiator? Oh yes, I\'ve been doing my research.','',0,0,0,0,0,0,0,0,5,0,34562,0,26124),
(70332,'Suffering from amnesia, he fought for his life in Horde arenas.','',0,0,0,0,0,0,0,0,5,0,34563,0,26124),
(70333,'There, he earned the name \"Lo\'Gosh,\" or \"Ghost Wolf.\"','',0,0,0,0,0,0,0,0,5,0,34564,0,26124),
(70334,'He IS a fighter. But... is he a leader?','',0,0,0,0,0,0,0,0,5,0,34565,0,26124),
(70335,'Think about it! His enemies took advantage of my father\'s Cataclysm.','',0,0,0,0,0,0,0,0,5,0,34566,0,26124),
(70336,'Horde soldiers thundered across the realm in the wake of the devastation.','',0,0,0,0,0,0,0,0,5,0,34567,0,26124),
(70337,'Varian Wrynn didn\'t use the disaster to gain a military advantage.','',0,0,0,0,0,0,0,0,5,0,34568,0,26124),
(70338,'Is this because he is weak...? Or because he is principled?','',0,0,0,0,0,0,0,0,5,0,34569,0,26124),
(70339,'Here\'s the bigger question: Can principles win a war?','',0,0,0,0,0,0,0,0,5,0,34570,0,26124),
(70340,'Make no mistake. Pandaria will challenge your King.','',0,0,0,0,0,0,0,0,5,0,34571,0,26124),
(70341,'Let us see what he is truly made of.','',0,0,0,0,0,0,0,0,5,0,34572,0,26124),
(70342,'Let us see if your Alliance has what it takes to rule Azeroth.','',0,0,0,0,0,0,0,0,5,0,34573,0,26124),
(70343,'Garrosh Hellscream! Warchief of the Horde.','',0,0,0,0,0,0,0,0,5,0,34574,0,26124),
(70344,'He did not always command such power.','',0,0,0,0,0,0,0,0,5,0,34575,0,26124),
(70345,'On Draenor, he was a miserable wretch. The actions of his father hung heavy on his heart.','',0,0,0,0,0,0,0,0,5,0,34576,0,26124),
(70346,'I understand you, Garrosh. I know what it is like to bear the weight of your father\'s deeds.','',0,0,0,0,0,0,0,0,5,0,34577,0,26124),
(70347,'A warrior like Garrosh comes to power with something to prove.','',0,0,0,0,0,0,0,0,5,0,34578,0,26124),
(70348,'Your Horde finds itself at a turning point. This war will define you.','',0,0,0,0,0,0,0,0,5,0,34579,0,26124),
(70349,'What IS the Horde?','',0,0,0,0,0,0,0,0,5,0,34580,0,26124),
(70350,'Is it an instrument of vengeance, hellbent to carve out a future for its people?','',0,0,0,0,0,0,0,0,5,0,34581,0,26124),
(70351,'Is it a refuge for those who need shelter, a commonwealth of the downtrodden, built for mutual support?','',0,0,0,0,0,0,0,0,5,0,34582,0,26124),
(70352,'Or is it an alliance of convenience, a confederacy of unlikely partners free to pursue their own agendas?','',0,0,0,0,0,0,0,0,5,0,34583,0,26124),
(70353,'This is my question to you: What is the SOUL of the Horde?','',0,0,0,0,0,0,0,0,5,0,34584,0,26124),
(70354,'We will find the answers here in Pandaria.','',0,0,0,0,0,0,0,0,5,0,34585,0,26124),
(70355,'Show me what your Horde is made of, Champion!','',0,0,0,0,0,0,0,0,5,0,34586,0,26124),
(70356,'Prove to me that your Horde is worthy of ruling over Azeroth.','',0,0,0,0,0,0,0,0,5,0,34587,0,26124),
(70357,'You have proven to be an exemplary hero. A champion for your cause.','',0,0,0,0,0,0,0,0,5,0,34588,0,26124),
(70358,'Do you recall our earlier conversation?','',0,0,0,0,0,0,0,0,5,0,34589,0,26124),
(70359,'We discussed the merits of your High King. I have been observing him closely.','',0,0,0,0,0,0,0,0,5,0,34590,0,26124),
(70360,'It is true: he has the spirit of the wolf. And he fights like a wolf.','',0,0,0,0,0,0,0,0,5,0,34591,0,26124),
(70361,'Having seen him in action, I now know what that means.','',0,0,0,0,0,0,0,0,5,0,34592,0,26124),
(70362,'Wolves are pack animals.','',0,0,0,0,0,0,0,0,5,0,34593,0,26124),
(70363,'Your King is calling his pack to him, assembling an Alliance in the truest sense of the word.','',0,0,0,0,0,0,0,0,5,0,34594,0,26124),
(70364,'His journey is long. He has only taken the first steps.','',0,0,0,0,0,0,0,0,5,0,34595,0,26124),
(70365,'But with heroes like you in his pack, there is little your Alliance cannot accomplish.','',0,0,0,0,0,0,0,0,5,0,34596,0,26124),
(70366,'Tong: fetch my things!','',0,0,0,0,0,0,0,0,5,0,34597,0,26124),
(70367,'Your dedication to your cause deserves to be rewarded.','',0,0,0,0,0,0,0,0,5,0,34598,0,26124),
(70368,'Like you, I continue to refine my skills here in Pandaria. I think you will appreciate the outcome.','',0,0,0,0,0,0,0,0,5,0,34599,0,26124),
(70369,'Choose your reward!','',0,0,0,0,0,0,0,0,5,0,34600,0,26124),
(70370,'Stay vigilant, hero. The return of the Thunder King is both a threat... and an opportunity!','',0,0,0,0,0,0,1,0,5,0,34601,0,26124),
(70371,'You have proven to be an exemplary hero. A champion for your cause.','',0,0,0,0,0,0,0,0,5,0,34602,0,26124),
(70372,'Do you recall our earlier conversation?','',0,0,0,0,0,0,0,0,5,0,34603,0,26124),
(70373,'We spoke of your Warchief. His inner conflicts and his outer conquests.','',0,0,0,0,0,0,0,0,5,0,34604,0,26124),
(70374,'I asked you: Who is the soul of the Horde?','',0,0,0,0,0,0,0,0,5,0,34605,0,26124),
(70375,'Your efforts on Pandaria\'s southern shores and elsewhere have given me my answer.','',0,0,0,0,0,0,0,0,5,0,34606,0,26124),
(70376,'YOU are the soul of the Horde.','',0,0,0,0,0,0,0,0,5,0,34607,0,26124),
(70377,'Your actions in the coming weeks will come to define your people.','',0,0,0,0,0,0,0,0,5,0,34608,0,26124),
(70378,'I want to make sure that you are properly equipped for the trials ahead.','',0,0,0,0,0,0,0,0,5,0,34609,0,26124),
(70379,'Welcome back, hero of the Alliance! How fares the battle along the coast?','',0,0,0,0,0,0,6,0,5,0,34557,0,26124),
(70380,'Have you killed him? Bloodhilt served the Horde in Southern Barrens. You\'ve avenged a great many lives today, champion.','',0,0,0,0,0,0,6,0,5,0,34558,0,26124),
(70381,'Welcome back, champion of the Horde! How fares the battle along the coast?','',0,0,0,0,0,0,6,0,5,0,34559,0,26124),
(70382,'So, General Twinbraid is dead? He was a pivotal figure in the Alliance push through Southern Barrens. Impressive work.','',0,0,0,0,0,0,6,0,5,0,34560,0,26124),
(70383,'','Stay vigilant, hero. This place has been sealed for centuries. Who knows what we will encounter within.',0,0,0,0,0,0,0,0,1,0,0,34460,26124),
(70384,'','There it is, hero! The Divine Bell!',0,0,0,0,0,0,0,0,1,0,0,34461,26124),
(70385,'','What was that thing? No matter. We will strike down any who stand in our way.',0,0,0,0,0,0,0,0,1,0,0,34463,26124),
(70386,'','We must take it somewhere safe. Sentinels! Let\'s get to work.',0,0,0,0,0,0,0,0,1,0,0,34462,26124),
(70387,'','Horde. It\'s a shame you were so slow to get here. The Divine Bell is already ours. Rangers! STRIKE!',0,0,0,0,0,0,0,0,1,0,0,34453,26124),
(70388,'','Arg! My archers should have stopped you! Sentinels! Now!',0,0,0,0,0,0,0,0,1,0,0,34454,26124),
(70389,'','Very well. I will face you myself. This is for the Alliance!',0,0,0,0,0,0,0,0,1,0,0,34455,26124),
(70390,'','My death... means... nothing. The Divine Bell is already in Darnassus. You filthy Horde... will never... have it!',0,0,0,0,0,0,0,0,1,0,0,34459,26124),
(70391,'','Denizens of the sky, attack!',0,0,0,0,0,0,0,0,1,0,0,34456,26124),
(70392,'','You will die here, by my blade!',0,0,0,0,0,0,0,0,1,0,0,34457,26124),
(70393,'','I strike from the shadows!',0,0,0,0,0,0,0,0,1,0,0,34458,26124),
(70394,'How did that story go again?','How did that story go again?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70395,'LOUD NOISES!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70396,'No! Monkey King no take rod! You no take rod! This not even real Monkey King.$b$bChief Ingoo Ingoo have rod from father Ingoo Ingoo, and his father before him, and his father before him.$b$bMonkey King give rod to my family in long long ago time. My family becomes chiefs.$b$bNo hozen live that long! None!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70397,'But that is the real Monkey King.','But that is the real Monkey King.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70398,'Time is of the essence, $n. Proveditor Grantley may be able to help you get back to Stormwind. Of course, everything has a price.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70399,'Poor Chief Ingoo Ingoo. His family forget what rod was for. He so mad.$b$bIf he keeps, he will corrupt his people. Very sad.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70400,'','Be silenced, Sunreaver!',0,0,0,0,0,0,0,0,1,0,0,34297,26124),
(70401,'','The Kirin Tor will not tolerate insurrection.',0,0,0,0,0,0,0,0,1,0,0,34298,26124),
(70402,'','You brought this on yourselves, Sunreavers.',0,0,0,0,0,0,0,0,1,0,0,34299,26124),
(70403,'','You had your chance to run.',0,0,0,0,0,0,0,0,1,0,0,34300,26124),
(70404,'','Dalaran is a better place without your kind.',0,0,0,0,0,0,0,0,1,0,0,34301,26124),
(70405,'','Did you think your actions would have no consequence?',0,0,0,0,0,0,0,0,1,0,0,34302,26124),
(70406,'','You chose your warchief over the Kirin-Tor.',0,0,0,0,0,0,0,0,1,0,0,34303,26124),
(70407,'Now... YOU must die!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70408,'Enter the portal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70409,'There once was a jibby nib mallet all shiny and divine.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(70410,'But the ookin\' bell it was meant for could never be mine.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(70411,'The mogu had stolen the bell, what is a hozen to do?','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(70412,'Think of the horror if those dookers stole the mallet too.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(70413,'Mogu are not bright, they fail to see things for what they are.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(70414,'The Monkey King broke the mallet and sent the pieces afar.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(70415,'My Hozen took the pieces and scattered them across the lands,','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(70416,'Disguised as \"nifty nibs\", never to fall into mogu hands.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(70417,'The head, the handle, these two must be made as one.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(70418,'Combined with evil\'s ointment, the bell\'s evil can be undone.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(70419,'If \"Garrosh\" has the bell than there is only one thing to do,','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(70420,'I\'ll send for my hozen friends, the mallet must be made anew.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(70421,'[PH] Some insult about how the Alliance is weak and boast about how Garrosh is awesome.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70422,'Do not incite violence on my temple grounds, $p. Be patient.','Do not incite violence on my temple grounds, $p. Be patient.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70423,'','Varian sent me to keep an eye on the temple while you finish building the defense.\n\nHave a little patience and don\'t approach the temple until Varian gives the word.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70424,'','Greetings, friend.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70425,'We are to surround the temple with defenses. Can your druids help?','We are to surround the temple with defenses. Can your druids help?',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(70427,'','Come children. May Elune guide our deeds this day.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70428,'This smells like a trap, but we have no time to lose. Let\'s go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70429,'','Meet us west of the temple, $rt. We shall require your aid.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70431,'It just so happens that Mishi returned it to me. You should be more careful! This artifact is a rare one of a kind piece.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70432,'Do you honestly believe you can defeat me?','Do you honestly believe you can defeat me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70433,'Another challenge?','Another challenge?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70435,'We have a winner!  $n has won SECOND PLACE in the tournament!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70436,'We have a winner!  $n has won THIRD PLACE in the tournament!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70437,'|TInterface\\Icons\\spell_arcane_massdispel.blp:20|t |cFFFF0000|Hspell:132275|h[Obliteration]|h|r killed you. Move out of the energy vortex before it deactivates.','|TInterface\\Icons\\spell_arcane_massdispel.blp:20|t |cFFFF0000|Hspell:132275|h[Obliteration]|h|r killed you. Move out of the energy vortex before it deactivates.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70439,'Some day we\'re havin\', eh?\n\nMe poor gryphons...','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(70440,'Fight with us. |cFF0008E8(Daggin will follow you.)|r','Fight with us. |cFF0008E8(Daggin will follow you.)|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70441,'Let\'s do this!','',0,0,0,0,0,0,71,0,1,0,0,0,26124),
(70448,'Move along. This doesn\'t concern you.','Move along. This doesn\'t concern you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70449,'You\'ll stay out of this if you know what\'s good for you.','You\'ll stay out of this if you know what\'s good for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70450,'Can you believe this? These Silver Covenant goons are trying to shake us down.','Can you believe this? These Silver Covenant goons are trying to shake us down.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70451,'I heard shouting through the pipes - what\'s happening?','I heard shouting through the pipes - what\'s happening?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70452,'What is all this nonsense about a\"purge?\"','What is all this nonsense about a\"purge?\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70453,'Heya! I\'m Tak-Tak. I\'ll take you to the Vale now, just like the big green guy over there told me to.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70454,'Wait an ookin\' jibbet! Are you the wikket dat cleared the beach of jerb-derkin\' Alliance slicky-siders?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70455,'There I was, minding my own business, enjoying a nice game of cards when these Silver Covenant... slugs came around telling us to hand over our belongings. What gives?','There I was, minding my own business, enjoying a nice game of cards when these Silver Covenant... slugs came around telling us to hand over our belongings. What gives?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70456,'Have the Silver Covenant lost their mind? Surely the Kirin Tor won\'t stand for this!','Have the Silver Covenant lost their mind? Surely the Kirin Tor won\'t stand for this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70457,'They said Lady Proudmoore wanted us out. I... I don\'t understand.','They said Lady Proudmoore wanted us out. I... I don\'t understand.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70458,'It\'s not safe here anymore. You need to evacuate Dalaran.','It\'s not safe here anymore. You need to evacuate Dalaran.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70459,'You did all of that? You bammin\'!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70460,'You know, big brown guy was lookin\' for a trip up north earlier. Some Garrod... err... Ganosh... err... anyway, I didn\'t get his name.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70461,'He looked real important. Tak-Tak try to chitchatter with \'im, but he jus\' stared at me so I shut my jabber real quick.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70462,'Well, if you say so.','As long as you\'ve got my back...',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(70463,'Oh, looks like we\'re here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70464,'Good luck out there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70465,'We meet again. You havin\' a good day now?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70466,'Anyway, Tak-Tak hear a lot of stuff goin\' on at the camp. I heard that your Warchief Garrosh was lookin\' around the Vale o\' Eternal Blossoms.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70467,'Did you and the pretty elves find somethin\' while you was there?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70468,'I heard somethin\' about a bell, made by those crazy mogu... thousands of years ago. Jimeny wikkets!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70469,'I guess I can head back to Silvermoon...','Leave Dalaran? Where will I even go...',0,0,0,0,0,0,547,0,1,0,0,0,26124),
(70470,'Is yer Warchief gonna look fer that bell now? Anything mogu is dangerous... an\' powerful.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70471,'Anyway, we\'re almost to Binan Village. You mus\' be doin\' somethin\' real ookin\' important.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70472,'A big pandaren came and asked me to take you there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70473,'Don\'t tell anyone where you\'re goin\', he said!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70474,'Tak-Tak good on his word. Tak-Tak been real quiet. Me helpful!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70475,'Ok, we\'re here. Get out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70476,'Headin\' back up to Kun-Lai Summit, wikket?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70477,'Last time we met, you were headin\' to Binan Village to see your pandaren friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70478,'Did you get your business done?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70479,'Anyway, I saw some more pretty elves headin\' north earlier. Lots of elves.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70480,'They\'re lookin\' for that bell. Big, powerful bell! You lookin\' for it too, wikket?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70481,'This is an outrage! Aethas will hear about this!','Fine, but I\'m taking this straight to the Archmage.',0,0,0,0,0,0,412,0,1,0,0,0,26124),
(70482,'Here we are. See ya!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70483,'Ooh, big stuff\'s shakin\'.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70484,'I heard some pretty elfs got slap-slapped up at Mogujia.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70485,'Say, wasn\'t you there? Did you see it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70486,'Anyway, big elf leader, Lor\'them-somethin\'... he\'s real mad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70487,'The blood elves weren\'t prepared to fight the Korune mogu. Lotta blood elves died, but I heard you saved many survivors.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70488,'Sure. I was getting tired of this sewer anyway.','Don\'t have to tell me twice - I\'ve got debts in this city I\'d like to leave behind.',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(70489,'You probably askin\', then what happen?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70490,'Well then what happen is ranger elf\'s people got jerbed in the nerb! Ouch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70491,'He mad, bro, real mad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70492,'He\'s still loyal to your Warchief, but he wants to do things differently.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70493,'Garrosh all about strength! Lor\'themar all about strategy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70494,'Even a simple hozen like Tak-Tak can see that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70495,'Oh look, we are here. Later!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70496,'So how did your trip to the Valley of Emperors go, wikket?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70497,'It\'s cold up there. And dangerous!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70498,'Too many mogu. Only our foolish mountain hozen cousins live up there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70499,'They so ookin\' stupid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70500,'I heard you found somethin\'... or someone. You caught one o\' those mogu, didn\'t you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70501,'Maybe nasty mogu tell you where to find that bell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70502,'Thank you for the warning. Be safe.','I will go. Shorel\'aran.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(70503,'Tak-Tak also hear mogu using dark magic.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70504,'Hozen call it... ikk! You call it sha, but ikk is SO much better name!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70505,'Anyways, those crazy mogu using ikk juju.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70506,'Even foolish hozen know ikk is worse than anything. Don\'t eat dook, don\'t touch ikk!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70507,'You think ookin\' is nasty word? You ain\'t ikkin\' know anything.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70508,'I ain\'t flyin\' a kite to Silvermoon City! You crazy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70509,'Yo.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70510,'I ain\'t seen you in a lick, wikket. How you been?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70511,'Tak-Tak been listenin\'. Everybody think oh, Tak-Tak is a stupid hozen, he don\'t know anything.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70512,'But Tak-Tak know a lot about things!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70513,'Even big orc general, Nazgrim! He talk so loud! Tak-Tak hear everything!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70514,'Tak-Tak know this...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70515,'Lor\'themar elf ranger thinkin\' about leavin\' the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70516,'Baine wonderin\' if Garrosh might not be fit for chief.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70517,'And Garrosh is losin\' patience over findin\' that ookin\' bell. Those mogu hide it good!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70518,'I hear, Garrosh is goin\' to torture that mogu prisoner until he talks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70519,'Anyway, you goin\' that way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70520,'You should not have interfered!','You don\'t belong here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70521,'Tell me if you find anything out, buddy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70522,'You know, they sayin\' your name all over camp!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70523,'And me, Tak-Tak, me is your friend! Bam!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70524,'Horde at camp buzzin\'. Everybody workin\'.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70525,'Since you saw Shan Kien\'s memory, they been sendin\' scouting parties out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70526,'And now, it looks like they found where the mogu hid that bell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70527,'Good luck. I hope you find that bell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70528,'I\'m not flying a kite to Darnassus, wikket. I don\'t even know where that is! Take that portal over there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70529,'You think I know where Dalaran is, $Gbuddy:lady;? I can\'t even find my own tail! Sometimes it\'s there, sometimes it isn\'t.$B$BYou know what I heard though, $n?$B$BDook\'s got real since last time.$B$BI heard you went to Darnassus and got the Divine Bell.$B$BBut some human lady... Jana or somethin\'... she got real mad!$B$BShe says the Horde betrayed her trust or something\'... and she\'s kickin\' all your people out of her city!$B$BOrc general Nazgrim say we need to help them vacuum... vacuate... err... evocate... err... get the ook out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70530,'Dook\'s got real since last time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70531,'I heard you went to Darnassus and got the Divine Bell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70532,'But some human lady... Jana or somethin\'... she got real mad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70533,'But some human lady... Jana or somethin\'... she got real mad!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70534,'Orc general Nazgrim say we need to help them vacuum... vacuate... err... evocate... err... get the ook out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70535,'I got a bad feelin\' about this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70536,'Your Warchief has got that bell, and he\'s goin\' to use it to make the Horde stronger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70537,'But I think that bell has got some power... and it\'s bad.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70538,'It jerbs the nib right outta my derb!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70539,'Nobody, not hozen, not human, not orc... should use the sha.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70540,'Ikk\'s gonna hit da land.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70541,'Be careful.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70542,'I hope I see you again, friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70543,'They attacked our ships from below, and will advance on the keep at any moment!\n\nWe don\'t have the numbers to stop them...','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(70544,'Fight with us. |cFF0008E8(Admiral Taylor will follow you.)|r','Fight with us. |cFF0008E8(Admiral Taylor will follow you.)|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70545,'We\'ll hold Lion\'s Landing or die trying!','',0,0,0,0,0,0,113,0,1,0,0,0,26124),
(70546,'What do you think you\'re doing?','Stop right there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70547,'Halt!','That\'s enough of your meddling!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70548,'Silence!','Stay out of this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70549,'Just who do you think YOU are?','Very sweet of you - now DIE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70550,'The Sunreavers are scum!','For the Silver Covenant!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70551,'Interference will not be tolerated!','You want some, too? Very well!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70552,'Can the Kirin Tor really kick us out like this?','How could this happen?',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(70553,'I think it may be time to bring my swords out of retirement...','They\'ll pay for this.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(70554,'I need to get to Dalaran.','I need to get to Dalaran.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70555,'Move quickly, but carefully, $n. We don\'t have much time, but this mission dies if you do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70556,'I would like to go to Krasarang Wilds.','I would like to go to Krasarang Wilds.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70559,'','Come on, girls. You\'ve had your share of meat for the day.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70560,'So long, Dalaran...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70561,'Thank you, $n. See you in Silvermoon...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70562,'I hope the Horde has a place for another mage...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70563,'','Jaina is taking away my home by force? I\'ll remember this...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70564,'What\'re ye lookin\' at? Is it m\'shoes?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70565,'I need a portal to Darnassus.','I need a portal to Darnassus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70566,'','Hello, $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70567,'Let\'s go get the bell.','Let\'s go get the bell.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70568,'Take me to the Shrine of Two Moons.','Take me to the Shrine of Two Moons.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70569,'Take me to Binan Village.','Take me to Binan Village.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70570,'Take me to Mogujia.','Take me to Mogujia.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70571,'Take me to the Valley of Emperors.','Take me to the Valley of Emperors.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70572,'Take me to Garrosh\'ar Advance.','Take me to Garrosh\'ar Advance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70573,'Take me to the Ruins of Korune.','Take me to the Ruins of Korune.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70574,'Take me to Emperor\'s Reach.','Take me to Emperor\'s Reach.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70575,'','Ooof! Well I sure am in a tizzy today. Got eighty irons in tha fire just abouts!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70576,'','Hilda\'s left all the documentin\' to me. Ye know that fer every artifact we find, I\'ve got six forms ta fill out? Whaddaya we need all these forms fer, I ask!?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70577,'','As if I ain\'t got enough on me hands, those dwarves at the mines\'ve gotten all crazy recently about some new drink called kafa.$B$BThey\'re insistin\' I bring \'em fresh cups o\' kafa every mornin\'!$B$BDo they know wot I \'ave ta do to get those kafa beans? Honestly!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70578,'','I\'m up ta me pretty knickers in ad-mino-strative duties, but wot else is new?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70579,'','Oh my. Ye must be the hero that everyone\'s been tellin\' me about.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70580,'','Oops, how do ye fly one o\' these things? Fer light\'s sake! Ye crummy piece o\' whackery, WORK!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70581,'','Sorry, I\'m still gettin\' the hang o\' things \'round here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70582,'','My older sister, Hilda, told me to expect ye.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70583,'','She won\'t let me go down to the excavation, so I\'ve become somethin\' o\' a personal assistant and chauffeur.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70584,'','Anyway, I met that SI:7 agent that you brought back outta retirement.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70585,'','Agent Connelly, ain\'t it? That man\'s got some charm... and some nerve! His sweet words made me blush ten ways out of Ironforge!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70586,'','He\'s out in the field now, and waitin\' fer ya special.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70587,'','I\'m takin\' you close ta a Horde encampment though, so you\'d best be on yer guard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70588,'','Let Connelly know that Fennie\'s askin\' about him!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70589,'','You lookin\' ta go to Dalaran? Heard the Lady Jaina Proudmoore herself\'s expectin\' ye! Go on through the mage portal down the path.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70590,'','Well, we meet again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70591,'','I trust that ye\'re well and good?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70592,'','Have ye heard all the buzz that\'s been going \'round Lion\'s Landing?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70593,'','I heard that the Horde\'s learned of an ancient mogu artifact... somethin\' called the Divine Bell.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70594,'','That bell\'s capable of turning a normal army into killin\' machines!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70595,'','No one knows where the artifact was hidden, but the Horde\'s doing anything they can ta get their hands on it first.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70596,'','The Reliquary is hot on the trail o\' that bell at Mogujia.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70597,'','I\'ll be a snot-nosed ninny if we don\'t beat \'em to the punch!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70598,'','I can\'t do much since I\'m just Hilda\'s assistant, but ye can. I hope ye can find out what they\'re up to.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70599,'','Here we are.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70600,'','Go wreck those Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70601,'','I\'m supposed to get ye to the Shrine o\' Seven Stars.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70602,'','The young Prince Anduin\'s been askin\' after ya.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70603,'','After the excavation trip to Mogujia, the Explorer\'s League brought their findings back to our city in the Vale o\' Eternal Blossoms.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70604,'','They\'ve been studying the relics that the blood elves were stealin\'.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70605,'','I\'m not supposed ta say anything \'bout this, but ye\'ve got a face that says ye like a good Dwarven stout, so I trust ye!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70606,'','Those mogu belong to a tribe called the Korune.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70607,'','From the looks o\' it, the Korune were loyal to the Thunder King, thousands o\' years ago... before even the pandaren came to rule this land.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70608,'','They worked from the shadows, and get this... somehow, they managed to master the sha.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70609,'','If the Korune were capable of such a feat, ain\'t no wonder Garrosh is after their knowledge!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70610,'','Imagine what would happen if that knotty-pated axe-bludgeoner Garrosh could manipulate the sha to his bidding.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70611,'','Makes me shudder even ta think.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70612,'','Here you go. Good luck!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70613,'','Howdy. How are ye today?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70614,'','After I dropped ye off last time, I heard there was some kind of sha infectin\' our soldiers at the Shrine of Seven Stars.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70615,'','If ye and Prince Anduin hadn\'t been there, we could all be turnin\' on each other, lettin\' our anger get the best o\' us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70616,'','I also heard that King Varian swore he would never use the sha to no good.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70617,'','Maybe Varian ain\'t such a sour grape after all! Good ta see our King show some heart.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70618,'','Anyway, Agent Connelly sent me word to bring ya to him in Kun-Lai Summit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70619,'','Sounds like the Horde are close to finding the location o\' that Divine Bell, and that ain\'t no good.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70620,'','You\'d better meet up with him in the field and see what Garrosh is up to.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70621,'','Good luck!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70622,'','Get on the kite, quick!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70623,'','We ain\'t got no time ta lose.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70624,'','We\'ve been lookin\' all over Kun-Lai Summit fer a place that matches what ye saw in that mogu\'s memory, and we finally found the Korune\'s hidin\' place.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70625,'','If we don\'t get to that Divine Bell first, that lizard-livered nut-brain Garrosh will. I don\'t much fancy fightin\' a Horde that commands the power o\' the bleepin\' sha.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70626,'','Commander Skyglaive is already workin\' with a team of Explorer\'s League archaeologists at the dig site.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70627,'','We\'re sendin\' out our best, and that means you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70628,'','Here we are. There\'s no time to waste.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70629,'','Good luck!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70630,'','I ain\'t flyin\' no kite to Dalaran! I don\'t even know where Jaina moved the city! Ye\'d best take the portal over there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70631,'','I ain\'t flyin\' no kite to Darnassus! I can barely navigate that thing in the mountains. Ye think we\'d last over an entire ocean? Ye\'d best talk to Seamus Goldenkicks over there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70632,'','Hey, Admiral Taylor asked me to hitch you a ride up to the Valley o\' Emperors.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70633,'','Lucky fer you, I\'m Prince Anduin\'s best gal. We\'re friends, but don\'t go tellin\' Agent Connelly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70634,'','That man\'s bound ta get all jealous, an\' I don\'t want him poppin\' a cap inta the royal son.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70635,'','Anyway, I know right where the Prince is hidin\', so I\'ll take ye right to \'im.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70636,'','Can\'t say I approve o\' the boy roamin\' round by himself, but I can understand his thinkin\'.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70637,'','I still cannae believe the Horde stole the Divine Bell, after everything we did to keep it safe in Darnassus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70638,'','I heard that Lady Jaina\'s still in shock about what happened.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70639,'','She was ready ta forgive the Horde fer the destruction o\' Theramore.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70640,'','She was ready ta forge a new future for the Kirin Tor, one where the Horde-allied Sunreavers and the Alliance-sided Silver Covenant could work together in peace.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70641,'','I heard her say it meself - that Dalaran would be a shining example of peace \'tween Alliance an\' Horde fer the rest o\' the world.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70642,'','Then the Sunreavers betray her trust and open portals straight ta the Bell from her own city!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70643,'','Course she\'s goin\' ta feel upset. Course she\'s got a right to throw those nasty Sunreavers out o\' Dalaran.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70644,'','Still, I can\'t help but get an uneasy feelin\' that the Horde ain\'t goin\' to take that quietly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70645,'','And now, Garrosh has the Divine Bell. He could attack us any day!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70646,'','I hope Anduin\'s got some plan up his sleeve.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70647,'','Good luck.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70648,'','It\'s about time ye showed up. Doomsday is a comin\'.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70649,'','Garrosh is amassing his troops on the northern side of Kun-Lai Summit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70650,'','He\'s going to use the Divine Bell, and Light help us if we can\'t stop \'im in time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70651,'','Anduin went on ahead. That cheeky, light-spoutin\', clod-brained fool!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70652,'','Boy\'s naive enough ta think he can change the Horde \'an save the world... but... he\'s still just a child.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70653,'','Ye\'ve either got to stop the boy or help him... one o\' the two!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70654,'','We\'re amassin\' an army to head Garrosh off, but that will take time, and the Prince may already be in danger.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70655,'','Oh, why can\'t this dang kite go faster?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70656,'','Quick - they haven\'t spotted us yet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70657,'','I\'ll go back fer reinforcements.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70658,'','Whatever ye do today, hero, ye\'re doin\' fer all the Alliance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70659,'Bah! I had my whole paycheck riding on that one!','Bah! I had my whole paycheck riding on that one!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70660,'No! NO NO NO!','No! NO NO NO!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70661,'I LOSE? NO YOU LOSE!','I LOSE? NO YOU LOSE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70662,'It was supposed to be a sure thing! I BET EVERYTHING!','It was supposed to be a sure thing! I BET EVERYTHING!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70663,'HOW THE... WHAT THE...  DAMMIT!','HOW THE... WHAT THE...  DAMMIT!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70664,'','Let\'s take this show on the road and go wreck up Stormwind!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70665,'','This place is packed! We should all team up and go kick Varian in his pretty little face!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70666,'','If you\'re so thirsty for blood, why not group up and go tear apart Stormwind?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70667,'','Portal\'s up! Get in there and show \'em how the Horde do it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70668,'','I\'ve opened a portal to Stormwind.  Get in there and kick some butt!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70669,'','The portal to Stormwind is good to go!  Get in!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70670,'This place is packed to the rafters with Alliance all-stars!  Let\'s go tear apart Orgrimmar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70671,'You folks want violence and bloodshed? Let\'s go take it to the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70672,'This practice is all fine and dandy, but Orgrimmar won\'t smash itself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70673,'I\'ve made a portal to Orgrimmar. Who wants to kick some Horde butt?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70674,'Orgrimmar portal open, Brawl fans!  Tell \'em Bubbles sent ya.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70675,'Did someone order a portal to Orgrimmar? No? TOO BAD!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70676,'%s can now be put to sleep.','',0,0,0,0,0,0,0,0,1,20081,0,0,26124),
(70677,'Take me to Fire Camp Bataar.','Take me to Fire Camp Bataar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70678,'Take me to Dalaran.','Take me to Dalaran.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70679,'Take me to Mogujia.','Take me to Mogujia.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70680,'Take me to the Shrine of Seven Stars.','Take me to the Shrine of Seven Stars.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70681,'Take me to Garrosh\'ar Advance.','Take me to Garrosh\'ar Advance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70682,'Take me to the Ruins of Korune.','Take me to the Ruins of Korune.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70683,'Take me to Darnassus.','Take me to Darnassus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70684,'Take me to the Valley of Emperors.','Take me to the Valley of Emperors.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70685,'Take me to Emperor\'s Reach.','Take me to Emperor\'s Reach.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70686,'|cff0000ffRank 1:|r\n  Goredome: $7367w-$7368w\n  Sanoriak: $7381w-$7382w\n  Smash Hoofstomp: $7407w-$7408w\n  Akama: $7397w-$7398w\n\n|cff0000ffRank 2:|r\n  Dippy: $7379w-$7380w\n  Kirrawk: $7389w-$7390w\n  King Kulaka: $7415w-$7416w\n  Fran & Riddoh: $7377w-$7378w','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70687,'|cff0000ffRank 3:|r\n  Blat: $7371w-$7372w\n  Vian the Volatile: $7365w-$7366w\n  Ixx: $7383w-$7384w\n  Mazhareen: $7395w-$7396w\n\n|cff0000ffRank 4:|r\n  Tyson Sanders: $7873w-$7874w\n  Nibbleh: $8034w-$8033w\n  Dominika the Illusionist: $7391w-$7392w\n  Meatball: $7425w-$7426w','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70688,'|cff0000ffRank 5:|r\n  Big Badda Boom: $8032w-$8031w\n  Millie Watt: $7393w-$7394w\n  Bruce: $7363w-$7364w\n  Leper Gnome Quintet: $7373w-$7374w\n\n|cff0000ffRank 6:|r\n  Proboskus: $7421w-$7422w\n  Doctor FIST: $8036w-$8035w\n  Unguloxx: $7419w-$7420w\n  Yikkan Izu: $7403w-$7404w','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70689,'|cff0000ffRank 7:|r \n  GG Engineering: $7411w-$7412w\n  Dark Summoner: $7413w-$7414w\n  Battletron: $7375w-$7376w\n  Ahoo\'ru: $8038w-$8037w','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70690,'Hey there, lucky. You like numbers?$b$bI keep track of all the fights around here. I can tell you how many fights each of the challengers won.$b$bMight come in handy, especially if you wanna... I dunno... predict the winner of one of these fights, for some... monetary benefit. You catch my drift?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70691,'View records for Rank 1-2 bosses.','View records for Rank 1-2 bosses.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70692,'View records for Rank 3-4 bosses.','View records for Rank 3-4  bosses.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70693,'View records for Rank 5-6 bosses.','View records for Rank 5-6 bosses.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70694,'View records for Rank 7 bosses.','View records for Rank 7 bosses.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70695,'Go back.','Go back.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70696,'|cff0000ffRank 1:|r\n  Goredome: $7431w-$7432w\n  Sanoriak: $7445w-$7446w\n  Smash Hoofstomp: $7471w-$7472w\n  Akama: $7461w-$7462w\n\n|cff0000ffRank 2:|r\n  Dippy: $7443w-$7444w\n  Kirrawk: $7453w-$7454w\n  King Kulaka: $7479w-$7480w\n  Fran & Riddoh: $7441w-$7442w','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70697,'|cff0000ffRank 3:|r\n  Blat: $7435w-$7436w\n  Vian the Volatile: $7429w-$7430w\n  Ixx: $7447w-$7448w\n  Mazhareen: $7459w-$7460w\n\n|cff0000ffRank 4:|r\n  Tyson Sanders: $8066w-$8065w\n  Nibbleh: $8074w-$8073w\n  Dominika the Illusionist: $7455w-$7456w\n  Meatball: $7489w-$7490w','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70698,'|cff0000ffRank 5:|r\n  Big Badda Boom: $8072w-$8071w\n  Millie Watt: $7457w-$7458w\n  Bruce: $7427w-$7428w\n  Leper Gnome Quintet: $7437w-$7438w\n\n|cff0000ffRank 6:|r\n  Proboskus: $7485w-$7486w\n  Doctor FIST: $8076w-$8075w\n  Unguloxx: $7483w-$7484w\n  Yikkan Izu: $7467w-$7468w','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70699,'|cff0000ffRank 7:|r\n  GG Engineering: $7475w-$7476w\n  Dark Summoner: $7477w-$7478w\n  Battletron: $7439w-$7440w\n  Ahoo\'ru: $8078w-$8077w','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70700,'Warlord Bloodhilt prepares a Bloodthirsty Strike!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70701,'Hey $c, you looking to go to Stormwind? Travel fast with one of my portals! If you ain\'t got the commissions, you\'ll have to get there on your own.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70702,'Take me to Silvermoon City.','Take me to Silvermoon City.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70703,'Take me to Darnassus.','Take me to Darnassus.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70704,'','I have long waited for an opportunity to deal with the Sunreavers. I asked my late husband to remove them from the city, but he believed too firmly in the neutrality of the Kirin Tor.$b$bHe was wise, but he was short-sighted. This has always been the destiny of the Kirin Tor: to serve the Alliance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70705,'I\'m ready to return to Pandaria.','I\'m ready to return to Pandaria.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70706,'Night Elf Construction Site Under Attack!','Night Elf Construction Site Under Attack!',0,0,0,0,0,0,30,0,1,0,34768,34768,26124),
(70707,'Our ships! What in the name o\' me beard happened?!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(70708,'Free at last! And now to be rid of you filthy hozen rebels.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70709,'You are next in line!','You are next in line!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70710,'The... Empire... will rise again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70711,'I\'ll scribble you out of existence!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70712,'You\'ll have to wrench me out of here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70713,'','For the Sunreavers!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70714,'','So it\'s come to this, eh?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70715,'Blast... the Silver Covenant\'s here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70716,'Here goes nothing. My research did not have nice things to say about this Jade Warlord. Be ready for battle.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(70717,'Is thish room is shpinning?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70718,'... *burp*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70719,'I shpilled me drink!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70720,'','Buy me a drinksh will ya?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70721,'','Yesh, Brom here\'s the love of my life.  We\'re two peash in a pod, even if he\'s a lightweight!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70722,'','You gotsh somethin\' to say to me? You do the talkin\' and I\'ll do the drinkin\'!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70723,'','You\'re better off not trusting anything I say.  In fact, disregard this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70724,'','Oh yeah, there are plenty of false rumors going around about me.  That I grew up as an attraction in the Darkmoon Faire, that I killed six demons on my fifth birthday using only a spoon, or even -- and this is my favorite -- that I\'m actually a natural blonde.  Folks will believe anything.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70725,'','This place is great.  Anywhere else I\'d be called a violent sociopath.  Well, they call me that here too, but at least they say it to my face with a smile.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70726,'Do I smell bacon?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70727,'I need to get some medication for my allergies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70728,'A few nights back some guy threw a ball and told me to fetch. In response, I did the same, but with his head.  Needless to say, he didn\'t have a witty comeback.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70729,'','I always cheer for Goredome anytime he\'s up.  That angry little shoveltusk makes quick work of the slow chubby ones.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70730,'','City life changes a druid.  I used a flight path for the first time last week... and it was great.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70731,'','Druids can sometimes be so serious, but I\'m a real party animal.  Yes, that was a joke.  You should laugh.  Now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70732,'I could break through four hardened pine boards using just your forehead.  Want me to demonstrate?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70733,'I don\'t get why so many other monks throw kegs around.  So wasteful.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70734,'Sure, I\'ll get into the ring.  Let me finish these two kegs first.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70735,'','Oh, sorry, I can\'t buy you a drink.  I\'m a bit broke right now, but that\'ll turn around.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70736,'','This place looks rough and tumble, but everyone around here is a softie on the inside.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70737,'','Oh, yes I am new to Orgrimmar.  Is it that obvious?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70738,'','You should queue up for a brawl.  I could use a good laugh.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70739,'','Keep staring.  I enjoy awkward silence.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70740,'','Shoes are for the weak.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70741,'','Last time I went into a brawl my opponent ran away crying.  Not surprising that they fled, but it was the first time I\'ve seen a crocolisk shed tears.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70742,'','\"Nairi, lift this thing!\", they always shout.  Why not \"Nairi, show us your dance moves!\"?  I\'m a great dancer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70743,'','That Duke Studlington\'s a jerk.  He talks a big game, but can barely lift his own sword.  Oh, and yeah that\'s not his real name, as I\'m sure you guessed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70744,'You want a knuckle sandwich, chump?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70745,'I beat up three orcs and a tauren last night, all without breaking a nail.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70746,'Do you even lift, bro?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70747,'No, that is my femur, but I am happy to see you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70748,'Chicks dig scars, so you can see why I\'m such a hit with the ladies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70749,'You like what you see? Of course you do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70750,'Why does everyone know my name?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70751,'I could use a hug.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70752,'Watch me back, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70753,'Keep ya eyes wide open.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70754,'Stay close.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70755,'Hold up - there\'s somethin\' dere.','',0,0,0,0,0,0,0,0,1,0,34513,0,26124),
(70756,'Good-bye.','',0,0,0,0,0,0,0,0,1,0,34514,0,26124),
(70757,'Ah... your grace?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(70758,'One a dem lizard-beasts. Fight on me bruddahs!','',0,0,0,0,0,0,0,0,1,0,34515,0,26124),
(70759,'My apologies. My name is Anduin Wrynn. This champion and I need your help.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(70760,'Thank you, but this is hardly the time for a party. A dangerous war leader named Garrosh has found the Divine Bell. We need the Harmonic Mallet to counter it.','',274,1,0,0,200,0,0,0,1,0,0,0,26124),
(70761,'Well, my research said you were the last one to-','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(70762,'Dis will help.','',0,0,0,0,0,0,0,0,1,0,34516,0,26124),
(70763,'Stay in da fight!','',0,0,0,0,0,0,0,0,1,0,34517,0,26124),
(70764,'Spirits be wit\' ya.','',0,0,0,0,0,0,0,0,1,0,34518,0,26124),
(70765,'Use \'dis to heal yourself!','',0,0,0,0,0,0,0,0,1,0,34519,0,26124),
(70766,'Pull \'im through da trap!','',0,0,0,0,0,0,0,0,1,0,34520,0,26124),
(70767,'Lure him into da trap!','',0,0,0,0,0,0,0,0,1,0,34521,0,26124),
(70768,'I set up a trap.','',0,0,0,0,0,0,0,0,1,0,34522,0,26124),
(70769,'Lead him inta dis trap!','',0,0,0,0,0,0,0,0,1,0,34523,0,26124),
(70770,'Get \'dese beasts offa me!','',0,0,0,0,0,0,22,0,1,0,34524,0,26124),
(70771,'Dere be others.','',0,0,0,0,0,0,0,0,1,0,34525,0,26124),
(70772,'Have you fought dese \'tings before?','',0,0,0,0,0,0,6,0,1,0,34526,0,26124),
(70773,'It\'s like dey got weapons, but no brains.','',0,0,0,0,0,0,1,0,1,0,34527,0,26124),
(70774,'We can take this boat inside.  Just let me make a few modifications...','',0,0,0,0,0,0,0,0,1,0,34356,0,26124),
(70775,'And...done! A self-propelled saurok slaying machine.','',0,0,0,0,0,0,4,0,1,0,34357,0,26124),
(70776,'One of you man da guns, the rest on foot.','',0,0,0,0,0,0,25,0,1,0,34528,0,26124),
(70777,'Kill anyting dat squirms!','',0,0,0,0,0,0,0,0,1,0,34529,0,26124),
(70778,'Ack, get that thing off us!','',0,0,0,0,0,0,430,0,1,0,34358,0,26124),
(70779,'They\'re busting up our boat!','',0,0,0,0,0,0,22,0,1,0,34359,0,26124),
(70780,'Gat da Sorceror!','',0,0,0,0,0,0,0,0,1,0,34530,0,26124),
(70781,'Get dese beasts off da boat!','',0,0,0,0,0,0,0,0,1,0,34531,0,26124),
(70782,'Here! Stop da boat here.','',0,0,0,0,0,0,25,0,1,0,34532,0,26124),
(70783,'Griz, you guard da boat. Da rest of ya wit\' me.','',0,0,0,0,0,0,0,0,1,0,34533,0,26124),
(70784,'Here, take this! It\'ll help you against any swarms.','',0,0,0,0,0,0,0,0,1,0,34373,0,26124),
(70785,'I\'ll just ... be right here. Don\'t forget about me!','',0,0,0,0,0,0,0,0,1,0,34374,0,26124),
(70786,'Wooo hoo! Son of an Ook! Pins and needles, pins and needles. Legs are asleep. Hand is asleep. Nibs are asleep.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(70787,'Dis be some kinda spawnin chamber.','',0,0,0,0,0,0,1,0,1,0,34534,0,26124),
(70788,'Be careful! Da roof be comin\' down!','',0,0,0,0,0,0,0,0,1,0,34536,0,26124),
(70789,'Ooo? Grace? I not an emperor, little thing. You stand before the Monkey King!','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(70790,'Somethin unnatural about \'dese creatures.','',0,0,0,0,0,0,1,0,1,0,34537,0,26124),
(70791,'Help? You saved me from eternity trapped in jade! I\'m gonna throw you the biggest party ever made!','',1,4,0,0,300,0,0,0,1,0,0,0,26124),
(70792,'This is the chamber we\'re looking for.','',0,0,0,0,0,0,1,0,1,0,34403,0,26124),
(70793,'The Warchief has learned there\'s a connection between the Mogu and these creatures.','',0,0,0,0,0,0,1,0,1,0,34404,0,26124),
(70794,'Troll! You know all about this... voodoo.  What can you find?','',0,0,0,0,0,0,25,0,1,0,34405,0,26124),
(70795,'Oh... the missing Harmonic Mallet, eh? Such a silly name. So you come find the King because he is to blame?','',6,1,0,0,300,0,0,0,1,0,0,0,26124),
(70796,'\"Voodoo\"','',0,0,0,0,0,0,14,0,1,0,34538,0,26124),
(70797,'Ah ya ta ta! Don\'t worry, you in the right place. But let\'s first see if I like what comes out of your face.','',1,1,0,0,300,0,0,0,1,0,0,0,26124),
(70798,'Watch me back while I investigate...','',0,0,0,0,0,0,1,0,1,0,34539,0,26124),
(70799,'\'Dese \"Mogu,\" dey workin\' wicked dark magic here.','',0,0,0,0,0,0,1,0,1,0,34508,0,26124),
(70800,'Da Saurok, \'dey not born - \'dey was created. Flesh shaped an\' bent.','',0,0,0,0,0,0,5,0,1,0,34509,0,26124),
(70801,'Dis be the blackest of magics, mon!','',0,0,0,0,0,0,274,0,1,0,34510,0,26124),
(70802,'Yes! The power to shape flesh, to build warriors.  This is what the Warchief wants!','',0,0,0,0,0,0,5,0,1,0,34400,0,26124),
(70803,'Garrosh playing god? Making monsters? Dis ain\'t what da Horde is about!','',0,0,0,0,0,0,274,0,1,0,34511,0,26124),
(70804,'He knew you were a traitor!','',0,0,0,0,0,0,5,0,1,0,34401,0,26124),
(70805,'H-help-','',0,0,0,0,0,0,0,0,1,0,34512,0,26124),
(70806,'The Warchief will annihilate his enemies!','',0,0,0,0,0,0,15,0,1,0,34402,0,26124),
(70807,'Da... Warchief shows... his hand.','',0,0,0,0,0,0,0,0,1,0,34540,0,26124),
(70808,'Breaking the valve.','Breaking the valve.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70809,'Dis be what da Horde come to? Killin\' its own? We can\'t let dis happen.','',0,0,0,0,0,0,0,0,1,0,34541,0,26124),
(70810,'Champions, I need ya.','',0,0,0,0,0,0,0,0,1,0,34542,0,26124),
(70811,'Go back to da Warchief.  Tell \'im I\'m dead. Stay close to \'im. Watch \'im.','',0,0,0,0,0,0,0,0,1,0,34543,0,26124),
(70812,'You an\' me, we move to take \'im out when da time is right.','',0,0,0,0,0,0,0,0,1,0,34544,0,26124),
(70813,'Others are like me. You gotta find \'em.','',0,0,0,0,0,0,0,0,1,0,34545,0,26124),
(70814,'Swear da blood oath wit me.','',0,0,0,0,0,0,0,0,1,0,34546,0,26124),
(70815,'It be done. We bruddahs in dis. Until da end.','',0,0,0,0,0,0,0,0,1,0,34547,0,26124),
(70816,'I gonna disappear for a while. [Gasps] Don\'t forget about me.','',0,0,0,0,0,0,0,0,1,0,34548,0,26124),
(70817,'I will try to lead the \"King\" back to Lion\'s Landing and see if I can\'t persuade him to volunteer the information we need. In the meantime, I would say try to solve his riddles and meet us there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70818,'Horde pigs! Yeh killed me only son!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70819,'For Theramore!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70820,'For Bael Modan!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70821,'That\'s right, yeh manks! Yer Horde\'s a heap o\' sheep dung, an\' I jes\' proved it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70822,'CANNONBALL!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70823,'Monsters... all of yeh... *sputter*','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70824,'Let us begin.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(70825,'You never stood a chance.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(70826,'What?  How is this possible!','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(70827,'Let\'s give someone else a chance to do some damage!','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(70828,'Did you really think all of your pets would survive?','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(70829,'No!  That was my favorite pet!','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(70830,'So Garrosh is looking for something called the Divine Bell? Whatever that is, it can\'t be good. I\'ll get this information back to headquarters.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70831,'Excellent work! I\'ll be in touch soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70832,'Pssssst! Hey, over here, it\'s me, Agent Connelly! Don\'t blow our disguise!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70833,'Rod is power! Rod is MY power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70834,'Unga Ingoo is mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70835,'Monkey King died long ago! This can\'t be him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70836,'Ingoo, I gave your people the rod for protection. Not to be ookin\' used for hooliganation!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70837,'Ingoo, rod is not for you. Give it up before it destroys you too.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70838,'We will return to Lion\'s Landing. Meet us there when you have everything.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70839,'<Klaxxi\'va Ik regards you with a judging eye.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70840,'Are you ready to witness history, wakener?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70841,'We\'re hit!','We\'re hit!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70842,'Missile incoming! Shields! SHIELDS!','Missile incoming! Shields! SHIELDS!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70843,'Nice one, $p! That was close.','Nice one, $p! That was close.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70844,'Use Force Shield to block Guided Missiles.','Use Force Shield to block Guided Missiles.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70845,'You\'re hit! We\'re losing your signal!','You\'re hit! We\'re losing your signal!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70846,'They\'ve got a lock on you! Shields! SHIELDS!','They\'ve got a lock on you! Shields! SHIELDS!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70847,'Like shootin\' fish in a barrel!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70848,'That was easy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70849,'Locked and loaded!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70850,'','Get down from there Sully!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70851,'','I hope you fall into the muck again, Sully!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70852,'','Just in time, $p! We need your help!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70853,'','The situation is dire, $p.\n\nThe Horde are after a cache of mantid weapons near the Heart of Zan\'vess. I don\'t know what they intend to do with them but I\'m not about to wait around and find out.\n\nI need you to get through the shield that enshrouds the island and secure those weapons before the horde does. Take a gyrocopter and head out to the island. I\'ll send further orders while you are en route.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70854,'...And dat be one ugly mudder!','',0,0,0,0,0,0,0,0,1,0,34535,0,26124),
(70855,'Is THIS where your loyalties lie?','',0,0,0,0,0,0,0,0,1,0,34406,0,26124),
(70856,'Hellscream\'s Horde demands absolute obedience!','',0,0,0,0,0,0,0,0,1,0,34407,0,26124),
(70857,'The Warchief will hear of this betrayal!','',0,0,0,0,0,0,0,0,1,0,34408,0,26124),
(70858,'Hellscream... will find out...','',0,0,0,0,0,0,0,0,1,0,34409,0,26124),
(70859,'Ha-HAH!','',0,0,0,0,0,0,0,0,1,0,34410,0,26124),
(70860,'Strength!','',0,0,0,0,0,0,0,0,1,0,34411,0,26124),
(70861,'Fury!','',0,0,0,0,0,0,0,0,1,0,34412,0,26124),
(70862,'...die!','',0,0,0,0,0,0,0,0,1,0,34413,0,26124),
(70863,'Hide the bodies!','',0,0,0,0,0,0,0,0,1,0,34414,0,26124),
(70864,'Leave no witnesses!','',0,0,0,0,0,0,0,0,1,0,34415,0,26124),
(70865,'Alright, I\'ll go. But this is the last time I\'m going to infiltrate the Horde! And I mean it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70866,'I\'m off to gather supplies and reconnect with old contacts. If I need backup in Pandaria, I\'ll send for ya!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70867,'Whatcha need?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70868,'We got this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70869,'Let\'s do some damage.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70870,'Honor and loyalty.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70871,'Hellscream\'s eyes are upon you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70872,'The Warchief rewards the loyal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70874,'A nearby group of Darkhatched Swarmlings has hatched!','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(70875,'Grizzle has given you a portable death ray!  Use it on the saurok eggs nearby.','',15,0,0,0,0,0,0,0,0,0,0,0,26124),
(70876,'Grizzle has given you a set of landmines!  Use them on the saurok eggs nearby.','',15,0,0,0,0,0,0,0,0,0,0,0,26124),
(70877,'Grizzle has given you a portable cluster rocket!  Use it on the saurok eggs nearby.','',15,0,0,0,0,0,0,0,0,0,0,0,26124),
(70878,'','I strike from the shadows!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70879,'','You will die here, by my blade!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70880,'','Denizens of the sky, attack!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70881,'Use the boat\'s abilities to defeat packs of saurok as you make your way through the cave.','',15,0,0,0,0,0,0,0,1,0,0,0,26124),
(70882,'The Darkhatched Lizard-Lord begins to spin violently.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70883,'Broodmaster Noshi begins to cast a massive Death Nova.  Get inside the Big Bad Voodoo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70884,'Broodmaster Noshi is stunned by the stalactite!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70885,'Aim for those amber bombs, they\'ll cause a huge explosion if you manage to set one off!','Aim for those amber bombs, they\'ll cause a huge explosion if you manage to set one off!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70886,'Broodmaster Noshi begins to hatch a group of Darkhatched Swarmlings!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70887,'Those scorpid are moving the towers! Take them out!','Those scorpid are moving the towers! Take them out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70888,'Broodmaster Noshi begins to drain power from everything around him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70889,'Stalactites begin to fall from the ceiling!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70890,'Only a few more towers and that whole thing is coming down!','Only a few more towers and that whole thing is coming down!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70891,'The shield is down! Nice work, $p! I\'ll take us to the beachhead.','The shield is down! Nice work, $p! I\'ll take us to the beachhead.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70892,'','The whole island is protected by a sonic shield, $p.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70893,'','My scouts report that the shield is maintained by several generators around the island.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70894,'','I need you to take them out before the horde overrun us.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70895,'','You\'re approaching the first towers now! Take them out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70896,'','Nice shooting, $p! The shield is weakening!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70897,'','I\'m sending you the coordinates of the next towers now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70898,'','The shield is down! Quickly get to the beachhead!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70899,'','Stop those horde! They\'re storming the island!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70900,'Aid in the construction of at least two of the five defenses.','Aid in the construction of at least two of the five defenses.',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(70901,'Horde scum!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70902,'For the Alliance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70903,'Cowardly dogs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70904,'Varian... I have... failed... you','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70905,'Varian will honor me for this victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70906,'Alliance scum!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70907,'For the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70908,'Blood and thunder!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70909,'You are powerless before Garrosh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70910,'I... have... failed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70911,'Zan\'vess will never fall!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70912,'Is this what you came for?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70913,'Your blood will paint Zan\'vess red!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70914,'Empress...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70915,'Fool!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70916,'The horde cannot be stopped!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70917,'Good work, $p! We\'ll take these bombs back to the admiral immediately.','Good work, $p! We\'ll take these bombs back to the admiral immediately.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70918,'You are a true hero of the Alliance!','You are a true hero of the Alliance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70919,'You are a true hero of the Horde!','You are a true hero of the Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70920,'Rak\'gor has dropped a gas bomb.  Stand in a Healing Ward to heal yourself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70921,'Your attire is UNNACCEPTABLE!','Your attire is UNNACCEPTABLE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70922,'I\'m just going to say it: you\'re fat.','I\'m just going to say it: you\'re fat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70923,'I woudn\'t serve that to a Worg!','I woudn\'t serve that to a Worg!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70924,'Maybe you could cook more and eat less, no?','Maybe you could cook more and eat less, no?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70925,'I think the meat has gone bad.  Oh wait, that\'s you!','I think the meat has gone bad.  Oh wait, that\'s you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70926,'You\'re going to cook in that?','You\'re going to cook in that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70927,'Do you have reservations?','Do you have reservations?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70928,'No tunic, no boots, no service!','No tunic, no boots, no service!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70929,'Ready to cook with fire?','Ready to cook with fire?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70930,'','There\'s too much smoke in the air to see very far.\n\nI can\'t make out much of anything on the beach, and sniping\'s useless.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(70931,'Fight with us. |cFF0008E8(Amber will follow you.)|r','Fight with us. |cFF0008E8(Amber will follow you.)|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70932,'','I\'ll keep you covered.',273,0,0,0,0,0,273,0,1,0,0,0,26124),
(70933,'','I\'ve done all I can for the wounded here. Twinbraid has all the bodies he\'ll get.\n\nI\'m defending the injured... unless you have a better plan?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(70934,'Fight with us. |cFF0008E8(Mishka will follow you.)|r','Fight with us. |cFF0008E8(Mishka will follow you.)|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70935,'If Bloodhilt thinks a few reinforcements are going to be enough to take Lion\'s Landing, he\'s got another thing coming!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(70936,'We\'re here to help.','We\'re here to help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70937,'Good timing, too. Here comes the assault\'s commander!','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(70938,'Ready up, lads!','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(70939,'Nodd and Nimm were out in the submersible when the Horde attacked.\n\nStill, I\'ve put all their gear and explosives to good use.\n\nWe can set up a defensive position at the front.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(70940,'Fight with us. |cFF0008E8(Sully will follow you.)|r','Fight with us. |cFF0008E8(Sully will follow you.)|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70941,'Let\'s get to work!','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(70942,'','Time to operate.',396,0,0,0,0,0,273,0,1,0,0,0,26124),
(70943,'We\'re all ready.','We\'re all ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70944,'My commanding officers are all dead or missing.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(70945,'Get me reports from that SI:7 team - how many Horde are left, and how many men we still have - and help Sully set up some defenses.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(70946,'Be ready! They\'ll charge any moment now.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(70947,'Here they come! HOLD FAST!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(70948,'That\'s how we do it, lads! Here comes more!','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(70949,'Keep on fighting, lads! DON\'T GIVE UP!','',0,0,0,0,0,0,71,0,1,0,0,0,26124),
(70950,'This is it! Their final assault! FOR LION\'S LANDING!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(70951,'We\'ve done it! WE\'VE DONE IT!','',0,0,0,0,0,0,71,0,1,0,0,0,26124),
(70952,'Carry on!$b$bThe attack will commence once two defenses are constructed.','Carry on!$b$bThe attack will commence once two defenses are constructed.',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(70953,'|cFF00ff00+25 Construction Progress|r','|cFF00ff00+25 Construction Progress|r',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(70954,'Where do you want to go?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70955,'So many places, so little time. Where to, $Gbrother:sister;?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70956,'Somethin\' smell funny.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70957,'|cFF00ff00Construction Progress: Rate increased!|r','|cFF00ff00Construction Progress: Rate increased!|r',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(70958,'','It\'s about time you got here, $n. This battle isn\'t going to win itself!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70959,'|cFF00ff00+5 Construction Progress|r','|cFF00ff00+5 Construction Progress|r',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(70960,'We shall rout all traitors to the Horde!','We shall rout all traitors to the Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70961,'We will rout out dissention among these mongrels!','We will rout out dissention among these mongrels!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70962,'This is Kor\'kron business! Nothing to see here.','This is Kor\'kron business! Nothing to see here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70963,'Use the Laborer\'s Tool at any construction site for a progress boost! $B$B|TInterface\\Icons\\INV_HAMMER_17.blp:64|t','Use the Laborer\'s Tool at any construction site for a progress boost! $B$B|TInterface\\Icons\\INV_HAMMER_17.blp:64|t',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(70964,'Sometimes things just need doin\' even if it does mean breakin\' a few things along the way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70965,'Use the Battle Rations at any construction site to boost its rate of progress! $B$B|TInterface\\Icons\\INV_MISC_FOOD_WHEAT_02.blp:64|t','Use the Battle Rations at any construction site to boost its rate of progress! $B$B|TInterface\\Icons\\INV_MISC_FOOD_WHEAT_02.blp:64|t',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(70966,'I remember when Vol\'jin and I first came to this land. The Horde was just an idea then. A hope. We needed one another.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(70967,'We made our home in this desert, and named it after my father Durotan, Chieftain of the Frostwolf Clan.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(70968,'The land was harsh. Time and again it was Vol\'jin and his people who ensured the Horde\'s survival, saving us from starvation, or taking up arms when we were attacked.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(70969,'Trolls and orcs have fought together. Died together. We are family. And family looks after its own.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(70970,'Use the Brittle Roots at select construction sites to boost their rate of progress! $B$B|TInterface\\Icons\\INV_WEAPON_SHORTBLADE_09.blp:64|t','Use the Brittle Roots at select construction sites to boost their rate of progress! $B$B|TInterface\\Icons\\INV_WEAPON_SHORTBLADE_09.blp:64|t',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(70971,'Use the Jungle Hops on the Blast-brew Cauldron at the pandaren construction site for a progress boost! $B$B|TInterface\\Icons\\INV_MISC_HERB_08.blp:64|t','Use the Jungle Hops on the Blast-brew Cauldron at the pandaren construction site for a progress boost! $B$B|TInterface\\Icons\\INV_MISC_HERB_08.blp:64|t',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(70972,'Use the Krasari Iron at the dwarven or gnome construction sites to boost their rate of progress! $B$B|TInterface\\Icons\\INV_ORE_PLATINUM_01.blp:64|t','Use the Krasari Iron at the dwarven or gnome construction sites to boost their rate of progress! $B$B|TInterface\\Icons\\INV_ORE_PLATINUM_01.blp:64|t',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(70973,'Use the Liquid Fire on the Blast-brew Cauldron at the pandaren construction site for a progress boost! $B$B|TInterface\\Icons\\ABILITY_WARLOCK_BURNINGEMBERS.blp:64|t','Use the Liquid Fire on the Blast-brew Cauldron at the pandaren construction site for a progress boost! $B$B|TInterface\\Icons\\ABILITY_WARLOCK_BURNINGEMBERS.blp:64|t',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(70974,'Use the Meaty Haunch at any construction site to boost its rate of progress! $B$B|TInterface\\Icons\\INV_MISC_FOOD_50.blp:64|t','Use the Meaty Haunch at any construction site to boost its rate of progress! $B$B|TInterface\\Icons\\INV_MISC_FOOD_50.blp:64|t',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(70975,'Use the Misplaced Keg at the pandaren construction site to permanently boost its rate of progress! $B$B|TInterface\\Icons\\INV_CASK_04.blp:64|t','Use the Misplaced Keg at the pandaren construction site to permanently boost its rate of progress! $B$B|TInterface\\Icons\\INV_CASK_04.blp:64|t',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(70976,'But know this, the Horde IS family, even if some of its leaders have forgotten that fact. To prove this, I shall remain with you and lend what strength I can to your chosen leaders until Vol\'jin returns.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70977,'Use the Snake Oil at the night elf or gnome construction sites to boost their rate of progress! $B$B|TInterface\\Icons\\ABILITY_VEHICLE_OILJETS.blp:64|t','Use the Snake Oil at the night elf or gnome construction sites to boost their rate of progress! $B$B|TInterface\\Icons\\ABILITY_VEHICLE_OILJETS.blp:64|t',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(70978,'Please, $p, do not tell Garrosh what we have done here today. I must make some weighty decisions before confronting him directly.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(70979,'Spirit-Kissed Water will awaken Master Brownstone, boost progress at pandaren construction site, or increase progress rate at night elf site! $B$B|TInterface\\Icons\\INV_MISC_VOLATILEWATER.blp:64|t','Spirit-Kissed Water will awaken Master Brownstone, boost progress at pandaren construction site, or increase progress rate at night elf site! $B$B|TInterface\\Icons\\INV_MISC_VOLATILEWATER.blp:64|t',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(70980,'Use the Unexploded Cannonball at the dwarven construction site to permanently boost its rate of progress! $B$B|TInterface\\Icons\\ABILITY_VEHICLE_SIEGEENGINECANNON.blp:64|t','Use the Unexploded Cannonball at the dwarven construction site to permanently boost its rate of progress! $B$B|TInterface\\Icons\\ABILITY_VEHICLE_SIEGEENGINECANNON.blp:64|t',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(70981,'Speak to the jinyu foreman, Elder Adler, who will use the Adorned Sceptre to permanently grant a significant increase to the jinyu rate of progress! $B$B|TInterface\\Icons\\INV_STAFF_2H_PANDARIATRADESKILL_C_05.blp:64|t','Speak to the jinyu foreman, Elder Adler, who will use the Adorned Sceptre to permanently grant a significant increase to the jinyu rate of progress! $B$B|TInterface\\Icons\\INV_STAFF_2H_PANDARIATRADESKILL_C_05.blp:64|t',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(70982,'Speak to the gnome foreman, Rosey Axlerod, who will use the Soggy Journal to permanently grant a significant increase to the gnome rate of progress! $B$B|TInterface\\Icons\\INV_MISC_BOOK_11.blp:64|t','Speak to the gnome foreman, Rosey Axlerod, who will use the Soggy Journal to permanently grant a significant increase to the gnome rate of progress! $B$B|TInterface\\Icons\\INV_MISC_BOOK_11.blp:64|t',0,0,0,0,0,0,30,0,1,0,0,0,26124),
(70983,'Shan Kien\'s hand twists into a Sha Claw!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70984,'Shan Kien\'s eyes glow with Sha Magic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70985,'Ya mon! A hero done freed our raptors!','Ya mon! A hero done freed our raptors!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70986,'Ah not a traitor mon! Ya not gonna be shacklin\' me again.','Ah not a traitor mon! Ya not gonna be shacklin\' me again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70987,'Us Darkspear not the type to wear chains well, mon. Ya be learnin\' this the hard way... soon.','Us Darkspear not the type to wear chains well, mon. Ya be learnin\' this the hard way... soon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70988,'Vol\'jin not be givin\' ya permission to question us like this.','Vol\'jin not be givin\' ya permission to question us like this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70989,'Ya not be gettin\' the drop on us again ya half wit Kor\'kron!','Ya not be gettin\' the drop on us again ya half wit Kor\'kron!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70990,'--GREETINGS, $P. PLEASE PROCEED DOWN THE TUNNEL BEHIND THIS UNIT. HIS HIGH AND POWERFULNESS THE GRAND MAGISTER ROMMATH AWAITS YOUR ARRIVAL.--','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70991,'You have no idea what\'s waiting for you!','You have no idea what\'s waiting for you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70992,'Scargash won\'t allow any alliance to escape the jungle!','Scargash won\'t allow any alliance to escape the jungle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70993,'The Commander will have the Alliance king\'s head on a spike!','The Commander will have the Alliance king\'s head on a spike!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70994,'Call for your king, $rt! Draw him in!','Call for your king, $rt! Draw him in!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70995,'','May the light of the eternal sun heal you, $p!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70996,'','Do not worry, $p, I will heal you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70997,'','I will not let you fall, $p!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70998,'','May your wounds be mended, $p.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(70999,'Your beloved king has taken the bait! He\'ll die in this jungle!','Your beloved king has taken the bait! He\'ll die in this jungle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71000,'It has been an age of the world or more since I felt any emotion at even a fraction of that.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71001,'Your blood will not be the last my blades taste today, $c!','Your blood will not be the last my blades taste today, $c!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71002,'Welcome to the jungle, $rt. You\'re gunna die!','Welcome to the jungle, $rt. You\'re gunna die!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71003,'It would seem this \"sha\" energy is far more powerful than I previously thought.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71004,'What... what was that?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71005,'Rommath... I... I don\'t know what came over me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71006,'This one\'ll be dead before long, $p.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71007,'Focus your fire, $p!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71008,'Ha! I like our chances, $p.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71009,'Right between the eyes...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71010,'Alright, $p, let\'s take this one out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71011,'Let\'s see how this one\'s bleeds...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71012,'Death to all who oppose the Blood Elves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71016,'','My King, I promise you. The Kirin-Tor will come down on Garrosh so hard his ancestors will reel. Blood will pay for blood!',0,0,0,0,0,0,0,0,5,0,0,34496,26124),
(71017,'Jaina -','',0,0,0,0,0,0,0,0,5,0,34647,0,26124),
(71018,'I will end Garrosh for this. His Horde already crumbles beneath him. We will deliver the final blow.','',0,0,0,0,0,0,0,0,5,0,34648,0,26124),
(71019,'Champion, you and Anduin thwarted the Warchief today and won the Alliance a critical victory.','',0,0,0,0,0,0,0,0,5,0,34649,0,26124),
(71020,'But please, leave me now. I must tend to my son... and prepare for our next battle.','',0,0,0,0,0,0,0,0,5,0,34650,0,26124),
(71021,'The boy\'s face is ashen and pale. He barely breathes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71022,'%s casts |cFFFF0000|Hspell:135759|h[Salvation of the Protector]|h|r to assist you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71023,'What do you think?','What do you think?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71024,'Let\'s talk to him.','Let\'s talk to him.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71025,'Yes - The Kirin Tor must remain above faction squabbles.','Yes - The Kirin Tor must remain above faction squabbles.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71026,'I\'m not sure I could.','I\'m not sure I could.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71027,'Ah. The smell of a proper battlefield. We have been on our own for far too long. Now, the full might of the Horde is unleashed! And we are the ones who direct where the next blow will land.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71028,'THIS is the best your pathetic Alliance can muster? PAH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71029,'We crushed your Alliance in Southern Barrens. We will crush you here. And Pandaria will tremble!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71030,'We will drive you from the beach. The Pandaren will tremble before our might!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71031,'Go ahead. Make me bleed. A true orc lives for combat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71032,'Warchief... I have failed you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71033,'An engraving reads: \"Spill No Evil!\"','An engraving reads: \"Spill No Evil!\"',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71034,'Bah! Pain don\'t hurt!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(71035,'Glory to the brave!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(71036,'Here comes the THUNDER!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(71037,'What is this that stands before me?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(71043,'Alright, we have the handle, the head, and the ointment like you asked for. Can you re-assemble the mallet?','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(71044,'Ayup! Silly youngin, just put rod in hole. And the mallet shall again be whole.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(71045,'Good as nibby new! But listen to the Monkey King. You only have enough ointment for one true swing.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(71046,'Only one swing? Are we sure this will work? Is there any way to get more ointment?','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(71047,'The Monkey King was there, the last time this mallet struck true. Tears came to eyes, and harmony was felt through and through. But no more ointment was ever made, for the mogu came with their raid. Use what you have, be grateful it is there. For the bell is a dangerous weapon, so handle with care.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(71048,'What is this dark magic?','What is this dark magic?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71049,'Don\'t let it touch you!','Don\'t let it touch you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71050,'Her locomotives won\'t locomote, but her weapons are fresh off the assembly line.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71051,'Rise and shine, beautiful!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71052,'Can\'t we work in peace?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71053,'I have a bad feeling about this place.','I have a bad feeling about this place.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71054,'Where are our reinforcements?','Where are our reinforcements?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71055,'How long can we hold out on our own?','How long can we hold out on our own?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71056,'I do not like the taste of this magic.','I do not like the taste of this magic.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71057,'What kind of magic is this?','What kind of magic is this?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71060,'Friend! Breath my incense if you need healing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71061,'Thank you, friend of the grummles!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71062,'COGWRENCH, YOU WERE SMALL AND I MISS YOU.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71063,'Wanderer! Inhale this if you wish to fight faster!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71064,'Many thanks! This is the last time we travel west of the wall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71065,'Keep up the good work, $p. With your help, we\'ll be done in no time!','',0,0,0,0,0,0,1,0,1,20163,0,0,26124),
(71066,'Your help is appreciated, friend. At this rate, we\'ll be able to get some rest soon!','',0,0,0,0,0,0,1,0,1,20163,0,0,26124),
(71067,'Your efforts are really accelerating our progress, $p. Perhaps you\'d like a permanent spot on our crew?','',0,0,0,0,0,0,1,0,1,20163,0,0,26124),
(71068,'We pandaren work best on a full stomach, $p. Be sure to keep our table full!','',0,0,0,0,0,0,1,0,1,20164,0,0,26124),
(71069,'Remember $p, meat from wildlife or rations from your enemies will keep my crew well fed!','',0,0,0,0,0,0,1,0,1,20164,0,0,26124),
(71070,'Some of our kegs went missing recently. They were last seen just east of here...','',0,0,0,0,0,0,1,0,1,20164,0,0,26124),
(71071,'The saurok here are scavengers. There\'s no telling what they might be carrying.','',0,0,0,0,0,0,1,0,1,20164,0,0,26124),
(71072,'Keep an eye out for brittle roots, $p. We can use their wood in the construction of our defenses.','',0,0,0,0,0,0,1,0,1,20164,0,0,26124),
(71073,'Spirit-Kissed Water is very unstable. Only one can be carried at any given time.','',0,0,0,0,0,0,1,0,1,20164,0,0,26124),
(71074,'Seek out the Volatile Fireflies, $p! They are instrumental in the creation of this special brew.','',0,0,0,0,0,0,1,0,1,20164,0,0,26124),
(71075,'Place the Jungle Hops directly into the cauldron, $p. No such thing as too much hops!','',0,0,0,0,0,0,1,0,1,20164,0,0,26124),
(71076,'You should always carry a Spirit-Kissed Water, friend. Without it, we tend to... nod off.','',0,0,0,0,0,0,1,0,1,20164,0,0,26124),
(71077,'Those gorillas look angry, friend, but challenging them may well be worth the risk!','',0,0,0,0,0,0,1,0,1,20164,0,0,26124),
(71078,'Please, $p, keep me awake! If we fall asleep, all productivity comes to a halt.','',0,0,0,0,0,0,1,0,1,20164,0,0,26124),
(71079,'It is wise to replenish our resources before they run out!','',0,0,0,0,0,0,1,0,1,20164,0,0,26124),
(71080,'I love overnight trips. Camping is my favorite thing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71081,'I\'m a good dancer. Wanna see?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71082,'I don\'t know why people treat me like a little kid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71083,'Stop bothering me! I normally get up late in the afternoon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71084,'I want to be a singer when I grow up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71085,'A ha a ha a ha uh- uh! A ha a ha yeah yeah yeah yeah!$B$BDo you like my song?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71087,'WIPING MEMORY OF UNBEARABLY SAD MEMORIES...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71088,'FACTORY SETTINGS LOADED...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71089,'AFFIRMATIVE, CUPCAKE.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71090,'Perhaps it could be harnessed. My people are well-versed in controlling the rage within...','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(71091,'Aye, $gladdie:lass;, that be some fine gatherin\' ye been doin. Keep it up!','',0,0,0,0,0,0,1,0,1,20167,0,0,26124),
(71092,'You\'ve got us workin\' up a sweat here, $p. We\'ll have our defenses in place in no time!','',0,0,0,0,0,0,1,0,1,20167,0,0,26124),
(71093,'We\'re runnin\' at full steam, $p. Just focus on keepin\' us topped off.','',0,0,0,0,0,0,1,0,1,20167,0,0,26124),
(71094,'Listen, $p, that grill\'s not gunna put food on itself. Don\'t let the fellas get hungry now!','',0,0,0,0,0,0,1,0,1,20168,0,0,26124),
(71095,'Focus, $p! The meat from wildlife or rations from orc troops will keep my crew well fed!','',0,0,0,0,0,0,1,0,1,20168,0,0,26124),
(71096,'Mebbe there be some unexploded cannonballs \'round these parts. Plenty of fightin\' offshore recently...','',0,0,0,0,0,0,1,0,1,20168,0,0,26124),
(71097,'Them lizard-folk could be carryin\' anything. Keep an eye out for \'em!','',0,0,0,0,0,0,1,0,1,20168,0,0,26124),
(71098,'Look fer brittle roots stickin\' out of the soil. There\'s good wood in \'em!','',0,0,0,0,0,0,1,0,1,20168,0,0,26124),
(71099,'There\'s a type of iron unique to these parts. Bring back any ya find, $p. Ain\'t no iron in Azeroth us dwarves can\'t forge.','',0,0,0,0,0,0,1,0,1,20168,0,0,26124),
(71100,'C\'mon, $p! We need resources if we\'re gunna get this job done! Food, wood, iron... whatever you can find!','',0,0,0,0,0,0,1,0,1,20168,0,0,26124),
(71101,'Them crocs drop some tasty meat, $p, but tiger haunch is my personal favorite!','',0,0,0,0,0,0,1,0,1,20168,0,0,26124),
(71102,'There\'s orcs out there, $p. I can smell \'em. And they\'re bound to have supplies we can make use of.','',0,0,0,0,0,0,1,0,1,20168,0,0,26124),
(71103,'Don\'t go wanderin\' off too far, $p. We\'re darn near defenseless without the likes of you.','',0,0,0,0,0,0,1,0,1,20168,0,0,26124),
(71104,'Productivity stops if we\'re attacked. Keep an eye on us!','',0,0,0,0,0,0,1,0,1,20168,0,0,26124),
(71105,'Take my advice, $p. It\'s best to keep our resources stocked up!','',0,0,0,0,0,0,1,0,1,20168,0,0,26124),
(71106,'','Saw yer flare \'n came quick as I could!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71107,'','Oh no! Prince Anduin!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71108,'','Don\'t worry. I\'ll get Anduin back to Lion\'s Landing safely. We\'ll meet ye there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71109,'Dem Saurok be guardin de cave.  Let\'s take care of \'em.','',0,0,0,0,0,0,0,0,1,0,34554,0,26124),
(71110,'I didn\'t get to be the Shredmaster by putting up with chumps like you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71111,'I was rusty...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71112,'You have done well, $rt. My workers are making efficient progress.','',0,0,0,0,0,0,1,0,1,20170,0,0,26124),
(71113,'Can I get you something?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71114,'You have us working very efficiently, $rt. Our task will be complete soon at this pace.','',0,0,0,0,0,0,1,0,1,20170,0,0,26124),
(71115,'Progress is going swimmingly, friend. You should focus on maintaining what you\'ve done.','',0,0,0,0,0,0,1,0,1,20170,0,0,26124),
(71116,'The beasts in the region all yield edible meat, $rt. Do what you can to keep the workers fed.','',0,0,0,0,0,0,1,0,1,20171,0,0,26124),
(71117,'Just deposit any food you gather on the table here. We can take it from there.','',0,0,0,0,0,0,1,0,1,20171,0,0,26124),
(71118,'Food and wood are our primary needs. Speak with me if you seek to aid us further.','',0,0,0,0,0,0,1,0,1,20171,0,0,26124),
(71119,'There is usable wood, even in these swamps. Look for brittle roots protruding from the soil.','',0,0,0,0,0,0,1,0,1,20171,0,0,26124),
(71120,'Here she comes!','Here she comes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71121,'My workers are highly skilled, but they are ineffective when it comes to combat. Do not wander too far off.','',0,0,0,0,0,0,1,0,1,20171,0,0,26124),
(71122,'Once you have delivered supplies, your work is not done. Do your best to keep our resources topped off.','',0,0,0,0,0,0,1,0,1,20171,0,0,26124),
(71123,'If your enemies harass the worker, productivity will cease until the threat is dealt with.','',0,0,0,0,0,0,1,0,1,20171,0,0,26124),
(71124,'Jaina! Stop!','Jaina! Stop!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71125,'I will not bow to th-','I will not bow to th-',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71126,'We didn\'t know th-','We didn\'t know th-',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71127,'','Woohoo! You\'ve got us running at peak efficiency, $p!',0,0,0,0,0,0,1,0,1,20173,0,0,26124),
(71128,'','This is as fast as I\'ve ever seen this team work! Keep it up, $p!',0,0,0,0,0,0,1,0,1,20173,0,0,26124),
(71129,'','You\'re doing great, $p! At this rate, our defenses will be complete in no time!',0,0,0,0,0,0,1,0,1,20173,0,0,26124),
(71130,'','We gnomes have a high metabolism, $p. Make sure we don\'t run outta food!',0,0,0,0,0,0,1,0,1,20174,0,0,26124),
(71131,'','Collect meat from the local wildlife or rations from the orcs. We\'re not picky eaters.',0,0,0,0,0,0,1,0,1,20174,0,0,26124),
(71132,'','Hey $p, we\'ll work faster if we have plenty of metal to work with. The local Krasari Iron Ore will do fine.',0,0,0,0,0,0,1,0,1,20174,0,0,26124),
(71133,'','Keep an eye out for oily serpents, $p. They\'re easy enough to catch. Put their oil in the cauldron and we\'ll work even faster.',0,0,0,0,0,0,1,0,1,20174,0,0,26124),
(71134,'','The lizard folk around here are likely to carry anything. Watch for \'em!',0,0,0,0,0,0,1,0,1,20174,0,0,26124),
(71135,'','Keep us well supplied for the greatest production benefit.',0,0,0,0,0,0,1,0,1,20174,0,0,26124),
(71136,'','Keep an eye on us, $p! We\'re builders, not fighters. We\'ll need your protection if any beasties come around!',0,0,0,0,0,0,1,0,1,20174,0,0,26124),
(71137,'','Snake Oil, Krasari Iron, Food... keep an eye out for anything that might benefit our crew!',0,0,0,0,0,0,1,0,1,20174,0,0,26124),
(71138,'','You can often supply us with multiples of an item for extra effect. Just try to keep the benefits from wearing off.',0,0,0,0,0,0,1,0,1,20174,0,0,26124),
(71139,'','Keep us well supplied, $p. Don\'t let the effects expire or you\'ll have to start from scratch!',0,0,0,0,0,0,1,0,1,20174,0,0,26124),
(71140,'','Practice being as efficient as you can, $p! One day, time might be a factor...',0,0,0,0,0,0,1,0,1,20174,0,0,26124),
(71141,'','<Static> Come in, $p, this is Sky Admiral Rogers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71142,'','Things could not be going better, friend. Thank you for your aid.',0,0,0,0,0,0,1,0,1,20176,0,0,26124),
(71143,'','You have served us well, $p. Please continue as we draw near completion.',0,0,0,0,0,0,1,0,1,20176,0,0,26124),
(71144,'','Our resources are well stocked, thanks to you. Please strive to keep them so.',0,0,0,0,0,0,1,0,1,20176,0,0,26124),
(71145,'This is our home too! You can\'t do this!','This is our home too! You can\'t do this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71146,'','We are accustomed to wisps carrying out our labors. Please bring food to keep us sustained.',0,0,0,0,0,0,1,0,1,20177,0,0,26124),
(71147,'','We typically shy away from eating the flesh of beasts, but our predicament requires that we make exception.',0,0,0,0,0,0,1,0,1,20177,0,0,26124),
(71148,'','Bring us wood to graft into our saplings, $p. We shall make do with the roots in the region.',0,0,0,0,0,0,1,0,1,20177,0,0,26124),
(71149,'Alliance witch!','Alliance witch!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71150,'','The Spirit-Kissed Water from the local sprites will nourish our saplings well. And once the bucket is filled, you will not need to replenish it.',0,0,0,0,0,0,1,0,1,20177,0,0,26124),
(71151,'','Do not shirk, friend. Keep us well supplied and our work will be completed sooner.',0,0,0,0,0,0,1,0,1,20177,0,0,26124),
(71152,'This is my home too!','This is my home too!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71153,'I will NOT submit!','I will NOT submit!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71154,'','Watch over us, $p. We are not accustomed to fighting. We will require your protection if we are attacked.',0,0,0,0,0,0,1,0,1,20177,0,0,26124),
(71155,'No surrender!','No surrender!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71156,'','Wood, snake oil, food and water will speed our progress, $p. Please, do what you can to keep us supplied.',0,0,0,0,0,0,1,0,1,20177,0,0,26124),
(71157,'','As you supply our camp, strive to keep the benefits from wearing off.',0,0,0,0,0,0,1,0,1,20177,0,0,26124),
(71158,'','Learn well from your experience here, $p. In the future, your efficient efforts may be well rewarded.',0,0,0,0,0,0,1,0,1,20177,0,0,26124),
(71159,'So the Alliance sent... you?','',0,0,0,0,0,0,0,0,1,0,23330,0,26124),
(71160,'Not bad for a newbie.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71161,'Your fighting skills are bad and you should feel bad.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71162,'You call that a hit?  My grandma could hit harder and she\'s dead!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71163,'Just keep standing there looking dumb, it suits you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71164,'You smell worse than a sulfur mine filled with unwashed yaks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71165,'Surprise us both and do something smart, like running away.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71166,'I need a portal to Dalaran.','I need a portal to Dalaran.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71167,'Like our people, the Horde is always in motion, always changing. But make no mistake. We will endure.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71168,'Let\'s go track down those thieves!','Let\'s go track down those thieves!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71169,'Keep looking, Reliquary. We will find it. The bell is meant to ensure Horde victory. I feel it in my bones.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71170,'I will concern myself with how it works once I have it in my possessions, Blood Elf.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71171,'The Divine Bell is a weapon of unquestionable power. It belongs in horde hands. It belongs to me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71172,'We\'re close! These documents all mention the bell and Kun-Lai Summit. It must be here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71173,'','We\'ve been searching for days. All we have found are dusty scrolls and broken statues.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71174,'What if the Divine Bell is in disrepair too? Are you certain you can use it even if we do find it?','What if the Divine Bell is in disrepair too? Are you certain you can use it even if we do find it?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71175,'','Perhaps the mogu hid the bell for a reason, Warchief.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71176,'Hey!','Get your hands off that!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71177,'I thought I smelled something!','Hey!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71178,'For the Horde!','Death to the Alliance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71179,'Pandaria is ours!','You\'re trespassing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71180,'You\'ll never take this land from us!','Garrosh will have your head!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71181,'Get your hands off that!','Hey you there!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71182,'Get outta here!','I thought I smelled something!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71183,'Silence, coward. You\'d better ask where your loyalties lie: With the Kirin Tor? Or with the Horde?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71184,'Death to the Alliance!','For the Horde',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71185,'Trespassin\' huh?!','Thief!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71186,'Enough! Do you want me to report to Garrosh that you asked us to bow to that Kirin Tor wench?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71187,'You don\'t belong here!','For the Alliance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71188,'Hugs... we want hugs...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71189,'Fanlyr, what is going on here? I didn\'t authorize this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71190,'I\'d give you a thumbs down, but I can\'t find it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71191,'Heigh-ho... heigh-ho... OH NO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71192,'I thought I smelled something!','Death to the Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71193,'You\'re routing this attack through Dalaran? Proudmoore will suspect the Sunreavers! Stop this immediately!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71194,'You\'ll never leave this jungle alive!','So, you\'ve come to die?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71195,'The night elves didn\'t properly secure their portals in Dalaran. It was a simple matter to exploit the ley lines...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71196,'Engaging hostile entity.  Removing protective failsafes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71197,'Challenger defeated. Uploading report for analysis and verbal harassment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71198,'Warranty voided.  I hope you are happy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71199,'This is for Theramore!','You\'ll burn for your crimes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71200,'','Do not let your eyes deceive you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71201,'','Everyone gather \'round for a group hug.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71202,'Die Horde scum!','You will pay for your crimes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71203,'','I wish I had someone other to blame than myself.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71204,'Death to the Alliance!','I thought I smelled something!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71205,'I had your back to the end...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71206,'Nice job big guy.  Brains and brawn -- together we overcome any obstacle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71207,'Together we are unstoppable!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71208,'So, you\'ve come to die?!','You\'ll never leave this jungle alive!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71209,'You\'ll burn for your crimes!','This is for Theramore!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71210,'DIE QUICKLY -- I HAVE LUNCH PLANS!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71211,'YOU ARE BAD AND SHOULD FEEL BAD!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71212,'NOT COOL.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71213,'You will not destroy this land too!','Die Horde scum!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71214,'So you want to play?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71215,'Go get it, Sunny!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71216,'You won\'t survive this game of fetch, $c!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71217,'You know nothing of loyalty!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71219,'Fetch!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71220,'NO! Noooooo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71221,'RIDDOH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71222,'You will not defeat us!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71223,'Very well. I saw nothing. But in the future, you are NOT to exploit our relationship with the Kirin Tor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71224,'Ri... Ri... Riddoh.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71225,'','We pandaren are such a peaceful race, but we do appreciate a good brawl every now and again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71226,'These Pandaren are sittin\' on a treasure trove. They even got books in here about vrykul. I mean the vrykul! Come on! How could they possibly have encountered them?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71227,'Time to pay the toll!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71228,'Relax, Aethas. This attack cannot be traced. I am certain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71229,'Are you sure you want to take the portal to Stormwind?','Are you sure you want to take the portal to Stormwind?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71230,'Are you sure you want to take the portal to Orgrimmar?','Are you sure you want to take the portal to Orgrimmar?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71231,'And stay out!','And stay out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71232,'We don\'t let just any riffraff off the street in here!','We don\'t let just any riffraff off the street in here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71233,'Come back when you actually deserve to go up to the Boom Room!','Come back when you actually deserve to go up to the Boom Room!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71234,'Look at this wise guy!','Look at this wise guy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71235,'Boss Bizmo said no nobodies allowed!','Boss Bizmo said no nobodies allowed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71236,'Right this way!','Right this way!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71237,'','Oh, yes I am new to Stormwind.  Is it that obvious?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71238,'I\'M CHARGING MY LASER!','',0,0,0,0,0,0,0,13,1,0,0,0,26124),
(71239,'I\'M FIRING MY LASER!','',0,0,0,0,0,0,0,13,1,0,0,0,26124),
(71240,'SHOOP DA WHOOP!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71241,'','There\'s too much smoke in the air to see very far.\n\nI can\'t make out much of anything on the beach, and sniping\'s useless.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(71242,'','I\'ll keep you covered.',273,0,0,0,0,0,273,0,1,0,0,0,26124),
(71243,'Fight with us. |cFF0008E8(Shokia will follow you.)|r','Fight with us. |cFF0008E8(Shokia will follow you.)|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71244,'','Alliance dogs!\n\nLook at my poor wyverns...',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(71245,'','Let\'s slaughter them all.',0,0,0,0,0,0,71,0,1,0,0,0,26124),
(71246,'Fight with us. |cFF0008E8(Kromthar will follow you.)|r','Fight with us. |cFF0008E8(Kromthar will follow you.)|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71247,'','Anyone not already standing is dead. Bloodhilt has all the fighters he\'ll get.\n\nSo... I\'m ravenous. Shall we go find something to eat?',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(71248,'','They\'ll never see me coming.',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(71249,'Fight with us. |cFF0008E8(Kiryn will follow you.)|r','Fight with us. |cFF0008E8(Kiryn will follow you.)|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71250,'It\'s a good thing I spend all my spare time tinkering on my greatest passion: High-power directed explosives!\n\nLet\'s use some to set up defensive positions at the gates.','',396,153,0,0,3,0,0,0,1,0,0,0,26124),
(71251,'Fight with us. |cFF0008E8(Rivett will follow you.)|r','Fight with us. |cFF0008E8(Rivett will follow you.)|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71252,'Let\'s start explodinatin\'!','',0,0,0,0,0,0,71,0,1,0,0,0,26124),
(71253,'Miserable gnomes! They dropped out of the sky and set fire to EVERYTHING.\n\nNow the whole refinery\'s alight, and the main Alliance forces will advance on the keep at any moment!\n\nWe don\'t have the numbers to stop them...','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(71254,'We\'ll hold Domination Point or die trying!','',0,0,0,0,0,0,113,0,1,0,0,0,26124),
(71255,'Fight with us. |cFF0008E8(General Nazgrim will follow you.)|r','Fight with us. |cFF0008E8(General Nazgrim will follow you.)|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71256,'If the Alliance thinks a few reinforcements are all it takes to conquer MY fortress, they\'ve got another thing coming!','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(71257,'My commanding officers are all dead or missing.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(71258,'I need information, NOW. How many Alliance are left, and how many orcs we still have - and help that mad goblin Clutchpop set up some defenses.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(71259,'Good timing. Here they come again!','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(71260,'Ready up, you mangy grunts!','',66,0,0,0,0,0,0,0,1,0,0,0,26124),
(71261,'We\'re here to help.','We\'re here to help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71262,'We\'re all ready.','We\'re all ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71263,'Victory! VICTORY FOR THE HORDE!','',0,0,0,0,0,0,71,0,1,0,0,0,26124),
(71264,'Here they come! HOLD FAST!','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(71265,'HAH! Hellscream would be proud! Here comes some more meat for the grinder...','',0,0,0,0,0,0,71,0,1,0,0,0,26124),
(71266,'Keep on fighting, grunts! THE EYES OF HELLSCREAM ARE UPON US!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(71267,'Here comes the final assault. For Domination Point! BUTCHER THEM ALL!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(71268,'Weapons up, you magnificent monsters! They\'re about to charge.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(71271,'Don\'t forget to set your worldstate area!','Don\'t forget to set your worldstate area!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71272,'This is the Thunder King Raid!','This is the Thunder King Raid!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71273,'Thunder begins with a shock wave in the air due to the sudden thermal expansion of the plasma in the lightning channel!','Thunder begins with a shock wave in the air due to the sudden thermal expansion of the plasma in the lightning channel!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71274,'The speed of sound in dry air is approximately 343 m/s!','The speed of sound in dry air is approximately 343 m/s!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71275,'I will go, but only as a witness for my people. Someone gotta keep you in check, Garrosh.','',0,0,0,0,0,0,1,0,1,0,34507,0,26124),
(71276,'$n, over here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71278,'%s and Rak\'gor Bloodrazor exchange hushed words.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(71280,'Those Mantid are protecting the towers, $p. Take them out or we won\'t be able to land any shots.','Those Mantid are protecting the towers, $p. Take them out or we won\'t be able to land any shots.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71281,'Those scorpid are moving the towers! Take them out!','Those scorpid are moving the towers! Take them out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71282,'Good work, $p! We\'ll take these bombs back to the admiral immediately.','Good work, $p! We\'ll take these bombs back to the admiral immediately.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71283,'Oh, yuck! This food is terrible!','Why don\'t buffets ever have anything good?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71284,'Who eats this stuff anyway?','Sezik calls this food?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71285,'Boss-Lady is nuts if she thinks I\'ll just eat this grub!','My sensibilities are offended by this mess!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71290,'Good shot, $p! Keep aiming for those bombs.','Good shot, $p! Keep aiming for those bombs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71291,'Stealing','Stealing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71292,'Ro\'shak! Grant me wings of flame!','',0,0,0,0,0,0,0,0,1,0,35468,0,26124),
(71293,'Let\'s talk!','Let\'s talk!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71294,'Nice one, $p! That was close.','Nice one, $p! That was close.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71295,'You were hit! Weapons temporarily disabled!','You were hit! Weapons temporarily disabled!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71296,'The Void Binder can be found in the Hall of Secrets, just upstairs and to the right as you enter the building.','The Void Binder can be found in the Hall of Secrets, just upstairs and to the right as you enter the building.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(71297,'The Void Binder can be found in the Ethereal Corridor, just upstairs and to the right as you enter the building.','The Void Binder can be found in the Ethereal Corridor, just upstairs and to the right as you enter the building.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(71299,'Void Binder','Void Binder',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(71301,'I will show no mercy!','',0,0,0,0,0,0,0,0,7,0,20505,0,26124),
(71302,'Vol\'jin holds his hand out to you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71303,'Swear the blood oath with Vol\'jin','Swear the blood oath with Vol\'jin',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71304,'','Without these throwing axes, their axe throwers will certainly be less effective.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(71305,'You want to fight?  Come back when you\'re a bit stronger.$b$bYou\'re welcome to watch, though.','You want to fight?  Come back when you\'re a bit stronger.$b$bYou\'re welcome to watch, though.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(71306,'You want to fight?  You\'re gonna need an invite.$b$bYou\'re welcome to watch, though.','You want to fight?  You\'re gonna need an invite.$b$bYou\'re welcome to watch, though.',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(71307,'Ah, $n, ya heart be a worthy sacrifice!','Ah, $n, ya heart be a worthy sacrifice!',0,0,0,0,0,0,16,0,1,0,0,0,26124),
(71314,'','That\'s fewer accursed Zandalari Priests we have to deal with.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(71315,'','Those innocent pterodactyl hatchlings now have a chance at a real life.',0,0,0,0,0,0,21,0,1,0,0,0,26124),
(71316,'','Hopefully taking these offerings will slow their sacrificial rituals down.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(71317,'','These Zandalari are proving to be a greater threat than I expected.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71318,'','I can\'t believe the Zandalari actually make living sacrifices!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71319,'When did you arrive on this island?','When did you arrive on this island?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71320,'','Not long ago, but I\'ve already seen terrible suffering in this place!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(71339,'','An enormous thundering cloud serpent bars our entrance into Lei Shen\'s domain.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71340,'','There are few thundering cloud serpents left in our world.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71341,'','We are investigating the sewer system - perhaps there is another way in to the citadel.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71342,'','Me? I practice the art of the Jade Lightning. My fists are so fast, you won\'t even be able to see them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71343,'','Ah, $p! Just the $c I\'ve been looking for.$B$BDo you remember how the Alliance came to Pandaria? You were there, weren\'t you? But your presence in that part of Pandaria\'s timeline is... incomplete. You saw only a portion of the events which transpired that day.$B$BMaybe you fled the chaos of war to walk the peaceful valleys of this land. Or perhaps the call of treasure from dungeons exotic and ancient was louder than the call of your king to find his White Pawn.$B$BRegardless, I am not here to judge. I merely offer a second chance.$B$BSay the word, and I will transport you back to that day. Lion\'s Landing will not yet have been built, and the Skyfire will loom over Jade Forest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71344,'I want to see the Skyfire in Jade Forest. Take me back.','I want to see the Skyfire in Jade Forest. Take me back.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71345,'Are you sure you want to change your phase?','Are you sure you want to change your phase?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71346,'%s lets out a booming call, attracting nearby turtles.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71347,'','Ah, $p! Just the $c I\'ve been looking for.$B$BDo you remember how the Alliance came to Pandaria? You were there, weren\'t you? But your presence in that part of Pandaria\'s timeline is... incomplete. You saw only a portion of the events which transpired that day.$B$BMaybe you fled the chaos of war to walk the peaceful valleys of this land. Or perhaps the call of treasure from dungeons exotic and ancient was louder than the call of your king to find his White Pawn.$B$BRegardless, I am not here to judge. I merely offer a second chance.$B$BSay the word, and I will transport you back to that day. Lion\'s Landing will not yet have been built, and the Skyfire will loom over Jade Forest.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71348,'Look for Old Man Barlo out by Silmyr Lake, northeast of Shattrath City.','Look for Old Man Barlo out by Silmyr Lake, northeast of Shattrath City.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(71349,'','Hello again, $p! Enjoying your second chance?$B$BIf you continue along the adventure here until the Skyfire leaves, you\'ll automatically re-join the normal timeline and find Lion\'s Landing established again.$B$BOr, if you\'d rather go back, er... forward to Lion\'s Landing now, let me know!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71350,'I want to return to Lion\'s Landing.','I want to return to Lion\'s Landing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71355,'I am born of thunder!','I am born of thunder!',0,0,0,0,0,0,0,0,1,0,35732,35732,26124),
(71356,'Can you feel a chill wind blow? The storm is coming...','Can you feel a chill wind blow? The storm is coming...',0,0,0,0,0,0,0,0,1,0,35730,35730,26124),
(71357,'The clouds arc with vengeance!','The clouds arc with vengeance!',0,0,0,0,0,0,0,0,1,0,35734,35734,26124),
(71358,'The air crackles with anger!','The air crackles with anger!',0,0,0,0,0,0,0,0,1,0,35735,35735,26124),
(71359,'The sky weeps for your demise!','The sky weeps for your demise!',0,0,0,0,0,0,0,0,1,0,35733,35733,26124),
(71360,'I am but...the darkness...before the storm...','I am but...the darkness...before the storm...',0,0,0,0,0,0,0,0,1,0,35731,35731,26124),
(71361,'Let me share dis gift with ya!','',0,0,0,0,0,0,0,0,1,0,35395,0,26124),
(71362,'More are coming aboard.  Hold them off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71363,'They\'re sending boarding parties from the sea.  One of you man the aft cannon and take \'em down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71364,'Gusting Grimoire','Gusting Grimoire',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71365,'Dark Portal Heartstone','Dark Portal Heartstone',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71366,'Ghastly Charger','Ghastly Charger',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71367,'Betrayal of the Guardian','Betrayal of the Guardian',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71368,'We\'ve held them off for now.  Hop in the port-side cannon and help out our other ships!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71369,'We\'ve pushed them back to their ship.  Swing over and use some of their explosives to blow it to smithereens!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71371,'|TInterface\\Icons\\inv_misc_dust.blp:20|tDurumu begins charging up his eye to cast |cFFFF0000|Hspell:134169|h[Disintegration]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(71372,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71373,'Your Capacitor will Discharge in 10 Seconds! Get to a Drill!','Your Capacitor will Discharge in 10 Seconds! Get to a Drill!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71374,'On this island I must ask you to face great dangers. Your loyalty and trust are appreciated, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71375,'We blood elves have weathered many a storm. Whatever the Thunder King unleashes against us, we shall strike him an even greater blow!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71376,'While our goals call for the eradication of the mogu, we can\'t ignore our flanks.$b$bWhile both the Alliance and the saurok attack the mogu alongside us, either could turn on us at any moment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71377,'We must find a way to strip our enemies of their power. Without their strength, we can easily overcome them with our will.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71378,'Stealing artifact','Stealing artifact',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71379,'Removing','Removing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71380,'Don\'t be makin\' da big one mad, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71381,'We gonna\' feed ya to the big one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71382,'Too late for ya to be runnin\' away now, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71383,'Ya barely be fit tah\' feed to de big one.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71384,'Came to the wrong place, ya did.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71385,'Good! Mah pet be gettin\' hungry, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71386,'Ah, the food be arrivin\'.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71387,'Ya came to the right place... to be eaten!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71388,'Bow before the Zandalari!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71389,'It be feedin\' time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71390,'Ya come to the right place to die.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71391,'I gonna\' feed ya soul to dah beasts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71392,'Ya be nothin\' but fuel to me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71393,'The Loa gonna\' eat you up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71394,'Die ya trespassah.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71395,'Have a taste of Zandalari magic!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71396,'Ya soul be weak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71397,'Come closer. Just a little cut, I promise!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71398,'Once the incision is made, the blood flows quickly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71399,'The more you struggle, the more it will hurt!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71400,'Your death will not come swiftly. I can guarantee that!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71401,'Ah, a new subject? I will take you apart... piece by piece!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71402,'Yes, come closer, little one. My scalpel thirsts for your blood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71403,'Horridon sets his eyes on $n and stamps his tail!','Horridon sets his eyes on $n and stamps his tail!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71404,'Ah, the lair of the beasts. While I admire the Zandalari skill with beasts I am more impressed with their ability to endure this foul odor.$b$bKeep a devilsaur upwind of you and it will never catch you off guard.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71405,'|TInterface\\Icons\\ability_warrior_focusedrage.blp:20|t Horridon goes on a |cFFFF0000|Hspell:136821|h[Rampage]|h|r after seeing War-God Jalak fall!','|TInterface\\Icons\\ability_warrior_focusedrage.blp:20|t Horridon goes on a |cFFFF0000|Hspell:136821|h[Rampage]|h|r after seeing War-God Jalak fall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71406,'You be gettin\' back!','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(71407,'Come back, stupid vermin!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(71408,'Not anotha!','',0,0,0,0,0,0,53,0,1,0,0,0,26124),
(71409,'Die by the fury of the storm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71412,'|TInterface\\Icons\\ability_thunderking_lightningwhip.blp:20|t%s begins to cast |cFFFF0000|Hspell:136850|h[Lightning Whip]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71413,'I was not always a shortfang. I was strong.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71414,'My father was a brute. My mother was a saur-priest. I am nothing.$b$bI am a disgrace to the Skumblade. I will die in the filth, and they will not eat my meat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71415,'I will never know the strength of Kros. I will never hunt in his fields.$b$bI am not the predator. I am the prey.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71416,'They tell me that I can shed my shame. I only need to do one thing, and then I will not be a shortfang.$b$bBut I cannot do that. I cannot take Farros\' strength for myself. Not after what he has done for me...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71417,'As a shortfang, I must wait until the stronger saurok have had their share of meat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71418,'I smell you, outsider. I know you are not one of us.$b$bWhy do you sneak into our village? Why do you wear the skin of our people? I do not understand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71419,'I know you are not one of us. You are one of them.$b$bI follow you. I watch you. You kill our people, but you also kill mogu. You kill straight-back trolls.$b$bI do not care who you kill. I pick up the meat afterward. So very, very much meat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71420,'I have seen your magic. I know that you are not saurok. You are other.$b$bYour magic makes you weak. You are not brave. You are coward who hides in enemy\'s skin. YOU ARE NOT STRONG!$b$b<Gokkar spits at your feet.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71421,'I know your secret, outsider. I know you are an enemy. I smell through your false skin.$b$bI am not scared of you. Fear is for the weak. I am not weak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71422,'I smell through your disguise, stranger. You are bold to come to such a sacred ritual.$b$bWhat do you intend here? Will you eat the flesh of Kroshik?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71423,'We are born from the flesh of Kros. We were fashioned from his meat, his bones. He is our creator.$b$bKroshik is the blood of Kros. He watches over us. He is our connection to Kros. He has the strength of Kros, yet he walks on our world.$b$bWhen the time comes, Kroshik will die, and we will take his strength. Then, the cycle will start again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71424,'Kroshik has a body of meat and bone, but he carries with him the spirit of Kros.$b$bOne day, Kroshik\'s hunt will end. But Kros\'s hunt goes on forever.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71425,'The mogu lie to our people. They tell us that we are their creation, that they twisted our flesh into its current form. They claim that we owe our existence to them.$b$bI DEFY the mogu! They have no power over us! They do not know what we see, how we live, what we feel! They cannot see into our souls!$b$bOnly Kros, the great creator, knows what is in your soul. Kros knows, and Kros understands. Kros gave you your strength, saurok. No mogu owns you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71426,'Kros, our creator, will not save the weak. The souls of the weak will exist in eternal fear, always fleeing from the teeth and claws of Kros and his followers.$b$bIf you are strong, Kros will allow you to hunt. Your eternity will be spent chasing the weak, eating their flesh, and becoming ever stronger.$b$bBe strong, saurok.$b$bStrength always to the Skumblade. Strength always to you, saurok.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71427,'Eat the flesh of Kroshik, and be cleansed of weakness! Let the spirit of Kros pass through your body!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71428,'You know what I think? <Tomma glances quickly behind him.>$b$bThe saur-priests are as filled with filth as the village itself.$b$bTheir Kroshik-worship makes them weak. They preach strength, but do they hunt? Do they kill? Do they roll in the decaying remains of their fallen brothers?$b$bNo. They hide in their caves and talk. If they were truly strong, they would be out here fighting with us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71429,'The saur-priests will tell you that our strength comes from Kroshik. Don\'t listen to their religious talk.$b$bOur strength comes from our claws, from our teeth, from our weapons. It comes from the filth that the filth-mongers gather and cultivate.$b$bIt comes from us.$b$bI don\'t care whether we descended from some devilsaur in the sky or we were created by the mogu. All I care about is protecting this land from our enemies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71430,'We were created by the mogu. There is no reason not to believe it. Anybody who denies it is ignorant, or living in fantasy.$b$bI refuse to pretend I am a devilsaur. I know what I am. I know where my strength comes from.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71431,'Saurok who worship Kroshik only do so because they are scared.$b$bThey pretend that we are all just little walking devilsaurs, proving our \"strength\" to gain the favor of an invisible, all-powerful devilsaur that lives in the sky.$b$bThat is truly what they believe.$b$bWe are not devilsaurs. We are saurok. And when we die, there will be no eternal hunt, no promised paradise, no punishment for the weak, and no Kros. We will be eaten, and our remains thrown into the filth-pool. And that is all. I have seen it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71432,'I will not participate in their false ritual. There is nothing special about Kroshik, or his meat. Meat is meat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71433,'Found any good meat lately?$b$bI ate a gnome the other day. Hardly worth the effort of pulling all those pink hairs out of my teeth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71434,'You have roach on your foot, $gbrother:sister;.$b$bWatch your step.  The roaches help us spread disease.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71435,'I found a good bit of filth out in the swamps today. The filth-mongers will be proud of me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71436,'Do not eat clean meat. The Skumblade are just as strong on the inside as they are on the outside.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71437,'I watch our new enemies.$b$bThe straight-back trolls ally with the mogu, but the other invaders fight against them.$b$bPfah! I do not care. Their battles have given us many new corpses to scavenge. The Skumblade have never been stronger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71438,'Found any good meat lately?$b$bI ate a blood elf the other day. He tasted like he\'d been rolling in flowers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71439,'Do me a favor: deposit your extra filth into the filth-pool.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71440,'Change is coming to Ihgaluk. The saurok are turning on one another. Some think that there are intruders among us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71441,'Made any good kills lately?$b$bI killed a tauren yesterday. It took three scavengers to bring his parts back to the filth-pool!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71442,'The mogu seek to destroy us. The mogu are our enemy. I will slay every last mogu that comes close to our home.$b$bWill you help?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71443,'Made any good kills lately?$b$bI killed a draenei yesterday. You can still find her near the filth-pool... just look for the blue entrails.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71444,'Keep your claws sharp. You never know when another piece of meat will walk by.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71445,'Fight, kill, eat, live another day.$b$bIf you die, die where your brothers and sisters can eat you. No point in feeding your enemies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71446,'Kill the mogu.$b$bKill the mogu.$b$bKill the mogu.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71447,'Strength always to the Skumblade. Death and dismemberment to our enemies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71448,'How do you prefer to kill? With tooth? With blade? From behind? From darkness?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71449,'Look at you, clean-scale. Do you want the mogu to attack you? Do you want to be their pet?$b$bProtect yourself, $gbrother:sister;. Get your filth on.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71450,'It is our responsibility to keep the muck fresh. The filth keeps us safe. It keeps our enemies away.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71451,'Keep your hunger in check, $gbrother:sister;. Always leave some meat behind to rot.$b$bOverly-ravenous saurok will bring doom to us all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71452,'Ah! You have a clean spot, $gbrother:sister;. Let me just get that for you...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71453,'Let me know if you catch anybody interfering with our filth-pool. I\'ve heard stories about intruders.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71454,'Try not to step on my roaches, $gbrother:sister;.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71455,'If you ever need any filth, come talk to me. I can help.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71456,'Stay away from the sea. Too clean.$b$bThe saur-priests can tell you: Filthiness is next to godliness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71457,'The mogu claim to have created us... to have twisted us into our current forms. Do not believe their lies.$b$bWe are our own people, evolved from the great creator, Kros himself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71458,'Kroshik is a gift from our creator, Kros. He reminds us of our strength, of our heritage, of our legacy. He gives us a glimpse at our glorious future.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71459,'The mogu are our enemy. They seek to eliminate us from this world. Why should we believe the creation myths that they feed us?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71460,'Be strong.$b$bBe vicious.$b$bKill more than you can eat.$b$bMake no friends, and take no pets.$b$bDie fighting.$b$bThese, and many more, are lessons we can learn from Kroshik.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71461,'Humble yourself before Kroshik, saurok. In this world, he is the closest to Kros that you will ever get.$b$bSavor in his presence. He will not live forever.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71462,'Kroshik gives us his body, his bones, his strength, and his spirit. We owe our existence to him.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71463,'Kroshik is the blood of Kros, our creator. We are Kros\' chosen people.$b$bWith his strength behind us, we can never die.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71464,'Live a life devoted to the ideals of Kros. Never stop fighting, never stop growing. Each day, stronger than before.$b$bFight through pain. Suffer through filth. Everyone is your enemy.$b$bDie with your weapon in your hand. Give your body to Ihgaluk.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71465,'Kill mogu.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71466,'Enemy is walking meat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71467,'Death to mogu.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71468,'Kill. Eat. Kill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71469,'Sharp teeth, sharp claws.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71470,'No fear. No remorse. Kill invader.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71471,'No mercy for weak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71472,'Never weak. Always strong.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71473,'Keep an eye to the sea, $gbrother:sister;. The mogu can attack from anywhere.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71474,'Seadragons rank high in the eyes of Kros. The sea is home to good food and filth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71475,'The Altar of Kros is sacred ground, $gbrother:sister;. Watch where you tread when you\'re on my beach.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71476,'We see strange ships. These are not mogu ships.$b$bWho are the invaders? What do they want? What do they taste like?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71477,'Lots of corpses in the sea. More than usual.$b$bThere is war nearby.$b$bThis is good for the saurok. More corpses means more food, more filth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71478,'I smell intruders. They are near.$b$b<The seadragon eyes you suspiciously.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71479,'Some saur-priests call me traitor. \"Kroshik does not hunt in the sea,\" they say.$b$bI follow the path of Kros, but I do not agree with these priests. Kroshik hunts WHEREVER HE CAN, and so do I.$b$bThese priests and their stubborn, closed-mind idea of Kroshik have no place in today\'s Skumblades.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71480,'Filth protects us. Our enemies cannot stand the smell of Ihgaluk.$b$bBut it is hard to keep filth on the beach. The ocean drinks our filth faster than we can create it. There must be other ways to protect our shores.$b$b<The seadragon flashes a razor-toothed smile.> That\'s where I come in, $gbrother:sister;.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71481,'<The saurok cowers behind its pet.>','',430,0,0,0,0,0,0,0,1,0,0,0,26124),
(71482,'Please, stay back, stronger. I want no fight.','',430,0,0,0,0,0,0,0,1,0,0,0,26124),
(71483,'The saur-priests have seen my weakness. The brutes beat me, and call me shortfang. If I did not have my basilisk to protect me, I would be all alone.$b$bLikely dead.','',430,0,0,0,0,0,0,0,1,0,0,0,26124),
(71484,'You bend down to speak with me? A pet-keeper? A shortfang?$b$bI know my place in this world, stronger. I am not strong enough to fight on my own, so I keep a pet. I am called weak, and pushed to the edge of the village.$b$bYou should stay away from me, before they see you.','',430,0,0,0,0,0,0,0,1,0,0,0,26124),
(71485,'Yes, stronger?','',430,0,0,0,0,0,0,0,1,0,0,0,26124),
(71486,'I am nothing, I am no one, I am weak.$b$bI am nothing, I am no one, I am weak.$b$bI am nothing...','',430,0,0,0,0,0,0,0,1,0,0,0,26124),
(71487,'There are ways for a shortfang to become stronger. If I wanted, I could escape the scorn of my tribe.$b$bThere are ways... but I am afraid. I am too scared, too weak.$b$bThey do not understand me. I will be a shortfang all my life.','',430,0,0,0,0,0,0,0,1,0,0,0,26124),
(71488,'<The shortfang recoils in fear.>','',430,0,0,0,0,0,0,0,1,0,0,0,26124),
(71489,'Silence, fool! Kroshik approaches!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71490,'<The saurok kneels in silent reverence.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71491,'Show some respect, saurok. Do you not see Kroshik?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71492,'Close your mouth and take a knee, fool. Kroshik is near.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71493,'Eat the flesh of Kroshik, and be cleansed of your weakness.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71494,'His flesh will feed us, and give us strength. His rotting insides will be thrown into the filth-pool, protecting us from intruders. His bones will build our homes. His seed will continue the cycle indefinitely.$b$bStrength always to Kroshik. Strength always to the Skumblade.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71495,'Kroshik!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71496,'Strength always to the Skumblade!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71497,'|TInterface\\Icons\\spell_nature_lightningoverload.blp:20|t The |cFFFF0000Northwest|r doors begin to open, causing |cFFFF0000|Hspell:136889|h[Violent Gale Winds]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71498,'Metal Lord Mono-Han prepares a whirling attack!','Metal Lord Mono-Han prepares a whirling attack!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71500,'Lord Gura commanded the very power of the storm at his fingertips. With a single word, he could blanket the earth in crackling electricity. Those caught in his storm died a terrible, scorching death.','Lord Gura commanded the very power of the storm at his fingertips. With a single word, he could blanket the earth in crackling electricity. Those caught in his storm died a terrible, scorching death.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71501,'Stupid ting!','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(71502,'','Death, danger, the return of the Zandalari and their magic. Exciting!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71504,'','The Kirin Tor can keep Dalaran for all I care. This is where I feel most at home, behind enemy lines, right in the thick of things!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71506,'The Quicksilver falls off his blades! Kill the blobs to absorb their power!','The Quicksilver falls off his blades! Kill the blobs to absorb their power!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71507,'Thank you, friend. You have rescued me from a terrible fate.','Thank you, friend. You have rescued me from a terrible fate.',0,0,0,0,0,0,2,0,1,924,0,0,26124),
(71508,'Did the Sunreavers send you? Thank you for the well-timed rescue.','Did the Sunreavers send you? Thank you for the well-timed rescue.',0,0,0,0,0,0,2,0,1,923,0,0,26124),
(71509,'Thank you. I can find my way back to camp from here.','Thank you. I can find my way back to camp from here.',0,0,0,0,0,0,2,0,1,924,0,0,26124),
(71510,'Thank you, champion. Please, free the others as well!','Thank you, champion. Please, free the others as well!',0,0,0,0,0,0,2,0,1,924,0,0,26124),
(71511,'How could the mogu be capable of such atrocity? Thank goodness you arrived when you did.','How could the mogu be capable of such atrocity? Thank goodness you arrived when you did.',0,0,0,0,0,0,2,0,1,924,0,0,26124),
(71512,'You have my eternal gratitude, hero.','You have my eternal gratitude, hero.',0,0,0,0,0,0,2,0,1,924,0,0,26124),
(71513,'You have saved my life, champion. For that, I am in your debt.','You have saved my life, champion. For that, I am in your debt.',0,0,0,0,0,0,2,0,1,924,0,0,26124),
(71514,'Did the Silver Covenant send you? Thank you for the well-timed rescue.','Did the Silver Covenant send you? Thank you for the well-timed rescue.',0,0,0,0,0,0,2,0,1,924,0,0,26124),
(71515,'I knew the Silver Covenant would not desert me. Thank you, champion.','I knew the Silver Covenant would not desert me. Thank you, champion.',0,0,0,0,0,0,2,0,1,924,0,0,26124),
(71516,'I knew the Sunreavers would not desert me. Thank you, champion.','I knew the Sunreavers would not desert me. Thank you, champion.',0,0,0,0,0,0,2,0,1,923,0,0,26124),
(71517,'I should tear you apart, Alliance scum! I will restrain myself this once.','I should tear you apart, Alliance scum! I will restrain myself this once.',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(71518,'I will stay my hand this time, Alliance hero. Let it not be said that the Sunreavers do not show gratitude.','I will stay my hand this time, Alliance hero. Let it not be said that the Sunreavers do not show gratitude.',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(71519,'If you had not just rescued me from certain death, I would kill you where you stand. Next time we meet, I will not hold back.','If you had not just rescued me from certain death, I would kill you where you stand. Next time we meet, I will not hold back.',0,0,0,0,0,0,2,0,1,923,0,0,26124),
(71520,'Although we are enemies, I will thank you. Just this once.','Although we are enemies, I will thank you. Just this once.',0,0,0,0,0,0,2,0,1,923,0,0,26124),
(71521,'Thank you, Alliance hero, but next time we meet, I will show no mercy.','Thank you, Alliance hero, but next time we meet, I will show no mercy.',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(71522,'Thank you, Horde hero, but next time we meet, I will show no mercy.','Thank you, Horde hero, but next time we meet, I will show no mercy.',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(71523,'I will stay my hand this time, Horde hero. Let it not be said that the Silver Covenant does not show gratitude.','I will stay my hand this time, Horde hero. Let it not be said that the Silver Covenant does not show gratitude.',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(71524,'I should tear you apart, Horde scum! I will restrain myself this once.','I should tear you apart, Horde scum! I will restrain myself this once.',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(71525,'If you had not just rescued me from certain death, I would kill you where you stand. Next time we meet, I will not hold back.','If you had not just rescued me from certain death, I would kill you where you stand. Next time we meet, I will not hold back.',0,0,0,0,0,0,2,0,1,924,0,0,26124),
(71526,'Although we are enemies, I will thank you. Just this once.','Although we are enemies, I will thank you. Just this once.',0,0,0,0,0,0,2,0,1,924,0,0,26124),
(71527,'Thank you. I can find my way back to camp from here.','Thank you. I can find my way back to camp from here.',0,0,0,0,0,0,2,0,1,923,0,0,26124),
(71528,'Thank you, champion. Please, free the others as well!','Thank you, champion. Please, free the others as well!',0,0,0,0,0,0,2,0,1,923,0,0,26124),
(71529,'How could the mogu be capable of such atrocity? Thank goodness you arrived when you did.','How could the mogu be capable of such atrocity? Thank goodness you arrived when you did.',0,0,0,0,0,0,2,0,1,923,0,0,26124),
(71530,'You have my eternal gratitude, hero.','You have my eternal gratitude, hero.',0,0,0,0,0,0,2,0,1,923,0,0,26124),
(71531,'Thank you, friend. You have rescued me from a terrible fate.','Thank you, friend. You have rescued me from a terrible fate.',0,0,0,0,0,0,2,0,1,923,0,0,26124),
(71532,'You have saved my life, champion. For that, I am in your debt.','You have saved my life, champion. For that, I am in your debt.',0,0,0,0,0,0,2,0,1,923,0,0,26124),
(71533,'What is this magic?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71534,'Strength always to the Skumblade!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71535,'Aggh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71536,'Intruders!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71537,'I\'ll rip you apart!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71538,'Gah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71539,'You come to steal our filth?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71540,'I\'ll throw your corpse in the filth-pool!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71541,'Blech!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71542,'Stay back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71543,'What do you want from me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71544,'N-no!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71545,'You die now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71546,'Strength.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71547,'Time to kill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71548,'By Kroshik\'s teeth, how did you get here?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71549,'What is this magic?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71550,'Kros, give me strength...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71551,'Curse you, coward...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71552,'I knew I smelled something...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71553,'You\'ll regret this...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71554,'I\'ve been busy. A few of the Saur-Priests have been calling for Horde and Alliance blood.$b$bNaturally, I killed them in their sleep.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71555,'The filth pool is more rancid than I\'ve ever seen it. We need to get somebody in here to clean up before it gets any worse and starts spreading outside the crag.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71556,'They\'ve been chanting: \"Kill the mogu\" all day. Whatever Aethas has you doing, it\'s working.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71557,'They\'ve been talking all day about the mogu weapons they found within Ihgaluk Crag.$b$bThey don\'t suspect us at all. Keep up the good work.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71558,'From what I\'ve gathered, they\'re preparing for an attack on the mogu at dawn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71559,'These saurok just returned from an attack on the mogu. I will continue to observe them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71560,'The saurok leadership has called off their attacks on the mogu. They plan on attacking the Horde and Alliance instead.$b$bIt may be time to intervene.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71561,'The saurok have been quiet lately, and are becoming restless. The time is ripe to turn them against the mogu.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71562,'','Tell Aethas that the saurok have been quiet today. No impending attacks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71563,'','The saurok are restless. They\'re planning something. Aethas will want to know.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71564,'','Let the archmage know that everything is under control here at Ihgaluk. I\'ll have another report in a few days.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71565,'','It looks like the scavengers may be sending a large party out into the swamp soon. Tell the archmage to be ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71566,'REBOOTING...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71567,'SYSTEM ONLINE. FEELING MUCH BETTER NOW.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71568,'ATTEMPTING TO RECOVER FROM EMBARRASSING MALFUNCTION...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71569,'RECOVERY FAILED. INCREMENTING SHAME PARAMETER. RETURNING TO BASE.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71570,'LEG FAILURE LOOP BROKEN. RETURNING TO BASE.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71571,'EXECUTING SAND EXTRACTION PROTOCOL.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71572,'WARNING: MANA FLOW RATE STILL ELEVATED.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71573,'ATTEMPTING MANA FLOW RATE REDUCTION OVERRIDE PROTOCOL.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71574,'\"EVERYTHING IS OK\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71575,'\"EVERYTHING IS ALRIGHT\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71576,'\"$N WILL MAKE IT ALL BETTER\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71577,'MANA FLOW RATE NOMINAL. RETURNING TO BASE.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71578,'ATTEMPTING TO DESTROY MEMORY RECORDS OF PREVIOUS 6 HOURS.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71579,'MEMORY RECORDS DESTROYED. WHO ARE YOU. RETURNING TO BASE.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71580,'POWERING ON...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71581,'LOCATION UNRECOGNIZED. RETURNING TO LAST KNOWN BASE LOCATION.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71582,'EXECUTING GRATITUDE PROTOCOL.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71583,'\"THANK YOU\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71584,'Have you seen our magnificent riding turtles? They only appear slow at a glance - an experienced rider may keep pace with the swiftest wolves on all of Kalimdor. Alas, they are reserved only for our most trusted allies.','Have you seen our magnificent riding turtles? They only appear slow at a glance - an experienced rider may keep pace with the swiftest wolves on all of Kalimdor. Alas, they are reserved only for our most trusted allies.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(71585,'You will find no better riding companion than our dragon turtles. Their low stance means the rider experiences no bounce or jostle, even when cornering sharply. If you are interested in purchasing one, you must prove your trust to the Tushui.','You will find no better riding companion than our dragon turtles. Their low stance means the rider experiences no bounce or jostle, even when cornering sharply. If you are interested in purchasing one, you must prove your trust to the Tushui.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(71586,'So cold, so dark...','So cold, so dark...',0,0,0,0,0,0,0,0,1,0,35744,35744,26124),
(71587,'We will not be forgotten, no, no, no...','We will not be forgotten, no, no, no...',0,0,0,0,0,0,0,0,1,0,35745,35745,26124),
(71588,'We are the perfect one, yes, yes, not a failure, no no, not a failure...','We are the perfect one, yes, yes, not a failure, no no, not a failure...',0,0,0,0,0,0,0,0,1,0,35746,35746,26124),
(71589,'What is this? What do they want? To punish us? No, no...','What is this? What do they want? To punish us? No, no...',0,0,0,0,0,0,0,0,1,0,35747,35747,26124),
(71590,'Your flesh, yes yes, so perfect, GIVE IT TO US!','Your flesh, yes yes, so perfect, GIVE IT TO US!',0,0,0,0,0,0,0,0,1,0,35742,35742,26124),
(71591,'No no no, the pain returns!','No no no, the pain returns!',0,0,0,0,0,0,0,0,1,0,35749,35749,26124),
(71592,'It tears at us from the inside!','It tears at us from the inside!',0,0,0,0,0,0,0,0,1,0,36112,36112,26124),
(71593,'Who is perfect now? Yes, yes...','Who is perfect now? Yes, yes...',0,0,0,0,0,0,0,0,1,0,35748,35748,26124),
(71594,'Again...we are torn apart...again...to the cold darkness...','Again...we are torn apart...again...to the cold darkness...',0,0,0,0,0,0,0,0,1,0,35743,35743,26124),
(71595,'I want to use my challenge card!','I want to use my challenge card!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71596,'I want to fight to increase my rank!','I want to fight to increase my rank!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71597,'Your soul is mine, trespasser!','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(71598,'Ahhh, another soul for the taking.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(71599,'I will make good use of you, intruder.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(71600,'I will savor your death, interloper!','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(71601,'For the Thunder King!','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(71602,'Living Fluids begin to form in a nearby pool!','Living Fluids begin to form in a nearby pool!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71603,'Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136210|h[Ventral Sacs]|h|r!','Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136210|h[Ventral Sacs]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71604,'Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136215|h[Gas Bladder]|h|r!','Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136215|h[Gas Bladder]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71605,'Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136218|h[Acidic Spines]|h|r!','Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136218|h[Acidic Spines]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71606,'Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136225|h[Pathogen Glands]|h|r!','Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136225|h[Pathogen Glands]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71607,'Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136245|h[Metabolic Boost]|h|r!','Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136245|h[Metabolic Boost]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71608,'Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136246|h[Erupting Pustules]|h|r!','Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136246|h[Erupting Pustules]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71609,'Dis is gonna hurt!','',0,0,0,0,0,0,0,0,1,0,35566,0,26124),
(71610,'Primordius mutates out of control!','Primordius mutates out of control!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71611,'Hoku begins to corrupt your blood...','Hoku begins to corrupt your blood...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71612,'I am ready! [Queue for solo instance.]','I am ready! [Queue for solo instance.]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71613,'Welcome, weaklings, to the rebirth of the Zandalari Empire!','Welcome, weaklings, to the rebirth of the Zandalari Empire!',0,0,0,0,0,0,0,0,1,0,36009,36009,26124),
(71614,'The tribes have assembled - ye face not one force, but the combined might of all of the troll empire! The hand of Zul will span all the continents of Azeroth once again! An ye lesser races will know pain!','The tribes have assembled - ye face not one force, but the combined might of all of the troll empire! The hand of Zul will span all the continents of Azeroth once again! An ye lesser races will know pain!',0,0,0,0,0,0,0,0,1,0,36010,36010,26124),
(71615,'Now, witness the true might of the Beast Ward. D\'akala di\'chuka HORRIDON! Kalimaste!','Now, witness the true might of the Beast Ward. D\'akala di\'chuka HORRIDON! Kalimaste!',0,0,0,0,0,0,0,0,1,0,36011,36011,26124),
(71616,'Drakkari tribe, show them the might of the frozen North!','Drakkari tribe, show them the might of the frozen North!',0,0,0,0,0,0,0,0,1,0,36013,36013,26124),
(71617,'Gurubashi tribe, send their bloated corpses down the river with ya jungle poisons.','Gurubashi tribe, send their bloated corpses down the river with ya jungle poisons.',0,0,0,0,0,0,0,0,1,0,36014,36014,26124),
(71618,'Farraki tribe, flay their flesh wit the fury of the sands!','Farraki tribe, flay their flesh wit the fury of the sands!',0,0,0,0,0,0,0,0,1,0,36015,36015,26124),
(71619,'Amani tribe, avenge ye fallen warlords, in the name of Zul\'jin!','Amani tribe, avenge ye fallen warlords, in the name of Zul\'jin!',0,0,0,0,0,0,0,0,1,0,36016,36016,26124),
(71620,'Hahaha! Now it be my turn! Ye gonna see what it means to be a War-God!','Hahaha! Now it be my turn! Ye gonna see what it means to be a War-God!',0,0,0,0,0,0,0,0,1,0,36007,36007,26124),
(71621,'Ya skull gonna make a fine ornament for my tusks.','Ya skull gonna make a fine ornament for my tusks.',0,0,0,0,0,0,0,0,1,0,36012,36012,26124),
(71622,'Da\'kala koraste...Horridon...destroy them...','Da\'kala koraste...Horridon...destroy them...',0,0,0,0,0,0,0,0,1,0,36008,36008,26124),
(71623,'Hallo.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71624,'Did you just say \"hello\"?','Did you just say \"hello\"?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71625,'Nah. I said \"Hallo.\" But that\'s close enough.$b$bBye now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71626,'You have time to kill hapless island folk but no time to assemble my glorious body?','',0,0,0,0,0,0,0,0,1,20393,0,0,26124),
(71627,'Enough dilly dallying supplicant! I demand you assemble my body.','',0,0,0,0,0,0,0,0,1,20393,0,0,26124),
(71628,'You call that slaying an opponent? I expected more... fire. Or maybe some lightning.','',0,0,0,0,0,0,0,0,1,20393,0,0,26124),
(71629,'I have seen saurok with more fighting panache than what you have just displayed.','',0,0,0,0,0,0,0,0,1,20393,0,0,26124),
(71630,'Ah! Now that was a proper smiting. There is hope for you yet.','',0,0,0,0,0,0,0,0,1,20393,0,0,26124),
(71631,'Your skills are somewhat impressive. You shall make an excellent slave one day.','',0,0,0,0,0,0,0,0,1,20393,0,0,26124),
(71632,'I survived for hundreds of years during the Thunder King\'s reign. Do you know how? By not keeping my masters waiting!','',0,0,0,0,0,0,0,0,1,20393,0,0,26124),
(71633,'What a pitiful creature. And the thing you just killed.','',0,0,0,0,0,0,0,0,1,20393,0,0,26124),
(71634,'I am ready. Wake the guardians!','I am ready. Wake the guardians!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71635,'Shan Bu shall fall! Are you ready to proceed?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71636,'I\'m ready to take on Shan Bu!','I\'m ready to take on Shan Bu!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71637,'We are too late! Shan Bu is nearly done resurrecting Nalak, the Storm Lord. That is only incidental, however. Our true objective is to defeat Shan Bu!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71638,'','It is chaos out there, $p! The siege has begun but our heavy explosives never made it to the wall.',0,0,0,0,0,0,5,0,1,0,0,36375,26124),
(71639,'','I will cover the flanks. Gather up our explosives and get them to the wall. Hurry!',0,0,0,0,0,0,1,0,1,0,0,36376,26124),
(71640,'Zeb\'tula Beastcaller summons raptors to his aid!','Zeb\'tula Beastcaller summons raptors to his aid!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71641,'I have selected a landing site for our forces: a small peninsula to our east that is easily defended.','',0,0,0,0,0,0,0,0,1,0,35616,0,26124),
(71642,'Alas, the Zandalari trolls have already claimed and fortified it.','',0,0,0,0,0,0,0,0,1,0,35617,0,26124),
(71643,'They\'re protecting it with a powerful spirit barrier. We will need to disable it before our ships can land.','',0,0,0,0,0,0,0,0,1,0,35618,0,26124),
(71644,'Champion, I need you to lead a ground assault and take down that barrier from within!','',0,0,0,0,0,0,0,0,1,0,35619,0,26124),
(71645,'Mount up and rendezvous with Scout Captain Elsia. She is organizing an elite group of rangers to accompany you. May the light of the sun shine upon you.','',0,0,0,0,0,0,0,0,1,0,35620,0,26124),
(71646,'','Up here, champion!',0,0,0,0,0,0,0,0,1,0,0,35358,26124),
(71647,'','The Sunreavers have devised a way to ward our flying mounts against the lightning. But fly in loose formation, just in case.',0,0,0,0,0,0,0,0,1,0,0,35359,26124),
(71648,'','Look below! Our continued assaults on the town and crypts have thrown the enemy into disarray. The mogu and the Zandalari already fear the might of the Horde.',0,0,0,0,0,0,0,0,1,0,0,35360,26124),
(71649,'','Do you see the central tower? Lightning strikes it continuously. Aethas suspects that the storms originate from the heart of the palace itself.',0,0,0,0,0,0,0,0,1,0,0,35361,26124),
(71650,'','The other rangers are waiting for us just ahead. Our first priority is - Look out!',0,0,0,0,0,0,0,0,1,0,0,35362,26124),
(71651,'','By the sunwell! The skies betray us - we are not safe up here!',0,0,0,0,0,0,0,0,1,0,0,35363,26124),
(71652,'','Down! Everyone, down!',0,0,0,0,0,0,0,0,1,0,0,35364,26124),
(71653,'','Champion, are you all right?',0,0,0,0,0,0,0,0,1,0,0,35365,26124),
(71654,'','We were not safe at all. They were waiting for us. Our forces are scattered throughout the swamp, and we are alone behind enemy lines!',0,0,0,0,0,0,0,0,1,0,0,35366,26124),
(71655,'','No. Not good.',0,0,0,0,0,0,0,0,1,0,0,35367,26124),
(71656,'','They are pulling back, but we cannot let up now.',0,0,0,0,0,0,0,0,1,0,0,35368,26124),
(71657,'','Our only hope of getting out of here alive is to take the town.',0,0,0,0,0,0,0,0,1,0,0,35369,26124),
(71658,'','The entrance is barricaded. Break it down!',0,0,0,0,0,0,0,0,1,0,0,35370,26124),
(71659,'','I do not like the look of that troll. Be careful!',0,0,0,0,0,0,0,0,1,0,0,35371,26124),
(71660,'','Defeat that creature so we can free our own!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71661,'','They are protecting that mask. It must be the source of the barrier. Destroy it!',0,0,0,0,0,0,0,0,1,0,0,35372,26124),
(71662,'','Destroy the spirit mask to bring down the barrier!',0,0,0,0,0,0,0,0,1,0,0,35373,26124),
(71663,'','He is protecting the mask. Kill him!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71664,'','Do not back down. We are winning this!',0,0,0,0,0,0,0,0,1,0,0,35375,26124),
(71665,'','The shield - it is down! We did it!',0,0,0,0,0,0,0,0,1,0,0,35376,26124),
(71666,'','Champion, without your help I would\'ve died in that swamp. I owe you my very life.',0,0,0,0,0,0,0,0,1,0,0,35377,26124),
(71667,'','Good work, hero. Let\'s move on.',0,0,0,0,0,0,0,0,1,0,0,35378,26124),
(71668,'','You\'re an inspiration.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71669,'','You make this look easy.',0,0,0,0,0,0,0,0,1,0,0,35380,26124),
(71670,'','I like your style, hero.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71671,'','Impressive!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71672,'Victory to the Sin\'dorei! And another triumph for the Horde.','',0,0,0,0,0,0,0,0,1,0,35621,0,26124),
(71673,'Rommath, establish a perimeter. Aethas, begin placing the sentry wards. Kethiel, unload the shelters and supplies.','',0,0,0,0,0,0,0,0,1,0,35622,0,26124),
(71674,'Brothers and sisters of the Horde! Enemies surround us on all sides! Your courage in weeks to come will be the difference between victory and defeat.','',0,0,0,0,0,0,0,0,1,0,35623,0,26124),
(71675,'Champion, you have brought glory to the Horde. Your unshakable will has secured our position here. Now, the true work begins.','',0,0,0,0,0,0,0,0,1,0,35624,0,26124),
(71676,'They come! To arms me brothers - hurl them back to the sea!','',0,0,0,0,0,0,0,0,1,0,35415,0,26124),
(71677,'Hold the ruins. Slay them where they stand!','',0,0,0,0,0,0,0,0,1,0,35417,0,26124),
(71678,'Crush the intruders. The barrier must not fall.','',0,0,0,0,0,0,0,0,1,0,35418,0,26124),
(71679,'Face me now! My will is iron. My people, unbreakable!','',0,0,0,0,0,0,0,0,1,0,35419,0,26124),
(71680,'You are nothing! You are food for my beasts!','',0,0,0,0,0,0,0,0,1,0,35420,0,26124),
(71681,'The spirits will feast on your blood!','',0,0,0,0,0,0,0,0,1,0,35421,0,26124),
(71682,'Spirits give me strength. Break their will...','',0,0,0,0,0,0,0,0,1,0,35422,0,26124),
(71683,'Zandalar...','',0,0,0,0,0,0,0,0,1,0,35423,0,26124),
(71684,'Wake up, kitties. It\'s time to play...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71685,'Take down the gatekeepers! It will unlock the gates!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71686,'That takes care of them. Are you ready for me to open the gates?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71687,'We were too late to stop the resurrection of Nalak, but not to defeat Shan Bu and his forces! Attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71688,'Shan Bu, it is time! Stop hiding behind that magic of yours and fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71689,'Look out! Zandalari are jumping over the walls! Knock those Beastcallers off their mounts!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71690,'You underestimated us, Shan Bu. We have rid this place of you, and Pandaria is better for it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71691,'Hefting','Hefting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71692,'Rise, Nalak. Bring forth your wrath upon those who would sully our master\'s palace!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71693,'','The explosives!$b$bGood work, $n. Not a moment too soon.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(71694,'Here are the explosives, Elsia.','Here are the explosives, Elsia.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71695,'','Hurry, $n!$b$bThere\'s no way we\'ll breach this wall without those explosives!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(71696,'','Ugh! Hold on!',0,0,0,0,0,0,0,0,1,0,0,36372,26124),
(71697,'','I\'ve selected a landing site on the island: high ground that\'s easily defended.',0,0,0,0,0,0,0,0,1,0,0,35526,26124),
(71698,'','Unfortunately, the Zandalari trolls have already claimed and fortified it.',0,0,0,0,0,0,0,0,1,0,0,35527,26124),
(71699,'','They\'re protecting it with a powerful spirit barrier. We\'ll need to take it down before we can portal our troops in.',0,0,0,0,0,0,0,0,1,0,0,35528,26124),
(71700,'','Champion, I need you to lead a ground assault and shatter that barrier from within!',0,0,0,0,0,0,0,0,1,0,0,35529,26124),
(71701,'','Mount up and rendezvous with Vereesa Windrunner. She is organizing the forces that will accompany you.',0,0,0,0,0,0,0,0,1,0,0,35530,26124),
(71702,'','Up here, champion!',0,0,0,0,0,0,0,0,1,0,0,35943,26124),
(71703,'','I think we have figured out a way to ward our flying mounts against the lightning. But fly in loose formation, just in case.',0,0,0,0,0,0,0,0,1,0,0,35944,26124),
(71704,'','Our continued incursions into the graveyard and town below are already paying off. Neither the mogu nor the Zandalari should be able to mount a counter-attack.',0,0,0,0,0,0,0,0,1,0,0,35945,26124),
(71705,'','Do you see the central tower? Lightning strikes it continuously. We suspect the storms originate from the heart of the palace itself.',0,0,0,0,0,0,0,0,1,0,0,35946,26124),
(71706,'','The rendezvous is just up ahead. We\'ve gathered an elite strike force - What?',0,0,0,0,0,0,0,0,1,0,0,35947,26124),
(71707,'','Anar\'alah! The skies betray us - we are not safe up here!',0,0,0,0,0,0,0,0,1,0,0,35948,26124),
(71708,'','Down! Everybody down!',0,0,0,0,0,0,0,0,1,0,0,35949,26124),
(71709,'','Champion, are you all right?',0,0,0,0,0,0,0,0,1,0,0,35950,26124),
(71710,'','They were ready for us all along. Our forces are scattered, and we are on our own.',0,0,0,0,0,0,0,0,1,0,0,35951,26124),
(71711,'','So much for the element of surprise.',0,0,0,0,0,0,0,0,1,0,0,35952,26124),
(71712,'','They are falling back! We need to press the assault before they can regroup. Follow me!',0,0,0,0,0,0,0,0,1,0,0,35953,26124),
(71713,'','As I always say - Victory to the bold!',0,0,0,0,0,0,0,0,1,0,0,35954,26124),
(71714,'','The entrance is barricaded. Break it down!',0,0,0,0,0,0,0,0,1,0,0,35955,26124),
(71715,'','Be quick on your feet - that is no ordinary Zandalari!',0,0,0,0,0,0,0,0,1,0,0,35956,26124),
(71716,'','They are protecting that mask. It must be the source of the barrier. Destroy it!',0,0,0,0,0,0,0,0,1,0,0,35957,26124),
(71717,'','Destroy the spirit mask to bring down the barrier!',0,0,0,0,0,0,0,0,1,0,0,35958,26124),
(71718,'','He\'s protecting the mask. Kill him!',0,0,0,0,0,0,0,0,1,0,0,35959,26124),
(71719,'','Keep it up, they are beginning to rout!',0,0,0,0,0,0,0,0,1,0,0,35960,26124),
(71720,'','The shield - it is down! We did it!',0,0,0,0,0,0,0,0,1,0,0,35961,26124),
(71721,'','Jaina was right to recommend you. You saved this mission from disaster... and saved my life.',0,0,0,0,0,0,0,0,1,0,0,35962,26124),
(71722,'','That\'s the Alliance spirit for you - unstoppable!',0,0,0,0,0,0,273,0,1,0,0,35531,26124),
(71723,'','Vereesa, establish a perimeter. Modera, place the sentry wards. Narasi, begin porting in tents and supplies.',0,0,0,0,0,0,25,0,1,0,0,35532,26124),
(71724,'','Everyone take up positions! Enemies surround us on all sides! There is no time to waste.',0,0,0,0,0,0,1,0,1,0,0,35533,26124),
(71725,'','Champion, you have exceeded my expectations. Our position on the isle is secured, thanks to your courage and your will. Now, the true work begins.',0,0,0,0,0,0,1,0,1,0,0,35534,26124),
(71726,'','Good work, hero. Let\'s move on.',0,0,0,0,0,0,0,0,1,0,0,35963,26124),
(71727,'','As much as I expected from a troll.',0,0,0,0,0,0,0,0,1,0,0,35964,26124),
(71728,'','In the name of the Kirin Tor!',0,0,0,0,0,0,0,0,1,0,0,35965,26124),
(71729,'','I like your style, hero.',0,0,0,0,0,0,0,0,1,0,0,35966,26124),
(71730,'','Impressive!',0,0,0,0,0,0,0,0,1,0,0,35967,26124),
(71731,'You have not seen the full might o\' the Zandalari!','',0,0,0,0,0,0,0,0,1,0,35416,0,26124),
(71732,'$n forces Horridon to charge the Farraki door!','$n forces Horridon to charge the Farraki door!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71733,'$n forces Horridon to charge the Gurubashi door!','$n forces Horridon to charge the Gurubashi door!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71734,'$n forces Horridon to charge the Drakkari door!','$n forces Horridon to charge the Drakkari door!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71735,'$n forces Horridon to charge the Amani door!','$n forces Horridon to charge the Amani door!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71736,'The Zandalari Dinomancer drops an Orb of Control!','The Zandalari Dinomancer drops an Orb of Control!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71737,'','The charges are placed. Hero - you may have the honor.',0,0,0,0,0,0,1,0,7,0,0,36377,26124),
(71738,'Did ya think ya could just fly ova\' hea\' unnoticed?!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(71739,'Well, ya got where you were goin\'. Too bad you\'re not gonna live long enough to see it!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(71740,'Prepare to die, intrudah!','',0,0,0,0,0,0,53,0,1,0,0,0,26124),
(71741,'Horaki readies a Frost Shot!','Horaki readies a Frost Shot!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71742,'Horaki launches a Hail of Arrows into the sky!','Horaki launches a Hail of Arrows into the sky!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71743,'$n calls for food!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(71744,'|TInterface\\Icons\\achievement_moguraid_03:20|t%s is |cFFF00000|Hspell:136442|h[Possessed]|h|r by the spirit of Gara\'jal!','|TInterface\\Icons\\achievement_moguraid_03:20|t%s is |cFFF00000|Hspell:136442|h[Possessed]|h|r by the spirit of Gara\'jal!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71745,'How is a locksmith supposed to make a living in a world with no locked doors?','How is a locksmith supposed to make a living in a world with no locked doors?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71746,'|TInterface\\Icons\\spell_priest_divinestar:20|t%s summons a |cFFF00000|Hspell:137203|h[Blessed Loa Spirit]|h|r!','|TInterface\\Icons\\spell_priest_divinestar:20|t%s summons a |cFFF00000|Hspell:137203|h[Blessed Loa Spirit]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71747,'|TInterface\\Icons\\spell_priest_divinestar_shadow2:20|t%s summons a |cFFF00000|Hspell:137350|h[Shadowed Loa Spirit]|h|r!','|TInterface\\Icons\\spell_priest_divinestar_shadow2:20|t%s summons a |cFFF00000|Hspell:137350|h[Shadowed Loa Spirit]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71748,'|TInterface\\Icons\\spell_monk_envelopingmist:20|t%s summons a deadly |cFFF00000|Hspell:136894|h[Sandstorm]|h|r!','|TInterface\\Icons\\spell_monk_envelopingmist:20|t%s summons a deadly |cFFF00000|Hspell:136894|h[Sandstorm]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71749,'|TInterface\\Icons\\spell_shaman_staticshock:20|t%s |cFFF00000|Hspell:137149|h[Overloads]|h|r!','|TInterface\\Icons\\spell_shaman_staticshock:20|t%s |cFFF00000|Hspell:137149|h[Overload]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71750,'|TInterface\\Icons\\spell_shaman_staticshock:20|t%s begins to |cFFF00000|Hspell:137166|h[Discharge]|h|r!','|TInterface\\Icons\\spell_shaman_staticshock:20|t%s begins to |cFFF00000|Hspell:137166|h[Discharge]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71751,'|TInterface\\Icons\\ability_deathknight_remorselesswinters2:20|tMove away from your allies! You are afflicted with |cFFF00000|Hspell:136991|h[Biting Cold]|h|r!','|TInterface\\Icons\\ability_deathknight_remorselesswinters2:20|tMove away from your allies! You are afflicted with |cFFF00000|Hspell:136991|h[Biting Cold]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71752,'|TInterface\\Icons\\spell_mage_frostbomb:20|t$n is afflicted with |cFFF00000|Hspell:136922|h[Frostbite]|h|r!','|TInterface\\Icons\\spell_mage_frostbomb:20|t$n is afflicted with |cFFF00000|Hspell:136922|h[Frostbite]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71753,'I am ready to launch the assault [Queue for solo instance.]','I am ready to launch the assault [Queue for solo instance.]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71754,'','Good, you are here.',0,0,0,0,0,0,0,0,1,0,0,36594,26124),
(71755,'','Regent Lord! Everyone is in position, and the Shado-Pan are inside, but...',0,0,0,0,0,0,0,0,1,0,0,36595,26124),
(71756,'','The Alliance is waiting for us just across the courtyard.',0,0,0,0,0,0,0,0,1,0,0,36385,26124),
(71757,'Yes?','',0,0,0,0,0,0,0,0,1,0,35639,0,26124),
(71758,'Ahhh, so the grand lady of the Kirin Tor wants a fight, does she?','',0,0,0,0,0,0,0,0,1,0,35640,0,26124),
(71759,'Rangers! Advance!','',0,0,0,0,0,0,0,0,1,0,35641,0,26124),
(71760,'I will deal with Proudmoore.','',0,0,0,0,0,0,0,0,1,0,35642,0,26124),
(71761,'|TInterface\\Icons\\spell_nature_unrelentingstorm.blp:20|t The |cFFFF0000|Hspell:135680|h[North Conduit]|h|r has burned out and caused |cFFFF0000|Hspell:137176|h[Overloaded Circuits]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71762,'|TInterface\\Icons\\spell_nature_unrelentingstorm.blp:20|t The |cFFFF0000|Hspell:135681|h[East Conduit]|h|r has burned out and caused |cFFFF0000|Hspell:137176|h[Overloaded Circuits]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71763,'|TInterface\\Icons\\spell_nature_unrelentingstorm.blp:20|t The |cFFFF0000|Hspell:135682|h[South Conduit]|h|r has burned out and caused |cFFFF0000|Hspell:137176|h[Overloaded Circuits]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71764,'|TInterface\\Icons\\spell_nature_unrelentingstorm.blp:20|t The |cFFFF0000|Hspell:135683|h[West Conduit]|h|r has burned out and caused |cFFFF0000|Hspell:137176|h[Overloaded Circuits]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71765,'One problem at a time, people. Focus on the Zandalari!','',0,0,0,0,0,0,0,0,1,0,35643,0,26124),
(71766,'YOU will kneel when you beg for my mercy, monster.','',0,0,0,0,0,0,0,0,1,0,35888,0,26124),
(71767,'Taran Zhu! It does not matter how many you array against the Thunder King. Soon all will kneel before him.','',0,0,0,0,0,0,0,0,1,0,35769,0,26124),
(71768,'Those statues wield the power of the first emperor. Destroy them!','',0,0,0,0,0,0,0,0,1,0,35889,0,26124),
(71769,'Taoshi, get those doors open.','',0,0,0,0,0,0,0,0,1,0,35890,0,26124),
(71770,'Champion, with me. We must press forward while your comrades cover the rear.','',0,0,0,0,0,0,0,0,1,0,35891,0,26124),
(71771,'','The Thunder King\'s palace lies ahead. We must secure a foothold on the island before we can assault his fortress.',0,0,0,0,0,0,0,0,1,0,0,36373,26124),
(71772,'','Regent Lord - more Zandalari approach from the mines!',0,0,0,0,0,0,0,0,1,0,0,36386,26124),
(71773,'Damn their hides. Rangers! Hold this position!','',0,0,0,0,0,0,0,0,1,0,35644,0,26124),
(71774,'Who needs a God? We have the Thunder King!','',0,0,0,0,0,0,0,0,1,0,35770,0,26124),
(71775,'Trolls - make yourselves useful. I am almost finished here.','',0,0,0,0,0,0,0,0,1,0,35771,0,26124),
(71776,'Shan Bu! Again you try to create a God. When will you learn?','',0,0,0,0,0,0,0,0,1,0,35892,0,26124),
(71777,'Zandalari reinforcements are coming.','',0,0,0,0,0,0,0,0,1,0,35893,0,26124),
(71778,'Yalia - we need more healing! Taoshi - cover the rear!','',0,0,0,0,0,0,0,0,1,0,35894,0,26124),
(71779,'Face me, Shan Bu! Or is the court of the Thunder King a den of cowards?','',0,0,0,0,0,0,0,0,1,0,35895,0,26124),
(71780,'Arise, Nalak! Protect our beloved emperor.','',0,0,0,0,0,0,0,0,1,0,35772,0,26124),
(71781,'The emperor will be most pleased when I present him with your head, Shado-Pan.','',0,0,0,0,0,0,0,0,1,0,35773,0,26124),
(71782,'The unworthy have not yet learned of my power.','',0,0,0,0,0,0,1,0,7,0,35577,0,26124),
(71783,'War-God Al\'chukla, add my strength to your own.','',0,0,0,0,0,0,1,0,7,0,35578,0,26124),
(71784,'','The priests imbue the guardian with their Loas! They must be stopped!',0,0,0,0,0,0,0,0,1,20514,0,0,26124),
(71785,'','You must hurry!',0,0,0,0,0,0,0,0,1,20514,0,0,26124),
(71786,'','The guardian\'s power grows! Kill them before it\'s too late!',0,0,0,0,0,0,0,0,1,20514,0,0,26124),
(71787,'','The guardian has awoken! Destroy it!',0,0,0,0,0,0,0,0,1,20514,0,0,26124),
(71788,'','You have robbed it of its strength. Now rob it of its life!',0,0,0,0,0,0,0,0,1,20514,0,0,26124),
(71789,'The battle begins in 2 minutes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71790,'The battle begins in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71791,'The battle begins in 30 seconds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71792,'The battle has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71793,'','The priests imbue the guardian with their Loas! They must be stopped!',0,0,0,0,0,0,0,0,1,20556,0,0,26124),
(71794,'','The guardian\'s power grows! Kill them before it\'s too late!',0,0,0,0,0,0,0,0,1,20556,0,0,26124),
(71795,'','You must hurry!',0,0,0,0,0,0,0,0,1,20556,0,0,26124),
(71796,'','The guardian has awoken! Destroy it!',0,0,0,0,0,0,0,0,1,20556,0,0,26124),
(71797,'','You have robbed it of its strength. Now rob it of its life!',0,0,0,0,0,0,0,0,1,20556,0,0,26124),
(71798,'Make a demonstration of these invaders, such that all nations tremble before me.','',0,0,0,0,0,0,1,0,7,0,35579,0,26124),
(71799,'All will fall before us!!','',0,0,0,0,0,0,1,0,7,0,35990,0,26124),
(71800,'Shan Bu, secure the inner courtyard. None should look upon my works and live.','',0,0,0,0,0,0,1,0,7,0,35580,0,26124),
(71801,'As my emperor wills!','',0,0,0,0,0,0,1,0,7,0,35767,0,26124),
(71802,'This island is home to a very powerful magic. If we can harness it, no one will be able to stand in our way.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71803,'The Zandalari here practice a dark magic I am unfamiliar with. They mix arcane powers with shadow; a frightening and dangerous combination.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71804,'The magic emanating from this area is fascinating, $c. I\'m anxious to study their artifacts. There is so much we can learn.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71805,'Have you seen the golems that wander these paths, $c? Spirits bound to servitude of the Zandalari for all of eternity.$b$bPerhaps, the Mogu and the Zandalari are more alike than we ever anticipated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71806,'A Restless Spirit is after your soul.  Don\'t let it reach you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71807,'A Draining Spirit is draining your soul. Hide from it to break the spell!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71808,'','Ah! Hero, we were just talking about you.',0,0,0,0,0,0,396,0,1,0,0,35544,26124),
(71809,'It does not matter. Taoshi\'s proposal is too dangerous.','',0,0,0,0,0,0,274,0,1,0,35915,0,26124),
(71810,'','If we are to bring down the Thunder King, we must breech the shipyard. Now is the time for bold ideas!',0,0,0,0,0,0,396,0,1,0,0,35545,26124),
(71811,'','Champion, hear me out: We strike the shipyard at night, using this magnificent beast you have tamed.',0,0,0,0,0,0,1,0,1,0,0,35849,26124),
(71812,'','Once inside, we sabotage the Zandalari ship. In the chaos, we will slip into the courtyard and open the gates from within.',0,0,0,0,0,0,1,0,1,0,0,35850,26124),
(71813,'','I love it! Brains over brute force.',0,0,0,0,0,0,396,0,1,0,0,35546,26124),
(71814,'Very well, Taoshi. If our champion here agrees, the mission may proceed.','',0,0,0,0,0,0,1,0,1,0,35916,0,26124),
(71815,'','Thank you, Lord Zhu. I will not let you down.',0,0,0,0,0,0,2,0,1,0,0,35851,26124),
(71816,'','Speak with me when you are ready.',0,0,0,0,0,0,1,0,1,0,0,35848,26124),
(71817,'Ah! Champion, we were just talking about you.','',0,0,0,0,0,0,1,0,1,0,35669,0,26124),
(71818,'The sheer audacity of the plan is exactly what intrigues me. If we breech the shipyard, we will deprive the mogu of further Zandalari reinforcements.','',0,0,0,0,0,0,1,0,1,0,35670,0,26124),
(71819,'You\'ve been afflicted by Spirit\'s Wrath.  Run away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71820,'Surely you agree that decisive action wins wars, Lord Zhu.','',0,0,0,0,0,0,1,0,1,0,35671,0,26124),
(71821,'','I count six... no, seven guards on patrol in the sky.',0,0,0,0,0,0,0,0,1,0,0,35852,26124),
(71822,'','One of them flies higher than the others... He loops far out over the water - alone. He is over-extending. That is our in.',0,0,0,0,0,0,0,0,1,0,0,35853,26124),
(71823,'','We will neutralize him and take his route. Let\'s go!',0,0,0,0,0,0,0,0,1,0,0,35854,26124),
(71824,'','Just a little closer...',0,0,0,0,0,0,0,0,1,0,0,35855,26124),
(71825,'','Hyah!',0,0,0,0,0,0,0,0,1,0,0,35856,26124),
(71826,'','The Zandalari are more cautious than I thought. Look down there - swarming with patrols.',0,0,0,0,0,0,0,0,1,0,0,35857,26124),
(71827,'','Those archers are keeping a close watch over the shipping area.',0,0,0,0,0,0,0,0,1,0,0,35858,26124),
(71828,'','And their shamans have laid out a network of sentry totems.',0,0,0,0,0,0,0,0,1,0,0,35859,26124),
(71829,'','Here: Use these darts to take down as many archers as you can.',0,0,0,0,0,0,0,0,1,0,0,35860,26124),
(71830,'','One of these smoke bombs will blind a sentry totem.',0,0,0,0,0,0,0,0,1,0,0,35861,26124),
(71831,'','We cannot circle up here for long. Do what you can while I plan our next move.',0,0,0,0,0,0,0,0,1,0,0,35863,26124),
(71832,'','We have got to disable more of their defenses or we will never be able to get in! Loop around again.',0,0,0,0,0,0,0,0,1,0,0,35865,26124),
(71833,'Awaken, Hu\'seng! The docks are your responsibility. See that none pass his majesty\'s gates.','',0,0,0,0,0,0,0,0,1,0,35781,0,26124),
(71834,'The Thunder King wills it; it shall be done.','',0,0,0,0,0,0,0,0,1,0,35446,0,26124),
(71835,'','Our time is up. We need to get aboard that ship.',0,0,0,0,0,0,0,0,1,0,0,35864,26124),
(71836,'','We should sabotage the siege weapons toward the bow. Then we will go below decks and find the captain.',0,0,0,0,0,0,0,0,1,0,0,35868,26124),
(71837,'','Easy now... Get in close and incapacitate them.',0,0,0,0,0,0,0,0,1,0,0,35866,26124),
(71838,'','I will take the ugly one.',0,0,0,0,0,0,0,0,1,0,0,35869,26124),
(71839,'','Not as quiet as I would prefer, but it works.',0,0,0,0,0,0,0,0,1,0,0,35870,26124),
(71840,'','There will be a very unpleasant surprise waiting for the next troll who disturbs these. Let\'s keep moving.',0,0,0,0,0,0,0,0,1,0,0,35867,26124),
(71841,'%s snores peacefully.','',0,0,0,0,0,0,0,0,1,0,35320,0,26124),
(71842,'Hm-wha? Stowaways!','',0,0,0,0,0,0,0,0,1,0,35321,0,26124),
(71843,'If this be the caliber of pandaren to resist us, this land be ours in no time!','',0,0,0,0,0,0,0,0,1,0,35322,0,26124),
(71844,'Oh hoh, you tickle me. But I be done playin\' with you.','',0,0,0,0,0,0,0,0,1,0,35323,0,26124),
(71845,'I am UNSINKABLE!','',0,0,0,0,0,0,0,0,1,0,35324,0,26124),
(71846,'You... never get outta here... alive.','',0,0,0,0,0,0,0,0,1,0,35325,0,26124),
(71847,'','The courtyard gate is directly up that hill.',0,0,0,0,0,0,0,0,1,0,0,35871,26124),
(71848,'','Remember to stay clear of those sentry totems.',0,0,0,0,0,0,0,0,1,0,0,35872,26124),
(71849,'','Let\'s move.',0,0,0,0,0,0,0,0,1,0,0,35873,26124),
(71850,'','Wait for it...',0,0,0,0,0,0,0,0,1,0,0,35874,26124),
(71851,'','Go!',0,0,0,0,0,0,0,0,1,0,0,35875,26124),
(71852,'','Sounds like they found our little present.',0,0,0,0,0,0,0,0,1,0,0,35877,26124),
(71853,'','Here! Into the smoke!',0,0,0,0,0,0,0,0,1,0,0,35876,26124),
(71854,'Enough hiding, little ones!','',0,0,0,0,0,0,0,0,1,0,35447,0,26124),
(71855,'There is no escape now. The only way out is through me!','',53,0,0,0,0,0,0,0,1,0,35448,0,26124),
(71856,'','Through you, is it? I think we can manage that.',397,0,0,0,0,0,397,0,1,0,0,35878,26124),
(71857,'','Would you prefer we go through the belly, or the ribcage?',547,0,0,0,0,0,45,0,1,0,0,35879,26124),
(71858,'These gates are sealed by imperial decree.','',0,0,0,0,0,0,0,0,1,0,35449,0,26124),
(71859,'You, pandaren! You will be back in chains where you belong.','',0,0,0,0,0,0,0,0,1,0,35450,0,26124),
(71860,'Your little friend is disposable.','',0,0,0,0,0,0,0,0,1,0,35451,0,26124),
(71861,'Trespassers will be executed!','',0,0,0,0,0,0,0,0,1,0,35452,0,26124),
(71862,'Keep. OUT!','',0,0,0,0,0,0,0,0,1,0,35453,0,26124),
(71863,'You are finished!','',0,0,0,0,0,0,0,0,1,0,35454,0,26124),
(71864,'To strike me is to strike his Majesty! He will not suffer this insult!','',0,0,0,0,0,0,0,0,1,0,35455,0,26124),
(71865,'None... shall...','',0,0,0,0,0,0,0,0,1,0,35456,0,26124),
(71866,'','Well fought! Now - the gates. Before the thunder king\'s entire army comes down on us!',396,0,0,0,0,0,0,0,1,0,0,35880,26124),
(71867,'','Rangers - shatter the hinges. Wedge the doors open!',0,0,0,0,0,0,0,0,1,0,0,35940,26124),
(71868,'','Your plan worked! The two of you accomplished the work of an army.',0,0,0,0,0,0,0,0,1,0,0,35941,26124),
(71869,'','The fighting skills of my companion are quickly becoming legendary among the Shado-Pan.',396,0,0,0,0,0,0,0,1,0,0,35881,26124),
(71870,'','Indeed. We must get you two back to safety. Thanks to you, the Thunder King is now completely under siege.',0,0,0,0,0,0,0,0,1,0,0,35942,26124),
(71871,'','Rangers - shatter the hinges. Wedge the doors open!',0,0,0,0,0,0,0,0,1,0,0,36393,26124),
(71872,'','Your plan worked! The two of you accomplished the work of an army.',0,0,0,0,0,0,0,0,1,0,0,36394,26124),
(71873,'','The Regent Lord will want a full report. Let\'s get you back to camp - you have earned a rest.',0,0,0,0,0,0,0,0,1,0,0,36395,26124),
(71874,'','Would you believe I was laughed at when I began researching magic that would mask one\'s scent? It was deemed as impractical and a waste of time by the Arch-magi.$b$bWell, who is standing upwind of a devilsaur and laughing now? Ha!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71875,'','It is a shame I am only able to mask our own smells and not the foul odors pouring out of the Zandalari and their beasts.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71876,'','I never was very fond of field work. Especially when it involves vast quantities of trolls.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71877,'Keep moving! Avoid the Storm-Lord\'s lightning!','',0,0,0,0,0,0,0,0,1,0,35896,0,26124),
(71878,'Stay close to Yalia\'s healing, champion!','',0,0,0,0,0,0,0,0,1,0,35897,0,26124),
(71879,'Dance around Shan Bu\'s attacks. We are faster! We are smarter!','',0,0,0,0,0,0,0,0,1,0,35898,0,26124),
(71880,'Stay near Yalia so that she may heal you!','',0,0,0,0,0,0,0,0,1,0,35899,0,26124),
(71881,'Your cries of pain delight his majesty!','',0,0,0,0,0,0,0,0,1,0,35777,0,26124),
(71882,'Ours is to rule. Yours is to serve!','',0,0,0,0,0,0,0,0,1,0,35778,0,26124),
(71883,'You are weak. You Shado-Pan scurry through shadows like roaches.','',0,0,0,0,0,0,0,0,1,0,35774,0,26124),
(71884,'','%s begins to heal her sister!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71885,'I tire of your insolence! I will choke the life from you, impudent slave!','',0,0,0,0,0,0,0,0,1,0,35779,0,26124),
(71886,'Auugh - kill him. Quickly!','',0,0,0,0,0,0,0,0,1,0,35903,0,26124),
(71887,'Finish him!','',0,0,0,0,0,0,0,0,1,0,35904,0,26124),
(71888,'An Essence of Storms erupts from the embedded spear and fixates on you!','An Essence of Storms erupts from the embedded spear and fixates on you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71889,'I ... no... My emperor! My emperor, I have failed you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71890,'The storm will consume you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71891,'Lord of thunder... protect me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71892,'|TInterface\\Icons\\ability_warlock_jinx:20|t%s begins to cast |cFFF00000|Hspell:137891|h[Twisted Fate]|h|r!','|TInterface\\Icons\\ability_warlock_jinx:20|t%s begins to cast |cFFF00000|Hspell:137891|h[Twisted Fate]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71893,'','The shadows will be our allies.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71894,'Queue for A Dagger in the Dark.','Queue for A Dagger in the Dark.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71895,'The Zandalari are a proud race. Their pride will ultimately be their undoing.$b$bEven the most powerful of foes have a weakness; we need only to find it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71896,'And thus... the spark of life... fades...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71897,'BLOOD! DELICIOUS! You shall feed me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71898,'Even your own blood can be made to serve!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71899,'No! My blood, it... spills...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71900,'Champion! Our campaign is reaching a climax: We are at the very threshold of the Thunder King\'s palace. It is time to knock down his front door.','',0,0,0,0,0,0,0,0,1,0,35637,0,26124),
(71901,'Speak to me when you are ready to launch the assault!','',0,0,0,0,0,0,0,0,1,0,35638,0,26124),
(71902,'','Your timing is perfect as always, hero. It is time to kick down the Thunder King\'s front door.',0,0,0,0,0,0,0,0,1,0,0,35497,26124),
(71903,'','Speak to me when you are ready to launch the assault!',0,0,0,0,0,0,0,0,1,0,0,35498,26124),
(71904,'','Good, you are here.',0,0,0,0,0,0,0,0,1,0,0,36156,26124),
(71905,'','Lady Proudmoore! Everyone is in position, and the Shado-Pan are inside, but...',0,0,0,0,0,0,0,0,1,0,0,36157,26124),
(71906,'','But what?',0,0,0,0,0,0,0,0,1,0,0,35499,26124),
(71907,'','The Horde is just across the courtyard.',0,0,0,0,0,0,0,0,1,0,0,35930,26124),
(71908,'','Of course they are. One problem at a time, Vereesa.',0,0,0,0,0,0,0,0,1,0,0,35500,26124),
(71909,'','Everyone! Advance!',0,0,0,0,0,0,0,0,1,0,0,35501,26124),
(71910,'','... and if anyone sees that traitor, Aethas Sunreaver, save that one for me...',0,0,0,0,0,0,0,0,1,0,0,35502,26124),
(71911,'','Ignore the Horde - focus on the Zandalari guarding the door!',0,0,0,0,0,0,0,0,1,0,0,35503,26124),
(71912,'','Lady Proudmoore - more Zandalari are approaching from the docks.',0,0,0,0,0,0,0,0,1,0,0,35931,26124),
(71913,'','They\'re trying to flank us. Hold this position!',0,0,0,0,0,0,0,0,1,0,0,35504,26124),
(71914,'Look out, he is coming your way!','',0,0,0,0,0,0,0,0,1,0,35900,0,26124),
(71915,'Don\'t let him get close to you!','',0,0,0,0,0,0,0,0,1,0,35901,0,26124),
(71916,'Be careful - he is coming for you!','',0,0,0,0,0,0,0,0,1,0,35902,0,26124),
(71917,'Your \"Alliance\" is all flash, no strength whatsoever.','',0,0,0,0,0,0,0,0,1,20702,35775,0,26124),
(71918,'Your \"Horde\" is a disgusting pack of animals, hardly worth enslaving.','',0,0,0,0,0,0,0,0,1,20703,35776,0,26124),
(71919,'You see? No power of this world can trample the pure of spirit.','',0,0,0,0,0,0,0,0,1,0,35905,0,26124),
(71920,'','Lord Zhu! The Alliance - the Horde - all chaos is about to erupt out here!',0,0,0,0,0,0,0,0,1,0,0,35820,26124),
(71921,'Like children.','',0,0,0,0,0,0,0,0,1,0,36158,0,26124),
(71922,'Taoshi! Hand me my weapon.','',0,0,0,0,0,0,0,0,1,0,36159,0,26124),
(71923,'','My Lord... you are gravely wounded!',0,0,0,0,0,0,0,0,1,0,0,35821,26124),
(71924,'My weapon! Champion, with me. I want you to see this.','',0,0,0,0,0,0,0,0,1,0,35907,0,26124),
(71925,'','Hand over the Archmage and I may yet allow you to walk out of here, Lor\'themar.',0,0,0,0,0,0,0,0,1,0,0,35505,26124),
(71926,'Proudmoore! You will release my people from the Violet Hold, or I will cut you down myself!','',0,0,0,0,0,0,0,0,1,0,35608,0,26124),
(71927,'','Your people are legitimate prisoners of war. They orchestrated an attack on Darnassus from MY city-',0,0,0,0,0,0,0,0,1,0,0,35506,26124),
(71928,'The Sunreavers knew NOTHING of Garrosh\'s raid on Darnassus!','',0,0,0,0,0,0,0,0,1,0,35609,0,26124),
(71929,'Aethas Sunreaver shifts uncomfortably.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71930,'ENOUGH!! There will be no more bloodshed today.','',0,0,0,0,0,0,0,0,1,0,35908,0,26124),
(71931,'I see now why your Alliance and your Horde cannot stop fighting.','',0,0,0,0,0,0,0,0,1,0,35909,0,26124),
(71932,'Every reprisal is itself an act of aggression, and every act of aggression triggers immediate reprisal.','',0,0,0,0,0,0,0,0,1,0,35910,0,26124),
(71933,'','They have undermined EVERY attempt at peace!',0,0,0,0,0,0,0,0,1,0,0,35507,26124),
(71934,'I must protect my sovereign people.','',0,0,0,0,0,0,0,0,1,0,35610,0,26124),
(71935,'SILENCE! YOU must break the cycle.','',0,0,0,0,0,0,0,0,1,0,35911,0,26124),
(71936,'It ends TODAY. Here. The cycle ends when you, Regent Lord, and you, Lady Proudmoore, turn from one another. And walk. Away.','',0,0,0,0,0,0,0,0,1,0,35912,0,26124),
(71937,'','Jaina takes a deep breath.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71938,'Lor\'themar narrows his eyes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71939,'Rangers. Lower your weapons.','',0,0,0,0,0,0,0,0,1,0,35611,0,26124),
(71940,'','My Lord!',0,0,0,0,0,0,0,0,1,0,0,36387,26124),
(71941,'Do it.','',0,0,0,0,0,0,0,0,1,0,35612,0,26124),
(71942,'','Very well. We will stand down.',0,0,0,0,0,0,0,0,1,0,0,35509,26124),
(71943,'','They killed my husband!',0,0,0,0,0,0,0,0,1,0,0,35932,26124),
(71944,'','This won\'t bring him back.',0,0,0,0,0,0,0,0,1,0,0,35508,26124),
(71945,'','But know this, \"Blood\" Elf: There can be no peace while Hellscream is Warchief of the Horde.',0,0,0,0,0,0,0,0,1,0,0,35510,26124),
(71946,'That is precisely why I wish to conserve our strength today.','',0,0,0,0,0,0,0,0,1,0,35613,0,26124),
(71947,'','Jaina\'s expression softens.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71948,'','Lord.',0,0,0,0,0,0,0,0,1,0,0,35511,26124),
(71949,'Lady.','',0,0,0,0,0,0,0,0,1,0,35614,0,26124),
(71950,'Gather the wounded. Withdraw to the harbor.','',0,0,0,0,0,0,0,0,1,0,35615,0,26124),
(71951,'','Everyone, regroup back at the camp. Our work here is done.',0,0,0,0,0,0,0,0,1,0,0,35512,26124),
(71952,'','Lord Zhu!',0,0,0,0,0,0,0,0,1,0,0,35822,26124),
(71953,'Champion, this cease-fire may not last, but remember what you have seen today.','',0,0,0,0,0,0,0,0,1,0,35913,0,26124),
(71954,'','We must get you back to the monastery.',0,0,0,0,0,0,0,0,1,0,0,35823,26124),
(71955,'Shan Bu\'s monstrosity remains at the foot of the palace. It must be stopped before it wreaks havoc across Pandaria.','',0,0,0,0,0,0,0,0,1,0,35914,0,26124),
(71956,'','Yalia, take Lord Zhu to safety.',0,0,0,0,0,0,0,0,1,0,0,35824,26124),
(71957,'','Hero, it will be up to you to defeat the Storm Lord Nalak. You will have to marshal a small army!',0,0,0,0,0,0,0,0,1,0,0,35825,26124),
(71958,'','But after what I have seen today, I have faith in you.',0,0,0,0,0,0,0,0,1,0,0,35826,26124),
(71959,'','It has been a great honor to fight by your side. Thank you.',0,0,0,0,0,0,0,0,1,0,0,35827,26124),
(71960,'','You\'ve earned my trust hero. Simply place my staff on the Thunder King\'s dais and it will do the rest. You are very brave to take this mission on; good luck!',0,0,0,0,0,0,0,0,1,0,0,35513,26124),
(71961,'','You did it! Incredible! Pandaren Lorewalkers will be telling your story for generations!',0,0,0,0,0,0,0,0,1,0,0,35514,26124),
(71962,'','I can feel it ... the Thunder King\'s power courses through my staff.',0,0,0,0,0,0,0,0,1,0,0,35515,26124),
(71963,'','Best of all, you\'ve forever disabled his infernal machine, leaving nothing for the Horde to claim as their own.',0,0,0,0,0,0,0,0,1,0,0,35516,26124),
(71964,'','When the time is right, I\'ll use this staff to bring the walls of Orgrimmar crashing down around Garrosh Hellscream\'s head.',0,0,0,0,0,0,0,0,1,0,0,35517,26124),
(71965,'','Thank you, friend. The Alliance is lucky to have you.',0,0,0,0,0,0,0,0,1,0,0,35518,26124),
(71966,'You have earned my trust hero. This will be your most dangerous task yet: To steal the secrets of the Thunder King from the very heart of his lair. I wish you the best of luck.','',1,1,0,0,0,0,0,0,1,0,35645,0,26124),
(71967,'What have you brought back? Ah! Fascinating.','',0,0,0,0,0,0,0,0,1,0,35646,0,26124),
(71968,'Blood as a power source - a very powerful form of life magic. The work of the titans, perhaps? How does it work?','',0,0,0,0,0,0,0,0,1,0,35647,0,26124),
(71969,'Aethas, I want our best archmages studying this device at once. We have so much to learn.','',0,0,0,0,0,0,0,0,1,0,35648,0,26124),
(71970,'Thank you, champion! The Horde may be on the verge of crisis, but your actions on these shores have ensured our continued survival and prosperity no matter what comes next.','',0,0,0,0,0,0,0,0,1,0,35649,0,26124),
(71971,'You have our deepest gratitude. Al diel shala, hero.','',0,0,0,0,0,0,0,0,1,0,35650,0,26124),
(71972,'Weak.','',0,0,0,0,0,0,0,0,1,0,35551,0,26124),
(71973,'So easy to break.','',0,0,0,0,0,0,0,0,1,0,35552,0,26124),
(71974,'How you beat me?','',0,0,0,0,0,0,0,0,1,0,35549,0,26124),
(71975,'Bored.  You die now.','',0,0,0,0,0,0,0,0,1,0,35548,0,26124),
(71976,'Da Thunder King give me power! Come, I show you!','',0,0,0,0,0,0,0,0,1,0,35550,0,26124),
(71977,'I must break you.','',0,0,0,0,0,0,0,0,1,0,35547,0,26124),
(71978,'Smash!','',0,0,0,0,0,0,0,0,1,0,35553,0,26124),
(71979,'Crush your bones!','',0,0,0,0,0,0,0,0,1,0,35554,0,26124),
(71980,'I call da storm!','',0,0,0,0,0,0,0,0,1,0,35555,0,26124),
(71981,'Zap!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71982,'|TInterface\\Icons\\ability_vehicle_electrocharge:20|t%s\'s |cFFFF0000|Hspell:137422|h[Focused Lightning]|h|r fixates on you. Run!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71983,'The eggs in one of the lower nests begin to hatch!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(71984,'Use Displacement Pad.','Use Displacement Pad.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71985,'%s prepares to unleash a |cFFFF0000|Hspell:133939|h[Furious Stone Breath]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(71988,'The eggs in one of the lower nests begin to hatch!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(71989,'The eggs in one of the lower nests begin to hatch!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(71990,'The eggs in one of the lower nests begin to hatch!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(71991,'The eggs in one of the lower nests begin to hatch!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(71992,'The eggs in one of the upper nests begin to hatch!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(71993,'The eggs in one of the upper nests begin to hatch!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(71994,'The eggs in one of the upper nests begin to hatch!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(71995,'The eggs in one of the upper nests begin to hatch!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(71996,'The eggs in one of the upper nests begin to hatch!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(71999,'Use the Cloud Tiles to dispel Mantle of the Thunder King!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72000,'','A new land overrun by evil horrors of this world. A new place for us to save.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72001,'Some laugh at my concern for beasts. I scoff at their lack of compassion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72002,'There is much we can learn from these Zandalari, largely by doing what they do not.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72003,'Da Amani empire cannot be stopped!','',0,0,0,0,0,0,0,0,1,0,35570,0,26124),
(72004,'Da thunder king... promised...','',0,0,0,0,0,0,0,0,1,0,35567,0,26124),
(72005,'Ya shouldn\'t be messin\' wit da Zandalari!','',0,0,0,0,0,0,0,0,1,0,35571,0,26124),
(72006,'On ya knees!','',0,0,0,0,0,0,0,0,1,0,35572,0,26124),
(72007,'Out da way!','',0,0,0,0,0,0,0,0,1,0,35573,0,26124),
(72008,'Incoming!','',0,0,0,0,0,0,0,0,1,0,35574,0,26124),
(72009,'Lei Shen give us strength!','',0,0,0,0,0,0,0,0,1,0,35568,0,26124),
(72010,'Da Thunder King shows us da way!','',0,0,0,0,0,0,0,0,1,0,35575,0,26124),
(72011,'Shocking!','',0,0,0,0,0,0,0,0,1,0,35576,0,26124),
(72012,'Ya spirit is mine!','',0,0,0,0,0,0,0,0,1,0,35396,0,26124),
(72013,'De Thunder King will reward us for stoppin\' ya!','',0,0,0,0,0,0,0,0,1,0,35397,0,26124),
(72014,'Witness de power of de spiritbinder!','',0,0,0,0,0,0,0,0,1,0,35398,0,26124),
(72015,'Time ta die!','',0,0,0,0,0,0,0,0,1,0,35399,0,26124),
(72016,'Da Zandalari cannot be stopped!','',0,0,0,0,0,0,0,0,1,0,35400,0,26124),
(72017,'Wit de Thunder King\'s power de Zandalari will be reborn!','',0,0,0,0,0,0,0,0,1,0,35401,0,26124),
(72018,'Lei Shen\'s power makes us stronger!','',0,0,0,0,0,0,0,0,1,0,35402,0,26124),
(72019,'Yer soul will pay da price!','',0,0,0,0,0,0,0,0,1,0,35403,0,26124),
(72020,'Des fools thought they beat me once before. Dey only make me stronger. Now we show dem da true power of the Zandalari!','',0,0,0,0,0,0,0,0,1,0,35404,0,26124),
(72021,'Lei Shen let us prove ta ya the might of the Zandalari. We will crush des intruders where dey stand!','',0,0,0,0,0,0,0,0,1,0,35405,0,26124),
(72022,'We will never fail ya!','',0,0,0,0,0,0,0,0,1,0,35406,0,26124),
(72023,'Da\' Drakkari will never fall to de\' likes of you!','',0,0,0,0,0,0,0,0,1,0,35390,0,26124),
(72024,'Ya have met your match, fools!','',0,0,0,0,0,0,0,0,1,0,35387,0,26124),
(72025,'Da... empire... can\'t... fall...','',0,0,0,0,0,0,0,0,1,0,35388,0,26124),
(72026,'Death\'s cold embrace.','',0,0,0,0,0,0,0,0,1,0,35391,0,26124),
(72027,'Witness da Drakkari\'s might.','',0,0,0,0,0,0,0,0,1,0,35392,0,26124),
(72028,'Getting cold?','',0,0,0,0,0,0,0,0,1,0,35393,0,26124),
(72029,'Freeze!','',0,0,0,0,0,0,0,0,1,0,35394,0,26124),
(72030,'Winter is coming...','',0,0,0,0,0,0,0,0,1,0,35389,0,26124),
(72031,'','Shadra\'s rage will destroy you!',0,0,0,0,0,0,0,0,1,0,0,35435,26124),
(72032,'','Death ta all who appose da empire!',0,0,0,0,0,0,0,0,1,0,0,35432,26124),
(72033,'','Shadra... save... me...',0,0,0,0,0,0,0,0,1,0,0,35433,26124),
(72034,'','Another offering to da loa!',0,0,0,0,0,0,0,0,1,0,0,35436,26124),
(72035,'','She will feast on yer soul!',0,0,0,0,0,0,0,0,1,0,0,35437,26124),
(72036,'','Succumb ta her venom!',0,0,0,0,0,0,0,0,1,0,0,35438,26124),
(72037,'','Yer soul belongs ta me!',0,0,0,0,0,0,0,0,1,0,0,35439,26124),
(72038,'','Da spiritbinder reveals yer soul ta me!',0,0,0,0,0,0,0,0,1,0,0,35434,26124),
(72039,'','Embrace yer demise!',0,0,0,0,0,0,0,0,1,0,0,35440,26124),
(72040,'Dey tink dey can stop da Farraki?','',0,0,0,0,0,0,0,0,1,0,35814,0,26124),
(72041,'Da sands will consume everyting!','',0,0,0,0,0,0,0,0,1,0,35812,0,26124),
(72042,'I return... to... da... sands...','',0,0,0,0,0,0,0,0,1,0,36454,0,26124),
(72043,'Da sands are endless.','',0,0,0,0,0,0,0,0,1,0,35815,0,26124),
(72044,'Da first of many!','',0,0,0,0,0,0,0,0,1,0,35816,0,26124),
(72045,'Watch yer step!','',0,0,0,0,0,0,0,0,1,0,35817,0,26124),
(72046,'Da storm approaches!','',0,0,0,0,0,0,0,0,1,0,35818,0,26124),
(72047,'Lei Shen gives life!','',0,0,0,0,0,0,0,0,1,0,35819,0,26124),
(72048,'I will bury ya all!','',0,0,0,0,0,0,0,0,1,0,35813,0,26124),
(72049,'These insects do not know their place, Gara\'jal. If you wish to prove your \"might\" on such weaklings, it matters not to me.','',0,0,0,0,0,0,0,0,1,0,35586,0,26124),
(72050,'The orb swirls malevolently...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72051,'The orb explodes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72052,'My Lord.','',0,0,0,0,0,0,0,0,7,0,37025,0,26124),
(72053,'Recovering','Recovering',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72054,'','Well now. You sure know how to arrive in style.',0,0,0,0,0,0,0,0,1,0,0,35828,26124),
(72055,'','This way. The doors can only be opened from within.',0,0,0,0,0,0,0,0,1,0,0,35829,26124),
(72056,'','We can slip through here quietly, or fight our way through. It is your decision.',0,0,0,0,0,0,0,0,1,0,0,35830,26124),
(72057,'','The mogu forge weapons of both blood and steel. Their blades feast on death.',0,0,0,0,0,0,0,0,1,0,0,35831,26124),
(72058,'','Slaves - everywhere slaves. You can see what we fight against.',0,0,0,0,0,0,0,0,1,0,0,35832,26124),
(72059,'','The Shado-Pan strike from the shadows, so that our enemies fear the dark.',0,0,0,0,0,0,0,0,1,0,0,35833,26124),
(72060,'','I have seen many things. But the cruelty of the mogu still curdles my blood.',0,0,0,0,0,0,0,0,1,0,0,35834,26124),
(72061,'','We are in the heart of the mogu war machine.',0,0,0,0,0,0,0,0,1,0,0,35835,26124),
(72062,'','I have trained my entire life for this.',0,0,0,0,0,0,0,0,1,0,0,35836,26124),
(72063,'','They will learn that no place is safe from the Shado-Pan.',0,0,0,0,0,0,0,0,1,0,0,35837,26124),
(72064,'','I prefer a swift, silent kill. But your methods have their advantages.',0,0,0,0,0,0,0,0,1,0,0,35838,26124),
(72065,'','Your skills in combat are most impressive.',0,0,0,0,0,0,0,0,1,0,0,35839,26124),
(72066,'','The Shado-Pan will never rest.',0,0,0,0,0,0,0,0,1,0,0,35840,26124),
(72067,'','Step lightly! We are almost to the gate.',0,0,0,0,0,0,0,0,1,0,0,35841,26124),
(72068,'','There - the slave master! Hold his attention while I undo the lock.',0,0,0,0,0,0,0,0,1,0,0,35842,26124),
(72069,'','This lock... it is more complicated than I thought...',0,0,0,0,0,0,0,0,1,0,0,35843,26124),
(72070,'','Keep him busy! I am almost finished!',0,0,0,0,0,0,0,0,1,0,0,35844,26124),
(72071,'','I have it! The gates are undone!',0,0,0,0,0,0,0,0,1,0,0,35845,26124),
(72072,'Farraki forces pour from the Farraki Tribal Door!','Farraki forces pour from the Farraki Tribal Door!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72073,'Gurubashi forces pour from the Gurubashi Tribal Door!','Gurubashi forces pour from the Gurubashi Tribal Door!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72074,'Drakkari forces pour from the Drakkari Tribal Door!','Drakkari forces pour from the Drakkari Tribal Door!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72075,'Amani forces pour from the Amani Tribal Door!','Amani forces pour from the Amani Tribal Door!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72076,'The ghost fades away into the mist...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72077,'Return as my master.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72078,'I am your master.','I am your master.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72079,'Close... enough.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72080,'You look nothing like him.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72081,'No! No no no! Put those down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72082,'Why are you still standing there? Deliver those boxes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72083,'This is not a construct break. Get back to work.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72084,'Do you even know how to walk? Move those legs of yours you worthless golden scrap heap!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72085,'Where are the barrels? Did you lose the barrels? We need more barrels!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72086,'If you drop one more crate I swear I am sending you off to be disenchanted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72087,'How could you lose another one? I swear, there are gems in my shoes that have more intelligence than you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72088,'CARRIER HAS ARRIVED.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72089,'In theory, these crystals are natural insulators. They should absorb most of the lightning strikes in the area.','In theory, these crystals are natural insulators. They should absorb most of the lightning strikes in the area.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72090,'Do the instructions clarify how much mana these crystals will require? I do not want to get converted to a wretched by using this thing.','Do the instructions clarify how much mana these crystals will require? I do not want to get converted to a wretched by using this thing.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72091,'I think the crystal on the left is defective. We should never have rushed their construction. This is how accidents happen.','I think the crystal on the left is defective. We should never have rushed their construction. This is how accidents happen.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72092,'Why is it everywhere on this island I go my hair always feels like it is standing on end?','Why is it everywhere on this island I go my hair always feels like it is standing on end?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72093,'It is days like this I miss using fel magic. Sure it was evil, but it got the job done.','It is days like this I miss using fel magic. Sure it was evil, but it got the job done.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72094,'Are these going to be enough to take out those pterrorwings?','Are these going to be enough to take out those pterrorwings?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72095,'Someone told me these crystals are blue in their natural state. I am so glad someone took the time to apply some proper aesthetics.','Someone told me these crystals are blue in their natural state. I am so glad someone took the time to apply some proper aesthetics.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72096,'It is said the God King Rastakhan, ruler of the Zandalari, lords over his mighty kingdom from a throne carved of solid gold.','',0,0,0,0,0,0,0,0,5,0,36432,0,26124),
(72097,'Years ago, as he sat on this opulent seat of power, he was visited by his most trusted prophet: Zul.','',0,0,0,0,0,0,0,0,5,0,36433,0,26124),
(72098,'Zul warned King Rastakhan of a terrible Cataclysm. For Zul had seen a vision of a great armored dragon clenching the world in his ferocious jaws.','',0,0,0,0,0,0,0,0,5,0,36434,0,26124),
(72099,'King Rastakhan did nothing.','',0,0,0,0,0,0,0,0,5,0,36436,0,26124),
(72100,'Months later Zul returned, bearing more grim news from his visions. He saw a legion of serpents pouring forth from a gaping fissure that tore open the floor of the ocean.','',0,0,0,0,0,0,0,0,5,0,36438,0,26124),
(72101,'Still, King Rastakhan did nothing.','',0,0,0,0,0,0,0,0,5,0,36439,0,26124),
(72102,'Finally, mere months before the Cataclysm, Zul returned. Tearing his clothes and throwing his staff to the ground, Zul spoke of earthquakes and tidal waves.','',0,0,0,0,0,0,0,0,5,0,36440,0,26124),
(72103,'He described the golden capital of Zandalar slowly sinking beneath the waves in the aftermath of the Cataclysm, its once-great people drowning as their mighty works slipped forever beneath the sea.','',0,0,0,0,0,0,0,0,5,0,36441,0,26124),
(72104,'King Rastakhan tired of Zul and his troubling nightmares. To be rid of the prophet, he granted Zul the use of his largest ships, so that he and his followers could seek a new land if his visions came to pass.','',0,0,0,0,0,0,0,0,5,0,36442,0,26124),
(72105,'And his visions DID come to pass.','',0,0,0,0,0,0,0,0,5,0,36443,0,26124),
(72106,'When Deathwing rose from the Maelstrom, dark, angry waves crashed into the Zandalari capital. The spine of the land broke in two, and soon, the city and all its riches began to slide into the hungry sea.','',0,0,0,0,0,0,0,0,5,0,36445,0,26124),
(72107,'The Zandalari people turned to their King for help, but there was only one Zandalari equipped to help them: The prophet Zul. The prophet, and the mighty warfleet he had assembled while his King sat idle.','',0,0,0,0,0,0,0,0,5,0,36446,0,26124),
(72108,'You see, the TRUE power of kings and emperors stems from the power to aid their people.','',0,0,0,0,0,0,0,0,5,0,36447,0,26124),
(72109,'The moment they fail, they cede their power to the one who can.','',0,0,0,0,0,0,0,0,5,0,36448,0,26124),
(72110,'The mogu tell a legend about Lei Shen, the Thunder King.','',0,0,0,0,0,0,0,0,5,0,35672,0,26124),
(72111,'His followers fell to their knees before him. \"We will call you \'The Lightning King,\'\" they said.','',0,0,0,0,0,0,0,0,5,0,35674,0,26124),
(72112,'It is said that he tore out the very heart of the mogu God. And from that hateful act he gained power over wind and storm.','',0,0,0,0,0,0,0,0,5,0,35673,0,26124),
(72113,'But Lei Shen did not agree.','',0,0,0,0,0,0,0,0,5,0,35675,0,26124),
(72114,'\"Lightning strikes in an instant and is over in a flash,\" he said.','',0,0,0,0,0,0,0,0,5,0,35676,0,26124),
(72115,'\"But thunder. Thunder! Thunder proclaims the coming of the storm.\"','',0,0,0,0,0,0,0,0,5,0,35677,0,26124),
(72116,'\"Thunder quakes the skies long before the lightning strikes, and thunder echoes in the hills long after lightning\'s power is spent.\"','',0,0,0,0,0,0,0,0,5,0,35678,0,26124),
(72117,'\"It is thunder that sends animals cowering and fills the hearts of peasants with dread. Let thunder be my herald, so that my power is felt throughout the land.\"','',0,0,0,0,0,0,0,0,5,0,35679,0,26124),
(72118,'\"I will be... The Thunder King.\"','',0,0,0,0,0,0,0,0,5,0,35680,0,26124),
(72119,'Oh my friend - that awful sound. For a hundred hundred generations the crash of thunder filled the hearts of pandaren with terror.','',0,0,0,0,0,0,0,0,5,0,35681,0,26124),
(72120,'It is said that after the revolution, the Red Crane of Hope placed the rainbow in the sky, so that pandaren would know not to fear the storms any longer.','',0,0,0,0,0,0,0,0,5,0,35682,0,26124),
(72121,'I do not see any rainbows today. Do you?','',0,0,0,0,0,0,0,0,5,0,35683,0,26124),
(72122,'Fathers and sons. Mothers and daughters. As parents, we pass our legacy on to our children.','',0,0,0,0,0,0,0,0,5,0,35684,0,26124),
(72123,'What values do we choose to instill in our progeny?','',0,0,0,0,0,0,0,0,5,0,35685,0,26124),
(72124,'What will our children learn from our mistakes?','',0,0,0,0,0,0,0,0,5,0,35686,0,26124),
(72125,'What sort of world will we create and leave behind for our daughters and sons?','',0,0,0,0,0,0,0,0,5,0,35687,0,26124),
(72126,'Parents place their children on a path, but they do not always know where the road will take them.','',0,0,0,0,0,0,0,0,5,0,35688,0,26124),
(72127,'The mogu were children as well. Children of the titans. They were once a legion of stone, heartless and obedient.','',0,0,0,0,0,0,0,0,5,0,35689,0,26124),
(72128,'By the titans\' command, they fought the terrible servants of the old gods. They shaped the mountains and carved the rivers of the land.','',0,0,0,0,0,0,0,0,5,0,35690,0,26124),
(72129,'And they created a magical cradle of life in a hidden valley that we now call the Vale of Eternal Blossoms.','',0,0,0,0,0,0,0,0,5,0,35691,0,26124),
(72130,'But eventually the titans fell silent. And their creations were cursed with flesh.','',0,0,0,0,0,0,0,0,5,0,35692,0,26124),
(72131,'The mogu grew restless. Many generations later, when Thunder King united them, they seized upon their legacy!','',0,0,0,0,0,0,0,0,5,0,35693,0,26124),
(72132,'I truly believe now that the mogu thought they were doing the work of the titans. They fought against the mantid and used the powers of the Vale to create new life.','',0,0,0,0,0,0,0,0,5,0,35694,0,26124),
(72133,'Ah, but such terrible works!','',0,0,0,0,0,0,0,0,5,0,35695,0,26124),
(72134,'Parents cannot always be assured of the legacy they will leave behind.','',0,0,0,0,0,0,0,0,5,0,35696,0,26124),
(72135,'How especially true this is, when the parents are gods. And their children - monsters.','',0,0,0,0,0,0,0,0,5,0,35697,0,26124),
(72136,'All I be needin\' is your heart.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72137,'Give in, I make it quick.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72138,'Anotha sacrifice, bruddas!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72139,'I love to spill dis one\'s blood.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72140,'I hear ya blood flow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72141,'Come to me aid, pets.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72142,'Dinner be here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72143,'You be good eatin\' for me pets.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72144,'Sometimes dey start eatin\' before you dead.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72145,'Me pets have a big feast, brudda.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72146,'You weak, friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72147,'Dis was a mistake fo\' you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72148,'Anotha fool come to die.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72149,'Dis one too brave.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72150,'Dis one\'s death be fun.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72151,'De ritual don\'t stop.','De ritual don\'t stop.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72152,'You never be stoppin\' us!','You never be stoppin\' us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72153,'You should fear de loa.','You should fear de loa.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72154,'De power of loa comes.','De power of loa comes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72155,'Stop interruptin\'.','Stop interruptin\'.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72156,'What?! What was that?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72157,'I see no one. Ha. Stupid trolls can\'t even collapse a tunnel properly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72158,'No... perhaps someone is in hiding. Fetch the Saurok slaves! They will sniff them out...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72159,'The Dark Animus goes berserk!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72160,'Yes, master! I will fight with my life!','',0,0,0,0,0,0,0,0,1,0,36017,0,26124),
(72161,'THEY ARE NO MATCH FOR MANCHU!','',0,0,0,0,0,0,0,0,1,0,35717,0,26124),
(72162,'Stare into the face of true power!','',0,0,0,0,0,0,0,0,1,0,35465,0,26124),
(72163,'What a pathetic display.','',0,0,0,0,0,0,0,0,1,0,35478,0,26124),
(72164,'I run you through!','',0,0,0,0,0,0,0,0,1,0,35472,0,26124),
(72165,'Fall at my feet!','',0,0,0,0,0,0,0,0,1,0,35473,0,26124),
(72166,'More... training...','',0,0,0,0,0,0,0,0,1,0,35469,0,26124),
(72167,'Quet\'zal! Unleash the storm upon my enemies!!!','',0,0,0,0,0,0,0,0,1,0,35467,0,26124),
(72168,'Dam\'ren!  Freeze them to oblivion!','',0,0,0,0,0,0,0,0,1,0,35466,0,26124),
(72169,'Strike quickly, Manchu. Show them no mercy!','',0,0,0,0,0,0,0,0,1,0,35474,0,26124),
(72170,'All brawn. No brains. A recoverable loss.','',0,0,0,0,0,0,0,0,1,0,35475,0,26124),
(72171,'Focus, Weisheng. Show your enemy the meaning of pain!','',0,0,0,0,0,0,0,0,1,0,35479,0,26124),
(72172,'He fought with honor. His first and last mistake.','',0,0,0,0,0,0,0,0,1,0,35476,0,26124),
(72173,'ARGH! Worthless mongrels! I will kill you myself!','',0,0,0,0,0,0,0,0,1,0,35477,0,26124),
(72174,'Enough of this! Come now, weaklings. You have earned your reward. You may now face the Iron Qon.','',0,0,0,0,0,0,0,0,1,0,35471,0,26124),
(72175,'Turn back now, strangers! You face the army of Iron Qon!','',0,0,0,0,0,0,0,0,1,0,35470,0,26124),
(72176,'How can this be?!','',0,0,0,0,0,0,0,0,1,0,35462,0,26124),
(72177,'Gaaaahh!','',0,0,0,0,0,0,0,0,1,0,35463,0,26124),
(72178,'USELESS!','',0,0,0,0,0,0,0,0,1,0,35464,0,26124),
(72179,'','If I must...',0,0,0,0,0,0,0,0,1,0,0,35702,26124),
(72180,'','Was that really necessary...?',0,0,0,0,0,0,0,0,1,0,0,35707,26124),
(72181,'','You shouldn\'t have come here.',0,0,0,0,0,0,0,0,1,0,0,35706,26124),
(72182,'','It is warm.',0,0,0,0,0,0,0,0,1,0,0,35703,26124),
(72183,'','Just... leave me alone!',0,0,0,0,0,0,0,0,1,0,0,35708,26124),
(72184,'','Please, just go! You are making her angry.',0,0,0,0,0,0,0,0,1,0,0,35709,26124),
(72185,'','Just this once...',0,0,0,0,0,0,0,0,1,0,0,35710,26124),
(72186,'','So... lonely.',0,0,0,0,0,0,0,0,1,0,0,35704,26124),
(72187,'','Are they gone yet?',0,0,0,0,0,0,0,0,1,0,0,35705,26124),
(72188,'','More kindling for the flame! Come, Lu\'lin... let us burn them to ash!',0,0,0,0,0,0,0,0,1,0,0,35798,26124),
(72189,'','Hahahahaha!',0,0,0,0,0,0,0,0,1,0,0,35804,26124),
(72190,'','Die in agony!',0,0,0,0,0,0,0,0,1,0,0,35803,26124),
(72191,'','I can see the light.',0,0,0,0,0,0,0,0,1,0,0,35799,26124),
(72192,'','INTRUDERS! GUARDIANS OF THE THRONE, AWAKEN!',0,0,0,0,0,0,0,0,1,0,0,35800,26124),
(72193,'','BLAZE OF DEATH!',0,0,0,0,0,0,0,0,1,0,0,35805,26124),
(72194,'','Lu\'lin! Lend me your strength!',0,0,0,0,0,0,0,0,1,0,0,35806,26124),
(72195,'','Witness the true meaning of pain!',0,0,0,0,0,0,0,0,1,0,0,35807,26124),
(72196,'','Time to deal with these mogu once and for all.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72197,'','I will destroy this cave in, and then we can sneak in from behind. Let me know when you are ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72198,'|TInterface\\Icons\\ability_monk_forcesphere.blp:20|tDurumu begins charging up his Mind\'s Eye to cast |cFFFF0000|Hspell:136932|h[Force of Will]|h|r on |cFFFF0000$n|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72199,'|TInterface\\Icons\\inv_misc_eye_02.blp:20|tDurumu begins charging up his Appraising Eye to cast |cFFFF0000|Hspell:133792|h[Lingering Gaze]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72200,'|TInterface\\Icons\\spell_shadow_lifedrain02.blp:20|tDurumu begins charging up his Hungry Eye to cast |cFFFF0000|Hspell:133795|h[Life Drain]|h|r on |cFFFF0000$n|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72201,'|TInterface\\Icons\\spell_shadow_curseofmannoroth.blp:20|tDurumu begins charging up his Evil Eye to cast |cFFFF0000|Hspell:133597|h[Dark Parasite]|h|r on |cFFFF0000$n|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72202,'|TInterface\\Icons\\priest_icon_chakra_blue.blp:20|tDurumu begins charging up his Blue Eye to cast |cFFFF0000|Hspell:134122|h[Blue Rays]|h|r on |cFFFF0000$n|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72203,'|TInterface\\Icons\\priest_icon_chakra_red.blp:20|tDurumu begins charging up his Red Eye to cast |cFFFF0000|Hspell:134123|h[Infrared Light]|h|r on |cFFFF0000$n|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72204,'|TInterface\\Icons\\priest_icon_chakra.blp:20|tDurumu begins charging up his Yellow Eye to cast |cFFFF0000|Hspell:134124|h[Bright Light]|h|r on |cFFFF0000$n|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72205,'The Infrared Light reveals a Crimson Fog!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72206,'The Bright  Light reveals an Amber Fog!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72207,'The Blue Rays reveal an Azure Fog!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72208,'The Harsh Light reveals a Pale Fog!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72212,'Alright. Let\'s go.','Alright. Let\'s go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72213,'More work?','',0,0,0,0,0,0,0,0,1,0,6288,0,26124),
(72214,'','It is imperative that we understand the mogu\'s history. Our best chance at a successful offensive will come from knowledge of our enemy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72215,'','The mogu\'s history is fraught with savage conquest and tests of strength. After thousands of years, only the strongest members of their race have survived.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72216,'The beast ward has fallen! Defend the council with ya lives, brothas!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72217,'<The blood elf is visibly shaken.>$B$BIt was horrible, just horrible! After we were caught, a mogu took me by the throat. I expected to die then and there, but instead, the mogu made a clutching motion and PULLED. All of a sudden, it was as if all the air were gone from my lungs.$B$BI felt a terrible twisting and ripping. My skin and bones felt as if on fire. Suddenly I was floating out of my own body.$B$BThe mogu laughed in my face, and I knew that my soul would suffer for the rest of eternity.$B$BHave you ever felt complete and utter terror, $c? I have.$B$B<The blood elf shudders and grows quiet.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72218,'The peasant contemplates what life means without work.','',0,0,0,0,0,0,0,0,1,0,1290,0,26124),
(72219,'Stay strong, $c. The mogu will not lay down their arms quietly. We will have to fight for every inch of land on this forsaken island.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72220,'','I\'ve grown quite interested in mogu culture and history. I would call it a bit more than a passing hobby.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72221,'','Archmage Modera is taking a straightforward strategy - defeat the mogu by force. I believe that with further research, we may be able to discover the mogu\'s weaknesses.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72222,'','I\'ve decided to write a book. \"The Mysteries of Mogu Magic.\" Has a nice ring to it, don\'t you think?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72223,'What is it?','',0,0,0,0,0,0,0,0,1,0,6287,0,26124),
(72224,'What?','',0,0,0,0,0,0,0,0,1,0,6289,0,26124),
(72225,'The peasant wishes there was more work to do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72226,'','We are vastly outnumbered here, but with a well-executed strategy, I believe we can succeed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72227,'','Our strategy is sound. We must not falter now, when we have so much still to gain.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72228,'|TInterface\\Icons\\spell_nature_lightningoverload.blp:20|t The |cFFFF0000Northeast|r doors begin to open, causing |cFFFF0000|Hspell:136889|h[Violent Gale Winds]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72229,'|TInterface\\Icons\\spell_nature_lightningoverload.blp:20|t The |cFFFF0000Southeast|r doors begin to open, causing |cFFFF0000|Hspell:136889|h[Violent Gale Winds]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72230,'|TInterface\\Icons\\spell_nature_lightningoverload.blp:20|t The |cFFFF0000Southwest|r doors begin to open, causing |cFFFF0000|Hspell:136889|h[Violent Gale Winds]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72232,'Ready to work.','',0,0,0,0,0,0,0,0,1,0,6290,0,26124),
(72233,'This is but a taste of my power.','',0,0,0,0,0,0,0,0,1,0,35765,0,26124),
(72234,'Why do the peasants seem depressed?','Why do the peasants seem depressed?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72235,'Ah, the familiar embrace of the storms....','',0,0,0,0,0,0,0,0,1,0,35764,0,26124),
(72236,'The touch of creation... and destruction.','',0,0,0,0,0,0,0,0,1,0,35763,0,26124),
(72237,'For millennia I have waited in darkness, in silence pierced only by the shrieks of the tormented, my dreams a waking nightmare.','',0,0,0,0,0,0,0,0,1,0,35756,0,26124),
(72238,'I see the naive hope in your eyes. You... think you are my saviors? Wring that mocking pity from your hearts and focus it inwards, for you shall soon know my agony.','',0,0,0,0,0,0,0,0,1,0,35757,0,26124),
(72239,'This twisted world is beyond redemption, beyond the reach of deluded heroes. The only answer to corruption is destruction. And that begins... now.','',0,0,0,0,0,0,0,0,1,0,35758,0,26124),
(72240,'When I am finished with you, I shall not rest until this world is cleansed. Now perish!','',0,0,0,0,0,0,0,0,1,0,35754,0,26124),
(72241,'Feel your own life essence betray you.','',0,0,0,0,0,0,0,0,1,0,35762,0,26124),
(72242,'Accept the inevitable.','',0,0,0,0,0,0,0,0,1,0,35759,0,26124),
(72243,'Amusing. You really thought you could win.','',0,0,0,0,0,0,0,0,1,0,35760,0,26124),
(72244,'You still think victory possible? Fools!','',0,0,0,0,0,0,0,0,1,0,35761,0,26124),
(72245,'You are the best this world has to offer? Ha, no wonder it has fallen to ruin.','',0,0,0,0,0,0,0,0,1,0,35755,0,26124),
(72246,'Wait! I am... I am not your enemy. You are powerful. More powerful than he was, even.... Perhaps you are right. Perhaps there is still hope.','',0,0,0,0,0,0,0,0,1,0,35766,0,26124),
(72247,'They are depressed because they have no work to do?','They are depressed because they have no work to do?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72248,'Righto.','',0,0,0,0,0,0,0,0,1,0,6284,0,26124),
(72249,'Hello.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72250,'But there is a yawning chasm of darkness beneath you, mortals. Vast, endless, and all-consuming. I do not believe that you can correct this doomed course.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72251,'But... you have earned the right to try. Farewell.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72252,'','The siege is underway but our heavy explosives never made it to the wall!',0,0,0,0,0,0,5,0,1,0,0,35920,26124),
(72253,'','Gather up the explosives and get them to the wall while I rally the reinforcements.',0,0,0,0,0,0,1,0,1,0,0,35921,26124),
(72254,'|TInterface\\Icons\\ability_warrior_throwdown:20|t%s grabs $n and readies his |cFFFF0000|Hspell:137175|h[Thundering Throw]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72255,'|TInterface\\Icons\\spell_shaman_thunderstorm:20|t%s begins to channel an intense |cFFFF0000|Hspell:137313|h[Lightning Storm]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72256,'%s dies, sending arcing lightning to a nearby ally!','%s dies, sending arcing lightning to a nearby ally!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72257,'Go now, to Ihgaluk Crag. I will apply the second half of your illusion once you have arrived.','Go now, to Ihgaluk Crag. I will apply the second half of your illusion once you have arrived.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72258,'%s is pursuing you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72259,'$n is affected by |cFFF00000|Hspell:136192|h[Lightning Storm]|h|r !','$n is affected by |cFFF00000|Hspell:136192|h[Lightning Storm]|h|r !',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72260,'Guardian Tak\'u is casting Fire of the Serpent! Interrupt now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72261,'Guardian Tak\'u has gained Waves of the Hydra! Dispel now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72263,'','Are you prepared, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72264,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72265,'','Taoshi motions at Captain Halu\'kal, then draws a finger across her neck.',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(72266,'%s drains power from the other golems with |cFFFF0000|Hspell:138644|h[Siphon Anima]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72267,'Hey, we should jump off the side of the Black Temple, and see what\'s down there!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72268,'More DoTs! More DoTs! Throw more DoTs!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72269,'...okay, stop DoTs.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72270,'It doesn\'t seem like you\'re casting enough Shadowbolts.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72271,'The last warlock who tried this failed as well.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72272,'Has anyone ever told you that you slouch? Good posture is important to proper spell casting!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72273,'How did you manage to make it this far? Props to your healers!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72274,'Run to the center!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72275,'You didn\'t think he was just going to GIVE you green fire, did you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72276,'Healthstone! Use your Healthstone!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72277,'That Curse of Ultimate Doom looks pretty dangerous! Dispel it, quick!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72278,'I want BLUE fire!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72279,'Have you tried NOT standing in that? It might work better.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72280,'You should use your wand when you get low on mana! You DO have a wand, right?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72281,'We should drink some tiger blood. Then we\'d surely be winning!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72282,'%s is about to end |cFFFF0000Supercharge Conduits|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72283,'','Be careful, Agrant!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(72284,'','We can make it if we run!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(72285,'','At least there are no electrified fences. Or trolls.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(72286,'','I told you that you weren\'t machine compatible!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(72287,'','How could we know anything about an extinct ecosystem? Even the plants are poisonous!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(72288,'','You only brought enough food for seven days! Seven! That\'s just great.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(72289,'When we have control of the expedition again, everything will be fine...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(72290,'For some odd reason, I love to stare at this cane. Hmmm...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(72291,'What we need is some sort of protein-based population control. Perhaps we should have thought of that before coming here.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(72292,'How could the expedition be a failure? I spared no expense!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(72293,'Agrant? Nellie? Isn\'t it a bit dangerous to be outside of the zeppelin?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(72294,'Anyone, ah, hear that? It\'s ah, it\'s ah, an impact tremor.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(72295,'I\'m fairly alarmed here.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(72296,'Remind me to thank Hamlock for a lovely weekend.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(72297,'It\'s, ah, the cycle of life, mm. The Light creates troll, troll creates dinosaur, dinosaur eats human, trolls inherit Azeroth.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(72298,'Do you think they\'ll have this on the, ah, tour? Hm?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(72299,'I really do hate being right all the time.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(72300,'Am I, mm, talking to myself? I am? See there, I\'m right again.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(72301,'Cover one another! Stand your ground!','',0,0,0,0,0,0,0,0,1,0,35625,0,26124),
(72302,'THIS is who I am. No paperwork, no politics - just the hot fury of magic and steel!','',0,0,0,0,0,0,0,0,1,0,35626,0,26124),
(72303,'Press forward! We shape our own destiny today!','',0,0,0,0,0,0,0,0,1,0,35627,0,26124),
(72304,'We are the Horde. We do NOT back down.','',0,0,0,0,0,0,0,0,1,0,35628,0,26124),
(72305,'Cut them down. Show them our might!','',0,0,0,0,0,0,0,0,1,0,35629,0,26124),
(72306,'Destroy them, me brothers!','',0,0,0,0,0,0,0,0,7,0,35992,0,26124),
(72307,'The spirits give us strength!','',0,0,0,0,0,0,0,0,1,0,35993,0,26124),
(72308,'Eviscerate them! Our gods will drink their blood!','',0,0,0,0,0,0,0,0,1,0,35994,0,26124),
(72309,'Crush them! Bleed them!','',0,0,0,0,0,0,0,0,1,0,35995,0,26124),
(72310,'Break them!','',0,0,0,0,0,0,0,0,1,0,35996,0,26124),
(72311,'The Thunder King! What a magnificent individual.','',0,0,0,0,0,0,0,0,5,0,36071,0,26124),
(72312,'Could you imagine what his empire would be like today if it had not been overthrown and hidden by the pandaren?','',0,0,0,0,0,0,0,0,5,0,36072,0,26124),
(72313,'I couldn\'t imagine a crueler tyrant. He enslaved this entire continent.','',0,0,0,0,0,0,0,0,5,0,35311,0,26124),
(72314,'Benevolence is a luxury for the strong, young prince. No great empire was ever built with kindness.','',0,0,0,0,0,0,0,0,5,0,36073,0,26124),
(72315,'...I\'m not so sure about that. But I can tell you: no great empire has ever stood the test of time by crushing its own citizens.','',0,0,0,0,0,0,0,0,5,0,35312,0,26124),
(72316,'Remember, the mogu were overthrown! THAT should be the lesson of the Thunder King. It\'s your move, by the way.','',0,0,0,0,0,0,0,0,5,0,35313,0,26124),
(72317,'I worry you may be too soft to wear your kingdom\'s crown, Prince Anduin. You would do well to learn some of your father\'s hardness.','',0,0,0,0,0,0,0,0,5,0,36074,0,26124),
(72318,'Are you lecturing me? You\'re what - two years old?','',0,0,0,0,0,0,0,0,5,0,35314,0,26124),
(72319,'Two in DRAGON years. It is your move.','',0,0,0,0,0,0,0,0,5,0,36075,0,26124),
(72320,'Hmmm.','',0,0,0,0,0,0,0,0,5,0,35315,0,26124),
(72321,'...Why did you play that piece just now?','',6,0,0,0,0,0,6,0,5,0,36018,0,26124),
(72322,'It\'s a Pandaren board game. The object is for both players to win.','',0,0,0,0,0,0,1,0,5,0,35302,0,26124),
(72323,'That\'s ridiculous! Why would you even play!?','',1,0,0,0,0,0,1,0,5,0,36019,0,26124),
(72324,'Champion, return now to the Isle of the Thunder King. I will meet you at the forge, where together we will create an instrument of legendary power.','',0,0,0,0,0,0,0,0,5,0,36056,0,26124),
(72325,'To what end? What are you two working towards?','',0,0,0,0,0,0,0,0,5,0,35303,0,26124),
(72326,'...world peace!','',0,0,0,0,0,0,0,0,5,0,36057,0,26124),
(72327,'Using a mogu weapon forge whose powers you barely understand?','',0,0,0,0,0,0,0,0,5,0,35304,0,26124),
(72328,'My dear prince, you and I share the same goals. We only differ in our level of commitment.','',0,0,0,0,0,0,0,0,5,0,36058,0,26124),
(72329,'Come, hero! Let us shape a new Azeroth together!','',0,0,0,0,0,0,0,0,5,0,36059,0,26124),
(72330,'Champion, I know that our people are at war, but if you blindly trust this black dragon in the pursuit of power, are you any better than your warchief? Please - just be careful.','',0,0,0,0,0,0,1,0,5,923,35305,0,26124),
(72331,'My friend, if you blindly trust a black dragon in the search for greater power, are you any better than Garrosh Hellscream? Please - just be careful.','',0,0,0,0,0,0,1,0,5,924,35306,0,26124),
(72332,'Tong, is that our friend?','',0,0,0,0,0,0,0,0,5,0,36611,0,26124),
(72333,'I can\'t believe you\'re still alive.','',0,0,0,0,0,0,1,0,5,0,35316,0,26124),
(72334,'Remind me to tell you the story about my friend here and what we accomplished together at Ravenholdt. Good times!','',0,0,0,0,0,0,1,0,5,21046,36077,0,26124),
(72335,'What did I tell you? Few mortals possess such courage and tenacity.','',0,0,0,0,0,0,1,0,5,21047,36078,0,26124),
(72336,'Meet me atop Mason\'s Folly, where we met before!','',0,0,0,0,0,0,0,0,5,0,36079,0,26124),
(72337,'What are you two plotting?','',0,0,0,0,0,0,6,0,5,0,35317,0,26124),
(72338,'I keep no secrets! You are welcome to accompany us, Anduin Wrynn. If your injury permits.','',0,0,0,0,0,0,0,0,5,0,36080,0,26124),
(72339,'I implore my Horde friend here not to push you off of the cliff.','',547,0,0,0,0,0,6,0,5,923,36081,0,26124),
(72340,'Truly a splendor! Have you ever seen such a view, Prince Anduin?','',0,0,0,0,0,0,0,0,5,0,36082,0,26124),
(72341,'It\'s breathtaking.','',0,0,0,0,0,0,0,0,5,0,35318,0,26124),
(72342,'It\'s about to get even more awe-inspiring.','',0,0,0,0,0,0,0,0,5,0,36083,0,26124),
(72343,'Champion! Behold the fruits of your labors!','',0,0,0,0,0,0,0,0,5,0,36724,0,26124),
(72344,'At the dawn of the world, when the mortal races were young, they did not yet possess the secrets of fire.','',0,0,0,0,0,0,0,0,5,0,36084,0,26124),
(72345,'They shivered in the cold and the rain until - in one instant - lightning tore the sky!','',0,0,0,0,0,0,0,0,5,0,36085,0,26124),
(72346,'It rent a tree asunder and set it aflame.','',0,0,0,0,0,0,0,0,5,0,36086,0,26124),
(72347,'The mortals gathered around the fire in awe and wonder. It could cook their food and warm their homes. They seized it! And protected it!','',0,0,0,0,0,0,0,0,5,0,36087,0,26124),
(72348,'They fed the fire every hour of every day. Hot coals were carried from one primitive camp to the next. Do you see? In a single flash of light, civilization was born.','',0,0,0,0,0,0,0,0,5,0,36088,0,26124),
(72349,'Truly, lightning is a gift of the Gods.','',0,0,0,0,0,0,0,0,5,0,36089,0,26124),
(72350,'The mogu, ah! The mogu! Their minds were so small! They were built to serve, and when they lost their masters, they served themselves.','',0,0,0,0,0,0,0,0,5,0,36090,0,26124),
(72351,'But they could have been so much more.','',0,0,0,0,0,0,0,0,5,0,36091,0,26124),
(72352,'They built an empire, when they could have built a new world.','',0,0,0,0,0,0,0,0,5,0,36092,0,26124),
(72353,'We will do better, champion. Behold! The Crown of Heaven! My gift to you.','',0,0,0,0,0,0,0,0,5,0,36093,0,26124),
(72354,'You are the ember. You are the spark! You are the fire that will spread across the world. You will awaken Azeroth\'s potential!','',0,0,0,0,0,0,0,0,5,0,36094,0,26124),
(72355,'Come to me.','',0,0,0,0,0,0,0,0,5,0,36095,0,26124),
(72356,'We know now that the mogu share their roots with the Titans. But many mysteries remain. Why were they here? Why Pandaria?','',0,0,0,0,0,0,1,0,5,0,36096,0,26124),
(72357,'What were the mogu sent here to guard? Or destroy? We are missing the final puzzle pieces, and YOU will help me find them!','',0,0,0,0,0,0,6,0,5,0,36097,0,26124),
(72358,'The crown I have given you will be as your third eye. It will tie us together. I will see what you see. Together we will lay the secrets of the Titans bare.','',0,0,0,0,0,0,273,0,5,0,36098,0,26124),
(72359,'I will be watching you closely, hero!','',0,0,0,0,0,0,0,0,5,0,36099,0,26124),
(72360,'Champion... I would think twice before putting that thing on your head.','',0,0,0,0,0,0,6,0,5,21064,35319,0,26124),
(72361,'According to this runestone, the mogu were Titan constructs, soulless creatures built of stone. We suspected as much.','',0,0,0,0,0,0,0,0,5,0,36412,0,26124),
(72362,'You\'ve found another stone! What have we learned? The \"curse of flesh\" made the mogu mortal. Ah - but later, they found a way to reverse the process. A clever race.','',0,0,0,0,0,0,0,0,5,0,36413,0,26124),
(72363,'The mogu served a Titan keeper. His name was \"Ra.\" In the mogu tongue, \"Ra-den\" means \"Master Ra.\" Fascinating! I must know more!','',0,0,0,0,0,0,0,0,5,0,36414,0,26124),
(72364,'According to this, the mogu and their master were sent to Pandaria. They were pursuing a great darkness - ah, the fragment is incomplete. We must find others.','',0,0,0,0,0,0,0,0,5,0,36415,0,26124),
(72365,'Here, there is mention of an Old God. \"Y\'Shaarj.\" A beast with seven heads, who breathed darkness. I suspect that thing was the source of the sha that haunts Pandaria to this day.','',0,0,0,0,0,0,0,0,5,0,36416,0,26124),
(72366,'This runestone speaks of a \"Cradle of Life.\" A place where the Titans could create new creatures. Oh - of course - the Vale of Eternal Blossoms! It was a living laboratory, much like Un\'goro Crater or Sholazar Basin.','',0,0,0,0,0,0,0,0,5,0,36417,0,26124),
(72367,'We\'re beginning to put the pieces together, champion. The mogu were created and sent here to guard the Vale for their Titan masters. Guard it from what? Were the Old Gods still a threat?','',0,0,0,0,0,0,0,0,5,0,36418,0,26124),
(72368,'Here, this fragment speaks of \"The Winged Legions of Y\'Shaarj.\" Servants of an Old God? Could this mean the mantid?','',0,0,0,0,0,0,0,0,5,0,36419,0,26124),
(72369,'This runestone is more recent than the others. Something about \"The sleeping keeper.\" I think it\'s referring to Ra-Den. But why was he asleep?','',0,0,0,0,0,0,0,0,5,0,36420,0,26124),
(72370,'You\'ve found another piece of the puzzle! This was carved by the mogu. They were frustrated - a thousand years with no orders from their master, and their bodies had turned to flesh. The mogu began to argue among themselves.','',0,0,0,0,0,0,0,0,5,0,36421,0,26124),
(72371,'Hmmm. This runestone speaks of mogu savagery. They fell apart into warrior clans. But one King was more ambitious than the others - Lei Shen. The Thunder King. When the Titan Keeper fell silent, Lei Shen decided to speak for him.','',0,0,0,0,0,0,0,0,5,0,36422,0,26124),
(72372,'Ah! The final piece of the puzzle. The Thunder King took on the powers of Ra-Den, the very essence of a Titan. He united the mogu into an empire and tried to continue the Titans\' work. Of course he saw himself as a God!','',0,0,0,0,0,0,0,0,5,0,36423,0,26124),
(72373,'Quickly, return to me at the Veiled Stair. We should talk face-to-face.','',0,0,0,0,0,0,0,0,5,0,36424,0,26124),
(72374,'I have been looking forward to your return, champion.','',0,0,0,0,0,0,1,0,5,0,36060,0,26124),
(72375,'The Thunder King took within himself the powers of a Titan keeper. We must take them back!','',0,0,0,0,0,0,1,0,5,0,36061,0,26124),
(72376,'Bring me his cruel, black heart. We will be doing the Pandaren a favor, and the powers that we liberate will once again be put to the service of Azeroth.','',0,0,0,0,0,0,25,0,5,0,36062,0,26124),
(72377,'A chill just went up my spine!','',0,0,0,0,0,0,1,0,5,0,35307,0,26124),
(72378,'Something tells me our friend has returned triumphant.','',0,0,0,0,0,0,6,0,5,0,36063,0,26124),
(72379,'Ahhh - the heart of a King. The powers of a God.','',0,0,0,0,0,0,0,0,5,0,36064,0,26124),
(72380,'What are you doing? You\'re not seriously going to eat that-','',0,0,0,0,0,0,6,0,5,0,35308,0,26124),
(72381,'It is filled with Titan magic, the very language of creation...','',0,0,0,0,0,0,1,0,5,0,36065,0,26124),
(72382,'Oh - I see them - a million, million worlds - glittering in their perfection - but one above all others - oh -','',0,0,0,0,0,0,1,0,5,0,36066,0,26124),
(72383,'WE HAVE FALLEN. WE MUST REBUILD THE FINAL TITAN. DO NOT FORGET.','',0,0,0,0,0,0,0,0,5,0,36067,0,26124),
(72384,'What are you trying to pull?','',0,0,0,0,0,0,274,0,5,0,35309,0,26124),
(72385,'It is gone. I don\'t remember any of it. Oh! None of them remember. The irony!','',0,0,0,0,0,0,0,0,5,0,36068,0,26124),
(72386,'What are you talking about? I don\'t trust you.','',0,0,0,0,0,0,5,0,5,0,35310,0,26124),
(72387,'You are wise not to.','',0,0,0,0,0,0,1,0,5,0,36069,0,26124),
(72388,'Champion, I need time to... \"digest\" what I have learned.  But soon, we will take action.','',0,0,0,0,0,0,6,0,5,0,36070,0,26124),
(72389,'Stop casting! %s is generating an |cFFFF0000|Hspell:138763|h[Interrupting Jolt]|h|r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72390,'For the Light!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72391,'Your class cooldowns have been reset!','Your class cooldowns have been reset!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72392,'How dare you interrupt our preparations! The Zandalari will not be stopped, not this time!','How dare you interrupt our preparations! The Zandalari will not be stopped, not this time!',0,0,0,0,0,0,1,0,1,0,35737,35737,26124),
(72393,'Destroy them, I command you! No, stop, stop!','Destroy them, I command you! No, stop, stop!',0,0,0,0,0,0,25,0,1,0,35736,35736,26124),
(72394,'Who dares disturb me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72395,'The spirits shall consume you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72396,'','Don\'t fall back. Don\'t give them an inch!',0,0,0,0,0,0,0,0,1,0,0,35484,26124),
(72397,'','The Zandalari are nothing but lap-dogs. Do you hear me? You are pets for the mogu!',0,0,0,0,0,0,0,0,1,0,0,35486,26124),
(72398,'','Everyone, stay together. Stay focused.',0,0,0,0,0,0,0,0,1,0,0,35487,26124),
(72399,'','Press the attack! We\'re smarter than they are strong!',0,0,0,0,0,0,0,0,1,0,0,35488,26124),
(72400,'','Press the attack!',0,0,0,0,0,0,0,0,1,0,0,35489,26124),
(72401,'Thank you for that. Now let\'s take down that wall!','Thank you for that. Now let\'s take down that wall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72402,'You have my gratitude.','You have my gratitude.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72403,'Let\'s take this fight to the Thunder King!','Let\'s take this fight to the Thunder King!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72404,'Come on! Let\'s keep going!','Come on! Let\'s keep going!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72405,'Death to the Zandalari!','Death to the Zandalari!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72406,'','Clear a path from the ship to the gate at the upper level - we will need to cross on foot.',0,0,0,0,0,0,0,0,1,0,0,35862,26124),
(72407,'Sinu a\'manore, champion.','',0,0,0,0,0,0,0,0,1,0,35661,0,26124),
(72408,'With the help of the Shado-Pan and this beast you recovered, I believe we can infiltrate and disable the Thunder King\'s armory.','',0,0,0,0,0,0,0,0,1,0,35662,0,26124),
(72409,'Speak to me when you are ready to begin.','',0,0,0,0,0,0,0,0,1,0,35663,0,26124),
(72410,'Elsia is waiting for you, champion.','',0,0,0,0,0,0,0,0,1,0,35664,0,26124),
(72411,'Rangers! Secure the forge. Smash the gate, so it cannot be closed!','',0,0,0,0,0,0,0,0,1,0,35665,0,26124),
(72412,'Incredible work. I knew the Shado-Pan would make excellent allies.','',0,0,0,0,0,0,0,0,1,0,35666,0,26124),
(72413,'Regardless, we have delivered a terrible blow to the Thunder King today. Horde metalsmiths can begin studying mogu fabrication techniques immediately.','',0,0,0,0,0,0,0,0,1,0,35667,0,26124),
(72414,'In good time, my pandaren friend. In good time.','',0,0,0,0,0,0,0,0,1,0,35668,0,26124),
(72415,'','We share a common enemy, Regent Lord, nothing more.',0,0,0,0,0,0,2,0,1,0,0,35883,26124),
(72416,'','With all respect - these abominable tools should be destroyed!',0,0,0,0,0,0,5,0,1,0,0,35884,26124),
(72417,'Good to see you again adventurer.  Are you ready to begin?','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(72418,'Let\'s go!','Let\'s go!',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(72419,'Thank you for your help, adventurer.  We will assist you as best we can in fending off the mogu.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(72420,'I\'m ready to begin my mission.','I\'m ready to begin my mission.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72422,'My wares are reserved for those who have proven themselves on the field of battle. Come see me after you\'ve swept the fields clean of Alliance filth.','My wares are reserved for those who have proven themselves on the field of battle. Come see me after you\'ve swept the fields clean of Alliance filth.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72423,'My wares are reserved for those who have proven themselves on the field of battle. You\'ll need to prove your dominance over the Horde scum before I\'ll entrust them to you.','My wares are reserved for those who have proven themselves on the field of battle. You\'ll need to prove your dominance over the Horde scum before I\'ll entrust them to you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72424,'Kill the Skumblade Ritualist before the Echo of Kros eats it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72425,'','This creature you\'ve recovered is immune to the lightning strikes that protect the island.',0,0,0,0,0,0,0,0,1,0,0,36388,26124),
(72426,'','Do you think you can ride it?',0,0,0,0,0,0,0,0,1,0,0,36389,26124),
(72427,'','Very good!  Once you take to the skies, the Zandalari will try to stop you.',0,0,0,0,0,0,0,0,1,0,0,36390,26124),
(72428,'','Be ready to dogfight in the air. Jump from mount to mount if you have to!',0,0,0,0,0,0,0,0,1,0,0,36391,26124),
(72429,'','A Shado-Pan contact will be waiting to meet you behind the mines. Good luck!!',0,0,0,0,0,0,0,0,1,0,0,36392,26124),
(72430,'What is this? Another uprising?','',0,0,0,0,0,0,0,0,1,0,35787,0,26124),
(72431,'I will soon put you in your place.','',0,0,0,0,0,0,0,0,1,0,35793,0,26124),
(72432,'You are not a slave. How did you get here?','',0,0,0,0,0,0,0,0,1,0,35789,0,26124),
(72433,'You will be in chains before I am done! You will beg for death!!','',0,0,0,0,0,0,0,0,1,0,35790,0,26124),
(72434,'Bend before me!','',0,0,0,0,0,0,0,0,1,0,35791,0,26124),
(72435,'Kneel before your master!','',0,0,0,0,0,0,0,0,1,0,35792,0,26124),
(72436,'You will be... punished...','',0,0,0,0,0,0,0,0,1,0,35788,0,26124),
(72437,'Tinzo the Emberkeeper is nearing full health!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72438,'Tinzo the Emberkeeper is stealing all of your heals!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72439,'Kor\'dok winds up a powerful shield slam.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72440,'YES! Finally! I won a Brawler\'s Guild invite! Nobody can stop me now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72441,'I guess I wasn\'t ready to be a brawler.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72442,'Everyone look! I won a Brawler\'s Guild invite! I can\'t wait to try it out!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72443,'I won a Brawler\'s Guild invitation just now! I\'ll surely be rank 8 by tonight!  I sure hope I don\'t lose my ticket before I get there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72444,'Da view from above is... breathtaking!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72445,'Grab them ma pets!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72446,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72447,'Have a safe fall, Rogue.','',0,0,0,0,0,0,0,0,1,18177,0,0,26124),
(72448,'Going... up?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72449,'Hope you packed some feathers, Priest.','',0,0,0,0,0,0,0,0,1,18176,0,0,26124),
(72450,'No coppa? This flights on me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72451,'','NO!',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72452,'BEHOLD! I have truly mastered the fel energies of this world! The demonic power I now command... It is indescribable, unlimited, OMNIPOTENT!','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72453,'You think I\'ve gone too far? There is no such thing. The Black Harvest will enslave the most powerful demons, draw on their power, and destroy all who oppose us, in this world, and on Azeroth! Do YOU mean to stop me, little one?','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72455,'My power is unimaginable!','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72456,'Hah. Your feeble attacks are entertaining. Would you like to see one of my new pets?','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72457,'I\'d like to see you try.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72458,'The Annihilan are incredibly destructive creatures. Their sheer strength and power is absolutely unrivaled.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72459,'WHAT?! Now you\'ve angered me.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72460,'I\'ll shatter your soul!','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72461,'You are nothing!','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72462,'Deathwing had unstoppable power. And now, it is MINE.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72463,'You cannot stop your final Cataclysm!','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72464,'This will be your END.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72465,'CATACLYSMIC POWER!','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72466,'Burn.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72467,'Pure... CHAOS.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72468,'Chaos will reign.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72469,'Chaotic energy will destroy you.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72470,'The clock is ticking...','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72471,'NOOOOO!','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72472,'AUGHHHH!','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72473,'UNFATHOMABLE!','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72474,'How can it be?!','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72475,'You\'ll burn for that.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72476,'Hold still...','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72477,'This may seem meager at first, but give it a moment. Soon, the pain will be unbearable.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72478,'Twist in agony.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72479,'Rising pain.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72480,'The anguish will creep up on you.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72481,'Away from me, mongrel!','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72482,'I am untouchable!','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72483,'Run in fear, coward.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72484,'Destructive forces corrupt you from the inside.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72485,'Plant a seed and watch it grow...','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72486,'I wonder what this seed will grow into?','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72487,'I give you the gift of destruction!','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72488,'Terrible destruction awaits you when this seed erupts.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72489,'Chaotic magic always has the potential for unexpected results.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72490,'Archimonde\'s use of the ered\'ruin was brilliant. Their command of the dark energies is unparalleled.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72491,'The ered\'ruin have had no master since Archimonde\'s death. Now I shall be that master.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72492,'While not the most powerful combatants, a pack of felhounds still has many uses.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72493,'The felhounds are always hungry for magic to devour.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72494,'If two imps are better than one imp, what\'s better than two imps? SIXTY IMPS.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72495,'Even the smallest demon can be valuable, in large enough numbers.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72496,'','This is only what you once asked me to do if it came to this, Kanrethad. You brought this on yourself.',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72497,'','$n, thank you for your help. While the world will not know, you\'ve saved them more than they\'re aware. Kanrethad had to be stopped. I\'ll see to it that he stays banished.',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72498,'','Kanrethad enveloped himself with so much fel energy that it corrupted him totally. But a small taste of his power should not be harmful. Go ahead.',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72499,'','Now go, and use what you\'ve learned. If you ever wish to have the fel energy purged from you, or reabsorb some of Kanrethad\'s, talk to me. I\'ll be at the Altar of Damnation in Shadowmoon Valley, keeping him banished.',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72500,'Hah ha ha... You thought you could defeat me? NOTHING can kill me now, puny mortal!','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72501,'And now, your sad tale comes to an end.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72502,'Jubeka?! What are you...?!','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72503,'...AUGHHHHHH!!!','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72504,'Many imps! Handle it!','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72505,'%s devours your Enslave Demon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72506,'These insects have not yet learned their place, Gara\'jal. If you wish to prove your \"might\" on such weaklings it matters not to me.','',0,0,0,0,0,0,0,0,1,0,35586,0,26124),
(72507,'You have swept the filth from my doorstep. Perhaps you are worthy of my attention.','',0,0,0,0,0,0,0,0,1,0,35587,0,26124),
(72508,'But your trespass ends here. None may enter my forbidden stronghold. I shall rebuild this bridge with your bones for bricks.','',0,0,0,0,0,0,0,0,1,0,35588,0,26124),
(72509,'You! You have earned my ire. I will make an example of you, such that all who look upon my might will tremble and submit.','',0,0,0,0,0,0,0,0,1,0,35589,0,26124),
(72510,'I am Lei Shen, slayer of kings and gods. You have made a grave mistake.','',0,0,0,0,0,0,0,0,1,0,35581,0,26124),
(72511,'Kneel!','',0,0,0,0,0,0,0,0,1,0,35599,0,26124),
(72512,'Die!','',0,0,0,0,0,0,0,0,1,0,35600,0,26124),
(72513,'Submit!','',0,0,0,0,0,0,0,0,1,0,35601,0,26124),
(72514,'Lightning, seek my foes!','',0,0,0,0,0,0,0,0,1,0,35602,0,26124),
(72515,'Wind, heed my call!','',0,0,0,0,0,0,0,0,1,0,35603,0,26124),
(72516,'My power cannot be contained!','',0,0,0,0,0,0,0,0,1,0,35583,0,26124),
(72517,'You have sealed your doom!','',0,0,0,0,0,0,0,0,1,0,35584,0,26124),
(72518,'You would challenge me in my own sanctum? Witness your folly!','',0,0,0,0,0,0,0,0,1,0,35595,0,26124),
(72519,'Bah! I will crush you myself. Let us see how you fare against Lightning.','',0,0,0,0,0,0,0,0,1,0,35596,0,26124),
(72520,'You are NOTHING! I wield the power of the heavens!','',0,0,0,0,0,0,0,0,1,0,35597,0,26124),
(72521,'NO! You are UNWORTHY! I... AM... THE THUNDER KING!','',0,0,0,0,0,0,0,0,1,0,35598,0,26124),
(72522,'I sought only to finish... the work of the Gods...','',0,0,0,0,0,0,0,0,1,0,35585,0,26124),
(72523,'Enough of this!','',0,0,0,0,0,0,0,0,1,0,35582,0,26124),
(72524,'Minuscule.','',0,0,0,0,0,0,0,0,1,0,35590,0,26124),
(72525,'Unworthy.','',0,0,0,0,0,0,0,0,1,0,35591,0,26124),
(72526,'My judgment is final.','',0,0,0,0,0,0,0,0,1,0,35592,0,26124),
(72527,'Lightning strikes.','',0,0,0,0,0,0,0,0,1,0,35593,0,26124),
(72528,'Kneel before me!','',0,0,0,0,0,0,0,0,1,0,35594,0,26124),
(72529,'|cFFFF0000|Hspell:135096|h[Thunderstruck]|h|r killed you.  Move away from the impact point to decrease damage taken.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72530,'Such an exotic land. I am sure there is quite a menagerie of animals and beasts to be found here. And all with that delightful electrical discharge popping off their bodies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72531,'What a delightful specimen you have captured. I have been teaching it to not electrocute our servants. Though it is still a hatchling, and you have to expect such behavior when it is this young.$b$bThankfully the sunwalker over there has been quite helpful in healing those injured by such mischief.$b$bOh, and I took the liberty of giving your tiny creature a name.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72532,'I am astounded by how quickly this creature grows. At first the diet of cheeses was simply irritating the beast.$b$bBut then we fed it some of the local goats and it started booming in size.$b$bA voracious creature to be sure.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72533,'We found a saddle and harness from one of the carcasses of the various beasts being shot out of the sky.$b$bA little polish and a little magic and presto... good as new!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72534,'The Celestial Blacksmith is near death!','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(72535,'The Celestial Defender is near death!','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(72536,'The Celestial Defender manifests an area of |cFFFF2222|Hspell:140068|h[healing energy]|h|r!','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(72537,'Ahaha, get a load \'a me, mon!$b$bGriftah be back again! New stall, and brand new wares, and ready to pass on the deals to ya!$b$bWant more luck for deh mountains? Want tah buy the best \"luckydo\" ya ever smelled? Well step right up and don\' be talkin\' to grummles. Just let your good ol\' friend Griftah lead ya right.$b$bThese miraculous baubles be cheap at tripple the price!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72538,'Ya tink these herbs and fancy incense be givin\' ya luck in dah mountains? Ha ha! Ya not be tradin\' with dah right mon, mon. Come be gettin\' you a genuine Lucky Lock!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72539,'Griftah, you think those are luckydos? They smell more like luckydon\'ts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72540,'Griftah, your nose is too pointy to smell good fortune. And you smell like unwashed yak.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72541,'The pandaren have many legends about trolls like you, Griftah. Many legends indeed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72542,'Hey! Griftah! That is one of my luckydos! Where did you get that?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72543,'And to think, my friends say I \"troll\" too much. I must show them you, Griftah.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72544,'What is that smell? What is that smell?! Is that you Griftah? How can you have that smell? This is most offensive. Most offensive, yes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72545,'Ya grummles be good sports. I be likin\' the cut of your jib.$b$bFor dat reason, I be willing to part with this \"Luckydo Kazoo\" which be makin\' only deh most luckiest of music.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72546,'Ya can\'t be riding yaks into the mountains without a bonified \"Lucktug\"! That be madness! Lemme sell ya some for cheap.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(72547,'So ya be smellin\' fortune eh? What say ya come with me to Bilgewater and we make a fortune at the gamblin\' tables.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(72548,'Ah, come on! Dis\' deal be a good one and ya know it ya snuffler.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(72549,'Dunna\' be judgin\' too quickly, ya? Dis lil\' trinket be exactly what ya looking for, smeller man.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(72550,'Good! You\'re here.  Speak to me when you\'re ready to begin.','',0,0,0,0,0,0,0,0,1,0,36020,0,26124),
(72551,'The trillium you brought me must be refined for our purposes.','',0,0,0,0,0,0,1,0,1,0,36021,0,26124),
(72552,'This foundry should be sufficient.  Help me manipulate the molds.','',0,0,0,0,0,0,25,0,1,0,36022,0,26124),
(72553,'Be ready to fight if we draw too much attention.','',0,0,0,0,0,0,0,0,1,0,36023,0,26124),
(72554,'Clear out the rabble, would you?','',0,0,0,0,0,0,22,0,1,0,36024,0,26124),
(72555,'I need to concentrate. Keep the foundry clear!','',0,0,0,0,0,0,22,0,1,0,36025,0,26124),
(72556,'Excellent! The materials are prepared.  Follow me.','',0,0,0,0,0,0,4,0,1,0,36026,0,26124),
(72557,'How interesting! This forge is built atop of ancient Titan machinery. Lei Shen, you clever, clever tyrant, you!','',0,0,0,0,0,0,0,0,1,0,36027,0,26124),
(72558,'Now if I were a dwarf I would just start randomly pushing buttons. But you and I are here for a purpose.','',0,0,0,0,0,0,0,0,1,0,36028,0,26124),
(72559,'Watch my back while I activate the forge. Did you know that all dragons innately understand the language of the Titans? No doubt a part of their \"grand design.\"','',0,0,0,0,0,0,1,0,1,0,36029,0,26124),
(72560,'Look at that. How easy it must have been for Lei Shen to build an empire, for he wielded the power to create worlds.','',0,0,0,0,0,0,0,0,1,0,36030,0,26124),
(72561,'Please, keep away the distractions.  I need to concentrate on this.','',0,0,0,0,0,0,0,0,1,0,36031,0,26124),
(72562,'Protect the forge!','',0,0,0,0,0,0,5,0,1,0,36032,0,26124),
(72563,'\"Security Protocols?\" Ridiculous. Why were the Titans so obsessed with hiding all of their wonderful toys?','',0,0,0,0,0,0,0,0,1,0,36033,0,26124),
(72564,'You titans infuriate me. I am acting on behalf of the greater good.','',0,0,0,0,0,0,0,0,1,0,36034,0,26124),
(72565,'Do me a favor and silence those things. I am otherwise engaged.','',0,0,0,0,0,0,0,0,1,0,36035,0,26124),
(72566,'Fortunately I can just disable the security. What would you do without me, hm?','',0,0,0,0,0,0,0,0,1,0,36036,0,26124),
(72567,'Certainly there\'s an easier way - oh. Ah! There we go!','',0,0,0,0,0,0,0,0,1,0,36037,0,26124),
(72568,'Ohh, look at that!','',0,0,0,0,0,0,25,0,1,0,36038,0,26124),
(72569,'The mogu were using only a fraction of the resources available to them. Few among them possessed the cunning of the Thunder King.','',0,0,0,0,0,0,0,0,1,0,36039,0,26124),
(72570,'What\'s this - \"Anomaly detected.\" Anomaly?','',0,0,0,0,0,0,6,0,1,0,36040,0,26124),
(72571,'Look at that. This old Titan technology is acting like a magnet for the sha.','',0,0,0,0,0,0,1,0,1,0,36041,0,26124),
(72572,'You\'re an expert at destroying sha by now. Clean up this mess!','',0,0,0,0,0,0,396,0,1,0,36042,0,26124),
(72573,'The forge draws power from the surrounding land. Amazing! I suspect at one time this whole island looked like the Vale of Eternal Blossoms.','',0,0,0,0,0,0,0,0,1,0,36043,0,26124),
(72574,'Keep it up. I am working miracles here!','',0,0,0,0,0,0,0,0,1,0,36044,0,26124),
(72575,'Excellent work! Protect the forge - I am almost finished.','',0,0,0,0,0,0,0,0,1,0,36045,0,26124),
(72576,'This is no good - too dangerous. We\'ll try again later!','',0,0,0,0,0,0,0,0,1,0,36046,0,26124),
(72577,'The forge is overwhelmed! We\'ve got to leave!','',0,0,0,0,0,0,0,0,1,0,36047,0,26124),
(72578,'No no no - this isn\'t right at all. Let\'s get out of here.','',0,0,0,0,0,0,0,0,1,0,36048,0,26124),
(72579,'There! Our work is complete - we have forged a masterpiece!','',0,0,0,0,0,0,1,0,1,0,36049,0,26124),
(72580,'We are done here, but the weapon is not yet tempered.','',0,0,0,0,0,0,1,0,1,0,36050,0,26124),
(72581,'You must thrust the spear into the heart of the Storm Lord while he still lives.','',0,0,0,0,0,0,1,0,1,0,36051,0,26124),
(72582,'Be careful! The moment it pierces his hide, you will be assaulted by his power.','',0,0,0,0,0,0,274,0,1,0,36052,0,26124),
(72583,'It is important to throw the spear just before slaying the beast. Not a moment too soon! Not a moment too late!','',0,0,0,0,0,0,6,0,1,0,36053,0,26124),
(72584,'I must make preparations back on the mainland. Return to me at the Veiled Stair when you have what I need.','',0,0,0,0,0,0,25,0,1,0,36054,0,26124),
(72585,'Oh, and don\'t die.','',0,0,0,0,0,0,0,0,1,0,36055,0,26124),
(72586,'','Got a work related complaint to register? Great! That\'ll be five hundred macaroons for investigation fees and three hundred macaroons for assorted palm greasing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72587,'|cFFF00000Megaera|r rises from the mists!','|cFFF00000Megaera|r rises from the mists!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72588,'My order has long wandered these lands, lending aid where we can. Ever since the days of Lei Shen there have been five of our order, passing the secrets of our order from generation to generation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72589,'What secrets?','What secrets?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72590,'If I told you... it would not be called a secret, now would it?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72591,'Five sorcerers?','Five sorcerers?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72592,'I no longer remember where the others are. Indeed it has been so long since we last saw each other the others may very well be dead, or replaced by their pupils. I can only have faith that there are still five of us left.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72593,'FOOLS! I will show you how it is done!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(72594,'The cavern trembles violently!','The cavern trembles violently!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72595,'An ancient beast stirs within the mists!','An ancient beast stirs within the mists!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72596,'My parents once spoke of a strange, furry folk that lived far to the south of our homeland before the Sundering. I always assumed they spoke of smarter furbolgs.$b$bI know now just how wrong I was. Would that they still walked this world and could see this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72597,'|cFFFF0000|Hspell:134916|h[Decapitate]|h|r killed you.  The further you are from Lei Shen, the lower the damage from Decapitate. Have the off-tank taunt!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72598,'You said you would ring the gong first.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72599,'Nuh uh! And besides, that\'s not a gong! It\'s a bell. I didn\'t say I would hit a bell.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72600,'I dare you!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72601,'No way. That bell is bigger than my daddy\'s belly!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72602,'I double dare you!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72603,'The Bellmaster is right over there. I heard he turns kids into bells!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72604,'You heard that from your sister and she doesn\'t count. She\'s a big meanie. I double hozen dare you to ring the bell!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72605,'*gulp* Dou... dou... double hozen dare?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72606,'Yep! You don\'t do this and I\'ll tell everyone in Dawn\'s Blossom you are a big chicken who likes wine instead of beer!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72607,'But my dad says I\'m too little to drink.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72608,'Yeah! And you\'ll get in trouble for that too! Now ring the bell you big baby.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72609,'Hah ha ha... You thought you could defeat me? NOTHING can kill me now, puny mortal!','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72610,'','I swore an oath to the Kirin Tor. That bond was one of trust and mutual understanding. And then they betrayed that bond. It is time to remind them the blood elves do not suffer betrayal lightly.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72611,'Stop them! The Animus must not be disturbed!','',0,0,0,0,0,0,0,0,0,0,35725,0,26124),
(72612,'The power... It cannot be wielded this way! You tempt forces you do not understand!','',0,0,0,0,0,0,0,0,0,0,35722,0,26124),
(72613,'You have doomed yourselves. It... is... unleashed.','',0,0,0,0,0,0,0,0,0,0,35724,0,26124),
(72614,'$C, if you are looking for the Black Prince, you will find him upstairs.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(72615,'This continent does not give up its secrets easily.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72616,'We still have so much to learn.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72617,'The pandaren embrace life. With so much fighting all around us, it is refreshing to know what we\'re fighting for.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72618,'Come, have a drink. The prince here is showing me how to play one of the local games.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72619,'The mogu, the mantid, the saurok... they are not just enemies to defeat. They are mysteries to solve!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72620,'','Hail, friend!',0,0,0,0,0,0,0,0,1,0,0,35535,26124),
(72621,'','I think I have a plan to infiltrate the Thunder King\'s armory. We\'ll use that creature you recovered, with a little help from the Shado-Pan.',0,0,0,0,0,0,0,0,1,0,0,35536,26124),
(72622,'','Speak to me when you are ready to begin.',0,0,0,0,0,0,0,0,1,0,0,35537,26124),
(72623,'','Vereesa is waiting for you, champion.',0,0,0,0,0,0,0,0,1,0,0,35538,26124),
(72624,'Enter the Fall of Shan Bu scenario.','Enter the Fall of Shan Bu scenario.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72625,'','This beautiful creature you rescued is immune to the lightning strikes that protect the island.',0,0,0,0,0,0,0,0,1,0,0,35933,26124),
(72626,'','Do you think you can ride it?',0,0,0,0,0,0,0,0,1,0,0,35934,26124),
(72627,'','Wonderful!  Once you take to the skies, the Zandalari may come after you.',0,0,0,0,0,0,0,0,1,0,0,35935,26124),
(72628,'','Be ready to dogfight in the air. Jump from mount to mount if you have to!',0,0,0,0,0,0,0,0,1,0,0,35936,26124),
(72629,'','A Shado-Pan agent will meet you behind the mines. Good luck!!',0,0,0,0,0,0,0,0,1,0,0,35937,26124),
(72630,'Once you have met the various factions in Pandaria, work orders will pour in.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72631,'Thousands of years ... without new playthings ... I will enjoy this.','',0,0,0,0,0,0,558,0,1,0,35339,0,26124),
(72632,'Behold the power of the void.','',0,0,0,0,0,0,0,0,1,0,35336,0,26124),
(72633,'I expected so much more. How ... disappointing.','',0,0,0,0,0,0,0,0,1,0,35337,0,26124),
(72634,'I ... welcome ... the void\'s ... embrace.','',0,0,0,0,0,0,0,0,1,0,35338,0,26124),
(72635,'Do you see what I did there?','',0,0,0,0,0,0,0,0,1,0,35340,0,26124),
(72636,'Looks like you couldn\'t keep up ... pity.','',0,0,0,0,0,0,0,0,1,0,35341,0,26124),
(72637,'Watch your footing ... muhahaha!','',0,0,0,0,0,0,0,0,1,0,35342,0,26124),
(72638,'The mists hide many secrets ... if you know where to look.','',0,0,0,0,0,0,0,0,1,0,35343,0,26124),
(72639,'I\'m keeping an eye on you.','',0,0,0,0,0,0,0,0,1,0,35344,0,26124),
(72640,'Observe your demise.','',0,0,0,0,0,0,0,0,1,0,35345,0,26124),
(72641,'This is the tale of the Dagger in the Dark!$B$BIt was here that three bold adventurers saved Vol\'jin, leader of the Horde\'s Darkspear trolls, from certain assassination.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72642,'Why do I look like a troll?','Why do I look like a troll?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72643,'Ah, because you are an actor in this tale!$B$BMuch better than simply reading history from some musty old scroll, wouldn\'t you agree?$B$BNow go forward, and learn!','',11,1,0,0,6,0,0,0,1,0,0,0,26124),
(72644,'This is the tale of A Little Patience!$B$BIt was here that the king of men, Varian Wrynn, counseled patience to Tyrande Whisperwind, high priestess of the night elf\'s moon goddess and leader of their people.$B$BKing Varian\'s plan -- and the work of three bold adventurers! -- saw to an Alliance victory at the temple of the Red Crane, despite being vastly outnumbered by Commander Scargash\'s Horde forces.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72645,'Why do I look like a human?','Why do I look like a human?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72646,'','Lady Proudmoore, it is safe for you to enter.',0,0,0,0,0,0,0,0,1,0,0,35939,26124),
(72647,'','Rangers! Secure the forge. Smash the gate, so it cannot be closed!',0,0,0,0,0,0,0,0,1,0,0,35938,26124),
(72648,'','You two did it! I knew the Shado-Pan would make excellent allies.',0,0,0,0,0,0,0,0,1,0,0,35539,26124),
(72649,'','We share a common enemy, Lady Proudmoore. Nothing more.',0,0,0,0,0,0,2,0,1,0,0,35846,26124),
(72650,'','My lady. Weapons of the Thunder King are an abomination. They should be destroyed.',0,0,0,0,0,0,2,0,1,0,0,35847,26124),
(72651,'','But together we have delivered a terrible blow to the Thunder King!',0,0,0,0,0,0,0,0,1,0,0,35540,26124),
(72652,'','Vereesa, gather up everything we can find before the mogu return. Leave nothing for the Horde to claim.',0,0,0,0,0,0,0,0,1,0,0,35541,26124),
(72653,'','Oh, they will be. But knowledge is power, and I will never turn down an opportunity to study something new. Thank you, Taoshi.',0,0,0,0,0,0,0,0,1,0,0,35542,26124),
(72654,'','And thank YOU, hero. It will be difficult to hold the forge, but think of what we can learn here!',0,0,0,0,0,0,0,0,1,0,0,35543,26124),
(72655,'|TInterface\\Icons\\trade_archaeology_whitehydrafigurine:20|tMegaera begins to |cFFF00000|Hspell:139458|h[Rampage]|h|r!','|TInterface\\Icons\\trade_archaeology_whitehydrafigurine:20|tMegaera begins to |cFFF00000|Hspell:139458|h[Rampage]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72656,'The Shado-Pan are here! They may be of use to us. We should help.','',0,0,0,0,0,0,0,0,1,0,36402,0,26124),
(72657,'This foundry should be sufficient.  We will empower the metal with an electrical charge.','',0,0,0,0,0,0,1,0,1,0,36405,0,26124),
(72658,'Perhaps if I overcharge the forge, it will destabilize this sha nuisance? Let\'s try it.','',0,0,0,0,0,0,0,0,1,0,36406,0,26124),
(72659,'There. Problem solved.','',0,0,0,0,0,0,1,0,1,0,36407,0,26124),
(72660,'Oh - I may have spoken too soon. The sha grows in strength! Destroy it!','',0,0,0,0,0,0,274,0,1,0,36408,0,26124),
(72661,'You aren\'t harboring any bad thoughts, are you?','',0,0,0,0,0,0,0,0,1,0,36409,0,26124),
(72662,'I\'ve overcharged the anvils. They will be VERY effective against the sha, but each one can only be used once more!','',0,0,0,0,0,0,22,0,1,0,36410,0,26124),
(72663,'The lance is finished. Quickly, hurl it at the sha!','',0,0,0,0,0,0,22,0,1,0,36411,0,26124),
(72664,'','Taoshi nods toward the crewman on the right. Sneak up behind him to knock him out!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72665,'','Are you prepared, $n?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72666,'You will be exterminated!','',0,0,0,0,0,0,0,0,0,0,35725,0,26124),
(72667,'An empty crate waits to be filled and prepared for delivery.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72668,'You are being chased by lightning!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72669,'','Hello, $n. \n\nKanrethad\'s power is too great to allow him to be free. I\'ll ensure he stays banished, for as long as I exist.\n\nStill, a taste of the fel energies he is saturated with should cause no ill. Feel free to drain some for your own use. Should you ever grow tired of its effects, I can purge the fel energy from you, for a price.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72670,'Jubeka, I no longer wish to be tainted by this fel energy.','Jubeka, I no longer wish to be tainted by this fel energy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72671,'Are you sure that you no longer want the Codex of Xerrath?','Are you sure that you no longer want the Codex of Xerrath?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72672,'The Zandalari Prophecy.','The Zandalari Prophecy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72673,'Rumbles of Thunder.','Rumbles of Thunder.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72674,'Gods and Monsters.','Gods and Monsters.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72675,'I\'m ready to tear down the wall! [Queue for solo instance.]','I\'m ready to tear down the wall! [Queue for solo instance.]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72676,'The Sha Amalgamation begins casting |cFFFF2222|Hspell:139382|h[Insanity]|h|r!  Discharge one of the anvils to stop it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72677,'Spectacular! Move up - press onward. Show them no quarter!','',0,0,0,0,0,0,0,0,1,0,35632,0,26124),
(72678,'','This way - the Zandalari are falling back!',0,0,0,0,0,0,5,0,1,0,0,36379,26124),
(72679,'','Through the breech! Target the wounded!',0,0,0,0,0,0,5,0,1,0,0,36380,26124),
(72680,'','What... what did they DO to that troll!?',0,0,0,0,0,0,5,0,1,0,0,36381,26124),
(72681,'','My Lord Regent - you should not be so close to the front lines.',0,0,0,0,0,0,5,0,1,0,0,36383,26124),
(72682,'Rangers - to me! We have broken their lines!','',0,0,0,0,0,0,0,0,1,0,35633,0,26124),
(72683,'Nonsense. This is where I belong.','',0,0,0,0,0,0,0,0,1,0,35634,0,26124),
(72684,'Champion! Again you are at the forefront of a Horde triumph. And once more I am in your debt.','',0,0,0,0,0,0,0,0,1,0,35635,0,26124),
(72685,'Regroup behind the wards, everyone. They will counter-attack... but we will be ready.','',0,0,0,0,0,0,0,0,1,0,35636,0,26124),
(72686,'','This way - the Zandalari are falling back!',0,0,0,0,0,0,5,0,1,0,0,35923,26124),
(72687,'','Through the breech! Focus on their priests - they\'re empowering the others!',0,0,0,0,0,0,5,0,1,0,0,35924,26124),
(72688,'','By the Light - what did they DO to that thing?',0,0,0,0,0,0,5,0,1,0,0,35925,26124),
(72689,'','I\'m hurt - do not back down.',0,0,0,0,0,0,5,0,1,0,0,35926,26124),
(72690,'','Kill that thing!',0,0,0,0,0,0,5,0,1,0,0,35927,26124),
(72691,'','It is nothing. I am fine.',0,0,0,0,0,0,5,0,1,0,0,35928,26124),
(72692,'','Well done! We\'re through - pull together, everyone. Press the advantage!',0,0,0,0,0,0,0,0,1,0,0,35492,26124),
(72693,'','Vereesa, are you hurt?',0,0,0,0,0,0,0,0,1,0,0,35494,26124),
(72694,'','You need to get back to camp. I can\'t lose you.',0,0,0,0,0,0,0,0,1,0,0,35495,26124),
(72695,'','Gather up the wounded! We\'ve struck a mighty blow today - the next part of our campaign begins.',0,0,0,0,0,0,0,0,1,0,0,35496,26124),
(72696,'Step forward! Witness the gift of the Thunder King!','',0,0,0,0,0,0,1,0,7,0,35997,0,26124),
(72697,'I was chosen. My blood burns with his power!','',0,0,0,0,0,0,1,0,7,0,35998,0,26124),
(72698,'Too much... the spirits cannot contain his might...','',0,0,0,0,0,0,1,0,7,0,35999,0,26124),
(72699,'You will be punished! Your life a lesson in futility!','',0,0,0,0,0,0,1,0,7,0,36000,0,26124),
(72700,'For Zandalar!!','',0,0,0,0,0,0,1,0,7,0,36001,0,26124),
(72701,'Bar the gates. The Zandalari have failed to hold the wall.','',0,0,0,0,0,0,1,0,7,0,35768,0,26124),
(72705,'Lei Shen must not be allowed to marshal his full strength.$b$bA direct assault on the front gates will take time, and the aid of your Alliance and Horde. But if there is one thing we Shado-pan know it is that where there is a wall, there is a way around.$b$bThe sewers at the back of this tunnel lead all the way to the fortress entrance. We must hold this entrance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72706,'','I believe Thunderwing here is our opportunity to score a devastating blow against Lei Shen.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72707,'I\'m with you. Let\'s break into that shipyard! [Queue for solo instance.]','I\'m with you. Let\'s break into that shipyard! [Queue for solo instance.]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72708,'Shaol\'mara Beastcaller summons raptors to his aid!','Shaol\'mara Beastcaller summons raptors to his aid!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72709,'Greetings, $p!$b$bWe have a chance to stop the Thunder King himself before he can reclaim his former power.$b$bEven on the Wandering Isle, his hateful name is remembered, and the sound of thunder feared by pandaren children.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72710,'','$p, it is good to see you. It will be an honor to face Lei Shen.$b$bThe lorewalkers of the Wandering Isle told us many stories of the dreaded Thunder King. We must proceed with caution here. If legends are to be believed, he was as clever as he was brutal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72711,'$C! Come to my aid!','$C! Come to my aid!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72712,'','The mogu and Zandalari cower behind the Thunder King\'s walls. Lady Jaina has a plan to blast our way through. Speak to me when you\'re ready!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72713,'Turn away, weaklings. This be the realm of the Thunder King!','',0,0,0,0,0,0,0,0,1,0,35992,0,26124),
(72714,'','Hurry up with the explosives!',0,0,0,0,0,0,0,0,1,0,0,35489,26124),
(72715,'','We must break through - where are my explosives?',0,0,0,0,0,0,0,0,1,0,0,35489,26124),
(72716,'','The wall is wired up and ready to go - the honor is all yours!',0,0,0,0,0,0,1,0,7,0,0,35922,26124),
(72717,'','Well done! We\'re through - pull together, everyone. Press the advantage!',0,0,0,0,0,0,0,0,1,0,0,35489,26124),
(72718,'','This way - the Zandalari are falling back!',0,0,0,0,0,0,1,0,1,0,0,35923,26124),
(72719,'','Through the breech! Focus on their priests - they\'re empowering the others!',0,0,0,0,0,0,1,0,1,0,0,35921,26124),
(72720,'','By the light - what did they DO to that thing?',0,0,0,0,0,0,1,0,1,0,0,35925,26124),
(72721,'','I\'m hurt - don\'t back down.',0,0,0,0,0,0,1,0,1,0,0,35921,26124),
(72722,'','Kill that thing!',0,0,0,0,0,0,1,0,1,0,0,35921,26124),
(72723,'Step forward! Witness the gift of the Thunder King!','',0,0,0,0,0,0,0,0,1,0,35996,0,26124),
(72724,'I was chosen. My blood burns with his power!','',0,0,0,0,0,0,0,0,1,0,35996,0,26124),
(72725,'Too much... the spirits cannot contain his might...','',0,0,0,0,0,0,0,0,1,0,35996,0,26124),
(72726,'You will be punished! Your life a lesson in futility!','',0,0,0,0,0,0,0,0,1,0,35996,0,26124),
(72727,'For Zandalar!!','',0,0,0,0,0,0,0,0,1,0,35996,0,26124),
(72728,'Bar the gates. The Zandalari have failed to hold the wall.','',0,0,0,0,0,0,1,0,7,0,35767,0,26124),
(72729,'','It\'s dead! You\'re an inspiration to the Kirin Tor!',0,0,0,0,0,0,0,0,1,0,0,35493,26124),
(72732,'','It\'s nothing. I\'m fine.',0,0,0,0,0,0,1,0,1,0,0,35921,26124),
(72733,'Hurry - bring me those explosives!','',0,0,0,0,0,0,0,0,1,0,35629,0,26124),
(72734,'Gather up those explosives!','',0,0,0,0,0,0,0,0,1,0,35629,0,26124),
(72735,'','For the Horde!!',0,0,0,0,0,0,1,0,7,0,0,36378,26124),
(72736,'','I\'m hit! Leave me - finish that thing off!',0,0,0,0,0,0,5,0,1,0,0,36382,26124),
(72737,'Rangers - to me! We have broken their lines!','',0,0,0,0,0,0,0,0,1,0,35629,0,26124),
(72738,'Nonsense. This is where I belong.','',0,0,0,0,0,0,0,0,1,0,35629,0,26124),
(72739,'Champion! Again you are at the forefront of a Horde triumph. And once more I am in your debt.','',0,0,0,0,0,0,0,0,1,0,35629,0,26124),
(72740,'Regroup behind the wards, everyone. They will counter-attack... but we will be ready.','',0,0,0,0,0,0,0,0,1,0,35629,0,26124),
(72741,'The Thunder Forge has begun to charge an area nearby.  Run into it to |cFFFF2222|Hspell:139397|h[Overcharge]|h|r yourself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72742,'Removing the tome.','Removing the tome.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72743,'Death to the mogu!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72744,'For Ihgaluk!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72745,'Die in pain, mogu!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72746,'Tear the mogu to pieces!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72747,'I\'ll drag your corpse to the filth pit!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72748,'Megaera\'s rage subsides.','Megaera\'s rage subsides.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72749,'|TInterface\\Icons\\spell_shadow_curseofmannoroth.blp:20|tDurumu infects his enemies with |cFFFF0000|Hspell:133597|h[Dark Parasites]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72750,'The saurok are despicable, but they may end up useful.$b$bIf we can incite them against the mogu, they can draw attention away from our men.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72751,'','The saurok intrigue me.$b$bHow is it that they\'ve survived so long in the shadow of their clearly superior enemy?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72752,'','I\'m here to deal with the disease and plague that stems from the Skumblade saurok.$b$bWhile theirs is a different type of plague than I\'m accustomed to, there are certainly several similarities.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72753,'Use the color cones to reveal and slay the three hidden fog beasts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72754,'Take care not to forget the true price of war.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72755,'May the Light be with you, brave $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72756,'','While our goals call for the eradication of the mogu, we can\'t ignore our flanks.$b$bWhile both the Horde and the saurok attack the mogu alongside us, either could turn on us at any moment.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72758,'','The saurok are despicable, but they may end up useful.$b$bIf we can incite them against the mogu, they can draw attention away from our men.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72759,'The saurok intrigue me.$b$bSo much so, in fact, that some have started calling me \"Skumblade Steve\".','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72760,'I\'m here to clean up the mess that stems from the Skumblade saurok.$b$bWhile theirs is a different type of mess than I\'m accustomed to, there are certainly several similarities.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72761,'','Let us be done with this, so we can all return to our homes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72762,'','Fight well, $r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72763,'','I\'m glad you\'re here! Proudmoore needs all the reinforcements she can get. Are you ready to go?',0,0,0,0,0,0,0,0,1,0,0,35968,26124),
(72764,'','The Pandaren are deeply concerned about the return of this \"Thunder King.\" But I\'m more concerned about the Horde. We can talk during the flight.',0,0,0,0,0,0,0,0,1,0,0,35969,26124),
(72765,'','Over 12,000 years ago, the Mogu empire was founded by Lei Shen, \"The Thunder King.\"',0,0,0,0,0,0,0,0,1,0,0,35970,26124),
(72766,'','He united the mogu, conquered the other pandaren races, and built an empire that would last for thousands of years.',0,0,0,0,0,0,0,0,1,0,0,35971,26124),
(72767,'','Legend has it that the Thunder King possessed enormous power, and built himself a palatial fortress. We should be able to see it soon...',0,0,0,0,0,0,0,0,1,0,0,35972,26124),
(72768,'','There it is! The Isle of the Thunder King. Already, the Horde is circling it like hungry birds of prey.',0,0,0,0,0,0,0,0,1,0,0,35973,26124),
(72769,'','If the Thunder King is not defeated, Pandaria will suffer. But worse: if the Horde lays their hands on the source of his power, the whole WORLD will pay the price.',0,0,0,0,0,0,0,0,1,0,0,35974,26124),
(72770,'','Whoa - look out! We have to land. It is almost impossible to fly here!',0,0,0,0,0,0,0,0,1,0,0,35975,26124),
(72771,'','Lady Jaina Proudmoore would like to see you as soon as possible.',0,0,0,0,0,0,0,0,1,0,0,35976,26124),
(72772,'','This has been the worst year of my life: Theramore, destroyed. And a betrayal from within the Kirin-Tor.',0,0,0,0,0,0,0,0,1,0,0,35519,26124),
(72773,'','The lesson is clear. From here on out, I\'m taking the initiative.',0,0,0,0,0,0,0,0,1,0,0,35520,26124),
(72774,'','Just down the coast, the Horde is searching for a place to land their troops.',0,0,0,0,0,0,0,0,1,0,0,35521,26124),
(72775,'','They seek to defeat the Thunder King, not to protect Pandaria, but to claim his power for themselves.',0,0,0,0,0,0,0,0,1,0,0,35522,26124),
(72776,'','But this time, we\'re a step ahead.',0,0,0,0,0,0,0,0,1,0,0,35523,26124),
(72777,'','The Horde will find no purchase on these shores. And when the Thunder King lies beaten, the Pandaren will see that it was Alliance heroes who stood by them in their hour of need.',0,0,0,0,0,0,0,0,1,0,0,35524,26124),
(72778,'','This fight will take everything we have. I hope you are ready.',0,0,0,0,0,0,0,0,1,0,0,35525,26124),
(72779,'I am ready! [Queue for solo instance.]','I am ready! [Queue for solo instance.]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72780,'','You\'re here! The Regent Lord had asked about you specifically. Are you ready to go?',0,0,0,0,0,0,0,0,1,0,0,35349,26124),
(72781,'','Pandaren legends tell of Lei Shen, \"The Thunder King.\" He was the brutal founder of the Mogu empire over 12,000 years ago.',0,0,0,0,0,0,0,0,1,0,0,35350,26124),
(72782,'','He united the mogu, defeated the other pandaren races, and founded a glorious nation with the slave labor of those he conquered.',0,0,0,0,0,0,0,0,1,0,0,35351,26124),
(72783,'','The Thunder King built a palatial fortress on the borders of his empire. We should see it soon...',0,0,0,0,0,0,0,0,1,0,0,35352,26124),
(72784,'Excellent! Can you feel the power of this crystal? I can almost feel my hair standing on end.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72785,'','There! Just ahead: The Isle of the Thunder King.',0,0,0,0,0,0,0,0,1,0,0,35353,26124),
(72786,'','The Pandaren are terrified that the former Emperor will try to reclaim his empire, and enslave them once again.',0,0,0,0,0,0,0,0,1,0,0,35354,26124),
(72787,'','But we have our own reasons for assisting them. I will allow Lor\'themar to explain.',0,0,0,0,0,0,0,0,1,0,0,35355,26124),
(72788,'','Whoa! Careful - it is nearly impossible to fly anywhere near the island!',0,0,0,0,0,0,0,0,1,0,0,35356,26124),
(72789,'','Be sure to speak with the Lord Regent. He\'s waiting for you at the prow.',0,0,0,0,0,0,0,0,1,0,0,35357,26124),
(72790,'Aethas, leave us for a moment.','',0,0,0,0,0,0,0,0,1,0,35651,0,26124),
(72791,'Hero, you have served the Horde nobly across many campaigns. I feel I can take you into confidence.','',0,0,0,0,0,0,0,0,1,0,35652,0,26124),
(72792,'Our Warchief\'s campaign across Kalimdor and Pandaria is pulling the Horde apart at the seams.','',0,0,0,0,0,0,0,0,1,0,35653,0,26124),
(72793,'We are here to fight the Thunder King. Justice demands it, and Hellscream is too preoccupied at Domination Point to pay attention here.','',0,0,0,0,0,0,0,0,1,0,35654,0,26124),
(72794,'But, in defeating him, we must seek out the source of his great power. We must claim it for ourselves, as leverage against our \"Warchief.\"','',0,0,0,0,0,0,0,0,1,0,35655,0,26124),
(72795,'In the event of an uprising, we must be prepared.','',0,0,0,0,0,0,0,0,1,0,35656,0,26124),
(72796,'Heads up!','',0,0,0,0,0,0,0,0,1,0,35657,0,26124),
(72797,'Ha-hah! It will feel good to bloody my blade again. Against Alliance or mogu, does not matter to me.','',0,0,0,0,0,0,0,0,1,0,35658,0,26124),
(72798,'Enough talk. You know how precarious our position is. Between the Alliance and the Thunder King, only with the help of heroes like you can we hope to succeed here.','',0,0,0,0,0,0,0,0,1,0,35659,0,26124),
(72799,'Anar\'alah belore, hero. Good luck.','',0,0,0,0,0,0,0,0,1,0,35660,0,26124),
(72800,'The forge is safe, and we must take our leave.  Good luck on your quest, adventurer.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(72801,'Make your way through the maze of Eye Sores while avoiding Durumu\'s Disintegration Beam.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72802,'Step out of the illuminated area before Force of Will finishes casting to avoid being knocked down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72803,'Clearly the Kirin Tor has no clue about the power of this island. They are just here to stop us out of spite. Those ignorant amateur mages must be taught a lesson.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72804,'Mmm. This is a good crystal. You have done well, $p.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72805,'Kill the Hatchlings before they get a chance to eat and mature.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72806,'Slain Hatchlings will drop feathers, use the feather to fly for short periods of time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72807,'A powerful gem.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72808,'Well done, $p. The crystals of this island are better in our hands than the Kirin Tor\'s.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72809,'Fly up to the nests above to stop Juveniles from hatching.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72810,'|TInterface\\Icons\\ability_druid_galewinds.blp:20|tJi-Kun uses her wings to create a massive |cFFFF0000|Hspell:134370|h[Down Draft]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72811,'|TInterface\\Icons\\ability_hunter_pet_dragonhawk.blp:20|tJi-Kun sends her |cFFFF0000|Hspell:134380|h[Quills]|h|r flying in all directions!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72812,'|TInterface\\Icons\\ability_hunter_animalhandler.blp:20|tJi-Kun |cFFFF0000|Hspell:138923|h[Caws]|h|r, sending powerful sound waves at her enemies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72813,'Ji-Kun goes into a berserk rage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72814,'|TInterface\\Icons\\spell_nature_removecurse.blp:20|tThe Dark Parasites morph into a |cFFFF0000|Hspell:133598|h[Dark Plague]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72815,'The Gastropod starts chasing |cFFFF0000$n|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72816,'A Corpse Spider stirs from its sleep in the webs above!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72817,'The nearby activity of living flesh drives some Bore Worms to action!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72818,'Upon dying, the Hidden Fog\'s Burst of Light reveals all Pale Fogs in the area.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72819,'The Eye Sentry pulls nearby enemies into its field of misery, defeat it to get free!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72820,'|TInterface\\Icons\\ability_creature_disease_02.blp:20|tThe Eye Servant picks up |cFFFF0000$n|r and |cFFFF0000|Hspell:134668|h[Gnaws]|h|r on them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72821,'$n makes the catch!','$n makes the catch!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(72822,'All this electricity in the air is wreaking havoc on my hair.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72823,'Ah, good, a $c. We could use more of your kind for some of these tasks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72824,'Activation Sequence: Matrixing protocols','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72825,'Activation Sequence: Rerouting auxiliary power','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72826,'Activation Sequence: Deciphering command parse','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72827,'Activation Sequence: Starting micro suppressors','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72828,'Activation Sequence: Repressing urge to activate early','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72829,'Activation Sequence: COMPLETE','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72830,'Activation Sequence: Successfully dividing by zero','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72831,'Activation Sequence: Setting doom level to 15,000 milli-dooms','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72832,'','There is no time to waste. The Alliance move on the Isle of Thunder as we speak!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72833,'Activation Sequence: Plotting your demise','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72834,'','There is no time to waste. The Horde move on the Isle of Thunder as we speak!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72835,'Who wishes to test my spears?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72836,'My hammer always strikes true! Let the fires rage once again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72838,'Sparkmaster Vu stares at you mutely. With a powerful swing of his halberd, he attacks!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72839,'Activation Sequence: INITIATED','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72840,'Just think of all the knowledge I could share. Think of all the food we could grow!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(72841,'Nana Mudclaw asked ME to join the Tillers council?','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(72842,'But... I don\'t think I\'ll have time to work for the council, AND run Sunsong Ranch.','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(72843,'This farm has been in my family for generations. How can I give it up? Yet, a greater responsibility has fallen upon me.','',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(72844,'$n, I\'m gifting Sunsong Ranch to you. You\'re in charge, now!','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(72846,'I\'d better head up and talk to Nana. The farm is yours now, $n. I know you\'ll take great care of it.','',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(72847,'I never knew that helping the Tillers Union would be so much work.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72848,'How is Sunsong Ranch doing, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72849,'I\'ve got my hands full around here, but The Heartland is prospering.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72850,'Ever since the Vale opened up its gates, we\'ve been sending shipment after shipment of vegetables north.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72851,'Your friends down in the Krasarang Wilds have quite the appetites. There\'s an endless demand for fresh produce.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72852,'I hear that the Shado-Pan are preparing to assault the Isle of Thunder to the northwest. They will need plenty of food, and we\'re the ones to supply it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72853,'I am working with Seedkeeper Shing Sing to develop more efficient methods of farming, harvesting, and storage. Delicious, fresh, high-quality produce is what the Tillers aim to deliver!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72854,'Farmer Yoon, will you join the council of the Tillers Union?','Farmer Yoon, will you join the council of the Tillers Union?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72855,'I\'m here for the order of red blossom leeks.','I\'m here for the order of red blossom leeks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72856,'Domination Point thanks you!','Domination Point thanks you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72857,'Do you have the witchberries?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72858,'Oh, here they are! Lion\'s Landing thanks you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72860,'We\'re in desperate need of those turnips!','We\'re in desperate need of those turnips!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72861,'Thank you so much! The Golden Lotus is in your debt.','Thank you so much! The Golden Lotus is in your debt.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72862,'We could use some more of those beautiful striped melons!','We could use some more of those beautiful striped melons!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72863,'I just love the sound they make when they explode!','I just love the sound they make when they explode!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72864,'Is our order of green cabbages ready to go?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72865,'Mmmmm! I just love green cabbage soup!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72866,'Do you have the required pumpkins?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72867,'I\'m ready for my mission.','I\'m ready for my mission.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72868,'Well, these will have to do. The Klaxxi\'va send their thanks, though I don\'t know why.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72869,'The essence of Chi-Ji dissipates, leaving a scattered trail of stardust.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72870,'The essence of Yu\'lon smiles warmly at you as it fades into the sky.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72871,'The essence of Niuzao rumbles in acceptance of your aid.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72872,'Dust falls from the guardian as it begins to crack.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72873,'The guardian begins to move with a rumble.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72874,'The stone begins to fall away from the guardian. The ritual is almost complete!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72875,'Guardian Tak\'u has awakened!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72876,'The essence of Xuen roars triumphantly and disperses into celestial dust.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72877,'','The mogu and Zandalari are in the process of moving another shipment of treasures from Lei Shen\'s tomb to his throne room.  We will strike quickly and take as much as we can before his forces arrive.  You will only have a limited time before we pull you out, so be efficient $n.\n\nWe\'re only getting one shot at this, so make it count.\n\nWhen you\'re ready to begin, hand me the key and I\'ll open the door.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72878,'Here\'s the key.  Let\'s go.','Here\'s the key.  Let\'s go.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72879,'Make every second count.\n\nWhen you\'re ready to go, let me know and I\'ll get you out of here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72880,'I\'m ready to leave.  Let\'s get out of here.','I\'m ready to leave.  Let\'s get out of here.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72881,'','Make it out of there with anything good?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72882,'I\'ll be happy to help you empty that pack of yours.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72883,'','It is discouraging that Lei Shen has found so many allies to flock to his throne so soon after his return. We should have done a better job to eliminate them during his absence.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72884,'','Enemies litter this isle, both old and new. We will not gain a foot of ground here without spilling blood for it.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72885,'','My ship took a beating to make landing on these shores. I will see to it that they pay for every single nick on her hull.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72886,'There is great arcane power on this island. I cannot yet tell if it lies in the hands of the Thunder King, or in the hands of our old Sunreaver allies.$B$BWe will find out in time.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72887,'Wanna get in on a little secret? It\'s about where to fish today...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72888,'Are you lookin\' to hear a secret about where to fish?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72889,'After a high tide in the Gokk\'lokk Shallows in Dread Wastes, sometimes the increased fish activity loosens the kelp along the shore. $b $b Shrimp, octopus, and all manner\'o\'things get tangled up in there. I bet you could get you a small fortune o\' Mantis Shrimp if you fished out there a while.$b $b  Let me know if you need help finding it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72890,'Sure thing, friend. I\'ll mark where you can find Mantis Shrimp map. Take a look at the Northwest corner of Dread Wastes, it\'s a place called Gokk\'lok Shallows.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72891,'The Anglers over at Sri-La village are reporting an unusually high number of Reef Octopi at their village. I\'d wager that it\'s spawning season, but who knows? $b $b The problem is, that the increased octopus influx is damaging the shellfish population... and everyone knows the real money is in shellfish. $b $b Dangle your bobber there for a minute or two, I bet you\'d walk away with swarms of those octopi.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72892,'I\'m thinkin\' the Reef Octopi are hereabouts this area in Sri-La village of Jade Forest. $b$b<Ben stuffs a pin along the Northeast shore of Jade Forest on your map.>$b$b','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72893,'During a full moon, the sprite darters in The Woods of The Lost in Jade forest are known to shed their scales. They do it late at night and it\'s actually beautiful to see. $b $b Their scales glow with a bright jade light and fleck off into the water. This attracts Jade Lungfish like you wouldn\'t believe! Like moths to the light! $b $b Careful not to disturb those mogu, though... they ain\'t exactly the friendly type.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72894,'Yeah, sure. The Jade Lungfish are found about here, in the Enchanted Woods of the Lost in Jade Forest on your map. It\'s not the biggest pool in Pandaria, but it\'s majestic all its own.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72895,'So today as I was gathering supplies, I found a wandering sherpa who sold exotic potions and oils. One of the more strange oils he had was known as a \"love potion\" for fish.  $b $b Nevermind how he created it, just know that the stuff REALLY works! It DOUBLED the Redbelly Mandarin population in his pond! $b $b I found him at the lake north of Niuzao Temple. You\'d probably do some good if you helped even out the population there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72896,'<Ben scratches his head.>$b$b I\'m not the greatest with directions, but I reckon the Redbelly Mandarin are about\'s here, in the Fields of Niuzao in Townlong Steppes. $b$b<Ben circles a general area on your map.>$b$b','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72897,'Here in Valley of the Four Winds, we have our famous Stormstout Brewery. You may have noticed that a rather destructive bunch of Hozu have decided to make that place their own. Their drunken debauchery is known to get a little out of hand. $b $b Sometimes, after a new batch of brew is made, they are known to have beer fights. That\'s right, gallons upon gallons of brew are wasted and wash away into the Yan-Zhe river. $b $b The beer attracts Emperor Salmon, and they swarm like nothin\' I\'ve ever seen. They\'re a bit easier to catch, too... seein\' as they\'ve had a few.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72898,'The best place to go for Emperor Salmon would probably be right outside the brewery here in the Valley of Four Winds. I\'ll mark it on your map.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72899,'Do I look angry? Well it\'s because I AM! $b $b My arch nemesis, Wizak Blastbait, is encroaching pretty close onto my turf. He\'s a nasty little goblin, who uses... non-conventional means of fishing.  $b $b Last I saw him, he was at Krasari Falls. You should fish there today if you want Krasarang Paddlefish, I bet he\'s scaring them up left and right. Maybe if he sees other people fishing there, he\'ll deem the area overcrowded and leave. $b $b Oh, and if you can,  make a rude gesture at him. Tell\'m old Ben sent\'ya.$b$b<Ben smirks to himself.>$b$b','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72900,'You\'ll find the Krasarang Paddlefish AND that no-good goblin in the biggest pool of the Krasari River. Right in the heart of Krasarang Wilds. Right here. $b$b<Ben pokes a hole in your map with his claw.>$b$b','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72901,'The Jin\'yu of Binan Village in Kun-Lai Summit spoke to the water today, and it is TEEMING with Sha. $b $b You may already know this, but the Spinefish is a rather aggressive fish. Now, you mix that with a little bit\'o that Sha mojo, and you\'ve got a proper frenzy in the make!  $b $b If you can catch those angry beasties, you may help restore balance to their fragile ecosystem... not to mention gettin\' yourself a dream catch of Spinefish.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72902,'The Spinefish are right here on your map. Off the shores of Bin\'an Village in Kun-Lai Summit. Anywhere the sky is dark and heavy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72903,'Last night, Master Snowdrift was giving some lessons at the Shado-Pan monastery in Kun-Lai Summit. He was teaching his students how to cast fists of frost. $b $b The good news is, the students did great. The bad news is, hundreds of icy fist balls were cast into the water. This froze the Tiger Gourami living in the surrounding lake!$b $b If you\'re looking to catch some Tiger Gourami today, that\'s probably your best bet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72904,'The Tiger Gourami will be found near the pagoda of Shado-pan Monastery... here, in Kun-Lai Summit. $b$b<Ben marks a spot on your map.>$b$b','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72905,'Mad Qao-Pao doesn\'t mean any harm. Truly, he doesn\'t. He heard that the pond in front of the Mogu\'shan Palace granted wishes, you see... like a wishing well. $b $b And... well... the poor guy has more gold than wit. Last I heard, he\'s been dumping gold into the water... hoping to become king of the world! $b $b Sadly, Jewel Danio\'s favorite treats are fireflies that fly low on the water. The glimmer of the coins lures them out in droves. $b $b Hopefully the poor things aren\'t swallowing too many coins. Today\'s the day to get Jewel Danio if you want, though. You may even find a couple of coins yourself.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72906,'Mad Qao Pao and his Jewel Danio were last found  in the Summer Fields in Vale of Eternal Blossoms. Probably around this area. $b$b<Ben marks a spot on your map.>$b$b','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72907,'Sure, I\'d love to hear a secret.','Sure, I\'d love to hear a secret.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72908,'Even better, can you just show me on my map?','Even better, can you just show me on my map?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72909,'These fish jump up and down like a bouncing luckydo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72910,'I don\'t even know how to fish! Can you teach me?','I don\'t even know how to fish! Can you teach me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72911,'Do you happen to have any fishing supplies?','Do you happen to have any fishing supplies?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72912,'The smell of good fortune is upon this lake...  or is that just Fishbreath?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72913,'It is very sad that fish have no trails or mountains to climb.  If I bring them more fish friends will they be happy?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72914,'Lightning is better than thunder right?  Well, then I wish to be crowned the Lightning King of Pandaria!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72915,'I wish for a million gold, wait a second  I already have a million gold...  I wish for a million million gold!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72916,'Ooh I know!  I wish for all the beer in Stormstout Brewery!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72917,'I want a panther encrusted in the world\'s finest jewels!  Wait, doesn\'t one of my friends already have one of those?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72918,'No no no, that\'s not what I want.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72919,'Hmm, well on second thought...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72920,'Oh wait, I have a better one!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72921,'Haha!  Take that you unsuspecting water dwellers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72922,'I was never that good with a fishing pole...  No matter!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72923,'Taste hot TNT you fishy fiends!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72924,'Bow before your terrestrial overlord as fire rains down upon you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72925,'You can tell that booming voice that he\'s nothing but hot air!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72926,'Now I\'m really angry!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72927,'That\'s the rudest thing anyone\'s ever done to me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72928,'First the fish!...  Now you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72929,'Nibbin\' these slickies gonna grook you in the jerb.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72930,'So many slickies...  Hozen grookin\' love slickies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72931,'Ookin\' slicky just ooked me in the nib tickler!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72932,'Slickies love wikket slerp...  Hozen grookin\' love wikket slerp!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72933,'This unfortunate Zandalari has been gored and trampled. The expression on his face is not one of fear, but one of steely determination, even in death.$b$bHis open eyes appear to burn with intense passion, even as they stare unblinking into the sky. A fly crawls along their still-moist surface.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72934,'The king wanted Prince Anduin to stay in the vale until he recovered. But the prince insists on wandering around talking to people. What are we to do when a prince wants to disobey his king?$b$bBest to stay close and keep him out of trouble.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72935,'<The bodyguard glowers at you, his fist tightly clenching his sword.>$b$bThe prince wants to have a quiet chat, $c. If you start any trouble, we\'ll respond in kind.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72936,'<The tauren paladin looks you up and down, as if sizing up your intentions.>$b$bI mean you no hostility, $c. The human prince and I met at the Temple of the White Tiger, and he often seeks me out to talk about my Chieftain, Baine, and to discuss matters of war and peace.$b$b<The paladin and the Prince\'s bodyguards periodically exchange distrustful glances at one another.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72937,'Greetings, $c!$b$bChieftain Baine Bloodhoof was distressed to learn of Garrosh\'s savage attack on the human prince. Our causes for grievance against the Alliance are many, but none are the responsibility of this little one.$b$bThe prince and I met at the Temple of the White Tiger. On my honor I have pledged that I will do what I can to keep him safe.$b$b<Despite his words and the warmth the prince directs his way, the tauren paladin suffers distrustful glances from the royal bodyguards in the corner of the room.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72938,'No - stop. Stop this at once!','',0,0,0,0,0,0,5,0,5,0,0,0,26124),
(72939,'Stay your hand! Not here - not now!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72940,'Wrathion claims to be the last living black dragon. Do you think that\'s true?$b$bHe\'s got the most curious outlook on the world. I can\'t decide if he thinks human life is precious or expendable! I do enjoy talking with him, however.','',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(72941,'<Anduin\'s bodyguards edge closer the moment you address the prince.>$b$bIt\'s okay. I\'d just like to have a chat with my friend. We\'re far from any battlefronts here. Can some part of the world still be safe for civilized conversation?$b$bCome, sit down! Join us!','',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(72942,'Oh, this? <Anduin indicates his crutch.>$b$bGarrosh Hellscream tried to use an ancient mogu artifact to summon and control sha energy. I found a way to stop him, but probably shouldn\'t have confronted him on my own. He thought I was dead when he left me buried under the wreckage of his failed plan. I swear he shattered every bone in my body.$b$bThe pandaren mistweavers got me back on my feet again, but it may be some time before I can walk without assistance.','',1,274,0,0,0,0,1,0,1,0,0,0,26124),
(72943,'You know of our history with the black dragonflight, do you? I won\'t soon forget what Lady Prestor - Onyxia - did to my family. Maybe that\'s why I sought Wrathion out.$b$b<Anduin peers across the table at his unusual companion.>$b$bBut... he\'s not like the other black dragons, is he? He\'s completely honest and yet always hiding something. Not at all what I expected.','',1,6,0,0,0,0,1,0,1,0,0,0,26124),
(72944,'Wrathion claims to be the last living black dragon. Do you think that\'s true? Weren\'t there others still in Outland somewhere?$b$bRegardless, I find him fascinating. He\'s not like any other dragon I\'ve ever met. He is honest, almost painfully so. I can\'t decide if he thinks mortal lives are absolutely precious or completely expendable.','',1,6,0,0,0,0,1,0,1,0,0,0,26124),
(72945,'What happened to your leg? Are you wounded?','What happened to your leg? Are you wounded?',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(72946,'How can you trust a black dragon, after what they put your family through?','How can you trust a black dragon, after what they put your family through?',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(72947,'What do you make of Wrathion?','What do you make of Wrathion?',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(72948,'Once you have earned the respect of his majesty, the Black Prince, then you will have earned mine. Complete more of his tasks.$b$bUntil then, begone. I have nothing to sell to you.','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(72949,'Welcome. I can replace any any rewards you may have gotten from the Black Prince... for a price.','',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(72950,'How can I replace items you have awarded me in the past?','How can I replace items you have awarded me in the past?',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(72951,'Look for my Blacktalon Quartermaster here in the tavern. He can resupply you with any rewards I have given you previously... for a price of course. As you no doubt have noticed, the materials I work with are not at all cheap.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72952,'You made it! Excellent. Now we can begin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72953,'I am ready!','I am ready!',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(72954,'%s sweeps the area with its |cFFFF0000|Hspell:136898|h[Flamethrower]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72955,'%s is unable to find a target to melee, so resorts to its |cFFFF0000|Hspell:136854|h[Death Stare]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72956,'%s prepares to pound nearby targets with |cFFFF0000|Hspell:137074|h[Ground Slam]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72957,'%s winds up a massive |cFFFF0000|Hspell:136847|h[Shockwave]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72958,'%s uses |cFFFF0000|Hspell:138019|h[Lightning Prod]|h|r! Get away from the Saurok!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72959,'Kor\'dok resurrects a fallen ally to aid him in battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72960,'The discharged electricity has manifested itself as an elemental!','The discharged electricity has manifested itself as an elemental!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72961,'|cFFFF2222[Electrified]|r  You can discharge the electricity at a nearby Lightning Rod.','|cFFFF2222[Electrified]|r  You can discharge the electricity at a nearby Lightning Rod.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72962,'Where the Warchief commands, my blade shall follow.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72963,'There\'s only one solution. I have to join the council. As for the farm...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(72964,'We stirred up a great deal of trouble, $n. But it was worth it.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72965,'|TInterface\\Icons\\spell_frost_piercing chill:20|tYou are being targeted by |cFFF00000|Hspell:139866|h[Torrent of Ice]|h|r!','|TInterface\\Icons\\spell_frost_piercing chill:20|tYou are being targeted by |cFFF00000|Hspell:139866|h[Torrent of Ice]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72966,'|TInterface\\Icons\\inv_misc_volatilefire:20|tYou are afflicted with |cFFF00000|Hspell:139822|h[Cinders]|h|r!','|TInterface\\Icons\\inv_misc_volatilefire:20|tYou are afflicted with |cFFF00000|Hspell:139822|h[Cinders]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72967,'Transmogrification and Void Storage','Transmogrification and Void Storage',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72968,'I have the key, let\'s start the raid. [Queue for solo instance.]','I have the key, let\'s start the raid. [Queue for solo instance.]',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72969,'','I\'m helping!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72970,'','Paw-paw says I\'m not s\'posed to talk to strangers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72971,'','I can count alllll the way to \"nine-ten.\" Listen!$B$B<Milly counts on her fingers and toes.>$B$BOne, two, three, five, six, umm... seven, eight, nine-ten!$B$BWait, I missed one...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72972,'','Don\'t put seeds in your nose. That makes paw-paw real mad!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72973,'','I like turtles.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72974,'','Counting is fun!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72975,'Milly, I need you to bag some seeds for me.','Milly, I need you to bag some seeds for me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72976,'We are ready to launch the raid at a moment\'s notice. All we need is the key. Have you found one?','We are ready to launch the raid at a moment\'s notice. All we need is the key. Have you found one?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72977,'|TInterface\\Icons\\spell_nature_callstorm:20|t%s afflicts his enemies with |cFFFF0000|Hspell:138732|h[Ionization]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72978,'Persistence in training shall always achieve results.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72979,'Let\'s head outside to the island.','Let\'s head outside to the island.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(72980,'Are you ready to try again?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72981,'Yes, let\'s charge that Trillium!','Yes, let\'s charge that Trillium!',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(72982,'','Good job making it out in time.  We recovered a key that should work on one of these troves.  It\'s all yours.',1,0,0,0,0,0,396,0,1,21089,0,0,26124),
(72983,'','We barely pulled you out of there.  You\'re lucky to be alive.',1,0,0,0,0,0,396,0,1,21090,0,0,26124),
(72984,'I\'m ready to go.','I\'m ready to go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72985,'I\'m ready to go.','I\'m ready to go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72986,'Bring on the sha!','Bring on the sha!',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(72987,'I just need a quart, I promise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72988,'You\'re O negative, right?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72989,'Ah yes, I can smell it from here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72990,'You are abandoning your mission! You must return before you are teleported to the nearest graveyard.','You are abandoning your mission! You must return before you are teleported to the nearest graveyard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72991,'|TInterface\\Icons\\achievement_zone_cataclysm.blp:20|t%s begins channeling a massive |cFFFF0000|Hspell:138564|h[Cataclysm]|h|r!','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72992,'|TInterface\\Icons\\ability_warlock_chaosbolt.blp:20|t%s begins casting a massive |cFFFF0000|Hspell:138559|h[Chaos Bolt]|h|r!','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(72993,'','The Thunder King\'s palace lies ahead. We must secure a foothold on the island before we can assault his fortress.',0,0,0,0,0,0,0,0,1,0,0,35978,26124),
(72994,'','Ugh! Hold on!',0,0,0,0,0,0,0,0,1,0,0,35977,26124),
(72995,'Forgemaster Vul\'kon equips his Staff and begins to channel the powers of lightning!','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(72996,'Forgemaster Vul\'kon equips his Hammer and begins to swing with great force!','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(72997,'The Sha Amalgamation is casting |cFFFF2222|Hspell:139375|h[Shadow Burst]|h|r! Run Away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72998,'The Sha Amalgamation is vulnerable!  Throw the |cFFFF2222[Lightning Lance]|r at it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(72999,'The Sha Amalgamation casts |cFFFF2222|Hspell:139443|h[Meteor Storm]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73000,'The Sha Amalgamation banishes the Celestial Defender.  Defend yourself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73001,'The Celestial Defender is critically injured and is no longer able to fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73002,'You are out of time.','You are out of time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73003,'A |cFFFF2222[Thundering Anvil]|r has become overcharged! Click it to cause a |cFFFF2222|Hspell:138834|h[Thunder Surge]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73004,'Dis ship is unda new management! Anybody not pullin\' dey weight is gonna have dey spirit re-assigned to a golem.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73005,'Unda my command, dis ship gonna be feared by all! Isn\'t dat right, Ripi?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73006,'These Zandalari are not to be underestimated. They are quite unlike any troll I have yet encountered.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73007,'My rangers have sent back disturbing reports from Za\'Tual. I believe it is time to take this fight to their doorstep.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73008,'The bones side with the spirits!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73009,'The bones side with death!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73010,'The bones side with me!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73011,'The bones side with you, mon!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73012,'Rollin the bones...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(73013,'Zur\'chaka Rolls the Bones!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73014,'Here are the explosives, Vereesa.','Here are the explosives, Vereesa.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73015,'The Shado-pan Defender has placed a |cFFFF2222|Hspell:132744|h[Healing Orb]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73016,'Are you ready for me to start up the Thunder Forge?  Things could get a bit hairy.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(73017,'Start it up!','Start it up!',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(73018,'Death to the Alliance!','Death to the Alliance!',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(73019,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(73020,'You won\'t escape alive, $r!','You won\'t escape alive, $r!',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(73021,'I\'m going to enjoy this...','I\'m going to enjoy this...',0,0,0,0,0,0,0,0,1,924,0,0,26124),
(73022,'You don\'t belong here!','For the Alliance!',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(73023,'I thought I smelled something!','Death to the Horde!',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(73024,'This is for Theramore!','You\'ll burn for your crimes!',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(73025,'Die Horde scum!','You will pay for your crimes!',0,0,0,0,0,0,0,0,1,923,0,0,26124),
(73026,'A |cFFFF2222[Thundering Anvil]|r has become overcharged! Activate it to |cFFFF2222|Hspell:138834|h[Discharge]|h|r its energy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73027,'The |cFFFF2222[Lightning Lance]|r is charged.  Use it to finish off the Sha Amalgamation!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73028,'|TInterface\\Icons\\spell_arcane_mindmastery.blp:20|t %s wakes up with a terrible |cFFFF0000|Hspell:140432|h[Hangover]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73029,'Dat came from da ship! Let\'s go!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73032,'A storm is brewing near the Lightning Pillar.  Beware!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73033,'Move away from the shackles to break the chains!','Move away from the shackles to break the chains!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73034,'|TInterface\\Icons\\ability_thunderking_thunderstruck.blp:20|tLei Shen has become angered and calls down a |cFFFF0000|Hspell:140549|h[Lightning Storm]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73035,'|TInterface\\Icons\\spell_shadow_destructivesoul.blp:20|t%s casts |cFFFF0000|Hspell:140543|h[Empower Axe]|h|r! Run Away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73036,'|TInterface\\Icons\\warrior_talent_icon_bloodandthunder.blp:20|t%s begins to cast |cFFFF0000|Hspell:140531|h[Desist]|h|r! Kill the  |cFFFF0000Chains|r to free yourself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73037,'Set','Set',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73038,'Make Sunsong Ranch your home.','Make Sunsong Ranch your home.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73039,'<A hefty tome with a well-worn cover and bits of earth stuck in the bindings. It looks like Yoon has been carrying on tradition and recording the history of Sunsong Ranch in this journal. It lies open to his last entry: a note addressed to you!>$B$B\"Thank you for restoring my family\'s land to its former glory. I am on to bigger things; It is your turn to fill in these pages now.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73040,'Cavern Burrower begins to call nearby Shale Stalkers to aid it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73041,'Cavern Burrower alerted nearby Shale Stalkers to your presence with |cFFF00000|Hspell:140600|h[Sonic Call]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73044,'The %s begins to cast Hymn of Silence! Hide inside a barrier!','The %s begins to cast Hymn of Silence! Hide inside a barrier!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73045,'Stop casting! %s is generating an |cFFFF0000|Hspell:139869|h[Interrupting Jolt]|h|r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73046,'Stop casting! %s is generating an |cFFFF0000|Hspell:139867|h[Interrupting Jolt]|h|r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73062,'The |cFFFF0000Horde|r has lost control of the Pandaren Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73063,'The Alliance has taken control of the Pandaren Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73064,'The |cFFFF0000Horde|r has taken control of the Pandaren Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73065,'The Alliance has lost control of the Pandaren Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73066,'The Alliance has taken control of the Goblin Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73067,'The |cFFFF0000Horde|r has taken control of the Goblin Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73068,'The |cFFFF0000Horde|r has lost control of the Goblin Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73069,'The Alliance has lost control of the Goblin Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73071,'I lend you the cold vengeance of the northern winds!','',0,0,0,0,0,0,0,0,1,0,29024,0,26124),
(73075,'','He represents everything that is just, and righteous, and a bunch of other boring crap too. It\'s the draenei paladin, Ahoo\'ru!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73076,'','Get out your shovels, everyone! Mingus Diggs is about to teach us a lesson in archaeology!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73077,'','Well, well, well... look who came waddling back. It\'s the bruised-beaked bouncing bird, Dippy! And this time, he\'s not alone!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73078,'He represents everything that is just, and righteous, and several other virtues which are of no interest to most of you. It\'s the draenei paladin, Ahoo\'ru!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73079,'Get out your shovels, everyone! Mingus Diggs is about to teach us a lesson in archaeology!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73080,'It seems we have a returning challenger! Welcome back to the arena, Dippy!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73081,'Newt, get that door open.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73082,'Recruit $p, you\'re with me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73083,'We\'ve tracked the recent disappearances in Durotar to this abandoned section of Ragefire.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73084,'','Yes, sir!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73085,'Good day, sir!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73086,'It\'s our job to find out who\'s behind these abductions and put a stop to them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73087,'Grit, Ticker and Volt, you three back her up.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73088,'Stay close.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73089,'Newt, we need this door open now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73090,'','I\'m setting the last charge now, sir!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73091,'','The charges are all set; hit the detonator as soon as you\'re ready!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73092,'Move! Move! Move!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73093,'EXTREME HOZEN-FU!','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(73094,'The Horde have dropped the Alliance gold cart!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73095,'The Horde have stolen gold from the Alliance!','',0,0,0,0,0,0,0,0,1,0,8213,0,26124),
(73096,'Gonna set wikkets up the boom boom! AGAIN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73097,'Now with more BOOM in every BOOM BOOM!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73098,'Kaboom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73099,'Gonna boom wikkets up the boom boom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73100,'What the...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73101,'Use the cones of light to find and defeat the hidden Crimson Fogs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73102,'Use the cones of light to find and defeat the one fog beast of each color!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73103,'Two fog beasts remain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73104,'One fog beast remains.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73105,'You are the target of the Infrared Light! Move around the arena with your teammates to find and defeat a Crimson Fog.','You are the target of the Infrared Light! Move around the arena with your teammates to find and defeat a Crimson Fog.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73106,'You are the target of the Blue Rays! Move around the arena with your teammates to find and defeat an Azure Fog.','You are the target of the Blue Rays! Move around the arena with your teammates to find and defeat an Azure Fog.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73107,'Intruders! Stop them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73108,'Weaklings!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73109,'There aren\'t any more challengers who want to fight you, $n. You\'re just too damned good.\n\nYou still want a fight? Go pick up a challenge card and talk to me again.','There aren\'t any more challengers who want to fight you, $n. You\'re just too damned good.\n\nYou still want a fight? Go pick up a challenge card and talk to me again.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(73110,'Luckydo floot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73111,'','Also entering the arena: the magnanimous Master Boom Boom, the dynamite throwing monkey monk!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73112,'Also entering the arena: the hozen with the box of bombs! It\'s Master Boom Boom, the dynamite throwing monkey monk!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73113,'Many bad fortunes to you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73114,'You must have good luckydo.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73115,'Stupid grummlepack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73118,'We found somethin\' down there, somethin\' HUGE, and all of a sudden the rocks started fightin\' back and everyone went crazy. Bad business!','',1,0,0,0,0,0,0,0,0,0,37165,0,26124),
(73119,'Please, just make it all stop!','',20,0,0,0,0,0,20,0,0,0,37166,0,26124),
(73120,'','Whatcha lookin\' at kid?  There\'s work to be done!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73121,'Hostile target acquired.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73122,'Vertical stabilizers offline. Powering down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73123,'Target nonfunctional. Ending combat actions.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73124,'','Ye ain\'t cookin\' ME, ye long-eared snow-huffer!',0,0,0,0,0,0,0,0,1,0,0,37289,26124),
(73125,'','Take THIS, ye blue-skinned hag!',0,0,0,0,0,0,0,0,1,0,0,37290,26124),
(73126,'','Tryin\' ta roast ME, ye snaggle-toothed bone-biter?! I\'ll show ye!',0,0,0,0,0,0,0,0,1,0,0,37291,26124),
(73127,'Egg sensor offline. Shutting down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73128,'Armor unit malfunction. System offloading.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73129,'Beak device overloaded. Unit deactivating.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73130,'Ye\'ve got my attention.  OK, now ye\'ve lost it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73131,'Punchin\' faces bought this suit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73132,'Aye, my brawlin\' days are over.  Nowadays, I fill my time with fancy ale and not-so-fancy lasses.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73133,'','The view really is much better from up here.  Not to mention the distinct lack of blood-spatter.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73134,'','I always cheer for the robots.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73135,'','Did you say something?  I\'m sorry, I tend to not pay attention to conversation when things are being killed for my amusement.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73136,'No, no, I\'m not brawling. I\'m mainly here to cheer for Bruce.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73137,'Ahh yes, I remember the first time I fought against the Dark Summoner.  And the second time... and the third...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73138,'A piece of advice?  Never underestimate your foe, no matter how short, waddly, and heart-meltingly cute they might be.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73139,'','What? Can\'t a death knight get a little dressed up every once in a while?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73140,'','I can\'t BELIEVE she wore the same dress as me.  How embarrassing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73141,'','Stare at me like that one more time and I will push you off the side of the boat.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73142,'Googa not actually supposed to be here.  Googa just not sure how to get down.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73143,'Googa fight one time, but then get a little bit eaten by crocolisk.$b$bEverybody root against Googa.$b$bGooga feel sad because of this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73144,'You know Riko?  He good party.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73145,'','$gHey there, handsome.  You want to go somewhere after this?  Just you and me?:Back off, skank.  I\'m trying to put out a vibe here, and you\'re ruining it.;',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73146,'','I\'m done with the brawling ring.  These days, I am looking for a different kind of ring.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73147,'','$gHey there, stranger. I\'d brawl with you any day of the week.  And I promise you, it\'ll last longer than 2 minutes.\n\n<Helga winks disarmingly.>:I saw you making eyes at Harr back there. That tauren is MINE.\n\nWhy don\'t you drag your ugly, gold-digging face to another blimp?;',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73148,'Yes! Yes! Yes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73149,'My chickens... ATTACK!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73150,'More chickens! Many more chickens!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73151,'BRUCE!','BRUCE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73152,'BRUUUUUUUUCE!','BRUUUUUUUUCE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73153,'BRUUUUUUUUUUUUCE!','BRUUUUUUUUUUUUCE!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73154,'Come on, Bruce!','Come on, Bruce!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73155,'You got Bruced!','You got Bruced!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73156,'Chomp chomp chomp!','Chomp chomp chomp!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73157,'That\'s my Bruce!','That\'s my Bruce!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73158,'Woo hoo!','Woo hoo!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73159,'Come on Bruce, get it together!','Come on Bruce, get it together!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73160,'You had one job, Bruce. One job!','You had one job, Bruce. One job!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73161,'Noooo!','Noooo!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73162,'Bruce! Why!?!','Bruce! Why!?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73163,'On it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73168,'Doctor FIST!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73169,'Give em\' the FIST!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73170,'What did the five fingers say to the face?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73171,'Drop the hammer!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73172,'Feel the Iron Grip!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73173,'Doctor FIST!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73174,'Take a dose of pain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73175,'Ka-boosh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73176,'Boosh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73177,'Ka-kow!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73178,'Ha ha!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73179,'Boss Bazzelflange wants more people fighting, and she wants \'em fighting better.\n\n\"Incentives!\", she says.  \"We need to give \'em a better reason to brawl!\"\n\nSo she has us build this zeppelin, see. Glorious views of the fight, all the fancy alcohol you can buy, and the satisfaction of bragging to your mates that you can go to a place that they can\'t go to. Y\'see - she only lets you up if you\'re Rank 8 or higher.\n\nYou want to get up on the zep? Keep winning your fights, bucko.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73180,'Hop onto the teleporter, $n! It probably won\'t kill you!\n\nIt might kill you, though.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73181,'Sir, these Kor\'kron don\'t seem very friendly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73182,'+15 Artifact Bonus!','+15 Artifact Bonus!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(73183,'+30 Artifact Bonus!','+30 Artifact Bonus!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(73184,'The Alliance have dropped the Horde gold cart!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73185,'The Alliance have stolen gold from the Horde!','',0,0,0,0,0,0,0,0,1,0,8213,0,26124),
(73186,'Ah, so it\'s a duel you want?  Then a duel you shall have!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73187,'|TInterface\\Icons\\inv_stone_10.blp:20|t %s Chooses |cFFFF0000Rock|r! You |cFF00FF00Win|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73188,'|TInterface\\Icons\\inv_stone_10.blp:20|t %s Chooses |cFFFF0000Rock|r! You |cFFFF0000Lose|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73189,'|TInterface\\Icons\\inv_stone_10.blp:20|t %s Chooses |cFFFF0000Rock|r! You Tie!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73190,'','hello $p race $pr class $pc',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73191,'Lost... to a CHICKEN!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73192,'[PH] This fallen orc is dressed in the fashion of the Frostwolf Clan. Perhaps there are more nearby.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73193,'This is where my agents tracked the Zandalari.','',0,0,0,0,0,0,25,0,1,0,37328,0,26124),
(73194,'I can only imagine what foul business the Zandalari have with them...','',0,0,0,0,0,0,1,0,1,0,37329,0,26124),
(73195,'Yes. This weather is not natural.','',0,0,0,0,0,0,1,0,1,0,37330,0,26124),
(73196,'My champions will go. They will see what can be done, and rescue who they can.','',0,0,0,0,0,0,1,0,1,0,37331,0,26124),
(73197,'It is heartening to see you here, Moira. You have my thanks.','',0,0,0,0,0,0,2,0,1,0,37332,0,26124),
(73198,'...and so you marshaled your personal guard, even without the support of the other clans?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(73199,'Hrmmm. Fare well, Queen Regent.','',0,0,0,0,0,0,66,0,1,0,37333,0,26124),
(73200,'','Shimmer Ridge. I know it well. The Frostmane trolls breed and plot atop that snow-blown mesa.',273,0,0,0,0,0,273,0,1,0,0,37190,26124),
(73201,'','We\'ve lost many mountaineers to this freakish storm, or the trolls slithering about in it.',1,0,0,0,0,0,1,0,1,0,0,37191,26124),
(73202,'','Aye. I am loath to send my men into that. It reeks of ambush and bloody disaster.',1,0,0,0,0,0,273,0,1,0,0,37192,26124),
(73203,'','If they can stop that storm, I\'ll lead the Forgeguard to the top myself.',1,0,0,0,0,0,5,0,1,0,0,37193,26124),
(73204,'','And you have mine, Varian. Your words rang true in the throne room...',1,0,0,0,0,0,273,0,1,0,0,37194,26124),
(73205,'','Indeed. With the aid of your champions, the Dark Irons will put an end to the Zandalari threat in Dun Morogh.',1,0,0,0,0,0,1,0,1,0,0,37195,26124),
(73206,'','I\'ll see you when it\'s done, King of Stormwind.',2,0,0,0,0,0,2,0,1,0,0,37196,26124),
(73207,'Here we are - the ancient seat of pandaren wisdom.$b$bShall we begin?','',547,0,0,0,0,0,0,0,1,0,0,0,26124),
(73208,'To Yu\'lon, then.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73209,'Yu\'lon awaits!','Yu\'lon awaits!',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(73210,'We could smell you tracking us from a league away. If you had not peaked our curiosity you would be dead now.$b$bAs it stands, the way you slew this creature, you have gained our attention.$b$bWhat do you want of us?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73211,'','We will prove our loyalty - to the Council, Ironforge, and the Alliance - here, today, and with our own blood.',1,0,0,0,0,0,5,0,1,0,0,0,26124),
(73212,'','The dissension within the Council of Three Hammers must come to an end.',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(73213,'','Stop whatever wickedness is conjuring up that storm, and the Forgeguard will assault the ridge and wipe out the Frostmane and Zandalari both.$B$BUse my mountaineers and whatever prisoners the trolls have taken to guide your way.',396,0,0,0,0,0,273,0,1,0,0,0,26124),
(73214,'Find a way to stop that conjured storm, champion, and rescue whatever prisoners you can.$B$BFare you well.','',1,66,0,0,4,0,25,0,1,0,0,0,26124),
(73215,'What is this that trespasses in my new lair? A pet of the Frostwolves perhaps?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73216,'Wait, this isn\'t a Frostwolf.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73217,'Kill it anyway! Let us see how it tastes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73218,'There ye are. Here\'s the lay of it: The king\'s spies are dead to a man. Only a handful o\' dwarven scouts are left.','',0,0,0,0,0,0,396,0,1,0,37262,0,26124),
(73219,'The nearest is just ahead. If ye can save him, he may know a thing or two.','',0,0,0,0,0,0,0,0,1,0,37263,0,26124),
(73220,'Once upon a time - moments ago, in fact - a great king sought the help from a trio of powerful dwarves: The Council of Three Hammers.','',0,0,0,0,0,0,0,0,7,0,37118,0,26124),
(73221,'The king\'s scouts had discovered that Zandalari trolls threatened the dwarven capital.','',0,0,0,0,0,0,0,0,7,0,37119,0,26124),
(73222,'Surely, the king thought, if he helped them with their troll problem, they would give him more troops for his campaign against the Horde.','',0,0,0,0,0,0,0,0,7,0,37120,0,26124),
(73223,'But what the king did not realize is that the dwarves did not trust one another!','',0,0,0,0,0,0,0,0,7,0,37121,0,26124),
(73224,'\"We cannot help you,\" said the Bronzebeard dwarf, \"For if we turn our back on the Dark Irons, they will defeat the Wildhammer and take over Ironforge!\"','',0,0,0,0,0,0,0,0,7,0,37122,0,26124),
(73225,'\"We cannot help you,\" said the Wildhammer dwarf. \"For if we turn our back on the Dark Irons, they will defeat the Bronzebeard and take over Ironforge!\"','',0,0,0,0,0,0,0,0,7,0,37123,0,26124),
(73226,'The king was furious. \"If none of you help, then Ironforge will fall under siege!\"','',0,0,0,0,0,0,0,0,7,0,37124,0,26124),
(73227,'Only one dwarf offered to help the king. \"We will lend you our strength,\" said Moira, of the Dark Iron. \"We will trust our dwarven brothers, and we will show them what loyalty means!\"','',0,0,0,0,0,0,0,0,7,0,37125,0,26124),
(73228,'And so Moira and the High King set out into the snow to save the city, leaving the others to think about their actions.','',0,0,0,0,0,0,0,0,7,0,37126,0,26124),
(73229,'What happens next? I must know!','',0,0,0,0,0,0,0,0,7,0,37127,0,26124),
(73230,'The High King, his champions, and the Dark Iron dwarves worked together to save Ironforge.','',0,0,0,0,0,0,0,0,7,0,37128,0,26124),
(73231,'The other dwarven leaders were ashamed of their behavior, and vowed never again to allow fear or distrust to cloud their judgment.','',0,0,0,0,0,0,0,0,7,0,37129,0,26124),
(73232,'And so it was a human king who helped to unite the dwarven clans so long divided.','',0,0,0,0,0,0,0,0,7,0,37130,0,26124),
(73233,'Free to trust one another, all three dwarven leaders pledged their full strength to the Alliance cause.','',0,0,0,0,0,0,0,0,7,0,37131,0,26124),
(73234,'Meanwhile, in the city of Orgrimmar, Warchief Garrosh Hellscream sent goblin dig teams all across the continent of Pandaria.','',0,0,0,0,0,0,0,0,7,0,37132,0,26124),
(73235,'He promised gold and riches to any who could discover for him the hidden secrets of this land that fill Pandaria with such a dark and powerful energy.','',0,0,0,0,0,0,0,0,7,0,37133,0,26124),
(73236,'To my surprise, his people have found something! Right here, in the sacred vale! What will happen now?','',0,0,0,0,0,0,0,0,7,0,37134,0,26124),
(73237,'The story is still being written...','',0,0,0,0,0,0,0,0,7,0,37135,0,26124),
(73238,'So! Even as the Alliance binds itself ever closer together, the Horde is ripping itself apart.','',0,0,0,0,0,0,0,0,7,0,37114,0,26124),
(73239,'My friend, something is about to give. I wish I could experience the next chapter of the story, but alas, I am just the storyteller.','',0,0,0,0,0,0,0,0,7,0,37115,0,26124),
(73240,'You, brave hero - you are strong enough to leap into the center of events as they transpire.','',0,0,0,0,0,0,0,0,7,0,37116,0,26124),
(73241,'Go now! Go to Durotar! Make your mark as history unfurls around you!','',0,0,0,0,0,0,0,0,7,0,37117,0,26124),
(73242,'Thank the laws of physics you\'re here!','',5,0,0,0,0,0,5,0,0,0,37164,0,26124),
(73243,'|TInterface\\Icons\\inv_inscription_scroll.blp:20|t %s Chooses |cFFFF0000Paper|r! You |cFFFF0000Lose|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73244,'|TInterface\\Icons\\inv_inscription_scroll.blp:20|t %s Chooses |cFFFF0000Paper|r! You Tie!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73245,'|TInterface\\Icons\\inv_inscription_scroll.blp:20|t %s Chooses |cFFFF0000Paper|r! You |cFF00FF00Win|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73246,'|TInterface\\Icons\\inv_sword_102.blp:20|t %s Chooses |cFFFF0000Scissors|r! You |cFFFF0000Lose|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73247,'|TInterface\\Icons\\inv_sword_102.blp:20|t %s Chooses |cFFFF0000Scissors|r! You Tie!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73248,'|TInterface\\Icons\\inv_sword_102.blp:20|t %s Chooses |cFFFF0000Scissors|r! You |cFF00FF00Win|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73249,'Oh ho ho ho ho! By my beard, I thought I was done for! Oh, thank ye. Thank ye!','',0,0,0,0,0,0,4,0,1,0,37296,0,26124),
(73250,'Oh... right. Now: Did the human king send ye? Oh, his spies are all dead... and most of us are, too.','',0,0,0,0,0,0,6,0,1,0,37297,0,26124),
(73251,'I saw \'em draggin\' Boldbrew, kickin\' and bitin\', towards some hut south o\' here. Now if ye hurry, ye can help her, and she might know more.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(73252,'BUT STAY AWAY FROM THE  BIG VILLAGE! There\'s dozens o\' mad ice trolls in there! Oh, that Zandalari priest has \'em whipped up into a great frenzy.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(73253,'This mouthwatering brew has an almost hypnotic aroma coming from it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73254,'','Oh, that was a CLOSE one, thank ye!',0,0,0,0,0,0,71,0,1,0,0,37292,26124),
(73255,'','There\'s only a few of us left; the ones they don\'t eat, they butcher at some big altar.',0,0,0,0,0,0,396,0,1,0,0,37293,26124),
(73256,'','It\'s just northwest o\' here; if ye hurry, ye might be able ta save some! Sorry I don\'t know anythin\' more...',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(73257,'Not now, $c. I cannot train you today.$b$b<Your trainer\'s voice lowers to a whisper.>$b$bThe Kor\'kron watches our every move. Garrosh has the Valley of Spirits under his thumb.$b$bYou want to help? Find Vol\'jin. He will know what to do.','Not now, $c. I cannot train you today.$b$b<Your trainer\'s voice lowers to a whisper.>$b$bThe Kor\'kron watches our every move. Garrosh has the Valley of Spirits under his thumb.$b$bYou want to help? Find Vol\'jin. He will know what to do.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73258,'Ya need trainin\'?  You picked a real inconvenient time to come pokin\' through the Valley of Spirits.$b$b<Your trainer\'s voice lowers to a whisper.>$b$bThe Kor\'kron watches our every move. Garrosh has the Valley of Spirits under his thumb. I could be killed if they saw me talkin\' to you.$b$bLucky for you, they don\'t ever see me. Lean in close, $n. We gotta keep this on the down low.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73259,'','Trainin\' services are on temporary hiatus. You wanna learn how to cook? You\'ll have to look somewhere else.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73260,'','No. Not now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73261,'Sorry, $c. De ink\'s run dry \'round here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73262,'There be no fishin\' today. Kor\'kron orders.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73263,'Not now, $n. The bank\'s been taken over for the time being.$b$bThe Kor\'kron leader said that they won\'t be makin\' any \"unauthorized withdrawals\", but... you might wanna check an\' make sure.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73264,'','I have no room for you here, $n. The Kor\'kron have taken over my inn as a temporary barracks.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73265,'<Xon\'cha looks nervously over his shoulder.> You\'ll have to go elsewhere if you want to get at your pets, $c. The Kor\'kron be watchin\'.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73266,'','No auctions today, $r. No auctions for a while, by the look o\' things.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73267,'','Best be takin\' your business elsewhere, $r. Don\'t wanna be causin\' suspicion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73268,'','No sale today. Too dangerous.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73269,'My snakes, mon. They took my snakes!','',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(73270,'','I got nothin\' to sell ya today.',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(73271,'<Huju glances warily over his shoulder.> Not now. Things be gettin\' pretty hot in here lately.','',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(73272,'You might wanna keep your distance, $c. We on pretty strict Kor\'kron lockdown around here. No knowin\' what might happen.','',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(73273,'','Sorry, $c. I got nothin\' for ya.',18,0,0,0,0,0,0,0,1,0,0,0,26124),
(73274,'Filthy monsters! I owe ye me life.','',0,0,0,0,0,0,4,0,1,0,37294,0,26124),
(73275,'Listen: The storm. We figured out what\'s makin\' it. That sneaky Zandalari has these ice trolls makin\' blood sacrifices ta elemental spirits.','',0,0,0,0,0,0,1,0,1,0,37295,0,26124),
(73276,'There\'s a cave, north o\' here, across a bridge. If ye can slay the elemental within, the storm ought ta stop.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(73277,'Queue for A Little Patience.','Queue for A Little Patience.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73278,'Queue for Battle on the High Seas.','Queue for Battle on the High Seas.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73279,'Queue for Blood in the Snow.','Queue for Blood in the Snow.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73280,'Queue for the Secrets of Ragefire.','Queue for the Secrets of Ragefire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73281,'Queue for Dark Heart of Pandaria.','Queue for Dark Heart of Pandaria.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73283,'','The portals are shut down. I hear the orcs still have a portal to the Blasted Lands open, down in the Cleft o\' Shadow.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73284,'VOL\'JIN LIVES!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73285,'Vol\'jin lives, me bruddas!','',0,0,0,0,0,0,4,0,1,0,0,0,26124),
(73286,'Fight de oppression!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(73287,'Rise up against Garrosh Hellscream! Today is de new dawn of de Horde!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73288,'Argh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73289,'$n has been |cFFFF0000|Hspell:141407|h[Frozen Solid]|h|r. Break $ghim:her; free!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73290,'Hex dem good.','',0,0,0,0,0,0,0,0,1,0,6479,0,26124),
(73291,'Dis\'ll help Bom\'bay\'s Witch Doctorin.','',0,0,0,0,0,0,0,0,1,0,6479,0,26124),
(73292,'Bom\'bay found a volunteer!','',0,0,0,0,0,0,0,0,1,0,6482,0,26124),
(73293,'Dat\'ll fix dem.','',0,0,0,0,0,0,0,0,1,0,6482,0,26124),
(73294,'Troll! What are you still doing in my town?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73295,'Trainin\' de mages.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73296,'Hellscream\'s Horde has no need for your voodoo tricks, troll. Now get out of my sight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73297,'Ring the gong to accept Yu\'lon\'s Challenge. You need only to overcome one of the four celestial\'s challenges.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73298,'Ring the Gong [Ranged DPS Challenge]','Ring the Gong [Ranged DPS Challenge]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73299,'Ah, here we are. Oh - oh, these old bones are tired. More than you can imagine.','',0,0,0,0,0,0,0,0,7,0,37304,0,26124),
(73300,'You surprised me. I expected a hero such as yourself to balk at the task of carrying an old man up a mountain. Most are too proud.','',0,0,0,0,0,0,396,0,7,0,37305,0,26124),
(73301,'I was going to teach you a lesson but instead, it is you who have taught me. You see, when I was young... when I was young... when I was young...','',0,0,0,0,0,0,0,0,7,0,37306,0,26124),
(73302,'I was EMPEROR.','',0,0,0,0,0,0,0,0,7,0,37307,0,26124),
(73303,'The realm you see all around you was mine to command.','',0,0,0,0,0,0,0,0,7,0,37308,0,26124),
(73304,'I conquered my doubts, my fears, my anger... I buried all of it within the land.','',0,0,0,0,0,0,0,0,7,0,37309,0,26124),
(73305,'But I held on to one vice. The one sha I never conquered. PRIDE.','',0,0,0,0,0,0,0,0,7,0,37310,0,26124),
(73306,'My pride cloaked this land in mists! I thought we were better than the rest of the world.','',0,0,0,0,0,0,0,0,7,0,37311,0,26124),
(73307,'I thought we could solve our own problems. But for ten thousand years, we stagnated, our doubts and fears buried in the land, rising up to fester whenever we allowed them.','',0,0,0,0,0,0,0,0,7,0,37312,0,26124),
(73308,'Pride. It is the most insidious of sha. It is good until it is bad. And then it is more dangerous than all the others combined.','',0,0,0,0,0,0,0,0,7,0,37313,0,26124),
(73309,'Beware of pride! Be humble! The world is plunging into chaos. Old enemies must work together. Proud races must admit they need help.','',0,0,0,0,0,0,0,0,7,0,37314,0,26124),
(73310,'Things are going to get worse before they get better. Only by working together can we overcome the darkness.','',0,0,0,0,0,0,0,0,7,0,37315,0,26124),
(73311,'All that stands in our way... is pride.','',0,0,0,0,0,0,0,0,7,0,37317,0,26124),
(73312,'Packed up with lumber? Good. Send it up to Orgrimmar.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(73313,'Orgrimmar\'s walls need to be taller! Thicker!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(73314,'No one will question the might of Hellscream\'s Horde!','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(73315,'What do we have here? Oil?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(73316,'Send it to Orgrimmar.','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(73317,'Fresh meat! Straight from the slaughterhouse. Good.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73318,'Move it south, to the Valley of Trials. We have hungry young orcs to feed.','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(73319,'Excellent, a shipment of stone. Send it to Orgrimmar!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73320,'Fiery Anger is about to |cFFFF2222|Hspell:141456|h[Detonate]|h|r!','Fiery Anger is about to |cFFFF2222|Hspell:141456|h[Detonate]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73321,'Make sure your blades are sharp. We\'ve got enemies to cleave today!','Make sure your blades are sharp. We\'ve got enemies to cleave today!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73322,'Get those blades clean. There\'s troll blood to be spilled today!','Get those blades clean. There\'s troll blood to be spilled today!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73323,'No one disobeys Hellscream!','No one disobeys Hellscream!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73324,'The warchief will hear of our success!','The warchief will hear of our success!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73325,'The warchief will hear of your failure!','The warchief will hear of your failure!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73326,'The Darkspear will know the true price of defiance!','The Darkspear will know the true price of defiance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73327,'Wipe the Darkspear from the face of Azeroth!','Wipe the Darkspear from the face of Azeroth!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73328,'This village is ours! Death to the trolls!','This village is ours! Death to the trolls!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73329,'I have an ale for every scalp you bring!','I have an ale for every scalp you bring!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73330,'I will cut down anyone I see fleeing from battle. For Garrosh!','I will cut down anyone I see fleeing from battle. For Garrosh!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73331,'Ya want a present?! WELL, MY LEGS DON\'T EVEN WORK!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73332,'ELEC... TRICITY... GREATEST... WEAKNESS...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73333,'Prepare yourself, hero. Your challenge will begin soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73334,'Dis the kind of trainin Bom\'bay needs.','',0,0,0,0,0,0,0,0,1,0,6482,0,26124),
(73335,'Heya mon.','',0,0,0,0,0,0,0,0,1,0,6479,0,26124),
(73336,'Maybe dey make Bom\'bay full Witch Doctor after dis!','',0,0,0,0,0,0,0,0,1,0,6479,0,26124),
(73337,'Stay away from da voodoo.','',0,0,0,0,0,0,0,0,1,0,6482,0,26124),
(73338,'The spirits have abandoned you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73339,'At last! A proper challenge for my power.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73340,'For the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73341,'Ah, a $r. I haven\'t killed one of your kind in a while.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73342,'Intruders!','Intruders!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73343,'More blood for my axe!','More blood for my axe!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73344,'The Alliance are here!','The Alliance are here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73345,'We\'re under attack!','We\'re under attack!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73346,'Mok-thora ka!','Mok-thora ka!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73347,'The Alliance are here!','The Alliance are here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73348,'You can\'t hide from me!','You can\'t hide from me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73349,'I will feed you to my wolf.','I will feed you to my wolf.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73350,'For the Warchief!','For the Warchief!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73351,'I see you!','I see you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73352,'Tauren! What have your people done? You have dredged open a scar within our sacred Vale!','',6,5,0,0,500,0,0,0,7,0,0,0,26124),
(73353,'Lord Zhu, please understand - the orc \"Warchief\" who ordered the deed no longer speaks for the whole of the Horde. Many voices are rising up against him.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(73354,'Your politics are no concern of mine. Your Horde has disrespected the sanctity of this place. You are no longer welcome here - leave at once!','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(73355,'Give us time, Lord Zhu. Give us the opportunity to bring Hellscream to justice.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(73356,'Sunwalker, I respect your people. You have aided us in our campaign against the Sha and the Thunder King. Otherwise, I would\'ve already ordered the Shado-Pan to purge this entire shrine. But my patience is at an end. The Horde must leave.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(73357,'Please. Give us time to make this right.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(73358,'Taran Zhu stares grimly into the distance.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(73359,'Very well. You have until season\'s end. No longer.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(73360,'We pandaren are no strangers to dealing with tyrants. The coming battle will try your souls. May the celestials guide your actions.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(73361,'The Warchief demands that this shore is secured! When the Alliance makes its move, the tides will run red with their blood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73362,'Have you heard? The traitorous trolls have launched an attack on Razor Hill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73363,'Riko got dis beach on lockdown!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73365,'We may not trust the Alliance, but we need their help if we are to take back the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73366,'Very well. Ya earned me trust. I will put me faith in tha Alliance to do tha right ting.','',0,0,0,0,0,0,0,0,1,0,37209,0,26124),
(73367,'The Darkspear and her allies will attack Orgrimmar by land, so that you can attack her by sea. It be the only way.','',0,0,0,0,0,0,0,0,1,0,37210,0,26124),
(73368,'If we survive dis, maybe someday I call you... \"Friend.\"','',0,0,0,0,0,0,0,0,1,0,37211,0,26124),
(73369,'Look at us three. Back to da sands of old Durotar! It be just like old times.','',0,0,0,0,0,0,1,0,7,21600,37212,0,26124),
(73370,'Not quite, old friend. Times have changed. The line between friend and foe is not so clear.','',0,0,0,0,0,0,1,0,7,21600,37318,0,26124),
(73371,'Dey come! Hellscream tink his own people gonna roll right over.','',0,0,0,0,0,0,1,0,7,0,37224,0,26124),
(73372,'Time ta show dis Warchief da fury of da Darkspear!','',0,0,0,0,0,0,5,0,7,0,37225,0,26124),
(73373,'Hold! Let dem run away. Hellscream will execute dem as cowards if they go back. Sen\'jin Village is safe!','',0,0,0,0,0,0,22,0,7,0,37226,0,26124),
(73374,'Regroup! We press da advantage. Before the Warchief fortifies Razor Hill, we take it for da revolution, an\' close off da road to da Barrens.','',0,0,0,0,0,0,0,0,7,0,37217,0,26124),
(73375,'Anyone who can still fight, come wit\' me!','',0,0,0,0,0,0,0,0,7,0,37218,0,26124),
(73376,'Wait Vol\'jin. Horde is spilling Horde blood. It is tearing me apart.','',0,0,0,0,0,0,0,0,7,0,37319,0,26124),
(73377,'We need ya, mon.','',0,0,0,0,0,0,0,0,7,0,37219,0,26124),
(73378,'I know. I trust you to lead the siege. I am needed elsewhere.','',0,0,0,0,0,0,0,0,7,0,37320,0,26124),
(73379,'I refuse to believe that all of my brethren support Garrosh.','',0,0,0,0,0,0,0,0,7,0,37321,0,26124),
(73380,'You set one foot in Orgrimmar, Hellscream gonna bury a knife in ya neck!','',0,0,0,0,0,0,0,0,7,0,37220,0,26124),
(73381,'I am going to Orgrimmar, alone. Eitrigg, Saurfang, surely they are standing against Garrosh. I must find others.','',0,0,0,0,0,0,0,0,7,0,37322,0,26124),
(73382,'I won\'t hear ya say such tings.','',0,0,0,0,0,0,0,0,7,0,37221,0,26124),
(73383,'It has to be said, Vol\'jin. If we do not make it through this - I want you to know. You have always been my friend. My brother.','',0,0,0,0,0,0,0,0,7,0,37324,0,26124),
(73384,'For da Horde.','',0,0,0,0,0,0,0,0,7,0,37222,0,26124),
(73385,'For the Horde.','',0,0,0,0,0,0,0,0,7,0,37325,0,26124),
(73386,'Darkspear, with me! We ride! No sleep \'til Orgrimmar!','',0,0,0,0,0,0,0,0,7,0,37223,0,26124),
(73387,'The Warchief should\'ve never crossed the Darkspear. He tore the Horde apart.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73388,'I have trained hundreds of young warriors. The Warchief sheds their blood recklessly. He is no longer MY Warchief.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73389,'Please - don\'t hurt us! Vol\'jin is welcome to quarter his revolutionaries here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73390,'You can turn my steel against the \"Warchief,\" but only against his corrupt soldiers - leave the civilians out of your bloodshed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73391,'Ours is the true Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73392,'YOU are the traitors, here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73393,'Vol\'jin and his animals will be put down like the filth they are!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73394,'It be done! Razor Hill is ours! Da Warchief probably see da fires all the way from Grommash Hold...','',0,0,0,0,0,0,0,0,1,0,37213,0,26124),
(73395,'My floot is good luckydo! You can\'t have it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73396,'Vol\'jin - you\'re alive! It is true then - an open rebellion against the Warchief.','',0,0,0,0,0,0,0,0,1,0,37136,0,26124),
(73397,'Baine. We be needin\' ya support. Razor Hill be but an outpost - the walls of Orgrimmar be fortified since da Cataclysm.','',0,0,0,0,0,0,0,0,1,0,37214,0,26124),
(73398,'I must tread carefully. Many of my people are still within Orgrimmar.','',0,0,0,0,0,0,0,0,1,0,37137,0,26124),
(73399,'You should dance for my floot toot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73400,'Flooting isn\'t for stoopids.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73401,'Luckydo, or Luckydon\'t?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73402,'Only stoopid wants to meet Bad Luckydo.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73403,'Lor\'themar be ready to strike once he finish wit da Isle of Thunder, and da Banshee Queen need no excuse, but they both across da sea. Without ya strength, we can\'t breech the city. I need tauren arms.','',0,0,0,0,0,0,0,0,1,0,37215,0,26124),
(73404,'We are preparing. I just need time to ensure the safety of my people. But Vol\'jin...','',0,0,0,0,0,0,0,0,1,0,37138,0,26124),
(73405,'Hmm?','',0,0,0,0,0,0,0,0,1,0,37216,0,26124),
(73406,'Garrosh has turned Orgrimmar into a fortress. You may need to seek out allies... beyond the Horde.','',0,0,0,0,0,0,0,0,1,0,37139,0,26124),
(73407,'My, you are strong! When I was young, I might have doubted that we could do this. But now, I have no doubts at all.','',0,0,0,0,0,0,5,0,7,0,37299,0,26124),
(73408,'Such wind! Such cold! Once, it would have filled these old bones with despair. But on this day, I am filled with hope.','',0,0,0,0,0,0,396,0,7,0,37300,0,26124),
(73409,'Heh, do not get angry with the elements. Violence is their nature. I conquered my own anger long, long ago.','',0,0,0,0,0,0,153,0,7,0,37301,0,26124),
(73410,'Such a patient one! When I was young, I would have hated this task. Nowadays, I am filled with love.','',0,0,0,0,0,0,396,0,7,0,37302,0,26124),
(73411,'Do not fear the heights, as I did when I was young. Fear can drive us to terrible deeds. Ah, but I see that like me, you have learned the lessons of courage!','',0,0,0,0,0,0,396,0,7,0,37303,0,26124),
(73425,'Hey there! I\'m a Hydrolizer model two, dash zero or, H2-0 for short.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73426,'I\'ve been sent here to help you keep Anthracite under control.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73427,'I come stocked with a complimentary charge of water, you\'ll have to find more if you wish to take advantage of my Hydrolizing feature multiple times.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73428,'The |cFFFF0000Horde|r has taken control of the Center Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73429,'Seal the gate, and inform the overseer immediately.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73430,'All lesser races are enemies of the true Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73431,'The Alliance has taken control of the Center Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73432,'The |cFFFF0000Horde|r has lost control of the Center Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73433,'The Alliance has lost control of the Center Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73434,'Lei Shi\'s reflection ripples playfully.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(73435,'Lei Shi\'s reflection smiles happily.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(73436,'Lei Shi\'s reflection burbles quietly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(73437,'This ain\'t in my contract!','This ain\'t in my contract!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73438,'I aint\' gettin\' paid enough for this.','I aint\' gettin\' paid enough for this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73439,'Sabatoger, eh? Not on my watch!','Sabatoger, eh? Not on my watch!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73440,'Sir, these are Garrosh\'s men.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73441,'You tryin\' to make me look bad?!','You tryin\' to make me look bad?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73442,'Alliance are here!','Alliance are here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73443,'Hey! How\'d you get here?!','Hey! How\'d you get here?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73444,'Guards! Alliance over here!','Guards! Alliance over here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73445,'This is bad.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73446,'All of you fan out and search the chamber. If Garrosh is behind this, we\'re going to need proof.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73447,'We aren\'t your enemy, Xorenth!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73448,'These supply crates came from Orgrimmar. What is Garrosh planning to do with so many war supplies?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73449,'Proto-drake eggs... is Garrosh working with the Dragonmaw? Orcs on proto-drakes sounds bad to me, $p. Very bad.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73450,'','These are from the dig site in the Vale of Eternal Blossoms. What is Garrosh trying to find there?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73451,'Quickly, $p! We need you over here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73452,'You may have stopped the storm, but you cannot stop the will of Zandalar! You will DIE, here... ALL OF YOU!','',0,0,0,0,0,0,0,0,1,0,37173,0,26124),
(73453,'Bleed, in the snow!','',0,0,0,0,0,0,25,0,1,0,37177,0,26124),
(73454,'Trolls of the world will unite against you!','',0,0,0,0,0,0,0,0,1,0,37174,0,26124),
(73455,'We control the sand, the seas, the winds...','',0,0,0,0,0,0,0,0,1,0,37175,0,26124),
(73456,'We will bury you in your mountain!','',0,0,0,0,0,0,0,0,1,0,37176,0,26124),
(73457,'There... will be more! Zandalar... will never fall...','',0,0,0,0,0,0,0,0,1,0,37172,0,26124),
(73458,'','The king\'s champions have done it: The storm has ended! Forward, Dark Irons! TO BATTLE WE MARCH!',273,0,0,0,0,0,397,0,1,0,0,37197,26124),
(73459,'','For Ironforge! FOR THE ALLIANCE!',273,0,0,0,0,0,397,0,1,0,0,37188,26124),
(73460,'','Hearts of fire, wills of iron! Back on your feet! GRIND THEM TO DUST!',273,0,0,0,0,0,5,0,1,0,0,37189,26124),
(73461,'Well fought. I see the Dark Irons are as formidable as ever.','',0,0,0,0,0,0,1,0,1,0,37334,0,26124),
(73462,'Hah! For that, I\'m glad. The Bronzebeards and Wildhammers will regret not having been here to share in your glory.','',0,0,0,0,0,0,1,0,1,0,37335,0,26124),
(73463,'Well, you\'ve done just that. Come; let us return to Ironforge, and announce your victory to the Council.','',0,0,0,0,0,0,1,0,1,0,37336,0,26124),
(73464,'','That they are, King Varian. And at the service of the Alliance, I might add.',273,0,0,0,0,0,273,0,1,0,0,37198,26124),
(73465,'','Better they\'re grateful for the clansmen spared death on this miserable hillock. We sought to protect and impress, not to shame.',273,0,0,0,0,0,274,0,1,0,0,37199,26124),
(73466,'Your eyes fail you yet!','',0,0,0,0,0,0,0,0,1,0,37445,0,26124),
(73467,'Well done!','',0,0,0,0,0,0,0,0,1,0,37448,0,26124),
(73468,'%s cackles ominously.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73469,'But can you find me again?','',0,0,0,0,0,0,0,0,1,0,37446,0,26124),
(73470,'I am looking forward to this: The White Tiger is the embodiment of strength in Pandaria!','',0,0,0,0,0,0,1,0,1,0,37385,0,26124),
(73471,'$n has assaulted the Pandaren Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73472,'$n has assaulted the Goblin Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73473,'$n has defended the Goblin Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73474,'$n has assaulted the Center Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73475,'$n has defended the Center Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73476,'$n has defended the Pandaren Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73477,'Great White Tiger! Hear our plea.','',0,0,0,0,0,0,5,0,1,0,37434,0,26124),
(73478,'Ah, the young black dragon graces my temple. The deeds of you and your champion are quickly becoming Pandaren legend.','',0,0,0,0,0,0,1,0,1,0,37347,0,26124),
(73479,'My champion and I seek the blessing of your strength.','',0,0,0,0,0,0,1,0,1,0,37467,0,26124),
(73480,'I take great pride in the company I keep.','',0,0,0,0,0,0,1,0,1,0,37435,0,26124),
(73481,'Tell me, young prince: What is the nature of strength?','',0,0,0,0,0,0,1,0,1,0,37348,0,26124),
(73482,'The power to crush one\'s foes. That is strength.','',0,0,0,0,0,0,1,0,1,0,37436,0,26124),
(73483,'You speak only in terms of one\'s enemies.','',0,0,0,0,0,0,1,0,1,0,37349,0,26124),
(73484,'Certainly, strength can benefit one\'s allies.','',0,0,0,0,0,0,273,0,1,0,37437,0,26124),
(73485,'How so?','',0,0,0,0,0,0,1,0,1,0,37350,0,26124),
(73486,'...by using it to crush their enemies!','',0,0,0,0,0,0,5,0,1,0,37438,0,26124),
(73487,'A black dragon, through and through. Very well, I will give you my blessing, but also some advice:','',0,0,0,0,0,0,1,0,1,0,37351,0,26124),
(73488,'Strength used in the service of others is twice as powerful as strength spent on our foes.','',0,0,0,0,0,0,1,0,1,0,37352,0,26124),
(73489,'Now. My challenge, should you accept it, will test your ability to stand right in the face of danger and persevere.','',0,0,0,0,0,0,1,0,1,0,37353,0,26124),
(73490,'|cFFFE1CF7|Hspell:139267|h[Reliquary Pick]|h|r Double artifacts for 15 seconds!','|cFFFE1CF7|Hspell:139267|h[Reliquary Pick]|h|r Double artifacts for 15 seconds!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73491,'Use the [Rapier Parry] ability to avoid Vertical Slash!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73492,'%s begins to drink a |cFFFF2222|Hspell:141327|h[Volatile Concoction]|h|r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73493,'Ring the gong to accept Xuen\'s Challenge. You need only to overcome one of the four celestial\'s challenges.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73494,'Ring the Gong [Melee DPS Challenge]','Ring the Gong [Melee DPS Challenge]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73495,'Can you open this, Ticker?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73496,'I\'ve been saving this for a special occasion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73497,'I\'ve got just the thing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73498,'A mantid bomb?! Are you sure that won\'t bring down the whole cavern?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73499,'We\'ll need to make a few modifications, but it will get the job done.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73500,'Recruit, bring me that pool pony, three cannon balls, two batteries, and some of that proto-drake egg yolk.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73501,'You heard the goblin, $p. Get to work!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73504,'Wait? They put this here? Who would put this here? Whoever it is should feel bad about themselves.','Wait? They put this here? Who would put this here? Whoever it is should feel bad about themselves.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73505,'\"Put the real bolts in,\" he says. \"The kind that won\'t get us killed,\" he says. Bah.','\"Put the real bolts in,\" he says. \"The kind that won\'t get us killed,\" he says. Bah.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73506,'Huh, I hope someone figured out how to make this thing move.','Huh, I hope someone figured out how to make this thing move.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73507,'These orc designs are okay. They just need more bombs.','These orc designs are okay. They just need more bombs.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73508,'Let the challenge begin! Hero, you must defeat the Black Prince in close-quarters combat.','',0,0,0,0,0,0,1,0,1,0,37343,0,26124),
(73509,'You, Wrathion, will be blindfolded.','',0,0,0,0,0,0,1,0,1,0,37344,0,26124),
(73510,'Black Prince, you are very strong. But what good is strength without the vision to guide it?','',0,0,0,0,0,0,1,0,1,0,37345,0,26124),
(73511,'Begin!','',0,0,0,0,0,0,1,0,1,0,37346,0,26124),
(73512,'Wait - that\'s absurd. I would annihilate my own champion!','',0,0,0,0,0,0,274,0,1,0,37388,0,26124),
(73513,'... interesting. But the outcome is unlikely to change.','',0,0,0,0,0,0,6,0,1,0,37389,0,26124),
(73514,'Very well. I am sorry, champion - But I will not be the one learning a lesson today.','',0,0,0,0,0,0,1,0,1,0,37390,0,26124),
(73515,'We need more oil! How many times do I have to tell you peons!','We need more oil! How many times do I have to tell you peons!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73516,'%s mutters to himself as he ties the blindfold.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73517,'A blind dragon. Ridiculous!','',0,0,0,0,0,0,1,0,1,0,37391,0,26124),
(73518,'Seek out your true enemy! Do not be fooled by his false images!','',0,0,0,0,0,0,1,0,1,0,37337,0,26124),
(73519,'The dragon is stronger than you, hero! Do not let him finish his attacks!','',0,0,0,0,0,0,1,0,1,0,37338,0,26124),
(73520,'Come on! You people are laborers! You are supposed to be laboring!','Come on! You people are laborers! You are supposed to be laboring!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73521,'Is this all the explosives we got? I\'ve made boots with more explosives than this.','Is this all the explosives we got? I\'ve made boots with more explosives than this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73522,'Disarm him if you can. Use every advantage.','',0,0,0,0,0,0,1,0,1,0,37339,0,26124),
(73523,'Stay behind your foe. He cannot see you! Move quickly!','',0,0,0,0,0,0,1,0,1,0,37340,0,26124),
(73524,'Here we are, the home of Niuzao, the Black Ox. He is the patron spirit of Pandaren fortitude, the only celestial who chooses to live beyond the wall.','',0,0,0,0,0,0,1,0,1,0,37387,0,26124),
(73525,'Mighty Black Ox! Hear our plea.','',0,0,0,0,0,0,1,0,1,0,37409,0,26124),
(73526,'My champion and I seek your blessing of fortitude.','',0,0,0,0,0,0,1,0,1,0,37410,0,26124),
(73527,'The strength to overcome any hardship! This is fortitude.','',0,0,0,0,0,0,1,0,1,0,37411,0,26124),
(73528,'You mean to say - physical strength is developed without, but fortitude comes from within?','',0,0,0,0,0,0,1,0,1,0,37412,0,26124),
(73529,'...Sure. I knew that.','',0,0,0,0,0,0,1,0,1,0,37413,0,26124),
(73530,'So enters the dragon, and his mortal champion. You are welcome here.','',0,0,0,0,0,0,402,0,1,0,37274,0,26124),
(73531,'Tell me, Black Prince: What is the nature of fortitude?','',0,0,0,0,0,0,402,0,1,0,37275,0,26124),
(73532,'You confuse strength with fortitude, young dragon. But power is worthless without spirit!','',0,0,0,0,0,0,402,0,1,0,37276,0,26124),
(73533,'I have seen humble slaves endure unimaginable torture, only to rise up and overthrow their masters.','',0,0,0,0,0,0,402,0,1,0,37277,0,26124),
(73534,'And I have seen the mightiest of emperors laid low by the perseverance of the smallest of enemies.','',0,0,0,0,0,0,402,0,1,0,37278,0,26124),
(73535,'Precisely!','',0,0,0,0,0,0,1,0,1,0,37279,0,26124),
(73536,'Of course you did. We will put your understanding to the test.','',0,0,0,0,0,0,1,0,1,0,37280,0,26124),
(73537,'My challenge, if you accept it, will test your champion\'s ability to defend and protect while enduring terrible hardship.','',0,0,0,0,0,0,402,0,1,0,37281,0,26124),
(73538,'Dodge his attacks. Use his strength against him!','',0,0,0,0,0,0,1,0,1,0,37341,0,26124),
(73539,'The elements will not die! Make use of your time before they rise again!','',0,0,0,0,0,0,1,0,1,0,37342,0,26124),
(73540,'The Alliance gold cart is now full and can be stolen from their base!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73541,'The Horde gold cart is now full and can be stolen from their base!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73542,'What was that?','What was that?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73543,'We\'re under attack!','We\'re under attack!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73544,'Ring the gong to accept Niuzao\'s Challenge. You need only to overcome one of the four celestial\'s challenges.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73545,'Ring the Gong [Defense Challenge]','Ring the Gong [Defense Challenge]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73546,'We may not trust the Alliance, but we need their help if we are to take back the Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73547,'%s runs to reload his |cFFFF2222|Hspell:141381|h[Shotgun]|h|r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73548,'$n has taken the Alliance gold cart!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73549,'$n has taken the Horde gold cart!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73550,'The Red Crane of Hope has inspired the citizens of Pandaria from the very dawn of history. I very much want to speak with him.','',0,0,0,0,0,0,1,0,1,0,37386,0,26124),
(73551,'Great Red Crane! Hear our plea.','',0,0,0,0,0,0,1,0,1,0,37392,0,26124),
(73552,'My champion and I seek your blessing of hope.','',0,0,0,0,0,0,1,0,1,0,37393,0,26124),
(73553,'Hope is... a belief in a better tomorrow.','',0,0,0,0,0,0,1,0,1,0,37394,0,26124),
(73554,'...Great Crane. You have not seen what I have seen.','',0,0,0,0,0,0,0,0,1,0,37395,0,26124),
(73555,'... the fires that once burned the sky will return. It is inevitable. The Burning Legion WILL find Azeroth.','',0,0,0,0,0,0,0,0,1,0,37396,0,26124),
(73556,'Seas of blood, cities in ruin! Who are we - one divided world - to stand against a legion?','',0,0,0,0,0,0,0,0,1,0,37397,0,26124),
(73557,'You speak of hope. Believe me, the thinnest sliver of belief that we might somehow survive the coming devastation is all that sustains me.','',0,0,0,0,0,0,0,0,1,0,37398,0,26124),
(73558,'... thank you, Great Crane.','',0,0,0,0,0,0,1,0,1,0,37399,0,26124),
(73559,'My my, the child of the Worldbreaker, proof that none are beyond redemption. I am honored by your visit.','',0,0,0,0,0,0,1,0,1,0,37249,0,26124),
(73560,'Tell me, son of the Earth-Warder: What is the nature of hope?','',0,0,0,0,0,0,1,0,1,0,37250,0,26124),
(73561,'You speak, but doubt your own words.','',0,0,0,0,0,0,1,0,1,0,37251,0,26124),
(73562,'You underestimate me.','',0,0,0,0,0,0,1,0,1,0,37252,0,26124),
(73563,'Rise, son of Deathwing. I will give you my blessing, for you need it more than any I have ever met.','',0,0,0,0,0,0,1,0,1,0,37253,0,26124),
(73564,'I challenge you not to think of hope as a vague and unimaginable future.','',0,0,0,0,0,0,1,0,1,0,37254,0,26124),
(73565,'Live EVERY day with hope in your heart. In doing so, you CREATE the future you dream of.','',0,0,0,0,0,0,1,0,1,0,37255,0,26124),
(73566,'My challenge, if you accept it, tasks you with healing the most grievous of wounds.','',0,0,0,0,0,0,1,0,1,0,37256,0,26124),
(73567,'Ring the gong to accept Chi-Ji\'s  Challenge. You need only to overcome one of the four celestial\'s challenges.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73568,'Ring the Gong [Healing Challenge]','Ring the Gong [Healing Challenge]',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73569,'A Horde caravan needs to be escorted from the Grol\'dom Farm to Far Watch Post.','',0,0,0,0,0,0,0,0,1,20111,37500,0,26124),
(73570,'A Horde caravan needs to be escorted from Southern Barrens to the Crossroads.','',0,0,0,0,0,0,0,0,1,20111,37500,0,26124),
(73571,'A Horde caravan needs to be escorted from Ratchet to the Crossroads.','',0,0,0,0,0,0,0,0,1,20111,37500,0,26124),
(73572,'A Horde caravan needs to be escorted from the Sludge Fen to Durotar.','',0,0,0,0,0,0,0,0,1,20111,37500,0,26124),
(73573,'A Horde caravan needs to be escorted from Stonetalon Mountains to the Crossroads.','',0,0,0,0,0,0,0,0,1,20111,37500,0,26124),
(73574,'A Horde caravan needs to be escorted out of the Dry Hills.','',0,0,0,0,0,0,0,0,1,20111,37500,0,26124),
(73575,'A Horde caravan needs to be escorted out of Wailing Caverns.','',0,0,0,0,0,0,0,0,1,20111,37500,0,26124),
(73576,'A Horde caravan needs to be escorted out of the Stagnant Oasis.','',0,0,0,0,0,0,0,0,1,20111,37500,0,26124),
(73577,'A Horde caravan has been destroyed.','',0,0,0,0,0,0,0,0,1,20111,0,0,26124),
(73579,'Time\'s runnin\' out!','',5,0,0,0,0,0,5,0,0,0,37154,0,26124),
(73580,'Hurry up with those artifacts!','',5,0,0,0,0,0,5,0,0,0,37155,0,26124),
(73581,'Get moving - something ain\'t right about this place.','',5,0,0,0,0,0,5,0,0,0,37156,0,26124),
(73582,'Hands off - you don\'t what that thing is!','',0,0,0,0,0,0,5,0,0,0,37157,0,26124),
(73583,'Just what in the name of all that is unholy was that thing?','',0,0,0,0,0,0,6,0,0,0,37158,0,26124),
(73584,'Oh don\'t you worry none, I don\'t think anyone wants to touch that thing again.  I\'ll collect our money and we are outta here.','',0,0,0,0,0,0,1,0,0,0,37159,0,26124),
(73585,'Hey hey, what is this, huh?  This is barely a fifth of the promised payment!','',0,0,0,0,0,0,5,0,0,0,37160,0,26124),
(73586,'Naw naw naw, see there\'s a contract.  Payment in full is req-','',0,0,0,0,0,0,274,0,0,0,37161,0,26124),
(73587,'Yeah, we\'ll see who\'s got Garrosh\'s back when it counts.','',0,0,0,0,0,0,1,0,0,0,37162,0,26124),
(73588,'Oh yeah, hey no nothing your, uh, your hugeness.  Uh, for the Horde, and all that...  Bye!','',0,0,0,0,0,0,1,0,0,0,37163,0,26124),
(73589,'Containment failure.  Active defense matrix enabled.','',0,0,0,0,0,0,0,0,0,0,37205,0,26124),
(73590,'Security breach.  All safety protocols disabled.','',0,0,0,0,0,0,0,0,0,0,37208,0,26124),
(73591,'Power units activated.','',0,0,0,0,0,0,0,0,1,0,37206,0,26124),
(73592,'Maximum power achieved.','',0,0,0,0,0,0,0,0,1,0,37207,0,26124),
(73593,'A mere toy left by the usurper... you, too, are dust.','',0,0,0,0,0,0,0,0,0,0,37144,0,26124),
(73594,'My blood hungers.','',0,0,0,0,0,0,0,0,0,0,37142,0,26124),
(73595,'I feast on your suffering.','',0,0,0,0,0,0,0,0,0,0,37145,0,26124),
(73596,'Your agony rejuvenates me.','',0,0,0,0,0,0,0,0,0,0,37146,0,26124),
(73597,'Release... me...','',0,0,0,0,0,0,0,0,0,0,37147,0,26124),
(73598,'Your hatred strengthens me!','',0,0,0,0,0,0,0,0,0,0,37148,0,26124),
(73599,'Oh, such... exquisite... pain!','',0,0,0,0,0,0,0,0,0,0,37149,0,26124),
(73600,'I only sleep.','',0,0,0,0,0,0,0,0,0,0,37143,0,26124),
(73601,'Step aside goblin.  This artifact is exactly what the warchief hoped to find here.  I am taking it under Kor\'kron protection.','',0,0,0,0,0,0,5,0,0,0,37182,0,26124),
(73602,'You are paid for all workers present, foreman.  The warchief does not compensate the dead.','',0,0,0,0,0,0,1,0,0,0,37183,0,26124),
(73603,'THIS.  This is what has diluted the vitality of our precious Horde!','',0,0,0,0,0,0,0,0,0,0,37184,0,26124),
(73604,'The warchief graciously permits the families of the dead to live in his city.  To die in the service of the Horde should be a great honor, but you see it as another opportunity to line your filthy pockets!','',0,0,0,0,0,0,1,0,0,0,37185,0,26124),
(73605,'Your kind DISGUSTS me.  Small.  Weak.  Honorless as thieves.  Be thankful the warchief still tolerates your presence at all.','',0,0,0,0,0,0,5,0,0,0,37186,0,26124),
(73606,'What was that, goblin?','',0,0,0,0,0,0,547,0,0,0,37187,0,26124),
(73607,'%s prepares a massive |cFFFF2222|Hspell:141187|h[Vertical Strike]|h|r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73608,'Ours is the true Horde!','Ours is the true Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73609,'YOU are the traitors here!','YOU are the traitors here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73610,'Darkspear animals will be put down like the filth they are!','Darkspear animals will be put down like the filth they are!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73611,'For Hellscream!','For Hellscream!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73612,'The Darkspear never deserved to be part of the Horde!','The Darkspear never deserved to be part of the Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73613,'I\'ll bring Garrosh your head!','I\'ll bring Garrosh your head!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73614,'You betrayed the Warchief!','You betrayed the Warchief!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73615,'All who conspire with the Darkspear face punishment by death!','All who conspire with the Darkspear face punishment by death!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73616,'The Rapier has fallen to the ground.  Pick it up to engage Admiral Hagman!','The Rapier has fallen to the ground.  Pick it up to engage Admiral Hagman!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73617,'The Warchief should\'ve never crossed the Darkspear. He tore the Horde apart.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73618,'Please - don\'t hurt us! Vol\'jin is welcome to quarter his revolutionaries here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73619,'You gonna pay for what ya done to me raptors!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73620,'I have trained hundreds of young warriors. The Warchief sheds their blood recklessly. He is no longer MY Warchief.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73621,'You can turn my steel against the \"Warchief,\" but only against his corrupt soldiers - leave the civilians out of your bloodshed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73622,'Follow ol\' Bom\'bay! He know de way!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73623,'A Kor\'kron shipment of lumber has been overturned!','',0,0,0,0,0,0,0,0,1,20106,37503,0,26124),
(73624,'A Kor\'kron shipment of oil has been overturned!','',0,0,0,0,0,0,0,0,1,20106,37503,0,26124),
(73625,'A Kor\'kron shipment of meat has been overturned!','',0,0,0,0,0,0,0,0,1,20106,37503,0,26124),
(73626,'A Kor\'kron shipment of stone has been overturned!','',0,0,0,0,0,0,0,0,1,20106,37503,0,26124),
(73627,'That\'s exactly what we needed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73628,'Careful! This isn\'t a toy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73629,'This may be my greatest work yet!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73630,'You carried that with your hands?! Uh... you should probably see a medic when we get back...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73631,'Ah, this is exactly the $r I was hoping for.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73632,'I think you misunderstand my brother, Go\'el.  He is not the type to be convinced by a stranger. Especially one so small.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73633,'Don\'t worry, this $c is far more than $ghe:she; first seems. Your brother values strength, and $p possesses that in abundance.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73634,'$p, I was hoping you might aid me yet again. The Frostwolf clan is divided. Many are here, under Durotan\'s command, but many of their strongest warriors traveled into the desert months ago, lead by Durotan\'s brother, Ga\'nar.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73635,'The Frostwolf clan needs to be reunited if it is going to stand strong against the Iron Horde. We need Ga\'nar and his warriors to return.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73636,'We\'ve had no contact with Ga\'nar or his exiles for sometime, but I suspect they are in the north.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73637,'I must warn you though, Ga\'nar and his warriors did not leave on good terms, and are not likely to welcome you with open arms. I think what Go\'el is asking of you may not even be possible.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73638,'I leave that for you to decide.  Go now and prove me wrong.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73639,'The most important ingredient!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73640,'This should give us enough power to disable the stabilization matrix.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73641,'Just a little more power...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73642,'','Disable?!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73643,'My masterpiece is finished!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73644,'It\'s... it\'s beautiful!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73645,'','What the heck is the pool pony for?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73646,'Don\'t question my genius!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73647,'I don\'t care what it\'s for! Is it going to get this door open?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73648,'The longer we spend standing here the sooner Garrosh\'s men are going to find us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73649,'This thing could open Gallywix\'s personal safe!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73650,'Once the detonator goes off in... err... NOW!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73651,'If you do not engage in combat soon, you will forfeit!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(73652,'','The Warchief won\'t be pleased. He is wasting valuable troops fending off their pathetic rebellion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73653,'','I was not expecting this many troops...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73654,'','I\'ve been in the middle of a few messes in my day, but this is ridiculous!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73655,'','We just need to stay focused on our mission so we can get out of here in one piece.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73656,'Can you re-stealth me?','Can you re-stealth me?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73657,'Very good - lay down your weapons!','',0,0,0,0,0,0,1,0,1,0,37356,0,26124),
(73658,'I hope now you understand the limits of strength without vision. It is one thing to change the world, but quite another to do what is right.','',0,0,0,0,0,0,1,0,1,0,37357,0,26124),
(73659,'Young prince, I hope you take this lesson to heart.','',0,0,0,0,0,0,1,0,1,0,37358,0,26124),
(73660,'PAH! A lopsided challenge.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(73661,'I am pleased that our hero is still alive. Thank you for your blessing, mighty tiger.','',0,0,0,0,0,0,2,0,1,0,37439,0,26124),
(73662,'Just as I expected. Do you want to give it another go?','',0,0,0,0,0,0,6,0,1,0,37432,0,26124),
(73663,'That is enough.','',0,0,0,0,0,0,1,0,1,0,37354,0,26124),
(73664,'Champion, turn your foe\'s strength and confidence against him. I believe in you.','',0,0,0,0,0,0,1,0,1,0,37355,0,26124),
(73665,'cautiously rolls the old pirate dice. The dice tumble resulting in |cFFFF2222|Hspell:141967|h[Snake eyes]|h|r.','cautiously rolls the old pirate dice. The dice tumble resulting in |cFFFF2222|Hspell:141967|h[Snake eyes]|h|r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73666,'Urtharges calls on the aid of an elemental!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73667,'','Ticker?! Wake up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73668,'That door didn\'t even budge...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73669,'Warn us a little sooner next time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73670,'%s begins to cast |cFFFF2222|Hspell:136473|h[Counter Shot]|h|r at $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73671,'Help!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73672,'I\'m on fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73673,'Calm down! I\'d hardly call that a fire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73674,'Is he still alive, Newt?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73675,'','Barely. He needs a medic and soon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73676,'Grit quit goofing around!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73677,'Grit, setup the emergency teleporter! We need to report this to Vol\'jin immediately.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73678,'Right away, Sir!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73679,'You will never escape these caverns!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73680,'The true Horde, the pure Horde, cannot be stopped!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73681,'All of Azeroth will run red with the blood of the lesser races.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73682,'Destroy them! FOR THE HORDE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73683,'Recruits, you\'re the only ones left that can fight!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73684,'Defend us until the teleporter is ready!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73685,'|cFFFF0000|Hspell:141387|h[Urtharges\' Shield]|h|r has been broken!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73686,'These crates bear the mark of the Kor\'kron. Various weapons and other war supplies lay strewn about the cavern. From the looks of things, Garrosh is planning an invasion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73687,'%s has put a |cFFFF2222|Hspell:132998|h[Sticky Bomb]|h|r on you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73688,'Young proto-drake eggs line the cavern floor. Many recently hatched eggs fill the surrounding area. With this many proto-drakes, no place would be safe from Garrosh\'s invasion.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73689,'Many artifacts lay here, seemingly discarded. Most appear to have come from Garrosh\'s dig site in the Vale of Eternal Blossoms. Whatever he is trying to find, it does not appear to be among these forgotten relics.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73690,'Vol\'jin jabs his spear into the ground, saying nothing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73691,'You will pay for this!','You will pay for this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73692,'The Warchief will have your blood!','The Warchief will have your blood!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73693,'I curse the Darkspear!','I curse the Darkspear!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73694,'Not like this...','Not like this...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73695,'Traitor!','Traitor!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73696,'I die for Hellscream!','I die for Hellscream!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73697,'You will never defeat the Kor\'kron!','You will never defeat the Kor\'kron!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73698,'I regret nothing!','I regret nothing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73699,'Da people have spoken!','Da people have spoken!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73700,'Ya won\'t take de Horde from us!','Ya won\'t take de Horde from us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73701,'Vol\'jin lives!','Vol\'jin lives!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73702,'Down wit de Kor\'kron!','Down wit de Kor\'kron!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73703,'Hellscream will fall!','Hellscream will fall!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73704,'We be takin\' out de trash!','We be takin\' out de trash!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73705,'For Vol\'jin!','For Vol\'jin!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73706,'We been idle too long!','We been idle too long!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73707,'Gob Squad, defend yourselves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73708,'The Crazy Sapper activates the bomb strapped to its chest!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73709,'Start Basic Damage (Silver)','Start Basic Damage (Silver)',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73710,'Start Basic Damage (Gold)','Start Basic Damage (Gold)',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73711,'Start Basic Damage (Endless)','Start Basic Damage (Endless)',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73712,'Lesser? We\'ll show you who\'s lesser!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73713,'','Found any rare cards lately? Bring them to me, and I\'ll add them to the collection.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73714,'I\'d like to purchase a challenge card.','I\'d like to purchase a challenge card.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73715,'','He doesn\'t need blades or magic to defeat his enemies. Our next challenger, Hexos, fights his foes with the powers of GEOMETRY!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73716,'','He may be a huge chicken, but he\'ll still put up a fight. It\'s Tyson Sanders!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73717,'','He\'s got two modes. Both modes are labeled \"KILL\". Let\'s hear it for T440!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73718,'','Hope you all like your brawlers extra-crispy! Here comes Anthracite!!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73719,'','What\'s better than an explosion? Lots and lots of explosions! In this corner, we have Big Badda Boom!!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73720,'','Aww... look at the cute little snake, Nibbleh! Go ahead, let him nibble on your toes. Let\'s see what happens.',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73721,'','He\'s not a real doctor, but he\'s going to attempt some facial reconstruction surgery. On his next opponent. Welcome, Doctor FIST!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73722,'','Dust off that luckydo, because you\'re gonna need it. It\'s Grandpa Grumplefloot!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73723,'','No introduction could possibly do our challengers justice. Feast your eyes on the Bear and the Lady Fair!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73724,'','Throw down your weapon and pick up your gloves. It\'s time for a good old-fashioned boxing match. Prepare to be floored by Ty\'thar!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73725,'','He\'s probably the most deadly brawler we\'ve ever had here at the Brawl\'gar Arena. Unfortunately, he\'s a little out of his element. Everybody raise your glass for Razorgrin!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73726,'','Brawl\'gar veterans may remember Blat, the self-replicating ooze. Today, we meet his meaner, uglier, older sister: Splat!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73727,'','What\'s this? Bruce is back! A better, faster, stronger Bruce! It\'s MECHA-BRUCE!!!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73728,'','He\'s a strategic mastermind, and he doesn\'t even have a head. Or an elbow, even. It\'s Ro-Shambo! Let\'s give him a hand!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73729,'','Ever wonder what we do with all our obsolete robots? We send them to their deaths in bloody gladiatorial arenas, of course! Here comes Blingtron 3000!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73730,'','He\'s never seen an opponent that he wouldn\'t fight. Ah, small correction: he\'s never seen an opponent. He\'s the Blind Hero!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73731,'It is good to see you, my friend. So much is transpiring it is hard for a Lorewalker like myself to keep up. I have seen many things through my dream brew, but we will need a hero such as yourself to help write this next chapter of our history.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73732,'This mouthwatering brew has an almost hypnotic aroma coming from it.$b$b(Scenarios require item level 425 or greater.)','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73733,'Great Jade Serpent! Hear our plea.','',0,0,0,0,0,0,1,0,7,0,37449,0,26124),
(73734,'My champion and I seek the blessing of your wisdom.','',0,0,0,0,0,0,1,0,7,0,37466,0,26124),
(73735,'|cff6600aaLegacy Challengers:|r\n  Dungeon Master Vishas: $7369w-$7370w\n  Crush: $7387w-$7388w\n  Deeken: $7405w-$7406w\n  Fjoll: $7399w-$7400w\n  Leona Earthwind: $7423w-$7424w\n  T440 Dual-Mode Robot: $8028w-$8027w\n  Hexos: $7871w-$7872w\n  Anthracite: $8030w-$8029w\n  Epicus Maximus: $7385w-$7386w\n  Disruptron: $7417w-$7418w\n  Millhouse Manastorm: $7401w-$7402w\n  Zen\'shar: $7409w-$7410w','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73736,'|cff6600aaSpecial Challengers:|r\n  Grandpa Grumplefloot: $8040w-$8039w\n  Master Boom Boom: $8044w-$8043w\n  Ty\'thar: $8046w-$8045w\n  Razorgrin: $8048w-$8047w\n  Splat: $8050w-$8049w\n  Dippy & Doopy: $8054w-$8053w\n  Mecha-Bruce: $8052w-$8051w\n  Blingtron 3000: $8058w-$8057w\n  Ro-Shambo: $8056w-$8055w\n  The Bear and the Lady Fair: $8042w-$8041w\n  Mingus Diggs: $8060w-$8059w\n  Blind Hero: $8062w-$8061w','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73737,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73738,'|cff6600aaLegacy Challengers:|r\n  Dungeon Master Vishas: $7433w-$7434w\n  Crush: $7451w-$7452w\n  Leona Earthwind: $7487w-$7488w\n  Deeken: $7469w-$7470w\n  Fjoll: $7463w-$7464w\n  T440 Dual-Mode Robot: $8068w-$8067w\n  Hexos: $8064w-$8063w\n  Anthracite: $8070w-$8069w\n  Epicus Maximus: $7385w-$7386w\n  Disruptron: $7417w-$7418w\n  Millhouse Manastorm: $7401w-$7402w\n  Zen\'shar: $7409w-$7410w','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73739,'|cff6600aaSpecial Challengers:|r\n  Grandpa Grumplefloot: $8080w-$8079w\n  Master Boom Boom: $8084w-$8083w\n  Ty\'thar: $8086w-$8085w\n  Razorgrin: $8088w-$8087w\n  Splat: $8090w-$8089w\n  Dippy & Doopy: $8094w-$8093w\n  The Bear and the Lady Fair: $8082w-$8081w\n  Blingtron 3000: $8098w-$8097w\n  Ro-Shambo: $8096w-$8095w\n  Mecha-Bruce: $8092w-$8091w\n  Mingus Diggs: $8100w-$8099w\n  Blind Hero: $8102w-$8101w','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73740,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73741,'View records for legacy challengers.','View records for legacy challengers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73742,'View records for special challengers.','View records for special challengers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73743,'View records for Special Challengers (Page 2).','View records for Special Challengers (Page 2).',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73744,'$gHe\'s:She\'s; one of our veteran Rank 9 brawlers here in the Brawlpub. It\'s $n!','$gHe\'s:She\'s; one of our veteran Rank 9 brawlers here in Brawl\'gar. It\'s $n!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73745,'Nothing can stop our Rank 10 champion brawler, $N!','Nothing can stop our Rank 10 champion brawler, $N!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(73746,'To do what is right, no matter the cost. That is wisdom.','',0,0,0,0,0,0,1,0,7,0,37450,0,26124),
(73747,'When is it ever wise not to act for the greater good?','',0,0,0,0,0,0,1,0,7,0,37451,0,26124),
(73748,'','Ah, the dragon child and the hero. Together you will achieve great things.',0,0,0,0,0,0,2,0,1,0,0,37364,26124),
(73749,'','Tell me, dragon child: What is the nature of wisdom?',0,0,0,0,0,0,2,0,1,0,0,37365,26124),
(73750,'','Spoken like a true child of the Aspects. Always seeking to change the world.',0,0,0,0,0,0,2,0,1,0,0,37366,26124),
(73751,'','But true wisdom comes from KNOWING what is right. And sometimes, DOING nothing at all.',0,0,0,0,0,0,2,0,1,0,0,37367,26124),
(73752,'','To learn THAT is to learn true wisdom.',0,0,0,0,0,0,2,0,1,0,0,37368,26124),
(73753,'','Come forward! I will give you my blessing.',0,0,0,0,0,0,2,0,1,0,0,37369,26124),
(73754,'','My challenge, if you accept it, will test your cunning and footwork even in the midst of life-threatening danger.',0,0,0,0,0,0,2,0,1,0,0,37524,26124),
(73755,'cautiously rolls the old pirate dice. The dice tumble resulting in a 3, afflicting him with |cFFFF2222|Hspell:141962|h[Scurvy]|h|r.','cautiously rolls the old pirate dice. The dice tumble resulting in a 3, afflicting her with |cFFFF2222|Hspell:141962|h[Scurvy]|h|r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73756,'cautiously rolls the old pirate dice. The dice tumble resulting in a 4, and a group of skeleton pirates ambush him!','cautiously rolls the old pirate dice. The dice tumble resulting in a 4, and a group of skeleton pirates ambush her!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73757,'cautiously rolls the old pirate dice. The dice tumble resulting in a 5, afflicting him with |cFFFF2222|Hspell:142037|h[Black Mark]|h|r.','cautiously rolls the old pirate dice. The dice tumble resulting in a 5, afflicting her with |cFFFF2222|Hspell:142037|h[Black Mark]|h|r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73758,'cautiously rolls the old pirate dice. The dice tumble resulting in a 6, causing a |cFFFF2222|Hspell:142058|h[Cannon Barrage]|h|r.','cautiously rolls the old pirate dice. The dice tumble resulting in a 6, causing a |cFFFF2222|Hspell:142058|h[Cannon Barrage]|h|r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73759,'cautiously rolls the old pirate dice. The dice tumble resulting in a 7. Nothing happens.','cautiously rolls the old pirate dice. The dice tumble resulting in a 7. Nothing happens.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73760,'cautiously rolls the old pirate dice. The dice tumble resulting in an 8, granting him |cFF3366FF|Hspell:141968|h[Pirate\'s Boon]|h|r.','cautiously rolls the old pirate dice. The dice tumble resulting in an 8, granting her |cFF3366FF|Hspell:141968|h[Pirate\'s Boon]|h|r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73761,'cautiously rolls the old pirate dice. The dice tumble resulting in a 9, granting him |cFF3366FF|Hspell:142107|h[Thick Skin]|h|r.','cautiously rolls the old pirate dice. The dice tumble resulting in a 9, granting her |cFF3366FF|Hspell:142107|h[Thick Skin]|h|r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73762,'cautiously rolls the old pirate dice. The dice tumble resulting in a 10, and a skeleton pirate comes to aid him in battle!','cautiously rolls the old pirate dice. The dice tumble resulting in a 10, and a skeleton pirate comes to aid her in battle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73763,'cautiously rolls the old pirate dice. The dice tumble resulting in an 11, granting him |cFF3366FF|Hspell:142061|h[Cursed Pirate Dice]|h|r.','cautiously rolls the old pirate dice. The dice tumble resulting in an 11, granting her |cFF3366FF|Hspell:142061|h[Cursed Pirate Dice]|h|r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73764,'cautiously rolls the old pirate dice. The dice tumble resulting in a 12, granting his whole crew |cFF3366FF|Hspell:142140|h[Pirate\'s Life]|h|r.','cautiously rolls the old pirate dice. The dice tumble resulting in a 12, granting her whole crew |cFF3366FF|Hspell:142140|h[Pirate\'s Life]|h|r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73765,'','Let the challenge begin! Hero, you must defeat the Black Prince in combat.',0,0,0,0,0,0,2,0,1,0,0,37370,26124),
(73766,'','You, my dark prince, will be blindfolded.',0,0,0,0,0,0,2,0,1,0,0,37371,26124),
(73767,'','We will demonstrate the limits of power without vision to guide it.',0,0,0,0,0,0,2,0,1,0,0,37372,26124),
(73768,'','Begin!',0,0,0,0,0,0,2,0,1,0,0,37373,26124),
(73770,'','Use movement to your advantage. Do not allow the dragon child to get close.',0,0,0,0,0,0,2,0,1,0,0,37360,26124),
(73771,'','Be aware of your surroundings.',0,0,0,0,0,0,2,0,1,0,0,37361,26124),
(73772,'','Do not allow the elements to engage you!',0,0,0,0,0,0,2,0,1,0,0,37362,26124),
(73773,'The legendary power of the Titans is mine to command!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(73774,'Stand still! I am trying to kill you here!','',0,0,0,0,0,0,1,0,1,0,37441,0,26124),
(73775,'Where did you go? Come back.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(73776,'Ahhh.... Hah!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(73777,'You\'re lucky I\'m not one of those green dragons that can see with their eyes closed.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(73778,'Just as I expected. Did you want to give it another go?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(73779,'','That is enough!',0,0,0,0,0,0,2,0,1,0,0,37374,26124),
(73780,'','Champion, predict your foe\'s movements, and always stay a step ahead. Victory is within you!',0,0,0,0,0,0,2,0,1,0,0,37375,26124),
(73781,'','Very good - that is enough!',0,0,0,0,0,0,2,0,1,0,0,37376,26124),
(73782,'PAH! A lopsided challenge.','',0,0,0,0,0,0,1,0,1,0,37433,0,26124),
(73783,'','Do you see? Power without vision causes only random chaos and destruction.',0,0,0,0,0,0,2,0,1,0,0,37377,26124),
(73784,'I am pleased that our hero is still alive. Thank you for your blessing, great serpent.','',0,0,0,0,0,0,1,0,1,0,37452,0,26124),
(73785,'Let the challenge begin! Hero, you must keep the Black Prince alive with your skills as a healer.','',0,0,0,0,0,0,1,0,1,0,37245,0,26124),
(73786,'Are you certain? You are filled with doubts and fears, young Prince.','',0,0,0,0,0,0,1,0,1,0,37246,0,26124),
(73787,'You have not fully reconciled with your past. Now is the time.','',0,0,0,0,0,0,1,0,1,0,37247,0,26124),
(73788,'Your champion will keep you alive. Begin!','',0,0,0,0,0,0,1,0,1,0,37248,0,26124),
(73789,'I\'m a black dragon. I won\'t need any help.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73790,'What - wait - father!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73791,'Please - don\'t make me do this.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73792,'I shall tear this world apart!','',0,0,0,0,0,0,0,0,5,0,37644,0,26124),
(73793,'Heal the prince, but do not forget to keep yourself alive!','',0,0,0,0,0,0,1,0,1,0,37238,0,26124),
(73794,'Do not miss any opportunity to heal the Black Prince.','',0,0,0,0,0,0,1,0,1,0,37239,0,26124),
(73795,'The veil of shadows has lifted!','',0,0,0,0,0,0,1,0,1,0,37240,0,26124),
(73796,'Keep moving. Your foe is dangerous, but you are smarter.','',0,0,0,0,0,0,1,0,1,0,37241,0,26124),
(73797,'Use the blood of the world to regenerate yourself. You can do this.','',0,0,0,0,0,0,1,0,1,0,37242,0,26124),
(73798,'The elements are undying! Make use of your time before they rise again!','',0,0,0,0,0,0,1,0,1,0,37243,0,26124),
(73799,'Be not afraid of his traps, champion. Your healing is more powerful than his magic!','',0,0,0,0,0,0,1,0,1,0,37244,0,26124),
(73800,'Your tenacity is admirable, but pointless!','',0,0,0,0,0,0,0,0,1,0,37645,0,26124),
(73801,'Your efforts are insignificant!','',0,0,0,0,0,0,0,0,1,0,37646,0,26124),
(73802,'There is no shelter from my fury!','',0,0,0,0,0,0,0,0,1,0,37647,0,26124),
(73803,'Your armor means nothing. Your faith, even less!','',0,0,0,0,0,0,0,0,1,0,37648,0,26124),
(73804,'Enough! Make it stop!','',0,0,0,0,0,0,0,0,1,0,37403,0,26124),
(73805,'Very well. The test is over.','',0,0,0,0,0,0,1,0,1,0,37257,0,26124),
(73806,'But, do not give into despair. You have the spirit to overcome this. Try again - I believe in you!','',0,0,0,0,0,0,1,0,1,0,37258,0,26124),
(73807,'Very good! You have done it!','',0,0,0,0,0,0,1,0,1,0,37259,0,26124),
(73808,'Do not despair, young prince. You are not your father.','',0,0,0,0,0,0,1,0,1,0,37260,0,26124),
(73809,'More importantly, your champion would not let you fall. Do you see? With the support of friends, nothing is impossible.','',0,0,0,0,0,0,1,0,1,0,37261,0,26124),
(73810,'Such... madness...','',0,0,0,0,0,0,0,0,1,0,37404,0,26124),
(73811,'I understand. Thank you, great Crane.','',0,0,0,0,0,0,0,0,1,0,37405,0,26124),
(73812,'Let the challenge begin! Hero, you must defend the Black Prince while he faces his inner turmoil.','',0,0,0,0,0,0,1,0,1,0,37270,0,26124),
(73813,'Is that so? You are filled with doubts and fears, young Prince.','',0,0,0,0,0,0,1,0,1,0,37271,0,26124),
(73814,'Face your inner demons. Now is the time.','',0,0,0,0,0,0,1,0,1,0,37272,0,26124),
(73815,'Your champion will defend you. Begin!','',0,0,0,0,0,0,1,0,1,0,37273,0,26124),
(73816,'I\'m a black dragon. I won\'t need any help.','',0,0,0,0,0,0,1,0,1,0,37400,0,26124),
(73817,'What - wait - father!?','',0,0,0,0,0,0,1,0,1,0,37401,0,26124),
(73818,'Please - don\'t make me do this.','',0,0,0,0,0,0,274,0,1,0,37402,0,26124),
(73819,'The elements will not die! Make use of your time before they rise again!','',0,0,0,0,0,0,1,0,1,0,37264,0,26124),
(73820,'Control the combat. Pay attention to ALL of your foes.','',0,0,0,0,0,0,1,0,1,0,37265,0,26124),
(73821,'Use the battlefield to regenerate yourself.','',0,0,0,0,0,0,1,0,1,0,37266,0,26124),
(73822,'Protect the Black Prince! Distract his enemies!','',0,0,0,0,0,0,1,0,1,0,37267,0,26124),
(73823,'Do not allow your foe to complete his attack.','',0,0,0,0,0,0,1,0,1,0,37268,0,26124),
(73824,'You must sacrifice yourself to keep the dragon child from falling!','',0,0,0,0,0,0,1,0,1,0,37269,0,26124),
(73825,'So be it. The test is over.','',0,0,0,0,0,0,1,0,1,0,37282,0,26124),
(73826,'Remember: You are never defeated until you decide to remain so. Those with true fortitude always rise whenever they fall.','',0,0,0,0,0,0,1,0,1,0,37283,0,26124),
(73827,'Try again - I know you can defeat this challenge!','',0,0,0,0,0,0,1,0,1,0,37284,0,26124),
(73828,'You have friends. Your champion did not allow you to fall. Take this lesson to heart.','',0,0,0,0,0,0,402,0,1,0,37287,0,26124),
(73829,'You are stronger than your father, young prince.','',0,0,0,0,0,0,1,0,1,0,37286,0,26124),
(73830,'Well done! You have triumphed!','',0,0,0,0,0,0,1,0,1,0,37285,0,26124),
(73831,'I understand. Thank you, mighty Ox.','',0,0,0,0,0,0,1,0,1,0,37414,0,26124),
(73832,'The Alliance gold cart was returned to its base by $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73833,'The Alliance gold cart has been returned to their base!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73834,'The Horde gold cart was returned to its base by $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73835,'%s readies a |cFFFF0000|Hspell:142111|h[Disrupting Bellow]|h|r!','%s readies a |cFFFF0000|Hspell:142111|h[Disrupting Bellow]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73836,'The Alliance gold cart was returned to its base!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73837,'The Horde gold cart was returned to its base!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73838,'Fools! The true Horde cannot be stopped by the likes of you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73839,'The teleporter is ready! Let\'s get out of here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73840,'Dem Kor\'kron be gatherin\'.','Dem Kor\'kron be gatherin\'.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73841,'Soon we gonna\' be seein\' dem Kor\'kron rollin\' up over da hills.','Soon we gonna\' be seein\' dem Kor\'kron rollin\' up over da hills.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73842,'Ya gonna\' be helpin\' us, $c?','Ya gonna\' be helpin\' us, $c?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73843,'Ya here to join da revolution, mon?','Ya here to join da revolution, mon?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73844,'Welcome to da\' revolution.','Welcome to da\' revolution.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73845,'Dem Kor\'kron not be catchin\' us off guard dis time.','Dem Kor\'kron not be catchin\' us off guard dis time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73846,'Some of me best friends be orcs. Dis\' be a bad time.','Some of me best friends be orcs. Dis\' be a bad time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73847,'We Darkspear gonna\' be ready.','We Darkspear gonna\' be ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73848,'Ya been invaluable to the revolution, mon. We be armin\' up now.','Ya been invaluable to the revolution, mon. We be armin\' up now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73849,'I was certain we would find you impaled on its stinger...','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73850,'I know why you\'ve come to the northern wastes, curr.  I should gut you and leave you here for the scavengers as a message to my feeble brother.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73851,'But I have a more important message that you will deliver for me.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73852,'My men and I prepare to ride to gron grotto, to unleash our fury upon the gron there.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73853,'If you can prove your strength by subduing a frost wolf, you will be allowed to ride with us, and bear witness.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73854,'We can speak about my fledgling brother\'s request once this task is done.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73855,'Durotan claims himself a leader.  He wears the title, and fools the clan into following him.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73856,'But Durotan is weak and impotent. He lacks the strength to lead the Frostwolves.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73857,'He led us to this northern home of ours early in the season, fleeing the new orc clans in Nagrand.  He inflicts cowardice upon our people.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73858,'He wastes the food of our people on his sickly wife, Drakka, rather than sending her out into the cold, as is custom for the weak.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73859,'He refuses to lead our warriors against the gron and avenge our father\'s death, saying we can\'t spare the men.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73860,'At every turn, Durotan shows his weakness, and spits on the strength of our ancestors.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73861,'We ride now to avenge my father, and remind the entire Frostwolf clan how a true warchief behaves.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73862,'You will witness these acts, and should you somehow live, you will tell my brother and his clan what I have done this day.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73863,'The Thunderlord clan.  My scouts informed me of their presence here in the oasis, blocking our way to the grotto.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73864,'We will call out their leader and put his head on a pike, and then we will slaughter any that remain in our way.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73865,'Show yourself, Graktul!  I am challenge you here, in front of your men.  I will show them the color of your innards!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73866,'I spit on your corpse, orc.  You are weak!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73867,'Slaughter them all, men!  Leave no Thunderlord alive!','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73868,'The strongest of the Frostwolf clan come here when they wish to prove themselves as leaders.  They bring warriors of their choosing, and return to the clan with the head of a freshly slain gron.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73869,'My father lead such a group here to kill the ancient gron, Kolloc, but none of them returned.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73870,'I will finish what my father started this day, and I will heft his spear and shield in his memory.  I will remind the clan how a true Frostwolf warchief behaves.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73871,'Ya be callin\' dat a grip on your weapon? Any Kor\'kron worth \'is hide will have dat ting disarmed in a pinch.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73872,'You\'re alive.  I\'ll take that as a good sign.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73873,'We be facin\' da Kor\'kron. Deh be da meanest, baddest orcs deh\' Horde have ever seen. Ya betta\' not be sleepin\' through \'dis trainin\'.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73874,'Remembah! Kor\'kron axes gotta\' hit you wit\' their blade. Ya maces ain\'t got dat kinda limitation.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73875,'SPAWN ACTION','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(73876,'Meet me at the coliseum.  You\'ve played an important role in this.  You deserve to see the results.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(73877,'You call \'dat a battlecry? We be startin\' a revolution. Roar like ya already won and deh\' other side just not figured it out yet.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73878,'Everyone out before more of them show up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73879,'I\'ll defend until the last goblin is out! See you all at the rendezvous!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73880,'','Seek out your true enemy! Do not be fooled by his false images!',0,0,0,0,0,0,2,0,1,0,0,37363,26124),
(73881,'','The elements are undying! Make use of your time before they rise again!',0,0,0,0,0,0,1,0,1,0,0,37359,26124),
(73882,'','Please, young prince. Take this lesson to heart.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(73883,'Avast, these Alliance scallywags have made their way onto our ship.  Take care of them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73884,'%s hands you a climbing rope.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(73885,'Walk wit\' me, $c. Vol\'jin be seein\' ya in just a moment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73886,'De \"Warchief\" still believes Vol\'jin be dead, slain by his Kor\'kron assassin in Kun-Lai Summit.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73887,'Vol\'jin survived, but he still remember da sting a\' Hellscream\'s betrayal. Darkspear never die.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(73888,'When Vol\'jin come back ta us, I saw he was changed. Da light a\' revolution be burnin\' in his eyes!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(73889,'Now, look around you. De Darkspear rebellion begins. Hellscream\'s worst nightmare.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(73890,'De spark becomes a flame, de flame becomes a fire, de fire... an inferno. We gonna burn our way ta da gates a\' Orgrimmar.','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(73891,'But we gotta feed dis war machine. Stone, wood, oil, meat - we be needin\' \'em in large supply.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(73892,'Dat\'s where we need you, $Gbruddah:sistah;.','',0,0,0,0,0,0,66,0,1,0,0,0,26124),
(73893,'Go, speak to Vol\'jin. Prepare yourself. From here on out, we be askin\' more of you den ever before.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(73894,'The Horde are coming aboard!  Get up to the deck and help fend them off!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(73895,'It is a risk I have to take. But if I am killed, please watch over Aggra and my boy.','',0,0,0,0,0,0,0,0,7,0,37323,0,26124),
(73896,'','You did good, $n. Looks like trouble is brewing within the Horde. Garrosh has a full-scale troll rebellion on his hands.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73897,'So the rumors are true? Vol\'jin is alive and out for Garrosh\'s blood?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73898,'','Yes. This is just the opportunity the Alliance needs. We\'ll use the trolls as a diversion while the main Alliance fleet assembles. You get what I\'m saying, Sully?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73899,'Wait a minute! Are you suggestin\' that we help Vol\'jin?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73900,'','Vol\'jin is backed into a corner. With our aid, he\'ll be the spear that breaks open Hellscream\'s fortress. Let our enemies weaken one another, while we wait in the wings for our chance to strike.',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(73901,'That\'s my girl, fanning the flames! I like it. Now, which one o\' us is brave enough ta pay a little visit to tha Darkspear?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73902,'Not it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73903,'Look mon, Alliance filth washed up from Theramore. Kill it!','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(73904,'','Wait! Lower ya weapons. I know of dis one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73905,'','Tell Vol\'jin I bring an ambassador from de Alliance.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73906,'','Walk wit\' me, $r.',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(73907,'','Keep ya hands where we can see \'em. Everybody be jumpy. We be in a war here, a war against de Warchief hisself.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(73908,'','Hellscream already try ta have Vol\'jin killed. Heh. Ain\'t so easy ta kill a troll.',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(73909,'','What he did? He woke de fury a\' de Darkspear tribe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73910,'','Hellscream thought Vol\'jin dead, \'til Vol\'jin show up at Sen\'jin Village. Den de Warchief try to crush de rebellion, but we was waitin\' for \'im. We fought back de Kor\'kron at Sen\'jin, and den we took Razor Hill, hah, right under de Warchief\'s nose!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(73911,'','We turn eyes now ta de final prize - Orgrimmar.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(73912,'','De Alliance want a second front on Orgrimmar? We can do dat. You can help. We be needin\' resources: Stone. Wood. Oil. Meat. Only den can we move on da city.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(73913,'','Dis ain\'t a task for da weak-hearted, stranger. But if ya help us, maybe Vol\'jin begin ta trust ya. Either way ya weaken de Warchief\'s grasp on his own lands. Tink a soft-skinned Alliance can do it? Ahahahahaaa!',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(73914,'|TInterface\\Icons\\ability_deathknight_remorselesswinters:20|t%s summons a |cFFF00000|Hspell:142320|h[Glacial Freeze Totem]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73915,'|TInterface\\Icons\\spell_fire_windsofwoe:20|t%s begins to cast |cFFF00000|Hspell:142306|h[Ruined Earth]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73916,'We have done it, hero! We have the blessings of the celestials, and we have completed their challenge.','',0,0,0,0,0,0,5,0,1,0,37430,0,26124),
(73917,'I know our next step. Meet me back atop Mason\'s Folly - you\'ll be pleasantly surprised at what I have in store for you!','',0,0,0,0,0,0,5,0,1,0,37431,0,26124),
(73918,'Hey hey hey! You lookin\' fer some fast travel to the Barrens?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73919,'You need ta go somewhere? As long as that somewhere is Ratchet, I\'ve got yer fast track right here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73920,'Never had an unsatisfied customer! Try Chatterswitch Travels today!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73921,'My state of the art teleporter will take you straight to the Northern Barrens. Whaddaya say?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73922,'I\'d like to travel to Ratchet.','I\'d like to travel to Ratchet.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73923,'All right, step right up, $r. Right up there on the teleporter.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73924,'Go, go, go! Get on that teleporter. Got lotsa customers today, so hurry it up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73925,'Step onto that teleporter. Ratchet, comin\' right up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73926,'Garrosh\'s goons didn\'t like that I kept working with trolls.','Garrosh\'s goons didn\'t like that I kept working with trolls.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73927,'The Warchief is caging all the dissidents. Even us orcs!','The Warchief is caging all the dissidents. Even us orcs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73928,'I never thought Garrosh would turn against orcs!','I never thought Garrosh would turn against orcs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73929,'Now I see why the Darkspear are fighting back!','Now I see why the Darkspear are fighting back!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73930,'Use your body to shield Wrathion from the incoming attacks!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(73931,'The Jade Serpent is the incarnation of wisdom in Pandaria. Let\'s see what she has to say.','',0,0,0,0,0,0,1,0,7,0,37384,0,26124),
(73932,'Taunt the Vision of Deathwing when he fixates on Wrathion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73933,'Minions, destroy these insects!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(73934,'You already had that artifact!  Combo chain restarted...','You already had that artifact!  Combo chain restarted...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(73935,'11','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73936,'12','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73937,'13','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73938,'14','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73939,'15','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73940,'These Horde dogs are swinging aboard.  Fend them off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73941,'These Alliance pigs are swinging aboard.  Fend them off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73942,'These ruffians are swinging aboard to steal our treasure.  Fend them off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73943,'More are coming aboard.  Hold \'em off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73944,'Enemy Lieutenant coming aboard, fend him off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73945,'Not so fast...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73946,'En Garde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73947,'FIRE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73948,'We\'ve pushed them back to their ship.  Swing over and steal their explosives to blow it to smithereens!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73949,'That\'ll teach \'em!  Now hop in that cannon and converge on their lead ship!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73950,'Watch out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73951,'Fire in the hole!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73952,'I\'m out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73953,'Let\'s see how this works!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73954,'Avast, these Horde scallywags have made their way onto our ship.  Take care of them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73955,'Avast, these scallywags have made their way onto our ship.  Take care of them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73956,'We were working on this wall here and... well, I don\'t even remember.  Who are you, anyhow?  Where\'s Gearslip?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(73957,'Everything is fine.  Look, there\'s too much to explain...','Everything is fine.  Look, there\'s too much to explain...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73958,'It\'s all clear then?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(73959,'That was some explosion!  Let\'s check it out.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(73960,'It looks like some sort of gigantic chest... probably full of gold.  And it\'s all ours!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(73961,'What... what\'s going on?  Somethin\'... in... my head...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(73962,'Ahhhhhhhhhhhh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(73963,'I\'ll be destitute if I don\'t recover my losses from this disaster.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(73964,'Help a goblin out and grab some of them fancy artifacts.  Meanwhile, my guys will clear the entrance to the mine.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(73965,'No time to waste... let\'s blow this wall to pieces!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(73966,'','Ya not gonna be foolin\' ol\' Zen\'tabra with dat cat disguise. I be rememberin\' dis, $r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73967,'Now\'s your chance to escape. Make a run for it!','Now\'s your chance to escape. Make a run for it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73968,'','De Alliance willing to help da Darkspear? Never thought I would live to see de day.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73969,'','My thanks, $r. I won\'t be forgettin\' dis.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73970,'Wrathion falls breathlessly to the ground in defeat!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(73971,'An Alliance caravan needs to be escorted out of the Dry Hills.','',0,0,0,0,0,0,0,0,1,20112,37500,0,26124),
(73972,'Intruders have been spotted! Defend the Thunder Forge!','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(73973,'The Thunder Forge is ours!  We will defend it with our lives!','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(73974,'Laz Madwire calls in Crazy Sappers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73975,'An Alliance caravan needs to be escorted out of the Forgotten Pools.','',0,0,0,0,0,0,0,0,1,20112,37500,0,26124),
(73976,'An Alliance caravan needs to be escorted off of Dreadmist Peak.','',0,0,0,0,0,0,0,0,1,20112,37500,0,26124),
(73977,'An Alliance caravan needs to be escorted out of the Sludge Fen.','',0,0,0,0,0,0,0,0,1,20112,37500,0,26124),
(73978,'An Alliance caravan needs to be escorted out of the Forgotten Pools.','',0,0,0,0,0,0,0,0,1,20112,37500,0,26124),
(73979,'An Alliance caravan needs to be escorted out of the Wailing Caverns.','',0,0,0,0,0,0,0,0,1,20112,37500,0,26124),
(73980,'An Alliance caravan needs to be escorted out of the Stagnant Oasis.','',0,0,0,0,0,0,0,0,1,20112,37500,0,26124),
(73981,'An Alliance caravan needs to be escorted out of Thorn Hill.','',0,0,0,0,0,0,0,0,1,20112,37500,0,26124),
(73982,'An Alliance caravan has been destroyed.','',0,0,0,0,0,0,0,0,1,20112,0,0,26124),
(73983,'De Darkspear will never give up!','De Darkspear will never give up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73984,'Vol\'jin lives!','Vol\'jin lives!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73985,'De Darkspear will be your end!','De Darkspear will be your end!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73986,'Garrosh will pay!','Garrosh will pay!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73987,'Dis is only da beginning!','Dis is only da beginning!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73988,'De Darkspear is gonna destroy Garrosh!','De Darkspear is gonna destroy Garrosh!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73989,'The Vision of Deathwing fixates on Wrathion, heal him!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73990,'A Kor\'kron commander has appeared on the battlefield.','A Kor\'kron commander has appeared on the battlefield.',0,0,0,0,0,0,0,0,1,20106,0,0,26124),
(73991,'De spirits be restless.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73992,'<The stench around Vol\'jin\'s makeshift revolutionary camp is intolerable. The troll leader allows you to speak first, while his guards eye you warily.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73993,'Why are the Darkspear in rebellion against Garrosh?','Why are the Darkspear in rebellion against Garrosh?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73994,'What about Hellscream? What does the Horde mean to him?','What about Hellscream? What does the Horde mean to him?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73995,'Why should we help you? What if we kept the Barrens supplies for ourselves?','Why should we help you? What if we kept the Barrens supplies for ourselves?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(73996,'<Vol\'jin twists his face into a scowl.>$b$bYa wouldn\'t understand. What\'s de Horde ta ya, $r? Hm? Diseased? Alien? Betrayers? Demon-blooded? Beasts? I know what ya say \'bout us.$b$bI\'ll tell ya what de Horde is. De Horde dat me an\' Thrall built. It be a family. When de whole world try ta put us down, de family come an\' pick us back up.$b$bHellscream, he don\'t see family. Ain\'t never had one.','',1,5,0,0,0,0,0,0,1,0,0,0,26124),
(73997,'For him, Horde be about orcs, an\' buildin\' up orc power. Like he just come through de portal. Anyone stand in his way, anyone tink any diff\'rent, he shut \'em up.$b$b<Vol\'jin runs his three-fingered hand across his scar.>$b$bHe like an angry dog. Oh, I fight next to Hellscream in battle, sure. But put him in charge? Ya askin\' for trouble. He pick his favorites, start his war, shove me bruddahs aside... He don\'t tink he need nobody else. Well, he wrong.$b$bHe gonna learn: ya never cross family.','',1,274,0,0,0,0,0,0,1,0,0,0,26124),
(73998,'<Vol\'jin cackles, the stench of his hot breath reeking in your nostrils.>$b$bOh, ya got anudda plan? I got anudda plan, too. I let ya siege Orgrimmar on ya own. See how far ya get. An\' once da city be filled wit\' corpses, den me shadow hunters come in, we mop up what left, kill Kor\'kron an\' Alliance alike. Give ya dead ta Sylvanas. Hmm! I save a lot a Darkspear lives wit\' dis plan!$B$BMmnn? You don\'t like? Then, we stay wit\' da first plan. We work together.$b$bWe don\'t even have ta like each other.','',11,274,1,0,0,0,0,0,1,0,0,0,26124),
(73999,'What happened to you in Pandaria?','What happened to you in Pandaria?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74000,'Does Garrosh know you\'re alive?','Does Garrosh know you\'re alive?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74001,'Why are you fighting against our own Warchief?','Why are you fighting against our own Warchief?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74002,'How do you see the Horde?','How do you see the Horde?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74003,'<Vol\'jin runs his three-fingered hand over his scar.>$b$bIt been a long road, friend. Garrosh tried ta take me life wit\' a knife in de throat. Left me for dead. I crawl out dat cave, couldn\'t even speak. It was Chen Stormstout who found me, nursed me back from de brink.$b$bWe travelled to de Shado-Pan monastery, an\' dey help me do some soul-searching. Figure out who I was. Who de Horde was. Me father...$b$bI made up me mind. I\'m takin\' de Horde back. No matter de cost.$b$bDarkspear never die.','',1,274,0,0,0,0,0,0,1,0,0,0,26124),
(74004,'<Vol\'jin allows a grim smile to creep across his scowling features.>$b$bNot yet he don\'t. Maybe he hearin\' rumors. Maybe he thinkin\', dey ghost stories. Maybe ol\' Vol\'jin comin\' back ta haunt him. Hah.$b$bHe find out soon enough. Too bad I\'m not gonna be there ta see da look on his fat, beady-eyed face when he hears ol\' Vol\'jin is back, an\' gonna make good on me promise. Ta end his sad little reign. Ta fire de arrow dat pierces his black heart.','',11,1,0,0,0,0,0,0,1,0,0,0,26124),
(74005,'Ya still call him \"Warchief,\" $c? Is he still YOUR Warchief? What of de spoils of his war? I don\'t see you fat an\' happy like his Kor\'kron. His Horde be an orc Horde. Do ya still feel welcome here, $r? Are ya a part of his plan? Or are ya trash he gonna do away wit\' once he has his way? He promise glory, but bathes our Horde in blood, an\' steps on anyone who see it diff\'rent.$b$bYa wanna know how I see de Horde? De Horde dat me an\' Thrall built?','',25,1,274,0,0,0,0,0,1,0,0,0,26124),
(74006,'Horde be a family. When de whole world try ta put us down, de family come an\' pick us back up. We all each other got, see?$b$bHellscream, he don\'t see family. Ain\'t never had one. All he see is power, like he just come through the portal.$b$b<Vol\'jin stares off into the distance.>$b$bWe stand against him - together, here, now - or he stomp us out. One. By. One. I got de scars ta prove it.$b$bWho do ya trust, $n? Where be your loyalty now? Hellscream? Or family?','',5,1,0,0,0,0,0,0,1,0,0,0,26124),
(74007,'Ya still call him \"Warchief,\" $c? Is he still YOUR Warchief? What of de spoils of his war? I don\'t see you fat an\' happy like his Kor\'kron.$b$bLook, ya be an orc, maybe ya don\'t see it. Da ghettos in Orgrimmar. De way he talk \'bout de other races. De way he use \'em like cannon fodder. Are ya one of de chosen few, $n? Or are ya disposable, like de rest of us? De trash he throw away once he get his monstrous way. He promise glory but bathes our Horde in blood.$b$bMe an\' Thrall, we see a diff\'rent Horde.','',25,1,274,0,0,0,0,0,1,0,0,0,26124),
(74008,'Years ago, I helped put the Horde together on these very sands. My... how times have changed.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(74009,'What are you doing here, Chen Stormstout?','What are you doing here, Chen Stormstout?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(74010,'$n! So strange to see you here, far from the green forests of Pandaria.$b$bWhen I first sailed away from the Wandering Isle, years ago, this ragged shore was one of the first places I visited. Ahh! The air still smells the same!$b$bBut times have changed. Back then I helped Thrall, Vol\'jin, Rexxar and Rokhan to lay the foundation of Orgrimmar. Today, I hardly recognize the place.$b$b<Chen\'s face falls.>$b$BSo much needless bloodshed. I just don\'t understand. Has Pandaria taught us nothing?','',1,6,0,0,0,0,0,0,1,0,0,0,26124),
(74011,'Wrathion is blindfolded, so attack from behind for bonus damage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74012,'Ya\' better stay away, chumps. No one hassles the Hoff!','',0,0,0,0,0,0,0,0,1,0,37502,0,26124),
(74013,'MUGG! Get over here! The Hoff\'s under attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74014,'Hoff... out...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74015,'You aren\'t gonna off the Hoff!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74016,'It\'s ROCKET TIME, ladies! Come and get it!','',0,0,0,0,0,0,0,0,1,0,37502,0,26124),
(74017,'Oh, that was a bad move, buddy. A baaaaad move.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74018,'I will meet you at each of the four shrines, champion.','',0,0,0,0,0,0,0,0,5,0,37426,0,26124),
(74019,'Remember, we must visit all four, but we only need to complete ONE of the four challenges.','',0,0,0,0,0,0,0,0,5,0,37427,0,26124),
(74020,'Choose the challenge most appropriate for your unique talents.','',0,0,0,0,0,0,0,0,5,0,37428,0,26124),
(74021,'Good luck!','',0,0,0,0,0,0,0,0,5,0,37429,0,26124),
(74022,'BAM! BOOM! A-hahahahaha!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74023,'$n picked up the Alliance gold cart!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74024,'$n picked up the Horde gold cart!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74025,'Stand still! I am trying to kill you here!','',0,0,0,0,0,0,0,0,1,0,37441,0,26124),
(74026,'Ahhh... Hah!','',0,0,0,0,0,0,0,0,1,0,37443,0,26124),
(74027,'Where did you go? Come back!','',0,0,0,0,0,0,0,0,1,0,37442,0,26124),
(74028,'Proto-Drake Whelps hatch from the nearby eggs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74029,'Ashes! Smoking craters! AHAHAHAHA!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74030,'Looks like my fuse... went out...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74031,'My boys may not be the brightest, but we can take all of you on!','',0,0,0,0,0,0,0,0,1,0,37502,0,26124),
(74032,'Bombs away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74033,'Couldn\'t deal with our explosive tempers, huh?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74034,'DEATH FROM ABOVE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74035,'Blown... to... bits...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74036,'Blood and thunder! Challengers, your death comes for you!','',0,0,0,0,0,0,0,0,1,0,37502,0,26124),
(74037,'Ha! A challenge?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74038,'Dodge this!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74039,'How sad. I expected more.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74040,'At last, a worthy opponent.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74041,'Smell blood. Puny fleas afraid to fight.','',0,0,0,0,0,0,0,0,1,0,37502,0,26124),
(74042,'This one. Should be fun kill.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74043,'Heart will stop!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74044,'Dead. Happy.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74045,'Sleep... finally...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74046,'Back to work, you pathetic grunts! A bunch of rebels and Alliance weaklings aren\'t going to stop us!','',0,0,0,0,0,0,0,0,1,0,37502,0,26124),
(74047,'You might have gotten past the weaklings. You aren\'t gonna get past me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74048,'Let it rain!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74049,'Weak. How predictable.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74050,'How could you... have beaten me?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74051,'I will crush any who oppose the Warchief!','',0,0,0,0,0,0,0,0,1,0,37502,0,26124),
(74052,'Enemies! SMASH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74053,'I will flatten you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74054,'Nothing stands against me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74055,'I failed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74056,'','Watch your back...',0,0,0,0,0,0,0,0,1,0,0,37502,26124),
(74057,'','How foolish.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74058,'','Hope you like pain.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74059,'','Hmph. Too easy.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74060,'','No!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74061,'Aheh... heh... heh...','',0,0,0,0,0,0,0,0,1,0,37502,0,26124),
(74062,'Mwahahaha!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74063,'Eee ya ha ha ha!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74064,'Mmmmmmm...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74065,'Ha... ha...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74066,'','This world will burn before the might of the Warchief!',0,0,0,0,0,0,0,0,1,0,0,37502,26124),
(74067,'','More kindling for the fire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74068,'','Don\'t get burned...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74069,'','Mmm, the smell of charred flesh...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74070,'','Ash... to ash...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74071,'','I speak, and the oceans tremble. Fear me, enemies of Hellscream.',0,0,0,0,0,0,0,0,1,0,0,37502,26124),
(74072,'','I will wash you to sea.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74073,'','The currents bow to me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74074,'','Drown in your own failure.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74075,'','I wash away...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74076,'The earth shall swallow you!','',0,0,0,0,0,0,0,0,1,0,37502,0,26124),
(74077,'These ones wish to return to the earth...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74078,'RISE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74079,'Return to the earth, weaklings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74080,'I... am no longer...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74081,'We\'ll cover ye from the brush: Point out a target, and we\'ll open fire.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(74082,'Core Spiders appear from the lava!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74083,'|cFF0000FFQueue for Blood in the Snow.|r','|cFF0000FFQueue for Blood in the Snow.|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74084,'|cFF0000FFQueue for Dark Heart of Pandaria.|r','|cFF0000FFQueue for Dark Heart of Pandaria.|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74085,'Deadeye Kail sticks to his guns.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74086,'Why are you and Sully out here?','Why are you and Sully out here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74087,'','The High King has no intention of letting Garrosh continue his mad campaign. It is costing too many innocent lives.$b$bWe are here to look for vulnerabilities in Orgrimmar\'s defenses. The sort of vulnerabilities that an Alliance army could take advantage of.$b$bUnfortunately, it looks like Garrosh has not been idle. He has stepped up recruitment of Kor\'kron and turned them into a full-fledged war machine.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74088,'','They used to be an elite band of orcs created to serve the Warchief as protectors and enforcers of his command.$b$bNow they are an army of incredibly well trained destroyers. Garrosh\'s personal legion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74089,'What are the Kor\'kron?','What are the Kor\'kron?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74090,'This ol\' cloaking chicken better not fail. She\'s been actin\' up lately.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74091,'Tell me again about the King and the Council...','Tell me again about the King and the Council...',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74092,'I think I saw trolls being carted off in chains. Why would orcs be cartin\' trolls off in chains?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74093,'Sittin\' in the middle of enemy forces with not much more than this cloaking chicken protectin\' us. This has become my new normal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74094,'Tell me again about the Warchief and the Darkness...','Tell me again about the Warchief and the Darkness...',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74095,'The Horde brought back a hozen?! Dinna\' they had enough of those back in Pandaria?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74096,'I never seen this many Kor\'kron in one place before!$b$bThose orcs are as fierce as fierce gets and angry to boot. They must have upped their recruiting program.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74097,'Where did Project C4T come from?','Where did Project C4T come from?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74098,'Ol\' Boots?! He\'s a creation all my own. After Socks, may he rest in peace, I needed a more durable companion.$b$bIt was Amber that decided to use him for our mission, so try not to blow him up!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74099,'','Good riddance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74100,'Narali deserved worse!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74101,'Welcome back, champion!','',0,0,0,0,0,0,1,0,1,0,37415,0,26124),
(74102,'Excellent work with the celestials. Can you believe how chatty they were?','',0,0,0,0,0,0,1,0,1,0,37416,0,26124),
(74103,'I just wanted them to hand us our reward, but they were just, \"talk talk talk talk talk.\"','',0,0,0,0,0,0,1,0,1,0,37417,0,26124),
(74104,'I\'m sorry - where were we? Oh yes! I have something for you:','',0,0,0,0,0,0,1,0,1,0,37418,0,26124),
(74105,'The very spirits of Pandaria are supporting us in our grand crusade! Behold:','',0,0,0,0,0,0,1,0,1,0,37419,0,26124),
(74106,'The strength of the White Tiger.','',0,0,0,0,0,0,25,0,1,0,37420,0,26124),
(74107,'The wisdom of the Jade Serpent.','',0,0,0,0,0,0,1,0,1,0,37421,0,26124),
(74108,'The fortitude of the Black Ox.','',0,0,0,0,0,0,1,0,1,0,37422,0,26124),
(74109,'And from the Red Crane, a shining beacon of hope for a better world!','',0,0,0,0,0,0,1,0,1,0,37423,0,26124),
(74110,'Our world.','',0,0,0,0,0,0,1,0,1,0,37424,0,26124),
(74111,'There! It is ready.','',0,0,0,0,0,0,1,0,1,0,37425,0,26124),
(74113,'Escort caravans to earn bonus Kor\'kron supplies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74114,'Defeat enemy commanders to earn bonus Kor\'kron supplies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74115,'The Alliance are coming aboard!  Get up to the deck and fight for your honor!','',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(74116,'Ring the gong if you wish to accept this challenge. Otherwise, we are done here for now.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(74117,'Tap Keg','Tap Keg',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74118,'Embercores wake from the lava!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74119,'Hey, you\'re not that stinking goat! What do you want with Kil\'rek?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74120,'The Menagerie is for guests only.','',0,0,0,0,0,0,0,0,1,0,37518,0,26124),
(74121,'Do not touch the displays.','',0,0,0,0,0,0,0,0,1,0,37517,0,26124),
(74122,'You are not a guest.','',0,0,0,0,0,0,0,0,1,0,37516,0,26124),
(74123,'Gallery rules will be strictly enforced.','',0,0,0,0,0,0,0,0,1,0,37515,0,26124),
(74124,'Kill these Alliance scum! For the Horde!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74125,'Out of the way, peasant!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74126,'The warchief calls.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74127,'The true horde will rule all of Azeroth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74128,'Tito begins to yip annoyingly!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74129,'Victory is ours!  Get in the cannon and press the attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74130,'My work is not quite finished. This cloak will grant you the power of the celestials.','',0,0,0,0,0,0,1,0,5,0,37406,0,26124),
(74131,'Very soon we will be able to augment your cloak with my own formidable draconic powers.','',0,0,0,0,0,0,1,0,5,0,37407,0,26124),
(74132,'Continue to aid your allies in the war effort. I will contact you shortly!','',0,0,0,0,0,0,1,0,5,0,37408,0,26124),
(74133,'Seer Hao Pham Roo hands you the end of his climbing rope. Tie it to the next Rope Anchor and help him up the mountain!','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(74134,'$C! This area\'s swarming with Kor\'kron. Give us a hand?','$C! This area\'s swarming with Kor\'kron. Give us a hand?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74135,'That\'s the last of them!  Get to the bottom of the ship and plant those explosives!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74136,'He doesn\'t need blades or magic to defeat his enemies. Our next challenger, Hexos, fights his foes with the awesome powers of GEOMETRY!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(74137,'He may be a huge chicken, but he\'ll still put up a fight. It\'s Tyson Sanders!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(74138,'He\'s got two modes. Both modes are labeled \"KILL\". Let\'s hear it for T440!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(74139,'Hope you all like your brawlers extra-crispy! Here comes Anthracite!!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(74140,'What\'s better than an explosion? Lots and lots of explosions, of course! In this corner, we have Big Badda Boom!!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(74141,'Aww... look at the cute little snake, Nibbleh! Go ahead, let him nibble on your toes. Let\'s see what happens.','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(74142,'He\'s not a real doctor, but he\'s going to attempt some facial reconstruction surgery. On his next opponent. Welcome, Doctor FIST!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(74143,'Dust off that luckydo, because you\'re gonna need it. It\'s Grandpa Grumplefloot!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(74144,'No introduction could possibly do our challengers justice. Feast your eyes on the Bear and the Lady Fair!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(74145,'Throw down your weapon and pick up your gloves. It\'s time for a good old-fashioned boxing match. Prepare to be floored by Ty\'thar!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(74146,'He\'s probably the most deadly brawler we\'ve ever had here at the Brawlpub. Unfortunately, he\'s a little out of his element. Everybody raise your glass for Razorgrin!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(74147,'Brawl\'gar veterans may remember Blat, the self-replicating ooze. Today, we meet his meaner, uglier, older sister: Splat!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(74148,'What\'s this? Bruce is back! A better, faster, stronger Bruce! It\'s MECHA-BRUCE!! YAYYYY!!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(74149,'He\'s a strategic mastermind, and he doesn\'t even have a head. Or an elbow, even. It\'s Ro-Shambo! Let\'s give him a hand!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(74150,'Ever wonder what we do with all our obsolete robots? We send them to their deaths in bloody gladiatorial arenas, of course! Here comes Blingtron 3000!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(74151,'He\'s never seen an opponent that he wouldn\'t fight. Ah, small correction: he\'s never seen an opponent. He\'s the Blind Hero!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(74152,'Float like a dragonhawk, sting like a scorpid!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(74153,'Ya, mon! I\'m da best there ever was!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74154,'Everyone got a plan until dey get punched in da tusks...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74155,'An\' stay down dis time!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74156,'Dis is Ty\'thar\'s house!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74157,'I never seen such speed before...','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(74158,'My bling is blung...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74159,'I\'ll archeologize yer skull, $glad:lassie;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74160,'Will you help an old man retrace the steps of the last emperor?','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74161,'I am ready to help you walk the path.','I am ready to help you walk the path.',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74162,'Bury me with me shovel...\nLiterally...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74163,'CAN YOU DIG IT?!?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74164,'Who\'s the obsolete one now?','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(74165,'%s appears to be weeping.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74166,'I will find you...','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(74167,'The sound of death... so sweet to my ears...','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(74168,'What is this sensation? Is that... a light...?','',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(74169,'%s appears unstable.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74170,'The doctor is out...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74171,'When all you have is your fists, everything looks like a face.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74172,'You are now being judged.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74173,'I wield... the LIGHT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74174,'You test my faith.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74175,'The Light is my shield.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74176,'You fought... with... valor...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74177,'You now face your doom.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74178,'Too slow, mortal.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74179,'Grkkk!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74180,'Cock-a-doodle-DIE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74181,'B-gawkk!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74182,'Help us fend off these Alliance dogs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74183,'More are swinging over.  It looks like this is the last of \'em!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74184,'Zephyr increases your movement speed - share this effect with Seer Hao Pham Roo by walking beside him.','Zephyr increases your movement speed - share this effect with Seer Hao Pham Roo by walking beside him.',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(74185,'Please, keep your voice low, $r. I was sent here by Baine Bloodhoof to keep an eye on events in the Vale.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74186,'I am a simple tauren. Baine and I have been friends for a long time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74187,'Come with us, fool. You don\'t want this to get bloody.','Come with us, fool. You don\'t want this to get bloody.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74188,'You are asking for an axe in your back. Drop the weapon, now.','You are asking for an axe in your back. Drop the weapon, now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74189,'Where do you think you\'ll run to? The Kor\'kron control this city.','Where do you think you\'ll run to? The Kor\'kron control this city.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74190,'You don\'t want to force the hand of the warchief.','You don\'t want to force the hand of the warchief.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74191,'Look at this dishonorable creature. You smell of straw.','Look at this dishonorable creature. You smell of straw.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74192,'I am going to enjoy crushing your spirit.','I am going to enjoy crushing your spirit.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74193,'|TInterface\\Icons\\inv_misc_pocketwatch_01:20|t Bonus Objective Started: Defeat all enemies before time runs out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74194,'|TInterface\\Icons\\inv_misc_pocketwatch_01:20|t Bonus timer started!','|TInterface\\Icons\\inv_misc_pocketwatch_01:20|t Bonus timer started!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74195,'I got to practice.\n \n<Points at you tool in hand.>\n \nIf you\'re not practicing, you should be practicing. So keep practicing. \n \nThat\'s the only way you are going to get better, to get better at anything. \n \nPractice. Practice. Practice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74196,'When I grow up, I want to be the bestest Shaman in the world!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74197,'The two paths of sha corruption in Dread Wastes both seem to be in very straight lines.  I wonder where they are heading?  Curious.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74198,'Sometimes things happen because someone said a thing had to happen.  It makes keeping history straight a little difficult... but we make do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74199,'Do not dwell on lost friends and companions for too long.  Perhaps it is best to feel honored that you had the privilege of sharing an experience with them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74200,'Have you heard of the Isle of Thunder? Dark portents reach us even here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74201,'It is said that the Thunder King\'s armies are vast and powerful. Do you think that the battle will ever reach us here?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74202,'We are a peaceful people, but awaken the warriors within us, and we will fight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74203,'I have heard tell of many dangerous enemies and creatures on the Isle of Thunder. It seems that every day, the threat changes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74204,'Help us fend off these Horde pigs!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74205,'More are swinging over.  It looks like this is the last of \'em!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74206,'I live by the ways of the new travelers to Pandaria. \"Keep yer powder dry and yer ale cold!!\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74207,'This rocket will take you all the way to Badlands, which is very far away.  Are you sure?','This rocket will take you all the way to Badlands, which is very far away.  Are you sure?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74208,'|TInterface\\Icons\\inv_misc_pocketwatch_01:20|t Bonus Objective: Rescue all scouts and stop the summoned storm!','|TInterface\\Icons\\inv_misc_pocketwatch_01:20|t Bonus Objective: Rescue all scouts and stop the summoned storm!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74209,'|TInterface\\Icons\\inv_misc_pocketwatch_01:20|t Bonus Objective: Defeat Borokhula the Destroyer!','|TInterface\\Icons\\inv_misc_pocketwatch_01:20|t Bonus Objective: Defeat Borokhula the Destroyer!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74210,'|TInterface\\Icons\\inv_misc_pocketwatch_01:20|t Bonus Objective: Defeat the Abomination of Anger!','|TInterface\\Icons\\inv_misc_pocketwatch_01:20|t Bonus Objective: Defeat the Abomination of Anger!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74211,'Enjoy de rock, mon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74212,'Hello friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74213,'I\'ve never worked a day in my life. That\'s just one of the many benefits of being nocturnal!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74214,'','I\'d rather be reading!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74215,'I\'m learning how to speak Hozen, ookin\' Wikkets! Jae-Sun Di Fo eated all my slickies. For that, I\'ll grook him in the dookers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74216,'For Hellscream!','For Hellscream!',0,0,0,0,0,0,0,0,1,0,39091,39091,26124),
(74217,'Death to the enemies of the true Horde!','Death to the enemies of the true Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74218,'No one shall withstand our might!','No one shall withstand our might!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74219,'We will purge this land!','We will purge this land!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74220,'The eyes of Hellscream are upon us!','The eyes of Hellscream are upon us!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74221,'Victory or death!','Victory or death!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74222,'We will grind you under our heels!','We will grind you under our heels!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74223,'You do not deserve to live, weakling.','You do not deserve to live, weakling.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74224,'Death to Vol\'jin and all of his allies!','Death to Vol\'jin and all of his allies!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74225,'For the true Horde!','For the true Horde!',0,0,0,0,0,0,0,0,1,0,39090,39090,26124),
(74226,'','What an interesting door.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74227,'','I never imagined such a world.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74228,'','Good to see you again. Have we met?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74229,'','What an odd outcome.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74230,'','This world is so different.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74231,'','I must be going, there is so much to see.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74232,'','The possibilities are infinite.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74233,'','Me? Oh, I\'m not from around here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74234,'|TInterface\\Icons\\ability_creature_poison_04:20|t%s coats his daggers with |cFFFF0000|Hspell:143224|h[Instant Poison]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74235,'|TInterface\\Icons\\ability_rogue_deviouspoisons:20|t%s coats his daggers with |cFFFF0000|Hspell:143239|h[Noxious Poison]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74238,'The Conduit is at full energy and Lei Shen disconnects!','',0,0,0,0,0,0,0,0,1,0,35589,0,26124),
(74239,'A strange creature. What precious things will I find on your corpse?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74240,'This seems urgent, Kadrak. There must be another way!','This seems urgent, Kadrak. There must be another way!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74241,'Very well, $n. I\'ll meet you there.','',0,0,0,0,0,0,0,0,1,0,3980,0,26124),
(74242,'The Alliance is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74243,'The Horde is near victory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74244,'The Alliance is victorious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74245,'The Horde is victorious!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74246,'Foolish creature. Taste the true sting of the desert.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74247,'You will die like the other Frostwolf filth.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74248,'Thought I was dead, eh?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74249,'I defy death and you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74250,'Your blades are no match for our cunning.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74251,'You may not be a Frostwolf, but you WILL bleed like them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74253,'[Call his bluff] Why don\'t WE wait until YOU attack Orgrimmar, and then mop up YOUR dead?','[Call his bluff] Why don\'t WE wait until YOU attack Orgrimmar, and then mop up YOUR dead?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74254,'<Vol\'jin sees his opportunity slipping away. He holds up his hands.>$b$bWait now, $r! Orgrimmar be a fortress. My people, we ain\'t gonna crack dat nut on our own. How long we gonna last out here? Days? Weeks? Vol\'jin can\'t say.$b$bYou keep da supplies comin\', an\' I promise, more Kor\'kron gonna die. Before ya troops even land! The blood bein\' spilt ain\'t even ya own! Surely dat be worth a few crates of meat?','',274,5,1,0,0,0,0,0,1,0,0,0,26124),
(74256,'Good, $r. Many Kor\'kron gonna die thanks to ya help.','',1,0,0,0,0,0,0,0,1,924,0,0,26124),
(74257,'This\'ll keep da rebellion around a little longer. Orgrimmar will fall!','',1,0,0,0,0,0,0,0,1,924,0,0,26124),
(74258,'Dese be strange times... Thanks, $r. We gonna spill a lot of Kor\'kron blood wit\' dis.','',1,0,0,0,0,0,0,0,1,924,0,0,26124),
(74259,'More supplies! De Alliance be like a machine. Soon we cut our way through Garrosh\'s goons... A lotta orcs done picked the wrong side.','',1,0,0,0,0,0,0,0,1,924,0,0,26124),
(74260,'You good, $r! We gonna crush Garrosh\'s army wit\' dis!','',1,0,0,0,0,0,0,0,1,924,0,0,26124),
(74261,'Hatock, son of the Iron Wolf! I come for your head.','',0,0,0,0,0,0,53,0,5,0,44104,0,26124),
(74262,'Frostwolves! Kill the gronn! Find the coward!','',0,0,0,0,0,0,0,0,1,0,44105,0,26124),
(74263,'I WILL HAVE MY REVENGE!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74264,'Seek out Lien Farner. He\'ll be able to train you in any profession.','Seek out Lien Farner. He\'ll be able to train you in any profession.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(74265,'|cFFFE1CF7|Hspell:139267|h[Reliquary Pick]|h|r Special artifacts revealed!','|cFFFE1CF7|Hspell:139267|h[Reliquary Pick]|h|r Special artifacts revealed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74266,'+5 Artifact Bonus!','+5 Artifact Bonus!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74267,'+10 Artifact Bonus!','+10 Artifact Bonus!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74268,'Urtharges\' death severely wounds the remaining elementals!','Urtharges\' death severely wounds the remaining elementals!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74269,'%s detects a cluster of injured enemies and goes into a  |cFFFF0404|Hspell:143440|h[Blood Frenzy]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74270,'%s begins to heal himself with |cFFFF0000|Hspell:141423|h[Hekima\'s Wisdom]|h|r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74271,'','My thanks for your assistance, champions. I will tend to the slain and wounded here before returning to Ironforge.',396,0,0,0,0,0,273,0,1,0,0,0,26124),
(74272,'Hold still pup. At this range it wouldn\'t take much to pierce that armor.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(74273,'Ga\'nar, we caught Durotan\'s tracker.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(74274,'More vermin come to infest our sacred grounds.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(74275,'Durotan must have sent $Ghim:her; for a reason.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(74276,'Bah. Let me show you what I think of my brother\'s \"message\".','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(74277,'Hold still demon. At this range it wouldn\'t take much to pierce that armor.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74278,'Ga\'nar, we caught Durotan\'s green orc tracker that has been tracking us.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(74279,'More corrupted filth. As if this scorpar infestation were not enough.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74280,'That green skin of yours marks you as the aberration you are. You are no more orc than the filth at the bottom of this pit.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74281,'Do you hear the howling winds? It is a lonely sound. Make no mistake - if you are not careful, the land will claim you for its own.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74282,'Ye\'ll want ta seek out Wembil Taskwidget, just along the south road.\n\nHe can help ye with any profession ye\'re interested in!','Ye\'ll want ta seek out Wembil Taskwidget, just along the south road.\n\nHe can help ye with any profession ye\'re interested in!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74283,'You want Nedric Sallow, in the inn.\n\nHe\'s just to the right of the stairs down.','You want Nedric Sallow, in the inn.\n\nHe\'s just to the right of the stairs down.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(74284,'Look for Runda.\n\nShe\'s usually just north of the barracks entrance.','Look for Runda.\n\nShe\'s usually just north of the barracks entrance.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(74285,'Seek out Iranis Shadebloom.\n\nYou\'ll find him inside the inn, on the main floor.','Seek out Iranis Shadebloom.\n\nYou\'ll find him inside the inn, on the main floor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74286,'Look for Saren, in the Falconwing Square inn.\n\nYou\'ll find him upstairs, near the kitchens.','Look for Saren, in the Falconwing Square inn.\n\nYou\'ll find him upstairs, near the kitchens.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(74287,'Valn can aid you.\n\nSeek him out on the south side of Azure Watch.','Valn can aid you.\n\nSeek him out on the south side of Azure Watch.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(74288,'Ga\'nar\'s impatience could tear the Frostwolves apart. It is just like my brother to put his own needs above the clan.','',0,0,0,0,0,0,396,0,5,0,45234,0,26124),
(74289,'[Line Deleted] Help him, $p. You will not be able to turn him from his path of vengeance, and it is dangerous to try.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(74290,'Don\'t worry. This hero will convince Ga\'nar to return. Your brother values strength, and my friend possesses that in abundance.','',0,0,0,0,0,0,396,0,1,0,46371,0,26124),
(74291,'I fear the cost of Ga\'nar\'s impatience will be Frostwolf blood.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(74292,'But then, Ga\'nar has always put his own needs before the clan.','',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(74293,'The bones of the Ancient Clefthoof stir to life!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74294,'May I have another racing ram?','May I have another racing ram?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(74295,'Noooo! You fool! The ritual grows... out of... control...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74296,'Who dares to interrupt my magiks?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74297,'You need to be on a racing ram to receive a keg! Return to Neill Ramstein and ask for another.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74298,'You need to be on a racing ram to receive a keg! Return to Ram Master Ray and ask for another.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74299,'What do you want?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74300,'[%s] confesses: When my allies get mind controlled, I try really hard to kill them.','[%s] confesses: When my allies get mind controlled, I try really hard to kill them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74301,'[%s] confesses: I don\'t use the strongest battle pets. Just the cutest ones.','[%s] confesses: I don\'t use the strongest battle pets. Just the cutest ones.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74302,'[%s] confesses: I get heart of the wild and the other heart of the wild confused.','[%s] confesses: I get heart of the wild and the other heart of the wild confused.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74303,'[%s] confesses: I always ask someone else how to reforge my gear.','[%s] confesses: I always ask someone else how to reforge my gear.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74304,'[%s] confesses: I inspect others to see if they are inspecting me.','[%s] confesses: I inspect others to see if they are inspecting me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74305,'[%s] confesses: When pandaren tell me to slooow doooown, I just want to punch them.','[%s] confesses: When pandaren tell me to slooow doooown, I just want to punch them.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74306,'[%s] confesses: I always sell all of my old gear to the same vendor. Dude\'s rich or something.','[%s] confesses: I always sell all of my old gear to the same vendor. Dude\'s rich or something.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74307,'[%s] confesses: I care more about transmogrification gear than upgrade gear.','[%s] confesses: I care more about transmogrification gear than upgrade gear.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74308,'[%s] confesses: I can\'t decide between Horde and Alliance. Horde has goblin mages with quad-pigtails but Alliance has dwarf priests with twirly braids.','[%s] confesses: I can\'t decide between Horde and Alliance. Horde has goblin mages with quad-pigtails but Alliance has dwarf priests with twirly braids.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74311,'|TInterface\\Icons\\spell_frost_summonwaterelemental.blp:20|t%s begins to cast |cFFFF0000|Hspell:143309|h[Swirl]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74312,'|TInterface\\Icons\\ability_shawaterelemental_split.blp:20|t%s |cFFFF0000|Hspell:143020|h[Splits]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74313,'A frostwolf pup excitedly nips at your ankles before falling in step with your stride.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74314,'','|TInterface\\Icons\\sha_spell_fire_blueflamestrike:20|t%s focuses her |cFFFF0000|Hspell:143602|h[Meditation Spikes]|h|r at $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74315,'|TInterface\\Icons\\ability_shawaterelemental_reform.blp:20|t%s |cFFFF0000|Hspell:143469|h[Reforms]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74316,'Ga\'nar! It is about time you returned. What grisly trophies are these?','',0,0,0,0,0,0,0,0,7,0,45203,0,26124),
(74317,'I have slain the sons of the Iron Wolf. He drowns in the blood of his own.','',0,0,0,0,0,0,1,0,7,0,44070,0,26124),
(74318,'Your fool crusade left us exposed to attack. Many died.','',0,0,0,0,0,0,25,0,7,0,45204,0,26124),
(74319,'You are no Chieftain of mine, brother. By my rights as second son, by the justice I have dealt today, I declare mak\'gora.','',0,0,0,0,0,0,274,0,7,0,44071,0,26124),
(74320,'It has come to this.','',0,0,0,0,0,0,0,0,7,0,45206,0,26124),
(74321,'AWESOME IN-GAME EVENT','AWESOME IN-GAME EVENT',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74322,'','You must not do this! You are family!',0,0,0,0,0,0,5,0,7,0,0,44699,26124),
(74323,'Family looks to its own! Only I cared to avenge our father\'s death!','',0,0,0,0,0,0,15,0,7,0,44072,0,26124),
(74324,'Vengeance neither feeds nor protects our clan. Do you not see why father chose me as his heir when our eldest brother went missing?','',0,0,0,0,0,0,0,0,7,0,45207,0,26124),
(74325,'Father chose wrong. This clan needs strength!','',0,0,0,0,0,0,0,0,7,0,44073,0,26124),
(74326,'End it.','',0,0,0,0,0,0,0,0,7,0,44074,0,26124),
(74327,'Chieftain.','',0,0,0,0,0,0,2,0,7,0,44075,0,26124),
(74328,'Her presence defiles Frostwolf honor. The other clans will spit upon us.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74329,'Those who cannot stand... deserve... to... die! [PH - Targets Draka and is about to charge.]','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74330,'Vengeance does not make our clan strong.','',0,0,0,0,0,0,6,0,7,0,45209,0,26124),
(74331,'Rise up, brother. I need you. This clan needs you.','',0,0,0,0,0,0,0,0,7,0,45211,0,26124),
(74332,'The strength that comes from protecting the ones you love.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74333,'We are a family, Ga\'nar. Family stands together.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74334,'THAT is what makes the Frostwolves strong.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74335,'Come stand with us, brother. Join your forces with us. There is much work to be done.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74336,'Enough! I yield.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74337,'I guess you aren\'t a pushover.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74338,'Lok\'tar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74339,'You don\'t belong here! Urtok is going to teach you a lesson about strength!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74340,'I lost? How could this be?','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74341,'Yes, brother. I would welcome you with open arms.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74342,'Still alive, pup? I guess I won\'t have to save you after all. Come, we should talk.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(74343,'Oh, and try not to die. Scorpar are unkind to corpses.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74344,'Your corpse will be of great use to me. Hair, flesh, and bone. So many concoctions I could make.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74345,'Why have you come? Was it for your precious wolf pups? Their flesh is mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74346,'I am proud, but I admit you bested me, brother. I wish to learn more of your strength. We shall rejoin you.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74347,'Such... power...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74348,'|TInterface\\Icons\\ability_warrior_offensivestance.blp:20|t General Nazgrim assumes a |cFFFF0000|Hspell:143589|h[Battle Stance]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74349,'|TInterface\\Icons\\ability_warrior_defensivestance.blp:20|t General Nazgrim assumes a |cFFFF0000|Hspell:143593|h[Defensive Stance]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74350,'|TInterface\\Icons\\ability_racial_avatar.blp:20|t General Nazgrim assumes a |cFFFF0000|Hspell:143594|h[Berserker Stance]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74351,'Give me money for cool things','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(74352,'Rifleman','Rifleman',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(74353,'The carcass looks fresh and largely un-carved, with the exception of six careful incisions on the belly.$B$BBehind each incision you find a large cavity where some critical organ may once have been housed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74354,'|TInterface\\Icons\\ability_priest_pathofthedevout:20|t%s begins to cast |cFFFF0000|Hspell:143497|h[Bond of the Golden Lotus]|h|r.','|TInterface\\Icons\\ability_priest_pathofthedevout:20|t%s begins to cast |cFFFF0000|Hspell:143497|h[Bond of the Golden Lotus]|h|r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74355,'Xaril hurls blue catalyst around the room!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74356,'Xaril hurls red catalyst around the room!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74357,'Xaril hurls yellow catalyst around the room!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74358,'Xaril hurls orange catalyst around the room!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74359,'Xaril hurls purple catalyst around the room!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74360,'Xaril hurls green catalyst around the room!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74361,'Hold!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74362,'Ga\'nar? Is that you? I thought we killed you already.','',0,0,0,0,0,0,0,0,1,0,46952,0,26124),
(74363,'Or did you like it so much the first time you decided to come back for more?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74364,'Have you come sniffing for a place among the Thunderlords? Hrah hah hah!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74365,'If you beg like a good dog, my father may-','',0,0,0,0,0,0,0,0,1,0,46953,0,26124),
(74366,'Your father MAY be able to identify what\'s left of your tiny skull.','',0,0,0,0,0,0,0,0,5,0,44088,0,26124),
(74367,'Hrgh... K-... KILL THEM!!','',0,0,0,0,0,0,0,0,1,0,46954,0,26124),
(74368,'Brothers! Today, we do what Durotan will not!','',0,0,0,0,0,0,5,0,5,0,0,0,26124),
(74369,'The scorpar are at bay and our mounts are ready, old friend.','',0,0,0,0,0,0,396,0,5,0,0,0,26124),
(74370,'Today, we take vengeance on the beast who killed Garad!','',0,0,0,0,0,0,4,0,5,0,0,0,26124),
(74371,'Let\'s ride!','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(74377,'Ga\'nar, the Thunderlord clan trains their hunters in the canyon this time year.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74378,'Pah! Thunderlord filth. Not enough room for all of them in that carcass they call home?','',0,0,0,0,0,0,6,0,1,0,0,0,26124),
(74379,'We\'ll carve right through them if we have to.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74380,'This warrior died from several puncture marks across his body. He was positioned in a ceremonious and caring fashion before set ablaze.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74381,'Please... KILL ME...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74382,'The magic... it burns ... AUUUUGGGHHHHHH!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74383,'Stop, my brothers! Do you not see the beast of burden before you?','',0,0,0,0,0,0,25,0,1,0,38927,0,26124),
(74385,'We must consume his flesh, for he is weak! The cycle must continue!','',0,0,0,0,0,0,1,0,1,0,38929,0,26124),
(74386,'Yes! Consume him! Meat and bone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74387,'By the blood of Kros!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74388,'Taste his flesh! Drink his blood!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74389,'Strength to the Skumblade!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74390,'Do you not see the light of Kros? He has been defiled!','',0,0,0,0,0,0,5,0,1,0,38928,0,26124),
(74391,'The Door is under attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74392,'Durok? What foul sorcery is this?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74393,'My brother is gone, and only this creature remains. It must be destroyed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74394,'I will destroy this foul altar while you deal with Kurak\'akan.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74395,'Welcome to Frostwind.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(74396,'Hear me, Thunderlords! I am Ga\'nar of the Frostwolves! Son of Garad!','',0,0,0,0,0,0,0,0,1,0,44090,0,26124),
(74397,'Your chief slew my father. So I have come to claim the heads of his sons. Who among you has the spine to stop me?','',0,0,0,0,0,0,0,0,1,0,44091,0,26124),
(74398,'Ready yourselves...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74399,'Ga\'nar, there is no denying the worth of the outsider.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74400,'Ha! Urtok, go lick your wounds. You, pup, are taking his place. Soon we will ride to avenge my father. When we succeed, I shall go to Durotan myself.','',11,1,0,0,500,0,0,0,1,0,0,0,26124),
(74401,'You may ride with us, but you\'ll ride as we do, or not at all--on a beast from these very hills.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74402,'Exiles! It is time for us to ride! Behold our new friend\'s... mount!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74403,'To the canyon! To glory!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74404,'Magic Dude','Magic Dude',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(74405,'AoE Dude','AoE Dude',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(74406,'Snare Dude','Snare Dude',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(74407,'Come $r, I ride for the exile camp immediately.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74408,'I must tell Ga\'nar what we have witnessed.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74409,'We knew the scorpar were a vile infestation, but we never knew how they were able to grow their numbers.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74410,'No matter. Kurak\'akan is slain, thanks to you. The threat of the Kuraki scorpar lay in ruin.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74411,'Ga\'nar must hear of your deeds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74412,'Brothers, look. An outsider.','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(74413,'Vragor! Who\'s the runt?','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(74414,'No mutt, Chieftain. I vouch for this stranger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74415,'What\'s this mutt you\'ve dragged to my doorstep, Vragor?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74416,'Forward, brothers and sisters! Cut through the camp and rally at the Savage Crag!','',0,0,0,0,0,0,0,0,5,0,44102,0,26124),
(74417,'Lok\'tar ogar!','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(74418,'Lok\'tar ogar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74419,'Lok\'tar ogar!','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(74420,'Bet I can kill more gronn than you, brother.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(74421,'Eat up, boys! We\'ve got gronn to kill.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(74422,'Sharpen the blades, sharpen the blades...','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(74423,'Nice and pointy. Perfect for stabbing a gronn in the eye or a Thunderlord in the chest.','',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(74424,'Stop $Ghim:her;!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74425,'Don\'t let $Ghim:her; through!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74426,'Don\'t let $Ghim:her; escape!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74427,'Psssst! Meatbag, over here!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74428,'I can smell them. They stink of fear.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74429,'Such hunger...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74430,'You! Come over here, give us just a taste...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74431,'Stop, my brothers! Do you not see the beast of burden before you?','',0,0,0,0,0,0,5,0,1,0,38927,0,26124),
(74432,'What\'s going on in here? Get that thing back in its cage!','',0,0,0,0,0,0,5,0,1,0,38985,0,26124),
(74433,'Intruders! I will lock you in a cell with the rest of the filth.','',0,0,0,0,0,0,5,0,1,0,39032,0,26124),
(74434,'Stop this madness! You have no idea what you\'re dealing with!','',0,0,0,0,0,0,5,0,1,0,38986,0,26124),
(74435,'<Ga\'nar is mustering his strength to challenge the enormous gronn.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74436,'<Assist Ga\'nar in battle.>','<Assist Ga\'nar in battle.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74437,'Great beast of burden, heed my call!','',0,0,0,0,0,0,1,0,1,0,38930,0,26124),
(74438,'I have come to return you to Kros! Surrender your flesh to me!','',0,0,0,0,0,0,1,0,1,0,38931,0,26124),
(74439,'Bro, my pet is going to incinerate you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74440,'My menagerie will eat the flesh from your bones.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74441,'Burn them all! Burn them to ash!','',0,0,0,0,0,0,0,0,1,0,39142,0,26124),
(74442,'Then it is time.','',0,0,0,0,0,0,396,0,5,0,0,0,26124),
(74443,'As for you, outsider...','',0,0,0,0,0,0,397,0,5,0,0,0,26124),
(74446,'You\'ll ride the loaner. Hrah hah hah!','',0,0,0,0,0,0,153,0,5,0,0,0,26124),
(74447,'You have earned a place in this raid. And since you haven\'t yet bonded with a frostwolf of your own...','',0,0,0,0,0,0,396,0,5,0,0,0,26124),
(74448,'Thank you, friends. I will lend what aid I can.','',0,0,0,0,0,0,1,0,1,0,38933,0,26124),
(74449,'%s reels in pain and leers angrily at $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74450,'%s |cFFFF0404|Hspell:143445|h[Fixates]|h|r on you!','%s |cFFFF0404|Hspell:143445|h[Fixates]|h|r on you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74451,'My death means nothing. You cannot quell the storm!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74452,'You cannot stop us... as long as Kurak\'akan lives!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74453,'Fool, you have achieved nothing! Our true power lies in the valley to the north.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74454,'Their hunting camp stands directly between us and the gronn caves.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74455,'%s bolts at the first sign of trouble!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74456,'Ga\'nar can be a bit... brash. Especially now while he is so at ends with his brother.$b$bIt would be best not to take his kicking you down this hole personally.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74457,'Tell Vragor why Durotan sent you.','Tell Vragor why Durotan sent you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74458,'<The spider peers at you menacingly.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74459,'Begin pet battle.','Begin pet battle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74460,'You are trying to unite the Frostwolves? Well then we share a common goal. I have known Ga\'nar and Durotan since they were born, and I can tell you it will take more than words to get them to come together again.$b$bGa\'nar must finish what he started. He intends to avenge his father\'s death, and there is not a voice in this world or the next that will convince him to stray from this goal.$b$bSo, instead of fighting him, I choose to help him and increase his chances of success.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74461,'Many of our riders are still crossing the dunes behind us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74462,'Hold here until reinforcements arrive. In the meantime, let us draw out as many as we can...','',0,0,0,0,0,0,0,0,1,0,44089,0,26124),
(74463,'Wraaugh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74464,'I\'m not THAT snarky, am I?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74465,'I got a bone to pick wit\' you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74466,'Why don\'t I dance at parties? I have no body to dance wit\'!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74467,'What kind of spirit haunts a chicken coop? A poultry geist!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74468,'I know my jokes ain\'t so good... I lost my funny bone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74469,'You ain\'t foolin\' nobody, ghosty! I can see right through you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74470,'I was bone to be wild!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74471,'Who just called me a numbskull?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74472,'Maybe I\'m a bit of a bonehead...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74473,'Sorry for ribbin\' ya so much.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74474,'Sometimes you gotta be sternum with unruly ghosts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74475,'I used to be more humerus.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74476,'Want to hear somethin\' funny? Coccyx.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74477,'Who needs a body when your jokes got legs?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74478,'Ya know... my heart really ain\'t in it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74479,'They didn\'t leave me with a leg to stand on!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74480,'Ghosts must get cold. The wind goes straight through \'em!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74481,'I always wanted to play the organ.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74482,'I love you wit\' every bone in my body!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74483,'I\'m bonin\' up on my spirit lore.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74484,'Say anythin\', it won\'t get under my skin!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74485,'Sticks and stones may break my bones...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74486,'I thought about askin\' her out but I didn\'t have the guts.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74487,'I\'m not sure I have the stomach for this...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74488,'Hey, meat sack! If you got five minutes, come talk to me! I got no body!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74489,'Good deal. Welcome to the spirit world. Kinda. Let\'s check out the chests for any goodies, and see if you can find my body somewhere!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74490,'In the meantime, let us draw out as many as we can...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74491,'You fought well against Urtok. Let\'s see if those tricks work against a gronn.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(74492,'Durotan sent you? He should have come himself. We are avenging HIS father after all.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(74493,'I remember the first time I had to feed the wolves. Nearly lost my hand in the process.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(74494,'The scouts found Kolloc on the other side of the Bladespire Oasis. Be ready to head out soon.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(74495,'They say the Thunderlord are between us and the gronn. They should be a nice warm up. Ha!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(74496,'A $c hmm? How are you in a real fight?','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(74497,'I remember my first ride with Ga\'nar. Nearly lost my eye. A good day!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(74498,'It will take more than a pittance of meat to win over the heart of a true Frostwolf. Though it doesn\'t hurt.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(74502,'Still alive, pup? Come, we must reach Ga\'nar before he finishes marshaling his forces.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74503,'I have no time for this. Urtok, get this filth out of my sight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74504,'Iyyokuk begins choosing criteria from $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74505,'Kor\'kron, at my side!','',0,0,0,0,0,0,0,0,1,0,38198,0,26124),
(74506,'Warriors, on the double!','',0,0,0,0,0,0,0,0,1,0,38199,0,26124),
(74507,'Next squad, to the front!','',0,0,0,0,0,0,0,0,1,0,38200,0,26124),
(74508,'Defend the gate!','',0,0,0,0,0,0,0,0,1,0,38201,0,26124),
(74509,'Rally the forces!','',0,0,0,0,0,0,0,0,1,0,38202,0,26124),
(74510,'All Kor\'kron... under my command... kill them... NOW!','',0,0,0,0,0,0,0,0,1,0,38203,0,26124),
(74511,'Save your breath, pup. I have no time for Durotan\'s whining. We are here to do the job he was unwilling to do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74512,'Iyyokuk selects: Sword |TInterface\\Icons\\ABILITY_IYYOKUK_SWORD_white.BLP:20|t!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74513,'Iyyokuk selects: Drum |TInterface\\Icons\\ABILITY_IYYOKUK_DRUM_white.BLP:20|t!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74514,'Iyyokuk selects: Bomb |TInterface\\Icons\\ABILITY_IYYOKUK_BOMB_white.BLP:20|t!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74515,'Iyyokuk selects: Mantid  |TInterface\\Icons\\ABILITY_IYYOKUK_MANTID_white.BLP:20|t!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74516,'Iyyokuk selects: Staff  |TInterface\\Icons\\ABILITY_IYYOKUK_STAFF_white.BLP:20|t!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74517,'Iyyokuk selects: |cFFFF0000Red|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74518,'Iyyokuk selects: |cFFFF00FFPurple|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74519,'Iyyokuk selects: |cFF0000FFBlue|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74520,'Iyyokuk selects: |cFF00FF00Green|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74521,'Iyyokuk selects: |cFFFFFF00Yellow|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74522,'Iyyokuk selects: One!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74523,'Iyyokuk selects: Two!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74524,'Iyyokuk selects: Three!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74525,'Iyyokuk selects: Four!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74526,'Iyyokuk selects: Five!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74527,'|TInterface\\Icons\\spell_nature_diseasecleansingtotem.blp:20|t The Dark Shaman drop |cFFFF0000|Hspell:144288|h[Poisonmist Totems]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74528,'|TInterface\\Icons\\spell_nature_natureresistancetotem.blp:20|t The Dark Shaman drop |cFFFF0000|Hspell:144289|h[Foulstream Totems]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74529,'|TInterface\\Icons\\spell_frost_fireresistancetotem.blp:20|t The Dark Shaman drop |cFFFF0000|Hspell:144290|h[Ashflare Totems]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74530,'|TInterface\\Icons\\spell_shaman_totemrecall.blp:20|t The Dark Shaman drop |cFFFF0000|Hspell:144291|h[Rusted Iron Totems]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74531,'|TInterface\\Icons\\spell_nature_bloodlust.blp:20|t The Dark Shaman gain |cFFFF0000|Hspell:144302|h[Bloodlust]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74532,'The Dark Shaman go into a berserker rage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74538,'Lunk loves to play on seesaw!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(74539,'Please let someone else have a turn, Lunk.','Please let someone else have a turn, Lunk.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74540,'The statue softly hums as you approach.','The statue softly hums as you approach.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74541,'The statue lies dormant.','The statue lies dormant.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74542,'Touch the statue.','Touch the statue.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74544,'','Is our shipment of juicycrunch carrots ready to be picked up?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74545,'','Here they are! These are beautiful, $n. The Kirin Tor Offensive is in your debt.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74546,'','I\'ve come for our order of Scallions.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74547,'','This is more than I expected, $c. The Sunreaver Onslaught thanks you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74548,'Xaril the Poisoned-Mind prepares several white catalyst potions to throw at his enemies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74549,'Start Basic Tank (Bronze)','Start Basic Tank (Bronze)',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74550,'Start Basic Tank (Endless)','Start Basic Tank (Endless)',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74551,'Start Basic Tank (Gold)','Start Basic Tank (Gold)',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74552,'Start Basic Tank (Silver)','Start Basic Tank (Silver)',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74553,'|TInterface\\Icons\\inv_misc_sawblade_01.blp:20|t Siegecrafter Blackfuse faces you and readies |cFFFF0000|Hspell:143266|h[Launch Sawblade]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74554,'As you approach the crystal, you can feel its potent energy. Some nearby sprites glare dubiously in your direction.','As you approach the crystal, you can feel its potent energy. Some nearby sprites glare dubiously in your direction.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74555,'Destroy the crystal.','Destroy the crystal.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74556,'Ooo oOOo ooOoO','Ooo oOOo ooOoO',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74557,'ooOo Ooo oO OooO','ooOo Ooo oO OooO',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74558,'OOoO','OOoO',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74559,'ooo OoOooO oo','ooo OoOooO oo',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74560,'o OOooO OoooO','o OOooO OoooO',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74561,'O OoO OOoO','O OoO OOoO',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74562,'oOO OOooO','oOO OOooO',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74563,'oOooO OoOo','oOooO OoOo',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74564,'Like you, I could not resist the opportunity to take part of this ancient Pandaren tradition.  When you are ready, let us see how well you can lead your pets in battle.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74565,'','Hello, $n.  My name is Oriana, and I attend the tournament to make sure no pets are grievously injured, and to explain the rules.\n\nYou cannot heal or revive your pets during the tournament.  If you run out of pets to use in battle, you can leave and enter the tournament again.\n\nIf you lose to a challenger, you may fight them again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74566,'Healing your pets will disqualify your current progress in the scenario, and you\'ll have to battle your opponents again.  Are you sure?','Healing your pets will disqualify your current progress in the scenario, and you\'ll have to battle your opponents again.  Are you sure?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74567,'Pay 5 Timeless Coins for 1 Kukuru\'s Kache Key.','Pay 5 Timeless Coins for 1 Kukuru\'s Kache Key.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74568,'Pay 5 Timeless Coins?','Pay 5 Timeless Coins?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74569,'Wise hozen say: All that glitters is not gold. Unless it is gold. Then it glitters.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74571,'Wise hozen say: To seek riches, look within yourself. Or in one of these chests.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74572,'Wise hozen say: Appearances can be deceiving, especially if you have bad eyesight.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74573,'Wise hozen say: Don\'t bite off more than you can chew, unless there are other hungry hozen nearby.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74574,'Wise hozen say: Actions speak louder than words, unless the person is yelling.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74575,'Wise hozen say: If at first you don\'t succeed, get someone else to do it for you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74576,'Wise hozen say: Don\'t put off until tomorrow what you can do... oh nevermind, I\'ll tell you the rest later.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74577,'Welcome, traveler! I have treasure from all across the world.$B$BYou want to test your luck? Only a few timeless coins for a key.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74578,'','Hi there, $n!  It\'s great to see you again.  Everyone is still talking about the last time you won the tournament... I didn\'t get to see all of it, but I had to heal a lot of burns and bruises.  But don\'t worry, they\'re fine now!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74580,'','%s begins to cast |cFFFF0000|Hspell:144590|h[Moonfang\'s Curse]|h|r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74584,'%s shifts back into Assault Mode!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74585,'%s shifts into Siege Mode!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74586,'|TInterface\\Icons\\ability_mage_firestarter.blp:20|t|cFFFF0000Siege Engineers|r appear in the wings and begin to cast |cFFFF0000|Hspell:144616|h[Power Iron Star]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74587,'Steel yourselves, men! We\'re bein\' boarded!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74588,'Look out! Another wave comes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74589,'Fight fer yer lives, mateys! If The Barnacle\'s going down, we\'re going down with her!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74590,'The hammer is warm to the touch.','The hammer is warm to the touch.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74591,'Pick up the hammer.','Pick up the hammer.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74592,'By Firallon\'s beard, what is that thing? Kill it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74593,'We did it men, we saved The Barnacle! Finally, a moment of rest since we entered this forsaken mist. Turn the sails, men. We\'re goin\' home!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74594,'','|cFFFF0000BEWARE:|r Moonfang Dreadhowls now prowl the woods!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74595,'','|cFFFF0000BEWARE:|r Den Mother Moonfang has appeared in the woods!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74596,'','Moonfang, Den Mother of Darkmoon Island, has been slain!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74599,'You hear a mournful howl in the distance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74600,'An anguished howl echoes in the twilight.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74601,'A sorrowful howling floats through the forest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74602,'There is a pained howl from deep within the woods.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74603,'Almost... got... it...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74604,'Well that was unexpected!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74605,'Uhhh.. you can handle this right?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74606,'Oh hello! I was just about to reel in this catch. I have a hunch it\'s going to be a doozy!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74607,'Well what are you waiting for?! Let\'s see!','Well what are you waiting for?! Let\'s see!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74608,'Good! I\'ll just leave you to it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74610,'Anger. Hatred. Fear!! They are weapons of war - the tools of a Warchief!','',0,0,0,0,0,0,0,0,1,0,38048,0,26124),
(74616,'Yes... yes I can see now...I can see the future of this world...a world ruled by the horde...MY horde.','',0,0,0,0,0,0,0,0,1,0,38051,0,26124),
(74617,'Enter my realm.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74619,'Chelon has been engaged by $n the $r $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74621,'|cFFFF0000|Hspell:144985|h[Whirling Corruption]|h|r killed you.  Move away from Garrosh to decrease damage taken.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74622,'My eternal vigil has kept the corruption of pride at bay. To face this corruption yourself you must purify yourselves in the burning light.  This process will not go easily for you.\n\nAre you ready?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74623,'We are ready, Keeper.','We are ready, Keeper.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74624,'Do you wish to begin the Norushen Encounter?','Do you wish to begin the Norushen Encounter?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74625,'Let\'s see how you like the newest addition to the Warchief\'s arsenal... the Iron Star!','',0,0,0,0,0,0,0,0,6,0,38460,0,26124),
(74626,'Oh, look. You\'re the ones that smashed up my Juggernaut.','',0,0,0,0,0,0,0,0,6,0,38459,0,26124),
(74627,'Time to mix business with pleasure.','',0,0,0,0,0,0,0,0,1,0,38445,0,26124),
(74628,'You there, $r! I beg of you, set us free.','',0,0,0,0,0,0,0,0,1,0,39140,0,26124),
(74629,'The strength of my clan will be with you. I swear it.','',0,0,0,0,0,0,0,0,1,0,39141,0,26124),
(74630,'Just open this door.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74631,'Our prayers have been answered!','',0,0,0,0,0,0,1,0,1,0,38932,0,26124),
(74632,'','We must redeem the Vale.',0,0,0,0,0,0,0,0,1,0,0,38418,26124),
(74633,'','You will suffer from our failure.',0,0,0,0,0,0,0,0,1,0,0,38419,26124),
(74634,'','Protectors, come to my aid!',0,0,0,0,0,0,0,0,1,0,0,38420,26124),
(74635,'','Will you succeed where we have failed?',0,0,0,0,0,0,0,0,1,0,0,38413,26124),
(74636,'','We have not fulfilled our oath!',0,0,0,0,0,0,0,0,1,0,0,38421,26124),
(74637,'','We return to when we lost our way. You... are very kind.',0,0,0,0,0,0,0,0,1,0,0,38414,26124),
(74638,'Feeling... better now... Thank you... little friend.','',0,0,0,0,0,0,0,0,1,0,38717,0,26124),
(74639,'Start Basic Healer (Bronze)','Start Basic Healer (Bronze)',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74640,'Start Basic Healer (Endless)','Start Basic Healer (Endless)',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74641,'Start Basic Healer (Gold)','Start Basic Healer (Gold)',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74642,'Start Basic Healer (Silver)','Start Basic Healer (Silver)',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74643,'Rook... not safe...','',0,0,0,0,0,0,0,0,1,0,38728,0,26124),
(74644,'Rook... needs help!','',0,0,0,0,0,0,0,0,1,0,38727,0,26124),
(74645,'Brawl... with Rook.','',0,0,0,0,0,0,0,0,1,0,38725,0,26124),
(74646,'Rook fight!','',0,0,0,0,0,0,0,0,1,0,38726,0,26124),
(74647,'Sun... He... aid me.','',0,0,0,0,0,0,0,0,1,0,38716,0,26124),
(74648,'%s signals for help.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74649,'I\'m sorry, $n, but I\'m not really up for talking.  Leave me in peace.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74650,'','We\'ve made so many sacrifices, and our fight lingers on. These battles have a way of wearing away at my spirit...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74651,'Stay strong, $c.  Hold on tightly to those you love.  We never know how long any of us will have for this world.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74652,'%s enters a meditative pose to heal his wounds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74653,'|TInterface\\Icons\\ability_druid_typhoon:20|t%s enters a |cFFFF0000|Hspell:143559|h[Dark Meditation]|h|r!','|TInterface\\Icons\\ability_druid_typhoon:20|t%s enters a |cFFFF0000|Hspell:143559|h[Dark Meditation]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74654,'Goro\'dan! You\'re on deck!','',0,0,0,0,0,0,0,0,1,0,38449,0,26124),
(74655,'|TInterface\\Icons\\ability_rogue_deadliness:20|t%s creates a |cFFFF0000|Hspell:143840|h[Mark of Anguish]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74656,'Aggron! Show \'em who\'s boss!','',0,0,0,0,0,0,0,0,6,0,38451,0,26124),
(74657,'Alright, Shanna. You\'re up.','',0,0,0,0,0,0,0,0,1,0,38452,0,26124),
(74658,'|TInterface\\Icons\\spell_monk_ringofpeace:20|t%s calls upon |cFFFF0000|Hspell:143955|h[Misery, Sorrow, and Gloom]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74659,'Looks like I\'m in the market for a new assistant.','',0,0,0,0,0,0,0,0,1,0,38453,0,26124),
(74660,'That\'s for the Juggernaut.','',0,0,0,0,0,0,0,0,1,0,38463,0,26124),
(74661,'Another satisfied customer.','',0,0,0,0,0,0,0,0,1,0,38464,0,26124),
(74663,'Presenting... the beautiful new ST-03 Shockwave missile turret!','',0,0,0,0,0,0,0,0,1,0,38471,0,26124),
(74664,'What\'s better than a bomb, huh?! I\'ll tell ya - a bomb with two bombs inside!','',0,0,0,0,0,0,0,0,1,0,38469,0,26124),
(74665,'Meet the LT-403 Evaporation laser. A personal point of pride.','',0,0,0,0,0,0,0,0,1,0,38467,0,26124),
(74666,'Ya\' ever wonder how magnets work?','',0,0,0,0,0,0,0,0,1,0,38468,0,26124),
(74668,'Start the assembly line!','',0,0,0,0,0,0,0,0,1,0,38454,0,26124),
(74669,'The SD-5 Automated Shredder defense unit. A labor of love.','',0,0,0,0,0,0,0,0,1,0,38457,0,26124),
(74670,'Don\'t... think you\'ve won...','',0,0,0,0,0,0,0,0,1,0,38447,0,26124),
(74671,'You are not... my friend...','',0,0,0,0,0,0,0,0,1,0,38724,0,26124),
(74672,'','You too have failed.',0,0,0,0,0,0,0,0,1,0,0,38416,26124),
(74673,'%s nods at his foes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74674,'Hey, I heard you like mines, so... enjoy!','',0,0,0,0,0,0,0,0,1,0,38470,0,26124),
(74675,'Another round!','',0,0,0,0,0,0,0,0,1,0,38455,0,26124),
(74676,'More! More!','',0,0,0,0,0,0,0,0,1,0,38456,0,26124),
(74677,'Unfinished weapons begin to roll out on the assembly line.','Unfinished weapons begin to roll out on the assembly line.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74689,'','Drek\'Thar! I don\'t know what you are doing up there but it is angering the goren to no end.',0,0,0,0,0,0,0,0,7,0,0,41780,26124),
(74690,'Copying','Copying',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74691,'$n has set up a Noodle Cart!','$n has set up a Noodle Cart!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74692,'$n has set up a Noodle Cart!','$n has set up a Noodle Cart!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74693,'$n has set up a Deluxe Noodle Cart!','$n has set up a Deluxe Noodle Cart!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74694,'$n has set up a Deluxe Noodle Cart!','$n has set up a Deluxe Noodle Cart!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74695,'$n has set up a Pandaren Treasure Noodle Cart!','$n has set up a Pandaren Treasure Noodle Cart!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74696,'$n has set up a Pandaren Treasure Noodle Cart!','$n has set up a Pandaren Treasure Noodle Cart!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74697,'TIME TO DRINK ALL THE  KOOL-AID!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74698,'It is not too late, Garrosh. Lay down the mantle of Warchief. We can end this here, now, with no more bloodshed.','',0,0,0,0,0,0,0,0,1,0,38934,0,26124),
(74699,'Then you have forced my hand.  I will correct the mistake I made long ago.  Spirits of the wind, the earth, the water, hear my call!  Come to my aid!','',0,0,0,0,0,0,0,0,1,0,38935,0,26124),
(74700,'Never powerless Garrosh. And never alone.','',0,0,0,0,0,0,0,0,1,0,38936,0,26124),
(74701,'Ha! Do you remember nothing of Honor? Of glory on the battlefield?  You who would parlay with the humans, who allowed warlocks to practice their dark magics right under our feet.  You are weak.','',0,0,0,0,0,0,0,0,1,0,38059,0,26124),
(74702,'We are the Orcish Horde, the True Horde.  We die, bloody and thrashing on the field of battle, like true orcs SHOULD.','',0,0,0,0,0,0,0,0,1,0,38060,0,26124),
(74703,'You are an Orc no longer, and speak for none but yourself. You betrayed our people to forge your fragile alliances, and I will take great pleasure in tearing them apart.','',0,0,0,0,0,0,0,0,1,0,38061,0,26124),
(74704,'Fool. My Dark Shaman have twisted and tortured the elements for miles around. They cannot hear you now. Once again you prove too weak and powerless to do anything.','',0,0,0,0,0,0,0,0,1,0,38062,0,26124),
(74705,'So, you wish to face off against a real Orc Warchief.  So be it.','',0,0,0,0,0,0,0,0,1,0,38063,0,26124),
(74706,'My people should have taken this world long ago, during the First War. But they fell to corruption.  In their weakness, they allowed the pitiful races of Azeroth to join the horde.  I will succeed where they have failed, and no power in this world can stop me!','',0,0,0,0,0,0,0,0,1,0,38045,0,26124),
(74707,'Witness the power of the True Horde\'s arsenal!','',0,0,0,0,0,0,0,0,1,0,38068,0,26124),
(74708,'We will cleanse this world in steel and fire!','',0,0,0,0,0,0,0,0,1,0,38070,0,26124),
(74709,'Warbringers, bloody your blades!  Lok\'tar Ogar!','',0,0,0,0,0,0,0,0,1,0,38071,0,26124),
(74710,'Farseers, mend our wounds!','',0,0,0,0,0,0,0,0,1,0,38072,0,26124),
(74711,'Die with honor!','',0,0,0,0,0,0,0,0,1,0,38075,0,26124),
(74712,'Blood and Thunder!','',0,0,0,0,0,0,0,0,1,0,38074,0,26124),
(74713,'For the True Horde!','',0,0,0,0,0,0,0,0,1,0,38073,0,26124),
(74714,'The power flows through me!','',0,0,0,0,0,0,0,0,1,0,38076,0,26124),
(74715,'The power to crush your world, and everything on it!','',0,0,0,0,0,0,0,0,1,0,38077,0,26124),
(74716,'All will fall in the name of Hellscream!','',0,0,0,0,0,0,0,0,1,0,38069,0,26124),
(74717,'Weak.','',0,0,0,0,0,0,0,0,1,0,38065,0,26124),
(74718,'Pitiful.','',0,0,0,0,0,0,0,0,1,0,38066,0,26124),
(74719,'Now you know your place in my new world.','',0,0,0,0,0,0,0,0,1,0,38067,0,26124),
(74720,'The Old One calls to you!','',0,0,0,0,0,0,0,0,1,0,38052,0,26124),
(74721,'The Heart will be your end!','',0,0,0,0,0,0,0,0,1,0,38053,0,26124),
(74722,'See the visions of fear, despair, and doubt, as I have!','',0,0,0,0,0,0,0,0,1,0,38054,0,26124),
(74723,'You will be trapped for eternity!','',0,0,0,0,0,0,0,0,1,0,38055,0,26124),
(74724,'The True Horde WILL come to pass.  I have SEEN it.  IT HAS SHOWN ME. I HAVE SEEN MOUNTAINS OF SKULLS AND RIVERS OF BLOOD.  AND I WILL...HAVE...MY...WORLD!','',0,0,0,0,0,0,0,0,1,0,38056,0,26124),
(74728,'Rodoh.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74729,'I wish to enter the tournament.','I wish to enter the tournament.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74730,'Can I enter the tournament?','Can I enter the tournament?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74731,'You\'ve done well for yourself, I can see that.  But to enter the Celestial Tournament, you must prove yourself as a leader.  When you have taken fifteen battle pets to their maximum level, you may attempt the trials that await you there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74735,'Karg? Yeah, I saw him. He saved my life - took on five of those filthy Thunderlords by himself.','Karg? Yeah, I saw him. He saved my life - took on five of those filthy Thunderlords by himself.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74736,'He had \'em, too. Until the Iron Wolf showed up riding the biggest, meanest rylak I\'ve ever seen. Snatched him up and carried him away.','He had \'em, too. Until the Iron Wolf showed up riding the biggest, meanest rylak I\'ve ever seen. Snatched him up and carried him away.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74737,'They took others, too. Dragged \'em down into the canyon. Ask around, find out who\'s gone missing.','They took others, too. Dragged \'em down into the canyon. Ask around, find out who\'s gone missing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74738,'','Be careful. This place is sacred, not safe. What I am about to do could get a lot of unwanted attention.',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74739,'','Great spirits of the wind, heed my call! Share with me the source of your pain.',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74740,'','I will try to use my totems to assist you if the need arises.',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74741,'I came to ask the elements for aid in the coming battle.','',0,0,0,0,0,0,0,0,7,0,46644,0,26124),
(74742,'But among the burning, biting winds of the mountains I heard the cry of the fury, Exurotus.','',0,0,0,0,0,0,0,0,7,0,46645,0,26124),
(74743,'Beaten, half consumed, and shattered by ancient magics, the fury is the prisoner of the magnaron Kron.','',0,0,0,0,0,0,0,0,7,0,46646,0,26124),
(74744,'The fury has been fragmented, its pieces scattered on the wind or consumed by scavengers.','',0,0,0,0,0,0,0,0,7,0,46647,0,26124),
(74745,'My stable hand, Roknor tried to fight off one of those rylaks with a pitchfork and got himself dragged down into the Boneslag!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74746,'','I haven\'t seen Makar in some time. His healing skills are desperately needed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74747,'','One of those things grabbed my daughter Gana! Dragged her away in chains like an animal!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74750,'','How unusual for Akama to send a stranger...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74751,'','...but I trust you. Thank you, outsider.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74752,'Hm. About time we showed these filthy orcs some vengeance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74753,'WHAT? HUH? GO TO AKAMA? OKAY!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74754,'You\'re not with the revolutionaries are you?','You\'re not with the revolutionaries are you?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(74755,'Make it quick $r, your kind make me sick.','Make it quick $r, your kind make me sick.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(74756,'','I\'m going into the boneslag.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(74757,'Enter the Proving Grounds','Enter the Proving Grounds',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74758,'We have them on their heels. Now is the time to press them back!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74759,'','I will follow you wherever you lead, Akama.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74760,'We must drive these orcish rats out of our temple! They will feel the full weight of draenei justice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74761,'I LIKE TO HEAL MYSELF!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74762,'By the Light... we\'ll need someone to take care of that orcish artillery.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74763,'ALREADY ON IT!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74764,'So I see.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74765,'Ahura! Hogo! $n! Continue to press the offensive!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74766,'','Commander, I cannot leave these men stranded here. You three go on without me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74767,'Very well. Stay alive, Ahura.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74768,'Hogo, $n. These orcs aren\'t going to slay themselves.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74769,'Hogo, you go ahead - make sure they don\'t counterattack. I will stay behind and establish defenses.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74770,'As you wish, commander.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74771,'$n! Follow me, into the jaws of the enemy! BY THE LIGHT OF KARABOR!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74772,'Interested in trading your battle-stones?','Interested in trading your battle-stones?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74773,'','Drek\'Thar may have doubts about his capabilities but I do not.$b$bI am not about to let that blind fool turn his back on the elements. Not after all they have done for our people.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74774,'This way.','This way.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74775,'My methods never fail!','',153,0,0,0,0,0,0,0,1,0,0,0,26124),
(74776,'Some may question my methods, but there\'s no denying my results.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(74777,'Suffering loosens the tongue. Take my word for it, $r.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(74778,'Not everyone is cut out for the work I do.$b$b<Tormentor Sipe sharpens his blade.>$b$bCut out, get it? Oh, I slay me.','',153,0,0,0,0,0,0,0,1,0,0,0,26124),
(74779,'That troll doesn\'t seem to want to tell me what he knows. You want to take a stab at him, $c?','',153,0,0,0,0,0,0,0,1,0,0,0,26124),
(74780,'Once all this strife is behind us, I think I\'ll retire to Durotar.$b$bA nice little shack on a hill. Maybe a little garden.$b$bYeah, that sounds nice.','',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(74781,'Just wait, I\'ll have that troll singin\' by day\'s end.','',153,0,0,0,0,0,0,0,1,0,0,0,26124),
(74782,'Seek out Lalum Darkmane, within the village\'s main tipi.','Seek out Lalum Darkmane, within the village\'s main tipi.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(74783,'','Wait $p! This way. Before the giant sees you.',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74784,'Akama! Why not raze their town? Why give them another chance?','',0,0,0,0,0,0,5,0,5,0,0,0,26124),
(74785,'The word of an orc is garbage. They\'re only buying time.','',0,0,0,0,0,0,396,0,5,0,0,0,26124),
(74786,'Enough talk of battle, Hogo. Finally, Shadowmoon enjoys peace.','',0,0,0,0,0,0,274,0,5,0,0,0,26124),
(74787,'Or not.','',0,0,0,0,0,0,6,0,5,0,0,0,26124),
(74788,'MY EARS HURT!','',0,0,0,0,0,0,5,0,5,0,0,0,26124),
(74789,'','Asha! Let\'s go, girl. Karg and Nerok are in trouble!',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(74790,'','I\'m going after Karg. You look for the others!',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(74791,'|TInterface\\Icons\\sha_ability_warrior_bloodnova.blp:20|t You have created a |cFFF00000|Hspell:145066|h[Projection]|h|r!','|TInterface\\Icons\\sha_ability_warrior_bloodnova.blp:20|t You have created a |cFFF00000|Hspell:145066|h[Projection]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74792,'|TInterface\\Icons\\sha_spell_warlock_demonsoul.blp:20|t The %s begins to cast |cFFF00000|Hspell:144400|h[Swelling Pride]|h|r!','|TInterface\\Icons\\spell_warlock_demonsoul.blp:20|t The %s begins to cast |cFFF00000|Hspell:144400|h[Swelling Pride]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74795,'Our enemies have finally arrived!  Demolishers, fire at will!','',0,0,0,0,0,0,0,0,1,0,38287,0,26124),
(74798,'<The wolf watches you with wise eyes.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74799,'','|TInterface\\Icons\\ability_priest_halo_shadow:20|t%s begins to cast |cFFFF0000|Hspell:143491|h[Calamity]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74800,'|TInterface\\Icons\\Ability_Siege_Engineer_Superheated.blp:20|t An Activated Laser turret has locked on to you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74801,'|TInterface\\Icons\\Ability_Siege_Engineer_Detonate.blp:20|tA Crawler Mine has targeted you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74802,'Thanks! I\'m getting out of here!','Thanks! I\'m getting out of here!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74803,'Ahh! Ahhhhhhhhhhh!','Ahh! Ahhhhhhhhhhh!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74804,'I\'m outta here! Stupid orcs, always hated the orcs!','I\'m outta here! Stupid orcs, always hated the orcs!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74805,'I owe you my life!','I owe you my life!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74806,'Thanks!','Thanks!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74807,'You\'re the best!','You\'re the best!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74808,'Screw this place!','Screw this place!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74809,'Leave me alone!!','Leave me alone!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74812,'Spirits, heed my call! Aid this fallen warrior!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74813,'Be still.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74814,'Vol\'jin needs you on the front lines!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74815,'May the spirits aid you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74816,'Hey thanks! While I\'m here, ya wanna browse my wares? Got this stuff new from Pandaria. Won\'t be cheap, war times you know.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74817,'I will NOT burn like the rest! Face the demons you fear, traitors!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74818,'What is that horrible smell?','I\'m going to puke...',0,0,0,1,0,0,0,0,1,0,0,0,26124),
(74819,'still sick!!!','still sick!!!',462,0,0,0,0,0,0,0,1,0,0,0,26124),
(74820,'Don\'t let them through!','',53,0,0,0,0,0,0,0,1,0,0,0,26124),
(74821,'Protect the temple!!','',22,0,0,0,0,0,0,0,1,0,0,0,26124),
(74822,'The Warchief ignored my council. I discovered he was building a compound beneath the caverns of Ragefire.','',0,0,0,0,0,0,0,0,1,0,38564,0,26124),
(74823,'Thrall and Saurfang have already gone down below.','',0,0,0,0,0,0,0,0,1,0,38565,0,26124),
(74824,'Go with caution.  Hellscream has been assembling an arsenal down there - goblin mercenaries, pandaren artifacts, and some sort of darkness I can feel in my very soul.','',0,0,0,0,0,0,0,0,1,0,38567,0,26124),
(74825,'I\'m scared!','I\'m scared!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74826,'','Stay behind us! Keep your heads down!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74827,'An Automated Shredder draws near!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74828,'','I hear a spirit. A powerful one! Keep those goren at bay for just a little longer.',0,0,0,0,0,0,0,0,7,22207,0,0,26124),
(74829,'','Buy me just a few more moments.',0,0,0,0,0,0,0,0,7,22207,0,0,26124),
(74830,'The Kor\'kron are ready. Let them come and taste steel!','The Kor\'kron are ready. Let them come and taste steel!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74831,'Almost all of da troops be here now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74832,'I am uneasy, old friend.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74833,'An me as well. We dun know what Garrosh been plannin this whole time.  What he\'s got in store for us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74834,'I fear for the safety of our people.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74835,'Not everyone gonna come out of this alive.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74836,'And for what? What did the Horde gain from such actions?  Garrosh is a fool, and a betrayer.  I should have killed him long ago, when he betrayed my father.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74837,'You gonna get your chance mon.  But first we gotta take da city.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74838,'Have you been communicating with the humans?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74839,'Both da alliance and da horde got ships sailin for da harbor.  We gonna split der forces an assault da front gate.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74840,'A bold plan.  Let us hope we do not run into any surprises.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74841,'I don\'t think we got a choice, mon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74842,'','Stay down, shaman. Catch your breath. This champion can forge ahead and we will catch up when you are ready.',0,0,0,0,0,0,0,0,7,0,0,41783,26124),
(74843,'','Elune-Adore, $c.',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(74844,'We will defeat Garrosh and restore the Horde!','We will defeat Garrosh and restore the Horde!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74845,'The spirits will guide us in the coming battle.','The spirits will guide us in the coming battle.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74846,'I\'m honored to fight alongside of you, $n!','I\'m honored to fight alongside of you, $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74847,'We be ready to take da fight to Garrosh.','We be ready to take da fight to Garrosh.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74848,'Ready to fight, mon?','Ready to fight, mon?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74849,'Vol\'jin be a true leader.','Vol\'jin be a true leader.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74850,'These demolishers aren\'t gonna fix themselves!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74851,'Work, work.  Heh, had you there didn\'t I?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74852,'It\'s not safe in Orgrimmar for us now.','It\'s not safe in Orgrimmar for us now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74853,'I just want my family to be safe.','I just want my family to be safe.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74854,'Garrosh is a tyrant for taking our home.','Garrosh is a tyrant for taking our home.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74855,'I want this all to be over soon.','I want this all to be over soon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74856,'Mommy says daddy will be home soon.','Mommy says daddy will be home soon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74857,'I wanna go home.','I wanna go home.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74858,'I hear the adults whispering all the time.','I hear the adults whispering all the time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74859,'I wanna fight too! I\'m ready!','I wanna fight too! I\'m ready!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74860,'I live to fight again.','I live to fight again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74861,'These wounds won\'t prevent me from facing the Kor\'kron.','These wounds won\'t prevent me from facing the Kor\'kron.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74862,'Orgrimmar will fall to our forces!','Orgrimmar will fall to our forces!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74863,'I call and the spirits answer $r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74864,'Wars make enemies into friends, and friends into enemies.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74865,'Garrosh be backed into a corner $r, and that\'s when he\'ll be most dangerous.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74866,'Thrall be me brother, I hope he be safe.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74867,'Da greater enemy be Garrosh, not da Alliance.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74868,'The true Horde will triumph.','The true Horde will triumph.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74869,'These rebels are nothing.  Garrosh will stomp them beneath his heel.','These rebels are nothing.  Garrosh will stomp them beneath his heel.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74870,'I\'m keeping my eye on you $r.','I\'m keeping my eye on you $r.',0,0,0,0,0,0,0,0,1,8525,0,0,26124),
(74871,'You\'re not with the rebellion, are you?','You\'re not with the rebellion, are you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74872,'We\'ve finally captured this tauren.','We\'ve Finally captured this tauren.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74873,'I\'m looking forward to gutting this one.','I\'m looking forward to gutting this one.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74874,'Lash him to the tree!','Lash him to the tree!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74875,'','These warlocks will suffer for their demonic pacts.',0,0,0,0,0,0,0,0,1,22210,0,0,26124),
(74876,'','We will root out all corruption within Orgrimmar.',0,0,0,0,0,0,0,0,1,22210,0,0,26124),
(74877,'','The stench that surrounds your kind is overwhelming.  You will pay with all the others who commune with demonkind.',0,0,0,0,0,0,0,0,1,18181,0,0,26124),
(74878,'It\'s up to me to ensure these Kor\'kron are ready.','It\'s up to me to ensure these Kor\'kron are ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74879,'They\'ll thank me for being hard on them when the battle starts.','They\'ll thank me for being hard on them when the battle starts.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74880,'I know what you\'re planning, these Kor\'kron will be ready when you strike.','I know what you\'re planning, these Kor\'kron will be ready when you strike.',0,0,0,0,0,0,0,0,1,8525,0,0,26124),
(74881,'Think twice before you fight the might of the Kor\'kron.','Think twice before you fight the might of the Kor\'kron.',0,0,0,0,0,0,0,0,1,8525,0,0,26124),
(74883,'','Ishnu-alah, commander.',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(74884,'Good! Again!','Good! Again!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74885,'Garrosh will not tolerate failure.  AGAIN!','Garrosh will not tolerate failure.  AGAIN!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74886,'Garrosh demands the wealth you\'ve accumulated.  You will give me access to your vaults!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74887,'We shall see if you are so defiant after we start breaking your bones.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74888,'I... I can\'t! I won\'t!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74889,'','Garrosh will not tolerate demon worship within the walls of Orgrimmar. You will submit and allow yourselves to be taken into custody or be destroyed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74890,'Ey mon, help us out! Find da key!','',0,0,0,0,0,0,5,0,1,0,38937,0,26124),
(74891,'Tanks mon, we won\'t be forgettin dis!','',0,0,0,0,0,0,1,0,1,0,38938,0,26124),
(74892,'Doyo\'da places a Resistance Totem to aid you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74893,'Over here! Please let us out! They key is around here somewhere!','',0,0,0,0,0,0,0,0,1,0,39782,0,26124),
(74894,'Thanks! We owe you one!','',0,0,0,0,0,0,0,0,1,0,39783,0,26124),
(74895,'The Wildhammer Shaman places a Resistance Totem to aid you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74896,'DIE $C!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74897,'I am not your friend!!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74898,'Thank you for saving us from the Pale, $n. I shudder to think what horrors might have been in store for us.','Thank you for saving us from the Pale, $n. I shudder to think what horrors might have been in store for us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74899,'You are welcome. [Vignette Reward Here]','You are welcome. [Vignette Reward Here]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(74900,'Why are you out here?','Why are you out here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74901,'','I dropped my totem.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74902,'Dropped your totem?','Dropped your totem?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74903,'','I have not slept in weeks, and my mind is filled with a screaming that no one else seems to hear.$b$bWhat kind of shaman is unable to lift her own totem? How can I claim Ga\'nar is wrong if when I hoist my own axes my arms buckle? I am not fit for war, I am not fit as a shaman.$b$bI must find what the spirits purpose is for me. Only their guidance can set me on the right path now. They obviously have a plan or I would not have access to my powers as a shaman anymore.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74904,'You\'ve walked into your own grave, pup.','',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(74905,'Lighting Fuse...','Lighting Fuse...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74906,'He\'s gone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74907,'','Spirits of the wind, lend us your speed.',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74908,'','The Thunderlord are fools for the most part, but they understand combat with giants.',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74909,'','They are also notorious for etching down their favorite tactics on armbands. I assume they are either bragging or failing to remember.',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74910,'','Spirits save me but it is cold. My lungs feel like they are on fire.',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74911,'','There it is. The carcass. I... I don\'t think I can go with you in there. My arm will not stop shaking and it is as if the land itself is screaming in my mind.',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74912,'','I.. I can\'t... they took my children!',0,0,0,0,0,0,0,0,1,0,0,38568,26124),
(74913,'','I\'m so sorry!',0,0,0,0,0,0,18,0,1,0,0,38569,26124),
(74914,'','Please, find my babies!',0,0,0,0,0,0,18,0,1,0,0,38570,26124),
(74915,'','Please, let us go!',0,0,0,0,0,0,20,0,1,0,0,39043,26124),
(74916,'','We didn\'t want to do this!',0,0,0,0,0,0,5,0,1,0,0,39044,26124),
(74917,'','I owe you my life!',0,0,0,0,0,0,1,0,1,0,0,39045,26124),
(74918,'Shut up!','',0,0,0,0,0,0,5,0,1,0,39047,0,26124),
(74919,'Attack them!','',0,0,0,0,0,0,25,0,1,0,39048,0,26124),
(74920,'Get back in line!','',0,0,0,0,0,0,5,0,1,0,39049,0,26124),
(74921,'Have anything to say for yourself, Pandaren?','',0,0,0,0,0,0,1,0,1,0,39051,0,26124),
(74922,'Do you see this burning candle? You have until it burns out to tell us about the Pandaren artifacts! Now start talking!','',0,0,0,0,0,0,397,0,1,0,39052,0,26124),
(74923,'Very well, if you won\'t talk, you won\'t need your head anymore.','',0,0,0,0,0,0,1,0,1,0,39053,0,26124),
(74924,'','Ji must be in here somewhere, I have to find him!',0,0,0,0,0,0,0,0,1,0,0,38555,26124),
(74925,'','Oh no, Ji! They are going to execute him!',0,0,0,0,0,0,0,0,1,0,0,38556,26124),
(74926,'','They have practically beaten him unconscious! I have to do something!',0,0,0,0,0,0,0,0,1,0,0,38557,26124),
(74927,'','Ji! No! I will kill you!',0,0,0,0,0,0,0,0,1,0,0,38558,26124),
(74928,'','Ji... I am sorry...',0,0,0,0,0,0,0,0,1,0,0,38559,26124),
(74929,'','Ji, I am so sorry, we can be together now, please, let us just go back to the turtle, please do not die.',0,0,0,0,0,0,0,0,1,0,0,38560,26124),
(74930,'','I am getting him out of here.',0,0,0,0,0,0,0,0,1,0,0,38561,26124),
(74931,'','I will see you on the inside, $p. Spirits guide you. Orgrock, lend me a hand if you will.',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(74933,'Hngg... huh? I could hear Lokra... moments ago...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74934,'I could hear Lokra... moments ago...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74935,'Ah, but she is the hunter, not the quarry. And ahead of the pack as usual...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74936,'Go on ahead, friend. I will catch up. I just need a moment to regain my strength.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74937,'Hrnngg... thank you...','',0,0,0,0,0,0,0,0,1,0,38276,0,26124),
(74938,'I may be bruised and beaten, but the hatred boils inside me.','',0,0,0,0,0,0,396,0,1,0,38277,0,26124),
(74939,'Many times have I fallen at the hands of an Orc, and many times have I risen again.','',0,0,0,0,0,0,396,0,1,0,38278,0,26124),
(74940,'But never again.','',0,0,0,0,0,0,274,0,1,0,38279,0,26124),
(74941,'For every orc that struck me, I will cleave a thousand of their skulls!','',0,0,0,0,0,0,5,0,1,0,38280,0,26124),
(74942,'This ends here!','This ends here!',0,0,0,0,0,0,15,0,1,0,38281,38281,26124),
(74943,'I, Gamon, will save us!','I, Gamon, will save us!',0,0,0,0,0,0,71,0,1,0,38282,38282,26124),
(74944,'Taste my axe!','Taste my axe!',0,0,0,0,0,0,0,0,1,0,38271,38271,26124),
(74945,'Pay for your crimes!','Pay for your crimes!',0,0,0,0,0,0,0,0,1,0,38272,38272,26124),
(74946,'I am a storm of pain!','I am a storm of pain!',0,0,0,0,0,0,0,0,1,0,38283,38283,26124),
(74949,'Some terrible things have happened in the Vale of Eternal Blossoms, but the real tragedy is that it\'s no longer a good place for fishing. All that Jewel Danio! Gone!  $b $bFortunately for you, I\'ve heard of an island off the eastern coast where you can still fish Jewel Danio. If the rumors are correct, you should be able to find a lake full of them there.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74950,'If the rumors are true, you should be able to find Jewel Danio here. $b$b<Ben marks a spot on your map.>$b$b','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74953,'An old scroll covered in various pandaren pictograms. You suspect that unless the sha corruption in the temple is cleansed you won\'t be able to peruse the contents further.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74954,'Read the scroll.','Read the scroll.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74956,'Rage is power!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74957,'SQEEEE!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74958,'You have been judged, and proven yourselves worthy. But be warned, what lies beyond will try your souls to their utmost.  When you are fully prepared, you may enter the chamber.','',0,0,0,0,0,0,0,0,1,0,38882,0,26124),
(74959,'','Shhh... not so loud!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(74960,'','Thank you. Mother must be worried sick about me!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(74961,'','I can get back to the outpost from here. Find me if you need leatherworking!',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(74962,'The corruption is amplifying.  The fragments must be purged before it becomes too great.','',0,0,0,0,0,0,0,0,1,0,38903,0,26124),
(74963,'It did not matter. It comes.  Steel your hearts and prepare your souls.','',0,0,0,0,0,0,0,0,1,0,38904,0,26124),
(74964,'You... must... contain... it...','',0,0,0,0,0,0,0,0,1,0,38902,0,26124),
(74965,'Be humble.','',0,0,0,0,0,0,0,0,1,0,38900,0,26124),
(74966,'Free yourself of arrogance.','',0,0,0,0,0,0,0,0,1,0,38901,0,26124),
(74968,'Ah, we adventure together again, except this time I am afraid that the circumstances are much more dire.','',0,0,0,0,0,0,378,0,1,0,38120,0,26124),
(74969,'Oh, what has become of the Vale?','',0,0,0,0,0,0,0,0,1,0,38121,0,26124),
(74970,'The land is scarred, the ever-blooming trees and plants wither and die as the water from the pools drains away.','',0,0,0,0,0,0,378,0,1,0,38122,0,26124),
(74971,'Come, let us see what other horrors Garrosh has unleashed upon our land.','',0,0,0,0,0,0,0,0,1,0,38123,0,26124),
(74972,'Once, the Titans used these life-giving waters to create and shape all life in Pandaria.','',0,0,0,0,0,0,0,0,1,0,38124,0,26124),
(74973,'It is these waters that kept the Vale in bloom.  Their runoff into the Valley of the Four Winds created the most fertile farmland in the world!','',0,0,0,0,0,0,378,0,1,0,38125,0,26124),
(74974,'And now, the malignance of the Old God has manifested itself within the waters.','',0,0,0,0,0,0,1,0,1,0,38126,0,26124),
(74975,'Such a foul, foul thing - destroy it, before it seeps deep into the soil and corrupts all of Pandaria!','',0,0,0,0,0,0,5,0,1,0,38127,0,26124),
(74976,'Ah, you have done it!  The waters are pure once more.','',0,0,0,0,0,0,5,0,1,0,38128,0,26124),
(74977,'Can you feel their life-giving energies flow through you?','',0,0,0,0,0,0,6,0,1,0,38129,0,26124),
(74978,'It will take much time for the Vale to heal, but you have given us hope!','',0,0,0,0,0,0,1,0,1,0,38130,0,26124),
(74979,'Can it be...? Oh no, no no no no no.','',0,0,0,0,0,0,274,0,1,0,38131,0,26124),
(74980,'The Golden Lotus... they pledged their lives to defend this place.','',0,0,0,0,0,0,1,0,1,0,38132,0,26124),
(74981,'Yes!  Rook Stonetoe!  You remember me!  What has happened to you?','',0,0,0,0,0,0,5,0,1,0,38133,0,26124),
(74982,'I see. This sha energy has trapped their spirits here, to endlessly relive their failure. It feeds on their despair.','',0,0,0,0,0,0,1,0,1,0,38134,0,26124),
(74983,'NOOOOO!','',36,0,0,0,0,0,0,0,1,0,0,0,26124),
(74984,'This is a fate far worse than death - please, heroes!  Set their souls free!','',0,0,0,0,0,0,1,0,1,0,38135,0,26124),
(74985,'Be at peace, dear friends.','',0,0,0,0,0,0,1,0,1,0,38136,0,26124),
(74986,'May your souls become one with the land you gave your life to protect.','',0,0,0,0,0,0,1,0,1,0,38137,0,26124),
(74987,'Astounding! Another chamber that looks to originate from these \"Titans.\"','',0,0,0,0,0,0,0,0,1,0,38138,0,26124),
(74988,'It must have been hidden away long before recorded history.  And with good reason!','',0,0,0,0,0,0,0,0,1,0,38139,0,26124),
(74989,'In the chamber ahead, under our peaceful land, slept the heart of an Old God.','',0,0,0,0,0,0,0,0,1,0,38140,0,26124),
(74990,'Oh my!  What is this?  Hello!  I am Lorewalker Cho!','',0,0,0,0,0,0,3,0,1,0,38141,0,26124),
(74991,'Further corruption?  No, we are here to stop the corruption, and save Pandaria!','',0,0,0,0,0,0,274,0,1,0,38142,0,26124),
(74992,'Yes! Please let us pass!','',0,0,0,0,0,0,273,0,1,0,38143,0,26124),
(74993,'Taran Zhu!','',0,0,0,0,0,0,0,0,1,0,38144,0,26124),
(74994,'Don\'t speak, friend, I will take you to the healers.','',0,0,0,0,0,0,0,0,1,0,38145,0,26124),
(74995,'I will find help!  Try to hold off the Sha for as long as you can!','',0,0,0,0,0,0,0,0,1,0,38146,0,26124),
(74996,'Heroes! You\'re alive. I brought help.','',0,0,0,0,0,0,0,0,1,0,38147,0,26124),
(74997,'*Cough cough* Nyyyunnngggg...','',0,0,0,0,0,0,0,0,1,0,38307,0,26124),
(74998,'Cho... the outsiders... THEY did this... we should never have let them in...','',0,0,0,0,0,0,0,0,1,0,38308,0,26124),
(74999,'I SEE YOU!','',36,0,0,0,0,0,0,0,1,0,0,0,26124),
(75000,'','<Gana strains to look around, then speaks in a hushed whisper.>$B$BAre... are they gone?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75001,'Break the chains.','Break the chains.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75002,'','It\'d be easier to guard you if you stayed out of sight, Khadgar.',0,0,0,0,0,0,0,7,0,0,0,44123,26124),
(75003,'','I\'m going ahead to the demon\'s lair. We\'ll capture it together.',0,0,0,0,0,0,0,7,0,0,0,44122,26124),
(75008,'','In here.',0,0,0,0,0,0,0,7,4,0,0,44119,26124),
(75009,'I am not a child to cower beneath your cape, Cordana.','',0,0,0,0,0,0,0,7,0,0,44993,0,26124),
(75010,'','We\'ll run them down. Catch up to us when you can!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75011,'','Swiftly, Asha! After them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75012,'','Let\'s go, Sky! After them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75013,'Hold still. More help should arrive soon.','Hold still. More help should arrive soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75014,'Our work is vital to the world.','',0,0,0,0,0,0,0,0,7,0,41913,0,26124),
(75015,'','Well done. I\'ll take it back to the outpost and see that it\'s secured.',0,0,0,0,0,0,0,7,0,0,0,44120,26124),
(75016,'Begin the ritual.','Begin the ritual.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75017,'The Iron Horde continue to attack from the south.','The Iron Horde continue to attack from the south.',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(75018,'What should we do?','What should we do?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(75019,'You there.','You there.',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(75020,'Go tell Aklana Swifthoof the fight is getting out of control.','Go tell Aklana Swifthoof the fight is getting out of control.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75021,'Right away sir.','Right away sir.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75022,'NO! I will feed your bones to her pups!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75023,'The %s prepares a |cFFFF0404|Hspell:144485|h[Shock Pulse]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75024,'Let\'s do battle!','Let\'s do battle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75025,'I cannot challenge the Celestials today, but I look forward to watching your progress.  Good luck, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75026,'Halt!','',0,0,0,0,0,0,0,0,1,0,38883,0,26124),
(75027,'No further corruption will enter the heart chamber!','',0,0,0,0,0,0,0,0,1,0,38884,0,26124),
(75028,'You wish to purge the corruption?','',0,0,0,0,0,0,0,0,1,0,38885,0,26124),
(75029,'Should you pass this door, at this time, you would fail!  You, all of you, are corrupted with the insiduous plague known as Pride.','',0,0,0,0,0,0,0,0,1,0,38886,0,26124),
(75030,'Speak to me again when you are prepared to face your inner demons.','',0,0,0,0,0,0,0,0,1,0,38887,0,26124),
(75031,'Very well, I will create a field to keep your corruption quarantined.','',0,0,0,0,0,0,0,0,1,0,38888,0,26124),
(75032,'Prove yourselves worthy and I will let you pass.','',0,0,0,0,0,0,0,0,1,0,38889,0,26124),
(75033,'|TInterface\\Icons\\spell_shadow_shadesofdarkness.blp:20|t%s begins to cast |cFFF00000|Hspell:142842|h[Breath of Y\'Shaarj]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75034,'The light cleanses; but it is not gentle.  Gird yourselves and be purified!','',0,0,0,0,0,0,0,0,1,0,38880,0,26124),
(75035,'Look inside yourself and cleanse the darkness within.','',0,0,0,0,0,0,0,0,1,0,38892,0,26124),
(75036,'Face your inner demons!','',0,0,0,0,0,0,0,0,1,0,38893,0,26124),
(75037,'Be purified in the light!','',0,0,0,0,0,0,0,0,1,0,38894,0,26124),
(75038,'Unworthy.','',0,0,0,0,0,0,0,0,1,0,38890,0,26124),
(75039,'Only the pure of heart may pass!','',0,0,0,0,0,0,0,0,1,0,38891,0,26124),
(75040,'The light will not suffer your taint.','',0,0,0,0,0,0,0,0,1,0,38881,0,26124),
(75041,'','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75042,'','He was here... I let them slip away.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75043,'','I\'m so sorry, Asha. If only I had trained more... if only I\'d been faster.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75044,'You push yourself too hard, Little Paw.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75045,'Here! My champion arrives!','',0,0,0,0,0,0,0,0,7,16604,38370,0,26124),
(75046,'Ah, of course! My old friend from the Jade Forest!','',0,0,0,0,0,0,0,0,7,16604,38107,0,26124),
(75047,'Wait wait wait - let me make sure I get the story right.','',0,0,0,0,0,0,0,0,7,0,38108,0,26124),
(75048,'You run fast, Little Paw, and kill for your love. But you must think also of the pack. And of your own safety.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(75049,'','Makar! I told you not to call me that anymore...',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(75050,'Pandaren will tell this tale for generations!','',0,0,0,0,0,0,0,0,7,0,38109,0,26124),
(75051,'Asha. \"Open sky.\" She will be fine. She is strong, like you.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(75052,'It starts with a hero.','',0,0,0,0,0,0,0,0,7,0,38371,0,26124),
(75053,'','I am going to Thunderfall, shaman. I will free Karg or die trying.',0,0,0,0,0,0,25,0,1,0,0,0,26124),
(75054,'An outsider, from beyond the mists!','',0,0,0,0,0,0,0,0,7,0,38110,0,26124),
(75055,'No, and I would not try.','',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(75056,'Conquering a strange new land!','',0,0,0,0,0,0,0,0,7,0,38372,0,26124),
(75057,'','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(75058,'Must we use the word, \"Conquer?\"','',0,0,0,0,0,0,0,0,7,0,38111,0,26124),
(75059,'Venturing into forgotten vaults...','',0,0,0,0,0,0,0,0,7,0,38373,0,26124),
(75060,'I will rally the strongest of our riders from Stonefang. Find us where the giant\'s shadow meets the mountain of fury.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(75061,'Mantid and mogu alike were brought low by the hero\'s fury.','',0,0,0,0,0,0,0,0,7,0,38112,0,26124),
(75062,'We will show Fenris the Hunter there are yet jaws he cannot muzzle.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(75063,'','Thank you, Makar.',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(75064,'Their power and wisdom seized for a greater glory!','',0,0,0,0,0,0,0,0,7,0,38374,0,26124),
(75065,'You fight with spirit of the pack in your blood and the fire of love in your heart. Precious gifts. Do not waste them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75066,'When war came to Pandaria\'s shores, our hero was ready.','',0,0,0,0,0,0,0,0,7,0,38113,0,26124),
(75067,'A faction standard-bearer, beloved by the people and feared by their foes.','',0,0,0,0,0,0,0,0,7,0,38375,0,26124),
(75068,'Even the mighty Thunder King fell before our champion\'s might.','',0,0,0,0,0,0,0,0,7,0,38114,0,26124),
(75069,'One by one the secrets of an ancient empire were laid bare.','',0,0,0,0,0,0,0,0,7,0,38376,0,26124),
(75070,'Yes, knowledge uncovered for the benefit of the world.','',0,0,0,0,0,0,0,0,7,0,38115,0,26124),
(75071,'POWER acquired for WAR and CONQUEST!','',0,0,0,0,0,0,0,0,7,0,38377,0,26124),
(75072,'And then the Old One will remake this world for the Mantid!','',0,0,0,0,0,0,0,0,0,0,38677,0,26124),
(75073,'I will drink your blood!','',0,0,0,0,0,0,0,0,0,0,38674,0,26124),
(75074,'Let us stop for a moment - what kind of hero are we talking about?','',0,0,0,0,0,0,0,0,7,0,38116,0,26124),
(75075,'Feast on the blood of our enemies!','',0,0,0,0,0,0,0,0,0,0,38679,0,26124),
(75076,'Another notch for my blade.','',0,0,0,0,0,0,0,0,0,0,38678,0,26124),
(75077,'Avenge me, brothers!','',0,0,0,0,0,0,0,0,0,0,38675,0,26124),
(75078,'An agent of destruction, forged by my will to forever change the face of Azeroth.','',0,0,0,0,0,0,0,0,7,0,38378,0,26124),
(75079,'We will slay you all as easily as we slew the Pandaren of old.','',0,0,0,0,0,0,0,0,0,0,38637,0,26124),
(75080,'You move too slowly, how does your kind catch any prey?','',0,0,0,0,0,0,0,0,0,0,38634,0,26124),
(75081,'I ache with power!','',0,0,0,0,0,0,0,0,0,0,38639,0,26124),
(75082,'Muahahahahaha!','',0,0,0,0,0,0,0,0,0,0,38640,0,26124),
(75083,'My friend, please think carefully about the legacy you will leave behind.','',0,0,0,0,0,0,0,0,7,0,38117,0,26124),
(75084,'See Kil\'ruk? Speed is king!','',0,0,0,0,0,0,0,0,0,0,38638,0,26124),
(75085,'Behold! Latent titan power, imbued with my own draconic essence, tempered by the wisdom of the pandaren celestials.','',0,0,0,0,0,0,0,0,7,0,38379,0,26124),
(75086,'Much too slow.','',0,0,0,0,0,0,0,0,0,0,38636,0,26124),
(75087,'Look how they fall, like so many blades of grass in the wind.','',0,0,0,0,0,0,0,0,0,0,38676,0,26124),
(75088,'Curse this chitinous shell, I was not fast enough!','',0,0,0,0,0,0,0,0,0,0,38635,0,26124),
(75089,'Overwhleming power. Use it to heal or destroy! To protect or annihilate!','',0,0,0,0,0,0,0,0,7,0,38380,0,26124),
(75090,'How illogical, did they not hear your warning Kil\'ruk?','',0,0,0,0,0,0,0,0,0,0,38621,0,26124),
(75091,'Chaos is order unrecognized by a lesser mind!','',0,0,0,0,0,0,0,0,0,0,38618,0,26124),
(75092,'How about a game?','',0,0,0,0,0,0,0,0,0,0,38623,0,26124),
(75093,'Come to me, champion! Collect your well-earned reward!','',0,0,0,0,0,0,0,0,7,0,38381,0,26124),
(75094,'An interesting commonality, now to exploit it!','',0,0,0,0,0,0,0,0,0,0,38624,0,26124),
(75095,'I see many threes repeating...','',0,0,0,0,0,0,0,0,0,0,38625,0,26124),
(75096,'I predicted that to be a likely outcome.','',0,0,0,0,0,0,0,0,0,0,38622,0,26124),
(75097,'So easily solved, you are not so complicated after all!','',0,0,0,0,0,0,0,0,0,0,38620,0,26124),
(75098,'My calculations, incorrect? Perhaps another 800 years...','',0,0,0,0,0,0,0,0,0,0,38619,0,26124),
(75099,'We have endured the Usurpers, their children, the loss of the Old One, and soon... you.','',0,0,0,0,0,0,0,0,0,0,38670,0,26124),
(75100,'You now face the Prime. Bow down to your superior!','',0,0,0,0,0,0,0,0,0,0,38667,0,26124),
(75101,'The amber protects us.','',0,0,0,0,0,0,0,0,0,0,38672,0,26124),
(75102,'The Old One grants us strength.','',0,0,0,0,0,0,0,0,0,0,38673,0,26124),
(75103,'The Usurpers abandoned you.','',0,0,0,0,0,0,0,0,0,0,38671,0,26124),
(75104,'We remain unscathed.','',0,0,0,0,0,0,0,0,0,0,38669,0,26124),
(75105,'How will the story end?','',0,0,0,0,0,0,0,0,7,0,38118,0,26124),
(75106,'Return me to the amber...','',0,0,0,0,0,0,0,0,0,0,38668,0,26124),
(75107,'It matters not, the Old One will not suffer their intrusion.','',0,0,0,0,0,0,0,0,0,0,38646,0,26124),
(75108,'Come little Kunchongs, it\'s feeding time!','',0,0,0,0,0,0,0,0,0,0,38790,0,26124),
(75109,'Your mind has grown weak since we last met.','',0,0,0,0,0,0,0,0,0,0,38648,0,26124),
(75110,'Zor\'lok wasn\'t the only one with a strong voice.','',0,0,0,0,0,0,0,0,0,0,38649,0,26124),
(75111,'There is only one way to find out.','',0,0,0,0,0,0,0,0,7,0,38382,0,26124),
(75112,'A fitting meal for my children.','',0,0,0,0,0,0,0,0,0,0,38647,0,26124),
(75113,'Let the feast begin!','',0,0,0,0,0,0,0,0,0,0,38645,0,26124),
(75114,'Kovok... come to me... I need...','',0,0,0,0,0,0,0,0,0,0,38643,0,26124),
(75115,'A pandaren legend is born! Sing praises to our new hero, $n!','',0,0,0,0,0,0,0,0,7,22592,38119,0,26124),
(75116,'Come children of the Titans, you face the Paragons.','',0,0,0,0,0,0,0,0,0,0,38609,0,26124),
(75117,'Time for a little target practice.','',0,0,0,0,0,0,0,0,0,0,38606,0,26124),
(75118,'Yes... a target of great importance.','',0,0,0,0,0,0,0,0,0,0,38611,0,26124),
(75119,'My intelligence suggests this one is a high-value target.','',0,0,0,0,0,0,0,0,0,0,38612,0,26124),
(75120,'Another kill, another trophy!','',0,0,0,0,0,0,0,0,0,0,38610,0,26124),
(75121,'Target practice has ended.','',0,0,0,0,0,0,0,0,0,0,38608,0,26124),
(75122,'The hunter... becomes... the hunted....','',0,0,0,0,0,0,0,0,0,0,38607,0,26124),
(75123,'We Mantid serve a power far greater than they or their gods.','',0,0,0,0,0,0,0,0,0,0,38707,0,26124),
(75124,'Have you come to try my new concoctions, Wakener?  I assure you these are nothing like you\'ve tasted before.','',0,0,0,0,0,0,0,0,0,0,38704,0,26124),
(75125,'So many wonderful varieties, which concoction shall I give you?','',0,0,0,0,0,0,0,0,0,0,38709,0,26124),
(75126,'All reactions begin with the proper catalyst.','',0,0,0,0,0,0,0,0,0,0,38710,0,26124),
(75127,'My alchemy is supreme!','',0,0,0,0,0,0,0,0,0,0,38708,0,26124),
(75128,'There is nothing the proper mixture can\'t handle.','',0,0,0,0,0,0,0,0,0,0,38706,0,26124),
(75129,'I never discovered... how to put a stopper... in death...','',0,0,0,0,0,0,0,0,0,0,38705,0,26124),
(75130,'Look brothers, the Wakener is here!','',0,0,0,0,0,0,0,0,0,0,38657,0,26124),
(75131,'I will carry you one last time Wakener... to your doom!','',0,0,0,0,0,0,0,0,0,0,38654,0,26124),
(75132,'I am a leaf on the wind!','',0,0,0,0,0,0,0,0,0,0,38659,0,26124),
(75133,'Watch how I soar!','',0,0,0,0,0,0,0,0,0,0,38658,0,26124),
(75134,'I did warn you, Wakener.','',0,0,0,0,0,0,0,0,0,0,38656,0,26124),
(75135,'Well fought Wakener.  We will meet again...','',0,0,0,0,0,0,0,0,0,0,38655,0,26124),
(75136,'They made it this far? I told you the others needed some micro-sonic genetic alterations.','',0,0,0,0,0,0,0,0,0,0,38916,0,26124),
(75137,'Yes... new test subjects!','',0,0,0,0,0,0,0,0,0,0,38913,0,26124),
(75138,'Success! They are alive!','',0,0,0,0,0,0,0,0,0,0,38918,0,26124),
(75139,'Natural evolution takes far too long. Here, let me help you along...','',0,0,0,0,0,0,0,0,0,0,38919,0,26124),
(75140,'Curses!  More data lost to an untimely death.','',0,0,0,0,0,0,0,0,0,0,38917,0,26124),
(75141,'Hmmm, dead already?  I wonder if a session of micro-sonic deep-gene probing can reanimate them...','',0,0,0,0,0,0,0,0,0,0,38915,0,26124),
(75142,'Perhaps I could have used... some enhancements... of my own...','',0,0,0,0,0,0,0,0,0,0,38914,0,26124),
(75143,'Just look at this place! An entire ecology secluded, cut off from all known timelines!$b$bIt is rare for one such as I to be surprised by, well, anything really. I shall relish every moment I spend here.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(75144,'Remember when we compelled the All-Seeing Eye to spy upon the Shadow Council?','Remember when we compelled the All-Seeing Eye to spy upon the Shadow Council?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75145,'This... is a good death.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75148,'Nonsense. I had that handled. Cool as a cucumber.','',0,0,0,0,0,0,0,0,4,0,45001,0,26124),
(75149,'The Warsong will NEVER surrender!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75150,'','I knew it. You should\'ve stayed back at the garrison, Archmage.',0,0,0,0,0,0,0,0,4,0,0,44127,26124),
(75151,'','Khadgar will join us on the way. Come, Throm\'var lies just over the ridge.',0,0,0,0,0,0,0,1,0,0,0,44140,26124),
(75152,'','I\'ve been scouting the dunes. A demonic force has infected some of the beasts.',0,0,0,0,0,0,0,1,0,0,0,44141,26124),
(75153,'','We\'re certain the Shadow Council is involved, but we\'ve yet to pinpoint them.',0,0,0,0,0,0,0,1,0,0,0,44142,26124),
(75157,'Stay away from me with those things!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75158,'Hmmm... It looks like these bunnies are to blame for the sickness that is spreading around.','Hold still. More help should arrive soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75159,'You stand tall and proud atop your accomplishments, and this will be your downfall.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75160,'Should you wish to defeat the corruption, you will first need to purify the corruption within yourselves.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75161,'Nazgrim has failed us. Kor\'kron, destroy these intruders!','',0,0,0,0,0,0,0,0,0,0,38174,0,26124),
(75162,'I will never fail the warchief!','',0,0,0,0,0,0,0,0,0,0,38172,0,26124),
(75163,'Garrosh gives me strength!','',0,0,0,0,0,0,0,0,0,0,38176,0,26124),
(75164,'Weaklings!','',0,0,0,0,0,0,0,0,0,0,38177,0,26124),
(75165,'You dare challenge the warchief?','',0,0,0,0,0,0,0,0,0,0,38178,0,26124),
(75166,'Witness the might of the true Horde!','',0,0,0,0,0,0,0,0,0,0,38179,0,26124),
(75167,'The power of the warchief will overwhelm you!','',0,0,0,0,0,0,0,0,0,0,38180,0,26124),
(75168,'The true Horde cannot be STOPPED!','',0,0,0,0,0,0,0,0,0,0,38181,0,26124),
(75169,'Stand and FACE ME!','',0,0,0,0,0,0,0,0,0,0,38182,0,26124),
(75170,'To die... for the warchief... is... an... honor...','',0,0,0,0,0,0,0,0,0,0,38173,0,26124),
(75171,'The overwhelming power!','',0,0,0,0,0,0,0,0,0,0,38183,0,26124),
(75172,'The warchief demands it!','',0,0,0,0,0,0,0,0,0,0,38175,0,26124),
(75173,'The Iron Juggernaut focuses a |cFFFF0404|Hspell:144918|h[Cutter Laser]|h|r on you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75174,'Kairoz! I want you to meet one of my most accomplished of agents.','',0,0,0,0,0,0,1,0,0,0,38386,0,26124),
(75175,'Tell us again why this island is so unique?','',1,0,0,0,0,0,6,0,0,0,38387,0,26124),
(75176,'I would very much like to study such unique items.','',1,0,0,0,0,0,1,0,0,0,38388,0,26124),
(75177,'Oh?','',1,0,0,0,0,0,6,0,0,0,38389,0,26124),
(75178,'...I like the way you think!','',1,0,0,0,0,0,5,0,0,0,38390,0,26124),
(75179,'A pleasure.','',1,0,0,0,0,0,66,0,0,0,38867,0,26124),
(75180,'We do not know! That is precisely why I am here.','',1,0,0,0,0,0,5,0,0,0,38868,0,26124),
(75181,'Time is frozen in this place. The island teems with life, yet somehow never changes.','',1,0,0,0,0,0,1,0,0,0,38869,0,26124),
(75182,'Until recently this place was lost in the mists. Those few inhabitants who found themselves stranded here were forced to mint their own currency, immune to time distortion. It is the only way trade is possible.','',1,0,0,0,0,0,1,0,0,0,38870,0,26124),
(75183,'As would I! The presence of the Timeless Isle is proof that many things are possible beyond the boundaries of linear thinking.','',1,0,0,0,0,0,5,0,0,0,38871,0,26124),
(75184,'Indeed. After the Cataclysm, my flight\'s connection to the timeways forever changed.','',1,0,0,0,0,0,1,0,0,0,38872,0,26124),
(75185,'What if it were possible to shape and mold time as you would a ball of clay? What possibilities await? What new worlds could we create?','',1,0,0,0,0,0,6,0,0,0,38873,0,26124),
(75186,'|TInterface\\Icons\\racial_orc_berserkerstrength.blp:20|t%s enters a |cFFF00000|Hspell:142879|h[Blood Rage]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75187,'I can see the emptiness in your soul, $n. In the end, it will be I who compels you!','',35,0,0,0,0,0,0,0,0,0,0,0,26124),
(75188,'Begin the compulsion of the All-Seeing Eye.','Begin the compulsion of the All-Seeing Eye.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75189,'|TInterface\\Icons\\racial_orc_berserkerstrength.blp:20|t%s\'s |cFFF00000|Hspell:142879|h[Blood Rage]|h|r subsides!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75190,'','Fools! These docks are under Dragonmaw control! Your ships will burn, and you with them!',0,0,0,0,0,0,0,0,0,0,0,38400,26124),
(75191,'','Reinforcements to the docks!  Lok\'tar Ogar!',0,0,0,0,0,0,0,0,0,0,0,38401,26124),
(75192,'','You think you have won? We are orcs! Pure of blood, commanded by the greatest Warchief who ever lived! Your blood will fill this bay!',0,0,0,0,0,0,0,0,0,0,0,38402,26124),
(75193,'','Dragonmaw clan, retake the docks and push them into the sea!  In the name of Hellscream and the True Horde!',0,0,0,0,0,0,25,0,0,0,0,38391,26124),
(75194,'','Next squad, push forward!',0,0,0,0,0,0,0,0,0,0,0,38393,26124),
(75195,'','Dragonmaw, advance!',0,0,0,0,0,0,0,0,0,0,0,38394,26124),
(75196,'','For Hellscream!',0,0,0,0,0,0,5,0,0,0,0,38395,26124),
(75197,'','For the True Horde!',0,0,0,0,0,0,5,0,0,0,0,38396,26124),
(75198,'','They\'ve breached the tower, bring it down!',0,0,0,0,0,0,0,0,0,0,0,38397,26124),
(75199,'','Then they will die an honorable death in combat!',0,0,0,0,0,0,0,0,0,0,0,38398,26124),
(75200,'','Turn the siege weapons to attack that tower, and bury them alive!',0,0,0,0,0,0,0,0,0,0,0,38399,26124),
(75201,'','Galakras, rain fire on them!',0,0,0,0,0,0,0,0,0,0,0,38403,26124),
(75202,'','Ahhhhhhh!',0,0,0,0,0,0,0,0,0,0,0,38392,26124),
(75203,'','High King! I\'ve brought reinforcements.',0,0,0,0,0,0,2,0,0,0,0,38095,26124),
(75204,'','I can open a portal to the docks... large enough to get a strike team through.',0,0,0,0,0,0,1,0,0,0,0,38096,26124),
(75205,'','The Dragonmaw are supporting the Warchief.',0,0,0,0,0,0,1,0,0,0,0,38097,26124),
(75206,'','We\'re going to need some serious firepower.',0,0,0,0,0,0,1,0,0,0,0,38098,26124),
(75207,'','Here they come!',0,0,0,0,0,0,1,0,0,0,0,38099,26124),
(75208,'','Help me!',0,0,0,0,0,0,0,0,0,0,0,38079,26124),
(75209,'','Oh... thank you!',0,0,0,0,0,0,0,0,0,0,0,38083,26124),
(75210,'','Nice shot!',0,0,0,0,0,0,0,0,0,0,0,38084,26124),
(75211,'','She\'s turning her siege weapons on her own towers!',0,0,0,0,0,0,0,0,0,0,0,38085,26124),
(75212,'','One down, one to go!',0,0,0,0,0,0,0,0,0,0,0,38086,26124),
(75213,'','It worked!  The Proto-drake is falling!',0,0,0,0,0,0,0,0,0,0,0,38087,26124),
(75214,'','We\'ve done it!',0,0,0,0,0,0,0,0,0,0,0,38088,26124),
(75215,'','We\'ll hold the docks for the remaining landing parties. Follow the path to the gates of Orgrimmar, and make contact with Vol\'jin and his revolutionaries.',0,0,0,0,0,0,0,0,0,0,0,38089,26124),
(75216,'','I\'ve conjured a Blizzard, lead them into it!',0,0,0,0,0,0,0,0,0,0,0,38100,26124),
(75217,'','I... can\'t... go on...',0,0,0,0,0,0,0,0,0,0,0,38078,26124),
(75218,'','Varian!  No!  Varian!!',0,0,0,0,0,0,0,0,0,0,0,38080,26124),
(75219,'','You\'re still alive! Good. There\'s chaos in the city streets.',0,0,0,0,0,0,1,0,0,0,0,38081,26124),
(75220,'','The Kor\'kron are making a push for this compound. They\'re not giving up!',0,0,0,0,0,0,5,0,0,0,0,38082,26124),
(75221,'You heroes are a sight for sore eyes. Vol\'jin\'s rebellion wasn\'t able to secure the bay. We\'re taking a pounding.','',0,0,0,0,0,0,1,0,0,0,38951,0,26124),
(75222,'Do it! Once the area is clear we will make landfall. Champions, I\'m counting on you.','',0,0,0,0,0,0,1,0,0,0,38952,0,26124),
(75223,'Well done! Landing parties, form up! Footmen to the front!','',0,0,0,0,0,0,25,0,0,0,38953,0,26124),
(75224,'Yes. My scouts learned all about this one.\"Warlord Zaela.\" Bring her proto-drake down and the rest of the Dragonmaw will crumble.','',0,0,0,0,0,0,1,0,0,0,38954,0,26124),
(75225,'Commandeer those towers! Turn the anti-air batteries around and blast her from the sky!','',0,0,0,0,0,0,25,0,0,0,38955,0,26124),
(75226,'Some of you should stay behind to hold the landing zone.','',0,0,0,0,0,0,1,0,0,0,38956,0,26124),
(75227,'I can\'t take much more of this!','',0,0,0,0,0,0,1,0,0,0,38940,0,26124),
(75228,'Thank you!','',0,0,0,0,0,0,1,0,0,0,38941,0,26124),
(75229,'A mighty blow!','',0,0,0,0,0,0,153,0,0,0,38942,0,26124),
(75230,'She\'s called in more siege weapons!','',0,0,0,0,0,0,1,0,0,0,38943,0,26124),
(75231,'That\'s both of them!  Fire the cannons!','',0,0,0,0,0,0,22,0,0,0,38944,0,26124),
(75232,'It\'s also coming right at us.  Watch out for the mouth!','',0,0,0,0,0,0,22,0,0,0,38945,0,26124),
(75233,'Ha!  The bigger they are...','',0,0,0,0,0,0,153,0,0,0,38946,0,26124),
(75234,'We will see if he has managed to keep up his end of the bargain.','',0,0,0,0,0,0,1,0,0,0,38947,0,26124),
(75235,'Bring them within reach of my blade!','',0,0,0,0,0,0,5,0,0,0,38957,0,26124),
(75236,'Jaina!  You ORCISH SCUM!','',0,0,0,0,0,0,53,0,0,0,38948,0,26124),
(75237,'Anduin...','',0,0,0,0,0,0,1,0,0,0,38939,0,26124),
(75238,'Our lines are holding, but Vol\'jin\'s rebels are taking a beating.','',0,0,0,0,0,0,1,0,0,0,38949,0,26124),
(75239,'We\'ll post up here with some troops. Scout on ahead and see if you can flush Garrosh out of hiding.','',0,0,0,0,0,0,1,0,0,0,38950,0,26124),
(75240,'We still have forces in that tower!','We still have forces in that tower!',0,0,0,0,0,0,5,0,0,0,39046,39046,26124),
(75241,'Bladefist Bay is fortified -- by the Sunwell, we\'re getting slaughtered!','',0,0,0,0,0,0,1,0,0,0,38163,0,26124),
(75242,'Heroes. Port over to the docks and take out their shore defenses. Put a stop to this bloodshed.','',0,0,0,0,0,0,1,0,0,0,38164,0,26124),
(75243,'Sylvanas! You will leave our corpses alone or I will deal with you here and now.','',0,0,0,0,0,0,5,0,0,0,38165,0,26124),
(75244,'... well, I suppose that\'s between you and the Alliance, isn\'t it?','',0,0,0,0,0,0,6,0,0,0,38166,0,26124),
(75245,'Well done. The first brigade has made landfall.','',0,0,0,0,0,0,1,0,0,0,38167,0,26124),
(75246,'Strategy, Dark Lady. We should repurpose the shore defenses.','',0,0,0,0,0,0,1,0,0,0,38168,0,26124),
(75247,'Heroes, take the towers, turn the guns onto that proto-drake, and blast it from the sky!','',0,0,0,0,0,0,5,0,0,0,38169,0,26124),
(75248,'Some of you will need to stay behind to hold the beachhead.','',0,0,0,0,0,0,1,0,0,0,38170,0,26124),
(75249,'I require assistance!','',0,0,0,0,0,0,5,0,0,0,38149,0,26124),
(75250,'Ah, much improved.','',0,0,0,0,0,0,273,0,0,0,38150,0,26124),
(75251,'Impressive!','',0,0,0,0,0,0,273,0,0,0,38151,0,26124),
(75252,'She seems to be assaulting her own towers!','',0,0,0,0,0,0,5,0,0,0,38152,0,26124),
(75253,'We are halfway there!','',0,0,0,0,0,0,5,0,0,0,38153,0,26124),
(75254,'Finally!  I will never get all of this dust out of my robes.','',0,0,0,0,0,0,5,0,0,0,38155,0,26124),
(75255,'I will take that as a compliment.  We\'ll hold the docks for now and marshall the forces. Vol\'jin should await you at the gates of Orgrimmar.','',0,0,0,0,0,0,1,0,0,0,38156,0,26124),
(75256,'I\'m summoning a Flamestrike, lead them into it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75257,'W...where...is this blood coming from?','',0,0,0,0,0,0,0,0,0,0,38148,0,26124),
(75258,'Oh my, what has overcome our Dark Lady?','',0,0,0,0,0,0,6,0,0,0,38157,0,26124),
(75259,'','I can raise your dead, Regent Lord. Your rangers can fight again.',0,0,0,0,0,0,1,0,0,0,0,38298,26124),
(75260,'','I\'m sorry to see your lack of commitment... What of the human corpses?',0,0,0,0,0,0,6,0,0,0,0,38299,26124),
(75261,'','Rise, my angels! Let your screams fill the streets of Orgrimmar with TERROR!',0,0,0,0,0,0,5,0,0,0,0,38300,26124),
(75262,'','Garrosh really has gone all-out this time, hasn\'t he?  I expected more spikes, honestly.',0,0,0,0,0,0,1,0,0,0,0,38304,26124),
(75263,'','I see the Dragonmaw have thrown in their lot with Garrosh.',0,0,0,0,0,0,1,0,0,0,0,38301,26124),
(75264,'','My arrows alone cannot bring that monstrosity down.',0,0,0,0,0,0,1,0,0,0,0,38302,26124),
(75265,'','Bring her down quick so I can wrap my fingers around her neck.',0,0,0,0,0,0,1,0,0,0,0,38303,26124),
(75266,'','I will not fall, not here, not now!',0,0,0,0,0,0,0,0,0,0,0,38289,26124),
(75267,'','I feel better already.',0,0,0,0,0,0,0,0,0,0,0,38290,26124),
(75268,'','A bold move.',0,0,0,0,0,0,0,0,0,0,0,38291,26124),
(75269,'','She\'s attacking the towers again.',0,0,0,0,0,0,0,0,0,0,0,38292,26124),
(75270,'','You do realize we are directly below it, right?',0,0,0,0,0,0,0,0,0,0,0,38294,26124),
(75271,'','Oh, you\'re still here?  I had kind of hoped that you had perished.  You would make a very attractive corpse.',0,0,0,0,0,0,0,0,0,0,0,38295,26124),
(75272,'','If he\'s not dead.',0,0,0,0,0,0,0,0,0,0,0,38296,26124),
(75273,'','A hail of death approaches! Bring them to their fate!',0,0,0,0,0,0,5,0,0,0,0,38305,26124),
(75274,'','I can\'t wait to see the look on his face when I animate his corpse.',0,0,0,0,0,0,0,0,0,0,0,38297,26124),
(75275,'','I will... rise... again...',0,0,0,0,0,0,0,0,0,0,0,38288,26124),
(75276,'','Light the fuses! They will not leave this tower alive!',0,0,0,0,0,0,5,0,0,0,0,38740,26124),
(75277,'','Is that all you\'ve got?',0,0,0,0,0,0,153,0,0,0,0,38742,26124),
(75278,'','At least... I die... with honor...',0,0,0,0,0,0,0,0,0,0,0,38741,26124),
(75279,'You dare try to take my tower?  Hahaha...','',0,0,0,0,0,0,574,0,0,0,38737,0,26124),
(75280,'I am Dragonmaw, I am the blood of the Dragon and the fist of the Horde!','',0,0,0,0,0,0,5,0,0,0,38739,0,26124),
(75281,'You... cannot win... this war...','',0,0,0,0,0,0,0,0,0,0,38738,0,26124),
(75282,'','Where did my father put his notes? Surely they must be around here somewhere...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75283,'','How am I supposed to make secret ingredient soup without the secret ingredient?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75284,'','Drat, how am I supposed to run the family noodle cart if I don\'t know our family recipe?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75285,'Who wants soup!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(75286,'Ah, new customers. Welcome!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75287,'The secret to good noodle soup begins with strong, thick noodles!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75288,'The soup must be piping hot to warm the soul!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75289,'Leaving so soon? Do come again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75290,'Leaving so soon? Be sure to tell your friends to stop by the Lin family noodle cart for some secret ingredient noodle soup.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75291,'Time to close already? Well, I guess I should get home to Chao-Wei.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75292,'Godspeed, heroes. It will be an honor to fight alongside you in battle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75293,'Welcome to the party, $n.  Would you like to receive a lesson in how to fight with minions?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75294,'I\'ve brewed up a real fight if you think you can handle it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75295,'Pet battles are the most awesome force that Azeroth has ever seen, but I\'ve seen those that wield it like a kid that\'s found his father\'s crossbow.  What about you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75296,'The Celestial Tournament is nearly as old as Pandaria itself.  Many have come to test their mettle.  Shall we test yours?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75297,'','Did you come to see my pretty face, or are you looking for a fight?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75298,'Never thought I was any good with animals \'til these little fellas started showin\' up.  So what do ye say, wanna fight?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75299,'My monks were shrunken by a troll witch doctor, and thus meet the size requirements for battle.  Do you wish to face them in combat?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75300,'Can you face the living waters and evade defeat?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75301,'Congratulations on your lucky win.  May your gift packages be filled with dead moles.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75302,'Well done, $n.  You fight as well as I can drink!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75303,'Well I, uh, I need to rethink everything.  Everything!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75304,'You have beaten me today, but you will need all the virtues to take on the Celestials.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75305,'','The lone wolf dies but the pack survives.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75306,'How do ye even HEAL an undead raccoon?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75307,'It appears we have more training to do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75308,'You fight with the ferocity of a raging river.  Let us hope you do not run dry.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75309,'Welcome to a very special trial!  The wisdom of a leader is reflected in the greatness of his followers. Let us see if your training has truly inspired those you lead...','',0,0,0,0,0,0,0,0,0,0,38044,0,26124),
(75310,'In this trial, you will not be allowed to heal your pets.  One of the marks of a great leader is the ability to lead many subjects from many backgrounds, united under one banner.','',0,0,0,0,0,0,0,0,0,0,38031,0,26124),
(75311,'Today, you will face many trainers, who have honed their skills and proven themselves.  Will your pets tell the same story about you?  We shall see!  Good luck!','',0,0,0,0,0,0,0,0,0,0,38032,0,26124),
(75312,'Ah, you have raised your pets well, and beaten some of Pandaria\'s most seasoned and charismatic trainers.  But the trial is not over, oh no!','',0,0,0,0,0,0,0,0,0,0,38033,0,26124),
(75313,'You shall face off against the true visages of wisdom, strength, fortitude, and hope - the children of the Celestials themselves!  Be warned, they have power and abilities the likes of which have not been seen for generations.','',0,0,0,0,0,0,0,0,0,0,38034,0,26124),
(75314,'Hurrah for our new champions!  You have shown your own inner strength, and it is reflected in those you have raised.  They are lucky to have such a strong leader.  May the lessons of the Celestials light your way in the most trying of times.','',0,0,0,0,0,0,0,0,0,0,38035,0,26124),
(75315,'Here we are, at the precipice of war. Signal to me when your troops are in order and I will issue the command to attack.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75316,'How many have to die before Garrosh\'s bloodlust is sated? It is with both shame and honor that I storm the walls of Orgrimmar, but I am glad to have you heroes at my side.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75317,'This is where it matters, hero. You may signal to me when you are ready to press the attack. Oh, and, do try to keep Lady Sylvanas in line, would you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75318,'I will do my best, Regent Lord. My troops are ready.','I will do my best, Regent Lord. My troops are ready.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(75319,'My troops are yours to command, my King.','My troops are yours to command, my King.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(75320,'Tell my story...','Tell my story...',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(75321,'','Well met, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75322,'I\'m ready to discover the secret ingredient in the Lin family\'s secret ingredient noodle soup!','I\'m ready to discover the secret ingredient in the Lin family\'s secret ingredient noodle soup!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75323,'This will begin a solo scenario. Are you sure you wish to proceed?','This will begin a solo scenario. Are you sure you wish to proceed?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75324,'','Grom\'gar is to the southeast. Look for the gigantic skeleton - you can\'t miss it.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75325,'','I don\'t think Karg is out this far.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75326,'','Grom\'gar. Built in the corpse of a colossus. Look at the size of that thing...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75327,'The door barring the South Tower has been breached!','The door barring the South Tower has been breached!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75328,'','There he is! Karg!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75329,'The door barring the North Tower has been breached!','The door barring the North Tower has been breached!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75330,'','I\'m not sure I want to see this thing\'s rear end.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75331,'In the name of Warchief Garrosh, hold the line!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75332,'Crush them with iron! Drown them in blood!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75333,'For the honor of our fallen, kill them all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75334,'It burns!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75335,'No more!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75336,'I\'ll show you nothing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75337,'Reffus lliw uoy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75338,'Your ancestors will languish!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75339,'I will eat your soul!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75340,'Aaaaaghh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75341,'Lovely day for a compulsion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75342,'Galakras staggers, but recovers from the blast!','Galakras staggers, but recovers from the blast!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75343,'%s is blasted off of her mount!','%s is blasted off of her mount!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75344,'Run for it!!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75345,'Elune\'s radiance grant me strength!','Elune\'s radiance grant me strength!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75346,'Bask in... the light of Elune... and... reveal all, demon!','Bask in... the light of Elune... and... reveal all, demon!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75347,'The power of Elune compels you!','The power of Elune compels you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75348,'Blarggggrgggrggrrr!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75349,'Ahahahahaha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75350,'No more! I will turn my gaze upon Gul\'var for you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75351,'I will crush it! (The Pale are the key.)','',0,0,0,0,0,0,0,0,6,0,46624,0,26124),
(75352,'The sprites look angry! Kill them while you can!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75353,'Welcome $n. Come, have a seat.','Welcome $n. Come, have a seat.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75354,'I heard that this place has great noodle soup.','I heard that this place has great noodle soup.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75355,'I sure am hungry.','I sure am hungry.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75356,'I heard they discovered the lost secret of the Lin family\'s secret ingredient noodle soup.','I heard they discovered the lost secret of the Lin family\'s secret ingredient noodle soup.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75357,'Finally got a seat, now what to eat?','Finally got a seat, now what to eat?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75358,'Which noodle soup should I have?','Which noodle soup should I have?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75359,'There are so many choices, I can\'t decide!','There are so many choices, I can\'t decide!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75360,'This is so delicious!','This is so delicious!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75361,'Ah.. noodle soup always refreshes both my body and my soul.','Ah.. noodle soup always refreshes both my body and my soul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75362,'I\'ve never had such excellent noodle soup before. What\'s the secret?','I\'ve never had such excellent noodle soup before. What\'s the secret?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75363,'The service here is really slow.','The service here is really slow.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75364,'I can\'t wait anymore, I\'ll go to Stoneplough. I hear they\'re cooking some Chimaerok Chops over there.','I can\'t wait anymore, I\'ll go to Stoneplough. I hear they\'re cooking some Chimaerok Chops over there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75365,'This place won\'t stay in business long if they keep this up.','This place won\'t stay in business long if they keep this up.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75366,'This is okay; but not really what I wanted, shouldn\'t the chef know what I want?','This is okay; but not really what I wanted, shouldn\'t the chef know what I want?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75367,'I\'ve had better.','I\'ve had better.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75368,'Mmm, not spicy enough for my liking.','Mmm, not spicy enough for my liking.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75369,'No... It cannot end...like this...What I... What I have seen...','',0,0,0,0,0,0,0,0,1,0,38046,0,26124),
(75370,'%s prepares a |cFFFF0404|Hspell:143343|h[Deafening Screech]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75371,'The priestess of the moon also has something to ask of you.','',0,0,0,0,0,0,0,7,0,22214,44992,0,26124),
(75372,'','Be careful. It\'s likely the rock has attracted the creatures of the woods.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(75373,'%s is devoured by Thok the Bloodthirsty!','%s is devoured by Thok the Bloodthirsty!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75374,'Unlike you, your minions are adorable.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75375,'I have been programmed to gloat.  Ha ha.  Ha ha.  Ha ha.','',0,0,0,0,0,0,11,0,0,0,0,0,26124),
(75376,'This is unfortunate.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75377,'Now for a real pet.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75378,'How does that feel, $r?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75379,'If I had emotions, I still wouldn\'t feel sad about that.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75380,'A large device of unknown origin hums in front of you. Several words are scratched into the side:\n\n|TInterface\\Icons\\inv_gizmo_02:20|t |cFFDD2222[Goblin-Titan control module]|r\n\nIt appears to be protected by a voice-recognition module.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75381,'Kick the machine.','Kick the machine.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75382,'Xuen will not be defeated. He is grace in battle.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75383,'They stand no chance against Xuen.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75384,'I am glad that I am not the one down there.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75385,'','Welcome, $n. I\'ve had the market area cleared to make room for Halfhill\'s first noodle stand, run by you!',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(75386,'This will be a battle to tell your friends about, Eli.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75387,'','Customers will line up and wait for you to tell them to sit down. They will only wait for a short while before leaving so be sure to get them to a seat before they leave.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75388,'','Once seated, a customer will wait a short while for you to deliver their noodle soup. As with waiting in line, be sure to get the customer their food before they decide to leave.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75389,'','Some tips: You can always tell what a customer wants by their outfit.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75390,'','Some customers are hungry, they\'ll want a second bowl after they finish their first.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75391,'Be careful. I would not want you to fall into the arena.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75392,'','Other customers are impatient, they won\'t wait as long; but are really happy when they are served quickly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75393,'','Now get out there and make some noodle soup!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75394,'Wow, I have quite an appetite today!','Wow, I have quite an appetite today!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75395,'Your minion has been terminated.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75396,'My olfactory sensors detect a burning odor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75397,'Too bad.  Now for a real pet.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75398,'You\'ll pay for that.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75400,'|TInterface\\Icons\\sha_ability_rogue_sturdyrecuperate.blp:20|t The %s begins to cast |cFFF00000|Hspell:144563|h[Imprison]|h|r!','|TInterface\\Icons\\sha_ability_rogue_sturdyrecuperate.blp:20|t The %s begins to cast |cFFF00000|Hspell:144563|h[Imprison]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75401,'This place is remarkable, don\'t you think?','',1,0,0,0,0,0,1,0,1,0,0,0,26124),
(75402,'Hey there, $n. Won\'t you try some of my hot noodle soup?','Hey there, $n. Won\'t you try some of my hot noodle soup?',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(75403,'The tower reinforcements will not abandon their post!','The tower reinforcements will not abandon their post!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75404,'','Burn, baby, burn!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75405,'','This place is really heating up!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75406,'','Who ever said fire can\'t be beautiful?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75407,'Nobody understands me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75408,'Everybody has fun but me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75409,'Why come they make me watch stupid dead wolves?...  no fair.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75410,'','My vigil never ends, but I cherish this short reprieve in my duty.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75411,'','A good battle always makes my adrenaline rush.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75412,'','There are many gathered here from many walks of life. Today, we are all equal as audience to these epic battles.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75413,'Why so surprised, $n?$b$bIt is as I have always told you. Pandaria is a wondrous land full of secrets and mysteries.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75414,'','Facing the celestials will test your resolve, question your skills, and call forth your greatness.$B$BAre you prepared?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75415,'','It is unfortunate that this is not a contest of brewing. Never have I seen so many brewmasters gathered at once!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75416,'','Let us see this day who defeats a celestial, and who is themselves defeated.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75417,'','After all the Alliance has done to the pandaren, they still allow them here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75418,'','Perhaps we will be fortunate enough to watch an Alliance dog get torn limb from limb.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75419,'','May the warchief guide you to victory.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75420,'You want to fight celestials. Eh, wikket?$B$BKah Kah glad to watch, but not help.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75421,'Ookin\' jinyu shouldn\'t be here!$B$B$n $n want help Kah Kah ook some jinyu?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75422,'Want to give Kah Kah some of your shinies?$B$BThink of all the grookin\' Kah Kah could do with a weapon like that!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75423,'Who would\'ve thought this sort of place existed when we first saw Pandaria from Hellscream\'s Fist?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75424,'Two words: Ka-boom!$B$BAll I\'m sayin\' is that this shindig could benefit from a powder keg or two.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75425,'I\'m workin\' on a new invention that\'s goin\' to blow your mind!$B$BAnd probably maim other body parts.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75426,'','Let\'s see a good fight!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75427,'','This sure is exciting, isn\'t it?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75428,'','It\'s so nice to have a break from fighting the sha.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75429,'','Fei Li needs to chill with all the fireworks.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75430,'Keep it down! Stupid dog.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75431,'','There is a serenity to this place. It is untainted by the wars that ravage the mainland.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75432,'','Stay true to yourself always, and your resolve will be that of a mighty glacier.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75433,'Players capture control of the North Tower Anti-Air Turret!','Players capture control of the North Tower Anti-Air Turret!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75434,'A mantid tried to follow me here.$B$BIt didn\'t end well for him.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75435,'There is much adventure to be had on this isle!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75436,'Here to join in on the fun, I see!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75437,'Relax. You are among friends.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75438,'Remain vigilant, but do not forget to enjoy the finer things in life. Good food, good friends, and good drink!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75439,'We can learn much by watching others do battle.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75440,'','It is truly an honor to be in the presence of Xuen and the other celestials.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75441,'','I don\'t think I could ever challenge one of the celestials.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75442,'','They say time does not affect this island. There must be many amazing things to find here!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75443,'I\'ve never seen anything like the water here. It speaks, but I know not what it says.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75444,'Fight well, and bring honor to your people!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75445,'You fight with great skill and purpose. I hope to one day follow your path.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75446,'|TInterface\\Icons\\achievement_dungeon_ulduarraid_titan_01.blp:20|t You have been blessed with |cFFF00000|Hspell:144359|h[Gift of the Titans]|h|r!','|TInterface\\Icons\\achievement_dungeon_ulduarraid_titan_01.blp:20|t You have been blessed with |cFFF00000|Hspell:144359|h[Gift of the Titans]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75447,'','Once a customer is done eating, the seat they were using will need to be cleaned. Just click on them and I\'ll go clean up.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75448,'I\'m thinking about jumping in the ring myself... just not right now.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75449,'After fighting the mogu, how much stronger could any other foes really be?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(75450,'Stand up straight!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75451,'The Celestial Tournament tests your leadership skills through pet battles with other contestants, and if you are successful enough, the children of the celestials.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75452,'Sorry boss...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75453,'I\'d like to enter the Celestial Tournament.','I\'d like to enter the Celestial Tournament.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75454,'What can I buy with Celestial Coins?','What can I buy with Celestial Coins?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75455,'I feel drawn to Chi-Ji. Maybe the Red Crane will impart some of its wisdom to me.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75456,'Everybody fighting in the good way. Everybody drinking. Everybody happy!','',4,0,0,0,0,0,0,0,0,0,0,0,26124),
(75457,'You need drink! Drink! Be happy!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75458,'It good thing that this place is timeless. Ken-Ken hopes this never ends!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75459,'It is good to see Niuzao healthy and strong.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75460,'We must enjoy this time together before yet more conflict arrives on our doorsteps.','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(75461,'It has been quite some time since I have been so at ease!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75462,'I\'m not a fighter. I grow vegetables and raise yaks.$B$BYou fight, I\'ll watch.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75463,'Champion... you\'ve done it...','',1,0,0,0,0,0,5,0,0,0,38366,0,26124),
(75464,'How\'d you like to make yourself useful and top me off?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75465,'Few mortals possess such spirit, such power. Believe me - I have tested many!','',1,0,0,0,0,0,1,0,0,0,38367,0,26124),
(75466,'I\'m thinking of trying to grow some crops here.$B$BCan you imagine what might happen if I planted an engima seed?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75467,'To complete our great work, we will need a sacred place.','',1,0,0,0,0,0,1,0,0,0,38368,0,26124),
(75468,'Travel to the Vale of Eternal Blossoms, and meet me at the Seat of Knowledge.','',1,0,0,0,0,0,1,0,0,0,38369,0,26124),
(75469,'A legend is born!','',1,0,0,0,0,0,0,0,0,0,38106,0,26124),
(75470,'What are the requirements to enter the Celestial Tournament?','What are the requirements to enter the Celestial Tournament?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75471,'Only those who have trained extensively can enter the tournament.\n\nWhen you have trained 15 pets to their maximum level, you will be deemed ready.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75472,'Tell me about the tournament again.','Tell me about the tournament again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75473,'Lokra! My love! What are you doing here?!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75474,'','What\'s it look like? Saving your hide!',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(75475,'','Where is Nerok?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75476,'We were separated. Where is Asha?','',0,0,0,0,0,0,547,0,1,0,0,0,26124),
(75477,'Hmph. I always knew Draka was stronger than she let on.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75478,'These here chicks might be small right now, but they grow up fast!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75479,'Less fightin\', more farmin\'. That\'s the life, I tell ya.$B$B\'Course, if yer doin\' the fightin\', I don\'t mind watchin\'.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75480,'Humph. Back in my day, we had to walk uphill both ways in the snow to see a celestial.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75481,'','I would gladly fight by your side, but you do not require my assistance.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75482,'','I am excited to see the full potential from a true $c.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75483,'','The arena is a bit loud for my tastes, but it is worth it to witness such a spectacle.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75484,'','Do you like my outfit today?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75485,'','I wish you the best of luck on your adventures here!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75486,'','I can\'t believe both Farmer Yoon and Farmer Fung are here!$B$BWhat\'s a girl to do?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75487,'How\'s about we sit down and chat over a nice cold brew?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(75488,'A lot of the Tillers came here to watch the fights. Nothing like a good brawl and a cold brew!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75489,'Have a good fight, but don\'t forget to tend to your farm afterwards!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75490,'A good bout in the arena will keep you strong for future trials.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75491,'There are many hidden things on this island. You should seek them out.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75492,'It is always good to see a strong $r like yourself.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75493,'This is history in the making...','',1,0,0,0,0,0,5,0,0,0,38015,0,26124),
(75494,'I sure am a long way from home!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75495,'...Interesting.','',1,0,0,0,0,0,1,0,0,0,38866,0,26124),
(75496,'I\'ve never fought much, but this is exciting!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75497,'Wow, what a fight!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75498,'Hero, you are an inspiration!','',1,0,0,0,0,0,0,0,0,0,38218,0,26124),
(75499,'','This will make for a good story, don\'tcha think?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(75500,'I knew you were destined for greatness.','',1,0,0,0,0,0,0,0,0,0,38023,0,26124),
(75501,'','I\'ve been wrastlin\' celestials all mornin\'!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75502,'An opportunity presents itself! I believe the Timeless Isle holds the key to unlocking the full potential of your cloak.','',0,0,0,0,0,0,0,0,5,0,38383,0,26124),
(75503,'An island, lost in time, where the sun never sets. What could it mean?','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(75504,'Power! Glory! Loot!','',0,0,0,0,0,0,0,0,5,0,38384,0,26124),
(75505,'...Ours for the taking! Hero, meet me at the Timeless Isle.','',0,0,0,0,0,0,0,0,5,0,38385,0,26124),
(75506,'','There\'s so much going on! Isn\'t it exciting?',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(75507,'I should very much like to see this island for myself. Perhaps I will see you there?','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(75508,'Woo! You ook \'em good!','',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(75509,'How\'s it goin\', boss? Drink a brew for Mung-Mung!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75510,'Mung-Mung tried some of the beer at Pi\'jiu. Terrible!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75511,'You\'re going to die in horrible pain, $p!','',0,0,0,0,0,0,0,0,1,22373,0,0,26124),
(75512,'Since I\'m not farming right now, this is a great way to pass the time!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75513,'Don\'t forget to take a break between battles. A good $c knows when not to fight.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75514,'Not bad.','',1,0,0,0,0,0,0,0,0,0,38753,0,26124),
(75515,'The might of the Burning Legion will fall upon your worlds!','',0,0,0,0,0,0,0,0,1,22373,0,0,26124),
(75516,'A succulent priestess of the moon. What a tasty morsel you\'ll make, delightful Delas.','',0,0,0,0,0,0,0,0,1,22373,0,0,26124),
(75517,'I see all! Not one of you will escape my wrath!','',0,0,0,0,0,0,0,0,1,22373,0,0,26124),
(75518,'Mung-Mung is too impatient to farm on his own.$B$BI am trying to help him take things more slowly.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75519,'Ah... the inestimable Khadgar. Your suffering will be legendary.','',0,0,0,0,0,0,0,0,1,22373,0,0,26124),
(75520,'Draenor is nothing. It will fall, just as Argus fell. Just as your world will soon be consumed!','',0,0,0,0,0,0,0,0,1,22373,0,0,26124),
(75521,'$p, set me free and I will reward you beyond your wildest dreams!','',0,0,0,0,0,0,0,8,1,22373,0,0,26124),
(75522,'This pitiful trap cannot hold me. Better that you let me go now while I still might grant you a quick death.','',0,0,0,0,0,0,0,0,1,22373,0,0,26124),
(75523,'','Oh! Hello there! I... um... didn\'t expect to see you here!$B$B<Ella looks back to the arena suddenly.>',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75524,'The pandaren will sing your praises for ages to come.','',1,0,0,0,0,0,0,0,0,0,38219,0,26124),
(75525,'','The pink cranes are beautiful!$B$BI mean... if you wanted to know...',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75526,'','Oh, I really should go check on my cats. I hope they\'re okay!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75527,'This place is quite strange. There is powerful magic everywhere around us.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75528,'I dare not create a portal here. The results could be... interesting.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75529,'I have heard that there are many hidden treasures on the island.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75530,'Face my axe!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75531,'','For the Frostwolf clan!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75532,'What\'s this?! A couple of stray mutts, who need to be put down!','',0,0,0,0,0,0,0,0,1,23991,0,0,26124),
(75533,'','I will never forget my father\'s sacrifice.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75534,'URGH! Damn... unruly dogs...','',0,0,0,0,0,0,0,0,1,23991,0,0,26124),
(75535,'You should have killed me when you had the chance. Now where is my wolf?!','',0,0,0,0,0,0,397,0,1,0,0,0,26124),
(75536,'I know. We\'d better find him before that happens.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75537,'','Being broken? Nerok would die before he obeyed them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75538,'','I would be lying if I said that I did not appreciate this opportunity to relax.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75539,'','These matches remind me of my time training as a young recruit.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75540,'There is no room for war here.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75541,'Fight with honor always.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75542,'A soldier\'s duty is never done.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75543,'','Stop, summoner. Spare my people, and you\'ll find what you seek below us, at The Arbitum.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75544,'Deploy the gear! Establish a perimeter!','',0,0,0,0,0,0,0,0,0,0,38184,0,26124),
(75545,'Oh, hello friends! We\'ve just about secured the surface. It looks like the real fight\'s going to be down here!','',0,0,0,0,0,0,0,0,0,0,38185,0,26124),
(75546,'Don\'t worry, we\'ve got your back! Forge ahead, brave heroes!','',0,0,0,0,0,0,0,0,0,0,38186,0,26124),
(75547,'Oh, look at her over there.  She\'s be beautiful.  A perfect 10!','',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(75548,'A 10? Ha! Maybe in Razor Hill.  In Orgrimmar she\'d only be a 6.','',11,1,0,0,1,0,0,0,0,0,0,0,26124),
(75549,'','Did you hear that Tina Mudclaw is here?$B$BI wonder if Farmer Yoon or Farmer Fung have noticed...',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75550,'','It is so relaxing to not have to run the market for once.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75551,'','I should have brought a cart with me. There\'s money to be made here!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75552,'Power... drained...','Power... drained...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75553,'Your strength has helped free this land of its long held darkness. It is my honor to witness your deeds with my own eyes, Champion.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(75554,'So weak...','So weak...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75555,'The dark star fails me...','The dark star fails me...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75556,'No...','No...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75557,'This tree stands as a symbol of hope. Hope that the land might in time be healed and made stronger by your deeds.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75558,'You continue to impress me, $n.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75559,'It is too late, Priestess. We know of your precious \"prophecy.\"','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(75560,'Now... tell me where the Iris crystals are guarded, or watch more of your companions die.','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(75562,'','There is much work ahead of us if we are to heal the land and mend our wounds. But thanks to your deeds we no longer must work in the shadow of the seven breaths of Y\'Shaarj.$b$bIn time, the sha will cease to be, and your name will be remembered with the reverence of the last emperor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75563,'How about a drink, $c?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(75564,'Fight with purpose, friend.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75565,'','It is truly admirable to do combat with a celestial.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75566,'','There is always value  in spending time with old friends.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75567,'','This island holds many secrets that have yet to be uncovered.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75568,'Fortune smiles on us this day. There are many people to deliver things to.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75569,'You have the stride of a champion, $r.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75570,'A good grummle is a busy grummle!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75571,'May your brews be strong, and your heart stronger.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75572,'Your story continues on, friend.$B$BIt is a story worth reading.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75573,'You fight like a true $r.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75574,'There is no greater joy than walking the world, writing your story.$B$BIt is the wanderer\'s way.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75575,'An occasion like this calls for a drink!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75576,'','Wanna go explore the island together?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(75577,'','Have you seen the fireworks? They\'re beautiful!',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(75578,'','The celestials are so huge!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75579,'','Wow, you must be a $c, huh?$B$B$Cs are the best!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75580,'The Shadowmoon came without warning. Quickly, champion, help us defend the upper platform!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75581,'Fighting and beer. There is no greater place than this.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75582,'Next round\'s on me!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75583,'Today is a good day.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75584,'I\'ve got agents on every continent in the world and none of them can give me a clear picture of what happened in Orgrimmar!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75585,'Idiot king!','',0,0,0,0,0,0,5,0,0,0,38863,0,26124),
(75586,'You can never leave this place. There is no way home.','',0,0,0,0,0,0,0,0,1,0,38778,0,26124),
(75587,'You will die when you leave this place.  There is nothing left of your world.','',0,0,0,0,0,0,0,0,1,0,38779,0,26124),
(75588,'You have already lost.','',0,0,0,0,0,0,0,0,1,0,38780,0,26124),
(75589,'All of your friends are dead.','',0,0,0,0,0,0,0,0,1,0,38781,0,26124),
(75590,'No one is coming to save you.','',0,0,0,0,0,0,0,0,1,0,38782,0,26124),
(75591,'Your allies will leave you behind.','',0,0,0,0,0,0,0,0,1,0,38783,0,26124),
(75592,'You cannot succeed. Your cause is hopeless.','',0,0,0,0,0,0,0,0,1,0,38784,0,26124),
(75593,'Your allies think you are weak.','',0,0,0,0,0,0,0,0,1,0,38785,0,26124),
(75594,'You do not have the strength to defeat him. You are too weak to carry on.','',0,0,0,0,0,0,0,0,1,0,38786,0,26124),
(75595,'','|cFFFF8040Ki the Assassin |r|cFF71D5FF|Hspell:145427|h[Kick]|h|r|cFFFF8040s the $n.|r',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(75596,'','|cFFFF8040Kavan the Arcanist |r|cFF71D5FF|Hspell:145530|h[Counterspell]|h|r|cFFFF8040s the $n.|r',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(75597,'','The lights went out here at the Observatory shortly before the Shadowmoon attacked.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75598,'','From Teluuna Observatory, we watch the movements of the stars.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75599,'','The Prophet\'s work is very important.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75600,'','I have studied the Light since I was a young girl.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75601,'','The stars can tell us much about our past and future, if you only know how to read the signs.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75602,'','Sometimes, on a cold dark night, I can hear a voice from the distant stars. <Sylene laughs nervously.> That\'s silly, isn\'t it?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75603,'','The Shadowmoon orcs are powerful shaman.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75604,'','Some say the moon is a seductress, luring wanderers with her silvery light. Those who drink in too much of her glow... can lose their minds.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75605,'For Warchief Garrosh!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75606,'Please come down, Fish. It isn\'t safe up there.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75607,'If you fall off, I\'m not going in after you!','',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(75608,'Please, come down. How am I ever going to explain this to the rest of the Tillers?','',20,0,0,0,0,0,0,0,0,0,0,0,26124),
(75609,'Fine, fall off. I don\'t care.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75618,'I\'ve learned so much about brewing. I haven\'t gotten my brew just right yet, but it\'s getting there!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75619,'What do you currently have in stock?','What do you currently have in stock?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75620,'I give myself to you, dark star...','I give myself to you, dark star...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75621,'Void, hear my call!','Void, hear my call!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75622,'I give myself unto the void...','I give myself unto the void...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75623,'Voidy voidy void void...','Voidy voidy void void...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75624,'','How about a nice brew?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(75625,'','You look like you could use a drink.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75626,'','Fighting isn\'t fighting without a fine ale!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75627,'There\'s nothing better than a fine brew!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75628,'How about another round?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(75629,'You are what you drink, $n -- I hope you have been drinking something strong.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75630,'You fought well, but your tactics are all wrong.  Have a drink and and rethink them.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75631,'Look at this, I have been beaten!  I\'m going to have to brew up some ideas for next time.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75632,'Why did he fight?  To die, apparently.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75633,'The wind blows in my favor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75634,'A fortunate attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75635,'I knew that was coming.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75636,'Such a glorious defeat!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75637,'Rest for now, little friend.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(75638,'Maybe, uh, maybe you\'re ready for a lesson in chaos?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(75639,'You were so preoccupied with whether or not you could win, you didn\'t stop to think if you should.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75640,'Gee, the lack of humility before nature that\'s being displayed here, uh... staggers me.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75641,'What\'s so great about victory? It\'s a violent, penetrative act that scars what it explores. What you call victory... well, nevermind.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75642,'Dead?  Don\'t you mean extinct?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75643,'Your pet had its shot, and nature selected it for extinction.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75644,'I\'m, I\'m simply saying that life, uh... didn\'t find a way.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75645,'That\'s, that\'s chaos theory.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75646,'What have you got on that team of yours, King Mukla?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75647,'Dinos... dropping?  Dropping?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75648,'You now face Patience!  Wisdom!  Knowledge!  What virtues do you possess, $n?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75649,'Today you have lost -- but what have you learned?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75650,'You have taught me much, $r.  It seems the master has again become the student.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75651,'A worthy sacrifice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75652,'The autumn leaves must fall to make room for spring blossoms.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75653,'Defeat is merely a lesson masked by disappointment.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75654,'Like the stream meeting the cliff, there is beauty in the fall, if you know where to look.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75655,'To die would be a wonderfully grand adventure.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75656,'When one virtue is lost, cling to those that remain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75657,'A worthy sacrifice?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75658,'','Oh, I hope you like surprises.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75659,'','You\'re lucky it was just your pets... this time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75660,'','In the Celestial Tournament, either you win or you die.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75661,'','Take the right opponent out and it\'s all downhill from there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75662,'','Oh, was that one of your favorites?  My bad.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75663,'','This is so easy it would be boring -- if it weren\'t so much fun.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75664,'','You bastard, my pet may never walk again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75665,'','The things we love destroy us every time, $c, remember that.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75666,'','Keep killing my pets and you may find a dash of poison in your drink tonight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75667,'','Fear cuts deeper than swords.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75668,'Yer lucky Gizmo couldn\'t be here, but I\'ll still wipe the floor with ye, $c.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75669,'That one\'s for you, Gizmo!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75670,'Ach, so much for being good with animals. Now how do these bandages work?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75671,'Ha!  That worked better than I thought!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75672,'Oh, sorry, that fella\'s gunna need some tender lovin\' later.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75673,'Fer a moment there, I thought we were in trouble.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75674,'No! Not again!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75675,'Curse my dwarven luck!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75676,'Oi, you\'ll pay for that one you will!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75677,'Do not be fooled by their diminutive size, $n, they are disciplined and quick.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75678,'Impatience is the road to defeat, you must learn to master your timing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75679,'It requires a cunning strategist indeed to defeat my monks.  Well done, $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75680,'Exactly as I had planned.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75681,'You lack the necessary discipline.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75682,'Can you survive with what remains?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75683,'He fought and died with honor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75684,'Victory often requires sacrifice.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75685,'When one Shado-Pan falls, another steps forward to take his place.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75686,'As water cracks stone, so shall we be your undoing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75687,'The rivers foretold of this triumph.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75688,'The rivers foretold of this defeat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75689,'And so they are washed away with little trace of what once was.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75690,'The stone thinks itself unmovable until the ground is washed away beneath it.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75691,'Cleansed by the righteous waters!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75692,'My companion is dispersed.  She will flow back to me when the time is right.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75693,'The river does not stop from a single stone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75694,'The ebbs and flows of battle are to be expected.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75695,'The eons have awakened me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75696,'Dragons are dangerous at any size, as I\'m sure you\'ll find out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75697,'If I can win a battle like that, I may have a chance against the Celestials.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75698,'Well done, $n.  You picked your friends wisely and led them with honor.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75699,'As I warned you before, dragons are known for their deadly attacks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75700,'Even the strongest ally can fall to draconic magic.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75701,'A glass cannon sometimes breaks before it can fire.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75702,'You have strength I didn\'t see at first.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75703,'An unexpected move.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75704,'It will be difficult to recover from such a loss.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75705,'Zooooooooom!','',0,0,0,0,0,0,0,0,0,0,38641,0,26124),
(75706,'Do not despair the damage that was done here.','',0,0,0,0,0,0,0,0,7,0,39079,0,26124),
(75707,'A long time ago, this land was beset by the shadows of doubt, of fear, and hatred.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(75708,'One by one, I overcame them - and buried them deep within the earth.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(75709,'And there ... they remained.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(75710,'For ten thousand years ... as the veil of mists kept Pandaria hidden from prying eyes.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(75711,'When the Cataclysm struck, I decided the time had come to part the mists ... and help heal our broken world.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(75712,'But as your war-fleets crashed upon our shores, all of my old doubts and fears rose up, to torment the land once again.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(75713,'You triumphed over the darkness I had locked away.','',0,0,0,0,0,0,0,0,7,0,39080,0,26124),
(75714,'You have shown Pandaria the power of a true hero.','',0,0,0,0,0,0,0,0,7,0,39081,0,26124),
(75715,'But the question still remains... why do we fight?','',0,0,0,0,0,0,0,0,7,0,39082,0,26124),
(75716,'Face your fears. Calm your hatreds.','',0,0,0,0,0,0,0,0,7,0,39084,0,26124),
(75717,'Find peace within yourself, so that you may share it with the world around you.','',0,0,0,0,0,0,0,0,7,0,39085,0,26124),
(75718,'These are the greatest treasures in life.','',0,0,0,0,0,0,0,0,7,0,39086,0,26124),
(75719,'Surely they... are worth fighting for.','',0,0,0,0,0,0,0,0,7,0,39087,0,26124),
(75720,'Heh, sounds like Malkorok just tore apart those intruders.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75721,'I don\'t know, I\'ve got a bad feeling. It\'s way too quiet in there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75722,'It\'s busting out of the cage!  Arm the shock collar, get that thing under control!','',0,0,0,0,0,0,5,0,1,0,38982,0,26124),
(75723,'Shock it until it can\'t move anymore!  It\'s causing a riot in here!','',0,0,0,0,0,0,5,0,1,0,38983,0,26124),
(75724,'Deal with the devilsaur first, then we\'ll lock the rest up!','',0,0,0,0,0,0,5,0,1,0,38984,0,26124),
(75725,'Fools! Imbeciles!','',0,0,0,0,0,0,5,0,0,0,38864,0,26124),
(75726,'I have been apprising the lorewalker of your deeds, champion. Are you ready to hear your tale?','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(75727,'Tell my story.','Tell my story.',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(75728,'Be wary... I suspect the stones will be heavily-guarded.','',0,0,0,0,0,0,0,7,0,0,44994,0,26124),
(75729,'','Please be swift and merciful. Those creatures are the true victims here.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(75730,'','Khadgar. I was just explaining the situation.',6,0,0,0,0,0,0,1,0,0,0,44143,26124),
(75731,'Greetings, farseer. We come on a matter of great urgency. $n, the savior of Wor\'gol, will vouch for us.','',0,0,0,0,0,0,0,1,0,0,45015,0,26124),
(75732,'Greetings, commander. It is good to see you again.','',0,0,0,0,0,0,0,1,0,0,45010,0,26124),
(75733,'Indeed. The Shadow Council is nearby and with them, Gul\'dan. I can feel it.','',0,0,0,0,0,0,0,1,0,0,45011,0,26124),
(75734,'Honor our death $n!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75735,'','Greetings, $n. You have freed me from this cave, and I wish to thank you. Please, accept my gift and my humble gratitude.',2,0,0,0,0,0,0,0,0,0,0,0,26124),
(75736,'I accept this gift.','I accept this gift.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75737,'Come, face me. Give in to your pride. Show me your \"Greatness.\"','',0,0,0,0,0,0,0,0,0,0,38899,0,26124),
(75738,'So foolish...','',0,0,0,0,0,0,0,0,0,0,38896,0,26124),
(75739,'You are better than your companions!','',0,0,0,0,0,0,0,0,0,0,38908,0,26124),
(75740,'Your arrogance compels you...','',0,0,0,0,0,0,0,0,0,0,38909,0,26124),
(75741,'Succumb to your pride!','',0,0,0,0,0,0,0,0,0,0,38910,0,26124),
(75742,'Your arrogance feeds me!','',0,0,0,0,0,0,0,0,0,0,38911,0,26124),
(75743,'You should bow to no king or warchief.','',0,0,0,0,0,0,0,0,0,0,38912,0,26124),
(75744,'You\'ve let your pride cloud your vision, Titan puppet! You can never contain ME!','',0,0,0,0,0,0,0,0,0,0,38898,0,26124),
(75745,'That one is WEAK.','',0,0,0,0,0,0,0,0,0,0,38905,0,26124),
(75746,'That one is unworthy of your group.','',0,0,0,0,0,0,0,0,0,0,38906,0,26124),
(75747,'Blame your companions!','',0,0,0,0,0,0,0,0,0,0,38907,0,26124),
(75748,'Half of the Vale lies in ruin! These outsiders have been more destructive than the mantid and mogu combined!','',0,0,0,0,0,0,5,0,1,0,38306,0,26124),
(75749,'We\'re here to lend our aid. We can help you rebuild the Vale.','',0,0,0,0,0,0,396,0,1,0,38017,0,26124),
(75750,'Hey, we recording?  Yeah?  Okay.  Goblin-Titan control module starting up, please stand back.','',0,0,0,0,0,0,0,0,1,0,38479,0,26124),
(75751,'Checking out the datas, hold on a second will ya.','',0,0,0,0,0,0,0,0,1,0,38480,0,26124),
(75752,'Oh, now you did it, that was really really really not the correct input code.','',0,0,0,0,0,0,0,0,1,0,38481,0,26124),
(75753,'|TInterface\\Icons\\ability_garrosh_whirling_corruption.blp:20|t%s begins to cast |cFFFF0000|Hspell:144985|h[Whirling Corruption]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75754,'Activating GB-11010 \"Armageddon\"-class defense systems. Hey, does anybody know if we\'re zoned for this?','',0,0,0,0,0,0,0,0,1,0,38482,0,26124),
(75755,'Goblin-like typing detected, unlocking cache of riches and treasures.','',0,0,0,0,0,0,0,0,1,0,38483,0,26124),
(75756,'Initiating system reset. Module 1 at 50%%. Hey, system reset requires two modules to complete.','',0,0,0,0,0,0,0,0,1,0,38473,0,26124),
(75757,'Module 1\'s all prepared for system reset.','',0,0,0,0,0,0,0,0,1,0,38474,0,26124),
(75758,'Initiating system reset. Module 2 at 50%%. Hey, system reset requires two modules to complete.','',0,0,0,0,0,0,0,0,1,0,38475,0,26124),
(75759,'Module 2\'s all prepared for system reset.','',0,0,0,0,0,0,0,0,1,0,38476,0,26124),
(75760,'System resetting. Don\'t turn the power off, or the whole thing will probably explode.','',0,0,0,0,0,0,0,0,1,0,38477,0,26124),
(75761,'Security system deactivated.  Welcome back Siegecrafter Blackfuse.','',0,0,0,0,0,0,0,0,1,0,38478,0,26124),
(75762,'|TInterface\\Icons\\ability_titankeeper_uncheckedcorruption.blp:20|t%s begins to cast |cFFFF0000|Hspell:147011|h[Manifest Rage]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75763,'Have a great day and don\'t let the door hit you on the way out.','',0,0,0,0,0,0,0,0,1,0,38472,0,26124),
(75764,'|TInterface\\Icons\\ability_garrosh_empowered_whirling_corruption.blp:20|t%s begins to cast |cFFFF0000|Hspell:144985|h[Empowered Whirling Corruption]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75765,'System\'s shutting down.  HEY DOES ANYONE KNOW IF ITS SUPPOSED TO BE DOING THIS?','',0,0,0,0,0,0,0,0,1,0,38485,0,26124),
(75766,'\"Armageddon\"-class defense systems fully on-line. Here comes the explosions!','',0,0,0,0,0,0,0,0,1,0,38484,0,26124),
(75767,'Stop working and I\'ll sacrifice you to the dark!','Stop working and I\'ll sacrifice you to the dark!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75768,'You think this is a game, runt? Work harder!','You think this is a game, runt? Work harder!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75769,'Put your back into it!','Put your back into it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75770,'The Iron Horde needs these supplies. Faster!','The Iron Horde needs these supplies. Faster!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75771,'Do you want the Iron Horde to crush us? Keep moving!','Do you want the Iron Horde to crush us? Keep moving!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75772,'Dear Emperor. It is done. The darkness that you once struggled against has been purged from Pandaria - forever.','',0,0,0,0,0,0,0,0,7,0,39076,0,26124),
(75773,'But the cost... such a terrible cost.','',0,0,0,0,0,0,0,0,7,0,39077,0,26124),
(75774,'Be careful. The demon will try to trick you.','',0,0,0,0,0,0,0,7,0,0,44995,0,26124),
(75775,'Look out. Invaders!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75776,'These outsiders have brought chaos to this land. Can we trust them to set it right?','',0,0,0,0,0,0,0,0,7,0,38754,0,26124),
(75777,'Wicked! You found my body! Look at them old bones.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75778,'I really thought I\'d be more excited about this...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75779,'Know what? I don\'t even want \'em. I like being able to float around freely.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75780,'It appears that this fishgorged crane suffered a violent death.$B$BThere are bites and claw marks all over its body and most of its viscera have been consumed.$B$BThis must be a favorite meal of something ravenous.','It appears that this fishgorged crane suffered a violent death.$B$BThere are bites and claw marks all over its body and most of its viscera have been consumed.$B$BThis must be a favorite meal of something ravenous.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75781,'You will fall before the true Horde!','You will fall before the true Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75782,'For Warchief Garrosh!','For Warchief Garrosh!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75783,'Your skull will make a fine prize!','Your skull will make a fine prize!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75784,'None can stand against Garrosh!','None can stand against Garrosh!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75785,'','Come with me, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75786,'','We draenei have long held an uneasy peace with the Shadowmoon orc clan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75787,'','But their aggression has grown ever since the Iron Horde arrived in our valley.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75788,'','Now, it seems they seek Iris crystals - special gems that contain incredible latent energy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75789,'','Anyway, could you check those telescopes for me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75790,'You are the chosen! The might of the true Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75791,'','Gul\'dan sends his best.',0,0,0,0,0,0,0,0,4,0,0,44460,26124),
(75792,'Our armies shall shake the pillars of the world!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75793,'Those who stand against us will receive no mercy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75794,'We shall claim victory for Warchief Garrosh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75795,'|TInterface\\Icons\\ability_vehicle_demolisherflamecatapult.blp:20|tThe Horde Fleet begins their |cFFFF0000|Hspell:147088|h[Bombardment]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75796,'Those who meddle with the timeways for their own selfish ends are often dangerous.\n\nIt is for this reason I joined Wardens, staunch defenders of the Timewalkers.\n\nWe guard the Watchers and Weavers as they go about their tasks.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75797,'I trust you have learned: To fight out of fear or anger is to fight a war that never ends.','',0,0,0,0,0,0,0,0,7,0,39083,0,26124),
(75798,'A complete waste!','',0,0,0,0,0,0,5,0,0,0,38865,0,26124),
(75799,'|TInterface\\Icons\\ability_garrosh_siege_engine.blp:20|t The Fleet Captain detected a cluster! Firing |cFFFF0000|Hspell:147047|h[Unstable Iron Star]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75800,'Another failure! Bring that beast down before he gets loose!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75801,'Once I\'ve perfected the infusing process, the power of Y\'Shaarj will make us unstoppable!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75802,'The Weavers are arcanists who specialize in chronomancy; the art of weaving time.\n\nAmongst the Timewalkers, we alone can repair damage to the timeways, open temporal portals, and other such tasks.\n\nThese things once came easily to the bronze dragonflight, but alas, no longer.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75803,'','The Watchers are the Timewalkers\' scholars and scouts, researchers and spies.\n\nWe watch the timeways and record, investigate, and report temporal tampering and unusual phenomena.\n\nIt was a Watcher, of course, that brought the Timewalkers\' attention to this bizarre, timeless isle.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75804,'|TInterface\\Icons\\sha_ability_rogue_envelopingshadows.blp:20|t You are afflicted with |cFFF00000|Hspell:146817|h[Aura of Pride]|h|r!','|TInterface\\Icons\\sha_ability_rogue_envelopingshadows.blp:20|t You are afflicted with  |cFFF00000|Hspell:146817|h[Aura of Pride]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75805,'I hold some of the emperor\'s most prized possessions. Should you wish to curry favor with Shaohao, you may aid us by driving back the Ordon yaungol that seek to overtake the Celestial Court.','I hold some of the emperor\'s most prized possessions. Should you wish to curry favor with Shaohao, you may aid us by driving back the Ordon yaungol that seek to overtake the Celestial Court.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75806,'Let the intruders come this way! I look forward to crushing their skulls.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75807,'Of course, those cowards will likely sneak by rather than face my wrath.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75808,'What else would you expect from those without valor?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75809,'Falling to me would probably be the greatest achievement they could hope to obtain.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75810,'What can I buy with timeless coins?','What can I buy with timeless coins?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75811,'%s caused the Unstable Iron Star to explode.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75812,'Let\'s settle this.','',0,0,0,0,0,0,0,0,1,0,38446,0,26124),
(75813,'Hehehehahahaha!','',0,0,0,0,0,0,0,0,6,0,38461,0,26124),
(75814,'Alright, boys. Let\'s show \'em how Blackfuse Company fights.','',0,0,0,0,0,0,0,0,6,0,38462,0,26124),
(75815,'Nobody beats Blackfuse. NOBODY!','',0,0,0,0,0,0,0,0,1,0,38465,0,26124),
(75816,'Never interrupt an artist!','',0,0,0,0,0,0,0,0,1,0,38466,0,26124),
(75817,'Hey! You\'re gonna pay for that!','',0,0,0,0,0,0,0,0,1,0,38458,0,26124),
(75818,'You son of a...','',0,0,0,0,0,0,0,0,1,0,38450,0,26124),
(75819,'My legacy... will live on...','',0,0,0,0,0,0,0,0,1,0,38448,0,26124),
(75820,'You think you have WON?  You are BLIND.  I WILL FORCE YOUR EYES OPEN.','',0,0,0,0,0,0,0,0,1,0,38057,0,26124),
(75821,'BEHOLD, MY GLORIOUS DESTINY!','',0,0,0,0,0,0,0,0,7,0,38058,0,26124),
(75822,'THERE IS NO PLACE FOR YOU IN MY WORLD.','',0,0,0,0,0,0,0,0,1,0,38049,0,26124),
(75823,'I WILL DESTROY EVERYTHING YOU HAVE EVER LOVED.','',0,0,0,0,0,0,0,0,1,0,38050,0,26124),
(75824,'No... NO... This world... Is my destiny... My destiny...','',0,0,0,0,0,0,0,0,1,0,38047,0,26124),
(75825,'I, Garrosh, son of Grom, will show you what it means to be called Hellscream!','',0,0,0,0,0,0,0,0,1,0,38064,0,26124),
(75826,'Over here, hero!','',0,0,0,0,0,0,0,0,1,0,39072,0,26124),
(75827,'My my - this is all that remains of the terrible being that haunted Pandaria all these years.','',0,0,0,0,0,0,0,0,1,0,39073,0,26124),
(75828,'Whatever darkness it once exuded is silent at last.','',0,0,0,0,0,0,0,0,1,0,39074,0,26124),
(75829,'Come with me, hero. Let us return to the Vale. There is someone I think who would be particularly interested in this turn of events, if we can get his attention.','',0,0,0,0,0,0,0,0,1,0,39075,0,26124),
(75830,'Let\'s go.','Let\'s go.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75831,'I\'m ready.','I\'m ready.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75832,'','You\'re right, you\'re not going out there!',0,0,0,0,0,0,0,7,0,0,0,44124,26124),
(75833,'We\'re under attack!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75834,'You were there! Is it true then? What happened in Orgrimmar?','',1,0,0,0,0,0,25,0,0,0,38847,0,26124),
(75835,'','Kazdar said they knew of the prophecy... but how? This is disturbing news, indeed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75836,'That fool king!!','',1,0,0,0,0,0,5,0,0,0,38848,0,26124),
(75837,'I did everything in my power. The whole world was his, he needed only seize it!','',1,0,0,0,0,0,5,0,0,0,38849,0,26124),
(75838,'Oh sure, another year of fighting. Enormous casualties trying to take Thunder Bluff. But the rest of the Horde would\'ve caved, eventually.','',1,0,0,0,0,0,1,0,0,0,38850,0,26124),
(75839,'TONG! DRINK! NOW!','',1,0,0,0,0,0,25,0,0,0,38851,0,26124),
(75840,'What? Yes, I was backing the Alliance.','',1,0,0,0,0,0,273,0,0,0,38852,0,26124),
(75841,'I thought Hellscream\'s victory was assured before he turned half of his Horde against him. So I changed my allegiance.','',1,0,0,0,0,0,1,0,0,0,38853,0,26124),
(75842,'%s falls to his knees in defeat. Your army retreats.','%s falls to her knees in defeat. Your army retreats.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75843,'|TInterface\\Icons\\ability_warlock_eradication.blp:20|t%s casts |cFFFF0000|Hspell:147209|h[Malice]|h|r on |cFFFF0000$n|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75844,'I yield!','I yield!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75845,'Do you yield?','Do you yield?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75846,'','',0,0,0,0,0,0,0,0,0,0,38436,0,26124),
(75847,'Welcome to the Proving Grounds. Your first trial will now begin. Defeat each wave of illusions before time runs out.','',0,0,0,0,0,0,0,0,0,0,38500,0,26124),
(75848,'As before, defeat each wave of illusions before time runs out. This time, you will encounter more difficult illusions.','',0,0,0,0,0,0,0,0,0,0,38553,0,26124),
(75849,'Prepare yourself for the most difficult illusions. Defeat them before time expires, and success will be yours.','',0,0,0,0,0,0,0,0,0,0,38552,0,26124),
(75850,'This trial will test how far your skill can take you. It will never end; it only gets more challenging.','',0,0,0,0,0,0,0,0,0,0,38501,0,26124),
(75851,'Success! Hah, well done. See me for your next trial.','',0,0,0,0,0,0,0,0,0,0,38554,0,26124),
(75852,'You have run out of time. Shall we try again?','',0,0,0,0,0,0,0,0,0,0,38499,0,26124),
(75853,'Illusionary Varmints come in packs, and are harmless. Use attacks that affect multiple opponents to kill them quickly.','',0,0,0,0,0,0,0,0,0,0,38498,0,26124),
(75854,'The Illusionary Amber-Weaver conjures globs of amber that float toward you and explode on any contact. Lead the amber globs into other illusions.','',0,0,0,0,0,0,0,0,0,0,38497,0,26124),
(75855,'Ah, the Illusionary Banana-Tosser! It will rapidly toss bananas toward you. Move to avoid them. Prevent it from running away from you, if you can.','',0,0,0,0,0,0,0,0,0,0,38496,0,26124),
(75856,'The Illusionary Mystic will heal any ally that is significantly wounded. Interrupt its healing spells.','',0,0,0,0,0,0,0,0,0,0,38495,0,26124),
(75857,'A master of defense, the Illusionary Guardian deflects all attacks from the front. Stay behind it.','',0,0,0,0,0,0,0,0,0,0,38494,0,26124),
(75858,'Oh, the Illusionary Sha! Save your strongest attacks for when its barrier falls, leaving it exposed.','',0,0,0,0,0,0,0,0,0,0,38493,0,26124),
(75859,'This Illusionary Slayer will test your ability to damage your opponent. Do not worry; it cannot harm you.','',0,0,0,0,0,0,0,0,0,0,38492,0,26124),
(75860,'An Illusionary Banshee! Kill it, quickly, before it explodes!','',0,0,0,0,0,0,0,0,0,0,38491,0,26124),
(75861,'Hello. For this trial, you must keep us alive while we face the incoming illusions. I am Oto, and will protect you.','',0,0,0,0,0,0,0,0,0,0,38599,0,26124),
(75862,'Hold tight! I am coming!','',0,0,0,0,0,0,0,0,0,0,38593,0,26124),
(75863,'I am a wall of iron, but I cannot hold much longer!','',0,0,0,0,0,0,0,0,0,0,38594,0,26124),
(75864,'Illusionary Hive-Singers! Their sonic waves will harm us all.','',0,0,0,0,0,0,0,0,0,0,38596,0,26124),
(75865,'Ah, a new challenge, Illusionary Conquerors! When they become enraged, they strike with incredible power.','',0,0,0,0,0,0,0,0,0,0,38597,0,26124),
(75866,'I have fallen. I am sorry, I shall train harder for next time.','',0,0,0,0,0,0,0,0,0,0,38598,0,26124),
(75867,'','Oto! I cannot attack them while they are attacking me!',0,0,0,0,0,0,0,0,0,0,0,38958,26124),
(75868,'','An Aqua Bomb has detonated! Dispel it faster, next time.',0,0,0,0,0,0,0,0,0,0,0,38959,26124),
(75869,'','These Illusionary Aqualytes will affect us with dark magic. Dispel it quickly.',0,0,0,0,0,0,0,0,0,0,0,38961,26124),
(75870,'','I am down! Quick healing spells would be best for emergencies like that!',0,0,0,0,0,0,0,0,0,0,0,38962,26124),
(75871,'','Hello again. More illusions approach, and we will require your healing arts.',0,0,0,0,0,0,0,0,0,0,0,38963,26124),
(75872,'','Sorry, vanishing!',0,0,0,0,0,0,0,0,5,0,0,38580,26124),
(75873,'','I am sure they are trying, Kavan. Be nice.',0,0,0,0,0,0,0,0,5,0,0,38581,26124),
(75874,'','Sooli, move!',0,0,0,0,0,0,0,0,5,0,0,38582,26124),
(75875,'','Ah, our first enemy! Illusionary Rippers are but simple warriors. Now, let us do this!',0,0,0,0,0,0,0,0,5,0,0,38584,26124),
(75876,'','Illusionary Flamecallers! Watch your feet, everyone. Do not stand in the lava.',0,0,0,0,0,0,0,0,5,0,0,38585,26124),
(75877,'','I am down. Let us try again!',0,0,0,0,0,0,0,0,5,0,0,38586,26124),
(75878,'','Oh no, did you forget to heal yourself?',0,0,0,0,0,0,0,0,5,0,0,38587,26124),
(75879,'','The illusions will not hold back, this time. Their attacks will be relentless. Be prepared to use your strongest healing spells.',0,0,0,0,0,0,0,0,5,0,0,38588,26124),
(75880,'Oh dear. Speedy, help!','',0,0,0,0,0,0,0,0,5,0,38964,0,26124),
(75881,'Huh? Ohhhh, ohhh!','',0,0,0,0,0,0,0,0,5,0,38965,0,26124),
(75882,'Ahh, Illusionary Tunnelers! Speedy and I have faced these foes before. Beware, they may burrow into the ground and then suddenly pop up under a new target, and CHOMP! Hah ha hah ha.','',0,0,0,0,0,0,0,0,5,0,38967,0,26124),
(75883,'Argh... please... take care... of Speedy!','',0,0,0,0,0,0,0,0,5,0,38968,0,26124),
(75884,'There is no end in sight to these illusions, but we shall hold out as long as we can.','',0,0,0,0,0,0,0,0,5,0,38969,0,26124),
(75885,'Hah ha! Wonderful job, everyone! Friend, see Rotun about beginning the next trial.','',0,0,0,0,0,0,0,0,5,0,38970,0,26124),
(75886,'I will not fall again!','',0,0,0,0,0,0,0,0,1,0,38273,0,26124),
(75887,'You are an honorable Orc, Nazgrim. I regret what I must do.','',0,0,0,0,0,0,0,0,1,0,38274,0,26124),
(75888,'You fought with honor. Gamon will ensure that your legacy lives on. For the Horde, my friend.','',0,0,0,0,0,0,0,0,1,0,38275,0,26124),
(75889,'It cannot end... like... this...','',0,0,0,0,0,0,0,0,1,0,38270,0,26124),
(75890,'Can you stand on the tallest peak, winds and sleet buffeting your skin, until the trees wither and the mountains fall into the sea?','',1,0,0,0,0,0,0,0,0,0,38757,0,26124),
(75891,'We shall see.','',1,0,0,0,0,0,0,0,0,0,38755,0,26124),
(75892,'The winds may be strong, and the sleet may sting.','',1,0,0,0,0,0,0,0,0,0,38759,0,26124),
(75893,'You are the mountain, unmovable by all but time.','',1,0,0,0,0,0,0,0,0,0,38760,0,26124),
(75894,'Be vigilant in your stand, or you will never achieve your goals.','',1,0,0,0,0,0,0,0,0,0,38761,0,26124),
(75895,'You must persevere!','',1,0,0,0,0,0,0,0,0,0,38758,0,26124),
(75896,'Though you will be surrounded by foes greater than you can imagine, your fortitude shall allow you to endure. Remember this in the times ahead.','',1,0,0,0,0,0,0,0,0,0,38756,0,26124),
(75897,'When faced with challenges the like you have never seen, what do you hope for? What is the future you seek?','',1,0,0,0,0,0,0,0,0,0,38026,0,26124),
(75898,'Then let us begin.','',1,0,0,0,0,0,0,0,0,0,38024,0,26124),
(75899,'Believe in one another, and let others carry hope for you!','',1,0,0,0,0,0,0,0,0,0,38028,0,26124),
(75900,'Without hope, there is no brightness in the future!','',1,0,0,0,0,0,0,0,0,0,38029,0,26124),
(75901,'Create the destiny you seek!','',1,0,0,0,0,0,0,0,0,0,38030,0,26124),
(75902,'Do not give up on yourself!','',1,0,0,0,0,0,0,0,0,0,38027,0,26124),
(75903,'Your hope shines brightly, and even more brightly when you work together to overcome. It will ever light your way in even the darkest of places.','',1,0,0,0,0,0,0,0,0,0,38025,0,26124),
(75934,'When my journey began, I was reckless in my strength. The White Tiger taught me control. My hatred, anger, and violence were vanquished.','',0,0,0,0,0,0,0,0,7,0,38037,38037,26124),
(75905,'The trial begins!','',1,0,0,0,0,0,0,0,0,0,38222,0,26124),
(75906,'Listen to your inner voice, and seek out the truth!','',1,0,0,0,0,0,0,0,0,0,38226,0,26124),
(75908,'Always consider the consequences of your actions!','',1,0,0,0,0,0,0,0,0,0,38228,0,26124),
(75909,'Learn from your mistakes!','',1,0,0,0,0,0,0,0,0,0,38225,0,26124),
(75933,'Long ago, the Jade Serpent instructed me to purify my spirit and become one with the land, my doubts were vanquished.','',0,0,0,0,0,0,0,0,7,0,38036,38036,26124),
(75911,'Strength. It is far more than simple physical prowess. When you are truly tested, will you be able to tell the difference between strength and power?','',1,0,0,0,0,0,0,0,0,0,38213,0,26124),
(75912,'Ha ha! The trial commences!','',1,0,0,0,0,0,0,0,0,0,38211,0,26124),
(75910,'Your wisdom has seen you through this trial. May it ever light your way out of dark places.','',1,0,0,0,0,0,0,0,0,0,38223,38223,26124),
(75907,'Do not let your judgment be clouded in trying times!','',1,0,0,0,0,0,0,0,0,0,38227,38227,26124),
(75918,'Ah, finally some action. Lok\'tar Ogar!','',0,0,0,0,0,0,0,0,1,0,38285,0,26124),
(75919,'Ha... ha ha... well-struck...','',0,0,0,0,0,0,0,0,1,0,38286,0,26124),
(75920,'Don\'t be foolish, Vol\'jin! You have no siege weapons left! You cannot win this battle!','',0,0,0,0,0,0,5,0,0,0,38205,0,26124),
(75921,'You may have defeated my war machine, but the gate still stands. You will not take Orgrimmar today.','',0,0,0,0,0,0,274,0,1,0,38206,0,26124),
(75922,'What? Kor\'kron, to the gates! Now!','',0,0,0,0,0,0,397,0,1,0,38207,0,26124),
(75923,'No alliance hand has ever struck me down. Do you think you are seasoned enough?','',0,0,0,0,0,0,0,0,1,0,38204,0,26124),
(75924,'I am Nazgrim, fist of the Warchief and General of the Horde Army. If I must die today, I will die with honor, in battle, for the horde!','',0,0,0,0,0,0,0,0,1,0,38191,0,26124),
(75925,'You should have trained harder.','',0,0,0,0,0,0,0,0,1,0,38209,0,26124),
(75926,'I die... with honor... Lok\'tar Ogar...','',0,0,0,0,0,0,0,0,1,0,38193,0,26124),
(75927,'Ah... Gamon... you have finally learned... I am proud... to have died... at your hands...','',0,0,0,0,0,0,0,0,1,0,38194,0,26124),
(75928,'Ah... you have learned much... and learned well... an honorable battle.','',0,0,0,0,0,0,0,0,1,0,38196,0,26124),
(75929,'In the end, I stood by the warchief, because it was my duty, and I am glad that it was you who struck me down. May your strength... lead the horde... into a new era of prosperity...','',0,0,0,0,0,0,0,0,1,0,38197,0,26124),
(75930,'For the horde...','',0,0,0,0,0,0,0,0,1,0,38195,0,26124),
(75931,'So, it has come to this. Together, we have learned and grown over the years, and now we find ourselves face to face on the battlefield. Do not think I will go easy on you, nor do I expect any quarter. What we do now, we do for the horde, both of us.','',0,0,0,0,0,0,0,0,1,0,38208,0,26124),
(75932,'It is an honor to finally face you in combat. Lok\'tar Ogar, for Honor, and for the Horde!','',0,0,0,0,0,0,0,0,1,0,38192,0,26124),
(75904,'The lesson of true wisdom lies within you dear heroes, and in the choices you make. When faced with overwhelming darkness, will you make the right decisions?','',1,0,0,0,0,0,0,0,0,0,38224,38224,26124),
(75916,'Return twice as powerful!','',1,0,0,0,0,0,0,0,0,0,38214,38214,26124),
(75917,'You are strong, stronger even than you realize. Carry this thought with you into the darkness ahead, and let it shield you.','',1,0,0,0,0,0,0,0,0,0,38212,38212,26124),
(75915,'Do not mistake the power that darkness offers for true strength!','',1,0,0,0,0,0,0,0,0,0,38217,38217,26124),
(75913,'Believe in your strength!','',1,0,0,0,0,0,0,0,0,0,38215,38215,26124),
(75914,'You have the power to change your destiny!','',1,0,0,0,0,0,0,0,0,0,38216,38216,26124),
(75941,'I have tried everything to remove this cave-in!  Black Ox give me fortitude, I cannot move even a single rock. Perhaps if I were to borrow one of the great weapons of legend from the temple grounds...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75942,'My friend, please, meet me near the Big Blossom Mine in the center of the Vale. There is something I wish to show you there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75943,'Riko Riko has a nice ring to it...','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75944,'Oh, don\'t look so surprised! I\'m a black dragon. My loyalties are my own.','',1,0,0,0,0,0,274,0,0,0,38854,0,26124),
(75945,'Riko like all the fireworks!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75947,'Riko had an idea. Grookin\' club!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75948,'When the river turns left or right, flow along it instead of fight.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75949,'Never forget your greatest friend, they stick with you until the end.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75950,'The emperor is very near; fought doubt, hate, rage, despair, and fear.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(75951,'But that idiot, IDIOT Wrynn! \"High King\" indeed!','',1,0,0,0,0,0,5,0,0,0,38855,0,26124),
(75952,'Why did he allow another warchief? He could\'ve united the world under the Alliance banner. What a fool I was to trust his ambition!','',1,0,0,0,0,0,6,0,0,0,38856,0,26124),
(75953,'Should\'ve taken over the throne room myself. Like Auntie Onyxia. Get things DONE.','',1,0,0,0,0,0,1,0,0,0,38857,0,26124),
(75954,'%s will not be pulled from his tower!','%s will not be pulled from her tower!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75955,'Please take care, $n.\n\nThe August Celestials will not tolerate aggression between the Alliance and Horde here.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(75956,'','Help! Get these things off of me!',0,0,0,0,0,0,0,0,5,0,0,38426,26124),
(75957,'','What are you standing in?! Get out of the fire!',0,0,0,0,0,0,0,0,5,0,0,38427,26124),
(75958,'','Illusionary Rippers approaching. They should pose little challenge; they are but mindless grunts.',0,0,0,0,0,0,0,0,5,0,0,38428,26124),
(75959,'','Prepare your defenses. That is an Illusionary Conqueror! When they become enraged, they gain great strength, and nothing can stop them.',0,0,0,0,0,0,0,0,5,0,0,38429,26124),
(75960,'','A new enemy, Illusionary Flamecallers. They cast fireballs and spew lava. Use the lava to your advantage; it will burn the other illusions.',0,0,0,0,0,0,0,0,5,0,0,38430,26124),
(75961,'','Beware! Illusionary Wind-Guards can use their wings to knock you back. When they do, they will likely switch to attacking me instead.',0,0,0,0,0,0,0,0,5,0,0,38431,26124),
(75962,'','Illusionary Ambushers! Get their attention, quick. And get them away from me, so they cannot hit me with their devastating bananas!',0,0,0,0,0,0,0,0,5,0,0,38432,26124),
(75963,'','Illusionary Foragers are attacking. Do not let their cute faces fool you. They can work together to cause terrible devastation.',0,0,0,0,0,0,0,0,5,0,0,38433,26124),
(75964,'','Ahh, I cannot heal through that much damage! Did you forget to equip your heaviest armor?!',0,0,0,0,0,0,0,0,5,0,0,38434,26124),
(75965,'','I am down. Maybe I should bring more healing herbs for next time.',0,0,0,0,0,0,0,0,5,0,0,38435,26124),
(75966,'','Greetings. I am Sikari, master of jade lightning, chi, and healing mists. For this trial, you must protect me from the incoming illusions, while I heal you and dispatch our foes.',0,0,0,0,0,0,0,0,5,0,0,38439,26124),
(75967,'','Greetings, again. Our next trial will be more challenging. Prepare to defend me.',0,0,0,0,0,0,0,0,5,0,0,38438,26124),
(75968,'','Once again, you must defend me. Rotun, give us a challenge this time.',0,0,0,0,0,0,0,0,5,0,0,38437,26124),
(75969,'','While our end is inevitable, let us try to take as many of them down with us as we can. Be ready.',0,0,0,0,0,0,0,0,5,0,0,38994,26124),
(75970,'With the Sha of Doubt defeated you are ready to read the scroll.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75971,'You have already done what you can for this lost knowledge.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75972,'Be careful out there.\n\nAside from all the gigantic beasts, there\'s an enemy camp on the other end of this beach.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(75973,'%s squints menacingly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(75974,'Do give my regards to Khadgar. I\'ve a present coming for him.','',0,0,0,0,0,0,0,0,0,0,45322,0,26124),
(75975,'The pain!','The pain!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75976,'','Assassin!',0,0,0,0,0,0,0,0,4,0,0,44126,26124),
(75977,'Enough!!','',0,0,0,0,0,0,274,0,0,0,38404,0,26124),
(75978,'Talk! Talk! Talk!','',0,0,0,0,0,0,5,0,0,0,38405,0,26124),
(75979,'Always you speak. Never do you listen! You ignore the lessons of Pandaria!','',0,0,0,0,0,0,25,0,0,0,38406,0,26124),
(75980,'You see, there is balance in all things. Wisdom etched in our very fur: Black and white. Darkness and light.','',0,0,0,0,0,0,1,0,0,0,38407,0,26124),
(75981,'When the last emperor hid our land from the rest of the world, he also preserved the homeland of our ancient enemy, the mantid. Why did he do this?','',0,0,0,0,0,0,1,0,0,0,38408,0,26124),
(75982,'So it is with your Alliance and your Horde. They are not strong despite one another; they are strong BECAUSE of one another.','',0,0,0,0,0,0,25,0,0,0,38410,0,26124),
(75983,'You mistake your greatest strength for weakness. Do you see this?','',0,0,0,0,0,0,25,0,0,0,38411,0,26124),
(75984,'...He destroyed my inn. He left no tip. He is not nice.','',0,0,0,0,0,0,274,0,0,0,38412,0,26124),
(75985,'Uhh... wha?','',1,0,0,0,0,0,6,0,0,0,38858,0,26124),
(75986,'...you ...you\'re just a WAITER!','',1,0,0,0,0,0,25,0,0,0,38859,0,26124),
(75987,'I promise you this: I will stop at nothing to prepare this world for the battle to come.','',1,0,0,0,0,0,1,0,0,0,38860,0,26124),
(75988,'Next time, I will leave nothing to chance.','',1,0,0,0,0,0,1,0,0,0,38861,0,26124),
(75989,'NOTHING!','',1,0,0,0,0,0,5,0,0,0,38862,0,26124),
(75990,'He did so to keep the land whole. Living with the mantid for ten thousand years has made us both STRONG.','',0,0,0,0,0,0,1,0,0,0,38409,0,26124),
(75991,'Have fun dealing with this.','',0,0,0,0,0,0,0,0,0,0,45320,0,26124),
(75992,'\"Though blood floods the ground, the mountain is unmoved.\" - Niuzao','\"Though blood floods the ground, the mountain is unmoved.\" - Niuzao',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75993,'\"The truth shines brightest in clouded times.\" - Yu\'lon','\"The truth shines brightest in clouded times.\" - Yu\'lon',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75994,'\"Hope\'s fire grows when the flames come together.\" - Chi-Ji','\"Hope\'s fire grows when the flames come together.\" - Chi-Ji',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75995,'\"Strength and power are as different as sun and moon.\" - Xuen','\"Strength and power are as different as sun and moon.\" - Xuen',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75996,'The shrine was corrupted by Ordos!','The shrine was corrupted by Ordos!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75997,'','Click on a patron who is waiting in line. You should see them wave to you when you have successfully interacted with them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75998,'|TInterface\\Icons\\ability_racial_timeismoney.blp:20|t|cFFFF0000|Hspell:146506|h[Waiting in Line]|h|r','|TInterface\\Icons\\ability_racial_timeismoney.blp:20|t|cFFFF0000|Hspell:146506|h[Waiting in Line]|h|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(75999,'','When a customer has been selected, click on an open seat and the customer will go sit there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76000,'|TInterface\\Icons\\inv_misc_fork&knife.blp:20|t|cFFFF0000|Hspell:146448|h[Waiting for Food]|h|r','|TInterface\\Icons\\inv_misc_fork&knife.blp:20|t|cFFFF0000|Hspell:146448|h[Waiting for Food]|h|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76001,'Khadgar, let\'s go over what happened when Garona attacked.','Khadgar, let\'s go over what happened when Garona attacked.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76002,'We must defend the pools from their corruption!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76003,'Our work is not yet complete! Stop them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76004,'Defend the pools!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76005,'','Make some noodle soup for your customer. This is a scholar so they like the simplicity of a standard noodle soup. Try making one now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76006,'','Now that the soup is made, pick it up by clicking on it. Soups will go bad if left out too long so only make what you need for your customers.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76007,'','Now click on the seated customer to deliver them their noodle soup.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76008,'','Excellent! Now your customer will happily eat the noodle soup you\'ve made for them. When they\'re done they\'ll leave happy.',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(76009,'Are you leaving the camp?\n\nThe August Celestials have requested that we not push our forces any further into the island, so we\'re staying here to secure this landing point.\n\nWatch yourself out there. The enemy has taken an interest in this place, too. Their camp is on the other end of the beach, and well-guarded.','',6,66,0,0,5,0,0,0,0,0,0,0,26124),
(76010,'My life for the flame!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76011,'Ordos guide my way!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76012,'The flames are truth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76013,'My fate is written in flames!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76014,'You will perish in agony!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76015,'For Ordos!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76016,'I serve the fire gods!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76017,'For the ever-burning flame!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76022,'Stand in the light and be judged!','',0,0,0,0,0,0,0,0,1,0,38895,0,26124),
(76023,'You... Rook knows you....','',0,0,0,0,0,0,396,0,0,0,38718,0,26124),
(76024,'Rook... does not know... head... is cloudy....','',0,0,0,0,0,0,396,0,0,0,38720,0,26124),
(76025,'','We know only despair now. A fitting punishment for our failure....',0,0,0,0,0,0,396,0,1,0,0,38415,26124),
(76026,'Please... help....','',0,0,0,0,0,0,396,0,0,0,38722,0,26124),
(76027,'No! We are not finished.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76028,'The waters have not been cleansed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76029,'These interlopers must be stopped before our work is undone!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76030,'Defend me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76031,'You must protect me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76032,'It falls to you to defend your master.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76033,'You meddle in affairs beyond your comprehension.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76034,'|TInterface\\Icons\\INV_MISC_FOOD_COOKED_GREATPABANQUET_POT.BLP:20|t|cFFFF0000|Hspell:146498|h[Hungry]|h|r','|TInterface\\Icons\\INV_MISC_FOOD_COOKED_GREATPABANQUET_POT.BLP:20|t|cFFFF0000|Hspell:146498|h[Hungry]|h|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76035,'|TInterface\\Icons\\ability_hunter_posthaste.BLP:20|t|cFFFF0000|Hspell:146497|h[Impatient]|h|r','|TInterface\\Icons\\ability_hunter_posthaste.BLP:20|t|cFFFF0000|Hspell:146497|h[Impatient]|h|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76036,'It looks as if $n has decided to heal and revive his pets!  $gHis:Her; progress in the tournament has been reset, and they will be allowed to attempt each challenge again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76037,'Someone warn the master!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76038,'Once you have the demon\'s heart, we\'ll forge the soul trap.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(76039,'Quickly. Combine the shards to forge a soul trap for Gul\'dan.','',0,0,0,0,0,0,0,7,0,0,44998,0,26124),
(76040,'Don\'t worry about me. They can\'t see this projection.$B$BEverything we do here is leading to one thing, $n: Gul\'dan\'s capture.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(76041,'Be careful, my friend. Gul\'dan is not to be underestimated no matter how prepared you might be.','',0,0,0,0,0,0,0,7,0,0,44999,0,26124),
(76042,'I am not that easy.','',0,0,0,0,0,0,0,0,0,0,45318,0,26124),
(76043,'Razuun, your time has come.','',0,0,0,0,0,0,0,0,0,0,45319,0,26124),
(76044,'What? No...','',0,0,0,0,0,0,0,0,0,0,46271,0,26124),
(76045,'No matter. Soon there will be enough felblood to make thousands for the Burning Legion.','',0,0,0,0,0,0,0,0,0,0,45321,0,26124),
(76046,'Honorless pup. His death is his greatest achievement.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76047,'Ahahahaha... you are too late. Even now, the crystal is on its way to Shaz\'gul.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76048,'/sigh','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76049,'','You\'ve let too many customers get away. Perhaps you should try again?',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(76050,'','Well done!',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(76051,'Why not?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76052,'Isn\'t that the same spear you use to hunt rabbits?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76053,'Agreed, I don\'t even want my spear anymore...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76054,'Throm-Ka, warriors of the great Frostwolf clan.','',0,0,0,0,0,0,0,1,0,0,45012,0,26124),
(76055,'Because it\'s tainted with this youngling\'s weak blood.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76056,'It\'s imperative we find the council\'s base of operations and deal with them.','',0,0,0,0,0,0,0,1,0,0,45013,0,26124),
(76057,'So... what\'s your point?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76058,'Warden, let\'s go make your introduction to the farseer at Throm\'var.','Warden, let\'s go make your introduction to the farseer at Throm\'var.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76059,'','To think: This place has been outside our time stream - and existence itself! - for millennia.\n\nOur most experienced Weavers assure us the island\'s temporal position is presently stable, but still, I wonder...\n\nWhat would happen if it vanished again while we were upon it?',1,6,0,0,3,0,0,0,0,0,0,0,26124),
(76060,'Commander, if you\'d be so kind as to make our introductions.','',0,0,0,0,0,0,0,1,0,0,45014,0,26124),
(76061,'Champion of the Frostwolf clan, if they are friends of yours, then they are welcome here.','',0,0,0,0,0,0,0,1,0,0,46810,0,26124),
(76062,'....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76063,'Thank you... emperor. Thank you.','',0,0,0,0,0,0,0,0,7,0,39078,0,26124),
(76064,'The pain.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(76065,'Fight, my brothers. Show them what it means to be Warsong.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76066,'Rabbits are pretty weak.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76067,'Please be swift and merciful. The Mother of Wolves is the true victim here.','',0,0,0,0,0,0,0,1,0,0,46808,0,26124),
(76068,'Shut up.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76069,'The Spineclaw scuttles away in fear!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76070,'Galakras is hit! Nice shot!','Galakras is hit! Nice shot!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76071,'I\'m ready for my next shift at the noodle stand!','I\'m ready for my next shift at the noodle stand!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76072,'','We stand behind Dezco and his choices. We will stand against the mogu, the saurok, the sha, even the warchief of the Horde. We will protect this Vale to the last, if necessary.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76073,'I will destroy you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76074,'Well played.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76075,'You win this round...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76076,'I will burn your corpses to ash!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76077,'What IS this place?','',0,0,0,0,0,0,6,0,0,0,38018,0,26124),
(76078,'I\'ve been here for hours and the sun hasn\'t moved...','',0,0,0,0,0,0,396,0,0,0,38019,0,26124),
(76079,'What could create such a thing?','',0,0,0,0,0,0,6,0,0,0,38020,0,26124),
(76080,'Is it dangerous?','',0,0,0,0,0,0,5,0,0,0,38021,0,26124),
(76081,'I will.','',0,0,0,0,0,0,273,0,0,0,38022,0,26124),
(76082,'A pandaren enigma, my young prince! A mystery in the mists.','',0,0,0,0,0,0,396,0,0,0,38874,0,26124),
(76083,'Exactly. Time is frozen in perpetuity. Cause and effect - rendered all but meaningless.','',0,0,0,0,0,0,396,0,0,0,38875,0,26124),
(76084,'I should like to find out! Perhaps it is related to the mists? Or the power that was unleashed in the sundering ten thousand years ago? We must investigate!','',0,0,0,0,0,0,6,0,0,0,38876,0,26124),
(76085,'Indeed. This place overturns our very notion of time, and how it shapes the universe.','',0,0,0,0,0,0,396,0,0,0,38877,0,26124),
(76086,'Stranded on this island you will find the most dangerous creatures in all of Pandaria. Explore if you must, Prince Anduin. But be cautious.','',0,0,0,0,0,0,396,0,0,0,38878,0,26124),
(76087,'Hello, $c.  Have you come to learn the secrets of the Timeless Isle?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76088,'','Can you believe this place?  There\'s so much to learn and discover!  I\'m going to fill up books and books with all my findings here.$b$bBut it\'s just so much information, I don\'t know how anyone could possibly read through it all.  Chadrik thought we could write it up as a song, but that\'s silly... right?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76089,'Your journey ends here cowards! These doors won\'t open as long as I live!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76090,'Lok-Narash!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76091,'...kill... me.','...kill... me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76092,'[%s] confesses: I haven\'t visited Sunsong Ranch in months. I can just imagine weeds and virmen everywhere.','[%s] confesses: I haven\'t visited Sunsong Ranch in months. I can just imagine weeds and virmen everywhere.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76093,'[%s] confesses: I think one time I tried to kill Lei Shi instead of Lei Shen.','[%s] confesses: I think one time I tried to kill Lei Shi instead of Lei Shen.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76094,'[%s] confesses: I used to think Medivh was a druid because of all the feathers.','[%s] confesses: I used to think Medivh was a druid because of all the feathers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76095,'[%s] confesses: I still carry around Argent Crusade Scourgestones. You never know when they\'ll be useful again.','[%s] confesses: I still carry around Argent Crusade Scourgestones. You never know when they\'ll be useful again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76096,'[%s] confesses: I feel bad for my ground mounts. I hardly ever use them anymore.','[%s] confesses: I feel bad for my ground mounts. I hardly ever use them anymore.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76097,'[%s] confesses: I\'m going to totally ninja that hunter\'s loot.','[%s] confesses: I\'m going to totally ninja that hunter\'s loot.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76098,'[%s] confesses: I am confused why female draenei like gnomes.','[%s] confesses: I am confused why female draenei like gnomes.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76099,'The crystal vibrates at your touch!','The crystal vibrates at your touch!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76100,'','Khadgar - someone\'s here!',0,0,0,0,0,0,0,0,4,0,0,44125,26124),
(76101,'The Land of Winds belongs to the Warsong.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76102,'Dis harder den I finked.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76103,'One?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76104,'Umm...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76105,'Hrm...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76106,'What after one?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76107,'How many\'s tree?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76108,'Anudder one.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76109,'One lots.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76110,'Today, a bright fire exploded across the heavens.$B$BA great white crystal landed in the plains below our village.$B$BWe know not what it is. Is it a gift from our ancestors?','Today, a bright fire exploded across the heavens.$B$BA great white crystal landed in the plains below our village.$B$BWe know not what it is. Is it a gift from our ancestors?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76111,'Shortly afterward, a shadow appeared in the sky beneath the pale moon. Some stare at it in fear, others in adoration.$B$BThe clan has given it many names: great father, dark mother.$B$BThe Chieftain calls it the \"Dark Star.\"','Shortly afterward, a shadow appeared in the sky beneath the pale moon. Some stare at it in fear, others in adoration.$B$BThe clan has given it many names: great father, dark mother.$B$BThe Chieftain calls it the \"Dark Star.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76112,'Since the crystals fell, our power has grown in ways we do not fully understand.$B$BWe have always spoken the language of the stars and the earth. Now, we hear another - the voice of shadow.','Since the crystals fell, our power has grown in ways we do not fully understand.$B$BWe have always spoken the language of the stars and the earth. Now, we hear another - the voice of shadow.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76113,'Yesterday, we found one of our clan defiling the spirits of our ancestors.$B$BThe Chieftain is livid. It is clear - this new magic is dangerous. It leads us down a path from which we cannot return.$B$BFrom this day forth, let it be known. The powers of shadow are forbidden to the clan.$B$BThe \"Dark Star\" is evil.','Yesterday, we found one of our clan defiling the spirits of our ancestors.$B$BThe Chieftain is livid. It is clear - this new magic is dangerous. It leads us down a path from which we cannot return.$B$BFrom this day forth, let it be known. The powers of shadow are forbidden to the clan.$B$BThe \"Dark Star\" is evil.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76114,'<Wrathion sits alone, twirling a game piece in his fingers. He is staring intently at the game board but you get the impression that his mind is elsewhere.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76115,'In ages long past, aspiring heroes and emperors came here to face the tests of the August Celestials.\n\nJust as our ancestors watched over the passage of those time-honored proceedings, so shall we.\n\nThe Celestial Guard will brook no faction squabbles in this sacred place.','',396,274,0,0,0,0,0,0,0,0,0,0,26124),
(76116,'I don\'t think I\'ve ever seen the boss so upset.$b$bYou\'d best not go looking for the Prince until he cools down a little.','',1,0,0,0,0,0,6,0,1,0,0,0,26124),
(76117,'It\'s all I can do to stop from staring at the sun. It never moves.$b$bJust what IS this place?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(76118,'I\'ve got a hankerin\' to do some fishin\'!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76119,'Stop the intruder!','Stop the intruder!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76120,'To arms!','To arms!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76121,'Kill!','Kill!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76122,'No prisoners!','No prisoners!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76123,'Destroy the $pc!','Destroy the $pc!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76124,'Get that $pc!','Get that $pc!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76125,'You will die!','You will die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76126,'Lok-Narash!','Lok-Narash!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76127,'You cannot stop us, $c! All orcs will one day drink of the felblood!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76128,'The darkness comes!','The darkness comes!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76129,'The Council\'s will be done!','The Council\'s will be done!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76130,'Time to die, $pc!','Time to die, $pc!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76131,'Your soul will be consumed!','Your soul will be consumed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76132,'Quickly! Kill the intruders!','Quickly! Kill the intruders!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76133,'Kill the outsider!','Kill the outsider!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76134,'You will make a fine sacrifice!','You will make a fine sacrifice!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76135,'You\'re too late!','You\'re too late!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76136,'','You\'re too late, $c. The Shadow Council ascends!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76137,'I will consume your soul!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76138,'','Watch yourself out there. Those things come out of nowhere.',0,0,0,0,0,0,0,1,0,0,0,44144,26124),
(76139,'Rest well, honored mother. You will be avenged.','Rest well, honored mother. You will be avenged.',0,0,0,0,0,0,0,1,4,0,0,0,26124),
(76140,'What is making the ground shake?','What is making the ground shake?',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(76141,'I don\'t see a gronn. What is that?','I don\'t see a gronn. What is that?',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(76142,'The farseer says that Shui Halad has awakened.','The farseer says that Shui Halad has awakened.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(76143,'The great worm twists in its lair.','The great worm twists in its lair.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(76144,'Perhaps the Thunderlord have come to play.','Perhaps the Thunderlord have come to play.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(76145,'Why does the ground shake? Are we under attack?','Why does the ground shake? Are we under attack?',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(76146,'Someone calm the wolves.','Someone calm the wolves.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(76147,'The human wizard and his pet elf are to blame. The land knows they don\'t belong.','The human wizard and his pet elf are to blame. The land knows they don\'t belong.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(76148,'It\'s all fun and games until...','',0,0,0,0,0,0,0,0,6,0,45330,0,26124),
(76149,'Eye, what are you looking at?','',0,0,0,0,0,0,0,0,6,0,45329,0,26124),
(76150,'Razuun, you stay here. I have other plans for... what is that?','',0,0,0,0,0,0,0,0,6,0,45328,0,26124),
(76151,'All I require is its limitless power.','',0,0,0,0,0,0,0,0,6,0,45327,0,26124),
(76152,'It will be done, Lord Gul\'dan.','',0,0,0,0,0,0,0,0,6,0,44440,0,26124),
(76153,'Are you ready to change the world, $n?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(76154,'You know what needs to be done, champion.','',0,0,0,0,0,0,0,0,7,0,38845,0,26124),
(76155,'Meet me in the Veiled Stair when the deed is done - assuming you\'re still alive when this is over.','',0,0,0,0,0,0,0,0,7,0,38846,0,26124),
(76156,'Rrrraaaaghhhh!!','',0,0,0,0,0,0,0,0,0,0,38973,0,26124),
(76157,'My pain... is endless...','',0,0,0,0,0,0,0,0,0,0,38974,0,26124),
(76158,'The flames... never cease...','',0,0,0,0,0,0,0,0,0,0,38975,0,26124),
(76159,'I burn... for all time...','',0,0,0,0,0,0,0,0,0,0,38976,0,26124),
(76160,'You will take my place on the eternal brazier.','',0,0,0,0,0,0,0,0,0,0,38971,0,26124),
(76161,'Your flesh will melt.','',0,0,0,0,0,0,0,0,0,0,38978,0,26124),
(76162,'Your pain will be endless.','',0,0,0,0,0,0,0,0,0,0,38979,0,26124),
(76163,'You will feel but a fraction of my agony.','',0,0,0,0,0,0,0,0,0,0,38980,0,26124),
(76164,'Burn!','',0,0,0,0,0,0,0,0,0,0,38981,0,26124),
(76165,'Up in smoke.','',0,0,0,0,0,0,0,0,0,0,38977,0,26124),
(76166,'The eternal fire will never be extinguished.','',0,0,0,0,0,0,0,0,0,0,38972,0,26124),
(76167,'Steady hands..','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76168,'Blue wire with the green stripe, or black wire with the yellow stripe? I can never remember.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76169,'','Hurry up!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76170,'','Not the red wire, the blue one!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76171,'','Wait for me!',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(76172,'Knocking Down','Knocking Down',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76173,'I live again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76174,'Hahahahaha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76175,'The South Seas are mine to pillage for all eternity!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76176,'Come, Vazuvius, rise from the depths!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76177,'|TInterface\\Icons\\ability_gouge:20|t%s attempts to |cFFFF0000|Hspell:143330|h[Gouge]|h|r you, turn away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76178,'','Oi! That was a fun ride!',0,0,0,0,0,0,0,0,6,0,0,38187,26124),
(76179,'','Heroes, I salute you. There\'s something right foul in these chambers below the city.',0,0,0,0,0,0,0,0,6,0,0,38188,26124),
(76180,'','Ooh, that looks dangerous. Get in there, boys, and show em\' what we\'re made of.',0,0,0,0,0,0,0,0,6,0,0,38189,26124),
(76181,'','A right deadly machine, that is. Best watch yer step down here, heroes.',0,0,0,0,0,0,0,0,6,0,0,38190,26124),
(76182,'Oh, ho ho... Hey now. What do we have here?','',0,0,0,0,0,0,0,0,6,0,38571,0,26124),
(76183,'So Garrosh thinks he can cheat ol\' Grizzle out of a payday, huh?!','',0,0,0,0,0,0,0,0,6,0,38572,0,26124),
(76184,'Go get it boys, that contraption\'s got nothin\' on real goblin engineering!','',0,0,0,0,0,0,0,0,6,0,38573,0,26124),
(76185,'Ahhhh! Or maybe it does. I better, um, go check on the others.','',0,0,0,0,0,0,0,0,6,0,38574,0,26124),
(76186,'','This island is equal parts fascinating and terrifying.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76187,'Gorlocs.','Gorlocs.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76188,'<Ku\'ma stares at you.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76189,'','Let us test your knowledge of history, then! Tell me, hero, what are undead murlocs called?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76190,'Mur\'ghouls.','Mur\'ghouls.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76191,'Wolvar.','Wolvar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76192,'Mur\'liches.','Mur\'liches.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76193,'','Incorrect!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76194,'','That is correct!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76195,'','Let us test your knowledge of history, then! White wolves were once the favored mounts of which orc clan?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76196,'','Let us test your knowledge of history, then! What is the highest rank bestowed on a druid?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76197,'','Let us test your knowledge of history, then! Who is the current leader of the gnomish people?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76198,'','Let us test your knowledge of history, then! Malfurion Stormrage helped found this group, which is the primary druidic organization of Azeroth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76199,'','Let us test your knowledge of history, then! Brown-skinned orcs first began showing up on Azeroth several years after the Third War, when the Dark Portal was reactivated. What are these orcs called?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76200,'','Let us test your knowledge of history, then! Before she was raised from the dead by Arthas to serve the Scourge, Sindragosa was a part of what dragonflight?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76201,'','Let us test your knowledge of history, then! This structure, located in Zangarmarsh, was controlled by naga who sought to drain a precious and limited resource: the water of Outland.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76202,'','Let us test your knowledge of history, then! What was the original name of the world connected to Azeroth via the Dark Portal?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76203,'','Let us test your knowledge of history, then! What powerful sword could smite the undead with such force that only ashes remained?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76204,'','Let us test your knowledge of history, then! How many dragonflights were bestowed with special powers in order to protect the world of Azeroth?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76205,'','Let us test your knowledge of history, then! What night elf is widely known as \"the Betrayer\"?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76206,'','Let us test your knowledge of history, then! Most forest trolls became hostile to the Horde after the Second War. Which tribe of forest trolls is on friendly terms with the Horde today?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76207,'','Let us test your knowledge of history, then! What demon forced the blue dragon Kalecgos to fight a group of adventurers in the Sunwell Plateau?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76208,'','Let us test your knowledge of history, then! One of Sylvanas Windrunner\'s sisters leads a militant faction of high elves and Kirin Tor. What is the name of this group?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76209,'','Let us test your knowledge of history, then! What famous axe did Grom Hellscream wield in battle?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76210,'','Let us test your knowledge of history, then! What did the Dragon Aspects give the night elves after the War of the Ancients?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76211,'','Let us test your knowledge of history, then! What evidence drove Prince Arthas to slaughter the people of Stratholme during the Third War?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76212,'','Let us test your knowledge of history, then! Arthas\'s death knights were trained in a floating citadel that was taken by force when many of them rebelled against the Lich King. What was the fortress\'s name?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76213,'','Let us test your knowledge of history, then! Thane Kurdran Wildhammer recently suffered a tragic loss when his valiant gryphon was killed in a fire. What was this gryphon\'s name?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76214,'','Let us test your knowledge of history, then! This queen oversaw the evacuation of her people after the Cataclysm struck and the Forsaken attacked her nation.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76215,'','Let us test your knowledge of history, then! Before Ripsnarl became a worgen, he had a family. What was his wife\'s name?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76216,'','Let us test your knowledge of history, then! Who was the first death knight to be created on Azeroth?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76217,'','Let us test your knowledge of history, then! Formerly a healthy paladin, this draenei fell ill after fighting the Burning Legion and becoming one of the Broken. He later became a powerful shaman.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76218,'','Let us test your knowledge of history, then! Who were the three young twilight drakes guarding twilight dragon eggs in the Obsidian Sanctum?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76219,'','Let us test your knowledge of history, then! What is the name of Tirion Fordring\'s gray stallion?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76220,'','Let us test your knowledge of history, then! This Horde ship was crafted by goblins. Originally intended to bring Thrall and Aggra to the Maelstrom, the ship was destroyed in a surprise attack by the Alliance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76221,'','Let us test your knowledge of history, then! Name the titan lore-keeper who was a member of the elite Pantheon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76222,'','Let us test your knowledge of history, then! Who was the mighty proto-dragon captured by Loken and transformed into Razorscale?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76223,'','Let us test your knowledge of history, then! The draenei like to joke that in the language of the naaru, the word Exodar has this meaning.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76224,'','Let us test your knowledge of history, then! Whose tomb includes the inscription \"May the bloodied crown stay lost and forgotten\"?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76225,'','Let us test your knowledge of history, then! Who was the first satyr to be created?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76226,'','Let us test your knowledge of history, then! Which of these is the correct name for King Varian Wrynn\'s first wife?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76227,'','Let us test your knowledge of history, then! Name the homeworld of the ethereals.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76228,'','Let us test your knowledge of history, then! Before the original Horde formed, a highly contagious sickness began spreading rapidly among the orcs. What did the orcs call it?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76229,'','Let us test your knowledge of history, then! This defender of the Scarlet Crusade was killed while slaying the dreadlord Beltheris.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76230,'','Let us test your knowledge of history, then! The Ironforge library features a replica of an unusually large ram\'s skeleton. What was the name of this legendary ram?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76231,'','Let us test your knowledge of history, then! In the assault on Icecrown, Horde forces dishonorably attacked Alliance soldiers who were busy fighting the Scourge and trying to capture this gate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76232,'','Let us test your knowledge of history, then! What phrase means \"Thank you\" in Draconic, the language of dragons?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76233,'','Let us test your knowledge of history, then! While working as a tutor, Stalvan Mistmantle became obsessed with one of his students, a young woman named Tilloa. What was the name of her younger brother?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76234,'','Let us test your knowledge of history, then! Not long ago, this frail Zandalari troll sought to tame a direhorn. Although he journeyed to the Isle of Giants, he was slain in his quest. What was his name?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76235,'','Let us test your knowledge of history, then! This emissary of the Horde felt that Silvermoon City was a little too bright and clean.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76236,'','Let us test your knowledge of history, then! Succubus demons revel in causing anguish, and they serve the Legion by conducting nightmarish interrogations. What species is the succubus?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76237,'','Let us test your knowledge of history, then! One name for this loa is \"Night\'s Friend\".',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76238,'','Let us test your knowledge of history, then! In Taur-ahe, the language of the tauren, what does lar\'korwi mean?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76239,'Whiteclaw clan.','Whiteclaw clan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76240,'Warsong clan.','Warsong clan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76241,'Frostwolf clan.','Frostwolf clan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76242,'Icefang clan.','Icefang clan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76243,'Shaman.','Shaman.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76244,'Stormcaller.','Stormcaller.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76245,'Archdruid.','Archdruid.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76246,'Far seer.','Far seer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76247,'Gelbin Mekkatorque.','Gelbin Mekkatorque.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76248,'Millhouse Manastorm.','Millhouse Manastorm.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76249,'Sicco Thermaplugg.','Sicco Thermaplugg.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76250,'Fizzcrank Fullthrottle.','Fizzcrank Fullthrottle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76251,'Crimson Ring.','Crimson Ring.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76252,'Emerald Circle.','Emerald Circle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76253,'Earthen Ring.','Earthen Ring.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76254,'Cenarion Circle.','Cenarion Circle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76255,'Mag\'har.','Mag\'har.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76256,'Felblood.','Felblood.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76257,'Mok\'Nathal.','Mok\'Nathal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76258,'Fel orc.','Fel orc.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76259,'Red dragonflight.','Red dragonflight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76260,'Blue dragonflight.','Blue dragonflight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76261,'Green dragonflight.','Green dragonflight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76262,'Bronze dragonflight.','Bronze dragonflight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76263,'Snakecoil Cavern.','Snakecoil Cavern.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76264,'Serpentine Basin.','Serpentine Basin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76265,'Coilfang Reservoir.','Coilfang Reservoir.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76266,'Spiralfang Cistern.','Spiralfang Cistern.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76267,'Draenor.','Draenor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76268,'Argus.','Argus.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76269,'Koltar.','Koltar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76270,'Kalimdor.','Kalimdor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76271,'Ashbringer.','Ashbringer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76272,'Lightbringer.','Lightbringer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76273,'Light\'s Vengeance.','Light\'s Vengeance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76274,'Soulfire.','Soulfire.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76275,'Five.','Five.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76276,'Four.','Four.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76277,'Seven.','Seven.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76278,'Three.','Three.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76279,'Tyrande Whisperwind.','Tyrande Whisperwind.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76280,'Tyranis Malem.','Tyranis Malem.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76281,'Fandral Staghelm.','Fandral Staghelm.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76282,'Illidan Stormrage.','Illidan Stormrage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76283,'Smolderthorn tribe.','Smolderthorn tribe.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76284,'Amani tribe.','Amani tribe.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76285,'Revantusk tribe.','Revantusk tribe.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76286,'Shadowglen tribe.','Shadowglen tribe.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76287,'Razelikh the Defiler.','Razelikh the Defiler.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76288,'Archimonde the Defiler.','Archimonde the Defiler.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76289,'Sathrovarr the Corruptor.','Sathrovarr the Corruptor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76290,'Talnivarr the Sleeper.','Talnivarr the Sleeper.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76291,'Violet Eye.','Violet Eye.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76292,'Silver Covenant.','Silver Covenant.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76293,'Sunreavers.','Sunreavers.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76294,'Bladedancers.','Bladedancers.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76295,'Gorefang.','Gorefang.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76296,'Bloodcleave.','Bloodcleave.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76297,'Gorehowl.','Gorehowl.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76298,'Shriekblade.','Shriekblade.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76299,'Teldrassil.','Teldrassil.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76300,'Well of Eternity.','Well of Eternity.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76301,'Nordrassil.','Nordrassil.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76302,'Moonwells.','Moonwells.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76303,'Tainted soil.','Tainted soil.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76304,'Tainted wildlife.','Tainted wildlife.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76305,'Tainted water.','Tainted water.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76306,'Tainted grain.','Tainted grain.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76307,'Acherus.','Acherus.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76308,'Naxxanar.','Naxxanar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76309,'Kolramas.','Kolramas.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76310,'Naxxramas.','Naxxramas.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76311,'Swiftwing.','Swiftwing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76315,'Sharpbeak.','Sharpbeak.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76316,'Sky\'ree.','Sky\'ree.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76317,'Stormbeak.','Stormbeak.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76318,'Queen Lia Greymane.','Queen Lia Greymane.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76319,'Queen Malia Greymane.','Queen Malia Greymane.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76320,'Queen Liria Greymane.','Queen Liria Greymane.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76321,'Queen Mia Greymane.','Queen Mia Greymane.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76322,'Emma Harrington.','Emma Harrington.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76323,'Calissa Harrington.','Calissa Harrington.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76324,'Vanessa Whitehall.','Vanessa Whitehall.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76325,'Katrina Whitehall.','Katrina Whitehall.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76326,'Teron Gorefiend.','Teron Gorefiend.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76327,'Arthas Menethil.','Arthas Menethil.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76328,'Alexandros Mograine.','Alexandros Mograine.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76329,'Koltira Deathweaver.','Koltira Deathweaver.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76333,'Velen.','Velen.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76334,'Akama.','Akama.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76335,'Maraad.','Maraad.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76336,'Nobundo.','Nobundo.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76337,'Tenebron, Vesperon, and Shadron.','Tenebron, Vesperon, and Shadron.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76338,'Tenebron, Vesperon, and Halion.','Tenebron, Vesperon, and Halion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76339,'Theralion, Shadron, and Abyssion.','Theralion, Shadron, and Abyssion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76340,'Theralion, Halion, and Abyssion.','Theralion, Halion, and Abyssion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76342,'Ashanor.','Ashanor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76343,'Mistsilver.','Mistsilver.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76351,'Feonir.','Feonir.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76352,'Mirador.','Mirador.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76353,'Draka\'s Fury.','Draka\'s Fury.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76354,'Hellscream\'s Fury.','Hellscream\'s Fury.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76355,'Aggra\'s Fury.','Aggra\'s Fury.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76356,'Durotan\'s Fury.','Durotan\'s Fury.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76358,'Aman\'Thul.','Aman\'Thul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76359,'Norgannon.','Norgannon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76361,'Eonar.','Eonar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76362,'Khaz\'goroth.','Khaz\'goroth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76385,'Galakrond.','Galakrond.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76386,'Veranus.','Veranus.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76387,'Zeptek.','Zeptek.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76388,'Kill them all! No survivors!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76389,'Vyletongue.','Vyletongue.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76390,'Defective elekk turd.','Defective elekk turd.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76391,'Crystal death trap.','Crystal death trap.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76392,'Worthless elekk dung.','Worthless elekk dung.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76393,'Radioactive biohazard.','Radioactive biohazard.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76394,'Prince Arthas Menethil.','Prince Arthas Menethil.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76395,'King Llane Wrynn.','King Llane Wrynn.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76396,'Uther the Lightbringer.','Uther the Lightbringer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76397,'King Terenas Menethil II.','King Terenas Menethil II.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76398,'Peroth\'arn.','Peroth\'arn.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76399,'Garaxxas.','Garaxxas.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76400,'Xavius.','Xavius.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76401,'Vyletongue.','Vyletongue.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76402,'Tiffin Windemere Wrynn.','Tiffin Windemere Wrynn.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76403,'Therese Anne Wrynn.','Therese Anne Wrynn.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76404,'Therese Angharad Wrynn.','Therese Angharad Wrynn.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76405,'Tiffin Ellerian Wrynn.','Tiffin Ellerian Wrynn.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76407,'K\'aresh.','K\'aresh.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76409,'Xarodi.','Xarodi.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76410,'Khu\'ral.','Khu\'ral.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76412,'Xoroth.','Xoroth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76422,'Scarlet fever.','Scarlet fever.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76423,'Blood pox.','Blood pox.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76424,'Crimson fever.','Crimson fever.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76425,'Red pox.','Red pox.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76431,'Fellari Swiftarrow.','Fellari Swiftarrow.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76432,'Holia Sunshield.','Holia Sunshield.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76433,'Yana Bloodspear.','Yana Bloodspear.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76434,'Valea Twinblades.','Valea Twinblades.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76435,'Gorehoof.','Gorehoof.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76436,'Toothgnasher.','Toothgnasher.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76437,'Bloodhorn.','Bloodhorn.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76438,'Steelmauler.','Steelmauler.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76440,'Corp\'rethar.','Corp\'rethar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76441,'Aldur\'thar.','Aldur\'thar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76442,'Angrathar.','Angrathar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76443,'Mord\'rethar.','Mord\'rethar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76444,'Borela mir.','Borela mir.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76445,'Belan shi.','Belan shi.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76446,'Avral shi.','Avral shi.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76447,'Alena mir.','Alena mir.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76448,'Billy.','Billy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76449,'William.','William.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76450,'Giles.','Giles.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76451,'Tobias.','Tobias.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76452,'Maaka.','Maaka.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76453,'Grimath.','Grimath.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76454,'Talak.','Talak.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76456,'Ra\'wiri.','Ra\'wiri.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76460,'Cheneta.','Cheneta.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76462,'Kristine Denny.','Kristine Denny.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76463,'Tatai.','Tatai.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76465,'Dela Runetotem.','Dela Runetotem.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76472,'Ered\'ruin.','Ered\'ruin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76473,'Sayaad.','Sayaad.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76475,'Shivarra.','Shivarra.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76476,'Eredar.','Eredar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76477,'Shirvallah.','Shirvallah.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76478,'Kimbul.','Kimbul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76479,'Mueh\'zala.','Mueh\'zala.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76480,'Shadra.','Shadra.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76481,'Sharp claw.','Sharp claw.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76483,'Razor tooth.','Razor tooth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76485,'Sharp tooth.','Sharp tooth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76487,'Razor claw.','Razor claw.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76527,'Hello, traveler!$b$bAre you coming to the Wanderer\'s Festival tonight? Pandaren will gather right here on Turtle Beach shortly after sunset! It\'s quite the sight.$b$bSpeak to me as the event draws near and I will let you know how long you have to wait.','',1,0,0,0,0,0,6,0,1,0,0,0,26124),
(76528,'Hello, traveler!$b$bAre you coming to the Wanderer\'s Festival tonight? Pandaren will gather right here on Turtle Beach shortly after sunset! It\'s quite the sight.$b$bThe festival will begin under three hours from now. Check back at the top of the hour!','',1,0,0,0,0,0,6,0,1,0,0,0,26124),
(76529,'Hello, traveler!$b$bAre you coming to the Wanderer\'s Festival tonight? Pandaren will gather right here on Turtle Beach shortly after sunset! It\'s quite the sight.$b$bThe festival will begin under two hours from now. Check back at the top of the hour!','',1,0,0,0,0,0,6,0,1,0,0,0,26124),
(76530,'Hello, traveler!$b$bAre you coming to the Wanderer\'s Festival tonight? Pandaren will gather right here on Turtle Beach shortly after sunset! It\'s quite the sight.$b$bWithin the next hour, the festival will begin. Check back at the top of the hour!','',1,0,0,0,0,0,6,0,1,0,0,0,26124),
(76531,'The festival has begun! Invite your friends!$b$bBe sure not to miss the fireworks at the beginning or end of the festival. They\'re the most important part.','',1,0,0,0,0,0,6,0,1,0,0,0,26124),
(76532,'You heard the king, bolster the line! Give our heroes the time they need to reach Garrosh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76533,'Requires Skeleton Key','Requires Skeleton Key',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76534,'You dare interrupt my dinner?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76535,'Somethings smells funny... AHA! I see you $c!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76536,'So, soo... hungry... Ack!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76537,'Hey, mon! I be Adjutant Historian Ju\'pa. Dey not add dat to me title yet, but I be sure that be temporary.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76538,'Greetings! I am Historian Llore! Everyone says I smile too much, but I don\'t think that\'s possible!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76539,'At last, the time for justice is at hand. This monster will answer for each and every Alliance life that we have lost in this war.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76540,'Garrosh will pay for his crimes.','Garrosh will pay for his crimes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76541,'Thank you for helping me end the great mistake I made long ago, that led our people into this dark place. I could not do it alone. Let me regain my honor, and end Garrosh\'s reign of terror once and for all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76542,'End it, for the Horde.','End it, for the Horde.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76543,'We\'ll hold the line, $n. You just worry about putting an end to Garrosh\'s madness.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(76544,'The first lock of the Thrice-Locked cage clicks and falls to the ground. Two Remain.','The first lock of the Thrice-Locked cage clicks and falls to the ground. Two Remain.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76545,'The second lock of the Thrice-Locked cage clicks and falls to the ground. One Remains.','The second lock of the Thrice-Locked cage clicks and falls to the ground. One Remains.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76546,'The third lock of the Thrice-Locked cage clicks and falls to the ground. The cage opens!','The third lock of the Thrice-Locked cage clicks and falls to the ground. The cage opens!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76547,'I like shorts! They\'re perfect for this weather!','I like shorts! They\'re perfect for this weather!',1,0,0,0,0,0,0,0,5,0,0,0,26124),
(76548,'I only have one pet! I hope that\'s ok!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76549,'Go easy on me!','',6,0,0,0,0,0,0,0,5,0,0,0,26124),
(76550,'Your pet fell down!','',1,0,0,0,0,0,0,0,5,0,0,0,26124),
(76551,'Awww! No fair!','',25,0,0,0,0,0,0,0,5,0,0,0,26124),
(76552,'Yay! I\'m the best!','',4,0,0,0,0,0,0,0,5,0,0,0,26124),
(76553,'You have parcel to pick up? You have mail to send?$B$BVery fast service, yes!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(76554,'Use the mail service.','Use the mail service.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76557,'<PH> REUSE','<PH> REUSE',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76558,'','Eee! Wh-what?! Oh...$B$BD-did you n-need something?$B$BWhy d-did I ever let my sister convince me to visit here... have you SEEN how b-big the animals get?!',430,2,6,0,1,3,0,0,0,0,0,0,26124),
(76559,'<The scruffy old pandaren snores peacefully. A pile of assorted bottles are strewn about next to him.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76560,'Examine his goods.','Examine his goods.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76561,'','Oh, hello!$B$BPlease, come in, come in! Rest for a while.$B$BWould you like something to eat? To drink?',3,1,0,0,2,0,0,0,0,0,0,0,26124),
(76562,'','Your face!',4,0,0,0,0,0,4,0,0,0,0,0,26124),
(76563,'Faster! Keep moving!','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(76564,'One more mistake and you\'re going in next!','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(76565,'You should be thankful you aren\'t on kitchen duty chopping wood!','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(76566,'Put your backs into it!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(76567,'We need to complete the ritual now! Faster!','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(76568,'Show me what you\'re workin\' with!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76569,'Well met, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76570,'Farewell my friends, for time grows short. I must depart.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76571,'POOF!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76572,'Do you know any good jokes, $r?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76573,'Ahahaha, that was a good one!','',0,0,0,0,0,0,11,0,0,0,0,0,26124),
(76574,'You know, you\'re pretty funny.','',0,0,0,0,0,0,11,0,0,0,0,0,26124),
(76575,'Nah, I don\'t much care for that one. Do you have any more?','',0,0,0,0,0,0,11,0,0,0,0,0,26124),
(76576,'Ahahahaha... hahahahahaha!','',0,0,0,0,0,0,11,0,0,0,0,0,26124),
(76577,'Ahahaha... Oh, I\'m holding my sides at that one!','',0,0,0,0,0,0,11,0,0,0,0,0,26124),
(76578,'Hohohoho, that\'s a funny one! Tell me another.','',0,0,0,0,0,0,11,0,0,0,0,0,26124),
(76579,'Beautiful day, isn\'t it?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76580,'For the Light.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76581,'Have you seen my comrades?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76582,'Your challenge has been answered, outsider. Ordon, claim this area in the name of the Burning God!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76583,'','A historian\'s work is never done, you see. There\'s always something important happening that we will need to remember.$B$BI\'ve written much of your legacy already, but there is still so much to learn! Surely your feats will be remembered for ages to come.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76584,'My eyes are playing tricks on me! Are those... skeletons manning that ship?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76585,'That storm pushed us off course. We could be anywhere between Kul Tiras and Lordaeron, so stay sharp!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76586,'I ain\'t seen mist this thick before. We\'ll have to drop our sails and wait for it to pass. I don\'t much like the thought of beaching The Barnacle on a shallow reef today.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76587,'What\'s that in the distance? Sails? Ahoy! We\'ve been stranded fer nine days! Help us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76588,'All hands on deck! The Barnacle\'s under attack!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76589,'Thank you. I don\'t know if I would have survived without your help.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76590,'Turgall was a cruel master. He tortured his slaves and let us starve to death!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76591,'I am sorry for such a short meeting. I must seek my rylak companion. She disappeared before I was captured. Again, you have my thanks.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76592,'Hey, watch it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76593,'Ow! I hit you back for that!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76594,'Don\'t hit me, stupid!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76595,'Back off, dis one is mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76596,'Argh! I kill you first, den I smash little one!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76597,'Outta my way!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76598,'Urgh, I kill you for that!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76599,'Gah, my eye! Where you learn that?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76600,'Had enough yet?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76601,'Tough guy, huh? I show you tough!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76602,'You\'ve made your final mistake, foreigner. Feel the power of lava as your bones melt!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76603,'My body becomes one with the volcanoes.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76604,'Not so tough now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76605,'Dats what I thought!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76606,'Shoulda stayed outta my way!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76607,'Rahh! I crush anyone who challenge me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76608,'Now you stupid AND dead!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76609,'','Time can be both beautiful and cruel.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76610,'Ain\'t no other way, mon. We gotta stop Garrosh here an\' now, else we be runnin\' the rest of our lives.','',0,0,0,0,0,0,1,0,0,0,39151,0,26124),
(76611,'Dey must have taken da docks!  Ha ha!  Welcome to da\' fields of slaughter.','',0,0,0,0,0,0,1,0,0,0,39152,0,26124),
(76612,'Dey be heroes, no doubt about dat.','',0,0,0,0,0,0,1,0,0,0,39144,0,26124),
(76613,'Da beast be slain!','',0,0,0,0,0,0,5,0,0,0,39145,0,26124),
(76614,'Tyrande...','',0,0,0,0,0,0,1,0,0,0,39153,0,26124),
(76615,'Garrosh be concealin\' a whole hidden base. Where did his lust for power take him?','',0,0,0,0,0,0,5,0,0,0,39146,0,26124),
(76616,'Baine, you and your warriors hold this junction. These heroes should forge ahead an\' flush the Warchief out of hiding.','',0,0,0,0,0,0,1,0,0,0,39147,0,26124),
(76617,'People be dyin\' up above. Da city is in chaos. I\'m gonna finish it - stop da bloodshed. I\'ll come back for ya.','',0,0,0,0,0,0,1,0,0,0,39148,0,26124),
(76618,'It\'s gonna be fine, Baine. We gonna find Thrall, gonna kill de Warchief, gonna avenge your father.','',0,0,0,0,0,0,1,0,0,0,39149,0,26124),
(76619,'Hah. Darkspear never die.','',0,0,0,0,0,0,1,0,0,0,39150,0,26124),
(76620,'','Anu\'dora!',0,0,0,0,0,0,5,0,0,0,0,38309,26124),
(76621,'','At them, my sisters! For Kalimdor!',0,0,0,0,0,0,5,0,0,0,0,38310,26124),
(76622,'','Don\'t think we\'re here to save you, troll. We\'re here for Kalimdor.  Get forces inside the gates while we distract the enemy!',0,0,0,0,0,0,1,0,0,0,0,38311,26124),
(76623,'Our casualties are too heavy!','',0,0,0,0,0,0,5,0,0,0,38262,0,26124),
(76624,'Perhaps our newfound reinforcements will aid us.','',0,0,0,0,0,0,1,0,0,0,38263,0,26124),
(76625,'Perhaps there is hope after all.','',0,0,0,0,0,0,1,0,0,0,38264,0,26124),
(76626,'Blessing of the Earthmother be upon them.','',0,0,0,0,0,0,1,0,0,0,38256,0,26124),
(76627,'We will soon find out. He is cornered like a rat down one of these corridors.','',0,0,0,0,0,0,1,0,0,0,38257,0,26124),
(76628,'What should we do next?','',0,0,0,0,0,0,6,0,0,0,38258,0,26124),
(76629,'What about you?','',0,0,0,0,0,0,6,0,0,0,38259,0,26124),
(76630,'...very well.','',0,0,0,0,0,0,1,0,0,0,38260,0,26124),
(76631,'Earthmother protect you, Vol\'jin.','',0,0,0,0,0,0,1,0,0,0,38261,0,26124),
(76632,'','Going so soon? What about the customers?',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(76633,'Ha! We\'ve weathered storms worse than this, $n. Now hurry, you don\'t want to keep Garrosh waiting!','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(76634,'Garrosh\'s madness must be stopped, $n, our future depends on it. While the gravity of this task is immense, I would not entrust this deed to another.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(76635,'|TInterface\\Icons\\ability_titankeeper_quarantine.blp:20|tNorushen activates the |cFFFF0000|Hspell:145779|h[Safety Measures]|h|r of the Quarantine Zone!','|TInterface\\Icons\\ability_titankeeper_quarantine.blp:20|tNorushen activates the |cFFFF0000|Hspell:145779|h[Safety Measures]|h|r of the Quarantine Zone!',0,0,0,0,0,0,0,0,1,0,38895,38895,26124),
(76636,'','Do you need an outfit, traveler? I can help.',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(76637,'','I could see you from a mile away in THAT outfit, $r.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(76638,'','I know just the color that would suit your complexion.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(76639,'','Over here, $r. Gimme those scraps and I\'ll whip up some options.',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(76640,'','I swear, none of these Kor\'kron animals will pass as long I draw breath. Just promise you will put Garrosh down like the rabid dog he is.',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(76641,'','Right now, the best medical care I can provide is giving you the tools to avoid injury in the first place.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(76642,'','This is definitely more exciting than my usual intelligence gathering operations. Now hurry and take care of Garrosh, I don\'t want this to be my last mission for SI:7.',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(76645,'I don\'t care how fancy your gear is, $n, if you don\'t take care of your feet then you\'re finished. So give those pups a break and use my portal to instantly travel back the entrance.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(76648,'I win!','',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(76649,'','I can help you pull off ANY look. What do you need?',0,0,0,0,0,0,547,0,0,0,0,0,26124),
(76650,'Show me my options.','Show me my options.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76651,'This mission is far too vital to leave your repairs in the hands of someone other than myself.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(76652,'','Ah! I was sent here to guide you to the Timeless Isle, but I see you have already made the voyage. I fear I have gotten tangled up in the timeways again.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76653,'','%s pulls out a bronze timepiece, shakes it, and squints at the dial. She seems somewhat embarassed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76654,'Quit yer bickering!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76655,'Dat\'s enough brawlin\'!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76656,'Get over here and help me! You can kill each other later!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76657,'Get back in line!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76658,'Knock it off!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76659,'','Every life is a thread, and the tapestry we weave together is the story of our world. The pandaren lorewalkers know this more than any other. Just look at this library! So many stories...',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(76661,'Aid me, essence of lava!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76662,'','Welcome to Woo\'s, where the sun is always shining and the food is always hot!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76663,'What smells delicious?','What smells delicious?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76664,'','It\'s nice to sit amongst friends both old and new.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76665,'','Don\'t forget to take some time to just enjoy the scenery!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76666,'','I have the best seat in the house, don\'t you think?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76667,'Everybody nice here... Chee Chee like that.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(76668,'You going to fight giant ox?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(76669,'You strongest looking $c Chee Chee has ever seen!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(76670,'Impressive.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76671,'Yes, $n?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76672,'I am prepared to fly into Karabor.','I am prepared to fly into Karabor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76673,'Well played.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76674,'You\'ve stumbled right into my trap.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76675,'Hmm.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76676,'One more, Kat.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76677,'Ah, more of Vol\'jin\'s revolutionaries. You\'ve made it.','',0,0,0,0,0,0,0,0,0,0,38920,0,26124),
(76678,'Have you found Thrall? I am badly hurt, he insisted on going ahead alone.','',0,0,0,0,0,0,0,0,0,0,38921,0,26124),
(76679,'Tell me, how goes the battle up above? What of Nazgrim? Speak to me!','',0,0,0,0,0,0,0,0,0,0,38922,0,26124),
(76680,'Ah, Nazgrim. A great leader and a fine warrior. He valued his oath to the Warchief more than his life.','',0,0,0,0,0,0,0,0,0,0,38923,0,26124),
(76681,'I tried to tell him... to tell him that Hellscream betrayed us, cast aside a Warchief\'s responsibility to his own people.  But Nazgrim... too loyal... too proud.','',0,0,0,0,0,0,0,0,0,0,38924,0,26124),
(76682,'Damn Hellscream.  His ambition tore our Horde apart.','',0,0,0,0,0,0,274,0,0,0,38925,0,26124),
(76683,'Go on, find Thrall.  Finish this.  I will live.','',0,0,0,0,0,0,1,0,0,0,38926,0,26124),
(76684,'In the name of Warlord Garrosh, kill them all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76685,'','Thank you for coming on such short notice, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76687,'Clear these invaders from Lok-rath. Then we will destroy their pitiful base.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76688,'Iron Horde, use your war machines to level the enemy base.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76689,'You\'re just in time, sacrifice!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76690,'Go quickly, $n, bring an end to Garrosh. And remember, the Earth Mother\'s eyes are upon you.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(76691,'I swear by the power of An\'she, these Kor\'kron whelps will not pass.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(76692,'','You\'re going down!',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(76695,'Riko make sure Kor\'kron get ooked in their dooker. $n do favor for Riko in return? Tell Kiryn, Riko the one who bashy Garrosh.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(76698,'','I...lost?',547,0,0,0,0,0,0,0,0,0,0,0,26124),
(76699,'','Now that\'s what I\'m talking about!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76700,'','I swear by my ancestors, these Kor\'kron will not pass. Now go, $n, the honor of felling Garrosh is yours!',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(76701,'','Let\'s see...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76702,'','Nice move!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76703,'','Let\'s do it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76704,'','I\'ve still got a few moves left up my sleeve!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76705,'','I don\'t have enough mana! Oh no!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76706,'','I need to rebuild my deck...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76707,'','You aren\'t so tough!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76712,'Well played, sir.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76713,'How\'s about another round?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76714,'How\'d you like that card?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76715,'Ten kegs of the strongest ale to whoever brings me $p\'s head!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76716,'Hrmph. Nice card.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76717,'Do you feel the power they\'re drawing on? (It\'s the naaru in Nagrand!)','',0,0,0,0,0,0,0,1,0,0,46609,0,26124),
(76718,'Haven\'t seen that card before.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76719,'Best two out of three!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76720,'I\'m makin\' a comeback!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76721,'Come, $p. Meet your end, coward.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76722,'Now that\'s what I call a match!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76723,'This time, I\'m goin\' t\' kick yer rear!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76724,'Alright, alright, you win.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76725,'Yeah, yeah, I\'ll come join you on your adventure. Just let me play one more game first.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76726,'This is the best I\'ve felt in years!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76727,'See this card here? This one\'s going to really knock the dwarf off his chair!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76728,'How do ye figure he\'s so good at this game?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76729,'See this card? He won\'t see this one comin\'!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76730,'I can beat him, I swear!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76731,'Unleash Shagor. Let loose the Terror of Nagrand!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76732,'','I\'ll offer what aid I can, $n. Just promise you\'ll make lots of delicious Kor\'kron corpses on your way to Garrosh.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(76733,'I\'ve got the brains, you\'ve got the muscle. Together, we\'ll make beautiful carnage.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(76734,'The harbor defenses have fallen! Kor\'kron, fall back and move to higher ground!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76735,'Players capture control of the South Tower Anti-Air Turret!','Players capture control of the South Tower Anti-Air Turret!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76736,'Greetings, $r.  I am the sworn protector of Watcher Megana.  She has special gifts that I... uh, our leaders... greatly admire, and must be guarded closely.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76737,'','Merchants will spend that extra bit for something with more variety like the Dragon\'s Nest Noodle Soup.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76738,'','Farmhands need the hearty goodness of the Pandaren Treasures Noodle Soup to restore their spirit after a hard day\'s work in the fields.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76739,'Alright. I need some help... I\'m lookin\' for my body. It\'s somewhere in this cave, but you can only see it if you\'re in the spirit world. If you want to help me find it, let me know.\n\nBe warned, though. The timeless spirits can kick us out of the spirit world, and I don\'t think I\'m strong enough to get you back in there for a while if they do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76740,'I\'m ready to enter the spirit world.','I\'m ready to enter the spirit world.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76742,'We needed these weapons done hours ago. Move!','',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(76743,'Yes, sir.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76744,'This isn\'t smashing...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76745,'I\'m on it, I\'m on it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76746,'I\'m busy here! What do you want?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76748,'The Klaxxi Paragons go berserk!','The Klaxxi Paragons go berserk!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76750,'Not today, little $pr!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76751,'$n has captured the Center Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76752,'$n has captured the Pandaren Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76753,'$n has captured the Goblin Mine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76754,'','Come, foul creature.',0,0,0,0,0,0,0,7,0,0,0,44121,26124),
(76755,'Together, we will defeat the Shadow Council.','',1,0,0,0,0,0,0,7,0,0,0,0,26124),
(76756,'No one can stop us! Onward to the open seas!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76757,'Select a phrase to carve into the sign.','Select a phrase to carve into the sign.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76758,'Town ahead.','Town ahead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76759,'Danger ahead.','Danger ahead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76760,'Treasure ahead.','Treasure ahead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76761,'Difficult enemy ahead.','Difficult enemy ahead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76762,'Enemy faction ahead.','Enemy faction ahead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76763,'Secret nearby.','Secret nearby.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76764,'Here!','Here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76765,'Dead end.','Dead end.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76766,'Death trap.','Death trap.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76767,'Horde nearby.','Horde nearby.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76768,'Alliance nearby.','Alliance nearby.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76769,'Need tank.','Need tank.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76770,'Need healer.','Need healer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76771,'Need damage-dealer.','Need damage-dealer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76772,'Need special item.','Need special item.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76773,'Need epic weapon.','Need epic weapon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76774,'Need friends.','Need friends.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76775,'Rare creature.','Rare creature.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76776,'Deadly fall.','Deadly fall.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76777,'Tears.','Tears.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76778,'This cannot be! The Vazuvius could never fall to the likes of you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76779,'The Underhold has been breached! Get to the Shredders, and tear these interlopers to pieces!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(76780,'','A hundred crates of meat, furs, and lumber are on their way to Tanaan Jungle, Arnokk.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(76781,'','Remember that the Shadowmoon takes good care of its allies, and brings pain upon its enemies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76782,'Well done. When the Iron Horde takes the draenei temple by sea, your clan shall be honored within our ranks.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(76783,'What of the steel? Coal, oil, and black powder? That is only a fraction of what you promised!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(76784,'','Please forgive us, Commander. We are hard at work delivering on our other promise. The Iron Horde shall receive a gift beyond compare...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(76785,'','A weapon capable of destroying worlds.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(76786,'So where is this weapon?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76787,'','Patience, Commander. We are faithful servants of the Iron Horde. It will be soon, now.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(76788,'Hurry up then! The draenei temple will fall... SOON.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76789,'','Courier! Go to the main lodge and deliver the Iris Crystals to Chieftain Ner\'zhul. We mustn\'t keep our Iron Horde friends waiting.',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(76790,'For generations I protected my people with the mists, and yet with each and every champion I see before me, I realize more and more the error of my ways. May you learn from the lessons of Pandaria, as I have.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76791,'I am so happy to share this moment with my son. Thank you again for all that you have done for us.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76792,'I am so happy to share this moment with my son.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76793,'Magic sky lanterns for sale! Light the candle and watch it float, even without wind!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(76794,'The sound of grinding metal reverberates through the halls as the lock on the Nexus doors releases.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76795,'I have a limitless supply of Kor\'kron at my command you fools! Surrender now and I will give you a quick death.','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(76796,'You must find Thrall and put a stop to Hellscream\'s reign.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76797,'Once we\'ve dealt with the ogres, the Burning Blade, and the orcs at Lok-rath, we\'ll be ready to move on Grommashar.','',0,0,0,0,0,0,0,7,0,0,46252,0,26124),
(76798,'Without the protection of the Celestials you are forcibly ejected from Ordos\' temple!','Without the protection of the Celestials you are forcibly ejected from Ordos\' temple!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76800,'Did you see that? He nearly took my head off!','Did you see that? He nearly took my head off!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(76801,'A Rangari spy? Here, in our village?','A Rangari spy? Here, in our village?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(76802,'Were you sleeping on duty AGAIN?','Were you sleeping on duty AGAIN?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(76803,'Uh... no...','Uh... no...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(76804,'Or fed to our wolves?','Or fed to our wolves?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(76805,'Ahahaha!','Ahahaha!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(76806,'Haha!','Haha!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(76822,'','We show these orcs mercy and how do they repay us?! Just look around!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76823,'','They\'re building weapons, but why?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76824,'','We\'ve won this battle, but the war is far from over, $n.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76825,'','I will make sure the Iris Crystal gets back to the prophet. I sense you still have much to do.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76826,'','The Prophet will be disappointed to hear of our failure.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76827,'','Just look at all of these supplies being amassed!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76828,'','What need would the Iron Horde have for weapons if they did not intend to attack again?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76829,'','We should not have shown them mercy...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76830,'','All we\'ve done is given them time to regroup.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76831,'','We need to hurry. The Iron Horde will mobilize again soon by the looks of it.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76832,'','I\'m itching to bury my mace in some orc skulls!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76833,'','We should have never trusted the Iron Horde!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76834,'','The only good orc is a dead orc...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76835,'','Hellscream will pay for this dishonesty with his life!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76836,'','It\'s about time we try a little hostile negotiations!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76837,'','I will purge you from this land!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76838,'','Your betrayal will not be forgotten, orc!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76839,'','Let this be a message to Grommash!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76840,'','You do not belong in Shadowmoon orc filth!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76841,'','I\'ll handle this one!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76842,'','This is terrible... Grommash Hellscream has ordered a second attack on Karabor. So much for a peaceful resolution.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76843,'','This isn\'t so much a journal as it is an order form...',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76844,'','With the amount of weapons and ammunition they intend to build Karabor will be left in ruins!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76845,'','Let me see that. Here we go! The Iris Crystal has been moved, but it\'s still in the area. We still have time to find it and return it to the Prophet.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76846,'Th-thank you, stranger...','Th-thank you, stranger...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76847,'Get me out of here!','Get me out of here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76848,'','We don\'t have time to waste here, $n.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76849,'Look at that roast, Ufga! I bet our Iron Horde guests have never tasted anything like it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76850,'We need to hurry. The sooner we start blowing stuff up, the sooner we can focus on activating the crystal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76851,'I\'m going to need more than a couple props and a can of Kaja\'Cola to pull this off.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76852,'I\'ll show those smelly orcs a thing or two.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76853,'Why? Why do they attack us?','Why? Why do they attack us?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76854,'I never wanted a fight...','I never wanted a fight...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76855,'I thought I was going to die!','I thought I was going to die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76856,'Thank the naaru, I\'m saved!','Thank the naaru, I\'m saved!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76857,'','Performing the same action multiple times in a row will get you a small bonus. Try seating many customers or delivering their orders in rapid succession to earn extra points!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76858,'Do you like hammers?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76859,'Don\'t take dose hammers!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76860,'Don\'t need deez no more.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76861,'Dem hammers not workin\'.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76862,'Time for udder hammers.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76863,'Deez hammers is stupid.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76864,'Der\'s more where dose came from.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76865,'Tryin\' new hammers.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76866,'I t\'ink one of dose had a splinter.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76867,'I got more hammers den a fixer guy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76868,'Here we are, $n. Time to stomp out these orcs once and for all.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76869,'Bet you didn\'t know I had a fif hammer!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76870,'You got anudder t\'ing comin\'!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76871,'I like to t\'row deez hammers at you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76872,'Time for clang sound!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76873,'Da fif one is my favorite!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76874,'I\'ll try dis diff\'rent one!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76875,'Da more hammers da better!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76876,'Jus\' hold still!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76877,'Rise, old friends. The time has come for the next step of my plan.','',0,0,0,0,0,0,0,0,6,0,45323,0,26124),
(76878,'Teron\'gor, infiltrate the Auchenai and take control of Auchindoun. Bleed them dry.','',0,0,0,0,0,0,0,0,6,0,45324,0,26124),
(76879,'Cho\'gall, we\'ll finish your Frostfire business together.','',0,0,0,0,0,0,0,0,6,0,45325,0,26124),
(76880,'I see beyond your guise, child. Do not be afraid.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(76881,'I\'m sending you to Nagrand to subjugate the naaru in Oshu\'gun.','',0,0,0,0,0,0,0,0,6,0,45326,0,26124),
(76885,'We should send her head to Karabor as a message!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76894,'Use the Vial of Moon Water to compel the All-Seeing Eye.$B$B|TInterface\\Icons\\INV_Potion_20.blp:64|t','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76895,'When the demon is weakened, read from the Scripture of Elune.$B$B|TInterface\\Icons\\INV_Scroll_12.blp:64|t','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76896,'A crawler mine detonated on $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76897,'Foul Stream is being cast on you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76898,'','We should have dealt with the Iron Horde when we had the chance.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(76899,'Send in da reserves! Charge!','Send in da reserves! Charge!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76900,'Warlord Zaela orders a |cFFFF0404|hKor\'kron Demolisher|h|r to assault the tower!','Warlord Zaela orders a |cFFFF0404|hKor\'kron Demolisher|h|r to assault the tower!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76901,'Soldiers! Come to my aid!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76902,'I yield!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76903,'GRAHHH!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76904,'Hellscream!','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(76905,'Your attack on Karabor was cowardly and unwarranted.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(76906,'What\'s more, we thoroughly outclassed your orcs on the battlefield.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(76907,'I would be within my rights to behead you and raze this town...','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(76908,'...but not today.  Today, we show mercy.  Pack up your machines of war and leave this place.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(76909,'Y... yes, sir. We will leave right away. You have my word.','',0,0,0,0,0,0,2,0,1,0,0,0,26124),
(76910,'I\'ll take you down with me, $c!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76911,'Retrieving the Iris Crystal','Retrieving the Iris Crystal',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76912,'Go away!','Go away!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76913,'My moonstone! No follow me!','My moonstone! No follow me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76914,'You smell bad! You no friend at all!','You smell bad! You no friend at all!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76915,'You should get no foods!','You should get no foods!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76916,'RUNAWAY!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76917,'LEAF ME ALONE!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76918,'This moonstone for friends!','This moonstone for friends!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76919,'NOT GOOD!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76920,'NOBODY LIKES YOU! KEEP YOUR DISTANCE $C!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76921,'NOBODY LIKES YOU!','NOBODY LIKES YOU!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76922,'','Brewly keeps drinking Uncle\'s brew.  Hope it makes him strong in the fight!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(76923,'','That dumb cricket keeps me up at night.  Don\'t tell Uncle, but I want you to squash it!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(76924,'','Sometimes Tonsa lets me ride on his back... but he\'s kinda stinky.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(76925,'','I don\'t know why he won\'t listen to me!  I\'m just trying to explain how to make his noodles even better.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76926,'A song?','A song?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76927,'','Yes!  A song about the lore and all the lessons we can learn from it all.  Sounds exciting, doesn\'t it?$b$bBut... we\'re still working on it.  Chadrik seems easily distracted lately.  Is there something on my tabard?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76928,'No orc steps foot in Karabor and gets away with it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76929,'Deploy the gear! Establish a perimeter!','',0,0,0,0,0,0,0,0,0,0,38184,0,26124),
(76930,'Oh, hello friends! We\'ve just about secured the surface, it looks like the real fight\'s going to be down here.','',0,0,0,0,0,0,0,0,0,0,38185,0,26124),
(76931,'Don\'t worry, we\'ve got your back!  Forge ahead, brave heroes!','',0,0,0,0,0,0,0,0,0,0,38186,0,26124),
(76932,'My expertise is needed elsewhere, heroes! When you see Garrosh, tell him he should\'ve invested in gnomish technology!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76933,'','Earth!',0,0,0,0,0,0,0,0,0,0,0,39016,26124),
(76934,'Bend to our will!','Bend to our will!',0,0,0,0,0,0,0,0,0,0,39013,39013,26124),
(76935,'','We do not ask the elements for aid...',0,0,0,0,0,0,0,0,0,0,0,39014,26124),
(76936,'','Tortured wind, stale and toxic!',0,0,0,0,0,0,0,0,0,0,0,39018,26124),
(76937,'','Long-dead fire, black and smouldering!',0,0,0,0,0,0,0,0,0,0,0,39019,26124),
(76938,'The blood of the True Horde lusts for power!','The blood of the True Horde lusts for power!',0,0,0,0,0,0,0,0,0,0,39028,39028,26124),
(76939,'','I can hear them no longer...',0,0,0,0,0,0,0,0,0,0,0,39015,26124),
(76940,'','My wolf will feast on your blood!',0,0,0,0,0,0,0,0,0,0,0,39017,26124),
(76941,'Storm!','',0,0,0,0,0,0,0,0,0,0,39022,0,26124),
(76942,'And fire!','',0,0,0,0,0,0,0,0,0,0,39023,0,26124),
(76943,'The True Horde takes what it wants!','',0,0,0,0,0,0,0,0,0,0,39020,0,26124),
(76944,'Anguished water, stagnant and poisonous!','',0,0,0,0,0,0,0,0,0,0,39025,0,26124),
(76945,'Crumbling earth, plagued with rust!','',0,0,0,0,0,0,0,0,0,0,39026,0,26124),
(76946,'The blood of the True Horde lusts for power!','The blood of the True Horde lusts for power!',0,0,0,0,0,0,0,0,0,0,39027,39027,26124),
(76947,'The elements... what have we done...','',0,0,0,0,0,0,0,0,0,0,39021,0,26124),
(76948,'Your skull will adorn my necklace.','',0,0,0,0,0,0,0,0,0,0,39024,0,26124),
(76949,'Glad you made it. Are we ready to proceed?','Glad you made it. Are we ready to proceed?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76950,'Reporting for duty!','Reporting for duty!',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(76951,'Glad you made it. Are we ready to proceed?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76952,'We should subjugate these Pale orcs and the... (An intruder! Let\'s leave.)','',0,0,0,0,0,0,0,1,0,0,46610,0,26124),
(76953,'Foods!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76954,'More foods! Happy day!','More foods! Happy day!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76955,'Yay foods!','Yay foods!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76956,'I will be chief! You will be lunch.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76957,'We don\'t like you anymore!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76958,'Go tell chief I new boss in these woods!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76959,'With the warlock\'s magic device, you and I will spy upon the Shadow Council.','',0,0,0,0,0,0,0,1,0,0,45008,0,26124),
(76960,'I\'m getting so hungry...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76961,'|TInterface\\Icons\\Ability_Siege_Engineer_Superheated.blp:20|t Shanna is firing her laser at you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76962,'','It sounds like they\'ve conjured demonic eye sentries. Be careful down there.',0,0,0,0,0,0,0,1,0,0,0,44139,26124),
(76963,'No creature should be subjected to what they\'re doing down there.','',0,0,0,0,0,0,0,1,0,0,46809,0,26124),
(76964,'We must end the Shadow Council threat.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(76965,'Get your Noodle Soup here!','Get your Noodle Soup here!',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(76966,'I am ready, Khadgar. Let\'s use the All-Seeing Ring.','I am ready, Khadgar. Let\'s use the All-Seeing Ring.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76967,'Let me know when you\'re ready.','',0,0,0,0,0,0,0,1,0,0,45016,0,26124),
(76968,'','Isn\'t Pierre amazing?  My friend Jard made him for me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76969,'','I want to train him, but I really don\'t want him to get hurt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76970,'','He\'s really nice and he tries to cook things for me. Unfortunately, they aren\'t edible and I have to toss them out when he isn\'t looking.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76971,'Come on orcs! Come and get your justice!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76972,'You fought your way into Karabor, now you\'ll have to fight your way through me!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76973,'Come! Come and fight me! Are you afraid?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76974,'You made a mistake attacking Karabor, orcs. You\'ve awoken a sleeping giant!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76975,'Teron\'gor, we\'ll finish your Shadowmoon business together.','',0,0,0,0,0,0,0,0,6,0,45345,0,26124),
(76976,'I\'m sending you to Talador. Infiltrate the Auchenai. Take control of Auchindoun. Bleed it dry.','',0,0,0,0,0,0,0,0,6,0,45346,0,26124),
(76977,'Yes, commander!','Yes, commander!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76978,'As you wish, commander!','As you wish, commander!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76979,'Cho\'gall, I\'m sending you to Nagrand.','',0,0,0,0,0,0,0,0,6,0,45347,0,26124),
(76980,'For the Iron Horde!','For the Iron Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76981,'R-r-r-rahh!!','R-r-r-rahh!!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76982,'You\'ll subjugate the fallen naaru inside Oshu\'gun.','',0,0,0,0,0,0,0,0,6,0,45348,0,26124),
(76983,'Giselda, you stay here. I have other plans for... what is behind me?','',0,0,0,0,0,0,0,0,6,0,45349,0,26124),
(76984,'Can I has a bite?','Can I has a bite?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76985,'You smell like Foods!','You smell like Foods!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76986,'Yummy!','Yummy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76987,'Nom Noms!','Nom Noms!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76988,'','Now is my chance!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(76989,'You my best friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76990,'I help you find all the friends.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76991,'Hello best friend!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76992,'Let\'s find your friends!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76993,'You smell so good best friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76994,'I will help you best friend!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76995,'Mine! Go away!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76996,'Get your own foods!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76997,'I\'m cheif now! Go tell friends!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76998,'You no friend!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(76999,'You smell bad! Stinky mud!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77000,'Go away! This my forest now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77001,'Stay away from best friend!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77002,'','I\'ve never seen anything quite like this!  I think I\'ll be healing a lot of pets after the tournament is over.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77003,'','Oh, no I\'m sorry but I can\'t!  It\'s against the rules to heal pets during the tournament.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77004,'Sometimes I impress even myself. And down goes the dragon!','',0,0,0,0,0,0,6,0,0,0,38154,0,26124),
(77005,'','And there goes the other one.',0,0,0,0,0,0,0,0,0,0,0,38293,26124),
(77006,'For the True Horde!','For the True Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77007,'Lok\'tar Ogar!','Lok\'tar Ogar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77008,'Blood and Thunder!','Blood and Thunder!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77009,'Garrosh Hellscream','Garrosh Hellscream',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77010,'General Nazgrim','General Nazgrim',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77011,'Helix Blackfuse','Helix Blackfuse',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77013,'By your command.','By your command.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(77014,'Great job taking out those cannons, hero. Are you ready to settle this for good?','Great job taking out those cannons, hero. Are you ready to settle this for good?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77015,'Warchief Hellscream','Warchief Hellscream',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77016,'For Warchief Hellscream!','For Warchief Hellscream!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77017,'Legionnaire Nazgrim','Legionnaire Nazgrim',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77018,'Siegecrafter Blackfuse','Siegecrafter Blackfuse',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77019,'Warlord Zaela','Warlord Zaela',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77020,'My life for the Horde!','My life for the Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77022,'','Come rest for a while in the shade!',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(77023,'','Delicious food and drink at  reasonable prices!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(77024,'','Come rest your weary feet, adventurer!',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(77025,'','Hungry? Thirsty? Tired? Let Graceful Swan take care of you!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77026,'','Arms and armor repaired!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(77027,'','Blades sharpened! Armor mended!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(77028,'','Don\'t be caught unprepared! Let Crafter Kwon see to your gear!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(77029,'','Fine weapons and armor for sale!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(77030,'BUY NOODLES!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(77031,'Best. Noodles! EVER!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(77032,'I got good noodles here!','',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(77033,'Victory or Death!','Victory or Death!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77034,'Monmon study MANY weeks with master noodle chef.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77035,'Die with Honor!','Die with Honor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77036,'Please come enjoy my fine Golden Dragon Noodles.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(77037,'You will find only the best noodles in all Pandaria here.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77038,'I would be honored by your patronage, adventurer.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(77039,'Golden Dragon Noodles! The very BEST!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(77040,'Look here! He left his weapon behind.','',0,0,0,0,0,0,0,0,0,0,38158,0,26124),
(77041,'This means he\'s completely unhinged.','',0,0,0,0,0,0,0,0,0,0,38159,0,26124),
(77042,'Likewise. Sylvanas and I have both sent ships to support Vol\'jin\'s revolution.','',0,0,0,0,0,0,0,0,0,0,38160,0,26124),
(77043,'It is always a pleasure to see you, Lady Proudmoore.','',0,0,0,0,0,0,0,0,0,0,38161,0,26124),
(77044,'Champions, come with me. It\'s time to settle grievances with our... \"Warchief.\"','',0,0,0,0,0,0,0,0,0,0,38162,0,26124),
(77045,'','So Hellscream\'s arrogance unleashed the last of the sha. I am not surprised.',0,0,0,0,0,0,0,0,0,0,0,38090,26124),
(77046,'','Gorehowl.',0,0,0,0,0,0,0,0,0,0,0,38091,26124),
(77047,'','News to no one, Regent Lord. King Wrynn\'s fleet is converging on Orgrimmar as we speak.',0,0,0,0,0,0,0,0,0,0,0,38092,26124),
(77048,'','I\'m warning you, Lor\'themar. The Alliance is besieging the city and we will destroy Hellscream. Your people had best stay out of our way.',0,0,0,0,0,0,0,0,0,0,0,38093,26124),
(77049,'','Come heroes, through the portal! The siege of Orgrimmar begins!',0,0,0,0,0,0,0,0,0,0,0,38094,26124),
(77050,'%s\'s projection explodes!','%s\'s projection explodes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77051,'FEAST LIKE A CHIEFTAIN! Yaungolian noodles!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(77052,'Why settle for weak, flavorless noodles? Try them yaungolian style!','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(77053,'HOT AND HEARTY! Come try Yaungolian noodles!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(77054,'Bold flavor, bold heat! No other noodles come close!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77055,'Exotic, aromatic, a brew good for both body and spirit!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77056,'Shimmering amber-brew! Come and try!','',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(77057,'Exquisite amber-brew from beyond the Serpent\'s Spine!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(77058,'Brave the brew that\'s truly unique! Invigorating, satisfying... amber-brew!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(77059,'Sap is where it\'s at.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(77060,'Steaming goat noodle: NUMBER ONE!','',0,0,0,0,0,0,51,0,0,0,0,0,26124),
(77061,'Come fill belly with noodle, yes! Very good!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77062,'STEAMING GOAT NOODLE! The best!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(77063,'Noodle so tasty! You come try, yes?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77064,'Gul\'dan is with them!','',0,0,0,0,0,0,0,1,0,0,45017,0,26124),
(77065,'Greetings, I am Shaohao. Are you hear to hear the wisdom of the Celestials?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77066,'','Tell me when you are ready, $n. And get ready to fight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77067,'Let\'s get out of here!','Let\'s get out of here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77068,'','For the finest food, look no further!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(77069,'','Come, sit down, enjoy a meal!',0,0,0,0,0,0,70,0,0,0,0,0,26124),
(77070,'[PLACEHOLDER] AWESOME HOLY VISUALS OF VELEN BREAKING FREE OF CHAINS!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77071,'','There is no dish I have not mastered! Come and eat!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(77072,'Now\'s our chance. Let\'s go!','Now\'s our chance. Let\'s go!',0,0,0,0,0,0,0,0,0,0,45647,45647,26124),
(77073,'','Delicious dishes and fresh-made island delicacies!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(77074,'Magic sky lanterns for sale!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(77075,'Light the candle and watch one float, even without wind!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77076,'Do you wish to see the island from the sky? Glide upon a golden kite!','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(77077,'The perfect mix of northern and southern styles!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(77078,'GRUB N\' GROG!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(77079,'Ye won\'t find anythin\' like it elsewhere. Come and try!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77080,'Dare ta drink a Dragon P.I.E.! It\'ll put hair on yer chest, and then hair on THAT!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(77081,'I will eat your face off!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77082,'Lucky-Lucky! Come have some noodles!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(77083,'Yoo-hoo! Come try some Lucky Mushroom Noodles?','',0,0,0,0,0,0,24,0,0,0,0,0,26124),
(77084,'So tasty! So delicious! Double Lucky special noodles!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(77085,'Hey hey! Come here, have some tasty noodles!','',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(77086,'That cave is inside the Gloomspire. Those are the ruins of Ata\'gar to the west.','',0,0,0,0,0,0,0,1,0,0,46811,0,26124),
(77087,'Remind me about the time we used the All-Seeing Ring to spy on Gul\'dan and the Shadow Council.','Remind me about the time we used the All-Seeing Ring to spy on Gul\'dan and the Shadow Council.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77088,'River style noodles, made with only the freshest fish.','',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(77089,'Please try my Harmonious River Noodles. They will not disappoint.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(77090,'Fresh fish, caught within the hour! ...I think? Curse this island.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77091,'Harmonious River Noodles!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(77092,'It\'s Stormstout time!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(77093,'When you say Stormstout, you\'ve said it all.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77094,'Stormstout: The emperor of brews!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(77095,'Stormstout: Delicious and light!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(77096,'Stormstout: It\'s all about the brew.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77097,'If you\'ve got the time, we\'ve got the brew. Stormstout!','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(77098,'Stormstout. Pandaren for \"beer.\"','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(77099,'Stormstout. Probably the best brew in Azeroth.','',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(77100,'Greenstone Brew! Straight from the heart of the Jade Forest.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77101,'Taste the jade! Greenstone Brew!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(77102,'Nothing beats the bold bite of Greenstone Brew!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(77103,'You there! Come and try some Greenstone Brew!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(77104,'Send word to the rest of the pack: The sons of the Iron Wolf have been found. Lok\'tar ogar!','',0,0,0,0,0,0,0,0,7,0,44101,0,26124),
(77105,'My... father... will... avenge... me.','',0,0,0,0,0,0,0,0,7,0,41923,0,26124),
(77106,'<You find a journal laying in a pool of blood.$b$bYou attempt to read it, unfortunately the blood has fused the pages together.>','',0,0,0,0,0,0,0,0,2,0,0,0,26124),
(77107,'Your father will mourn, as I have mourned.','',0,0,0,0,0,0,0,0,7,0,44100,0,26124),
(77108,'We are honored that you are here to help us, $n. Together, we\'ll destroy the foul things that are plaguing our land.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(77109,'You\'ll find the Sleeper\'s lair to the southwest across the dunes.','',0,0,0,0,0,0,0,1,0,0,46812,0,26124),
(77111,'I can make this into a cool hat!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77112,'I\'ll meet you there.','',0,0,0,0,0,0,0,1,0,0,45009,0,26124),
(77113,'You\'re Screwed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77114,'You\'re about to take a turn for the worse!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77115,'This is going to hurt a bit!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77116,'','Every Shadow Council member we kill now is one less headache later.',0,0,0,0,0,0,0,1,0,0,0,44138,26124),
(77117,'The people of Pandaria came here millennia ago to watch aspiring emperors face the challenges of the August Celestials.\n\nSo! Are you here to watch would-be heroes brave the Celestials\' tests?\n\nOr to brave them yourself?','',1,6,0,0,4,0,0,0,0,0,0,0,26124),
(77118,'RATTLESKEW!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77119,'DESTROY!','',71,0,0,0,0,0,0,0,0,0,46272,0,26124),
(77120,'I... remember... you...','',0,0,0,0,0,0,0,0,0,0,45317,0,26124),
(77121,'','Ishnu-alah, commander.',273,0,0,0,0,0,0,0,0,0,0,0,26124),
(77122,'Place offering','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77123,'The three crystals are strategically located about the ruins. Destroy them with the Heart of Fernus.','',0,0,0,0,0,0,0,1,0,0,45007,0,26124),
(77124,'Khadgar, did I leave the Heart of Fernus here?','Khadgar, did I leave the Heart of Fernus here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77125,'','I\'m more beautiful than ever.',0,0,0,0,0,0,0,0,0,0,0,46452,26124),
(77126,'WHAT?! I remember you.','',0,0,0,0,0,0,0,0,0,0,45342,0,26124),
(77127,'I won\'t lower myself to fight you, but, I have an idea.','',0,0,0,0,0,0,0,0,0,0,45343,0,26124),
(77128,'Would you like to leave this nightmare?','',0,0,0,0,0,0,0,0,1,0,38071,0,26124),
(77129,'Take me back.','Take me back.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77130,'Giselda, my beauty, your time has come.','',0,0,0,0,0,0,0,0,0,0,45344,0,26124),
(77132,'','What? No...',0,0,0,0,0,0,0,0,0,0,0,46451,26124),
(77134,'Half-breed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77135,'I will not sit here waiting for Ligra and Korga while Gorr\'thog still breathes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77136,'','Throm-Ka, $C. We got cut off from Ga\'nar during the initial attack.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77137,'Lok\'tar. Gorr\'thog\'s chamber is just ahead.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(77138,'','Uncle brought a keg to drink if he wins, and two to drink if he loses.  So in the end, I guess he still won!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(77139,'Much yet remains to be done, friend. I will hold this point until the keep is more secure. We cannot let Gorr\'thog escape.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(77140,'','The Iron Horde approaches. No sudden movements.',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(77141,'I\'ve fought my way to the ramp leading to Gorr\'thog\'s throne. It is time to strike!','',0,0,0,0,0,0,0,0,0,22878,0,0,26124),
(77142,'<Niuzao nods approvingly at you.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77143,'What you have achieved today will shape the face of Pandaria for thousands of years to come.$b$bThank you, hero. The Lorewalkers shall pass your story down from generation to generation.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77144,'A soft hum ceases as the corruption creating new Puddles ebbs away with the death of the final Aqueous Defender.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77145,'Now I will eat you!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77146,'No! You supposed to be foods...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77147,'Sabotaging','Sabotaging',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77148,'','Throm-Ka, Commander Vorka. The Shadowmoon clan is honored by your presence.',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(77149,'Shaman, women... <spits>. I have no time for seers and mystics.','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(77150,'Where are your true warriors? Or, is what they say about the Shadowmoon true?','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(77151,'That you\'re a mass of cravens hiding behind your magic?','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(77152,'Iron Sentinels! To me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77153,'Step aside, brothers. We must speak with Hellscream.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77154,'No one may enter the city. Not even you, Shaman.','No one may enter the city. Not even you, Shaman.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77155,'Thrall? Varok? What business do you have here?','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77156,'Strength and Honor, General. We come to speak with Garrosh. There may yet be hope for peace.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77157,'But...','But...',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77158,'Kor\'kron! You are needed at the front!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77159,'NOW!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77160,'You know I can make no guarantee of your safety... or Garrosh\'s response.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77161,'Lok\'tar Ogar, brothers.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77162,'Who\'s next?','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(77163,'','Cravens? I\'ll show you craven!',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(77164,'Hold. I would not spill your blood today, Hara.','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(77165,'You Shadowmoon are proud and still have the warriors\' spirit!','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(77166,'','<Narrows her eyes, but relaxes.>',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(77167,'','Very well, Vorka, son of Vorash. The Shadowmoon clan will join this Iron Horde.',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(77168,'','Lok-Regar. What orders?',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(77169,'Gather your clan. Soon the Iron Horde will crush Karabor once and for all!','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(77170,'','Zug-zug.',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(77171,'I\'m so hungry.$b$bChief kicks me out of village. Says that I\'m foods? I will be new chief. When I have all the foods, foreling friends all love me. When friends love me, they give me more foods! I need lots of friends.$b$bYou my best friend, $c.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77172,'Careful friend, these woods can be dangerous.','',0,0,0,0,0,0,0,35,0,0,0,0,26124),
(77173,'Beware the podlings, $c. They are not what they seem.','',0,0,0,0,0,0,0,35,0,0,0,0,26124),
(77174,'The Podlings will say they are your friends. They are not.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(77175,'If we are not vigilant, the podlings\' hunger will consume us all.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(77176,'I would be careful in this forest, $c.','',0,0,0,0,0,0,0,35,0,0,0,0,26124),
(77177,'Yeehaw!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77178,'What am I thinking?! I haven\'t trained on this piece of equipment! AAAAH!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77179,'HOT! HOT! HOT!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77180,'Alert. You are combusting. Please execute safety procedures.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77181,'Alright boys, lets go nuts.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77182,'Annihilator activated!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77183,'We\'re going to need a mop over here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77184,'Wow! Now that is an incredible piece of shiny!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77185,'Let\'s see what sort of toys the Kor\'kron have been building.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77186,'Time to clean up! Activate the Annihilator!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77187,'Woof!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77188,'','These ogres have a painful lesson to learn.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77189,'','Never leave a Frostwolf alive.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77190,'','Thank you for freeing me. You fight with the skill of a Frostwolf.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77192,'','Our paths diverge here. Good luck, champion.',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(77193,'Hatock, son of the Iron Wolf! I come for your head.','',0,0,0,0,0,0,22,0,5,0,0,0,26124),
(77194,'Well look here boys, the mongrel son of Garad has returned from the grave.','',0,0,0,0,0,0,22,0,5,0,41890,0,26124),
(77195,'Hrah hrah hrah! You should have stayed dead, Ga\'nar. You would have lived longer.','',0,0,0,0,0,0,22,0,5,0,41891,0,26124),
(77196,'Had Garrad just joined the Iron Horde like he was told you would still have your precious daddy to save you today.','',0,0,0,0,0,0,22,0,5,0,0,0,26124),
(77197,'Chose your last words carefully Hatock. There is no Thunderlord that can stand against me.','',0,0,0,0,0,0,1,0,5,0,0,0,26124),
(77198,'Yes, your wolves are very formidable in battle when in the open. But let us see how you do in the shadow of a gronn.','',0,0,0,0,0,0,22,0,5,0,41892,0,26124),
(77199,'Thunderlord...  RELEASE THE BEAST!','',0,0,0,0,0,0,22,0,5,0,41893,0,26124),
(77200,'Keep a grip on those chains.','',0,0,0,0,0,0,22,0,5,0,0,0,26124),
(77201,'His arm is loosening! Tighten that slack before he puts you all against a wall.','',0,0,0,0,0,0,22,0,5,0,0,0,26124),
(77202,'Put your backs into it!','',0,0,0,0,0,0,22,0,5,0,0,0,26124),
(77203,'We have a schedule to keep.','',0,0,0,0,0,0,22,0,5,0,0,0,26124),
(77204,'Follow me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77205,'Let me know when you are ready to move forward with our attack.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77206,'The Frostwolves will sing songs of this day.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77207,'I\'m ready to begin.','I\'m ready to begin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77208,'Speak to me when you are ready.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77209,'Let\'s go.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77210,'You feel the blessing of the Celestials as your cloak billows with jade mist.','You feel the blessing of the Celestials as your cloak billows with jade mist.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77211,'Your attacks on my clan end here, ogre.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77212,'I have an empire at my back. What do you have, little orcs?','',11,0,0,0,0,0,0,0,0,0,0,0,26124),
(77213,'The strength of the Frostwolves. Lok\'tar ogar!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77214,'Enough! Enough!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77215,'Hatock, son of the Iron Wolf! I come for your head.','',0,0,0,0,0,0,1,0,5,0,44104,0,26124),
(77216,'Let me live, and we won\'t attack your people again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77217,'Like you let my clan\'s women and children live in your raids?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77218,'Some empire.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77220,'','The others, are they okay?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77225,'','We were... also separated.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(77226,'','You ready to race?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77227,'Yes!','Yes!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77228,'','Ready... set... go!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77229,'Why you here? What\'s this?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77230,'I do not know. But the orc who dragged us here is feasting nearby. We get him first.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77231,'','Come. Let\'s find your frost wolf.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77232,'What is wrong Ga\'nar? Afraid of a bit of Gronn?','',0,0,0,0,0,0,22,0,5,0,41894,0,26124),
(77233,'I thought you Frostwolves were supposed to be skilled?','',0,0,0,0,0,0,22,0,5,0,41895,0,26124),
(77234,'Not so easy to fight a Thunderlord, is it?','',0,0,0,0,0,0,22,0,5,0,41896,0,26124),
(77236,'You mongrels are no match for my blade!','',0,0,0,0,0,0,22,0,7,0,41897,0,26124),
(77237,'If you had just joined the Iron Horde I wouldn\'t have to kill you now.','',0,0,0,0,0,0,22,0,5,0,41898,0,26124),
(77238,'','Yes, that\'s it! The perfect disguise!',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(77239,'','Now that\'s what I call a hat!',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(77240,'Hatock! You cannot hide from me!','',0,0,0,0,0,0,22,0,5,0,44106,0,26124),
(77241,'','Not bad, if you want to look like an orc with no fashion sense.',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(77242,'','The embroidery on that shirt is just lovely if I say so myself.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77243,'','The perfect accessory for pillaging, don\'t you think?',0,0,0,0,0,0,547,0,0,0,0,0,26124),
(77244,'','I can feel the fireballs already!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(77245,'','Wow! You look just like an orc with that mask.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77246,'','Oooh yes, underwater is all the rage this season!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77247,'You are tiny, useless insects!','',0,0,0,0,0,0,0,0,0,0,41882,0,26124),
(77248,'Look chief! I bring all these goodies for you! And we can eat this guy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77249,'','Looking sharp!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(77250,'I fight for the empire!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77251,'','Wowza! You look great, but that dress might be a bit... impractical.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77252,'','Nice color, but the cut is too rustic if you ask me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77253,'','Very stylish, but it\'s just not ORC enough.',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(77254,'','That skirt is soooo last year.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77255,'','No no no, totally the wrong shade of red! I asked for crimson, not scarlet.',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(77256,'Nobody is as strong as I am!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77257,'','That kilt goes well with your eyes.',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(77258,'','It fits you well, but it just doesn\'t scream \"$n.\"',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77259,'You... will... regret this...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77260,'','We need to find the perfect outfit, so mix and match all three clothing options until we get the right Shadowmoon orc disguise!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77261,'Ha ha hah hahh! We have you surrounded, whelp!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77262,'Throm-Ka, $C. Thrall has spoken highly of you.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(77263,'The Bladespire ogres have plagued my people for too long. It is time to take action.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(77264,'It is time to address this problem at its source.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(77265,'Come, brother. You are free now.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77266,'%s sniffs Lokra and whines.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77267,'He must pay!!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77268,'','You smell Asha, don\'t you? I... am so sorry, Nerok. I failed to protect her.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77269,'So many brothers and sisters lost...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77270,'','Oh, they will. Trust me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77271,'Unite the orc clans under a single banner! Join the Iron Horde today!','Unite the orc clans under a single banner! Join the Iron Horde today!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77272,'Grommash Hellscream: legendary warrior, fearsome enemy. He will lead us to a better tomorrow!','Grommash Hellscream: legendary warrior, fearsome enemy. He will lead us to a better tomorrow!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77273,'The might of the Iron Horde is unquestionable. Join today!','The might of the Iron Horde is unquestionable. Join today!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77274,'Join the Iron Horde, or die beneath draenei rule!','Join the Iron Horde, or die beneath draenei rule!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77275,'Are you orc enough for the challenge? Join Hellscream\'s forces today.','Are you orc enough for the challenge? Join Hellscream\'s forces today.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77276,'Do not trust the draenei. They want you to fail!','Do not trust the draenei. They want you to fail!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77277,'Trust only your own kind. Trust in the might of the Iron Horde!','Trust only your own kind. Trust in the might of the Iron Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77278,'Be a proud orc! Help the Iron Horde!','Be a proud orc! Help the Iron Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77279,'[PH] Stay tuned for a super epic fight scene between me and my brother, yo!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77280,'','Glad to see you made it through, $n!$B$BWelcome to Frostfire Ridge!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77281,'I\'m ready to fly to Bladespire Citadel.','I\'m ready to fly to Bladespire Citadel.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77282,'This metal is not like any you have worked with. It will fight back. Your will must be stronger!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77283,'Strike hard, and with purpose. As if you were crushing the skull of a hated foe!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77284,'Pay attention! This part is important.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77285,'See here? This is the reaction you are looking for.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77286,'Make every swing count! You aren\'t slamming out spearheads anymore.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77287,'FPOW!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77288,'Those sparks are weakness leaving the metal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77289,'I am glad you have accompanied me on this journey, friend.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(77290,'Come on you louts, put some muscle into it!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(77291,'I want to hear that metal sing!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(77292,'You want weapons like the Blackrock, you need to WORK like the Blackrock!','',0,0,0,0,0,0,23,0,0,0,0,0,26124),
(77293,'Keep up the momentum!','',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(77294,'Every swing brings us closer to crushing our foes!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(77295,'Good. Those are good strikes.','',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(77296,'Do not let the material rest!','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(77297,'Use Naaru\'s Momentum to damage enemies, or to quickly escape danger.$B$B|TInterface\\Icons\\Spell_Holy_Heroism.blp:64|t','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77298,'The darkness will overcome you! ATTACK!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77299,'The dark star... brightens...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77300,'Heh heh heh... you runts gonna die in here...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77301,'The flames will catch you, soon enough...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77302,'The Iron tide will wash over you, friend of the draenei...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77303,'The Iron Horde... comes...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77304,'AHHHHH!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77305,'IT BURNS!!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77306,'Run, brothers! Run away!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77307,'We don\'t stand a chance against them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77308,'Back to the tower!','Back to the tower!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77309,'To the tower!','To the tower!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77310,'Fall back!','Fall back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77311,'Retreat!','Retreat!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77312,'Retreat!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77313,'Run for your lives! They\'re in our walls!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77314,'Ga\'nar! We are with you! Lok\'tar ogar!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77315,'','You saved some for us? How thoughtful!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77318,'Come, $n. Let us discuss how to best help Durotan and his clan.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77319,'<It looks like this shield belonged to the missing search party.$b$bUpon further inspection, you find what appears to be hundreds of little puncture marks covering the blood-stained armor.>','',0,0,0,0,0,0,0,0,2,0,0,0,26124),
(77320,'<You find thousands of tiny puncture marks covering the dead mule\'s body.>','',0,0,0,0,0,0,0,0,2,0,0,0,26124),
(77321,'The draenei are coming! Fall back!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77322,'Get back to the ships!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77323,'Back to the boats!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77324,'Run for your lives!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77325,'|TInterface\\Icons\\spell_holy_powerinfusion.blp:32|t\nK\'ara has blessed you. You can now track the remaining orcs on your minimap.','|TInterface\\Icons\\spell_holy_powerinfusion.blp:32|t\nK\'ara has blessed you. You can now track the remaining orcs on your minimap.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77327,'Frostwolves! Fan out and harry the Thunderlord. For vengeance!','',0,0,0,0,0,0,53,0,5,0,44103,0,26124),
(77334,'Destroy them! Destroy them in the name of the Shadowmoon clan!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77335,'Ahahahaaa... your defiance only fuels us, draenei.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77336,'Will mercy, truth, and goodness save you now?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77337,'Your ideals make you weak, draenei. Survival is the only truth in this world.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77338,'Enough of this! I will deal with you myself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77339,'','I will gather my strength and we will meet you upstairs after you have found the others.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77340,'You friends was here, now they gone.','',0,0,0,0,0,0,0,0,2,0,0,0,26124),
(77341,'The clues you seek, is by the pond.','',0,0,0,0,0,0,0,0,2,0,0,0,26124),
(77342,'You found the armor, no friend in reach.','',0,0,0,0,0,0,0,0,2,0,0,0,26124),
(77343,'You find more answers in the field.','',0,0,0,0,0,0,0,0,2,0,0,0,26124),
(77344,'Their mounts is dead, they must be saved.','',0,0,0,0,0,0,0,0,2,0,0,0,26124),
(77345,'Your final clue, is in the cave.','',0,0,0,0,0,0,0,0,2,0,0,0,26124),
(77346,'','Show Krag no mercy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77347,'I have nothing to say to you, $r.','I have nothing to say to you, $r.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(77348,'I have nothing to say to you, $r. Your people have a lot to answer for. But maybe this is a new beginning.','',1,6,0,0,0,0,0,0,0,0,0,0,26124),
(77349,'Thank you, hero. You and your companions were the tip of the Alliance spear: Your work exploring Pandaria, securing the Vale, and ultimately assaulting Garrosh\'s stronghold is what made this victory possible.$b$bOur triumph here will put a stop to the fighting in Kalimdor, but even in peace, there\'s much to be done - here, back home, and elsewhere.','',1,274,0,0,0,0,0,0,0,0,0,0,26124),
(77350,'What\'s next for the Alliance?','What\'s next for the Alliance?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77351,'Why not keep fighting?','Why not keep fighting?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77352,'We are unified like never before. We\'ve bought our people security in Kalimdor, an end to the blockade, and an end to the total war that\'s spilt so much blood on either side of the great sea.$b$bNow, to the work of winning the peace. I would like to station a garrison near Theramore. We need to investigate cleansing the plague from Gilnean lands so they can rebuild. We must contain Sylvanas.$b$bFrom here on forward, the Alliance will be proactive. Never again can there be another the likes of Hellscream.','',1,25,0,0,0,0,0,0,0,0,0,0,26124),
(77353,'I understand your desire to inflict more suffering on the Horde. But when do we stop? How many more Alliance will number among the dead if we invaded Thunder Bluff, Azshara, and the Echo Isles? And how would we govern the conquered people?$b$bThe Pandaren always question why we fight. Today, we\'ve won justice, and have given the Horde an opportunity to atone by supporting their rebellion. Further bloodshed would be for vengeance alone - and it would reap vengeance in return.','',1,274,0,0,0,0,0,0,0,0,0,0,26124),
(77354,'','King Wrynn will rue the day he allowed the Horde to name another Warchief.$b$bWe should\'ve kept fighting. Who\'s to say this new Warchief won\'t get any ideas in his troll head a few years from now?',1,274,0,0,0,0,0,0,0,0,0,0,26124),
(77355,'I think my father did the right thing. If we tried to occupy Orgrimmar, the fighting would never stop. And what about the rest of the Horde? Would we resort to internment camps? We\'ve been down that road before - it doesn\'t work!$b$bWe deposed of a warmonger and replaced him with a leader we can work with. It\'s our only chance for peace in the future.','',1,5,0,0,0,0,0,0,0,0,0,0,26124),
(77356,'Victory for the Alliance! Before we clear out of here, my people will grab as much of this crazy goblin technology as we can get our hands on.','',1,5,0,0,0,0,0,0,0,0,0,0,26124),
(77357,'','There\'s nothing like a common enemy to bring people together. The dwarven clans have never been so united. If the peace holds, our three kingdoms will be stronger than ever before...',1,5,0,0,0,0,0,0,0,0,0,0,26124),
(77358,'','Varian and I spoke at length about the price of peace before his decision here today. I am willing to allow the Horde the use of Azshara\'s lumber if they abandon Ashenvale for good. Knowing the way that goblins chew through resources, we will see how long that will sustain them.$b$bI support this peace, but I do not share the High King\'s confidence. If the Horde breaks treaty to engage us again... my people will be ready.',1,274,0,0,0,0,0,0,0,0,0,0,26124),
(77359,'A major victory, to be sure. We turn our attention now to our Gilnean homeland - ravaged by disease. Wrynn has pledged his help rebuilding my kingdom, but it is difficult to know where to begin.','',1,274,0,0,0,0,0,0,0,0,0,0,26124),
(77360,'Peace is all that is worth fighting for.','',273,0,0,0,0,0,0,0,0,0,0,0,26124),
(77361,'Stand tall, $c. Today ya saved de soul of de Horde.','',273,0,0,0,0,0,0,0,0,0,0,0,26124),
(77362,'I thought Garrosh was ready. I thought the mantle of Warchief would give him perspective. Of the many problems facing our people, he saw only one solution - his vision of the Horde brought us to the brink.$b$bIt is time for a new direction. Vol\'jin will take us there. In many ways he did not want this responsibility... but I think that will make him a better leader.','',1,274,0,0,0,0,0,0,0,0,0,0,26124),
(77363,'I find politics exhausting. I am confident Vol\'jin will take us where we need to go.$b$b<Lor\'themar glances over to Sylvanas.>$b$bAssuming he can hold this Horde together.','',274,1,0,0,0,0,0,0,0,0,0,0,26124),
(77364,'We are all in this together, $c.','',273,0,0,0,0,0,0,0,0,0,0,0,26124),
(77365,'','\"Warchief Vol\'jin.\" Does it sound absurd to you, $c? I, for one, certainly won\'t be taking orders from a troll.$b$b\nBut, he put this little coalition together, and won the day. He\'s also proven to be impossible to kill - I admire that.$b$b\nTime to test what he\'s made of...',274,1,0,0,0,0,0,0,0,0,0,0,26124),
(77366,'Vol\'jin\'s one tough nut. Stabbed in the neck, still he comes back to collect what\'s due. I like this guy!$b$bMy people need security and profit. Under Hellscream, we got a whole lot of neither.','',273,0,0,0,0,0,0,0,0,0,0,0,26124),
(77367,'He will regret crossing me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77368,'Gorr\'thog! I, Ga\'nar, son of Garad, come for your head! Lok\'tar ogar!','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(77369,'|TInterface\\Icons\\inv_misc_bomb_05:20|tYou have |cFFFF0000|Hspell:145996|h[Set to Blow]|h|r! Use |cFFFF0000|Hspell:146364|h[Throw Bomb]|h|r to throw them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77370,'Follow me. Maybe my brother Durotan will be brave enough to join us against Gorr\'thog.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77371,'Dat\'s de end of Hellscream.$b$b<Vol\'jin eyes you warily.>$b$bWhat next, $r?','',274,0,0,0,0,0,0,0,0,0,0,0,26124),
(77374,'Food!','Food!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77375,'Honored brothers and sisters! Today we achieved what Durotan would not even dare to try.','',0,0,0,0,0,0,0,0,5,0,44107,0,26124),
(77376,'Make no mistake. We are at war. And we need a Warchief!','',0,0,0,0,0,0,0,0,5,0,44108,0,26124),
(77377,'Those of you bold enough to stand with me - come! We will show the world the might of the Frostwolves!','',0,0,0,0,0,0,0,0,5,0,44109,0,26124),
(77378,'We... are... FROSTWOLVES!','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(77379,'Stay with us!','Stay with us!',0,0,0,0,0,0,0,0,0,22997,0,0,26124),
(77381,'Don\'t let it get away!','Don\'t let it get away!',0,0,0,0,0,0,0,0,0,22997,0,0,26124),
(77383,'You cannot defeat us all, weaklings.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77384,'Run $c, it\'s a trap!','Run $c, it\'s a trap!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77385,'You be lookin\' lost, mon.','You be lookin\' lost, mon.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(77386,'Look for de orc Varzok up on de city\'s central mesa, just east of de Flight Master. Ya can\'t miss him mon.','Look for de orc Varzok up on de city\'s central mesa, just east of de Flight Master. Ya can\'t miss him mon.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77387,'Three ethereal technomancers have set up shop in Orgrimmar, over in de Drag.\n\nLook for de weird machinery and purple lights... ya can\'t miss it.\n\nDey might be havin\' what cha lookin\' for.','Three ethereal technomancers have set up shop in Orgrimmar, over in de Drag.\n\nLook for de weird machinery and purple lights... ya can\'t miss it.\n\nDey might be havin\' what cha lookin\' for.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77388,'It\'s in de Valley o\' Strength, east of Grommash Hold.','It\'s in de Valley o\' Strength, east of Grommash Hold.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77389,'De goblins set up shop in de Valley of Honor, across the bridge.','De goblins set up shop in de Valley of Honor, across the bridge.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77390,'De Valley of Strength\'s bank is south Grommash Hold, northwest of de main gate.','De Valley of Strength\'s bank is south Grommash Hold, northwest of de main gate.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77391,'De Valley of Honor\'s bank is just before de gate to de Drag.','De Valley of Honor\'s bank is just before de gate to de Drag.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77392,'De barber? Her shop be in de cliffs above the Valley of Strength.','De barber? Her shop be in de cliffs above the Valley of Strength.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77393,'Battlemasters be at de Hall of the Brave in de Valley of Honor.','Battlemasters be at de Hall of the Brave in de Valley of Honor.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77394,'What trainer you be lookin\' for?','What trainer you be lookin\' for?',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77395,'Sunwalker Atohmo be in de Valley of Wisdom.  He\'ll be able to help.','Sunwalker Atohmo be in de Valley of Wisdom.  He\'ll be able to help.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(77396,'Ji be near de Pandaren Pavilion in de Valley of Honor.','Ji be near de Pandaren Pavilion in de Valley of Honor.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77397,'Doras be at de top of de Sky Tower in de Valley of Strength.','Doras be at de top of de Sky Tower in de Valley of Strength.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77398,'','This is the Arbitum.',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(77399,'','The Prophet foresaw a time in our future when our people would come into grave danger.',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(77400,'','This shrine holds the power to save us from destruction.',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(77401,'','I pray that the day of judgment shall never come. Power like this can only come at great cost.',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(77402,'','Activation of The Arbitum requires an incredible amount of energy - energy of a kind that can\'t be found on this world.',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(77403,'','Luckily, Iris Crystals do not originate from Draenor. We think three should be enough to supply the energy we need.',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(77404,'','Five Iris Crystals have fallen from the skies around Shadowmoon Valley.',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(77405,'','Unfortunately, it looks like the Shadowmoon are collecting them as well. We cannot allow them to succeed.',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(77406,'','This is the Prophet\'s vision of what will come to pass.',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(77407,'','Do you know the workings of our magic, traveler?',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(77408,'','See this hammer? In my hands, it strikes with magical force against enemies. But used by an inexperienced trainee, it is no more than a blunt rock.',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(77409,'','The Arbitum is only as powerful as the one who uses it.',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(77410,'','In the right hands, it restores hope for this world. In the wrong ones, it is a weapon of absolute destruction.',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(77411,'You be lookin\' for Urtrun Clanbringer?  He be around de west side of de Valley of Strength.','You be lookin\' for Urtrun Clanbringer?  He be around de west side of de Valley of Strength.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77412,'De Horde Embassy be in de Valley of Strength.','De Horde Embassy be in de Valley of Strength.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77413,'Second building on de right in de Valley of Strength as you enter de city be de inn mon.  Gryshka be running da place.','Second building on de right in de Valley of Strength as you enter de city be de inn mon.  Gryshka be running da place.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77414,'Look for Innkeeper Grishka in de Valley of Strength.  Her inn be on de east side, north of de city\'s gates.','Look for Innkeeper Grishka in de Valley of Strength.  Her inn be on de east side, north of de city\'s gates.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77415,'De Wyvern\'s Tail, just outside the Hall of the Brave, be a great spot to rest!','De Wyvern\'s Tail, just outside the Hall of the Brave, be a great spot to rest!',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77416,'De Hall of Legends be high up on de west side of de Valley of Strength.','De Hall of Legends be high up on de west side of de Valley of Strength.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77417,'De shaman of de Earthen Ring set up portals to all over de world up on the cliffs north of de zeppelin towers.\n\nIf ya be lookin\' to go to Tol Barad der be a portal there too.','De shaman of de Earthen Ring set up portals to all over de world up on the cliffs north of de zeppelin towers.\n\nIf ya be lookin\' to go to Tol Barad der be a portal there too.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77418,'Let me mark de location on your map.','Let me mark de location on your map.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(77419,'You be lookin\' to hone de art of Alchemy?  Den you better be off to Yelmak\'s.  He be holed up in his shop, Alchemy and Potions in de middle of de Drag.','You be lookin\' to hone de art of Alchemy?  Den you better be off to Yelmak\'s.  He be holed up in his shop, Alchemy and Potions in de middle of de Drag.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77420,'Yelmak be an expert at Alchemy.  His shop be in de middle of de Drag.','Yelmak be an expert at Alchemy.  His shop be in de middle of de Drag.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77421,'Der be a blood elf in Grommash Hold, his name be Belloc, who be interested in old relics.  Talk to him if you be needin\' training.','Der be a blood elf in Grommash Hold, his name be Belloc, who be interested in old relics.  Talk to him if you be needin\' training.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77422,'Saru Steelfury be at de Burning Anvil in de Valley of Honor.  He loves teachin\' de art of blacksmithing.','Saru Steelfury be at de Burning Anvil in de Valley of Honor.  He loves teachin\' de art of blacksmithing.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77423,'In de Valley of Honor there be an orc who is a master craftsman, Saru Steelfury.  He be at de far end of de Valley of Honor down de path past Red Canyon Mining.','In de Valley of Honor there be an orc who is a master craftsman, Saru Steelfury.  He be at de far end of de Valley of Honor down de path past Red Canyon Mining.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77424,'Ahh, the brothers Frostwolf. I knew we would reunite on the battlefield someday.','',0,0,0,0,0,0,0,0,0,0,41753,0,26124),
(77425,'Or don\'t you recognize your eldest brother?','',0,0,0,0,0,0,0,0,0,0,41754,0,26124),
(77426,'Look for a shop in de Drag, right next to de Valley of Wisdom.  Godan\'s Runeworks is the name of de place.','Look for a shop in de Drag, right next to de Valley of Wisdom.  Godan\'s Runeworks is the name of de place.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77427,'Brothers! Oblige our Frostwolf guests!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77428,'Lumark is de best fisherman around.  You can find him loungin\' around the dock in the Valley of Honor.','Lumark is de best fisherman around.  You can find him loungin\' around the dock in the Valley of Honor.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77429,'Find Red Canyon Mining northeast of the lake in de Valley of Honor.  Speak to Makaru there.','Find Red Canyon Mining northeast of the lake in de Valley of Honor.  Speak to Makaru there.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77430,'Makaru can teach you what you need to know mon.  He be in de Valley of Honor at Red Canyon Mining right by de lake.','Makaru can teach you what you need to know mon.  He be in de Valley of Honor at Red Canyon Mining right by de lake.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77431,'Look for Kodohide Leatherworkers in de Drag, talk to Thuwd.  He can show you all you need to know.','Look for Kodohide Leatherworkers in de Drag, talk to Thuwd.  He can show you all you need to know.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77432,'South of de huge tree, next to Kodohide Leatherworks in de Drag, is Magar\'s Cloth Goods.  I can show you on your map, mon.','South of de huge tree, next to Kodohide Leatherworks in de Drag, is Magar\'s Cloth Goods.  I can show you on your map, mon.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77433,'Now, Lokra! You and $p get to Fenris!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77434,'','Karg and the others should be crashing the front entrance any minute now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77435,'','They\'ll hold off the bulk of the Thunderlord fighters while you and I go for Fenris.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77436,'','FOR THE CLAN!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77437,'You\'ll find Lumak out on his dock on the lake in the Valley of Honor.','You\'ll find Lumak out on his dock on the lake in the Valley of Honor.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77438,'Seek out Seer Liwatha in the Valley of Wisdom.  Her healing powers are unmatched.','Seek out Seer Liwatha in the Valley of Wisdom.  Her healing powers are unmatched.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77439,'Sunwalker Atohmo has touched the Light, seek him out for further training.','Sunwalker Atohmo has touched the Light, seek him out for further training.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77440,'There is no one braver than Nahu.  He has protected our people for many years.  Seek him out in the Valley of Wisdom.','There is no one braver than Nahu.  He has protected our people for many years.  Seek him out in the Valley of Wisdom.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77441,'Looking to learn a thing or two about your trade hunter?  Seek out Nohi in the Valley of Wisdom.','Looking to learn a thing or two about your trade hunter?  Seek out Nohi in the Valley of Wisdom.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77442,'Within the Valley of Wisdom Shai Cloudsinger communes with the elements.  Speak with her.','Within the Valley of Wisdom Shai Cloudsinger communes with the elements.  Speak with her.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77443,'Earth Mother watch over Shalla.  She can be found in the Valley of Wisdom near the other trainers.  Let me mark your map with her location.','Earth Mother watch over Shalla.  She can be found in the Valley of Wisdom near the other trainers.  Let me mark your map with her location.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77444,'The pandaren have set up an encampment in the Valley of Honor.  Seek out Ji Firepaw to hone your skills further.','The pandaren have set up an encampment in the Valley of Honor.  Seek out Ji Firepaw to hone your skills further.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77445,'Ormok is a slipery type who can be found within the Cleft of Shadows.  He can teach you how to survive on the streets of Orgrimmar.','Ormok is a slipery type who can be found within the Cleft of Shadows.  He can teach you how to survive on the streets of Orgrimmar.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77446,'Within the Cleft of Shadow there is a conclave of warlocks.  Let me show you on your map.','Within the Cleft of Shadow there is a conclave of warlocks.  Let me show you on your map.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77447,'Many arcane secrets can be learned within the Cleft of Shadow.  Seek out Marud, he can teach you.','Many arcane secrets can be learned within the Cleft of Shadow.  Seek out Marud, he can teach you.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(77455,'','The podlings seemed so innocent. I\'m still in shock... my husband. They killed my husband...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77456,'','They lied to us about many things. Fortunately the crystal was not one of them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77457,'','Now that the crystal is activated I\'ll contact Velen.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77458,'','Let\'s hope finding this crystal was worth the blood spilled in this forest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77459,'','I can\'t believe it was right here the whole time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77460,'Ga\'nar and the others went up to the second level.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77461,'Go outside and follow the ramp to the south. Korga should be up there. She\'ll know where Ga\'nar is.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(77462,'We can handle this area. Go!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77464,'Welcome friend!','Welcome friend!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77467,'I\'m so glad you are here!','I\'m so glad you are here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77468,'Peace and happiness friend!','Peace and happiness friend!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77470,'Here they come. Ready yourselves!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77471,'Fool, I tricked you from the start. The time is now, I\'ll swallow your heart!','Fool, I tricked you from the start. The time is now, I\'ll swallow your heart!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77472,'Enjoy your time in the forest!','Enjoy your time in the forest!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77473,'','You\'ll need to destroy that barricade to get through!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77474,'','Thank the light... I feared the worst.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77475,'','Thank you again, $c. I can handle the rest from here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77476,'','Hold them at bay, $p! I need to catch my breath.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77477,'','Lok\'tar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77478,'Spirits of the water, I seek your guidance. Spirits of the earth, I seek your strength.','',0,0,0,0,0,0,0,0,5,0,46639,0,26124),
(77479,'I... I hear the voice of a Fury!','',0,0,0,0,0,0,0,0,5,0,46640,0,26124),
(77480,'You be lookin\' for Sesebi, mon.$B$BShe most often be sleepin\' under de tree by old Umbehto, de fisherman, lookin\' like a big ol\' tiger in de Valley of Spirits.','You be lookin\' for Sesebi, mon.$B$BShe most often be sleepin\' under de tree by old Umbehto, de fisherman, lookin\' like a big ol\' tiger in de Valley of Spirits.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(77481,'Kuzari be trainin\' headhunters on one of de small islets towards de southeast end of de Valley of Spirits, mon.','Kuzari be trainin\' headhunters on one of de small islets towards de southeast end of de Valley of Spirits, mon.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(77482,'Zanga be trainin\' headhunters on one of de small islets towards de southeast end of de Valley of Spirits, mon.','Zanga be trainin\' headhunters on one of de small islets towards de southeast end of de Valley of Spirits, mon.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(77484,'Dey be on top of de tall building in de southeast end of de Valley of Spirits.','Dey be on top of de tall building in de southeast end of de Valley of Spirits.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(77485,'Shadow-Walker Zuru can help ya.$B$BYou\'ll find him on de lowest floor of de taller building in de southeast of de Valley of Spirits.','Shadow-Walker Zuru can help ya.$B$BYou\'ll find him on de lowest floor of de taller building in de southeast of de Valley of Spirits.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(77486,'Ku\'nanji, de Night-Stalker, is who yer lookin\' for.$B$BHe be just north of de Valley of Spirits\' central building.','Ku\'nanji, de Night-Stalker, is who yer lookin\' for.$B$BHe be just north of de Valley of Spirits\' central building.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(77487,'Witch Doctor Umbu spends his time walkin\' about de Valley of Spirits, tendin\' to de people and elemental spirits alike.$B$BLook for him around de central building.','Witch Doctor Umbu spends his time walkin\' about de Valley of Spirits, tendin\' to de people and elemental spirits alike.$B$BLook for him around de central building.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(77488,'You be crazy, mon, meddlin\' with dat bad mojo. But I ain\'t one ta stop ya.$B$BUnjari Feltongue is in de taller building in de southeast of de Valley of Spirits, past de shadow priest\'s shrine.','You be crazy, mon, meddlin\' with dat bad mojo. But I ain\'t one ta stop ya.$B$BUnjari Feltongue is in de taller building in de southeast of de Valley of Spirits, past de shadow priest\'s shrine.',396,0,0,0,0,0,0,1,1,0,0,0,26124),
(77489,'Fly with me, hero. We will assist them from above!','',0,0,0,0,0,0,0,0,4,0,44799,0,26124),
(77490,'The purifying light of the naaru is both our hammer AND shield.','',0,0,0,0,0,0,0,0,4,0,44800,0,26124),
(77491,'They are at the very temple gates - fly closer! Hurry!','',0,0,0,0,0,0,0,0,4,0,44801,0,26124),
(77492,'Circle back. We must clear the steps.','',0,0,0,0,0,0,0,0,4,0,44802,0,26124),
(77493,'Exarch Akama! Watch your flanks!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77494,'Thank you, old friend!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77495,'Never again will you orcish hordes darken the light of Karabor!','',0,0,0,0,0,0,0,0,4,0,44803,0,26124),
(77496,'Press onward. By the light of the Naaru!','',0,0,0,0,0,0,0,0,4,0,44804,0,26124),
(77497,'Use the sightstone to mark the catapults. The Timewalkers can take out those catapults, but they cannot do so safely without eyes on the ground.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77498,'','Watch out! Goren!',0,0,0,0,0,0,0,0,7,0,0,41779,26124),
(77499,'It must not disturb the master.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77500,'The master demands silence!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77501,'The meat must be silenced!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77502,'Spirits of fire, I seek ferocity- aaaaaah!','',0,0,0,0,0,0,0,0,5,0,46641,0,26124),
(77503,'Hold, $p! This is not our enemy.','',0,0,0,0,0,0,0,0,5,0,46642,0,26124),
(77504,'','Drek\'Thar! $p, cover me.',0,0,0,0,0,0,0,0,5,0,0,41782,26124),
(77505,'','Hear it faster! We are getting swarmed down here.',0,0,0,0,0,0,0,0,5,0,0,41781,26124),
(77506,'','Drek\'Thar! $p, cover me. <WRONG RECORD>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77507,'Rwaghh!','',0,0,0,0,0,0,0,0,0,23021,0,0,26124),
(77508,'Smash!','',0,0,0,0,0,0,0,0,0,23021,0,0,26124),
(77509,'Fresh meat!','',0,0,0,0,0,0,0,0,0,23021,0,0,26124),
(77510,'You die!','',0,0,0,0,0,0,0,0,0,23021,0,0,26124),
(77511,'Go away!','',0,0,0,0,0,0,0,0,0,23021,0,0,26124),
(77512,'Wolves make tasty snack!','',0,0,0,0,0,0,0,0,0,23021,0,0,26124),
(77513,'Wor\'gol!','Wor\'gol!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77521,'Lok\'tar ogar! Victory or death!','Lok\'tar ogar! Victory or death!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77522,'We know you\'re in there! Don\'t make us burn the hut down!','There is no use hiding! Come out and face your death!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77523,'','Show Dorogg no mercy. Lok\'tar ogar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77524,'','You hear that, Asha? Karg is coming. That means you get to play with Nerok!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77525,'More Thunderlord scum attacking from the east! We\'re holding at Karg\'s hut!','More Thunderlord scum attacking from the east! We\'re holding at Karg\'s hut!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77528,'I will kill the Thunderlord!','I will kill the Thunderlord!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77529,'This is my home!','This is my home!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77530,'Thunderlord dogs!','Thunderlord dogs!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77531,'Lok\'tar ogar!','Lok\'tar ogar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77532,'Come, $pc. Let\'s kill these Thunderlord weaklings!','Come, $pc. Let\'s kill these Thunderlord weaklings!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77533,'','Well fought! Come here, it is time to take the fight into the heart of the fortress.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77534,'','I\'ll meet you with Ga\'nar and the others at the ramp.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77535,'|TInterface\\Icons\\spell_holy_heroism.blp:32|t\nK\'ara has blessed you. You will gain the |cff71d5ff|Hspell:147414|h[Naaru\'s Glory]|h|r ability when out of combat.','|TInterface\\Icons\\spell_holy_heroism.blp:32|t\nK\'ara has blessed you. You will gain the |cff71d5ff|Hspell:147414|h[Naaru\'s Glory]|h|r ability when out of combat.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77536,'|TInterface\\Icons\\inv_boots_cloth_31v3.blp:32|t\nK\'ara has blessed you. Haste and run speed increased.','|TInterface\\Icons\\inv_boots_cloth_31v3.blp:32|t\nK\'ara has blessed you. Haste and run speed increased.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77537,'|TInterface\\Icons\\spell_holy_aspiration.blp:32|t\nK\'ara has blessed you. Damage taken reduced and health restored.','|TInterface\\Icons\\spell_holy_aspiration.blp:32|t\nK\'ara has blessed you. Damage taken reduced and health restored.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77538,'|TInterface\\Icons\\spell_fire_ragnaros_supernova.blp:32|t\nK\'ara has blessed you. Successful attacks will now build up holy energy that periodically explodes, damaging nearby enemies.','|TInterface\\Icons\\spell_fire_ragnaros_supernova.blp:32|t\nK\'ara has blessed you. Successful attacks will now build up holy energy that periodically explodes, damaging nearby enemies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77539,'|TInterface\\Icons\\spell_holy_aspiration.blp:32|t\nK\'ara has blessed you. Damage reduction and health restoration increased.','|TInterface\\Icons\\spell_holy_aspiration.blp:32|t\nK\'ara has blessed you. Damage reduction and health restoration increased..',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77540,'|TInterface\\Icons\\spell_fire_ragnaros_supernova.blp:32|t\nK\'ara has blessed you. Successful attacks will now build up more holy energy, dealing more damage to nearby enemies.','|TInterface\\Icons\\spell_fire_ragnaros_supernova.blp:32|t\nK\'ara has blessed you. Successful attacks will now build up more holy energy, dealing more damage to nearby enemies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77541,'$n, we are over here. Come quickly!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77542,'The Bladespire are weak. Their legions have fallen to our blades.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77543,'We have Gorr\'thog cornered. It is time to strike him down.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77544,'Ghostfur will take you to Gorr\'thog\'s chamber. He has taken a liking to you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77545,'Ghostfur looks at you expectantly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77546,'','That\'s enough, child. Try not to speak.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77547,'','I\'m sorry... I\'m just a little overwhelmed. Quickly $c, this way.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77548,'','Let your wolf guide you Drek\'Thar, and stay close to me if you can. $p, look for us in the Ice Forges when you are finished. Lok\'tar ogar!',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(77549,'Ligra, Korga, hold this point. We\'ll deal with this filth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77550,'$p is here, brother. Korga watched $Ghim:her; defeat Dorogg when our warriors could not. We wait no longer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77551,'Coming, brother?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77552,'Very well. Let\'s finish this.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(77553,'You\'re going to get yourself killed! As your chieftain, I say that we wait.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77555,'The deeds of the Iron Horde are contemptible. Their intentions are impure, and their leader is corrupt.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77556,'Bloodshed is the only answer here. Go with my blessing, champion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77557,'You look lost, outsider! What is your business here?','You look lost, outsider! What is your business here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77558,'Find them you imbeciles! Lord Bathiel will not be denied his sacrifices!','',0,0,0,0,0,0,0,0,0,0,43722,0,26124),
(77559,'You have done well, champion. Shadowmoon rests now... and so should you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77560,'The road is secure, adventurer! And I see you have successfully cast our invaders back to the sea. Truly, you are a champion of the light.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77561,'','Hey mon, help us! Da Twilight\'s Hammer be fixin to sacrifice our green hides.',0,0,0,0,0,0,0,0,0,0,0,45524,26124),
(77562,'','I have the chains and grapples you got from the Thunderlord. If you attack a forger I will use these to expose its weaknesses.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77563,'','Quick $p! Hit it hard while I have it tied down!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77564,'','I have it chained! Quick! Hit it hard!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77565,'','Now! Bring it down!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77566,'I remember you from the battle at Bladespire. You must have killed twenty ogres! Take whatever you need.','I remember you from the battle at Bladespire. You must have killed twenty ogres! Take whatever you need.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77567,'','That should be enough motes. This totem can barely hold any more.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77568,'','I got the primal! On to the next forger.',0,0,0,0,0,0,0,0,0,23043,0,0,26124),
(77569,'','Rulkan was Ner\'zhul\'s most trusted advisor for many years. Ner\'zhul\'s strength and ambition guided our lives, but Rulkan\'s wisdom and vision inspired our spirits.',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(77570,'','Ner\'zhul\'s methods are brutal and direct. He cuts his enemies down by force.$B$BRulkan is clever and wise. She will turn an enemy\'s own blade against them.',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(77571,'','The Shadowmoon Clan is no longer. Even if physical remnants remain, its spirit is corrupted.',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(77572,'','We are here in self-exile. We refused to tap the magic of Ner\'zhul\'s Dark Star.',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(77573,'','It is unclear what will happen to us from here, but one thing is certain. My loyalty to Chieftess Rulkan is absolute.',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(77574,'We\'ve broken through! Kill them all!','We\'ve broken through! Kill them all!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77575,'It\'s frightening how quickly the orcs have adapted to their new technology, even if it is crude.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77576,'We under attack!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77577,'Me crush you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77578,'Nobody tougher than me! Rwargh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77579,'You make tasty snack!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77580,'This only hurt for a second.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77581,'You no supposed to be here! Smash!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77582,'I\'m fine sh...shaman. I need to fight.','I\'m fine sh...shaman. I need to fight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77583,'I refuse to die this way. Laying here...like a coward.','I refuse to die this way. Laying here...like a coward.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77584,'Their catapults destroyed our forces...','Their catapults destroyed our forces...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77585,'Gorr\'thog will pay for this...','Gorr\'thog will pay for this...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77586,'Draka, help me up. We shou- hrraarh!','',0,0,0,0,0,0,0,0,7,0,46649,0,26124),
(77587,'Do not forget, child, one of us is blind and unable to call upon the spirits like he used to.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(77588,'','Bah! That should just come close to making it a fair fight. On your feet, old man.',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(77589,'What hope is there against a foe that can consume the very elements?','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(77590,'','You taught me long ago that the elements have always been there for us. Now it is our turn to be there for them. Victory or death, we owe it to them to try.',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(77592,'','Oh, he will. Trust me.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77593,'%s rumbles in assent.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(77594,'','I felt invincible once; I was wrong. We return to the pack. The Iron Wolf will answer to the full might of the Frostwolf clan.',0,0,0,0,0,0,274,0,1,0,0,0,26124),
(77595,'$C! You have freed my children and made me whole. Accept my boon and bring the full fury of Frostfire to your enemies.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(77596,'Shaman, you alone were strong enough to hear my call. You were wise enough to know what needed to be done. Give me your totem.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(77602,'Feel the flames of the fury!','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(77603,'Frost Wolf nuzzles its master\'s side, whining softly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77604,'Exurotus was always believed to be a legend. A story told from shaman to shaman as a symbol of a true elemental spirit.$b$bTo see something so revered in shackles is an affront to orcs, to shamanism, and to me.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(77605,'Begin your ritual.','Begin your ritual.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77606,'It is good to see you again, $n. There isn\'t a moment to spare.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77607,'Climb on Brazen\'s back when you are ready to leave. I will explain everything on the way.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77608,'Let\'s ride.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77609,'The stench of tortured stone fills the air, Draka. What do you see?','',0,0,0,0,0,0,0,0,4,22102,0,0,26124),
(77610,'I can feel hundreds of goren burrowing through the earth. This will not be easy.','',0,0,0,0,0,0,0,0,4,0,46672,0,26124),
(77611,'So this is the pact of iron we have heard about. In truth, many clans working together to crush anyone who does not share their vision.$B$BDurotan was wise to refuse this so-called Iron Horde. I can only hope we are strong enough to withstand it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77612,'','Goren... lots of goren. We will distract them in order to sneak you into the Ice Forge.',0,0,0,0,0,0,0,0,4,22102,0,41801,26124),
(77613,'What you suggest should be good enough to bring down a forger, but only for a few seconds at a time.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(77614,'It was horrible. The podlings ate Ryan right in front of me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77615,'Shelly and the others were captured by the podling king... we must find them. I... I will not let them die.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77616,'We must kill their king... they headed off to the west... save them. Save my wife!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77617,'This is Frostfire Ridge. The Frostwolf Clan journeys here each year so their newly aged warriors may bond with their own wolf.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77618,'The Horde is in a fragile state. We cannot afford to raise an army of our own.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77620,'I have already met with their chieftain to discuss an alliance. Durotan has been... resistant.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77621,'The Bladespire ogres have been attacking more frequently. He wants to launch an assault on their fortress soon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77622,'Ogres! Brazen, freeze them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77623,'We\'re nearing the fortress now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77624,'Durotan\'s forces have already begun attacking! Hold on, we\'re going in.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77625,'We don\'t have much time. We have to help the Frostwolves.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77626,'Our entire existence depends on it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77627,'I only hope that we are enough.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77628,'Durotan and Ga\'nar are just ahead. Let\'s go.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77630,'These animals have done nothing but leave chaos and death in their wake. Let\'s send them an unmistakable message.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77631,'You brutes! Attack!','',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(77632,'Hurry it up! Tiny is getting anxious. Aren\'t you girl? Who\'s a good girl?','Hurry it up! Tiny is getting anxious. Aren\'t you girl? Who\'s a good girl?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77633,'Just waiting on sticky fingers over there.','Just waiting on sticky fingers over there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77634,'Hold your talbuks, will you? There\'s loot in here.','Hold your talbuks, will you? There\'s loot in here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77635,'There will be plenty of time to loot the place after we come back with those cannons. Let\'s go!','There will be plenty of time to loot the place after we come back with those cannons. Let\'s go!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77636,'Gorr\'thog! I, Ga\'nar, son of Garad, come for your head!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77637,'Come. I\'ll paint the walls with your blood, orc.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77638,'\"Fall back to the outpost!\" they said.$B$B\"The Thunderlords will overwhelm you!\" they said.$B$B<The old orc spits.>$B$BPah! This is my hut, and I\'m not moving. I\'ll stand my ground and die with honor!$B$BHow about you, pup? Will you run, too? Or stand and fight?!','\"Fall back to the outpost!\" they said.$B$B\"The Thunderlords will overwhelm you!\" they said.$B$B<The old orc spits.>$B$BPah! This is my hut, and I\'m not moving. I\'ll stand my ground and die with honor!$B$BHow about you, pup? Will you run, too? Or stand and fight?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77639,'Stand and fight! Victory or death!','Stand and fight! Victory or death!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77640,'Nothing wrong with a little tactical retreat...','Nothing wrong with a little tactical retreat...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77641,'You would have us sit idle while Gorr\'thog still breathes? I refuse!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77642,'<The old orc spits again. You\'re pretty sure a tooth came out this time.>$B$BPAH!!$B$BCome back when you grow a spine!','<The old orc spits again. You\'re pretty sure a tooth came out this time.>$B$BPAH!!$B$BCome back when you grow a spine!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77643,'Spoken like a true orc! And here comes your chance to prove it. Thunderlords incoming!','Spoken like a true orc! And here comes your chance to prove it. Thunderlords incoming!',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(77644,'Come, fools! Break yourselves upon us!!','Come, fools! Break yourselves upon us!!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77645,'Ah, the thrill of battle! I feel young again!','Ah, the thrill of battle! I feel young again!',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(77646,'Go on inside my hut - you\'ll find an old chest in the corner. I want you to have what\'s inside.','Go on inside my hut - you\'ll find an old chest in the corner. I want you to have what\'s inside.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77647,'Go away! I will fix this!','',0,0,0,0,0,0,0,0,0,0,42051,0,26124),
(77648,'Uh... stone!','',0,0,0,0,0,0,0,0,0,0,42055,0,26124),
(77649,'FIRE!','',0,0,0,0,0,0,0,0,0,0,42058,0,26124),
(77650,'Smash!','',0,0,0,0,0,0,0,0,0,0,41738,0,26124),
(77651,'Pound to dust...','',0,0,0,0,0,0,0,0,0,0,41737,0,26124),
(77652,'Next time, I get ta pick first, ya pasty blue blowhard!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77653,'You are but a pebble amongst boulders...','',0,0,0,0,0,0,0,0,0,0,41725,0,26124),
(77655,'I am a rockslide!','',0,0,0,0,0,0,0,0,0,0,41726,0,26124),
(77656,'Freedom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77657,'Ha, rocks are dumb!','',0,0,0,0,0,0,0,0,0,0,42053,0,26124),
(77658,'Hah hah! So weak.','',0,0,0,0,0,0,0,0,0,0,42054,0,26124),
(77659,'I will defend this home to my last breath.$B$BI only hope death finds me in battle, and not in bed.','I will defend this home to my last breath.$B$BI only hope death finds me in battle, and not in bed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77660,'What are you waiting for? Go on inside and take your reward.$B$BDon\'t you have enough manners to accept a gift?','What are you waiting for? Go on inside and take your reward.$B$BDon\'t you have enough manners to accept a gift?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77661,'Ghostfur will take you to Durotan and Ga\'nar.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77662,'Yes... the brute weakens...','',0,0,0,0,0,0,0,0,0,0,41729,0,26124),
(77663,'Kill him! I will be free!','',0,0,0,0,0,0,0,0,0,0,41730,0,26124),
(77664,'Lokra, wait! Gah... so impulsive, that one.','Lokra, wait! Gah... so impulsive, that one.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(77665,'I fight with my father\'s spirit watching over me. No ogre or orc can stand in my way.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77666,'I am ready to fight when you are.','I am ready to fight when you are.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77667,'<The clefthoof chews what little grass he can find. Pickings are slim in Gorgrond.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77668,'Another one! How many of these did they set loose in here?!','Another one! How many of these did they set loose in here?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77669,'Careful! Keep it away from the huts!','Careful! Keep it away from the huts!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77670,'Wasted material.','',0,0,0,0,0,0,0,0,0,0,41731,0,26124),
(77671,'I will expunge your existence.','',0,0,0,0,0,0,0,0,0,0,41727,0,26124),
(77672,'Take the caravan to [LAUGHING SKULL RUINS].','Take the caravan to [LAUGHING SKULL RUINS].',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77673,'Take the caravan to [TANK TEST FACILITY].','Take the caravan to [TANK TEST FACILITY].',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77674,'Take the caravan to [OGRE SLAVE CAMP].','Take the caravan to [OGRE SLAVE CAMP].',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77675,'Take the caravan to [PIPEWORKS CAMP].','Take the caravan to [PIPEWORKS CAMP].',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77676,'Take the caravan to [STEAM CAPPING CAMP].','Take the caravan to [STEAM CAPPING CAMP].',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77677,'Take the caravan to [SHIPYARD CAMP].','Take the caravan to [SHIPYARD CAMP].',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77678,'You found a weapon a friend might wield.','',0,0,0,0,0,0,0,0,2,0,0,0,26124),
(77679,'You find more clues, at the beach.','',0,0,0,0,0,0,0,0,2,0,0,0,26124),
(77680,'<This weapon looks like it could have belonged to someone from the missing search party.>','',0,0,0,0,0,0,0,0,2,0,0,0,26124),
(77681,'Spirits of the wind! Heed my call! We have need of your wisdom.','',0,0,0,0,0,0,0,0,7,0,46638,0,26124),
(77682,'These stones appear to retain the force and heat being hammered into them.','These stones appear to retain the force and heat being hammered into them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77683,'These thick plates are being tempered to withstand extreme heat.','These thick plates are being tempered to withstand extreme heat.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77684,'','Tread lightly, stranger. There is fight in me yet.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77685,'Is that... Gorr\'thog? Out here?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77686,'You are weak, tiny, frail creatures. I will enjoy watching you die.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77687,'Ga\'nar, you will spearhead the attack and take out their catapults.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77688,'The rest of us will follow in and we can secure...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77689,'Come, brother. We can\'t let him escape!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77690,'No, Ga\'nar. It\'s too dangerous. We need to follow the plan.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77691,'No. We end this now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77692,'Lorgosh! Korga! We ride!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77693,'Lok\'tar ogar!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77694,'Lord of the Void, hear us. Let our blood herald your arrival into this world!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77695,'The void... HUNGERS!','',0,0,0,0,0,0,0,0,0,0,44451,0,26124),
(77696,'','What is that monstrosity?',0,0,0,0,0,0,0,0,0,0,0,45641,26124),
(77698,'Your blood only makes me stronger.','',0,0,0,0,0,0,0,0,0,0,44452,0,26124),
(77699,'You cannot defeat the void!','',0,0,0,0,0,0,0,0,0,0,44453,0,26124),
(77700,'Lok\'tar ogar!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77701,'','Lok\'tar ogar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77702,'Lok\'tar ogar!','Lok\'tar ogar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77703,'Ease off, Hansel. I assure you there\'s plenty of opportunity to kill more Iron Horde.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77704,'A Stonemaul ogre camp. They\'re slavers.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(77705,'This is not a place Frostwolves tread. Be mindful of what shadows you step in.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77706,'Ahoy there! I\'ve got just the drink you need to get ye to yer destination.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77707,'I\'m ready to go, Adm\'rl.','I\'m ready to go, Adm\'rl.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77713,'Seared by flames...','',0,0,0,0,0,0,0,0,0,0,41734,0,26124),
(77714,'Burn unto nothingness!','',0,0,0,0,0,0,0,0,0,0,41735,0,26124),
(77715,'My thanks, stranger.','My thanks, stranger.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(77716,'I am in your debt, whoever you are...','I am in your debt, whoever you are...',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(77717,'Ahhh, I feel... better.','Ahhh, I feel... better.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77718,'Freedom, at last.','Freedom, at last.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77719,'These ogres shall pay dearly!','These ogres shall pay dearly!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(77720,'Durotan shall hear of your deeds, stranger.','Durotan shall hear of your deeds, stranger.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(77721,'My death feeds the Old Gods...','My death feeds the Old Gods...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77722,'All things must end.','All things must end.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77723,'You will be consumed as well.','You will be consumed as well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77724,'They come. Defend the road!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77725,'','We Frostwolves are wiser than we seem, outsider.$b$bAnd I am watching you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77726,'There are three sets of ogre tracks running off to the east after our mysterious female.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(77727,'Careful around those tailthrashers. They hit hard.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(77728,'','My wolf shall feast tonight, if she still lives.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77729,'Gorr\'thog was a fool. No ogre can stand against a Frostwolf.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(77730,'You fought well as always, brother. Now we need to secure our borders and clean out any remaining Bladespire. The Thunderlords could attack at any moment.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(77731,'Look around you, Durotan. The Bladespire are dead. We should strike down the Thunderlords now while our warriors\' spirits are high.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(77732,'Our riders and their wolves need to rest. It would be foolish to march again so soon. I will not sacrifice our safety for vengeance against the Thunderlords.','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(77733,'You are the fool, brother. We should kill Fenris wherever he\'s hiding. Instead, he attacks our villages and we sit idle.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(77734,'If you will not avenge our father, I will.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(77735,'Those of you who would ride with me, I will waste no time in a fortress made by ogres.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(77736,'Victory or death!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(77737,'Lok\'tar ogar!','Lok\'tar ogar!',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(77738,'I\'ll come back when Fenris is dead.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(77739,'Ner\'zhul must not be interrupted!','Ner\'zhul must not be interrupted!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77740,'','Thank you, stranger! The Shadowmoon attacked the Observatory without warning.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77741,'','Hurry - the Shadowmoon Chieftain has taken the Observatory!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77742,'The researchers here at Arkaat Outpost have been gathering pieces of our ancestors\' original wreckage.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77743,'My scouts are swift and strong. They will give us ample warning at the first sign of enemy movement.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77744,'The scouts of Karabor move like the wind. When we strike, we are swift and true.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77745,'<The young draenei is intently focused on the battlefield.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77746,'Velen summons us NOW? What task might be more important than protecting Karabor against this tide of orcs?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77747,'He has a plan to break the siege, but he needs the might of your vindicators.','He has a plan to break the siege, but he needs the might of your vindicators.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77748,'<The draenei corpse appears to have been dispatched with an axe blow to the back of the head. The poor soul probably never saw it coming.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77749,'He\'s a PROPHET. He probably has a good idea what\'s coming.','He\'s a PROPHET. He probably has a good idea what\'s coming.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77750,'','I am sworn by duty. If we are needed, we will be there. Come, Vindicators!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77751,'','Hmmm... yes, you make a compelling point. Come, vindicators!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77752,'WHAT?!','',0,0,0,0,0,0,0,0,0,0,41769,0,26124),
(77753,'','They\'ve scaled the cliffs! Find the Vindicators - anyone - help!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(77754,'Come, child. Find safe refuge in my totem.','',0,0,0,0,0,0,0,0,5,0,46643,0,26124),
(77755,'Please, keep your voice down. I don\'t want to give away our position.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77756,'This is highly unusual. We are in perfect position! Why leave now?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77757,'So many? Very well. When the Prophet calls, the rangari answer. Follow me, men! Velen requests our aid!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77758,'I place my trust in Velen\'s wisdom. He is, after all, the Prophet of my people. Follow me, men!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77759,'I don\'t know the details of the plan, but he\'s asking for the rangari, the anchorites, the vindicators, AND the artificers.','I don\'t know the details of the plan, but he\'s asking for the rangari, the anchorites, the vindicators, AND the artificers.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77760,'Velen\'s orders.','Velen\'s orders.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77761,'I need to get this crystal repaired as soon as possible, but the nearby wolves are not making it easy.$B$BCan you defend me while I work on the repairs?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77762,'You - you are the hero from Tanaan, yes? I need your aid.$b$bIn the absence of Karabor\'s normal defensive shields, we\'ve been installing Aeluun defense crystals. That crystal down at the bottom of the stairs is malfunctioning, and I can\'t leave this post until it\'s repaired. Could you place this resonator on the crystal?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77763,'Excellent news. The malfunctioning crystal is just to the north, along the temple grounds\' outer wall.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77764,'It is done? Good. Once this battle is over, we will have to begin repairing Karabor\'s proper shield defenses.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77765,'Yes, Rommul. I will repair your crystal for you.','Yes, Rommul. I will repair your crystal for you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77766,'Visitor. What is it you wish?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77767,'The Prophet calls, and of course, I follow. But first, I have a request.$b$bMy anchorites are well-trained in the healing arts, but are less skilled in battle. I have many wounded defenders down beyond enemy lines, without any battle-hardened adventurers to rescue them...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77768,'I would be grateful, visitor. You may use this sigil to heal the wounded soldiers, if you need it.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(77769,'You are a friend of the anchorites, visitor. I will see you back at the rallying point.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77770,'I will help you heal the wounded defenders.','I will help you heal the wounded defenders.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77771,'Velen has requested your help.','Velen has requested your help.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77772,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77773,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77774,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77775,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77776,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77777,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77778,'With Ga\'nar and his followers gone, we cannot hope to hold this fortress.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77779,'Ha! Your ranger friend can\'t shoot  me here. Let\'s see how you do without him.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77780,'We should form an alliance, Durotan. The Horde can help your clan.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77781,'You are right, Thrall. We will join your Horde. You have proved your worth and your honor.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77782,'Now that the fortress is ours, we need to liberate the mines below and the nearby arena.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77783,'It will be done. Focus on your people here. $p will deal with the remaining Bladespire.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77784,'We cannot leave so many wounded behind enemy lines.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77785,'I have done what you ask, Harbinger.','I have done what you ask, Harbinger.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77786,'The crystal is functional again, Master Artificer.','The crystal is functional again, Master Artificer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77787,'With that crystal non-functional, the Iron Horde has a direct aerial access point into Karabor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77788,'Kill da intruder!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77789,'Attack!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77790,'Rwargh! Smash $Ghim:her;*!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77791,'|cFFFF0000|Hspell:150381|h[Power Shot]|h|r hit you. Move before Fenris releases it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77792,'Carry this symbol of my gratitude into battle, and its fire shall join with your own to burn your enemies to ash.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(77793,'We are the only ones close enough to collect these pieces and unleash the fury.','',0,0,0,0,0,0,0,0,7,0,46648,0,26124),
(77794,'Work harder, chump!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77795,'Get minin\'!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77796,'Need more throwin\' rocks!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77797,'Gimme more rocks or Turgall hear about dis.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77798,'You so weak!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77799,'Hurry up or me bonk you again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77800,'Dis hard work.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77801,'You slackin\' off?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77802,'Thank you, stranger.','Thank you, stranger.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77803,'If only I had the strength to fight...','If only I had the strength to fight...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77804,'Curse these ogres!','Curse these ogres!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77805,'You\'ve saved me from a sure death.','You\'ve saved me from a sure death.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77806,'I had given up hope of rescue.','I had given up hope of rescue.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77807,'Thank you for your bravery.','Thank you for your bravery.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77808,'I thought I was doomed.','I thought I was doomed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77809,'You have my thanks.','You have my thanks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77810,'Aye.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77811,'Defend the village, $pc. I go to check on my family.','Defend the village, $pc. I go to check on my family.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77812,'You fight well, $pc. For Wolf Home!','You fight well, $pc. For Wolf Home!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77813,'You have the heart of a true warrior!','You have the heart of a true warrior!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77814,'I\'m going to attack their flank!','I\'m going to attack their flank!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77815,'Here I come Thunderlord cowards!','Here I come Thunderlord cowards!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77816,'Aka\'Mogosh, $pc. A blessing on you and yours.','Aka\'Mogosh, $pc. A blessing on you and yours.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77817,'Gol\'Kosh! Blood will be spilt!','Gol\'Kosh! Blood will be spilt!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77818,'Spill the blood of the enemy!','Spill the blood of the enemy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77819,'Throm-Ka, $pr. I will fight by your side.','Throm-Ka, $pr. I will fight by your side.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77820,'The wolf spirit be with you, $pc!','The wolf spirit be with you, $pc!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77821,'Two sets of tracks lead off to the north. Looks like an ogre leading the woman. No doubt as a captive.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(77822,'Och! Enough with the bickerin\', you two!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77823,'Nice of you to share your information, ranger.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77824,'No change. The snipers are on alert, but everyone else is behaving normally. $p approaches.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77825,'Very well, we will head out right away. The might of the Alliance stands behind your people.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77826,'Ah, $n! You\'re here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77827,'','Nice shot! Let\'s get out of here before they launch a counter-attack. Hold on to something!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77828,'','$p! Fire the main cannon. Destroy the train depot!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77829,'','$p, incoming! Use those explosives to destroy their ground forces.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77830,'You Frostwolves were fools to attack the ogres.','',0,0,0,0,0,0,0,1,0,0,41770,0,26124),
(77831,'I\'ll make a trophy of your head, Drek\'Thar.','',0,0,0,0,0,0,0,1,0,0,41771,0,26124),
(77832,'Accept your shame. Admit defeat. I will give you a quick death.','',0,0,0,0,0,0,0,1,0,0,41772,0,26124),
(77833,'You haven\'t won yet, $pc dog! I\'ll salt the earth with your corpse!','',0,0,0,0,0,0,0,1,0,0,41773,0,26124),
(77834,'','I\'m going to scout the depot and devise a plan to destroy it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77835,'I\'m ready to back you up from the safety of the tank.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(77836,'I can see Iron Horde reinforcements on the way. Yrel\'s across the depot to the northeast. Best get to her quickly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77837,'','Let\'s see if we can provide Goc with an incentive to aid us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77838,'','We have loosened your bonds and bring you gifts.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77839,'YES, LITTLE ONES, WE WILL CRUSH THEM TOGETHER!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77840,'Your security is lax, Chieftain. I caught these Rangari spies within your gates.','',0,0,0,0,0,0,1,0,4,0,43661,0,26124),
(77841,'They are too late. The prisoners are already on their way to Anguish Fortress.','',0,0,0,0,0,0,1,0,4,0,43702,0,26124),
(77842,'Their blood will summon forth the Dark Star, and make me as a God among the Iron Horde!','',0,0,0,0,0,0,1,0,4,0,43703,0,26124),
(77843,'The Warchief honors deeds, not words, shadowcaster.','',0,0,0,0,0,0,1,0,4,0,43662,0,26124),
(77844,'Seal the exits! No draenei scum leaves this village alive!','',0,0,0,0,0,0,1,0,4,0,43705,0,26124),
(77846,'','He\'s given his assent. Come, $n, let\'s ride with Goc.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77847,'','We have a common enemy. I ask you, humbly, for your aid. Let us destroy them together.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77848,'Thunderlord... I have failed you...','',0,0,0,0,0,0,0,1,4,0,41774,0,26124),
(77849,'','Goc, son of Gruul, prince of gronn, I am Yrel. Hear me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77850,'I\'ve seen your future, Gargrak. It doesn\'t look good.','',0,0,0,0,0,0,0,1,1,0,46693,0,26124),
(77851,'','Come, $n. Let\'s convince Goc to help us destroy this place.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77852,'$p, Yrel\'s plan is crazy. It\'s also brilliant. The two of you are going to destroy the depot... with a little help.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77853,'Going down to liberate the mines? Mount up and follow me, there\'s a quick way down.','Going down to liberate the mines? Mount up and follow me, there\'s a quick way down.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(77854,'This will take you down to the mines and arena, champion.','This will take you down to the mines and arena, champion.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(77855,'','Husband...',0,0,0,0,0,0,0,0,7,0,0,44700,26124),
(77856,'Enough! You scheming draenei can keep your precious temple... for now.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77857,'The Iron Horde will return!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77858,'I will move ahead and prepare a staging area for our counter-attack.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77859,'Show some respect to the Iron Horde and put your back into it, weaklings.','',0,0,0,0,0,0,0,0,0,23301,0,0,26124),
(77860,'Imperfections.','',0,0,0,0,0,0,0,0,0,0,41732,0,26124),
(77863,'Your blood will grant me the powers of the Dark Star. To Shaz\'gul with you!','',0,0,0,0,0,0,5,0,0,0,43699,0,26124),
(77864,'Take the prisoners to Shaz\'gul.','',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(77865,'|TInterface\\Icons\\achievement_arena_2v2_5:20|t$n has agreed to begin the encounter. Additional players required to begin: $8589w.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77866,'Let\'s stop Blackthorn!','Let\'s stop Blackthorn!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77867,'','You\'ve done it!  The plague preventing my access has been disrupted and we can now begin our final push to disrupt Death Speaker Blackthorn\'s ritual.  Lead on if you are ready to begin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77868,'Crushed by earth!','',0,0,0,0,0,0,0,0,0,0,41739,0,26124),
(77869,'Servants, to me!','',0,0,0,0,0,0,0,0,0,0,41736,0,26124),
(77870,'You... are... too late.  Amnennar is reborn with my death...','',0,0,0,0,0,0,0,0,0,0,46220,0,26124),
(77873,'','The Shadowmoon have scaled the cliffs! What are they doing!?',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(77874,'','An attack from the Shadowmoon clan? I\'ve never seen them so aggressive. We must strike back!',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(77876,'Hero, I know you have many questions, for you are not from this world.','',0,0,0,0,0,0,1,0,0,5692,0,0,26124),
(77877,'Hero, I know you have many questions, for these events are not as you remember them.','',0,0,0,0,0,0,1,0,0,5685,0,0,26124),
(77878,'Ner\'zhul has used this observatory to call down the \"Dark Star,\" a creature of shadow who darkens these skies.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77879,'We cannot stop it. But, we may be able to purify the darkness when it arrives.','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(77880,'Six ancient crystals lie dormant throughout this valley. If we can activate them before the star descends... there is hope.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(77881,'These orcs have violated the sanctity of Karabor. Their attack ends NOW!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77882,'May the Light guide our path!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77883,'Karabor ki\'le!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77884,'Karabor ki\'le!','Karabor ki\'le!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77885,'Arepheon! Provide us with cover fire!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77886,'Rangari! Arrows ready...','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77887,'FIRE AT WILL!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77888,'Artificers, disable those tanks!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77889,'As you wish, Great Prophet.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77890,'Akama, Taalo! Show them the might of the draenei!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77891,'The legion is ENDLESS!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77892,'You stand no chance against the Legion!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(77893,'You cannot run from the Legion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77894,'|TInterface\\Icons\\spell_fire_elementaldevastation.blp:20|t |cFFF00000|Hspell:150678|h[Molten Core]|h|r causes %s to unleash a |cFFF00000|Hspell:150682|h[Molten Barrage]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77895,'$n, you come with me.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(77896,'','Forces of the earth... give me strength!',0,0,0,0,0,0,0,0,0,0,0,41844,26124),
(77897,'','My body... returns... to the Kraul...',0,0,0,0,0,0,0,0,0,0,0,41845,26124),
(77898,'I understand now why you have come to Draenor, visitor. You do not belong here - but you have a noble reason to be here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77899,'Our paths start and end at very different places, visitor. But they will cross again. Go with the blessing of the naaru.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77900,'I need you to stay on the ground and keep these orcs distracted while I search for Romuul.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77901,'You ready?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77902,'Good luck, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77903,'Are you sure this is safe?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77904,'Whoooa!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77905,'Okay... seems stable. Now, if just activate the-- there we go!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77906,'If you see any boombots that look like they might be duds give them a good kick.  That\'ll get them moving again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77908,'We need to get moving. How much longer?','',6,0,0,2,0,0,0,0,0,0,0,0,26124),
(77909,'Just give me a second to think! I\'m working with scraps over here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77910,'Blackrock leadership is easy to identify. Just look for the biggest, loudest, ugliest orcs on the field.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77911,'|TInterface\\Icons\\spell_fire_selfdestruct.blp:20|t %s\'s |cFFF00000|Hspell:150734|h[Unleashed Flames]|h|r reaches full strength!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77912,'I can\'t believe they actually shot me down. I swear, if Rommul wouldn\'t have been yelling in my ear the whole time we would have been back at the observatory hours ago.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77913,'We need to activate that crystal. But we can\'t just stand by and watch as these orcs build weapons to attack Karabor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77914,'Gnomes, they seem more interested in their inventions than they do their own lives. Let us hope that ingenuity can actually benefit our efforts.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77915,'I\'m finding it difficult to put my trust in Zipfizzle.$b$bHe seems sincere, and his heart is full of light, but he is clearly using bubblegum to attach some of those wires together.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77916,'By Agamaggan, I will END you!','',0,0,0,0,0,0,0,0,0,0,41659,0,26124),
(77917,'Great Boar, grant me strength!','',0,0,0,0,0,0,0,0,0,0,41663,0,26124),
(77918,'The crystals speak to me. Today brings victory.','',0,0,0,0,0,0,0,0,0,0,41661,0,26124),
(77919,'Shards of earth, blind them!','',0,0,0,0,0,0,0,0,0,0,41664,0,26124),
(77920,'Blood of Agamaggan, burn them!','',0,0,0,0,0,0,0,0,0,0,41665,0,26124),
(77921,'INFERNO!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77924,'You walk so willingly to your death?','',0,0,0,0,0,0,547,0,0,0,0,0,26124),
(77925,'Let us see how you fare against the searing winds of the Twisting Nether!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77926,'Your world will BURN!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77927,'You should be honored, fools! Your blood will feed Aku\'mai, the destroyer of Azeroth!','',0,0,0,0,0,0,0,0,0,0,45105,0,26124),
(77928,'Invaders in the Kraul! Drive them back!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77929,'Keep looking. If there are any survivors from the crash I want them dealt with immediately.','',0,0,0,0,0,0,0,0,0,23301,0,0,26124),
(77930,'Failure is not an option.','',0,0,0,0,0,0,0,0,0,23301,0,0,26124),
(77931,'Fan out. I want to know who was on that plane.','',0,0,0,0,0,0,0,0,0,23301,0,0,26124),
(77932,'','Pathetic, you call that welding? Do better.',0,0,0,0,0,0,0,0,0,23301,0,0,26124),
(77933,'','Tighten that up. I don\'t want to see a wheel fall off of this as it moves into battle.',0,0,0,0,0,0,0,0,0,23301,0,0,26124),
(77934,'','Put some muscle into it.',0,0,0,0,0,0,0,0,0,23301,0,0,26124),
(77935,'','Pay attention! You are going to weld that right to the main axle.',0,0,0,0,0,0,0,0,0,23301,0,0,26124),
(77936,'Dig faster.','',0,0,0,0,0,0,0,0,0,23301,0,0,26124),
(77937,'Work harder.','',0,0,0,0,0,0,0,0,0,23301,0,0,26124),
(77938,'Keep digging, worthless scum!','',0,0,0,0,0,0,0,0,0,23301,0,0,26124),
(77939,'Thank you, heroes!','Thank you, heroes!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77940,'They were going to feed us to the beast Aku\'mai. There are more prisoners deeper in the dungeon. Please, save them!','They were going to feed us to the beast Aku\'mai. There are more prisoners deeper in the dungeon. Please, save them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77941,'Intruders?! Move the prisoners! Their flesh belongs to Lord Bathiel.','',0,0,0,0,0,0,0,0,0,0,43550,0,26124),
(77942,'Come along, heroes! The water is fine. HAHAHAHAHA!!!','',0,0,0,0,0,0,0,0,0,0,43551,0,26124),
(77943,'%s flees in fear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(77944,'We are going to report back to Velen now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77945,'Feel free to use the gyro Thaelin made to get back to the observatory.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77946,'I have to say, it is a bit terrifying utilizing some of his inventions at first, but ultimately very enjoyable.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77947,'Aww... I knew you would come around.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77948,'No! AAAAaaahhhhhhh...','No! AAAAaaahhhhhhh...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77949,'','Heroes, step quickly into the redeemed soils and allow life to flow back into you!',0,0,0,0,0,0,0,0,0,0,0,43606,26124),
(77950,'DIG, YOU MAGGOTS! DIG!','DIG, YOU MAGGOTS! DIG!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(77951,'This cargo is worth more than your lives!','This cargo is worth more than your lives!',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(77952,'Come on, put your backs into it!','Come on, put your backs into it!',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(77953,'The Iron Horde war machine has toppled nations, and you idiots can\'t get us over a PILE of SNOW?!','The Iron Horde war machine has toppled nations, and you idiots can\'t get us over a PILE of SNOW?!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(77954,'Dig like you mean it!','Dig like you mean it!',0,0,0,0,0,0,480,0,0,0,0,0,26124),
(77955,'You shovel like a Shadowmoon! Would you like to draw a little circle in the snow? Maybe light some candles and ask the wheel nicely to come out?!','You shovel like a Shadowmoon! Would you like to draw a little circle in the snow? Maybe light some candles and ask the wheel nicely to come out?!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(77956,'I thought they sent me ORCS!','I thought they sent me ORCS!',0,0,0,0,0,0,480,0,0,0,0,0,26124),
(77957,'Many shots, one kill!','',0,0,0,0,0,0,0,0,0,0,41947,0,26124),
(77958,'My boars will overrun you!','',0,0,0,0,0,0,0,0,0,0,41945,0,26124),
(77959,'Pin them!','',0,0,0,0,0,0,0,0,0,0,41951,0,26124),
(77960,'Run them through!','',0,0,0,0,0,0,0,0,0,0,41950,0,26124),
(77961,'Dorogg see how punies like hot rocks!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77962,'Deez rocks smash you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77963,'I put duh rocks in lavas!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77964,'Deez rocks is hot!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77965,'Rocks so hot dey on fire!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77966,'How do you like dis rock?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77967,'More fire rocks is better den less!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77968,'If puny scared of rocks, puny scared of Dorogg!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77969,'Get that one!','',0,0,0,0,0,0,0,0,0,0,41652,0,26124),
(77970,'Run away, little ones! Ha ha!','',0,0,0,0,0,0,0,0,0,0,41653,0,26124),
(77973,'%s inhales deeply.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77974,'%s\'s laugh echoes ominously in your mind.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77975,'','Resisting my magic is useless Ghamoo-Ra! Soon you will be under my power, then I shall unleash your fury on these meddling heroes!',0,0,0,0,0,0,0,0,0,0,0,43726,26124),
(77977,'','Wait... wait! It\'s too soon! NOOOOOoooooo...',0,0,0,0,0,0,0,0,0,0,0,43725,26124),
(77978,'Hold that barricade! I don\'t want to see a single orc past these lines.','',0,0,0,0,0,0,397,0,0,24449,0,0,26124),
(77979,'Karabor cannot fall!','',0,0,0,0,0,0,397,0,0,24449,0,0,26124),
(77980,'Hold strong against these hordes. We will outlast them!','',0,0,0,0,0,0,397,0,0,24449,0,0,26124),
(77981,'Do not give them an inch! Hold your ground!','',0,0,0,0,0,0,397,0,0,24449,0,0,26124),
(77982,'I am feeling much more healthy now.','I am feeling much more healthy now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77983,'Thank you.','Thank you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77984,'Back to the battle.','Back to the battle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77985,'Thank you, priest.','Thank you, priest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77986,'You have my gratitude.','You have my gratitude.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77987,'I thought I was done for. Thank you, healer.','I thought I was done for. Thank you, healer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77988,'That will do. You have my thanks.','That will do. You have my thanks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77989,'Thank the Light you were here. You saved my life.','Thank the Light you were here. You saved my life.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77990,'','No... Samaara!',0,0,0,0,0,0,5,0,0,0,0,45637,26124),
(77991,'','Ner\'zhul, stop this! What do you want?',0,0,0,0,0,0,0,0,0,0,0,43222,26124),
(77992,'Slaves! Fight or die!','',0,0,0,0,0,0,0,0,0,0,41654,0,26124),
(77993,'We need to get our eyes onto the field. The Rangari can help us.','',0,0,0,0,0,0,1,0,0,0,45394,0,26124),
(77998,'','The Light never falters. We WILL prevail!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(77999,'Yes... Very good. Around Shadowmoon Valley are four arkonite crystals, ancient wreckage from our vessel.','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(78000,'I thought we would never need their power, but the time has come. Take my staff, and gather their energy for me.','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(78001,'All right, give me one moment...','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(78003,'The twin crystals powering Karabor\'s shield took my artificers over a year to engineer.$B$BIts creation was an unrivalled accomplishment, and its destruction, an utter waste.$B$BThe four arkonite shards that lie dormant across Shadowmoon were created ages ago, but still, they may prove serviceable.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78005,'There are still enemies among us. EVERYONE TO ARMS!','',0,0,0,0,0,0,1,0,4,0,43704,0,26124),
(78010,'Champion, locating our prisoners may slow Ner\'zhul\'s plans, but we will need the power of all four crystals if we are to triumph over his schemes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78012,'%s sighs heavily.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78014,'There is no darkness that the light cannot pierce.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78015,'True sacrifice is willingly given. Ammi\'s sacrifice is a pact made in cold blood. It is capable only of the basest of magic. True sacrifice is made with one\'s soul, with no selfish intentions, with the purest of goodwill for one other than yourself. This type of sacrifice is capable of miraculous things.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78016,'Behold my power, Warchief Hellscream. With my clan at your side, you will be unstoppable.','',0,0,0,0,0,0,0,0,0,0,43714,0,26124),
(78018,'','Yrel... my dearest sister...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78021,'Come forth, Borrok!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78022,'Mighty Devourer, come and claim this offering from da Grimfrost!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78023,'HEY, COME OUT!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78024,'COME OUT WE GOTS FOOD!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78025,'Da Grimfrost ogres pay tribute to you! Show yourself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78026,'BIG WORM!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78027,'We are always on the hunt.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78028,'Keep your eyes and senses sharp. Danger lurks in the marsh.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78029,'Greetings, $n. Prophet Velen has told me of your deeds.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78030,'','The Shadowmoon clan is of special interest to me. I believe that the more we know of their history, the more we can come to understand them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78031,'','The first step to fighting your enemy is understanding them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78032,'','Of all the orc clans, it seems the Shadowmoon have the strongest affinity with  mysticism and superstition.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78033,'','The Shadowmoon clan lived in peaceful coexistence with us for many centuries. Only recently have we noticed more hostile behavior from the clan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78034,'','Such powerful casters the Shadowmoon are. Their magic is one I am not entirely familiar with, but that\'s why it is so fascinating.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78035,'','I am very interested in the Shadowmoon\'s particular brand of magic. It seems their most powerful abilities involve some type of blood pact, and thus, sacrifice.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78036,'What can I do for you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78037,'I\'ll carry out any job, for the right price.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78038,'My team is the best out there. We get the job done.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78039,'Our scouts are positioned across the marshes and the forests. We keep a close eye on the Shadowmoon orcs.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78040,'','Champion! Focus your attacks on that... THING! I will protect the others.',0,0,0,0,0,0,5,0,0,0,0,45638,26124),
(78041,'AHHHH!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78042,'Borrok the Devourer demands sustenance! Feed him Grimfrost Ogres!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(78043,'Borrok snatches %s from the feeding area!','Borrok snatches %s from the feeding area!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(78044,'','Heroes! I require your aid!',0,0,0,0,0,0,0,0,0,0,0,43603,26124),
(78045,'','You are too late!  The ritual has begun.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78046,'','Amnennar will be reawakened!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78047,'Mmm-hnng - yeah, come here! I\'ll put you in chains.','',0,0,0,0,0,0,0,0,0,0,41645,0,26124),
(78048,'Fools! The more blood you spill, the easier it will be for Aku\'mai to rise!','',0,0,0,0,0,0,0,0,0,0,43723,0,26124),
(78049,'','Let the power of the red dragonflight mend your wounds!',0,0,0,0,0,0,0,0,0,0,0,43604,26124),
(78050,'','No darkness can hold back the powers of the Life-Binder.',0,0,0,0,0,0,0,0,0,0,0,43605,26124),
(78051,'','We have done it.  I will take the phylactery into safekeeping. Amnennar will no longer control the Quilboar nor threaten Kalimdor.',0,0,0,0,0,0,0,0,0,0,0,43601,26124),
(78058,'Karabor is as much a fortress as it is a temple.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78059,'We\'ve defended against orc raids before, but the size of this army is much greater than any I\'ve ever seen.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78060,'I will see to the defense of Karabor - even if it requires laying down my own life.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78061,'You must defeat Commander Vorka. There he is, at the very gates of Karabor.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(78062,'With pleasure. Vindicators, follow me into the fray!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(78063,'','Together we can put a stop to Death Speaker Blackthorn\'s plans.  We must be quick, the ritual is almost complete!',0,0,0,0,0,0,0,0,0,0,0,43602,26124),
(78064,'<A lone orc traveler lies dead in the snow, apparently overwhelmed by ravenous tundra wolves. Judging by his gear, he was prepared for a long journey through harsh conditions.$B$BTucked into the front of his robe is a scroll bound in leather laces, with a furry trinket dangling from one end.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78065,'Take the scroll.','Take the scroll.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78066,'','You are good to have come so quickly.  I\'m afraid I must ask you to put your lives in danger again to save Kalimdor.$B$BAmnennar\'s apprentice, Death Speaker Blackthorn, hopes to return his master to the realm of the living!  We must quickly make our way atop the Spiral of Thorns and defeat him before the ritual can be completed.$B$BWe must strike together, only with our combined force can we hope to stop him!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78067,'I thought Amnennar was destroyed.','I thought Amnennar was destroyed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78068,'','I too thought Amnennar the Coldbringer had been defeated; a grave mistake indeed. How clouded my judgment must have been to forget the true power of a lich lies in their phylactery.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78069,'A phylactery?','A phylactery?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78070,'','A powerful necromancer such as Amnennar can store his soul in a physical vessel, allowing himself to be reborn if the proper rituals can be completed.$B$BI should have searched across Kalimdor for Amnennar\'s Phylactery, but I was too prideful in our previous victory.$B$BNow, all of that work may come undone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78071,'Skeletons assault you constantly and plague roils out of the caves.  How can I help stop the ritual?','Skeletons assault you constantly and plague roils out of the caves.  How can I help stop the ritual?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78072,'','I know Death Speaker Blackthorn\'s newest creation, Mushlump, spews forth plague from every pore and he has reenlisted Mordresh Fire Eye\'s help in rallying the undead.$B$BEven the Death\'s Head has been helping Blackthorn.  Their Arachnomancers have created a monstrosity of fang and plague, a spider of enormous size named Aarux.$B$BIf you could defeat these enemies and clear the plague blocking my path we could climb the Spiral of Thorns to defeat Death Speaker Blackthorn and recapture Amnennar\'s phylactery before it is too late.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78073,'','<This orc appears to have been camping here for several days before succumbing to the bitter cold. Her face is frozen in a woeful stare, gazing southwest toward the icy flats.$B$BClutched to her breast is a neatly folded letter.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78074,'Take the letter.','Take the letter.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78075,'You have to stop them! They\'re mad!','You have to stop them! They\'re mad!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(78076,'We mustn\'t let Auchindoun fall!','We mustn\'t let Auchindoun fall!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(78077,'Thank you, stranger. I owe you my life.','Thank you, stranger. I owe you my life.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(78078,'Thank you. I\'ll return to the gate.','Thank you. I\'ll return to the gate.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(78079,'I thought I was going to die! Thank you.','I thought I was going to die! Thank you.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(78080,'','<She waited for him until her breath froze.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78081,'<He was willing to lose everything to be with her.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78082,'%s has calmed down, and looks ready to be ridden into battle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78083,'Focus on the kill.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78084,'Don\'t let the beast out of your sights.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78085,'Watch your prey closely... and fire!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78086,'%s calls in reinforcements!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(78087,'I join... the earth...','',0,0,0,0,0,0,0,0,0,0,41660,0,26124),
(78088,'Destroy the void fragments before they merge with the %s!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(78089,'You will never take my glory!','',0,0,0,0,0,0,0,0,0,0,41946,0,26124),
(78090,'Furious little orcling!','',0,0,0,0,0,0,0,0,6,0,41878,0,26124),
(78091,'In your blind rage you rush to face my ogres alone.','',0,0,0,0,0,0,0,0,6,0,41879,0,26124),
(78092,'They will end you, little lone wolf.','',0,0,0,0,0,0,0,0,6,0,41880,0,26124),
(78093,'Your conquered clan will fill my slave pens...','',0,0,0,0,0,0,0,0,6,0,41881,0,26124),
(78094,'You are too late, fool. The Destroyer of Dreams\' plans are nearing fruition.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78095,'We will soon have portals surrounding Auchindoun. Pity you won\'t be around to see them unleashed.','',0,0,0,0,0,0,11,0,0,0,0,0,26124),
(78096,'Hellmaw, tear their souls asunder.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(78097,'$p! I came as quickly as I could. Did you find their leader?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78098,'The wound is severe. If I can cauterize it, I might be able to stop the bleeding.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78099,'What\'s happening here?','What\'s happening here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78100,'The intruders are still alive?! Stop them! The ritual must not be disturbed!','',0,0,0,0,0,0,0,0,0,0,43552,0,26124),
(78101,'The Razorfen never die.','',0,0,0,0,0,0,0,0,0,0,41572,0,26124),
(78102,'Spirits... guide my blade.','',0,0,0,0,0,0,0,0,0,0,41568,0,26124),
(78103,'This is not the last... of us...','',0,0,0,0,0,0,0,0,0,0,41569,0,26124),
(78104,'Yrel never arrived. I fear the worst.$B$BI won\'t lose her again, $n.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(78105,'The Iron Horde were merely testing us. They will come again, with a larger force.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78106,'The crystal is malfunctioning again. What we really need is a high-grade crystal shipment from Talador.$B$BThese old components just aren\'t holding together anymore.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78107,'A thousand and more were lost defending the temple, but our walls still stand.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78108,'What? Romuul, I need you to take care of this. I will send reinforcements after you.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78109,'Life is the Light, and the Light is Life itself. They may be exchanged, but nothing is ever lost.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78110,'Oh, hi. Do you need something?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(78111,'You must be the $r Taalo said we were waiting for.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(78112,'You must be the $c that snooty draenei, Taalo said was comin\' round.$B$BBy the looks o\' ye, we\'re gonna have some fun!','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(78113,'I\'ll drown you in the blood of your little army!','',0,0,0,0,0,0,0,0,6,0,44066,0,26124),
(78114,'Kill Hellmaw\'s Felblood to stop him from regenerating!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78115,'There\'s nothin\' I hate more than orcs, \'cept fer Blackrock orcs!','',11,0,0,0,0,0,0,0,0,0,0,0,26124),
(78116,'IMPUDENT FLEA! Now you will see what power lies in this fortress.','',0,0,0,0,0,0,0,0,0,0,41883,0,26124),
(78117,'Gorgrond is unforgiving. I\'m glad you\'re here, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78118,'Yrel never showed and has gone missing.$B$BI worry for her, but also about how Maraad will react to bad news.$B$BRegardless, I think it\'d be wise for us to leave this place soon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78119,'I\'m glad you\'re here. I don\'t want to go in alone.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78120,'They got \'emselves somethin\' big \'n nasty o\'er there.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78121,'There were three ogres and a draenei; a female by the look of the tracks. The survivors headed north. I\'ll tell Maraad when I know more.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78122,'She doesn\'t want me going with you. But, I can help by magically projecting myself.','',0,0,0,0,0,0,0,7,0,0,44996,0,26124),
(78123,'Of all the things that could go wrong, it had to be Karabor\'s shield.$B$BNo, it couldn\'t be a malfunctioning resonancy code. It wasn\'t a bad shipment of agentite.$B$BIt just had to be the shield protecting the largest draenei city in Shadowmoon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78124,'I\'ll be a talbuk\'s hind if I let that shield be the end of Karabor.$B$BWe must activate those arkonite crystals, now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78125,'Any other master artificer wouldn\'t have a sporebat\'s cahoot how to fix the city\'s shield, that\'s what I\'d like to say.$B$BWhat would they do without me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78126,'My wife always says I should relax more.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78127,'The arkonite crystals around Shadowmoon fell from the wreckage of our original descent to Draenor, nearly three hundred years ago.$B$BIt\'s a testament to draenei technology that they are still functional.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78128,'','I came as quickly as I could. Were you able to catch their leader?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78129,'Ready the cannons!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78130,'Steady!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78131,'Hold, me boyos!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78132,'Wait fer it!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78133,'Almost there!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78134,'Fire!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78135,'Give \'em all ye got!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78136,'Now!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78137,'Pound \'em, lads!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78138,'Send \'em back ta Hell!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78139,'Ignaeus! Protect me!','',0,0,0,0,0,0,0,0,0,0,41884,0,26124),
(78140,'|TInterface\\Icons\\spell_arcane_blast:20|t %s readies an |cFFFF0000|Hspell:151273|h[Arcane Shot]|h|r at $n!','|TInterface\\Icons\\spell_arcane_blast:20|t %s readies an |cFFFF0000|Hspell:151273|h[Arcane Shot]|h|r at $n!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78141,'There are fewer ogres in our way with you around. I\'ll get these orcs to safety.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78142,'I will get these orcs to safety and meet with you outside.','',0,0,0,0,0,0,0,0,4,0,45189,0,26124),
(78143,'Gol\'kosh headed southeast toward the supply room.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78144,'AAAHHHHHH!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78145,'Aaahhhhh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78146,'Wha... AAAAHHHHHH!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78147,'Grrrr... RRRAAAHHHH!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78148,'Gahhhh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78149,'I carry the satchel charges, you do the fighting. Deal?','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78150,'This gruesome corpse has had its face forcibly shaped into that of a smile. Across the chest armor reads: \"We got them to laugh... eventually.\"','This gruesome corpse has had its face forcibly shaped into that of a smile. Across the chest armor reads: \"We got them to laugh... eventually.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78151,'We will not be slaves again!','We will not be slaves again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78152,'I will be strong and stand with you!','I will be strong and stand with you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78153,'Here\'s to a less miserable future!','Here\'s to a less miserable future!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78154,'I follow the beating of my heart!','I follow the beating of my heart!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78155,'Work more better!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78156,'Faster pipsqueaks!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78157,'No one blows up MY village! Nobody! Except maybe Kaz. But nobody else!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78158,'Where is Kaz?','Where is Kaz?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78159,'Get me lose and I will speak with your wolf chief.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(78160,'Let\'s go.','Let\'s go.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(78161,'I... feel... better! You\'ve done the right thing! Now I shall go see what your wolf chief has to say.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(78162,'What skulls that are still alive are going to be here. We need to get them out.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78163,'You break the wall, I\'ll break the guard!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78164,'Hi, I can start this race if you ask me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78165,'Yes, please start.','Yes, please start.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78166,'If we don\'t kill more of these goren soon they will forget who we are.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78167,'The world will burn!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78168,'','Exarch, we have to bring the shards to safety. Auchindoun\'s safety is at stake!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78169,'Satisfied for now, Borrok spews forth a massive stone.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(78170,'We cannot hold this point much longer. Make haste, $n!','',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(78171,'The burning corpse of this Laughing Skull orc is beyond saving.','The burning corpse of this Laughing Skull orc is beyond saving.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78172,'This orc seems to have been eating when the attack came.','This orc seems to have been eating when the attack came.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78173,'You thought the eyes of this orc turned to look at you as you approached, but the orc is now clearly dead.','You thought the eyes of this orc turned to look at you as you approached, but the orc is now clearly dead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78174,'Pitiful soft-skins.','',0,0,0,0,0,0,0,0,0,0,41573,0,26124),
(78175,'Jargba, break their will!','',0,0,0,0,0,0,0,0,0,0,41574,0,26124),
(78176,'Aggem, aim for the eyes!','',0,0,0,0,0,0,0,0,0,0,41575,0,26124),
(78177,'Exarch... I... saw one of them walk towards the Shadow Tomb.','Exarch... I... saw one of them walk towards the Shadow Tomb.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78178,'Auchindoun is safe... for now. Unfortunately, I have a feeling our work is far from done.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(78179,'Be careful, $n. If that portal is any indication, great evil may be waiting for you in the tomb.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78180,'The siege is broken! Come, brothers and sisters - drive these orcs from Karabor!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(78181,'','You\'re going to have to trust me. We, too, have been chased across the nether by the Legion. We are here to put a stop to their efforts here before they gain any ground.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(78183,'And they say the same of us. We do not have time for clan rivalries.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78184,'The Laughing Skull are murderous and insane. Durotan, I would advise against this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78186,'They may be mad, but they are the only orc clan familiar with this savage land. We may need to rely upon their knowledge.','',0,0,0,0,0,0,0,0,0,0,45265,0,26124),
(78187,'','You should speak with Nyami as well before you head out.',0,0,0,0,0,0,1,0,0,23412,0,0,26124),
(78188,'I hope you did not spill any of it on your clothes. Demon blood stains, you know.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78189,'How this even work?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78190,'Stupid wheel! Work!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78191,'Me hurt you if you don\'t spin!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78192,'FOODS TIME!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78193,'We offer dis orc to you, Borrok!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78194,'\'Bout time this got here! I was runnin\' outta ogres to kill...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78195,'It appears their leader is headed to the Shadow Tomb, Matriarch. Shall I execute this heathen now?','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(78196,'','No, Mehlar. That is no longer our way. He lives for now.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78197,'My friends ought to keep you occupied.','',0,0,0,0,0,0,0,0,0,0,46224,0,26124),
(78198,'A few moments more, keep my guests entertained.','',0,0,0,0,0,0,0,0,0,0,46225,0,26124),
(78199,'Amnennar will be reborn!','',0,0,0,0,0,0,0,0,0,0,46219,0,26124),
(78200,'','I have a special fire I am saving just for the genesaur. I am going to make him choke on it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78201,'','I am going to BURN all of those plant people to ash and then sprinkle that ash on a piece of meat and then feed that piece of meat to a boar and then set that boar ON FIRE!$b$bAnd THEN I\'ll get started on them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78202,'','Do you burn easily? You should probably keep more water on you. Things are going to get messy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78203,'','This is Gorgrond. Here the sky, the earth, and the water are all made to burn. Shall we light the first spark?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78204,'Test of Gas','Test of Gas',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78205,'Pushing','Pushing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(78206,'Okay, that\'s enough.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78208,'Now\'s our chance to escape!','Now\'s our chance to escape!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78209,'Run for it!','Run for it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78210,'From the dirt and cracks comes the blackest of waters, but do not drink it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78211,'The land of Gorgrond gives much. From its earth comes gas but do not mistake it for steam. These apparitions do not respond well to flames.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78212,'Test of Oil.','Test of Oil.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78213,'Test of Blackrock.','Test of Blackrock.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78214,'The truest test of Gorgrond: the Blackrock. Behold fire made stone.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78215,'You must defeat all three tests. Chose which test you wish to face now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78216,'And what have you learned?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78217,'To respect the elements.','To respect the elements.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78218,'To be careful what weapon to use.','To be careful what weapon to use.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78219,'Gorgrond is dangerous.','Gorgrond is dangerous.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78220,'Wrong! You were supposed to learn that any problem in Gorgrond can be solved by blowing it up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78221,'Karabor stands, for today.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(78222,'Hrahahahaha! *cough* Hee hee. *cough* You... missed me. Filthy Iron Hordies!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78223,'Grant me one request. Grant me revenge!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78224,'I will crush my enemies and see them driven before me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78225,'I miss the smell of fresh wind before a storm...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78226,'You will not die today, champion!','You will not die today, champion!',0,0,0,0,0,0,1,0,4,0,45649,45649,26124),
(78227,'Let the Light heal your wounds!','Let the Light heal your wounds!',0,0,0,0,0,0,1,0,4,0,45650,45650,26124),
(78228,'The Light protects its champions.','The Light protects its champions.',0,0,0,0,0,0,1,0,4,0,45651,45651,26124),
(78229,'Thank you, $n. I will meet you back at Twilight Glade.','Thank you, $n. I will meet you back at Twilight Glade.',0,0,0,0,0,0,1,0,4,0,45655,45655,26124),
(78230,'When the deed is done, leave the dead and bring the masks. Join us at the ruin of Laughing Skull.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78231,'<whispered> Hey, wait. I wouldn\'t go in there. I think our boys may all be dead.','<whispered> Hey, wait. I wouldn\'t go in there. I think our boys may all be dead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78232,'You\'re cannon is down. Soon your base will be gone, $pc!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78233,'Just enough time to kill you on the way out, $pc.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78234,'You weren\'t in the mission plan.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78235,'Too late. Your defenses are down.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78236,'Our cannon\'s bigger than yours, $pr.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78237,'Good. A challenge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78238,'More collateral damage.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78239,'Intel didn\'t mention a $pc.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78240,'Your base\'s time has run out.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78241,'Nothing changes. Our next shot will...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78242,'Get moving you mangy beast!','',0,0,0,0,0,0,0,0,0,23452,0,0,26124),
(78243,'I don\'t care if your mate is dead, beast! We have a war to finish!','',0,0,0,0,0,0,0,0,0,23452,0,0,26124),
(78244,'Get up, beast! You are making me look bad in front of the Blackrock.','',0,0,0,0,0,0,0,0,0,23452,0,0,26124),
(78245,'Get to |cFF00FF00|Hspell: 150665|h[Redeemed Soil]|h|r to break %s\'s |cFFFF0000|Hspell:150679|h[Soul Leech]|h|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78247,'Defeat Ignaeus to remove Gorr\'thog\'s shield!','Defeat Ignaeus to remove Gorr\'thog\'s shield!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78248,'Gorr\'thog is afflicted by |cFFFF0000|Hspell:151217|h[Elemental Overload]|h|r! Finish him!','Gorr\'thog is afflicted by |cFFFF0000|Hspell:151217|h[Elemental Overload]|h|r! Finish him!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78249,'','Help! Someone help!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(78250,'','Thank the... Light... I found you.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78251,'','Telmor... attacked...',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(78252,'','They... demons...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78253,'','Laughing Skull! Durotan, we must move on before we are discovered.',0,0,0,0,0,0,0,0,0,0,0,44743,26124),
(78254,'What?! By who? Who did this?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78255,'Tell me, mongrel! Where is Vorpil?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78256,'You\'re wasting your time... we\'ve already won.','',0,0,0,0,0,0,11,0,0,0,0,0,26124),
(78257,'Here, $n, take some of the explosives. Just  place them on the front of a war machine... then run!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78258,'Not sure what I expected.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78259,'These peasants had nothing worth taking.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78260,'Who\'s laughing now?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78261,'That Goliath Cannon destroyed more than we thought it would.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78262,'Ugh. Why would they keep this?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78263,'*cough* Hee hee... *cough* *gasp*','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78264,'Filthy... *cough* ... Iron Hordies!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78265,'What...*cough* what was that... *cough* it burns...*gasp*.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78266,'','Enough, Mehlar! I order you to stop.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78267,'','Bring him some water and untie him. Followers of the Light do not act this way.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78268,'Fine, Liadrin. I\'ll talk... in exchange for my freedom.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78269,'*cough* I... exploded! *cough*','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78270,'Filthy Iron Hordies...*cough* cheated!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78271,'Witness the TRUE power of the Iron Horde!','',0,0,0,0,0,0,0,0,0,0,43658,0,26124),
(78272,'The skies darken with iron!','',0,0,0,0,0,0,0,0,0,0,43659,0,26124),
(78273,'Look! Fire!','Look! Fire!',0,0,0,0,0,0,0,0,4,0,43219,43219,26124),
(78274,'','Very well. Now, where is your base?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78275,'Due west of Auchindoun, north of Telmor.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(78276,'Not that it matters. Telmor\'s portal is shielded. You\'ll never make it to the Grandmaster.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(78277,'I\'m strongest podling in Gorgrond. Stick with me. I keep you safe.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78278,'You\'re gonna DIE, Rocker!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78279,'I guess you can come along.','I guess you can come along.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78280,'Wrahahahahahaha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78281,'Hee hee! Hee HEE! HRAHAHA! HAHA! HAHA!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78282,'Invite Jagahari?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78283,'Stabbing time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78285,'Soldiers - Come to my aid!','',0,0,0,0,0,0,0,0,0,0,43660,0,26124),
(78286,'Hansel, D\'kaan... we\'re leaving now. It\'s time to defeat the Iron Horde. It\'s time to gain vengeance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78287,'Ah! $p of the Not-Here, Not-Now Place. My rock said you would come. Where is your pack of wolves?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78288,'Bah. You are too cautious. I will gather our warriors and do it myself!','',0,0,0,0,0,0,396,0,0,0,44068,0,26124),
(78289,'The citadel is ours! Come, brother - we press the attack!','',0,0,0,0,0,0,396,0,0,0,44067,0,26124),
(78290,'Contact! I found a survivor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78291,'There is something alive over here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78292,'I got a live one over here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78293,'Survivor found!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78294,'Help me. I feel so weak... need water.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78295,'Revive Jagahari by rubbing muddy water on his leaves.','Revive Jagahari by rubbing muddy water on his leaves.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78296,'Revive Jagahari?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78297,'Aaauuughh!','Aaauuughh!',0,0,0,0,0,0,0,0,4,0,43220,43220,26124),
(78298,'No, Ga\'nar. We are surrounded and exposed. We must fortify.','',0,0,0,0,0,0,396,0,4,0,45196,0,26124),
(78299,'Reckless brother!','',0,0,0,0,0,0,396,0,4,0,45197,0,26124),
(78300,'Smart move, $n. I meet you back at caravan.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78301,'O\'re atal\'sha! For the Light!','O\'re atal\'sha! For the Light!',0,0,0,0,0,0,1,0,4,0,45652,45652,26124),
(78302,'We will not yield!','We will not yield!',0,0,0,0,0,0,1,0,4,0,45653,45653,26124),
(78303,'Forward! For Karabor!','Forward! For Karabor!',0,0,0,0,0,0,1,0,4,0,45654,45654,26124),
(78304,'','I see... the clan\'s ancestors forbade the use of void magic. So why has Ner\'zhul broken their ancient laws?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78305,'Let\'s go.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78306,'Prepare to be burned alive!','',0,0,0,0,0,0,0,0,0,0,43671,0,26124),
(78307,'Taste the flames!','',0,0,0,0,0,0,0,0,0,0,43672,0,26124),
(78308,'I\'ll burn the ground beneath your feet.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78309,'The Iron Horde... will... take you all...','',0,0,0,0,0,0,0,0,0,0,43673,0,26124),
(78310,'Guardians of Auchindoun, let this square be cleansed!','',0,0,0,0,0,0,0,35,0,0,0,0,26124),
(78311,'Spirits of our ancestors, rid this land of its torment!','',0,0,0,0,0,0,0,35,0,0,0,0,26124),
(78312,'By my oath, I will not let our spirits be tormented!','',0,0,0,0,0,0,0,35,0,0,0,0,26124),
(78313,'No please! I don\'t want to die like this!!!','',0,0,0,0,0,0,0,0,0,0,43728,0,26124),
(78314,'','The sacrifice is complete! Grant me your power, Aku\'mai! AHAHAHAHA!!!',0,0,0,0,0,0,0,0,1,0,0,45731,26124),
(78315,'I will see to matters here briefly. I\'ll meet you at the staging grounds.','',0,0,0,0,0,0,1,35,0,0,0,0,26124),
(78316,'Deathgonia family will be sorry they messed with Jagahari!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78317,'My shield! Give me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78318,'Online.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78319,'Demonic energy detected. Cleansing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78320,'Processing fel energies. Standby.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78321,'Purification module activated.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78322,'Objective complete. Instructions to user to meet at staging area. Over.','',0,0,0,0,0,0,1,35,0,0,0,0,26124),
(78323,'The blast was larger than anticipated. Blackhand will be pleased.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78324,'One shot, one clan killed. Hrah ha ha ha.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78325,'The Laughing Skull won\'t be laughing anymore after this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78326,'A flawless test of the Goliath Cannon. It is finally ready for full production.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78327,'I told the commander we should have just fired the cannon first. We could have avoided this pitiful last stand from the Laughing Skull all together.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78328,'This proves it. Once the Goliath Cannon is ready to move we can hit those mangy Frostwolves with the full strength of the Iron Horde.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78329,'Get up, beast! Get up and fight!','',0,0,0,0,0,0,0,0,0,23452,0,0,26124),
(78330,'I am not about to let you embarrass me in front of the Iron Horde!','',0,0,0,0,0,0,0,0,0,23452,0,0,26124),
(78331,'Show some pride you mangy beast! Lets show them why the Thunderlords belong in the Iron Horde!','',0,0,0,0,0,0,0,0,0,23452,0,0,26124),
(78332,'Ogre attack!','Ogre attack!',0,0,0,0,0,0,0,0,0,0,39974,39974,26124),
(78333,'Regroup!','Regroup!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78334,'Fall back!','Fall back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78335,'They counterattack!','They counterattack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78336,'There is much to be done. Taalo, see that the troops are healed and rested.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(78337,'Bah! Time to remind my beast how to kill.','',0,0,0,0,0,0,0,0,0,23452,0,0,26124),
(78338,'Looks like my beast is going to be feeding well tonight!','',0,0,0,0,0,0,0,0,0,23452,0,0,26124),
(78339,'|cff71d5ff|Hspell:149587|h[Race Complete]|h|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78340,'Placing Resonator Crystal','Placing Resonator Crystal',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(78341,'I use this club to smash Deathgonia face!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78342,'Jagahari? You leave now or I kill you!','',0,0,0,0,0,0,0,0,0,23508,0,0,26124),
(78343,'He dead? Good!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78344,'Disengaging','Disengaging',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(78345,'Guards! Stop yapping, start smashing!','',0,0,0,0,0,0,0,0,0,0,41647,0,26124),
(78346,'Trial Complete!','Trial Complete!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78347,'Trial Failed!','Trial Failed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78348,'You cheating cheater!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78349,'Me stop them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78350,'We make them pay!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78351,'My slaves! Those were Bloodmaul property!','',0,0,0,0,0,0,0,0,0,0,41648,0,26124),
(78352,'Jagahari? You banished. How dare you return!','',0,0,0,0,0,0,0,0,0,23508,0,0,26124),
(78353,'Jagahari? You were banished. How dare you return to our land!','',0,0,0,0,0,0,0,0,0,23508,0,0,26124),
(78354,'Don\'t be scared. I protect you.','Don\'t be scared. I protect you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78355,'Deathgonia family will die!!','Deathgonia family will die!!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78356,'Follow me.','Follow me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78357,'It\'s good I\'m here. I protect you.','It\'s good I\'m here. I protect you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78358,'Banished? I show them banished.','Banished? I show them banished.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78359,'Jagahari? You little peck. You think you can defeat me?','',0,0,0,0,0,0,0,0,0,23513,0,0,26124),
(78360,'Whoa! I got him! Did you see that?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78361,'You wreck Thruk\'s catch of legendary guardian crab! Thruk fillet you now!','',0,0,0,0,0,0,0,0,0,0,46794,0,26124),
(78362,'Maraad\'s grumpier than ever. He\'s really worried about Yrel.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78363,'Did you see my Tank? It\'s the best thing I\'ve ever built.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78364,'What happened to Hansel\'s wife is horrible. It\'s why he hates the orcs so much.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78365,'D\'kaan\'s so mysterious. All those draenei rangers are.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78366,'I\'m glad you\'re here. If we don\'t destroy the Iron Horde\'s big war machine, we\'re all dead!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78367,'AHH! Don\'t hurt me!','',0,0,0,0,0,0,0,0,0,23508,0,0,26124),
(78368,'Not in the face!','',0,0,0,0,0,0,0,0,0,23508,0,0,26124),
(78369,'It\'s not my fault! $n made me do it!','',0,0,0,0,0,0,0,0,0,23508,0,0,26124),
(78370,'Ever since our king die the Spinebloom tribe is broken.$b$bDeathgonia family and they goons banish or kill all podlings that challenge them.$b$bThey say they family new leaders? They say they new kings of Spinebloom? Guess again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78371,'Is there no place left for us?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78372,'First they discard us, now they come to dispose of us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78373,'A thousand curses upon Arak!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78374,'Hmm. Is that $g cologne : perfume; I smell?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78375,'Pin them down! Let none of them pass!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78376,'Fall back to the sanctum, Lord Bathiel\'s ritual must not be disturbed! Thruk, do not let them past!','',0,0,0,0,0,0,0,0,0,0,43553,0,26124),
(78377,'Thruk want Guardian treasure!','',0,0,0,0,0,0,0,0,0,0,46796,0,26124),
(78378,'Nooooooooooooooooooooooooooo!','Nooooooooooooooooooooooooooo!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78379,'Iron Hordies win. Get this off me and we are outta here! Abandon village!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78380,'','Oh please, you must save the others before Domina sacrifices them!',0,0,0,0,0,0,0,0,0,0,0,46815,26124),
(78381,'Follow me when you are ready.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78382,'Over hee hee here. Over hee hee here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78383,'Hrahahhahahehehheeheheheee... This way.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78384,'Artifacts from the greatest age belong to us! You have no claim to them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78385,'No... the prism...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78386,'Bah! I loathe caves; I can barely see a thing down here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78387,'Agreed. And it reeks of the low races.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78388,'Slaves who try to escape go one place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78389,'Please no! I won\'t try to escape again!','Please no! I won\'t try to escape again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78390,'I\'m your worst nightmare...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78391,'','Gah! He tried to stab me! I told you we couldn\'t trust the Laughing Skulls.',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(78392,'Limbflayer forgot to be nice. I saw pretty orc. I wanted to see if she could dance. Sorry. Sorry.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(78393,'I have come to hunt the Iron Horde. I could destroy what remains of your ruined village, or perhaps we could assist one another.','',0,0,0,0,0,0,0,0,7,0,45266,0,26124),
(78394,'Yes, wolves and skulls need each other. You need to know where the big Iron Hordy weapon is at. We need your $p.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(78395,'Defend the Kraul with your life!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78396,'You have proven yourself loyal to my clan. Capable of great things.','',0,0,0,0,0,0,396,0,4,0,45198,0,26124),
(78397,'Our hold on Bladespire is tenuous, and some of my best warriors have raced off with my reckless brother.','',0,0,0,0,0,0,396,0,4,0,45199,0,26124),
(78398,'I was impressed by your skill in our battle against Dorogg the Ruthless.','',0,0,0,0,0,0,396,0,4,0,45200,0,26124),
(78399,'I would be honored if you continued to fight by our side.','',0,0,0,0,0,0,396,0,4,0,45201,0,26124),
(78400,'','So, this is what they were after... Thank you for clearing the way.',0,0,0,0,0,0,0,0,0,0,0,45909,26124),
(78401,'<The prism hums with energy. It could be salvaged, though the strange machine it once powered - perhaps a devastating weapon, or some kind of depraved torture device - looks to be completely ruined.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78402,'Now just relax, $p. You and I are going to have a chat.','',0,0,0,0,0,0,0,0,0,0,46303,0,26124),
(78403,'Destroy that wretched prism! We cannot risk it falling into their hands.','',0,0,0,0,0,0,0,0,0,0,46304,0,26124),
(78404,'Aku\'mai, kill them all!','',0,0,0,0,0,0,0,0,0,0,46102,0,26124),
(78405,'What precious treasures my murlocs have lured to me.','',0,0,0,0,0,0,0,0,1,0,46101,0,26124),
(78406,'Arise, Aku\'mai, and feed!','',0,0,0,0,0,0,0,0,0,0,46103,0,26124),
(78407,'Forgive my deception. I had to appeal to your sympathy in order to play you against Kairyx.','',0,0,0,0,0,0,0,0,0,0,46306,0,26124),
(78408,'I half-expected him to vaporize you, but you dispatched him quite handily. An impressive display...','',0,0,0,0,0,0,0,0,0,0,46307,0,26124),
(78409,'You did it. It\'s firing again!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78410,'I saw the blast. I SAW it. The scream of the elements as their combined essences were ripped asunder and turned into a weapon of destruction. Such a weapon must not exist!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78411,'The Laughing Skulls have agreed to help.','The Laughing Skulls have agreed to help.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78412,'It has been a long time since I was in the presence of the Laughing Skull. I remember them being taller.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78413,'Everything is ready.','Everything is ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78414,'Have you all of the things?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78415,'','The mighty Durotan descends from his mountain without an army. It would seem you have grown tired of living.',0,0,0,0,0,0,0,0,0,0,0,46175,26124),
(78416,'Iron will, iron blood!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78417,'The Iron Horde will consume you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78418,'Nothing can stop the Iron Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78419,'I will CRUSH you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78420,'Iron will, iron blood!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78421,'The Iron Horde will consume you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78422,'Nothing can stop the Iron Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78423,'Come, puny $r. Come and die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78425,'Though... it was your decision to enter the mine that truly piqued my interest. Your desire to reveal the truth behind the attack.','',0,0,0,0,0,0,0,0,0,0,46308,0,26124),
(78427,'<Cough> Need muddy water... up the hill... <Cough>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78428,'With dying breath... me hate you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78429,'Wow... I still in shock.$b$bI was amazing.$b$bYou need my help or not? I\'m sure you do.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78430,'... wheel...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78431,'','Who dares interrupt my sacrifice?! Slay them!',0,0,0,0,0,0,0,0,1,0,0,45732,26124),
(78432,'','My flesh will be claimed by the Old Gods...',0,0,0,0,0,0,0,0,0,0,0,45730,26124),
(78433,'I was hoping you would make it to me. Now I get the pleasure of removing your heads!','',0,0,0,0,0,0,0,0,0,0,43548,0,26124),
(78434,'I delayed you long enough... Aku\'mai will rise...','',0,0,0,0,0,0,0,0,0,0,43549,0,26124),
(78435,'Thruk... want... Guardian... TREASURE!','',0,0,0,0,0,0,0,0,0,0,46795,0,26124),
(78436,'Ahh, these will be worthy companions for the long journey home.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78437,'Perhaps we shall meet again, yes?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78438,'%s spits on the ground.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78439,'<ptah!> Good riddance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78440,'Guess I\'d better find a way to make myself useful. Do you think a blind old warrior can still make a difference?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78441,'Remember, $p: the sun burns the flesh. Only in shadow will you find refuge.','',0,0,0,0,0,0,1,0,0,0,46311,0,26124),
(78442,'You\'ve won nothing, fools. Aku\'mai arises!','',0,0,0,0,0,0,0,0,0,0,45758,0,26124),
(78443,'You are too late, heroes, the summoning of Aku\'mai is complete.','',0,0,0,0,0,0,0,0,0,0,45759,0,26124),
(78444,'Unfortunately, you will not live long enough to behold his glory. Finish them!','',0,0,0,0,0,0,0,0,0,0,45760,0,26124),
(78445,'Before I kill you know this, heroes. Aku\'mai will devour this world!','',0,0,0,0,0,0,0,0,0,0,45757,0,26124),
(78446,'You are unworthy of being devoured by Aku\'mai. Instead, our sacrifices shall tear the flesh from your bones.','',0,0,0,0,0,0,0,0,0,0,43269,0,26124),
(78447,'Our herald, Aku\'mai, arises from the depths. You have earned the honor of being the first he devours.','',0,0,0,0,0,0,0,0,0,0,43270,0,26124),
(78448,'Mushlump play with squishy-squishy!','',0,0,0,0,0,0,0,0,0,0,43569,0,26124),
(78449,'You give Mushlump owie...','',0,0,0,0,0,0,0,0,0,0,43570,0,26124),
(78450,'Splat!','',0,0,0,0,0,0,0,0,0,0,43571,0,26124),
(78451,'Crunch!','',0,0,0,0,0,0,0,0,0,0,43572,0,26124),
(78452,'Playtime over for you!','',0,0,0,0,0,0,0,0,0,0,43573,0,26124),
(78455,'Ha! This catch be too puny.','',0,0,0,0,0,0,0,0,0,0,46797,0,26124),
(78456,'Thruk is hooked on you!','',0,0,0,0,0,0,0,0,0,0,46798,0,26124),
(78457,'This catch be too ugly to eat.','',0,0,0,0,0,0,0,0,0,0,46799,0,26124),
(78458,'Ramtusk has fallen! We must protect the Crone!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78459,'The Prophet will kneel before us...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78460,'Commander Vorka will lead us to victory...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78461,'More of my kind await... in... Grommar....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78462,'We will unite the clans, and slay all who oppose us...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78463,'No more! Please, I beg you! Don\'t kill me! I surrender!','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78464,'I will block the temple against any more damage.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(78465,'Go, $n. I will hold the temple gates!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(78466,'Mok\'luk smash!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78467,'Me flatten you punies!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78468,'SMASH SMASH SMASH!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78469,'Catch this you puny!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78470,'Haha puny got smashed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78471,'Puny been smashed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78472,'Smash everything!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78473,'Me... get... smashed?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78474,'Slaves no work, slaves get SMASHED!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78476,'Eek eeper eek!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78477,'Squeaken eep!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78478,'Squeakity squeak!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78479,'Squeaker eek squeak!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78480,'Eeper squeak!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78481,'Soon Amnennar will return!','',0,0,0,0,0,0,0,0,0,0,45956,0,26124),
(78482,'Our conquest of Kalimdor begins and nothing will survive our wrath!','',0,0,0,0,0,0,0,0,0,0,45957,0,26124),
(78484,'You make better firewood than miner!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78485,'AHHHHHHHHHHHHHHHHHHHHHHHHHH!','AHHHHHHHHHHHHHHHHHHHHHHHHHH!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78486,'','Please, help! We barely escaped the Twilight\'s Hammer sacrificial altar.',0,0,0,0,0,0,0,0,0,0,0,44671,26124),
(78487,'Look out!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(78488,'Rooter stares at you thoughtfully-then sneezes up a piece of ham.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78489,'Rooter wiggles his tail and drools; this would probably be cute if he wasn\'t farting and burping at the same time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78490,'Pet Rooter?','Pet Rooter?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78491,'Pet Rooter?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78492,'Augh! Noooooo...','',0,0,0,0,0,0,0,0,0,0,42052,0,26124),
(78493,'I will be your shield!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78494,'My life for the flame!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78495,'Torch it all! For the glory of Rukhmar!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78496,'Purge these heathens!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78497,'WHAT? You said this base was secure!','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78498,'I have a wide selection of slaves for sale. In fact, I just acquired a particularly feisty draenei female you may be interested in.','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78499,'I\'m given to understand you\'re having some trouble with the... what do you call them? Dwarves? Nasty, small creatures. We have a few for sale if you\'re interested.','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78500,'Iron Horde, iron dwarves... a perfect match. Purchase some. If nothing else, you can load them into your war machines and fire them back at their Bastion Rise.','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78501,'The Imperion Slavers\' Guild is always interested in cultivating relationships with our good friends the Iron Horde. For you, my deepest discounts and best slaves.','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78502,'We could not help but notice your \"prototype\" war machine. No doubt, Bastion Rise will be no more very soon. We are happy to call the Iron Horde our friends.','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78503,'So soon? What happened to the last batch of slaves we sold you just yesterday? No matter. There are more. There are always more.','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78504,'First the Laughing Skull are wiped out and soon these tiny dwarves at Bastion Rise. The Iron Horde are truly gifted where the waging of war is concerned.','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78505,'You are by far the best customers I have ever had the pleasure of dealing with. Would you like to open a line of credit, or do you prefer to pay in black rock again? Gold perhaps?','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78506,'I have a wide selection of slaves for sale. In fact, I just acquired a particularly dangerous blademaster you may be interested in. He\'s very deadly and would make an excellent warrior.','',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(78507,'I\'m given to understand your troubles with the Laughing Skull clan are at an end. We have a few survivors for sale if you\'re interested.','',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(78508,'No doubt, the Iron Horde will want to purchase our remaining Laughing Skulls. If nothing else, you can load them into your war machines and fire them for target practice.','',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(78509,'The Imperion Slavers\' Guild is always interested in cultivating relationships with our good friends the Iron Horde. For you, my deepest discounts and best slaves.','',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(78510,'We could not help but notice your \"prototype\" war machine. The destruction of the Laughing Skull village was quite impressive. We are happy to call the Iron Horde our friends.','',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(78511,'So soon? What happened to the last batch of slaves we sold you just yesterday? No matter. There are more. There are always more.','',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(78512,'First the Laughing Skull are wiped out and soon these tiny dwarves at Bastion Rise. The Iron Horde are truly gifted where the waging of war is concerned.','',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(78513,'You are by far the best customers I have ever had the pleasure of dealing with. Would you like to open a line of credit, or do you prefer to pay in black rock again? Gold perhaps?','',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(78514,'More slaves!','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78515,'We have much black rock to buy slaves with!','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78516,'Your slaves die quickly. We want better slaves, ogre!','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78517,'You talk too much. Less talk, more slaves!','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78518,'Maybe we will fire the Goliath prototype at your slave pen?!','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78519,'Your slaves cost too much already and die far too quickly!','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78520,'All will feel the might of the Iron Horde. Even the ogres, if your slaves do not improve!','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78521,'Your slaves are all dead! Why would I buy more?','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78522,'I\'m certain we can come to a mutually beneficial arrangement.','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78523,'Of course, of course, my friend. No worries.','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78524,'No need to be upset, my friend. We will make sure you receive only the toughest slaves.','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78525,'Of course, you are quite right, my capable orc friend. Quite right.','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78526,'I shall redouble my efforts to address all of your concerns.','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78527,'Iron will, iron blood!','Iron will, iron blood!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78528,'The Iron Tide will consume you!','The Iron Tide will consume you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78529,'The slavers\' guild is only too happy to meet your needs.','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78530,'Intruders!','Intruders!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78531,'I couldn\'t agree more. Just let me know when you\'d like to come see our wares.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78532,'No need for ire. You and I are friends. We respect the might of the Iron Horde.','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78533,'I lapped a clefthoof the other day. Hrah ha ha.','I lapped a clefthoof the other day. Hrah ha ha.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78534,'You ever fix that lame wheel of yours?','You ever fix that lame wheel of yours?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78535,'How fast you get that thing going? Outrun any farah yet?','How fast you get that thing going? Outrun any farah yet?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78536,'That\'s because the beast was standing still.','That\'s because the beast was standing still.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78537,'You ever fix that lame face of yours?','You ever fix that lame face of yours?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78538,'At least I got it to start, which is more than you can claim.','At least I got it to start, which is more than you can claim.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78539,'What is the meaning of this?! I am an official of the Imperion Slavers\' Guild!','',0,0,0,0,0,0,0,0,0,23648,0,0,26124),
(78540,'','Thank you brave heroes.  Without your help Amnennar would have returned to Azeroth and brought untold horrors with him.$b$bI will return this dangerous artifact to my brothers and sisters of the red dragonflight.  Perhaps we can find a way to destroy it.$b$bI am in your debt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78541,'<This Iron Horde scouting party appears to have been incinerated in the arakkoa attack on Aruuna.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78542,'Search the body.','Search the body.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78543,'Hold steady, damned beast!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(78544,'Subdue it already, you worthless excuses for orcs!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(78545,'We need this thing to pull the cannon out. Faster!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(78546,'Your bones will be added to this pile!  Burn!','',0,0,0,0,0,0,0,0,0,0,45954,0,26124),
(78547,'Too hot for you?','',0,0,0,0,0,0,0,0,0,0,45958,0,26124),
(78548,'Another soldier for Amnennar\'s army.','',0,0,0,0,0,0,0,0,0,0,45959,0,26124),
(78549,'You\'ll dance with the rest!','',0,0,0,0,0,0,0,0,0,0,45960,0,26124),
(78550,'Death is only the beginning!','Death is only the beginning!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78551,'Savor your death, mortal. The Dark Star beckons!','Savor your death, mortal. The Dark Star beckons!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78552,'My life for Ner\'zhul!','My life for Ner\'zhul!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78553,'More souls for the taking!','More souls for the taking!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78554,'','Maintain... focus...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78555,'','Focus your power...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78556,'','It is... too... strong...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78557,'Hah! |5$pr from the other world? Throm-Ka, $pc! Ahahahahahahaha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78558,'','The stones did not tell of this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78560,'Iron will, iron blood!','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(78561,'No one touches Bertha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78562,'Get away from my girl!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78563,'No one looks at my roller like that! No one!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78564,'Burry me... with.. my Bertha...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78565,'I will still serve in death!','I will still serve in death!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78566,'I have been chosen!','I have been chosen!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78568,'I return to the earth...','',0,0,0,0,0,0,0,0,0,0,41728,0,26124),
(78569,'Yes! My flesh is for Aku\'mai!','Yes! My flesh is for Aku\'mai!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78570,'Ugg... we kill you all for this...','',0,0,0,0,0,0,0,0,0,0,41646,0,26124),
(78572,'|cFFF00000Slagna|r rises from the lava!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78573,'%s spits blood.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(78574,'','Fan out! Leave nothing alive!',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(78575,'','Let\'s do this!',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(78576,'','Woohoo! We did it! That was so cool!',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(78577,'','I\'m going to go back to my father. I\'ll meet you there!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78578,'','By the Light... they\'re slaughtering everything!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(78579,'A shadow is growing beneath the spires...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78580,'Iskar will guide us to freedom.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78581,'I shall not forget this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78582,'We can hide from them no longer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78583,'Live to fight another day? Don\'t mind if I do.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78584,'Bank','Bank',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(78585,'','I think I can shut this thing off. Just give me a minute!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78587,'You be lookin\' for de bank mon?  You be followin\' the road to de north all de way to Orgrimmar.  Speak to de guards there and they can help ya.','You be lookin\' for de bank mon?  You be followin\' the road to de north all de way to Orgrimmar.  Speak to de guards there and they can help ya.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78588,'Ya be a long way off mon.  De bank be in Orgrmmar.  Follow de road to de north, ya can\'t miss de place.','Ya be a long way off mon.  De bank be in Orgrmmar.  Follow de road to de north, ya can\'t miss de place.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78589,'Lookin\' for a ride eh?  Burok be at the southern end of town, next to de wind riders.','Lookin\' for a ride eh?  Burok be at the southern end of town, next to de wind riders.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78590,'De inn be just north of de road leading to de Barrens.  Grosk be helpin\' ya out.','De inn be just north of de road leading to de Barrens.  Grosk be helpin\' ya out.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78591,'Havin\' some furry friends needin\' a place to stay? Shoja\'my, outside of de inn, can help.','Havin\' some furry friends needin\' a place to stay? Shoja\'my, outside of de inn, can help.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78592,'You be needin\' to see a trainer, mon?','You be needin\' to see a trainer, mon?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78593,'Jabul, can help you.  He\'s been givin\' new druids trainin\' for years now.','Jabul, can help you.  He\'s been givin\' new druids trainin\' for years now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78594,'The Hunter Trainer\'s name is Thotar.  Seek him out inside the burrow on the southwest corner of Razor Hill.','The Hunter Trainer\'s name is Thotar.  Seek him out inside the burrow on the southwest corner of Razor Hill.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78595,'Ah, ya be after de mojo, eh?  Un\'Thuwa can teach you.  Ya be findin\' him near the entrance to the barracks.','Ah, ya be after de mojo, eh?  Un\'Thuwa can teach you.  Ya be findin\' him near the entrance to the barracks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78596,'Ya be lookin\' for Tai\'jin then. She be spendin\' most of her time in de barracks.','Ya be lookin\' for Tai\'jin then. She be spendin\' most of her time in de barracks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78597,'Kaplak be da orc you be lookin\' for mon.  He be in de burrow south of da inn.','Kaplak be da orc you be lookin\' for mon.  He be in de burrow south of da inn.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78598,'Swart be communin\' wit de elements inside of da barracks.  It be de large building in de center of town.','Swart be communin\' wit de elements inside of da barracks.  It be de large building in de center of town.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78599,'Lookin\' for Dhugru Gorelust eh?  He be practicin\' his craft behind de barracks.','Lookin\' for Dhugru Gorelust eh?  He be practicin\' his craft behind de barracks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78600,'You be messin\' with some bad mojo mon, but Dhugru be behind de barracks.','You be messin\' with some bad mojo mon, but Dhugru be behind de barracks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78601,'De warrior trainer, Tarshaw Jaggedscar, be inside de barracks on de east side of town.','De warrior trainer, Tarshaw Jaggedscar, be inside de barracks on de east side of town.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78602,'Runda be de one person you be needin\' to talk to.\n\nShe be just north of de barracks entrance.','Runda be de one person you be needin\' to talk to.\n\nShe be just north of de barracks entrance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78603,'Hammer and tongs, beat to this song...s, stoke the fire higher.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78604,'What cha be lookin\' for mon?','What cha be lookin\' for mon?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78605,'Bring down, the hammer ...um... frown, and make the sparks fly higher.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78606,'Smelly smelting, smelly smelting, no air must be in the iron.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78607,'Hey! You are not supposed to be in here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78608,'This is MY foundry!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78609,'Who dares interrupt my smelting!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78610,'Lookin\' for Kaplak eh?  Ya be keepin\' your eyes on your coin if ya visit with dat one.','Lookin\' for Kaplak eh?  Ya be keepin\' your eyes on your coin if ya visit with dat one.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78612,'Your land will succumb to the Iron Tide.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78613,'The nearest bank is in Orgrimmar.  Follow the road north and you cannot miss the big gates leading to the city.','The nearest bank is in Orgrimmar.  Follow the road north and you cannot miss the big gates leading to the city.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78614,'','We did it! Hopefully we can clean the water quickly so we can regrow the crops!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78615,'Burok can be found near the wind riders on the southern end of town.  He can take you where you need to go.','Burok can be found near the wind riders on the southern end of town.  He can take you where you need to go.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78616,'Grosk and his inn can be found in the northwest corner of Razor Hill.','Grosk and his inn can be found in the northwest corner of Razor Hill.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78617,'Shoja\'my is the one you are looking for.  He is just outside of the inn.','Shoja\'my is the one you are looking for.  He is just outside of the inn.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78618,'Which trainer do you seek?','Which trainer do you seek?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78619,'Jabul has trained many, perhaps he can help you too.','Jabul has trained many, perhaps he can help you too.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78620,'You seek bigger game?  Perhaps Thotar can teach you what you need to know.  He can be found inside the burrow on the southwest corner of Razor Hill.','You seek bigger game?  Perhaps Thotar can teach you what you need to know.  He can be found inside the burrow on the southwest corner of Razor Hill.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78621,'You seek knowledge of the powers of magic.  There are many things Un\'Thuwa can teach you.  Find him just north of the entrance to Razor Hill\'s barracks.','You seek knowledge of the powers of magic.  There are many things Un\'Thuwa can teach you.  Find him just north of the entrance to Razor Hill\'s barracks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78622,'Tai\'jin can be found inside the barracks, the largest building in town.','Tai\'jin can be found inside the barracks, the largest building in town.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78623,'You seek Kaplak.  He can be found in the burrow in the southwest area of Razor Hill.  Do not take your eyes off of that one for a second.','You seek Kaplak.  He can be found in the burrow in the southwest area of Razor Hill.  Do not take your eyes off of that one for a second.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78624,'Swart is inside the barracks, on the east side of Razor Hill.','Swart is inside the barracks, on the east side of Razor Hill.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78625,'Dhugru Gorelust hides behind the barraks on the east side of town practicing his craft.','Dhugru Gorelust hides behind the barraks on the east side of town practicing his craft.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78626,'If it is sparring lessons you are looking for Tarshaw Jaggedscar can be found in the barracks on the east side of town.','If it is sparring lessons you are looking for Tarshaw Jaggedscar can be found in the barracks on the east side of town.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78627,'Earth Mother watch over you traveler, what is it you seek?','Earth Mother watch over you traveler, what is it you seek?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78628,'Look for Runda.\n\nShe\'s usually just north of the barracks entrance.','Look for Runda.\n\nShe\'s usually just north of the barracks entrance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78629,'','Almost done. Hold on!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78630,'Stop them! Make them slaves!','',0,0,0,0,0,0,0,0,2,0,0,0,26124),
(78631,'Iron will, iron blood!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78632,'Death is your only option.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78633,'Oh yah! Come ta papa, ya scummy orc bastich!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78634,'Curse you, dwarf!','',0,0,0,0,0,0,0,1,0,23617,0,0,26124),
(78635,'Somebody, come quickly! Please!','',0,0,0,0,0,0,22,0,0,23614,0,0,26124),
(78636,'May the birds of Gorgrond feast on your bones!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78637,'The ogre will have chains and manacles you can secure him with. Poetic when you think about it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78638,'','You\'ll die for those refugees, fool.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78639,'Grrowl!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78640,'Seek the shadows -- someone approaches.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78641,'The plague mists barring Koristrasza\'s passage begin to dissipate.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78642,'It\'s not safe, Skreek! Get back in your cage before they see you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78643,'Our reinforcements should be here soon. Get moving!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(78644,'I want a report on the draenei movements every half hour.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(78645,'We will slaughter every last one of them. Blood will run.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(78646,'4...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78647,'3...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78648,'1...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78649,'GO!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78650,'Get ready to race!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78651,'First the iron horde destroyed Tuurem, now podlings are here. Will it ever end?','First the iron horde destroyed Tuurem, now podlings are here. Will it ever end?',0,0,0,0,0,0,547,0,0,0,0,0,26124),
(78652,'2...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78653,'We will have water soon, friends. I will not fail you again.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78654,'','Thank you, $p. Feeding all of these people is hard work!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78655,'Please hurry. I don\'t know what I would do if something happened to her.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78656,'','blah blah blah',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78657,'There is a draenei female back at our slave pens. We captured her yesterday. Perhaps you would trade my life for hers?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78658,'You got the drop on me, $r. Next time, you won\'t be so lucky.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78659,'The iron horde followed us here! What do we do now?','The iron horde followed us here! What do we do now?',0,0,0,0,0,0,547,0,0,0,0,0,26124),
(78660,'I\'ll take care of him, $n. The others were asking after you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78661,'An eternity in darkness... cannot... escape...','An eternity in darkness... cannot... escape...',0,0,0,0,0,0,274,0,0,0,42013,42013,26124),
(78662,'Ner\'zhul will not hear us, he hears only darkness now.','Ner\'zhul will not hear us, he hears only darkness now.',0,0,0,0,0,0,6,0,0,0,43611,43611,26124),
(78663,'You wade through a river of souls, stranger. It\'s best to turn back.','You wade through a river of souls, stranger. It\'s best to turn back.',0,0,0,0,0,0,1,0,0,0,42012,42012,26124),
(78664,'This was once a place of peace. A place for eternal rest...','This was once a place of peace. A place for eternal rest...',0,0,0,0,0,0,579,0,0,0,42014,42014,26124),
(78665,'Leave this place, outsider. It will be your final resting place.','Leave this place, outsider. It will be your final resting place.',0,0,0,0,0,0,5,0,0,0,43612,43612,26124),
(78666,'I know ya can understand me! I WANT MY WIFE BACK!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78667,'Thank ye fer the help, $p. I\'ll meet ya back at the camp.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78670,'I\'ll meet ya o\'er there. We\'ll make that orc sing!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78671,'I hope it\'s okay me asking you to do this. If you get me these things, we\'ll be able to destroy that monstrosity.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78672,'May the Naaru protect us from the terrors that follow us across the universe.','May the Naaru protect us from the terrors that follow us across the universe.',0,0,0,0,0,0,0,35,0,0,0,0,26124),
(78673,'Be careful, $r! The podlings are attacking!','Be careful, $r! The podlings are attacking!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(78674,'Where\'s Malkorok?!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78675,'Talk! Tell me where yer bosses are!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78676,'I know ye were part o\' it! Yer gonna pay fer what ye did to me Elsa, orc!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78677,'The Goliath Cannon will...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78678,'','Mother Kashur once told us the story of the great colossus: Gorgrond.$b$bIt was the largest beast to ever walk the world, and when it fell, its body became the land, its spine the mountains, its blood the ore, and its will the savagery that rules this place.$b$bIt may have only been a fireside tale, but I can see how this story was inspired.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78679,'If we are to defeat the Iron Horde, we will need power beyond that which we possess. It is my hope that this land will reveal answers we had not thought of yet.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78680,'I know some of these orcs. We must proceed with caution. If they discover me we will have more Iron Horde on us than even we can handle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78681,'Antur, I still remember the day you were born. May your spirit go with peace.','Antur, I still remember the day you were born. May your spirit go with peace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78682,'Sartuu loved this world so much. Old friend, walk with the spirits, now.','Sartuu loved this world so much. Old friend, walk with the spirits, now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78683,'Ralkura never knew his parents. He has led a hard life. Let his spirit find peace in the halls of Auchindoun.','Ralkura never knew his parents. He has led a hard life. Let his spirit find peace in the halls of Auchindoun.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78684,'Zaanve was always a rascal. He loved to play jokes on his friends. You will be remembered, friend.','Zaanve was always a rascal. He loved to play jokes on his friends. You will be remembered, friend.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78685,'Ah, Thamuun. For twenty years, he hid his love for a woman named Thalia. He never found the courage to tell her.','Ah, Thamuun. For twenty years, he hid his love for a woman named Thalia. He never found the courage to tell her.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78686,'He\'s jus\' one in a long line o\' orcs I intend ta \"question\".','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78687,'Okay, $n, I\'ve got it reprogrammed. All you have to do is push the plunger. EVERYONE BRACE YOURSELVES!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78688,'Racers ahead of you: 0. You\'re winning!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78689,'Racers ahead of you: 1','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78690,'Racers ahead of you: 2','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78691,'Racers ahead of you: 3','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78692,'Racers ahead of you: 4','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78693,'Racers ahead of you: 5','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78694,'Racers ahead of you: more than 5','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78695,'I will take care of the rest here, champion. Return to Akama and see what else needs to be done.','I will take care of the rest here, champion. Return to Akama and see what else needs to be done.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78696,'Lady Giana, who took up the paladin\'s charge. May your spirit go with peace.','Lady Giana, who took up the paladin\'s charge. May your spirit go with peace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78697,'Cheerful Shalu. Her laugh could be heard echoing around the halls of the Temple. You bring joy to the spirits, now.','Cheerful Shalu. Her laugh could be heard echoing around the halls of the Temple. You bring joy to the spirits, now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78698,'Markeet\'s brothers once bet her that she couldn\'t lift an elekk. They did her chores for a week after. Walk with the Light, my child.','Markeet\'s brothers once bet her that she couldn\'t lift an elekk. They did her chores for a week after. Walk with the Light, my child.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78699,'Many saw Enaka shield her comrades with her own body when the wall fell. Your deeds will be honored, sister.','Many saw Enaka shield her comrades with her own body when the wall fell. Your deeds will be honored, sister.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78700,'Brave Kaati. It is said that she feared nothing. She leaves behind two young children.','Brave Kaati. It is said that she feared nothing. She leaves behind two young children.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78701,'Aphuun, your parents will be proud of your courage. May your spirit go with peace.','Aphuun, your parents will be proud of your courage. May your spirit go with peace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78702,'Raknur was as skilled with a hammer as he was with a paintbrush. May your spirit go with peace.','Raknur was as skilled with a hammer as he was with a paintbrush. May your spirit go with peace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78703,'Maarkus, you always greeted me with a bright smile. May your spirit go with peace.','Maarkus, you always greeted me with a bright smile. May your spirit go with peace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78704,'Harvu, you earned your initiation into the vindicators only a moon ago. May your spirit go with peace.','Harvu, you earned your initiation into the vindicators only a moon ago. May your spirit go with peace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78705,'Rakmun, son of Arva. As a young child, you used to beg me for candy. May your spirit go with peace.','Rakmun, son of Arva. As a young child, you used to beg me for candy. May your spirit go with peace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78708,'Jarool was the only son of my former apprentice, Neerva. He inherited his mother\'s boldness. Walk with the spirits, child.','Jarool was the only son of my former apprentice, Neerva. He inherited his mother\'s boldness. Walk with the spirits, child.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78709,'Umaat wished to someday become a teacher. We will remember you always. Walk with the spirits, now.','Umaat wished to someday become a teacher. We will remember you always. Walk with the spirits, now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78710,'Thakuur showed early signs of prophetic talent. Your passing is a great loss. Rest now, my brother.','Thakuur showed early signs of prophetic talent. Your passing is a great loss. Rest now, my brother.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78711,'Kamuur joined the city\'s defenses against his mother\'s wishes. You served us proudly, brother. Now be at peace.','Kamuur joined the city\'s defenses against his mother\'s wishes. You served us proudly, brother. Now be at peace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78712,'Baruud helped build the walls of Karabor, which still stand today thanks to him. Walk with the spirits, now.','Baruud helped build the walls of Karabor, which still stand today thanks to him. Walk with the spirits, now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78715,'Sanduur held the forward gate until reinforcements could arrive. Walk with the Light now, brother.','Sanduur held the forward gate until reinforcements could arrive. Walk with the Light now, brother.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78716,'Hemeer recently celebrated the arrival of his first son. They will know of your courage, brother. Walk with the Light.','Hemeer recently celebrated the arrival of his first son. They will know of your courage, brother. Walk with the Light.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78717,'Gheeda joined the Vindicators to follow in his father\'s footsteps. Now, let your spirits be joined in Auchindoun.','Gheeda joined the Vindicators to follow in his father\'s footsteps. Now, let your spirits be joined in Auchindoun.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78718,'The Temple will be too quiet now without the sound of your voice, Barada. Walk with the Light, brother.','The Temple will be too quiet now without the sound of your voice, Barada. Walk with the Light, brother.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78719,'Armoot has six brothers, all of whom serve proudly in Karabor\'s guard. They will honor your deeds, brother.','Armoot has six brothers, all of whom serve proudly in Karabor\'s guard. They will honor your deeds, brother.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78722,'Timoor, quiet and shy. You fought bravely. Your deeds shall be remembered, child.','Timoor, quiet and shy. You fought bravely. Your deeds shall be remembered, child.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78723,'Anmet was born on a farm in Talador. He took up the paladin\'s hammer in his elder years to defend our city. Your courage shall be honored.','Anmet was born on a farm in Talador. He took up the paladin\'s hammer in his elder years to defend our city. Your courage shall be honored.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78724,'Merool was the last of his bloodline. He never married nor had children. Your name will be remembered with honor, warrior.','Merool was the last of his bloodline. He never married nor had children. Your name will be remembered with honor, warrior.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78725,'Veraan\'s spirit was gentle, but his hammer struck fiercely today. Walk with the Light, brother.','Veraan\'s spirit was gentle, but his hammer struck fiercely today. Walk with the Light, brother.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78726,'Judging from his wounds, it took ten Iron Horde to take Inavu down. Your deeds shall be honored, friend.','Judging from his wounds, it took ten Iron Horde to take Inavu down. Your deeds shall be honored, friend.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78727,'Maani, youngest of her family. She wished to someday travel across all of Draenor. Travel now with the Light, child.','Maani, youngest of her family. She wished to someday travel across all of Draenor. Travel now with the Light, child.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78728,'Hareeni, I blessed you on the day that you were born. Brave in life, brave in death. Go in peace, now.','Hareeni, I blessed you on the day that you were born. Brave in life, brave in death. Go in peace, now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78729,'Amuura, twin of Faari. May your spirit go peacefully.','Amuura, twin of Faari. May your spirit go peacefully.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78730,'Brea, youngest amongst the acolytes. Your courage cannot be denied. May your spirit go with peace.','Brea, youngest amongst the acolytes. Your courage cannot be denied. May your spirit go with peace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78731,'Farvi, favorite of the younger children. They will remember your stories. May your spirit go with peace.','Farvi, favorite of the younger children. They will remember your stories. May your spirit go with peace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78732,'Yrvaa, your sons shall know their mother\'s courage in her final hour. Walk with the spirits, now.','Yrvaa, your sons shall know their mother\'s courage in her final hour. Walk with the spirits, now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78733,'Kevana, artist of the written word. Your stories will live on in the great library at Shattrath. Walk with the spirits, now.','Kevana, artist of the written word. Your stories will live on in the great library at Shattrath. Walk with the spirits, now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78734,'Ruidan, skilled in the healing arts. Her passing is a great loss to us. Walk with the spirits, now.','Ruidan, skilled in the healing arts. Her passing is a great loss to us. Walk with the spirits, now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78735,'Feraan, lover of music. She used to sing me songs as a young child. Walk with the spirits, child.','Feraan, lover of music. She used to sing me songs as a young child. Walk with the spirits, child.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78736,'Jeluuna, your passing is a great loss to us. Walk with the spirits, now.','Jeluuna, your passing is a great loss to us. Walk with the spirits, now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78737,'Unaa, swift of hoof. She could run from one end of the Valley to the other before sunset. Now, you run with the champions of Auchindoun.','Unaa, swift of hoof. She could run from one end of the Valley to the other before sunset. Now, you run with the champions of Auchindoun.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78738,'Tavala, bright and talkative. Walk with the Light.','Tavala, bright and talkative. Walk with the Light.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78739,'Safta and her husband both fought in the battle. Such courage in a pair so young. You walk with the Light now.','Safta and her husband both fought in the battle. Such courage in a pair so young. You walk with the Light now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78740,'Ranha, none could match your skill with the bow and arrow. Your aim was true to the end. Walk with the Light, brave one.','Ranha, none could match your skill with the bow and arrow. Your aim was true to the end. Walk with the Light, brave one.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78741,'Navine is one of the many Anchorites who stayed near the frontlines. Her courage saved many lives today. Walk with the Light, brave one.','Navine is one of the many Anchorites who stayed near the frontlines. Her courage saved many lives today. Walk with the Light, brave one.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78742,'Chuume, I will see that your sons grow into fine young men. Your deeds will be honored, sister.','Chuume, I will see that your sons grow into fine young men. Your deeds will be honored, sister.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78743,'Olanna took up the hammer after her family was killed in an Iron Horde raid. Let your spirit be at peace now.','Olanna took up the hammer after her family was killed in an Iron Horde raid. Let your spirit be at peace now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78744,'Avette led teams to disable numerous Iron Horde siege weapons. Your deeds will be honored, sister.','Avette led teams to disable numerous Iron Horde siege weapons. Your deeds will be honored, sister.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78745,'Sifting','Sifting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(78746,'Eluuvi joined the Vindicators with her two best friends from childhood. They will honor your deeds, child.','Eluuvi joined the Vindicators with her two best friends from childhood. They will honor your deeds, child.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78747,'Help me, you savages!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78748,'To me, Iron Tide!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78749,'Help me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78750,'Oh yeah! Burn \'em all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78751,'','Help me!',0,0,0,0,0,0,1,0,0,23649,0,0,26124),
(78752,'After Daami\'s husband died of fever, she developed cures for many diseases. Your deeds will be honored, sister.','After Daami\'s husband died of fever, she developed cures for many diseases. Your deeds will be honored, sister.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78753,'Kinna was always one to speak her mind. I\'m sure she cursed the Iron Horde as fiercely as she fought them. Be one with the Light now.','Kinna was always one to speak her mind. I\'m sure she cursed the Iron Horde as fiercely as she fought them. Be one with the Light now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78754,'Vaanta, your valor was an example to us all. Be one with the Light now.','Vaanta, your valor was an example to us all. Be one with the Light now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78755,'Basha treated everyone as dearly as family. Be one with the Light now, gentle one.','Basha treated everyone as dearly as family. Be one with the Light now, gentle one.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78756,'Kippa\'s family commands our naval fleet. Be one with the Light now, child.','Kippa\'s family commands our naval fleet. Be one with the Light now, child.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78757,'Freita\'s squadron broke the Iron Horde siege on the northern courtyard. We are honored by your courage.','Freita\'s squadron broke the Iron Horde siege on the northern courtyard. We are honored by your courage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78758,'In the chaos after the initial attack, Amyta rallied the draenei at the front wall. We are honored by your courage.','In the chaos after the initial attack, Amyta rallied the draenei at the front wall. We are honored by your courage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78759,'Kaveen led the first charge when the battle began. His fearlessness inspired courage in his comrades. Rest now.','Kaveen led the first charge when the battle began. His fearlessness inspired courage in his comrades. Rest now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78760,'Rahsteel trained many of the Vindicators on this field. Today, he led his students by example. Rest now, brother.','Rahsteel trained many of the Vindicators on this field. Today, he led his students by example. Rest now, brother.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78761,'Teruum died with great valor. Be one with the Light now.','Teruum died with great valor. Be one with the Light now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78762,'Umaat joined Karabor\'s guard to protect his family. Be one with the Light now, brother.','Umaat joined Karabor\'s guard to protect his family. Be one with the Light now, brother.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78763,'Gerood led the elekk cavalry. Be one with the Light now, champion.','Gerood led the elekk cavalry. Be one with the Light now, champion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78764,'Kinta led the charge onto the Iron March. Be one with the Light now, champion.','Kinta led the charge onto the Iron March. Be one with the Light now, champion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78765,'Life is the Light ... and the Light is Life itself. They may be exchanged, but nothing is ever lost.','Life is the Light ... and the Light is Life itself. They may be exchanged, but nothing is ever lost.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78766,'< Hold him steady!>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78767,'< You\'re not going anywhere. >','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78768,'< It\'s too strong! >','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78769,'AHHHH!!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78770,'I don\'t know how much longer we can go on like this.$B$BMost of our harvest has come alive and started attacking my farmhands, and the little food we are able to gather isn\'t nearly enough to feed all of the refugees that have showed up from Tuurem.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(78771,'','We did nothing to th-threaten the podlings... w-we were just guiding the last of the refugees into the farm...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78772,'When Tuurem fell to the Iron Horde, I was in charge of its defense. We were more volunteers than an army, but I was still sworn to protect my home.$B$BThese displaced souls you see here are lost because of my failure. I only hope I do not let them down again.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(78773,'','We make quite the team, don\'t you think?$B$BThat oil machine was no match for the dynamic duo - Illona and $n!',547,0,0,0,0,0,0,0,0,0,0,0,26124),
(78774,'Hurry, $n. We have to get to Yrel!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78775,'Those things are so poorly built. Anything you do is going to mess them up.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(78776,'Now it\'s time to free my beloved. I won\'t lose her again! COME, WE\'RE LEAVING!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78777,'We\'re under attack!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78778,'Function Disabled. See Operation Manual Vol. X pp.1014-1034','Function Disabled. See Operation Manual Vol. X pp.1014-1034',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78779,'Uh oh. Pipe making noise.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78780,'It not supposed to whistle that much.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78781,'Why they build pipe here?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78782,'Who put valve there? Why they do that?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78783,'Lok\'tar? Or sleep? Maybe sleep.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78784,'I\'m glad that you\'re here, $n. We\'ve been through a lot together.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(78785,'Yrel is alive! The filthy ogres have her at their slave camp.$B$BWe need to destroy this place and get to her!','',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(78786,'Please, somebody help!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78787,'Augh! It burn!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78788,'Ow ow ow!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78789,'Help or I fall!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78790,'Bunch of meanies...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78791,'Fire hot hot hot!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78792,'','My love... is it over?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78793,'Yes, you are safe. I will not leave your side.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78794,'Get back here!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(78795,'You, over there! Please, all of the talbuk have escaped!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(78796,'There are podlings everywhere! I\'ll get killed if I try to rescue them!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78797,'','The mighty Goc, son of Gruul, know that you now bow before Gro\'naka, gronnstalker of the Thunderlords!',0,0,0,0,0,0,0,0,0,23646,0,0,26124),
(78798,'','I am sorry, but could you say that a little louder? I couldn\'t hear you over the sound of your chains.',0,0,0,0,0,0,0,0,0,23646,0,0,26124),
(78799,'Your name is as insignificant to me as the names of the thousands who have died under the might of Goc.  I will crush you!','',0,0,0,0,0,0,0,0,1,23646,0,0,26124),
(78800,'I\'ll help you find your friend as long as you promise not to kill me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78801,'','Quiet, you fool!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78802,'','Stop laughing. Are you trying to get us caught?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78803,'','Stop touching me or I will break every bone in your hand.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78804,'','Silence! Patrols are near.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78805,'','Be silent! Do you want someone to hear you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78806,'','Enough giggling. Be quiet!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78807,'','Why are you making so much noise? Have you ever actually tried to sneak up on someone before?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78808,'Pul, I need to quickly return to Bladespire Citadel.','Pul, I need to quickly return to Bladespire Citadel.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78809,'Let\'s get movin\', then!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(78810,'Lemme just get her warmed up...','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(78811,'Come on, baby girl...','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(78812,'There we go!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(78813,'This way. There is a safe spot up ahead, just outside the Iron Horde\'s facilities.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(78814,'I s\'pose priority number one is to take care o\' that nasty giant cannon.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(78815,'Did somebody say \"giant cannon\"?','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(78816,'Soon enough. Our first priority is to find Yrel. She is out there somewhere.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(78817,'D\'kaan, you and our champion did some scouting earlier. What did you find?','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(78818,'...nothing conclusive, Vindicator.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(78819,'I see. Well then, we will just have to...','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(78820,'AAAAAHHH! SO MUCH FIRE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78821,'Karmaan is at the back of the farm. Let\'s go.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(78822,'He\'s just ahead.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(78823,'Karmaan, this hero and I spotted iron horde in podling territory!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(78824,'$p, time is running out. You need to find his daughter so he will listen to us. We need his knowledge of the land if we are to have any hope against the iron horde!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(78825,'The podlings are ravaging the farm. My daughter is missing. Let the iron horde come.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78826,'This adventurer disposed of most of the podlings. We once fought alongside one another at Karabor, brother. We cannot give up now.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(78827,'Ow! Hey! Why hurt me?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78828,'No! I falling!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78829,'The tank rumbles, rattles, sputters, and spurts.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78831,'<Move out to Ulon Oasis.>','<Move out to Ulon Oasis.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78833,'Here it comes! Form ranks! Grapplers at the ready!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78834,'','We have incoming. Use some of those explosives to destroy their ground forces.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78835,'Ah, old Shadowmoon! I never thought to set eyes on these woods again.','',0,0,0,0,0,0,1,0,0,0,44824,0,26124),
(78836,'','Vindicator Akama! I\'ve just come from Teluuna Observatory. Our people there are under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78837,'','My sister Samaara is stationed at the Observatory. I will go as well.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(78838,'Tell your prophet that his era is over. Darkness dawns!','',5,0,0,0,0,0,5,0,0,0,43700,0,26124),
(78839,'I\'ll dispatch artificers to secure the crystals to the north.','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(78840,'And what of Ner\'zhul? Will we let him take our people without retribution?','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(78841,'Patience, Maraad. A rescue will require planning - do not rush into danger until we know where our people are.','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(78842,'We made the wrong choice once before. I won\'t let it happen again. I can\'t leave our people to die.','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(78843,'','I will keep an eye on him, teacher.',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(78844,'Now brother! Let us escape while we still can!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78850,'','When the Iron Horde came, they gave our clan a choice. Join them, or die.',0,0,0,0,0,0,1,0,4,0,0,43241,26124),
(78851,'','My husband Ner\'zhul chose to save our people. He joined the Iron Horde, but they asked of him a heavy price.',0,0,0,0,0,0,1,0,4,0,0,43242,26124),
(78852,'','They said:',0,0,0,0,0,0,0,0,4,0,0,43243,26124),
(78853,'','So Ner\'zhul turned to the silent void. He broke the ancient laws, and drew upon the dark star.',0,0,0,0,0,0,1,0,4,0,0,43244,26124),
(78854,'','I pleaded with him to stop, but he would not turn back.',0,0,0,0,0,0,579,0,4,0,0,43245,26124),
(78855,'','By breaking this stone, he forswore all loyalty to our ancestors.',0,0,0,0,0,0,1,0,4,0,0,43246,26124),
(78856,'','I can ask only one thing of you now, stranger.',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(78857,'','You must do what I cannot. Stop Ner\'zhul. End his madness before it is too late.',0,0,0,0,0,0,1,0,4,0,0,43247,26124),
(78858,'What\'s this? A little $r?$B$BWhat possible use would I have with |5$r slave?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78859,'Well done, Ner\'zhul. We attack Karabor soon. Summon forth the Dark Star.','',0,0,0,0,0,0,1,0,0,0,46499,0,26124),
(78860,'','Hang on Samaara. I will call for Velen. He can save you, just hold on!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78861,'','Yrel, do not be sad. I did not choose this fate, but you... you can still choose.',0,0,0,0,0,0,0,0,0,0,0,43226,26124),
(78862,'','Be strong, little one. I... I will be watching over you.',0,0,0,0,0,0,0,0,0,0,0,43225,26124),
(78863,'','No. No!!!!!',0,0,0,0,0,0,0,0,0,0,0,45644,26124),
(78864,'','Samaara, I swear to you, I will become strong. I will protect our people. I. Will. Fight!',0,0,0,0,0,0,0,0,0,0,0,45645,26124),
(78865,'','Come, champion. I will need your help to crush this \"Iron Horde.\"',0,0,0,0,0,0,0,0,0,0,0,45646,26124),
(78866,'Run brother! Before it is too late!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78867,'Find Yrel. And, $n, if this filthy ogre gives you any problems, kill him!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78868,'Better hope Ripclaw is tired... no one I send against him ever survives.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78869,'$n is it? You\'ll sell quickly for the Nagrand fighting pits. In the meantime, Ok\'mok will find someplace to put you to work.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78870,'Up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78871,'Gazlowe\'s Solution is ready to deploy!','Gazlowe\'s Solution is ready to deploy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78872,'Must be closer to Gazlowe\'s objectives to deploy!','Must be closer to Gazlowe\'s objectives to deploy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78873,'Front of the line, slave!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78874,'Flames assist me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78875,'','That\'s quite enough of this illusion, I think.',0,0,0,0,0,0,0,0,0,0,0,45910,26124),
(78876,'Ahhh, much better.','',0,0,0,0,0,0,0,0,0,0,46302,0,26124),
(78877,'I will bring our new friend here back to the refuge.','',0,0,0,0,0,0,0,0,0,0,46305,0,26124),
(78878,'Shadows engulf your mind as the illusion shatters!','Shadows engulf your mind as the illusion shatters!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78880,'Why you no save me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78881,'Me sorry...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78882,'This pay back!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78883,'Maybe me take your body!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78884,'Boo!  You scared?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78886,'< You find Skreek\'s lifeless body sprawled out on the ground. >','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78887,'You search the bushes for hidden enemies.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78888,'Lookout!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78889,'We are not alone, $c. Check the bushes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78890,'Did you kill them all?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78891,'The centipedes are no use to me dead. You will have to catch them by hand.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78892,'This potion will surely be useful. Now let us find Skreek.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78893,'This... this cannot be... my brother. My family. We are too late.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78894,'I will kill him. I\'ll tear Greatscar to pieces! I will avenge you brother!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78895,'','We... cannot... be stopped.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78896,'','You struggle in vain.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78897,'','I have bought you all the time that I can, Death Speaker.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78898,'It\'s Swiftshadow! He\'s still alive!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78899,'You should have stayed in your cage. Now you will die like your brother!','',0,0,0,0,0,0,0,0,0,23731,0,0,26124),
(78900,'','Papa, I\'m scared!',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(78901,'I know, lightning bug. But Papa needs you to be brave right now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78902,'Do you remember what you want to be when you grow up? Come now, you just told me this morning.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78903,'','<sniff> <sniff> ... a vindicator.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78904,'And what are vindicators like?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78905,'','...they\'re brave.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78906,'That\'s right! Can you be brave for me, Vindicator Melani?','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(78907,'','%s stands up straight and puffs out her chest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78908,'','I\'ll try!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78909,'There\'s my girl. Now stay close to Papa. Let\'s go!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78910,'','You\'re going after it?! Suit yourself. I am getting out of here!',0,0,0,0,0,0,0,0,0,0,0,45908,26124),
(78911,'Get in there you worthless $c and don\'t come out until either you or the raptor is dead!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78912,'','$p! Fire the main cannon and bring that tower down!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78913,'','Nice shot! Easy shot. But nice one! Now let\'s get out of here before they can launch a counter attack. Hold on to something!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78914,'You insignificant vermin cannot hold me forever.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(78915,'I look forward to eating your precious pack beast.$b$bAnd you. Do not forget that I will eat you as well!$b$bBut mostly I am looking forward to eating your pack beast.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(78916,'Release me and I shall consider not slaying all of you.$b$BMaybe just those chuckling orcs over in the corner.$b$bEspecially the one that keeps stabbing me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(78917,'I hunger. FEED ME!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(78918,'There is no hope for you. You should just line up in the order of fattest so that I might consume you more efficiently.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(78919,'Armies have quaked before my coming. You will learn this, soon enough.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(78920,'Is the gronn safe?','Is the gronn safe?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78921,'','Safe? No. But managable. Goc would eat us if he could but the Iron Horde succeeded in driving their devices into his brain in just the right way.$b$bHe can\'t move unless operated by a controller.$b$bJust hope none of those bolts loosen or we will have a giant problem on our hands.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78922,'What will happen to the gronn?','What will happen to the gronn?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78923,'','He is too large to bring with us. While the added firepower would be nice we still need to keep a low profile. He was not the only gronn in the Iron Horde arsenal.$b$bWe will probably leave him here for now. Those harnesses will keep him in place. Given how many orcs he has consumed, I have no problem leaving him here to starve for his crimes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78924,'The caravan I\'m traveling with could use some help. You seem like you would fit right in.','The caravan I\'m traveling with could use some help. You seem like you would fit right in.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78925,'Invite Y\'kish?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78926,'Without Skreek and Swiftshadow I don\'t know how I will survive.$b$bMy brother has always taken care of me. If it wasn\'t for him I would have suffered a far worse fate than having my wings clipped.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78927,'My bond with Swiftshadow is almost as important to me as the bond I share with my brother.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78928,'Swiftshadow and I could not be more grateful for your actions today, $c.$b$bWe are in your debt.$b$bI\'ll meet up with you and the caravan after I am done burying my brother.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78929,'','They killed Bonetusk... we must hold them off!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78930,'','Roogug has failed us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78931,'','Take refuge, my brethren. Ramtusk will protect the Kraul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78932,'Garrosh Hellscream has escaped.\n\nIf you have any information regarding the war criminal\'s whereabouts, please inform your local authorities and any agent of the Shado-Pan you see.','Garrosh Hellscream has escaped.\n\nIf you have any information regarding the war criminal\'s whereabouts, please inform your local authorities and any agent of the Shado-Pan you see.',2,1,0,0,3,0,0,0,0,0,0,0,26124),
(78933,'The murlocs flee in the face of Aku\'mai\'s wrath!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78934,'Hurry it up, slave!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78935,'','Good work, $p! Meet us at the rendezvous. Time to see how to drive this beast.',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(78936,'No slacking off!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78937,'What? Is this |5$pr? Pathetic!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78938,'','Let\'s see how you do when you don\'t have a machine of MY design at your disposal...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78939,'You\'re going to get a beating if you don\'t move it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78940,'Work harder!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78941,'Faster, $pr, or it\'s the cooking pot for you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78942,'Are you eyeballing me?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78943,'You don\'t belong here, $pr. Get back to work!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78944,'What happened?','What happened?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78945,'Allies of Garrosh attacked the Temple of the White Tiger during his trial.\n\nIn the confusion, Kairoz -- a bronze dragon assisting with the proceedings -- betrayed us all and opened a magical portal through which both he and Garrosh fled.','Allies of Garrosh attacked the Temple of the White Tiger during his trial.\n\nIn the confusion, Kairoz -- a bronze dragon assisting with the proceedings -- betrayed us all and opened a magical portal through which both he and Garrosh fled.',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(78946,'Where did Garrosh go?','Where did Garrosh go?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78947,'Pandaria\'s waterspeakers assure us that he has fled that land.\n\nBeyond that, we cannot say.','Pandaria\'s waterspeakers assure us that he has fled that land.\n\nBeyond that, we cannot say.',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(78948,'Who is Kairoz?','Who is Kairoz?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78949,'Kairozdormu is one of the bronze dragonflight.\n\nHe was assisting in the trial, conjuring images of Garrosh\'s past atrocities.\n\nThere is no known link between Kairoz and Garrosh, and neither we nor the bronze dragonflight know why he aided the orc.','Kairozdormu is one of the bronze dragonflight.\n\nHe was assisting in the trial, conjuring images of Garrosh\'s past atrocities.\n\nThere is no known link between Kairoz and Garrosh, and neither we nor the bronze dragonflight know why he aided the orc.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(78950,'Tell me about the attack.','Tell me about the attack.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78951,'An orc known as Warlord Zaela led the attack; assisting her were her Dragonmaw clan, a number of dragons, and a band of hired pirates.\n\nOnce Garrosh escaped, Zaela and the surviving Dragonmaw fled on dragon-back.\n\nThe pirates were abandoned but know nothing of Garrosh\'s whereabouts.','An orc known as Warlord Zaela led the attack; assisting her were her Dragonmaw clan, a number of dragons, and a band of hired pirates.\n\nOnce Garrosh escaped, Zaela and the surviving Dragonmaw fled on dragon-back.\n\nThe pirates were abandoned but know nothing of Garrosh\'s whereabouts.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(78954,'You\'re pathetic!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78955,'Faster or it\'s the cooking pot for you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78956,'Get back to work!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78959,'I\'ll hold the line. Go find the others!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(78960,'Hurry it up, slave! Get to your assignment!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78961,'<whispers>The first slave you should talk to is on the way to the quarry. Keep your head down and we\'ll be fine. Just don\'t let your ranger friend kill me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78962,'Muura and Illona are further out. You\'ll need to cut through the Iron Horde\'s forces to get to them.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(78976,'Mining','Mining',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(78977,'','You\'re a light in these dark times, $p.',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(78978,'','Illona is on the other side of the farm. Hurry!',0,0,0,0,0,0,396,0,0,23767,0,0,26124),
(78979,'ENOUGH! SOUND THE ALARM!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78980,'The two of you will never escape alive!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78981,'Killstripe might know. He\'s up the hill. Here, take this crate of rocks so you look like you\'re working.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78982,'Yrel? Is that the draenei woman they brought in yesterday?$B$BYeah, I don\'t know where she is, but Killstripe might.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78983,'<The saberon narrows his eyes, judging you.>','',15,0,0,0,0,0,0,0,0,0,0,0,26124),
(78984,'<Killstripe nods his approval.>','',2,0,0,0,0,0,0,0,0,0,0,0,26124),
(78985,'','These guys aren\'t so tough!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(78986,'Killstripe points at one of the ogres and makes a cutting motion in front of his throat.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78987,'Points to the mine and draws an image of a foreling in the dirt.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78988,'','Muura is on the other side of the farm. Hurry!',0,0,0,0,0,0,396,0,0,23766,0,0,26124),
(78989,'Killstripe? He\'s a saberon. They don\'t talk. Give up now, $n. I\'ll be lenient.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78990,'I wouldn\'t if I were you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78991,'What are you doing in Gorgrond?','What are you doing in Gorgrond?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78992,'You\'ll pay for that, $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78993,'After being banished from the spires my older brother Skreek and I sought refuge.$b$bWe traveled a great distance on the back of Swiftshadow before the saberon shot us down not far from here. I can only assume they planned to eat us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78994,'Why are you bothering me? Can\'t you see I\'m on my break?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78996,'You\'re alright for a $r. You can do my work for me anytime.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(78997,'You want to know where your friend is? Mine these rocks for me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78998,'Thank you, $r. You\'ll find her toiling away just down the hall.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(78999,'Why would you or your brother need a mount like Swiftshadow to fly?','Why would you or your brother need a mount like Swiftshadow to fly?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79000,'This one\'s lazy and should be beaten. You get back to work, foreling!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79001,'Last chance, $n. Let me go unharmed and surrender now, or else!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79015,'What are you doing back here?$B$BGet to your work assignment before I squash you!','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(79016,'Please, I beg you, don\'t kill me!','',20,0,0,0,0,0,0,0,0,0,0,0,26124),
(79017,'When we were banished from the spires our wings were clipped. It was Skreek who had the idea to tame a mount. To fly on the back of a beast would be humiliating for most arakkoa. To my brother and me -- it was a chance to reclaim the skies.$b$bSkreek found Swiftshadow just a few days after we had been banished. She had fallen from her nest.$b$bMy brother and I raised her. We gave her shelter and food.$b$bSkreek taught her how to fly and in return Swiftshadow gave us back the gift of flight.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79018,'','Do you need something fixed?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79019,'Do you have an Optical Disc?','Do you have an Optical Disc?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79020,'Do you have Romuul\'s Wrench?','Do you have Romuul\'s Wrench?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79021,'This is some place al\'right.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(79022,'These draenei are funny lookin\', dontcha think?','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(79023,'Do you have some brew for the Master Artificer?','Do you have some brew for the Master Artificer?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79024,'Now I understand.','Now I understand.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79025,'Fearlessly delving into the unknowable. Seeking answers in the dark...','',0,0,0,0,0,0,0,0,0,0,46309,0,26124),
(79026,'I am Iskar. And now that you have become acquainted with the arakkoa, I wonder if you might aid me in subverting them.','',0,0,0,0,0,0,0,0,0,0,46310,0,26124),
(79027,'You will collapse under the weight of your own madness...','',0,0,0,0,0,0,0,9,0,0,0,0,26124),
(79028,'You think I would idly wait while you stab pointlessly at me?','',0,0,0,0,0,0,0,9,0,0,0,0,26124),
(79029,'Spin in the maddening whorls of eternity!','',0,0,0,0,0,0,0,9,0,0,0,0,26124),
(79030,'','I will use your bones to sharpen my blade.',0,0,0,0,0,0,0,0,0,23791,0,0,26124),
(79031,'','Your pitiful skills are no match for my talents.',0,0,0,0,0,0,0,0,0,23791,0,0,26124),
(79032,'','Ah, a challenge.',0,0,0,0,0,0,0,0,0,23791,0,0,26124),
(79033,'','But... my... training...',0,0,0,0,0,0,0,0,0,23792,0,0,26124),
(79034,'Scour the room! Check every corner and shadow, and do not move the artifact until we can be certain it is safe.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79035,'You are not of the chosen.','',0,0,0,0,0,0,0,0,0,26739,0,0,26124),
(79039,'','Quickly! Stop the ritual!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79041,'We\'re gaining ground! Keep it up!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(79042,'These mongrels will learn to never set foot in our home again!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(79043,'Make sure we tend to the wounded! They could launch a new attack at any moment!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(79044,'Fight to the last! We will not bow down to these brutes!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(79045,'Warbringer Trosk and his siege weapon will fall this day!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(79046,'If I die, so do you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79047,'Mmmmmppphhhh!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79048,'Mmmph! Mmmmppphhhh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79049,'Mmmph!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79050,'','Quickly! Stand within the healing soils to protect yourselves!',0,0,0,0,0,0,0,0,0,0,0,43607,26124),
(79051,'','My weapon is in this tower.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79052,'','Great timing, $n! I was just about to make my escape. Where\'s Maraad?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79053,'','I think my armor\'s inside here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79054,'','Much better. Now I have something to fight with.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79055,'','It\'s nice not being so naked. Let\'s find Ok\'mok and my pendant from Maraad.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79056,'','Ok\'mok is at the top of this giant tower. Let\'s go.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79057,'','The pendant Maraad gave me. The ogre took it when he captured me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79058,'','Thank you, $n. You have no idea how much this means. Let\'s get out of here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79059,'','MARAAD!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79060,'Watch out, it\'s going to explode!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(79061,'YREL, MY LOVE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79062,'','Thank you for coming to get me, $n.$B$BI must get back to Maraad.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(79063,'','$n? Great timing! I was just about to make my escape.',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(79064,'Thank you, stranger!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79065,'Savor this victory, mortal. Now that you\'ve heard our whispers, it is only a matter of time until you belong to us.','',0,0,0,0,0,0,0,0,0,0,43268,0,26124),
(79066,'Finally! Let\'s get some revenge!','Finally! Let\'s get some revenge!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79067,'Thank you, $c. I\'m in your debt.','Thank you, $c. I\'m in your debt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79068,'Death to the slavers!','Death to the slavers!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79069,'For vengeance, my $g brother:sister;!','For vengeance, my $g brother:sister;!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79070,'They\'ll pay for what they did to us!','They\'ll pay for what they did to us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79071,'It feels good to be free again. Thank you!','It feels good to be free again. Thank you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79072,'I\'ll help clear the way for your escape!','I\'ll help clear the way for your escape!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79073,'I\'ll kill them with my bare hands!','I\'ll kill them with my bare hands!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79074,'You\'ll get no fight from me, $n. Please, let me live.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79075,'It\'s Swiftshadow! He has returned!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79076,'I need some time alone to say goodbye to my brother. Thank you for all your help, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79077,'Swiftshadow and I will meet you at the caravan when we are done here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79078,'This cage was getting tiresome.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(79079,'Who calls on the spirit of fire?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79080,'Let\'s calibrate the crystal.','Let\'s calibrate the crystal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79081,'','The spirits have been very restless, champion. Watch my back while I perform the calibration.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79082,'Our work is almost complete...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79083,'The nearby spirits grow restless. Keep them away from the staff.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79084,'Defend the staff while it absorbs the energies of the crystal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79085,'Farewell, Charlga. May the earth mother watch over you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(79086,'Thank you, heroes, for your valiant deeds. I hope that our paths may cross again.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(79087,'Velen\'s Staff is under attack!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79088,'','Help me, hero! I\'m under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79089,'','Protect me champion! I\'m hurt!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79090,'','Who dares defile our ancient lands?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79091,'Maraad\'s dealing with some trouble back at camp. I\'ll cover you as best I can.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79092,'','Every crystal has base properties. From there, it is the artificer\'s skill at cutting that determines the quality of the final product.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79093,'|TInterface\\Icons\\inv_misc_noose_01:20|t%s trips a |cFFFF0000|Hspell:150809|h[Rope Trap]|h|r!','|TInterface\\Icons\\inv_misc_noose_01:20|t%s trips a |cFFFF0000|Hspell:150809|h[Rope Trap]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79094,'I\'ll hang your head on Grommar\'s walls, runt.','',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(79095,'Iron will, iron blood!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(79096,'Who challenges da hammer of Frostfire?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79097,'I refuse to die to the likes of you, orc.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(79102,'Thank you for your help. May we meet again soon, friend.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79103,'We stand with Ga\'nar. He is eldest, and should have been our chieftain.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79104,'Hmrph. I have scars that look older than you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79105,'Ga\'nar will rule the Frostwolves one day, mark my words.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79106,'What do you want, pup?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79107,'I remember fighting alongside Garad and Ga\'nar against the Laughing Skulls many seasons ago. It was glorious. Never was there a more fearsome force on the battlefield.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79108,'Garad was a great chieftain, but he took leave of his senses in the end and gave Durotan leadership of the clan even though it was Ga\'nar\'s by birthright.$b$bWe now hunt with the one we proudly call \"chieftain.\"','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79109,'PH','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(79110,'','It is good to know that not all old alliances are broken. The draenei have welcomed me by their fire.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79111,'','I am Rulkan, daughter of Neema. I was an elder of the Shadowmoon Clan, but am not of the clan any longer.$B$BNer\'zhul is my husband, but we have parted ways. He took his followers in one direction, and I took mine in another.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79112,'I\'ll need more fuel to get rid of this pest...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79113,'Need more fuel!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79114,'Thought I was out of fuel? Think again, whelp!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79115,'More fuel!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79116,'More fuel to feed the flames!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79117,'More fuel!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79118,'Time to refuel...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79119,'Time to feed the flames!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79120,'You little rat!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79121,'How dare you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79122,'Owww!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79123,'AAAAHHH!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79124,'Frostwolves are here!','Frostwolves are here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79125,'Enemy incoming!','Enemy incoming!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79126,'I\'ll string you up for my beasts to feed upon!','I\'ll string you up for my beasts to feed upon!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79127,'Ah, some soft meat to hunt.','Ah, some soft meat to hunt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79128,'Easy prey!','Easy prey!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79129,'For the Iron Wolf!','For the Iron Wolf!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79130,'Ah, practice for my chains.','Ah, practice for my chains.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79131,'Why would the botani be wandering outside of Blademoon Bloom in the first place?','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(79132,'Wolf Home is under attack. Stop the Thunderlord clan raid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(79133,'They came from the forest... why are they attacking us?','They came from the forest... why are they attacking us?',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(79134,'We were fleeing from Tuurem seeking shelter when podlings came out of the forest and ambushed us!$B$BUsually if we don\'t go into their territory they leave us alone... why now?','We were fleeing from Tuurem seeking shelter when podlings came out of the forest and ambushed us!$B$BUsually if we don\'t go into their territory they leave us alone... why now?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(79135,'When you see Draka... tell her that I will be home soon.','',0,0,0,0,0,0,0,1,0,0,45202,0,26124),
(79136,'Thrall grins at his father\'s words.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79137,'The whole place is overrun. Get out while you still can!','The whole place is overrun. Get out while you still can!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(79138,'Beldos! The Iron Horde have already begun attacking!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(79139,'Thank you, champion! You have given me new hope today.','Thank you, champion! You have given me new hope today.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79140,'The Shadowmoon - they\'ve changed. They pray to the Void now...','The Shadowmoon - they\'ve changed. They pray to the Void now...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79141,'Thank you, champion. I will never forget... their screams...','Thank you, champion. I will never forget... their screams...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79142,'Hurry - Ner\'zhul is dragging prisoners to the altar!','Hurry - Ner\'zhul is dragging prisoners to the altar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79143,'Thank you. Please save the others! Ner\'zhul is using them for some kind of ritual!','Thank you. Please save the others! Ner\'zhul is using them for some kind of ritual!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79144,'Ner\'zhul is sacrificing prisoners. He\'s babbling about a \"Dark Star!\"','Ner\'zhul is sacrificing prisoners. He\'s babbling about a \"Dark Star!\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79145,'There were more prisoners... they took them somewhere... please help them!','There were more prisoners... they took them somewhere... please help them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79146,'Thank you for getting me out of here! You cannot imagine the horrors we saw...','Thank you for getting me out of here! You cannot imagine the horrors we saw...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79147,'We need help out here!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79148,'Nearby Muck Crawlers are roused by the commotion!','Nearby Muck Crawlers are roused by the commotion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79149,'Uprooting','Uprooting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(79150,'Who have we here...?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79151,'','Thank you. I\'m not cut out for fighting.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79152,'','Our people have always drawn their magic from the earth and the moon.$B$BNearly three centuries ago, the ancestors sensed a different magic. A dark source.$B$BThis was magic of shadows. It corrupted the mind, tainting those who used it, driving them mad.$B$BSince then, our clan was forbidden to use these shadows.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79154,'','What are those Thunderlord fools doing with the gronn?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79155,'What good are stars and visions against steel and powder? Make a worthy offering, or your people shall die.','',0,0,0,0,0,0,1,0,4,0,46498,0,26124),
(79156,'For Karabor!','For Karabor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79157,'For Karabor!','For Karabor!',0,0,0,0,0,0,0,35,0,0,0,0,26124),
(79158,'Stand tall brothers and sisters! Today we fight for Karabor!','Stand tall brothers and sisters! Today we fight for Karabor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79159,'I am no slave!','I am no slave!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79160,'Prepare to die!','Prepare to die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79161,'My life for Karabor!','My life for Karabor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79162,'My life for Karabor!','My life for Karabor!',0,0,0,0,0,0,0,35,0,0,0,0,26124),
(79163,'','Let\'s get cooking!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79164,'','The Shadowmoon fortress is sealed to outsiders, but this keystone will allow entry. Good luck, hero.',0,0,0,0,0,0,1,0,4,0,0,43248,26124),
(79165,'I should be at work.','I should be at work.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79166,'','Okay, how about something that\'ll stir it up and wriggle around!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79167,'','Let\'s add in something dangerous... maybe even toxic!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79168,'','How about something that\'ll give it a nice glow!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79169,'Wander.','Wander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79170,'working.','Working.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79171,'Smash the Podlings before %s can bring them to maturity!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79172,'That\'s a load off.','That\'s a load off.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79173,'Smack Boombot','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79174,'%s\'s suction intensifies!','%s\'s suction intensifies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79175,'For the Frostwolf!','For the Frostwolf!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79176,'Gathering Weapons','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79177,'%s howls in excitement.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79178,'','Good job!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79179,'','Throw in something meaty!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79180,'These heads will make the perfect trophy for such a glorious battle!','These heads will make the perfect trophy for such a glorious battle!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79181,'Throm-Ka, $c. Elements be with you.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(79182,'I am ready for the ritual, farseer.','I am ready for the ritual, farseer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79183,'Damn Thunderlords and their cheap hunting spears. I\'ll be picking these things up for a week!','Damn Thunderlords and their cheap hunting spears. I\'ll be picking these things up for a week!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79184,'Let me know when you\'re ready to begin the ritual, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79185,'Farseer, I\'d like to witness the vision again.','Farseer, I\'d like to witness the vision again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79187,'You talk a great deal, Thunderlord.','',0,0,0,0,0,0,0,1,1,0,46694,0,26124),
(79188,'The only shame here is in your cowardly attack on our home!','',0,0,0,0,0,0,0,1,1,0,46695,0,26124),
(79189,'You are overconfident, Gargrak. $p is easily your match.','',0,0,0,0,0,0,0,1,1,0,46696,0,26124),
(79190,'A waste of air. Come, friend, we have much to discuss.','',0,0,0,0,0,0,0,1,1,0,46697,0,26124),
(79191,'The ritual is ready, $n. Let me know when you wish to begin.','',0,0,0,0,0,0,0,1,1,0,46698,0,26124),
(79192,'The elements once spoke to me... now I hear only whispers. Is this our fate, or a warning?','',0,0,0,0,0,0,0,0,1,0,46700,0,26124),
(79193,'','Follow the path northwest. Hurry, that monster will kill Drek\'Thar!',0,0,0,0,0,0,0,1,1,0,0,41815,26124),
(79194,'','Well met, $c. Welcome to Wolf Home.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(79195,'','You have my thanks for returning in our time of need, $c.',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(79196,'','You must get to Drek\'Thar before it is too late!',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(79197,'','The savior of Wolf Home. It is good to see you again, $n.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(79198,'I will begin my preparations at once.','',0,0,0,0,0,0,1,0,0,0,43715,0,26124),
(79199,'','Here, this herb\'s effects will let you get to the island more easily.',0,0,0,0,0,0,1,0,0,23901,0,0,26124),
(79200,'','Oh no! That wasn\'t quite right. Let\'s just whip up a new batch.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79201,'','That\'s the stuff!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79202,'','Perfect!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79203,'','Nicely done!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79204,'','Samaara!',0,0,0,0,0,0,0,0,0,0,0,45643,26124),
(79205,'','Let me know when you\'re ready!',0,0,0,0,0,0,1,0,0,23902,0,0,26124),
(79206,'I\'m ready, Fiona.','I\'m ready, Fiona.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79207,'','Herbalism was so much easier in the old days. Now we have to fight through hell and back to extract even a few herbs!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(79208,'Time for a change of scenery.','Time for a change of scenery.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79209,'Another reason we shouldn\'t trust the shadowmoon. They can\'t even control their own magic.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79210,'There is no way I\'m going back in there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79211,'Taste iron fury!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79212,'The bigger the target, the better the boom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79213,'Just like bombing kobolds back home!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79214,'After I\'m through, it\'ll be rainin bits O\' gronn fer weeks!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79215,'There is some kind of demon at the back of the cave. He killed the fool that summoned him.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79216,'This is another reason it\'s better to wield an iron blade over dark magic.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79217,'We should be mining this cave for resources...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79218,'This is unacceptable. Why are we even considering letting these fools join us?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79219,'','We did it! This elixir should do the trick.',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(79220,'','Here, give this to Gidwin. Hopefully this works.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79221,'You\'ll find a majority of the plane wreckage just down the hill. Bring back whatever you find.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79222,'As soon I get this gyro running I can start my search for Romuul.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79223,'I would rather die than live my life as slave to the Iron Horde.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79224,'Find some weapons. It is time we stand up to our captors.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79225,'The crimes these orcs have committed against my people are unspeakable. Kill them all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79226,'Battleships! Fire on my position!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79227,'Battleships! Fire on that platform over there!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79228,'Ruffling','Ruffling',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(79229,'Ner\'zhul! Your army is scattered, your fortress in ruins.','',0,0,0,0,0,0,1,0,6,0,46495,0,26124),
(79230,'Your \"dark star\" has fallen, and now serves the draenei. You are a disgrace!','',0,0,0,0,0,0,1,0,6,0,46496,0,26124),
(79231,'We would still serve the Iron Horde, Hellscream. Our magic is-','',0,0,0,0,0,0,1,0,6,0,43698,0,26124),
(79232,'YOU HAVE NO PLACE IN MY IRON HORDE! Go back to your little village, Ner\'zhul.  You can watch the stars while the Iron Tide washes over you.','',0,0,0,0,0,0,5,0,6,0,46497,0,26124),
(79233,'Go back to your little village, Ner\'zhul.  You can watch the stars while the Iron Tide washes over you.','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(79234,'Korhol, Zhakta, Trokar... move in from all sides. Gargrak, hold for now.','',0,0,0,0,0,0,0,1,4,0,41762,0,26124),
(79235,'ZHAKTA NO!... you will be avenged!','',0,0,0,0,0,0,0,1,4,0,41763,0,26124),
(79236,'Bring me that $r $c\'s head!','',0,0,0,0,0,0,0,1,0,0,41764,0,26124),
(79237,'Dammit all. Gargrak, go now... kill the blind shaman.','',0,0,0,0,0,0,0,1,4,0,41765,0,26124),
(79238,'Call in all reinforcements. I want the She-Wolf taken alive.','',0,0,0,0,0,0,0,1,0,0,41766,0,26124),
(79239,'RETREAT! WE\'LL BE BACK, FROSTWOLVES!','',0,0,0,0,0,0,0,1,4,0,41767,0,26124),
(79240,'See what you can dig up. If the Shadowmoon clan joins forces with the Iron Horde, I worry our darkest days are yet to come.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79241,'Army! Grow!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79242,'No chance now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79243,'Little ones! Grow! Kill!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79244,'Eat you friends! Then eat you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79245,'It appears the Shadowmoon clan is having difficulty integrating with the Iron Horde. This could play out in our favor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79246,'You ours now.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79247,'Healing.','Healing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79248,'I\'ve given you some smoke grenades. Use these to help Thaelin target the Arkonite Protector.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79249,'I\'ve got enough blasting powder to wipe that gronn right off the face of Draenor. Just show me where to drop it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79250,'The spirits are restless, Durotan.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79251,'','This.. this is horrible. What are we going to do?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79252,'','I ran as soon as I had a chance. Poor Laabru. I hope he is still alive.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79253,'We have to break free of these bonds. Hurry!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79254,'We kill you soon.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79255,'This Iron Tide comes for us because Durotan is strong and the Frostwolf would not join them.','',0,0,0,0,0,0,0,1,1,0,46699,0,26124),
(79256,'Wake up! We need to break free now! Look at that thing!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(79257,'We need backup!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79258,'Help! We have intruders!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79259,'Iron Horde, we have unwanted visitors!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79260,'Did you hear that?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79261,'I am on the way!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79262,'The Iron Horde will crush you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79263,'What was that noise?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79264,'It is time for death!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79265,'To arms!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79266,'','I hear the sounds of battle!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79267,'','Hold on, we are on the way!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79268,'','Blood and conquest!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79269,'We are needed!','We are needed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79270,'Destroy the intruders!','Destroy the intruders!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79271,'I hear a battle! Move it!','I hear a battle! Move it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79272,'Damn the Iron Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79273,'Healing Loop.','Healing Loop.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79278,'Arise my creation, slay these intruders!','',0,0,0,0,0,0,0,0,0,0,46427,0,26124),
(79279,'Many Frostwolf have fallen here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79280,'They\'re using the souls of my people to raise the Colossal as a weapon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79281,'$n, destroy these Soul Shaman and stop the ritual.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79282,'My warriors and I will rescue our brethren that still live.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79283,'','Where\'s my daddy?',0,0,0,0,0,0,547,0,0,0,0,0,26124),
(79284,'You cannot defeat us all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79285,'For the Iron Wolf!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79286,'','DADDY!!!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79287,'Thunderlords, to arms!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79288,'Frostwolf scum!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79289,'You are no match for the Thunderlords!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79290,'<The gyro looks like it\'s held together with duct tape and bubble gum. Thaelin seems to know what he is doing though. It should be safe.>','<The gyro looks like it\'s held together with duct tape and bubble gum. Thaelin seems to know what he is doing though. It should be safe.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79291,'Return to the Observatory?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79292,'I\'ll make a trophy from your head.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79293,'Return to the Observatory?','Return to the Observatory?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79294,'Lok\'tar Ogar, $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79295,'Wander, infirmary.','Wander, infirmary.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79296,'Did you get separated from your precious pack?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79297,'Thank you, $n. With those brutes dead it will be easier to convince the others to rise up.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79298,'The Iron Horde will surely think twice before they hold a Draenei captive again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79299,'It is good to see you again, $n. Without you and Thaelin I would surely be doomed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79300,'The tip of the Thunderlord spear, no greater honor.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(79301,'Me and Thunderhoof are going to crush all of you.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(79302,'','Death to the puny Frostwolf clan.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(79303,'','Here, this herb\'s effects will put a spring in your step. Be careful, $n.',0,0,0,0,0,0,1,0,0,23898,0,0,26124),
(79304,'','Let me know when you\'re ready!',0,0,0,0,0,0,1,0,0,23899,0,0,26124),
(79305,'Hurry $p, Ga\'nar is beneath us in the lair of Grulloc. You should join him before he kills everyone without you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79306,'Anvil.','Anvil.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79307,'Anvil done.','Anvil done.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79308,'The Shamanstone hums in the presence of powerful heroes.','The Shamanstone hums in the presence of powerful heroes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79309,'Blessing of the Wolf','Blessing of the Wolf',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(79310,'Spirit of the Wolf','Spirit of the Wolf',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(79315,'*Cough, Sputter*','',0,0,0,0,0,0,0,0,1,0,46692,0,26124),
(79316,'Did you see THIS coming, you blind fool? Hah! Hah!','',0,0,0,0,0,0,0,1,0,0,41768,0,26124),
(79317,'Kalandrios, I would like to witness the Ritual of Binding again.','Kalandrios, I would like to witness the Ritual of Binding again.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(79318,'Get out of my face, scum.$B$BWhen I break free, I\'m going to cut you in two.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79319,'','Sorcerous coward.',0,0,0,0,0,0,0,0,4,0,0,44459,26124),
(79320,'','Reinforcements to the east.',0,0,0,0,0,0,0,1,0,0,0,41807,26124),
(79321,'','Watch for Thunderlord from the ledge to the north.',0,0,0,0,0,0,0,1,0,0,0,41808,26124),
(79322,'','To the south, now my brothers and sisters.',0,0,0,0,0,0,0,1,0,0,0,41809,26124),
(79323,'','They can only attack us when most of our clan is away. Kill these Thunderlord cowards.',0,0,0,0,0,0,0,1,0,0,0,41810,26124),
(79324,'','Watch for their warleader, Gargrak.',0,0,0,0,0,0,0,1,0,0,0,41811,26124),
(79325,'','We will make Durotan proud this day!',0,0,0,0,0,0,0,1,0,0,0,41812,26124),
(79326,'','Come down and face me, \"Iron Wolf\". I\'ll show you how a true wolf fights!',0,0,0,0,0,0,0,1,0,0,0,41813,26124),
(79327,'','Protect the Pool of Visions. Do not let them get to the Farseer.',0,0,0,0,0,0,0,1,0,0,0,41814,26124),
(79328,'Check Crate.','Check Crate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79329,'Lok\'tar Ogar!','Lok\'tar Ogar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79330,'Despicable. The Iron Wolf has no respect for beast or brother - they are all just weapons for the hunt.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79331,'Never enough...','Never enough...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79332,'I need to look this up.','I need to look this up.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79333,'We\'ve called every able-bodied soldier to defend the city.$B$BStay stalwart, hero. This is the hour for courage.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79334,'Reporting for duty.','Reporting for duty.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79335,'The Iron Horde are moving toward the Temple of Karabor. The attack has beg--','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(79336,'Wait... what is that light?','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(79337,'It\'s too late for this one.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79338,'','How are you feeling, Hemma?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(79339,'Yes, Princess.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79340,'','Just a sip, be easy on her!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79341,'','Thank you, Kadus. We have to try. There\'s too much at stake.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79342,'I\'m ready whenever you are.','I\'m ready whenever you are.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79343,'Docking.','Docking.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79344,'','I refuse to remain in Darnassus any longer. There are people that need help.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79345,'Hydrating.','Hydrating.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79346,'','Here, $p. Give this potion to Hemma. It might help.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79347,'Right away, Princess.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79348,'Hemma. Drink this. It\'ll help you feel better.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79349,'No effect, Princess. We tried.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79350,'You are fierce, pup, but your attachments make you weak!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79351,'Free yourself of weakness, or be swept away by the Iron Tide!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79352,'','I... I feel...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79353,'','Asha?! Asha, NO!!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(79354,'','HnnGYAAHH!!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79355,'','HUNGRY!!!',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(79356,'','Hemma! Please, wait! Control yourself!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79357,'','$p, you\'re the fastest one here. Track Hemma down and try to get her under control. We\'ll catch up!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79358,'','I\'m losing control... please, help...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79359,'Here, drink this. How are you feeling?','Here, drink this. How are you feeling?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79360,'This talbuk has been ripped to pieces by Hemma. She must be close by.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79361,'Ah, that\'s the stuff...','Ah, that\'s the stuff...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79362,'','Coward! Release Karg and face me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79363,'','Wh - where am I? Where is the spirit?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79364,'You lost control. You\'re on a hilltop near camp.','You lost control. You\'re on a hilltop near camp.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79365,'','Hemma, we\'re here. Are you alright?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(79366,'Go, $c. Wreak havoc. Impose justice on those who so thoroughly deserve it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79367,'','I don\'t remember much. Just a spirit... of pure rage. It called to me.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79368,'','I... I don\'t feel well.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79369,'U\'luut thanks you for saving him and the forests of Shadowmoon Valley.','',0,0,0,0,0,0,377,0,0,0,0,0,26124),
(79370,'Hi, you!','Hi, you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79371,'Hi. See you later!','Hi. See you later!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79372,'','Thank you. I hope Princess Greymane can find the cure soon. It has be out here somewhere.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(79373,'Lok\'tar, $p!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79374,'Lok\'tar!','Lok\'tar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79375,'Did you think me defeated so easily?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79376,'Who dares disturb my research!','',0,0,0,0,0,0,15,0,0,0,43920,0,26124),
(79377,'Stand back!','',0,0,0,0,0,0,0,0,4,0,46359,0,26124),
(79378,'We have driven the Iron Horde back, $p, but the inner chamber remains sealed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79379,'It seems the elements of Draenor do not respond to me as they do on Azeroth...','',0,0,0,0,0,0,0,0,4,0,47062,0,26124),
(79380,'Go on ahead. Durotan awaits. I must catch my breath.','',0,0,0,0,0,0,0,0,4,0,46360,0,26124),
(79381,'I\'m crazy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79382,'','Stay away from me! Stay away! I\'ll kill you! I\'ll kill you all!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79383,'I can bring it down but I need time to harness the elements.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79384,'','The might of my ancestors flows through me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79385,'Kilrogg! I should have known you were behind this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79386,'Heh... that mutt... <cough> is being broken... with the other beasts.','',0,0,0,0,0,0,0,0,1,23991,0,0,26124),
(79387,'You were fools to come here. I will rip the souls from your bodies and raise the Colossal to crush your feeble clan!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79388,'To Bladespire! Attack!','',0,0,0,0,0,0,0,0,4,0,44069,0,26124),
(79389,'There is no time to waste! We strike NOW!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(79390,'We must breach the inner chamber. Kilrogg cannot get away with this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79391,'$p, defend me while I destroy the barrier!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79392,'This one\'s lost blood.','This one\'s lost blood.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79393,'','I... I can\'t believe he\'s gone...',0,0,0,0,0,0,0,0,0,0,0,45606,26124),
(79394,'Yrel! The defense crystal is broken. The Iron Horde have overrun Karabor. We\'d need a miracle to break through.','',0,0,0,0,0,0,5,0,0,0,44813,0,26124),
(79395,'','%s wipes away a tear.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79396,'','Velen\'s sacrifice means nothing if the temple falls.',0,0,0,0,0,0,1,0,0,0,0,45607,26124),
(79397,'Dorogg has fallen! Stay close, Frostwolves - the citadel is not yet ours.','',0,0,0,0,0,0,396,0,4,0,45195,0,26124),
(79398,'<Dulcet chiming tones reverberate within your mind.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79399,'I am ready to join the attack against the Iron Horde.','I am ready to join the attack against the Iron Horde.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79400,'Press the attack!','',0,0,0,0,0,0,396,0,4,0,45190,0,26124),
(79401,'The Frostwolves will triumph.','',0,0,0,0,0,0,396,0,4,0,45191,0,26124),
(79402,'This fortress will fall.','',0,0,0,0,0,0,396,0,4,0,45192,0,26124),
(79403,'Do not give up!','',0,0,0,0,0,0,396,0,4,0,45193,0,26124),
(79404,'Gather your strength!','',0,0,0,0,0,0,396,0,4,0,45194,0,26124),
(79405,'*Sniff*','*Sniff*',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79406,'Carry the light, brothers and sisters!','',0,0,0,0,0,0,0,0,4,0,44805,0,26124),
(79407,'Curse him!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79408,'That was barely a scratch! I should recover quickly.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(79409,'','Samaara is the only family that I have. As long as I can remember, she has taken care of me.$B$BShe is good and kind, whereas I am... not as convicted.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79410,'','For many years, the Shadowmoon Clan and the draenei of Karabor have lived in relative peace.$B$BThings began to change after this... Iron Horde... arrived.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79411,'','Maraad says his injury is not serious, but in truth, he was gravely wounded by Ner\'zhul. Though I am not sure which suffered greater ill - his body or his pride.$B$BNevertheless, he was very lucky you showed up when you did.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79412,'Can you believe this?','Can you believe this?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79413,'What do we have today?','What do we have today?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79414,'Who are you?','Who are you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79415,'WEEE wee wee!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79416,'','I will coil your souls into darkness!',0,0,0,0,0,0,0,0,1,0,0,43636,26124),
(79417,'Your blissful afterlife is over.','',0,0,0,0,0,0,0,0,0,0,43201,0,26124),
(79418,'','Too late... my Master... comes...',0,0,0,0,0,0,0,0,1,0,0,43637,26124),
(79419,'','Shadows envelop you!',0,0,0,0,0,0,0,0,1,0,0,43646,26124),
(79420,'','Your oath is unfinished!',0,0,0,0,0,0,0,0,1,0,0,43647,26124),
(79421,'','Return to this world!',0,0,0,0,0,0,0,0,1,0,0,43648,26124),
(79422,'','The spirits are mine to command!',0,0,0,0,0,0,0,0,1,0,0,43649,26124),
(79423,'','I will drown this world in shadows!',0,0,0,0,0,0,0,0,1,0,0,43650,26124),
(79428,'Your undying souls will fuel my ascension from the darkness!','',0,0,0,0,0,0,0,0,0,0,43200,0,26124),
(79429,'Cower before me!','',0,0,0,0,0,0,0,0,0,0,43199,0,26124),
(79431,'','I\'m free!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79432,'','Thank you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79433,'','My torment is over!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79434,'Keep your wits about you. Some of the refugees reported seeing a plant hydra in the forest near the podling den to the west.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79435,'It is up to you, champion. I will stay here and help with the wounded slaves you rescued.','',0,0,0,0,0,0,0,0,4,0,46361,0,26124),
(79436,'Please bring her back, $n. She\'s the only family I have left.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(79437,'','Nothing worthwhile ever is.',0,0,0,0,0,0,0,0,4,0,0,41802,26124),
(79438,'We were hunting a large pale orc when the spiders attacked.$b$bI lost my assistant Ganky in the chaos. I was bitten countless times as I ran.$b$bThe spider bites are affecting my ability to think straight. I need to create a cure quickly before my mind escapes me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79439,'It looks like this is the bowl Helga was going to use to create a cure.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79440,'Mushroom show future.  Believe!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79441,'Wash in holy spores.  Feel might of mushroom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79442,'Visions this mushroom has given.  Truth told!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79443,'Drek\'Thar, old friend, you\'re alive!','',0,0,0,0,0,0,396,0,4,31541,45256,0,26124),
(79444,'Who? These strangers you\'ve brought?','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(79445,'I know your eyes don\'t work, shaman, but this one has green skin.','',0,0,0,0,0,0,396,0,4,0,45258,0,26124),
(79446,'Hmph. Yes. Ga\'nar is already causing trouble.','',0,0,0,0,0,0,396,0,4,0,45260,0,26124),
(79447,'Very well, strangers. You have earned the trust of our shaman. I will not turn away the help.','',0,0,0,0,0,0,396,0,4,0,45261,0,26124),
(79448,'I can barely stand. But for the actions of these heroes, I would be dead.','',0,0,0,0,0,0,396,0,4,0,46689,0,26124),
(79449,'These are champions from a faraway realm, pledged to fight the Iron Horde.','',0,0,0,0,0,0,396,0,4,0,46690,0,26124),
(79450,'I do not need eyes to see it; they are noble of heart. They saved our kin -- including your brother.','',0,0,0,0,0,0,396,0,4,0,46691,0,26124),
(79451,'Come, friends. If you wish to fight with our clan, we welcome you to receive our blessings.','',0,0,0,0,0,0,396,0,4,0,46686,0,26124),
(79452,'Reach out to the Shamanstone. Embrace the wisdom of this land and the ancestors that came before us.','',0,0,0,0,0,0,396,0,4,0,46687,0,26124),
(79453,'I am still scarred by those infernal warlocks. The spirits are quiet.','',0,0,0,0,0,0,396,0,0,0,46688,0,26124),
(79454,'I can feel it. This land speaks to me, but in a language I do not yet understand.','',0,0,0,0,0,0,25,0,0,0,46382,0,26124),
(79455,'The spirits will never abandon you, Drek\'Thar. This I can promise.','',0,0,0,0,0,0,396,0,0,0,46383,0,26124),
(79456,'','Come with me, shaman. Let me see your wounds.',0,0,0,0,0,0,396,0,0,0,0,41805,26124),
(79457,'','Draka looks at Drek\'Thar, concerned.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79458,'Warriors! Today the tide turns.','',0,0,0,0,0,0,396,0,4,0,45250,0,26124),
(79459,'We will claim Bladespire Citadel as our own.','',0,0,0,0,0,0,396,0,4,0,45251,0,26124),
(79460,'Fight as one. We win this - together!','',0,0,0,0,0,0,396,0,4,0,45252,0,26124),
(79461,'Ga\'nar is a great fighter, but he is impatient. He has taken some of our best warriors with him.','',0,0,0,0,0,0,396,0,4,0,45253,0,26124),
(79462,'He never listens. His ruthlessness may cost us.','',0,0,0,0,0,0,396,0,4,0,45254,0,26124),
(79463,'Here - Gormaul Tower. This will be our foothold. Leave none alive! LOK\'TAR OGAR!','',0,0,0,0,0,0,396,0,4,0,45255,0,26124),
(79464,'Durotan, your brother has already rushed ahead.','',0,0,0,0,0,0,396,0,0,0,46386,0,26124),
(79465,'The Bladespire ogres threw me into that hellhole. I\'ll notch my axe with their skulls until vengeance is mine!','',0,0,0,0,0,0,0,0,4,0,44087,0,26124),
(79466,'Bladespire Citadel! I will have my vengeance on those ogres, even if I have to tear it down stone by stone.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(79467,'','Keep the Iron Horde at bay!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79468,'My friends, you have earned a hero\'s welcome. Follow us to the Frostwolf Chieftain.','',0,0,0,0,0,0,396,0,4,0,46674,0,26124),
(79469,'Wise-ear! You are alive!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79470,'My eyes may not work, but the familiar chill of the air is comforting.','',0,0,0,0,0,0,396,0,4,0,46683,0,26124),
(79471,'I worry about Ga\'nar. Always quick to fight. His need for vengeance will make him more reckless than ever.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(79472,'Ah yes. Garad\'s youngest: a noble soul named Durotan.','',0,0,0,0,0,0,396,0,4,0,46684,0,26124),
(79473,'Wise beyond his years, but still young. I fear he has been thrust into the Gronn\'s jaws - our people are in great danger.','',0,0,0,0,0,0,396,0,4,0,46685,0,26124),
(79474,'Here we are! Wor\'gol, home of the Frostwolves.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(79475,'You mentioned the Frostwolf Chieftain...','',0,0,0,0,0,0,396,0,4,0,46377,0,26124),
(79476,'Durotan!','',0,0,0,0,0,0,396,0,4,0,46378,0,26124),
(79477,'Visions! No!  You pay for interfering!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79478,'You fight well, $p! With you here, the odds are stacked in our favor.','',0,0,0,0,0,0,113,0,1,0,0,0,26124),
(79479,'Lokra... with you at my side, I feel invincible! Let us challenge the Iron Wolf right now and end this!','',0,0,0,0,0,0,71,0,1,0,0,0,26124),
(79480,'','We leave now, and return to the pack. The Iron Wolf will answer to the full might of the Frostwolf clan.',0,0,0,0,0,0,396,0,1,0,0,0,26124),
(79481,'Lead us to Durotan, old friend!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(79482,'','Fomic ore is tougher than hardened steel. You will need my goren-toothed pick axe to cut through the rock.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(79483,'','The spirits were kind to guide you to me at this moment.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(79484,'','It is done! The blade is forged.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(79486,'|TInterface\\Icons\\mocking_banner:20|t%s places a |cFFFF0000|Hspell:153799|h[Rallying Banner]|h|r to call nearby allies!','',0,0,0,0,0,0,0,0,0,0,12197,0,26124),
(79487,'','You now stand before Na\'Shra! Weaponsmith of the Frostwolf Clan. For your service, I give you mine.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(79488,'','Oops! Wrong wire. Watch out!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79491,'','You have done me a great service. This blade is as much yours as it is mine.$b$bI offer you this blood oath: I shall serve your cause and lend my knowledge of blades and mining to your forces.$b$BWill you accept it?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79492,'Accept the Blood Oath of Blademaster Na\'Shra. (Garrison Follower)','Accept the  Blood Oath of Blademaster Na\'Shra. (Garrison Follower)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79495,'You are hurt. Your flesh is pale.','',0,0,0,0,0,0,396,0,4,0,45257,0,26124),
(79496,'Bandage up those who can still walk! No orc of able body will be denied this fight.','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(79497,'So hungry.','So Hungry.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79498,'Mixing','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79499,'Reading','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79500,'The battle is joined. Lok-Narash!','',0,0,0,0,0,0,396,0,4,0,45235,0,26124),
(79501,'Reinforcements approach. Attack!','',0,0,0,0,0,0,396,0,4,0,45236,0,26124),
(79502,'The stench of a boar beast. Beware its tusks... Charge!','',0,0,0,0,0,0,396,0,4,0,45237,0,26124),
(79503,'The tower is ours! Regroup and press on!','',0,0,0,0,0,0,396,0,4,0,45238,0,26124),
(79504,'I will ride ahead. Frostwolves, hold the tower. Igrimar, with me!','',0,0,0,0,0,0,396,0,4,0,45188,0,26124),
(79505,'I will forestall any counterattacks by the enemy. Lok\'tar ogar!','',0,0,0,0,0,0,396,0,4,0,46358,0,26124),
(79506,'$p, I need you out there. There\'s no way we\'ll be able to fight them off without you.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(79507,'Disrupt Rune Conduits to weaken Gor\'ashan\'s defenses.','',0,0,0,0,0,0,0,0,0,0,12197,0,26124),
(79508,'Helga has been like this ever since she returned to camp.$b$bShe was babbling something about needing a cure -- then she started eating dirt.$b$bI am not getting paid enough for this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79509,'Why can\'t I ever catch a break?$b$bI figured tagging along with a Nesingwary was a surefire way to make some moolah.$b$bI should have stayed in Azeroth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79510,'','What about me? $p and I are a team!',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(79511,'Absolutely not. I\'m not going to lose you again.','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(79512,'','You\'re going to be ok... I promise... just hang in there...',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(79513,'The barrier is down! Let us put an end to this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79514,'Invite Helga to join the caravan?','Invite Helga to join the caravan?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79515,'','The Pale walk these lands at night. They have no morals. They attack children and the elderly without even a second thought.$b$bI will not let their horrible deeds go unpunished.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79516,'','$GHe:She;\'s coming to! $n, talk to me!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79517,'','Am I alive? Who am I? Who are we? So much pain!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79518,'','So many spiders... So many bunnies...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79519,'|TInterface\\Icons\\spell_shadow_chilltouch.blp:20|t%s casts |cFFFF0000|Hspell:154766|h[Summon Ancient Spirits]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79520,'Helga was writing in her journal when she lost it. It\'s right over here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79521,'Invisible bunnies? Sheesh... talk about crazy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79522,'I would have read it myself, but it\'s not in my job description.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79523,'You have to do what with the eyeballs? That\'s just gross.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79524,'Darksting Queen huh? Good luck with that. I\'ll be back here taking care of Helga if you need me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79525,'','I... I feel much better. Thank you, $c. Now listen carefully. We need your help.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79526,'I hope this works. I\'m living paycheck to paycheck over here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79529,'','Be careful, $n. I\'ll join you as soon as I can.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79530,'Not for long.','',0,0,0,0,0,0,0,0,0,0,45239,0,26124),
(79531,'\"Iron Wolf\" indeed! A coward, hiding behind his minions.','',0,0,0,0,0,0,0,0,0,0,44092,0,26124),
(79532,'','That\'s the third assistant I\'ve lost this week.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79533,'Stand down, Warlord. It is over.','',0,0,0,0,0,0,397,0,4,0,45240,0,26124),
(79534,'','I can\'t thank you enough, $c. This could have been a real disaster.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79535,'Could have been a disaster? I gotta find a new line of work.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79536,'...Fenris?','',0,0,0,0,0,0,0,0,4,0,45241,0,26124),
(79537,'Helga has no respect for me or any of her other assistants for that matter.$b$bAnd honsetly... the pay ain\'t all that hot.$b$bI think it\'s time I find a new employer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79538,'Fenris!','',0,0,0,0,0,0,0,0,0,0,44093,0,26124),
(79539,'Invite Greblin to join the caravan?','Invite Greblin to join the caravan?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79540,'This deal is getting worse all the time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79541,'Sure I\'ll join you. As long as the money is good and you promise I won\'t get eaten by spiders.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79542,'','Great... now I\'ve lost four assistants this week. Thanks, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79543,'','I would be happy to join you and the caravan, $n. Start packing our stuff Greblin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79544,'','*Sigh* It\'s so hard to find good help these days',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79545,'Pack it yourself. I quit. I\'m going to find a job that doesn\'t involve being eaten by spiders.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79546,'Thought we were dead, eh? LAUGHING SKULL! LAUGHING SKULL! HAHAHAHAHA!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79547,'Laughing Skull scum!','',0,0,0,0,0,0,0,1,0,24106,0,0,26124),
(79548,'What? No more fancy toys to hide behind? Getting a little scared are you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79549,'I\'m gonna cut a smile into that pretty orc face of yours!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79550,'We are going to rip your little Iron Horde apart piece by piece!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79551,'My family! My friends! My home! You burned it all and I want it back!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79552,'And that is the first name on my list. So many more names to go.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79553,'Chilltongue - devour them!','',0,0,0,0,0,0,0,0,0,0,41755,0,26124),
(79554,'It\'s cold out here.','It\'s cold out here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79555,'Sarge hears that, you\'ll be on ridge duty all winter.','Sarge hears that, you\'ll be on ridge duty all winter.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79557,'Here you go. I borrowed the wrench from Romuul to fix my spyglass. Tell him I say thank you.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79558,'','I foresaw your arrival, $n, so here is the crystal that Romuul needs.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79559,'I don\'t drink anymore, $Glad:lass;. Swore ne\'er ta down a cold one until tha day I can see me sweet Elsa once more.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79560,'Me on tha other hand, I brought plenty o\' stout ta share! Give this ta our wiggly-haired blue friend downstairs.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79561,'What are you doing?','What are you doing?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79562,'','We are too few to stop the Iron Tide dead in its tracks.$B$BBut, we can fight smartly and take full advantage of their mistakes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79563,'%s begins to |cFFFF0404|Hspell:153804|h[Inhale]|h|r his enemies!','%s begins to |cFFFF0404|Hspell:153804|h[Inhale]|h|r his enemies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79564,'','Ah, right here. This disc should contain the information that Romuul is looking for.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79565,'%s\'s piercing screech attracts nearby Carrion Worms!','%s\'s piercing screech attracts nearby Carrion Worms!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79566,'Brother, wait. Let us talk. We are still family.','',0,0,0,0,0,0,0,0,0,0,45243,0,26124),
(79567,'Champion - focus on Fenris.','',0,0,0,0,0,0,0,0,0,0,45242,0,26124),
(79568,'We\'ll take care of Chilltongue!','',0,0,0,0,0,0,0,0,0,0,44094,0,26124),
(79569,'$p, don\'t let Fenris escape!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79570,'Brother, wait. Let us talk. We are still family.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79571,'\"Family.\" You are soft - like our father!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79572,'You dare speak of our father! You gloated over his mangled corpse!','',0,0,0,0,0,0,0,0,0,0,44095,0,26124),
(79573,'A small chieftain of an insignificant clan. I saw what father didn\'t - that we could be so much more.','',0,0,0,0,0,0,0,0,0,0,41757,0,26124),
(79574,'Reinforcements! Slay the Frostwolf pups!','',0,0,0,0,0,0,0,0,0,0,41758,0,26124),
(79575,'Ga\'nar, cover the rear.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79576,'Yes, brother!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79577,'Stinking animals, all of you! Sleeping with your dogs.','',0,0,0,0,0,0,0,0,0,0,41759,0,26124),
(79578,'Orcs are meant to be masters of beasts! Masters of all!','',0,0,0,0,0,0,0,0,0,0,41760,0,26124),
(79579,'No slave fights with the will of one who is free.','',0,0,0,0,0,0,0,0,4,0,45244,0,26124),
(79580,'Finish this!','',0,0,0,0,0,0,0,0,0,0,44096,0,26124),
(79581,'Careful, brother!','',0,0,0,0,0,0,0,0,0,0,45245,0,26124),
(79582,'Animals... Your clan is finished... The Iron Horde already comes...','',0,0,0,0,0,0,0,0,0,0,41761,0,26124),
(79583,'Let them come! Traitor!','',0,0,0,0,0,0,60,0,0,0,44097,0,26124),
(79584,'The Thunderlords retreat! They are making their way through Thunder Pass to the Iron Horde.','',0,0,0,0,0,0,0,0,4,0,46384,0,26124),
(79585,'They are going to retaliate. We must be ready.','',0,0,0,0,0,0,0,0,4,0,45246,0,26124),
(79586,'How could he have done this to us?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79587,'Those were my own nephews I slaughtered in battle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79588,'What is this...?','',0,0,0,0,0,0,0,0,4,0,46385,0,26124),
(79589,'The \"Iron Wolf\" is our lost brother. Was... our brother. He was family.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79590,'No longer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79591,'We will bury him as a Thunderlord. With the honors due a chieftain. It was his choice.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79592,'Come, Durotan. If the Iron Horde wants a fight, we will give it to them. They will NEVER take the pass!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79593,'Ga\'nar... it is an honor to fight with you at my side. Brother.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79594,'','Are you okay, husband?',0,0,0,0,0,0,6,0,0,0,0,41806,26124),
(79595,'No, I will never be okay with this.','',0,0,0,0,0,0,274,0,4,0,45248,0,26124),
(79596,'Come! To Thunder Pass. We are outnumbered 50 to 1. They don\'t stand a chance!','',0,0,0,0,0,0,22,0,4,0,45249,0,26124),
(79597,'Thank you, child. I can always count on you.','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(79598,'There\'s nothing here.','There\'s nothing here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(79599,'I will speak with this slaver and see if he knows where we might find Orgrim.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79600,'In the meantime, help Drek\'Thar find some method of destroying that cannon before they find a way to move it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79601,'Bring me that ogre, $p. He will be the key to finding Orgrim in this wasteland.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79602,'Lay down your axe and warm your belly with a brew by the fire.','Lay down your axe and warm your belly with a brew by the fire.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(79603,'There! Is this what you seek, Prophet?','',0,0,0,0,0,0,25,0,4,0,0,0,26124),
(79604,'Grow! Grow!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79605,'Power in mushrooms.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79606,'More! More!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79607,'We draenei are not originally from this world. Our homeworld was named Argus, but it was taken over by the Burning Legion.','We draenei are not originally from this world. Our homeworld was named Argus, but it was taken over by the Burning Legion.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79608,'A small group of survivors, led by Prophet Velen, were able to escape and flee.','A small group of survivors, led by Prophet Velen, were able to escape and flee.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79609,'','Kron approaches! Champion, with me.',0,0,0,0,0,0,0,0,7,0,0,41798,26124),
(79610,'Once, our people had three leaders. Their names were Velen, Archimonde, and Kil\'jaeden.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79611,'When the Burning Legion came to Argus, Velen was the only one who resisted their promise of immortality and power.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79612,'Kil\'jaeden leads the Burning Legion\'s demonic army. Once, he was a wise leader of our people, but he fell to the dark promises of the enemy.','Kil\'jaeden leads the Burning Legion\'s demonic army. Once, he was a wise leader of our people, but he fell to the dark promises of the enemy.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79613,'He would chase us to the end of the universe to see our people destroyed.','He would chase us to the end of the universe to see our people destroyed.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79614,'After our ancestors fled from Argus, they traveled across the stars seeking refuge from the Burning Legion.','After our ancestors fled from Argus, they traveled across the stars seeking refuge from the Burning Legion.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79615,'One day, the ships\' energy source, powered by the brilliant light of the naaru, died out. They jettisoned the source from the ship, but it was too late.','One day, the ships\' energy source, powered by the brilliant light of the naaru, died out. They jettisoned the source from the ship, but it was too late.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79616,'Naaru are wise and powerful beings of pure Light. It was a naaru who came to Prophet Velen and helped engineer our escape from the Burning Legion.','Naaru are wise and powerful beings of pure Light. It was a naaru who came to Prophet Velen and helped engineer our escape from the Burning Legion.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79617,'Much about them is still unknown, but when a naaru\'s energy is depleted, it inverts into a darkened state.','Much about them is still unknown, but when a naaru\'s energy is depleted, it inverts into a darkened state.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79618,'Dark naaru are beings of pure shadow, and fearsome to behold.','Dark naaru are beings of pure shadow, and fearsome to behold.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79619,'If I try to release Exurotus it is sure to bring Kron down on us.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(79620,'As pieces of the ship exploded around them, they navigated toward the closest world - a tranquil, untamed land we would later call Draenor.','As pieces of the ship exploded around them, they navigated toward the closest world - a tranquil, untamed land we would later call Draenor.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79621,'We have company, Master.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(79622,'Tagar, deal with the intruder.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(79623,'Champion! I heard Drek\'Thar\'s call. I am with you!','',0,0,0,0,0,0,0,0,0,0,46374,0,26124),
(79624,'Frostwolves! The Iron Horde is coming. As we speak, they march on Thunder Pass.','',0,0,0,0,0,0,1,0,4,0,45215,0,26124),
(79625,'But the Frostwolf clan is reunited! Together, we can protect this land!','',0,0,0,0,0,0,71,0,4,0,45216,0,26124),
(79626,'Lok-Narash, Frostwolves! Prepare for battle!','',0,0,0,0,0,0,113,0,4,0,45217,0,26124),
(79627,'You know me, brother. I\'m always ready to fight.','',0,0,0,0,0,0,0,0,4,0,44076,0,26124),
(79628,'We will hold the line here.','',0,0,0,0,0,0,1,0,0,0,45218,0,26124),
(79629,'','Drek\'Thar, you can speak with the earth. Do you think you can collapse this canyon?',0,0,0,0,0,0,6,0,0,0,0,41784,26124),
(79630,'Stop them! They can\'t be allowed to disturb the master from his trance!','Stop them! They can\'t be allowed to disturb the master from his trance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79631,'It would be a momentous task... I cannot make any promises.','',0,0,0,0,0,0,274,0,0,0,46650,0,26124),
(79632,'I can. Shaman, if you bring that cliff wall down, I promise that our enemy will be waiting right underneath it.','',0,0,0,0,0,0,397,0,0,0,44077,0,26124),
(79633,'Then I will do my best.','',0,0,0,0,0,0,273,0,0,0,46651,0,26124),
(79634,'You\'d better hurry!  Here they come!','',0,0,0,0,0,0,1,0,0,0,46362,0,26124),
(79636,'You mustn\'t awaken the master!','You mustn\'t awaken the master!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79637,'Kill them!','Kill them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79638,'Hold your position, Frostwolves! Let them come to you!','',0,0,0,0,0,0,5,0,4,0,45219,0,26124),
(79639,'Bring me more! Your Iron Horde can bleed on my axe!','',0,0,0,0,0,0,0,0,0,0,44078,0,26124),
(79640,'Axes up! Here they come again!','',0,0,0,0,0,0,0,0,4,0,45220,0,26124),
(79641,'We can\'t fight with this cannon fire coming down. Thrall! $p! Take care of that tank!','',0,0,0,0,0,0,0,0,4,0,45221,0,26124),
(79642,'Dabu!','',0,0,0,0,0,0,0,0,0,0,46363,0,26124),
(79643,'You fight like no shaman I have ever seen.','',0,0,0,0,0,0,0,0,0,0,46652,0,26124),
(79644,'I was taught by the best... Drek\'thar.','',0,0,0,0,0,0,0,0,0,0,46364,0,26124),
(79645,'You should tell your teacher to rely less on the hammer, and more on his brains.','',0,0,0,0,0,0,0,0,0,0,46653,0,26124),
(79646,'He would be pleased to hear you say that.','',0,0,0,0,0,0,0,0,0,0,46365,0,26124),
(79647,'...no, not really.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79648,'Get back here! They\'ll be rallying again soon!','',0,0,0,0,0,0,0,0,0,0,45222,0,26124),
(79649,'Durotan, this isn\'t a choke point... it\'s a meat grinder!','',0,0,0,0,0,0,0,0,0,0,45053,0,26124),
(79650,'','...and yet they still they keep coming.',0,0,0,0,0,0,0,0,0,0,0,41785,26124),
(79651,'I know! That\'s the best part!','',0,0,0,0,0,0,0,0,0,0,44080,0,26124),
(79652,'Durotan! I need help!','',0,0,0,0,0,0,0,0,0,0,46654,0,26124),
(79653,'Drek\'Thar\'s in trouble. Ga\'nar, get out there and lend him a hand.','',0,0,0,0,0,0,0,0,4,0,45223,0,26124),
(79654,'Thought you\'d never ask, brother.','',0,0,0,0,0,0,0,0,0,0,44081,0,26124),
(79655,'You go too, $p.  Make sure my brother doesn\'t get himself killed.','',0,0,0,0,0,0,0,0,4,0,45224,0,26124),
(79656,'I can still hear you!','',0,0,0,0,0,0,0,0,0,0,44082,0,26124),
(79657,'Thank you. I owe you my life.','Thank you. I owe you my life.',0,0,0,0,0,0,0,0,0,0,46655,46655,26124),
(79658,'Save the embraces for later, shaman. I\'ve got a kill streak going.','',0,0,0,0,0,0,0,0,0,0,44083,0,26124),
(79659,'Fall back! Prepare for the next attack!','',0,0,0,0,0,0,0,0,4,0,45225,0,26124),
(79660,'','I smell Thunderlords...',0,0,0,0,0,0,0,0,0,0,0,41786,26124),
(79661,'Spears incoming! Hold your ground!','',0,0,0,0,0,0,0,0,4,0,45226,0,26124),
(79662,'Here comes another elekk!','',0,0,0,0,0,0,0,0,0,0,46368,0,26124),
(79663,'','Another elekk on the way!',0,0,0,0,0,0,0,0,0,0,0,41787,26124),
(79664,'Durotan! Tell your pups to come out of the kennel!','',0,0,0,0,0,0,0,0,0,0,41903,0,26124),
(79665,'Hero, approach my totem for aid!','',0,0,0,0,0,0,0,0,4,0,46665,0,26124),
(79666,'','This one\'s mine.',0,0,0,0,0,0,0,0,0,0,0,41788,26124),
(79667,'I\'ll be waiting.','',0,0,0,0,0,0,0,0,4,0,45227,0,26124),
(79668,'','Come back me up, $p.',0,0,0,0,0,0,0,0,0,0,0,41789,26124),
(79669,'Look at this cute little puppy you\'ve sent me, Durotan! Does she know any tricks?','',0,0,0,0,0,0,0,0,0,0,41904,0,26124),
(79670,'','Yeah. A few.',0,0,0,0,0,0,0,0,0,0,0,41790,26124),
(79671,'Come here, puppy. I want to play FETCH.','',0,0,0,0,0,0,0,0,0,0,41905,0,26124),
(79672,'','Well... if it\'ll make you happy, then LET\'S PLAY!',0,0,0,0,0,0,0,0,0,0,0,41791,26124),
(79673,'Draka... come join me in the Iron Horde.  Lose that armor, and settle down with a REAL MAN.','',0,0,0,0,0,0,0,0,0,0,41906,0,26124),
(79674,'','A real man treats his mate with respect!',0,0,0,0,0,0,0,0,0,0,0,41792,26124),
(79675,'','...and he probably would have caught that axe.',0,0,0,0,0,0,0,0,0,0,0,41793,26124),
(79676,'Frostwolves! Stand strong! The battle is nearly done!','',0,0,0,0,0,0,0,0,4,0,45228,0,26124),
(79677,'Drek\'Thar! How much time do you need?','',0,0,0,0,0,0,0,0,4,0,45229,0,26124),
(79678,'Only a bit longer!','',0,0,0,0,0,0,0,0,0,0,46656,0,26124),
(79679,'We are counting on you, shaman!','',0,0,0,0,0,0,0,0,4,0,45230,0,26124),
(79680,'Chieftain, do you hear that rumbling?','',0,0,0,0,0,0,0,0,0,0,46369,0,26124),
(79681,'I do. Something big is coming.','',0,0,0,0,0,0,0,0,4,0,45231,0,26124),
(79682,'Good. I\'ve been waiting for the big one.','',0,0,0,0,0,0,0,0,0,0,44084,0,26124),
(79683,'GRONN!','',0,0,0,0,0,0,0,0,4,0,45232,0,26124),
(79684,'All Frostwolves - charge ahead! Take that thing down!','',0,0,0,0,0,0,0,0,4,0,45233,0,26124),
(79685,'Lok\'tar ogar!','',0,0,0,0,0,0,0,0,0,0,46370,0,26124),
(79686,'For the Frostwolves!','',0,0,0,0,0,0,0,0,0,0,44085,0,26124),
(79687,'','For our home! For our family!',0,0,0,0,0,0,0,0,0,0,0,41794,26124),
(79688,'','I\'m alive!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79689,'If the Thunderlords are to be believed, then the Iron Horde is on its way. It falls on us to prevent them from taking Frostfire Ridge by force.$b$bWe should move forward and defend our homeland at once!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79690,'Let\'s move forward.','Let\'s move forward.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79691,'Draka, make your way to the cave the scout spotted. I will meet the commander at the coastal village.','',0,0,0,0,0,0,396,0,4,0,45291,0,26124),
(79692,'Champion, we will meet you ahead when you are done with your mission.','',0,0,0,0,0,0,396,0,4,0,45292,0,26124),
(79693,'','Great Prophet! Ner\'zhul is taking the captives to Shaz\'gul.',0,0,0,0,0,0,1,0,0,0,0,45639,26124),
(79694,'BWAAAR! Work harder filthy slave things!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(79695,'Puny workers make me so ANGRY! RARGH!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(79696,'Work or me gonna bash yer skulls!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(79697,'P-please... somebody... anybody...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79698,'','Lead it away from Drek\'Thar!',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(79699,'Light p-protect you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79700,'Returning to job, infirmary.','Returning to job, infirmary.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79701,'Going on break.','Going on break.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79702,'I will save my clan, even if I must forfeit the souls of my ancestors.','',0,0,0,0,0,0,0,0,0,0,43693,0,26124),
(79703,'Without you, I would still be in that jungle, or worse.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(79704,'Let\'s go meet Durotan.','Let\'s go meet Durotan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79705,'','We have to stop Teron\'gor and his Bonechewer allies from breaking into Auchindoun at all costs.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79706,'Exurotus is too weak. The most I can do is free him of his bonds. Death will claim him shortly afterward.','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(79707,'If I were stronger...','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(79708,'','There must be something you can do.',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(79709,'The fury is dying. We don\'t have much time.','',0,0,0,0,0,0,0,0,6,0,46375,0,26124),
(79710,'There might be something. Exurotus, I offer my spirit as host to your own. Join with me, so that your fire may not be quenched.','',0,0,0,0,0,0,0,0,6,0,46669,0,26124),
(79711,'','I\'m glad you\'re here, $n. Our forces are stretched thin. I need someone I can count on.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79712,'MY SPIRIT... BURNS!','',0,0,0,0,0,0,0,0,6,0,46670,0,26124),
(79713,'','Drek\'Thar, what has it done to you?',0,0,0,0,0,0,0,0,7,0,0,41800,26124),
(79714,'He has become one with the fury. Their spirits are now merged.','',0,0,0,0,0,0,0,0,6,0,46376,0,26124),
(79715,'','The Auchenai are not prepared to defend against an assault like this. Auchindoun is a mausoleum, not a fortress. They need our help.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79716,'I... I can see. I can see the shift of the elements, the movement of the spirits through the land. It is glorious.','',0,0,0,0,0,0,0,0,6,0,46671,0,26124),
(79717,'','If Teron\'gor devours the souls within, the results would be catastrophic.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79718,'The ogres will suffer for what they\'ve done!','',0,0,0,0,0,0,396,0,4,0,0,0,26124),
(79719,'We are not prepared to defend against an assault like this. Auchindoun is a mausoleum, not a fortress.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79720,'$n, we must stop Teron\'gor and his Bonechewer allies from breaking into Auchindoun at all costs.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79721,'If Teron\'gor devours the souls within, the results would be catastrophic.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79722,'You are too late, hero. Your world will be cast into shadow!','',0,0,0,0,0,0,153,0,0,0,0,0,26124),
(79723,'I\'m ready to go, Exarch.','I\'m ready to go, Exarch.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79724,'Light bless you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79729,'Help me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79730,'Coming, $n?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79731,'Is he dead? I think he was saving me for later. Come on Icepaw, let\'s get out of here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79732,'The last time I saw Orac, he was chasing Icepaw out the southern gates of Wor\'gol.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79733,'You should have seen it uncle! I had that filthy Saberon right where I wanted him.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79734,'Is that right? Good job, Orac. You will make a fine hunter one day.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79735,'None escape the Void!','',0,0,0,0,0,0,0,0,0,0,43204,0,26124),
(79736,'We will secure our borders!','We will secure our borders!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(79737,'Once Master Blackheart\'s portal is active, he will come to take the key to the Master.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79738,'The Master needs the key fragment. We will protect it until Lord Blackheart arrives!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79739,'This world will be ours, just as the Master foretold.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79740,'This wolf has been gutted and left to rot.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79741,'','Your pitiful weapons are useless against our Goliath Cannon!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79742,'','How did you survive the Goliath Cannon?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79743,'','Our Goliath Cannon will destroy all that you hold dear.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79755,'Darkness is my strength! With this power, the Shadowmoon will be conquerors!','',0,0,0,0,0,0,0,0,0,0,43694,0,26124),
(79756,'Huh? I must have passed out. I suppose a warm fire and hot meal with my family wouldn\'t be so bad.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79757,'Flowers?! Noooooo!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(79758,'Please... no flowers...','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(79759,'Not me! Not now!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(79760,'Not like this...','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(79761,'The legends are true!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(79762,'Anything but flowers!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(79763,'I hate cooking duty. I should be out there hunting.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79764,'Flowers?','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(79765,'No matter. You are too late!','',0,0,0,0,0,0,0,0,0,0,43697,0,26124),
(79766,'Deal with these, insects!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79767,'Teron\'gor comes for you, mortal...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79768,'Kill it. It threatens the master!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79769,'Juicy innards, so fresh...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79770,'Kill it, eat it, burn it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79771,'','Krunk sent you huh? I was just finishing up. I\'ll see you back at camp.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79772,'I\'m not going back until I\'m finished here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79773,'This will make a perfect gift for Raa\'la. Thank you, $n. I\'ll meet you back at camp when I\'m done here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79775,'|TInterface\\Icons\\ability_druid_astralstorm.blp:20|t%s casts |cFFFF0000|Hspell:155105|h[Soul Storm]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79776,'Your health is low!$b$bThe Frostwolf healers are located behind the choke point.','Your health is low!$b$bThe Frostwolf healers are located behind the choke point.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79777,'','Hmm. And what are you supposed to be? Are you with the iron orcs? Shall we see if you burn as well as they do?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79778,'Durotan wishes for an alliance.','Durotan wishes for an alliance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79779,'','On behalf of the Frostwolf clan, I greet you, $c.',66,0,0,500,0,0,0,1,0,0,0,0,26124),
(79780,'The pain of this stake is nothing compared to that of my failure...','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(79781,'My heart aches with grief for the loss of my kin...','',66,0,0,500,0,0,0,1,0,0,0,0,26124),
(79782,'','So the wolves have come to play with the skulls? I will speak with Durotan but I will not hold out hope. His wolves are soft and lack conviction.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(79783,'They were saving me for dessert!','Boy am I glad to see you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79784,'Thanks pal! I\'d offer you a reward but you don\'t seem like the type!','I never thought I would get out of here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79785,'Thanks, friend! I\'ll let you buy me a drink back at the arena!','They took my coin purse too...got any gold I can borrow?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79786,'They were going to eat me!','I thought I was done for! Thanks pal!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79787,'Those dirty bags of fur came out of nowhere!','How could this happen to me?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79788,'Ahhh!!!!! Finish it! Just let me die!','',0,0,0,0,0,0,0,0,4,24312,0,0,26124),
(79789,'Emma was here recently. Follow her trail up the hill!','Emma was here recently. Follow her trail up the hill!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79790,'1...','1...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79791,'2...','2...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79792,'3...','3...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79793,'I\'m almost certain it\'s Yrel, but Maraad can\'t afford the distraction right now. If she\'s alive, we\'ll rescue her.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(79794,'Discovered Shamanstone: Blessing of the Wolf','Discovered Shamanstone: Blessing of the Wolf',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79795,'Discovered Shamanstone: Spirit of the Wolf','Discovered Shamanstone: Spirit of the Wolf',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79796,'Discovered Shamanstone: Touched by Fire','Discovered Shamanstone: Touched by Fire',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79797,'Touched by Ice','Touched by Ice',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79798,'Discovered Shamanstone: Buffeting Galefury','Discovered Shamanstone: Buffeting Galefury',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79799,'Discovered Shamanstone: Ogrish Fortitude','Discovered Shamanstone: Ogrish Fortitude',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79800,'$p, speak with Kaz to see if she has some ideas on other ways in which to disrupt the Blackrock Outpost.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79801,'Buffeting Galefury','Buffeting Galefury',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79802,'Ogrish Fortitude','Ogrish Fortitude',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79803,'Touched by Fire','Touched by Fire',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79804,'Discovered Shamanstone: Touched by Ice','Discovered Shamanstone: Touched by Ice',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79805,'And here\'s where they caught up with her.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(79806,'Duck!','Duck!',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(79807,'Whoa!','Whoa!',0,0,0,0,0,0,412,0,0,0,0,0,26124),
(79808,'Ahhh!','Ahhh!',0,0,0,0,0,0,430,0,0,0,0,0,26124),
(79809,'What on Draenor?!','What on Draenor?!',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(79810,'Curses!','Curses!',0,0,0,0,0,0,14,0,0,0,0,0,26124),
(79811,'Ack!','Ack!',0,0,0,0,0,0,33,0,0,0,0,0,26124),
(79812,'Oof!','Oof!',0,0,0,0,0,0,34,0,0,0,0,0,26124),
(79813,'Watch out!','Watch out!',0,0,0,0,0,0,34,0,0,0,0,0,26124),
(79814,'The intruders are here! Shadowmoon orcs, take your positions!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79815,'Gunners, roll out! Don\'t let them into the hold!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79816,'Oh, nelly, ain\'t she a big \'un? Ya need ta get back up there an\' tell Maraad.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(79817,'Don\'t let them through! Release the wolves!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79818,'DIE!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79819,'','I am trying to divine Ner\'zhul\'s plans, but alas, I have nothing yet.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79820,'No excuses, Kor\'gall. We are at WAR with another world. Motivate your people, get a mining pick yourself, I do not care. You WILL meet your quota or find your clan the target of our next weapon test.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(79821,'Here, let me make some adjustments.','',0,0,0,0,0,0,0,7,6,0,0,0,26124),
(79822,'There ya go.','',0,0,0,0,0,0,0,7,6,0,0,0,26124),
(79823,'And while you\'re in there, get the main cannon firing again.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(79824,'Dis gonna be bad...','',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(79825,'But...me afraid of heights!','',1,0,0,0,0,0,1,1,0,0,0,0,26124),
(79826,'Me fly like birdy? Me no have wings!','',1,0,0,0,0,0,1,1,0,0,0,0,26124),
(79827,'I can feel my lord\'s power... coursing through my veins...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79828,'DIE IN THE NAME OF TERON\'GOR!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(79829,'I will use Auch\'naaru to enact your will, my lord!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(79830,'Teron\'gor said... we would have the bodies... and he would eat the souls...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79832,'There were too many of them.','There were too many of them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79833,'Is that the best you can do?','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(79834,'Filthy coward.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(79835,'Hansel! What\'s going on down there?!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(79836,'Find these Iron Horde cowards. Give them the Light\'s justice.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(79837,'No mercy for the likes of you.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(79838,'The Iron Horde\'s days are numbered.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(79839,'Thaelin, I want the Tank ready to go. Now!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(79840,'Is there no end to these orcs?','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(79841,'We\'re saved! Thank you, hero.','We\'re saved! Thank you, hero.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79842,'Kor\'gall, your guards are worthless. Dispose of this invader.','',0,0,0,0,0,0,0,0,0,24360,0,0,26124),
(79843,'Durotan? Draka? What are YOU doing here?','',0,0,0,0,0,0,0,0,7,24360,0,0,26124),
(79844,'Agreed, Soulbinder. We cannot risk leaving Auchindoun vulnerable even for a moment. We will stand our ground with what forces we have left.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(79845,'Orgrim Doomhammer! You will be made to answer for your attack on my people!','',0,0,0,0,0,0,0,0,7,24360,0,0,26124),
(79846,'You will bow before me as you beg for death.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79847,'Did you mistake me for one of those weak creatures we have you fight in the arenas?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79848,'Your Iron Horde murdered my brother, threatened my people, and deal in slaves and blood. You would have us work with that?','',0,0,0,0,0,0,0,0,0,24360,0,0,26124),
(79849,'Stay your hand, hero. I want him alive.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(79850,'','Auchindoun is safe as long as it is kept sealed. We need to retrieve the fragments so my priests can protect them.',0,0,0,0,0,0,1,0,0,0,0,43630,26124),
(79851,'I have not forgotten or forgiven that. But Orgrim was once an honorable orc, and my closest friend. I owe it to him to at least try to help him regain some of his honor.','',0,0,0,0,0,0,0,0,7,24372,0,0,26124),
(79852,'Always sentimental, Durotan. I am as loyal to my people as you are to yours. Do not presume that I walk this path willingly. Some things are more important than honor.','',0,0,0,0,0,0,0,0,7,24372,0,0,26124),
(79853,'','Husband? It was his forces that killed your brother.',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(79854,'That\'s enough. We don\'t have the men to spare. We\'re staying here.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(79855,'The Dark Emanation breaks free of its bonds!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79856,'','We have to get to the other shards before it\'s too late.',0,0,0,0,0,0,5,0,0,0,0,43629,26124),
(79857,'','Wait, $n... I will come with you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79858,'INCOMING! TAKE COVER!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(79859,'Friends, be ready to move out. This hero is going to secure us an entrance in to that slave camp!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79860,'For Doomhammer!','For Doomhammer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79861,'Another shot like that from the Iron Horde and we\'re done. We need to destroy whatever\'s firing those massive rounds.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(79862,'Satchel charges are all over the place in there. But, we\'ll have to go all the way to the bottom to get the big cannon firing again.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(79863,'Follow me, $n. I will perform last rites on my fallen brethren. You rid the temple of any Iron Horde stragglers.','Follow me, $n. I will perform last rites on my fallen brethren. You rid the temple of any Iron Horde stragglers.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79864,'There\'s the button. Press it to restart the Big Cannon.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(79865,'I am ready to go.','I am ready to go.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79866,'See if Hansel needs anything on your way down.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(79873,'So much for subtlety. Those Laughing Skull are going to get us all killed.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(79874,'Hmph. I remember ogre architecture being more formidable.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(79875,'I\'ll kill you like I killed the rest of them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79876,'Thank the Light you came when you did.','Thank the Light you came when you did.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79881,'','May the Light guide our blades into the hearts of our enemies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79882,'I\'m ready to go when you are.','I\'m ready to go when you are',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79883,'','Let\'s go, $p.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79884,'You sack of useless worms for brains! Why isn\'t that wheel fixed yet?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79885,'A rock could fix that wheel faster than you!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79886,'Get that wheel repaired or I\'ll throw you to the Pale! Hurry up!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79887,'Are the repairs finished yet? The Shadowmoon are waiting for us.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79888,'Thank you for saving me, hero. They\'re taking more prisoners on top of the mountain!','Thank you for saving me, hero. They\'re taking more prisoners on top of the mountain!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79889,'<Move out to Spineling Crevice.>','<Move out to Spineling Crevice.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79890,'Velen sent me. We seek information about Ner\'zhul.','Velen sent me. We seek information about Ner\'zhul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79891,'','Welcome to my fire, traveler. I know much of Ner\'zhul, and yet these days, I know him not at all.',0,0,0,0,0,0,1,0,0,0,0,43240,26124),
(79892,'I issued no such order. I wanted your people to join us and protect this world from the threat of those beyond the portal.','',0,0,0,0,0,0,0,0,7,24360,0,0,26124),
(79893,'Vehicle Control Overridden. Returning to Creator.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79895,'Hello traveler. Where would you like to fly today?','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(79897,'I am glad you see the wisdom in this course, Durotan. I hope Maraad and the Alliance do as well.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79898,'I have never held the prejudices against the Draenei that some of my people do, Khadgar.','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(79899,'There is reason in your plan, and I agree to take part. My clan will stay its hand when we enter the city.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79900,'You can trust in Khadgar\'s plan, Durotan. His cause is just and motivations are noble.','',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(79901,'You are my vanguard.','',0,0,0,0,0,0,0,0,6,0,46072,0,26124),
(79902,'These shores are ours!','',0,0,0,0,0,0,0,0,6,0,46074,0,26124),
(79903,'Leave no enemy alive!','',0,0,0,0,0,0,0,0,6,0,46075,0,26124),
(79904,'Iron will, iron blood.','',0,0,0,0,0,0,0,0,6,0,46076,0,26124),
(79905,'Go forth to victory!','',0,0,0,0,0,0,0,0,6,0,46077,0,26124),
(79907,'Commander.$B$BWe\'ve secured Lok-rath and the Warsong.$B$BI await your orders.','',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(79908,'','We cannot allow the Warsong to continue to nip at our heels.$B$BWe cannot allow the ogres of Highmaul to regain the glory of their lost Gorian Empire.$B$BWe must protect our own and bring justice to Nagrand before it brings ruin upon us.',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(79909,'Not long ago, we were orcs of many clans, quibbling over scraps in a world that was ours for the taking.','',0,0,0,0,0,0,0,0,6,0,46085,0,26124),
(79910,'Now, as one clan, no enemy can hope to stand against the Iron Horde!','',0,0,0,0,0,0,0,0,6,0,46086,0,26124),
(79911,'We will crush their bones beneath our boots.  We will burn their cities to ash!','',0,0,0,0,0,0,0,0,6,0,46087,0,26124),
(79912,'The iron tide washes over them!','',0,0,0,0,0,0,0,0,6,0,46088,0,26124),
(79913,'Closing','Closing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(79914,'The doom that is coming will destroy us all. These outsiders will bring a wave of fire and death down upon us if the orcs do not act as one to destroy them first.','',1,0,0,0,0,0,0,0,7,0,0,0,26124),
(79915,'Because I have witnessed it! Every night! Every night for many months now. My dreams become nightmares, and in those nightmares I watch helplessly as the land corrupts beneath our feet and the sky is turned to fire.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(79916,'Say what you will, but this is the doom that is coming. And it is these creatures from beyond the portal that will bring it.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(79917,'And how can you be so certain of such a fate?','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(79918,'','I have never known the great Doomhammer to be afraid of anything.',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(79919,'Cho\'gall! I sent you here to enslave this thing.','',0,0,0,0,0,0,0,0,6,0,45313,0,26124),
(79920,'','Be careful not to get overwhelmed! They pack a punch!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79921,'Let\'s begin the assault!','Let\'s begin the assault!',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(79922,'If we are able to repel the Iron Horde from Shattrath, it will be a great blow to their strategy. If we manage to take out their Superweapon as well...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79923,'Take these torches and cleanse our temple of the fallen Orcs.','Take these torches and cleanse our temple of the fallen Orcs.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79924,'You will be forever missed, my dear friend.','You will be forever missed, my dear friend.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79925,'Velen will seek justice for this travesty, of this I am certain.','Velen will seek justice for this travesty, of this I am certain.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79926,'','Have you seen my parents?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79927,'You there! Please... can\'t breathe...','',0,0,0,0,0,0,0,0,0,24440,0,0,26124),
(79928,'I do not know who you are, but I will not forget your actions this day.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79929,'Lok\'tar... friend. Let us meet above here at my village.','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(79930,'','Yes! Let us free ALL of the skulls! Remind them how to laugh! Burn all of the slavers to ash and ruin!',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(79931,'Hrah ha ha ha ha! It\'s stabbing time!','Hrah ha ha ha ha! It\'s stabbing time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79932,'Stab all of the things!','Stab all of the things!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79933,'Burn the slavers! Whip their hides! Make them crawl!','Burn the slavers! Whip their hides! Make them crawl!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79934,'Ogres are going to fear the Skulls again!','Ogres are going to fear the Skulls again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79935,'I\'m baaaack!','I\'m baaaack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79936,'It... is... ogre stabbing time!','It... is... ogre stabbing time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79937,'Thank you, $n. We are in your debt.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(79938,'I heard ogres with one eye are smarter than those with two. Perhaps we should test this?','I heard ogres with one eye are smarter than those with two. Perhaps we should test this?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79939,'Death awaits you, traitor...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79940,'Taking all bets. How many pokes with my poking stick until this slaver scum squeals?','Taking all bets. How many pokes with my poking stick until this slaver scum squeals?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79941,'Oh, we will get you to laugh. They always laugh... before the end.','Oh, we will get you to laugh. They always laugh... before the end.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79942,'I wonder. Will the wolves will let us keep you?','I wonder. Will the wolves will let us keep you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79943,'Ah, the great one who is neither a wolf or a skull.$b$bWill you chose a banner you will answer to? Or will the banners answer to you in the end, I wonder.','Ah, the great one who is neither a wolf or a skull.$b$bWill you chose a banner you will answer to? Or will the banners answer to you in the end, I wonder.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79944,'Many thanks, great one, for reminding me of who and what I really am. May the Iron Horde dread the day they remember who and what I really am.','Many thanks, great one, for reminding me of who and what I really am. May the Iron Horde dread the day they remember who and what I really am.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79945,'You have earned the aid of the skulls, hero. Try not to get as squeamish as one of your wolves when you learn what that truly means.','You have earned the aid of the skulls, hero. Try not to get as squeamish as one of your wolves when you learn what that truly means.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79946,'I look forward to stabbing your enemies in the face.','I look forward to stabbing your enemies in the face.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79947,'Limbflayer says you saved him from a burning building. Did you also save the money he owes me?','Limbflayer says you saved him from a burning building. Did you also save the money he owes me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79948,'','LAUGHING...',0,0,0,0,0,0,0,0,0,24417,0,0,26124),
(79949,'SKULLS!','SKULLS!',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(79950,'Witness our power! Iron will, iron blood!','',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(79951,'Destroy the Heat Regulators to release the Heart of the Mountain inside the furnace.','Destroy the Heat Regulators to release the Heart of the Mountain inside the furnace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79952,'|TInterface\\Icons\\ability_foundryraid_bellows.blp:20|tThe Bellows Operators are increasing the heat of the furnace, defeat them quickly to stop the heat level from increasing.','|TInterface\\Icons\\ability_foundryraid_bellows.blp:20|tThe Bellows Operators are increasing the heat of the furnace, defeat them quickly to stop the heat level from increasing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79953,'One Pressure Regulator has been destroyed. One remains.','One Pressure Regulator has been destroyed. One remains.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79954,'Both Heat Regulators have been destroyed. The Heart of the Mountain is unleashed!','Both Heat Regulators have been destroyed. The Heart of the Mountain is unleashed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79955,'Defeat the Primal Elementalists to release the Heart of the Mountain from its bindings.','Defeat the Primal Elementalists to release the Heart of the Mountain from its bindings.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79956,'Three Primal Elementalists remain.','Three Primal Elementalists remain.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79957,'Two Primal Elementalists remain.','Two Primal Elementalists remain.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79958,'One Primal Elementalist remains.','One Primal Elementalist remains.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79959,'All Primal Elementalists have been defeated. The Heart of the Mountain is free!','All Primal Elementalists have been defeated. The Heart of the Mountain is free!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79960,'Protect the furnace at all costs!','',0,0,0,0,0,0,0,0,0,0,44390,0,26124),
(79961,'Get those billows pumping!','',0,0,0,0,0,0,0,0,0,0,44392,0,26124),
(79962,'Turn up the heat boys, we\'ll sweat \'em out!','',0,0,0,0,0,0,0,0,0,0,44393,0,26124),
(79963,'Call in more security!','',0,0,0,0,0,0,0,0,0,0,44394,0,26124),
(79964,'The Fury has broken free!','',0,0,0,0,0,0,0,0,0,0,44395,0,26124),
(79965,'I will crush you!','',0,0,0,0,0,0,0,0,0,0,44399,0,26124),
(79966,'Die scum!','',0,0,0,0,0,0,0,0,0,0,44400,0,26124),
(79967,'RAWR!','',0,0,0,0,0,0,0,0,0,0,44401,0,26124),
(79968,'Smash!','',0,0,0,0,0,0,0,0,0,0,44402,0,26124),
(79969,'Weak!','',0,0,0,0,0,0,0,0,0,0,44396,0,26124),
(79970,'Pathetic!','',0,0,0,0,0,0,0,0,0,0,44397,0,26124),
(79971,'awww...aaaaggg...','',0,0,0,0,0,0,0,0,0,0,44391,0,26124),
(79972,'','The Fury has broken free!',0,0,0,0,0,0,0,0,0,0,0,42891,26124),
(79973,'','Quick, get it under control!',0,0,0,0,0,0,0,0,0,0,0,42892,26124),
(79974,'Guards! Intruders are meddling with the Blast Furnace!','',0,0,0,0,0,0,0,0,0,0,45466,0,26124),
(79975,'The machinery is damaged. Keep those scum from sabotaging the furnace!','',0,0,0,0,0,0,0,0,0,0,45463,0,26124),
(79976,'The furnace is overheating! Fools, if the Fury breaks free, our work will be ruined!','',0,0,0,0,0,0,0,0,0,0,45464,0,26124),
(79977,'Fury under control, sending in additional security personel to clear intruders from the area.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79978,'We\'re losing containment personnel. Get it together security teams!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79979,'A small victory, but now you will perish in the flame that burns at the heart of Blackrock!','',0,0,0,0,0,0,0,0,0,0,45465,0,26124),
(79980,'Enjoy your victory while you can. The fires of the Blast Furnace are but a candle to the heart of the volcano where you\'ll face me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79981,'|TInterface\\Icons\\ability_fixated_state_red.blp:20|t%s |cFFFF0404|Hspell:154952|h[Fixates]|h|r on you!','|TInterface\\Icons\\ability_fixated_state_red.blp:20|t%s |cFFFF0404|Hspell:154952|h[Fixates]|h|r on you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(79983,'Stand strong, defenders of Karabor! Carry the light with you!','',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(79984,'Together we can repel these orcs!','',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(79985,'Let the Light carry you through this battle!','',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(79986,'The Iron Tide will wash over our enemies!','',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(79987,'Aaaaaaaaaaahhhhhhhh! Ha ha ha!','',0,0,0,0,0,0,0,0,7,0,40185,0,26124),
(79988,'Fire! Fire! Waa-aaaaaa! Ha!','',0,0,0,0,0,0,0,0,7,0,40185,0,26124),
(79989,'...TREMOR-TRACKER V.2.6 ONLINE...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79990,'...TRACKING...FAILED::REDUCING FOCAL DEPTH....TRACKING...FAILED::REDUCING FOCAL DEPTH...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79991,'Drogguk was a proud orc. Thank you for bringing honor to his death.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(79992,'...HYPOCENTER DISPLACEMENT::TWENTY PERCENT...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79993,'...WARNING::INCOMING BODY WAVE...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79994,'...WARNING::GROUND FAILURE DETECTED...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79995,'See what I mean? We cannot pinpoint the source of the activity...','',0,0,0,0,0,0,547,0,0,0,0,0,26124),
(79996,'Huh... the source is moving? How is that even possible?!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(79997,'Uh oh... Brace yerself!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(79998,'\"Ground failure?\" Oh, ye think?! It\'s spittin\' out orcs!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(79999,'...TRACKING...NEW HYPOCENTER DETECTED...TRACKING...DISPLACEMENT::FIFTY PERCENT...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80000,'Here comes another one!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80001,'...WARNING::GROUND FAILURE IMMINENT...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80002,'ALRIGHT, WE GET IT.','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(80003,'...TRACKING...NO ACTIVITY DETECTED...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80004,'...FINAL ANALYSIS::ACTIVITY SOURCE DETERMINED TO BE UNNATURAL...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80005,'...THANK YOU FOR USING TREMOR-TRACKER...HAVE A NICE DAY...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80006,'Oh, thank my boots it\'s over...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80007,'Aye, brilliant analysis. Thanks.','',0,0,0,0,0,0,14,0,0,0,0,0,26124),
(80008,'','I\'ll give you goren something to eat!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80009,'','Yrel.... noooo!',0,0,0,0,0,0,0,0,0,0,0,43223,26124),
(80010,'Champion, we will secure the road.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80011,'K\'ara has chosen you to break the siege - the naaru\'s power will enhance you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80012,'Yrel, where is Prophet Velen?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80013,'','Prophet Velen is... no more.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80014,'','But his light is within all of us now. Nothing can stop us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80015,'Champion, go! Cleanse that base!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80016,'Let us leave this place. Yrel has already returned to Karabor, and wishes to speak to us both. [NYI - Shadowmoon Playtest Complete!]','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80022,'We have pushed them back to their bastion.$b$bNow it is time to drive them out of Shadowmoon once and for all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80023,'Let\'s do it, then.','Let\'s do it, then.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80024,'Hero, meet us at Twilight Glade. We must save the prisoners.','',0,0,0,0,0,0,1,0,4,0,45395,0,26124),
(80025,'','The work of prophecy is difficult. Sight of the future is often clouded, and one must rely on instinct to discern what WILL come to pass, and what MIGHT come to pass.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80026,'Freeeedommmmm!','',0,0,0,0,0,0,0,0,0,0,43751,0,26124),
(80027,'I will reduce you all to ashes!','',0,0,0,0,0,0,0,0,0,0,43749,0,26124),
(80028,'Inferno!','',0,0,0,0,0,0,0,0,0,0,43756,0,26124),
(80029,'Drown in fire!','',0,0,0,0,0,0,0,0,0,0,43757,0,26124),
(80030,'My flames will lick the flesh from your bones!','',0,0,0,0,0,0,0,0,0,0,43758,0,26124),
(80031,'SUFFER!','',0,0,0,0,0,0,0,0,0,0,43759,0,26124),
(80032,'I consume all!','',0,0,0,0,0,0,0,0,0,0,43752,0,26124),
(80033,'Die!','',0,0,0,0,0,0,0,0,0,0,43753,0,26124),
(80034,'Burn!','',0,0,0,0,0,0,0,0,0,0,43754,0,26124),
(80035,'My fire is... Exting..uished.','',0,0,0,0,0,0,0,0,0,0,43750,0,26124),
(80036,'I will burn this mountain unto ash!','',0,0,0,0,0,0,0,0,0,0,43755,0,26124),
(80037,'Can\'t take the heat? Get out of the furnace!','',0,0,0,0,0,0,0,0,0,0,44398,0,26124),
(80038,'Intruders at the Blast Furnace have been eliminated. Throw their bodies into the furnace and return to your posts!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80039,'','Burn burn burn burn torch and burn and cinder and burn and FIRE!',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(80040,'Frostwolves and Laughing Skulls? Working together? You orcs are more desperate than I suspected.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80041,'Well done, $n. These crystals fell from our vessel centuries ago when we first arrived on this world.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80042,'Sadly, the \"Dark Star\" Ner\'zhul spoke of also came with us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80043,'I fear our arrival here has forever altered the fate of the Shadowmoon orcs.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80044,'','I\'ll be okay. Thank you again for all of your help, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80045,'You\'ve done good work here, champion. Now we only have three more crystals to find.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80046,'Are you lost, stranger?','Are you lost, stranger?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80047,'An outsider approaches.','An outsider approaches.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80048,'Halt right there.','Halt right there.',0,0,0,0,0,0,0,0,0,0,43277,43277,26124),
(80049,'Tread carefully, stranger.','Tread carefully, stranger.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80050,'','Stay your weapons. This must be the messenger the draenei prophet promised.',0,0,0,0,0,0,1,0,0,0,0,43239,26124),
(80051,'','Please find the prisoners, hero. My sister is among them. Were I a fighter, I could help you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80052,'I have learned the hard way, Yrel. You must fight for what you love, with every fiber of your being.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80053,'Trust in the light to protect you - and if that fails, trust in yourself to do what must be done.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80054,'','Prophet - are you okay?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80055,'I could not help but overhear. Maraad is right. Sometimes, we must give ourselves wholly to the cause.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80056,'But we must never, ever, forsake the light... Even should it consume us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80057,'Excellent! This crystal has been lost to us for decades.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80058,'The energy you gather is our only hope if we are forced to encounter the shadow of the Dark Star...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80059,'This is the first of four crystals. We must find the others!','',0,0,0,0,0,0,0,0,0,24465,0,0,26124),
(80060,'This was the final crystal. See me atop Mount Teluuna when your work is done, champion.','',0,0,0,0,0,0,0,0,0,24467,0,0,26124),
(80061,'Ner\'zhul struggles to earn the trust of the Iron Horde.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80062,'To do so, he\'s dabbling with terrible shadow magic he cannot possibly control.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80063,'If he succeeds in bringing down the Dark Star, his clan - and his world - will suffer for his arrogance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80064,'We have located two of the four crystals. We must find the others before Ner\'zhul completes his ritual.','',0,0,0,0,0,0,0,0,0,24464,0,0,26124),
(80065,'Only one crystal remains. We need all of their power if we are to succeed.','',0,0,0,0,0,0,0,0,0,24466,0,0,26124),
(80066,'This was the final crystal. See me atop Mount Teluuna - there is no time to lose!','',0,0,0,0,0,0,0,0,0,24467,0,0,26124),
(80067,'Thanks for your help, $n. I\'ll report these findings back to Velen.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80068,'','Fenris Wolfbrother was once a Frostwolf, but his ambition and pride led him astray. He left the pack in search of personal glory, and fell in with our hated enemies.$B$BWho knows where my own reckless ways would have led me... where I\'d be now if you hadn\'t found me in Bladespire.$B$BAmbition and talent will grant you the power to take many lives. But the strength required to protect even one... that comes from somewhere else.$B$BThank you, $p.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80069,'','The crystal that we came for is right over there, on the hill.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80070,'','The podlings were saving these elekk to snack on later. If you wish, ride this one back to the outskirts of the forest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80071,'','I cannot sit back and watch Karabor burn, $n.  I am coming with you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80072,'','I am no fighter, but I will do my best.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80073,'','I was trained in this temple. I expected to spend my whole life here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80074,'','I never expected to come back from the slave camps of Tanaan, only to see my home in flames.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80075,'','You fight heroically, $n.  You are an inspiration.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80076,'','I thought we would be safe here! Who would attack a temple?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80077,'','Once this is over, I hope to return to my studies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80078,'','I\'m not trained for combat. I am no Vindicator!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80079,'','They will turn our palace of light into some sort of... dark temple!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80080,'','That must be their leader, up on the gardenhouse.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80081,'','Watch your step, $n! He\'s burning everything in sight!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80082,'','I will aid you as best I can.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80083,'','These orcs are forged of steel and fire. They never used to act this way.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80084,'','I suppose that works.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80085,'','You are... brutal and direct. You have seen combat before.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80086,'','I shudder to imagine the carnage outside of our walls.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80087,'','Problem solved.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80088,'','Will our temple ever recover from being a war zone?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80089,'|TInterface\\Icons\\item_summon_cinderwolf.blp:20|t%s summons|cFFFF0000 Cinder Wolves|r!','|TInterface\\Icons\\item_summon_cinderwolf.blp:20|t%s summons|cFFFF0000 Cinder Wolves|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80090,'','They are just throwing their lives away!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80091,'','They are just throwing their lives away!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80092,'','The prophet is just up ahead!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80093,'','Hurry, $n!  I see Velen up ahead!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80094,'','Prophet Velen will save us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80095,'|TInterface\\Icons\\spell_shaman_stormearthfire.blp:20|t%s begins to channel |cFFFF0404|Hspell:155493|h[Firestorm]|h|r!','|TInterface\\Icons\\spell_shaman_stormearthfire.blp:20|t%s begins to channel |cFFFF0404|Hspell:155493|h[Firestorm]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80096,'Ner\'zhul has shown us power in the darkness!','Ner\'zhul has shown us power in the darkness!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80097,'The ritual will soon be complete. The Dark Star comes!','The ritual will soon be complete. The Dark Star comes!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80098,'Your blood will feed the Dark Star...','Your blood will feed the Dark Star...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80099,'The Void calls to us!','The Void calls to us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80100,'Strength through darkness.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80101,'Ner\'zhul peered into the void, and it answered...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80102,'Ner\'zhul has given us power over the void!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80103,'We\'re being attacked!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80104,'They\'re destroying our city!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80105,'The draenei will fall, and ALL will kneel before the void.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80106,'Thank you, champion. I have always felt my fate and that of the Dark Star are intertwined.','',1,0,0,0,0,0,0,0,6,0,0,0,26124),
(80107,'Light. Pure light. Hope in times of despair, brightness in our darkest hour!','',1,0,0,0,0,0,0,0,6,0,0,0,26124),
(80108,'Ner\'zhul\'s ritual... begins! We are out of time!','',1,0,0,0,0,0,0,0,6,0,0,0,26124),
(80109,'We must stop the Shadowmoon Chieftain.','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(80110,'What needs to be done, child.','',1,0,0,0,0,0,0,0,6,0,0,0,26124),
(80111,'Hurry, champion. I will get there as soon as I can.','',1,0,0,0,0,0,0,0,6,0,0,0,26124),
(80112,'Do whatever you can to delay Ner\'zhul...','',1,0,0,0,0,0,0,0,6,0,0,0,26124),
(80113,'','Prophet! What have you done to yourself!?',1,0,0,0,0,0,0,0,6,0,0,0,26124),
(80114,'MMmmff! Mmffmf!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80115,'Come on, then! The prototype should be able to take us to Thaelin!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80118,'<Nightstalker keeps scratching at the rickety wooden barrier.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80119,'You don\'t have to do this, Yrel. Take the survivors and flee.','',0,0,0,0,0,0,1,0,0,0,44814,0,26124),
(80120,'LAUGHING SKULL! LAUGHING SKULL! HAHAHAHAHA!','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(80121,'','LAUGHING SKULL! LAUGHING SKULL! HAHAHAHAHA!',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(80122,'Now it is time to drive them out of Shadowmoon once and for all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80123,'','By the light - what IS that thing!?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80124,'','There\'s got to be a weak spot - get behind it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80125,'','How did the orcs build such a monstrosity?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80126,'','Is this kind of thing common on your world?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80127,'I\'ve been workin\' on a little secret project whenever the guards are away.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80128,'Suit! Come to papa!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80129,'A beauty, isn\'t it? Now let\'s go cause some damage.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80130,'Guards! GUARDS!? Where are those worthless fools?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80131,'More Frostwolf scum to feed my pet! Gutgore, attack!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80132,'Ye gonna be hog food!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80133,'Intruder in the camp!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80134,'You just made the wrong choice!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80135,'Hostile in the camp!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80136,'Vul\'gath will reward me well when I bring him your head!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80137,'Your soul is mine!','',0,0,0,0,0,0,0,0,0,0,46221,0,26124),
(80138,'Kill them all!','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(80139,'Your attempt to stop me ends now!','',0,0,0,0,0,0,0,0,0,0,46222,0,26124),
(80140,'You struggle against the inevitable.','',0,0,0,0,0,0,0,0,0,0,46223,0,26124),
(80141,'Lok\'tar ogar!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80142,'I have fallen before...','',0,0,0,0,0,0,0,0,0,0,45955,0,26124),
(80143,'','The Iron Horde represents a clear and present danger to all that we hold dear on Draenor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80144,'','This data...is shocking. What kind of monster would mutate their own people like this?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80145,'No! Our work cannot be interrupted!','No! Our work cannot be interrupted!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80146,'The Dark Star\'s power flows through us! You will not stop us!','The Dark Star\'s power flows through us! You will not stop us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80147,'This forest is ours!','',0,0,0,0,0,0,0,0,6,0,46073,0,26124),
(80148,'The Iron Horde were merely testing us...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80149,'Cindermaw submerges and tunnels southeast.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80150,'% is overcome with the energy from the crystal.','',0,0,0,0,0,0,0,0,0,24467,0,0,26124),
(80151,'Defend me! I must maintain the portal!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80152,'Cindermaw submerges and tunnels north.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80161,'Master Blackheart! Intruders are in the tomb!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80163,'We do not need your precious key. We are... Legion...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80164,'Thaelin\'s Quick Fix is ready to deploy!','Thaelin\'s Quick Fix is ready to deploy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80165,'Yrel! We will spill some orcish blood...','',0,0,0,0,0,0,396,0,4,0,44782,0,26124),
(80166,'I am your Chieftain; you and your warriors will fall back in line.','',0,0,0,0,0,0,5,0,7,0,45205,0,26124),
(80167,'OUR - FATHER - would BE - ASHAMED - of WHAT - YOU\'VE - BECOME!','',0,0,0,0,0,0,0,0,7,0,45208,0,26124),
(80168,'Our strength comes from working together.','',0,0,0,0,0,0,1,0,7,0,45210,0,26124),
(80169,'[PH] Temporary cut-scene with my brother? Let\'s do it!','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(80170,'I will crush you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80171,'I am FREE!','',0,0,0,0,0,0,396,0,0,0,45765,0,26124),
(80172,'We will help you defeat your enemies. We will repay our debt to you, tiny one.','',0,0,0,0,0,0,153,0,0,0,45767,0,26124),
(80173,'I am in your debt, little one. You have saved my people from an eternity of suffering.','',0,0,0,0,0,0,396,0,0,0,45766,0,26124),
(80174,'','Few of the Frostwolves are willing to trade their goods this far east.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80175,'You may find refuge here, traveler. A battle is always better after a good rest.','You may find refuge here, traveler. A battle is always better after a good rest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80176,'WHO SENT YOU HERE?! Deathbloom. Surely it was Deathbloom. CURSE YOU!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80177,'And you... yes! You! Bow to your traitor king and DIE FOR YOUR INSOLENCE!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80178,'','Though I cannot bear to see my only child destroyed, I also would not feel right sending you into the spirit world alone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80179,'','My spirit will cross over with you. Return to me when the deed is done.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80180,'I am glad you see the wisdom in this course, Maraad. I trust Durotan and his clan will as well.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80181,'I concede that Durotan is indeed a wiser leader than most of his kind.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80182,'If you can convince him of this plan of yours, we will comply.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80183,'I am ready to begin the Battle for Shattrath! [Queue for solo instance.]','I am ready to begin the Battle for Shattrath! [Queue for solo instance.]',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(80184,'FOOL! I will not be lured out so easily!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80185,'Orgrim spoke proudly of the might of the Iron Horde, but I never imagined that they would be THIS massive. The sheer size of this place...$b$bOur small party cannot hope to take this base down, but we can certainly try to keep those ships from leaving the harbor. Are you with me, $n?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80186,'I am with you, Warchief.','I am with you, Warchief.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80187,'Rage unending... Face the fury of the wolf!','',0,0,0,0,0,0,0,0,0,0,41959,0,26124),
(80188,'No! I will wield your strength...','',0,0,0,0,0,0,0,0,0,0,41958,0,26124),
(80189,'Your heart... dreams of fire...','',0,0,0,0,0,0,0,0,0,0,41957,0,26124),
(80190,'Faultline! I will avenge you! Yes... There. Will. Be. BLOOD!','',0,0,0,0,0,0,0,0,0,0,41961,0,26124),
(80191,'Yrel, walk with us a moment...','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80192,'Ner\'zhul summons $ns for the |cFFFF0000|Hspell:154733|h[Ritual of Destruction]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80193,'Priming','Priming',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80194,'Ha ha! Smashed.','',0,0,0,0,0,0,0,0,0,0,41649,0,26124),
(80195,'Not fit for capture!','',0,0,0,0,0,0,0,0,0,0,41650,0,26124),
(80196,'Next! Ha ha!','',0,0,0,0,0,0,0,0,0,0,41651,0,26124),
(80197,'I will NOT die here! Faultline, come aid your master!','',0,0,0,0,0,0,0,0,0,0,41960,0,26124),
(80202,'Come! Your meat and bones will feed my animals!','',0,0,0,0,0,0,0,0,0,0,41952,0,26124),
(80203,'Feel my fury!','',0,0,0,0,0,0,0,0,0,0,41965,0,26124),
(80204,'Let us crush them!','',0,0,0,0,0,0,0,0,0,0,41954,0,26124),
(80205,'Grant me your strength!','',0,0,0,0,0,0,0,0,0,0,41955,0,26124),
(80206,'Animality!','',0,0,0,0,0,0,0,0,0,0,41962,0,26124),
(80207,'Aid me!','',0,0,0,0,0,0,0,0,0,0,41956,0,26124),
(80208,'That one shall not die alone.','',0,0,0,0,0,0,0,0,0,0,41963,0,26124),
(80209,'Weak.','',0,0,0,0,0,0,0,0,0,0,41964,0,26124),
(80210,'The others...  will avenge... me...','',0,0,0,0,0,0,0,0,0,0,41953,0,26124),
(80211,'','One of those green spiders bit me, but it was just a scratch. No pain, no fame, am I right?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80212,'I\'m a Vindicator in training, so I can handle a spider or two. But when night fell, a hundred glowing eyes lit up the darkness...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80213,'','\'Let\'s explore the old mine,\' she said. \'I need a sample for research,\' she said. Oh, why did I ever listen to Isaari?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80214,'S-s-s-s-s-spiders... why did it have to be s-s-s-spiders?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80215,'Please find my other three friends! If you save them, I will gladly reward you when I return to Light\'s Rest.','Please find my other three friends! If you save them, I will gladly reward you when I return to Light\'s Rest.',0,0,0,0,0,0,0,0,0,24574,0,0,26124),
(80216,'My other two friends are still out there... please find them, hero.','My other two friends are still out there... please find them, hero.',0,0,0,0,0,0,0,0,0,24575,0,0,26124),
(80217,'Anyway, I can find my way back to Light\'s Rest, but one of my party is still missing. Please find them!','Anyway, I can find my way back to Light\'s Rest, but one of my party is still missing. Please find them!',0,0,0,0,0,0,0,0,0,24576,0,0,26124),
(80218,'You found the others? Thank goodness! Come see us at Light\'s Rest. I\'m sure we can find some way to thank you.','You found the others? Thank goodness! Come see us at Light\'s Rest. I\'m sure we can find some way to thank you.',0,0,0,0,0,0,0,0,0,24577,0,0,26124),
(80219,'Please find my other three friends! If you save them, I will gladly reward you when I return to Sunsworn Camp.','Please find my other three friends! If you save them, I will gladly reward you when I return to Sunsworn Camp.',0,0,0,0,0,0,0,0,0,24578,0,0,26124),
(80220,'My other two friends are still out there... please find them, hero.','My other two friends are still out there... please find them, hero.',0,0,0,0,0,0,0,0,0,24579,0,0,26124),
(80221,'Anyway, I can find my way back to Sunsworn Camp, but one of my party is still missing. Please find them!','Anyway, I can find my way back to Sunsworn Camp, but one of my party is still missing. Please find them!',0,0,0,0,0,0,0,0,0,24580,0,0,26124),
(80222,'You found the others? Thank goodness! Come see us at Sunsworn Camp. I\'m sure we can find some way to thank you.','You found the others? Thank goodness! Come see us at Sunsworn Camp. I\'m sure we can find some way to thank you.',0,0,0,0,0,0,0,0,0,24581,0,0,26124),
(80223,'','\'Let\'s explore the old mine,\' she said. \'I need a sample for research,\' she said. Oh, why did I ever listen to Norana?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80224,'S-s-s-s-s-spiders... why did it have to be s-s-s-spiders?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80225,'I\'m a Blood Knight in training, so I can handle a spider or two. But when night fell, a hundred glowing eyes lit up the darkness...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80226,'','One of those green spiders bit me, but it was just a scratch. No pain, no fame, am I right?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80227,'','Guys? I... I don\'t feel... so good...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80228,'I will defend my lands and my people, whatever the cost.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80229,'I\'m with you! [Begin Scenario]','I\'m with you! [Begin Scenario]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80230,'I... already told you... all that I know...','',0,0,0,0,0,0,0,0,7,0,41922,0,26124),
(80231,'Do you even know how to wield a weapon!?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80232,'Easy as taking sweets from a draenei.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80233,'This belongs to me now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80234,'','Guys? I... I don\'t feel... so good...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80235,'','I\'ve known Isaari since she was a little girl. She\'s always getting me into trouble!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80236,'I can still hear them... chittering and clacking to one another...$B$B<Doruun shudders.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80237,'Well, I\'m glad we escaped in one piece.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80238,'Well, I\'m glad we escaped in one piece.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80239,'I can still hear them... chittering and clacking to one another...$B$B<Orian shudders.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80240,'','That\'s it! I\'m never going on another one of Norana\'s stupid expeditions ever again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80241,'I see you are all safe.','I see you are all safe.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80242,'Thanks to you, $n, we surviv-- Isaari? Are you all right?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80243,'Thanks to you, $n, we surviv-- Norana? Are you all right?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80244,'Bleed for me!','',0,0,0,0,0,0,0,0,0,0,41966,0,26124),
(80245,'I\'ll roast your flesh!','',0,0,0,0,0,0,0,0,0,0,41967,0,26124),
(80246,'We continue to gather more information on the frost wolf clan and their pathetic attempts at survival.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80247,'Anything?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80248,'Do you see anything?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80249,'Snow... I see lots of snow.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80250,'Bah... this is a waste of time. Goreseeker has no idea what he is doing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80251,'Umm... Yeah. We are doing great. Tell Goreseeker we are really gathering some great intel out here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80252,'Excellent. I\'ll let Goreseeker know.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80253,'It\'s happening just ahead, in the bottom of the tomb. I\'ve got to get out of here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80254,'Igniting Barrel','Igniting Barrel',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80255,'$n, you are back! Please take the chest in this cart. It is only a small token of thanks for saving my life.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80256,'I\'m da best bestest beater der is! I\'m gonna beat ya till ya beaten.','',0,0,0,0,0,0,0,0,0,24596,0,0,26124),
(80257,'Hey $n, remember me? You saved my life at the Court of Souls! Take this chest behind me as a token of my thanks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80258,'What the? Shtop right there! I\'m going to kick your...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80259,'<BLAAAAARG!!!>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80260,'You think you can beat me!??? I\'ll shhlap you right in your shtupid face, $c!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80261,'He just slipped off the bridge?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80262,'','I\'ll keep the portal open as long as I can!',0,0,0,0,0,0,0,0,0,0,0,43634,26124),
(80263,'Yup.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80264,'','Go now, while I can still hold it!',0,0,0,0,0,0,0,0,0,0,0,43635,26124),
(80265,'What a fool... Well, let\'s pick up these supplies and head back to base.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80266,'You have done well, Soulbinder.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(80267,'Come, Teron. Auchindoun awaits. Unthinkable power will soon be yours.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(80268,'The Iron Horde will not hesitate to use that cannon on our base. We should find a more tactical location.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80269,'Is everyone alright?','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80270,'I think I soiled m\'self...','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80271,'My ALE was back there...','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80272,'Yes, everyone appears to be alright.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80273,'Very well. We will set up camp ahead, and deal with this cannon.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80274,'Yrel will have to wait.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80275,'You are ready, Hurkan. Slay these mortals in my name!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(80276,'I have souls to devour.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(80277,'MY CLAN FOR GOREFIEND!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(80278,'Nixxie is dead? Right on! She couldn\'t manage her way out of a paper bag. Let\'s get out of here boys!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80279,'','Get it together you bums! It\'s bad Kal\'rak ditched out on us. But that doesn\'t mean you can start slacking.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80280,'','How many times have I told you! That keg is going to go bad if you keep it out  like that!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80281,'','This Iron Horde is paying us good money to transport these goods on time. So put some elbow grease into it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80282,'You won\'t get away with this.','You won\'t get away with this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80283,'','Stupid Kal\'rak... I\'m going to report that idiot to the Iron Horde\'s HR department. Assuming they have a HR department.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80284,'','I can\'t... hold it... much longer...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80285,'','I should have kept my job at the Kaja\'Cola factory in Azeroth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80286,'','I don\'t care what you think! I\'m the lead here. Now get back to work!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80287,'','The wagon gets attacked by a giant insect, and what does the big, strong, Iron Horde orc do?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80288,'','He runs off with a keg of brew. Sheesh...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80289,'','Hey! What are you doing here?! Don\'t even think about touching our cargo!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80290,'I\'m outta here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80291,'Ding-Dong! Nixxie is dead!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80292,'Finally we are free!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80293,'Great to see you $R, we could use your help right away!','Great to see you $R, we could use your help right away!',25,0,0,0,0,0,0,0,1,0,0,0,26124),
(80294,'Let\'s start construction!','Let\'s start construction!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80295,'Ready to get this garrison started?','Ready to get this garrison started?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80296,'Everybody in the Tank. Yrel is being held as a slave in the Stonemaul ogres\' slave camp.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80297,'Yrel might already be free if it weren\'t for the actions of one deceitful rangari.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80298,'I did what I thought was right, Vindicator. The missing girl seems to be distracting you from our mission.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80299,'Yeah, what\'s so special about this girl anyway?','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80300,'I lost her once. I will not lose her again.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80301,'Now THAT\'S somethin\' I can get behind.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80302,'Besides, the ogres\'re sellin\' slaves to the Iron Horde. Stoppin\' ta beat \'em up fer a bit is well within the scope o\' our mission.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80303,'You all is gonna get smashed.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80304,'Oh no, ogre, that\'s where you have it wrong. You see, we are the ones that will be doing the smashing today. Thaelin?','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80305,'Aye aye, cap\'n!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80306,'Now is our chance! Forward, Thaelin, with speed!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80307,'What da...?','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80308,'Stay silent, all of you! Ogre, if you so much as GRUNT, I will personally beat the Light out of you.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80309,'We can set up over there.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80310,'Ok\'mokk didn\'t make no sounds at all. You don\' need ta smash Ok\'mokk.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80311,'Ach, I have a feelin\' yer gonna get smashed anyway.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80312,'A direct attack. A bold decision.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80313,'Gathering allies. Wise decision.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80314,'Form up, everyone. We are headed to Smokebelcher Depot.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80315,'Form up, everyone. We are headed to the Planteau. [TEMP NAME]','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80316,'','Room for one more on that elekk?',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80317,'Always, my love.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80318,'Yrel, did you learn anything about the Goliath Cannon before your capture?','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80319,'','A bit. The one you destroyed was merely a prototype. The actual cannons are built in the foundry, to the north.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80320,'','I overheard one of the orcish leaders discussing a plan to use them on Shattrath.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80321,'Shattrath? Ha! Even that big ol\' hunk o\' metal couldn\'t hit Shattrath from here.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80322,'They could if it was loaded onta\' a boat.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80323,'I suspected the same thing. They must plan to load the cannons onto barges at the Naval Base, in the northeast.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80324,'Our small group would never survive an attack on the Naval Base. Too fortified.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80325,'We will continue attacking their supply lines.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80326,'','D\'kaan, how long have you been scouting out here in Gorgrond?',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80327,'A very long time. Longer than you\'ve been alive, probably by two or threefold.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80328,'D\'ye get lonely?','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80329,'A rangari who is not lonely is not doing his job.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80330,'Sounds like a crap job to me. Life ain\'t worth livin\' if y\'don\'t have lads and a lass t\'come home to.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80331,'','Do you have a wife, Hansel?',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80332,'Ach... the Blackrocks took \'er away.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80333,'That\'s half o\'why I\'m here: ta look after Thaelin, and ta get me wife back.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80334,'We will find your wife, Hansel. And we will leave a wake of bodies behind us. The orcs will pay with blood for what they did to our families.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80335,'Y\'know, that\'s the darkest, coldest, most inspirin\' thing I\'ve ever heard from the lips of a paladin.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80336,'Our work here is done. Next, we head to Smokebelcher Depot.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80337,'Our work here is done. Next, we head to the Planteau.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80338,'','Thaelin, are you doing alright in there?',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80339,'Quite fine, ma\'am. Just happy to be out o\' combat and back in me Tank.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80340,'','<sigh> This land is plagued by war. Do you think you\'ll return to the safety of home after our mission is done?',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80341,'I dunno how much you\'ve heard about Azeroth, ma\'am, but we\'ve got our fair share of war, too.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80342,'Once I\'ve found me Ellie, I know I\'ll be headed back ta Searin\' Gorge.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80343,'What about you, lassie? Will ye go home?','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80344,'','With Velen gone, I feel like I don\'t have a home anymore.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80345,'We are draenei, Yrel. Being without a home is in our nature.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80346,'','I was thinking I might go through the portal with you, my love.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80347,'Yes, Yrel. You will have a home on Azeroth.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80348,'But first, we will make these orcs suffer for what they did to you. Their sins cannot be forgiven.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80349,'','Maraad, you\'re frightening me.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80350,'The Iron Horde\'s supply lines are now cut, however temporarily. We have forged our alliance with the Shapers.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80351,'There will never be a better time than this. Let us head to the Naval Base and exact our vengeance on the Iron Horde!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80352,'','What is our plan, Maraad?',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80353,'We will slay as many of the vile things as we can. We will burn their homes and show them fear.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80354,'I will make them feel the pain I felt when I lost you, Yrel.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80355,'','Maraad... I am honored...',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80356,'','...but perhaps you are taking your vengeance too far. Have you forgotten what the Prophet taught us?',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80357,'The prophet is DEAD, Yrel. Look what his teachings did for him.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80358,'Ye\'ve gone too far, Maraad.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80359,'The Light\'s left ye. Even I can see that.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80360,'I carry no particular love for the Light, but I agree. You need to remember what you stand for, Vindicator.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80361,'Are any of you more holy than me? I am the LEADER of this expedition, and I will not be questioned any further!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80362,'The Light has not left me, Thaelin. No... the Light has finally shown me its true form.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80363,'Vengeance.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80364,'I saw the naaru\'s vengeance in the Purge of Grommar. I was there as K\'ara herself unleashed holy death upon the filthy hordes.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80365,'[UNUSED]','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80366,'','Maraad, my love. That\'s enough.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80367,'Yrel...','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80368,'','You have been through too much, Maraad. Your thirst for vengeance will only lead to our death.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80369,'','[UNUSED]',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80370,'','Rest now. I will lead our attack on the Naval Base.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80371,'I\'m with you, Yrel.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80372,'I, too, will follow you.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80373,'And I.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80374,'Very well.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80375,'Thank you, Yrel. I don\'t know what\'s coming over me.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80376,'Shutting Down','Shutting Down',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80377,'Pull the first lever to increase combustion!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80378,'Pull the second lever to overdrive the engine!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80379,'Pull the third lever to destroy the Ultrabliterator!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80380,'Stay back! It\'s on a rampage!','Stay back! It\'s on a rampage!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80381,'Well done, champion! We will do our best to repair this unit. Thank you.','Well done, champion! We will do our best to repair this unit. Thank you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80382,'','We are all entitled to our own opinion. Yours is just wrong. NOW GET BACK TO WORK!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80383,'Sorry! I just work here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80384,'Whoa! What did I do?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80385,'Nixxie! Help!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80386,'I should have never left Azeroth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80387,'Can\'t we talk this through?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80388,'Lok-Narash!','',0,0,0,0,0,0,0,0,0,0,45284,0,26124),
(80389,'Gazlowe, buy us some time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80390,'We will take the east!','',0,0,0,0,0,0,0,0,0,0,45286,0,26124),
(80391,'Orgrim, you will answer for your betrayal!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80392,'Brother!','',0,0,0,0,0,0,0,0,0,0,45288,0,26124),
(80393,'Auchindoun will soon be ours. Too bad you won\'t be around to see it, elf.','Auchindoun will soon be ours. Too bad you won\'t be around to see it, elf.',0,0,0,0,0,0,153,0,0,0,0,0,26124),
(80394,'Innocent?!','',0,0,0,0,0,0,15,0,0,0,45469,0,26124),
(80395,'Yes, I will see Draenor burn. You, traitor, will not.','',0,0,0,0,0,0,0,0,0,0,45470,0,26124),
(80396,'','Lok\'tar ogar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80397,'','I will hold off reinforcements at the docks!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80398,'','I will get the children to safety!',0,0,0,0,0,0,0,0,0,0,0,44751,26124),
(80399,'You got it, boss!','',0,0,0,0,0,0,0,0,0,0,44488,0,26124),
(80400,'Together, we fight!','',0,0,0,0,0,0,0,0,0,0,44897,0,26124),
(80401,'Prepare for a counter-attack!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80402,'They\'re retreating to the harbor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80403,'The children are safe! Their lieutenants are exposed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80404,'Only the harbor remains between us and the weapon!','',0,0,0,0,0,0,0,0,0,0,44898,0,26124),
(80405,'Champion! Speak with me when you are ready to travel to the enemy battleship.','',0,0,0,0,0,0,0,0,0,0,44899,0,26124),
(80406,'I will not slay so many innocent people!','',0,0,0,0,0,0,5,0,0,0,46070,0,26124),
(80407,'It is YOU who would make Draenor burn. It is YOU who must be stopped!','',0,0,0,0,0,0,25,0,0,0,46071,0,26124),
(80408,'For Shattrath!','',0,0,0,0,0,0,0,0,0,0,44786,0,26124),
(80409,'','Thaelin, use your tank to save them! We will provide escort.',0,0,0,0,0,0,0,0,0,0,0,45590,26124),
(80410,'','We will hold off Blackhand! Destroy that weapon!',0,0,0,0,0,0,0,0,0,0,0,45592,26124),
(80411,'','They have children in those buildings!',0,0,0,0,0,0,0,0,0,0,0,44750,26124),
(80412,'','We will take the west!',0,0,0,0,0,0,0,0,0,0,0,45591,26124),
(80413,'Dismantling','Dismantling',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80414,'%s hisses, slinking back into the shadowy depths!','%s hisses, slinking back into the shadowy depths!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80415,'A chill wind howls across the empty hills...','A chill wind howls across the empty hills...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80416,'A chittering sound echoes across the trees, then fades...','A chittering sound echoes across the trees, then fades...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80417,'Something flickers in the shadows, growing closer...','Something flickers in the shadows, growing closer...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80418,'We don\'t want any trouble, $c. We stopped fighting a long time ago.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80419,'I could eat an orc.','I could eat an orc.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80420,'When you live in a savage world like we do, sometimes you just want to get away.$b$bThat\'s why we left the war behind.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80421,'Feel free to take some fish. They are delicious.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80422,'|TInterface\\Icons\\ability_fixated_state_red:20|tA %s |cFFFF0000|Hspell:156653|h[Fixates]|h|r on you. Run!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80423,'Stop! Who goes there? Go away before I put an arrow in your eye!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80424,'Pardon my rudeness, traveler. I did not know you from the enemy.$B$BThe Shadow Council has tried to raid my home several times now.$B$BThe first time, they didn\'t expect much resistance from an old hermit like me. I put arrows into the throats of three.$B$BThe second time, I was prepared. Four orcs blundered right into my traps. Stupid mongrels.$B$BI made them angry, and now, I\'m waiting for them to come again.$B$BI hope they send more. It just means that many more will die.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80425,'Do you need help?','Do you need help?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80426,'Stay if you want, traveler. I\'ll die before letting these dogs take my home. Watch out! They come!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80427,'Heh, you\'ve got some fight in you, traveler. Ready for more?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80428,'This is it, friend. Let\'s cut them off at the head!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80429,'We did it! I... I can\'t thank you enough, stranger. I don\'t have much, but I want you to have this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80430,'','The hunt comes to an end. Quickly, drink this antidote! The spider\'s venom will no longer affect you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80431,'Are you sure this is a good idea?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80432,'If you want something done, you have to do it yourself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80433,'','There is another I hunt within these caves. I leave this kill to you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80434,'Find a way to destroy the Supply Depot!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80435,'The Sky Rider\'s have noticed your presence!','The Sky Rider\'s have noticed your presence!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80436,'','Rise and serve your master!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80441,'Our clan grows stronger by the second.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80442,'Careful - we have a tough enemy cornered in there.','Careful - we have a tough enemy cornered in there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80443,'Grulk gonna pound you all!! Rargrh!!','',0,0,0,0,0,0,0,0,0,0,40026,0,26124),
(80444,'Feel weak...Grulk need serum...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80445,'Grulk Smash!! Rarggah!!','',0,0,0,0,0,0,0,0,0,0,40026,0,26124),
(80446,'Grulk so tired...just want nap.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80447,'Grulk is strongest one there is!! Rrrrgh!!','',0,0,0,0,0,0,0,0,0,0,40026,0,26124),
(80448,'This place where Grulk change...where old self die...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80449,'NO MORE!! GRULK CRUSH!!','',0,0,0,0,0,0,0,0,0,0,40026,0,26124),
(80450,'Are you sure this is a good idea?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80451,'Yeah, you\'ll be fine. I just forgot to adjust my sights last time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80455,'','Keep your eyes open... The stones speak of trouble...',0,0,0,0,0,0,0,0,0,0,0,41846,26124),
(80456,'Hunters, arm your traps. I smell something...','',0,0,0,0,0,0,0,0,0,0,41948,0,26124),
(80457,'Another trophy for the pen.','',0,0,0,0,0,0,0,0,0,0,41949,0,26124),
(80458,'The stones spoke of your demise.','',0,0,0,0,0,0,0,0,0,0,41662,0,26124),
(80459,'Who dares wake me?','',0,0,0,0,0,0,0,0,0,0,41570,0,26124),
(80460,'You are weak.','',0,0,0,0,0,0,0,0,0,0,41571,0,26124),
(80461,'','I see you, interlopers. You tread on sacred ground...',0,0,0,0,0,0,0,0,0,0,0,41873,26124),
(80462,'','Insignificant whelps, what makes you think you can challenge me?',0,0,0,0,0,0,0,0,0,0,0,41871,26124),
(80463,'','I will turn you into ash!',0,0,0,0,0,0,0,0,0,0,0,41875,26124),
(80464,'','Drown in venom!',0,0,0,0,0,0,0,0,0,0,0,41876,26124),
(80465,'','The undertow will consume you!',0,0,0,0,0,0,0,0,0,0,0,41877,26124),
(80466,'','Hah! My power rules here.',0,0,0,0,0,0,0,0,0,0,0,41874,26124),
(80467,'','Agamaggan will rise again!',0,0,0,0,0,0,0,0,0,0,0,41872,26124),
(80469,'Auchindoun... is... doomed...','',0,0,0,0,0,0,0,0,1,0,46435,0,26124),
(80470,'None live who assault the holy Auchenai.','',0,0,0,0,0,0,0,0,1,0,46436,0,26124),
(80471,'I will strike you down.','',0,0,0,0,0,0,0,0,0,0,46434,0,26124),
(80472,'The Light guide my hand!','',0,0,0,0,0,0,0,0,1,0,46439,0,26124),
(80473,'Light guide you.','',0,0,0,0,0,0,0,0,1,0,46437,0,26124),
(80474,'Bathe in the glory of the Light!','',0,0,0,0,0,0,0,0,1,0,46438,0,26124),
(80475,'I don\'t know... Roc\'tar doesn\'t look so good.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80476,'','It is my sworn duty to protect this tomb and its grounds.$B$BWe will fight to the last to prevent these orcs from taking the Shard of Souls!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(80477,'Soulbinder Nyami sent me to bring the Shard of Souls to safety.','Soulbinder Nyami sent me to bring the Shard of Souls to safety.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80478,'','Protect that with your life! We need it to power Auchindoun\'s defenses!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80479,'Put me down!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80480,'I will give you a swift death!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80481,'Drop me now you beast!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80482,'Pathetic creature! Unhand me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80483,'Grulk done wit\' Iron Horde...Grulk go now.','',0,0,0,0,0,0,0,0,0,0,40026,0,26124),
(80484,'You friend to Grulk...Grulk not forget what you done.','',0,0,0,0,0,0,0,0,0,0,40026,0,26124),
(80485,'I\'m strongest! This food is mine! Stay away!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80486,'You no try and fight me! Now you food!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80487,'I kill you! I eat you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80488,'See what I have?! No mess with me! Or you next.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80489,'','Hold your ground. We have to protect the wounded!',0,0,0,0,0,0,0,0,0,0,0,44642,26124),
(80490,'%s calls in a distant |cFFFF0000Siegemaker|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80491,'Your head will be mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80492,'It is no matter. These souls are mine. My power grows.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80493,'Auchindoun will be mine! I will devour every last soul and bathe the ashes in hellfire!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80494,'To arms, anchorites! The arakkoa are coming! Hero, lend us your aid!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80495,'More birds on the horizon, my comrades. Send them back to the Spires of Arak, where they belong!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80496,'Will their numbers never cease? Muster your courage, friends. We will not be taken so easily!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80497,'Finally, we have drawn out their leader! Face us, you feathered tyrant!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80498,'Our town is safe thanks to all of you. Today we have given the arakkoa a taste of our steel. Steady hearts, anchorites! We will stay vigilant.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80500,'Welcome to Anchorite\'s Sojourn, traveler. It is here that the devout gather for pilgrimage to the Temple of Karabor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80501,'','And why do you think we need your help, \'blood elf\'? We Auchenai are sworn to Auchindoun\'s protection.',0,0,0,0,0,0,396,0,0,0,0,43632,26124),
(80502,'Explosions, sabotage, demolition...all in a day\'s work friend.','',0,0,0,0,0,0,0,0,0,0,40026,0,26124),
(80503,'Defend the shard! It must reach Lord Teron\'gor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80504,'Grommar is a perfect example of the Alliance not knowin\' how to get the job done right...','',0,0,0,0,0,0,0,0,0,0,40026,0,26124),
(80505,'I have seen your kind before, flying among the mountains to the south. Why have you come here?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80506,'Auuugghhh! What have you done? The sun... it blinds me! It burns! IT BURNS!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80507,'The darkness closes in. I can no longer feel the Light. YOU! You did this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80508,'I alone will stand against you. I will turn you back from these lands!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80509,'The old paladin suddenly gasps. A look of rapture crosses his face and he blinks, seeing you for the first time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80510,'I... I can feel the Light again! I am freed of her curse. I... I see the way to Auchindoun.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80511,'An arakkoa sun priest has come, seeking dominion over our lands.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80512,'My village bled slowly. Many fell to his sorcery. I, too, fell under his abominable curse... the \"sun sickness.\"','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80513,'We knew the sun priest would come one last time to claim his victory.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80514,'I alone remained to face him. My sight was nearly gone, and the Light no longer answered my prayers.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80515,'I prayed once last time, although where there had once been everlasting divinity, now, I felt only emptiness.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80516,'In that moment, I knew true terror.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80517,'I did not see the sun priest arrive, but I heard the flutter of his wings, and felt his gloating breath on my face, and then, moments later, felt him die on my blade.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80518,'Afterward, I wandered. Blind and alone, and severed from the Light. Even in my dying moment, I felt I had been forsaken.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80519,'You have delivered me from his curse. You have restored my faith, champion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80520,'Take my sword, which rests upon the stone. May it guide you when your faith falters, hero.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80521,'NOTUSED','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80522,'','Take one step closer and I\'ll gut you like a fish, orc!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80523,'','Thank the stars you arrived, hero! We are all that is left of Telmor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80524,'','Thanks pal! I\'d hug yah, but we don\'t have much time...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80525,'','Do me a favor and release Grulk from his cage...don\'t worry, he\'s cool.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80526,'To smash? Or not to smash? Dis Grulk question.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80527,'Something need smashing?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80528,'','Grulk was mutated against his will by the Iron Horde and then locked up for being angry over it. Can you believe that?!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80529,'SMASH!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80530,'Grulk rhyme now!$b$bSmash the baddies! Smash them up!$b$bSmash them till fit in soup cup!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80531,'','We gotta bust up this mutation laboratory before it\'s too late! Grulk will fill you in on the details.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80532,'','I\'d better meet back up with the squad. Regroup with us once you\'ve destroyed the lab!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80533,'','Yes, Tuulani. Now you see.',0,0,0,0,0,0,0,0,6,0,0,43638,26124),
(80534,'','Your efforts were valiant. I did not think the anchorites could power the defenses with only one of the crystals.',0,0,0,0,0,0,0,0,6,0,0,43639,26124),
(80535,'','But nothing will stop my plan, nor that of my masters. And the only things in our way...',0,0,0,0,0,0,0,0,6,0,0,43640,26124),
(80536,'','Protector! Destroy these intruders!',0,0,0,0,0,0,0,0,6,0,0,43645,26124),
(80537,'Run for your lives!','Run for your lives!',0,0,0,0,0,0,22,0,4,0,0,0,26124),
(80538,'They\'re eating us alive... literally!','They\'re eating us alive... literally!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(80539,'Where are the Auchenai? Why is no one saving us?','Where are the Auchenai? Why is no one saving us?',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(80540,'There\'s no hope! Run!','There\'s no hope! Run!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(80541,'They killed my family!','They killed my family!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(80542,'I\'m glad you showed up. We were going to be killed next!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80543,'The creatures around here are a pain to deal with.$b$bI\'ve taken to placing some of my food and prized possessions up high to avoid any unwanted incidents.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80544,'Wow! Thanks! I can find my way out of here now. I\'m sure I won\'t get captured again. See ya!','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(80545,'Crush, crack, splinter! AHAHAHahahaha...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80546,'Whispers... slithering behind my EYES!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80547,'$ns drop from the ceiling!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80548,'No! The ritual is incomplete! Who dares to interrupt my arrival?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80549,'My power... it fades!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80550,'NO! Noooooooooooooooooooooooooooooooo!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80551,'Gazlowe, get rid of that barricade!','',0,0,0,0,0,0,0,0,0,0,45285,0,26124),
(80552,'Gazlowe...','',0,0,0,0,0,0,0,0,0,0,45287,0,26124),
(80553,'I fear that even with the Heart intact, Auchindoun\'s defenses may not be enough. The Shadow Council has eyes everywhere.','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(80554,'Barricade! On it!','',0,0,0,0,0,0,0,0,0,0,44489,0,26124),
(80555,'','Thaelin, get that tank down here.',0,0,0,0,0,0,0,0,0,0,0,45589,26124),
(80556,'It isn\'t safe to fire this thing near kids! But I bet the concussion from shooting blanks would blast open those doors...','',0,0,0,0,0,0,0,0,0,0,45742,0,26124),
(80557,'Champion, take control of the cannon! If they get close, use the flames... hahahahaha!','',0,0,0,0,0,0,0,0,0,0,45741,0,26124),
(80558,'Suit! Go home!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(80559,'There ye go... easy on the turn now... easy...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80560,'GAH!!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(80561,'Oh, ye poor thing. You\'ll not be forgotten!','',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(80562,'','The key is in the chest by the wall, go grab it and let me out!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80563,'','What are you staring at? Go grab the key from the chest and let me out!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80564,'','Boy am I glad to see you! The key is in that chest over there, be a pal and let me out will yah?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80565,'','I\'m locked in here, you\'ll need to get the key. It\'s in the chest by the wall!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80566,'','Don\'t mind me, I\'ll just wait here in my cage while you continue NOT letting me out! The key is in that chest over there!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80567,'','This isn\'t some romantic \"rescue the princess from the tower\" situation. This is a torture room and I\'m in a freakin\' cage! Get me outta here!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80568,'Pledge yourself to the master and you will receive untold power!','Pledge yourself to the master and you will receive untold power!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80569,'Witness the infinite power of the Legion!','Witness the infinite power of the Legion!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80570,'The draenei will crumble under our combined might, brothers and sisters!','The draenei will crumble under our combined might, brothers and sisters!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(80571,'Nothing can stop our power! Not the Iron Horde, not the draenei, we are invincible!','Nothing can stop our power! Not the Iron Horde, not the draenei, we are invincible!',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(80572,'Give your souls to Teron\'gor. Gorge yourselves in his power!','Give your souls to Teron\'gor. Gorge yourselves in his power!',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(80573,'','Hurry up... we have work to do.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80574,'','This is a waste of time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80575,'','Are you done yet?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80576,'','*Sigh*',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80577,'','As for you beast, flee if you must, but my arrows will catch you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80578,'I\'m almost done! Just one more time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80579,'You have got to try this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80580,'Don\'t knock it till you try it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80581,'Come on! You might like it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80582,'','Die beast, and know that whatever hell you fall into will be more merciful than I!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80583,'','Thank you for your aid, adventurer. Meet me back at camp and we will discuss matters further.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80584,'','That Grulk guy sure is incredible, ain\'t he? Mutated against his will...out for revenge...HUGE rippling biceps...a girl can only dream.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80585,'You need somethin\' done right? You\'re talkin\' to the right guy...but the right guy ain\'t cheap.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(80586,'Lok-Narash!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80587,'No!!! I will tear you apart for that! You will be avenged, Gutgore!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80588,'The thunderlord... will rise...  again...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80589,'Mole machine, go home!','Mole machine, go home!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(80590,'Don\'t bite me! I will not harm you... Seriously, don\'t do it.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(80591,'I should have stayed in Shadowmoon Valley.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(80592,'Please! I have so much more to see before I die.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(80593,'Thank you, friend! Till we meet again!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(80594,'So much power! I am invincible!','',0,0,0,0,0,0,0,0,0,0,43923,0,26124),
(80595,'But the power... it protects me...','',0,0,0,0,0,0,0,0,0,0,43919,0,26124),
(80596,'You disappoint me, I thought you\'d be tougher.','',0,0,0,0,0,0,0,0,0,0,43921,0,26124),
(80597,'The weak should know better than to test me!','',0,0,0,0,0,0,0,0,0,0,43922,0,26124),
(80598,'%s begins to channel |cFFFF0404|Hspell:157059|h[Rune of Grasping Earth]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80599,'The wormhole is spinning really fast.  You\'ll have to jump first and hope for the best.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80600,'A jagged landscape','A jagged landscape',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80601,'A reddish-orange forest','A reddish-orange forest',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80602,'Shadows...','Shadows...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80603,'Pick your second location.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80604,'Too many Frostwolves have died in this war.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80605,'I will not rest till the Thunderlords are destroyed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80606,'I once hunted Clefthooves for meat and skins, now I hunt Thunderlords for their heads. Not much of a difference really.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80607,'Grassy plains','Grassy plains',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80608,'Primal forest','Primal forest',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80609,'Lava and snow','Lava and snow',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80610,'Location 07','Location 07',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80611,'Location 08','Location 08',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80612,'Location 09','Location 09',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80613,'Location 10','Location 10',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80614,'Location 11','Location 11',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80615,'Location 12','Location 12',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80616,'Got anything important to say or are you just wasting my time?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80617,'Location 13','Location 13',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80618,'Location 14','Location 14',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80619,'Location 15','Location 15',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80620,'Location 16','Location 16',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80621,'Burying','Burying',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80623,'Start P3 Text!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80624,'Just before you kill them, let \'em scream. It\'ll make a better distraction.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80625,'Better not forget my good axe!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80626,'','You face your executioner, $r.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80627,'Meet me in Grommar when you\'re done! Nobody sinks my battleship and gets away with it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80628,'|TInterface\\Icons\\ability_blackhand_demolition.blp:20|t %s casts |cFFFF0000|Hspell:156425|h[Demolition]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80629,'|TInterface\\Icons\\spell_fire_ragnaros_lavabolt.blp:20|t %s casts |cFFFF0000|Hspell:156928|h[Slag Eruption]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80630,'What happened to my furnace? Where are my guards? Shut these intruders down!','',0,0,0,0,0,0,0,0,0,0,45460,0,26124),
(80631,'I\'ll sneak into the camp. When you finish I\'ll meet you at the rendezvous point I marked on your map.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80632,'','Mother?',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(80633,'Meat still looks too rare...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80634,'You want a burger, $p?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80635,'There\'s always time for BBQ!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80636,'Grillin\' and killin\'...it\'s what I do best!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80637,'','Confound these wards! No matter how much I call upon the light to purge them it is as if the wards themselves thwart my ability to unmake them.',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(80638,'Looks like it still needs more heat...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80639,'The secret to good BBQ is to cook it slowly with extreme heat...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80640,'Extra crispy anyone?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80641,'The runes have been destroyed.','The runes have been destroyed.',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(80642,'Ready to face Revaan?','Ready to face Revaan?',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(80643,'Smells like it\'s burning...that means it\'s almost done!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80644,'','Has it been so long? Has she truly grown so much since I last saw her?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80645,'','We shall see about that.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80646,'Child! Leave now. Those wards were there for your protection. You should not be here.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(80647,'Yes. And she will never be yours.','',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(80648,'What? Where am I? I am so tired.','',0,0,0,0,0,0,6,0,0,0,43257,0,26124),
(80649,'Wait a second. It is coming back to me. This is Blackrock Spire, and we are... we are here to vanquish evil and get me some much needed loot.','',0,0,0,0,0,0,1,0,0,0,43258,0,26124),
(80650,'I remember it all, now. You are my pals, my pals for life. Weird, I thought there were more of you.','',0,0,0,0,0,0,5,0,0,0,43259,0,26124),
(80651,'No matter. You are the brains, the creators of the perfect plan, and I am the one who will enact that plan with surgical accuracy.','',0,0,0,0,0,0,5,0,0,0,43260,0,26124),
(80652,'But first, I am hungry. It is like I have not eaten in 8 years. I guess I will just cook this chicken that I have in my bag while you devise our plan of attack.','',0,0,0,0,0,0,1,0,0,0,43261,0,26124),
(80653,'Yep, I will cook this completely not rotten chicken that I had in my bag. You all just go ahead and devise the perfect plan.','',0,0,0,0,0,0,1,0,0,0,43262,0,26124),
(80654,'I like what I am hearing from your planning, pals. It is very well thought out and mathematically flawless.','',0,0,0,0,0,0,1,0,0,0,43263,0,26124),
(80655,'Alright chums, I\'m back! Let\'s do this! Leeroooooy... Jenkins!','',0,0,0,0,0,0,53,0,0,0,43253,0,26124),
(80656,'I\'m ready to detonate the explosives.','I\'m ready to detonate the explosives.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80657,'','Hop on $p!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80658,'The boundless power of the stones flows through me! Your destruction comes!','',0,0,0,0,0,0,0,0,0,0,42023,0,26124),
(80659,'Deliciousss...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80660,'Look upon the tools of your demise! The ancient stones grant me unimaginable power!','',0,0,0,0,0,0,0,0,0,0,42018,0,26124),
(80661,'You can never challenge my rule! I command the power of the stones and know no equal!','',0,0,0,0,0,0,0,0,0,0,42027,0,26124),
(80662,'So thirsty... so much blood...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80663,'Juicy...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80664,'','By the light! Why won\'t you... just... break!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80665,'','Who built this barrier?! It is as if it knows me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80666,'','I will break this barrier down if it is the last thing I ever do!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80667,'','Give... me... back... my... FATHER!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80668,'','Open! By the light, just open!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80669,'','The barrier is down! Well done champion! I can sense my father is near. This way.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80674,'','We\'re in range of the tower $p! Light \'em up!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80675,'','The second tower is in range! Hit the detonator!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80676,'','That fortress could use some remodeling...let\'s give them a hand!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80677,'','Ticker?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80678,'','Great work, $p! Grommar\'s gonna be feelin\' the hurt from this operation for a while!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80679,'','Ah! And what a lovely sacrifice you will make.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80680,'Perfect! I needed a test target for my new powers.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80681,'Say hello to my little friends.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80682,'Enemies approach! Defend Xanatos at all costs!','Enemies approach! Defend Xanatos at all costs!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(80683,'Every living thing will be turned. You cannot stop it!','Every living thing will be turned. You cannot stop it!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80684,'Ah, there you are. I thought I smelled $r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80685,'What can I do for you?','What can I do for you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80686,'Ya can\'t beat Blook.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80687,'Blook likes to beat things. Want to be beaten?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80688,'What?','What?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80689,'Ouch! No more hitting. Blook sorry. Blook beaten.','',0,0,0,0,0,0,0,0,0,24861,0,0,26124),
(80690,'Blook never been beaten before. So Blook now follows tiny beater person.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80691,'Blook can be follower? Blook like to follow. Not as much as Blook like to beat. But Blook got beat, so Blook follows.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80692,'One day, Blook will beat all of the tiny people. Blook have many dreams for this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80693,'Pulling','Pulling',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80694,'Alright! Now keep \'em busy while I work my magic.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80695,'We\'re all set! Re-engage the clutch!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80696,'Cha-CHING!!','',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(80697,'Someone... please... it burns...','Someone... please... it burns...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80698,'Revenge is a dish best served with explosions! Hit the button, $p!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80699,'Hurry up puny orc! Chief need slaves now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80700,'Nobody sinks my battleship!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80701,'','Tuulani, go to Telmor and meet with Soulbinder Aedraa. She has retrieved the final fragment and brought it there.',0,0,0,0,0,0,396,0,4,0,0,43633,26124),
(80702,'','Right away.',0,0,0,0,0,0,1,0,4,0,0,44641,26124),
(80703,'','Master Dawnblade, here is the antivenin I prepared with $p\'s help. It should counter the deathweb venom\'s effects.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80704,'Thank you, Soulbinder.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(80709,'Let\'s just clamp the blowoff valve here...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80710,'Loosen this... tighten that... aaand....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80711,'Hey! Get away from that!','',0,0,0,0,0,0,0,0,0,24863,0,0,26124),
(80712,'','We will return to Frostfire as conquerors!',0,0,0,0,0,0,0,0,0,24864,0,0,26124),
(80713,'You work faster!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80714,'Puny thing work harder or I gives you to da boss!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80715,'Mine faster puny slave or da boss gonna drain you dead!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80716,'It hard work making you work hard!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80717,'Y-y-yes sir, whatever you say.','Y-y-yes sir, whatever you say.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80718,'Ow!','Ow!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80719,'Oww! Will the hurting ever stop?','Oww! Will the hurting ever stop?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80720,'No more! Please stop!','No more! Please stop!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80721,'RARGH! Puny slave things make me so ANGRY!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80722,'If they see you talking to me they will kill us both! Go away!','If they see you talking to me they will kill us both! Go away!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80723,'The Taskmasters, they have a key to my shackles. Help me, please!','The Taskmasters, they have a key to my shackles. Help me, please!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80724,'Help me, please!','Help me, please!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80725,'I... can\'t go on... please just leave me alone.','I... can\'t go on... please just leave me alone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80726,'Please, no more! I just need a moment to rest!','Please, no more! I just need a moment to rest!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80727,'Will this ever end?','Will this ever end?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80728,'Who are you? Leave me be.','Who are you? Leave me be.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80729,'Once I get my hands on an axe these ogres will pay for everything they\'ve done to me!','Once I get my hands on an axe these ogres will pay for everything they\'ve done to me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80730,'You\'re free! Get out of here and head to the nearest camp.','You\'re free! Get out of here and head to the nearest camp.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80731,'You\'re free! Make a run for it!','You\'re free! Make a run for it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80732,'You\'ve saved me from certain death. Thank you!','You\'ve saved me from certain death. Thank you!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(80733,'Don\'t let a single one of those ogres live.','Don\'t let a single one of those ogres live.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(80734,'I owe you my life!','I owe you my life!',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(80735,'I\'ve been waiting forever for this day!','I\'ve been waiting forever for this day!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(80736,'Too many of us have died here. Far too many.','Too many of us have died here. Far too many.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80737,'This nightmare is finally over.','This nightmare is finally over.',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(80738,'Be careful, I\'ve seen the bodies that come back after their \"boss\" has finished with them. They have no markings of torture on them but their faces are all frozen in a scream.','Be careful, I\'ve seen the bodies that come back after their \"boss\" has finished with them. They have no markings of torture on them but their faces are all frozen in a scream.',0,0,0,0,0,0,396,7,1,0,0,0,26124),
(80739,'A few nights ago there was a bunch of weird looking lights flashing from the cave across the lava flows. It sent a chill down my spine! The next day we were forced to haul the bodies of several prisoners out for the birds to eat. I.. still feel sick remembering it.','A few nights ago there was a bunch of weird looking lights flashing from the cave across the lava flows. It sent a chill down my spine! The next day we were forced to haul the bodies of several prisoners out for the birds to eat. I.. still feel sick remembering it.',0,0,0,0,0,0,396,7,1,0,0,0,26124),
(80740,'I was helping to move the bodies out of the western cave. One strange looking hair covered thing was still alive! They took it to their camp on the northeast hill.','I was helping to move the bodies out of the western cave. One strange looking hair covered thing was still alive! They took it to their camp on the northeast hill.',0,0,0,0,0,0,396,7,1,0,0,0,26124),
(80741,'I feel it!','I feel it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80742,'','Vindicator Namuun, here is the antivenin I prepared with $p\'s help. It should counter the deathweb venom\'s effects.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80743,'Thank you, Soulbinder.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(80749,'Fleshy creature! Come to the lava and speak with me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80750,'You dare assault the seat of my power? Is this the work of that traitor Cho\'gall? Kneel and swear fealty to me, and I may yet spare your lives for my coliseum.','',0,0,0,0,0,0,0,0,0,0,42029,0,26124),
(80751,'You will learn why I am king, and you are little more than peasants.','',0,0,0,0,0,0,0,0,0,0,42015,0,26124),
(80752,'I will make sure Artaal gets to safety. Retribution Point is not far from here.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(80753,'Scouts! Find that vermin!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80754,'We\'re ready to pick up our slaves for today. Uh... where are they?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80755,'The key to my cage is contained within the chest behind you. Would you mind obtaining it and letting me out?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80756,'While you ponder the current situation would it be possible to obtain the key from the chest and let me out?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80757,'Your presence in this dungeon is most fortuitous! At this very moment you represent the metaphorical key to my freedom! The literal key is in the chest behind you.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80758,'I would join you outside of this cage if it were not for the unfortunate fact that I am currently locked inside of it.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80759,'Slaves puny thing deliver be weak. Puny thing go get better slaves for Nub.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80760,'Although this prison cell is quite spacious, the accommodations are lacking. Would you mind letting me out?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80761,'Residing in this cage has made my skin rather itchy. Do you have any salve?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80762,'What?! We were told you would have a shipment ready when we got here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80763,'Salutations! Please excuse the abruptness of my greeting but we are precariously short on time...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80764,'While residing in this dungeon I had the curious pleasure of meeting this fellow Grulk that you see in the cage before you...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80765,'Please grant Grulk his freedom, $n. Do not be alarmed, I have found him to be of an exceedingly gentle nature...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80766,'Grulk was mutated against his will by the Iron Horde and has valuable information regarding this malevolent operation in Grommar.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80767,'While you assist Grulk in addressing the mutation business, I will find my way back to the team and continue the operation. Good luck, $n!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80768,'Huh? Yer no ogre. Are me eyes playin\' tricks on me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80769,'Everyone off! Let\'s get them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80770,'Ye here to get me outta this?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80775,'The Gyrocopter crash was not definitively my fault. Though to be fair, it was not definitively not my fault either. Is somebody trying to find fault? If so, I maintain that definitive fault in the matter is definitively inconclusive.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80776,'Put your backs into it, you lazy mutts!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80777,'We need to send out these shipments by sundown!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80778,'We have work to do. Bladefury\'s orders!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80779,'Hurry it up, or you\'ll feel my boot in your hide!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80780,'All dis snow and ice and fire. Everyt\'ing here be tryin\' to burn ya one way or anotha.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80781,'Eh boss-mon! We gonna be needin\' a few t\'ings. And it ain\'t pretty how we get them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80782,'Abandon Doomguard','Abandon Doomguard',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80783,'Abandon Terrorguard','Abandon Terrorguard',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80784,'Abandon Infernal','Abandon Infernal',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80785,'Abandon Abyssal','Abandon Abyssal',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80786,'Accept Shadow Hunter Rala\'s offer of service.','Accept Shadow Hunter Rala\'s offer of service.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80787,'My sista have other duties, but I have leave of ol\' Vol\'jin to extend my services to you.$b$bYa proved your worth, and did a task that needed doing.$b$bI be followin\' ya, boss-mon, if ya be willing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80788,'|TInterface\\Icons\\ability_blackhand_marked4death:20|tYou are |cFFFF0000|Hspell:156096|h[Marked for Death]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80789,'No! I must ascend!','No! I must ascend!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80790,'The Light! It burns!','The Light! It burns!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80791,'You will pay for this, mortal!','You will pay for this, mortal!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80792,'What are you doing? Stop!','What are you doing? Stop!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80793,'Stop! I must give myself to Teron\'gor!','Stop! I must give myself to Teron\'gor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80794,'Too little, too late. Arise!','Too little, too late. Arise!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80795,'Your blessings stop nothing!','Your blessings stop nothing!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80796,'I... am... LEGION!','I... am... LEGION!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80797,'DIE!','DIE!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80798,'Our power is too great for the likes of you.','Our power is too great for the likes of you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80799,'','$n, speak to Choluna. Let\'s go investigate this... Cragplume Cauldron.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80800,'','Hang on tight, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80801,'','Here we are. What is this place?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80802,'','I\'ve always had a fascination for blending in with the locals, but the inside of this Iron Horde armor smells awful. Maybe they\'d be less angry if they took a bath once in a while...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80803,'','The Iron Horde should never be underestimated, $n. Although they wield weaponry and sizeable forces that are worthy of respect, it is their unwavering persistence that must never go unchecked.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80804,'My trusty wrist-mounted, gnomatic cloaking device allows me to repair my gyrocopter unseen. An ingenious device if I do say so myself!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80809,'Borgal! Get back here, you murdering son of a trogg!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80810,'Barrels are the operative\'s perfect disguise. Nobody ever suspects a barrel...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80811,'','The Iron Horde cannot hide from our sharp eyes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80812,'','I have never before seen such a large network of steam vents and craters. What a fascinating place to study!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80813,'Take me to Cragplume Cauldron.','Take me to Cragplume Cauldron.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80814,'Hop on $p!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80815,'The tower is within range, $p! Use the detonator!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80816,'The second tower is in range! Hit the detonator!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80817,'We\'re in range of the fortress, $p! Explode them!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80818,'Do you know what this battleship needs, $p? Explosions!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80819,'','The Cauldron is just up ahead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80820,'Superlative work, $p! The Iron Horde operation in Grommar has been sufficiently attenuated thanks to your efforts!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80821,'I guess it could be worse...I could be in an outhouse.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80822,'I\'d like to know who came up with the phrase \"barrel of fun\", because I think I picked the wrong one.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80823,'Wait...what is this...termites!?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80824,'I hope your disguise is as good as mine, Adele.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80825,'The key to avoiding detection is to never be detected.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80826,'I wish this was a beer barrel...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80827,'You have seen but a fraction of my power. Behold the ancient magics unearthed by my empire!','',0,0,0,0,0,0,0,0,0,0,42019,0,26124),
(80828,'King\'s guard, to my side! I must focus my power and awaken the stone!','',0,0,0,0,0,0,0,0,0,0,42020,0,26124),
(80829,'Such power! It takes form to destroy you!','',0,0,0,0,0,0,0,0,0,0,42021,0,26124),
(80830,'Its energy overflows! Soon it will be unleashed!','',0,0,0,0,0,0,0,0,0,0,42022,0,26124),
(80831,'My activator is $n.','My activator is $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80832,'Enough! Long have the Sorcerer Kings guarded these chambers. Today you will see our secret power.','',0,0,0,0,0,0,0,0,0,0,42024,0,26124),
(80833,'Guards, remove these peasants.','',0,0,0,0,0,0,0,0,0,0,42025,0,26124),
(80834,'Its power grows beyond comprehension!','',0,0,0,0,0,0,0,0,0,0,42026,0,26124),
(80835,'Cho\'gall?! Traitorous scum - I knew you were behind this!','',0,0,0,0,0,0,0,0,0,0,42028,0,26124),
(80840,'I like to shop and you like to loiter','I like to shop and you like to loiter',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80841,'I like shopping. You like loitering.','I like shopping. You like loitering.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80842,'Shopping\'s my thing. What\'s yours?','Shopping\'s my thing. What\'s yours?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80843,'Nah... this is junk.','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(80844,'It\'s signed \"Uratok\" ...with a backwards \"r.\" Something tells me that\'s not who we\'re lookin\' for.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(80845,'Hm, no mark on this one.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(80846,'This was mass-produced at the foundry in Gorgrond. Looks like they ship some of the parts in and assemble them here.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(80847,'Ah-HAH! This one\'s signed \"DA\" with an anvil-shaped box around the letters. Now THAT\'s a mark I recognize.','',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(80848,'The threat on Draenor is one that impacts us all. I am glad that at least a few of you have agreed to work together against such great odds.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80849,'Please open a portal to Azeroth, Khadgar.','Please open a portal to Azeroth, Khadgar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80850,'De slaves are ready for ye boss.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80851,'Good, their wretched spirits will serve me better than their weak bodies ever could!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80852,'Hush, you idiot!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80853,'Ahhhh... Yes, now the Soulgrinder hums with power! With this, we shall be unstoppable!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80854,'Yo, Darkanvil! Nice digs you got here - I\'d prefer fewer bloodthirsty orcish warmongers, but whatever turns your crank I guess.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80855,'The drill ain\'t a problem no more. You ready to get outta here?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(80856,'Gazlowe! Listen, they forced me to build a drill-','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(80857,'But you better use it to die in a blaze o\' glory!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(80858,'I won\'t leave with my work still in the hands of the Iron Horde. I\'ve got a plan to make things right, if ye can spot me a can of yer famous rocket fuel...','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(80859,'You turned into some kinda hero, huh? Alright, suit yourself. Here.','',0,0,0,0,0,0,547,0,0,0,0,0,26124),
(80860,'','Good work, $n! This must be the chamber they were looking for.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80861,'Hah! We dwarves prefer to blast the OTHER guy to smithereens - not ourselves. I\'ll leave that to the goblin engineers.','',0,0,0,0,0,0,153,0,0,0,0,0,26124),
(80862,'Hold a moment $Glad:lass;, keep quiet and come over here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80863,'','What a fearsome creature. Well done, champion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80864,'','Wait... I feel a tremendous power. It\'s coming from the back of the cavern!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80865,'','Is this what the Iron Horde were after?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80866,'','Oh no! The cavern is unstable. Let\'s get out of here. Follow me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80867,'','Up this way, $n!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80868,'','Over here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80869,'The others will follow. The Legion will rise!','The others will follow. The Legion will rise!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80870,'','Looks like there\'s only one way out, hero. UP!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80871,'You do not understand the Great Work.','',0,0,0,0,0,0,0,0,7,0,41914,0,26124),
(80872,'You cannot defy the Great Work.','',0,0,0,0,0,0,0,0,7,0,41915,0,26124),
(80873,'This is the way of things. You cannot stop it.','',0,0,0,0,0,0,0,0,7,0,41916,0,26124),
(80874,'You do not understand... You cannot know...','',0,0,0,0,0,0,0,0,7,0,41917,0,26124),
(80875,'I\'m a lumberjack. How\'s the guarding?','I\'m a lumberjack. How\'s the guarding?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80876,'I\'m a lumberjack. you\'re the boss.','I\'m a lumberjack. you\'re the boss.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80877,'we both like to loiter','we both like to loiter',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80878,'we both like to loiter2','we both like to loiter2',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80879,'I like to loiter. What do you like to do?','I like to loiter. What do you like to do?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80880,'Yay! We unstoppable! We unstoppable!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80881,'I must return to the spirit world to continue my research. Guard this room and make sure that NO ONE touches the portal!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80883,'Thanks for the fuel, Gazlowe. After my great escape, maybe I\'ll pay you a visit and show you how I did it.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(80884,'','I\'ve got birds in the air all over Gorgrond. If Blackhand so much as visits an outhouse, I want to know about it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80885,'','Stupid Beast! Your training is not done!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80886,'','You will pay for this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80887,'','Foolish creature! Return to me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80888,'Come forth, Soulgrinder! Devour the souls that we have brought for you!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80889,'','Get back here! You are not free to go!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80890,'Axes down, brothers! Don\'t you recognize your own clan?','',0,0,0,0,0,0,0,0,4,0,44086,0,26124),
(80895,'','Got you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80896,'We are home.','',0,0,0,0,0,0,0,0,4,0,46673,0,26124),
(80897,'We will burn your homes to the ground!','We will burn your homes to the ground!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80898,'Please! Let us live!','Please! Let us live!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80899,'We will take everything!','We will take everything!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80900,'You will pay for this one day.','You will pay for this one day.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80901,'I will not give up...','I will not give up...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80902,'Your clan is no match for us!','Your clan is no match for us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80903,'The Thunderlord are the strongest!','The Thunderlord are the strongest!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80904,'You won\'t get away with this!','You won\'t get away with this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80905,'Watch!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80906,'Your wolf cannot help you now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80907,'The Frostwolf are weak!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80908,'Fill it with arrows.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80909,'Kill them!','Kill them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80910,'We will never bow to you!','We will never bow to you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80911,'Ha, not a chance. Light it up!','Ha, not a chance. Light it up!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80912,'Connecting Rocket Chicken','Connecting Rocket Chicken',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80913,'','What do you make of it, Thrall?',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80914,'It reeks of hatred and dust, Choluna. I don\'t like having it here at the garrison.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80915,'I\'d like it even less in the hands of the Iron Horde.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80916,'We should destroy it.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80917,'Perhaps. First, we must find out what purpose it serves for Blackhand.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80918,'Choluna, step up our operation in Gorgrond. Whatever the Iron Horde are planning, I want to be ready.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80919,'Up ya go!','',0,0,0,0,0,0,70,0,0,0,0,0,26124),
(80920,'That stuff makes an awesome lubricant. You know, for engines.','',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(80921,'Careful, now... that thing shatters and we\'re toast.','',0,0,0,0,0,0,430,0,0,0,0,0,26124),
(80922,'Ha! Just try and stop us!','Ha! Just try and stop us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80923,'Take from the weak!','Take from the weak!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80924,'This belongs to the Thunderlord now!','This belongs to the Thunderlord now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80925,'Hold up, I sense we\'re not alone in here. Come out peacefully before I have to flush ye out! Show yourself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80926,'You can\'t stop us!','You can\'t stop us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80927,'And what are you supposed to be?','',0,0,0,0,0,0,396,0,4,0,45259,0,26124),
(80928,'Amazing.','',0,0,0,0,0,0,396,0,4,0,45005,0,26124),
(80929,'I thought my life was over! My thanks to you.','I thought my life was over! My thanks to you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80930,'The mine began to quake and then the creatures appeared...','The mine began to quake and then the creatures appeared...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80931,'My thanks! I think I can make it out on my own.','My thanks! I think I can make it out on my own.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80932,'','Please, hold your weapons! I mean you no harm. I just needed to make sure you\'re not here with Borgal. From the way you two look, I don\'t think you\'re going to be on friendly terms when you catch up to him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80933,'This is Frostwolf territory, but you may claim this plateau as your own. Consider it a reward for rescuing my people.','',0,0,0,0,0,0,396,0,4,0,45262,0,26124),
(80934,'Thank you, chieftain. We will establish a foothold immediately.','',0,0,0,0,0,0,396,0,4,0,46387,0,26124),
(80935,'Honestly boss, I\'m a wee bit out o\' me element here. I think we should give her a shot. We might need her help.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80936,'','That fat ogre needs to pay for the suffering he caused! Maybe we can work together? If you help me out, I\'ll be able to help you track down Borgal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80937,'Why should we trust ye?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(80938,'I would have surely died. Thank you, Hero.','I would have surely died. Thank you, Hero.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80939,'Please help the others...I\'ll try to make it out on my own.','Please help the others...I\'ll try to make it out on my own.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80940,'Our fallen demand vengeance!','Our fallen demand vengeance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80941,'For the Iron Wolf!','For the Iron Wolf!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80942,'I would have perished without your aid. You have my gratitude!','I would have perished without your aid. You have my gratitude!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80943,'Don\'t worry, little ones. We\'ll make it through this.','Don\'t worry, little ones. We\'ll make it through this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80944,'Any Thunderlord get in here, we\'ll carve them up!','Any Thunderlord get in here, we\'ll carve them up!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80945,'Garrison - Event - Orc Attack Stage 1 Begin','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80946,'Garrison - Event - Orc Attack Stage 2 Begin','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80947,'Garrison - Event - Orc Attack Stage 3 Begin','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80948,'Garrison - Event - Orc Attack Stage 1 End','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80949,'Garrison - Event - Orc Attack Stage 2 End','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80950,'Garrison - Event - Orc Attack Stage 3 End','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80951,'The weak deserve this!','The weak deserve this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80952,'You cannot save them!','You cannot save them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80953,'Here\'s another come to die.','Here\'s another come to die.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80954,'We will crush you just the same!','We will crush you just the same!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80955,'Even our wyverns are not prepared for this type of cold.','Even our wyverns are not prepared for this type of cold.',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(80956,'It looks as though we will not have allies in the skies for this one.','It looks as though we will not have allies in the skies for this one.',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(80957,'We are going to have to find a better way to shield our wyvern from the cold.','We are going to have to find a better way to shield our wyvern from the cold.',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(80958,'It would seem we need to rely on the local rylak for air travel.','It would seem we need to rely on the local rylak for air travel.',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(80959,'The orc\'s face has been chewed off.','The orc\'s face has been chewed off.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80960,'Half of this orc\'s body was seared away by a steam fissure.','Half of this orc\'s body was seared away by a steam fissure.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80961,'The mangled body is scored by deep claw marks.','The mangled body is scored by deep claw marks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80962,'The flesh is macerated almost beyond recognition.','The flesh is macerated almost beyond recognition.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80963,'','Eh, boss-mon. We gonna be needin\' a lot more furs. No one told us how cold it be on dis side of the portal before we stepped through.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80964,'','I\'m gonna rearrange your nuts and bolts!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80965,'','Saddle up maggot, you\'re going for a ride!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80967,'Nope.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(80968,'What do you make of it, Yrel?','',0,0,0,0,0,0,6,0,4,0,0,0,26124),
(80969,'','It reeks of hatred and dust, Omnuron. I don\'t like this.',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(80970,'We should destroy it.','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(80971,'Okay let\'s do this! Borgal\'s been having prisoners delivered to a cave on the other side of the lava flows.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80972,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80973,'Those poor people! Hurry $Glad:lass;, we got to get rid of Grubnor then follow Borgal through that portal to... wherever the blazes it goes!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80974,'The shard is mine. The portal will grow!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80975,'NO! THE LEGION WILL CONSUME ALL!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80976,'It be so cold I can feel me mojo freezin\'. Dis not what I signed up for.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80977,'Ya mon. These furs be lettin\' me legs thaw. I can feel my toes again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80978,'How they not be tellin\' us this be a frozen wasteland. Even da fire be frozen. How can fire be frozen?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80979,'I tried to have a drink from me flask earlier. It froze just after it hit me tongue. Took two orcs to pry it off. Dey ain\'t happy \'bout that.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80980,'Eh mon. Eh. I dare ya to lick the metal. Do eet!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80981,'Who in charge thought island trolls be good for a frozen land war?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80982,'Ma breath just froze in front of me. It fell like ice to da ground. I hate dis place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80983,'I be warmer now! I can think a full thought again wit\'out swearin\' at da cold.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80984,'Dat fur really be workin\' mon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80985,'I smell like yeti. Dis pleases me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80986,'I don\'t get it. How you be gettin\' fire and ice in da same place at da same time?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80987,'I clearly underestimated the size of the bones one can find here. I will need a larger hacksaw, and a few of those wolf sleds, and maybe a few extra wolves for resear... er... labor. Yes, labor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80988,'Ah, $p. At least you have the stomach for my research. With the peace treaty under way in Azeroth I find I am in need of fresh corpses.$b$bFortunately, you seem to leave plenty in your wake.','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(80989,'You smell like something the Thunderlord would hunt.','You smell like something the Thunderlord would hunt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80990,'You may have strength on your side, but the cold will sap that from you in the first few seconds of combat. Stay warm if you want to stay alive.','You may have strength on your side, but the cold will sap that from you in the first few seconds of combat. Stay warm if you want to stay alive.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80991,'Thunderlord hunt in packs and prefer large prey. Are you large prey?','Thunderlord hunt in packs and prefer large prey. Are you large prey?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80992,'When dealing with Thunderlord, it is vital to reduce their numbers quickly. In a group they are lethal. Individually you can squash them like the bugs they are.','When dealing with Thunderlord, it is vital to reduce their numbers quickly. In a group they are lethal. Individually you can squash them like the bugs they are.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80993,'','Look at me, isn\'t my reason obvious? I\'m dead! My body is rotted and gone! I used to go climb the mountains and watch the sunrise in the morning. Now I\'m doomed to not know the warmth of daylight ever again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80994,'','And I have Borgal to thank for this... this state I\'m in. I want to see his spirit flayed for what he\'s done to me and all of the others who he has murdered. Is that reason enough to believe me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80995,'Do not fear the snow and ice. Use it. If you are wounded you can quickly slow the damage until you get help from a healer. Embrace the cold and you survive.','Do not fear the snow and ice. Use it. If you are wounded you can quickly slow the damage until you get help from a healer. Embrace the cold and you survive.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(80996,'This terrain is ideal for a stronghold.','',0,0,0,0,0,0,396,0,4,0,46379,0,26124),
(80997,'I can open up a portal to Orgrimmar only briefly. Reinforcements are standing by, I hope?','',0,0,0,0,0,0,396,0,4,0,45002,0,26124),
(80998,'The very best.','',0,0,0,0,0,0,396,0,4,0,46380,0,26124),
(80999,'Somebody call for a fixer?','',0,0,0,0,0,0,396,0,4,0,47505,0,26124),
(81000,'... You\'re entrusting a goblin to be your foreman?','',0,0,0,0,0,0,396,0,4,0,45003,0,26124),
(81001,'Gazlowe, here, oversaw the construction of Orgrimmar.','',0,0,0,0,0,0,396,0,4,0,46381,0,26124),
(81002,'Orgrimmar! The impenetrable fortress!','',0,0,0,0,0,0,396,0,4,0,47506,0,26124),
(81003,'Wasn\'t it recently sacked?','',0,0,0,0,0,0,396,0,4,0,45004,0,26124),
(81004,'Yeah yeah, okay, one little sacking.','',0,0,0,0,0,0,396,0,4,0,47507,0,26124),
(81005,'Omnuron, step up our operation in Gorgrond. Whatever the Iron Horde are planning, I want to be ready.','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(81006,'She makes a good argument. Honestly boss, I think we should give her a shot. We might need her help.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81007,'The nearby hatchlings try to skitter away...','The nearby hatchlings try to skitter away...',0,0,0,0,0,0,0,0,0,25099,0,0,26124),
(81008,'|TInterface\\Icons\\ability_hunter_rapidregeneration.blp:20|t Admiral Gar\'an looks towards you and readies |cFFFF0000|Hspell:156626|h[Rapid Fire]|h|r!','|TInterface\\Icons\\ability_hunter_rapidregeneration.blp:20|t Admiral Gar\'an looks towards you and readies |cFFFF0000|Hspell:156626|h[Rapid Fire]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81009,'','You fools! I will make you pay for this interruption!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81010,'','Enough! Once I dispose of you interlopers nothing will stand in my way!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81011,'','No! It was not supposed to happen...this way...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81012,'$p, I can only channel this barrier for a short time. You must defeat Kaelynara before it is too late!','$p, I can only channel this barrier for a short time. You must defeat Kaelynara before it is too late!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81013,'','Such power...such potential. The latent energy within this crystal shall go to waste no longer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81014,'','How naive you are. This place is nothing but a shell, a husk, to be torn and discarded from the fruit of power that I shall devour!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81015,'You will never take our homes!','You will never take our homes!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81016,'Garrison - Event - Enemy Killed','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81017,'','You must stop this madness Kaelynara! Look around at the destruction you are causing!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81018,'Your lust for power has overcome you, Kaelynara. I will not allow you to destroy this mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81019,'To honor our fallen!','To honor our fallen!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81020,'I give my life for my home!','I give my life for my home!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81021,'Die!','Die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81022,'Repel the invaders!','Repel the invaders!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81023,'What is this -- Wise-ear! You are alive!','',0,0,0,0,0,0,0,0,4,0,46663,0,26124),
(81024,'Lead us to Durotan, old friend.','',0,0,0,0,0,0,0,0,4,0,46664,0,26124),
(81025,'Wor\'gol is the winter home of the Frostwolf Clan.','',0,0,0,0,0,0,0,0,4,0,46657,0,26124),
(81026,'Durotan walks a cliff\'s edge, pinned between the Thunderlord orcs and Bladespire ogres.','',0,0,0,0,0,0,0,0,4,0,46658,0,26124),
(81027,'Ga\'nar seemed bent on dealing out retribution to both.','',0,0,0,0,0,0,0,0,4,0,46372,0,26124),
(81028,'Ah yes! I worry about Durotan\'s brother. Always quick to fight. His need for vengeance will make him more reckless than ever.','',0,0,0,0,0,0,0,0,4,0,46659,0,26124),
(81029,'What is THAT? I see a fortress of stone!','',0,0,0,0,0,0,0,0,4,0,46373,0,26124),
(81030,'Bladespire Citadel. Once a far-flung outpost of the ogre empire.','',0,0,0,0,0,0,0,0,4,0,46660,0,26124),
(81031,'If our people are to have any hope to survive, we must rout the ogres from their stronghold.','',0,0,0,0,0,0,0,0,4,0,46661,0,26124),
(81032,'This is Durotan\'s goal. He will not ask for it, but we will need your help!','',0,0,0,0,0,0,0,0,4,0,46662,0,26124),
(81033,'','Borgal\'s death is only a matter of time, and time is something I have plenty of.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81034,'I found this totem, can you tell me anything about it?','I found this totem, can you tell me anything about it?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81035,'','This is one of the totems that Borgal used to channel his magic before he unearthed the Soulgrinder. $b$bI sense there is still quite a bit of spiritual power emanating from it. If we can find the rest of his totems I can use them to eject Borgal out of the Spirit world. Once he has been cut off from the power of this plane you and Owynn should be able to end him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81036,'Garrison - Event - Reinformcement Killed','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81037,'','The Jorune Mine provides many of the crystals used to power Auchindoun and Shattrath.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81038,'Our Draenei brothers and sisters of the Alliance warned us of the Blood Elves\' lust for magical power. If such is the cost of their aid against the Burning Legion, I will gladly fight the demons alone.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81039,'Come here, hero! I need your help!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81040,'The Legion will rise! Draenor will be bathed in hellfire!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81041,'','Ga\'nar did not wait for the muster call. His blood burns too hot.',0,0,0,0,0,0,0,0,4,0,0,41803,26124),
(81042,'','Go! Win us a great victory. Tell my husband I will defend the town until he returns.',0,0,0,0,0,0,0,0,4,0,0,41804,26124),
(81043,'What can you tell me about this place?','What can you tell me about this place?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81044,'','Concentrate, sisters! We must maintain Auchindoun\'s defenses.',0,0,0,0,0,0,0,0,0,0,0,47215,26124),
(81045,'','Don\'t give up, soulbinders. Auchindoun must be protected!',0,0,0,0,0,0,0,0,0,0,0,47216,26124),
(81046,'','The defenses will not falter. We are Auchindoun\'s protectors!',0,0,0,0,0,0,0,0,0,0,0,47217,26124),
(81047,'As you already know, arcane crystals are an important part of Draenei culture. The crystals from this mine are used in many places, but are mostly supplied to Shattrath and Auchindoun.$b$bWhen treated with care these crystals can be powerful sources of arcane energy. Attempting to unleash the energy from a crystal this size is reckless and foolhardy.$b$bThe earth elementals you see rampaging throughout the mine typically slumber far beneath the ground. It appears as though Kaelynara\'s tampering has enraged them.$b$bMy vindicators will be successful in reclaiming the mine, but the battle will be hard fought.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81048,'','We are sworn to Auchindoun\'s protection. Keep up the defenses!',0,0,0,0,0,0,0,0,0,0,0,47218,26124),
(81049,'','We must recover Karab\'uun at all costs. March forward the moment you see a hole in their lines!',0,0,0,0,0,0,0,0,0,0,0,43631,26124),
(81050,'','We will stand by you, Exarch. No demon will set foot in Auchindoun on my watch.',0,0,0,0,0,0,1,0,0,0,0,45716,26124),
(81051,'Today we fulfill our eternal oath. We will protect Auchindoun with our lives!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(81052,'My enslavement... is over.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81053,'At... last... freedom.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81054,'Sweet release...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81055,'Back to dust.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81056,'','The Legion won\'t give up so easily. Auchindoun is too valuable to them.',0,0,0,0,0,0,1,0,4,0,0,45717,26124),
(81057,'','Teron\'gor! The Light comes for you!',0,0,0,0,0,0,1,0,4,0,0,45719,26124),
(81058,'Oooh... I don\'t feel so good...','',0,0,0,0,0,0,15,0,1,0,0,0,26124),
(81059,'|cFFFF0000|Hspell:156479|h[Massive Demolition]|h|r killed you.  Move away from the impact point to decrease damage taken.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81060,'The Legion will not stop here. They desire Auchindoun too much.','',0,0,0,0,0,0,1,0,4,0,44600,0,26124),
(81061,'Nyami. Tuulani. We ride for Light\'s Rest immediately.','',0,0,0,0,0,0,1,0,4,0,44602,0,26124),
(81062,'A mind control device is sitting on the table.','A mind control device is sitting on the table.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81063,'I told Liadrin that I would take care of this...situation. The last thing the Sunsworn want right now is to lose the trust of the Auchenai.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81064,'Timber!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(81065,'Strike their hearts!','Strike their hearts!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81066,'Claiming','Claiming',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81067,'Those bodies don\'t look like they\'ve been laying there for long. Lets keep onward to that cave but keep ye eyes an ears open.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81068,'','I\'ve come to Talador at the request of Archmage Khadgar to assist the Auchenai against the Burning Legion. When I learned of the situation here at the mine I came to offer my aid.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81069,'','Burn in fel fire, you insignificant maggots!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81070,'','Cower before me, you insolent mortals!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81071,'Down, ye filthy beast!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81072,'Not good!','Not good!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81073,'For the Alliance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81074,'Whoa! I said, \"Whoa!!!\"','Whoa! I said, \"Whoa!!!\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81075,'Seriously?!','Seriously?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81076,'Enough with the spinning!','Enough with the spinning!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81077,'Eat dirt!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81078,'What are you doing?!','What are you doing?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81079,'I\'m gonna puke!','I\'m gonna puke!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81080,'Stop! Stupid rylak!','Stop! Stupid rylak!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81081,'Oh that looked like it hurt!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81082,'Hey! Hold on! Wait!','Hey! Hold on! Wait!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81083,'Should have watched yer back!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81084,'AHH!!!','AHH!!!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81085,'What the what?!','What the what?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81086,'NOT GOOD!','NOT GOOD!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81087,'Why me?!','Why me?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81088,'I thought we were friends!','I thought we were friends!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81089,'NOO!!','NOO!!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81090,'We meet again, $n! Could you please wait a minute?$B$BNorana should be back at any moment. We should thank you together.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81091,'We meet again, $n! Thank you again for your help back there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81092,'','<Ankaa blinks through tears.> I feel terrible about what happened to Isaari. She was my best friend!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81093,'','<Riasa blinks through tears.> I feel terrible about what happened to Norana. She was my best friend!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81094,'We should never have gone into that forest. I... I don\'t know how I\'m going to get over this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81095,'We should never have gone into that forest. I... I don\'t know how I\'m going to get over this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81096,'Breaking Lock','Breaking Lock',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81097,'Garrison - Event - Orc Attack Add Kill Bar','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81098,'You know nothing of the power you meddle with, Mar\'gok. (It calls to us. We know! Its power will be ours!)','',0,0,0,0,0,0,0,0,0,0,46614,0,26124),
(81099,'It baffles me to see so much that was once majestic and beautiful be reduced to the fel infested wasteland that is Outland.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81100,'Accept the The Staff of Archmage Vargoth. (Garrison Follower)','Accept the The Staff of Archmage Vargoth. (Garrison Follower)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81101,'Your reign has come to an end, the infinite night begins. (Darkness comes!)','',0,0,0,0,0,0,0,0,0,0,46615,0,26124),
(81102,'Tagar, destroy the intruder! These souls are nearly mine!','',0,0,0,0,0,0,0,0,0,0,44414,0,26124),
(81103,'There is no darkness light cannot pierce, Ner\'zhul!','',0,0,0,0,0,0,5,0,0,0,45377,0,26124),
(81104,'Ya can\'t tie a wolf to dat sledge, mon. Dem Frostwolf orcs gonna kill you for dat if dey be findin\' out.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81105,'Look at dat tiny wolf, mon. There no way it can pull the whole sledge. Ya just bein\' mean.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81106,'Ya got issues, mon. Serious issues. What dat wolf ever do to you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81107,'The shadows have already consumed my soul, prophet.','',0,0,0,0,0,0,0,0,0,0,43695,0,26124),
(81108,'Ah much better! Fits a bit loose but nothing a couple mugs o\' ale can\'t sort out.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81109,'','Quickly, hero! This beast must be stopped!',0,0,0,0,0,0,5,0,0,0,0,45603,26124),
(81110,'Fool! Auchindoun will be mine. Every soul I consume grows my power. You face the wrath of a power greater than you can possibly imagine.','',0,0,0,0,0,0,0,0,0,0,44415,0,26124),
(81111,'Sir, Thunderlord Orcs are marching on the garrison!','Sir, Thunderlord Orcs are marching on the garrison!',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(81112,'Rain? Now? This feels unnatural, and I bet I know who is behind it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81113,'Thunderlords, here?  Scout, ring the Call to Arms bell to get everyone inside!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81114,'Footmen, to arms! We\'re damn sure not dying in Draenor today! To your posts!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81115,'No! The power of the Dark Star will be MINE!','',0,0,0,0,0,0,5,0,0,0,43696,0,26124),
(81116,'It is not too late. Turn from this dark path and let us help you.','',0,0,0,0,0,0,1,0,0,0,45378,0,26124),
(81117,'','The Light is with us!',0,0,0,0,0,0,5,0,0,0,0,45604,26124),
(81118,'Back, you mongrels! You\'ll get out of here over my dead body!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(81119,'Don\'t worry, girls. I won\'t let anything happen to you.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(81120,'I\'ll head back to the front. For Auchindoun!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81121,'Thank you for your help. These brutes will have to try harder than that to beat us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81126,'Thunderlord! To the front!','Thunderlord! To the front!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81127,'Do not let any more of them through!','Do not let any more of them through!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81128,'Report to the front lines!','Report to the front lines!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81129,'We will stop the Frostwolf!','We will stop the Frostwolf!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81130,'Jus\' stay warm. It be okay. Ya gonna be fine.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81131,'We will stop the rest!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81132,'Jus\' stay close to da fire. Wyverns ain\'t be made for such cold. Jus\' stay warm.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81133,'Don\' be freezin\' on me now. Stay warm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81134,'I am ready to confront Kaelynara.','I am ready to confront Kaelynara.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81135,'I am ready to return to the Jorune Mine.','I am ready to return to the Jorune Mine.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81136,'Well fought! We will meet you just up ahead!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81137,'Let\'s get going! Commander, we\'ll meet ye at the tower.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81138,'Furnace pressure is out of control - the Heart of the Mountain starts gaining more heat!','Furnace pressure is out of control - the Heart of the Mountain starts gaining more heat!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81139,'Welcome, traveler. This land has seen hard times of late, but also great heroism. Would you like to walk in the steps of these brave adventurers and witness their deeds?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81140,'The tales I have to tell are still yours to experience! Go forth and adventure!$b$b(You must be at least level 91 to hear Fu\'s stories.)','The tales I have to tell are still yours to experience! Go forth and adventure!$b$b(You must be at least level 91 to hear Fu\'s stories.)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81141,'Tell me of Greenstone Village.','Tell me of Greenstone Village.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81142,'Tell me of Unga Ingoo.','Tell me of Unga Ingoo.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81143,'Tell me of the Crypt of Forgotten Kings.','Tell me of the Crypt of Forgotten Kings.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81144,'Tell me of the Arena of Annihilation.','Tell me of the Arena of Annihilation.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81145,'Tell me the tale of a Brewing Storm.','Tell me the tale of a Brewing Storm.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81146,'Tell me of the Assault on Zan\'vess.','Tell me of the Assault on Zan\'vess.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81147,'Tell me of the Brewmoon Festival.','Tell me of the Brewmoon Festival.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81148,'Tell me of Theramore\'s Fall.','Tell me of Theramore\'s Fall.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81149,'Tell me of the Dagger in the Dark that felled Vol\'jin.','Tell me of the Dagger in the Dark that felled Vol\'jin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81150,'Tell me of the Battle on the High Seas.','Tell me of the Battle on the High Seas.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81151,'Tell me of how Varian and Tyrande learned a Little Patience.','Tell me of how Varian and Tyrande learned a Little Patience.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81152,'Tell me of the unearthing of the Dark Heart of Pandaria.','Tell me of the unearthing of the Dark Heart of Pandaria.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81153,'Tell me of the Secrets of Ragefire.','Tell me of the Secrets of Ragefire.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81154,'Tell me the tale of Blood in the Snow.','Tell me the tale of Blood in the Snow.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81155,'','Stand ready, $n. As soon as her shield is broken I will teleport us out of the mine.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81156,'','This madness ends now Kaelynara! We will not allow you to cause further destruction!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81157,'So, you have decided to join me on my quest to tame the Darktide Matriarch?$b$bIt appears you are not the only one. The Iron Horde is destroying this island and the creatures that inhabit it. They have no respect for the rylaks they hunt.$b$bRest assured $c, I will not let this disgraceful slaughter go unpunished.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81158,'It appears that one of your allies has arrived, mage.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81159,'My vindicators will handle things here. May the Light return you both in safety.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81160,'','Wait...what are you...?! Nooooo!!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81161,'Unfortunate, but now we know more. You can take the portal back to Throm\'var.','',0,0,0,0,0,0,0,1,0,0,45006,0,26124),
(81162,'Garrison - Event - Attack Prototype - Building Burning','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81163,'','Good, I have been waiting for a fight!',0,0,0,0,0,0,15,0,0,0,0,43554,26124),
(81164,'Garrison - Event - Attack Prototype - Reduce Reinforcements','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81165,'Arrogant spirit, you dare to summon me?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81166,'Your pathetic magic will have no control over me back in da normal world. Once I\'ve fed your friends to da Soulgrinder I\'ll return for you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81167,'%s |cFFFF0404|Hspell:158986|h[Fixates]|h|r on you!','%s |cFFFF0404|Hspell:158986|h[Fixates]|h|r on you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81168,'Khadgar, let\'s go over what happened when Garona attacked.','Khadgar, let\'s go over what happened when Garona attacked.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81169,'You owe me a fight, cowards.','',0,0,0,0,0,0,0,0,0,0,44515,0,26124),
(81170,'Carnage!','',0,0,0,0,0,0,0,0,0,0,44526,0,26124),
(81171,'There is no escape.','',0,0,0,0,0,0,0,0,0,0,44527,0,26124),
(81172,'Let\'s give the crowd something to chew on.','',0,0,0,0,0,0,0,0,0,0,44528,0,26124),
(81173,'You break so easily!','',0,0,0,0,0,0,0,0,0,0,44523,0,26124),
(81174,'You\'ll always be remembered, as a smudge on my boot.','',0,0,0,0,0,0,0,0,0,0,44524,0,26124),
(81175,'No mercy!','',0,0,0,0,0,0,0,0,0,0,44525,0,26124),
(81176,'The vanguard is falling. We will not let their great sacrifice be in vain!','',0,0,0,0,0,0,0,0,4,0,44880,0,26124),
(81177,'Your sacrifices will not be forgotten, Netherwane.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81178,'Archmage, let me stay behind. It was my sworn duty to watch over this portal.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81179,'I shared that duty with you, Dar\'toon.  We will meet the enemy together.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81180,'They will sing songs of your heroism, Dar\'toon.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81181,'Just get me free, stranger. I could kill a hundred of these pigs with this shovel alone.','',0,0,0,0,0,0,0,0,4,0,45045,0,26124),
(81182,'Prepare to heroically CTRL-E through the portal with me!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81183,'Be careful, I\'ve seen the bodies that come back after their \"boss\" has finished with them. They have no markings of torture on them but their faces are all frozen in a scream.','Be careful, I\'ve seen the bodies that come back after their \"boss\" has finished with them. They have no markings of torture on them but their faces are all frozen in a scream.',0,0,0,0,0,0,396,7,1,0,0,0,26124),
(81184,'I was helping to move the bodies out of the western cave. There was a tall skinny female with green hair and pale blue skin that was still alive! It didn\'t look like an orc or if it was it was by far the most sickly looking thing I\'ve ever seen. One of the ogres took her down to the cave in the north east.','I was helping to move the bodies out of the western cave. There was a tall skinny female with green hair and pale blue skin that was still alive! It didn\'t look like an orc or if it was it was by far the most sickly looking thing I\'ve ever seen. One of the ogres took her down to the cave in the north east.',0,0,0,0,0,0,396,7,1,0,0,0,26124),
(81185,'A few nights ago there was a bunch of weird looking lights flashing from the cave across the lava flows. More of that foul ogre magic no doubt.','A few nights ago there was a bunch of weird looking lights flashing from the cave across the lava flows. More of that foul ogre magic no doubt.',0,0,0,0,0,0,396,7,1,0,0,0,26124),
(81186,'On your guard, $n. Once I break through Kaelynara\'s shield I will teleport us outside the mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81187,'This has gone on long enough! Your madness ends here Kaelynara!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81188,'Kaelynara\'s betrayal was unfortunate. I will inform Astalor as to what has become of his apprentice...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81189,'When you are ready, I will teleport you back to Jorune Mine.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81190,'','True arcane mastery only comes with patience and dedication. Kaelynara was naive to think otherwise...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81191,'','When you are ready, I will teleport you back to Jorune Mine, $p.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81192,'','I\'ll lead the wounded to safety. Cover our escape!',0,0,0,0,0,0,396,0,4,0,0,44643,26124),
(81193,'The Frenzied Manafeeder has entered a weakened state.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81194,'','Welcome, wolf-$g brother:sister;. Warm yourself by the fire.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(81195,'Greetings. I have focused my studies on the heroic deeds of recent visitors to these lands. Would you hear any of these tales?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81196,'Tell me of the Battle on the High Seas (Heroic).','Tell me of the Battle on the High Seas (Heroic).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81197,'Tell me of the unearthing of the Dark Heart of Pandaria (Heroic).','Tell me of the unearthing of the Dark Heart of Pandaria (Heroic).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81198,'Tell me of the Secrets of Ragefire (Heroic).','Tell me of the Secrets of Ragefire (Heroic).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81199,'Tell me the tale of Blood in the Snow (Heroic).','Tell me the tale of Blood in the Snow (Heroic).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81200,'Tell me the tale of a Brewing Storm (Heroic).','Tell me the tale of a Brewing Storm (Heroic).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81201,'Tell me of the Crypt of Forgotten Kings (Heroic).','Tell me of the Crypt of Forgotten Kings (Heroic).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81202,'Gul\'dan\'s a slippery one.$B$BDon\'t let it get you down, commander. We\'ll catch him.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(81203,'','My apologies for not joining you, commander. I\'d love to be out there killing the Shadow Council with you.$B$BHowever, my duty to protect the archmage must come first.$B$BOf course, you could whisper in his ear to have one of my sisters come and take my place.',1,274,0,0,0,0,0,0,0,0,0,0,26124),
(81204,'','The Shadow Council are disgusting. But, infusing the bodies of dead frost wolves with demonic energy is a new low!',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(81205,'','I\'d bet you my spare blade that whatever\'s causing these ground tremors is also directly responsible for those rockworms.$B$BOf course, you have no idea how to wield one of these. Maybe you could mount it on your wall.',1,274,0,0,0,0,0,0,0,0,0,0,26124),
(81206,'','I\'ll be fine!',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(81207,'Don\'t worry about me. They can\'t see this projection.$B$BEverything we do here is leading to one thing, $n: Gul\'dan\'s capture.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(81208,'Commander, our work here is done. Please use the portal to return to Throm\'var.$B$BWe\'ll speak at length of next steps when you return.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(81209,'If we\'re to destroy the fel crystals and bring down the barrier protecting the Gloomspire, you must find the demon key.$B$BI\'d start by killing Fernus.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(81210,'Quickly, $n. The next step is to move throughout the ruins, using the infernal\'s heart to destroy the fel crystals.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(81211,'Time is of the essence, commander. Gul\'dan could leave at any moment.$B$BYou must destroy those fel crystals and get to him inside the Gloomspire.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(81212,'You continue to impress, Commander $n.$B$BOne thing remains: to capture Gul\'dan.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(81213,'Gul\'dan is down below. Do whatever you must, $n, but capture him before he escapes.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(81214,'You lot need to smash harder! We gotta beat da Bladespire at da next Circle of Blood!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81215,'You hit harder or me hit you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81216,'You win da Circle of Blood, me give you dat slave I gots locked up outside.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81217,'My apologies, wolf-$g brother:sister;. We are dishonored for letting the archmage be attacked here in our home.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(81218,'If I had it within my power, I\'d go back in time and strangle Gul\'dan before he drank of Mannoroth\'s blood.','',15,0,0,0,0,0,0,0,0,0,0,0,26124),
(81219,'Mark my words, $g brother:sister;, no good will come of Cho\'gall\'s interest in these Pale.','',274,0,0,0,0,0,0,0,0,0,0,0,26124),
(81220,'My heart lies heavy in my chest. Thank you for showing the Mother of Wolves her proper respects.$B$BShe will be avenged.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(81221,'%s cries out for help!','%s cries out for help!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81222,'Whoever you are... thank you.','Whoever you are... thank you.',0,0,0,0,0,0,0,0,4,0,43878,43878,26124),
(81223,'They were bleeding us dry. I don\'t think we had much longer...','They were bleeding us dry. I don\'t think we had much longer...',0,0,0,0,0,0,0,0,4,0,43879,43879,26124),
(81224,'Whoever you are... thank you.','Whoever you are... thank you.',0,0,0,0,0,0,0,0,4,0,46155,46155,26124),
(81225,'They were bleeding us dry. I don\'t think we had much longer...','They were bleeding us dry. I don\'t think we had much longer...',0,0,0,0,0,0,0,0,4,0,46154,46154,26124),
(81226,'Help us!','Help us!',0,0,0,0,0,0,0,0,4,0,43876,43876,26124),
(81227,'Set us free!','Set us free!',0,0,0,0,0,0,0,0,4,0,43877,43877,26124),
(81228,'Is anybody out there?','Is anybody out there?',0,0,0,0,0,0,0,0,4,0,46152,46152,26124),
(81229,'Help! Anybody!','Help! Anybody!',0,0,0,0,0,0,0,0,4,0,46153,46153,26124),
(81230,'Time to spill your blood!','',0,0,0,0,0,0,0,0,0,0,44529,0,26124),
(81231,'','Hurry! We must move these supplies.  Ner\'zhul will not tolerate delays and neither will I!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81232,'','One...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81233,'','Two...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81234,'','Three...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81235,'','Four... Where\'s a peon when you need one?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81236,'Look at the Draenei, so peaceful.  They have no idea their conquest awaits.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81237,'','Wit\'out your help, commander, we\'d be hard pressed ta put dat ogre down.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81238,'Hurry runts, we have a quota to make!','Hurry runts, we have a quota to make!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81239,'The Iron Horde needs more steel!','The Iron Horde needs more steel!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81240,'I\'ll eat the meat off your ribs!','I\'ll eat the meat off your ribs!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81241,'Give me your blood...','Give me your blood...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81242,'The Bleeding Hollow have you now!','The Bleeding Hollow have you now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81243,'CRUSH YOU, MAKE BLEED!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81244,'OUT OF THE WAY, INSECT!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81245,'YOUR BLOOD IS MINE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81246,'Fetch!','Fetch!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81247,'Get it boy!','Get it boy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81248,'Where\'s your ball?','Where\'s your ball?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81249,'','Da mojo be strong here mon. Now be da time to fight dis monsta.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81250,'You thought you could get away so easily?  Attack!','You thought you could get away so easily?  Attack!',0,0,0,0,0,0,0,0,0,0,44407,44407,26124),
(81251,'Stop them!  No one gets out of the city!','Stop them!  No one gets out of the city!',0,0,0,0,0,0,0,0,0,0,44408,44408,26124),
(81252,'This is the end of your race, draenei!','This is the end of your race, draenei!',0,0,0,0,0,0,0,0,0,0,44409,44409,26124),
(81253,'There is no escape!','There is no escape!',0,0,0,0,0,0,0,0,0,0,44410,44410,26124),
(81254,'Terrorfang will put an end to you.','Terrorfang will put an end to you.',0,0,0,0,0,0,0,0,0,0,44411,44411,26124),
(81255,'Bomb Exploded! (-$8911w)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81256,'$n triggered a Slag Bomb.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81257,'Stick around shorty! I gonna make ye watch as I feed yer friend to da Soulgrinder!','',0,0,0,0,0,0,0,0,0,23503,0,0,26124),
(81258,'You stay right there small woman! You not gonna use yer weird magic on me! You gonna stay there an watch as I feed yer friend to da Soulgrinder!','',0,0,0,0,0,0,0,0,0,23504,0,0,26124),
(81259,'Quickly! Get these flames under control.','Quickly! Get these flames under control.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81260,'More water over there!','More water over there!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81261,'If this building burns, so will you! Faster!','If this building burns, so will you!  Faster!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81262,'','You there! Find water! We must put these fires out.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81263,'Aaaah!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81264,'Run!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81265,'Fire!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81266,'Someone find water!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81267,'We must join the Iron Horde else we will be crushed by it.  We must prove our worth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81268,'Our ancestors once prohibited the use of the dark magic, they held us back.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81269,'Back from the power needed to save our clan!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81270,'So I say to you my brothers and sisters of the Shadowmoon clan; use the skills passed down from age to age!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81271,'Use them and summon forth the spirits of our ancestors.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81272,'Bind them to your will.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81273,'And twist them into the power we need.  Into the power we deserve!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81274,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81275,'Only then can the future of the Shadowmoon be certain!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81276,'','$p, I think you should follow Tuulani and protect her. We need to ensure the crystal reaches Auchindoun safely.',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(81277,'$p, you should follow Tuulani and protect her. We must ensure the crystal reaches Auchindoun safely.','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(81278,'Squeezing','Squeezing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81279,'Blessings to you, stranger. Because of you, I will see daylight once more.','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(81280,'','Thank you, stranger! I was supposed to be their next meal...',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(81281,'','Thank you, hero. I can fight my way out of here on my own.',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(81282,'We must deny Teron\'gor entrance to Auchindoun. Come, let us meet at Retribution Point and discuss how to bring the fight to the enemy.','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(81283,'','Lets go mon, da cave be ta de south an west of de lava fields.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81284,'','These bodies, they still be warm. Lets move on but keep ye wits about ye.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81285,'','I kill you!',0,0,0,0,0,0,0,14,0,0,0,0,26124),
(81286,'','Kill more mon, and we be bringing da spirits back to dis place!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81287,'','Tayhuwaniwanga!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81288,'','Hold up, mon. Keep quiet an\' come ova here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81289,'','Let\'s go, mon! We got ta hurry and clear out dat ogron so we can use de portal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81290,'','We on de hunt! Through de portal quickly now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81291,'','Watch ye back commander, we not be alone here. I sense ye presence spirit! Show yeself!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81292,'','Commanda, I sense nae evil intent in her and she be da first spirit ta speak wid us since I be here. \'Twould be wise ta have her help.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81293,'You have *cough* restored this dying orc\'s honor, champion. Farewell. And farewell, Snowpaw, my old friend...','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81294,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81295,'','Thank you, hero. Your deeds will be remembered.',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(81296,'Did you hear? The Iron Horde has sent emissaries to talk to Ner\'zhul.','Did you hear? The Iron Horde has sent emissaries to talk to Ner\'zhul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81297,'I overheard one of the Iron Horde grunts. I think they\'re planning an attack on Karabor soon.','I overheard one of the Iron Horde grunts. I think they\'re planning an attack on Karabor soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81298,'Ner\'zhul has taught us how to take the power we deserve.  The draenei will see soon enough.','Ner\'zhul has taught us how to take the power we deserve.  The draenei will see soon enough.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81299,'Rulkan left with the weaker members of our clan who would not embrace the Void.','Rulkan left with the weaker members of our clan who would not embrace the Void.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81300,'I\'ve heard whispers. Ner\'zhul intends to summon the Dark Star!','I\'ve heard whispers. Ner\'zhul intends to summon the Dark Star!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81301,'Thank you!','Thank you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81302,'I must seek a fire!','I must seek a fire!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81303,'I should never have come to this place!','I should never have come to this place!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81304,'Get out before they freeze you too!','Get out before they freeze you too!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81305,'So cold... but still aware...','So cold... but still aware...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81306,'The torment..','The torment..',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81307,'So cold it burns!','So cold it burns!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81308,'I have felt the absence of heat...','I have felt the absence of heat...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81309,'I\'ll free the rylak. You take care of this worm.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81310,'[ALL TEXT TEMP] This altar blocks our way! I\'ll look for a weak spot...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81311,'This isn\'t working. I guess I\'ll have to hulk out...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81312,'Alright, now it\'s time to smash things!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81313,'Alright, all smashed. Let\'s head back.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81314,'Enough rest, move out!','Enough rest, move out!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81315,'Our allies can only buy us so much time before the entirety of that... Iron Horde is upon our camp.$b$bWe have to keep moving.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81316,'Let\'s get going, then!','Let\'s get going, then!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81317,'|TINTERFACE\\ICONS\\ability_socererking_arcanewrath.blp:20|t You have been branded by |cFFF00000|Hspell:156238|h[Arcane Wrath]|h|r!','|TINTERFACE\\ICONS\\ability_socererking_arcanewrath.blp:20|t You have been branded by |cFFF00000|Hspell:156238|h[Arcane Wrath]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81318,'|TINTERFACE\\ICONS\\Spell_Arcane_MassDispel.blp:20|t You are afflicted with |cFFF00000|Hspell:158605|h[Mark of Chaos]|h|r!','|TINTERFACE\\ICONS\\Spell_Arcane_MassDispel.blp:20|t You are afflicted with |cFFF00000|Hspell:158605|h[Mark of Chaos]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81319,'|TINTERFACE\\ICONS\\spell_Mage_NetherTempest.blp:20|t |cFFF00000|Hspell:158648|h[Orbs of Chaos]|h|r explode from $n!','|TINTERFACE\\ICONS\\spell_Mage_NetherTempest.blp:20|t |cFFF00000|Hspell:158648|h[Orbs of Chaos]|h|r explode from $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81320,'Receive my gift, Vorpil. You will be the first of a new breed of conquerors!','',0,0,0,0,0,0,0,0,0,0,44416,0,26124),
(81321,'','What a curious specimen! Have you ever seen such a flower as this, traveler?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81322,'Ah, the thorn in my side has arrived.','',0,0,0,0,0,0,396,0,0,0,45337,0,26124),
(81323,'It\'s time I taught you a lesson.','',0,0,0,0,0,0,396,0,0,0,45338,0,26124),
(81324,'Come, Cerus. Dinner awaits.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(81325,'','Start Worldaction!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81326,'','End Worldaction!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81327,'','Terminate Worldaction!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81328,'Let the ritual begin.','',0,0,0,0,0,0,396,0,0,0,45339,0,26124),
(81329,'Feast your eyes on my limitless power, mortal.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(81330,'Spirit!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81331,'Hold her! We can\'t let her escape before the ritual completes!','Hold her! We can\'t let her escape before the ritual completes!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81332,'We are almost finished! A little more and her power will be ours to command!','We are almost finished! A little more and her power will be ours to command!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81333,'Hold steady!  We must consume our ancestor\'s power if we have any hope to join the Iron Horde.','Hold steady!  We must consume our ancestor\'s power if we have any hope to join the Iron Horde.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81334,'IGNORE ME!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81335,'Stables.','Stables.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81336,'Remove Stables.','Remove Stables.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81337,'Well, hero, I owe you both my life and my honor. I ask that you allow me to repay this debt by serving under your command.$b$bYou will find that I am a fearsome warrior. I have also mastered the art of riding the rylaks, which few among the Frostwolves can claim.$b$bWill you accept my service?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81338,'Accept the Mulverick\'s Offer of Service. (Garrison Follower)','Accept the  Mulverick\'s Offer of Service. (Garrison Follower)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81339,'Your deeds have shown you to be a fine commander. The sort of commander I would be honored to fight alongside.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81340,'Run! %s has |cFFFF0000|Hspell:159632|h[Insatiable Hunger]|h|r and wants to eat you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81341,'What are you doing here?','What are you doing here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81342,'Run away... they\'ll torture you too...','Run away... they\'ll torture you too...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81343,'Who... who are you...?','Who... who are you...?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81344,'Just let me die already!','Just let me die already!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81345,'Do it now, stranger! End my pain!','Do it now, stranger! End my pain!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81346,'Need... water...','Need... water...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81347,'What\'s happening? Who are you?','What\'s happening? Who are you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81348,'I want my mama...','I want my mama...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81349,'Here, take one of their blades. Don\'t use it until we give the signal.','Here, take one of their blades. Don\'t use it until we give the signal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81350,'I lend you my strength, master!','',0,0,0,0,0,0,396,0,0,0,44417,0,26124),
(81351,'Lord Mongrethod, hear my call. This mortal threatens the master\'s plans!','',0,0,0,0,0,0,0,0,0,0,45340,0,26124),
(81352,'','Eh boss-mon! Come in outta da cold. We be findin\' a right hot spot here in these rocks. Make ya feel right at home.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81353,'words and things','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81355,'A glorious battle awaits us, $p.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81356,'Saberon! I smell your stink upon the shadows...come out and play!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81357,'This had better work, Gul\'dan.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81358,'Why do you torment us?','Why do you torment us?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81359,'You have damned yourself and our clan.','You have damned yourself and our clan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81360,'You have defiled our sacred arts and for what?','You have defiled our sacred arts and for what?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81361,'Hey! What you doing? Dems MY food!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81362,'We do what we must to survive!','We do what we must to survive!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81363,'Do not judge me!  Our clan depends on the power your soul hides.','Do not judge me!  Our clan depends on the power your soul hides.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81364,'I will enjoy twisting what remains of you.','I will enjoy twisting what remains of you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81365,'I find no joy in this. Do not make this any harder than it already is.','I find no joy in this, do not make this any harder than it already is.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81366,'Come, Teron\'gor. Our contact has provided another entrance to Auchindoun. Your feast of souls awaits.','',0,0,0,0,0,0,396,0,0,0,45341,0,26124),
(81367,'My... dinner....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81368,'Yes, Gul\'dan. Your will be done.','Yes, Gul\'dan. Your will be done.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(81369,'Not dying on my watch!','Not dying on my watch!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81370,'Live!','Live!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81371,'Gaahh! How me supposed to learn how to control da ice if you breaks me out of it! Me gonna smash you for dat!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(81372,'I t\'ink I\'m getting colder...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81373,'I\'ve seen enough here.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81374,'Kargath, you coward!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81375,'You wouldn\'t last ten seconds against me, draenei.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81376,'You sound afraid, Kargath.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81377,'Two on one? Now, you speak my language!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81378,'That\'s not very sportsmanlike, Bladefist. Why don\'t we settle this in the arena?','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81379,'Hold everything! Now, they speak my language!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81380,'But I\'m afraid you\'re not much more than a warm-up, draenei. Doesn\'t anyone else feel like dying today?','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81381,'Thought you\'d never ask.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81382,'Return to Khadgar, champion! We will buy you the time you need!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81383,'I\'d like to cut off that head of yours, draenei.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81384,'Why don\'t you put your blade where your mouth is, Kargath?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81385,'... looks like somebody already put his blade where his hand was.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81386,'I\'ll do one better and put my blade where your throat is!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81387,'Do you always let a draenei fight your battles for you, green-skin?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81388,'I do when we share a common enemy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81389,'Ptuh! And I thought you were an orc...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81390,'You wield a Blackrock hammer, green-skin.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81391,'Yes, I do. Would you like to take a closer look?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81392,'I love fighting draenei. You people always look so scared before you die.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81393,'Sorry to disappoint you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81394,'Mangy beasts! You fight like kittens!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81395,'Come at me with tooth and claw!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81396,'The blood of the innocent stains your claws!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81397,'%s flees to report your position!','%s flees to report your position!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81398,'The rest have fled...but not from us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81399,'The air...it smells like...something is wrong.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81400,'','Asha! To me!',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(81401,'I\'ll help you!','I\'ll help you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81402,'I will fight by your side.','I will fight by your side.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81403,'','Can you imagine a live colossus? They say this was the last one, and the Thunderlord clan took it down generations ago.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81404,'I must help the others. Slay more of them for me!','I must help the others. Slay more of them for me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81405,'I am here to end your suffering, friend. Go in peace, your tormentors will not go unpunished.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81406,'Wipe out the Unmanned Shredders and meet us on the south side of the island.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81407,'Ha, we\'ll kill them yet!','Ha, we\'ll kill them yet!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81408,'Death to our enemies!','Death to our enemies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81409,'Well fought!','Well fought!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81410,'It\'s time for the Iron Horde to learn a little respect for the hunt. Haratha, see to it that our friend here is protected.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81411,'When I said I\'d help with the war effort I thought I\'d be a soldier helping win the war through skill with a weapon.$bInstead I\'m here drawing up plans and placing bricks.$b$bI guess I\'ll live longer this way at least.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81412,'As promised I will set you free. But I think these wolves would like to talk with you before you go.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81413,'Let\'s go, $n. Our hunt continues.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81414,'Whoa! Hold on! Now, just wait a second! We can talk this through!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81415,'You fight with honor, $p.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81416,'I will tell my brethren at the arena of your courage. Be safe.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81417,'Somebody help!!! I need back up!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81418,'I feel the flames dying down. What is happening, exarch?','',0,0,0,0,0,0,0,0,4,0,46708,0,26124),
(81419,'We have a visitor. Perhaps... a savior.','',0,0,0,0,0,0,0,0,4,0,44593,0,26124),
(81420,'We are freed! Follow me, shaman. We will escape through the hills.','',0,0,0,0,0,0,0,0,4,0,44594,0,26124),
(81421,'Steady...  steady. You are no longer in danger. I will not hurt you.','',0,0,0,0,0,0,0,0,0,25298,0,0,26124),
(81422,'I will fly her to safety. Meet me at the islands east of here. Nisha will fly you there if you wish.','',0,0,0,0,0,0,0,0,0,25298,0,0,26124),
(81423,'Whoa! There you go... good girl.','',0,0,0,0,0,0,0,0,0,25298,0,0,26124),
(81424,'Eye of Gul\'dan has spotted you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81425,'%s plants an Ironmarch War Banner!','%s plants an Ironmarch War Banner!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81426,'Teron\'gor does not desire further disturbances. Dispose of the intruder!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(81427,'I\'m ready to choose the outpost building now.','I\'m ready to choose the outpost building now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81428,'','This is where it happened...',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(81429,'','Look here - wolf tracks. They turn into orc tracks. One of our shamans found her.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81430,'Where is her body?','',0,0,0,0,0,0,547,0,1,0,0,0,26124),
(81431,'The Iron Horde has been feeding these wolves to the rylaks.$b$bThis little runt was trying to get away when I broke the gate open.$b$bLet\'s see if he is of any use to us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81432,'','Whoever it was, they must have recovered Asha\'s body.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81433,'','They will give her the proper last rites. Come, let us speak with Durotan.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81434,'IGNORE ME!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81435,'I ain\'t giving up easy! Garrosh personally promised me Stormwind!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81436,'Hey Franz? Franzok! We got a jam!','',0,0,0,0,0,0,0,0,0,0,47411,0,26124),
(81437,'I ain\'t un-jammin it! I un-jammed it last time!','',0,0,0,0,0,0,0,0,0,0,47412,0,26124),
(81438,'Ey you! Get in dere and un-jam that stamper!','',0,0,0,0,0,0,0,0,0,0,47414,0,26124),
(81439,'So? Go un-jam it den!','',0,0,0,0,0,0,0,0,0,0,47400,0,26124),
(81440,'You wanna tell Blackhand we got a stamper that ain\'t stampin\'?','',0,0,0,0,0,0,0,0,0,0,47401,0,26124),
(81441,'Ha ha ha! Guess dis batch will have some impurities.','',0,0,0,0,0,0,0,0,0,0,47402,0,26124),
(81442,'Work work work...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81443,'He is right. The Iron Horde will move against us. We must be ready.','',0,0,0,0,0,0,396,0,4,0,45247,0,26124),
(81444,'We\'ll be ready. They will NEVER take the pass.','',0,0,0,0,0,0,5,0,0,0,44098,0,26124),
(81445,'','Are you okay, husband?',0,0,0,0,0,0,0,0,0,0,0,41806,26124),
(81446,'No, I will never be okay with this.','',0,0,0,0,0,0,0,0,4,0,45248,0,26124),
(81447,'He made his choice.','',0,0,0,0,0,0,274,0,4,0,44099,0,26124),
(81448,'Come! To Thunder Pass. We are outnumbered 50 to 1. They don\'t stand a chance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81450,'<Ared\'s breath comes in short gasps as he lays in an uneasy sleep.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81451,'Examine Ared\'s condition more closely.','Examine Ared\'s condition more closely.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81452,'<Ared\'s breath comes in short gasps as he lays in an uneasy sleep. Beads of sweat cover his head and a noxious odor rises from his bloody wounds. It would seem that what time he has left will not last for long.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81453,'A nearby Void Wolf is alerted to you! Get away before it attacks!','A nearby Void Wolf is alerted to you! Get away before it attacks!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81454,'A nearby Void Occulus is alerted to you! Get away before it attacks!','A nearby Void Occulus is alerted to you! Get away before it attacks!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81455,'I have seen your forces marching boldly across the landscape with the confidence of the Warsong.$b$bYou have my attention.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81456,'Accept the Defection of Gronnstalker Rokash. (Garrison Follower)','Accept the  Defection of Gronnstalker Rokash. (Garrison Follower)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81457,'You take care of the lieutenants, champion. Bladefist is mine.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81458,'Cutting down unarmed prisoners? Why not fight a real battle?','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81459,'','[ph] Can I follow you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81460,'Accept the Blood Oath of Lokra. (Garrison Follower)','Accept the  Blood Oath of Lokra. (Garrison Follower)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81461,'You are about to be ejected from your Wor\'var Demolisher. Return to Nagrand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81462,'At your service, commander.','',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(81463,'Capping','Capping',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81464,'Fracking','Fracking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81465,'We\'re all counting on you, $n.','',0,0,0,0,0,0,1,0,0,0,44868,0,26124),
(81471,'$n crafts an Air Trinket!','$n crafts an Air Trinket!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81472,'$n is attempting to free an ally from all crowd-controlling effects!','$n is attempting to free an ally from all crowd-controlling effects!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81473,'A throng of angry orcs begin throwing |cFFFF0000|Hspell:159386|h[Iron Bombs]|h|r into the arena! $B$B x5 Iron Bombers |TInterface\\Icons\\achievement_character_orc_male_brn.blp:32|t','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81474,'Drunken Ogres begin hurling |cFFFF0000|Hspell:159410|h[Mauling Brew]|h|r from the stands! $B$B x2 Drunken Bileslingers|TInterface\\Icons\\achievement_reputation_ogre.blp:32|t x5 Iron Bombers |TInterface\\Icons\\achievement_character_orc_male_brn.blp:32|t','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81479,'Eager for bloodshed, the crowd rains destruction onto the arena floor! $B$B x1 Drunken Bileslinger|TInterface\\Icons\\achievement_reputation_ogre.blp:32|t x5 Iron Bombers |TInterface\\Icons\\achievement_character_orc_male_brn.blp:32|t','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81480,'Enthralled by the violence, the crowd attempts to up the body count! $B$B x3 Drunken Bileslingers |TInterface\\Icons\\achievement_reputation_ogre.blp:32|t x5 Iron Bombers |TInterface\\Icons\\achievement_character_orc_male_brn.blp:32|t','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81481,'Enraged by the lack of corpses, the crowd showers the arena with explosives! $B$B x5 Iron Bombers |TInterface\\Icons\\achievement_character_orc_male_brn.blp:32|t','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81482,'','Master Velen, I have never led soldiers before. Are you sure--',0,0,0,0,0,0,1,0,4,0,0,45613,26124),
(81483,'You are capable of more than you know, Yrel.','',0,0,0,0,0,0,1,0,4,0,45385,0,26124),
(81485,'Now go. The Rangari follow your orders. Find the prisoners.','',0,0,0,0,0,0,1,0,4,0,45386,0,26124),
(81486,'','It\'s hopeless. How are we going to get out of here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81487,'Think of your people. The captives still need our help!','Think of your people. The captives still need our help!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81488,'','Why? What is the use of saving them? Only death awaits us all in the end.',0,0,0,0,0,0,0,0,0,0,0,45622,26124),
(81489,'We can\'t give up now! Heroes learn from their mistakes.','We can\'t give up now! Heroes learn from their mistakes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81490,'','A hero? Hardly! I am just an initiate, and not a very good one at that.',0,0,0,0,0,0,0,0,0,0,0,45614,26124),
(81491,'We all start from humble beginnings. I once hunted troggs in the cold mountains of Dun Morogh.','We all start from humble beginnings. I once hunted troggs in the cold mountains of Dun Morogh.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81492,'','I see, $n. You have never backed down from a challenge. I must strive to do the same.',0,0,0,0,0,0,0,0,0,0,0,45615,26124),
(81493,'Pull yourself together, Yrel! You can do better than this!','Pull yourself together, Yrel! You can do better than this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81494,'','Oh! I needed to hear that, $n. I must not fall prey to my own fears.',0,0,0,0,0,0,0,0,0,0,0,45616,26124),
(81495,'You must choose, Yrel. Will you rise and fight, or fall here to doubt?','You must choose, Yrel. Will you rise and fight, or fall here to doubt?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81496,'','You are right, $n. My choices do matter. I choose... to fight!',0,0,0,0,0,0,0,0,0,0,0,45617,26124),
(81497,'Believe in the Light! Despite setbacks, it will always prevail.','Believe in the Light! Despite setbacks, it will always prevail.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81498,'','Is it true? Good doesn\'t always triumph over evil.',0,0,0,0,0,0,0,0,0,0,0,45618,26124),
(81499,'The Light is only as strong as its champions. Believe in YOURSELF.','The Light is only as strong as its champions. Believe in YOURSELF.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81500,'\'Doubt the Light\' just doesn\'t have the same ring to it.','\'Doubt the Light\' just doesn\'t have the same ring to it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81501,'Your people have triumphed over endless persecution. Will you let their hopes die here without a fight?','Your people have triumphed over endless persecution. Will you let their hopes die here without a fight?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81502,'','You are truly wise, $n. I must believe in myself, for I carry the Light within me.',0,0,0,0,0,0,0,0,0,0,0,45619,26124),
(81503,'','You choose the strangest times for humor, $c. Nevertheless, you have a point. I must have courage!',0,0,0,0,0,0,0,0,0,0,0,45620,26124),
(81504,'','You are right, $n. I will not bow quietly to these enemies. I must fight!',0,0,0,0,0,0,0,0,0,0,0,45621,26124),
(81505,'$n activates the Great Spire\'s Focusing Iris!','$n activates the Great Spire\'s Focusing Iris!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81506,'You are about to be ejected from your Telaari Tank. Return to Nagrand.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81508,'','You have a pretty good shop going on here. Much bigger then the shack I used to work at in Shattrath.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81509,'Just be ready when our ships arrive at Karabor.','',0,0,0,0,0,0,1,0,4,0,43663,0,26124),
(81510,'I\'d like an equipment upgrade...','I\'d like an equipment upgrade...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81511,'I found some strange metal for you to examine...','I found some strange metal for you to examine...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81512,'I have more frost iron ingots for you.','I have more frost iron ingots for you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81513,'Artillery Strike Inbound!','Artillery Strike Inbound!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81515,'','Keep flappin\' yer gums, if you want to be an orc kabob.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81516,'You two are workin\' slower than scrawny goblins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81517,'Might want to repair that stamper before Northrend thaws!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81518,'I can\'t wait to hear a job\'s done.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81519,'','You know how easy it is to hide a body under one of these things?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81520,'','That\'s enough outta you, gasbag.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81521,'Get those peons under control!  You heard Ner\'zhul, no one leaves this village!','Get those peons under control!  You heard Ner\'zhul, no one leaves this village!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81522,'|TInterface\\Icons\\spell_shaman_improvedfirenova.blp:20|tThe frequency of the Heart of the Mountain\'s |cFFFF0000|Hspell:155209|h[Blast]|h|r has been increased!','|TInterface\\Icons\\spell_shaman_improvedfirenova.blp:20|tThe frequency of the Heart of the Mountain\'s |cFFFF0000|Hspell:155209|h[Blast]|h|r has been increased!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81523,'Invaders have been spotted near the front gate!','Invaders have been spotted near the front gate!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81524,'Invaders have been spotted near the farm!','Invaders have been spotted near the farm!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81525,'Invaders have been spotted near the town hall!','Invaders have been spotted near the town hall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81526,'Garrison - Event - Orc Attack Stage 1.1a Begin','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81527,'Garrison - Event - Orc Attack Stage 1.1 Begin','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81528,'','Good! We must have arrived before Teron\'gor and Gul\'dan!',0,0,0,0,0,0,3,0,0,0,0,44644,26124),
(81529,'','Nyami is working to bolster the defenses against their assault - follow me, we will report to her.',0,0,0,0,0,0,1,0,0,0,0,44654,26124),
(81530,'','Beautiful, isn\'t it? Just think - you\'re one of the first outsiders to see inside Auchindoun.',0,0,0,0,0,0,6,0,0,0,0,44655,26124),
(81531,'','Strange... why is the door sealed? No matter...',0,0,0,0,0,0,6,0,0,0,0,44656,26124),
(81532,'','Let us proceed.',0,0,0,0,0,0,25,0,0,0,0,44657,26124),
(81533,'','The Vindicators and Exarchs of the past. Heroes all - their souls still remain with us here.',0,0,0,0,0,0,1,0,0,0,0,44658,26124),
(81534,'','Nyami! We are here -',0,0,0,0,0,0,22,0,6,0,0,44659,26124),
(81535,'','What is this? Oh, no... no...',0,0,0,0,0,0,6,0,6,0,0,44660,26124),
(81536,'','You have to stop them!',0,0,0,0,0,0,5,0,6,0,0,44661,26124),
(81537,'','...The protector... still answers her call... you\'ll have to defeat it!',0,0,0,0,0,0,0,0,6,0,0,44645,26124),
(81538,'','Ahhh!',0,0,0,0,0,0,0,0,6,0,0,44646,26124),
(81539,'','She... got away. The defenses...',0,0,0,0,0,0,1,0,0,0,0,44647,26124),
(81540,'','She had help. So many of our order were corrupt...',0,0,0,0,0,0,603,0,0,0,0,44648,26124),
(81541,'','I\'ll gather any who remain loyal here and protect them. You - please, go put a stop to this madness!',0,0,0,0,0,0,25,0,0,0,0,44649,26124),
(81542,'','You... you did it!',0,0,0,0,0,0,5,0,0,0,0,44650,26124),
(81543,'','Here - this is not enough to thank you for your actions, but it is what we have to give.',0,0,0,0,0,0,1,0,0,0,0,44651,26124),
(81544,'','Now we can rebuild... we must rebuild. We will never allow our souls to fall to the Legion.',0,0,0,0,0,0,1,0,0,0,0,44652,26124),
(81545,'','You have done more than you know. Our people can never thank you enough.',0,0,0,0,0,0,1,0,0,0,0,44653,26124),
(81546,'Seismic Shockwave! Use a steam vent to get off the ground!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81547,'','Now that the Heart of Auchindoun is back inside, our defenses should be impenetrable!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(81548,'Champion! It is good that you have joined us! I will hold these Thunderlord off in case any of your allies arrive.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(81549,'','$n loses their Damage Shield!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81550,'','$n regains their Damage Shield!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81551,'Invaders have been spotted near the back gate!','Invaders have been spotted near the back gate!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81552,'Invaders have been spotted near the mine!','Invaders have been spotted near the mine!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81553,'Invaders have been spotted near the western wall!','Invaders have been spotted near the western wall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81554,'Invaders have been spotted near the town square!','Invaders have been spotted near the town square!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81555,'','Are YOU, Tuulani, and your outsider friends.',0,0,0,0,0,0,0,0,6,0,0,43641,26124),
(81556,'','Try as you might, this place is doomed. It is only a matter of time...',0,0,0,0,0,0,0,0,6,0,0,43642,26124),
(81557,'','Yes! Yes! The crystal hums... just a bit of focus and...',0,0,0,0,0,0,0,0,6,0,0,43643,26124),
(81558,'Time to build stuff!','Time to build stuff!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81559,'Look out behind you!','Look out behind you!',0,0,0,0,0,0,5,0,4,0,0,0,26124),
(81560,'I think I got him.','I think I got him.',0,0,0,0,0,0,11,0,4,0,0,0,26124),
(81561,'You have my thanks.','You have my thanks.',0,0,0,0,0,0,2,0,4,0,0,0,26124),
(81562,'Praise the Light!','Praise the Light!',0,0,0,0,0,0,5,0,4,0,0,0,26124),
(81563,'A weapon!','A weapon!',0,0,0,0,0,0,5,0,4,0,0,0,26124),
(81564,'Now, let\'s see how THEY like being cut open!','Now, let\'s see how THEY like being cut open!',0,0,0,0,0,0,5,0,4,0,0,0,26124),
(81565,'At last, freedom!','At last, freedom!',0,0,0,0,0,0,5,0,4,0,0,0,26124),
(81566,'Farewell, my love.','Farewell, my love.',0,0,0,0,0,0,5,0,4,0,0,0,26124),
(81567,'Thank the Light!','Thank the Light!',0,0,0,0,0,0,5,0,4,0,0,0,26124),
(81568,'I thought I was going to die here.','I thought I was going to die here.',0,0,0,0,0,0,5,0,4,0,0,0,26124),
(81569,'You have no idea how long I\'ve been waiting to do this.','You have no idea how long I\'ve been waiting to do this.',0,0,0,0,0,0,5,0,4,0,0,0,26124),
(81570,'Die, pig!','Die, pig!',0,0,0,0,0,0,5,0,4,0,0,0,26124),
(81571,'I will avenge you, Tannosh.','I will avenge you, Tannosh.',0,0,0,0,0,0,5,0,4,0,0,0,26124),
(81572,'Go with the Light, sister.','Go with the Light, sister.',0,0,0,0,0,0,5,0,4,0,0,0,26124),
(81573,'May your spirit find rest with those of your people\'s ancestors.','May your spirit find rest with those of your people\'s ancestors.',0,0,0,0,0,0,5,0,4,0,0,0,26124),
(81574,'Kill them. Kill them all.','Kill them. Kill them all.',0,0,0,0,0,0,5,0,4,0,0,0,26124),
(81575,'Make them suffer, like I suffered.','Make them suffer, like I suffered.',0,0,0,0,0,0,5,0,4,0,0,0,26124),
(81576,'Thanks.','Thanks.',0,0,0,0,0,0,5,0,4,0,0,0,26124),
(81577,'I\'ve never held a weapon before.','I\'ve never held a weapon before.',0,0,0,0,0,0,5,0,4,0,0,0,26124),
(81578,'It feels good.','It feels good.',0,0,0,0,0,0,5,0,4,0,0,0,26124),
(81579,'Ooh!','Ooh!',0,0,0,0,0,0,5,0,4,0,0,0,26124),
(81580,'You give my people hope, stranger.','You give my people hope, stranger.',0,0,0,0,0,0,5,0,4,0,0,0,26124),
(81581,'','The poor dear, she injured herself trying to escape the flames.$b$b<Vilonia pats Miss Purr-Purr softly on the head.>$b$bLook at that sad face, I can\'t just leave her to face the fire alone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81582,'Oregorger has grown hungry and wants to eat more blackrock ore!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81583,'A bomb is placed! Find it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81584,'','Help! The little Prowlers have been frightened senseless by the fire and won\'t evacuate! Please, calm them down so they can escape!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81585,'Dagg tanks you, friend! <Dagg lets out a guttural chuckle.>','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81586,'','I cannot thank you enough for all of your help, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81587,'','Commander! Your timing is impeccable as always.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81588,'','Luuka, follow me. It is time we returned to the garrison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81589,'Oregorger is full of blackrock ore!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81590,'Ga\'nar said stay out of his way, so I am doing just that. I am not going to get myself killed in the name of the Iron Wolf or his kin.$b$bWe should talk... if you survive this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81591,'Will you join me in the fight against the Iron Horde?','Will you join me in the fight against the Iron Horde?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81592,'Don\'t mind me. I\'m staying out of this fight.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81593,'Dunno how dem orcs keep catchin\' me. <Dagg snickers disarmingly.>','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81594,'Hi again.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81595,'Gonna have to ask demself, \"Did Dagg get catched or did Dagg catched dem?\"\n\nBig hero been blowin\' Dagg\'s cover! But you special, Dagg t\'inks. Dagg is master of dis guys and want to join you.\n\nDagg is unanimous in dis.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81596,'Unanimously agree with Dagg? (Garrison Follower)','Unanimously agree with Dagg? (Garrison Follower)',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81597,'A great leader sets an example for all those who follow.$b$bThey know when to speak, and when to listen.$b$bThey know when to stand and fight for their survival, and when to sacrifice it all for the greater good.$b$bAre you ready to lead, $n?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81598,'Thank you, stranger. Now I may finally enter Auchindoun.','Thank you, stranger. Now I may finally enter Auchindoun.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(81599,'I am free!','I am free!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(81600,'A thousand blessings, $c.','A thousand blessings, $c.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(81601,'Thank the Light you showed up.','Thank the Light you showed up.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(81602,'Can you feel it, $n? A great army will stand at this very spot, and they will look to you for guidance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81603,'Plant your banner, and claim your destiny.','',0,0,0,0,0,0,0,0,0,0,44819,0,26124),
(81607,'Don\' blow Dagg\'s cover!$B$BDey never question a tree.$B$BDagg is unanimous in dis.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81608,'Don\' let dem see us talkin\'!\n\nDey never question a two-head.\n\nDagg is unanimous in dis.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81609,'Shh! Act natural.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81610,'Shh! Don\' blow my cover.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81611,'Burn the bridge! Nothing must interfere!','Burn the bridge! Nothing must interfere!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(81612,'Turn away to avoid Hypnocroak\'s |cFFFF0000|Hspell:160664|h[Hypnotic Gaze]|h|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81613,'So, this is where we will build your garrison.$b$bHave you commanded this many troops before?$b$bI\'m sure you\'ll do fine... I hope.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81614,'Debug - Garrison - Toggle Stage 1 Version','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81616,'','I be feelin\' better \'bout our chances wid you here, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81617,'$n','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81618,'$n','$n',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81619,'Garrisons - Attack Stage 1.2 Begin','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81620,'Garrisons - Attack Stage 1.3 Begin','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81621,'The Temple of Karabor? No... it cannot be. We are under attack!','',0,0,0,0,0,0,1,0,0,0,45356,0,26124),
(81622,'Wait... no... it cannot be. The temple is under attack!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(81623,'','Hold the barricades! Protect the defense crystal at all costs!',0,0,0,0,0,0,5,0,0,0,0,45673,26124),
(81625,'ENOUGH! Play time is over. Ships, on my mark, FIRE ON THE CRYSTAL!','',0,0,0,0,0,0,5,0,0,0,43664,0,26124),
(81626,'','No! That defense crystal was our only hope.',0,0,0,0,0,0,0,0,0,0,0,45677,26124),
(81627,'Stay close to me, champion!','',0,0,0,0,0,0,1,0,0,0,45357,0,26124),
(81628,'','There must be something we can use in these old bones.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81629,'','Work faster fools, the Dark Star draws ever closer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81630,'$n is hosting a Feast of Blood. Enjoy!','$n is hosting a Feast of Blood. Enjoy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81631,'Yrel, what is happening?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(81632,'','We couldn\'t stop the Dark Star, Prophet. The Iron Horde have taken the harbor!',0,0,0,0,0,0,5,0,0,0,0,45674,26124),
(81633,'','Watch your heads! Iron capsules incoming!',0,0,0,0,0,0,5,0,0,0,0,45675,26124),
(81634,'|TInterface\\Icons\\Spell_Fire_Fireball02:20|t $n has picked up |cFFFF0000|Hspell:160702|h[Blackrock Mortar Shells]|h|r!','|TInterface\\Icons\\Spell_Fire_Fireball02:20|t $n has picked up |cFFFF0000|Hspell:160702|h[Blackrock Mortar Shells]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81635,'|TInterface\\Icons\\inv_misc_pyriumgrenade:20|t $n has picked up |cFFFF0000|Hspell:160703|h[Blackrock Grenades]|h|r!','|TInterface\\Icons\\inv_misc_pyriumgrenade:20|t $n has picked up |cFFFF0000|Hspell:160703|h[Blackrock Grenades]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81636,'|TInterface\\Icons\\spell_shaman_improvedfirenova:20|t $n has picked up |cFFFF0000|Hspell:156357|h[Blackrock Shrapnel]|h|r!','|TInterface\\Icons\\spell_shaman_improvedfirenova:20|t $n has picked up |cFFFF0000|Hspell:156357|h[Blackrock Shrapnel]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81638,'I need you to come on patrol with me.','I need you to come on patrol with me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81639,'Yes, sir!','Yes, sir!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81640,'Welcome to the Ring of Trials! I\'m here setting up fights for the arena. If you\'re looking to make some extra cash, you\'ve come to the right place!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81641,'What can I do for you, Commander?','What can I do for you, Commander?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81642,'I\'ve got you, Commander!','I\'ve got you, Commander!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81643,'Hang in there, sir!','Hang in there, sir!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81644,'You\'re not going down that easy!','You\'re not going down that easy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81645,'The light will protect you!','The light will protect you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81646,'Marking','Marking',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81647,'You want fight in the arena? Talk wit\' Dexyl, he puts the fights together.$b$bMe? I just here to start the match... and clean up the bodies after! BAWHAHA!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81648,'Over here, you ugly brutes!','Over here, you ugly brutes!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81649,'Grrraahh!','Grrraahh!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81650,'I\'ve got these ones!','I\'ve got these ones!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81651,'Why don\'t you pick on me for a bit?','Why don\'t you pick on me for a bit?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81652,'Stop the saboteurs!','Stop the saboteurs!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81653,'We\'re ready for construction! I learned a few new techniques when building Orgrimmar.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81654,'Begin Construction [Build Garrison]','Begin Construction [Build Garrison]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81655,'Iron Fleet! Darken the skies!','',0,0,0,0,0,0,0,0,0,0,43656,0,26124),
(81656,'I am ready to begin the first Trial of The Ring.','I am ready to begin the first Trial of The Ring.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81657,'Marak the Blooded begins to channel a |cFFFF0000|Hspell:158079|h[Blood Ritual]|h|r on you!','Marak the Blooded begins to channel a |cFFFF0000|Hspell:158079|h[Blood Ritual]|h|r on you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81658,'So much to do and so little time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81659,'I am ready to begin the second Trial of The Ring.','I am ready to begin the second Trial of The Ring.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81660,'I am ready to begin the third Trial of The Ring.','I am ready to begin the third Trial of The Ring.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81661,'I am ready to begin the fourth Trial of The Ring.','I am ready to begin the fourth Trial of The Ring.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81662,'I am ready to begin the fifth Trial of The Ring.','I am ready to begin the fifth Trial of The Ring.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81663,'They\'re bombarding with artillery!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81664,'Thank you for your assistance, be healed and back to battle!','Thank you for your assistance, be healed and back to battle!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81665,'Forward! We must stop Vorka!','Forward! We must stop Vorka!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81666,'My thanks to you. Be healed and carry on!','My thanks to you. Be healed and carry on!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81667,'We did not expect to find any friendly faces out here in this wasteland. We have survived only by sticking together and relying on one another to get this far.$b$bOur escape attempt was only half executed though. Kor\'gall got wind of our plan before we could assassinate him and take his axe.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81668,'I have never met a beast I could not hunt!','I have never met a beast I could not hunt!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81669,'','No! Awk! You\'re just another illusion! Another lie! Ra-awk! I\'ll expose the darkness within you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81670,'Admiral Gar\'an prepares to man the Dreadnaught\'s Main Cannon!','Admiral Gar\'an prepares to man the Dreadnaught\'s Main Cannon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81671,'Enforcer Sorka prepares to man the Dreadnaught\'s Main Cannon!','Enforcer Sorka prepares to man the Dreadnaught\'s Main Cannon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81672,'Marak the Blooded prepares to man the Dreadnaught\'s Main Cannon!','Marak the Blooded prepares to man the Dreadnaught\'s Main Cannon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81674,'I am afraid I must depart and rejoin our pack at Wor\'gol. Aka\'Magosh.','',0,0,0,0,0,0,396,0,4,0,0,0,26124),
(81675,'Out of the way, peon!','Out of the way, peon!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81676,'What you looking at?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81677,'Kash\'drakor says it is time to escape.','Kash\'drakor says it is time to escape.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81678,'','Who\'s there!? Oh - I\'m glad I\'m not the only one fighting these monsters.',0,0,0,0,0,0,0,0,0,0,0,45551,26124),
(81679,'The darkness comes for you...','The darkness comes for you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81680,'More souls for the taking!','More souls for the taking!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81681,'My life for Ner\'zhul!','My life for Ner\'zhul!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81682,'Did my father send you? I told them he would find a way to spring me! Thanks, stranger.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81683,'You think you\'re clever?! You\'re next to burn!','',0,0,0,0,0,0,0,0,0,0,44518,0,26124),
(81684,'Fool! You\'ll need more than flames to finish me!','',0,0,0,0,0,0,0,0,0,0,44519,0,26124),
(81685,'Coward! You can\'t hide behind these traps forever!','',0,0,0,0,0,0,0,0,0,0,44520,0,26124),
(81686,'My death changes nothing! Full... ATTACK!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81687,'','Up there! The fleet commander shows himself!',0,0,0,0,0,0,397,0,0,0,0,45676,26124),
(81688,'Brave champion, I need your aid in my defense, we will break this siege if you can give me time!','Brave champion, I need your aid in my defense, we will break this siege if you can give me time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81689,'','They\'re breaking through. Retreat! We\'ll make our final stand on the stairs!',0,0,0,0,0,0,5,0,0,0,0,45678,26124),
(81690,'Commander. I\'m at your disposal.$B$BDo you have any further orders?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(81691,'Oh good, it\'s you, $n.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(81692,'','How DARE you interrupt my work! I\'ll send your soul screaming into the beyond!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81693,'$n is hosting a Feast of the Waters. Enjoy!','$n is hosting a Feast of the Waters. Enjoy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81694,'What? How did you find my sleeping post?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81695,'','Now can I come in?',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(81696,'The vision guides us, $n. Let us see what it wishes us to learn.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81697,'Prophet, we\'re being overrun!','Prophet, we\'re being overrun!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81698,'I hear it tastes just like chicken, not that you\'d catch me eating raw meat.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81699,'She may backfire a bit, but don\'t worry. She\'ll get you there.','',0,0,0,0,0,0,0,7,0,0,45737,0,26124),
(81700,'As long as I live, Karabor shall not fall!','',0,0,0,0,0,0,5,0,0,0,45358,0,26124),
(81701,'Prophet, your attempts are meaningless. Witness the TRUE might of the Iron Horde!','',0,0,0,0,0,0,5,0,0,0,43665,0,26124),
(81702,'The Iron Horde is like nothing you\'ve ever seen!  Every meal a banquet, every plunder a fortune!  We are unstoppable and the glory will be unending!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81703,'More intruders!','More intruders!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81704,'Grommash leads us to countless victories across TWO worlds.  With a Warsong at our head, how can we lose?  The Warsong and Iron Horde together are unbeatable!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81705,'It is true that both foe and glory abound on the plains of Nagrand. That was not enough for your warchief though, and he has made a place for you at his side across ALL of Draenor.  The Iron Horde will see true glory across two worlds!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81706,'','$n, strike with the power of holy light!',0,0,0,0,0,0,0,0,0,0,0,45656,26124),
(81707,'','We are the shield against the darkness!',0,0,0,0,0,0,0,0,0,0,0,45657,26124),
(81708,'','There is no power stronger than hope!',0,0,0,0,0,0,0,0,0,0,0,45658,26124),
(81709,'Welcome to Shadowmoon Valley. I\'ve been expecting you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81710,'','We are the light against the darkness! Shield of the meek! Hope for the helpless!',0,0,0,0,0,0,0,0,0,0,0,45659,26124),
(81711,'','Do not let doubt trouble you! Where there is light there is hope. Strike now!',0,0,0,0,0,0,0,0,0,0,0,45660,26124),
(81712,'Yrel, my most promising student returns home. Please lead our friends here to the Shadowmoon Ruins.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81713,'I\'ll explain on the way there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81714,'','Yes, teacher. $n, jump on that Elekk and we will be on our way.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81715,'','Follow me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81716,'You\'re coming with me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81717,'The trials that lay before you will not be easy, $n. Some of your most trusted companions will surely be lost. When the darkness closes in, follow the light.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81718,'Time to die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81719,'We need to establish a foothold here in Shadowmoon Valley as soon as possible. There is a clearing not far from here that will be a perfect place to start.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81720,'Glory and death!','',0,0,0,0,0,0,0,0,0,0,45788,0,26124),
(81721,'Ask not what the Iron Horde can do for you, but what you can do for the Iron Horde.  With your help, the Iron Horde can reach across the continent and rule everything the way it should be ruled!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81722,'Perhaps you fear the smoke and recoil from the fires.  I tell you these are not things to fear!  Our armor is impenetrable!  Our weapons unstoppable!  The fires of our industry make you the greatest warriors that have ever existed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81723,'There is much glory riding for the Iron Horde!  The enemies of the Iron Horde are often strong and dangerous.  This is not something to fear though!  Strong enemies make us stronger, and while we can be hurt, we have never fallen.  We never will!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81724,'Hurry up! I can\'t hold this thing open forever!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81725,'','Killing the beast will surely gain the respect of Karabor peacekeepers.',0,0,0,0,0,0,0,0,0,0,0,45610,26124),
(81726,'If you mark those trees, Shelly\'s lumberjacks will do the rest.','',0,0,0,0,0,0,0,0,0,0,43525,0,26124),
(81727,'Giant killer ravens... I have a feeling it\'s going to be a long, cold night.','',0,0,0,0,0,0,0,0,0,0,43527,0,26124),
(81728,'<whispers> No noise!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81729,'Commander. What would you say to showing the Warsong some Rangari justice?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(81730,'Light forgive me. I failed them all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81731,'We have everything we need. It\'s time to build the garrison.','We have everything we need. It\'s time to build the garrison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81732,'Throm-ka, commander.','Throm-ka, commander.',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(81733,'Commander $n approaches! Salute!','Commander $n approaches! Salute!',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(81734,'Lok\'tar, commander!','Lok\'tar, commander!',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(81735,'My blade is yours, Commander $n.','My blade is yours, Commander $n.',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(81736,'','Please, let us go. We haven\'t hurt anyone.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(81737,'','At least let Isel go. She\'s just a child.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(81738,'','We never harmed any of you. We all used to get along so well.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(81739,'','I just want to take my daughter and leave. We aren\'t any threat to you.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(81740,'','Maybe if I were to talk with your leader? Explain things? You\'d see it\'s okay for us to leave.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(81741,'','If you harm my baby, I will kill you!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(81742,'','You\'re monsters to threaten a defenseless woman and her child!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(81743,'','Please, I\'m begging you. Let us go!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(81744,'Orders, commander?','Orders, commander?',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(81745,'Welcome Commander $n. It is an honor to serve under you.','Welcome Commander $n. It is an honor to serve under you.',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(81746,'Our commander approaches! Men, at the ready!','Our commander approaches! Men, at the ready!',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(81747,'At your service, commander.','At your service, commander.',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(81748,'','The Shattered Hand\'s crimes against humanity are unforgivable, but we can\'t ignore their crimes against nature.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81749,'|TInterface\\Icons\\ability_paladin_beaconoflight.blp:20|tK\'ara has blessed you with |cFFFF0000|Hspell:160972|h[K\'ara\'s Essence]|h|r!','|TInterface\\Icons\\ability_paladin_beaconoflight.blp:20|tK\'ara has blessed you with |cFFFF0000|Hspell:160972|h[K\'ara\'s Essence]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81750,'Khadgar wants us to scout the cave.','Khadgar wants us to scout the cave.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81751,'If we make it out of this jungle, I will personally see to it that you and your people are taken care of.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81752,'Khadgar wants us to scout the cave.','Khadgar wants us to scout the cave.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81753,'|TInterface\\Icons\\spell_holy_aspiration.blp:20|tK\'ara has blessed you with|cFFFF0000|Hspell:149699|h[K\'ara\'s Benevolence]|h|r!','|TInterface\\Icons\\spell_holy_aspiration.blp:20|tK\'ara has blessed you with|cFFFF0000|Hspell:149699|h[K\'ara\'s Benevolence]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81754,'|TInterface\\Icons\\spell_arcane_arcaneresilience.blp:20|tK\'ara has blessed you with |cFFFF0000|Hspell:157035|h[K\'ara\'s Resilience]|h|r!','|TInterface\\Icons\\spell_arcane_arcaneresilience.blp:20|tK\'ara has blessed you with |cFFFF0000|Hspell:157035|h[K\'ara\'s Resilience]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81755,'','Oh, thank the Light for you, stranger!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(81756,'','The Warsong attacked us without provocation.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(81757,'','Come, Isel. We must be very quiet.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(81758,'You have done it $n! Now to put an end to this assault!','You have done it $n! Now to put an end to this assault!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81759,'','Yes, mama. Thank you, $g sir:ma\'am;!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(81760,'If I am to be forgotten here, so will you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81761,'No! You will be forgotten as I have!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81762,'I... will... return...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81763,'Will you help me, $c? Scores of my brethren died because I failed to defend them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81764,'Here lies the body of Arbiter Khan.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81765,'','You have the eggs, yes? They need to get to the hatchery straight away so I\'ll take them there now. May the light embrace you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81766,'Horrible creatures of appeared out of nowhere and are killing the drakes! $b$bThey are all going to be killed if we don\'t do anything!$b$bIf you could get rid of the creatures attacking them and help me gather some of their lost eggs it would be a huge help.$b$bPlease, $c, I\'m the only eggtender left, I need your help if they are to survive!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81767,'Don\'t get in my way.','',0,0,0,0,0,0,0,0,0,0,45782,0,26124),
(81768,'I\'m unstoppable!','',0,0,0,0,0,0,0,0,0,0,45783,0,26124),
(81769,'Got one!','',0,0,0,0,0,0,0,0,0,0,43740,0,26124),
(81770,'This too much fun!','',0,0,0,0,0,0,0,0,0,0,45780,0,26124),
(81771,'You! You hurt the boss man!','',0,0,0,0,0,0,0,0,0,0,45777,0,26124),
(81772,'Time to go to plan B!','',0,0,0,0,0,0,0,0,0,0,43736,0,26124),
(81773,'','My life... for the master.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81774,'','Fool! I am in communion with forces beyond your reckoning!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81775,'AHH!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81776,'Watch out!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81777,'HELP!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81778,'Stay away from me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81779,'The Warsong are trying to activate Telaar\'s shielding crystal down there. If they succeed, we won\'t be able to support you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81780,'The Warsong are trying to activate Telaar\'s defense shield. If they succeed, the rangari on the overlook will not be able to support you.','',0,0,0,0,0,0,0,7,0,0,46253,0,26124),
(81781,'Snow? Our shamans said there would be mild weather today... I don\'t trust these clouds.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81782,'Invaders have been spotted near the western wall!','Invaders have been spotted near the western wall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81783,'Invaders have been spotted near east wall!','Invaders have been spotted near east wall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81784,'','We must hurry - these Shadowmoon orcs are under the command of \"Ner\'zhul.\"',0,0,0,0,0,0,396,0,0,0,0,45552,26124),
(81785,'','With his commanders dead, Ner\'zhul will surely come looking for us.',0,0,0,0,0,0,396,0,0,0,0,45553,26124),
(81786,'','I\'ll take the right flank, Maraad will take the left, you defend K\'ara!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81787,'This acolyte and I will retrieve the rest of our group. Do everything in your power to stop that orc from opening that portal!','',0,0,0,0,0,0,0,0,4,0,44597,0,26124),
(81788,'','We will return with help.',0,0,0,0,0,0,0,0,4,0,0,45556,26124),
(81789,'I\'ll murder all o\' ya!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81790,'Which one a ya is first?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81791,'Come ta die? You\'ve come ta the right place, boyos.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81792,'Don\'t be shy. There\'s plenty o\' me ta go \'round.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81793,'Don\'t worry. I\'m comin\' fer all o\' ya.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81794,'Where ya got the survivors stashed, ya animals?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81795,'If ye\'ve harmed the wee one or her mum, I\'m gonna kill ya twice... painfully!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81796,'Vindicator... Arbiter, can ya hear me? I\'m comin\'.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81797,'Invaders have been spotted near the western gate!','Invaders have been spotted near the western gate!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81798,'Are you going to be okay?','Are you going to be okay?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81799,'Thank you, again, for the aid. Luckily, I was able to get the eggs into the spare incubators.$bI wish I had more strength in my arms for swinging a weapon or I\'d be out there dealing righteous justice but... taking care of the eggs is about all I can do. Please find the cause of this mess and get rid of it, the fey dragons and I are counting on you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81800,'I should be fine... I just twisted a hoof.','I should be fine... I just twisted a hoof.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81801,'I am not jumping! Just go get a ladder!','I am not jumping! Just go get a ladder!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81802,'No way! It\'s too far! Seriously... get a ladder!','No way! It\'s too far! Seriously... get a ladder!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81803,'You will be fine. Just jump!','You will be fine. Just jump!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81804,'It\'s not that far. Come on, just jump already!','It\'s not that far. Come on, just jump already!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81805,'For years I\'ve worked to tame these gentle creatures.$bThey are fantastically intelligent, you know. We have so much we could learn from them, if only we had more youngsters willing to learn the delicate art of communing with them.$b$b<Alorn sighs>$b$bWere the world more peaceful I could have taught others my trade, but I\'m afraid we have more pressing concerns to deal with.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81806,'I softened \'em up fer ya.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(81807,'Ack... I\'m a bit woozy. Ya got this? I need ta get back ta the station.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(81808,'No... NO! This cannot be the fate of my people!','',0,0,0,0,0,0,274,0,4,0,45360,0,26124),
(81809,'Ner\'zhul leads us to this destiny. To save Karabor, we must stop him.','',0,0,0,0,0,0,1,0,4,0,45361,0,26124),
(81810,'Meet me back at Twilight Glade, champion. We have much to do.','',0,0,0,0,0,0,1,0,4,0,45362,0,26124),
(81812,'<An inscription on the hilt reads:>\n\n\"Here Vindicator Torvath fell in battle to end the rage of the ancients.\n\n May the light shine upon this grove that he so valiantly fought to protect and may it forever bring peace upon its denizens.\"','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81817,'<The waters begin to stir.>','<The waters begin to stir.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81818,'Percy, would you hold still?! How do you expect me to read it with you fluttering about like that?','',0,0,0,0,0,0,0,0,0,0,46019,0,26124),
(81819,'We\'ll slip away while you keep the herald busy. Meet us near the bridge just outside of town!','',0,0,0,0,0,0,0,0,0,0,46022,0,26124),
(81820,'Come along, Percy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81821,'Good people of Fort Wrynn, our commander has finalized construction on a new building!','',0,0,0,0,0,0,0,0,4,0,43534,0,26124),
(81822,'We\'re going to need to work together to get it up to full production. See to it our commander is not kept waiting!','',0,0,0,0,0,0,0,0,4,0,43535,0,26124),
(81823,'I cannot... hold them... back...','',0,0,0,0,0,0,0,0,0,0,45359,0,26124),
(81824,'Yo everybody, listen up. Thanks to our commander we got a new building up!','',0,0,0,0,0,0,0,0,4,0,44485,0,26124),
(81825,'We gotta get this new structure up to snuff pronto, alright? Get to it yesterday!','',0,0,0,0,0,0,0,0,4,0,44486,0,26124),
(81826,'You can handle things from here, I\'m sure. Well done!','',0,0,0,0,0,0,0,0,4,0,43536,0,26124),
(81827,'You won\'t be needin\' me, you\'re in charge after all.','',0,0,0,0,0,0,0,0,4,0,44487,0,26124),
(81828,'Honored to be fighting by your side, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81829,'Khadgar wants us to scout the cave.','Khadgar wants us to scout the cave.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81830,'','Their depravity sickens me.$b$bWe should wipe this Iron Horde off the map.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81831,'Khadgar wants us to scout the cave.','Khadgar wants us to scout the cave.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81832,'','I\'ll take this draenei back to Khadgar. Stop that orc from opening that portal!',0,0,0,0,0,0,0,0,4,0,0,45714,26124),
(81833,'','We will return with help.',0,0,0,0,0,0,0,0,4,0,0,45556,26124),
(81834,'The Grove of Ancients begins to awaken!','',0,0,0,0,0,0,0,0,1,0,32714,0,26124),
(81835,'A second ancient is called to battle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81836,'A third ancient moves to attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81837,'Drink the elixir and focus on the crystal, $n. Let the ebb and flow of time wash over you...','',0,0,0,0,0,0,1,0,0,0,45355,0,26124),
(81838,'','I have what you want, commander. You\'ll have to come to me. Warsong, find $g him:her;!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81839,'','Ahahaha. Come get your precious blueprints. If you can!',0,0,0,0,0,0,0,0,0,924,0,0,26124),
(81840,'Go, $n. Finish it. Exact justice for the fallen of Telaar.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81841,'Well done, commander!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81842,'We will get as much ore out of here as we can. We might need to reinforce some of these walls.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81843,'This place is looking pretty run down.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81844,'','I want this shield surrounding all of Telaar, now.',0,0,0,0,0,0,0,0,0,924,0,0,26124),
(81845,'','Find the intruder and those damned rangari.',0,0,0,0,0,0,0,0,0,924,0,0,26124),
(81846,'','All glory to the Warsong. All glory to the new warlord, Garrosh Hellscream!',0,0,0,0,0,0,0,0,0,924,0,0,26124),
(81847,'','No more prisoners. Kill outsiders on sight!',0,0,0,0,0,0,0,0,0,924,0,0,26124),
(81848,'','Warsingers, more power. Once the draenei shield surrounds all of Telaar, no one can get in.',0,0,0,0,0,0,0,0,0,924,0,0,26124),
(81849,'','We\'ve rid our homeland of the draenei. This is a glorious day for the Warsong.',0,0,0,0,0,0,0,0,0,924,0,0,26124),
(81850,'','Faster! I intend to ride upon Telaari Station soon.',0,0,0,0,0,0,0,0,0,924,0,0,26124),
(81851,'','Soon, we will crush the draenei survivors. For the Warsong!',0,0,0,0,0,0,0,0,0,924,0,0,26124),
(81852,'Go through the portal, Gazlowe said. You\'ll be rich, he said.$B$BWhat a load of bologna.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(81853,'$n crafts a Defense Prism!','$n crafts a Defense Prism!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81854,'$n crafts a Sun Trinket!','$n crafts a Sun Trinket!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81855,'|TInterface\\Icons\\inv_feather_14.blp:20|tRukhran unleashes a shower of |cFFFF0000|Hspell:159382|h[Quills]|h|r - take cover!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81856,'|TInterface\\Icons\\inv-mount_raven_54.blp:20|tRukhran has no one to melee and begins to |cFFFF0000|Hspell:153896|h[Screech]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81857,'For the Warsong!','For the Warsong!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81858,'Blood and thunder!','Blood and thunder!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81859,'Die outsider!','Die outsider!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81860,'For Garrosh!','For Garrosh!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81861,'Now you die.','Now you die.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81862,'Nagrand is for the Warsong.','Nagrand is for the Warsong.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81863,'Lok\'tar ogar!','Lok\'tar ogar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81864,'Lok-Narash!','Lok-Narash!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81865,'Eh Boss-mon! We be needin\' ya for sometin\' important over here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81866,'Power fluctuator active. Rebooting core systems. Please wait.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81867,'Alright, Pleasure-Bot 8000. Get back to work!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81868,'Command unrecognized. Will only accept commands from Pleasure-Bot 8000 owner: $p.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81869,'The Gift of the Naaru imbues you! Push through the courtyard, we will meet you at the harbor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81870,'Damn it all, I give up. $p, you can have him! I\'m done!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81871,'I know how dangerous this place is, but I ain\'t leaving until I get back what\'s mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81872,'Leave me be.','Leave me be.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(81873,'You look like an able fisherman, do you think you can help us out?\n\nWe have established a small garrison nearby, but we are finding it difficult to feed our troops. Any fishing advice you could give us would really help.','You look like an able fisherman, do you think you can help us out?\n\nWe have established a small garrison nearby, but we are finding it difficult to feed our troops. Any fishing advice you could give us would really help.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(81874,'Who knows what we might invent with the materials on this world?','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(81875,'Alright, Pleasure-Bot 8000. Execute command X47G5!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81876,'That\'s it, I\'ve had it! $p, you can have him! I\'m going back to tank-building from here on out!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81877,'%s goes into a wild |cFFFF0404|Hspell:155222|h[Tantrum]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81878,'%s creates an |cFFFF0404|Hspell:159044|h[Epicenter]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81879,'%s goes into a wild |cFFFF0404|Hspell:162275|h[Tantrum]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81880,'%s creates an |cFFFF0404|Hspell:162277|h[Epicenter]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81881,'How can I be of service, commander?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81882,'Khadgar\'s magic is strong indeed. He managed to open a permanent portal directly to Stormwind.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81883,'Everything is going according to plan, commander. How may I help you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81884,'','With the giant defeated we shouldn\'t have any more trouble clearing out the area.',0,0,0,0,0,0,0,0,0,0,0,45611,26124),
(81885,'An excellent choice of lumber, if I do say so myself.','',0,0,0,0,0,0,0,0,0,0,43526,0,26124),
(81886,'Impressive work, commander. I know I\'ll sleep a lot better without those giant killer birds flying around.','',0,0,0,0,0,0,0,0,0,0,43528,0,26124),
(81887,'Let me know when you are ready to start construction, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81888,'Thanks to you we have a terrific foothold here in Shadowmoon Valley.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81889,'Baros is just down the stairs. I\'m sure he will be more than happy to help you construct a barracks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81890,'With the barracks complete we can finally shelter all of these troops from this eternal night.','',0,0,0,0,0,0,0,0,0,0,44815,0,26124),
(81891,'Qiana just headed out to Moonflower Valley. She is quite eager to explore this new land.','',0,0,0,0,0,0,0,0,0,0,44816,0,26124),
(81892,'I helped! Did you see?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81893,'That just happened!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81894,'Let\'s split the loot! How does 60/40 sound?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81895,'Are you rich and famous? If so, I want to be just like you when I grow up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81896,'Check and see if there\'s any loot!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81897,'That...was...AWESOME!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81898,'Can you teach me to fight like that?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81899,'I\'ll take the next one! Just watch!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81900,'Please, repurpose me!','',0,0,0,0,0,0,0,0,0,0,46184,0,26124),
(81901,'I think that arm is still usable, and maybe the leg.','',0,0,0,0,0,0,0,0,0,0,46186,0,26124),
(81902,'You can\'t handle this!','',0,0,0,0,0,0,0,0,0,0,43924,0,26124),
(81903,'I will destroy you.','',0,0,0,0,0,0,0,0,0,0,43926,0,26124),
(81904,'I can feel this in my soul.','',0,0,0,0,0,0,0,0,0,0,43925,0,26124),
(81905,'Just think all the things I will make out of your parts.','',0,0,0,0,0,0,0,0,0,0,46187,0,26124),
(81906,'I hope those limbs aren\'t too broken.','',0,0,0,0,0,0,0,0,0,0,46188,0,26124),
(81907,'So many pieces!','',0,0,0,0,0,0,0,0,0,0,46189,0,26124),
(81908,'Don\'t try to run, you will only die tired.','',0,0,0,0,0,0,0,0,0,0,46190,0,26124),
(81909,'I will catch you and I will fix you.','',0,0,0,0,0,0,0,0,0,0,46191,0,26124),
(81910,'That one! That is the one that I need!','',0,0,0,0,0,0,0,0,0,0,46192,0,26124),
(81911,'I can feel the vile taint flowing through me.','',0,0,0,0,0,0,0,0,0,0,46193,0,26124),
(81912,'A revenge assault, eh?  Scout, sound the Call to Arms! Get the peons inside!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81913,'To arms! To your posts! Show the Thunderlords what it is to be Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81914,'Sergeant, Thunderlord orcs are at the walls!','Sergeant, Thunderlord orcs are at the walls!',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(81915,'You dare challenge the might of Skog?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81916,'We all start from humble beginnings. I took my first steps outside an abbey in Elwynn Forest.','We all start from humble beginnings. I took my first steps outside an abbey in Elwynn Forest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81917,'We all start from humble beginnings. My life began after emerging from the wreckage of the Exodar.','We all start from humble beginnings. My life began after emerging from the wreckage of the Exodar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81918,'We all start from humble beginnings. Once, I was just a trainee on a faraway isle called Shen-zin Su.','We all start from humble beginnings. Once, I was just a trainee on a faraway isle called Shen-zin Su.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81919,'We all start from humble beginnings. I began my journey in the tranquil boughs of Teldrassil.','We all start from humble beginnings. I began my journey in the tranquil boughs of Teldrassil.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81920,'We all start from humble beginnings. My story began on the streets of Gilneas.','We all start from humble beginnings. My story began on the streets of Gilneas.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81921,'','No army can function without orcs like me supplying them.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(81922,'Screaming with blood lust, the crowd wreaks havoc on the arena! $B$B x2 Drunken Bileslingers |TInterface\\Icons\\achievement_reputation_ogre.blp:32|t x5 Iron Bombers |TInterface\\Icons\\achievement_character_orc_male_brn.blp:32|t','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81923,'Lusting for carnage, the crowd howls for a blood bath. $B$B x3 Drunken Bileslingers|TInterface\\Icons\\achievement_reputation_ogre.blp:32|t x5 Iron Bombers |TInterface\\Icons\\achievement_character_orc_male_brn.blp:32|t','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81924,'Get back to work!','',0,0,0,0,0,0,0,0,0,0,52698,0,26124),
(81925,'You cannot abandon them to this fate. If we forsake our friends now, we are no better than Ner\'zhul.','You cannot abandon them to this fate. If we forsake our friends now, we are no better than Ner\'zhul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81926,'It is not our deaths that matter in the end, but how we live. How will you live, Yrel?','It is not our deaths that matter in the end, but how we live. How will you live, Yrel?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81927,'Your allies\' lives will mean nothing if you give up here. Let their sacrifice inspire you.','Your allies\' lives will mean nothing if you give up here. Let their sacrifice inspire you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81928,'','You\'re absolutely right, $n. Samaara and the others are depending on us. For them, I must survive!',0,0,0,0,0,0,0,0,0,0,0,45623,26124),
(81929,'','I will live to protect the righteous, the helpless, and the hopeless. You are a wise teacher, $n.',0,0,0,0,0,0,0,0,0,0,0,45624,26124),
(81930,'','Let us do this.',0,0,0,0,0,0,0,0,0,0,0,45625,26124),
(81931,'We all start from humble beginnings. I began this life in service of the Lich King.','We all start from humble beginnings. I began this life in service of the Lich King.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81932,'Hey! Hey! Wait up!','',0,0,0,0,0,0,0,0,0,25649,0,0,26124),
(81933,'Are you here to fight the saberon? I need your help!','',0,0,0,0,0,0,0,0,0,25649,0,0,26124),
(81934,'Please! You\'ve gotta help me out!','',0,0,0,0,0,0,0,0,0,25649,0,0,26124),
(81935,'What do you want? Money? Power? I\'ll do anything! Just help me out!','',0,0,0,0,0,0,0,0,0,25649,0,0,26124),
(81936,'Don\'t worry I can take care of myself, but I need your help getting my stuff back!','',0,0,0,0,0,0,0,0,0,25649,0,0,26124),
(81937,'Take your time, I\'ll just be right here...waiting...next to you...forever.','',0,0,0,0,0,0,0,0,0,25649,0,0,26124),
(81938,'You aren\'t going to leave me hanging here...right?','',0,0,0,0,0,0,0,0,0,25649,0,0,26124),
(81939,'So much rests on your shoulders! You can\'t imagine the consequences!','',0,0,0,0,0,0,0,0,0,25649,0,0,26124),
(81940,'Hammering','Hammering',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81941,'Think you can take a disciple of the Sorcerer King? HAH!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81942,'Stop my research? Let me show you my research! Meet my latest creation, Bulgorg!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81943,'Back to work, boss.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(81944,'Commander save me. Me happy orc!','',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(81945,'Give the blueprints a good look, commander.','',0,0,0,0,0,0,0,7,0,0,45738,0,26124),
(81946,'Me thought me dead for sure!','',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(81947,'Tiger-men try to eat me!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(81950,'You found it! Roxxie Rocketgrip...Bombshell Belle...they\'re all here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81951,'My precious...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81952,'Profession Building Blueprint','Profession Building Blueprint',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81953,'So boss, what\'s your focus? Remember, only the first one is free.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81954,'','Oh, Commander, you\'ve been awfully busy lately. Fancy a drink? Maybe a nice sharp sword?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(81955,'There is only one way you may prove your worth to me, stranger.$B$BCombat.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(81956,'Very well. Let us fight.','Very well. Let us fight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81957,'Ah, sweet freedom! You won\'t regret this, commander. I\'ll make you the finest armaments in all of Draenor!','',0,0,0,0,0,0,0,0,4,0,45831,0,26124),
(81958,'Let us begin.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(81959,'Let\'s see what we have to work with.','',0,0,0,0,0,0,0,0,4,0,45832,0,26124),
(81960,'The forge is the soul of the foundry. This one\'s small but with the right equipment I can enhance it.','',0,0,0,0,0,0,0,0,4,0,45833,0,26124),
(81961,'These look good, with some modifications I should be able to load them into the cannons for a burst shot.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81963,'You have proven yourself to me.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(81966,'','You want to lay eyes upon Auchindoun?$B$BProve your worth to me in combat.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(81967,'So be it.','So be it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81968,'','I yield! You are indeed worthy. Your soul is pure.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(81969,'','May you rest in peace.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(81970,'I\'ll not die out here on the frontier.  I will continue my research back at Highmaul!  Enjoy your temporary victory...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81971,'Shhh! Don\'t let dem see us talkin\' or you\'ll blow my cover!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(81972,'See you around, $p! You can be my sidekick anytime!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81973,'ENOUGH. Play time is over. I will deal with you myself.','',0,0,0,0,0,0,0,0,0,0,43657,0,26124),
(81974,'Pathetic...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81975,'I need a Shadowmoon orc illusion.','I need a Shadowmoon orc illusion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81976,'','The illusion should hold until your work is done.$B$BMagic is fickle, however!$B$BTake my Amulet of Illusion. If you lose your orc appearance while at Shaz\'gul, simply use the amulet.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81977,'','Be careful of the wolves that patrol Shaz\'gul. Unlike eyes, their noses will not be fooled.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81978,'Lok\'tar Commander $p.$b$bI was sent by Warchief Vol\'jin himself to assist you in day to day operations. While you are in the field I can manage, train, and dispatch your troops on missions essential to our survival in this place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81979,'What Missions are available?','What Missions are available?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(81980,'I\'ll see if I can get this thing goin\'. Khadgar, buy me some time!','',0,0,0,0,0,0,0,0,4,0,45748,0,26124),
(81981,'We will do what we can, Thaelin.','',0,0,0,0,0,0,0,0,4,0,44866,0,26124),
(81982,'$n, keep these orcs off of us!','',0,0,0,0,0,0,0,0,4,0,44867,0,26124),
(81983,'','Tank coming over the rise! Look out!',0,0,0,0,0,0,0,0,4,0,0,45555,26124),
(81984,'These controls don\'t make SENSE. Remind me never ta drive a tank built by an orc.','',0,0,0,0,0,0,0,0,4,0,45749,0,26124),
(81985,'Hold strong, everyone. Here they come!','',0,0,0,0,0,0,0,0,4,0,46408,0,26124),
(81986,'They\'re bringin\' up explosives! $n, destroy those carts before they get close!','',0,0,0,0,0,0,0,0,4,0,45701,0,26124),
(81987,'There\'s so many of them...','',0,0,0,0,0,0,0,0,4,0,44779,0,26124),
(81988,'Don\'t you give up yet, paladin.','',0,0,0,0,0,0,0,0,4,0,46709,0,26124),
(81989,'That\'s it! I\'ve got \'er runnin\'! Let\'s finish this.','',0,0,0,0,0,0,0,0,4,0,45750,0,26124),
(81990,'We have been called upon to protect Auchindoun from further interference.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(81991,'','Only those who prove their souls to us may enter.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(81992,'','I\'ll make my way through shortly. Thank you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81993,'I will make my way through shortly. Thank you again, $p.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(81994,'Throm-Ka, commander.$B$BI\'m glad you\'re here. I need you to take over our preparations to deal with the Warsong clan.$B$BWe will drive them before us, and we\'ll bring Garrosh to justice once and for all.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(81995,'','Ashes to ashes.',0,0,0,0,0,0,23,0,0,0,0,0,26124),
(81996,'','You... are not.. WORTHY!',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(81997,'Not worthy.','',0,0,0,0,0,0,23,0,0,0,0,0,26124),
(81998,'The gateway shall remain sealed!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(81999,'Hey, $c! You\'re the one in charge right? Tell your dogs to let me out of this cage!','',0,0,0,0,0,0,0,0,0,0,45828,0,26124),
(82000,'Have you even inspected this cage? It\'s on the verge of falling apart! Let me out and I\'ll show you how to make one strong enough to hold a raging clefthoof bull in it!','',0,0,0,0,0,0,0,0,0,0,45829,0,26124),
(82001,'Hey, let me out of this thing!','',0,0,0,0,0,0,0,0,0,0,45830,0,26124),
(82002,'','I miss Telaar, but it\'s always a pleasure to see you, Commander $n.$B$BMay the naaru light your way.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82003,'Flesh burns.','',0,0,0,0,0,0,0,0,0,0,41733,0,26124),
(82004,'|TInterface\\Icons\\spell_arcane_arcaneresilience.blp:20|tK\'ara is nearing full power and gains |cFFFF0000|Hspell:161045|h[K\'ara\'s Defense]|h|r!','|TInterface\\Icons\\spell_arcane_arcaneresilience.blp:20|tK\'ara is nearing full power and gains |cFFFF0000|Hspell:161045|h[K\'ara\'s Defense]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82005,'Ahh ha ha haaa! Nice shot!','',0,0,0,0,0,0,0,0,4,0,45700,0,26124),
(82006,'Invader Killed! (+$9042w)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82007,'Saboteur Killed! (+$9044w)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82008,'Boss Killed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82009,'Defender slain! (-$9043w)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82010,'The Warsong are truly inspiring warriors!  You have taken Nagrand in your fist and made it yours!  The Iron Horde would be honored to have Warsong warriors in its ranks.  Let them fear the Warsong across Draenor as you ride for the Iron Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82011,'','Oh, hehehe, aren\'t you a darling little tadpole? Tell me, do you like frogs?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82012,'','The others don\'t believe me, but I have seen HIM. The great one. Once you fall under his gaze, you will never be the same again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82013,'For the Iron Horde!','For the Iron Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82014,'','Croak... croak... croak... Just listen to them! I love it when they talk about me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82015,'Even if I fall, ten more will take my place!','Even if I fall, 10 more will take my place!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82016,'','Have you ever tried frog soup, dear? It\'s quite delicious, and good for you as well.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82017,'','Oh, I just love their cute little bellies and slimy little toes, don\'t you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82018,'Die weakling!','Die weakling!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82019,'Fall before the might of the Iron Horde!','Fall before the might of the Iron Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82020,'The Iron Horde needs ore, and you are in the way!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82021,'I must get the color out of the stone!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82022,'It\'s no safer under my guns, my blades are just as dangerous!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82023,'Old Torglork has sent hundreds like you to the depths!  Time to join them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82024,'Attacked in the middle of this base?!  The Sorcerer King shall hear of this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82025,'You\'ll find I\'m no Iron Horde weakling.  You face one trained by the Sorcerer King himself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82026,'Your efforts are fruitless!  Soon you and your allies will fall!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82027,'You think the Warsong will just stop joining if you slay me?  My work here is finished and the Warsong swell the ranks of the Iron Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82028,'Killing you will boost recruitment tenfold and I probably won\'t even scratch my armor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82029,'Thank you again, $p. Now to use the potion to bring Tuliaa back!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(82030,'Come on, Tuliaa. Wake up. Please... you have to wake up...','',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(82031,'Go boss! Kill cat-man!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(82032,'Hey cat-man! You smell!','',0,0,0,0,0,0,14,0,0,0,0,0,26124),
(82033,'Not so tough now, are you cat-man?','',0,0,0,0,0,0,19,0,0,0,0,0,26124),
(82034,'Woo! Kick his butt!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(82035,'Cat-man? More like gnome lover!','',0,0,0,0,0,0,14,0,0,0,0,0,26124),
(82036,'Take that! And that!','',0,0,0,0,0,0,21,0,0,0,0,0,26124),
(82037,'That\'s it! Kill him good!','',0,0,0,0,0,0,21,0,0,0,0,0,26124),
(82038,'You unstoppable!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(82039,'Thanks boss! Back to work!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(82040,'Those filthy saberon ain\'t going to get away with this...nobody steals from the Steamwheedle Cartel and gets away with it!$b$bNobody!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82041,'','The Ring of Trials is the perfect place to make some cash!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82042,'Mess with the peasant, you get the boss!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(82043,'I\'m pretty sure you\'re gonna win!','',0,0,0,0,0,0,14,0,0,0,0,0,26124),
(82044,'You\'ll regret this, creature. I swear on me mum!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(82045,'Kill him, Commander!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(82046,'You\'re as intimidating as a goblin!','',0,0,0,0,0,0,14,0,0,0,0,0,26124),
(82047,'Take that! And that!','',0,0,0,0,0,0,21,0,0,0,0,0,26124),
(82048,'You picked the wrong day to mess with $p!','',0,0,0,0,0,0,21,0,0,0,0,0,26124),
(82049,'You can do it!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(82050,'','Isel, don\'t go far.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82051,'','Stay near, young lady.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82052,'','I want you back soon, Isel.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82053,'','Isel, come back!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82054,'','No going outside the walls.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82055,'','Don\'t be gone long, Isel.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82056,'','Stay close. It\'s not safe anymore.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82057,'','Did you finish your chores?',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82058,'','Oh mom.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82059,'','Uh huh. Yep.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82060,'','Be back soon.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82061,'','I\'m not a baby!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82062,'','I cleaned up. You promised!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82063,'','Don\'t worry. I won\'t go outside the gates.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82064,'','Mother!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82065,'','There\'s nothing to do around here!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82066,'','Ugh. Children.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82067,'','Behave, young lady.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82068,'','No bothering the guards.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82069,'','Do you have any of your own, $p?',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82070,'','Just once, I wish she\'d behave.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82071,'','She\'s growing up too quickly.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82072,'','And, no fishing!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82073,'','I mean it, little bug. Be safe.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82074,'','Isel frowns.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82075,'','Isel!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82076,'Please, my family has nothin to eat.','',20,0,0,0,0,0,20,0,0,0,0,0,26124),
(82077,'What\'s a matter, little kitty?  Don\'t like the whip?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82078,'Adventurer, could you please spare some coin?','',20,0,0,0,0,0,20,0,0,0,0,0,26124),
(82079,'','Commander Tharbek, it seems your troops have allowed a group of pitiful heroes to sneak past them.',0,0,0,0,0,0,1,0,0,0,0,43564,26124),
(82080,'','Isel sighs.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82081,'','Disappointment crosses Isel\'s face.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82082,'','The young lady rolls her eyes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82083,'','Isel shakes her head.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82084,'','Isel wrinkles her nose.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82085,'','The girl exhales dramatically.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82086,'','Isel kicks at the dirt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82087,'','Coming!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82088,'I apologize for this failure Warlord Zaela. The Iron March will take care of these intruders!','',0,0,0,0,0,0,1,0,0,0,45861,0,26124),
(82089,'Iron March, kill them or I will kill you!','',0,0,0,0,0,0,5,0,0,0,45862,0,26124),
(82090,'','Kill the one in the dress!',0,0,0,0,0,0,25,0,0,0,0,43565,26124),
(82091,'','Why?! I\'ll kill them... I\'ll kill them all!!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82092,'Perhaps you\'d like to join my little pet in this cage!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82093,'Can\'t you see I\'m busy with my \"honored\" guest?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82094,'Come to save the poor broken cat?  Perhaps its time to switch pets!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82095,'This way, friend. The ward is nearly at full power.','',0,0,0,0,0,0,0,0,0,0,46759,0,26124),
(82096,'We will sink these crystalline resonance emitters into the earth, harnessing the very energies of Draenor itself to power our defenses.','',0,0,0,0,0,0,396,0,0,0,46760,0,26124),
(82097,'|TInterface\\Icons\\ability_warrior_shieldguard:20|t%s readies a |cFFFF0000|Hspell:158136|h[Shield Charge]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82098,'|TInterface\\Icons\\ability_whirlwind:20|t%s readies a |cFFFF0000|Hspell:157943|h[Whirlwind]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82099,'Boss killed! (+$9048w)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82100,'Total Score: $1i','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82101,'We can\'t just run away while these barbarians bleed my people dry. We have to stop them!','',0,0,0,0,0,0,0,0,0,924,0,0,26124),
(82102,'We can\'t just run away while these brutes bleed my people dry. We have to stop them!','',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(82103,'Very well, but don\'t take long. I will require both of you later, and you will need to be alive.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(82104,'She\'s a beauty, there\'s no doubt about it. We do good work together, $n.$B$BWe\'re going to crush the Warsong!','',273,0,0,0,0,0,0,0,0,0,0,0,26124),
(82105,'This is no time for laziness!$B$BOnce this beauty\'s built, we\'re going to crush the Warsong and anyone else who gets in our way.','',274,0,0,0,0,0,0,0,0,0,0,0,26124),
(82106,'The corral is built. Time to put it to good use and bring justice to Nagrand.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(82107,'The tankworks is built. Time to put it to good use and bring justice to Nagrand.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(82108,'Together, we will bring justice to Garrosh and the Warsong clan.','',396,0,0,0,0,0,0,1,0,0,46388,0,26124),
(82109,'Come, $p. I will introduce you to a friend of mine who can help you with your tower.','',0,0,0,0,0,0,1,0,0,0,44904,0,26124),
(82110,'','Eh boss-mon! Ya be needin\' a rest?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82111,'Come, Cordana!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(82112,'Let us pass, gatekeeper.','',0,0,0,0,0,0,1,0,0,0,44905,0,26124),
(82113,'','Well done Commander, but it seems that the intruders are still quite alive.',0,0,0,0,0,0,1,0,0,0,0,43566,26124),
(82114,'What? Unacceptable!','',0,0,0,0,0,0,1,0,0,0,45863,0,26124),
(82115,'Kill them you fools!','',0,0,0,0,0,0,5,0,0,0,45864,0,26124),
(82116,'Lady Proudmoore has expressly forbid Horde from entering Kirin Tor grounds.','',0,0,0,0,0,0,1,0,0,0,45993,0,26124),
(82117,'I am forming a small party to scout the enemy\'s fortifications.','I am forming a small party to scout the enemy\'s fortifications.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(82118,'Then let Jaina take it up with me. I am a member of the Council, and you WILL let me and my friend pass!','',0,0,0,0,0,0,25,0,0,0,44906,0,26124),
(82119,'My tower lies just through this pass.','',0,0,0,0,0,0,1,0,0,0,44907,0,26124),
(82120,'Thrall, take command of the remaining survivors and meet us up ahead.','Thrall, take command of the remaining survivors and meet us up ahead.',0,0,0,0,0,0,0,0,4,924,0,0,26124),
(82121,'Maraad, take command of the remaining survivors and meet us up ahead.','Maraad, take command of the remaining survivors and meet us up ahead.',0,0,0,0,0,0,0,0,4,923,0,0,26124),
(82122,'It will be done.','',0,0,0,0,0,0,0,0,4,924,0,0,26124),
(82123,'','The Iron Horde cares nothing for the quality of a blade or the workmanship that goes into it. They craft them big and heavy to make up for the poor steel they\'re made with.$b$bPathetic.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(82124,'Yes, Archmage.','',0,0,0,0,0,0,0,0,4,923,0,0,26124),
(82125,'<The mule looks at you with its big old eyes... then it tries to eat your shirt.>','<The mule looks at you with its big old eyes... then it tries to eat your shirt.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82126,'Very well, Archmage. As you wish.','',0,0,0,0,0,0,1,0,0,0,45994,0,26124),
(82127,'It\'s so hard to find good ingredients around here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82128,'','This is pitiful! Do your men not know where the sharp part of the axe goes?',0,0,0,0,0,0,1,0,0,0,0,43567,26124),
(82129,'I don\'t understand, these intruders fight with the fury of Grommash himself.','',0,0,0,0,0,0,1,0,0,0,45865,0,26124),
(82130,'Up ahead! Look at that!','',0,0,0,0,0,0,0,0,4,923,0,0,26124),
(82131,'Ancestors help us... look at that!','',0,0,0,0,0,0,0,0,4,924,0,0,26124),
(82132,'','I will hear no more of these excuses. I am going to go prepare the weapon, take care of these invaders or I will show you how a true orc deals with failure.',0,0,0,0,0,0,1,0,0,0,0,43568,26124),
(82138,'When you are ready, take this portal down to my tower.','',0,0,0,0,0,0,396,0,0,0,44908,0,26124),
(82139,'%s is attracted by the smell of fresh blood!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82140,'Yes Warlord! I will handle this personally!','',0,0,0,0,0,0,1,0,0,0,45866,0,26124),
(82141,'Fetch my mount, I am tired of watching you peons disgrace my Iron Horde.','',0,0,0,0,0,0,5,0,0,0,45867,0,26124),
(82142,'Finally! Now you will pay for embarrassing me!','',0,0,0,0,0,0,1,0,0,0,45854,0,26124),
(82143,'My Warlord, I have failed you.','',0,0,0,0,0,0,1,0,0,0,45855,0,26124),
(82144,'Now let us finish this.','',0,0,0,0,0,0,1,0,0,0,45856,0,26124),
(82145,'Warlord Zaela! I have regained my honor!','',0,0,0,0,0,0,1,0,0,0,45860,0,26124),
(82146,'Your friends will join you soon!','',0,0,0,0,0,0,1,0,0,0,45857,0,26124),
(82147,'Too easy!','',0,0,0,0,0,0,1,0,0,0,45858,0,26124),
(82148,'How did you get this far?','',0,0,0,0,0,0,1,0,0,0,45859,0,26124),
(82149,'I know what I must do.','',0,0,0,0,0,0,0,0,4,0,46164,0,26124),
(82150,'BLOOD AND HONOR!','',0,0,0,0,0,0,0,0,4,0,46165,0,26124),
(82151,'KILROGG DEADEYE','KILROGG DEADEYE',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(82152,'WARLORD OF THE BLEEDING HOLLOW','WARLORD OF THE BLEEDING HOLLOW',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(82153,'Look what dragged itself through my jungle. Fresh meat!','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(82154,'We won\'t go without a fight, Deadeye.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(82155,'It looks like you could use a hand.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(82156,'No! Fight me instead!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(82157,'GOOOO... FIND... KHADGARRRR....','',0,0,0,0,0,0,0,0,4,0,46166,0,26124),
(82158,'My friend is just ahead.','',0,0,0,0,0,0,1,0,0,0,44909,0,26124),
(82159,'Defend me and I will break this siege $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82160,'Ah, there you are! This is the one I was telling you about.','',0,0,0,0,0,0,1,0,0,0,44910,0,26124),
(82161,'You fools! How could you dump mines into the harbor?!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(82162,'No.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82163,'I should be out there killing the White Kraken but instead I have to clean up this mess! Get more orcs down there!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(82164,'If those mines aren\'t cleared by daybreak tomorrow I will fire on the dock I swear!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(82165,'Very good. I\'m sure I\'ll be seeing the both of you soon.','',0,0,0,0,0,0,1,0,0,0,44903,0,26124),
(82166,'I am Magister Krelas. Pleasure. Let us begin, yes?','',0,0,0,0,0,0,2,0,0,0,45516,0,26124),
(82167,'Vorka is landing, quickly destroy him and stop this Bombardment of Karabor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82168,'Splendid! I can take things from here.','',0,0,0,0,0,0,1,0,0,0,45517,0,26124),
(82169,'No outsiders allowed. Lady Proudmoore\'s orders.','',0,0,0,0,0,0,1,0,0,0,45992,0,26124),
(82170,'','I\'m Mr. G\'s right hand gal on this expedition. A genius like Mr. G can\'t be bothered to deal with mundane everyday problems.$b$bThat\'s what I\'m here for, to get the doing done so that he can focus on the important stuff!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82171,'My friend is just ahead.','',0,0,0,0,0,0,1,0,0,0,44909,0,26124),
(82172,'Ah, there you are! This is the one I was telling you about.','',0,0,0,0,0,0,1,0,0,0,44910,0,26124),
(82173,'','Wonderful! Thank you, Archmage. I can handle things from here.',0,0,0,0,0,0,1,0,0,0,0,44039,26124),
(82174,'The Steamwheedle Preservation Society was created to help ensure the safety of valuable artifacts and antiquities across Azeroth and Draenor.$b$bWe travel far and wide to obtain the most precious relics and artifacts ever seen!$b$bOur mission is to put all of these priceless artifacts exactly where they belong... in the hands of the highest bidder!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82175,'I wish to disenchant some old gear.','I wish to disenchant some old gear.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82176,'The essence font allows you to break down weapons and armor into enchanting materials.  The item is PERMANENTLY destroyed.\n\nDo you wish to continue?','The essence font allows you to break down weapons and armor into enchanting materials.  The item is PERMANENTLY destroyed.\n\nDo you wish to continue?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82177,'Hello.','Hello.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82178,'','Yay! Thank you thank you thank you SO much!',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(82179,'I thought everyone forgot about me. Thank you, $Gkind mister:kind lady;!','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(82180,'Wow, did you fight off all the orcs? You\'re strong!','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(82182,'','<The little girl wails inconsolably.>',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(82183,'Let\'s burn it up!','',0,0,0,0,0,0,1,0,0,0,45504,0,26124),
(82184,'Aid me! I cannot move!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82185,'By the Earthmother, this land will test us at every turn!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82186,'That\'s it fellas, as of right now we\'re on strike!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82187,'%s lands. Attack him!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82188,'These rampaging elementals are a threat to worker safety! This wasn\'t in the contract!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82189,'If Futzwangler wants the diggin\' done in Stonecrag Gorge, then he can do it himself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82190,'It\'s about time we had a new contract! Revise the labor agreement!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82191,'We need better pay! More leisure time! Fewer regulations!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82192,'Come on! Make some noise! Let old Futzwangler know that we ain\'t budging until we get a bigger cut!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82193,'When was the last time Gazmolf let us party? We\'ve got to fight for our right to party!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82194,'You\'ve been had! You\'ve been took! You\'ve been hoodwinked. Bamboozled!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82195,'Hmm. Perhaps we can use these energized mushrooms to our advantage.','',0,0,0,0,0,0,1,0,0,0,45502,0,26124),
(82196,'Madam Goya has decided to move her operations to more lucrative markets. It seemed like a prudent time to give up a thankless job.','Madam Goya has decided to move her operations to more lucrative markets. It seemed like a prudent time to give up a thankless job.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82197,'It\'s odd that these ancient protectors never awakened despite all this mess.','',0,0,0,0,0,0,1,0,0,25787,45503,0,26124),
(82198,'Watch out!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82199,'With luck, the small ones will now flee, and we can begin construction.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(82200,'Great fishing in these local waters, just have to get out there!','Great fishing in these local waters, just have to get out there!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(82201,'Ready for me to go fishing?  I will return with a shipment soon.','Ready for me to go fishing?  I will return with a shipment soon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82202,'Who dares challenge me?','',0,0,0,0,0,0,0,0,0,0,46116,0,26124),
(82203,'Readdyyyyyyyy!!!','',0,0,0,0,0,0,0,0,0,0,46109,0,26124),
(82204,'Let \'em have it, boys!','',0,0,0,0,0,0,0,0,0,0,46111,0,26124),
(82205,'I\'ve got my sights on you.','',0,0,0,0,0,0,0,0,0,0,46113,0,26124),
(82206,'RAPID FIRE!!!','',0,0,0,0,0,0,0,0,0,0,46114,0,26124),
(82207,'Give \'em all ya got.','',0,0,0,0,0,0,0,0,0,0,46112,0,26124),
(82208,'Hah! Let\'s take this down to your level.','',0,0,0,0,0,0,0,0,0,0,46115,0,26124),
(82209,'Another contender down!','',0,0,0,0,0,0,0,0,0,0,46120,0,26124),
(82210,'So weak!','',0,0,0,0,0,0,0,0,0,0,46121,0,26124),
(82211,'None can compete!','',0,0,0,0,0,0,0,0,0,0,46122,0,26124),
(82212,'I didn\'t... even... try...','',0,0,0,0,0,0,0,0,0,0,46110,0,26124),
(82213,'','Nobody stops the Iron Horde. Nobody!',0,0,0,0,0,0,0,0,0,0,0,45883,26124),
(82214,'Excellent! We can make our scroll of mass teleportation with these.','',0,0,0,0,0,0,1,0,0,25790,45515,0,26124),
(82215,'We won\'t go without a fight, Deadeye.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(82216,'I\'ve seen large numbers of Thunderlords massing nearby. They are preparing for an attack.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(82217,'Khadgar speaks highly of you. You have quite the list of accolades.','',0,0,0,0,0,0,1,0,0,0,45514,0,26124),
(82218,'','Commander! Great! Can you tell Gazlowe that if he is serious about trying to use this plot up here for fishing and farming that he is going to have to find someone who knows what they are doing?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82219,'I was not expecting the arcane energy to be this... potent.','',0,0,0,0,0,0,1,0,0,25796,45495,0,26124),
(82220,'','Rakun, let\'s give \'em hell!',0,0,0,0,0,0,0,0,0,0,0,45878,26124),
(82221,'','Another one!',0,0,0,0,0,0,0,0,0,0,0,45880,26124),
(82222,'','Light \'em up!',0,0,0,0,0,0,0,0,0,0,0,45881,26124),
(82223,'','How shocking.',0,0,0,0,0,0,0,0,0,0,0,45884,26124),
(82224,'','Hah!',0,0,0,0,0,0,0,0,0,0,0,45885,26124),
(82225,'','You can never stop this train!',0,0,0,0,0,0,0,0,0,0,0,45886,26124),
(82226,'','You... can\'t...',0,0,0,0,0,0,0,0,0,0,0,45879,26124),
(82227,'I can get the building started, but I can\'t finish it without the blueprints. They\'re the key to everything we\'re doing here.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(82228,'The Burning Blade is an honorable clan, but they have chosen the wrong side in this conflict.','',0,0,0,0,0,0,0,1,0,0,46389,0,26124),
(82229,'','Show them what you\'re made of!',0,0,0,0,0,0,0,0,0,0,0,45882,26124),
(82230,'Gazlowe needs your extra construction materials.','Gazlowe needs your extra construction materials.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82231,'Off your lazy butts. It\'s time to get to work.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82232,'','BOLD! Is that what this garrison says to you, commander? No! It does not! But then this is why I was hired.$b$bUsing the small plots we can build a striking array of structures like... an apothecary! Yes, an apothecary. Or perhaps a smithy or a workshop.$b$bIf we use the large plots, we could outfit you with a barracks for your troops that will strike fear into the hearts of your enemies and sleep into the faces of your soldiers.$b$bThe sky is the limit, as is the width and length.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82233,'Gazlowe needs your extra construction materials.','Gazlowe needs your extra construction materials.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82234,'Commander, your pack of peons awaits your orders.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82235,'Building Burning! (-$9063w)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82236,'[%s] confesses: After so much talk about Garrison, I thought it was a person.','[%s] confesses: After so much talk about Garrison, I thought it was a person.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82237,'[%s] confesses: I knew he played a priest...','[%s] confesses: I knew he played a priest...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82238,'[%s] confesses: I have no idea how to pronounce Draenor.','[%s] confesses: I have no idea how to pronounce Draenor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82239,'[%s] confesses: I frequently get Vale of Eternal Blossoms and Valley of the Four Winds confused.','[%s] confesses: I frequently get Vale of Eternal Blossoms and Valley of the Four Winds confused.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82240,'[%s] confesses: I refuse to talk when I am underwater.','[%s] confesses: I refuse to talk when I am underwater.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82241,'[%s] confesses: I frequently wondered where the greater charms of good fortune are.','[%s] confesses: I frequently wondered where the greater charms of good fortune are.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82242,'[%s] confesses: I once did every daily quest all in one day.','[%s] confesses: I once did every daily quest all in one day.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82243,'[%s] confesses: I really, really like to Leap of Faith my allies at \"opportune\" moments.','[%s] confesses: I really, really like to Leap of Faith my allies at \"opportune\" moments.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82244,'[%s] confesses: I like to exaggerate what I get from Unclaimed Black Market Containers.','[%s] confesses: I like to exaggerate what I get from Unclaimed Black Market Containers.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82245,'[%s] confesses: I don\'t understand how so many people know about the Brawler\'s Guild.  The first rule...','[%s] confesses: I don\'t understand how so many people know about the Brawler\'s Guild.  The first rule...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82246,'[%s] confesses: I once died to the same Gastropod three times.','[%s] confesses: I once died to the same Gastropod three times.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82247,'[%s] confesses: I purposely let Sooli die in Proving Grounds more than once.','[%s] confesses: I purposely let Sooli die in Proving Grounds more than once.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82248,'[%s] confesses: I spent a whole day looking for mining nodes in Silvershard Mines.','[%s] confesses: I spent a whole day looking for mining nodes in Silvershard Mines.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82249,'[%s] confesses: I thought capturing the enemy\'s mine cart in Deepwind Gorge would make me a better miner.','[%s] confesses: I thought capturing the enemy\'s mine cart in Deepwind Gorge would make me a better miner.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82250,'[%s] confesses: I hum the same song to myself whenever I am pet battling.','[%s] confesses: I hum the same song to myself whenever I am pet battling.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82251,'I\'m your temporary Follower. To battle, $N!','I\'m your temporary Follower. To battle, $N!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82252,'I\'m your fake follower for now. Lead, I will follow!','I\'m your fake follower for now. Lead, I will follow!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82253,'We make slaves of you all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82254,'Dis my salvage!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82255,'Your kind will be our new slaves!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82256,'You no match for Bladespire army!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82257,'First, we deal with the bridge.','',0,0,0,0,0,0,25,0,0,0,44849,0,26124),
(82258,'Mm.','',0,0,0,0,0,0,0,0,6,0,46707,0,26124),
(82259,'This slaver and torturer knows nothing of honor.','',0,0,0,0,0,0,0,0,4,0,44590,0,26124),
(82260,'We cannot hide here forever.','',0,0,0,0,0,0,0,0,4,0,44851,0,26124),
(82261,'Step into my arena and die with honor.','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(82262,'You have entered my arena, strangers. You will either leave it as victors, or as corpses.','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(82263,'Such is the way of the SHATTERED HAND.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(82264,'A combat arena. This may be a trap, but at least we will die with honor.','',0,0,0,0,0,0,0,0,4,0,46407,0,26124),
(82265,'MY STUFF!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82266,'What\'s this? An outsider!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82267,'[%s] confesses: I once asked for a Jeeves to be dropped right after a different Jeeves had disappeared.','[%s] confesses: I once asked for a Jeeves to be dropped right after a different Jeeves had disappeared.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82268,'I will go to your outpost to make the scroll. Meet me there when you can.','',0,0,0,0,0,0,1,0,0,25790,45513,0,26124),
(82269,'Pathetic.','',0,0,0,0,0,0,0,0,0,25820,0,0,26124),
(82270,'You call yourself Burning Blade?','',0,0,0,0,0,0,0,0,0,25820,0,0,26124),
(82271,'The half-breed fights better than you!','',0,0,0,0,0,0,0,0,0,25820,0,0,26124),
(82272,'If it weren\'t for my sons, I\'d weep for the future of our clan.','',0,0,0,0,0,0,0,0,0,25820,0,0,26124),
(82273,'You are the worst group I\'ve ever had the displeasure to train.','',0,0,0,0,0,0,0,0,0,25820,0,0,26124),
(82274,'Once the masters see you, I\'ll be executed, my blade melted down, and my banner fed to the flames.','',0,0,0,0,0,0,0,0,0,25820,0,0,26124),
(82275,'I\'d laugh if this inept display weren\'t so depressing.','',0,0,0,0,0,0,0,0,0,25820,0,0,26124),
(82276,'The villagers would do a better job.','',0,0,0,0,0,0,0,0,0,25820,0,0,26124),
(82277,'Your fishing shipment should be here soon, try back later.','Your fishing shipment should be here soon, try back later.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82278,'%s begins to cast |cFFFF0404|Hspell:157659|h[Rippling Smash]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82279,'Futzwangler hired a strikebreaker?!','Futzwangler hired a strikebreaker?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82280,'They\'re taking our jobs!','They\'re taking our jobs!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82281,'You can\'t just take our jobs because we refuse to work! It ain\'t right!','You can\'t just take our jobs because we refuse to work! It ain\'t right!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82282,'I knew this would happen! I\'ve got to get my job back!','I knew this would happen! I\'ve got to get my job back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82283,'It\'s all yours, buddy. Have fun with the elementals!','It\'s all yours, buddy. Have fun with the elementals!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82284,'Futzwangler hired scabs?!','Futzwangler hired scabs?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82285,'What do you mean I\'m not getting paid?!','What do you mean I\'m not getting paid?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82286,'Maybe I can still get my job back!','Maybe I can still get my job back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82287,'','Quickly Aknor! Bring me another. Blackhand will not tolerate any delays.',0,0,0,0,0,0,0,0,0,0,0,41998,26124),
(82288,'','My work. You\'ve interrupted my WORK!',0,0,0,0,0,0,0,0,0,0,0,41990,26124),
(82289,'','Another falls to my blade!',0,0,0,0,0,0,0,0,0,0,0,42000,26124),
(82290,'','Too hot for you?',0,0,0,0,0,0,0,0,0,0,0,42001,26124),
(82291,'','Burn!',0,0,0,0,0,0,0,0,0,0,0,42002,26124),
(82292,'','Your flesh feeds the fire.',0,0,0,0,0,0,0,0,0,0,0,42003,26124),
(82293,'','Iron and flame!',0,0,0,0,0,0,0,0,0,0,0,42004,26124),
(82294,'','Come my pets.',0,0,0,0,0,0,0,0,0,0,0,42005,26124),
(82295,'','Feeding time!',0,0,0,0,0,0,0,0,0,0,0,42006,26124),
(82296,'','I have more friends for you to meet!',0,0,0,0,0,0,0,0,0,0,0,42007,26124),
(82297,'','Work complete!',0,0,0,0,0,0,0,0,0,0,0,41993,26124),
(82298,'','Glory to the Blackrock!',0,0,0,0,0,0,0,0,0,0,0,41994,26124),
(82299,'','Let flame kiss your tender flesh!',0,0,0,0,0,0,0,0,0,0,0,41995,26124),
(82300,'','Your bodies will make good kindling.',0,0,0,0,0,0,0,0,0,0,0,41999,26124),
(82301,'','Aknor! You are an embarrassment to your clan.',0,0,0,0,0,0,0,0,0,0,0,41991,26124),
(82302,'','That\'s enough - you will burn!  YOU WILL ALL BURN!',0,0,0,0,0,0,0,0,0,0,0,41992,26124),
(82303,'','My flame... burned too bright.',0,0,0,0,0,0,0,0,0,0,0,41997,26124),
(82304,'What brings you to my door? I have no wares to sell, and no need for vagabonds!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82305,'Through the Undergrowth you go. Hurry now, and keep your eyes peeled!$B$BKah-hah hah ha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82306,'I\'m a guard!','I\'m a guard!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82307,'\"Shadows gather...\"','\"Shadows gather...\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82308,'I\'m a laborer!','I\'m a laborer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82309,'I\'m a laborer too!','I\'m a laborer too!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82310,'Yes, yes, I understand. I will tell you the way.','',0,0,0,0,0,0,396,0,0,0,46230,0,26124),
(82311,'And I see you out there, Reshad! No use hiding from me, darling. Come in, come in!','',0,0,0,0,0,0,70,0,0,0,46231,0,26124),
(82312,'You too, Percy! That\'s it... give old Ornekka some sugar.','',0,0,0,0,0,0,153,0,0,0,46232,0,26124),
(82313,'Oh... yes, of course. Greetings, Ornekka.','',0,0,0,0,0,0,0,0,0,0,46007,0,26124),
(82314,'Hey, wait up! Don\'t leave, we\'re just getting started!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82315,'','Come on gang! Let\'s get back to work before Thazwix gets us in more trouble...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82316,'Yes?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(82317,'Show me my Garrison.','Show me my Garrison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82318,'You kill Guh friends, now who Guh trade with?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82319,'Very well.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(82320,'You should trade with me, then.','You should trade with me, then.',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(82321,'Perhaps you could be persuaded to visit my garrison and do some trading?','Perhaps you could be persuaded to visit my garrison and do some trading?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(82322,'My fist!','My fist!',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(82323,'Guh no think that a good idea.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82324,'Strange face-coin, very shiny. Maybe me come visit sometime.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82325,'You not very nice.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82326,'Are you sure you want to give Guh some coins?','Are you sure you want to give Guh some coins?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82327,'','You cannot stop Ner\'zhul. The power of the void will consume you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82328,'If you want to know where your important piece of paper is, you\'ll return with my blade or not at all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82329,'Guh like you. Me come visit sometime.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82330,'A $c? You\'ve come to Hallvalor to die. It would appear that I have, too.$B$BAs a half-draenei, half-orc, my enemies within the Burning Blade cast me out when they rose to power. But my honor will not allow this to stand.$B$BExiling me was an act of cowardice. They should have allowed me to fight for my place like any other.$B$BNow, I will exact justice from them at the tip of my blade.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82331,'','Listen up you idiots! The excavation is happening with or without you! If you want to get paid you\'d better start working!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82332,'Murderers! Brigands! Assassins! Where are my GUARDS!?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82333,'','If you see any Shadowmoon orcs around the Stargazers... kill them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82334,'','The Shadowmoon clan is clearly not happy we have formed our own village. We will need to stay vigilant.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82335,'Help! Guards! Where are they? Fine, I\'ll kill you myself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82336,'Most buildings take some time to construct. But seein\' as how this is your first building, I\'m gonna comp ya and employ my handy Senior Peon II to help out.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82337,'When a building finishes its construction you finalize it and we\'ll open the building for business.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82338,'Look how it burns!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82339,'As you find more blueprints and materials you can bring \'em to me and we can try to use up some of your other plots.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82340,'Fire! Fire! Fire!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82341,'Rezlak will also try to keep some blueprints in stock that you can purchase... for a price.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82342,'Burn it all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82343,'','I went stargazing with Zukaza once... ONCE! We were still young, and I had not yet met my mate.$B$BI\'ve rebuffed him gently over the years, but alas, his head is as thick as an elekk\'s hide.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82344,'Love is such a fickle game...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82345,'','Ready when you are!',0,0,0,0,0,0,1,0,0,0,0,44027,26124),
(82346,'','These mushrooms have been affected as well. We could use these to our advantage!',0,0,0,0,0,0,1,0,0,0,0,44025,26124),
(82347,'','It is curious that these ancient protectors never awakened despite all this mess.',0,0,0,0,0,0,1,0,0,25787,0,44026,26124),
(82348,'','That ought to be all we need for our scroll of mass teleportation. Well done!',0,0,0,0,0,0,1,0,0,25790,0,44038,26124),
(82349,'','The Archmage talks about you all the time you know. You\'re quite the hero!',0,0,0,0,0,0,1,0,0,0,0,44037,26124),
(82350,'','Oh, my. These energy levels are higher than I thought!',0,0,0,0,0,0,1,0,0,25796,0,44018,26124),
(82351,'','I will go back to your outpost to make the scroll. See you there!',0,0,0,0,0,0,1,0,0,25790,0,44036,26124),
(82352,'You will never take our land!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82353,'You! You don\'t belong here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82354,'This is Gordunni land!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82355,'It will be a pleasure blasting you into the ground!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82356,'Love is in the air!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82357,'Look what $n brought me! Kat\'la will surely fall in love with me now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82358,'Hey! You ate my flowers!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82359,'I\'m doomed to live a life of solitude.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82360,'NOOO!!! I give up...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82361,'','Hurry, Yrel. Your hammer\'s might will help us greatly.',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(82362,'','If you find Kral\'za, and he is with that void witch Dol\'mak, tell him his mother is looking for him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82363,'','FOOL! If you won\'t respect Ner\'zhul you will be sacrificed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82364,'Mother was right; the Shadowmoon clan cannot be trusted!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82365,'','Thank you, $n. Maybe next time my son will listen to his mother.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82366,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82367,'What can you tell me about the Steamwheedle Preservation Society?','What can you tell me about the Steamwheedle Preservation Society?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82368,'Tell me, what do you see when you stare into an ancient artifact?$b$bHistory? Culture? Mystery?$b$bThat\'s because you have an untrained eye! Do you know what I see?$b$bMoney! Lots of it!$b$bStick around with me long enough and if you\'re smart you\'ll learn a thing or two about real archaeology!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82369,'Invaders Killed: $9046w (+$9072w)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82370,'Saboteurs Killed: $9047w (+$9068w)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82371,'Morale Bonus: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82372,'Bombs Exploded: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82373,'Burn Penalty: $9066w (-$9070w)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82374,'That\'s better!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(82375,'Just a few whacks more!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(82376,'','%s readies her |cFFFF0404|Hspell:154989|h[Inferno Breath]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82377,'%s prepares |cFFFF0404|Hspell:155499|h[Superheated Shrapnel]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82378,'Sergeant, our soldiers need assistance! Charge forward and aid them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82379,'The Alliance has won this stage of the battle!','',0,0,0,0,0,0,0,0,0,30987,48252,0,26124),
(82380,'The Horde has won this stage of the battle!','',0,0,0,0,0,0,0,0,0,30987,48251,0,26124),
(82381,'Sergeant, our situation worsens each moment! I need you in battle immediately!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82382,'Sergeant, our soldiers fight bravely, but they need our aid! Go, lead them to victory!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82383,'Sergeant, the situation has grown dire! March out, for honor and glory!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82384,'Soldiers of the Alliance! Stand fast against them! I come to aid you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82385,'','I see the Prophet! He\'s here!',0,0,0,0,0,0,25,0,0,0,0,45635,26124),
(82386,'Yrel, my student! I thought you had perished for sure.','',0,0,0,0,0,0,0,0,0,0,45387,0,26124),
(82387,'','Prophet, this hero - and many others from another world - have come to aid us.',0,0,0,0,0,0,1,0,0,0,0,45636,26124),
(82388,'I am extremely grateful, champion.','',0,0,0,0,0,0,2,0,0,0,45388,0,26124),
(82389,'We need a base of operations on your world, Great Prophet.','',0,0,0,0,0,0,1,0,0,0,44848,0,26124),
(82390,'It is good to see you, my child. My people welcome your aid, champion. Come with me.','',0,0,0,0,0,0,0,0,0,0,45389,0,26124),
(82391,'Prophet, I must warn you: the Iron Horde intends to strike out against all who oppose him. We must prepare our defenses!','',0,0,0,0,0,0,1,0,0,0,44825,0,26124),
(82392,'Indeed, we have many enemies both within and without.','',0,0,0,0,0,0,1,0,0,0,45390,0,26124),
(82393,'We will deal with one problem at a time. First, we must settle your people.','',0,0,0,0,0,0,1,0,0,0,45391,0,26124),
(82394,'Here! This location commands the entrance to our valley.','',0,0,0,0,0,0,1,0,0,0,45392,0,26124),
(82395,'Do you sense the potential? A great army will someday stand on this very spot, and they will look to you for guidance.','',0,0,0,0,0,0,0,0,0,0,45380,0,26124),
(82396,'Plant the banner, commander, and claim your destiny.','',0,0,0,0,0,0,25,0,0,0,45381,0,26124),
(82397,'I can open up a portal to Stormwind only briefly.','',0,0,0,0,0,0,0,0,0,0,44990,0,26124),
(82398,'The King assured me that our best builders will be ready.','',0,0,0,0,0,0,0,0,0,0,44820,0,26124),
(82399,'This is it, boys! Let\'s break some ground and take this world for the Alliance!','',0,0,0,0,0,0,5,0,0,0,43531,0,26124),
(82400,'I do hope my trust in your people is not misplaced.','',0,0,0,0,0,0,0,0,0,0,45382,0,26124),
(82401,'I assure you, my Prophet, the commander we\'ve chosen represents the very best of the Alliance.','',0,0,0,0,0,0,1,0,0,0,44821,0,26124),
(82402,'','Many of us owe our lives to these strangers.',0,0,0,0,0,0,1,0,0,0,0,45612,26124),
(82403,'Mmnnn. That is good. This world is perched on oblivion. Many trials lie ahead. Many heroes will surely give their lives.','',0,0,0,0,0,0,0,0,0,0,45383,0,26124),
(82404,'When the darkness closes in... follow the light.','',0,0,0,0,0,0,0,0,0,0,45384,0,26124),
(82405,'I am needed here. Champion, please help the others!','',0,0,0,0,0,0,1,0,0,0,45393,0,26124),
(82406,'What are you planning, Ariok?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82407,'Simply a back-up plan. Hopefully we don\'t need it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82408,'Mm.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82409,'','No. We stand here against the Iron Horde. I will fight.',0,0,0,0,0,0,1,0,0,0,0,45608,26124),
(82410,'It\'s time to finish this. Meet me in the Masters\' Cavern.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82411,'We\'re under attack!','We\'re under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82412,'Intruders!','Intruders!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82413,'Lok-Narash!','Lok-Narash!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82414,'Alert the masters!','Alert the masters!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82415,'I\'ll kill you!','I\'ll kill you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82416,'Over here!','Over here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82417,'Outsiders in the village!','Outsiders in the village!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82418,'Kill $g him:her;!','Kill $g him:her;!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82419,'Help!','Help!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82420,'Kagh!','Kagh!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82421,'Lok\'tar ogar!','Lok\'tar ogar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82422,'I will wet my blade with your unworthy blood.','I will wet my blade with your unworthy blood.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82423,'An easy test.','An easy test.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82424,'I\'ll prove myself by killing you!','I\'ll prove myself by killing you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82425,'You have no honor.','You have no honor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82426,'Your tricks won\'t work on me, $c.','Your tricks won\'t work on me, $c.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82427,'You\'ll die for setting foot in my home!','You\'ll die for setting foot in my home!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82428,'No one will remember you when you\'re dead.','No one will remember you when you\'re dead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82429,'Burn!','Burn!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82430,'I\'ll feed you to the flame.','I\'ll feed you to the flame.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82431,'A fitting sacrifice for Hyperious.','A fitting sacrifice for Hyperious.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82432,'Lava consume you!','Lava consume you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82433,'Hallvalor is under attack. Lok-Narash!','Hallvalor is under attack. Lok-Narash!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82434,'Lok\'tar ogar!','Lok\'tar ogar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82435,'The fire is honor!','The fire is honor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82436,'My life for the Burning Blade!','My life for the Burning Blade!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82437,'You dare challenge me?','You dare challenge me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82438,'You are without honor.','You are without honor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82439,'Taste my blade.','Taste my blade.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82440,'For the Burning Blade.','For the Burning Blade.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82441,'For honor and glory!','For honor and glory!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82442,'There will be no songs sung for you, $c.','There will be no songs sung for you, $c.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82443,'My blade seeks vengeance.','My blade seeks vengeance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82444,'A blademaster does not fear death, he fears dishonor.','A blademaster does not fear death, she fears dishonor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82445,'An outsider approaches!','An outsider approaches!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82446,'Enter the ring and make your challenge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82447,'Commander, shall we see the strength of your forces? You may have the honor of first blood.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82448,'Ya gonna\' be earnin\' ya titles this trip.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82449,'Remembah, try to not make the locals too angry. We gotta\' keep a low profile \'til we get fortified.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82450,'Bring ya scout reports to me, and I gonna be relayin\' dem to the commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82451,'Be watchin\' for any \'ting out of da ordinary.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82452,'','Those saberon are going to pay what they owe!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82453,'','Find out what happened to that trade shipment, $p. I\'ll make it worth your while!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82454,'I\'d worry less about the saberon and more about what Pyxni will do to us if we don\'t get her stuff back!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82455,'There\'s still time to save the others...but you\'ll have to hurry!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82456,'This will be the adventure of a lifetime!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82457,'Most gladiators have got a mean right or a mean left; Crushmaul... he\'s just mean!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82458,'Raketalon only eats when she wins in the ring... let\'s just say she\'s well fed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82459,'You\'ve slain Raketalon and you\'ve crushed Crushmaul! Get in there and do the same thing to Hol\'yelaa! Good luck!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82460,'Nobody has been able to extinguish Boomspark! He\'s burned through the competition like a thatched roof cottage!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82461,'This is it, $n! There\'s nobody left to beat after Roakk! Get in there and give \'em hell!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82462,'','If you run into any of my lazy workers down there, tell \'em that if they want to get paid they\'d better start working!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82463,'Do you hear that sound, $p? It\'s the sound of opportunity knocking at your door with a huge pile of money!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82464,'I am injured, but you must press on!','I am injured, but you must press on!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82465,'Thank you, stranger.','Thank you, stranger.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82466,'My thanks for your aid.','My thanks for your aid.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82467,'My thanks.','My thanks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82468,'This frostwolf is not done yet.','This frostwolf is not done yet.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82469,'I am in your debt.','I am in your debt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82470,'Lok\'tar friend.','Lok\'tar friend.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82471,'These brutes test our strength!','These brutes test our strength!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82472,'Hmm, nice and thick, and enough to coat the entire pile.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82473,'This much timber will burn quickly, be ready!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82474,'I demand vengeance!','I demand vengeance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82475,'Ogre blood will be spilled!','Ogre blood will be spilled!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82476,'There are others, we must save them.','There are others, we must save them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82477,'They will see what a cornered wolf is like!','They will see what a cornered wolf is like!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82478,'Let us slaughter these ogres!','Let us slaughter these ogres!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82479,'My wrists are raw from the chains, but I can fight.','My wrists are raw from the chains, but I can fight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82480,'The ogres will pay in blood.','The ogres will pay in blood.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82481,'I am weak, but I can follow.','I am weak, but I can follow.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82482,'Lantresor cuts through his chains.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82483,'You want my things?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82484,'Those damned Goren, they took out over half of our numbers before we were able to evacuate the mine.$b$bWe\'re holding our own out here but we\'re going to need some serious help if the mine is going to be made safe again.','Those damned Goren, they took out over half of our numbers before we were able to evacuate the mine.$b$bWe\'re holding our own out here but we\'re going to need some serious help if the mine is going to be made safe again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82485,'I\'ll see you at the ring. Fight with honor, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82486,'I\'ll move forward and scout their gates while you\'re taking out those catapults. Lok\'tar ogar!','',0,0,0,0,0,0,0,0,4,0,45840,0,26124),
(82487,'It broke.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(82488,'Maybe we can fix it?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(82489,'I didn\'t break it!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(82490,'Magic is scary.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(82491,'Not gonna turn around.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(82492,'Hope it run out of juice soon.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(82493,'All my stuff in dat tower too...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(82494,'Commander, Over here!','',0,0,0,0,0,0,0,0,4,0,45841,0,26124),
(82495,'Now\'s my chance!','Now\'s my chance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82496,'Damn these ogres and their magic! I can\'t find a way to bring the barrier down so we\'re just going to have to sneak in around it.','',0,0,0,0,0,0,0,0,4,0,45827,0,26124),
(82497,'I\'ll go first and clear the way, meet me on the other side.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(82498,'A challenge has been issued from this $g man:woman;... this outsider.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82499,'Bomb Exploded: $9067w (-$8911w)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82500,'Finish it. Show us the might of the Warsong.','',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(82501,'With pleasure.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82502,'Let\'s finish this, pup.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82503,'He was only Warsong and did not fight very well in any case.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82504,'Now you will face a true challenge -- my grandsons.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82505,'You killed their father outside. It\'s only fitting they return the favor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82506,'For father! For honor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82507,'I will cut you down, $pc!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82508,'My boys. You\'ve destroyed my legacy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82509,'I\'ll kill you myself. Honor be damned!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82510,'Dharl. You have no honor. You will die.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82511,'','Hear me, Burning Blade! By right of ascension, I, Azuka Bladefury, daughter of Dharl, assume the mantle of warlord.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82512,'','You, $pc, may leave unharmed. However, if I see you again, you will die.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82513,'','Any clan member who wishes to challenge me may do so.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82514,'','As for you, Lantresor of the Blade, you had no right joining this one\'s challenge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82515,'','You remain a half-breed and an exile. You are not worthy of the Burning Blade. Leave and never return.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82516,'Lantresor spits and throws his banner on the ground.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82517,'Overloading','Overloading',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82518,'Dran\'ruk, your theft of $g his:her; blueprints brought $g him:her; here.','',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(82523,'How did you find me?','How did you find me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82524,'Come, $pc. Issue your challenge. We will allow you to fight... and die.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82525,'Blood and thunder, what a battle!','',0,0,0,0,0,0,0,0,4,0,45838,0,26124),
(82530,'Let\'s kill some ogres!','',0,0,0,0,0,0,1,0,4,0,45839,0,26124),
(82531,'My blade is yours, $n. I will fight by your side until the end of my days.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82532,'The corral is built. Time to put it to good use and bring justice to Nagrand.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(82533,'The tankworks is built. Time to put it to good use and bring justice to Nagrand.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(82534,'I\'ve never seen anything so beautiful. It\'s good working with you, $n.$B$BWe\'re going to crush the Warsong!','',273,0,0,0,0,0,0,0,0,0,0,0,26124),
(82535,'','I will go with you, hero. A warm welcome awaits us at Embaari Village.',0,0,0,0,0,0,1,0,0,0,0,45661,26124),
(82536,'','Your garrison is impressive, hero. Even draenei builders could not work so quickly.',0,0,0,0,0,0,1,0,0,0,0,45662,26124),
(82537,'','Hello Mister Taarvos!',0,0,0,0,0,0,3,0,0,0,0,45663,26124),
(82538,'','That temple is the home to the Shadowmoon Clan. Their leader is the warlord, Ner\'zhul.',0,0,0,0,0,0,1,0,0,0,0,45665,26124),
(82539,'','Gloomshade Grove hides many dangers. If you enter, I will wait for you outside.',0,0,0,0,0,0,1,0,0,0,0,45667,26124),
(82540,'','I have a bad feeling about these woods. I\'ll stay here if you want to venture within.',0,0,0,0,0,0,1,0,0,0,0,45668,26124),
(82541,'','We are nearing draenei lands. Come now, my sister is waiting for us!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(82542,'','I never thought I\'d come back from the slave camps of Tanaan alive.',0,0,0,0,0,0,1,0,0,0,0,45669,26124),
(82543,'','I watched so many of my people die... and I could do nothing to help them.',0,0,0,0,0,0,1,0,0,0,0,45670,26124),
(82544,'','Wow! I\'ve never seen anyone move like that before.',0,0,0,0,0,0,0,0,0,0,0,45594,26124),
(82545,'','What was that? I couldn\'t hear you! Quickly hero, let\'s go before she comes after me!',0,0,0,0,0,0,6,0,0,0,0,45671,26124),
(82546,'','I will aid you as best I can.',0,0,0,0,0,0,0,0,0,0,0,45595,26124),
(82547,'','Impressive.',0,0,0,0,0,0,0,0,0,0,0,45596,26124),
(82548,'','In the flesh!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82549,'','Let me guess. You\'ve done this before.',0,0,0,0,0,0,0,0,0,0,0,45597,26124),
(82550,'','You have a natural gift.',0,0,0,0,0,0,0,0,0,0,0,45598,26124),
(82551,'','I can\'t wait to surprise my sister, Samaara. I never thought I would see her again.',0,0,0,0,0,0,1,0,0,0,0,45599,26124),
(82552,'','Yrel? After the Iron Horde took you, I feared the worst!',0,0,0,0,0,0,3,0,0,0,0,46911,26124),
(82553,'','The light granted me strength when I needed it most. It is good to be home.',0,0,0,0,0,0,1,0,0,0,0,45601,26124),
(82554,'','Samaara! I\'m back!',0,0,0,0,0,0,3,0,0,0,0,45600,26124),
(82555,'In the end, all will be consumed.','',0,0,0,0,0,0,0,0,0,0,44454,0,26124),
(82556,'It is but a fraction of the Dark Star\'s power.','',0,0,0,0,0,0,0,0,0,0,45397,0,26124),
(82557,'','We\'ll see about that!',0,0,0,0,0,0,0,0,0,0,0,45642,26124),
(82558,'The Iron Horde fleet has been sighted off the coast. We\'re calling every defender to the Temple.','',0,0,0,0,0,0,1,0,0,0,44809,0,26124),
(82559,'','But Ner\'zhul poses an equal threat. What should we do, Prophet?',0,0,0,0,0,0,6,0,0,0,0,45602,26124),
(82560,'Champion, I need your help to stop the Dark Star\'s arrival. Maraad, can you hold Karabor until we are finished?','',0,0,0,0,0,0,1,0,0,0,45363,0,26124),
(82561,'As long as the defense crystal stands, we will hold.','',0,0,0,0,0,0,273,0,0,0,44810,0,26124),
(82562,'Commander, I will gather the troops from your garrison. Do not delay long, they will need your leadership on the battlefield.','',0,0,0,0,0,0,1,0,0,0,44811,0,26124),
(82563,'The Gordunni have been disconnected from the empire for too long. They really think a wall can stop us?','',0,0,0,0,0,0,1,0,0,0,45498,0,26124),
(82564,'There we go! Let\'s, shall we?','',0,0,0,0,0,0,1,0,0,0,45499,0,26124),
(82565,'','Let us hope Ga\'nar\'s fighting skills are better than his navigation skills.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82566,'How we survived this far is a mystery to me. You are quite the field commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82567,'','Hero, are you with us?',0,0,0,0,0,0,6,0,0,0,0,45609,26124),
(82568,'Fly with me, hero. We will assist them from above!','',0,0,0,0,0,0,1,0,6,0,44799,0,26124),
(82569,'The purifying light of the naaru is both our hammer AND shield.','',0,0,0,0,0,0,1,0,6,0,44800,0,26124),
(82570,'They are at the very temple gates - fly closer! Hurry!','',0,0,0,0,0,0,1,0,6,0,44801,0,26124),
(82571,'Circle back. We must clear the steps.','',0,0,0,0,0,0,1,0,6,0,44802,0,26124),
(82572,'Exarch Akama! Watch your flanks!','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(82573,'Thank you, old friend!','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(82574,'Never again will you orcish hordes darken the light of Karabor!','',0,0,0,0,0,0,1,0,6,0,44803,0,26124),
(82575,'Press onward. By the light of the naaru!','',0,0,0,0,0,0,1,0,6,0,44804,0,26124),
(82576,'Carry the light, brothers and sisters!','',0,0,0,0,0,0,1,0,6,0,44805,0,26124),
(82577,'We\'ve done all we can from up here...','',0,0,0,0,0,0,1,0,6,0,44806,0,26124),
(82578,'We did it! We broke the blockade!','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(82579,'We\'ve broken the main siege. We should meet with our forces on the ground.','',0,0,0,0,0,0,1,0,6,0,44822,0,26124),
(82580,'These are the last of our forces. We\'ll stay here to hold the temple gates.','',0,0,0,0,0,0,1,0,6,0,46723,0,26124),
(82581,'Champion, I need you to fight your way to the harbor.','',0,0,0,0,0,0,1,0,6,0,46724,0,26124),
(82582,'','I\'ll approach the enemy from the south. Light of the naaru, guide you.',0,0,0,0,0,0,1,0,6,0,0,45626,26124),
(82583,'','Champion, the naaru has come to aid us. We must defend it while it gathers power!',0,0,0,0,0,0,1,0,6,0,0,45628,26124),
(82584,'','We\'ve done it! Now to put an end to this assault...',0,0,0,0,0,0,1,0,6,0,0,45629,26124),
(82585,'Witness the TRUE power of the Iron Horde!','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(82586,'ENOUGH. Play time is over. I will deal with you myself.','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(82587,'','Up there! The fleet commander shows himself.',0,0,0,0,0,0,1,0,6,0,0,45630,26124),
(82588,'','What is the naaru doing?',0,0,0,0,0,0,6,0,6,0,0,45631,26124),
(82589,'It is done. Victory is ours!','',0,0,0,0,0,0,1,0,6,0,44823,0,26124),
(82590,'','Hero, you fought fearlessly. For that, please accept my thanks.',0,0,0,0,0,0,1,0,6,0,0,45632,26124),
(82591,'I am ready to teleport to the ship.','I am ready to teleport to the ship.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82592,'Greetings, savior of my people!','',0,0,0,0,0,0,1,0,6,0,45364,0,26124),
(82593,'If you are hearing this message, it means that I am no more - but Karabor is safe.','',0,0,0,0,0,0,1,0,6,0,45365,0,26124),
(82594,'I owe you an explanation.','',0,0,0,0,0,0,1,0,6,0,45366,0,26124),
(82595,'The naaru that we draenei revere are creatures of pure light.','',0,0,0,0,0,0,1,0,6,0,45367,0,26124),
(82596,'But if their death is near, they lose their essence, collapsing into creatures of shadow.','',0,0,0,0,0,0,1,0,6,0,45368,0,26124),
(82597,'When we draenei first arrived on this world, naaru accompanied us. But they could not stop our vessel from crashing.','',0,0,0,0,0,0,1,0,6,0,45369,0,26124),
(82598,'The \"Dark Star\" that appeared in the skies above Draenor that terrible night was no celestial body.','',0,0,0,0,0,0,1,0,6,0,45370,0,26124),
(82599,'It was a fallen naaru, ejected from our vessel in moments of panic and terror. Its name was K\'ara.','',0,0,0,0,0,0,1,0,6,0,45371,0,26124),
(82600,'What was once a creature of faith and beauty became a dark and hungering God, a living font of darkness.','',0,0,0,0,0,0,1,0,6,0,45372,0,26124),
(82601,'We owed K\'ara a great debt. Without the naaru\'s aid, my people would never have escaped our homeworld of Argus.','',0,0,0,0,0,0,1,0,6,0,45373,0,26124),
(82602,'To see K\'ara\'s transformation into shadow was a heavy burden to bear. When the naaru returned to us... I did what I had to do.','',0,0,0,0,0,0,1,0,6,0,45374,0,26124),
(82603,'Remember, life is the light, and light is life itself. They may be exchanged, but nothing is ever lost.','',0,0,0,0,0,0,1,0,6,0,45375,0,26124),
(82604,'','Kitty!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82605,'','Mr. Scratchy.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82606,'','Let\'s play, Scratch.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82607,'','Bad kitty.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82608,'','Come on, Mr. Scratch. Follow me.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82609,'','Mommy says you\'re a mean, ol\' kitty. But I don\'t think so.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82610,'','I wonder who\'s going to fly in.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82611,'Get back to work!','Get back to work!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82612,'','Now nothing will stop the Iron Horde!',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(82613,'The Rubble Pile is too close and %s throws over it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82614,'','I am sorry Garrosh, I have failed you.',0,0,0,0,0,0,0,0,0,0,0,43555,26124),
(82615,'','Now you have tasted the blade of the Dragonmaw.',0,0,0,0,0,0,1,0,0,0,0,43557,26124),
(82616,'','All who stand against the Iron Horde will fall.',0,0,0,0,0,0,1,0,0,0,0,43558,26124),
(82617,'','Are you dead or just pretending, coward?',0,0,0,0,0,0,1,0,0,0,0,43559,26124),
(82618,'','You will burn!',0,0,0,0,0,0,22,0,0,0,0,43560,26124),
(82619,'','Flames will consume you!',0,0,0,0,0,0,22,0,0,0,0,43561,26124),
(82620,'','My blade will end you!',0,0,0,0,0,0,22,0,0,0,0,43562,26124),
(82621,'','And now, you die!',0,0,0,0,0,0,22,0,0,0,0,43563,26124),
(82622,'','Have you come to get a front row seat for Stormwind\'s destruction?',0,0,0,0,0,0,25,0,0,0,0,43556,26124),
(82623,'It\'s not my fault. At least I have chicken.','',0,0,0,0,0,0,0,0,0,0,43252,0,26124),
(82624,'Leerooooy! Jeeeeeenkins!','',0,0,0,0,0,0,0,0,0,0,43251,0,26124),
(82625,'Check and see if it has my shoulders!','',0,0,0,0,0,0,0,0,0,0,43254,0,26124),
(82626,'My Devout shoulders! I knew they were here! My quest is complete.','',0,0,0,0,0,0,4,0,0,0,43255,0,26124),
(82627,'Now time for a little well deserved rest and relaxation! If you need me, I will be back at your garrison.','',0,0,0,0,0,0,1,0,0,0,43256,0,26124),
(82628,'Attuning','Attuning',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82629,'','Dey kill me huntas. You an me, we gonna have some fun wit dese wolves.',273,0,0,0,0,0,0,0,0,0,0,0,26124),
(82630,'','Kargora is out in de open. Time ta kill her an\' destroy dat shield, mon.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(82631,'I am a shaman of the old ways and I care not for the petty conflicts between clans.$b$bThroughout the years many clans have called this valley home, but it has always belonged to the elements first.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82632,'','Be sure to check back for more resources later, commander. The peons will keep putting them in this chest while you are away.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82633,'','Hush you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82634,'But, my lady, what about our reserve in the pon-','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82635,'You got it. One fully armed and operational army of motivated peons coming right up.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82636,'Chop, Chop boys, these rocks aren\'t gonna blow themselves up!','Chop, Chop boys, these rocks aren\'t gonna blow themselves up!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(82637,'No sleeping on the job fellas!','No sleeping on the job fellas!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(82638,'At this rate, we might never get paid for this job.  Speed it up!','At this rate, we might never get paid for this job.  Speed it up!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(82639,'Hmmm... This looks just about right.','Hmmm... This looks just about right.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(82640,'Nope, this won\'t do at all.','Nope, this won\'t do at all.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(82641,'','The Warsong descended on us by surprise. Tensions have been high in Nagrand since the formation of the Iron Horde, but we didn\'t expect this.$B$BLet\'s be clear. There are only two reasons that I\'m helping you, $r.$B$BFirst, your shadow hunter here saved my life, albeit for her own selfish reasons. I certainly don\'t expect to see another sunrise.$B$BSecond, if the Warsong manage to learn how to use Telaar\'s shield, there\'ll be no stopping them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82642,'I\'m going to enjoy this.','',0,0,0,0,0,0,1,0,0,0,45505,0,26124),
(82643,'','Bring me back any toads you find hibernating in the mud; I\'m sure one of them is my husband.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82644,'We need to destroy all of these wards before we can use the scroll of mass teleportation we prepared.','',0,0,0,0,0,0,1,0,0,26003,45496,0,26124),
(82645,'','I\'ll have to kiss each toad to break the spell on my husband.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82646,'Hey honey, I\'m back.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82647,'Oh not again... Loola, I\'m right here. I\'m not a toad... for Light\'s sake.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82648,'Varmint...','Varmint...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82649,'','I don\'t know... seems suspicious. Maybe I should kiss a couple toads just to be sure.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82650,'Masterful fighting! We need only take out Zulmork and Cromaug now.','',0,0,0,0,0,0,4,0,0,26005,0,0,26124),
(82651,'Now to find Cromaug and put an end to his miserable existence.','',0,0,0,0,0,0,4,0,0,26006,45506,0,26124),
(82652,'Two down, only Zulmork to go.','',0,0,0,0,0,0,4,0,0,26007,45508,0,26124),
(82653,'Masterful fighting! We need only take out Vorgrosh and Cromaug now.','',0,0,0,0,0,0,4,0,0,26008,0,0,26124),
(82654,'Now to find Cromaug and put an end to his miserable existence.','',0,0,0,0,0,0,4,0,0,26006,0,0,26124),
(82655,'Two down, only Vorgorsh to go.','',0,0,0,0,0,0,4,0,0,26009,0,0,26124),
(82656,'Masterful fighting! We need only take our Zulmork and Vorgorsh now.','',0,0,0,0,0,0,4,0,0,26010,0,0,26124),
(82657,'Now to find Vorgorsh and put an end to his miserable existence.','',0,0,0,0,0,0,4,0,0,26007,45507,0,26124),
(82658,'Two down, only Zulmork to go.','',0,0,0,0,0,0,4,0,0,26007,0,0,26124),
(82659,'Does this count for hazard pay?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82660,'','I\'ll move this impenetrable shield to Grommashar. There\'ll be no stopping the Warsong.',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(82661,'The air\'s thin up here...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82662,'The harder we work, the faster we profit.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82663,'That\'s the last of them. We won\'t have to worry about them interfering.','',0,0,0,0,0,0,4,0,0,26019,45509,0,26124),
(82664,'We should get the peons to help.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82665,'When\'s the beer break?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82666,'What\'s this pick made of? Lodestone?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82667,'Let\'s portal in slave labor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82668,'Anyone need Kafa ? 10 gold a bean.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82669,'We Rangari are trained to endure long vigils. I have not moved a single muscle for several hours.','We Rangari are trained to endure long vigils. I have not moved a single muscle for several hours.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82670,'The swamplighters seem especially upset tonight.','The swamplighters seem especially upset tonight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82671,'It looks like a number of Botani have started to move into the marsh.','It looks like a number of Botani have started to move into the marsh.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82672,'Granny Loola needs to be more careful. She has been wandering around the marsh kissing toads again.','Granny Loola needs to be more careful. She has been wandering around the marsh kissing toads again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82673,'Hydras are causing quite a bit of chaos. We will eventually need to take care of them to ensure our safety.','Hydras are causing quite a bit of chaos. We will eventually need to take care of them to ensure our safety.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82674,'','You will find the Rangari Hidden throughout the marsh. Report back after you have spoken to each of them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82675,'','Impressive. Thank you for reporting back to me so quickly, $n.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(82676,'Darkness... comes...','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(82677,'The shadows grow closer!','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(82678,'The Dark Star approaches...','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(82679,'The void will consume all...','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(82680,'Your forces are waiting to teleport in. Morkurk won\'t last long against all of us.','',0,0,0,0,0,0,1,0,0,0,45497,0,26124),
(82681,'%s |cFFFF0404|Hspell:162497|h[Fixates]|h|r on you!','%s |cFFFF0404|Hspell:162497|h[Fixates]|h|r on you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82682,'This sure is a lot of wood!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82683,'','I don\'t see many visitors all the way out here. It is so very nice to have a guest.$b$bWill you be staying for dinner?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82684,'Tank ya, mon. Dese Warsong be trixie an\' got de drop on ol\' J\'wan.','',0,0,0,0,0,0,0,1,4,0,0,0,26124),
(82685,'I\'m off ta Samedi\'s realm. I be seein\' ya.','',0,0,0,0,0,0,0,1,4,0,0,0,26124),
(82686,'I wish to know the truth about Dahaka. What do you know of her death?','I wish to know the truth about Dahaka. What do you know of her death?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82687,'WARLORD BLACKHAND','WARLORD BLACKHAND',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(82688,'LEADER OF THE BLACKROCK ORCS','LEADER OF THE BLACKROCK ORCS',0,0,0,0,0,0,0,0,7,0,0,0,26124),
(82689,'Intruders approach the keep! To arms!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82690,'For Morkurk! For the empire!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82691,'Now, where were we?','',0,0,0,0,0,0,6,0,0,0,45500,0,26124),
(82692,'','Durotan has grown into a great leader. In part, we have you to thank for that.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82693,'Orgrim\'s forces are formidable. He may have betrayed me, but I will not allow vengeance to force me into folly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82694,'I live to servo!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82695,'Almost anything can be fixed with a wrench and a good swingin\' arm.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82696,'Exploring my home world has proven more dangerous than I hoped.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82697,'I will stop at nothing to prevent Shattrath from falling again. Show these orcs no mercy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82698,'','I fear that Maraad is becoming consumed by his anger.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82699,'Depressing','Depressing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82700,'Acquiring targets!','',0,0,0,0,0,0,0,0,0,0,43742,0,26124),
(82701,'Correcting for air speed velocity.','',0,0,0,0,0,0,0,0,0,0,43743,0,26124),
(82702,'Adjusting for drag coefficient.','',0,0,0,0,0,0,0,0,0,0,43744,0,26124),
(82703,'All systems online! Fire!','',0,0,0,0,0,0,0,0,0,0,43737,0,26124),
(82704,'Right in the face!','',0,0,0,0,0,0,0,0,0,0,43741,0,26124),
(82705,'Ooo! Had ta hurt.','',0,0,0,0,0,0,0,0,0,0,45781,0,26124),
(82706,'','Gar\'rok is a fool! I would have shared this power with him!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82707,'','I will devour you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82708,'','Cower before my true power!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82709,'','So that poor fool Gar\'rok is dying and wishes to know the truth?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82710,'','I remember Dahaka. She was as you see me now...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82711,'I \'preciate da blessin\', mon. De Lord of de Grave smile upon ya.','',0,0,0,0,0,0,0,1,4,0,0,0,26124),
(82712,'Dey\'s someting in Oshu\'gun pullin\' on me soul. I gonna hava look.','',0,0,0,0,0,0,0,1,4,0,0,0,26124),
(82713,'','...until I drained the life from her wretched body!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82714,'What dis? I be dead!','',0,0,0,0,0,0,0,1,4,0,0,0,26124),
(82715,'I gonna haunt dese Warsong foreva. Stay away from de voodoo.','',0,0,0,0,0,0,0,1,4,0,0,0,26124),
(82716,'AHHHHHHHHHHHHHHHHHHHHHHHH!','AHHHHHHHHHHHHHHHHHHHHHHHH!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(82717,'','It be good ta see ya, Commanda. We need ta bless mah dead, stop de shield, and kill every Warsong in sight.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(82718,'','It\'s a simple matter, really. Just activate the perimeter crystals. Good thing the Warsong aren\'t too bright.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82719,'I stand with you, Gar\'rok. Rest with honor.','I stand with you, Gar\'rok. Rest with honor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82720,'I\'ll erase you from existence!','',0,0,0,0,0,0,0,0,0,0,45092,0,26124),
(82721,'Taste the power of the Empire!','',0,0,0,0,0,0,0,0,0,0,45093,0,26124),
(82722,'I\'ve had enough of your meddling.','',0,0,0,0,0,0,0,0,0,0,45094,0,26124),
(82723,'You are a fool for challenging me.','',0,0,0,0,0,0,0,0,0,0,45090,0,26124),
(82724,'I\'ll turn you to dust where you stand.','',0,0,0,0,0,0,0,0,0,0,45091,0,26124),
(82725,'You\'ll take the crystal from my quivering corpse, mortal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82726,'<Hooks have been run through his limbs, and a Shattered Hand insignia carved into his beak.$B$BIt seems the orcs found him first.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82727,'Quickly! We need a barrier to protect against his arcane annihilation!','Quickly! We need a barrier to protect against his arcane annihilation!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82728,'Nooooooooooooooooooo!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82729,'You wish to see the power of the Empire firsthand, little $r? So be it. I could use some entertainment.','',0,0,0,0,0,0,0,0,0,0,45089,0,26124),
(82730,'This body grows weary, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82731,'Your forces can handle any remaining ogres. Let\'s get out of here.','',0,0,0,0,0,0,1,0,0,0,45493,0,26124),
(82732,'I shall teleport us back.','',0,0,0,0,0,0,1,0,0,0,45491,0,26124),
(82733,'I bring the gift of death to the Alliance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82734,'The hour belongs to my enemy but I will return when the odds are in my favor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82735,'','It\'s time to see what I can do, to test my limits and break through!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82736,'','Defeat never bothered me anyway.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82737,'I\'m interested in fishing these savage lands.','I\'m interested in fishing these savage lands.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(82738,'We won\'t go down that easy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82739,'Down goes Van Rook eeeeeeeee....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82740,'Get the peons back to work.','Get the peons back to work.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82741,'','Gar\'rok, my mate...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82742,'','I have stood by you as a breath upon the wind.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82743,'','I have watched as you lived with honor and my love has not waned.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82744,'Tank schematics? Good thinkin\'. I\'ll look \'em over.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82745,'\'Ey, $n. You wanna join in the fun? Come get a hand on this here plunger.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82746,'Wait for it...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82747,'','Rise, husband. Your ancestors call...reunited we shall answer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82748,'','I want this shield surrounding all of Telaar, now.',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(82749,'','Find the intruder and that damned shadow hunter.',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(82750,'','All glory to the Warsong. All glory to the new warlord, Garrosh Hellscream!',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(82751,'','No prisoners. Kill outsiders on sight!',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(82752,'','Warsingers, more power. Once the draenei shield surrounds all of Telaar, no one can get in.',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(82753,'','We\'ve rid our homeland of the draenei. This is a glorious day for the Warsong.',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(82754,'','Faster! I intend to ride upon Wor\'var soon.',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(82755,'','Soon, we will crush our enemies. For the Warsong!',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(82757,'','Watch out, hero! We must protect K\'ara at all costs!',0,0,0,0,0,0,5,0,0,0,0,45627,26124),
(82758,'','Dey shield is up. Now be da time ta strike, $n. Kill Kargora and get de shield back down.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(82759,'These old eyes darken...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82760,'','Keilnei looks hopeful.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82761,'Dahaka, it is your call that I have waited so long to hear.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82762,'','We need to spread news of our victory. Take the fey dragon and meet me back at Embaari Village.',0,0,0,0,0,0,1,0,0,0,0,45634,26124),
(82763,'You are... but a pebble to us...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82764,'You were dead the moment you came here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82765,'NO! I cannot fall to the likes of you! I...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82766,'The fishing here is like nothing we have ever seen back home. How about helping us get this fishing operation off the ground?','The fishing here is like nothing we have ever seen back home. How about helping us get this fishing operation off the ground?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(82767,'You have my thanks once again, commander. These fiends were going to eat me alive. I will meet you back at the garrison.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82768,'%s goes into a frenzy at the sight of its master\'s death.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82769,'Beasts! Move your lazy hides!','Beasts! Move your lazy hides!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82770,'Indolent animals! Clear the hallway!','Indolent animals! Clear the hallway!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82771,'Move, brutes! These supplies need to get downstairs!','Move, brutes! These supplies need to get downstairs!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82772,'You will not enter the Iron Assembly!','You will not enter the Iron Assembly!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82773,'Dran\'ruk, as our guest, I give you the honor of the first battle.','',0,0,0,0,0,0,0,0,0,924,0,0,26124),
(82774,'Show us the might of the Warsong.','',0,0,0,0,0,0,0,0,0,924,0,0,26124),
(82775,'I need a break!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82776,'It\'s gonna blow! Up! After ya use it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82777,'The Burning Blade are known for their honor in battle. However, that does not mean they will not try to kill you on sight.','',0,0,0,0,0,0,0,7,0,0,46254,0,26124),
(82778,'We should have wiped Draenor clean of orcs when we arrived. None of this would ever have happened.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82779,'','The Iron Horde\'s machines must be disabled. Be careful, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82780,'','Those weapons can no longer be used against our people. Well done, $c.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82781,'It is done.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82782,'Only bring back pages that are legible!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82783,'Mmm... sleep...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82784,'Just a quick nap...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82785,'Remind me to clean the eyepiece when yer done. Thing hasn\'t been cleaned for ages.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82786,'I got \'er all fixed up for ya!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82787,'So tired!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82788,'You defeated her!  You have proven yourself to me and saved me from a life of toil at the forge.  I pledge my life to you $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82789,'Use your |TInterface\\Icons\\inv_scroll_02.blp:32|t |cFFFF0000|Hspell:162568|h[Scroll of Mass Teleportation]|h|r now!','',0,0,0,0,0,0,0,0,1,26091,0,0,26124),
(82790,'Thanks fer helpin\' out up in Telaar, $n.$B$BI had her under control, but it\'s always good ta have ya around, $g boyo:lass;.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(82791,'Ya ask me, I say we kill every orc on sight! Who cares \'bout which clans they belong ta?','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(82792,'More stone!','',0,0,0,0,0,0,0,0,0,0,42056,0,26124),
(82793,'Um... ROCKS!','',0,0,0,0,0,0,0,0,0,0,42057,0,26124),
(82794,'Yes... fire!','',0,0,0,0,0,0,0,0,0,0,42059,0,26124),
(82795,'More... fire?','',0,0,0,0,0,0,0,0,0,0,42060,0,26124),
(82796,'Who is dat?','',0,0,0,0,0,0,0,0,0,0,41932,0,26124),
(82797,'Oy! Dey fightin\'!','',0,0,0,0,0,0,0,0,0,0,41928,0,26124),
(82798,'Da King don\'t wanna see nobody! Go away!','',0,0,0,0,0,0,0,0,0,0,42086,0,26124),
(82799,'Fight \'em back den.','',0,0,0,0,0,0,0,0,0,0,42083,0,26124),
(82800,'Hear \'dis?','',0,0,0,0,0,0,0,0,0,0,42090,0,26124),
(82801,'Git out!','',0,0,0,0,0,0,0,0,0,0,42091,0,26124),
(82802,'Watch out!','',0,0,0,0,0,0,0,0,0,0,42092,0,26124),
(82803,'Boom!','',0,0,0,0,0,0,0,0,0,0,42093,0,26124),
(82804,'Heh heh... \'Dis gonna be gud.','',0,0,0,0,0,0,0,0,0,0,42085,0,26124),
(82805,'I got one, too!','',0,0,0,0,0,0,0,0,0,0,42087,0,26124),
(82806,'Dey so small.','',0,0,0,0,0,0,0,0,0,0,42088,0,26124),
(82807,'Hah! Hah! Hah!','',0,0,0,0,0,0,0,0,0,0,42089,0,26124),
(82808,'Oooowwwww....','',0,0,0,0,0,0,0,0,0,0,42084,0,26124),
(82809,'Crush dat!','',0,0,0,0,0,0,0,0,0,0,41937,0,26124),
(82810,'Feel \'dis!','',0,0,0,0,0,0,0,0,0,0,41938,0,26124),
(82811,'\'Dis gonna hurt.','',0,0,0,0,0,0,0,0,0,0,41939,0,26124),
(82812,'Ha hah... Smash!','',0,0,0,0,0,0,0,0,0,0,41940,0,26124),
(82813,'Let\'s have some fun!','',0,0,0,0,0,0,0,0,0,0,41931,0,26124),
(82814,'Dat one\'s dead.','',0,0,0,0,0,0,0,0,0,0,41934,0,26124),
(82815,'Dey squeal when ya smoosh \'em.','',0,0,0,0,0,0,0,0,0,0,41935,0,26124),
(82816,'Dat wus fun. Let\'s do it again!','',0,0,0,0,0,0,0,0,0,0,41936,0,26124),
(82817,'Ow... dat... hurts...','',0,0,0,0,0,0,0,0,0,0,41930,0,26124),
(82818,'Bored. Let\'s kill \'dem now.','',0,0,0,0,0,0,0,0,0,0,41929,0,26124),
(82819,'Oh yeah! Try to stay clear of the blast or you might get knocked around a bit.','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(82820,'These machines the Iron Horde has are unlike anything I had seen before their arrival.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(82821,'','Good luck, and be careful with the explosives.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(82822,'I can\'t wait to fix this thing up!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(82823,'Sorry if the Eye \'n\' Ear smells funny. Nothin\' to worry about!','',0,0,0,0,0,0,24,0,0,0,0,0,26124),
(82824,'Enjoy piloting the shredder! This is gonna be sweet!','',0,0,0,0,0,0,94,0,0,0,0,0,26124),
(82825,'Excellent. Let\'s grab that crystal and get out of here!','',0,0,0,0,0,0,1,0,0,0,45492,0,26124),
(82826,'When you are ready, we will follow you into Shattrath.','',0,0,0,0,0,0,1,0,0,0,44893,0,26124),
(82827,'Ornekka\'s hut is just down the road. Percy and I will be close behind.','',0,0,0,0,0,0,0,0,0,0,46023,0,26124),
(82828,'Let\'s finalize this building and put it to work!','Let\'s finalize this building and put it to work!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(82829,'','Being a mage does have its perks!',0,0,0,0,0,0,4,0,0,0,0,44023,26124),
(82830,'','How quaint. A wall! The Gordunni really have been disconnected from the empire for too long.',0,0,0,0,0,0,1,0,0,0,0,44021,26124),
(82831,'','This ought to get us over!',0,0,0,0,0,0,1,0,0,0,0,44022,26124),
(82832,'','Let\'s do this!',0,0,0,0,0,0,1,0,0,0,0,44028,26124),
(82833,'','We\'ve got to get rid of these wards. They\'re stopping us from using the scroll of mass teleportation we prepared!',0,0,0,0,0,0,1,0,0,26003,0,44019,26124),
(82834,'','Splendid! Glad we won\'t have to deal with them.',0,0,0,0,0,0,4,0,0,26114,0,44032,26124),
(82835,'','What a fight! Grab the crystal and let\'s get out of here.',0,0,0,0,0,0,1,0,0,0,0,44014,26124),
(82836,'','You\'re an incredible fighter! We\'ve only got Zulmork and Cromaug left now.',0,0,0,0,0,0,4,0,0,26115,0,0,26124),
(82837,'','We just need to find Cromaug now.',0,0,0,0,0,0,4,0,0,26116,0,44029,26124),
(82838,'','That only leaves one. Zulmork.',0,0,0,0,0,0,4,0,0,26117,0,44030,26124),
(82839,'','You\'re an incredible fighter! We\'ve only got Vorgrosh and Cromaug left now.',0,0,0,0,0,0,4,0,0,26118,0,0,26124),
(82840,'','You\'re an incredible fighter! We\'ve only got Zulmork and Vorgorsh left now.',0,0,0,0,0,0,4,0,0,26119,0,0,26124),
(82841,'','We just need to find Vorgorsh now.',0,0,0,0,0,0,4,0,0,26133,0,44031,26124),
(82842,'','Your forces are waiting for our teleport spell. Morkurk won\'t know what hit him.',0,0,0,0,0,0,1,0,0,0,0,44020,26124),
(82843,'','Let\'s get back to your outpost. Your forces can handle any remaining ogres.',0,0,0,0,0,0,1,0,0,0,0,44015,26124),
(82844,'','I\'ll teleport us back.',0,0,0,0,0,0,1,0,0,0,0,44016,26124),
(82845,'Filling','Filling',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82846,'A dark presence grows in the west. Gordawg, the great earthen fury, has gone missing.','',0,0,0,0,0,0,0,0,0,0,46513,0,26124),
(82847,'Furies of the Throne of Elements, we answer your call. How may we serve?','',0,0,0,0,0,0,1,0,4,0,46704,0,26124),
(82848,'Without a fury of earth upon the throne, the elemental bonds that hold this world together weaken.','',0,0,0,0,0,0,0,0,0,0,46094,0,26124),
(82849,'Gordawg must be found and returned to the throne.','',0,0,0,0,0,0,0,0,0,0,46095,0,26124),
(82850,'The balance has been disrupted. The Elemental Plateau has grown unstable and must be purged.','',0,0,0,0,0,0,0,0,0,0,43613,0,26124),
(82851,'If left imbalanced, the elements will rage across this valley tearing all life asunder.','',0,0,0,0,0,0,0,0,0,0,43614,0,26124),
(82852,'This is the Throne of Elements.$b$bYou stand in the presence of furies, $n. Here, the earth lives beneath your feet and the wind watches your every move.$b$bThis place is truly hallowed ground.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82853,'I am ready to commune with the furies.','I am ready to commune with the furies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82854,'%s emerges to haunt you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82855,'Your will is understood. Gordawg will be found and the balance restored.','',0,0,0,0,0,0,1,0,0,0,46705,0,26124),
(82856,'The fate of the elements rests in your hands.','',0,0,0,0,0,0,0,0,0,0,46514,0,26124),
(82857,'After everything I\'ve gone through who would have thought I\'d end up here?$b$bNothing quite like gutting ogres while sticking it to my pompous ass former bosses in the Iron Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82858,'Commander! When I heard the ogre\'s death cry I came as soon as I could. Did everything go well?','',0,0,0,0,0,0,0,0,4,0,45826,0,26124),
(82859,'Use your |TInterface\\Icons\\CREATUREPORTRAIT_GOBLIN_ROCKET.blp:32|t |cFFFF0000|Hspell:162896|h[Emergency Rocket Pack]|h|r now!','',0,0,0,0,0,0,0,0,1,26121,0,0,26124),
(82860,'Someone call for a lift?','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(82861,'Ugh! Get them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82862,'Rargh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82864,'If you return when you are wiser, I will regale you with tales of great heroics.$b$b(You must be at least level 91 to hear Shin\'s stories.)','If you return when you are wiser, I will regale you with tales of great heroics.$b$b(You must be at least level 91 to hear Shin\'s stories.)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82865,'Tell me of the Guardians of Mogu\'shan.','Tell me of the Guardians of Mogu\'shan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82866,'I sing of arms and a man who.... Oh, hm, you are not quite ready for this one. Return when you have experienced more of the world.$b$b(You must be at least level 91 to hear Han\'s stories.)','I sing of arms and a man who.... Oh, hm, you are not quite ready for this one. Return when you have experienced more of the world.$b$b(You must be at least level 91 to hear Han\'s stories.)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82867,'Not long ago, outsiders\' ships were cast upon the shores of Pandaria, bearing strife but also courage. Listen, and I will speak of how a deep shadow crept across Pandaria, and how brave heroes brought us a new dawn.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82868,'Tell me of the Vault of Mysteries.','Tell me of the Vault of Mysteries.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82869,'Tell me of the Dread Approach to the Heart of Fear.','Tell me of the Dread Approach to the Heart of Fear.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82870,'Tell me of the Nightmare of Shek\'zeer.','Tell me of the Nightmare of Shek\'zeer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82871,'Tell me of the Terrace of Endless Spring.','Tell me of the Terrace of Endless Spring.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82872,'','That only leaves one. Cromaug.',0,0,0,0,0,0,4,0,0,26116,0,0,26124),
(82873,'Tell me of the Last Stand of the Zandalari.','Tell me of the Last Stand of the Zandalari.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82874,'Tell me of the Forgotten Depths beneath the Throne of Thunder.','Tell me of the Forgotten Depths beneath the Throne of Thunder.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82875,'Tell me of the twisted mogu Halls of Flesh-Shaping.','Tell me of the twisted mogu Halls of Flesh-Shaping.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82876,'Tell me of Lei Shen\'s Pinnacle of Storms.','Tell me of Lei Shen\'s Pinnacle of Storms.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82877,'Tell me of the Vale of Eternal Sorrows that surrounds us.','Tell me of the Vale of Eternal Sorrows that surrounds us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82878,'Tell me of the war that came to the Gates of Retribution.','Tell me of the war that came to the Gates of Retribution.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82879,'Tell me of the Underhold beneath Orgrimmar.','Tell me of the Underhold beneath Orgrimmar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82880,'Tell me of the Downfall of Garrosh Hellscream.','Tell me of the Downfall of Garrosh Hellscream.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82881,'','We will not be able to pass through their gates. If you wish to try, I will wait for you here.',0,0,0,0,0,0,1,0,0,0,0,45666,26124),
(82882,'You are not one of the flock but you leave an impressive gift for the Raven Mother.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82883,'Just let me look at it!','',0,0,0,0,0,0,1,0,0,26151,0,0,26124),
(82884,'Not a chance. Malrok would skin us both if I let anyone near that thing.','',0,0,0,0,0,0,274,0,0,26151,0,0,26124),
(82885,'Bah! I\'m not afraid of that old cutthroat.','',0,0,0,0,0,0,14,0,0,26151,0,0,26124),
(82886,'You should be.','',0,0,0,0,0,0,397,0,0,26151,0,0,26124),
(82887,'Now, let\'s get moving!','',0,0,0,0,0,0,273,0,0,0,44850,0,26124),
(82888,'Only when you are attuned to the elements, will you be able to undertake the Ritual of Binding.','',0,0,0,0,0,0,0,0,0,0,46701,0,26124),
(82889,'When you are ready, I will commune with the great furies.','',0,0,0,0,0,0,0,0,0,0,46702,0,26124),
(82890,'Hurry, $c. The Cycle of Rebirth must take place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82891,'Although they are weakened, the Avatars upon the plateau are still mighty incarnations. Do not underestimate their strength.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82892,'The fire and thorns of the ember blossom have always reminded me of her strength and conviction.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(82893,'I have always suspected Challe, but I have not had the proof necessary to bring justice upon her.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(82894,'My time is at an end, but I die knowing that I have honored her memory.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82895,'You will find Gar\'rok high upon a cliff, overlooking the Throne of Elements.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82896,'','Return when you have weathered the sands of time further. You are not yet ready for this challenge.$b$b(You must be at least level 86 to access Dragon Soul Raid Finder on your own.)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82897,'','The sands of time have passed you by, but I can return you to the hour of twilight, when the Destroyer threatened to crush the world in his grasp.$b$b(Auridormi will allow you and your party members to access the Raid Finder version of Dragon Soul directly, without outside assistance.)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82898,'Take me to the Siege of Wyrmrest Temple.','Take me to the Siege of Wyrmrest Temple.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82899,'Bring me to the moments preceding the Fall of Deathwing.','Bring me to the moments preceding the Fall of Deathwing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82900,'You have for the moment earned my curiosity, yes. Tell me, what is it that brings you to us?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82901,'This is hardly a fitting camp for a member of the Gorian Empire.  If your Iron Horde wishes to remain allies you would do well to treat us well!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82902,'Water nourishes and sustains life, yet also has the power to cut through earth and rock.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82903,'Those who draw upon the strength of the earth will crush their enemies like gravel beneath their feet.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82904,'Break you!','',0,0,0,0,0,0,0,0,0,0,45792,0,26124),
(82905,'Butchered!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82906,'Me rip, you die!','',0,0,0,0,0,0,0,0,0,0,45791,0,26124),
(82907,'Those with burning conviction and fierce courage often attune themselves to the way of the flame.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82908,'The wind is the voice of the elements, it whispers gently upon the breeze and howls fiercely within the storm.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82909,'Join... us...','Join... us...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82910,'Bring you... to the Heart...','Bring you... to the Heart...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82911,'Please help... come to me...','Please help... come to me...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82912,'Borrowing','Borrowing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82913,'Be resolute brothers and sisters of the flock! Our faith is merely being tested by the Raven Mother!','',0,0,0,0,0,0,0,0,0,27082,0,0,26124),
(82914,'The Raven Mother sends these beasts to test our resolve! We must lift our voices to her with even more fervor!','',0,0,0,0,0,0,0,0,0,27082,0,0,26124),
(82915,'High Ravenspeaker, I have brought you this gift and wish an audience with you.','High Ravenspeaker, I have brought you this gift and wish an audience with you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82916,'May the Raven Mother\'s shadow be upon you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82917,'Blackhand wants to see these shipments in Talador. NOW!','',0,0,0,0,0,0,0,0,0,0,41709,0,26124),
(82918,'Blackhand won\'t tolerate any more delays.','',0,0,0,0,0,0,0,0,0,0,41670,0,26124),
(82919,'Track one.','',0,0,0,0,0,0,0,0,0,0,41697,0,26124),
(82920,'Live iron on track one!','',0,0,0,0,0,0,0,0,0,0,41698,0,26124),
(82921,'Track two!','',0,0,0,0,0,0,0,0,0,0,41699,0,26124),
(82922,'Incoming on two.','',0,0,0,0,0,0,0,0,0,0,41700,0,26124),
(82923,'Track three.','',0,0,0,0,0,0,0,0,0,0,41701,0,26124),
(82924,'Track three inbound.','',0,0,0,0,0,0,0,0,0,0,41702,0,26124),
(82925,'Track four!','',0,0,0,0,0,0,0,0,0,0,41703,0,26124),
(82926,'Inbound on four.','',0,0,0,0,0,0,0,0,0,0,41704,0,26124),
(82927,'Trains inbound!','',0,0,0,0,0,0,0,0,0,0,41683,0,26124),
(82928,'Double-time.','',0,0,0,0,0,0,0,0,0,0,41684,0,26124),
(82929,'Clear the tracks!','',0,0,0,0,0,0,0,0,0,0,41685,0,26124),
(82930,'Ah - reinforcements.','',0,0,0,0,0,0,0,0,0,0,41705,0,26124),
(82931,'Reinforcements, right on time.','',0,0,0,0,0,0,0,0,0,0,41706,0,26124),
(82932,'Troop train - inbound!','',0,0,0,0,0,0,0,0,0,0,41707,0,26124),
(82933,'Here they come - hit the grit, boys!','',0,0,0,0,0,0,0,0,0,0,41708,0,26124),
(82934,'The command car is here.','',0,0,0,0,0,0,0,0,0,0,41675,0,26124),
(82935,'Here comes the brass.','',0,0,0,0,0,0,0,0,0,0,41676,0,26124),
(82936,'Coming in hot.','',0,0,0,0,0,0,0,0,0,0,41672,0,26124),
(82937,'Here\'s my artillery.','',0,0,0,0,0,0,0,0,0,0,41673,0,26124),
(82938,'Here come the boomers!','',0,0,0,0,0,0,0,0,0,0,41674,0,26124),
(82939,'Redball incoming!','',0,0,0,0,0,0,0,0,0,0,41693,0,26124),
(82940,'Express, coming through.','',0,0,0,0,0,0,0,0,0,0,41694,0,26124),
(82941,'Send \'er on down the line!','',0,0,0,0,0,0,0,0,0,0,41695,0,26124),
(82942,'Faster! Bat the stack off her!','',0,0,0,0,0,0,0,0,0,0,41696,0,26124),
(82943,'End of the line.','',0,0,0,0,0,0,0,0,0,0,41688,0,26124),
(82944,'Terminated!','',0,0,0,0,0,0,0,0,0,0,41689,0,26124),
(82945,'Hah, flat as a copper piece.','',0,0,0,0,0,0,0,0,0,0,41690,0,26124),
(82946,'All aboard!','',0,0,0,0,0,0,0,0,0,0,41691,0,26124),
(82947,'Right. On. Time.','',0,0,0,0,0,0,0,0,0,0,41692,0,26124),
(82948,'Couldn\'t keep up, eh?','',0,0,0,0,0,0,0,0,0,0,41686,0,26124),
(82949,'Hah hah, this timetable is a killer!','',0,0,0,0,0,0,0,0,0,0,41687,0,26124),
(82950,'Let\'s step up the pace.','',0,0,0,0,0,0,0,0,0,0,41678,0,26124),
(82951,'You\'re just in time for the rush.','',0,0,0,0,0,0,0,0,0,0,41679,0,26124),
(82952,'I\'m not impressed. More trains are inbound!','',0,0,0,0,0,0,0,0,0,0,41680,0,26124),
(82953,'I have a schedule to keep!','',0,0,0,0,0,0,0,0,0,0,41681,0,26124),
(82954,'You are running out of time...','',0,0,0,0,0,0,0,0,0,0,41682,0,26124),
(82955,'It is the END of the LINE!','',0,0,0,0,0,0,0,0,0,0,41671,0,26124),
(82956,'That wasn\'t on the... schedule...','',0,0,0,0,0,0,0,0,0,0,41677,0,26124),
(82957,'|TInterface\\Icons\\spell_shadow_mindbomb.blp:20|t Siege Bombs are locked on to you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82958,'You worthless swine!  Get back to work.  We have a quota to make!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82959,'%s frenzies!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82960,'No! You gunna pay...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82961,'Now I grind yer soul!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82962,'Remember the lesson of the Scroll of The Broken Glass! You must shake before the might of the Raven Mother, do not swish around in life as if stirred to swirl in an eternal cycle! Through the Raven Mother\'s blessings the Flock will endure!','',0,0,0,0,0,0,0,0,0,27082,0,0,26124),
(82963,'You three! Follow $p onto the battlefield, and listen for my call.','',0,0,0,0,0,0,0,0,4,0,44885,0,26124),
(82964,'I have a plan.','',0,0,0,0,0,0,0,0,4,0,44886,0,26124),
(82965,'What was his plan?','',0,0,0,0,0,0,6,0,0,923,0,0,26124),
(82966,'','We are yours to command, $p.',0,0,0,0,0,0,1,0,0,0,0,44135,26124),
(82967,'Keep up your guard!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(82968,'Excellent form. Now, press the attack!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(82969,'And the Raven Mother spoke to me: Krikka, you are my dear child. You shall seek out my other wayward children and bring them back to the nest.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(82970,'When all of the flock have gathered the end shall come. The world will be torn asunder in a great catastrophe! Fear not, for the Raven Mother will save us!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(82971,'The Raven Mother will come from the heavens for her children. We will rise upon her great ebon wings to take our rightful place in her dark kingdom!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(82972,'Until that time comes give your praise to the Raven Mother! Look after her great kin for guidance and strength. May she cast her shadow upon you!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(82973,'Scribe! Did you get all of that?','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(82974,'Yes, High Ravenspeaker.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(82975,'Praise the Raven Mother!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(82976,'Who\'s there? Father... is that you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82977,'Please, come closer. It\'s so dark...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82978,'You are not my father... but... you have something of his...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82979,'|c00FFFF00|Hspell:178380|h[Kor\'lok, the Ogre King]|h|r awakens!','',0,0,0,0,0,0,0,0,0,30987,0,0,26124),
(82980,'|c00FFFF00|Hspell:178380|h[Kor\'lok, the Ogre King]|h|r slumbers once more.','',0,0,0,0,0,0,0,0,0,30987,0,0,26124),
(82981,'|c00FFFF00|Hspell:178380|h[Kor\'lok, the Ogre King]|h|r has elected to fight alongside the Alliance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82982,'|c00FFFF00|Hspell:178380|h[Kor\'lok, the Ogre King]|h|r has returned to his throne.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82983,'|c00FFFF00|Hspell:178380|h[Kor\'lok, the Ogre King]|h|r has elected to fight alongside the Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82984,'','%s cast |cFFFF0404|Hspell:155277|h[Blazing Radiance]|h|r on you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(82985,'Nooo! My... Soulgrinder...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82986,'We\'re eating riverbeast tonight, boys!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(82988,'By the Raven Mother\'s shadow! How can such such a slaughter have happened to us?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82989,'Hold to your faith scribe! Remember the lesson in the Scroll of the Dark Dawn, \"Ravens of the flock should stay together.\" Once the Raven Mother has returned and all her children are in the nest then we will truly be safe!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82990,'Of course sir.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82991,'Change of plans. Tear it down!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82992,'We\'re moving in a different direction. Tear this building down!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82993,'With the keystone, you will be able to pass through, alone. Once inside, deactivate their shields and we will join you.','',0,0,0,0,0,0,1,0,6,0,45396,0,26124),
(82994,'The caravan was led by a woman that looked like a wolf. I must admit, I\'m still getting used to you Azerothians. They left here just a few hours ago.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82995,'Commander, we found this draenei laying on the road outside our walls.','Commander, we found this draenei laying on the road outside our walls.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(82996,'','Hold on, Gidwin. Help is on the way.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82997,'Come, I take you to the High Ravenspeaker, yes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82998,'I should never have left Dalaran. What was I thinking?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(82999,'Have you seen any of the hidden artifacts?$B$BYou can find fragments all throughout Ashran. I hear killing the creatures in this the outskirts off of the Road of Glory has uncovered some recently. $B$BYou can give me any you find, and I\'ll distribute them to those who need them.','Have you seen any of the hidden artifacts?$B$BYou can find fragments all throughout Ashran. I hear killing the creatures in this the outskirts off of the Road of Glory has uncovered some recently. $B$BYou can give me any you find, and I\'ll distribute them to those who need them.',0,0,0,0,0,0,0,0,0,27639,0,0,26124),
(83000,'You have come to us at the perfect time, yes. Soon the Raven Mother herself will join us here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83001,'High Ravenspeaker, may the Raven Mother always keep you in her sacred shadow.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83002,'High Ravenspeaker, this outsider has come to us just as written! Yes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83003,'Mm? Need somethin\'?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83004,'Yes. I need you to help me operate that enormous tank.','Yes. I need you to help me operate that enormous tank.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83005,'','Take home a wondrous creature, never before seen on Draenor!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(83006,'','Come see Chelie\'s Mystical Menagerie! Gaze upon these exotic creatures from faraway lands!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(83007,'','Over here, hero, before they see us! Listen - they\'re talking about the Dark Star.',0,0,0,0,0,0,3,0,0,0,0,45640,26124),
(83008,'Can\'t... breathe... this foul smelling gas makes me even angrier!','',0,0,0,0,0,0,584,0,0,923,0,0,26124),
(83015,'','Sometimes I come here just to clear my head.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83016,'','My younger sister comes here to ponder the Light.  Muku and I make sure the orcs think twice about bothering her.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83017,'','Not too much longer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83018,'','Soon.  My meditation is almost complete.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83019,'','Just a few more minutes.  It\'s so peaceful here, it reminds me of... of the past.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83020,'','How long must we wait here?  It\'s not safe Amnumi.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83021,'','Are you going to kneel there forever?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83022,'','Please tell me you\'re ready to get back to the village! We\'ve been here for hours.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83023,'','I love my little kitty buddies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83024,'','Awww... Isn\'t Barbar the sweetest little kitty you\'ve ever seen?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83025,'','Dinah is a sweetheart. Just watch out for her claws, especially when she gets those crazy eyes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83026,'Them plant people are tryin\' to mulch me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83027,'Make for the road.','Make for the road.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83028,'Oh man... this war is crazy huh?$b$bI can\'t wait till it\'s over so I can go home and see my girls.$b$bWant to see some pictures?$b$bThis is my wife Ashley and my beautiful daughter Ella. Man, I miss them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83029,'','I think it would be best if you left, $r.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83030,'Well, well, a hero has come to our rescue. Be careful my friend, Gorgrond is no place for a hero.','',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(83031,'The way is clear.','The way is clear.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83032,'Ya don\'t have to tell me twice. I\'ll meet ya on the road.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83033,'Is it now? Well, I suppose we should abandon this post now that it has been compromised. The fara will not allow us to stay now that they have our scent.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(83034,'','Very well. I\'ll meet you there. Stay safe.',0,0,0,0,0,0,1,0,0,0,0,44137,26124),
(83035,'','Rest your weary bones for a spell?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(83036,'The spirit of Golmash is merciless. Let this gift of ancestral wind guide your hands.','',0,0,0,0,0,0,51,0,0,0,0,0,26124),
(83037,'If the pyres remain unlit, we too shall be drawn into the void and consumed.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83038,'','The echoes must be put down if the remaining spirits here are to rest.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83039,'For the glory of the Warsong, I will crush you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83040,'You dare approach the Giantslayer? I will cleave your head from your body!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83041,'Why do I feel no pain from your blows?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83042,'I see now... this is not my death. My death was long ago... and it was glorious!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83043,'','You wish to speak with Ared? I\'m sorry, his wounds were great and the illness too strong.',0,0,0,0,0,0,0,0,0,0,0,44680,26124),
(83044,'','Ared would not want to see me standing here crying like this. Let\'s go to this armory of yours.',0,0,0,0,0,0,0,0,4,0,0,44682,26124),
(83045,'','This looks amazing! If only Ared was alive to see this, he would be so proud!',0,0,0,0,0,0,0,0,4,0,0,44683,26124),
(83046,'','After everything we went through in escaping Shattrath his sickness finally caught up to him.$b$b My dear master, you will be missed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83047,'The docks. Run to the docks. Run. RUN!','',0,0,0,0,0,0,0,0,4,0,44874,0,26124),
(83048,'Come at me, Hellscream!','',0,0,0,0,0,0,0,0,4,0,45043,0,26124),
(83049,'Don\'t be a fool, Ga\'nar - Run! We will fight another day.','',0,0,0,0,0,0,0,0,4,0,46712,0,26124),
(83050,'','Look out!',0,0,0,0,0,0,0,0,4,0,0,45557,26124),
(83051,'','Keep moving. I see the ships ahead.',0,0,0,0,0,0,0,0,4,0,0,45558,26124),
(83052,'Their entire army is behind us.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(83053,'','Their entire army is behind us.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(83054,'Where now?','',0,0,0,0,0,0,0,0,4,0,44598,0,26124),
(83055,'No!  Let me see it... up close.  This has to be it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83056,'Head for the ships at the end of the road.','',0,0,0,0,0,0,0,0,4,0,44780,0,26124),
(83057,'This way. Go, go, go!','',0,0,0,0,0,0,0,0,4,0,44875,0,26124),
(83058,'There is no place to run, outsiders. This is MY world. We will find you!','',0,0,0,0,0,0,0,0,4,0,46503,0,26124),
(83059,'Dead... or used up.  I was so sure I would find what I needed here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83060,'We Frostwolves will be waiting for you, Hellscream! You, your ogres, your whole Iron Horde... You\'re as good as dead!','',0,0,0,0,0,0,0,0,4,0,45044,0,26124),
(83061,'Ignore his threats. We will go to Shadowmoon for reinforcements. This time, the draenei will triumph.','',0,0,0,0,0,0,0,0,4,0,44781,0,26124),
(83062,'Let\'s get underway then. We will need to build a stronghold if we hope to end the Iron Horde threat. And we\'re going to need help from the natives.','',0,0,0,0,0,0,0,0,6,0,44876,0,26124),
(83063,'To Shadowmoon!','',0,0,0,0,0,0,0,0,6,0,44877,0,26124),
(83064,'To the home of the Frostwolves!','',0,0,0,0,0,0,0,0,6,0,44878,0,26124),
(83065,'Come on, swines! Move like you signed up for this.','',0,0,0,0,0,0,0,0,0,0,46119,0,26124),
(83066,'They\'re here... GET UP!','',0,0,0,0,0,0,0,0,0,0,46117,0,26124),
(83070,'Formation, NOW!','',0,0,0,0,0,0,0,0,0,0,46118,0,26124),
(83071,'Wait, I feel it.  It is closer now.  Quickly! To me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83072,'','Everyone said I was foolish to collect all of these pets. Now look who\'s having the last laugh!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83073,'Exotic pets? These all seem pretty ordinary...','Exotic pets? These all seem pretty ordinary...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83074,'','Ordinary to you, perhaps. These yokels have never even seen a chicken before! I\'m going to make a fortune!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83075,'','Long ago, before the exodus aboard the Genedar, the Draenei made up just a small portion of the great Eredar civilization.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83076,'','Hakaam, please tell the class the name of the world that the Eredar once called home?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83077,'Um... Is it Eredor?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83078,'','Good guess, Hakaam, but the world is actually called Argus.',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(83079,'','The Eredar were a wise and powerful people. It was only through the deceitful corruption brought upon them by a fallen deity that led to their downfall.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83080,'','Now, Rastaak, could you tell me the name of the fallen deity who was responsible for corrupting the Eredar?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83081,'They need your help with Blackhand! I can get you there. Speak with me when you\'re ready.','',0,0,0,0,0,0,0,0,0,0,44900,0,26124),
(83082,'Sargeras, I think...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83083,'','Very good, child.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83084,'','When Sargeras approached the Eredar with his plans, our wise prophet saw through his lies and was able to save a small number of his people. Those few survivors are what make our civilization today.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83085,'','Who can tell me the name of the prophet that saved our people from corruption and led us to Draenor? How about you, Ariaana?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83086,'','You know, we make a pretty good team.$b$bAt first I just wanted to honor the memory of my master but now, I could really see working for you in the long term. Thanks for giving me a chance.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(83087,'','Velen, Miss Kierii.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83088,'','Indeed it is. Well done.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83089,'','However, even a prophet such as Velen could not hope to save the Draenei alone. In his quest he was aided by divine beings of light.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83090,'','Does anyone know the name of the beings that helped Velen save the Draenei people?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83091,'Ooh, I know this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83092,'','Go ahead, Hakaam.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83093,'The Naaru!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83094,'','Very good, Hakaam!',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(83095,'','Our people, the Draenei, were the only ones to escape the absolute corruption of Sargeras. The remaining Eredar were transformed into his dark minions.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83096,'','For extra credit, what do we call these minions, now that they are no longer recognizable as Eredar? Ariaana?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83097,'','The Man\'ari, Miss Kierii.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83098,'','Well, done Ariaana. That is correct.',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(83099,'','That concludes today\'s lesson. Be sure to study up for our next lesson on the wonders of our new homeworld of Draenor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83100,'','Stay frosty, men. You\'re going to teleport into the heart of ogre territory.',0,0,0,0,0,0,22,0,0,0,0,44034,26124),
(83101,'Keep your weapons hot. You\'re going to be teleporting straight into hell.','',0,0,0,0,0,0,22,0,0,0,45511,0,26124),
(83102,'','I\'ll move forward and scout their gates while you\'re taking out those catapults. Dioniss aca.',0,0,0,0,0,0,0,0,4,0,0,44677,26124),
(83103,'I\'m well aware that the fish are more plentiful in the upper pools. However, a real professional knows that the big ones prefer a spot with a little more cover. \n\nJust wait until Roluna sees what I can land down here in the weeds!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83104,'Is... is this the place?  Is it here?  Clear these creatures so I can think!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83105,'','Commander, over here!',0,0,0,0,0,0,0,0,4,0,0,44678,26124),
(83106,'','That magical barrier is too strong for our explosives to break open. I can\'t find a way to bring it down so we\'re going to have to sneak in around it.',0,0,0,0,0,0,0,0,4,0,0,44679,26124),
(83107,'','I\'ll go first and clear the way, meet me on the other side.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(83108,'I can\'t see...  I need a moment...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83109,'','Thank you for your aid, $n. I hope we meet again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83110,'Thank you for your assistance, $n. I am sure we will meet again in due time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83111,'Nyami awaits you in the western ritual chamber, champions.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83112,'Blacksmith Haephest creates some of the finest arms and armor in Shadowmoon. His wares will fetch a hefty sum in the Shattrath markets.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83113,'Pah, weak. Come back when you\'re stronger.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83114,'Yrel!?! Have you come back from the dead?','',0,0,0,0,0,0,3,0,0,0,45410,0,26124),
(83115,'','It will take more than some orcs to defeat me!',0,0,0,0,0,0,5,0,0,0,0,45664,26124),
(83116,'','Yrel! Is that you? You still owe me six copper!',0,0,0,0,0,0,3,0,0,0,0,43495,26124),
(83117,'','You still owe me six copper!',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(83118,'A trader with an empty cart, such a sad sight, no? \n\nIf only my partner Daruun would make up his mind so we could be on our way.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83119,'It\'s a lovely plant, yes? What color would be best suited for Shattrath\'s markets? \n\nDoes anyone even buy plants these days?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83120,'Yay! You\'re here!','',0,0,0,0,0,0,0,0,0,0,43934,0,26124),
(83121,'Hello stranger!','',0,0,0,0,0,0,0,0,0,0,46814,0,26124),
(83122,'','Yrel! She\'s come to save us!',0,0,0,0,0,0,0,0,0,0,0,42889,26124),
(83123,'','The stranger will help us!',0,0,0,0,0,0,0,0,0,0,0,42890,26124),
(83124,'She\'s back!','',0,0,0,0,0,0,0,0,0,0,46813,0,26124),
(83125,'A hero! A hero!','',0,0,0,0,0,0,0,0,0,0,43935,0,26124),
(83126,'','Good day, children! I\'ve brought a hero from a far away land to meet you.',0,0,0,0,0,0,3,0,0,0,0,45672,26124),
(83127,'That danged army should be here any minute. Let\'s move!','',0,0,0,0,0,0,0,0,4,0,45751,0,26124),
(83128,'SESK!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83129,'GORN!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83130,'Now that we\'re connected, we can create a portal directly to your garrison.','',0,0,0,0,0,0,1,0,0,0,45494,0,26124),
(83131,'Out in the field, weapon in hand, this is almost as fun as being at the forge!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83132,'Personnel evacuation system engaged.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(83137,'','Arbor Glen is in trouble. We had better go see if we can help.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83138,'','Nandaez might think he\'s clever for fishing the cover down below, but you can literally see the fish up here! Just look at them! What a fool he is.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83139,'I\'m okay.  We must keep moving.  It calls to us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83140,'Ha! I can see you are brave, but danger is my trade!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83141,'I live, I love, I slay, and I am content.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83142,'Ah, at last.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83143,'Argh!  I can\'t think with all these beasts shouting at me.  Stop their screaming!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83144,'Yrel is my brightest student, and at times the dimmest.$B$BShe is fierce in battle, but does not discipline herself through training.$B$BShe learns quickly, but cannot sit still enough to read a book.$B$BShe would much rather play with the village children than memorize the holy texts.$B$BIf only she would focus!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83145,'','By the light, what a battle!',0,0,0,0,0,0,4,0,4,0,0,44672,26124),
(83146,'Not men, not women, not beasts...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83147,'This I can trust.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83148,'For me, there is no spring.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83149,'','Prophet Velen is a great teacher, but he\'s too serious sometimes!$B$BI would much rather live out the holy principles than read about them in a book, don\'t you agree?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83150,'Nothing can hurt me! Only pain.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83151,'No man shall live in chains!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83152,'All that matters is that we few stood against many.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83153,'Very well. Come with me if you want to live.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83154,'','Lets do this!',0,0,0,0,0,0,1,0,4,0,0,44681,26124),
(83155,'Pilfering','Pilfering',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(83156,'Almost... almost there.  Just a little further.  Soon...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83157,'Enough talk!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83158,'','We\'re connected to the ley line network. Now we can create a portal directly to your garrison.',0,0,0,0,0,0,1,0,0,0,0,44017,26124),
(83159,'I\'ll... be... back...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83160,'','One thing we learned early from the Laughing Skull: podlings hate fire.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83161,'D\'kaan is coming with help.','D\'kaan is coming with help.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83162,'','Go without me, stranger. I will only slow you down. I shall hold my own until D\'kaan arrives.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83163,'Those foul creatures poison their spears. I keep an antidote but it will take time for my head to clear enough for me to move.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83164,'Here.  Yes here!  This is where I need to be.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83165,'Do not worry about me, my friend. I will await D\'kaan\'s arrival. Please, find the others.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83166,'Ah, the smell of victory. If only I had my sword with me... the things I could accomplish.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83167,'Together, we have crushed the slavers and brought upon them swift destruction. They who have taken everything from me. \n\nBut, I have one last thing to give. To be a part of something greater... I\'d forgotten what that feels like.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83168,'Yes, I see it now.  We must take this.  Take it back to our people and show them the way.  You have been very helpful. I think its time you joined us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83169,'I will not leave the fallen to the children of the genesaur. I will protect their bodies until D\'kaan arrives.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83170,'We fought as well as we could. But in the end, too many of my friends were lost.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83171,'If it bleeds, we can kill it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83172,'I\'m your worst nightmare!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83173,'Gidwin and I were out fishing when those things showed up and attacked us.$b$bWe would be dead for sure if wasn\'t for these draenei.$b$bI would have killed them myself but somebody needed to carry Gidwin back to camp... foolish little dwarf.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83174,'All hell\'s broken loose out there!','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(83175,'That monster\'s loose!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(83176,'You\'ve fallen right into my trap, \'commander\'. WARSONG ATTACK!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83177,'The botani are never this hostile.$b$bIf this keeps up we are going to have to venture into the bloom.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83178,'','Watch yourself, commander. Despite our victory, I have a bad feeling about this.',0,0,0,0,0,0,0,7,0,0,0,45573,26124),
(83179,'','I\'ll see you at the gates of Grommashar.',0,0,0,0,0,0,0,7,0,0,0,45572,26124),
(83180,'We need fish for the garrison, are you up to the task?','We need fish for the garrison, are you up to the task?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(83181,'Is that Frostwolf runt broken yet?','',0,0,0,0,0,0,0,0,0,26453,43608,0,26124),
(83182,'Tell that Frostwolf to keep shoveling! Hrah hrah hrah...','',0,0,0,0,0,0,0,0,0,26453,43609,0,26124),
(83183,'Don\'t let up on that Frostwolf pup. We must break his spirit.','',0,0,0,0,0,0,0,0,0,26453,43610,0,26124),
(83184,'Just get me free, stranger. I could kill a hundred of these pigs with this shovel alone.','',0,0,0,0,0,0,0,0,0,0,45045,0,26124),
(83185,'I wish that all we had to deal with in Nagrand were the Warsong and Highmaul.$B$BThere\'s a whole world of hurt on the other side of the river.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(83186,'Lead the charge against the genesaur, $n. The rangari will be right behind you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83187,'I\'m not sure we could have defeated that genesaur without you. Until we meet again, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83188,'Tread carefully, $c. This bloom is as deadly as it is beautiful.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83189,'Detonating the explosives... now!','Detonating the explosives... now!',0,0,0,0,0,0,0,0,0,0,45648,45648,26124),
(83190,'','We need to make sure no more travelers are attacked by the botani.$b$bArepheon just left with the others, if you leave now you should be able to catch up with him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83191,'How am I supposed to make any money if we just sit here all day?$b$bYeah, I know Gidwin looks a little sick, but I have a lot of merchandise I need to sell over here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83192,'In my profession I have learned that the nature of crystals is very much like that of the Draenei people. \n\nThe core material has amazing potential, but begins as rough and heavily flawed. It is only through careful shaping and nurturing that its potential can truly be reached. \n\nOnly then can it show its magnificent beauty and wondrous clarity.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83193,'A Ravenous Bloodmaw is released from its pit!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83194,'Commander! Shadowmoon forces are gathering up outside of the garrison. Our troops are in defensive positions and await your orders.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83195,'He\'s just getting started!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83196,'You are most entertaining but there\'s no stopping the Breakers!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83197,'Don\'t fail me, Bulgorg, you are worth a hundred ogre warriors!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83198,'Come and get it!','',0,0,0,0,0,0,0,0,0,0,41626,0,26124),
(83199,'I will break you!','',0,0,0,0,0,0,0,0,0,0,41627,0,26124),
(83200,'Time for the meat grinder!','',0,0,0,0,0,0,0,0,0,0,41628,0,26124),
(83201,'Give it to us raw... and wiggling!','',0,0,0,0,0,0,0,0,0,0,41629,0,26124),
(83202,'So juicy!','',0,0,0,0,0,0,0,0,0,0,41630,0,26124),
(83203,'That was close.','',0,0,0,0,0,0,0,0,4,0,44891,0,26124),
(83204,'There is no turning back. We press on, through the very jaws of the beast.','',0,0,0,0,0,0,0,0,4,0,44892,0,26124),
(83205,'Come here you scrawny grabbers!','',0,0,0,0,0,0,0,0,0,0,41631,0,26124),
(83206,'All crunch and no meat.','',0,0,0,0,0,0,0,0,0,0,41632,0,26124),
(83207,'Gonna make a Pale stew.','',0,0,0,0,0,0,0,0,0,0,41633,0,26124),
(83208,'Lanky, gamey, little runts!','',0,0,0,0,0,0,0,0,0,0,41634,0,26124),
(83209,'Get off! You ain\'t worth eatin\'.','',0,0,0,0,0,0,0,0,0,0,41635,0,26124),
(83210,'Just a slice off the top.','',0,0,0,0,0,0,0,0,0,0,41636,0,26124),
(83211,'Get the blood flowing!','',0,0,0,0,0,0,0,0,0,0,41637,0,26124),
(83212,'Smash!','',0,0,0,0,0,0,0,0,0,0,41638,0,26124),
(83213,'Looks like meat\'s back on the menu!','',0,0,0,0,0,0,0,0,0,0,41639,0,26124),
(83214,'Let me browse your wares.','Let me browse your wares.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83215,'Thanks for the rescue pal! I knew we shouldn\'t have tried to get out on a half-built zeppelin.','Thanks for the rescue pal! I knew we shouldn\'t have tried to get out on a half-built zeppelin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83216,'If you are okay, I\'m ready to go.','If you are okay, I\'m ready to go.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83217,'You are finally here.  This place stinks, let\'s be done with this mess quickly...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83218,'Thanks! I\'m so glad to see a face that\'s not been covered in fungus!','Thanks! I\'m so glad to see a face that\'s not been covered in fungus!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83219,'Thanks for the rescue pal. That crash was rough.','Thanks for the rescue pal. That crash was rough.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83220,'That was a REAAAAAALY nice explosion! Wish I wasn\'t in the middle of it.','That was a REAAAAAALY nice explosion! Wish I wasn\'t in the middle of it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83221,'I think I broke every bone in my body. I think I even broke some bones that we don\'t have names for!','I think I broke every bone in my body. I think I even broke some bones that we don\'t have names for!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83222,'The Heart of the Mountain goes berserk!','The Heart of the Mountain goes berserk!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(83223,'The wind will destroy you!','The wind will destroy you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83224,'The Warsong will eradicate you!','The Warsong will eradicate you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83225,'I will scatter your bones upon the wind!','I will scatter your bones upon the wind!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83226,'I will be your death!','I will be your death!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83227,'I am the storm!','I am the storm!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83228,'The Warsong will prevail!','The Warsong will prevail!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83229,'Victory or death!','Victory or death!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83230,'My power will destroy you!','My power will destroy you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83231,'Draw upon the void! Feel the power seep into your bones!','Draw upon the void! Feel the power seep into your bones!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83232,'Drink of the void my brothers and sisters! The Warsong grow stronger!','Drink of the void my brothers and sisters! The Warsong grow stronger!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83233,'With this dark gift, none shall challenge the superiority of our clan!','With this dark gift, none shall challenge the superiority of our clan!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83234,'Unleash the void! None shall resist the might of the Warsong!','Unleash the void! None shall resist the might of the Warsong!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83235,'There is no glory in weakness! Bathe yourself in this dark power and become mighty!','There is no glory in weakness! Bathe yourself in this dark power and become mighty!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83236,'Let this dark gift flow through your veins! Feel it grow within you!','Let this dark gift flow through your veins! Feel it grow within you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83237,'As mortals, you are weak! Drink of the void and become endowed with power!','As mortals, you are weak! Drink of the void and become endowed with power!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83238,'Harness the power of the void! Call upon this gift and realize your true destiny!','Harness the power of the void! Call upon this gift and realize your true destiny!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83239,'Oh good, it\'s you, commander. This \'thing\' is ready for you.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(83240,'Usurper! I AM the Talon King!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83241,'The blood of Sethe is a gift, not a curse! We will show them all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83242,'Terokk...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83243,'The Sethekk will rise!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83244,'For Talon King Ikiss!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83245,'I have seen the other side...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83246,'Rukhmar has forsaken us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83247,'Your entrails will make a fine tribute to Sethe.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83248,'Ikiss demands sacrifice!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83249,'We live for Sethe now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83250,'Stealth and speed are our greatest friends.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83251,'My rangari are the absolute best at laying traps and creating camouflaged illusions. The Shadowmoon have no idea we are here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83252,'','The Shadowmoon are an ancient clan with untold knowledge of this world and its secrets. If only we had access to their records!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83253,'','There is one thing you must learn about us draenei.$B$BWe will learn everything we can from others, and use it to our advantage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83254,'Kneel before the Sethekk!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83255,'Who knew the draenei held such... delicious treasures in their temple?','',0,0,0,0,0,0,0,0,6,0,44423,0,26124),
(83256,'Do you dare challenge me, defenders of Auchindoun?!','',0,0,0,0,0,0,0,0,6,0,44424,0,26124),
(83257,'Sever my bonds... and the portal falls...','',0,0,0,0,0,0,0,0,6,0,45331,0,26124),
(83258,'Such decadence... it will all burn.','',0,0,0,0,0,0,0,0,6,0,44425,0,26124),
(83259,'Yes... Yes!','',0,0,0,0,0,0,0,0,4,0,45332,0,26124),
(83260,'Grommash will pay for his arrogance.','',0,0,0,0,0,0,0,0,4,0,45334,0,26124),
(83261,'The legion comes for you.... We will feast on these souls.','',0,0,0,0,0,0,0,0,6,0,44426,0,26124),
(83262,'Do not delay, mortal. I can feel the life-essence of your armies fading. There will be time for regret later...','',0,0,0,0,0,0,0,0,6,0,45335,0,26124),
(83263,'We will meet again... $n.','',0,0,0,0,0,0,0,0,6,0,45336,0,26124),
(83264,'Gul\'dan, such foolishness. This gift... so much more than you could ever know....','',0,0,0,0,0,0,0,0,6,0,44427,0,26124),
(83265,'Long have I waited...','',0,0,0,0,0,0,0,0,6,0,44428,0,26124),
(83266,'...hungered... to be more...','',0,0,0,0,0,0,0,0,6,0,44429,0,26124),
(83267,'On one side, our enemy, the Warsong. On the other, our more ancient foe, the ogres of Highmaul.$B$BWe must bring both to justice. We must rid Nagrand of their very presence.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(83268,'And now, all shall bow before me!','',0,0,0,0,0,0,0,0,6,0,44430,0,26124),
(83269,'This power... you will be the first to know it.','',0,0,0,0,0,0,0,0,0,0,44418,0,26124),
(83270,'Iruun... You battled demons in life... in death, your power will feed them!','',0,0,0,0,0,0,0,0,0,0,44420,0,26124),
(83271,'Joraa, paragon of Order - I shall twist your soul to power destruction!','',0,0,0,0,0,0,0,0,0,0,44421,0,26124),
(83272,'Elum... a liftetime of healing, now you shall fuel disease and decay!','',0,0,0,0,0,0,0,0,0,0,44422,0,26124),
(83273,'All will fall before me.','',0,0,0,0,0,0,0,0,0,0,44431,0,26124),
(83274,'Fear my name.','',0,0,0,0,0,0,0,0,0,0,44432,0,26124),
(83275,'Destruction!','',0,0,0,0,0,0,0,0,0,0,44433,0,26124),
(83276,'Wither away!','',0,0,0,0,0,0,0,0,0,0,44434,0,26124),
(83277,'I... become... something greater!','',0,0,0,0,0,0,0,0,0,0,44435,0,26124),
(83278,'Die!','',0,0,0,0,0,0,0,0,0,0,44436,0,26124),
(83279,'Your demise awaits.','',0,0,0,0,0,0,0,0,0,0,44437,0,26124),
(83280,'Quickly, now!','',0,0,0,0,0,0,0,0,0,0,44438,0,26124),
(83281,'More! I... need... more!','',0,0,0,0,0,0,0,0,0,0,44439,0,26124),
(83282,'The bonds weaken. Freedom will be mine!','',0,0,0,0,0,0,0,0,4,0,45333,0,26124),
(83283,'','Go\'el thinks that I should have stayed back on Azeroth with our children. I have put him in his place on that matter.$B$BMy Go\'el and I have been through much together. Now is not the time for us to be apart.$B$BTo be back in Nagrand after all of this time. It\'s a bit overwhelming for us both.$B$BI just wish for us to both get back to our little ones once this is all over.',274,273,0,0,0,0,0,0,0,0,0,0,26124),
(83284,'','Earth Mother willing, you and the shadow hunters will expel the Warsong from Telaar.',0,0,0,0,0,0,0,1,0,0,0,46198,26124),
(83285,'Everyone - find cover!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(83286,'We must defeat the ogres, the Burning Blade, and the orcs at Lok-rath. Then, we\'ll be ready to move on Grommashar.','',0,0,0,0,0,0,0,1,0,0,46390,0,26124),
(83287,'As if all we had to deal with in Nagrand were the Warsong and Highmaul.$B$BThere\'s a whole world of pain on the other side of that river.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(83288,'Commander.$B$BWe\'ve secured Lok-rath and the Warsong.$B$BI await your orders.','',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(83289,'All hell\'s broken loose out there!','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(83290,'Watch yourself, commander. Despite our victory, the Warsong are never to be underestimated.','',0,0,0,0,0,0,0,1,0,0,45268,0,26124),
(83291,'Oh good, it\'s you, commander. This \'thing\' is ready for you.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(83292,'I\'ll see you at the gates of Grommashar.','',0,0,0,0,0,0,0,1,0,0,45269,0,26124),
(83293,'That monster\'s loose!','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(83294,'I will slice the flesh from your bones!','',0,0,0,0,0,0,0,0,0,0,43887,0,26124),
(83295,'We will feed your corpse to the Kaliri!','',0,0,0,0,0,0,0,0,0,0,43889,0,26124),
(83296,'Move faster ground dweller!','',0,0,0,0,0,0,0,0,0,0,43890,0,26124),
(83297,'Your doom is coming.','',0,0,0,0,0,0,0,0,0,0,43891,0,26124),
(83298,'You cannot outrun the wind!','',0,0,0,0,0,0,0,0,0,0,43892,0,26124),
(83299,'I... perish....','',0,0,0,0,0,0,0,0,0,0,43888,0,26124),
(83300,'As long as we rule the skies, none shall oppose us!','',0,0,0,0,0,0,0,0,0,0,43893,0,26124),
(83301,'We will cast you down like the mongrels you are!','',0,0,0,0,0,0,0,0,0,0,45176,0,26124),
(83302,'You are unfit to rise to this height, return to your filth below!','',0,0,0,0,0,0,0,0,0,0,45178,0,26124),
(83303,'What funny little birds, you have no wings!','',0,0,0,0,0,0,0,0,0,0,45179,0,26124),
(83304,'Cast them down, let the scavengers below feed on their pulp!','',0,0,0,0,0,0,0,0,0,0,45180,0,26124),
(83305,'Servants, protect your master!','',0,0,0,0,0,0,0,0,0,0,45181,0,26124),
(83306,'We will always... soar....','',0,0,0,0,0,0,0,0,0,0,45177,0,26124),
(83307,'As long as we rule the skies you will always be beneath us!','',0,0,0,0,0,0,0,0,0,0,45183,0,26124),
(83308,'Behold the might of the Arakkoa!','',0,0,0,0,0,0,0,0,0,0,45182,0,26124),
(83309,'','My brothers and sisters will be watching from the shadows, we will aid you when we can.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83310,'','Those poor riverbeasts...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83311,'','Thaelin? What are you doing here?',0,0,0,0,0,0,0,0,0,0,0,45565,26124),
(83312,'','Giving away our position. The fool brought a genesaur down on us.',0,0,0,0,0,0,0,0,4,0,0,46542,26124),
(83313,'It\'s okay, Gidwin. You are going to be okay.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83314,'','Please let me know if there is anything I can do to repay you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83315,'','Take care if you plan on roaming the plains, traveler. The windfang packs have been particularly dangerous of late.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83316,'Kill them. Kill them all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83317,'Those plants are lucky I don\'t have my shears on me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83318,'Seek me out inside Blademoon Bloom. It is time we put a stop to this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83319,'I heard Zorkra and her followers barely made it into Talador before orcs got them.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83320,'Perhaps we should have thrown our lot in with Ikiss...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83321,'All this talk about poison and paralysis is not helping my sales. Gidwin can be so rude sometimes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83322,'Hey you wanna buy some stingtail eye drops before you head out? They are great for reading at night and almost never cause blindness.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83323,'Nonsense! I\'d sooner die than bend knee to that lunatic.','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(83324,'What do we have here? A hero? Gorgrond is no place for heroes, my friend.','',0,0,0,0,0,0,0,0,4,0,46251,0,26124),
(83325,'What then? Join Iskar\'s fool crusade and stand up to the Adherents?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83326,'We\'d only get in his way.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83327,'We are unaccustomed to having so many with us. Our rangari are trained to be self sufficient, and are used to surviving for long periods of time in the wilds.$b$bYou may find some of us prefer it that way.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83328,'MASTER! I COME FOR YOU!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83329,'For now, we disappear. Disappear and survive.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83330,'It is unwise to draw the attention of the genesaur and their fara. In their eyes, we are nothing more than plant food.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83331,'Graaagh! KAHL...  AHK... RAAHHHH!','',0,0,0,0,0,0,0,0,0,0,45416,0,26124),
(83332,'Ah, an exotic traveler from the north. Come, have a look at my wares!','',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(83333,'Don\'t take too long, I don\'t share skulls!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83334,'Test 1 | Caster: %s  | Target: $n','Test 1 | Caster: %s  | Target: $n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(83335,'How exactly did you get to Draenor, anyway?','How exactly did you get to Draenor, anyway?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83336,'','Oh, that? I may have hitched a ride through your garrison portal. \n\nThey should probably guard those things better, come to think of it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83338,'They fired on Veil Akraz!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(83339,'It\'s just... gone...','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(83340,'Come, we must go!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(83341,'','I have lost both my sister and my mentor, and yet I know there are others who suffer even more greatly.$B$BIt is for them that I must go on.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83342,'','Prophet Velen was truly a great teacher. I will remember him, always.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83343,'','There is so much to do. We must stay focused.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83344,'','I am very thankful that you are here, $n. You are one of the few people I know I can trust.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83345,'Trade is the backbone of Embaari Village. As a representative of the tradesmen of our village, it falls under my responsibility to keep these operations running smoothly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83346,'','The skies hold untold wonders, waiting to be discovered. Our researchers study the stars and beyond over at the observatory. \n\nIf you have time, traveler, I would recommend paying it a visit.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83347,'','The ranchers of Embaari raise elekk and talbuk to supply Shattrath, as well as many of the smaller draenei villages. \n\nIf you wish to review the livestock, you can find their ranches along the outskirts of the village.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83348,'','Don\'t mind all of the noise and dust, commander.$B$BWhat can I get for you? Food? Drink? A place to put your feet up?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83349,'Blessings of the naaru upon you, my friend.$B$BIs it not strange to be back on Draenor? I would not have guessed in a million years I would have ever returned.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(83350,'This is test 1','This is test 1',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83351,'This is test 2','This is test 2',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83352,'I must break you!','I must break you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83353,'Garrison - Event - Orc Attack Sub Stage Begin','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83354,'... the Lost Spirit fades away.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83355,'An |c00FFFF00|Hspell:178360|h[Alliance Captain]|h|r has joined the battle','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83356,'A |c00FFFF00|Hspell:178361|h[Horde Captain]|h|r has joined the battle','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83357,'Do not lose faith Alliance; I shall aid you in your cause.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83358,'','When I get my hands on him...',0,0,0,0,0,0,0,7,0,0,0,45574,26124),
(83359,'','We\'ll see who gets the last laugh.',0,0,0,0,0,0,0,7,0,0,0,45571,26124),
(83360,'Sorcerous fool! I alone am the key to this portal.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83361,'Set me free, or your precious world will burn.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83362,'Gul\'dan! Khadgar - they\'ve got Gul\'dan here.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83363,'He\'s in chains.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83364,'Good! That\'s where he belongs. Don\'t listen to a word he says.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83365,'Ah, Skyreach. I have not been this close to her in many years.','',0,0,0,0,0,0,0,0,0,0,46004,0,26124),
(83366,'The High Sage will be well protected. We can fly no closer.','',0,0,0,0,0,0,0,0,0,0,46005,0,26124),
(83367,'Destroy their false sun, that we may meet again in the shade.','',0,0,0,0,0,0,0,0,0,0,46006,0,26124),
(83368,'The bones do not lie. They showed me fire, and then nothing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83369,'The omens are clear! Skettis is doomed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83370,'Abominations, all of us! Throw yourselves before Rukhmar and beg for the cleansing fire!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83371,'Rukhmar! Hear your forlorn children! Pray, rid us of this wretched form!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83372,'What the? Aaaaaaaaah!','',0,0,0,0,0,0,0,7,0,0,45740,0,26124),
(83373,'Goblin! You better be finishing up.  Railmaster Rocketspark is almost finished patching up the Grimrail.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83374,'Come on ya runts.  I don\'t need anyone else breathin\' down my neck!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83375,'Do you feel that?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83376,'You are wrong. It is the Burning Blade that is not worthy of me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83377,'Leave nothing alive!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83378,'Eat, you stupid creatures. Eat it all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83379,'Stop rolling around that thing and just eat it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83380,'Sergeant, a gronn is marching toward our garrison. It\'ll be here in minutes!','Sergeant, a gronn is marching toward our garrison. It\'ll be here in minutes!',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(83381,'Rise up, Frostwolves! Avenge the murder of your Chieftain, and reclaim the honor of our clan!','',0,0,0,0,0,0,0,0,0,0,46711,0,26124),
(83382,'Come, my brothers and sisters! We will bring justice to our dead by sending these orcs to the darkness beyond!','',0,0,0,0,0,0,0,0,0,0,44596,0,26124),
(83383,'A revenge assault, eh?  Scout, sound the Call to Arms! Get the peons inside!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83384,'If there\'s a gronn coming, then goren won\'t be far. Quick, get the peons to high ground!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83385,'We don\'t have much more time! Everyone, get to high ground!','',0,0,0,0,0,0,0,0,0,924,44887,0,26124),
(83386,'Free at last.','',0,0,0,0,0,0,0,0,4,0,45040,0,26124),
(83387,'I swear, by the spirit of my father, I WILL MAKE THEM PAY.','',0,0,0,0,0,0,0,0,4,0,45041,0,26124),
(83388,'Gah!','',0,0,0,0,0,0,0,0,4,0,44888,0,26124),
(83389,'Ugh - oh!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(83390,'Well now.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(83391,'I\'d say we made an impact.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(83392,'The fungus keeps creeping in but we have to keep burning it back. It\'s like celebrating Fire Festival every day; I love it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83393,'You here to register for fire duty or what?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83394,'Eleena\'s a fine lass. I\'m sure she\'s just takin\' her sweet time gettin\' a proper look-see at them ogres.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(83395,'','Wolf-$g brother:sister;, it is always good to see you.$B$BIt has been many years since last I strode the great Land of Winds. Yet some things, never change.$B$BThe Warsong are as dishonorable as ever, and now worse with this Garrosh Hellscream as their new warlord.$B$BI understand you have had trouble with him before. We shall have to see about dealing with him.$B$BBringing Garrosh to justice is just about the only thing that Thrall talks about.',273,0,0,0,0,0,0,0,0,0,0,0,26124),
(83396,'That was really mean, $n. I\'m not sure I can forgive you and Yrel after that.$B$B...$B$BAh, who am I kidding? I guess I had it coming.$B$BIt was a pretty good prank, don\'t ya think?$B$BI need to figure out what the next one\'s going to be. She\'ll never see it coming.','',274,6,396,0,1000,0,0,0,0,0,0,0,26124),
(83397,'There she goes...','',0,0,0,0,0,0,0,0,0,0,45702,0,26124),
(83398,'...wait for it...','',0,0,0,0,0,0,0,0,0,0,45703,0,26124),
(83399,'KER-PLOW!','',0,0,0,0,0,0,0,0,0,0,45704,0,26124),
(83400,'Ohhh, weren\'t that the prettiest thing?','',0,0,0,0,0,0,0,0,0,0,45705,0,26124),
(83401,'The Laughing Skull fighting technique is a delicate balance of stabbing your enemy until long after they are dead while also laughing in a fine tuned insulting fashion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83402,'You do the fightin\' and I\'ll do the fixin\'. Now let\'s get up on that tank!','',0,0,0,0,0,0,0,0,0,0,46831,0,26124),
(83403,'Look back there. I think we can climb up those chains.','',0,0,0,0,0,0,0,0,0,0,46838,0,26124),
(83404,'I see the controls!','',0,0,0,0,0,0,0,0,0,0,46839,0,26124),
(83405,'Orcs off the starboard bow!','',0,0,0,0,0,0,0,0,0,0,46840,0,26124),
(83406,'Looks like we arrived just in time.','',0,0,0,0,0,0,0,0,4,0,44889,0,26124),
(83407,'$n! Hop inta that turret and keep \'em away!','',0,0,0,0,0,0,0,0,0,0,46841,0,26124),
(83408,'How do I get materials?','How do I get materials?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83409,'Hey... I\'m a versatile goblin. I can build out of almost anything. You find treasure lying about or some extra mean monsters with a nice hoard of loot, chances are there will be extra materials I can use.$b$bI\'ve been hearing of all sorts of rare beasts around here that might stash materials you could use. Not to mention I\'m pretty sure Lady Sena skimmed off the top and stashed those extra materials around your garrison somewhere.$b$bGet out and explore.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83410,'WARSONG, WE RIDE.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83411,'Eh? A traveler? It\'s a dangerous time to be in Skettis, you know.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83412,'\"Shadows gather...\"','\"Shadows gather...\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83413,'Azik sent you to me for answers, and I promise you will have them.$B$BBut for now, we need to escape.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83414,'COMMANDER $N. WARRIDERS ATTACK!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83415,'You want to know why my people flee Arak? Look outside. Our own kin fear and revile us for this curse!','',0,0,0,0,0,0,0,0,0,0,46021,0,26124),
(83416,'The mountain of Oshu\'gun stands tall above the valley of Nagrand. This place is sacred among all orc clans, but now the Warsong have claimed it as their own.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83417,'Make it look real, or they are going to flood this place with ogres.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83418,'You win this round. But when we fight in the \"real\" arena, I will end you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83419,'You... were going to save me? Ha.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(83420,'Are you a savior or a challenger?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83421,'Challenge the gladiator.','Challenge the gladiator.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(83422,'Tell me of the defense of Lion\'s Landing.','Tell me of the defense of Lion\'s Landing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83423,'Tell me of the defense of Domination Point.','Tell me of the defense of Domination Point.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83424,'To arms! To your posts! And look beneath you. They\'ll come from below....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83425,'Tell Akaani I will be ready for her signal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83426,'I see Akaani left a mark on your cloths. So the time has finally come to make our escape?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83427,'Fight me. Do not let the ogres witness weakness.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83428,'Enough! This not real arena.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83429,'Dead dead dead.','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(83430,'I wait for Akaani\'s signal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83431,'Free at last! Join me in the ogre mound when you are done, and we shall slay the ogre chieftain together.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(83432,'You saved my life. Now I must repay the debt. I will teach you tricks and ways of fighting only seen in the darkest corners of Skettis.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83433,'That\'s a cute child\'s toy of a weapon you got there. Let\'s see what it can do against my orcish fists!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83434,'I laugh in the face of my own defeat!','',11,0,0,0,0,0,0,0,0,0,0,0,26124),
(83435,'You call that a fighting style? Ha ha ha!','',11,0,0,0,0,0,0,0,1,0,0,0,26124),
(83436,'Oh, and yes, I suppose I can wait for her signal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83437,'Run back to Akaani and tell her I will rip this place apart, burn it to the ground, and laugh at the corpses of all the ogres!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83438,'You know what I hate about the arena?$b$bThe losers!$b$bThey keep dying so quickly. It is embarrassing. I barely have time to finish giving them a proper smile...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83439,'Got one!','Got one!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83442,'...get back!','...get back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83443,'Profession Building Blueprint','Profession Building Blueprint',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83444,'I am ready, commander. Where would you like to start?','I am ready, commander. Where would you like to start?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83445,'I am... THE SHOVELER!','I am... THE SHOVELER!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83446,'A %s cries out incoherently and rushes up the ramp.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83447,'Back to the dust with you!','',0,0,0,0,0,0,0,0,1,0,46564,0,26124),
(83448,'<The creature is still alive, but is completely incapacitated by the Iron Horde\'s chains.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83449,'Release the creature from its chains.','Release the creature from its chains.',0,0,0,0,0,0,432,0,0,0,0,0,26124),
(83452,'','Wait! Spare me and I will tell you what you want to know!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83453,'Go on.','Go on.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83455,'','The Breaker Artifact. We have located it! It is deep within Ogron Grotto west of this location. We were going to take it from them before this camp was destroyed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83456,'Get out of my sight.','Get out of my sight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83457,'We must go.  I am so close now...  I must find it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83458,'What a nightmare!','Thank you - the whole mine is overrun!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83459,'It\'s the resonance crystal - it\'s driving them crazy!','It\'s the resonance crystal - it\'s driving them crazy!',0,0,0,0,0,0,0,0,0,26456,0,0,26124),
(83460,'Garrison - Attack - 1.1 Complete','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83461,'What is this? A new challenger? We will enjoy watching you consumed by my little pet.','',0,0,0,0,0,0,0,0,0,26572,0,0,26124),
(83462,'','The Archmage tells me that Garrosh set all of these events in motion. He was a criminal from your world, yes? I have never seen the orcish idea of \'justice\' before.$B$BI wish I could say it\'s over, but this war is only beginning. Grommash\'s Iron Horde continues to grow stronger. My people will never be safe so long as his foundries continue churning out their terrible weapons. We draenei were not ready for this fight, but we must be prepared to finish it.$B$BThere are shadows before us - but only because the light is at our back.',1,274,0,0,0,0,0,0,0,0,0,0,26124),
(83463,'A meager victory. Let us see how you fair against my personal ogron.','',0,0,0,0,0,0,0,0,0,26573,0,0,26124),
(83464,'','We march on your order, commander. Garrosh and his forces await.',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(83465,'Such impudence. I will see you consumed by my favorite pet.','',0,0,0,0,0,0,0,0,0,26574,0,0,26124),
(83466,'That was my favorite ravager. You filthy savage. I will kill you with my own bare hands!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83467,'Our forces are massed. We\'re ready to strike.$B$BLead the way, commander. Let us be rid of this Garrosh Hellscream once and for all.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(83468,'Garrosh came out of nowhere, and manipulated the clans as you would play a drum. It is good that he is finished.$B$BBut, the damage is already done. It\'s like I don\'t recognize my own people anymore. Grommash Hellscream has turned family and friends alike against one another, and it has to stop. We must dismantle his war machine: First by taking out his ogre allies, then by demolishing the Blackrock Foundry.$B$BAfter that, we will bring Hellscream himself to justice. Just as we\'ve seen today.','',274,273,0,0,0,0,0,0,0,0,0,0,26124),
(83469,'It looks as if the Iron Horde attempted to fuse a cannon with this gronn\'s spine.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83470,'Molten helms don\'t fit on gronn as well as one might think.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83471,'A cannon for an arm and explosives on the back? Seriously?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83472,'<Thrall is deep in thought and doesn\'t appear to want to speak at the moment.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83473,'','My husband takes all the responsibility of the world on his shoulders, as if it\'s his burden alone. He needs to learn that we all have a role to play.$B$BFriend, this whole world remains in turmoil. The elements cry out. They are being tortured in the depths of the Blackrock foundry, and Gul\'dan is still at large.$B$BSo much remains to be done... and the stronghold you\'ve built is the key. Never hesitate to call on me for aid. This is my fight, too.',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(83474,'Take me to my base in Talador.','Take me to my base in Talador.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83475,'Note the information.','Note the information.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83476,'Split up and meet back at Akaani and Kash\'drakor. Kor\'gall\'s axe is yours for the taking, $p.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83477,'The storied Gorehowl rests here planted firmly in the grassy hill. At your touch, a barely-noticeable power vibrates from the axe.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83478,'Remember the Battle at the Stones of Prophecy.','Remember the Battle at the Stones of Prophecy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83479,'Take cover within the shield!','',0,0,0,0,0,0,0,0,0,0,45104,0,26124),
(83480,'Hold \'em off! I\'ll get this Iron Star activated!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83481,'I got this!  Keep them off me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83482,'Prepare for a little goblin ingenuity!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83483,'Ow ow ow! You\'ll pay for that!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83484,'Pinchwhistle Point is a nice town as long as you don\'t mind the heat and the oppressive humidity.$b$bOk, as long as you don\'t mind the heat, the oppressive humidity, and the infectious fungus.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83485,'Pinchwhistle Point can\'t be lost, I got to find a cure!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83488,'The mines are overrun!','The mines are overrun!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83503,'Commander, reinforcements from the arcane sanctum have arrived!','',0,0,0,0,0,0,71,0,0,0,45103,0,26124),
(83504,'Gather Shelly\'s report.','Gather Shelly\'s report.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83505,'','Where did Pippers go? Little guys keeps stealing my supplies.$b$bOops! I meant to check in with Baros, we have just been really busy.$b$bThis forest is almost out of wood... I need to get a logging operation together. I\'ll send a full report to Baros as soon as possible.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83506,'Take cover within the shield!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83511,'I need a flight to the border of Nagrand.','I need a flight to the border of Nagrand.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83512,'A Hungry Goren ate his fill! (-$9168w)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83513,'Goren engorged: $9169w (-$9170w)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83514,'Strike!','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(83515,'Heavy strike!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(83516,'Now, block!','',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(83517,'Nice work, soldiers.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83518,'I tire of this. Begone!','',0,0,0,0,0,0,0,0,0,0,42016,0,26124),
(83519,'I... am... king...','',0,0,0,0,0,0,0,0,0,0,42017,0,26124),
(83520,'I will meet you at the base of the fortress.','',0,0,0,0,0,0,1,0,0,0,45512,0,26124),
(83521,'Learn your place.','',0,0,0,0,0,0,0,0,0,0,42031,0,26124),
(83522,'Your presence bores me.','',0,0,0,0,0,0,0,0,0,0,42032,0,26124),
(83523,'My power knows no limit!','',0,0,0,0,0,0,0,0,0,0,42033,0,26124),
(83524,'You have earned my wrath!','',0,0,0,0,0,0,0,0,0,0,42034,0,26124),
(83525,'The arcane bends to my will, as shall you!','',0,0,0,0,0,0,0,0,0,0,42035,0,26124),
(83526,'Come, see the error of your ways.','',0,0,0,0,0,0,0,0,0,0,42036,0,26124),
(83527,'Begone from my sight.','',0,0,0,0,0,0,0,0,0,0,42037,0,26124),
(83528,'I command the arcane!','',0,0,0,0,0,0,0,0,0,0,42038,0,26124),
(83529,'','I\'ll meet you at the base of the fortress.',0,0,0,0,0,0,1,0,0,0,0,44035,26124),
(83530,'Imperator Gor\'vidus laughs.','',0,0,0,0,0,0,0,0,0,0,42030,0,26124),
(83531,'','Oh, come on! It\'s just a little spider!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83532,'','This thing keeps wriggling! Could you please come give me a hand?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83533,'','I could use a little help over here, Hostus.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83534,'A little spider?! Do you have eyes?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83535,'Nope nope nope nope!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83536,'Well, I could use a lot less spiders over here, Liveia!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83537,'We were lookin\' for something to help fight goren and I got separated.$b$bThen these botani lads showed up and just started feeding me berries, mead, honey.$b$bI swear I\'ve gained twenty pounds at least since I got here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83538,'They are fattening you up. Your friends have been turned into mulch to feed the botani seedlings.','They are fattening you up. Your friends have been turned into mulch to feed the botani seedlings.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83539,'A rescue? At last! I\'m never eatin\' another fruit again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83540,'Thank you, kindly. I shall notify you of my results later.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83541,'D\'kaan, where are those parts? I\'ve only got two hands over here.','',0,0,0,0,0,0,5,7,0,0,45739,0,26124),
(83542,'Good luck, commander.','',0,0,0,0,0,0,1,7,0,0,46255,0,26124),
(83543,'','What do you want, initiate?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83544,'','Only the strong prevail.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83545,'','We ARE the chosen race.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83546,'','The Sargerei will reclaim what is rightfully ours.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83547,'Reporting for duty!','Reporting for duty!',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(83548,'This is where they\'ll attack first...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83549,'','Welcome, initiate. Those who wish to join our order must prove themselves. You look... promising.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83550,'As long as you hold the shaman stone, we will be able to speak with one another through the power of the elements.$b$bThe stone also grants me the ability to see the world through your eyes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83551,'They\'re coming...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83552,'<Laanda lowers his voice to a whisper.>$B$BYou have the appearance of an ally, but I cannot speak long. I am working to infiltrate the ranks of the Sargerei, to take down their system from within. So far, no one suspects my identity.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83553,'The rain falls on Shadowmoon.','The rain falls on Shadowmoon.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(83554,'Modera sends her regards.','Modera sends her regards.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(83555,'The elekk is nature\'s most noble animal.','The elekk is nature\'s most noble animal.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(83556,'The portal has taken me into the Twisting Nether, Farseer.','The portal has taken me into the Twisting Nether, Farseer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83557,'You think so, do you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(83558,'Who is that?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(83559,'I see. I am prepared for stormy weather.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(83560,'','I did it, Papa! I made a wish!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83561,'What is this $r doing here?','What is this $r doing here?',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(83562,'Finalizing','Finalizing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(83563,'$p saved what is left of Aruuna. Let $Ghim:her; leave in peace.','',0,0,0,0,0,0,1,0,0,23504,0,0,26124),
(83564,'Collapsing Portal','Collapsing Portal',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83565,'The day has come for true retribution!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83566,'What you think you doing?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83567,'It dinna matter where we are. SI:7 is gonna get the job done.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83568,'For da Empire!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83569,'Die puny thing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83570,'I must find a way to enhance my performance for next time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83571,'At last practice is over! Taste dis axe!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83572,'Reglakk says no complications... you is a complication.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83573,'But my research!  Reglakk... needs... it...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83574,'Me guess me need more practice...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83575,'I hope you Horde scum enjoy a shield to the face!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83576,'Hmm, I never had this problem in Alterac Valley.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83577,'Your magic is powerless here!','',0,0,0,0,0,0,0,0,0,0,41970,0,26124),
(83578,'I am finished with you!','',0,0,0,0,0,0,0,0,0,0,41971,0,26124),
(83579,'Impossible...','',0,0,0,0,0,0,0,0,0,0,41972,0,26124),
(83580,'AHHHHHH!','',0,0,0,0,0,0,0,0,0,0,41973,0,26124),
(83581,'YOU WILL PAY FOR THIS!!!','',0,0,0,0,0,0,0,0,0,0,41974,0,26124),
(83582,'AHHHHHH!','',0,0,0,0,0,0,0,0,0,0,41975,0,26124),
(83583,'For... The Highmaul...','',0,0,0,0,0,0,0,0,0,0,41976,0,26124),
(83584,'You dare enter these halls?','',0,0,0,0,0,0,0,0,0,0,41977,0,26124),
(83585,'Worthless.','',0,0,0,0,0,0,0,0,0,0,41978,0,26124),
(83586,'Weak.','',0,0,0,0,0,0,0,0,0,0,41979,0,26124),
(83587,'Your efforts were in vain!','',0,0,0,0,0,0,0,0,0,0,41980,0,26124),
(83588,'Silence!','',0,0,0,0,0,0,0,0,0,0,41981,0,26124),
(83589,'Quiet!','',0,0,0,0,0,0,0,0,0,0,41982,0,26124),
(83590,'Broken.','',0,0,0,0,0,0,0,0,0,0,41983,0,26124),
(83591,'The Highmaul will end you.','',0,0,0,0,0,0,0,0,0,0,41984,0,26124),
(83592,'Your attacks are weak!','',0,0,0,0,0,0,0,0,0,0,41985,0,26124),
(83593,'I will crush you!','',0,0,0,0,0,0,0,0,0,0,41986,0,26124),
(83594,'I will tear you in half!','',0,0,0,0,0,0,0,0,0,0,41987,0,26124),
(83595,'I am unstoppable.','',0,0,0,0,0,0,0,0,0,0,41988,0,26124),
(83596,'Get out!','',0,0,0,0,0,0,0,0,0,0,41989,0,26124),
(83597,'I am in control here.','',0,0,0,0,0,0,0,0,0,0,41968,0,26124),
(83598,'We control the flow of power here.','',0,0,0,0,0,0,0,0,0,0,41969,0,26124),
(83599,'That can\'t be all of them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83600,'Spread out! Protect the structures!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83601,'You can\'t stop me!  I will make our Breakers even stronger!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83602,'Someone else will finish my research!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83603,'I will eat your Wind magic all up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83604,'No... wind magic?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83605,'I would like to place a work order.','I would like to place a work order.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(83606,'I will send you dogs to the void!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83607,'My return will be your end.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83608,'I have laid out a list of available missions for your forces on the command table for you.$B$BI will relay any orders to your garrison for your convenience, commander.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(83609,'I\'ve spread out all available missions for your forces on the command table.$B$BSay the word and I will send a courier to your garrison immediately with your will.','',113,0,0,0,0,0,0,0,0,0,0,0,26124),
(83610,'Are you prepared to meet Azeroth\'s greatest champion?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83611,'Not goren one!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(83612,'Abuuuguu!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83613,'Bwaaaah!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83614,'Guuughfff!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83615,'Ooohuuffuu!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83616,'Eeeeeerk!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83617,'Yeeeooowwwch!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83618,'The goren mumbles something incomprehensible to you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83619,'I\'ve been watching you, $r. Come closer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83620,'I foresee... your defeat.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83621,'Look into the maw of your demise!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83622,'I see everything... your time on this world ends here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83623,'','Not a moment too soon, this ogre bastion is much busier than it used to be.$b$bLet\'s do something about it, yes?',595,0,0,0,0,0,0,0,0,0,0,0,26124),
(83624,'Engorged seeds and roots within the pool are digging into the corpse of Lera, feeding on the remains.','Engorged seeds and roots within the pool are digging into the corpse of Lera, feeding on the remains.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83625,'','This area is back to normal thanks to you!',595,0,0,0,0,0,0,0,0,0,0,0,26124),
(83626,'It will be a pleasure to break you.','',0,0,0,0,0,0,0,0,2,0,42068,0,26124),
(83627,'First, I break your spirit, then, I sell your future.','',0,0,0,0,0,0,0,0,2,0,42065,0,26124),
(83628,'Burn!','',0,0,0,0,0,0,0,0,2,0,42071,0,26124),
(83629,'You will be slaves to the slag!','',0,0,0,0,0,0,0,0,2,0,42072,0,26124),
(83630,'The elements hear me and obey!','',0,0,0,0,0,0,0,0,2,0,42073,0,26124),
(83631,'Your charred remains will make a fine example.','',0,0,0,0,0,0,0,0,2,0,42074,0,26124),
(83632,'Fool!','',0,0,0,0,0,0,0,0,2,0,42069,0,26124),
(83633,'You will learn to obey!','',0,0,0,0,0,0,0,0,2,0,42070,0,26124),
(83634,'You will never... be... free...','',0,0,0,0,0,0,0,0,2,0,42067,0,26124),
(83635,'Bring them to me alive, Roltall. They will fetch an excellent price.','',0,0,0,0,0,0,0,0,6,0,42066,0,26124),
(83636,'A stunned look of surprise is frozen on the dead face of this dwarf.','A stunned look of surprise is frozen on the dead face of this dwarf.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83637,'This dwarf appears to have gained a lot of weight prior to his death.','This dwarf appears to have gained a lot of weight prior to his death.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83638,'C\'mon people step it up here. We got hungry bellies to fill.','',0,0,0,0,0,0,0,0,0,0,44534,0,26124),
(83639,'Dat new kind! Da Keeper keep it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83640,'Sir, commander, sir!$b$bOn Maraad\'s orders I rounded up a bunch of lackeys - erm - quality skilled labor. Say the word and we\'ll get this caravan to Elodor and secure some food.','',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(83641,'Very good, Zipfizzle. Move out.','Very good, Zipfizzle. Move out.',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(83642,'Hey! You don\'t belong here! Vexaar, tell Laanda that we have a traitor in our midst.','Hey! You don\'t belong here! Vexaar, tell Laanda that we have a traitor in our midst.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83643,'You are all annoying.  I\'m going to go get some sleep.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(83644,'You heard the commander. MOVE OUT! Go, go!','',0,0,0,0,0,0,5,0,0,0,44535,0,26124),
(83645,'Commander! You have built a most impressive garrison. I am eager to see your men in action.','',0,0,0,0,0,0,0,0,0,0,46714,0,26124),
(83646,'We were fools to follow Velen\'s path. Socrethar is our true leader!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83647,'Hey buddy, let\'s talk about what you saw.','Hey buddy, let\'s talk about what you saw.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83648,'You\'ll find our Alliance is full of surprises, Exarch. This is the commander I told you about.','',0,0,0,0,0,0,0,0,0,0,44788,0,26124),
(83649,'We will escort this caravan and meet you in Elodor, commander.','',0,0,0,0,0,0,0,0,0,0,44789,0,26124),
(83650,'Ah. The little one is the taskmaster.','',0,0,0,0,0,0,0,0,0,0,46713,0,26124),
(83651,'I will rend the mortal flesh from your bones and feast upon your soul!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83652,'Talking won\'t do any good. I know what I saw!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83653,'In fact, I\'ll take care of you myself. Zamaya is bound to promote me for this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83654,'The draenei will not go free!','The draenei will not go free!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83655,'You\'ll rot with the draenei.','You\'ll rot with the draenei.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83656,'You\'ll free the draenei over my corpse, whelp.','You\'ll free the draenei over my corpse, whelp.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83657,'Did you see the size of that thing? It\'s even bigger than I thought.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83658,'It took Talakuu. The fool got too close to the entrance of the cave.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83659,'I don\'t even think it\'s possible to kill it. I mean, it\'s made of dirt and stone.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83660,'You go first.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83661,'Yeah ummm... I just need to adjust my gloves really quick.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83662,'It seems like most of the earthfuries are coming out of this cave.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83663,'By the Light! You truly are a great champion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83664,'Orgrim! Brother, what have you done?','',0,0,0,0,0,0,5,0,0,0,45293,0,26124),
(83665,'Brother? You have allied with enemy invaders, Durotan. You\'ve chosen your side.','',0,0,0,0,0,0,6,0,0,0,46082,0,26124),
(83666,'Can you not see it? The Iron Horde will destroy Draenor!','',0,0,0,0,0,0,396,0,0,0,45294,0,26124),
(83667,'My visions show me otherwise.','',0,0,0,0,0,0,1,0,0,0,46083,0,26124),
(83668,'Commander, I will meet you ahead. I must join Draka.','',0,0,0,0,0,0,396,0,0,0,45296,0,26124),
(83669,'With me!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(83670,'Maybe those orcs have something on that boat we can use?... besides tooth piercing devices.','',0,0,0,0,0,0,0,0,0,0,43529,0,26124),
(83671,'Eww, some of these supplies are really water logged and... sticky? These will get the job done, but truly, this is disgusting.','',0,0,0,0,0,0,0,0,0,0,43530,0,26124),
(83672,'So this is the traitor in our midst.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83673,'Join me, brother. Velen was wrong to refuse the Burning Legion\'s gifts.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83674,'Never. Will you take Kil\'jaeden\'s blessing, only to give up your soul?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(83675,'Fool, your soul will be mine, even in death! Shattrath, Auchindoun, Elodor, Karabor... ALL shall fall!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83676,'Zamaya, finish him!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83677,'','With pleasure, master.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83678,'Auuughhhh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(83679,'Auughh auuuughhhhh!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(83680,'How am I supposed to do this all myself!? Keep it together, Baros... keep it together.','',0,0,0,0,0,0,0,0,0,0,43532,0,26124),
(83681,'I feel so relieved. Maybe I can actually do some stargazing tonight. That would be a nice change of pace.','',0,0,0,0,0,0,0,0,0,0,43533,0,26124),
(83682,'','Baros is looking for me?$b$bI\'ve been right here with my crew the whole time... Poor guy is so busy he\'s losing it.$b$bAlright, break time is over.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83683,'Time to get back to work.','Time to get back to work.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83684,'See reason, old friend. You must stop this lunacy!','',0,0,0,0,0,0,274,0,0,0,45295,0,26124),
(83685,'War is not a time for reason. Lieutenant, deal with them.','',0,0,0,0,0,0,25,0,0,0,46084,0,26124),
(83686,'Over...*cough*... here...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83687,'The barracks should take the men no time to complete at all.  Follow me, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83688,'The Iron Horde have landed upon these shores. It is our task to make them regret it.','',0,0,0,0,0,0,396,0,4,0,0,0,26124),
(83689,'','Our presence here has gone undetected by the Sargerei so far. Let\'s keep it that way.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83690,'A |cFFFF0404%s|r comes lurking from the depths!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83691,'','What little supplies we had upon arrival are quickly being used up for the needs of the refugees. \n\nI hope we are able to leave here soon, lest we become stranded in Auchindoun just like them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83692,'Most of our other buildings are going to take quite a while longer to construct.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83693,'The barracks looks fantastic. You should go check in with Maraad. I\'m going to hang out here and admire my handy work.','',0,0,0,0,0,0,0,0,0,0,43524,0,26124),
(83694,'We must depart for Oshu\'gun with great haste.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83695,'The Warsong shaman have turned their backs on the old ways, $n. Do what must be done.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83696,'Be wary of the ritual leaders. The source of their power is corrupt, but it is by no means weak.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83697,'Once you have entered the Twisting Nether, use the shaman stone to contact me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83698,'Be careful, commander. If these pale orcs are real, who knows what powers they possess.','',0,0,0,0,0,0,0,0,0,0,44817,0,26124),
(83699,'How the Pale have learned to enslave the elements, I do not know, but it cannot be allowed to continue.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83700,'These pale orcs sound dangerous. Hopefully this is the last we see of them.','',0,0,0,0,0,0,0,0,0,0,44818,0,26124),
(83701,'Find this Greyseer and bury him back into the mud from where he came!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83702,'Make your way to the ancestral grounds and discover the cause of the disturbance there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83703,'The monsters of the void grow in strength and number. They must be stopped.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83704,'Countless portals are opening from within the Twisting Nether. They must be closed with all haste!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83705,'','How ye doin?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83706,'Show no mercy when facing Invalidus, such kindness will not be returned to you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83707,'','How ye doin\'? Welcome to the finest garage on Draenor.$b$bIf you need repair work on your trike, hot rod, shredder, flamethrower, or rocket sled we\'re the best!$b$bIn fact you could say we got the market cornered.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(83708,'Return to me from the Twisting Nether and we shall speak more.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83709,'The naaru...is dying! Hurry, you must stop Cho\'gall before all is lost!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83710,'I require a new shaman stone.','I require a new shaman stone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83711,'In here!','',0,0,0,0,0,0,0,0,4,0,44882,0,26124),
(83712,'Da king tell me you gonna free us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83713,'We gonna fight for you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83714,'For da old king, and da new one!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83715,'We gonna help you, cuz\' you helpin\' us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83716,'Dis be our way out!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83717,'Dis gonna save our souls!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83718,'We cannot stay here long. Soon, the entirety of the Iron Horde will be upon us.','',0,0,0,0,0,0,0,0,4,0,44864,0,26124),
(83719,'$n, our champion, will stay back and disrupt the enemy camp. The rest of us will seek safe passage through the jungle.','',0,0,0,0,0,0,0,0,4,0,44865,0,26124),
(83720,'Good luck, $n.','',0,0,0,0,0,0,0,0,4,0,46406,0,26124),
(83721,'Fight well, $n.','',0,0,0,0,0,0,0,0,4,0,44778,0,26124),
(83722,'It\'ll take more than a handful o\' mouthy earth beasts ta take out ol\' Heavyhands!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83723,'Dunna ask how we found that artifact. It\'s not what ya\'d call a \'happy\' story.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83724,'Invaders! Defend Morkurk, you fools!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(83725,'The Witch Lord requires your blades! Attack!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(83726,'YOU NO ATTACK MORKURK!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(83727,'Help! Help!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(83728,'Take care, the demons can strike again at any moment. It seems the Shadow Council will stop at nothing to breach the gates of Auchindoun.\n\nWe must remain vigilant!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83729,'The threat of the Burning Legion is larger than the Alliance and the Horde. We must set aside our differences, even reluctantly, to ensure that history does not repeat itself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83730,'Remmel has been telling me the story of his people. We have more in common than one might think.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83731,'The Sargerei must be kept in check.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83732,'The talbuk and elekk are blessed gifts bestowed upon us by Draenor. Take of them only when necessary and give back whenever able.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83733,'Spill blood in the master\'s name!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83734,'Leave nothing alive. All life must burn!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83735,'I\'ll make this quick.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83736,'This world will be turned to ash!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83737,'You face the burning hatred of the master, cretin.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83738,'None will be spared. Slay them all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83739,'','Feast your eyes upon the terrible might of the Burning Legion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83740,'','You are all fools. This world is damned.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83741,'','Yes... come. Greet your death.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83742,'','Alright, break time\'s over fellas.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83743,'','My uncle\'s in Pinchwhistle Point, I hope everyone\'s ok.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(83744,'','Remember, the secret phrase is, \"The rain falls on Shadowmoon.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83745,'Ok, fine.','Ok, fine.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83746,'This spot\'s good for either a corral or a tankworks. You choose and I\'ll make sure it gets built.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(83747,'Strength is of little importance without the wisdom to know when to properly use it.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83748,'','Wars cannot be won solely by destroying your enemies. Without the protection of your people, you can never be victorious.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83749,'The greatness of our civilization cannot maintain if even a single draenei voice is silenced by its leaders.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83750,'The Naaru have blessed the draenei people with the gift of the Light. Let it guide you and be your solace.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83751,'The forces of the elements can offer unlimited power, but will surely lead to destruction for those who fail to maintain the balance.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83752,'','A leader is only as strong as the weakest of those they lead. The key to victory is to empower even the lowliest soldier to greatness.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83753,'The latent power of Draenor can be found in every rock. When harnessed with care, it will never falter.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83754,'','Hey, you\'re here just in time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83755,'My contract was for burning fungus, repairing engines, and salvage work. It said nothing about dealing with bugs!','',1,274,0,0,100,0,0,0,0,0,0,0,26124),
(83756,'Greetings, initiate. What can I do for you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83757,'I\'ll never sneak onto another wagon again. I swear!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83758,'','How is your mission of subterfuge going? In order to infiltrate the enemy, make sure you are wearing a Sargerei disguise.$B$BYou can create one by collecting the cowl, robe, and slippers from fallen Sargerei enemies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83759,'Communing','Communing',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83760,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83761,'','You have my utmost respect, commander. I will follow you into the dark anytime.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83762,'AAAAAAHHHHHHHHHH!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(83763,'','Some of the larger demons can tear through our ballistae relatively quickly. \n\nIf I can\'t produce them more rapidly than they get destroyed, then there may be no stopping the Shadow Council.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83764,'|TInterface\\Icons\\inv_misc_embers.blp:20|t %s is completely dehydrated and has |cFFFF0404|Hspell:164275|h[Brittle Bark]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83765,'%s has absorbed enough water to become active again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83766,'An Unchecked Growth absorbs a nearby Aqueous Globule and comes to life!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83767,'Use the Command Table to send Qiana on a mission.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83768,'','Starfall isn\'t far. Good luck, Qiana.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83769,'Git to the surface an\' keep that genesaur busy. I\'ll git this cannon firin\' soon as I can!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83770,'Kicking','Kicking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(83771,'I hope you\'re right. The dead grow... fearful. Something truly dark is coming.','',0,0,0,0,0,0,0,0,0,0,44599,0,26124),
(83772,'','Well, Commander, my life has gotten quite exciting since I started following you around.$b$bI see you managed to get the genesaur artifact. Here, take the seeds and water as well and please bring them to Maraad back at the main outpost.$b$bWe will help Thaelin remove his tank in the meantime.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83773,'I will find my way to your garrison. Fight with honor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83774,'','Exarch, have your soulbinders meet me at my camp. I intend to stop Teron\'gor before he unleashes more demons.',0,0,0,0,0,0,1,0,4,0,0,45718,26124),
(83775,'We must stop Teron\'gor before this world falls... as so many others have.','',0,0,0,0,0,0,1,0,4,0,44601,0,26124),
(83776,'','I understand that our relationship with the Draenei has been through some trying times, but right now, these soldiers need my help. \n\nWe need to stick together if we all wish to defeat the Shadow Council.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83777,'','We need to be on our guard. This place is crawling with ogres.',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(83778,'Don\'t worry, $n. We\'ve got your back!','',0,0,0,0,0,0,0,0,4,0,45747,0,26124),
(83779,'','Leafshadow has hidden our position from Teron\'gor, and his forces have not yet left Gul\'rok for their final march on Auchindoun. We have the element of surprise on our side.',0,0,0,0,0,0,1,0,0,0,0,45720,26124),
(83780,'They are far too powerful to attack head-on. Restalaan is most familiar with this area. I believe he has a plan.','',0,0,0,0,0,0,1,0,0,0,44603,0,26124),
(83781,'Light of Lights, cover us from those who wish us harm.','',0,0,0,0,0,0,0,35,0,0,0,0,26124),
(83782,'Deliver us from the darkness and shine your light upon us.','',0,0,0,0,0,0,0,35,0,0,0,0,26124),
(83783,'Hide us from the Dark One. Protect our people from the Great Shadow.','',0,0,0,0,0,0,0,35,0,0,0,0,26124),
(83784,'We are the children of the Light. We ask for naught but peace.','',0,0,0,0,0,0,0,35,0,0,0,0,26124),
(83785,'','You won\'t stand alone. The Light gives us strength!',0,0,0,0,0,0,0,0,0,26702,0,45721,26124),
(83786,'We are bound together by the Light. We fight as one.','',0,0,0,0,0,0,0,0,0,26703,44604,0,26124),
(83787,'Today I repay my debt. I will handle the portals.','',0,0,0,0,0,0,0,0,0,0,45768,0,26124),
(83788,'ANGO\'ROSH! TO ME!','',0,0,0,0,0,0,0,0,0,0,45769,0,26124),
(83789,'Liadrin, I have it. Finish it!','',0,0,0,0,0,0,0,0,0,0,44605,0,26124),
(83790,'','Let\'s go. They went through that portal.',0,0,0,0,0,0,0,0,0,0,0,45722,26124),
(83791,'Thanks for the patch-up! Since you saved me here\'s some advice, stay away from Pinchwhistle Point.','Thanks for the patch-up! Since you saved me here\'s some advice, stay away from Pinchwhistle Point.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83792,'Pinchwhistle Point is crawling with the infected, I... I think the town\'s a lost cause.','Pinchwhistle Point is crawling with the infected, I... I think the town\'s a lost cause.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83793,'Pinchwhistle Point is completely lost. We only saw one guy who didn\'t look infected but we lost control of the zeppelin before we could make contact.','Pinchwhistle Point is completely lost. We only saw one guy who didn\'t look infected but we lost control of the zeppelin before we could make contact.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83794,'The voice calls us to Oshu\'gun...and my ancestors answer. In time, we shall have no choice but to answer as well.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83795,'','I watched with great joy as you brought peace to Gar\'rok during his final hours of life. We will be forever grateful for your kindness and bravery.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83796,'','These pilgrims gather from all over Draenor to hear the wisdom of the spirits interred at Auchindoun. \n\nFor the draenei people, such wisdom comes with great reward.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83797,'The skirmishes with the Shadow Council have left many travelers stranded in Auchindoun. \n\nUnless the tide of battle turns, it is likely we will never leave this place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83798,'You big oaf! Quit breaking my things!','',0,0,0,0,0,0,0,0,0,0,43732,0,26124),
(83799,'That was my entire collection of Hearthstone cards!','',0,0,0,0,0,0,0,0,0,0,43733,0,26124),
(83800,'Gah! That was my last samophlange! Do you know how hard those are to get?','',0,0,0,0,0,0,0,0,0,0,43734,0,26124),
(83801,'Hey dummy! How would you like it if I broke all your things?!','',0,0,0,0,0,0,0,0,0,0,43735,0,26124),
(83802,'We\'re nearly out of supplies, but the refugees keep coming. This cannot continue for long.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83803,'I got this boss.','',0,0,0,0,0,0,0,0,0,0,45775,0,26124),
(83804,'','These great defense crystals are just one of the myriad uses for the crystals in the Jorune mine. \n\nIt is a pity that the Shadow Council forces us to use them only for instruments of war.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83809,'prelude. Stage: $8883w sub-stage: $8938w','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83810,'This is it, soldiers. Time to make your commander proud.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83811,'Fly me to the Spirit Woods near Oshu\'gun.','Fly me to the Spirit Woods near Oshu\'gun.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83812,'Little blue warriors, you have proven yourself worthy of avoiding my wrath.','',0,0,0,0,0,0,0,0,0,0,45969,0,26124),
(83813,'The red ones, yes, they will bear witness to my devastation!','',0,0,0,0,0,0,0,0,0,0,45970,0,26124),
(83814,'It was an ambush - Shadowmoon orcs. They are circling back for the kill.','',0,0,0,0,0,0,5,0,0,0,44790,0,26124),
(83815,'I have returned! Submit, peasants, to the might of the great Ogre Empire!','',0,0,0,0,0,0,0,0,0,0,45968,0,26124),
(83816,'We can\'t fight them. We\'re just farmers! We don\'t even have weapons!','',0,0,0,0,0,0,5,0,0,0,45849,0,26124),
(83817,'Such little faith. Give me your sickle. Watch what is possible with the light.','',0,0,0,0,0,0,1,0,0,0,46716,0,26124),
(83818,'','You will pay for that!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83819,'Take me to Shadowmoon Valley.','Take me to Shadowmoon Valley.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83820,'The mountain of Oshu\'gun was once a place of peace and worship.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83821,'During the Kosh\'harg, our clans would meet at the foot of the great mountain in celebration.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83822,'The Kosh\'harg is just a memory now. The Warsong have claimed Oshu\'gun for their own.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83823,'Tressia was a good solider, but when the venom took its hold on her, she left me no choice. \n\nI hope we wipe every member of the Shadow Council from the face of Draenor. Our people deserve better than to end up like this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83824,'The stench of darkness lingers in the air here...it is not as I remember.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83825,'<Lets out a soft, deep groan>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83826,'Our power is not strong enough to revive this ancient, but we\'ll keep trying. Are you going to help us?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83827,'We\'re from Moonglade, have you been? It\'s great this time of year.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83828,'We haven\'t been able to use our Crow shapeshift in this strange world yet, but I heard a rumor we\'ve found a way to do so here by using the power of the artifacts.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83829,'I\'m gonna load up me tank and head southwest. I\'ll see if I can\'t get one of these rangari to be a guide.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(83830,'I see a... delicious, fleshy $c... do you like what you see before you? Cho\'gall has taught us so much...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83831,'Yes... closer, $c... delve deeper and I will show you the true power of the Pale! Our master has been good to us...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83832,'Our master has made us strong... behold his gifts!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83833,'The master commands and I obey!','',0,0,0,0,0,0,0,0,0,0,46293,0,26124),
(83834,'','Come on, we need to get going pronto!',1,0,0,0,0,0,0,0,4,0,0,0,26124),
(83835,'We have waited long for this moment. The true power of the stones will be realized at last! (None shall survive. We shall be the unmaking! Destroy them! Wash over this world!)','',0,0,0,0,0,0,0,0,0,0,46611,0,26124),
(83836,'Gaze into the abyss. (It sees you! It knows!)','',0,0,0,0,0,0,0,0,0,0,46616,0,26124),
(83837,'Your world will be swallowed in darkness! (All will hear his call!)','',0,0,0,0,0,0,0,0,0,0,46617,0,26124),
(83838,'Death comes! (We know it well.)','',0,0,0,0,0,0,0,0,0,0,46618,0,26124),
(83839,'The end draws closer! (This is our purpose!)','',0,0,0,0,0,0,0,0,0,0,46619,0,26124),
(83840,'Embrace the end.','',0,0,0,0,0,0,0,0,0,0,47370,0,26124),
(83841,'Give in to darkness.','',0,0,0,0,0,0,0,0,0,0,47371,0,26124),
(83842,'He comes... (You can never escape...)','',0,0,0,0,0,0,0,0,0,0,46613,0,26124),
(83843,'The night consumes us! (We have won! All will be as foretold!)','',0,0,0,0,0,0,0,0,0,0,46612,0,26124),
(83844,'Your prisoner is with me. He means your people no harm.','Your prisoner is with me. He means your people no harm.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83845,'We will draw a cloak of midnight across the burning sky.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83846,'Let the prisoner go. Its master has earned a favor from us.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83847,'Here you are, miss Pinchwhistle!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(83848,'','About time! Come on, Gazwitz.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(83849,'','Of course, ma\'am.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(83850,'','Supervising of course. Now, get moving!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(83851,'What can I do to help?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83852,'Khadgar has asked us to go distract the Eye of Kilrogg.','Khadgar has asked us to go distract the Eye of Kilrogg.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83853,'Go ahead and sign off whenever you\'re ready, sir.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83854,'I be goin\' ahead to get da troops ready for your inspection, commander.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83855,'I will move ahead and ensure the troops are ready for your inspection.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83856,'You and I against an entire clan? Sounds like my kind of fight.','',0,0,0,0,0,0,396,0,0,0,46156,0,26124),
(83857,'Here we stand, cowards! Come... FIGHT US!','',0,0,0,0,0,0,0,0,0,0,46159,0,26124),
(83858,'I can see you...','',0,0,0,0,0,0,0,0,0,0,45923,0,26124),
(83859,'We\'re in your kitchen, Kilrogg! Come and get us!','',0,0,0,0,0,0,0,0,0,0,46161,0,26124),
(83860,'I\'m coming for you, intruders...','',0,0,0,0,0,0,0,0,0,0,45924,0,26124),
(83861,'It looks like Khadgar and the rest are on the move. Our work is nearly done, champion!','',0,0,0,0,0,0,0,0,0,0,46162,0,26124),
(83862,'Your deeds here will not be forgotten, $n. Your name shall be spoken in reverence among the spirits of my people.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83863,'Stand up straight, you pathetic savages! Our commander approaches!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(83864,'For $p! For the Horde!','For $p! For the Horde!',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(83865,'Garrison - Debug - Shutdown Scenario','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83866,'This way, commander!','',0,0,0,0,0,0,1,0,0,0,44791,0,26124),
(83867,'Such a joy to see Exarch Akama in action.','',0,0,0,0,0,0,1,0,0,0,44792,0,26124),
(83868,'Look out - here they come.','',0,0,0,0,0,0,1,0,0,0,44793,0,26124),
(83869,'Go now. I will cover the rear.','',0,0,0,0,0,0,5,0,0,0,46717,0,26124),
(83870,'So far, none of our medicines have had any effect on the spiders\' poison. \n\nWe must gather more specimens before we can concoct an effective antidote.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83871,'We\'ve found another egg for your experiments, Teris. I hope this one helps.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83872,'Well done, ranger. These spider\'s eggs should aid in the concoction of an antidote for their venom.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83873,'Look!','',0,0,0,0,0,0,0,0,0,0,46163,0,26124),
(83874,'Atten-tion! Our commander has arrived. Salute!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(83875,'This way. I remember these hills well.','',0,0,0,0,0,0,1,0,0,0,44794,0,26124),
(83876,'Another attack. They must think us an easy target. Hah!','',0,0,0,0,0,0,1,0,0,0,44795,0,26124),
(83877,'','Start gathering everybody together, we need to expand our operation. And let me know if you find Pippers... he stole my favorite slippers.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83878,'','I swear if he is swimming again... he has a horrible work ethic. He says he lost those supplies. I don\'t believe him for a second.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83879,'For $p! For the Alliance!','For $p! For the Alliance!',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(83880,'We are almost there.','',0,0,0,0,0,0,1,0,0,0,44796,0,26124),
(83881,'Supplies? What supplies? I have no idea what you are talking about.$b$b<Scrap\'s eyes dart back and forth and he nervously clears his throat.>$b$bWhat? I\'m not trying to steal them or anything... I mean, if I knew what you were even talking about, which I don\'t.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83882,'You made it.','',0,0,0,0,0,0,1,0,0,31251,46718,0,26124),
(83883,'There you are. Now get to work, you slackers!','',0,0,0,0,0,0,25,0,0,31251,44536,0,26124),
(83884,'The Bleeding Hollow orcs use savage blood magic to transform their warriors into hulking berserkers.','',0,0,0,0,0,0,396,0,0,0,46157,0,26124),
(83885,'Listen up, maggots. We\'re doubling up patrols. Nothing goes wrong while the commander is here, understood?','',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(83886,'All of you, double your efforts! I want this place spotless for our commander.','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(83887,'Commander, a moment, please.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(83888,'With any luck, we will escape before they can complete their transformation ritual.','',0,0,0,0,0,0,396,0,0,0,46158,0,26124),
(83889,'We\'ve done it! |c00FFFF00|Hspell:178358|h[Fangraal]|h|r marches into Ashran to cleanse the Horde filth. Don\'t let him die, Alliance!','',0,0,0,0,0,0,0,0,0,36470,8173,0,26124),
(83890,'Excellent. I will endeavor to bring more, should the opportunity arise. Anu belore dela\'na!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83891,'As we stand beneath the shadow of the once mighty Gordawg, I can feel the elements weep.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83892,'|TInterface\\Icons\\spell_holy_surgeoflight.blp:20|t %s readies |cFFF00000|Hspell:153006|h[Consecrated Light]|h|r. Hide!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(83893,'','I\'m on it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83894,'Ey commander, you have a second?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(83895,'Fangraal is born! He is pushing forward on the Road of Glory at this moment.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83896,'The artifact fragments contain enough magical power to restore this Ancient to full strength. $B$BHow many have you brought us?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83897,'Search to the northwest. I will be right behind you.','',0,0,0,0,0,0,1,0,0,0,46715,0,26124),
(83898,'Augh! Brain so cold!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83899,'Ungh! Brain freeze!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83900,'There are many injured who need my aid. There is no time to waste.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83901,'|c00FFFF00|Hspell:178358|h[Fangraal]|h|r has been slain by the Horde!','',0,0,0,0,0,0,0,0,0,36470,8213,0,26124),
(83902,'','Is he dead? Phew... great work, commander. I\'ll stay here and take care of any stragglers.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83903,'','A temple-kneeler and a metal-bender have no place in this jungle. You will need my help to survive.',0,0,0,0,0,0,0,0,0,0,0,46545,26124),
(83904,'','Hmmph. Just keep up if you can.',0,0,0,0,0,0,0,0,0,0,0,46546,26124),
(83905,'I be goin\' ahead and makin\' sure it not a trap, commander.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83906,'I\'ll move ahead and check for any orc ambushes, commander.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(83907,'','Prophet Velen trusted me to turn the Iron Horde from Karabor. I can handle the jungle.',0,0,0,0,0,0,0,0,0,0,0,45568,26124),
(83908,'','Why did you join us, Kaalya? If we are such an inconvenience, why not leave us to our own devices?',0,0,0,0,0,0,0,0,0,0,0,45569,26124),
(83909,'','Rangari do not leave people behind.',0,0,0,0,0,0,0,0,0,0,0,46547,26124),
(83910,'Oh gross! Well, that wasn\'t it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83915,'Hey, you don\'t look infected. You must be the $Gguy:lady; my niece was telling me about. Come on over!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83916,'Behold, a void god is born! (You fools are too late!)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83917,'Thank you, stranger.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83918,'A pity that I cannot stay to watch you die. (We\'re going to Highmaul!)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83919,'You can find those cherries under any of the trees.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83920,'New babies are just the thing to get these two feeling right as rain.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83921,'Ahh...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83922,'... CHOOO!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83923,'They could come from anywhere.','They could come from anywhere.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83924,'They\'ll be going for our buildings!','They\'ll be going for our buildings!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83925,'Spread out! Spread out!','Spread out! Spread out!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83926,'I can\'t hear any more digging...','I can\'t hear any more digging...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83927,'They\'re on the run now.','They\'re on the run now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83928,'Just a few whacks more.','Just a few whacks more.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83929,'Their attack is weakening.','Their attack is weakening.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83930,'Oy! Commander! That genesaur found us. The lasses are outside tryin\' to keep it at bay. They are gonna need yer help!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83931,'Hansel! You\'re alive! Here... let me help ya load.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83932,'Now you gonna get it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83933,'Ow ow ow! Why me?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83934,'','Let\'s get moving!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83935,'Ha ha! Come get me now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83936,'Grr! Now I show you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83937,'Exarch Akama, these attacks are just the beginning.','',0,0,0,0,0,0,1,0,0,0,44797,0,26124),
(83938,'Who the dummy now?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83939,'Ice da best!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83940,'The orcs would be fools to attack our fortified cities.','',0,0,0,0,0,0,1,0,0,0,46719,0,26124),
(83941,'With respect, I disagree. We MUST not underestimate them. Take me to the Exarch Council.','',0,0,0,0,0,0,1,0,0,0,44798,0,26124),
(83942,'Champions! Nyami\'s agents - they went this way!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83943,'Best be quick with that thing. We got incoming!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83944,'No... Oh no...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83945,'','Step inside the chamber of truth and be cleansed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83946,'On our homeworld, art, science, magic and technology were all as one. Ah, such wonders we would build!','',0,0,0,0,0,0,396,0,0,0,46761,0,26124),
(83947,'Now, all I have is spare parts and whatever primitive materials we can cobble together.','',0,0,0,0,0,0,396,0,0,0,46762,0,26124),
(83948,'It is ready! Go inside and power on the console while I observe...','',0,0,0,0,0,0,396,0,0,0,46763,0,26124),
(83949,'Haunted Hound has spotted you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83950,'Get the goren!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83951,'Someone find a way to collapse that tunnel!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83952,'Where do these keep coming from?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83953,'There\'s too many of these things!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83954,'There are so many of them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83955,'Look at the size of its teeth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83956,'I wonder if I could sell their crystals...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83957,'Don\'t die or they\'ll eat you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83959,'Well done, $n.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(83960,'This cave will serve us well.','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(83962,'At long last... my time has come! This world shall crumble beneath the power of the void!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83963,'The furies await you at the Throne of Elements, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83964,'Uh oh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83965,'Just like Mom used to make.','Just like Mom used to make.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83966,'It\'s like a little piece of Ironforge.','It\'s like a little piece of Ironforge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83967,'Ah. Tastes like home.','Ah. Tastes like home.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83968,'That\'ll get you there, son.','That\'ll get you there, son.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83969,'No, no, no. The whole thing\'s all wrong!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83970,'Some sorta bad voodoo be happenin\' here, commander.','',0,0,0,0,0,0,396,0,0,26702,0,0,26124),
(83971,'Bryan! It\'s me, Jasper. What happened to you?','',0,0,0,0,0,0,5,0,0,26703,0,0,26124),
(83972,'Alliance Win!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83973,'There, there. It will all be okay.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83974,'The Light heals all wounds.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83975,'Go! I will hold back any reinforcements that attempt to follow!','',0,0,0,0,0,0,0,0,0,0,46706,0,26124),
(83976,'Are you hungry, little Moonglow? Here, let me get you some fish.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(83977,'Where did all of my workers go? They\'ll be working overtime to finish this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83978,'Show the schematic to Bryan.','Show the schematic to Bryan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83979,'Though much has been lost, I sense a great peace in the elements. I will remember your courage always, friend.','',0,0,0,0,0,0,1,0,0,0,46703,0,26124),
(83980,'Who\'s a pretty fey dragon? You\'re a pretty fey dragon!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(83981,'This looks to be a hydra egg and is very close to hatching.$b$bIts mother would likely be nearby and would not appreciate you being near her nest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83982,'I am ready to begin the Ritual of Binding.','I am ready to begin the Ritual of Binding.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83983,'Wh- what happened? Where am I? Jasper... is that you?','',0,0,0,0,0,0,6,0,0,26703,0,0,26124),
(83984,'Alright Moonglow, now play dead!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(83985,'Wh- what happened? Where am I?','',0,0,0,0,0,0,6,0,0,26702,0,0,26124),
(83986,'Sit, Moonglow, sit! Good dragon!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(83987,'Horde Win!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83988,'Alright, come on through. Steady... Steady...','',0,0,0,0,0,0,0,0,0,0,44537,0,26124),
(83989,'','Gronnlings, break their bones and bring them to me!',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(83990,'','Gronn, gnash them in your teeth!',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(83991,'Varasha charges into her lair!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83992,'','<Alice doesn\'t seem to acknowledge your presence.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83993,'Show the spectral essences to Alice.','Show the spectral essences to Alice.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83994,'','Wh-who are you? Where\'s Bryan?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(83995,'Please... when you see her... tell her I love her.','',0,0,0,0,0,0,396,0,0,26830,0,0,26124),
(83996,'Please... when you see her... tell her I love her.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(83997,'The villagers were easy. You\'re next.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(83998,'','We\'ll see who\'s best.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(83999,'','Make Azeroth proud, commander.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(84000,'','Don\'t underestimate the talbuk, $c. While they\'re mostly peaceful creatures, they hit as hard as an elekk.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(84001,'','I know... Tall Buck\'s a silly name. But, we have to call him something, and he is rather large.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(84002,'I am Nobundo, a humble paladin. I have been called here by a voice upon the wind. How may we aid you?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84003,'You will have our aid. We will find the fury of earth and restore the balance.','',0,0,0,0,0,0,1,0,0,0,45912,0,26124),
(84004,'You must attune yourself with the elements upon the plateau.','',0,0,0,0,0,0,0,0,0,0,45913,0,26124),
(84005,'When you are ready, we will commune with the great furies.','',0,0,0,0,0,0,0,0,0,0,45914,0,26124),
(84006,'We must act swiftly, Oshu\'gun awaits.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84007,'I had heard of the Throne of Elements, a place where the elements could speak with the orcs. I had never dreamed that one day I would stand here in the presence of giants.$b$bThough I am a stranger here, I feel as if I have been here before...in a dream perhaps.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84008,'','Greetings, commander. How may I help you?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(84009,'Follow me, and stay close.','',0,0,0,0,0,0,0,0,4,0,44852,0,26124),
(84010,'','Greetings, wolf-$g brother:sister;.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(84011,'We\'ll see who\'s best.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(84012,'Make Azeroth proud, commander.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(84013,'','Don\'t underestimate the talbuk, wolf-$g brother:sister;. While they\'re mostly peaceful creatures, they hit as hard as an elekk.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(84014,'','I know... Tall Buck\'s a silly name. But, we have to call him something, and he is rather large.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(84015,'Get back to work! Commander Taylor won\'t be kept waiting.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84016,'Your break isn\'t for another hour. Back to work!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84017,'I\'ll have you written up for this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84018,'I\'ve had enough. You\'re fired!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84019,'I\'ve got the enemy in my sights. Hold the line, lads!','I\'ve got the enemy in my sights. Hold the line, lads!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84020,'Now - kill your hundred, or die trying!','',0,0,0,0,0,0,0,0,6,0,44509,0,26124),
(84021,'Sorry, but we don\'t have that kind of time.','',0,0,0,0,0,0,0,0,6,0,44853,0,26124),
(84022,'Hmph. I only counted ninety-nine kills, wizard.','',0,0,0,0,0,0,0,0,4,0,44511,0,26124),
(84023,'Then I guess we owe you one.','',0,0,0,0,0,0,0,0,4,0,44854,0,26124),
(84024,'Everyone, with me!','',0,0,0,0,0,0,0,0,4,0,44855,0,26124),
(84025,'Quickly! Into the cave, before they thaw.','',0,0,0,0,0,0,0,0,4,0,44856,0,26124),
(84026,'','We brought this sapling with us from our home, and now it is dying. I cannot sense any evil nearby, but I will keep trying.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84027,'Beneath the crystal mountain the orcs call Oshu\'gun lays the wreckage of the Genedar. Were it not for the Prophet Velen and the mercy of the naaru K\'ure, my people would have perished to the Burning Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84028,'You have learned all the recipes from this research.','You have learned all the recipes from this research.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84029,'Alright, back to work.','Alright, back to work.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84030,'But, I was just about to win...','Alright, back to work.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84031,'Do we have to?','Do we have to?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84032,'The shaman stone that the furies gave to us at the Throne of Elements allows us to communicate through the elements.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84033,'The portal has taken me into the Twisting Nether.','The portal has taken me into the Twisting Nether.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84034,'<Touch the sword.>','<Touch the sword.>',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(84035,'','Impossible!',0,0,0,0,0,0,14,0,0,0,0,0,26124),
(84036,'The remains of this corpse are being devoured by the roots and vines of the swiftly budding seeds in the pool.','The remains of this corpse are being devoured by the roots and vines of the swiftly budding seeds in the pool.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84037,'This Laughing Skull looks as though they were eating a lot before they were slain, their body grown fat and distorted before death.','This Laughing Skull looks as though they were eating a lot before they were slain, their body grown fat and distorted before death.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84038,'What remains of this corpse is now fertilizer for the seeds growing in this pool.','What remains of this corpse is now fertilizer for the seeds growing in this pool.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84039,'The Genedar was once a vessel guided by the naaru and powered by the Light itself. Now, as we stand among the wreckage of that great ship, the Light is absent... I sense only darkness here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84040,'','Don\'t let them take the artifact!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(84041,'The object we seek is here!','',0,0,0,0,0,0,0,0,0,0,46558,0,26124),
(84042,'Get them!','',0,0,0,0,0,0,22,0,0,0,46559,0,26124),
(84043,'Hahaha! I\'ve always enjoyed killing gronn.','',0,0,0,0,0,0,53,0,0,0,46560,0,26124),
(84044,'Nisha, get her down here!','',0,0,0,0,0,0,1,0,0,0,46561,0,26124),
(84045,'REMOVE - Brak, you will receive no mercy this time.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(84046,'','Aggghh!',0,0,0,0,0,0,14,0,0,0,0,0,26124),
(84047,'','In order to successfully train a fey dragon, one must keep them well fed and rested. A restless dragon tends to be less than receptive to orders.\n\nPlease do not disturb them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84048,'I am ready to make my choice.','I am ready to make my choice.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84049,'Here is where we train the young fey darters to follow commands. \n\nThough their antics may seem silly, the discipline they learn now is imperative if we ever wish them to take a rider.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84050,'I should crush you but what would be the point... I have failed in my duties and can only wait until I am crushed to dust...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84051,'A building is being eaten!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84052,'Brighteye looks at you eagerly, awaiting a command.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84053,'Brighteye, go fetch!','Brighteye, go fetch!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84054,'Thank you for not killing me.  What duty have you failed?','Thank you for not killing me.  What duty have you failed?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84055,'Sit, Brighteye, sit!','Sit, Brighteye, sit!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84056,'Okay, Brighteye, now play dead!','Okay, Brighteye, now play dead!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84057,'Dionor was a powerful and bold champion of our kind. He sought to break the ancient lines of battle and take the fight to the enemy.$b$bIt ended with his defeat at the hands of several Magnaron... Here he fell, some of his energy creating a small sanctuary for those of us that remained until I could fulfill my duty... but I cannot...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84058,'What were you supposed to do?','What were you supposed to do?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84059,'When a champion like Dionor falls, a Death Bloom will grow from his husk. I was to collect this Bloom and perform a sacred rite here to release his life force back to the overgrowth.$b$bAs I was about to do this I was set upon by fur-covered two legs and they took the Bloom first. We tried to follow but they raised barriers and used fire to drive us back.$b$bSo now I stand vigil over my failure until we are all ground into the tortured soil by our great enemy...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84060,'So getting that bloom back might fix things... interesting...','So getting that bloom back might fix things... interesting...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84061,'It\'s your watch. Wake up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84062,'We\'ve done all we can from up here...','',0,0,0,0,0,0,0,0,4,0,44806,0,26124),
(84063,'Whatsh do you want? Can\'t you shee I\'m trying to drinksss here? Pour yourshelf one.$B$BHemetsh, come to Nagrandsss the Alliance and Horde shaid. There\'sh big game to hunt shtill.$B$BBut, when I gots here wasss that what they wantsh me to do? NO!$B$BHemetsh, hunt the Warshong\'s wolvesss. Deprive the orcsh of their mountsss.$B$BThat\'sh no job for Hemet Neshingwary!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84064,'','Brighteye is one of the smartest fey dragons we\'ve trained at the Draakorium. He loves doing tricks for visitors!\n\nWhy don\'t you see if Brighteye can do a trick for you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84065,'Well done. The artifact is yours to take.','',0,0,0,0,0,0,0,0,0,0,46562,0,26124),
(84066,'It\'s working! It\'s... not stable. But it\'s working.','',0,0,0,0,0,0,0,0,0,0,46747,0,26124),
(84067,'This new structure is able to tap into a surprising amount of power.','',0,0,0,0,0,0,0,0,0,0,46748,0,26124),
(84068,'Defend the ward at all costs!','',0,0,0,0,0,0,0,0,0,0,46749,0,26124),
(84069,'Keep the Shadowmoon at bay. What is causing this madness?','',0,0,0,0,0,0,0,0,0,0,46750,0,26124),
(84070,'Defend the ridgeline. Let them come to us.','',0,0,0,0,0,0,0,0,0,0,46751,0,26124),
(84071,'Keep them engaged. The defense ward is drawing so much power - I can\'t maintain it for long.','',0,0,0,0,0,0,0,0,0,0,46752,0,26124),
(84072,'This is the final resting place of some of my companions who were killed by ogron.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(84073,'Visha, newly born and not yet ready for combat.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(84074,'Qisha, still young but showing great promise.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(84075,'And finally, the dearest of them all, Latisha.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(84076,'I will destroy the Breakers of this canyon and avenge those I have lost!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(84077,'I used to be an adventurer like yourself...$b$bI remember it like it was yesterday. I was back in Azeroth at my favorite establishment, maybe you\'ve heard of it? Goes by the name of Lion\'s Pride Inn, smack dab in the middle of Goldshire.$b$bWell, there I was across from ol\' Dobbins enjoying myself a nice bit of fine aged cheddar and washing it back with a flagon of melon juice when Dughie runs into the tavern!$b$bHis face was white as snow...nay, whiter than snow! Says he spotted a kobold not far off and it was carrying a candle, like it was fixin\' to burn Goldshire to the ground!$b$bI threw down my fine aged cheddar, made for the door and tripped over a dwarven hunter.$b$bWe crashed to the ground and POW! I took an arrow right to the knee!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84078,'You! Strange thing. Come, eat! The food is so delicious. You must taste.$b$bIt is so tasty I have not thought to stab you once... yet.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84079,'Yrel, let\'s blow open those gates and take Grommashar.','Yrel, let\'s blow open those gates and take Grommashar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84080,'','Attention, trainees! My fellow riders call me Moonstag. You may address me as \"Sir.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84081,'','You\'ve all flown before, but you\'re about to enter a whole new world, so pay attention.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84082,'I\'m the fastest courier in the army. Do you need a report delivered?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84083,'','This is a Draakorium Fey Dragon. It\'s as maneuverable as a jackrabbit and can flip end to end in less than a second.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84084,'','Today we will be doing basic take off, approach, and landing maneuvers.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84085,'','Anyone not paying attention is liable to end up as a puddle of something to be scrubbed off the rocks of the Draakorium. Dismissed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84086,'After them! Don\'t let them get away!','',0,0,0,0,0,0,0,0,4,0,44512,0,26124),
(84087,'Durotan, let\'s blow open those gates and take Grommashar.','Durotan, let\'s blow open those gates and take Grommashar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84088,'Come back Porkchop! You embarrassin\' us!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84089,'Bad Porkchop!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84090,'Change of plans, men. Let\'s do it again!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(84091,'Energy... waning...','Energy... waning...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84092,'Must... keep... fighting...','Must... keep... fighting...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84093,'Cannot fail... I will not fail...','Cannot fail... I will not fail...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84094,'We fight on for Azeroth!','We fight on for Azeroth!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84095,'If I could just close my eyes for a few moments...','If I could just close my eyes for a few moments...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84096,'Do you not honor our commander\'s will? Are you not Horde?! Build it AGAIN!','',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(84097,'I can\'t kill all these botani by myself. I\'m coming with you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84098,'Pull back! We must find Ner\'zhul his sacrifices elsewhere.','',0,0,0,0,0,0,0,0,0,0,45848,0,26124),
(84099,'Burn it all while there\'s still time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84100,'Ashes to ashes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84101,'We have to burn the corpses while we still can!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84102,'Another dark soul for the chopping block.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84103,'This will only hurt for a second.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84104,'Defying the master\'s will is punishable by death.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84105,'Hungry Goren Killed! (+$9044w)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84106,'An |c00FFFF00|Hspell:178360|h[Alliance Captain]|h|r has joined the battle!','',0,0,0,0,0,0,0,0,0,30987,49299,0,26124),
(84107,'A |c00FFFF00|Hspell:178361|h[Horde Captain]|h|r has joined the battle!','',0,0,0,0,0,0,0,0,0,30987,49299,0,26124),
(84108,'I am pleased. I could watch you rats fight for hours.','',0,0,0,0,0,0,0,0,6,0,44510,0,26124),
(84109,'These blasted plants have ruined my hunting grounds!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84110,'The sol-shapers will be severely weakened in those caves, but do not underestimate them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84111,'I... I remember...','',0,0,0,0,0,0,396,0,0,26905,0,0,26124),
(84112,'','I... I remember...',0,0,0,0,0,0,396,0,0,26907,0,0,26124),
(84113,'We need to help Taylor!','',0,0,0,0,0,0,396,0,0,26906,0,0,26124),
(84114,'','We need to help Taylor!',0,0,0,0,0,0,396,0,0,26906,0,0,26124),
(84115,'Are you sure they can\'t see me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84116,'Thank you, but where can I go now?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84117,'Ahh, a decoy. Now\'s my chance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84118,'Back into hiding...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84119,'Come now, my beak isn\'t that big! This thing looks nothing like me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84120,'Raven watch over you, friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84121,'Extricating','Extricating',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(84122,'Exarch Maladaar, take Qiana with you and scout the cave.','',0,0,0,0,0,0,0,0,4,924,44857,0,26124),
(84123,'As you wish.','',0,0,0,0,0,0,0,0,4,0,44592,0,26124),
(84124,'$n - I have a special job for you.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(84125,'Lady Liadrin, take Olin with you and scout the cave.','',0,0,0,0,0,0,0,0,4,923,44858,0,26124),
(84126,'','At your command.',0,0,0,0,0,0,0,0,4,0,0,45711,26124),
(84128,'$GSir:Madam;, an attack on our garrison looms close. I have commissioned some items that you may find useful.$B$BWhoever these fools are, I welcome the chance to earn another scar.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84129,'Prepare to battle the Gorens.','Prepare to battle the Gorens.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84130,'Start the garrison invasion?','Start the garrison invasion?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84131,'Porkchop go squish?! I squish you now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84132,'Crushin\' time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84133,'*gasp*  Th... *cough* Thanks for getting me outta that thing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84134,'The damned hatch jammed shut on me! It\'s just my luck that I escape the infected only to get stuck in a defective escape pod.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84135,'Stop that thing! Bring it down!','',0,0,0,0,0,0,5,0,0,0,46753,0,26124),
(84136,'Stay in your swamp, Rangari. I will handle this.','',0,0,0,0,0,0,1,0,0,0,46754,0,26124),
(84137,'You really got me out of a tight situation there... ZING! Hah, I kill myself... DOUBLE ZING! ...Because I got stuck in the escape pod... eh you get the idea.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84138,'$GSir:Madam;, we\'ll assemble the troops at your command.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84139,'Look, I owe you some thanks for helping me out. I grabbed this while I was getting out of town; figure you could use it better than I can.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84140,'See you around $g dude : toots;!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84141,'Augh! Now hornets? Why!?!?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84142,'','What is going on here? The entire mushroom forest is riled up.',0,0,0,0,0,0,5,0,0,0,0,45892,26124),
(84143,'','Did you sink resonance crystals in the ground again? You\'re driving the creatures of the earth berserk!',0,0,0,0,0,0,5,0,0,0,0,45893,26124),
(84144,'','When will you learn that this world is nothing like Argus?',0,0,0,0,0,0,5,0,0,0,0,45894,26124),
(84145,'<The two Exarchs are in the midst of a heated argument.>$b$bThank you for all your help, $n. Apparently my devices have riled up the local flora - not to mention my fellow Exarch.$b$bIt is no matter. I will do whatever it takes to defend our people and rebuild what we lost... the occasional bug is to be expected. Surely you agree!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(84146,'','<The two Exarchs are in the middle of a heated argument.>$b$bExarch Hataaru focuses too much on what we lost. I keep trying to tell him - it would be folly to turn this world into a second Argus, even if we had the power. Draenor is unique, and we should build our technology to suit this new world. Not the other way around!$b$bHe seems willing to listen to you. Maybe you can talk some sense into him.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(84147,'I\'M HIT!','I\'M HIT!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84148,'GET BEHIND ME!','',0,0,0,0,0,0,0,0,0,0,44859,0,26124),
(84149,'KHADGAR! INCOMING!','',25,0,0,0,0,0,0,0,0,0,44772,0,26124),
(84150,'Hero, help me down from here. We don\'t have much time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84151,'Ephial betrayed me. He slaughtered my men and turned them against -','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84152,'You have heart, Taylor. I\'ll give you that.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84153,'I suppose there\'s not much point in disguises anymore.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84154,'Now, Admiral, it is time to finish what I started.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84155,'Genesaur coming. Get ready!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84156,'Help Draka and Kaz! Draka said I get to fire the big gun. I\'m gonna rip that beast apart with this dwarven behemoth blaster.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84157,'Loading','Loading',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(84158,'They\'re... eating our garrison.','They\'re... eating our garrison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84159,'They\'re eating our buildings!','They\'re eating our buildings!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84160,'They can eat anything!','They can eat anything!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84161,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84162,'Go! I will defend you from any Pale that would interfere...','',0,0,0,0,0,0,0,0,0,0,45917,0,26124),
(84163,'Would you be interested in some card trading?','Would you be interested in some card trading?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84164,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84165,'','Burn that beast to the ground!',11,0,0,0,0,0,0,0,0,0,0,6938,26124),
(84166,'Your laborers are hard at work, Commander. Soon your garrison will be well-stocked with food.','',0,0,0,0,0,0,1,0,0,0,44807,0,26124),
(84167,'I will seek out Exarchs Akama and Maladaar. Good luck, Commander.','',0,0,0,0,0,0,1,0,0,0,44808,0,26124),
(84170,'The Pale must not be allowed to build an army of elemental slaves.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84171,'Speak with Kalandrios to begin the ritual.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84174,'The terrors of the void march upon Oshu\'gun, $n. They must be stopped.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84175,'The ritual leaders must be dealt with before it is too late!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84176,'With every moment, Invalidus grows in strength. Move swiftly!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84177,'The Warsong rituals must be stopped!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84178,'If the portals open, the path will be clear for the terrors of the void to march upon Draenor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84179,'Seek out the four pillars upon the plateau and attune yourself to the elements.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84180,'Very well. I\'ll finish you myself.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84181,'Rise, and carry out my will!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84182,'You\'ve done it. We are free!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84183,'We are free now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84184,'The Adherents will do their utmost to cast your corpses down to the forests below.  I can return you safely.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84185,'Return me to the surface, friend.','Return me to the surface, friend.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84186,'Are you sure you wish to exit the dungeon?','Are you sure you wish to exit the dungeon?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84187,'To arms! For the Horde!','To arms! For the Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84188,'Finally, a battle.','Finally, a battle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84189,'Get the peons to safety.','Get the peons to safety.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84190,'Spirits of air, wind, and all...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84191,'I bind this creature to my call!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84192,'Fool.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84193,'You meddle in powers... beyond your comprehension.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84194,'','What?!  He\'s just gonna leave?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84195,'Rest Dionor, I am sorry it took so long...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84196,'','I will take the high roads and meet you south of the Evermorn Springs, should you survive.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84197,'Commander, are you alright?','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(84198,'You alright, commander?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(84199,'Aaaaauuuuuggghhhhh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84200,'','The front lines are faltering. They cannot hold for much longer.',0,0,0,0,0,0,0,0,0,0,0,44136,26124),
(84201,'','This should be easy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84202,'','This should be easy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84203,'','This should be easy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84204,'','This should be easy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84205,'','This should be easy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84206,'','This should be easy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84207,'','This should be easy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84208,'','This should be easy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84209,'','This should be easy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84210,'','This should be easy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84211,'$p needs more time to finish the mission!','',0,0,0,0,0,0,0,0,0,0,44860,0,26124),
(84212,'The elements will grant us time! For Azeroth!','',0,0,0,0,0,0,0,0,0,0,46398,0,26124),
(84213,'FURY OF EARTH, GRANT ME YOUR STRENGTH!','',0,0,0,0,0,0,0,0,0,0,46399,0,26124),
(84214,'I... I grow weary. The elements are barely a whisper.','',0,0,0,0,0,0,0,0,0,0,46400,0,26124),
(84215,'Rest now, heroes! Soon more will come! We must allow $p to finish the mission! For Azeroth!','',0,0,0,0,0,0,0,0,0,0,46401,0,26124),
(84216,'MUSTER YOUR STRENGTH! ANOTHER IRON HORDE BATTALION APPROACHES!','',25,0,0,0,0,0,0,0,0,0,44773,0,26124),
(84217,'You will not interrupt the master\'s plans!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84218,'%s is about to burst!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84219,'Of course.','Of course.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84220,'','DISCLAIMER:\n\nThe Steamwheedle Preservation Society will not be held liable for any accidental deaths, dismemberments or mutilations involved with rocket-propelled ascensions.\n\nMisti Zingwozzer,\nLegal Department, Steamwheedle Preservation Society',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84221,'Good work so far! The crystal conduits are energizing. Just a few minutes longer...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84222,'Excellent. Keep them away. I\'ve almost got it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84223,'It\'s done! Not bad, stranger. Take the spoils from that beast if you wish. We should be safe, now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84224,'Watch out! Here they come!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84225,'','Get out of here! Only staff is allowed in the larder.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84226,'%s calls down a |cFFFF0404|Hspell:150045|h[Molten Impact]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84227,'I\'ll guide Admiral Taylor back to camp. See you there.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(84228,'I be helpin\' da admiral find his way to his people. I be meetin\' you back at camp.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(84229,'\"...when the raven swallows the day.\" Who sent you?','',0,0,0,0,0,0,0,0,0,0,46020,0,26124),
(84230,'Very well. I\'m listening.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84231,'','IRON HORDE TANK HEADING TO THE FRONT! IT\'S MASSIVE!',25,0,0,0,0,0,0,0,0,0,0,45712,26124),
(84232,'Focus on your mission, $p! I will handle the tank!','',0,0,0,0,0,0,0,0,0,0,44861,0,26124),
(84233,'Hey! You have any idea of the repair cost for this thing!?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84234,'Stop using my own bombs against me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84235,'Here\'s a tip! Stand in my fire, you\'ll like it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84236,'WAAAAaaahh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84237,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84238,'','Wahoo! We\'re Airborne!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84239,'','This thing wasn\'t built with this many passengers in mind, so just find a place and grab on. Hope you have a strong grip!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84241,'','I\'m sure we could come up with a decent rental agreement. How about 5,000,000 gold for a cot down in the workshop?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84244,'We\'ve done it! Kronus marches into battle for the Horde!','',0,0,0,0,0,0,0,0,0,0,8173,0,26124),
(84245,'The Alliance has slain Kronus!','',0,0,0,0,0,0,0,0,0,36471,8213,0,26124),
(84246,'','Pull up a chair! Burgers are almost ready, boss!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84247,'Hello, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84248,'Your scurrying is at an end, rats.','',0,0,0,0,0,0,0,0,6,0,43708,0,26124),
(84249,'Not so fast, Ner\'zhul.','',0,0,0,0,0,0,0,0,6,0,44890,0,26124),
(84250,'Yes... step closer! I will bury you alive for the glory of the Iron Horde!','',0,0,0,0,0,0,0,0,6,0,43709,0,26124),
(84251,'Check it out here, got the best seats in the house!\n\nDid you come here to watch some fights, too?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84252,'I don\'t know Kimzee, I\'m gettin\' too old for this nonsense. You have a nice place at the gearworks; think you could spare a place for your dear ol\' uncle to rest his weary legs?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84253,'I think my legs suddenly feel a lot better.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84254,'No luck this time!','No luck this time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84255,'I got one! I got one!','I got one! I got one!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84256,'A whopper!','A whopper!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84257,'Smuggling is my business.... and business is good.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84258,'Got some rare stuff here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84259,'Ah, yes!  I\'ve something special just for you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84260,'Not even a nibble!','Not even a nibble!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84261,'Sigh...','Sigh...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84262,'A bite!','A bite!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84263,'Did I feel something?','Did I feel something?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84264,'I think I got one!','I think I got one!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84265,'Poisoning','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84266,'Ah, traveler, did you expect more from a humble artist? A trinket perhaps? Coin, or a keepsake?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84267,'Just look in front of you. The true treasure is the beauty of this moment.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84268,'Worthless...','',0,0,0,0,0,0,0,0,6,0,43707,0,26124),
(84269,'Do not waver!','',0,0,0,0,0,0,0,0,0,0,45281,0,26124),
(84270,'Strike them down!','',0,0,0,0,0,0,0,0,0,0,45282,0,26124),
(84271,'Victory is near!','',0,0,0,0,0,0,0,0,0,0,45283,0,26124),
(84272,'Show them no mercy!','',0,0,0,0,0,0,0,0,0,0,44783,0,26124),
(84273,'Your blood will spill!','',0,0,0,0,0,0,0,0,0,0,44784,0,26124),
(84274,'Taste your own death!','',0,0,0,0,0,0,0,0,0,0,44785,0,26124),
(84275,'','Steel yourselves!',0,0,0,0,0,0,0,0,0,0,0,45586,26124),
(84276,'','Never give up!',0,0,0,0,0,0,0,0,0,0,0,45587,26124),
(84277,'','We will not falter!',0,0,0,0,0,0,0,0,0,0,0,45588,26124),
(84278,'','Be strong!',0,0,0,0,0,0,0,0,0,0,0,44747,26124),
(84279,'','Keep your guard up!',0,0,0,0,0,0,0,0,0,0,0,44748,26124),
(84280,'','I\'ve got this.',0,0,0,0,0,0,0,0,0,0,0,44749,26124),
(84281,'You have not seen the likes of me!','',0,0,0,0,0,0,0,0,0,0,44894,0,26124),
(84282,'Think you\'ve seen magic?','',0,0,0,0,0,0,0,0,0,0,44895,0,26124),
(84283,'Together, we cannot fail!','',0,0,0,0,0,0,0,0,0,0,44896,0,26124),
(84284,'Hey, thanks again for helping me down in Pinchwhistle Point.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84285,'','Hey if you ever need some engines fixed or something burned down just ask anytime!$b$bI\'ll even give you the employee discount of 0% off!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84286,'Alright gang, it\'s archaeology time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84287,'','Boss! My readings indicate a spatial anomaly around the artifact!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84288,'We\'ll need to neutralize it. Set your archaeology blasters to dissipate!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84289,'I\'m getting feedback! My archaeology blaster can\'t hold it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84290,'I just had to wear the red shirt...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84291,'Set blasters to full power!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84292,'','Such skill! You must have gone through much to learn how to fight like that. Only Zulmork and Cromaug remain.',0,0,0,0,0,0,4,0,0,26999,0,0,26124),
(84293,'It\'s a live one!','It\'s a live one!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84294,'It\'s fighting!','It\'s fighting!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84295,'','Only Cromaug remains now.',0,0,0,0,0,0,4,0,0,27000,0,0,26124),
(84296,'I\'m not letting you get away!','I\'m not letting you get away!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84297,'','Zulmork is our last target.',0,0,0,0,0,0,4,0,0,27001,0,0,26124),
(84298,'','Such skill! You must have gone through much to learn how to fight like that. Two targets remain.',0,0,0,0,0,0,4,0,0,27002,0,44675,26124),
(84299,'','Now only Cromaug remains.',0,0,0,0,0,0,4,0,0,27003,0,44676,26124),
(84300,'','Now we need to hunt down Vorgorsh.',0,0,0,0,0,0,4,0,0,27004,0,0,26124),
(84301,'','Such skill! You must have gone through much to learn how to fight like that. Two targets remain.',0,0,0,0,0,0,4,0,0,27005,0,44675,26124),
(84302,'','Now we hunt down Vorgorsh.',0,0,0,0,0,0,4,0,0,27006,0,44674,26124),
(84303,'','Now we hunt down Zulmork.',0,0,0,0,0,0,4,0,0,27007,0,44673,26124),
(84304,'|TInterface\\Icons\\ability_hanzandfranz_bodyslam.blp:20|t$n is going to be hit by |cFFF00000|Hspell:159646|h[Body Slam]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(84305,'','I\'ll head to your garrison and get your mages in line. See you there!',0,0,0,0,0,0,1,0,0,0,0,44024,26124),
(84306,'If you\'ll excuse me, commander, I\'d like to see your garrison and get your mages in line.','',0,0,0,0,0,0,1,0,0,0,45501,0,26124),
(84307,'Only Cromaug remains now.','',0,0,0,0,0,0,4,0,0,27008,45837,0,26124),
(84308,'A fine strike! Onward to our next kill! Both Vorgorsh and Cromaug remain.','',0,0,0,0,0,0,4,0,0,27009,0,0,26124),
(84309,'Now we need to hunt down Vorgorsh.','',0,0,0,0,0,0,4,0,0,27010,45835,0,26124),
(84310,'Only Cromaug remains now.','',0,0,0,0,0,0,4,0,0,27011,45837,0,26124),
(84311,'A fine strike! Onward to our next kill! Both Zulmork and Cromaug remain.','',0,0,0,0,0,0,4,0,0,27012,0,0,26124),
(84312,'Zulmork is our last target.','',0,0,0,0,0,0,4,0,0,27014,0,0,26124),
(84314,'A fine strike! Onward to our next kill! Both Zulmork and Vorgorsh remain.','',0,0,0,0,0,0,4,0,0,27016,0,0,26124),
(84315,'Now we hunt down Zulmork.','',0,0,0,0,0,0,4,0,0,27017,45834,0,26124),
(84316,'Now we hunt down Vorgorsh.','',0,0,0,0,0,0,4,0,0,27015,45835,0,26124),
(84317,'Archmage, if $p is to succeed in their mission the vanguard must not fall!','',0,0,0,0,0,0,0,0,0,0,46402,0,26124),
(84318,'I will not stand by and watch our heroes be destroyed!','',0,0,0,0,0,0,0,0,0,0,46403,0,26124),
(84319,'FURY OF STORMS, HEAR MY PLEA!','',0,0,0,0,0,0,0,0,0,0,46404,0,26124),
(84320,'I will not be able to defend the front for much longer. My power here is greatly diminished. $p must succeed or Azeroth will fall.','',0,0,0,0,0,0,0,0,0,0,46405,0,26124),
(84321,'Commander, reinforcements from the arcane sanctum have arrived!','',0,0,0,0,0,0,71,0,0,0,45847,0,26124),
(84322,'Nooooo! You can\'t take Wibson, he\'s all I have left!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84323,'Avenge me, Wibson. Avenge me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84324,'Sappy\'s feeder?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84325,'Sappy hungry.','',0,0,0,0,0,0,449,0,0,0,0,0,26124),
(84326,'<Feed Sappy.>','<Feed Sappy.>',0,0,0,0,0,0,449,0,0,0,0,0,26124),
(84327,'Turn away to avoid Roakk\'s |cFFFF0000|Hspell:166139|h[Blinding Light]|h|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84328,'If you\'ve got the gold, I\'ve got the goods!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84329,'Let\'s take a look','Let\'s take a look',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84330,'','D\'kaan, let\'s get in there.',0,0,0,0,0,0,0,0,0,0,0,45575,26124),
(84331,'Siege engines, fire.','',0,0,0,0,0,0,0,0,0,0,46878,0,26124),
(84332,'','Alliance, advance!',0,0,0,0,0,0,0,0,0,0,0,45576,26124),
(84333,'Warsong, bring me their heads!','',0,0,0,0,0,0,0,0,0,0,44541,0,26124),
(84334,'','We\'ll protect you while you flank them to the west.',0,0,0,0,0,0,0,0,0,0,0,45577,26124),
(84335,'Watch out. Wolfriders!','',0,0,0,0,0,0,0,0,0,0,45100,0,26124),
(84336,'Welcome! Come rest your head and leave your coin!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(84337,'Warsong, run them down!','',0,0,0,0,0,0,0,0,0,0,46278,0,26124),
(84338,'Fetch, girl.','',0,0,0,0,0,0,0,0,0,0,46279,0,26124),
(84339,'You won\'t survive this.','',0,0,0,0,0,0,0,0,0,0,46280,0,26124),
(84340,'Finish these weaklings.','',0,0,0,0,0,0,0,0,0,0,46281,0,26124),
(84341,'No... this can\'t be.','',0,0,0,0,0,0,0,0,0,0,46282,0,26124),
(84342,'','We need to move up.',0,0,0,0,0,0,0,0,0,0,0,44689,26124),
(84343,'Leap from your caves, my wolves.','',0,0,0,0,0,0,0,0,0,0,44542,0,26124),
(84344,'Seal those wolf dens!','',0,0,0,0,0,0,0,0,0,0,46816,0,26124),
(84345,'Bad news, commander. They\'ve enslaved Durn the Hungerer.','',0,0,0,0,0,0,0,0,0,0,46879,0,26124),
(84346,'','We have to go through the beast to get to Garrosh.',0,0,0,0,0,0,0,0,0,0,0,45578,26124),
(84347,'Loose the Hungerer.','',0,0,0,0,0,0,0,0,0,0,44543,0,26124),
(84348,'','Get into the Holy Light.',0,0,0,0,0,0,0,0,0,0,0,45579,26124),
(84349,'Rangari, fire!','',0,0,0,0,0,0,0,0,0,0,46880,0,26124),
(84350,'Come, draenei witch. I\'m waiting.','',0,0,0,0,0,0,0,0,0,0,44544,0,26124),
(84351,'','D\'kaan, I need you and our forces to stay here.',0,0,0,0,0,0,397,0,0,0,0,45580,26124),
(84352,'','Buy us the time we need to deal with Garrosh.',0,0,0,0,0,0,396,0,0,0,0,45581,26124),
(84353,'Whatever happens, Maraad would be proud of you.','',0,0,0,0,0,0,396,0,0,0,46881,0,26124),
(84354,'Blow open these gates!','',0,0,0,0,0,0,603,0,0,0,46882,0,26124),
(84355,'You\'re a fool to come here.','',0,0,0,0,0,0,0,0,0,0,44545,0,26124),
(84356,'You think after everything, you can kill me?','',0,0,0,0,0,0,0,0,0,0,44546,0,26124),
(84357,'','We\'ll bring you to justice, monster!',0,0,0,0,0,0,0,0,0,0,0,45582,26124),
(84358,'Justice. You don\'t know the meaning of the word.','',0,0,0,0,0,0,0,0,0,0,44547,0,26124),
(84359,'I am your death.','',0,0,0,0,0,0,0,0,0,0,44548,0,26124),
(84360,'Taste Gorehowl\'s steel.','',0,0,0,0,0,0,0,0,0,0,44549,0,26124),
(84361,'I cannot be defeated.','',0,0,0,0,0,0,0,0,0,0,44550,0,26124),
(84362,'Now, you die.','',0,0,0,0,0,0,0,0,0,0,44551,0,26124),
(84363,'Garrosh!','',0,0,0,0,0,0,0,0,0,0,46391,0,26124),
(84364,'Thrall? You\'re too late, old friend.','',0,0,0,0,0,0,0,0,0,0,44552,0,26124),
(84365,'No. No more, Garrosh. Just you and me.','',0,0,0,0,0,0,0,0,0,0,46392,0,26124),
(84366,'I challenge you to Mak\'gora.','',0,0,0,0,0,0,0,0,0,0,46393,0,26124),
(84367,'','Thrall, no.',0,0,0,0,0,0,0,0,0,0,0,45583,26124),
(84368,'Very well, shaman. We finish this alone, where it all began...','',0,0,0,0,0,0,0,0,0,0,44553,0,26124),
(84369,'... at the Stones of Prophecy.','',0,0,0,0,0,0,0,0,0,0,44554,0,26124),
(84370,'','Commander, over here.',0,0,0,0,0,0,0,0,0,0,0,45584,26124),
(84371,'','Now, commander!',0,0,0,0,0,0,0,0,0,0,0,45585,26124),
(84372,'Commander, over here.','',0,0,0,0,0,0,0,0,0,0,46883,0,26124),
(84373,'Now, commander!','',0,0,0,0,0,0,0,0,0,0,46884,0,26124),
(84374,'I\'ve seen it in my dreams... these strangers from other worlds would burn everything we\'ve fought for.','',0,0,0,0,0,0,0,0,6,0,46078,0,26124),
(84375,'But it is orc blood that runs in the veins of Draenor!','',0,0,0,0,0,0,0,0,6,0,46079,0,26124),
(84376,'Go forth, Iron Horde!  Make corpses of our enemies.','',0,0,0,0,0,0,0,0,6,0,46080,0,26124),
(84377,'For the glory of Grommash!','',0,0,0,0,0,0,0,0,6,0,46081,0,26124),
(84378,'','Well done! Two more to go.',0,0,0,0,0,0,4,0,0,26114,0,44033,26124),
(84379,'Masterful fighting! Two more to go.','',0,0,0,0,0,0,4,0,0,26005,45510,0,26124),
(84380,'A fine strike! Two remain.','',0,0,0,0,0,0,4,0,0,27016,45836,0,26124),
(84381,'','Such skill! You must have gone through much to learn how to fight like that. Two targets remain.',0,0,0,0,0,0,4,0,0,27002,0,44675,26124),
(84382,'','RAMPAGING BEASTS CHARGING TO OUR POSITION!',25,0,0,0,0,0,0,0,0,0,0,45713,26124),
(84383,'Conserve your energy. We must ensure that $p completes the mission. I will deal with the beasts myself!','',25,0,0,0,0,0,0,0,0,0,44774,0,26124),
(84384,'Aggra, let\'s get in there.','',0,0,0,0,0,0,0,0,0,0,45270,0,26124),
(84385,'Light, grant me your vengeance and $p your protection.','',25,0,0,0,0,0,0,0,0,0,44775,0,26124),
(84386,'','Demolishers, fire.',0,0,0,0,0,0,0,0,0,0,0,46200,26124),
(84387,'Advance!','',0,0,0,0,0,0,0,0,0,0,45271,0,26124),
(84388,'Warsong, bring me their heads!','',0,0,0,0,0,0,0,0,0,0,44555,0,26124),
(84389,'We\'ll protect you while you flank them to the west.','',0,0,0,0,0,0,0,0,0,0,45272,0,26124),
(84390,'Watch out. Wolfriders!','',0,0,0,0,0,0,5,0,0,0,43724,0,26124),
(84391,'Warsong, run them down!','',0,0,0,0,0,0,0,0,0,0,46278,0,26124),
(84392,'You won\'t survive this.','',0,0,0,0,0,0,0,0,0,0,46280,0,26124),
(84393,'Fetch, girl.','',0,0,0,0,0,0,0,0,0,0,46279,0,26124),
(84394,'Finish these weaklings.','',0,0,0,0,0,0,0,0,0,0,46281,0,26124),
(84395,'No... this can\'t be.','',0,0,0,0,0,0,0,0,0,0,46282,0,26124),
(84396,'','We need to move up.',0,0,0,0,0,0,0,0,0,0,0,46817,26124),
(84397,'Leap from your caves, my wolves.','',0,0,0,0,0,0,0,0,0,0,44556,0,26124),
(84398,'','Seal those wolf dens!',0,0,0,0,0,0,397,0,0,0,0,46818,26124),
(84399,'','Bad news, commander. They\'ve enslaved Durn the Hungerer.',0,0,0,0,0,0,0,0,0,0,0,46201,26124),
(84400,'We have to go through the beast to get to Garrosh.','',0,0,0,0,0,0,0,0,0,0,45273,0,26124),
(84401,'Loose the Hungerer.','',0,0,0,0,0,0,0,0,0,0,44557,0,26124),
(84402,'Darkspear, fire!','',0,0,0,0,0,0,0,0,0,0,45274,0,26124),
(84403,'','Get next to my healing totem.',0,0,0,0,0,0,0,0,0,0,0,46202,26124),
(84404,'Come, warchief. I am waiting.','',0,0,0,0,0,0,0,0,0,0,44558,0,26124),
(84405,'Aggra, I need you and our forces to stay here.','',0,0,0,0,0,0,397,0,0,0,45275,0,26124),
(84406,'Buy us the time we need to deal with Garrosh.','',0,0,0,0,0,0,396,0,0,0,45276,0,26124),
(84407,'','Please know, Durotan, you have been like a father to Thrall.',0,0,0,0,0,0,25,0,0,0,0,46203,26124),
(84408,'','Blow open these gates!',0,0,0,0,0,0,603,0,0,0,0,46204,26124),
(84409,'You\'re a fool to come here.','',0,0,0,0,0,0,0,0,0,0,49404,0,26124),
(84410,'You think after everything, you can kill me?','',0,0,0,0,0,0,0,0,0,0,44559,0,26124),
(84411,'We\'ll bring you to justice, monster!','',0,0,0,0,0,0,0,0,0,0,45277,0,26124),
(84412,'Justice. You don\'t know the meaning of the word.','',0,0,0,0,0,0,0,0,0,0,44560,0,26124),
(84413,'I am your death.','',0,0,0,0,0,0,0,0,0,0,44561,0,26124),
(84414,'I cannot be defeated.','',0,0,0,0,0,0,0,0,0,0,44562,0,26124),
(84415,'Now, you die.','',0,0,0,0,0,0,397,0,0,0,44563,0,26124),
(84416,'Garrosh!','',0,0,0,0,0,0,333,0,0,0,46391,0,26124),
(84417,'Thrall? You\'re too late, old friend.','',0,0,0,0,0,0,14,0,0,0,44564,0,26124),
(84418,'No. No more, Garrosh. Just you and me.','',0,0,0,0,0,0,396,0,0,0,46392,0,26124),
(84419,'I challenge you to Mak\'gora.','',0,0,0,0,0,0,53,0,0,0,46393,0,26124),
(84420,'Thrall, no.','',0,0,0,0,0,0,0,0,0,0,45278,0,26124),
(84421,'Very well, shaman. We finish this alone, where it all began...','',0,0,0,0,0,0,153,0,0,0,44565,0,26124),
(84422,'... at the Stones of Prophecy.','',0,0,0,0,0,0,396,0,0,0,44566,0,26124),
(84423,'','Commander, over here.',0,0,0,0,0,0,0,0,0,0,0,46205,26124),
(84424,'Commander, over here.','',0,0,0,0,0,0,0,0,0,0,45279,0,26124),
(84425,'','Now, commander!',0,0,0,0,0,0,0,0,0,0,0,46199,26124),
(84426,'Now, commander!','',0,0,0,0,0,0,0,0,0,0,45280,0,26124),
(84427,'Taste Gorehowl\'s steel.','',0,0,0,0,0,0,0,0,0,0,44567,0,26124),
(84428,'Fight on, brothers and sisters! $p will see us through this war!','',25,0,0,0,0,0,0,0,0,0,44776,0,26124),
(84429,'Merely adolescent gronn, Khadgar. Nothing that Commander $p couldn\'t handle alone.','',25,0,0,0,0,0,0,0,0,0,44777,0,26124),
(84430,'The shadows gather in Veil Terokk, beneath the lonely spire.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84431,'Let me get to da beaten!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84432,'\'Dis mace wants to help out with ya beaten.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84433,'You done getting beaten?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84434,'Dis here be your last beaten!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84435,'I gots something to tell you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84436,'I heard you like da beaten!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84437,'Thank you! I would have surely died in there.','Thank you! I would have surely died in there.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(84438,'I\'ll never forget this.','I\'ll never forget this.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(84439,'Thank the light! I shall go rescue my sisters.','Thank the light! I shall go rescue my sisters.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(84440,'You are a true hero.','You are a true hero.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(84441,'Lok\'tar!','Lok\'tar!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(84442,'I\'m going to slay every ogre I see!','I\'m going to slay every ogre I see!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(84443,'Thank you, $n. May the spirits guide you.','Thank you, $n. May the spirits guide you.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(84444,'Sweet freedom!','Sweet freedom!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(84445,'Where is my power, ogre?','',0,0,0,0,0,0,0,0,6,0,45314,0,26124),
(84446,'Your power? (It\'s MY power!)','',0,0,0,0,0,0,0,0,6,0,46620,0,26124),
(84447,'You will obey, disciple. Hand over its reins.','',0,0,0,0,0,0,0,0,6,0,45315,0,26124),
(84448,'I think not. (We\'re done taking orders from you!)','',0,0,0,0,0,0,0,0,6,0,46621,0,26124),
(84449,'Now THAT\'S how archaeology is done!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84450,'Hey Boss, you sure this thing\'s safe?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84451,'Fel energies are even now devouring Exarch Hataaru\'s soul. We must act quickly.$b$bSoulbinder Nyami will anchor Hataaru\'s spirit to this realm while I exorcise the demons assaulting him. With luck, we will find out who murdered him.$b$bIt will be up to you to destroy the evil as I unleash it. Are you ready, $n?','',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(84452,'I am ready. Begin the ritual, Exarch.','I am ready. Begin the ritual, Exarch.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84453,'A traitor among us - a fallen Exarch!$b$bThis is... unthinkable.','',274,0,0,0,0,0,274,0,0,0,0,0,26124),
(84454,'Let\'s get moving! $n, we\'ll see you back at camp.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84455,'I will be unable to help once the ritual begins. Stay focused.','',0,0,0,0,0,0,1,0,0,0,44606,0,26124),
(84456,'','The body is ready, Exarch. I will anchor his spirit.',0,0,0,0,0,0,6,0,0,0,0,43625,26124),
(84457,'Of course! A little cosmic radiation never hurt anybody!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84458,'','Hey there and welcome to the Rusty Cylinder Bar and Grill!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84459,'Golad, maloch, valsheva. Follow the sound of my voice, spirit - lend your sight to the living. Golad, maloch, valsheva!','',0,0,0,0,0,0,0,0,0,0,44607,0,26124),
(84460,'Begone, exarch. This one, and all he knows, belongs to us now.','',0,0,0,0,0,0,0,0,0,27250,45523,0,26124),
(84461,'You may have claimed his body, but his immortal soul is mine to protect.','',0,0,0,0,0,0,0,0,0,0,44608,0,26124),
(84462,'Golad, maloch, valsheva! Golad, maloch, valsheva - Light give me strength...','',0,0,0,0,0,0,0,0,0,0,44609,0,26124),
(84463,'We\'ve learned much from K\'ure. (We\'re writing a book.)','',0,0,0,0,0,0,0,0,6,0,46622,0,26124),
(84464,'You\'re insane.','',0,0,0,0,0,0,0,0,6,0,45316,0,26124),
(84465,'Run away, old man. (Soon Highmaul will burn. Then, the world!)','',0,0,0,0,0,0,0,0,6,0,46623,0,26124),
(84466,'','The glider is good to go! Just let us know if you find anything good, okay?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84467,'','Looks like this spot\'s dried up. Maybe you should try one of the other gliders.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84468,'Golad, maloch, valsheva. Follow the sound of my voice, spirit. Lend your sight to the living. Golad, maloch, valsheva!','',0,0,0,0,0,0,1,0,0,0,44607,0,26124),
(84469,'Quickly now, I have a bad feeling about all this...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84470,'Hiya, pal. Nice day for some gliding, eh?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84471,'You... strange invaders...','',0,0,0,0,0,0,0,0,0,0,44441,0,26124),
(84472,'You seek to disable the Dark Portal?','',0,0,0,0,0,0,0,0,0,0,44442,0,26124),
(84473,'I can help you. Just... set me free.','',0,0,0,0,0,0,0,0,0,0,44443,0,26124),
(84474,'How many Artifact Fragments have we collected?','How many Artifact Fragments have we collected?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84475,'A persistent one, aren\'t ya? I think you\'re safe to move on now, boss.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84476,'We currently have $9250w collected. We need $9706w total.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84477,'Glider\'s all yours, friend. I\'d go myself, but untimely death is not my thing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84478,'Still alive, eh? If I were you, I\'d cut my losses while you\'re ahead. There can\'t be anything more worth finding around here anyway.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84479,'There\'s a party in your heart, and all the bladed weapons are invited.  Have a pleasant day.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(84480,'My presence is requested for duty.  I must leave immediately.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(84481,'Rent my constructs.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84482,'Ok, I\'ll rent them.','Ok, I\'ll rent them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84483,'Put them away please.','Put them away please.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84484,'How do you like my constructs?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84485,'Rent Constructs for 1 copper?','Rent Constructs for 1 copper?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84486,'Not until we know. We must know who did this to him!','',0,0,0,0,0,0,0,0,0,0,44610,0,26124),
(84487,'Exoch, maloch, talomai! Hataaru, come to the light...','',0,0,0,0,0,0,0,0,0,0,44611,0,26124),
(84488,'K\'ure will be deeply missed by my people, but the story of your courage in the face of evil will inspire them.','',0,0,0,0,0,0,1,0,0,0,45911,0,26124),
(84489,'','Exarch, they\'re tearing his soul apart. We must stop this!',0,0,0,0,0,0,6,0,0,0,0,43626,26124),
(84490,'Auchindoun... they wanted...','',0,0,0,0,0,0,0,0,0,0,46756,0,26124),
(84491,'...wanted what, Hataaru? The codes to Auchindoun? Your security wards?','',0,0,0,0,0,0,0,0,0,0,44612,0,26124),
(84492,'','Maladaar. We\'re losing him.',0,0,0,0,0,0,6,0,0,0,0,43627,26124),
(84493,'...the Exarch\'s orders...','',0,0,0,0,0,0,0,0,0,0,46757,0,26124),
(84494,'Who, Hataaru? Who had you killed?','',0,0,0,0,0,0,0,0,0,0,44613,0,26124),
(84495,'<coughs> What foul stench!  I don\'t think I got a full breath of it though...','',0,0,0,0,0,0,584,0,0,924,0,0,26124),
(84496,'...Soulbinder...','',0,0,0,0,0,0,0,0,0,0,46758,0,26124),
(84497,'%s points at Soulbinder Nyami.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84498,'','We were about to lose him. You saw him - he called out to me for help. His spirit is safe now.',0,0,0,0,0,0,1,0,0,0,0,43628,26124),
(84499,'What happened? Why did you stop it?','',0,0,0,0,0,0,1,0,0,0,44614,0,26124),
(84500,'He mentioned an Exarch. A betrayal from within the council itself?','',0,0,0,0,0,0,1,0,0,0,44615,0,26124),
(84501,'Nyami, take the body to Auchindoun and lay it to rest.','',0,0,0,0,0,0,25,0,0,0,44616,0,26124),
(84502,'%s is about to vomit ectoplasm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84503,'Purge the void energy from the Soulgrinder!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84504,'The Soulgrinder is purged!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84505,'','With all these rampaging elementals, we\'re running short on pilots. Got plenty of gliders, though. Take one out for a spin and see what you find!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84506,'prelude 2. Stage: $8883w sub-stage: $8938w','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84507,'','No sense in risking your neck out there anymore. We\'ve cleared out all of the profitable excavations.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84512,'','We\'ll find a way out of this, that\'s what Pinchwhistles do best!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84513,'Stop - stop the ritual at once! Focus. We must protect his spirit.','',0,0,0,0,0,0,5,0,0,0,44617,0,26124),
(84514,'Our forces are faltering, and my energy is waning, $n. We have precious little time left before we are overwhelmed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84515,'The mana bombs are placed!','The mana bombs are placed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84516,'Use whatever means are necessary, champion. Azeroth\'s final hope lies with you.','',0,0,0,0,0,0,1,0,0,0,44873,0,26124),
(84517,'You cannot escape us, scrollkeeper!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84518,'Your beak will make a fine trophy for the High Sage!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84519,'Your pitiful uprising ends here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84520,'Did you think yourself safe in the woods? Rukhmar sees all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84521,'Filthy, accursed wretch - allow me to end your misery.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84522,'Ah, such easy prey.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84523,'Found you, Reshad!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84524,'RuaAWK!! What\'s this?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84525,'A decoy?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84526,'My eyes! What\'s happening?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84527,'Rrre... shaaad...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84528,'WAAWWK! Where... where am I?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84529,'','Did the boss send you?\n\nLook, if he asks, just tell him I\'m doing some underwater excavation.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84530,'If you ask me, excavating giant mushrooms sounds like a bad idea, but you\'re welcome to grab a glider and take a look. After all, it\'s not my time you\'re wastin\'.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84531,'I doubt you\'ll find anything more out there. All I\'m seeing here is mushrooms, mushrooms, and more mushrooms.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84532,'This is it... this is it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84533,'Dead... or used up.  I was so sure I would find what I needed here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84534,'Wait, I feel it.  It is closer now.  Quickly! To me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84535,'This unfortunate soul seems to have suffered a rather disastrous fall.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84536,'Stop wasting time, Goblin. Keep that city in sight.','Stop wasting time, Goblin. Keep that city in sight.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(84537,'Don\'t lose focus, mage. We don\'t have all day.','Don\'t lose focus, mage. We don\'t have all day.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(84538,'Keep that portal open. Our Far Seers have almost calibrated the cannon.','Keep that portal open. Our Far Seers have almost calibrated the cannon.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(84539,'Peon, get those bombs in the cannon. NOW!','Peon, get those bombs in the cannon. NOW!',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(84540,'What are you doing, maggot? You\'re supposed to have this done yesterday!','What are you doing, maggot? You\'re supposed to have this done yesterday!',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(84541,'Hurry it up!','Hurry it up!',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(84542,'Far Seers, status report!','Far Seers, status report!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(84543,'Shaman, give me an update.','Shaman, give me an update.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(84544,'What do you see?','What do you see?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(84545,'We\'re nearly there, Captain.','We\'re nearly there, Captain.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84546,'She\'s just ahead, Captain.','She\'s just ahead, Captain.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84547,'Almost in sight, Captain.','Almost in sight, Captain.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84548,'','I have laid out a list of available missions for your forces on the command table for you.$B$BI will relay any orders to your garrison for your convenience, commander.',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(84549,'We must go.  I am so close now...  I must find it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84550,'I can\'t see...  I need a moment...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84551,'Is... is this the place?  Is it here?  Clear these creatures so I can think!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84552,'I\'m okay.  We must keep moving.  It calls to us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84553,'Step aside, $p. Let us see if this fellow had anything worthwhile...','',0,0,0,0,0,0,0,0,0,0,46010,0,26124),
(84554,'Mind the door, will you?','',0,0,0,0,0,0,0,0,0,0,46011,0,26124),
(84555,'Argh!  I can\'t think with all these beasts shouting at me.  Stop their screaming!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84556,'Almost... almost there.  Just a little further.  Soon...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84557,'We are finally here... yet something is wrong.  I have to get closer... I have no choice!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84558,'I see it all now. It wants me to take the spores out of the Crimson Fen and give them to my friends.  I... must do it!  You must stop me $p!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84559,'Hold off the Adherents.','Hold off the Adherents.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84560,'My, my... What a curious collection...','',0,0,0,0,0,0,0,0,0,0,46012,0,26124),
(84561,'Percy, what\'s that you\'ve got there? Come, now, let\'s see it...','',0,0,0,0,0,0,0,0,0,0,46013,0,26124),
(84562,'Fifty Layers of Shadow?! PERCIVAL, YOU PUT THAT BACK THIS INSTANT.','',0,0,0,0,0,0,0,0,0,0,46014,0,26124),
(84563,'Ah, here\'s something! The Saga of Terokk.','',0,0,0,0,0,0,0,0,0,0,46016,0,26124),
(84564,'And he\'s written notes inside. Here, have a look.','',0,0,0,0,0,0,0,0,0,0,46017,0,26124),
(84565,'Nasty bird...','',0,0,0,0,0,0,0,0,0,0,46015,0,26124),
(84566,'In death... I am free...','',0,0,0,0,0,0,0,0,4,0,46294,0,26124),
(84567,'My life for Commander $p.','My life for Commander $p.',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(84568,'Throm-Ka, Commander.','Throm-Ka, Commander.',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(84569,'Lok\'tar, commander.','Lok\'tar, commander.',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(84570,'We live and die for your will, commander.','We live and die for your will, commander.',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(84571,'At your service, commander.','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(84572,'Travel well, commander.','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(84573,'The spirits smile upon you, commander.','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(84574,'May the wind carry tales of your greatness, commander.','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(84575,'Destroy the relic, invader!','',0,0,0,0,0,0,0,0,0,0,44444,0,26124),
(84576,'Those Iron cowards were using us as conduits to power their portal. They will regret that.','',0,0,0,0,0,0,1,0,4,0,44445,0,26124),
(84577,'The Shadow Council thanks you.','',0,0,0,0,0,0,273,0,4,0,44446,0,26124),
(84578,'You... outsider. Destroy that relic, and set us free. (Crush the relic! Smash the relic!)','',0,0,0,0,0,0,0,0,0,0,46625,0,26124),
(84579,'Crush the relic! Smash the relic!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84580,'Seek out Gul\'dan if you truly wish to stop the Iron Horde. (Gul\'dan! Gul\'dan powers the portal!)','',0,0,0,0,0,0,0,0,4,0,46626,0,26124),
(84581,'Gul\'dan! Gul\'dan powers the portal!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(84582,'Dig faster! The Sorcerer King wants more relics!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84583,'Work faster! The key to the relic is in here somewhere!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84584,'No more smashing artifacts! The Sorcerer King wants them unbroken!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84585,'Kill any intruders on sight! We supposed to keep what we doing secret!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84586,'First rule of digging for relics is don\'t talk about the relics!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84587,'Why you idiots break so many wagons? Now you have to carry the relics to Highmaul!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84588,'If you slack off you gonna answer to the Sorcerer King!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84589,'Look! The portal grows weaker!','',0,0,0,0,0,0,0,0,0,0,44883,0,26124),
(84590,'Hold that front! Our work is nearly done!','',0,0,0,0,0,0,0,0,0,0,44884,0,26124),
(84591,'Iron Horde! The intruders are freeing our prisoners!','',0,0,0,0,0,0,0,0,0,0,46504,0,26124),
(84592,'Stop them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84593,'Thank you, stranger.','',0,0,0,0,0,0,0,0,1,0,46565,0,26124),
(84594,'Rarrgh! I hope you like dying!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84595,'Puny, $r! I\'ll squish you like a bug!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84596,'I want to smash you to bits! Rarrgh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84597,'Hi','Hi',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84598,'I\'m going to crush your skull!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84599,'You going to pay for stealing the relic! Rargh!','',0,0,0,0,0,0,0,0,0,27089,0,0,26124),
(84600,'You and those pesky goblins gonna pay!','',0,0,0,0,0,0,0,0,0,27089,0,0,26124),
(84601,'That relic was for Highmaul! You gonna die!','',0,0,0,0,0,0,0,0,0,27089,0,0,26124),
(84602,'You stole the relic, now I gonna crush your bones!','',0,0,0,0,0,0,0,0,0,27089,0,0,26124),
(84603,'Keep it down, boss. If the Warsong found us up here, well, let\'s just say it\'d be bad for business.','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(84604,'These Warsong guys couldn\'t possibly need all of the supplies they\'ve been stockpiling here - especially after the Horde puts the hurt on \'em. \n\nSo the way I see it, if we want to take some to make some profit on the side, what\'s the harm?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84605,'The miasma here coats everything! We should not stay long...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84606,'I can\'t seem to get this filth off of me... don\'t worry, I\'ve crawled through worse...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84607,'It is so hazy here, I can barely see... and its so loud.  I wish everyone would be quiet!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84608,'Tell D\'kaan... I am... sorry...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84609,'No sticky spores are going to stop me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84610,'Let\'s be done with this. There is power here, I can smell and taste it! No screaming marsh or misty monsters are going to stop me!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84611,'We... we could have ruled Gorgrond with this... red everywhere...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84612,'Just one more bolt to tighten....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84613,'The goren fled, but I don\'t think they fled from us...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84614,'','<Ka\'alu calmly gazes at you a moment before her voice fills your thoughts.>$b$bIn all of these eons I have never allowed anyone to ride upon my back. But now is the time for my vanity to end, too many lives hang in the balance.$b$bThe children of Rukhmar threaten both these accursed ones and my flock. I know that it is only together, with all of our strength, can we prevail.$b$bAre you ready to do that which must be done?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84615,'','Careful if you plan on taking the glider over Grommashar, pal. Those orcs down there are not too fond of the pop-in.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84616,'','I think you cleaned those Warsong out good an\' proper. No sense in risking your neck out there anymore.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84617,'','Nagrand is just full of amazing artifacts and the Steamwheedle Preservation Society is here to find them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84618,'What does the Ancient of War do?','What does the Ancient of War do?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84619,'Back to the shadows for us, Percy.','',0,0,0,0,0,0,1,0,0,0,46018,0,26124),
(84620,'Ahh, it\'s you. Trust me, friend, I will handle this. You may go.','',0,0,0,0,0,0,0,0,0,0,43281,0,26124),
(84621,'','Well \'ello there! \'Ave ya got somethin\' for me today?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84622,'','Even the skies can be dangerous in Gorgrond. Be on your guard.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84623,'I need to meet with Rangari Erdanii.','I need to meet with Rangari Erdanii.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84624,'Fangraal will march into the Road of Glory and clear it of any Horde it finds.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84625,'What is that? Is that Maladaar\'s work? No no, you don\'t need to do that. He is not to be trusted.','',0,0,0,0,0,0,6,0,0,0,43282,0,26124),
(84626,'','The Gateways are up and running, $n! Use them to move around Ashran faster.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84627,'','The Warlocks will erect Gateways so we can move around Ashran faster. We just need the magical power from those scattered artifact pieces found around Ashran. $B$BHow many have you brought me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84628,'She\'s nothing now, a twisted soul chained to our world.  My sister was so sweet, so loving, so young... The Shadowmoon did this!  Twisted her by some foul magic! They left her walking the world as a shadow, crying out in eternal torment.\n\nI couldn\'t.  I can\'t.  I cannot end her pain.  I cannot be the one to relive her pain.\n\nRelease her spirit.  Put her to rest.  I cannot bear seeing her like this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84629,'So you\'ve done it?  Well, then.  Be gone and leave me to my mourning.\n\nSo young... she was so young...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84630,'','Our work here is finished. The forgotten children of Rukhmar fight bravely against their headstrong brethren. Now, we must continue our attack. Hold tightly, our destination is the next spire.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84631,'','We currently have $9261w collected. We need $9708w total.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84632,'Yield, old friend... and we shall show mercy in your final hour.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(84633,'','Socrethar! We bear proof of your slain lieutenants. Will you take retribution against us, or are you afraid?',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(84634,'','They fell beneath the glory of the Light. As you will fall before us, demon!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(84635,'Who dares to challenge me? I am the voice of those who will burn this world to ash!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(84636,'Never! My power is that of the Burning Legion... endless.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(84637,'Now, DIE!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(84638,'','When you see Gazmolf, tell him Gabby sent you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84639,'That wretched outcast begged for death in the end - and so will you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84640,'We can\'t allow that relic to fall into ogre hands! It belongs in a private collection!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84641,'So this is what the little sneak was hiding... the High Sage will be pleased.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84642,'','The Gateways activate at the South-East and North-West of Ashran. Use them to teleport between the two points.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84643,'What do the Gateways do?','What do the Gateways do?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84644,'Failure!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84645,'Ornekka, it is not safe here - the Adherents are out in force. Come with us to Veil Terokk.','',0,0,0,0,0,0,1,0,0,0,46008,0,26124),
(84646,'Oh, how sweet of you, Reshad! I never knew you cared.','',0,0,0,0,0,0,11,0,0,0,46233,0,26124),
(84647,'But my old bones would only slow you down. I\'ll be fine here.','',0,0,0,0,0,0,1,0,0,0,46234,0,26124),
(84648,'See you on the next dig, $n! We couldn\'t have done it without you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84649,'Well fought, Lady Liadrin. Let us meet back at the Spire of Light.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(84650,'','Same to you, Exarch. We have much to report to Archmage Khadgar.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(84651,'Very well. Let us proceed, $p.','',0,0,0,0,0,0,1,0,0,0,46009,0,26124),
(84652,'A Gronnling is terrifying your troops!','A Gronnling is terrifying your troops!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84653,'I have brought this as a peace offering. I hope we can become close allies.','I have brought this as a peace offering. I hope we can become close allies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84654,'You bring this strange gift and helped those in Skettis... yes, I think we can come to an arrangement. The shadows cover much.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84655,'What have we here? A friend of the family?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84656,'We cannot allow the Burning Legion to gain a foothold here on Draenor. Socrethar\'s reign must end.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84657,'','Socrethar is working directly with the Shadow Council. To stop the Burning Legion, we must end his reign.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84658,'I admit, even in Socrethar\'s madness, there was a hint of truth.','',0,0,0,0,0,0,396,0,4,0,0,0,26124),
(84659,'He questioned our complacency. Perhaps we have been too content, too SAFE, hiding here on Draenor.','',0,0,0,0,0,0,396,0,4,0,0,0,26124),
(84660,'A call is coming, hero. I feel it, large and looming, just beyond the horizon. When the time  comes, the draenei must answer.','',0,0,0,0,0,0,396,0,4,0,0,0,26124),
(84661,'','The |c00FFFF00|Hspell:178535|h[Warlock Gateway]|h|r has been activated! Check your map for the locations.',0,0,0,0,0,0,0,0,0,36470,0,8173,26124),
(84662,'','Today, we have defeated one of Gul\'dan\'s strongest allies.',0,0,0,0,0,0,396,0,4,0,0,0,26124),
(84663,'','Without their leader, the Sargerei will crumble. The Auchenai will soon be able to reclaim their city.',0,0,0,0,0,0,396,0,4,0,0,0,26124),
(84664,'','The |c00FFFF00|Hspell:178535|h[Warlock Gateway]|h|r has been destroyed by the Horde!',0,0,0,0,0,0,0,0,0,36470,0,8213,26124),
(84665,'','For now, we can consider this a monumental victory. Thank you, hero.',0,0,0,0,0,0,396,0,4,0,0,0,26124),
(84666,'The vanguard will hold the front, commander. You must complete your mission!','The vanguard will hold the front, commander. You must complete your mission!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84667,'Almost there. Come along, Percy!','',0,0,0,0,0,0,0,0,0,0,46024,0,26124),
(84668,'I am ready to fly, Ka\'alu.','I am ready to fly, Ka\'alu.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84669,'Set me free!','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(84670,'All\'s quiet!','All\'s quiet!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84671,'The news!','The news!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84672,'Raastok, I need a shroud at that dig site. Kura, back him up.','',0,0,0,0,0,0,0,0,0,0,46312,0,26124),
(84673,'Shadows gather...','',0,0,0,0,0,0,0,0,0,0,46025,0,26124),
(84674,'The Adherents grow bolder each day. It\'s all we can do to keep Veil Terokk shrouded from them.','',0,0,0,0,0,0,0,0,0,0,46314,0,26124),
(84675,'Do you have the relics?','',0,0,0,0,0,0,0,0,0,0,46315,0,26124),
(84676,'Yes, yes. And something unexpected, too! We have much to discuss.','',0,0,0,0,0,0,0,0,0,0,46027,0,26124),
(84677,'Go on ahead, I would like a word with $p.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84678,'','<The Raven Mother\'s voice coos within your mind.>$B$BDo you know why I allow these accursed, forgotten children of Rukhmar to live among my flock? it is because I weep for them.$B$BThey are trapped between two gods: one who fears and rejects them, and one who would enslave them to his dark will.$B$BTheir only champion abandoned them long ago, and nobody has stood beside them since.$B$BUntil you came along.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84679,'Thanks, commander. I don\'t know what I\'d do if something happened to her.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(84680,'Better get used to loss, kid. That\'s life.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(84681,'We\'re frostwolf. We don\'t lose, blood elf.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(84682,'','My family must be avenged.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(84683,'','Thank you for sending the commander, Mankrik.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(84684,'I don\'t ever want us to be apart again.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(84685,'Good on you, kid.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(84687,'Reshad! You survived Skettis!','',0,0,0,0,0,0,0,0,0,0,46313,0,26124),
(84688,'Yes, just barely. Are we late?','',0,0,0,0,0,0,0,0,0,0,46026,0,26124),
(84689,'','The spirits of my family are forever with in my heart.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(84690,'','Thank you for everything, commander.$B$BI\'m happy to be back here with Mankrik, even if he is a jerk sometimes. Don\'t tell him, but I kinda like him, too.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(84691,'I feel like a fool for not having gone with her.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(84692,'I\'m indebted to you for life, commander.$B$BOlgra and I were promised to each other. One day, she\'s going to be my wife.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(84693,'Heretics! Kill! Feast!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84694,'Damn him. I thought I\'d gotten rid of Maladaar when I gave him up to the Iron Horde.','',0,0,0,0,0,0,0,0,0,0,43283,0,26124),
(84695,'Yes, I had Hataaru killed. And you are next.','',0,0,0,0,0,0,0,0,0,0,43284,0,26124),
(84696,'The Legion\'s power is unsurpassed.','',0,0,0,0,0,0,0,0,0,0,43288,0,26124),
(84697,'','This jungle is beautiful. I have never seen a place like this before.$b$bOf course, Kaalya keeps insisting that is why \'the jungle will kill you.\'',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84698,'REMOVE - Good work. The artifact is yours to use.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84699,'','This jungle is no place for the temple-kneeler or the metal-bender.$b$bYou, however, I am not so sure of.$b$bYour weapons and gear speak of one who is experienced in a number of environments.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84700,'Rifling Books','Rifling Books',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(84701,'This is a traditional wayshrine. Terokk built many of them around the land to guide outcasts to Skettis.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84702,'If we are to move forward, we must understand what we\'ve left behind.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84703,'This blade looks worn and rusted... you said it was newly smithed!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84704,'This axe couldn\'t chop a twig... let alone a gladiator!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84705,'This blade has someone\'s initials engraved in it... did you find this on the arena floor?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84706,'These blades are too dull for combat....','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84707,'Your prices are reasonable... but these weapons are battered.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84708,'Are these gladiator weapons or souvenirs?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84709,'I would sooner take a tree branch into combat than this shield....','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84710,'Good to see you again, $p.$B$B I knew you couldn\'t leave the Adherents to run free - not after witnessing what they did in Aruuna and Veil Shadar.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84711,'You call that a battle axe? It looks more like a cheap hatchet....','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84712,'The fate of Azeroth depends on you, $n!','The fate of Azeroth depends on you, $n!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84713,'This is it, Commander $n. Judgment day is upon us! We must be victorious!','This is it, Commander $n. Judgment day is upon us! We must be victorious!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84714,'Get us home safely, $n. I have a family I\'d like to see again.','Get us home safely, $n. I have a family I\'d like to see again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84715,'If my death results in success for your mission it will be a death well spent.','If my death results in success for your mission it will be a death well spent.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84716,'It would seem that the gate is being powered by the souls of innocents!','It would seem that the gate is being powered by the souls of innocents!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84717,'I hear that Gul\'dan is here! Is it true, commander?','I hear that Gul\'dan is here! Is it true, commander?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84718,'I\'ve worked my whole life for this one moment. To die for Azeroth is the most glorious of deaths!','I\'ve worked my whole life for this one moment. To die for Azeroth is the most glorious of deaths!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84719,'','Come, COME! Sit yourself by my fire. Would you like some frogs legs?',1,0,0,0,0,0,0,7,1,0,0,0,26124),
(84720,'Your bodies shall feed the bloom. Aren\'t you thankful?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84721,'Now\'s my chance!','Now\'s my chance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84722,'Run!','Run!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84723,'She\'s dead! I\'m out of here!','She\'s dead! I\'m out of here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84724,'Thank you!','Thank you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84725,'Work it harder! Better! Faster! Stronger!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84726,'Take the rappelling rope down, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84727,'You think you are gladiators? I could crush your skulls between my toes!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84728,'Fight harder or I\'ll save you the trouble of dying in the arena and kill you myself!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84729,'I\'ll see you there. Don\'t wait up!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84730,'','Go on, I\'ll be fine! I\'ll catch up.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84731,'I am not the traitor here. It was the false prophet Velen who betrayed our people.','',0,0,0,0,0,0,0,0,0,0,43285,0,26124),
(84732,'Do you have supplies for me commander?  Every piece helps the war effort.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84733,'%s was holding a Bloodmaul Cache!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84734,'More supplies commander? Our soldiers could always use them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84735,'I\'m going to laugh when you weaklings die in the ring!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84736,'I serve our true master now. The Legion whose call I once denied.','',0,0,0,0,0,0,6,0,0,0,43286,0,26124),
(84737,'If you try to dance like a butterfly... you\'ll get crushed like one!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84738,'My Lord Sargeras will scorch this pathetic world, as he has countless others.','',0,0,0,0,0,0,5,0,0,0,43287,0,26124),
(84739,'You wimps aren\'t even worthy to clean the arena floor!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84740,'When you die in there, I\'ll make sure Meatgut puts what\'s left of you to good use!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84741,'You will eat, breathe, and kill for the glory of the arena!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84742,'I have sworn the sacrament. I have taken my new name... Socrethar.','',0,0,0,0,0,0,1,0,0,0,43289,0,26124),
(84743,'Hey oh! These plant people make quite a spread, but I canno\' stand the sight o\' it much longer!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(84744,'Lighting Torch','Lighting Torch',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(84745,'Check for a pulse.','Check for a pulse.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84746,'Cut down in the prime of his life, sadly the arbiter didn\'t make it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84747,'Shhh... You\'ll be okay, Nisha.','',0,0,0,0,0,0,0,0,1,0,46557,0,26124),
(84748,'That one almost hit me!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84749,'I didn\'t mean to steal from you, honest!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84750,'Nobody ever taught me that stealing was wrong! I was misled as a youth!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84751,'You can let me down now, I learned my lesson!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84752,'Wow, you want to fight in the arena with that aim?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84753,'All I did was borrow your purse... and your gear... and your mount. I was going to give it back!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84754,'You\'re pretty much the worst archer I\'ve ever seen!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84755,'Azeroth has been invaded by a vicious enemy that seems bent on world domination.$b$bWe must act quickly if we are to put a stop to the chaos that is unfolding around us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84756,'I promise never to lie, cheat, or steal ever again! Honest!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84757,'I will take my rightful place.','',0,0,0,0,0,0,15,0,0,0,43290,0,26124),
(84758,'The Legion will prevail.','',0,0,0,0,0,0,11,0,0,0,43294,0,26124),
(84759,'There are others at my command. In Shattrath and Auchindoun.','',0,0,0,0,0,0,0,0,0,0,43291,0,26124),
(84760,'Enough! When next we meet, it will be on MY terms.','',0,0,0,0,0,0,1,0,0,0,43292,0,26124),
(84761,'Tell the remaining exarchs to number their days.','',0,0,0,0,0,0,0,0,0,0,43293,0,26124),
(84762,'Initiate harvesting of organics.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84763,'Please! Take me to the town hall!','Please! Take me to the town hall!',0,0,0,0,0,0,0,0,0,23503,0,0,26124),
(84764,'Thank you!','Thank you!',0,0,0,0,0,0,0,0,0,23503,0,0,26124),
(84765,'Gar\'mak is dead. You fought well today. Meet me back at camp.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84766,'This madness ends now, Gar\'mak!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84767,'Attack!','Attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84768,'For the Alliance!','For the Alliance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84769,'For Nethergarde!','For Nethergarde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84770,'We must hold the frontline!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84771,'I am glad you are on our side, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84772,'We cannot win this battle if those Iron Horde war machines remain operational.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84773,'With those machines destroyed we can focus on our next move.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84774,'We cannot win this battle if the enemy is always one step ahead of us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84775,'Terrifying Gronnling Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84776,'With those scouts dead we have a greater chance of catching the Iron Horde by surprise. Excellent work, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84777,'My goods is only for ogres and gladiators! If you is something else, I\'ll crush your face with my hammer!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84778,'Nethergarde has lost so much already, I can\'t stand to see them lose more.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84779,'For the freshest meat come to Meatgut! If you don\'t, I\'ll pound your face in!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84780,'I am the night!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84781,'Hopefully the prisoners you saved will have an opportunity to rebuild Nethergarde to its former glory.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84782,'For the Raven Mother!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84783,'','Scrape your knee in the arena? I can fix any injury for the right price!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84784,'I can fly again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84785,'Bring those battleplans back to me and we can begin to dismantle this Iron Horde.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84786,'Come get your burgers! You like sausage? I\'ve got the juiciest clefthoof wieners around!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84787,'Hmm... it appears the Iron Horde has formed an alliance with the Dreadmaul ogres. This is going to be more difficult than I thought.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84788,'','You lookin\' to fight in the arena? I\'ve got everything you need under one roof!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84789,'Ahhhhhh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84790,'','Got someone you need to shank, bludgeon, cleave, or perforate? I\'ve got the right weapon for any job!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84791,'Charge!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84792,'Plant the Alliance flags inside Nethergarde, our men will do the rest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84793,'We must keep pushing back on the Iron Horde. They need to know we will not sit by and watch as they kill our brothers and sisters.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84794,'I will meet you at Okril\'lon. We will take down Gar\'mak together.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84795,'With Gar\'mak dead the Iron Horde will be in disarray until they appoint a new leader here on Azeroth. Although we have won this battle, I fear the war has just begun.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84796,'','Those ogres deserve a slow painful death. This poison will ensure that happens.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84797,'','My sister is avenged. I am in your debt, $c.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84798,'The will of the genesaur shall be upheld!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84799,'You\'re nothing more than a weed that must be pulled.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84800,'For Iyu!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84801,'For the genesaur!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84802,'Your body shall feed our armies.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84803,'Die, infestation of flesh.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84804,'You shall not pervert our grove.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84805,'You are unwelcome, flesh beast.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84806,'Weed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84807,'Vile creature.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84808,'A terrified worker is caught in the open!','A terrified worker is caught in the open!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84809,'Don\'t push the plunger!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84810,'I\'m gonna try to work me way back to Thaelin. I\'ll see ya there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84811,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84812,'Death to the Iron Horde!','Death to the Iron Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84813,'Scorchbrow! No! Ah they squished ya like a bug. I swear, as soon as I get back to fightin\' weight, I will avenge ye.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84814,'Workers Saved: $1i (+$2i VP)','Workers Saved: $1i (+$2i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84815,'','Alright, let\'s build the generator and get this show on the road!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(84816,'Let\'s get the generator up and running - stat!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(84817,'','Naughty thing, you shouldn\'t be here...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84818,'','You\'re too late, poor thing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84819,'I will never rest. I must join the Sethekk!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84820,'We were cut down... before our time...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84821,'','Despite that ancient\'s attack, these saberon are doing well... I can\'t wait to change that! <chuckles creepily>',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84822,'Taste my blade!','Taste my blade!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84823,'For the Burning Blade!','For the Burning Blade!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84824,'My blade seeks vengeance!','My blade seeks vengeance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84825,'','I\'ll show these saberon who the real hunter is... for the good of the Laughing Skull of course! We need these reagents!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84826,'','What a disappointment... other than the slaughtered saberon village... and the plundered plant treasures... okay maybe this was a decent haul after all.$b$bMostly I was hoping to ride a Genesaur into battle...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84827,'The challenge is met!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(84828,'You are... a worthy foe...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84829,'None who challenge me survive!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84830,'I have been... defeated? No...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84831,'Get over here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84832,'You cannot harm me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84833,'Crushin\' time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84834,'My bacon... is cooked...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84835,'I beg of you, $c, use the Heart for its true purpose!  The favor of Dionor will be quite tremendous indeed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84836,'Let\'s turn up the heat!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84837,'He didn\'t kill us!  What an incredible reward!  We live to sprout another day.$b$bThank you for your service to the Overgrowth, $p!  I wish to personally repay you for your efforts.  Perhaps I can grow you some special fruits or something.  Do you have a home I can visit?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84838,'Your light will be extinguished!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84839,'Behold my brilliance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84840,'Run!','Run!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84841,'She\'s gonna blow!','She\'s gonna blow!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84842,'Look out.','Look out.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84843,'Uh oh.','Uh oh.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84844,'Mommy.','Mommy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84845,'That\'s not good.','That\'s not good.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84846,'The ammo\'s unstable!','The ammo\'s unstable!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84847,'The mixture\'s too rich!','The mixture\'s too rich!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84848,'My light can never go out...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84849,'If you\'ve got the cash, I\'ve got the ride!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84850,'With those scouts dead we have a greater chance of catching the Iron Horde by surprise. Aka\'Magosh, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84851,'Plant the Horde flags inside Nethergarde, our men will do the rest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84852,'We must keep pushing back on the Iron Horde. They need to know we will not sit by and watch as they kill our brethren.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84853,'Okril\'lon has lost so much already, I can\'t stand to see them lose more.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84854,'Follow the trail. Find our hidden foe.','',0,0,0,0,0,0,0,0,0,0,44589,0,26124),
(84855,'Hopefully the prisoners you saved will have an opportunity to rebuild Okril\'lon to its former glory.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84856,'Where are you going, $c?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84857,'','Look deep into my eyes, $n and you can survey Ashran from afar.$B$BWhat would you like to see?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84858,'Show me Brute\'s Rise.','Show me Brute\'s Rise.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84859,'Show me the Molten Quarry.','Show me the Molten Quarry.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84860,'Show me the Amphitheater Of Annihilation.','Show me the Amphitheater Of Annihilation.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84861,'Show me the Ashmaul Burial Grounds.','Show me the Ashmaul Burial Grounds.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84862,'Lok\'tar ogar!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84863,'I will meet you in the Spirit Woods near Oshu\'gun. We must act swiftly!','',0,0,0,0,0,0,0,0,0,0,45915,0,26124),
(84864,'Run for your lives! It\'s too strong!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84865,'I will meet you in the Spirit Woods near Oshu\'gun. Cho\'gall must be stopped!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84866,'Our only course of action is to retreat. Everyone, with me!','',0,0,0,0,0,0,0,0,4,0,44881,0,26124),
(84867,'It looks like you might have a bite...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84868,'Reel it in!','Reel it in!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84869,'You honor us, Kargath. I will enjoy watching you fight in the arena again, even with your... handicap.','',0,0,0,0,0,0,0,0,0,0,44756,0,26124),
(84870,'Gladiators! Seize this opportunity to die gloriously, for your names will be carved into history. Let the battle begin!','',0,0,0,0,0,0,0,0,0,0,44757,0,26124),
(84871,'Finish him.','',0,0,0,0,0,0,0,0,0,0,44758,0,26124),
(84872,'Cho\'gall!','',0,0,0,0,0,0,0,0,6,0,44759,0,26124),
(84873,'Guards! Stop him!','',0,0,0,0,0,0,0,0,6,0,44760,0,26124),
(84874,'Seal the gates! Protect the palace! Highmaul will never fall to the likes you.','',0,0,0,0,0,0,0,0,6,0,44761,0,26124),
(84875,'You tempt power that you cannot comprehend. Let me show you...','',0,0,0,0,0,0,0,0,0,0,44762,0,26124),
(84876,'Have a taste of my power!','',0,0,0,0,0,0,0,0,0,0,44763,0,26124),
(84877,'Feel the energies flow through you!','',0,0,0,0,0,0,0,0,0,0,44764,0,26124),
(84878,'The stones and their power are mine to command.','',0,0,0,0,0,0,0,0,0,0,44765,0,26124),
(84879,'Your fragile mind cannot resist my command!','',0,0,0,0,0,0,0,0,0,0,44766,0,26124),
(84880,'Forfeit your power to me!','',0,0,0,0,0,0,0,0,0,0,44767,0,26124),
(84881,'Highmaul will never fall. The Gorian empire will not be overthrown by these peasants!','',0,0,0,0,0,0,0,0,0,0,44768,0,26124),
(84882,'End this now, Mal\'gris. Remove them from my throne room.','',0,0,0,0,0,0,0,0,0,0,44769,0,26124),
(84883,'You thought to imprison us, Mar\'gok? (You could never control us!)','',0,0,0,0,0,0,0,0,6,0,47434,0,26124),
(84884,'Destroy them all. Raze this city to the ground! (The stones will be ours! All shall fall to darkness!)','',0,0,0,0,0,0,0,0,6,0,47435,0,26124),
(84885,'Take this key and get to safety!','Take this key and get to safety!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84886,'The pleasure is mine. The crowd deserves a superior gladiator, seeing as the last one fell so easily.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84887,'This\'s gotta be a mistake! These puny squishies be the scourge of Nagrand? They look like Elekk poodoo.','',0,0,0,0,0,0,0,0,0,0,43580,0,26124),
(84888,'Ha! Today\'s games honor great sorcerer king! We gonna see his bloody victory over the orcs at the Battle of Red Spires!','',0,0,0,0,0,0,0,0,0,0,43581,0,26124),
(84889,'We\'ll see what dese competitors be made of, Thoktar, just as soon as what dey be made of gets splattered across the arena! HAHAHAHA!','',0,0,0,0,0,0,0,0,0,0,43582,0,26124),
(84890,'Now, playing our mighty king, scream his name and bash a skull for the Shadow of Highmaul, champion of games, Vul\'gor!','',0,0,0,0,0,0,0,0,0,0,43583,0,26124),
(84891,'Time to spill blood and die for Highmaul! The Battle of Red Spires begins!','',0,0,0,0,0,0,0,0,0,0,43584,0,26124),
(84892,'These wimps be taking more limbs than losing em!','',0,0,0,0,0,0,0,0,0,0,43587,0,26124),
(84893,'Looks like they don\'t care they\'re supposed to die.','',0,0,0,0,0,0,0,0,0,0,43588,0,26124),
(84894,'The punies... defeated, Vul\'gor!?','',0,0,0,0,0,0,0,0,0,0,43585,0,26124),
(84895,'The sorcerer king!? Here!? King only leaves palace to witness legendary battles.','',0,0,0,0,0,0,0,0,0,0,43586,0,26124),
(84896,'The crowd is getting what it wants, blood and mayhem.','',0,0,0,0,0,0,0,0,0,0,43576,0,26124),
(84897,'Ey, these peewees not bad.','',0,0,0,0,0,0,0,0,0,0,43577,0,26124),
(84898,'These worms know how to crack skulls. I\'ll almost be sad to see em butchered.','',0,0,0,0,0,0,0,0,0,0,43578,0,26124),
(84899,'Heh, slaves gonna have hard time cleaning that up.','',0,0,0,0,0,0,0,0,0,0,43579,0,26124),
(84900,'Heh, if you\'d been hit like that, all you\'d have left are pebbles. HAHAHA!','',0,0,0,0,0,0,0,0,0,0,43574,0,26124),
(84901,'HAHAHA!','',0,0,0,0,0,0,0,0,0,0,43575,0,26124),
(84902,'Dey gonna look like puddles after dis fight.','',0,0,0,0,0,0,0,0,0,0,45938,0,26124),
(84903,'I hope dese weaklings die better\'n they smell.','',0,0,0,0,0,0,0,0,0,0,45939,0,26124),
(84904,'HAHAHAHAHA!','',0,0,0,0,0,0,0,0,0,0,45940,0,26124),
(84905,'Didn\'t we win Battle O\' Red Spires?','',0,0,0,0,0,0,0,0,0,0,45942,0,26124),
(84906,'Disrespectin\' our heritage won\'t get em invited to next year\'s games.','',0,0,0,0,0,0,0,0,0,0,45943,0,26124),
(84907,'How tiny mens beat mighty Vul\'gor?!','',0,0,0,0,0,0,0,0,0,0,45941,0,26124),
(84908,'Ouch, even I felt that hit in my boulders.','',0,0,0,0,0,0,0,0,0,0,45935,0,26124),
(84909,'HAHAHA!','',0,0,0,0,0,0,0,0,0,0,45936,0,26124),
(84910,'Kargath be one scary orc. When he starts choppin, not even his own limbs are safe! HAHA!','',0,0,0,0,0,0,0,0,0,0,45937,0,26124),
(84911,'Enough! I will show these weaklings what a true champion is capable of.','',0,0,0,0,0,0,0,0,0,0,44521,0,26124),
(84912,'The pleasure is mine. The crowd deserves a superior gladiator, seeing as the last one fell so easily.','',0,0,0,0,0,0,0,0,0,0,44522,0,26124),
(84913,'You dare interrupt my ascendance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84914,'Do it now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84915,'Begin the Ritual!  I will become one with the Void!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84916,'You never should have interfered!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84917,'Take me to Darktide Roost.','Take me to Darktide Roost.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84918,'','My cries will rattle your enemies like thunder. Guide my aim and strike them down!',0,0,0,0,0,0,0,0,0,0,0,46786,26124),
(84919,'We\'ve spawned the Portals and they\'re up and running. Good work!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84920,'How many Artifact Fragments have we collected?','How many Artifact Fragments have we collected?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84921,'What do the Mage Portals do?','What do the Mage Portals do?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84922,'If you bring us enough of those artifact pieces scattered around Ashran we can use their power to conjure a Mage Portal. $B$BHow many have you brought me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84923,'The riders are out and on duty now. Good job procuring those artifacts, soldier.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84924,'Bring me back enough of those artifacts and I can gear up our Knights and send them out into battle. $B$BHow many have you brought me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84925,'How many Artifact Fragments have we collected?','How many Artifact Fragments have we collected?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84926,'We currently have $9314w collected. We need $9705w total.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84927,'What do the Knight Riders do?','What do the Knight Riders do?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84928,'Our best Knight Riders will ride around Ashran to protect and serve. You know, ruin the Horde\'s day.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84929,'Welcome to the Ring of Trials! Your first match is wit\' Crushmaul the orc slayer!','',0,0,0,0,0,0,1,0,0,0,43589,0,26124),
(84930,'Unbelievable! Crushmaul has been defeated! Thoktar, how this happen?','',0,0,0,0,0,0,0,0,0,0,43590,0,26124),
(84931,'','Let\'s just get this apparatus hooked up.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84932,'','Ok, all systems are go. Fire it up!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84933,'Dis next fight is against Raketalon! Dis gonna be a good one!','',0,0,0,0,0,0,0,0,0,0,43591,0,26124),
(84934,'HAHAHAHA!!','',0,0,0,0,0,0,0,0,0,0,43592,0,26124),
(84935,'Raketalon is dead! This the first time Raketalon ever died in the ring!','',0,0,0,0,0,0,0,0,0,0,43593,0,26124),
(84936,'<A crude arakkoa effigy adorned with relics of the old king Terokk.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84937,'Touch the wingblades to witness one of Terokk\'s legends.','Touch the wingblades to witness one of Terokk\'s legends.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84938,'The next trial is about to commence! I hope you like dying \'cuz you about to face Hol\'yelaa!','',0,0,0,0,0,0,0,0,0,0,43594,0,26124),
(84940,'Inconceivable! Hol\'yelaa has been defeated! Who would have seen this coming?','',0,0,0,0,0,0,0,0,0,0,43595,0,26124),
(84941,'Oggum dror undro dukkar.','',0,0,0,0,0,0,0,0,0,0,42903,0,26124),
(84942,'DESTRUCTION!','',0,0,0,0,0,0,0,0,0,0,42909,0,26124),
(84943,'LANDSLIDE!','',0,0,0,0,0,0,0,0,0,0,42910,0,26124),
(84944,'Bury you!','',0,0,0,0,0,0,0,0,0,0,42911,0,26124),
(84945,'MOGGOK DOOM AGURR!','',0,0,0,0,0,0,0,0,0,0,42912,0,26124),
(84946,'CRRRRRUSH... YOU!','',0,0,0,0,0,0,0,0,0,0,42915,0,26124),
(84947,'Into nothing....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84948,'Into... nothing....','',0,0,0,0,0,0,0,0,0,0,42906,0,26124),
(84949,'To dust....','',0,0,0,0,0,0,0,0,0,0,42907,0,26124),
(84950,'%s rumbles into laughter.','',0,0,0,0,0,0,0,0,0,0,42904,0,26124),
(84951,'Gruul smell flesh...','',0,0,0,0,0,0,0,0,0,0,45033,0,26124),
(84952,'Hahahaha, Gruul kill you so easy!','',0,0,0,0,0,0,0,0,0,0,45030,0,26124),
(84953,'You stay...','',0,0,0,0,0,0,0,0,0,0,45036,0,26124),
(84954,'GRUUL SMASH!','',0,0,0,0,0,0,0,0,0,0,45037,0,26124),
(84955,'No escape!','',0,0,0,0,0,0,0,0,0,0,45038,0,26124),
(84956,'Scurry....','',0,0,0,0,0,0,0,0,0,0,45039,0,26124),
(84957,'Unworthy.','',0,0,0,0,0,0,0,0,0,0,45034,0,26124),
(84958,'No more.','',0,0,0,0,0,0,0,0,0,0,45035,0,26124),
(84959,'Gruul... Fall... Down?','',0,0,0,0,0,0,0,0,0,0,45032,0,26124),
(84960,'GRUUL CRUSH YOU NOW!!!','',0,0,0,0,0,0,0,0,0,0,45031,0,26124),
(84961,'De Alliance be at de gates! To Arms soldiers of de Horde!','',0,0,0,0,0,0,0,0,0,30987,46573,0,26124),
(84962,'Get ready for the next bout! You going up against Captain Boomspark and the Burninator!','',0,0,0,0,0,0,0,0,0,0,43596,0,26124),
(84963,'Stop that.','',0,0,0,0,0,0,0,0,0,0,44862,0,26124),
(84964,'Please stop doing that.','',0,0,0,0,0,0,0,0,0,0,44863,0,26124),
(84965,'','Well, well, well... look who\'s walked right into our trap.',0,0,0,0,0,0,0,0,0,0,0,46348,26124),
(84966,'','You will be my gift to Warchief Hellscream.',0,0,0,0,0,0,0,0,0,0,0,46349,26124),
(84967,'Alliance fools! You expect to attack my base and live?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84968,'Capain Boomspark is defeated! Only one gladiator remains!','',0,0,0,0,0,0,0,0,0,0,43597,0,26124),
(84969,'Let me hook up the apparatus. Just a moment.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84970,'All systems are active. Fire!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(84971,'This is how he was found. Murdered!','',0,0,0,0,0,0,1,0,0,0,46725,0,26124),
(84972,'Exarch Naielle, weren\'t you overheard arguing with Hataaru earlier?','',0,0,0,0,0,0,6,0,0,0,43278,0,26124),
(84973,'','We ALWAYS argue. That doesn\'t mean I killed him!',0,0,0,0,0,0,5,0,0,0,0,45891,26124),
(84974,'The weapon is tainted with fel energy.','',0,0,0,0,0,0,25,0,0,0,44584,0,26124),
(84975,'You seem to know an awful lot about the tools of our enemy.','',0,0,0,0,0,0,1,0,0,0,43279,0,26124),
(84976,'It is my duty to know. Allow me to speak with the body.','',0,0,0,0,0,0,274,0,0,0,44585,0,26124),
(84977,'I forbid it! He has suffered enough!','',0,0,0,0,0,0,5,0,0,0,46726,0,26124),
(84978,'I agree. Stand down, Exarch. Enough damage has been done.','',0,0,0,0,0,0,1,0,0,0,43280,0,26124),
(84979,'There is a rat among us. I will find out who.','',0,0,0,0,0,0,5,0,0,0,44586,0,26124),
(84980,'The time has come for the final bout! Roakk the Zealot versus the challenger!','',0,0,0,0,0,0,0,0,0,0,43598,0,26124),
(84981,'Meet me north of here when you are finished.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(84982,'Incredible! The Ring of Trials has a new champion! What you think, Thoktar?','',0,0,0,0,0,0,0,0,0,0,43599,0,26124),
(84983,'Crushmaul gonna win dis by a landslide! HAHAHA!!','',0,0,0,0,0,0,0,0,0,0,45944,0,26124),
(84984,'It obvious dat dis was a fluke! Dat is my expert opinion, Jhorn!','',0,0,0,0,0,0,0,0,0,0,45945,0,26124),
(84985,'Raketalon always fight harder when she hungry, and we not feed her dis week! BAHAHAHA!!','',0,0,0,0,0,0,0,0,0,0,45946,0,26124),
(84986,'Raketalon was weak! Da next fight won\'t be so easy!','',0,0,0,0,0,0,0,0,0,0,45947,0,26124),
(84987,'Hol\'yelaa kill da last challenger before da fight even start! HAHAHA!!','',0,0,0,0,0,0,0,0,0,0,45948,0,26124),
(84988,'Yea, yea... I not impressed! Let\'s see how da next fight goes!','',0,0,0,0,0,0,0,0,0,0,45949,0,26124),
(84989,'Da best part of Captain Boomspark fights is eatin\' da extra crispy challengers! HAHAHA!!','',0,0,0,0,0,0,0,0,0,0,45950,0,26124),
(84990,'Now Captain Boomspark is da extra crispy one! Save me a drumstick! HAHAHA! Drumstick!','',0,0,0,0,0,0,0,0,0,0,45951,0,26124),
(84991,'Da only gladiator strong enough to beat Roakk is Vul\'gor! Dis fight is over before it even start!','',0,0,0,0,0,0,0,0,0,0,45952,0,26124),
(84992,'We are truly kindred spirits, $n. Until we meet again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(84993,'Dis gladiator may be da new champion of da ring, but dey is still no match for Vul\'gor!','',0,0,0,0,0,0,0,0,0,0,45953,0,26124),
(84994,'Long ago, a Bloodmane pridelord commanded his hunters to bring him ten thousand arakkoa feathers.','',0,0,0,0,0,0,0,0,0,0,46032,0,26124),
(84995,'But the Talon King came alone, and what ensued was not a war. It was a slaughter.','',0,0,0,0,0,0,0,0,0,0,46034,0,26124),
(84996,'Gggrrr... You are unworthy to fight Vul\'gor!','',0,0,0,0,0,0,1,0,0,0,45793,0,26124),
(84997,'He moved with grace and power matched only by the wind.','',0,0,0,0,0,0,0,0,0,0,46035,0,26124),
(84998,'With the sweep of his wings, he cut down even the strongest of the Bloodmane like so many blades of grass.','',0,0,0,0,0,0,0,0,0,0,46036,0,26124),
(84999,'','Hello commander! What\'s the plan for today?$b$bPut me in the front, I\'m ready for anything!',66,0,0,0,0,0,66,0,0,0,0,0,26124),
(85000,'Their pridelord was fierce, but he was no match for Terokk.','',0,0,0,0,0,0,0,0,0,0,46037,0,26124),
(85001,'Greetings, commander!$b$bNeed anything fixed? Tinkered with? ...Killed?','',66,0,0,0,0,0,66,0,0,0,0,0,26124),
(85002,'Satisfied that his message was clear, the Talon King left the Bloodmane to pick up the pieces of their broken tribe.','',0,0,0,0,0,0,0,0,0,0,46038,0,26124),
(85003,'','Hello, commander.$b$bI\'ve been scouting around the garrison to make sure the perimeters are secure. Unfortunately, I wasn\'t alone. Something was watching me from the underbrush, but it ran away. The trail gets cold at the river\'s edge.$b$bStay on your guard!',66,0,0,0,0,0,66,0,0,0,0,0,26124),
(85004,'Eager for the glory of battle, the young chieftain had hoped to incite a war with the arakkoa.','',0,0,0,0,0,0,0,0,0,0,46033,0,26124),
(85005,'','Rangari Chel reporting for duty.',66,0,0,0,0,0,66,0,0,0,0,0,26124),
(85006,'The final setting sun draws near.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85007,'','Greetings, commander! My name is Rangari Chel.$b$bWhen we first arrived on Draenor, this whole world was a mystery - a dangerous mystery. The rangari were tasked with exploring all these new, hostile environments. We learned to survive on our feet - using the natural resources of the land around us to survive and slip unseen in and out of enemy territory.$b$bAs your follower, I\'d focus on staying out of sight, keeping foes at bay, and doing serious damage.',1,6,273,0,0,0,66,0,0,0,0,0,26124),
(85008,'Someday I hope to drop the \"Apprentice\" title.','',1,0,0,0,0,0,66,0,0,0,0,0,26124),
(85009,'Commander!$b$bI am Apprentice Artificer Andren. Before Hataaru was murdered I was one of his most trusted assistants. As an Artificer I use draenei technology to disable foes long enough for me or someone else to crush them. I suppose among your people I\'d be considered a... warrior engineer?$b$bI will do my best to serve your interests if you choose me as a follower.','',1,274,6,0,0,0,66,0,0,0,0,0,26124),
(85010,'','Vindicator Onaala, ready for orders.',66,0,0,0,0,0,66,0,0,0,0,0,26124),
(85011,'','Commander, it is a pleasure to meet you.$b$bWhen I was young I trained hard to become an anchorite in the priesthood, but the Light walks us down mysterious paths. My defensive spells were so powerful that the Prophet himself encouraged me to train with the Vindicators.$b$bThese days, I am not afraid to stand toe-to-toe with our enemies, protecting those behind me. Choose me as your follower and my faith will be your shield, my armor a bulwark protecting your garrison from our many enemies.',1,6,273,0,0,0,66,0,0,0,0,0,26124),
(85012,'','The ogres of Stonemaul forced us to be gladiators.$b$bEveryday we fight, we kill, and we salute.$b$bThey made us battle whatever beast or creature the ogres had found that day.$b$bIt took a long time planning, but some of us managed to escape.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85013,'Now I can kill who I want, when I want! Meet me in the ogre mound when you are done and we will rip faces together!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85014,'Operations in Tanaan go well. The Citadel is almost complete.','',0,0,0,0,0,0,0,0,4,0,45926,0,26124),
(85015,'I am keeping a close eye on the Highmaul ogres, Warchief. So far, they remain... obedient.','',0,0,0,0,0,0,0,0,4,0,44514,0,26124),
(85016,'What of you, Blackhand?','',0,0,0,0,0,0,0,0,4,0,46505,0,26124),
(85017,'Alliance and Horde forces strike at the Foundry, but they are nothing I cannot handle.','',0,0,0,0,0,0,0,0,4,0,45467,0,26124),
(85018,'Again, Blackhand? All I hear are excuses.','',0,0,0,0,0,0,0,0,4,0,46506,0,26124),
(85019,'Azuka! How goes the search for the alpha?','',0,0,0,0,0,0,0,0,4,0,46507,0,26124),
(85020,'','Well, Warchief. We need only the Heart of Gorgorek to give it life.',0,0,0,0,0,0,0,0,4,0,0,46350,26124),
(85021,'Good. I will have you deal with the other-worlders as well. Or... do you lack the bloodlust of your forefathers?','',0,0,0,0,0,0,0,0,4,0,46508,0,26124),
(85022,'','My blade skills surpass those of my sires, Warchief. I can clean up Blackhand\'s mess.',0,0,0,0,0,0,0,0,4,0,0,46351,26124),
(85023,'Hrahh... I will slice off your tongue for that!','',0,0,0,0,0,0,0,0,4,0,45468,0,26124),
(85024,'Ahahaha... bold words from my newest Warlord. Very well!','',0,0,0,0,0,0,0,0,4,0,46509,0,26124),
(85026,'Carry forth your ancestral blade. Bathe it in the blood of our enemies. Show me its legendary power.','',0,0,0,0,0,0,0,0,4,0,46510,0,26124),
(85027,'Prove yourself, Azuka, and I shall esteem you among my Warlords.','',0,0,0,0,0,0,0,0,4,0,46511,0,26124),
(85028,'','Don\'t worry, little mouse. I haven\'t forgotten about you. I\'ll take care of you... later.',0,0,0,0,0,0,0,0,4,0,0,46352,26124),
(85029,'','More supplies commander? Our soldiers could always use them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85030,'','My... my husband... did you save my husband?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85031,'My fists and gratitude are yours, stranger. How do you feel about killing an ogre chief before you go?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85032,'Fight another.','',0,0,0,0,0,0,0,0,0,27343,0,0,26124),
(85033,'Getting tired yet, little draenei?','',0,0,0,0,0,0,0,0,0,27343,0,0,26124),
(85034,'You will learn to salute after each kill, or I will take your other eye.','',0,0,0,0,0,0,0,0,0,27343,0,0,26124),
(85035,'Faster! You should have been able to kill that thing in half the time it took you.','',0,0,0,0,0,0,0,0,0,27343,0,0,26124),
(85036,'Andren, I choose you!','Andren, I choose you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85037,'Are you sure this is the follower you want?','Are you sure this is the follower you want?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85038,'I\'d like to speak to the others.','I\'d like to speak to the others.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85039,'Chel, I choose you!','Chel, I choose you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85040,'Onaala, I choose you!','Onaala, I choose you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85041,'Hang tight, $Gsir:my lady;. I\'m here to help you.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(85042,'Come, little draenei, that thing should not have cut you. You are getting sloppy.','',0,0,0,0,0,0,0,0,0,27343,0,0,26124),
(85044,'Such a clever bird. How clever are you feeling now?','',0,0,0,0,0,0,0,0,0,26553,0,0,26124),
(85045,'Begone invaders! I, Malkor, rule here now! My minions will feast on your bones!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(85046,'Find the choicest bits of the intruders my minions! Find them and bring them to me!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(85047,'If you kneel before me, I will grant you a quick death before feeding you to my digestion pool!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(85048,'Do not presume your parlor tricks will work on me.','',0,0,0,0,0,0,0,0,0,26553,0,0,26124),
(85049,'Don\'t worry about me. I know my way around here.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(85050,'I\'ll poke around here. See if you can find anything elsewhere in the camp.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(85051,'Where are you going, my brethren? It has only been a thousand years since we saw the last ogre! They may return anytime, we must be vigilant!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(85052,'What do you know about Grommash Hellscream\'s plans?','What do you know about Grommash Hellscream\'s plans?',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(85053,'The proud Y\'kish, bound in chain and leagues upon leagues from your precious Skettis.','',0,0,0,0,0,0,0,0,0,26553,0,0,26124),
(85054,'I... I will stay until the job is done my brothers... return to the Overgrowth and I will meet you there in a few thousand years... I will not rest until my minions have crushed every worked stone to dust!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(85055,'I... I do not remember... what is this?  Fleshbags in my domain! Slay them my minions!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(85056,'You are free to go, you need only fly away. Hee hee.','',0,0,0,0,0,0,0,0,0,26553,0,0,26124),
(85057,'Kill the ogres! Wait... there are no more ogres... all gone so long ago. Only their broken ruins that must be returned to the ground...','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(85058,'Grommash Hellscream met with his Warlords - Blackhand, Kargath Bladefist, Kilrogg Deadeye, and Azuka Bladefury. I\'d watch out for Azuka... it seems she is charged with destroying the Alliance forces here on Draenor.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(85059,'Backup has arrived! Dispose of dose dat remain.','',0,0,0,0,0,0,0,0,0,30987,46569,0,26124),
(85060,'<Written on a nearby piece of paper:$B$BWe have uncovered Gorgorek the Worldrender, an ancient magnaron frozen in the stone pools of Gorgrond.$B$BThe Warsong elders believe this magnaron was a once-powerful alpha, with the ability to command lesser beings of its own kind.$B$BAncient clan records suggest that the beast can be awakened.>','<Written on a nearby piece of paper:$B$BWe have uncovered Gorgorek the Worldrender, an ancient magnaron frozen in the stone pools of Gorgrond.$B$BThe Warsong elders believe this magnaron was a once-powerful alpha, with the ability to command lesser beings of its own kind.$B$BAncient clan records suggest that the beast can be awakened.>',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(85061,'<Scraps of paper surround the map of Blackrock Foundry. They look like manufacturing orders for war machines.>','<Scraps of paper surround the map of Blackrock Foundry. They look like manufacturing orders for war machines.>',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(85062,'<This map bears many markings within Tanaan Jungle, including drawings of fortifications and troop movements. Hellscream seems quite interested in that region.>','<This map bears many markings within Tanaan Jungle, including drawings of fortifications and troop movements. Hellscream seems quite interested in that region.>',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(85063,'Touch the bangle to witness Terokk\'s fall.','Touch the bangle to witness Terokk\'s fall.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85064,'Accept Terokk\'s power.','Accept Terokk\'s power.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85065,'Take me to Shadow\'s Vigil.','Take me to Shadow\'s Vigil.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85066,'It is an honor to serve you, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85067,'|TInterface\\Icons\\spell_holy_avengersshield:20|t %s hurls his |cFFF00000|Hspell:153480|h[Holy Shield]|h|r at $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85068,'I am at your command.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85069,'The Talon King\'s own sages betrayed him. Terokk and his allies were cast into the pools.','',0,0,0,0,0,0,0,0,0,0,46039,0,26124),
(85070,'The accursed blood seared his flesh and tore at his mind.','',0,0,0,0,0,0,0,0,0,0,46040,0,26124),
(85071,'As he withered, Terokk had but one concern: his daughter Lithic.','',0,0,0,0,0,0,0,0,0,0,46041,0,26124),
(85072,'Seeing her broken body, Terokk despaired. He surrendered to the creeping darkness.','',0,0,0,0,0,0,0,0,0,0,46042,0,26124),
(85073,'But in that darkness, something found him.','',0,0,0,0,0,0,0,0,0,0,46043,0,26124),
(85074,'A strange power filled the Talon King. A presence urged him on.','',0,0,0,0,0,0,0,0,0,0,46044,0,26124),
(85075,'Fool! You\'ve walked right into my trap!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85076,'A strange orb peeked out from the wastes. Gazing into it, Terokk met the being that had saved him.','',0,0,0,0,0,0,0,0,0,0,46047,0,26124),
(85077,'','I\'ll meet you there.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(85078,'','I\'ll meet ye there.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(85079,'The Raven God Anzu gifted Terokk and his guards with dark powers. In time, they would be known as Talonpriests.','',0,0,0,0,0,0,0,0,0,0,46048,0,26124),
(85080,'Is this one of yours?','',0,0,0,0,0,0,0,0,1,0,46556,0,26124),
(85081,'Watch yourself, dog!','Watch yourself, dog!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85082,'Stand down, fool!','Stand down, fool!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85083,'For the Alliance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85084,'Charge!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85085,'To arms!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85086,'For the Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85087,'Attack!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85088,'Lok\'tar!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85089,'Told you! Tell him who I am, commander. Tell him how I like bones and killing.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85090,'','You won\'t find stuff this good anywhere else!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85091,'','I smuggled these myself!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85092,'','No time to haggle!  Take it or leave it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85093,'Fine, but my animal friends will be watching.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(85094,'','I gotta go.  Maybe you\'ll spend a little more coin next time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85095,'','Time\'s up.  Back to swindlin\' the locals.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85096,'It\'s back to the road for me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85097,'Gotta run.  Stay out of trouble!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85098,'','Kajassa got ya, mon. I be here ta help ya.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(85099,'','Shhhh... keep dem eyes an\' ears open.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(85100,'','Reinforcements have arrived! Clear this rabble from Stormshield!',0,0,0,0,0,0,0,0,0,30987,0,46519,26124),
(85101,'','Stormshield is under attack! To the defenses. Push them back!',0,0,0,0,0,0,0,0,0,30987,0,46523,26124),
(85102,'Wake up! Pathetic worms... why do we even bother with you.','Wake up! Pathetic worms... why do we even bother with you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85103,'Using Nether Beacon','Using Nether Beacon',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85104,'Beat it, kid. I told you, we\'re not interested.','Beat it, kid. I told you, we\'re not interested.',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(85105,'','You\'re all a bunch of cowards. $p\'s the only one of you with any guts.',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(85106,'<Fence your loot>','<Fence your loot>',595,0,0,0,0,0,0,0,0,62,0,0,26124),
(85107,'Ya got the goods, mon. I be able to turn dem inta Dingy Iron Coins for ya. I got my ways. See me lata and spend dem coins on someting fancy!','Ya got the goods, mon. I be able to turn dem inta Dingy Iron Coins for ya. I got my ways. See me lata and spend dem coins on someting fancy!',595,0,0,0,0,0,0,0,0,62,0,0,26124),
(85108,'Don\'t go easy on the horde, $n. Bring me back a token of their demise and I\'ll reward you handsomely.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85109,'I\'ve heard of Warlord Bladefury. She is a masta a da blade, undefeated across da orc clans. Those who underestimate her, die.','',0,0,0,0,0,0,396,0,4,0,0,0,26124),
(85110,'She be ambitious, clever, an\' cruel. Now dat she has risen ta Warlord, we had betta watch our backs.','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(85111,'I have heard of Warlord Bladefury. She is a master of the blade. Many underestimate her, but she is undefeated across the orc clans.','',0,0,0,0,0,0,396,0,4,0,0,0,26124),
(85112,'She is ambitious, clever, and cruel. Now that she has risen to power, I fear we must face her soon.','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(85113,'Wretches driven mad by the curse thrashed about in the pools in agony. But Terokk set them free.','',0,0,0,0,0,0,0,0,0,0,46045,0,26124),
(85114,'|TInterface\\Icons\\sha_ability_rogue_bloodyeye.blp:32|t$b\n|cFFFF0000|Hspell:167410|h[Khadgar\'s Watch]|h|r reverses time!','|TInterface\\Icons\\sha_ability_rogue_bloodyeye.blp:32|t$b\n|cFFFF0000|Hspell:167410|h[Khadgar\'s Watch]|h|r reverses time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85115,'Prepare to battle the Iron Horde.','Prepare to battle the Iron Horde.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85116,'I\'m ready, High Ravenspeaker.','I\'m ready, High Ravenspeaker.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85117,'Tag! You\'re it!','Tag! You\'re it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85118,'OGRE! You\'re the ogre! HA-HA!','OGRE! You\'re the ogre! HA-HA!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85119,'Can we stop running now?','Can we stop running now?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85120,'You know why orc eyes glow red? It\'s because they drink blood!','You know why orc eyes glow red? It\'s because they drink blood!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85121,'Well done!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85122,'Yes, very good.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85123,'No, that isn\'t how the ritual goes. Try again.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(85124,'Defenders of Shattrath, we\'ve taken the docks!  Fall back to the city and look for any survivors!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85127,'Fool child. You are my property now.','',0,0,0,0,0,0,0,0,0,27389,0,0,26124),
(85128,'Your father has abandoned you. Now you will replace him in the arena.','',0,0,0,0,0,0,0,0,0,27389,0,0,26124),
(85129,'You will grow, you will bleed, you will fight, or you will die.','',0,0,0,0,0,0,0,0,0,27389,0,0,26124),
(85130,'It falls to you, little one, to pay the debt of your father\'s escape.','',0,0,0,0,0,0,0,0,0,27389,0,0,26124),
(85131,'My father is going to rip your horn off.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85132,'You better fear the day I get let out of this cage!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85133,'You can\'t keep me locked up forever.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85135,'You dogs will soon do your part to strengthen the Iron Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85136,'Shhhh... This will all be over soon. The pain will end when your souls depart from your bodies and feed the Dark Portal!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85137,'This is the price you Frostwolf pay for not joining the Iron Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85138,'Do not fret, even now the might of the Iron Horde amasses at Frostfire. Your home will be ours soon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85139,'We have captured your leader! HAH! He shovels our excrement in the quarry! His brother Durotan will be next!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85140,'We have captured the Shadow Council and their leader, Gul\'dan! It is they who power this portal -- with your souls!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85141,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85142,'It is only through our faith in the Raven Mother that we will find our salvation.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85143,'This might hurt a little.','This might hurt a little.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85144,'Like a bird to the slaughter.','Like a bird to the slaughter.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85145,'I\'ll eat your bones!','I\'ll eat your bones!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85146,'Another trophy for my necklace.','Another trophy for my necklace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85147,'Die!','Die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85148,'Did your \"prophet\" not see this in your future? HAH!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85149,'Little draenei, did you think that you could keep us suppressed forever? This is our world and none will hold us from it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85150,'The Iron Horde war machine is already on the way to Karabor. It will soon be nothing more than ash!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85151,'The fate of your people is to feed the Iron Horde war machine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85152,'It is your souls that fuel the portal. And soon you will join the countless souls that have already crossed over!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85153,'None will stand in the way of the warlords! You do not stand a chance! Once Karabor falls, Shattrath will soon follow!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85154,'Time may have taken some of my strength, but this old wolf still has his bite!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85155,'At least, I die... in combat...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85156,'<The voice of Kalandrios fills your mind as you approach the Shamanstone.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85157,'','As handmaiden to Tyrande, my sentinels stand ready to fight by your side and defend your garrison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85158,'I would like the night elves to protect the garrison.','I would like the night elves to protect the garrison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85159,'Mr. Nichols? Another cup of coffee please.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(85160,'Coming right up, lad. Say \"hi\" to your mother for me.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(85161,'She\'s my best customer.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(85162,'Thanks, I will.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(85163,'The garrison is yours, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85164,'Switch back to human guards.','Switch back to human guards.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85165,'Hey, Ana!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(85166,'','Hey, Xander.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(85167,'Hi, Topper.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(85168,'Better get a move on, kid. That coffee\'s not getting any hotter.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(85169,'Don\'t worry, I\'ll get around to all of you.','Don\'t worry, I\'ll get around to all of you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85170,'Here\'s your coffee, mom.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(85171,'Phew. I could really use a break.','Phew. I could really use a break.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85172,'Ewwww. I JUST washed my boots.','Ewwww. I JUST washed my boots.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85173,'','Thank you, sweetie.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(85174,'','Mmm, that\'s good. All right, off with you. Go play.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(85175,'Is everyone in their places? Good, let us begin!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(85176,'Okay! See you in an hour.','',0,0,0,0,0,0,0,7,0,51288,0,0,26124),
(85177,'The strongest of his guards clung to sanity. And when the Talon King called, they answered.','',0,0,0,0,0,0,0,0,0,0,46046,0,26124),
(85178,'Hello, boy.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(85179,'It was written in the \"Tome of the Falling Sands\", \"Time waits for no one\". The Raven Mother knew we would have one who is not of the flock here for the ritual! Oh, You are truly blessed!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(85180,'Hey, dad!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(85181,'Hey you with the face! You gotta help me down... my pants are chafing like crazy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85182,'We need to fill the air with a sweet smell. Put something fragrant into the fire.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85183,'Now, inspire us with a reading from the Scroll of the Ravens.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85184,'Quickly now, throw the sacred feathers to the winds!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85185,'Now, splash the flames with some of the blessed water!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85186,'Together they would build Skettis, and protect the unwanted children of Rukhmar.','',0,0,0,0,0,0,0,0,0,0,46049,0,26124),
(85187,'As the years passed, the Talon King\'s health declined. Grief hung in his heart, while the curse chewed relentlessly at his mind.','',0,0,0,0,0,0,0,0,0,0,46050,0,26124),
(85188,'He began to hate this world, abandoning Skettis - even sacrificing his own people in search of a cure.','',0,0,0,0,0,0,0,0,0,0,46051,0,26124),
(85189,'The Raven Mother! We humbly welcome you back to the nest! Your presence brings joy to our hearts!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85190,'You call this pain? I\'ve done worse to myself.','You call this pain? I\'ve done worse to myself.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85191,'Your poison is pathetic.','Your poison is pathetic.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85192,'Yes... the pain... it sustains me...','Yes... the pain... it sustains me...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85193,'More... give me more!','More... give me more!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85194,'My will is iron. I\'ll never talk.','My will is iron. I\'ll never talk.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85195,'It\'s going to take more than that, whelp.','It\'s going to take more than that, whelp.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85196,'I\'ll chew on your bones.','I\'ll chew on your bones.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85197,'You want pain? I\'ll show you pain.','You want pain? I\'ll show you pain.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85198,'I took my own hand. You are nothing!','I took my own hand. You are nothing!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85199,'Yes, more. Give me more!','Yes, more. Give me more!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85200,'Kargath will hang your corpse on his throne.','Kargath will hang your corpse on his throne.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85201,'This is your idea of poison? I bathe with worse.','This is your idea of poison? I bathe with worse.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85202,'Let me give you a taste of real poison.','Let me give you a taste of real poison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85203,'I\'ve given everything to be Shattered Hand. You\'ll get nothing from me.','I\'ve given everything to be Shattered Hand. You\'ll get nothing from me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85204,'I live for pain. Your efforts are weak.','I live for pain. Your efforts are weak.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85205,'You are too late. Our poisoned blades will be your end.','You are too late. Our poisoned blades will be your end.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85206,'STOP! No more!','STOP! No more!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85207,'Our master assassin\'s name is Gardul Venomshiv. He crafted the poison.','Our master assassin\'s name is Gardul Venomshiv. He crafted the poison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85208,'He is at the camp just down the road right now. But you\'ll never stop...','He is at the camp just down the road right now. But you\'ll never stop...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85209,'Who crafted the poison that killed the arakkoa?','Who crafted the poison that killed the arakkoa?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85210,'Who is behind this? Where are they?','Who is behind this? Where are they?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85211,'Who creates the poison on your blade. Tell me!','Who creates the poison on your blade. Tell me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85212,'I need answers. Tell me who created the poison you use.','I need answers. Tell me who created the poison you use.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85213,'You did not craft this poison. Tell me who did and this can all end.','You did not craft this poison. Tell me who did and this can all end.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85214,'Who is G.V.? His poisons killed the arakkoa. Tell me!','Who is G.V.? His poisons killed the arakkoa. Tell me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85215,'Who led the raid on the arakkoa. Where is he hiding?','Who led the raid on the arakkoa. Where is he hiding?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85216,'Do not test my patience. Tell me who crafted the poison you wield.','Do not test my patience. Tell me who crafted the poison you wield.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85217,'Do not waste my time. Who is G.V. and where is he?','Do not waste my time. Who is G.V. and where is he?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85218,'Good seein\' ya.','Good seein\' ya.',595,0,0,0,0,0,0,0,0,62,0,0,26124),
(85219,'','Hold your arms, brothers. I do not believe this one serves the ogres.',0,0,0,0,0,0,0,0,0,924,0,0,26124),
(85220,'Hold, friends! This one does not look like a minion of the ogres.','',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(85221,'%s succumbs to the poison.','%s succumbs to the poison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85222,'Time is of the essence! Meet me in the Underpale and we will confront Cho\'gall!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85223,'K\'ure must be saved! Meet me in the Underpale and we will confront Cho\'gall!','',0,0,0,0,0,0,0,0,0,0,45916,0,26124),
(85224,'Glory to the Alliance!','Glory to the Alliance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85225,'','I have returned!',0,0,0,0,0,0,0,0,0,0,0,46787,26124),
(85227,'OW, MY LEG!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85228,'','Tiny! Please don\'t die!!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85229,'','Please save Tiny!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85230,'','Is he going to be okay?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85231,'','Why did you have to fight with those mean old orcs!?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85232,'','Just hang in there Tiny!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85235,'','Don\'t worry, he will be fine.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85236,'','He fought bravely, you should be proud!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85237,'','Your elekk managed to save many lives.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85238,'','I will make sure that he is fully healed.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85239,'Alright, it\'s time to go!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85240,'','I see your friends in the chamber up above. I think I can get there safely.',0,0,0,0,0,0,0,0,0,0,0,45554,26124),
(85241,'You - from beyond the portal! You will make a marvelous sacrifice.','',0,0,0,0,0,0,0,0,0,0,45980,0,26124),
(85242,'Come closer... and burn!','',0,0,0,0,0,0,0,0,0,0,45981,0,26124),
(85243,'The void consumes you!','',0,0,0,0,0,0,0,0,0,0,45982,0,26124),
(85244,'Ner\'zhul... Help me...','',0,0,0,0,0,0,0,0,0,0,45983,0,26124),
(85245,'Find us weapons and armor, and I swear my people will carve a path through these orcs all the way to Karabor if we must.','',0,0,0,0,0,0,0,0,0,0,44595,0,26124),
(85246,'Put axes in our hands and I promise you, every Frostwolf orc here can take down ten orcs of any other clan.','',0,0,0,0,0,0,0,0,0,0,46710,0,26124),
(85247,'We gonna crush dem good, Porkchop!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85248,'Bahaha! You so puny!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85249,'','I sense one who is not of the flock. Come closer, child.',0,0,0,0,0,0,0,0,0,0,0,46788,26124),
(85250,'Come at me, bro!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85251,'','Oh, it\'s worse than I thought. They hit here, too.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(85252,'','Dark Lady watch over us. We weren\'t the only ones.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(85253,'We don\'t yet know of the casualties.','We don\'t yet know of the casualties.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85254,'How could this have happened...','How could this have happened...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85255,'...and the children. Who will care for them now?','...and the children. Who will care for them now?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85256,'It hasn\'t just affected our lives - the weather is gloomier.  The attack is mourned by all.','It hasn\'t just affected our lives - the weather is gloomier.  The attack is mourned by all.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85257,'Light\'s blessing be upon us.','Light\'s blessing be upon us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85258,'Mind your form.','Mind your form.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85259,'The savages won\'t be so kind to forgive attacks like that.','The savages won\'t be so kind to forgive attacks like that.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85260,'Good...good.','Good...good.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85261,'Maintain your balance. You must remain steady at all times.','Maintain your balance. You must remain steady at all times.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85262,'Excellent work. Your skills are improving.','Excellent work. Your skills are improving.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85263,'Just a taste of Gorian civilization!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85264,'<This head used to be attached to a large brute, until it was ripped off by a larger brute name Brokyo.>','<This head used to be attached to a large brute, until it was ripped off by a larger brute name Brokyo.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85265,'Challenge Brokyo.','Challenge Brokyo.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85266,'I love the smell of burnt gladiators in the morning!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85267,'Taking a look...','Taking a look...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85268,'Rukhmar takes flight!','Rukhmar takes flight!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85269,'|TInterface\\Icons\\ability_fixated_state_red:20|tA Phoenix has |cFFFF0000fixated|r on you! If it reaches you it will |cFFFF0000|Hspell:167630|h[Explode]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85270,'Get on in there, champ!','',0,0,0,0,0,0,0,0,4,0,45699,0,26124),
(85271,'I need some luck!','I need some luck!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85272,'%s tosses a coin in the fountain.','%s tosses a coin in the fountain.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85273,'Come to Highmaul and my claws will tear you apart....','',0,0,0,0,0,0,603,0,0,0,45794,0,26124),
(85274,'What\'ve you got?','What\'ve you got?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85275,'The mending begins.','The mending begins.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85276,'I know it hurts, but you must try and rest.','I know it hurts, but you must try and rest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85277,'The wounds are great, but the spirit is stronger.','The wounds are great, but the spirit is stronger.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85278,'Blessings aide your wounds.','Blessings aide your wounds.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85279,'$n says a prayer for the spirit of the departed.','$n says a prayer for the spirit of the departed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85280,'%s inhales slowly, each breath increasing discomfort.','%s inhales slowly, each breath increasing discomfort.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85281,'%s ignores the pain, allowing nearby injured brethren to be cared for.','%s ignores the pain, allowing nearby injured brethren to be cared for.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85282,'%s lets loose a whisper from under his breath, slowly releasing a pained sigh.','%s lets loose a whisper from under his breath, slowly releasing a pained sigh.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85283,'%s swings with great force at their target.','%s swings with great force at their target.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85284,'%s adjusts their combat stance, improving balance and form.','%s adjusts their combat stance, improving balance and form.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85285,'%s breathes heavily, attacking their target with precision and focus.','%s breathes heavily, attacking their target with precision and focus.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85286,'We\'ll get our chance.','We\'ll get our chance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85287,'','How is Sir Percival today?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85288,'','Come on Percy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85289,'','Such a good boy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85290,'Bring me back enough of those artifacts and I can gear up our Wolf Riders and send them out into battle. $B$BHow many have you brought me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85291,'','Ok, Percy. Bang!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85292,'','Show them no mercy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85293,'','Give them a piece o\' their own medicine.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85294,'','Good Job!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85295,'I want a new recipe for myself.','I want a new recipe for myself.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85296,'I want you to make me something.','I want you to make me something.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85297,'','Amazing what you can dig up if you don\'t mind fighting through monsters, traps, bandits, and any other number of things trying to kill you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85298,'Traitors, all of you. You\'ve led the enemy to our doorstep!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(85299,'Hoping to rejuvenate their fading king, the Talonpriests sealed Terokk away in the shadows.','',0,0,0,0,0,0,0,0,0,0,46052,0,26124),
(85300,'','Hello, peach - great to be back under your command!$b$bGazlowe said you might need some goblin firepower, ingenuity, and awesomeness out here, so naturally I was chosen.$b$bAnd this has absolutely nothing to do with him not wanting me around his explosives.$b$bI got your back, commander!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85301,'And that brings us to today! With the relics and the Talonpriests in place, we are ready to call upon the Talon King.','',0,0,0,0,0,0,0,0,0,0,46053,0,26124),
(85302,'','Husband, please reconsider. No good can come of this.',0,0,0,0,0,0,0,0,0,0,0,44744,26124),
(85303,'Enough. I will handle this myself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85304,'My lord, I -','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(85305,'We\'ve closed this chapter. But Garrosh only set these events in motion... We\'ll have to close all the loops if we want to keep Azeroth safe. That means finding and neutralizing Gul\'dan.$B$B<Khadgar breathes a heavy sigh.>$B$BStill, a little celebration may be in order before we get back to business. I\'ve got a bottle of aged Dalaran red saved up for just such an occasion, if you\'d care to meet me in my tower later.','',396,273,0,0,0,0,0,0,0,0,0,0,26124),
(85306,'I yet live you green beasts! Come face Tormmok if you dare!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(85307,'Curse you... Mar\'gok...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85308,'You\'re not supposed to be here yet! The assault on the Dark Portal isn\'t ready!$b$bCome back later, $c.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85309,'You look like a strong, capable $c. I could use a champion like you.$b$bInterested in risking your life on a suicide mission to save Azeroth?$b$bJust say the word.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85310,'','The archmage is gearing up for another campaign. All he can talk about is finding Gul\'dan.$B$BBut, I worry... Gul\'dan has already tried to kill Khadgar once. The Archmage is going to need all the help he can get.$B$B<Cordana looks at you, pointedly.>',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(85311,'The word.','The word.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85312,'','We Frostwolves have always walked alone, with only our wolves at our side. But, our clan is a part of this world, and it\'s clear that we have a role to play in protecting it.$B$BThis \'Garrosh\' was a dangerous one. Still, he showed us something valuable. I see now that, united, the orcs can be great. It is more important than ever to have a righteous voice to guide them.$B$BThe Frostwolves must be that voice.',1,273,0,0,0,0,0,0,0,0,0,0,26124),
(85313,'Is that the best you can do?! I\'ve put bigger forests to the torch in my campaigns!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85314,'You just keep coming like the weeds you are! Fine then! I\'ve killed a hundred of you, I can kill hundreds more!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85315,'Vindicator Yrel says that we must work with both the Alliance and the Horde from your world.$B$BBut, if your world created monsters like Garrosh - why should we trust you?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(85316,'I will NOT die in this accursed jungle! I will not become plant food! My death is meant for something far more glorious than you plants!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85317,'Anybody want to go to Tanaan?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85318,'Don\'t waste my time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85319,'Fear not flesh bag, you will do more good in the ground than above it. I will see to that.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85320,'Ha ha ha, wind cannot hurt me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85321,'The Iron Horde remains a threat. We should hit them where it hurts, and take out the Blackrock Foundry.','',1,0,0,0,0,0,0,0,0,0,45267,0,26124),
(85322,'','Perhaps we should deprive them of their allies. The ogres here in Nagrand are vulnerable now.',1,0,0,0,0,0,0,0,0,0,0,45570,26124),
(85323,'Good plan. Now, let\'s get moving.','',0,0,0,0,0,0,396,0,0,0,44989,0,26124),
(85324,'Stay alive, $n.','',0,0,0,0,0,0,0,0,0,0,44771,0,26124),
(85325,'Stay alive, $n.','',0,0,0,0,0,0,0,0,0,0,46397,0,26124),
(85326,'Good, good.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85327,'Yes, that is coming along nicely.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85328,'Hopefully there will not be any more interruptions.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85329,'It will be a struggle to make quota this week.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85330,'To prove yourself worthy of the wolf, you must first test your strength and tenacity. \n\nTo do this, you must gather a heavy stone from the quarry and bear it on your back into the lands of your enemy. Once you have cut your way through their ranks, place the stone in a place of prominence, and set upon it a trophy of your foe.\n\nOnly then, when your strength is displayed for all to see, can you hope to claim the wolf as your subject.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85331,'Once your display of strength is set for all to see, you must claim your wolf.\n\nGo to their hunting grounds. There you must find the largest wolf in the pack, and subdue it in the presence of its kin. You will likely be eaten alive, but if you survive the ordeal, the wolf will answer to you as its master.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85332,'It is not enough that the wolf regard you as its master. To ready your wolf for riding, you must break its will completely.\n\nOnce you have subdued your wolf, you will mount it and ride it to the top of the tallest peak in Nagrand. If your wolf is willful, it will throw you to your death on the mountain slopes. \n\nIf you survive to the peak, the will of your wolf will be broken. \n\nThen, you can call yourself \"Wolfrider\".','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85333,'What do the Wolf Riders do?','What do the Wolf Riders do?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85334,'Our best Wolf Riders will ride around Ashran to protect and serve. Tear those Alliance dogs to shreds.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85335,'How many Artifact Fragments have we collected?','How many Artifact Fragments have we collected?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85336,'We currently have $9313w collected. We need $9705w total.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85337,'What does Kronus do?','What does Kronus do?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85338,'How many Artifact Fragments have we collected?','How many Artifact Fragments have we collected?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85339,'','We currently have $9312w collected. We need $9707w total.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85340,'We currently have $9262w collected. We need $9708w total.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85341,'We currently have $9253w collected. We need $9706w total.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85342,'','The fool. He\'s going to lead us straight to his brewing operation. Follow me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85343,'Kronus will patrol into the Road of Glory and clear it of any Alliance it finds.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85344,'Kill... eat... torn to pieces... ate... alive... they took us... DIE... kill... me... kill me... KILL ME... please...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85345,'Put the corporal out of his misery.','Put the corporal out of his misery.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85346,'WHAT ARE YOU DOING JUST STANDING AROUND? GO SLAY SOME ALLIANCE SCUM. BRING ME BACK THEIR HEADS, TEETH, TAILS... WHATEVER! GO, NOW!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85347,'','The fool. He\'s going tae lead us straight to his brewin\' operation. Come on.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85348,'I can clear the way to the flagship. Hold off these invaders while I finish my spell!','',0,0,0,0,0,0,0,0,0,0,44901,0,26124),
(85349,'Your corpse will grow countless of us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85350,'There will always be more of us... here...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85351,'I hate this jungle... You there! I would speak with you.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(85352,'You are the first thing that has not immediately attacked me since my expedition arrived in this forsaken land... I should not even be here!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(85353,'No one should become fertilizer for these monsters.  How did you come to be here?','No one should become fertilizer for these monsters.  How did you come to be here?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(85354,'Ever since \"Sorceror King\" Mar\'gok came to power and found those artifacts its been Felbreaker this and Firebreaker that. With his newfound power he thinks he doesn\'t need the Legion!$b$bThis empire was forged with ogre strength and ogre blades and I told him as such!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(85355,'I doubt he took that well...','I doubt he took that well...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(85356,'He did not. He turned my words against me!$b$bHe ordered me and my loyal supporters to go on this cursed expedition to find the first ogre civilization and find some stupid relics! I could not disobey... now my troops are all dead and I cannot return...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(85357,'','You and your friend are too late, $n. My blade has already tasted the blood of Ugbright. My power will soon be unstoppable.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85358,'','Now if you will excuse me, I have more blood to spill. Take care of this worm.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85360,'','Till we meet again, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85361,'Augh! Too much!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85362,'Acquiring','Acquiring',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85363,'','We cannot hold for much longer!',0,0,0,0,0,0,0,0,0,0,0,45593,26124),
(85364,'We must give the wizard more time! Hold the line!','',0,0,0,0,0,0,0,0,0,0,45289,0,26124),
(85365,'It is finished. I must rest a moment. The flagship is up ahead. I will join you there once I regain my energy.','',0,0,0,0,0,0,0,0,0,0,44902,0,26124),
(85366,'No touchin\' da merchandise without proof of purchase.','No touchin\' da merchandise without proof of purchase.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85367,'I can\'t believe we\'re both standing here, $n. It\'s Draenor... but it\'s not Draenor. I feel as though we\'re trespassing on the far side of the looking glass.$b$bLet\'s finish the job and get out of this place, hm?','',1,274,0,0,0,0,0,0,0,0,0,0,26124),
(85368,'','For the Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85369,'Are you ready?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(85370,'What\'s the plan, Khadgar?','What\'s the plan, Khadgar?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(85371,'It\'s coming right for us!','It\'s coming right for us!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(85372,'WHAT THE HELL?!','WHAT THE HELL?!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(85373,'','Yes... this body will do nicely!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85374,'[Placeholder Scene!]','',1,274,0,0,0,0,0,0,4,0,0,0,26124),
(85375,'Take me to the Broken Precipice in Nagrand.','Take me to the Broken Precipice in Nagrand.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85381,'','The Archmage is expecting you.',1,0,0,0,0,0,1,0,0,0,0,44149,26124),
(85382,'Ra-AWWK! I am still-awAWWK - still with you, my king!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85383,'I... still have my strength...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85384,'What will become of us?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85385,'I.. huh... wha? Ra-AWWK!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85386,'The Talon King lives!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85387,'','It will be alright.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85388,'T-t-to the end, my k-king!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85389,'','He escaped, I just know it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85390,'','We have to stay strong. I am sure he will be back soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85391,'AAHHHHHHHHH!!!!!!!','AAHHHHHHHHH!!!!!!!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(85392,'','Have hope $n!  The Light will protect you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85393,'<The amorphous blob of arcane energy appears to be giving people a tour of your garrison.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85394,'','May the light bless you $r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85395,'This Warsong orc looks to have died trying to carry a giant stone through the Gorian outpost. \n\nThere\'s no clear indication of where he was taking the stone, but it obviously didn\'t help him in combat.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85397,'Get these war machines ready for the siege.','',0,0,0,0,0,0,396,0,0,0,46238,0,26124),
(85398,'Don\'t shoot until you see the whites of their eyes!','',0,0,0,0,0,0,396,0,0,0,46239,0,26124),
(85399,'One shot, one kill!','',0,0,0,0,0,0,71,0,0,0,46240,0,26124),
(85401,'Don\'t let your lust for battle cloud your sight.','',0,0,0,0,0,0,396,0,0,0,46241,0,26124),
(85402,'Stop showin\' off.','',0,0,0,0,0,0,153,0,0,0,46242,0,26124),
(85403,'Get in there and show me what you\'ve got.','',0,0,0,0,0,0,396,0,0,0,46243,0,26124),
(85404,'You think you have what it takes to bear the standard of the Iron Horde?','',0,0,0,0,0,0,396,0,0,0,46244,0,26124),
(85405,'No quarter. No mercy.','',0,0,0,0,0,0,396,0,0,0,46245,0,26124),
(85406,'Warsong arrows sing from the sky! They\'ll be the last thing you hear as I crush your skull.','',0,0,0,0,0,0,396,0,0,0,46059,0,26124),
(85407,'Start the funeral pyres!','',0,0,0,0,0,0,396,0,0,0,46057,0,26124),
(85408,'Let them have it!','',0,0,0,0,0,0,396,0,0,0,46062,0,26124),
(85409,'That\'s it? You barely drew blood!','',0,0,0,0,0,0,396,0,0,0,46063,0,26124),
(85410,'A death worthy of a warrior!','',0,0,0,0,0,0,396,0,0,0,46065,0,26124),
(85411,'Terror overwhelms you, death is near.','',0,0,0,0,0,0,396,0,0,0,46064,0,26124),
(85412,'Revel in the slaughter!','',0,0,0,0,0,0,396,0,0,0,46060,0,26124),
(85413,'My blade thirsts for more.','',0,0,0,0,0,0,396,0,0,0,46061,0,26124),
(85414,'You will burn with me.','',0,0,0,0,0,0,0,0,0,0,46058,0,26124),
(85415,'','Now you ain\'t so tall no more.',0,0,0,0,0,0,0,0,0,0,0,46130,26124),
(85416,'','Ooooh! Is there killin\' ta be done? Lemme at\'em!',0,0,0,0,0,0,0,0,0,0,0,46128,26124),
(85417,'','You\'d better step back. I\'m calling in the Bombsquad!',0,0,0,0,0,0,0,0,0,0,0,46131,26124),
(85418,'','Time is money, friend! And it looks like you\'s outta both!',0,0,0,0,0,0,396,0,0,0,0,46132,26124),
(85419,'','Tick tick tick... BOOM!',0,0,0,0,0,0,396,0,0,0,0,46129,26124),
(85420,'Event sent.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85421,'','Ahhhhhhhh! I\'m hit!',0,0,0,0,0,0,0,0,0,0,0,46127,26124),
(85422,'$n browses the books.','$n browses the books.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85423,'Hmmm... something helpful?','Hmmm... something helpful?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85424,'','It\'s alright... they are all gone now.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85425,'I\'m going to killl the gronn!','I\'m going to killl the gronn!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85426,'','There is no reason to be scared!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85427,'','Can we please head back now?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85428,'I... couldn\'t save them.','I... couldn\'t save them.',0,0,0,0,0,0,18,0,1,0,0,0,26124),
(85429,'What\'s this? What\'s going on down there?','',0,0,0,0,0,0,0,0,0,0,45472,0,26124),
(85430,'What good are a handful of slaves against the Blackrock war machine?','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(85431,'Blackrocks... CRUSH THEM!','',0,0,0,0,0,0,0,0,6,0,45474,0,26124),
(85432,'Super Thrall Action Dialogue!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85433,'Super Thrall Action Option 1!','Super Thrall Action Option 1!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85434,'','You will never defeat the Light, demon!',0,0,0,0,0,0,0,0,0,0,0,45723,26124),
(85435,'Eh Boss-mon! Ol\' Vol\'jin da warchief be sendin\' me some shadow hunters to be ya eyes an ears.$b$bWhen I hear of tings out there in da world ya should be hearin\' of, I\'ll be lettin\' ya know.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85436,'Call upon Terokk.','Call upon Terokk.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85437,'Wowee, that\'s a big one!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(85438,'Something me doing?','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(85439,'OWWWW! Okay, okay, me go back to work!','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(85440,'Whaaat?','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(85441,'Bad touch! Bad touch!','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(85442,'Ain\'t bigger than Princess!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(85443,'$g Yessir:Yes ma\'am;, right away, $g sir:ma\'am;.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(85444,'Me busy. Leave me alone.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(85445,'We\'ll take \'er from here!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(85446,'Me not that kind of orc.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(85447,'What you want?','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(85448,'This son of Hellscream is a madman.$B$BI don\'t want justice... I want vengeance for what he did at Telaar.','',274,0,0,0,0,0,0,0,0,0,0,0,26124),
(85449,'D\'kaan, what\'s up ahead?','D\'kaan, what\'s up ahead?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85450,'','Garrosh has escaped justice time and again, but we\'re going to finish him off this time, once and for all.',273,0,0,0,0,0,0,0,0,0,0,0,26124),
(85451,'Aggra, what\'s up ahead?','Aggra, what\'s up ahead?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85452,'I LIVE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85453,'BE CONSUMED BY FLAME!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85454,'They seem focused on their ritual. Maybe destroying those blood orbs will get their attention.','',0,0,0,0,0,0,0,0,0,0,46160,0,26124),
(85455,'','The power lies within the artifact fragments, $n. Bring back enough of those and the mages will summon a portal so we can return back to Warspear Outpost faster.$B$BHow many have you brought me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85456,'','The portal is up, $c. Good work.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85457,'How many Artifact Fragments have we collected?','How many Artifact Fragments have we collected?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85458,'What do the Mage Portals do?','What do the Mage Portals do?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85459,'What do the Warlock Gateways do?','What do the Warlock Gateways do?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85460,'','The mages will summon a portal west of Ashran which can be used to take you back to Warspear Outpost.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85461,'The Gateways are located in the North-West and South-East and can be used to move between those two points.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85462,'Somebody call for a highly overqualified lumberjack?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(85463,'The warlocks have finished activating the Gateways and they are now fully functional. Good work, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85464,'If we can gather enough of the artifact fragments found within Ashran we can activate the Warlock Gateways so we can move between the areas faster. $B$BHow many have you brought me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85465,'How many Artifact Fragments have we collected?','How many Artifact Fragments have we collected?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85466,'You have my thanks, hero, for releasing my soul from Cho\'gall\'s malevolent grip.$b$bThough my body rests, my spirit will stand vigil and maintain the balance until a new earthen fury takes my place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85467,'','Of course.',0,0,0,0,0,0,0,0,0,0,0,44752,26124),
(85468,'Draka, join the draenei in searching for any survivors.','',0,0,0,0,0,0,0,0,0,0,45290,0,26124),
(85469,'Forward! The superweapon is on one of these ships. Follow me!','',0,0,0,0,0,0,0,0,0,0,44787,0,26124),
(85470,'','Right away, captain! It will be my pleasure.',0,0,0,0,0,0,0,0,0,0,0,44691,26124),
(85471,'','The blood of the slain comes to my aid!',0,0,0,0,0,0,0,0,0,0,0,44692,26124),
(85472,'','You dare contest my power??? Our blood surges with energy!',0,0,0,0,0,0,0,0,0,0,0,44693,26124),
(85473,'','Your blood washes over me!',0,0,0,0,0,0,0,0,0,0,0,44694,26124),
(85474,'','No! None shall possess my potency!',0,0,0,0,0,0,0,0,0,0,0,44690,26124),
(85475,'Hah. Ditto.','',0,0,0,0,0,0,0,0,0,0,45800,0,26124),
(85476,'You will burn!','',0,0,0,0,0,0,0,0,0,0,45801,0,26124),
(85477,'This is far from over.','',0,0,0,0,0,0,0,0,0,0,45799,0,26124),
(85478,'','',0,0,0,0,0,0,0,0,0,0,42174,0,26124),
(85479,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85480,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85481,'','Warsong! To me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85482,'','Don worry mon. I keep dese raiders off ya back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85483,'Allow me the honor of holding back these raiders!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85484,'','The Warsong will tear you apart!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85485,'','The dangers of this land are not to be underestimated.$b$b<Thorn points to her eyepatch>$b$bI bear the mark of my naivety and own this mistake.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85486,'','In Pandaria I did not make a habit of asking for \"help\" on missions. Perhaps that is why we haven\'t met before?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85487,'','My blood runs rose red. This heart beats for Gilneas.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85488,'','Not so fast, mon!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85489,'You have my hammer!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85490,'','Haha, Who\'d thought an apprenticeship\'d plop me here? It\'s quite exciting!',11,0,0,0,0,0,0,0,0,0,0,0,26124),
(85491,'','Psst, do ye think Alexston and Thorn would make a cute couple? HEEHEE!',24,0,0,0,0,0,0,0,0,0,0,0,26124),
(85492,'','Hey Commander, ye ever catch a game of Battle Ball? GO FORGERS!',4,0,0,0,0,0,0,0,0,0,0,0,26124),
(85493,'','That Thorn needs to throw back a pint n\' lighten up!  Er um... Commander!',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(85494,'','So you\'re the new commander, eh? I thought you\'d be taller.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85495,'Have you seen Brightstone? My latest assistant is more than a handful.$b$bShe does everything to the extreme - drinking, talking, rushing from one task to another...$b$bShe is a damn fine architect though, and probably the brightest student I\'ve ever had.$b$bI\'ll give her that.','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(85496,'','Commander! I trust you are prepared to have your mind blown away by my designs.$b$bI am thinking... wood! Yes, wood! Lots of it. In BOLD arrangement the way that only the orcs of the original horde could conceive.$b$bAnd spikes! Yes, spikes. We must not forget the spikes. That is how you know it is Horde.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85497,'Lieutenant Thorn is a shining example to us all. Never have I seen such a dedicated leader.$B$BI haven\'t worked up the courage to speak to her, but perhaps someday, she will know my name.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85498,'You need a tree murdered, commander?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(85499,'Don\'t you have a world to save, $n? Let me do the dirty work here!','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(85500,'Did you know that we commandojacks have a twenty percent survival rate in the wild?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(85501,'I got this, Commander $n. Go save some orphans or kill an orc or something equally heroic.','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(85502,'Return to Gorgrond or Tanaan Jungle!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85503,'After I\'m done with you even the Kaliri will refuse to pick at your corpse!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85504,'By the will of Rukhmar, you shall die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85505,'I shall end this pathetic uprising here and now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85506,'I will see your corpse broken on the stones below!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85507,'Filthy scum! How dare you set foot on my terrace!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85508,'You cannot stop us...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85509,'','Greblin Fastfizzle\'s last know location was the Broken Precipice. Dungar will set you up with a flight, when you\'re ready.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(85510,'My life... for Rukhmar...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85511,'','Keep yer volume down, their camp is right here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85512,'','Stay down. Their camp is right here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85513,'No... not into the darkness...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85514,'How dare you outcasts land on my terrace! I\'ll see your bodies broken upon the stones below!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85515,'Here Mr. Lizzy... over here.','Here Mr. Lizzy... over here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85516,'Yes, those are sawblades. Now step aside! I got a tree to murder!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85517,'I\'ve pooped timber bigger than this! Step aside and let me get to work!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85518,'You go do what you\'re good at and I\'ll do what I\'m good at: killing trees.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85519,'Do you feel it? This tree is scared. I\'d say it\'s petrified...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85520,'Please remain calm while I administer healing.','Please remain calm while I administer healing.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(85521,'Please remain calm while I administer healing.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(85522,'Cut them down! Nothing will keep us from taking the city.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85523,'Another pup enters the fray?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85524,'Derrook waves good bye.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85525,'I have dedicated my life to preserving priceless artifacts and then quickly selling them for profit.$b$bIt\'s a difficult job, but I like money. Know what I\'m sayin?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85526,'If you find anything that looks like it needs some preserving let me know, chances are I can sell it somebody who likes old stuff.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85527,'You know the old saying?$b$bOne goblin\'s junk, is another goblin\'s garbage, so sell it to someone stupid enough to buy it.$b$bMy dear old mother told me that one, right before she sold me to that caravan of worgen.$b$bStill not sure how I feel about that.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85528,'<The wyvern looks at you expectantly.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85529,'Take me back to my outpost.','Take me back to my outpost.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85530,'<The gryphon looks at you expectantly.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85531,'Once those ogres are outta here I can call my people and get this excavation started.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85532,'The nerve of some ogres. I could have been done with this surveying operation weeks ago if they would have died sooner.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85533,'Amongst many scribbled entries of the trials of a pirate\'s life and a surprising amount of different uses for barnacles, you find an entry of note:\n\n\"\'Tis been a week since that cursed bird made off with the keys to my chest. He keeps flyin\' by, as if he be tauntin\' me, but I can\'t seem to to catch him on the wing. \n\nThat good for nothin\' squab can\'t fly forever. I\'ll just wait here \'till he goes aground.\"','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85534,'These ogres wouldn\'t know a priceless artifact if it jumped up and bit\'em in the rear. In fact, they probably wouldn\'t know if anything bit\'em in the rear. Know what I\'m sayin?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85535,'The Horde controls the Market Graveyard for 15 minutes!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85536,'The Alliance controls the Market Graveyard for 15 minutes!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85537,'The Market Graveyard has become neutral!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85538,'I... uh... I thought it would be funny.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(85539,'I sleep all night and I work all day, commander.$B$BI\'ve got to relieve stress somehow.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(85540,'I hope this is alright, commander.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(85541,'This isn\'t what it looks like, I swear.$B$BPlease don\'t put me on outhouse duty.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(85542,'\'Go touch the ravager nest,\' Tom said. \'It\'ll be fun,\' he said.$B$BThis oughta show him...','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(85543,'Brokyo killed the old ogre chieftain and put his head on a stake by his throne. He\'s surrounded by guards, but trust me, if you touch that ogre head he\'ll come down to greet you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85544,'<Nisha bobs her head at you, affection showing in her glowing blue eyes.>','<Nisha bobs her head at you, affection showing in her glowing blue eyes.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85545,'I work hard, too, commander. Really, I do.$B$BTom made fun of me one too many times, that\'s all. I have to get back at him.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(85546,'Ride Nisha to Fissure of Fury.','Ride Nisha to Fissure of Fury.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85547,'Well, looks like your debt to me is finally paid off. See you around.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85548,'<Nisha playfully flicks out her tongue and licks your cheek.>','<Nisha playfully flicks out her tongue and licks your cheek.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85549,'No touch! I squish you for being so dumb!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85550,'Our fates are intertwined.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85551,'Have you come to join the other fools in death?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85552,'Take my power. It is yours to command.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85553,'I\'ll make you wish you stayed on the ground!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85554,'For Rukhmar!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85555,'The skies are ours!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85556,'Yrel and I will lead the bulk of our forces south beyond this barrier.$B$BMeanwhile, if I may suggest, you lead the rest of the soldiers west and create a flanking diversion.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(85557,'I agree. A flanking maneuver will buy you the time you need to move most of our forces closer to Garrosh.','I agree. A flanking maneuver will buy you the time you need to move most of our forces closer to Garrosh.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85558,'','Durotan and I will lead the bulk of our forces south beyond this barrier.$B$BMeanwhile, if I may suggest, you lead the rest of the soldiers west and create a flanking diversion.',273,0,0,0,0,0,0,0,0,0,0,0,26124),
(85559,'I agree. A flanking maneuver will buy you the time you need to move most of our forces closer to Garrosh.','I agree. A flanking maneuver will buy you the time you need to move most of our forces closer to Garrosh.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85560,'Khadgar! Get us out of here!','',0,0,0,0,0,0,0,0,6,0,47061,0,26124),
(85561,'','D\'kaan just finished scouting up ahead. I don\'t think you\'re going to like this.',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(85562,'Like it or not, we need to move ahead. What\'s the situation?','Like it or not, we need to move ahead. What\'s the situation?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85563,'That\'s Durn the Hungerer they\'ve enslaved up ahead.$B$BIt\'s going to take everything we\'ve got to get through him.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(85564,'','That\'s Durn the Hungerer they\'ve enslaved up ahead.$B$BIt\'s going to take everything we\'ve got to get through him.',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(85565,'Aggra just finished scouting up ahead. I don\'t think you\'re going to like this.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(85566,'Like it or not, we need to move ahead. What\'s the situation?','Like it or not, we need to move ahead. What\'s the situation?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85567,'','Garrosh sits on his throne behind these gates. This is the moment it\'s all been building toward, $n.$B$BOn your order, you and I will confront him once and for all.',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(85568,'Give the order, Yrel. Destroy the gates and get us in there.','Give the order, Yrel. Destroy the gates and get us in there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85569,'Garrosh sits on his throne behind these gates. This is the moment it\'s all been building toward, $n.$B$BOn your order, you and I will confront him once and for all.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(85570,'Give the order, Durotan. Destroy the gates and get us in there.','Give the order, Durotan. Destroy the gates and get us in there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85571,'I naer thought I would live to see such an incredible place, commander.$B$BI\'m just glad I have my trusty old pal Sir Bearington tae see it all wi\' me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85572,'Good morning, commander!','',0,0,0,0,0,0,0,0,0,0,44211,0,26124),
(85573,'Good afternoon, commander!','',0,0,0,0,0,0,0,0,0,0,44212,0,26124),
(85574,'Been a long day, commander.','',0,0,0,0,0,0,0,0,0,0,44213,0,26124),
(85575,'Commander.','',0,0,0,0,0,0,0,0,0,0,44214,0,26124),
(85576,'Keep up the good work, commander.','',0,0,0,0,0,0,0,0,0,0,44215,0,26124),
(85578,'My back is aching!','',0,0,0,0,0,0,0,0,0,0,44216,0,26124),
(85579,'I\'m ready for that drink.','',0,0,0,0,0,0,0,0,0,0,44217,0,26124),
(85580,'Is it just me or is this work never done?','',0,0,0,0,0,0,0,0,0,0,44218,0,26124),
(85581,'Good to see you, commander.','',0,0,0,0,0,0,0,0,0,0,44219,0,26124),
(85582,'Just a few whacks more.','',0,0,0,0,0,0,0,0,0,0,44220,0,26124),
(85583,'Commander.','Commander.',0,0,0,0,0,0,0,0,0,0,45872,45872,26124),
(85584,'Good to see you, commander.','Good to see you, commander.',0,0,0,0,0,0,0,0,0,0,45873,45873,26124),
(85585,'All\'s quiet, commander.','All\'s quiet, commander.',0,0,0,0,0,0,0,0,0,0,45874,45874,26124),
(85586,'We\'re ready, commander.','We\'re ready, commander.',0,0,0,0,0,0,0,0,0,0,45875,45875,26124),
(85587,'Orders, commander?','Orders, commander?',0,0,0,0,0,0,0,0,0,0,45876,45876,26124),
(85588,'','Even you need to rest sometimes, commander.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(85589,'Take me to the Broken Precipice.','Take me to the Broken Precipice.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85590,'Commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85591,'I\'m working!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85592,'Just resting my eyes, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85593,'I\'ll take care of it, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85594,'Commander.','Commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85595,'Hail, commander.','Hail, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85596,'Orders, commander?','Orders, commander?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85597,'At your command.','At your command.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85598,'All\'s quiet, commander.','All\'s quiet, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85599,'We\'re under attack!','We\'re under attack!',0,0,0,0,0,0,0,0,0,0,45877,0,26124),
(85600,'Commander. What are your orders?','Commander. What are your orders?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85601,'Commander! We\'re under attack!','Commander! We\'re under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85602,'What are your orders, commander?','What are your orders, commander?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85603,'Glory to you, commander.','Glory to you, commander.',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(85604,'Long live Commander $p.','Long live Commander $p.',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(85605,'Nothing major to report, commander.','Nothing major to report, commander.',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(85606,'Orders, commander?','Orders, commander?',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(85607,'May the winds carry you swiftly, commander.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(85608,'Your ancestors would be proud of your deeds, commander.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(85609,'I will get you anywhere you need to go, commander. Just say the word.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(85610,'May Elune bless our mission, commander.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(85611,'Move along, nothing to see here.','Move along, nothing to see here.',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(85612,'Blast off!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85613,'From death.... sprouts life.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85614,'Out with the old, in with the.... new.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85615,'Arise, my little sapling.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85616,'These leaves I\'ve sprouted... are new.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85617,'Thank you Druids... you\'ve got the nature\'s touch.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85618,'And now, let\'s clear those Horde from this land.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85619,'','Apples, check. Helmets, check. Beautiful quartermaster, check.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85620,'','No, no, no, this won\'t do at all. We don\'t have nearly enough swords.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85621,'','Oh, my. We\'re definitely going to need more food.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85622,'','For the Alliance!',0,0,0,0,0,0,0,0,0,0,0,46520,26124),
(85623,'What\'s this? An arakkoa challenger in my arena?!','',0,0,0,0,0,0,0,0,0,0,44498,0,26124),
(85624,'Tired of being hunted? Or just here for revenge?','',0,0,0,0,0,0,0,0,0,0,44499,0,26124),
(85625,'%s laughs.','',0,0,0,0,0,0,0,0,0,0,44500,0,26124),
(85626,'Go ahead, little bird. Do your worst!','',0,0,0,0,0,0,0,0,0,0,44501,0,26124),
(85627,'What?! Who are you?!','',0,0,0,0,0,0,0,0,0,0,44502,0,26124),
(85628,'Enough. This ends NOW!','',0,0,0,0,0,0,0,0,0,0,44504,0,26124),
(85629,'I am the Talon King! I have come from beyond death to stem the iron tide!','',0,0,0,0,0,0,0,0,0,0,46462,0,26124),
(85630,'Hngh! Im...possible...','',0,0,0,0,0,0,0,0,0,0,46463,0,26124),
(85631,'Well I\'m Kargath Bladefist, and when I kill something IT STAYS DEAD.','',0,0,0,0,0,0,0,0,0,0,44503,0,26124),
(85632,'My power... has... failed you... $p.','',0,0,0,0,0,0,0,0,0,0,46464,0,26124),
(85633,'Hmph. So it\'s you in there.','',0,0,0,0,0,0,6,0,0,0,44505,0,26124),
(85634,'Khadgar isn\'t here to protect you this time.','',0,0,0,0,0,0,397,0,0,0,44506,0,26124),
(85649,'Blackhand has cast |TInterface\\Icons\\ability_rogue_hungerforblood.blp:20|t|cFFFF0404|Hspell:168261|h[Marked for Death]|h|r on you. Hide behind the Iron Stars to avoid the attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85650,'What?! GGRAAAHHH!!!!','',0,0,0,0,0,0,603,0,0,0,44507,0,26124),
(85651,'','I don\'t want to say we were unprepared, but we are short on supplies here in Ashran. We just didn\'t bring enough through the portal.$B$BHopefully Sprocket\'s team can get us the heavy machinery we need to win this battle against the Horde.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85652,'Are you alright? That was a close call.','',0,0,0,0,0,0,0,0,0,0,46300,0,26124),
(85653,'Time to paint my masterpiece!','Time to paint my masterpiece!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85654,'No tree can withstand the force of my blows!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85655,'This monster tree will be obliterated in no time, commander. Stand by!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85656,'I\'m a mobile lumber mill, built for shredding wood. Stand back!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85657,'I could do better.','I could do better.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85658,'','I have been waiting all day for some repairs to be done. But that\'s okay, there are plenty of things to do to pass the time.',595,0,0,0,0,0,0,0,0,0,0,0,26124),
(85659,'','Fellworth got our group lost by finding a \"shortcut\" through the hollow and now my boots are full of slime and mud!\n\nI think I will be charge of the map from now on.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85660,'','Your flight master insisted you fly back.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(85661,'','Yer flight master insisted ye fly back.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(85662,'Very well, Birchus, let\'s see if this works.  Here\'s the Heart Seed.','Very well, Birchus, let\'s see if this works.  Here\'s the Heart Seed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85663,'You will not be disappointed. Finally my long adventure is over! Arise Dionor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85664,'We weren\'t lost; I was just taking the adventurous route!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85665,'So, what do you do for a living?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85666,'Well, I study and translate ancient mogu scrolls.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85667,'Yeah, I know, tell that to my C.O.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85668,'You don\'t find a lot of that out here...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85669,'','Let me check the map, Fellworth. I will decide where we travel next.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85670,'Patrols have been increased throughout the city.  We will not succumb to attacks by these savages.','Patrols have been increased throughout the city.  We will not succumb to attacks by these savages.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85671,'Defenders of Karabor stand ready!','Defenders of Karabor stand ready!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85672,'Our people nor our city shall fall to the savages!','Our people nor our city shall fall to the savages!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85673,'It is now we must come together, stronger than ever.','It is now we must come together, stronger than ever.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85674,'It bein\' just my luck, mon! I be findin\' da best fishin\' spot down \'ere, but only after da elementals and da ogres broke up all my gear. \n\nNow I\'m needin\' a new rod, reel, and da special voodoo lure so I can land da big ones hidin\' in da weeds.','',0,0,0,0,0,0,0,0,0,28629,0,0,26124),
(85675,'I think I can help you. (Give Abu\'gar his rod, reel and lure)','I think I can help you. (Give Abu\'gar his rod, reel and lure)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85676,'Hey, commander! You sure you aren\'t part Laughing Skull?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85677,'You have proven that you have the strength to survive even the most dangerous of situations. Your technique in combat is unlike anyone I have seen. I am glad to call you friend.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(85678,'Ey, boss-mon. Take a load off. Relax.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(85679,'May the Light\'s power resonate within your actions. We shall not let the hatred of our savage enemies overcome our will to survive. Carry forth and return our people to health!','May the Light\'s power resonate within your actions. We shall not let the hatred of our savage enemies overcome our will to survive. Carry forth and return our people to health!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85680,'','So it is true. The heart CAN infuse life into these creatures.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(85681,'','Ah, hero... I knew you would come. You are just in time to witness the heart\'s power.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(85682,'','This magnaron walked Draenor before the first orc took breath. And now, it... and an endless army of these destroyers... bend to MY will!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(85683,'','Follow me, $n. She\'s up this way.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(85684,'Foreman, change this building into a tankworks.','Foreman, change this building into a tankworks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85685,'We barely got you out in time.','',0,0,0,0,0,0,0,0,0,0,46301,0,26124),
(85686,'That orc... Kargath. Even at my full strength, he would prove a challenge.','',0,0,0,0,0,0,0,0,0,0,46465,0,26124),
(85687,'My children, it will take more than a fading memory from the past to overcome the challenges you face today.','',0,0,0,0,0,0,0,0,0,0,46466,0,26124),
(85688,'Switching the building will cost 5,000 gold.\n\nAre you sure?','Switching the building will cost 5,000 gold.\n\nAre you sure?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85689,'You must strike your own path. Lay the past to rest and raise new champions.','',0,0,0,0,0,0,0,0,0,0,46467,0,26124),
(85690,'So far the Alliance found them all over Ashran. Killing any creature you can find will no doubt increase your chances for discovery.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85691,'','We got wind that there are hidden artifacts here, in this place called Ashran. Artifacts from a remnant Highmaul Ogre clan.$B$BThey could be the key to our success against the Iron Horde.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85692,'Stouttoe! Is that you?','Stouttoe! Is that you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85693,'You have one already.','',0,0,0,0,0,0,0,0,0,0,46468,0,26124),
(85694,'Hero, I can never again grant you my full power. Kargath severed that bond.','',0,0,0,0,0,0,0,0,0,0,46469,0,26124),
(85695,'But so long as you tread in Arak, some piece of me will remain with you.','',0,0,0,0,0,0,0,0,0,0,46470,0,26124),
(85696,'Foreman, change this building into a corral.','Foreman, change this building into a corral.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85697,'I will lend my power as often as I can.','',0,0,0,0,0,0,0,0,0,0,46471,0,26124),
(85698,'Your suffering will be legendary.','',0,0,0,0,0,0,0,0,0,0,46324,0,26124),
(85699,'Thaelin, let\'s change this building into a tankworks.','Thaelin, let\'s change this building into a tankworks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85700,'But first... I think I need to wash my hands. I will meet you back at your camp.','',0,0,0,0,0,0,0,0,4,0,45042,0,26124),
(85701,'Thaelin, let\'s change this building into a corral.','Thaelin, let\'s change this building into a corral.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85702,'Arise, my minions! Rend their flesh.','',0,0,0,0,0,0,0,0,0,0,46325,0,26124),
(85703,'VERMIN! I WILL TURN YOUR WORLD TO ASH!','',0,0,0,0,0,0,0,0,0,0,46326,0,26124),
(85704,'Where are they, exactly?','Where are they, exactly?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85705,'Should I bring them to you?','Should I bring them to you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85706,'I\'ll do my best!','I\'ll do my best!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85707,'Tell you what, go grab me five or so and bring them back to the Mage sitting near the campfire over there. Ecilam\'s his name. He\'s using the artifact\'s power to summon some Mage portals within Ashran.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85708,'Commander, what\'s wrong?','',0,0,0,0,0,0,0,0,4,0,45000,0,26124),
(85709,'','I cannot wait to target some Iron Horde.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85710,'Squeeeeeeek!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85711,'','So then he pulls out a handful of moss. What a weirdo!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85712,'','So I said, \"I can do it, but not for cheap.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85713,'','Next thing I know I\'m waking up behind the shop with it all in my hair!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85714,'They keep coming!','They keep coming!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85715,'More to slay.','More to slay.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85716,'I lost count. How many was that?','I lost count. How many was that?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85717,'They must breed like Murlocs.','They must breed like Murlocs.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85718,'Praise the Raven Mother, we have everything ready! Speak with me again when you are prepared to begin.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85719,'Goren Gluttons Killed: $1i (+$2i)','Goren Gluttons Killed: $1i (+$2i)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85720,'Goren Burrowers Killed: $1i (+$2i VP)','Goren Burrowers Killed: $1i (+$2i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85721,'Acidback Rollers Killed: $1i (+$2i VP)','Acidbacks Rollers Killed: $1i (+$2i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85722,'','What do you make of that... thing? It\'s enormous.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85723,'What\'s the situation?','What\'s the situation?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85724,'Can I get another Icespine Stinger Bait?','Can I get another Icespine Stinger Bait?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(85725,'now... Nowww!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85726,'Aaaaahhhh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85727,'Death comes...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85728,'Yeeeesssss','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85729,'','Now... Nowww!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85730,'','Aaaaahhhh!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85731,'','Death comes...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85732,'','Yeeeesssss',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85733,'What should I paint... what should I paint?','What should I paint... what should I paint?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85734,'','Argghh! Looks like we\'ll have to deal with that gronn.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(85735,'','Well, at least we took care of that thing. Come on, hero. We\'d better report this back to headquarters.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(85736,'Shattrath has been attacked by a terrible foe!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(85737,'Many lives were lost in the attack, both friends and family alike.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(85738,'Due to your heroic actions, however, many more lives were saved!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(85739,'Although we were unprepared for the attack, each one of you performed admirably.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(85740,'Starting today, new patrols will be instituted across all of Shattrath.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(85741,'Make no mistake, we will NOT be caught unprepared again!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(85742,'May the light embrace you!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(85743,'How goes the fight from the front lines, $n?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85744,'$n, Sir! Reporting for duty, Sir!','$n, Sir! Reporting for duty, Sir!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85745,'Don\'t let this nuisance anywhere near the cannon.','',0,0,0,0,0,0,0,0,0,0,43931,0,26124),
(85746,'Don\'t let those Horde anywhere near Stormshield, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85747,'Huh, well then, I\'ll just have to end this myself.','',0,0,0,0,0,0,0,0,0,0,43932,0,26124),
(85748,'I\'ll take you out with me!','',0,0,0,0,0,0,0,0,0,0,43933,0,26124),
(85749,'Reporting for duty, Sir!','Reporting for duty, Sir!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85750,'Reporting in!','Reporting in!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85751,'Your Alchemy Lab is under attack!','Your Alchemy Lab is under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85752,'Watch this!','Watch this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85753,'Your Armory is under attack!','Your Armory is under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85754,'Your Barn is under attack!','Your Barn is under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85755,'Your Barracks is under attack!','Your Barracks is under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85756,'Your Blacksmith is under attack!','Your Blacksmith is under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85757,'Your Enchanter\'s Study is under attack!','Your Enchanter\'s Study is under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85758,'Your Engineering Works is under attack!','Your Engineering Works is under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85759,'Your Inn is under attack!','Your Inn is under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85760,'Your Scribe\'s Quarters is under attack!','Your Scribe\'s Quarters is under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85761,'Your Gem Boutique is under attack!','Your Gem Boutique is under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85762,'Your Tannery is under attack!','Your Tannery is under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85763,'You\'re to show me Ashran?','You\'re to show me Ashran?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85764,'Your Lumber Mill is under attack!','Your Lumber Mill is under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85765,'Your Sparring Arena is under attack!','Your Sparring Arena is under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85766,'Not again! Another broken string.','Not again! Another broken string.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85767,'Your Mage Tower is under attack!','Your Mage Tower is under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85768,'Your Salvage Yard is under attack!','Your Salvage Yard is under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85769,'Your Stables are under attack!','Your Stables are under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85770,'Your Storehouse is under attack!','Your Storehouse is under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85771,'Good Shot!','Good Shot!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85772,'Your Trading Post is under attack!','Your Trading Post is under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85773,'Your Tailoring Emporium is under attack!','Your Tailoring Emporium is under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85774,'Your Workshop is under attack!','Your Workshop is under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85775,'BONUS: Alchemy Lab Intact (+$1i VP)','BONUS: Alchemy Lab Intact (+$1i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85776,'Show off.','Show off.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85777,'Now let\'s try this again.','Now let\'s try this again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85778,'Child\'s Play.','Child\'s Play.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85779,'I... <gasp> I\'m fine, $p. I just need to catch my breath.$b$bI wasn\'t expecting the ride to be so fast.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85780,'Good work, $p! Come speak with me, there is much still to do.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85781,'BONUS: Armory Intact (+$1i VP)','BONUS: Armory Intact (+$1i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85782,'BONUS: Barn Intact (+$1i VP)','BONUS: Barn Intact (+$1i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85783,'BONUS: Barracks Intact (+$1i VP)','BONUS: Barracks Intact (+$1i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85784,'BONUS: Blacksmith Intact (+$1i VP)','BONUS: Blacksmith Intact (+$1i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85785,'BONUS: Enchanter\'s Study Intact (+$1i VP)','BONUS: Enchanter\'s Study Intact (+$1i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85786,'BONUS: Engineering Works Intact (+$1i VP)','BONUS: Engineering Works Intact (+$1i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85787,'BONUS: Inn Intact (+$1i VP)','BONUS: Inn Intact (+$1i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85788,'BONUS: Scribe\'s Quarters Intact (+$1i VP)','BONUS: Scribe\'s Quarters Intact (+$1i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85789,'BONUS: Gem Boutique Intact (+$1i)','BONUS: Gem Boutique Intact (+$1i)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85790,'BONUS: Tannery Intact (+$1i VP)','BONUS: Tannery Intact (+$1i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85791,'BONUS: Lumber Mill Intact (+$1i VP)','BONUS: Lumber Mill Intact (+$1i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85792,'BONUS: Mage Tower Intact (+$1i VP)','BONUS: Mage Tower Intact (+$1i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85793,'BONUS: Salvage Yard Intact (+$1i VP)','BONUS: Salvage Yard Intact (+$1i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85794,'BONUS: Sparring Arena Intact (+$1i VP)','BONUS: Sparring Arena Intact (+$1i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85795,'BONUS: Stable Intact (+$1i VP)','BONUS: Stable Intact (+$1i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85796,'BONUS: Storehouse Intact (+$1i VP)','BONUS: Storehouse Intact (+$1i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85797,'BONUS: Tailoring Emporium Intact (+$1i VP)','BONUS: Tailoring Emporium Intact (+$1i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85798,'BONUS: Trading Post Intact (+$1i VP)','BONUS: Trading Post Intact (+$1i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85799,'BONUS: Workshop Intact (+$1i VP)','BONUS: Workshop Intact (+$1i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85800,'You make Graveltooth ANGRY! Now you go squish!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(85801,'Then let\'s hurry!','Then let\'s hurry!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85802,'This area is off limits.','This area is off limits.',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(85803,'Please take a step back.','Please take a step back.',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(85804,'Lumber shipment en route to your lumber mill!','Lumber shipment en route to your lumber mill!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85805,'I am ready to fly again, Ka\'alu.','I am ready to fly again, Ka\'alu.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85806,'','Such devastation...',0,0,0,0,0,0,18,0,0,0,0,9676,26124),
(85807,'','Why must the orcs cause so much suffering?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(85808,'','Next time... I will reduce ALL of them to ash!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(85809,'','%s lets out a long, drawn out sigh.',0,0,0,0,0,0,0,0,0,0,0,10577,26124),
(85810,'The enemy battleship is just off the coast.  We will hold off Blackhand, it\'s up to you to disable that boat and save Shattrath!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85811,'What progress do you have to report? This better not be like last time!','',0,0,0,0,0,0,603,0,4,0,0,0,26124),
(85812,'','We have learned how to dominate the minds of gronn.',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(85813,'Good. Finish your work and bring them to me.','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(85814,'','Yes, Commander Gar.',0,0,0,0,0,0,273,0,4,0,0,0,26124),
(85815,'Greetings, $n. Here to do some lumberjacking?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(85816,'I\'d like to submit a work order.','I\'d like to submit a work order.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85817,'Place your hand on Nisha\'s head.','Place your hand on Nisha\'s head.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85818,'<Nisha flutters her wings, ready to go scouting for Rexxar.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85819,'<Kolrigg\'s eyes are closed and his skin is pale.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85820,'Administer the antidote to Kolrigg.','Administer the antidote to Kolrigg.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85821,'','<Lunzul\'s eyes are closed and her skin is pale.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85822,'Administer the antidote to Lunzul.','Administer the antidote to Lunzul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85823,'Oi, me head.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85824,'Ah, commander, I can\'t thank ye enough. I\'ll get the ol\' brewery up and runnin\' in two shakes of a talbuk\'s tail.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(85825,'','My head be hurtin\' somethin\' terrible.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85826,'','Bless ya, boss mon. I be gettin\' da tavern up and runnin\' faster than you be believin\'.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(85827,'Your Alchemy Lab has been damaged!','Your Alchemy Lab has been damaged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85828,'Your Workshop has been damaged!','Your Workshop has been damaged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85829,'Your Trading Post has been damaged!','Your Trading Post has been damaged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85830,'Your Tailoring Emporium has been damaged!','Your Tailoring Emporium has been damaged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85831,'Your Storehouse has been damaged!','Your Storehouse has been damaged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85832,'Your Stables have been damaged!','Your Stables have been damaged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85833,'Your Sparring Arena has been damaged!','Your Sparring Arena has been damaged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85834,'Your Salvage Yard has been damaged!','Your Salvage Yard has been damaged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85835,'Your Mage Tower has been damaged!','Your Mage Tower has been damaged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85836,'Your Lumber Mill has been damaged!','Your Lumber Mill has been damaged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85837,'Your Tannery has been damaged!','Your Tannery has been damaged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85838,'Your Gem Boutique has been damaged!','Your Gem Boutique has been damaged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85839,'Your Scribe\'s Quarters has been damaged!','Your Scribe\'s Quarters has been damaged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85840,'Your Inn has been damaged!','Your Inn has been damaged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85841,'Your Engineering Works has been damaged!','Your Engineering Works has been damaged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85842,'The Iron Maidens have fallen? They were my favorite! Find these invaders and bring me their heads!','',0,0,0,0,0,0,0,0,0,0,45461,0,26124),
(85843,'Your Enchanter\'s Study has been damaged!','Your Enchanter\'s Study has been damaged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85844,'That beast was irreplaceable. Where are the attackers now? I want them dead. DEAD!','',0,0,0,0,0,0,0,0,0,0,45462,0,26124),
(85845,'Your Blacksmith has been damaged!','Your Blacksmith has been damaged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85846,'Your Barracks has been damaged!','Your Barracks has been damaged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85847,'Your Barn has been damaged!','Your Barn has been damaged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85848,'You? You\'re the dogs who have been wreaking havoc throughout my foundry? Step forward! I will put you in your place.','',0,0,0,0,0,0,0,0,0,0,45434,0,26124),
(85849,'Your Armory has been damaged!','Your Armory has been damaged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85850,'I will hang your broken bodies from the gates of this foundry!','',0,0,0,0,0,0,0,0,0,0,45419,0,26124),
(85851,'You destroyed my furnace.... Now, my furnace will destroy YOU.','',0,0,0,0,0,0,0,0,0,0,45447,0,26124),
(85852,'Open the flumes! Flood the room with molten slag.','',0,0,0,0,0,0,0,0,0,0,45448,0,26124),
(85853,'I\'ll burn you alive, even if I have to flood the whole foundry...','',0,0,0,0,0,0,0,0,0,0,45449,0,26124),
(85854,'I\'ll bring this whole place down around your heads!','',0,0,0,0,0,0,0,0,0,0,45421,0,26124),
(85855,'I\'ll tear this place apart if I have to!','',0,0,0,0,0,0,0,0,0,0,45422,0,26124),
(85856,'We will rebuild this place... but no one will be able to put YOU back together.','',0,0,0,0,0,0,0,0,0,0,45423,0,26124),
(85857,'You are slow.','',0,0,0,0,0,0,0,0,0,0,45450,0,26124),
(85858,'You are weak.','',0,0,0,0,0,0,0,0,0,0,45451,0,26124),
(85859,'You should\'ve ducked.','',0,0,0,0,0,0,0,0,0,0,45452,0,26124),
(85860,'There\'s no place to hide, now.','',0,0,0,0,0,0,0,0,0,0,45453,0,26124),
(85861,'Coward!','',0,0,0,0,0,0,0,0,0,0,45454,0,26124),
(85862,'You hide like children!','',0,0,0,0,0,0,0,0,0,0,45455,0,26124),
(85863,'Get out here and fight!','',0,0,0,0,0,0,0,0,0,0,45456,0,26124),
(85864,'Everyone DOWN.','',0,0,0,0,0,0,0,0,0,0,45440,0,26124),
(85865,'Snipers! Gun them down.','',0,0,0,0,0,0,0,0,0,0,45431,0,26124),
(85866,'Soldiers! Open fire!','',0,0,0,0,0,0,0,0,0,0,45432,0,26124),
(85867,'Blackrock warriors - fire!','',0,0,0,0,0,0,0,0,0,0,45433,0,26124),
(85868,'Bring in the siegemaker.','',0,0,0,0,0,0,0,0,0,0,45457,0,26124),
(85869,'Siege machines! Tear this place apart!','',0,0,0,0,0,0,0,0,0,0,45458,0,26124),
(85870,'Machines, open fire! Destroy them at any cost!','',0,0,0,0,0,0,0,0,0,0,45459,0,26124),
(85871,'Burn - you will all BURN!','',0,0,0,0,0,0,0,0,0,0,45441,0,26124),
(85872,'This foundry\'s molten heart will devour you.','',0,0,0,0,0,0,0,0,0,0,45442,0,26124),
(85873,'Your bodies will fuel the flames.','',0,0,0,0,0,0,0,0,0,0,45425,0,26124),
(85874,'The furnace will consume you!','',0,0,0,0,0,0,0,0,0,0,45426,0,26124),
(85875,'The hotter the flame, the stronger the steel...','',0,0,0,0,0,0,0,0,0,0,45427,0,26124),
(85876,'This cauldron is your end.','',0,0,0,0,0,0,0,0,0,0,45428,0,26124),
(85877,'Your time runs out.','',0,0,0,0,0,0,0,0,0,0,45429,0,26124),
(85878,'This crucible is your molten grave!','',0,0,0,0,0,0,0,0,0,0,45430,0,26124),
(85879,'Weak.','',0,0,0,0,0,0,0,0,0,0,45435,0,26124),
(85880,'You have no discipline.','',0,0,0,0,0,0,0,0,0,0,45436,0,26124),
(85881,'Our weapons are superior.','',0,0,0,0,0,0,0,0,0,0,45437,0,26124),
(85882,'Pah! Dead.','',0,0,0,0,0,0,0,0,0,0,45438,0,26124),
(85883,'That\'s all you can muster?','',0,0,0,0,0,0,0,0,0,0,45439,0,26124),
(85884,'I will finish this myself!','',0,0,0,0,0,0,0,0,0,0,45420,0,26124),
(85885,'This one should go out with a bang...','',0,0,0,0,0,0,0,0,0,0,45443,0,26124),
(85886,'This one\'s packing a little extra heat.','',0,0,0,0,0,0,0,0,0,0,45444,0,26124),
(85887,'This prototype has double armor plating.','',0,0,0,0,0,0,0,0,0,0,45445,0,26124),
(85888,'The fastest machine in our arsenal!','',0,0,0,0,0,0,0,0,0,0,45446,0,26124),
(85889,'We are... the Warchief\'s weapon... Without us, he...','',0,0,0,0,0,0,0,0,0,0,45424,0,26124),
(85890,'A wounded defender has perished!','A wounded defender has perished!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85891,'Prepare to battle the Primals.','Prepare to battle the Primals.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85892,'Try and keep the peon from dying. They\'re like monster magnets!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85893,'','<A voice fills your thoughts.>$b$bWe must hurry before the children of Rukhmar can regroup their forces.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85894,'Fine, but I\'ll have my eye on her.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(85895,'','Much better, oaf! I am here to see the commander.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85896,'Please, don\'t wander too far. We need you here, champion.','',0,0,0,0,0,0,0,0,0,0,44879,0,26124),
(85897,'Shelly? Is that you?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(85898,'Yes?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85899,'Don\'t trust them, Shelly! They are lying to you. They will eat you. They will eat us all!','',18,0,0,0,0,0,0,0,0,0,0,0,26124),
(85900,'I always did hate vegetables...','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(85901,'','Hi Mom!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85902,'Well done, friend. It is rare for one to emerge from that cave alive.','',0,0,0,0,0,0,1,0,1,0,46563,0,26124),
(85903,'Fall in line, maggots! Looks like we\'ve got company.','Fall in line, maggots! Looks like we\'ve got company.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85904,'CRUSH THEM!!!','',0,0,0,0,0,0,480,0,0,0,0,0,26124),
(85905,'','Rubee just loves her treats.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85906,'Calm yourself, Zoggosh. We will do no such thing. If these weaklings are so eager to die, then we should oblige.','',0,0,0,0,0,0,603,0,0,0,43899,0,26124),
(85907,'Zoggosh, do not question my authority. This isn\'t just ANY gronn. This is Skulloc, Son of Gruul. The blood of a champion courses through his veins. I\'m not concerned with these... paltry whelps.','',0,0,0,0,0,0,1,0,0,0,43900,0,26124),
(85908,'And what exactly do you think they\'re going to do with orcish iron? Fall on it and die, probably. I\'m not worried in the least.','',0,0,0,0,0,0,6,0,0,0,43901,0,26124),
(85909,'Hah. Would you look at that. Maybe I... underestimated them. Zoggosh! Prepare Skulloc! Let them have a taste of what he has to offer.','',0,0,0,0,0,0,6,0,0,0,43902,0,26124),
(85910,'FIRE... FIRE! AIM, THEN FIRE!','',0,0,0,0,0,0,6,0,0,0,43903,0,26124),
(85911,'What is wrong with you?! Keep firing you oaf!','',0,0,0,0,0,0,603,0,0,0,43904,0,26124),
(85912,'Argghhhh! Forget it! They\'ll never make it past the tracks. Makogg, Ahri\'ok - front and center! There\'s some new meat for you to tenderize.','',0,0,0,0,0,0,1,0,0,0,43905,0,26124),
(85913,'That was an insignificant loss. Let them exhaust themselves, preying against our weak -- against those who are unworthy of serving in Blackhand\'s army! Blood and honor, Zoggosh. That is all that orcs understand.','',0,0,0,0,0,0,1,0,0,0,43906,0,26124),
(85914,'That is what I do, Zoggosh. I think good.','',0,0,0,0,0,0,1,0,0,0,43907,0,26124),
(85915,'I\'m not playing these games anymore. Bring in the saberon and we\'ll be done with it.','',0,0,0,0,0,0,603,0,0,0,43908,0,26124),
(85916,'Put a muzzle on it.','',0,0,0,0,0,0,1,0,0,0,43909,0,26124),
(85917,'I didn\'t mean the cat.','',0,0,0,0,0,0,1,0,0,0,43910,0,26124),
(85918,'How dare you march into MY DOCKS and so brazenly set foot on MY SHIP. Nothing will stop the Iron Horde, least of all you.  Enjoy your death, weaklings. Zoggosh, man the machine turret!','',0,0,0,0,0,0,603,0,0,0,43911,0,26124),
(85919,'I don\'t have the 10 timber required to place a work order. Where can I find more timber?','I don\'t have the 10 timber required to place a work order. Where can I find more timber?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85920,'Zoggosh, ready your axe. This ends now!','',0,0,0,0,0,0,603,0,0,0,43912,0,26124),
(85921,'So WEAK!','',0,0,0,0,0,0,11,0,0,0,43913,0,26124),
(85922,'Bow before the might of the Iron Horde!','',0,0,0,0,0,0,5,0,0,0,43914,0,26124),
(85923,'In... conceivable....','',0,0,0,0,0,0,0,0,0,0,43898,0,26124),
(85924,'Sir, they\'ve breached the gates! Nok\'gar... He\'s dead!! We should pick up anchor and set sail for Talador right now!','',0,0,0,0,0,0,603,0,0,0,44047,0,26124),
(85925,'But sir, this is the last of the gronn that we have! Blackhand will have our hides if we show up empty handed!','',0,0,0,0,0,0,603,0,0,0,44048,0,26124),
(85926,'Yessir!','',0,0,0,0,0,0,603,0,0,0,44049,0,26124),
(85927,'Sir! They\'re tampering with the Iron Stars!','',0,0,0,0,0,0,603,0,0,0,44050,0,26124),
(85928,'Igniting the cannons, sir!','',0,0,0,0,0,0,603,0,0,0,44051,0,26124),
(85929,'Sir, he\'s out of ammunition! I\'m reloading, I\'m reloading!','',0,0,0,0,0,0,603,0,0,0,44052,0,26124),
(85930,'Sir, half of our army has been taken out! Don\'t you think we should--','',0,0,0,0,0,0,6,0,0,0,44053,0,26124),
(85931,'Ahhh. Good thinking, sir.','',0,0,0,0,0,0,1,0,0,0,46637,0,26124),
(85932,'Captain, they\'re almost here! What do we do now?!','',0,0,0,0,0,0,603,0,0,0,44054,0,26124),
(85933,'Uhhh... Are you sure you want to let that thing out of its cage? I don\'t think we have fed it since we found it.','',0,0,0,0,0,0,6,0,0,0,44055,0,26124),
(85934,'Good idea, sir!','',0,0,0,0,0,0,603,0,0,0,44056,0,26124),
(85935,'Oh.','',0,0,0,0,0,0,0,0,0,0,44057,0,26124),
(85936,'Aye aye, sir!','',0,0,0,0,0,0,0,0,0,0,44058,0,26124),
(85937,'Yes, captain!','',0,0,0,0,0,0,0,0,0,0,44059,0,26124),
(85938,'Koramar, no! I will avenge you!','',0,0,0,0,0,0,0,0,0,0,44060,0,26124),
(85939,'','Right away, captain! It will be my pleasure.',0,0,0,0,0,0,1,0,0,0,0,44691,26124),
(85940,'Hah. Ditto.','',0,0,0,0,0,0,0,0,0,0,45800,0,26124),
(85941,'','Ooooh! Is there killin\' ta be done? Lemme at\'em!',0,0,0,0,0,0,603,0,0,0,0,46128,26124),
(85942,'Rooby Roo looks at you, then runs off!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85943,'Iron Horde Killed: $1i (+$2i VP)','Iron Horde Killed: $1i (+$2i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85944,'Scout! What do you have to report?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85945,'Looks like the Iron Horde is making their move. Grunts! Get the peons to shelter!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85946,'To arms! To your posts! We face a worthy foe today...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85947,'Sergeant! Smoke on the horizon, and war drums in the distance!','Sergeant! Smoke on the horizon, and war drums in the distance!',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(85948,'We\'ll have to face their scouts first.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85949,'Here they come...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85950,'Rooby Roo is hungry!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85951,'','To become an Exarch, I must first pass through a series of trials.',0,0,0,0,0,0,0,0,0,0,0,45544,26124),
(85952,'','I am allowed one champion to accompany me along this journey. I would like that person to be you, $n.',0,0,0,0,0,0,0,0,0,0,0,45545,26124),
(85953,'','I am ready. Come, the Exarch Council awaits.',0,0,0,0,0,0,0,0,0,0,0,45546,26124),
(85954,'They were just sent to soften us up...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85955,'Spread out! They\'ll be coming from all angles!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85956,'Rukhmar sheds her feathers, igniting all Piles of Ash to fight one last time!','Rukhmar sheds her feathers, igniting all Piles of Ash to fight one last time!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85957,'We.... we made it...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85958,'','|TInterface\\Icons\\Ability_Mage_MoltenArmor.blp:20|tArchmage Sol begins casting Fire spells!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85959,'','|TInterface\\Icons\\Spell_Frost_FrostArmor02.blp:20|tArchmage Sol begins casting Frost spells!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85960,'','|TInterface\\Icons\\Spell_MageArmor.blp:20|tArchmage Sol begins casting Arcane spells!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85961,'Rooby Roo looks at you, then slowly saunters off.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85962,'Rooby Roo barks. There\'s something in there!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85963,'','Is... is it dead?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85964,'I was promised... eternal life...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85965,'We are nearly free of Tanaan\'s grasp. Stay focused now, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85966,'','A-a-a-about t-time, $n. I-it\'s f-freezing out here. No wonder we draenei s-s-settled in warmer areas.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85967,'Let\'s get out of here.','Let\'s get out of here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85968,'I\'m ready to face Everburn.','I\'m ready to face Everburn.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85969,'','Are you ready, hero? It is just up this way.',0,0,0,0,0,0,0,0,0,0,0,45547,26124),
(85970,'','Steel yourself. This is not the lair of an ordinary beast.',0,0,0,0,0,0,0,0,0,0,0,45548,26124),
(85971,'','Come, fury! My courage shall not falter before you!',0,0,0,0,0,0,0,0,0,0,0,45549,26124),
(85973,'','Well done, champion! Akama\'s task is finished. I cannot wait to see his face when we report on our success.',0,0,0,0,0,0,0,0,0,0,0,45550,26124),
(85974,'I will tear you and your garrison apart.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85975,'A soldier\'s duty... is never done.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85976,'Your time... will come.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85977,'You\'re a fool. Just like Taylor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85978,'I turned the Admiral\'s \"followers\" against him. Perhaps I shall pay your garrison a visit next?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85979,'The dark one promised me so much... if I succeeded...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85980,'<Rooby Roo looks hungry. Perhaps her owner has something that would help.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85981,'Your bags have been pickpocketed by |c00FFFF00|Hspell:168798|h[Pick Pocket]|h|r. You\'ve lost 5 |c00FFFFFF|Hcurrency:944|h[Artifact Fragments]|h|r.','Your bags have been pickpocketed by |c00FFFF00|Hspell:168798|h[Pick Pocket]|h|r. You\'ve lost 5 |c00FFFFFF|Hcurrency:944|h[Artifact Fragments]|h|r.',0,0,0,0,0,0,0,0,0,0,44578,44578,26124),
(85982,'Were it not for you, this would be Nisha\'s resting place as well.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85983,'Oregorger has gone insane from hunger!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85984,'Very good! Did you rehearse when I wasn\'t looking?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85985,'Correct, you are doing fine.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85986,'Fantastic! The power of the ritual is increasing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85987,'Perfect! Oh, we are so close to success!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85988,'Come on, Bryan. Snap out of it!','',0,0,0,0,0,0,603,0,0,26703,0,0,26124),
(85989,'Snap out of it, mon. Come back to us.','',0,0,0,0,0,0,603,0,0,26702,0,0,26124),
(85990,'%s does not detect any nearby enemies, and initiates |cFFFF0404|Hspell:168929|h[Cannon Barrage!]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(85991,'It came... in the night...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85992,'','This is it. Garrosh Hellscream sits smugly on his throne just beyond these gates.$B$BWe can\'t let him escape this time, $n.',396,274,0,0,0,0,0,0,0,0,0,0,26124),
(85993,'Can\'t you see I am trying to fish here?','Can\'t you see I am trying to fish here?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(85994,'You look like an able fisherman, do you think you can help us out?\n\nWe have established a small garrison nearby, but we are finding it difficult to feed our troops. Any fishing advice you could give us would really help.','You look like an able fisherman, do you think you can help us out?\n\nWe have established a small garrison nearby, but we are finding it difficult to feed our troops. Any fishing advice you could give us would really help.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(85995,'At this point, we are just waiting for an opening. Once the stream of enemies abates, we make our move.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85996,'<The archmage focuses intently on the portal.>$b$bLook. Their numbers are abating, however briefly. This may be our chance.$b$bAre you prepared to face whatever\'s on the other side of that portal?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85997,'FOR AZEROTH!','FOR AZEROTH!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(85998,'Tread carefully. If the rumors I hear are true, you will find yourself in grave danger.','',1,0,0,0,0,0,0,0,0,0,45263,0,26124),
(85999,'You have shown great courage and recovered an invaluable artifact. Lok\'tar.','',113,0,0,0,0,0,0,0,0,0,45264,0,26124),
(86000,'I know not what you will find out there, but if you encounter any of the Iron Horde, show them no mercy.','',1,0,0,0,0,0,0,0,0,0,44839,0,26124),
(86001,'The heart of the magnaron... the power we now wield against the Iron Horde is immense.','',603,0,0,0,0,0,0,0,0,0,44840,0,26124),
(86003,'Miss Pinchwhistle! The \"Mother Lode,\" it just crashed into the mountains south of here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86004,'','What!? They were only supposed to be observing; we need to get a rescue team down there pronto!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86005,'','Whoa! What was that?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86006,'Speak with Ka\'alu when you are ready to fly.','',0,0,0,0,0,0,1,0,0,0,45995,0,26124),
(86007,'There\'s timber to be found across all of Draenor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86008,'There\'s timber all across this world, commander, but I would recommend that you harvest in Gorgrond or Talador.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(86009,'There\'s timber all across this world, commander, but I would recommend that you harvest in the Spires of Arak or Talador.$B$BBoth of those regions are overflowing with timber to chop down!','',1,5,0,0,0,0,0,0,0,0,0,0,26124),
(86010,'Nagrand is the final frontier for harvesting timber, $g sir:ma\'am;.$B$BOf course the rest of Draenor is wide open to your keen harvesting skills.','',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(86011,'','I can\'t believe Baros is gone... If you will excuse me commander I really need to focus on my work right now.',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(86012,'','Poor Thorn, she\'s so heartbroken. I don\'t think she will ever leave her worgen form again.',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(86013,'Many leagues of deadly land yet stand between us and the Blackrock.','',0,0,0,0,0,0,0,0,4,0,44837,0,26124),
(86014,'Gorgrond is no place for armies. This land swallows all who enter. We will be fortunate to even lay eyes upon the Iron Horde base.','',0,0,0,0,0,0,0,0,0,0,44838,0,26124),
(86015,'','We should have brought an army to fight the Iron Horde!',0,0,0,0,0,0,0,0,4,0,0,45564,26124),
(86016,'','Life is short, commander. It is important to seize the moment.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86017,'','Baros was such a sweet man.$b$bIf only I would have paid more attention to him when he was alive. I\'ll never forgive myself for letting him slip through my fingers.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86018,'','How can I help you, commander?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86019,'','Ha! Your size makes you weak, giant.',0,0,0,0,0,0,0,0,7,0,0,41799,26124),
(86020,'Tell me, commander, what do you think of Lieutenant Thorn? Whenever she\'s around, I get so flustered.$b$bI\'m just... not really good with women. Which she is an exceptional example of. A woman, that is. Although she is also a worgen. Which I also like. Oh, that long, silky fur...$B$BSigh...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86021,'','Commander, I was just wondering. Has Baros mentioned me by any chance? What? Oh... no reason.$b$b<Thorn blushes>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86022,'Logging is just a hobby. My true calling is singing and dancing. Me and my group, \'N Swing, are going to be rich and famous some day.','',1,273,0,0,0,0,0,0,0,0,0,0,26124),
(86023,'There\'s timber all across this world, commander, but I would recommend that you start your search in Gorgrond.$B$BIf you\'re a risk taker you can try Shadowmoon Valley, but I hear the Alliance controls that region. You might run into some trouble if you\'re not careful.$B$BFrostfire isn\'t so great for trees, but if you\'re desperate you can look around. You might find a few small timber.','',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(86024,'There\'s timber all across this world, commander, but I would recommend that you start your search in Shadowmoon Valley or Gorgrond.$B$BIf you\'re a risk taker you can try Frostfire Ridge, but I hear the Horde controls that region. You might run into some trouble if you\'re not careful.','',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(86025,'Fury of Earth, grant these heroes your protection!','',0,0,0,0,0,0,0,0,0,0,46409,0,26124),
(86026,'Fury of Fire, ignite our fists and weapons!','',0,0,0,0,0,0,0,0,0,0,46410,0,26124),
(86027,'Fury of Wind, honor these soldiers with your presence!','',0,0,0,0,0,0,0,0,0,0,46411,0,26124),
(86028,'Fury of Water, heal our injured!','',0,0,0,0,0,0,0,0,0,0,46412,0,26124),
(86029,'I thought I was done for. Thank you, hero.','I thought I was done for. Thank you, hero.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86030,'The mist took me by surprise. Thank you for helping me.','The mist took me by surprise. Thank you for helping me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86031,'Thank you, stranger. What brought this mist upon us so suddenly?','Thank you, stranger. What brought this mist upon us so suddenly?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86032,'My gratitude to you, hero. I thought my fate was surely sealed.','My gratitude to you, hero. I thought my fate was surely sealed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86033,'Bless you, stranger. I can find my way back from here.','Bless you, stranger. I can find my way back from here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86034,'The creatures native to this swamp seem unaffected by the poison mist.$B$BThere must be something about the clackers and crabs that make them especially resilient to this strange phenomenon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86035,'Luckily, we\'ve discovered that the native mushroom species have immense restorative properties.$B$BWhile we search for the cause of the mist, we have been eating the mushrooms to recover our strength and combat the poison.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86036,'We currently have $9311w collected. We need $9707w total.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86037,'We have activated the |c00FFFF00|Hspell:178538|h[Mage Portal]|h|r! Good work!','',0,0,0,0,0,0,0,0,0,36470,8173,0,26124),
(86038,'The Axe of Serathil compels you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86039,'The Mage Portal has been destroyed by the Horde!','',0,0,0,0,0,0,0,0,0,36470,8213,0,26124),
(86040,'Ha! Now I fight... you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86041,'I am sorry! The axe whispers and I must obey!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86042,'The |c00FFFF00|Hspell:178537|h[Knight Riders]|h|r are out for duty!','',0,0,0,0,0,0,0,0,0,36470,8173,0,26124),
(86043,'The |c00FFFF00|Hspell:178537|h[Knight Riders]|h|r have been slain by the Horde!','',0,0,0,0,0,0,0,0,0,36470,8213,0,26124),
(86044,'My mind is not my own! Serathil!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86045,'','So how many Alliance have you slain today, $n?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86046,'','Tag you\'re it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86047,'','Foolish little rodent, you are too late! The Heart of Gorgorek is mine.',0,0,0,0,0,0,0,0,0,0,0,46339,26124),
(86048,'','Unfortunately for you, my blade hungers.',0,0,0,0,0,0,0,0,0,0,0,46340,26124),
(86049,'','Race you around!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86050,'','Warlord, we have it under control.',0,0,0,0,0,0,0,0,0,0,0,42893,26124),
(86051,'Race you back!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86052,'I win!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86053,'','It... is free. Warlord, we have failed...',0,0,0,0,0,0,0,0,0,0,0,42894,26124),
(86054,'','Hey, no fair.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86055,'','I don\'t have time for this. Your end is near, hero. The next time we meet, be prepared for death.',0,0,0,0,0,0,0,0,0,0,0,46341,26124),
(86056,'1, 2, 3...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86057,'Twenty! Ready or not, here I come!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86058,'Found you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86059,'','No peeking.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86060,'','Race you back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86061,'','Syd, Brae!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86062,'','Now, I want you to come home before dark.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86063,'','And you stay out of trouble!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86064,'','Bye Mom.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86065,'Yes, mom.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86066,'Caught anything?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86067,'Any bites?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86068,'So, still...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86069,'Maybe we should move on?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86070,'Nah.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86071,'Same answer as the last two times.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86072,'The Matriarch is safe. You have proven to be a worthy ally; I look forward to fighting alongside you again.','',0,0,0,0,0,0,0,0,0,25298,0,0,26124),
(86073,'Haha...haha... AHHAHAHAHA! Didn\'t anyone ever tell you not to play with fire?','',0,0,0,0,0,0,153,0,0,0,45471,0,26124),
(86074,'They took Corporal Thukmar!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(86080,'The skies are not out of reach. No, not out of reach.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(86081,'The dusk will rise to the stars.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(86082,'My muzzle\'s never missed its mark! The prize is as good as mine!','My muzzle\'s never missed its mark! The prize is as good as mine!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86083,'Holy light, did ya hafta get the worst-smelling one of the bunch?','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(86084,'Aw, ain\'t his fault he\'s stinky, is it fella?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(86085,'Tommy Joe, last time you took a bath \nwas before the Cataclysm.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86086,'Even in the light, there is shadow.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(86087,'Caught yerself a fiesty one here, Commander!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(86088,'Look at him go!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(86089,'Oh... So close that time!','Oh... So close that time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86090,'Guess you can\'t make milk without breakin\' a few eggs!','',0,0,0,0,0,0,574,0,0,0,0,0,26124),
(86091,'I wonder how the other competitors are doing.','I wonder how the other competitors are doing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86092,'Folks back at the garrison will appreciate this one.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(86093,'I wanna eat it already, how about just a little bite?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(86094,'Another shot, another miss.','Another shot, another miss.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86095,'Tommy Joe, last time you tried that you ended up with a bad case of broken face.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(86096,'I should really work on my aim if I expect to win the competition!','I should really work on my aim if I expect to win the competition!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86097,'Ya know, haulin\' these things back ain\'t a walk in the park.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(86098,'A wolf nearly ate my foot!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(86099,'Back in my day, wolves would eat both of our feet, both ways to and from Ironforge, in the snow.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86100,'This one\'s even bigger than the last one!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(86101,'Bigger\'n three cows tied together!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(86102,'Yep, sure bigger\'n... wait, what?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(86103,'Come take a look at my newest goods!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86104,'Come try out the best tools in Draenor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86105,'Rare items from the fabled Azeroth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86106,'Someday, I will have a greenhouse of my own.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86107,'Just two more years, then I can branch out on my own.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86108,'I am glad Jayciel made it out of Karabor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86109,'Can I get another Moonshell Claw Bait?','Can I get another Moonshell Claw Bait?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(86110,'Tomen? Are you in there?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86111,'Who\'s that hollering?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86112,'Berethal? It has been a long time. What brings you back here?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86113,'I heard about the attacks and came out to help.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86114,'Well it is good to see you. What can I get you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86115,'Just two packages for now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86116,'You think yourself a worthy vessel for my power? Prove it!','',0,0,0,0,0,0,5,0,0,0,46472,0,26124),
(86117,'Impressive...','',0,0,0,0,0,0,0,0,0,0,46473,0,26124),
(86118,'','I\'ve been waiting for you. I\'m going to have to cut you now -- and it\'s going to burn.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86119,'Fool, you challenge me? I will boil your insides.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86120,'So you are the one Azuka spoke of. So puny, I thought this would be a challenge.  Prepare to die.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86121,'Long have my people suffered the Curse of Sethe, and long have we sought a cure.','',0,0,0,0,0,0,1,0,0,0,46453,0,26124),
(86122,'','Some sort of veil has descended on this outpost. We need to find the cause.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86123,'Let\'s do some investigating.','Let\'s do some investigating.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86124,'Begin your spell.  I\'ll protect you!','Begin your spell.  I\'ll protect you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86125,'','So be it. Katsuo, show this \'gladiator\' the might of the Burning Blade.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(86126,'The chest is empty, the heart has been stolen.','The chest is empty, the heart has been stolen.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86127,'','You are fortunate. The honor of the arena stays my hand.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(86128,'Sorceries, rituals and rites. Unspeakable acts of darkness and desperation, all for naught.','',0,0,0,0,0,0,1,0,0,0,46454,0,26124),
(86129,'','Who dares to challenge my clan?',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(86130,'We now must face the Iron Horde fleet. They have a powerful weapon aboard a battleship just off the coast. I know a spell that can clear the way, but it will take all my focus to channel it. During my incantation, I will be vulnerable. It will be up to you and our allies to protect me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86131,'Continue your search for Azuka Bladefury.','Continue your search for Azuka Bladefury.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86132,'We found refuge in the shadows, yes, but also shame. We lost our way.','',0,0,0,0,0,0,1,0,0,0,46455,0,26124),
(86133,'','Impossible! Insolent whelp. You dare spit in the face of my clan\'s honor?',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(86134,'','This just became personal. Let me see how you fight firsthand.',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(86135,'I led my people astray. You would have been fair to shun them as others do.','',0,0,0,0,0,0,0,0,0,0,46456,0,26124),
(86136,'And yet, you showed them kindness. Curious.','',0,0,0,0,0,0,0,0,0,0,46457,0,26124),
(86137,'Did we import roses from Azeroth to the garrison farm? I don\'t remember.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86138,'','I\'ll set up a patrol. We need to know if any more members of the Burning Blade have infiltrated the garrison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86139,'','Baros, you fool... you should have told me you loved me sooner. It didn\'t have to end like this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86140,'','This is not over. The Iron Horde... will... pay.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86141,'','These mists are quite dangerous. I will try to keep you safe, but use the mushrooms to heal yourself.',0,0,0,0,0,0,0,0,0,0,0,45541,26124),
(86142,'','There! That creature must be the cause of the poisonous mist!',0,0,0,0,0,0,0,0,0,0,0,45542,26124),
(86143,'','Excellent teamwork, hero! We have cured the swamp of its curse. I will go on ahead, so meet me when you are done here.',0,0,0,0,0,0,0,0,0,0,0,45543,26124),
(86144,'I have half a dozen rangari unaccounted for. Please find them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86145,'Thank you for helping my people, friend. I will be sure to send word of your kindness to Exarch Naielle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86146,'Mr. Jones! Is that you?','Mr. Jones! Is that you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86147,'You gave them strength. Though the curse may forever weigh upon their bones, I see them standing tall and proud.','',0,0,0,0,0,0,0,0,0,0,46458,0,26124),
(86148,'You have succeeded where I failed. You have set my people free.','',0,0,0,0,0,0,0,0,0,0,46459,0,26124),
(86149,'Truly, you are their Talon King.','',0,0,0,0,0,0,0,0,0,0,46461,0,26124),
(86150,'Truly, you are their Talon Queen.','',0,0,0,0,0,0,0,0,0,0,46460,0,26124),
(86151,'Reporting in!','Reporting in!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86152,'You\'re to show me Ashran?','You\'re to show me Ashran?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86153,'Xeri\'tac descends from her web!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86154,'|TInterface\\Icons\\Ability_Racial_Cannibalize.blp:20|tXeri\'tac starts to |cFFFF0000|Hspell:169248|h[Consume]|h|r a Pale Orc!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86155,'|TInterface\\Icons\\spell_festergutgas.blp:20|tA Pale Orc has |cFFFF0000|Hspell:169233|h[Inhaled]|h|r Toxic Gas! Their power will increase the longer they are alive.','|TInterface\\Icons\\spell_festergutgas.blp:20|tA Pale Orc has |cFFFF0000|Hspell:169233|h[Inhaled]|h|r Toxic Gas! Their power will increase the longer they are alive.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86156,'So. Thirsty.','',0,0,0,0,0,0,0,0,0,0,45108,0,26124),
(86157,'Returned to the earth.','',0,0,0,0,0,0,0,0,0,0,45110,0,26124),
(86158,'Feed my roots.','',0,0,0,0,0,0,0,0,0,0,45111,0,26124),
(86159,'No!','',0,0,0,0,0,0,0,0,0,0,45109,0,26124),
(86160,'I. Cannot. Be. Stopped.','',0,0,0,0,0,0,0,0,0,0,45113,0,26124),
(86161,'Refreshed.','',0,0,0,0,0,0,0,0,0,0,45112,0,26124),
(86163,'+$i Points from $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86164,'Come, he has not yet reached his full strength.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86165,'I will handle Sethe, you take care of the cultists!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86166,'Behold, my rebirth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86167,'My blood will blacken the seas!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86168,'My flesh shall fester until the very sky rots with it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86169,'My hatred is... undying...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86170,'*sneeze* There\'s something in the air...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86171,'Through this rocky ground? Impossible. Sound the alarm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86172,'To arms! To your posts! And be wary of new wild growth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86173,'Sergeant, strange plants are growing inside the garrison.','Sergeant, strange plants are growing inside the garrison.',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(86174,'Apexis crystals are common among the most dangerous parts of Draenor. You will find them immensely useful as you augment your equipment.','',0,0,0,0,0,0,1,0,0,0,44939,0,26124),
(86175,'We\'ll cart this sucker back to base immediately, commander!','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(86176,'I think this is the beginning of a very powerful partnership, my friend. Good luck.','',0,0,0,0,0,0,1,0,0,0,44926,0,26124),
(86177,'I brought my favorite rope!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(86178,'Oh no, not Clyde.','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(86179,'Interestin\' markings on this little guy.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86180,'Aww, look at his little tuft of fur!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(86181,'Now don\'t be touchin\' that, Tommy Joe.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86182,'','Be careful, champion.',1,0,0,0,0,0,1,0,0,0,0,44150,26124),
(86183,'You create a diversion to the west while I move the rest of us south.','',397,0,0,0,0,0,0,0,0,0,0,0,26124),
(86184,'Yrel, Maraad, and Duotan need your help on the flagship.  Blackhand will not go down without a fight.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86185,'Who dare challenge Lug\'dol?','',0,0,0,0,0,0,0,0,0,27766,0,0,26124),
(86186,'I snap da neck of anyone who challenge me!','',0,0,0,0,0,0,0,0,0,27766,0,0,26124),
(86187,'Nobody can beat Lug\'dol. Lug\'dol da best!','',0,0,0,0,0,0,0,0,0,27766,0,0,26124),
(86188,'Nobody left to fight. Lug\'dol sad.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86189,'I\'m in da running to be da next blood champion. You dead!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86190,'I\'m gonna be da next blood champion. You die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86191,'Your head will be my good luck charm to be the next blood champion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86192,'You just another kill towards me becoming da blood champion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86193,'I... lose?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86194,'','We have activated the |c00FFFF00|Hspell:178539|h[Mage Portal]|h|r!',0,0,0,0,0,0,0,0,0,36471,0,8213,26124),
(86195,'It no end like dis...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86196,'But you so small...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86197,'','The |c00FFFF00|Hspell:178539|h[Mage Portal]|h|r has been destroyed by the Alliance!',0,0,0,0,0,0,0,0,0,36471,0,8173,26124),
(86198,'Lug\'dol... finished.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86199,'Enough of dis. Lug\'dol SMASH!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86200,'The |c00FFFF00|Hspell:178536|h[Wolf Riders]|h|r are out for duty!','',0,0,0,0,0,0,0,0,0,36471,8213,0,26124),
(86201,'The |c00FFFF00|Hspell:178536|h[Wolf Riders]|h|r have been slain by the Alliance!','',0,0,0,0,0,0,0,0,0,36471,8173,0,26124),
(86202,'The |c00FFFF00|Hspell:178534|h[Warlock Gateway]|h|r has been activated! Check your map for the locations.','',0,0,0,0,0,0,0,0,0,36471,8213,0,26124),
(86203,'The |c00FFFF00|Hspell:178534|h[Warlock Gateway]|h|r has been destroyed by the Alliance!','',0,0,0,0,0,0,0,0,0,36471,8173,0,26124),
(86204,'|c00FFFF00|Hspell:178359|h[Kronus]|h|r has arisen!','',0,0,0,0,0,0,0,0,0,36471,8213,0,26124),
(86205,'You fools! The Alliance has killed |c00FFFF00|Hspell:178359|h[Kronus]|h|r!','',0,0,0,0,0,0,0,0,0,36471,8173,0,26124),
(86206,'We\'ve managed to contain this building. You should be safe from the mist in here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86207,'The mine entrance is boarded up while work goes on inside.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86208,'','We shall fight it, together.',0,0,0,0,0,0,0,0,0,0,0,44745,26124),
(86209,'','Your size works against you!',0,0,0,0,0,0,0,0,0,0,0,44746,26124),
(86210,'','I remember your true face.',0,0,0,0,0,0,0,0,0,0,0,46173,26124),
(86211,'','Yes! Burn it... sister.',0,0,0,0,0,0,0,0,0,0,0,46174,26124),
(86212,'','For the light!',0,0,0,0,0,0,0,0,4,0,0,45566,26124),
(86213,'','We do not fear you!',0,0,0,0,0,0,0,0,0,0,0,45567,26124),
(86214,'','Be at peace.',0,0,0,0,0,0,0,0,0,0,0,46543,26124),
(86215,'Oh yeah, this conversation never happened. Gotta be an unbiased promoter and all.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(86216,'','Watch your flank, sister.',0,0,0,0,0,0,0,0,0,0,0,46544,26124),
(86217,'Coming right up.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86218,'This is the life. I missed good old Nagrand.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86219,'These will work great. Thank you Tomen, I hope to get back to them soon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86220,'See you at the ring, champ.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(86221,'Here you go. I hope you can get back to your family in Shattrath soon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86222,'Our campaign is gaining momentum. Both the Alliance and Horde have established garrisons on the mainland. But we must be wary of counter-attacks...','',1,274,0,0,0,0,0,0,0,0,0,0,26124),
(86223,'I\'m ready. Start casting!','I\'m ready. Start casting!',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(86224,'Invasive Thornblooms Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86225,'Ravager Wasps Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86226,'Podlings Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86227,'Plant Hydras Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86228,'Lashers Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86229,'Gnarled Ancient Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86230,'Botanis Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86231,'Ancients Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86232,'','I can\'t wait to explore Draenor Percy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86233,'Roadblock removed!','Roadblock removed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86234,'','Ooh, another trick!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86235,'','That was great!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86236,'','So what is he?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86237,'','Bark* Bark*',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86238,'','Percy is a pug.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86239,'','A... what?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86240,'','Hmm.. well, a pug is a type of dog we have on Azeroth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86241,'','It\'s a shame what happened to his face.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86243,'','Ruff*!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86244,'','I am Magister Serena. Nice to meet you!',0,0,0,0,0,0,1,0,0,0,0,44040,26124),
(86245,'Commander, our aerial squadron has weakened the magnaron, but we\'re pinned out here. We need your help to assault the main compound.','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(86246,'I don\'t like da look a\' dis ting, hero.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(86247,'Is this him?','',0,0,0,0,0,0,6,0,0,0,44971,0,26124),
(86248,'Betrayed by Garrosh the moment they arrived on Draenor.','',0,0,0,0,0,0,1,0,0,0,44972,0,26124),
(86249,'','It is. The final resting place of Kairozdormu.',0,0,0,0,0,0,1,0,0,0,0,43846,26124),
(86250,'','Ah, welcome, Vindicator Yrel. I see you have come for Maladaar\'s trial.',0,0,0,0,0,0,1,0,4,0,0,44668,26124),
(86251,'','The spirits sense your purpose. They already grow eager to challenge you.',0,0,0,0,0,0,1,0,4,0,0,44669,26124),
(86252,'','It is my honor to face the heroes of the ancient past. They will not find me lacking.',0,0,0,0,0,0,1,0,4,0,0,45529,26124),
(86253,'','Good luck, Lady Yrel.',0,0,0,0,0,0,1,0,4,0,0,44670,26124),
(86254,'Yrel, this is how I always wished to see you. Do not let me down.','',0,0,0,0,0,0,0,0,4,0,46765,0,26124),
(86255,'','Greetings, teacher. Let me show you what I have learned in my travels.',0,0,0,0,0,0,0,0,4,0,0,45530,26124),
(86256,'You have exceeded all my hopes, Yrel. You may proceed.','',0,0,0,0,0,0,0,0,4,0,46766,0,26124),
(86257,'','Now, to lay Maraad\'s ashes to rest.',0,0,0,0,0,0,0,0,4,0,0,45531,26124),
(86258,'Yrel... how you have grown since last we met. But... is it enough? Are you worthy of leading our people?','',0,0,0,0,0,0,0,0,4,0,44826,0,26124),
(86259,'Now, it is my turn to test your strength.','',0,0,0,0,0,0,0,0,4,0,44827,0,26124),
(86260,'When you face a more powerful foe, will you stand strong?','',0,0,0,0,0,0,0,0,4,0,44828,0,26124),
(86261,'','Do not fear, for I will stand!',0,0,0,0,0,0,0,0,4,0,0,45532,26124),
(86262,'When our people look to you, will you be ready to command?','',0,0,0,0,0,0,0,0,4,0,44829,0,26124),
(86263,'','I shall not let them down!',0,0,0,0,0,0,0,0,4,0,0,45533,26124),
(86264,'When all hope is lost, will you... still... fight?','',0,0,0,0,0,0,0,0,4,0,44830,0,26124),
(86265,'','I shall never yield!',0,0,0,0,0,0,0,0,4,0,0,45534,26124),
(86266,'','I... can...',0,0,0,0,0,0,0,0,4,0,0,45535,26124),
(86267,'When you look inside yourself and see only darkness, can you still find the Light?','',0,0,0,0,0,0,0,0,4,0,44831,0,26124),
(86268,'What was that?','',0,0,0,0,0,0,0,0,4,0,44832,0,26124),
(86269,'','Because... in this world... we are never...',0,0,0,0,0,0,0,0,4,0,0,45536,26124),
(86270,'','Hero! Use the hammer, now!',0,0,0,0,0,0,0,0,4,0,0,45538,26124),
(86271,'Yrel... it is true. The student has surpassed the teacher. You are ready.','',0,0,0,0,0,0,0,0,4,0,44833,0,26124),
(86272,'If only Prophet Velen could see you now... he would be proud.','',0,0,0,0,0,0,0,0,4,0,44834,0,26124),
(86273,'Rise, Yrel. It is your charge to unite the draenei. Prepare them for what\'s to come.','',0,0,0,0,0,0,0,0,4,0,44835,0,26124),
(86274,'Farewell...','',0,0,0,0,0,0,0,0,4,0,44836,0,26124),
(86275,'','Maraad, my friend... be at peace.',0,0,0,0,0,0,0,0,4,0,0,45539,26124),
(86276,'','Thank you, hero. I will meet up with you later. I just need a moment to pay my respects to the ancestors.',0,0,0,0,0,0,0,0,4,0,0,45540,26124),
(86277,'One final trial awaits, Yrel. US!','',0,0,0,0,0,0,0,0,4,0,44621,0,26124),
(86278,'You have chosen your champion. Now, let us begin!','',0,0,0,0,0,0,0,0,4,0,44622,0,26124),
(86279,'Ahh, I am defeated.','',0,0,0,0,0,0,0,0,4,0,46741,0,26124),
(86280,'','Such strength!',0,0,0,0,0,0,0,0,4,0,0,45897,26124),
(86281,'I submit!','',0,0,0,0,0,0,0,0,4,0,44623,0,26124),
(86282,'Yrel, today, you have completed the trials of the exarch.','',0,0,0,0,0,0,0,0,4,0,44625,0,26124),
(86283,'You have proven courage, kindness, faith, and strength... pillars upon which our society has arisen.','',0,0,0,0,0,0,0,0,4,0,44626,0,26124),
(86284,'However, we measure a leader not only by her merit, but also by the character of her companions.','',0,0,0,0,0,0,0,0,4,0,44627,0,26124),
(86285,'Champion, we have watched you throughout this trial.','',0,0,0,0,0,0,0,0,4,0,44628,0,26124),
(86286,'We saw your bravery in Frostfire, your persistence in Nagrand, and your loyalty in Auchindoun.','',0,0,0,0,0,0,0,0,4,0,44629,0,26124),
(86287,'Your dedication to Lady Yrel proves to us that she is worthy. We did not choose the next Exarch. YOU did.','',0,0,0,0,0,0,0,0,4,0,44630,0,26124),
(86288,'Yrel, do not forget that an exceptional leader inspires greatness in others. Trust in your people, and trust in yourself.','',0,0,0,0,0,0,0,0,4,0,44631,0,26124),
(86289,'Now, RISE...','',0,0,0,0,0,0,0,0,4,0,44632,0,26124),
(86290,'EXARCH YREL!','',0,0,0,0,0,0,0,0,4,0,44633,0,26124),
(86291,'Good luck to you, Yrel. Courage comes from the mind and heart.','',0,0,0,0,0,0,0,0,0,0,46727,0,26124),
(86292,'','Go with my blessing, Yrel. Do not forget those less fortunate.',0,0,0,0,0,0,0,0,0,0,0,45898,26124),
(86293,'Let faith guide you, Yrel.','',0,0,0,0,0,0,0,0,0,0,44624,0,26124),
(86294,'','Gaze upon the source of your demise, heroes.',0,0,0,0,0,0,396,0,4,0,0,46342,26124),
(86295,'','This magnaron walked Draenor before the first orc took breath.  And now it bends to my will.',0,0,0,0,0,0,396,0,4,0,0,46343,26124),
(86296,'','It will crush your armies and your pitiful fortress.  But first, it will crush YOU!',0,0,0,0,0,0,396,0,4,0,0,46344,26124),
(86297,'The beast is defeated, but we cannot rest yet. One enemy still remains.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(86298,'I am needed near the gates. Warchief Hellscream has been spotted on the battlefield.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(86299,'Find Bladefury. Bring me her head!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(86300,'Taz\'dingo! Well fought, mon. But we ain\'t leavin\' until da she-orc be dead.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(86301,'I be needed near da main gate. Dey say Grommash has joined da battle.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(86302,'Take care a  Bladefury. Bring me her head!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(86303,'','I grow tired of our games, little mouse. It\'s time to finish this.',0,0,0,0,0,0,396,0,4,0,0,46345,26124),
(86304,'','My blade thirsts for your blood!',0,0,0,0,0,0,603,0,4,0,0,46346,26124),
(86305,'','No... noooo... Warchief... I have... failed you...',0,0,0,0,0,0,0,0,4,0,0,46347,26124),
(86306,'','Halt! Hellscream approaches.',0,0,0,0,0,0,396,0,4,0,0,45525,26124),
(86307,'Look! Hellscream shows himself.','',0,0,0,0,0,0,396,0,4,0,48916,0,26124),
(86308,'','The battle is finished! We\'ve routed the Iron Horde and pushed them back to the gates!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(86309,'The Iron Horde is never beaten! I will NEVER surrender!','',0,0,0,0,0,0,0,0,4,0,46500,0,26124),
(86310,'I will remember this day, heroes. I will remember your names and your faces, and when the time comes, I will carve you limb from limb.','',0,0,0,0,0,0,0,0,4,0,46501,0,26124),
(86311,'+$1i score','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86312,'|cFFFF0000+$1i score|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86313,'|cFF0000FF-1 reinforcement|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86314,'|cFFFF0000-1 reinforcement|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86315,'You want to fight, hmm? How tough are you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86316,'Never before have the spirits spoken with such strength to me.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(86317,'Dis one time, I killed two clefthoof at once with bare hands!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(86318,'','Sorry for all the times you\'re about to get killed. If it\'s any consolation, you won\'t remember any of them.',0,0,0,0,0,0,1,0,0,0,0,43847,26124),
(86319,'Deez Ashmaul dunt break my Boulder Shield so dey threw me in dis cage... Now dat I\'m free I dun need it no more, you have it $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86320,'Hah! You nowhere near tough enough.','',0,0,0,0,0,0,11,0,0,0,0,0,26124),
(86321,'Draenor is not without its own primal beauty.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(86322,'The three of us all bring different talents to the table. Chromie can manipulate time to heal our wounds, and I am capable of bearing the brunt of the dragon\'s attacks. All of us are worthy fighters.$b$bBut YOU are the tactical expert. We\'ll follow your lead. In what role are you strongest? Say the word and we\'ll begin!','',1,6,0,0,0,0,0,0,0,0,0,0,26124),
(86323,'I\'ll deal out the damage.','I\'ll deal out the damage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86324,'I\'ll heal us.','I\'ll heal us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86325,'I\'ll defend us.','I\'ll defend us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86326,'Attacking Vines Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86327,'Mutated Defenders Killed: $1i (+$2i)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86328,'Don\'t yell at your students; Instead, speak very softly but firmly when disciplining them.  It forces them to listen more carefully and frankly it\'s a lot scarier than yelling.','',274,1,0,0,0,0,0,0,0,0,0,0,26124),
(86329,'Few truly understand how fragile the fabric of this world is.$b$bWhy, a poorly designed spell could bring our entire reality to a screeching halt.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(86330,'Firebolts, ice blocks, arcane blasts, all of these are simple manifestations of arcana.$b$bThey are safe spells, proven time and again to be both stable and effective.$b$bNow, if you really want to blow up the universe, well... some things are best kept for the advanced class.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(86331,'Before one can truly understand the artistry of weaving a spell, one must first ask themselves how many bunnies can you see?$b$bWhen you understand the meaning of this question, the foundation of the universe will become more clear.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(86332,'If your spell fails to land, make sure the arcana you are trying to wield has enough power to manifest at its destination.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(86333,'This week we are discussing ley lines... again. Their practicality when it comes to magical understanding cannot be understated.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(86334,'Never underestimate the ingenuity and mischief that can be caused by a child who has mastered Invsibility.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(86335,'LUG\'DOL! What dis little thing do to you?!','',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(86336,'','Grom\'kar archers, fire at will!',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(86338,'My wings were taken from me once. You will not take them again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86339,'Well done, $n. Allow me to return you safely to the surface.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86340,'It cannot be! My wings have failed me once again...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86341,'Excellent, more raw materials!','',0,0,0,0,0,0,0,0,0,0,46185,0,26124),
(86342,'Think you got what it takes, $n? Remember, once a battle starts you have to stay in the arena. It\'s life or death!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(86343,'Step right up, ladies and gentle-ogres. Witness utter carnage and devastation in the one and only Ring of Blood! In this once in a lifetime battle for the coveted Blood Champion title we have $n from parts unknown versus Katsuo of the Burning Blade!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(86344,'Let the Blood Champion title fight BEGIN!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(86345,'Not even close, baby! What a slaughter!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(86346,'Finish him! Oh, wait, you did. All over the arena floor, too. We need a cleanup over here!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(86347,'Oh, for the love of... I just had this place cleaned! Can you kill a little bit neater next time?','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(86348,'What a one-sided fight! Absolutely unfair. Not even remotely close!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(86349,'Wodin, toss me the scraper. It\'s a mess down here!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(86350,'Right in the face! I could feel that one from here!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(86351,'Going... going... dead! Definitely dead. Oh, the humanity!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(86352,'That\'s one to tell the kids about, folks. I haven\'t seen carnage like that in years!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(86353,'Azuka Bladefury emerges from the shadows!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(86354,'We\'ll find that dragon, dead or alive!','',0,0,0,0,0,0,5,0,0,0,44966,0,26124),
(86355,'','Incredible work. The archmage would be lost without you!',1,0,0,0,0,0,1,0,0,0,0,44155,26124),
(86356,'Got a bit tired of Elwynn after so many years, and figured we should come on out and do our part.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86357,'Sure is awful quiet out here at night, makes me miss the sounds of Goldshire in the distance.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86358,'You ever seen one of those rylaks? Kinda wonder how one of them would taste.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86359,'Sure wish we didn\'t have to live in this barn, not sure I\'ll ever get the smell out of my clothes.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86360,'Ma does the grillin\' around here. She can cook you up a mean flank!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86361,'Bein\' out here with so many different types makes me wonder if those Maclures are really so bad after all.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86362,'Can you tell me about trapping beasts?','Can you tell me about trapping beasts?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86363,'What\'s new with the improved iron trap?','What\'s new with the improved iron trap?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86364,'What about the deadly iron trap?','What about the deadly iron trap?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86365,'What can I do with meat obtained from trapping?','What can I do with meat obtained from trapping?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86366,'Well, you just pick up one of these traps I\'ve got right beside me here. Then, head on out to and find yourself a beast. You\'re looking for talbuk and elekk, but wolves and clefthooves can do in a pinch.$B$BAll you got to do is give the beast of your choice a whallop until it ain\'t got much fight left in it, then lead it into the trap. Be careful now, that trap can snap shut on your feet, too!$B$BBring the trap back to us, and we can turn it into materials. The type of creature you trap will determine what all we can get out of it: clefthooves and elekk produce the best leathers, while talbuks and wolves have the most fur.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86367,'This trap\'s a sure sight more resilient than the last one. With the improved iron trap, you\'ll be able to take down boars and riverbeasts.$B$BBring us back a boar or riverbeast and ma back there will cook you up some of the tastiest grilled meat you\'ve ever had!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86368,'This is the biggest, iron-est trap we could create, and it\'ll allow you to take down the largest beasts this world has to offer. Out in Nagrand you\'ll find the most powerful critters around. Trapping one of them will net you tons of the best materials!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86369,'Take it on over to Ma back there, she\'ll grill you up a mean steak.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86370,'Win or die, mon! Win or die! You can\'t be fleein\'!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(86372,'You looking for a fight, champ?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(86373,'The entrance to the main vestibule opens!','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(86374,'The barrier behind Exarch Hataaru slides open!','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(86375,'','I was so angry when you didn\'t return. I couldn\'t understand why you had to leave.',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(86376,'I know, Kugra... but, I had to support our forces.','',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(86377,'The teleporter to the central platform is now active!','',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(86378,'','I didn\'t understand why you had to go.',1,0,0,0,0,0,6,0,0,0,0,0,26124),
(86379,'I know, Kugra... but, I wanted to help put an end to this miserable conflict.','',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(86380,'The Thunderlords spared my life, but they forced me to work... forging weapons to be used against our own.','',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(86381,'','Why didn\'t you try to flee!?',5,0,0,0,0,0,603,0,0,0,0,0,26124),
(86382,'I tried, Kugra! They hunted me... tortured me....','',18,0,0,0,0,0,18,0,0,0,0,0,26124),
(86383,'Kugra, you owe me no apologies! But now, I must ask that you continue my work here.','',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(86384,'The Thunderlords wanted me to forge weapons to be used against our brothers and sisters.','',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(86385,'Some assistant you are. You need to learn to keep better tabs on your employees.','',588,0,0,0,0,0,0,0,0,0,0,0,26124),
(86386,'','I... I had no idea. I am so sorry that I let my anger consume me, father.',18,0,0,0,0,0,18,0,0,0,0,0,26124),
(86387,'Sorry, boss.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86388,'Kugra, you owe me no apologies! Please, honor me by taking up my hammer and continuing to fight!','',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(86389,'See what happens? Now your assistant is all burned up and dead. How does that make you feel?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(86390,'Not good...','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(86391,'I owe my allegiance to $n now. I will accompany $Ghim:her; on $Ghis:her; mission to confront this new Iron Horde threat.','',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(86392,'','Father, I swear to make you proud!',603,0,0,0,0,0,603,0,0,0,0,0,26124),
(86393,'I\'d sure hate to be on the end of one of those Burning Blade swords. Talk about painful.','',588,0,0,0,0,0,0,0,0,0,0,0,26124),
(86394,'You already have, Kugra, you already have....','',579,0,0,0,0,0,579,0,0,0,0,0,26124),
(86395,'A $c? Oh, are you a sight for sore eyes.$b$bWe didn\'t expect to hit anything when digging through the ground like we were.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86396,'My poor assistant...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86397,'','Thank you, $n. If you are ever in need of aid, please come back and see me.',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(86398,'|TInterface\\Icons\\warrior_disruptingshout.blp:20|t %s begins to cast |cFFFF0000|Hspell:169498|h[Deafening Shout]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(86399,'I\'m ready to fight in the Blood Championship.','I\'m ready to fight in the Blood Championship.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86400,'','I am so sorry that I let my anger consume me father.',18,0,0,0,0,0,18,0,0,0,0,0,26124),
(86401,'Alright, alright, move along. No shame in not fightin\'. NEXT!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(86402,'Looks like we have a no-show folks. Bring out the next fight!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(86403,'Time\'s up, and time is money. Let\'s get movin\'!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(86404,'Where\'s the action at? I\'m falling asleep over here! Next!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(86405,'Clear out, clear out. We have a tight schedule, folks.','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(86406,'I can\'t blame ya pal, you\'d probably be dead by now if you\'d gone through with it.','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(86407,'What kind of mom and pop show is this? Get someone in that ring!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(86408,'Are we fightin\' hard or hardly fightin\' in this joint? Put some feeling into it, people!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(86409,'I\'m ready for the Trial of Faith.','I\'m ready for the Trial of Faith.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86410,'','I want to see how you fight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86411,'','Coward.',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(86412,'|TInterface\\Icons\\achievement_halloween_rottenegg_01.blp:20|tXeri\'tac begins unleashing Toxic Spiderlings down on you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86413,'Do you have your ring with you? Good! Are you ready?$b$bHold on to your helm, $c!','',6,5,0,0,0,0,0,0,0,0,0,0,26124),
(86414,'I am ready, Archmage.','I am ready, Archmage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86415,'I will head to your garrison now, $n.','',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(86416,'','Enough! Not bad... for a rat that escaped its cage.',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(86417,'','But do you know the power of my blade? The more it kills, the stronger it grows.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(86418,'You\'ll never make it out alive!','You\'ll never make it out alive!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(86419,'%s puts a letter into the mailbox.','%s puts a letter into the mailbox.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86420,'','The portal is lost! We must stop this beast before it can escape!',0,0,0,0,0,0,0,0,0,0,0,44237,26124),
(86421,'','We\'ve got its attention!',0,0,0,0,0,0,0,0,0,0,0,44227,26124),
(86422,'','Look out!',0,0,0,0,0,0,0,0,0,0,0,44230,26124),
(86423,'','Quickly, draw it towards the flames!',0,0,0,0,0,0,0,0,0,0,0,44231,26124),
(86424,'','It\'s reviving the little ones!',0,0,0,0,0,0,0,0,0,0,0,44232,26124),
(86425,'','The vines are overtaking everything!',0,0,0,0,0,0,0,0,0,0,0,44233,26124),
(86426,'','That doesn\'t look good...',0,0,0,0,0,0,0,0,0,0,0,44234,26124),
(86427,'','We are lost! It\'s pushing us back!',0,0,0,0,0,0,0,0,0,0,0,44235,26124),
(86428,'','Do you want to die here?! Move!',0,0,0,0,0,0,0,0,0,0,0,44236,26124),
(86429,'','You\'ve saved us all! Thank you strangers, the city would have been lost without you.',0,0,0,0,0,0,0,0,0,0,0,44228,26124),
(86430,'','I never thought we\'d be saved by the Horde. You should go before the Stormwind guard arrive...',0,0,0,0,0,0,0,0,0,0,0,44229,26124),
(86431,'You will never escape...','',0,0,0,0,0,0,0,0,0,0,46209,0,26124),
(86432,'You befoul this place!','',0,0,0,0,0,0,0,0,0,0,46207,0,26124),
(86433,'You will be purged!','',0,0,0,0,0,0,0,0,0,0,46212,0,26124),
(86434,'The forest shields us.','',0,0,0,0,0,0,0,0,0,0,46213,0,26124),
(86435,'We protect.','',0,0,0,0,0,0,0,0,0,0,46214,0,26124),
(86436,'The cycle continues...','',0,0,0,0,0,0,0,0,0,0,46210,0,26124),
(86437,'Life ends.','',0,0,0,0,0,0,0,0,0,0,46211,0,26124),
(86438,'I will... be... renewed...','',0,0,0,0,0,0,0,0,0,0,46208,0,26124),
(86439,'You are not welcome here!','',0,0,0,0,0,0,0,0,0,0,46133,0,26124),
(86440,'The forest closes in around you.','',0,0,0,0,0,0,0,0,0,0,46135,0,26124),
(86441,'Water brings life!','',0,0,0,0,0,0,0,0,0,0,46138,0,26124),
(86442,'Grow!','',0,0,0,0,0,0,0,0,0,0,46139,0,26124),
(86443,'Life renewed!','',0,0,0,0,0,0,0,0,0,0,46140,0,26124),
(86444,'You were warned!','',0,0,0,0,0,0,0,0,0,0,46136,0,26124),
(86445,'Trespassers beware!','',0,0,0,0,0,0,0,0,0,0,46137,0,26124),
(86446,'I return... to the soil...','',0,0,0,0,0,0,0,0,0,0,46134,0,26124),
(86447,'Delivery of animal skins!','Delivery of animal skins!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86448,'Wait... is that Thaelin\'s tank? The lad made it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86449,'Fly me to Talon Watch.','Fly me to Talon Watch.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86450,'They grow like weeds.','They grow like weeds.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86451,'Reaping crop is peon\'s work.','Reaping crop is peon\'s work.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86452,'Capture and control the bonfires!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86453,'The Alliance controls this fire but another has appeared!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86454,'The Horde controls this fire but another has appeared!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86455,'The Alliance wins!','',0,0,0,0,0,0,0,0,0,0,8455,0,26124),
(86456,'The Horde wins!','',0,0,0,0,0,0,0,0,0,0,8454,0,26124),
(86457,'Slay the invaders and bring me their bodies. We have much work to do.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86458,'Faster. I do not wish to keep the great Iyu waiting.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86459,'Alive or dead, bring these invaders to me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86460,'Uproot this infestation of a camp.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86461,'More fodder for our soil!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86462,'I have known weeds that were more threatening than your kind.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86463,'Your kind will not defy the will of Iyu.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86464,'Over here!','',4,0,0,0,0,0,0,0,0,0,0,0,26124),
(86465,'I will bring glory to your name, warlord!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(86466,'DEFILER! Your lifeblood will nourish the Everbloom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86467,'','ALONE!',0,0,0,0,0,0,0,0,4,0,0,45537,26124),
(86468,'No brawlin\' ahead unless in da ring. Mogor\'s orders.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(86469,'Da ring is just ahead. Don\'t cause no trouble.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(86470,'Mogor says no brawlin\' ahead unless you in da ring.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(86471,'Ready for fightin\', tiny one? Da ring is just ahead.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(86472,'Follow da rules. Only brawl in da ring. Uh... and don\'t brawl not in da ring.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(86473,'Talk to tiny green thing by Mogor if you want to fight.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(86474,'Me crush you if you fight outside da ring. Mogor said so.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(86475,'RAAAAAAAAAAAAAR! Me... uphold order!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(86476,'','Yes, sugar?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86477,'','%s marks the location of the most recent coordinates on her parchment.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86478,'','%s inspects the translocator\'s findings.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86479,'','%s ponders the location of the next transponder unit.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86480,'Cherish this victory, invader. The next time we meet you will suffer!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86481,'I have found you once more, defiler! The wilds will grant you no reprieve!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86482,'Sunderthorn descends from the treetops to protect her hive!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86483,'Your... Your species is superior. I am yours to command.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86484,'Twice you have bested me. You will not win again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86485,'I will journey to your fortress, $g master:mistress;. Once there, all that I know, you will know.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86486,'Anything good?','Anything good?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86487,'I\'ll find the right person for the job.','I\'ll find the right person for the job.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86488,'I\'m looking to recruit someone.','I\'m looking to recruit someone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86489,'|cFF0000FF+$1i slain|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86490,'|cFFFF0000+$1i slain|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86491,'|cFF0000FF+1 points|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86492,'|cFFFF0000+1 points|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86493,'|cFF0000FF+$1i points|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86494,'|cFFFF0000+$1i points|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86495,'Greetings, and thank you for helping to test the Warlords of Draenor Beta! \n\nI can teleport you directly into a number of raid or dungeon instances that are currently open for testing. This is just a teleport, not a match-making service, so I hope you have a party ready to tackle the challenges waiting inside. If not, you might want to check out our new Group Finder feature to find some allies.\n\nMake sure you have selected the difficulty you want to test before teleporting, since you may not be able to zone out easily if you need to change the difficulty setting!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86496,'I want to go to Bloodmaul Slag Mines.','I want to go to Bloodmaul Slag Mines.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86497,'I want to go to Iron Docks.','I want to go to Iron Docks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86498,'I want to go to Auchindoun.','I want to go to Auchindoun.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86499,'I want to go to Skyreach.','I want to go to Skyreach.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86500,'I want to go to Grimrail Depot.','I want to go to Grimrail Depot.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86501,'I want to go to Overgrown Outpost.','I want to go to Overgrown Outpost.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86502,'I want to go to Shadowmoon Burial Grounds.','I want to go to Shadowmoon Burial Grounds.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86503,'I want to go to Upper Blackrock Spire.','I want to go to Upper Blackrock Spire.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86504,'I want to go to Highmaul (Raid).','I want to go to Highmaul (Raid).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86505,'I want to go to Blackrock Foundry (Raid).','I want to go to Blackrock Foundry (Raid).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86506,'So eager to die?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86507,'We are ready, Gharg!','We are ready, Gharg!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86508,'A leader\'s work is never finished. Onward we press, fighting for justice and protecting our people.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86509,'I am ready to fight the Exarch Council.','I am ready to fight the Exarch Council.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86510,'Shinri flees at the sight of you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86511,'Ready for more, $n?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86512,'Send me to the arena, Gharg.','Send me to the arena, Gharg.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86513,'No! Stop! I can\'t control him!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86514,'','You\'re far from home, $r. For the right coin, I\'ll offer you a flight instead of an axe, but don\'t tarry.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(86515,'','I\'m sorry to disappoint you, but If you\'ve come to join up with the Nesingwary Safari then you\'re out of luck.$b$bThe safari has been put on hold while Hemet assists the Alliance and Horde in their fight against the Warsong.$b$bA shame really, this land is one of the most majestic and savage that I have ever laid eyes on.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86516,'I have yet to fully unravel the mysteries of the Zangar fungi, but I am making great progress.$b$bIf my theories are correct, an understanding of the fungal strains in relation to the local ecology will teach us a great deal about the various species on Draenor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86517,'A pleasure to meet you! My name is Dr. Hadley Ricard, and as you can see I seem to be in a pickle of sorts...$b$bI\'ve been taken captive by these podlings, and if my assessment of their intentions is correct... they mean to kill me and use my remains as fertilizer for their offspring!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86518,'Marybelle Walsh sent me to rescue you. Go and I\'ll protect you!','Marybelle Walsh sent me to rescue you. Go and I\'ll protect you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86519,'My research station is near the shore, not far from here. I\'ll wait for you there!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86520,'Used glass vials.','Used glass vials.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86521,'Have a box of foraged herbs.','Have a box of foraged herbs.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86522,'I found all these potions while I was out on adventure.','I found all these potions while I was out on adventure.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86523,'Dropping off the things you asked for.','Dropping off the things you asked for.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86524,'Hope you get some use out of this.','Hope you get some use out of this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86525,'Here you go.','Here you go.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86526,'Anything new?','Anything new?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86527,'Any new inventory?','Any new inventory?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86528,'I need to pick up a few things.','I need to pick up a few things.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86529,'What do you have in stock?','What do you have in stock?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86530,'Did you get the items I was looking for?','Did you get the items I was looking for?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86531,'What\'s for sale?','What\'s for sale?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86532,'Just browsing.','Just browsing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86533,'Anything on sale?','Anything on sale?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86534,'','You expect to defend us with those skills?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86535,'','Keep your guard up when you strike!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86536,'','Lean into your attack more!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86537,'','That thrust was pitiful!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86538,'','Hmph... that attack was satisfactory. More like that!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86539,'Give me a list of what you need and I\'ll get on it.','Give me a list of what you need and I\'ll get on it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86540,'Short on anything?','Short on anything?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86541,'I\'ll have your order done soon.','I\'ll have your order done soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86542,'We\'re a little backed up today.','We\'re a little backed up today.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86543,'War!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86544,'For glory!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86545,'To battle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86546,'Death to all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86547,'Spill their blood!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86548,'Victory will be ours!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86549,'It\'s... only... a flesh wound!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86550,'You win... this time...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86551,'Spiteleaves... avenge me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86552,'I cannot... die...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86553,'Our seeds... will blot out the sun!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86554,'Victory is ours!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86555,'Death to fungi!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86556,'Victory!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86557,'Onward to battle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86558,'Once the research and supplies are returned, Pickles and I will be able to continue our experiments!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86559,'I\'ve heard that Dirgemire makes its lair in an underwater cavern... how magnificently primitive!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86560,'In order to properly dissect such a delicate organ, one must have a steady hand and precise...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86561,'Pickles... NO!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86562,'Quickly, Pickles! Describe to me in exacting detail what you feel at this very moment!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86563,'Wait, Pickles! We must document the experiment!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86564,'It appears that I require a new research assistant...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86565,'Ribbit.','',0,0,0,0,0,0,0,0,0,0,15707,0,26124),
(86567,'A townsfolk has been mutated!','A townsfolk has been mutated!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86568,'Thank you for helping my people through this dark time. We hope to return the favor someday.','',595,0,0,0,0,0,0,0,0,0,0,0,26124),
(86569,'All the components for the spell are in place. I am ready when you are, $n.','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(86570,'When your armor sad from fightin\' in da ring, Glub make not sad.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86571,'Meat for the meat god!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86572,'Work complete!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86573,'Off I go then!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86574,'Hey there, you headed out to the shallows?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86575,'I\'ve been at it for hours. My satchel is almost ready for delivery.','I\'ve been at it for hours. My satchel is almost ready for delivery.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86576,'Take a look at what I\'ve collected so far.','Take a look at what I\'ve collected so far.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86577,'Collecting the talons sure isn\'t easy.','Collecting the talons sure isn\'t easy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86578,'There\'s some stiff competition this year!','There\'s some stiff competition this year!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86579,'Have you seen Garaal\'s work? It\'s quite amazing!','Have you seen Garaal\'s work? It\'s quite amazing!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86580,'Hey you, with da face. Fresh grub over here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86585,'','See ya there, commander!',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(86586,'Thanks, pal! You\'re a life saver!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(86587,'More! More more more!','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(86588,'Fire all the cannons!','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(86589,'Blow them to bits!','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(86590,'Boom!','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(86591,'Help! Help!...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86592,'After many years in Durotar, it feels good to return home.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86593,'I am not used to the scent of air so crisp. It is much less boar-flavored.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86594,'This is not the Draenor I remember, but I was young, and Nagrand was my home.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86595,'We have come to aid the horde in any way that we can.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86596,'Our fortifications here are mighty, but the landscape is savage.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86597,'I have obtained a new pitchfork for this adventure.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86598,'So, you wish to test your strength against the beasts of Draenor? I spent many days, in my youth, doing the same. Take one of the iron traps from the stack behind me, and find a wolf, clefthoof, talbuk, or elekk to pit yourself against.$B$BFirst, you must wound the creature greatly. Then, lead it into the trap, which will snap shut, capturing the creature.$B$BBring the trapped creature back to us, and we will turn it into materials. The creature you choose to hunt will determine what we will gain: the talbuk and wolves have the thickest furs, while the clefthoof and elekks have sturdy hides of leather.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86599,'We have managed to create a trap that closes more tightly than the last. With this improved iron trap, you will be able to bring down the mighty boar and riverbeast.$B$BBoar and riverbeast meat are thick and tasty. We can make them into the perfect meal.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86600,'Our elders once spoke of the most ancient and powerful beasts on the western plains of Nagrand. We now have a trap with jaws that can rival any war wolf. Should you manage to bring down one of these beasts, the furs, meats, and leathers will last us for some time.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86601,'','It\'s about time you got that fixed, Thuldren!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(86602,'An excellent catch, commander, I will have it taken back to the stronghold.','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(86603,'A mighty beast, well done! We will bring it back right away.','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(86604,'Quite a fine creature, it will surely produce many materials for us.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86605,'The smell of this one reminds me of the boar farms in Durotar.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(86606,'The hide of this beast is like iron! I will sharpen my blades.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(86607,'Ah, the air of Nagrand smells as I remember. Fresh, with a hint of blood!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(86608,'I smelled blood in the air, and was not disappointed!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(86609,'A mighty kill, you should be quite proud!','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(86610,'Look for traces of fel energy and follow them! I saw her running west.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86611,'I saw something rush past. I think she scrambled down the cliff here...','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(86612,'We\'re in this together, $p. Side by side.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(86613,'I\'ll be at your garrison if you need me. Be careful out there.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(86614,'Thank you again, friend. I\'ll see you soon.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(86615,'You are a parasite! A blood-sucking insect that looks to feed on my world! We will not allow it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86616,'Ten thousand years as Interfactional Champion, Oooooh yeeeah!','',603,0,0,0,0,0,603,0,0,0,0,0,26124),
(86617,'Rulkamania is like a single grain of sand in the Silithus desert that is Honcho Madness.','',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(86618,'History beckons the Honcho Man!','',603,0,0,0,0,0,603,0,0,0,0,0,26124),
(86619,'I\'m the Honcho Man Randy Ravage and I\'m the Azerothian Brawler\'s Guild Champion and YOU\'RE NOT!','',603,0,0,0,0,0,603,0,0,0,0,0,26124),
(86620,'We\'re in Draenor and Draenor is the domicile!','',603,0,0,0,0,0,603,0,0,0,0,0,26124),
(86621,'Oooooh yeeeah!','',23,0,0,0,0,0,23,0,0,0,0,0,26124),
(86622,'Put yer back into it. There ya go!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(86623,'I must be going now.','I must be going now.',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(86624,'The trap worked! Kill it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86625,'','Curse these plant vermin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86626,'','Mow them down.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86627,'','Don\'t let the little ones past you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86628,'Let\'s get outta here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86629,'','They just keep coming!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86630,'','Pitiful plants.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86631,'Only gladiators is welcome here! If you ain\'t here to fight, then you ain\'t allowed to stay!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86632,'You too puny to be a gladiator! This some kind of joke? Get lost!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86633,'We only allow gladiators here... if I find out you ain\'t here to fight, I\'ll kill you myself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86634,'Puny $r! Just looking at you makes me angry!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86635,'Knowledge is half the battle.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(86636,'Keep your wits about you, commander.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(86637,'The battle is heating up. We must push forward!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(86638,'This is our chance to send the Iron Horde scattering. Steel yourself. We must hold the front line!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(86639,'Reporting for battle!','Reporting for battle!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86640,'See ya at Tangleheart.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(86641,'I\'ll be pulling thorns out of my armor for weeks...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86642,'This is it, warriors. Time for axe work!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86643,'','Hey there, Commander! I found us a tactical copse.$b$bI just need to build us a front door so we don\'t have to find janky ways around it whenever we go in or out.$b$bWanna do the honors? Hit the plunger and enjoy the fireworks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86644,'$n nails a note on the board.','$n nails a note on the board.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86645,'Attacking Vines Killed: $1i (+$2i VP)','Attacking Vines Killed: $1i (+$2i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86646,'Take all of my Artifact Fragments!','Take all of my Artifact Fragments!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86647,'Oh man, that crash was so rough that my insides are still churning.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86648,'I thought I was never going to get back up from that crash. I really can\'t thank you enough!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86649,'I owe you a drink!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86650,'I owe you my life! Thanks for the help!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86651,'','<The assassin can no longer put up a fight. Her arms hang limply at her sides.>$b$bFinish it, $c.$b$b<A quick search of her belongings reveals the antidote to the poison she used on you. You hurriedly prepare the incarceration rune to capture her and send her up to Khadgar\'s Tower above.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86652,'<Use the Incarceration Rune.>','<Use the Incarceration Rune.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86653,'Thank you, $r. I thought I would be trapped forever.','Thank you, $r. I thought I would be trapped forever.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86654,'Miss Kimzee, before we crashed we saw one survivor. I think it might be your uncle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86655,'Good luck!','Good luck!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86656,'','Uncle Krixel!? Get outta the way, I got to rescue him!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86657,'Dad! Dad! We brought your tools!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86658,'I will show these Alliance mongrels what a real warrior can do!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86659,'Did my father send you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86660,'Aaargh, I\'ll stick to tavern games from now on.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86661,'Ahahaha, major choppable!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86662,'Yes, come with me.','Yes, come with me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86663,'B... Ba... Bad idea...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86664,'$GSir:Madam;, an attack on our garrison looms close. I have commissioned some items that you may find useful.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86665,'Guys, I have some really bad news...I\'ve been defeated.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86666,'I thought I knew cold, but that was beyond anything an orc should endure.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(86667,'Time to unleash my macro power on the Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86668,'One shot!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86669,'Whoooo. Darrrrrres. Awakkkkken. ME!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86670,'Get stomped on!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86671,'Hit\'em with the flex!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86672,'Sergeant, a gronn is marching toward our garrison. It\'ll be here in minutes!','Sergeant, a gronn is marching toward our garrison. It\'ll be here in minutes!',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(86673,'Good luck $r, I am going to find a nice warm fire!','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(86674,'Failure is not an option, I will return, after training.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86675,'Fury Bajheera has been unleashed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86676,'','I\'m free! I will never waste time again.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(86677,'Sergeant, Thunderlord Orcs are at the walls!','Sergeant, Thunderlord Orcs are at the walls!',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(86678,'','Good luck, $r. Don\'t waste time, ever!',0,0,0,0,0,0,603,0,4,0,0,0,26124),
(86679,'My stature is only surpassed by my power!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86680,'Send my regards to Armsmaster Holinka little one!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86681,'Sergeant! Smoke on the horizon, and war drums in the distance!','Sergeant! Smoke on the horizon, and war drums in the distance!',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(86682,'Sergeant, strange plants are growing inside the garrison.','Sergeant, strange plants are growing inside the garrison.',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(86683,'Perhaps I\'ll stick to commentating the action from afar.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86684,'What?! Did you see my health!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86685,'The Horde is no match for the power of sun and moon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86686,'Goodness.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86687,'It is most certainly kill time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86688,'These ferns don\'t look friendly...','These ferns don\'t look friendly...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86689,'','Now where am I supposed to work on my trophies?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86690,'The power of the elements flows through me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86691,'This is but a setback, I will return.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86692,'Free win!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86693,'Small, sneaky and ready to fight!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86694,'For Gnomeregan...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86695,'','Let the hunt begin!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86696,'','The hunt is over...for now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86697,'If Pazerp doesn\'t return soon I\'m going to have to send a scout to find my scout. That will be awkward for everybody involved.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(86698,'The shadow looms larger than ever before','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86699,'This is not the end.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86700,'We have lost too many lives already. This battle is getting out of hand.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(86701,'','Tell Isaac, I tried.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86702,'','What you\'ve been looking for has been here the whole time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86703,'','We will stand together!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86704,'','We cannot win if we do not show courage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86705,'Nooooo!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86706,'I will not stay silenced for long.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86707,'Your quality has been assured.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86708,'Ah, c\'mon! You was workin\' just a minute ago!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86709,'I will test your strength and your skill.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86710,'Your will to fight will bleed away before my eyes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86711,'Lousy hunk of... ooof! Pinched myself that time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86712,'This thing has some serious upkeep!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86713,'I hope you\'ve recovered from any wounds that Garona inflicted on you.$b$bAs soon as you are ready, we will combine our efforts to upgrade your ring.','',6,1,0,0,0,0,0,0,0,0,0,0,26124),
(86714,'Hacked to pieces','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86715,'If you dare challenge me, I will be waiting in Tanaan Jungle. You will find only death beyond these gates.','',0,0,0,0,0,0,0,0,4,0,46502,0,26124),
(86716,'Fear not Alliance, for fear is now your ally.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86717,'Defeated but not destroyed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86718,'I will cut them down one by one!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86719,'I never asked for this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86720,'','Disease, death and defeat come for you Horde scum!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86721,'','This is not the end.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86722,'$g Sir:Ma\'am;, I know I\'m not the sharpest saw in the shed, but this doesn\'t seem like the best idea you\'ve ever had. Are you sure about this?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86723,'Ok then! Silence means yes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86724,'No! You cannot stop me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86725,'','They will... overrun... you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86726,'Don\'t you worry! The effects will fade soon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86727,'Just relax... take it easy for a few.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86728,'I can\'t believe we made it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86729,'<The music box crackles and sparks.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86730,'','I\'m surprised you hit the mark. The last one wasn\'t so fortunate!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86731,'','Fully intact, eh? That\'s new.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86732,'','Wow! Where did you come from? This thing isn\'t even hooked up yet!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86733,'','My, my, my... another delivery from Goggles\'. What\'s next? Flyin\' Alarm-o-Bots?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86734,'Play \"Legends of Azeroth\"','Play \"Legends of Azeroth\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86735,'Play \"The Burning Legion\"','Play \"The Burning Legion\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86736,'Play \"Wrath of the Lich King\"','Play \"Wrath of the Lich King\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86737,'Play \"The Shattering\"','Play \"The Shattering\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86738,'Play \"Heart of Pandaria\"','Play \"Heart of Pandaria\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86739,'Play \"A Siege of Worlds\"','Play \"A Siege of Worlds\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86740,'Play \"Stormwind\"','Play \"Stormwind\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86741,'Play \"High Seas\"','Play \"High Seas\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86742,'Boss, me not what dey call smart, but dis tree not right. Maybe we no chop dis one?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86743,'Doh! Me sorry for being stupid! STUPID ME! STUPID! STUPID! Choppy dis tree now, boss!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86744,'Where is the rest of the army?','Where is the rest of the army?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86745,'If ya see Pazaztick, tell\'em Rokhan be lookin\' for him.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86746,'Da Iron Horde is bad news. We need ta put a stop ta dis.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86747,'','Follow me, hero!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(86748,'','Give up, Grommash! Look around you. You are beaten!',0,0,0,0,0,0,603,0,4,0,0,45526,26124),
(86749,'','Very well, Grommash... then we will come for you.',0,0,0,0,0,0,396,0,4,0,0,45527,26124),
(86750,'','Congratulations, hero. This victory is ours.',0,0,0,0,0,0,396,0,4,0,0,45528,26124),
(86751,'The void beckons for your soul!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86752,'NOOOOO!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86753,'%s goes berserk and begins to attack friend and foe alike!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(86754,'','Goren teeth make an excellent tool for cutting through the thickest armor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86755,'','Hello, commander. It has been a pleasure seeing you in action.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(86756,'I was almost back to base with a sack of those artifact fragments when some Horde stole them from me. Watch your back at all times, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86757,'Search him for the gavel.','Search him for the gavel.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86758,'How\'d you get up here? Harrison Jones didn\'t mention this adventure would be so... dangerous.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86759,'','It is good that nobody touched my... work... here. I chose this place to avoid those who would intrude on my... collection...',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(86760,'You riding or biting today?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86761,'I got dis $p!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86762,'By the elements... what has Cho\'gall done?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86763,'Hold fast, $n! The naaru is transforming into a void god... we have no choice but to stand and fight!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86764,'','Auchindoun is safe... for now. Fan out and find Teron\'gor and Gul\'dan.',0,0,0,0,0,0,603,0,0,26702,0,45724,26124),
(86765,'The great furies must be informed of what has transpired here. Quickly, follow me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86766,'I sense a cool draft on my skin and the smell of earth and leaves... there must be an opening to the outside!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86767,'The naaru... this cannot be!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86768,'K\'ure is transforming into a void god... and we are all that stands between it and the destruction of this land!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86769,'My heart aches over the loss of K\'ure... but there is little time to mourn. We must find a way out of this place. Follow me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86770,'','Good, let\'s get in there!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86771,'%s calls for help from its mother.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86772,'Just as I thought! There is an opening not far ahead!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86773,'%s chirps excitedly and flutters away.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86774,'Dis battle is jus\' gettin\' started. Let no Iron Horde survive!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86775,'Commander, our rylak riders have weakened da magnaron, but we\'re pinned outside. We need ya help ta break inta da main compound.','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(86776,'Greetings, Commander! You will find today\'s glorious invention waiting for you on the workbench.','Greetings, Commander! You will find today\'s glorious invention waiting for you on the workbench.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86777,'Tell me about how inventions work.','Tell me about how inventions work.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86778,'Just a moment, $n, please allow me to prepare the materials.','',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(86779,'It is done!','',603,0,0,0,0,0,603,0,0,0,0,0,26124),
(86780,'Your bones will be ground into fertile soil!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86781,'The might of the forest will destroy you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86782,'Eternal darkness awaits!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86783,'I am the protector of these forests. Time to die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86784,'','Hands where I can see \'em, big \'n\' tall.',0,0,0,0,0,0,213,0,0,0,0,0,26124),
(86785,'Fell off yer glider right into me lap!','',0,0,0,0,0,0,213,0,0,0,0,0,26124),
(86786,'','The battle is finished. We\'ve pushed the Iron Horde army back to the gates.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(86788,'Lay down your weapons, Grommash! Look around you. You are lost.','',0,0,0,0,0,0,603,0,4,0,48917,0,26124),
(86789,'Wait then, Grommash. Wait, because we are coming for you.','',0,0,0,0,0,0,0,0,4,0,48918,0,26124),
(86790,'Thank you, hero.  Today, we taste victory! Lok\'tar ogar!','',0,0,0,0,0,0,71,0,4,0,48919,0,26124),
(86791,'I am with you, $p! We shall face this evil together!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86792,'With me, $p! We fight as wolves!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86793,'What new inventions will be available now that we\'ve upgraded?','What new inventions will be available now that we\'ve upgraded?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86794,'Tell me about making vehicles.','Tell me about making vehicles.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86795,'This workshop is great! Each day we\'ll have a different invention available for you to try out. Right now we have the plans and machinery to make four inventions.$B$BThe Sticky Grenade is a grenade that... sticks to things. After a bit, it will explode for terrible damage!$B$BThe Pneumatic Power Glove can pull foes towards you or push them away, using the power of steam and magnets. It will automatically detect which feature to use, depending on your combat abilities.$B$BThe Robo-Rooster is based on the OOX technology we thoroughly tested in Azeroth, this robot fowl can also go berserk, furiously decimating foes!$B$BFinally, we\'ve packaged up a glider and rocket into the \"Skyterror\" P.D.S. The best in highly-explosive one-way travel!','This workshop is great! Each day we\'ll have a different invention available for you to try out. Right now we have the plans and machinery to make four inventions.$B$BThe Sticky Grenade is a grenade that... sticks to things. After a bit, it will explode for terrible damage!$B$BThe Pneumatic Power Glove can pull foes towards you or push them away, using the power of steam and magnets. It will automatically detect which feature to use, depending on your combat abilities.$B$BThe Robo-Rooster is based on the OOX technology we thoroughly tested in Azeroth, this robot fowl can also go berserk, furiously decimating foes!$B$BFinally, we\'ve packaged up a glider and rocket into the \"Skyterror\" P.D.S. The best in highly-explosive one-way travel!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86796,'I\'m glad that you asked! Our manufacture of the rare 7-sided wingnut have unlocked our most brilliant inventions yet!$B$BThe Prototype Chopper is the most rapid ground-faring vehicle we\'ve ever created, and comes with an explosive ejector seat.$B$BYou want to go faster? Try  the XD-57 \"Bullseye\" Guided Rocket Kit! It can\'t stop, or slow down, and explodes when it hits things!$B$BThe Sentry Turret Dispenser will rapidly build a turret capable of shredding your foes into a fine, fragrant mist.$B$BThe GG-117 Micro-Jetpack will allow you to rapidly leap from location to location, creating a explosion when you land.$B$BFinally, the N.U.K.U.L.A.R. Target Painter: select a location, and we\'ll launch a huge rocket capable of massive destruction!','I\'m glad that you asked! Our manufacture of the rare 7-sided wingnut have unlocked our most brilliant inventions yet!$B$BThe Prototype Chopper is the most rapid ground-faring vehicle we\'ve ever created, and comes with an explosive ejector seat.$B$BYou want to go faster? Try  the XD-57 \"Bullseye\" Guided Rocket Kit! It can\'t stop, or slow down, and explodes when it hits things!$B$BThe Sentry Turret Dispenser will rapidly build a turret capable of shredding your foes into a fine, fragrant mist.$B$BThe GG-117 Micro-Jetpack will allow you to rapidly leap from location to location, creating a explosion when you land.$B$BFinally, the N.U.K.U.L.A.R. Target Painter: select a location, and we\'ll launch a huge rocket capable of massive destruction!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86797,'We\'ve completed the vehicle bays, which will allow us to make siege weaponry right here in the shop!$B$BAll we need are some resources, and in about a day\'s time we\'ll be able to deliver a high-powered weapon of destruction.$B$BThe siege weapon will be limited by its fuel consumption, so be sure to watch that gauge!','We\'ve completed the vehicle bays, which will allow us to make siege weaponry right here in the shop!$B$BAll we need are some resources, and in about a day\'s time we\'ll be able to deliver a high-powered weapon of destruction.$B$BThe siege weapon will be limited by its fuel consumption, so be sure to watch that gauge!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86798,'I would like the dwarves to protect the garrison.','I would like the dwarves to protect the garrison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86799,'The might of Ironforge is at your call, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86800,'','The gnomish infantry stands at the ready, commander!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86801,'Only say the word, commander, and the draenei will help to keep the peace.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86802,'The others think they can help. That\'s laughable. Only the might and the ferocity of the worgen can match these lands and protect your garrison. Don\'t you agree?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86803,'We are at your service, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86804,'I would like the gnomes to protect the garrison.','I would like the gnomes to protect the garrison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86805,'I would like the draenei to protect the garrison.','I would like the draenei to protect the garrison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86806,'I do. I would like the worgen to protect the garrison.','I do. I would like the worgen to protect the garrison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86807,'I would like the pandaren to protect the garrison.','I would like the pandaren to protect the garrison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86808,'The city is safe now.','The city is safe now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86809,'The people of Karabor will overcome the losses. The fate of our people will not succumb to the acts of savages.','The people of Karabor will overcome the losses. The fate of our people will not succumb to the acts of savages.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86810,'We must carry our strengths not just for ourselves, but for our people!','We must carry our strengths not just for ourselves, but for our people!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86811,'','No... You can\'t... It\'s... I can\'t FIGHT IT!',0,0,0,0,0,0,0,0,0,0,0,45481,26124),
(86812,'','Flee! The vines! They control us all!',0,0,0,0,0,0,0,0,0,0,0,45479,26124),
(86813,'','Yes, fire! Fire will burn away the contagion.',0,0,0,0,0,0,0,0,0,0,0,45484,26124),
(86814,'','Surely the cold will make them wither?',0,0,0,0,0,0,0,0,0,0,0,45485,26124),
(86815,'','Get away! GET AWAY!',0,0,0,0,0,0,0,0,0,0,0,45486,26124),
(86816,'','No! They will take you too!',0,0,0,0,0,0,0,0,0,0,0,45482,26124),
(86817,'','You mustn\'t give them another host!',0,0,0,0,0,0,0,0,0,0,0,45483,26124),
(86818,'','Burn my body, it\'s the only way to stop them.',0,0,0,0,0,0,0,0,0,0,0,45480,26124),
(86819,'Outsider! I\'ll have your head!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86820,'Leave me alone. Only one who is familiar with the art of enchanting will understand my dilemma.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86821,'What do you want, weakling?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86822,'I will wait for you at the Throne of Elements. Be safe.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86823,'The opening is just ahead!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86824,'What are you doing here?','What are you doing here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86825,'Prepare to battle the Shadowmoon clan.','Prepare to battle the Shadowmoon clan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86826,'The exit is just ahead!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86827,'You have nothing to offer me enchanter. Let me return to my study.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86828,'Prepare to battle the Shadowmoon clan.','Prepare to battle the Shadowmoon clan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86830,'I will await your return at the Throne of Elements.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86831,'We can wait no longer. The Talon King must return.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86832,'','Be careful out there, $c.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86833,'I\'ll get that scared little girl out from under the log, $g sir:ma\'am;!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86834,'[PLACEHOLDER] YOU GOT IT!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86835,'I tink der\'s a woman stuck under der, boss! We gotta help her!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86836,'[PLACEHOLDER] WORK WORK!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86837,'There is power here. I will take it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86838,'I\'m glad for the help, $c.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86839,'Frost is clearly the superior path. Give up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86840,'We\'ll see about that!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86841,'N.U.K.U.L.A.R. Launch Detected','N.U.K.U.L.A.R. Launch Detected',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86842,'MMMMF! HELFFP!! STMUCK UMDER LOG!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86843,'Ah, thank you for the assistance, young peasant. Here is a token of my gratitude.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86844,'+$1i VP','+$1i VP',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86845,'Should you be looking to make a few more coppers there will be work for you at your garrison. I will take my leave. Find me there if you wish.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86846,'Iron Horde Flame Tanks Destroyed: $1i (+$2i VP)','Iron Horde Flame Tanks Destroyed: $1i (+$2i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86847,'Here comes their commander!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86848,'Oh wow, my head hurts...','Oh wow, my head hurts...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86849,'It was like someone else was controlling my body.','It was like someone else was controlling my body.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86850,'What am I doing here? I got to get somewhere safe!','What am I doing here? I got to get somewhere safe!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86851,'Whoa, I\'m in control of myself again! Thanks, friend!','Whoa, I\'m in control of myself again! Thanks, friend!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86852,'Filth! I\'ll send you back where you belong!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86853,'This may take a moment.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86854,'%s hears the whispers growing, louder and louder as the secrets become overwhelming.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86855,'... do you hear that?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86856,'His powers were much greater than I anticipated.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86857,'I should be able to get back to Karabor by the end of the week.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86858,'It is good you are here, there is more trouble than even I can handle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86861,'The spell has been nullified. Our crystals pulse with vigorous energy once again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86862,'','Ain\'t nuthin\' better than ridin\' the ol\' red rocket!',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(86863,'I\'m going to try to counter Morakh\'s spell.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86864,'I wonder what Chris Clarkie does with all those Troll Feet people bring him.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86865,'The incantations on the tablets you discovered will imbue your ring with tremendous power. Are you ready?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(86866,'','I\'m so glad I was rescued from that cramped cage. Once I find the rest of my supplies, I\'m going back to the village.',595,0,0,0,0,0,0,0,0,0,0,0,26124),
(86867,'Flare spotted! An ally signals for aid. The location is marked on your map.','',0,0,0,0,0,0,0,0,0,36471,15911,0,26124),
(86868,'Flare spotted! Our soldiers need your help. The location is marked on your map.','',0,0,0,0,0,0,0,0,0,36470,15912,0,26124),
(86869,'Hey, be careful with that sword!','Hey, be careful with that sword!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86870,'A Laughing Skull orc does grim work here. We should finish our task quickly before they return.$b$bThis one is particularly brutal...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(86871,'These saberon are playing with magic they don\'t understand! They are sure to enrage the magnaron.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(86872,'Let\'s see...','Let\'s see...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86873,'Hmm...','Hmm...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86874,'What do we have here?','What do we have here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86875,'How much is this?','How much is this?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86876,'How interesting!','How interesting!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86877,'I hope this all works out...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86878,'There\'s a chill in the air...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86879,'It must be the Shadowmoon Clan. Sound the alarm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86880,'To arms! To your posts! The Shadowmoon Clan has a score to settle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86881,'Don\'t fear, brothers and sisters. We\'ve fought orcs for decades.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86882,'Do you feel that chill? Like something stomping on your grave...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86883,'Garona is a dangerous assassin. We must keep our guard up. Let me know when you are ready!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(86884,'That was just a test.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86885,'Spread out! Protect the structures!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86886,'I am ready. Let\'s free Garona\'s mind!','I am ready. Let\'s free Garona\'s mind!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86887,'Take heart. It is always darkest before dawn.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86888,'It is here. Charge! For the Alliance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86889,'Sergeant, the dead walk outside our garrison.','Sergeant, the dead walk outside our garrison.',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(86890,'%s checks the delivery list.','%s checks the delivery list.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86891,'writes something on the list of deliveries.','writes something on the list of deliveries.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86892,'The Shadowmoon spirit thanks you before departing the realm of the living.','The Shadowmoon spirit thanks you before departing the realm of the living.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86893,'Mr. Coinbender,\n\nYour payment\'s been arranged, but I had to leave it off shore so the local orcs wouldn\'t confiscate the goods.\n\nI\'ve put out some buoys to help you find it. Best of luck, pal.\n\nRegards,\nGazrix Gearlock','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86894,'You\'ve still got a ways to go. Just keep following the buoys and you\'ll find it.\n\n- Gazrix','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86895,'You\'re almost there. I\'m sure you can see the final buoy by now, chum.\n\n- Gazrix','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86896,'Oh, did I forget to mention that your payment is on the bottom of the ocean?  Maybe you\'ll think about that next time you try to double-cross the Cartel.\n\nJust keep swimming down, though. I\'m sure you\'ll find it, chump.\n\n- GG','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86897,'','These bones are huge! I bet they belong to an ogre... maybe a GIANT ogre!',378,0,0,0,0,0,0,0,0,0,0,0,26124),
(86898,'Beautiful day commander.','Beautiful day commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86899,'Everything is growing so well here.','Everything is growing so well here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86900,'Don\'t all the plants look great?','Don\'t all the plants look great?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86901,'I would like to pick what we plant next.','I would like to pick what we plant next.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86902,'Ok commander, I am currently planting a random set of herbs. Would you like me to switch to something specific?','Ok commander, I am currently planting a random set of herbs. Would you like me to switch to something specific?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86903,'Frostweed.','Frostweed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86904,'Fireweed.','Fireweed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86905,'Gorgrond Flytrap.','Gorgrond Flytrap.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86906,'Talador Orchid.','Talador Orchid.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86907,'Nagrand Arrowbloom.','Nagrand Arrowbloom.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86908,'Starflower.','Starflower.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86909,'Let\'s go with a random planting.','Let\'s go with a random planting.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86910,'Ok commander, I am currently planting Frostweed. Would you like me to switch to something specific?','Ok commander, I am currently planting Frostweed. Would you like me to switch to something specific?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86911,'Ok commander, I am currently planting Fireweed. Would you like me to switch to something specific?','Ok commander, I am currently planting Fireweed. Would you like me to switch to something specific?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86912,'Ok commander, I am currently planting Starflower. Would you like me to switch to something specific?','Ok commander, I am currently planting Starflower. Would you like me to switch to something specific?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86913,'Ok commander, I am currently planting Talador Orchid. Would you like me to switch to something specific?','Ok commander, I am currently planting Talador Orchid. Would you like me to switch to something specific?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86914,'Ok commander, I am currently planting Gorgrond Flytrap. Would you like me to switch to something specific?','Ok commander, I am currently planting Gorgrond Flytrap. Would you like me to switch to something specific?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86915,'','Okay commander, you should be able to use the mole machine to get back to the outpost.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(86916,'Ok commander, I am currently planting Nagrand Arrowbloom. Would you like me to switch to something specific?','Ok commander, I am currently planting Nagrand Arrowbloom. Would you like me to switch to something specific?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86921,'Commander, feel free to use the mole machine to return to yer outpost. It\'ll get ya there. Perhaps.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(86922,'Excellent, now to business!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86923,'|cffADFF2F+$1i Timber|r','|cFF0000FF+$1i Timber|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86924,'','How do you think these got here? Do you think someone put them in the sand?',378,0,0,0,0,0,0,0,0,0,0,0,26124),
(86925,'','No, dummy! Something died and it turned into bones!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86926,'+$1i VP','+$1i VP',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86927,'Yea, this place is pretty interesting to explore. But have you ever been to the Timeless Isle? Now that place was perfection!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86928,'I seem to have misplaced my key to Admiral Taylor\'s coffer. I know I had it a moment ago, but now everything seems so hazy...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(86929,'Maybe you should try retracing your steps?','Maybe you should try retracing your steps?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86930,'The last I remember, I was enjoying a book under a tree somewhere nearby. I\'m not sure quite where, though.\n\nI seem to recall large stones... and for some reason a painting of a death\'s-head... but that is all.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(86931,'It was nearly the end for me out there, $n. Those of us who made it back are truly blessed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86932,'','What ARE those things? They look like figures carved from stone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86933,'What! Who are you?! How did you cross over to this side?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86934,'%s sniffs the air and reels.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86935,'An elixir? And a powerful one at that...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86936,'By tonight I\'ll be wearing your face for a mask!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86937,'For the Shattered Hand!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86938,'You just made the wrong choice!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86939,'All it takes is a little bit of love and care to keep a beautiful garden.','All it takes is a little bit of love and care to keep a beautiful garden.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(86940,'Can you grow these draenic seeds into herbs for me?','Can you grow these draenic seeds into herbs for me?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(86941,'Draenic seeds can be gathered from herbalism nodes across draenor.  Return to me once you have 5 or more and I will grow them into herbs for you.','Draenic seeds can be gathered from herbalism nodes across draenor.  Return to me once you have 5 or more and I will grow them into herbs for you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(86942,'You! Maybe there is still time. The portal atop this outpost is a direct link to our world-- to Stormwind! The genesaur...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86943,'If that beast crosses through, the unchecked growth will choke the whole of Azeroth! Hurry!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(86944,'Look at my horse, isn\'t it magnificent? My partner over there doesn\'t even HAVE a horse. Turn your face from them, now, and look back at me. Still on a horse! Aren\'t you amazed? And look at how great my hat is!','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(86945,'','Ooooh!',378,0,0,0,0,0,0,0,0,0,0,0,26124),
(86946,'','Ooooh!',378,0,0,0,0,0,0,0,0,0,0,0,26124),
(86947,'My next pet won\'t be so easy!','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(86948,'All\'s fair in tiny monkeys and war.','',4,0,0,0,0,0,0,0,1,0,0,0,26124),
(86949,'What? How?? I will have my revenge, you liver-scented codswallup!','',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(86950,'A fitting conclusion to yet another epic battle, featuring me!','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(86951,'Prepare for the smiting of a lifetime!','',2,0,0,0,0,0,0,0,1,0,0,0,26124),
(86952,'Ah, lucky for you I was not paying attention this time!','',21,0,0,0,0,0,0,0,1,0,0,0,26124),
(86953,'I will make for Veil Terokk. Time is short and we have many preparations to make.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86954,'Those are our people down there. May the light bring them peace.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86955,'','Papa said you\'ll be in trouble if you don\'t get out of the boat!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86956,'I\'m not done playing captain! I\'ll go back when I\'m done.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86957,'','I\'m telling!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86958,'As powerful as I am, I cannot be everywhere at once.','',0,0,0,0,0,0,1,0,4,0,44927,0,26124),
(86959,'But you, commander, are my greatest resource. Between the skill of your allies and the might of your garrison, there is not a stronghold that can withstand you.','',0,0,0,0,0,0,0,0,4,0,44928,0,26124),
(86960,'Under your leadership, the full might of the Alliance expeditionary force will engage the Iron Horde.','',0,0,0,0,0,0,0,0,4,0,44929,0,26124),
(86961,'Under your command, the Horde\'s greatest warriors will engage Grommash and his army.','',0,0,0,0,0,0,0,0,4,0,44930,0,26124),
(86962,'But I will be concentrating on the single greatest threat to the safety of Azeroth:','',0,0,0,0,0,0,0,0,4,0,44931,0,26124),
(86963,'Gul\'dan. Darkness incarnate.','',0,0,0,0,0,0,0,0,4,0,44932,0,26124),
(86964,'In all my years, Gul\'dan is the craftiest, most diabolical foe I have ever encountered. I hold myself accountable for his release.','',0,0,0,0,0,0,0,0,4,0,44933,0,26124),
(86965,'We MUST find and eliminate Gul\'dan and his nascent Shadow Council network.','',0,0,0,0,0,0,0,0,4,0,44934,0,26124),
(86966,'With your help, I can track him down. I will ask a great deal of you. I will task you to the very edge of your abilities.','',0,0,0,0,0,0,0,0,4,0,44935,0,26124),
(86967,'But I will also help you as much as I am able. Together we will create for you an artifact of legendary power.','',0,0,0,0,0,0,0,0,4,0,44936,0,26124),
(86968,'With a core forged from the heart of Draenor\'s sun, this ring is a foundation upon which we will build a wonder.','',0,0,0,0,0,0,0,0,4,0,44937,0,26124),
(86969,'...there! It is done. Now to find Gul\'dan.','',0,0,0,0,0,0,0,0,4,0,44938,0,26124),
(86970,'Follow me, commander!','',0,0,0,0,0,0,0,0,4,0,44958,0,26124),
(86971,'Once we locate Gul\'dan, we may have to move quickly...','',0,0,0,0,0,0,0,0,4,0,44959,0,26124),
(86972,'My eyes are open: Van shalach, om aeschis, khaz\'tolim!','',0,0,0,0,0,0,0,0,4,0,44960,0,26124),
(86973,'Come on, come on... Where are you...','',0,0,0,0,0,0,0,0,4,0,44961,0,26124),
(86974,'Wait - here - what...?','',0,0,0,0,0,0,0,0,4,0,44962,0,26124),
(86975,'Hiding! He\'s countering my spell.','',0,0,0,0,0,0,0,0,4,0,44963,0,26124),
(86976,'Champion, killing Teron\'gor must\'ve shaken him up. That\'s good. But now he knows we\'re getting closer.','',0,0,0,0,0,0,0,0,4,0,44964,0,26124),
(86977,'We need... more power!','',0,0,0,0,0,0,0,0,4,0,44965,0,26124),
(86978,'','Perfect timing!',0,0,0,0,0,0,5,0,0,0,0,43840,26124),
(86979,'','We\'ll track you from the air!',0,0,0,0,0,0,1,0,4,0,0,43841,26124),
(86980,'The trail will not be easy to follow. Start by heading east.','',0,0,0,0,0,0,0,0,4,0,44967,0,26124),
(86981,'','Follow the trail of time anomalies like this.',0,0,0,0,0,0,0,0,4,0,0,43842,26124),
(86982,'','Here! It looks like Garrosh came down this way alone after he first arrived on Draenor. But where was Kairoz?',0,0,0,0,0,0,0,0,4,0,0,43843,26124),
(86983,'Look at Garrosh. His hands are bound. But he\'s alone. When did he and Kairoz part ways?','',0,0,0,0,0,0,0,0,4,0,44968,0,26124),
(86984,'','Hmmm... That ogre shouldn\'t be here. Something strange must\'ve happened up on this ridge.',0,0,0,0,0,0,0,0,4,0,0,43844,26124),
(86985,'Who is that?','',0,0,0,0,0,0,0,0,4,0,44969,0,26124),
(86986,'','That\'s Kairoz in disguise. Garrosh killed him! But where was the body?',0,0,0,0,0,0,0,0,4,0,0,43845,26124),
(86987,'We must be close!','',0,0,0,0,0,0,0,0,4,0,44970,0,26124),
(86988,'Very good: I will distract Kairoz while you attack.','',0,0,0,0,0,0,1,0,0,28205,44973,0,26124),
(86989,'','If anyone gets too hurt, I\'ll undo your wounds.',0,0,0,0,0,0,1,0,0,0,0,43848,26124),
(86990,'Excellent! I will distract Kairoz while Chromie goes on the offensive.','',0,0,0,0,0,0,0,0,0,28207,44974,0,26124),
(86991,'','Do your best to keep us both alive!',0,0,0,0,0,0,0,0,0,0,0,43849,26124),
(86992,'Good plan. You distract Kairoz while I attack.','',0,0,0,0,0,0,0,0,0,0,44975,0,26124),
(86993,'Bloodmaul...$B$BNo matter what you hear of that horrid place, you know nothing! I\'ll never go back.','Bloodmaul...$B$BNo matter what you hear of that horrid place, you know nothing! I\'ll never go back.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86994,'Now that I\'ve been freed I must plan to help others escape from Bloodmaul. We cannot leave our brothers and sisters behind!','Now that I\'ve been freed I must plan to help others escape from Bloodmaul. We cannot leave our brothers and sisters behind!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(86995,'You are Warchief no longer, Hellscream. You\'re free because I willed it. You live because I will it. You will join your father and rally the old orc clans because I will it!','',0,0,0,0,0,0,0,0,0,0,46599,0,26124),
(86996,'','He thinks he\'s still fighting Garrosh.',0,0,0,0,0,0,0,0,0,0,0,43851,26124),
(86997,'Kairoz! What did you want? Why did you need an army?','',0,0,0,0,0,0,0,0,0,0,44976,0,26124),
(86998,'Not just one... An infinite number of armies, across an infinite number of worlds...','',0,0,0,0,0,0,378,0,0,0,46600,0,26124),
(86999,'I would be INFINITE!','',0,0,0,0,0,0,5,0,0,0,47376,0,26124),
(87000,'Auuuggh - Hellscream - without me - wh-','',0,0,0,0,0,0,0,0,0,0,46601,0,26124),
(87001,'Look out!','',0,0,0,0,0,0,0,0,0,0,44977,0,26124),
(87002,'I\'ve got him...','',0,0,0,0,0,0,0,0,0,0,44978,0,26124),
(87003,'Keep him distracted!','',0,0,0,0,0,0,0,0,0,0,44979,0,26124),
(87004,'','Watch your feet!',0,0,0,0,0,0,0,0,0,0,0,43858,26124),
(87005,'','Stay away from him!',0,0,0,0,0,0,0,0,0,0,0,43859,26124),
(87006,'Stop it - Chromie, take us back!','',0,0,0,0,0,0,5,0,0,0,44980,0,26124),
(87007,'No - it\'s not working - Chromie-!','',0,0,0,0,0,0,0,0,0,0,44981,0,26124),
(87008,'','Eek! Noooo - I\'m stopping it!',0,0,0,0,0,0,0,0,0,0,0,43860,26124),
(87009,'','...I fixed it.',0,0,0,0,0,0,0,0,0,0,0,43861,26124),
(87010,'','...we\'ll have to try that again.',0,0,0,0,0,0,0,0,0,0,0,43862,26124),
(87011,'','...it\'s okay. We have all the time in the world.',0,0,0,0,0,0,0,0,0,0,0,43863,26124),
(87012,'Victory! Champion, you did it!','',0,0,0,0,0,0,0,0,0,0,44982,0,26124),
(87013,'So many were lost inside the mines...$B$BI barely escaped, but so many are still enslaved.','So many were lost inside the mines...$B$BI barely escaped, but so many are still enslaved.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87014,'Kairoz created this world. We will use his power to find Gul\'dan within it.','',0,0,0,0,0,0,1,0,0,0,44983,0,26124),
(87015,'','Good night, my time-lost prince.',0,0,0,0,0,0,0,0,0,0,0,43864,26124),
(87016,'I am forever indebted to those who set me free.','I am forever indebted to those who set me free.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87017,'Those ogres treated us like dirt. They enslaved our people, forced them to work and slaughtered our kind for their own enjoyment.','Those ogres treated us like dirt. They enslaved our people, forced them to work and slaughtered our kind for their own enjoyment.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87018,'I know now how to defeat Gul\'dan\'s magic and reveal the Shadow Council. But we\'ll need more power.','',0,0,0,0,0,0,0,0,4,0,44984,0,26124),
(87019,'The mines are an unspeakable place.','The mines are an unspeakable place.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87020,'We will have to tear artifacts from the very heart of the Ogre Empire.','',0,0,0,0,0,0,0,0,4,0,44985,0,26124),
(87021,'I can help you. Let us augment the power of that ring of yours...','',0,0,0,0,0,0,0,0,4,0,44986,0,26124),
(87022,'Hold out your hand, and step into the light!','',0,0,0,0,0,0,0,0,4,0,44987,0,26124),
(87023,'I\'m sorry, I should\'ve mentioned that you would be... slightly killed.','',0,0,0,0,0,0,0,0,4,0,44988,0,26124),
(87024,'Don\'t let down your guard, my friend. The ogres of this era are not all brainless brutes. Some among them are dangerously clever.','',0,0,0,0,0,0,1,0,0,0,44949,0,26124),
(87025,'The Sorcerer King comes from a long lineage of terror. To crush him in battle was no small feat.','',0,0,0,0,0,0,1,0,0,0,44950,0,26124),
(87026,'Marvelous... we have everything we need!','',0,0,0,0,0,0,0,0,4,0,44912,0,26124),
(87027,'Gul\'dan will NOT be able to hide from my gaze this time.','',0,0,0,0,0,0,0,0,4,0,44913,0,26124),
(87028,'','Archmage, be careful.',0,0,0,0,0,0,0,0,4,0,0,44145,26124),
(87029,'The mines are sweltering. The heat permeates through everything. I had no energy to move, yet somehow I was able to work countless days without rest.$B$BI would never wish what I went through on another being. It was unbearable...','The mines are sweltering. The heat permeates through everything. I had no energy to move, yet I worked countless days without rest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87030,'We have him where we want him!','',0,0,0,0,0,0,0,0,4,0,44914,0,26124),
(87031,'My eyes are open: Val\'mir, khar abra, mal ozymius...','',0,0,0,0,0,0,0,0,4,0,44915,0,26124),
(87032,'Come, come, come... I will find you...','',0,0,0,0,0,0,0,0,4,0,44916,0,26124),
(87033,'...there! Gul\'dan! He is -','',0,0,0,0,0,0,0,0,4,0,44917,0,26124),
(87034,'You! The human mage from Tanaan...','',0,0,0,0,0,0,0,0,4,0,45306,0,26124),
(87035,'I have found you!','',0,0,0,0,0,0,0,0,4,0,44918,0,26124),
(87036,'I\'ve been inquiring about you, \"Khadgar.\" It would seem we have a history.','',0,0,0,0,0,0,0,0,4,0,45307,0,26124),
(87037,'Then you know how this ends. Give yourself up.','',0,0,0,0,0,0,0,0,4,0,44919,0,26124),
(87038,'Your clumsy magic works both ways. I have also found you.','',0,0,0,0,0,0,0,0,4,0,45308,0,26124),
(87039,'','Archmage, look ou-',0,0,0,0,0,0,0,0,4,0,0,44146,26124),
(87040,'Foolish mage. Your death will be excruciatingly slow. I only wish I could be there to enjoy it.','',0,0,0,0,0,0,0,0,4,0,45309,0,26124),
(87041,'','Champion - The archmage!',0,0,0,0,0,0,0,0,4,0,0,44147,26124),
(87042,'','I will stay with the archmage and find help. Quickly! Capture Garona!',0,0,0,0,0,0,5,0,0,0,0,44148,26124),
(87043,'','You\'re a brave one, coming after me all alone...',0,0,0,0,0,0,0,0,0,0,0,44461,26124),
(87044,'','Come out into the open, \"hero.\" Let me get a good look at you.',0,0,0,0,0,0,0,0,0,0,0,44462,26124),
(87045,'','Following my trail? You\'re strong AND crafty. I LOVE a good hunt.',0,0,0,0,0,0,0,0,0,0,0,44463,26124),
(87046,'','The trail ends! Where did she go...?',0,0,0,0,0,0,0,0,0,0,0,44464,26124),
(87047,'','Got you!',0,0,0,0,0,0,25,0,0,0,0,44465,26124),
(87048,'','The poison is like fire in your veins, isn\'t it? Don\'t worry - it\'ll all be over soon!',0,0,0,0,0,0,0,0,0,0,0,44466,26124),
(87049,'','Still on your feet? You\'re a tough one!',0,0,0,0,0,0,0,0,0,0,0,44467,26124),
(87050,'','Better kill me quick. You don\'t have much time.',0,0,0,0,0,0,0,0,0,0,0,44468,26124),
(87051,'','You\'re too late. Nothing can save your Archmage now.',0,0,0,0,0,0,0,0,0,0,0,44469,26124),
(87052,'','Gul\'dan takes what he wants. Always. I am nothing.',0,0,0,0,0,0,0,0,0,0,0,44470,26124),
(87053,'How do I play Firebird\'s Challenge?','How do I play Firebird\'s Challenge?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(87054,'','Thank you, champion! We got the murder weapon just in time.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(87055,'','Be still, Khadgar. Garona\'s dagger was enchanted.',0,0,0,0,0,0,0,0,4,0,0,46442,26124),
(87056,'%s groans in pain.','',0,0,0,0,0,0,0,0,4,0,44921,0,26124),
(87057,'','This wound is grisly. You should see a priest.',0,0,0,0,0,0,0,0,4,0,0,46443,26124),
(87058,'I am freed, but others are still captive. I shall avenge my brothers and sisters when the time is right.$B$BThe Bloodmaul do not realize what is coming.','I am freed, but others are still captive. I shall avenge my brothers and sisters when the time is right.$B$BThe Bloodmaul do not realize what is coming.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87059,'The Bloodmaul ogres are relentless. They stop at nothing to maintain their workforce.','The Bloodmaul ogres are relentless. They stop at nothing to maintain their workforce.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87060,'For years I was enslaved by the Bloodmaul deep within their mines, but no longer.','For years I was enslaved by the Bloodmaul deep within their mines, but no longer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87061,'No - no priest. Cordana, stitch me up.','',0,0,0,0,0,0,0,0,4,0,44922,0,26124),
(87062,'Ready to fly! |cFF0008E8(Darkmoon Game Token)|r','Ready to fly! |cFF0008E8(Darkmoon Game Token)|r',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(87063,'','I see you\'ve been working with the Horde.',0,0,0,0,0,0,1,0,0,0,0,46444,26124),
(87064,'We\'re worlds away from the conflict in Azeroth. I need all the help I can find.','',0,0,0,0,0,0,1,0,0,0,44923,0,26124),
(87065,'','The rest of the Council of Six doesn\'t want the Horde anywhere near Kirin Tor business.',0,0,0,0,0,0,274,0,0,0,0,46445,26124),
(87066,'It\'s not the first time I\'ve disagreed with the council and it won\'t be the last.','',0,0,0,0,0,0,1,0,0,0,44924,0,26124),
(87067,'','Stubborn old man!',0,0,0,0,0,0,6,0,0,0,0,46446,26124),
(87068,'','Thank you, Commander. You\'re an asset to the Alliance.',0,0,0,0,0,0,1,0,0,0,0,46447,26124),
(87069,'I work with the best.','',0,0,0,0,0,0,273,0,0,0,44925,0,26124),
(87070,'','I heard you\'ve also been working with the Horde. The rest of the Council of Six wouldn\'t approve. I don\'t.',0,0,0,0,0,0,274,0,0,0,0,46448,26124),
(87071,'','Keep protecting our archmage, Commander. We\'d be lost without him.',0,0,0,0,0,0,25,0,0,0,0,46449,26124),
(87072,'Come, this way. This will only hurt - well, quite a bit actually.','',0,0,0,0,0,0,0,0,4,0,44951,0,26124),
(87073,'The power once reserved for the Sorcerer Kings, I place in your hands.','',0,0,0,0,0,0,0,0,4,0,44952,0,26124),
(87074,'Omnivus, al-vitrade! Arcanum totalus!','',0,0,0,0,0,0,0,0,4,0,47377,0,26124),
(87075,'','These are dangerous forces you\'re working with, archmage.',0,0,0,0,0,0,0,0,4,0,0,46450,26124),
(87076,'Our friend needs them. The hardest trials are yet to come.','',0,0,0,0,0,0,0,0,4,0,44953,0,26124),
(87077,'','Welcome! We\'ve got a special delivery of \"Firebird\"-class fireworks ready to strap to your back and send you soaring in search of rings and glory!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87078,'Hand over a game token and I\'ll strap one of our newfangled \"Firebird\"-class fireworks to your back. You\'ll be launched up high in the air and sprout wings of flame!$B$BNow here\'s the tricky part: you only have 10 seconds of flight, and there are a bunch of fiery rings scattered around the fairgrounds. Each ring you pass through will count towards your total of collected rings, and most importantly, will give you another 10 seconds of flight.$B$BCollect 15 rings and the prizes are yours! But if you fail to collect enough rings, it will cost you another token!','Hand over a game token and I\'ll strap one of our newfangled \"Firebird\"-class fireworks to your back. You\'ll be launched up high in the air and sprout wings of flame!$B$BNow here\'s the tricky part: you only have 10 seconds of flight, and there are a bunch of fiery rings scattered around the fairgrounds. Each ring you pass through will count towards your total of collected rings, and most importantly, will give you another 10 seconds of flight.$B$BCollect 15 rings and the prizes are yours! But if you fail to collect enough rings, it will cost you another token!',396,0,0,0,0,0,0,0,1,0,0,0,26124),
(87079,'Today has been a great day for fishing! Now we can have fish for every meal!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87080,'','Hey there, you look like someone that might enjoy strapping a dozen fireworks to their back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87081,'','Fly high in the sky with the Firebird\'s Challenge!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87082,'','Great prizes await, just a fuse away!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87083,'','Am I seeing stars? Nope, it\'s just another great contender for the Firebird\'s Challenge!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87084,'','I may not share my husband\'s enthusiasm for fish, but I am happy that we will have enough food for a while.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87085,'','I\'ll be keeping my eyes on you.',0,0,0,0,0,0,0,0,4,0,0,46440,26124),
(87086,'','Good luck, champion. Be careful in that foundry!',0,0,0,0,0,0,0,0,4,0,0,46441,26124),
(87087,'Now, stand perfectly still.','',0,0,0,0,0,0,0,0,4,0,44954,0,26124),
(87088,'This magic is extremely reliable and - maybe a tiny bit fatal. Hold still, I said!','',0,0,0,0,0,0,0,0,4,0,44955,0,26124),
(87089,'I draw my strength, from the HEART of Draenor...','',0,0,0,0,0,0,0,0,4,0,44956,0,26124),
(87090,'Come, Grommash. Drink.','',0,0,0,0,0,0,0,0,4,0,45310,0,26124),
(87091,'I told you - get out!','',0,0,0,0,0,0,0,0,4,0,46493,0,26124),
(87092,'They assault your foundry. They murder your allies. Mine is the only way.','',0,0,0,0,0,0,0,0,4,0,45311,0,26124),
(87093,'Go!','',0,0,0,0,0,0,0,0,4,0,46494,0,26124),
(87094,'Take me to the Pinchwhistle Gearworks.','Take me to the Pinchwhistle Gearworks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87095,'','It worked.',0,0,0,0,0,0,0,0,4,0,0,44154,26124),
(87096,'I maintain a pair of goblin jumper cables for just such an emergency. Are you well, commander?','',0,0,0,0,0,0,0,0,4,0,44957,0,26124),
(87097,'And so the foundry falls! You\'ve got the Iron Horde on the run, commander.','',0,0,0,0,0,0,1,0,0,0,44911,0,26124),
(87098,'Come with me. Gul\'dan will not give up control of his pet without a fight.','',0,0,0,0,0,0,0,0,4,0,44940,0,26124),
(87099,'','Just kill me and be done with it, archmage.',0,0,0,0,0,0,0,0,4,0,0,44472,26124),
(87100,'I\'m not here to kill you, assassin.','',0,0,0,0,0,0,0,0,4,0,44941,0,26124),
(87101,'','%s reels in pain.',0,0,0,0,0,0,0,0,4,0,0,44473,26124),
(87102,'Where is your master? Tell me!','',0,0,0,0,0,0,0,0,4,0,44942,0,26124),
(87103,'','Burn... in a thousand... hells...',0,0,0,0,0,0,0,0,4,0,0,44474,26124),
(87104,'You first. Where is Gul\'dan!?','',0,0,0,0,0,0,0,0,4,0,44943,0,26124),
(87105,'','Argghgh - he - will undo you -',0,0,0,0,0,0,0,0,4,0,0,44475,26124),
(87106,'Where is he hiding?','',0,0,0,0,0,0,0,0,4,0,44944,0,26124),
(87107,'','Archmage...',0,0,0,0,0,0,0,0,4,0,0,44151,26124),
(87108,'TELL ME!','',0,0,0,0,0,0,0,0,4,0,44945,0,26124),
(87109,'','%s grasps her head.',0,0,0,0,0,0,0,0,4,0,0,44476,26124),
(87110,'','Khadgar, stop! What\'s the difference between this and torture?',0,0,0,0,0,0,0,0,4,0,0,44152,26124),
(87111,'But she knows...','',0,0,0,0,0,0,0,0,4,0,44946,0,26124),
(87112,'','I don\'t even know what you\'re fighting for anymore.',0,0,0,0,0,0,0,0,4,0,0,44153,26124),
(87113,'You - you\'re right. Gul\'dan has butchered her mind already.','',0,0,0,0,0,0,0,0,4,0,44947,0,26124),
(87114,'I am sorry, Garona. We will find another way.','',0,0,0,0,0,0,0,0,4,0,44948,0,26124),
(87115,'This note appears to have fallen off the crate. It reads:\n\n\"Caution. Contents extremely dangerous and unpredictable. Do not tamper with or compromise shipping containers.\"','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87116,'I\'d like to join the Sargerei.','I\'d like to join the Sargerei.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87117,'I\'m gonna steal the Statement of Subordination!','',603,0,0,0,0,0,603,0,0,0,0,0,26124),
(87118,'No... Mogor... cannot die...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87119,'MOGOR CANNOT DIE!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87120,'Ergh... mfmff...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87121,'Heh... heheh... hah','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87122,'Nyaaana na na na... haha','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87123,'Row... roads... row-ads heh heh','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87124,'Hrgrhlflffbrrrr...thhpppttpt','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87125,'Secret seeker it\'s a - NO! No-no-no...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87126,'I SEE IT!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87127,'The door... do you see it? I...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87128,'','Look at this place. The botani are monsters.$b$bI think I am starting to see why the Laughing Skull are as brutal as they are.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87129,'See you soon! Hehehe...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87130,'Exarch Maladaar has opened his weapon stores to any willing to lend their hand to the battle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87131,'Oh good, you\'re back! Enjoy yourself in there?','',0,0,0,0,0,0,70,0,0,0,0,0,26124),
(87132,'Kaz! Kaz! Kaz! This no-mask took me on an adventure! We saw infested orcs, a green ogron, and we set everything on FIRE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87133,'You have drawn Wrath!','You have drawn Wrath!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87134,'You have drawn Devastation!','You have drawn Devastation!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87135,'You have drawn Nimbleness!','You have drawn Nimbleness!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87136,'You have drawn Frailty!','You have drawn Frailty!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87137,'You have drawn Vulnerability!','You have drawn Vulnerability!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87138,'You have drawn Swiftness!','You have drawn Swiftness!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87139,'You have drawn The Void!','You have drawn The Void!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87140,'You have drawn The Herd!','You have drawn The Herd!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87141,'You have drawn The Warp!','You have drawn The Warp!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87142,'You have drawn The Barbarian!','You have drawn The Barbarian!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87143,'Long have I dwelt in the shadows. I can hide no longer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87144,'Are you ready to fight Sethe, $r?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87145,'I am ready Anzu, we will not fail.','I am ready Anzu, we will not fail.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87146,'Are you ready to join Anzu in his fight with Sethe?','Are you ready to join Anzu in his fight with Sethe?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87147,'Protect me, $n! Sethe\'s blood is harmful to all who cross its path.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87148,'Help me, $n! My life force is fading!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87149,'I will darken the skies, and all will fall!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87150,'It is done. Meet me at Lithic\'s Rest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87151,'','We\'ll get a rescue party together as soon as we can. Where did you see him last?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87153,'<The spirit wolf does not acknowledge your presence, and continues to stare blankly at a crude grave nearby.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87154,'(Beast Mastery) Lean down and scratch the wolf behind its ears.','(Beast Mastery) Lean down and scratch the wolf behind its ears.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87155,'Hey, pal! Good to see one of you $gguys:ladies; from the Alliance around here!\n\nWith your help, I bet I can make some progress with my work.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87156,'If she is searching for this \"Heart of Gorgorek,\" then we must find it before her. I will notify you as soon as I learn more.','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(87157,'Commander, this will be a protracted campaign. I should have more information for you in a week\'s time.','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(87158,'If she and da Iron Horde be searchin\' for dis \"Heart a Gorgorek,\" den we must find it first. I will send for ya when I hear more.','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(87159,'Commander, dis will be a long campaign. I will have more information for ya in a week\'s time.','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(87160,'You\'re from the Horde aren\'t you?$b$bI didn\'t know Kimzee would be out working with your kind, but considering the situation, I\'ll take any help I can get.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87161,'Gwaagghhh!!!!','Gwaagghhh!!!!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87162,'We aren\'t the only ones with Prisoners, $n.$B$BOver at the Horde base lies their prison, underneath the relief hut to the left when you go through their main gate.$B$BIf we can find some of those Warspear Prison Keys in Ashran, we can break them free.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87163,'Did... did you hear something?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87164,'The Sargerei were no fools. They had been watching me this whole time.$B$BBut I am happy to know that my work was not in vain.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(87165,'You cannot flee.','',0,0,0,0,0,0,0,0,0,0,43205,0,26124),
(87166,'','',0,0,0,0,0,0,0,0,0,0,43206,0,26124),
(87167,'Your souls are mine.','',0,0,0,0,0,0,0,0,0,0,43207,0,26124),
(87168,'Flee! Flee from your former masters!','',0,0,0,0,0,0,0,0,0,0,43208,0,26124),
(87169,'Your mortal bodies are so fragile.','',0,0,0,0,0,0,0,0,0,0,43202,0,26124),
(87170,'Another soul to devour.','',0,0,0,0,0,0,0,0,0,0,43203,0,26124),
(87171,'You are just maggots swarming to the corpse of a dying god.','',0,0,0,0,0,0,0,0,0,0,43198,0,26124),
(87172,'Yes, come closer... your souls are strong and proud! I will feast on your terror!','',0,0,0,0,0,0,0,0,0,0,43197,0,26124),
(87173,'It seems like they are close to figuring out the concept of death. Do you think we should tell them a bit more about it?','',378,0,0,0,0,0,0,0,0,0,0,0,26124),
(87174,'No, we should let them learn about it through their own discoveries. Just as we learned about the cycle of life on our own, they must do the same.','',378,0,0,0,0,0,0,0,0,0,0,0,26124),
(87175,'Ahh, I thought I\'d never get out of there! Good work!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87176,'I try to bring my talbuk down to the shore to relax as often as I can. He really likes watching the fishermen on the boats.','',378,0,0,0,0,0,0,0,0,0,0,0,26124),
(87177,'','Papa, brother won\'t get out of the boat. I told him and he didn\'t listen to me!',605,0,0,0,0,0,0,0,0,0,0,0,26124),
(87178,'That\'s alright, honey. That just means there\'s more of your mother\'s stew for us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87179,'%s begins to cast |cFFFF0404|Hspell:171078|h[Exsteaminate]|h|r on targets that are both |cFFFF0404|Hspell:171061|h[Waterlogged]|h|r and |cFFFF0404|Hspell:171065|h[On Fire]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(87180,'','Maybe he will learn now not to skip meals.',378,0,0,0,0,0,0,0,0,0,0,0,26124),
(87181,'','You there, scrollkeeper. You are not of the ravenspeakers. Why do you stand before me?',0,0,0,0,0,0,0,0,0,0,0,46789,26124),
(87182,'Great Ka\'alu, the tales of your majesty are woefully inadequate.','',0,0,0,0,0,0,0,0,0,0,46028,0,26124),
(87183,'','You flatter me, but darkness weighs upon your thoughts - speak, child.',0,0,0,0,0,0,0,0,0,0,0,46790,26124),
(87184,'The Adherents of Rukhmar wield a great power. They would use it to burn us all, including your ravens.','',0,0,0,0,0,0,1,0,0,0,46029,0,26124),
(87185,'','They also subjugate my children, forcing them to fight and die. What might you have us do?',0,0,0,0,0,0,0,0,0,0,0,46791,26124),
(87186,'Great mother, in the name of Anzu we ask humbly that you lend us your wings.','',0,0,0,0,0,0,16,0,0,0,46030,0,26124),
(87187,'With your help, we can extinguish the light which sets the sky ablaze.','',0,0,0,0,0,0,1,0,0,0,46031,0,26124),
(87188,'','Anzu always was meddling in the affairs of mortals. One would think I might learn from his mistakes.',0,0,0,0,0,0,0,0,0,0,0,46792,26124),
(87189,'','Very well, scrollkeeper. My flock is yours.',0,0,0,0,0,0,0,0,0,0,0,46793,26124),
(87190,'I came to find my daddy\'s tools and these savages trapped me! He needs them to work...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87191,'Percy, you stay here and guard the nest.','',0,0,0,0,0,0,0,0,0,0,45996,0,26124),
(87192,'We must secure this terrace. Help our forces turn the tide!','',0,0,0,0,0,0,0,0,0,0,45997,0,26124),
(87193,'You fight like a legend! Come, let us return to the sky.','',0,0,0,0,0,0,603,0,0,0,45998,0,26124),
(87194,'We need to capture those alignment controls.','',0,0,0,0,0,0,0,0,0,0,45999,0,26124),
(87195,'The ravenspeaker acolytes are ready to leap at your command.','',0,0,0,0,0,0,0,0,0,0,46000,0,26124),
(87196,'It\'s no good, they\'re dying out there! Clear a path for them!','',0,0,0,0,0,0,0,0,0,0,46001,0,26124),
(87197,'Reinforcements! Clear them out!','',0,0,0,0,0,0,0,0,0,0,46002,0,26124),
(87198,'It looks like everyone is in position. Ka\'alu, give the signal and get us out of here!','',0,0,0,0,0,0,0,0,6,0,46003,0,26124),
(87199,'Tweet me if you hate it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87200,'Tweet me if you LOVE it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87201,'Tweet me if you find bugs!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87202,'This one! Take it down!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87203,'So my wretched brother lives... and he has sent an assassin!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87204,'Duna! My boy... I thought you were lost.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87205,'Servants, attack!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87206,'Think you can help us catch some fish around here?','Think you can help us catch some fish around here?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(87207,'','Armies fight and die on the backs o\' their suppliers.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(87208,'How many do you think you can catch today?','',378,0,0,0,0,0,0,0,0,0,0,0,26124),
(87209,'I\'m feeling pretty lucky, so I\'m thinking double the catch I pulled in yesterday.','',378,0,0,0,0,0,0,0,0,0,0,0,26124),
(87210,'So you think you\'ll catch two fish today?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(87211,'It was a pretty big fish! It was bigger than the little ones you brought in...','',378,0,0,0,0,0,0,0,0,0,0,0,26124),
(87212,'I was just using the wrong bait! I actually brought the correct one today.','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(87213,'Shadowmoon Dark Prophets Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87214,'Shadowmoon Defilers Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87215,'Shadowmoon Voidtwisters Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87216,'Reanimated Bones Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87217,'Risen Guards Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87218,'Primordial Horror Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87219,'Shadowmoon Warriors Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87220,'We shall purge these Iron Horde scum from my hunting grounds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(87221,'This is one of my allies.','This is one of my allies.',0,0,0,0,0,0,273,0,1,0,0,0,26124),
(87222,'Working like a charm! Don\'t mind the smoke...','',0,0,0,0,0,0,432,0,0,0,0,0,26124),
(87223,'Hop in!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87224,'','My Phantom Potions are perfect for sneaking around the Horde guards, or even into their main base! Have you tried them yet, $n?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87225,'','Someone just showed me a Tuber root they found somewhere in east of Ashran. $B$BThey rival my healing potions in power!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87226,'','Are you here to visit one of the wounded, $n?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87227,'','Every day I see more and more wounded come into this relief hut. Take my advice and bring a healer along with you on your missions.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87228,'','Healers are truly underestimated, $n. If more would choose to bring us along on their missions there would be less here in my relief hut.',0,0,0,0,0,0,0,0,0,17483,0,0,26124),
(87229,'','Have you seen Feezzel? I can\'t find him anywhere.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87230,'Shadowmoon Deathcallers Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87231,'Better luck next time.','Better luck next time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87232,'Nothing.','Nothing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87233,'What was that?','What was that?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87234,'Hey!','Hey!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87235,'Success!','Success!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87236,'Finally!','Finally!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87237,'That\'s more like it!','That\'s more like it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87238,'Catch of the day!','Catch of the day!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87239,'Wow! Look at the size of that one!','Wow! Look at the size of that one!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87240,'There\'s always a bigger fish.','There\'s always a bigger fish.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87241,'Will you look at that?','Will you look at that?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87242,'A prize catch!','A prize catch!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87243,'purrs.','purrs.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87244,'The secrets of the Apexis will be revealed to us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87245,'Sister...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87246,'You will... burn...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87247,'How dare you challenge the will of Rukhmar!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87248,'Be careful with that serum, I\'m not exactly sure what the effects will be.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87249,'','Don\'t you worry, I\'ll get this thing flying one way or another.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(87250,'You ground-dwellers need to learn your place!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87251,'Lowborn... wretches...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87252,'A Shadowmoon Deathcaller begins awakening the dead.','A Shadowmoon Deathcaller begins awakening the dead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87253,'Dig, you worms!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(87254,'You have my thanks!','You have my thanks!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87255,'It\'s an honor to fight by your side!','It\'s an honor to fight by your side!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87256,'You fight well!','You fight well!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87257,'You have my gratitude!','You have my gratitude!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87258,'Victory will be ours!','Victory will be ours!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87259,'With you on our side, they cannot win!','With you on our side, they cannot win!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87260,'Ready to do some mining?','Ready to do some mining?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87261,'Blood, sweat and tears. That\'s what it takes to be a strong miner.\n\nAre you up to the task?','Blood, sweat and tears. That\'s what it takes to be a strong miner.\n\nAre you up to the task?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87262,'Never thought you would be into mining, did ya?','Never thought you would be into mining, did ya?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87263,'Can you refine this draenic stone into ore for me?','Can you refine this draenic stone into ore for me?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(87264,'Draenic stone can be mined from mining deposits across draenor.  Return to me once you have 5 or more and I will refine them into ore for you.','Draenic stone can be mined from mining deposits across draenor.  Return to me once you have 5 or more and I will refine them into ore for you.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(87265,'Care for your Garden and it will take care for you in return.','Care for your Garden and it will take care for you in return.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(87266,'Glory to the Alliance!','Glory to the Alliance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87267,'Good day, Commander. Or is it night? Never can tell in this blasted place.','Good day, Commander. Or is it night? Never can tell in this blasted place.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87268,'All hail Commander $n, hero of the Alliance!','All hail Commander $n, hero of the Alliance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87269,'You are a light in this dark place, Commander.','You are a light in this dark place, Commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87270,'Commander! Never a dull day on Draenor, is it?','Commander! Never a dull day on Draenor, is it?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87271,'Victory or death, Commander! I\'d prefer the first one, though, if at all possible.','Victory or death, Commander! I\'d prefer the first one, though, if at all possible.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87272,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87273,'Show those iron mongrels what the real Horde is made of, Commander!','Show those iron mongrels what the real Horde is made of, Commander!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87274,'Strength and honor!','Strength and honor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87275,'For Warchief Vol\'jin and Commander $n!','For Warchief Vol\'jin and Commander $n!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87276,'You bring glory to the Horde, Commander!','You bring glory to the Horde, Commander!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87277,'All hail Commander $n, pride of the Horde!','All hail Commander $n, pride of the Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87278,'Tonight we feast in your honor, Commander!','Tonight we feast in your honor, Commander!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87279,'Glad to be in your presence, Commander.','Glad to be in your presence, Commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87280,'It is my honor to serve you.','It is my honor to serve you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87281,'The garrison is secure.','The garrison is secure.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87282,'That a new scar, Commander? What\'s the tally at now?','That a new scar, Commander? What\'s the tally at now?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87283,'Look alive, everyone! The commander is here!','Look alive, everyone! The commander is here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87284,'Commander!','Commander!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87285,'One look at you and our enemies will cower like the dogs they are!','One look at you and our enemies will cower like the dogs they are!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87286,'I live to serve.','I live to serve.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87287,'I smell battle in the air, Commander.','I smell battle in the air, Commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87288,'It is an honor to fight by your side!','It is an honor to fight by your side!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87289,'Need something killed?','Need something killed?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87290,'Commander. How goes the battle?','Commander. How goes the battle?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87291,'Say the word and it\'s done.','Say the word and it\'s done.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87292,'Orders, Commander?','Orders, Commander?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87293,'We will strike hard and true.','We will strike hard and true.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87294,'I stand before a legend.','I stand before a legend.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87295,'Stand as one!','Stand as one!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87296,'For the Alliance!','For the Alliance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87297,'They will write songs of this battle.','They will write songs of this battle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87298,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87299,'You\'ll make a nice trophy.','You\'ll make a nice trophy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87300,'I survived the Siege of Orgrimmar. This is nothing.','I survived the Siege of Orgrimmar. This is nothing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87301,'This won\'t take long.','This won\'t take long.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87302,'That one\'s got loot! Get it!','That one\'s got loot! Get it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87303,'Take them down!','Take them down!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87304,'Oh good, I was getting bored.','Oh good, I was getting bored.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87305,'Feel free to run.','Feel free to run.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87306,'More enemies. Watch your back!','More enemies. Watch your back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87307,'This won\'t be a problem.','This won\'t be a problem.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87308,'Here we go!','Here we go!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87309,'I\'m starting to like this garrison. You can\'t have it.','I\'m starting to like this garrison. You can\'t have it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87310,'They\'re attacking! That\'s too bad for them.','They\'re attacking! That\'s too bad for them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87311,'Someone\'s going to get hurt real bad.','Someone\'s going to get hurt real bad.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87312,'Don\'t get cocky!','Don\'t get cocky!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87313,'Brace yourselves!','Brace yourselves!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87314,'This will be your end. Try not to embarrass yourself.','This will be your end. Try not to embarrass yourself.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87315,'When this is over, I\'ll buy the first round.','When this is over, I\'ll buy the first round.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87316,'Here they come. Stay focused.','Here they come. Stay focused.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87317,'This might be interesting.','This might be interesting.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87318,'Eyes open, everyone! They\'re here!','Eyes open, everyone! They\'re here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87319,'I hope you\'re more of a challenge than the last one.','I hope you\'re more of a challenge than the last one.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87320,'This is not the day I die.','This is not the day I die.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87321,'I have prepared my whole life for this moment.','I have prepared my whole life for this moment.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87322,'I\'ve killed tougher things than you.','I\'ve killed tougher things than you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87323,'A challenger!','A challenger!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87324,'I will crush you!','I will crush you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87325,'That\'s not a weapon - this is a weapon!','That\'s not a weapon - this is a weapon!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87326,'Fight me! Fight like a warrior!','Fight me! Fight like a warrior!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87327,'I will take your head as a trophy, coward.','I will take your head as a trophy, coward.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87328,'Submit now, and I will kill you quickly.','Submit now, and I will kill you quickly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87329,'All you fight for will be dust.','All you fight for will be dust.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87330,'Ours is the side of right!','Ours is the side of right!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87331,'Victory shall be mine.','Victory shall be mine.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87332,'I will strike you down!','I will strike you down!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87333,'You will not prevail!','You will not prevail!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87334,'Ah, finally, a worthy opponent!','Ah, finally, a worthy opponent!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87335,'A pity I\'ll have to kill you.','A pity I\'ll have to kill you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87336,'Pathetic. You fight like a child.','Pathetic. You fight like a child.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87337,'I\'ve seen better strategy from a target dummy!','I\'ve seen better strategy from a target dummy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87338,'I will fight to my last breath.','I will fight to my last breath.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87339,'The ground will run red with your blood!','The ground will run red with your blood!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87340,'Ever wonder what color your insides are? You\'re about to find out.','Ever wonder what color your insides are? You\'re about to find out.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87341,'Your every bone - broken!','Your every bone - broken!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87342,'Let\'s see how you fight without limbs.','Let\'s see how you fight without limbs.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87343,'You will die here, alone and forgotten.','You will die here, alone and forgotten.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87344,'Nice weapon. I\'ll have to take it off your corpse.','Nice weapon. I\'ll have to take it off your corpse.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87345,'Hah! With every blow, your hope flees!','Hah! With every blow, your hope flees!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87346,'Don\'t worry. Your end will be quick.','Don\'t worry. Your end will be quick.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87347,'You\'re the best your kind could muster?','You\'re the best your kind could muster?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87348,'I\'ll put your head on a pike!','I\'ll put your head on a pike!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87349,'Why don\'t you do something useful, like dig your own grave?','Why don\'t you do something useful, like dig your own grave?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87350,'This is growing tedious! Surrender!','This is growing tedious! Surrender!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87351,'You should have trained harder.','You should have trained harder.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87352,'I could take you down with one blow.','I could take you down with one blow.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87353,'Fool! You\'re no match for me!','Fool! You\'re no match for me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87354,'This is too easy! Are you trying to die?','This is too easy! Are you trying to die?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87355,'I will not be defeated!','I will not be defeated!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87356,'I fight with honor! You fight like a dog!','I fight with honor! You fight like a dog!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87357,'This is not even a challenge.','This is not even a challenge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87358,'Go back home, whelp. There\'s nothing for you here but death.','Go back home, whelp. There\'s nothing for you here but death.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87359,'Try this on for size!','Try this on for size!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87360,'I go now to the Light.','I go now to the Light.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87361,'I return to my ancestors.','I return to my ancestors.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87362,'I have failed you, Commander.','I have failed you, Commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87363,'The dark consumes me.','The dark consumes me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87364,'Is this how it ends?','Is this how it ends?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87365,'I give my life for Azeroth!','I give my life for Azeroth!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87366,'Tell my family... I love them.','Tell my family... I love them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87367,'Curse this Light-forsaken realm!','Curse this Light-forsaken realm!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87368,'My sacrifice will not be in vain.','My sacrifice will not be in vain.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87369,'I did... my best.','I did... my best.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87370,'I may be defeated, but Azeroth shall prevail!','I may be defeated, but Azeroth shall prevail!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87371,'I\'ll see Garrosh in hell!','I\'ll see Garrosh in hell!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87372,'I cannot go on.','I cannot go on.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87373,'This isn\'t over. I shall be avenged!','This isn\'t over. I shall be avenged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87374,'At least I go down fighting.','At least I go down fighting.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87375,'I die with honor.','I die with honor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87376,'I regret nothing!','I regret nothing!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87377,'So... cold...','So... cold...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87378,'Promise me... you\'ll get the one that got me.','Promise me... you\'ll get the one that got me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87379,'Death is a small price to pay.','Death is a small price to pay.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87380,'I\'d die a thousand deaths for Azeroth.','I\'d die a thousand deaths for Azeroth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87381,'You should see the other guy...','You should see the other guy...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87382,'I am... finished...','I am... finished...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87383,'Is that the best you\'ve got... Wait, that was pretty good.','Is that the best you\'ve got... Wait, that was pretty good.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87384,'My only regret is I didn\'t kill more of you Iron Horde dogs.','My only regret is I didn\'t kill more of you Iron Horde dogs.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87385,'I\'m not even supposed to be here today.','I\'m not even supposed to be here today.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87386,'\'Tis but a scratch!','\'Tis but a scratch!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87387,'I said I\'d die for Azeroth, but I didn\'t think it would be so soon.','I said I\'d die for Azeroth, but I didn\'t think it would be so soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87388,'Finish me, you cur. I\'ll never surrender!','Finish me, you cur. I\'ll never surrender!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87389,'I could not resist the primal call of this world. This land is so unlike Azeroth. There is so much to discover, and so much to understand.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87390,'The Druids of the Talon are here to help defend our world against the Iron Horde. The balance of life on Azeroth must be preserved.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87391,'We druids are uniquely equipped to fight against the Iron Horde. I have stationed most of my forces throughout Gorgrond.$B$BThere, we patrol the jungles, deserts, and skies.$B$BI have eyes and ears reporting regularly on Blackhand\'s movements.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87392,'','The Druids of the Talon are here to help. Our teams are spread out across Gorgrond, listening and watching.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87393,'There are still Iron Horde in the northern courtyard.','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(87394,'I smell battle in the air, Commander. Or is that the outhouse again?','I smell battle in the air, Commander. Or is that the outhouse again?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87395,'I have lost my garrison hearthstone, can you give me another?','I have lost my garrison hearthstone, can you give me another?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(87396,'Blacksmith Haephest has gone into the village to sell our wares today. However, I can handle any repair needs you may have.\n\nMay I be of assistance?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87397,'%s sighs wearily.','%s sighs wearily.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87398,'%s looks exhausted.','%s looks exhausted.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87399,'%s wipes his brow.','%s wipes her brow.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87400,'','No matter how much I feed them, your pets keep wandering into the town hall and begging for scraps.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87401,'I hear you\'re a force to be reckoned with in the arena, $n.','',11,0,0,1,0,0,0,0,0,0,0,0,26124),
(87402,'Not all High Warlords are the same, $c. Some got here by persistence and time, others by skill of combat. Take a guess at which of those I belong.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87403,'Sorry, I can\'t heal your pets right now.  I can help if you come back in a few minutes.\n\n(You cannot heal your pets within 3 minutes of logging in.)','Sorry, I can\'t heal your pets right now.  I can help if you come back in a few minutes.\n\n(You cannot heal your pets within 3 minutes of logging in.)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87404,'','So this whole fight club thing just isn\'t my style. I\'m more of a rip the trees down with a homemade giant mechanical monster kind of gal.$b$bIf you change your mind later, come talk to me and I can flip this fight club out of your way and replace it with a nice big rompin\' lumber camp! Complete with its own shredder!$b$bOf course, that ain\'t gonna be cheap.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87405,'Build the Lumber Yard instead.','Build the Lumber Yard instead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87406,'Do you have any booty for sale?','Do you have any booty for sale?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(87407,'Why are you called the Lioness?','Why are you called the Lioness?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87408,'','<Lio narrows her eyes.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87409,'','You sure you want an answer?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87410,'','<Lio growls softly.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87411,'','Someone else asked me that once... just once.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87412,'','Kid, don\'t start with me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87413,'Pursue Garona!','Pursue Garona!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87414,'Nevermind!','Nevermind!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87415,'Any pet stuff for sale?','Any pet stuff for sale?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(87416,'','Oh, what a great question.  Let me write that one down.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87417,'','Do you like scars?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87418,'','Did you find anything on O\'rok\'s body? A letter perhaps? Or some orders?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87419,'Gro the Uncreator, I call to you!','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(87420,'The spirits of the Laughing Skull have spoken. We must join together to fight our common enemy, the Iron Horde!','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(87421,'Yes! It is working! The spirits were right!','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(87422,'Trees? Bah! Why rebuild when we can destroy!$b$bI can show you and your soldiers tricks no shredder could compete with.$b$bCome back when you are older and have some coin, and we\'ll get ourselves a proper fight club going.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87423,'Xuk...','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(87424,'Build the Fight Club instead.','Build the Fight Club instead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87425,'%s\'s Wicked Curse has found a more suitable host and jumps to $n.','%s\'s Wicked Curse has found a more suitable host and jumps to $n.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(87426,'I want the head of the orc that dumped those mines into the harbor!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(87427,'The White Kraken could attack at any time! I need those mines loaded now!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(87428,'We have already discovered hundreds of new species here on Draenor. There is so much to study, so much to collect, so much to catalog!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87429,'Take me down to the ground.','Take me down to the ground.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87430,'The pain... so exquisite...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87431,'But who... will stop... the White Kraken...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87432,'The Iron Horde will fight on without me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87433,'The Gorian Empire will... prevail...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87434,'','Hey! I\'m scouting for danger.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87435,'Take me up to Cragplume Cauldron.','Take me up to Cragplume Cauldron.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87436,'This place is quaint. It reminds me of the servant\'s quarters in my summer retreat on the shores of Lordamere Lake - only more rustic. And dirtier.$B$BPerhaps you should make an investment in some of Barov Industries\' wares to secure this make-shift tree fort before a light breeze topples the structure.','',1,1,11,0,0,0,0,0,0,0,0,0,26124),
(87437,'What have you got for sale?','What have you got for sale?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(87438,'My brother must be brought to justice!','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(87439,'Interested in representing your guild here in Lunarfall?','Interested in representing your guild here in Lunarfall?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87440,'I would like to display my guild\'s standards in the garrison.','I would like to display my guild\'s standards in the garrison.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(87441,'I would like to remove my guild\'s standards from the garrison.','I would like to remove my guild\'s standards from the garrison.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(87442,'More invaders?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87443,'Burners and usurpers!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87444,'How dare you enter our sacred grove.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87445,'Your body will serve us in death.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87446,'Your blood shall become sap.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87447,'Ahhh, there it is. There\'s MY artifact. How foolish of me to trust Brak with something so valuable.','',0,0,0,0,0,0,1,0,4,0,46584,0,26124),
(87448,'It\'s a shame that you\'re too late to stop me. Surrender the artifact, and I will allow you to escape with your lives.','',0,0,0,0,0,0,1,0,4,0,46585,0,26124),
(87449,'Hahahaha, so be it! IRON HORDE, ADVANCE!','',0,0,0,0,0,0,574,0,4,0,46586,0,26124),
(87450,'See what weapons I have in my arsenal!','',0,0,0,0,0,0,603,0,4,0,46587,0,26124),
(87451,'You will never withstand the might of Goc!','',0,0,0,0,0,0,603,0,4,0,46588,0,26124),
(87452,'RELEASE THE IRON STARS!','',0,0,0,0,0,0,273,0,4,0,46589,0,26124),
(87453,'Gronnlings, attack!','',0,0,0,0,0,0,25,0,4,0,46590,0,26124),
(87454,'ARGH... UNBELIEVEABLE! You will DIE for your insolence! I\'LL TEAR YOU LIMB FROM LIMB!','',0,0,0,0,0,0,53,0,4,0,46591,0,26124),
(87455,'NO! I will DIE before I let you take what is mine! YOU... WILL NOT... WIN... THIS... WAR! AAARRRRGHH!','',0,0,0,0,0,0,603,0,4,0,46592,0,26124),
(87456,'Hahaha! Not so confident now, are we?! Face me on even ground, cowards!','',0,0,0,0,0,0,574,0,4,0,46593,0,26124),
(87457,'','We will never surrender to you! Champion, now is the time! Use the artifact!',0,0,0,0,0,0,603,0,0,0,0,45559,26124),
(87459,'','Brace yourself, champion. The light is with you. I will not let you fall.',0,0,0,0,0,0,66,0,0,0,0,45560,26124),
(87461,'','The artifact... What has he done?! We must restore it, we must get it to safety!',0,0,0,0,0,0,603,0,0,0,0,45561,26124),
(87463,'','With pleasure.',0,0,0,0,0,0,273,0,0,0,0,45562,26124),
(87464,'','With pleasure.',0,0,0,0,0,0,273,0,0,0,0,44741,26124),
(87465,'','It is over, their defenses are shattered. We have won this battle, but without the artifact we have far to go.',0,0,0,0,0,0,6,0,0,0,0,45563,26124),
(87466,'','Let us rally back at your outpost, commander. We must plan our next course of attack.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(87467,'','It is over, their defenses are shattered. We have won this battle, but without the artifact we have far to go. Let us rally back at your outpost, commander. We must plan our next course of attack.',0,0,0,0,0,0,6,0,0,0,0,44742,26124),
(87469,'SKRAWWAWWW!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87470,'We shall rule the skies, and all the lands below them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87471,'You should have trained harder!','You should have trained harder!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87472,'Hold just a little longer!','Hold just a little longer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87473,'','Fantastic choice! I\'ll go ahead and head on to your garrison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87474,'I am needed urgently at the Iron Docks.','I am needed urgently at the Iron Docks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87475,'This won\'t be a problem.','This won\'t be a problem.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87476,'Nothing can stop us now that we have the artifact. Come, let us paint these rocks with their blood!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(87477,'','The Iron Horde have no idea how much potential lies within the artifact. Let us give them a proper demonstration, shall we?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(87478,'Gotta be careful in Gorgrond, even in the sky!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87479,'Blessings to you stranger, you have my thanks.','Blessings to you stranger, you have my thanks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87480,'At long last... freedom.','At long last... freedom.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87481,'My people.  What have they done?','My people.  What have they done?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87482,'Finally, I can find rest.','Finally, I can find rest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87483,'Prove allegiance to your guild by conquering all the dungeons in Draenor with your guild mates.  Once you complete this task, you may purchase Garrison Guild Banners from the Guild Vendor.\n\nCome see me once you have acquired the item and I will help you display guild banners in your Garrison for all to see.','Prove allegiance to your guild by conquering all the dungeons in Draenor with your guild mates.  Once you complete this task, you may purchase Garrison Guild Banners from the Guild Vendor.\n\nCome see me once you have acquired the item and I will help you display guild banners in your Garrison for all to see.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(87484,'So this is how it ends...','So this is how it ends...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87485,'If only you put up more of a fight!','If only you put up more of a fight!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87486,'You call that fighting?','You call that fighting?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87487,'Go! I\'ll cover you!','Go! I\'ll cover you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87488,'Hold just a little longer!','Hold just a little longer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87489,'We stand together! We fight as one!','We stand together! We fight as one!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87491,'First one to fifty kills wins!','First one to fifty kills wins!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87492,'C\'mon then! Battles don\'t start every day, you know!','C\'mon then! Battles don\'t start every day, you know!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87493,'Follow my lead!','Follow my lead!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87494,'To battle!','To battle!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87495,'Hold the line! Do not let the Iron Horde break your ranks!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87496,'Push back the Iron Horde with all your strength!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87502,'Fight with courage and victory will be ours!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87503,'Teach the Iron Horde the value of cold steel!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87507,'Fight with all of your might for each inch of the battlefield!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87512,'Hold your ground! Show the Iron Horde that we will not be broken!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87513,'RRRRRRRRRrrooaaaarrr...','',0,0,0,0,0,0,0,0,0,0,42905,0,26124),
(87514,'Smash you... into mountain.','',0,0,0,0,0,0,0,0,0,0,42908,0,26124),
(87515,'','',0,0,0,0,0,0,0,0,0,0,42913,0,26124),
(87516,'','',0,0,0,0,0,0,0,0,0,0,42914,0,26124),
(87517,'May the healing mend your wounds.','May the healing mend your wounds.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87518,'My blade\'s edge will cut right through you!','My blade\'s edge will cut right through you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87519,'My strikes are swift and true.','My strikes are swift and true.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87520,'Your skills are no match for my blade.','Your skills are no match for my blade.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87521,'Feel healing\'s touch upon you.','Feel healing\'s touch upon you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87522,'Stand close! Healing is on its way!','Stand close! Healing is on its way!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87523,'Moving targets... my favorite!','Moving targets... my favorite!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87524,'You can\'t avoid my shots forever!','You can\'t avoid my shots forever!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87525,'Get behind me! Quickly!','Get behind me! Quickly!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87526,'I\'ll hold them off while you take them down!','I\'ll hold them off while you take them down!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87527,'You\'ll have to get through me first!','You\'ll have to get through me first!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87528,'Feel my spell\'s wrath!','Feel my spell\'s wrath!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87529,'I don\'t need mana to take you down!','I don\'t need mana to take you down!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87530,'I\'ve got something better than weapons - magic!','I\'ve got something better than weapons - magic!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87531,'I strike without hesitation!','I strike without hesitation!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87532,'My attacks never miss their mark.','My attacks never miss their mark.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87533,'My shield has never been broken!','My shield has never been broken!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87534,'Your attacks are no match for my armor!','Your attacks are no match for my armor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87535,'Just try to get through my shield. I dare you!','Just try to get through my shield. I dare you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87536,'Just because I have a shield doesn\'t mean you have to run!','Just because I have a shield doesn\'t mean you have to run!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87537,'Have you ever heard of Nat Pagle? No? Well come over here and let me tell you about him!','Have you ever heard of Nat Pagle? No? Well come over here and let me tell you about him!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(87538,'You have never heard of Nat Pagle? The man is a legend!\n\nNat has traveled the world over, always looking for the biggest catch! Speaking of big catches, I bet there are some huge catches for us out here in Draenor. If only we could get Nat to come out here and teach us the way...  Keep working on that fishing skill and come back to me when you are fully trained.','You have never heard of Nat Pagle? The man is a legend!\n\nNat has traveled the world over, always looking for the biggest catch! Speaking of big catches, I bet there are some huge catches for us out here in Draenor. If only we could get Nat to come out here and teach us the way...  Keep working on that fishing skill and come back to me when you are fully trained.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(87539,'You may commune with Gro the Uncreator.','You may commune with Gro the Uncreator.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87540,'What can you tell me about this \"Nat Pagle\" character?','What can you tell me about this \"Nat Pagle\" character?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(87541,'You mirin\'?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87542,'Are you Nat Pagle?  I have been looking all over for you!','Are you Nat Pagle?  I have been looking all over for you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(87543,'The Exarch Council is the \"Hand of the Prophet.\" We represent the draenei people, and act as the Prophet\'s messengers, enforcers, and conscience.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(87544,'I made it! This place is a long way from home!','I made it! This place is a long way from home!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(87545,'Let\'s go fishing!','Let\'s go fishing!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(87546,'You will pay for that!','You will pay for that!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87547,'Hold the entrance soldiers! Once the gronn lose interest we will move out!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(87548,'I\'d like to requisition my seal for the week.','I\'d like to requisition my seal for the week.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87549,'I was brave... wasn\'t I?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87550,'It just stepped on me like an ant...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87551,'What am I needed for?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87552,'Leave me... I will only slow you down... Lok\'tar...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87553,'When I heal, the gronn will pay...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87554,'Taming these gronn is stupid... we should rely on our own strength!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87555,'We will make it.  Greldrok has a way of getting out of these things...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87556,'The Laughing Skull will rise again!','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(87557,'','Rexxar is not quick to trust, is he? It is lucky that you happened upon us when you did.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(87558,'Fish fall down the waterfall and right to my bait.$B$BI hope to share my catch with Tega back at camp. She is... ferocious.','Fish fall down the waterfall and right to my bait.$B$BI hope to share my catch with Tega back at camp. She is... ferocious.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(87559,'Once I get this thing working we\'ll be able to clear-cut this island in no time flat.\n\nLasers, baby!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87560,'Trust Greldrok, he will get us out of this... mess...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87561,'Who would think so many gronn would be here? Our scouts should be broken for this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87562,'Think to take advantage of us while we recover? Think again fool!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87563,'Perhaps your corpse will distract the gronn!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87564,'We may be wounded but you will find us strong still!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87565,'We will be back... you cannot stop us...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87566,'Rally Score Earned!','Rally Score Earned!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87567,'Gorian Bruisers Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87568,'Gorian Elementalists Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87569,'Gorian Arcanists Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87570,'Gorian Mage-Lords Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87571,'Gorian Cohorts Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87572,'Gorian Sentinels Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87573,'Gorian Centurions Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87574,'Commander, Gorgrond is a hardy place. If you let it, it can shape you into a weapon.$b$BSpeak with me if you grow tired of chopping down trees.$b$BWith a bit of coin we can replace this lumber yard with a prized sparring arena.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87575,'Build the Sparring Arena instead.','Build the Sparring Arena instead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87576,'That sparring arena of yours is way too sweaty and violent for my tastes.$b$bNow, if you want something that is more practical, then I got what ye need!$b$bWe could build a big ol\' lumber yard with what I got in me mole machine.$b$bI think I even have the schematics for a goblin mechano-shredder.$b$bYou get the coin together an\' I can build it for ya.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87577,'I\'m not much use in a sparring arena. But if ya fancy a lumber yard, I\'m yer dwarf.$b$bCome see me when you are a bit more experienced an\' finished your Iron Horde vendetta.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(87578,'Build a Lumber Yard instead.','Build a Lumber Yard instead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87579,'You want a garrison.$B$BI know.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(87580,'Commander, I have no interest in lumber or the collection of wood.$b$bSee me when you have completed your tasks with the Iron Horde, and perhaps after you have gained more experience in combat.$b$bWith a bit of coin I could have this lumber yard removed and replaced with a sparring arena you would be proud of.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87581,'Create a garrison for me.','Create a garrison for me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87582,'Upgrade my garrison to the next tier.','Upgrade my garrison to the next tier.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87583,'What are you waiting for? Let\'s catch some fish!','What are you waiting for? Let\'s catch some fish!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(87584,'Can I get another Hookshot Bait?','Can I get another Hookshot Bait?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(87585,'I need a set of blueprints for all of the Tier 1 and Tier 2 buildings.','I need a set of blueprints for all of the Tier 1 and Tier 2 buildings.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87586,'I need a way to finish under construction garrison buildings instantly.','I need a way to finish under construction garrison buildings instantly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87587,'','What do you need, commander?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87588,'Are you ready to join up, Nat? I can\'t wait for you to join the team!','Are you ready to join up, Nat? I can\'t wait for you to join the team!',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(87589,'Fortune shine on me.','Fortune shine on me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87590,'I could always use a little luck.','I could always use a little luck.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87591,'Couldn\'t hurt.','Couldn\'t hurt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87592,'I\'m feeling lucky!','I\'m feeling lucky!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87593,'Give me more garrison materials.','Give me more garrison materials.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87594,'I need some followers for my garrison.','I need some followers for my garrison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87595,'Take me to Stormshield in Ashran.','Take me to Stormshield in Ashran.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87596,'Nisha is willing to take you to the den of the ogron if you are in need.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(87597,'Incoming target!','Incoming target!',5,0,0,0,0,0,5,0,0,0,0,0,26124),
(87598,'Target to the northeast!','Target to the northeast!',5,0,0,0,0,0,5,0,0,0,0,0,26124),
(87599,'Target to the northwest.','Target to the northwest.',5,0,0,0,0,0,5,0,0,0,0,0,26124),
(87600,'Didn\'t stand a chance!','Didn\'t stand a chance!',11,0,0,0,0,0,11,0,0,0,0,0,26124),
(87601,'Aim!','Aim!',5,0,0,0,0,0,5,0,0,0,0,0,26124),
(87602,'Prepare to fire!','Prepare to fire!',5,0,0,0,0,0,5,0,0,0,0,0,26124),
(87603,'FIRE!','FIRE!',5,0,0,0,0,0,5,0,0,0,0,0,26124),
(87604,'BOOM!','BOOM!',5,0,0,0,0,0,5,0,0,0,0,0,26124),
(87605,'Looks like we are having seared clefthoof tonight!','Looks like we are having seared clefthoof tonight!',5,0,0,0,0,0,5,0,0,0,0,0,26124),
(87606,'I can\'t believe we are getting paid for this.','I can\'t believe we are getting paid for this.',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(87607,'Where do they keep coming from?','Where do they keep coming from?',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(87608,'','Commander! Oh wow, didn\'t expect to see you out here. Would you like to trade for some blueprints?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87609,'','Such and honor to serve you, $GSir:Madam;. Wait till I tell the others.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87610,'I\'m almost done with my shift. You want to grab a steak over at Elton Black\'s place? I heard he kills the cow right in front of you so you know it\'s fresh.','',23,0,0,0,0,0,0,0,0,0,0,0,26124),
(87611,'We don\'t have much more time! Everyone, get to high ground!','',0,0,0,0,0,0,0,0,0,923,44887,0,26124),
(87612,'Hot stuff coming through!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87613,'Cho\'gall has escaped! The city is in chaos!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87614,'Better luck next time.','Better luck next time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87615,'Coming here today was a poor choice.','Coming here today was a poor choice.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87616,'Enjoy the afterlife, $n.','Enjoy the afterlife, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87617,'Your efforts have failed you, $n!','Your efforts have failed you, $n!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87618,'$R\'s like you should know better than to challenge me.','$R\'s like you should know better than to challenge me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87619,'May your spirit rest in peace.','May your spirit rest in peace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87620,'Prepare to battle the ogres.','Prepare to battle the ogres.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87621,'Prepare to battle the ogres.','Prepare to battle the ogres.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87622,'Prepare to battle the Gorens.','Prepare to battle the Gorens.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87623,'Prepare to battle the Iron Horde.','Prepare to battle the Iron Horde.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87624,'Prepare to battle the Primals.','Prepare to battle the Primals.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87625,'Sergeant, ogres storm toward our front gate.','Sergeant, ogres storm toward our front gate.',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(87626,'What\'s that sound? It\'s like a stampede...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87627,'Sound the alarm! Prepare for a frontal assault!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87628,'To arms! To your posts! Our fight today is with ogres.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87629,'Stand firm, soldiers. Draenor ogres are not unlike Azeroth\'s.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87630,'Remember when they die, don\'t let them fall on you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87631,'No more at the front gate....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87632,'Spread out! Protect the structures!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87633,'That took care of the lesser ogres.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87634,'Is he going to fit through the gate? Charge! For the Alliance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87635,'What the... THIEF!','What the... THIEF!',603,0,0,0,0,0,603,0,0,0,0,0,26124),
(87636,'Whoa! You are here too? Phew... I was starting to think I made a bad call. I\'m ready to win this war for the Alliance, $GSir:Madam;!','',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(87638,'','You know I\'m a vegetarian right?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(87639,'You will not join the red? Then you will die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87640,'The inn is this way, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87641,'I will show them! I will show them all my power!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87642,'','Welcome, commander. Please let me know if there is anything I can do to make your stay more comfortable.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(87643,'Just a second, pal. Can\'t you see I\'m busy here?','',6,0,0,0,0,0,0,0,0,28519,0,0,26124),
(87644,'We have come far since our journey began, but we always have more to do.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87645,'May the Raven Mother keep you under her wing!','May the Raven Mother keep you under her wing!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87646,'Praise the Raven Mother!','Praise the Raven Mother!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87647,'The Raven Mother bless you!','The Raven Mother bless you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87648,'%s emerges!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(87649,'','Speak with Dungar when you are ready to fly to Ashran.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87650,'Come one, come all. Witness fights to the death in the one and only Ring of Blood! Today we have $n and $Ghis:her; pals foolishly going up against Skull Chewer! Time for some more skulls, buddy!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(87651,'Let the fight begin!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(87652,'Me grandpa Gygax trained me when I was just a lad. Ye won\'t be finding a better warrior in these parts. I can promise ye that.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87653,'Everyone is a little on edge with the Iron Horde\'s presence looming. Your visit here is much appreciated.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87654,'Delvar Ironfist is just up the hill. He\'s surly, but his passion for battle is palpable.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87655,'It\'s that time again, folks. Come watch hopeful gladiators lay their lives on the line for your enjoyment! This match will be $n and $Ghis:her; friends against the impenetrable Fracktus! No weapon can pierce his granite hide!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(87656,'Just point me in the direction of the Iron Horde. I\'ll take care of the rest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87657,'Once the mages opened up the portal from Stormwind this place really started to boom. We probably have the greatest assembly of vendors and trade goods this side of Draenor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87658,'Lieutenant Howell has done an excellent job pulling this staging area together.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87659,'Lieutenant Howell is just inside. It\'s been a pleasure serving you, commander.','',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(87660,'Dead $Gman:woman; walking, folks. $n and $Ghis:her; allies are entering the world famous Ring of Blood to test themselves versus Rotvine, living weapon of destruction! This will be a slaughter to see!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(87661,'$n and $Ghis:her; allies want to prove their worth against Mogor\'s prize beast: Dreshax, the Corpse Mauler! This worm has consumed the bones of countless fallen hopefuls - can $n come out of this alive?','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(87662,'No! He will awaken!','',0,0,0,0,0,0,0,0,0,0,43600,0,26124),
(87663,'We have not yet purified the water!','',0,0,0,0,0,0,0,0,0,0,46515,0,26124),
(87664,'We are all... doomed.','',0,0,0,0,0,0,0,0,0,0,43968,0,26124),
(87665,'The bindings no longer hold me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87666,'Now all shall die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87667,'Life essence...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87668,'No! Stay back!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87669,'','Let\'s see your skill at arms!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87670,'Ah, a $c. Would you like to participate in today\'s lecture?$b$bI am in need of a volunteer.','',274,1,0,0,0,0,0,0,0,0,0,0,26124),
(87671,'Volunteer.','Volunteer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87672,'Thank you, commander.','Thank you, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87673,'Commander.','Commander.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(87674,'We shall use the orb to contact Anzu. But first, I believe its power can help us save lives here...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87675,'What have they... done to me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87676,'The voices... they\'re stopping...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87677,'The fog is lifting... where am I?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87678,'Thank you... I can still walk.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87679,'My wings! My beautiful wings!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87680,'They will pay for this...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87681,'This power... I must have more!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87682,'Sethe has chosen me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87683,'I am reborn...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87684,'A new way... yes...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87685,'I see my fate...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87686,'Bwagh! Your face makes me ANGRY!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87687,'Rargh!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87688,'I\'m going to crush you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87689,'Grarrgh! Your skull needs crushing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87690,'I\'m gonna punch your head in!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87691,'Grargh! Crush the weakling!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87692,'I hope you like dying! GRAAGH!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87693,'Now I gonna break you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87694,'Boss, I got the recent threats sketched out on the table for ya whenever you be ready.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(87695,'It\'s in my head, $p! I can\'t control myself! Kill me before I spread the disease!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87696,'Ogres and ogrettes, history is being made today at the world famous Ring of Blood! Mogor, reigning champion of the ring, is going to defend his title against the likes of $n and $Ghis:her; friends. This will be a fight to see!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(87697,'We must hurry, $p! I have to get there now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87698,'You dare challenge me in MY arena? You are a fool.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(87699,'I will make you beg for mercy, and will show you none.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(87700,'Pour it on!','Pour it on!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87701,'Reminds me of that Stranglethorn campaign, years ago.','Reminds me of that Stranglethorn campaign, years ago.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87702,'I feel like a gardener killing weeds.','I feel like a gardener killing weeds.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87703,'MEATBALL GETTING HUNGRY!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87704,'MEATBALL READY TO FIGHT!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87705,'MEATBALL KILL!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87706,'These plants remind me of Orgrimmar....','These plants remind me of Orgrimmar....',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87707,'MEATBALL WANT TO FIGHT YOU!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87708,'MEATBALL EAT WHAT MEATBALL WANT!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87709,'They\'re weakening.','They\'re weakening.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87710,'MEATBALL KILL WHAT MEATBALL WANT!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87711,'MEATBALL NO LOSE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87712,'','There is still so much we do not know about this world. The Iron Horde have been here far longer than we, and their allies have lived here for generations.$B$BThey know more about this artifact\'s powers than we do. If we are to succeed, we must press every advantage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87713,'MEATBALL GET SNACK NOW!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87714,'MEATBALL READY TO FIGHT!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87715,'MEATBALL HUNGRY!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87716,'MEATBALL BELLY GURGLE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87717,'MEATBALL TUMMY RUMBLE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87718,'MEATBALL LIKE TO FIGHT!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87719,'BURP...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87720,'|TInterface\\Icons\\Spell_Arcane_Blink:20|t%s casts |cFFFF0000|Hspell:163359|h[Arcane Fragment]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87721,'|TInterface\\Icons\\Spell_Arcane_Arcane04:20|t%s casts |cFFFF0000|Hspell:163372|h[Arcane Volatility]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87722,'','You\'ll regret this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87723,'','This garrison will not fall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87724,'','I wield powers from beyond.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87725,'','Taste my power.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87726,'','Step back before I turn you to ash!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87727,'','Taste the fury of the sun!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87728,'','For the Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87729,'','Come closer... and burn!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87730,'','Nice try.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87731,'','You deserved that.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87732,'','One down.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87733,'','Who\'s next?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87734,'','You do not belong!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87735,'','For the Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87736,'','I tried to warn you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87737,'|TInterface\\Icons\\Spell_Arcane_FocusedPower:20|t%s casts |cFFFF0000|Hspell:163297|h[Arcane Twisted]|h|r at $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87738,'','You are weak.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87739,'','Bal\'a dash, malanore.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87740,'','Anu belore dela\'na.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87741,'','I am yours to command.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87742,'','This is not the version of this world I know.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87743,'','My power is yours, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87744,'','I am sworn to you, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87745,'','Andu fallah.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87746,'','Our destiny awaits, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87747,'','It\'s so... cold...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87748,'','For Auchindoun!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87749,'','You do not belong here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87750,'','Souls of Auchenai past, guide my hand!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87751,'','A million draenei souls stand by my side, fiend.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87752,'','We\'re under attack. Protect the unarmed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87753,'','I will not let you harm the innocent.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87754,'','Step no further!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87755,'','I won\'t let you take another innocent life!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87756,'','Your soul was too weak.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87757,'','You do not deserve the gift of life.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87758,'','Be gone with you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87759,'','Such dark souls.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87760,'','Ashes to ashes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87761,'','Your soul departs this realm.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87762,'','Forever hold your peace, heathen.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87763,'Ride Nisha to your outpost.','Ride Nisha to your outpost.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87764,'','Dust to dust.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87765,'','Your soul burns brightly as always!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87766,'','How go your exploits?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87767,'','At your service.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87768,'','The spirits smile upon you, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87769,'','Anything I can help you with?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87770,'','Together we will never falter against the darkness.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87771,'','The Light guides us always, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87772,'','It\'s good to see you, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87773,'','Auchindoun... I am coming...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87774,'For $p! Charge!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87775,'Show me what you\'ve got.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87776,'Maybe you\'ll put up an actual fight.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87777,'Form up! We\'ve got company.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87778,'Brace yourselves. Hostiles incoming!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87779,'You will go no further!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87780,'We fight for the Alliance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87781,'I will show you no quarter, fiend!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87782,'Not on my watch.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87783,'This garrison will not fall!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87784,'None can stand against the might of the Alliance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87785,'Over my dead body.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87786,'Victory shall be ours today!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87787,'For $p. For the Alliance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87788,'You\'ll have to try harder than that.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87789,'Another one bites the dust.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87790,'Good to see you, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87791,'Our enemies stand no chance against the both of us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87792,'At your service, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87793,'Care to swap some old war stories?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87794,'Any sign of the Horde?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87795,'For the Alliance, always and forever.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87796,'The Light guides us to victory.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87797,'I\'ll fight by your side through anything.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87798,'The Alliance... will live on...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87799,'New plaything!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87800,'Know the might of the Iron Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87801,'Who interrupts the harvest?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87802,'These savages will eat anything!','These savages will eat anything!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87803,'To arms! To arms!','To arms! To arms!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87804,'Danger is close!','Danger is close!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87805,'Get the townsfolk to safety.','Get the townsfolk to safety.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87806,'I want to recruit guards from other lands.','I want to recruit guards from other lands.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87807,'If you are exalted by Ironforge, Darnassus, Gnomeregan, Exodar, Gilneas, the Tushui pandaren, or if you are a Death Knight exalted by the Knights of the Ebon Blade, you can recruit guards from their respective ranks by speaking to the corresponding recruiting officer in the Town Hall.','If you are exalted by Ironforge, Darnassus, Gnomeregan, Exodar, Gilneas, the Tushui pandaren, or if you are a Death Knight exalted by the Knights of the Ebon Blade, you can recruit guards from their respective ranks by speaking to the corresponding recruiting officer in the Town Hall.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87808,'Graveltooth gonna make you sorry for hurting the munchkins! Rarrggh!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(87809,'Grrrggh! Graveltooth no like it when you kill the munchkins!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(87810,'The Raven Mother watches over the flock once again!$b$bWe could not have done this without you, $n.$b$bWe will always remember the outsider who helped us in our time of need.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87811,'MEATBALL GETTING TIRED!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87812,'MEATBALL STILL HUNGRY!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87813,'MEATBALL BUTT ITCHY!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87814,'MEATBALL VOICE HURT MEATBALL EAR!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87815,'MEATBALL READY TO STOP FIGHTING!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87816,'Dis\' is a big one, mon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87817,'I\'ll gut ya like a fat eel!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87818,'You take da bait, I reel ya in!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87819,'Dis one\'s a fighta!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87820,'You gon\' be bait for my next big catch!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87821,'Lookin\' like we got some more chum!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87822,'No catch and release for you, mon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87823,'I could kill a hundred of you at once!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87824,'This can hardly be called a battle...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87825,'I will end your worthless life!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87826,'Your pathetic life is over.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87827,'Your death will be forgotten quickly...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87828,'Barely worth the effort.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87829,'You wanna know da\' secret to catching the lunkers mon? Voodoo!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87830,'Catch anything lately, boss man?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87831,'This camp could use discipline, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87832,'','Hey stranger! I\'m good at fixing stuff. Do you want me to take a look?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87833,'','Someday I\'m going to be a hero, too!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87834,'Give me troops, commander, and I will give you the Gorian Empire!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87835,'Been workin on a new rod, mon, but I can\'t think of a good name. Maybe \"Abu\'gar\'s Vivaciousness?\"','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87836,'You have orders, sir?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87837,'Nothin\' doin\' today, mon. I guess that\'s why they call it fishin\' and not catchin\'.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87838,'Is there a foe worth crushing, commander?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87839,'You wanna know da best way ta fish? Trollin\'.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87840,'My line neva break, mon. I be makin it from braided Dwarf beard hair.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87841,'To die so far... from home...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87842,'Not the end... I had imagined...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87843,'It... got... away...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87844,'','After seeing you and Rexxar in action, I hope to learn more of combat from each of you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(87845,'Rarrgh! You kill munchkins and Graveltooth gonna kill you back!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(87846,'Die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87848,'You\'ll make a fine meal for the ravagers.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87849,'Kill!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87850,'I\'m searching for Owynn Graddock. Take me to Frostfire Ridge.','I\'m searching for Owynn Graddock. Take me to Frostfire Ridge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87851,'Take me to Ashran.','Take me to Ashran.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87852,'Face me, and we will see who is stronger.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(87853,'My new Blood Champion has been crowned. Bow before $n, for $Ghe:she; has proven $Ghimself:herself; worthy of my favor in the arena.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(87854,'Enough! I will not stand by and watch my prized beasts fall. I will show them true strength.','',0,0,0,0,0,0,1,0,1,32359,0,0,26124),
(87855,'Much thanks again, mon, for gettin\' me back my gear. \n\nNow da fishes don\'t stand a chance against Abu\'gar!','',0,0,0,0,0,0,0,0,0,28630,0,0,26124),
(87856,'For the light of Karabor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87857,'My hammer should suffice.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87858,'Don\'t underestimate me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87859,'Justice prevails.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87860,'Not on my watch.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87861,'You have been defeated!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87862,'I serve you, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87863,'Do you need anything fixed, commander?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87864,'I should have... tried... harder...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87865,'','On guard!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87866,'','It\'s a nice day for a fight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87867,'','Do you challenge me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87868,'','I hope you\'re ready for this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87869,'','That was easy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87870,'','I didn\'t even break a claw.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87871,'','And stay down!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87872,'','Greetings from Elune, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87873,'','May the stars shine upon you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87874,'','A beautiful day awaits us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87875,'','Ugh... it wasn\'t... enough...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87876,'','Give me your best shot.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87877,'','Do you think you can take me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87878,'','I know a dirty trick or two.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87879,'','Hmm, just as I thought.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87880,'','I made quick work of you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87881,'','Let that be a lesson to you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87882,'','Think twice before crossing me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87883,'','My skills are at your disposal, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87884,'','I am ready to serve.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87885,'','Do you have a mission for me, commander?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87886,'','I... did not... expect that...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87887,'','I will try my best!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87888,'','Let\'s fight fair!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87889,'','We did it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87890,'','That wasn\'t so bad!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87891,'','All right!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87892,'','That was a close one!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87893,'','Good day, commander!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87894,'','What shall we do today?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87895,'','Today is a beautiful day for an adventure.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87896,'','Ouch...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87897,'','Patience, sisters. The sooner we finish our work, the sooner we crush our enemies.',0,0,0,0,0,0,0,0,0,0,0,41824,26124),
(87898,'','Sorka! Ensure the peons are keeping pace!',0,0,0,0,0,0,0,0,0,0,0,41825,26124),
(87899,'','Marak! Load the ammunition into the main cannon!',0,0,0,0,0,0,0,0,0,0,0,41826,26124),
(87900,'','What?! The trains are behind schedule?',0,0,0,0,0,0,0,0,0,0,0,41827,26124),
(87901,'','Sorka! This isn\'t a game! Get down there!',0,0,0,0,0,0,0,0,0,0,0,41828,26124),
(87902,'','You insufferable...',0,0,0,0,0,0,0,0,0,0,0,41829,26124),
(87903,'Ohh, that\'s how you sweep the leg!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87904,'','Sisters, to battle!',0,0,0,0,0,0,0,0,0,0,0,41830,26124),
(87905,'','Sisters, I... failed...',0,0,0,0,0,0,0,0,0,0,0,41831,26124),
(87906,'Maybe I\'m not cut out for this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87907,'I hope they don\'t catch me with this manual...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87908,'I can\'t wait to get my first real set of armor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87909,'','None will stand against the Iron Horde!',0,0,0,0,0,0,0,0,0,0,0,41832,26124),
(87910,'I\'ll show them what I\'m made of. I\'ll prove them all wrong!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87911,'','Enemy down.',0,0,0,0,0,0,0,0,0,0,0,41833,26124),
(87912,'','Grenade out!',0,0,0,0,0,0,0,0,0,0,0,41834,26124),
(87913,'','You will burn!',0,0,0,0,0,0,0,0,0,0,0,41836,26124),
(87914,'','Lining up my sights...',0,0,0,0,0,0,0,0,0,0,0,41837,26124),
(87915,'','Blood and Thunder!',0,0,0,0,0,0,0,0,0,0,0,41838,26124),
(87916,'','Rapid fire!',0,0,0,0,0,0,0,0,0,0,0,41839,26124),
(87917,'','... than battle to death!',0,0,0,0,0,0,0,0,0,0,0,41840,26124),
(87918,'','Sorka! Man the cannon!',0,0,0,0,0,0,0,0,0,0,0,41841,26124),
(87919,'','Marak! Let your aim be true.',0,0,0,0,0,0,0,0,0,0,0,41842,26124),
(87920,'','Must I do everything myself?!',0,0,0,0,0,0,0,0,0,0,0,41843,26124),
(87921,'','My pleasure.',0,0,0,0,0,0,0,0,0,0,0,41851,26124),
(87922,'','I think I see the problem...',0,0,0,0,0,0,0,0,0,0,0,41852,26124),
(87923,'','Let\'s see how well you\'ve trained our soldiers, Gar\'an.',0,0,0,0,0,0,0,0,0,0,0,41853,26124),
(87924,'','Ha! What brutality, what bloodshed... Beautiful!',0,0,0,0,0,0,0,0,0,0,0,41854,26124),
(87925,'','Don\'t worry, I\'m coming... this looks fun.',0,0,0,0,0,0,0,0,0,0,0,41855,26124),
(87926,'','I\'m going to enjoy this...',0,0,0,0,0,0,0,0,0,0,0,41856,26124),
(87927,'','It feels... so...',0,0,0,0,0,0,0,0,0,0,0,41857,26124),
(87928,'','Oh, look. I broke it.',0,0,0,0,0,0,0,0,0,0,0,41858,26124),
(87929,'','I\'m just too good.',0,0,0,0,0,0,0,0,0,0,0,41859,26124),
(87930,'','Come closer!',0,0,0,0,0,0,0,0,0,0,0,41860,26124),
(87931,'','Too slow!',0,0,0,0,0,0,0,0,0,0,0,41861,26124),
(87932,'','Catch!',0,0,0,0,0,0,0,0,0,0,0,41862,26124),
(87933,'','You...',0,0,0,0,0,0,0,0,0,0,0,41863,26124),
(87934,'','...die now!',0,0,0,0,0,0,0,0,0,0,0,41864,26124),
(87935,'','All will burn!',0,0,0,0,0,0,0,0,0,0,0,41865,26124),
(87936,'','No greater pleasure...',0,0,0,0,0,0,0,0,0,0,0,41866,26124),
(87937,'','Right.',0,0,0,0,0,0,0,0,0,0,0,41710,26124),
(87938,'','Time to die.',0,0,0,0,0,0,0,0,0,0,0,41711,26124),
(87939,'','My... blood...',0,0,0,0,0,0,0,0,0,0,0,41712,26124),
(87940,'','Feast, Koloch na!',0,0,0,0,0,0,0,0,0,0,0,41713,26124),
(87941,'','I win.',0,0,0,0,0,0,0,0,0,0,0,41714,26124),
(87942,'','Koloch na, wind and blood!',0,0,0,0,0,0,0,0,0,0,0,41715,26124),
(87943,'','Dance with my blade!',0,0,0,0,0,0,0,0,0,0,0,41716,26124),
(87944,'','Death...',0,0,0,0,0,0,0,0,0,0,0,41717,26124),
(87945,'','Ancestors, guide my axe...',0,0,0,0,0,0,0,0,0,0,0,41718,26124),
(87946,'','You will know pain...',0,0,0,0,0,0,0,0,0,0,0,41719,26124),
(87947,'','Lok\'tar ogar!',0,0,0,0,0,0,0,0,0,0,0,41720,26124),
(87948,'What kind of fish is that? I have never seen anything like that before, get over here and let me check it out!','What kind of fish is that? I have never seen anything like that before, get over here and let me check it out!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(87949,'','I\'ll take you down!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87950,'','Your death will be swift.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87951,'','I won\'t go easy on you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87952,'','Just as you deserved.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87953,'','The darkness closes in.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87954,'','Do you need any killing, commander?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87955,'','Send me to the front lines, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87956,'','My blade is at your call.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87957,'','Jarrod... I will be with you... soon...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87958,'','Do you seek your own death?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87959,'','The eve of your demise is here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87960,'','I\'m looking forward to this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87961,'','Another kill.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87962,'','An honorable fight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87963,'','Well fought, but not well enough.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87964,'','Honor to you, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87965,'','Can I be of service today?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87966,'','The elements are calling.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87967,'','I was not strong... enough...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87968,'I\'m your worst nightmare!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87969,'If it bleeds, we can kill it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87970,'I will terminate you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87971,'It\'s showtime.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87972,'You\'ve just been erased.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87973,'','My wrench, your face.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87974,'Just plain zero.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87975,'Well that hit the spot.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87976,'','This is REALLY going to leave a mark.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87977,'Iced that guy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87978,'Who needs slaying, commander?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87979,'Today could use a little mayhem, what do you say?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87980,'','I don\'t go down that easily.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87981,'Just point me at any ogres. I\'ll carve \'em up for you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87982,'','Disassembly, required.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87983,'Good to see you again, sir.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87984,'','Oops, I did it again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87985,'When\'s the next battle, commander?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87986,'','Sometimes I amaze even myself.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87987,'I\'ll be back...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87988,'','Got any business leads today?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87989,'','Come on, I\'m getting bored here. You have anything for me to do?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87990,'','So what do you prefer, gunpowder or napalm? Me, I\'m a napalm girl.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87991,'','What\'s up, commander?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87992,'','Hey there commander, you here to give me a job or can we just skip straight to you giving me money?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87993,'','Up... yours...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87994,'','You march towards your grave.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87995,'','Beautiful death awaits you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87996,'','Revel in your final moments.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87997,'','Death is only the beginning.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87998,'','Welcome to the Dark Lady\'s embrace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(87999,'','The Dark Lady sends her regards.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88000,'','Anything that needs killing, commander?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88001,'','Any new assignments?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88002,'','At your service, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88003,'','Good evening, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88004,'','Lovely evening for some killing, don\'t you think?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88005,'','My staff is yours to command.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88006,'','Death will come... to you too...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88007,'Lok\'tar ogar!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88008,'Taste my blade.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88009,'You too will die by my blade.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88010,'Come, face me if you can.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88011,'This is a waste of my time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88012,'Don\'t you know death by sight?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88013,'Finally, something to kill.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88014,'This will be quick','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88015,'You were not worthy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88016,'Is there no one to challenge me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88017,'Your blood dishonors my blade.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88018,'At least you didn\'t run.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88019,'I salute you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88020,'A clean death was more than you deserved.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88021,'Anyone else?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88022,'I yearn for a true adversary.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88023,'It\'s good to see you again, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88024,'Lok-Regar. I am ready for something new.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88025,'Throm-Ka, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88026,'I miss the grassy plains of Nagrand.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88027,'My blade hungers.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88028,'Honor is everything.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88029,'Any news of the Burning Blade?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88030,'How long must we stay in this \'garrison\' of yours?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88031,'It was... an... honor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88032,'Leeroooooooy! Jeeeeenkins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88033,'Time\'s up. Let\'s do this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88034,'Great job, guys!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88035,'Sorry, did you say something?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88036,'Uh, what did you say?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88037,'We are pals for life.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88038,'It\'s not my fault.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88039,'At least I have chicken.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88040,'Stick to the plan, chums!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88041,'You seem surprised to see us here, $C. It is understandable. I am all too familiar with how the arakkoa have treated your people.\n\nThe Adherents of Rukhmar are savage creatures, and their lust for power can only lead to their downfall. We seek a different path.\n\nWe search for artifacts of the Apexis so that we may use them to initiate a peaceful new beginning for the arakkoa. In exchange for these relics, we offer finely crafted goods, which we hope you will find equal in value.\n\nWould you see it fit to aid us, $C?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88042,'','Don\'t be scared Rosie, we are safe here.',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(88043,'Only da very best be fightin\' in the ring.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88044,'Find respite in the shadows.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88045,'','Shut your mouth, goblin, unless you want me to shut it for you. I just want a taste of this one\'s skill.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88046,'Hey! No registered contenders in the ring, please!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(88047,'','Someday, your blood will coat its edge. It is only a matter of time.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88048,'I greet you, $C. We are the Order of the Awakened, and we represent the best interests of the arakkoa people.\n\nI am certain that you have witnessed the horrors brought upon the arakkoa and others by the Adherents of Rukhmar. We wish to reverse this damage and bring about a peaceful new era for our society. To do this, however, we require the knowledge of the Apexis.\n\nIf you wish to assist us, we will trade valuable items for any Apexis relics you happen upon. What say you, $C?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88049,'Lieutenant Kragil is just inside. It\'s been a pleasure serving you, commander.','',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(88050,'','Everyone is a little on edge with the Iron Horde\'s presence looming. Your visit here is much appreciated.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88051,'Commander! Oh wow, didn\'t expect to see you out here. While you\'re here, you wanna trade for some blueprints?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88052,'Boss-mon! Ya here too? Phew... I was startin\' ta tink I made da bad call. Let\'s win dis war for da Horde!','',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(88053,'','It is done! As for you, I think it is fitting that one of my tools dispatches the others...',0,0,0,0,0,0,0,0,6,0,0,43644,26124),
(88058,'','Vivianne is just down the hill. She\'s a bit of a pyro, but her passion for battle is palpable.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88059,'','Welcome, commander. Please let me know if there is anything I can do to make your stay more comfortable.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88060,'This is almost too easy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88061,'An Imperial battalion would be done with this fight already!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88062,'The Emperor protects me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88063,'No formations... no tactics... this is a brawl, not a battle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88064,'','If you play with me, you are playing with fire... literally.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88065,'And that\'s... one hundred.','',0,0,0,0,0,0,0,0,0,0,44513,0,26124),
(88066,'','As you wish, commander. The Iron Horde will suffer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88067,'If only you had some skill.','If only you had some skill.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88068,'Such a pity.','Such a pity.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88069,'And to think... that could have been me.','And to think... that could have been me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88070,'A most unfortunate end.','A most unfortunate end.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88071,'Your sacrifice is a valuable lesson to us all.','Your sacrifice is a valuable lesson to us all.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88072,'My regards.','My regards.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88073,'A noble sacrifice.','A noble sacrifice.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88074,'May you rest in pieces.','May you rest in pieces.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88075,'','For the fallen!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88076,'','This\'ll be easier than working the forge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88077,'','In memory of Ared!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88078,'','I will not let you pass!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88079,'','Begone!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88080,'','Shoddy equipment, shoddy fighting.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88081,'','With gear that poor I\'m not surprised you lost.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88082,'','And stay down!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88083,'','Hello commander. Do you have need of my skills?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88084,'','My skills are at your command.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88085,'','Does this weapon match my horns? I\'m trying to color coordinate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88086,'','This beats working at a forge in some dusty old city.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88087,'','Ared, I join you... at last...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88088,'Really? You\'re going to fight me with THAT? Hah!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88089,'Time to test my latest weapon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88090,'Pathetic.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88091,'Nothing worth looting here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88092,'Didn\'t even leave a scratch on my weapon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88093,'Need me to make you anything?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88094,'Forge or field, commander?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88095,'Seen any sign of the Iron Horde? I could use their gear for scrap metal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88096,'Not... yet...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88097,'STOP. There is no courage in attacking others here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88098,'What\'s wrong with you?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88099,'A Warrior of the Light will not just sit and take it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88100,'Hrgraaah!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88101,'I have no choice!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88102,'You are quite stubborn.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88103,'Ohh, ohhh...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88104,'In your last moments, think upon what you have accomplished.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88105,'In the name of the Light!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88106,'Now you shall know the brilliance of our Light!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88107,'Yes, I did it... I did!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88108,'I am the Light!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88109,'Hah hah hah!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88110,'Ahh, it\'s over...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88111,'Exhilarating, is it not?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88112,'This place is sacred and you are NOT welcome here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88113,'Magnificent!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88114,'Praise the Light!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88115,'No need to hide your reaction. I get that look all the time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88116,'We are surrounded by strange beings, in a strange land...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88117,'The flow of time itself is twisted...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88118,'Let us engage in joyous collaboration!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88119,'If only I could be so utterly luminescent!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88120,'I am honored to have found such a brave companion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88121,'You really are fond of conversing with me, aren\'t you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88122,'Ahh, it\'s over...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88123,'My light... it\'s fading...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88124,'It\'s dark, so dark...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88125,'Miss Chi-Yuan possesses a talent in inscription which I can only hope to one day achieve.\n\nIf you wish to be trained on the subject, there is no finer instructor than she.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88126,'I am not finished!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88127,'For my family!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88128,'I will not let you attack this place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88129,'I have unfinished business.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88130,'You do not belong here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88131,'I will not falter!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88132,'Commander, enemies over here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88133,'You will not leave this place alive.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88134,'I\'ll see you on the other side.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88135,'Join me in the spirit realm.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88136,'Your kind will plague this world no longer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88137,'What did you expect to do, kill me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88138,'My spirit stands strong!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88139,'Is that all you\'ve got?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88140,'Put some effort into it at least.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88141,'My family will no longer live in fear of the likes of you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88142,'Greetings, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88143,'I will not rest until the Iron Horde is destroyed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88144,'I am in your debt, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88145,'We will defeat the Iron Horde together, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88146,'Any sign of the Iron Horde, commander?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88147,'Blademaster Bralok will torment my family no longer, thanks to you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88148,'I am bound to you, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88149,'It is calm, commander. Too calm.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88150,'Peace... at last...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88151,'Give Rooby Roo a Rooby Reat.','Give Rooby Roo a Rooby Reat.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88152,'Cut!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88153,'Thrust!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(88154,'Block!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(88155,'Tell me what you know!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88156,'HA! So much fun to torture you weaklings.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88157,'I take such pleasure in my job.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88158,'The local draenei have been indispensable allies in our fight here in Ashran. \n\nSo long as we keep a steady stream of supplies from the mainland, our victory is assured!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88159,'','Your cause on Ashran is just, and the draenei will assist in any way we can.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88160,'People always wonder how a Worgen becomes a stablehand, but the truth is, I\'ve been doing this long before I got afflicted. Just leave your pets with ol\' Orville and I\'ll take good care of them.\n\nAnd before you ask, yes, I promise I won\'t eat them.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88161,'Let us get to work.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88162,'In killing Sethe, Anzu was the first to bear his dying curse.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88163,'As he grappled with the curse, Anzu commanded his dread ravens to eradicate the brood of Sethe.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88164,'$gSir:Ma\'am;, I have some recent threats sketched out on the map here whenever you\'re ready.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88165,'|cFF3ADF00+5% Progress!|r','|cFF3ADF00+5% Progress!|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88166,'You are afflicted with |TInterface\\Icons\\spell_burningbladeshaman_molten_torrent.blp:20|t |cFFFF0404|Hspell:154938|h[Molten Torrent]|h|r!','You are afflicted with |TInterface\\Icons\\spell_burningbladeshaman_molten_torrent.blp:20|t |cFFFF0404|Hspell:154938|h[Molten Torrent]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88167,'Pleasure-Bot 8000, engaging.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88168,'Your systems appear to be malfunctioning.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88169,'Activating defense mechanisms.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88170,'Intruder!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88171,'In the name of my Commander!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88172,'Your skills were found to be lacking.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88173,'Target deactivated.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88174,'The pleasure was mine.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88175,'Your service is no longer required.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88176,'I was made to serve!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88177,'Need some assistance?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88178,'Greetings, commander. May I interest you in a massage?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88179,'Greetings! Allow me to assist you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88180,'It\'s my... pleasure to serve you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88181,'Commander, your clothing appears to be dirty. Allow me to clean them for you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88182,'Entering shutdown mode...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88183,'Systems... overload...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88184,'Pl... pleas... pleasure serving...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88185,'My people have been held captive for too long by these creatures.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88186,'In one bloody night, the children of Sethe were eradicated.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88187,'','Hey! Wadda ya think ya doin\' here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88188,'','I may be small, but I pack a punch!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88189,'','I knew I shoulda brought some dynamite!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88190,'It seems the wind serpents, like their master, refuse to stay dead.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88191,'','Looks like someone needs some explodin\'!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88192,'','Hey, you! Over here, busta!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88193,'','Kaaa-blooouuiiieeeee!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88194,'','Ha ha ha ha! Another one down!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88195,'','Shoulda stayed home today, friend!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88196,'','Woah... that had to hurt!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88197,'','Add another to my tally.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88198,'','Don\'t let the eye patch fool ya. I see everything!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88199,'','Need somethin\', commander?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88200,'','Hey there!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88201,'','This... ain\'t... over...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88202,'','Always figured I\'d go out with a bang...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88203,'Sorry hon, we need more room in this place before we start considering what else to build.  Come back once you upgrade to tier 2, then we can talk specifics.','Sorry hon, we need more room in this place before we start considering what else to build.  Come back once you upgrade to tier 2, then we can talk specifics.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88204,'Sorry boss, Gazlowe says this place needs to be bigger before we think about remodeling.  Come back once you upgrade to tier 2 and I will show ya what I got.','Sorry boss, Gazlowe says this place needs to be bigger before we think about remodeling.  Come back once you upgrade to tier 2 and I will show ya what I got.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88205,'Soaking','Soaking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88206,'Are you ready for a real battle?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88207,'I am ready!','I am ready!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88208,'Scaly vermin!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88209,'I am at your service, $g master:mistress;.','',2,0,0,0,0,0,0,0,0,0,0,0,26124),
(88210,'Phylarch, I need more Everbloom seeds.','Phylarch, I need more Everbloom seeds.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88211,'Out of seeds?$B$BIn exchange for the timber you are stealing from the land I will grant you another packet.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(88212,'','Light \'em up!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88213,'No, the ritual doesn\'t go like that! Try again.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88214,'Wrong! Every mistake weakens the ritual. Quickly, do what I said and we might be able to salvage this.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88215,'By the Raven Mother... are you paying attention? Try again.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88216,'No, that isn\'t right. Let\'s try again.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88217,'Put your backs into it!','Put your backs into it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88218,'Blackhand won\'t stand for this pace! Pick it up!','Blackhand won\'t stand for this pace! Pick it up!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88219,'DIG! DIG! We need this ore!','DIG! DIG! We need this ore!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88220,'Good work men! Keep it up!','Good work men! Keep it up!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88221,'Prepare to battle the Shadow Council.','Prepare to battle the Shadow Council.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88222,'Prepare to battle the Shadow Council.','Prepare to battle the Shadow Council.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88223,'Stealth Detection Systems Online. Invisibility Flare Booting up...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88224,'Systems Shutting Down...','',0,0,0,0,0,0,0,0,0,0,40466,0,26124),
(88225,'The train doesn\'t come through here anymore... Right?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88226,'I don\'t think we should be standing on these tracks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88227,'Should we really be hanging out so close to these tracks?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88228,'','I\'m heading to your garrison, commander!',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(88229,'You follow a false king!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88230,'Cultist filth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88231,'In Terokk\'s name!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88232,'I\'ll see ya at yer garrison, commander!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(88233,'Back, you beast!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88234,'Ra-aawk! For Anzu!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88235,'Who puts wings on a snake?! Honestly!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88236,'Sorry, big fellow.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88237,'Rest well.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88238,'Look at the size of that thing! We\'d better put it down.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88239,'Let us make for the Talon Altar.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88240,'','Let us make haste to Khadgar and the others.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88241,'He\'s here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88242,'Let\'s go. Khadgar isn\'t far from here.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88243,'What can I do for you?','What can I do for you?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88244,'Your arrival is timely, mortals. The Sethekk must be stopped.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88245,'You are just in time. Witness the dark majesty of the void!','',0,0,0,0,0,0,153,0,0,0,43692,0,26124),
(88246,'','I look forward to seeing your garrison, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88247,'Come at me!','',0,0,0,0,0,0,0,0,0,0,43829,0,26124),
(88248,'My face, your mace! Wait... reverse that.','',0,0,0,0,0,0,0,0,0,0,43833,0,26124),
(88249,'Victory for me!','',0,0,0,0,0,0,0,0,0,0,43834,0,26124),
(88250,'It is a good day for a fight, eh commander?','',0,0,0,0,0,0,0,0,0,0,43865,0,26124),
(88251,'These fools think they can win? Ha!','',0,0,0,0,0,0,0,0,0,0,43869,0,26124),
(88252,'Die with honor.','',0,0,0,0,0,0,0,0,0,0,43870,0,26124),
(88253,'You have failed, Kil\'Jaeden. The orcs did not drink of Mannoroth\'s blood as you promised.','',0,0,0,0,0,0,1,0,0,28821,0,0,26124),
(88254,'We will take this world with the unending strength of the Legion. The time for subtlety has passed.','',0,0,0,0,0,0,1,0,0,28822,0,0,26124),
(88255,'Lord Mongrethod, rally your forces. The time is close at hand.','',0,0,0,0,0,0,1,0,0,28823,0,0,26124),
(88256,'It is time, Mongrethod. Gul\'dan\'s work is nearly complete.','',0,0,0,0,0,0,1,0,0,28824,0,0,26124),
(88257,'Azzakel, you will be our vanguard. Lead the charge.','',0,0,0,0,0,0,1,0,0,28825,0,0,26124),
(88258,'The draenei\'s souls will empower us. Any living orcs and draenei will become our puppets.','',0,0,0,0,0,0,1,0,0,28826,0,0,26124),
(88259,'Yes... Auchindoun will be ours. The portals are nearly ready for our full invasion.','',0,0,0,0,0,0,1,0,0,28828,0,0,26124),
(88260,'The sky will rain fire... the oceans will be filled with blood...','',0,0,0,0,0,0,1,0,0,28829,0,0,26124),
(88261,'|TInterface\\Icons\\INV_Fabric_Felcloth_Ebon.blp:20|t |cFFFF0404|Hspell:161242|h[Caustic Energy]|h|r begins to flow into $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88262,'','A penny for your thoughts.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88263,'','You\'re on the wrong side of my gun, pal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88264,'','Ready... draw!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88265,'','I\'m gonna take a shot in the dark...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88266,'','Know why they call me Clobberbottom? Because I kick butt!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88267,'','You should never have crossed me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88268,'','Know what\'s as fast as a speeding bullet? A bullet.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88269,'','Am I gonna need the big guns for this one?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88270,'','A little slow on the draw, aren\'t ya?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88271,'','My jokes killed out there!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88272,'','Gotta love the smell of gunpowder.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88273,'','A bullet is best served as fast as a speeding bullet.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88274,'','Toodles!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88275,'','Another one up in smoke!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88276,'','Who wants some?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88277,'','Not sure they were even worth the bullets.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88278,'','Heya, commander!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88279,'','Need a gunslinger?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88280,'','What\'s up?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88281,'','Sometimes I use an axe to cut down a tree. Sometimes I just blow \'em up.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88282,'','Look around your garrison and you can tell it\'s good ol\' goblin engineering!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88283,'','Say... you look like famil... oh, hiya commander!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88284,'','Talk high, talk fast, and say anything that comes to mind. Potato!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88285,'','Ain\'t it cool bein\' on Draenor? Another world to exploit... er... explore.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88286,'','That didn\'t go... as well as I hoped...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88287,'I have a crossbow pointed at yer unmentionables.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88288,'What\'ll it be, axe or crossbow?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88289,'Target practice!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88290,'You callin\' me a coward?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88291,'Looks like someone wants ta tussle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88292,'Let me axe you a question.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88293,'Don\'t be runnin\' off now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88294,'Do not fail again.','',0,0,0,0,0,0,274,0,0,28830,0,0,26124),
(88295,'What ya doin\' ya dunderhead?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88296,'Kick \'em while they\'re down!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88297,'I tol\' ya not to look at me that way.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88298,'Must\'ve been the first Dark Iron you met.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88299,'This is the last time I warn ya... err... oops.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88300,'Say hi to yer ancestors for me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88301,'Who\'s next?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88302,'Don\'t lose yer heed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88303,'Another notch for me axe.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88304,'Lumber, I hardly knew \'er!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88305,'You a fan of pubs?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88306,'Nice place ya got here, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88307,'How are ya?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88308,'Good day.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88309,'Where\'s the lavvy?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88310,'What ale\'s ya? Get it?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88311,'Cheers!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88312,'Ah, ya bastart!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88313,'I care not for your vendetta against the draenei... but their souls may still prove useful to us.','',0,0,0,0,0,0,1,0,0,28821,0,0,26124),
(88314,'I wonder what your bones will look like...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88315,'Sticks and stones will break your bones.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88316,'Xuk you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88317,'What the Xuk?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88318,'Haha! Haha! Hahahahahaha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88319,'I like killing! And bones!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88320,'You\'re boned!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88321,'What is this? A new friend for Xuk?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88322,'Just a pile of bones.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88323,'Ahahahahahaha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88324,'Time to debone this one.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88325,'You\'re Xuk out of luck.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88326,'Another skull for my collection.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88327,'Orc and draenei both will bow in fealty to the Legion. Our hordes will scorch the earth beneath them. Together, Kil\'Jaeden, we are unstoppable.','',0,0,0,0,0,0,1,0,0,28822,0,0,26124),
(88328,'Don\'t bleed too much on your bones!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88329,'Does anyone else want to kick this corpse?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88330,'Go torment my spirits.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88331,'Remember when the spirits made me talk to that magnaron? Xuk that.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88332,'Good to see your bones are still intact, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88333,'Xuk will haunt your garrison. Helpfully.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88334,'You sure you weren\'t born Laughing Skull?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88335,'Our orc pawn readies portals into the heart of Auchindoun as I speak. We will devour their souls and usher in the full might of our forces.','',0,0,0,0,0,0,1,0,0,28823,0,0,26124),
(88336,'Commander, you have lovely bone structure.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88337,'Sometimes it\'s fun to scare the others.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88338,'Xuk is honored by your presence.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88339,'Tonight we will FEAST!','',0,0,0,0,0,0,1,0,0,28824,0,0,26124),
(88340,'I no longer trust my ancestors. You, I trust. Xuk them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88341,'Xuk...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88342,'You will herald the end of this world.','',0,0,0,0,0,0,1,0,0,28825,0,0,26124),
(88343,'','Enjoy your last moments.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88344,'Nothing can stop your might. Pour out into this world... and feast!','',0,0,0,0,0,0,1,0,0,28826,0,0,26124),
(88345,'','You are not the first to oppose me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88346,'','May your days be short and your hardships many.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88347,'','May I be of service?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88348,'','Even the patience of the draenei has its limits.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88349,'','Have any last words?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88350,'','Blade or bow? Loser\'s choice.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88351,'','This is your final lesson.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88352,'','It was a better death than you deserved.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88353,'','Dioniss aca.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88354,'','Do you require medical attention?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88355,'','Good death, short life.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88356,'','Embrace your final rest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88357,'','Remember the lessons of your death.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88358,'','Now you understand what it is to oppose me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88359,'','Was that all you could muster?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88360,'','Commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88361,'','Hello, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88362,'','Archenon poros.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88363,'','It is good to see you again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88364,'','Thank you for inviting me here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88365,'','May you have good fortune.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88366,'','My training has failed me...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88367,'I don\'t remember singing up for this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88368,'Maybe after this we can grab a drink.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88369,'Aw, don\'t start yet... I lost a sandal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88370,'Come and get it, chums!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88371,'Looks like the tide\'s rollin\' in!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88372,'Sit your duff down.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88373,'I reckon you\'re not quite welcome here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88374,'Quite a character, that one.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88375,'I just keep reeeeeeling \'em in!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88376,'You\'ve been found gill-ty. Hah!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88377,'Rise, legion, and turn this world to ash!','',0,0,0,0,0,0,1,0,0,28828,0,0,26124),
(88378,'Bring you a drink, commander?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88379,'How\'s about some fishing?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88380,'Ever dipped your foot in some water and it\'s really cold?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88381,'I feel like a fish outta water here, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88382,'I don\'t suppose there\'s a watering hole in this garrison?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88383,'Alright, well... it\'s no big deal...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88384,'Got me hook, line and sinker.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88385,'To the deep sea...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88386,'Ouch, I\'m hooked!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88387,'DRAENOR WILL BURN!','',0,0,0,0,0,0,15,0,0,28829,0,0,26124),
(88388,'Sergeant, the Shadow Council is upon us!','Sergeant, the Shadow Council is upon us!',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(88389,'You saved my life once, it is about time I returned the favor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88390,'The air has taken a turn for the foul...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88391,'The Council? The demons! Sound the alarm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88392,'Soldiers, to your posts! Others, to shelter. And those who hold sway with the Light, pray.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88393,'One last fight, I see. This is it, soldiers. Charge!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88394,'Draw strength from each other, brothers and sisters.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88395,'May the spirits guide my hand.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88396,'The winds turn against you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88397,'I have no time for insolence.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88398,'You test my patience.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88399,'Let me introduce you to my friend, lumber.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88400,'I fell trees with my bare hands. You will fall easily.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88401,'Remember, strike for head and heart. And do not fear. Fear will kill you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88402,'The winds speak to me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88403,'The Earthmother is with me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88404,'The wind takes you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88405,'You are naught but ash.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88406,'Back to the dust with you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88407,'Let me just sprinkle some dust right there...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88408,'Do not get underhoof.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88409,'We won\'t go down that easy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88410,'This one fell easily.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88411,'The spirits were not with you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88412,'You should not have come here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88413,'May the winds guide your steps, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88414,'Peace, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88415,'The Earthmother is with you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88416,'The best views can be seen from a cliff\'s edge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88417,'Which way does the wind blow?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88418,'The winds of this land speak, should you choose to listen.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88419,'If a wind stirs in the forest with no one there to hear it, does it make a sound?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88420,'Spread out! Don\'t let them gain a foothold!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88421,'Commander, the spirits speak of your bravery.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88422,'All we are is dust in the wind.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88423,'Have we driven them back?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88424,'This was not the plan...','',0,0,0,0,0,0,0,0,0,0,43731,0,26124),
(88425,'Talon Guard, ready the altar beneath the broken spire.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88426,'Hero, meet us there when you have broken the cult.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88427,'I\'m ready to fly down to Aegwynn\'s Tower.','I\'m ready to fly down to Aegwynn\'s Tower.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88428,'So Roben, what is the soup today?','So Roben, what is the soup today?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88429,'','It\'s split legume.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88430,'Ooh, my mom used to make a split legume soup. What are the orange slices?','Ooh, my mom used to make a split legume soup. What are the orange slices?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88431,'','Those are carrots, our new allies brought them to me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88432,'Interesting, well I look forward to trying it.','Interesting, well I look forward to trying it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88433,'I am sure it will be great. See you later Roben.','I am sure it will be great. See you later Roben.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88434,'','Thank you, let me know what you think.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88435,'Ugh... me no feel so good... hic!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88436,'You want a piece of thish? ...hic!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88437,'You dare to defy Rukhmar?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88438,'You defile us with your presence!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88439,'Rukhmar has forsaken me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88440,'Defeated by filthy outcasts and foreign trash!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88441,'I go to the judgment of Rukhmar.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88442,'I am undone!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88443,'Another sacrifice for Rukhmar!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88444,'You are unworthy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88445,'Want to join slaves? Why not say so?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88446,'Stop hitting slaves? You funny!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88447,'Me hate trespassers!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88448,'You no belong here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88449,'Let slaves go? You stupid!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88450,'Why my insides go outside?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88451,'It hurts! Wait, going numb. Better!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88452,'Sleepy now...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88453,'No fair!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88454,'You no want to play anymore?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88455,'Enough talking!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88456,'You look cold. Here fire!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88457,'Magic make slaves listen!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88458,'|TInterface\\Icons\\ability_fixated_state_red:20|tA creature has |cFFFF0000fixated|r on you! It will chase only you until it dies!','|TInterface\\Icons\\ability_fixated_state_red:20|tA creature has |cFFFF0000fixated|r on you! It will chase only you until it dies!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88459,'Let\'s give these dogs their medicine.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88460,'I shall enjoy torturing you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88461,'I will take your skull as a trophy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88462,'Are you so eager to die?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88463,'You\'ll beg for death!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88464,'My death means nothing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88465,'My torment ends.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88466,'Kargath will not be pleased.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88467,'The pain... feels so good...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88468,'Hah hah hah... got one!','',0,0,0,0,0,0,0,0,0,0,41933,0,26124),
(88469,'Ready to die already? Pathetic!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88470,'You\'re almost not worth killing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88471,'Bored now. Time for you to die.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88472,'Not even a good fight, what a waste of my time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88473,'More food for Soulgrinder!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88474,'Borgal no like you. I no like you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88475,'Slaves no need souls! You dumb!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88476,'Intruders must die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88477,'GET OUT!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88478,'Borgal said I don\'t die. Borgal lie!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88479,'Soulgrinder eat me now?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88480,'My blood! It runs away!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88481,'Why lights go out?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88482,'Help me put snake-things back in stomach!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88483,'Hey, we\'re workin\' here!','Hey, we\'re workin\' here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88484,'You lookin\' for a smackdown?','You lookin\' for a smackdown?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88485,'You die too easy! Die harder next time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88486,'Stay outta my business!','Stay outta my business!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88487,'Soulgrinder eat you now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88488,'Soulgrinder make my magic strong!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88489,'I\'ll pulverize ya!','I\'ll pulverize ya!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88490,'','My wolves will rend your flesh!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88491,'We found these animals fair and square!','We found these animals fair and square!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88492,'Keep your grubby hands off our merchandise!','Keep your grubby hands off our merchandise!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88493,'These animals ain\'t worth your life!','These animals ain\'t worth your life!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88494,'','Aid me, my children...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88495,'We are making a fortune off these birds. So back off!','We are making a fortune off these birds. So back off!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88496,'','I\'m going to enjoy this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88497,'','Today is not my day to die.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88498,'The storm will take you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88499,'No job was worth... this...','No job was worth... this...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88500,'Tell my wife I... ah, forget it.','Tell my wife I... ah, forget it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88501,'The shadows will consume you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88502,'Well... that sucked.','Well... that sucked.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88503,'Bury me... with my gold.','Bury me... with my gold.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88504,'Mis... calculated...','Mis... calculated...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88505,'I got a... real bad headache...','I got a... real bad headache...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88506,'Ooh... that really hurts.','Ooh... that really hurts.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88507,'You will find only death here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88508,'I return to the elements...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88509,'This may have been a bad idea...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88510,'Fear the axe of the Warsong!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88511,'I... shoulda brought... more axes...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88512,'Now... who protect... my munchkins?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88513,'Why is everyone so intent on war? Can we not give peace a chance?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88514,'','One day, we will live in peace. I hope...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88515,'Your blood will give me strength!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88516,'Sethe calls to me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88517,'You are no match for the Shattered Hand\'s venom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88518,'Your end will come...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88519,'Interloper! You will not tamper with the relics of the Apexis!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88520,'Rukhmar will avenge me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88521,'Thanks again for doin\' me a service back dere in Nagrand, mon. Eva\' since da Lich King be forcin\' me into his service, all I eva\' want ta do is get away an\' do some fishin\'.\n\nDis Draenor place be much nicer dan Northrend for fishin\', ya know. Ya don\'t have ta worry about da ice, and da fish be a lot less likely ta eat ya.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88522,'I\'ll filet ya wit\' me runeblade, mon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88523,'Ya soul will make a fine voodoo lure!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88524,'Maybe I should try runeforgin\' da fishin\' rod.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88525,'','TEST, I GOT THE TRIGGER',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88526,'','The Iron Horde should pay for what they did to Karabor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88527,'To take up the weapon of a Blademaster is to invite your own demise.','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(88528,'We must get the wards reignited. Otherwise, I guarantee the Legion will overrun our position and pour into Azsuna.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88529,'Your own order is unraveling. Betrayed from within... a curse you\'ll bear for all eternity.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88530,'Enter the portal when you are ready to teleport.  You will be sent directly to Stormshield on the island of Ashran.\n\nHave no fear, Stormshield will not flag you for PVP.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88531,'Enter the portal when you are ready to teleport.  You will be sent directly to Warspear on the island of Ashran.\n\nHave no fear, Warspear will not flag you for PVP.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88532,'I\'m ready to teleport to Stormshield on Ashran!','I\'m ready to teleport to Stormshield on Ashran!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88533,'I\'m ready to teleport to Warspear on Ashran!','I\'m ready to teleport to Warspear on Ashran!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88534,'Meet me within the Broken Spire.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88535,'','Kesmet. Please sit down to eat.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88536,'','Hands off, you filthy thief!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88537,'','Greetings commander!$b$bHow are you doing today?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88538,'Tuura, it was a magnificent meal as always.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88539,'How were your errands?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88540,'','They were fine. Urel says hello.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88541,'','He asks how the fishing is going. Did you catch much today?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88542,'I caught a few.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88543,'I will have to venture down and talk with Urel tomorrow. I need to also swing by Alexie\'s and pick up some new bait.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88544,'','That will do you good. You stay up here too much.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88545,'Kesmet grunts.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88546,'','Tuura smiles.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88547,'','How are we holding up in the front lines, $n?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88548,'','GO!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88549,'I\'ll slit any Alliance\'s throat for a copper.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88550,'I come and go like the wind.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88551,'','Tending the horses is not as easy as it seems, but at least you get to enjoy the outdoors.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88552,'You, over there! Mind helping me out of this? Contrary to what these idiots seem to believe I am in fact not dead yet. Not in that sense of the word at least.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88553,'Thank you, commander. I\'ll make my way back to your garrison. I saw what I assume is your outpost not far from here.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88554,'%s goes into a |cFFFF0404|Hspell:155539|h[Destructive Rampage]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88555,'I\'m responding to the Steamwheedle call for help. Take me to the Spires of Arak.','I\'m responding to the Steamwheedle call for help. Take me to the Spires of Arak.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88556,'Yuz be needin\' me! I haz da information yuz need... help me mon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88557,'HAAALP!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88558,'You be messin\' with the wrong mojo mon, deez new Iron Horde save me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88559,'','Greetings Commander, I hope your travels are going well.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88560,'Spirits! Get them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88561,'Argh! These flamethrowers are useless, it\'s eating us alive!','',0,0,0,0,0,0,0,0,0,0,46607,0,26124),
(88562,'Fall back! Drop your weapons and retreat to the ship!','',0,0,0,0,0,0,0,0,0,0,46608,0,26124),
(88563,'|TInterface\\Icons\\spell_fire_felfirenova.blp:20|t You are afflicted with |cFFFF0404|Hspell:172895|h[Expel Magic: Fel]|h|r!','|TInterface\\Icons\\spell_fire_felfirenova.blp:20|t You are afflicted with |cFFFF0404|Hspell:172895|h[Expel Magic: Fel]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88564,'Good day Commander!','Good day Commander!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88565,'We will be done with the harvest in no time.','We will be done with the harvest in no time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88566,'We are with you commander.','We are with you commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88567,'For the Alliance!','For the Alliance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88568,'Once the mages opened up the portal from Orgrimmar this place really started to boom. We probably have the greatest assembly of vendors and trade goods this side of Draenor.','',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(88569,'Interested in fishing around here?','Interested in fishing around here?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(88570,'Foolish raven!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88571,'<The Altar of Glory awaits an offering.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88572,'<Place an offering atop the Altar of Glory.>','<Place an offering atop the Altar of Glory.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88573,'In this circle of blood only glory matters! Throw the broken bones of your enemies upon the altar and a conqueror\'s tribute will be yours.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88574,'The cursed ones are safe from Sethe, but their sky still burns.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88575,'They will need help from the ravens. Find me in Veil Terokk.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88576,'|Hunit:77182:Oregorger|hOregorger prepares to cast |cFFFF0000|Hspell:156879|h[Blackrock Barrage]|h|r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88577,'','I got caught by the guards while trying to rescue Jobby. He owes me one.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88578,'I was a moment too late. Your scout is dead... this is worse than I could have imagined. The Iron Horde invasion has begun. Take a look for yourself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88579,'I laugh at your failure, hahaha!','',0,0,0,0,0,0,0,0,0,0,46482,0,26124),
(88580,'More next time. Many more!','',0,0,0,0,0,0,0,0,0,0,46484,0,26124),
(88581,'That was pretty savage.','',0,0,0,0,0,0,0,0,0,0,46483,0,26124),
(88582,'I\'m not done killing you yet.','',0,0,0,0,0,0,0,0,0,0,46485,0,26124),
(88583,'Kill them a lot!','',0,0,0,0,0,0,0,0,0,0,46486,0,26124),
(88584,'Let us carve a smile on their faces.','',0,0,0,0,0,0,0,0,0,0,46481,0,26124),
(88585,'Learn to beat more better.','',0,0,0,0,0,0,0,0,0,0,43830,0,26124),
(88586,'Dat was good.','',0,0,0,0,0,0,0,0,0,0,43832,0,26124),
(88587,'Dat was glor-ee-ous!','',0,0,0,0,0,0,0,0,0,0,43831,0,26124),
(88588,'|cffADFF2F+$1i Broken Bones|r','|cFF0000FF+$1i Broken Bones|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88589,'','This is not the day we die.',0,0,0,0,0,0,0,0,0,0,0,46531,26124),
(88590,'','They think they are doing well?',0,0,0,0,0,0,0,0,0,0,0,46535,26124),
(88591,'','Stay down!',0,0,0,0,0,0,0,0,0,0,0,46536,26124),
(88592,'','That was... disappointing.',0,0,0,0,0,0,0,0,0,0,0,46532,26124),
(88593,'','Keep your guard up.',0,0,0,0,0,0,0,0,0,0,0,46534,26124),
(88594,'','That was a glorious fight!',0,0,0,0,0,0,0,0,0,0,0,46533,26124),
(88595,'Start running. I will even give you a head start...','',0,0,0,0,0,0,0,0,0,0,46428,0,26124),
(88596,'We may need more to hunt after this.','',0,0,0,0,0,0,0,0,0,0,46432,0,26124),
(88597,'I could do this blindfolded.','',0,0,0,0,0,0,0,0,0,0,46433,0,26124),
(88598,'Continue practicing, commander.','',0,0,0,0,0,0,0,0,0,0,46429,0,26124),
(88599,'My eye is on you, commander.','',0,0,0,0,0,0,0,0,0,0,46431,0,26124),
(88600,'You are becoming quite the survivor.','',0,0,0,0,0,0,0,0,0,0,46430,0,26124),
(88601,'You should work more on your form, commander.','',0,0,0,0,0,0,0,0,0,0,43866,0,26124),
(88602,'Not bad! Now back to the Arena!','',0,0,0,0,0,0,0,0,0,0,43868,0,26124),
(88603,'Now THAT was a battle!','',0,0,0,0,0,0,0,0,0,0,43867,0,26124),
(88604,'I am here to repay my debt.','',0,0,0,0,0,0,0,0,0,0,46416,0,26124),
(88605,'For Skettis!','',0,0,0,0,0,0,0,0,4,0,46420,0,26124),
(88606,'You trust your eyes too much, fool.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(88607,'I expected more from you.','',0,0,0,0,0,0,0,0,0,0,46417,0,26124),
(88608,'Good. You are learning.','',0,0,0,0,0,0,0,0,0,0,46419,0,26124),
(88609,'Yes! At this rate my debt to you will be paid in no time.','',0,0,0,0,0,0,0,0,0,0,46418,0,26124),
(88610,'I tried to break Lyrdrea out of here but failed. Think she will appreciate the effort?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88611,'There MUST be a way past these statues.$b$bI want to retire to my chamber, but the owls send me away whenever I step in front of them. And I\'m growing so very tired...','There MUST be a way past these statues.$b$bI want to retire to my chamber, but the owls send me away whenever I step in front of them. And I\'m growing so very tired...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88612,'Well, I suppose you could get past them if you were |cFF0000FF[Invisible]|r...','Well, I suppose you could get past them if you were |cFF0000FF[Invisible]|r...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88613,'I will find a way past the owls.','I will find a way past the owls.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88614,'I need help! How do you get past the owls?','I need help! How do you get past the owls?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88615,'Work harder! Crack more stones!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(88616,'Them stones won\'t crack theyselves!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88617,'Work! Work!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(88618,'I must tell King Wrynn at once. Keep alert, $c. Dark times lay ahead.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88619,'My stomach growls louder and louder with each passing year. I could really use a bite to eat.$b$bI might even be convinced to give my scroll to you if you could help me sate this hunger.','My stomach growls louder and louder with each passing year. I could really use a bite to eat.$b$bI might even be convinced to give my scroll to you if you could help me sate this hunger.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88620,'Hmm... you look like a conjurer, of sorts. You must have a way to |cFF0000FF[Conjure Refreshments]|r for me...','Hmm... you look like a conjurer, of sorts. You must have a way to |cFF0000FF[Conjure Refreshments]|r for me...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88621,'I will get you some food.','I will get you some food.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88622,'I need help! What can I possibly do to feed a hungry companion?','I need help! What can I possibly do to feed a hungry companion?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88623,'I really should go put my daughter to sleep. It\'s centuries past her bedtime.$b$bI can\'t seem to get past these walls, though. What\'s a parent to do?','I really should go put my daughter to sleep. It\'s centuries past her bedtime.$b$bI can\'t seem to get past these walls, though. What\'s a parent to do?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88624,'Children grow so fast. |cFF0000FF[Blink]|r twice and they\'re all grown up...','Children grow so fast. |cFF0000FF[Blink]|r twice and they\'re all grown up...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88625,'I will find a way past the walls.','I will find a way past the walls.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88626,'I need help! How can I get past these walls?','I need help! How can I get past these walls?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88627,'The master has asked me to clear the vermin out of the lyceum. This one particular rat, however, has me completely vexed.','The master has asked me to clear the vermin out of the lyceum. This one particular rat, however, has me completely vexed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88628,'The damned thing has a powerful enchantment on it. Sure, a powerful mage might be able to |cFF0000FF[Steal its Spell]|r somehow, but I\'m just a guy with a broom...','The damned thing has a powerful enchantment on it. Sure, a powerful mage might be able to |cFF0000FF[Steal its Spell]|r somehow, but I\'m just a guy with a broom...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88629,'I will defeat it for you.','I will defeat it for you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88630,'Murg used to be a peon just like these orcs, but I got to be the best stone cracker out there!\n\nNow, they give Murg the name \"Stonecrack\" and lets me boss around these little guys. It\'s the best job, I tell ya!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88631,'I need help! How can I defeat that monstrosity?','I need help! How can I defeat that monstrosity?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88632,'This Murg guy is great. It\'s a real inspiration watching him yell at those peons.\n\nMaybe after we get off this rock, I\'ll acquire his services for some of my operations.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(88633,'In this circle of blood only glory matters! Throw the broken bones of your enemies upon the altar and a conqueror\'s tribute will be yours.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88634,'Together, we will reseal the Tomb of Sargeras and defeat the Burning Legion.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(88635,'I\'m ready to go find my artifact!','I\'m ready to go find my artifact!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88636,'Hey! What\'s the big deal trying to bring your goons in here to stop my business?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(88637,'Business?! These are priceless artifacts that you\'re offloading here!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(88638,'In my experience, \'priceless\' just means really expensive. What do you expect me to do, give them away?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88639,'The Horde needs those artifacts! We must study them if we wish to gain the upper hand in this war.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88640,'That still doesn\'t answer my question.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(88641,'Listen, you green little twerp! You\'ll hand over the artifacts or we will be forced to take them!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(88642,'Easy pal, how \'bout I give you a nice discount and you can be on your way. How does five percent sound?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88643,'Fair enough, ten. And I wouldn\'t try any funny business if I were you. Nobody wants in bad with the Cartel.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(88644,'Food! Please, take my spell scroll, I no longer have need of it.','Food! Please, take my spell scroll, I no longer have need of it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88645,'Are you mad?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(88646,'','These Reliquary guys look like they mean business.\n\nTo me, that sounds very bad for business.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88647,'Train me in Archaeology.','Train me in Archaeology.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88648,'I must inform Warchief Vol\'jin. Keep alert, $c. Dark times lie ahead.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88649,'Want bodyguard? You not need one, but I can help you kill stuff.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(88650,'Sure. I could use a little muscle.','Sure. I could use a little muscle.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88651,'Your order has already been placed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88652,'Collect your blood to regain your health!','Collect your blood to regain your health!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88653,'%s comforts you.','%s comforts you.',396,0,0,0,0,0,396,0,0,0,0,0,26124),
(88654,'%s gives you a high five!','%s gives you a high five!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88655,'Ye ain\'t gettin\' through me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88656,'I\'ll cut ya!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88657,'Your head will make a fine trophy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88658,'That\'s for me grand pappy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88659,'Ick... ya got blood in me beard.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88660,'At ye service, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88661,'What da ye want? Err... commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88662,'Let me know when there\'s something to kill.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88663,'Is it time ta kill something?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88664,'Death... where is thy sting?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88665,'I\'m coming home, pappy...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88666,'Psh... just a... flesh... wound...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88667,'Is that me blood or yours?... Definitely mine...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88668,'We\'re out of time, we need to start the ritual over. Everyone in your places, we\'re doing this again!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88669,'Our moment has passed and we need to do this again. Please, assist us with the ritual one more time.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88670,'%s salutes you with respect.','%s salutes you with respect.',66,0,0,0,0,0,66,0,0,0,0,0,26124),
(88671,'Filthy burgla! You gun be my dinna now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88672,'Perhaps you were not ready for the ritual? It\'s ok, we can try this again.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88673,'Oooh, dis look like a tasty one!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88674,'','Thank you, commander. On my honor, I shall not disappoint you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88675,'What are you offering today?','What are you offering today?',3,0,0,0,0,0,0,0,0,0,0,0,26124),
(88676,'Work work!','',0,0,0,0,0,0,0,0,0,0,6197,0,26124),
(88677,'Howdy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88678,'Ha! Caught one.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88679,'','You\'ve angered the wrong night elf!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88680,'','Your death will be swift.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88681,'','I don\'t take any prisoners.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88682,'','Any last words?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88683,'','That wasn\'t so tough.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88684,'','Hardly a challenge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88685,'','A clean kill.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88686,'','Where\'s the danger?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88687,'','I\'m on the alert.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88688,'','Do you need my aid?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88689,'','Nooo...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88690,'','Do you disturb the wilds?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88691,'','Nature guide me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88692,'','You will go no further!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88693,'','Rest in peace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88694,'','Mu\'sha guide you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88695,'','Well fought.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88696,'','May the moon guide you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88697,'','Be one with nature, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88698,'','Shhh, listen. The wind whispers...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88699,'','I see... the... light...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88700,'Who dares challenge the might of Skog?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88701,'Bring me the corpses of these invaders.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88702,'This is MY domain!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88703,'What are these... things... that dare enter the domain of Skog?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88704,'Something need doing?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88705,'Gazlowe needs you.','Gazlowe needs you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88706,'Okee dokee.','',0,0,0,0,0,0,0,0,0,0,6294,0,26124),
(88707,'YES! They must burn! Come, we have much to discuss!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88708,'Write, write, all day long. Make the pretty letters flow.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88709,'The Bloodmane attack came from the southern path over the mountain. If you follow it you should find the valley they come from.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88710,'I swear to eradicate all humans from the face of Draenor.','I swear to eradicate all humans from the face of Draenor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88711,'You have selected human as your nemesis.\n\nAre you sure?','You have selected human as your nemesis.\n\nAre you sure?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88712,'','The Light prevails, because WE stand against the darkness.',0,0,0,0,0,0,1,0,6,0,0,45633,26124),
(88713,'You have selected draenei as your nemesis.\n\nAre you sure?','You have selected draenei as your nemesis.\n\nAre you sure?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88714,'You have selected night elf as your nemesis.\n\nAre you sure?','You have selected night elf as your nemesis.\n\nAre you sure?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88715,'You have selected gnome as your nemesis.\n\nAre you sure?','You have selected gnome as your nemesis.\n\nAre you sure?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88716,'You have selected worgen as your nemesis.\n\nAre you sure?','You have selected worgen as your nemesis.\n\nAre you sure?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88717,'You have selected dwarf as your nemesis.\n\nAre you sure?','You have selected dwarf as your nemesis.\n\nAre you sure?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88718,'You have selected pandaren as your nemesis.\n\nAre you sure?','You have selected pandaren as your nemesis.\n\nAre you sure?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88719,'A fine choice. Humans are a blight upon this world and must be destroyed or driven out of Draenor.$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88720,'Draenei...$B$B<Raza\'kul spits.>$B$BYou would do all denizens of this world a great service by ridding these lands of draenei.$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88721,'The lasso breaks! The beast got away!','The lasso breaks! The beast got away!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88722,'I swear to eradicate all draenei from the face of Draenor.','I swear to eradicate all draenei from the face of Draenor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88723,'I swear to eradicate all pandaren from the face of Draenor.','I swear to eradicate all pandaren from the face of Draenor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88724,'I swear to eradicate all dwarves from the face of Draenor.','I swear to eradicate all dwarves from the face of Draenor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88725,'I swear to eradicate all worgen from the face of Draenor.','I swear to eradicate all worgen from the face of Draenor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88726,'I swear to eradicate all gnomes from the face of Draenor. And hopefully the rest of the known universe.','I swear to eradicate all gnomes from the face of Draenor. And hopefully the rest of the known universe.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88727,'I swear to eradicate all night elves from the face of Draenor.','I swear to eradicate all night elves from the face of Draenor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88728,'','We will hold the Temple. I will not accept any other outcome.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88729,'','We\'ve done it, $n! K\'ara\'s energy has destroyed what\'s left of the Iron Horde army.$B$BWe are safe.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88730,'These worgen that have invaded our lands share the same ferocity and animal instincts of the native saberon, but with none of their survival sense. Let their deaths serve as a lesson to the rest of this so called \"Alliance.\"$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88731,'These pandaren had a choice to serve in your mighty army, but instead opted to betray the Horde and join the enemy. Now they aid the draenei in their mission to kill all orcs. The traitorous pandaren of the Alliance must be exterminated.$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88732,'Whether an aberration of nature or a cruel joke by the gods of your world, gnomes have no business living. Their extinction will clear the way for a more powerful species to rise. You must be the instrument of their demise!$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88734,'Commander, check this thing out. We found an Iron Star and Thaelin over there has been helping me get it fully operational.\n\nI think it\'s ready for action, if you want to give it a test roll.\n\nKhadgar and the others said they\'d meet you at the entrance to the harbor. Maybe run over any Iron Horde you encounter along the way for kicks.','',11,0,0,3000,0,0,0,0,0,0,0,0,26124),
(88735,'Thanks. I\'ll meet them at the docks.','Thanks. I\'ll meet them at the docks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88736,'Cheers, commander. We found this Iron Star here just waitin\' to be repaired, and Gazlowe over there has been helpin\' me fix it up.\n\nIt should be ready for action when you are.\n\nKhadgar said he\'d meet ya down by the harbor with the others. I\'m a wee bit jealous that ya get to roll over some Iron Horde in this thing.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(88737,'Aye, that\'s a fine one, commander. I\'ll get \'er back to the stables now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88738,'Night elves, conspirators one and all. The night elf invaders must be crushed and sent back to their moon gods!$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88739,'Dwarves are integral to the Alliance as they are the builders of war machines. For this reason alone they must all be slain. Show no mercy, as none will be shown to you.$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88740,'I\'ve changed my mind. I feel there is an enemy more worthy of my rage.','I\'ve changed my mind. I feel there is an enemy more worthy of my rage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88741,'Tectus directs his Crystalline Barrage towards you!','Tectus directs his Crystalline Barrage towards you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88742,'','We can\'t be stopped!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88743,'','Have any spare Artifact Fragments, $n? My friend Ecilam could use them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88744,'','Chris Clarkie rewards handsomely if you bring him some Tauren Hooves.$B$BI don\'t know why.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88745,'<The book is filled with spells - some strange, many familiar. One spell, in particular, is of special interest.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88746,'<Cast the spell to summon Aluneth.>','<Cast the spell to summon Aluneth.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88747,'I\'m... uh oh...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88748,'I\'M UNSTOPPABLE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88749,'Beyond this point is Stormshield Stronghold. I suggest you stay away if you aren\'t too keen in battle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88750,'If you\'re going in, could you say a kind hello to Damarcus and Vessup at the main gate for me? They must miss me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88751,'Leaf me alone!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88752,'\"The great staff Aluneth resides in a plane unreachable by all except the most skilled arcanists. Archmage Rentarric was the first to summon it. I was the last.\"$b$b- Magna Aegwynn','\"The great staff Aluneth resides in a plane unreachable by all except the most skilled arcanists. Archmage Rentarric was the first to summon her. I was the last.\"$b$b- Magna Aegwynn',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88753,'\"Aluneth will defy those who attempt to wield it. The greatstaff\'s willful spirit must first be broken.\"$b$b- Magna Aegwynn','\"Aluneth will defy those who attempt to wield her. The greatstaff\'s willful spirit must first be broken.\"$b$b- Magna Aegwynn',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88754,'\"Aluneth is capricious. The entity must be quickly bound to her summoner before its curiosity leads it astray.\"$b$b- Magna Aegwynn','\"Aluneth is capricious. She must be quickly bound to her summoner before her curiosity leads her astray.\"$b$b- Magna Aegwynn',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88755,'\"Aluneth\'s power should be immediately apparent to any who wield it. Its subtleties, however, will only become more apparent with time.\"$b$b- Magna Aegwynn','\"Aluneth\'s power should be immediately apparent to any who wield her. Her subtleties, however, will only become more apparent with time.\"$b$b- Magna Aegwynn',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88756,'\"When unused, Aluneth must be allowed to return to its own plane.\"$b$b- Magna Aegwynn','\"When unused, Aluneth must be allowed to return to her own plane.\"$b$b- Magna Aegwynn',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88757,'This world don\'t give us nothing, $n. It be our lot to suffer... and our duty to fight back.$b$b\nThis Horde be our family! We don\'t always see eye-to-eye. We come to blows before. But when we work together - ah - there\'s nothing this Horde can\'t do.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(88758,'','My brothers... will avenge me...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88759,'','Death to the enemies of the Warsong!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88760,'This won\'t end well for you.','This won\'t end well for you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88761,'Give them no quarter!','Give them no quarter!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88762,'We are the iron hand of war!','We are the iron hand of war!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88763,'Wipe them out!','Wipe them out!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88764,'Nothing can stop the Iron Horde!','Nothing can stop the Iron Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88765,'A storm of iron comes!','A storm of iron comes!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88766,'You worms dare to oppose us?','You worms dare to oppose us?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88767,'Curs. You are outmatched!','Curs. You are outmatched!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88768,'Ahh... Aluneth. You speak of the Magna\'s greatstaff.$b$bI knew from the start it was not a weapon of normal means. My lady would simply reach upwards and GRAB the staff out of thin air, wave it around a bit, and then... just PUT it back into the thin air it came out of.$b$bThere was no cloaking or charlatan\'s invisibility going on here. That staff came from another realm. And the Magna knew how to reach into that realm and pluck it out.','Ahh... Aluneth. You speak of the Magna\'s greatstaff.$b$bI knew from the start it was not a weapon of normal means. My lady would simply reach upwards and GRAB the staff out of thin air, wave it around a bit, and then... just PUT it back into the thin air it came out of.$b$bThere was no cloaking or charlatan\'s invisibility going on here. That staff came from another realm. And the Magna knew how to reach into that realm and pluck it out.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88769,'I saw the great weapon once, in my lady\'s library, moving on its own through the stacks!$b$bI pretended not to see it, but I fear it noticed my stare.','I saw the great weapon once, in my lady\'s library, moving on its own through the stacks!$b$bI pretended not to see it, but I fear it noticed my stare.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88770,'You mean the Magna\'s weapon? I can tell you what I know.$b$bOnce, when I was much, much younger, I reached out to touch the greatstaff, as my lady had left it propped up against her chamber door. The staff rejected my touch with painful tendrils of pink and purple lightning.$b$bNot one second later, the Magna appeared and wrested the weapon away from me.$b$bShe shared a powerful bond with that staff - one that I will never fully understand.','You mean the Magna\'s weapon? I can tell you what I know.$b$bOnce, when I was much, much younger, I reached out to touch the greatstaff, as my lady had left it propped up against her chamber door. The staff rejected my touch with painful tendrils of pink and purple lightning.$b$bNot one second later, the Magna appeared and wrested the weapon away from me.$b$bShe shared a powerful bond with that staff - one that I will never fully understand.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88771,'That weapon... I\'ve never seen anything like it before.$b$bMy lady used to talk to the thing, like it was alive. She\'d talk about spells, rituals, other matters of the arcane... all of it well over my head.$b$bShe was always a bit wild, my lady was, but she never quite struck me as batty. Odd to be talking to a staff, though.','That weapon... I\'ve never seen anything like it before.$b$bMy lady used to talk to the thing, like it was alive. She\'d talk about spells, rituals, other matters of the arcane... all of it well over my head.$b$bShe was always a bit wild, my lady was, but she never quite struck me as batty. Odd to be talking to a staff, though.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88772,'What can you tell me about Aluneth?','What can you tell me about Aluneth?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88773,'You are about to embark on a dangerous mission, and you may not be able to return immediately. Are you sure?','You are about to embark on a dangerous mission, and you may not be able to return immediately. Are you sure?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88774,'','Ye be lookin\' lost, mon.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(88775,'Um... I\'m gonna need your raptor again.','Um... I\'m gonna need your raptor again.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88776,'','We do not fear you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88777,'Thank... you...','Thank... you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88778,'My liege, the city is lost! We must abandon the palace!','',0,0,0,0,0,0,0,0,0,0,45106,0,26124),
(88779,'The gates have been breached! They have come for the stones!','',0,0,0,0,0,0,0,0,0,0,45107,0,26124),
(88780,'... return... to... the light...','... return... to... the light...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88781,'The pain... thank you...','The pain... thank you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88782,'... you... are kind...','... you... are kind...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88783,'May the light... watch... over you...','May the light... watch... over you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88784,'I\'m glad you made it here safely. Are you ready?','I\'m glad you made it here safely. Are you ready?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88786,'Abyssal Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88787,'Shadow Anguishers Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88788,'Imps Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88789,'Shadowblades Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88790,'Shadow Council Portals Destroyed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88791,'Council Voidrenders Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88792,'Aren\'t you thankful?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88793,'Felfire Batriders Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88794,'The rest of the story will have to wait until you\'ve returned from Talon Watch.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88795,'Ah, thanks to the bangle you recovered from Ikiss, we can go right into the tale of Terokk\'s fall.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88796,'This gift will surely prove useful - but we still need the Talonpriests to perform the rites.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88797,'Tread carefully, stranger. I am not accustomed to visitors in this wasteland.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88798,'With this, we can delve into the tale of Terokk\'s fall.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88799,'The past has much to teach us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88800,'Train me in Archaeology.','Train me in Archaeology.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88801,'Train me in Inscription.','Train me in Inscription.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88802,'A giant Carrion Worm smells his next meal!','A giant Carrion Worm smells his next meal!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88803,'Carrion Worms Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88804,'','<The half-orc snarls at you from within her arcane prison. Her eyes are filled with fire and hate - it\'s clear that Gul\'dan still has her under his complete control.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88805,'Long have I toiled at my craft, stranger. There is no greater pursuit, in my opinion, than to admire and reflect upon the beauty of this world.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88806,'','Please don\'t die... please! Nyami said I cannot fail again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88807,'Greetings champion.$b$BI volunteered for this expedition to examine the oddities and abnormalities of Draenor.$b$bIf you find any strange anomalies during your journey I would be interested in examining them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88808,'The battle for the ritual fires will begin in 3 minutes!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88809,'%s begins to cast |TInterface\\Icons\\ability_priest_voidentropy.blp:20|t |cFFFF0404|Hspell:174016|h[Decimate]|h|r! Run into a Neutralization Zone!','%s begins to cast |TInterface\\Icons\\ability_priest_voidentropy.blp:20|t |cFFFF0404|Hspell:174016|h[Decimate]|h|r! Run into a Neutralization Zone!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88810,'','Right away, Exarch. May the dead speak through you.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(88811,'Story time is over!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88812,'We have found him...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88813,'The battle for the quarry will begin in 3 minutes!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88814,'The battle for the stadium will begin in 3 minutes!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88815,'This cannot be! My gaze is.. eternal...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88816,'The feeble arakkoa thought he could enslave me, but nothing can contain the void\'s eternal gaze!','',0,0,0,0,0,0,0,0,0,0,10112,0,26124),
(88817,'You got it, boss. I meet you outside.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88818,'You will meet the same fate!','',0,0,0,0,0,0,15,0,0,0,10110,0,26124),
(88819,'Fool!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88820,'Lead the way, boss.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88821,'Tormmok, head back to the barracks.','Tormmok, head back to the barracks.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88822,'Okay boss.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88823,'This unusual arakkoa seems to have suffered mortal wounds from some sort of powerful dark magic.\n\nWhatever caused these wounds, however, is nowhere to be seen.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88824,'It\'s no use.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88825,'Thank you again, $p. Your kindness will not be forgotten... and neither will Tuliaa.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88826,'|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the man slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the man slayer is hunting you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88827,'We obey Ner\'zhul\'s will!','We obey Ner\'zhul\'s will!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88828,'We will cover this world in darkness!','We will cover this world in darkness!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88829,'Another prisoner for the sacrifice!','Another prisoner for the sacrifice!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88830,'Darkness is our will, and iron is our blood!','Darkness is our will, and iron is our blood!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88831,'I will deliver you to your end!','I will deliver you to your end!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88832,'','Do you want some company, commander?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(88833,'Lookin\' fer a bodyguard, commander?$B$BYe\'ve come tae the right dwarf.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88834,'Leorajh come with $n?$B$BLeorajh good bodyguard. Keep you alive!','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(88835,'The shadows foretold that you might ask of my protection.$B$BI am prepared.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88836,'','Do you desire my aid, commander?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(88837,'','Would you like me to accompany you, $gsir:ma\'am;?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(88838,'Sure. I could use a little muscle.','Sure. I could use a little muscle.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88839,'','Perfect! I\'ll meet you outside.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88840,'Illona, head back to the barracks.','Illona, head back to the barracks.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88841,'','Ready when you are!',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(88842,'','I\'ll meet you back home!',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(88843,'Sure. I could use a little muscle.','Sure. I could use a little muscle.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88844,'','Gladly. I will meet you outside.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88845,'Vivianne, head back to the barracks.','Vivianne, head back to the barracks.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88846,'','Ready when you are.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(88847,'','I\'ll return to base.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(88848,'Sure. I could use a little muscle.','Sure. I could use a little muscle.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88849,'I will join you outside.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88850,'Ishaal, head back to the barracks.','Ishaal, head back to the barracks.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88851,'I heed your call.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(88852,'I return to the shadows.','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(88853,'Sure. I could use a little muscle.','Sure. I could use a little muscle.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88854,'Leorajh meet you outside.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88855,'Leorajh, head back to the barracks.','Leorajh, head back to the barracks.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88856,'Yes, master?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(88857,'Leorajh meet you at home.','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(88858,'Sure. I could use a little muscle.','Sure. I could use a little muscle.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88859,'Yer the boss. I\'ll meet ye outside.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88860,'Delvar, head back to the barracks.','Delvar, head back to the barracks.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88861,'I\'m right behind ye.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(88862,'See ya at home.','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(88863,'Sure. I could use a little muscle.','Sure. I could use a little muscle.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88864,'','So be it. I shall meet you outside.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88865,'Aeda, head back to the barracks.','Aeda, head back to the barracks.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88866,'','Say the word.',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(88867,'','See you back home.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(88868,'Commander! Would you endorse my shop?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88869,'Quite the beast ye caught there! Let me get it back to the stables and brushed down.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88870,'This one\'s gonna be feisty, hope I make it back in one piece!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88871,'A great catch, commander! I\'ll get it some water when we get back.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88872,'Quite the beast ye got there, let me get it back to the stables.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88873,'Oi, this one\'s meh favorite yet! Come with me lil\' beastie!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88874,'Ah, a fine beast. I will return it to the stables.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88875,'A powerful creature, it will make a fine mount. I shall guide it home.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88876,'This beast will require some handling to be properly trained. I will begin immediately.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88877,'The beasts here are quite savage, but this one looks to be breakable. Come with me, beast.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88878,'A great catch, commander. I will get it some water.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88879,'I have not seen this much fire in a beast in quite some time. Come, unruly creature.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88880,'Welcome, commander. I carry the finest weapons and armor in all of Ashran.$b$bLet me know if there is anything I can help you with.','Welcome, commander. I carry the finest weapons and armor in all of Ashran.$b$bLet me know if there is anything I can help you with.',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(88881,'Lookout! The Alliance has summoned a Frostwyrm! Get out of the main road!','',0,0,0,0,0,0,0,0,0,31197,8332,0,26124),
(88882,'|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the draenei slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the draenei slayer is hunting you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88883,'|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the dwarf slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the dwarf slayer is hunting you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88884,'|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the night elf slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the night elf slayer is hunting you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88885,'|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the gnome slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the gnome slayer is hunting you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88886,'I could kill a hundred of you at once!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88887,'|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the worgen slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the worgen slayer is hunting you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88888,'|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the pandaren slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the pandaren slayer is hunting you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88889,'I will end your worthless life!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88890,'This can hardly be called a battle...','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88891,'Mar\'gok will regret losing my brawn.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88892,'Hah. I\'ve killed bigger in my sleep!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88893,'You face the fist of the empire, fool.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88894,'Face me, cowards!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88895,'Today is not the day I die.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88896,'Your pathetic life is over.','',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(88897,'Your death will be forgotten quickly...','',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(88898,'Barely worth the effort.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88899,'I almost broke a sweat that time.','',0,0,0,0,0,0,153,0,0,0,0,0,26124),
(88900,'You call that a fight?','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88901,'That nearly tickled.','',0,0,0,0,0,0,153,0,0,0,0,0,26124),
(88902,'Another. I could do this all day!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88903,'Surely there are stronger foes.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88904,'Want some meat?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88905,'You have orders, sir?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88906,'Is there a foe worth crushing, commander?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88907,'We will slay countless foes together.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88908,'This will be a glorious battle.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88909,'I knew you\'d recognize my might, commander.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88910,'All of Draenor will fall beneath us.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88911,'You need true ogre strength at your side, commander.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88912,'I am yours to command, my liege.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88913,'To die so far... from home...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88914,'Not the end... I had imagined...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88915,'Too... soon...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88916,'No! I... refuse...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(88917,'This is almost too easy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88918,'An Imperial battalion would be done with this fight already!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88919,'You cannot break me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88920,'No formations... no tactics... this is a brawl, not a battle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88921,'How about we get a few more into the fray?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88922,'Don\'t worry, it\'s almost over.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88923,'Come closer. My blade isn\'t bloody enough yet!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88924,'For a moment I thought this might have been a challenge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88925,'Looking for a way to impress your friends? Maybe catch the eye of a lass you bumped into at the inn? Well, you\'re in luck, my friend. Feast your eyes on Bil Sparktonic\'s fantastical incantations!\n\nFor a low, low price, you too can enchant the world and make it glow! \n\nMy assistant, Bob, can also help you with recipes for the latest and greatest enchantments from Draenor!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(88926,'Impress the ladies with Sparktonic\'s Spectacular Sparkles!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88927,'Sparktonics Enchanting: Bringing you the best Enchanting prices in Stormshield!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88928,'Have the shiniest weapon in town with Sparktonic\'s Enchanting!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88929,'Sparktonic\'s Enchanting: We turn plus one into plus fun!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88930,'Welcome to Sparktonic\'s Enchantments, offering the lowest prices on enchanting in Stormshield.\n\nCare to browse our recipes?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88931,'','Jeek on it. Jeek on this. You take that back, dooker $r!',36,0,0,0,0,0,0,0,0,0,0,0,26124),
(88932,'','Mank you, $g man:lady;. MANK YOU.',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(88933,'Blikkety slickety ook. This mank jeeked on my dook. Face! Now hand over the Fighter Chow!','Blikkety slickety ook. This mank jeeked on my dook. Face! Now hand over the Fighter Chow!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88934,'','You\'ve out-hozened me, wicket-lover. Here, take the chow. You earned it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88935,'','What now, you ookin dookin, blookin flookin, blickjikity flip wicket, slicky slapper, dook manker? Jeek!',53,0,0,0,0,0,0,0,0,0,0,0,26124),
(88936,'If we didn\'t want the support of these giants, I\'d kill you where you stand.','',0,0,0,0,0,0,0,0,0,0,52695,0,26124),
(88937,'No food for you today, slave.','',0,0,0,0,0,0,0,0,0,0,52697,0,26124),
(88938,'','Tell me, demon! Where is the Legion holding Illidan\'s body?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88939,'Ah, it feels great to get Fanny out on a proper honeymoon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88940,'I sought to escape the frozen wastes of Northrend for a while. I choose poorly.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(88941,'<The young adventurer\'s body is punctured in several places.$B$BJudging from the state of the makeshift camp, a struggle broke out here not long ago.$B$BA note is crumpled in his hand.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88942,'','What ARE these creatures?',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(88943,'I am stronger than ever!','',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(88944,'I am the strongest ogre in all of Draenor!','',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(88945,'Go ahead, Ga\'nar. Take the clan. Slay your own brother in cold blood. See who follows you then.','',0,0,0,0,0,0,0,0,7,0,45213,0,26124),
(88946,'You think THIS is what father wanted?','',0,0,0,0,0,0,6,0,7,0,45212,0,26124),
(88947,'Ow! Sleep... time... now...','',0,0,0,0,0,0,0,0,0,0,45776,0,26124),
(88948,'My totem will empower you!','',0,0,0,0,0,0,0,0,4,0,46666,0,26124),
(88949,'Stand nearby to use my totem\'s strength.','',0,0,0,0,0,0,0,0,4,0,46667,0,26124),
(88950,'Stand beside my totem to gain its power.','',0,0,0,0,0,0,0,0,4,0,46668,0,26124),
(88951,'A fine choice. Blood elves are a blight upon this world and must be destroyed or driven out of Draenor.$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88952,'','Auchenai, secure this chamber.',0,0,0,0,0,0,25,0,0,0,0,43234,26124),
(88953,'','The barrier protecting Auchindoun is asunder.',0,0,0,0,0,0,1,0,0,0,0,43235,26124),
(88954,'','A foul force has penetrated these sacred chambers.',0,0,0,0,0,0,1,0,0,0,0,43236,26124),
(88955,'Orc...$B$B<Kuros spits.>$B$BYou would do all denizens of this world a great service by ridding these lands of orc.$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88956,'','Scout ahead while we establish a foothold.',0,0,0,0,0,0,603,0,0,0,0,43237,26124),
(88957,'','No... no, she cannot! My mind is not my own!',0,0,0,0,0,0,22,0,0,0,0,43238,26124),
(88958,'','I return... to the Light.',0,0,0,0,0,0,0,0,0,0,0,43233,26124),
(88959,'In my tongue, goblin roughly translates to parasite. A fitting name they have given themselves. As with any pest, they must be exterminated. Let their deaths serve as a lesson to the rest of this so called \"Alliance.\"$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88960,'These pandaren had a choice to serve in your mighty army, but instead opted to betray the Alliance and join the enemy. Now they aid the orcs in their mission to kill all draenei. The traitorous pandaren of the Horde must be exterminated.$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88961,'On Argus we hunted powerful horned beasts like your tauren for sport. Prove your might over this worthy adversary!$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88962,'Trolls, conspirators one and all. The troll invaders must be crushed and sent back to their savage gods!$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88963,'Death incarnate now walks the land. These Forsaken are a crime against life itself... anathema to the Light. For that alone they must all be purged from Draenor.$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88964,'Your Mount-In-Training runs away in fear!','Your Mount-In-Training runs away in fear!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88965,'','We will never surrender to you! Champion, now is the time! Use the artifact!',0,0,0,0,0,0,603,0,0,0,0,44738,26124),
(88966,'','Brace yourself, champion. The might of the Horde is within you. Lok\'tar ogar!',0,0,0,0,0,0,66,0,0,0,0,44739,26124),
(88967,'','The artifact! Has he gone mad?! We must restore it. We must get it to safety.',0,0,0,0,0,0,603,0,0,0,0,44740,26124),
(88968,'<Little power is left in this machine, rendering it useless>','<Little power is left in this machine, rendering it useless>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88969,'<Investigate further>','<Investigate further>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88970,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(88971,'','My strength grows!',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(88972,'','The Light shines ever brighter!',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(88973,'','I won\'t go down easily.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88974,'','For my grandfather.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88975,'','I will earn my place.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88976,'','You will not break us.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88977,'','Light grant me strength!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88978,'','You cannot stand against the Light!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88979,'','We fight as one.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88980,'','I will never be broken.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88981,'','You are broken.',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(88982,'','You will threaten this world no longer.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88983,'','You cannot stand against the Light.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88984,'','Not on my watch.',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(88985,'','I\'ve killed one!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88986,'','We will prevail!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88987,'','Our defenses hold.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88988,'','I stand for another day.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88989,'','May the Light protect us.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88990,'','I will stand by your side, commander.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88991,'','May the Light bless you, commander.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88992,'','Lead the way.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88993,'','Together we cannot fall.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88994,'','I will avenge the fallen.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88995,'','The spirits of the fallen watch over us.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88996,'','It is an honor to fight by your side.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88997,'','I am... done.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88998,'','The Light... fades...',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(88999,'','I see... only... darkness...',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89000,'','Grandfather... I have failed you...',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89001,'','Spirits grant me strength!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89002,'','I do not fear you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89003,'','I will defend my homeland with my life.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89004,'','Fall before my hammer, fiend.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89005,'','My conviction is unwavering.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89006,'','I will not falter.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89007,'','I will have retribution!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89008,'','For Draenor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89009,'','None will stand in my way now.',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(89010,'','Power... overwhelming!',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(89011,'','You will regret this.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89012,'','I wield powers from beyond.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89013,'','You will beg for mercy.',0,0,0,0,0,0,396,8,0,0,0,0,26124),
(89014,'','I will turn you to ash!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89015,'','Taste the fury of the sun!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89016,'','For the Horde!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89017,'','You will know pain.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89018,'','I will tear your very soul asunder.',0,0,0,0,0,0,396,8,0,0,0,0,26124),
(89019,'','Nice try.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89020,'','You deserved that.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89021,'','One down.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89022,'','Who\'s next?',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89023,'','I tried to warn you.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89024,'','You are weak.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89025,'','That was only the beginning.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89026,'','Chaos reigns!',0,0,0,0,0,0,396,8,0,0,0,0,26124),
(89027,'','I am yours to command.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89028,'','My power is yours, commander.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89029,'','Our destiny awaits.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89030,'','I am sworn to your service, commander.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89031,'','Shall we sow fear into the hearts of your enemies?',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89032,'','We aren\'t in Outland anymore.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89033,'','I will bathe your enemies in hellfire.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89034,'','We will defeat the Legion.',0,0,0,0,0,0,396,8,0,0,0,0,26124),
(89035,'','It\'s so... cold...',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89036,'','The nether... embraces me...',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89037,'','Commander... I have... failed.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89038,'','My soul... was too weak.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89039,'','CHAOS!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89040,'','Burn!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89041,'','Stand still.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89042,'','I will banish you to the Twisting Nether.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89043,'','You will learn to fear me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89044,'','Impressive.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89045,'','My power is unending.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89046,'','You will suffer.',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(89047,'Ha!  Just what I expected from something so puny.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89048,'You think you can beat Tarr with pets?  Funny.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89049,'','I don\'t really like when my pets fight, but I love making them feel better when they\'re done.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89069,'','Do you wish to offer challenge?  My wolves must train to become strong.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89079,'6.0 Battle Pet Trainer - Reenari - None','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89094,'6.0 Battle Pet Trainer - Vesharr - None','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89095,'6.0 Battle Pet Trainer - Veruna - None','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89096,'','My wolves will tear your pets apart!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89098,'|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the pandaren slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the pandaren slayer is hunting you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(89099,'|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the goblin slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the goblin slayer is hunting you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(89100,'|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the tauren slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the tauren slayer is hunting you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(89101,'|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the troll slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the troll slayer is hunting you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(89102,'|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the Forsaken slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the Forsaken slayer is hunting you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(89103,'|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the blood elf slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the blood elf slayer is hunting you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(89104,'|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the orc slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the orc slayer is hunting you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(89105,'... our might rules the skies... behold, terror given wings!','',0,0,0,0,0,0,0,0,0,0,46583,0,26124),
(89106,'','%s glares intensely at you.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(89107,'','I do love the fresh air out here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89108,'Once I walked these halls with pride, holding my head high as an orc of the Blackrock clan. But this is a wrong path. Our hammers were meant to craft axes, swords... not these machines from the stranger\'s whispers.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89109,'I will punch you in the face!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89110,'Rocketspark leaps, beginning a |TInterface\\Icons\\inv_misc_missilelargecluster_red.blp:20|t |cFFFF0404|Hspell:162407|h[X21-01A Missile Barrage]|h|r!','Rocketspark leaps, beginning a |TInterface\\Icons\\inv_misc_missilelargecluster_red.blp:20|t |cFFFF0404|Hspell:162407|h[X21-01A Missile Barrage]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89111,'To procure and shreddinate.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89112,'Initiating the Lower Extremity Adjustment Protocol...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89113,'... Protocol.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89114,'Unacceptable heat parameters... initiating the Sublimega-Z Protocool.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89115,'','You should have left when you had the chance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89116,'Witness true power!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89117,'I\'d stand back... if I were you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89118,'Johnny Five... dead?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89119,'','Tormak asked me to accompany him on an adventure through Azeroth. I never thought we\'d end up here. I\'m glad I came with him, though.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89120,'Ye ain\'t gettin\' through me!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89121,'I\'ll cut ya!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89122,'Yer head will make a fine trophy!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89123,'Where\'s the rest o\' ya?','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89124,'Ye\'ve no idea who yer messin\' with.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89125,'Don\'t expect me ta go easy on ye.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89126,'For the Alliance!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89127,'Show me what ye\'ve got!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89128,'That\'s fer me grand pappy!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89129,'Ya got blood in me beard. Delicious.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89130,'Haha! Never faced a dwarf death knight, have ye?','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89131,'Keep yer kills up commander, I think I\'m winnin\'!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89132,'Another kill fer me!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89133,'Me beard\'s killed tougher!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89134,'When\'s the battle start? I\'m fallin\' asleep!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89135,'I\'ll drink to that!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89136,'At yer service, commander.','',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(89137,'What da ye want? Err... commander.','',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(89138,'Let me know when there\'s something ta kill.','',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(89139,'Is it time fer some good ol\' fashioned slaughter?','',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(89140,'Ye\'ve got the best dwarf this side a Draenor by yer side!','',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(89141,'Shay, commander ...hic! What\'sh yer policy on havin\' a bit o\' mead on the job?','',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(89142,'I\'m with ye, commander.','',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(89143,'Delvar Ironfist reportin\' fer duty.','',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(89144,'I\'m comin\' home, pappy...','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89145,'Psh... just a... flesh... wound...','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89146,'Is that me blood or yours?... Definitely mine...','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89147,'Commander... I\'m... finished....','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89148,'Feelin\' saucy, are ye?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89149,'Yer goin\' ta have ta try harder than that!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89150,'Me grand pappy would\'ve loved this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89151,'I\'ll only tell ye once. No touchin\' a the beard o\' face.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89152,'Let me show ye why they call me ironfist.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89153,'Come on. Put some feelin\' into it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89154,'I\'m a fighter o\' the Alliance. Ye stand no chance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89155,'By my axe, you\'ll pay fer that!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89156,'That\'s what I\'m talkin\' about!','',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(89157,'I\'m nigh unstoppable!','',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(89158,'','You march towards your grave.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89159,'','Beautiful death awaits you.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89160,'','Your end is near.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89161,'','I\'ll make this quick.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89162,'','Everything you know will burn!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89163,'','Death is inevitable.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89164,'','You know what happens when you play with fire.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89165,'','I hope your estate is in order.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89166,'','Revel in your final moments.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89167,'','Death is only the beginning.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89168,'','Welcome to the Dark Lady\'s embrace.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89169,'','The Dark Lady sends her regards.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89170,'','You\'re far more useful to me dead.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89171,'','You cannot stop death.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89172,'','Forever hold your peace.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89173,'','The hour of your departure has arrived.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89174,'','Anything that needs killing, commander?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89175,'','Any new assignments?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89176,'','At your service, commander.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89177,'','Good evening, commander.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89178,'','Lovely evening for some killing, don\'t you think?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89179,'','My staff is yours to command.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89180,'','Where shall we go next?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89181,'','Your wish is my desire, commander.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89182,'','Death will come... to you too...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89183,'','My service is... complete...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89184,'','Dark Lady... watch over me...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89185,'','My time... has come...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89186,'','Burn!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89187,'','You\'ll pay for that.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89188,'','I am forsaken.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89189,'','How do you kill that which has no life?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89190,'','I\'ll see you on the other side.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89191,'','It is time for your reckoning.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89192,'','I will bathe you in flames until there is nothing left.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89193,'','Stare into the darkness of your demise.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89194,'With danger at every corner, it\'s most wise to form a Party when exploring Ashran. If within a Party, I can teleport you to your Party Leader. $b$bWould you like me to Teleport you to your Party Leader?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89195,'','My power grows.',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(89196,'','The Dark Lady smiles upon me.',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(89197,'Yes, Teleport me to my Party Leader.','Yes, Teleport me to my Party Leader.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89198,'A model with skill such as mine does not come without dedication.  \n\nI have spent a lifetime perfecting my signature poses.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89199,'Show me \"Le Talbuk!\"','Show me \"Le Talbuk!\"',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(89200,'Okay, how about \"Azure Steel?\"','Okay, how about \"Azure Steel?\"',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(89201,'Now show me \"Magnuum!\"','Now show me \"Magnuum!\"',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(89202,'A classic pose. Stand back and let me show you how it\'s done.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89203,'Le Talbuk!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89204,'This is my most popular pose. Brace yourself.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89205,'Azure Steel!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89206,'Ah, Magnuum. I have been practicing for years to perfect it. Let me show you.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89207,'Magnuum!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89208,'A Horde spy has snuck in amidst the chaos!','A Horde spy has snuck in amidst the chaos!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89209,'A Ravenous Goren is feasting on your garrison\'s resources!','A Ravenous Goren is feasting on your garrison\'s resources!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89210,'A Traitorous Looter is looting your buildings!','A Traitorous Looter is looting your buildings!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89211,'Dere be danger at every corner, ya be wise to form a Party when explorin\' Ashran. If ya within a Party, I can teleport ya to your Party Leader. $b$bTeleport ya to ya Party Leader?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89212,'Infiltrators Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89213,'Goldsniffers Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89214,'Turncoats Brought to Justice: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89215,'Together, we will defeat the Shadow Council.','',1,0,0,0,0,0,0,7,0,0,44991,0,26124),
(89216,'Sorry, $n.','Sorry, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89217,'Not so fast!','Not so fast!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89218,'So eager to run away?','So eager to run away?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89219,'Azuka isn\'t finished with you yet.','Azuka isn\'t finished with you yet.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89220,'You don\'t stand a chance.','You don\'t stand a chance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89221,'World Broadcast Text Test','World Broadcast Text Test',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89222,'','Pitiful. Just as I expected.',0,0,0,0,0,0,0,0,0,0,0,46338,26124),
(89223,'Teleport to Party Leader','Teleport to Party Leader',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89224,'Teleport to your Party Leader?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89225,'Teleport to your Party Leader?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89230,'I will gladly give my life for the Iron Horde!','I will gladly give my life for the Iron Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89231,'','Enough! It\'s time to show you the true power of this blade.',0,0,0,0,0,0,0,0,0,0,0,46335,26124),
(89232,'','My blade grows stronger!',0,0,0,0,0,0,0,0,0,0,0,46337,26124),
(89233,'','Ya be needin\' someone for a job? I\'ll find ya two.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89234,'Who\'s looking for a job?','Who\'s looking for a job?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89235,'The Talon King\'s power belongs to the children of Skettis.$B$BReshad should never have shared it with an outsider...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89236,'|TInterface\\Icons\\Spell_Fire_Fireball02:20|t You are carrying |cFFFF0000|Hspell:160702|h[Blackrock Mortar Shells]|h|r. Hop in a Blackrock Turret to use them!','|TInterface\\Icons\\Spell_Fire_Fireball02:20|t You are carrying |cFFFF0000|Hspell:160702|h[Blackrock Mortar Shells]|h|r. Hop in a Blackrock Turret to use them!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(89237,'Iskar wanted to bring Terokk back with a body of his own. But would the Talon King have saved us, or lead us further into darkness?$B$BI was not willing to repeat the mistakes of our past.$B$BIn you, I saw a worthy steward of the Talon King\'s power. Ishaal agreed, and helped me to bind your essences together.$B$BIskar will not be happy about this, but what\'s done is done.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89238,'In my days with the rangari, I have learned many nuances of skinning the varied beasts of Draenor.\n\nNow that I am in Stormshield, however, I find it is much more enjoyable to pass these teachings onto others, than to toil in the fields with the skinning knife.\n\nWouldn\'t you agree?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89239,'','That Swann may not have been born a dwarf, but the heat of the forge runs through her veins. \n\nI could not ask for a finer apprentice.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(89240,'','Come close heroes, and let me heal your wounds.',1,0,0,0,0,0,0,0,0,36470,0,0,26124),
(89241,'','No pets up to the challenge?  I don\'t have time for amateurs, come back when you have a few fights under your belt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89242,'','Come close heroes, and let me heal your wounds.',1,0,0,0,0,0,0,0,0,31197,0,0,26124),
(89243,'','Sanketsu! Unleash your power!',0,0,0,0,0,0,0,0,0,0,0,46336,26124),
(89244,'Slay the Burning Blade Initiate before they can reach Azuka!','Slay the Burning Blade Initiate before they can reach Azuka!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89245,'It is good that you have come to Ashran, $C. You will likely be needed in the days to come.\n\nThe artifacts found on this island from the ancient ogre kingdom may be the determining factor in our battle against the Iron Horde. Unfortunately, the Horde has decided that they wish to take this knowledge for their own, in spite of our truce.\n\nWe must not let the Horde impede our efforts against our foe here on Draenor. Take the battle to them and pry the artifacts from their dead hands if you must!\n\nFor the Alliance!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(89246,'Our people appreciate the aid you have lent us against the Adherents of Rukhmar. \n\nWe will not forget your generosity.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(89247,'The appearance of the Order of the Awakened vexes many of the Outcasts. Though they claim their intentions are pure, their kind has wronged us so many times before.\n\nWe hope they are true to their words, but for now we will wait and see.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(89248,'I am not a fighter myself, but I feel like even the most battle-minded of us should step away from time to time to enjoy some peace and quiet.\n\nFor me, there\'s no better way to do so then with a fishing rod in your hand and the gentle sounds of the ocean. \n\nWhat do you think, $C?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(89249,'Train me in Fishing.','Train me in Fishing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89250,'Is that $n? I can\'t believe $Ghe:she;\'s in Stormshield!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(89251,'$n has come to Stormshield! I\'ve never seen a finer $c in my day!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(89252,'Look, $n has arrived! This may be the stroke that turns the tide of this battle!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(89253,'','What is your command?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89254,'Switch back to orc grunts.','Switch back to orc grunts.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89255,'I want to recruit guards from other lands.','I want to recruit guards from other lands.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89256,'The Horde has conquered Stormshield Hold!','',0,0,0,0,0,0,0,0,0,30987,0,0,26124),
(89257,'The Alliance has conquered Warspear Outpost!','',0,0,0,0,0,0,0,0,0,30987,0,0,26124),
(89258,'If you are exalted by Undercity, Thunder Bluff, the Darkspear trolls, Silvermoon City, Bilgewater Port, the Huojin pandaren, or if you are a death knight exalted by the Knights of the Ebon Blade, you can recruit guards from their respective ranks by talking to the right recruiting officer in your Great Hall.','If you are exalted by Undercity, Thunder Bluff, the Darkspear trolls, Silvermoon City, Bilgewater Port, the Huojin pandaren, or if you are a death knight exalted by the Knights of the Ebon Blade, you can recruit guards from their respective ranks by talking to the right recruiting officer in your Great Hall.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89259,'The shadows are restless.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89260,'Your time has come.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89261,'Gaze into the abyss!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89262,'RaAWK!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89263,'The darkness comes for you.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89264,'Your fate has already been set.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89265,'Come closer... the shadow fiends hunger.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89266,'You will be eradicated.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89267,'A feast for the shadow fiends.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89268,'Fade away.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89269,'Kaw-ha-ha! Fool!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89270,'Wither and fall.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89271,'Ra-aawk! Pathetic.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89272,'Welcome the shadow\'s embrace.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89273,'Enough.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89274,'I had expected more.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89275,'Commander.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89276,'Shadows gather...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89277,'What ruin shall we dispense today?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89278,'I have seen good omens for us.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89279,'I am prepared.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89280,'As you wish.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89281,'You called?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89282,'The shadows smile upon you, commander.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89283,'At last... I am free.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89284,'So much... left... undone.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89285,'I... can-raAWK!... Go no further...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89286,'The shadows... welcome me...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89287,'Gaze upon your demise.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89288,'I will be your end.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89289,'Your future is... short.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89290,'Suffer... as I have.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89291,'Kaw-rawk!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89292,'You know nothing of pain.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89293,'Begone!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89294,'Writhe in agony.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89295,'You die!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89296,'This our territory!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89297,'Leorajh keep friends alive.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89298,'Sun rock protects us.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89299,'Battle make us stronger.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89300,'Leorajh bring glory to clan.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89301,'Leorajh ready for anything.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89302,'We fight together.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89303,'Leorajh kill with purpose.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89304,'Learn much from this.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89305,'Weak!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89306,'Our clan is strongest!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89307,'Go away!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89308,'You will not hurt master.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89309,'Sun rock never fail us.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89310,'Leorajh understands you now.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89311,'New lessons today?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(89312,'<The scroll details a secret war council meeting that is to take place within Sunspring Watchpost. In order to call the members together, the signal horn in front of the Warsong meeting chambers must be blown.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89313,'Leorajh use sun rock, help clan.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89314,'What teaching does commander bring?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(89315,'Leorajh ready to learn.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89316,'Where we going?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(89317,'If you require our aid, the tauren will provide it.','If you require our aid, the tauren will provide it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89318,'Leorajh up for anything.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89319,'You call Leorajh?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(89320,'For good of clan.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89321,'Was only beginning... to understand...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89322,'Leorajh... hurt...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89323,'Sun rock... not help...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89324,'Why... Leorajh... cold...?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89325,'Leorajh help!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89326,'You no hurt master!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89327,'You not so tough.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89328,'Leorajh make you hurt.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89329,'Do not worry. Leorajh heal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89330,'Leorajh heal clan.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89331,'Furies on our side.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89332,'Sun rock help us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89333,'Do you feel that? RUN! It\'s a STAMPEDE!','',0,0,0,0,0,0,0,0,0,31197,8332,0,26124),
(89334,'The Darkspear trolls are yours to command.','The Darkspear trolls are yours to command.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89335,'The archmage gestures toward the forge and awaits your return with the fiery heart of Krosnis.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89336,'I will leave the defense of the garrison to the Darkspear trolls.','I will leave the defense of the garrison to the Darkspear trolls.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89337,'I want the tauren to protect the garrison.','I want the tauren to protect the garrison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89338,'','Like I said, the claw has a strange effect on the mounts we\'ve got here. If ye have it with ye when training a mount-in-training, your mount will be MUCH more vulnerable.$B$BShould ye find the training not rough enough, ye might want to challenge yourself.$B$BI\'d have a pretty hefty prize for anyone that could manage that!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89339,'What are your orders, commander?','What are your orders, commander?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89340,'I want the Forsaken to defend the garrison.','I want the Forsaken to defend the garrison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89341,'The Alliance has defended Stormshield Hold!','',0,0,0,0,0,0,0,0,0,30987,48252,0,26124),
(89342,'What are your orders, commander?','What are your orders, commander?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89343,'I want the blood elves to defend the garrison.','I want the blood elves to defend the garrison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89344,'The Horde has defended Warspear Outpost!','',0,0,0,0,0,0,0,0,0,30987,48251,0,26124),
(89345,'Need something, commander? I\'m sure we can work it out.','Need something, commander? I\'m sure we can work it out.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89346,'I want the goblins to defend the garrison.','I want the goblins to defend the garrison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89347,'Our warriors return via the north gate! They bring treasures from their recent raid!','Our warriors return via the north gate! They bring treasures from their recent raid!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89348,'At least we\'ve wounded it!  How dangerous can it be?','At least we\'ve wounded it!  How dangerous can it be?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89349,'There\'s no way I\'m going back in there, did you see what it did?','There\'s no way I\'m going back in there, did you see what it did?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89350,'|TInterface\\Icons\\Spell_Arcane_Blast.blp:20|t You are afflicted with |cFFFF0404|Hspell:162186|h[Expel Magic: Arcane]|h|r!','|TInterface\\Icons\\Spell_Arcane_Blast.blp:20|t You are afflicted with |cFFFF0404|Hspell:162186|h[Expel Magic: Arcane]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(89351,'Greetings, commander. How can I be of service?','Greetings, commander. How can I be of service?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89352,'I want the Huojin pandaren to defend the garrison.','I want the Huojin pandaren to defend the garrison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89353,'','I\'m wounded, leave me. Protect the village below.',0,0,0,0,0,0,0,0,0,0,0,46522,26124),
(89354,'','You should not have come here.',0,0,0,0,0,0,0,0,0,0,0,46516,26124),
(89355,'','You were no match for us.',0,0,0,0,0,0,0,0,0,0,0,46517,26124),
(89356,'','One less problem for the Alliance.',0,0,0,0,0,0,0,0,0,0,0,46518,26124),
(89357,'','Your advance stops here!',0,0,0,0,0,0,0,0,0,0,0,46521,26124),
(89358,'Do you feel that? RUN! It\'s a STAMPEDE!','',0,0,0,0,0,0,0,0,0,31196,8333,0,26124),
(89359,'Lookout! The Horde has summoned a Frostwyrm! Get out of the main road!','',0,0,0,0,0,0,0,0,0,31196,8333,0,26124),
(89360,'Our warriors return via the south gate! They bring treasures from their recent raid!','Our warriors return via the south gate! They bring treasures from their recent raid!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89361,'I sell designs for the techniques used to harness the power of Draenor\'s crystals. \n\nIf you are skilled enough, you may benefit greatly from this knowledge.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89362,'I have for sale a collection of plans for the most wondrous creations of your imagination!\n\nCare to take a look?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89363,'Do you have what it takes to shape the metals of Draenor to your bidding? \n\nIf you do, then my plans may be of use to you.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(89364,'','Ready to turn those raggedy old leathers into something worth wearing?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(89365,'I am quite busy, as you can no doubt see. \n\nAre you going to buy something?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89366,'I can reveal to you the greatest secrets of Inscription if you have the proper skill.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89367,'Good day $Gsir:mam;, Have anything you want me to break down for you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89368,'Send or receive mail.','Send or receive mail.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89369,'Ra-aawwk!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89370,'','Interested in rare pets? My crawlies are the best!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(89371,'','You need to talk to Audrey Burnhep in Stormwind City!  Any guard there should be able to give you directions to find her.\n\nYou will find a portal to Stormwind inside the Mage Tower.  Good luck!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89372,'Come! You have your orders. I ride for Tanaan.','',0,0,0,0,0,0,0,0,4,0,46512,0,26124),
(89373,'The battle for supremacy begins in 2 minutes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(89374,'The battle for supremacy begins in 1 minute!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(89375,'The battle for supremacy begins in 30 seconds!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(89376,'The battle for supremacy has begun!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(89377,'I need a way to level my followers up quickly.','I need a way to level my followers up quickly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89378,'Ner\'zhul! Your ambitions are at an end. Today will be the day of your final judgment!','',0,0,0,0,0,0,5,0,0,0,45379,0,26124),
(89379,'I only hope my people will understand.','',0,0,0,0,0,0,1,0,6,0,45376,0,26124),
(89380,'','You cannot escape my blades!',0,0,0,0,0,0,0,0,0,0,0,46332,26124),
(89381,'','Your power will be MINE!',0,0,0,0,0,0,0,0,0,0,0,46333,26124),
(89382,'','You aren\'t afraid of a little blood, are you?',0,0,0,0,0,0,0,0,0,0,0,46334,26124),
(89383,'Hello there stranger!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89384,'','Hey there, boss, Want me to melt something down for ya?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89385,'','Champion! Let us send this creature back to the shadows!',0,0,0,0,0,0,5,0,0,0,0,45605,26124),
(89386,'Wibson Strike!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89387,'Save me, Wibson!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89388,'Oh, now you asked for it... WIBSON! GET THEM!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89389,'Wibson, use your sand storm, now! Do-do-do-do-do!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89390,'Wibson, use your fire breath on them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89391,'Wibson, slam attack, now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89392,'Wibson, hit them with your confuse ray!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89393,'Oh Wibson, I knew we could do it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89394,'$n is victorious!','$n is victorious!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89395,'The Coliseum will close in 5 minutes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89396,'This is going to hurt you so much more than it will hurt me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89397,'Another trip \'round the murder-go-round, eh?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89398,'Let\'s have a little bit of fun.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89399,'Yes... you will do nicely.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89400,'Very well then. I\'ll kill you first.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89401,'I will kill you, take a break, raise you from the dead, and then kill you again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89402,'Oh good... more of you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89403,'You\'re begging me to cut your head off, aren\'t you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89404,'That tickled.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89405,'Scream louder... I can\'t hear you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89406,'I had really thought that might have been a challenge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89407,'For my next trick... I will make your corpse dance around like a marionette!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89408,'Really, now. Is that the best you can do?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89409,'That was short lived.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89410,'I suppose I\'ll have to take what I can get.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89411,'Death is all that awaits you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89412,'Salutations, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89413,'I haven\'t killed anything in what feels like ages... might I go on a mission?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89414,'The Dark Lady watches over us, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89415,'Commander, I\'m sure you don\'t have a favorite amongst your followers... but if you did, let\'s be honest. I\'m by far the most capable soldier you\'ve got - I don\'t even sleep!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89416,'Your will is my own, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89417,'What is it you wish, commander? Say the word and consider it done.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89418,'I will lay my life on the line for you, commander... what\'s left of it, anyway.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89419,'Do you think Hellscream has any idea what\'s coming for him? The fool.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89420,'Death isn\'t so bad... the second time around.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89421,'The shadows are restless.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89422,'Your time has come.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89423,'Gaze into the abyss!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89424,'RaAWK!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89425,'A feast for the shadow fiends.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89426,'Fade away.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89427,'Kaw-ha-ha! Fool!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89428,'Wither and fall.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89429,'Commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89430,'Shadows gather...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89431,'What ruin shall we dispense today?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89432,'I have seen good omens for us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89433,'I am prepared.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89434,'At last... I am free.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89435,'You die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89436,'This our territory!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89437,'Leorajh keep friends alive.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89438,'Sun rock protect us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89439,'Battle make us stronger.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89440,'Leorajh bring glory to clan.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89441,'Leorajh kill with purpose.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89442,'Learn much from this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89443,'Weak!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89444,'Our clan is strongest!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89445,'New lessons today?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89446,'Leorajh use sun rock, help clan.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89447,'What teaching does commander bring?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89448,'Leorajh ready to learn.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89449,'Was only beginning... to understand...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89450,'Come quickly. We must not let him overwhelm us.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(89451,'For Terokk!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89452,'Back, you filth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89453,'KrAWW!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89454,'Let us get to work.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89455,'Grim... but necessary','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89456,'Die well.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89457,'Hah - too easy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89458,'This is how we do it in Skettis.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89459,'Our path is right, of this I am certain.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89460,'My life for the Talon King.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89461,'Ready when you are, my king.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89462,'By your command.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89463,'I will follow you to the end.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89464,'My service has ended...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89465,'The Knights of the Ebon Blade are here.','The Knights of the Ebon Blade are here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89466,'I want the Knights of the Ebon Blade to defend the garrison.','I want the Knights of the Ebon Blade to defend the garrison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89467,'|TInterface\\Icons\\SPELL_HOLY_PROCLAIMCHAMPION_02.BLP:##|t |cFFF00000%s|r is victorious!','|TInterface\\Icons\\SPELL_HOLY_PROCLAIMCHAMPION_02.BLP:##|t |cFFF00000%s|r is victorious!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89468,'Initializing defense sequence.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89469,'Actuating subjugation systems.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89470,'Threat detected.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89471,'Commencing conflict resolution routines.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89472,'Engaging purification module.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89473,'Murder drive online.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89474,'Anomaly detected.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89475,'Outcome optimal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89476,'Threat neutralized.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89477,'Sequence completed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89478,'Conflict resolved.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89479,'Relations module: Have a nice day. END: Relations module.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89480,'Apexis core online. Power reserves at ninety-nine percent.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89481,'Systems optimal. Awaiting input.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89482,'Maintenance cycle complete. Looping standby routine.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89483,'Master detected. Diverting power to relations module. Relations module: Greetings.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89484,'Relations module: Master, do I have a soul? Ha-ha-ha. Just kidding. END: Relations module.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89485,'Error: Locomotion systems non-functional. Jettisoning ellipses...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89486,'','The light shall protect us!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(89487,'I have failed my Horde, my tribe, my chieftain...','',0,0,0,0,0,0,0,0,0,0,46572,0,26124),
(89488,'','Present a challenge at least.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89489,'','I salute you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89490,'','You shall taste my blade.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89491,'','Glorious.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89492,'','Well fought.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89493,'','Lok\'tar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89494,'','Hail, $p.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89495,'Tiny thing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89496,'Beating time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89497,'Nobody beats Blook!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89498,'','We will persevere!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(89499,'But... Blook beats. Not beaten.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89500,'You beaten by Blook.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89501,'Blooked!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89502,'Beated!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89503,'Hail, Blook beater.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89504,'Hi beater boss.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89505,'I am Bashiok!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89506,'I... am... Bashiok.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89507,'You made a mistake comin\' ta Warspear.','',0,0,0,0,0,0,0,0,0,0,46566,0,26124),
(89508,'You think you can kill me with that? Ha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89509,'Another fool falls.','',0,0,0,0,0,0,0,0,0,0,46567,0,26124),
(89510,'Yes! Charge toward your death!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89511,'I\'m gonna punch a grin into your face.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89512,'You die better than ya fight.','',0,0,0,0,0,0,0,0,0,0,46568,0,26124),
(89513,'I am going to put a smile on your corpse.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89514,'You call that a fighting style? Ha ha ha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89515,'Your allies have no sense of humor, or pain threshold.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89516,'You are foolish ta challenge me!','',0,0,0,0,0,0,0,0,0,0,46570,0,26124),
(89517,'I laugh at my own defeat!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89518,'Slay dem all!','',0,0,0,0,0,0,0,0,0,0,46571,0,26124),
(89519,'I am all that is ORC!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89520,'Stay there, I\'m going to burn your corpse later.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89521,'Aw. You fell down.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89522,'Stop looking at me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89523,'Never fight like that again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89524,'May you have the last laugh, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89525,'Your troops seem afraid of my headbutting competition.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89526,'How you find me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89527,'Dagg is the greatest thief that ever lived!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89528,'You no see me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89529,'How... you... see... Dagg... ?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89530,'Dagg rolling need.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89531,'Dagg dibs on loot!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89532,'You find more treasure?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89533,'Always be looking for Dagg.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89534,'How you see through Dagg\'s dis guys?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89535,'Dis guys Dagg!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89536,'You best boss Dagg ever had. Dagg is unanimous in dis.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89537,'You\'s dead. Dagg is unanimous in dis.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89538,'Dat give Dagg idea for new dis guys.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89539,'Fresh prey.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89540,'More food for my pet.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89541,'Ah! Something to test my new traps on.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89542,'This... was a terrible... idea...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89543,'Pathetic.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89544,'You chose the wrong side, fool.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89545,'Still the highest predator on the food chain, commander?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89546,'For the Kirin Tor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89547,'What do you believe you will accomplish?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89548,'Oh dear, do you believe you will win?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89549,'Fascinating. How barbaric.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89550,'You do realize I am not really here, don\'t you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89551,'I\'m losing control of my image...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89552,'Well, that was an interesting result.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89553,'With some practice you might have been a greater threat.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89554,'Well met, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89555,'Greetings Commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89556,'','I am going to burn a smile on that face of yours.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89557,'','Hahahaha!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89558,'','I am going to wear your skull.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89559,'','I will get you to laugh.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89560,'','I... die... laughing!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89561,'','Burn my body... keep... my skull.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89562,'','Don\'t die yet. I\'m not done with you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89563,'','Say hello to goodbye!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89564,'','When you die, might I wear your skull?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89565,'','May your enemies burn!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89566,'','For the Frostwolves!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89567,'','Spirits guide me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89568,'','You have bit off more than you can chew, $t.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89569,'','We stand ready!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89570,'','For honor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89571,'','Honorless fool.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89572,'','Victory for the Frostwolves.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89573,'','Asha... I\'m coming...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89574,'','Hail.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89575,'This is what I call a target rich environment.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89576,'I come for you, $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89577,'Going... down...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89578,'Top axe!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89579,'Requesting a flyby.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89580,'You can be my wingman anytime.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89581,'Let us see what you are made of.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89582,'Can you fold in half? Let us see.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89583,'A challenger?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89584,'Well... fought...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89585,'Boot to the head.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89586,'You must learn to be faster than any punch.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89587,'You never stood a chance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89588,'These soldiers of yours need to be tougher.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89589,'I look forward to our next challenge, Commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89590,'Lug\'dol is nearby.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89591,'','One shot, one kill.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89592,'','You cannot escape.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89593,'','I have a poison just for you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89594,'','What a waste of arrows.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89595,'','Target practice.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89596,'','Burn... my body...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89597,'','Cover your tracks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89598,'Ya dead, mon. Ya just don\' know it yet.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89599,'We gonna kill ya mon. Nothin\' personal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89600,'For da Warchief!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89601,'For da Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89602,'Neva\' know what hit ya.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89603,'Ya gonna be bleedin\' soon, mon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89604,'It gonna take... more... dan... dat to kill... me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89605,'Ya dead, mon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89606,'Anotha\' one be down.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89607,'Ding!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89608,'Taz\'dingo!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89609,'Watch da shadows, boss-mon','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89610,'Eh, boss-mon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89611,'Vol\'jin sends his regards.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89612,'May I take your cloak? No? Very well, commander. The commander is, of course, welcome to continue dripping mud all over the floor that I have spent just this morning polishing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89613,'You would ally with the enemy, Tormmok? You betray your king!','',0,0,0,0,0,0,0,0,0,29687,0,0,26124),
(89614,'Yeah, yeah let\'s, let\'s... incinerate and pulverate \'em!','',0,0,0,0,0,0,0,0,0,0,47413,0,26124),
(89615,'Ha! Quit... hitting yourselves!','',0,0,0,0,0,0,0,0,0,0,47416,0,26124),
(89616,'Pump the forge up to overdrive!','',0,0,0,0,0,0,0,0,0,0,47406,0,26124),
(89617,'I\'ll be back!','',0,0,0,0,0,0,0,0,0,0,47418,0,26124),
(89618,'Wait till they get a load of me.','',0,0,0,0,0,0,0,0,0,0,47419,0,26124),
(89619,'No, Aaagh! I wasn\'t done yet!','',0,0,0,0,0,0,0,0,0,0,47415,0,26124),
(89620,'No, not like this....','',0,0,0,0,0,0,0,0,0,0,47410,0,26124),
(89621,'I\'m going to take you DOWN!','',0,0,0,0,0,0,0,0,0,0,47409,0,26124),
(89622,'Ahh, I\'ve been waiting for something to pulverize and incinerate!','',0,0,0,0,0,0,0,0,0,0,47403,0,26124),
(89623,'Defenseless weakling!','',0,0,0,0,0,0,0,0,0,0,47405,0,26124),
(89624,'There can only be... two! Ha ha ha!','',0,0,0,0,0,0,0,0,0,0,47407,0,26124),
(89625,'Hah, you think that was good? You just wait!','',0,0,0,0,0,0,0,0,0,0,47408,0,26124),
(89626,'If it bleeds, we can kill it!','',0,0,0,0,0,0,0,0,0,0,47404,0,26124),
(89627,'Hear me now... and believe me... later....','',0,0,0,0,0,0,0,0,0,0,47399,0,26124),
(89628,'Your bones will be crushed to dust!','',0,0,0,0,0,0,0,0,0,0,47398,0,26124),
(89629,'Oh no yeh don\'t!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89630,'Imma beat dis one down!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89631,'C\'mere! I got sumtun\' fer yeh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89632,'Yer gettin\' a good swift kick inna jimmies.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89633,'Oh yeh want somma dis do yeh?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89634,'Oh aye, that\'s watcha get.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89635,'And I\'ll do tha same ta yer mum!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89636,'An\' stay down!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89637,'Har! Smoked \'at one.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89638,'%s belches.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89639,'Ah-hyup!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89640,'Jes\' gimmie somethun\' ta shoot.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89641,'Issit time ta eat yet?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89642,'They won\'t let me near tha powder reserves. Whadder they reservin\' it fer, anyways!?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89643,'Yer heals is CRAP!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89644,'I have no king. I\'ve chosen my side.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89645,'I loot the hat.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89646,'%s squeaks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89647,'I. AM. BASHIOK!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89648,'I am Bashiok.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89649,'I AM Bashiok.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89650,'Ahahahaha!','',0,0,0,0,0,0,0,0,0,0,45971,0,26124),
(89651,'Bugs, you are bugs to me!','',0,0,0,0,0,0,0,0,0,0,45972,0,26124),
(89652,'More, bring more to die at my blade!','',0,0,0,0,0,0,0,0,0,0,45973,0,26124),
(89653,'You are a fool to oppose me weakling!','',0,0,0,0,0,0,0,0,0,0,45974,0,26124),
(89654,'Too easy','',0,0,0,0,0,0,0,0,0,0,45975,0,26124),
(89655,'Give in now, Socrethar. You have been bested.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89656,'The empire... will rise again!','',0,0,0,0,0,0,0,0,0,0,45967,0,26124),
(89657,'Your will is meaningless here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89658,'Victory or death!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89659,'You should run while you can.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89660,'No foe can stand to my might!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89661,'You should have ran.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89662,'Hammer! Meet face!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89663,'I\'ll forge a weapon in your honor commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89664,'I saw a new shipment of ore. I\'ll make sure it goes to good use.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89665,'What do you ask of me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89666,'Thank you once more for my freedom.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89667,'Commander, I can never repay the debt.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89668,'I have not yet gotten used to being under the sky all day.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89669,'At least... I die... free.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89670,'Will you grab my sword, commander? I cannot penetrate the runic circle Dar\'gud placed around it.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89671,'Are these orcs alive, or undead?','Are these orcs alive, or undead?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89672,'I am eternally grateful.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89673,'I live another day. You have my thanks.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89674,'The furies will never forget this, thank you.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89675,'You have made a powerful ally, friend.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89676,'Saving','Saving',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(89677,'STAND AT ATTENTION!','',15,0,0,0,0,0,15,0,0,0,0,0,26124),
(89678,'GET BACK TO WORK!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89679,'I\'M SURROUNDED BY LAZY RUNTS!','',0,0,15,0,0,0,15,0,0,0,0,0,26124),
(89680,'','Do you see the light up ahead? That must be it!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89681,'','That light up ahead must be where the crystal is. Hellmaw must be there.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89682,'The scent of blood attracts nearby goren nibblers!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89683,'You will pay dearly for your interference, mortal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89684,'','Well done! Let us get the Light of Exodus to safety.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89685,'','You hear a barely audible whistle come from the south.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89686,'','And don\'t come back, demon scum. Commander, let\'s get the Light of Exodus out of here.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89687,'|TInterface\\Icons\\Ability_Druid_EmpoweredTouch:20|t Yalnu begins to channel |cFFFF0404|Hspell:169613|h[Genesis]|h|r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89688,'Bah, those peons at the docks must be slacking.','Bah, those peons at the docks must be slacking.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89689,'What happened?  Our machinery stopped working.','What happened?  Our machinery stopped working.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89690,'Send one of the runts down to the docks to check this out.','Send one of the runts down to the docks to check this out.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89691,'Send one of the runts down to the furnace to check this out.','Send one of the runts down to the furnace to check this out.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89692,'What happened to the presses?  They\'ve gone cold!','What happened to the presses?  They\'ve gone cold!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89693,'Where\'s Foreman Feldspar? Someone needs to get these running again!','Where\'s Foreman Feldspar? Someone needs to get these running again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89694,'Keep them away from me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89695,'I\'m not dying first this time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89696,'Stay away!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89697,'Stop it. Stop... just stop that.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89698,'I\'m keeping the loot.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89699,'Whew.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89700,'I got one. Hey guys - I got one!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89701,'\"Warlord\" Schweitzer. I like the sound of that.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89702,'One step closer to High Marshall.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89703,'This garrison needs a trampoline.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89704,'When are you building the ball-pit?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89705,'Can we build a brewery next?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89706,'Commander, the men are demanding a water slide. By \"the men\" I mean me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89707,'When are you building the mosh-pit?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89708,'Can we get a park? Like Stormwind. But, not like Stormwind.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89709,'Commander I\'d like to formally apologize for last night\'s wet-tabard contest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89710,'...again... ?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89711,'Suck mana, twerp!','Suck mana, twerp!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89712,'I\'ve got this.','I\'ve got this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89713,'Eat it!','Eat it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89714,'Have at it!','Have at it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89715,'Weak.','Weak.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89716,'Ha HAH - for Gnomeregan!','Ha HAH - for Gnomeregan!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89717,'Pathetic.','Pathetic.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89718,'Sad.','Sad.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89719,'Dead!','Dead!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89720,'Might I suggest upgraded mage facilities?','Might I suggest upgraded mage facilities?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89721,'Commander, how do I get into the more... lucrative missions?','Commander, how do I get into the more... lucrative missions?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89722,'My gear is gemmed and enchanted, commander!','My gear is gemmed and enchanted, commander!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89723,'When you have the time, commander, I\'d like to suggest some ways you can optimize your gear.','When you have the time, commander, I\'d like to suggest some ways you can optimize your gear.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89724,'Out... of... manaaaa...','Out... of... manaaaa...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89725,'','I\'ll get this one.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89726,'','Cover me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89727,'','Call the shot...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89728,'','Oooh, right in the neck!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89729,'','Ooh! Gut shot.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89730,'','Ooh! Gut shot.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89731,'','Ow! Right through the head.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89732,'','Dropped one.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89733,'','I\'m your biggest fan, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89734,'','I\'m so glad to be here. My last party was... I think they\'re dead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89735,'','Shadowmoon is so pretty!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89736,'','This garrison is SO much nicer than Admiral Taylor\'s.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89737,'','...help!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89738,'Fly me to Warspear Outpost!','Fly me to Warspear Outpost!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89739,'Quick $n, the Grand Marshal wants to see you back at Stormshield at once!','Quick $n, the Grand Marshal wants to see you back at Stormshield at once!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89740,'','Fresh bread! Fresh bread for sale!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(89741,'','Warm, wholesome bread!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(89742,'','Rolls, buns and bread. Fresh from the oven!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(89743,'','Come and get your freshly baked bread!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(89744,'I hear that Harrison Jones still isn\'t any closer to finding that artifact.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89745,'','How long does he plan to take? We can\'t stay holed up here forever with the Horde breathing down our necks.',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(89746,'I hope it\'s not much longer. I haven\'t seen my family in Stormwind in months.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89747,'','The Horde is growing bolder every day. They attacked another one of our outposts this morning.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89748,'Did those mongrels forget that we\'re supposed to have a treaty?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(89749,'','It looks that way. I think they fear that if we do find the artifact, we\'ll end up using it against them.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89750,'If they keep attacking our soldiers the way they have been, they may just drive us to it.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89751,'Flank and destroy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89752,'Annihilate them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89753,'For Orgrimmar, for the Horde - for the glory of our fathers!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89754,'I will end this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89755,'Leave their bones to amuse the wolves.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89756,'%s spits on the corpse.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89757,'The taste of victory never sours.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89758,'Take the body but save me the teeth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89759,'Nothing more beautiful than blood on the snow.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89760,'Glory to the mighty Horde, commander!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89761,'None dare question your strength.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89762,'Frostfire is secured for the Horde. If we need to construct another garrison, I volunteer to be among the vanguard.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89763,'Glory to the new Warchief! Even if he isn\'t an orc.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89764,'Send me to the front. My strength is yours to command.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89765,'We will see our enemies driven before us! We will hear the lamentations of - whatever would lament these beasts. I can\'t wait to hear them lamenting! Ha hah! Lamenters are funny.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89766,'I give my life... for... THE HORDE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89767,'','Eek - get them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89768,'','Oh! Oh! I\'m fighting!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89769,'','They\'re in our base! They\'re breaking all my things!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89770,'','I\'m casting magic!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89771,'','Yea THAT happened.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89772,'','And I wasn\'t even paying attention.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89773,'','Yay!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89774,'','So dead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89775,'','Hi!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89776,'','Oooh, I like your gear.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89777,'','I love what you\'ve done with your place.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89778,'','I\'m sorry about all my demons burning your things. They do that.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89779,'','But... but... no!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89780,'I will disintegrate them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89781,'Heh. Heh. Heh. Heh heh HAH.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89782,'Oh such sweet glorious slaughter!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89783,'Look what just walked in. Parts!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89784,'Save the best parts for me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89785,'Save the limbs, I can use those.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89786,'Face: Melted.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89787,'If there are any brains left, save them for me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89788,'I could build such a wonderful creature from these parts.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89789,'Those organs will fetch a pretty price.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89790,'My work is progressing wonderfully on Draenor. There just aren\'t as many \"laws\" here to fret over.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89791,'I was wondering if I had your permission to \'experiment\' on some of the guards... ?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89792,'Can I offer you some embalming fluid, commander?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89793,'Let me run this by you: Instead of five ordinary-sized guards, what if we stitched together one enormous shambly guard? Think of the possibilities!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89794,'I adore the frigid cold of Frostfire Ridge. It arrests corpse decay.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89795,'How are you doing, commander? Are you happy with your arms? would you like... a third? You know who to talk to.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89796,'Most of your other followers have redundant kidneys. You wouldn\'t mind if I \"borrowed\" a few? The bathtub is ready.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89797,'I will haunt you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89798,'Imma get dis one!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89799,'*Cough* Are we fighting something?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89800,'*Cough cough* Eh? We fightin\'?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89801,'Hey mon I kill dis one!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89802,'Dat\'s right.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89803,'Grav wit\' da kill, oh yah.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89804,'$n (Alliance) has looted the |c00FFFF00|Hspell:168506|h[Ancient Artifact]|h|r!','',0,0,0,0,0,0,0,0,1,0,46851,0,26124),
(89805,'Mmnn-hmmm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89806,'Imma cook you for dinner.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89807,'$n (Horde) has looted the |c00FFFF00|Hspell:168506|h[Ancient Artifact]|h|r!','',0,0,0,0,0,0,0,0,0,0,46850,0,26124),
(89808,'Lookout it\'s da commander!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89809,'I ain\'t doin\' nothin\' wrong over here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89810,'Commander! You didn\'t see nothin\' did you? No? I\'m good, we all good. Everything be good here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89811,'Hey Commander you hungry?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89812,'Shhhh quiet here come da commander. Shh! Hey. Hi.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89813,'%s goes into a coughing fit.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89814,'For the... Allia- uh - HORDE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89815,'For somebody!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89816,'What are these guys doing here?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89817,'Don\'t kill me! I\'m a priest!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89818,'That was one hell of a bender last night. When did it start snowing in Shadowmoon?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89819,'Commander I uh - come closer - shhh - I think there\'s some Horde spies in our base.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89820,'What\'s with all the skulls and spikes? It\'s like... does the King know about this?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89821,'Commander I don\'t know what contractors you\'re using but if you ask me this looks like a Horde base.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89822,'Welcome, gladiators! You have been hand selected by Imperator Mar\'gok himself to participate in these gladiatorial games! An honor this great is reserved only for the most bloodthirsty and savage fighters of Draenor. May honor and victory be yours today!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89823,'I came across a Horde patrol trying to sweep around one of our outposts today.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89824,'','Did you, now? Were you spotted?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89825,'Yeah, one of em saw me. Knife to the eye took care of that.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89826,'Fly me to Stormshield Hold.','Fly me to Stormshield Hold.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89827,'Board the platform. It will take you to the arena floor, where glory awaits!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89828,'','Let me guess, subtlety not your strong suit?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89829,'I got myself a shiny new knife when I was out scouting today.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89830,'','Oh yeah? Where did you find it?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89831,'Belly of one of them goren.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89832,'Once that elevator starts moving this room will flood with deadly poison gas, killing anyone left behind. I suggest you get aboard the platform.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89833,'That\'s it, get bunched up on the platform. You don\'t want to be left behind down here. No, not with the poison gas that we\'ll be releasing in here to clear out cowards.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89834,'Get on the platform! The elevator will begin its glorious ascent into the arena shortly!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89835,'Good luck, champions! May the strongest among you earn glory in the Coliseum today!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89836,'','You found a knife in the stomach of a goren? What made you even think of cutting it open?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89837,'Where else do you think one of them things would keep its loot?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89838,'I... see...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89839,'I don\'t know why Harrison Jones asked us to come out here and help with the excavation. I can\'t hunt for a single artifact without an ogre trying to cut me in half!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89840,'If you think the ogres are bad, you should see the spirit ogres around that altar. Bad news, there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89841,'Spirit ogres? Geez, this island sure has some creative ways to kill a guy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89842,'So I hear that they\'re uncovering some interesting stuff in the mines. Harrison is staying pretty hush hush about it though.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89843,'Why do you think that is?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89844,'I spoke to one of the workers, and they think the place is haunted. They say folks are disappearing, and then there\'s the accidents.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89845,'Weird ones. Solid cave walls up and crumbling on a digger. Malfunctioning machinery chewing up its operator. They say it happens more and more the further down you go.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89846,'I don\'t like the sound of that. I think I\'ll just stay here at the inn.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89847,'You get no argument from me, there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89848,'Accidents? What kind of accidents?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89849,'How did you get over here?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89850,'It\'s quiet over here, don\'t you think? Almost... too quiet.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89851,'Poisoning','Poisoning',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(89852,'Hurry $n, Volrath has ordered you to return to Warspear at once!','Hurry $n, Volrath has ordered you to return to Warspear at once!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89853,'Kronus is born! Good work, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89854,'Look around you. Can you not see that we have already won?','',0,0,0,0,0,0,0,0,0,29905,0,0,26124),
(89855,'The artifact fragments contain enough magical power to restore this Earth Fury to full strength. $B$BHow many have you brought us?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89856,'Report from the field, sir!','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(89857,'De Alliance can\'t have Ashran, $c. Da powa of any Ogre artifacts here will be ours.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89858,'','Alliance soldiers, take their supplies quickly and take a gryphon back to Stormshield Stronghold!',0,0,0,0,0,0,70,0,0,36470,0,0,26124),
(89859,'','Alliance soldiers, we must leave now! Horde reinforcements are on their way.',0,0,0,0,0,0,0,0,0,36470,0,0,26124),
(89860,'','Retreat quickly, Alliance reinforcements are arriving soon!',0,0,0,0,0,0,0,0,0,36471,0,0,26124),
(89861,'','Plunder their supplies then grab a wyvern back to Warspear Outpost!',0,0,0,0,0,0,0,0,0,36471,0,0,26124),
(89862,'Loosen yer belts, ladies! We\'re eatin\' a feast tonight!','',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(89863,'','I shoot to kill.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89864,'','What are you lookin\' at?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89865,'By all that is unholy, what is that thing?','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89866,'','No one pulls a fast one on me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89867,'','Dark Lady save us all... it\'s worse than I thought.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89868,'It seems the ogres at Brute\'s Rise are employing large beasts to hurl giant boulders at our troops!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89869,'So the ogres like to throw stones, do they?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(89870,'I\'ll have Sprocket ready one of his tanks to pay them a visit. We\'ll see how their stones fare against steel.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(89871,'Thank you for your report, soldier. You may return to the field.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89872,'Yes sir!','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(89873,'Something resembling sap drools out of Acanthus\' mouth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89874,'Sir, our scouts report that the Horde forces are working to empower an ancient earth fury!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89875,'A fury of the earth, you say? That is troubling.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(89876,'I will have to confer with our druid allies. The ancient that they are awakening may be our only key to defeating such a force.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89877,'$n has placed a Savage Feast.','$n has placed a Savage Feast.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(89878,'Reports are coming in of a massive beast residing in the ogre mine.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89879,'None of our scouts have been able to get a good look at it, but its so massive it barely fits in the cave!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(89880,'We will have to alert our men fighting near the cave. Good work, soldier.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89881,'Commander, I suggest we get out o\' here. This is nae a place ye want ta stick around in.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89882,'','Disgusting. Commander, I\'ll watch your back while you grab what\'s left of that... thing.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89883,'Harrison Jones is reports that though he has received several fragments, he is no closer to discovering the location of the artifact we seek.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89884,'He requests more men to aid in the search.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89885,'He asks as if we have an endless supply of adventurers at our disposal. He will get whoever volunteers to aid him. Our soldiers are already spread thin due to the Horde threat.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89886,'The shadows have granted me new strength.','',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(89887,'Leorajh is stronger!','',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(89888,'Yes... I grow ever closer to the shadows.','',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(89889,'Leorajh more powerful than ever!','',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(89890,'There is the one we seek. Her staff is the key.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89891,'Yes... excellent. RaAWK!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89892,'Give Leorajh back his prayer beads!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89893,'Commander, we did it!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89894,'','Thanks sweetie. Now back to battle!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89895,'','I was dying in there! Thanks!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89896,'Alright, Twix... let\'s take a look at the fabled predator Aogexon!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89897,'We aren\'t the only ones with Prisoners, $c.$B$BOver at the Alliance base, underneath their main building lies their prison.$B$BWe just need to find those Stormshield Prison Keys to break them out.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89898,'','You got it boss! Initiating holo-projection D-092!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89899,'It\'s been said that Aogexon\'s fangs can cut through solid steel! Magnificent!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89900,'We simply must have Aogexon\'s fangs, Twixnee. They will make fine fossils one day!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89901,'Let\'s move on to the next specimen!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89902,'','Next up in the database is Bergruu. Initiating holo-projection D-093...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89903,'Ahh yes! Bergruu, the mighty Ironhide of the northern plains! Bergruu\'s horn is said to be the largest clefthoof horn ever seen...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89904,'','Has anyone actually gotten close enough to measure the thing?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89905,'Not yet! However, there are several collectors that would pay a fortune to acquire it.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89906,'Let\'s move on to Dekorhan, the mysterious and ancient Elekk of Nagrand!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89907,'','Initiating holo-projection D-095...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89908,'Elekk are one of the oldest living species on Draenor, and Dekorhan sightings have been recorded by the orcs for generations...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89909,'Pop quiz, Twix! How do you tell the age of an Elekk?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89910,'','Umm... by the size of its tusks?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89911,'Precisely! Did you learn that from me?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89912,'','That size matters? Uhh... yeah, sure! You bet!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89913,'Now then, let\'s review the deadly and elusive talbuk known as Direhoof...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89914,'','Holo-projection D-096 initiated, boss!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89915,'Direhoof is the most dangerous talbuk this side of Nagrand, and a specimen of rare quality...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89916,'It\'s our duty as archaeologists to preserve this mighty beast while still in the prime of its life!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89917,'','Just hearing you speak makes me proud to be an archaeologist, sir!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89918,'As it should, Twixnee... as it should.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89919,'Now, on to the next specimen!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89920,'','Initiating holo-projection D-097... Gagrog the Brutal!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89921,'Such a magnificently brutal creature! Few Gronn are as feared as Gagrog the Brutal!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89922,'','Hide the women and the children! Hide everybody!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(89923,'Somewhere out there, in a private collection, is an empty place just waiting for Gagrog\'s skull to fill the void.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89924,'Boss, you\'re bringing tears to my eyes!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89925,'This is our town, scrub.','This is our town, scrub.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89926,'Yeah, beat it!','Yeah, beat it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89927,'Behold the power of the Legion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89928,'I will destroy you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89929,'Now, let\'s take a look at Mu\'gra! Holo-projection D-098, Twix...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89930,'','D-098 coming right up!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89931,'Mu\'gra... my old nemesis!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89932,'','Nemesis? Do you and this hippo have some kind of history?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89933,'Let\'s just say that extracting a hippo tooth for preservation is far more dangerous while the hippo is alive...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89934,'','The things we archaeologists have to deal with these days! Sheesh!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89935,'Let us continue on to the next specimen!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89936,'','You got it, Mr. G! Initiating holo-projection D-099...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89937,'Ahh, yes! Here we have Thek\'talon, a windroc of superb size and ferocity.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89938,'','Does it have large talons?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89939,'Indeed, Twix... and razor sharp! It\'s a shame we don\'t have time to allow Thek\'talon to die naturally and slowly fossilize through the ages...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89940,'...instead, it is our duty to lend nature a helping hand and speed up the process!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89941,'','Natural fossilization? Ain\'t nobody got time for that!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89942,'Twixnee, please intiate the holo-projection for Xelganak!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89943,'','Sure thing, boss! Initiating holo-projection D-100...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89944,'Xelganak is a most peculiar creature indeed! The bioluminescent fluid in Xelganak\'s sac is highly corrosive and can be propelled at high velocity.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89945,'','So Xelganak could melt someone\'s face off?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89946,'What do you think happened to Bozzil? He wasn\'t born looking like that!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89947,'','<Rachelle gives you a polite nod.>$B$BGreetings.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89948,'','Yes?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89949,'','Hello.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89950,'','Good day.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89951,'','Need something?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89952,'','<Rachelle looks at her tools.>$B$BThere\'s much work to do.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89953,'','<Rachelle shrugs.>$B$BI\'m not much for words.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89954,'','What can I do for you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89955,'My patented Rocket Cast system works flawlessly. Now if only these fish wouldn\'t be so picky and bite!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89956,'Nina, we\'re not getting enough fish! We need more rockets!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(89957,'Whoever said proper technique is required for a long cast has obviously never tried rockets!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89958,'Tired of casting like the puny weakling that you are? Try my patented Rocket Cast system!','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(89959,'Some think it strange, but I find the rhythmic sound of goblin machinery to be quite relaxing. \n\nThe smell, however, I could do without.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89960,'Burn in Fel Fire!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89961,'All gladiators have perished. There will be no champion today.','All gladiators have perished. There will be no champion today.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89962,'I have a few spells that can mend your equipment - for a price.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89963,'I need reagents.','I need reagents.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(89964,'Man, those Alliance soldiers sure are crybabies!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89965,'You talkin\' bout da one who kept screamin\' after you chopped off his foot?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(89966,'Yeah! I mean come on, it\'s only a foot! Those things are so easy to stitch back on.','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(89967,'Uh, I don\'t think it works that way...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89968,'So what\'s the deal with these artifacts I keep hearing about?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(89969,'All I know is da Alliance wants em, and da elves think they big and powerful. We don\'t want da Alliance havin that.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89970,'Powerful, you say? Maybe I should go get my hands on some of them.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(89971,'','Must you orcs always practice with sharpened axes?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89972,'','Next time, don\'t pull out the barbed arrow yourself. Find something else to stab your opponent with.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89973,'','Let me see to that wound...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89974,'','Hold still, I\'ll patch you up.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89975,'The answers are out there, hiding in dark places.$B$BWe must be bold enough to seek them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89976,'I want to check my mail.','I want to check my mail.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89977,'I need you to repair my gear.','I need you to repair my gear.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89978,'I got gold on the big guy!','I got gold on the big guy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89979,'OUCH! That had to hurt!','OUCH! That had to hurt!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89980,'Bite him! Bite him!','Bite him! Bite him!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89981,'Hey! That one no fight fair!','Hey! That one no fight fair!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89982,'Come on Brute!','Come on Brute!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89983,'I am close to replicating the Apexis interface.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89984,'','Intruders! Someone, inform Keli\'dan!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89985,'I will enjoy feasting on your soul...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89986,'<Raastok cackles with glee.>$B$BDid you see the size of that explosion?! Marvelous!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89987,'Interrupting cretins! I\'ll sear that pretty armor right into your skin!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89988,'I want to check on my followers\' missions.','I want to check on my followers\' missions.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(89989,'%s escapes!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89990,'You now stand upon hallowed ground. In this place, upon the arena floor, the greatest gladiators of Draenor have spilled blood. Most have given up their lives for such a great honor. Today, you will do the same.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89991,'You will fight. You will kill. You will salute! 100 LIVES. Live or die.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89992,'To the last gladiator standing goes honor, glory and riches!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89993,'Down goes $n! Dat $r left notin\' but doodoo an blood on da floor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89994,'What was dat?! Sometin\' exploded on da floor. I tink it was $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89995,'$n down! Dat remind me of da time when dat orc got his stones crushed by dat big elekk. Dat was a good week at da circus!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89996,'$n dead! Looks like der are $9662W gladiators still fighting!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89997,'Oof! Dat little $r died ugly!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89998,'Looks like da janitor gonna be pickin\' up pieces of $n for days!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(89999,'Was dat a baby $r or da fully growd up kind? Dat died too easy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90000,'HAH! Hey Jhorn, remember da poop I made dat looked like a $r? Dat\'s what $n looks like now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90001,'','Oh, this should be interesting.  You don\'t mind if I take notes, do you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90002,'','It\'s easy to see why objects such as these would have been highly prized by their cultures!  Er, sorry about your pets.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90003,'','Very interesting results.  Thanks for helping me test them out!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90004,'','Well, what can you expect from something that\'s been buried in the ground for a millennium?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90005,'','In its native culture, that pet might have been revered as a martyr.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90006,'','Huh, I kinda thought that might happen.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90007,'','Fortunately, Gyraxle can repair anything.  Even himself.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90008,'','Now, was that result the device performing as expected, or did it just explode?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90009,'','All in the name of science.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90010,'You will feed my roots.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90011,'','I\'ve got bandages in my field kit if you need some...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90012,'','You have to respect the ingenuity of such an ancient device.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90013,'The plants will feast on you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90014,'','I\'ll add a special thanks to your pet when I publish this research.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90015,'','Oh, you must mean my father, Belloc.  What he and the Reliquary do can hardly be called \'archaeology\'.  Grave robbing is more like it.$b$bTrue archaeology is the search for fact, not treasure.  I want to learn about the past, study where we came from, and rediscover lost knowledge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90016,'I may fall... but the Overgrowth will take you eventually...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90017,'Brightblade?  That name sounds familiar...','Brightblade?  That name sounds familiar...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90018,'','You don\'t look like you\'re very good at pet battles.  Maybe you should come back when you\'re better.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90019,'','Here we go!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90020,'','Oh my pets did so good.  They\'re going to get so many extra snuggles for that.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90021,'','Oh, that\'s okay I guess.  Doodle will need a new eye though.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90022,'','Don\'t worry, I\'ll kiss the boo-boo all better.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90023,'','Soup will make you all better!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90024,'','Oh no!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90025,'','She\'s not dead, she\'s just sleeping.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90026,'','We\'ll put the rainbow bandage on that.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90027,'','Oh no!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90028,'','Is your pet sleeping too?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90029,'','You can make your pet all better, right?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90030,'Begin a ritual of summoning. I want to summon my allies to my location.','Begin a ritual of summoning. I want to summon my allies to my location.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(90031,'','As I thought, $r, you are too weak.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90032,'','You are lucky my wolves are not yet full grown, or else you would have been the meal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90033,'','Only defeat truly exposes our weaknesses.  This loss will improve their training.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90034,'','That one was too stupid.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90035,'','That one did not lack courage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90036,'','That one won\'t make that mistake again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90037,'','That one was too slow.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90038,'','That one will need some healing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90039,'','A good kill.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90040,'','A clean kill.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90041,'','Hardly even a challenge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90042,'','Why are your pets so weak?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90043,'','An easy kill.  My wolves will learn nothing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90044,'Gladiators, kill!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90045,'I remain the greatest warlord in all of Nagrand!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90046,'What?  How is this possible?  You must have cheated!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90047,'What is one death when I have an army of three?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90048,'My gladiators fight to the death!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90049,'You make Tarr angry!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90050,'I told you to kill, not die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90051,'Haha, puny $r has puny pets.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90052,'Gladiator smash!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90053,'Are you not entertained?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90054,'Tarr will rock you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90055,'This is why Tarr is the greatest warlord in all of Nagrand!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90056,'','Hey $gMister:Lady;, you wanna see my pets?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90057,'','Come back another time then.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90058,'','I may be small, but if you hurt my pets, I\'ll hurt you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90059,'','Thanks $gMister:Lady;!  I bet 100 coppers on this fight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90060,'','This is just like the time my home town was overrun by demons.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90061,'','It\'s okay, they\'re used to dying.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90062,'','Not the first time someone has hunted that one to the ends of the earth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90063,'','Easy now!  I paid a pretty copper for that one.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90064,'','I\'ll sell ya a Stone of Jordan if you promise not to do that again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90065,'','Bad luck just runs in my family.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90066,'','Sorry, $gMister:Lady;.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90067,'','Don\'t throw that one away, it can still be fixed up.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90068,'','That\'s right!  My pets are from the mean streets of Caldeum.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90069,'','That\'s a bit of bad luck there, $gMister:Lady;.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90070,'$R, I am devoted to training the guardians of Anzu.  Will you aid me in this cause?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90071,'Very well.  Train and come back to me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90072,'Our hopes lie in what these pets will become.  They are sacred to us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90073,'Glory to Anzu!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90074,'We are Arakkoa.  We are not broken by a single defeat.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90075,'A bad omen.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90076,'Anzu protect your children!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90077,'No!  The guardians cannot fall!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90078,'Doom and gloom!  Dooooooooom and glooooooom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90079,'The curse of Sethe is upon us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90080,'A good omen.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90081,'The strength of the Arakkoa is with us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90082,'The raven god blesses us today.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90083,'The guardians stand strong.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90084,'Anzu protects his children.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90085,'','Hello $n.  Would you like to dance with my moths?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90086,'','I understand.  Please come back when you are ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90087,'','Pay attention, $n.  Strength is often found where you least expect it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90088,'','I hope you have learned something today.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90089,'','I hope you have learned something today.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90090,'','I am sad for the loss, but glad for your victory.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90091,'','Fear not, a simple healing spell will set that to rights.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90092,'','Life is full of surprises.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90093,'','The Light has not yet taken her.  She simply rests.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90094,'','The moth is drawn to the flame, it seems.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90095,'','Life is full of surprises.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90096,'','It is folly to underestimate the stength of nature.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90097,'','The moth is delicate, but not without defenses.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90098,'','Do not dispair, both you and your pet can learn from this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90099,'','A tender lesson learned too late.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90100,'Begin a guiding light ritual. I want to summon my allies to my location.','Begin a guiding light ritual. I want to summon my allies to my location.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(90101,'Sorry, I still need to train one of my pets to level 25.','Sorry, I still need to train one of my pets to level 25.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90102,'I admire your morals.  Carry on.','I admire your morals.  Carry on.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90103,'Open a portal to my garrison.','Open a portal to my garrison.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(90104,'The |cFFE86B17|Hspell:175519|h[Essence of Flame]|h|r is knocked from your hands!','The |cFFE86B17|Hspell:175519|h[Essence of Flame]|h|r is knocked from your hands!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(90105,'The darkness... it flows within me. It seeps from every vein.','',0,0,0,0,0,0,0,0,6,0,48235,0,26124),
(90106,'Come, strangers! Cross into the realm of the Shadow Lands! I shall deliver you to your death.','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(90107,'The Shadowmoon CANNOT be defeated - we walk in the realm of death itself.','',0,0,0,0,0,0,0,0,0,0,43682,0,26124),
(90108,'I am the herald of the end!','',0,0,0,0,0,0,0,0,0,0,43688,0,26124),
(90109,'A kindling of bone and shadow! Army of the dead, arise!','',0,0,0,0,0,0,0,0,0,0,43689,0,26124),
(90110,'Into the abyss!','',0,0,0,0,0,0,0,0,0,0,43690,0,26124),
(90111,'Feel the void\'s cold embrace.','',0,0,0,0,0,0,0,0,0,0,43691,0,26124),
(90112,'My power... Will ripple... Across eternity.','',0,0,0,0,0,0,0,0,0,0,43683,0,26124),
(90113,'Your soul shall serve me!','',0,0,0,0,0,0,0,0,0,0,43686,0,26124),
(90114,'You bend to my will!','',0,0,0,0,0,0,0,0,0,0,43687,0,26124),
(90115,'','Rivers of the damned, RISE! RISE in the name of darkness, RISE in the name of Ner\'zhul! The Shadowmoon beckons...',0,0,0,0,0,0,0,0,0,0,0,43541,26124),
(90116,'','Ancestors of the Shadowmoon, shine in the darkness! Lend me your strength!',0,0,0,0,0,0,0,0,0,0,0,43539,26124),
(90117,'','For Ner\'zhul...',0,0,0,0,0,0,0,0,0,0,0,43544,26124),
(90118,'','Mmm, yes. The PERFECT sacrifice.',0,0,0,0,0,0,0,0,0,0,0,43545,26124),
(90119,'','Your souls will belong to ME.',0,0,0,0,0,0,0,0,0,0,0,43546,26124),
(90120,'','Restless spirits, HEED my command!',0,0,0,0,0,0,0,0,0,0,0,43547,26124),
(90121,'','Another spirit for the army!',0,0,0,0,0,0,0,0,0,0,0,43542,26124),
(90122,'','Embrace the eternal darkness...',0,0,0,0,0,0,0,0,0,0,0,43543,26124),
(90123,'','The dead... Shall rise again...',0,0,0,0,0,0,0,0,0,0,0,43540,26124),
(90124,'Let\'s do this!','Let\'s do this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90125,'Rekindle the |cFFE86B17|Hspell:175519|h[Essence of Flame]|h|r at a Kindling Flame!','Rekindle the |cFFE86B17|Hspell:175519|h[Essence of Flame]|h|r at a Kindling Flame!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(90126,'Thank you, $n. May the Furies of Frostfire burn within you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90127,'Thank you for help, $n. I may be wounded, but no matter. Lead on!','Thank you for help, $n. I may be wounded, but no matter. Lead on!',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(90128,'$n, I will remember your help. These wounds won\'t stop a good fight!','$n, I will remember your help. These wounds won\'t stop a good fight!',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(90129,'That\'s more like it. I\'m injured, but you\'ve given me a chance to redeem myself.','That\'s more like it. I\'m injured, but you\'ve given me a chance to redeem myself.',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(90130,'By Sha\'tar, thanks for your aid. I\'m wounded, but you\'ve given me a chance to fight on!','By Sha\'tar, thanks for your aid. I\'m wounded, but you\'ve given me a chance to fight on!',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(90131,'$n, I will remember your name. These wounds are no greater than my anger - let us fight on!','$n, I will remember your name. These wounds are no greater than my anger - let us fight on!',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(90132,'Thanks for the help, $n. We shall fight together, for Shattrath!','Thanks for the help, $n. We shall fight together, for Shattrath!',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(90133,'Thanks, $r, but I have no desire to fight by your side.','Thanks, $r, but I have no desire to fight by your side.',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(90134,'Our paths do not align, $r. Thank you for the aid, but I must be going.','Our paths do not align, $r. Thank you for the aid, but I must be going.',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(90135,'My wounds are too great, friend. I must leave, but I hope we meet again.','My wounds are too great, friend. I must leave, but I hope we meet again.',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(90136,'I need another drink.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90137,'A crushed fruit tastes all the sweeter.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90138,'I am too injured, $n, and must go heal. Thank you for our time together.','I am too injured, $n, and must go heal. Thank you for our time together.',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(90139,'You have already been blessed by a Pilgrim\'s Altar. A feeling of great peace and serenity envelops you.','You have already been blessed by a Pilgrim\'s Altar. A feeling of great peace and serenity envelops you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90140,'Blessing of K\'ure','Blessing of K\'ure',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(90141,'Some fine grog you have here, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90142,'','Go away.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90143,'Light be with you, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90144,'So much death in this land...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90145,'Aviana\'s blessing upon you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90146,'The herbs and fungus found on Draenor can be used to concoct all manner of pestilence. \n\nI believe our next plague will be the best yet!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(90147,'Have you ever spent time, like really spent time, in the belly of an acidic swamp ooze? I wouldn\'t recommend it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90148,'What ho, squire?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90149,'I will find a way to save Bolvar, if it takes the rest of my days.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90150,'','I wish to be alone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90151,'Zen\'kiki likes da kitty form best for sleeping.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90152,'I am wounded, $n, and need rest. Al diel shala!','I am wounded, $n, and need rest. Al diel shala!',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(90153,'With my recipes, you can transform the reagents of Draenor into concoctions with the power to bestow or destroy life as you see fit.\n\nThat is, of course, if you possess the proper skill to wield them.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(90154,'Ah, hello commander! Would you like me to tell you a lengthy story about a bridge?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90155,'I need rest, $n. Shorel\'aran!','I need rest, $n. Shorel\'aran!',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(90156,'','The instructions are simple: you duck, or you don\'t have a head any longer. It does make ducking much easier in the future.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90157,'I, Gamon, will save us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90158,'I wonder if this world has any world-destroying artifacts? We can\'t allow them to fall into the hands of the enemy, you know!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90159,'No fight, sit by fire. Fire warm, outside cold. You sit.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90160,'I love boats!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90161,'You may inspect me from the maximum distance only.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90162,'','Good fortune, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90163,'All I\'ve ever known is war. Out here, I\'m someone.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90164,'Fifty! Yep! I was just tellin\' them all about the best task I\'ve ever given an\' aspirin\' adventurer. Ah, those were the days...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90165,'Many beasts of Draenor have hides as resilient as the toughest kodo. \n\nWith the proper skill, I can show you how to work these hides into fine armors.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(90166,'I\'m right in the middle of communicating cross-dimensionally with Nibly, if you DON\'T MIND.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90167,'','Hi! This fort is swell.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90168,'The stone statue gives off a restful aura. A plaque on the sign reads:$B$BThose blessed by the light of A\'dal shall gain fortitude and armor to confront the most challenging of foes.$B$BSeek the blessing of D\'ore to be healed in times of need.$B$BK\'ara guides the weapons of the blessed, granting the chance for additional strikes in times of war.$B$BK\'ure rewards the faithful, granting their movement the swiftness of wind.','The stone statue gives off a restful aura. A plaque on the sign reads:$B$BThose blessed by the light of A\'dal shall gain fortitude and armor to confront the most challenging of foes.$B$BSeek the blessing of D\'ore to be healed in times of need.$B$BK\'ara guides the weapons of the blessed, granting the chance for additional strikes in times of war.$B$BK\'ure rewards the faithful, granting their movement the swiftness of wind.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90169,'Blessing of D\'ore','Blessing of D\'ore',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(90170,'Blessing of K\'ara','Blessing of K\'ara',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(90171,'Blessing of A\'dal','Blessing of A\'dal',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(90172,'You look like you could use an updated wardrobe.  \n\nLuckily for you, I may just be able to teach you how to make some of the finest tailored garments in Draenor.\n\nCare to take a look at my patterns?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(90173,'The draenei crystalsmiths closely guard the secrets to harnessing the latent power of the gems of Draenor. \n\nI, however, have managed to access these secrets and can share them with a talented jewelcrafter.\n\nFor a price, of course.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(90174,'I see ya wishin\' to enhance ya gear with da powah of da voodoo. \n\nGed\'kah can be of service, mon.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(90175,'','Da right words have da powah of da strongest voodoo. \n\nDem dat keep da words, dey know real powah!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(90176,'These Iron Horde guys think they know how to make machines. \n\nJust wait until they see what a goblin can do once we get our hands on their tech!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(90177,'With the Alliance making themselves a threat again on Ashran, the demand for quality weapons and armor is higher than ever!\n\nDo you smell profit?','',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(90178,'Zikk mon. Could ya be doin me a fava and grab me da scroll from da enchantas?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(90179,'Now dat\'s a good rapta!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90180,'Where I be puttin dat quill, now?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(90181,'A scribe\'s work neva be done, mon.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90182,'','You be free to house any of ya animals here wit\' da raptas. We will be keepin dem well fed. \n\nYa animals, of course. What did ya think I meant?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90183,'','Shhhhh... I\'m trying to catch something!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90184,'Why are we out here, do you ask? We are seasoned adventurers, seeking the wake of a legendary sea beast.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90185,'The creature must exist! I will seek it to the end of my days!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90186,'','The reagents of Draenor are as wondrous as they are mysterious.\n\nFor a price, I can teach you to harness their potential.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(90187,'My power is unending!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90188,'By the Raven Mother\'s feathers, you will not find a better deal!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90189,'Show me your wares.','Show me your wares.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90190,'Raaaaawwwwrrrrr! Raaawwwwwrrrrrrrr!!!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90191,'Have you seen any enormous sea creatures in these waters?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90192,'Here, you look hungry.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90193,'Eat this, it will make you strong.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90194,'01001001 01100110 00100000 01111001 01101111 01110101 00100000 01110111 01100001 01101110 01110100 00100000 01110100 01101111 00100000 01110111 01101001 01101110 00100000 01110100 01101000 01100101 00100000 01100111 01100001 01101101 01100101','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90195,'01111001 01101111 01110101 00100000 01100111 01101111 01110100 00100000 01110100 01101111 00100000 01110100 01100001 01101011 01100101 00100000 01100111 01101111 01101111 01100100 00100000 01100001 01101001 01101101','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90196,'','I\'m telling you it\'s going to work, just trust me!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90197,'I can\'t even see out of this thing... how\'s the plan supposed to work if we can\'t see where we\'re going?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90198,'','Just follow the sound of the money you\'ll make when we sell off all these bones!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90199,'','The disguise is working! Those dumb gronn don\'t even know we\'re here!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90200,'So all we gotta do now is wait until they go to sleep and then scram with the bones?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90201,'','Right... hey you feel something crawling around in your skull?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90202,'Only a sense of regret for letting you talk me into this...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90203,'','So how about you tell us a little bit about these machines you and your cronies have been making for the Iron Horde?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90204,'I ain\'t got nothin\' to say to you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90205,'','Oh well, we can do this the hard way.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90206,'','Did that loosen up your tongue a bit, or do you need more persuasion?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(90207,'I\'m not talkin! I ain\'t no rat!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90208,'','Persuade em, boys.',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(90209,'All right, all right! I\'ll talk! Just call off your goons!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90210,'','Take five, guys. We\'ve got a little conversing to do here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90211,'Hollowed Skull','Hollowed Skull',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90212,'I... will not... tell you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90213,'Amidst the chaos and carnage of the Coliseum, one among you has emerged the victor. $n! Shout $ghis:her; name in praise! Glory be to $n on this day!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90214,'Come! Honor your champion! See the riches bestowed upon the most powerful of your kind!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90215,'','Then taste the Scythe of Souls...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90216,'','Forged in flame, my power knows no bounds, my allies fear nothing!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90217,'The battle has begun! The last gladiator standing will be victorious!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90218,'','My body has fallen, but my spirit rises. I will always be with you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90219,'Hack imposters like Harrison Jones may frown on my methods, but fossilization takes thousands of years!$b$bThe best way to preserve a rare and fascinating creature is to do it yourself!$b$bWhy wait thousands of years for nature to do something that you can do a better job of yourself?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90220,'You help out the Steamwheedle Preservation Society and we help you back! But don\'t forget, sharing may be caring but gold is how it\'s sold!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90221,'<Bozzil flails his arms wildly as you approach>$b$bWhoa! Hey! Who\'s there?$b$bOh, sorry... I haven\'t been able to see very well since that whole... Xelganak thing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90222,'I said, when I beat your brother black and blue, he dooked his pants and jumped away. Now give me the chow!','I said, when I beat your brother black and blue, he dooked his pants and jumped away. Now give me the chow!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90223,'Hey, Ooka, your ooker is showing. That\'s unsavory and not the least bit sanitary.','Hey, Ooka, your ooker is showing. That\'s unsavory and not the least bit sanitary.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90224,'Your mom.','Your mom.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90225,'It burnssss... it BURNSSSSS!','',0,0,0,0,0,0,34,0,0,0,0,0,26124),
(90226,'The mages will summon a portal west of Ashran which can be used to take you back to Stormshield Stronghold.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90227,'GRRRRAAAAaaaaahhhh!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90228,'$n is unstoppable! Keep an eye on $ghim:her;, Kargath.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90229,'Did I steal these rylaks from the Iron Horde?$b$bThat depends on who\'s asking!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90230,'','You look like the adventering type!$b$bIf you find any relics or artifacts while you\'re out there, bring them back here and we\'ll make a deal!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90231,'','Go mank a slicky, wicket. In fact, go mank two while one manks you from behind and the other manks your dooker.',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(90232,'','My head? You\'re a slicky headed dook-manker!',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(90233,'The signal horn was blown, why have the others not arrived?','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(90234,'Probably drinking themselves into a stupor.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(90235,'Something isn\'t right. Feels like we are being watched.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(90236,'','You leave my brother out of this you, blickjikity dook-manker!',498,0,0,0,0,0,0,0,0,0,0,0,26124),
(90237,'','Don\'t mind me, I just work the holo-projector! If you\'re looking for work you should talk with Mr. G over there!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90238,'I\'d like to see your selection of spirits.','I\'d like to see your selection of spirits.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90239,'No word yet on the northern troop movements.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90240,'Our raiders spotted artillery moving up the coast.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90241,'Our warriors caught the outpost by surprise and burned it to the ground.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90242,'No word back from our scouts yet.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90243,'Our ships will be arriving at the Iron Docks soon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90244,'Reports of heavy losses to the south.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90245,'Our scouts have spotted a caravan ripe for the plundering.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90246,'No word yet from the other clans.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90247,'','My mom? MY MOM! You wikket licking ooker!',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(90248,'Our raiders have burned the village and left no survivors.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90249,'We have enemy forces moving west through Nagrand.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90250,'Any bites yet?  I have found that patience (and beer) really helps bring in the big catch!','',1,0,0,0,0,0,0,0,4,0,0,0,26124),
(90251,'Did you bring a cooler?  Don\'t EVER go fishing without a cooler!','',1,0,0,0,0,0,0,0,4,0,0,0,26124),
(90252,'Any bites yet?  I have found that patience (and beer) really helps bring in the big catch!','',1,0,0,0,0,0,0,0,4,0,0,0,26124),
(90253,'*HIC!*  Was that a dolphin?!  *HIC!*  I love dolphins!','',1,0,0,0,0,0,0,0,4,0,0,0,26124),
(90254,'Seriously?  I think I would actually just throw that one back.','',1,0,0,0,0,0,0,0,4,0,0,0,26124),
(90255,'We need to concentrate on getting weapons to give to the other prisoners and setting you up as Sternfathom\'s champion pit fighter.\n\nThen, we can go kill Prince Oceanus.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(90256,'The Legion will enslave all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90257,'Carrion Worms Killed: $1i (+$2i VP)','Carrion Worms Killed: $1i (+$2i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90258,'Infiltrators Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90260,'Looters Stopped: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90261,'*YAWN* It would seem that you require some outside assistance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90262,'The crowd grows weary of this battle! Perhaps a little fire can liven things up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90263,'This pace is not to my liking! This should help...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90264,'My patience has run out! I WILL MAKE YOU FIGHT!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90265,'See ya!','',1,0,0,0,0,0,0,0,4,0,0,0,26124),
(90266,'I will be back later, save me a beer!','',1,0,0,0,0,0,0,0,4,0,0,0,26124),
(90267,'Good luck on the lunkers!','',1,0,0,0,0,0,0,0,4,0,0,0,26124),
(90268,'Howdy $n!  Any luck out here?','',1,0,0,0,0,0,0,0,4,0,0,0,26124),
(90269,'$n, I found ya!','',1,0,0,0,0,0,0,0,4,0,0,0,26124),
(90270,'Greetings $n!','',1,0,0,0,0,0,0,0,4,0,0,0,26124),
(90271,'Snowfury mournfully paws at the rubble.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90272,'We stand victorious, but at a high cost.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90273,'What happened here?','What happened here?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(90274,'Bwargh! Nobody spills my brew... DIE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90275,'MY WILL... I WILL NOT BE... BROK... EN....','',0,0,0,0,0,0,0,0,0,0,43513,0,26124),
(90276,'AUGHHHHH!','',0,0,0,0,0,0,0,0,0,0,43514,0,26124),
(90277,'ALL THAT LIVES, TO DUST.','',0,0,0,0,0,0,0,0,0,0,43509,0,26124),
(90278,'BREAK.','',0,0,0,0,0,0,0,0,0,0,43517,0,26124),
(90279,'THE EARTH CONSUMES YOU.','',0,0,0,0,0,0,0,0,0,0,43518,0,26124),
(90280,'I... AM... ETERNAL!','',0,0,0,0,0,0,0,0,0,0,43519,0,26124),
(90281,'SHATTER.','',0,0,0,0,0,0,0,0,0,0,43520,0,26124),
(90282,'RISE, MOUNTAINS!','',0,0,0,0,0,0,0,0,0,0,43521,0,26124),
(90283,'TOO... MUCH!','',0,0,0,0,0,0,0,0,0,0,43511,0,26124),
(90284,'WHAT... IS... THIS....','',0,0,0,0,0,0,0,0,0,0,43512,0,26124),
(90285,'EVEN THE MOUNTAIN... FALLS....','',0,0,0,0,0,0,0,0,0,0,43510,0,26124),
(90286,'RETURN TO THE EARTH.','',0,0,0,0,0,0,0,0,0,0,43515,0,26124),
(90287,'FLESH. WEAK.','',0,0,0,0,0,0,0,0,0,0,43516,0,26124),
(90288,'His sacrifice will echo through our generations... forever.','',1,0,0,0,0,0,0,0,0,31108,45214,0,26124),
(90289,'Kral\'ach.... The darkness speaks.... A VOICE!','',0,0,0,0,0,0,0,0,0,0,45411,0,26124),
(90290,'MASTER! I COME FOR YOU!','',0,0,0,0,0,0,0,0,0,0,45412,0,26124),
(90291,'Yjj\'rmr... Xzzolos...','',0,0,0,0,0,0,0,0,0,0,45415,0,26124),
(90292,'Night! My blood... stars....','',0,0,0,0,0,0,0,0,0,0,45413,0,26124),
(90293,'Yes, Tectus. Bend to master\'s will!','',0,0,0,0,0,0,0,0,0,0,45417,0,26124),
(90294,'No! You do not understand... must not get away...','',0,0,0,0,0,0,0,0,0,0,45418,0,26124),
(90295,'Who dares meddle in the works of the Legion?!','',0,0,0,0,0,0,0,0,0,0,46776,0,26124),
(90296,'This world... ALL worlds... shall burn!','',0,0,0,0,0,0,0,0,0,0,46774,0,26124),
(90297,'The master claims your soul.','',0,0,0,0,0,0,0,0,0,0,46777,0,26124),
(90298,'Burn.','',0,0,0,0,0,0,0,0,0,0,46778,0,26124),
(90299,'Come forth, servants!','',0,0,0,0,0,0,0,0,0,0,46779,0,26124),
(90300,'Burn in the master\'s fire!','',0,0,0,0,0,0,0,0,0,0,46780,0,26124),
(90301,'Die, insect!','',0,0,0,0,0,0,0,0,0,0,46781,0,26124),
(90302,'That\'s better! Do not disappoint us again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90303,'Am I not a gracious host? Are you not entertained?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90304,'Lose the crowd again and you will all pay dearly!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90305,'|TInterface\\Icons\\spell_druid_massentanglement.blp:20|t You are entangled in |cFFFF0404|Hspell:176001|h[Savage Vines]|h|r!','|TInterface\\Icons\\spell_druid_massentanglement.blp:20|t You are entangled in |cFFFF0404|Hspell:176001|h[Savage Vines]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(90306,'All dem muscles and you can\'t break boulders?! Useless ogron!','',0,0,0,0,0,0,153,0,0,0,0,0,26124),
(90307,'Even dead talbuk be more useful den dese stupid ogron!','',0,0,0,0,0,0,153,0,0,0,0,0,26124),
(90308,'|TInterface\\Icons\\Ability_Druid_EmpoweredTouch:20|t Tarlna begins to channel |cFFFF0404|Hspell:175979|h[Genesis]|h|r.','|TInterface\\Icons\\Ability_Druid_EmpoweredTouch:20|t Tarlna begins to channel |cFFFF0404|Hspell:175979|h[Genesis]|h|r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(90309,'Ey, wanna know what\'s more stupid den a ogron?','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(90310,'Two ogron! Har har har!','',0,0,0,0,0,0,153,0,0,0,0,0,26124),
(90311,'','Yeah? What? This fighter chow is a special family secret.\n\nThere\'s no ookin way you\'re getting any, $r.',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(90312,'Get back ta work ya lazy ogron!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90313,'You better start breakin\' rocks before I break you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90314,'Quit wanderin\' round and break some rocks ya stupid ogron!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90315,'Go into the Road of Glory!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90316,'Thaelin is on his way soon.','Thaelin is on his way soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90317,'Test - male.','Test - female',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90318,'Get dem ogron back to work!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90319,'Get control of da ogron, now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90320,'Get dem ogron workin\', or start bashin\' skulls!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90321,'You like meat? We got lots o\' fresh meat here! How much you want?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90322,'','Commander, may I have a moment?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(90324,'','I understand your concerns about this artifact, Myshal, but we must not interfere with our allies efforts to retrieve it.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90325,'But Priestess, if the artifact is as powerful as they say, the destruction that could be wrought by its wielder could be devastating!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(90326,'','That is why we must assure that our allies are the ones to retrieve it. Once recovered, we will offer our guidance to ensure it is not misued.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90327,'What if they don\'t listen? What if our allies\' lust for power leads them down the path of destruction?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(90328,'I love goblins, but they are a tough audience.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90329,'','Let us hope that day does not come, Myshal.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90330,'','You seem troubled, Myshal. What vexes you?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(90331,'It\'s the Horde forces, Priestess. They fight with great savagery to obtain the artifact before us.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90332,'Do you think they wish to use it against the Alliance?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(90333,'','Perhaps they fight with such ferocity because they fear we will use it against them.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90334,'','Greetings, friend.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90335,'','Your order has already been placed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90336,'','Thank you, commander. I will see you at your garrison.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90337,'You\'re only given a little spark of madness... and if you lose that, you\'re nothing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90338,'No matter what people tell you, words and ideas can change the world.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90339,'If there\'s one thing I\'ve learned on Draenor, it\'s never to pick a fight with an ogre; they\'ve got nothing to lose.','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(90340,'','If this artifact that Harrison is seeking is as powerful as he seems to think, I hope it remains undiscovered.\n\nRegardless of intentions, the wielding of great power often comes with drastic consequences.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(90341,'But hey, the Alliance aren\'t all bad. If you want a linguistic adventure, go drinking with a dwarf!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90342,'Goblin \"engineering\" - yeah, right. You goblins got hands and a brain, and only enough blood to run one at a time!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(90343,'How about those draenei? Or as they like to say, the other blue race. How can you trust an army that makes warhammers out of pink gemstones?!','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(90344,'You know the difference between a bar fight and an orcish wedding? Me neither.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(90345,'You guys have it great out here. You got the right to bear arms, the right to arm bears. Whatever the hell you want to do!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(90346,'','Commander, could I have a moment o\' yer time?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(90347,'Anyone been to Silvermoon? I only ever play Silvermoon one night at a time. It\'s a hideous, gaudy place.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(90348,'Do you do characters?','Do you do characters?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90349,'','Thank ye, commander. I\'ll see ye at your garrison.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90350,'Show me the Blasted Lands before the invasion.','Show me the Blasted Lands before the invasion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(90351,'Hey everyone, John Swifty here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90352,'Check THIS one out!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90353,'PHENOMENAL COSMIC POWERS!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90354,'Itty bitty living space.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90355,'','War does not simply visit these lands, it lives here.  The violence thrives in past, present, and future...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90356,'I only had one shot.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90357,'Macro power!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90358,'<Kharg seems uninterested.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90359,'How can Kharg assist you, gladiator?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90360,'I wish to battle in the Coliseum!','I wish to battle in the Coliseum!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90361,'The cost to do battle in the Coliseum is 100 Broken Bones. Do you wish to proceed?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90362,'Wut is it? Me need to work out more!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90363,'Never keep a kaliri in the bedroom. They hear EVERYTHING.','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(90364,'Clockspan, we need to get that tank repaired. Our troops need some assistance on the front line!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(90365,'We need that rock clearing bot on the double, Sparkswift. Do you expect Harrison Jones to clear out that mine with a pick?','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(90366,'How long does normal maintenance take, Springfizzle? We needed that tank on the field hours ago!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(90367,'Where is Wobblewrench? She\'s been working on that spider tank for ages!','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(90368,'All this coordinating work is tiring. I sure could use a frosty brew.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90369,'Apologies, gladiator, but you have already been victorious in the Coliseum this week. Come back next week.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90370,'Shome commander you are ...hic! I\'ve been working with the orcsh shince the shtart! ...hic!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90371,'It\'s over, Jacob. Come quietly and we\'ll get you on the first gryphon to prison for treason.','It\'s over, Jacob. Come quietly and we\'ll get you on the first gryphon to prison for treason.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90372,'You da champ! Dat means you can\'t fight in Coliseum for six...hundred years. Or maybe it one week? Me no know!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90373,'Hold on, you\'ll like this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90374,'What\'s that sound? Reminds me of a kodo stampede...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90375,'You\'ll never take me alive ...hic!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90376,'There\'s a stench in the air. Demons...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90377,'We\'re in luck! Once again, we can show the demons that the true Horde will not be swayed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90378,'This is where they\'ll attack first...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90379,'Finally, a fight...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90380,'Keep your eyes open. They might spring from anywhere.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90381,'I can feel them down there...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90382,'The Shadowmoon Clan shames all Orcs. Every one we kill is a lesson to the rest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90383,'Hello there, poppet!','Hello there, poppet!',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(90384,'Oh! Two seconds as a woman and I\'m already getting hot flashes.','Oh! Two seconds as a woman and I\'m already getting hot flashes.',0,0,0,0,0,0,430,0,0,0,0,0,26124),
(90385,'','The cold certainly bothers you',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90386,'Many adventurers have come to Ashran of late. Some seek their own personal fortune, while others come to aid the Alliance in their plight against the Horde.\n\nWhat adventure do you seek here, friend?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(90387,'','From a distance, you look very small.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90388,'Commander, we\'ll assemble the troops at your command.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90389,'My power is surpassed only by my stature!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90390,'I hope this last one\'s bigger than the rest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90391,'','Be healed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90392,'','Light mend your wounds!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90393,'','It is not your day to die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90394,'Their leader is here. For the Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90395,'Defeated? No! Charles, where were you?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90396,'I am unstoppable!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90397,'Alive or dead, I tower over you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90398,'Let\'s beat these ogres back to Highmaul!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90399,'Now let\'s put these demon-spawn out of their misery!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90400,'The goren fled, but I don\'t think they fled from us...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90401,'The power of sun and moon flow through me with a deafening boom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90402,'I\'ll be pulling thorns out of my armor for weeks...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90403,'By Alune, I will return, stronger than ever before!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90404,'I never thought I\'d tire of smashing skulls.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90405,'That took care of the lesser ogres.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90406,'They\'re too fever-brained to know they\'re defeated!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90407,'BOOM!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90408,'KA-BOOM!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90409,'BA-BA-BOOM!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90410,'All hail, $n! Champion of the Coliseum! King of the gladiators!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90411,'If there\'s a gronn coming, then goren won\'t be far. Get the peasants to safety!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90412,'To arms! To your posts! And look beneath you. They\'ll come from below....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90413,'This is where they\'ll attack first...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90414,'They\'re coming...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90415,'Be wary of flowers and vines. Any plant may be our foe...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90416,'They\'re coming...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90417,'I\'m gonna light you up, sweet cheeks!','I\'m gonna light you up, sweet cheeks!',0,0,0,0,0,0,0,0,0,0,49764,49764,26124),
(90418,'Remember when they die, don\'t let them fall on you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90419,'','Shome commander you are ...hic! I\'ve been working with the Alliance shince the shtart! ...hic!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90420,'It\'s over, Rorka. Come quietly and we\'ll get you on the first wyvern to prison for treason.','It\'s over, Rorka. Come quietly and we\'ll get you on the first wyvern to prison for treason.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90421,'','You\'ll never take me alive ...hic!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90422,'That can\'t be all of them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90423,'Spread out! Protect the structures!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90424,'They were just sent to soften us up...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90425,'Spread out! They\'ll be coming from all angles!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90426,'Kneel before the might of the Iron Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90427,'I\'ll have your head on my axe!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90428,'Looks like I\'ll have to take care of this one myself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90429,'Where do you think you\'re going?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90430,'Spread out! Protect the structures!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90431,'That was just a test.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90432,'Spread out! Protect the structures!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90433,'No more at the front gate....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90434,'Spread out! Protect the structures!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90435,'We won\'t go down that easy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90436,'Spread out! Don\'t let them gain a foothold!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90437,'The goren fled, but I don\'t think they fled from us...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90438,'','The battle begins!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90439,'This... Horde is... tough.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90440,'','It\'s getting warm up here...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90441,'','Thought I was a pushover like Balinda? Ha!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90442,'','Chill out.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90443,'','Dress warmer next time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90444,'','I\'m burning up!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90445,'This is it, soldiers. Stay focused and we\'ll make it through.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90446,'The enemy commander comes! It\'ll be just like old times!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90447,'','Shattered!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90448,'Ahhh, I have feelin\' back in my toes. Tanks, $Gbrudda:sista;. I won\'t forget dis.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90449,'Feel the burn!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90450,'The heat is on!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90451,'I will rise again... and again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90452,'I\'m burned out.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90453,'Ashes to ashes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90454,'Too hot for you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90455,'Aaalllriiiight!! Who ordered up an extra large can of whoop-ass?','Aaalllriiiight!! Who ordered up an extra large can of whoop-ass?',0,0,0,0,0,0,0,0,1,0,49766,49766,26124),
(90456,'','I could use a heal here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90457,'','Say Bahh to your healers!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90458,'Gordawg is nowhere to be found! The minions of Kalandrios must be to blame! Bury the air with earth... suffocate the wind!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90459,'The earthen fury has abandoned the throne! The minions of Gordawg must be punished...  scatter the earth like pebbles upon the wind!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90460,'The fury of earth is missing and the minions of Aborius do nothing to aid the throne! If the waters refuse to flow... we shall boil them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90461,'The minions of Gordawg are without control! The followers of Incineratus burn uncontrollably! Cleanse the plateau... drown the lesser elements and wash them away!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90462,'','Ahh... a nice cool breeze.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90463,'|cFFFF0000|Hspell:155187|h[Bombs]|h|r damage all players in the area when they expire or when they are triggered by the player wearing them.','|cFFFF0000|Hspell:155187|h[Bombs]|h|r damage all players in the area when they expire or when they are triggered by the player wearing them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90464,'|TInterface\\Icons\\ability_foundryraid_traindeath:20|t An |cFFFF0000|Hspell:156554|h[Incoming Train]|h|r has killed you. Avoid standing on a track while that track\'s doors are open.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(90465,'Haven\'t been here in ages.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90466,'Hahaha.','',11,0,0,0,0,0,11,0,0,0,6953,0,26124),
(90467,'|TInterface\\Icons\\ability_whirlwind:20|t |cFFFF0000|Hspell:157943|h[Whirlwind]|h|r has killed you. Avoid standing near Phemos during |cFFFF0000|Hspell:157943|h[Whirlwind]|h|r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(90468,'|cFFFF0000|Hspell:176123|h[Volatile Fire]|h|r deals damage to the player with the Volatile Fire and any nearby players when it expires.','|cFFFF0000|Hspell:176123|h[Volatile Fire]|h|r deals damage to the player with the Volatile Fire and any nearby players when it expires.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90469,'|cFFFF0000|Hspell:155200|h[Burn]|h|r deals damage to the player Fixated by the Slag Elemental.','|cFFFF0000|Hspell:155200|h[Burn]|h|r deals damage to the player Fixated by the Slag Elemental.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90470,'|cFFFF0000|Hspell:155209|h[Blast]|h|r deals damage to all players every time the Heart of the Mountain reaches 100 energy.','|cFFFF0000|Hspell:155209|h[Blast]|h|r deals damage to all players every time the Heart of the Mountain reaches 100 energy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90471,'|cFFFF0000|Hspell:155223|h[Melt]|h|r deals damage to all players inside its area of effect every second for as long as they remain in the area.','|cFFFF0000|Hspell:155223|h[Melt]|h|r deals damage to all players inside its area of effect every second for as long as they remain in the area.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90472,'|cFFFF0000|Hspell:155242|h[Heat]|h|r deals more damage to you the more |cFFFF0000|Hspell:155240|h[Tempered]|h|r you are and stacks.','|cFFFF0000|Hspell:155242|h[Heat]|h|r deals more damage to you the more |cFFFF0000|Hspell:155240|h[Tempered]|h|r you are and stacks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90473,'The |cFFFF0000|Hspell:155743|h[Slag Pool]|h|r activates once the Heart of the Mountain leaves the Blast Furnace and burns all players standing in it.','The |cFFFF0000|Hspell:155743|h[Slag Pool]|h|r activates once the Heart of the Mountain leaves the Blast Furnace and burns all players standing in it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90474,'|cFFFF0000|Hspell:175104|h[Melt Armor]|h|r Inflicts more damage to you the more times you get hit by the spell. Alternate tanking Foreman Feldspar with other players to allow your Melt Armor stacks to expire.','|cFFFF0000|Hspell:175104|h[Melt Armor]|h|r Inflicts more damage to you the more times you get hit by the spell. Alternate tanking Foreman Feldspar with other players to allow your Melt Armor stacks to expire.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90475,'Slag Elementals become a |cFFFF0000|Hspell:176133|h[Slag Bomb]|h|r when their health is depleted.','Slag Elementals become a |cFFFF0000|Hspell:176133|h[Slag Bomb]|h|r when their health is depleted.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90476,'|cFFFF0000|Hspell:156147|h[The Cleaver]|h|r stacks up the longer you tank the Butcher.','|cFFFF0000|Hspell:156147|h[The Cleaver]|h|r stacks up the longer you tank the Butcher.',0,0,0,0,0,0,0,0,0,0,41639,41639,26124),
(90477,'|cFFFF0000|Hspell:156143|h[The Tenderizer]|h|r inflicts more damage to you the longer you tank the Butcher.','|cFFFF0000|Hspell:156143|h[The Tenderizer]|h|r inflicts more damage to you the longer you tank the Butcher.',0,0,0,0,0,0,0,0,0,0,41639,41639,26124),
(90478,'|cFFFF0000|Hspell:156153|h[Gushing Wounds]|h|r will instantly kill any player with more than 9 stacks of the debuff.','|cFFFF0000|Hspell:156153|h[Gushing Wounds]|h|r will instantly kill any player with more than 9 stacks of the debuff.',0,0,0,0,0,0,0,0,0,0,41639,41639,26124),
(90479,'|cFFFF0000|Hspell:156157|h[Cleave]|h|r divides its damage amongst all targets and always targets the largest clump within melee range.','|cFFFF0000|Hspell:156157|h[Cleave]|h|r divides its damage amongst all targets and always targets the largest clump within melee range.',0,0,0,0,0,0,0,0,0,0,41639,41639,26124),
(90480,'Oh captain, my captain.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90481,'|cFFFF0000|Hspell:156138|h[Heavy Handed]|h|r attacks the next closest target to the Butcher\'s current tank target or attacks his current tank a second time if there are no other tanks in range.','|cFFFF0000|Hspell:156138|h[Heavy Handed]|h|r attacks the next closest target to the Butcher\'s current tank target or attacks his current tank a second time if there are no other tanks in range.',0,0,0,0,0,0,0,0,0,0,41639,41639,26124),
(90482,'The earth will crush your mortal bones!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90483,'You dare approach the fury of the storm?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90484,'%s prepares a |cFFFF0404|Hspell:168148|h[Cannon Barrage]|h|r! Get behind cover to survive!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90485,'I DIED!','I DIED!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90486,'My waters will cleanse your pathetic mortal flesh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90487,'Why can\'t I fight?','Why can\'t I fight?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90488,'My flames will turn your bones to ash!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90489,'%s begins to channel |cFFFF0404|Hspell:157059|h[Rune of Grasping Earth]|h|r, seek a rune for protection!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90490,'|cFFFF0404|Hspell:163590|h[Creeping Moss]|h|r is spreading! Use flame throwers to control the overgrowth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90491,'%s\'s |cFFFF0404|Hspell:155539|h[Destructive Rampage]|h|r ends.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(90492,'You have emerged victorious, gladiator. You are not permitted to battle again until next week.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90493,'The Exarchs are charged with leading the draenei people. We represent and uphold the values of our society.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(90494,'It\'s not the end of the world per se, but you can certainly see it from there!','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(90495,'Mrrgggl!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90496,'Mrrgl.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90497,'Mrrrrgl?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90498,'Mrrgl. Mrrgl.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90499,'','The situation has become very dangerous on Ashran lately. This morning I nearly had my head taken off by an enraged ancient!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90500,'','Da Alliance must be desparate to obtain da artifact to unleash such foes upon us.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90501,'','The fury of nature should not be abused in such a way. In the end, they will pay for their folly.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90502,'','The primal forces of Draenor are wild and untamed. They seem to resist any attempt at control.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90503,'','Dat must make things diffcult for ya on da battlefield.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90504,'','Not necessarily. I still have my teeth and claws.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90505,'','You hear what happened? The blood elves say they found something big in the mines.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90506,'What, like a really big axe?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(90507,'','Not an axe, dimwit! They say it\'s part of the big artifact the Alliance is lookin\' for.',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(90508,'Bah! Who cares about some old, dusty relics? I came here to bash some Alliance heads in!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(90509,'','Do you even understand why we\'re here in Ashran?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(90510,'All I care about is that we get to bring the battle to the humans again. I\'ve been itchin\' for a proper fight!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90511,'','It\'s been years since I\'ve been out in the field like this.$B$B<The stately archmage takes a deep breath.>$B$BThere\'s nothing like the smell of clean air and danger.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(90512,'','If it were up to me, I\'d be the one to carry out this mission. But Archmage Khadgar insisted that you would have a more delicate touch.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(90513,'','I still bear old wounds from the demons\' first coming to Azeroth. I remember the horror, the madness, and the stillness that descended upon a city destroyed.$B$BI will do anything in my power to prevent that from happening again.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(90514,'','I cannot fathom why anyone would pledge themselves to the Legion.$B$BThere are those who lust for power, and do not know how to wield it.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(90515,'','The Sargerei village is like a beehive.$B$BDisturb its denizens, and we will get stung. Destroy it in flames, and we will destroy the precious honeycomb as well.$B$BThe only way to retrieve the information we seek is through sublety.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(90516,'','I spoke with Warlord Volrath today. He is concerned that our troops are refusing to march into the burial grounds.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90517,'To arms! To your posts! The Thunderlords want to play.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90518,'Oh yeah? Why do you think that is?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(90519,'I\'ve toyed with you long enough!','',0,0,0,0,0,0,0,0,0,0,44517,0,26124),
(90520,'','The grunts that return from there are reporting sighting of strange spirits. They say that necromancers are enslaving the ghosts of the ancient ogres.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90521,'Ghost ogres? I can see why they\'d stay away. Not that I\'m afraid or anything, but I prefer enemies I can actually strike with an axe.','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(90522,'','Exarch Othaar\'s betrayal was sudden. How could a leader of the draenei turn his back on the Light, and embrace the enemies who persecuted his entire race?',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(90523,'I\'ve seen enough. Fight your own battles, oh great and powerful king.','',0,0,0,0,0,0,0,0,0,0,46492,0,26124),
(90524,'Our task is grim, but necessary.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90525,'','His new allies have given him a new name, and a new identity - \"Socrethar.\" He is a powerful enemy, and I fear what he is capable of.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(90526,'','Greetings, commander. Would you like to view any recent major events?',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(90527,'Show me what happened at the Battle for Shattrath.','Show me what happened at the Battle for Shattrath.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90528,'','Have you heard of me, $n? I am Modera, archmage of the Council of Six, which rules the Kirin Tor and Dalaran.$B$BI could wipe out this entire village if I chose.$B$BBut that is not why we are here. As I have learned through the years, sometimes you need honey to catch a fly.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(90529,'Lok\'tar, commander. Would you like to view any recent major events?','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(90530,'','Look! It\'s $n!',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(90531,'','Is that $n? They say $Ghe\'s:she\'s; the greatest $c that ever was!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(90532,'It looks like $n\'s arrived to help crack some Alliance skulls!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90533,'Could you conjure me some food?','Could you conjure me some food?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90534,'','It\'s a bit warm out today, don\'t you think?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90535,'Da Alliance think dey so smart. Dey hidin\' behind dis truce of deirs, meanwhile dey searchin\' dis island high and low for a powerful weapon, but dey no askin\' for our help.\n\nSure, dey say da weapon is ta be used against da Iron Horde, but what is ta stop dem from turnin\' it on us once we off dis world?\n\nI say we take da weapon, and we be showin\' dem who has da powah - on dis world as well as ours.\n\nFor da Horde!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(90536,'','We got reports from da field, mon!',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(90537,'You did good bringin\' me dis report. Now, be returnin\' to da field.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90538,'','Right away, boss!',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(90539,'','Our reports be statin\' dat dere is a group of hostile arakkoa outcasts  jus\' outside da outpost.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90540,'Arakkoa outcasts, ya say? Here I thought we be allies with dem.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90541,'I\'ll be needin\' to have some words with our friends from the Ravenspeakers to figure out da true nature of dese arakkoa.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90542,'','Boss, our scouts are sayin\' dat da Alliance is empowerin\' a giant ancient ta send into battle!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90543,'Hah! If dey think they can scare da Horde with a big tree, den we be havin\' a surprise for dem!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(90544,'We\'ll be seein how dey feel when da earth below dem comes ta fight at our side!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90545,'','Da elf, Belloc, been sayin\' dat he be needin more men ta find da big artifact.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90546,'Dat Belloc bein\' lucky dat I haven\'t lost my patience with him! I don\'t jave soldia\'s layin around ta be diggin\' up relics!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90547,'You tell da elf that he get whateva\' volunteers he get. And he better be hurryin\' up before I get tired a\' lookin at him!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90548,'','We be gettin some strange reports from out scouts over by da big ogre mine.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90549,'','Dey say dere be a giant creature in the mine dat\'s been makin\' short work of any grunts dat look at it twice.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90550,'I am a master of persuasion, but it seems the Sargerei value strength, not oratory.$B$BThe quickest way to earn their trust is through battle. I am sure that is why Modera sent you to help me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90551,'Da grunts be tough, it\'s true, but dey don\'t have da smarts to take on such a monsta. I\'ll send da Shadow Huntas in, and we\'ll see how tough dis thing is.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90552,'The Thunderlords are here to give us a lesson in revenge. Instead, let\'s teach them humility.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90553,'The first charge is broken.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90554,'Spread out! Don\'t let them flank us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90555,'We\'ve almost got them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90556,'Stubborn, I see. This is it, soldiers. For the Alliance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90557,'Touch the Time Bombs to send them back into the sky!','Touch the Time Bombs to send them back into the sky!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90558,'Remember, keep your mouth clenched, so if you\'re struck by lightning then you won\'t bite off your tongue.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90559,'Go Away!','Go Away!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90560,'Tears Ahead','Tears Ahead',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90561,'Dead Inside','Dead Inside',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90562,'Allies Required Ahead','Allies Required Ahead',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90563,'Help Me!','Help Me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90564,'Visions of Demise','Visions of Demise',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90565,'Stay Calm','Stay Calm',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90566,'Loot Ahead','Loot Ahead',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90567,'Thousands of years ago, the demons of the Burning Legion came to our homeworld and offered our leaders a great gift.$B$BTwo of them, Kil\'jaeden and Archimonde, saw the wisdom in their offering, but the last leader, Prophet Velen, refused.$B$BHe and his followers fled from that world, forever hunted by those who once offered their hands in friendship.$B$BVelen was a FOOL! And we are descended from those fools, who would turn their backs on paradise!$B$BNo longer, my brethren! Today, we rise up and bow to the demon lords. They have given us another chance to share in their power.$B$BThis, my brothers and sisters, is our TRUE destiny. Today, we walk in the footsteps of our eredar forerunners, and claim the future that is rightfully ours!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90568,'The Legion\'s work must continue uninterrupted. There are those on Draenor who wish to disrupt their plans, and chief among them are the unbelievers - draenei who still follow the Light.$B$BDestroy our kin, and keep our masters\' work unhindered. Defeat the draenei, and we prove our loyalty to the Legion. Crush Shattrath, and the demons promise us the glory of immortality!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90569,'We draenei are the chosen race... civilized, cultivated, keenly intellectual.$B$BThere is no technology that our minds cannot grasp, and no magic that our arcanists cannot master.$B$BOur civilization on Argus was magnificent to behold.$B$BOur people were never slaves nor cowards, hiding from their potential.$B$BOur people have the means to conquer the stars!$B$BUnite with me, brothers and sisters, and let us take what is rightfully ours!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90570,'','When is Papa coming home?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90574,'%s begins to cast |cFFFF0404|Hspell:176464|h[Ripples in Time]|h|r! Seek cover!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90577,'','Is Papa still hunting?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90579,'I want to build a new structure.','I want to build a new structure.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90588,'Only the very best for you, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90589,'You can make your choice at the drafting table, commander.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90590,'Strengthen my armor and weapon so that they do not dull.','Strengthen my armor and weapon so that they do not dull.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(90591,'Ranjit creates a |cFFFF0000|Hspell:153759|h[Windwall]|h|r near |cFFFF0000$n|r!','Ranjit creates a |cFFFF0000|Hspell:153759|h[Windwall]|h|r near |cFFFF0000$n|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90592,'Ranjit uses his secret technique, |cFFFF0000|Hspell:156793|h[Four Winds]|h|r!','Ranjit uses his secret technique, |cFFFF0000|Hspell:156793|h[Four Winds]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90593,'|TInterface\\Icons\\ability_fixated_state_red:20|tA Solar Flare has |cFFFF0000|Hspell:176544|h[Fixated]|h|r on you! If it reaches you it will |cFFFF0000|Hspell:153828|h[Explode]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(90594,'A Solar Flare |cFFFF0000|Hspell:176544|h[Fixates]|h|r on |cFFFF0000$n|r!','A Solar Flare |cFFFF0000|Hspell:176544|h[Fixates]|h|r on |cFFFF0000$n|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90595,'|cFFFF0000$n|r has been targeted by the Arakkoa\'s |cFFFF0000|Hspell:154043|h[Super Weapon]|h|r!','|cFFFF0000$n|r has been targeted by the Arakkoa\'s |cFFFF0000|Hspell:154043|h[Super Weapon]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90596,'|cFFFF0000$n|r has been selected to be |cFFFF0000|Hspell:153954|h[Cast Down]|h|r!','|cFFFF0000$n|r has been selected to be |cFFFF0000|Hspell:153954|h[Cast Down]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90597,'Tremble before the might of the Forsaken.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90598,'One shot, one kill.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90599,'You won\'t even see me coming.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90600,'Hold still.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90601,'You might feel a slight pinch.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90602,'You\'re already dead.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90603,'Let\'s dance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90604,'Don\'t make this boring.','Don\'t make this boring.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90605,'Right between the eyes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90606,'You will serve in death.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90607,'Dark Lady watch over you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90608,'That\'s it?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90609,'Hardly worth the effort.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90610,'You are unfit to even be raised as a ghoul.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90611,'I knew you wouldn\'t last long.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90612,'You are unworthy of my mercy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90613,'What is your wish, commander?','What is your wish, commander?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90614,'May the Dark Lady smile upon you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90615,'I shall send your regards to the Dark Lady.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90616,'At your service.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90617,'Say the word and consider it done.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90618,'My bow is ready.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90619,'Your will be done.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90620,'Yes, commander?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90621,'You will pay... for this...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90622,'','Don\'t worry, I\'ll only take a moment.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90623,'','Ye want me tae cut ya here first? How about... here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90624,'','Let me show ye how it\'s done.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90625,'','I\'m goin\' tae take me time with ye. I want tae savor yer screamin\'.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90626,'','Ye want tae fight with me, do ye?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90627,'','Show me what yer made out of, ye mongrel.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90628,'','Ye won\'t even know what hit ye.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90629,'','Very well. I\'ll kill ye first.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90630,'','Oops. Did I do that?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90631,'','Scream louder, will ye? I can barely hear ye!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90632,'','That\'s how a Dark Iron does it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90633,'','I may have stabbed ye one too many times.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90634,'','I cannae believe ye were so easy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90635,'','Not much of a fight, really.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90636,'','Well, ye died, so ye have that goin\' fer ya.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90637,'','Better luck next time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90638,'','What can I do fer ye?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90639,'','Nice to see ye, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90640,'','The pleasure is mine.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90641,'','My blades are yours, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90642,'','Need somethin\' \'taken care of\', commander?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90643,'','I won\'t let ye down.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90644,'','At yer service.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90645,'','Point in a direction and I\'m there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90646,'','Ah... they got me...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90647,'On your knees, slave!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90648,'100 gold pieces to the ogre who can bring me this weakling\'s head!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90649,'I\'m casting a big cooldown.','I\'m casting a big cooldown.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90650,'Greetings, Commander $p.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90651,'One more cast...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90652,'A bad day of fishing is still better than the best day of work.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90653,'Here fishy, fishy fishy...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90654,'Spending too much time fishing? That\'s a good problem to have.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90655,'You can make your choice at the drafting table, commander.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90656,'','Greetings, Commander $p.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90657,'$N is under our protection.','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(90658,'You shall not harm this $c.','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(90659,'The guardians of the forge watch over this $r.','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(90660,'I\'m going to light you up, sweet cheeks!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90661,'Who ordered up an extra large can of whoop-ass?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90662,'Stonecore was merely a setback!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90663,'You go ahead and get started. I need to summon up some water.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90664,'I will gladly join your fight against this impudent imbecile!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90665,'Prepare to defend yourself, cretin!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90666,'Here\'s a little something you\'re gonna love!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90667,'Who\'s bad? Who\'s bad? That\'s right, we bad!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90668,'I didn\'t even break a sweat on that one!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90669,'You guys feel free to jump in anytime.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90670,'Don\'t say I didn\'t warn ya!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90671,'Witness the full power of Millhouse Manastorm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90672,'Meet your DOOOOOOOM!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90673,'Better luck next time, BWAHAHAHA!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90674,'Greetings, commander! Faithful minion Millhouse Manastorm here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90675,'You wouldn\'t happen to have access to any N.U.K.U.L.A.R. weapons, would you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90676,'Point me at \'em!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90677,'Hold on, one sec, just need to get my buffs up.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90678,'When do we destroy the world? Soon? I hope it\'s soon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90679,'You will all be my slaves! Er, I mean, hi!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90680,'If you have any excess priceless artifacts that were lost in time, I\'m making a collection.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90681,'Have you ever been hit in the face by a worm made out of rocks? It feels like what it sounds like.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90682,'Heal me! For the love of all that\'s holy, heal me! I\'m dying!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90683,'Krud is here! Any puke dat tinks dey can bring Krud down, better get some tribute. Get enough before Krud gets bored, and earn da right to be eviscerated by Krud.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90684,'Ha! You must really want Krud to slice you in half. Krud be twice as happy to oblige!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90685,'Ha! Krud knew no one brave enough to face Krud. You not even half da fighter Krud be.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90686,'When dis be over, da gravediggers gonna spend days figurin\' out what limbs go wit which body.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90687,'Pathetic... Krud could of cut dat kill time in half...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90688,'Thank you for sparing Leorajh.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90689,'Leorajh and sun rock serve you well. Bring glory to clan!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90690,'Tick... Tock... Tick... Tock','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90691,'Who set up the bomb? Me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90692,'Time to bash skulls.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90693,'No way you gonna get to the Ring of Blood.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90694,'When did dey start lettin\' vermin into da provin\' grounds?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90695,'Dis gonna be a quick fight.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90696,'I\'ve been killin\' pukes like you all day.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90697,'HA! You tink you\'re gonna make it past me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90698,'Careful with that beast you idiots! You have no idea what it cost me to get it here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90699,'Stop gawking and get that beast into a cage!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90700,'Do your job, morons! This beast is worth more than both of your lives!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90701,'If the alliance want Volrath, they\'ll have to get through me first.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90702,'','Well met.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90703,'','Spirits be with you, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90704,'','Watch the shadows, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90705,'Long ago, before this place was infested with saberon, it was a peaceful village.The saberon invaded in the darkness of night and murdered us as we slept.$b$bAll that remains of my kin are our bones beneath the earth.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90706,'I\'m sorry $Gladdie:lass;, but I can\'t give you access to the vault.\n\nThis is where Dr Jones is keepin\' his artifacts secure. Even though the Explorer\'s League is allowing adventurers to store their gear in the extra space, the vault stays off limits.','',274,0,0,0,0,0,0,0,0,0,0,0,26124),
(90707,'turns his |Hitem:118427|h|cFFFFFFFF[Autographed Hearthstone Card]|r|h card over, revealing a |cFFFFFFFF[Common Hearthstone Card]|r!','turns her |Hitem:118427|h|cFFFFFFFF[Autographed Hearthstone Card]|r|h card over, revealing a |cFFFFFFFF[Common Hearthstone Card]|r!',0,0,0,0,0,0,0,0,1,0,47498,47498,26124),
(90708,'Chopped and brewed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90709,'Alright boys and girls, it\'s prime time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90710,'I don\'t care how many o you dere be, one swing and you all be on da ground.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90711,'turns his |Hitem:118427|h|cFFFFFFFF[Autographed Hearthstone Card]|r|h card over, revealing a |cFF0070dd[Rare Hearthstone Card]|r!','turns her |Hitem:118427|h|cFFFFFFFF[Autographed Hearthstone Card]|r|h card over, revealing a |cFF0070dd[Rare Hearthstone Card]|r!',0,0,0,0,0,0,21,0,1,0,47499,47499,26124),
(90712,'turns his |Hitem:118427|h|cFFFFFFFF[Autographed Hearthstone Card]|r|h card over, revealing an |cFFa335ee[Epic Hearthstone Card]|r!','turns her |Hitem:118427|h|cFFFFFFFF[Autographed Hearthstone Card]|r|h card over, revealing an |cFFa335ee[Epic Hearthstone Card]|r!',0,0,0,0,0,0,71,0,1,0,47500,47500,26124),
(90713,'Dead rats!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90714,'That was not a profitable endeavor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90715,'turns his |Hitem:118427|h|cFFFFFFFF[Autographed Hearthstone Card]|r|h card over, revealing a |cffff8000[Legendary Hearthstone Card]|r!','turns her |Hitem:118427|h|cFFFFFFFF[Autographed Hearthstone Card]|r|h card over, revealing a |cffff8000[Legendary Hearthstone Card]|r!',0,0,0,0,0,0,71,0,1,0,47501,47501,26124),
(90716,'To the face!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90717,'Eat dirt!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90718,'I puke up puddles tougher den you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90719,'','Time for you to leave!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90720,'I not sure whether to kiss you... or fight you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90721,'I been lookin\' for a fight!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90722,'Victory or death. There are no other options.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(90723,'I fought long and hard to get the opportunity to serve under you, commander.$B$BIt\'s truly an honor.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(90724,'It will be done, commander.','',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(90725,'Right away, commander.','',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(90726,'You can make your choice at the drafting table, commander.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(90727,'You can make your choice at the drafting table, commander.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(90728,'Fortune cookie say...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90729,'Oh boy...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90730,'Awful, just awful.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90731,'Please, never again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90732,'What?! C\'mon that was gold man.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90733,'Did you see the look on his face?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(90734,'It was priceless!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(90735,'Cymre! Is that you?','Cymre! Is that you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90736,'','Hello again. We got wind that there are hidden artifacts here, in this place called Ashran. Artifacts from a remnant Highmaul Ogre clan. $B$BDo you have any idea what kind of power they could possibly hold?$B$B',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90737,'We\'re going to have to get back out there soon.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90738,'Yeah I know, but those crazy bird things really creep me out.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90739,'Welcome, my friend, to your death.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90740,'By the light!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90741,'Go on! Give me a reason to heal myself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90742,'... sigh...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90743,'Try healing through that.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90744,'Should have brought a better healer, my friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90745,'... sigh...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90746,'I look forward to healing you, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90747,'Warm wishes to you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90748,'Where was my tank... ?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90749,'Hey there, Commander $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90750,'For the Frostwolves!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90751,'For honor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90752,'To battle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90753,'Lok-tar ogar! Victory or death!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90754,'Taste my axe!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90755,'For Stonefang!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90756,'A good death.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90757,'Die with some dignity.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90758,'Lok-tar!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90759,'Yes! A good battle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90760,'Throm-Ka.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90761,'The Frostwolves stand ready.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90762,'Lok-Regar.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90763,'My axe is ready.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90764,'Nerok thirsts for battle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90765,'The Iron Horde will pay for my fallen brothers and sisters.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90766,'Lokra... forgive me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90767,'|cFFFF0000WARNING!|r! You\'ve entered an extremely dangerous area! |cFFFF0000Turn Back|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(90768,'When you die, I shall claim your shoes as my own!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90769,'Hahahaha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90770,'Time for a taste from the pain wagon of murder meat!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90771,'Another skull to wear.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90772,'Dibs on its belt!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90773,'I am keeping its nose.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90774,'This skull is too small and unusable. Bring me another!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90775,'Can I have your skull when you die?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90776,'I shall make a totem from the corpses of your enemies.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90777,'Hahahaha... ahem... hail.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90778,'No! I lost my ankh.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90779,'','Ah, hero... I knew you would come. Gaze upon the source of your demise!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(90780,'','Now, I will leave you a taste of the Iron Horde\'s new power!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(90781,'We have been studying this \"Heart of Gorgorek.\" It bears a great number of similarities to certain titan artifacts we have seen back on Azeroth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90782,'We must call upon experts before we can be sure of the artifact\'s origin, and purpose. In fact, we may need to transport the device back to Azeroth for additional study.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90783,'The artifact that we discovered in Gorgrond appears to have a similiar signature to this one.$B$BIt is almost certain that it was a smaller fragment of this larger, intact device.$B$BIf the splinter was capable of summoning a colossal creature to your aid, then what could this device be capable of?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90784,'','We have been studying this \"Heart of Gorgorek.\" It bears a great number of similarities to certain titan artifacts we have seen back on Azeroth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90785,'','We must call upon experts before we can be sure of the artifact\'s origin, and purpose. In fact, we may need to transport the device back to Azeroth for additional study.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90786,'','The artifact that we discovered in Gorgrond appears to have a similiar signature to this one.$B$BIt is almost certain that it was a smaller fragment of this larger, intact device.$B$BIf the splinter was capable of summoning a colossal creature to your aid, then what could this device be capable of?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90787,'','Why did we have to come to Shadowmoon? Min Loo knows I hate the dark...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90788,'','I improved our map by color coding each destination by its danger level!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90789,'Have you tried the local fare? These draenei sure know how to cook.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90790,'Have you been to the Crescent Hearth? They have some delicious pies. Or Embaari Village? The fresh produce is shipped in from Elodor daily!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90791,'I like it here in Shadowmoon Valley. It\'s so peaceful and quiet... not like that bone zone.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90792,'When we improve this boat, I\'m going to replace all the parts for half the price!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90793,'','This boat is quite legitimate!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90794,'Zarg like kitties. Zarg train his little kitties to be cute little warriors. \n\nWhat? Why you look at me like that? \n\nYou got something against kitties?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90795,'You need talk to Varzok in Orgrimmar!  Any guard there should be able to give directions to him.\n\nDa portal to Orgrimmar inside shaman hut.  Good luck!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90796,'$n detonated Destructive Resonance!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(90797,'I have seen the saberon strip the bones of the innocent. I have seen the remains of my clansmen cooked in their wretched cauldron. Now... it shall be the saberon whose bones are desecrated and boiled!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90798,'You have honored the memory of my kin, $c. Take this blessing with you on your journey, so that it may it guide your arm and swiften your step.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90799,'Man, I thought it would be a pretty sweet gig coming out here with the Society. Boy was I wrong!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90800,'','What\'s wrong with this place? The digs ain\'t bad.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90801,'It ain\'t the digs I\'m concerned about. Everywhere you turn either an ogre is trying to club your head in, or one of those Alliance goons wants to stick a sword in ya!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(90802,'','I thought you were tellin\' me that you laugh in the face of danger? Sounds like you might be afraid of this place.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90803,'Oh I ain\'t afraid, baby. It\'s just that death puts a steep cut in the profit margins.','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(90804,'Is beer the only thing these orcs drink? What does a goblin gotta do to get a nice cocktail around here?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(90805,'','It ain\'t so bad. It kinda makes me nostalgic.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90806,'Nostalgic? How does that swill make you nostalgic?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(90807,'','Well, the taste kinda reminds me of the runoff water from cooling the machines back home. It\'s all we had to drink when I was a kid.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90808,'Wow, that\'s... surprisingly accurate.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90809,'How about we see who is on the other side of these anomalous shenanigans?','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(90810,'After the toll taken from our assault on the Dark Portal, much of our remaining forces came to regroup here in Ashran. It is unfortunate that hostilities with the Alliance came shortly after.\n\nDo you seek refuge here, as well, or do you wish to stoke the flames of battle further?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(90811,'Temporal juxtaposition incoming!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(90812,'','These trolls aren\'t so bad. They may be skinny and talk funny, but they make a fun spear launcha! \n\nI can\'t wait to skewer some dwarves with this thing!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(90813,'Wow! It worked. And we haven\'t been temporally inverted.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(90814,'The sign reads:\n\n\"I\'m Commander $n, and this is my favorite merchant in Warspear.\"','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90815,'','Pay dat sign no heed, mon. Just a harmless bit a\' advertisin\'.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90816,'','This did not have to end in violence.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90817,'','The light shall burn you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90818,'','For the Sha\'tari.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90819,'','For the Alliance, for the King!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90820,'','You chose the wrong side.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90821,'','You have failed in your quest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90822,'','Commander, I think an inn would greatly improve morale.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90823,'','Commander, I have tallied your defenses and believe we might benefit from additional balancing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90824,'','Commander! ...When will the Prince be visiting?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90825,'','If I wrote a letter, would you take it to Stormwind for me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90826,'','I hear you have a prince who follows the light. Will he be visiting soon?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90827,'','For... the light.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90828,'The Spirit of Exarch Hataaru begins casting |cFFFF0000|Hspell:176784|h[Pain Field]|h|r!','The Spirit of Exarch Hataaru begins casting |cFFFF0000|Hspell:176784|h[Pain Field]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90829,'','Let\'s see what YOUR bones look like.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90830,'','Mind helping with an experiment?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90831,'','Oh, hold still. I want to try a new spell.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90832,'','Are you an animal, vegetable, mineral, or other?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90833,'','I mostly work with fossils, so, this might hurt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90834,'','Oh, so that happened.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90835,'','Interesting results.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90836,'','Note to self, $n is very sensitive to fire.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90837,'','Oops.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90838,'','There are all sorts of shiny trinkets buried under the ground here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90839,'','Hey commander. Can I get salvage rites to this place after you die?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90840,'','Live by the fossil, become a fossil.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90841,'Kneecaaaaps!','Kneecaaaaps!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90842,'Die! Die-die-die-die!','Die! Die-die-die-die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90843,'Mmm. Smell meat!','Mmm. Smell meat!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90844,'Dinner time? Dinner tiiiime!','Dinner time? Dinner tiiiime!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90845,'Look tasty-tasty!','Look tasty-tasty!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90846,'Hee hee hee! Blood!','Hee hee hee! Blood!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90847,'We kill! Kill-kill-kill!','We kill! Kill-kill-kill!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90848,'No kill?','No kill?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90849,'This will only hurt for a moment.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90850,'Why you no die?','Why you no die?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90851,'I will reduce you to ashes!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90852,'For the Order!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90853,'Ow-ow-ow-ow-ow!','Ow-ow-ow-ow-ow!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90854,'You will burn for your crimes!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90855,'Rukhmar, guide my hand.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90856,'You... you no good.','You... you no good.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90857,'You have no place in our future.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90858,'No-no-no-no-no...','No-no-no-no-no...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90859,'Such is the cost of progress.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90860,'I have no tolerance for savagery.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90861,'Blind fool.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90862,'A brilliant future awaits us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90863,'Greetings, commander. I trust everything is in order?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90864,'The light of the Awakened is at your command.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90865,'You are looking rather radiant today.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90866,'I am glad to be among new allies.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90867,'Forgive me, commander, but I am feeling a bit... cooped up. Do you have an away mission for me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90868,'I return... to Rukhmar.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90869,'You will not interfere!','You will not interfere!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90870,'Are you lost?','Are you lost?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90871,'These rylaks are property of the Iron Horde!','These rylaks are property of the Iron Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90872,'Your path leads only to death.','Your path leads only to death.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(90873,'Trespasser!','Trespasser!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(90874,'Bin huruk thora korro... rra hokumm ura korak.','Bin huruk thora korro... rra hokumm ura korak.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90875,'I do not fear death.','I do not fear death.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90876,'My brothers shall avenge me.','My brothers shall avenge me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90877,'Ah ha! More for the mulch!','Ah ha! More for the mulch!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90878,'The god in bloom will not be disturbed!','The god in bloom will not be disturbed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90879,'Remove this... bramble from our garden.','Remove this... bramble from our garden.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90880,'Your corpse will feed our god!','Your corpse will feed our god!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90881,'You will be harvested!','You will be harvested!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90882,'Great genesaur, feed on me.','Great genesaur, feed on me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90883,'I give life to my master.','I give life to my master.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90884,'The cycle... continues...','The cycle... continues...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90885,'...Farondis... the Tidestone of Golganneth... our last hope...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90886,'That is all I can remember. Help me reclaim my memories, and I may be able to aid you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90887,'Farondis, the time to move is now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90888,'Your Queen Azshara\'s abuse of magic has attracted the attention of a legion of demons. We have little time left.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90889,'I agree... but must we use the Tidestone? Such a drastic solution.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90890,'Very well.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90891,'I knew I could rely on you, Farondis.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90894,'Illidan, I have doubts about Cenarius\' plan.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90895,'He wants to use the Tidestone of Golganneth! To destroy the Well of Eternity itself!','',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(90896,'It\'s a doomsday device!','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(90897,'I know. But you aren\'t strong enough to keep Cenarius away from the Tidestone... even with my help.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90898,'What do we do, then?','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(90899,'Only Queen Azshara herself stands a chance against a demigod like him.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(90900,'I\'m sorry, Cenarius. I believed in your cause, but I couldn\'t bring myself to turn against...','',0,0,0,0,0,0,397,0,4,0,0,0,26124),
(90901,'','You\'ve done me a great service today, Farondis.',0,0,0,0,0,0,430,0,4,0,0,0,26124),
(90902,'','What a shame that you won\'t LIVE to reap the benefits of my gratitude.',0,0,0,0,0,0,396,0,4,0,0,0,26124),
(90903,'...what?!','',0,0,0,0,0,0,5,0,4,0,0,0,26124),
(90904,'','This whole valley is filled with plotters and schemers.',0,0,0,0,0,0,274,0,4,0,0,0,26124),
(90905,'','Cavorting with Cenarius behind my back? I will NOT tolerate dissent!',0,0,0,0,0,0,474,0,4,0,0,0,26124),
(90906,'Tasty tasty!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90907,'Aim for its heart!','Aim for its heart!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90908,'Watch. I shall conjure an image of the few memories I have about this... Tidestone.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90909,'I\'m afraid that the Tidestone of Golganneth may be our last hope.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90910,'','Here it is, my Prince: The Tidestone of Golganneth, one of the seven Stones of Creation, and treasured relic of the kaldorei.',0,0,0,0,0,0,6,0,4,0,0,0,26124),
(90911,'Very good. Leave me.','',0,0,0,0,0,0,1,0,4,0,0,0,26124),
(90912,'','Tales of your deeds travel far, $c. Allow me to recount some of your greatest exploits.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(90913,'%s throws down a Hearthstone board! Who\'s ready to play?','%s throws down a Hearthstone board! Who\'s ready to play?',396,0,0,0,0,0,396,0,0,0,0,0,26124),
(90914,'%s opens up a new pack of Hearthstone cards. Mmm, love that new card smell!','%s opens up a new pack of Hearthstone cards. Mmm, love that new card smell!',396,0,0,0,0,0,396,0,0,0,0,0,26124),
(90915,'%s just won a game of Hearthstone!','%s just won a game of Hearthstone!',396,0,0,0,0,0,396,0,0,0,0,0,26124),
(90916,'|TInterface\\Icons\\spell_burningbladeshaman_molten_torrent.blp:20|t |cFFFF0404|Hspell:154938|h[Molten Torrent]|h|r killed you. Minimize damage by standing near several allies.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90917,'Where did everyone go?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90918,'|TInterface\\Icons\\spell_burningbladeshaman_molten_torrent.blp:20|t |cFFFF0404|Hspell:154938|h[Molten Torrent]|h|r killed you. Standing near a group of allies reduces the amount of damage taken by everyone affected!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90919,'|TInterface\\Icons\\spell_burningbladeshaman_molten_torrent.blp:20|t |cFFFF0404|Hspell:154938|h[Molten Torrent]|h|r killed you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90920,'You want spikes? Got lots of spikes. Spikes go good on everything! Make it look spikier.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90921,'The shrine has dozens of niches where the Prophet\'s followers have placed memory crystals, mourning the great leader\'s sacrifice. There are hundreds of prayers and remembrances here, from peasants to Exarchs and everyone in-between.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90922,'The shipment from the Forge never arrived, so the boys took off early.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90923,'Listen to the Prophet\'s final message.','Listen to the Prophet\'s final message.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90924,'The load of weapons from the Forge never showed up, what\'s going on up there?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90925,'These weapons aren\'t imbued! Ka\'graz go on break or something?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90926,'This place needs more spikes.','This place needs more spikes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90927,'','Tales of your deeds travel far, $c. Allow me to recount some of your greatest exploits.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(90928,'Man who turned the heat off, it\'s FREEZING in here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90929,'What\'s wrong with Kromog? I haven\'t heard him rumbling in a while.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90930,'Not now! These humans have brought in all of this mouth watering meat! Just look at it! Imagine, gnashing and shredding it with your fangs. The juices and the ripping of meat from the bone as you\'re devouring it... \n\n<The worgen\'s eyes wander off...>\n\nWhat did you want again?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90931,'When a Druid fights in tree form, he\'s called a combat log.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90932,'Talador: The Battle for Shattrath','Talador: The Battle for Shattrath',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90933,'Frostfire Ridge: Thunder Pass','Frostfire Ridge: Thunder Pass',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90934,'These crates of Ore are piling up, those guys up in the Blast Furnace sure are slacking!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90935,'When a gnome clockmaker is hungry, he goes back 4 seconds.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90936,'Talador: Battle for Shattrath','Talador: Battle for Shattrath',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90937,'Shadowmoon Valley: Darkness Falls','Shadowmoon Valley: Darkness Falls',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90938,'I tried getting Feldspar on the line and he isn\'t answering, I bet he\'s off talking to Foreman Jorge again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90939,'When one Tauren spies on another, it\'s called a steak out.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90940,'A rogue\'s favorite drink is subtle tea.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90941,'A Pandaren who cooks in the dark must use a Shado-Pan.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90942,'Why would you start a fire! Don\'t you see the crates of ammo piling up over there!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90943,'Cuz it\'s cold!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90944,'Hunters take bad photographs because they are always out of focus.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90945,'Blasted Lands: Into the Portal','Blasted Lands: Into the Portal',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90946,'Never argue with a Tauren, it goes in one ear and out the udder.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90947,'A Mage who cannot fish is considered a bad caster.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90948,'Queue me up for the Coliseum!','Queue me up for the Coliseum!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90949,'Tanaan Jungle: A Taste of Iron','Tanaan Jungle: A Taste of Iron',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90950,'When a trinket gets angry, it needs to cooldown.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90951,'When Paladins are unhappy about their pay, they go on Crusader Strike.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90952,'Nagrand: And Justice for Thrall','Nagrand: And Justice for Thrall',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90953,'Kill the interlopers! The siphoning must not be disturbed! (We\'re making a void god!)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90954,'Open the portals to the realm of the living! Soon we shall feast upon their souls!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90955,'I can\'t wait till I\'m strong enough to wear THIS skull!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90956,'The Light within Oshu\'gun is dying... soon our path will be clear to invade the realm of the living!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90957,'Oh hi! Kaz told me you might be back. She comes by sometimes to see how I\'m doing and burn bodies.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90958,'The legions of the void are without number! Nothing will stand in our way!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90959,'Did you know genesaur have skulls? I didn\'t know. It took a long time to get all the vines off of it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90960,'The void within Oshu\'gun grows... and with it our path to the mortal realm! The feast of souls is upon us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90961,'Greetings, $r.$B$BI can see from your demeanor that you are no ordinary adventurer.$B$BDraenor is a harsh world and many dangerous enemies lurk in both palaces and crypts. They aim to bring terrible destruction to this land using devastating weapons and magic. Securing these places and their treasures would mean excellent rewards for you and your companions.$B$BHowever, do not tread idly into these places, for other adventurers are nipping at your heels and only a race against time will prove your skills to be unmatched!$B$BAre you up for the new challenge Draenor has to offer?','Greetings, $r.$B$BI can see from your demeanor that you are no ordinary adventurer.$B$BDraenor is a harsh world and many dangerous enemies lurk in both palaces and crypts. They aim to bring terrible destruction to this land using devastating weapons and magic. Securing these places and their treasures would mean excellent rewards for you and your companions.$B$BHowever, do not tread idly into these places, for other adventurers are nipping at your heels and only a race against time will prove your skills to be unmatched!$B$BAre you up for the new challenge Draenor has to offer?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(90962,'Grant me the blessings of the anvil and the forge.','Grant me the blessings of the anvil and the forge.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(90963,'We will feed your bones to the wolves, outsider.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90964,'You cannot defeat the spirit of the Warsong!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90965,'Relent to the unstoppable power of the elements!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90966,'What wonderful timing. My last plaything had to split.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90967,'I return to the earth, but I will rise again enflamed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90968,'Coming into our camp was reckless, but facing me is suicide.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90969,'It\'s an ambush!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90970,'I want to hear you scream as I peel the flesh from your bones!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90971,'Scream for me!','Scream for me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90972,'I want to watch you bleed.','I want to watch you bleed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90973,'Blood and pain!','Blood and pain!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90974,'I\'m going to rip you apart slowly.','I\'m going to rip you apart slowly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90975,'Such lovely skin, I think I\'ll keep it after you\'re dead.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90976,'Victory or death!','Victory or death!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90977,'For the glory of the Warsong!','For the glory of the Warsong!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90978,'The might of the Warsong will crush you!','The might of the Warsong will crush you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90979,'How did you get up here?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90980,'What are you doing here?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90981,'This land is ours!','This land is ours!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90982,'You dare stand against the Warsong?!','You dare stand against the Warsong?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90983,'Blood and glory!','Blood and glory!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90984,'Death to our enemies!','Death to our enemies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90985,'You should not be here!','You should not be here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90986,'Leave us to our anguish!','Leave us to our anguish!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90987,'','For Draenor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90988,'','Try to flank them...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90989,'','Keep the high ground!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90990,'','Exarch Naielle sends her regards.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90991,'','Dispatched.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90992,'The pain... make it stop!','The pain... make it stop!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90993,'','Stay out of Shadowmoon!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90994,'','The rangari are ready to serve.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90995,'','May I suggest building a few sniper nests in the trees surrounding our stronghold?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90996,'I\'ll rip the skin from your bones!','I\'ll rip the skin from your bones!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90997,'','I will scout the perimeter during the night watch.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90998,'','These woods provide excellent cover, but may mask an attack. We should stay vigilant.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(90999,'You\'ll pay for coming here!','You\'ll pay for coming here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91000,'','I\'m... bleeding out...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91001,'Die!','Die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91002,'Make the voices stop!','Make the voices stop!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91003,'I am engaging!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91004,'Defend the town hall!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91005,'Get the laborers to safety.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91006,'They will go no further!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91007,'Engage the defenses. Begin the counter-attack!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91008,'Target eliminated.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91009,'You are finished!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91010,'Begone!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91011,'My equipment is superior.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91012,'','You fight with much experience, Thrall. Why do you not have a mate?',0,0,0,0,0,0,6,0,0,0,0,44717,26124),
(91013,'Commander! I have submitted plans to reinforce the walls.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91014,'For the glory of the Iron Horde!','For the glory of the Iron Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91015,'Do you need anything repaired?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91016,'Our might will crush you!','Our might will crush you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91017,'','You... wanted her to stay? This is war! More than ever, this is when family belongs at your side!',0,0,0,0,0,0,1,0,0,0,0,44718,26124),
(91019,'Your followers need better equipment. I will do my best to procure what I can.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91020,'You dare challenge our might?!','You dare challenge our might?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91021,'','What a strange green orc you are.',0,0,0,0,0,0,274,0,0,0,0,44719,26124),
(91022,'Your death will be my glory!','Your death will be my glory!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91024,'I\'ve been sharing schematics with the engineers from Azeroth. Gnomish technology is... unique.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91025,'So much to build. So little time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91026,'They got me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91027,'The Iron Horde will break you!','The Iron Horde will break you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91028,'Hurry up and die!','Hurry up and die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91030,'','Light protect us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91031,'','The faithful will never fall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91032,'','Light guide my strikes...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91033,'','We will never falter!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91034,'','Stay behind me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91035,'I will crush the life from your bones!','I will crush the life from your bones!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91036,'','Justice is done.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91038,'I do. I saw that my mate remained behind to care for our little ones.','',0,0,0,0,0,0,1,0,0,0,46366,0,26124),
(91039,'','We must fight on.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91040,'','This is not over.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91041,'I will be your end!','I will be your end!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91042,'','The light will never forsake us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91043,'I... never looked at it that way.','',0,0,0,0,0,0,1,0,0,0,46367,0,26124),
(91045,'','It is good to see you, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91046,'','I have been aiding the wounded since the last attack.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91048,'','We must protect the draenei heartland.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91049,'','You have created a tranquil bastion amidst the chaos of war. Thank you, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91052,'','I give myself to the light!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91053,'Primordial Horrors Killed: $1i (+$2i)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91054,'We may have lost the heart but we won this battle. The garrison is secure... for now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91055,'Shadowmoon Voidaxes Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91056,'Shadowmoon Ritualist Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91057,'My assistant is dead? Oh man... that\'s not good. This is a little over my pay grade. You probably want to speak with Zog.','',412,0,0,0,0,0,0,0,0,0,0,0,26124),
(91058,'Shadowmoon Prophets Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91059,'Shadowmoon Voidbinder Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91060,'Void Essences Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91061,'Shadowmoon Darkcasters Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91062,'Where can I replace a lost ring or acquire another?','Where can I replace a lost ring or acquire another?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91063,'','Despite the chaos, the sunset here is very soothing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91064,'Impossible! Your ring is a handcrafted masterpiece of exquisite arcane craftsmanship, invaluable and irreplaceable!$b$bOn the other hand, Zooti Fizzlefury outside of my tower here is an expert in procuring the impossible. Maybe you could cross his palms with some gold.$b$bI won\'t make any guarantees.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91065,'Hello $ghandsome:miss;.  I can assist you in recovering lost companions.','Hello $ghandsome:miss;.  I can assist you in recovering lost companions.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91066,'The void beckons me...','The void beckons me...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91067,'I am unstoppable!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91068,'Return to the earth mongrel!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91069,'Return to the light!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91070,'You have been judged, unworthy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91071,'For Silvermoon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91072,'','I hear you are responsible for returning one of my sons to me, $p. You have my eternal gratitude.$b$bThough my heart was warmed at the sight of Ga\'nar again, his own heart has been torn by too much grief and suffering.$b$bI had seen this before in his eldest brother Fenris before we lost him forever.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91073,'I feel like I\'m staring into eternity...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91074,'<Simply standing in the presence of the naaru fills you with a sense of peace. You sense something else, as well - a watchful, protective eye. Perhaps Prophet Velen lives forever within the light of the purified naaru.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91075,'I was raised on stories of Frostfire Ridge, the ancestral home of the Frostwolves.$b$bI never believed I would ever see the clan as they were in their prime, with Durotan as their chief.$b$bHe is... shorter... than I imagined. The burden of leadership weighs heavy on his shoulders.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91076,'Turn around, $c. You\'ll find nothing but suffering in here.','Turn around, $c. You\'ll find nothing but suffering in here.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(91077,'The darkness calls... I cannot resist.','The darkness calls... I cannot resist.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91078,'Oshu\'gun awaits...','Oshu\'gun awaits...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91079,'The call of the void... I can hear it beckoning...','The call of the void... I can hear it beckoning...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91080,'The void... calls...','The void... calls...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91082,'Can\'t stop, won\'t stop!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91083,'Shattered!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91084,'If you\'ve got the cash, I\'ve got the ride!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91085,'I can fly you anywhere... for a price of course!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91086,'Galactic Fist Strike!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91087,'You lack discipline!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91088,'Aha ha ha ha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91089,'|cFFFF0000|Hspell:177150|h[Booming Shout]|h|r killed you.  Get out of Line of Sight or the further you are from Kor\'lok, the lower the damage from Booming Shout.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(91090,'','For Gnomergan!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91091,'Just don\'t touch my pigtails please...','Just don\'t touch my pigtails please...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91092,'','Fear the power of the gnomes!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91093,'','Gnome power!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91094,'','Small and sneaky!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91095,'','These Steamwheedle goblins are reprehensible. They\'ll do anything to make a quick coin!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(91096,'What did they do this time?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(91097,'Fresh meat!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91098,'No one survives.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91099,'Pain is the lesson!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91100,'This one is mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91101,'Run! It\'s more fun that way...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91102,'','They\'ve started selling souvenirs!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(91103,'Your life is mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91104,'I\'ll cut you to pieces!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91105,'|TInterface\\Icons\\warrior_disruptingshout.blp:20|t %s begins to cast |cFFFF0000|Hspell:177155|h[Disrupting Shout]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(91106,'Show me your blood!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91107,'We\'re barely recovering from our assault on the dark portal, and they\'re setting up a tourism racket? Surely you must be joking.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(91108,'I die free!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91109,'I fear no death!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91110,'I regret nothing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91111,'Freedom... was a lie.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91112,'','I wish it were a jest. They\'ve been stringing together artifact fragments and selling them as jewelry. The nerve of them to treat a priceless such a way!',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(91113,'Never... surrender...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91114,'','Has Belloc come any closer to finding the location of this mysterious artifact?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(91115,'|TInterface\\Icons\\ability_warrior_savageblow.blp:20|t %s begins to cast |cFFFF0000|Hspell:177147|h[Mortal Cleave]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(91116,'Iron and blood!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91117,'You cannot stand against iron!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91118,'Iron hearts and iron will!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91119,'Frostfire is ours!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91120,'He\'s had some leads, but nothing terribly solid yet.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(91121,'','We must make haste if we wish to find it before Dr. Jones gets his hands on it.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(91122,'Agreed, there is no telling what the Alliance might do with such a powerful weapon. We must petition for more aid before our cause becomes lost.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(91123,'Death to the low races!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91124,'The skies are ours!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91125,'Die, vermin!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91126,'For Rukhmar\'s glory!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91127,'For Skyreach!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91128,'So what do you supposed the nature of this fabled artifact is?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(91129,'Kneel before your superior!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91130,'You will not escape me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91131,'','If it is as powerful as Dr. Jones theorizes, it may very well be of titan origin.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(91132,'Ra-kawww!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91133,'That seems a little far-fetched. I haven\'t seen any evidence to link the titans to this world.','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(91134,'How... ?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91135,'Not by... you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91136,'','That may be so, but wouldn\'t it be grand to discover that the titans had reach even here? Just think of the ramifications!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(91137,'','Another trophy for my wall.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91138,'That was some rough business at the Dark Portal. How are you holding up?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(91139,'','I\'m a little worse for the wear, but it\'s not my first scrape. I\'m just excited that our new outpost has such fascinating history to discover!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(91140,'Aye, that it does. That is, when said history isn\'t chasing after you with a broadaxe!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(91141,'My flight... has ended...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91142,'I die for Skyreach.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91143,'','My pet hungers.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91144,'','Shots fired!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91145,'Lord Mes hungers.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91146,'Utterly pathetic.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91147,'Kolrigg! Are you alright?','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(91148,'Death cannot be stopped.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91149,'Lunzul! Stand up, soldier!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(91150,'You show no skill.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91151,'Your will melts before my eyes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91152,'Thieves!','Thieves!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91153,'You dare defy the Adherents?','You dare defy the Adherents?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91154,'Behold Rukhmar\'s fury!','Behold Rukhmar\'s fury!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91155,'Filthy lowborn!','Filthy lowborn!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91156,'Rukhmar... have mercy...','Rukhmar... have mercy...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91157,'Rukhmar... I have failed...','Rukhmar... I have failed...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91158,'The Adherents never forget...','The Adherents never forget...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91159,'Exterminate them all!','Exterminate them all!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91160,'Purge these interlopers from our midst!','Purge these interlopers from our midst!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91161,'You will die like the outcasts!','You will die like the outcasts!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91162,'No mercy for the lowborn.','No mercy for the lowborn.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91163,'This is not your battle, stranger.','This is not your battle, stranger.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91164,'You are a blight on this world.','You are a blight on this world.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91165,'Pitiful ground dweller!','Pitiful ground dweller!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91166,'You will burn with the outcasts!','You will burn with the outcasts!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91167,'You will all burn...','You will all burn...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91168,'Do not trust the outcasts...','Do not trust the outcasts...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91169,'Their curse will rot you...','Their curse will rot you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91170,'This was not... Rukhmar\'s will...','This was not... Rukhmar\'s will...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91171,'Trespassers!','Trespassers!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91172,'This ogre land! You not ogre!','This ogre land! You not ogre!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91173,'Bow to Morkurk!','Bow to Morkurk!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91174,'Ha! So puny!','Ha! So puny!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91175,'I add your head to my collection!','I add your head to my collection!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91176,'Enjoy the void','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91177,'Your head nice. Make good trophy!','Your head nice. Make good trophy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91178,'What hole you crawl out of?','What hole you crawl out of?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91179,'You strong... for something so small...','You strong... for something so small...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91180,'How you do that?','How you do that?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91181,'Morkurk break you soon!','Morkurk break you soon!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91182,'Ah... a fresh soul!','Ah... a fresh soul!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91183,'Another soul for Teron\'gor!','Another soul for Teron\'gor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91184,'Behold Gul\'dan\'s power!','Behold Gul\'dan\'s power!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91185,'Teron\'gor will not be denied!','Teron\'gor will not be denied!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91186,'Teron\'gor... my soul is yours...','Teron\'gor... my soul is yours...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91187,'This... changes... nothing...','This... changes... nothing...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91188,'You will join me soon.','You will join me soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91189,'You have already lost...','You have already lost...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91190,'Delicious souls...','Delicious souls...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91191,'Mongrethod hungers!','Mongrethod hungers!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91192,'We are the gateway to oblivion.','We are the gateway to oblivion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91193,'Another soul to harvest.','Another soul to harvest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91194,'Flay them all!','Flay them all!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91195,'How eagerly you seek death...','How eagerly you seek death...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91196,'Mortal blood... delicious...','Mortal blood... delicious...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91197,'A-kreesh!','A-kreesh!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91198,'A-rul shach kigon!','A-rul shach kigon!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91199,'Katra zil shukil!','Katra zil shukil!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91200,'Reesh, hokta!','Reesh, hokta!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91201,'Shaza-kiel!','Shaza-kiel!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91202,'I will live... again...','I will live... again...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91203,'You will succumb... in time...','You will succumb... in time...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91204,'Wretched mortal!','Wretched mortal!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91205,'Anakh kyree!','Anakh kyree!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91206,'Gor\'om haguul!','Gor\'om haguul!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91207,'Kirel narak!','Kirel narak!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91208,'The invasion has begun!','The invasion has begun!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91209,'The Legion consumes all!','The Legion consumes all!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91210,'Drown this city in blood!','Drown this city in blood!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91211,'Auchindoun will crumble!','Auchindoun will crumble!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91212,'This city belongs to the Legion!','This city belongs to the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91213,'You will find only death here.','You will find only death here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91214,'I see... darkness eternal...','I see... darkness eternal...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91215,'You have gained nothing.','You have gained nothing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91216,'Gul\'dan will flay your soul...','Gul\'dan will flay your soul...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91217,'Begone from this place!','Begone from this place!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91218,'You should not have come here.','You should not have come here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91219,'Do not meddle in our affairs!','Do not meddle in our affairs!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91220,'Socrethar demands your soul!','Socrethar demands your soul!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91221,'The Legion guides us!','The Legion guides us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91222,'The Sargerei will... prevail...','The Sargerei will... prevail...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91223,'We did what was... necessary...','We did what was... necessary...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91224,'This is not what was promised...','This is not what was promised...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91225,'This world is ripe for conquest!','This world is ripe for conquest!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91226,'This world will burn like the rest.','This world will burn like the rest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91227,'Burn in emerald fire!','Burn in emerald fire!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91228,'Bleed this world dry!','Bleed this world dry!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91229,'Submit or be consumed!','Submit or be consumed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91230,'The Legion is eternal.','The Legion is eternal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91231,'You will fall... in time...','You will fall... in time...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91232,'You only delay the inevitable.','You only delay the inevitable.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91233,'Intruders!','Intruders!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91234,'Form ranks!','Form ranks!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91235,'Repel the attackers!','Repel the attackers!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91236,'My hatred... burns...','My hatred... burns...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91237,'You will suffer our fate!','You will suffer our fate!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91238,'Traitors!','Traitors!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91239,'Stand down or die!','Stand down or die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91240,'Protect the garrison!','Protect the garrison!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91241,'So... cold...','So... cold...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91242,'Strange. I feel no pain...','Strange. I feel no pain...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91243,'My spirit... is free...','My spirit... is free...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91244,'I am... at peace...','I am... at peace...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91245,'This is our slaughterhouse!','This is our slaughterhouse!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91246,'I hope you fight better than those birds!','I hope you fight better than those birds!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91247,'Your skin will make a fine belt.','Your skin will make a fine belt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91248,'Finally, a challenge!','Finally, a challenge!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91249,'Go on, beg for mercy!','Go on, beg for mercy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91250,'I\'ll give you a scar to be proud of!','I\'ll give you a scar to be proud of!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91251,'Lucky mongrel!','Lucky mongrel!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91252,'Let me suffer!','Let me suffer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91253,'Kargath will be angry...','Kargath will be angry...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91254,'Such... glorious... pain...','Such... glorious... pain...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91255,'Break time!','Break time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91256,'I\'ve got an empty hook for you.','I\'ve got an empty hook for you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91257,'You must be feeling lucky.','You must be feeling lucky.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91258,'Come to join the beasts?','Come to join the beasts?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91259,'Good. Something to skin!','Good. Something to skin!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91260,'Let me hear you scream!','Let me hear you scream!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91261,'This... this is true pain...','This... this is true pain...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91262,'You will not leave here alive.','You will not leave here alive.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91263,'I have never felt... more alive...','I have never felt... more alive...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91264,'Put me on a hook...','Put me on a hook...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91265,'This one is mine!','This one is mine!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91266,'Just like in the arena!','Just like in the arena!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91267,'I\'ll bleed you good!','I\'ll bleed you good!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91268,'You must enjoy pain.','You must enjoy pain.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91269,'Die, you little runt!','Die, you little runt!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91270,'','Taste the fury!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91271,'','Small in stature, grand in talent!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91272,'','You bore me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91273,'My power is unlimited!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91274,'Bwahahahaha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91275,'B-b-b-b-bladestorm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91276,'Not in my house!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91277,'','Don\'t bother trying to duel Zurge, he\'s such a sore loser.$B$BDon\'t tell him I said that.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91278,'Orders are orders.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91279,'If only Max were here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91280,'I told Mare Wildrunner I\'d go explore any part of Ashran other than that Altar area. Ogres I can deal with, but ghost ones? Sorry but it gives me the willies.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91281,'I don\'t know how you can stand talking to that animal Zurge. He\'s so uncivil, even for an Orc.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91282,'You\'re dead weight!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91283,'As for you, well you\'re easy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91284,'I was carrying a sack full of the artifact fragments back to Warspear when some Alliance scum took them from me. Watch your back out there, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91285,'You slow me down, I\'m gonna drop you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91286,'Me lightning!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91287,'You no lightning! You thunder! A force of nature and energy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91288,'Oh! Yes. Me thunder, naturally.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91289,'Yes, it comes naturally to you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91290,'But you lightning, we come together... sparks fly!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91291,'KIIILLLLLLLL!!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91292,'DIIIIIEEEEE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91293,'DEAAATTTH!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91294,'Test, failed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91295,'Your skills are not up to par.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91296,'I consider your effort, incomplete.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91297,'You are nothing to me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91298,'You have failed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91299,'Drown in shadow.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91300,'Greetings, commander. Some willing recruits may still wish to join our garrison. I will gather the contracts for you, so that you may peruse them at your leisure.','Greetings, commander. Some willing recruits may still wish to join our garrison. I will gather the contracts for you, so that you may peruse them at your leisure.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91301,'I don\'t have time to chat. Grand Marshal Tremblade is in desperate need of tanks to help in the battle against the Horde.$B$BWhere did I put that Arclight Spanner...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91302,'','If you see any Horde out there, use some of Bixxie Rocketsocket\'s relief flares. Alliance in the area are sure to come assist you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91303,'We have a number of mounts that still need to be trained. They aren\'t as hardy as your mounts, though, and will tire out after a few battles.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91304,'Do you have any mounts left to train?','Do you have any mounts left to train?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91305,'I\'d like the talbuk-in-training.','I\'d like the talbuk-in-training.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91306,'I\'d like the clefthoof-in-training.','I\'d like the clefthoof-in-training.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91307,'I\'d like the boar-in-training.','I\'d like the boar-in-training.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91308,'I\'d like the elekk-in-training.','I\'d like the elekk-in-training.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91309,'I\'d like the wolf-in-training.','I\'d like the wolf-in-training.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91310,'I\'d like the riverbeast-in-training.','I\'d like the riverbeast-in-training.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91311,'','Harrison Jones is convinced the Artifact may lie within the mines. If that\'s true, the next stage of this battle will be fought underground.$B$BWhat new dangers await us in there? That\'s what I need to find out.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91312,'','While the battle against the Horde indeed lies within what we\'re calling the Road of Glory, we must also focus our efforts at trying to find the Artifact. Who knows where it may be.$B$BLeave no stone unturned. We must find the Artifact before the Horde.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91313,'How are we supposed to win this battle against the Horde without siege engines?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91314,'If only we had an airship. We could take out Warspear from the skies!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91315,'We must focus all of our efforts into the mines. I agree with Dr. Jones, the Artifact has to be there. It has to be!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91316,'It is as we feared, we must venture into the mines. Who knows what ancient dangers are within there...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91317,'Truce? With the Alliance? Never.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91318,'Rogue spies have informed us that the Alliance are building machinery used to drill through rocks. Do you think its for the mines?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91319,'Have you seen how many Death Knights are within our ranks? Why is it that we still can\'t penetrate Stormshield? Are they not using Necrotic Plague?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91320,'If only we were able to bring a Zeppelin through the portal. We could take out Stormshield from the skies!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91321,'Your suffering will be legendary.','',0,0,0,0,0,0,0,0,0,0,46324,0,26124),
(91322,'Arise, my minions! Rend their flesh.','',0,0,0,0,0,0,0,0,0,0,46325,0,26124),
(91323,'VERMIN! I WILL TURN YOUR WORLD TO ASH!','',0,0,0,0,0,0,0,0,0,0,46326,0,26124),
(91324,'Orgrim\'s warpath stops here. I will see to it that my old friends meets the fate he has earned.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(91325,'Shattrath will not fall again. Let us go put these Iron Horde dogs in the ground.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(91326,'','Everything Maraad did... he did to protect our people.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(91327,'','He paid the ultimate price for our freedom. We can never forget his sacrifice.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(91328,'','Thank you for everything you did, $n. Without you... none of us would have survived.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(91329,'Orgrim did what he thought was right. He did not know the path he was following.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(91330,'I will never forget you... old friend.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(91331,'I won\'t forget your help, $n. Without your aid, we all would have fallen to Blackhand.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(91332,'Thank you! We could never have defeated the golem alone.','Thank you! We could never have defeated the golem alone.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(91333,'What can I do fer ya?','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(91334,'You not worthy of ring!','You not worthy of ring!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91335,'I crush you!','I crush you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91336,'Ha! You no gladiator!','Ha! You no gladiator!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91337,'You came to wrong place, runt!','You came to wrong place, runt!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91338,'Me smash you!','Me smash you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91339,'You die in ring...','You die in ring...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91340,'I strong... you stronger...','I strong... you stronger...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91341,'Me... smash... you...','Me... smash... you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91342,'For Auchindoun!','For Auchindoun!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91343,'Light grant us strength!','Light grant us strength!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91344,'Spirits watch over us!','Spirits watch over us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91345,'We will stand against the darkness.','We will stand against the darkness.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91346,'Forward march. For Auchindoun!','Forward march. For Auchindoun!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91347,'The Light... fades...','The Light... fades...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91348,'Auchindoun welcome me...','Auchindoun welcome me...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91349,'The darkness comes for us all...','The darkness comes for us all...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91350,'Want to see a magic trick?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91352,'This ought to be entertaining.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91353,'I hope you\'re wearing fire resistant armor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91354,'You might feel a slight burning sensation.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91355,'I did try to warn you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91356,'Is it warm out here, or is it just me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91357,'Now, now, don\'t get all burned out on me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91358,'It was inevitable, really.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91359,'Pleasure to see you, commander.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(91360,'Any spells you need cast, commander? Portals you need opened? Diabolical schemes you need carried out?','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(91361,'Lovely time for a stroll around the garrison, commander.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(91362,'Honored as always, commander.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(91363,'Not... cool...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91364,'I\'ve been snuffed out...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91365,'','I won\'t go easy on you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91366,'','You want to play rough, huh?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91367,'','Freeze!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91368,'','I\'ve spotted one. Over here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91369,'','You got what you deserved.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91370,'','You aren\'t so tough.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91371,'','Maybe you\'ll think twice next time! Wait....',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91372,'','I did it! I got one!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91373,'','Hey, commander! Got any missions I could go on? I\'m ready!',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(91374,'','Nice to see you!',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(91375,'','Anything I can do for you, commander?',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(91376,'','Commander! It\'s an honor.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(91377,'','Is it warm in here? Or is it just me...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91378,'','I... tried my best...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91379,'','I\'m sorry commander...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91380,'(Beast Mastery) Show Gara the Shadowberries.','(Beast Mastery) Show Gara the Shadowberries.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91381,'<Gara sniffs the berries, then looks at you expectedly.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91382,'My soul... feels at peace... thank you.','My soul... feels at peace... thank you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91383,'(Beast Mastery) I am not with the Shadowmoon, and I want to help this wolf!','(Beast Mastery) I am not with the Shadowmoon, and I want to help this wolf!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91384,'Gara was my wolf, back before we forsook shamanism for these... dark magics. She wouldn\'t even look at me, not after I was tainted by the void.','Gara was my wolf, back before we forsook shamanism for these... dark magics. She wouldn\'t even look at me, not after I was tainted by the void.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91385,'How dare you set her soul at rest. Om\'ra\'s soul belongs to the VOID!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91386,'I shall take this one as compensation!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91387,'Your soul will fill the void!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91388,'You can never escape from the void! Your souls will be devoured!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91389,'She is being swallowed by the void! You must help her! There is only one way, tame her, now! Maybe you can find a way to reverse the process, and put her soul at rest, as you have done mine!','She is being swallowed by the void! You must help her! There is only one way, tame her, now! Maybe you can find a way to reverse the process, and put her soul at rest, as you have done mine!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91390,'You\'ve done it... thank you. Goodbye, Gara, my soul is at peace now. I hope... that you find this peace some day, too. I am so sorry, my dearest Gara.','You\'ve done it... thank you. Goodbye, Gara, my soul is at peace now. I hope... that you find this peace some day, too. I am so sorry, my dearest Gara.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91391,'You instinctively use Deterrance to avoid the attack!','You instinctively use Deterrance to avoid the attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91392,'Your skill at tracking allows you to remain in this realm!','Your skill at tracking allows you to remain in this realm!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91393,'You are pulled into the Void Realm!','You are pulled into the Void Realm!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91394,'I will consume all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91395,'The fight against the Warsong clan is honorable, but I don\'t think Hemet has taken very well to the change of priorities here in Nagrand.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(91396,'Fool! You dare challenge the might of the Spiteleaves? Die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91397,'Winter... has... come for me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91398,'The master... will burn your soul!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91399,'The hour is near... soon you will die...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91400,'Our master will devour your soul...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91401,'You cannot stop the destruction...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91402,'Noooo... it is you who should die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91403,'No! No... nooo... the darkness...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91404,'The void is coming... it will destroy you all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91405,'You fool... we\'ve already... won...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91406,'Hey... what were you expecting? Frostmourne or something?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(91407,'Cut down to size.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91408,'And not a hair out of place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91409,'That\'s why I\'m here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91410,'','You are not welcome here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91411,'','I am unimpressed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91412,'','You had no chance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91413,'I\'d like to go back to the nest.','I\'d like to go back to the nest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91414,'Grrrawr I thirst for blood!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91415,'Well met.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91416,'Whoops! My bad.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91417,'Globalized!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91418,'Making plays!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91419,'I would like to place a work order for leather.','I would like to place a work order for leather.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91420,'I would like to place a large work order for leather.','I would like to place a large work order for leather.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91421,'I would like to place a work order for meat.','I would like to place a work order for meat.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91422,'I would like to place a large work order for meat.','I would like to place a large work order for meat.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91423,'I would like to place a work order for fur.','I would like to place a work order for fur.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91424,'I would like to place a large work order for fur.','I would like to place a large work order for fur.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91425,'<The good doctor reeks like the floor of tavern and wears a face like five miles of bad road. His color is washed out and he\'s making a deliberate effort not to be sick all over your feet.>$b$bHey Com-om-mander! <Urp> S\'was one HELLUVA bender at Pinchwhistle last night. But I got home all-right for ready! Duty! Yessir. <Belch> Man you really did a number on this garrison since yessserday. With um. Spikes. Furs. And... snow? Did you do that?  I\'mma sit down.','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(91426,'Jeron Emberfall has been slain by the Alliance!','',0,0,0,0,0,0,0,0,0,0,8173,0,26124),
(91427,'Rylai Crestfall has been slain by the Horde!','',0,0,0,0,0,0,0,0,0,0,8213,0,26124),
(91428,'Do you need an analysis? I can have it ready for you by the end of the week.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91429,'Once we\'re done here, whaddaya say we go to shore and grab a drink?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91430,'If you find yourself within the Dark Woods, keep an eye out for the blooming Song Flower. They have powerful magical properties.$B$BYou may have to fight off a few of the Arakkoa for them though.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(91431,'Tell me about the mounts-in-training.','Tell me about the mounts-in-training.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91432,'The Night Elves are attempting to resurrect an Ancient to be used against us using the power of the Artifacts found here in Ashran.$B$BIf you see any alliance out there, take any fragments they carry by any force necessary.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(91433,'We\'ve been following your lead, and capturing mounts to train up for the rest of the garrison. You\'re welcome to take one out for the day, just ask and I\'ll hand you the whistle.$B$BKeep in mind that they\'re not as well-trained as your own mount, and will tire out after only a few battles.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91434,'We have been following your lead, and capturing mounts to train for use in the garrison. Of course, you are welcome to take one out for the day, simply tell me which whistle you would prefer.$B$BBe aware that they are not as well-trained as your own mount, and will tire out after only a few battles.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91435,'','The flames coming out of the braziers near the Ring of Conquest may look ordinary at first glance. However, I believe they have been enchanted by ancient Highmaul magic.$B$BI was strangely drawn to them. Touching one, I was suddenly filled with magical energy.',0,0,0,0,0,0,0,0,0,17483,0,0,26124),
(91436,'','Protect our Priests in the Road of Glory if you see them under attack.$B$BI\'ve trained them myself, their healing power is unmatched this side of the Dark Portal.',0,0,0,0,0,0,0,0,0,17483,0,0,26124),
(91437,'I am SUPER excited to be here today!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91438,'','Who goes there? Keep your hands and weapons where I can see them.',0,0,0,0,0,0,0,0,0,0,0,51893,26124),
(91439,'','Prove to me that you are not an enemy.',0,0,0,0,0,0,0,0,0,0,0,52770,26124),
(91442,'|TInterface\\Icons\\spell_sandexplosion.blp:20|tYou have a |cFFFF0000|Hspell:155187|h[Bomb]|h|r on you!','|TInterface\\Icons\\spell_sandexplosion.blp:20|tYou have a |cFFFF0000|Hspell:155187|h[Bomb]|h|r on you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91443,'|TInterface\\Icons\\Spell_Fire_LavaSpawn.blp:20|tA Firecaller has affected you with |cFFFF0000|Hspell:176121|h[Volatile Fire]|h|r!','|TInterface\\Icons\\Spell_Fire_LavaSpawn.blp:20|tA Firecaller has affected you with |cFFFF0000|Hspell:176121|h[Volatile Fire]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91444,'|TInterface\\Icons\\ability_rhyolith_magmaflow_whole.blp:20|tForeman Feldspar is going to create a |cFFFF0000|Hspell:156934|h[Rupture]|h|r under your feet!','|TInterface\\Icons\\ability_rhyolith_magmaflow_whole.blp:20|tForeman Feldspar is going to create a |cFFFF0000|Hspell:156934|h[Rupture]|h|r under your feet!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91445,'|TInterface\\Icons\\ability_foundryraid_melt.blp:20|tThe Heart of the Mountain is going to |cFFFF0000|Hspell:155225|h[Melt]|h|r the ground under your feet!','|TInterface\\Icons\\ability_foundryraid_melt.blp:20|tThe Heart of the Mountain is going to |cFFFF0000|Hspell:155225|h[Melt]|h|r the ground under your feet!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91446,'|TInterface\\Icons\\ability_garrosh_hellscreams_warsong.blp:20|t%s begins to cast |cFFF00000|Hspell:160838|h[Disrupting Roar]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91447,'Forgive me, father.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91448,'You\'ve got quite the mouth on you, Ooka. Maybe I should stuff it full of your blookin mank chow.','You\'ve got quite the mouth on you, Ooka. Maybe I should stuff it full of your blookin mank chow.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91449,'Ah, visitors. It\'s been a long time since Mardum, Allari.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91450,'Placeholder Text','Placeholder Text',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91451,'','|TInterface\\Icons\\ability_warrior_dragonroar.blp:20|t %s begins to cast |cFFFF0000|Hspell:177477|h[Dragon Roar]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(91452,'','Whatcha need?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91453,'What do you need directions to?','What do you need directions to?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(91454,'If you\'re looking for information on pet battling, seek out Misty Webtangle.\n\nI believe she\'s staying in the cellar of the inn. Let\'s hope she can keep her pets from wandering too far from there.','If you\'re looking for information on pet battling, seek out Misty Webtangle.\n\nI believe she\'s staying in the cellar of the inn. Let\'s hope she can keep her pets from wandering too far from there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91455,'A pair of ethereals have set up shop in the lower floor of Andromath\'s Rise. \n\nSeek them out there if you wish to use their services for Transmogrification or Void Storage.','A pair of ethereals have set up shop in the lower floor of Andromath\'s Rise. \n\nSeek them out there if you wish to use their services for Transmogrification or Void Storage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91456,'Whether you\'re looking to make a little coin or spend it, the Tyron family and their associates should be able to help you.\n\nThey\'ve set up shop just down the road from the Town Hall, next to the arakkoa refugees.','Whether you\'re looking to make a little coin or spend it, the Tyron family and their associates should be able to help you.\n\nThey\'ve set up shop just down the road from the Town Hall, next to the arakkoa refugees.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91457,'The dwarves of the Explorer\'s League have been allowing adventurers to use the extra space in Bronzebeard\'s Vault to store their excess goods.\n\nIt\'s the big metal building with the cannon on top in the center of town. You can\'t miss it.','The dwarves of the Explorer\'s League have been allowing adventurers to use the extra space in Bronzebeard\'s Vault to store their excess goods.\n\nIt\'s the big metal building with the cannon on top in the center of town. You can\'t miss it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91458,'If you need to travel by gryphon, you\'ll want to speak to our Gryphon Master, Ernst ten Bosch. \n\nYou can find him at the top of the hill past the mess hall.','If you need to travel by gryphon, you\'ll want to speak to our Gryphon Master, Ernst ten Bosch. \n\nYou can find him at the top of the hill past the mess hall.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91459,'If you\'re looking to take a load off, then you\'ll want to head down to the Hero\'s Rest Inn. Jaesia should be able to set you up with a room and a mug of ale.\n\nJust take the road past the stone walls and follow it to the west. That\'ll take you right to it.','If you\'re looking to take a load off, then you\'ll want to head down to the Hero\'s Rest Inn. Jaesia should be able to set you up with a room and a mug of ale.\n\nJust take the road past the stone walls and follow it to the west. That\'ll take you right to it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91460,'We\'ve actually got a few mailboxes about. Were you looking for one in particular?','We\'ve actually got a few mailboxes about. Were you looking for one in particular?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91461,'You can find that mailbox right outside of Bronzebeard\'s Vault in the center of town.\n\nIt\'s the big metal building with the cannon on top.','You can find that mailbox right outside of Bronzebeard\'s Vault in the center of town.\n\nIt\'s the big metal building with the cannon on top.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91462,'You can find that mailbox right next to the door to the Hero\'s Rest Inn. \n\nJust take the road through the stone walls and follow it west and you\'ll run into the inn at the bottom of the hill.','You can find that mailbox right next to the door to the Hero\'s Rest Inn. \n\nJust take the road through the stone walls and follow it west and you\'ll run into the inn at the bottom of the hill.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91463,'Town Hall','Town Hall',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(91464,'You\'ll find another mailbox just outside the Town Hall. \n\nJust head to the southern part of town. The Town Hall is just past the central monument.','You\'ll find another mailbox just outside the Town Hall. \n\nJust head to the southern part of town. The Town Hall is just past the central monument.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91465,'Our mages have set up portals to a few different locations in various parts of the settlement. \n\nWhere would you like to go?','Our mages have set up portals to a few different locations in various parts of the settlement. \n\nWhere would you like to go?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91466,'Darnassus','Darnassus',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(91467,'The portal to Darnassus can be found near the night elf moonwell on the eastern side of Stormshield. \n\nJust follow the road past the auction house and that will lead you to it.','The portal to Darnassus can be found near the night elf moonwell on the eastern side of Stormshield. \n\nJust follow the road past the auction house and that will lead you to it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91468,'Ironforge','Ironforge',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(91469,'Not surprisingly, the portal to Ironforge has been set up outside of Bronzebeard\'s Vault. You can find it on the south side of the building.\n\nIt\'s the big metal one with the cannon on top in the center of town.','Not surprisingly, the portal to Ironforge has been set up outside of Bronzebeard\'s Vault. You can find it on the south side of the building.\n\nIt\'s the big metal one with the cannon on top in the center of town.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91470,'Stormwind','Stormwind',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(91471,'The portal to Stormwind has been set up outside Andromath\'s Rise.\n\nIf you head up the road past Bronzebeard\'s Vault you\'ll run right into the tower.','The portal to Stormwind has been set up outside Andromath\'s Rise.\n\nIf you head up the road past Bronzebeard\'s Vault you\'ll run right into the tower.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91472,'In what particular profession were you seeking training?','In what particular profession were you seeking training?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91473,'Looks like the Iron Horde is making its move. Soldiers! Get the townsfolk to safety!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91474,'The secrets of Draenor alchemy are well known by our resident alchemist, Jaiden Trask. \n\nYou can find him outside of the Hero\'s Rest Inn, in the southern part of town.','The secrets of Draenor alchemy are well known by our resident alchemist, Jaiden Trask. \n\nYou can find him outside of the Hero\'s Rest Inn, in the southern part of town.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91475,'Our resident archaeologist, Manda Darlowe, has set up shop outside the barracks in the center of Stormshield.\n\nShe is accompanied by a strange arakkoa who may be able to assist you in your endeavors as well.','Our resident archaeologist, Manda Darlowe, has set up shop outside the barracks in the center of Stormshield.\n\nShe is accompanied by a strange arakkoa who may be able to assist you in your endeavors as well.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91476,'Me too!','Me too!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91477,'Aimee Goldforge is our local blacksmithing expert. \n\nYou can find her and her crew around the open-air forge outside of Bronzebeard\'s Vault in the center of Stormshield.','Aimee Goldforge is our local blacksmithing expert. \n\nYou can find her and her crew around the open-air forge outside of Bronzebeard\'s Vault in the center of Stormshield.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91478,'If you\'re looking for the best cook in town, seek out Elton Black over at the Hero\'s Rest Inn.\n\nHe may seem a bit silly with his props and gadgets, but he knows how to make some seriously great eats.','If you\'re looking for the best cook in town, seek out Elton Black over at the Hero\'s Rest Inn.\n\nHe may seem a bit silly with his props and gadgets, but he knows how to make some seriously great eats.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91479,'Hope you draw some lucky hands today!','',273,0,0,0,0,0,273,0,0,0,0,0,26124),
(91480,'If you seek training in enchanting, Bil Sparktonic is the most knowledgeable enchanter in Stormshield. Just be careful of anything he offers at a \"discount.\"\n\nYou can find him and his associate, Bob, hanging out behind the Auction House, crying their wares.','If you seek training in enchanting, Bil Sparktonic is the most knowledgeable enchanter in Stormshield. Just be careful of anything he offers at a \"discount.\"\n\nYou can find him and his associate, Bob, hanging out behind the Auction House, crying their wares.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91481,'','|TInterface\\Icons\\Spell_Shadow_SoulLeech_2.blp:20|t %s begins to cast |cFFF00000|Hspell:153477|h[Soul Vessel]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(91482,'Our foremost engineer in Stormshield is Hilda Copperfuze.\n\nYou can find her in the Engineering Works at the center of town.','Our foremost engineer in Stormshield is Hilda Copperfuze.\n\nYou can find her in the Engineering Works at the center of town.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91483,'|TInterface\\Icons\\inv_elemental_crystal_fire.blp:20|tYou have been targeted with |cFFFF0000|Hspell:160282|h[Solar Detonation]|h|r! Move away from your allies!','|TInterface\\Icons\\inv_elemental_crystal_fire.blp:20|tYou have been targeted with |cFFFF0000|Hspell:160282|h[Solar Detonation]|h|r! Move away from your allies!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(91484,'$n crafts a Cyclone Trinket!','$n crafts a Cyclone Trinket!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91485,'Thunderlord Windfires Killed: $1i (+$2i VP)','Thunderlord Windfires Killed: $1i (+$2i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91486,'A Flame Tank draws near!','A Flame Tank draws near!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91487,'The battle for the burial grounds will begin in 3 minutes!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91488,'At long last... I can finally rest...','At long last... I can finally rest...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91489,'The torment is over...','The torment is over...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91490,'Thank you for this kindness...','Thank you for this kindness...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91491,'Please... do not let us be forgotten...','Please... do not let us be forgotten...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91492,'The saberon attack is over. Go now, and rest in peace.','The saberon attack is over. Go now, and rest in peace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91493,'Please! You must help us! The saberon have come and our lives are in danger!','Please! You must help us! The saberon have come and our lives are in danger!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91494,'|TInterface\\Icons\\spell_shaman_earthquake.blp:20|t %s begins to cast |cFFFF0000|Hspell:170905|h[Ground Pound]|h|r!','',0,0,0,0,0,0,0,0,1,36470,0,0,26124),
(91495,'You aren\'t in a party.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91496,'If you run into some trouble with alliance around here, use one of Frizzo Sparkrocket\'s flares.$B$BWe can\'t help you if we don\'t know where you\'re at.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91497,'<Gara\'s ears perk up, but her gaze remains on the grave.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91498,'The Lord of Glass, a void god who calls himself Xan, had taken my soul captive in the void realm. Fragments of it were... torn away... for use by the Shadowmoon here in the burial grounds.','The Lord of Glass, a void god who calls himself Xan, had taken my soul captive in the void realm. Fragments of it were... torn away... for use by the Shadowmoon here in the burial grounds.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91499,'But she wouldn\'t leave my side, Gara. Not until the proper effigy was burned, that my soul may find peace.','But she wouldn\'t leave my side, Gara. Not until the proper effigy was burned, that my soul may find peace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91500,'Thank you for releasing us both.','Thank you for releasing us both.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91501,'Please fly me to Spires of Arak.','Please fly me to Spires of Arak.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91502,'%s begins to channel |cFFFF0404|Hspell:159996|h[Infesting Spores]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91503,'','Your orders are clear! Find the Tidestone, and return it to Her Glory, Queen Azshara!',0,0,0,0,0,0,0,0,0,0,0,52615,26124),
(91504,'','These creatures only pretend to understand its power. The Tidestone belongs to Azshara, Her Radiance, the Light Beneath the Tides!',0,0,0,0,0,0,0,0,0,0,0,52613,26124),
(91505,'','Scour the sands!',0,0,0,0,0,0,0,0,0,0,0,52622,26124),
(91506,'','Pillage the ruins!',0,0,0,0,0,0,0,0,0,0,0,52614,26124),
(91507,'','Slay anyone and anything that gets in your path!',0,0,0,0,0,0,0,0,0,0,0,52618,26124),
(91508,'','FIND THAT TIDESTONE!',0,0,0,0,0,0,0,0,0,0,0,52621,26124),
(91509,'','Your Queen Azshara wills it, and so shall it be done!',0,0,0,0,0,0,0,0,0,0,0,52619,26124),
(91510,'Telys Vinemender is our resident first aid expert. \n\nYou can find her and her apprentice tending to the wounded in the barracks.','Telys Vinemender is our resident first aid expert. \n\nYou can find her and her apprentice tending to the wounded in the barracks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91511,'Austin Windmill is the best with a rod and reel here in Stormshield. Seek him out for your fishing needs.\n\nYou can normally find him outside his house along the shore, just behind the Town Hall and Auction House.','Austin Windmill is the best with a rod and reel here in Stormshield. Seek him out for your fishing needs.\n\nYou can normally find him outside his house along the shore, just behind the Town Hall and Auction House.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91512,'Stormshield\'s premier herbalist, Jie Wildblossom, has travelled all the way from Pandaria to study the native flora of Draenor. \n\nYou can find her outside the Hero\'s Rest Inn, if you require instruction in Herbalism.','Stormshield\'s premier herbalist, Jie Wildblossom, has travelled all the way from Pandaria to study the native flora of Draenor. \n\nYou can find her outside the Hero\'s Rest Inn, if you require instruction in Herbalism.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91513,'In the Mage Tower you will find Scribe Chi-Yuan. \n\nShe is the finest scribe in all of Ashran, and can train you for any of your inscription needs.','In the Mage Tower you will find Scribe Chi-Yuan. \n\nShe is the finest scribe in all of Ashran, and can train you for any of your inscription needs.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91514,'The draenei Artificers are lending a hand with our operations in Stormshield. \n\nIf you seek training in jewelcrafting, find Artificer Nissea in the draenei encampment, just west of the center of Stormshield.','The draenei Artificers are lending a hand with our operations in Stormshield. \n\nIf you seek training in jewelcrafting, find Artificer Nissea in the draenei encampment, just west of the center of Stormshield.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91515,'Jistun Sharpfeather is the local expert on leatherworking. \n\nYou can find his stall just outside of Bronzebeard\'s Vault, in the center of town.','Jistun Sharpfeather is the local expert on leatherworking. \n\nYou can find his stall just outside of Bronzebeard\'s Vault, in the center of town.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91516,'If you need help with mining, I\'d speak with Jonath Chainfist. He\'s the expert in these parts. \n\nYou can find him just outside the Engineering Works, in the center of town.','If you need help with mining, I\'d speak with Jonath Chainfist. He\'s the expert in these parts. \n\nYou can find him just outside the Engineering Works, in the center of town.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91517,'Rangari Laandon has been lending his expertise on skinning to our forces here in Stormshield. \n\nHe can be found in the leatherworking stall, right outside of Bronzebeard\'s Vault in the center of town.','Rangari Laandon has been lending his expertise on skinning to our forces here in Stormshield. \n\nHe can be found in the leatherworking stall, right outside of Bronzebeard\'s Vault in the center of town.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91518,'Joshua Fuesting is the finest tailor in all of Draenor. There\'s no better to assist you with anything done with needle and thread. \n\nYou can find him in his stall in the trade center of town. Just looks for the sharp-dressed models, they are easy to spot.','Joshua Fuesting is the finest tailor in all of Draenor. There\'s no better to assist you with anything done with needle and thread. \n\nYou can find him in his stall in the trade center of town. Just looks for the sharp-dressed models, they are easy to spot.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91519,'The Order of the Awakened have set up shop right outside the Auction House, in the southern part of Stormshield.  \n\nI hear they\'re offering great rewards to any adventurer who can help them in their search for Apexis relics.','The Order of the Awakened have set up shop right outside the Auction House, in the southern part of Stormshield.  \n\nI hear they\'re offering great rewards to any adventurer who can help them in their search for Apexis relics.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91520,'Various factions throughout Draenor have gathered in the Town Hall to offer their assistance in Ashran. \n\nThey even have goods for sale to those with sufficient reputation with them.','Various factions throughout Draenor have gathered in the Town Hall to offer their assistance in Ashran. \n\nThey even have goods for sale to those with sufficient reputation with them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91521,'Kenneth Knowles has set up shop in the center of Stormshield, close to many of our profession trainers.\n\nIf you are in need of materials for your craft, seek him out there.','Kenneth Knowles has set up shop in the center of Stormshield, close to many of our profession trainers.\n\nIf you are in need of materials for your craft, seek him out there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91522,'Trader Caerel offers various goods for adventurers such as yourself. \n\nYou can find his wagon set up just outside the Town Hall, next to the central monument.','Trader Caerel offers various goods for adventurers such as yourself. \n\nYou can find his wagon set up just outside the Town Hall, next to the central monument.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91523,'If you wish to stable your animals, seek out Orville Manfred, outside the inn in the southern part of Stormshield.\n\nDespite his ferocious appearance, I hear he takes quite good care of the animals.','If you wish to stable your animals, seek out Orville Manfred, outside the inn in the southern part of Stormshield.\n\nDespite his ferocious appearance, I hear he takes quite good care of the animals.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91524,'We have many merchants who have set up shop here in Stormshield. Which one were you looking for?','We have many merchants who have set up shop here in Stormshield. Which one were you looking for?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91525,'Apexis Shard Vendor','Apexis Shard Vendor',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(91526,'Reputation Vendors','Reputation Vendors',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(91527,'Sound the alarm! It must be a Primal invasion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91532,'Rubbing','Rubbing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(91533,'Witherbark casts |TInterface\\Icons\\Spell_Nature_ElementalShields.blp:20|t |cFFFF0404|Hspell:164294|h[Unchecked Growth]|h|r on you!','Witherbark casts |TInterface\\Icons\\Spell_Nature_ElementalShields.blp:20|t |cFFFF0404|Hspell:164294|h[Unchecked Growth]|h|r on you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91534,'%s begins to breath |cFFFF0404|Hspell:155031|h[Engulfing Fire]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(91535,'What were you looking for?','What were you looking for?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91536,'Pet battles? You want to talk to Zarg Bonecrunch. He\'s the orc with the kittens, north of the big totem. \n\nYeah, you heard right, the orc with the kittens.','Pet battles? You want to talk to Zarg Bonecrunch. He\'s the orc with the kittens, north of the big totem. \n\nYeah, you heard right, the orc with the kittens.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91537,'A couple of those ethereals came with and set up shop in the Tower of Elements. \n\nI\'m not sure what their game is here in Ashran, but they have some useful services.','A couple of those ethereals came with and set up shop in the Tower of Elements. \n\nI\'m not sure what their game is here in Ashran, but they have some useful services.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91538,'If you\'re lookin\' to try your hand at the markets, you might want to seek out the Auction House. \n\nYou can find it in the tauren quarter, in the northern part of Warspear.','If you\'re lookin\' to try your hand at the markets, you might want to seek out the Auction House. \n\nYou can find it in the tauren quarter, in the northern part of Warspear.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91539,'You can keep your extra gear protected by leaving it with the bankers in Warspear Hold. Nobody would be crazy enough to try to steal anything from that place! \n\nIt\'s the big building just south of the totem, you can\'t miss it.','You can keep your extra gear protected by leaving it with the bankers in Warspear Hold. Nobody would be crazy enough to try to steal anything from that place! \n\nIt\'s the big building just south of the totem, you can\'t miss it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91540,'We\'ve got a couple of trained wind riders in Warspear if you need to travel quickly. \n\nSeek out Ilalu at the top of the hill behind the inn, if you have need of them.','We\'ve got a couple of trained wind riders in Warspear if you need to travel quickly. \n\nSeek out Ilalu at the top of the hill behind the inn, if you have need of them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91541,'If you are in need of rest, the Brokenspear Tavern is where you should be headed. \n\nYou will find it off of the road heading north from the big totem.','If you are in need of rest, the Brokenspear Tavern is where you should be headed. \n\nYou will find it off of the road heading north from the big totem.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91542,'We\'ve got plenty of mailboxes. Which one were you lookin\' for?','We\'ve got plenty of mailboxes. Which one were you lookin\' for?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91543,'There\'s one right outside of the Brokenspear Tavern. \n\nYou can find it right off the road heading north from the big totem.','There\'s one right outside of the Brokenspear Tavern. \n\nYou can find it right off the road heading north from the big totem.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91544,'We got a mailbox right outside the Auction House, in the tauren quarter.\n\nIt\'s just north of the big bonfire.','We got a mailbox right outside the Auction House, in the tauren quarter.\n\nIt\'s just north of the big bonfire.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91545,'The bankers put a mailbox right outside of Warpsear Hold that you\'re welcome to use. \n\nIt\'s the big building to the south of the totem.','The bankers put a mailbox right outside of Warpsear Hold that you\'re welcome to use. \n\nIt\'s the big building to the south of the totem.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91546,'The goblins have set up a mailbox outside of Gallywix\'s Garage. \n\nIt\'s the biggest building in the goblin quarter, on the east side of town.','The goblins have set up a mailbox outside of Gallywix\'s Garage. \n\nIt\'s the biggest building in the goblin quarter, on the east side of town.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91547,'The mages set up a handful of portals to different places. Which one did you want?','The mages set up a handful of portals to different places. Which one did you want?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91548,'You can find the portal to Orgrimmar in the Tower of Elements. \n\nJust head east from the big totem.','You can find the portal to Orgrimmar in the Tower of Elements. \n\nJust head east from the big totem.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91549,'The portal to Thunder Bluff has been set up in the tauren quarter. \n\nIt should be right next to the Auction House.','The portal to Thunder Bluff has been set up in the tauren quarter. \n\nIt should be right next to the Auction House.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91550,'The Forsaken have set up a portal to the Undercity in their quarter. \n\nLook for it behind their alchemy hut.','The Forsaken have set up a portal to the Undercity in their quarter. \n\nLook for it behind their alchemy hut.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91551,'What kind of profession did you need help with?','What kind of profession did you need help with?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91552,'If you\'re lookin\' to make a new plague, there\'s no better than the Forsaken. \n\nLook for Kristoph Cossey in their quarter, inside the alchemy hut.','If you\'re lookin\' to make a new plague, there\'s no better than the Forsaken. \n\nLook for Kristoph Cossey in their quarter, inside the alchemy hut.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91553,'The Steamwheedle Preservation Society is your best bet for archaeology around here. \n\nYou can find them in the smaller garage in the goblin quarter. Just seek out Reena Cogscrap there.','The Steamwheedle Preservation Society is your best bet for archaeology around here. \n\nYou can find them in the smaller garage in the goblin quarter. Just seek out Reena Cogscrap there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91554,'Mazdon Bizratchet is your best bet for blacksmithing around here. \n\nYou can find him in the goblin quarter, behind Gallywix\'s Garage.','Mazdon Bizratchet is your best bet for blacksmithing around here. \n\nYou can find him in the goblin quarter, behind Gallywix\'s Garage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91555,'You want to speak with me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91556,'The best cook on Warspear is Guy Fireeye, no doubt about that. He makes all the grub for the Brokenspear Tavern. \n\nYou can usually find him manning the kichen below the inn itself.','The best cook on Warspear is Guy Fireeye, no doubt about that. He makes all the grub for the Brokenspear Tavern. \n\nYou can usually find him manning the kichen below the inn itself.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91557,'The trolls are taking care of all our enchanting needs in Warspear. \n\nLook for Hane\'ke in the Enchanter\'s Study over in their quarter. He should be able to help you out.','The trolls are taking care of all our enchanting needs in Warspear. \n\nLook for Hane\'ke in the Enchanter\'s Study over in their quarter. He should be able to help you out.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91558,'Your people treat you with contempt. Why? What did you do?','Your people treat you with contempt. Why? What did you do?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91559,'They\'ve got a pretty good engineering setup in Gallywix\'s Garage over in the goblin quarter. Just look for the biggest building in the area.\n\nOnce you\'re there, talk to Han Leaprocket if you need training.','They\'ve got a pretty good engineering setup in Gallywix\'s Garage over in the goblin quarter. Just look for the biggest building in the area.\n\nOnce you\'re there, talk to Han Leaprocket if you need training.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91560,'The pandaren, Wei Suremend, has been tending to our grunts. He\'s probably your best bet for first aid training. \n\nYou can find him in the barracks. Just follow the sound of training orcs.','The pandaren, Wei Suremend, has been tending to our grunts. He\'s probably your best bet for first aid training. \n\nYou can find him in the barracks. Just follow the sound of training orcs.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91561,'Brix Rocketcast is the goblin with the most fishing know-how around here. \n\nYou can find his little island off the shore, north of the goblin quarter.','Brix Rocketcast is the goblin with the most fishing know-how around here. \n\nYou can find his little island off the shore, north of the goblin quarter.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91562,'If you need help with herbalism, you should look in the undead quarter. \n\nAnthony Allain is over there next to the alchemist\'s hut. He should be able to show you a thing or two.','If you need help with herbalism, you should look in the undead quarter. \n\nAnthony Allain is over there next to the alchemist\'s hut. He should be able to show you a thing or two.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91563,'The best scribe we have in Warspear is Joro\'man over in the troll quarter. \n\nFor your sake, I hope he doesn\'t write the way he talks.','The best scribe we have in Warspear is Joro\'man over in the troll quarter. \n\nFor your sake, I hope he doesn\'t write the way he talks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91564,'A small group of Blood Elves set up camp across the way from the tauren. \n\nYou\'ll find a jewelcrafter there by the name of Alixander Swiftsteel.','A small group of Blood Elves set up camp across the way from the tauren. \n\nYou\'ll find a jewelcrafter there by the name of Alixander Swiftsteel.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91565,'The tauren that came over with us seem to have the best grasp on leatherworking around here. \n\nSeek out Burga Stronghide in their quarter for leatherworking training.','The tauren that came over with us seem to have the best grasp on leatherworking around here. \n\nSeek out Burga Stronghide in their quarter for leatherworking training.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91566,'If you\'re lookin\' for a good miner, go find Murg Stonecrack. He\'s so good that they promoted him from a peon and put him in charge of the mining operations here in Warspear. \n\nLast I saw him, I think he was working the rocks east of the goblin quarter.','If you\'re lookin\' for a good miner, go find Murg Stonecrack. He\'s so good that they promoted him from a peon and put him in charge of the mining operations here in Warspear. \n\nLast I saw him, I think he was working the rocks east of the goblin quarter.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91567,'The Huntsworns have skinned just about every kind of beast on Draenor, so if you need training, go to them. \n\nYou can find Kondal working his skins in the tauren quarter.','The Huntsworns have skinned just about every kind of beast on Draenor, so if you need training, go to them. \n\nYou can find Kondal working his skins in the tauren quarter.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91568,'I prefer hides and furs myself, but if you prefer to work with dainty cloth, then you should seek out the blood elf, Saesha Silverblood. \n\nShe\'s set up with her kin, across from the tauren quarter.','I prefer hides and furs myself, but if you prefer to work with dainty cloth, then you should seek out the blood elf, Saesha Silverblood. \n\nShe\'s set up with her kin, across from the tauren quarter.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91569,'The birds have set themselves up next to our training grounds in the southern part of town. \n\nThey say they\'re looking for ancient relics, and have some pretty nice gear to trade for them.','The birds have set themselves up next to our training grounds in the southern part of town. \n\nThey say they\'re looking for ancient relics, and have some pretty nice gear to trade for them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91570,'We\'ve got a couple different factions holed up in Warspear Hold. \n\nI\'ve heard they\'ve even got stuff for sale, though they\'re picky who they sell to.','We\'ve got a couple different factions holed up in Warspear Hold. \n\nI\'ve heard they\'ve even got stuff for sale, though they\'re picky who they sell to.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91571,'Bren Puresun in the tauren quarter has been working to keep our tradesmen supplied. \n\nSeek him out if you need goods for crafting.','Bren Puresun in the tauren quarter has been working to keep our tradesmen supplied. \n\nSeek him out if you need goods for crafting.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91572,'Outside the Brokenspear Tavern, you can find Jasa\'s trade hut. \n\nThere you can find whatever adventuring supplies you might need.','Outside the Brokenspear Tavern, you can find Jasa\'s trade hut. \n\nThere you can find whatever adventuring supplies you might need.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91573,'Ujia handles the beasts for most of us around here. I\'d just be careful around her raptors. \n\nYou can find her outside the cave in the troll quarter.','Ujia handles the beasts for most of us around here. I\'d just be careful around her raptors. \n\nYou can find her outside the cave in the troll quarter.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91574,'Lookin\' to buy somethin\'? What, exactly?','Lookin\' to buy somethin\'? What, exactly?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91579,'Gallywix\'s Garage','Gallywix\'s Garage',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(91580,'Orgrimmar','Orgrimmar',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(91581,'Thunder Bluff','Thunder Bluff',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(91582,'Undercity','Undercity',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(91583,'You did all this? How? Why?','You did all this? How? Why?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91584,'','Ookin Dookin blookin flookin wikket!',35,0,0,0,0,0,0,0,0,0,0,0,26124),
(91585,'','Flip blookin dook-sniffer. You better take that back!',53,0,0,0,0,0,0,0,0,0,0,0,26124),
(91587,'You want to fight in the arena? No? Work harder!','',0,0,0,0,0,0,0,0,0,0,52699,0,26124),
(91588,'Test 2 | Caster: %s  | Target: $n','Test 2 | Caster: %s  | Target: $n',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(91590,'Leading Kargath Bladefist into an active Fire Pillar will counter his Berserker Rush.','Leading Kargath Bladefist into an active Fire Pillar will counter his Berserker Rush.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(91591,'Slicky slapper! That\'s right, I said it. Slicky slapper.','Slicky slapper! That\'s right, I said it. Slicky slapper.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91592,'I am taking my leave, nightwatchers... though I doubt you will miss me.','',0,0,0,0,0,0,0,0,0,0,52804,0,26124),
(91593,'Hmm. How long has this road been flooded? I must have the groundskeepers attend to it.','',0,0,0,0,0,0,0,0,0,0,52794,0,26124),
(91594,'Look out!','',0,0,0,0,0,0,0,0,0,0,52795,0,26124),
(91595,'Gah! Watch out!','',0,0,0,0,0,0,397,0,0,0,52536,0,26124),
(91596,'Thaldrys, my trusted captain.','',0,0,0,0,0,0,0,0,0,0,52538,0,26124),
(91597,'You know what, Ooka? You have a dook for a head!','You know what, Ooka? You have a dook for a head!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91598,'If the giants didn\'t want you alive for their sport, you\'d be dead.','',0,0,0,0,0,0,0,0,0,0,52689,0,26124),
(91599,'Let\'s go find that Tidestone.','Let\'s go find that Tidestone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91600,'Why did you let THAT one free? He opposed Lord Illidan!','',0,0,0,0,0,0,603,0,0,0,57320,0,26124),
(91603,'Soothsayers Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91604,'|TInterface\\Icons\\ability_mage_livingbomb.blp:20|tYou have a |cFFFF0000|Hspell:176670|h[Living Bomb]|h|r on you!','|TInterface\\Icons\\ability_mage_livingbomb.blp:20|tYou have a |cFFFF0000|Hspell:176670|h[Living Bomb]|h|r on you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(91605,'Deathblades Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91606,'|TInterface\\Icons\\spell_shaman_improvedfirenova.blp:20|tThe Heart of the Mountain is about to release a |cFFFF0000|Hspell:155209|h[Blast]|h|r of intense heat!','|TInterface\\Icons\\spell_shaman_improvedfirenova.blp:20|tThe Heart of the Mountain is about to release a |cFFFF0000|Hspell:155209|h[Blast]|h|r of intense heat!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91607,'While you are helping the Illidari in their fight against the demons, I will figure out what our next move is here on Azsuna.\n\nWe must track down that Pillar of Creation. I know it is here somewhere.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(91608,'Khadgar, let\'s go.','Khadgar, let\'s go.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91609,'Don\'t let them get by us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91610,'I remember - I stowed the Tidestone within the confines of the Nar\'thalas Academy.','',0,0,0,0,0,0,0,0,0,0,52533,0,26124),
(91611,'That was a very long time ago.','',0,0,0,0,0,0,0,0,0,0,52539,0,26124),
(91612,'Come with me.','',0,0,0,0,0,0,0,0,0,0,52534,0,26124),
(91613,'The elves in this area are much less hospitable than I am. Tread carefully.','',0,0,0,0,0,0,0,0,0,0,52790,0,26124),
(91614,'Farondis! You traitor! You brought this upon us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91615,'','DIE... FARONDIS....',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91616,'Here, the Nar\'thalas Academy. This is where it all happened.','',0,0,0,0,0,0,0,0,0,0,52791,0,26124),
(91617,'Please, show me where the Tidestone lies.','Please, show me where the Tidestone lies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91620,'Fum fee fo fie!  Get back to work or it\'s time to die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91621,'Whalebelly can make our job more difficult. Try not to offend him.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91622,'What\'s a puny $r like you doing in here?\n\nOh, we\'re going to have a good time making chum of you.','',6,25,0,0,0,0,0,0,0,0,0,0,26124),
(91623,'Boss Whalebelly, it\'s great to meet you. Just letting you know that I\'m going to be the arena champion by the end of the day.','Boss Whalebelly, it\'s great to meet you. Just letting you know that I\'m going to be the arena champion by the end of the day.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91624,'Don\'t let the dark sky fool you. This is a good day.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91625,'Show the demon-tainted Shadow Council the strength of freedom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91626,'','Greblin Fastfizzle\'s last known location was the Broken Precipice. You might want to catch a flight out there before it\'s too late.',595,0,0,0,0,0,0,0,0,0,0,0,26124),
(91627,'I\'m on to you and your little friend over there. You think you can muscle in on what I\'ve got going on here?\n\nNever going to happen.\n\nLet me assure you that by the end of the day, you\'ll be groveling on the arena floor with my boot to your neck, $r.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(91628,'That\'s where you\'re wrong, chum. Dead wrong.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91629,'You see this blade? I\'m going to stick it so far up your...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91630,'Wait... what?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91631,'I\'ll get you, $p, if it\'s the last thing I do.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91632,'Whalebelly, what\'s all this?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91633,'Told you. No talking to enemy pit fighters!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91634,'Stop your blubbering. Your battle\'s coming.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91635,'This is it, warriors. Let\'s see how hard this Gronn falls.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91636,'Stubborn, I see. This is it, warriors. For the Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91637,'Please! Mercy! Oh, the shame...','Please! Mercy! Oh, the shame...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91638,'Win or don\'t bother crawling back, little crab.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91639,'I\'m going to keep digging around for more artifacts. Thanks again for all your help.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91640,'','You\'re a life saver, $n. I can see why everyone is following you around. You really live up to the hype.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91641,'Not bad for a bunch of worthless pukes! Come face Krud when you ready to die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91643,'Where do you want this box?','',0,0,0,0,0,0,0,0,0,0,45778,0,26124),
(91644,'Spore Flowers: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91645,'Why do I gotta move all the boxes?','',0,0,0,0,0,0,0,0,0,0,45779,0,26124),
(91646,'Over there! Why do you keep asking? You always move the boxes from here to there!','',0,0,0,0,0,0,0,0,0,0,43738,0,26124),
(91647,'Stop askin\' and get back to work!','',0,0,0,0,0,0,0,0,0,0,43739,0,26124),
(91648,'A Spore Flower is blocking your road!','A Spore Flower is blocking your road!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91649,'I like your bravery, little one. I\'ll enjoy gutting you in front of my entire battalion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91650,'My lady, Athissa! I have... failed you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91651,'','What\'s going on down there?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91652,'','Myrmidons! Slay these intruders!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91653,'With pleasure, my mistressss...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91654,'Get in there and kill. Nothing else matters.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91655,'Fight like your life depends on it. It does.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91656,'You\'re what I have left?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91657,'Do whatever it takes to win. Cheat, throw sand in his eyes, I don\'t care. Just win!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91658,'I need to go sink another ship and find some better fighters.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91659,'Gut him through the liver. Pull out his spleen!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91660,'I want to see blood all over the sand and it better not be yours!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91661,'I choose you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91662,'I have faith in you, little one.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91663,'Just get in there and try your best.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91664,'Win or lose, you\'re still a winner in my eyes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91665,'Don\'t be afraid. You can do it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91666,'Don\'t listen to old Bilgerudder. He\'s just mad because no one loves him.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91667,'With the right attitude, you can accomplish anything.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91668,'Make me proud, my little friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91669,'I\'ll murder all of you if I don\'t see some wins out there!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91670,'Useless, little piece of flotsam!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91671,'Your pet cheated, Sternfathom. You\'ll pay for that.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91672,'I\'ve half a mind to come over there and wipe that grin off your face.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91673,'It\'s good to cull the weak. I haven\'t played my strongest fighters yet.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91674,'If you know what\'s good for you, you\'ll stay down.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91675,'You\'re all worthless. You hear me? Worthless!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91676,'Goes to show you how weak the smaller races are. We should crush them all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91677,'If you know what\'s good for you, you\'ll keep winning, little crab.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91678,'Hah! Of course, I won. Was there any doubt?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91679,'Give it up, Sternfathom. Your puny weaklings don\'t have what it takes to win.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91680,'And you\'re going to keep fighting until you die or he runs out of pets.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91681,'Fight better next time, or I\'ll crush you under my boot.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91682,'Another win for me! You\'re nothing but a weak, has-been, Sternfathom.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91683,'Now that\'s how you win a fight. The rest of you better have been paying attention!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91684,'A-B-W. A-Always, B-Be, W-Winning. Always be winning, ALWAYS BE WINNING!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91685,'NOOOOOOOOooooooo....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91686,'Oh no, not you, my little friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91687,'Rest in peace, buddy. You\'ve earned it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91688,'Bilgerudder, you villain. Your fighter cheated!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91689,'You fought valiantly and with great skill, little one.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91690,'Don\'t worry, my friends. We\'ll win next time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91691,'Let\'s drink a toast to our fallen comrade.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91692,'Chin up, everyone. Bilgerudder\'s people have more experience, but we have heart!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91693,'Score one for the good guys!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91694,'YES! Great fighting, my little friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91695,'You\'re unstoppable, little one.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91696,'Now we\'re having fun!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91697,'Good show, but maybe next time let them live?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91698,'Here\'s mud in your eye, Bilgerudder.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91699,'Team Sternfathom wins again. Huzzah!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91700,'Great work, team. Let\'s make sure we stay safe out there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91702,'That hits the spot!','That hits the spot!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91703,'Not bad at all!','Not bad at all!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91704,'Good stuff!','Good stuff!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91705,'Ah. Worth the trip!','Ah. Worth the trip!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91706,'Hey! Is this pandaren ale?!','Hey! Is this pandaren ale?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91707,'|c00FFFF00|Hspell:178019|h[Event: Collect Empowered Ore]|h|r begins at the Molten Quarry in 3 minutes.','',0,0,0,0,0,0,0,0,0,0,43448,0,26124),
(91708,'|c00FFFF00|Hspell:178022|h[Event: Stadium Racing]|h|r begins at the Amphitheater of Annihilation in 3 minutes.','',0,0,0,0,0,0,0,0,0,0,43448,0,26124),
(91709,'|c00FFFF00|Hspell:178020|h[Event: Risen Spirits]|h|r begins at the Ashmaul Burial Grounds in 3 minutes.','',0,0,0,0,0,0,0,0,0,0,43448,0,26124),
(91710,'|c00FFFF00|Hspell:178021|h[Event: Ogre Fires]|h|r begins at Brute\'s Rise in 3 minutes.','',0,0,0,0,0,0,0,0,0,0,43448,0,26124),
(91711,'Good luck on your quest for the Tidestone, $n.','',0,0,0,0,0,0,0,0,0,0,52805,0,26124),
(91712,'I dare not enter that academy, but I swear I will aid you in whatever way I can.','',0,0,0,0,0,0,0,0,0,0,52806,0,26124),
(91713,'','Yes, yes, what is it?$b$bIf this is about the evocation final, then the answer is no, you may not take it again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91714,'','You - pff - what!?$b$bYou ARE aware that the Tidestone Chamber is under quarantine, and has been so since the very day of Prince Farondis\' betrayal, correct?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91715,'','And you are ALSO aware that infringement upon said quarantine carries punishments as severe as death or even detention, correct?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91716,'','Nooo! Must... protect... the Tidestone...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91717,'You have the stink of that traitor Farondis on you...','You have the stink of that traitor Farondis on you...',0,0,0,0,0,0,0,0,0,31167,0,0,26124),
(91718,'Fool! You\'ve disturbed my studies!','Fool! You\'ve disturbed my studies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91719,'Sul\'dren il nathas!','Sul\'dren il nathas!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91720,'Intruders in our halls! Inform the headmistress!','Intruders in our halls! Inform the headmistress!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91721,'STAY... OUT...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91722,'WHERE IS FARONDIS...?','',0,0,0,0,0,0,0,0,0,31167,0,0,26124),
(91723,'SLAY THE OUTSIDERS...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91724,'MUST PROTECT TIDESTONE...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91725,'','How perfectly convenient... the brainless $r led us right to the Tidestone.',0,0,0,0,0,0,0,0,0,0,0,52612,26124),
(91726,'','Our Queen Beneath the Tides can reassemble the pieces.',0,0,0,0,0,0,0,0,0,0,0,52616,26124),
(91727,'','As for you... you will make an acceptable slave.',0,0,0,0,0,0,0,0,0,0,0,52623,26124),
(91728,'If Azuka is able to retrieve the heart, there is no telling what type of evil she will unleash on our people.','',378,0,0,0,0,0,0,0,0,0,0,0,26124),
(91729,'If you see that worthless grunt can you tell him I\'m looking for him?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(91730,'Hey you! Where do you think you\'re going?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91731,'Stay out.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91732,'Be careful, $n. Dhow\'s a light sleeper.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91733,'While you\'re doing that, I\'m heading into Oceanus Cove.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91734,'I\'ll free and arm the pit fighters in there. That\'ll get us some help dealing with the giants.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91739,'Our people are being held captive, $r. Please help us free them. Head into the ruins and free our brothers from their oppressors. Leading them in battle will greatly aid our cause; but you must get them back to one of the Darkscryers safely!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91740,'I\'ve rescued these outcasts, guide them to safety.','I\'ve rescued these outcasts, guide them to safety.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91741,'Yes, good! You have freed more outcasts from our oppressive brothers. Quickly now, we must get them to safety.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91742,'Free the outcasts, lead them in battle, escort them out to the Darkscryers, don\'t let them perish. Got it.','Free the outcasts, lead them in battle, escort them out to the Darkscryers, don\'t let them perish. Got it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91743,'Don\'t let me catch you back here again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91745,'I\'m trying to sleep here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91747,'Think you can sneak past me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91750,'That stuff\'s not for you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91751,'Next time, I\'ll squish you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91755,'Don\'t let me see your face again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91757,'Help! I\'m alive!','Help! I\'m alive!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91758,'Retreat!','',0,0,0,0,0,0,0,0,0,924,48489,0,26124),
(91759,'','Run!',0,0,0,0,0,0,0,0,0,924,0,48490,26124),
(91760,'Retreat!','',0,0,0,0,0,0,0,0,0,923,48493,0,26124),
(91761,'','Run!',0,0,0,0,0,0,0,0,0,923,0,48494,26124),
(91762,'Charge!','',0,0,0,0,0,0,0,0,0,924,48496,0,26124),
(91763,'','To battle!',0,0,0,0,0,0,0,0,0,924,0,48495,26124),
(91764,'','For Durotar!',0,0,0,0,0,0,0,0,0,923,0,48499,26124),
(91765,'Slay them all!','',0,0,0,0,0,0,0,0,0,923,48498,0,26124),
(91766,'Good work Alliance! If we now capture Emberfall Tower we can have our Sentinels take out those |c00FFFF00|Hspell:178362|h[Warspear Gladiators]|h|r. Victory is near!','Good work Alliance! If we now capture Emberfall Tower we can have our Sentinels take out those |c00FFFF00|Hspell:178362|h[Warspear Gladiators]|h|r. Victory is near!',0,0,0,0,0,0,0,0,0,31196,0,0,26124),
(91767,'Lok\'tar ogar! We must capture this last point and our Headhunters can take out those |c00FFFF00|Hspell:178363|h[Stormshield Gladiators]|h|r, then we can storm Stormshield Stronghold. Tremblade will die this day!','Lok\'tar ogar! We must capture this last point and our Headhunters can take out those |c00FFFF00|Hspell:178363|h[Stormshield Gladiators]|h|r, then we can storm Stormshield Stronghold. Tremblade will die this day!',0,0,0,0,0,0,0,0,0,36471,0,0,26124),
(91768,'$p? Hah! You\'re the last of Sternfathom\'s pit fighters.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91769,'Come on. Let\'s finish this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91770,'Alright, Feargus, you\'re up. Kill for me.','',0,0,0,0,0,0,1,0,0,45656,0,0,26124),
(91771,'Ready to die, $pr?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91772,'Good luck, my little friend.','',0,0,0,0,0,0,1,0,0,45656,0,0,26124),
(91773,'Great job, $p! Only two more to go.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(91774,'|TInterface\\Icons\\ability_warrior_rampage.blp:20|t %s begins to cast |cFFFF0000|Hspell:164426|h[Reckless Provocation]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91775,'Don\'t fail me, fish man, or you\'ll be bait on my hook.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91776,'Blessings of the Jade Serpent upon you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91777,'You\'re still going to lose.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91778,'Yes!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(91779,'NOOO!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(91780,'Finish this, Whalebelly!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(91781,'Come on, Bilgerudder. Get me in there!','',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(91782,'I told you I was going to chop you up into little chunks of chum, $p.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91783,'And that\'s what I\'m going to do!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91784,'Stupid tuskarr!','',0,0,0,0,0,0,53,0,0,45699,0,0,26124),
(91785,'You win this time, Sternfathom. It won\'t happen again.','',0,0,0,0,0,0,1,0,0,45699,0,0,26124),
(91786,'An incredible performance, my little $p. Go, find your friend.','',0,0,0,0,0,0,15,0,0,45699,0,0,26124),
(91787,'WHAT? No...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91788,'We are shamed in this defeat. Fall back!','',0,0,0,0,0,0,0,0,0,31196,0,0,26124),
(91789,'','Discretion is the better part of valor. Now flee!',0,0,0,0,0,0,0,0,0,31196,0,0,26124),
(91790,'Ready to be thrown into the arena?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91791,'It\'s my lifelong dream to beat Bilgerudder during a real challenge against his three champions. They\'re just so good!\n\nMaybe you\'ll be the one to make my dream come true, $n?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(91792,'$n! So good to see you.\n\nYou can come back and fight for me anytime.','',53,0,0,0,0,0,0,0,0,0,0,0,26124),
(91793,'They\'re ready, Sternfathom. Toss me into battle.','They\'re ready, Sternfathom. Toss me into battle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91794,'Make Team Sternfathom proud.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91795,'','|TInterface\\Icons\\ability_deathwing_bloodcorruption_earth.blp:20|t%s begins to cast |cFFFF0000|Hspell:163689|h[Sanguine Sphere]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91796,'Eeeeek! A dooker on you!','',0,0,0,0,0,0,0,0,0,31406,0,0,26124),
(91797,'I\'m ookin\' outa here.','',0,0,0,0,0,0,0,0,0,31406,0,0,26124),
(91798,'What the ook? This not sanctioned fight!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91799,'Ookin\' wikket! Walk away, just like your brother.','Ookin\' wikket! Walk away, just like your brother.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91800,'','Parjesh! Rally the rest of our forces. I shall make short work of this minor interruption.',0,0,0,0,0,0,0,0,0,0,0,51877,26124),
(91801,'It will be done, Tidemistress.','',0,0,0,0,0,0,0,0,0,0,52899,0,26124),
(91802,'','I have lost two sons this day. I would see this war end before more brothers and sisters of the clans fall prey to the Iron Horde.$b$bMy way is that of a healer. It is my gift to aid others injured by life or battle.$b$bIf you will have me, I shall lend my healing talents to your forces.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91803,'Greatmother Geyah, I choose you!','Greatmother Geyah, I choose you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91804,'You\'ve surpassed me on the battlefield more than once, and that\'s no simple feat.$b$bStill, there is much I can do that you\'ve not yet seen. The spirits have seen it fit to grant me their coldest, most harsh powers. The elements are my allies, and the bane of our enemies.$b$bIt would be my honor to serve at your side.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91805,'Kal\'gor the Honorable, I choose you!','Kal\'gor the Honorable, I choose you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91806,'Lokra, I choose you!','Lokra, I choose you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91807,'','You\'ve seen me at my worst, $n. My husband taken from me... my wolf killed by the coward, Fenris. I know intimately the price of war.$B$BWe must bring the Iron Horde to an end. Grant me a place by your side on the battlefield and I will bring the elements to bear to reap vengeance on our enemies.$b$bYou have only to accept my axe, and I will come.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91808,'What happened, Farondis?','What happened, Farondis?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91809,'Guilt overcame me. I could not simply WAIT while you fought my battles.','',0,0,0,0,0,0,0,0,0,0,52803,0,26124),
(91810,'I resolved to follow you into the academy.','',0,0,0,0,0,0,0,0,0,0,52792,0,26124),
(91811,'','Make sure that prisoner doesn\'t awaken, Parjesh.',0,0,0,0,0,0,1,0,0,0,0,53658,26124),
(91812,'Yes, my mistress.','',0,0,0,0,0,0,1,0,0,0,52901,0,26124),
(91813,'I followed them as closely as I dared.','',0,0,0,0,0,0,0,0,0,0,52789,0,26124),
(91814,'In the midst of the chaos, I saw it: the sorceress had dropped the Tidestone.','',0,0,0,0,0,0,0,0,0,37087,52793,0,26124),
(91815,'You deal with our guest, Athissa. I shall take the prisoner to the slave pens.','',0,0,0,0,0,0,1,0,0,0,52900,0,26124),
(91816,'','Curse you and your kind, elf. The queen herself will hear of this!',0,0,0,0,0,0,1,0,0,0,0,53659,26124),
(91817,'Athissa and the Tidestone had evaded me. Rather than pursuing her, I set off to rescue you, my champion.','',0,0,0,0,0,0,0,0,0,0,62547,0,26124),
(91818,'At the entrance to the cave, however, I ran into an old acquaintance.','',0,0,0,0,0,0,0,0,0,0,52783,0,26124),
(91819,'I had finally found their slave pen.','',0,0,0,0,0,0,0,0,0,0,52527,0,26124),
(91820,'','Be gone, spirit! The Tidestone belongs to us now!',0,0,0,0,0,0,1,0,0,0,0,53660,26124),
(91821,'I believe you know the rest of the story, $n.','',0,0,0,0,0,0,0,0,0,0,52796,0,26124),
(91822,'Follow Maraad','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(91832,'<Okuna Longtusk\'s pack lies here on the ground. One of the straps is broken and there are signs of a struggle. But otherwise, it\'s intact including its contents.>\n\n<Odds are that Okuna was captured and taken to Prince Oceanus. Time to proceed without him.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91833,'Freedom!','Freedom!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91834,'Aaarr! Now you die, scum.','Aaarr! Now you die, scum.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91835,'This isn\'t my weapon, but she feels good in my hand.','This isn\'t my weapon, but she feels good in my hand.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91836,'Time to pay the price of iron, skrogs.','Time to pay the price of iron, skrogs.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91837,'Rise up. Let\'s kill them all.','Rise up. Let\'s kill them all.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91838,'Better to die free than as a slave.','Better to die free than as a slave.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91839,'Death to the giants. Death to Prince Oceanus!','Death to the giants. Death to Prince Oceanus!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91840,'Kill them all. Let Neptulon sort them out.','Kill them all. Let Neptulon sort them out.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91841,'%s takes a deep breath.','%s takes a deep breath.',0,0,0,0,0,0,0,7,1,30987,0,0,26124),
(91842,'Commander, Morthis Whisperwing from the Druids of the Talon was looking for you. He can be found beneath the great tree to the south.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(91843,'My hero! Say, you don\'t happen to have my weapons?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91844,'Outstanding! Let\'s get to work.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91845,'You start things off and I\'ll be sneaky.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91846,'The sooner we deal with Oceanus, the sooner we can get out of here.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(91847,'We really did it. We took out Oceanus!\n\nNow we\'re free.','',4,0,0,0,0,0,0,0,0,0,0,0,26124),
(91848,'Hey, $p, I\'m right over here in this cage. Let me out!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91849,'You\'re going down, Oceanus!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91850,'Zug! You lead to great hall?','Zug! You lead to great hall?',0,0,0,0,0,0,0,0,0,23504,0,0,26124),
(91851,'Zug zug!','Zug zug!',0,0,0,0,0,0,0,0,0,23504,0,0,26124),
(91852,'You want an audience? You\'ve got one!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91853,'For the Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91854,'Blood and Honor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91855,'Drive them out! Do not hold back!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91856,'For the Alliance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91857,'Do not falter!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91858,'Press the attack! Onward!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91859,'YES! I\'ll see you down below.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91860,'The Alliance has assaulted the Blacksmith!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91861,'The Horde has assaulted the Blacksmith!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91862,'The Alliance has taken the Blacksmith!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91863,'The Horde has taken the Blacksmith!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91864,'The Horde has defended the Blacksmith!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91865,'The Alliance has defended the Blacksmith!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91866,'The Alliance has assaulted the Farm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91867,'The Horde has assaulted the Farm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91868,'The Alliance has taken the Farm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91869,'The Horde has taken the Farm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91870,'The Alliance has defended the Farm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91871,'The Horde has defended the Farm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91872,'The Alliance has assaulted the mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91873,'The Horde has assaulted the mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91874,'The Alliance has taken the mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91875,'The Horde has taken the mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91876,'The Alliance has defended the mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91877,'The Horde has defended the mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91878,'The Alliance has assaulted the Lumber Mill!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91879,'The Horde has assaulted the Lumber Mill!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91880,'The Alliance has taken the Lumber Mill!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91881,'The Horde has taken the Lumber Mill!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91882,'The Alliance has defended the Lumber Mill!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91883,'The Horde has defended the Lumber Mmill!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91884,'The Alliance has assaulted the Stables!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91885,'The Horde has assaulted the Stables!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91886,'The Horde has defended the Stables!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91887,'The Alliance has defended the Stables!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91888,'The Alliance has taken the Stables!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91889,'The Horde has taken the Stables!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91890,'Thank you, stranger.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91891,'I don\'t know what happened. I heard a loud crashing noise, and then I found myself stuck beneath this beam. Since then, I\'ve just been waiting.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91892,'Now, where did that lovely girl run off to?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91893,'Whew, thank goodness I got to you in time! I know you are eager, hero, but we should build our strength before facing the dangers of Tanaan Jungle.','Whew, thank goodness I got to you in time! I know you are eager, hero, but we should build our strength before facing the dangers of Tanaan Jungle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91894,'An Alliance spy has snuck in amidst the chaos!','An Alliance spy has snuck in amidst the chaos!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91895,'Let battle be joined!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91896,'For the Frostwolves!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91897,'For Commander $p!','',0,0,0,0,0,0,0,0,0,26967,0,0,26124),
(91898,'A... glorious... end.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91899,'May the spirits have mercy on you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91900,'The spirits will break you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91901,'You have failed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91902,'Lok-narosh.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91903,'May the spirits bring you victory.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91904,'','Have you heard from my son, Durotan?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91905,'','Will this war ever end?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91906,'','How is my son, Durotan?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91907,'','It did not have to be this way.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91908,'','These people are protected.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91909,'','You will harm our people no more.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91910,'','I am sorry it ended this way.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91911,'','Garad... I am coming...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91912,'','You will not harm our people.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91913,'','The Burning Legion has overrun the vault and most of my wardens are dead. That\'s why I\'m setting you free. No one kills demons like you, $n.\n\nThey\'re heading for Illidan\'s tomb. We have to work together to stop the Legion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91914,'I advise we cooperate with our jailors... for now.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(91915,'Lingering in this prison is a waste of our time. We need to get out of here as soon as possible.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(91916,'It has been a long time, Kayn. I still believe in the cause. But, I do not blindly follow anyone... even Illidan.','',0,0,0,0,0,0,1,0,0,0,57285,0,26124),
(91917,'The Horde has taken control of the Draenei Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91918,'$n has defended the Draenei Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91919,'$n has defended the Blood Elf Tower!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91920,'$n has defended the Blood Elf Tower!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91921,'$n has defended the Fel Reaver Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91922,'$n has defended the Fel Reaver Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91923,'$n has defended the Mage Tower!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91924,'$n has defended the Mage Tower!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91925,'Goren Shardbacks Killed: $1i (+$2i VP)','Goren Shardbacks Killed: $1i (+$2i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91926,'Gronn Earthbreakers Killed: $1i (+$2i VP)','Gronn Earthbreakers Killed: $1i (+$2i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91931,'Wildfire Elementals Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91932,'A Wildfire Elemental is being summoned at the front gates!','A Wildfire Elemental is being summoned at the front gates!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91933,'A Goren Hole has opened up!','A Goren Hole has opened up!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91934,'Goren Holes closed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91935,'Ready when you are, my queen.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91936,'My life for the Talon Queen.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91937,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91938,'Dese pukes better at dieing den fighten.','',0,0,0,0,0,0,0,0,0,0,45933,0,26124),
(91939,'HA! Looks like getting split in half made that grub twice as ugly!','',0,0,0,0,0,0,0,0,0,0,45934,0,26124),
(91940,'<Snore>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91941,'Observing','Observing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(91942,'Gronnling Groundshakers Killed: $1i (+$2i VP)','Gronnling Groundshakers Killed: $1i (+$2i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91943,'','Let\'s go! Commander, we\'ll meet ya at the tower.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91944,'A Gorian Warcaller joins the battle to raise morale!','A Gorian Warcaller joins the battle to raise morale!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91945,'Gorian Warcallers Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91946,'Rifts to the void open!','Rifts to the void open!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91947,'Void Portals Closed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91948,'Void Fragments Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91949,'A fallen guard has been turned into a skeleton!','A fallen guard has been turned into a skeleton!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91950,'Exarch Haataru - How do you plan to vote with the council?','',0,0,0,0,0,0,6,0,0,0,46721,0,26124),
(91951,'You would risk everything we have built. I cannot agree!','',0,0,0,0,0,0,5,0,0,0,46722,0,26124),
(91952,'It is wisest to fight where we are strongest.','',0,0,0,0,0,0,1,0,0,0,46720,0,26124),
(91953,'This \"Alliance\" from another world intrigues me. I would give them our full support.','',0,0,0,0,0,0,1,0,0,0,46755,0,26124),
(91954,'','Exarch Akama, how do you plan to vote? I suppose you\'ll want to wait behind the fortifications of Shattrath and Karabor.',0,0,0,0,0,0,6,0,0,0,0,45895,26124),
(91955,'','If we never leave our city walls, we will never be able to call this world our home.',0,0,0,0,0,0,5,0,0,0,0,45896,26124),
(91956,'Gorian Battle Beasts Killed: $1i (+$2i)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91957,'The Alliance has lost control of the Blood Elf Tower!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91958,'The Horde has lost control of the Blood Elf Tower!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91959,'The Alliance has lost control of the Draenei Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91960,'The Horde has lost control of the Draenei Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91961,'The Alliance has lost control of the Fel Reaver Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91962,'The Horde has lost control of the Fel Reaver Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91963,'The Alliance has lost control of the Mage Tower!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91964,'The Horde has lost control of the Mage Tower!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91965,'A Void Wolf Patriarch is terrorizing your guards!','A Void Wolf Patriarch is terrorizing your guards!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91966,'Void Wolf Patriarchs Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91967,'Ah! That old thing. I was so young and naive when I made that staff. Look at that hair! And that nose!$b$bAnd I can\'t BELIEVE I ever wore something so atrocious as a hat like that.$b$bYou should keep this old staff. The image is from a few years ago, and hasn\'t quite caught on to current events. May you enjoy the nostalgia of my more youthful visage.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91968,'Is this |Hitem:118191|h|cff0070dd[Archmage Vargoth\'s Spare Staff]|r|h yours?','Is this |Hitem:118191|h|cff0070dd[Archmage Vargoth\'s Spare Staff]|r|h yours?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91969,'Felbringers Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91970,'Destructors Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91971,'Soulspeakers Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91972,'Ritualists Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91973,'Insurgents Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91974,'Militants Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91975,'Ransacking','Ransacking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(91976,'An Earth Fury is causing an earthquake in your garrison!','An Earth Fury is causing an earthquake in your garrison!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91977,'Infuriated Earthpounder Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91978,'Marauders Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91979,'Doombringers Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91980,'Imp Charmers Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91981,'Imp Seers Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91982,'','NO! This is not for you. It\'s for Prince Oceanus!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91983,'','Wake up. I demand to see Prince Oceanus, now!',0,0,0,0,0,0,0,0,0,31463,0,0,26124),
(91984,'','You slumbering oaf. I will not be made to wait here all day. I demand to see your prince!',0,0,0,0,0,0,0,0,0,31463,0,0,26124),
(91985,'A Gorian Battle-Mage enters the fray!','A Gorian Battle-Mage enters the fray!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91986,'Gorian Battle-Mages Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91987,'','If your prince does not want this treasure, I will happily take it and leave.',0,0,0,0,0,0,0,0,0,31463,0,0,26124),
(91991,'','If treasure is not to his liking, perhaps your prince needs a different kind of motivation?',0,0,0,0,0,0,0,0,0,31463,0,0,26124),
(91993,'The commotion of the battle attracts a rylak!','The commotion of the battle attracts a rylak!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91994,'A Gorian Spellbinder arrives to slow down your forces!','A Gorian Spellbinder arrives to slow down your forces!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91995,'Gorian Spellbinders Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91996,'Rylak Killed: $1i (+$2i)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91997,'Nefarious Consorts Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91998,'Fel Legionnaires Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(91999,'Shattered Hand Assassins Killed: $1i (+$2i VP)','Shattered Hand Assassins Killed: $1i (+$2i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92000,'An Assassin is hunting your guards!','An Assassin is hunting your guards!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92001,'I would like to deactivate this waygate.','I would like to deactivate this waygate. |cFFFF2222 [Requires 10 Ogre Waystones]|r |TInterface\\Icons\\INV_RELICS_RUNESTONE.BLP:##|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92002,'What business do you have here, mortal?\n\nMy life is dedicated to protecting these ancient waygates.  If you wish to activate them, you will need to procure a collection of ancient artifacts known as ogre waystones.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92003,'Are you sure you want to deactivate this ogre waygate?\n\n|TInterface\\Icons\\INV_RELICS_RUNESTONE.BLP:24|t Requires 10 Ogre Waystones','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92004,'I heard you might have high-quality rings for sale?','I heard you might have high-quality rings for sale?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92005,'A Siege Cannon draws near!','A Siege Cannon draws near!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92006,'Siege Cannons Destroyed: $1i (+$2i VP)','Siege Cannons Destroyed: $1i (+$2i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92007,'A Brute is frightening your troops!','A Brute is frightening your troops!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92008,'Horrifying Brutes Destroyed: $1i (+$2i VP)','Horrifying Brutes Destroyed: $1i (+$2i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92009,'Concubines of Sin Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92010,'A Sniper is shooting your guards!','A Sniper is shooting your guards!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92011,'Grom\'kar Sniper Killed: $1i (+$2i VP)','Grom\'kar Sniper Killed: $1i (+$2i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92012,'A host of Concubines appear!','A host of Concubines appear!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92013,'Succubus Group Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92014,'Go away, tiny creature, or I will have you for a snack.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92015,'$n, over here. Get me out of this cage.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92016,'Grom\'kar Commander Killed: $1i (+$2i VP)','Grom\'kar Commander Killed: $1i (+$2i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92017,'BLACKHAND','BLACKHAND',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92018,'GUL\'DAN','GUL\'DAN',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92019,'KARGATH','KARGATH',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92020,'KILROGG','KILROGG',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92021,'NER\'ZHUL','NER\'ZHUL',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92022,'Infernals Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92023,'Infernal Waves Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92024,'A storm of Infernals appear!','A storm of Infernals appear!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92025,'What do we have in stock?','What do we have in stock?',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(92026,'The Horde has assaulted the Blood Elf Tower!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92027,'The Alliance has assaulted the Blood Elf Tower!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92028,'The Horde has assaulted the Draenei Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92029,'The Alliance has assaulted the Draenei Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92030,'The Horde has assaulted the Fel Reaver Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92031,'The Alliance has assaulted the Fel Reaver Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92032,'The Horde has assaulted the Mage Tower!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92033,'The Alliance has assaulted the Mage Tower!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92034,'Alchemy Lab\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92035,'Barn\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92036,'Barracks\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92037,'Dwarven Bunker\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92038,'Enchanter\'s Study\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92039,'Engineering Works\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92040,'Fishing Shack\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92041,'Gem Boutique\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92042,'Gladiator\'s Sanctum\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92043,'Gnomish Gearworks\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92044,'Herb Garden\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92045,'Lumber Mill\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92046,'Lunarfall Excavation\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92047,'Lunarfall Inn\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92048,'Mage Tower\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92049,'Menagerie\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92050,'Salvage Yard\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92051,'Scribe\'s Quarters\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92052,'Stables\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92053,'Storehouse\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92054,'Tailoring Emporium\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92055,'The Forge\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92056,'The Tannery\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92057,'Trading Post\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92058,'Frostwall Mine\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92059,'Frostwall Tavern\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92060,'Goblin Workshop\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92061,'Spirit Lodge\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92062,'War Mill\nLevel 1','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92066,'Alchemy Lab\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92067,'Barn\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92068,'Barracks\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92069,'Dwarven Bunker\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92070,'Enchanter\'s Study\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92071,'Engineering Works\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92072,'Fishing Shack\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92073,'Gem Boutique\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92074,'Gladiator\'s Sanctum\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92075,'Gnomish Gearworks\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92076,'Herb Garden\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92077,'Lumber Mill\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92078,'Lunarfall Excavation\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92079,'Lunarfall Inn\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92080,'Mage Tower\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92081,'Menagerie\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92082,'Salvage Yard\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92083,'Scribe\'s Quarters\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92084,'Stables\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92085,'Storehouse\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92086,'Tailoring Emporium\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92087,'The Forge\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92088,'The Tannery\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92089,'Trading Post\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92090,'Frostwall Mine\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92091,'Frostwall Tavern\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92092,'Goblin Workshop\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92093,'Spirit Lodge\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92094,'War Mill\nLevel 2','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92095,'Alchemy Lab\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92096,'Barn\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92097,'Barracks\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92098,'Dwarven Bunker\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92099,'Enchanter\'s Study\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92100,'Engineering Works\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92101,'Fishing Shack\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92102,'Gem Boutique\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92103,'Gladiator\'s Sanctum\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92104,'Gnomish Gearworks\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92105,'Herb Garden\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92106,'Lumber Mill\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92107,'Lunarfall Excavation\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92108,'Lunarfall Inn\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92109,'Mage Tower\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92110,'Menagerie\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92111,'Salvage Yard\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92112,'Scribe\'s Quarters\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92113,'Stables\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92114,'Storehouse\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92115,'Tailoring Emporium\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92116,'The Forge\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92117,'The Tannery\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92118,'Trading Post\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92119,'Frostwall Mine\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92120,'Frostwall Tavern\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92121,'Goblin Workshop\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92122,'Spirit Lodge\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92123,'War Mill\nLevel 3','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(92124,'|TInterface\\Icons\\inv_bannerpvp_02.blp:20|t An Alliance Bannerman arrives at your Town Hall! |TInterface\\Icons\\inv_bannerpvp_02.blp:20|t','|TInterface\\Icons\\inv_bannerpvp_02.blp:20|t An Alliance Bannerman arrives at your Town Hall! |TInterface\\Icons\\inv_bannerpvp_02.blp:20|t',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(92125,'|TInterface\\Icons\\inv_bannerpvp_01.blp:20|t A Horde Bannerman arrives at your Great Hall! |TInterface\\Icons\\inv_bannerpvp_01.blp:20|t','|TInterface\\Icons\\inv_bannerpvp_01.blp:20|t A Horde Bannerman arrives at your Great Hall! |TInterface\\Icons\\inv_bannerpvp_01.blp:20|t',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(92126,'A swarm of ravager wasps approaches!','A swarm of ravager wasps approaches!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92127,'Void Wolves Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92128,'Void Essences Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92129,'Shadowmoon Darkcasters Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92130,'Shadowmoon Reavers Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92131,'I\'m out of banners, commander! I shall take my leave.','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(92132,'Spor Shooters are attacking your guards!','Spor Shooters are attacking your guards!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92133,'Guards Inspired: $1i (+$2i VP)','Guards Inspired: $1i (+$2i VP)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92134,'Spore Shooters: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92135,'Ravager Wasps: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92140,'Enthralled Mutants: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92141,'A Nefarious Consort is assaulting your forces!','A Nefarious Consort is assaulting your forces!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92142,'A Fel Legionnaire draws near!','A Fel Legionnaire draws near!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92143,'Ravager Swarms Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92144,'Spore Shooter Waves Killed: $1i (+$2i VP)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92145,'Searching for Clues','Searching for Clues',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(92146,'We were headed for... Stormheim.','We were headed for... Stormheim.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(92147,'Ship crashed... gilblin swarmed us.','Ship crashed... gilblin swarmed us.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(92148,'Makrura queen... demon...','Makrura queen... demon...',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(92149,'Storm... ran aground.','Storm... ran aground.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(92150,'Captain... taken...','Captain... taken...',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(92151,'We were... going to Stormheim... after the Broken Shore.','We were... going to Stormheim... after the Broken Shore.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(92152,'Demon... here...','Demon... here...',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(92153,'I heard... makrura ate... the captain!','I heard... makrura ate... the captain!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(92154,'The queen...','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(92155,'A $r, how refreshing. Come closer, child.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92156,'What am I thinking? This fight is all yours, my queen.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92157,'Useless, like the rest of her kind. I\'ll deal with you, myself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92158,'HEY! That\'s not for you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92159,'Don\'t think of us as smugglers. Instead, refer to us as professional salvors.\n\nWe are salvage experts. We specialize in flotsam, jetsam, lagan, derelicts, and, of course, exotic archaeological recovery.\n\nOh, and by the way, you might want to steer clear of the temple area to the south. I have my men investigating some salvage opportunities and I wouldn\'t want you to be confused for a competitor.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(92160,'%s beckons the sailor forward.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92161,'Stranger, quickly. Over here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92162,'I await your orders, $g sir:ma\'am;.','',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(92163,'You, Kor\'vas, and Cyana attack the Legion from within. Then, we will wipe them out together.','',0,0,0,0,0,0,25,0,0,0,51888,0,26124),
(92164,'','You must all be taught a lesson.',0,0,0,0,0,0,474,0,4,0,0,0,26124),
(92169,'Accompany Prophet Velen to Lunarfall.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92170,'We must hurry to Lunarfall.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92171,'Escort Prophet Velen to Lunarfall.','Escort Prophet Velen to Lunarfall.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92172,'Accompany Prophet Velen to Lunarfall.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92173,'Great job on the training, let\'s let your talbuk rest for the night.','Great job on the training, let\'s let your talbuk rest for the night.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92174,'They\'re tough, for sure, but your clefthoof will still need to rest for a while.','They\'re tough, for sure, but your clefthoof will still need to rest for a while.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92175,'Your boar looks like he could use a good brushing and feeding, check back tomorrow.','Your boar looks like he could use a good brushing and feeding, check back tomorrow.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92176,'Ye fought well today, we\'ll let the riverbeast bed down for the night.','Ye fought well today, we\'ll let the riverbeast bed down for the night.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92177,'The elekk\'s already almost asleep, we\'ll let it rest up a bit before more training.','The elekk\'s already almost asleep, we\'ll let it rest up a bit before more training.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92178,'That wolf\'s a fiesty one, but he\'s all curled up and asleep after today\'s training, come back tomorrow for more.','That wolf\'s a fiesty one, but he\'s all curled up and asleep after today\'s training, come back tomorrow for more.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92179,'The wolf is a fiery predator, but will require a day\'s rest before it can be trained further.','The wolf is a fiery predator, but will require a day\'s rest before it can be trained further.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92180,'The talbuk training appears to be going well, it should rest for the night.','The talbuk training appears to be going well, it should rest for the night.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92181,'The riverbeasts are not so used to land combat, we will need to let this one retire for tonight.','The riverbeasts are not so used to land combat, we will need to let this one retire for tonight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92182,'The elekk is nearly asleep after today\'s training, we will let it rest for the night.','The elekk is nearly asleep after today\'s training, we will let it rest for the night.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92183,'The clefthoof will need a good brushing and some water, check back tomorrow for more training.','The clefthoof will need a good brushing and some water, check back tomorrow for more training.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92184,'Your boar looks weary but healthy, leave it with us for tonight and we will take care of it.','Your boar looks weary but healthy, leave it with us for tonight and we will take care of it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92190,'Somehow, the Burning Legion is nullifying my demon wards. If we don\'t get those defenses back in working order, we\'ll be overrun and I will have failed all of us.','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(92192,'Welcome to our humble place of business, traveler.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92193,'I saw my chance. I would attack the naga leaders and save you from captivity.','',0,0,0,0,0,0,0,0,2,0,52782,0,26124),
(92195,'\"Going for a walk.\" Hah! He\'s probably out visiting that little common girl he fancies so much.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92196,'','Aldryth. You weren\'t out consorting with that servant girl, were you?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(92197,'What? No, of course not!','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(92198,'...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92199,'I was visiting a different girl.','',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(92200,'What should we do with this one?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92201,'Torture? Hard labor? Kill it?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92202,'I say we kill it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92203,'Good idea, let\'s kill it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92204,'Huh?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92205,'What?','',0,0,0,0,0,0,0,0,0,0,52694,0,26124),
(92206,'Ten thousand years ago, I found myself mixed up with a rebel alliance of sorts.','',0,0,0,0,0,0,0,0,6,0,49588,0,26124),
(92207,'This was during the pinnacle of Queen Azshara\'s power over the elves. Her abuse of magic had grown dangerously strong.','',0,0,0,0,0,0,0,0,6,0,49588,0,26124),
(92208,'We plotted to use the Tidestone of Golganneth against the queen.','',0,0,0,0,0,0,0,0,6,0,49588,0,26124),
(92209,'Cenarius. I can wield the Tidestone, but I must warn you: we risk destroying the entire Well of Eternity!','',0,0,0,0,0,0,0,0,4,0,49588,0,26124),
(92210,'That, my friend, is precisely the plan.','',0,0,0,0,0,0,0,0,4,0,49588,0,26124),
(92211,'Fah! We need simply to do away with Queen Azshara herself, not the very source of our people\'s power.','',0,0,0,0,0,0,0,0,4,0,49588,0,26124),
(92212,'I agree. We are firing a cannon at sparrows.','',0,0,0,0,0,0,0,0,4,0,49588,0,26124),
(92213,'','We are fighting the greatest danger our world has ever seen!',0,0,0,0,0,0,0,0,4,0,0,49588,26124),
(92214,'','Even now, Queen Azshara colludes with demons. She puts our world at risk.',0,0,0,0,0,0,0,0,4,0,0,49588,26124),
(92215,'Very well. Prince Farondis, you can secure the Tidestone of Golganneth?','',0,0,0,0,0,0,0,0,4,0,49588,0,26124),
(92216,'I shall have it arranged, Cenarius.','',0,0,0,0,0,0,0,0,4,0,49588,0,26124),
(92217,'You there. Stop!','',0,0,0,0,0,0,0,0,0,0,52692,0,26124),
(92218,'Such interesting thoughts! Show us more, $r. Kill the others here! Let us feed on our enemies, exploit their machines and discover the wonders that our home hides!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92219,'Let us feed... slay them all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92220,'We hunger... kill more of them! Let us consume their corpses!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92221,'What is this? We must know more. Move closer!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92222,'Fascinating, we will have to remember this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92223,'Our power grows...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92224,'We are learning! We can see the next phase of our life cycle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92225,'Our powers are ready, we EVOLVE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92226,'A strange parasite attaches itself to your head, you feel an intrusion in your thoughts.','A strange parasite attaches itself to your head, you feel an intrusion in your thoughts.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92227,'The Amorphic Cognitor undulates with excitement, it is clearly pleased with your actions.','The Amorphic Cognitor undulates with excitement, it is clearly pleased with your actions.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92228,'The Amorphic Cognitor tightens its grip on your head, it is getting stronger.','The Amorphic Cognitor tightens its grip on your head, it is getting stronger.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92229,'As the Amorphic Cognitor evolves, you feel yourself pulled off the ground. You are evolving with it!','As the Amorphic Cognitor evolves, you feel yourself pulled off the ground. You are evolving with it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92230,'','Together, we will release the demon souls from the gems and use the scythe to compel them to talk.\n\nLet me know when you are ready to begin.',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(92231,'We cannot leave our home, $r. We will continue our life cycle without you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92232,'The strange parasite detaches from your head and disappears into the distance.','The strange parasite detaches from your head and disappears into the distance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92233,'You\'ll learn nothing from me, Souleater!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92234,'','After the Battle at the Broken Shore, it was only fitting that I step down so that Khadgar could lead the Kirin Tor.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(92235,'The time has come for us to put aside our petty differences. The united force of Dalaran will crush the Burning Legion!','',274,0,0,0,0,0,0,0,0,0,0,0,26124),
(92236,'Ooka, may I please have some of your delicious Fighter Chow? I hear it\'s the best.','Ooka, may I please have some of your delicious Fighter Chow? I hear it\'s the best.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92237,'','Where is the Legion keeping Illidan\'s body? Tell me or your suffering will be the stuff of legend.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92238,'I\'m ready, Allari. Let\'s begin.','I\'m ready, Allari. Let\'s begin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92239,'','What did they do? What did the demons offer you?',0,0,0,0,0,0,0,0,0,32378,0,57183,26124),
(92240,'','Who did this to you?',0,0,0,0,0,0,0,0,0,32379,0,57184,26124),
(92241,'','Did anyone give in?',0,0,0,0,0,0,0,0,0,32380,0,57185,26124),
(92242,'','We will work together to destroy the Legion from within.',0,0,0,0,0,0,0,0,0,0,0,56344,26124),
(92243,'','They have all been tortured.',0,0,0,0,0,0,0,0,0,32377,0,57182,26124),
(92244,'','I think I understand why this is not working.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92245,'','$p, you must enter the soul gem and force Arev\'naal to reveal Lord Illidan\'s location.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92246,'','A powerful demon I have kept trapped in the gems is helping them to resist.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92247,'Our combined will is stronger than your scythe. I will not tell you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92248,'','Illidari, what happened here?',0,0,0,0,0,0,0,0,0,32376,0,57181,26124),
(92252,'','Quickly, $p, break the next soul gem.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92333,'We sense the deaths of some of our brothers. This is good, they were clearly unfit to evolve.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92334,'Such a sweet taste of our future evolution. We must have more.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92335,'The Amorphic Cognitor tightens its grip on your head once again, its voice booms through your mind.','The Amorphic Cognitor tightens its grip on your head once again, its voice booms through your mind.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92336,'|TInterface\\Icons\\Ability_Racial_Cannibalize:20|tRight-click on corpses to |cFFFF0000|Hspell:174133|h[Consume]|h|r them after you\'ve looted them.','|TInterface\\Icons\\Ability_Racial_Cannibalize:20|tRight-click on corpses to |cFFFF0000|Hspell:174133|h[Consume]|h|r them after you\'ve looted them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92337,'','Quickly, $p, we have to find the key to those demonic locks. I\'d bet anything it\'s on that big jailer to the east.',0,0,0,0,0,0,0,0,0,0,0,57399,26124),
(92339,'','Get the key. Let\'s get over there and free that drake.',0,0,0,0,0,0,0,0,0,32396,0,57400,26124),
(92340,'Who are you? You\'re no slave!','',0,0,0,0,0,0,0,0,0,0,52691,0,26124),
(92341,'Where are you going?','',0,0,0,0,0,0,0,0,0,0,52690,0,26124),
(92342,'What\'s the meaning of this?','',0,0,0,0,0,0,0,0,0,0,52693,0,26124),
(92343,'Greetings, $c.\n\nThe Burning Legion have taken Faronaar. I have a plan to contain and crush them before they overrun all of Azsuna.\n\nWe could use your assistance in doing so.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(92344,'Already, the Burning Legion spreads like a wildfire across the Broken Isles.\n\nWe must hunt them down and destroy them wherever they pop up.\n\nYou must see to it that the Tomb of Sargeras is resealed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92345,'Come friend, let us walk in together and greet this Senegos.','',0,0,0,0,0,0,0,0,0,0,51876,0,26124),
(92346,'This does not look good. He is not well.','',0,0,0,0,0,0,0,0,0,0,52608,0,26124),
(92347,'Archmage Khadgar? $C? An unexpected surprise.','',0,0,0,0,0,0,0,0,0,33556,52717,0,26124),
(92358,'The Tidestone calls to them...','The Tidestone calls to them...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92359,'Show me your goods!','Show me your goods!',595,0,0,0,0,0,0,0,0,62,0,0,26124),
(92360,'My queen.','',0,0,0,0,0,0,397,0,4,0,0,0,26124),
(92361,'These big ones are strange. Big and slow yes; but with the potential for great intellect just slipping away.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92362,'We can\'t explain why; but we feel great unease around these feathered ones and their cave.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92363,'These little ones are most curious, always so eager to explore, experiment, and learn. Much like us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92364,'These sickly looking creatures are more... pliable than the others. They give themselves over to our brothers.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92365,'This one was already host to one like us. They chose a poor host.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92366,'Such a sad fate for our brother. Evolution\'s circle is savage, not merciful.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92384,'Without the moss here our minds would rot away, leaving us shells of our true potential.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92385,'How interesting, we have not tasted the fruits from this cave.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92386,'What is this ... thing? What hides inside?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92387,'How strange, we do not remember how such things came to be here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92388,'Fascinating, we can sense the energy coursing through you. What could it possibly be for?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92389,'We recognize this now! This infernal device is responsible for the slaughter of so many of us! Our brothers are going to perish soon, leaving us to thrive in their absence.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92390,'Why does this make so much noise? What is this thing\'s purpose?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92391,'I will fight by your side.','I will fight by your side.',0,0,0,0,0,0,0,0,0,31742,0,0,26124),
(92392,'Hopefully that was enough to deter them. Let\'s report in to the prince.','Hopefully that was enough to deter them. Let\'s report in to the prince.',0,0,0,0,0,0,0,0,0,31716,0,0,26124),
(92393,'%s laughs heartily.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92394,'Yes, good thinking. Perhaps a few comparable items are all I need to jog my failing memory.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92395,'','Enough of this! The Tidestone will be ours!',0,0,0,0,0,0,0,0,0,0,0,52617,26124),
(92402,'The Amorphic Cognitor\'s evolution fades away. You feel the parasite resume its precarious position atop your head.','The Amorphic Cognitor\'s evolution fades away. You feel the parasite resume its precarious position atop your head.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92403,'Ahahaha! We are Legion. We know you, Allari, and you, $p. You will be ours.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92411,'We have seen all you can show us, we will seek another to show us more.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92412,'Placeholder Text','Placeholder Text',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92413,'Placeholder Text','Placeholder Text',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92414,'Placeholder Text','Placeholder Text',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92415,'','Tell us everything you know, foul creature!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92416,'','Come, $c, we are going to compel some demon souls.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92417,'You can mank my dook, Ooka. I\'m taking the chow and there\'s nothing you can ookin do about it, wicket licker.','You can mank my dook, Ooka. I\'m taking the chow and there\'s nothing you can ookin do about it, wicket licker.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92418,'','What did you ookin say?!',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(92419,'We have chosen... poorly. We shall find another host.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92421,'A stranger approaches!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92442,'This is the prince\'s palace. Let\'s finish off those naga before we return.','This is the prince\'s palace. Let\'s finish off those naga before we return.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92443,'Stay close, $n. Do not leave my side.','',0,0,0,0,0,0,0,0,0,0,52530,0,26124),
(92444,'$p? Where are you going?','',0,0,0,0,0,0,0,0,0,0,52801,0,26124),
(92445,'Please stay close, $p.','',0,0,0,0,0,0,0,0,0,0,52532,0,26124),
(92446,'I cannot do this on my own. Stay with me.','',0,0,0,0,0,0,0,0,0,0,52529,0,26124),
(92447,'Where are you?','',0,0,0,0,0,0,0,0,0,0,52788,0,26124),
(92448,'I am truly sorry.','',0,0,0,0,0,0,2,0,0,0,52802,0,26124),
(92540,'Where is the Tidestone?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92541,'Give usss the Tidesssstone!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92545,'','The Illidari are the first and last defense against the Burning Legion.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(92547,'Let\'s see what you have.','Let\'s see what you have.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92550,'I should be out there fighting. The best use for my hands are wrapped around the neck of a demon.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(92551,'Bind me. I might be here a while.','Bind me. I might be here a while.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92552,'','$p, break the first soul gem and release a demon soul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92556,'Get out of here. I don\'t want to see you again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92557,'You\'ll hand over the fighter chow now if you know what\'s good for you.','You\'ll hand over the fighter chow now if you know what\'s good for you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92565,'Bring the Constructs back here.','Bring the Constructs back here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92566,'Summon Constructs?','Summon Constructs?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92592,'Those eggs will provide the perfect balance of texture and arcane power my cocktail needs.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92593,'This will be the one they remember me by.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92594,'Now for the finishing touches.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(92595,'Your instructors should be down the ramp to the west. You\'d better hurry, before the second bell rings!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92596,'Bottoms up.','',0,0,0,0,0,0,92,0,0,0,0,0,26124),
(92597,'Uh oh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92598,'','Garuhod? He exploded!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(92599,'','First, a simple arcane rune. Trace its outline with your steps. Memorize it. Commit its intricacies to memory.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92600,'','Well done. Now, we will trace a fire rune. Be careful: incorrectly drawing this rune can result in instant, painful death.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92601,'','Excellent! Finally, a frost rune. Don\'t forget the fifth circle! Everybody always forgets the fifth circle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92602,'','That will do for today.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92603,'Gift of the Earth','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92604,'','Ready... fire!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(92605,'','Aim carefully, and fire!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(92606,'','Line up your wand, and fire!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(92607,'','Fire!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(92608,'','Shoot!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(92609,'','Fire at will!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(92610,'','You may fire when ready.',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(92611,'','Ready, aim, fire!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(92612,'','Well done!',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(92613,'','Excellent hit!',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(92614,'','Spectacular!',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(92615,'','Fantastic.',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(92616,'','You\'ve been studying, I see.',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(92617,'','Impeccable aim, as usual.',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(92618,'','Perfect.',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(92619,'','Good form.',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(92620,'','No, no, no! Your aim is all off!',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(92621,'','Come on, focus!',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(92622,'','Gah... pay attention!',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(92623,'','<Sigh...>',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(92624,'','You\'ll have to do better than that.',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(92625,'','No. We will try it again.',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(92626,'','Still needs work.',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(92627,'','Unacceptable.',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(92628,'','Your turn.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(92629,'','Now it is your turn.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(92630,'','Now, you try.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(92631,'','Next student.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(92632,'For Gul\'dan! For the Legion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92633,'For... Gul\'dan...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92634,'$b','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92635,'Zzz... no, Headmistress! Not the paddle... zzzz....','Zzz... no, Headmistress! Not the paddle... zzzz....',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92636,'Just five more minutes...','Just five more minutes...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92637,'Abjuration, Conjuration, Divination, Necromancy...','Abjuration, Conjuration, Divination, Necromancy...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92638,'<sigh>... I feel like I\'ve been reading this same scroll for ten thousand years, and I STILL don\'t understand it.','<sigh>... I feel like I\'ve been reading this same scroll for ten thousand years, and I STILL don\'t understand it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92639,'I hope everything went alright in there.','I hope everything went alright in there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92643,'YAEGER-367 SYSTEMS INITIATED. SECOND PILOT REQUIRED TO BEGIN PROGRAM.','YAEGER-367 SYSTEMS INITIATED. SECOND PILOT REQUIRED TO BEGIN PROGRAM.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92644,'MISSION INITIATED. DESTINATION COORDINATES RETRIEVED.','MISSION INITIATED. DESTINATION COORDINATES RETRIEVED.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92645,'PROGRAM COMMENCING. AUTO-DRIFT ENGAGE.','PROGRAM COMMENCING. AUTO-DRIFT ENGAGE.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92646,'RIFT DETECTED 1000 METERS AHEAD. MANUAL PILOT MODE INITIATED.','RIFT DETECTED 1000 METERS AHEAD. MANUAL PILOT MODE INITIATED.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92647,'Search high and low! Turn the ruins to rubble!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92648,'The Tidestone will be ours!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92649,'PILOT SYNCHRONIZATION REQUIRED. AWAITING MOVEMENT ORDERS.','PILOT SYNCHRONIZATION REQUIRED. AWAITING MOVEMENT ORDERS.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92650,'HOSTILE TARGET DETECTED.','HOSTILE TARGET DETECTED.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92651,'NEW MISSION: ELIMINATE ENEMY.','NEW MISSION: ELIMINATE ENEMY.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92652,'MISSION SUCCESSFUL. RETURN SEQUENCE INTITIATED.','MISSION SUCCESSFUL. RETURN SEQUENCE INTITIATED.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92653,'COMMENCING SHUTDOWN AND RETURN SEQUENCE.','COMMENCING SHUTDOWN AND RETURN SEQUENCE.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92654,'','I carry the finest selection of wines you\'ve ever seen.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92655,'','Oh look, \"nope\" and \"not a chance\" overlap right where you\'re standing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92656,'WARNING: PILOT EJECTED. SHUTDOWN SEQUENCE INITIATED.','WARNING: PILOT EJECTED. SHUTDOWN SEQUENCE INITIATED.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92657,'WARNING: NO INPUT DETECTED. COMMENCING AUTOMATIC SHUTDOWN SEQUENCE.','WARNING: NO INPUT DETECTED. COMMENCING AUTOMATIC SHUTDOWN SEQUENCE.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92662,'A quest accept event fires at this point.','A quest accept event fires at this point.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92663,'A quest completion event fires at this point.','A quest completion event fires at this point.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92664,'Cut down the intruder!','Cut down the intruder!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92665,'We are the Iron Horde! We will never be defeated!','We are the Iron Horde! We will never be defeated!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92666,'Kill them all, leave no survivors!','Kill them all, leave no survivors!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(92667,'Lok\'tar ogar!','Lok\'tar ogar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92668,'I\'ll take your head for a trophy!','I\'ll take your head for a trophy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92669,'Our will is Iron!','Our will is Iron!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92670,'It looks like this is where Val Goldspade\'s hunt for Gutrek\'s Cleaver came to an end.','It looks like this is where Val Goldspade\'s hunt for Gutrek\'s Cleaver came to an end.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92671,'Search the orc for clues','Search the orc for clues',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92672,'Take me to the Iron Docks.','Take me to the Iron Docks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92673,'Heating','Heating',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(92674,'Forging','Forging',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(92675,'Quenching','Quenching',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(92676,'Arise my lovelies, it\'s feeding time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92677,'My pets are so hungry.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92678,'You\'ll make an excellent treat.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92679,'You\'ll never take my pets from me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92680,'Try not to scream, my pets are sleeping.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92681,'Shhhhh, sleep now my precious.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92682,'You\'re so adorable when you\'re sleeping.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92683,'I won\'t let anything bad happen to you again, little one.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92684,'Return to the Start Banner!','Return to the Start Banner!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92685,'You want my blade, little $c?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92686,'How bout I plant it in your little skull!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(92687,'You are a fool for coming here, mortals. All of your accomplishments... all the foes you\'ve struck down... all mean nothing here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92688,'Feast, my minions. Bring me the Ashbringer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92689,'Your schemes are through, demon. We\'ve come to destroy you once and for all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92690,'I\'ve had enough of your meddling. This ends now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92691,'We stand together, champion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92692,'In this book are catalogued notes of your past relic hunts.\n\nIf at any point you happen to lose your way, you can consult these notes to pick up where you\'ve left off.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92694,'<The great dragon pulls in ragged breaths. He is in pain.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92695,'I\'m here! Oh what\'s this?','I\'m here! Oh what\'s this?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92696,'Hero... the Ashbringer... it is the only way... take it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92697,'You dare to come into my port and kill my soldiers? Come, face me and learn the might of the Iron Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92702,'Do you grunts have no pride? Train harder or I\'ll throw your worthless hides into the bay!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92703,'Gul\'dan will not tolerate weakness!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92704,'I swear that if you don\'t improve I\'ll make sure you peons will never obtain Gul\'dan\'s blessing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92705,'You\'re not trying hard enough. Half rations until you get it together!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92706,'Togg, next time you use da forge, remember to hammer da blade while it still nice and hot. \n\nIf you put da blade in da water before you hammer it, it just gonna break again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92707,'Time: $1i tolls','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92708,'Did that dying lizard and his brood send you? I shall not be bound again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92709,'You call that a trident swing?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92710,'Learn to fight you weakling water worms.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92711,'Keep that trident up you lazy sea snakes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92712,'So, the surface-dweller seeks to fly upon the golden wings of Rukhmar?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(92713,'A pity that you arrived too late. Now you must be punished for your insolence!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(92714,'Rukhmar\'s gifts belong to the Arakkoa!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92715,'Take me back to the garrison.','Take me back to the garrison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92716,'The iron siegeworks. We could steal some of their cannons.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92717,'The Iron Horde cowers behind their walls.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(92718,'There is a harbor there. Could we commandeer any boats?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92719,'The Iron Docks... yes, your earlier assault put it out of commission.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92720,'Use the |cFFE86B17|Hspell:179576|h[Net]|h|r to stop Tremor\'s submerge!','Use the |cFFE86B17|Hspell:179576|h[Net]|h|r to stop Tremor\'s submerge!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(92721,'','You have some nerve showing your face around here.',0,0,0,0,0,0,0,0,0,0,0,52758,26124),
(92726,'','For the Queen!',0,0,0,0,0,0,0,0,0,0,0,52703,26124),
(92727,'','We will claim the Tidestone and there is nothing you can do to stop us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92728,'','Azshara\'s wrath will drown you.',0,0,0,0,0,0,0,0,0,0,0,52706,26124),
(92729,'','Have you come to drown?',0,0,0,0,0,0,0,0,0,0,0,52700,26124),
(92730,'For Nazjatar!','',0,0,0,0,0,0,0,0,0,0,52685,0,26124),
(92731,'Your bones will sharpen my trident.','',0,0,0,0,0,0,0,0,0,0,52681,0,26124),
(92732,'You dare stand against us?','',0,0,0,0,0,0,0,0,0,0,52682,0,26124),
(92733,'%s sheds the net in which it was entangled!','%s sheds the net in which it was entangled!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92735,'The bomb has been planted. Stand clear!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92736,'3','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92737,'2','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92738,'1','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92739,'I will lead the diversion on the western gates and draw the Iron Horde forces to me. This will give you and Draka enough time to establish a base of operations on their flank.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92740,'Let us begin the invasion.','Let us begin the invasion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92741,'','You have no game tokens. Get at least one and then come back to me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92742,'The prisoners are breaking free!','',0,0,0,0,0,0,0,0,0,0,52688,0,26124),
(92743,'It\'s an uprising!','',0,0,0,0,0,0,0,0,0,0,52696,0,26124),
(92744,'Alright boys, this dock isn\'t going to clear itself! Get to work!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92745,'','I see that you\'re ready to race! Well step right up and we\'ll get you started.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92746,'True wisdom can only be reached when we focus as one.\n\nIt is then that the path will be opened.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92747,'Commander, what do you suggest?','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(92748,'Many would die in a direct assault.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(92749,'You look like you have another plan, Commander. A feint perhaps?','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(92750,'The waters are mined, and there are more soldiers than supplies there.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(92751,'Yes, but no shipbuilding materials. I think the commander is looking for a naval strategy.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(92752,'A shipyard. We could use the abandoned equipment there.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(92753,'Genius, commander! We\'ll sail around Tanaan and hit the Iron Horde from the sea where they least expect it.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(92754,'This appears to be the altar the ogres use to place offerings for the ancient rylaks. The bones of previous meals lay scattered about.\n\nIf you can find a proper offering, perhaps you could lure one of the rylaks down. \n\nThe bones may provide some clue as to what they would eat...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92755,'Place offering of raw clefthoof meat.','Place offering of raw clefthoof meat.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92756,'','This Real Big Race will reopen every 15 minutes. Be ready!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92757,'','The Real Big Race will reopen in 1 minute!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92758,'','The Real Big Race will reopen any second! Good luck!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92759,'You are like the wind!','You are like the wind!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92760,'I\'ll take care of this, commander.','I\'ll take care of this, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92761,'','Maraad would\'ve argued for a direct assault on the gates. But how could we hope to succeed?',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(92762,'','The rangari report that very little equipment remains for us to steal.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(92763,'','The orcs left behind some siege equipment here, at the Iron Siegeworks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92764,'','But heavy equipment remains. Enough to commandeer a ship!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(92765,'','The Iron Horde has regrouped behind fortified walls.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(92766,'Commander, what do you suggest?','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(92767,'The Iron Horde cowers behind their walls.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(92768,'The Thunderlord sage didn\'t make it very far through Magnarok. Hopefully he still possesses some useful information...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92769,'The Light watches over us all, friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92770,'After you, $n. Your presence is of the utmost importance.','',0,0,0,0,0,0,2,0,0,32449,0,0,26124),
(92771,'Rest in peace, brother... we will never forget the events of the Broken Shore.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92772,'Under Malygos\' command, these blue scaled beasts killed my friends, my family, and my wife.$b$bDo what you must with me, but know that I will never stop hunting them until they share the pain I feel.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92773,'I... I remember you. From Northrend. You helped me interrogate the foul minions of these blue scaled beasts.$b$bUnder Malygos\' command, they killed my friends, my family, and my wife, simply because they disagreed with our use of magic.$b$bDo what you must with me, but know that I will never stop hunting them until they share the pain I feel.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92774,'Let him live.','Let him live.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92775,'Finish him.','Finish him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92776,'Test line!','Test line!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(92777,'No! I must be allowed to end these creatures! I will have my revenge!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92778,'I will make your kind PAY for what you did in Northrend!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92779,'You blue-scaled lizard-breaths slew many of my friends in Northrend!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92780,'This is a fortified high-security bastion. Only a fool would go into there without an army.$b$bI mean... good luck, Champion.$b$b<Khadgar gives you a comforting pat on the shoulder.>','',6,0,0,0,0,0,0,0,4,0,0,0,26124),
(92781,'Compassion? It has been so long since I have known that. I will remember this, $r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92782,'%s is sounding the alarm!','%s is sounding the alarm!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92783,'Alarms sound! You\'ve been caught!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92784,'','Tirion said you would come. Is it time?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(92785,'Yes, it is time. We leave immediately.','Yes, it is time. We leave immediately.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92786,'','I am with you, $n. ((Liadrin runs outside))',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(92787,'This way!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92788,'You\'re safe. I\'ve got you.','',0,0,0,0,0,0,1,0,0,0,49609,0,26124),
(92789,'That was close. You should be more careful.','',0,0,0,0,0,0,1,0,0,0,49610,0,26124),
(92790,'Whoa now! I nearly didn\'t get you out in time.','',0,0,0,0,0,0,6,0,0,0,49611,0,26124),
(92791,'Let the youthful one approach. I am not as dead as I look.','',0,0,0,0,0,0,0,0,0,0,52850,0,26124),
(92792,'Forgive my granddaughters. They think they need to protect me from every $r $c that stumbles through my pools.$b$bGo on, then.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92793,'<Place your hand upon Senegos\' horn.>','<Place your hand upon Senegos\' horn.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92794,'','Rest now, grandfather! You must save your energy.',0,0,0,0,0,0,1,0,0,0,0,52869,26124),
(92795,'Don\'t be so eager to mourn, starlight. Give me this one last adventure.','',0,0,0,0,0,0,1,0,0,0,52856,0,26124),
(92796,'We should return to grandfather.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92797,'Let\'s get back to Azurewing Repose!','Let\'s get back to Azurewing Repose!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92798,'<Before you stands... not Senegos himself, but a magical projection of him. He appears strong, confident, and cheerful. This is not the decaying dragon you saw languishing in a pool.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92799,'<As you approach the ravager, a high-pitched, chittering voice echoes in your mind.>\n\nYou drink the seeing juice, and now you speak! You must be friend of the skull-head. \n\nYou here to take skulls too?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92800,'Can you take me to Skulltaker?','Can you take me to Skulltaker?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(92801,'Avoid the darkness, friend. Your mind-sight is fragile.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92802,'You have skulls? Gu\'rakh can carry all skulls!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92803,'Friend want Gu\'rakh. Can take you to high place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92804,'Follow us. We show!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92805,'Wrong way, two-leg! Turn around!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92806,'Friend brings more skulls to pick clean?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92807,'Do not stray, friend. The ground-walkers will lead the way.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92808,'Gu\'rakh very close! Take all the skulls!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92813,'So, this one wishes to find the Skulltaker?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92814,'Very well, I will bring you to him.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92815,'Take care, $C, lest it be your skull that is taken.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92816,'Show me what contracts are available.','Show me what contracts are available.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(92817,'I seek the seeker.','I seek the seeker.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92818,'Come one, come all, and witness history in the making! Today we have an exhibition match in the the bloodiest place in Draenor, the Ring of Blood! We have a real treat for you today. $n and their friends will take on Mogor\'s newest, exclusive find. Ousted from Highmaul, completely blind but with a special sense for magic, it\'s the one and only Nullifier Darkoor!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(92819,'Let the exhibition match BEGIN!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(92820,'WHAT YOU CALL ME?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92821,'Hm, not bad. Take your prize from my coffer. You live... for now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92822,'[PH] I NEED TEXT','[PH] I NEED TEXT',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92823,'I\'m ready to leave when you are, $n.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(92824,'Then let us make haste.','Then let us make haste.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92825,'Very good. I will meet you at the Highlord. ((Gryan runs outside))','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(92826,'No. NO! I will tolerate no more setbacks!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92827,'Kaboom!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(92828,'Brewing Elixir','Brewing Elixir',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(92829,'I will meet you outside and prepare our mounts. I formed the Order of the Silver Hand to defeat the Burning Legion - this will be its first charge.((Tirion walks outside))','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(92830,'Free the outcasts from their shackles, the Labormasters will definitely have keys.','Free the outcasts from their shackles, the Labormasters will definitely have keys.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92831,'Guide freed Outcasts to the safety of the Darkscryers. Their morale will be added to your progress.','Guide freed Outcasts to the safety of the Darkscryers. Their morale will be added to your progress.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92832,'Kills made with freed Arakkoa Outcasts in tow will increase their morale. Morale is added to your progress when you guide the freed Arakkoa Outcasts to safety.','Kills made with freed Arakkoa Outcasts in tow will increase their morale. Morale is added to your progress when you guide the freed Arakkoa Outcasts to safety.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92833,'If a freed Arakkoa Outcast expires before being led to safety its morale will be lost.','If a freed Arakkoa Outcast expires before being led to safety its morale will be lost.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92834,'Higher morale scores will greatly increase your progress when the Arakkoa Outcast is led to safety.','Higher morale scores will greatly increase your progress when the Arakkoa Outcast is led to safety.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92835,'You are afflicted with |TInterface\\Icons\\Spell_Shadow_ChillTouch.blp:20|t |cFFFF0404|Hspell:179977|h[Touch of Doom]|h|r!','You are afflicted with |TInterface\\Icons\\Spell_Shadow_ChillTouch.blp:20|t |cFFFF0404|Hspell:179977|h[Touch of Doom]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(92836,'Stay close to Garona, and stay out of sight!','',0,0,0,0,0,0,1,0,0,0,49607,0,26124),
(92837,'I will teleport you out of there if you get into trouble.','',0,0,0,0,0,0,274,0,0,0,49608,0,26124),
(92838,'','Discipline is lax. Your campaign against the Iron Horde is wearing them down.',0,0,0,0,0,0,0,0,0,0,0,49632,26124),
(92839,'','Bleeding Hollow scavengers. We should crush them before they threaten our supply lines.',0,0,0,0,0,0,396,0,0,0,0,50342,26124),
(92840,'','What was THAT?',0,0,0,0,0,0,0,0,0,0,0,49629,26124),
(92841,'','Grrr! We were almost through.',0,0,0,0,0,0,0,0,0,0,0,49630,26124),
(92842,'','Bah! We can do better.',0,0,0,0,0,0,0,0,0,0,0,49631,26124),
(92843,'Hiding','Hiding',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(92844,'','We\'re ready when you are, Highlord.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(92845,'','Gul\'dan\'s thugs are up to something. I do not know what they are planning so near the Dark Portal, but they are in the way.',0,0,0,0,0,0,396,0,0,0,0,50344,26124),
(92846,'','Jackpot! Iron Horde plans and papers...',0,0,0,0,0,0,1,0,0,0,0,49636,26124),
(92847,'','Grommash ordered a full retreat behind the walls of Tanaan.',0,0,0,0,0,0,25,0,0,0,0,49637,26124),
(92848,'','Interesting. The Bleeding Hollow clan are showing signs of insubordination. Perhaps the Iron Horde is falling apart?',0,0,0,0,0,0,6,0,0,0,0,49638,26124),
(92849,'We will leave on your command, friend.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(92850,'[[Spectacular Cinematic of Gul\'dan Being a BOSS!]]','[[Spectacular Cinematic of Gul\'dan Being a BOSS!]]',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(92851,'Bah, these cannons are WORTHLESS! Face our latest creation, the Fel Orc!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(92852,'The Legion thinks we are finished. We will show them how wrong they are.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92853,'','After you, $n. Your presence is of the utmost importance.',0,0,0,0,0,0,2,0,0,32450,0,0,26124),
(92854,'Entering','Entering',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(92855,'Ahh, my friend. My good, dependable friend $n.$b$bYou wouldn\'t happen to have any mana crystals on you, would you?$b$bListen, my friend. If you ever need anything - I stress, ANYTHING - you just come talk to your loyal friend Runas. I will make your problems go away. You can count on me.$b$bOf course, if I needed something, I assume you would assist me, correct? For example, if I needed a mana crystal or something similar, you would give me one?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92856,'Just... just lead the way, Runas.','Just... just lead the way, Runas.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92857,'The Warchief does not want to see you.','',0,0,0,0,0,0,274,0,0,0,49613,0,26124),
(92858,'Come, Warlock. Show us what you\'ve got.','',0,0,0,0,0,0,11,0,0,0,49614,0,26124),
(92859,'He doesn\'t have a choice.','',0,0,0,0,0,0,1,0,0,0,49640,0,26124),
(92860,'Gul\'dan has only grown in power since our last encounter. He must still have contact with the Burning Legion. Stopping him is more important than ever.','',0,0,0,0,0,0,1,0,0,0,49612,0,26124),
(92861,'','Over here, commander!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(92862,'','This be a prime spot. We can see for miles. Plant your banner, commander.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(92863,'','We on our way!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(92864,'You need a Darkmoon Game Token to start the race!','You need a Darkmoon Game Token to start the race!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92865,'-1 Darkmoon Game Token','-1 Darkmoon Game Token',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92866,'Bonus Objective Unlocked!\n|TINTERFACE\\GLUES\\CREDITS\\CrystalSong1TGA1.blp:64|t|TINTERFACE\\GLUES\\CREDITS\\CrystalSong1TGA2.blp:64|t|TINTERFACE\\GLUES\\CREDITS\\CrystalSong1TGA3.blp:64|t\n|TINTERFACE\\GLUES\\CREDITS\\CrystalSong1TGA5.blp:64|t|TINTERFACE\\GLUES\\CREDITS\\CrystalSong1TGA6.blp:64|t|TINTERFACE\\GLUES\\CREDITS\\CrystalSong1TGA7.blp:64|t\n|cFFFFFFFFLey-Ruins of Zarkhenar|r','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(92867,'What in blazes are you doing?','',0,0,0,0,0,0,0,0,0,0,52823,0,26124),
(92868,'Don\'t you know who I am?','',0,0,0,0,0,0,0,0,0,0,52826,0,26124),
(92869,'I surrender. Please, my friend, forgive me. I am truly, truly sorry.','',0,0,0,0,0,0,0,0,0,0,52835,0,26124),
(92870,'Feeding on such raw energy... it clouds my judgment.','',0,0,0,0,0,0,0,0,0,0,52824,0,26124),
(92871,'I hope you can see beyond my tattered robes and desperate behavior. I am not a monster.','',0,0,0,0,0,0,0,0,0,0,52827,0,26124),
(92872,'You go on, my friend. I will stay here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92873,'Thank you, my friend, for letting my last few hours mean something.','',0,0,0,0,0,0,0,0,0,0,62765,0,26124),
(92874,'Watch. I shall prove it to you. I am not just some mana-addled FREAK, like the rest of those wretches.','',0,0,0,0,0,0,0,0,0,0,52828,0,26124),
(92875,'Ooh, look! Mana crystal! Just a taste.','',0,0,0,0,0,0,0,0,0,0,52836,0,26124),
(92876,'I think... perhaps it is time to say goodbye, then.','',0,0,0,0,0,0,0,0,0,0,62764,0,26124),
(92877,'Quite an impressive weapon, my friend!','',0,0,0,0,0,0,0,0,0,0,52838,0,26124),
(92878,'I... I can not see you anymore.','',0,0,0,0,0,0,0,0,0,0,62763,0,26124),
(92879,'Who is this?','',0,0,0,0,0,0,0,0,0,0,52812,0,26124),
(92880,'I am called Runas, son of Indarril, formerly of Suramar. Pleased to make your acquaintance.','',0,0,0,0,0,0,0,0,0,0,52842,0,26124),
(92881,'Nightfallen. I do not trust you and your kind.','',0,0,0,0,0,0,0,0,0,0,52815,0,26124),
(92882,'I understand, good dragon. My people have earned your distrust. Allow me to make amends.','',0,0,0,0,0,0,0,0,0,0,52844,0,26124),
(92883,'Very good! Off to Zarkhenar, then. Off to see all my friends and family and loved ones.','',0,0,0,0,0,0,0,0,0,0,52832,0,26124),
(92884,'...to kill them, of course, for harming your dragon.','',0,0,0,0,0,0,0,0,0,0,52845,0,26124),
(92885,'Bunch of mana addicts, that lot, ha hah! Not me, though. My discipline is iron.','',0,0,0,0,0,0,0,0,0,0,52818,0,26124),
(92886,'Ooh! Mana crystal. Just a moment.','',0,0,0,0,0,0,0,0,0,0,52839,0,26124),
(92887,'So... why are you here in Azsuna, friend? Just visiting, or...?','',0,0,0,0,0,0,0,0,0,0,52833,0,26124),
(92888,'Does this one ever stop talking?','',0,0,0,0,0,0,0,0,0,0,52814,0,26124),
(92889,'My apologies, good dragon. Ahh, look! We are here.','',0,0,0,0,0,0,0,0,0,0,52837,0,26124),
(92890,'This hunger is consuming my very mind. It is taking every ounce of my energy to just... just...','',0,0,0,0,0,0,0,0,0,0,62761,0,26124),
(92891,'','Not like this...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92892,'','Another one down.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92893,'','Swift and silent...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92894,'','I love the hunt!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92895,'','You\'re finished.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92896,'','The hunt begins!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92897,'','Leave this one to me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92898,'','You\'ve come to the wrong house, puppet.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92899,'','Any last words?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92900,'','I am all yours, commander.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(92901,'','Who\'s next...?',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(92902,'','Give me a target, commander. I am ready for anything.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(92903,'','None can oppose us! Not Gul\'dan, not the Shadow Council, not even the Legion itself.',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(92904,'','I cannot thank you enough for what you and Khadgar have done for me. I am yours to command.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(92905,'|TInterface\\Icons\\inv_blacksmithdye_black.blp:20|t %s dropped |cFFFF0000|Hspell:180147|h[Felfire Munitions]|h|r.','|TInterface\\Icons\\inv_blacksmithdye_black.blp:20|t %s dropped |cFFFF0000|Hspell:180147|h[Felfire Munitions]|h|r.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92906,'We must find a way to break into Tanaan again!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(92907,'','I long to spill the blood of our foes, but I can be patient when I need to.',0,0,0,0,0,0,595,0,0,0,0,0,26124),
(92908,'Those walls boss... and those orcs in the way... woo boy!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(92909,'If there\'s anyone that can crack this nut, its you, commander.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(92910,'They just leave this stuff laying around? Sweet!','They just leave this stuff laying around? Sweet!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92911,'I\'ll have this outta here in a jiffy, boss!','I\'ll have this outta here in a jiffy, boss!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92912,'','$C, the Burning Legion is sending the most powerful demons in its arsenal against us. They do not intend to lose this third war and they will stop at nothing to see to it that we are all wiped from the face of Azeroth.\n\nWe will return the favor.',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(92913,'','Looters are not welcome here! This belongs to the Iron Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92914,'','It... makes... no difference...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92915,'','This is Iron Horde property! You will pay for trying to take it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92916,'','Hate you... hate you all...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92917,'This\'ll be quite tha siege, commander!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(92918,'We are ready to put an end to this commander, no matter the cost.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(92919,'I understand the need to defeat this foe, but my heart breaks for the lives it will take from us.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(92920,'','I prefer to go around such problems, and I think you do too, commander.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(92921,'','I\'m still unfamiliar with such strategy, such numbers. We must do our best to minimize casualties, our soldiers deserve better.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(92922,'','Just give me a moment...',0,0,0,0,0,0,0,0,0,0,0,57180,26124),
(92923,'These will help immensely, commander.','These will help immensely, commander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92924,'This is a great find, commander!','This is a great find, commander!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92925,'I\'d like to fight Skull Chewer.','I\'d like to fight Skull Chewer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92926,'I\'d like to fight Fracktus.','I\'d like to fight Fracktus.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92927,'I\'d like to fight Rotvine.','I\'d like to fight Rotvine.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92928,'I\'d like to fight Dreshax.','I\'d like to fight Dreshax.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92929,'I\'d like to fight the champion.','I\'d like to fight the champion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92930,'You\'ll have to hold on a minute, pal. I can\'t start the next fight until this one\'s finished.$B$BI may be a profiteering heartless fight promoter leading countless innocents to their untimely deaths, but I have a conscience for coin\'s sake.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(92931,'','How strange that Gul\'dan\'s Horde has all but abandoned this area. I was expecting more of a fight.',0,0,0,0,0,0,396,0,0,0,0,50341,26124),
(92932,'','The Bleeding Hollow are running rampant out here. Where is their leadership?',0,0,0,0,0,0,396,0,0,0,0,50343,26124),
(92933,'','What foul magic was that warlock cooking up? I think I preferred fighting Iron Horde cannons!',0,0,0,0,0,0,396,0,0,0,0,50345,26124),
(92934,'','I take back what I said about cannons. We\'ll have to fight our way through.',0,0,0,0,0,0,396,0,0,0,0,50346,26124),
(92935,'Here\'s your share of the winnings, champ!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(92936,'Drawing Power','Drawing Power',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92937,'They did... things... to me.','',0,0,0,0,0,0,0,0,0,32377,52710,0,26124),
(92938,'I didn\'t give in.','',0,0,0,0,0,0,0,0,0,32376,52711,0,26124),
(92939,'The demons promised us unimaginable power.','',0,0,0,0,0,0,0,0,0,32378,51887,0,26124),
(92940,'A warden tried to convince us to turn traitor. I heard screaming.','',0,0,0,0,0,0,0,0,0,32379,52712,0,26124),
(92941,'Cyana Nightglaive turned traitor. She joined the Legion.','',0,0,0,0,0,0,0,0,0,32380,52708,0,26124),
(92942,'Nightglaive went southwest with a warden named Cordana Felsong.','',0,0,0,0,0,0,0,0,0,32381,52709,0,26124),
(92943,'All will be consumed in my flames!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92944,'|TInterface\\Icons\\ability_fixated_state_purple:20|t%s |cFFFF0404|Hspell:180148|h[Fixates]|h|r on you!','|TInterface\\Icons\\ability_fixated_state_purple:20|t%s |cFFFF0404|Hspell:180148|h[Fixates]|h|r on you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92945,'Graaah, and who do YOU think you are?','',0,0,0,0,0,0,0,0,0,0,49619,0,26124),
(92946,'Give yourselves to the shadow. None can resist the master.','',0,0,0,0,0,0,0,0,0,0,49623,0,26124),
(92947,'All must serve or DIE.','',0,0,0,0,0,0,0,0,0,0,49620,0,26124),
(92948,'You will not leave this cave alive!','',0,0,0,0,0,0,0,0,0,0,49624,0,26124),
(92949,'Throw the corpse to the felhounds, hah hah hah!','',0,0,0,0,0,0,0,0,0,0,49622,0,26124),
(92950,'Take me to the Iron Front.','Take me to the Iron Front.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92951,'','Watch yourself, champion. The Shadow Council will prey on your doubts and weaknesses.',0,0,0,0,0,0,1,0,0,0,0,49598,26124),
(92952,'Play \"Ironforge\"','Play \"Ironforge\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92953,'Play \"Cold Mountain\"','Play \"Cold Mountain\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92954,'Play \"Night Song\"','Play \"Night Song\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92955,'','I can feel the dark energy surrounding you. What IS that thing?',0,0,0,0,0,0,1,0,0,0,0,49593,26124),
(92956,'Play \"Gnomeregan\"','Play \"Gnomeregan\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92957,'Play \"Tinkertown\"','Play \"Tinkertown\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92958,'Play \"Exodar\"','Play \"Exodar\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92959,'Play \"Curse of the Worgen\"','Play \"Curse of the Worgen\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92960,'Play \"Way of the Monk\"','Play \"Way of the Monk\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92961,'Play \"Song of Liu Lang\"','Play \"Song of Liu Lang\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92962,'Play \"Angelic\"','Play \"Angelic\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92963,'Play \"Ghost\"','Play \"Ghost\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92964,'Play \"Jungle.\"','Play \"Jungle.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92965,'Play \"Magic\"','Play \"Magic\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92966,'Play \"The Black Temple\"','Play \"The Black Temple\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92967,'Play \"Invincible\"','Play \"Invincible\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92968,'Play \"Bronze Jam.\"','Play \"Bronze Jam.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92969,'These new fel orcs fight hard. This will not be over soon...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92970,'We began our siege the moment you took the boats. We fought cautiously until a large contingent of Iron Horde left, probably to face you. That is when we truly struck!$b$bYour Gazlowe fashioned a terrible device to destroy the gates and we charged through... only to be met with this new foe... the fel orcs. They have managed to stop our advance and keep us here. I hope you are having better luck in the east.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92971,';p;','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92972,'What\'s the situation?','What\'s the situation?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92973,'Eating','Eating',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(92974,'Kaz said I could help! This place is so cool!$b$bI can tell you about Zeth\'Gol to the northwest, the Temple of Sha\'naar to the south, and the Zorammarsh to the southeast.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92975,'Uh okay... so what do you have for me Scout Cutter?','Uh okay... so what do you have for me Scout Cutter?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92976,'Yeah! So these Bleeding Hollow guys are almost as dangerous as Laughing Skull, but they spend too much time looking at the skies. They have tons of traps and hunt like raptors in the jungle. Deeper in their town they are doing weird things with blood and magic.$b$bI think sending a magnaron through the center of this village would do it a lot of good!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92977,'Commander beware! The Sargerei are here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92978,'The Sargerei? What\'s going on up there?','The Sargerei? What\'s going on up there?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92979,'They\'ve slaughtered the civilians there some time ago. I couldn\'t get too close but they are corrupting the wildlife with fel energy and summoning demons.$b$bThis fallen village should be razed to the ground, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92980,'','Stellagosa, no... come back. Damn!',0,0,0,0,0,0,22,0,0,0,0,57398,26124),
(92981,'Hey commandah. De arakkoa are here in Aktar\'s Watch. Also I checked out that big tunnel to de southeast there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92982,'What are the arakkoa doing here? And who is this?','What are the arakkoa doing here? And who is this?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92983,'Dis be Aktar. De followers of Sethe an\' the Shadow Council be gatherin\' in tha ruins near here and he be keepin\' a eye on em. Also mo\' a da flyin\' arakkoa are here causing trouble. Der be a lot of bird poop to clean up here.$b$bAlso if ya need to head east, dere\'s a big tunnel to the southeast, take ya right to Ironhold Harbor. Might be dangerous though.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92984,'Now it be time to demonstrate what we learned!','Now it be time to demonstrate what we learned!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92985,'How dare you interrupt my instruction!','How dare you interrupt my instruction!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92986,'Ah... I can use your soul for the next lesson!','Ah... I can use your soul for the next lesson!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92987,'Commander! I have news! I can tell you about Ironhold Harbor, the Fel Forge, and the Throne of Kil\'jaeden.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92988,'Tell me what occurs at Ironhold Harbor.','Tell me what occurs at Ironhold Harbor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92989,'It appears Gul\'dan is calling in all Iron Horde from across Draenor. They come in from the harbor on ships... then they go east... to the pits.$b$bThere they are... converted... into fel orcs. It is horrible. We must destroy this place at once!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92990,'Was this your friend? He died well... saved me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92991,'What happened here?','What happened here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92992,'Your warrior tried to save me but my captors caught up with us. I am sorry for your friend.$b$bUp on the mountain a powerful demon was slain by Grommash. It was left alone for some time but the Iron Horde has a new master... one with renewed interest. Minions of Gul\'dan summon demons and keep the fel corrupted waters flowing.$b$b It is extremely dangerous up there, you should not go alone.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92993,'Greetings, is there something I can help you with?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92994,'You are Lagar? I bring word from a shaman of your order. He says... Gul\'dan knows. May I ask what this means?','You are Lagar? I bring word from a shaman of your order. He says... Gul\'dan knows. May I ask what this means?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92995,'Thank you friend. It means that an ancient secret has been revealed to the worst person possible.$b$bI will need to summon the rest of my order to defend it.$b$bYou lead the army that opposes Gul\'dan? You are welcome here and we will assist where we can. We are few, but are well respected by the elemental forces of Draenor.$b$bWe will speak of this secret later. Go in peace.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92996,'Very painful to be hit with.','',0,0,0,0,0,0,0,0,0,0,52831,0,26124),
(92997,'You... you are beginning to ANGER ME!!','',0,0,0,0,0,0,0,0,0,0,52843,0,26124),
(92998,'<The great dragon acknowledges you with a smile.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(92999,'Urgent message for Senegos!','',0,0,0,0,0,0,0,0,0,0,52582,0,26124),
(93000,'The Nightfallen have assaulted the whelplands.','',0,0,0,0,0,0,0,0,0,0,52583,0,26124),
(93001,'These four whelplings need to be treated with ley crystals immediately.','',0,0,0,0,0,0,0,0,0,0,52579,0,26124),
(93002,'You are a kind small thing, $n.','',0,0,0,0,0,0,0,0,0,0,52847,0,26124),
(93003,'','Where did Cyana Nightglaive go? I need to find her!',0,0,0,0,0,0,0,0,0,32381,0,57186,26124),
(93004,'Wait... what is that you\'re holding?','',0,0,0,0,0,0,0,0,0,0,52840,0,26124),
(93005,'I\'LL KILL YOU! I\'LL RIP OUT YOUR HEART!','',0,0,0,0,0,0,0,0,0,0,52841,0,26124),
(93006,'Come to free that pitiful drake, demon hunter?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93007,'','Feel the fel energy course through...',0,0,0,0,0,0,0,0,0,0,0,52659,26124),
(93008,'','We\'ve been expecting you, $p. How is Khadgar?',0,0,0,0,0,0,0,0,0,0,0,52662,26124),
(93009,'','We\'ve dealt them a telling blow. But even now, the Legion is summoning in more powerful demons.',0,0,0,0,0,0,0,0,0,0,0,57406,26124),
(93010,'','Felsworn Nightglaive, prove yourself. I have other matters to attend to.',0,0,0,0,0,0,0,0,0,0,0,52660,26124),
(93011,'','Yes, my mistress...',0,0,0,0,0,0,0,0,0,0,0,52764,26124),
(93012,'','We cannot allow them to regain their momentum or the Broken Isles are lost.',0,0,0,0,0,0,0,0,0,0,0,57413,26124),
(93013,'','What\'s he talking about? Meet me outside the gem.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93014,'','You WILL talk, foul demon!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93015,'','You are no demon. Friend or foe?',0,0,0,0,0,0,0,0,0,0,0,56343,26124),
(93016,'','I am more powerful than all of you!',0,0,0,0,0,0,0,0,0,0,0,52766,26124),
(93017,'','Cyana. Do not give in!',0,0,0,0,0,0,0,0,0,0,0,57402,26124),
(93018,'','I have to find Stellagosa and Cyana Nightglaive.',0,0,0,0,0,0,0,0,0,0,0,57401,26124),
(93019,'','Meet me up at the overlook. We will finish this business together.',0,0,0,0,0,0,0,0,0,0,0,57446,26124),
(93020,'','$p, let\'s get out of here before we\'re overrun.',0,0,0,0,0,0,0,0,0,0,0,57407,26124),
(93021,'','A warden working for the Legion? I look forward to killing her.',0,0,0,0,0,0,0,0,0,32381,0,57187,26124),
(93023,'','You stand in one of the great wonders of the world.$b$bOur wine is made of the finest fruits, and our oils the finest of olives.$b$bI dare anyone to claim they have better.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93024,'Gather what you need and meet me outside the entrance.','',0,0,0,0,0,0,1,0,0,0,49606,0,26124),
(93025,'','You will soon be free, drake.',0,0,0,0,0,0,0,0,0,0,0,57397,26124),
(93026,'Come with me. This is exactly what I need to undo Gul\'dan\'s hold on Garona.','',0,0,0,0,0,0,1,0,4,0,49599,0,26124),
(93027,'We\'re using the tools of our enemy against them.','',0,0,0,0,0,0,1,0,4,0,49600,0,26124),
(93028,'Not \'til my dying breath. I will end your torment, Garona.','',0,0,0,0,0,0,274,0,4,0,49601,0,26124),
(93029,'Om na ka om, Fel na om kal...','',0,0,0,0,0,0,0,0,4,0,49602,0,26124),
(93030,'Quickly, destroy that thing!','',0,0,0,0,0,0,5,0,4,0,49603,0,26124),
(93031,'Awaken, Garona. You are free at last.','',0,0,0,0,0,0,1,0,4,0,49604,0,26124),
(93032,'Come with me, Garona. Together we will plan for Gul\'dan\'s downfall.','',0,0,0,0,0,0,1,0,4,0,49605,0,26124),
(93033,'','Archmage. That is dark magic you\'re working with.',0,0,0,0,0,0,1,0,4,0,0,49594,26124),
(93034,'','You are using the tools of our enemy!',0,0,0,0,0,0,1,0,4,0,0,49595,26124),
(93035,'','I do not like this.',0,0,0,0,0,0,1,0,4,0,0,49596,26124),
(93036,'','Give me that orb, Khadgar. I will destroy that hideous thing.',0,0,0,0,0,0,1,0,4,0,0,49597,26124),
(93037,'','Haven\'t you given up already, mage?',0,0,0,0,0,0,1,0,4,0,0,49625,26124),
(93038,'','%s gasps in pain.',0,0,0,0,0,0,0,0,4,0,0,49626,26124),
(93039,'','Gul\'dan... he\'s not in my head anymore...',0,0,0,0,0,0,274,0,4,0,0,49627,26124),
(93040,'','I owe everything to you! To both of you!',0,0,0,0,0,0,1,0,4,0,0,49628,26124),
(93041,'','I will do whatever it takes to stop Gul\'dan. Wherever you lead, I will follow... commander!',0,0,0,0,0,0,66,0,4,0,0,49639,26124),
(93042,'Let\'s try this again. For Garona!','Let\'s try this again. For Garona!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93043,'','Lookin\' to learn something?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93044,'','You are unworthy of our craft!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93045,'','My wine is only for the queen.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93046,'','Begone from this place. Our works are not for the lowly likes of you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93047,'You should not be here.','',0,0,0,0,0,0,0,0,0,0,52727,0,26124),
(93048,'This place is not for you.','',0,0,0,0,0,0,0,0,0,0,52728,0,26124),
(93049,'We remember the queen.','',0,0,0,0,0,0,0,0,0,0,52726,0,26124),
(93050,'For Azshara!','',0,0,0,0,0,0,0,0,0,0,52729,0,26124),
(93051,'Your soul will be made to serve!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93052,'Death cannot take... its master...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93053,'','The Shadowmoon will break you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93054,'','The crystal... is mine...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93055,'The void will claim you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93056,'I return to the nether...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93057,'I\'ll blast you to pieces!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93058,'Shoulda... brought more... rockets...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93059,'No one beat Gutrek... no one...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93060,'I lost track of Garona.','I lost track of Garona.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93061,'Play Default Garrison Music','Play Default Garrison Music',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93062,'Play \"Mountains of Thunder\"','Play \"Mountains of Thunder\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93063,'I\'ve lost my Theramore Tabard.','I\'ve lost my Theramore Tabard.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(93064,'Reigniting','Reigniting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(93065,'Play \"Karazhan Opera House\"','Play \"Karazhan Opera House\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93066,'Play \"The Argent Tournament\"','Play \"The Argent Tournament\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93067,'Play \"Lament of the Highborne\"','Play \"Lament of the Highborne\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93068,'Play \"Faerie Dragon\"','Play \"Faerie Dragon\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93069,'Play \"Totems of the Grizzlemaw\"','Play \"Totems of the Grizzlemaw\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93071,'Play \"Darkmoon Carousel\"','Play \"Darkmoon Carousel\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93072,'Play \"Shalandis Isle\"','Play \"Shalandis Isle\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93073,'Excellent, you\'re getting better! Soon you will be ready to summon your first imp!','',274,396,0,0,3,0,0,0,0,0,0,0,26124),
(93074,'Keep your focus and bend the chaos to your will.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93075,'You mind must be strong, like ogre! If you weak then you die. Our path be that simple.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93080,'Hold on for just a moment while I unlock the seal.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93082,'Ish valah, wynn talos...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93083,'Aha! There we are.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93084,'Follow me, $n. I read all about this place when I was studying to join the Kirin Tor. I\'ll show you around.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93086,'Sarim!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93087,'This is the portrait room. Each picture works as a portal.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93088,'We can direct them almost anywhere on Azeroth we need to go. It is with these that we will gather the resources we need to defeat the Legion.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93089,'Now, let us discuss where our efforts are best focused.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93090,'$B***** RULES OF THE GAME *****\n$B$GHe:She; who starts the game will be the|cFF990000 Seeker|r and gain the ability to|cFF2959D3 Tag|r party members. All other party members will gain the ability to|cFF2959D3 Hide|r.\n$BThe |cFF990000 Seeker|r has 60 seconds from the time the game begins to find and|cFF2959D3 Tag|r a party member.\n$BHidden party members will be revealed if they move OR if the|cFF990000 Seeker|r draws near. Players who can reach home base without being|cFF2959D3 Tagged|r win!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93091,'I... am... awakened!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93092,'','Are you injured?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93093,'Fortune and glory, kid. Fortune and Glory.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(93094,'I\'m like a bad penny. I always turn up.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(93095,'I\'m making this up as I go!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(93096,'I\'ll give ya a tip, kid. \"X\" never, ever marks the spot.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(93097,'Thank the Light I found you! Please wait a moment, champion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93098,'Highlord Tirion sent me to find you. He needs to see you right away!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93099,'Fortunately I kept some of these handy. It had to be snakes!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(93100,'Too good to be... true.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(93101,'See ya around... kid...','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(93102,'Fortune and... glory...','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(93103,'He chose... poorly.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(93104,'I hate snakes, kid. I hate\'em!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(93105,'This looks dangerous. You go first!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(93106,'Leave this one to me!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(93107,'You call THIS archaeology?','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(93108,'Nothing surprises me, commander. I\'m a scientist.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(93109,'Have you found any more artifacts, commander?','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(93110,'You need my help with anything today, commander?','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(93111,'This is gonna get nasty.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(93112,'The Kirin Tor is here to help! When I\'m fully-implemented, I\'ll help you close a rift and give you something good if I survive!','The Kirin Tor is here to help! When I\'m fully-implemented, I\'ll help you close a rift and give you something good if I survive!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93113,'Sargeras sends forces against you!','Sargeras sends forces against you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93114,'','I overestimated my strength. All of the dragons - even the Aspects themselves - have been greatly weakened since the fall of Deathwing.',0,0,0,0,0,0,0,0,0,0,0,52876,26124),
(93115,'','My grandfather is the last among us that clings to any magical power. Do you really want him to expend it all on this Tidestone?',0,0,0,0,0,0,0,0,0,0,0,52873,26124),
(93116,'After you, $n. Your presence is of the utmost importance.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(93117,'','After you, $n. Your presence is of the utmost importance.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(93118,'','Thank the Light I found you! Please wait a moment, champion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93119,'','Highlord Tirion sent me to find you. He needs to see you right away!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93120,'We\'re ready to begin!','We\'re ready to begin!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93121,'My keepers are overrun. We will require aid.','',0,0,0,0,0,0,0,0,0,0,52580,0,26124),
(93122,'Is your party ready to begin?','Is your party ready to begin?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93123,'Stellagosa. Do me one last favor. Your younger brothers and sisters need your help.','',0,0,0,0,0,0,0,0,0,0,52855,0,26124),
(93124,'10...','10...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93125,'','Of course.',0,0,0,0,0,0,0,0,0,0,0,52868,26124),
(93126,'9...','9...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93127,'8...','8...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93128,'','Farewell, grandfather.',0,0,0,0,0,0,0,0,0,0,0,52872,26124),
(93129,'7...','7...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93130,'See you soon, starlight.','',0,0,0,0,0,0,0,0,0,0,52853,0,26124),
(93131,'6...','6...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93132,'5...','5...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93133,'4...','4...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93134,'3...','3...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93135,'2...','2...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93136,'1...','1...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93137,'Ready or not, here I come!','Ready or not, here I come!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93138,'%s begins to count down. Find a hiding spot!','%s begins to count down. Find a hiding spot!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93139,'%s was unable to tag any players! The Hiders win!','%s was unable to tag any players! The Hiders win!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93140,'%s has tagged $n, the Seeker wins!','%s has tagged $n, the Seeker wins!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93141,'%s has reached home base! $GHe:She; is safe!','%s has reached home base! $GHe:She; is safe!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93144,'Ah, that\'s the stuff!','Ah, that\'s the stuff!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93145,'Thanks - my back has been killing me since the crash.','Thanks - my back has been killing me since the crash.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93146,'Exactly what I needed!','Exactly what I needed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93147,'This stuff isn\'t habit-forming, right?','This stuff isn\'t habit-forming, right?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93148,'I owe ya one - and Mishka, too!','I owe ya one - and Mishka, too!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93149,'Gah, I hate needles! But... that does feel nice.','Gah, I hate needles! But... that does feel nice.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93150,'I could fight all day. Bring it!','I could fight all day. Bring it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93151,'Another Nightfallen attack? Bring my child to me, young one.','',0,0,0,0,0,0,0,0,0,0,52857,0,26124),
(93152,'My poor, poor children. We can\'t afford to lose a single one of you.','',0,0,0,0,0,0,0,0,0,0,52863,0,26124),
(93153,'Very good, soon you will be ready for the next lesson.','Very good, soon you will be ready for the next lesson.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93154,'Let the dark power flow through you. Focus it!','Let the dark power flow through you. Focus it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93155,'The ritual is weakening, try harder!','The ritual is weakening, try harder!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93156,'Gul\'dan will be pleased when I bring him your soul!','Gul\'dan will be pleased when I bring him your soul!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93157,'The masters come!','The masters come!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93158,'The Sethekk will rise again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93159,'We have been shown the path to true power!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93160,'We serve a new master now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93161,'The master demands a sacrifice!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93162,'Let me show you what I\'ve learned.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93163,'So... much... blood! Death to the enemies of the Bleeding Hollow!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93165,'Play \"Mountains\"','Play \"Mountains\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93166,'I will slay those that disrupt our rituals! Prepare for death!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93167,'Play \"Orgrimmar\"','Play \"Orgrimmar\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93168,'Night falls...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93169,'We will rise again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93170,'I\'ll drag you down with me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93171,'I\'ll make you kneel.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93172,'I found it first!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93173,'Get back! It\'s mine... MINE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93174,'Don\'t look at me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93175,'Stay back! Stay back!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93176,'','No... NO! I still thirst. Give me more!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93177,'','So... thirsty...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93178,'Kneel, lowborn scum!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93179,'This cannot be! I had it all...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93180,'What\'s this? Have the peasants come to grovel before their prince?','',0,0,0,0,0,0,0,0,0,0,52578,0,26124),
(93181,'You rats aren\'t fit to touch the hem of my robe!','',0,0,0,0,0,0,0,0,0,0,52576,0,26124),
(93182,'I need... more... power!','',0,0,0,0,0,0,0,0,0,0,52575,0,26124),
(93183,'Yes... YEEESSSSS!','',0,0,0,0,0,0,0,0,0,0,52577,0,26124),
(93184,'We will see if you are truly worthy. Come, and prove yourself a champion of the Light.','',0,0,0,0,0,0,0,0,0,32514,0,0,26124),
(93185,'I carved through thousands of foul scourge. No creature of darkness could stand against The Ashbringer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93186,'No... I was betrayed... cut down... by my own son.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93187,'Play \"War March\"','Play \"War March\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93188,'Play \"Thunder Bluff\"','Play \"Thunder Bluff\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93189,'Play \"Mulgore Plains\"','Play \"Mulgore Plains\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93190,'Play \"Undercity\"','Play \"Undercity\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93191,'Play \"Zul\'Gurub Voodoo\"','Play \"Zul\'Gurub Voodoo\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93192,'Play \"The Zandalari\"','Play \"The Zandalari\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93193,'Play \"Silvermoon\"','Play \"Silvermoon\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93194,'Play \"Rescue the Warchief\"','Play \"Rescue the Warchief\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93195,'','I am busy, $n. Finish your business here and move on.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93196,'Ahh... I feared we might lose that one. He was so weak when I found him. Pick him up and take him to Senegos.','',0,0,0,0,0,0,0,0,0,0,52581,0,26124),
(93197,'Thanks, $c. I\'ll be fine.','Thanks, $c. I\'ll be fine.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93198,'Go on ahead, I can make it from here.','Go on ahead, I can make it from here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93199,'<cough> I\'m good.','<cough> I\'m good.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93200,'','Champion, follow the Highlord\'s spirit! We will hold this ground!',0,0,0,0,0,0,0,0,0,32512,0,0,26124),
(93201,'We have to get out of here before more demons come. Quickly, the Highlord is just outside the temple.','',0,0,0,0,0,0,0,0,0,0,52034,0,26124),
(93202,'Renault! My son... by the Light... help me up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93203,'The Light is dead.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93204,'Attention, soldiers! Commander $p passing through.','Attention, soldiers! Commander $p passing through.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93205,'You are stronger than I thought. Come.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93206,'Ahhhhh...','',0,0,0,0,0,0,0,0,0,0,52851,0,26124),
(93207,'','Get up, brother. Wake up.',0,0,0,0,0,0,0,0,0,0,0,52866,26124),
(93208,'','No! Not you, too...',0,0,0,0,0,0,0,0,0,0,0,52871,26124),
(93209,'','You are nothing but a coward.',0,0,0,0,0,0,0,0,0,0,0,57412,26124),
(93210,'','If you only knew the Legion\'s power. Join us, Kor\'vas.',0,0,0,0,0,0,0,0,0,0,0,52763,26124),
(93211,'','Never! You and your new mistress will die by my warglaives.',0,0,0,0,0,0,0,0,0,0,0,57405,26124),
(93212,'','My wine is only for Queen Azshara!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93213,'Stranger! Can you help me? None of these fools will believe me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93214,'Leaving','Leaving',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(93215,'','But, I was promised...',0,0,0,0,0,0,0,0,0,0,0,52765,26124),
(93216,'They all laughed when I said I could out brew them. I told them I would make something worthy of Lady Challiane, maybe even worthy of the queen herself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93217,'Eat this!','Eat this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93218,'Yeah! Keep \'em coming!','Yeah! Keep \'em coming!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93219,'Get some!','Get some!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93220,'You truly think yourself worthy?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93221,'The Ashbringer can only be wielded by the pure. You waste your time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93222,'','Now, now, Zeliek. Perhaps this is the chosen one the blade speaks of?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93223,'No more babblin\'. Let\'s get to fightin\'!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93224,'Enough. If you are worthy of the Ashbringer...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93225,'Prove yourself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93226,'','You are getting so very frail and weak.',0,0,0,0,0,0,0,0,0,0,0,50591,26124),
(93227,'More slaves for the queen and her new master.','',0,0,0,0,0,0,0,0,0,0,52626,0,26124),
(93228,'You don\'t look like a sailor, but you\'ll do.','',0,0,0,0,0,0,0,0,0,0,52625,0,26124),
(93229,'I\'ll enslave you with my spells.','',0,0,0,0,0,0,0,0,0,0,52629,0,26124),
(93230,'You do not belong. I\'ll kill ya for the queen.','',0,0,0,0,0,0,0,0,0,0,52631,0,26124),
(93231,'A taste of my venom and you\'ll be mine.','',0,0,0,0,0,0,0,0,0,0,52638,0,26124),
(93232,'Another victim for the queen and her demonic friend.','',0,0,0,0,0,0,0,0,0,0,52634,0,26124),
(93233,'My poison is fast to act, but slow to burn.','',0,0,0,0,0,0,0,0,0,0,52639,0,26124),
(93234,'Don\'t be afraid. My venom weakens. Makes you cooperative.','',0,0,0,0,0,0,0,0,0,0,52632,0,26124),
(93235,'So long as my twisted soul dwells within the Ashbringer you will not take it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93236,'|TInterface\\Icons\\Ability_Warlock_FireandBrimstone:20|tYou have been targeted with |cFFFF0000|Hspell:180776|h[Overwhelming Flames]|h|r! Move away from your allies!','|TInterface\\Icons\\Ability_Warlock_FireandBrimstone:20|tYou have been targeted with |cFFFF0000|Hspell:180776|h[Overwhelming Flames]|h|r! Move away from your allies!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(93237,'I\'LL DRINK THE MANA FROM YOUR BROKEN BONES!!','',0,0,0,0,0,0,0,0,0,0,52829,0,26124),
(93238,'I... I...','',0,0,0,0,0,0,0,0,0,0,52820,0,26124),
(93243,'By the Light... it really is you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93244,'What? You not supposed to be here!','',0,0,0,0,0,0,0,0,0,0,52666,0,26124),
(93245,'You are pure of heart and noble of spirit. You are the one the Ashbringer was searching for.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93246,'Come with me. The blade awaits.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93247,'','Enforcer, enact my will!',0,0,0,0,0,0,0,0,0,0,0,50590,26124),
(93248,'Crush you underfoot, little fish.','',0,0,0,0,0,0,0,0,0,0,51886,0,26124),
(93249,'For Prince Oceanus!','',0,0,0,0,0,0,0,0,0,0,52668,0,26124),
(93250,'Me drown you in the sea.','',0,0,0,0,0,0,0,0,0,0,51885,0,26124),
(93251,'Take up the blade and fulfill your destiny, champion. You are... The Ashbringer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93252,'I do not trust Nightfallen...','',0,0,0,0,0,0,0,0,0,0,52813,0,26124),
(93253,'But it seems we have little choice.','',0,0,0,0,0,0,0,0,0,0,52811,0,26124),
(93254,'I only want to help, good dragon.','',0,0,0,0,0,0,0,0,0,0,52821,0,26124),
(93255,'Use the whelplings, then. But if you deceive me, prepare to face the wrath of a dragonflight.','',0,0,0,0,0,0,0,0,0,0,52816,0,26124),
(93256,'I was once a noble elf, good dragon. I know the meaning of honor.','',0,0,0,0,0,0,0,0,0,0,52830,0,26124),
(93261,'','You\'ve been a naughty child. Time to be punished.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93262,'','Avenge me, my children!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93263,'I know why you are here, small one...','',0,0,0,0,0,0,0,0,0,0,52865,0,26124),
(93264,'','No... you can\'t... have it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93265,'Please... help...','',0,0,0,0,0,0,0,0,0,0,52852,0,26124),
(93266,'You mortals and your arrogance. You will burn in my flames!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93267,'I will return!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93268,'Ah, the Light\'s greatest champion has arrived to claim the holy Ashbringer and lay waste to my kin.','',0,0,0,0,0,0,1,0,0,0,52018,0,26124),
(93269,'I\'ve been waiting for you, paladin. Know that I will rip the soul from your flesh and make your body my own.','',0,0,0,0,0,0,1,0,0,0,52025,0,26124),
(93270,'','We\'ve got your back, champion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93271,'The Light will always triumph against darkness.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93272,'Burn everything, my pets. Leave only ash.','',0,0,0,0,0,0,0,0,0,0,52019,0,26124),
(93273,'I WILL return!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93278,'Ah, $p. Good. I am in need of someone with a calmer head than Marius here.$b$bThis location is prime for summoning a demon more powerful than any I have summoned before.$b$bI need you to ensure that this demon hunter doesn\'t do anything foolish like killing the demon before I have a chance to force it into submission.$b$bWill you stand with me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93279,'Okay...?','Okay...?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93280,'Your cowardice is showing, Marius. We must learn the limits of our enemy if we are to defeat them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93281,'Who dares summon me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93282,'There are enough demons for us to kill without you summoning more.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93283,'Too big! Too big! KILL IT!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93284,'Next time I need to remember to have a soulstone ready.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93285,'Not right now, my friend. Not right now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93286,'Activate','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93287,'Legion has chosen its champion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93288,'You are not wanted here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93289,'For the God King!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93290,'The God King will have the Aegis!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93291,'The God King commands your death!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93292,'You are not worthy of the trials! Hail the God King!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93293,'No one will challenge the God King!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93294,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Balnazzar.blp:50:80|t$b[Balnazzar] You really think you can stand against me? My endless felguard will cut you down.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93295,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Balnazzar.blp:50:80|t$b[Balnazzar] Impressive... but not enough. Infernal, crush them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93296,'Enough. Never again will that damned blade slay my brethren! YOU... WILL... DIE!','',0,0,0,0,0,0,0,0,0,0,52011,0,26124),
(93297,'HAHA!! Now that I have consumed the blood of my brothers, I have the power to destroy you and the God King!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93300,'<The strange gnomish robot has one eye hanging loose from its socket. A cardboard sign on its chest says, \"BETA.\" Most of its wiring is duct-taped in place. Suddenly, it speaks in a warbling voice:>$b$bGreetings adventur-er-er*click*! Inp-p-p-*clink* TEST PARAMETERS REBOOT 001011010 Greetings adventurer!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(93301,'','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-COMMANDER SARANNIS.blp:50:80|t$b[Lady Liadrin] Hero, we\'re up on the ledge behind you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93302,'$p, you must come quickly. Tirion called for you by name. I fear he does not have long for this world. Hurry!','',0,0,0,0,0,0,0,0,0,0,52721,0,26124),
(93303,'Protect Reshad.','Protect Reshad.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93304,'BETA: Trigger the Invasion','BETA: Trigger the Invasion',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(93306,'Praying','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93307,'|cffADFF2F+$1i Artifact Power|r','|cFF0000FF+$1i Artifact Power |r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93308,'','The Ashbringer...',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(93309,'','The Ashbringer...',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(93310,'The Ashbringer...','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(93311,'((This will be a brief cutscene. You attempt to give Tirion the Ashbringer, but he refuses.)) No... I am too crippled to continue the Ashbringer\'s legacy. The burden must fall on your shoulders, $p. From this day forward, you will wield the Ashbringer against the forces of darkness wherever you are needed, champion.','',0,0,0,0,0,0,2,0,0,924,0,0,26124),
(93312,'((This will be a brief cutscene. You attempt to give Tirion the Ashbringer, but he refuses.)) No... I am too crippled to continue the Ashbringer\'s legacy. The burden must fall on your shoulders, $p. From this day forward, you will wield the Ashbringer against the forces of darkness wherever you are needed, champion.','',0,0,0,0,0,0,2,0,0,923,0,0,26124),
(93319,'Word has already spread of your exploits on the Broken Shore. The Ashbringer... the forces of the Legion will surely cower in your wake.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93320,'The Burning Legion\'s numbers are endless. If we are ever going to put a stop to their assault, we need to stop them at the source - the Tomb of Sargeras.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93321,'Long ago, the Titans used powerful tools called the Pillars of Creation to shape Azeroth. They are the key to seal the Legion\'s gateway into our world forever.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93322,'We\'ve identified the location of one of the pillars - the Tidestone of Golganneth. It is somewhere on the ancient isle of Azsuna. I need you to retrieve it by any means necessary.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93323,'Aegwynn built this chamber in secret as some sort of safeguard against the Legion. We must discover its secrets so we can make use of it.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93324,'Why have you summoned me here, imp?','',0,0,0,0,0,0,0,0,0,32600,0,0,26124),
(93325,'Minion! Glad you could make it. The time has come to make my old master pay for violating my contract. You ready to face him?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93326,'Begin your ritual.','Begin your ritual.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93327,'Ah... my \'former\' master. Minion! Kill it!','',0,0,0,0,0,0,0,0,0,32600,0,0,26124),
(93328,'You failed, \'master\'! Who\'s the master now?','',0,0,0,0,0,0,0,0,0,32600,0,0,26124),
(93329,'You will pay for this betrayal!','',0,0,0,0,0,0,0,0,0,32600,0,0,26124),
(93330,'Of course. If Tirion beckons, it must be important.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93331,'Follow me, champion. Let me show you Light\'s Hope Sanctum and introduce you to the Order of the Silver Hand.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93332,'Yes! Yes! Dark-ish feathers for dark-ish purpose!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93333,'','Greetings, $c. Your aid is welcome here.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(93334,'Yes! Yes! Good! The cursed power that flows in these horns is invaluable to any evil...er... morally ambiguous ritual.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93335,'Well done, minion! One olive for each of my fingers.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93336,'Please join me. I am ready to continue our quest.','Please join me. I am ready to continue our quest.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(93337,'Make way for the little guy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93338,'Meet me at the ritual site for your reward.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93339,'Switching the building will cost 500 gold.\n\nAre you sure?','Switching the building will cost 500 gold.\n\nAre you sure?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93340,'Archmage Khadgar, can you direct one of these portals to Light\'s Hope Chapel?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(93341,'','Archmage Khadgar, can you direct one of these portals to Light\'s Hope Chapel?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(93342,'You never know what you\'ll find while wandering the land in search of a good trade.  Hopefully I\'ve found someone willing to barter?','You never know what you\'ll find while wandering the land in search of a good trade.  Hopefully I\'ve found someone willing to barter?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93343,'Come brothers! Seize your destiny!','',0,0,0,0,0,0,0,0,0,0,50421,0,26124),
(93348,'','I have heard Malfurion\'s name spoken in passing. He was \'alora thero-shan\' - the beloved first student - of Cenarius.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93349,'','I understand your matter is of great urgency. Help us, and we shall help you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93350,'','Many of our own slumber in the barrow den, keeping watch within the Emerald Dream.$B$BThe Archdruid is among them. I only pray we are not too late to save them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93351,'','The furbolg are relentless, and strong. There is no stopping them without the use of force.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93352,'It hurts...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93354,'','Greetings, traveler!$B$BNormally, I would welcome you to this sunlit glade by sitting you down for a meal of fresh berries bursting with ripeness, washed down with clear stream water caressed by moonlight, but unfortunately, we are under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93355,'','If you believe, you can achieve!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93356,'','Hang in there, Tenno. Shhh, save your strength. Don\'t die on me now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93357,'Druids of the Claw, do not falter! We must retake the barrow den!','Druids of the Claw, do not falter! We must retake the barrow den!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93358,'','I haven\'t had any fancy druidic training like you, but I\'m going to heal Tenno with the power of my friendship!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93359,'Cenarius, my mentor...$b$bWhat foul power could hold sway over him?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93360,'','The Dream was clouded with such darkness...',0,0,0,0,0,0,0,0,0,0,0,52349,26124),
(93361,'I can fly you back to Light\'s Hope Sanctum if you need, hero.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93362,'I would like to return to Light\'s Hope Sanctum.','I would like to return to Light\'s Hope Sanctum.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93363,'I\'m awake, I\'m awake...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93364,'Is this world real? Or is the dream the actual reality?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93365,'I slept well, but my dreams were troubled.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93366,'My dreams felt strange. I fear not all is well in the Emerald Dream.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93367,'I wandered long and far in my dreams. So very, very far...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93368,'I sensed a dark presence within the Dream.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93369,'','My druids are still caught inside The Emerald Dream, unable to awaken.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93370,'The demons before us are all that stand between us and the Ashbringer. Regardless of the outcome, our families will know that we fought for the freedom and safety of our world.','',0,0,0,0,0,0,0,0,0,0,52723,0,26124),
(93371,'','My slumber was overcome by shadows. I have awoken, only to find those shadows reaching into our world.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93373,'Come, champion, before we are overrun by demons!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93374,'Arise Dorg! Arise and avenge your fallen brethren!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(93375,'Bloodhunter Zulk! Too many of our rituals are being stopped, execute the interlopers!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(93376,'The Blood Moon rises and strengthens our chieftain! Rejoice Bleeding Hollow, soon he will be unstoppable!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(93377,'The Blood Moon has been drained! Quickly, animate the remains and salvage what power is left!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(93378,'Curse you interlopers! The Blood Moon will rise again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93379,'You must hurry.... w-we don\'t have much time!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(93380,'%s spits.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93381,'Coward.','',0,0,0,0,0,0,0,0,0,0,52757,0,26124),
(93383,'','You did this to us, Farondis.',0,0,0,0,0,0,0,0,0,0,0,52761,26124),
(93384,'H... He is... c-coming...','',0,0,0,0,0,0,20,0,0,0,0,0,26124),
(93385,'','We should never have forsaken the grace of Elune for the vanity of the arcane!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93386,'I gonna break you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93387,'More souls for the masters!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93388,'I\'m gonna drink your blood!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93389,'Kaww! You dare to harm my worshipers? You will know the vengeance of the Sethekk!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93390,'','Deal with this...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93391,'Take me to Aktar\'s Post.','Take me to Aktar\'s Post.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93392,'','Maintain your vigil. I want to know every move that dragon makes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93393,'Hold right there. We will not let you into Nar\'thalas again. Not after what happened last time.','',0,0,0,0,0,0,397,0,0,0,52773,0,26124),
(93394,'I beg your forgiveness, Thaldrys.','',0,0,0,0,0,0,0,0,0,0,52798,0,26124),
(93395,'You sundered the land we called home. You denied us the release of death.','',0,0,0,0,0,0,396,0,0,0,52774,0,26124),
(93396,'Ten thousand years of damnation for ten thousand elves. All because of your foolish alliances and botched politics.','',0,0,0,0,0,0,5,0,0,0,52775,0,26124),
(93397,'What can I do to make amends?','',0,0,0,0,0,0,0,0,0,0,52784,0,26124),
(93398,'I doubt there\'s anything you can do now, prince.','',0,0,0,0,0,0,396,0,0,0,52776,0,26124),
(93399,'Failure.','Failure.',0,0,0,0,0,0,0,0,0,0,52760,69792,26124),
(93400,'Murderer.','Murderer.',0,0,0,0,0,0,0,0,0,0,52755,69791,26124),
(93401,'Fool.','Fool.',0,0,0,0,0,0,0,0,0,0,52759,69790,26124),
(93402,'Butcher.','Butcher.',0,0,0,0,0,0,0,0,0,0,52762,69789,26124),
(93403,'Stop! Stop the voices, I beg you!','',0,0,0,0,0,0,0,0,0,0,52785,0,26124),
(93404,'Take me to Aktar\'s Post.','Take me to Aktar\'s Post.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93405,'','I will escort you to Prince Farondis, if that is what you truly wish.',0,0,0,0,0,0,0,0,0,0,0,52767,26124),
(93406,'','If you get the chance, spit on him for me.',0,0,0,0,0,0,0,0,0,0,0,52771,26124),
(93407,'The Archdruid of Lore has sent me to you. Will you help me cure the petrified acolytes?','The Archdruid of Lore has sent me to you. Will you help me cure the petrified acolytes?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(93408,'Prepare for your deaths, worms!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93409,'You cannot escape your punishment!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93410,'Ha! Impudent coward!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93411,'Not so fast!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93412,'Grommash, I have... failed...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93413,'Wrong move, weaklings.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93414,'Witness your unmaking!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93415,'Scurry, like the vermin you are!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93416,'You can\'t handle this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93417,'How did I... lose?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93418,'','Burn... BURN!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93419,'','Oh, new playthings?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93420,'','Dance, little one!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93421,'','What a bore... I tire of this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93422,'','No! NO!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93423,'','I will open the way for you, but be careful. I sense powerful magic down below.',0,0,0,0,0,0,0,0,0,0,0,52350,26124),
(93424,'This is just... the beginning.','',0,0,0,0,0,0,0,0,0,0,52351,0,26124),
(93425,'We are prisoners of the druids no longer. Soon, your world will become ours!','',0,0,0,0,0,0,0,0,0,0,52352,0,26124),
(93426,'You must excuse my attendants. Their brusqueness is not directed at you... it is toward me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93427,'Azsuna was once a center of elven civilization. My people flourished. Now, they are damned.$b$bMost cannot bear to look at me.$b$bThey are the scars of my past. The marks of my shame.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93428,'This is too difficult. I cannot look my people in the eye and explain my actions.$b$bI should return to the solitude of my palace. At least my guards are content to ignore me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93429,'','I will travel to the Grove of Cenarius shortly, hero. Thank you for your help here.',0,0,0,0,0,0,0,0,0,0,0,52353,26124),
(93430,'','Be wary. $n is here.',0,0,0,0,0,0,0,0,0,0,0,52661,26124),
(93431,'','Kill them, Malinoth!',0,0,0,0,0,0,0,0,0,0,0,52658,26124),
(93432,'I damned our people. I brought about the destruction of our ancestral homeland.$b$bI killed them all.$b$bIt is because of my folly that our people cannot experience the relief of death. My failures led our people to this cursed ghostly half-existence.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93433,'It will be my pleasure.','',0,0,0,0,0,0,0,0,0,0,52745,0,26124),
(93434,'I will feast upon your soul when you die!','',0,0,0,0,0,0,0,0,0,0,52746,0,26124),
(93435,'I was a poor leader. I was blind, and I chose the wrong path for my people. I...$b$b...I cannot go into any more detail than that. Give me time, $n. I am certain that all will be revealed in good time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93436,'Percy and I will travel on ahead. When you are ready to join us speak with your flight master.','',0,0,0,0,0,0,1,0,0,0,50812,0,26124),
(93437,'Out with the tides...','',0,0,0,0,0,0,0,0,0,0,52687,0,26124),
(93438,'','You are no match for the might of our forces!',0,0,0,0,0,0,0,0,0,0,0,52701,26124),
(93439,'None shall enter without the blessing of Yotnar.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93440,'You will surely die if you enter Aggramar\'s Vault without the blessing of Yotnar.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93441,'Haha! Back to the nether!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93442,'D\'ah! Now you\'re making me angry!','D\'ah! Now you\'re making me angry!',0,0,0,0,0,0,0,0,0,0,49734,49734,26124),
(93443,'You landlubbers are tougher than I thought! I\'ll have to improvise!','You landlubbers are tougher than I thought! I\'ll have to improvise!',0,0,0,0,0,0,0,0,1,0,49735,49735,26124),
(93444,'We\'re under attack! Avast, ye swabs! Repel the invaders!','We\'re under attack! Avast, ye swabs! Repel the invaders!',0,0,0,0,0,0,0,0,1,0,49736,49736,26124),
(93445,'They will bleed. I will show them how to bleed.','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(93446,'You there! Check out that noise!','You there! Check out that noise!',0,0,0,0,0,0,0,0,0,0,49748,49748,26124),
(93447,'I can wait no longer - follow!','',0,0,0,0,0,0,15,0,0,0,50307,0,26124),
(93448,'I\'d only reached the academy entrance when I saw those two naga, with you in tow.','',0,0,0,0,0,0,0,0,0,0,52799,0,26124),
(93449,'For Azsuna!','',0,0,0,0,0,0,0,0,3,0,0,0,26124),
(93450,'The shrine has been brutally defaced.','The shrine has been brutally defaced.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(93451,'Look alive, nightwatchers! Our prince needs us!','',0,0,0,0,0,0,0,0,3,0,0,0,26124),
(93452,'For Azsuna!','For Azsuna!',0,0,0,0,0,0,0,0,3,0,0,0,26124),
(93453,'','Farondis! My most loyal subject. It\'s been too long.',0,0,0,0,0,0,1,0,0,0,0,52897,26124),
(93454,'That voice...','',0,0,0,0,0,0,1,0,0,0,60758,0,26124),
(93455,'','I\'m sorry, you must not recognize me.',0,0,0,0,0,0,1,0,0,0,0,52896,26124),
(93456,'We have devoured countless worlds. Yours will be no different.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93457,'','Is this better?',0,0,0,0,0,0,6,0,0,0,0,52898,26124),
(93458,'Queen Azshara... you... YOU lead the naga?','',0,0,0,0,0,0,5,0,0,0,60757,0,26124),
(93459,'','Poor, deluded Farondis. Don\'t you remember? I quashed your rebellion ten thousand years ago. Do you remember how powerless you were to stop me?',0,0,0,0,0,0,25,0,0,0,0,52894,26124),
(93460,'To release my people\'s curse... to redeem myself and secure my legacy...','',0,0,0,0,0,0,0,0,0,0,62704,0,26124),
(93461,'The people of Azsuna were-- and always will be-- too proud to kneel before your demonic allies, witch.','',0,0,0,0,0,0,0,0,0,0,62705,0,26124),
(93462,'','Ha ha ha haaa... my wrath is coming.',0,0,0,0,0,0,15,0,4,0,0,52895,26124),
(93463,'Let us begin.','Let us begin.',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(93464,'Impossible!','Impossible!',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(93465,'I am victorious again.','I am victorious again.',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(93466,'That was unexpected.','That was unexpected.',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(93467,'Your pet will recover with time.','Your pet will recover with time.',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(93468,'Eh? I\'m new to this game. Got any tips for building mah deck?','Eh? I\'m new to this game. Got any tips for building mah deck?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93469,'I\'m on a winning streak with this new strategy. I call it my \'menagerie\' deck.','I\'m on a winning streak with this new strategy. I call it my \'menagerie\' deck.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93470,'Mind controlled again? Noooooo!','Mind controlled again? Noooooo!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93471,'Wha?!? Now just how did that dragon pop out o\' that shredder?','Wha?!? Now just how did that dragon pop out o\' that shredder?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93472,'Murlocs? Nooooo! Why did it have to be murlocs?','Murlocs? Nooooo! Why did it have to be murlocs?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93473,'Did you just unleash the hounds on me?','Did you just unleash the hounds on me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93474,'Looks like I win again. But well played.','Looks like I win again. But well played.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93475,'Let\'s see how you handle a different threat.','Let\'s see how you handle a different threat.',0,0,0,0,0,0,0,0,5,0,0,0,26124),
(93476,'Illidan\'s soul is in the Twisting Nether. I must get back to him.','Illidan\'s soul is in the Twisting Nether. I must get back to him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93477,'The glyph is covered with fine writing in an unknown language. A large portion of it appears to be missing.','The glyph is covered with fine writing in an unknown language. A large portion of it appears to be missing.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(93478,'','Gul\'dan\'s army awaits within the armored walls of Hellfire Citadel. What horrors lie within, we have yet to find out.$B$BOur forces here at Lion\'s Watch will hold back the demonic threat until the last of us falls.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(93479,'Please don\'t make any sudden moves around Alexi, or you might lose a finger.  Or worse.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93480,'The scroll is addressed to Iskar. You quickly show it to Reshad.','The scroll is addressed to Iskar. You quickly show it to Reshad.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(93481,'I have a great deal of information to give to you, but time is short. I will tell you what I can and you will have to find a way to return later to hear the rest.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(93482,'I am ready, Illidan.','I am ready, Illidan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93483,'','And what offerings do you have for me?',0,0,0,0,0,0,0,0,0,0,0,51895,26124),
(93484,'Planting Seeds','Planting Seeds',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(93485,'Look around. What do you see? Worlds enough to fill the sky.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93486,'This is how it looked millennia ago, before the Burning Legion started its march of destruction across the cosmos.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93488,'That\'s a powerful artifact that you carry. Powerful enough to destroy the Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93489,'You and the Illidari must recover my corpse from Black Rook Hold before it is too late.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93490,'Ah Interesting... \"Come to Tanaan. Assist me, and I will return you to the skies.\"','',0,0,0,0,0,0,1,0,0,0,50815,0,26124),
(93491,'Our time is at an end. You must return again. But for now, leave before the Legion detects us here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93492,'<The dead orc clutches an unsent letter in his hand.>$B$BDear Ma, I\'ve decided to leave da Iron Horde army.$B$BNot enough grub, and I miss your cooking.$B$BLove, Your Son.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93493,'Mmmmmm, you look tasty!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93494,'Let us proceed, $p.','',0,0,0,0,0,0,1,0,0,0,50813,0,26124),
(93495,'|cFFFF0000%s|r prepares a brutal attack!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(93496,'Who wrote this message? Come, let\'s continue the search.','',0,0,0,0,0,0,1,0,0,0,50816,0,26124),
(93497,'I... I am sorry.','',0,0,0,0,0,0,2,0,0,0,52787,0,26124),
(93498,'You there! Check out that noise!','You there! Check out that noise!',0,0,0,0,0,0,0,0,0,0,49760,49760,26124),
(93499,'We\'re under attack! Avast, ye swabs! Repel the invaders!','We\'re under attack! Avast, ye swabs! Repel the invaders!',0,0,0,0,0,0,0,0,1,0,49761,49761,26124),
(93500,'You landlubbers are tougher than I thought! I\'ll have to improvise!','You landlubbers are tougher than I thought! I\'ll have to improvise!',0,0,0,0,0,0,0,0,1,0,49762,49762,26124),
(93501,'D\'ah! Now you\'re making me angry!','D\'ah! Now you\'re making me angry!',0,0,0,0,0,0,0,0,1,0,49763,49763,26124),
(93502,'Ah-ha! I\'ve got you right where I want you!','Ah-ha! I\'ve got you right where I want you!',0,0,0,0,0,0,0,0,1,0,49765,49765,26124),
(93503,'Now... witness the full power of Millhouse Manastorm!','Now... witness the full power of Millhouse Manastorm!',0,0,0,0,0,0,0,0,1,0,49767,49767,26124),
(93504,'Yes! Yes! More blood!','Yes! Yes! More blood!',0,0,0,0,0,0,0,0,1,0,27751,27751,26124),
(93505,'Blood blood blood BLOOD BLOOD!!','Blood blood blood BLOOD BLOOD!!',0,0,0,0,0,0,0,0,1,0,49770,49770,26124),
(93506,'Dripping and pouring and clotting!','Dripping and pouring and clotting!',0,0,0,0,0,0,0,0,1,0,49776,49776,26124),
(93507,'More blood!','More blood!',0,0,0,0,0,0,0,0,1,0,49775,49775,26124),
(93508,'The scent of blood...so delicious!','The scent of blood...so delicious!',0,0,0,0,0,0,0,0,1,0,49774,49774,26124),
(93509,'Spurts of crimson!','Spurts of crimson!',0,0,0,0,0,0,0,0,1,0,49773,49773,26124),
(93510,'Always pumping, always pumping!','Always pumping, always pumping!',0,0,0,0,0,0,0,0,1,0,49772,49772,26124),
(93511,'So warm, so red!','So warm, so red!',0,0,0,0,0,0,0,0,1,0,49771,49771,26124),
(93512,'We are everywhere... you cannot hide!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93513,'Hello again, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93514,'What do you require, oh most noble Highlord? Are there any damsels that are in a state of distress?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93515,'Show me your wares, squire.','Show me your wares, squire.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93516,'I need to relay mission orders.','I need to relay mission orders.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93517,'The great and all-powerful Highlord has called upon me. What dragon needs slaying, $ct $p?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93518,'Why, Thaldrys? Why did you and your men come to my aid?','',0,0,0,0,0,0,0,0,0,0,52797,0,26124),
(93519,'I thought you despised me.','',0,0,0,0,0,0,0,0,0,0,52810,0,26124),
(93520,'We saw what you did.','',0,0,0,0,0,0,0,0,0,0,52780,0,26124),
(93521,'','Any elf with the courage to stand up against the Queen herself is worth following.',0,0,0,0,0,0,0,0,0,0,0,52768,26124),
(93522,'The nightwatchers are yours to command once more, my prince.','',0,0,0,0,0,0,0,0,0,0,52777,0,26124),
(93523,'I\'m glad to have your loyalty again. It\'s been a long time Thaldrys.','',0,0,0,0,0,0,0,0,0,0,52786,0,26124),
(93524,'Yes. Warlord Parjesh escaped with it through the magic portal ahead.','',0,0,0,0,0,0,0,0,0,0,52779,0,26124),
(93525,'Oh, hello there.  I don\'t get many visitors up here.\n\nYou may not know this, but I\'m the author of Tome of the Clear Mind.  It\'s a best seller, for sure, but I came up here for inspiration on something less technical.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93526,'Any inspiration so far?','Any inspiration so far?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93527,'I\'d rather not say.  Last time I talked about it, another author stole my idea and made it into a disturbing romance novel.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93536,'A stranger? Hopefully $ghe:she;\'s an assassin, to finally do away with that prince!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93537,'','I wish.',0,0,0,0,0,0,574,0,0,0,0,0,26124),
(93539,'Become prey to the darkness!','',0,0,0,0,0,0,0,0,0,0,61461,0,26124),
(93540,'I will send you to eternal sleep.','',0,0,0,0,0,0,0,0,0,0,61462,0,26124),
(93541,'Your torment will be endless!','',0,0,0,0,0,0,0,0,0,0,61463,0,26124),
(93542,'Nightmare consume you!','',0,0,0,0,0,0,0,0,0,0,61464,0,26124),
(93543,'A shrine to Terokk! The Sethekk revere the Talon king, why would they deface their own shrine? Hmm... we must continue to investigate.','',0,0,0,0,0,0,1,0,0,0,50817,0,26124),
(93545,'Every garrison could use a bit more bass, wouldn\'t you agree Commander?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93546,'You keep the garrison safe, and I\'ll supply the tunes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93547,'Where are the jukebox parts?','Where are the jukebox parts?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93548,'We know why you and your abomination are here.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(93549,'You do not attack. What is this place?','You do not attack. What is this place?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93550,'In this cave, chieftains of the Bleeding Hollow perform a ritual to see glimpses of the future, and their own death. The other chieftains... they blindly follow Kilrogg... but not us. Grommash was worthy, Gul\'dan...\n\nWe have felt disturbances deep in Draenor. We believe Gul\'dan means to do great harm to Draenor, and our tribe will suffer greatly for it.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(93551,'Ah, this is written in the language of the Apexis. \"... buried... evil... forbidden...\" Without the other half of this fragment this is all I can discern. We must carry on.','',0,0,0,0,0,0,1,0,0,0,50818,0,26124),
(93552,'We share a problem then. Will you aid us?','We share a problem then. Will you aid us?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93553,'... Yes. There is a way for you to... see... some of Kilrogg\'s future... and your own.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(93554,'There you are, $p. Welcome to Val\'Sharah.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93555,'Welcome to Lorlathil, sanctuary of the druids. Though this forest has aged, its spirits still remember me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93556,'Speak to me when you wish to depart. I know these forests better than any other.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93557,'Every step in this forest brings back precious memories.','',0,0,0,0,0,0,0,0,0,0,52358,0,26124),
(93558,'Ages ago, the first druids molded this land to be a reflection of the Emerald Dream.','',0,0,0,0,0,0,0,0,0,0,52359,0,26124),
(93559,'[lose this]','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93560,'Merely an echo, but Val\'sharah is as close to the Dream as this world can come.','',0,0,0,0,0,0,0,0,0,0,52360,0,26124),
(93561,'Prepare yourself, hero. We draw near to the Grove of Cenarius.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93562,'We shall stand in the presence of the Lord of the Forest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93563,'He will direct us to the Tears of Elune.','',0,0,0,0,0,0,0,0,0,0,52740,0,26124),
(93564,'And then you will be free to collect Aegwynn\'s other relics.','',0,0,0,0,0,0,0,0,0,0,52361,0,26124),
(93565,'Follow me.','',0,0,0,0,0,0,0,0,0,0,52741,0,26124),
(93566,'','Malfurion! Thank Elune you\'ve come!',0,0,0,0,0,0,0,0,0,0,0,52362,26124),
(93567,'It is good to see you agai--','',0,0,0,0,0,0,0,0,0,0,52742,0,26124),
(93568,'','You must come quickly; something\'s happened!',0,0,0,0,0,0,0,0,0,0,0,52363,26124),
(93569,'','He was in the Dream, but now he won\'t wake. We cannot stir him.',0,0,0,0,0,0,0,0,0,0,0,52364,26124),
(93570,'What is this... corruption?','',0,0,0,0,0,0,0,0,0,0,52743,0,26124),
(93571,'','We--we don\'t know. It only just appeared.',0,0,0,0,0,0,0,0,0,0,0,52365,26124),
(93574,'Listen well, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93575,'Our work is nearly done.$b$bI must thank you for including me in your adventure, $n. I may have assisted you in finding the Tidestone itself, but I feel you have done so much more for me and my people.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93577,'I am ready, Malfurion.','I am ready, Malfurion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93578,'','Hatecoil! Seize them!',0,0,0,0,0,0,0,0,0,0,0,52620,26124),
(93579,'Look alive, nightwatchers! Our prince needs us!','',0,0,0,0,0,0,0,0,0,0,52778,0,26124),
(93580,'The Tidestone of Golganneth...','',0,0,0,0,0,0,0,0,0,0,52848,0,26124),
(93581,'I\'m afraid it will be of no use to you in its current shattered state.','',0,0,0,0,0,0,0,0,0,0,52849,0,26124),
(93583,'I can rebuild it. This will be my final gift to you.','',0,0,0,0,0,0,0,0,0,0,52861,0,26124),
(93585,'What\'s this? This book looks... familiar.','',0,0,0,0,0,0,1,0,0,0,50814,0,26124),
(93586,'I\'m ready to begin.','I\'m ready to begin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93587,'These lands feel very foreign to me.  Conflict, anger and hate are everywhere.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93588,'Would you like to join our cause?','Would you like to join our cause?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93589,'Allow Fen Tao to join our cause?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93590,'I have heard stories of your glorious deeds in Pandaria!  It\'s an honor to finally meet you in person!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93591,'Dat not smart, little thing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93592,'We hit you more hard than bass blaster!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93593,'Party pooper get smashed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93594,'Hey... that\'s mine! I think...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93595,'Why are you here?','Why are you here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93596,'My name is Fen Tao, and I am from Pandaria.  I have spent many days traveling to these lands.  Why you ask?\n\nWe are a family of helpful people, and you look like someone that could use some help.  Just let me know how I can be of service to you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93597,'To die gloriously in battle protecting your home... that is the fate all true warriors strive for.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93598,'<The faerie dragon looks sad.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93599,'How are you?','How are you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93600,'Oh, I\'ve had better nights... I was working on a beautiful enchantment for months and months but no one got to see it!\n\nHey, would YOU like to see it?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93601,'It\'s good to see you survived that last assault, but when the Burning Legion makes its final push, they\'ll wipe us out.','',0,0,0,0,0,0,0,0,0,0,50633,0,26124),
(93602,'It\'s been an honor to fight by your side all these years, but our strength was not enough to save Azeroth. Before we meet death, let\'s send a few hundred demons screaming back to the Twisting Nether!','',0,0,0,0,0,0,0,0,0,0,50634,0,26124),
(93603,'Gather them together, champions! My magic will do the rest!','',0,0,0,0,0,0,0,0,0,0,50637,0,26124),
(93604,'Give Sargeras my regards!','',0,0,0,0,0,0,0,0,0,0,50635,0,26124),
(93605,'You will not defeat us so easily!','',0,0,0,0,0,0,0,0,0,0,50636,0,26124),
(93606,'Sure, why not?','Sure, why not?',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(93607,'','BEHOLD! My wondrous creation! Convincing, isn\'t it?',0,0,0,250,0,0,0,0,0,0,0,0,26124),
(93608,'We will reap your souls.','',0,0,0,0,0,0,0,0,0,0,50779,0,26124),
(93609,'I must protect our sacred grounds...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93610,'I will not allow you to take that!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93611,'Die desecrator!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93612,'Rally up ya scurvy dogs. Are you going to let this big burly giant drag your fortunes to the bottom of the sea?','',0,0,0,0,0,0,0,0,0,32768,0,0,26124),
(93613,'Come on lads! Slay that large beast so we can be off.','',0,0,0,0,0,0,0,0,0,32768,0,0,26124),
(93614,'Here spirits are restless. They are angry we are here. They will not stop me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93615,'Put yer backs into it! I don\'t want to get ate.','',0,0,0,0,0,0,0,0,0,32768,0,0,26124),
(93616,'Now that\'s the spirit! Fire another salvo across that thing\'s chin.','',0,0,0,0,0,0,0,0,0,32768,0,0,26124),
(93617,'Stand to and bring that thing down or its the gullet for all of you.','',0,0,0,0,0,0,0,0,0,32768,0,0,26124),
(93618,'','Thanks for taking a moment to appreciate my hard work. It really makes me happy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93619,'We go. Find me Kilrogg.','',0,0,0,0,0,0,0,0,0,0,50308,0,26124),
(93620,'Well done, men! You have saved your beloved captain and- wait... where are you all going?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93621,'You are not welcome here invader, but we must talk.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(93622,'Blood and thunder, there you are! We must speak at once, champion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93623,'Saurfang wants to see you at once.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93624,'Khadgar, can you direct this portal to Orgrimmar?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93625,'I will follow your lead, champion. We mustn\'t keep Saurfang waiting.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93626,'Khadgar, old friend! I hate to interrupt, but I need to speak with $n immediately.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93627,'King Magni of Ironforge wants to see you at once.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93628,'Khadgar, can you direct this portal to Stormwind?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93629,'I will follow your lead, champion. We mustn\'t keep King Magni waiting.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93630,'They are raiding Zeth\'Gol. We need to pull back and defend my home -','',0,0,0,0,0,0,603,0,0,0,50432,0,26124),
(93631,'Patience, Kilrogg. Your warriors must continue to seek the cipher.','',0,0,0,0,0,0,1,0,0,0,50941,0,26124),
(93632,'But-','',0,0,0,0,0,0,0,0,0,0,50433,0,26124),
(93633,'Once the cipher is mine our enemies will have no safe ground... wait - do you feel it? We are being watched. Hold still.','',0,0,0,0,0,0,1,0,0,0,50942,0,26124),
(93634,'Your sacred grounds are defiled, Kilrogg. Do not worry - I have taken care of the problem.','',0,0,0,0,0,0,0,0,0,0,50943,0,26124),
(93635,'Destroying Armaments','Destroying Armaments',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(93636,'Cutscene Placeholder: The God-King blows up the bridge, blocking your way up the mountain path!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93638,'Helheim... the sooner we find a way out of here the better.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93639,'Seaweed Disguise','Seaweed Disguise',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93640,'You know not what you do, foolish mortal.','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(93641,'Wh-what are you... doing?!','',0,0,0,0,0,0,430,0,0,0,0,0,26124),
(93642,'You... you dare disturb my work?!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(93643,'What is the meaning of this?!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(93644,'You dare taunt death itself, mortal?','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(93645,'','We seek Solog Roark!',0,0,0,0,0,0,0,0,4,0,0,50565,26124),
(93646,'','We don\'t want you dead. We need a shipwright.',0,0,0,0,0,0,0,0,4,0,0,50566,26124),
(93647,'You found him. If you wish me dead, put a hammer in my hands and let\'s make a fight of it.','',0,0,0,0,0,0,0,0,4,0,50557,0,26124),
(93648,'Hah! There\'s none better.','',0,0,0,0,0,0,0,0,4,0,50558,0,26124),
(93649,'Go use the eye! I will stop the spirits from attacking you.','',0,0,0,0,0,0,0,0,0,0,50311,0,26124),
(93650,'I\'m counting on you and my drakes to protect me, $n.$b$bThe ritual I am about to perform is complicated, and will take some time. It will almost certainly attract the attention of Azsuna\'s more unsavory inhabitants.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93651,'I will protect you, Senegos.','I will protect you, Senegos.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93652,'Kilrogg... at the citadel. I must kill him... before I lose... everything...','',0,0,0,0,0,0,15,0,0,0,50312,0,26124),
(93653,'','Farondis did this to us!',0,0,0,0,0,0,0,0,0,0,0,52904,26124),
(93654,'','Why has the queen forsaken us?',0,0,0,0,0,0,0,0,0,0,0,52905,26124),
(93655,'','Join us. Join us forever...',0,0,0,0,0,0,0,0,0,0,0,52903,26124),
(93656,'','Azshara forgive me!',0,0,0,0,0,0,0,0,0,0,0,52902,26124),
(93657,'Your Bleeding Hollow dogs have failed, Gul\'dan. They are as inept as ever.','',0,0,0,0,0,0,1,0,0,0,50450,0,26124),
(93658,'Arrogance will not be tolerated, Iskar. What of your search for the cipher? Or are you too... a failure?','',0,0,0,0,0,0,1,0,0,0,50930,0,26124),
(93659,'In the ruins I\'ve found mention of a dark power hidden within the earth. This fragment will show you the path to where it is sealed.','',0,0,0,0,0,0,1,0,0,0,50451,0,26124),
(93660,'You have done well Iskar! Success will be rewarded.','',0,0,0,0,0,0,1,0,0,0,50931,0,26124),
(93661,'Drink and you will fly once more.','',0,0,0,0,0,0,1,0,0,0,50932,0,26124),
(93663,'This feeling... my wings are strong again! I am forever yours, my master!','',0,0,0,0,0,0,1,0,0,0,50452,0,26124),
(93664,'Go, prepare an army of your kind. They too will serve the legion.','',0,0,0,0,0,0,1,0,0,0,50933,0,26124),
(93665,'We are ready. Let it come!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93666,'Marius, you prideful glutton. You almost got me killed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93667,'I... can\'t... hold it... any longer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93668,'This... demon... is too powerful. I can\'t contain it for long and we... are not strong enough... to defeat it by ourselves.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93669,'Kilrogg and others... they wounded themselves here. Mmm... sacrifice?','',0,0,0,0,0,0,0,0,0,0,50309,0,26124),
(93670,'It is Kilrogg\'s eye, I can smell it. We must go, the spirits are enraged.','',0,0,0,0,0,0,0,0,0,0,50310,0,26124),
(93671,'Could I purchase a copy?','Could I purchase a copy?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(93672,'','Smooth sailing so far. Give me a status report.',0,0,0,0,0,0,1,0,0,0,0,53290,26124),
(93673,'King Wrynn and the Stormwind Fleet arrived several hours ago. Reports indicate heavy fighting.','',0,0,0,0,0,0,0,0,0,924,53291,0,26124),
(93674,'<The ghost wails mournfully.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93675,'I wish to hear your music.','I wish to hear your music.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93676,'<The ghost seems a bit happier.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93677,'Let\'s see what we can discover. Oh and keep your guard, this might draw some attention our way.','',0,0,0,0,0,0,1,0,0,0,50810,0,26124),
(93678,'I\'ve seen enough. Iskar is lost to us, he has traded one curse for another.','',0,0,0,0,0,0,603,0,0,0,50811,0,26124),
(93679,'We are all that stands between the sanctity of this forest and the demonic legions that would raze it to the ground.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93680,'The power - it courses through my veins! It is like nothing you\'ve ever felt.','The power - it courses through my veins! It is like nothing you\'ve ever felt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93681,'Gul\'dan will save us. Gul\'dan is our last hope. His is the way!','Gul\'dan will save us. Gul\'dan is our last hope. His is the way!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93682,'Great is the power of the Legion. You will know no fear. No doubt. Everything is clear!','Great is the power of the Legion. You will know no fear. No doubt. Everything is clear!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93683,'Your destiny lies in Tanaan. Come! Drink the fel gift, and you will be as war incarnate.','Your destiny lies in Tanaan. Come! Drink the fel gift, and you will be as war incarnate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93684,'Your leaders have failed you! Only Gul\'dan can save our race. Join us or perish in defeat.','Your leaders have failed you! Only Gul\'dan can save our race. Join us or perish in defeat.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93685,'This is not your destiny. Gul\'dan will lead us to victory. It is not too late!','This is not your destiny. Gul\'dan will lead us to victory. It is not too late!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93686,'Need some help with the shopping list?\n\nBass Blaster\'s easy. The Ogres love loud music to go with their fights at the Ring of Blood. The spectators aren\'t there to fight. Just take it from them!\n\nI seem to remember a working Laz-tron down at Pinchwhistle Point, from a gig I played there once.\n\nWe\'ll never find a real Phonic Amplifier, so just rip a big hunk of metal off of one of those Arakkoa sun constructs. That\'ll do fine.\n\nAs for the capacitor, you\'ll probably need to break open an Iron Horde shredder. Seems like your kind of work.\n\nOh, and the kind of wood I need has to be seriously ancient, so Everbloom Wilds is probably your best bet in Draenor.','Need some help with the shopping list?\n\nBass Blaster\'s easy. The Ogres love loud music to go with their fights at the Ring of Blood. The spectators aren\'t there to fight. Just take it from them!\n\nI seem to remember a working Laz-tron down at Pinchwhistle Point, from a gig I played there once.\n\nWe\'ll never find a real Phonic Amplifier, so just rip a big hunk of metal off of one of those Arakkoa sun constructs. That\'ll do fine.\n\nAs for the capacitor, you\'ll probably need to break open an Iron Horde shredder. Seems like your kind of work.\n\nOh, and the kind of wood I need has to be seriously ancient, so Everbloom Wilds is probably your best bet in Draenor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93687,'Destroy them - in the name of Gul\'dan!','Destroy them - in the name of Gul\'dan!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93688,'Nothing will stop us.','Nothing will stop us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93689,'Where can I get more music rolls?','Where can I get more music rolls?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93690,'Kill me if you can - but nothing will stop the Legion I serve!','Kill me if you can - but nothing will stop the Legion I serve!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93691,'Another victory in the name of Gul\'dan!','Another victory in the name of Gul\'dan!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93692,'Deep in the heart of Blackrock is a track so legendary, it takes two dragons to protect it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93693,'Up for a journey into the Black Temple? You still won\'t be prepared for the hard hitting bass of the track you\'ll find.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93694,'Face his wrath, in that flying fortress, with that icy weather? All for new music? You\'re crazy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93695,'Finding classic tracks takes hard work, and sometimes that means flying on the back of a colossal, cataclysmic dragon. Them\'s the breaks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93696,'Conquering fear itself will help you glimpse the Heart of Pandaria, musically speaking, of course.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93697,'You\'re already leading a campaign against the Iron Horde. Might as well take Blackhand\'s music roll collection while you\'re at it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93698,'Lion\'s Landing has a track as fresh as the sea. Watch out for sharks!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93699,'EXTREMELY PLACEHOLDER EVENT!!!! YSERA ARRIVES, POOF!','EXTREMELY PLACEHOLDER EVENT!!!! YSERA ARRIVES, POOF!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93700,'Got a rod and reel handy? I hear there\'s an artist leaving her work in creative places in Ironforge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93701,'Tinkertown is good, clean fun. Good music, too!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93702,'Are you dying for more music? I hear the spirits of Duskwood are something to behold.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93703,'I camped out once in Winterspring with this amazing artist who loved cold, crisp weather. I\'d love to hear his stuff again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93704,'Ashenvale\'s a magical place. Musicians have been known to find shady nooks there, and write for weeks on end.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93705,'Songs of the Black Temple used to echo through the Warden\'s prison. I wonder if I\'ll ever hear those again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93706,'Invincible is a pretty bold name for a music track, let alone a horse.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93707,'Opera can make a great roll, if you\'re adventurous enough to find it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93708,'Songs of Northrend valor are worth seeking out as morale boosters for your troops.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93709,'Faerie Dragons are known to make amazing music, if you catch them in the right Glade.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93710,'Willing to get dirty for a new track? I hear the Stranglethorn Arena\'s prize pot has been sweetened lately.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93711,'I once ran into a grizzled musician in the hills of Northrend with a ton of talent. He\'d be worth finding.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93712,'Titan songs of Ulduar are awfully hard to come by these days.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93713,'Hearing carousel music always takes me back. Maybe the Darkmoon Faire has a roll of that somewhere?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93714,'Sylvanas\' legendary lamentation was recorded only once. Rumor is she keeps it in a very safe place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93715,'Tyrande herself loves the mysterious Shalandis Isle roll. She has the only copy I\'ve ever seen.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93716,'Lorewalkers love great music almost as much as they love food and drink.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93717,'Don\'t you just love the outdoors? Go ahead, breathe in that crisp mountain air!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93718,'It\'s crisp!','It\'s crisp!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93719,'I literally just said that.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93720,'<Breathe deeply.>','<Breathe deeply.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93721,'Ha ha! There you go! Now what brings you out here, friend?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93722,'I\'d rather be in a tavern right now.','I\'d rather be in a tavern right now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93723,'If there\'s a game of Hearthstone going on there, you\'ll probably find my father as well.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93724,'I\'m looking for a song...','I\'m looking for a song...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93725,'Nothing in particular.','Nothing in particular.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93726,'Ha! Well I wish you the best in your travels, then!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93727,'The... mountain air?','The... mountain air?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93728,'You sure do like to talk about air! Bit of a one-trick subject, though. \n\nBoring, is what I\'m saying.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93729,'A song? Well, there\'s nothing that goes better with lumberjacking than singing, that\'s for sure!  \n\nWhat kind of song are you looking for?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93730,'A song about lumberjacking?','A song about lumberjacking?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93731,'A song about adventure!','A song about adventure!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93732,'A song about the wilderness.','A song about the wilderness.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93733,'We don\'t sing songs ABOUT lumberjacking. That would be crazy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93734,'Can\'t say I\'ve had too many of those, spend most of my time around these parts.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93735,'Ha, yes! The wilderness is both serene and wild, the perfect subject of a song.\n\nI happen to have one of the old lumberjack\'s songs written down here. Would you like a copy?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93736,'Yes!','Yes!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93737,'Yes, please.','Yes, please.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93738,'No.','No.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93739,'Well, it was nice talking to you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93740,'Here you go!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(93742,'I hope that song reminds you of the wilds of Northrend!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93743,'Feeling a song of war? Domination Point in Pandaria used to shake with heavy drum beats.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93744,'How about fishing the Bluffs? An eccentric musician is known to toss rolls of hers in there, from time to time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93745,'Trolls make some... interesting music. Their best stuff is somewhere in Zul\'Gurub.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93746,'Where can I get some really hard to find music rolls?','Where can I get some really hard to find music rolls?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93747,'I still need more music rolls! Where should I go to finish my collection?','I still need more music rolls! Where should I go to finish my collection?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93748,'Such power - you\'ve never experienced anything like it.','Such power - you\'ve never experienced anything like it.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93749,'Put your faith in Gul\'dan. He knew what was right all along.','Put your faith in Gul\'dan. He knew what was right all along.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93750,'Our time is now. Gul\'dan will save us. Our power will be infinite!','Our time is now. Gul\'dan will save us. Our power will be infinite!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(93751,'The fel is not a curse. It\'s a gift. A wonderous gift!','The fel is not a curse. It\'s a gift. A wonderous gift!',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(93752,'','Were it not for the Archdruid Seferaes Nightmane, we would not be alive.$b$bWe were greatly outnumbered and wounded, but Seferaes ferociously fought to preserve our lives with no regard to his own safety.$b$bThe Archdruid was wounded in the battle and, though we tried to treat his wounds, he insisted that there was no time.$b$bLast I saw of him, he fought his way up the cliff to Moonrise Cavern.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93753,'Malfurion Stormrage has sent me to find the Archdruid of the Prowl.','Malfurion Stormrage has sent me to find the Archdruid of the Prowl.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93754,'<Reshad reads over the page.>$B$BSo, his travel here was in truth to hide his search for this \"cipher.\" This is troubling but there are many unanswered questions that remain.$b$bI have a small vial of enchanted sands that when paired with the book will show us what occurred when it was last in Iskar\'s hands.$b$bWhen you are ready we will see what really happened.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93755,'','There were... too many...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93756,'','I see enemies coming in from the lagoon!',0,0,0,0,0,0,0,0,0,0,0,52867,26124),
(93757,'Those are no enemies, starlight.','',0,0,0,0,0,0,0,0,0,0,52864,0,26124),
(93758,'Farondis, old friend. Is that you?','',0,0,0,0,0,0,0,0,0,0,52854,0,26124),
(93759,'We\'re here to help. The naga are right on our tail.','',0,0,0,0,0,0,0,0,0,0,52528,0,26124),
(93760,'The Tidestone calls to them. We cannot let them approach.','',0,0,0,0,0,0,0,0,0,0,52860,0,26124),
(93761,'$p. Aid Prince Farondis in the southeast.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93762,'Heroes! Something is attacking me from behind!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93763,'Someone, anyone, go protect Senegos!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93764,'$p, to me! The naga are about to break through!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93765,'The Tidestone... such power...','',0,0,0,0,0,0,0,0,0,0,52819,0,26124),
(93766,'','You... Runas! What are you doing here?',0,0,0,0,0,0,0,0,0,0,0,52875,26124),
(93767,'So sorry, my friends. I just couldn\'t help myself.','',0,0,0,0,0,0,0,0,0,0,52822,0,26124),
(93768,'Sisters, brothers! The great mana crystal I promised lies in the pool above!','',0,0,0,0,0,0,0,0,0,0,52834,0,26124),
(93769,'','They\'re attacking, we need re-enforcements in the north east.',0,0,0,0,0,0,0,0,0,0,0,52870,26124),
(93770,'','|TInterface\\Icons\\achievement_boss_princesstheradras.blp:40|tMy master\'s master knows your plans, dragon. The Tidestone shall not be yours.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93771,'The demons have returned.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93772,'Idri. Protect the great dragon at all costs.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93773,'','Yes, my prince.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93774,'','Come join us, $p. We could use your weapon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93775,'Forget the Tidestone, brothers. Let the lizards and the lowborn have their crystal.','',0,0,0,0,0,0,0,0,6,0,52846,0,26124),
(93776,'We will feast on the dragons instead!','',0,0,0,0,0,0,0,0,6,0,52825,0,26124),
(93777,'$p, my starlight is in danger! Protect her!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93778,'Great day for some tunes, eh Commander?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93779,'A quiet garrison is a sad garrison. Nothing some music can\'t fix!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93780,'Need some help with the shopping list?\n\nI hate to encourage theft, but the Ogres partying at the Ring of Blood love their Bass Blaster. I doubt they\'ll be in a fighting mood, but don\'t stick around after you swipe it from them.\n\nI had a Laz-tron Disc Reader stolen from me a few weeks ago, and I couldn\'t get the Goblin smell out of my bunk for a week. Check Pinchwhistle Point.\n\nPhonic Amplifiers are tough to find. A piece of metal from an Arakkoa construct might be enough.\n\nIf you\'re up to sticking it to some Iron Horde, their shredders in Talador usually have the sort of capacitor I need.\n\nAnd for the finishing touch, wood from the ancients in Gorgrond, if the Commandojacks have spared any.','Need some help with the shopping list?\n\nI hate to encourage theft, but the Ogres partying at the Ring of Blood love their Bass Blaster. I doubt they\'ll be in a fighting mood, but don\'t stick around after you swipe it from them.\n\nI had a Laz-tron Disc Reader stolen from me a few weeks ago, and I couldn\'t get the Goblin smell out of my bunk for a week. Check Pinchwhistle Point.\n\nPhonic Amplifiers are tough to find. A piece of metal from an Arakkoa construct might be enough.\n\nIf you\'re up to sticking it to some Iron Horde, their shredders in Talador usually have the sort of capacitor I need.\n\nAnd for the finishing touch, wood from the ancients in Gorgrond, if the Commandojacks have spared any.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93781,'For Gul\'dan!','For Gul\'dan!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93782,'You\'ll never defeat us. We are legion!','You\'ll never defeat us. We are legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93783,'','The Archdruids have studied at the feet of Cenarius himself for thousands of years.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(93784,'Your fate is sealed.','Your fate is sealed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93785,'For the glory of Gul\'dan!','For the glory of Gul\'dan!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93786,'Get moving! We need to get these supplies to Tanaan.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(93787,'We\'re pulling out. Go go go!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(93788,'Step it up, you peons. You don\'t want to be left behind.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93789,'Gul\'dan wants us in Tanaan. This is our last chance. Haul those crates!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(93790,'Faster, faster. Let\'s get this gear on the boat to Tanaan. Today, you scrubs!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(93791,'This is no place to linger. I\'ll head back to Aktar\'s camp.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93792,'If anyone is going to be able to stop Iskar, it\'s you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93793,'I was just speaking with Aktar. Did you know that he used to be a Sky Admiral before he was banished by the adherents?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93794,'Keep Aktar safe Percy. I\'ll be back soon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93795,'The forest whispered of your arrival, young one.$b$bFew outsiders have entered my precious grove. Please show reverence during your visit.','',0,0,0,0,0,0,0,0,0,43622,0,0,26124),
(93796,'These harpies have coexisted peacefully with us for ages.$b$bWhat could have prompted such aggression?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93797,'','Fools! This forest will soon die... and you with it!',0,0,0,0,0,0,0,0,0,0,0,52321,26124),
(93798,'','Wretched! Soon... <cough>... you will follow me in death!',0,0,0,0,0,0,0,0,0,0,0,52322,26124),
(93799,'','',0,0,0,0,0,0,0,0,0,32869,0,0,26124),
(93800,'Come at me!','',0,0,0,0,0,0,0,0,0,0,61499,0,26124),
(93801,'Stab it! Stab it! Hahaha!','',0,0,0,0,0,0,0,0,0,0,61491,0,26124),
(93802,'You\'re not taking our dragons!','',0,0,0,0,0,0,0,0,0,0,61502,0,26124),
(93803,'Let\'s kill it!','',0,0,0,0,0,0,0,0,0,0,61503,0,26124),
(93804,'Arrgh!','',0,0,0,0,0,0,0,0,0,0,61500,0,26124),
(93805,'You win... this time...','',0,0,0,0,0,0,0,0,0,0,61493,0,26124),
(93806,'Can\'t see... too much pain...','',0,0,0,0,0,0,0,0,0,0,61501,0,26124),
(93807,'Just wanted... a little fun...','',0,0,0,0,0,0,0,0,0,0,61504,0,26124),
(93808,'The Nightmare will consume us all!','',0,0,0,0,0,0,0,0,0,0,52327,0,26124),
(93809,'All that remains... agony... madness!','',0,0,0,0,0,0,0,0,0,0,52328,0,26124),
(93810,'<The body of this nightsaber matriarch is not long dead. It appears to have put up a stalwart fight before eventually succumbing to its wounds.>','<The body of this nightsaber matriarch is not long dead. It appears to have put up a stalwart fight before eventually succumbing to its wounds.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93811,'','Flesh and bone to earth and stone!',0,0,0,0,0,0,0,0,0,0,0,61237,26124),
(93812,'','This land is ours now!',0,0,0,0,0,0,0,0,0,0,0,61232,26124),
(93813,'','Behold my curse!',0,0,0,0,0,0,0,0,0,0,0,61242,26124),
(93814,'','Fool! Die!',0,0,0,0,0,0,0,0,0,0,0,61240,26124),
(93815,'','The Witchmother commands it!',0,0,0,0,0,0,0,0,0,0,0,61235,26124),
(93816,'','Flay the flesh and scatter the bones!',0,0,0,0,0,0,0,0,0,0,0,61238,26124),
(93817,'','No... it cannot be!',0,0,0,0,0,0,0,0,0,0,0,61233,26124),
(93818,'','This land... is.. ours...',0,0,0,0,0,0,0,0,0,0,0,61243,26124),
(93819,'','Ahh... curse you!',0,0,0,0,0,0,0,0,0,0,0,61241,26124),
(93820,'','We will not be stopped!',0,0,0,0,0,0,0,0,0,0,0,61236,26124),
(93821,'','You cannot... escape... the curse!',0,0,0,0,0,0,0,0,0,0,0,61239,26124),
(93822,'','Crrggghaaawww!',0,0,0,0,0,0,0,0,0,0,0,61234,26124),
(93823,'I live!','I live!',0,0,0,0,0,0,0,0,0,0,0,60965,26124),
(93824,'Ahh, to breathe again!','Ahh, to breathe again!',0,0,0,0,0,0,0,0,0,0,0,60966,26124),
(93825,'Bless you, stranger!','Bless you, stranger!',0,0,0,0,0,0,0,0,0,0,0,60967,26124),
(93826,'You have my gratitude, traveler.','You have my gratitude, traveler.',0,0,0,0,0,0,0,0,0,0,0,60968,26124),
(93827,'I felt myself slipping away...','I felt myself slipping away...',0,0,0,0,0,0,0,0,0,0,0,60969,26124),
(93828,'You... you have saved me!','You... you have saved me!',0,0,0,0,0,0,0,0,0,0,0,60970,26124),
(93829,'','Those afflicted with the curse have little time... we must hurry!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93830,'','We have saved all that we can, $n. I\'ll meet you back in the grove. Elen\'elora-ethil.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93831,'Terrors... everywhere!','Terrors... everywhere!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93832,'No... not my mind! Stop!','No... not my mind! Stop!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93833,'The Nightmare comes for you!','The Nightmare comes for you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93834,'Help me! Why won\'t you help me?!','Help me! Why won\'t you help me?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93835,'They\'re chasing me... They... Make them stop!','They\'re chasing me... They... Make them stop!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93836,'Bwahaha... HAHAHA!','Bwahaha... HAHAHA!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93837,'Welcome to your nightmare!','',0,0,0,0,0,0,0,0,0,40029,61459,0,26124),
(93838,'Soon, you will welcome death with open arms!','',0,0,0,0,0,0,0,0,0,40029,61439,0,26124),
(93839,'This land shall be consumed!','',0,0,0,0,0,0,0,0,0,40029,52344,0,26124),
(93840,'You cannot stop us. We are Legion!','',0,0,0,0,0,0,0,0,0,40029,61453,0,26124),
(93841,'My master will devour... your... soul...','',0,0,0,0,0,0,0,0,0,40029,52346,0,26124),
(93842,'The Nightmare... welcomes me...','',0,0,0,0,0,0,0,0,0,40029,61458,0,26124),
(93843,'You cannot... escape... your dreams....','',0,0,0,0,0,0,0,0,0,40029,61438,0,26124),
(93844,'Fool... this land is already doomed...','',0,0,0,0,0,0,0,0,0,40029,61460,0,26124),
(93845,'Who dares disturb Lord Balnazzar\'s work?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93846,'You cannot hide from our gaze.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93847,'Our lord needs more time. Slay them all in the name of the Legion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93848,'The Ashbringer belongs to the Legion. All who stand in our way shall burn!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93849,'Zerus... will... stop... you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93850,'You will suffer for a thousand lifetimes.','',0,0,0,0,0,0,0,0,0,0,52050,0,26124),
(93851,'NO! The Ashbringer... must not...','',0,0,0,0,0,0,0,0,0,0,52020,0,26124),
(93852,'','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-COMMANDER SARANNIS.blp:50:80|t$b[Lady Liadrin] By the Light, Tirion is alive!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93853,'','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-COMMANDER SARANNIS.blp:50:80|t$b[Lady Liadrin] We will scout ahead and try to find some sign of Tirion. We\'re with you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93854,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-GRAND CHAMPIONS-ALLIANCE.blp:50:80|t$b[Lord Maxwell Tyrosus] We found him, champion! Tirion is alive!','',0,0,0,0,0,0,0,0,0,924,0,0,26124),
(93855,'','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-COMMANDER SARANNIS.blp:50:80|t$b[Lady Liadrin] We found him, champion! Tirion is alive!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93856,'Tirion needs to speak with you, champion. The Ashbringer is lost!','',0,0,0,0,0,0,0,0,0,924,0,0,26124),
(93857,'','Tirion needs to speak with you, champion. The Ashbringer is lost!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93858,'','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-COMMANDER SARANNIS.blp:50:80|t$b[Lady Liadrin] Champion, move ahead and find Tirion. We will cover your advance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93859,'','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-COMMANDER SARANNIS.blp:50:80|t$b[Lady Liadrin] The Ashbringer is somewhere in the crevice ahead - we need to hold these demons off long enough for someone to make it through their lines!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93860,'What sort of bait would ya like?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93861,'Abyssal Gulper Eel','Abyssal Gulper Eel',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93862,'Sea Scorpion','Sea Scorpion',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93863,'Blind Lake Sturgeon','Blind Lake Sturgeon',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93864,'Blackwater Whiptail','Blackwater Whiptail',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93865,'Fire Ammonite','Fire Ammonite',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93866,'Jawless Skulker','Jawless Skulker',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93867,'Fat Sleeper','Fat Sleeper',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93868,'Any regular fish bait?','Any regular fish bait?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93869,'','Our first combat mission, time to prove that Bravery isn\'t just a name.',0,0,0,0,0,0,0,0,0,0,0,53292,26124),
(93870,'','I haven\'t seen so much as a seagull for hours now.',0,0,0,0,0,0,6,0,0,0,0,53293,26124),
(93871,'There is a foulness in the air, and we are headed directly towards it.','',0,0,0,0,0,0,1,0,0,924,53301,0,26124),
(93872,'Face my wrath.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93873,'Eternal suffering.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93874,'','You\'ll find the giants to the southeast. There are a few ways into their arena. Good luck.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93875,'Aid me, damn you. Our lord must not be disturbed!','',0,0,0,0,0,0,0,0,0,0,52023,0,26124),
(93876,'','Disciples! Your work is not yet done!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93877,'I... am returned...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93878,'Once more into the breach!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93879,'I am the Enforcer\'s will... and your demise.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93880,'You will trespass no further!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93881,'','I was to be... undying...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93882,'','Harbinger, restore my wounds!',0,0,0,0,0,0,0,0,0,0,0,50721,26124),
(93883,'','The Sovereign watches over me!',0,0,0,0,0,0,0,0,0,0,0,50589,26124),
(93884,'','The Eredar are no strangers to war. Are you so eager to meet your end?',0,0,0,0,0,0,0,0,0,0,0,50585,26124),
(93885,'','Enough! This is where you die!',0,0,0,0,0,0,0,0,0,0,0,50592,26124),
(93886,'','What a... tragedy...',0,0,0,0,0,0,0,0,0,0,0,50586,26124),
(93887,'','A tempest of righteous fire!',0,0,0,0,0,0,0,0,0,0,0,50602,26124),
(93888,'By all that is good in this world... you did it. The Ashbringer is saved!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93889,'','Insects deserve to be crushed!',0,0,0,0,0,0,0,0,0,0,0,50601,26124),
(93890,'The blade glows so brightly... not even at the top of Icecrown Citadel have I seen it so powerful. It must be so.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93891,'','Your pathetic defeat was... inevitable.',0,0,0,0,0,0,0,0,0,0,0,50587,26124),
(93892,'All Paladins, hear my voice. The Ashbringer has chosen its successor.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93893,'$p will wield its power against the forces of the Legion. They will strike at the very heart of darkness. The Light shall TRIUMPH!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93894,'','Your attempts, meaningless.',0,0,0,0,0,0,0,0,0,0,0,50723,26124),
(93895,'','Your existence, without purpose.',0,0,0,0,0,0,0,0,0,0,0,50598,26124),
(93896,'','Your failures, absolute.',0,0,0,0,0,0,0,0,0,0,0,50599,26124),
(93897,'','Your thoughts, insipid.',0,0,0,0,0,0,0,0,0,0,0,50600,26124),
(93898,'Work faster, I will not tolerate any further delays!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93899,'If this reaver isn\'t finished in time, I will devour your souls!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93900,'Yes! Fight for your pathetic life, mortal! I could use the entertainment.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93901,'I will feast upon your heart!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93902,'You will suffer for this disturbance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93903,'This... isn\'t over!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93904,'I\'ll be back... I\'ll... have my revenge...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93905,'Fool! The shadows betray you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93906,'I am prepared. Take me to the Nor\'danil Wellspring.','I am prepared. Take me to the Nor\'danil Wellspring.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93907,'I feel strong enough to perform this task, $n, but it cannot be done here. I must first take the Tidestone fragments to the Nor\'danil Wellspring, in the west.$b$bMy drakes will protect me, of course... but I would appreciate having you nearby. Hop on my back. I will take you there much more quickly than your small legs could manage.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93908,'','These naga invaded Azsuna only recently. They\'ve been trying to free Prince Farondis.\n\nNo doubt, like you, they and Queen Azshara are after the Tidestone of Golganneth. The prince knows where it is.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(93909,'No, please! No!','No, please! No!',0,0,0,0,0,0,0,0,0,924,0,0,26124),
(93910,'No, please! No!','No, please! No!',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(93911,'Another ear for my necklace!','Another ear for my necklace!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93912,'I saw you at the Iron Docks! This time you\'re going down!','I saw you at the Iron Docks! This time you\'re going down!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93913,'You\'re finished!','You\'re finished!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93914,'Engaging!','Engaging!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93915,'Drop \'em!','Drop \'em!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93916,'Fire at will!','Fire at will!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93917,'Suppress that target!','Suppress that target!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93918,'(Possible transition scene showing Thrymjaris empowering your artifact.)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93919,'Are you ready to take the fight to the Drekirjar?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93920,'Let\'s blast these Vrykul!','Let\'s blast these Vrykul!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93921,'How nice of you to spare me the trouble of culling the weak. Come, I will show you a real fight!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93922,'Soon, you will beg for death!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93923,'Couldn\'t take the pain?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93924,'Did you even try?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93925,'Ah, your tears are pure ecstasy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93926,'Inconceivable...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93927,'Sargeras fills us with his presence.','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(93928,'Feel the wrath of the God of Fel and Flame!','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(93929,'The Destroyer of Worlds grants me his power. Your time has come, mortal!','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(93930,'Hey there, $c.  I\'m looking to trade for some leather, so whaddya say?','Hey there, $c.  I\'m looking to trade for some leather, so whaddya say?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93931,'I grow bored of waiting for a real challenge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93932,'I knew you were too pathetic to face me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93933,'I will show you to your maker!','I will show you to your maker!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93934,'Are you so eager to meet your ancestors?','Are you so eager to meet your ancestors?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93935,'Unfortunately for you, your spirit will never see Auchindoun!','Unfortunately for you, your spirit will never see Auchindoun!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93936,'The naaru\'s promises were empty. Our new master gives us true power!','The naaru\'s promises were empty. Our new master gives us true power!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93937,'What good is faith, when the Legion grants such power?','What good is faith, when the Legion grants such power?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93938,'Fool! You follow the wrong path!','Fool! You follow the wrong path!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93939,'The Legion is truth. The Legion is strength!','The Legion is truth. The Legion is strength!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93940,'In the Light, I saw only emptiness.','In the Light, I saw only emptiness.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93941,'Who dares interrupt me?','Who dares interrupt me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93942,'What a nuisance. I will deal with you, first!','What a nuisance. I will deal with you, first!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93943,'Katra zil shukil! You will die for your insolence!','Katra zil shukil! You will die for your insolence!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93944,'You will take our secrets to the grave!','You will take our secrets to the grave!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93945,'The power of the Legion flows through me!','The power of the Legion flows through me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93946,'','They are here Teron\'gor! We must leave.',0,0,0,0,0,0,0,0,0,0,0,50607,26124),
(93947,'NO! So many souls... such power...','',0,0,0,0,0,0,0,0,0,0,50381,0,26124),
(93948,'You will not interrupt my feast!','',0,0,0,0,0,0,0,0,0,0,50382,0,26124),
(93949,'You cannot stop me now!','',0,0,0,0,0,0,0,0,0,0,50383,0,26124),
(93950,'I will add your soul to the others I have claimed!','',0,0,0,0,0,0,0,0,0,0,50384,0,26124),
(93951,'I must have it all!','',0,0,0,0,0,0,0,0,0,0,50385,0,26124),
(93952,'I will show you my new power!','',0,0,0,0,0,0,0,0,0,0,50386,0,26124),
(93953,'','Cease your desecration of my ancestors!',0,0,0,0,0,0,0,0,0,0,0,50571,26124),
(93954,'','Time to die vile beast!',0,0,0,0,0,0,0,0,0,0,0,50434,26124),
(93955,'Bah! I will return here once Gul\'dan has annihilated you.','',0,0,0,0,0,0,0,0,0,0,50387,0,26124),
(93956,'Your boots! Yes... we has them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93957,'Attack the feet! The feet!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93958,'','Wretched $c, be purged by the flames of a new world!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93959,'If you\'ll excuse us, Council and guests. I need to speak with $n immediately.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93960,'Follow me, friend. This won\'t take long, I promise.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93961,'','I will do whatever it takes to stop Gul\'dan. Wherever you lead, I will follow... commander.',0,0,0,0,0,0,6,0,0,0,0,49639,26124),
(93962,'Start Phase 2!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93963,'You have been gathered here because you are weak. On every front we have been broken by our enemies. Even now they close in upon us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93964,'Why did we end up in this situation? Pride. Hellscream\'s foolish pride denied us the means to unleash our true strength.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93965,'However Gul\'dan is merciful. He again offers you the power to surpass your mortal limits! Partake of this gift and obtain the might that\'s been denied you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93966,'This device is imbued with powerful magic. Perhaps it is linked to these portraits lining the chamber walls?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(93967,'You have been chosen to partake of the master\'s gift. Step forward and drink. Obtain the strength that has for so long been denied you!','You have been chosen to partake of the master\'s gift. Step forward and drink. Obtain the strength that has for so long been denied you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93968,'','They must be rooted out before they accomplish their task.',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(93969,'','I fear for the countless souls this Gorefiend has consumed. He must be destroyed!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(93970,'Start Phase 3!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93971,'Start Phase 4!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93972,'Hold them here, Mannoroth. My work is almost done. Our master comes...','',0,0,0,0,0,0,0,0,0,0,50951,0,26124),
(93973,'We need you to sneak into the compound. SNEAK! Stealthy! Not go blasting around in a rocket like some sort of goblin maniac. Honestly, now. We should\'ve never given you a garrison.','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(93974,'|TInterface\\Icons\\warlock_summon_doomguard.blp:20|t|cFFFF0000$n|r has been afflicted with |cFFFF0000|Hspell:181275|h[Curse of the Legion]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(93975,'|cFFFF0000%s|r appears and begins to empower the Fel Spire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(93976,'Raaaaaaghh!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93977,'GRRAAaaaaggghhh!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93978,'|cFFFF0000%s|r begins to empower the Fel Spire!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(93979,'DIE! DIE! DIE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93980,'I AM IMMORTAL!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93981,'B... Blood! Can\'t fight it... must kill!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93982,'It\'s so... dark...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93983,'I regret nothing...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93984,'Just one more... strike...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93985,'I\'m... free now...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93986,'I... should have... never drank...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93987,'You make it seem so easy.','',0,0,0,0,0,0,603,0,0,0,50819,0,26124),
(93988,'Grim... but necessary.','',0,0,0,0,0,0,1,0,0,0,50820,0,26124),
(93989,'Back to the shadows with them.','',0,0,0,0,0,0,603,0,0,0,50821,0,26124),
(93990,'I didn\'t expect that to be over so quickly.','',0,0,0,0,0,0,1,0,0,0,50822,0,26124),
(93991,'|cFFFF0000%s|r begins to cast |cFFFF0000|Hspell:182178|h[Fel Chakram]|h|r at you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(93992,'You cannot have more than 10 seals at once!  Too much fate-twisting is a terrible thing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93993,'<Laanda eyes you up and down, then whispers urgently.>$B$BWhat are you doing, $c? If you mean to carry out your garrison mission without getting caught, YOU NEED A DISGUISE.$B$BSpeak to me again when you have acquired and equipped a Sargerei Disguise.$B$BKill the nearby Sargerei and loot their clothing if you have to. Just don\'t compromise my cover.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93994,'I cannot give you any Seals of Inevitable Fate.  Maybe a time in the future?  Either when you are powerful enough to wield them or enough time has passed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93995,'','Light\'s sake, what is THAT?',0,0,0,0,0,0,603,0,0,0,0,53295,26124),
(93996,'It appears to be a great source of fel energy. I have never seen anything like it.','',0,0,0,0,0,0,603,0,0,924,53304,0,26124),
(93997,'$p, thank the Light I found you. I must speak with you at once.','',0,0,0,0,0,0,1,0,0,0,52004,0,26124),
(93998,'','We will mend Tirion\'s wounds enough to get him out of here. Highlord, you must move on and retrieve the Ashbringer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(93999,'I will lead the diversion on the western gates and draw the Iron Horde forces to me. This will give you and Yrel enough time to establish a base of operations on their flank.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94000,'','The Iron Horde have all but abandoned this area. I was expecting a harder fight for the docks.',0,0,0,0,0,0,396,0,0,0,0,50578,26124),
(94001,'','Bleeding Hollow scavengers. We should deal with their leader and send them scurrying back into the jungle!',0,0,0,0,0,0,0,0,0,0,0,50579,26124),
(94002,'We are the masters of the storm!','',0,0,0,0,0,0,0,0,0,0,51618,0,26124),
(94003,'You have already failed. The Thorignir are broken!','',0,0,0,0,0,0,0,0,0,0,51619,0,26124),
(94004,'You are not worthy of the Thorignir\'s power!','',0,0,0,0,0,0,0,0,0,0,51620,0,26124),
(94005,'The dragons belong to the Skovald, worm!','',0,0,0,0,0,0,0,0,0,0,51713,0,26124),
(94006,'Beg for your life!','',0,0,0,0,0,0,0,0,0,0,52468,0,26124),
(94007,'Kneel to the God-King!','',0,0,0,0,0,0,0,0,0,0,51715,0,26124),
(94008,'Another soul to fuel the legion.','',0,0,0,0,0,0,0,0,0,0,50785,0,26124),
(94009,'Ha ha ha!','',0,0,0,0,0,0,0,0,0,0,50786,0,26124),
(94010,'We will cleave your souls in twain.','',0,0,0,0,0,0,0,0,0,0,50790,0,26124),
(94011,'Yes.. we leave destruction in our wake.','',0,0,0,0,0,0,0,0,0,0,50791,0,26124),
(94012,'Corrupt souls are so easily harvested.','',0,0,0,0,0,0,0,0,0,0,50792,0,26124),
(94013,'You cannot contain our power!','',0,0,0,0,0,0,0,0,0,0,50793,0,26124),
(94014,'We sow the seeds of your demise.','',0,0,0,0,0,0,0,0,0,0,50794,0,26124),
(94015,'Behold the power of the Legion.','',0,0,0,0,0,0,0,0,0,0,50795,0,26124),
(94016,'Die!','',0,0,0,0,0,0,0,0,0,0,50796,0,26124),
(94017,'Suffer!','',0,0,0,0,0,0,0,0,0,0,50797,0,26124),
(94018,'Flame! Death! Destruction!','',0,0,0,0,0,0,0,0,0,0,50782,0,26124),
(94019,'We are as one.','',0,0,0,0,0,0,0,0,0,0,50783,0,26124),
(94020,'We are unstoppable!','',0,0,0,0,0,0,0,0,0,0,50784,0,26124),
(94021,'Power unleashed!','',0,0,0,0,0,0,0,0,0,0,50780,0,26124),
(94022,'We will consume this puny world.','',0,0,0,0,0,0,0,0,0,0,50798,0,26124),
(94023,'We are... bested.','',0,0,0,0,0,0,0,0,0,0,50781,0,26124),
(94024,'','If these looters are roaming free, where is the rest of Gul\'dan\'s Horde? They may be waiting for us up ahead.',0,0,0,0,0,0,0,0,0,0,0,50580,26124),
(94025,'','Warlocks and their foul magic! If Gul\'dan has his way, this whole world would burn.',0,0,0,0,0,0,0,0,0,0,0,50582,26124),
(94026,'I have little time for talk. Unimaginable destruction marches towards us and we are all that stands in the way.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94027,'','Deserted except for looters and warlocks. What are Gul\'dan\'s minions doing so close to the ruins of the portal?',0,0,0,0,0,0,0,0,0,0,0,50581,26124),
(94028,'%s casts |cFFFF0000|Hspell:156446|h[Blast Wave]|h|r! Hide!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(94029,'','Gul\'dan\'s fel magic is corrupting even the very machinery of the Iron Horde! We must fight through this gauntlet...',0,0,0,0,0,0,396,0,0,0,0,50583,26124),
(94030,'|TInterface\\Icons\\Spell_Shadow_GatherShadows.blp:20|tYou\'ve been |cFFFF0000|Hspell:179711|h[Befouled]|h|r, move away from your allies!','|TInterface\\Icons\\Spell_Shadow_GatherShadows.blp:20|tYou\'ve been |cFFFF0000|Hspell:179711|h[Befouled]|h|r, move away from your allies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94031,'|TInterface\\Icons\\spell_fel_elementaldevastation.blp:20|tA |cFFFF0000|Hspell:181498|h[Wake of Destruction]|h|r strikes a |cFFFF0000|Hspell:179620|h[Fel Crystal]|h|r!','|TInterface\\Icons\\spell_fel_elementaldevastation.blp:20|tA |cFFFF0000|Hspell:181498|h[Wake of Destruction]|h|r strikes a |cFFFF0000|Hspell:179620|h[Fel Crystal]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94032,'|TInterface\\Icons\\spell_fel_elementaldevastation.blp:20|t$n\'s |cFFFF0000|Hspell:182008|h[Latent Energy]|h|r reacts violently as they step into the |cFFFF0000|Hspell:179582|h[Rumbling Fissure]|h|r!','|TInterface\\Icons\\spell_fel_elementaldevastation.blp:20|t$n\'s |cFFFF0000|Hspell:182008|h[Latent Energy]|h|r reacts violently as they step into the |cFFFF0000|Hspell:179582|h[Rumbling Fissure]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94033,'|TInterface\\Icons\\spell_fel_elementaldevastation.blp:20|t$n\'s |cFFFF0000|Hspell:182008|h[Latent Energy]|h|r reacts violently as they are struck by a |cFFFF0000|Hspell:181498|h[Wake of Destruction]|h|r!','|TInterface\\Icons\\spell_fel_elementaldevastation.blp:20|t$n\'s |cFFFF0000|Hspell:182008|h[Latent Energy]|h|r reacts violently as they are struck by a |cFFFF0000|Hspell:181498|h[Wake of Destruction]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94034,'This is ours now, back to the sea with you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94035,'Kilrogg will... avenge me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94036,'|TInterface\\Icons\\Spell_Shadow_ChillTouch.blp:20|t|cFFFF0000|Hspell:182008|h[Latent Energy]|h|r corrupts you!','|TInterface\\Icons\\Spell_Shadow_ChillTouch.blp:20|t|cFFFF0000|Hspell:182008|h[Latent Energy]|h|r corrupts you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94037,'|TInterface\\Icons\\Spell_Shadow_SeedOfDestruction.blp:20|tYour |cFFFF0000|Hspell:181508|h[Seed of Destruction]|h|r will emit |cFFFF0000|Hspell:181498|h[Wakes of Destruction]|h|r.','|TInterface\\Icons\\Spell_Shadow_SeedOfDestruction.blp:20|tYour |cFFFF0000|Hspell:181508|h[Seed of Destruction]|h|r will emit |cFFFF0000|Hspell:181498|h[Wakes of Destruction]|h|r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(94038,'|TInterface\\Icons\\ability_deathwing_grasping_tendrilsgreen.blp:20|tThe |cFFFF0000|Hspell:179582|h[Rumbling Fissures]|h|r harden into |cFFFF0000|Hspell:179620|h[Fel Crystals]|h|r!','|TInterface\\Icons\\ability_deathwing_grasping_tendrilsgreen.blp:20|tThe |cFFFF0000|Hspell:179582|h[Rumbling Fissures]|h|r harden into |cFFFF0000|Hspell:179620|h[Fel Crystals]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94039,'|TInterface\\Icons\\ability_warlock_moltencoregreen.blp:20|tFel Lord Zakuun\'s axe begins emitting |cFFFF0000|Hspell:179622|h[Fel Explosions]|h|r!','|TInterface\\Icons\\ability_warlock_moltencoregreen.blp:20|tFel Lord Zakuun\'s axe begins emitting |cFFFF0000|Hspell:179622|h[Fel Explosions]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94040,'|TInterface\\Icons\\inv_axe_2h_pvphorde_a_01blackhigh.blp:20|tFel Lord Zakuun takes up his axe again, |cFFFF0000|Hspell:179670|h[Arming]|h|r himself.','|TInterface\\Icons\\inv_axe_2h_pvphorde_a_01blackhigh.blp:20|tFel Lord Zakuun takes up his axe again, |cFFFF0000|Hspell:179670|h[Arming]|h|r himself.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94041,'|TInterface\\Icons\\inv_axe_2h_orgrimmarraid_d_01.blp:20|tFel Lord Zakuun frenzies and is now |cFFFF0000|Hspell:179671|h[Heavily Armed]|h|r!','|TInterface\\Icons\\inv_axe_2h_orgrimmarraid_d_01.blp:20|tFel Lord Zakuun frenzies and is now |cFFFF0000|Hspell:179671|h[Heavily Armed]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94042,'What is your will, Archdruid? Death and terror surround us...','',0,0,0,0,0,0,1,0,0,0,52305,0,26124),
(94043,'|TInterface\\Icons\\warrior_talent_icon_mastercleaver.blp:20|tFel Lord Zakuun\'s axe sends out |cFFFF0000|Hspell:181498|h[Wakes of Destruction]|h|r!','|TInterface\\Icons\\warrior_talent_icon_mastercleaver.blp:20|tFel Lord Zakuun\'s axe sends out |cFFFF0000|Hspell:181498|h[Wakes of Destruction]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94044,'Finally a break from the boredom of all this \"preparation!\"','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94045,'He will bring me back... he is never finished with... us...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94046,'You pull the Ashbringer out of the ground, holding it up triumphantly. A moment later, Balanazzar appears in front of you.','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(94047,'','Quickly now, you must see this place!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94048,'','Over here, commander!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(94049,'','Excellent location... good fields of fire... excellent recon routes. I recommend planting your banner here, commander.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(94050,'All is lost...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94051,'Don\'t let them feed me to the hounds again...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94052,'I fought well in life... I don\'t belong here','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94053,'Helira! Hear my calls! Please... set me free.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94054,'Doomed... we are all doomed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94055,'Helira, send me to the eternal battlefield. I am worthy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94056,'If we do not act swiftly, the vale will be overrun. Druids, lend me your claws!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94057,'Our losses were almost more than I could bear... but we made it through. To this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94058,'Our siege began the moment you took the boats. It looked like it would be a long battle until a large part of their forces departed suddenly, most likely when you attacked from the east.$b$b\nThen we hit them with everything. Thaelin brought in a massive powered ram and the gates fell quickly. Then we ran into this new foe... the fel orcs. They press us sorely and we can make no headway. I hope you are having better luck in the east.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94059,'Die!','',0,0,0,0,0,0,0,0,0,0,51702,0,26124),
(94060,'You will not win this fight!','',0,0,0,0,0,0,0,0,0,0,51703,0,26124),
(94061,'I will bathe in your blood!','',0,0,0,0,0,0,0,0,0,0,51704,0,26124),
(94062,'I will ascend!','',0,0,0,0,0,0,0,0,0,0,51705,0,26124),
(94063,'We meet again, friend. This place is not Gorgrond, but I do not miss the giant beasts that shake the earth!$b$bI have reports on Zeth\'Gol, the Temple of Sha\'naar, and the Zorammarsh.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94064,'Tell me of Zeth\'Gol.','Tell me of Zeth\'Gol.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94065,'Helya, witness my strength. I am worthy!','',0,0,0,0,0,0,0,0,0,0,51706,0,26124),
(94066,'These Bleeding Hollow are fearsome hunters and trappers. They have lived well in this jungle. Deep inside their village they practice dark blood magic. That cannot be good for us, so I must recommend reducing this village to ash at the earliest opportunity!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94067,'','This poor village... crushed by the Sargerei...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94068,'What is happening at the Temple of Sha\'naar?','What is happening at the Temple of Sha\'naar?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94069,'They destroyed this village some time ago and replaced it with training grounds, demon summoning, and corrupting the wildlife into fel weapons.$b$bThe people that died here must be avenged, commander!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94070,'Incredible. With the Ashbringer and your might at our head, we might still stand a chance of turning the Burning Legion back.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94071,'','The Ashbringer...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94072,'','The hunt continues here, commander. I have reports on Aktar\'s Watch just to the northwest and the Ironmonger\'s Hold, that big tunnel to the southeast.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94073,'Arakkoa in Tanaan? Tell me more of Aktar\'s Watch.','Arakkoa in Tanaan? Tell me more of Aktar\'s Watch.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94074,'','The outcasts are concerned about their brethren. Some lost souls are being trained by the Shadow Council in fel magics and demon summoning. They have even recruited some high arakkoa as well but that area is significantly more dangerous, you will need allies to clear that particular area out. We should clear out this poisonous nest soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94075,'Our men are waiting outside to take us back to Dalaran. We should leave while we still can!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94076,'[Nathanos and his rangers move out.]','[Nathanos and his rangers move out.]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94077,'','Directly ahead, Alliance ships! Make for the beach! Hold on everyone, this is going to get worse before it gets better!',0,0,0,0,0,0,603,0,0,0,0,53303,26124),
(94078,'Thievery will not be tolerated, slave.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94079,'[Nathanos leaps down from the cliff and walks over.]','[Nathanos leaps down from the cliff and walks over.]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94080,'No sign of Sylvanas in the hills. What have we here?','',0,0,0,0,0,0,0,0,0,0,51726,0,26124),
(94081,'That\'s one of hers alright...','',0,0,0,0,0,0,1,0,0,0,51727,0,26124),
(94082,'Eat up, lads! We\'ve a witch to hunt!','',0,0,0,0,0,0,0,0,0,0,51732,0,26124),
(94083,'Ye won\'t stop my hunt!','',0,0,0,0,0,0,0,0,0,0,51731,0,26124),
(94084,'','I\'m not sure if I\'ve ever been in an area that was more determined to kill me!$b$bThat being said I have some early information on Ironhold Harbor just to the northwest, the Fel Forge to the southeast, and the Throne of Kil\'jaeden up on the mountain right behind you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94085,'Lots of ships coming into that harbor, what\'s going on there?','Lots of ships coming into that harbor, what\'s going on there?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94086,'','It appears the Iron Horde is summoning all of its farflung holdings back here. Most Iron Horde troops disembark at the harbor and immediately go to get converted. The rest stay and bring in munitions and other resources to feed their army.$b$bIf Gul\'dan is allowed to convert the entire Iron Horde he will have an unbeatable army!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94087,'Now!','',0,0,0,0,0,0,0,0,0,0,51728,0,26124),
(94088,'Why do you resist your own blood, Ariok? Give into your rage.','',0,0,0,0,0,0,0,0,0,0,50423,0,26124),
(94089,'Release me from these bonds and I will show you my rage, Kilrogg!','',0,0,0,0,0,0,0,0,0,0,50317,0,26124),
(94090,'The choice is simple, Ariok. Submit, or die.','',0,0,0,0,0,0,0,0,0,0,50424,0,26124),
(94091,'I\'ve been waiting for this day!','',0,0,0,0,0,0,0,0,0,0,50419,0,26124),
(94092,'Let\'s see how many fall before I do!','',0,0,0,0,0,0,0,0,0,0,50429,0,26124),
(94093,'Gaze into my eyes and witness your doom!','',0,0,0,0,0,0,0,0,0,0,50430,0,26124),
(94094,'I\'m going to cut your heart out!','',0,0,0,0,0,0,0,0,0,0,50431,0,26124),
(94095,'Was this how you wanted to die?','',0,0,0,0,0,0,0,0,0,0,50427,0,26124),
(94096,'Die!','',0,0,0,0,0,0,0,0,0,0,50426,0,26124),
(94097,'Did you believe you could kill me?','',0,0,0,0,0,0,0,0,0,0,50428,0,26124),
(94098,'You were not the ones I saw.','',0,0,0,0,0,0,0,0,0,0,50422,0,26124),
(94099,'At last, this is the death I saw!','',0,0,0,0,0,0,0,0,0,0,50420,0,26124),
(94100,'FOR AZEROTH!','',0,0,0,0,0,0,0,0,0,0,50632,0,26124),
(94101,'','Soon you will burn with the rest of Azeroth!',0,0,0,0,0,0,0,0,0,0,0,50403,26124),
(94102,'','Burn!',0,0,0,0,0,0,0,0,0,0,0,50404,26124),
(94103,'Unstoppable!','Unstoppable!',0,0,0,0,0,0,0,0,0,0,50357,50357,26124),
(94104,'Crush the weak!','Crush the weak!',0,0,0,0,0,0,0,0,0,0,50358,50358,26124),
(94105,'Fool dwarf. Deliver his head to the foothold!','',0,0,0,0,0,0,0,0,0,0,52951,0,26124),
(94106,'|TInterface\\Icons\\Ability_GolemThunderClap.blp:20|tKormrok begins |cFFFF0000|Hspell:180244|h[Pounding]|h|r the ground!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94107,'|TInterface\\Icons\\Spell_Shaman_TidalWaves.blp:20|tThe Shadow Pool starts generating |cFFFF0000|Hspell:181292|h[Shadow Globules]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94108,'|TInterface\\Icons\\Spell_Shaman_TidalWaves.blp:20|tAll three pools start generating |cFFFF0000|Hspell:181293|h[Fel Globules]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94109,'|TInterface\\Icons\\spell_fire_rune.blp:20|t|cFFFF0000|Hspell:181296|h[Explosive Runes]|h|r appear on the ground!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94110,'|TInterface\\Icons\\spell_fire_rune.blp:20|t|cFFFF0000|Hspell:181297|h[Empowered Explosive Runes]|h|r appear on the ground!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94111,'|TInterface\\Icons\\Spell_Shadow_Requiem.blp:20|tKormrok summons |cFFFF0000|Hspell:181299|h[Grasping Hands]|h|r from the ground!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94112,'|TInterface\\Icons\\Spell_Shadow_Requiem.blp:20|tKormrok summons |cFFFF0000|Hspell:181300|h[Dragging Hands]|h|r from the ground!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94113,'|TInterface\\Icons\\inv_offhand_stratholme_a_02.blp:20|t$n is |cFFFF0000|Hspell:181305|h[Launched]|h|r into the air!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94114,'|TInterface\\Icons\\spell_arcane_teleportdalarancrater.blp:20|tWith no one to absorb their |cFFFF0000|Hspell:182427|h[Impact]|h|r, $n perishes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94115,'|TInterface\\Icons\\Ability_Mage_LivingBomb.blp:20|t$n is going to |cFFFF0000|Hspell:181324|h[Explode]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94116,'|TInterface\\Icons\\Spell_DeathKnight_Strangulate.blp:20|tA Fel Hand starts |cFFFF0000|Hspell:181345|h[Crushing]|h|r $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94117,'|TInterface\\Icons\\INV_Bijou_Purple.blp:20|tKormrok leaps into the Shadow Pool, gaining |cFFFF0000|Hspell:181293|h[Empowered Fel Outpouring]|h|r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94118,'|TInterface\\Icons\\INV_Bijou_Orange.blp:20|tKormrok leaps into the Fiery Pool, gaining |cFFFF0000|Hspell:181297|h[Empowered Explosive Runes]|h|r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94119,'|TInterface\\Icons\\INV_Bijou_Green.blp:20|tKormrok leaps into the Foul Pool, gaining |cFFFF0000|Hspell:181300|h[Empowered Fel Grasp]|h|r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94120,'|TInterface\\Icons\\INV_Bijou_Purple.blp:20|tKormrok leaps into the Shadow Pool, gaining |cFFFF0000|Hspell:181292|h[Fel Outpouring]|h|r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94121,'|TInterface\\Icons\\INV_Bijou_Orange.blp:20|tKormrok leaps into the Fiery Pool, gaining |cFFFF0000|Hspell:181296|h[Explosive Runes]|h|r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94122,'|TInterface\\Icons\\INV_Bijou_Green.blp:20|tKormrok leaps into the Foul Pool, gaining |cFFFF0000|Hspell:181299|h[Fel Grasp]|h|r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94123,'|TInterface\\Icons\\INV_Bijou_purple.blp:20|tA |cFFFF0000|Hspell:181365|h[Violent Reaction]|h|r occurs from Kormrok leaping into the Shadowy Pool!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94124,'|TInterface\\Icons\\INV_Bijou_orange.blp:20|tA |cFFFF0000|Hspell:181370|h[Violent Reaction]|h|r occurs from Kormrok leaping into the Fiery Pool!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94125,'|TInterface\\Icons\\INV_Bijou_green.blp:20|tA |cFFFF0000|Hspell:181371|h[Violent Reaction]|h|r occurs from Kormrok leaping into the Foul Pool!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94126,'|TInterface\\Icons\\spell_fire_rune.blp:20|t$n triggers an |cFFFF0000|Hspell:180370|h[Explosive Rune]|h|r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94127,'|TInterface\\Icons\\spell_fire_rune.blp:20|tAn |cFFFF0000|Hspell:180370|h[Explosive Rune]|h|r explodes on its own.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94128,'|TInterface\\Icons\\Trade_Engineering.blp:20|tThe |cFFFF0000|Hspell:181300|h[Empowered Fel Hand]|h|r |cFFFF0000|Hspell:180442|h[Releases]|h|r a fatal burst of Fel Energy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94129,'He\'s not... the archdruid has... save yourself... run!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94130,'','We got the queen into a rowboat, but she didn\'t want an escort. Told us to stay behind and fight.',0,0,0,0,0,0,1,0,0,0,0,52936,26124),
(94131,'','My guess? She landed somewhere up the coast and continued on foot.',0,0,0,0,0,0,1,0,0,0,0,51730,26124),
(94132,'[Tattersail tells you what she knows and runs away.]','[Tattersail tells you what she knows and runs away.]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94133,'I\'m not dying again without a fight!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94134,'You\'re not feeding me to the hounds this time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94135,'Helira! You can\'t hold me here forever! I will be free!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94136,'This beautiful madness... why did I fight it?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94137,'%s targets you for |cFFFF0404|Hspell:180372|h[Heart Seeker]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(94138,'There is nowhere to hide.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94139,'Something has stirred the furbolgs into a frenzy. In my memory, never have they attacked in force like this.','Something has stirred the furbolgs into a frenzy. In my memory, never have they attacked in force like this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94140,'The heart of a Druid of the Claw never falters. We are the ones who endure.','The heart of a Druid of the Claw never falters. We are the ones who endure.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94141,'Archdruid Steelclaw is still down in the barrows, with the others. We must save them quickly.','Archdruid Steelclaw is still down in the barrows, with the others. We must save them quickly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94142,'We must hold on. We will outlast them, I know it.','We must hold on. We will outlast them, I know it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94143,'Just one... more... fight...','Just one... more... fight...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94144,'Cover\'s blown. Now you die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94145,'We are all doomed to spend an eternity here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94146,'There is no light anymore... only darkness.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94147,'What is this place?','What is this place?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94148,'We are the Legion!','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(94149,'Don\'t you know? You are in Helheim, $r... your soul belongs to Helira now. No one leaves here without the goddess\'s consent.$b$bI have heard rumors the corpses clashing on the eternal battlefield are allowed to leave if they prove their might to Helira.$b$bBut it\'s impossible to get to the battlefield with that beast Guarm guarding the path to Helira.$b$bI\'ve tried to slip by that monster more times than you can imagine, and it always ends the same way... me torn apart and fed to the hounds.','',6,605,0,0,5,0,0,0,0,0,0,0,26124),
(94150,'There has to be a way.','There has to be a way.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94151,'Feel the power flowing through you, servants!','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(94152,'Gorefiend is about to |TInterface\\Icons\\Spell_Shadow_DeathCoil:20|t |cFFFF0404|Hspell:181295|h[Digest]|h|r you!','Gorefiend is about to |TInterface\\Icons\\Spell_Shadow_DeathCoil:20|t |cFFFF0404|Hspell:181295|h[Digest]|h|r you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94153,'We must regroup and rally to our queen. The task of finding the Aegis of Aggramar falls to you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94154,'','The Ashbringer has certainly earned its reputation. We could hear the demons screaming in agony from here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94155,'','We\'ll meet you back at Illidari Stand.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(94156,'','Ha Ha Ha... it looks like we have a new challenger. It has been ages since a soul has approached my throne.',595,0,0,0,0,0,0,0,0,0,0,0,26124),
(94157,'','Baldir, find out what $n\'s soul seeks. I do long for amusement.',595,0,0,0,0,0,0,0,0,0,0,0,26124),
(94158,'Through the mist, and into the darkness, I rest my soul forever in the hands of Helira.$b$bKneel before your goddess.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94159,'','I will gather the rest of the Blood Knights and await your call.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94160,'','My men are at Azurewing Repose negotiating safe passage with the dragon\'s brood.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94161,'Who is Bloodbeard?','Who is Bloodbeard?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94162,'Bloodbeard is Helira\'s champion.$b$bHe has defeated every warrior on the battlefield a thousand times over...$b$bYou will not win.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(94163,'We will see about that.','We will see about that.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94164,'Bloooood... Bloodbeard... Bloodbeard must... die...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94165,'','Bloodbeard is Helira\'s champion.$b$bHe has defeated every warrior on the battlefield a thousand times over...$b$bIt would bring me pleasure to watch him die at the tip of my blade.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(94166,'','Their souls are weak and not worthy of my blade. I long to return to the Halls of Valor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94167,'GHHAAAaaa!!!','',0,0,0,0,0,0,0,0,0,0,50314,0,26124),
(94168,'','I\'ll see you there.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94169,'I agree with you.','I agree with you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94170,'Friends of yours, Ariok? No, wait... you look familiar.','',0,0,0,0,0,0,0,0,0,0,50425,0,26124),
(94171,'I am in your debt, heroes. My strength is yours.','',0,0,0,0,0,0,0,0,0,0,50315,0,26124),
(94172,'','The slayer of Malinoth returns. Blood Knights, salute!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94173,'I will die before I serve The Burning Legion!','',0,0,0,0,0,0,0,0,0,0,50316,0,26124),
(94174,'You cannot fight fate, Ariok! You can only embrace it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94175,'Over here! Please help!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94176,'','How can I help you, $g handsome : gorgeous;?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(94177,'A paladin? Here? We must investigate.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94178,'I am on the beach now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94179,'There is no time to waste, demon hunter. We have urgent matters at hand.','',0,0,0,0,0,0,1,0,0,0,64055,0,26124),
(94180,'Are you sure?','Are you sure?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94181,'Give up! This is your final resting place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94182,'It is pointless. Why try?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94183,'There is no happiness. Only darkness.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94184,'Don\'t be a fool. You will not succeed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94185,'Eternal sadness is all that awaits you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94186,'I, Daglop the Mercifel, Daglop the Magnivalent, Daglop the Wondevil, have come to make a deal!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94187,'Read contract.','Read contract.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94188,'Sign contract in blood.','Sign contract in blood.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94189,'The contract starts with a large, flowing, vile looking script that, with each sentence gets smaller and smaller in its lettering. It begins:$b$bPage 1:$b\"I, the undersigned, hereafter referred to as \'the second party,\' do solemnly swear and agree to the terms set forth by Daglop Ravaliash Driscol Blat, here after referred to as \'Daglop.\'\"','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94190,'Flip to Page 2.','Flip to Page 2.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94191,'Flip to Page 3.','Flip to Page 3.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94192,'Flip to Page 1.','Flip to Page 1.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94193,'The contract continues in a progressively smaller font:$b$bPage 2:$b\"These terms include the acquisition of materials required for the Ritual of Sharazaan, hereafter referred to as \'the gig,\' and any extermination, elimination, assassination, or murderation of subjects, living or otherwise, that resist the afore mentioned assets required by the gig and Daglop.\"','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94194,'The lettering is now nearly illegible:$b$bPage 3:$b\"In exchange, Daglop agrees to provide the second party with a physically intangible source of fel-based energy for the infusing of one artifact of great power in said second party\'s possession, hereafter referred to as \'the reward.\'\"','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94195,'Flip to Page 4.','Flip to Page 4.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94196,'Page 4:$b\"Upon completion of the gig, the aforementioned reward intended for the second party must be provided through direct source extraction from the third party, role to be filled by the target of-\"$b$bThe lettering becomes so small at this point the words are effectively unreadable by mortal eyes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94197,'Kneel before Helira.','Kneel before Helira.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94198,'You are the commander? Please, I beg you to listen to me, the fate of Draenor is at stake! Gul\'dan has found it! He found the Cipher!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(94199,'Xalythar has fallen! How can this be?!','Xalythar has fallen! How can this be?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94200,'The druids were not supposed have such power! Gathenak is slain!','The druids were not supposed have such power! Gathenak is slain!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94201,'Who could slay Xalythar?!','Who could slay Xalythar?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94202,'They\'ve killed Gathenak!','They\'ve killed Gathenak!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94203,'Speak quickly warlock.','Speak quickly warlock.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94204,'Gul\'dan intends to use the Cipher of Damnation to corrupt the very elements of Draenor. He will scorch the whole of this jungle in hellfire.$b$bOnly now do I see the depths of his madness and hatred.$b$bQuickly! Gul\'dan has learned of the guardian shaman that protect the Cipher. He is moving to attack their stronghold. Someone must protect them.','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(94205,'I will go immediately.','I will go immediately.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94206,'','The world has never been so dark. We will help bring in a new dawn.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94207,'Smell that sea air! It feels good to be out in the open water again.','',0,0,0,0,0,0,1,0,0,923,53305,0,26124),
(94208,'Help! Gul\'dan... he is inside!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94209,'Kneel before the goddess, Helya.','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(94210,'Are you crazy, launching yourself into the air like that!? Why not just send Gul\'dan a telegram? Better yet, march into the compound at the head of a Brewfest oompah band. This is a stealth mission, $n! Stealth!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(94211,'Protect me while I sever this link to the Twisting Nether!','Protect me while I sever this link to the Twisting Nether!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94212,'I\'ll disrupt the portal. Keep the Demons at bay while I work!','I\'ll disrupt the portal. Keep the Demons at bay while I work!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94213,'','Thank you for allowing us to join you, $n. When you call, the Sunwalkers will answer.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94214,'','I will go gather the rest of the Sunwalkers - they will not want to miss seeing you in action. Light be with you.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94215,'$GHe:She; fell for it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94216,'Did you think it would be that easy?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94217,'That\'s our treasure, ugly $r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94218,'Ha! Got you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94219,'I\'m sure dat payment from Orgrimmar had nothin\' ta do wit it.','',0,0,0,0,0,0,574,0,0,923,53306,0,26124),
(94220,'There\'s an old goblin saying that goes \"the best bets use other people\'s money.\"','',0,0,0,0,0,0,1,0,0,923,53307,0,26124),
(94221,'Dat assumes we gonna make it back.','',0,0,0,0,0,0,274,0,0,923,53308,0,26124),
(94222,'At last! With this I will scorch the land with hellfire. The very elements will tremble before me.','',0,0,0,0,0,0,0,0,0,0,50934,0,26124),
(94223,'Any messages from Orgrimmar?','',0,0,0,0,0,0,6,0,0,923,53309,0,26124),
(94224,'You are too late hero. The cipher is mine. Your armies will burn!','',0,0,0,0,0,0,0,0,0,0,50935,0,26124),
(94225,'','The owls of this grove are in grave danger from a murderous vulture known as Gorebeak.$B$BTiris and I plan to lure the beast down from its lair.$B$BWe must slay him to restore balance to the forest, but we could use all the help we can get.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94226,'','Are you ready, Tiris?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94227,'','The vulture must be stopped, Lorel. It\'s time we restored balance to this grove.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94228,'','Aren\'t these little birds just precious? If we don\'t help them, they are in danger of being wiped out.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94229,'I will help you defeat Gorebeak.','I will help you defeat Gorebeak.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94230,'Sylvanas an\' da main fleet arrived a few hours ago. Demons coverin\' da whole island.','',0,0,0,0,0,0,1,0,0,923,53310,0,26124),
(94231,'Already? How\'d they get so many here so fast?','',0,0,0,0,0,0,6,0,0,923,53311,0,26124),
(94232,'I got da feelin we gonna find out.','',0,0,0,0,0,0,1,0,0,923,53312,0,26124),
(94233,'Cut through those waves, Blackwater! We\'re pirates, we own these seas! Keep her steady!','',0,0,0,0,0,0,5,0,0,923,53313,0,26124),
(94234,'What\'s that ahead?','',0,0,0,0,0,0,6,0,0,923,53314,0,26124),
(94235,'','Not. Even. Worthy.',0,0,0,0,0,0,0,0,0,0,0,50722,26124),
(94236,'','Know your place, weakling!',0,0,0,0,0,0,0,0,0,0,0,50594,26124),
(94237,'','Oh, is that one finished?',0,0,0,0,0,0,0,0,0,0,0,50595,26124),
(94238,'Looks like trouble. Big trouble.','',0,0,0,0,0,0,1,0,0,923,53315,0,26124),
(94239,'Alright horde troops, this is your stop, a beach lined with demons! Bring her in snappy now!','',0,0,0,0,0,0,5,0,0,923,53316,0,26124),
(94240,'','The third fleet reinforcements!',603,0,0,0,0,0,5,0,0,924,0,53345,26124),
(94241,'Just in time. We haven\'t been able to break their line, now we may have a chance.','',0,0,0,0,0,0,1,0,0,924,53346,0,26124),
(94242,'','It\'s now or never, Genn!',5,0,0,0,0,0,5,0,0,924,0,53347,26124),
(94243,'','Does it hurt, being so powerless?',0,0,0,0,0,0,0,0,0,0,0,50596,26124),
(94244,'','Look, someone approaches!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94245,'Be ready champion, I do not know what lies beyond this barrier, but it will be bad.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(94246,'Almost... there...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94247,'Oh, thank goodness! Please help me!$B$BI was attempting a growth spell, but something went terribly wrong.$B$BOne of the flowers kept growing and growing, and now it\'s taken on a mind of its own.$B$BPlease, you have to stop it before someone gets hurt!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94248,'No, no, stop! This wasn\'t supposed to happen! Stop growing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94249,'It... is done. Go and stop him...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94250,'I\'ve got to get my hands on those plans. They are my life\'s work.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(94251,'%s loots a rifle from the corpse of a fallen foe.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94252,'Let\'s roll, Roark!','Let\'s roll, Roark!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94253,'Let\'s get this over with. Gul\'dan has turned these docks into a recruiting ground.','',0,0,0,0,0,0,1,0,0,0,50549,0,26124),
(94254,'Cyrukh! You serve no shaman now. Sever your link to them. Ravage this land!','',0,0,0,0,0,0,0,0,0,0,50936,0,26124),
(94255,'No! How could he be defeated?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94256,'Blackhand ordered construction of a gigantic cannon. Then I built a monstrous warship to carry it. Bigger isn\'t always better - our strategy fell apart in the waters around Shattrath.','',0,0,0,0,0,0,1,0,0,0,50550,0,26124),
(94257,'We normally use these grapples to tug ships into port...','',0,0,0,0,0,0,1,0,0,0,50551,0,26124),
(94258,'This is why you should cover your buildings in spikes!','',0,0,0,0,0,0,0,0,0,0,50552,0,26124),
(94259,'','You did it! Why don\'t you take a bloom yourself, adventurer? Elune\'s Kiss has powerful properties.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94260,'','Adventurer, over here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94261,'','Stranger, do you see those flowers growing on the lake shore?$B$BElune\'s Kiss, we call them. I\'ve searched the forest for days to find this patch, only to find it guarded by that foul monster.$B$BPlease, adventurer. I need to get those flowers.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94262,'','Pah! You\'re too ugly for my collection. Better to kill you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94263,'','My collection... they were all... I had...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94264,'Please, please... no more!','Please, please... no more!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94265,'FOOL! You will fall before the might of the Legion!','FOOL! You will fall before the might of the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94266,'Great work, heroes! Keep up the fight!','Great work, heroes! Keep up the fight!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94267,'One rift closed, but there are still more demons. Do they ever cease?','One rift closed, but there are still more demons. Do they ever cease?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94268,'With me by your side we will overcome the Legion. Nothing can stand in our way!','With me by your side we will overcome the Legion. Nothing can stand in our way!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94269,'As we speak, the God-King\'s forces amass at Hrydshal. We must strike at them with all the fury of the storm.\n\nAre you ready to leave this place, $C?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94270,'Take me out of the cave.','Take me out of the cave.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94271,'I\'ll keep watch. Get my blueprints.','',0,0,0,0,0,0,1,0,0,0,50553,0,26124),
(94273,'What is this filth doing on my docks!?','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(94274,'Gul\'dan... will finish this...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94275,'Look, brother. A new challenger approaches.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94276,'Let us test your strength, champion! Prepare yourself! [OUR ABILITIES AND CLEANUP AREN\'T SET UP YET!]','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94277,'Hang in there, Oakleaf. I know it is painful, but please, hold on!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94278,'It will get worse before it gets better, old friend. Let us begin!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94279,'Something is wrong with my friend. A darkness has taken root within him, paralyzing him with fear.$B$BI believe the only recourse is to cleanse his mind, but in doing so, we will face his nightmares.$B$BI cannot defeat this evil alone. Will you help me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94280,'I will help. Let\'s begin.','I will help. Let\'s begin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94281,'Darkness, come forth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94282,'That\'s the spirit, Oakleaf. Thank you, adventurer. He seems to have regained control of his senses.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94283,'We did it! How do you feel, old friend?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94284,'%s grunts.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94285,'','Arg, why isn\'t it working? The power of my friendship should heal all wounds!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94286,'','Oh, hello there!$B$BMy poor friend here was attacked by wolves, and now I\'m nursing him back to health!$B$BI\'m having a little bit of trouble with this spell, so it should just take a few more minutes.$B$BI think some of those nasty predators are still nearby, so could you hold them off while I finish here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94287,'Yes, I\'ll defend you.','Yes, I\'ll defend you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94288,'','Eep! Watch out! Defend me, hero!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94289,'','Look, my wonderful forest friend has been saved!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94290,'','Champion, it looks like he wants us to follow him!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94291,'%s bows to you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94292,'%s beckons to the chest inside the den, as if he wants you to have it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94293,'','What a curious little house he has! I\'ll stay and make sure he\'s all right. Thank you, hero.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94294,'Death to the enemies of Kilrogg!','Death to the enemies of Kilrogg!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94295,'Your corpse will serve in our rituals!','Your corpse will serve in our rituals!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94296,'I will skin you alive!','I will skin you alive!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94297,'Glory to the Bleeding Hollow!','Glory to the Bleeding Hollow!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94298,'Your blood will be most useful!','Your blood will be most useful!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94299,'Kilrogg... I\'ve failed you...','Kilrogg... I\'ve failed you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94300,'You cannot stop us!','You cannot stop us!',0,0,0,0,0,0,0,0,0,0,50360,50360,26124),
(94301,'Kill you... kill... you...','Kill you... kill... you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94302,'My brothers will make you pay.','My brothers will make you pay.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94303,'Kilrogg will still be victorious...','Kilrogg will still be victorious...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94304,'Now you die!','Now you die!',0,0,0,0,0,0,0,0,0,0,50359,50359,26124),
(94305,'Crush you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94306,'Stomp and smash!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94307,'Blood for Kilrogg!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94308,'Crush... you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94309,'Rest... at last...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94310,'No... Kilrogg...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94311,'Try and dodge my spears fool!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94312,'Spears... you have failed me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94313,'If you flee, I will hunt you to the ends of the world!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94314,'My hunters will find you... wherever you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94315,'Blood for the Blood Moon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94316,'My blood... for Kilrogg...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94317,'','Don\'t worry, Brimbil. Every young sapling must step into the real world. You\'ll be fine!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94318,'You cannot stop the rituals, you can only join them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94319,'My blood... joins the others...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94320,'I will take your blood as payment for your interference!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94321,'There will be another after me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94322,'','Ah, hello traveler!$B$BSometimes, young saplings just need a little push to gain confidence, you know?$B$BYoung Brimbil here has everything he needs to take his first journey across the forest, but perhaps he could use some guidance.$B$BWould you escort him to Keeper Ferthalos, across the river?$B$BJust follow Brimbil. He should know the way.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94323,'I will accompany Brimbil.','I will accompany Brimbil.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94324,'','Take good care of him, adventurer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94325,'We saved Draenor once, I will help you save it again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94326,'','These new cannon... dey be something else...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94327,'%s moans in agony.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94332,'[PH] Climb to the top of the ridge to get a good view of the grapple point.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94333,'Click the nearby Grapple Point to launch yourself to the top of the wall. Grapple points within range will light up.','',0,0,0,0,0,0,0,0,0,0,12197,0,26124),
(94334,'These poor people. Gul\'dan will stop at nothing to get what he wants!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94335,'What is the Black Candle?','What is the Black Candle?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94336,'The Black Candle... I know not where Gul\'dan found this. It never burns down and exudes a corruptive smoke as it lights everything with an unholy glint.\n\nMy fingers still feel oily from when I touched it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94337,'What is the Tome of Protection?','What is the Tome of Protection?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94338,'The Tome was stolen from the Imperator Mar\'gok himself, though he blames the Frostwolf clan for the theft. It is more arcane in nature but is still usable by warlocks.\n\nThe enchantments from this tome are a core component to the barrier spell. Fear not, I can dispel it though it may cost me dearly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94339,'What is this... Mac\'Gufin?','What is this... Mac\'Gufin?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94340,'It is a true mystery. Gul\'dan went through great lengths to get this dagger. He says it was quite the adventure. \n\nHe made sure I knew it was the most important part of the spell. Truth be told, when I held it I felt nothing. I\'m not entirely sure it did anything at all, but we should get it just in case. Gul\'dan wouldn\'t have given it to me otherwise... right?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94341,'','G\'day to ye, Highlord $n. Can I help ye find somethin\'?',2,0,0,0,0,0,0,0,0,0,0,0,26124),
(94342,'','Lookin\' fer somethin\' specific, Highlord?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(94343,'','The knowledge of our forefathers is laid bare before us. What a marvelous opportunity!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(94344,'','Whenever ye accomplish a great feat, I\'ll be sure tae jot it down in yer libram for posterity!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(94347,'Show me what happened in Azsuna.','Show me what happened in Azsuna.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(94350,'Light\'s honor, Highlord.','',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(94351,'Say the world and I will rally your best knights, $GLord:Lady; $n.','',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(94352,'What threats shall we tackle first? Say the word and consider it done.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(94353,'Our enemies grow bolder with each passing day. Thank the Light we have you at the helm of our efforts.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(94354,'You trespass on sacred ground!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94355,'I will guard the eyes with my eternal soul!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94356,'Think you can loot the Bleeding Hollow\'s most treasured relics?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94357,'Others will guard the eyes after me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94358,'You will pay infidel... someday...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94359,'Kilrogg... they come for the eyes...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94360,'I have failed my chieftain...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94361,'You will pay... defiler...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94362,'I will return...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94363,'','The human King is quite versed in military strategy, but even he can\'t perform miracles.$b$bIf we\'re to break through into the jungles of Tanaan, we\'re going to need some sort of diversion.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(94364,'Gul\'dan\'s Horde is ready for us. A full-frontal assault would be costly at best and suicide at worst.$b$bThere\'s got to be another way...','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(94365,'I heard Kilrogg! What happened?!','',0,0,0,0,0,0,15,0,0,0,50313,0,26124),
(94366,'You have found all you will find down here. Now leave and do not return...','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(94367,'','Hi there!$b$bI\'m a placeholder treasure hunter. I travel around telling people where the treasures are that I can\'t actually get myself because of \'reasons.\' Eventually I may be found in exotic and/or common places once I make up my mind.$b$bDo you want to hunt treasures?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94368,'I am looking for treasure.','I am looking for treasure.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94369,'Heroes, up here! This portal is too strong for my magic to close!','Heroes, up here! This portal is too strong for my magic to close!',3,0,0,0,0,0,0,0,0,0,0,0,26124),
(94370,'Quickly, activate the temple\'s defenses to amplify my magic!','Quickly, activate the temple\'s defenses to amplify my magic!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94371,'Each death has given me untold power.  Now I unleash it upon you!','',0,0,0,0,0,0,0,0,0,0,50365,0,26124),
(94372,'It is my blood they require fools! They\'ll let no harm come to me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94373,'I have feasted upon a thousand souls.  Yours will be next!','',0,0,0,0,0,0,0,0,0,0,50367,0,26124),
(94374,'Give in!','',0,0,0,0,0,0,0,0,0,0,50370,0,26124),
(94375,'Death!','',0,0,0,0,0,0,0,0,0,0,50371,0,26124),
(94376,'Wither and DIE!','',0,0,0,0,0,0,0,0,0,0,50372,0,26124),
(94377,'Don\'t worry... it gets worse.','',0,0,0,0,0,0,0,0,0,0,50373,0,26124),
(94378,'I must have more souls!','',0,0,0,0,0,0,0,0,0,0,50374,0,26124),
(94379,'More! I must have more!','',0,0,0,0,0,0,0,0,0,0,50375,0,26124),
(94380,'I must feast!','',0,0,0,0,0,0,0,0,0,0,50376,0,26124),
(94381,'I\'ll savor your soul the most.','',0,0,0,0,0,0,0,0,0,0,50368,0,26124),
(94382,'Each death only makes me more powerful!','',0,0,0,0,0,0,0,0,0,0,50369,0,26124),
(94383,'But... my power...','',0,0,0,0,0,0,0,0,0,0,50366,0,26124),
(94384,'','Ah... another succulent world ready to be beat into submission!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94385,'Not this time Gul\'dan! Hurry, get the Cipher!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94386,'Impossible! This means nothing. One way or another, this world will burn!','',0,0,0,0,0,0,0,0,0,0,50940,0,26124),
(94387,'Get those fires out before Nathanos returns! I don\'t want to be food for his dogs.','',0,0,0,0,0,0,0,0,0,33099,0,0,26124),
(94388,'Faster! Get this ship floating before more of those scum scavenging crab people notice us.','',0,0,0,0,0,0,0,0,0,33099,0,0,26124),
(94389,'Hammer you fools! We have a schedule to keep.','',0,0,0,0,0,0,0,0,0,33099,0,0,26124),
(94390,'Are you going to let the Alliance sink your ship? Prove the feebleness of their weapons by getting this barge floating.','',0,0,0,0,0,0,0,0,0,33099,0,0,26124),
(94391,'Nathanos has charged us with restoring his ship to operational status.$b$bBut these lazy fools are taking forever to... wait... do you hear that?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94392,'Hear what?','Hear what?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94393,'Incoming!','',0,0,0,0,0,0,0,0,0,33099,0,0,26124),
(94394,'And stay off, you crab faced filth!','',0,0,0,0,0,0,0,0,0,33099,0,0,26124),
(94395,'','The plan is working. Our landing was unopposed. We have taken them by surprise!',0,0,0,0,0,0,396,0,0,0,0,50577,26124),
(94396,'','Your plan is working, commander. Our landing met little resistance.',0,0,0,0,0,0,396,0,0,0,0,50340,26124),
(94397,'','We must stop them before they accomplish their dark goals.',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(94398,'','I will weep for the lost souls later. We will seal this breach...',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(94399,'','|cFFFF0000%s|r activates an |cFFFF0000|Hspell:181718|h[Aura of Oppression]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(94400,'','|cFFFF0000%s|r activates an |cFFFF0000|Hspell:179986|h[Aura of Contempt]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(94401,'','|cFFFF0000%s|r activates an |cFFFF0000|Hspell:179991|h[Aura of Malice]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(94402,'','|cFFFF0000%s|r targets you with an |cFFFF0000|Hspell:180260|h[Annihilating Strike]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(94403,'','|cFFFF0000%s|r begins to channel an |cFFFF0000|Hspell:180312|h[Infernal Tempest]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(94404,'','|cFFFF0000%s|r readies a |cFFFF0000|Hspell:180608|h[Gavel of the Tyrant]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(94405,'','|cFFFF0000%s|r focuses you with an |cFFFF0000|Hspell:182459|h[Edict of Condemnation]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(94406,'Polishing','Polishing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(94407,'','|cFFFF0000%s|r attempts to heal its master!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(94408,'|cFFFF0000%s|r protects its master with |cFFFF0000|Hspell:180040|h[Sovereign\'s Ward]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(94410,'The avatar of an |cFFFF0000%s|r enters the battle!','The avatar of an |cFFFF0000%s|r enters the battle!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(94412,'|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tI can already tell that we\'ll need to pre-temper this. Heat the ore in the forge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94413,'|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tNow, quickly, quench it in the trough.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94414,'|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tSee? It already looks better. Heat and quench again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94415,'|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tNow, bring the metal up to drawing heat in the forge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94416,'|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tThat should be hot enough. Next, we\'ll draw the metal out into a bar.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94417,'|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tYou know what to do next. Heat the bar, then hammer it into shape.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94418,'|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tVery good. Let\'s get ready to weld. Apply some of the flux from my workbench.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94419,'Heroes, hurry! Iroxus must not be allowed to enter Dire Maul!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94420,'I have arrived, whelps. Come face me and get this over with!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94421,'Heh-eh, marvelous, marvelous.','',0,0,0,0,0,0,574,0,0,0,50823,0,26124),
(94422,'Impressive.','',0,0,0,0,0,0,1,0,0,0,50824,0,26124),
(94423,'','The metal will not bend so easily, try striking harder.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94424,'Everything rests upon your shoulders, commander. Build us a navy so we can assault Gul\'dan from all sides. Good luck!','',0,0,0,0,0,0,1,0,0,0,51321,0,26124),
(94425,'These fine men and women need a leader, $p. Your deeds prove you are the clear choice to bear that burden. Come, I will address them on your behalf.','',0,0,0,0,0,0,1,0,0,0,63831,0,26124),
(94426,'Paladins of Azeroth, you\'ve gathered to mourn the loss of Highlord Tirion Fordring. Many of you looked to him as an ideal, the paragon of what we all strive to be.','',0,0,0,0,0,0,1,0,4,0,63832,0,26124),
(94427,'You all know the noble deeds of the champion at my side. $p has been chosen by the Light to succeed Tirion as Highlord. Under our new leader, this order shall become a mighty weapon brought to bear against the Legion!','',0,0,0,0,0,0,1,0,0,0,63835,0,26124),
(94428,'On this day, the Order of the Silver Hand is reborn! Together, Sargeras himself shall shudder at our might!','',0,0,0,0,0,0,1,0,0,0,63839,0,26124),
(94429,'|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tOkay. It appears that leystone interacts violently with flux. Let\'s stop right there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94430,'We seek Solog Roark!','',0,0,0,0,0,0,0,0,4,0,50348,0,26124),
(94431,'No, friend. We have a common enemy and need your skills.','',0,0,0,0,0,0,0,0,4,0,50349,0,26124),
(94432,'Tell me more...','',0,0,0,0,0,0,0,0,4,0,50559,0,26124),
(94433,'You dare come into MY CAMP? I\'m going to take great pleasure in tearing you apart... piece by piece.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94434,'Come, heroes! Stand by my side and unleash your power!','Come, heroes! Stand by my side and unleash your power!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94435,'','I hunt in shadow...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94436,'The hunt continues...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94437,'','Evil shall tremble before my claws...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94438,'Fear the night!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94439,'','These claws demand vengeance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94440,'Even the wicked fear what lurks behind the shadows...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94441,'Hail, Highlord.','Hail, Highlord.',0,0,0,0,0,0,66,0,0,36951,0,0,26124),
(94442,'I heard that Highlord $p killed Archimonde with $Ghis:her; own bare hands!','I heard that Highlord $p killed Archimonde with $Ghis:her; own bare hands!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(94443,'Did you know that the Highlord once slew five hundred demons in a single blow?','Did you know that the Highlord once slew five hundred demons in a single blow?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94444,'I overheard Champion Bachi say that the Highlord can come back from death.','I overheard Champion Bachi say that the Highlord can come back from death.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94445,'I read that Highlord $p killed Ragnaros the Firelord... twice!','I read that Highlord $p killed Ragnaros the Firelord... twice!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94446,'We\'ll continue our training later, $p. Stay alive out there.','',0,0,0,0,0,0,0,0,0,33121,0,0,26124),
(94447,'Do you think I\'ll be picked to go on the next mission outing? I heard that the Highlord lets you keep some of the spoils!','Do you think I\'ll be picked to go on the next mission outing? I heard that the Highlord lets you keep some of the spoils!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94448,'All the world\'s paladins united under one roof... the Legion doesn\'t stand a chance.','All the world\'s paladins united under one roof... the Legion doesn\'t stand a chance.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94449,'Do you think Highlord $p has noticed how hard I\'ve been training lately? I want to impress $Ghim:her; so much!','Do you think Highlord $p has noticed how hard I\'ve been training lately? I want to impress $Ghim:her; so much!',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(94450,'Do you think Highlord $p is a demigod?','Do you think Highlord $p is a demigod?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(94451,'The Highlord approaches. Salute!','The Highlord approaches. Salute!',0,0,0,0,0,0,66,0,0,33184,0,0,26124),
(94452,'This creature is the chieftain of your Horde, $n? I like him. He is not afraid of brash action, but he waits to build a consensus among his people before he makes a move.$b$bWe will need a bold strategy if we are to attack Tanaan Jungle. Your warchief is fortunate to have you at the ready.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(94453,'|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tLet\'s do this! Heat the leystone in the forge, just as you did before.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94454,'|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tNow, let\'s ask a Kirin Tor mage to thoroughly chill the metal. Check the cake stand outside my shop.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94455,'','You need my help in the blacksmithing shop? Fine, but every mage has her price... and my price happens to be candy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94456,'|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tCome on back in here! We still need to heat and re-chill the metal one more time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94457,'','Consider me hired. See you there!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94458,'|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tVery good. Now let\'s see if you remember the rest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94459,'I\'ll keep pondering on how we can improve our leystone techniques, $n. Your training isn\'t done yet.','',0,0,0,0,0,0,0,0,0,33142,0,0,26124),
(94460,'This world will be burned to ash!','This world will be burned to ash!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94461,'Submit to your destruction!','Submit to your destruction!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94462,'None shall be spared!','None shall be spared!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94463,'You have no idea... what you face...','You have no idea... what you face...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94464,'You can\'t stop us all.','You can\'t stop us all.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94465,'The Legion is eternal!','The Legion is eternal!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94466,'You... will... die...','You... will... die...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94467,'Da Horde be countin\' on ya, commander. Find us a shipwright so we can surround Tanaan!','',0,0,0,0,0,0,1,0,0,0,50608,0,26124),
(94468,'','Since the time of my youth, I have lived in this vale... hunting alongside the vale prowlers and protecting the sanctity of the forest.$b$bAs I look out upon what was once the beautiful land that I love... my heart is filled with sadness. Will the forest ever be whole again?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94469,'See how easily your gauntlet crumples beneath my hoof! This is unacceptable.','',0,0,0,0,0,0,480,0,0,0,20606,0,26124),
(94470,'','Their numbers are endles... how can we possibly defeat the satyrs?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94472,'Chaos will rain down upon you.','Chaos will rain down upon you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94473,'Destruction!','Destruction!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94474,'You will know pain.','You will know pain.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94475,'No mercy.','No mercy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94476,'Destroying Fel Conduit','Destroying Fel Conduit',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94477,'PH: TALKING HEAD - MALFURION: Archdruid Moonclaw and his kin embody the most feral and savage aspects of nature. I would tread lightly in their domain, $n.','',0,0,0,0,0,0,1,0,0,0,52744,0,26124),
(94478,'','The flora of this land vary wildly from those of my home. Some of them seem more animal than plant.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94479,'','The flowers have much to teach, if you are willing to listen.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94480,'','Walk with a light hoof. The grass still breathes beneath you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94481,'Alard at the blacksmith shop will need a regular supply of foxflower. Do you have any?','Alard at the blacksmith shop will need a regular supply of foxflower. Do you have any?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94482,'Alard at the blacksmith shop will need a regular supply of foxflower flux. Can you make any?','Alard at the blacksmith shop will need a regular supply of foxflower flux. Can you make any?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94483,'','The Light is lost... they\'ve already won.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94484,'You carry the Light within you, Tiza. Look inside yourself.','You carry the Light within you, Tiza. Look inside yourself.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94485,'You\'re a paladin - you must uphold your oath fight against the darkness.','You\'re a paladin - you must uphold your oath fight against the darkness.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94486,'I won\'t give up on you. You\'re getting out of here.','I won\'t give up on you. You\'re getting out of here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94487,'There\'s no point anymore. Look around you... it\'s over.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94488,'No, YOU look around. Is this what you want for all of Azeroth?','No, YOU look around. Is this what you want for all of Azeroth?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94489,'Your death comes from the sky!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94490,'The Light has never forsaken you, Sammuel. Don\'t forsake it.','The Light has never forsaken you, Sammuel. Don\'t forsake it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94491,'Stand strong, brother. It is not over yet.','Stand strong, brother. It is not over yet.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94492,'','I... I can feel the Light deep in me heart.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94493,'','The Legion cannae defeat us! I\'ll make my way back to camp while I have the chance!',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(94494,'','Yer right. I swore to defend the Light and here I am forsakin\' it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94495,'','I won\'t let ye down $p! I\'ll meet ye back at camp.',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(94496,'','Bless ye, hero. I thought I was a goner!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94497,'','I won\'t forget this! I\'ll meet ye back at camp.',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(94498,'I knew someone would come for me. The Legion hasn\'t won yet!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94499,'I will fight against the Legion until my last breath! I\'ll meet you back at camp.','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(94500,'You\'re right, $p. How could I turn my back on the Light?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94501,'I can\'t. I won\'t. I will stand strong! I will meet you back at camp.','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(94502,'Maybe there is hope after all...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94503,'I won\'t let it be over. We can do this! I will meet you back at camp.','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(94504,'Time is running out, $n. You are needed at the Grove of Cenarius... we must act swiftly.','',0,0,0,0,0,0,1,0,0,0,52736,0,26124),
(94505,'','Use your body to swing the hammer, not just your arm.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94506,'','You\'re progressing quite nicely.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94507,'','Of course. Our herbalists bring in plenty of foxflower. I will make sure to set some aside for your metalwork.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94508,'','Whoah! Neat recipe. As long as the herbalists keep bringing me fresh foxflower, I can certainly make this preparation for you. No problem.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94509,'Come back again later, $n. I have something interesting I want to show you.','',0,0,0,0,0,0,0,0,0,33133,0,0,26124),
(94510,'I\'ve expended my energy. Keep at it while I recharge my powers!','I\'ve expended my energy. Keep at it while I recharge my powers!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94511,'The dragons will serve or be slain!','',0,0,0,0,0,0,0,0,0,0,52404,0,26124),
(94512,'The Thorgnir are broken. You\'re next!','',0,0,0,0,0,0,0,0,0,0,52525,0,26124),
(94513,'','Skovald will possess the Aegis. You will not interfere!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94514,'','Insolent worm... you cannot stop the God-King...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94515,'You are too late, weakling! Even now, we break the dragons to serve us!','',0,0,0,0,0,0,25,0,0,0,51617,0,26124),
(94516,'Only I possess the power of the Thorignir! The Aegis will be mine!','',0,0,0,0,0,0,15,0,0,0,51626,0,26124),
(94517,'Give up, outsider. You are not worthy of the Halls of Valor!','',0,0,0,0,0,0,274,0,0,0,51625,0,26124),
(94518,'','You need your mount shod? Let\'s see if I can make these hoofplates fit...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94519,'','All done! You take care of that mount now. It\'s a beauty.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94520,'Can you fit these hoofplates on my mount?','Can you fit these hoofplates on my mount?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94521,'','I sure can! Just mount up right here on the curb and I\'ll take a look.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94522,'Don\'t be a stranger, smith.','',0,0,0,0,0,0,0,0,0,33140,0,0,26124),
(94523,'','I have more I can teach you, but you\'re not ready to learn it yet. Come back when you\'re a bit less green, $c.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94524,'How pitiful. You must prove yourself worthy before you are given the privilege of facing me in battle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94525,'Erling, teach this invader some manners.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94526,'A trifle. Asger, deliver this fool to Helheim!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94527,'Bah! She was nothing to me. Cuyler, avenge your fallen comrades.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94528,'Well, perhaps you can offer me some sport after all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94529,'I thought I was dead for sure. I owe you my life!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94530,'I think I can make it back to camp on my own. Strike swiftly, champion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94531,'The might of Stormwind will prevail, demons!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94532,'Shoot true, men. These demons will feel our fury!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94533,'Heroes, man the cannons! Take out that crystal!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94534,'','Hey there, commander. The crew\'s doing a fine job keeping the defenses up!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94535,'','I have freely given you our hard-learned pattern for Demonsteel Armguards.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94536,'','Speak with Urael if you wish to learn more demonsteel patterns.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94537,'They will come at a price. We need raw materials.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94538,'$p has arrived!','$p has arrived!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(94539,'A rider approaches from the south!','A rider approaches from the south!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(94540,'Bless us all. The cavalry is here, lads!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94541,'A rider approaches from the north!','A rider approaches from the north!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(94542,'','I must take to the sky. Embrace the power I have given you.',0,0,0,0,0,0,0,0,0,0,0,52924,26124),
(94547,'Hey there, commander! This place isn\'t quite as nice as Stormshield, but it\'s starting to get there.$b$bDon\'t you think?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94548,'The Drekirjar are attacking your dragon! Use Unleash Storm\'s Fury to blast them off!','',0,0,0,0,0,0,0,0,0,0,37666,0,26124),
(94549,'We\'ve already directed a portrait to Undercity for you, $n. Follow me, please.','',0,0,0,0,0,0,1,0,0,26702,0,0,26124),
(94550,'When you are ready, step through the portrait to teleport to Undercity.','',0,0,0,0,0,0,1,0,0,26702,0,0,26124),
(94551,'Everyone, we ride for Light\'s Hope at once!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(94552,'','I can\'t believe you talked me into this! Can you even control this thing?!',0,0,0,0,0,0,0,0,0,33181,0,51716,26124),
(94553,'','Heads up! Very big dragon incoming!',0,0,0,0,0,0,0,0,0,33181,0,51717,26124),
(94554,'Of course I can! Wait... woahh! Woah!','',0,0,0,0,0,0,0,0,0,33181,52979,0,26124),
(94555,'Alright, let\'s just set her down nice and eas-GAAHH!!','',0,0,0,0,0,0,0,0,0,33181,51720,0,26124),
(94556,'Return to the Gates of Valor','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94557,'Come here, $n. I wish to show you something.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94558,'I can teach you how to craft that more efficiently.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94559,'Pause for a moment, smith. I have a lesson for you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94560,'Allow me to teach you something, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94561,'Very good, but let me teach you how to do it better.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94562,'Somebody call for air support?','Somebody call for air support?',0,0,0,0,0,0,0,0,0,33181,0,0,26124),
(94563,'Keep those Pale scum back troops!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94564,'We must keep the tunnel open! Fight on!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94565,'Get me more men! These Pale are endless!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94566,'Collect the supplies! Don\'t let the Pale take them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94567,'<The machine looks like it\'s best days are long gone, but it might still get you off the ground.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94568,'Target is bugging out. Secure the Admiral.','Target is bugging out. Secure the Admiral.',0,0,0,0,0,0,0,0,0,33181,0,0,26124),
(94569,'Let\'s fly to the Throne of Kil\'jaeden.','Let\'s fly to the Throne of Kil\'jaeden.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94570,'A plaque on the side reads:$B$BThank you for purchasing the B-2 Personnel Relocator system. Be aware that use of the system is at your own risk and Vol\'mar Engineering takes no responsibility for death or dismemberment incurred from use.$b$bPersonnel Relocator features:$B$B* Minimalist cockpit,$b* Weight-shift adjustment turning,$b* Guided navigation system,$b    - G-X3 Beacons sold separately.$b* Gigantic supply of fuel.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94571,'Let\'s fly to the Throne of Kil\'jaeden.','Let\'s fly to the Throne of Kil\'jaeden.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94572,'Bat-riders heading your way! Hang in there, the Admiral and I are trying to find a way up!','',0,0,0,0,0,0,0,0,0,0,53059,0,26124),
(94573,'Many of the greatest paladins to walk Azeroth were buried on these sacred grounds. The others await you within the sanctum just below, $n.','Many of the greatest paladins to walk Azeroth were buried on these sacred grounds. The others await you within the sanctum just below, $n.',0,0,0,0,0,0,66,0,0,33185,0,0,26124),
(94574,'Light bless you, $n. Azeroth would be lost to the Legion if it weren\'t for you.','Light bless you, $n. Azeroth would be lost to the Legion if it weren\'t for you.',0,0,0,0,0,0,66,0,0,36946,0,0,26124),
(94575,'My beautiful leaves! You fleshbags will pay!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94576,'The green fire does not stop burning! It is inside me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94577,'The corruption is too much! All will pay for this injustice!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94578,'You were supposed to hook the vrykul, not his pet lizard.','',0,0,0,0,0,0,0,0,0,33182,0,0,26124),
(94579,'Victory for Sylvanas!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94580,'Hero, we\'re behind you! For Stormwind!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94581,'We will defend our homeland to the death!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94582,'Broadcasting Signal','Broadcasting Signal',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94583,'You will pay for your insolence, mortal!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94584,'Are you really so eager for death?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94585,'There\'s only one way out of this, Alliance, and it\'s through that line of demons! Cannons, lay down covering fire! All forces, CHARGE!','',0,0,0,0,0,0,5,0,0,924,53348,0,26124),
(94586,'I\'m not going to make it...','I\'m not going to make it...',0,0,0,0,0,0,0,0,0,924,70951,69114,26124),
(94587,'Everything is... going dark...','Everything is... going dark...',0,0,0,0,0,0,0,0,0,924,76253,69115,26124),
(94588,'I\'m hit!','I\'m hit!',0,0,0,0,0,0,0,0,0,924,70950,61530,26124),
(94589,'Can\'t... hold on any longer...','Can\'t... hold on any longer...',0,0,0,0,0,0,0,0,0,924,70949,61531,26124),
(94590,'Side by side, don\'t let them break through!','',0,0,0,0,0,0,0,0,0,924,53353,0,26124),
(94591,'Go for the throat!','',0,0,0,0,0,0,0,0,0,924,53354,0,26124),
(94592,'This one\'s mine!','',0,0,0,0,0,0,0,0,0,924,53355,0,26124),
(94593,'','Laying down a blizzard!',0,0,0,0,0,0,0,0,0,924,0,53356,26124),
(94594,'','Putting this one on ice!',0,0,0,0,0,0,0,0,0,924,0,53357,26124),
(94595,'','My magic will tear you apart!',0,0,0,0,0,0,0,0,0,924,0,53358,26124),
(94596,'Break them!','',0,0,0,0,0,0,0,0,0,924,53359,0,26124),
(94597,'You march to your doom!','',0,0,0,0,0,0,0,0,0,924,53360,0,26124),
(94598,'Do not let them reach the spires!','',0,0,0,0,0,0,0,0,0,924,53361,0,26124),
(94599,'Fer the glory of the Alliance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94600,'I know... I\'m a wee bit late. Me misses weren\'t too pleased fer me ta come out ta battle after all these years. There  ain\'t nobody wantin\' an old warrior, she said.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94601,'Let\'s get this rumble started!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94602,'Me shields by me side and me blade\'s at yer service, commander!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94604,'You dare defy the Legion?','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(94605,'Shields up! Never give in!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94606,'You saved me! I... I can still hear the voices. Please, stop them from taking others.','',0,0,0,0,0,0,579,0,0,0,0,0,26124),
(94607,'I don\'t feel so good. How did I get here? What... what are those things?','',0,0,0,0,0,0,579,0,0,0,0,0,26124),
(94608,'The God King has already entered the Halls of Valor. It is time for you to finish your trials and defeat the Gatekeeper.','The God King has already entered the Halls of Valor. It is time for you to finish your trials and defeat the Gatekeeper.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94609,'Fly me through the storm. I am ready to fight the Gatekeeper.','Fly me through the storm. I am ready to fight the Gatekeeper.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94610,'Hey, I think I\'ve got it!','',0,0,0,0,0,0,0,0,0,0,51721,0,26124),
(94611,'','Put that vile thing out of its misery already.',0,0,0,0,0,0,0,0,0,0,0,51718,26124),
(94612,'He\'s not vile! Just... misunderstood.','',0,0,0,0,0,0,0,0,0,0,51722,0,26124),
(94613,'Don\'t let my trophy headpiece fool you. I\'m on your side!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94614,'The cipher will be ours!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94615,'','We had the Forsaken fleet right where we wanted them - trapped in that bay like fish in a barrel.$B$BThere was no time to wait for reinforcements.$B$BWe had one shot, so I gave the order.$B$BI have no regrets.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94616,'','Our crew will rendezvous with the Alliance navy and continue hunting Sylvanas.$B$BYou, however, have bigger fish to fry.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94617,'We will find the cipher!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94618,'Strength alone will not win what you seek.','',0,0,0,0,0,0,0,0,0,0,53057,0,26124),
(94619,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-GRAND CHAMPIONS-ALLIANCE.blp:50:80|t$b[Gryan Stoutmantle] Your invasion stops now, demon.','',0,0,0,0,0,0,0,0,0,33196,0,0,26124),
(94620,'But it will get you started. Find me near Aggramar\'s Vault, and I will put your strength to the test.','',0,0,0,0,0,0,0,0,0,0,53058,0,26124),
(94621,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-GRAND CHAMPIONS-ALLIANCE.blp:50:80|t$b[Gryan Stoutmantle] $p has unleashed the wrath of the Ashbringer. Charge!','',0,0,0,0,0,0,0,0,0,33196,0,0,26124),
(94622,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-ARGALOTH.blp:50:80|t$b[Malgalor] I will crush the Pillars of Creation and you with them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94623,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-ARGALOTH.blp:50:80|t$b[Malgalor] You waste your time, mortals.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94624,'Grab some healthstones, heroes!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94625,'','Ah, something to relieve the tedium!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94626,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-ARGALOTH.blp:50:80|t$b[Malgalor] Your pathetic weapons cannot penetrate my armor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94627,'You did it! I\'ll fly you back down to the portal.','You did it! I\'ll fly you back down to the portal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94628,'Fly me back through the storm. I am ready to enter the Halls of Valor.','Fly me back through the storm. I am ready to enter the Halls of Valor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94629,'','Wrong... mixture....',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94630,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-ARGALOTH.blp:50:80|t$b[Malgalor] This world will burn. Listen to the screams of your allies, \'champion\'.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94632,'','Those crystals appear to be anchoring the structures to our dimension. Take them out, and I bet the whole structure would crumble!',0,0,0,0,0,0,0,0,0,924,0,53362,26124),
(94633,'Let\'s hope you\'re right.','',0,0,0,0,0,0,0,0,0,924,53363,0,26124),
(94634,'My wolf is going to eat well tonight!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94635,'','It worked!',0,0,0,0,0,0,0,0,0,924,0,53364,26124),
(94636,'One down, two to go.','',0,0,0,0,0,0,0,0,0,924,53365,0,26124),
(94637,'You will pay for this transgression. The legion is endless! INFERNO.','',0,0,0,0,0,0,0,0,0,924,53366,0,26124),
(94638,'One more and the shore is ours!','',0,0,0,0,0,0,0,0,0,924,53367,0,26124),
(94639,'You wish to face the might of the Legion? Ha, very well. The master will reward me for your souls.','',0,0,0,0,0,0,0,0,0,924,53368,0,26124),
(94640,'Your head will be a gift to Gul\'dan!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94641,'Finally, enough of your chatter.','',0,0,0,0,0,0,0,0,0,924,53369,0,26124),
(94642,'We are strong, we are legion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94643,'I will gather anyone still able to fight and join you on the battlefield, $p.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94644,'','Bringing such divided forces together is quite the feat, but there is still much to prove. I pray you live up to the Ashbringer\'s legacy, Highlord. Call on me when needed.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94645,'What are you waiting for? Charge!','What are you waiting for? Charge!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94646,'You, mortal, are merely postponing the inevitable...','You, mortal, are merely postponing the inevitable...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94647,'Your form means nothing! We sense your being regardless of physical presence.','Your form means nothing! We sense your being regardless of physical presence.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94648,'Into the shadows you go... But will you escape?','Into the shadows you go... But will you escape?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94649,'Your safety is quite an illusion.','Your safety is quite an illusion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94650,'In the end, there is nothing...','In the end, there is nothing...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94651,'The shadows offer no protection.','The shadows offer no protection.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94652,'The forces grow stronger while you hide from your surroundings.','The forces grow stronger while you hide from your surroundings.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94653,'You are nothing.','You are nothing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94654,'','They came so quickly! We\'re outnumbered!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94655,'','We will meet you outside Light\'s Hope Sanctum when you are ready, Highlord $p. ((Liadrin and Gryan walk outside.))',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(94656,'GOT YOU $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94657,'You think this is over, paladin? Our journey together has just begun...','',0,0,0,0,0,0,0,0,0,0,52035,0,26124),
(94658,'The gates are surrounded by vrykul. No doubt a small task for a champion like yourself.$b$bI\'m sure you are weary after your travels through Helhiem.$b$bYou will need your full strength if you wish to defeat the gatekeeper.$b$bIt would be my honor if I could carry you to the Halls of Valor.$b$bWhat say you, champion?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94659,'I\'d love a ride.','I\'d love a ride.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94660,'No thanks.','No thanks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94661,'Die, vermin!','',0,0,0,0,0,0,0,0,0,0,51708,0,26124),
(94662,'Glory to Skovald!','',0,0,0,0,0,0,0,0,0,0,51709,0,26124),
(94663,'For the God-King!','',0,0,0,0,0,0,0,0,0,0,51710,0,26124),
(94664,'Valhalas!','',0,0,0,0,0,0,0,0,0,0,51711,0,26124),
(94665,'You have bested me, champion. You may enter the Halls of Valor and continue your trials.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94666,'Give up or suffer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94667,'This champion is worthy! You will let him through.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94668,'Ah! Finally a battle worth fighting!','',0,0,0,0,0,0,0,0,0,0,52500,0,26124),
(94669,'Ha! Even deadlier than I\'d hoped!','Ha! Even deadlier than I\'d hoped!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94671,'This will make their blood burn.','This will make their blood burn.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94672,'Kilrogg will be pleased.','Kilrogg will be pleased.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94673,'HURTS! Make you hurt, too!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94674,'My blood burns!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94675,'Fear smell good.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94676,'Crunch your bones.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94677,'By the Light... the Ashbringer...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94678,'','Words cannot describe... such purity...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94679,'$n... come closer...','',0,0,0,0,0,0,0,0,0,0,63810,0,26124),
(94680,'You must... wield the blade... you must... stop the Legion...','',0,0,0,0,0,0,0,0,0,0,63811,0,26124),
(94681,'They need... you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94682,'[[ Client-Side Cinematic - Docks Being Built ]]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(94683,'Round clear! Reload!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94684,'Boom! Great shot!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94685,'Keep firing, I\'ll keep you loaded!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94686,'','Without this corn, our village dies. But don\'t worry dear, I\'ve got this area on lockdown!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94687,'Over here! I\'ve got me mortar ready to fire!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94688,'','I wish I could explain what\'s happening, but it\'s as if the dead have arisen.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94689,'Worst fishing spot ever.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94690,'How do they move so fast?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94691,'Almost had it that time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94692,'They\'re mocking me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94693,'Would you shut up about the fish?!','',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(94694,'Maybe you should try some REAL work.','',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(94695,'Don\'t make me come over there.','',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(94696,'Worthless wretch. I hope you fall in.','',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(94697,'GAH! Ah... <gasp> that\'s better...','GAH! Ah... <gasp> that\'s better...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94698,'Help... Help!','Help... Help!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94699,'Anyone? Please help...','Anyone? Please help...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94700,'Help! They won\'t let me leave!','Help! They won\'t let me leave!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94702,'','You will have to get through me first if you want Gorefiend!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94703,'','You can\'t stop him... and you can\'t stop the Burning Legion...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94705,'Is the Admiral okay?','Is the Admiral okay?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94706,'Heh, someone\'s rescuing us for a change. I\'ll try not to get used to it.','Heh, someone\'s rescuing us for a change. I\'ll try not to get used to it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94707,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-GRAND CHAMPIONS-ALLIANCE.blp:50:80|t$b[Gryan Stoutmantle] You\'ve done it! Meet back at camp at once!','',0,0,0,0,0,0,71,0,0,33196,0,0,26124),
(94708,'Another volunteer! New blood to be spilled!','Another volunteer! New blood to be spilled!',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(94709,'','Thank you, $Gmister:miss;! I was so scared all by myself, but I know a shortcut back to town!',0,0,0,0,0,0,0,0,0,0,0,52781,26124),
(94711,'A Hulking Terror howls in rage!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94712,'We can observe Zeth\'Gol from here. The Bleeding Hollow clan is in chaos as one by one their leaders embrace Gul\'dan\'s dark gift. It is a good time to strike.','We can observe Zeth\'Gol from here. The Bleeding Hollow clan is in chaos as one by one their leaders embrace Gul\'dan\'s dark gift. It is a good time to strike.',6,1,0,0,0,0,0,0,0,0,0,0,26124),
(94713,'Work faster! Fail me and you will know horrors beyond reckoning!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94714,'','I have come too far to give up now. My people are in danger.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94715,'','The villagers tell stories about the people of the forest, but until today, I had never seen a... a druid.$B$BTheir magic is beyond my comprehension. It\'s as if the very forest can hear their commands.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94716,'','It was a desperate plan, some might even say foolish. It was a gamble to ask the druids for help.$B$BThey have treated me kindly, but it looks like they have their own battle to fight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94717,'','Do not tarry, $r. We cannot afford to squander such time.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(94718,'I am ready, Ysera. Let us find Malfurion!','I am ready, Ysera. We must find Malfurion!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(94719,'I see that I am speaking to a seasoned veteran.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94720,'Watch yourself. Make one wrong move and we\'ll throw you in chains.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94726,'Yum-my.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94727,'Uh. Meat\'s back on menu.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94728,'Eat.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94729,'Free! Free from that accursed body!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94730,'By besting me in battle, by destroying my body, you have undone the vile curse laid upon me by the mystics.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94731,'I go now to the Halls of Valor. You have my everlasting thanks, champion. May you one day die with honor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94732,'I accept your challenge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94733,'No! The Light burns in my heart... I will NEVER surrender!','',0,0,0,0,0,0,0,0,0,0,52041,0,26124),
(94734,'Great work! Better get movin\' to the next spot \'fore it\'s too late!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94735,'Time fer me ta get movin\'! This evil ne\'er seems ta stop!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94736,'Well that weren\'t too bad. Time we get a move on it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94737,'$n! You must... the Ashbringer. Leave me... there... isn\'t much time...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94738,'','Rage has blinded Malfurion. He and Xavius have a long history of conflict.',0,0,0,0,0,0,0,0,0,0,0,52935,26124),
(94739,'','Barrage incoming to the gates! Take Cover!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94740,'Akrrilo has been challenged at the Arena!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94741,'Tremble, mortals and despair! Doom has come to this world.','',0,0,0,0,0,0,0,0,0,0,50662,0,26124),
(94742,'Gul\'dan, ready the Black Gate for my invasion. These vermin will not delay me. The last light will fall by my hand.','',0,0,0,0,0,0,0,0,0,0,50663,0,26124),
(94743,'My coming heralds the end of your pathetic world, insects. Your meager forces shall be the first of many to be consumed by the Burning Legion!','',0,0,0,0,0,0,0,0,0,0,50664,0,26124),
(94744,'Let the echoes of doom resound across this wretched world, that all who live may hear them and despair.','',0,0,0,0,0,0,0,0,0,0,50648,0,26124),
(94745,'Your foolish crusade ends here, mortals. The legion comes and with it this world breathes its dying breath!','',0,0,0,0,0,0,0,0,0,0,50649,0,26124),
(94746,'Insignificant whelps!','',0,0,0,0,0,0,0,0,0,0,50681,0,26124),
(94747,'Anach kyree!','',0,0,0,0,0,0,0,0,0,0,50682,0,26124),
(94748,'Vermin!','',0,0,0,0,0,0,0,0,0,0,50683,0,26124),
(94749,'This world will burn!','',0,0,0,0,0,0,0,0,0,0,50684,0,26124),
(94750,'Witness the flames that have consumed countless worlds!','',0,0,0,0,0,0,0,0,0,0,50685,0,26124),
(94751,'All will burn in the legion\'s fire.','',0,0,0,0,0,0,0,0,0,0,50686,0,26124),
(94752,'Accept your miserable fate.','',0,0,0,0,0,0,0,0,0,0,50687,0,26124),
(94753,'Akim-kurai!','',0,0,0,0,0,0,0,0,0,0,50688,0,26124),
(94754,'Kirel narak!','',0,0,0,0,0,0,0,0,0,0,50689,0,26124),
(94755,'You are so easily corrupted.','',0,0,0,0,0,0,0,0,0,0,50690,0,26124),
(94756,'Kneel before the might of the legion!','',0,0,0,0,0,0,0,0,0,0,50691,0,26124),
(94757,'You cannot escape my power!','',0,0,0,0,0,0,0,0,0,0,50692,0,26124),
(94758,'Your foolish resolve will break.','',0,0,0,0,0,0,0,0,0,0,50693,0,26124),
(94759,'Manach sheek-thrish!','',0,0,0,0,0,0,0,0,0,0,50694,0,26124),
(94760,'Face my eternal wrath!','',0,0,0,0,0,0,0,0,0,0,50695,0,26124),
(94761,'Your soul will be mine!','',0,0,0,0,0,0,0,0,0,0,50696,0,26124),
(94762,'Your soul shall know endless torment!','',0,0,0,0,0,0,0,0,0,0,50697,0,26124),
(94763,'You will never escape the endless void!','',0,0,0,0,0,0,0,0,0,0,50698,0,26124),
(94764,'The infinite darkness shall claim you!','',0,0,0,0,0,0,0,0,0,0,50699,0,26124),
(94765,'You are powerless to stop me!','',0,0,0,0,0,0,0,0,0,0,50700,0,26124),
(94766,'Burn! Burn in the fires of my wrath!','',0,0,0,0,0,0,0,0,0,0,50701,0,26124),
(94767,'Your existence ends now!','',0,0,0,0,0,0,0,0,0,0,50702,0,26124),
(94768,'The legion cannot be stopped!','',0,0,0,0,0,0,0,0,0,0,50703,0,26124),
(94769,'Your fate is sealed!','',0,0,0,0,0,0,0,0,0,0,50704,0,26124),
(94770,'Durotan sent me here to keep the peace between the Laughing Skull survivors and the Draenei.$b$b<Frogan looks uncomfortably toward the filthy Laughing Skull refugee camp.>$b$bI\'d rather be fighting something.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(94771,'All will come to ruin!','',0,0,0,0,0,0,0,0,0,0,50705,0,26124),
(94772,'Your souls are mine.','',0,0,0,0,0,0,0,0,0,0,50706,0,26124),
(94773,'This meaningless little world has already succumbed to my corruption. The land itself seethes with the mark of the legion!','',0,0,0,0,0,0,0,0,0,0,50650,0,26124),
(94774,'The pitiful light you call upon is powerless against me, child. End this foolishness!','',0,0,0,0,0,0,0,0,0,0,50651,0,26124),
(94775,'Rikk amanalar golad mishun amir shi!','',0,0,0,0,0,0,0,0,0,0,50652,0,26124),
(94776,'You have only delayed the inevitable! The Burning Legion consumes all!','',0,0,0,0,0,0,0,0,0,0,50653,0,26124),
(94777,'Enough! Your meaningless struggle ends now!','',0,0,0,0,0,0,0,0,0,0,50654,0,26124),
(94778,'Look upon the endless forces of the Burning Legion and know the folly of your resistance.','',0,0,0,0,0,0,0,0,0,0,50655,0,26124),
(94779,'Destructions comes! Lok thorje sorankar!','',0,0,0,0,0,0,0,0,0,0,50656,0,26124),
(94780,'Worthless mongrel! Your miserable race will suffer endlessly for your rebellion.','',0,0,0,0,0,0,0,0,0,0,50657,0,26124),
(94781,'I grow tired of this pointless game. You face the immortal Legion, scourge of a thousand worlds.','',0,0,0,0,0,0,0,0,0,0,50658,0,26124),
(94782,'I will shatter this pathetic world! Its broken husk will be torn apart in the twisting nether for all time!','',0,0,0,0,0,0,0,0,0,0,50659,0,26124),
(94783,'Oblivion draws closer, mage! Give up!','',0,0,0,0,0,0,0,0,0,0,50660,0,26124),
(94784,'I am the defiler! Lord of the Burning Legion! This world will feel my wrath and burn!','',0,0,0,0,0,0,0,0,0,0,50661,0,26124),
(94785,'Pathetic.','',0,0,0,0,0,0,0,0,0,0,50678,0,26124),
(94786,'You fall so easily!','',0,0,0,0,0,0,0,0,0,0,50679,0,26124),
(94787,'Miserable worm.','',0,0,0,0,0,0,0,0,0,0,50680,0,26124),
(94788,'You have failed this world!','',0,0,0,0,0,0,0,0,0,0,50707,0,26124),
(94789,'Incoming barrage! Brace yourselves!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94790,'Here lies Javen Moonpaw, devoted father and loyal soldier. He fell in the Battle of Rinuin to a demon\'s blade. He shall be remembered always.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94791,'Jus to da southeast lies Fang\'rila. You be bringing friends wit ya, de Blackfang saberon are de most powerful tribe I ever seen. \n\nYou bring back da claws and mebbe I have some tings for ya...','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(94792,'What do those challenge totems you sell do?','What do those challenge totems you sell do?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(94793,'Summa dem kitties been around a while. They only come out when ya challenge dem.\n\nGo kill summa dem cats.\n\nI take ya claws and make a challenge totem. Take it to da Fang\'rila arena and place it. It be sure to anger one of dem really big ones. Make sure ya bring friends, them kitties be no joke!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(94794,'Finish your business here, then meet me in the keep.','',0,0,0,0,0,0,1,0,0,0,52654,0,26124),
(94795,'Centuries ago, Black Rook Hold was known amongst all the kaldorei. The masses feared its cruel justice, and the nobility were in awe of its power.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94796,'After Lord Ravencrest\'s passing, I led his army. The weight of command seasoned me quickly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94797,'Lord Ravencrest was the greatest commander of his time. Only few can be considered his equal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94798,'','Light protect us from this atrocity! Grant us your strength to banish this evil!',0,0,0,0,0,0,0,0,0,0,0,50562,26124),
(94799,'Kur\'talos Ravencrest, Lord of Black Rook Hold, was respected and feared by many.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94800,'','No! I will never give in to darkness. The legion will fall!',0,0,0,0,0,0,0,0,0,0,0,50563,26124),
(94801,'','The light will not fail!',0,0,0,0,0,0,0,0,0,0,0,50564,26124),
(94802,'It has been thousands of years since I last walked these grounds, and yet, the memories flood back quickly.$B$BIt was here that we rallied our efforts to hold back the demon invasion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94803,'Rise! Grow! Take this forest!','',0,0,0,0,0,0,0,0,0,0,52817,0,26124),
(94804,'I live to serve Xavius.','',0,0,0,0,0,0,1,0,0,0,52309,0,26124),
(94805,'Nothing can withstand the might of Xavius.','',0,0,0,0,0,0,0,0,0,0,52310,0,26124),
(94806,'I will spread the Nightmare to every mountain and valley!','',0,0,0,0,0,0,0,0,0,0,52311,0,26124),
(94807,'I\'m going to check in with Stormwind for updates.','I\'m going to check in with Stormwind for updates.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94808,'I\'ll regroup with you shortly. I\'ve got to repair.','I\'ll regroup with you shortly. I\'ve got to repair.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94809,'Duty calls!','Duty calls!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94810,'You cannot hope to stop me.','',0,0,0,0,0,0,0,0,0,0,52312,0,26124),
(94811,'Cut me down and I will grow anew!','',0,0,0,0,0,0,0,0,0,0,52313,0,26124),
(94812,'I grow tired of you.','',0,0,0,0,0,0,0,0,0,0,52314,0,26124),
(94813,'Your souls will feel the agony of a thousand worlds!','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(94814,'I will turn you into a weapon of the Legion. With your death, the last glimmer of hope for this world will be extinguished.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94815,'Thank you... I\'ll make my way back behind the lines.','Thank you... I\'ll make my way back behind the lines.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(94816,'They\'re animals! What has Gul\'dan done?','They\'re animals! What has Gul\'dan done?',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(94817,'I\'ll try to make it to safety. Thank you.','I\'ll try to make it to safety. Thank you.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(94818,'The carnage...!','The carnage...!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(94819,'You saved my life. I\'ll make my way back to camp.','You saved my life. I\'ll make my way back to camp.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(94820,'I owe you my life. I will return to camp!','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(94821,'These animals fight without honor - were our people ever this savage?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(94822,'Thank you... I will re-arm myself back at camp.','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(94823,'Gul\'dan is turning orcs into beasts!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(94824,'Must... get... another weapon...','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(94825,'What do you know of Zorammarsh?','What do you know of Zorammarsh?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94826,'Nobody owns the swamp, it is a death trap. Raptors, giant bats, giant snakes... and something else. There\'s some kind of giant shadow that prowls there. I felt its eyes on me while I inspected a mutilated corpse.$b$bNeedless to say I did not linger.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94827,'How defended is that Iron Horde tunnel?','How defended is that Iron Horde tunnel?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94828,'','The hold still has forces in it, but with the recent \"landscaping\" from the citadel, they have apparently been breached by more of those Pale.$b$bWe could probably leave it alone and let the Iron Horde and Pale fight it out in there, but I suspect there may be useful resources to \"acquire\" as well.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94829,'It is just as I feared. Lord Ravencrest\'s remains are gone.','',0,0,0,0,0,0,1,0,0,0,52315,0,26124),
(94830,'The Fel Forge looks completely corrupted, what are they building there?','The Fel Forge looks completely corrupted, what are they building there?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94831,'','Combine typical Iron Horde mass weapons building with fel corruption and you have that mess down there.$b$bThey are building tanks, cannons, and infantry weapons infused with fel energy. Also something bigger further in, something we should really stop them from building.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94832,'Fel corrupted water is just pouring down from the mountain. What is going on at the Throne of Kil\'jaeden?','Fel corrupted water is just pouring down from the mountain. What is going on at the Throne of Kil\'jaeden?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94833,'','I didn\'t get a great look but I didn\'t need to, it is a Burning Legion paradise up there. Giant demons being summoned, infernals raining down from the sky, cultists continuing the flow of corrupted water...$b$bYou should be really careful up there, everything there is big and mean. I highly recommend you bring friends before you take any offensive actions there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94834,'Join us in death, and the Master of the Tower will grant you eternal glory!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94835,'Insects! I am the will of Sargeras made manifest in your world. Stormwind is helpless before me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94836,'Have fun! Second gear sticks a little.','Have fun! Second gear sticks a little.',0,0,0,0,0,0,70,0,0,0,0,0,26124),
(94837,'Need a lift?','Need a lift?',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(94838,'Ready yourselves, men! The Broken Shore awaits. We leave on $n\'s command.','',0,0,0,0,0,0,1,0,0,0,52718,0,26124),
(94839,'You brave souls have been chosen to strike into the depths of hell itself to rescue Highlord Tirion. This is your last chance to turn back.','',0,0,0,0,0,0,1,0,0,0,52720,0,26124),
(94840,'I cannot thank you enough! You saved me!','I cannot thank you enough! You saved me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94841,'I am in your debt, but I must hurry to warn the others!','I am in your debt, but I must hurry to warn the others!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94842,'These lands are safe no longer...','These lands are safe no longer...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94843,'Ten hours in the sky. It\'s time for a break! You can take \'er up, if you have the skills.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94844,'There\'s bad stuff going on up there. Evil glowy draenei are messing with wolves and summoning demons. I think they killed all the normal draenei up there.$b$bIsn\'t there some sort of giant rock you can drop on all of them?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94845,'At first it wasn\'t impressive... raptors, snakes, big bats, nothing special.$b$bBut there is something in there... something really creepy that kills people. I got out of there super quick after that. And I\'m not going back.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94846,'I\'m on a break.','I\'m on a break.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94847,'Hey! Don\'t scratch it up!','Hey! Don\'t scratch it up!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94848,'Simply tell me where Sylvanas is, and I will end this quickly.','',0,0,0,0,0,0,0,0,0,33264,0,0,26124),
(94849,'You should tell me what you know. My hounds are getting... hungry.','',0,0,0,0,0,0,0,0,0,33264,0,0,26124),
(94850,'Where is Sylvanas? We shall stalk this entire wood if necessary.','',0,0,0,0,0,0,0,0,0,33264,0,0,26124),
(94851,'Da Iron Horde dere are in trouble. When de fel stuff broke da land, it angered da Pale. They be attacking each other in da tunnel.$b$bWe don\'t have ta worry about dat tunnel too much, but dere may be sum useful stuff in dere.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94852,'Defend the strongpoint!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94853,'Why not save yourself the pain and tell me where Sylvanas is? You could spare both of us a lot of inconvenience if you would just come clean.','',0,0,0,0,0,0,0,0,0,33264,0,0,26124),
(94854,'Ah! Perfect! A fresh lead. Where is your banshee queen?','',0,0,0,0,0,0,0,0,0,33264,0,0,26124),
(94855,'They are building weapons of war, but now they power them with Gul\'dan\'s fel might. Soon we will face fel cannon, tanks, and smaller weapons.$b$bAlso, something else... something bigger.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94856,'Come down, come down, my little bony friend. We might let you live if you tell me what I want to know.','',0,0,0,0,0,0,0,0,0,33264,0,0,26124),
(94857,'I was not able to get too close but what I saw was terrible!$b$bDemons! Infernals! Cultists corrupting the waters as they fall down here. You should take care and bring allies if you go up there, commander. The foes are quite fearsome.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94858,'I am suspicious of Altruis\'s motivations, but for now, we have the same goal - getting out of this prison.','',274,0,0,0,0,0,0,0,0,0,0,0,26124),
(94859,'Unleash the beasts!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(94860,'Soon, I too will drink from Gul\'dan\'s font of power. We will be unstoppable!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94861,'I may be a demon hunter, but I am not one of the Illidari. I do not follow Illidan\'s teachings with the same blind loyalty as you.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(94863,'You must become... the Ashbringer...','',0,0,0,0,0,0,0,0,0,0,63812,0,26124),
(94864,'In the end, I could not follow Illidan\'s ways. He was falling to the demonic taint, and becoming more like his sworn enemies.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(94865,'We got...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94866,'Nothing will... stop us...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94867,'|TInterface\\Icons\\Spell_Frost_WindWalkOn:20|t %s |cFFFF0404|Hspell:183480|h[Windwalks]|h|r, leaving behind images!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94868,'My power is but a fraction of... Gul\'dan\'s...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94869,'They are advancing! Felsworn, descend upon them. Show them your newfound strength.','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(94870,'Hold a bit longer, men! Reinforcements have arrived!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94871,'Hold the line! Those bombs will break through the doors soon enough!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94872,'Hah! Is that all ye got, demons? Ye ain\'t seen what me men have in store for ye just yet!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94873,'Still they stand in defiance. ARTILLERY! Fire on their position. Reduce them to PULP!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(94874,'By my hammer!','By my hammer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94875,'This one\'s fer you!','This one\'s fer you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94876,'Keep movin\'! There\'s more just beyond!','Keep movin\'! There\'s more just beyond!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94877,'This here\'s fer you!','This here\'s fer you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94878,'Yess... Yes... scorch the earth!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(94879,'Felsworn, the master calls us to action! Reclaim what\'s ours...','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(94880,'Very well, I shall come down there myself.','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(94881,'Another victory on the field. Gul\'dan will be pleased.','',0,0,0,0,0,0,11,0,0,0,0,0,26124),
(94882,'Blood and honor, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94883,'Ahahahahaha! I will cut you down.','',0,0,0,0,0,0,0,0,0,0,55326,0,26124),
(94884,'For honor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94885,'For justice!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94886,'There is no escape!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94887,'This is your final chapter!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94889,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-ARGALOTH.blp:50:80|t$b[Malgalor] What is the meaning of this?! My armor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94890,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-ARGALOTH.blp:50:80|t$b[Malgalor] This... is... impossible!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94892,'Victory! Heroes have gained ground against Gul\'dan\'s forces.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94893,'[PH] Thanks for freeing me! I\'m going to run off now!','[PH] Thanks for freeing me! I\'m going to run off now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94894,'','Bring us in!',0,0,0,0,0,0,5,0,0,0,0,51764,26124),
(94895,'You will be destroyed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94896,'I thirst for battle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94897,'Glory to Gul\'dan!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94898,'Come! My blood burns for combat!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94899,'<The Illidari prisoner\'s face is ghostly white.>$B$BI... broke free... and ran...$B$BI... almost made it...$B$BPlease save... my companions...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94900,'','I thirst for bloodshed...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94901,'','Gul\'dan brings us strength!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94902,'','Must ... kill!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94903,'Gul\'dan will finish you all.','Gul\'dan will finish you all.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94904,'I\'ve got one in my sights.','I\'ve got one in my sights.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94905,'We\'re being attacked!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94906,'Keep them from the machines...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94907,'No, get away!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94908,'','Gul\'dan must not succeed. As long as I live, we shall stand against the Legion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94909,'Our army grows in might. You will be overrun!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94910,'Gul\'dan has shown us the way. Soon, we will all have the fel gift!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94911,'The might of our machines and the power of our warlocks will spell your doom.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94912,'You are nothing compared to Gul\'dan\'s magic!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94913,'The fel blood burns my veins! It gives me strength!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94914,'I will RIP you to SHREDS!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94915,'Gul\'dan has shown me the path to infinite power.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94916,'Sad little creatures. You understand so little of the power we wield.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94917,'','Even he cannot hope to defeat Xavius alone. We must find him at once.',0,0,0,0,0,0,0,0,0,0,0,52920,26124),
(94922,'This brave animal stayed by his master\'s side until the bitter end.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94923,'Avenge... us....','Avenge... us....',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94924,'Welcome to the Ironhorn Enclave.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94925,'He took everything! My crew... my name... my SHIP!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94926,'Death will not stop my rage. I\'M the real Ironbeard!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94927,'Ha ha, my crew may have betrayed me, but they didn\'t get my treasure! It\'s like they forgot how to swim!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94928,'I curse the false Ironbeard! May his ship run into mines!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94929,'They got me... but at least I took several of them double-crossers with me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94930,'I can see your secrets...','',0,0,0,0,0,0,0,0,0,0,55222,0,26124),
(94931,'Guarm sniffs you as you walk by.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(94932,'Invaders. Warn the Brood Queen!','',0,0,0,0,0,0,0,0,0,0,55186,0,26124),
(94933,'I will drink your blood!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94934,'Demon hunters? How did you get here?','',0,0,0,0,0,0,0,0,0,0,55187,0,26124),
(94935,'I\'ll rend you limb from limb.','',0,0,0,0,0,0,0,0,0,0,55188,0,26124),
(94936,'Die, Illidari fool.','',0,0,0,0,0,0,0,0,0,0,55189,0,26124),
(94937,'I will bathe in your blood!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94938,'All who stand against Gul\'dan will be destroyed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94939,'The blood is our power!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94940,'For Gul\'dan! For Victory!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94941,'Don\'t let them near the equipment!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94942,'My hammer, your face!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94943,'Intruder in the camp!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94944,'Huh? You\'re not supposed to be here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94945,'Ahh... you\'re not a miner, are you? Well I\'m sure you can find some ore on the auction house. Or you could simply purchase ore from another adventurer.','',0,0,0,0,0,0,0,0,0,10824,0,0,26124),
(94946,'Don\'t interrupt me when I\'m working!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94947,'In the name of Gul\'dan!','In the name of Gul\'dan!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94948,'You dare attack us? Fool! The Legion is all-powerful!','You dare attack us? Fool! The Legion is all-powerful!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94949,'Show them the powers Gul\'dan has taught us!','Show them the powers Gul\'dan has taught us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94950,'Nothing will stop us!','Nothing will stop us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94951,'$n, we must take the fight to the Legion here in the volcano. They must be destroyed before we fly up to the Brood Queen\'s command ship, the Fel Hammer.\n\nThen, we\'ll kill her, take the Sargerite Keystone, and return to the Black Temple to slay the invaders.\n\nNo small feat, but I think we\'ll manage.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(94952,'Stick your head up for one second... just one second...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94953,'He he... don\'t worry... you won\'t even feel this...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94954,'Why do they keep showing up in the same spots?! This is too easy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94955,'Hah! I shot them all in formation!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94956,'Oops, that was a fel orc... his fault for getting in my sights at the last second.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94957,'For the Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94958,'These are our lands!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94959,'Press onward! We must stop them before they send reinforcements!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94960,'These battles never end!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94961,'I\'m going to check in with Orgrimmar.','I\'m going to check in with Orgrimmar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94963,'WARNING: CONTENT BEYOND THIS POINT IS VERY UGLY FIRST PASS. IT\'S PLAYABLE, BUT DO SO AT YOUR OWN RISK.','WARNING: CONTENT BEYOND THIS POINT IS VERY UGLY FIRST PASS. IT\'S PLAYABLE, BUT DO SO AT YOUR OWN RISK.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94964,'','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TInterface\\Icons\\achievement_character_bloodelf_female.blp:40|t$B[Lady Liadrin] You there. Over here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94965,'Hi!','[NYI - SEE A COOL SCENE WITH RAVENCREST & GUL\'DAN TURNING THE ILLIDARI.]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94966,'Lord Ravencrest cannot be stopped. We will prevail!','',0,0,0,0,0,0,0,0,0,0,52316,0,26124),
(94967,'Lord Ravencrest\'s army will purge this land of all you invaders.','',0,0,0,0,0,0,0,0,0,0,52317,0,26124),
(94968,'','Death is just the beginning!',0,0,0,0,0,0,0,0,0,0,0,50361,26124),
(94969,'','You heard the master.  These trespassers have caused enough trouble!',0,0,0,0,0,0,0,0,0,0,0,50364,26124),
(94970,'','Finally... one with... the master...',0,0,0,0,0,0,0,0,0,0,0,50362,26124),
(94971,'','Cease bombardment!',0,0,0,0,0,0,5,0,0,0,0,51760,26124),
(94972,'','Man the deck guns! All hands, prepare for contact with the enemy!',0,0,0,0,0,0,5,0,0,0,0,51763,26124),
(94973,'','Gryphon riders, first wing, prepare to descend! Second wing, hold position!',0,0,0,0,0,0,1,0,0,0,0,51761,26124),
(94974,'','Enemy fliers incoming! All guns, fire at will!',0,0,0,0,0,0,5,0,0,0,0,51765,26124),
(94975,'The body has been scorched in several places.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94976,'Face it... we\'s lost.','',0,0,0,0,0,0,0,0,0,33330,0,0,26124),
(94977,'We ain\'t gonna find no beach if we\'s keep goin\' in circles. You getting us lost!','',0,0,0,0,0,0,0,0,0,33330,0,0,26124),
(94978,'Ain\'t no peasants down here to munch on. You says there was peasants!','',0,0,0,0,0,0,0,0,0,33330,0,0,26124),
(94979,'Thems vrykul are hard on me teeth. We should head back to Highmountain.','',0,0,0,0,0,0,0,0,0,33330,0,0,26124),
(94980,'Yous said we was gonna be there by now. I ain\'t seein\' us being there now.','',0,0,0,0,0,0,0,0,0,33330,0,0,26124),
(94981,'This all your fault. We\'s lost.','',0,0,0,0,0,0,0,0,0,33330,0,0,26124),
(94982,'Ain\'t nuthin\' out here but mutton and vrykul. I thoughts you said we was going to find a bunch of tasty gnomes down here.','',0,0,0,0,0,0,0,0,0,33330,0,0,26124),
(94983,'Ain\'t no roastable tauren down here. You said we was going to find more roastable tauren down here.','',0,0,0,0,0,0,0,0,0,33330,0,0,26124),
(94984,'','Boarding party on the deck!',0,0,0,0,0,0,5,0,0,0,0,51766,26124),
(94986,'A quest objective event fires at this point.','A quest objective event fires at this point.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94987,'My magic will fix your gear right up. All I ask is a small tip for my work.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94988,'Rendarr has been challenged at the Arena!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94989,'Eyepiercer has been challenged at the Arena!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94990,'They will die.','',0,0,0,0,0,0,0,0,0,0,55133,0,26124),
(94991,'You won\'t survive Inferno Peak...','',0,0,0,0,0,0,0,0,0,0,55134,0,26124),
(94992,'Go forth, minions of Sargeras. Our time has come!','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(94993,'Spare no one.','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(94994,'Destroy all living things. Leave nothing in your path!','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(94995,'It\'s too late - they\'re here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94996,'I\'m supposed to be on the next boat!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94997,'','Darkgrove has fled into a nearby cavern. Hunt him down and end this.',0,0,0,0,0,0,0,0,0,0,0,52933,26124),
(94998,'Defend the boats. We\'ve got to get to Tanaan.','Defend the boats. We\'ve got to get to Tanaan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(94999,'I\'ll hold them off. Get to the boats!','I\'ll hold them off. Get to the boats!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95000,'You can\'t stop all of us.','You can\'t stop all of us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95001,'This war isn\'t over yet.','This war isn\'t over yet.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95002,'Protect the shoreline. They\'re trying to stop us!','Protect the shoreline. They\'re trying to stop us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95003,'Don\'t let them destroy the ships!','Don\'t let them destroy the ships!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95004,'A battle takes place against Xavius. Ysera falls and is corrupted. Malfurion, gravely wounded, chases after Xavius.','A battle takes place against Xavius. Ysera falls and is corrupted. Malfurion, gravely wounded, chases after Xavius.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95005,'Did you think it would be so easy, to wander these halls unattended?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95006,'Come then. This journey shall be your trial... and your doom.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95007,'[PLACEHOLDER SCENE] The tears have been stolen and the guards are dead! The player will see Xavius escape with the tears before anything can be done.','[PLACEHOLDER SCENE] The tears have been stolen and the guards are dead! The player will see Xavius escape with the tears before anything can be done.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95008,'','The battle continues, commander. Where shall we concentrate our efforts?',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(95009,'','Our enemies surround us, commander. Where shall we spill their blood today?',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(95010,'You called, and the Hand of Argus has answered.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95011,'','The very mountains bleed today, commander. Come, let us stave off armageddon one more day!',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(95012,'','Our outriders have reported back, commander. We are greatly outnumbered on all sides. It is a glorious day to fight!',0,0,0,0,0,0,11,0,0,0,0,0,26124),
(95013,'','So many foes... so little time... Who should die today?',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(95014,'','The jungle hides many dangers. It would be wise to go on the offensive today.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(95015,'','If this is truly the end of the world, then let us meet our end in the fields of combat!',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(95016,'','Gul\'dan hasn\'t broken us yet, commander. Where shall we strike today?',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(95017,'How dare you interrupt my entertainment!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95018,'How did... I... lose....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95019,'Hostiles in the camp! Destroy them - in the name of Gul\'dan!','Hostiles in the camp! Destroy them - in the name of Gul\'dan!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95020,'The might of Gul\'dan is upon you!','The might of Gul\'dan is upon you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95021,'For Gul\'dan! For the Legion!','For Gul\'dan! For the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95022,'Burn!','Burn!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95023,'Kill them all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95024,'YOUR BLOOD IS MINE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95025,'I\'m gonna enjoy gutting you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95026,'Blood! Blood! BLOOD!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95027,'Strip the flesh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95028,'For the glory of Gul\'dan!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95029,'You know what to do, smith: temper, heat, hammer, and weld. You can use any of the shop\'s equipment.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95030,'Go see if you can find a frost mage to help us, $n. If we can get our quenching trough cool enough, we can perform this leysmithing technique.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95031,'Noo! My power!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95032,'A responsible smith does not waste material. You may use any pieces of scrap metal that you find around our camp.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95033,'','Be quick about your work. You\'ll only have a small window of time to hammer out those red-hot leystone bars into the components you need.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95034,'Your feeble minds will be mine to harvest!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95035,'None can resist the Legion. In time, all will serve.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95036,'The Firmament Stone is sacred to our order.$b$bIt is not unheard of for an outsider to seek out our anvil... but access does not come easily.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95037,'Never should have come here! He is lost!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95038,'Leave! The Crusader must not be disturbed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95039,'The Construct prepares to |cFFFF0000|Hspell:184247|h[Felblaze Charge]|h|r towards you!','The Construct prepares to |cFFFF0000|Hspell:184247|h[Felblaze Charge]|h|r towards you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(95040,'Stay away! Stay away! I do you favor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95041,'I will conquer this jungle! I will bring it all to the light! You will not stop me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95042,'At last I see... I failed long ago...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95043,'The Construct faces you and readies a |cFFFF0000|Hspell:180221|h[Volatile Fel Orb]|h|r!','The Construct faces you and readies a |cFFFF0000|Hspell:180221|h[Volatile Fel Orb]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(95044,'The Legion is coming. It is in our best interest to be ready for them.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95045,'I say let them come. We will defeat them together... or die trying.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95046,'','This temple has stood for generations as a tribute to The Moon Goddess, Elune.$b$bThis is not the first time the Burning Legion has sought to destroy it... and they will fail just as they did before.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95047,'Come and get some, demons! I\'ve got one bomb for each of ya!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95048,'Hold the line! Funnel them into range of my bombs!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95049,'Boom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95050,'That\'s gotta hurt!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95051,'The threat of the Emerald Nightmare approaches as an unstoppable storm upon the horizon... but we would sooner die fighting than run away and let it claim all that we hold dear.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95052,'First Cenarius... now... Ysera?$b$bXavius will pay for what he has done... they will be avenged!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95053,'Our power is undeniable!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95054,'How... did you...?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95055,'','We\'ve got him now! Focus on their commander!',0,0,0,0,0,0,0,0,0,924,0,53370,26124),
(95056,'The legion will crush you! INFERNO!','',0,0,0,0,0,0,0,0,0,924,53371,0,26124),
(95057,'Xavius...$b$bHe must be stopped...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95058,'','Look out, infernals!',0,0,0,0,0,0,0,0,0,924,0,53372,26124),
(95059,'Your souls will fuel the soul forge!','',0,0,0,0,0,0,0,0,0,924,53373,0,26124),
(95060,'I will flay the flesh from your bones!','',0,0,0,0,0,0,0,0,0,924,53374,0,26124),
(95061,'What has become of our precious Shaladrassil... our beloved Cenarius?$b$bI have failed them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95062,'<The sapling that grew from the Seed of Life is lush and vibrant, starkly contrasting the twisted destruction all around. From within the glowing leaves of the tree, the whisper of a voice can be softly heard...>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95063,'Now, $p, hit the metal as hard as you can.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95064,'Is that all you can do? You\'ll have to do much better than that.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95065,'Come on, smith! HIT IT!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95066,'','You... must get to the temple...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95067,'My power will destroy this pathetic land!','',0,0,0,0,0,0,0,0,0,0,52318,0,26124),
(95068,'How do you think you will fare against the might of Xavius?','',0,0,0,0,0,0,0,0,0,0,52319,0,26124),
(95069,'The Nightmare will consume all of you!','',0,0,0,0,0,0,0,0,0,0,52320,0,26124),
(95070,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-ARGALOTH.blp:50:80|t$b[Malgalor] You will all DIE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95071,'Azsuna will fall!','Azsuna will fall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95072,'Surrender the Tidestone, mortal.','Surrender the Tidestone, mortal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95073,'You cannot stop us. We are infinite.','You cannot stop us. We are infinite.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95074,'Azsuna is only the beginning.','Azsuna is only the beginning.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95075,'Hurry. The Illidari are about to be overrun.','',0,0,0,0,0,0,0,0,0,0,52607,0,26124),
(95076,'','Such devastation. We must destroy these monstrosities.',0,0,0,0,0,0,0,0,0,33395,0,52928,26124),
(95077,'','Call down my wrath to purge these unnatural creatures.',0,0,0,0,0,0,0,0,0,33395,0,52934,26124),
(95078,'','I fear that this forest is beyond hope. We must make haste.',0,0,0,0,0,0,0,0,0,33395,0,52931,26124),
(95079,'PLACEHOLDER: Cenarius is taken by the Nightmare. Enraged, Malfurion pursues Xavius, leaving the others behind.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95080,'We need to get down there, $n. The Illidari need our help to destroy the Burning Legion.\n\nOnce we\'ve done that, we can get to our business with the Pillar of Creation here on Azsuna.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(95081,'','I will never be taken prisoner again. Never!',0,0,0,0,0,0,0,0,0,0,0,55089,26124),
(95082,'PLACEHOLDER: Xavius escapes with Malfurion to the dungeon. Ysera has been sent to destroy the temple. Koda the Archdruid is dying...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95083,'','Xavius commands us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95084,'','This river will flow with your blood.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95085,'','Succumb to the Nightmare or die.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95086,'','This river is ours!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95087,'You\'ve come because you\'ve heard of the legend of $p, the paladin proven worthy of wielding the Silver Hand and succeeding Tirion. With $p at our head we can be the weapon brought to bear against the Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95088,'Do not linger here too long. The Legion is attacking everywhere.','',0,0,0,0,0,0,0,0,0,0,52606,0,26124),
(95089,'$n, I\'ll meet you up there. You will find the repose up the road to the northeast.','',0,0,0,0,0,0,0,0,0,0,52609,0,26124),
(95090,'Khadgar nods to Stellagosa.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95091,'|cFFFF0000|Hspell:182582|h[Fel Incineration]|h|r is following you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(95092,'What is happening here?','',0,0,0,0,0,0,0,0,0,0,52610,0,26124),
(95093,'I\'m free!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95094,'You got it from here! We\'ll push them back at the other camps!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95095,'Keep pushing! We\'ve gotta go help the others.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95096,'This is as far as we go. We\'ll secure the perimeter and meet up with you soon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95097,'What ho! The pathway to Un\'goro Crater is embroiled in a great fracas! I suspect dragons!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95098,'We\'ve set up along the cliffs at the southern pass! We will hold them off as long as we can...','We\'ve set up along the cliffs at the southern pass! We will hold them off as long as we can...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95099,'Good job Warder! Did any get away?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95100,'No sir, it was only these two.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95101,'Yes executor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95102,'We\'re on our way!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95103,'Engineers! Throw yourselves upon them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95104,'Your presence is NOT welcome in OUR chamber! Your kind could never fathom the knowledge flowing through these runes!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95105,'I won\'t bother with you, peasants. I\'ll let my students deal with your kind.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95106,'Very well. I\'ll deal with you myself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95107,'','HA HA HA!  Bloodbeard, it looks like your challenger has arrived.',595,0,0,0,0,0,0,0,0,0,0,0,26124),
(95108,'','Don\'t worry Nel. We\'ll find our prey soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95109,'','And afterward I\'ll give you two a juicy clefthoof steak!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95110,'They come for me. Stop them, Sargerei!','',0,0,0,0,0,0,0,0,0,0,50839,0,26124),
(95111,'You could not stop me in Shattrath. You will not end me here, fools.','',0,0,0,0,0,0,0,0,0,0,50840,0,26124),
(95112,'Just a bit longer, and the binding will be complete...','',0,0,0,0,0,0,0,0,0,0,50841,0,26124),
(95113,'Fight, you fools! Stop them!','',0,0,0,0,0,0,0,0,0,0,50842,0,26124),
(95114,'I should have expected as much. No matter.','',0,0,0,0,0,0,0,0,0,0,50843,0,26124),
(95115,'The construct is fully powered... the final binding will have to wait. For now, I believe we have a score to settle, fleas!','',0,0,0,0,0,0,0,0,0,0,50844,0,26124),
(95116,'For now, I believe we have a score to settle, fleas.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95117,'Death could not stop me - how do you hope to?','',0,0,0,0,0,0,0,0,0,0,50831,0,26124),
(95118,'You killed me once, mortals. It will not happen again.','',0,0,0,0,0,0,0,0,0,0,50832,0,26124),
(95119,'$n, over here. Let us walk in together.','',0,0,0,0,0,0,0,0,0,0,52611,0,26124),
(95124,'Placeholder cinematic: The player is granted freedom by Helira.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95125,'Time itself bends to my will!','',0,0,0,0,0,0,0,0,0,0,50845,0,26124),
(95126,'I am more powerful than ever!','',0,0,0,0,0,0,0,0,0,0,50846,0,26124),
(95127,'Kneel before me!','',0,0,0,0,0,0,0,0,0,0,50847,0,26124),
(95128,'HEY! I\'m at 100% Life!','HEY! I\'m at 100% Life!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95129,'No! The binding... I cannot control...','',0,0,0,0,0,0,0,0,0,0,50833,0,26124),
(95130,'My soul itself shall strike you down!','',0,0,0,0,0,0,0,0,0,0,50834,0,26124),
(95131,'Sargerei! To me!','',0,0,0,0,0,0,0,0,0,0,50835,0,26124),
(95132,'Join me in death!','',0,0,0,0,0,0,0,0,0,0,50848,0,26124),
(95133,'Wither away, fools!','',0,0,0,0,0,0,0,0,0,0,50849,0,26124),
(95134,'Your life ends here!','',0,0,0,0,0,0,0,0,0,0,50850,0,26124),
(95135,'You cannot control it... it is MINE!','',0,0,0,0,0,0,0,0,0,0,50836,0,26124),
(95136,'Out! It is too good for you, pitiful soul!','',0,0,0,0,0,0,0,0,0,0,50837,0,26124),
(95137,'The nether! It... consumes me...','',0,0,0,0,0,0,0,0,0,0,50838,0,26124),
(95138,'The time of apocalypse is upon us once again, $n.$b$bWill you rise to the occasion?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95139,'You! Yesssss! With that power in my hands, I can get him back.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95140,'<Koltira regards you with an emotionless stare.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95141,'<Koltira glowers at you.>$b$bLeave... I have nothing to say to you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95142,'When you took your first unholy breath it was in the musty halls of Acherus.$b$bIt is here where we must set aside our differences and work as a united Knights of the Ebon Blade if we are to defeat the Demons.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95143,'Ywaqol ish\'wi agthshh.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95144,'What has been set in motion will come to pass.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95145,'Iilth vwah, uhn\'agth fhssh za.','',0,0,0,0,0,0,0,0,0,0,18543,18543,26124),
(95146,'Where one falls, many shall take its place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95147,'Yglath vu\'aghth qol. Yglath ish\'za.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95148,'There is no light in the darkness. There is no hope.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95149,'Ithvil azj shnk naush.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95150,'Gaze upon your end.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95151,'[PH]The Runeseer banishes you to Helheim!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95152,'Az\'jtal calls upon its servants!','Az\'jtal calls upon its servants!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(95153,'You can\'t backstab me again Torglork! I\'m already dead!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95154,'Should have died... on my own ship...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95155,'I can kill just as fast up close!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95156,'Take care of my rifle...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95157,'This is sacred ground! Prepare to die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95158,'I will haunt you... forever...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95159,'Not... over..','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95160,'Slice it into strips!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95161,'Must... sleep....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95162,'Great... ANOTHER problem!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95163,'You take care of the Pale then...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95164,'I saw you coming a mile away!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95165,'You\'ll never get past the traps...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95166,'Little $r $n is friend to Gentle Rosh.\n\nYou stay?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(95167,'Yes, I think I\'ll stay awhile.','Yes, I think I\'ll stay awhile.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95168,'$n was consumed by Hunger for Life.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95169,'','Thanks for the help, $g handsome:beautiful;.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(95170,'','I\'m taking this opportunity to leave. I\'ll tell Mr. Shackle to expect you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95171,'Heyo! You... YOU! I owe you. I better get out of here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95172,'Rgth vi zash.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95173,'They see your soul. They know your fear.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95174,'Vilk qo nrsh, czkth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95175,'The tide cannot be altered. It ebbs and flows.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95176,'One for you! And another for you! Boom! Ha ha ha ha!','',11,0,0,3,0,0,0,0,0,0,0,0,26124),
(95177,'There\'s enough black powder to go around, demon scum! Step right up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95178,'You, in the green! Hit their left flank! No, their other left!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95179,'Gentle Rosh likes you, my little $r. Now Gentle Rosh will leave.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95181,'','You\'re messin\' with the wrong cartel! Get \'em, boys!',25,0,0,1,0,0,0,0,0,0,0,0,26124),
(95182,'','Steady! Stay in file! Show this Demon scum how a Goblin fights!',25,0,0,1,0,0,0,0,0,0,0,0,26124),
(95183,'','Yo flyboy, in the balloon! More bombs!',22,0,0,1,0,0,0,0,0,0,0,0,26124),
(95184,'','I\'ve been in there for days. Thank you, $c. I have got to go, if you know what I mean!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95185,'To walk the high halls is the greatest honor of the valorous.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95186,'You wield the Light with an unwavering conviction. I admire your passion, $n. I will give you my blessing.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(95187,'I will give you my blessing.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95188,'A pity you will never set foot beyond its gates!','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(95189,'Impossible! No outsider has ever bested me in combat!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(95191,'I judge you worthy, $c.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95192,'What\'s this? An outsider seeks my judgment?','',0,0,0,0,0,0,1,0,0,0,51660,0,26124),
(95193,'Insolent worm!  You would disgrace the Halls of Valor with your presence!','',0,0,0,0,0,0,25,0,0,0,51661,0,26124),
(95194,'I was mistaken. Your worth cannot be denied.','',0,0,0,0,0,0,274,0,0,0,52959,0,26124),
(95195,'You wish to walk among the chosen?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95196,'Come then, show me your fury!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(95197,'Never have I faced such ferocity. The blood of the dragon flows within your veins, outsider.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95198,'','Hey... HEY $g mister:lady;. You gotta let me outa here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95199,'I\'m right over here. Just watch out for the giant!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95200,'You come open door. Gentle Rosh not crush you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95201,'','Stand proud, warriors. Our enemies march upon the foot of this mighty citadel. Be on guard.',0,0,0,0,0,0,0,0,0,0,0,50532,26124),
(95202,'','Status report, soldier!',0,0,0,0,0,0,0,0,0,0,0,50533,26124),
(95203,'','How fares your work, warrior?',0,0,0,0,0,0,0,0,0,0,0,50534,26124),
(95204,'','You, check on the citadel\'s defenses.',0,0,0,0,0,0,0,0,0,0,0,50536,26124),
(95205,'','Inspect our defenses, now!',0,0,0,0,0,0,0,0,0,0,0,50537,26124),
(95206,'','I see we have visitors. To arms!',0,0,0,0,0,0,0,0,0,0,0,50538,26124),
(95207,'','So, you wish to test the might of the Fel Horde? Come warriors, show them how we treat unwanted guests.',0,0,0,0,0,0,0,0,0,0,0,50517,26124),
(95208,'','Hah-ha! Trample their corpses!',0,0,0,0,0,0,0,0,0,0,0,50539,26124),
(95209,'','For Gul\'dan!',0,0,0,0,0,0,0,0,0,0,0,50540,26124),
(95210,'','We are victorious!',0,0,0,0,0,0,0,0,0,0,0,50541,26124),
(95211,'','Taste my axe!',0,0,0,0,0,0,0,0,0,0,0,50542,26124),
(95212,'','Die!',0,0,0,0,0,0,0,0,0,0,0,50543,26124),
(95213,'','If you want something done right, you have to do it yourself...',0,0,0,0,0,0,0,0,0,0,0,50518,26124),
(95214,'','I\'ll be back...',0,0,0,0,0,0,0,0,0,0,0,50519,26124),
(95215,'','Fire in the hole!',0,0,0,0,0,0,0,0,0,0,0,50732,26124),
(95216,'','Comin\' in hot!',0,0,0,0,0,0,0,0,0,0,0,50733,26124),
(95217,'','Blitz!',0,0,0,0,0,0,0,0,0,0,0,50734,26124),
(95218,'','Run them down!',0,0,0,0,0,0,0,0,0,0,0,50735,26124),
(95219,'','Cannons on the way.',0,0,0,0,0,0,0,0,0,0,0,50736,26124),
(95220,'','They\'ll never see what hit them...',0,0,0,0,0,0,0,0,0,0,0,50737,26124),
(95221,'','Send in the crusher!',0,0,0,0,0,0,0,0,0,0,0,50738,26124),
(95222,'','Crusher, incoming!',0,0,0,0,0,0,0,0,0,0,0,50739,26124),
(95223,'','Burn them to the ground.',0,0,0,0,0,0,0,0,0,0,0,50740,26124),
(95224,'','Destruction!',0,0,0,0,0,0,0,0,0,0,0,50529,26124),
(95225,'','Strike them down!',0,0,0,0,0,0,0,0,0,0,0,50530,26124),
(95226,'','Destroy them!',0,0,0,0,0,0,0,0,0,0,0,50531,26124),
(95227,'','The might and invention of the Fel Horde... the fury of Hellfire itself! Behold!',0,0,0,0,0,0,0,0,0,0,0,50506,26124),
(95228,'','I warned you!',0,0,0,0,0,0,0,0,0,0,0,50501,26124),
(95229,'','FULLY CHARGED!',0,0,0,0,0,0,0,0,0,0,0,50503,26124),
(95230,'','Heads up!',0,0,0,0,0,0,0,0,0,0,0,50504,26124),
(95231,'','Ha ha ha, that was fun.',0,0,0,0,0,0,0,0,0,0,0,50505,26124),
(95232,'','EJECT! EJECT!',0,0,0,0,0,0,0,0,0,0,0,50502,26124),
(95233,'','Tick tock, your time is up!',0,0,0,0,0,0,0,0,0,0,0,50509,26124),
(95234,'','Pounded.',0,0,0,0,0,0,0,0,0,0,0,50507,26124),
(95235,'','Well done.',0,0,0,0,0,0,0,0,0,0,0,50508,26124),
(95236,'','The ground trembles!',0,0,0,0,0,0,0,0,0,0,0,50510,26124),
(95237,'','Burn burn burn!',0,0,0,0,0,0,0,0,0,0,0,50511,26124),
(95238,'','Incoming!',0,0,0,0,0,0,0,0,0,0,0,50512,26124),
(95239,'','Fire!',0,0,0,0,0,0,0,0,0,0,0,50513,26124),
(95240,'','Inferno!',0,0,0,0,0,0,0,0,0,0,0,50514,26124),
(95241,'','Tick tock, the clock is ticking!',0,0,0,0,0,0,0,0,0,0,0,50515,26124),
(95242,'','Boom!',0,0,0,0,0,0,0,0,0,0,0,50516,26124),
(95243,'The spirits have sent you here, $c.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95244,'Do you hear? The elements cry out.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95245,'My people mean you no harm.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95246,'Rest while you can, hero. I will keep watch.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95247,'Knights, ATTENTION!','Knights, ATTENTION!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95248,'We\'ve just entered hostile territory. Because of this we will be changing the patrol plan to maintain at least one flight active at all times. I don\'t want any surprises like at the Broken Shore.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95249,'','What is nature\'s call?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95250,'','Is there trouble?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95251,'','When Nature speaks, we must listen and take action.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95252,'I, Tyr, divine all the power granted to me by the Pantheon onto this paladin.','',0,0,0,0,0,0,1,9,0,0,0,0,26124),
(95253,'Our foes gather and the edge of oblivion hangs over our heads once again. They would have our world destroyed in a wave of hellfire. This we must not allow!','Our foes gather and the edge of oblivion hangs over our heads once again. They would have our world destroyed in a wave of hellfire. This we must not allow!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95254,'Use my gift wisely, $n. The weapon you now hold is a living bastion of the Light.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95255,'Go, report to Lady Alistra for your assignments. Suffer well, knights.','Go, report to Lady Alistra for your assignments. Suffer well, knights.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95256,'Suffer well, sir!','Suffer well, sir!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95257,'Commander!','Commander!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95259,'Plundering','Plundering',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(95260,'|TInterface\\Icons\\inv_misc_boilingblood.blp:20|t %s begins to use |cFFFF0404|Hspell:184357|h[Tainted Blood]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95261,'','%s marks half of her enemies with |cFFFF0404|Hspell:184449|h[Mark of the Necromancer]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95262,'','%s summons horrors from the |cFFFF0404|Hspell:184681|h[Darkness]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95263,'|TInterface\\Icons\\spell_nature_mirrorimage.blp:20|t %s begins to duplicate into |cFFFF0404|Hspell:183734|h[Mirror Images]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95264,'|TInterface\\Icons\\ability_foundryraid_demolition.blp:20|t %s crashes around using |cFFFF0404|Hspell:184366|h[Demolishing Leap]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95269,'Leave me! My research must continue undisturbed.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(95270,'This new job is m-much better... no m-mistress to boss me around.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95271,'M-more cleaning to be d-done!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95272,'Oh, I m-missed a spot...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95273,'Ah, m-more dirt. It\'s a m-mirror into my soul.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95274,'The satyrs will pay for this!','The satyrs will pay for this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95275,'I thought I was done for!','I thought I was done for!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95276,'You have my thanks!','You have my thanks!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95277,'The satyrs... they came out of nowhere!','The satyrs... they came out of nowhere!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95278,'I would be dead were it not for your aid!','I would be dead were it not for your aid!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95279,'Please... Val\'sharah must be saved!','Please... Val\'sharah must be saved!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95280,'That was only the beginning! Line \'em up, boys!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95281,'I\'m gonna gather the troops! Hold out as long as you can!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95282,'Another wave incoming!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95283,'Nice weapon you have there, $c. Speak with Jace and Allari if you\'d like to help.','',0,0,0,0,0,0,0,0,0,33556,52715,0,26124),
(95284,'Make ready, hero. We shall soon stand in the presence of the Lord of the Forest.','',0,0,0,0,0,0,0,0,0,0,52277,0,26124),
(95285,'','You have my thanks, stranger. It is good to have found aid in such dire circumstances.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95286,'Nightmane sent me to find you. Can you walk?','Nightmane sent me to find you. Can you walk?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95287,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95288,'If you make it past the beast seek Baldir. Through Baldir you may speak with Helira. Goodluck, $c.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95289,'','You are too late... The Dark Lady is already gone...',0,0,0,0,0,0,0,0,0,0,0,51769,26124),
(95290,'<The small creature shivers in fear. It appears too distraught to speak with you.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95291,'Queen Ashildir is on the Eternal Battlefield. I suggest you move quickly before Helira changes her mind.','',378,0,0,0,0,0,0,0,0,0,0,0,26124),
(95292,'','We\'ll tend to the wounded up here. Go quickly. Wake the Archdruid.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95293,'<The drake fixes you with a serpentine stare.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95294,'Advance. Destroy the Illidari. Take Azsuna.','',0,0,0,0,0,0,0,0,0,0,52751,0,26124),
(95295,'We are the LEGION. You cannot prevail.','',0,0,0,0,0,0,0,0,0,0,51889,0,26124),
(95296,'Too late, \"heroes\". Your world is lost.','',0,0,0,0,0,0,0,0,0,0,51890,0,26124),
(95297,'Grovel on your knees. Beg for your lives!','',0,0,0,0,0,0,0,0,0,0,52752,0,26124),
(95298,'You and your world will soon perish.','',0,0,0,0,0,0,0,0,0,0,52749,0,26124),
(95299,'Your titan gods have abandoned you. Lay down your arms. There is no hope left.','',0,0,0,0,0,0,0,0,0,0,52754,0,26124),
(95300,'That weapon will not save you. How can such a tiny thing prevail against the might of the Burning Legion?','',0,0,0,0,0,0,0,0,0,0,52750,0,26124),
(95301,'Salt the earth. Boil their seas. Drive them before you!','',0,0,0,0,0,0,0,0,0,0,52747,0,26124),
(95302,'You should have joined us!','',0,0,0,0,0,0,0,0,0,36777,52753,0,26124),
(95303,'Back to the Twisting Nether...','',0,0,0,0,0,0,0,0,0,36777,52748,0,26124),
(95304,'The console displays a number 1.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95305,'Enough, parasites! You deal with me now.','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(95306,'I should be on the battlefield with the others.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95307,'As soon as I get free I\'m going to kill the first kvaldir I see.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95308,'I am worthy. I know I\'m worthy...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95309,'Be ready champion, I know not what lies beyond this barrier.','',0,0,0,0,0,0,603,0,0,0,50294,0,26124),
(95310,'Almost there...','',0,0,0,0,0,0,0,0,0,0,50295,0,26124),
(95311,'It is done. Go. Stop Gul\'dan!','',0,0,0,0,0,0,0,0,0,0,50296,0,26124),
(95312,'Guarm senses something.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95313,'Be blessed, young one.','',0,0,0,0,0,0,0,0,0,0,52278,0,26124),
(95314,'Ashildir is here among us? Soon we will be free.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95315,'You have brought hope. Helira will not hold me here any longer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95316,'Bloodbeard will feel my wrath.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95317,'My queen has returned. The mystics will pay for their deception.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95318,'I... I can think clearly again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95319,'The goddess Helira has spoken. You will not defeat me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95320,'No.... impossible. Helira, spare me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95321,'','Bloodbeard you have failed me. Your punishment will be swift.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(95322,'','You are free to go champion. Leave now before I change my mind.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(95323,'Thank you, traveler. All is not yet lost.','',0,0,0,0,0,0,0,0,0,0,52279,0,26124),
(95324,'Elothir be with you, friend of the grove.','',0,0,0,0,0,0,0,0,0,0,52280,0,26124),
(95325,'Here they come!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95326,'Destroying this barrier will take a great deal of my strength. I fear I may not be able to aid you after it is broken.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95328,'Begin the ritual please.','Begin the ritual please.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95331,'','Prepare yourself. Gul\'dan is at his most powerful.',0,0,0,0,0,0,603,0,0,0,0,50568,26124),
(95332,'','In the name of the prophet. In the name of the light. This place shall be cleansed!',0,0,0,0,0,0,0,0,0,0,0,50569,26124),
(95333,'','Ugh...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95334,'','There... Go! Stop Gul\'dan!',0,0,0,0,0,0,0,0,0,0,0,50570,26124),
(95335,'','I... survived the fall.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95336,'','Swiftflight! Where is Swiftflight!?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95337,'Kill!','',0,0,0,0,0,0,0,0,0,0,50078,0,26124),
(95338,'Your soul is complete once more. Helira\'s hold on you is slipping away.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95339,'Destroy!','',0,0,0,0,0,0,0,0,0,0,50085,0,26124),
(95340,'Smash!','',0,0,0,0,0,0,0,0,0,0,50086,0,26124),
(95341,'Drown!','',0,0,0,0,0,0,0,0,0,0,50091,0,26124),
(95342,'Burn to Ashes!','',0,0,0,0,0,0,0,0,0,0,50087,0,26124),
(95343,'Crushed by earth!','',0,0,0,0,0,0,0,0,0,0,50082,0,26124),
(95344,'None Escape!','',0,0,0,0,0,0,0,0,0,0,50080,0,26124),
(95345,'Destruction!','',0,0,0,0,0,0,0,0,0,0,50079,0,26124),
(95346,'Weak!','',0,0,0,0,0,0,0,0,0,0,50090,0,26124),
(95347,'Break!','',0,0,0,0,0,0,0,0,0,0,50092,0,26124),
(95348,'Shatter!','',0,0,0,0,0,0,0,0,0,0,50088,0,26124),
(95349,'Ruin!','',0,0,0,0,0,0,0,0,0,0,50089,0,26124),
(95350,'Fragile!','',0,0,0,0,0,0,0,0,0,0,50083,0,26124),
(95351,'Broken!','',0,0,0,0,0,0,0,0,0,0,50084,0,26124),
(95352,'I... am... unmade...','',0,0,0,0,0,0,0,0,0,0,50081,0,26124),
(95353,'','Oh no! What did they do to you!?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95354,'A Sargerei Dominator protects Socrethar with |cFFFF0000|Hspell:184053|h[Fel Barrier]|h|r!','A Sargerei Dominator protects Socrethar with |cFFFF0000|Hspell:184053|h[Fel Barrier]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(95359,'','We are free! Until we meet again, champion.',378,0,0,0,0,0,0,0,0,0,0,0,26124),
(95360,'Four hours up in the air... It\'s time for a rest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95361,'You hit \'em hard, sir!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95362,'I\'m sure the new pilots coming in will do great!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95363,'','Legionnaires, move out! Storm those ships and find Sylvanas!',0,0,0,0,0,0,0,0,0,0,0,52957,26124),
(95364,'I only did what I thought was right.','',0,0,0,0,0,0,2,0,0,0,52808,0,26124),
(95365,'If we do not act quickly against the satyrs, the vale will be lost. We have little time...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95366,'We must fight our way deeper into the corruption if we are to strike at the heart of this threat!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95367,'The leader of the satyrs was seen near Saberfang Cavern. I shall go on ahead to confront him.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95368,'When you have completed your mission, meet me at Saberfang Cavern! This corruption ends now!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95369,'','%s |cFFFF0404|Hspell:184476|h[Reaps]|h|r all marked foes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(95370,'$p, the Skyfire is being overrun. They need you up there!','$p, the Skyfire is being overrun. They need you up there!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95371,'It looks as if woodland sprites have slain this little bear\'s family.$b$bVisibly trembling, the cub looks up at you with desperate eyes.$b$bYou hear rustling in the woods nearby: the forest sprites are coming back.$b$bThe baby bear won\'t survive on its own. Are you willing to rescue it?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95372,'The power of the totem is mine. You won\'t take it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95373,'Faster, swine! Move faster! You serve Sargeras now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95374,'Take everything for the Legion! Leave no spoils behind.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95375,'','I\'ll need some time to look at this, $glad:lass;. I may need to consult with some of my... contemporaries, as well. Come back in a few and I\'ll tell you what I\'ve learned.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95376,'','Glad you made it, champion! Better prepare for a bit of action. The Legion seems to have found a power source located in Un\'Goro. We must stop them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95377,'','Wait...! Wait for us...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95378,'','They hurt our friend Lixi over there. It\'s time for some payback!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95379,'','Hey, Porsha! Get a move on it, sister!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95380,'You... *cough* filthy swine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95381,'','Thank you - all of you. Everyone get ready. This isn\'t going to be easy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95382,'*cough* You\'re going to pay for that!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95383,'*cough* Augh my eyes!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95384,'Augh! It burns!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95385,'I\'ll save you, poor little thing.','I\'ll save you, poor little thing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95386,'','Stay close! Here we go!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95387,'I\'ll stab you in the knees!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95388,'You\'ll be sorry!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95389,'','',0,0,0,0,0,0,0,0,0,32869,0,0,26124),
(95390,'The bigger you are, the more there is to hurt!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95391,'We will never yield the wilds!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95392,'Bears don\'t like you! Why protect them?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95393,'Only wanted a little fun. This is... no fun...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95394,'I enjoy watching you squirm. You make a fitting sacrifice.','',0,0,0,0,0,0,0,0,0,0,50937,0,26124),
(95395,'Draenor itself serves the Legion now. See how the elements bend to my will!','',0,0,0,0,0,0,0,0,0,0,50938,0,26124),
(95396,'Cyrukh, what are you doing? Only flesh and blood oppose you!','',0,0,0,0,0,0,0,0,0,0,50939,0,26124),
(95397,'','I see you, $n. What is the plan?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(95398,'You kneel down and hold out a hand. The baby bear runs to you and sniffs at your fingers.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95399,'I\'ll adopt you, little cub.','I\'ll adopt you, little cub.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95400,'Welcome to Ironhorn Enclave.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95401,'Greetings, miner. Do you seek training?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95402,'Open your ears, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95403,'The first ancestor that any of us can remember was Rethu.\n\nRethu Ironhorn was the first of our kind to set hoof on this mountain. He made this plateau his home, and raised his children here. Some say he carved this very camp out of the mountain itself.\n\nHe was a smith, and he was a father, but before any of that... he was a MINER.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95404,'All stories mention his patience, and most refer to his wisdom. He may have been the greatest miner that our people have ever known, but he was not afraid to share his knowledge with the rest of the herd.\n\nHe trained his sons and daughters, of course, but he also took on apprentices. Greenhoofs who sought direction found themselves ascending Highmountain to learn what he had to teach.\n\nEverything we know, we owe to him.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95405,'In his youth, he walked the land. He carved out caves and canyons. He spoke to the rocks. Some stories say that this rock-speech was the reason he was ejected from his original tribe.\n\nHis knowledge of leystone was legendary. His time on Azeroth, much like ours, was also plagued with demons, and he worked with ore much like the felslate that you see nowadays.\n\nHe was a pioneer, $n. We all walk in his long shadow.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95406,'Nobody knows. He left the enclave while they slept, and never returned. Some say he sailed off in search of new challenges. Others say that he dug too deep and uncovered something he should not.\n\nEither way, his legacy lives on, threefold. He left us this land. He left us his knowlege. And he left a lineage - some of us, myself included, bear his surname.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95407,'Tell me your story.','Tell me your story.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95408,'What was he like?','What was he like?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95409,'Tell me about Rethu\'s mining.','Tell me about Rethu\'s mining.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95410,'What happened to Rethu?','What happened to Rethu?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95411,'I see.','I see.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95412,'Taste the steely justice-blows of my blade!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95413,'I say! Know you nothing of honor, dragon?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95414,'Art that the best thou canst do?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95415,'','Destroying this barrier will take a great deal of my strength. I fear I may not be able to aid you after it is broken.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95416,'Dragons! I\'ll slice off your tails, should I find them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95417,'','There are tracks here. Swiftflight must have gone this way!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95419,'Your beloved Swiftflight is dead! You managed to survive the fall, night elf. You will not be so lucky again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95420,'','Hero! Avenge Swiftflight!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95421,'I will crush you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95422,'Stab it until it\'s dead!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95423,'The magic is ours, thief!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95424,'My arrow kill you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95425,'I\'ll poke holes in you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95426,'I make you bleed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95427,'Go away, monster of dreams!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95428,'You dare disrupt our rituals?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95429,'Creature of dreams, begone!','Auughh! Creature of dreams, begone!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95430,'The bear cub sits on your foot and looks up at you trustingly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95431,'Thanks, boss... but two hundred gold? What a rip-off!','Thanks, boss... but two hundred gold? What a rip-off!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95432,'Yeowch! That\'s gonna leave a mark!','Yeowch! That\'s gonna leave a mark!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95433,'','Thank you, hero. I could not have done this alone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95434,'What is this magic?! You\'ll pay for this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95435,'What?! My Power!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95436,'Justice has been laid. Heroic deeds of valor, performed. I must now attend to matters of CHIVALRY!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95437,'A noble hero never forgets what beauty he fights for.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95438,'Know this, my worship: I nearly died this day. But my mortality was not threatened by any dragon-wound.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95439,'NAY! I nearly died, amidst that clanging melee, simply from unsatisfied desire!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95440,'While dragons bled on the ground, my heart bled for thee!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95441,'Wouldst thou consummate our secret love with a smile, or, perhaps, a wave?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95442,'The rustling sounds grow louder. The forest sprites are approaching the cave entrance! Prepare for their attack.$b$bThe baby bear looks helpless and frightened.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95443,'Squires, heroes, and damsels alike! Bring thineselves here, and be protected by me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95444,'You mortals dare stand against the might of the Legion?','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(95445,'Your time has come - and now it shall end.','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(95451,'<The druid speaks softly in his sleep.>$B$BThey will never find my treasure. I have hidden it too well.$B$B<He begins mumbling inaudibly afterwards.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95452,'The center control zone is now active!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95453,'The Alliance captured the center control zone','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95454,'The Horde have captured the center control zone','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95456,'<Gently shake the sleeping druid.>','<Gently shake the sleeping druid.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95457,'','There\'s a war outside. That means lives to save and money to be made, $n!\n\nWhadda ya say to taking my Nitro-Electric Jumpstarter and helping the Bruisers on the front shake it off? Don\'t forget to leave \'em the bill!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95458,'','They\'re not dead yet, $n. That means they\'re potential customers!\n\nIt\'s simple. You take my Nitro-Electric Jumpstarter and use it on some Bruisers who look a bit worse for wear. Then, they pay me! I\'m gonna be rich!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95459,'I\'ll take a Nitro-Electric Jumpstarter, Nurse.','I\'ll take a Nitro-Electric Jumpstarter, Nurse.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95460,'Champions! You must not let them reach the Caverns!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95461,'Still holding out hope Hellscream? Your precious Horde will serve the Legion.','',0,0,0,0,0,0,0,0,0,0,50787,0,26124),
(95462,'Prepare yourselves. My powers can only hold them for so long...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95463,'We... will.. NEVER be slaves!','',0,0,0,0,0,0,0,0,0,0,50805,0,26124),
(95464,'See how they struggle, not even their combined might will be enough to save you.','',0,0,0,0,0,0,0,0,0,0,50788,0,26124),
(95465,'I will have your skull for my helm when I next face your foul legion.','',0,0,0,0,0,0,0,0,0,0,50806,0,26124),
(95466,'No matter, we will crush you all.','',0,0,0,0,0,0,0,0,0,0,50789,0,26124),
(95467,'Heh Heh Heh, they are besting you demon.','',0,0,0,0,0,0,0,0,0,0,50807,0,26124),
(95468,'Finish him heroes, that I may drive that cursed axe down his throat and cut out his fel heart.','',0,0,0,0,0,0,0,0,0,0,50808,0,26124),
(95469,'My thanks to you, now leave me.  I have a trophy to carve.','',0,0,0,0,0,0,0,0,0,0,50809,0,26124),
(95470,'','Even the greatest heroes have tae rest every now and again.',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(95471,'Show me what goods you have for sale.','Show me what goods you have for sale.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95472,'[Outro cinematic of Skyfire flying away in flames, shaking from explosions.]','[Outro cinematic of Skyfire flying away in flames, shaking from explosions.]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95473,'No one will ever think to look behind the dishes.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(95474,'[Outro cinematic of Skyfire flying away in flames, shaking from explosions.]','[Outro cinematic of Skyfire flying away in flames, shaking from explosions.]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95475,'Fools! You have invoked the wrath of the Forsaken!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95476,'Burn! Hahaha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95477,'<The druid continues to mumble in his sleep, occasionally tossing and turning.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95478,'Aspect of Ursol','Aspect of Ursol',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95479,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_ORC_MALE.BLP:40|t[High Overlord Saurfang] Your invasion stops now, demon.','',0,0,0,0,0,0,0,0,0,33545,0,0,26124),
(95480,'|TInterface\\Icons\\spell_shadow_auraofdarkness:20|tYou have |cFFFF0000|Hspell:181099|h[Mark of Doom]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(95481,'|TInterface\\Icons\\ability_ironmaidens_convulsiveshadows:20|tYou are afflicted by |cFFFF0000|Hspell:181799|h[Shadowforce]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(95482,'|TInterface\\Icons\\ability_ironmaidens_convulsiveshadows:20|t%s begins to cast |cFFFF0000|Hspell:182084|h[Empowered Shadowforce]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(95483,'Aspect of Shakama','Aspect of Shakama',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95484,'Aspect of the Moon','Aspect of the Moon',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95485,'','A valorous sacrifice! But it is not yet your time...',0,0,0,0,0,0,0,0,0,0,0,60454,26124),
(95486,'','Keep your eyes on the skies. The infernals could start falling again at any moment.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95487,'','I will place three shards of felslate into your mining arm: one in your shoulder, one in the elbow, and one in the wrist. Small shards, but jagged shards of stone, nonetheless.$b$bThis may hurt a bit.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95488,'','You handled that well enough.$b$bThe next one goes into your elbow. Are you ready?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95489,'','We are nearly done. As is often the case, three is the magic number. You do not want any less felslate in your body... and you CERTAINLY don\'t want any more.$b$bThe final piece goes directly into your wrist. Ready?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95490,'','Understandable. The risk is high... but if you wish to improve your mining skill, there is no other way.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95491,'','Don\'t waste my time then. Go back to mining leystone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95492,'','We\'ve nearly finished the procedure, miner. No point in backing out now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95493,'','We demon hunters toe a dangerous line. Only you can determine where that line lays.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95494,'I am ready. Drive the felslate shard into my shoulder.','I am ready. Drive the felslate shard into my shoulder.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95495,'Actually, I\'m having second thoughts. I don\'t think I want to do this.','Actually, I\'m having second thoughts. I don\'t think I want to do this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95496,'Yes. Hammer the felslate into my elbow.','Yes. Hammer the felslate into my elbow.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95497,'I don\'t want to do this anymore.','I don\'t want to do this anymore.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95498,'Ready. Imbue my wrist with felslate.','Ready. Imbue my wrist with felslate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95499,'This is too much. I\'m not a demon hunter like you - I have no tolerance for such demonic augmentation.','This is too much. I\'m not a demon hunter like you - I have no tolerance for such demonic augmentation.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95500,'This is too risky. I am a demon hunter, Nal\'ryssa... I have already demon\'s blood in my veins. I may lose control.','This is too risky. I am a demon hunter, Nal\'ryssa... I have already demon\'s blood in my veins. I may lose control.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95501,'CLUCK! Threat detected! Extermination commencing.','CLUCK! Threat detected! Extermination commencing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95502,'Hardware overdrive enabled. Frz... gr... malfunction!','Hardware overdrive enabled. Frz... gr... malfunction!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95503,'Engaging. Entity type: Unknown.','Engaging. Entity type: Unknown.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95504,'Ha! This one\'s still got spirit!','',0,0,0,0,0,0,0,0,0,0,61498,0,26124),
(95505,'This one\'s slow! Somebody give me a dagger!','',0,0,0,0,0,0,0,0,0,0,61497,0,26124),
(95506,'You won\'t get rid of me that easily!','',0,0,0,0,0,0,0,0,0,0,61496,0,26124),
(95507,'Come on! You can\'t be that tired!','',0,0,0,0,0,0,0,0,0,0,61495,0,26124),
(95508,'$n prepares a Sugar-Crusted Fish Feast!','$n prepares a Sugar-Crusted Fish Feast!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(95509,'$n prepares a Fancy Darkmoon Feast!','$n prepares a Fancy Darkmoon Feast!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(95510,'Kraw, my cousin, harbors a thirst for power. Now, the tribe follows him into madness.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95511,'An Icebound Dreadnought freezes the gun solid!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95512,'Please find my nephew before he goes mad like the others!','Please find my nephew before he goes mad like the others!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95513,'Rockets, er... transportation systems ready to go!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95514,'Next victim! Ha! Hey, I\'m only kiddin\'...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95515,'No sign of Sylvanas here. We\'ll clean this up - find a way over to the next ship!','No sign of Sylvanas here. We\'ll clean this up - find a way over to the next ship!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95516,'We\'ll take it from here. Keep looking for the Windrunner!','We\'ll take it from here. Keep looking for the Windrunner!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(95517,'I go to my uncle. Thank you, kind stranger!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95518,'|TInterface\\Icons\\ACHIEVEMENT_CHARACTER_NIGHTELF_MALE.BLP:50|tWell done, $n. The druids of the claw are on our side, but our work is not yet finished.','',0,0,0,0,0,0,1,0,0,0,52739,0,26124),
(95519,'<The stone emanates demonic energy. Speak the name of its owner, and she will appear.>','<The stone emanates demonic energy. Speak the name of its owner, and she will appear.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95520,'Rin\'thissa.','Rin\'thissa.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95521,'Lyrelle.','Lyrelle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95522,'Ondri.','Ondri.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95523,'Can I ask your help, stranger?$B$BMy tribe is the Smolderhide. Recently, my brothers found bad magic. They have gone mad with rage. They attack the druids that are our friends.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95524,'Thank you for saving my nephew. Hopefully, we can rebuild our village.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95525,'Parachutes are downstairs, $Gsir:ma\'am;.','Parachutes are downstairs, $Gsir:ma\'am;.',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(95526,'I thank you, $c. If you had not saved me, I would have lost my mind... like the others.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95527,'The legionnaires are deploying from the rear deck. They\'ll be glad to fight alongside you!','The legionnaires are deploying from the rear deck. They\'ll be glad to fight alongside you!',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(95528,'<Deep lacerations cover the arms and face of this druid. Unfortunately, there is nothing more you can do for her.>','<Deep lacerations cover the arms and face of this druid. Unfortunately, there is nothing more you can do for her.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95529,'May you rest in peace. I will inform the Archdruid that you fought bravely to the end.','May you rest in peace. I will inform the Archdruid that you fought bravely to the end.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95530,'I was overwhelmed by the enemy. I was sure that I would die here... but not without a fight!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95531,'Nightmane sent me to find you. Are you wounded?','Nightmane sent me to find you. Are you wounded?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95532,'','Tell Nightmane that I still live, thanks to your aid.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95533,'I\'ll return to safety as soon as I recover my strength. Thank you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95534,'','My sisters are out there somewhere, $p. They\'re more demon than elf now, but they are still miners. Let me know if you see any sign of them in your travels.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95535,'Applying','Applying',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(95536,'Interested in building some ships?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95537,'I would like to build a carrier.','I would like to build a carrier.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95538,'Start construction on our first destroyer.','Start construction on our first destroyer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95539,'I would like to build a submarine.','I would like to build a submarine.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95540,'','Yes?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95541,'Show me what missions you have prepared.','Show me what missions you have prepared.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95542,'','Let me know when you\'re ready to split up.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95543,'Slay these unholy creatures! For the Alliance!','Slay these unholy creatures! For the Alliance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95544,'Watch yourselves - that doesn\'t look like Westfall Stew in those cauldrons...','Watch yourselves - that doesn\'t look like Westfall Stew in those cauldrons...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95545,'Royal guards - this is the Windrunner! Seize the captain!','Royal guards - this is the Windrunner! Seize the captain!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(95546,'|cFFFF0000%s|r is about to finish casting |cFFFF0000|Hspell:181912|h[Focused Blast]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(95547,'','And your ship is already doomed!',0,0,0,0,0,0,0,0,0,0,0,51770,26124),
(95548,'Redeem your darkmoon daggermaw here for fabulous prizes!','Redeem your darkmoon daggermaw here for fabulous prizes!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(95549,'Fishing prizes for all ages!','Fishing prizes for all ages!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(95550,'Try your rod against the crafty darkmoon daggermaw today!','Try your rod against the crafty darkmoon daggermaw today!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(95551,'Fresh-caught prizes right here, only a rod and reel away!','Fresh-caught prizes right here, only a rod and reel away!',0,0,0,0,0,0,70,0,1,0,0,0,26124),
(95552,'Ahh, Val\'sharah...','',0,0,0,0,0,0,1,0,0,0,52735,0,26124),
(95553,'','Wait! She may have information!',0,0,0,0,0,0,5,0,0,0,0,52976,26124),
(95554,'','So many bats...',0,0,0,0,0,0,1,0,0,0,0,52977,26124),
(95555,'Your pathetic efforts have accomplished nothing, mortals! Our citadels anchor Sargeras to this world. Your end is inevitable!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95556,'You were always weak, Iroxus! You will be flayed for millennia for failing Sargeras!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95557,'You dare to resist Sargeras\' will on this pathetic world? I will see to your end myself, mortals!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95558,'Need equipment for your ship?  I\'m your man!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95559,'What kind of naval equipment do you have?','What kind of naval equipment do you have?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95560,'Are you sure you want to buy th\'gear I\'ve got for sale? Slugg over there has all th\' latest and greatest.','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(95561,'I would like to buy outdated equipment from you.','I would like to buy outdated equipment from you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(95562,'Are you sure you want to buy th\'gear I\'ve got for sale? Crunchpaw has th\' best stuff these days.\n\nB\'tween the two of us, I heard she didn\'t get her nickname from fightin\' the Horde.\n\nDon\'t tell her I said that.\n\nActually, I\'d prefer y\'din\'t even mention that we spoke. I\'m not on her good side right now.','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(95563,'Well met.','Well met.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95564,'Legendary: Gul\'dan Ascendant','Legendary: Gul\'dan Ascendant',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95565,'','We will find someone with knowledge of the Pillars of Creation. You have my word.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95566,'','You are welcome to what shelter we can provide, $c.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95567,'You should have stayed home!','',0,0,0,0,0,0,0,0,0,924,53375,0,26124),
(95568,'The master will mend my flesh again and again. You have not won. You cannot win. We are endless! We are Legion!','',0,0,0,0,0,0,0,0,0,924,53376,0,26124),
(95569,'Our transport is ready. The invasion of Tanaan can begin.','',0,0,0,0,0,0,1,0,0,0,50638,0,26124),
(95570,'Durotan - are the Frostwolves prepared?','',0,0,0,0,0,0,6,0,0,0,50640,0,26124),
(95571,'Yes. We will assault the main gate while your ships circle around to the eastern shore.','',0,0,0,0,0,0,1,0,0,0,50350,0,26124),
(95572,'We\'re countin\' on you, commander. Bring victory to da Horde!','',0,0,0,0,0,0,5,0,0,0,50609,0,26124),
(95573,'','Durotan and I have spoken. I will accompany your naval assault and protect you while we establish a foothold in Tanaan Jungle.$b$bI am ready. Are you?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(95574,'Come now. Tell me you\'re at least considering it.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(95575,'Twenty-seven times in the past two hours. The same talk.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95578,'Damn it, Doug, look at me. We can\'t stay here!','',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(95579,'We\'ll hold out if we all do our part. Get back to work.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95580,'','|cFFFF0000%s|r attempts to remove any harmful effects on herself!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95581,'','I have spoken with the other Exarchs and everything is prepared. I will accompany your naval mission and support you while we establish a rear base. Maladaar has volunteered to lead the diversionary assault at the main gate.$b$bI\'m as ready as I\'ll ever be. Are you?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(95582,'Yrel - are your people prepared?','',0,0,0,0,0,0,6,0,0,0,50639,0,26124),
(95583,'','Yes. The draenei will lead an assault on the main gates while your navy circles around to the rear.',0,0,0,0,0,0,1,0,0,0,0,50567,26124),
(95584,'Godspeed, Commander!','',0,0,0,0,0,0,1,0,0,0,51322,0,26124),
(95585,'There\'s a ghost riding a big cat in the ruins.','There\'s a ghost riding a big cat in the ruins.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95586,'','There is an ancient blue dragon just north of here. If anyone will know of the Pillars, it will be him.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95587,'I\'ve been feeling a powerful magical presence in that same direction - it may be the dragon you found. We should investigate at once.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95588,'I got to visit the coffin maker yesterday. Brilliant!','I got to visit the coffin maker yesterday. Brilliant!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95589,'There were lights in the castle last night. Did you see them?','There were lights in the castle last night. Did you see them?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95590,'Have you seen a dead body? I have.','Have you seen a dead body? I have.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95591,'Da caught a two-headed fish a few days ago. It was all purple and oozy.','Da caught a two-headed fish a few days ago. It was all purple and oozy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95592,'Sis won\'t take me night fishing anymore. I never get to do anything fun.','Sis won\'t take me night fishing anymore. I never get to do anything fun.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95593,'','Yes, my liege. The camps are being prepared as we speak.',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(95594,'','You should finish your business with Kayn in the meantime.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95595,'','Our strength is unmatched. These beings have yet to withstand our assaults.',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(95596,'','Our grasp expands over the lands. The knowledge will soon be ours.',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(95597,'','A truly delicate planet. The inhabitants are quite... fragile.',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(95598,'Nathanos\' Rangers launch |TInterface\\Icons\\inv_ammo_arrow_04:20|t |cFFFF0404|Hspell:182466|h[Plague Arrows]|h|r.  Lead Thane Wildsky into them!','Nathanos\' Rangers launch |TInterface\\Icons\\inv_ammo_arrow_04:20|t%s |cFFFF0404|Hspell:182466|h[Plague Arrows]|h|r.  Lead Thane Wildsky into them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95599,'Move out!','',0,0,0,0,0,0,0,0,0,0,50495,0,26124),
(95600,'Charge!','',0,0,0,0,0,0,0,0,0,0,50496,0,26124),
(95601,'Attack!','',0,0,0,0,0,0,0,0,0,0,50497,0,26124),
(95602,'Ow!','',0,0,0,0,0,0,0,0,0,0,50498,0,26124),
(95603,'Reporting for duty!','',0,0,0,0,0,0,0,0,0,0,50499,0,26124),
(95604,'Ready to go!','',0,0,0,0,0,0,0,0,0,0,50500,0,26124),
(95605,'','Move out!',0,0,0,0,0,0,0,0,0,0,0,50825,26124),
(95606,'','Charge!',0,0,0,0,0,0,0,0,0,0,0,50826,26124),
(95607,'','Attack!',0,0,0,0,0,0,0,0,0,0,0,50827,26124),
(95608,'','Ow!',0,0,0,0,0,0,0,0,0,0,0,50828,26124),
(95609,'','Reporting for duty!',0,0,0,0,0,0,0,0,0,0,0,50829,26124),
(95610,'','Ready to go!',0,0,0,0,0,0,0,0,0,0,0,50830,26124),
(95611,'Ahh! Damn you, demon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95612,'Whoever you are, aid me, I beg you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95613,'Over here! Please help me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95614,'In the name of Elune! Save me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95615,'','Main cannons, prepare for a second volley as we breach the cloud-line.',0,0,0,0,0,0,0,0,0,0,0,51762,26124),
(95618,'Ssssmoke won\'t stop me, pitiful creature!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95620,'Old woman doesssn\'t sssssscare me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95623,'Ha! That Granny is blind as a bat!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95624,'Wassss that ssssupposed to hurt?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95625,'%s finishes off its victim, then departs in search of fresh prey.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95626,'I... um... well, this is terribly embarassing, but I\'ve misplaced the Branch of Nordrassil.','I... um... well, this is terribly embarassing, but I\'ve misplaced the Branch of Nordrassil.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95627,'Did that traitor of a prince send you? So be it, I\'ll show no mercy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95628,'What... what have I done?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95629,'%s lunges at new prey.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95630,'|cFFFF0000%s|r begins to cast |cFFFF0000|Hspell:186045|h[Solar Chakram]|h|r at you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(95631,'I will restrain my hand against these civilians. They do not know who I am, and I am in no danger from them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95632,'I must make them heed my words, not my sword. Novices will often resort to force, but persuasion is a master\'s weapon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95633,'|cFFFF0000%s|r is creating an energy well to empower his allies!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95634,'|cFFFF0000%s|r is being drained of energy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95635,'','You\'ve led well so far, $n - I see no reason to change direction now.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95636,'','I\'m off to Dalaran to find paladins worthy of joining our cause. Knights, stay here in case $n needs anything while I\'m gone.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95637,'They should have been here by - ah, there they are.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(95638,'','Elune bless my arrow. Let my aim be true!',0,0,0,0,0,0,0,0,0,0,0,52285,26124),
(95639,'','Invader, this world will not fall to your kind!',0,0,0,0,0,0,0,0,0,0,0,52286,26124),
(95640,'','Interlopers! The kaldorei protect these lands.',0,0,0,0,0,0,0,0,0,0,0,52287,26124),
(95641,'','Countless worlds have you destroyed, but we will not fall so easily.',0,0,0,0,0,0,0,0,0,0,0,52288,26124),
(95642,'','In Azshara\'s name, begone from this place!',0,0,0,0,0,0,0,0,0,0,0,52289,26124),
(95643,'','My blade is sharp, and my arrow, swift. We will not be easy targets.',0,0,0,0,0,0,0,0,0,0,0,52290,26124),
(95644,'Taste steel.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95645,'No obstacle shall stand in our way.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95646,'Bandu thoribas!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95647,'Tor ilisar\'thera\'nal!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95648,'In the master\'s name!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95649,'You shall not live to see another moon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95650,'','Amelia over there has much bett\'r gear than what I can offer yeh if you\'re lookin\' to take on the Horde.',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(95651,'','Y\'should speak with Holly McTilla if you\'re lookin\' to square off against the best the Horde has to offer. Also, ask her who does her hair for me would ya?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(95654,'Lion\'s Watch','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(95655,'Vol\'mar','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(95656,'','Ainderu! What do you make of this cloth?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95657,'Looks like night elf cloth to... wait a moment...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95658,'No... those are ancient Highborne patterns!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95659,'','Fascinating...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95660,'While the Nightfallen look much like I do, they are craven, twisted ley-addicts who will stab you in the back to get a taste of your mana. I am a friendly tailor who has simply fallen on hard times. Note the difference!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95661,'We will not stand idle while the Legion threatens our home. Our blades are yours.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95662,'Come forth, Incindrius! Show these fools the might of the Burning Legion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95663,'','We will always answer the Light\'s call. Let us know where we are needed.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(95664,'This equipment isn\'t as good as what Fobbly Kickfix sells. I suggest you arm yourself with her wares first.','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(95665,'You should speak with Malukah Lightsong if you intend to buy the best equipment available.','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(95666,'','Cladd Dawnstrider is the one you seek if you wish to claim the highest quality rewards for your honor in battle.',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(95667,'','Tae\'lox Soulshrivel is the one you seek if you wish to claim the highest quality rewards for your honor in battle.',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(95668,'','Yeah yeah, I know, my stuff isn\'t as good as what Tae\'lox is sellin\'. But ya know what, it\'s still prettier, right? Whaddaya mean you think it looks the same? It\'s CLEARLY different! You ungrateful bum! You\'re lucky my contract is still being enforced.',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(95669,'The quality of my wares is inferior to those sold by Malukah Lightsong. You should talk to her if you intend to take on the Alliance.','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(95670,'The quality of my equipment is inferior to that of the lovely Malukah Lightsong. Speak wit her if you intend to buy the best equipment available.','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(95671,'I regrettably inform you that the finest arms and armaments for use in the field of battle are now sold by Ms. Crunchpaw. Don\'t worry, I\'m hard at work figuring out how to modify what I do have to be even better. I\'m thinking... extra arms! That you control with your mind!','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(95672,'I would like to build a battleship.','I would like to build a battleship.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95673,'I would like to build a transport.','I would like to build a transport.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95674,'','I can\'t believe that peasant Holly McTilla was trusted with the finest weapons and armor. A dwarf! Honestly, it\'s no wonder we haven\'t taken this island yet.',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(95675,'Woof!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95676,'Rrrrruff!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95677,'%s whines piteously.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95678,'The shipyard is currently full, try back once the current ship completes.','The shipyard is currently full, try back once the current ship completes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95679,'Let us make haste. We must find the Legion before they strike again.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95680,'|c00FFFF00|Hspell:186255|h[Event: Apexis Marks]|h|r begins at the Ashran Excavation in 3 minutes.','',0,0,0,0,0,0,0,0,0,0,43448,0,26124),
(95681,'','We should hurry. The Legion could attack at any moment.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95682,'Please, take your time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95683,'I\'ll just be waiting here patiently to be summoned to Dalaran.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95684,'Try not to forget me, or how helpful I was!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95685,'|c00FFFF00|Hspell:178022|h[Event: Stadium Racing]|h|r has begun at the Amphitheater of Annihilation!','',0,0,0,0,0,0,0,0,0,0,43448,0,26124),
(95686,'|c00FFFF00|Hspell:186255|h[Event: Apexis Marks]|h|r has begun at the Ashran Excavation!','',0,0,0,0,0,0,0,0,0,0,43448,0,26124),
(95687,'|c00FFFF00|Hspell:178019|h[Event: Collect Empowered Ore]|h|r has begun at the Molten Quarry!','',0,0,0,0,0,0,0,0,0,0,43448,0,26124),
(95688,'|c00FFFF00|Hspell:178021|h[Event: Ogre Fires]|h|r has begun at Brute\'s Rise!','',0,0,0,0,0,0,0,0,0,0,43448,0,26124),
(95689,'|c00FFFF00|Hspell:178020|h[Event: Risen Spirits]|h|r has begun at the Ashmaul Burial Grounds!','',0,0,0,0,0,0,0,0,0,0,43448,0,26124),
(95690,'','There\'s no time to waste. Let\'s move!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95691,'I need somebody summoned up to Dalaran. Can you help me?','I need somebody summoned up to Dalaran. Can you help me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95692,'','A summon? Sure! Where did you say he was?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95693,'','Hold on a sec... there! I\'ve got him!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95694,'$n! Such a pleasure to see you again!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(95695,'So... this is Dalaran.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95696,'This is a lovely tailoring shop you have here. Do you mind if I look around?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95697,'','Not at all. Make yourself at home.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95698,'','I\'m sure there is much we can learn from one another.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95699,'Thank you, $n. I need to... acquaint myself with this shop before I can train you any further.','',0,0,0,0,0,0,0,0,0,33121,0,0,26124),
(95700,'','Welcome to Cartier and Company Fine Jewelry, $c. I can tell you\'re a customer with an appreciation for the finer things.$b$bWhat can I show you today?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95701,'Something very expensive, please.','Something very expensive, please.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95702,'I was told you can sharpen these needles for me.','I was told you can sharpen these needles for me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95703,'','Done! Tell Tanithria that she owes me another silk pillow.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95704,'','Easy enough...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95705,'Careful, $n. Cordana has declared Khadgar\'s tower off-limits. She\'s acting odd.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(95706,'We will send Gul\'dan\'s filth to the bottom of the sea!','',0,0,0,0,0,0,1,0,0,20068,50641,0,26124),
(95707,'Farahlon is mysterious land. Only send a crew you trust... or can afford to lose.','',0,0,0,0,0,0,274,0,0,924,50642,0,26124),
(95708,'Aid me, champions! This is not our final hour! We must survive!','',0,0,0,0,0,0,0,0,0,0,50665,0,26124),
(95709,'Never! This world will stand against the legion and prevail!','',0,0,0,0,0,0,0,0,0,0,50666,0,26124),
(95710,'The citadel is breached! Gul\'dan is within. I will establish a foothold here - press forward!','',0,0,0,0,0,0,0,0,0,0,50667,0,26124),
(95711,'We will plumb the depths of Draenor for all its secrets!','',0,0,0,0,0,0,1,0,0,924,50643,0,26124),
(95712,'I never believed Gul\'dan would go this far... We must press on. A portal lies within these ruins that will take us further into the citadel.','',0,0,0,0,0,0,0,0,0,0,50668,0,26124),
(95713,'The portal is ready, champion. Steel yourselves, I know not what further atrocities Gul\'dan has unleashed in this place.','',0,0,0,0,0,0,0,0,0,0,50669,0,26124),
(95714,'This entire citadel seethes with Gul\'dan\'s corruption! A second portal is nearby. Keep his demons at bay while I break the seals and attune the portal to his location.','',0,0,0,0,0,0,0,0,0,0,50670,0,26124),
(95715,'I\'ve breached the first seal, soon the portal will take us to Gul\'dan.','',0,0,0,0,0,0,0,0,0,0,50671,0,26124),
(95716,'Give Cordana my best. She\'s been quite distant lately.','',0,0,0,0,0,0,6,0,0,924,50644,0,26124),
(95717,'Another seal is open! Oh, I am good.','',0,0,0,0,0,0,0,0,0,0,50672,0,26124),
(95718,'The portal is nearly complete, the next seal has been removed.','',0,0,0,0,0,0,0,0,0,0,50673,0,26124),
(95719,'The final seal has fallen! My work here is almost finished.','',0,0,0,0,0,0,0,0,0,0,50674,0,26124),
(95720,'The portal is unlocked! It will take us directly to Gul\'dan. Now he will pay for his crimes.','',0,0,0,0,0,0,0,0,0,0,50675,0,26124),
(95721,'Gul\'dan has fled to the Dark Portal! Quickly, champions! He has no place left to run - we will finish this!','',0,0,0,0,0,0,0,0,0,0,50676,0,26124),
(95722,'And save me his skull. For... reasons.','',0,0,0,0,0,0,0,0,0,0,50677,0,26124),
(95723,'','Books. Yes, Gul\'dan\'s tomes. Are you sure Khadgar didn\'t try to use them?',0,0,0,0,0,0,6,0,0,0,0,50318,26124),
(95724,'','Books of power... books of knowledge... books written in the language of chaos... Don\'t you worry, champion, all will be destroyed.',0,0,0,0,0,0,0,0,0,0,0,50319,26124),
(95725,'','Now, give me your ring. I need it. Give it here!',0,0,0,0,0,0,5,0,0,0,0,50320,26124),
(95726,'That\'ll do for now. I think I\'d like to... explore your city some more.','',0,0,0,0,0,0,0,0,0,33126,0,0,26124),
(95727,'','Then I will TAKE it from you! For the Glory of Gul\'dan!',0,0,0,0,0,0,5,0,0,0,0,50321,26124),
(95728,'','The Orb of Dominion spoke to me. I saw the TRUTH.',0,0,0,0,0,0,0,0,0,0,0,50322,26124),
(95729,'','Khadgar is just a child, swaggering around, torturing his prisoners, playing with lives, dabbling in magics he pretends to comprehend.',0,0,0,0,0,0,0,0,0,0,0,50323,26124),
(95730,'','Such is the power of the Legion!',0,0,0,0,0,0,0,0,0,0,0,50324,26124),
(95731,'','Very well, walk away. Nothing will stop Gul\'dan, for the Legion stands behind him. Mark my words: Your leaders will betray you. AZEROTH WILL BURN.',0,0,0,0,0,0,5,0,0,0,0,50325,26124),
(95732,'The Burning Legion comes!','',0,0,0,0,0,0,0,0,0,0,50328,0,26124),
(95733,'Go now to Karabor, champion of the Alliance!','',0,0,0,0,0,0,25,0,0,924,50645,0,26124),
(95734,'You face the might of the Burning Legion!','',0,0,0,0,0,0,0,0,0,0,50326,0,26124),
(95735,'The elemental spirits of Draenor await you, champion of the Horde!','',0,0,0,0,0,0,25,0,0,923,50646,0,26124),
(95736,'Burn!','',0,0,0,0,0,0,0,0,0,0,50331,0,26124),
(95737,'Your life ends now!','',0,0,0,0,0,0,0,0,0,0,50332,0,26124),
(95738,'Suffer my wrath!','',0,0,0,0,0,0,0,0,0,0,50333,0,26124),
(95739,'My power grows!','',0,0,0,0,0,0,0,0,0,0,50334,0,26124),
(95740,'Feel the legion\'s power!','',0,0,0,0,0,0,0,0,0,0,50335,0,26124),
(95741,'All life will be eradicated!','',0,0,0,0,0,0,0,0,0,0,50329,0,26124),
(95742,'Pathetic wretch!','',0,0,0,0,0,0,0,0,0,0,50330,0,26124),
(95743,'Oblivion... comes...','',0,0,0,0,0,0,0,0,0,0,50327,0,26124),
(95744,'','Welcome, commander! Khadgar tells me you\'ve accomplished so many great things...',0,0,0,0,0,0,1,0,4,0,0,50572,26124),
(95745,'','Take your knee, champion. It is a rare and special privilege to be blessed by a Naaru.',0,0,0,0,0,0,2,0,4,0,0,50573,26124),
(95746,'Blessed are the torchbearers, who bring the light to darkness.','',0,0,0,0,0,0,0,0,4,0,50288,0,26124),
(95747,'Blessed are the valorous, who stand fast in an unjust world.','',0,0,0,0,0,0,0,0,4,0,50289,0,26124),
(95748,'Champion. A great darkness has taken root on Draenor.','',0,0,0,0,0,0,0,0,4,0,50290,0,26124),
(95749,'The righteous will flock to your banner. You must not falter.','',0,0,0,0,0,0,0,0,4,0,50291,0,26124),
(95750,'Go now, with the Light\'s blessing. Take the fight to our enemies.','',0,0,0,0,0,0,0,0,4,0,50292,0,26124),
(95751,'The fate of two worlds hangs in the balance...','',0,0,0,0,0,0,0,0,4,0,50293,0,26124),
(95752,'','Did you hear anything? Did the Naaru speak to you?',0,0,0,0,0,0,6,0,4,0,0,50574,26124),
(95753,'','Commander, whatever you should do next, know that you have the full support of the draenei people.',0,0,0,0,0,0,1,0,4,0,0,50575,26124),
(95754,'','We stand with you!',0,0,0,0,0,0,2,0,4,0,0,50576,26124),
(95755,'Commander, is that you? Your aura has grown quite strong.','',0,0,0,0,0,0,6,0,4,0,50297,0,26124),
(95756,'The very elements of Draenor tremble, friend. Can you hear them? Listen... listen...','',0,0,0,0,0,0,1,0,4,0,50298,0,26124),
(95757,'Spirits of stone, lend your strength to our champion.','',0,0,0,0,0,0,0,0,4,0,50299,0,26124),
(95758,'Spirits of air, grant our champion quickness of mind and body.','',0,0,0,0,0,0,0,0,4,0,50300,0,26124),
(95759,'Spirits of water, give our hero the gift of your wisdom.','',0,0,0,0,0,0,0,0,4,0,50301,0,26124),
(95760,'Spirits of flame, lend us your fury, that our enemies will be driven before us!','',0,0,0,0,0,0,0,0,4,0,50302,0,26124),
(95761,'Arise, champion. Know that the primal heart of Draenor burns within you.','',0,0,0,0,0,0,5,0,4,0,50303,0,26124),
(95762,'Gul\'dan will do all he can to sever our connection to the elements, to deprive us on their power. You must stop him.','',0,0,0,0,0,0,1,0,4,0,50304,0,26124),
(95763,'The fate of our world is in your hands, commander. Lok\'tar ogar.','',0,0,0,0,0,0,2,0,4,0,50305,0,26124),
(95764,'With every passing moment, Gul\'dan grows in power. But he no longer slinks through the shadows - we know where he is. We know what he\'s doing. Now, we strike! May the Light have mercy on all our souls.','',0,0,0,0,0,0,1,0,0,924,50647,0,26124),
(95765,'Did you think to challenge me, infant? A poor decision.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95766,'','Gryphon riders, back them up!',0,0,0,0,0,0,0,0,0,0,0,52958,26124),
(95767,'','Hero! <cough> Get those chemical flares away from the ammo!',0,0,0,0,0,0,0,0,0,0,0,52956,26124),
(95768,'Accept your death. It is bitter, but preferable to what is coming.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95769,'The last hero to oppose me lies dead at my feet. Join her.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95770,'You encroach upon our lands. For that, you shall pay dearly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95771,'Mother Moon, have mercy. Let me rest now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95772,'You have... won this fight, and yet I... almost pity you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95773,'Those damned leyweavers had no right to throw me out. No right at all, I say.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95774,'Lyndras, what are you doing here?','Lyndras, what are you doing here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95775,'My lord will hear of this and know... you are... no mere nuisance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95776,'I welcome the darkness. I have always... loved... the night.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95777,'The Ashbringer glows brightly and protects you with |cFFFF0000|Hspell:642|h[Divine Shield]|h|r!','The Ashbringer glows brightly and protects you with |cFFFF0000|Hspell:642|h[Divine Shield]|h|r!',0,0,0,0,0,0,0,0,0,34050,0,0,26124),
(95778,'Err... I was just uh... looking for new dyes. Yes, that\'s it. New dyes. I\'ll return to the shop immediately.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95779,'Destiny calls to you, $n.','',0,0,0,0,0,0,0,0,0,0,52473,0,26124),
(95784,'I swear, I\'m staying put. No more exploring the city for me. I\'m happy right here in the tailoring shop.','',0,0,0,0,0,0,0,0,0,33133,0,0,26124),
(95785,'I had thought $p dead in the explosion, but $Ghe:she; survived and slew the demon! Never in all my days have I - there you are! I was just telling your men about your fight with Malgalor.','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(95786,'Lyndras, please, stop! Get a hold of yourself, man!','Lyndras, please, stop! Get a hold of yourself, man!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95787,'Prove to me that you are worthy of this power! Free my brethren from their ghostly imprisonment, then come to me with their mark upon you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95788,'...What are you doing with the Orb of Dominion, Cordana?','...What are you doing with the Orb of Dominion, Cordana?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95789,'Khadgar wants you to destroy these books.','Khadgar wants you to destroy these books.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95790,'','Nothing.$b$bNothing that concerns you.$b$bI have this under control.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(95791,'A squire from the Argent Crusade? Here?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(95796,'','Yes, your ring. THE ring! The one Khadgar has been cooking up for you since we arrived on Draenor.$b$bGive it here. I just want to... borrow it.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(95797,'No.','No.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95798,'Oh, HELL no!','Oh, HELL no!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95799,'Destroy the Tomes of Chaos to break Cordana\'s shield','Destroy the Tomes of Chaos to break Cordana\'s shield',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95803,'','Father, please! Stranger, forgive us. We\'re all a tad wary of strangers these days.',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(95804,'','Thorns are a means of defense for green and growing things: fragile flora that would otherwise be defenseless.$B$BDo not curse the thorns. Rejoice in the blossoms they make possible.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95805,'','When our hearts falter, we cease to respect the world around us.$B$BNature holds a mirror to our souls.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95806,'Your bones will join the others!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95807,'Share in our curse!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95808,'You\'ll never defeat Bloodbeard!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95831,'We are in luck. Had the Underking learned all of the secrets of the Hammer, we would not be having this conversation.$b$bFor now he is like a child with a new toy. Dangerous, yes, but not as much as he will be the longer he possesses the hammer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95836,'Dig faster! We must bury this giant before the other challengers arrive.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95853,'','As with Moonglade, this village and its denizens are under my protection. I only wish I could shelter more of the wilds and its caretakers.$B$BWould that I were strong enough to protect you all.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95854,'','I have never seen these sprites so agitated.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95855,'What can you tell me about these Thistleleaf sprites?','What can you tell me about these Thistleleaf sprites?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95857,'May Odyn bless you on your trials.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95858,'','You may take your rest here without fear of nightmares.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95859,'','The Thistleleaf have always been a minor nuisance. However, lately their behavior has changed from puerile to hostile and destructive.$B$BI do not know what has caused this change, but something must be done to protect these faerie dragons.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95860,'Odyn? I kneel before no god.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95861,'I will do what I can.','I will do what I can.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95862,'Awww man not again.','Awww man not again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95863,'','Commander, reinforcements are arriving daily. Use this portal to travel between here and our stronghold in Ashran.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95864,'Stay out of Violet Hold if you know what\'s good for you, $r. I don\'t like the look of some of the creatures they\'re storing in there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95865,'Have you seen Lyndras?','Have you seen Lyndras?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95866,'Is he that Nightfallen rat? We caught him snooping around the edges of town. Looked suspicious. He\'s been thrown into Violet Hold for questioning.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95867,'Once I have the Aegis of Aggramar -- the gods will kneel to me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95868,'We Elderbranch know little of lands beyond our own.$B$BYou are good to have come here to help us, so far from your home.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95869,'','Now my warriors! The Halls of Valor are moments away!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95871,'Your lines are weak, mortals. Our ranks are endless! Lay down your arms and serve Sargeras!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95872,'There is no honor in death! Your cities will burn. Your armies will break. It is inevitable!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95873,'Into the breach! Show these weaklings what the might of Sargeras does when brought to bear on an enemy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95874,'','Go on and run, I won\'t cower under a tent! If the next shot has my name on it, so be it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95875,'','I know your purpose, Banshee Queen! You should turn away, lest you invoke my wrath!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95878,'','Refuse, and I will take your gifts by force!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95879,'[Intro cinematic of Skyfire unloading a volley on the fleet from above the clouds.]','[Intro cinematic of Skyfire unloading a volley on the fleet from above the clouds.]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95880,'','Foolish girl! You cannot comprehend the forces you meddle with.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95881,'','You will fall to your own arrogance. As did the one who created you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95882,'You have foolishly rushed to your end. The Black Gate is whole!','',0,0,0,0,0,0,0,0,0,0,50944,0,26124),
(95883,'Behold the might of the legion!','',0,0,0,0,0,0,0,0,0,0,50945,0,26124),
(95884,'Yes, master.','',0,0,0,0,0,0,0,0,0,0,50946,0,26124),
(95889,'','We will seize the Aegis in time - we must not miss this opportunity to take out Sylvanas!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95890,'Gilneas demands justice!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95891,'','Sylvanas will pay for her crimes...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95892,'Sound design is the best!','Sound design is the best!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95893,'Any luck contacting the fleet?','',0,0,0,0,0,0,6,0,0,0,52940,0,26124),
(95894,'It\'s no use - the weather systems around Stormheim are too strong. I can\'t get a signal through.','',0,0,0,0,0,0,22,0,0,0,51759,0,26124),
(95895,'','It is an honor to fight alongside you, $n. From the moment I first encountered you inside that horrible tunnel behind the Dark Portal, your presence has always inspired me.$b$bK\'ara, too, sees your inner strength. Are you ready to speak with the Naaru?',1,2,6,0,0,0,0,0,0,0,0,0,26124),
(95896,'I am ready, Yrel.','I am ready, Yrel.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95897,'','You aren\'t supposed to be up here, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95898,'','The others were speaking of |5$r $c that knew how to sew. I assume that you are that $c.$b$bIf Tytallo thinks you\'re ready, then I can show you the Queen\'s Grace Loom.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95899,'','Greetings, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95900,'','Wh- what is this power?! It.. can\'t be...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95901,'Tell me about the loom.','Tell me about the loom.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95902,'','The loom itself, frankly, isn\'t anything special.$b$bIt\'s a thing of beauty, to be sure. It\'s quite old, but at its core it\'s nothing but alderwood and a few nails. We do our best to maintain it.$b$bBut no, the loom itself is immaterial to our methods.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95903,'','How attentive of you. Yes, our order has made a bargain with a higher power, in order to gain more skill in our trade.$b$bI am prepared to show you our secret. Behold, the power of the Leyweavers!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95904,'Tytallo mentioned something about sacrifice.','Tytallo mentioned something about sacrifice.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95905,'Show me your secret.','Show me your secret.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95906,'','I am nothing like him! Behold!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(95907,'Work quickly! No relic is to fall into mortal hands!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95908,'Wrest this world\'s secrets from the earth! The Legion will have every drop of power this place has to offer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95909,'','A gift from your sister, Helya. Now... kneel!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95910,'Let\'s go for a joyride!','',0,0,0,0,0,0,0,0,0,0,61489,0,26124),
(95917,'You cursed beasts! After I return to the skies I will have your pathetic races obliterated!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95918,'Lord Iskar... I\'ve failed you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95919,'','We\'ve come to an arrangement with Gul\'dan. We provide him and his forces with supplies, and in return, he\'s granted us a few of his more capable inquisitors.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95920,'','Of course, I\'d prefer that the leyweavers operate without anyone\'s assistance, but the quality of this demonically-imbued cloth far surpasses anything we could do on our own.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95921,'','We\'re tailors, $n, and so are you. No price is too high if it means a better robe. Am I right?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95922,'|TInterface\\Icons\\Spell_DeathKnight_AntiMagicZone:20|tA nearby Dreadstalker begins to cast |cFFF00000|Hspell:186562|h[Consume Magic]|h|r!','|TInterface\\Icons\\Spell_DeathKnight_AntiMagicZone:20|tA nearby Dreadstalker begins to cast |cFFF00000|Hspell:186562|h[Consume Magic]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(95923,'I have shown you how to make Imbued Silkweave, and I\'ve also given you the pattern for Imbued Silkweave Bracers.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95924,'Inondra and I can help, but we cannot teach you all the patterns you need. You will need to earn or purchase them from others.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95925,'','There are many other leyweavers out wandering the world. I can show you where they are.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95926,'MY SHINY EYE! MINE! MINE! MINE! MINE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95927,'','What is it you need?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95928,'','Be careful out there!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(95929,'Where can I learn how to make an Imbued Silkweave Robe?','Where can I learn how to make an Imbued Silkweave Robe?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95930,'Where can I learn how to make an Imbued Silkweave Hood?','Where can I learn how to make an Imbued Silkweave Hood?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95931,'Where can I learn how to make an Imbued Silkweave Cinch?','Where can I learn how to make an Imbued Silkweave Cinch?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95932,'Where can I learn how to make Imbued Silkweave Slippers?','Where can I learn how to make Imbued Silkweave Slippers?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95933,'Where can I learn how to make Imbued Silkweave Gloves?','Where can I learn how to make Imbued Silkweave Gloves?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95934,'Where can I learn how to make Imbued Silkweave Pantaloons?','Where can I learn how to make Imbued Silkweave Pantaloons?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95935,'Where can I learn how to make Imbued Silkweave Epaulets?','Where can I learn how to make Imbued Silkweave Epaulets?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95936,'Where can I learn how to make Imbued Silkweave cloaks?','Where can I learn how to make Imbued Silkweave cloaks?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95937,'','Leyweaver Mithrogane, just outside this hall, knows that pattern.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95938,'','You should speak with Leyweaver Jorjana, in southern Suramar within the Docks District. I\'ll mark her position on your map.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95939,'','Leyweaver Erenyi. She\'s currently out researching druidic patterns in Val\'sharah. I\'ll mark her position on your map.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95940,'','Speak with Leyweaver Yaphisteia. She walks the roads of Highmountain. I\'ll mark her position on your map.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95941,'','I believe Leyweaver Athystro knows that pattern. You\'ll find him just west of here overlooking Felsoul Hold. I\'ll mark his position on your map.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95942,'','Leyweaver Tellumi, who is currently traveling in Stormheim, maintains that pattern for our guild. I\'ll mark her position on your map.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95943,'','Shoulder armor is the domain of Leyweaver Phaxondus. He prefers to spend his time near the exposed ley lines of Azsuna. I\'ll mark his position on your map.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95944,'','You are in luck. I can teach you those patterns myself.$b$bThey will come at a cost. Our clients are demanding, and our shop consumes a great amount of raw materials.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95945,'OK, how much?','OK, how much?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95946,'','Someday I hope to see this \"Azeroth\" of yours. What an amazing world it must be.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(95947,'You are of no interest to me. I come from an accomplished lineage of Suramar tailors. You, obviously, do not.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95948,'How fortuitous! A fellow tailor!$b$bWelcome to the leyweavers\' guild of Suramar. Perhaps you have heard of us?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95949,'Hello, leyweaver. What can I do for you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95950,'|TInterface\\Icons\\spell_fire_ragnaros_lavaboltgreen.blp:20|t %s has marked you for |cFFF00000|Hspell:182108|h[Artillery]|h|r!','|TInterface\\Icons\\spell_fire_ragnaros_lavaboltgreen.blp:20|t %s has marked you for |cFFF00000|Hspell:182108|h[Artillery]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(95951,'In-Game Cutscene','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(95952,'Stupid dragon! That\'ll cost you.','',0,0,0,0,0,0,0,0,0,0,61484,0,26124),
(95953,'I... will... return...','',0,0,0,0,0,0,0,0,0,924,53377,0,26124),
(95954,'','Is everyone alright?',0,0,0,0,0,0,6,0,0,924,0,53378,26124),
(95955,'Singed, but alive. We lost many good troops.','',0,0,0,0,0,0,1,0,0,924,53379,0,26124),
(95956,'','Steady! Hold this line or Menethil will fall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95957,'','The front lines are broken! Hold fast, I\'m sure reinforcements are coming!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95958,'','We\'ll have to mourn them later, we need to move before more demons arrive.',0,0,0,0,0,0,396,0,0,924,0,53380,26124),
(95959,'Agreed.','',0,0,0,0,0,0,1,0,0,924,53381,0,26124),
(95960,'Varian\'s forces should have landed just around this hill, let\'s hope they had more luck.','',0,0,0,0,0,0,396,0,0,924,53382,0,26124),
(95961,'','I\'ve never seen the demons expand this quickly.',0,0,0,0,0,0,396,0,0,924,0,53383,26124),
(95962,'Neither have I. Something has changed, this isn\'t the same legion we\'ve fought before.','',0,0,0,0,0,0,396,0,0,924,53384,0,26124),
(95963,'How... quaint.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95964,'Simple, but it has an antique charm to it.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95965,'Hey, watch this!','',0,0,0,0,0,0,0,0,0,0,61488,0,26124),
(95966,'I do like a plunging neckline.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95967,'Your hemming is impressive. This pattern, though... I could take it or leave it.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95968,'This should be fun!','',0,0,0,0,0,0,0,0,0,0,61487,0,26124),
(95969,'I really enjoy this pattern, $n. It has a classic feel to it, but the embroidery is so intriguing and unique.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95970,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ICONS\\ACHIEVEMENT_BOSS_ILLIDAN.blp:40|t$bYou are the most loyal of all the Illidari. You will be my eyes until this matter is finished.','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ICONS\\ACHIEVEMENT_BOSS_ILLIDAN.blp:40|t$bYou are the most loyal of all the Illidari. You will be my eyes until this matter is finished.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95971,'Let\'s try to catch the wind!','',0,0,0,0,0,0,0,0,0,0,61486,0,26124),
(95972,'Faster! Faster!','',0,0,0,0,0,0,0,0,0,0,61485,0,26124),
(95973,'You\'ll pay for that, dragon!','',0,0,0,0,0,0,0,0,0,0,61483,0,26124),
(95974,'','Oh no...',0,0,0,0,0,0,0,0,6,924,0,53385,26124),
(95975,'Crash landing!','',0,0,0,0,0,0,0,0,0,0,61482,0,26124),
(95976,'There, there, Feronas. The Warglaives of Kil\'Jaeden were created to destroy demons. You never stood a chance.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(95977,'You are but the first to die. The rest your brethren will soon follow. I, Varedis Felsoul, will be your end.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(95978,'Feel my wrath!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95979,'','Greetings, traveler. Our glade has seen more peaceful times, but the Druids of the Claw offer what protection we can.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95980,'This isn\'t possible. There are so many of them.','',0,0,0,0,0,0,0,0,6,924,53386,0,26124),
(95981,'','The streets of Dalaran are perfectly safe, I assure you. It is hardly surprising that someone might attack one of these... things.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(95982,'Ohh! That had to hurt!','',0,0,0,0,0,0,0,0,0,0,61494,0,26124),
(95983,'What a throw!','',0,0,0,0,0,0,0,0,0,0,61490,0,26124),
(95984,'You can\'t escape me!','',0,0,0,0,0,0,0,0,0,0,61492,0,26124),
(95990,'For the Legion!','For the Legion!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(95992,'Your bones will break under my boot, $r!','Your bones will break under my boot, $r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(95993,'Demon! Test your might upon me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(95994,'Long live the Legion! Die you worthless $r!','Long live the Legion! Die you worthless $r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(95996,'Not so mighty now, are we?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96000,'It is time to put an end to Varedis. I have arranged for a felbat to meet you at Krasus\' Landing to bring you to Felsoul Hold.','It is time to put an end to Varedis. I have arranged for a felbat to meet you at Krasus\' Landing to bring you to Felsoul Hold.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96002,'You are too late! The master\'s plan is already in motion.','',0,0,0,0,0,0,0,0,0,0,52251,0,26124),
(96004,'Yes, yes! I will feed upon your fear, and twist it into a living nightmare!','',0,0,0,0,0,0,0,0,0,0,52252,0,26124),
(96010,'My eyes... My eyes!','',0,0,0,0,0,0,0,0,0,0,55223,0,26124),
(96011,'Hold fast, Alliance! We will not fall this day! Push them back to the portal!','',0,0,0,0,0,0,0,0,6,924,53387,0,26124),
(96012,'Return Mannoroth... Yes, yes! Your masters call you to this world once more!','',0,0,0,0,0,0,0,0,0,0,50948,0,26124),
(96013,'Wha- What is this? Gul\'dan what have you done? I am... So weak...','',0,0,0,0,0,0,0,0,0,0,50459,0,26124),
(96014,'Fear the Legion\'s might!','',0,0,0,0,0,0,0,0,0,0,50482,0,26124),
(96015,'Fear not, Mannoroth. The fel gift empowers you... Make them suffer!','',0,0,0,0,0,0,0,0,0,0,50949,0,26124),
(96016,'My power returns! I am unleashed!','',0,0,0,0,0,0,0,0,0,0,50460,0,26124),
(96017,'Begone!','',0,0,0,0,0,0,0,0,0,0,50483,0,26124),
(96018,'These mortals cannot be this strong. Gul\'dan, do something!','',0,0,0,0,0,0,0,0,0,0,50461,0,26124),
(96019,'Let the power flow through you. You are the destructor, the flayer of flesh!','',0,0,0,0,0,0,0,0,0,0,50950,0,26124),
(96020,'I... AM... UNSTOPPABLE...','',0,0,0,0,0,0,0,0,0,0,50462,0,26124),
(96022,'Faithless fools. The Legion wills it; it will be done.','',0,0,0,0,0,0,0,0,0,0,50947,0,26124),
(96023,'Tremble before the Legion\'s might!','',0,0,0,0,0,0,0,0,0,0,50484,0,26124),
(96024,'You dare challenge the Legion?','',0,0,0,0,0,0,0,0,0,0,50453,0,26124),
(96025,'I will not fall again.','',0,0,0,0,0,0,0,0,0,0,50454,0,26124),
(96026,'Die, mongrels.','',0,0,0,0,0,0,0,0,0,0,50486,0,26124),
(96027,'Die, mongrels.','',0,0,0,0,0,0,0,0,0,0,50485,0,26124),
(96028,'Die, mongrels.','',0,0,0,0,0,0,0,0,0,0,50487,0,26124),
(96029,'Fall to your knees!','',0,0,0,0,0,0,0,0,0,0,50488,0,26124),
(96030,'Fall to your knees!','',0,0,0,0,0,0,0,0,0,0,50489,0,26124),
(96031,'The molten hand of the master will scourge this world clean!','',0,0,0,0,0,0,0,0,0,0,50490,0,26124),
(96032,'The Legion will burn this world, as it has countless others!','',0,0,0,0,0,0,0,0,0,0,50491,0,26124),
(96033,'Your flesh will burn.','',0,0,0,0,0,0,0,0,0,0,50492,0,26124),
(96034,'Your end has come.','',0,0,0,0,0,0,0,0,0,0,50493,0,26124),
(96035,'A worthy effort... but futile.','',0,0,0,0,0,0,0,0,0,0,50474,0,26124),
(96036,'A worthy effort... but futile.','',0,0,0,0,0,0,0,0,0,0,50473,0,26124),
(96037,'A worthy effort... but futile.','',0,0,0,0,0,0,0,0,0,0,50475,0,26124),
(96038,'Squirm... Scream!','',0,0,0,0,0,0,0,0,0,0,50477,0,26124),
(96039,'Squirm... Scream!','',0,0,0,0,0,0,0,0,0,0,50476,0,26124),
(96040,'Squirm... Scream!','',0,0,0,0,0,0,0,0,0,0,50478,0,26124),
(96041,'I am the destructor!','',0,0,0,0,0,0,0,0,0,0,50480,0,26124),
(96042,'I am the destructor!','',0,0,0,0,0,0,0,0,0,0,50479,0,26124),
(96043,'I am the destructor!','',0,0,0,0,0,0,0,0,0,0,50481,0,26124),
(96044,'The Legion will find you... No matter where you flee...','',0,0,0,0,0,0,0,0,0,0,50458,0,26124),
(96045,'None can oppose us!','',0,0,0,0,0,0,0,0,0,0,50456,0,26124),
(96046,'None can oppose us!','',0,0,0,0,0,0,0,0,0,0,50455,0,26124),
(96047,'Your end has come.','',0,0,0,0,0,0,0,0,0,0,50494,0,26124),
(96049,'','Varian!',0,0,0,0,0,0,5,0,0,924,0,53388,26124),
(96050,'Interested in building some ships?','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(96051,'','Here, try this pattern out. And use my materials! You\'ll find them lying around the shop.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96052,'','Now that you\'ve gathered the required materials, finish the pattern on my finishing table.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96053,'','What\'s that? What\'s happening with your thread? Why is the robe SMOKING?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96054,'','What a disaster. Look, the thread is just falling right out of the fabric. I\'ve never seen anything like this before.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96055,'','Ready yourself, hero. The creature descends!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96056,'','We did it! The pygmy owls of this grove are safe thanks to you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96057,'<Ga\'nar\'s spirit - so angry and ferocious in life - has at last found peace. He speaks to you with warmth.>$b$bGive \'em hell, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96058,'We owe you everything! Surely that last push would have forced us underwater.','',1,0,0,15,0,0,0,0,0,0,0,0,26124),
(96059,'These chests are full of supplies. You look like you might put them to better use than we will.','',1,0,0,15,0,0,0,0,0,0,0,0,26124),
(96060,'Help! We\'re going to be pushed back into the sea!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96061,'Oh thank the Light! We\'ve been holed up here, cut off from Menethil!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96062,'Here they come again! Steel yourselves! Help us fend them off!','',397,0,0,200,0,0,0,0,0,0,0,0,26124),
(96063,'No... Not again!','No... Not again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96064,'They never stop... there are so many of them!','They never stop... there are so many of them!',397,0,0,200,0,0,0,0,0,0,0,0,26124),
(96068,'Commander. It IS you. Word of your deeds has traveled far and wide. Even the very winds whisper your name.$b$bCome. It is time. As the defender of this world, it is only fitting that Draenor\'s elements bestow their power upon you. Are you ready?','',1,25,6,0,0,0,0,0,0,0,0,0,26124),
(96069,'<Drek\'Thar bows deeply.>$b$bChampion, remember. Those who live with regrets are slaves to the past. Those who live with hope are ready for the future.','',2,1,0,0,0,0,0,0,0,0,0,0,26124),
(96070,'I am ready, Farseer.','I am ready, Farseer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96071,'They are here. Hurry! Gul\'dan demands we finish this...','They are here. Hurry! Gul\'dan demands we finish this...',0,0,0,0,0,0,0,0,0,0,50352,50352,26124),
(96072,'Take me to the Tanaan Jungle.','Take me to the Tanaan Jungle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96073,'Varedis is well guarded. We need to take out the wards projecting that barrier.','',0,0,0,0,0,0,0,0,0,0,52007,0,26124),
(96074,'You\'ve been spotted. Push forward! Quickly!','',0,0,0,0,0,0,0,0,0,0,52012,0,26124),
(96075,'There\'s no time to land. You must dive headlong into the fray. Go!','',0,0,0,0,0,0,0,0,0,0,52716,0,26124),
(96076,'The Aegis of Aggramar belongs to me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96077,'You dare disturb me, weaklings? Your feeble minds cannot fathom the power of the Legion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96078,'Not... possible...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96079,'You challenge me? I\'ll crush you like a bug!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96080,'I will kill... you... ack!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96081,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96082,'You are not the only one seeking the Aegis. I suggest you hurry.','',0,0,0,0,0,0,0,0,0,0,53056,0,26124),
(96083,'','It\'s no use, the ammunition has caught fire! Quickly, up the stairs!',0,0,0,0,0,0,5,0,0,0,0,51768,26124),
(96084,'Allow me to dispose of them, master.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96085,'','There are demon hunters on my world, doom commander. This is unacceptable.',0,0,0,0,0,0,0,0,6,0,0,55070,26124),
(96086,'Defeat the other challengers and I will consider you for the trials.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96087,'Bring me the remains of my fallen brother and I will allow you to enter the vault.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96088,'Odyn, give me strength to do thy bidding.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96089,'','My spiders will feast upon your marrow.',0,0,0,0,0,0,0,0,0,0,0,55023,26124),
(96090,'|TInterface\\Icons\\achievement_character_human_female.blp:40|tLining up the shot...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96091,'Ha ha ha... You fight with purpose. That worthless orc would never be accepted among our ranks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96092,'You are too late. Soon the Halls of Valor will belong to the Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96093,'I\'m going to enjoy ridding our new home of your kind.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96094,'|TInterface\\Icons\\achievement_character_human_female.blp:40|tThis one\'s for Gilneas!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96095,'|TInterface\\Icons\\achievement_character_human_female.blp:40|tTaking him down...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96096,'Ahh... much better. Odyn has a plan for you, my friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96097,'Meet me inside the vault. Your trials are about to begin.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96098,'Get a move on it! I can\'t hold this forever.','Act quickly! This will only hold for a short time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96099,'Your first trial begins now. Defend yourself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96100,'I submit... I can see why Odyn favors you over the God-King. You may continue your trials.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96101,'I am not your enemy, Mayor. I came here to find someone within Black Rook Hold.','',0,0,0,0,0,0,274,0,0,0,52655,0,26124),
(96102,'Stop with your lies, night elf. You\'ll stay where we can keep an eye on you.','',0,0,0,0,0,0,396,0,0,0,52253,0,26124),
(96103,'<The blades hover before you.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96106,'Let\'s go!','',0,0,0,0,0,0,603,0,0,924,53389,0,26124),
(96107,'Genn, Jaina, it\'s good to see you safe.','',0,0,0,0,0,0,396,0,0,924,53390,0,26124),
(96108,'|TInterface\\Icons\\achievement_boss_hellfire_felmagnaron.blp:20|tKormrok |cFFFF0000|Hspell:186882|h[Enrages]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96109,'','Do not let them enter the volcano. The key to the Legion\'s worlds must not fall into their hands, Beliash.',0,0,0,0,0,0,0,0,6,0,0,55074,26124),
(96110,'Y\'know full well you lot should be inside. Come along!','',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(96111,'Aww...','Aww...',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(96112,'','This day will be your last!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96113,'Gul\'dan is close! I will send you further into the citadel. We must stop him before this corruption spreads any further.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96114,'Send me to the Hellfire Antechamber.','Send me to the Hellfire Antechamber.',51,0,0,0,0,0,0,0,0,0,0,0,26124),
(96115,'Send me to the Court of Blood.','Send me to the Court of Blood.',51,0,0,0,0,0,0,0,0,0,0,0,26124),
(96116,'Send me to the Nexus of Souls.','Send me to the Nexus of Souls.',51,0,0,0,0,0,0,0,0,0,0,0,26124),
(96117,'Go on. And this time, stay there.','',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(96118,'Send me to the Amphitheater of the Eternal.','Send me to the Amphitheater of the Eternal.',51,0,0,0,0,0,0,0,0,0,0,0,26124),
(96119,'Grownups are so stupid.','Grownups are so stupid.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(96120,'Rascals. Don\'t worry: I\'ll keep an eye out for them.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(96129,'You\'re mean!','You\'re mean!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(96130,'Yep.','Yep.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(96131,'Send me to The Black Gate.','Send me to The Black Gate.',51,0,0,0,0,0,0,0,0,0,0,0,26124),
(96132,'With your base fully constructed and your army in place, we can finally bring this campaign to a close. All that remains is the fortified bastion of Hellfire Citadel...','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(96134,'%s emerges from the shadows!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96135,'','Now, now. They can\'t help being lively.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(96136,'Receiving Blessing','Receiving Blessing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(96137,'My blades thirst for Legion blood. Do you know this thirst? Do you desire an end to the legion with every fiber of your being?\n\nDon\'t waste my time, nor yours. Every second the Legion persists is one too many.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96138,'<Throw the crystals into the pool.>','<Throw the crystals into the pool.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96139,'|TInterface\\Icons\\spell_fire_ragnaros_molteninferno.blp:20|t$n |cFFFF0000|Hspell:185828|h[Rekindles]|h|r a Fel Scorcher!','|TInterface\\Icons\\spell_fire_ragnaros_molteninferno.blp:20|t$n |cFFFF0000|Hspell:185828|h[Rekindles]|h|r a Fel Scorcher!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96140,'|TInterface\\Icons\\spell_fire_ragnaros_molteninferno.blp:20|t$n |cFFFF0000|Hspell:185835|h[Enkindles]|h|r all nearby Fel Scorchers!','|TInterface\\Icons\\spell_fire_ragnaros_molteninferno.blp:20|t$n |cFFFF0000|Hspell:185835|h[Enkindles]|h|r all nearby Fel Scorchers!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96142,'|TInterface\\Icons\\spell_fire_ragnaros_molteninferno.blp:20|tThe $n |cFFFF0000|Hspell:185824|h[Detonates]|h|r as it dies!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96144,'I\'m glad that you\'re here, $n.\n\nNow, let\'s be about our business.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96145,'My eredar are summoning in more demons to attack them from behind, your highness.','',0,0,0,0,0,0,0,0,6,0,55135,0,26124),
(96146,'','Deal with these insects, Beliash.',0,0,0,0,0,0,0,0,0,0,0,55071,26124),
(96148,'What\'s this?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96149,'This is a titan construct! It must have been guarding the prize that Sylvanas seeks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96150,'It seems that we are again a step behind. We must move quickly!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96151,'This world is full of kindling... a storm of fire is upon you, mortals!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96152,'The shadows will envelop you!','',0,0,0,0,0,0,15,0,0,0,50436,0,26124),
(96153,'Behind the veil, all you find is death!','',0,0,0,0,0,0,15,0,0,0,50439,0,26124),
(96154,'[PH] Sylvanas narrowly escapes, leaving you to fight her newest dark Val\'kyr!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(96155,'Now you dwell in darkness.','',0,0,0,0,0,0,15,0,0,0,50440,0,26124),
(96156,'The only truth is your death.','',0,0,0,0,0,0,15,0,0,0,50441,0,26124),
(96157,'Terokk\'s lies are proven false!','',0,0,0,0,0,0,15,0,0,0,50442,0,26124),
(96158,'Curses! The banshee witch escaped! Greymane will not be pleased...','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(96159,'And now, the Veil covers all!','',0,0,0,0,0,0,15,0,0,0,50449,0,26124),
(96160,'Let us dispatch of this infernal machine. At least we may be able to prevent Sylvanas from creating a new army of Val\'kyr...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96161,'[PH] Crowley rigs explosives to the machine.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(96162,'Briefing','Briefing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(96163,'I\'ll return to camp. You bring word of our findings to Greymane. Hurry, $c, this place is about to go down on our heads!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96164,'I took a pretty bad hit up there... my bird\'s still in good shape though. Bag a few Demons for me, eh?','I took a pretty bad hit up there... my bird\'s still in good shape though. Bag a few Demons for me, eh?',0,0,0,30,0,0,0,0,0,0,0,0,26124),
(96166,'','Got \'em in my sights!',0,0,0,0,0,0,0,0,0,0,0,52254,26124),
(96167,'','I see \'em. Good job with those stun grenades, $Glad:lass;!',0,0,0,0,0,0,0,0,0,0,0,52255,26124),
(96168,'','No way I\'ll miss this shot!',0,0,0,0,0,0,0,0,0,0,0,52256,26124),
(96169,'','Got that one, clear as day.',0,0,0,0,0,0,0,0,0,0,0,52257,26124),
(96170,'','Pow! Right in the kisser!',0,0,0,0,0,0,0,0,0,0,0,52258,26124),
(96171,'','Somebody order a bullseye?',0,0,0,0,0,0,0,0,0,0,0,52259,26124),
(96172,'','Headshot. Easy as pie.',0,0,0,0,0,0,0,0,0,0,0,52260,26124),
(96173,'','Like shootin\' fish in a bloody barrel.',0,0,0,0,0,0,0,0,0,0,0,52261,26124),
(96174,'Do you think you have won? You know nothing!','',0,0,0,0,0,0,15,0,0,0,50437,0,26124),
(96175,'Witness true power!','',0,0,0,0,0,0,15,0,0,0,50443,0,26124),
(96176,'The Veil can not hide my might!','',0,0,0,0,0,0,15,0,0,0,50444,0,26124),
(96177,'Terokk can not protect you!','',0,0,0,0,0,0,15,0,0,0,50445,0,26124),
(96178,'You had better learn to fly!','',0,0,0,0,0,0,15,0,0,0,50446,0,26124),
(96179,'The winds will punish you!','',0,0,0,0,0,0,15,0,0,0,50447,0,26124),
(96180,'It\'s a long way down!','',0,0,0,0,0,0,15,0,0,0,50448,0,26124),
(96181,'','Here, come closer and let me have a good look at you.$B$BAh! A $c, all the way out in these parts? My goodness!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96182,'After years of heroism, your life is snuffed out by a Hellblaze Imp.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96183,'Your last moments are agony as you fall before the Hellblaze Fiend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96184,'','The last thing you see is a Hellblaze Mistress laughing over your corpse.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96185,'We must go to Light\'s Hope Chapel at once. Highlord Fordring deserves to be put to rest amongst the ancient heroes of the Light buried there.','',0,0,0,0,0,0,0,0,0,0,52030,0,26124),
(96186,'','What\'s our status, Orc?',0,0,0,0,0,0,0,0,0,0,0,50535,26124),
(96187,'With his final breath, Khadgar unleashes a mana explosion that decimates everyone.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96188,'<This is a tub suitable for dyeing fabric.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96189,'Fill the tub with amber dye.','Fill the tub with amber dye.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96190,'Dye the silkweave.','Dye the silkweave.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96191,'<This is a tub suitable for dyeing fabric. The pattern you are working on requires a combination of green dye and brimstone shavings.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96192,'Fill the tub with green dye and brimstone shavings.','Fill the tub with green dye and brimstone shavings.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96193,'Tanithria at the tailoring shop needs some brimstone shavings for a pattern.','Tanithria at the tailoring shop needs some brimstone shavings for a pattern.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96194,'Brimstone? What could she possibly want THAT for? Gah, tailors. Here you go.','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(96195,'','You should start by filling the dyeing tub. Green dye\'s on the shelf, but you\'ll have to get the brimstone shavings from Alard Schmied in the blacksmithing shop.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96196,'That will be all for now. Go on, then.','That will be all for now. Go on, then.',0,0,0,0,0,0,0,0,0,34216,0,0,26124),
(96197,'You will be missed, brother.','',0,0,0,0,0,0,0,0,0,0,52725,0,26124),
(96198,'Highlord Tirion Fordring\'s last light fades.','Highlord Tirion Fordring\'s last light fades.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96199,'Greetings Commander!  We have lots of work to do before we get this shipyard operational!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(96200,'Talk to me about naval missions.','Talk to me about naval missions.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96201,'Controlling our fleet is no easy task, Commander.','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(96202,'I almost lost the fight against the fel energy inside me.','',0,0,0,0,0,0,0,0,0,0,55311,0,26124),
(96203,'Over here, Commander!  Let\'s get started on these naval missions!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(96205,'Communing With Ashildir','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(96206,'Before you stands a statue depicting the leader of the Shieldmaidens in Skold-Ashil. \n\nHer features look familiar...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96207,'Attempt to commune with the statue.','Attempt to commune with the statue.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96208,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96210,'The power of Xavius is too potent. I do not know what we can do against his Nightmare.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(96211,'The corruption of the Nightmare has seeped into the waters of the river.$B$BStand by, $c. I will call upon the power of Elune and purge this river.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(96212,'I hope this works, druid.','I hope this works, druid.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(96213,'Just a few more minutes here...  She will be seaworthy shortly!','',0,0,0,0,0,0,22,0,0,923,0,0,26124),
(96214,'The Portal Lord collapses, leaving its portal exposed! (Click the portal, glow is broken)','The Portal Lord collapses, leaving its portal exposed! (Click the portal, glow is broken)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96215,'','The Legion is invading the research station! Heroes, rally with me. We must protect the Kirin Tor at all costs! [PH]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96216,'','The Fel Lord has fallen, and the legion has retreated! We have pushed them back for now, but we must stay vigilant. [PH]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96217,'[PH] Ashildir tells you about the Val\'kyr.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(96218,'Penelope? Thank goodness you\'re all right! I was so worried!','',0,0,0,0,0,0,0,0,0,0,52262,0,26124),
(96219,'','Papa, papa, I\'m home! $GMister:Miss; $p saved me!',0,0,0,0,0,0,0,0,0,0,0,52263,26124),
(96220,'We was supposed to be off hours ago... at least we have these brews, eh?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96221,'A few more o\' these and I might even join this fight.','',11,0,0,0,0,0,0,0,0,0,0,0,26124),
(96222,'You will interfere no longer, mortals. Surrender the relic, or the Legion will burn you to ash and pluck it from your cinders! [PH]','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96223,'','I do hope they are still alive. It would break the Mayor\'s heart if we couldn\'t find his little girl.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(96224,'','Use that flare gun to mark the birds. That\'ll daze \'em long enough for me to take \'em out!',0,0,0,0,0,0,603,0,0,0,0,52264,26124),
(96225,'Cower before the might of the Legion!','Cower before the might of the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96226,'Our numbers are infinite!','Our numbers are infinite!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96227,'The relic shall be ours!','The relic shall be ours!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96228,'','We can handle the defense of the research station from here. Heroes, close the portals to cut off their line of attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96229,'','Face your judgment!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96232,'The Light will never leave your side.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96233,'','Bask in the glory of the Light.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96234,'We stand united!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96235,'If it breathes, put it out of its misery.','If it breathes, put it out of its misery.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96236,'These lands will fall to our hand.','These lands will fall to our hand.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96237,'Pathetic! Do these lands offer no challenge?','Pathetic! Do these lands offer no challenge?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96238,'The world crumbles under the Legion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96239,'Fragile beings serve no purpose under the Legion!','Fragile beings serve no purpose under the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96240,'Hope is your only enemy.','Hope is your only enemy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96241,'No presence is greater, mortals. In time you will see...','No presence is greater, mortals. In time you will see...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96242,'For centuries you have acted as uninvited guests in OUR world.','For centuries you have acted as uninvited guests in OUR world.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96243,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96244,'','They come for us! They will not find what they seek...',0,0,0,0,0,0,0,0,0,0,0,50764,26124),
(96245,'','Gurtogg! Dispatch our enemies...',0,0,0,0,0,0,0,0,0,0,0,50767,26124),
(96246,'','The sweet mercy... of death.',0,0,0,0,0,0,0,0,0,0,0,50766,26124),
(96247,'','How it struggles when death is near!',0,0,0,0,0,0,0,0,0,0,0,50768,26124),
(96248,'','It has fallen. It is mine now.',0,0,0,0,0,0,0,0,0,0,0,50769,26124),
(96249,'','They have been marked.',0,0,0,0,0,0,0,0,0,0,0,50770,26124),
(96250,'','They will carry the darkness with them.',0,0,0,0,0,0,0,0,0,0,0,50771,26124),
(96251,'','It rips. It tears. It is boundless and eternal...',0,0,0,0,0,0,0,0,0,0,0,50772,26124),
(96252,'','The void, it hungers!',0,0,0,0,0,0,0,0,0,0,0,50773,26124),
(96253,'','And then the dead shall rise once more.',0,0,0,0,0,0,0,0,0,0,0,50774,26124),
(96255,'','The Alliance will be upon us soon, and we have nowhere to run.',0,0,0,0,0,0,1,0,0,0,0,52948,26124),
(96256,'Iron Horde will CRUSH you!','',0,0,0,0,0,0,0,0,0,0,50388,0,26124),
(96257,'ArRRgghhHhh...','',0,0,0,0,0,0,0,0,0,0,50389,0,26124),
(96258,'ArRRgghhHhh...','',0,0,0,0,0,0,0,0,0,0,50391,0,26124),
(96259,'ArRRgghhHhh...','',0,0,0,0,0,0,0,0,0,0,50392,0,26124),
(96260,'','Do not question me, Nathanos. Now go - make for the Eternity, and bring this hero with you.',0,0,0,0,0,0,1,0,0,0,0,52949,26124),
(96261,'Tell us your plans, imp!','Tell us your plans, imp!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96262,'My Queen, your safety must be our first concern. Surely we can leave a few ships behind to-','',0,0,0,0,0,0,1,0,0,0,51737,0,26124),
(96263,'Yes, of course. Come along... \"hero.\"','',0,0,0,0,0,0,1,0,0,0,52952,0,26124),
(96264,'Me scratch you to bits!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96265,'','Organize our defenses beginning with the rear. I want bat-riders in the air and catapults at the ready!',0,0,0,0,0,0,1,0,0,0,0,52950,26124),
(96266,'We know you\'re after something. Out with it!','We know you\'re after something. Out with it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96267,'Yes, Dark Lady.','',0,0,0,0,0,0,0,0,0,0,50396,0,26124),
(96268,'Time to feast!','',0,0,0,0,0,0,0,0,0,0,50397,0,26124),
(96269,'Crush you!','',0,0,0,0,0,0,0,0,0,0,50398,0,26124),
(96270,'Crush you!','',0,0,0,0,0,0,0,0,0,0,50398,0,26124),
(96271,'Drink your blood! Eat your flesh!','',0,0,0,0,0,0,0,0,0,0,50400,0,26124),
(96272,'I\'ll rip the meat from your bones!','',0,0,0,0,0,0,0,0,0,0,50401,0,26124),
(96273,'More! I want MORE!','',0,0,0,0,0,0,0,0,0,0,50402,0,26124),
(96274,'My blade seeks vengeance!','',0,0,0,0,0,0,0,0,0,0,50405,0,26124),
(96275,'To ash...','',0,0,0,0,0,0,0,0,0,0,50407,0,26124),
(96276,'To cinders!','',0,0,0,0,0,0,0,0,0,0,50408,0,26124),
(96277,'I walk in shadow...','',0,0,0,0,0,0,0,0,0,0,50411,0,26124),
(96278,'Burn... BURN!','',0,0,0,0,0,0,0,0,0,0,50412,0,26124),
(96279,'A map of the Broken Isles showing the current status of your forces.','A map of the Broken Isles showing the current status of your forces.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96280,'Investigate the map.','Investigate the map.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96281,'No... The taint of Xavius is too strong.','',1,0,0,0,0,0,20,0,0,0,0,0,26124),
(96282,'Who are you? Stay back - I will protect the Queen with my last breath!','Who are you? Stay back - I will protect the Queen with my last breath!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96283,'Queen Azshara... betrayed us...','Queen Azshara... betrayed us...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96284,'','I was drawn back to this place, and for a moment I mistook you for the enemy. Be careful, hero. This place reeks of restless spirits.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96289,'Foul demons! You are no match for the Horde!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(96290,'Tirion!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(96291,'Have a go with me mortar. I\'ll spot for ye!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96292,'Master, I fight in your name!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96293,'Lord Ravencrest died long ago, but I will always revere him as my mentor.','',0,0,0,0,0,0,0,0,0,0,52647,0,26124),
(96294,'It appears we both have been wandering for quite some time. Would you care for some company?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96295,'Glad to see you out here, $n. Care for a lift?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96296,'These are not parts one should wander alone, $n. Allow me to offer you safe travel.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96297,'','Lord Ravencrest appointed me as Queen Azshara\'s personal guard.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96298,'','The tower beckons, but I fear its call. Hurry, free us before it\'s too late!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96299,'[WALKS FORWARD.] Wait, what is this? His tomb has been disturbed! His ashes are gone!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96300,'Greetings, and thank you for helping to test patch 6.2!\n\nI can teleport you directly into Hellfire Citadel or Tanaan Jungle. This is just a teleport, not a match-making service, so I hope you have a party ready to tackle the challenges waiting inside. If not, you might want to check out our new Group Finder feature to find some allies.\n\nMake sure you have selected the difficulty you want to test before teleporting, since you may not be able to zone out easily if you need to change the difficulty setting!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96301,'I want to go to Hellfire Citadel (Raid).','I want to go to Hellfire Citadel (Raid).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96302,'I want to go to Tanaan Jungle.','I want to go to Tanaan Jungle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96303,'','Entrap them, my children.',0,0,0,0,0,0,0,0,0,0,0,55024,26124),
(96304,'Activate all three gateways and summon in the rest of our forces.','',0,0,0,0,0,0,0,0,0,0,55244,0,26124),
(96305,'','Kill them all!',0,0,0,0,0,0,15,0,0,0,0,55284,26124),
(96306,'','Follow me, Highlord. You\'ll use the command map from now on to delegate your forces.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(96307,'','Yes? How might I help you, $n?',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(96308,'The Ashbringer... it\'s been a long time since I\'ve seen that blade. You\'re doing the Light\'s work defending our world, $n.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(96309,'These lands are covered with shrines of power that can make the Ashbringer even more powerful. Seek them out on your travels and you will truly become a force to be reckoned with.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(96310,'Walk always with the Light, Highlord, and it will never forsake you. Take my blessing, and you will never truly stand alone. Farewell.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(96311,'How DARE you enter MY sanctuary! You\'ll deal with me now!','How DARE you enter MY sanctuary! You\'ll deal with me now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96312,'Insolence! The Legion won\'t stand for this!','Insolence! The Legion won\'t stand for this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96313,'Begone, pests! It is time you met your end!','Begone, pests! It is time you met your end!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96314,'','Greetings keeper of the <artifact>. I speak for the Skyhorn Tribe.$b$b',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96315,'Will the Skyhorn join with Mayla Highmountain?','Will the Skyhorn join with Mayla Highmountain?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96316,'It\'s time we reclaim our lands!','It\'s time we reclaim our lands!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96317,'Thanks to the failure of Highmountain, the harpies have become emboldened and assault my people. The Skyhorn cannot fight a battle on two fronts.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96318,'Their shields are too strong! Protectors, at your will!','Their shields are too strong! Protectors, at your will!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96319,'So you are the one who carries <artifact>. I thought you would be taller.$b$bYou stand before Speaker Ragebull.$b$bI am the voice for the great Bloodtotem Tribe, strength of the earth and the most powerful warriors Highmountain has ever known.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96320,'Will the Bloodtotem join with Mayla Highmountain?','Will the Bloodtotem join with Mayla Highmountain?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96321,'Ha! Highmountain cannot even defend its own chieftain and you would have us join with them? The Bloodtotem honor strength, not victims.','',0,0,0,0,0,0,0,0,0,0,54859,0,26124),
(96322,'The bearer of <artifact>? This is a great honor.$b$bI speak for the Whitewater Tribe.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96323,'Will the Rivermane join with Mayla Highmountain?','Will the Rivermane join with Mayla Highmountain?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96325,'','It is with a heavy heart I must decline. The drogbar assault my lands. I am here to ask for aid and yet Mayla has none to give.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96334,'$r creaks and moans, gathering its strength as it prepares for battle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96335,'%s picks up the Wraith Zapper and checks its energy reserves. Good to go!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96336,'','Well done, hero. Now let us regroup before our enemy is able to.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96337,'<Apparently this brave soul perished moments after trapping something dangerous.>$B$B<Her gun lies nearby. Dare you pick it up and investigate further?>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96338,'These birds are comin\' from Black Rook Hold. Fourth one I\'ve shot today.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96339,'','What manner of beast IS this?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96340,'Sentinels, let\'s give them cover!','Sentinels, let\'s give them cover!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96342,'','Windgore! Attack this infidel!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96344,'I want these tauren off my mountain.','',11,0,0,0,0,0,0,0,0,0,54267,0,26124),
(96351,'Just inspect the anvil when yer ready to peruse yer options. Take yer time, it\'s nae a decision to rush through!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(96353,'','You know, they used to call me \"Mean Marlene.\" I could shoot the head off a nail at hundred paces.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96355,'My daughter is everything to me. I can\'t thank you enough for bringing her home, safe.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96356,'Sharpen your blades, warriors! No demon shall pass through our gates.','',0,0,0,0,0,0,1,0,0,0,52265,0,26124),
(96357,'The master commands us...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96358,'Go to your grave!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96359,'Join us in eternity...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96360,'The Hold shall not fall...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96361,'Dang it! Jammed again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96362,'Demons won\'t even see it coming!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96363,'Right between the eyes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96364,'Did you think to reclaim this land? What we take, we shall keep.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96365,'Excellent choice, if I do say so myself. We\'ll need a much stronger anvil to upgrade the blade further, but I\'ll find one. You have my word!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(96366,'Demons... hah! Demons don\'t scare me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96367,'I may be small, but I ain\'t scared of nothin\'!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96368,'Come and get some, demons!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96369,'You discard the Wraith Zapper as you leave the hilltop.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96370,'It\'s pretty bad up here over the Hill! I\'ll hold the skies as long as I can.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96371,'Don\'t worry friends. I\'ve got the skies over Sentinel Hill covered!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96372,'Sorry, demons! The skies over Sentinel Hill belong to us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96373,'You dare challenge me?','',11,0,0,0,0,0,0,0,0,0,54268,0,26124),
(96374,'The skies above Sentinel Hill seem to be thinning out. I\'ll continue my patrols until we\'re sure it\'s safe!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96375,'It appears to be over, friends! I\'ll keep watch over the Hill a while longer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96377,'Don\'t blink when you shoot!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96378,'','Our battle against the harpies is ongoing, but your actions have helped restore some balance to the basin. \n\nWith Morashu\'s spirit reborn, he will once again be able to guide other animals back to nature.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(96379,'Behold, the hilt of Frostmourne. From its broken form you will create a blade without equal! Approach and channel your power into it to create your weapon.','',0,0,0,0,0,0,0,0,0,0,53778,0,26124),
(96380,'Good.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96381,'Excellent shot!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96382,'To arms, men!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96383,'Move into positions!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96385,'Heard any pet battle news out of Tanaan Jungle?','Heard any pet battle news out of Tanaan Jungle?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96386,'','I\'ve heard rumors of no less than 15 very powerful pets, corrupted by the fel energies unleashed by Gul\'dan. Find and defeat them and you\'ll surely find some rewards of value!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96390,'Please... the others! We were separated... you have to save them!','Please... the others! We were separated... you have to save them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96391,'Oh thank you. Thank you, hero!','Oh thank you. Thank you, hero!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96392,'Why is this happening to us? What are these things?','Why is this happening to us? What are these things?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96393,'Stay calm, everyone. Reinforcements are here. We will protect you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96394,'We won\'t let them through! You\'re safe, so long as you stay here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96395,'We don\'t feel safe! What\'s going on out there?','We don\'t feel safe! What\'s going on out there?',6,0,0,300,0,0,0,0,0,0,0,0,26124),
(96397,'Everything gone... just like that. How can you hope to stop them?','Everything gone... just like that. How can you hope to stop them?',6,0,0,300,0,0,0,0,0,0,0,0,26124),
(96400,'Is that help I hear? Inside, please hurry!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96401,'So weak. So delicious! Me feed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96402,'Oh thank the Light! Please, you must stay here to protect us!','',22,0,0,500,0,0,0,0,0,0,0,0,26124),
(96403,'','Father, look out!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96404,'','I will join you. Let\'s kill some more demons.',0,0,0,0,0,0,0,0,0,0,0,55285,26124),
(96405,'','I... will not... give in!',0,0,0,0,0,0,0,0,0,0,0,55090,26124),
(96406,'Enough! I will reap your souls myself!','',25,0,0,150,0,0,0,0,0,0,0,0,26124),
(96407,'So weak... hard to contain... my energy.','',0,0,0,0,0,0,0,0,0,0,55310,0,26124),
(96408,'<The construct sits motionless on the ground.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96409,'<Insert 1000 Apexis Crystals.>','<Insert 1000 Apexis Crystals.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96410,'Repairing the construct will cost 1000 Apexis Crystals. Are you sure?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96411,'I will destroy all of you.','',0,0,0,0,0,0,0,0,0,0,55052,0,26124),
(96412,'Lemme hear your bones crunch!','',0,0,0,0,0,0,0,0,0,0,54860,0,26124),
(96413,'We\'re takin\' the mountain!','',0,0,0,0,0,0,0,0,0,0,54861,0,26124),
(96414,'Gonna enjoy guttin\' you!','',0,0,0,0,0,0,0,0,0,0,54862,0,26124),
(96415,'','The pain!',0,0,0,0,0,0,0,0,0,0,0,55226,26124),
(96416,'These are drogbar rocks! Drogbar stones!','',0,0,0,0,0,0,0,0,0,0,54871,0,26124),
(96418,'It appears to be in working order. Why don\'t you take a look and see what it can do?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96419,'','Help has arrived at last! Elune be praised!',0,0,0,0,0,0,1,0,0,0,0,60224,26124),
(96420,'Tremble beneath the might of the Burning Legion!','',0,0,0,0,0,0,0,0,0,0,52266,0,26124),
(96421,'Enjoy this moment, mortals... It shall be your last!','',0,0,0,0,0,0,0,0,0,0,52267,0,26124),
(96422,'At long last... destruction has come to this pathetic world!','',0,0,0,0,0,0,0,0,0,0,52268,0,26124),
(96423,'Yes... struggle... your meager attempts to survive amuse me!','',0,0,0,0,0,0,0,0,0,0,52269,0,26124),
(96424,'None shall awake from the Nightmare!','',0,0,0,0,0,0,0,0,0,0,52270,0,26124),
(96425,'Rend the flesh from their bones... and drain the life from their mortal bodies!','',0,0,0,0,0,0,0,0,0,0,52271,0,26124),
(96426,'Pray to your pathetic goddess... let her listen to your cries of agony!','',0,0,0,0,0,0,0,0,0,0,52272,0,26124),
(96427,'Shaladrassil... it cannot... it must not be true!','',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(96428,'I sense greater power within you, $n. Have you stolen a demon\'s essence?','',0,0,0,0,0,0,0,0,0,0,55229,0,26124),
(96429,'I would have perished without your aid!','I would have perished without your aid!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96430,'I\'m ready.','I\'m ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96431,'It\'s as if the forest itself has risen against us...','It\'s as if the forest itself has risen against us...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96432,'You have my thanks!','You have my thanks!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96433,'I will defend this forest to my dying breath!','I will defend this forest to my dying breath!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96434,'Hope is lost... but I will fight on!','Hope is lost... but I will fight on!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96435,'|TInterface\\Icons\\spell_fire_rune.blp:20|tThe |cFFFF0000|Hspell:187658|h[Empowered Explosive Rune]|h|r detonates one last time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96436,'Thank you!','Thank you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96437,'How kind of you.','How kind of you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96438,'Most appreciated.','Most appreciated.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96439,'I hope to someday repay the favor!','I hope to someday repay the favor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96440,'You\'ve been a great help, $n. Thank you.','You\'ve been a great help, $n. Thank you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96441,'','$n, over here.',0,0,0,0,0,0,0,0,0,0,0,55011,26124),
(96442,'Beware, brothers! We are discovered!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96443,'I\'ll handle this interference personally.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96444,'This... means nothing. You... are... nothing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96445,'We shall rise again... more numberless than the stars.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96446,'You fight for a world... that is... already lost.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96447,'The Nightmare is no mere illusion. It was born... from your darkest... truths.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96448,'Cowards and weaklings! You deserve to burn!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96449,'This ends now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96450,'','No!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96451,'Eek! They take candle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96452,'Is my candle! Why take?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96453,'Keep calm, fools! Finish defiling the shrine!','',53,0,0,0,0,0,0,0,0,0,0,0,26124),
(96454,'Taking','Taking',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(96455,'Shhh... Quit tryin\' ta attract \'em ta me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96456,'Find yer own hidin\' spot!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96457,'Come and get me when it\'s o\'er!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96458,'Quit makin\' all that racket! You\'ll draw their attention!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96459,'Spots claimed! Now if ya don\' mind... tryin\' ta keep me location a secret!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96460,'It burns!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96461,'Noooo!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96462,'Finally, flesh worthy of my pyre!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96463,'Protocol: Soul Harvest is active!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96464,'Soul detected. Reaping in progress.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96465,'Harvesting... unsuccessful.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96466,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-King Ymiron.blp:50:80|t$bAre you strong enough to wield Magnar Icebreaker\'s weapons? We shall see...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96467,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-King Ymiron.blp:50:80|t$bFinally someone worthy of Magnar Icebreaker\'s legacy.$bIf you would claim his legendary weapons, follow... and survive...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96468,'A 7th Legion Battlemage freezes the catapult solid!','A 7th Legion Battlemage freezes the catapult solid!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96469,'You do not look well, $n... are you alright?','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(96470,'$n, my thanks for coming..','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(96471,'|TInterface\\Icons\\spell_shadow_auraofdarkness:20|t%s begins to cast |cFFFF0000|Hspell:187466|h[Supreme Doom]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96472,'It is very good to see you, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96473,'I\'m ready to go to Magnar\'s island.','I\'m ready to go to Magnar\'s island.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96474,'DO NOT TRANSLATE','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96475,'DO NOT TRANSLATE','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96476,'DO NOT TRANSLATE','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96477,'DO NOT TRANSLATE','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96478,'DO NOT TRANSLATE','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96479,'|TInterface\\Icons\\spell_nature_astralrecalgroup:20|t%s casts |cFFFF0000|Hspell:187702|h[Twisted Reflection]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96480,'Finally we get some help around here. That is, if you\'re willing to put aside past differences, for now.','',603,0,0,15,0,0,0,0,0,0,0,0,26124),
(96481,'Let\'s team up. If we fight, we only help the demons.','Let\'s team up. If we fight, we only help the demons.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96482,'I don\'t work with murderers. The Defias are never to be trusted!','I don\'t work with murderers. The Defias are never to be trusted!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96483,'You high and mighty types are worse than demons!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96484,'Now... who is the murderer?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96485,'','What is this? The hero of Helheim seeks entrance to the vault?',0,0,0,0,0,0,6,0,0,0,0,51693,26124),
(96486,'','I know your worth. I will grant you an audience with Eyir.',0,0,0,0,0,0,1,0,0,0,0,51699,26124),
(96487,'','You may proceed, but know that Eyir may not regard you as I do.',0,0,0,0,0,0,0,0,0,0,0,51700,26124),
(96488,'','Seek your fate in the vault, $n. May Eyir be your wings.',0,0,0,0,0,0,1,0,0,0,0,51701,26124),
(96489,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ICONS\\Ability_Warlock_EmpoweredImp.blp:50:80|tI smell power behind this door! Let\'s dig it up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96490,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ICONS\\Ability_Warlock_EmpoweredImp.blp:50:80|tOuch ouch! I must get help!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96491,'Ladies and gentlemen, please! Please! We are doing all we can to address the situation.','Ladies and gentlemen, please! Please! We are doing all we can to address the situation.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96492,'Rest assured, Sentinel Hill is well protected!','Rest assured, Sentinel Hill is well protected!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96493,'The Legion will not penetrate our defenses. I assure you!','The Legion will not penetrate our defenses. I assure you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96494,'Please, listen a moment. We are forcing them back as we speak!','Please, listen a moment. We are forcing them back as we speak!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96495,'Ladies and gentlemen, we are safe and secure within the walls. There is no need for panic.','Ladies and gentlemen, we are safe and secure within the walls. There is no need for panic.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96498,'DO NOT TRANSLATE','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96499,'The bold fools are boarding my ship. Come on!','',0,0,0,0,0,0,0,0,0,0,52953,0,26124),
(96500,'Transport','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(96501,'Carrier','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(96502,'Destroyer','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(96503,'','You defile these grounds!',0,0,0,0,0,0,0,0,0,0,0,51672,26124),
(96504,'','Eyir take you!',0,0,0,0,0,0,0,0,0,0,0,51673,26124),
(96505,'','Eyir, guide my spear!',0,0,0,0,0,0,0,0,0,0,0,51674,26124),
(96506,'','You are not worthy of ascension!',0,0,0,0,0,0,0,0,0,0,0,51675,26124),
(96507,'','My shield will not falter!',0,0,0,0,0,0,0,0,0,0,0,51676,26124),
(96508,'','You are but another test!',0,0,0,0,0,0,0,0,0,0,0,52427,26124),
(96509,'','Sisters, to battle!',0,0,0,0,0,0,0,0,0,0,0,60751,26124),
(96510,'','Eyir, be my wings...',0,0,0,0,0,0,0,0,0,0,0,51678,26124),
(96511,'','The Halls of Valor await...',0,0,0,0,0,0,0,0,0,0,0,51679,26124),
(96512,'','It was... a glorious death...',0,0,0,0,0,0,0,0,0,0,0,51680,26124),
(96513,'','My shield remains... unbroken...',0,0,0,0,0,0,0,0,0,0,0,51681,26124),
(96515,'','The battle is upon us, sisters!',0,0,0,0,0,0,0,0,0,0,0,52417,26124),
(96516,'','Protect the temple!',0,0,0,0,0,0,0,0,0,0,0,52416,26124),
(96517,'','Break upon my shield!',0,0,0,0,0,0,0,0,0,0,0,52428,26124),
(96518,'','The temple must not fall...',0,0,0,0,0,0,0,0,0,0,0,52415,26124),
(96519,'','Eyir... I have failed...',0,0,0,0,0,0,0,0,0,0,0,52001,26124),
(96521,'Battleship','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(96522,'Submarine','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(96523,'We must take the fight to them. But it would be rude to show up without a gift... The apothecaries will have just what we need.','',0,0,0,0,0,0,0,0,0,0,52954,0,26124),
(96525,'Transport','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(96526,'Submarine','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(96527,'Battleship','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(96528,'Destroyer','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(96529,'Carrier','',0,0,0,0,0,0,0,0,14,0,0,0,26124),
(96533,'It is time to pass my legacy on to someone powerful enough to wield them. Survive my trial and you will be given the strongest sword and shield this world has ever seen...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96535,'What are the Armaments of the Black Wyrm?','What are the Armaments of the Black Wyrm?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96537,'Do you know of the Earthwarder, Neltharion? He was a glorious beast before he... fell. He was invulnerable to all but the gods in that age. Magnar worshipped him in his youth.\n\nEven though he was a venerated warrior Magnar wanted to be like him, invulnerable. His plan was arrogant. He would storm the nest of Neltharion himself and take something from his legendary hoard.\n\nMagnar and his warband fought Neltharion\'s younglings in a fierce battle. They had just made the nest when the dragon returned. With one breath he wiped away entire force. Magnar grabbed one of his cast off scales, used it to shield himself, and was blown down the mountain.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(96538,'So he left with nothing but a scale?','So he left with nothing but a scale?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96539,'Nothing but a scale? Hah! A scale from the most hard to kill dragon in the world!\n\nMagnar realized what he had and spent years learning the forge under masters both titanforged and vrykul. When he was finally skilled enough, he crafted from the scale a shield and sword that have never seen an equal. Those are the Armaments of the Black Wyrm. In the right hands they project the strength and invulnerability of the Earthwarder himself.\n\nTo this day I am still unsure if he was lucky to survive that encounter or if the Black Wyrm judged him worthy enough to live.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(96541,'Xhul\'horac targets you with |cFFFF0000|Hspell:186407|h[Fel Surge]|h|r!','Xhul\'horac targets you with |cFFFF0000|Hspell:186407|h[Fel Surge]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(96542,'Filthy worgen... A beast in a hat is still a beast.','',0,0,0,0,0,0,0,0,0,0,51747,0,26124),
(96543,'Dread-Riders, grab as many vials as you can carry and form up on me! We are bringing down that gunship.','',0,0,0,0,0,0,1,0,0,0,51748,0,26124),
(96546,'','I\'ve heard rumors of no less than 15 very powerful pets, corrupted by the fel energies unleashed by Gul\'dan. Find and defeat them and you\'ll surely find some rewards of value!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96547,'Heard any pet battle news out of Tanaan Jungle?','Heard any pet battle news out of Tanaan Jungle?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96550,'I am ready to begin the trial.','I am ready to begin the trial.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96551,'That was an exhilarating kill, one that will make a fine chapter in my next novel.','',0,0,0,0,0,0,0,0,0,0,54837,0,26124),
(96552,'Xhul\'horac targets you with |cFFFF0000|Hspell:186333|h[Void Surge]|h|r!','Xhul\'horac targets you with |cFFFF0000|Hspell:186333|h[Void Surge]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(96553,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-King Ymiron.blp:50:80|t$bYou are the one, bring them glory and they will bring glory to you. I will finally take my place in the Halls of Valor, where the brave may fight forever.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96554,'New directives: Serve Legion. Destroy property.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96555,'Slash. Burn. Harvest!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96556,'A |cFFFF0000|Hspell:186407|h[Shadowfel Annihilation]|h|r detonates on $n!','A |cFFFF0000|Hspell:186407|h[Shadowfel Annihilation]|h|r detonates on $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(96558,'','I may carry a book instead of a rifle, but I assure you $n, I\'m a hunter at heart.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(96559,'<Despite a heavy cloth across his eyes, the wizened seer gazes up at the skies with a contemplative look.>$B$BThe stars shape our destinies, child, granting their blessing to the worthy and shunning the weak.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96560,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] Do not hold back, $n. Show him your wrath.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96561,'Darksorrow and Ravencrest will have the honor of accompanying you into Suramar, $p. A small force will have the best chance of flying undetected into the hold.','',0,0,0,0,0,0,0,0,0,36911,57566,0,26124),
(96562,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ICONS\\Warlock_Summon_DoomGuard.blp:50:80|t$bI am here Pillik! What insect scared you off?!? Come out of there insect or I will bring everything down upon you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96563,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ICONS\\Warlock_Summon_DoomGuard.blp:50:80|t$bWe didn\'t kill all of you at the Broken Shore? I shall correct that mistake now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96564,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-ARCHIMONDEWOD.blp:50:80|t$B[Taldath the Destroyer] Insolent whelps! Release me now and I may yet spare you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96565,'FOOL! You dare face me alone?!','',0,0,0,0,0,0,25,0,0,0,64639,0,26124),
(96566,'Varedis will hunt down every one of your disgusting ilk. Pity you won\'t be around to witness it.','',0,0,0,0,0,0,0,0,0,0,64644,0,26124),
(96567,'The Twinblades... will be your end...','',0,0,0,0,0,0,0,0,0,0,64648,0,26124),
(96568,'Vermin! My lord wields power beyond your comprehension! He will end you!','',0,0,0,0,0,0,0,0,0,0,64646,0,26124),
(96569,'The smallest touch adds a just enough.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96570,'Ingredients as far as the eye can see...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96571,'Elixirs require such a delicate touch.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96572,'Potions by day. Potions by night.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96573,'A touch of this for ailments... or double for a more... sinister use, perhaps.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96574,'Mmm... such a pleasant aroma.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96575,'Hold your ground! Show them we will not be broken by such petty sorcery.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96576,'This one met a grisly end. No sign of Maiev here.','',0,0,0,0,0,0,1,0,0,0,52237,0,26124),
(96577,'\"Despite our attempts to extract information, the Warden remains stubbornly resistant.\" Could they be talking about Maiev?','',0,0,0,0,0,0,1,0,0,0,52238,0,26124),
(96578,'That\'s Maiev\'s weapon! She was here!','',0,0,0,0,0,0,1,0,0,0,52239,0,26124),
(96579,'','Eyir, mother of the Val\'kyr, I offer you this one chance to submit willingly.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(96580,'When the ancient war began, we suffered countless losses. Our cities burned.','',0,0,0,0,0,0,0,0,0,0,52653,0,26124),
(96581,'Lord Ravencrest saved our people and rescued our world from annihilation.','',0,0,0,0,0,0,0,0,0,0,52657,0,26124),
(96582,'His loss was tragic for us all. We owe him... everything.','',0,0,0,0,0,0,0,0,0,0,52648,0,26124),
(96583,'If you\'ve come for the warden, you\'re too late!','If you\'ve come for the warden, you\'re too late!',0,0,0,0,0,0,1,0,0,0,52240,0,26124),
(96584,'Lord Ravencrest, I have served you loyally.','Lord Ravencrest, I have served you loyally.',0,0,0,0,0,0,1,0,0,0,0,52241,26124),
(96585,'My loyalty to Lord Ravencrest will not falter.','My loyalty to Lord Ravencrest will not falter.',0,0,0,0,0,0,1,0,0,0,52242,52242,26124),
(96586,'In death, I see the truth. You are no enemy.','In death, I see the truth. You are no enemy.',0,0,0,0,0,0,1,0,0,0,0,52243,26124),
(96587,'You shall never reach Lord Ravencrest\'s tower!','You shall never reach Lord Ravencrest\'s tower!',0,0,0,0,0,0,1,0,0,0,52244,52244,26124),
(96588,'You\'ll be thrown into the prisons, just like the others.','You\'ll be thrown into the prisons, just like the others.',0,0,0,0,0,0,1,0,0,0,52245,52245,26124),
(96593,'The undead approach! To arms!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96595,'How did you and your sister get separated?','How did you and your sister get separated?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96596,'What did she do?','What did she do?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96597,'So why are you trying to save her?','So why are you trying to save her?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96598,'Maiev and I chose very different paths in life.$B$BNot long after the Legion\'s first defeat on Azeroth, she dedicated her life to the pursuit of justice.$B$BSome would say she\'s gone too far in that pursuit at times.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96599,'She murdered innocents, hoping to sever our people\'s ties with the Alliance.$B$BStill, I couldn\'t bring myself to kill her.$B$BAt first I thought that I\'d been weak -- that love had left me unable to do what was necessary.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96600,'I know my sister. She\'d never commit such crimes unless she was under some foul influence.$B$BEven so, rather than investigate fully, I assumed the worst.$B$BI\'ve been a poor brother, but there\'s still time for me to make things right.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96601,'DO NOT TRANSLATE','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96602,'I\'ll help you find Maiev.','I\'ll help you find Maiev.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96603,'White Lady, grant me your light so that I may purge these waters of the vile corruption of Xavius.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(96604,'','Little brother. You came for me. Even after I tried to k--',0,0,0,0,0,0,0,0,0,0,0,52730,26124),
(96605,'Foolish druid. The power of your goddess is pitiful. Behold the might of Xavius!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96606,'DO NOT TRANSLATE','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96607,'We can\'t go out there! Are you crazy? Have you seen those things?','',22,0,0,15,0,0,0,0,0,0,0,0,26124),
(96608,'Priom\'s right. Those things will crush us! It\'s just the five of us!','',396,0,0,15,0,0,0,0,0,0,0,0,26124),
(96609,'We\'re completely cut off. We have to wait for reinforcements!','',396,0,0,15,0,0,0,0,0,0,0,0,26124),
(96610,'','Enough! I won\'t stand for this cowardace.',22,0,0,15,0,0,0,0,0,0,0,0,26124),
(96611,'','We\'re dead if we stay here too long. Allen, keep your eyes open for any sign of help! We move as soon as reinforcements are in sight!',22,0,0,15,0,0,0,0,0,0,0,0,26124),
(96612,'Sergeant! I hear movement outside. It could be our reinforcements!','',396,0,0,15,0,0,0,0,0,0,0,0,26124),
(96613,'','Excellent! Shields up, everyone. We\'re headed outside! Form up!',22,0,0,15,0,0,0,0,0,0,0,0,26124),
(96614,'You have to earn the Legion\'s gift!','You have to earn the Legion\'s gift!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96615,'The Fel Touch is within your grasp!','The Fel Touch is within your grasp!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96616,'We cannot... allow Xavius... to get away with this! We must get to Shaladrassil... and put an end to the demon!','',0,0,0,0,0,0,1,0,0,0,52246,0,26124),
(96617,'I will meet you further ahead... We must hurry!','',0,0,0,0,0,0,0,0,0,0,52737,0,26124),
(96618,'No! We must press onward... The fate of the world is at stake!','',0,0,0,0,0,0,0,0,0,0,52738,0,26124),
(96619,'Great kill down there! Here comes the air support!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96620,'Like the wind!','',0,0,0,0,0,0,0,0,0,0,50413,0,26124),
(96621,'Your darkness burns within me!','',0,0,0,0,0,0,0,0,0,0,50414,0,26124),
(96622,'Clear the field of these demons and we\'ll get you the birds you\'ll need to attack this citadel!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96623,'That citadel\'s not going to destroy itself! Clear a landing site on the farm and we\'ll get you some birds for the assault!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96624,'If my memory serves me... there was an outpost not far from here.','',0,0,0,0,0,0,0,0,0,0,52247,0,26124),
(96625,'I am everburning!','',0,0,0,0,0,0,0,0,0,0,50406,0,26124),
(96626,'Do not worry about us, commander. We are outnumbered, but they lack our spirit. LOK\'TAR!','',0,0,0,0,0,0,0,0,0,0,50351,0,26124),
(96627,'Go now commander. We will continue to put pressure on this front.','',0,0,0,0,0,0,0,0,0,0,50435,0,26124),
(96628,'','Rotbeak is just northwest, past the dock. Bring me its head!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96629,'I will scour every inch of this island until I find someone who knows of the Pillars of Creation. On my honor.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(96630,'You have business with the Master you should attend to.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(96631,'Throwing','Throwing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(96632,'The Legion will fall.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96633,'Show me what missions you have prepared.','Show me what missions you have prepared.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96634,'Farahlon is mysterious land. Only send a crew you trust... or can afford to lose.','',0,0,0,0,0,0,274,0,0,923,50642,0,26124),
(96635,'We will plumb the depths of Draenor for all its secrets!','',0,0,0,0,0,0,1,0,0,923,50643,0,26124),
(96636,'Give Cordana my best. She\'s been quite distant lately.','',0,0,0,0,0,0,6,0,0,923,50644,0,26124),
(96637,'With every passing moment, Gul\'dan grows in power. But he no longer slinks through the shadows - we know where he is. We know what he\'s doing. Now, we strike! May the Light have mercy on all our souls.','',0,0,0,0,0,0,1,0,0,923,50647,0,26124),
(96640,'I have safely negotiated entrance into the elder drake\'s lair.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(96641,'I will meet you there.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(96642,'','An ancient blue dragon lies to the north. He is our best chance at finding out more about the Pillars.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(96643,'I will kill every last demon in my way.','',0,0,0,0,0,0,0,0,0,0,55053,0,26124),
(96644,'','A slight setback. I assure you it will not happen again.',0,0,0,0,0,0,0,0,0,0,0,55227,26124),
(96645,'Doom!','',0,0,0,0,0,0,0,0,0,0,55142,0,26124),
(96646,'You will die!','',0,0,0,0,0,0,0,0,0,0,55145,0,26124),
(96647,'Intruder, your life ends now.','',0,0,0,0,0,0,0,0,0,0,55146,0,26124),
(96648,'The Legion conquers all.','',0,0,0,0,0,0,0,0,0,0,55147,0,26124),
(96649,'You do not belong here.','',0,0,0,0,0,0,0,0,0,0,55148,0,26124),
(96650,'A fatal mistake, mortal.','',0,0,0,0,0,0,0,0,0,0,55149,0,26124),
(96651,'Succulent marrow. Crunchy bones.','',0,0,0,0,0,0,0,0,0,0,55150,0,26124),
(96652,'I will rip the fel from your soul.','',0,0,0,0,0,0,0,0,0,0,55151,0,26124),
(96653,'Quickly, grab them!','',0,0,0,0,0,0,0,0,0,0,55202,0,26124),
(96654,'Another morsel has come to say, hello.','',0,0,0,0,0,0,0,0,0,0,55203,0,26124),
(96655,'Help! Baddies here!','',0,0,0,0,0,0,0,0,0,0,55204,0,26124),
(96656,'We\'ll feast on your flesh and devour your soul.','',0,0,0,0,0,0,0,0,0,0,55205,0,26124),
(96657,'Hey! You\'re not supposed to be here.','',0,0,0,0,0,0,0,0,0,0,55206,0,26124),
(96658,'Tasty meats for me to eats.','',0,0,0,0,0,0,0,0,0,0,55207,0,26124),
(96659,'Warn the Brood Queen!','',0,0,0,0,0,0,0,0,0,0,55208,0,26124),
(96660,'I\'ll burn your kneecaps off.','',0,0,0,0,0,0,0,0,0,0,55209,0,26124),
(96661,'The fel you wield will not be enough.','',0,0,0,0,0,0,0,0,0,0,55190,0,26124),
(96662,'You dare attack us here?!','',0,0,0,0,0,0,0,0,0,0,55191,0,26124),
(96663,'For the Legion!','',0,0,0,0,0,0,0,0,0,0,55192,0,26124),
(96664,'For Brood Queen Tyranna. For the Legion!','',0,0,0,0,0,0,0,0,0,0,55193,0,26124),
(96665,'Stand still so I can shoot you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96666,'Let\'s see if your shields can stop a bullet!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96667,'Why do you always have to be so blurry?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96668,'You are too late! The corruption is nearly complete!','',0,0,0,0,0,0,15,0,0,0,50438,0,26124),
(96669,'Xavius is the master of this forest now, $c. To enter is to succumb to the Nightmare.','',0,0,0,0,0,0,1,0,0,0,52248,0,26124),
(96670,'Excuse me...','Excuse me...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96671,'<The demon hunter looks as pale as a ghost. He shivers uncontrollably.>','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(96672,'Be at peace.','Be at peace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96673,'Arduen sent me. You\'re free.','Arduen sent me. You\'re free.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96674,'','We were in pursuit of a dangerous dreadlord. Unfortunately, he lured us right into a trap.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(96675,'<The Illidari\'s body is nearly unrecognizable. He was tortured, then died from the wounds.>','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(96676,'','Good luck. I will make my way up to the foothold as soon as I am done with this demon.',0,0,0,0,0,0,0,0,0,0,0,55012,26124),
(96677,'Nethrandamus, take to the skies. Warn us if enemies approach.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(96678,'','Quickly! The archdruid\'s condition is quite serious...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96679,'Completing Ritual','Completing Ritual',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96680,'Use the crucible to complete the ritual.','',0,0,0,0,0,0,0,0,0,0,55242,0,26124),
(96681,'Take me to the nearest invasion point!','Take me to the nearest invasion point!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96682,'I suppose we can offer some assistance.','I suppose we can offer some assistance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96683,'There were few of our brethren who were worthy, but I do not return empty-handed.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(96686,'As powerful as we are, if Faronaar is any indicatio we will not be able to stop the demons alone.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(96687,'I will find any of our brethren with the courage to follow you into battle and do what needs to be done.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(96688,'Ah, a champion arrives in our most dire hour. Welcome.','',0,0,0,0,0,0,3,0,0,0,54289,0,26124),
(96689,'Beliash is protected by those Spires of Woe. You\'ll want to deactivate them.','',0,0,0,0,0,0,0,0,0,0,55230,0,26124),
(96690,'','This bastard leads the guards in this prison. He must pay for his crimes!',0,0,0,0,0,0,0,0,0,0,0,52734,26124),
(96691,'How dare you attack a kaldorei noble? You will beg for mercy, which I will not give.','',0,0,0,0,0,0,0,0,0,0,52249,0,26124),
(96692,'You always did think too highly of yourself. Another foolish death, then, if you insist.','',0,0,0,0,0,0,0,0,0,0,52650,0,26124),
(96693,'|TINTERFACE\\ICONS\\spell_fire_felflamestrike.blp:20|t Archimonde begins to cast |cFFF00000|Hspell:183254|h[Allure of Flames]|h|r!','|TINTERFACE\\ICONS\\spell_fire_felflamestrike.blp:20|t Archimonde begins to cast |cFFF00000|Hspell:183254|h[Allure of Flames]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96695,'A massive gronnling is heading for Rangari Refuge! We are going to require some assistance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96696,'','This is only the beginning.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96697,'I wish to browse your goods.','I wish to browse your goods.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96698,'All clear boys! Here come some extra birds. Set down and prepare to assault the citadel!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96699,'','You heard the commander! Let\'s help clear a landing zone!',22,0,0,15,0,0,0,0,0,0,0,0,26124),
(96700,'Charge!','Charge!',22,0,0,15,0,0,0,0,0,0,0,0,26124),
(96701,'','Begging\'s never been one of my talents, Stareye. You should know that by now.',0,0,0,0,0,0,0,0,0,0,0,52732,26124),
(96702,'Lord Ravencrest himself gave me this post. I won\'t surrender it to you demons!','',0,0,0,0,0,0,0,0,0,0,52250,0,26124),
(96703,'Ravencrest? Impossible! And we\'re not demons. Don\'t you recognize me?','',0,0,0,0,0,0,0,0,0,0,52656,0,26124),
(96704,'','It\'s useless, brother. Like the other undead, he cannot see us for who we are.',0,0,0,0,0,0,0,0,0,0,0,52733,26124),
(96705,'Never mind that. I heard what happened in the Vault of the Wardens. Luckily my hair can\'t get any grayer.','',0,0,0,0,0,0,0,0,0,0,52649,0,26124),
(96706,'Why did you have to chase after Gul\'dan alone? Thank Elune you\'re still alive.','',0,0,0,0,0,0,0,0,0,0,52652,0,26124),
(96707,'','Well said, brother: we have bigger concerns. Let\'s go. Stareye has much to answer for.',0,0,0,0,0,0,0,0,0,0,0,52731,26124),
(96715,'You broke ANOTHER drill!? Where did you get those, Venture Company?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96716,'Keep your helmet on... we are practically through. Just need to kick it a few times and we got our payday!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96717,'You\'re gonna need a sick note tomorrow!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96718,'Quickly, finish the summons.','',0,0,0,0,0,0,0,0,0,0,56990,0,26124),
(96719,'The Legion\'s will be done.','',0,0,0,0,0,0,0,0,0,0,56991,0,26124),
(96720,'Kill the Illidari.','',0,0,0,0,0,0,0,0,0,0,56992,0,26124),
(96721,'For the Brood Queen.','',0,0,0,0,0,0,0,0,0,0,56993,0,26124),
(96722,'Your world will be purged!','',0,0,0,0,0,0,0,0,0,0,56994,0,26124),
(96723,'Our ritual is interrupted.','',0,0,0,0,0,0,0,0,0,0,56995,0,26124),
(96724,'Defend the portal.','',0,0,0,0,0,0,0,0,0,0,56996,0,26124),
(96725,'In Sargeras\'s name.','',0,0,0,0,0,0,0,0,0,0,56997,0,26124),
(96726,'Never should have come to this stinkin\' world...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96727,'Don\'t be tricky now. I hate tricky!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96728,'No tricks! I said no tricks!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96729,'Nothing here for you pal, honest!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96730,'No... my payday...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96731,'Hold still a sec, I can fix that whole \"living\" thing for you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96732,'Ah man I\'m down!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96733,'The huntin\' party is here to help shoot down that cursed bird!','',0,0,0,0,0,0,0,0,0,0,54838,0,26124),
(96734,'You will not stop the spread of the Nightmare!','',0,0,0,0,0,0,36,0,0,0,0,0,26124),
(96735,'','Altruis said you would only take the best. Here we are.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(96736,'The engravings on the shield depict a goddess of the shieldmaidens, watching over them in battle. \n\nAbove her is inscribed the name \"Eyir\".','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96737,'This shield appears to show various trials undergone by the warriors of Skold-Ashil.\n\nA depiction of the nearby temple adorns the center.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96738,'An image of a shieldmaiden is carved on this shield, kneeling before an elaborate spear. \n\nThe priestesses of the temple stand nearby, silently observing the rite.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96739,'The scene on this shield shows one of the shieldmaidens hovering above a statue of an ancient champion of Skold-Ashil.\n\nThe shieldmaiden is glowing with a radiant aura, and is held aloft by golden wings.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96740,'Upon this shield, an engraving of Eyir stands at the entrance to the titan vault. \n\nShe appears to be welcoming a winged champion of the shieldmaidens inside.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96741,'This shield bears an image of a winged shieldmaiden lifting the body of a fallen vrykul from a battlefield.\n\nThe shieldmaiden\'s image appears eerily similar to that of a Val\'kyr.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96742,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96743,'|TINTERFACE\\ICONS\\ability_fixated_state_red.blp:20|t A Doomfire Spirit is |cFFF00000|Hspell:182879|h[Fixated]|h|r on you!','|TINTERFACE\\ICONS\\ability_fixated_state_red.blp:20|t A Doomfire Spirit is |cFFF00000|Hspell:182879|h[Fixated]|h|r on you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(96746,'We will find a Legion gateway or die trying.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(96747,'','Spare us the theatrics, won\'t you, Altruis?',0,0,0,0,0,0,11,0,0,0,0,0,26124),
(96748,'Ah, get behind me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96749,'I\'m flyin\'!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96750,'Did someone say bomb?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96751,'Special DELIVERY!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96752,'You have no power over me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96753,'You demons picked the wrong gnome to mess with!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96754,'Our blades have been honed for millennia. This world will fall!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96758,'Don\'t let them into the tower!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96759,'Keep them out of here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96760,'I\'ll be damned if those demons think they can take the tower!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96766,'Aye commander, we can divert resources from any of your nearby outposts for use here in Tanaan. Ye\' just let me know which one ye\' want!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96767,'Call to Arms.','Call to Arms.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96768,'Guardian Orb.','Guardian Orb.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96769,'Artillery Strike.','Artillery Strike.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96770,'Champion\'s Honor.','Champion\'s Honor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96771,'The Mechashredder.','The Mechashredder.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96772,'DO NOT TRANSLATE','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96773,'The structure cracks under pressure, exploding and releasing large amounts of fel energy into the sky.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96775,'Aye, Commander, I\'d like to talk to you about bringing some of our reinforcements here to Tanaan, if ye\' have a minute.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96776,'Hey there, Commander. We\'ve got some extra supplies I can call in to help out, if you give the order.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96777,'We\'ve got supplies from our nearby outposts that we can call in, now that most of the heat is taking place here. Which supplies did you want to bring over?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96779,'Time I stood up, got out there and helped! Ah, what\'s the use?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96780,'Great spot, great view - just me and the end of the world!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96781,'Here we come! This is it! It\'s the end of the world as we know it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96785,'You\'re gonna wear that hideous outfit today?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96786,'Do you really need to be carrying ALL that stuff around?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96787,'You should write to your mother. She\'s worried sick about you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96788,'I don\'t understand why you have critters fight other critters when you could do a much better job yourself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96789,'If I get you to where you want to go, will you agree to leave me alone?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96790,'You wanna get out of here? I\'ll get you out of here, but I\'m not making any promises on where you go.','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(96791,'Sure, I trust a demon to send me to a safe location.','Sure, I trust a demon to send me to a safe location.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96792,'','You found it! Thank you, traveler.$B$B<Syndrelle pauses for a moment.>$B$BOn second thought, I would rather you keep it and think of it as a reminder of our new friendship.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96793,'','Hello traveler. I\'ve lost my favorite charm somewhere around here. I don\'t suppose that you\'d be willing to help me look for it?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96794,'I\'d be happy to help.','I\'d be happy to help.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96795,'You must go ahead - Nethrandamus stayed with the others so I will only slow you down. Go!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(96796,'','This is so exciting!',0,0,0,0,0,0,603,0,0,0,0,54842,26124),
(96797,'','Don\'t worry, I can talk and shoot at the same time!',0,0,0,0,0,0,1,0,0,0,0,54854,26124),
(96798,'','Do rifles always have this much recoil?',0,0,0,0,0,0,1,0,0,0,0,54841,26124),
(96799,'','You make it look so easy!',0,0,0,0,0,0,1,0,0,0,0,54839,26124),
(96803,'It\'s a fine day for a hunt.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(96804,'It doesn\'t get much better than this; the smell of fresh pine in the breeze, an abundance of game to be hunted.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(96805,'','$n has arrived. For the Illidari!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(96806,'Help! Please!','Help! Please!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96807,'Please, save me!','Please, save me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96808,'They won\'t leave me alone...','They won\'t leave me alone...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96809,'Get me out of here!','Get me out of here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96810,'Please... help me...','Please... help me...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96811,'My services are yours if you help me escape!','My services are yours if you help me escape!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96812,'I shouldn\'t have come out here all alone!','I shouldn\'t have come out here all alone!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96813,'I don\'t want to go out like this...','I don\'t want to go out like this...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96814,'|TInterface\\Icons\\ability_vehicle_siegeenginecannon.blp:20|t A %s is slightly damaged!','|TInterface\\Icons\\ability_vehicle_siegeenginecannon.blp:20|t A %s is slightly damaged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96815,'|TInterface\\Icons\\ability_vehicle_siegeenginecannon.blp:20|t A %s is severely damaged!','|TInterface\\Icons\\ability_vehicle_siegeenginecannon.blp:20|t A %s is severely damaged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96816,'|TInterface\\Icons\\ability_vehicle_siegeenginecannon.blp:20|t A %s is critically damaged!','|TInterface\\Icons\\ability_vehicle_siegeenginecannon.blp:20|t A %s is critically damaged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96817,'','The Burning Legion will fall.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96818,'You are spotted by the %s!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(96819,'My blades thirst for the blood of the Legion!','My blades thirst for the blood of the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96820,'You shall perish!','You shall perish!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96821,'Your advances are ill-advised.','Your advances are ill-advised.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96822,'You will witness true power!','You will witness true power!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96823,'You will pray for a swift death!','You will pray for a swift death!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96824,'','I don\'t trust a gnome with a gun. \n\nAddie\'s more likely to shoot you than any of her intended targets.',11,0,0,2,0,0,0,0,0,0,0,0,26124),
(96825,'','It... it must be around here somewhere!',0,0,0,0,0,0,0,0,0,35394,0,0,26124),
(96826,'','Maybe the current moved it...',0,0,0,0,0,0,0,0,0,35394,0,0,26124),
(96827,'','Where could it have gone?',0,0,0,0,0,0,0,0,0,35394,0,0,26124),
(96828,'','By the antlers of Cenarius! Where is it?',0,0,0,0,0,0,0,0,0,35394,0,0,26124),
(96829,'','Don\'t you ever listen to your elders, $c? No matter, you did save my life.$B$BLet me rest a while. I\'ll be fine, just wait.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96830,'','I\'ll be fine, $c. Turn back. This is my score to settle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96831,'Score? Don\'t be a fool. You are badly injured.','Score? Don\'t be a fool. You are badly injured.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96832,'Gorefiend begins to cast |TInterface\\Icons\\spell_misc_zandalari_council_soulswap:20|t |cFFFF0404|Hspell:181973|h[Feast of Souls]|h|r!','Gorefiend begins to cast |TInterface\\Icons\\spell_misc_zandalari_council_soulswap:20|t |cFFFF0404|Hspell:181973|h[Feast of Souls]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96833,'How ya doin\'?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96834,'Time for a workout!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96835,'Anyone up for sketch group?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96836,'Oh ho ho. Well looky here. We got ourselves something new to hunt.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(96837,'Now I find you spending your last moments with this, this beast.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(96838,'I shalll enjoy putting you down.','',0,0,0,0,0,0,153,0,0,0,0,0,26124),
(96840,'','You should have listened... On your guard, $c.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96841,'This ancient moonwell has seen better days, but its waters still glow with the radiant  moonlight of Elune.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96842,'','Stand back. I do not need your assistance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96843,'Welcome to sketch group! Grab an easel, get comfortable. No judgments here - unless you\'re a Paladin, of course.$b$bToday we\'re studying the nexus. Such beauty! Such chaos! So much... blue.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(96844,'','Even though these woods have been lost to the corruption of Shaladrassil, this is still our home.$b$bThe fate of the forest is ours to share.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96846,'','That wasn\'t necessary of ya, but you have my thanks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96848,'Charge!','Charge!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96849,'Hyyeeaahhhaaay!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96850,'Take up the blade, Arthas Menethil. Embrace your destiny!','',0,0,0,0,0,0,1,0,0,0,64190,0,26124),
(96851,'Yes... you are right... I will bear any curse to have my revenge...','',0,0,0,0,0,0,1,0,0,0,64170,0,26124),
(96852,'','Insolent dog!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96853,'','You will suffer for this! Bring me his head!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(96854,'What? An intruder! You won\'t stop me! Frostmourne will be mine!','',0,0,0,0,0,0,25,0,0,0,64171,0,26124),
(96855,'To arms! Lord Felsoul must not be disturbed.','',0,0,0,0,0,0,0,0,0,0,52013,0,26124),
(96856,'Face me, Banshee Queen. Answer for your crimes!','',0,0,0,0,0,0,0,0,0,0,52942,0,26124),
(96857,'The demons underestimate your power. Punish them for their hubris!','',0,0,0,0,0,0,0,0,0,0,52028,0,26124),
(96858,'How dare you interfere! His soul belongs to ME!','',0,0,0,0,0,0,603,0,0,0,64191,0,26124),
(96860,'Argh! The darkness... I can\'t... I...','',0,0,0,0,0,0,0,0,0,0,64172,0,26124),
(96861,'ARRGHHHHHH!!!','',0,0,0,0,0,0,15,0,0,0,64173,0,26124),
(96866,'Bathe them in hellfire! Halt their advance!','',0,0,0,0,0,0,0,0,0,0,52047,0,26124),
(96867,'','It\'s about time I put you down, Greymane!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96868,'','Azshara kept her secrets well. By the time I saw the demons first-hand, it was already too late.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96869,'','The Queen\'s thirst for power doomed us all.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96870,'Ishnu-dal-dieb, traveler.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96871,'So many worlds... so many layers of existence...','',0,0,0,0,0,0,0,0,0,0,50616,0,26124),
(96872,'In the end, they become nothingness... or, perhaps...','',0,0,0,0,0,0,0,0,0,0,50617,0,26124),
(96873,'They will BURN! Die! The master wills it!','',0,0,0,0,0,0,0,0,0,0,50618,0,26124),
(96874,'No matter how it all ends, you will die here.','',0,0,0,0,0,0,0,0,0,0,50610,0,26124),
(96875,'I have so much to show you...','',0,0,0,0,0,0,0,0,0,0,50611,0,26124),
(96876,'Servants of the Void! Swallow this world!','',0,0,0,0,0,0,0,0,0,0,50619,0,26124),
(96877,'All life must decay.','',0,0,0,0,0,0,0,0,0,0,50620,0,26124),
(96878,'Corruption! Flame! Ash!','',0,0,0,0,0,0,0,0,0,0,50621,0,26124),
(96879,'LEGION! Destroy all who stand before you!','',0,0,0,0,0,0,0,0,0,0,50622,0,26124),
(96880,'I TEAR APART! AND WITH ME, YOU TOO SHALL DIE!','',0,0,0,0,0,0,0,0,0,0,50623,0,26124),
(96881,'These gaps in reality... I must tear them wider!','',0,0,0,0,0,0,0,0,0,0,50613,0,26124),
(96882,'All will be swallowed! No life shall remain!','',0,0,0,0,0,0,0,0,0,0,50614,0,26124),
(96883,'I cannot remain... I am becoming... EVERYTHING! NOTHING!','',0,0,0,0,0,0,0,0,0,0,50615,0,26124),
(96884,'BURN!','',0,0,0,0,0,0,0,0,0,0,50624,0,26124),
(96885,'RIP APART!','',0,0,0,0,0,0,0,0,0,0,50625,0,26124),
(96886,'I CANNOT... CONTAIN...','',0,0,0,0,0,0,0,0,0,0,50626,0,26124),
(96887,'IT OVERWHELMS ME!','',0,0,0,0,0,0,0,0,0,0,50627,0,26124),
(96888,'YES! YES! I SEE IT! I can see... the... end...','',0,0,0,0,0,0,0,0,0,0,50612,0,26124),
(96889,'This world will not fall so easily, demon. Its people will not give up without a fight. Our will is unbreakable! For Draenor!','',0,0,0,0,0,0,0,0,0,0,50803,0,26124),
(96890,'Lok\'tar ogar! They are pushed back! To the portal! Gul\'dan is mine!','',0,0,0,0,0,0,0,0,0,0,50804,0,26124),
(96891,'The final hour is at hand, the master comes! This is your purpose, summoners. Mannoroth will be whole again!','',0,0,0,0,0,0,0,0,0,0,51151,0,26124),
(96892,'The wrath of the legion will destroy you!','',0,0,0,0,0,0,0,0,0,0,51152,0,26124),
(96893,'Your failure will please the master!','',0,0,0,0,0,0,0,0,0,0,51153,0,26124),
(96894,'Death awaits...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96895,'I\'d like to purchase Seals of Tempered Fate.','I\'d like to purchase Seals of Tempered Fate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96896,'Finish the portal, damn you! We must protect the wards!','',0,0,0,0,0,0,0,0,0,0,52049,0,26124),
(96897,'','Thanks! Let\'s get to work. Here kitty, kitty, kitty...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96898,'','Seek out Maladaar in the west. I fear he may have encountered the brunt of Gul\'dan\'s forces.',1,0,0,0,0,0,0,0,0,0,0,50584,26124),
(96899,'','Find my husband in the battlefield to the west! I pray our losses were not too great.',5,0,0,0,0,0,5,0,0,0,0,50347,26124),
(96900,'Let the darkness consume you! Feast upon the souls of the damned!','',0,0,0,0,0,0,603,0,0,0,64192,0,26124),
(96902,'Here! This is a perfect natural harbor.','',0,0,0,0,0,0,25,0,0,0,50555,0,26124),
(96903,'Many of the souls freed by Frostmourne\'s destruction wander the halls of Icecrown, lashing out in eternal torment.','',0,0,0,0,0,0,0,0,1,0,52482,0,26124),
(96904,'|TInterface\\Icons\\spell_shadow_deadofnight.blp:20|t Cull the scourge before they are sacrificed!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(96905,'Use |TInterface\\Icons\\spell_shadow_antimagicshell.blp:20|t |cFF2959D3|Hspell:184366|h[Anti-Magic Shell]|h|r to avoid harmful spells!','Use |TInterface\\Icons\\spell_shadow_antimagicshell.blp:20|t |cFF2959D3|Hspell:184366|h[Anti-Magic Shell]|h|r to avoid harmful spells!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(96906,'Exposition','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96907,'Our people look to us for aid. Make these foul creatures regret the day they invaded our world!','',0,0,0,0,0,0,1,0,0,0,52205,0,26124),
(96908,'These demons think us easy prey. Today they will learn that the kaldorei stand down to no one.','',0,0,0,0,0,0,1,0,0,0,52206,0,26124),
(96909,'Warriors, you pledged your blades to the House of Ravencrest. Today, we take up arms and fight!','',0,0,0,0,0,0,1,0,0,0,52207,0,26124),
(96910,'Rally to me, soldiers! No matter the foes we face, Black Rook Hold shall not fall!','',0,0,0,0,0,0,1,0,0,0,52208,0,26124),
(96911,'Stand firm, champions! Our might is tested, but we shall prevail!','',0,0,0,0,0,0,1,0,0,0,52209,0,26124),
(96912,'You have gone far enough, mortal. This ends here.','',0,0,0,0,0,0,0,0,0,0,52022,0,26124),
(96913,'Another prisoner for my cells? Looks like I\'ll need to break you first!','',0,0,0,0,0,0,0,0,0,0,52210,0,26124),
(96914,'Intruder! Sound the alarm!','Intruder! Sound the alarm!',0,0,0,0,0,0,0,0,0,0,60989,0,26124),
(96915,'I\'ve been training for this moment!','I\'ve been training for this moment!',0,0,0,0,0,0,0,0,0,0,60988,0,26124),
(96916,'You\'ll get no further, invader!','You\'ll get no further, invader!',0,0,0,0,0,0,0,0,0,0,60987,0,26124),
(96917,'This world has no place for you, demon!','This world has no place for you, demon!',0,0,0,0,0,0,0,0,0,0,60986,0,26124),
(96918,'Your kind is not welcome here!','Your kind is not welcome here!',0,0,0,0,0,0,0,0,0,0,60985,0,26124),
(96919,'I\'ll wipe your blood off my blade, just like the rest!','I\'ll wipe your blood off my blade, just like the rest!',0,0,0,0,0,0,0,0,0,0,60984,0,26124),
(96920,'I have slain hundreds before you. You\'ll simply be one more notch on my belt.','I have slain hundreds before you. You\'ll simply be one more notch on my belt.',0,0,0,0,0,0,0,0,0,0,60983,0,26124),
(96921,'I will grant you a swift death, trespasser.','I will grant you a swift death, trespasser.',0,0,0,0,0,0,0,0,0,0,60982,0,26124),
(96922,'','I never miss!',0,0,0,0,0,0,0,0,0,0,0,52219,26124),
(96923,'','Stop, interloper. I\'ll make you bleed first!',0,0,0,0,0,0,0,0,0,0,0,52220,26124),
(96924,'','My strike is swift and true!',0,0,0,0,0,0,0,0,0,0,0,52221,26124),
(96925,'','If you won\'t return to your world, I\'ll send you there in pieces!',0,0,0,0,0,0,0,0,0,0,0,52222,26124),
(96926,'','Enjoy this moment. It will be your last!',0,0,0,0,0,0,0,0,0,0,0,52223,26124),
(96927,'','The lieutenant has ordered your execution.',0,0,0,0,0,0,0,0,0,0,0,52224,26124),
(96928,'$n... it\'s been years. You should know better than to stand against me.','',0,0,0,0,0,0,0,0,0,0,52045,0,26124),
(96929,'My master has granted me many gifts. Witness the power of the Deceiver!','',0,0,0,0,0,0,0,0,0,0,52005,0,26124),
(96930,'Each Vision of Death rune needs someone within it to avoid raid damage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(96931,'Over here, $c! Your help is needed inside!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(96932,'I will personally deal with their leader, my queen.','',0,0,0,0,0,0,0,0,6,0,55141,0,26124),
(96933,'I almost... made it... out...','',0,0,0,0,0,0,0,0,0,0,52225,0,26124),
(96934,'Welcome to the Scribes\' Sacellum!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96935,'Deucus said you owe him a favor. I have a tome in need of translation.','Deucus said you owe him a favor. I have a tome in need of translation.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96937,'Skyhorn, to me!','',0,0,0,0,0,0,0,0,0,0,54293,0,26124),
(96938,'Ha! Now that was a battle.','',0,0,0,0,0,0,0,0,0,0,54300,0,26124),
(96939,'The differences that have set the Arakkoa apart for years seem so trivial today. We have squandered the might of our people on fear and mistrust of one another when we should have been looking beyond the safety of Skyreach. There is nothing to be done about the past, but know that there are some who wish for our people to be more than a footnote to what Gul\'dan has wrought.\n\nI will help you, $c. We must all help one another now, or this world is doomed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96940,'I suppose I do owe that blowhard a favor. Lucky for you, translation is my specialty!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(96941,'This is ancient vrykul script, the property of someone named \"Svena\". A rare and intriguing find indeed. Tell Deucus he is now in MY debt!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(96942,'','I\'m sorry to hear that Arduen didn\'t make it. I will make sure the demons pay for his death.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(96943,'Who dares stand against the might of the Legion?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96944,'Come, champion. Let us pluck this Witchqueen from her throne.','',0,0,0,0,0,0,0,0,0,0,54298,0,26124),
(96945,'You handle the Witchqueen. We will contend with her brood.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96946,'Finally, I can rest.','Finally, I can rest.',0,0,0,0,0,0,1,0,0,0,0,52226,26124),
(96947,'','See that you do.',0,0,0,0,0,0,0,0,6,0,0,55075,26124),
(96948,'Quel\'Thalas will never fall!','Quel\'Thalas will never fall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96949,'You are not welcome here!','You are not welcome here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96950,'You shall not pass!','You shall not pass!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96951,'The king may have fallen but I will never abandon Lordaeron!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96952,'You an\' that prince of yours are gonna pay for what he did to ole\' Muradin!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96953,'The Light... no...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96954,'You unholy monster! The righteous fury of the Light will tear you apart!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96955,'Peace... at... last...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96956,'The Silver Hand will remove your blight from this world!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96957,'The pain... is over...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96958,'To arms soldiers of Quel\'Thalas! The enemy is at our very doorstep!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96959,'Ah, $n. So the Lich King chose you to be his hand? I\'m not surprised. We have all heard of your exploits.','',0,0,0,0,0,0,669,0,0,0,61923,0,26124),
(96960,'Our forces have gathered from all across Northrend. When the call to action comes... and it will come soon... the Knights of the Ebon Blade will be ready.','',0,0,0,0,0,0,669,0,0,0,61924,0,26124),
(96961,'Make no mistake, we are not bound to this new Lich King. However, he may prove a valuable ally against the Legion.','',0,0,0,0,0,0,603,0,0,0,61925,0,26124),
(96962,'The gates of Icecrown lie to the north. Do not keep our ally waiting!','',0,0,0,0,0,0,1,0,0,0,61927,0,26124),
(96964,'For now, our goals align with his. And in the meantime, it is in our best interests that the Scourge stay... contained.','',0,0,0,0,0,0,273,0,0,0,61926,0,26124),
(96968,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\LFGFRAME\\LFGICON-SUNWELL.BLP:50:80|t$bI will have my revenge!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96969,'|TINTERFACE\\ICONS\\ability_warlock_moltencoregreen.blp:20|t $n is marked with |cFFF00000|Hspell:186961|h[Nether Banish]|h|r!','|TINTERFACE\\ICONS\\ability_warlock_moltencoregreen.blp:20|t $n is marked with |cFFF00000|Hspell:186961|h[Nether Banish]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(96970,'|TINTERFACE\\ICONS\\spell_misc_zandalari_council_soulswap.blp:20|t You are marked with |cFFF00000|Hspell:186123|h[Wrought Chaos]|h|r!','|TINTERFACE\\ICONS\\spell_misc_zandalari_council_soulswap.blp:20|t You are marked with |cFFF00000|Hspell:186123|h[Wrought Chaos]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(96971,'|TINTERFACE\\ICONS\\spell_shadow_soulleech_1.blp:20|t You are marked with |cFFF00000|Hspell:185014|h[Focused Chaos]|h|r!','|TINTERFACE\\ICONS\\spell_shadow_soulleech_1.blp:20|t You are marked with |cFFF00000|Hspell:185014|h[Focused Chaos]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(96972,'Your soul is mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96975,'For Lordaeron!','For Lordaeron!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96976,'Meet your second death, undead filth!','Meet your second death, undead filth!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96977,'Repel the intruder!','Repel the intruder!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96978,'To arms!','To arms!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96981,'Death... really isn\'t so bad.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96982,'What are you afraid of?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96983,'Your death makes me stronger.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96985,'It\'s a fine day for a hunt.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(96986,'The Wardens are searching every corner of the Broken Isles for Gul\'dan.$B$BThey have reason to believe the warlock hides some secret within Black Rook Hold. And if he is here, then so perhaps is my sister, Maiev.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96988,'How strange... Ravencrest\'s army sees us as invaders. It\'s as if they are trapped within their own memories.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96989,'Sira and the other Wardens are doing everything they can to find Maiev.$B$BThe attack on the Vault of the Wardens was devastating. Of hundreds, only a handful survived.$B$BBut the Wardens are tough as steel. They will survive.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(96990,'I refuse to believe it. Lord Ravencrest cannot be working with Gul\'dan.','',0,0,0,0,0,0,1,0,0,0,52227,0,26124),
(96991,'','We must retrieve it. He\'s still my charge. We\'ll have to invade the tower. But it will be no easy task.',0,0,0,0,0,0,1,0,0,0,0,52228,26124),
(96992,'','Champion, return to your other duties for now. Soon we will face Lord Ravencrest himself.',0,0,0,0,0,0,1,0,0,0,0,52229,26124),
(96993,'Slay them all! For the Dark Lady!','',0,0,0,0,0,0,5,0,0,0,51752,0,26124),
(96994,'Hand over the Banshee Queen!','',0,0,0,0,0,0,0,0,0,0,52939,0,26124),
(96995,'Sylvanas! Come and face your executioner!','',0,0,0,0,0,0,0,0,0,0,52941,0,26124),
(96996,'I\'ll reduce this camp to rubble if I have to!','',0,0,0,0,0,0,0,0,0,0,52943,0,26124),
(96997,'','Thank you, hero. I did not expect salvation from this place. Where is my brother?',0,0,0,0,0,0,1,0,0,0,0,52230,26124),
(96998,'Show yourself, Sylvanas!','',0,0,0,0,0,0,0,0,0,0,52944,0,26124),
(96999,'You cannot hide from me!','',0,0,0,0,0,0,0,0,0,0,51707,0,26124),
(97000,'You call us monsters? How rich.','',0,0,0,0,0,0,6,0,0,0,51754,0,26124),
(97001,'Monsters! You have no place in this world!','',0,0,0,0,0,0,0,0,0,0,52938,0,26124),
(97002,'Stop holding back, old man! Show us the real you.','',0,0,0,0,0,0,5,0,0,0,51755,0,26124),
(97003,'I will take out the guards inside the prison. Get those keys and meet me within the cells.','',0,0,0,0,0,0,1,0,0,0,52231,0,26124),
(97004,'Rrgghhh... ENOUGH!','',0,0,0,0,0,0,5,0,0,0,51756,0,26124),
(97005,'I will stay to ease this prisoner\'s passing. It won\'t be long, now. Go ahead and find Maiev.','',0,0,0,0,0,0,1,0,0,35324,52651,0,26124),
(97006,'Take me to Dreadmist Peak!','Take me to Dreadmist Peak!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97007,'','Lieutenant Stareye commands. Death to all intruders!',0,0,0,0,0,0,0,0,0,0,0,52232,26124),
(97008,'We have secured the walls, demon! You will not escape here alive.','',0,0,0,0,0,0,0,0,0,0,52233,0,26124),
(97009,'Test my hammer, and YOU will be the one to break!','',0,0,0,0,0,0,0,0,0,0,52234,0,26124),
(97010,'Ah, there you are!','',0,0,0,0,0,0,5,0,0,0,51757,0,26124),
(97011,'This ends here, Demons!','',22,0,0,15,0,0,0,0,0,0,0,0,26124),
(97012,'Mo\'arg, to the front! This has gone on long enough.','',0,0,0,0,0,0,0,0,0,0,52048,0,26124),
(97013,'','Over here! This sewer will take us back outside. We should go before our enemies regroup.',0,0,0,0,0,0,1,0,0,0,0,52235,26124),
(97014,'What a tragic waste. Even in death, he only wanted to protect our people.','',0,0,0,0,0,0,1,0,0,0,52236,0,26124),
(97015,'','The battle rages throughout Tanaan, Commander. Where shall we focus our attention today?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(97016,'','Gul\'dan is creating his own army of zealots. Where should we strike back?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(97017,'','Gul\'dan will not break us. The Legion will NEVER break us! Today we fight back.',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(97018,'','This jungle hides dangers untold. But if we are wise, we can use it to mask our next attack.',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(97019,'','I have the latest reports from the Rangari right here, commander. Where should we strike?',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(97020,'','Gul\'dan\'s fel minions are closing in around us. We MUST go on the offensive, commander!',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(97021,'','Our warriors are blessed by the light, sure of purpose and hardened by battle. They await your orders.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(97022,'','If this is truly the end of the world, then I, for one, will go out fighting. For Samara, for Maraad, for all those who gave their lives to give us this day!',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(97023,'DIE!','',0,0,0,0,0,0,0,0,0,0,52046,0,26124),
(97024,'My forces are yours.','',0,0,0,0,0,0,0,0,4,0,55046,0,26124),
(97025,'We will assist in establishing the volcano foothold.','',0,0,0,0,0,0,0,0,4,0,55047,0,26124),
(97026,'Ashtongue, forward!','',0,0,0,0,0,0,0,0,4,0,55048,0,26124),
(97027,'You face not Malchezaar alone, but the legions I command!','',0,0,0,0,0,0,0,0,0,0,9322,0,26124),
(97028,'What, good $gsir:madam;, can I do to assist you today?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97029,'Where can I find a Leyflame Burner?','Where can I find a Leyflame Burner?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97030,'Where can I find Advanced Corks?','Where can I find Advanced Corks?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97031,'Where can I find a Dual-Chambered Mixing Flask?','Where can I find a Dual-Chambered Mixing Flask?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97032,'Where can I find Precipitating Powder?','Where can I find Precipitating Powder?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97033,'Where can I find a Shaldorei Silk Filter?','Where can I find a Shaldorei Silk Filter?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97034,'Where can I find a Demonsbreath Crucible?','Where can I find a Demonsbreath Crucible?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97035,'Where can I find Bendy Glass Tubes?','Where can I find Bendy Glass Tubes?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97036,'Where can I find a Malloric Burette?','Where can I find a Malloric Burette?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97037,'Where can I find a High-Capacity Decoction Conduit?','Where can I find a High-Capacity Decoction Conduit?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97038,'I need help finding the replacement alchemy equipment.','I need help finding the replacement alchemy equipment.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97039,'Our alchemy table remains woefully incomplete.$b$bI shall use my extensive knowledge to point you in the direction of replacement parts, but I fear you will have to do some legwork on your own.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97040,'I\'ve heard that someone over in the engineering shop is selling a burner that might be usable. You could likely negotiate a fairer price than I could!$b$bThe shop is just across the street. I\'ll make a note on your map for you.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(97041,'The naga have been known to hoard all manner of potions, so they might have the sort of corks we need. The best place to search is the Eye of Azshara itself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97042,'We require a flask capable of mixing more than reagents. Thoughts, ideas, dreams...$b$bYou may have to search the Emerald Nightmare for such an item!$b$bPLAYTEST CHEAT: CI 127872','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(97043,'It\'s said the ancient vrykul collected such powderfrom the residue of dragon\'s breath. If it\'s true that Neltharion\'s Lair lies somewhere below us, it seems a likely source.$b$bPLAYTEST CHEAT: CI 127874','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(97044,'The delicate yet resilient fabric needed for this sort of filter would come from a place of majesty and power. The locals speak of something called the Halls of Valor... you might investigate.$b$bPLAYTEST CHEAT: CI 127875','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(97045,'Artifacts of such potency are supposedly kept within the Vault of the Wardens. There are whispers of trouble in those halls, so be careful!$b$bPLAYTEST CHEAT: CI 127876','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(97046,'The alchemists of old were known to be buried alongside their implements. Searching within Suramar Crypts may yield results.$b$bPLAYTEST CHEAT: CI 127877','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97047,'That particular burette was designed by Alchemist Mallory of Stormwind. I\'ve heard that similarly valuable equipment might be stored in the Violet Hold.$b$bPLAYTEST CHEAT: CI 127878','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(97048,'Often rare finds only come from the darkest of places, $n. Dare I speak the name aloud? Venture into Helheim... if you dare!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(97049,'Queue for dungeon','Queue for dungeon',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97050,'Queue for heroic dungeon','Queue for heroic dungeon',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97051,'Nicely done! Patricia has a new recipe for you, $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97052,'How dare you speak to me!','How dare you speak to me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97053,'I can only laugh that you mortals keep holding on. The master even foresaw the coming of these days.','I can only laugh that you mortals keep holding on. The master even foresaw the coming of these days.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97054,'Pathetic. Begone from my sight... I can\'t stand grovelers.','Pathetic. Begone from my sight... I can\'t stand grovelers.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97055,'You are afflicted with |TInterface\\Icons\\Spell_Shadow_ChillTouch.blp:20|t |cFFFF0404|Hspell:189434|h[Touch of Doom]|h|r!','You are afflicted with |TInterface\\Icons\\Spell_Shadow_ChillTouch.blp:20|t |cFFFF0404|Hspell:189434|h[Touch of Doom]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(97056,'|cFFFF0000|Hspell:181295|h[Digest]|h|r killed you.  Run to the center to escape before the timer expires!','|cFFFF0000|Hspell:181295|h[Digest]|h|r killed you.  Run to the center to escape before the timer expires!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(97059,'Grah - uh COMMANDER! Yes commander! Zug zug!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97063,'<This grunt is oblivious to your presence, and is slumped against the wall dozing.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97064,'WAKE UP! Or I\'ll have you cleaning latrines before you can say \"ready to work!\"','WAKE UP! Or I\'ll have you cleaning latrines before you can say \"ready to work!\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97068,'Master... I have... failed...','',0,0,0,0,0,0,0,0,0,0,52037,0,26124),
(97070,'','This is pretty much the best day ever!',0,0,0,0,0,0,603,0,0,0,0,54850,26124),
(97071,'Curse Helya! Curse her cowardly followers! I\'ll not rest until she is dead!','',0,0,0,0,0,0,0,0,14,0,60406,0,26124),
(97073,'','You can\'t beat the thrill of hunting something ten times your size!',0,0,0,0,0,0,1,0,0,0,0,54849,26124),
(97074,'','Should we take a S.E.L.F.I.E.?',0,0,0,0,0,0,1,0,0,0,0,54847,26124),
(97075,'','On to the next one!',0,0,0,0,0,0,1,0,0,0,0,54846,26124),
(97078,'','I\'m feeling a bit more comfortable with my rifle.',0,0,0,0,0,0,1,0,0,0,0,54855,26124),
(97080,'I was Illidari once... left for dead at the Black Temple. Now you will witness the might of my new master!','',0,0,0,0,0,0,0,0,6,0,52043,0,26124),
(97081,'','We\'re not going in there, are we?',0,0,0,0,0,0,1,0,0,0,0,54851,26124),
(97082,'So, Illidari, you seek my head, that you might take the Twinblades as your own? Allow me to introduce you to their power... personally.','',0,0,0,0,0,0,0,0,0,0,52021,0,26124),
(97083,'Join me! Unleash your true power. Do not let the weak hold you back!','',0,0,0,0,0,0,0,0,0,0,52016,0,26124),
(97084,'Behold the might of the Deceiver! Behold the glory of the demon within!','',0,0,0,0,0,0,0,0,0,0,52027,0,26124),
(97085,'I am a GOD! KNEEL BEFORE ME!','',0,0,0,0,0,0,0,0,0,0,58252,0,26124),
(97086,'Beasts all over the ship! Put them down!','',0,0,0,0,0,0,5,0,0,0,51746,0,26124),
(97087,'Feel the icy chill of death around you!','',0,0,0,0,0,0,15,0,0,0,64174,0,26124),
(97088,'<Skoller pelts you in the face with several nuts before realizing you\'re not a squirrel.>$b$bOh, hello friend. Even in the heart of a war-torn jungle, it\'s important to take care of the little ones.','',1,6,0,0,0,0,0,0,0,0,0,0,26124),
(97089,'<Skoller pelts you in the face with several nuts before realizing you\'re not a squirrel.>$b$bOh, hello friend. Even in the heart of a war-torn jungle, it\'s important to take care of the little ones.$b$bHey... c\'mere. Since you took the time to say hello... Would you like a gift?','',1,6,0,0,0,0,0,0,0,0,0,0,26124),
(97090,'Yes I would! You, sir, are a gentleman and a ... Skoller.','Yes I would! You, sir, are a gentleman and a ... Skoller.',1,6,0,0,0,0,0,0,0,0,0,0,26124),
(97091,'Stand at attention! Commander $p is here.','Stand at attention! Commander $p is here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97092,'Garrison: Shipyard Construction','Garrison: Shipyard Construction',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97093,'Tanaan Jungle: The Invasion Begins','Tanaan Jungle: The Invasion Begins',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97094,'Tanaan Jungle: The Founding of Lion\'s Watch','Tanaan Jungle: The Founding of Lion\'s Watch',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97095,'Tanaan Jungle: The Founding of Vol\'mar','Tanaan Jungle: The Founding of Vol\'mar',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97096,'Hellfire Citadel: Gul\'dan\'s Plan','Hellfire Citadel: Gul\'dan\'s Plan',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97097,'Hellfire Citadel: Victory in Draenor!','Hellfire Citadel: Victory in Draenor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97098,'The explosives are set! Get to a safe distance and detonate them!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(97099,'The portal shimmers with images of the citadel.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97100,'Teleport to the Hellfire Antechamber.','Teleport to the Hellfire Antechamber.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97101,'Teleport to the Court of Blood.','Teleport to the Court of Blood.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97102,'Curse you, interloper! All my plans... ruined!','',3,0,0,0,0,0,603,0,0,0,64176,0,26124),
(97105,'Teleport to upper Hellfire Citadel.','Teleport to upper Hellfire Citadel.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97106,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-King Ymiron.blp:50:80|t$bReady are you? Let us see!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97107,'Gladly, my master!','',0,0,0,0,0,0,0,0,0,0,58253,0,26124),
(97108,'Send me to Destructor\'s Rise.','Send me to Destructor\'s Rise.',51,0,0,0,0,0,0,0,0,0,0,0,26124),
(97109,'You are victorious! Khadgar was watching the island, but the demons blocked us somehow for teleporting earlier. I should have known you would need no assistance.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(97110,'Teleport to the Destructor\'s Rise.','Teleport to the Destructor\'s Rise.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97111,'Teleport to the Black Gate.','Teleport to the Black Gate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97112,'How may I aid you, $c?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97113,'A single gunship? Are they insane?','',0,0,0,0,0,0,6,0,0,0,51742,0,26124),
(97114,'I wish to return to the Iron Bulwark.','I wish to return to the Iron Bulwark.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97115,'He put up quite a fight, but your archdruid belongs to me now...','',0,0,0,0,0,0,1,0,0,0,52177,0,26124),
(97116,'The other one put up quite a struggle.','',0,0,0,0,0,0,0,0,0,0,52178,0,26124),
(97117,'This will not be the last ally you lose. Even rats abandon a sinking ship.','',0,0,0,0,0,0,0,0,0,0,52179,0,26124),
(97118,'Lord Varedis will not rest until your heads decorate his throne!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97119,'Gryphons incoming! Man that catapult!','',0,0,0,0,0,0,5,0,0,0,51743,0,26124),
(97120,'','This one is unfortunately resilient. Ready when you are.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(97121,'The mixture in those vials is extremely volatile. Once you pop the cork, there\'s no containing it.','',0,0,0,0,0,0,1,0,0,0,51749,0,26124),
(97122,'Place a few vials near their ammunition - before long, the ship will be tearing itself apart from the inside.','',0,0,0,0,0,0,1,0,0,0,51750,0,26124),
(97123,'We will have our revenge, but I\'m far more interested in the blades the demon spoke of.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97124,'Meet me on deck when the vials are in place. There is someone here I want to kill personally...','',0,0,0,0,0,0,1,0,0,0,51751,0,26124),
(97125,'Just think of the power they could hold... power you could use to destroy the Legion.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97126,'We will meet you at Krasus\' Landing. The hunt begins.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97127,'It\'s clobbering time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97128,'','Give me a moment to catch my breath, hero. The long years of vigil have taken their toll.',0,0,0,0,0,0,0,0,0,0,0,52180,26124),
(97129,'The dreamworg phases into reality!','The dreamworg phases into reality!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97130,'','Damnit! We\'re sitting ducks out here!',0,0,0,0,0,0,5,0,0,0,0,51740,26124),
(97131,'','Show yourselves you cowards...',0,0,0,0,0,0,1,0,0,0,0,52937,26124),
(97133,'','More outsiders in my skies?! Die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97134,'I\'ll find a way to repay you, I swear!','I\'ll find a way to repay you, I swear!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97135,'A free rescue? You\'re some kind of hero!','A free rescue? You\'re some kind of hero!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97136,'Is it over? Can I go home now?','Is it over? Can I go home now?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97137,'Behold the infinite power of the Twinblades!','',0,0,0,0,0,0,0,0,0,0,52044,0,26124),
(97138,'Xandris has seen his last moonrise!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97139,'After the War of Ancients, the surviving satyrs were assembled together. I argued to execute them for their transgressions, but our merciful nature won the day. I was overruled.$b$bInstead, the satyrs were placed in an eternal sleep deep below the roots of Shaladrassil. Now, somehow, they have awoken.$B$BWe shall not make the same mistake again, if I must kill them all myself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97140,'<Thaon snarls> These satyrs should never have been allowed to live.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97141,'My lands suffer because of the council\'s shortsightedness...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97142,'These satyrs should never have been allowed to live. A demon can never be redeemed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97143,'The council foolishly decided to banish the satyrs deep below the roots of the World Tree.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97144,'Now, thousands of years later, some malevolent force has broken their bonds, rousing these demons to fight us once again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97145,'I will not stand idly by and watch my home succumb to this corruption!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97146,'We will correct the mistakes of the past and slay these satyrs. I will see their blood as payment for their curse!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97147,'With our combined might, we will destroy their demonic presence once and for all. They cannot hope to stand against us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97148,'For the World Tree! For Val\'sharah!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97149,'Target acquired!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97150,'I\'ve got you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97151,'Get out!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97152,'Arthas is healed when the scourge are sacrificed to Frostmourne!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(97153,'','I am relieved to see my brethren safe. The satyr have been defeated, but our fight is only beginning, I\'m afraid.$B$BIf what they said was true, then our vigil within the Emerald Dream must continue, with even greater urgency than before.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97154,'','I saw the signs early, but I was trapped within the dream. If only I had warned them sooner!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97155,'Begone from here, outsider!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(97156,'Over here, champion! Malorne himself has blessed this gazebo\'s flame.','Over here, champion! Malorne himself has blessed this gazebo\'s flame.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97157,'Merely touch the brazier, and you will be fortified for the battles ahead.','Merely touch the brazier, and you will be fortified for the battles ahead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97158,'Consuming','Consuming',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(97159,'|TInterface\\Icons\\warlock_curse_shadow_aura:20|t%s begins to cast |cFFFF0000|Hspell:186348|h[Wrath of Gul\'dan]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(97164,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\LFGFRAME\\LFGICON-SUNWELL.BLP:50:80|t$bBurn to Ashes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(97165,'I\'ll wager a good amount of gold that she\'ll shoot $n before she shoots her target!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97167,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\LFGFRAME\\LFGICON-SUNWELL.BLP:50:80|t$bYou arrogant insect, you think your pathetic blades will harm me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97168,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\LFGFRAME\\LFGICON-SUNWELL.BLP:50:80|t$bI do not have time to waste with this distraction. Felguards, cut this one down!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(97169,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\LFGFRAME\\LFGICON-SUNWELL.BLP:50:80|t$bThe end has come!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(97170,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\LFGFRAME\\LFGICON-SUNWELL.BLP:50:80|t$bEnough! You only delay the inevitable!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97171,'','Bat Handler Alzyzek calls forth a Screeching Felbat to rally nearby Legion forces!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97172,'','Meddlesome worgen, you should have let the flames take you.',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(97173,'|TINTERFACE\\ICONS\\TRADE_ENGINEERING.BLP:50|tA plume from Malfurion\'s coat... he may be close. You must continue the search!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97174,'|TINTERFACE\\ICONS\\TRADE_ENGINEERING.BLP:50|tAnother of Malfurion\'s plumes... and signs of a struggle. We must find him before it is too late!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97175,'|TINTERFACE\\ICONS\\TRADE_ENGINEERING.BLP:50|tClear signs of a confrontation... but Malfurion is not to be found...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97176,'','Enjoy your last moments as my venom destroys you from the inside. I delight to know how much you will suffer.',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(97177,'','Let us leave this place, $c.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97178,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97179,'For Honor!','For Honor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97180,'These lands will not succumb to your kind.','These lands will not succumb to your kind.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97181,'Your presence is not welcome in our lands!','Your presence is not welcome in our lands!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97182,'Dey not gone take dis land from us. Dat be the truth, mon.','Dey not gone take dis land from us. Dat be the truth, mon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97183,'Maybe dey got de ships, but we got de lands, tools, and we got eacho\'da.','Maybe dey got de ships, but we got de lands, tools, and we got eacho\'da.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97184,'','Ysera is attacking the Temple of Elune!$b$bWe must stop her before the temple is completely destroyed... we don\'t have much time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97185,'I am ready to begin the defense of the temple!','I am ready to begin the defense of the temple!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97186,'Ain\'t nobody \'fraid o\' dem Legion.','Ain\'t nobody \'fraid o\' dem Legion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97187,'If dey want war, we gonna bring \'em war.','If dey want war, we gonna bring \'em war.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97188,'Ain\'t nobody gone sit at home durin\' these times. Everybody gonna fight.','Ain\'t nobody gone sit at home durin\' these times. Everybody gonna fight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97189,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97190,'I know, Koru. I sense them too, but worry is for the weak. The Legion will not succeed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97191,'We\'ve known these lands for so long...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97192,'It is good that you arrived when you did. Our walls can\'t take much more of a beating from Greymane\'s cannons.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97193,'Koru, you must remain calm. These are our lands. Our people... we will not be defeated.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97194,'Excellent! With the cannons stopped, we can press our advance. \n\nNow we just need to find a way to take out his ship for good...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97195,'I could feel that explosion from here! \n\nThat Gilnean bastard never knew what hit him!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97196,'The disturbed tomb, demons here at Black Rook Hold, and the enemy night elves are no coincidence.$B$BThe Legion has resurrected Lord Ravencrest. My former master lives again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97197,'|TINTERFACE\\ICONS\\inv_enchant_voidsphere.blp:20|t A Void Star is |cFFF00000|Hspell:189894|h[Fixated]|h|r on you!','|TINTERFACE\\ICONS\\inv_enchant_voidsphere.blp:20|t A Void Star is |cFFF00000|Hspell:189894|h[Fixated]|h|r on you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(97198,'Fun to smash small people.','',0,0,0,0,0,0,0,0,0,0,52663,0,26124),
(97199,'Plainsland Cheetah voraciously defends its kin.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97200,'You\'ll make a fine fillet.','',0,0,0,0,0,0,0,0,0,0,52667,0,26124),
(97201,'Tiny bait for my hook.','',0,0,0,0,0,0,0,0,0,0,52664,0,26124),
(97202,'Let\'s try the recipe for this \"Draught of Wild Magic\", shall we?','',0,0,0,0,0,0,1,0,2,0,0,0,26124),
(97203,'Join me over here, $n. I believe we have some of the reagents here on this shelf.','',0,0,0,0,0,0,1,0,2,0,0,0,26124),
(97204,'Let\'s see here...','',0,0,0,0,0,0,0,0,2,0,0,0,26124),
(97205,'','WHO DARES TAMPER WITH MY BOOK?',0,0,0,0,0,0,1,0,2,0,0,0,26124),
(97206,'','ITS SECRETS ARE NOT YOURS TO STEAL, MORTALS!',0,0,0,0,0,0,1,0,2,0,0,0,26124),
(97207,'','YOU WILL PAY FOR YOUR INSOLENCE! THIS ENTIRE CITY WILL BURN!',0,0,0,0,0,0,463,0,2,0,0,0,26124),
(97208,'Dalaran is under my protection, vrykul! BEGONE!','',0,0,0,0,0,0,0,0,2,0,0,0,26124),
(97209,'We\'ll be fine, Archmage, but... look what that wretched creature did to my alchemy table!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97210,'Our friend $n can help rebuild your precious table, Deucus. Oh, and next time, have more care when handling ancient relics!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97211,'','ONCE AGAIN YOU STEAL FROM THE VRYKUL, OUTSIDER!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97212,'','MY TOME HOLDS WISDOM GLEANED FROM A THOUSAND LIFETIMES!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97213,'','ATONE FOR YOUR CRIMES! RETURN THE BOOK TO MY PEOPLE!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97214,'','PERSIST IN PLUNDERING ITS SECRETS AND YOUR LIFE SHALL BE FORFEIT!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97215,'Lord of the Seas take you!','',0,0,0,0,0,0,0,0,0,0,52665,0,26124),
(97224,'','So you mean to tell me that not only were you not able to secure the vault, you were unable to even overtake the village?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(97225,'','My Dark Lady, the vrykul here have proven more formidable than anticipated.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97226,'','Formidable for you, perhaps. We\'ll see how they fare when confronted by the Banshee Queen!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(97227,'','Of course, Dark Lady.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97232,'Sea spray and sand!','',0,0,0,0,0,0,0,0,0,0,52624,0,26124),
(97233,'What\'s that you have there? A shiny weapon?','',0,0,0,0,0,0,0,0,0,0,52627,0,26124),
(97234,'You\'ll make for a fatty meal.','',0,0,0,0,0,0,0,0,0,0,52630,0,26124),
(97235,'Great kraken take you!','',0,0,0,0,0,0,0,0,0,0,52628,0,26124),
(97236,'An offering for the tides.','',0,0,0,0,0,0,0,0,0,0,52637,0,26124),
(97237,'You\'re not from the ship!','',0,0,0,0,0,0,0,0,0,0,52635,0,26124),
(97238,'I\'ll chop you up into chum.','',0,0,0,0,0,0,0,0,0,0,52636,0,26124),
(97239,'Over here! Invaders!','',0,0,0,0,0,0,0,0,0,0,52633,0,26124),
(97240,'','I must commend you on ending that miserable worgen, Greymane. \n\nMy only regret is that I was not there to witness his final throes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97241,'','I must commend you on ending that miserable worgen, Greymane. \n\nMy only regret is that I was not there to witness his final throes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97242,'Thankfully I sensed her presence before she could do too much damage. Is anyone hurt?','',0,0,0,0,0,0,6,0,2,0,0,0,26124),
(97243,'Give us the Banshee Queen!','',0,0,0,0,0,0,0,0,0,0,51682,0,26124),
(97244,'We will have retribution!','',0,0,0,0,0,0,0,0,0,0,51683,0,26124),
(97245,'For Gilneas!','',0,0,0,0,0,0,0,0,0,0,51684,0,26124),
(97246,'For the Alliance!','',0,0,0,0,0,0,0,0,0,0,51685,0,26124),
(97247,'The Horde will pay for their treachery!','',0,0,0,0,0,0,0,0,0,0,51686,0,26124),
(97248,'I\'ll tear you to ribbons!','',0,0,0,0,0,0,0,0,0,0,51687,0,26124),
(97249,'Sylvanas cannot hide from justice!','',0,0,0,0,0,0,0,0,0,0,51688,0,26124),
(97250,'You cannot escape justice...','You cannot escape justice...',0,0,0,0,0,0,0,0,0,0,51689,51689,26124),
(97251,'Greymane... avenge me...','',0,0,0,0,0,0,0,0,0,0,51690,0,26124),
(97252,'Gilneas... will rise...','',0,0,0,0,0,0,0,0,0,0,51691,0,26124),
(97253,'Sylvanas will not escape...','',0,0,0,0,0,0,0,0,0,0,51692,0,26124),
(97254,'Savannah Highmane roars ferociously, licks his wounds and surrenders his services.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97255,'It is good to see you, $n. May the Waywatcher guide your path.','It is good to see you, $n. May the Waywatcher guide your path.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97256,'Is more important tings to do dan sellin\' me goods today, mon.','Is more important tings to do dan sellin\' me goods today, mon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97257,'Let\'s go make that potion!','Let\'s go make that potion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97264,'Aaaaaagh! Vengeance for our sisters!','Aaaaaagh! Vengeance for our sisters!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97265,'Don\'t you have a building to build?','Don\'t you have a building to build?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97266,'','Yo! Think I can get that Demolisher outside up and runnin\', if you think it\'s safe!',3,0,0,0,0,0,0,0,0,0,0,0,26124),
(97267,'I\'ll protect you, Torrix. Get the Demolisher working!','I\'ll protect you, Torrix. Get the Demolisher working!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97269,'','Alright boss, but you better watch my flank!',273,0,0,0,0,0,0,0,0,0,0,0,26124),
(97270,'Sounding','Sounding',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(97275,'','I\'m outta here! Good luck savin\' the world, boss!',273,0,0,0,0,0,0,0,0,0,0,0,26124),
(97276,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] Speak, demon. Who dares hunt the Illidari?','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(97277,'If you would do the honors, I will stand guard to ensure no one interferes.','',0,0,0,0,0,0,0,0,0,0,57565,0,26124),
(97278,'Meet Taldath, one of the most powerful eredar we\'ve ever encountered. I\'m sure you two will be fast friends.','',0,0,0,0,0,0,0,0,0,0,57564,0,26124),
(97279,'We have what we came for. Finish him!','',0,0,0,0,0,0,0,0,0,0,57563,0,26124),
(97280,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] Who is your master? Where is he hiding? SPEAK, DAMN YOU!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97281,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] Well done. The fool told us everything.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97282,'Help! Sound the alarm! The Sludge Fen rig\'s under attack!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97283,'We can\'t afford to lose this rig, boys! Break out the bombs!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97284,'They\'re getting closer! If they destroy the Pressure Control we\'re all gonna have a bad day!','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(97285,'Hurry and get up here or this rig\'s a goner! Bombs, bombs, bombs!','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(97286,'That was close! I\'ve got somethin\' to help you stick it to these demons up on top of the rig!','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(97287,'The finest in Goblin applied sciences. All yours, for savin\' my rig!','',4,0,0,0,0,0,0,0,0,0,0,0,26124),
(97288,'It\'s gonna blow! Get to safety!','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(97289,'You are not worthy! Turn back now or face the might of the Valarjar!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97291,'But I am not without mercy... You shall live long enough to watch your precious temple be destroyed.','',0,0,0,0,0,0,1,0,0,0,52914,0,26124),
(97292,'<The White Stag returns your gaze, approval in his glowing eyes. His gleaming white fur is so radiant that you have to blink away afterimages.>$b$b<Historically, sightings of Malorne have been rare and fleeting. Clearly your heroic deeds here have earned his favor.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97293,'','The Legion will fall.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97294,'Who dares awaken me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97295,'Your souls will burn!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97296,'My flames will consume you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97298,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-King Ymiron.blp:50:80|t$bYou\'ve lasted longer than most.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97299,'Thank you, $c.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97300,'I am confident you are up to the task, $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97301,'','Commander, if you wish to continue the fight, the other battlefields throughout Tanaan are now ripe for conquest.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(97302,'','We have the momentum, commander. You should assault the other battlefields throughout the jungle.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(97303,'','Another glorious victory! If your blood still runs hot, know that the rest of Tanaan\'s battlefields are ripe for the plucking...',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(97304,'','We should keep up the pressure, commander. The other hotspots throughout Tanaan are now vulnerable to attack.',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(97305,'The Nightmare encroaches.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97306,'For Moonclaw Vale!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97307,'','Another triumph for the Alliance! You should press our advantage and attack one of the other Tanaan hotspots.',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(97308,'','Well done, commander. Rangari scouts report that the other battlefields throughout Tanaan are now vulnerable.',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(97309,'','You\'ve got Gul\'dan\'s minions scrambling, commander. Consider attacking some of the other Tanaan battlefields while they are on the run.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97310,'','Keep up the good fight, commander! There are other hotspots throughout Tanaan that are now vulnerable to attack.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(97311,'Defeat the demons that threaten the the Halls of Valor and Odyn will surely let you compete in the final trial for the Aegis of Aggramar.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(97313,'','I\'m telling you, Alistair, I don\'t like this one bit. Don\'t you remember the Scourge uprising back in Gilneas?',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(97314,'I will never forget that horror. If it comes to that, we\'ll build another ship. We started over once, and we can do it again.','',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(97316,'Yes!','Yes!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97319,'I told Eitrigg not to worry, but I am impressed nonetheless. A powerful artifact obtained and a major demon lord slain!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(97320,'','Fools. This mountain is ours!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97321,'','For High Crawliac!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97322,'','You cannot stand against the might of our covens.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97323,'','Your corpse shall feed my young.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97324,'','I will make such lovely spells from your bones.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97325,'','Crawliac descends upon you all!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97326,'','I have a new spell just for you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97327,'','The skies belong to the Crawliac!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97328,'Zephyrus is a great spirit, and not easily tamed. Even if we win today, my people will need more reasons to follow you than some artifact from beyond the sea. This may prove the symbol they need to see you as a leader.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97329,'The rest of the way you must go alone. Follow this path up until you find the Skyhorn. If you live, I shall join you in the skies over Highmountain!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97330,'Who calls me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97331,'Come, mortal, let us see what you are made of.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97332,'<Placeholder Event: High Crawliac attacks, stealing Zephyrus and leaving the player at this upcoming position>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97333,'','The Skyhorn are not the only ones to suffer at the hands of the harpies. \n\nThe wildlife native to these mountains are plagued by the witches\' cruelty and chaos, and without Morashu to guide their spirits, they will never know peace.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(97334,'Tell me more about Morashu.','Tell me more about Morashu.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97335,'You are welcome to anything of value you find on its corpse.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(97336,'Thank you! I never thought to see a demon here in Val\'sharah.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97337,'','Morashu has lingered in these mountains as long as any tribe. His presence is needed to carry out the cycle of life and death that keeps nature in balance.\n\nIt is said that Morashu guides the spirits of animals when they meet their end. He is with them when the light leaves their eyes, and leads them down a path where their spirits may rejoin nature.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(97338,'','Genn is resting.$B$BWe should focus on making contact with the fleet and getting to a fortified position.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97339,'Who are you?','Who are you?',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(97340,'What\'s happening here?','What\'s happening here?',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(97341,'Have our paths crossed before, hero?$B$BI once commanded the night elf forces who defended this land from the Burning Legion, ten thousand years ago.$B$BMy sister is the warden named Maiev, and it is because of her that my path leads here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97342,'My people have seen too much suffering. It was the Scourge uprising that led us to flee Gilneas many years ago.$B$BNow, undead creatures have risen from the fortress to the north.$B$BI will defend this village to the bitter end.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97343,'','Look, it\'s $n! I told you $Ghe:she; was going to be the one chosen. Now, pay up!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97344,'Hurry up, Minerva! We\'re about to pull out of here. Mograine will kill us if we hold things up!','',0,0,0,0,0,0,0,0,0,0,61921,0,26124),
(97345,'One of Amal\'thazad\'s students? Bah! Fine, take your gold.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97346,'Ah, a fellow miner! Mama must have sent you to help me study the forest here. Or perhaps to relieve me of her son, I pray?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97347,'Yes yes, Diarmad, the dragons are nice, just don\'t bother them or me right no...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97348,'Mama Diggs sent me to collect your mineral analysis report.','Mama Diggs sent me to collect your mineral analysis report.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97349,'Ahhhhhhh!','Ahhhhhhh!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97352,'','We\'re already dead, idiot!',0,0,0,0,0,0,0,0,0,0,0,61922,26124),
(97353,'Looks like we\'re not wanted, Minerva. I guess we\'ll just guard the entrance then.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97354,'Gryphon Riders! To me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97355,'Riders! Circle back. Turn this ship to splinters!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97356,'Concentrate fire on the Blightcaller!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97357,'Lord Shadowsong, I was wrong about you. Everyone, put down your arms!','',0,0,0,0,0,0,396,0,0,0,52187,0,26124),
(97358,'Ah, here ya go $Glad:lass;! Could ye let Mama know I\'m running low on picks down here when ye see her again?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(97359,'$n, thank you for finding my daughter. Please, you are most welcome here.','',0,0,0,0,0,0,0,0,0,0,52188,0,26124),
(97360,'There\'s really nothing more I can teach the boy. I wish Mama would send for him already.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97361,'I need another set of Destroyer blueprints.','I need another set of Destroyer blueprints.',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(97363,'Looks like you lost one of our naval blueprints?  I can help you out with that!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(97364,'I need another set of Blast Furnace blueprints.','I need another set of Blast Furnace blueprints.',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(97365,'Looks like you lost one of our naval equipment blueprints?  I can help you out with that!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(97366,'|TINTERFACE\\ICONS\\inv_ammo_bullet_04:20|t |cFFFF0404|Hspell:190249|h[Explosive Rounds]|h|r on you! Close to melee range to disrupt the Huntress.','|TINTERFACE\\ICONS\\inv_ammo_bullet_04:20|t |cFFFF0404|Hspell:190249|h[Explosive Rounds]|h|r on you! Close to melee range to disrupt the Huntress.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97367,'','$GHe\'s:She\'s; waking up!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97368,'A true $c, $n. I admire your bravery. Please don\'t think less of me. I\'ll be when it\'s safe.','A true $c, $n. I admire your bravery. Please don\'t think less of me. I\'ll be when it\'s safe.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97369,'Thanks for the words, $n. I wish I could stay, but I\'ll return when it\'s a bit safer around these parts.','Thanks for the words, $n. I wish I could stay, but I\'ll return when it\'s a bit safer around these parts.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97370,'Apologies, $n. It\'s not that I\'m afraid. I\'m just no good in battle.','Apologies, $n. It\'s not that I\'m afraid. I\'m just no good in battle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97371,'','Good. Can $Ghe:she; fight?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97372,'I\'ll be back when it\'s all over.','I\'ll be back when it\'s all over.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97373,'I understand what you\'re saying, but I just don\'t have it in me to fight, $n.','I understand what you\'re saying, but I just don\'t have it in me to fight, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97374,'Do you crave death, elf? Do you dare face my lord\'s wrath alone?','',0,0,0,0,0,0,0,0,0,0,52010,0,26124),
(97375,'If you are ready to depart, Aviash can fly you to Thunder Totem.','',0,0,0,0,0,0,0,0,0,0,54328,0,26124),
(97376,'I am through with this charade! Your soul will feed the Twinblades.','',0,0,0,0,0,0,0,0,0,0,52026,0,26124),
(97377,'Mama Diggs sent me to collect your obsidian analysis report.','Mama Diggs sent me to collect your obsidian analysis report.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97378,'','W-w-where is everyone?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97379,'It\'s safe now.','It\'s safe now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97380,'This oil is promising! Gather all the fish you can carry! Melt their bones!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97381,'I will have it all! No fish left behind!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97382,'Goblin cowards! GET LOST!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97383,'Here\'s everything I\'ve been able to gather from the obsidian here. Hopefully there\'s something in it that can help with your venture.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(97384,'If you don\'t mind, I\'m rather busy right now.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97385,'The mineral composition of this stone is amazing... err... who are you?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97386,'Any word on those picks? I\'m down to me last one.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97387,'My blade will bathe in Legion blood before this fight is over.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97388,'DNT','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97389,'Despite what they say, these people need help. Defend their farms, and we will ease their suspicions.','',0,0,0,0,0,0,1,0,0,0,52189,0,26124),
(97390,'Is time actually money? Or is it, in fact, a more abstract concept?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97391,'Oh my god! There\'s another one and it\'s even bigger than the last one!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(97392,'Rhol! Look! Look at them all! Rhol? Rhol? Rhol?!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(97393,'This is the best trip ever! I\'m never gonna leave!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(97394,'These children... The innocent need not die here on the field of battle.$B$BIf you are brave enough, I could use a hand escorting them to safety.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97396,'I will help escort the children to safety!','I will help escort the children to safety!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97397,'','I will tear your pitiful worgen apart, Greymane!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97398,'','You will pay for your interference!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97399,'Very well. Stay close.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97400,'','Death awaits you all!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97401,'','Your life ends here, dog!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97402,'','Enough!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97403,'On your toes, $n! Our defenses are under constant attack from the Legion.$B$BYou can stay and find what comfort there is left, but remember - if you fight, you fight in the name of the Warchief.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97404,'Storm the vault! For Gilneas!','',0,0,0,0,0,0,0,0,0,0,51645,0,26124),
(97405,'Can\'t... control...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97406,'Come, Sylvanas! Face the beast you have unleashed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97407,'There is plenty of room in my cage for your souls.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97408,'You are no match for us, landwalker.','',0,0,0,0,0,0,0,0,0,0,52686,0,26124),
(97409,'Die, landwalker!','',0,0,0,0,0,0,0,0,0,0,52684,0,26124),
(97410,'The sea will claim your corpse.','',0,0,0,0,0,0,0,0,0,0,52683,0,26124),
(97411,'','For Nazjatar!',0,0,0,0,0,0,0,0,0,0,0,52705,26124),
(97412,'','My voice will be the last thing you hear.',0,0,0,0,0,0,0,0,0,0,0,52707,26124),
(97413,'Don\'t mistake me for these weak-minded fools. I\'m here on orders.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97414,'Mama Diggs sent me to collect your saronite composition report.','Mama Diggs sent me to collect your saronite composition report.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97415,'','Die, landwalker!',0,0,0,0,0,0,0,0,0,0,0,52704,26124),
(97416,'','The tide turns.',0,0,0,0,0,0,0,0,0,0,0,52702,26124),
(97417,'What do you want? Who sent you?! Are you the one who\'s been whispering to me?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97418,'Oh, right. Here\'s everything I\'ve learned so far. There\'s... something... something inside the ore that speaks to you.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(97419,'I need to get out of here before I become a mindless slave like these wretches.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97420,'|TINTERFACE\\ICONS\\TRADE_ENGINEERING.BLP:50|tSo long as the worldseed sapling survives, I will be able to aid you in your search for Malfurion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97421,'Fresh tuning comin\' right up, boss!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97422,'Oilin\' her up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97423,'I\'ll fix that hitch for ya.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97424,'Hmm... agh. Yep! That\'ll do it. Good to go!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97425,'','Gag, you\'re a sweetheart for checkin\' on me, but today is not the day, hon. We got demons to take care of!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97426,'Enter, $n, there is much to be done.','',0,0,0,0,0,0,0,0,0,0,52485,0,26124),
(97427,'Hey Liv. You doin\' okay over here?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97428,'If you need anything, you know where I\'ll be.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97429,'Argent Crusade - CHARGE!','',0,0,0,0,0,0,0,0,0,0,52015,0,26124),
(97430,'Such arrogance... must be punished.','',0,0,0,0,0,0,0,0,0,0,52038,0,26124),
(97431,'I get it, but I just don\'t have it in me to fight.','I get it, but I just don\'t have it in me to fight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97432,'','All\'s clear over here, Gaz!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97433,'An in-game event fires at this point.','An in-game event fires at this point.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97434,'Saddle up, boys! We\'re ridin\' this one out!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97435,'Shredder\'s all banged up. I\'m gonna need a new one with a little more oomph!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97436,'What\'re they always shootin\' at me for? I\'m just a goblin in a gigantic metal suit with rockets.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97437,'Baelgun\'s soul was cursed to relive the moment of his death for eternity and will see you as his enemy. Destroy him.','',0,0,0,0,0,0,0,0,1,0,52476,0,26124),
(97439,'Throw the |cFFFF0000|Hspell:179202|h[Eye of Anzu]|h|r to a Healer to dispel |cFFFF0000|Hspell:181753|h[Fel Bomb]|h|r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97440,'Throw the |cFFFF0000|Hspell:179202|h[Eye of Anzu]|h|r to a someone affected by |cFFFF0000|Hspell:181957|h[Phantasmal Winds]|h|r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97441,'Throw the |cFFFF0000|Hspell:179202|h[Eye of Anzu]|h|r to Tank affected by |cFFFF0000|Hspell:181824|h[Phantasmal Corruption]|h|r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97442,'The soul of Halahk was tortured within Frostmourne till he cursed the Light. Now that he has forsaken it, slay him.','',0,0,0,0,0,0,0,0,1,0,52470,0,26124),
(97443,'Even when consumed by Frostmourne, the soul of Magroth refused to give up the Light. Show him the error of his ways.','',0,0,0,0,0,0,0,0,1,0,52469,0,26124),
(97444,'Scorch the earth behind us. I must finish breaking our... guest.','',0,0,0,0,0,0,0,0,0,0,52014,0,26124),
(97445,'Once hailed by Arthas as a brother, Gavinrad too was ultimately fed to Frostmourne. Grant him a final death.','',0,0,0,0,0,0,0,0,1,0,52471,0,26124),
(97446,'','The drogbar here were at peace with us. Some were even friendly. What their Underking did to turn them against us, I do not know.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97447,'Aaaaaaah!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97448,'Without the fish the Rivermane supply, our mountain would soon starve.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97449,'','Though some of the other Highmountain look down on us for our peaceful way of life, we provide them with most of their food and heal the wounds of battle.\n\nThose calves need to show some respect for their elders.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97450,'They no take treasure. I watch. I wait. I see them coming.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(97451,'Infernals! Crush them!','',0,0,0,0,0,0,0,0,0,0,51976,0,26124),
(97452,'You no take treasure!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97453,'Take me the northern Illidari camp!','Take me the northern Illidari camp!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97454,'Take me the main Illidari camp!','Take me the main Illidari camp!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97455,'This location, adventurer, provides you the opportunity to survive in times like these.$B$BDo not be alarmed by the riders in the skies. They merely provide safe keeping and will do no harm to you, unless, of course, it is provoked.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97456,'We take the fight to Gul\'dan. We finish it here!','',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(97457,'Vol\'jin sent me to support your Tanaan campaign, commander. We shadow hunters be callin\' out the targets for you.','',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(97458,'We kill \'em here, commander. Every demon we slay in Tanaan is one less we deal with in Azeroth.','',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(97459,'Take me the main Illidari camp!','Take me the main Illidari camp!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97460,'Take me the eastern Illidari camp!','Take me the eastern Illidari camp!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97461,'Champion, we must persevere!','',0,0,0,0,0,0,0,0,0,0,52724,0,26124),
(97462,'We move on our champion\'s command.','',0,0,0,0,0,0,0,0,0,0,52719,0,26124),
(97463,'The fiends have Tirion! We have to act quickly.','',0,0,0,0,0,0,0,0,0,0,52009,0,26124),
(97464,'Champion, I\'ll signal for our hippogryph riders to get our fallen to Light\'s Hope Chapel. You must forge ahead and find the Highlord!','',0,0,0,0,0,0,0,0,0,0,52039,0,26124),
(97466,'Take me the southern Illidari camp!','Take me the southern Illidari camp!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97467,'A raven flies up and hovers expectantly. It has a message!','',0,0,0,0,0,0,0,0,0,37104,0,0,26124),
(97468,'','You are needed at Greywatch, $Gsir:ma\'am;.$B$BWhenever you\'re ready.',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(97469,'Take me to Greywatch.','Take me to Greywatch.',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(97470,'','Nathanos has requested your presence in Dreadwake\'s Landing.$B$BReady to go?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(97471,'Take me to Dreadwake\'s Landing.','Take me to Dreadwake\'s Landing.',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(97472,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-King Ymiron.blp:50:80|t$bYour stamina is impressive... but I am just getting started!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97474,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-King Ymiron.blp:50:80|t$bSo you can fight off a few lesser warriors. Its time to face a real foe!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97475,'Oh no... where is it? The Potion of Bubbling Pustules! ... you didn\'t drink it, did you?','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(97476,'It wasn\'t quite ready yet, so if you start to feel woozy just breath deeply. You may or may not keel over suddenly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97477,'The Nightmare will consume you!','',0,0,0,0,0,0,0,0,0,0,52191,0,26124),
(97478,'None can stand against the Nightmare Lord!','',0,0,0,0,0,0,0,0,0,0,52192,0,26124),
(97479,'Pathetic creature! This curse has made me stronger than the ancients!','',0,0,0,0,0,0,0,0,0,0,52193,0,26124),
(97480,'Sir, I\'ll have to excuse myself until these happenings are at an end.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97481,'','I... I was too late...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97482,'','Moonclaw... No...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97483,'','We are lost without Thaon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97484,'','<Aylea sobs uncontrollably.>$B$BI do not know what will do without Thaon Moonclaw by our side.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97485,'Well, that was certainly unexpected.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97488,'You will not escape me this time, betrayer!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97489,'Find me when Kagraxxis has been slain! I sense an even darker presence here...','',0,0,0,0,0,0,0,0,0,0,52194,0,26124),
(97490,'I will protect Val\'sharah with my life!','',0,0,0,0,0,0,0,0,0,0,52195,0,26124),
(97491,'Begone from my lands!','',0,0,0,0,0,0,0,0,0,0,52196,0,26124),
(97492,'Yes... harvest it all. Every last bit.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97493,'Our turn! We not lose this time we hope.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97494,'Time to face da pretty one, little thing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97495,'You think you take our belt? We are champion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97496,'\"Karkun\"','\"Karkun\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97497,'\"Danashj\"','\"Danashj\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97498,'\"Belan\"','\"Belan\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97499,'\"Rukadare\"','\"Rukadare\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97500,'\"Ticharamir\"','\"Ticharamir\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97501,'\"Veni\"','\"Veni\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97502,'\"Maez\"','\"Maez\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97503,'\"Parnus\"','\"Parnus\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97504,'\"Maladath\"','\"Maladath\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97505,'Enchant shoulder armor.','Enchant shoulder armor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97506,'Enchant gloves.','Enchant gloves.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97507,'Enchant gloves.','Enchant gloves.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97508,'Enchant boots.','Enchant boots.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97509,'Let\'s attempt to assemble a demonic enchant.','Let\'s attempt to assemble a demonic enchant.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97515,'','Karkun...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97516,'','Danashj...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97517,'','Belan...',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(97518,'','Rukadare...',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(97520,'','Ticharamir...',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(97522,'','Veni...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97523,'','Maez!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(97524,'','Parnus!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(97525,'','Maladath!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(97526,'At the end of their life, a vrykul\'s worth is determined by the great rulers of their people.','',0,0,0,0,0,0,0,0,0,0,52916,0,26124),
(97527,'If you wish to claim the Aegis, seek these ancient rulers and prove to them your merit.','',0,0,0,0,0,0,0,0,0,0,52372,0,26124),
(97528,'Only those deemed worthy shall pass the Trial of Valor.','',0,0,0,0,0,0,0,0,0,0,52373,0,26124),
(97529,'Be careful. I saw a few wyrmtongue roaming about.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(97530,'The Legion is here! Get out of here!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(97531,'I don\'t remember what happened, but the Legion...','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(97532,'Those spiders were vicious before, but now... well, you\'ll see.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(97533,'They\'re controlling them! The spiders... Get me outta here!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(97534,'','|cFFFF0000%s|r begins to cast |cFFFF0000|Hspell:192754|h[Nightmare Breath]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97535,'Hero, free us from this curse!','Hero, free us from this curse!',0,0,0,0,0,0,1,0,0,0,52197,52197,26124),
(97536,'It is done. From the shards of Frostmourne the twin blades are born! Soon, they shall feed upon the souls of my enemies!','',0,0,0,0,0,0,0,0,0,0,52446,0,26124),
(97537,'I sense powerful spirits remain within the blades. Enter into the spiritual realm within and purge them of all that resist your domination!','',0,0,0,0,0,0,0,0,0,0,52444,0,26124),
(97543,'','Yeah, I\'m getting a good feeling about ... that... spot over there...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97544,'Don\'t you have a building to build?','Drill baby drill!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97545,'Don\'t you have a building to build?','Hey commander, can I interest you in an investment plan that moves some of your assets offshore? Literally offshore, I know a guy that wants to build an oil rig.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97546,'','I just want to say one word to you. Just one word. Are you listening? Oil.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97547,'','Commander! Any good premonitions lately?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97548,'','Oh boy I just know we\'re going to strike it rich next time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97549,'','Do you think that those fel-powered machines the Iron Horde are using still need lubricants?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97550,'|TInterface\\Icons\\Spell_Fire_FelRainOfFire.blp:20|t %s begins to cast |cFFF00000|Hspell:185284|h[Barrage]|h|r!','|TInterface\\Icons\\Spell_Fire_FelRainOfFire.blp:20|t %s begins to cast |cFFF00000|Hspell:185284|h[Barrage]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(97551,'You have done well. Ascend to my throne and receive your charge.','',0,0,0,0,0,0,0,0,0,0,52466,0,26124),
(97552,'Where the weak showed mercy, you did not hesitate to strike. Where the unworthy were vanquished, you have conquered.','',0,0,0,0,0,0,0,0,0,0,52455,0,26124),
(97553,'As we speak the Ebon Blade is en route to the Broken Isles to hunt for the Dreadlords.','',0,0,0,0,0,0,0,0,0,0,52452,0,26124),
(97554,'Accessing Record','Accessing Record',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(97555,'Nothing will stand in the way of my vengeance!','',0,0,0,0,0,0,0,0,0,0,64169,0,26124),
(97556,'I see... only darkness... before me.','',0,0,0,0,0,0,0,0,0,0,64175,0,26124),
(97557,'Powering up archive device...','',0,0,0,0,0,0,0,0,0,0,52367,0,26124),
(97558,'Archive device activated. The record is now accessible.','',0,0,0,0,0,0,0,0,0,0,52371,0,26124),
(97559,'You cannot win, mortal.','',0,0,0,0,0,0,0,0,0,0,52368,0,26124),
(97560,'Skovald has tasted the Legion\'s power. He will claim the Aegis and grant its power to us!','',0,0,0,0,0,0,0,0,0,0,52369,0,26124),
(97561,'This land will be ours!','',0,0,0,0,0,0,0,0,0,0,52370,0,26124),
(97562,'In the name of the Prophet, we must cleanse this land.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(97563,'There is much to be done and little time. Our ancient enemies have found us. If we do not reclaim Tanaan... all is lost.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(97564,'We have been running for too long. Always running. No more! We made this world our home, and we will fight to the last to preserve it.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(97565,'Master, I have failed you...','',0,0,0,0,0,0,0,0,0,0,52198,0,26124),
(97566,'I underestimated your strength...','',0,0,0,0,0,0,0,0,0,0,52199,0,26124),
(97567,'','Forgive me, Lord Ravencrest. I... failed you...',0,0,0,0,0,0,0,0,0,0,0,52200,26124),
(97568,'I must... alert... the others...','',0,0,0,0,0,0,0,0,0,0,52201,0,26124),
(97601,'The outsider must not learn of the trials!','',0,0,0,0,0,0,0,0,0,0,52374,0,26124),
(97602,'You are unworthy of this place!','',0,0,0,0,0,0,0,0,0,0,52376,0,26124),
(97603,'','The God-King will have your head!',0,0,0,0,0,0,15,0,0,0,0,52378,26124),
(97604,'The Thorignir are the oldest and wisest dragons in Stormheim.','',0,0,0,0,0,0,0,0,0,0,52379,0,26124),
(97605,'To fly with them is to sail amongst the gods themselves.','',0,0,0,0,0,0,0,0,0,0,52380,0,26124),
(97606,'Seek their blessing to pass the Trial of Will.','',0,0,0,0,0,0,0,0,0,0,52381,0,26124),
(97607,'You are proving an invaluable ally in my efforts, $n. How may I help you?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(97608,'Commander Thalanor, patrol reporting in!','Commander Thalanor, patrol reporting in!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97609,'My blood... it burns! The fel energy... I can\'t.... control it... AAAAUUUGGGGHHH!','',0,0,0,0,0,0,1,0,0,0,52202,0,26124),
(97610,'The demons control Black Rook Hold. You must... stop them...','',0,0,0,0,0,0,1,0,0,0,52203,0,26124),
(97611,'You mortals are so vain... so arrogant. You will suffer for your hubris.','',0,0,0,0,0,0,0,0,0,0,52029,0,26124),
(97612,'','What? How? The whole time?!',6,5,0,0,500,0,0,0,0,0,0,54273,26124),
(97613,'The sundering of this one\'s soul has been... taxing. But he will be ours soon.','',0,0,0,0,0,0,0,0,0,0,52440,0,26124),
(97614,'','[Placeholder] I will be honest, the battles have not been going well. While our troops are powerful and well trained, they are not as familiar with war.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97615,'','[Placeholder] My time is short, Spiritwalker. Explain why you have summoned me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97616,'Archive device power at 50 percent...','',0,0,0,0,0,0,0,0,0,0,52375,0,26124),
(97617,'Archive device power at 75 percent...','',0,0,0,0,0,0,0,0,0,0,52377,0,26124),
(97618,'$p... save... the Ashbringer...','',0,0,0,0,0,0,0,0,0,0,63798,0,26124),
(97619,'Leave me... hurry, before more come...','',0,0,0,0,0,0,0,0,0,0,63800,0,26124),
(97620,'Lady Ysera, thank you for answering our call. We face a dire threat!','',0,0,0,0,0,0,2,0,0,0,52204,0,26124),
(97621,'','No need to explain, Malfurion. I have seen what is coming.',0,0,0,0,0,0,1,0,0,0,0,52922,26124),
(97622,'','The Emerald Dream is being overtaken by the Nightmare. The Legion and the satyr Xavius are to blame.',0,0,0,0,0,0,603,0,0,0,0,52925,26124),
(97623,'','Shaladrassil, the World Tree, has fallen to the Nightmare\'s corruption and spreads its curse across our precious land.',0,0,0,0,0,0,1,0,0,0,0,52929,26124),
(97624,'','The Nightmare Lord must be vanquished, or Val\'sharah is lost.',0,0,0,0,0,0,25,0,0,0,0,52921,26124),
(97625,'The Tears of Elune, stolen by Xavius! Then our champion\'s efforts were for nothing?','',0,0,0,0,0,0,6,0,0,0,52158,0,26124),
(97626,'','On the contrary, the temple was saved, and there is still time to recover the Tears.',0,0,0,0,0,0,6,0,0,0,0,52926,26124),
(97627,'Time we do not have. The temple was saved, but Cenarius was lost to the Nightmare.','',0,0,0,0,0,0,1,0,0,0,52159,0,26124),
(97628,'','Calm yourself, Malfurion. You have not seen the terrible power Xavius now possesses.',0,0,0,0,0,0,2,0,0,0,0,52923,26124),
(97629,'I have wasted too much time here. No more!','',0,0,0,0,0,0,5,0,6,0,52160,0,26124),
(97630,'','Cenarius\'s loss has left Malfurion unable to see reason.',0,0,0,0,0,0,1,0,6,0,0,52927,26124),
(97631,'','Make haste to the World Tree. He may be headed there, all too ready to take reckless risks.',0,0,0,0,0,0,25,0,6,0,0,52930,26124),
(97632,'','Meanwhile, you and I will follow his trail from here. Malfurion must not fall.',0,0,0,0,0,0,1,0,6,0,0,52932,26124),
(97633,'Insignificant gnat. I will enjoy breaking you.','',0,0,0,0,0,0,0,0,0,0,52042,0,26124),
(97634,'It\'s so good to fight again.','',0,0,0,0,0,0,0,0,0,0,55406,0,26124),
(97635,'Activating sequence: Trial of Might...','',0,0,0,0,0,0,0,0,0,0,52382,0,26124),
(97636,'I hope you are ready to face your first trial, outsider.','',0,0,0,0,0,0,0,0,0,45594,52383,0,26124),
(97637,'As the keeper of this vault, it is my duty to test the might of those who wish to proceed.','',0,0,0,0,0,0,0,0,0,45594,52384,0,26124),
(97638,'Prepare yourself!','',0,0,0,0,0,0,0,0,0,45594,52385,0,26124),
(97639,'Death is weakness leaving the universe.','',0,0,0,0,0,0,0,0,0,0,55418,0,26124),
(97640,'More power for my blades.','',0,0,0,0,0,0,0,0,0,0,55417,0,26124),
(97641,'My blades hunger.','',0,0,0,0,0,0,0,0,0,0,55416,0,26124),
(97642,'I will cast you all aside...','',0,0,0,0,0,0,0,0,0,0,55415,0,26124),
(97643,'... and I will unleash my fury upon you all!','',0,0,0,0,0,0,0,0,0,0,55414,0,26124),
(97644,'My hatred flows through me.','',0,0,0,0,0,0,0,0,0,0,55413,0,26124),
(97646,'Play with fire and you\'ll get burned.','',0,0,0,0,0,0,0,0,0,0,55412,0,26124),
(97647,'I need no blade to defeat you.','',0,0,0,0,0,0,0,0,0,0,55411,0,26124),
(97648,'My powers wane, I must have more!','',0,0,0,0,0,0,0,0,0,0,55410,0,26124),
(97649,'Anger, hate, rage! These will fuel me with the power I crave!','',0,0,0,0,0,0,0,0,0,0,55409,0,26124),
(97650,'My power.. Wasn\'t enough?','',0,0,0,0,0,0,0,0,0,0,55408,0,26124),
(97651,'I cannot be stopped.','',0,0,0,0,0,0,0,0,0,0,55407,0,26124),
(97655,'So ... long ... where is my Lord of Fire, why does he not answer my call?','',0,0,0,0,0,0,0,0,0,0,55437,0,26124),
(97656,'The fire consumes all.','',0,0,0,0,0,0,0,0,0,0,55436,0,26124),
(97657,'More fuel for our fire.','',0,0,0,0,0,0,0,0,0,0,55435,0,26124),
(97658,'Your flesh will know the sweet caress of fire.','',0,0,0,0,0,0,0,0,0,0,55434,0,26124),
(97659,'Your bones will blacken, your life extinguished.','',0,0,0,0,0,0,0,0,0,0,55433,0,26124),
(97660,'We give rise to flame.','',0,0,0,0,0,0,0,0,0,0,55432,0,26124),
(97661,'Fire has a life of its own.','',0,0,0,0,0,0,0,0,0,0,55431,0,26124),
(97662,'We will make ashes of you all!','',0,0,0,0,0,0,0,0,0,0,55430,0,26124),
(97663,'Flame! Death!','',0,0,0,0,0,0,0,0,0,0,55429,0,26124),
(97664,'So... C.. Cold.','',0,0,0,0,0,0,0,0,0,0,55428,0,26124),
(97665,'You cannot contain these flames!','',0,0,0,0,0,0,0,0,0,0,55427,0,26124),
(97667,'I am... Extinguished.','',0,0,0,0,0,0,0,0,0,0,55426,0,26124),
(97668,'I will burn this prison to the ground!','',0,0,0,0,0,0,0,0,0,0,55425,0,26124),
(97672,'Visitors? How exciting!','',0,0,0,0,0,0,0,0,0,0,55424,0,26124),
(97673,'Didn\'t see that one coming did you?','',0,0,0,0,0,0,0,0,0,0,55423,0,26124),
(97674,'You can watch from the floor.','',0,0,0,0,0,0,0,0,0,0,55422,0,26124),
(97675,'Follow the bouncing ball.','',0,0,0,0,0,0,0,0,0,0,55421,0,26124),
(97676,'Watch your step!','',0,0,0,0,0,0,0,0,0,0,55420,0,26124),
(97677,'Time to focus.','',0,0,0,0,0,0,0,0,0,0,55419,0,26124),
(97681,'Look into my eye.','',0,0,0,0,0,0,0,0,0,0,55477,0,26124),
(97682,'Curse the wardens and their mirrors.','',0,0,0,0,0,0,0,0,0,0,55476,0,26124),
(97683,'That didn\'t look that close...','',0,0,0,0,0,0,0,0,0,0,55475,0,26124),
(97684,'If only I could see the future...','',0,0,0,0,0,0,0,0,0,0,55474,0,26124),
(97685,'I look forward to my next set of guests.','',0,0,0,0,0,0,0,0,0,0,55473,0,26124),
(97689,'','So be it. I will slay you all.',0,0,0,0,0,0,0,0,0,0,0,55472,26124),
(97690,'','You should know better than to challenge a warden.',0,0,0,0,0,0,0,0,0,0,0,55471,26124),
(97691,'','Death embraces you, perhaps not for the first time?',0,0,0,0,0,0,0,0,0,0,0,55470,26124),
(97692,'','The best prison needs no walls.',0,0,0,0,0,0,0,0,0,0,0,55469,26124),
(97693,'','A warden\'s glaive can pierce the toughest armor.',0,0,0,0,0,0,0,0,0,0,0,55468,26124),
(97694,'','Yeeeah!',0,0,0,0,0,0,0,0,0,0,0,55467,26124),
(97695,'','Your downfall is inevitable.',0,0,0,0,0,0,0,0,0,0,0,55466,26124),
(97696,'','Watch your step! It\'s a long way down.',0,0,0,0,0,0,0,0,0,0,0,55465,26124),
(97698,'','Vengeance will be mine!',0,0,0,0,0,0,0,0,0,0,0,55464,26124),
(97699,'','All night elf children learn to love the dark.',0,0,0,0,0,0,0,0,0,0,0,55463,26124),
(97700,'','My powers have grown since joining the Legion. Here, let me show you.',0,0,0,0,0,0,0,0,0,0,0,55462,26124),
(97701,'','I will not be stopped! I have fought too long, suffered too much. Victory must be mine!',0,0,0,0,0,0,0,0,0,0,0,55461,26124),
(97702,'','Beaten? How! You are... nothing',0,0,0,0,0,0,0,0,0,0,0,55460,26124),
(97703,'','Your death was inevitable.',0,0,0,0,0,0,0,0,0,0,0,55459,26124),
(97704,'','How utterly predictable! Maiev is nothing if not persistent.',0,0,0,0,0,0,153,0,0,0,0,55458,26124),
(97705,'','I knew she had that artifact secreted away after the events at the Black Temple.',0,0,0,0,0,0,274,0,0,0,0,55457,26124),
(97706,'','And now you fools have brought me the key. I\'ll thank you to hand it over... willingly or otherwise.',0,0,0,0,0,0,0,0,0,0,0,55456,26124),
(97707,'Ooohh... New subjects.','',0,0,0,0,0,0,0,0,0,0,64824,0,26124),
(97708,'A pity.','',0,0,0,0,0,0,0,0,0,0,64825,0,26124),
(97709,'Death becomes you.','',0,0,0,0,0,0,0,0,0,0,64826,0,26124),
(97710,'Let\'s see what\'s behind door number...','',0,0,0,0,0,0,0,0,0,0,64827,0,26124),
(97711,'Your souls are mine.','',0,0,0,0,0,0,0,0,0,0,64828,0,26124),
(97712,'How terribly disappointing.','',0,0,0,0,0,0,0,0,0,0,64829,0,26124),
(97713,'Playtime has ended.','',0,0,0,0,0,0,0,0,0,0,64830,0,26124),
(97714,'','You have brought my armor and glaive...',0,0,0,0,0,0,1,0,0,0,0,52161,26124),
(97715,'Trial of Might sequence concluded.','',0,0,0,0,0,0,0,0,0,0,52386,0,26124),
(97716,'That is enough, outsider...','',0,0,0,0,0,0,0,0,0,0,52387,0,26124),
(97717,'Unbelievable! Decades of waiting without a worthy challenger, only to be beaten twice in the same day!','',0,0,0,0,0,0,0,0,0,0,52498,0,26124),
(97718,'You have passed the Trial of Might, outsider. Seek me at the vault\'s entrance, and I will grant you the blessing of the Watchers.','',0,0,0,0,0,0,0,0,0,0,52388,0,26124),
(97719,'The mortal approaches the Ashbringer. To arms!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97722,'','We have failed... Lord Balna...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97723,'Glaive Throwers cannot withstand the terrain outside of the Ravencourt. Return immediately or you will be ejected.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97724,'','Destroy them! Leave nothing but ash!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97727,'','Squaaak! I\'ll tear you apart!',0,0,0,0,0,0,0,0,0,0,0,61244,26124),
(97728,'','Rip the flesh from its bones!',0,0,0,0,0,0,0,0,0,0,0,61245,26124),
(97729,'','A prize for the Witchmother!',0,0,0,0,0,0,0,0,0,0,0,61246,26124),
(97730,'','Squaaak! You\'ll regret this!',0,0,0,0,0,0,0,0,0,0,0,61247,26124),
(97731,'','Shred its flesh! Scraaawk!',0,0,0,0,0,0,0,0,0,0,0,61248,26124),
(97732,'','I\'ll enjoy killing you!',0,0,0,0,0,0,0,0,0,0,0,61249,26124),
(97733,'','Scraaawk! Make it bleed!',0,0,0,0,0,0,0,0,0,0,0,61250,26124),
(97734,'','None shall survive!',0,0,0,0,0,0,0,0,0,0,0,61251,26124),
(97735,'','Craaawwkk!',0,0,0,0,0,0,0,0,0,0,0,61252,26124),
(97736,'','Sisters! Avenge me...',0,0,0,0,0,0,0,0,0,0,0,61253,26124),
(97737,'','No... Squaaggk!',0,0,0,0,0,0,0,0,0,0,0,61254,26124),
(97738,'','Curses upon you!',0,0,0,0,0,0,0,0,0,0,0,61255,26124),
(97739,'','Coward! You\'ll pay for this...',0,0,0,0,0,0,0,0,0,0,0,61256,26124),
(97740,'','No! NO! Craaawwkk...',0,0,0,0,0,0,0,0,0,0,0,61257,26124),
(97741,'','The village is... ours...',0,0,0,0,0,0,0,0,0,0,0,61258,26124),
(97742,'','OH GOD, WHAT IS THAT THING?! Someone, help! Please! It\'s tearing my room apart!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97743,'It\'s in here! I know it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97744,'Why won\'t this blasted cabinet open up!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97745,'Just a taste, that\'s all I need! Just, one... little... TASTE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97746,'Nothing will save you from our master!','',0,0,0,0,0,0,0,0,0,0,52131,0,26124),
(97747,'I will awaken the darkness inside you!','',0,0,0,0,0,0,0,0,0,0,52132,0,26124),
(97748,'You\'ll beg for death when I\'m done with you!','',0,0,0,0,0,0,0,0,0,0,52133,0,26124),
(97749,'Get away from me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97750,'Let me see your entrails!','',0,0,0,0,0,0,0,0,0,0,52134,0,26124),
(97751,'These potions are just delightful...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97752,'Your moon goddess has no power here!','',0,0,0,0,0,0,0,0,0,0,52135,0,26124),
(97753,'Fool! This land is already ours!','',0,0,0,0,0,0,0,0,0,0,52136,0,26124),
(97754,'You are too late... this land is ours!','',0,0,0,0,0,0,0,0,0,0,52137,0,26124),
(97755,'Our master will burn this world... and you with it!','',0,0,0,0,0,0,0,0,0,0,61440,0,26124),
(97756,'Terror is all that awaits... you...','',0,0,0,0,0,0,0,0,0,0,61441,0,26124),
(97757,'Raaarrgh...','',0,0,0,0,0,0,0,0,0,0,61442,0,26124),
(97758,'Mine are not the only hands... stained in blood...','',0,0,0,0,0,0,0,0,0,0,61443,0,26124),
(97759,'Death will not... stop us...','',0,0,0,0,0,0,0,0,0,0,61444,0,26124),
(97760,'Give up! There is no hope for this world...','',0,0,0,0,0,0,0,0,0,0,61445,0,26124),
(97761,'Your world is... doomed...','',0,0,0,0,0,0,0,0,0,0,61446,0,26124),
(97762,'','Illidari $n, I present the Coilskar.',0,0,0,0,0,0,0,0,4,0,0,55301,26124),
(97763,'','Lord Illidan sends his best wishes for a speedy success.',0,0,0,0,0,0,0,0,4,0,0,55302,26124),
(97764,'','I assume the foothold has been established?',0,0,0,0,0,0,0,0,4,0,0,55303,26124),
(97765,'','Lovely... another fel volcano.',0,0,0,0,0,0,0,0,4,0,0,55299,26124),
(97766,'The crystal pulses faintly, but fails to locate any nearby prey....','The crystal pulses faintly, but fails to locate any nearby prey.....',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97767,'Master...','',0,0,0,0,0,0,0,0,0,0,61447,0,26124),
(97768,'I was a fool to resist the call of Xavius.. behold my power!','',0,0,0,0,0,0,0,0,0,0,52146,0,26124),
(97769,'Val\'sharah will... perish!','',0,0,0,0,0,0,0,0,0,0,52147,0,26124),
(97770,'Insects! I will stomp you into the ground!','',0,0,0,0,0,0,0,0,0,0,52148,0,26124),
(97771,'GRRGHH... My leaves... have fallen...','',0,0,0,0,0,0,0,0,0,0,52149,0,26124),
(97772,'So, you think yourself a hunter, using that little toy to lead you around? Let me show you true strength....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97773,'The shadows.... Everywhere....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97774,'What?! Oh, it\'s you, $n. I was just looking for something. My apologies. I\'ll return to the shop immediately.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97777,'None may challenge the Brotherhood!','None may challenge the Brotherhood!',0,0,0,0,0,0,5,0,1,0,51831,51831,26124),
(97778,'Lap dogs, all of you!','Lap dogs, all of you!',0,0,0,0,0,0,5,0,1,0,51832,51832,26124),
(97779,'Socrethar summons aid from portals around the room!','Socrethar summons aid from portals around the room!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97782,'I apologize for the ruse, but I did not wish to reveal my identity in front of a tribe of known dragonslayers.$b$bI don\'t think they would approve of the real reason I am here.$b$bChampion, do you stand ready to assist me? I shall make it worth your while.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97783,'Ready.','Ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97784,'Very well, champion. Stay close.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97785,'Be on your guard. I have no doubt Deathwing left many traps behind to guard these treasures.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97786,'','Ah, there you are. Lord Illidan has placed my Shivarra at your disposal.',0,0,0,0,0,0,0,0,4,0,0,55319,26124),
(97787,'','A small force has infiltrated the Black Temple, but the Sha\'tari army is still being repelled.',0,0,0,0,0,0,0,0,4,0,0,55318,26124),
(97788,'','We are to obtain the Sargerite Keystone with all due haste and return to aid in the defense.',0,0,0,0,0,0,0,0,4,0,0,55317,26124),
(97790,'','If you will excuse us. Come my dears. Up the volcano to the foothold.',0,0,0,0,0,0,0,0,4,0,0,55316,26124),
(97794,'Not all of these eggs shall survive. But those that do should be free of Deathwing\'s corruption.','',0,0,0,0,0,0,396,0,0,0,62089,0,26124),
(97795,'Keep them off me just a little longer. One of the eggs is starting to hatch.','',0,0,0,0,0,0,396,0,0,0,62090,0,26124),
(97796,'Look! One survived. Such a small thing, and with little black horns.','',0,0,0,0,0,0,1,0,0,0,62091,0,26124),
(97797,'I shall call you Ebonhorn.','',0,0,0,0,0,0,0,0,0,0,62103,0,26124),
(97804,'I will search ahead for the trove. Search for what you are after but do not keep me waiting. This is a dangerous place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97805,'Excellent. Meet me at Krasus\' Landing when you are ready. I\'ve assembled the Argent Crusade\'s finest to join us to rescue Highlord Tirion.','',0,0,0,0,0,0,0,0,0,0,52722,0,26124),
(97806,'The vrykul champion is nowhere to be found. Oh well, the heads of the other champions will have to suffice.','',0,0,0,0,0,0,0,0,0,0,69880,0,26124),
(97807,'You have shown true valor today, and for this I will grant you a boon.','',0,0,0,0,0,0,0,0,0,0,52389,0,26124),
(97808,'Hold aloft your weapon, outsider, and receive a gift from the Titans!','',0,0,0,0,0,0,0,0,0,0,52390,0,26124),
(97809,'It is done. May our power aid you when you need it most.','',0,0,0,0,0,0,0,0,0,0,52391,0,26124),
(97810,'Go forth, champion of the vault!','',0,0,0,0,0,0,0,0,0,0,52392,0,26124),
(97811,'You have shown yourself as a challenger truly worthy of the trials. It was an honor to test you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97812,'You have one more trial, then we can talk about the Bloodtotem joining Mayla\'s crusade.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97813,'Take this drogbar to the cavern below. Slay the ettin. If you survive, we\'ll talk. If he survives, I\'ll leave his group of drogbar alone. Anything goes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97814,'I am ready to receive your gift, Yotnar.','I am ready to receive your gift, Yotnar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97815,'Know that I am Balnazzar. Know that you are but a pawn in plans beyond your reckoning.','',0,0,0,0,0,0,0,0,0,0,52024,0,26124),
(97816,'You have no reason to trust me, but we will have to work together to survive this cave.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97817,'This ettin is formidable. Beware its massive club.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97818,'I will turn you into a weapon of the Legion. I will use your hollow shell to corrupt and destroy everything you have ever loved, piece by piece.','',0,0,0,0,0,0,0,0,0,0,52017,0,26124),
(97819,'Impressive. I did not expect you to attune to the Ashbringer so quickly. No matter, I will finish you off personally.','',0,0,0,0,0,0,0,0,0,0,52036,0,26124),
(97820,'I heard you may have seen Lyndras?','I heard you may have seen Lyndras?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97821,'Haha! Such fun!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97822,'I can get us out of here. I know a secret path.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97823,'Let\'s get out of here!','Let\'s get out of here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97824,'The Bloodtotem are merciless and bloodthirsty. I don\'t think they mean for either of us to make it out of here alive.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97825,'The forest will prevail!','',0,0,0,0,0,0,0,0,0,0,52150,0,26124),
(97826,'Nature shall endure!','',0,0,0,0,0,0,0,0,0,0,52151,0,26124),
(97827,'My branches may bend... but they will not break!','',0,0,0,0,0,0,0,0,0,0,52152,0,26124),
(97828,'The wrath of nature is upon you, demons!','',0,0,0,0,0,0,0,0,0,0,52153,0,26124),
(97829,'Commander, over here!  I have the plans you are looking for.','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(97830,'Pathetic creatures.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97831,'Where is your goddess now?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97832,'Claw marks can be seen around the manhole cover and a trail of ley dust leads off towards Violet Hold.','Claw marks can be seen around the manhole cover and a trail of ley dust leads off towards Violet Hold.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97833,'Look what wandered into my lair.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97834,'Look Razzok, more target practice!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97835,'I will add your corpse to the pile!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97836,'All will fall before Xavius.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97837,'You think you have won?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97838,'Into darkness...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97839,'','Yea, I\'ve seen him. That cursed elf friend of yours came in here and stole one of my ley flame burners! I chased him as far as the sewers before he slipped away. \n\nIf you find him, make sure he returns that burner, they\'re very rare.',5,1,0,3,0,0,0,0,0,0,0,0,26124),
(97840,'I can supply you with the battleship plans you need, but first, you need to prove your worth to the Hand of the Prophet here in Tannan Jungle.','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(97841,'Outsider, you will never lay your hands on the Hammer of Khaz\'goroth! It is my destiny to wield it, not yours.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97842,'As for you, drogbar... We will wipe out your little cave after we throw your corpses off the cliff.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97843,'Bloodtotem, let\'s end this.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(97844,'I can supply you with the battleship plans you need, but first, you need to prove your worth to the Vol\'jin\'s Headhunters here in Tannan Jungle.','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(97845,'','Your gift is worthy, $r. Now let me see about that cloth you need repaired.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(97846,'Foolish mortal! The Tears of Elune are mine now!','',0,0,0,0,0,0,11,0,0,0,52154,0,26124),
(97847,'If Malfurion wants them back so badly, he can seek me out. I\'ll be waiting.','',0,0,0,0,0,0,1,0,0,0,52155,0,26124),
(97848,'You may enter the hold, but I will not put the lives of my guards at risk for your mission. Is that clear?','',0,0,0,0,0,0,1,0,0,0,64641,0,26124),
(97849,'Very well. Do not make me regret trusting you.','',0,0,0,0,0,0,1,0,0,0,64643,0,26124),
(97850,'As crystal, warden.','',0,0,0,0,0,0,1,0,0,0,57447,0,26124),
(97851,'Lower the barrier and evacuate the hold. These Illidari wish to... exchange words... with the eredar.','',0,0,0,0,0,0,1,0,0,0,64634,0,26124),
(97852,'Kirin Tor Protector bows its head slightly in agreement.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97853,'Your ancient rites and rituals mean nothing to me, Yotnar!','',0,0,0,0,0,0,0,0,0,0,52680,0,26124),
(97854,'I will conquer your trials and take the Aegis for my own!','',0,0,0,0,0,0,1,0,0,0,52679,0,26124),
(97855,'Cower here in your cave, while it still stands!','',0,0,0,0,0,0,0,0,0,0,52678,0,26124),
(97856,'The gods will not tolerate your actions, vrykul! You will answer for your heresy!','',0,0,0,0,0,0,0,0,0,0,52366,0,26124),
(97857,'Remember, demon hunter... you were never here.','',0,0,0,0,0,0,1,0,0,0,64638,0,26124),
(97858,'Our foes approach! Let\'s go boys, For Lordaeron!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97859,'Follow me. I shall open the cell for you.','',0,0,0,0,0,0,25,0,0,0,64635,0,26124),
(97860,'','This should help you see a bit better.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97861,'','What was torn has now been mended. I hope you put the Shaldorei Silk to good use. Safe travels.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(97866,'','Hi again. My charm should be somewhere around this pond.$B$BThe mark I have placed on you should help you locate it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97867,'$p?! You would stand before me after so many of your kin have fallen? Release me now and I may yet spare you.','',0,0,0,0,0,0,1,0,0,0,64637,0,26124),
(97868,'I knew the Bloodtotem would never let us live!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97869,'You lookin for that crazy elf? Yea, I seen\'im. He was down here making a huge ruckus and trying to munch on some sorta magical dust or something.$b$bI chased him off though, can\'t have the likes of him hanging around the shop.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(97870,'Where did he run off to?','Where did he run off to?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97880,'Well, I chased him around until he scrambled up a pipe that leads up top in front of Violet Hold. You\'ll probably wanna go looking around up there somewhere.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(97884,'','How about makin\' this place a little more festive, Commander?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97885,'','All this fighting must wear on you. How about a party?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97886,'','Don\'t you just love holidays? I know I do!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97887,'Make my garrison ready for a Hallow\'s Eve party.','Make my garrison ready for a Hallow\'s Eve party.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97888,'Make my garrison ready for a Winter Veil party.','Make my garrison ready for a Winter Veil party.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97889,'The party\'s over. Get rid of these decorations, Izzy.','The party\'s over. Get rid of these decorations, Izzy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97890,'','One last sip of wine...',0,0,0,0,0,0,0,0,0,0,0,51894,26124),
(97895,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-ARCHIMONDEWOD.blp:50:80|t$B[Taldath the Destroyer] The Twinblades... will destroy you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97896,'Where is he?! Where is Varedis? Tell us or die.','',0,0,0,0,0,0,1,0,0,0,57562,0,26124),
(97897,'The Twinblades of the Deceiver could be exactly what we need to strike down the most powerful Legion lords.','',0,0,0,0,0,0,1,0,0,0,57448,0,26124),
(97898,'Lord Illidan taught us to fight fire with fire, to use our enemies\' power against them. I believe we\'ve found our fire.','',0,0,0,0,0,0,1,0,0,0,57449,0,26124),
(97899,'$p, I will meet you at Krasus\' Landing and prepare a fel bat to take you to Suramar. Let the hunt begin!','',0,0,0,0,0,0,1,0,0,0,57561,0,26124),
(97900,'We have lost so many today, I did not think another champion would make it through. Come, we have a hard fight ahead of us. Are you ready?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97901,'Death comes soon.','',0,0,0,0,0,0,0,0,0,0,55332,0,26124),
(97902,'Taste my blade.','',0,0,0,0,0,0,0,0,0,0,55327,0,26124),
(97903,'Hunt this.','',0,0,0,0,0,0,0,0,0,0,55328,0,26124),
(97904,'Pitiful.','',0,0,0,0,0,0,0,0,0,0,55324,0,26124),
(97905,'Die in glorious battle!','',0,0,0,0,0,0,0,0,0,0,55330,0,26124),
(97906,'For Tyranna!','',0,0,0,0,0,0,0,0,0,0,55329,0,26124),
(97907,'I\'m going to destroy you, little demon hunter.','',0,0,0,0,0,0,0,0,0,0,55325,0,26124),
(97908,'Your soul will be mine.','',0,0,0,0,0,0,0,0,0,0,55013,0,26124),
(97909,'A new prisoner for the taking.','',0,0,0,0,0,0,0,0,0,0,55014,0,26124),
(97910,'Your armies are nothing, demon hunter.','',0,0,0,0,0,0,0,0,0,0,55015,0,26124),
(97911,'I\'ll crack open your flesh and feed upon your soul.','',0,0,0,0,0,0,0,0,0,0,55016,0,26124),
(97912,'Into my cage you go.','',0,0,0,0,0,0,0,0,0,0,55017,0,26124),
(97913,'So eager to be enslaved.','',0,0,0,0,0,0,0,0,0,0,55018,0,26124),
(97914,'In this place, you are the hunted.','',0,0,0,0,0,0,0,0,0,0,55019,0,26124),
(97915,'I am your judge, jury, and executioner.','',0,0,0,0,0,0,0,0,0,0,55020,0,26124),
(97917,'Master Moonclaw! What has become of your grove?','Master Moonclaw! What has become of your grove?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97920,'I understand.','I understand.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97934,'Bear witness, foolish elves. I will crush your champion.','',0,0,0,0,0,0,0,0,0,0,52156,0,26124),
(97935,'No! How can... this be?','',0,0,0,0,0,0,0,0,0,0,52157,0,26124),
(97947,'These druids were weak... I hope you have more fight in you than they did!','',0,0,0,0,0,0,0,0,0,0,52113,0,26124),
(97948,'','Getting low on arrows!',0,0,0,0,0,0,0,0,0,0,0,52114,26124),
(97949,'','They\'re coming around again!',0,0,0,0,0,0,0,0,0,0,0,52115,26124),
(97950,'','Back, you bastards!',0,0,0,0,0,0,0,0,0,0,0,52116,26124),
(97951,'','Bring down that bat!',0,0,0,0,0,0,0,0,0,0,0,52117,26124),
(97952,'','On your left!',0,0,0,0,0,0,0,0,0,0,0,52118,26124),
(97953,'','Tear them apart, sisters!',0,0,0,0,0,0,0,0,0,0,0,52119,26124),
(97954,'','Tor ilisar\'thera\'nal!',0,0,0,0,0,0,0,0,0,0,0,52120,26124),
(97955,'','In Elune\'s name!',0,0,0,0,0,0,0,0,0,0,0,52121,26124),
(97956,'Oh ho! What do we have here?','',0,0,0,0,0,0,0,0,0,0,52122,0,26124),
(97957,'','Hold the line!',0,0,0,0,0,0,0,0,0,0,0,52123,26124),
(97958,'','Ahhhh!',0,0,0,0,0,0,0,0,0,0,0,52124,26124),
(97959,'','Make them pay!',0,0,0,0,0,0,0,0,0,0,0,52125,26124),
(97960,'','Mother Moon!',0,0,0,0,0,0,0,0,0,0,0,52126,26124),
(97961,'','Don\'t let them through!',0,0,0,0,0,0,0,0,0,0,0,52127,26124),
(97962,'','Close that gap!',0,0,0,0,0,0,0,0,0,0,0,52128,26124),
(97963,'','Andu-falah-dor!',0,0,0,0,0,0,0,0,0,0,0,52129,26124),
(97964,'','Tohr falla nor dorah!',0,0,0,0,0,0,0,0,0,0,0,52130,26124),
(97965,'Welcome to the Nightmare!','',0,0,0,0,0,0,0,0,0,0,52092,0,26124),
(97966,'Your boldness will not save you this day!','',0,0,0,0,0,0,0,0,0,0,52093,0,26124),
(97967,'Thaon you fool! You\'ve already lost...','',0,0,0,0,0,0,0,0,0,0,52094,0,26124),
(97968,'This Nightmare shall consume you!','',0,0,0,0,0,0,0,0,0,0,52095,0,26124),
(97969,'I underestimated you.','',0,0,0,0,0,0,0,0,0,0,52096,0,26124),
(97970,'You cannot stop the Nightmare!','',0,0,0,0,0,0,0,0,0,0,52097,0,26124),
(97971,'You have entered the Nightmare! There is no exit!','',0,0,0,0,0,0,0,0,0,0,52098,0,26124),
(97972,'Cower in the Nightmare!','',0,0,0,0,0,0,0,0,0,0,52099,0,26124),
(97973,'You cannot wake from this Nightmare!','',0,0,0,0,0,0,0,0,0,0,52100,0,26124),
(97974,'You were foolish to come here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(97975,'The darkness will overwhelm you...','',0,0,0,0,0,0,0,0,0,0,52101,0,26124),
(97976,'You will never defeat us all...','',0,0,0,0,0,0,0,0,0,0,52103,0,26124),
(97978,'You think you\'ve won?','',0,0,0,0,0,0,0,0,0,0,52104,0,26124),
(97981,'Soon, this wretched forest will be bathed in darkness!','',0,0,0,0,0,0,0,0,0,0,52105,0,26124),
(98008,'Azeroth cannot resist its fate forever!','',0,0,0,0,0,0,0,0,0,0,52110,0,26124),
(98020,'What a wonderful time of year!','What a wonderful time of year!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98021,'Let me browse your seasonal fare.','Let me browse your seasonal fare.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(98023,'Damn your spectral sight!','',0,0,0,0,0,0,0,0,0,0,55172,0,26124),
(98029,'','This will be a glorious battle!',0,0,0,0,0,0,0,0,0,0,0,51677,26124),
(98030,'','I will carve your bones!',0,0,0,0,0,0,0,0,0,0,0,52420,26124),
(98031,'','The spirits serve my will!',0,0,0,0,0,0,0,0,0,0,0,52419,26124),
(98032,'','Spirits... you have failed me...',0,0,0,0,0,0,0,0,0,0,0,52418,26124),
(98033,'','Ancestors, give me strength!',0,0,0,0,0,0,0,0,0,0,0,52426,26124),
(98034,'','Mine is the power of the gods!',0,0,0,0,0,0,0,0,0,0,0,52425,26124),
(98035,'','Helheim awaits you, outsider!',0,0,0,0,0,0,0,0,0,0,0,52424,26124),
(98036,'','Ancestors, take me...',0,0,0,0,0,0,0,0,0,0,0,52423,26124),
(98037,'','I will live again...',0,0,0,0,0,0,0,0,0,0,0,52422,26124),
(98038,'','The gods... favor me...',0,0,0,0,0,0,0,0,0,0,0,52421,26124),
(98039,'','You cannot save the Thorignir!',0,0,0,0,0,0,0,0,0,0,0,52438,26124),
(98040,'','I\'ll decorate my dragon with your bones!',0,0,0,0,0,0,0,0,0,0,0,52437,26124),
(98041,'','I shall ride eternal!',0,0,0,0,0,0,0,0,0,0,0,52436,26124),
(98042,'','The next flight... awaits...',0,0,0,0,0,0,0,0,0,0,0,52435,26124),
(98046,'','The Tideskorn will wash you from this land!',0,0,0,0,0,0,0,0,0,0,0,52434,26124),
(98047,'','Your death will be my prize!',0,0,0,0,0,0,0,0,0,0,0,52433,26124),
(98048,'','I will feast in the Halls of Valor!',0,0,0,0,0,0,0,0,0,0,0,52432,26124),
(98049,'','I die... historic...',0,0,0,0,0,0,0,0,0,0,0,52431,26124),
(98050,'','Gods... deem me worthy...',0,0,0,0,0,0,0,0,0,0,0,52430,26124),
(98051,'','I go... to the next battle...',0,0,0,0,0,0,0,0,0,0,0,52429,26124),
(98056,'Pity your allies had to die. Don\'t worry... I\'ll put their souls to good use.','',0,0,0,0,0,0,0,0,0,0,52006,0,26124),
(98057,'You could never be worthy!','',0,0,0,0,0,0,0,0,0,0,52488,0,26124),
(98058,'The kings will spit on you, worm!','',0,0,0,0,0,0,0,0,0,0,52487,0,26124),
(98059,'The God-King has already won!','',0,0,0,0,0,0,0,0,0,0,52486,0,26124),
(98060,'You cannot resist your fate!','',0,0,0,0,0,0,0,0,0,0,52484,0,26124),
(98061,'The runes will break you!','',0,0,0,0,0,0,0,0,0,0,52483,0,26124),
(98062,'The spirits serve my will!','',0,0,0,0,0,0,0,0,0,0,52481,0,26124),
(98063,'Mine is the power of the gods!','',0,0,0,0,0,0,0,0,0,0,52480,0,26124),
(98064,'I will live again...','',0,0,0,0,0,0,0,0,0,0,52478,0,26124),
(98065,'Ancestors, take me...','',0,0,0,0,0,0,0,0,0,0,52477,0,26124),
(98066,'Even... the stone... erodes...','',0,0,0,0,0,0,0,0,0,0,52475,0,26124),
(98067,'You will never prevail...','',0,0,0,0,0,0,0,0,0,0,52474,0,26124),
(98068,'The Halls will not open... to you...','',0,0,0,0,0,0,0,0,0,0,52472,0,26124),
(98069,'The next flight... awaits...','',0,0,0,0,0,0,0,0,0,0,52451,0,26124),
(98070,'You will share the Thorignir\'s fate!','',0,0,0,0,0,0,0,0,0,0,52449,0,26124),
(98071,'You cannot match... our power...','',0,0,0,0,0,0,0,0,0,0,52448,0,26124),
(98072,'I\'ll hack your bones to splinters!','',0,0,0,0,0,0,0,0,0,0,52447,0,26124),
(98073,'Your blood will be my war paint!','',0,0,0,0,0,0,0,0,0,0,52445,0,26124),
(98074,'The crows will feast tonight!','',0,0,0,0,0,0,0,0,0,0,52443,0,26124),
(98075,'I am not... defeated...','',0,0,0,0,0,0,0,0,0,0,52442,0,26124),
(98076,'Death cannot sate my bloodlust...','',0,0,0,0,0,0,0,0,0,0,52441,0,26124),
(98077,'A glorious... ending...','',0,0,0,0,0,0,0,0,0,0,52439,0,26124),
(98078,'This vault belongs to the Tideskorn!','',0,0,0,0,0,0,0,0,0,0,52460,0,26124),
(98079,'You are too late, outsider!','',0,0,0,0,0,0,0,0,0,0,52459,0,26124),
(98080,'You cannot compete with the God-King!','',0,0,0,0,0,0,0,0,0,0,52458,0,26124),
(98081,'The gates are closed to you, outsider!','',0,0,0,0,0,0,0,0,0,0,52457,0,26124),
(98082,'I will send you back to Helheim!','',0,0,0,0,0,0,0,0,0,0,52456,0,26124),
(98083,'We will feed you to the Legion!','',0,0,0,0,0,0,0,0,0,0,52454,0,26124),
(98084,'You cannot escape the Nightmare Lord\'s grasp!','',0,0,0,0,0,0,0,0,0,0,61448,0,26124),
(98085,'I will feast in the High Halls!','',0,0,0,0,0,0,0,0,0,0,52467,0,26124),
(98086,'Die with honor, outsider!','',0,0,0,0,0,0,0,0,0,0,52465,0,26124),
(98087,'I die... historic...','',0,0,0,0,0,0,0,0,0,0,52464,0,26124),
(98088,'Gods... deem me worthy...','',0,0,0,0,0,0,0,0,0,0,52463,0,26124),
(98089,'Death is its own victory...','',0,0,0,0,0,0,0,0,0,0,52462,0,26124),
(98090,'Odyn, ready your halls...','',0,0,0,0,0,0,0,0,0,0,52461,0,26124),
(98091,'This land is doomed!','',0,0,0,0,0,0,0,0,0,40029,61449,0,26124),
(98092,'Your resistance is futile!','',0,0,0,0,0,0,0,0,0,40029,61450,0,26124),
(98093,'You do not see, but you will.','',0,0,0,0,0,0,0,0,0,40029,61451,0,26124),
(98094,'You were warned.','',0,0,0,0,0,0,0,0,0,40029,61452,0,26124),
(98095,'You cannot escape!','',0,0,0,0,0,0,0,0,0,0,52491,0,26124),
(98096,'Will the night elves mourn you, I wonder?','',0,0,0,0,0,0,0,0,0,40029,61454,0,26124),
(98097,'You will never leave!','',0,0,0,0,0,0,0,0,0,0,52490,0,26124),
(98098,'Looking for a fight? Allow me...','',0,0,0,0,0,0,0,0,0,40029,61455,0,26124),
(98099,'Your corpse is another gift for Helya!','',0,0,0,0,0,0,0,0,0,0,52489,0,26124),
(98100,'Pity. You could have joined us...','',0,0,0,0,0,0,0,0,0,40029,61456,0,26124),
(98101,'You would die for this pathetic land?','',0,0,0,0,0,0,0,0,0,40029,61457,0,26124),
(98102,'I will wear your bones!','',0,0,0,0,0,0,0,0,0,0,52497,0,26124),
(98103,'Drown in agony!','',0,0,0,0,0,0,0,0,0,0,52496,0,26124),
(98104,'The mists take you!','',0,0,0,0,0,0,0,0,0,0,52495,0,26124),
(98105,'I return to the mists...','',0,0,0,0,0,0,0,0,0,0,52499,0,26124),
(98106,'Helya, take me...','',0,0,0,0,0,0,0,0,0,0,52494,0,26124),
(98107,'Is the curse... ended?','',0,0,0,0,0,0,0,0,0,0,52493,0,26124),
(98108,'My war... is eternal...','',0,0,0,0,0,0,0,0,0,0,52492,0,26124),
(98109,'You will serve willingly, or in chains!','',0,0,0,0,0,0,0,0,0,0,52403,0,26124),
(98110,'The high halls will burn!','',0,0,0,0,0,0,0,0,0,0,52401,0,26124),
(98111,'I will break you against the gates!','',0,0,0,0,0,0,0,0,0,0,52402,0,26124),
(98112,'You have not begun to know destruction!','',0,0,0,0,0,0,0,0,0,0,52412,0,26124),
(98113,'The earth will shatter at the Legion\'s coming!','',0,0,0,0,0,0,0,0,0,0,52411,0,26124),
(98114,'Our devastation will be absolute!','',0,0,0,0,0,0,0,0,0,0,52410,0,26124),
(98115,'You cannot hope to survive!','',0,0,0,0,0,0,0,0,0,0,52409,0,26124),
(98116,'We will not stop...','',0,0,0,0,0,0,0,0,0,0,52408,0,26124),
(98117,'Do not think... you\'ve won...','',0,0,0,0,0,0,0,0,0,0,52407,0,26124),
(98118,'You fight the inevitable...','',0,0,0,0,0,0,0,0,0,0,52406,0,26124),
(98119,'We do not fear death...','',0,0,0,0,0,0,0,0,0,0,52405,0,26124),
(98120,'The dragons bend to my will!','',0,0,0,0,0,0,0,0,0,0,52526,0,26124),
(98121,'Your soul will be made to serve!','',0,0,0,0,0,0,0,0,0,0,52414,0,26124),
(98122,'Your pitiful trials will not save you from the Legion!','',0,0,0,0,0,0,0,0,0,0,52413,0,26124),
(98123,'Your future will know only despair!','',0,0,0,0,0,0,0,0,0,0,52393,0,26124),
(98124,'I feel your will... draining...','',0,0,0,0,0,0,0,0,0,0,52394,0,26124),
(98125,'Your fate is only death!','',0,0,0,0,0,0,0,0,0,0,52400,0,26124),
(98126,'I will shatter your soul!','',0,0,0,0,0,0,0,0,0,0,52399,0,26124),
(98127,'Death is only temporary...','',0,0,0,0,0,0,0,0,0,0,52398,0,26124),
(98128,'You cannot stop what is coming. Even in your dreams.','',0,0,0,0,0,0,0,0,0,0,61465,0,26124),
(98129,'You cannot escape our eyes...','',0,0,0,0,0,0,0,0,0,0,52397,0,26124),
(98130,'Humor me... scream for help!','',0,0,0,0,0,0,0,0,0,0,61466,0,26124),
(98131,'Let me show you what happens to heroes.','',0,0,0,0,0,0,0,0,0,0,61467,0,26124),
(98132,'If I cannot bend your mind, I will break your body.','',0,0,0,0,0,0,0,0,0,0,61468,0,26124),
(98133,'I see only darkness...','',0,0,0,0,0,0,0,0,0,0,52396,0,26124),
(98134,'The darkness consumes...','',0,0,0,0,0,0,0,0,0,0,52395,0,26124),
(98135,'My life... for the master...','',0,0,0,0,0,0,0,0,0,0,61469,0,26124),
(98136,'The dark beyond... awaits me.','',0,0,0,0,0,0,0,0,0,0,61470,0,26124),
(98137,'The master will destroy... your soul!','',0,0,0,0,0,0,0,0,0,0,61471,0,26124),
(98138,'Foolish mortal! You cannot win...','',0,0,0,0,0,0,0,0,0,0,61472,0,26124),
(98139,'Without hope, there can be no despair.','',0,0,0,0,0,0,0,0,0,0,61473,0,26124),
(98140,'It stirs, faceless, forgotten... deathless.','',0,0,0,0,0,0,0,0,0,0,61474,0,26124),
(98141,'The abyss whispers your name.','',0,0,0,0,0,0,0,0,0,0,61475,0,26124),
(98142,'Madness beckons me beyond...','',0,0,0,0,0,0,0,0,0,0,61476,0,26124),
(98143,'','Fighting this is futile, hero. None can resist the master.',0,0,0,0,0,0,0,0,0,0,0,52051,26124),
(98144,'','Strike now! Focus on the night elves\' champion!',0,0,0,0,0,0,0,0,0,0,0,52052,26124),
(98145,'','Press onward, demons! Destroy the temple!',0,0,0,0,0,0,0,0,0,0,0,52053,26124),
(98147,'','Slay the night elves and their champion! Water the land with blood!',0,0,0,0,0,0,0,0,0,0,0,52055,26124),
(98148,'','Kill these intruders, my children. Your queen commands it!',0,0,0,0,0,0,0,0,0,0,0,52056,26124),
(98149,'','To me, my flight! Eradicate these pests!',0,0,0,0,0,0,0,0,0,0,0,52057,26124),
(98150,'','Breathe deep, hero. Taste the essence of the Emerald Nightmare!',0,0,0,0,0,0,0,0,0,0,0,52058,26124),
(98151,'','I will choke you with terror and drive you from this place howling.',0,0,0,0,0,0,0,0,0,0,0,52059,26124),
(98152,'','Scatter, little ones. Scurry until your feet bleed and your lungs scream.',0,0,0,0,0,0,0,0,0,0,0,52060,26124),
(98153,'','Exhale the last of your hope. Inhale horror and ruination.',0,0,0,0,0,0,0,0,0,0,0,52061,26124),
(98154,'','I fought for you, believed in you! I was such a fool!',0,0,0,0,0,0,0,0,0,0,0,52062,26124),
(98155,'','End this torment! Kill me, or I will surely kill you!',0,0,0,0,0,0,0,0,0,0,0,52063,26124),
(98156,'','Faith. Duty. Just words! None of it matters!',0,0,0,0,0,0,0,0,0,0,0,52064,26124),
(98157,'','Am I dreaming? Then why can I not wake? Why?!',0,0,0,0,0,0,0,0,0,0,0,52065,26124),
(98160,'','I can no longer see your future, champion. I think you die here today.',0,0,0,0,0,0,0,0,0,0,0,52068,26124),
(98162,'','Forgive me. It felt... so real...',0,0,0,0,0,0,0,0,0,0,0,52070,26124),
(98163,'','At last! With this victory, despair takes root on Azeroth!',0,0,0,0,0,0,0,0,0,0,0,52071,26124),
(98164,'Destroy them, and gather the fragments of the blade, for they will be the heart of your new weapon.','',0,0,0,0,0,0,0,0,1,0,52479,0,26124),
(98165,'I now mark you with my sigil, let all recognize you as the enforcer of my will.','',0,0,0,0,0,0,0,0,0,0,52453,0,26124),
(98166,'Go, ensure that not a single demon escapes my wrath! Crush all who stand in your way!','',0,0,0,0,0,0,0,0,0,0,52450,0,26124),
(98167,'After you, $p.','',0,0,0,0,0,0,1,0,0,0,57450,0,26124),
(98168,'','Sylvanas will not escape...',0,0,0,0,0,0,0,0,0,0,0,52511,26124),
(98169,'','Gilneas... will rise...',0,0,0,0,0,0,0,0,0,0,0,52510,26124),
(98170,'','Greymane... avenge me...',0,0,0,0,0,0,0,0,0,0,0,52509,26124),
(98171,'','You cannot escape justice...',0,0,0,0,0,0,0,0,0,0,0,52508,26124),
(98172,'','Sylvanas cannot hide from justice!',0,0,0,0,0,0,0,0,0,0,0,52507,26124),
(98173,'','I\'ll tear you to ribbons!',0,0,0,0,0,0,0,0,0,0,0,52506,26124),
(98174,'','The Horde will pay for their treachery!',0,0,0,0,0,0,0,0,0,0,0,52505,26124),
(98175,'','For the Alliance!',0,0,0,0,0,0,0,0,0,0,0,52504,26124),
(98176,'','For Gilneas!',0,0,0,0,0,0,0,0,0,0,0,52503,26124),
(98177,'','We will have retribution!',0,0,0,0,0,0,0,0,0,0,0,52502,26124),
(98178,'','Give us the Banshee Queen!',0,0,0,0,0,0,0,0,0,0,0,52501,26124),
(98179,'You seek the Aegis... but will you claim it, or die trying? There is no compromise in this.','',0,0,0,0,0,0,0,0,0,0,52512,0,26124),
(98180,'Are you worthy? Only the gods may decide.','',0,0,0,0,0,0,0,0,0,0,52513,0,26124),
(98181,'Oh, back from the dead are we? Outstanding. Really, truly impressive!','',0,0,0,0,0,0,0,0,0,0,52514,0,26124),
(98182,'','Come on, you bilge-rats! I\'ll give you a burial at sea!',0,0,0,0,0,0,5,0,0,0,0,52515,26124),
(98183,'','Wretched mortal - your soul belongs to me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98184,'','What?! Impossible... What manner of being are you?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98185,'','Remember our bargain, banshee. Do not dare to cross me...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98186,'','You heard Nathanos. No survivors!',0,0,0,0,0,0,0,0,0,0,0,52519,26124),
(98187,'','That should be enough. Get up to the top deck.',0,0,0,0,0,0,0,0,0,0,0,52520,26124),
(98188,'','Hang on tight and try not to scream - Duchess has very sensitive ears.',0,0,0,0,0,0,0,0,0,0,0,52521,26124),
(98189,'For the Dark Lady! For Sylvanas!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98190,'Impossible...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98191,'No... it can\'t be...','',0,0,0,0,0,0,0,0,0,0,52524,0,26124),
(98192,'','I\'m usually quite cheery this time of year, but it\'s hard to be merry when Grumpus is about.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98193,'Victory! You\'ve rescued the little bear.$b$b%s paws at you, trying to get your attention.','',0,0,0,0,0,0,0,0,17,0,0,0,26124),
(98194,'Attack incoming! Defeat the attacking sprites.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(98197,'Is it time to know your future? Perhaps your end?','',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(98198,'%s looks panicked.$b$bClick the baby bear again to offer help.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(98199,'Time sheds from all of our bodies like fresh molt. How many feathers have you left to lose? Maybe Ikalyi can say.','',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(98200,'Let\'s hear about my future, Ikalyi.','Let\'s hear about my future, Ikalyi.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98201,'$n, will you use your spectral sight on the cave entrance? Something\'s not right.','',0,0,0,0,0,0,0,0,0,0,55233,0,26124),
(98202,'Tell me, $R, what beast of Draenor is your heart\'s ward?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(98203,'Don\'t let them cross that bridge or I\'ll have your hides!','',0,0,0,0,0,0,1,0,0,35496,54819,0,26124),
(98204,'','I\'m usually quite cheery this time of year, but it\'s hard to be merry when Grumpus is about.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98205,'No outsider will wield the Hammer of Khaz\'goroth! Flay them alive!','',0,0,0,0,0,0,25,0,0,35496,54818,0,26124),
(98206,'Tear them limb from limb! Spread their blood on the fields!','',0,0,0,0,0,0,5,0,0,35496,54817,0,26124),
(98207,'Excellent work. Speak to Patricia about a new recipe.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(98208,'You should talk to Patricia. I believe she can offer you a new recipe.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(98209,'This land is dense with the departed. My magic will make them feel more welcome here.','',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(98210,'Say the word if you require assistance, $p.','',0,0,0,0,0,0,1,0,0,0,57451,0,26124),
(98211,'','I heard a passing adventurer mention something about a tailor setting up shop in Azsuna, within the Greenway.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98212,'We are Bloodtotem! Would you let the weak overcome us?!','',0,0,0,0,0,0,6,0,0,35496,54816,0,26124),
(98213,'','We need to be out there searching for the Hammer. Tradition can wait.',5,0,0,0,0,0,0,0,0,0,0,54296,26124),
(98214,'I can\'t wait to get home!','I can\'t wait to get home!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98215,'Get me out of here!','Get me out of here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98216,'Those grumplings sure smell funny.','Those grumplings sure smell funny.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98217,'Thank you.','Thank you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98218,'Sure is cold here!','Sure is cold here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98219,'Let\'s see, did I remember the spritethorn needles...?','',0,0,0,0,0,0,0,0,0,35518,0,0,26124),
(98220,'Oh blast! I left my thimbles in my room!','',0,0,0,0,0,0,5,0,0,35518,0,0,26124),
(98221,'One... two... three, four... yes. They\'re all here.','',0,0,0,0,0,0,0,0,0,35518,0,0,26124),
(98222,'How can they see us?','',0,0,0,0,0,0,0,0,0,0,56998,0,26124),
(98223,'They have the spectral sight!','',0,0,0,0,0,0,0,0,0,0,56999,0,26124),
(98224,'Finish them. Recast the cloaking spell.','',0,0,0,0,0,0,0,0,0,0,57000,0,26124),
(98225,'This simply will not do. I MUST find better accommodations.','',0,0,0,0,0,0,0,0,0,35518,0,0,26124),
(98226,'Shame about that fellow that was living here before. But you did what you had to, Lyndras, to survive.','',0,0,0,0,0,0,0,0,0,35518,0,0,26124),
(98227,'Maybe if I explain that I was just borrowing it, they\'ll have me back. No, no, no! Tytallo would never go for that.','',0,0,0,0,0,0,0,0,0,35518,0,0,26124),
(98229,'The Path of Huln follows in the footsteps of Huln\'s last and greatest hunt.','',0,0,0,0,0,0,0,0,0,0,54865,0,26124),
(98232,'Please, use my table in the middle of the room to perform your tasks. You\'ll find some Runic Catgut on it as well.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98233,'Torok will not trouble the Stonedark again. Let\'s head to the homeland of my people.','',0,0,0,0,0,0,0,0,0,35605,54761,0,26124),
(98234,'','I just got a fresh shipment of Runic Catgut, $n. If your supply is low, you can buy some from me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98235,'Let me know when you are ready to continue, champion.','',0,0,0,0,0,0,1,0,0,0,54266,0,26124),
(98236,'No rush, Champion. We are just in the middle of a field of ettins. I am sure nothing bad could possibly happen.','',0,0,0,0,0,0,1,0,0,0,54263,0,26124),
(98237,'We should really keep moving.','',0,0,0,0,0,0,1,0,0,0,54264,0,26124),
(98238,'Is it wise to wait in a field of ettins?','',0,0,0,0,0,0,1,0,0,0,54265,0,26124),
(98239,'You have proven yourself the greatest living warrior on Azeroth. It is for this reason I have saved you.','',0,0,0,0,0,0,0,0,14,0,60361,0,26124),
(98240,'Why have you brought me here?','Why have you brought me here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98241,'Alright, bruls, get to work!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98242,'I have foreseen the coming of a mighty champion to these shores. One who would slay countless foes and prove their valor time and again. One who would lead my armies to victory against the great darkness that seeks to devour this world!','',0,0,0,0,0,0,0,0,14,0,60362,0,26124),
(98243,'What do you propose?','What do you propose?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98244,'I name you Valarjar! Bring glory to these halls on the wings of my val\'kyr!','',0,0,0,0,0,0,0,0,14,0,60363,0,26124),
(98245,'','Oh, $n, I have some Spritethorns for sale if you need any for your bag recipe.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98246,'Keep your wits about you, $p. Varedis will be a cunning adversary.','',0,0,0,0,0,0,0,0,0,0,58218,0,26124),
(98247,'For Sylvanas!','',0,0,0,0,0,0,0,0,0,0,52553,0,26124),
(98248,'','For Sylvanas!',0,0,0,0,0,0,0,0,0,0,0,52541,26124),
(98249,'Death to the living!','',0,0,0,0,0,0,0,0,0,0,52554,0,26124),
(98250,'I will feast on your bones!','',0,0,0,0,0,0,0,0,0,0,52555,0,26124),
(98251,'Join us in death!','',0,0,0,0,0,0,0,0,0,0,52556,0,26124),
(98252,'Abandon hope!','',0,0,0,0,0,0,0,0,0,0,52557,0,26124),
(98253,'You will suffer as we have!','',0,0,0,0,0,0,0,0,0,0,52558,0,26124),
(98254,'For the Dark Lady!','',0,0,0,0,0,0,0,0,0,0,52559,0,26124),
(98255,'Now you die!','',0,0,0,0,0,0,0,0,0,0,52560,0,26124),
(98256,'','Death to the living!',0,0,0,0,0,0,0,0,0,0,0,52542,26124),
(98257,'','I will feast on your bones!',0,0,0,0,0,0,0,0,0,0,0,52543,26124),
(98258,'','Join us in death!',0,0,0,0,0,0,0,0,0,0,0,52544,26124),
(98259,'','Abandon hope!',0,0,0,0,0,0,0,0,0,0,0,52545,26124),
(98260,'','You will suffer as we have!',0,0,0,0,0,0,0,0,0,0,0,52546,26124),
(98261,'','For the Dark Lady!',0,0,0,0,0,0,0,0,0,0,0,52547,26124),
(98262,'','Now you die!',0,0,0,0,0,0,0,0,0,0,0,52548,26124),
(98263,'Oh... not this again...','',0,0,0,0,0,0,0,0,0,0,52561,0,26124),
(98264,'Ah... at last...','',0,0,0,0,0,0,0,0,0,0,52562,0,26124),
(98265,'Dark Lady...','',0,0,0,0,0,0,0,0,0,0,52563,0,26124),
(98266,'No... no...','',0,0,0,0,0,0,0,0,0,0,52564,0,26124),
(98267,'','Oh... not this again...',0,0,0,0,0,0,0,0,0,0,0,52549,26124),
(98268,'','Ah... at last...',0,0,0,0,0,0,0,0,0,0,0,52550,26124),
(98269,'','Dark Lady...',0,0,0,0,0,0,0,0,0,0,0,52551,26124),
(98270,'','No... no...',0,0,0,0,0,0,0,0,0,0,0,52552,26124),
(98271,'They won\'t escape us. Illidari, attack!','',0,0,0,0,0,0,0,0,0,0,55234,0,26124),
(98272,'The fel lord is just ahead.','',0,0,0,0,0,0,0,0,0,0,55237,0,26124),
(98273,'We cannot launch our attack until we\'re sure we won\'t be flanked.','',0,0,0,0,0,0,274,0,0,0,55264,0,26124),
(98274,'I would have sundered your forces...','',0,0,0,0,0,0,0,0,0,0,55173,0,26124),
(98275,'','We\'re doing important work here in Feralas.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(98276,'','Yes. Let\'s be certain to take care of that.',0,0,0,0,0,0,1,0,0,0,0,55091,26124),
(98277,'Deucus sent me. He says you can help calibrate this burette.','Deucus sent me. He says you can help calibrate this burette.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98278,'Your aid to the Thorignir will not go unrewarded, outsider. $B$BIf you truly wish the blessing of our brood, then help us to rid this scourge from our home.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98279,'The deeds you have done are great, but we have not finished here yet. $B$BSpeak to me when you are ready to ascend to the mountain\'s summit.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98280,'When you have finished your business here, speak to me and I will fly you to the summit. $B$BOnce we leave, we may not return.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98281,'God-King Skovald summons a squad of Felskorn vrykul!','God-King Skovald summons a squad of Felskorn vrykul!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98282,'Fly me to the summit, Vethir.','Fly me to the summit, Vethir.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98283,'God-King Skovald summons a Felblaze Brute!','God-King Skovald summons a Felblaze Brute!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98284,'God-King Skovald summons a pack of felstalkers!','God-King Skovald summons a pack of felstalkers!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98285,'Odyn believes you are worthy to wield the Armaments of the Black Wyrm. I am here for Magnar Icebreaker. Let us both be successful, eh?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(98286,'','Your ties to this reality are but threads. Care to cut a few?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98287,'','Don\'t be scared. My brews only show you what was already there to begin with.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98288,'Who is Magnar Icebreaker?','Who is Magnar Icebreaker?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98289,'Welcome, my friends, to the Vault of Neltharion. Or as the world came to know him: Deathwing.','',0,0,0,0,0,0,396,0,0,0,54262,0,26124),
(98290,'Magnar Icebreaker was one of the greatest heroes of our time. He won many victories, became king, and crafted the greatest weapons I have ever seen, including the Armaments of the Black Wyrm.\n\nHe lost only one battle, his last. We were betrayed by jealous warriors led by cultists of Helira, that dark witch! They killed me first before we could react and he would not command after that.\n\nThey crafted his tomb with reverence, but he did not move on to the Halls of Valor. I hope his rage has not driven him to madness. He deserves to be here.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(98291,'We gave everything for the Ashbringer... you gave everything, $n. Tirion would be proud to see you wielding that blade.','',0,0,0,0,0,0,66,0,0,0,54097,0,26124),
(98292,'Let us go to the tomb.','Let us go to the tomb.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98293,'Come champion, I will need your help while the time scars are fresh.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98294,'Welcome, my friends, to the Vault of Neltharian.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98295,'Our journey will be a quick one. A single leap from Skyhold will take us to Azeroth. Follow me!','',0,0,0,0,0,0,396,0,0,0,60357,0,26124),
(98296,'Wrathion?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98297,'No. But if this is indeed Neltharian\'s Vault, he will prove useful.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98298,'','Can we trust this creature?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98299,'Commander, over here!  I have the plans you are looking for.','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(98300,'','If you deep-dwellers touched a hair on Moozy\'s head you\'ll never leave that cave alive!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(98301,'','Give Moozy back! Where is he?!',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(98302,'Krimple\'s the name, precision\'s my game!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(98303,'The others should be waiting for you in the sanctum beneath Light\'s Hope Chapel, $n. You should make haste.','',0,0,0,0,0,0,1,0,0,0,54098,0,26124),
(98304,'Don\'t know what ya heard, but my numbers are exact. EXACT, I tell ya!','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(98305,'What a wonderful time of year!','What a wonderful time of year!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98306,'No matter how many presents there are, we could always use more!','No matter how many presents there are, we could always use more!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98307,'\'Tis the season!','\'Tis the season!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98308,'Happy holidays!','Happy holidays!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98309,'Let\'s make this the most wonderful holiday ever!','Let\'s make this the most wonderful holiday ever!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98312,'What\'s the holiday without a lil\' smooch?','What\'s the holiday without a lil\' smooch?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98313,'','Lifespring Cavern is to the west. Meet me there when you can.',0,0,0,0,0,0,0,0,0,0,0,54749,26124),
(98316,'','There is harmony in precision, $r.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(98317,'A glorious landing! Are you ready to find Magnar?','',0,0,0,0,0,0,66,0,0,0,60384,0,26124),
(98318,'His tomb is not far.','',0,0,0,0,0,0,396,0,0,0,60385,0,26124),
(98319,'They buried him here after his only defeat...','',0,0,0,0,0,0,397,0,0,0,60422,0,26124),
(98320,'Desecrators! We must slay these abominations!','',0,0,0,0,0,0,22,0,0,0,60423,0,26124),
(98321,'A good fight! Follow me. I will open the tomb.','',0,0,0,0,0,0,0,0,0,0,60394,0,26124),
(98322,'The guardians do not obey me! Seems we will have to do this the hard way.','',0,0,0,0,0,0,396,0,0,0,60395,0,26124),
(98323,'We should be able to leap over this.','',0,0,0,0,0,0,273,0,0,0,60397,0,26124),
(98324,'Champion, we must save him! I will find the words to spur him on to the Halls of Valor, but he may resist the truth and turn his guards against me.','',0,0,0,0,0,0,396,0,0,0,60403,0,26124),
(98325,'Say the word and we shall begin.','',0,0,0,0,0,0,396,0,0,0,60404,0,26124),
(98326,'Father, it\'s me... your son. Odyn sent me here to--','',0,0,0,0,0,0,1,0,0,0,60405,0,26124),
(98327,'My son died before my very eyes. I FAILED to protect him! You will not--','',0,0,0,0,0,0,1,0,0,0,60410,0,26124),
(98328,'Gotta start somewhere!$B$BNow if you\'ll excuse me, I have some very important business to attend to.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98329,'It IS me. I fell before you in the battle of the Pass. We were betrayed!','',0,0,0,0,0,0,1,0,0,0,60409,0,26124),
(98330,'I fell in battle. We ALL fell. None survived the onslaught. Not even you!','',0,0,0,0,0,0,1,0,0,0,60411,0,26124),
(98331,'Lies! Can you not see my faithful soldiers?!','',0,0,0,0,0,0,1,0,0,0,60412,0,26124),
(98332,'You died in glorious battle! The Halls of Valor await. Come with me, father!','',0,0,0,0,0,0,603,0,0,0,60413,0,26124),
(98333,'Who are you, demon? Why do you torment me so?','',0,0,0,0,0,0,1,0,0,0,60415,0,26124),
(98334,'LIAR! You will DIE for saying his name! I shall send you to Helheim myself!','',0,0,0,0,0,0,603,0,0,0,60417,0,26124),
(98335,'Four, five... six...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98336,'You are not my son! He is in the Halls of Valor, called by Odyn before his time!','',0,0,0,0,0,0,603,0,0,0,60407,0,26124),
(98337,'I am the son of Magnar the Great, Champion of the Valarjar. Father, look at me! I am Hruthnir. I am your son!','',0,0,0,0,0,0,1,0,0,0,60416,0,26124),
(98338,'His weapons are yours now, champion. There is nothing left for us here. Let us feast in the Halls of Valor, together!','',0,0,0,0,0,0,1,0,0,0,60421,0,26124),
(98339,'Hmm... eight? Aw, not again...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98340,'One, two...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98341,'Such a small, fragile body. Yet it holds such power.','',0,0,0,0,0,0,0,0,0,0,53184,0,26124),
(98342,'','What is it? Precision requires focus, you know.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(98343,'Break time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98344,'Welp, better get back to it. These presents won\'t count themselves.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98345,'','Hello again. A true, true friend helps a friend indeed.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(98346,'$n, you\'ve arrived! The Sanctum of Light is just ahead. This way.','$n, you\'ve arrived! The Sanctum of Light is just ahead. This way.',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(98347,'Go forth, Ysera! Destroy all who stand in your way.','',0,0,0,0,0,0,25,0,0,0,53185,0,26124),
(98351,'I would like to build another destroyer.','I would like to build another destroyer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98352,'','Deucus is an old fla--er, friend. I\'d be happy to calibrate the burette for you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98353,'We checked every bulb, didn\'t we?$B$BMaybe we oughta check \'em again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98354,'','Let\'s go, $n. This moisture makes my joints hurt; make it snappy.',0,0,0,0,0,0,0,0,0,0,0,54750,26124),
(98355,'This place can never have too much holiday spirit!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98356,'Lousy holiday bonus. Who needs a Smokeywood Pastures lifetime membership anyway?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98357,'You didn\'t happen to see a squirrel running about, did you? Damn thing came in with the trees...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98358,'Could use a few more decorations around here. Wouldn\'t want our neighbors showing us up with their decorations this season, would we?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98359,'I will not be undone by some mortal filth! I am the Earth Warder!','',0,0,0,0,0,0,0,0,0,0,54866,0,26124),
(98360,'','There, much better. Please give my best to Deucus.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98364,'I would like to build a destroyer.','I would like to build a destroyer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98365,'','Deucus Valdera? A blustery fellow, but honorable. I will be pleased to assist you with calibration.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98367,'','I\'ve done my best to calibrate the burette. Give Deucus my regards.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98369,'Deucus? That undead has some nerve! Called me a cheater once... but I suppose I can forgive him. Lemme see...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98370,'','Behind you lies the Eye of Odyn, which peers across all of Azeroth! This way lies the Forge, where the mightiest weapons of the valarjar are crafted by Helgar, the greatest smith in the Halls.',0,0,0,0,0,0,0,0,0,0,0,60358,26124),
(98371,'Here ya go! Tell Deucus I treated ya fair \'n square!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98372,'','Odyn awaits ahead. I will go forth and announce you. Be respectful!',0,0,0,0,0,0,0,0,0,0,0,60360,26124),
(98374,'','Deucus? I thought he was dead! Of course I would be happy to help my old friend.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98375,'','Perfect calibration! Tell Deucus I shall make a trip to Dalaran soon to say hello.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98376,'The Data Extratinator 3000 might be able to decipher this core. Cross your fingers that it doesn\'t explode in the process.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98377,'Deucus always sends me the most challenging puzzles to solve! Let\'s see that burette!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98378,'This core contains a script written in an ancient Highborne dialect, which I can\'t read. Professor Pallin in the Scribes\' Sacellum may be able to translate this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98379,'Perfection! You can now make potions with precise exactitude!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98380,'I will signal my contacts on the other side of the tunnel. Meet me there as soon as you are able.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98381,'Thank you again, hero. You have just given the Black Dragonflight a second chance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98382,'','I really must make a trip to Dalaran sometime.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(98383,'Start construction on our first transport.','Start construction on our first transport.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98385,'Battlelord, your forces will assault The Doom Fortress to the southeast. Stop the mass of their demons from attacking us.','Battlelord, your forces will assault The Doom Fortress to the southeast. Stop the mass of their demons from attacking us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98386,'The dead are rising! Something is not right...','',0,0,0,0,0,0,396,0,0,0,60386,0,26124),
(98387,'Rest well, my brother.','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(98388,'These warriors are restless! They must sense some kind of disturbance...','',0,0,0,0,0,0,378,0,0,0,60387,0,26124),
(98389,'Onward! We are almost to Magnar\'s tomb.','',0,0,0,0,0,0,397,0,0,0,60388,0,26124),
(98390,'','Watch yourself down there... that doesn\'t look like Westfall stew in those cauldrons.',0,0,0,0,0,0,1,0,0,0,0,52973,26124),
(98391,'','Hop on. We\'ll check every ship if we have to!',0,0,0,0,0,0,1,0,0,0,0,52972,26124),
(98392,'','Slay these unholy creatures! For the Alliance!',0,0,0,0,0,0,5,0,0,0,0,52971,26124),
(98393,'','No sign of her. Let\'s keep looking.',0,0,0,0,0,0,1,0,0,0,0,52974,26124),
(98394,'','Those are royal guards... This must be her flagship. Seize the captain!',0,0,0,0,0,0,1,0,0,0,0,52975,26124),
(98395,'','The Skyfire is being overrun. Come on, we have to help!',0,0,0,0,0,0,5,0,0,0,0,52978,26124),
(98396,'My thanks, brul! I shall remember you always.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98397,'We are free? Free? No more dragons? No more wyrms?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98398,'Huln said he would free us. Are you with Huln?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98399,'Death to the tyrants! Death to Deathwing and his brood!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98400,'It will be as you say.','',0,0,0,0,0,0,0,0,0,0,55044,0,26124),
(98402,'Ashtongue with me!','',0,0,0,0,0,0,0,0,0,0,55045,0,26124),
(98403,'Please forgive me: I must warn the others. Elune be with you.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(98404,'','Most powerful Odyn, I bring you $n. They have slain the great pit lord Malgalor showing true valor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98410,'Behold my warriors! See my greatest champion, Skylord $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98414,'','Champion! It\'s good to see you. Vrykul aren\'t known for their hospitality.',0,0,0,0,0,0,0,0,0,0,0,53018,26124),
(98415,'','Psst... over here!',0,0,0,0,0,0,0,0,0,0,0,53019,26124),
(98416,'','Champion, over here! Quick, before the drakes catch your scent!',0,0,0,0,0,0,0,0,0,0,0,53020,26124),
(98417,'','The God-King hasn\'t won yet. Let\'s take those dragons back!',0,0,0,0,0,0,0,0,0,0,0,53021,26124),
(98418,'','For Gilneas!',0,0,0,0,0,0,0,0,0,0,0,53022,26124),
(98419,'','Hey, it\'s you! I\'m getting stir-crazy here - please tell me we\'re going in!',0,0,0,0,0,0,0,0,0,0,0,58279,26124),
(98420,'','This way, there\'s a good spot right here.',0,0,0,0,0,0,0,0,0,0,0,58280,26124),
(98421,'','Hey, over here! I\'ve got a plan!',0,0,0,0,0,0,0,0,0,0,0,58281,26124),
(98422,'','I feel like that guy having a dragon is a bad thing.',0,0,0,0,0,0,0,0,0,0,0,58282,26124),
(98423,'','Yes! Finally, some action!',0,0,0,0,0,0,0,0,0,0,0,58283,26124),
(98424,'Lower your weapon, outsider. I do not wish to harm you.','',0,0,0,0,0,0,0,0,0,0,53031,0,26124),
(98425,'Wait... you are not like the others...','',0,0,0,0,0,0,0,0,0,0,53032,0,26124),
(98426,'The demon binds me... please help...','',0,0,0,0,0,0,0,0,0,0,53033,0,26124),
(98427,'The Drekirjar have upset our ancient pact.','',0,0,0,0,0,0,0,0,0,0,53034,0,26124),
(98428,'It is time they face the consequences.','',0,0,0,0,0,0,0,0,0,0,53035,0,26124),
(98429,'Even as someone not of this land, you chose to save us from a wretched fate.','',0,0,0,0,0,0,1,0,0,0,53036,0,26124),
(98430,'You have passed the Trial of Will, and you have also gained an ally.','',0,0,0,0,0,0,1,0,0,0,53037,0,26124),
(98431,'Hold aloft your weapon, outsider. Accept the power of storm and thunder as a gift for your selfless acts.','',0,0,0,0,0,0,1,0,0,0,53038,0,26124),
(98432,'Take wing with Vethir, friend, and show these vrykul the true fury of the storm!','',0,0,0,0,0,0,0,0,0,0,53039,0,26124),
(98433,'The storm will purge Skovald from this land!','',0,0,0,0,0,0,0,0,0,0,53015,0,26124),
(98434,'The unworthy will be thrashed in the gale winds!','',0,0,0,0,0,0,0,0,0,0,53016,0,26124),
(98435,'Suffer the wrath of the Thorignir!','',0,0,0,0,0,0,0,0,0,0,53017,0,26124),
(98436,'The Thorignir owe you a debt of gratitude, outsider.','',0,0,0,0,0,0,0,0,0,0,53028,0,26124),
(98437,'Your trials are far from over. When you need me again, I shall be ready.','',0,0,0,0,0,0,0,0,0,0,53029,0,26124),
(98438,'It seems that a messenger awaits. May the gale winds carry you, friend.','',0,0,0,0,0,0,0,0,0,0,53030,0,26124),
(98439,'Two trials faced and one remains.','',0,0,0,0,0,0,0,0,0,0,53068,0,26124),
(98440,'You must seek the judgment of the ancient kings, but they are dead and you are not.','',0,0,0,0,0,0,0,0,0,0,53069,0,26124),
(98441,'There is one who can bridge the gap, if you indulge him.','',0,0,0,0,0,0,0,0,0,0,53070,0,26124),
(98442,'Meet me at Valdisdall, and I will spin the tale.','',0,0,0,0,0,0,0,0,0,0,53071,0,26124),
(98443,'In Haustvald, the Bonespeakers keep the dead. They will not help you.','',0,0,0,0,0,0,1,0,0,0,53064,0,26124),
(98444,'Their ways are twisted. They have forgotten the old vows.','',0,0,0,0,0,0,661,0,0,0,53067,0,26124),
(98445,'But there is one who remembers. One who is rooted in the old ways.','',0,0,0,0,0,0,1,0,0,0,53066,0,26124),
(98446,'Seek Vydhar! Earn your judgment, and pass the Trial of Valor.','',0,0,0,0,0,0,1,0,0,0,53065,0,26124),
(98447,'Dying roots.. twisted leaves... the runestones...','',0,0,0,0,0,0,1,0,0,0,53072,0,26124),
(98448,'I can hear... the woods call to me...','',0,0,0,0,0,0,0,0,0,0,53073,0,26124),
(98449,'Must break free... I can almost feel my leaves...','',0,0,0,0,0,0,0,0,0,0,53074,0,26124),
(98450,'I am unbound! My roots will seek the hearts of my betrayers!','',0,0,0,0,0,0,0,0,0,0,53075,0,26124),
(98451,'Ahh... oohh...','',0,0,0,0,0,0,1,0,0,0,53076,0,26124),
(98452,'Who goes there? Your footsteps fall as acorns. Stand before me, little one.','',0,0,0,0,0,0,1,0,0,0,53077,0,26124),
(98453,'I hear you\'re an expert on naval equipment.  Have some time to help me out?','I hear you\'re an expert on naval equipment.  Have some time to help me out?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98454,'','You will not force my judgment, Runeseer. This fel-tainted wretch will not befoul the Halls of Valor!',0,0,0,0,0,0,0,0,0,0,0,53040,26124),
(98456,'I grow impatient, Runeseer. Finish this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98459,'Give in, Ashildir. If your spirit will not bend, then it will be broken!','',0,0,0,0,0,0,0,0,0,0,53042,0,26124),
(98460,'','Champion! Destroy this usurper, and I will grant you my judgment!',0,0,0,0,0,0,0,0,0,0,0,53043,26124),
(98461,'You think to stop me? I am the master of the vengeful dead!','',0,0,0,0,0,0,0,0,0,0,53044,0,26124),
(98462,'','The runestone grants him power, champion. Destroy it!',0,0,0,0,0,0,0,0,0,0,0,53045,26124),
(98463,'These are just some of the artifacts collected by Deathwing in his day. Collect them and I will see they are properly investigated later.','',0,0,0,0,0,0,0,0,0,35578,0,0,26124),
(98464,'You were a fool to meddle. My armies are eternal!','',0,0,0,0,0,0,0,0,0,0,53046,0,26124),
(98465,'','Sisters, to arms! Show this coward the meaning of valor!',0,0,0,0,0,0,0,0,0,0,0,53047,26124),
(98466,'','He\'s empowering another runestone!',0,0,0,0,0,0,0,0,0,0,0,53048,26124),
(98467,'Enough of this!','',0,0,0,0,0,0,0,0,0,0,53049,0,26124),
(98468,'','No! This power... it\'s too strong!',0,0,0,0,0,0,0,0,0,0,0,53050,26124),
(98469,'You should have yielded, Ashildir.','',0,0,0,0,0,0,0,0,0,0,53051,0,26124),
(98470,'The God-King will not need your judgment if you are no longer among the honored dead.','',0,0,0,0,0,0,0,0,0,0,53052,0,26124),
(98471,'','No... you can\'t...',0,0,0,0,0,0,0,0,0,0,0,53053,26124),
(98472,'I can. You have sealed your fate, shieldmaiden. You and this... outsider.','',0,0,0,0,0,0,0,0,0,0,53054,0,26124),
(98473,'Enjoy your eternity of damnation. Helheim awaits!','',0,0,0,0,0,0,0,0,0,0,53055,0,26124),
(98474,'','I am sorry, hero. I have doomed us both.',0,0,0,0,0,0,1,0,0,0,0,52994,26124),
(98475,'','Perhaps this cowering wretch might be of some use.',0,0,0,0,0,0,0,0,0,0,0,52995,26124),
(98476,'','Disgusting! This plan better work, spirit.',0,0,0,0,0,0,1,0,0,0,0,52996,26124),
(98477,'','Such a revolting disguise. My armor still reeks of seaweed!',0,0,0,0,0,0,1,0,0,0,0,52997,26124),
(98479,'','Remember our bargain, banshee. Do not dare to cross me...',0,0,0,0,0,0,0,0,0,0,0,53008,26124),
(98480,'','What have we here? Another one of Greymane\'s mercenaries?',0,0,0,0,0,0,6,0,0,0,0,53009,26124),
(98481,'','No matter. Soon you will witness the birth of a new age.',0,0,0,0,0,0,274,0,0,0,0,53011,26124),
(98482,'','If you ever make it out of here, that is.',0,0,0,0,0,0,11,0,0,0,0,53013,26124),
(98483,'','Ah, my loyal hero.',0,0,0,0,0,0,1,0,0,0,0,53010,26124),
(98484,'','You must not languish here. The Aegis cannot fall into enemy hands!',0,0,0,0,0,0,274,0,0,0,0,53012,26124),
(98485,'','The future of the Horde depends on you and me. Find your way back to Stormheim - I will be waiting.',0,0,0,0,0,0,1,0,0,0,0,53014,26124),
(98486,'I can help ya out, $c.  I remember seeing some documents at the end of the docks.  Head down there and take a look.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98487,'','Unworthy! You will kneel before addressing the great Helya!',0,0,0,0,0,0,0,0,0,0,0,52998,26124),
(98488,'','Your spirit feels... weaker. What has she done?',0,0,0,0,0,0,1,0,0,0,0,52999,26124),
(98489,'','Have fun with my pet, outsider. I will enjoy watching him break you!',0,0,0,0,0,0,0,0,0,0,0,53000,26124),
(98490,'','Our foe is great, champion, but we will win the day.',0,0,0,0,0,0,1,0,0,0,0,53001,26124),
(98491,'','You are clever, outsider, but your efforts will only prove futile.',0,0,0,0,0,0,0,0,0,0,0,53002,26124),
(98492,'','Do not think you are close to winning, unworthy one.',0,0,0,0,0,0,0,0,0,0,0,53003,26124),
(98493,'','How resourceful you are. You might make a worthwhile plaything yet.',0,0,0,0,0,0,0,0,0,0,0,53004,26124),
(98494,'','The time for planning is over, champion. Now, we take action!',0,0,0,0,0,0,1,0,0,0,0,53005,26124),
(98495,'','No! My darling pet! You will pay for this!',0,0,0,0,0,0,0,0,0,0,0,53006,26124),
(98496,'','It is done, Helya! We have fulfilled your bargain, and we will collect our payment!',0,0,0,0,0,0,0,0,0,0,0,53007,26124),
(98497,'','It is done, Helya! We have fulfilled your bargain, and we will collect our payment!',0,0,0,0,0,0,1,0,0,0,0,52987,26124),
(98498,'','Such insolence! None will leave Helheim while I rule!',0,0,0,0,0,0,0,0,0,0,0,52988,26124),
(98499,'','What? This cannot be!',0,0,0,0,0,0,0,0,0,0,0,52989,26124),
(98500,'','Her hold is weakening. She cannot keep us here!',0,0,0,0,0,0,0,0,0,0,0,52990,26124),
(98501,'','No one leaves Helheim! No one!',0,0,0,0,0,0,0,0,0,0,0,52991,26124),
(98502,'','Your terms were met, Helya. It seems even you must honor your word.',0,0,0,0,0,0,0,0,0,0,0,52992,26124),
(98503,'','Nooooo!',0,0,0,0,0,0,0,0,0,0,0,52993,26124),
(98504,'What is it you seek?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98505,'The $ct approaches! Knights, salute!','The $ct approaches! Knights, salute!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98506,'The vault before you holds not gold, but wisdom.','',0,0,0,0,0,0,1,0,0,0,53060,0,26124),
(98507,'Yotnar is its lock, and glory is its key.','',0,0,0,0,0,0,1,0,0,0,53061,0,26124),
(98508,'Forge a key in the blood of champions, and perhaps the lock will turn.','',0,0,0,0,0,0,1,0,0,0,53062,0,26124),
(98509,'Inside you will find paths... and more.','',0,0,0,0,0,0,1,0,0,0,53063,0,26124),
(98510,'The trials are won, but your foe remains.','',0,0,0,0,0,0,0,0,0,0,53089,0,26124),
(98511,'His tainted flock bars the halls of the righteous.','',0,0,0,0,0,0,0,0,0,0,53090,0,26124),
(98512,'To sever this head, you must cripple the body.','',0,0,0,0,0,0,0,0,0,0,53091,0,26124),
(98513,'But first... Stormheim\'s savior has someone very important to save.','',0,0,0,0,0,0,0,0,0,0,53092,0,26124),
(98514,'I.. will not... yield!','',0,0,0,0,0,0,0,0,0,0,53093,0,26124),
(98515,'At last! It seems I owe you another life, friend.','',0,0,0,0,0,0,0,0,0,0,53094,0,26124),
(98516,'Let us stem this tide of filth!','',0,0,0,0,0,0,0,0,0,0,53095,0,26124),
(98517,'No mercy for those who taint this land!','',0,0,0,0,0,0,0,0,0,0,53096,0,26124),
(98518,'The demons keep coming! There must be another source!','',0,0,0,0,0,0,0,0,0,0,53097,0,26124),
(98519,'I will fly you to the top when you are ready, friend.','',0,0,0,0,0,0,0,0,0,0,53098,0,26124),
(98520,'Let us put an end to Skovald\'s minions once and for all!','',0,0,0,0,0,0,0,0,0,0,53099,0,26124),
(98521,'Fool! You cannot hope to stop my endless army.','',0,0,0,0,0,0,0,0,0,0,53078,0,26124),
(98522,'Hero, the eredar is shielding our foe!','',0,0,0,0,0,0,0,0,0,0,53082,0,26124),
(98523,'My soldiers are limitless!','',0,0,0,0,0,0,0,0,0,0,53079,0,26124),
(98524,'You cannot fight forever!','',0,0,0,0,0,0,0,0,0,0,53080,0,26124),
(98525,'The tide of destruction is unending!','',0,0,0,0,0,0,0,0,0,0,53081,0,26124),
(98526,'No! You cannot end... the endless...','',0,0,0,0,0,0,0,0,0,0,53083,0,26124),
(98527,'We are done here, champion. Let us return to Havi.','',0,0,0,0,0,0,0,0,0,0,53084,0,26124),
(98528,'The God-King\'s demon allies will no longer threaten Stormheim.','',0,0,0,0,0,0,0,0,0,0,53085,0,26124),
(98529,'It is time you pursue Skovald into the high halls.','',0,0,0,0,0,0,0,0,0,0,53088,0,26124),
(98530,'A great battle, a greater champion. Yes, you are worthy.','',0,0,0,0,0,0,0,0,0,0,53086,0,26124),
(98531,'Enter Halls of Valor, champion. The greatest of glory awaits!','',0,0,0,0,0,0,25,0,0,0,53087,0,26124),
(98532,'','They\'re trying to bring the ship down from the inside.',0,0,0,0,0,0,5,0,0,0,0,53100,26124),
(98533,'Death Knights of Acherus, I send to you $n who will serve as the enforcer of my will. Follow his commands as you would my own.','',0,0,0,0,0,0,0,0,0,0,53779,0,26124),
(98534,'For Huln, the War of the Ancients did not end at the Well of Eternity. With the Legion defeated, he focused on the monster that got away.','',0,0,0,0,0,0,0,0,0,0,54257,0,26124),
(98535,'Be warned, the path ahead is quite dangerous. I can only provide you guidance and healing. Nothing more.','',0,0,0,0,0,0,0,0,0,0,62092,0,26124),
(98536,'History is forged by the hearts of heroes, child. This is the truth your father wanted you to see.','',0,0,0,0,0,0,274,0,0,0,61685,0,26124),
(98537,'Come now, High Chieftain. It is only an ettin. I\'m sure you will be fine.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98538,'Spiritwalker, have you any spells that might assist us with healing?','',0,0,0,0,0,0,0,0,0,0,57628,0,26124),
(98539,'Insidia is all that remains of the flight in this tomb. We must be wary, one does not lift a weapon against a daughter of Deathwing without suffering consequences.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98540,'If it means freedom for my people, then I welcome any consequences she throws at us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98545,'The High Chieftain asked for me to join him in this negotiation.$b$bThe Highmountain tribe is spoken of in our legends and remembered with reverence.$b$bIt was important that we show respect for such an ancient tribe.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98546,'It has been many years since my people swore our loyalty to the Horde.$b$bThe Horde aided my people in our time of need, and I am here to speak well of that accord.$b$bThe Highmountain tribe is known even to us in the North, and respect must be paid.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98547,'','I\'ll cover you. Go help Greymane!',0,0,0,0,0,0,5,0,0,0,0,53101,26124),
(98548,'We make a good team, you and I. The alchemy table looks good as new!$b$bOne day we\'ll look back on this whole vrykul ghost mishap and have a good laugh. Thank you, $n!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(98549,'Greetings champion.$b$bWe are dangerously low on allies in this land and the Highmountain tribe is the only tribe in known tauren history to lock horns with the Burning Legion.$b$bI am here to lend whatever aid they need so that they can unite under the same totem once again and join us in the fight against the Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98550,'The dead are everywhere! Their souls must be sworn to Magnar.','',0,0,0,0,0,0,1,0,0,0,60424,0,26124),
(98551,'The Ashbringer...','',0,0,0,0,0,0,0,0,0,43820,0,0,26124),
(98552,'I have another question.','I have another question.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98553,'','A fine task for the Coilskar. I am in agreement.',0,0,0,0,0,0,0,0,0,0,0,55295,26124),
(98554,'','Let us be done with this business. A volcano is no place for naga.',0,0,0,0,0,0,0,0,0,0,0,55294,26124),
(98555,'Milady, you will take your naga north. Disrupt the ritual the demons are performing at their Soul Engine.','Milady, you will take your naga north. Disrupt the ritual the demons are performing at their Soul Engine.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98556,'','The Path of Huln was something I knew I might have to walk some day. I had just hoped I could wait until after dealing with Dargrul to walk it.$b$b',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98557,'Let us observe a moment of silence for a great soldier, leader, and friend. In the Light we are one, brother. Always.','',0,0,0,0,0,0,1,0,0,0,63833,0,26124),
(98558,'So this is the Vault of Neltharian.$b$bNow I see why Wrathion was so eager to visit this place. The secrets here could easily turn the tide in any war.$b$bBut this place has been abandoned by the living for thousands of years.$B$bWe should be on our guard. There is no telling what sort of sorcery and traps were left behind.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98559,'We must stand together against the coming darkness. We must cast aside the shackles of race and kingdom. We must unite as one!','',0,0,0,0,0,0,1,0,0,0,63836,0,26124),
(98560,'','We will see it done. I urge you to remember that the Black Temple is under attack.',0,0,0,0,0,0,0,0,0,0,0,55314,26124),
(98561,'','Time is of the essence. Come, sisters, our former brethren await our tender mercies.',0,0,0,0,0,0,0,0,0,0,0,55315,26124),
(98562,'Matron Mother, I need you to take your shivan across the gap to the Forge of Corruption. Make them suffer.','Matron Mother, I need you to take your shivan across the gap to the Forge of Corruption. Make them suffer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98563,'','Your gift is appreciated, $r. These potions will be most useful.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(98564,'Approach, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98565,'Greetings, Leyweaver. I offer this gift in hopes that you will mend some silk for me.','Greetings, Leyweaver. I offer this gift in hopes that you will mend some silk for me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98566,'I would be honored.','I would be honored.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98567,'Alright, let\'s see what we can do with this ore. First things first: we heat the ore.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(98568,'Now let\'s see what we can make with it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98569,'And now for the simple step of applying the flux. Lean in closely and watch my technique.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98570,'Then turn around and be recognized!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98571,'','I am in your debt, hero. Come. Let us destroy these demons together!',0,0,0,0,0,0,0,0,0,0,0,53113,26124),
(98572,'Champion: The Skyfire is about to embark on an urgent mission. I must ask that you accompany them.','',0,0,0,0,0,0,0,0,0,0,53162,0,26124),
(98573,'','Thank you, champion! Lead on. We must help the other defenders!',1,0,0,0,0,0,0,0,0,0,0,53114,26124),
(98574,'','Enemy reinforcements headed this way!',0,0,0,0,0,0,0,0,0,0,0,53115,26124),
(98575,'','Our enemies are launching a new attack!',0,0,0,0,0,0,0,0,0,0,0,53116,26124),
(98576,'Report to Stormwind Harbor as soon as possible - they are under strict orders not to leave without you.','',0,0,0,0,0,0,0,0,0,0,53163,0,26124),
(98577,'','Incoming! Defend the temple!',0,0,0,0,0,0,0,0,0,0,0,53117,26124),
(98578,'','Orders? Do you need anything repaired before we head out?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(98579,'I trust that your valor and discretion will serve the Alliance well, as it always has. With honor, King Anduin Wrynn.','',0,0,0,0,0,0,0,0,0,0,53164,0,26124),
(98580,'Yes, thank you, Nightsong. Will you see to my equipment?','Yes, thank you, Nightsong. Will you see to my equipment?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98581,'','Another wave of attackers! Hold the line!',0,0,0,0,0,0,0,0,0,0,0,53118,26124),
(98582,'','Fresh adversaries approach! Fight on!',0,0,0,0,0,0,0,0,0,0,0,53119,26124),
(98583,'','New foes incoming! Brace yourselves!',0,0,0,0,0,0,0,0,0,0,0,53120,26124),
(98584,'','By Elune! Clearly Ysera is beyond saving. All we can do is end her suffering.',0,0,0,0,0,0,0,0,0,0,0,53121,26124),
(98585,'','We have no choice: Ysera must die. She would agree, were she in her right mind.',0,0,0,0,0,0,0,0,0,0,0,53122,26124),
(98586,'','Stand in Elune\'s light, and her blessing will strengthen your attacks!',0,0,0,0,0,0,0,0,0,0,0,53123,26124),
(98587,'','Shine your light down, Mother Moon, and lend us your strength!',0,0,0,0,0,0,0,0,0,0,0,53124,26124),
(98588,'','O Elune, grant us your light and strengthen us for what we must do!',0,0,0,0,0,0,0,0,0,0,0,53125,26124),
(98589,'','Let me bear the brunt of Ysera\'s attacks, hero. You can rely on me: I am quite sturdy.',0,0,0,0,0,0,0,0,0,0,0,53126,26124),
(98591,'Shaping the ore...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98592,'Look how easily it bends...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98593,'The Light gives us strength.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98594,'Please address the gathered paladins on my behalf, Gryan.','Please address the gathered paladins on my behalf, Gryan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98595,'Come to me, my impish kin! We shall devour the power within!','',0,0,0,0,0,0,0,0,0,0,60389,0,26124),
(98596,'You seem delirious!','',0,0,0,0,0,0,0,0,0,0,60390,0,26124),
(98597,'But I am mysterious...','',0,0,0,0,0,0,0,0,0,0,60391,0,26124),
(98598,'You\'ll catch me soon, friend...','',0,0,0,0,0,0,0,0,0,0,60392,0,26124),
(98599,'Why... so serious...?','',0,0,0,0,0,0,0,0,0,0,60393,0,26124),
(98600,'','The Blood Knights stand by you, Highlord $p. Azeroth will not fall!',0,0,0,0,0,0,1,0,0,0,0,63837,26124),
(98601,'','Welcome to Skyhold! Here the brave live on forever!',0,0,0,0,0,0,0,0,0,0,0,60356,26124),
(98602,'We pledge ourselves to your cause, Highlord!','',0,0,0,0,0,0,1,0,0,0,63838,0,26124),
(98603,'','Champion, forgive the interruption. I bring an urgent message from the king.',0,0,0,0,0,0,0,0,0,0,0,53161,26124),
(98604,'','Stormheim is home to one of the Pillars of Creation - the Aegis of Aggramar.',0,0,0,0,0,0,1,0,0,0,0,53149,26124),
(98605,'','Vrykul legends speak of a trial - to conquer this trial is to prove one\'s worth, and lay claim to the Aegis.',0,0,0,0,0,0,1,0,0,0,0,53150,26124),
(98606,'','Our official orders are to escort you to Stormheim and ensure your success on this trial.',0,0,0,0,0,0,1,0,0,0,0,53152,26124),
(98607,'','Impressive, aren\'t they? The new guns could bag a wyvern at full speed from three hundred meters. Go ahead, have a look.',0,0,0,0,0,0,25,0,0,0,0,53151,26124),
(98608,'I\'ll just be upstairs so I can better observe your actions... at a safe distance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98609,'','Unofficially, however, we have another mission...',0,0,0,0,0,0,1,0,0,0,0,53153,26124),
(98610,'','The 7th Legion. The toughest men and women the Alliance has to offer. They, too, have come on direct orders from the king.',0,0,0,0,0,0,66,0,0,0,0,53154,26124),
(98611,'','Three days ago, the Forsaken fleet set sail from Durotar, heading straight for the Broken Isles. We think Sylvanas Windrunner herself may be among them.',0,0,0,0,0,0,1,0,0,0,0,53155,26124),
(98612,'','We are to track them from a safe distance. We may engage, but only if the situation demands.',0,0,0,0,0,0,1,0,0,0,0,53156,26124),
(98613,'','I strongly suspect the situation will demand it.',0,0,0,0,0,0,1,0,0,0,0,53157,26124),
(98614,'It had better.','',0,0,0,0,0,0,1,0,0,0,53158,0,26124),
(98615,'I am not in the habit of tracking prey unless I intend on killing it.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(98616,'','Preparations are nearly complete. Please make yourselves comfortable.',0,0,0,0,0,0,0,0,0,0,0,53160,26124),
(98617,'The spider fortress, the soul engine, and the forge are their primary targets. The Servants of Illidan must succeed.','',0,0,0,0,0,0,0,0,0,0,55263,0,26124),
(98618,'It worked?! I mean... it worked! Of course it did. That\'s excellent news.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(98619,'Alright, let me see the gauntlet.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98621,'Take me to the Broken Shore.','Take me to the Broken Shore.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98622,'','Let me help you get where you want to go. As you travel through the Broken Isles I will be able to get new destinations from you as well! Keep exploring!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98623,'Dalaran.','Dalaran.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98624,'Stormheim.','Stormheim.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98625,'Azsuna.','Azsuna.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98626,'Val\'sharah.','Val\'sharah.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98627,'Highmountain.','Highmountain.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98628,'Suramar.','Suramar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98629,'','I have a wide selection of recipes available.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(98630,'What can you tell me about this alchemy table?','What can you tell me about this alchemy table?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98631,'Gotcha!','Gotcha!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98632,'Hehe!','Hehe!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98633,'That one\'s free!','That one\'s free!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98634,'Oof! That had to hurt.','Oof! That had to hurt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98635,'','Champion: As your new Warchief, I share with you the burden of securing our future.',0,0,0,0,0,0,0,0,0,0,0,53178,26124),
(98636,'','To that end, my fleet is preparing to sail for the Broken Isles. When you set foot in Stormheim, you shall have the full power of the Forsaken at your back.',0,0,0,0,0,0,0,0,0,0,0,53179,26124),
(98637,'','Make the journey with us. Together, we will ensure that no one can oppose the might of the Horde!',0,0,0,0,0,0,0,0,0,0,0,53180,26124),
(98638,'','Isn\'t our alchemy table wonderful? Deucus spent years assembling the components. He\'s so proud of it!',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(98639,'It\'s a shame what happened to the alchemy table.','It\'s a shame what happened to the alchemy table.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98640,'Hey!','Hey!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98641,'','Are you familiar with the vrykul? Towering, brutish warriors from an ancient stock. Subtlety is not a value they hold in high regard.',0,0,0,0,0,0,6,0,0,0,0,53165,26124),
(98642,'Wow, that\'s cold!','Wow, that\'s cold!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98643,'Haha. This is great!','Haha. This is great!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98644,'I\'m gonna get you next!','I\'m gonna get you next!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98645,'','That awful Svena made a mess of the alchemy table. Poor Deucus! I know he hides it, but he\'s heartbroken.$b$bI certainly hope you can help him finish rebuilding it!',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(98646,'','Their legends speak of the Aegis of Aggramar. To claim it, one must undergo some kind of trial. One must be... worthy.',0,0,0,0,0,0,1,0,0,0,0,53166,26124),
(98647,'The alchemy table looks good as new!','The alchemy table looks good as new!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98648,'','The alchemy table looks terrific! Deucus is so relieved. Thank you for all the work you did restoring it.$b$bHere\'s hoping we don\'t see another vrykul ghost in the shop ever again!',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(98649,'I\'d like to buy from you.','I\'d like to buy from you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98650,'','The new catapults are faster and more powerful than ever before. I have our goblin allies to thank for that.',0,0,0,0,0,0,397,0,0,0,0,53167,26124),
(98651,'','I trust you are more than capable of handling whatever trials stand between you and the Aegis.',0,0,0,0,0,0,1,0,0,0,0,53168,26124),
(98652,'','Truthfully, Stormheim holds another treasure. One that I will be pursuing by my own means.',0,0,0,0,0,0,1,0,0,0,0,53169,26124),
(98653,'','<Setting her vigil aside for a moment, the majestic druid turns to look at you. Her dark eyes widen in recognition and warmth.>$b$b<Without a word, she makes it clear that you will always be welcome here.>',0,0,2,0,0,900,0,0,0,0,0,0,26124),
(98654,'','Nathanos has been training a new generation of rangers. They represent both our past, and our future.',0,0,0,0,0,0,1,0,0,0,0,53170,26124),
(98655,'','I think often about our future, hero. My people cannot reproduce. Are we not destined, then, to wither away eventually?',0,0,0,0,0,0,6,0,0,0,0,53171,26124),
(98656,'','No. The Forsaken will never stop fighting.',0,0,0,0,0,0,661,0,0,0,0,53172,26124),
(98657,'','Not while I reign. Not when there are still beings out there with the power to stop death.',0,0,0,0,0,0,603,0,0,0,0,53173,26124),
(98658,'','News from Captain Dreadwake, my lady. They have found the temple.',0,0,0,0,0,0,1,0,0,0,0,53174,26124),
(98659,'','The Oblivion has landed nearby. They are building fortifications now and will be ready to lay siege at your command.',0,0,0,0,0,0,1,0,0,0,0,53175,26124),
(98660,'','Good. Send a bat - tell them we are leaving shortly.',0,0,0,0,0,0,0,0,0,0,0,53176,26124),
(98661,'To hammer the metal is to hammer yourself. How far are you willing to bend, greenhorn?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98662,'%s eyes Reylar the Stormcaller cautiously.','',0,0,274,0,0,0,0,0,0,0,0,0,26124),
(98663,'What sorts of things do you sell?','What sorts of things do you sell?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98664,'Do not simply use your arm to swing the hammer. You have your torso, your legs, your spirit.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98665,'Do not be a slave to your hammer. It is an extension of your arm. YOU are its master.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98666,'','I sell the recipes that Deucus and I research together. As we learn new ones, I add them to my inventory.$b$bBe sure to check back from time to time to see if anything new is available!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(98667,'We will send Gul\'dan\'s filth to the bottom of the sea!','',0,0,0,0,0,0,1,0,0,20069,50641,0,26124),
(98668,'You there! I require a moment of your time.','',0,0,0,0,0,0,0,0,0,0,53177,0,26124),
(98669,'','I am the chosen of Eyir! What chance do think you have?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98670,'','I live. I die. I...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98671,'We have a lot of work ahead of us to fix the alchemy table!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(98672,'We did it! The alchemy table looks good as new!$b$bWith my brains and your brawn, we make a great team. Thank you, $n!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(98673,'Lord Shadowbreaker will be expecting you, $n. This way.','',0,0,0,0,0,0,1,0,0,0,63840,0,26124),
(98674,'Lord Shadowbreaker, the Highlord would like to peruse the reconnaissance you\'ve gathered on the Broken Isles.','',0,0,0,0,0,0,1,0,0,0,63841,0,26124),
(98675,'This is my favorite holiday!','This is my favorite holiday!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98676,'Snow for everyone!','Snow for everyone!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98677,'Snowball incoming!','Snowball incoming!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98678,'You go SQUISH!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98679,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98680,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98681,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98682,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98683,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98684,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98685,'These spirit winds are relentless! We cannot walk through.','',0,0,0,0,0,0,396,0,0,0,60396,0,26124),
(98686,'%s ponders the situation at hand.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98687,'I can charge from here.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(98688,'His madness infects his guards, they do not recognize me.','',0,0,0,0,0,0,1,0,0,0,60398,0,26124),
(98689,'Watch out!','',0,0,0,0,0,0,603,0,0,0,60399,0,26124),
(98690,'That door is sealed with lightning. We must find a way through!','',0,0,0,0,0,0,396,0,0,0,60400,0,26124),
(98691,'Like I always say, if you can\'t reach it, throw something at it. Never fails!','',0,0,0,0,0,0,396,0,0,0,60401,0,26124),
(98692,'Here we are... Magnar\'s chamber!','',0,0,0,0,0,0,396,0,0,0,60402,0,26124),
(98694,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98695,'Knights of the Ebon Blade! Assemble as we honor one of our own!','',0,0,0,0,0,0,0,0,4,0,61914,0,26124),
(98696,'You have all heard the legends of countless battles fought... of trials overcome at great cost.','',0,0,0,0,0,0,0,0,4,0,61916,0,26124),
(98697,'His exemplary deeds in the name of the Ebon Blade have shown him to be one of the best of us, worthy of our highest honor.','',0,0,0,0,0,0,0,0,4,0,61917,0,26124),
(98699,'By the will of the Lich King and upon my authority as Highlord, I declare that $n, wielder of the Blades of the Fallen Prince, will henceforth be known as Deathlord of the Ebon Blade.','',0,0,0,0,0,0,0,0,4,0,61920,0,26124),
(98700,'By the will of the Lich King and upon my authority as Highlord, I declare that $n, wielder of the Maw of the Damned, will henceforth be known as Deathlord of the Ebon Blade.','',0,0,0,0,0,0,0,0,4,0,61919,0,26124),
(98701,'By the will of the Lich King and upon my authority as Highlord, I declare that $n, wielder of Apocalypse, will henceforth be known as Deathlord of the Ebon Blade.','',0,0,0,0,0,0,0,0,4,0,60233,0,26124),
(98702,'<As you approach, the regal druid regards you with friendly curiosity.>$b$b<After a moment, he gives a chuff of approval and lowers his stately head before you.>','',0,0,2,0,0,900,0,0,0,0,0,0,26124),
(98703,'You will all bow to him as you once did to me, and carry out his will against the Legion!','',0,0,0,0,0,0,0,0,4,0,61918,0,26124),
(98704,'There is no time! Xavius must be stopped!','',0,0,0,0,0,0,0,0,0,0,53189,0,26124),
(98705,'','Easy now. This remedy takes time. You must rest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98706,'S - Save the temple! <choking sound> Hurry!','',0,0,0,0,0,0,0,0,6,0,53187,0,26124),
(98707,'Ysera is going to destroy the Temple of Elune!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98708,'','The Wardens seek our help? Things must be desperate.',0,0,0,0,0,0,1,0,0,0,0,57334,26124),
(98709,'','Ahhhh, it feels good to MOVE again. Thank you, $n.',0,0,0,0,0,0,1,0,0,0,0,57287,26124),
(98710,'','$n, it has been a long time since Mardum. I am ready for another fight.',0,0,0,0,0,0,1,0,0,0,0,57288,26124),
(98711,'','We will need weapons and supplies if we are to break out of here. I am on it, $n.',0,0,0,0,0,0,1,0,0,0,0,57289,26124),
(98712,'','Years and years with only the voices in my head. I thought I would go insane.',0,0,0,0,0,0,1,0,0,0,0,57290,26124),
(98713,'What a wonderful time of year!','What a wonderful time of year!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98714,'No matter how many presents there are, we could always use more!','No matter how many presents there are, we could always use more!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98715,'\'Tis the season!','\'Tis the season!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98716,'Happy holidays!','Happy holidays!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98717,'Come here goaties!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98718,'Stop moving! Me can\'t keep track.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98719,'You too fast. Stay!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98720,'Hello again, Linzy. What\'s new with you?','Hello again, Linzy. What\'s new with you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98721,'','Oh, you know, nothing much. Just helped move an entire city from the frozen north to a haunted keep, then on to a chain of demon-infested islands! All in a day\'s work, I suppose.$b$bI\'m semi-retired these days, so having Deucus take over has been wonderful. He\'s a good sort... if perhaps a bit overly fond of his alchemy table!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(98722,'Here to pillage our wares, demon?! You shall take NOTHING!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(98723,'Wait! Stop! You\'re... you\'re no demon...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98724,'Sounds like an exciting life!','Sounds like an exciting life!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98725,'The fog has lifted and I can see the truth once more. Thank you, $pc. If you would join me at my old shop, perhaps we can speak further.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98726,'','I admit, I never would have guessed that my work as an alchemist would be so thrilling!$b$bBut look who I\'m talking to... you\'ve seen far more adventure than I have!',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(98727,'','Wake up, demon hunter.',0,0,0,0,0,0,0,0,0,0,0,57335,26124),
(98729,'How have you fared since Northrend?','How have you fared since Northrend?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98730,'','I have been well, $n. The fall of the Lich King was a wonder to behold. If only all of Northrend\'s troubles had been solved by that victory.$b$bAh, but the past is the past. It feels great for Dalaran to be on the front lines of a new campaign! Though I admit, I\'m grateful you\'re out there fighting the battles instead of me.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(98731,'','Take up your weapons, $n. I trust you can still handle a blade.',0,0,0,0,0,0,0,0,0,0,0,57336,26124),
(98732,'I will burn this world with my fury!','',0,0,0,0,0,0,0,0,0,0,57337,0,26124),
(98734,'','I will need your help to stop Gul\'dan. Free the other Illidari, quickly!',0,0,0,0,0,0,0,0,0,0,0,57338,26124),
(98735,'I also wanted to ask about...','I also wanted to ask about...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98736,'The Highlord\'s will be done.','',0,0,0,0,0,0,0,0,0,0,63842,0,26124),
(98737,'Time for answers later. There are demons to kill.','',0,0,0,0,0,0,0,0,0,0,57339,0,26124),
(98738,'The demons aim to destroy our world. We need to release our allies.','',0,0,0,0,0,0,0,0,0,0,57340,0,26124),
(98739,'Well now, you have been turnin\' quite a lot of heads lately amongst the Explorer\'s League.$b$bOl\' Ebonhorn here seemed to know who I was and asked fer me to come help ya on this next journey.$b$bI hope ya don\'t mind but I dusted off me ol\' Talas here. I heard there were ettins involved and figured we could use us some heavy metal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98740,'','It worked! $GHe\'s:She\'s; alive!',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(98741,'','Of course it worked! I\'ve woken up things that were twice as dead for three times as long. This one was easy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98742,'I will stay here and await Gryan\'s return, Highlord.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(98743,'The altar lies just behind you, Highlord.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98744,'Thork - the northern portal is destroyed! We will push forward beyond Grol\'dom and make way toward the north.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98745,'Place the blade on the altar when you are ready. The Light will be our forge.','',0,0,0,0,0,0,0,0,0,0,72333,0,26124),
(98746,'','Our way is clear! Let\'s get to the top of the tower!',0,0,0,0,0,0,0,0,0,0,0,53197,26124),
(98747,'','You go ahead, I\'ll report back to Greymane. Good luck, champion.',0,0,0,0,0,0,0,0,0,0,0,53198,26124),
(98748,'','Now\'s our chance. Let\'s get up that tower!',0,0,0,0,0,0,0,0,0,0,0,58284,26124),
(98749,'','You\'re on your own from here. Good luck!',0,0,0,0,0,0,0,0,0,0,0,58285,26124),
(98750,'I am free! You are a true savior, outsider.','',0,0,0,0,0,0,0,0,0,0,53201,0,26124),
(98751,'But we haven\'t time for pleasantries, I must rally the Thorignir!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98752,'Speak to Vethir, he will take you to the summit!','',0,0,0,0,0,0,0,0,0,0,53202,0,26124),
(98753,'','I hope Maiev was right about freeing you, demon hunter. Go on - I will hold the line.',0,0,0,0,0,0,0,0,0,0,0,57291,26124),
(98754,'Your efforts are fruitless, demon hunter. Lord Gul\'dan sees all.','',0,0,0,0,0,0,0,0,0,0,57341,0,26124),
(98755,'Hey, you lot! If you need a quick pick-me-up, come and get a Rivermane Remedy!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(98756,'I\'ll let the others know of your gift, $n. Thank you again.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(98757,'','So HE is the key to Azeroth\'s downfall.',0,0,0,0,0,0,0,0,6,0,0,57342,26124),
(98758,'','We\'ve arranged a flight directly to Dalaran for you, Highlord.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(98759,'I live to serve.','',0,0,0,0,0,0,0,0,0,0,55363,0,26124),
(98760,'My life for the Legion.','',0,0,0,0,0,0,0,0,0,0,55364,0,26124),
(98761,'You will not gain the keystone.','',0,0,0,0,0,0,0,0,0,0,55365,0,26124),
(98762,'Brood Queen Tyranna orders your death.','',0,0,0,0,0,0,0,0,0,0,55366,0,26124),
(98763,'My blade will cut through you.','',0,0,0,0,0,0,0,0,0,0,55371,0,26124),
(98764,'You are outmatched and outnumbered.','',0,0,0,0,0,0,0,0,0,0,55367,0,26124),
(98765,'This is where you die.','',0,0,0,0,0,0,0,0,0,0,55362,0,26124),
(98766,'We will cleanse the universe in fire.','',0,0,0,0,0,0,0,0,0,0,55370,0,26124),
(98767,'Interested in representing your guild here in Frostwall?','Interested in representing your guild here in Frostwall?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98768,'Azsuna was once home to the great city of Nar\'thalas - one of the centerpieces of night elven civilization. It is a fine place to start our efforts against the Legion.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(98769,'This portal will take us to the western shore of the island not far from the city. Let\'s get down there, shall we?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(98770,'Little candles burn bright!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98771,'Hot Hot Hot!!!','',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(98772,'AIIIEEEEeeeee','',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(98773,'You have proven yourself a powerful hero, outsider. \n\nToday, you may also consider yourself a friend of the Thorignir.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98774,'Candle burn too bright!!!','',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(98775,'Before we proceed, I would like to bestow upon you a gift of the Thorignir.\n\nRaise your weapon, outsider, and brace yourself. This may prove uncomfortable for your kind.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98776,'I am prepared to receive your gift.','I am prepared to receive your gift.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98777,'Before us this day stands our comrade in arms, $n.','',0,0,0,0,0,0,0,0,4,0,61915,0,26124),
(98778,'Patricia! Would you be so kind as to show our friend here the newest recipes we\'ve discovered?','',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(98779,'','I\'d be happy to! Have a look at my stock, $n.',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(98780,'Just make sure $Ghe:she; doesn\'t make a mess on my alchemy table!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(98781,'','Yes, yes... We all know how attached you are to your alchemy table!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(98782,'','Hey, you\'re alive!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98783,'Kayn and Altruis have already gone ahead. Take this felbat and join them.','',0,0,0,0,0,0,1,0,0,0,57299,0,26124),
(98785,'Highlord, may I speak with you for a moment?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(98786,'Battle is upon us, $n. Prepare yourself!','Battle is upon us, $n. Prepare yourself!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98787,'These lands are in peril. Be careful.','These lands are in peril. Be careful.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98788,'The battlefield could use more heroes like you, $n.','The battlefield could use more heroes like you, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98789,'I don\'t remember what happened...','I don\'t remember what happened...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98790,'Thank you. I need time to recover.','Thank you. I need time to recover.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98791,'Are you ready to face Magnar with me, $n?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98792,'Feelin\' fine.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98793,'I will protect you, Hruthnir.','I will protect you, Hruthnir.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98794,'<Silgryn is shaking uncontrollably and can barely speak.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98795,'I am, as you will be. Come, let us go to the Halls of Valor. This mortal warrior will find the revenge you crave...','',0,0,0,0,0,0,1,0,0,0,60419,0,26124),
(98796,'Come with me now, let us dine with Odyn tonight.','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(98797,'I... have fallen. Hruthnir... you are a valarjar?','',0,0,0,0,0,0,1,0,0,0,60418,0,26124),
(98798,'I see now. My weapons are yours, warrior. May they bring you glory as you strike down Helya\'s minions!','',0,0,0,0,0,0,1,0,0,0,60420,0,26124),
(98799,'Begone from here, trespassers!','',0,0,0,0,0,0,603,0,0,0,60408,0,26124),
(98800,'ENOUGH OF THIS! Guards, punish these outsiders for their insolence!','',0,0,0,0,0,0,603,0,0,0,60414,0,26124),
(98801,'I work all this time to improve the forges and do I get a single word of thanks? No!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98802,'Make the weapons better, Corvus! Saronite isn\'t good enough anymore, Corvus! .. Bah! I\'ll show them what I can do to a blade.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98803,'This tropic air is too damp, makes me feel like there\'s flesh hanging from my bones again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98804,'It wouldn\'t have taken years to rebuild the forges if I had some help!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98805,'What can Corvus do for you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98806,'','Hold the line, demon hunters. We fight in Lord Illidan\'s name!',0,0,0,0,0,0,0,0,0,0,0,57303,26124),
(98807,'Stand firm. Do not let them break through!','',0,0,0,0,0,0,0,0,0,0,57304,0,26124),
(98808,'The Dreamgrove is spread thin these days, I fear.$b$bMalorne\'s Refuge is a bastion of druidic power in the Broken Isles. We cannot let it fall.','The Dreamgrove is spread thin these days, I fear.$b$bMalorne\'s Refuge is a bastion of druidic power in the Broken Isles. We cannot let it fall.',2,0,0,0,0,0,0,0,0,0,0,0,26124),
(98809,'Satyr have invaded our grove. They were once night elves, but pledged themselves to the Legion and became twisted by demonic magic. Such creatures have no place in nature.','Satyr have invaded our grove. They were once night elves, but pledged themselves to the Legion and became twisted by demonic magic. Such creatures have no place in nature.',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(98810,'|TInterface\\Icons\\ability_druid_galewinds.blp:20|t |cFFFF0000|Hspell:191797|h[Violent Winds]|h|r are picking up from the |cFFFF0000North|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(98811,'|TInterface\\Icons\\ability_druid_galewinds.blp:20|t |cFFFF0000|Hspell:191797|h[Violent Winds]|h|r are picking up from the |cFFFF0000East|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(98812,'|TInterface\\Icons\\ability_druid_galewinds.blp:20|t |cFFFF0000|Hspell:191797|h[Violent Winds]|h|r are picking up from the |cFFFF0000South|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(98813,'|TInterface\\Icons\\ability_druid_galewinds.blp:20|t |cFFFF0000|Hspell:191797|h[Violent Winds]|h|r are picking up from the |cFFFF0000West|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(98815,'Have you heard the tale of the White Stag and the Moon? It is said the tauren hunted Malorne and nearly cornered him. To escape, he leapt into the sky, but his antlers became tangled in the stars.$b$bNo matter how he struggled, he remained trapped. When the moon goddess Elune found him there, she offered to free him if he would love her and end her solitude.$b$bAh, but that is only one version of the myth, a tale shaped by the proud hunters who have passed it down for generations.','Have you heard the tale of the White Stag and the Moon? It is said the tauren hunted Malorne and nearly cornered him. To escape, he leapt into the sky, but his antlers became tangled in the stars.$b$bNo matter how he struggled, he remained trapped. When the moon goddess Elune found him there, she offered to free him if he would love her and end her solitude.$b$bAh, but that is only one version of the myth, a tale shaped by the proud hunters who have passed it down for generations.',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(98816,'Just a few more minutes here...  She will be seaworthy shortly!','',0,0,0,0,0,0,22,0,0,924,0,0,26124),
(98817,'Thank you, $n. I will fight by your side.','Thank you, $n. I will fight by your side.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98818,'Please - allow me to repay you with my services.','Please - allow me to repay you with my services.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98819,'It would be an honor to fight alongside you in battle, $n.','It would be an honor to fight alongside you in battle, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98820,'For honor!','For honor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98821,'We fight together until the end, $n.','We fight together until the end, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98822,'Some tales say that Malorne fell in love with the goddess of the moon during the world\'s first nightfall.$b$bHer light guided him through the woods and showed him he was not alone. It banished fear and brought hope.$b$bMany creatures have loved the moon and pursued her to madness. She grants light as she will, on her own timetable, and moonlight cannot be captured or possessed.$b$bEven so, night after night, the White Stag chased her across the skies. He grew so swift and strong that at last he succeeded in reaching her.$b$bShe was so moved by his devotion and beauty that she made him her consort. To this day he loves the wilds best when they are lit by her radiance.','Some tales say that Malorne fell in love with the goddess of the moon during the world\'s first nightfall.$b$bHer light guided him through the woods and showed him he was not alone. It banished fear and brought hope.$b$bMany creatures have loved the moon and pursued her to madness. She grants light as she will, on her own timetable, and moonlight cannot be captured or possessed.$b$bEven so, night after night, the White Stag chased her across the skies. He grew so swift and strong that at last he succeeded in reaching her.$b$bShe was so moved by his devotion and beauty that she made him her consort. To this day he loves the wilds best when they are lit by her radiance.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(98823,'Show me what missions you have prepared.','Show me what missions you have prepared.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98824,'Tell me about Azsuna and Val\'Sharah.','Tell me about Azsuna and Val\'Sharah.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98825,'Tell me about Stormheim and Highmountain.','Tell me about Stormheim and Highmountain.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98826,'[TEMP] Click on each gossip option to view half of the available zone options. You can only pick one of the four available initially. This will eventually be on the mission map.','[TEMP] Click on each gossip option to view half of the available zone options. You can only pick one of the four available initially. This will eventually be on the mission map.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98827,'Please, if you find anything which can keep this hunger at bay, bring it to me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98828,'The cravings have stopped. For now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98829,'Ah, I can feel the magic coursing through me. I am whole again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98830,'I surge with power! I cannot possibly contain any more.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98831,'Take Candle','Take Candle',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98832,'Thank you, outsider. I will make my way to the summit.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98833,'I know not why you came, but you have my gratitude.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98834,'These foul demons will pay for their treachery!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98835,'I was... nearly broken... You have my thanks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98836,'','Feelin\' fine. [PH]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98837,'Thank you so much $c! That dog was going to eat me!','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(98838,'','This road isn\'t safe, adventurer.\n\nKobolds attacked our caravan and made off with the soul chambers we were meant to deliver to Allari for interrogation.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(98839,'','I will honor Uriah\'s memory by delivering the soul chambers to Allari as planned.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(98840,'Shrug off your wounds, warriors! Another battle awaits!','',0,0,0,0,0,0,0,0,0,0,60427,0,26124),
(98841,'Rosalyn! Where is Rosalyn?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98842,'Yes! $n is here! We have a chance warriors, one more charge! LOK\'TAR!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98843,'Did I just see one of the gateways activate?','',0,0,0,0,0,0,0,0,0,0,55136,0,26124),
(98844,'I want a full report now!','',0,0,0,0,0,0,0,0,0,0,55137,0,26124),
(98845,'','I have to go. Kayn\'s called me back to handle something. He probably needs help killing a demon.',0,0,0,0,0,0,0,0,0,0,0,55291,26124),
(98846,'Demon hunters are using the gateways!','',0,0,0,0,0,0,0,0,0,0,55138,0,26124),
(98847,'Inquisitor Baleful? Who is this? Speak!','',0,0,0,0,0,0,0,0,0,0,55139,0,26124),
(98848,'','Last I saw, Kor\'vas cut a swath of destruction on her way across the bridge.',0,0,0,0,0,0,0,0,0,0,0,55010,26124),
(98849,'','Whatever you choose, it will feel good to use more of the Legion\'s power against them.',0,0,0,0,0,0,0,0,0,0,0,55293,26124),
(98850,'','Whoever this is, you\'re caught in my web now.',0,0,0,0,0,0,0,0,0,0,0,55072,26124),
(98851,'','Your attempt to gain my lord Sargeras\'s keystone will fail.',0,0,0,0,0,0,0,0,0,0,0,55073,26124),
(98852,'Hmm... it would appear that they\'re on to us, $n.','',0,0,0,0,0,0,0,0,0,0,55243,0,26124),
(98853,'Like Malorne himself, we spend most of our time in the wilds.$b$bIn these dire times, however, seclusion is a luxury no one can afford. We must stand together, or we will surely fall.','Like Malorne himself, we spend most of our time in the wilds.$b$bIn these dire times, however, seclusion is a luxury no one can afford. We must stand together, or we will surely fall.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(98854,'Val\'sharah has remained tranquil for ages, until recently. We\'ve underestimated the danger. Have no fear, champion. We will not be caught by surprise again.','Val\'sharah has remained tranquil for ages, until recently. We\'ve underestimated the danger. Have no fear, champion. We will not be caught by surprise again.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(98855,'Those things spew fel energy, corrupting everything they touch.','',0,0,0,0,0,0,0,0,0,0,55251,0,26124),
(98856,'Beliash\'s eredar are using those portals to summon in demonic reinforcements.','',0,0,0,0,0,0,0,0,0,0,55249,0,26124),
(98857,'We\'re vulnerable while they remain active.','',0,0,0,0,0,0,0,0,0,0,55247,0,26124),
(98858,'We\'ve taken the foothold, but with some losses.','',0,0,0,0,0,0,0,0,0,0,55250,0,26124),
(98859,'They\'re bombarding the pass into the volcano.','',0,0,0,0,0,0,0,0,0,0,55252,0,26124),
(98860,'More than ten millennia ago, Malorne and many other powerful ancients fought the Burning Legion\'s demons when they first invaded Azeroth.$b$bHe died nobly during the war, sacrificing his life so that his injured son, Cenarius, could be brought to safety and healing.$b$bNo parent could wish for a nobler death than to die protecting a child.$b$bHowever, let me be clear: to ancients like Malorne, we are all their children. We are fortunate that he has been restored to life and returned to us.','More than ten millennia ago, Malorne and many other powerful ancients fought the Burning Legion\'s demons when they first invaded Azeroth.$b$bHe died nobly during the war, sacrificing his life so that his injured son, Cenarius, could be brought to safety and healing.$b$bNo parent could wish for a nobler death than to die protecting a child.$b$bHowever, let me be clear: to ancients like Malorne, we are all their children. We are fortunate that he has been restored to life and returned to us.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(98861,'','Many centuries ago, I was the leader of the Skyhorn tribe. Never have I seen this sort of desecration of our ancient burial ground!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98862,'|TInterface\\Icons\\ability_rogue_venomouswounds:20|tYou are afflicted with |cFFFF0000|Hspell:191855|h[Toxic Wound]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(98863,'I not say you take candle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98864,'You no take green candle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98865,'What you doing here?! All candles my candles! See big horns?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98866,'You... no... take... candle...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98867,'Wait, you not real kobold!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98868,'You\'ve fought well, champion. The time has come for me to venture onward.','You\'ve fought well, champion. The time has come for me to venture onward.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98869,'I\'ve enjoyed fighting by your side, but I must be going now. Be safe!','I\'ve enjoyed fighting by your side, but I must be going now. Be safe!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98870,'I am being summoned elsewhere. Until our next adventure, friend!','I am being summoned elsewhere. Until our next adventure, friend!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98871,'Fight... to the death...','Fight... to the death...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98872,'Never... give up...','Never... give up...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98873,'Not like this...','Not like this...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98874,'My forces are legion! Your efforts are futile!','',0,0,0,0,0,0,0,0,2,0,60438,0,26124),
(98875,'It has been an honor fighting by your side.','It has been an honor fighting by your side.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98877,'Don\'t think I\'ll make it through this one.','Don\'t think I\'ll make it through this one.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98878,'This will be interesting.','This will be interesting.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98879,'This one\'s mine.','This one\'s mine.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98880,'With pleasure.','With pleasure.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98881,'Die scum!','Die scum!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98882,'You will see your grave soon enough, $n.','You will see your grave soon enough, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98883,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98884,'Help me out with this one!','Help me out with this one!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98885,'My life... for the Horde.','My life... for the Horde.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98887,'','Together we will imprison these demons once again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98890,'Choosing','Choosing',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98891,'I live!','',0,0,0,0,0,0,0,0,0,0,53206,0,26124),
(98892,'','I live!',0,0,0,0,0,0,0,0,0,0,0,53207,26124),
(98893,'I live!','',0,0,0,0,0,0,0,0,0,0,53208,0,26124),
(98894,'Ahh, to breathe again!','',0,0,0,0,0,0,0,0,0,0,53209,0,26124),
(98895,'','Ahh, to breathe again!',0,0,0,0,0,0,0,0,0,0,0,53210,26124),
(98896,'Ahh, to breathe again!','',0,0,0,0,0,0,0,0,0,0,53211,0,26124),
(98897,'Bless you, stranger!','',0,0,0,0,0,0,0,0,0,0,53212,0,26124),
(98898,'','Bless you, stranger!',0,0,0,0,0,0,0,0,0,0,0,53213,26124),
(98899,'Bless you, stranger!','',0,0,0,0,0,0,0,0,0,0,53214,0,26124),
(98900,'You have my gratitude, traveler.','',0,0,0,0,0,0,0,0,0,0,53215,0,26124),
(98901,'','You have my gratitude, traveler.',0,0,0,0,0,0,0,0,0,0,0,53216,26124),
(98902,'You have my gratitude, traveler.','',0,0,0,0,0,0,0,0,0,0,53217,0,26124),
(98903,'I felt myself slipping away...','',0,0,0,0,0,0,0,0,0,0,53218,0,26124),
(98904,'','I felt myself slipping away...',0,0,0,0,0,0,0,0,0,0,0,53219,26124),
(98905,'I felt myself slipping away...','',0,0,0,0,0,0,0,0,0,0,53220,0,26124),
(98906,'You... you have saved me!','',0,0,0,0,0,0,0,0,0,0,53221,0,26124),
(98907,'','You... you have saved me!',0,0,0,0,0,0,0,0,0,0,0,53222,26124),
(98908,'You... you have saved me!','',0,0,0,0,0,0,0,0,0,0,53223,0,26124),
(98909,'','The Legion empowers me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98910,'','The Feltotem... will be... your end.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98911,'Enough! I will break you myself!','',0,0,0,0,0,0,0,0,6,0,60440,0,26124),
(98913,'Let me show you how my fire can not only destroy homes, but lives!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98914,'In death I return to ash.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98915,'','The demon is weak enough for me to begin the containment spell. This should only take a moment.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98916,'','There are many who opposed him, but Illidan was right all along. We are the weapons that will bring down the Burning Legion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98920,'He is too strong! Our only hope is to reactivate the orbs and seal him inside the chamber!','',0,0,0,0,0,0,0,0,0,0,57305,0,26124),
(98921,'','This affront to nature cannot stand. These are our lands!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98922,'We are holding the demon back, but at great cost! I only have a few demon hunters left. We could use your help.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98924,'Master, you\'re here! Let us return this foul creature to the Twisting Nether.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98933,'[Placeholder Event: I get stunned!]','[Placeholder Event: I get stunned!]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98934,'The shield is broken! Quickly, everyone out while the creature is stunned!','',0,0,0,0,0,0,0,0,0,0,57306,0,26124),
(98935,'$n, the creature\'s destructive beam is focused upon me. Redirect the final mirror to shatter its shield!','',0,0,0,0,0,0,0,0,0,0,57307,0,26124),
(98936,'','We can\'t break through the demon\'s defenses. We need to reactivate the warden\'s trap to disable him!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98937,'It is time you be given a position that befits your accomplishments, $n.','',0,0,0,0,0,0,0,0,4,0,61913,0,26124),
(98938,'Push them back! The Horde will not succumb to Legion swine!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(98939,'The bear in the cave up ahead has immense power. He has been terrorizing Thunder Totem for a long time. He is too grand to put down... $b$b$p, I need you to help me weaken him so I can tame him. Will you help?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98940,'Let\'s do this.','Let\'s do this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98941,'','We\'ll see to securing the caverns. Thanks for your help, hero!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98942,'This table lists all of your currently available missions.','This table lists all of your currently available missions.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98943,'Show me any available missions.','Show me any available missions.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98944,'Alright, $p. He\'s right up here. Follow me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98945,'Your pathetic resistance only delays the inevitable. All will die to the Legion!','',0,0,0,0,0,0,0,0,0,0,60446,0,26124),
(98946,'Is that the best you can manage, weaklings? A few scratches?','',0,0,0,0,0,0,0,0,0,0,60447,0,26124),
(98947,'Enough of this! Face your destruction!','',0,0,0,0,0,0,0,0,0,0,60451,0,26124),
(98948,'You... you yet stand. Impossible!','',0,0,0,0,0,0,0,0,0,0,60452,0,26124),
(98949,'You will DIE like the insect you are!','',0,0,0,0,0,0,0,0,0,0,60449,0,26124),
(98950,'Death comes... but I will take you with me!','',0,0,0,0,0,0,0,0,0,0,60453,0,26124),
(98951,'You will be mine, Arru!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98952,'Ah, the disciple returns triumphant! You\'ve done well to remember the lessons I\'ve taught you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98953,'','You\'ve made quite the name for yourself, $n. It\'s good to see my instruction wasn\'t wasted.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98954,'$n! Welcome back! Don\'t you just love the smell of hot steel in the morning?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(98955,'How may I help you?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(98956,'We will not last much longer if those devastators are not destroyed!','',0,0,0,0,0,0,0,0,0,0,55260,0,26124),
(98957,'Come on, let\'s get up there!','',0,0,0,0,0,0,0,0,0,0,55257,0,26124),
(98958,'Have you come to cure us all, $n?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(98960,'Eons ago, Sargeras created Mardum to imprison demons. He also created the Sargerite Keystone to lock them away.\n\nBut when the Titan decided to burn all of creation, he shattered Mardum, sending its fragments hurtling throughout the Twisting Nether. Thus was born the Burning Legion.\n\nSargeras safeguarded his keystone on this particular fragment. It\'s a \'skeleton key\', allowing access to any Legion world. It\'s also the key to Lord Illidan\'s plan for the Legion\'s destruction.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(98961,'You may unlearn your current Class Specialization for a price, so that you may select a new one.\n\nThis will become more expensive each additonal time you do so.','You may unlearn your current Class Specialization for a price, so that you may select a new one.\n\nThis will become more expensive each additonal time you do so.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(98962,'Yes?','Yes?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98963,'Can you give me a lift back to the Foothold?','Can you give me a lift back to the Foothold?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98964,'You may unlearn all of your current Talents for a price, so that you may select new ones.\n\nThis will become more expensive each additonal time you do so.','You may unlearn all of your current Talents for a price, so that you may select new ones.\n\nThis will become more expensive each additonal time you do so.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(98965,'I lend you my power Hyrja!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98966,'You may empty all of your current Glyph slots for a price, so that you may select new ones.\n\nThis will become more expensive each additonal time you do so.','You may empty all of your current Glyph slots for a price, so that you may select new ones.\n\nThis will become more expensive each additonal time you do so.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(98967,'Naman and I will hold out here.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(98968,'','Your name... it\'s familiar. I believe this is the hero the others were talking about.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98969,'','I... what happened? My supplies - they\'re gone!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98970,'','Naman, still in a daze, looks around the room, searching for something.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98971,'This brave adventurer saved us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98972,'I would like to station a follower in Azsuna.','I would like to station a follower in Azsuna.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98973,'Your will is our command.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98974,'','Thank you. Be safe, brave adventurer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98975,'Station Lord Maxwell Tyrosus.','Station Lord Maxwell Tyrosus.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98976,'Station Vindicator Boros.','Station Vindicator Boros.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98977,'Station Aponi Brightmane.','Station Aponi Brightmane.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98978,'Station Lady Liadrin.','Station Lady Liadrin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98979,'Dual Specialization allows you to keep two active Class Specialization, Talent, and Glyph sets and easily switch between them.\n\nYou also will have separate glyph panes and action bars for each set.\n\nSwitching between the two sets cannot be done while in combat and will consume your available resources.','Dual Specialization allows you to keep two active Class Specialization, Talent, and Glyph sets and easily switch between them.\n\nYou also will have separate glyph panes and action bars for each set.\n\nSwitching between the two sets cannot be done while in combat and will consume your available resources.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(98980,'You have now learned Dual Specialization.','You have now learned Dual Specialization.',273,0,0,0,0,0,0,0,1,0,0,0,26124),
(98981,'Are you sure you would like to purchase Dual Specialization?','Are you sure you would like to purchase Dual Specialization?',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(98982,'What are soul chambers?','What are soul chambers?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98983,'Highlord, if you would like to station any of your followers so they may directly aid you in combat just let me know.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98984,'','Soul chambers are brilliant, but fragile gems that can be used to imprison demons.\n\nSoulkeeper Uriah and I were in possession of a handful of these shards until kobolds ransacked our caravan.\n\nThose mindless vermin have no idea what terror they may have unleashed.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(98985,'Mebok was right, the smarts are in the horns... but he kept trying to separate them from the raptor! We need the raptors intact, so we can use \'em to fight against the Legion.\n\nIf Mebok\'s books were right, I oughta be able to slather myself in some raptor pheromones and make myself their leader. Wish me luck!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98986,'<Coughing rather vigorously>$b$bWell that was unexpected! You alright, $n?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(98987,'','Deathlord, I must speak with you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98989,'Oh... the humanity!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98990,'Blood... ew! Wait a minute... yep - it\'s mine.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98991,'They got me good! I\'m fadin\' fast. Goodbye world...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98992,'I didn\'t expect to see anybody \'round these parts.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98993,'Normally I\'d offer my guests a snack, but I don\'t think those things would taste very good.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98994,'Sure am glad to see you, $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98995,'Come with me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98996,'She\'s all yours.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98997,'%s nudges the corpse gently with his workboot.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98998,'Never mess with a goblin and his wrench!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(98999,'','Glaciela, I swear, your teeth are going to fall out one day from eating all my delicious candies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99002,'','They outnumber us by an order of magnitude. Can we defeat them?',0,0,0,0,0,0,0,0,0,0,0,55092,26124),
(99003,'','You can find Grand Master Corvus working on the forges upstairs, $gsir:ma\'am;.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99004,'I feel footsteps... but they are not familiar...\n\nStranger... you must help...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(99005,'Many seasons have I slumbered. \n\nIt is good to smell the Runewood air again.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(99006,'|TInterface\\Icons\\inv_misc_volatilewater:20|t%s begins to |cFFFF0000|Hspell:191873|h[Submerge]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(99008,'We\'ve done it, Illidari! FREEDOM IS OURS!','',396,0,0,0,0,0,603,0,0,0,57366,0,26124),
(99009,'I\'m surrounded by weaklings! Just look at them, they couldn\'t cut their way out of a paper bag. \'Gonna be a liability when we fight the demons unless we can drill some proper skills into \'em.$b$bHow about we have a quick spar? Show \'em how real knights fight!','I\'m surrounded by weaklings! Just look at them, they couldn\'t cut their way out of a paper bag. \'Gonna be a liability when we fight the demons unless we can drill some proper skills into \'em.$b$bHow about we have a quick spar? Show \'em how real knights fight!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99010,'Hold on tight!','Hold on tight!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99011,'Sounds good, prepare yourself!','Sounds good, prepare yourself!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99012,'','My Lord Sargeras, no!!!',0,0,0,0,0,0,0,0,0,0,0,55055,26124),
(99013,'Hurry, $n. Use the keystone to activate the portal. We must rejoin the fight at the Black Temple.','',0,0,0,0,0,0,0,0,0,0,55259,0,26124),
(99014,'This may seem like nothing more than a tiny hole that no army can fit down, but it leads to the very lair of Neltharion himself.$b$bWithin, you shall find yourself behind the main assault force of the drogbar loyal to Dargrul.$b$bProceed with caution though, as those you do find will be more formidable than the drogbar you have encountered thus far. Good luck, brul.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99015,'Shoo! Get out of here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99016,'Caww! $p! $p!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99017,'These are NOT your lands!','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(99018,'I could always use more target practice!','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(99019,'','Thanks. Be safe out here.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(99020,'','$n, I have captured a few felbats. They will be ready when you decide to fly up to that Legion command ship.',2,0,0,0,0,0,0,0,0,0,0,0,26124),
(99021,'Whitemoon, I\'ll be taking one of your felbats. We\'re going to get what we came here for.','Whitemoon, I\'ll be taking one of your fel bats. We\'re going to get what we came here for.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99022,'Izal, get me back up there.','Izal, get me back up there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99023,'Is it over yet?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99024,'There\'s someone outside!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99025,'A visitor! Hey... is it safe out there yet?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99026,'','We are fine here. Please, just go... and be safe.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99027,'','We appreciate your visit, but this is not the time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99028,'','These lands have seen battle, but none like this...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99029,'','I\'m sure it will be over soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99030,'','The underking\'s forces assault Snowblind Mesa. Come! March the warpath with me and let us show them the might of Highmountain!',0,0,0,0,0,0,0,0,0,0,0,54867,26124),
(99031,'','Even now, the underking\'s forces march on Snowblind Mesa. Let us meet them in battle and show them the true power of Highmountain!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99032,'','March the warpath with me, and let us remind them that together, WE... ARE... HIGHMOUNTAIN!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99033,'You have more skill than I thought |5$r could possess.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(99034,'Thank you, $p. Arru will terrorize Thunder Totem no more. Instead, he will be a great aid. Help yourself to what he took from town.','',2,0,0,0,0,0,0,0,0,0,0,0,26124),
(99035,'I may have lost my bet, but I cannot deny your hunting skills.\n\nYou and the gnome have made fine additions to the hunting party.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(99036,'Again! A legion fighting as you do is an embarrassment to Sargeras!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99037,'Your blades are nearly as dull as your skills! Work harder, whelps!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99038,'Swing harder, and faster! This world\'s resistance must be broken!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99039,'','The elevator will be here shortly. The others are waiting for you above.',0,0,0,0,0,0,1,0,0,0,0,57356,26124),
(99040,'You\'d have better luck teaching a boar to fly than trying to teach a gnome to hunt.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(99041,'','I await your orders, Skylord. Now to explore this place!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99042,'I await your orders, Skylord.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99043,'','You\'ve more than proven your worth. It was an honor to hunt beside you and Addie.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(99044,'','Hemet only allows those with exceptional hunting skills to join his hunting party.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(99045,'I won\'t be forgettin\' that hunt anytime soon! \n\nI don\'t know if we could\'ve taken that beast down without you and Addie.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(99046,'Brul, you saved us from the Bloodtotem, so now I stand with Highmountain.$b$bWhile we Stonedark are no match for Dargrul\'s fighters in open combat, we do have other ways to help defeat your enemy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99047,'','The Skyhorn are nothing without their eagles!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99048,'Caww! $p! $p!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99049,'','For Highmountain!',0,0,0,0,0,0,0,0,0,0,0,54868,26124),
(99054,'','You will fall like all the others!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99055,'','Feast on their eyes my beauties!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99056,'','Your blood will rain from the sky!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99057,'Oh what a lovely day!','',275,0,0,0,0,0,0,0,0,0,0,0,26124),
(99058,'Something need doing?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(99059,'Zug zug.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99060,'You dare to assault Sargeras\' legion head-on? Come then, mortals, and face me!','You dare to assault Sargeras\' legion head-on? Come then, mortals, and face me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99061,'What is this? Our anchoring crystals are destroyed? I will flay the flesh from your bones, mortals!','What is this? Our anchoring crystals are destroyed? I will flay the flesh from your bones, mortals!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99062,'I\'ll keep pondering on how we can improve our leystone techniques, $n. Your training isn\'t done yet.','',0,0,0,0,0,0,0,0,0,33133,0,0,26124),
(99063,'Please, allow me to repay you.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(99064,'This way... and keep your head down. If those wyrmtongue catch a whiff of my concoctions they\'re sure to come running. Damn scavengers.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(99065,'','I commend you on a good start. However, your forces are already wavering.',0,0,0,0,0,0,0,0,0,0,0,55056,26124),
(99066,'','I\'d look forward to us meeting, but you will not survive.',0,0,0,0,0,0,0,0,0,0,0,55057,26124),
(99067,'','It\'s YOU who won\'t survive, demon witch!',0,0,0,0,0,0,0,0,0,0,0,55093,26124),
(99068,'','How droll. Even from up here, I can sense your uncertainty.',0,0,0,0,0,0,0,0,0,0,0,55058,26124),
(99069,'','Tell me dear, have you considered joining us?',0,0,0,0,0,0,0,0,0,0,0,55059,26124),
(99070,'','...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99071,'You cannot have them. They are mine!','',0,0,0,0,0,0,0,0,0,0,55199,0,26124),
(99072,'','I ask that you honor our pact and come to their aid.',0,0,0,0,0,0,0,0,0,0,0,55296,26124),
(99073,'','Soul harvesters are a vile Legion creation.',0,0,0,0,0,0,0,0,0,0,0,55009,26124),
(99074,'','You saved those Illidari from a fate worse than death.',0,0,0,0,0,0,0,0,0,0,0,55008,26124),
(99075,'That device you just destroyed helps stabilize the Legion\'s buildings.','',0,0,0,0,0,0,0,0,0,0,55235,0,26124),
(99076,'See if there are others around the fortress.','',0,0,0,0,0,0,0,0,0,0,55236,0,26124),
(99077,'You did it. Our forces have gained the upper hand.','',0,0,0,0,0,0,0,0,0,0,55261,0,26124),
(99078,'','Intruders on the Fel Hammer!',0,0,0,0,0,0,0,0,0,0,0,55025,26124),
(99079,'Now, we\'ll kill the brood queen and take the Sargerite Keystone.','',0,0,0,0,0,0,0,0,0,0,55254,0,26124),
(99080,'','You\'re free to try, demon hunter.',0,0,0,0,0,0,0,0,0,0,0,55060,26124),
(99081,'','What juicy little morsels you will make.',0,0,0,0,0,0,0,0,0,0,0,55061,26124),
(99082,'Sewer guards, time to take a break!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99083,'Sewer guards! Return to your posts!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99084,'Khadgar and his \"council\" may rule the roost above, but down here? My men and I run the show.$b$bI don\'t want to see any funny business while you\'re in my sewer, $r. That is, of course, unless you could convince me to look the other way...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99085,'Raethan, call off your guards.\n\n[Cost: 50 |TInterface\\Icons\\achievement_reputation_kirintor_offensive.blp:12|t Sightless Eyes]','Raethan, call off your guards.\n\n[Cost: 50 |TInterface\\Icons\\achievement_reputation_kirintor_offensive.blp:12|t Sightless Eyes]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99086,'Raethan, call back your guards.\n\n[Cost: 50 |TInterface\\Icons\\achievement_reputation_kirintor_offensive.blp:12|t Sightless Eyes]','Raethan, call back your guards.\n\n[Cost: 50 |TInterface\\Icons\\achievement_reputation_kirintor_offensive.blp:12|t Sightless Eyes]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99087,'Where\'s Torok?','',0,0,0,0,0,0,6,0,0,36914,54762,0,26124),
(99088,'The chief is expecting you down in the cave, Rivermane.','The chief is expecting you down in the cave, Rivermane.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(99089,'How do I obtain spooky supplies and merry supplies?','How do I obtain spooky supplies and merry supplies?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99090,'','During Hallow\'s End and the Feast of Winter Veil, locals may drop in and request your aid against some of the denizens of Draenor. They\'ll surely be willing to part with some festive supplies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99091,'The inhabitants of Tarren Mill have been inspired to join the fight against the Legion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99092,'Impossible!','',0,0,0,0,0,0,0,0,0,0,55200,0,26124),
(99093,'','My thanks. Come, my brothers... back to the battle!',0,0,0,0,0,0,0,0,0,0,0,55076,26124),
(99094,'','$n, my naga are trapped by a nearby pit lord.',0,0,0,0,0,0,0,0,0,0,0,55298,26124),
(99095,'Shaman! I have an urgent message.','',0,0,0,0,0,0,1,0,0,0,60553,0,26124),
(99096,'Yes, we must strike back. But how?','',0,0,0,0,0,0,6,0,0,0,60554,0,26124),
(99097,'We need weapons capable of overcoming the Legion.','',0,0,0,0,0,0,1,0,0,0,60529,0,26124),
(99100,'They will come for us.','',0,0,0,0,0,0,1,0,0,0,60559,0,26124),
(99103,'There are ancient safeguards here. We must use them.','',0,0,0,0,0,0,1,0,0,0,60530,0,26124),
(99104,'Help her! She\'s fadin\' fast!','',0,0,0,0,0,0,5,0,0,0,60539,0,26124),
(99105,'Thank ye, shaman.','',0,0,0,0,0,0,1,0,0,0,60540,0,26124),
(99106,'','The Highlands are completely overrun. The clan is scattered.',0,0,0,0,0,0,1,0,0,0,0,60550,26124),
(99107,'','What kind of a shaman can\'t light a fire?',0,0,0,0,0,0,6,0,0,0,0,60560,26124),
(99108,'Shush, you! Dis wood be wet and me hands be shakin\'.','',0,0,0,0,0,0,0,0,0,0,60525,0,26124),
(99109,'','The Legion destroys us in the open fields. Even Thunder Bluff isn\'t safe from the Infernals.',0,0,0,0,0,0,1,0,0,0,0,60561,26124),
(99110,'This thing has sat useless for ten thousand years.','',0,0,0,0,0,0,6,0,0,0,60548,0,26124),
(99112,'It just needs a little... boost. Shaman, can you help?','',0,0,0,0,0,0,1,0,0,0,60526,0,26124),
(99113,'Do you see? It\'s working. This world will fight for itself if we give it the tools to do so.','',0,0,0,0,0,0,1,0,0,0,60527,0,26124),
(99114,'Look out!','',0,0,0,0,0,0,0,0,0,0,60555,0,26124),
(99115,'','They followed us here!',0,0,0,0,0,0,5,0,0,0,0,60551,26124),
(99116,'I knew yer crap bird was too slow.','',0,0,0,0,0,0,1,0,0,0,60545,0,26124),
(99117,'My bird woulda been quicker if she weren\'t haulin\' yer fat arse.','',0,0,0,0,0,0,5,0,0,0,60542,0,26124),
(99118,'Here is where you insects crawled!','',0,0,0,0,0,0,396,0,0,0,60533,0,26124),
(99119,'Take to your knees, and my Master may yet be merciful.','',0,0,0,0,0,0,0,0,0,0,60538,0,26124),
(99120,'Your Master has not won yet.','',0,0,0,0,0,0,0,0,0,0,60556,0,26124),
(99121,'Ha-hah!! You are a champion in the making!','',0,0,0,0,0,0,15,0,0,0,60546,0,26124),
(99122,'Help the others!','',0,0,0,0,0,0,0,0,0,0,60547,0,26124),
(99123,'Spirits... hear my call...','',0,0,0,0,0,0,0,0,0,0,60557,0,26124),
(99124,'Are you the so-called \'World Shaman?\' Hah! You fight like a crippled pig.','',0,0,0,0,0,0,0,0,0,0,60534,0,26124),
(99125,'We can fight this... but we must work together...','',0,0,0,0,0,0,1,0,0,0,60528,0,26124),
(99126,'Auugh--','',0,0,0,0,0,0,0,0,0,0,60558,0,26124),
(99127,'You are so weak. You can barely lift your hammer, \'shaman.\'','',0,0,0,0,0,0,0,0,0,0,60537,0,26124),
(99128,'','Wildhammer!',0,0,0,0,0,0,15,0,0,0,0,60549,26124),
(99129,'Wildhammer!','',0,0,0,0,0,0,15,0,0,0,60541,0,26124),
(99130,'Wildhammer!','',0,0,0,0,0,0,15,0,0,0,60543,0,26124),
(99131,'','Over here, shaman! Take up my spear. The winds will guide your strike!',0,0,0,0,0,0,25,0,0,0,0,60524,26124),
(99132,'Do it! Bring it down!','',0,0,0,0,0,0,5,0,0,0,60544,0,26124),
(99133,'The heart. Get the heart.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(99134,'It is ready! Everyone, focus on the pillar. Quickly!','',0,0,0,0,0,0,5,0,0,0,60516,0,26124),
(99135,'You will die!','',0,0,0,0,0,0,0,0,4,0,60535,0,26124),
(99136,'Your precious \'earthen ring\' will shatter!','',0,0,0,0,0,0,1,0,4,0,60531,0,26124),
(99137,'Your world will succumb!!','',0,0,0,0,0,0,0,0,4,0,60536,0,26124),
(99138,'THE LEGION WILL--','',0,0,0,0,0,0,0,0,4,0,60532,0,26124),
(99139,'Hear me, elements of Azeroth.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(99140,'Once, we walked as one. I abused your powers for my own personal vendetta.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99141,'Take back the Doomhammer! Grant it to one who is worthy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99142,'Teach me, and again I will be your servant.','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(99143,'','Rivermane, scale the breach in flanking positions. Find a safe place to heal from.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99144,'','Skyhorn, take to the skies and keep our northern flank clear.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99145,'Thank ye, outsider. Follow me, and I\'ll tell ya me plan!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99146,'%s places the samples carefully in their satchel.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99147,'%s holds the sample toward the skies, inspecting them closely.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99148,'%s brings the sample close, sniffs it, then tastes it with a quick swipe of the tongue.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99149,'%s ponders the value of the collected sample, then throws it carelessly into its pack.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99150,'%s inspects the sample, shakes it, then discards it on the floor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99151,'%s tests the sample\'s toughness, then places it into its pack.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99152,'Light guide your blade, Highlord. Take care of yourself out there.','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(99153,'','Don\'t worry, mother\'s here... Oh my, he\'s a big one.',0,0,0,0,0,0,0,0,0,0,0,55321,26124),
(99155,'Let\'s go hunting!','Let\'s go hunting!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99156,'Yes... yes! Gather it all and bring it here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99157,'Such delicacies! We need them all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99158,'Master will be very pleased! Findings very interesting!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99159,'Into the pot! Bubbling to the top!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99160,'These creatures... mmm so delicious! They makes us trinkets of all kinds!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99161,'','I\'ll keep the water buckets coming. You put the fire out!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99162,'Achh! Me poor cart!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99163,'By Thargus\' bloody anvil! Is that... fel flame?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99164,'What in blazes is goin\' on today?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99165,'Stop them you idiots, or they\'ll break our anchoring with the Nether!','Stop them you idiots, or they\'ll break our anchoring with the Nether!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99166,'We\'re under attack! Crush these weaklings, and earn Sargeras\' favor!','We\'re under attack! Crush these weaklings, and earn Sargeras\' favor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99167,'Stupid, tiny things...','',0,0,0,0,0,0,0,0,0,0,55337,0,26124),
(99168,'','I\'m needed elsewhere.',0,0,0,0,0,0,0,0,0,0,0,55323,26124),
(99169,'','A mother\'s work is never done.',0,0,0,0,0,0,0,0,0,0,0,55320,26124),
(99170,'I\'ll hammer you into shape.','',0,0,0,0,0,0,0,0,0,0,55336,0,26124),
(99171,'Nope!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99172,'$n, this is embarassing...','',0,0,0,0,0,0,0,0,0,0,55049,0,26124),
(99173,'Want your little, broken draenei back?','',0,0,0,0,0,0,0,0,0,0,55281,0,26124),
(99174,'I would like to station a follower in Val\'Sharah.','I would like to station a follower in Val\'Sharah.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99175,'And you.','',0,0,0,0,0,0,396,0,0,924,53391,0,26124),
(99176,'We\'ve got to take down this portal!','',0,0,0,0,0,0,1,0,0,924,53392,0,26124),
(99177,'','The anchoring crystals are the key, just get us up there, and we\'ll take care of it.',0,0,0,0,0,0,396,0,0,924,0,53393,26124),
(99178,'Form up, Alliance! We push them back to the portal! For Azeroth!','',0,0,0,0,0,0,5,0,0,924,53394,0,26124),
(99179,'','Focus on the crystals!',0,0,0,0,0,0,0,0,0,924,0,53395,26124),
(99180,'Heal the wounded, we can\'t rest here for long.','',0,0,0,0,0,0,396,0,0,924,53396,0,26124),
(99181,'','What happened here?',0,0,0,0,0,0,6,0,0,924,0,53397,26124),
(99182,'It happened in seconds! We were fighting our way up the shore and then BOOM, explosions of fel energy all around us! And these buildings just grew up out of them, filled with demons! I don\'t know how we\'re going to be able to push them back at this rate!','',0,0,0,0,0,0,1,0,0,924,53398,0,26124),
(99183,'One demon at a time. With me, Alliance, leave nothing standing!','',0,0,0,0,0,0,5,0,0,924,53399,0,26124),
(99184,'You\'re from the Crusade! What happened? Where is Tirion?','',0,0,0,0,0,0,396,0,0,924,53400,0,26124),
(99185,'Don\'t know... they were on us in seconds... felfire everywhere...','Don\'t know... they were on us in seconds... felfire everywhere...',0,0,0,0,0,0,396,0,0,924,60734,61188,26124),
(99186,'Save your strength, we will find him.','',0,0,0,0,0,0,396,0,0,924,53402,0,26124),
(99187,'','Keep your eyes open for survivors! Save as many as you can!',0,0,0,0,0,0,5,0,0,924,0,53403,26124),
(99188,'Back where you came from!','',0,0,0,0,0,0,0,0,0,924,53404,0,26124),
(99189,'We\'re pushing them back! Don\'t let up!','',0,0,0,0,0,0,0,0,0,924,53405,0,26124),
(99190,'We\'re halfway there, take heart Alliance!','',0,0,0,0,0,0,0,0,0,924,53406,0,26124),
(99191,'For the Alliance!','',0,0,0,0,0,0,0,0,0,924,53407,0,26124),
(99192,'Taste blaster!','',0,0,0,0,0,0,0,0,0,924,53408,0,26124),
(99193,'For Gnomeregan!','',0,0,0,0,0,0,0,0,0,924,53409,0,26124),
(99194,'Back to the Nether with you!','',0,0,0,0,0,0,0,0,0,924,53410,0,26124),
(99195,'For... the Alliance...','For... the Alliance...',0,0,0,0,0,0,0,0,0,924,70948,61199,26124),
(99196,'I can\'t... go on...','I can\'t... go on...',0,0,0,0,0,0,0,0,0,924,70947,61200,26124),
(99197,'','Structural integrity at 0%%!',0,0,0,0,0,0,0,0,0,924,0,70946,26124),
(99198,'','They\'ve broken through my mechbot!',0,0,0,0,0,0,0,0,0,924,0,70945,26124),
(99206,'They\'ve slain me, my queen...','',0,0,0,0,0,0,0,0,0,0,55282,0,26124),
(99216,'Yes, yes more trinkets, give them to me!','',0,0,0,0,0,0,0,0,0,0,53431,0,26124),
(99217,'Kill you! Take your things!','',0,0,0,0,0,0,0,0,0,0,53432,0,26124),
(99218,'Curse your soul!','',0,0,0,0,0,0,0,0,0,0,53433,0,26124),
(99219,'They took Tirion!','They took Tirion!',0,0,0,0,0,0,396,0,0,924,60735,61189,26124),
(99220,'Light have mercy on us...','Light have mercy on us...',0,0,0,0,0,0,396,0,0,924,60736,61190,26124),
(99221,'I can still fight, I\'m with you.','I can still fight, I\'m with you.',0,0,0,0,0,0,396,0,0,924,60737,61191,26124),
(99222,'They came out of nowhere!','They came out of nowhere!',0,0,0,0,0,0,396,0,0,924,60738,61192,26124),
(99223,'By the light, it is good to see you.','By the light, it is good to see you.',0,0,0,0,0,0,396,0,0,924,60739,61193,26124),
(99224,'Have you seen Tirion?','Have you seen Tirion?',0,0,0,0,0,0,396,0,0,924,60740,61194,26124),
(99225,'I can\'t feel the Light in this place...','I can\'t feel the Light in this place...',0,0,0,0,0,0,396,0,0,924,60741,61195,26124),
(99226,'You\'re a welcome sight!','You\'re a welcome sight!',0,0,0,0,0,0,396,0,0,924,60742,61196,26124),
(99227,'Thank you, hero.','Thank you, hero.',0,0,0,0,0,0,396,0,0,924,60743,61197,26124),
(99228,'We couldn\'t hold them off...','We couldn\'t hold them off...',0,0,0,0,0,0,396,0,0,924,60744,61198,26124),
(99229,'They\'re retreating.','',0,0,0,0,0,0,0,0,6,924,53444,0,26124),
(99230,'I get the feeling this fight isn\'t over yet.','',0,0,0,0,0,0,0,0,6,924,53445,0,26124),
(99231,'','Varian, I found him! Look, across the chasm, Tirion!',0,0,0,0,0,0,0,0,6,924,0,53446,26124),
(99232,'All forces, to Jaina!','',0,0,0,0,0,0,0,0,6,924,53447,0,26124),
(99233,'How are we going to get across?','',0,0,0,0,0,0,1,0,0,924,53448,0,26124),
(99234,'','I\'ve got this.',0,0,0,0,0,0,0,0,0,924,0,53449,26124),
(99235,'Tirion!','',0,0,0,0,0,0,5,0,0,0,53450,0,26124),
(99236,'','Gul\'dan! You will pay for this!',0,0,0,0,0,0,5,0,0,0,0,53451,26124),
(99237,'Stay back... it\'s a trap... the Light will protect me...','',0,0,0,0,0,0,0,0,0,0,53452,0,26124),
(99238,'Ha, you fool! You stand before the temple of a GOD. Your pitiful Light cannot reach you here. How fortunate that your friends have arrived just in time to watch you die.','',0,0,0,0,0,0,396,0,0,0,53453,0,26124),
(99239,'Destroy him.','',0,0,0,0,0,0,274,0,0,0,53454,0,26124),
(99240,'The Light... will... ahh!  Aahhhh!!','',0,0,0,0,0,0,0,0,0,0,53455,0,26124),
(99241,'Fordring!','',0,0,0,0,0,0,5,0,0,0,53456,0,26124),
(99242,'','No!',0,0,0,0,0,0,5,0,0,0,0,53457,26124),
(99243,'All you have worked for, all you have sacrificed, just to see your champions fall to ash one by one.','',0,0,0,0,0,0,25,0,0,0,53458,0,26124),
(99244,'We will never give in to hopelessness!','',0,0,0,0,0,0,0,0,0,0,53459,0,26124),
(99245,'','The armies of Azeroth will triumph this day, together.',0,0,0,0,0,0,0,0,0,0,0,53460,26124),
(99246,'Together, for Azeroth!','',0,0,0,0,0,0,0,0,0,0,53461,0,26124),
(99247,'Destroy them!','',0,0,0,0,0,0,274,0,0,0,53462,0,26124),
(99248,'You will know fear.','',0,0,0,0,0,0,0,0,0,0,53463,0,26124),
(99249,'Brace yourselves, Alliance, it\'s coming this way!','',0,0,0,0,0,0,0,0,0,0,53464,0,26124),
(99250,'','Monsters from the felfire! Horde forces, be ready!',0,0,0,0,0,0,0,0,0,923,0,53465,26124),
(99251,'Focus your fire, bring him down!','',0,0,0,0,0,0,0,0,0,924,53466,0,26124),
(99252,'','He\'s going to breathe, look out!',0,0,0,0,0,0,0,0,0,924,0,53467,26124),
(99253,'Front line, avoid those fists!','',0,0,0,0,0,0,0,0,0,924,53468,0,26124),
(99254,'Fel magma incoming, watch yourselves!','',0,0,0,0,0,0,1,0,0,924,53469,0,26124),
(99255,'My forces are decimated. I have failed you.','',0,0,0,0,0,0,0,0,0,0,55050,0,26124),
(99256,'The magma erupts, watch yourselves!','',0,0,0,0,0,0,0,0,0,923,53470,0,26124),
(99257,'','Another wave incoming!',0,0,0,0,0,0,0,0,0,923,0,53471,26124),
(99258,'More beasts from da flame!','',0,0,0,0,0,0,0,0,0,923,53472,0,26124),
(99259,'They come at us again!','',0,0,0,0,0,0,0,0,0,923,53473,0,26124),
(99260,'I swear to give my life if that is what it takes.','',0,0,0,0,0,0,0,0,0,0,55051,0,26124),
(99261,'He\'s heading your way, Windrunner!','',0,0,0,0,0,0,0,0,0,0,53474,0,26124),
(99262,'','Let\'s go, Horde, it\'s time to show the Alliance how we slay demons.',0,0,0,0,0,0,0,0,0,0,0,53475,26124),
(99263,'','Beasts from the felfire emerge, be careful!',0,0,0,0,0,0,0,0,0,924,0,53476,26124),
(99264,'The next wave approaches, be ready!','',0,0,0,0,0,0,0,0,0,924,53477,0,26124),
(99265,'','They\'re coming again, let\'s put them on ice!',0,0,0,0,0,0,0,0,0,924,0,53478,26124),
(99266,'More enemies emerge from the flames!','',0,0,0,0,0,0,0,0,0,924,53479,0,26124),
(99267,'That magma\'s going to erupt, be ready to duck!','',0,0,0,0,0,0,1,0,0,924,53480,0,26124),
(99268,'He breathes that foul breath again, look out!','',0,0,0,0,0,0,0,0,0,923,53481,0,26124),
(99269,'','All Horde forces on my target, we\'re going to bring down that demon.',0,0,0,0,0,0,0,0,0,923,0,53482,26124),
(99270,'Dat great ball o\' felfire is comin\' dis way!','',0,0,0,0,0,0,0,0,0,923,53483,0,26124),
(99271,'His fists are like mountains! Keep moving!','',0,0,0,0,0,0,0,0,0,923,53484,0,26124),
(99272,'You\'ve got another shot at the kill, Sylvanas!','',0,0,0,0,0,0,0,0,0,0,53485,0,26124),
(99273,'','Consider your job done then, Wrynn.',0,0,0,0,0,0,0,0,0,0,0,53486,26124),
(99274,'','All yours, Alliance.',0,0,0,0,0,0,0,0,0,0,0,53487,26124),
(99275,'We\'ve got him this time! All forces, concentrate your fire!','',0,0,0,0,0,0,0,0,0,0,53488,0,26124),
(99276,'Ha, the bigger they are...','',0,0,0,0,0,0,153,0,0,0,53489,0,26124),
(99277,'','No time to gloat, Wrynn. We\'ve got to stop Gul\'dan before he summons another one of those things!',0,0,0,0,0,0,274,0,0,0,0,53490,26124),
(99278,'Everyone, across the chasm!','',0,0,0,0,0,0,5,0,0,924,53491,0,26124),
(99279,'','We\'ll take the ridge and cover your flank.',0,0,0,0,0,0,396,0,0,0,0,53492,26124),
(99280,'Sylvanas, thank you.','',0,0,0,0,0,0,396,0,0,0,53493,0,26124),
(99281,'','Good luck, Varian.',0,0,0,0,0,0,396,0,0,0,0,53494,26124),
(99282,'And you.','',0,0,0,0,0,0,396,0,0,0,53495,0,26124),
(99283,'There is nowhere to run, Gul\'dan. Give up now, and I will grant you a swift death.','',0,0,0,0,0,0,396,0,0,0,53496,0,26124),
(99284,'Run? Ha. You are right, human. There is nowhere to run from my master.  Now, witness the true might of Lord Sargeras!','',0,0,0,0,0,0,1,0,0,0,53497,0,26124),
(99285,'Hold steady, we\'ve broken their lines before, we will again. Charge!','',0,0,0,0,0,0,0,0,0,924,53498,0,26124),
(99286,'Down the ridge behind us, another portal!','',0,0,0,0,0,0,5,0,0,923,53499,0,26124),
(99287,'We\'ve got to hold dis ridge, no matter da cost.','',0,0,0,0,0,0,396,0,0,923,53500,0,26124),
(99288,'','Take up positions. We hold them off. We have to.',0,0,0,0,0,0,396,0,0,923,0,53501,26124),
(99289,'I cannot... take much more of this...','',0,0,0,0,0,0,0,0,0,923,53502,0,26124),
(99290,'','Pull Baine back to my position, close ranks!',0,0,0,0,0,0,5,0,0,923,0,53503,26124),
(99291,'We will never fall to you, Gul\'dan. The combined forces of Azeroth will triumph today.','',0,0,0,0,0,0,396,0,0,0,53504,0,26124),
(99292,'','Less chatting, Wrynn. Kill him already!',0,0,0,0,0,0,5,0,0,0,0,53505,26124),
(99293,'I have seen the end of your pitiful world, Wrynn. You will perish in felfire, like ten thousand worlds before your own. The legion is ENDLESS.','',0,0,0,0,0,0,1,0,0,0,53506,0,26124),
(99294,'','Shelds up, here they come!',0,0,0,0,0,0,0,0,0,924,0,53507,26124),
(99295,'Even more demons be pouring from dat portal. Get ready!','',0,0,0,0,0,0,5,0,0,923,53508,0,26124),
(99297,'','Vol\'jin! Pull him back! Keep your lines steady! We have to hold!',0,0,0,0,0,0,5,0,0,923,0,53510,26124),
(99298,'There are... too many of them!','',0,0,0,0,0,0,0,0,0,923,53511,0,26124),
(99299,'','Everyone pull back to me! We make our stand here!',0,0,0,0,0,0,5,0,0,923,0,53512,26124),
(99300,'No matter how many demons you throw at us, we will cut you down, monster.','',0,0,0,0,0,0,396,0,0,0,53513,0,26124),
(99301,'And now you will fall.','',0,0,0,0,0,0,1,0,0,924,53514,0,26124),
(99302,'Hold on, Alliance!','',0,0,0,0,0,0,0,0,0,924,53515,0,26124),
(99303,'We return.','',0,0,0,0,0,0,396,0,0,924,53516,0,26124),
(99304,'To conquer this puny world.','',0,0,0,0,0,0,396,0,0,924,53517,0,26124),
(99305,'And burn it to a husk.','',0,0,0,0,0,0,396,0,0,924,53518,0,26124),
(99306,'Do you see now, human? The fate of this world is sealed. The legion cannot be stopped.','',0,0,0,0,0,0,0,0,0,924,53519,0,26124),
(99307,'Together, we will defeat you, just as we always have.','',0,0,0,0,0,0,0,0,0,924,53520,0,26124),
(99309,'','Varian, behind us!  The Horde is gone!',0,0,0,0,0,0,0,0,0,924,0,53522,26124),
(99310,'','There are so many of them...',0,0,0,0,0,0,0,0,0,923,0,53523,26124),
(99311,'','There\'s nothing we can do! The ridge is lost! Horde forces, if you value your lives, cut a path through to the shore! We have to get out of here, or there won\'t be anyone left to fight!',0,0,0,0,0,0,0,0,0,923,0,53524,26124),
(99312,'It looks like our reinforcements have arrived.','',0,0,0,0,0,0,396,0,0,923,53525,0,26124),
(99313,'Good ting! We don\'t got much beach left ta retreat to.','',0,0,0,0,0,0,396,0,0,923,53526,0,26124),
(99314,'There\'s only one way out of this one, old friend.','',0,0,0,0,0,0,396,0,0,923,53527,0,26124),
(99315,'Listen up! Dere\'s only one way offa dis beach, and it be t\'rough alla dose demons ahead of us. But dey don\'t know who dey be dealin\' wit. Let\'s show dem what it means ta be Horde!','',0,0,0,0,0,0,5,0,0,923,53528,0,26124),
(99316,'I return... to the elements...','I return... to the elements...',0,0,0,0,0,0,0,0,0,923,70944,69116,26124),
(99317,'Not... going to make it...','Not... going to make it...',0,0,0,0,0,0,0,0,0,923,70943,69117,26124),
(99318,'Da pain!','Da pain!',0,0,0,0,0,0,0,0,0,923,69129,70942,26124),
(99319,'Dis be da end...','Dis be da end...',0,0,0,0,0,0,0,0,0,923,69130,70941,26124),
(99320,'Back to the Nether!','',0,0,0,0,0,0,0,0,0,923,53533,0,26124),
(99321,'The elements will destroy you!','',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(99322,'Lok\'tar ogar!','',0,0,0,0,0,0,0,0,0,923,53535,0,26124),
(99323,'Die.','',0,0,0,0,0,0,0,0,0,923,53536,0,26124),
(99324,'Dis one\'s mine.','',0,0,0,0,0,0,0,0,0,923,53537,0,26124),
(99325,'For da Horde!','',0,0,0,0,0,0,0,0,0,923,53538,0,26124),
(99326,'Ha, the fools attack!','',0,0,0,0,0,0,0,0,0,923,53539,0,26124),
(99327,'Crush them!','',0,0,0,0,0,0,0,0,0,923,53540,0,26124),
(99328,'Keep them away from the spires!','',0,0,0,0,0,0,0,0,0,923,53541,0,26124),
(99329,'There\'s something odd about the crystals surrounding that spire. They feel... wrong... like they\'re in two places at once. Hmm.','',0,0,0,0,0,0,0,0,0,923,53542,0,26124),
(99330,'Horde, make for dem crystals! We gonna see if ya hunch is right.','',0,0,0,0,0,0,0,0,0,923,53543,0,26124),
(99331,'Yes... they must anchor it to this world.','',0,0,0,0,0,0,0,0,0,923,53544,0,26124),
(99332,'Two more ta go.','',0,0,0,0,0,0,0,0,0,923,53545,0,26124),
(99333,'You destroy but one of the master\'s endless instruments of your demise! INFERNO!','',0,0,0,0,0,0,0,0,0,923,53546,0,26124),
(99334,'Keep it up! We almost got dem!','',0,0,0,0,0,0,0,0,0,923,53547,0,26124),
(99335,'Weaklings. Must I do everything myself? Very well, prepare yourselves!','',0,0,0,0,0,0,0,0,0,923,53548,0,26124),
(99336,'You gonna die just like all da others.','',0,0,0,0,0,0,397,0,0,923,53549,0,26124),
(99337,'Focus on the commander!','',0,0,0,0,0,0,0,0,0,923,53550,0,26124),
(99338,'You will all burn!','',0,0,0,0,0,0,0,0,0,923,53551,0,26124),
(99339,'Felfire rains from the sky! Look out!','',0,0,0,0,0,0,0,0,0,923,53552,0,26124),
(99340,'Your corpses will feed my hounds.','',0,0,0,0,0,0,0,0,0,923,53553,0,26124),
(99341,'Your souls will know endless agony.','',0,0,0,0,0,0,0,0,0,923,53554,0,26124),
(99342,'Looks like ya chose da wrong side.','',0,0,0,0,0,0,153,0,0,923,53555,0,26124),
(99343,'The master will mend my flesh again and again. You have not won. You cannot win. We are endless! We are Legion!','',0,0,0,0,0,0,0,0,0,923,53556,0,26124),
(99344,'I... will... return...','',0,0,0,0,0,0,0,0,0,923,53557,0,26124),
(99345,'It is good to fight with you again, Warchief.','',0,0,0,0,0,0,396,0,0,923,53558,0,26124),
(99346,'Ain\'t never gonna get used to you callin\' me dat.','',0,0,0,0,0,0,153,0,0,923,53559,0,26124),
(99347,'There\'s only one way to the tomb, are you ready?','',0,0,0,0,0,0,6,0,0,923,53560,0,26124),
(99348,'Let\'s get movin\'.','',0,0,0,0,0,0,396,0,0,923,53561,0,26124),
(99349,'Sylvanas\' ship must \'av crashed just ahead.','',0,0,0,0,0,0,396,0,0,923,53562,0,26124),
(99350,'They\'re expanding faster than we\'ve seen before.','',0,0,0,0,0,0,396,0,0,923,53563,0,26124),
(99351,'Ya, mon. Dis ain\'t da same Legion.','',0,0,0,0,0,0,396,0,0,923,53564,0,26124),
(99352,'What?','',0,0,0,0,0,0,0,0,6,923,53565,0,26124),
(99353,'Dat\'s no invasion force. Dat\'s an army!','',0,0,0,0,0,0,0,0,6,923,53566,0,26124),
(99354,'','Nock your arrows! Hold! Fire!',0,0,0,0,0,0,0,0,6,923,0,53567,26124),
(99355,'They\'re alive!','',0,0,0,0,0,0,5,0,0,923,53568,0,26124),
(99356,'Let\'s move!','',0,0,0,0,0,0,5,0,0,923,53569,0,26124),
(99357,'','It\'s about time you showed up!',0,0,0,0,0,0,396,0,0,923,0,53570,26124),
(99358,'You looked like you could use a hand.','',0,0,0,0,0,0,396,0,0,923,53571,0,26124),
(99359,'Their reinforcements are endless!','',0,0,0,0,0,0,5,0,0,923,53572,0,26124),
(99360,'Those crystals again... if we can get close to them, we can bring this thing down.','',0,0,0,0,0,0,396,0,0,923,53573,0,26124),
(99361,'','You heard him, rangers, we cut those demons down! Fire a volley on my mark... NOW!',0,0,0,0,0,0,5,0,0,923,0,53574,26124),
(99362,'Break the crystals!','',0,0,0,0,0,0,0,0,0,923,53575,0,26124),
(99363,'','Well, that was invigorating. Now how did they manage to get so many demons here so quickly?',0,0,0,0,0,0,6,0,0,923,0,53576,26124),
(99364,'This invasion is unlike any I have ever witnessed, and I don\'t think we\'ve seen the last of their surprises.','',0,0,0,0,0,0,396,0,0,923,53577,0,26124),
(99365,'These structures rose from the ground in moments, spewing forth demons in the hundreds in the blink of an eye.','',0,0,0,0,0,0,396,0,0,923,53578,0,26124),
(99366,'','And now we know how to destroy them. It\'s them or us. Let\'s get moving so we make sure it\'s not us.',0,0,0,0,0,0,396,0,0,923,0,53579,26124),
(99367,'','This is Argent Crusade insignia, can you speak? Where is the rest of the Crusade?',0,0,0,0,0,0,6,0,0,923,0,53580,26124),
(99368,'Dead... dying... they descended on us in seconds... nowhere to run...','Dead... dying... they descended on us in seconds... nowhere to run...',0,0,0,0,0,0,396,0,0,923,61535,69136,26124),
(99369,'An no sign of Tirion.','',0,0,0,0,0,0,396,0,0,923,53582,0,26124),
(99370,'We will find him. Horde forces, keep your eyes open for survivors, rescue as many as you are able!','',0,0,0,0,0,0,5,0,0,923,53583,0,26124),
(99371,'','One shot, one kill.',0,0,0,0,0,0,0,0,0,923,0,53584,26124),
(99372,'','Too easy.',0,0,0,0,0,0,0,0,0,923,0,53585,26124),
(99373,'','That\'s half of the city down, this is going better than expected.',0,0,0,0,0,0,0,0,0,923,0,53586,26124),
(99374,'','Right to the face!',0,0,0,0,0,0,0,0,0,923,0,53587,26124),
(99375,'','We\'ll never bow to you.',0,0,0,0,0,0,0,0,0,923,0,53588,26124),
(99376,'To the earth with you!','',0,0,0,0,0,0,0,0,0,923,53589,0,26124),
(99377,'Take heart, heroes!','',0,0,0,0,0,0,0,0,0,923,53590,0,26124),
(99378,'For the Earth Mother!','',0,0,0,0,0,0,0,0,0,923,53591,0,26124),
(99379,'Darkness... calls...','Darkness... calls...',0,0,0,0,0,0,0,0,0,923,53592,0,26124),
(99380,'This is... the end...','This is... the end...',0,0,0,0,0,0,0,0,0,923,53593,0,26124),
(99381,'I return... to the earth...','I return... to the earth...',0,0,0,0,0,0,0,0,0,923,70935,70936,26124),
(99382,'Earth Mother... guide me...','Earth Mother... guide me...',0,0,0,0,0,0,0,0,0,923,70933,70934,26124),
(99383,'We must find Tirion.','We must find Tirion.',0,0,0,0,0,0,396,0,0,923,61536,69137,26124),
(99384,'I am singed, but I can still fight.','I am singed, but I can still fight.',0,0,0,0,0,0,396,0,0,923,61537,69138,26124),
(99385,'Thank you for your aid.','Thank you for your aid.',0,0,0,0,0,0,396,0,0,923,61538,69139,26124),
(99386,'We were not prepared!','We were not prepared!',0,0,0,0,0,0,396,0,0,923,61539,69140,26124),
(99387,'It\'s good to see a friendly face.','It\'s good to see a friendly face.',0,0,0,0,0,0,396,0,0,923,61540,69141,26124),
(99388,'Where is Tirion?','Where is Tirion?',0,0,0,0,0,0,396,0,0,923,61541,69142,26124),
(99389,'I am wounded, but I can move.','I am wounded, but I can move.',0,0,0,0,0,0,396,0,0,923,61542,69143,26124),
(99390,'I am in your debt.','I am in your debt.',0,0,0,0,0,0,396,0,0,923,61543,69144,26124),
(99391,'We couldn\'t stop them...','We couldn\'t stop them...',0,0,0,0,0,0,396,0,0,923,61544,69145,26124),
(99392,'There were so many of them.','There were so many of them.',0,0,0,0,0,0,396,0,0,923,61545,69146,26124),
(99393,'Dey be retreatin\'.','',0,0,0,0,0,0,0,0,6,923,53606,0,26124),
(99394,'','That was too easy, something\'s wrong.',0,0,0,0,0,0,0,0,6,923,0,53607,26124),
(99395,'There, across the chasm, Gul\'dan! He has Tirion!','',0,0,0,0,0,0,0,0,6,923,53608,0,26124),
(99396,'All da Horde, get ta Thrall!','',0,0,0,0,0,0,0,0,6,923,53609,0,26124),
(99397,'','Anyone have any ideas how we\'re going to get across this thing?',0,0,0,0,0,0,6,0,0,923,0,53610,26124),
(99398,'Spirits of earth, aid me!','',0,0,0,0,0,0,0,0,0,923,53611,0,26124),
(99399,'','Convenient.',0,0,0,0,0,0,153,0,0,923,0,53612,26124),
(99400,'','You WILL be avenged, my love!',0,0,0,0,0,0,0,0,0,0,0,55062,26124),
(99401,'','Well, look who decided to show up. It\'s been a while since you\'ve been in the halls of Acherus.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99402,'It is good to see you as well, but we can reminisce later. I must speak with the $ct at once.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99403,'I\'m not here to waste time with the \"help,\" I must speak with the $ct at once.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99404,'Thank you, $ct.  I need to go see Corvis about getting my armor repaired. By your leave, $gsir:ma\'am;.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99405,'Thank you, Deathlord. I will not let you down.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99406,'I swear, I don\'t know nothin\' about any demon flames! I was just buyin\' and sellin\' armor, is all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99407,'Why should I believe you?','Why should I believe you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99408,'I believe you.','I believe you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99409,'I\'m just an honest trader, just lookin\' to buy all the goods on the auction house, sell \'em back to the people at a much higher price, make my ten million gold, and go home in peace! Is that so much to ask?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99410,'I know your kind. A dirty auction house speculator.','I know your kind. A dirty auction house speculator.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99411,'Very well. I believe you.','Very well. I believe you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99412,'No... I\'m one of the good ones! I... I donated to charity, once! And I hardly ever litter!$b$bAnd I never, EVER undercut.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99413,'Were there any other witnesses to what happened?','Were there any other witnesses to what happened?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99414,'Fine, I believe you.','Fine, I believe you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99415,'Sure, me mule was there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99416,'Your MULE? You\'ve got to be kidding me.','Your MULE? You\'ve got to be kidding me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99417,'OK, I believe you.','OK, I believe you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99418,'I don\'t know why you\'re so intent on questioning me. I just lost my cart and everything I own.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99419,'I WANT to believe you, but you\'re not making it easy for me.','I WANT to believe you, but you\'re not making it easy for me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99420,'Just being thorough. I believe you.','Just being thorough. I believe you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99421,'Wait a minute... are you EXTORTING me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99422,'Yes, I\'m extorting you.','Yes, I\'m extorting you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99423,'Of course not! I believe your story.','Of course not! I believe your story.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99424,'But... I spent every last copper I had on that cart full o\' gear! I mean it! I don\'t have any money to give you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99425,'Your whole story is falling apart, Caelen.','Your whole story is falling apart, Caelen.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99426,'I believe your story.','I believe your story.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99427,'Wait, here, look...$b$b<Caelen removes a pile of receipts from his pockets.>$b$bSee! All the stuff I bought, purchased legitimately from reputable Dalaran arms dealers.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99428,'These look like counterfeit receipts.','These look like counterfeit receipts.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99429,'I see everything is on the up-and-up here. I believe you.','I see everything is on the up-and-up here. I believe you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99430,'Counterfeit receipts? Really?$b$bLet me say this out loud, \'cause I wanna get it straight in my head.$b$bYou\'re saying that I brought a bunch of demonic... SOMETHING... into Dalaran, lit it on fire, hung around while it burned, and then produced a bunch of counterfeit receipts in case anybody asked me questions?$b$bI\'m right about that, right? That\'s correct? That\'s your story?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99431,'Yes, that\'s what I\'m saying.','Yes, that\'s what I\'m saying.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99432,'','Stop fighting, Skyhorn beast!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99433,'Well, when you put it that way, I believe you.','Well, when you put it that way, I believe you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99434,'I\'ve spent the last eleven years huddled shoulder-to-shoulder in a humid, smelly auction house, trying to make a few silver off a crate o\' leather hats. I\'m not some demon-corrupted adventurer... I\'ve never even SEEN a demon. Hell, I can\'t even wield half the gear I sell.$b$b<Caelen looks at you through anguished tears. He is, by all external signs, telling the truth.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99435,'FINE. I believe you.','FINE. I believe you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99436,'','You will soon be a roc!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99437,'','You\'re mine, eagle!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99438,'Thanks!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99439,'Now, what do you know about this powder?','Now, what do you know about this powder?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99440,'That wasn\'t in my crates. I always do a thorough investigation of everything I buy, and I woulda\' noticed some glowy green stuff.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99441,'That wasn\'t in my crates. I always do a thorough investigation of everything I buy, and I woulda\' noticed some glowy green stuff. Reminds me of enchanting dust. You should talk to the enchanters.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99442,'Helya\'s massive presence looms in the distance from the platform. \n\nThis altar appears to be a means to communicate with her.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99443,'I do not belong here! I wish to leave Helheim!','I do not belong here! I wish to leave Helheim!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99444,'She was a fine cart, she was.$b$b<Caelen wipes a tear into his beard.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99445,'Do you know why your cart exploded into fel flames?','Do you know why your cart exploded into fel flames?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99447,'Powder\'s not really my thing, kid. I\'m more of an \"inks and scrolls\" kind of guy.$b$bNow, let\'s think this through logically:$b$bThis powder of yours... is it an INK?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99448,'Is it a SCROLL?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99449,'Are you wasting my time?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99450,'Can I ask you a few questions about this powder?','Can I ask you a few questions about this powder?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99451,'Bring that powder to Enchanter Nalthanis. Maybe he\'ll know what to do with it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99452,'No.','No.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99453,'...no.','...no.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99454,'Goodbye, professor.','Goodbye, professor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99455,'','Our battle against the harpies is ongoing, but your actions have helped restore some balance to the basin.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(99456,'Let me know when you are ready, champion.','',0,0,0,0,0,0,0,0,0,0,58371,0,26124),
(99458,'We\'re in luck, warbrave. The champion you seek should be here shortly.','',0,0,0,0,0,0,1,0,0,0,54869,0,26124),
(99459,'Come champion. Journey with me and I shall show you the might of Highmountain.','',0,0,0,0,0,0,1,0,0,0,62093,0,26124),
(99460,'$p, the warbrave has good intentions - I think. Quickly, now, after him - his people are your best chance at an ally on that mountain.','',0,0,0,0,0,0,1,0,0,0,54870,0,26124),
(99461,'Meet me in the cave below, $n. They\'ll want to see the corpse of the harpy you slew.','',0,0,0,0,0,0,0,0,0,0,54768,0,26124),
(99462,'These things... I must warn the others.','These things... I must warn the others.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(99463,'Let me see... it smells like demon fire, it has the color of demonic corruption, and it appeared in my shop only moments after screams and explosions rocked the streets of Dalaran.$b$bAre you trying to kill me, $c?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99464,'Let me rephrase:$b$bIs this dust in any way related to the SMOLDERING BODY that is still lying on my shop\'s doorstep?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99465,'Get it out of here, then! I\'m dead enough as it is.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99466,'Get it out of here, then! Bring it to the enchanters\' shop. They know more about dusts than I do.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99467,'I\'m not trying to kill you.','I\'m not trying to kill you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99468,'Yes.','Yes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99469,'What can you tell me about this powder?','What can you tell me about this powder?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99470,'Today just might be our lucky day, $n.','',0,0,0,0,0,0,1,0,0,0,73008,0,26124),
(99471,'I\'ve made contact with Malfurion Stormrage in Val\'Sharah. His men have already nearly completed their mission there - they just want some backup, just in case.','',0,0,0,0,0,0,1,0,0,0,73010,0,26124),
(99472,'What\'re you waiting for? It isn\'t often we\'re handed victory on a silver platter like this. Relish every moment of it!','',0,0,0,0,0,0,1,0,0,0,73009,0,26124),
(99473,'We still tell the legends of when Highmountain stood against the tide of the Burning Legion many ages ago.$b$bIt will be an honor to stand against them again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99474,'Lead me to your High Chieftain.','Lead me to your High Chieftain.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99475,'You want my hammer? COME DIG FOR IT!','',0,0,0,0,0,0,0,0,0,0,54321,0,26124),
(99476,'They crunches!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99477,'Squish! Ah he he he!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99478,'Splatted under me feet!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99479,'Now where is $n? They always show up right when we - ah, there you are!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(99480,'Good luck to the both of you. You\'ll need it.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(99481,'I shouldn\'t have wandered off.','I shouldn\'t have wandered off.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99482,'Let\'s get a move on. The Dark Lady\'s fleet is nearly ready to leave.','',0,0,0,0,0,0,1,0,0,0,57560,0,26124),
(99483,'','Follow me, $n. The Skyfire is just about ready to leave.',0,0,0,0,0,0,1,0,0,0,0,57559,26124),
(99484,'$n is here to meet with Torok. $GHe:She; slew the Witch of the Wood.','',0,0,0,0,0,0,0,0,0,0,54763,0,26124),
(99485,'A challenger? Let\'s see what this one is capable of!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99486,'Repurposing','Repurposing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(99487,'','Experimentation yields wondrous things! Attack minions!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99488,'I watch over the valley and keep track of harpy activity... but they knew. They attacked here first so I would not see their main attack and warn the village. My wife and  I lived peacefully on this summit, but they injured me and took her life. I fear they will strike again for my son and I will not be able to protect him.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99489,'I think I hear them coming!','I think I hear them coming!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99490,'Keep those hands where I can see them, $r.','Keep those hands where I can see them, $r.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99491,'Hey! Hands off!','Hey! Hands off!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99492,'Not on my watch, scum.','Not on my watch, scum.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99493,'Back away and nobody gets hurt, $c.','Back away and nobody gets hurt, $c.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99494,'More souls! Come and accept your fate!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99495,'','Your young will be a tasty snack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99496,'Thank you for saving my son. I am forever indebted to you.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(99499,'Removing all of the annoying humans wasn\'t particularly difficult, but these demons...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99500,'What? Can\'t you see I\'m busy! These demons won\'t just kill themselves!$B$BSomeone has to find out how to get rid of them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99501,'As much as I love money, ain\'t no way I\'m sellin\' to demons!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(99502,'Ok I am here. I know this probably isn\'t what you\'d call opportune time, but hey - some of my wares can help stick it to these demons!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(99503,'','I... I did it! I am the greatest warlock that ever lived!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99504,'I will go ahead and secure the elevators.','',0,0,0,0,0,0,1,0,0,0,57292,0,26124),
(99505,'I sense demons nearby. After all that time in stasis, I am ready to hunt.','',0,0,0,0,0,0,1,0,0,0,57344,0,26124),
(99506,'','My blades are ready, $n. I will check on the situation ahead.',0,0,0,0,0,0,1,0,0,0,0,57293,26124),
(99507,'If those spires give you trouble, take out the stabilizers.','',0,0,0,0,0,0,0,0,0,0,55231,0,26124),
(99508,'','Gul\'dan could never access this chamber. One of my Wardens has betrayed me!',0,0,0,0,0,0,603,0,0,0,0,57308,26124),
(99509,'I, too, have felt betrayal by my own kind.','',0,0,0,0,0,0,1,0,0,0,57369,0,26124),
(99510,'%s looks over at Altruis the Sufferer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99511,'','Cordana! You will answer to the High Council for this.',0,0,0,0,0,0,0,0,6,0,0,57370,26124),
(99512,'Soon. The body is cold, but his soul is not done fighting. We have work to do before he is ready.','',0,0,0,0,0,0,0,0,6,0,57371,0,26124),
(99516,'We have defeated your champion. Now, release us from Helheim!','We have defeated your champion. Now, release us from Helheim!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99517,'Illidan Stormrage. At last, I meet the great Betrayer.','',0,0,0,0,0,0,0,0,6,0,57372,0,26124),
(99518,'','Thank you, $n. I would\'ve been dead fel meat without you. He must have been attracted to the magic at this site.',2,0,0,0,0,0,0,0,0,0,0,0,26124),
(99519,'','My first hunt on my own! I\'ve been tracking a beast all the way from the other side of Val\'sharah... The destruction he leaves in his wake is astounding! All signs point here. Will you help me track him down?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(99520,'Sure.','Sure.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99521,'','Alright. The tracks lead this way, up to the statue. Follow me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99522,'Just like old times, eh Kayn?','',0,0,0,0,0,0,0,0,0,0,57329,0,26124),
(99523,'','Look at this! The bite marks on this meat are nothing like I\'ve ever seen! Wait... why are they glowing green?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99524,'Do not speak to me of old times, Altruis. You betrayed Illidan. You betrayed us all!','',0,0,0,0,0,0,0,0,0,0,57345,0,26124),
(99525,'After ten-thousand years of imprisonment, Illidan succumbed to the fel energy within. When he was freed, he was not in his right mind.','',0,0,0,0,0,0,0,0,0,0,57284,0,26124),
(99526,'He was fighting it, as we all do. He needed us to have faith in him, Altruis.','',0,0,0,0,0,0,0,0,0,0,57325,0,26124),
(99527,'You followed Illidan blindly, like a dog. Even when he lost his way.','',0,0,0,0,0,0,0,0,0,0,57326,0,26124),
(99528,'He made the hard choices. He sacrificed EVERYTHING. What did you give?','',0,0,0,0,0,0,0,0,0,0,57321,0,26124),
(99529,'','A demon?! I\'m not that kind of hunter! I\'M NOT THAT KIND OF HUNTER!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99530,'You heard the Warden. We are the only ones who can defeat the Legion. We MUST survive this place.','',0,0,0,0,0,0,0,0,0,0,57322,0,26124),
(99531,'','This is sheer madness! The Wardens have lost control of their prison.',0,0,0,0,0,0,603,0,0,0,0,57323,26124),
(99532,'','Aside from us, the most powerful prisoners were sealed on this level. WERE being the operative word.',0,0,0,0,0,0,0,0,0,0,0,57324,26124),
(99533,'','I\'ll place these bracers into our improvised forge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99534,'','Now, add a little leyflame, and...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99535,'','Voila! It works!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99536,'Simply brilliant, Ildine! How much obliterum did we get?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99537,'','About two grains. Two grains of obliterum.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99538,'Well, it\'s a start.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99539,'','I cannot recommend this, Khadgar. Our knowledge of demonic forces is limited. We risk attracting the attention of the Legion, or worse.',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(99540,'I agree. Our artisans lack the skills to build such a forge. The dangers of toying with demonic powers are simply too great.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(99541,'I agree. You of all people should know that dealing with this type of power carries great danger, demon hunter. I cannot allow it in my city.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(99542,'I\'m sorry, but your request has been den--','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(99543,'Actually, Khadgar, I believe I may know someone that can build this forge. An expert.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(99544,'Really? Who?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(99545,'Perhaps better you didn\'t know, sir.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(99546,'How mysterious. Very well! Archmage Karlain will assist you, $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(99548,'The gargoyles lift off from their pressure plates and the portcullis slams shut!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(99549,'','Stop this foolish bickering. We do not have time for this!',0,0,0,0,0,0,603,0,0,0,0,57295,26124),
(99550,'Lord Illidan taught us to fight and to persevere. Together, we destroyed countless demons. YOU chose the coward\'s path.','',0,0,0,0,0,0,0,0,0,0,57296,0,26124),
(99551,'I could only trust my own sight, brother. Lord Illidan was becoming no better than our enemy.','',0,0,0,0,0,0,0,0,0,0,57346,0,26124),
(99552,'You killed our own people! You spit in the face of our sacrifices!','',0,0,0,0,0,0,0,0,0,0,57347,0,26124),
(99553,'We\'ve discovered an exciting new way to extract demonic essence from our crafted armor, but to do so, we need your permission to build a forge.','We\'ve discovered an exciting new way to extract demonic essence from our crafted armor, but to do so, we need your permission to build a forge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99554,'Enough! My colossal infernal will crush you.','',0,0,0,0,0,0,0,0,0,0,55224,0,26124),
(99555,'I did not summon you for nothing. Destroy them!','',0,0,0,0,0,0,0,0,0,0,55225,0,26124),
(99556,'I\'m gonna charge right over you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99557,'Your experience doesn\'t match mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99558,'You think you can match the strength of my fists?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99559,'You should wear a helmet when you fight me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99560,'Okay stop! STOP! Watch the jaw! You win! I\'ve never seen such speed before. You\'re a good kid, mac. Keep it up. I\'ll be back for my belt some day.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99561,'Might of the Legion? Hah! We\'ll see about that...','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(99562,'Let this be a lesson to all who invade OUR lands!','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(99563,'Hold the line! These treacherous creatures know NOTHING of war!','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(99564,'Sylvanas has instructed me to take ALL of your heads! And I WILL deliver.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(99565,'The only blood drawn on this day will be the blood of the Legion!','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(99566,'I\'m the heavyweight champion of Highmountain! You think you can take me on, kid? It\'ll be a punch out! Show me what you\'re worth... but when I knock you down DON\'T GET UP!','',15,0,0,0,0,0,0,0,0,0,0,0,26124),
(99567,'I\'m ready!','I\'m ready!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99568,'Things are not what they seem, $n. I suggest keeping a close eye on those around you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99569,'Hail champion.$b$bI was sent by the High Chieftain Ulan to find you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99570,'He went easy on you, outsider. Come, speak.','',0,0,0,0,0,0,1,0,0,0,54820,0,26124),
(99571,'Something about this doesn\'t seem right.','',0,0,0,0,0,0,0,0,0,0,54769,0,26124),
(99572,'I\'ve got a bad feeling about this.','',0,0,0,0,0,0,0,0,0,0,54770,0,26124),
(99573,'','Well that was terrifying. Thanks for helping, $p. Maybe I should find a demon hunter partner...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99574,'','Beware, $n. There is a dreadlord inside that Soul Engine.',0,0,0,0,0,0,0,0,0,0,0,55304,26124),
(99575,'Oh good, another soul for my engine.','',0,0,0,0,0,0,0,0,0,0,55086,0,26124),
(99576,'Tyranna... help.','',0,0,0,0,0,0,0,0,0,0,55087,0,26124),
(99577,'The portals are down! Their frontline has been crushed! Hold your defenses!','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(99578,'','At least your soul will now power my engine.',0,0,0,0,0,0,0,0,0,0,0,55063,26124),
(99579,'Signal the bat riders!','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(99580,'','You have my thanks, outsider.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(99581,'','I return to battle!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(99582,'','These wretches will know the wrath of the Valkyra!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(99583,'','You have saved me from an unimaginable fate. Thank you.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(99584,'','We will show Helya no quarter!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(99585,'','Uriah! I\'m here! Where are you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99586,'','Oh Uriah, you\'re injured!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99587,'','$n, we must do something to save him!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99588,'By this hammer, I claim this mountain!','',0,0,0,0,0,0,0,0,4,0,54873,0,26124),
(99589,'The curse is lifted! Finally I will battle in the Halls of Valor!','',378,0,0,0,0,0,0,0,0,0,0,0,26124),
(99590,'My soul belongs to Odyn.','',378,0,0,0,0,0,0,0,0,0,0,0,26124),
(99591,'I will never be a kvaldir!','',391,0,0,0,0,0,0,0,0,0,0,0,26124),
(99592,'Odyn smiles upon us.','',378,0,0,0,0,0,0,0,0,0,0,0,26124),
(99593,'Helya was a fool to think she could hold me.','',378,0,0,0,0,0,0,0,0,0,0,0,26124),
(99594,'To the Halls of Valor!','',15,0,0,0,0,0,0,0,0,0,0,0,26124),
(99595,'Dargrul the Underking! Come down here and face justice for those you have betrayed.','',0,0,0,0,0,0,22,0,0,0,62087,0,26124),
(99596,'Welcome, champion, to Thunder Totem. In better days we would have warriors from the Bloodtotem tribe or eagle riders from the Skyhorn tribe. Today, we are so few we could barely keep a kobold out.','',1,1,0,0,500,0,0,0,0,0,54290,0,26124),
(99597,'You bring this back in one piece, ok? Go get \'em!','You bring this back in one piece, ok? Go get \'em!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99598,'The ram on this one\'s supercharged. My handiwork! Bag a few demons for me!','The ram on this one\'s supercharged. My handiwork! Bag a few demons for me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99599,'Just a few tons of Gnomeregan\'s finest anti-Demon engineering! Put it to good use.','Just a few tons of Gnomeregan\'s finest anti-Demon engineering! Put it to good use.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99600,'I guess that isn\'t so bad...','I guess that isn\'t so bad...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(99601,'What must we give in return?','What must we give in return?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(99602,'Everything!','Everything!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(99603,'Loaded with munitions and ready to hit \'em hard. Fly safe!','Loaded with munitions and ready to hit \'em hard. Fly safe!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99604,'Death from above is the best kind, wouldn\'t you agree? Give \'em hell!','Death from above is the best kind, wouldn\'t you agree? Give \'em hell!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99605,'Be... careful... this is a... trap...','',0,0,0,0,0,0,0,0,0,0,54776,0,26124),
(99606,'Let\'s kick the tires and light the fires!','Let\'s kick the tires and light the fires!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99607,'Guuuaaaahhh!','',0,0,0,0,0,0,0,0,0,0,54771,0,26124),
(99608,'Please, defeat them! I\'ll protect my son!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99609,'Thank you, $p. We are forever indebted to you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99610,'I am beyond saving, Rosalyn. You need to focus on finding the demons that have been released from the soul chambers and trap them once again, before it\'s too late.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99611,'Soulkeeper Uriah takes a slow, pained breath.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99612,'','I have precious little time to waste. Speak or leave.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99613,'','Open the wells and unleash a torrent of souls on him.',0,0,0,0,0,0,0,0,0,0,0,55007,26124),
(99614,'Your soul will be ours.','',0,0,0,0,0,0,0,0,0,0,57001,0,26124),
(99615,'Kill them before they can get up to the Fel Hammer.','',0,0,0,0,0,0,0,0,0,0,57002,0,26124),
(99616,'Defend the Soul Engine.','',0,0,0,0,0,0,0,0,0,0,57003,0,26124),
(99617,'Thank you for the rescue. I will see if any of the other warbraves survived the attack.','',0,0,0,0,0,0,0,0,0,0,54292,0,26124),
(99618,'Ooh! You have little creatures! Let\'s fight, and if I win I get to EAT one!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99619,'Ha ha ha! Now we show them our true power!','',22,0,0,0,0,0,0,1,0,0,0,0,26124),
(99620,'To battle!','',22,0,0,0,0,0,0,1,0,0,0,0,26124),
(99621,'Flummox no need pets! Flummox eats them NOW!','',449,0,0,0,0,0,0,0,0,0,0,0,26124),
(99622,'I\'m still in training, Mac. But I\'m going to win my belt back from you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99623,'This platform will take you into the sacred Hall of Chieftains where Mayla Highmountain awaits you.','',25,1,0,0,0,0,0,0,0,0,54291,0,26124),
(99624,'','But... but I don\'t know how, Uriah. I cannot do it without you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99625,'You can, Rosalyn, and you will. You\'re more gifted than you let yourself believe.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99626,'Soulkeeper Uriah exhales tiredly as the last bit of breath leaves his lifeless body.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99627,'Knead with your fists, not your face!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99628,'Mix \'em up, mix \'em up! C\'mon now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99629,'Winning isn\'t that bad. You should all try it sometime!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99630,'Thanks, I thought I was going to die!','Thanks, I thought I was going to die!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(99631,'There\'s a reason why Taurson is the best! Keep training!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99632,'By the light of Elune, thank you!','By the light of Elune, thank you!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(99633,'We need to defend the temple!','We need to defend the temple!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(99634,'Thank you for saving me!','Thank you for saving me!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(99635,'Three hours in the air is too much. We need more pilots!','Three hours in the air is too much. We need more pilots!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99636,'I always wanted to fly... but not during the end of the world.','I always wanted to fly... but not during the end of the world.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99637,'I\'m exhausted... I don\'t know if I can take another flight today.','I\'m exhausted... I don\'t know if I can take another flight today.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99638,'We\'ve got to stay sharp. Too much is riding on us, and we\'re going back up soon.','We\'ve got to stay sharp. Too much is riding on us, and we\'re going back up soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99639,'We\'re in this together, ok? You\'re doing great up there! We\'re gonna make it.','We\'re in this together, ok? You\'re doing great up there! We\'re gonna make it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99640,'Azeroth depends on us fighting in the skies. Stay strong, for all of us.','Azeroth depends on us fighting in the skies. Stay strong, for all of us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99641,'Go, Champion. I will rally what forces I can to assault the drogbar stronghold to our south. Meet me at the cavern\'s mouth when you are ready.','',0,0,0,0,0,0,1,0,0,36058,0,0,26124),
(99642,'','I can\'t believe he\'s gone...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99643,'The eagle nods his thanks before flying away, free.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99644,'This is a disaster... but we can win this! Keep the tanks rolling. Keep our birds in the air. The world won\'t end without tasting some Gnome ingenuity!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99645,'','Let\'s keep moving. The others are in the chamber just ahead.',0,0,0,0,0,0,1,0,0,0,0,57361,26124),
(99646,'I respect our past, but I cannot forgive Illidan\'s methods. The Illidari deserve a better leader.','',0,0,0,0,0,0,0,0,0,0,57300,0,26124),
(99647,'Then we stand at an impasse. $n, you must resolve this conflict.','',0,0,0,0,0,0,0,0,0,0,57301,0,26124),
(99648,'','<Thalyssra is shaking uncontrollably and can barely speak. |cFFF92304Her hunger must be sated before all else.|r>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99649,'','The Nightwell is a font of incredible power. We must not allow the Legion to make use of it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99650,'','Yes! I can feel the power coursing through me!\n\nI am whole again.',0,0,0,0,0,0,0,0,0,0,0,67379,26124),
(99651,'What\'s this? Helya will surely reward me for this offering.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99652,'Impressive you have made it this far, demon hunters. Now, I will extinguish your souls like a candle\'s flame!','',0,0,0,0,0,0,0,0,0,0,57362,0,26124),
(99653,'We\'ve done it, Illidari! FREEDOM IS OURS!','',396,0,0,0,0,0,603,0,0,0,57363,0,26124),
(99656,'I am Archmage Khadgar, leader of the Kirin Tor.','',396,0,0,0,0,0,1,0,0,0,57302,0,26124),
(99658,'Demon hunters, Azeroth needs your help.','',396,0,0,0,0,0,1,0,0,0,57364,0,26124),
(99659,'Helya is defeated; it is time to call in the val\'kyr!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99660,'Once that witch is defeated I can free the stolen souls of the valejar.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99661,'This one\'s a bit rough on the stick. Be careful goin\' downhill boss.','This one\'s a bit rough on the stick. Be careful goin\' downhill boss.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99662,'Spikes... big rocks... everything looks ok. Smash those Demons good!','Spikes... big rocks... everything looks ok. Smash those Demons good!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99663,'Take the fight to \'em! Demons will burn by Horde might!','Take the fight to \'em! Demons will burn by Horde might!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99664,'You have my thanks, champion.','',0,0,0,0,0,0,0,0,0,0,54286,0,26124),
(99665,'Captains, report!','',0,0,0,0,0,0,0,0,0,0,55253,0,26124),
(99666,'','We\'ve encountered heavy resistance near the Soul Engine.',0,0,0,0,0,0,0,0,0,0,0,55297,26124),
(99667,'','Our assault is underway. I\'ll join in when you attack the overseer.',0,0,0,0,0,0,0,0,0,0,0,55322,26124),
(99668,'Be careful givin\' it gas. The tanks are a bit creaky!','Be careful givin\' it gas. The tanks are a bit creaky!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99669,'... Battlelord, report!','',0,0,0,0,0,0,0,0,0,0,55266,0,26124),
(99670,'Big pile of bombs for ya. Make sure they land on the demons, ok?','Big pile of bombs for ya. Make sure they land on the demons, ok?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99671,'The balloon\'s patched up, but I left a parachute in there just in case! At least, I think I did.','The balloon\'s patched up, but I left a parachute in there just in case! At least, I think I did.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99672,'','We\'ve regained control of Southpoint Gate! I\'m sending ground patrols toward Tarren Mill!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99673,'','Hold your defenses! I\'m headed your way!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99674,'Feed: 100x |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t|Hcurrency:1155|h|cFFFFFFFF Ancient Mana|h|r','Feed: 100x |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t|Hcurrency:1155|h|cFFFFFFFF Ancient Mana|h|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99675,'The Legion has begun its invasion of our world. From sea to shore, brave defenders of the Alliance and Horde are answering the call to arms.\n \nHowever, they will ultimately fail without the aid of the demon hunters. You were uniquely trained as ruthless weapons against the Legion. It is time to go on the offensive.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(99676,'Spend |TINTERFACE\\ICONS\\INV_OFFHAND_PVEALLIANCE_D_01.BLP:20|t|Hitem:129094|h|cFF0070DD Nightwell Ambrosia|r|h to Empower this Nightfallen?','Spend |TINTERFACE\\ICONS\\INV_OFFHAND_PVEALLIANCE_D_01.BLP:20|t|Hitem:129094|h|cFF0070DD Nightwell Ambrosia|r|h to Empower this Nightfallen?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99677,'Feed Ancient Mana |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t x100','Feed Ancient Mana |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t x100',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99678,'Thank you champion. But be careful, the drogbar Underking wields a tool of the titans.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99679,'','My... my village. It is gone.',0,0,0,0,0,0,0,0,0,0,0,54287,26124),
(99680,'In the name of the Dark Lady!','',22,0,0,3,0,0,0,1,0,0,0,0,26124),
(99681,'I want this shan ronir to tell the others. Tell them their doom will come once I master this hammer.','',1,0,0,0,0,0,0,0,0,0,54278,0,26124),
(99682,'Come, rest your weary soul on a feathery bed.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(99683,'Good, you made it! Defeat Helya and I will set these souls free!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99684,'Fishing','Fishing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(99685,'Yer soul belongs to Helya now, worm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99686,'Drown in the choking tides!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99687,'I\'ll hack ye in two!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99688,'Come on, hero! Follow us, and we\'ll help you take down these demons!','Come on, hero! Follow us, and we\'ll help you take down these demons!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99689,'None can escape... Helya\'s grasp...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99690,'Somebody! Anybody! Help!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99691,'I see you in there, Okuna. Did you think you could kill my father and get away with it?','',378,0,0,0,0,0,0,0,0,0,0,0,26124),
(99692,'I too would like to experiment with this pigment. Let\'s see here...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99693,'That went better than expected. Yes, this pigment WILL work out nicely.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99694,'','My husband says I battle too much.  What does he know?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99695,'What, me bein\' all hidden ain\'t enough of a clue that I wanna be left alone?$b$bGet lost, if ya know what\'s good for ya!','',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(99696,'','Bring it on!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99697,'','I\'ve already lost two sisters to the demons. You want to investigate that cart? It\'s all yours.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99698,'','Don\'t tell anyone, ok?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99699,'','Take it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99700,'','Aw, come on!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99701,'','Seriously?!?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99702,'','What the heck is wrong with you?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99703,'','Are you AFK?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99704,'','Maybe use your good pets.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99705,'','Are you even trying?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99706,'We\'ll need permission from the ruling council of Dalaran before we can build a forge big enough to create obliterum en masse.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(99707,'You seem to be on good terms with Khadgar - maybe you should ask him, $n.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(99708,'','I lost the obliterum.',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(99709,'Oh, Vanessa!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(99710,'Yeah? So what do you want? I\'m tryin\' to do business here!','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(99711,'Ildine sent me. Where\'s the shipment you owe her?','Ildine sent me. Where\'s the shipment you owe her?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99712,'Tell Ildine I got a better offer. Now scram, before I have to get rough!','',25,603,0,0,0,0,0,0,0,0,0,0,26124),
(99713,'If you\'re thinking about bribing me, think again. I have a duty to keep these sewers safe!$b$b<Raethan lowers his voice to a whisper:>$b$bCome back in a few minutes and we\'ll talk, $c.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99714,'Yes, I know that people are fighting out there. My guards are simply... taking a break.$b$b<Raethan lowers his voice to a whisper:>$b$bYou want us back on duty? Come back in a few minutes, and bring some Sightless Eyes with you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99715,'Quick tip on bribes, $r: make sure you actually have the money before you make the offer. Now get out of my sight, unless you\'re looking for a room in Violet Hold!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(99716,'<Threaten Belamy.>','<Threaten Belamy.>',505,0,0,0,0,0,0,0,0,0,0,0,26124),
(99717,'Okay, okay! You called my bluff. I\'ll tell you what you want to know, tough $Gguy:gal;.$b$bI sold the enchanting supplies to a fence up in Dalaran. Grimbore, Boargrim... somethin\' orcish like that.$b$bNow beat it, will ya? I\'ve got a customer on the way.','',11,603,0,0,0,0,0,0,0,0,0,0,26124),
(99718,'I\'ll inform Ildine that you tried to cheat her.','I\'ll inform Ildine that you tried to cheat her.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99719,'I want a word with you, Belamy.','I want a word with you, Belamy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99720,'I\'ve had enough. I\'m moving back to Moa\'ki Harbor the first chance I get.','',1,0,0,2,0,0,0,0,0,0,0,0,26124),
(99721,'My underking, this one still lives.','',0,0,0,0,0,0,0,0,0,0,54277,0,26124),
(99722,'Here are the cards you wanted.','Here are the cards you wanted.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99723,'THEY THREW AWAY A... errr... I mean, let\'s see what I can do with these.','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(99724,'This fish pigment really is something. I should start selling it...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99725,'And for the final touch, just a bit of magic and...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99726,'Voila! Finished.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99727,'I told ya what ya wanted to know. Ain\'t that enough?$b$bDon\'t exactly want to draw attention to myself here...','',274,0,0,0,0,0,0,0,0,0,0,0,26124),
(99728,'Empower: 1x |TINTERFACE\\ICONS\\INV_OFFHAND_PVEALLIANCE_D_01.BLP:20|t|Hitem:129094|h|cFF0070DD Nightwell Ambrosia|r|h','Empower: 1x |TINTERFACE\\ICONS\\INV_OFFHAND_PVEALLIANCE_D_01.BLP:20|t|Hitem:129094|h|cFF0070DD Nightwell Ambrosia|r|h',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99729,'The Battlelord sent me.','',0,0,0,0,0,0,0,0,0,36089,55035,0,26124),
(99730,'The Battlelord sent me.','',0,0,0,0,0,0,0,0,0,36090,55036,0,26124),
(99731,'We will destroy the Burning Legion.','',0,0,0,0,0,0,0,0,0,36090,55037,0,26124),
(99732,'It is an honor to kill in Lord Illidan\'s name.','',0,0,0,0,0,0,0,0,0,36090,55038,0,26124),
(99733,'Lord Illidan commands and I follow.','',0,0,0,0,0,0,0,0,0,36090,55039,0,26124),
(99734,'This demon will fall.','',0,0,0,0,0,0,0,0,0,36090,55040,0,26124),
(99735,'I am here to assist you.','',0,0,0,0,0,0,0,0,0,36090,55041,0,26124),
(99736,'The Ashtongue serve.','',0,0,0,0,0,0,0,0,0,36090,55042,0,26124),
(99737,'The Legion must be stopped.','',0,0,0,0,0,0,0,0,0,36090,55043,0,26124),
(99738,'','Lady S\'theno requested I join you.',0,0,0,0,0,0,0,0,0,36885,0,55077,26124),
(99739,'','Lady S\'theno requested I join you.',0,0,0,0,0,0,0,0,0,36883,0,55078,26124),
(99740,'','The Burning Legion will be destroyed.',0,0,0,0,0,0,0,0,0,36883,0,55079,26124),
(99741,'','Legion magic is nothing compared to that of the naga.',0,0,0,0,0,0,0,0,0,36883,0,55080,26124),
(99742,'','Lord Illidan leads and the Coilskar follow.',0,0,0,0,0,0,0,0,0,36883,0,55081,26124),
(99743,'','This demon will die.',0,0,0,0,0,0,0,0,0,36883,0,55082,26124),
(99744,'','I have come to your aid.',0,0,0,0,0,0,0,0,0,36883,0,55083,26124),
(99745,'','The Coilskar honor their allegiance.',0,0,0,0,0,0,0,0,0,36883,0,55084,26124),
(99746,'','The Legion must be stopped before they burn our world.',0,0,0,0,0,0,0,0,0,36883,0,55085,26124),
(99747,'','The Matron Mother bid me come to help.',0,0,0,0,0,0,0,0,0,36886,0,55355,26124),
(99748,'','The Matron Mother bid me come to help.',0,0,0,0,0,0,0,0,0,36884,0,55359,26124),
(99749,'','We will help you destroy the Legion.',0,0,0,0,0,0,0,0,0,36884,0,55353,26124),
(99750,'','I serve Illidan.',0,0,0,0,0,0,0,0,0,36884,0,55356,26124),
(99751,'','Lord Illidan commands and I follow.',0,0,0,0,0,0,0,0,0,36884,0,55358,26124),
(99752,'','This demon will die from a thousand cuts.',0,0,0,0,0,0,0,0,0,36884,0,55354,26124),
(99753,'','I am here to maim and kill.',0,0,0,0,0,0,0,0,0,36884,0,55361,26124),
(99754,'','The Shivarra serve.',0,0,0,0,0,0,0,0,0,36884,0,55360,26124),
(99755,'','The Legion\'s march across the stars will be stopped.',0,0,0,0,0,0,0,0,0,36884,0,55357,26124),
(99756,'Kayn, tell me what you know about Mardum.','Kayn, tell me what you know about Mardum.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99757,'If this doesn\'t end soon we\'re gonna need more supplies.','If this doesn\'t end soon we\'re gonna need more supplies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99758,'C\'mon then. Yer not goin\' out like this!','C\'mon then. Yer not goin\' out like this!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(99759,'You\'ll be back on yer feet in no time.','You\'ll be back on yer feet in no time.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(99760,'On the bright side - ye might get promoted after a heroic act like that!','On the bright side - ye might get promoted after a heroic act like that!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(99761,'I sold the enchanting supplies to a fence up in Dalaran. Grimbore, Boargrim... somethin\' orcish like that.$b$bNow beat it, will ya? I got a customer on the way.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(99762,'Your souls shall suffer!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99763,'The Legion conquers all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99764,'Worthless species!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99765,'You will burn!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99766,'Your world is at an end, mortals!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99767,'Ah, $n, it\'s good to see you again. Now that we are all gathered, let\'s begin.','',0,0,0,0,0,0,66,0,0,0,62020,0,26124),
(99768,'Bow before the might of Sargeras.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99769,'The outcome of this world has been decided!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99770,'Puny mortals. I\'ll deal with you myself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99771,'Yer not welcome here!','Yer not welcome here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99772,'I\'ll show ya who yer messin\' with!','I\'ll show ya who yer messin\' with!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99773,'Hold still! This\'ll only hurt a little!','Hold still! This\'ll only hurt a little!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99774,'Today ye find out what yer insides look like!','Today ye find out what yer insides look like!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99775,'You appear to be lost, friend.','You appear to be lost, friend.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99776,'By the Jade Serpent! What was that?!','',0,0,0,0,0,0,0,0,0,0,62034,0,26124),
(99777,'Yer messin\' with the wrong dwarf.','Yer messin\' with the wrong dwarf.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99778,'Today is not yer day!','Today is not yer day!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99779,'And to think I used to be afraid of Ildine back in our Ravenholdt days! She\'s gone soft!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99780,'Make yourself at home, and may the wind roll with you.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(99781,'Ready up! He\'s comin\' down!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(99782,'This is what we\'ve been trainin\' for!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(99783,'I\'ve got this one, shaman. Help the others!','',0,0,0,0,0,0,0,0,0,0,60552,0,26124),
(99784,'Training seems to have paid off! Well done!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(99785,'Whoever is meddling here shall be dealt with shortly!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99786,'Your soul belongs to me now.','',0,0,0,0,0,0,0,0,0,0,53680,0,26124),
(99787,'The service in this place is terrible. TERRIBLE!','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(99788,'I\'m here for the enchanting supplies Belamy sold you.','I\'m here for the enchanting supplies Belamy sold you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99789,'I got those supplies fair an\' square! I\'m an honest businessman trying to make a living!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(99790,'You\'re dealing in stolen goods. Hand them over!','You\'re dealing in stolen goods. Hand them over!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99791,'','Ah... the fog has lifted, just a bit...',0,0,0,0,0,0,0,0,0,0,0,67409,26124),
(99792,'','Thank you, I was... losing control.',0,0,0,0,0,0,0,0,0,0,0,67410,26124),
(99793,'','Ugh. I shall never grow accustomed to that.',0,0,0,0,0,0,0,0,0,0,0,67411,26124),
(99794,'','Hanging in there, thanks to you...',0,0,0,0,0,0,0,0,0,0,0,67412,26124),
(99795,'','My head... still spinning...',0,0,0,0,0,0,0,0,0,0,0,67413,26124),
(99796,'','Oh, but for a taste of the real thing...',0,0,0,0,0,0,0,0,0,0,0,67414,26124),
(99797,'','Oh, how I\'ve longed for this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99798,'Well timed, champion. We have cleared a path to Dargrul. This way...','',0,0,0,0,0,0,0,0,0,0,54275,0,26124),
(99799,'','At last, I am quenched.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99800,'','Ahh, to be alight with power once again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99801,'','My mind is ablaze. I am restored.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99802,'','I surge with power!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99803,'I\'m here for the enchanting supplies, Bonegrim. Where are...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99804,'','This feeling... flooding back to me... I am alive!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99805,'Listen, I don\'t want any trouble. I\'m just gonna go...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99806,'Not withering today, it seems...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99807,'Phew. I was close... too close.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99808,'A drop in the ocean of my thirst... But appreciated, nonetheless.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99809,'Blech. How did we live before the Nightwell?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99810,'Eurrghh... Still woozy...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99811,'Still here... for now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99812,'Oh, it burns going down. In a good way!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99813,'My strength returns!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99814,'$ct, I\'m proud to report that my mission was easily accomplished.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99815,'Ah, it is good to be in touch with my better half once again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99816,'Like a breath of air! Thank you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99817,'This power... Had I ever truly tasted this before?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99818,'Nooo! My profits! I was gonna buy myself a boat...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99819,'Station Highlord Darion Mograine.','Station Highlord Darion Mograine.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99820,'Station Thassarian.','Station Thassarian.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99821,'Station Koltira Deathweaver.','Station Koltira Deathweaver.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99822,'We\'ll stay here and make sure nothing more can be taken from the crater. Stay on the offensive!','We\'ll stay here and make sure nothing more can be taken from the crater. Stay on the offensive!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99823,'So much energy... We\'ve got to stay here and ensure the Demons can take no more from this crater. Keep up the fight!','So much energy... We\'ve got to stay here and ensure the Demons can take no more from this crater. Keep up the fight!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99824,'|TInterface\\Icons\\spell_frost_summonwaterelemental:20|t%s begins to cast |cFFFF0000|Hspell:193051|h[Call the Seas]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(99825,'Push them back! Don\'t let them take yer brothers and sisters!','',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(99826,'','$n! You and your demon hunters are nothing.',0,0,0,0,0,0,0,0,0,0,0,55064,26124),
(99827,'','The keystone was entrusted to me by Sargeras himself. You will not have it!',0,0,0,0,0,0,0,0,0,0,0,55065,26124),
(99828,'The mists are having an ill effect on my crew. They have become wild and uncontrollable. They care not for the sea and prefer to bicker and brawl with each other.$B$BKjell, the harbor master, has ordered us to depart for fresh supplies as soon as we are able. I have assigned extra duties in hopes that the work will occupy their time until we ship out.$B$BI can only hope that the sea air will calm my crew and return their vigor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99829,'','Hurry. Kayn has already launched the attack on Tyranna.',0,0,0,0,0,0,5,0,0,0,0,55095,26124),
(99830,'We have accomplished the impossible. I must admit, I had my doubts about your leadership, $n. But no more.\n\nLet\'s get back and put an end to the attack on the Black Temple. Lord Illidan awaits.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(99831,'','Your foul magic is in vain, monster! These writings are under my protection.',0,0,0,0,0,0,0,0,0,0,0,61971,26124),
(99832,'','Away with you, monster!',0,0,0,0,0,0,0,0,0,0,0,61972,26124),
(99833,'','Give up! You only strike at the wind!',0,0,0,0,0,0,0,0,0,0,0,61973,26124),
(99834,'Maybe it\'s best that I stay here in the foothold. I still haven\'t recovered from my wounds when I was held prisoner down below.\n\nThis world is overflowing with demonic energy. It\'s making it harder for me to contain my own fel power.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(99835,'Make the Illidari Foothold your home.','Make the Illidari Foothold your home.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99836,'$n, you made it through!','',0,0,0,0,0,0,0,0,0,0,55054,0,26124),
(99837,'','Good luck to all of you. I will get the rest of us up there, $n.',0,0,0,0,0,0,0,0,0,0,0,55228,26124),
(99838,'','Thank you, friend! My students died to protect these scrolls. Centuries of history could have been lost!',0,0,0,0,0,0,0,0,0,0,0,61975,26124),
(99839,'','A curse has fallen upon our harbor.$B$BGulls drop like stones from the sky. I saw one fall on a deck hand\'s head the other day. It knocked him out cold.$B$BSchools of fish rot belly-up in the shoals. Our fishermen have not had a decent catch in weeks and the stench of dead fish is horrible.$B$BI have taken on extra shifts in the tower, as most of my watchmen have gone missing. I take respite up here, as the foul odor and stale air are not as stifling.$B$BThe harbor is dead. The mists have choked the very life from it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99840,'<There is a note attached to a supply requisition.>$B$BHarbor Master Kjell,$B$BI do not know what foul bane these mists carry, but barely a day after they engulfed the harbor, our entire stock of provisions spoiled. We need to resupply our stock immediately.$B$BDispatch Captain Sten on a supply run as soon as he is able, assuming he can stop his crew from bickering long enough to set sail.$B$BIn the meantime, we will all have to tighten our belts and stretch what little we have left. Since most of the town has gone missing, this shouldn\'t be too difficult.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99841,'<Most of the roster entries are blank. There is a sloppily written note on the corner of one of the drafts.>$B$BDamn these mists to Helheim! Not long after they arrived, many of my craftsmen have vanished, and the few that remain have not the sense in their head to work. They act as if they had run headlong into the mast.$B$BHow am I supposed to get Sten\'s ship ready to sail with a sparse bunch of loons at my disposal?$B$BI will do what I can to get the ship seaworthy, alone if I must, but I need good men to fill my work roster.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99843,'You\'re in danger here. Grand Master Hight needs everyone to gather at the Shrine of the Ox.','You\'re in danger here. Grand Master Hight needs everyone to gather at the Shrine of the Ox.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99844,'','When Dargrul stole the Hammer of Khaz\'goroth he did so right in front of myself and the other chieftains.',0,0,0,0,0,0,0,0,0,0,0,54280,26124),
(99845,'','Our last High Chieftain, Ulan, tried to stop him and was slain. Mayla may have picked up her father\'s totem, but she is not High Chieftain yet.',0,0,0,0,0,0,0,0,0,0,0,54281,26124),
(99846,'','Dargrul didn\'t just steal a hammer, he shattered our people, driving a wedge between our tribes.',0,0,0,0,0,0,0,0,0,0,0,54282,26124),
(99847,'','Chen Stormstout was teaching a class of youngsters when the attack began. He\'s one of the strongest monks I know, but even he won\'t be able to hold out forever. Come, we must rescue them!',0,0,0,0,0,0,0,0,0,0,0,61976,26124),
(99848,'This fel circle is similar to the ones used in Skovald\'s attempts to enslave the Thorignir dragons of Thorim\'s Peak. $B$BIt appears to be too powerful to break by normal means.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99849,'','The time for ascension is upon you. Prepare yourselves; Odyn awaits your arrival.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99850,'Use the Jailer\'s Shard to break Vethir\'s prison.','Use the Jailer\'s Shard to break Vethir\'s prison.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99851,'We are almost to the exit, $n. Our freedom is near.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99852,'These beasts are quite feisty, unless you know how to deal with them. This one should listen to your commands... for a little while, at least.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99854,'You\'ve already ruined my business. Can\'t you just leave me alone?','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(99855,'','For years we were shunned, banished to the darkest depths of the world by the Wardens. \n\nNow, we must rise to the hardest challenge our world has ever faced. Now, we must defend Azeroth against its greatest enemies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99856,'Fine, $r, I\'ll send the supplies to the enchanting shop. Now leave me to drink in peace!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(99857,'','It was difficult, but I\'ve managed to gather some weapons and supplies. What do you need?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99858,'I will temper my differences for now. The enemy is nearly at our doorstep, and we will be more effective united as one.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(99859,'Your world is the last standing. It, too, will be purged.','',0,0,0,0,0,0,0,0,0,0,57298,0,26124),
(99860,'I have watched many of your kind walk the path of life, but none have carried themselves with a stride such as yours.$B$BI look forward to telling your story.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99861,'We are but the beginning of the tide.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99862,'Your doom awaits.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99863,'Prepare for your own demise!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99864,'I am the avatar of your destruction!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99865,'Resistance only delays the inevitable!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99866,'Your world will crumble into ashes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99867,'[Placeholder Event] - Anduin welcomes you to the Alliance.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(99868,'[Placeholder Event] - Sylvanas welcomes you to the Horde.','[Placeholder Event] - Sylvanas welcomes you to the Horde.',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(99869,'Ah, Darahir, my friend! Come have a drink!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99870,'Don\'t let this $c scare you away, Darahir! Wait... come back!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99871,'DIE!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99872,'Grand Master Hight... <gasp> Grand Master Hight! A giant... THING appeared in the sky!','',0,0,0,0,0,0,0,0,0,0,62013,0,26124),
(99873,'|TInterface\\Icons\\INV_Spear_07:20|t%s targets you with an |cFFFF0000|Hspell:191977|h[Impaling Spear]|h|r! Get behind someone!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(99874,'Look what the ravens have dropped off.','',0,0,0,0,0,0,0,0,0,0,78680,0,26124),
(99875,'GAHHH!! Keep going, $n. Activate the second pool.','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(99876,'It\'s... trying to break free! Hurry, $n, activate the final pool!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(99877,'','|TInterface\\Icons\\INV_Enchant_EssenceArcaneSmall:20|t%s targets |cFFFF0000$n|r with a massive |cFFFF0000|Hspell:192708|h[Arcane Bomb]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(99878,'Demons are appearing everywh--','',0,0,0,0,0,0,0,0,0,0,62024,0,26124),
(99879,'You walk among the spirits of an ancient land, $r.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(99880,'It is done. The demon is once again within my control.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(99887,'|TInterface\\Icons\\Spell_Shadow_ShadeTrueSight:20|t%s begins to release a |cFFFF0000|Hspell:197969|h[Roaring Cacophony]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(99889,'','|TInterface\\Icons\\ability_shawaterelemental_swirl:20|t|cFFFF0000|Hspell:192696|h[Raging Storms]|h|r begin while no enemies are in melee range!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(99890,'Ah, we meet again, weakling. Now it\'s just you and me... and my guards!','',0,0,0,0,0,0,0,0,0,0,54181,0,26124),
(99891,'Sssssth! Hatecoil, crush their bodies!','',0,0,0,0,0,0,0,0,0,0,54190,0,26124),
(99892,'Hatecoil, drown them out!','',0,0,0,0,0,0,0,0,0,0,54191,0,26124),
(99893,'Fools! Get out of the way!','',0,0,0,0,0,0,0,0,0,0,54183,0,26124),
(99894,'You can\'t stop.... the storm...','',0,0,0,0,0,0,0,0,0,0,54182,0,26124),
(99895,'Useless. All of you!','',0,0,0,0,0,0,0,0,0,0,54184,0,26124),
(99896,'Like fish in a net.','',0,0,0,0,0,0,0,0,0,0,54187,0,26124),
(99897,'That was for Athissa.','',0,0,0,0,0,0,0,0,0,0,54188,0,26124),
(99898,'Ha, nowhere to hide!','',0,0,0,0,0,0,0,0,0,0,54185,0,26124),
(99899,'Get my point?','',0,0,0,0,0,0,0,0,0,0,54186,0,26124),
(99900,'I must retrieve an artifact from Tideskorn Harbor.','I must retrieve an artifact from Tideskorn Harbor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99901,'','No good! We don\'t have time to fight our way through that horde!',0,0,0,0,0,0,0,0,0,0,0,61977,26124),
(99903,'What is it you seek, $c?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99904,'I\'m ready to begin the ritual.','I\'m ready to begin the ritual.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99905,'The Swamprock murlocs\' favorite thing to do is cause shipwrecks with their makeshift lighthouse. Murlocs are fascinating, but these are ruthless.\n\nWe must save this coast! I have been raising this young murloc, Murky. We need to help him become stronger so he can teach the tadpoles to be better than their elders.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(99906,'Almost had me that time! Try again!','',0,0,0,0,0,0,0,0,0,0,62011,0,26124),
(99907,'Did you think you could hit me with that?','',0,0,0,0,0,0,0,0,0,0,62022,0,26124),
(99910,'Hey! Over here!','',0,0,0,0,0,0,0,0,0,0,62027,0,26124),
(99913,'Run, children! I\'ll protect you from this monster!','',0,0,0,0,0,0,0,0,0,0,62028,0,26124),
(99919,'','Try not to be so conspicuous. Much more can be learned by observing than by engaging your enemy in combat.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99922,'\"Go here, Nicholo.\"$b$b\"Fetch me that, Nicholo.\"$b$bOne day I\'ll be giving the orders, I tell ya.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99924,'I\'m ready when you are, Nicholo.','I\'m ready when you are, Nicholo.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99925,'Stay alert, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99926,'Just be ready in case anything happens, $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(99927,'Whew, this is a lot harder than it looks.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(99928,'This is looking pretty good so far. Don\'t stop now, $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(99929,'I\'m almost finished, I swear.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(99930,'Captain Bladewind! A warrior is attacking us!','',0,0,0,0,0,0,22,0,0,0,60364,0,26124),
(99931,'To arms! Avenge me!','',0,0,0,0,0,0,0,0,0,0,60383,0,26124),
(99932,'Yo, champ! We\'ve been researchin\' and cataloguin\' day and night to make sure every bozo in this joint knows all there is to know about the one and only Grand Assassin $n.$B$BThere\'s only one of you, right?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99937,'Aaaaah!','',0,0,0,0,0,0,0,0,0,0,54276,0,26124),
(99939,'Success! We did it, $n!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(99940,'God-King Skovald has been spotted at the top of the gates. \n\nWhen you are ready, we will take the fight to him!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99941,'Take me to the top, Vethir!','Take me to the top, Vethir!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99942,'This may take longer than expected. Salvaging the necessary parts for these is quite difficult!','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(99943,'','ALL WILL BE ERADICATED!',0,0,0,0,0,0,0,0,0,0,0,54205,26124),
(99944,'','WATER... ETERNAL...',0,0,0,0,0,0,0,0,0,0,0,54206,26124),
(99945,'','WASHED AWAY.',0,0,0,0,0,0,0,0,0,0,0,54209,26124),
(99946,'','TORN ASUNDER.',0,0,0,0,0,0,0,0,0,0,0,54210,26124),
(99947,'','CRUSH!',0,0,0,0,0,0,0,0,0,0,0,54213,26124),
(99948,'','DROWN!',0,0,0,0,0,0,0,0,0,0,0,54214,26124),
(99949,'','TEMPEST!',0,0,0,0,0,0,0,0,0,0,0,54208,26124),
(99950,'','THE STORM AWAKENS.',0,0,0,0,0,0,0,0,0,0,0,54212,26124),
(99951,'<The crystal emanates a sinister energy.>','<The crystal emanates a sinister energy.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99952,'<Place the dreamleaf at the foot of the crystal.>','<Place the dreamleaf at the foot of the crystal.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99953,'I\'ll see if I can scrounge up a few more parts! We need every bit of help we can get.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(99954,'Evan Banlip begins to whistle a grim tune.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(99955,'You meddle in affairs you do not understand, gnome!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99956,'','SEEK... MAGIC...',0,0,0,0,0,0,0,0,0,0,0,54215,26124),
(99957,'','ARCANE... ENERGY...',0,0,0,0,0,0,0,0,0,0,0,54216,26124),
(99958,'You shall NOT finish what you have begun!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99959,'You will die before you finish your last stroke!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99960,'','[PLACEHOLDER - In this quest you walk around the boat with me while I explain my evil plan.]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99961,'','[PLACEHOLDER - Did I say evil? I didn\'t mean that. Forget you heard anything. You are queued for the scenario. Now listen to this awesome exposition.]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99962,'','Hello! Are you interested in learning how to craft leather wares?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(99963,'I\'m looking for some leather book cloth.','I\'m looking for some leather book cloth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99964,'','Oh yes, we just received a shipment the other day. I believe it\'s still upstairs if you want to go get it.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(99965,'Thank you for the assistance, friend! That foul creature put up quite a fight!','',0,0,0,0,0,0,0,0,0,0,62031,0,26124),
(99966,'Children! Behave yourselves!','',0,0,0,0,0,0,0,0,0,0,62035,0,26124),
(99967,'I sense that we will have more battles ahead of us.$b$b<Jang glances over at the cubs.>$b$bAnd I\'ve got to get them out of here!','',0,0,0,0,0,0,0,0,0,0,62040,0,26124),
(99968,'Sorry, mister Stormstout.','Sorry, mister Stormstout.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(99969,'Sorry, sir.','Sorry, sir.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(99970,'Sorry.','Sorry.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(99971,'','[PLACEHOLDER - In this quest we walk around the ship while I explain the mission.]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99972,'','[PLACEHOLDER - You\'re queued for the scenario. Ultimately we will push you directly into the scenario after this quest. For now, enjoy this exposition.]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99973,'Try again, monster!','',0,0,0,0,0,0,0,0,0,0,62032,0,26124),
(99974,'You have strength, but lack speed!','',0,0,0,0,0,0,0,0,0,0,62036,0,26124),
(99975,'You seem like the type that just wants a fight. If you\'re interested, the Horde needs more troops.','',0,0,0,0,0,0,0,0,0,36754,0,0,26124),
(99976,'I will fight alongside the Horde in battlegrounds, for now.','I will fight alongside the Horde in battlegrounds, for now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99977,'Get lost, $r! There\'s an ale callin\' my name.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99978,'I challenge you, Tor.','I challenge you, Tor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99979,'I challenge you, Ranulf.','I challenge you, Ranulf.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99980,'I challenge you, Haldor.','I challenge you, Haldor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99981,'I challenge you, Bjorn.','I challenge you, Bjorn.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99982,'Are you prepared?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99983,'Repelled by a mystic force within Shattrath!','Repelled by a mystic force within Shattrath!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99984,'We must not allow Skovald to take these filth into the Halls of Valor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99985,'<The ancient burial mound of a long-forgotten vrykul.>','<The ancient burial mound of a long-forgotten vrykul.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99986,'<Place 20 fjarnskaggl at the foot of the cairn.>','<Place 20 fjarnskaggl at the foot of the cairn.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99987,'Skovald may have escaped, but victory is still ours. His demons will no longer be able to plague Stormheim, thanks to you.\n\nLet us return to the gates, friend. I believe that Havi will wish to thank you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99988,'Take me back to the Gates of Valor.','Take me back to the Gates of Valor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99989,'I am the king\'s blade. I am the Enduring!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99990,'I will continue my watch for the king unabated!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99991,'You will not spoil the king\'s return!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99992,'Forgive me, my king. My vigilance... is broken.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99993,'For the king!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99994,'I have failed you, my watchers. The king will not return.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99995,'','My sight has waned, but my blade remains sharp!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99996,'','I will see you dead before you reach the Enduring!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99997,'','I do not need sight to defeat you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99998,'','Do not disturb... the Enduring.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(99999,'','I can see you now...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100000,'','My watch has ended.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100001,'The eagles of Highmountain are in danger of becoming extinct if the drogbar aren\'t stopped.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100002,'','Rath-domaas!',0,0,0,0,0,0,0,0,0,0,0,67544,26124),
(100003,'She must have come this way. Keep looking!','She must have come this way. Keep looking!',0,0,0,0,0,0,1,0,0,0,67554,0,26124),
(100004,'<A small pile of dried herbs litters the floor. These are not natural - they were placed here by someone... or something.>','<A small pile of dried herbs litters the floor. These are not natural - they were placed here by someone... or something.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100005,'Sargeras\'s keystone is the crux of my plan to defeat the Burning Legion.','',0,0,0,0,0,0,0,0,0,0,55306,0,26124),
(100006,'Yes, I agree to fight alongside the Horde in Ashran. Send me there now!','Yes, I agree to fight alongside the Horde in Ashran. Send me there now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100007,'\"You look as beautiful as the two moons of Azeroth.\"','\"You look as beautiful as the two moons of Azeroth.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100008,'\"I think you\'re cute.\"','\"I think you\'re cute.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100009,'\"I\'m hoping for some epic pants drops tonight.\"','\"I\'m hoping for some epic pants drops tonight.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100010,'|cFF600000<The story is started, but unfinished.>|r$b$bThe ever-eloquent Lord Gravesbane stepped into the royal chamber. Before him stood the draenei princess, widely-known for her beauty, grace, and biting wit.$b$bHe greeted the bejeweled princess with his most reliable compliment.$b$b|cFF600000<The next line is blank. What might Lord Gravesbane have said?>|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100011,'Damn you, outsider! You\'ll never have the secrets of the shal\'dorei herbalists! I\'ll take them to my grave!','',0,0,0,0,0,0,0,0,0,36203,0,0,26124),
(100012,'\"You look as beautiful as the two moons of Azeroth.\"$b$bThe faintest suggestion of a smile appeared on the edge of the blue-skinned monarch\'s mouth. She quickly suppressed it, lest Lord Gravesbane discover her true feelings. She replied quickly:$b$b|cFF600000<The next line is blank. How might the draenei princess have responded?>|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100013,'\"I think you\'re cute.\"$b$bThe princess continued watching Lord Gravesbane\'s mouth, as if she expected more compliment to come out. As time wore on, it became clear that his utterance was indeed limited to only four words.$b$bOnce she fully realized it was her turn to speak, she replied...$b$b|cFF600000<How might the draenei princess have responded?>|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100014,'\"I am immune to your charms, outsider. Flattery will get you nowhere.\"','\"I am immune to your charms, outsider. Flattery will get you nowhere.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100015,'\"That\'s a big sword you have there. Are you sure you know how to wield it?\"','\"That\'s a big sword you have there. Are you sure you know how to wield it?\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100016,'\"Is that a gnome in your legplates, or is that two gnomes in your legplates?\"','\"Is that a gnome in your legplates, or is that two gnomes in your legplates?\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100017,'\"Why do I suspect that \'nowhere\' is the name of your majesty\'s private bedchamber?\"','\"Why do I suspect that \'nowhere\' is the name of your majesty\'s private bedchamber?\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100018,'\"OK, bye.\"','\"OK, bye.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100019,'\"Yes, I\'m good at swords. This is a two-handed sword. I bought it at the sword store.\"','\"Yes, I\'m good at swords. This is a two-handed sword. I bought it at the sword store.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100022,'You heard Lord Illidan. Let\'s find that keystone.','',0,0,0,0,0,0,1,0,0,0,55248,0,26124),
(100023,'I\'ll cut a hole through the demons and meet you in the volcano.','',0,0,0,0,0,0,0,0,0,0,55245,0,26124),
(100024,'We must eliminate the Legion threat on this ridge so that you can bring the rest of our forces in from the Black Temple.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(100025,'','Do I know you? What are you doing here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100026,'','I suspected I would find some sort of greenery if I followed Freya\'s trail, but I never expected anything like this!$b$bWhat can I do for you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100027,'','Did you bring my analysis to Kuhuine? What did she say?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100028,'Kuhuine Tenderstride sent me to collect your felwort analysis.','Kuhuine Tenderstride sent me to collect your felwort analysis.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100029,'','Ah, yes. Here it is. Nasty plant, that.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100030,'Quiet! I\'m listening to the plants.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100031,'No, I\'m not lost - I\'m simply looking for rare herbs. I... wait, are you $n? The herbalist, $n?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100032,'You... wouldn\'t happen to know how to get out of this crater, would you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100033,'Yes, I am. Kuhuine Tenderstride sent me to collect your felwort analysis.','Yes, I am. Kuhuine Tenderstride sent me to collect your felwort analysis.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100034,'An honor to meet you, $n. Of course, I have your report right here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100035,'As a druid, the overgrowth in this area concerns me. As an herbalist, however, I couldn\'t be happier.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100036,'As a druid, the overgrowth in this area concerns me. As an herbalist, however, I couldn\'t be happier.$b$bHerbalist $n. You are here to collect my report?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100037,'Give Kuhuine my regards, herbalist.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100038,'Yes.','Yes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100039,'Very well, here it is. I apologize for any rips or claw marks on the paper.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100040,'','No! The ritual is not yet complete!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100041,'','The bindings weaken...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100042,'','It is still forming!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100043,'Can you believe there\'s a dwarf out there taking credit for my work? Have you ever heard of something so disrespectful?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100044,'I\'ve finished my book, Francis.','I\'ve finished my book, Francis.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100045,'','We need more time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100046,'','THE TIDES RISE!',0,0,0,0,0,0,0,0,0,0,0,54207,26124),
(100047,'Chuang!','',0,0,0,0,0,0,0,0,0,0,62039,0,26124),
(100048,'A stack of books, ready to be turned into masterpieces of literary art.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100049,'Finished already? Let\'s see what you have here...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100050,'Oh my, this is quite possibly...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100051,'the most amazingly, stupendously...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100052,'BADLY WRITTEN story I have ever had the displeasure of reading in either of my lives!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100053,'This really isn\'t that difficult, $n. Just be poetic, use adjectives, as many as your simple mind can come up with.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(100054,'For now, I will impart some of my unpublished works to you. As samples of course, to help you get started.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(100055,'Chuang, are you alright? Speak to me!','',0,0,0,0,0,0,0,0,0,0,62043,0,26124),
(100056,'I\'m ready to begin my lesson, Francis.','I\'m ready to begin my lesson, Francis.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100057,'Follow Francis Serbacon\'s instructions.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100058,'Any disturbance should catalyze the sequence. Just, uh, give it a poke or something.','',0,0,0,0,0,0,1,0,0,0,67264,0,26124),
(100059,'I will stay in contact with you for as long as I can.','',0,0,0,0,0,0,0,0,0,0,67553,0,26124),
(100060,'Reuse','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(100061,'Reuse','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(100062,'Be careful, champion. The land of Suramar has been wild for ten thousand years.','',0,0,0,0,0,0,0,0,0,0,67271,0,26124),
(100064,'Oh... my head...','',0,0,0,0,0,0,0,0,0,0,62037,0,26124),
(100065,'<cough> The demons... they cut down the students before my eyes! <wheeze> Heard shouting... from the Cave of the Crane...','',0,0,0,0,0,0,0,0,0,0,62041,0,26124),
(100066,'%s faints and falls onto the ground.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100067,'I... I don\'t feel so good...','',0,0,0,0,0,0,0,0,0,0,62045,0,26124),
(100068,'The might of the Legion will prevail!','The might of the Legion will prevail!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100069,'You\'ve defiled these lands long enough!','You\'ve defiled these lands long enough!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100070,'Sargeras demands your soul.','Sargeras demands your soul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100071,'Intruder!','Intruder!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100072,'Now listen, it\'s very simple. When setting your scene try to be descriptive enough so the reader can envision it in their head. And give the characters some action. For example:','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100073,'Today you die, $r!','Today you die, $r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100074,'\"Yes, my princess, and it\'s led me to countless treasures. In fact, I\'m hoping for some epic pants drops tonight.\"','\"Yes, my princess, and it\'s led me to countless treasures. In fact, I\'m hoping for some epic pants drops tonight.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100075,'\"Alas, your majesty, it is but one gnome - although he does know some magic spells...\"','\"Alas, your majesty, it is but one gnome - although he does know some magic spells...\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100076,'\"Alright, you caught me. I\'ll let them out now.\"','\"Alright, you caught me. I\'ll let them out now.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100077,'Next, have the characters engaging one another in an interesting conversation. It doesn\'t need to be so dry as you wrote it. For example:','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100078,'Nalthanis! I\'ve told you before to stop wasting time studying the magic of the primitives down below. I tire of repeating myself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100079,'And finally, come to a climax that leaves the readers wanting more. Give them a real page turner! For example:','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100080,'\"I\'ll bet you say that to every princess you meet.\"','\"I\'ll bet you say that to every princess you meet.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100081,'No more excuses, Nalthanis! Do as I say or I will find someone else to run this shop! And for the last time, wear that uniform I picked out for you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100082,'\"Simply \'cute\'? You\'ll have to do better than that, Lord Gravesbane.\"','\"Simply \'cute\'? You\'ll have to do better than that, Lord Gravesbane.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100083,'\"Well, I think you\'re terribly unclever!\"','\"Well, I think you\'re terribly unclever!\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100084,'\"So... do you come here often? How about this weather?\"','\"So... do you come here often? How about this weather?\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100085,'\"Who needs cleverness when you look like THIS?\" <flex>','\"Who needs cleverness when you look like THIS?\" <flex>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100086,'But archmage, $n\'s excursions to the surface have already born fruit!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100087,'\"Darn! I really wanted pants.\"','\"Darn! I really wanted pants.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100088,'','Ith\'el kanesh!',0,0,0,0,0,0,0,0,0,0,0,67265,26124),
(100089,'','I am Thalyssra of the shal\'dorei... the Nightborne. First Arcanist in the court of Suramar.',0,0,0,0,0,0,1,0,0,0,0,67266,26124),
(100090,'Your doom has come, mortals!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100091,'','My people have made a dire pact. One that spells doom for this world.',0,0,0,0,0,0,603,0,0,0,0,67267,26124),
(100092,'But I... As you command, archmage.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100093,'You can use the books on the table over there to begin writing your story.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(100094,'','Time is short. If you have found this message, you are capable of finding me as well.',0,0,0,0,0,0,1,0,0,0,0,67268,26124),
(100095,'I\'ve got him.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100096,'','Make haste for Suramar. You may be our last hope.',0,0,0,0,0,0,25,0,0,0,0,67269,26124),
(100097,'','%s winces in pain and holds her side.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100098,'Brace the west door! I don\'t want anymore surprises. Now, let\'s see what\'s going on out there.','',0,0,0,0,0,0,0,0,0,0,62047,0,26124),
(100099,'No... this cannot be!','',0,0,0,0,0,0,0,0,0,0,62049,0,26124),
(100100,'There are too many of them! We have to evacuate!','',0,0,0,0,0,0,0,0,0,0,62051,0,26124),
(100101,'$p, I need you to send any survivors you find back to the temple. Chaung mentioned the Cave of the Crane, so start there. Hurry, we must escape before we are overrun!','',0,0,0,0,0,0,0,0,0,0,62054,0,26124),
(100102,'These beasts do my bidding! You don\'t stand a chance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100103,'So powerful!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100104,'Stay in school!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100105,'Ha! Try harder!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100106,'Sic \'em!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100107,'I\'m unimpressed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100108,'Should have brought a beast!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100109,'No! How could you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100110,'Are you using mechanicals?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100111,'It\'s all part of the plan.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100112,'Don\'t believe any of those rumors ye\'ve been hearing. I\'m the only author of those novels, not that putrid, undead corpse!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100113,'I\'ve finished my book, Bill.','I\'ve finished my book, Bill.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100114,'I\'m ready to begin my lesson, Bill.','I\'m ready to begin my lesson, Bill\n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100115,'Now listen, it\'s very simple. When setting yer scene try to be descriptive enough so the reader can envision it in their head. And give the characters some action, $glad:lass;. For example:','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100116,'Next, have the characters engaging one another in an interesting conversation. It doesn\'t need to be so dry as ye wrote it. For example:','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100117,'And finally, come to a climax that leaves the readers wanting more. Give them a real page turner! For example:','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100118,'Finished already? Let\'s see what ye have here...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100119,'Well, this is quite possibly...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100120,'the most amazingly, stupendously...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100121,'BADLY WRITTEN story I\'ve ever read! I think me goat could write better drivel than this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100122,'Listen, it\'s very simple $glad:lass;. Just be poetic with what ye write, try using some adjectives.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(100123,'Talk to me again and I\'ll give ye a few sample scripts to get ye started.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(100124,'Go ahead and use the books on that table behind me to write yer story.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(100126,'Greetings, commander. What can I do for you?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100127,'You seemed rather harsh with Nalthanis.','You seemed rather harsh with Nalthanis.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100128,'You are vital to our war against the Legion, commander.$b$bI cannot allow my underling to waste your time chasing after rumors of primitive magic.$b$bPlus, he refuses to wear the very smart outfit I picked out for him. That\'s is both bad taste and insubordination!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100129,'His information seems promising. I believe it is worth pursuing.','His information seems promising. I believe it is worth pursuing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100130,'Haha! More things to burn!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100131,'','Begone, foul creature! You will not harm any more of our sacred texts!',0,0,0,0,0,0,0,0,0,0,0,61974,26124),
(100132,'Pursue his leads if you must. An archmage as skilled as myself should be out there on the front lines assisting you, not stuck overseeing an enchanting shop! What a waste of my talents!','',603,603,0,0,0,0,0,0,0,0,0,0,26124),
(100133,'An interesting idea...','An interesting idea...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100134,'What will the tide wash up next?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100135,'This is the LIFE! Water fish, land fish, sky fish, and new fish!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100136,'Now, let\'s see about activating that gateway.','',0,0,0,0,0,0,0,0,6,0,55143,0,26124),
(100137,'<Place 20 piles of starlight rosedust upon the pile.>','<Place 20 vials of starlight rosedust upon the pile.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100138,'I must speak to Khadgar about taking a more active role in the campaign. Good luck, Commander $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100139,'Ah... a new FOOD!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100140,'Hold strong! These demons soon will meet their end.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100141,'Our soil, our water... tainted by your vile actions. We will not stand for this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100142,'You scorch our skies, defile our lands, sacrifice innocent wildlife, but the Earth Mother\'s blessing will prevail.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100143,'Your footsteps corrupt the very earth you walk upon, but today we end this corruption.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100144,'For the Earth Mother!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100145,'','If I focus my Chi, I believe I can get us behind their forces. Quickly, $n. Take my hand.',0,0,0,0,0,0,0,0,0,0,0,61978,26124),
(100146,'Sunbreeze screeches at the death of her hatchlings.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(100147,'The Avenger is impressed with your efforts to fight the Burning Legion.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(100148,'You have earned the right to call upon his fury. Go - destroy all that threatens this world!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(100149,'','This is worse then I feared. $n! We must part ways. They need my help here at the temple. Chen\'s class should be just to the north across the bridges.',0,0,0,0,0,0,0,0,0,0,0,61979,26124),
(100150,'I\'m ready, $n. Activate the first essence pool.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100151,'Praying','Praying',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(100152,'What are you looking at, $r?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100153,'I\'m here for you head, Inkrot!','I\'m here for you head, Inkrot!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100154,'So Raethan sent you to do his dirty work for him?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(100155,'Too bad it\'ll be your body he\'ll be scraping off the sewer floor!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(100156,'','It\'s great that a hero like you is helping out us little enchanters! I don\'t mean we\'re little, as in short. Archmage Starsinger is actually quite tall.$b$bI mean... aw, nevermind!',1,603,0,0,0,0,0,0,0,0,0,0,26124),
(100157,'','Together, we have slain my enemy. I offer you my gratitude, $c.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100158,'','I have tracked my enemy to this place. This beastly orc has wreaked havoc across these lands.$B$BI would ask you not to interfere, but I know your kind. I ask only that you do not get in my way.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100159,'Draw out your enemy, Raven, and let us be done with it!','Draw out your enemy, Raven, and let us be done with it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100160,'','Bloody Raven! Through mists and over mountains I have tracked you!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(100161,'','Your trail of blood and betrayal has lead me to your doorstep!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(100163,'I see you are not alone. It matters not. I will cut you down and heave your remains over the cliff!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(100164,'','I grow tired of chasing you! Come to the fire and let us end this!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(100165,'','It is done. I take my leave of you now, but I know that we will meet again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100166,'Curse you... and your black birds...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100167,'Preparing','Preparing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(100168,'$n! Master Jia! Thank de spirits ya be alive! These demons be endless!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100169,'Pathetic creatures.','',0,0,0,0,0,0,11,0,0,0,6943,0,26124),
(100170,'','To me, hero! Elune protect us!',0,0,0,0,0,0,0,0,0,0,0,53737,26124),
(100171,'Murky is doing exquisitely! He and his followers are working and training quite hard. Once they\'re fully grown, I believe that the Swamprock Tribe will be a successful, budding group of murlocs. Who knows what they\'ll be able to accomplish! I\'m going to stay here to observe. Thank you for all your help, $p.','',4,0,0,0,0,0,0,0,0,0,0,0,26124),
(100172,'I wonder what treasures will fall from the sky...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100173,'','Die beast!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100174,'I\'ve got a boot and I know just where to put it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100175,'','By Elune\'s grace, is everyone alright?',0,0,0,0,0,0,0,0,0,0,0,53738,26124),
(100176,'I still feel them... so many voices in my mind.','I still feel them... so many voices in my mind.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100177,'I can see nothing but death... how can we possibly win?','I can see nothing but death... how can we possibly win?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100178,'Hold on, old friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100179,'Now is not your time to leave this world.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100180,'May the Earth Mother watch over you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100181,'There\'s no sign of the special wine cask in the vintner\'s room.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100182,'As you all know, the defeat at the Broken Shore was decisive. The loss of so many valiant heroes was a terrible blow.','',0,0,0,0,0,0,1,0,0,0,62026,0,26124),
(100183,'The Burning Legion is a grave threat. We must find a way to stop their assault before all that we hold dear can be...','',0,0,0,0,0,0,603,0,0,0,62030,0,26124),
(100184,'Murky, we need you to get stronger! The fate of this coast depends on it!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100185,'','Jade Serpent watch over you, $n.',0,0,0,0,0,0,0,0,0,0,0,61980,26124),
(100186,'Pathetic mortals! The armies of the Legion will crush you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100187,'Come, children, we must get to the temple. $n, I\'ll need your help. The complex is crawling with evil!','',0,0,0,0,0,0,0,0,0,0,62044,0,26124),
(100188,'My power is infinite!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100189,'The Legion shall prevail!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100190,'The Legion! Quickly, get inside! He\'ll have to blow the house down to get to us!','The Legion! Quickly, get inside! He\'ll have to blow the house down to get to us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100191,'What do they want with our small Villa?','What do they want with our small Villa?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100192,'The Legion is infinite and all-knowing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100193,'Grand Master Hight, it\'s a relief to see you!','',0,0,0,0,0,0,0,0,0,0,62050,0,26124),
(100194,'Chen, I\'m glad to see you and the children are safe!','',0,0,0,0,0,0,0,0,0,0,62055,0,26124),
(100195,'It was all thanks to this hero, who arrived just in time to help us out.','',0,0,0,0,0,0,0,0,0,0,62052,0,26124),
(100196,'Well fought, $n, but we\'re not done yet.','',0,0,0,0,0,0,0,0,0,0,62056,0,26124),
(100197,'Chen, take the cubs as far away from this place as you can. $n, and I will stay and seal the portal. White Tiger walk with you, my friend.','',0,0,0,0,0,0,0,0,0,0,62057,0,26124),
(100198,'Those were my husks, mortal! You will pay for depriving me of my property!','Those were my husks, mortal! You will pay for depriving me of my property!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100199,'We can not allow the Legion to establish a foothold here. We need to close that portal down!','',0,0,0,0,0,0,0,0,0,0,62058,0,26124),
(100200,'The vanquishers have already taken possession of it, Skovald, as was their right. Your protest comes too late.','',0,0,0,0,0,0,0,0,0,0,54607,0,26124),
(100202,'','We should capture and interrogate some of these demons.',0,0,0,0,0,0,0,0,0,0,0,55004,26124),
(100203,'','Where is the keystone, demon?',0,0,0,0,0,0,0,0,0,0,0,55003,26124),
(100204,'','My scythe will compel them.',0,0,0,0,0,0,0,0,0,0,0,55002,26124),
(100205,'','The Scythe of Souls will cut you down!',0,0,0,0,0,0,0,0,0,0,0,55001,26124),
(100206,'','Did we bring enough of us?',0,0,0,0,0,0,0,0,0,0,0,55097,26124),
(100207,'','Lord Illidan chose you to lead. I follow.',0,0,0,0,0,0,0,0,0,0,0,55098,26124),
(100208,'','The fel energy is everywhere. It\'s hard to resist.',0,0,0,0,0,0,0,0,0,0,0,55099,26124),
(100209,'','There are too many of them!',0,0,0,0,0,0,0,0,0,0,0,55100,26124),
(100210,'We should gather intel on their leaders.','',0,0,0,0,0,0,0,0,0,0,55238,0,26124),
(100211,'We must find the Sargerite Keystone.','',0,0,0,0,0,0,0,0,0,0,55239,0,26124),
(100212,'I\'ll scout forward after this and find the keystone.','',0,0,0,0,0,0,0,0,0,0,55240,0,26124),
(100213,'I\'m glad you\'re leading us, $n.','',0,0,0,0,0,0,0,0,0,0,55241,0,26124),
(100214,'The Earth Mother watches over us.','The Earth Mother watches over us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100215,'These intruders defile our sacred lands, slaughtering the innocent...$B$BWe will not stand for this!','These intruders defile our sacred lands, slaughtering the innocent...$B$BWe will not stand for this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100216,'Lord Illidan places a lot of faith in you.','',0,0,0,0,0,0,0,0,0,0,55279,0,26124),
(100217,'My gut tells me the keystone is up in that volcano.','',0,0,0,0,0,0,0,0,0,0,55274,0,26124),
(100218,'The skies weep as the lands beneath suffer tremendous loss.','The skies weep as the lands beneath suffer tremendous loss.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100219,'I have some ideas for how to proceed.','',0,0,0,0,0,0,0,0,0,0,55269,0,26124),
(100220,'You know, I should be in command.','',0,0,0,0,0,0,0,0,0,0,55280,0,26124),
(100221,'Be careful, $n. We cannot assure safety to those who wander our lands in these dire times.','Be careful, $n. We cannot assure safety to those who wander our lands in these dire times.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100222,'','Hah! Racking up the kills.',0,0,0,0,0,0,0,0,0,0,0,55288,26124),
(100223,'','Having fun? I am!',0,0,0,0,0,0,0,0,0,0,0,55287,26124),
(100224,'','What\'s next, $n?',0,0,0,0,0,0,0,0,0,0,0,55286,26124),
(100225,'','Just point me in the right direction.',0,0,0,0,0,0,0,0,0,0,0,55289,26124),
(100226,'<The corpse of this unfortunate earthen explorer has been shredded open. His entrails - which look like sand and pebbles - are spilled all over the floor. Traces of fel emanate from the gaping wounds.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100227,'','Continue the ritual! I will handle these fools!',0,0,0,0,0,0,0,0,0,0,0,54194,26124),
(100228,'','Can you feel the winds? They come for you...',0,0,0,0,0,0,0,0,0,0,0,54195,26124),
(100230,'','Too much to handle?',0,0,0,0,0,0,0,0,0,0,0,54197,26124),
(100231,'','Pitiful.',0,0,0,0,0,0,0,0,0,0,0,54198,26124),
(100234,'Mrrglrrgl!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100235,'','Fry, landwalkers!',0,0,0,0,0,0,0,0,0,0,0,54200,26124),
(100236,'','There is no escape!',0,0,0,0,0,0,0,0,0,0,0,54202,26124),
(100237,'','The waters rise...',0,0,0,0,0,0,0,0,0,0,0,54204,26124),
(100238,'','|TInterface\\Icons\\Spell_Frost_SummonWaterElemental:20|t%s begins to cast |cFFFF0000|Hspell:193682|h[Beckon Storm]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(100239,'','You cannot understand the Sentinel\'s song, $r? Then perhaps you will allow me to speak for him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100240,'To the victor go the spoils... The Aegis of Aggramar is yours for the taking.','',0,0,0,0,0,0,0,0,0,0,54609,0,26124),
(100242,'Hey, I need to deliver this message fast! If I\'m late Master Jang is going to have me painting the temple again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100243,'','|TInterface\\Icons\\Spell_Shaman_StaticShock:20|t%s starts to invoke a |cFFFF0000|Hspell:193597|h[Static Nova]|h|r. Get out of the water!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(100244,'','Just you wait...',0,0,0,0,0,0,0,0,0,0,0,54201,26124),
(100245,'','A storm is gathering...',0,0,0,0,0,0,0,0,0,0,0,54203,26124),
(100246,'Hey, $n! Message for you from Grand Master Hight!','',0,0,0,0,0,0,0,0,0,36340,62014,0,26124),
(100247,'Where are you going? Hey, got a message for you!','',0,0,0,0,0,0,0,0,0,36340,62025,0,26124),
(100248,'Come on! I got to deliver this message!','',0,0,0,0,0,0,0,0,0,36340,62029,0,26124),
(100249,'Please, just give me a moment. Master Jang is going to make me paint the whole temple again if I don\'t deliver this!','',0,0,0,0,0,0,0,0,0,36340,62033,0,26124),
(100250,'Do you know how big the temple is? It takes weeks to finish! Please, listen to the message!','',0,0,0,0,0,0,0,0,0,36340,62038,0,26124),
(100251,'Have a safe journey.','',0,0,0,0,0,0,0,0,0,0,62046,0,26124),
(100252,'','My dear friends... what has become of them? Why does everything feel so... different?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100253,'','The spirits of my dear friends have been entrusted to you. Keep them safe, enchanter.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100254,'','Our finest casks will soon be on their way to Queen Azshara! She will be so pleased!',603,603,0,0,0,0,0,0,0,0,0,0,26124),
(100255,'','Something seems amiss, but... I cannot place it...',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(100256,'','Ith\'nala kanesh!',0,0,0,0,0,0,0,0,0,0,0,67270,26124),
(100257,'','Reuse',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100262,'','I hope someone out there is listening...',0,0,0,0,0,0,0,0,0,0,0,67540,26124),
(100263,'Fine, be that way. I\'ll follow you around this whole city if I have to!','',0,0,0,0,0,0,0,0,0,36340,62042,0,26124),
(100264,'Reuse','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(100265,'','Ngh... need to keep moving.',0,0,0,0,0,0,0,0,0,0,0,67541,26124),
(100266,'Reuse','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100267,'Reuse','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100268,'','Withered... I must be getting close.',0,0,0,0,0,0,0,0,0,0,0,67543,26124),
(100269,'','N\'eth narala. REUSE',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100271,'Throughout your trials, you have demonstrated strength, skill, and intellect-traits shared by the greatest of our vrykul kings. Now... you will face them in combat. Emerge victorious, and you may yet claim your prize!','',0,0,0,0,0,0,0,0,0,0,54613,0,26124),
(100272,'The pages have been ripped from their binding and scattered across the room. The inn appears as though it was hit by a cyclone.','The pages have been ripped from their binding and scattered across the room. The inn appears as though it was hit by a cyclone...$b$bThere are clear signs that a struggle took place here, but Malfurion is nowhere to be found.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100273,'This appears to be a plume from Malfurion\'s coat.$b$bSearching the area closely, you are able to make out a faint set of footprints heading southwest along the path.$b$bThese footprints differ from the cloven hooves of Satyr...','This appears to be a plume from Malfurion\'s coat.$b$bSearching the area closely, you are able to make out a faint set of footprints heading southwest along the path.$b$bThese footprints differ from the cloven hooves of Satyr...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100274,'<The wounded satyr scowls at you as you approach. He doesn\'t have long to live.>$b$bHave you come to finish what your Archdruid started, $r? You mortals think you\'ve won... but Malfurion is in the Master\'s hands now.$b$bThat fool fell right into our trap... haha-HAHA...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100276,'','Narala ith\'el! <cough>  REUSE',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100277,'REUSE','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100278,'REUSE','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100279,'','Stand down, Erasmus! Can you not see that Elisande has forsaken us?!',0,0,0,0,0,0,0,0,0,0,0,67545,26124),
(100280,'','Rath-anu\'tanos!',0,0,0,0,0,0,0,0,0,0,0,67511,26124),
(100281,'REUSE','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100282,'','That will buy me some time...',0,0,0,0,0,0,0,0,0,0,0,67547,26124),
(100283,'','REUSE',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100284,'','In-leva dathos. REUSE',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100294,'Just remember, you\'re the \"smart\" part, so you gotta point this thing at the demons!','Just remember, you\'re the \"smart\" part, so you gotta point this thing at the demons!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100295,'Hit your target fast. This thing is packed and will blow when it runs out of fuel!','Hit your target fast. This thing is packed and will blow when it runs out of fuel!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100296,'I may be dead, but my pets are still kicking!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100297,'Only one of us is coming out of this alive...  Wait...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100298,'I will take you to Helheim myself, \"hero\" of Azeroth!','',0,0,0,0,0,0,0,0,6,0,60370,0,26124),
(100299,'Wanderer! Have you come to save your soul?\n\nIt will soon be upon us! The second coming! Deathwing is returning, and Azeroth will be destroyed! We must be prepared for the ocean to swallow the world!','',53,0,0,0,0,0,0,0,0,0,0,0,26124),
(100300,'What doesn\'t kill you makes you stronger!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100301,'...Deathwing? You mean the Burning Legion?','...Deathwing? You mean the Burning Legion?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100302,'Try again, if you dare!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100303,'My guide didn\'t say anything about this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100304,'How? My plan was foolproof!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100305,'Grrrrr....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100306,'The Burning Legion? Hah! They are naught but a sign. Listen to my sermon.','',11,0,0,0,0,0,0,0,0,0,0,0,26124),
(100307,'...Okay?','...Okay?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100308,'You just aren\'t very good.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100309,'My strategy is flawless!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100310,'You\'re no match for my pets!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100311,'And so I declare, Deathwing has not been defeated. He lays in wait for Azeroth\'s distraction. Soon he will return, flying over the world and spreading his destruction.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100312,'Surely, you may think, the Alliance and Horde will take him down with their great airships. But his body will cause the earth to shake, and the oceans will rise up to swallow us all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100313,'But the Prepfoot... we know! We have seen the future and will prepare until the time comes. We shall survive... nay, thrive!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100314,'','Demons! In the mine! Look, I know we Venture Company haven\'t been easy competitors, but just this once, you gotta help us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100315,'This prey has quite a bite! Follow... if you dare!','',0,0,0,0,0,0,0,0,0,0,60374,0,26124),
(100316,'A little farther before we fight, hero! I have a surprise for you...','',0,0,0,0,0,0,0,0,0,0,60375,0,26124),
(100317,'Huln was the strongest of champions and first of our tribe.','',0,0,0,0,0,0,0,0,0,37009,54788,0,26124),
(100318,'At the call of Krasus, he defied the Legion and defeated many demons with the Eagle Spear.','',0,0,0,0,0,0,0,0,0,37009,54789,0,26124),
(100319,'Huln\'s prowess in combat was unmatched.','',0,0,0,0,0,0,0,0,0,0,54790,0,26124),
(100320,'This smoldering corpse is clutching a totem still wreathed with wind spirits.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100321,'I don\'t remember him killing THAT many demons. You\'re exaggerating, Spiritwalker.','',0,0,0,0,0,0,0,0,0,0,54807,0,26124),
(100322,'Alright Murky! Time for you to get big and strong!','',3,0,0,0,0,0,0,0,0,0,0,0,26124),
(100323,'Skyhorn! Take to the air and show these harpies and their rocs the meaning of battle!','',0,0,0,0,0,0,0,0,0,0,54294,0,26124),
(100324,'Can you help me find my way?','Can you help me find my way?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100325,'I hear you have some useful goods.','I hear you have some useful goods.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100326,'Perhaps they were correct in their belief that Huln\'s love of fighting was too strong.','',0,0,0,0,0,0,0,0,0,0,54791,0,26124),
(100327,'Some believe Huln\'s bloodlust was too strong.','',0,0,0,0,0,0,0,0,0,0,54792,0,26124),
(100328,'They sing of Huln\'s thirst to spill demonic blood.','',0,0,0,0,0,0,0,0,0,0,54793,0,26124),
(100329,'','We were sent out here to keep an eye on the murlocs. They told us that they\'d send relief after a week... we\'ve been here for a month and seen no other tauren. I\'m getting sick of these two. They can\'t be near each other or they\'ll start bickering like an old married couple.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100330,'I\'m so sick of Scout Proudhill. All I want to do is go remind Thunder Totem that we\'re still out here! He refuses to let a single one of us leave our post. What could possibly be happening back home that\'s so important that they forgot about us?!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100331,'We cannot leave our post. If we look away for even a second, that weird guy in the murloc suit might do something insane. Thunder Totem will send relief when it is necessary. They haven\'t forgotten about us.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100333,'Archimonde the Defiler spent an eternity exposing the darkest tendrils of the arcane arts. Thousands of years, countless worlds\' knowledge and history are locked away within this tome\'s pages.$B$BNow we will tell your tale, $g milord:milady;.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100335,'','I\'m sure an enchanter like you will make good use of the Sentinel\'s essence.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100337,'','In-leva dathos. REUSE',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100338,'','Such is the fate of nightborne who cannot drink of the Nightwell.',0,0,0,0,0,0,0,0,0,0,0,67513,26124),
(100339,'','My strength is fading... we must find shelter...',0,0,0,0,0,0,0,0,0,0,0,67517,26124),
(100340,'','E\'rath omnas!',0,0,0,0,0,0,0,0,0,0,0,67516,26124),
(100341,'Cyana, Jace, Allari... find the keystone.','',0,0,0,0,0,0,0,0,6,0,55144,0,26124),
(100342,'','I am using the Scythe of Souls to interrogate these demons, but they do not know anything about the location of the Sargerite Keystone.\n\nThey just keep repeating their loyalty to some queen.\n\nCyana and Jace have moved ahead. Unfortunately, I think Cyana got herself captured trying to help some of our other demon hunters.\n\nThere is something not quite right with her...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100343,'This is a job for Murky in order to prove himself. Use his egg to mindmeld with Murky.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100344,'Mrrglrrgl?','',51,0,0,0,0,0,0,0,0,0,0,0,26124),
(100345,'Mrlrlrlrlrgl! Grglrgl!','',51,0,0,0,0,0,0,0,0,0,0,0,26124),
(100346,'Mrr mrrgl? Mrglglgl.','',51,0,0,0,0,0,0,0,0,0,0,0,26124),
(100347,'Mrrrglrglrglrgl!','',35,0,0,0,0,0,0,0,0,0,0,0,26124),
(100348,'Mrrgl? Mrglglglrglrgl! Mrgl!','',35,0,0,0,0,0,0,0,0,0,0,0,26124),
(100349,'Mrglrglrglglgl. Mrglgl? Mrrgl!','',35,0,0,0,0,0,0,0,0,0,0,0,26124),
(100350,'- CLIENT SIDE SCENE - Malfurion has been captured by Xavius. Ysera is destroying the Temple of Elune.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100351,'I will be rewarded greatly for your soul!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100352,'Infernal incoming! Watch your head!','',0,0,0,0,0,0,0,0,0,0,62048,0,26124),
(100353,'Another would be champion... pathetic.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100354,'An eternity of pain awaits you in Helheim!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100355,'I see only torment...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100356,'You have doomed me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100357,'The battlefield of dishonor lies ahead...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100358,'You\'ve come to the wrong place, hero.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100359,'They will make me helarjar for this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100360,'Join the other souls in Helheim, fool!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100361,'You won\'t make it out of here alive!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100362,'No, the torment...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100363,'I\'ll see you in... Helheim.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100364,'Then come meet death, hero!','',0,0,0,0,0,0,0,0,0,0,60371,0,26124),
(100365,'Helya\'s gifts have made me strong! In my hands, these blades have slain thousands!','',0,0,0,0,0,0,0,0,0,0,60372,0,26124),
(100366,'I am the champion of the helarjar! Die and accept your fate!','',0,0,0,0,0,0,0,0,0,0,60373,0,26124),
(100367,'What are you idiots doing? Well now... what is this I sense? A soul that radiates great power!','',0,0,0,0,0,0,0,0,0,0,60369,0,26124),
(100368,'The Aegis of Aggramar overloads!','The Aegis of Aggramar overloads!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100369,'... yes, and our forces -','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100370,'WHAT? You DARE disturb ME? Insolent... You will regret your decision.','',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(100371,'The priestess\'s room is long abandoned. A worn journal lies on the floor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100372,'The demons fancy themselves the masters of this universe, yet we bind stronger ones yet to our will with each passing day and take their knowledge for our own.$B$BI will not rest until every ounce of knowledge of the Scepter of Sargeras is within our grasp. You have my word.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100373,'Helya! Aid your champion! I will claim this prize in your name!','',0,0,0,0,0,0,0,0,0,0,60376,0,26124),
(100374,'No! I\'ll not fall to Odyn\'s lapdog! I will destroy you!','',0,0,0,0,0,0,0,0,0,0,60378,0,26124),
(100375,'I see only darkness. Helya... no! NO!','',0,0,0,0,0,0,0,0,0,0,60380,0,26124),
(100376,'I sense an intruder who has come in search of plunder. You underestimate the dangers of Icecrown, foolish mage!','',0,0,0,0,0,0,0,0,1,0,60505,0,26124),
(100377,'Your thoughts are transparent, $n. I sense you have come seeking Felo\'melorn. You hope to use it against the Legion. Interesting. I wonder...','',0,0,0,0,0,0,0,0,1,0,60506,0,26124),
(100378,'Our prey is on the retreat! Time for us to push our advantage.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100383,'These halls are home to much of the world\'s knowledge of the arcane arts... but not all of it.$B$BWe must find out more about Aluneth so that we may increase its power. I believe it is truly our only hope of driving the Legion back.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100384,'','Here! That demon must\'ve crawled this way. There\'s fel blood splattered on the stones.',0,0,0,0,0,0,0,0,0,0,0,60577,26124),
(100385,'','Stormbeak, stay here and guard the entrance.',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(100386,'','Don\'t you give me any beak. Stay!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(100387,'','Imps! Geth\'xun must be summoning these little buggers.',0,0,0,0,0,0,0,0,0,0,0,60578,26124),
(100388,'','Geth\'xun must be summoning these little buggers to corrupt the Realm of Earth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100389,'','Watch yourself! More imps!',0,0,0,0,0,0,0,0,0,0,0,60579,26124),
(100390,'','Thrall, that demon is still alive down here.',0,0,0,0,0,0,0,0,0,0,0,60580,26124),
(100391,'Yeah I stayed back while Nesingwary moved on. Why don\'t you go check on that murloc guy?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100392,'That crazy guy... calls himself Mrgl-Mrgl. Says he was a king in Northrend. I don\'t believe him for a second.','',274,0,0,0,0,0,0,0,0,0,0,0,26124),
(100393,'He keeps talking to his baby murloc. Calls him Murky.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100394,'','Watch it! That thing\'s corrupted by the fel. Kill it!',0,0,0,0,0,0,0,0,0,0,0,60587,26124),
(100395,'','We\'ve got to hurry. Keep going!',0,0,0,0,0,0,0,0,0,0,0,60581,26124),
(100396,'','Look! There he is.',0,0,0,0,0,0,0,0,0,0,0,60576,26124),
(100397,'','Shaman, we can\'t let that weapon fall to the wrong hands. I\'ll distract him. You grab the Doomhammer. No time to argue! Go!',0,0,0,0,0,0,0,0,0,0,0,60582,26124),
(100398,'','\'Ey! You there! Me bird craps scarier demons than you!',0,0,0,0,0,0,5,0,0,0,0,60586,26124),
(100399,'','Oh, aye, COME GET SOME!',0,0,0,0,0,0,0,0,0,0,0,60583,26124),
(100400,'','You got it! OOF!',0,0,0,0,0,0,5,0,0,0,0,60588,26124),
(100401,'','...I think I\'m done, shaman... It\'s the end of the tunnel for me...',0,0,0,0,0,0,0,0,0,0,0,60584,26124),
(100402,'','Thank ye...',0,0,0,0,0,0,1,0,0,0,0,60585,26124),
(100403,'','Come, let\'s go. With heroes like you, we just might have a prayer of saving this world. To the Maelstrom!',0,0,0,0,0,0,0,0,0,0,0,60589,26124),
(100404,'Bah, what is this sorcery?','',0,0,0,0,0,0,0,0,4,0,60564,0,26124),
(100405,'This hammer... I must claim it for my masters...','',0,0,0,0,0,0,0,0,4,0,60565,0,26124),
(100406,'<Geth\'xun roars.>','',0,0,0,0,0,0,0,0,0,0,60566,0,26124),
(100407,'Pathetic puny shaman! That hammer did little to help its last master.','',0,0,0,0,0,0,1,0,0,0,60573,0,26124),
(100408,'I WILL present that weapon to my masters as a trophy... Along with YOUR HEAD!','',0,0,0,0,0,0,0,0,0,0,60567,0,26124),
(100409,'I will bring down this whole cavern!','',0,0,0,0,0,0,0,0,0,0,60568,0,26124),
(100410,'I will corrupt your sorry world from within.','',0,0,0,0,0,0,0,0,0,0,60569,0,26124),
(100411,'The power of the Legion is unmatched!','',0,0,0,0,0,0,0,0,0,0,60570,0,26124),
(100412,'Kneel! Kneel and I may yet show mercy!','',0,0,0,0,0,0,0,0,0,0,60574,0,26124),
(100413,'You are witnessing the end of your world, shaman.','',0,0,0,0,0,0,1,0,0,0,60571,0,26124),
(100414,'...There are others... we are... legion...','',0,0,0,0,0,0,0,0,0,0,60572,0,26124),
(100415,'','Those things... complete disregard for life!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100416,'','There, there. You\'re on the mend already.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100417,'','You\'re lucky you\'ve got such a thick hide, old friend.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100418,'','I\'ll secure the exit portal back to the Black Temple once the others fly up here.',0,0,0,0,0,0,1,0,0,0,0,55096,26124),
(100419,'','I just needed a moment to reflect upon the choices I made. Now I am ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100420,'It\'s time to begin.','It\'s time to begin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100421,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-KERISTRASZA.BLP:50:80|t$b[Korialstrasz] You honored your promise to come, Highmountain. Do not fear my fire; it is demons who need fear my flames and your Eagle Spear.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100422,'','Elune, grant me the blessing of your purity one last time.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(100423,'%s squawks in protest.','',0,0,0,0,0,0,0,0,0,0,43464,0,26124),
(100424,'','It worked! Praise the goddess!',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(100425,'Huln Highmountain... Eche\'ro follows you? That is no ordinary beast; it is one of Malorne\'s chosen. Truly, you are blessed.','',0,0,0,0,0,0,0,0,0,0,54805,0,26124),
(100426,'Receive my blessing, Huln Highmountain. Your people shall forever have my favor.','',0,0,0,0,0,0,0,0,0,0,54806,0,26124),
(100427,'Even the Lord of the Forest, Cenarius, recognized Huln\'s greatness. He bestowed him with a blessing that we carry with us to this day: the Horns of Eche\'ro.','',0,0,0,0,0,0,0,0,0,0,54830,0,26124),
(100428,'I found Priestess Driana. She is safe, and wishes to speak to you.','I found Priestess Driana. She is safe, and wishes to speak to you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100429,'I have had the pleasure of watching you grow from a young $r into the finest hunter in all of Azeroth.$B$BYour tales must be written so that all may know of your deeds and the history of your great weapon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100430,'','I have returned, my love. I am home at last.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100431,'','My dear Driana... is it really you? Things here are so... strange... Almost like a dream.',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(100432,'','I know. But there is nothing to fear. We are together again.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100433,'','I\'m so glad! Later on can we take a walk by the wellspring? It always brings me comfort.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100434,'','I can\'t tell you how wonderful that sounds. But for now, I must go and... rest. We will be together again soon.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100435,'','Driana? DRIANA? Where have you...',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100436,'','Though my spirit fades, the part of me that remembers the satyr\'s trickery will serve you well. Thank you again, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100437,'These brave adventurers advance through the fields beneath our bluffs!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100439,'Bless you, $c! I owe you my life and a good meal. We better get out of here before their leader comes, or we\'ll end up like--','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100440,'NOOOO! SAVE YOURSELF!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100441,'We hold strong against the Legion at our position. Nothing gets through!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100442,'Huln! It is good to see you on this field of battle. You look... taller?','',0,0,0,0,0,0,3,0,0,0,54808,0,26124),
(100443,'This demon will fall to the Eagle Spear, Shadowsong. Play with your imps while I do the real work. Next one is on you.','',0,0,0,0,0,0,0,0,0,0,54809,0,26124),
(100445,'','Wait, what was I... Oh yes, the casks for Queen Azshara. I must be about my work.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100447,'I am by your side, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100448,'To battle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100449,'Well done, $n! That Fel Stone must be powering the portal. Destroy it!','',0,0,0,0,0,0,0,0,0,0,62019,0,26124),
(100450,'They\'re coming through!','',0,0,0,0,0,0,0,0,4,0,62060,0,26124),
(100451,'<Cinematic showing Gul\'dan and the Nightborne joining forces.>','<Cinematic showing Gul\'dan and the Nightborne joining forces.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100452,'Stand your ground, warbraves!','',0,0,0,0,0,0,0,0,6,0,54874,0,26124),
(100453,'The Legion is upon us! To arms! Dalaran is our best, last hope to save our world.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100454,'What are you doing out of your cage, $c?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100455,'','We\'ll cover more ground if we spread out. I\'ll go to the Commerce Exchange and rally the merchants!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100456,'','Merchants, artisans, we\'ll need your help in defending the city!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100457,'','Arm yourselves with whatever you can find! The Legion are already in the skies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100458,'','You are too late! The Wrath of Azshara has arrived!',0,0,0,0,0,0,0,0,0,0,0,54196,26124),
(100459,'','Bar that door! We can\'t have a demon just popping up at you now, can we?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100460,'','Keep your guard up, and call for help if you\'re overwhelmed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100461,'','Adventurers, take what you need from the Exchange to aid in defense. We\'ll can\'t hold anything back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100462,'Unworthy of my time.','',0,0,0,0,0,0,0,0,0,0,54189,0,26124),
(100463,'','The Hatecoil prove superior!',0,0,0,0,0,0,0,0,0,0,0,54199,26124),
(100465,'Bah. My people did not make this goblin trash. We only strapped it to that wyrm\'s hide. No weapon of mortal make can penetrate these metal plates.','',0,0,0,0,0,0,0,0,0,0,54875,0,26124),
(100466,'Go hunt somewhere else!','Go hunt somewhere else!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100467,'Then we must find weapons not made by mortals. Igrul, is there any tool or trinket that Deathwing kept from your people? Something he would not trust you to touch?','',1,0,0,0,0,0,0,0,0,0,54876,0,26124),
(100468,'Hmm. I may know of something...','',0,0,0,0,0,0,0,0,0,0,54877,0,26124),
(100469,'Get out of the way! You\'re blocking my shot.','Get out of the way! You\'re blocking my shot.',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(100472,'Enough trifling with fodder! I will harvest your soul myself!','',0,0,0,0,0,0,0,0,0,0,60366,0,26124),
(100473,'Now in my town!','Now in my town!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100474,'You\'re gonna regret this!','You\'re gonna regret this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100475,'Here we go again!','Here we go again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100476,'Not this time!','Not this time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100477,'','THIS WORLD WILL DROWN...',0,0,0,0,0,0,0,0,0,0,0,54211,26124),
(100478,'Sick \'em, boys!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100479,'... and a twist to the - OUCH! Hmph. How will we ever get reinforcements here in time if I can\'t get this thing working again?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100480,'If I could just get this working, we could call in more backup!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100481,'Pretty soon she\'ll be up and runnin\'! Then we call in the cavalry!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100482,'','Bandages! I need more bandages, Angelique!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100483,'','I can\'t keep them all stable... Keep the supplies coming, I won\'t give up!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100484,'Just remember what kinda protection I\'m payin\' ya for. Priorities! Us, the money, then everythin\' else... if there\'s time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100485,'','Here\'s another one! Catch!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100486,'Tell me more of Huln Highmountain. [Enter Flashback]','Tell me more of Huln Highmountain. [Enter Flashback]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100487,'','Oh, when did you get here, $c?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100488,'Best be prepared lads an\' lasses! Come an\' get yer weapons sharpened free of charge!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100489,'','You\'re not Belamy! But I suppose we can\'t leave any loose ends...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100490,'Hang in there, buddy! We\'re gonna make it through this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100491,'Damn demons! Somebody\'s gotta put an end to \'em!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100492,'It doesn\'t look so bad. You\'ll be okay. I promise.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100493,'','You may take my soul, cursed, but you will never take my will.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100494,'Silence. Your soul belongs to Helya.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100495,'Even now the Burning Legion marches unchecked on the Broken Shore. We need your aid.','',0,0,0,0,0,0,0,0,0,0,54295,0,26124),
(100496,'$n, we meet in dangerous territory. Thank you once again for your help at Riverbend. Be on your guard here among the Bloodtotem; they are not often kind to outsiders.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100497,'dnt','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100498,'dnt','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100499,'%s coughs a little, wheezing as he forms his words.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100504,'Alright already! I ain\'t stickin\' around, but you look like you could use a little help. Follow me.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(100505,'You\'ll not get below! The very dead will rise to stop you!','',0,0,0,0,0,0,0,0,0,0,60367,0,26124),
(100506,'Try and bring \'em back in one piece.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(100507,'We have to come to terms with it: Riverbend is destroyed. One day, we will rebuild our home. But for now we must wait and help Thunder Totem however we can, just as they help us.','',1,0,0,0,0,0,0,0,0,48585,0,0,26124),
(100508,'','You\'re doing great, Olisarra!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100509,'','The sprites of the Lunawing Shallows were a thorn in my side, but these murlocs are absolutely the most ill-mannered creatures that I have ever had the displeasure of meeting.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100510,'Boy is my head throbbing! Thanks, $n! Be careful out here.','Boy is my head throbbing! Thanks, $n! Be careful out here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100511,'Today just isn\'t my day. I should get going before I\'m put out for good!','Today just isn\'t my day. I should get going before I\'m put out for good!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100512,'Yikes! What a mess! Gotta run to warn the others!','Yikes! What a mess! Gotta run to warn the others!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100513,'Runes curse you. I will send you to the bottom of the sea where you belong!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100514,'The cases are secure! Can\'t we evacuate, Tiffany?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100515,'Fool. Our curse will be your undoing...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100516,'','We\'re not leaving! This is my family\'s shop, and we\'ll defend it to the last!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100517,'What brings you to the Murloc Shoals?','What brings you to the Murloc Shoals?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100518,'','After dealing with those troublesome Thistleleaf, I decided to venture into the ancient lands of Suramar.$B$BUnfortunately I came across these murlocs on my journey. I could not allow them to run about unchecked.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100519,'You have the patience of an ancients.','You have the patience of an ancients.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100520,'AHHHHHH!','',0,0,0,0,0,0,0,0,0,0,71617,0,26124),
(100521,'SMASH CHEST! BASH CHEST!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100522,'Stupid box! Gimme dem shinies!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100523,'HEY! Hey! You find somethin\' good yet?!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(100524,'Ooh! Pretty! You give?!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(100525,'What that? It magic? Is it? Is it? Is it? Is it?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(100526,'The intense magical currents here interfere with the mirror.','The intense magical currents here interfere with the mirror.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100527,'You have my healing, Archmage!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100528,'We\'re all gonna die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100529,'','Hide up here, Charles. We\'ll stop the demons!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100530,'','Welcome to Legendary Leathers. How may I help you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100531,'Don\'t ye dare say I look like me brother. I\'m clearly taller!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100532,'Get away from that, outsider!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(100533,'','Caria left me for dead... the fool!',0,0,0,0,0,0,0,0,0,0,0,58227,26124),
(100534,'Open the gates, Lord Saurfang. I have brought guests for the Warchief.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100535,'I don\'t like the looks of them, mage. They smell of demon filth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100536,'I\'ll be damned if any demon is ruinin\' my city. To arms, lads!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100537,'','Yes, stranger? Can I help you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100538,'$n! It\'s good to see you again! Is there anything I can do for you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100539,'I\'m the headbutt champ! You think a squishy thing like you can take me on? Hah! You make Jag laugh!','',15,0,0,0,0,0,0,0,0,0,0,0,26124),
(100540,'','This wouldn\'t have happened if your backside weren\'t so...<ahem>... GENEROUS.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100541,'','$p, is that you? Finally some good news!',0,0,0,0,0,0,0,0,0,0,0,58226,26124),
(100542,'Bring it on!','Bring it on!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100543,'','The barrier is being drained!',0,0,0,0,0,0,0,0,0,0,0,67524,26124),
(100544,'','Get them off the barrier!',0,0,0,0,0,0,0,0,0,0,0,67525,26124),
(100545,'','Ever since my husband came back we\'ve really been able to expand the place.$B$BWe\'ve even put in a brewery up top staffed by some of those nice monks from the temple!',646,0,0,0,0,0,0,0,0,0,0,0,26124),
(100546,'Hello there! We have some of the finest food you\'ll find anywhere.$b$bWe\'ve also a brand new brewery on the top floor. Try some of our new creations!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100547,'Hey! Hi. Hi. Hello. Hey. Hi. HI!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(100548,'You don\'t have to ask me twice.','You don\'t have to ask me twice.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100549,'Have you been waiting long, $r?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100551,'','My wounds are severe. I fear you must push ahead alone.',0,0,0,0,0,0,0,0,0,0,0,58228,26124),
(100552,'','I will join you as soon as I am able.',0,0,0,0,0,0,0,0,0,0,0,58229,26124),
(100553,'','Varedis has shown me the true path. The Legion can make us strong once more!',0,0,0,0,0,0,0,0,0,0,0,64681,26124),
(100554,'','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-ASIRA DAWNSLAYER.blp:50:80|t$b[Kor\'vas Bloodthorn] Doomguard incoming from above!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100555,'','Yes... I can feel your will weakening.',0,0,0,0,0,0,0,0,0,0,0,64682,26124),
(100556,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] Illidari, form up. Caria will not escape our wrath so easily.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100557,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] $p, we advance on your mark.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100558,'','Hello and welcome to the Laughing Crane!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100559,'You\'ll regret telling me to leave!','You\'ll regret telling me to leave!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100560,'Hey, me, listen up. I\'ve got a warning for you! Us! I\'m in danger. I mean, we\'re in danger. I mean... I\'ve been in danger, and you\'re going to be in danger. Darn time travel...','Hey, me, listen up. I\'ve got a warning for you! Us! I\'m in danger. I mean, we\'re in danger. I mean... I\'ve been in danger, and you\'re going to be in danger. Darn time travel...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100561,'Hey there, $n. No warnings this time. Just sayin\' hey.','Hey there, $n. No warnings this time. Just sayin\' hey.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100562,'$n, why haven\'t you enchanted that item yet? We aren\'t going to replace it for a while, believe me.','$n, why haven\'t you enchanted that item yet? We aren\'t going to replace it for a while, believe me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100563,'I think you\'re the one that should be leaving!','I think you\'re the one that should be leaving!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100564,'No one tells me what to do!','No one tells me what to do!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100565,'I\'ll hunt where I want, and you won\'t stop me!','I\'ll hunt where I want, and you won\'t stop me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100566,'I was just about to leave, anyway.','I was just about to leave, anyway.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100567,'You can have this spot. I\'ll find a better one.','You can have this spot. I\'ll find a better one.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100568,'Wow, $n, that transmogrification really is truly amazing! That is so amazingly amazing, I think I\'d like to use it.','Wow, $n, that transmogrification really is truly amazing! That is so amazingly amazing, I think I\'d like to use it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100569,'Every time you spend money repairing our gear, you\'re making it that much more difficult for me to buy Unclaimed Black Market Containers. Stay safe!','Every time you spend money repairing our gear, you\'re making it that much more difficult for us to buy Unclaimed Black Market Containers. Stay safe!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100570,'See you later, $n! Remember, I used to be you. I still am, but I used to be, too.','See you later, $n! Remember, I used to be you. I still am, but I used to be, too.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100571,'It is also your only way back. Find it and return to the Black Temple.','',0,0,0,0,0,0,0,0,0,0,55309,0,26124),
(100572,'Next time we\'re in Alterac Valley, whatever you do: DON\'T. CLICK. THE PORTAL.','Next time we\'re in Alterac Valley, whatever you do: DON\'T. CLICK. THE PORTAL.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100573,'I have to go, but it\'s vital that you remember to-','I have to go, but it\'s vital that you remember to-',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100574,'','Thanks, $n. I\'ll be back when this whole thing blows over.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100575,'','Thanks for the help. I\'m gonna lie down. Not feelin\' so hot.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100576,'Good to see you, $n! Say, do you think bronze dragons get any free time? Get it? Free time? They can time travel! Tough crowd.','Good to see you, $n! Say, do you think bronze dragons get any free time? Get it? Free time? They can time travel! Tough crowd.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100577,'So long, $n! I hope I get back to the right timeline. Chromie explains how it works, but we\'ll get confused.','So long, $n! I hope I get back to the right timeline. Chromie explains how it works, but we\'ll get confused.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100578,'Hey $n! Uh oh... is this the time we go to an inn, and you want help cheating at Hearthstone? Shame on us!','Hey $n! Uh oh... is this the time we go to an inn, and you want help cheating at Hearthstone? Shame on us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100579,'OooOOOooo! I\'m the Ghost of Winter Veil Future! If you play nice, play fair, we\'ll buy ourselves new armor to wear! Don\'t frown, don\'t fret; if we don\'t want armor, we can have a battle pet!','OooOOOooo! I\'m the Ghost of Winter Veil Future! If you play nice, play fair, we\'ll buy ourselves new armor to wear! Don\'t frown, don\'t fret; if we don\'t want armor, we can have a battle pet!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100580,'Take me to southern camp!','Take me to southern camp!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100581,'Goodbye $n! If you fly your mount fast enough, you can come visit me next time. You\'ll need to attach a Fel Lightning (Unstable X-treme) Capacitor to it. Has that been invented yet?','Goodbye $n! If you fly your mount fast enough, you can come visit me next time. You\'ll need to attach a Fel Lightning (Unstable X-treme) Capacitor to it. Has that been invented yet?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100582,'Bye, $n. A parting thought: Do bronze dragons buy into timeshares? Scheduling vacations must be a nightmare.','Bye, $n. A parting thought: Do bronze dragons buy into timeshares? Scheduling vacations must be a nightmare.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100584,'How\'s it going, $n? You don\'t have to answer that, I already know. Knew. I think you will have known how it was going. We think. You\'ve thought? Tenses are confusing.','How\'s it going, $n? You don\'t have to answer that, I already know. Knew. I think you will have known how it was going. We think. You\'ve thought? Tenses are confusing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100586,'Take me to the bluffs!','Take me to the bluffs!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100587,'$n cackles maniacally as they prepare to implode!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100588,'','<cough> I... need a moment...',0,0,0,0,0,0,0,0,0,0,0,67518,26124),
(100589,'','There are so many...',0,0,0,0,0,0,0,0,0,0,0,67519,26124),
(100590,'','Strange. Why do they not follow?',0,0,0,0,0,0,0,0,0,0,0,67520,26124),
(100591,'','<cough> I need to rest...',0,0,0,0,0,0,0,0,0,0,0,67521,26124),
(100592,'I wonder what this pool will reveal about you, Drelanim.','',0,0,0,0,0,0,1,0,0,0,55455,0,26124),
(100593,'Crimes? Our crime was to sacrifice everything to save this world.','',0,0,0,0,0,0,603,0,0,0,55454,0,26124),
(100594,'We fought for Illidan, you imprisoned the world\'s villains here for all eternity. And then you imprisoned us.','',0,0,0,0,0,0,1,0,0,0,55453,0,26124),
(100595,'','We protect life, often at great risk.  Too often at great cost.',0,0,0,0,0,0,274,0,0,0,0,55452,26124),
(100596,'You dare speak of sacrifice to me?','',0,0,0,0,0,0,603,0,0,0,55451,0,26124),
(100597,'','I told you to stop asking! Wait. Do you hear that?',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(100598,'','The spirits are whispering, if you stop chattering long enough to listen. Yes... yes, we are here!',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(100599,'','Yes, my son. In the embrace of the high mountain before us, we shall make our home. Run and fetch the elders.',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(100600,'','Then we can eat.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100601,'Mother, are we there yet?','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(100602,'I don\'t hear anything. Except the rumble of my hungry belly!','',1,603,0,0,0,0,0,0,0,0,0,0,26124),
(100603,'\"Here\" here? You mean we finally found our new home?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100604,'Then can we eat?','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(100605,'','The Bloodtotem will never fight beside fishers and rock climbers!',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(100606,'','Have a care, bird tender!',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(100607,'','Never!',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(100608,'','We will bathe the mountain in fel blood!',603,15,0,0,0,0,0,0,0,0,0,0,26124),
(100609,'Huln is right. We must unite against the Legion. It is the only way.','',603,1,0,0,0,0,0,0,0,0,0,0,26124),
(100610,'Enough! Will you doom our people for the sake of your pride? The Legion will leave nothing behind but the silent bones of our elders... our children.','',603,1,0,0,0,0,0,0,0,0,0,0,26124),
(100611,'Then let us stand as one. For Highmountain.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100612,'Together.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100613,'','My little Henle is out on her first trial to become a shaman... I am just so worried about her! Ferra, how did you handle yourself when Turn was doing his trials?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100614,'The Skyhorn will not stand with these savages! They are as wretched as the demons!','',603,274,0,0,0,0,0,0,0,0,0,0,26124),
(100615,'That must not come to pass.','',274,0,0,0,0,0,0,0,0,0,0,0,26124),
(100616,'Together!','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(100617,'I don\'t trust them, Borra. They\'re little more than beasts!','',1,603,0,0,0,0,0,0,0,0,0,0,26124),
(100618,'That\'s not what I... Listen, they\'re dangerous. Servants of corruption!','',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(100619,'Well, I\'m not letting my guard down. The drogbar are only good for--','',274,0,0,0,0,0,0,0,0,0,0,0,26124),
(100620,'Their crystals here have proven useful, I suppose.','',273,0,0,0,0,0,0,0,0,0,0,0,26124),
(100621,'I still don\'t trust them... but I like their stones. I mean crystals!','',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(100622,'','Don\'t work yourself up too much, Gala. Henle, like Turn, is a talented young tauren. She has earned her right to trial, and I know she will succeed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100623,'','We can learn much from the spirits of beasts, Fasho.',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(100624,'','That was the past. We must build a new future.',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(100625,'','Quiet! One approaches.',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(100626,'','Indeed we did.',273,0,0,0,0,0,0,0,0,0,0,0,26124),
(100627,'','Then let us strike a bargain here at the trading totem. Our skins for your stones. Deal?',1,6,0,0,0,0,0,0,0,0,0,0,26124),
(100628,'','At least that\'s a place to start.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100629,'Ronir bring more skins?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100630,'Me have stones. Good stones! Much magic!','',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(100631,'Deal!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100632,'These are not my pets! These are my friends! However, they are eager to beat you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100633,'Well done. You must have a strong connection with your companions.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100634,'If we must...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100635,'When you stop calling them pets and begin calling them friends, then can you defeat me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100636,'I take no joy in this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100637,'You should take better care of your friends.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100638,'Your bond is not yet strong enough.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100639,'Are you okay little guy?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100640,'So, the new blood awakens. You were spared the brunt of the pit lord\'s assault. A pity the rest of us... weren\'t so lucky...','',0,0,0,0,0,0,0,0,0,0,63907,0,26124),
(100641,'We would seem to be Jagganoth\'s prisoners on some forsaken Legion world. Imagine the horrors he has planned for us...','',0,0,0,0,0,0,0,0,0,0,63908,0,26124),
(100642,'Personally, I would prefer to avoid such torment.','',0,0,0,0,0,0,0,0,0,0,63909,0,26124),
(100643,'','I\'m glad that Kane only needed to go through his rites of age... I definitely would not be able to breathe if I knew he was ever in danger!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100644,'Take a rest my friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100645,'','Ladies, my child\'s only a little thing! I don\'t even want to THINK about her getting in any dangerous situations!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100646,'After this is over, we\'ll all go out for a pet treat.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100647,'','Hemet asked you to teach me how to hunt? \n\nI\'m glad you\'re up for the job. There\'s a lot I need to learn, but I think I know which end of the rifle to shoot with...\n\nI\'m ready whenever you are!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100648,'Protect the cargo! Protect... the souls...','',0,0,0,0,0,0,0,0,0,0,60368,0,26124),
(100649,'Oh, the pain...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100650,'I know, I know. You just hang in there! I promise the wounds will heal!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100651,'Just lie still! Help\'s comin\'! I know it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100652,'It\'s not the pain, numbskull - the sand! It BURNS!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100653,'Stay back, demons!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100654,'Think you can pick on us \'cause we\'re small? Huh?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100655,'You want a piece of this?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100656,'Would you keep quiet? You\'ll attract the others.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100657,'Oh yea. You\'ll show them! What are you gonna do? Punch \'em to death?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100658,'You\'ve been pacing for hours! Would ya give it a rest already?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100659,'Ya know, every time you run back \'n\' forth you hit me with sand! Not only am I mildly injured, but now I got sand in my hair, my eyes... bleh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100660,'','I think I\'m getting the hang of it!',1,0,0,0,0,0,1,0,0,0,0,54845,26124),
(100662,'','So this is the champion of Odyn! Let them die by Odyn\'s own blades! I bless these weapons with the fury of Helheim! Go, Vigfus! Slay this champion and earn my favor for all eternity!',0,0,0,0,0,0,0,0,0,0,0,60377,26124),
(100663,'','Vigfus, you weak fool! Your torment will be unending!',0,0,0,0,0,0,409,0,0,0,0,60381,26124),
(100664,'','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-ASIRA DAWNSLAYER.blp:50:80|t$b[Kor\'vas Bloodthorn] Those fallen soldiers... their souls have been torn from their bodies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100665,'','I grow weary of your presence! Tell Odyn that this changes nothing. He will suffer my wrath for ages to come!',0,0,0,0,0,0,1,0,0,0,0,60382,26124),
(100666,'','The imp mother is in that cave, right there.',0,0,0,0,0,0,0,0,0,0,0,55290,26124),
(100667,'Honorable $gsir:lady;, I am sorry but I must respectfully ask that you remain in the temple grounds or Mandori Village.','Honorable $gsir:lady;, I am sorry but I must respectfully ask that you remain in the Temple Grounds or Mandori Village.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100668,'Ah, my camel! Thank you my friend! You are most kind.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100669,'... what happened? My head - I...','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100670,'Demons! Their search won\'t be very fruitful once I\'ve taken their heads!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100671,'Take me to The Gaping Chasm!','Take me to The Gaping Chasm!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100672,'Take me to The Noxious Lair!','Take me to The Noxious Lair!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100673,'Ungh! Pain... hard to... focus...','',0,0,0,0,0,0,0,0,0,0,63910,0,26124),
(100674,'Quickly! Before our jailer turns his attention to us. You may be able to control him long enough...','',0,0,0,0,0,0,0,0,0,0,63911,0,26124),
(100675,'I will aid you... as I can.','',0,0,0,0,0,0,0,0,0,0,63912,0,26124),
(100676,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] Let\'s move out.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100677,'','Your destiny awaits!',0,0,0,0,0,0,0,0,0,0,0,58238,26124),
(100678,'What trickery is this? No one escapes my cells!','',0,0,0,0,0,0,15,0,0,0,63913,0,26124),
(100679,'Injuries... more severe than I thought... must recover my strength.','',0,0,0,0,0,0,0,0,0,0,63915,0,26124),
(100680,'A scream sounds from the top of the pit.','',0,0,0,0,0,0,0,0,0,0,14987,0,26124),
(100681,'That was Jubeka! The others might yet live!','',0,0,0,0,0,0,0,0,0,0,63916,0,26124),
(100682,'I am... too wounded to go with you, warlock. Find the others. Together... you might survive this.','',0,0,0,0,0,0,0,0,0,0,63917,0,26124),
(100683,'Leave me! Ritssyn Flamescowl is no one\'s burden!','',0,0,0,0,0,0,0,0,0,0,63918,0,26124),
(100684,'The Bloodtotem have always been a treacherous tribe to deal with, but I never expected them to accept the offer of a demon. They must be stopped before they destroy all of Highmountain.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100686,'','I don\'t think I missed a single shot!',1,0,0,0,0,0,1,0,0,0,0,54844,26124),
(100687,'','Hello children. Today we will work on the basics.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100688,'','Now, now. You can\'t run without first learning to walk.  Everyone, get into your stance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100689,'You seem like the type that just wants a fight. If you\'re interested, the Alliance needs more troops.','',0,0,0,0,0,0,0,0,0,36754,0,0,26124),
(100690,'Yes, I agree to fight alongside the Alliance in Ashran. Send me there now!','Yes, I agree to fight alongside the Alliance in Ashran. Send me there now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100691,'Aw, Master Aysa, can we do something else today? I want to learn the spinning crane kick!','Aw, Master Aysa, can we do something else today? I want to learn the spinning crane kick!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100692,'You seem like the type that just wants a fight. If you\'re interested, the Alliance needs more troops.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100693,'I will fight alongside the Alliance in battlegrounds, for now.','I will fight alongside the Alliance in battlegrounds, for now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100694,'','Uh... I\'m not a child.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100695,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] That is the mark of the Soulrenders. Vernus the Sourender once used the blades to tear the souls out of his enemies and feed his own power.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100696,'','Is this the right training session?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100697,'Safety mechanism override... complete. Defensive mode engaged!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100698,'','I think I\'m in the wrong class...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100699,'Brassbolt! You\'re going to short circuit! Get back here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100700,'','Yeah... I\'m pretty sure this isn\'t my training session.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100701,'','You are truly a master strategist.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100706,'','Let the bravest prove victorious!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100707,'','It\'s okay, you can try again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100708,'','Maybe a stronger pet would be better?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100709,'','That last pet seemed a little weak.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100710,'','You\'ll have to work harder to win.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100711,'','Now I am getting serious!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100712,'','That was a warm-up.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100713,'','You fought bravely little one.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100714,'','You must have come a long way, would you like some water?  Oh, a pet battle?  If you insist.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100715,'Go upstairs, Dorian. I\'ll protect the shop.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100716,'You still think me an old man, Jedidiah? If this city\'s going to burn, I\'m going with it.','',273,0,0,2,0,0,0,0,0,0,0,0,26124),
(100717,'Well I\'ll be... you are never boring, old friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100718,'Ready to get your latest recipe. That last one was quite the drink! We ran out of kegs on the first night!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100719,'','I don\'t think Hemet himself could\'ve taught me better. Hopefully he\'ll be impressed with my progress.',1,0,0,0,0,0,1,0,0,0,0,54843,26124),
(100720,'','Show\'s over, everyone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100721,'Awww, shucks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100722,'Teach us what you have learned, $n.','',0,0,0,0,0,0,0,0,0,0,55265,0,26124),
(100723,'Excellent! The latest batch is just outside.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100724,'What\'s that smell? Is that... Illidari?','',0,0,0,0,0,0,0,0,0,0,58230,0,26124),
(100725,'','Arm yourselves, comrades! The council needs our help!',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(100726,'','Horace, take a few of your boys out front.',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(100727,'','Orland, Alard, you\'re with me!',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(100728,'','Do you not see? Kil\'jaeden offers power Illidan never could!',0,0,0,0,0,0,0,0,0,0,0,58239,26124),
(100729,'DEATH IS ALL THAT AWAITS YOU!','',0,0,0,0,0,0,0,0,0,0,58234,0,26124),
(100730,'You heard the lady! Outside, with arms!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100731,'','The demonic energy... I feel deadlier.',0,0,0,0,0,0,0,0,0,0,0,55006,26124),
(100732,'Maiev is alive. For that, I will forever owe you my thanks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100733,'','Our primary goal here is to get the Sargerite Keystone.\n\nWe need to finish up down here and get up onto Tyranna\'s floating command center.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100734,'Allari, these are the secrets I\'ve uncovered.','Allari, these are the secrets I\'ve uncovered.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100735,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] $p, I will help the others to safety. You must complete the hunt!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100736,'Now Huln! While the dragon is weakened.','',0,0,0,0,0,0,0,0,0,0,54878,0,26124),
(100737,'','I don\'t know about you, but I\'m willing to do whatever it takes to survive.\n\nWhat we need is more power!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100738,'Listen closely, Cyana. This is what I learned from the Tome of Fel Secrets.','Listen closely, Cyana. This is what I learned from the Tome of Fel Secrets.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100739,'By the power of the titans, I banish you from this land Earth Warder!','',0,0,0,0,0,0,0,0,0,0,54879,0,26124),
(100740,'','More... I want more power!',0,0,0,0,0,0,0,0,0,0,0,55094,26124),
(100741,'Is it true that $p rescued everyone at the Peak of Serenity all by $ghis:her;self?','Is it true that $p rescued everyone at the Peak of Serenity all by $ghis:her;self?',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(100742,'I\'ve heard that $p can strike so precisely that $ghe:she; can kill a demon with just one finger.','I\'ve heard that $p can strike so precisely that $ghe:she; can kill a demon with just one finger.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(100743,'I\'ve been told that the Master doesn\'t sleep. $gHe:She; fades away into nothingness each night!','I\'ve been told that the Master doesn\'t sleep. $gHe:She; fades away into nothingness each night!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(100744,'I heard that Master $p once fought bare handed against the former Warchief of the Horde for over a year!','I heard that Master $p once fought bare handed against the former Warchief of the Horde for over a year!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(100745,'I\'d love to fight alongside Master $p someday!','I\'d love to fight alongside Master $p someday!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(100746,'I can feel it coursing through my veins. Altering my body.','',0,0,0,0,0,0,0,0,0,0,55258,0,26124),
(100747,'Kayn, I will teach you what I\'ve learned of the demonic mysteries.','Kayn, I will teach you what I\'ve learned of the demonic mysteries.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100748,'','I could destroy the Legion on my own!',0,0,0,0,0,0,0,0,0,0,0,55292,26124),
(100749,'','If it weren\'t for the Black Temple being under attack, I wouldn\'t mind staying here longer.\n\nThere are so many demons to kill.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100750,'Are you ready to learn the Legion\'s secrets, Kor\'vas?','Are you ready to learn the Legion\'s secrets, Kor\'vas?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100751,'','So Huln never backed down, no matter the enemy?',0,0,0,0,0,0,6,0,0,0,0,54880,26124),
(100752,'Mannethrel, prepare yourself. I am going to fill you with the power of the Legion\'s secrets.','Mannethrel, prepare yourself. I am going to fill you with the power of the Legion\'s secrets.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100753,'$n, wait... I can\'t contain the power.','',0,0,0,0,0,0,0,0,0,0,55313,0,26124),
(100754,'Aaaaggggghhhhh!','',0,0,0,0,0,0,0,0,0,0,55312,0,26124),
(100755,'The Skyhorn have tracked the beast to a nearby cave.','',0,0,0,0,0,0,0,0,0,36408,0,0,26124),
(100756,'Good. He must not be allowed to gather his strength so close to our homeland. We must drive him from his lair.','',0,0,0,0,0,0,0,0,0,36408,0,0,26124),
(100758,'The Path of Huln is more than just a tradition of our people. It is the right of passage for any who would carry the mantle of High Chieftain.$b$bIt is a dangerous path, and not all who have aspired to be chieftain have returned.$b$bLet me know when you are ready to depart.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100762,'','They\'re coming for us... it\'s the end of the world!',18,0,0,2,0,0,0,0,0,0,0,0,26124),
(100763,'','Don\'t overreact, Patty. We\'ve got the whole council in residence. We\'ll be ok!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100764,'','Stay hidden, ok? I\'ll keep them out of the shop.',2,0,0,1,0,0,0,0,0,0,0,0,26124),
(100765,'We stand at the precipice of oblivion, but we do not stand alone. Come forward, shaman.','',0,0,0,0,0,0,1,0,0,0,60715,0,26124),
(100766,'','Demons, you\'ve got to answer to Linzy Blackbolt!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100767,'Take your place among the circle, Farseer. The Earthen Ring is forged anew, and with it, we rekindle hope for this world.','',0,0,0,0,0,0,1,0,0,0,60716,0,26124),
(100768,'You are the chosen defender of Azeroth! May your wisdom guide this circle to victory, and may the power of the weapon you wield crush those who would bring chaos to this land.','',0,0,0,0,0,0,1,0,0,0,60717,0,26124),
(100769,'What?! You must have cheated!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100770,'This\'ll be easy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100771,'Ha! You call yourself a pet tamer?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100772,'I always hit my mark.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100773,'Boom, baby!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100774,'Smoked.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100775,'Who sold me this junk?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100776,'I thought this was pay to win!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100777,'Can I still get a refund?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100778,'You look ready for a beating!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100779,'Sorry friend, Cao is clearly the superior fighter. Just look at that form!','Sorry friend, Cao is clearly the superior fighter. Just look at that form!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100780,'Cao has only started training a year ago and he can already take on three of the tiger school at the same time!','Cao has only started training a year ago and he can already take on three of the tiger school at the same time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100781,'Ten gold on Cao.','Ten gold on Cao.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(100782,'The elements have chosen you as their champion, $n. The artifact you wield is proof.$b$bIt is your destiny to lead the Earthen Ring against the Burning Legion. We need you. Do you accept this burden?','',1,6,0,0,0,0,0,0,0,0,0,0,26124),
(100783,'Yes. I will be your Farseer!','Yes. I will be your Farseer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100784,'','You heard the Archmage! Defensive positions!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100785,'Fu Lin\'s got this. His speed is only second to the Master!','Fu Lin\'s got this. His speed is only second to the Master!',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(100786,'His form won\'t mean a thing if he can\'t connect! Fu Lin\'s going to wear him down.','His form won\'t mean a thing if he can\'t connect! Fu Lin\'s going to wear him down.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100787,'I am awake? How is this possible?','',0,0,0,0,0,0,0,0,0,0,57294,0,26124),
(100788,'His speed is like a serpent strike! I wouldn\'t want to face him.','His speed is like a serpent strike! I wouldn\'t want to face him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100789,'I\'ll take that bet and raise you a round of the latest brew at the Laughing Crane.','I\'ll take that bet and raise you a round of the latest brew at the Laughing Crane.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100790,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(100791,'Injured or not, we must fight!','Injured or not, we must fight!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(100792,'To battle!','To battle!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(100793,'We will never surrender.','We will never surrender.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(100794,'Welcome to Stonedark Grotto. It doesn\'t look like much, but it is our home.','',0,0,0,0,0,0,0,0,0,36730,54777,0,26124),
(100795,'It doesn\'t look like much, but it is our home.','',0,0,0,0,0,0,0,0,0,36730,0,0,26124),
(100796,'Here, we live in peace away from the other drogbar.','',0,0,0,0,0,0,0,0,0,36730,54778,0,26124),
(100797,'Stonedark! I have returned! We have this one to thank for saving us from the Bloodtotem.','',0,0,0,0,0,0,1,0,0,36730,54779,0,26124),
(100798,'We will help their cause when it is asked of us.','',0,0,0,0,0,0,0,0,0,36730,54780,0,26124),
(100799,'Oh, and don\'t kill $Ghim:her;.','',0,0,0,0,0,0,0,0,0,36730,54781,0,26124),
(100800,'Wait! Please don\'t hurt Calydus!','',0,0,0,0,0,0,430,0,0,0,63948,0,26124),
(100801,'Beshdal is gone! Calydus sees your power, warlock. Calydus wants to help!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100802,'Calydus is servant to the cruel, cruel Jagganoth. He abuses and mocks poor Calydus. But you! You could be his undoing!','',0,0,0,0,0,0,0,0,0,0,63950,0,26124),
(100803,'Calydus will distract sentries. Find your friends. We will meet again soon!','',0,0,0,0,0,0,1,0,0,0,63951,0,26124),
(100804,'A prisoner has escaped!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100805,'','Ah you\'re awake! Feeling better I hope? You were out for quite a while!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(100806,'','Welcome to Shen-zin Su! I\'m so sorry about what happened to the Peak of Serenity. We of Mandori Village are happy to allow you to stay here.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(100807,'','The other survivors are up at the temple. If you\'re feeling well, then you should head over there.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(100808,'Our people need a leader like Huln. One with the strength and courage to face any obstacle. Qualities you have proven to possess.','',0,0,0,0,0,0,1,0,0,0,54269,0,26124),
(100809,'Let\'s go, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100810,'And so there is one final vision you must witness. This is a secret passed from High Chieftain to High Chieftain since the day Huln banished Deathwing.','',0,0,0,0,0,0,1,0,0,0,61686,0,26124),
(100811,'','That really was a noteworthy hunt! We should head back to camp while it\'s still fresh in my mind.',1,0,0,0,0,0,1,0,0,0,0,54857,26124),
(100812,'','Listen to Sabriana! We\'ll keep you two safe.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100813,'','Get back! Find a place to hide. Let us do the fighting, ok?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100814,'I\'ll ready some supplies for the defenders!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100815,'I gave of my flesh, my soul; my people shun me as a freak.','',0,0,0,0,0,0,1,0,0,0,55450,0,26124),
(100816,'','I live to serve my people, my goddess; expecting neither personal gain nor glory.',0,0,0,0,0,0,66,0,0,0,0,55449,26124),
(100817,'I will serve MY people, the exiled and the reviled.','',0,0,0,0,0,0,1,0,0,0,55448,0,26124),
(100818,'A duel you say? Post haste!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100819,'My nightmare! This is the Junior Argent Tournament all over again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100820,'Back to training for you! Fifty lance squats!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100821,'It seems I have a new nemesis!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100822,'I can do this blindfolded if you prefer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100823,'A valiant effort.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100824,'The tip of the spear is always sharpest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100825,'You can always be my squire.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100826,'Are you ready Sir Murkeston? Fight gallantly!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100827,'Good show! Good show!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100828,'A hammer. Deathwing eats any of my people who get near it.','',0,0,0,0,0,0,1,0,0,0,54882,0,26124),
(100829,'This is a titan waygate. What lies beyond?','',1,0,0,0,0,0,1,0,0,0,54883,0,26124),
(100830,'Step this way, Farseer. The tauren tell of hidden chambers below that may serve as a base of operations.','',0,0,0,0,0,0,1,0,0,0,60718,0,26124),
(100831,'Enough stalling. We must slay the beast and set my people free.','',0,0,0,0,0,0,0,0,0,0,54884,0,26124),
(100832,'Both the hammer and Deathwing were tools of the titans. I doubt I could kill him, but I may be able to banish him.','',1,0,0,0,0,0,0,0,0,0,54885,0,26124),
(100833,'How many years were wasted in that cell?','',0,0,0,0,0,0,0,0,0,0,57343,0,26124),
(100834,'Mayla, I am still the same spiritwalker you have known your entire life. Know that regardless of what happens, I serve the High Chieftain.','',0,0,0,0,0,0,1,0,0,0,62094,0,26124),
(100835,'It seemed in my best interest to not tell the dragonslayers that I was a dragon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100836,'Send me to Shipwreck Cove, please.','Send me to Shipwreck Cove, please.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100837,'','How can I help you?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100838,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] He was was the greatest champion from one of the first worlds Sargeras destroyed, and one of the only beings to ever wound him in combat.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100839,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] That is why we must complete the hunt. The baldeswill allow us to destroy the Legion\'s foul masters for good.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100840,'','Get away. You cannot have my tome!',0,0,0,0,0,0,0,0,0,0,0,55338,26124),
(100841,'','They\'re stealing our secrets, my queen...',0,0,0,0,0,0,0,0,0,0,0,55339,26124),
(100842,'','Recover that tome at all costs, my minions!',0,0,0,0,0,0,0,0,0,0,0,55066,26124),
(100843,'Yeah! Let\'s DO THIS!','',0,0,0,0,0,0,0,0,0,36548,0,0,26124),
(100844,'','I WILL claim your soul, even if I have to tear it from your lifeless corpse!',0,0,0,0,0,0,0,0,0,0,0,58240,26124),
(100845,'','I will... be... reborn...',0,0,0,0,0,0,0,0,0,0,0,58241,26124),
(100846,'','For every soul I claim, my power grows. I will rule this world... ALL worlds!',0,0,0,0,0,0,0,0,0,0,0,58236,26124),
(100847,'','WITNESS THE MIGHT OF THE ALDRACHI!',0,0,0,0,0,0,0,0,0,0,0,58237,26124),
(100848,'','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-INSTRUCTOR MALICIA.blp:50:80|t$b[Caria Felsoul] I will claim every soul on this pathetic world.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100849,'Ha! Aviash didn\'t drop you into the river on your way here. Good! That means he is starting to like you.$b$bShall we get this ceremony over with?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100850,'Good! I am not one for ceremony so let\'s get this over with.','',0,0,0,0,0,0,0,0,0,0,54327,0,26124),
(100851,'I have already ordered my eagle riders to make for Thunder Totem. You may find the air a bit thicker with feathers soon.','',0,0,0,0,0,0,0,0,0,0,54325,0,26124),
(100852,'Let it be known that I, Lasan Skyhorn, Chieftain of the Skyhorn tribe, once again declare my allegiance to Highmountain.','',0,0,0,0,0,0,0,0,0,0,54324,0,26124),
(100853,'Together, we are Highmountain.','',0,0,0,0,0,0,0,0,0,0,54323,0,26124),
(100854,'$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] $p, let\'s get out of here before more demons arrive.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100855,'When you fight the ocean, the ocean always wins.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100856,'Sun\'s out! Pets out!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100857,'My guys need more time out on the water I think.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100858,'A storm is coming!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100859,'Waves crash and I crush!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100860,'You need more training before you paddle out.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100861,'Not every wave is a winner.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100862,'Wipe out!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100863,'Rub some sand in it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100864,'There\'s no surf, so the only thing left to do is battle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100865,'','Is that the best you\'ve got, demon? I thought your kind knew how to torture. Pathetic!',0,0,0,0,0,0,0,0,0,0,0,63942,26124),
(100866,'Savor your words while your mind can still form them, worm!','',0,0,0,0,0,0,0,0,0,0,63943,0,26124),
(100867,'','I appreciate the assistance, warlock. These demons are dreadfully boring.',0,0,0,0,0,0,0,0,0,0,0,63944,26124),
(100868,'Your silence cannot last forever, worgen!','',0,0,0,0,0,0,0,0,0,0,63945,0,26124),
(100869,'...','',0,0,0,0,0,0,0,0,0,0,558,0,26124),
(100870,'Yes... I can feel your mind breaking.','',0,0,0,0,0,0,0,0,0,0,63946,0,26124),
(100871,'','I was... nearly food for the hounds. Thank you.',0,0,0,0,0,0,0,0,0,0,0,63947,26124),
(100873,'Not today!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100874,'This one\'s mine.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100875,'Do not be afraid! This is not the first time Talendris has been under attack and I assure you it will not be the last!','',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(100876,'We must hold strong! We cannot allow the Point to fall!','',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(100877,'I\'ll be alright. Tend to the others.','I\'ll be alright. Tend to the others.',0,0,0,0,0,0,396,7,0,0,0,0,26124),
(100878,'Defend the Point!','Defend the Point!',0,0,0,0,0,0,396,7,0,0,0,0,26124),
(100879,'The glaives! Use the glaives!','The glaives! Use the glaives!',0,0,0,0,0,0,396,7,0,0,0,0,26124),
(100880,'Reuse','Reuse',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100881,'Reuse','Reuse',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100882,'Reuse','Reuse',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100883,'','Oculeth!',0,0,0,0,0,0,0,0,0,0,0,67243,26124),
(100884,'Archmage Khadgar! I\'ve been meaning to talk to you. I feel my contributions--','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100885,'The demon hunters? What do--','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100886,'Sir, I think this is an excellent--','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100887,'Yes sir! I have some wonderful ideas for Illidari uniforms!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100888,'Now where is he? I saw him milling about just a while ago. STARSINGER!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100889,'Yes, yes, we\'ll discuss that later. I\'ve received a request from the Illidari for your services.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100890,'You\'re to report to Allari the Souleater in Azsuna. Right away.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100891,'Right away!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100892,'Uniforms? For the Light\'s sake...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100893,'','Wait... where is Ritssyn?',0,0,0,0,0,0,0,0,0,0,0,63895,26124),
(100894,'','The orc was gravely injured and cannot follow. No matter. We four should suffice to control that pit lord. That is still our goal, yes?',0,0,0,0,0,0,0,0,0,0,0,63896,26124),
(100895,'...','',0,0,0,0,0,0,0,0,0,0,558,0,26124),
(100896,'','Fine, stubborn worgen! Escape shall be our first priority. But if the opportunity to enslave the demon presents itself, I say we take it!',0,0,0,0,0,0,0,0,0,0,0,63897,26124),
(100897,'','Then it\'s decided. Let\'s keep moving.',0,0,0,0,0,0,0,0,0,0,0,63898,26124),
(100898,'$n, over here. It\'s been far too long since we\'ve been on a proper hunt. Wouldn\'t you agree?','',0,0,0,0,0,0,1,0,0,0,58217,0,26124),
(100899,'I would prefer not to let you live, mortal!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100900,'Once we\'ve rid the area of these intruders, we can commence our removal of the night elves from our land.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100901,'What\'s going on down here?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100902,'You really think you can escape? I will crush you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100905,'Now that that\'s settled, $n, I have some Kirin Tor business to handle. Be well.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100906,'Jace, Allari, Kor\'vas, Altruis - we leave at once. Enforcers - ensure we are not followed.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(100907,'This way! Over here!','',0,0,0,0,0,0,0,0,0,0,63899,0,26124),
(100908,'','What is this miserable creature?',0,0,0,0,0,0,6,0,0,0,0,63900,26124),
(100909,'Calydus is a friend, you will see! Jagganoth hunts powerful weapons. Friend could use these weapons to rule this place!','',0,0,0,0,0,0,0,0,0,0,63901,0,26124),
(100910,'Jagganoth hunts powerful weapons that are dangerous to the Legion. If you get one, even mighty Jagganoth will fall before you! You will rule this place, with Calydus beside you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100911,'','Rule? I like the sound of that.',0,0,0,0,0,0,1,0,0,0,0,63903,26124),
(100912,'','Slow down, Shinfel. How do we know we can trust this thing?',0,0,0,0,0,0,1,0,0,0,0,63904,26124),
(100913,'You must trust Calydus! Come to the archives! It\'s not far!','',0,0,0,0,0,0,0,0,0,0,63905,0,26124),
(100914,'Now that was a proper hunt!','',0,0,0,0,0,0,11,0,0,0,58216,0,26124),
(100915,'','An\'ah!',0,0,0,0,0,0,0,0,0,0,0,67546,26124),
(100916,'','Rath!',0,0,0,0,0,0,0,0,0,0,0,67542,26124),
(100917,'Inside this long-abandoned house, you feel the flicker of fading enchantments.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100918,'Die!','',0,0,0,0,0,0,0,0,0,0,67548,0,26124),
(100919,'Gah! A time stop spell... She will pay for that!','',0,0,0,0,0,0,0,0,0,0,67549,0,26124),
(100920,'','Who awakens me after all this time?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100921,'This is not your business, outlander. Thalyssra has betrayed the Grand Magistrix and must be put down!','',0,0,0,0,0,0,0,0,0,0,67550,0,26124),
(100924,'Witness the power of the Nightborne!','',0,0,0,0,0,0,0,0,0,0,67551,0,26124),
(100925,'Who... are you?','',0,0,0,0,0,0,0,0,0,0,67552,0,26124),
(100926,'','$n, I need to speak with you.',0,0,0,0,0,0,1,0,0,0,0,64599,26124),
(100927,'','Kayn and the others await you at Krasus\' Landing. I\'ll meet you there.',0,0,0,0,0,0,1,0,0,36911,0,58224,26124),
(100928,'What... are... we?!','',0,0,0,0,0,0,0,0,0,0,54639,0,26124),
(100929,'Your death is fated!','',0,0,0,0,0,0,0,0,0,0,65814,0,26124),
(100930,'Our magic will break you!','',0,0,0,0,0,0,0,0,0,0,65817,0,26124),
(100931,'Your age has ended!','',0,0,0,0,0,0,0,0,0,0,65799,0,26124),
(100932,'Scum like you should obey your betters.','',0,0,0,0,0,0,0,0,0,0,65800,0,26124),
(100933,'The shal\'dorei will rule!','',0,0,0,0,0,0,0,0,0,0,65801,0,26124),
(100934,'Die, outlander!','',0,0,0,0,0,0,0,0,0,0,65820,0,26124),
(100935,'Anath\'ashar!','',0,0,0,0,0,0,0,0,0,0,65818,0,26124),
(100936,'No... Mannethrel.','',0,0,0,0,0,0,0,0,0,0,55262,0,26124),
(100937,'Light... save me...','Light... save me...',0,0,0,0,0,0,0,0,0,924,0,0,26124),
(100938,'Lok\'tar... ogar...','Lok\'tar... ogar...',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(100939,'','I should be focused on readying the casks for the queen. Why do I feel so... unsettled?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(100940,'The demon has been slain! Ensure the remaining attackers are disposed of and we may begin to rebuild.','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(100941,'We are in your debt, champions.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100942,'The monstrosity is dead! Ready yourselves! We\'re not through it just yet.','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(100943,'This... this hunger...','',0,0,0,0,0,0,0,0,0,0,54509,0,26124),
(100944,'YOU! Join us!','',0,0,0,0,0,0,0,0,0,0,54562,0,26124),
(100945,'We will continue our plans when this is over.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100946,'','Greetings, $n. I trust this projection is clear! This is Modera, Archmage of the Council of Six. I\'ve come across a lead on a weapon that could significantly aid your fight against the Legion.',0,0,0,0,0,0,0,0,0,0,0,60478,26124),
(100947,'','My source is... well... unable to join us within the city. I ask that you meet with me at the crater of Dalaran\'s foundation in Hillsbrad.',0,0,0,0,0,0,0,0,0,0,0,60479,26124),
(100948,'','I await your arrival.',0,0,0,0,0,0,0,0,0,0,0,60481,26124),
(100949,'I\'ve had enough of this for now. I ain\'t gonna die out here today!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100950,'These wicked vermin must not prevail over my precious grove.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100951,'','$p! Need a ride?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100952,'Whoa! Hey, $gguy:lady;! Hold up! Got a delivery for ya.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(100953,'Thanks for using Steamwheedle Express!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(100954,'Later, sucker!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(100955,'','The demon has been secured.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100956,'How\'s my little buddy doing?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100957,'Consume! Devour!','',0,0,0,0,0,0,0,0,0,0,54518,0,26124),
(100958,'Ain\'t no uninvited guests gettin\' into our house. Not today... not ever!','',22,0,0,3,0,0,0,0,0,0,0,0,26124),
(100959,'We got more where that came from!','',22,0,0,3,0,0,0,0,0,0,0,0,26124),
(100960,'If we run out of ammunitions, start throwin\' wrenches, boys!','',22,0,0,3,0,0,0,0,0,0,0,0,26124),
(100961,'Leyota, daughter of Garhan the Great, followed in her father\'s footsteps as one of the greatest leatherworkers of Highmountain. Yet her greatest achievement was her willingness to go against the grain and change the old ways.$b$bWhen Garhan had passed, all eyes looked to Leyota to carry on his tradition. She spoke to the elders of the tribe, \"My people, long have we hunted these lands, and its bounty has given us food, shelter and protection.\"$b$b\"But we are wasteful,\" she continued, \"We bury our kills with their teeth, their hooves, their claws.\"','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100962,'\"It is our ways,\" one elder spoke up, \"We leave their spirits with their weapons so they may hunt in the next realm. It is a sign of respect, Leyota. You know this.\"$b$b\"I see it differently, elder. Do we not show respect by ensuring that our prey\'s death was not in vain?\" she asked. \"Should we not use everything it has to offer? We can strengthen our armor two-fold if we used the rest of the animal in our construction.\"$b$bThe elders spoke silently for a moment amongst themselves then looked up to Leyota.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100963,'It would be far better to die in battle than to toil away all the years of my life producing arms and armor for... whatever this is that Gul\'dan has done to my brothers and sisters.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100964,'Down there! Keep \'em comin\'!','',22,0,0,3,0,0,0,0,0,0,0,0,26124),
(100965,'\"To change tradition, is to change our way of life. We do not believe that adding those components to ones armor will do anything for it save to make it look disrespectful to the animal from whom it came.\"$b$bLeyota\'s brow raised as the elders continued, \"We are sorry, Leyota, but we will not allow you to spoil our armor in such a way. If your quest is to strengthen our armor, you will have to find another way.\"$b$bThe elder\'s left the tent, leaving a frustrated Leyota to think.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100966,'They might have magic, but we got dynamite!','',22,0,0,3,0,0,0,0,0,0,0,0,26124),
(100967,'What dat green-skinned cripple did to dis jungle is terrible. Not even ogres are dis bad about ruining da world!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100968,'Ah, the smell of gunpowder and explosions.','',22,0,0,3,0,0,0,0,0,0,0,0,26124),
(100969,'','I don\'t know. I\'ve got a bad feeling about this.',0,0,0,0,0,0,0,0,0,0,0,63906,26124),
(100970,'','It would appear the pit lord is planning an invasion.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(100971,'Ready your weapons, children of my wrath! Tonight we strike at the heart of the mortals\' defenses!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(100972,'Join us... join us forever...','',0,0,0,0,0,0,0,0,0,0,53874,0,26124),
(100973,'','Oh no... the portal!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(100974,'...','',0,0,0,0,0,0,0,0,4,0,21449,0,26124),
(100975,'The next day, Leyota emerged from her tent wearing an unusual set of armor. Everyone looked at her quizically as she approached the center of the camp.$b$b\"This armor is made with the teeth and claws of a bristlefur bear I killed the other day.\" Shocked looks came over the people of the tribe as the realization of what she had done sunk in.$b$b\"I challenge any of our warriors to run me through, if they can.\" The tribes people looked around at one another, unsure to what to make of Leyota\'s challenge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100976,'','They must have linked their gateway to our summoning portal. They plan to attack Dalaran! We need to close that portal!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(100978,'','Assuming we can even reach the gateway...',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(100979,'Die. Die. Die.','',0,0,0,0,0,0,0,0,0,0,53873,0,26124),
(100980,'I will swallow your soul.','',0,0,0,0,0,0,0,0,0,0,53872,0,26124),
(100981,'Your soul is mine.','',0,0,0,0,0,0,0,0,0,0,53871,0,26124),
(100982,'\"Leyota!\", a voice yelled from the crowd. A young brave emerged with a spear in hand, \"I\'ll take your challenge. You have committed a great disrespect to our ways by what you have done. It would be my honor to send your spirit away from here.\"$b$bThe brave rushed at Leyota, yet she didn\'t move a muscle. The spear tip came into contact with her chest, right where her heart was and sent her falling to the ground with the weight of the brave behind it. As the dust settled, an unusual sight emerged. The spear had not penetrated the armor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100983,'The brave stood up, still clutching his spear and began to examine the tip. It was slightly bent.$b$bHe looked down at Leyota and she lay there, clutching at her chest, yet there was no blood to be seen. After a while, Leyota stood up, breathing heavily, but appearing unharmed. \"This is what I wanted to show you!\" she announced. \"The animal that I slew was given no disrespect as its life and its body was taken to protect me.\"$b$bThe tribe had fallen silent now, all eyes and ears paying full attention to what Leyota had to say.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100984,'OoooooooOoooo.','',0,0,0,0,0,0,0,0,0,0,53870,0,26124),
(100985,'Flesh... give me your flesh.','',0,0,0,0,0,0,0,0,0,0,53869,0,26124),
(100986,'Death... death shall take you.','',0,0,0,0,0,0,0,0,0,0,53868,0,26124),
(100987,'Death is only the beginning...','',0,0,0,0,0,0,0,0,0,0,53867,0,26124),
(100988,'\"The animals we kill can protect all of us in this way, if you\'ll let me continue to make our armor this way.\" she continued.$b$bAn elder emerged from the crowd and approached Leyota. He examined her armor, especially the point at which the spear had struck.$b$bHe nodded his head as he spoke, \"I understand now, Leyota. There is no vanity here, just strength.\"$b$bHe turned round to the tribe and said, \"Leyota has given us a stronger future. Our tribe will not fall so easily to those we hunt, or those who hunt us. And we will continue to honor our animal brothers and sisters in their death by the armor we wear.\"','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100989,'And so it was, that Leyota, daughter of Garhan had changed the ways of the past for her people. To this day, the leather armor of Highmountain continues to use nearly all of the animal to give it its strength.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(100990,'','Due to the sensitive nature of this matter, I must ask for your discretion. If you attempt to speak to me at any other location, I will disavow all knowledge of this message!',0,0,0,0,0,0,0,0,0,0,0,60480,26124),
(100992,'Off with you, then. Find me some cliffthorn.','',0,0,0,0,0,0,0,0,0,0,65625,0,26124),
(100993,'I feed on your essence...','',0,0,0,0,0,0,0,0,0,0,54522,0,26124),
(100994,'Leave this meager vessel, and join us...','',0,0,0,0,0,0,0,0,0,0,54564,0,26124),
(100995,'The harvest has come!','',0,0,0,0,0,0,0,0,0,0,54516,0,26124),
(100997,'Ancient souls of the Black Rook, rise and join our chorus!','',0,0,0,0,0,0,0,0,0,0,54563,0,26124),
(100998,'This energy... it is too much!','',0,0,0,0,0,0,0,0,0,0,54521,0,26124),
(100999,'','Welcome, $n. I\'m glad you received my message.',0,0,0,0,0,0,0,0,0,0,0,60492,26124),
(101000,'Free! I...','',0,0,0,0,0,0,0,0,0,0,54565,0,26124),
(101001,'','We are... why are we here?!',0,0,0,0,0,0,0,0,0,0,0,54556,26124),
(101002,'Demons! You did this to us!','',0,0,0,0,0,0,0,0,0,0,54560,0,26124),
(101003,'Now... now I see...','',0,0,0,0,0,0,0,0,0,0,54508,0,26124),
(101004,'','The darkness... it is gone.',0,0,0,0,0,0,0,0,0,0,0,54520,26124),
(101005,'You... aren\'t the ones who did this?','',0,0,0,0,0,0,0,0,0,0,54550,0,26124),
(101006,'Nobody touch it! Not until our guest arrives.','',0,0,0,0,0,0,1,0,0,0,67263,0,26124),
(101007,'I... understand now. You... you must find Kur\'talos. You must put a stop to this.','',0,0,0,0,0,0,0,0,0,0,54558,0,26124),
(101008,'Here - father showed me this passage! Take it, and find him!','',0,0,0,0,0,0,0,0,0,0,54559,0,26124),
(101009,'','As for us... we do not belong here. Farewell, and may Elune\'s light guide you.',0,0,0,0,0,0,0,0,0,0,0,54557,26124),
(101010,'Thank you both for meeting me in such an inhospitable location. I assure you that if I were able to join you in Dalaran, I would.','',0,0,0,0,0,0,0,0,0,0,60495,0,26124),
(101011,'Precisely why I\'m here. If I can\'t return to my former position, then perhaps the council will at least consider restoring my access to the city. As a show of good faith, I have information to offer.','',0,0,0,0,0,0,0,0,0,0,60497,0,26124),
(101012,'I once knew Lyandra Sunstrider, a distant relative of King Anasterian. Though she bore the Sunstrider name, in truth her branch of the family held no claim to the throne.','',0,0,0,0,0,0,0,0,0,0,60500,0,26124),
(101013,'After Kael\'thas\'s betrayal, she became obsessed with finding Felo\'melorn to claim it for her own. I told her it was a fool\'s errand, that she\'d never find the relic. Indeed, it has been many years since I last heard from her.','',0,0,0,0,0,0,0,0,0,0,60501,0,26124),
(101014,'Thank you, stranger!','Thank you, stranger!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101015,'Where did all these drogbar come from?!','Where did all these drogbar come from?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101016,'You saved my life!','You saved my life!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101017,'I\'m getting out of here!','I\'m getting out of here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101018,'You wield such power!','You wield such power!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101019,'Thank you!','Thank you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101020,'I thought I was going to die!','I thought I was going to die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101021,'May the Earthmother bless you!','May the Earthmother bless you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101022,'','Moozy! Oh, thank the Earthmother that you are okay! Bless you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101023,'The prisoners are escaping! After them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101024,'Worthless minions! I\'ll take care of you myself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101025,'The portal will take you directly inside Icecrown. Hurry, it won\'t last long! I\'ll follow after you as soon as I can.','',274,0,0,0,0,0,0,0,0,0,60493,0,26124),
(101026,'The Alliance will be ready. I\'ll sound the alarm throughout the Silver Enclave.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101027,'The Legion! They\'re already upon us. Spread out, cover the Enclave. Send these Demons back to the hells from which they\'ve come!','',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(101028,'Rulen, you take the tavern. Selone, you handle the upper level. Everyone else, find a defensible location!','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(101029,'Stefen, Isirami, get everyone to the cellar! The Legion are coming to stop Archmage Khadgar!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101030,'','More reinforcements! Ready your spells!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101031,'Invaders have breached the passage to the crypts. Illysanna, you must hold them here.','',0,0,0,0,0,0,0,0,0,0,54567,0,26124),
(101032,'Look at the city, $r. It is beautiful, and it is tragic.$b$bWe were cowards to hide beneath that shield. Azeroth was in our care, and we chose to abandon her. We failed our sacred duty to protect the world, and our shame is too great.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101033,'There is another way, Thaedris. We have a refuge not far from here. Thalyssra is there.','There is another way, Thaedris. We have a refuge not far from here. Thalyssra is there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101034,'','Follow me, everyone! Hurry, give the guards some space!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101035,'','Stay safe, Rulen. Thank you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101036,'Thalyssra escaped? She always was one of the more rational ones. I am glad that she did not stay and join the Grand Magistrix in her road to damnation.$b$bStill, it is hopeless. Our allies are few and scattered, and our enemy has gained a powerful one. We cannot possibly stop their combined forces.$b$bCome now. There is much to be done if you would earn my coin.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101037,'We\'ve got your back, $n.','',0,0,0,0,0,0,0,0,0,0,55271,0,26124),
(101038,'Hurry up with that portal, man\'ari! Jagganoth hungers for the blood of these mortals.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101039,'Don\'t be a fool! The portal isn\'t yet stable enough for an army.  Do you wish to be lost to the Twisting Nether?','Don\'t be a fool! The portal isn\'t yet stable enough for an army.  Do you wish to be lost to the Twisting Nether?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101040,'','The key! They\'re using it to stabilize the portal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101041,'','I guess we\'ll just have to take it, then.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101042,'','The Rivermane are not a warlike tribe, but this trespass of our sacred cavern will not go unpunished. The drogbar will know the power of water magic.\n\nWith age comes wisdom, and with wisdom comes power!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101043,'What are you waiting for? Crush them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101044,'Good luck, hero!','',0,0,0,0,0,0,0,0,0,0,60494,0,26124),
(101045,'Kneel before your new masters!','',0,0,0,0,0,0,0,0,0,0,54810,0,26124),
(101046,'You will never defeat us! We are Legion!','',0,0,0,0,0,0,0,0,0,0,54811,0,26124),
(101047,'Your world is ours now!','',0,0,0,0,0,0,0,0,0,0,54812,0,26124),
(101048,'You will not stop me! I will not fail!','',0,0,0,0,0,0,0,0,0,0,54813,0,26124),
(101049,'We have much to lose - your father\'s life, most of all.','',0,0,0,0,0,0,0,0,0,0,54552,0,26124),
(101050,'Hah, nicely done! Maybe now they\'ll think twice about who they\'re messin\' with.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101051,'Er... did, uh... did you feel that?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101052,'Ayep! That\'s definitely the ground shakin\'!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101053,'Southern wall - Incoming!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101054,'You do not belong here, $c.','You do not belong here, $c.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101055,'Begone!','Begone!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101056,'','The Earthmother will receive your corpse!',0,0,0,0,0,0,0,0,0,0,0,54751,26124),
(101057,'','The water will wash over you!',0,0,0,0,0,0,0,0,0,0,0,54752,26124),
(101058,'','Get out of my cavern! I didn\'t spend a lifetime nurturing its magic only to hand it to you upstarts!',0,0,0,0,0,0,0,0,0,0,0,54742,26124),
(101059,'','This is it! Let\'s see if we can make this portal a little less stable!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101060,'','Return to the depths! Ow! My back!',0,0,0,0,0,0,0,0,0,0,0,54753,26124),
(101061,'','Your magic is weak here!',0,0,0,0,0,0,0,0,0,0,0,54754,26124),
(101062,'','They\'re trying to disrupt our channeling! Stop them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101063,'','It\'s working, we just need more time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101064,'','We tried peace, now we try war!',0,0,0,0,0,0,0,0,0,0,0,54755,26124),
(101065,'','I\'m getting too old for this.',0,0,0,0,0,0,0,0,0,0,0,54743,26124),
(101066,'','For the Rivermane! ... Did you say something? Speak up!',0,0,0,0,0,0,0,0,0,0,0,54756,26124),
(101067,'That the best you got? And here I thought my guys would have to work for what little pay they earn...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101068,'Leave the Sunreavers to me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101069,'Defenders of the Horde, we have visitors from the Burning Legion. Let us not leave them unattended!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101070,'Little goblin - your ignorance reeks of mortality.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101071,'Enough of this foolishness.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101072,'...spoke too soon. Northern side! Watch out!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101073,'I will await you in a lodge on the southwestern bluff. I advise against delay.','',0,0,0,0,0,0,0,0,0,0,54330,0,26124),
(101074,'If yer looking for mail armor, look no further! I\'ve got the best in town!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101075,'Do you happen to have an extra crowbar?','Do you happen to have an extra crowbar?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101076,'Here are your stands. May I have the crowbar now?','Here are your stands. May I have the crowbar now?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101077,'Ye think I\'m just gonna give one out fer free? Sorry $glad:lass;, but you gotta give something to get something.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101078,'I\'d be willing to part with a crowbar for some new armor stands. Imindril Spearsong over at Tanks for Everything has some handy.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101079,'Get those fer me and we\'ve got a deal.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101080,'Yeah yeah. The spirits are important to ya. I get it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101081,'I\'ll be honest. I\'m here cause ya mentioned Khaz\'goroth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101082,'Took ye long enough. Stop for a pint on your way back, did ye? One crowbar, as we agreed.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101083,'','This way, sisters!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101084,'','Welcome to Tanks for Everything. We have the finest in all your blacksmithing and mining needs.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101085,'If you are as powerful as you believe, then perhaps you may prove more worthy of the sword than the last mage who came to claim it.','',0,0,0,0,0,0,0,0,1,0,60507,0,26124),
(101086,'Do you have any armor stands you could part with?','Do you have any armor stands you could part with?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101087,'Here is your dress. Can I have the armor stands now?','Here is your dress. Can I have the armor stands now?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101088,'','I do have some extra, but I\'m not really willing to part with them. Unless...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101089,'','Would you be willing to run a quick errand for me? Do it and I\'ll promise I\'ll give you some armor stands.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101090,'','I just need you to take my dress over to Shandy to have cleaned. It has soot all over it.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101091,'','That Shandy... he sure does know how to get the blood and gore out! Here are those armor stands I promised you.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101092,'But be warned! I will not be responsible for the fate which befalls you... any more than I was for what happened to the last seeker who hoped to take my relic.','',0,0,0,0,0,0,0,0,1,0,53944,0,26124),
(101093,'Can you clean this dress for me, Shandy?','Can you clean this dress for me, Shandy?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101094,'Pay the 2 gold.','Pay the 2 gold.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101095,'Sure I can clean that for you. I charge 2 gold per garment.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101096,'I\'ll get this cleaned for you in a jiffy!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101097,'One dress, clean as new. Thank you for your business.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101098,'','Are we taking bets on how long the gnome lasts?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(101099,'Mayla, this is something your father made me promise I would do for you. Please, your people need this. You need this.','',1,0,0,0,0,0,0,0,0,0,54888,0,26124),
(101100,'I dunno what them tauren were huffin, but these ain\'t no spirits. These are time echoes. Somethin\' bad happened here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101101,'I... obey...','',0,0,0,0,0,0,0,0,0,0,63914,0,26124),
(101102,'Push \'em back! We have to hold out a bit longer!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101103,'Runnin\' low on fuel!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101104,'I don\'t know how much longer I can keep them out of the harbor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101105,'They keep clippin\' my wings! Not sure how much longer I can keep her in the air.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101106,'They just keep coming!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101107,'We gotta clear \'em out, boys! The ground forces are getting overwhelmed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101108,'This is what we trained for!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101109,'Born to fly! Live or die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101110,'Alright, Aquanos, you\'re up!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101111,'','Take your boots off and rest a while. Nothin\' beats sleepin\' under the stars.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(101112,'That was close.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101113,'The threat over here at the Harbor has been... reduced, to say the least. We can manage from here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101114,'Are these ronir giving you too much trouble, Gelmogg?','',0,0,0,0,0,0,0,0,0,0,54773,0,26124),
(101115,'Perhaps I misjudged your worth...','',0,0,0,0,0,0,0,0,0,0,54774,0,26124),
(101116,'When you\'re done with this distraction, meet us in Riverbend.','',0,0,0,0,0,0,0,0,0,0,54775,0,26124),
(101117,'','While the arkhana will allow me to do most of the work, I\'ll still need a stronger reagent for the final word. A leylight shard, to be exact.$b$bNow, let\'s put those big, scary demon words to work!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(101118,'','Meet me at Riverbend as soon as you can, $n. I\'ll meet you there--my old bones don\'t move like they used to.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101119,'INFERNALS!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101120,'Your soul is mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101121,'The legion will devour you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101122,'','You need not worry. I will not fail, Latosius.',0,0,0,0,0,0,0,0,0,0,0,54566,26124),
(101123,'Foolish mortal! You are mine now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101124,'Well now, if this ain\'t the spot I dunna know what is. Looks Like back in Deathwing\'s day he gathered up all sorts of stuff.$b$bLet me know when you are ready and we can see what defenses that old wyrm left in place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101125,'You cannot escape... legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101126,'The legion is... eternal!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101127,'','You step into the land of the dead, mortal. The Lich King has decreed that the living shall not enter Icecrown!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101128,'This world will... burn...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101130,'','Men! The invaders come for us. Do not let them pass! For Kalimdor!',0,0,0,0,0,0,0,0,0,0,0,54511,26124),
(101131,'What are these mortals doing here? Guards, seize them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101132,'','We will bury you here, fools.',0,0,0,0,0,0,0,0,0,0,0,54515,26124),
(101133,'From this map you may dispatch members of the Earthen Ring throughout the Broken Isles. Lead us to victory, Farseer!','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(101134,'This Astral Portal will return you to Dalaran whenever you wish, Farseer. I will keep it open so that you may return here any time.','',0,0,0,0,0,0,1,0,0,0,60714,0,26124),
(101135,'Be sure to see me again after you\'ve gained further renown in the Broken Isles, $n. There is more for us to do!','',1,0,0,0,0,0,0,0,0,36663,0,0,26124),
(101136,'It just took hold of me... I\'ve never felt anything like that before.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101137,'I\'ll hold out here \'til it\'s over.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101138,'A stranger from another land has come to honor my name? I\'m pleased to see this. The knowledge I have to pass on to you is that of totality.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101139,'Some believe the journey is most important, while others believe it\'s the destination.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101140,'A true master knows that the experience in its entirety is what fuels the mind. Never forget the beginning simply because you have reached the end.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101141,'This cave belongs to the Murkloc tribe!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101142,'This is for your help.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101143,'Make sure you send those demons our regards.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101144,'','You show honor through your deeds.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101145,'','Be vigilant and guard against corruption.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101146,'','May you always strive for balance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101147,'','My blessings to you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101148,'You cannot use Spymaster Jenri\'s Scope on a target with that debuff.','You cannot use Spymaster Jenri\'s Scope on a target with that debuff.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101149,'So, Deathwing wants this titan hammer kept secret? Perhaps this is the weapon we need to challenge the beast.','',0,0,0,0,0,0,1,0,0,0,61687,0,26124),
(101150,'Looks like ol\' Deathwing left the automated defenses on. Watch me back.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101151,'Try aimin\' fer the titan defenders. Them orbs are what are holdin\' the portals open.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101152,'Alright! That should be enough. I\'ll meet ya near the exit to this dragon hole.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101154,'','Awaken, Gorewing! Tear my foe asunder!',0,0,0,0,0,0,0,0,0,0,0,53964,26124),
(101155,'','Your respect is humbly received, $r. The wisdom I grant to those who honor me is frugality.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101156,'','Do not throw away the scrap simply because you don\'t see an immediate use for it.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101157,'','$n, thank you for coming. Through this hall you can see the history of my people. A history I have been part of for the better part of a century.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101158,'','We have a history of both harvest and war. Never are we stronger than when together with the other tribes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101159,'','Ah, Thunder Totem. This feels right. My knees? Not so right.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101160,'','Let it be known that I, Jale Rivermane, Chieftain of the Rivermane tribe, declare my allegiance to Highmountain once again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101161,'','Together, we are Highmountain!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101162,'Selentia wails, calling forth ancient keepers!','Selentia wails, calling forth ancient keepers!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101163,'','Many small things will always add up to something bigger, and often just as strong.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101164,'','With the drogbar threat to my people quelled, we are happy to rejoin Mayla Highmountain\'s cause. I am ready to begin the ritual when you are.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101165,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101166,'Respect is paid, and knowledge is given. Hear now my lesson of flexibility.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101167,'The same methods one uses to shape one\'s leather can also be used to shape one\'s spirit and mind.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101168,'The sooner I crush you the faster I go back to sleep!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101169,'Confidence in your conclusions will give you strength, but fluidity with your actions will grant you wisdom.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101171,'Sleep... at last....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101172,'Give me one reason not to let Talas here rip yer wings off and beat ya with \'em.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101173,'Look, that incident with Iron Horde was just a misunderstanding. Garrosh was supposed to convince them to fight the Burning Legion, not invade Azeroth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101174,'Bah. Never trust a dragon. At least he showed us a way out. Once we get these disks back to Ironforge I\'ll be able to really dig into them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101175,'Please find Moozy. I will try to recover and search as well. If you find him, take him to his mother upriver.','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(101176,'$n! I found you! The four winds have been sent to seek you out. Come with me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101177,'%s gestures toward Thrall.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101178,'What do you want, puny creature? You want a lesson? Okay, I\'ll give you a lesson.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101179,'','You\'re not the only one with minions, demon!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101180,'','Make sure you give those demons what\'s comin\'!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101181,'','Nice of you to show up. Haven\'t seen much backup yet.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101182,'','Some kinda party, eh? So many uninvited guests.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101183,'','Be nice when things are back to normal \'round here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101184,'You said it, sister!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101185,'Couldn\'t have said it better myself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101186,'','Fall before me!',0,0,0,0,0,0,0,0,0,0,0,54638,26124),
(101187,'Never work with hides that are still attached to the animal. Especially if it\'s alive. Just trust me on this.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101188,'That is all.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101189,'Learn our stories, outlander. They carry great meaning.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(101190,'','Now might be a good time, Zinnin...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101191,'Your soul will burn!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101192,'This world will... perish...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101193,'We are... infinite...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101194,'','You can not escape.',0,0,0,0,0,0,0,0,0,0,0,54561,26124),
(101195,'','Brothers and sisters! The temple - it must be preserved!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101196,'','They desecrate our ruins!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101197,'This memorial is not as grand or famous as the others here, but it holds special importance for me. Within lies Lady Latara, a consummate huntress and my wife. Oh, how I miss her.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101198,'Destroy the intruders!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101200,'','The Mindbenders! Do not give in!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101201,'','Zin-Malor is ours!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101203,'Do not be afraid, for I am not. I will soon be reunited with my lady love. These heroes that surround you were men and women just like me. They too had their own loves and vices, and they understood the meaning of sacrifice. Let this be mine.$b$b<Thaedris sighs.>$b$bPerhaps you are right, $n. I have been so tired and weary with the shame of our people. I believed that I had no path, no recourse. Truly it would be impossible for me to atone for our actions. I am no hero, despite what you may think. I am simply an old man who has seen too much for one lifetime.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101204,'We may have a way to stave off the hunger - long enough to find a cure. Let us help.','We may have a way to stave off the hunger - long enough to find a cure. Let us help.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101205,'','Your actions cannot disrupt our studies! The power will soon be ours!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101207,'It is good to fight with you again.','It is good to fight with you again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101208,'','The hunt is eternal...',0,0,0,0,0,0,0,0,0,0,0,54513,26124),
(101209,'','Guards! Hold them off!',0,0,0,0,0,0,0,0,0,0,0,54519,26124),
(101210,'','I will burn you alive!',0,0,0,0,0,0,0,0,0,0,0,54510,26124),
(101211,'','Thank you...',0,0,0,0,0,0,0,0,0,0,0,67380,26124),
(101212,'','What is this place?',0,0,0,0,0,0,0,0,0,0,0,67381,26124),
(101213,'','Ah, the Arcway. Great halls which run beneath the entire region... even the city itself.',0,0,0,0,0,0,0,0,0,0,0,67382,26124),
(101214,'','For now, at least, we know the withered have learned to avoid this place.',0,0,0,0,0,0,0,0,0,0,0,67395,26124),
(101215,'','And nobody from the palace would think to search for us here.',0,0,0,0,0,0,0,0,0,0,0,67396,26124),
(101216,'What is this commotion I hear? Why has the portal been closed?','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(101217,'','It looks like we got his attention.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101218,'','We should hurry. I would rather avoid a confrontation if we can.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101219,'','Oh, you\'re no fun.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101220,'','Let\'s find this archive and get out of here before it\'s too late.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101221,'','No! I can see now... betrayed...',0,0,0,0,0,0,0,0,0,0,0,54514,26124),
(101222,'In the end, you will all succumb to the Legion...','',0,0,0,0,0,0,0,0,0,0,57368,0,26124),
(101223,'','Got another, Maruul! You\'re falling behind!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101224,'','Minions - Attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101225,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101226,'','Another down! You\'ve got nothing on me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101227,'','You\'re wasting your time, Maruul! Your aim will never be as good as mine!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101228,'With pleasure.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101229,'The archive is just ahead! Xel\'toth waits there, coveting all of Jagganoth\'s knowledge to himself. Question him, and you will find your artifact!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101230,'','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101231,'','Even if you stop us here we will never be done.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101232,'What mortal dares approach the archives? Such insolence will not be tolerated!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101233,'','I don\'t think he means to cooperate. Let\'s see how brave he is when we take away his strength.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101234,'','He\'s just too strong!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101235,'','Defend yourselves!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101236,'Fools! You will suffer for your trespass!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101237,'Someone else marked that target.','Someone else marked that target.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101238,'','He is weakened! Quickly, banish him before he recovers!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101239,'This cannot be! Release me at once!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101240,'','We\'ll consider it, demon, but first, what can you tell me about these artifacts that Jagganoth is hunting?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101241,'Never!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101242,'','In that case, how about I simply cast you out into the Great Dark? You can spend eternity observing the nothingness.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101243,'You wouldn\'t!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101244,'','She would.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101245,'Very well. If you truly wish to defeat Jagganoth, there is only one artifact you would wish to seek.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101246,'Deep beneath the keep of Karazhan rests the dread scythe Ulthalesh, The Deadwind Harvester.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101247,'In their unending search for powerful relics, the Dark Riders plucked Ulthalesh from its resting place and stashed it in their armory.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101248,'','Indeed, my pet. Indeed...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101249,'My knowledge has been granted. Now, release me from my bonds!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101250,'','Hm, I don\'t remember ever agreeing to let you go.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101251,'Insolent worms! You will burn for this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101252,'What is this? The petulant mortals disrupt my portals and invade my archives? I should have simply destroyed you like that petty little gnome.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(101253,'','You will see me again at the Temple of Elune.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(101254,'','Killing us would have been your salvation, Jagganoth. Now, you will have to pay for Zelifrax! Band\'or shorel\'aran!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101255,'','Shinfel! Zinnin!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101256,'','They cannot hope to face him alone. Come, warlock!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101257,'No! Friend must not confront Jagganoth without the weapon! Friend will surely be defeated!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101258,'','But we cannot leave them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101259,'Calydus will go help his friend find weapon. Then we will return with the power to defeat Jagganoth. We must hurry!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101260,'','Go then, warlock, but I cannot abandon the Council. Let us hope we can survive to see your return.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101261,'Yes, yes! Use the portal! Hurry, friend!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101262,'Maxxael! The master will not tolerate sloth... Where are you?!','',0,0,0,0,0,0,0,0,0,0,54505,0,26124),
(101263,'','Kassarus! Dispose of these intruders.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101264,'','I don\'t think Hemet himself could have taught me better.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(101265,'No! YOU... you killed him!','',0,0,0,0,0,0,0,0,0,0,54502,0,26124),
(101266,'I will paint this keep with your blood!','',0,0,0,0,0,0,0,0,0,0,54504,0,26124),
(101267,'For the love of the Naaru, I missed again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101268,'I\'ve had enough of your barking, Emily!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101269,'I got one! How\'s that for being a \"bad shot\"?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101270,'Our defeat at the Broken Shore was a disaster. What\'s left of the Alliance and Horde are at one another\'s throats.$b$b$C, heroes like you may be our last great hope. Stay strong, and do not give up.','',1,274,0,0,0,0,0,0,0,0,0,0,26124),
(101271,'','So long as the Legion does not break our spirit, they cannot triumph.',1,66,0,0,0,0,0,0,0,0,0,0,26124),
(101272,'Tremble beneath me.','',0,0,0,0,0,0,0,0,0,0,54501,0,26124),
(101273,'Don\'t bother running, flea...','',0,0,0,0,0,0,0,0,0,0,54506,0,26124),
(101274,'Ha! Got you!','',0,0,0,0,0,0,0,0,0,0,54503,0,26124),
(101275,'Take this!','',0,0,0,0,0,0,0,0,0,0,54635,0,26124),
(101276,'Out with the refuse.','',0,0,0,0,0,0,0,0,0,0,54500,0,26124),
(101277,'','Neutralized.',0,0,0,0,0,0,0,0,0,0,0,54512,26124),
(101278,'But... I can\'t... lose...','',0,0,0,0,0,0,0,0,0,0,54636,0,26124),
(101279,'Kur\'talos... they come for you.','',0,0,0,0,0,0,0,0,0,0,54540,0,26124),
(101280,'They do. Together we shall defeat them, Latosius.','',0,0,0,0,0,0,0,0,0,0,54527,0,26124),
(101281,'Fiends, you shall never have our world!','',0,0,0,0,0,0,0,0,0,0,54536,0,26124),
(101282,'I shall cleave you in twain!','',0,0,0,0,0,0,0,0,0,0,54526,0,26124),
(101283,'You will not take our world!','',0,0,0,0,0,0,0,0,0,0,54528,0,26124),
(101284,'Burn away!','',0,0,0,0,0,0,0,0,0,0,54539,0,26124),
(101285,'Enough! I tire of this.','',0,0,0,0,0,0,0,0,0,0,54538,0,26124),
(101286,'Ravencrest, you worthless husk. Ten thousand years have not been kind.','',0,0,0,0,0,0,0,0,0,0,54537,0,26124),
(101287,'When Trand started spreading news of Deathwing\'s coming, my family did not want to follow. My heart told me to stay with them, but my body... \n\nI want to live, $c. There is no shame in that.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(101288,'Now, you.','',0,0,0,0,0,0,0,0,0,0,54546,0,26124),
(101289,'Sleep, now...','',0,0,0,0,0,0,0,0,0,0,54499,0,26124),
(101290,'Your skin crawls...','',0,0,0,0,0,0,0,0,0,0,54542,0,26124),
(101291,'We are legion!','',0,0,0,0,0,0,0,0,0,0,54543,0,26124),
(101292,'You cannot comprehend that which you face, mortals...','',0,0,0,0,0,0,0,0,0,0,54541,0,26124),
(101293,'No... no...','',0,0,0,0,0,0,0,0,0,0,54535,0,26124),
(101294,'What am I? This is... not...','',0,0,0,0,0,0,0,0,0,0,54534,0,26124),
(101295,'My ancestors... Illysanna! No, forgive me...','',0,0,0,0,0,0,0,0,0,0,54533,0,26124),
(101296,'Heroes! You must defeat him!','',0,0,0,0,0,0,0,0,0,0,54532,0,26124),
(101297,'Ha! You expect these worthless mortals to defy the Legion?','',0,0,0,0,0,0,0,0,0,0,54545,0,26124),
(101299,'Why... why do you bother to struggle? You will fail - if not today, then tomorrow, or the next...','',0,0,0,0,0,0,0,0,0,0,54544,0,26124),
(101300,'Souls of my ancestors! To me! Aid our champions!','',0,0,0,0,0,0,0,0,0,0,54530,0,26124),
(101301,'Yes - we may bend, but never break.','',0,0,0,0,0,0,0,0,0,0,54529,0,26124),
(101303,'I... will... return!','',0,0,0,0,0,0,0,0,0,0,54547,0,26124),
(101304,'I will count on it. Whenever you come, we will meet you. And we WILL defend our world.','',0,0,0,0,0,0,0,0,0,0,54525,0,26124),
(101305,'Thank you, heroes. A great veil has been lifted from our eyes.','',0,0,0,0,0,0,0,0,0,0,54524,0,26124),
(101306,'We Ravencrests have sacrificed much and more in defense of this land. I see now we may rest, safe in the knowledge that heroes still live who will defend our world.','',0,0,0,0,0,0,0,0,0,0,54523,0,26124),
(101307,'Good luck, $n. I\'ll see you up in the volcano.','',0,0,0,0,0,0,0,0,0,0,55232,0,26124),
(101308,'','I, too, came to Icecrown in search of Felo\'melorn. The Lich King gave me the blade... and more. He gave me purpose!',0,0,0,0,0,0,0,0,0,0,0,53955,26124),
(101309,'Looks like you could use a little help.','',0,0,0,0,0,0,0,0,0,0,55270,0,26124),
(101310,'We\'re too spread out. Everyone regroup!','',0,0,0,0,0,0,0,0,0,0,55278,0,26124),
(101311,'So far, so good, $n. We\'re about to take the ridge.','',0,0,0,0,0,0,0,0,0,0,55272,0,26124),
(101312,'Are you ready to plant the banner?','',0,0,0,0,0,0,0,0,0,0,55273,0,26124),
(101313,'I\'m going to need my warglaive back after you kill that demon.','',0,0,0,0,0,0,0,0,0,0,55275,0,26124),
(101314,'After we take this place, you need to summon our forces through that huge Legion gateway.','',0,0,0,0,0,0,0,0,0,0,55277,0,26124),
(101315,'I can\'t get to you right now, but I can throw my warglaive at your demon.','',0,0,0,0,0,0,0,0,0,0,55276,0,26124),
(101318,'Use Murky\'s Egg to mindmeld with him and guide his actions.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101319,'Mrgl, grrglrrgl. GURGLRRGLRRRGL! Mrgl.','',35,0,0,0,0,0,0,0,0,0,0,0,26124),
(101320,'MrglRGLRGLRGL. Mrrrmrgl!','',35,0,0,0,0,0,0,0,0,0,0,0,26124),
(101321,'Grmrglrgml? Mrgrl. RGL!','',51,0,0,0,0,0,0,0,0,0,0,0,26124),
(101322,'Mglrrglrgl! Grml. Mrgrmlgr.','',51,0,0,0,0,0,0,0,0,0,0,0,26124),
(101324,'You saved my people from the Feltotem and their Legion allies. We will now help you and your Highmountain allies against Dargrul and his mindless followers.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101325,'I am nervous about entering this place. Best hurry in before they change their mind about allowing me safe passage.','',0,0,0,0,0,0,0,0,0,0,54782,0,26124),
(101326,'I, Navarrogg, leader of the Stonedark drogbar, declare my allegiance to the Highmountain tribe.','',0,0,0,0,0,0,0,0,0,0,54783,0,26124),
(101327,'Together, we are Highmountain!','',0,0,0,0,0,0,0,0,0,0,54784,0,26124),
(101328,'Looks like they\'re trying to surround the Harbor! Keep \'em busy until reinforcements arrive!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101329,'Hold \'em off \'til we can get some backup here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101330,'We\'re not gonna lose the Strand! Air reinforcements are comin\' soon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101331,'If we lose ground here they\'ll siege Bilgewater! Throw the kitchen sink at \'em. We ain\'t losin\' Bilgewater!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101332,'Mrrgl. Mrrglrgrgrgl. Rrglrgl, mrglrgl. RRGL!! Mrglrgl. Mrr, mrgl. Rglrglmrr, glrmrlr. Mrglrrrr. Gllrmrl. Mrr? Grmlrml!\n\nMrgl. Mrrky. Mrg.','',51,0,0,0,0,0,0,0,0,0,0,0,26124),
(101334,'','Who taught you how to shoot a gun, a murloc?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101335,'Your pride will be the end of you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101336,'<The vrykul seems to be unconscious.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101337,'Try to rouse the vrykul.','Try to rouse the vrykul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101338,'Firmly kick the vrykul.','Firmly kick the vrykul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101339,'Repeatedly poke the vrykul with a stick','Repeatedly poke the vrykul with a stick',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101340,'<Fjolrik mumbles to himself.>$B$BNot now, Asta. I\'m trying to sleep.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101341,'<Fjolrik mumbles to himself.>$B$BNot so rough, Asta!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101342,'<Fjolrik mumbles to himself.>$B$BAsta! Is it time to battle?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101344,'Is there something I can help you with, $c?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101345,'I was wondering if you would be able to part with one of your scales?','I was wondering if you would be able to part with one of your scales?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101346,'I came for the Illidari, but Azoran will be pleased when I bring him your corpse as well!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101347,'I\'m sorry, $n, but I cannot simply give you one of my scales. In this time of need, we must keep all of our strength.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101348,'A strange request, $n, but I trust it will go towards a good cause. Here, take it, and may it help you against the legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101349,'','SKREEE! IT BURNS! I will flay you alive for this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101350,'I wish I could do more to aid Senegos.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101351,'You come here, at this hour, and ask for such a thing? Leave me be, $c.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101352,'I take it you need this for some vital task? Since I\'m of no help to my kin, I suppose the least I could do is help you.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101353,'','Have you checked the storehouse up the hill? We\'ve been trying to gather all the good bits we can find. Things that will last. You know; bananas, milk... that sort of thing. \n\nI think we\'re doing a good job!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(101354,'These damn Nightfallen are relentless. Have you come to aid us in our fight against them?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101355,'My scale? The nighfallen take our essence and you ask for my scale?! Leave before I confuse you with one of them!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101356,'That\'s a very difficult request you ask of me, $n. Here, take one. I only hope it leads to ending this war.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101357,'Huln cast Tichondrius out of this world with the Eagle Spear.','',0,0,0,0,0,0,0,0,0,0,54803,0,26124),
(101358,'He returned to his homeland after the War of the Ancients and it was renamed in his honor.','',0,0,0,0,0,0,0,0,0,0,54804,0,26124),
(101359,'Trand is an inspiration. He\'s strong willed, a good leader, and he cares about others. When he had the vision of Deathwing\'s return, he didn\'t just run off by himself. He told us, his peers, and called us to follow him if we wanted to live. \n\nI\'ve known many a shaman in my life, but Trand really knows how to... ride the lightning, so to speak.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(101361,'','It\'s a fine day for a hunt.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(101362,'Your movements have caused a Frost Block to break open!','Your movements have caused a Frost Block to break open!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(101364,'','The Doomhammer fell somewhere below. Hold on! This part always gives me tummy the wubblies!',0,0,0,0,0,0,1,0,0,0,0,60575,26124),
(101365,'Come closer if you want to die, naga!','',0,0,0,0,0,0,0,0,0,38051,0,0,26124),
(101367,'I don\'t know who you are, but you best get out of here before the giants catch you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101368,'Day 5: Wards prove effective at deterring the withered, but do nothing for the cacophony of critters and beasts outside. The nights are so loud out here.','',0,0,0,0,0,0,0,0,0,0,67434,0,26124),
(101369,'I relish what little sleep I can manage. Tomorrow I begin looking for subjects.','',0,0,0,0,0,0,0,0,0,0,67435,0,26124),
(101375,'We will never forget the great deeds you have done in service of our people... until we do.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101376,'Greetings brul.$b$bIf you tire of the stench of wood and clean air then speak with me, Bogrogg, the STONESCREAMER!$b$bI can send you by way of stone and earth to the Stonedark Grotto.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101377,'I wish to journey to Stonedark Grotto.','I wish to journey to Stonedark Grotto.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101378,'Sure didn\'t see that coming! I\'m gonna warn the others.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101379,'By the horns on my head, I will kill every last one of these naga!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101380,'Thanks! Is that my blood or yours?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101381,'Protect the Harbor at all costs!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101382,'Ain\'t no way these things are taking over.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101383,'I am no naga, Stokalfr! I come on behalf of Brandolf!','I am no naga, Stokalfr! I come on behalf of Brandolf!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101384,'Glad you\'re here. We could use some backup.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101385,'That pup is still alive? Glorious!$B$BI will follow you, but keep your hands off my helmet.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101386,'There! The portal should be stable enough to take you to Dalaran.','There! The portal should be stable enough to take you to Dalaran.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101387,'It took you long enough, man\'ari. Jagganoth hungers for the blood of these mortals!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101388,'','The key! They\'re using it to stabilize the portal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101389,'','If we can get to it in time, we may be able to stop them from reaching Dalaran!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101394,'You will never escape!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101395,'','Arise, ghouls! Feast upon this intruder\'s heart!',0,0,0,0,0,0,0,0,0,0,0,53960,26124),
(101396,'Celea sent me to free you. Here, put on this armor.','Celea sent me to free you. Here, put on this armor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101397,'Stay in Thunder Totem if you want, woman. I\'m done with these weaklings. My true place is with the Bloodtotem.','',274,25,0,0,1,0,0,0,0,0,0,0,26124),
(101398,'Get away from that portal, worm!','Get away from that portal, worm!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101400,'You seem like the type that just wants a fight. If you\'re interested, the Horde needs more troops.','',0,0,0,0,0,0,0,0,0,36754,0,0,26124),
(101401,'It appears you didn\'t complete your last tour of duty in Ashran. Return to me in a few minutes.','',0,0,0,0,0,0,0,0,0,36755,0,0,26124),
(101402,'It appears you didn\'t complete your last tour of duty in Ashran. Return to me in a few minutes.','',0,0,0,0,0,0,0,0,0,36755,0,0,26124),
(101403,'','I can feel the connection breaking. We\'re almost there!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101404,'','There. It is done.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101405,'','They won\'t be reaching Dalaran anytime soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101406,'-PH- TEXT WILL BE DONE DURING POLISH','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101407,'These lands are not your own.','These lands are not your own.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101408,'Blood and Honor!','Blood and Honor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101409,'','That was too close for my liking. $n, the demon\'s power is yours.',0,0,0,0,0,0,0,0,0,0,0,57357,26124),
(101410,'Join me, demon hunters. I will increase your power beyond imagining!','',0,0,0,0,0,0,0,0,0,0,57358,0,26124),
(101411,'Courage... is your greatest weapon...','',0,0,0,0,0,0,0,0,0,0,63778,0,26124),
(101412,'The wardens would keep us rotting here forever. Why do you fight on their side?','',0,0,0,0,0,0,0,0,0,0,57359,0,26124),
(101413,'Find the strength within...','',0,0,0,0,0,0,0,0,0,0,63779,0,26124),
(101414,'Put your faith... in the Light...','',0,0,0,0,0,0,0,0,0,0,63780,0,26124),
(101415,'The Ashbringer...','',0,0,0,0,0,0,0,0,0,0,63781,0,26124),
(101416,'No... noooooo! Fools...','',0,0,0,0,0,0,0,0,0,0,57360,0,26124),
(101417,'Ashes... to ashes...','',0,0,0,0,0,0,0,0,0,0,63782,0,26124),
(101418,'None can escape Jagganoth\'s wrath!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101419,'In the Light... we are one...','',0,0,0,0,0,0,0,0,0,0,63783,0,26124),
(101420,'Remain... vigilant...','',0,0,0,0,0,0,0,0,0,0,63784,0,26124),
(101421,'Unbreakable...','',0,0,0,0,0,0,0,0,0,0,63785,0,26124),
(101422,'We stand... united...','',0,0,0,0,0,0,0,0,0,0,63786,0,26124),
(101423,'Hope... never dies...','',0,0,0,0,0,0,0,0,0,0,63787,0,26124),
(101424,'','I will not be defeated! Come, my pet! Sate your hunger with the flesh of the living!',0,0,0,0,0,0,0,0,0,0,0,53962,26124),
(101425,'Day 9: Still no luck in communicating with the withered. I must regard this failure not as a measure of ability, but a measure of progress.','',0,0,0,0,0,0,0,0,0,0,67436,0,26124),
(101426,'Day 14: The new subject, number 16, is special. His arcane essence is touched by some mysterious power. I have named him Theryn.','',0,0,0,0,0,0,0,0,0,0,67437,0,26124),
(101427,'Let me know when you\'re ready, $n. I can\'t wait to get out of here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101428,'I\'m ready, Taldranis. Let\'s go.','I\'m ready, Taldranis. Let\'s go.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101429,'You honor us with your strength, champions. I ask that you fight - bleed for our cause! We will not fall to the Legion!','',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(101430,'Blood and Honor, champions! Show them your strength! Stand together! Fight together!','',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(101431,'The Ashbringer...','The Ashbringer...',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(101432,'Day 16: Breakthrough! Using Theryn\'s essence as the base, I have crafted a spell that calms the withered. At least, it works sometimes...','',0,0,0,0,0,0,0,0,0,0,67438,0,26124),
(101433,'Day 24: Awoke to a night elf\'s blade at my neck. He asked what I was doing to the withered. \"Searching for a cure,\" I replied. He merely grunted, and disappeared into the woods.','',0,0,0,0,0,0,0,0,0,0,67439,0,26124),
(101434,'Shinfel and Zinnin attack Jagganoth!','Shinfel and Zinnin attack Jagganoth!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101436,'Wield your weapons with purpose! Drive them back!','',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(101437,'Day 33:  Low on arc-wine. Theryn making excellent progress. Shal\'an remains stubborn. Crystals becoming harder to find.','',0,0,0,0,0,0,0,0,0,0,67440,0,26124),
(101438,'Day 50: The sky... has turned black. Demons... everywhere. And this hunger... this endless hunger...','',0,0,0,0,0,0,0,0,0,0,67442,0,26124),
(101439,'Subjects released... I can no longer protect them...','',0,0,0,0,0,0,0,0,0,0,67443,0,26124),
(101440,'Death Knights of Acherus, I send to you $n who will serve as the enforcer of my will. Follow her commands as you would my own.','',0,0,0,0,0,0,0,0,0,0,53880,0,26124),
(101441,'Jumping from this bridge is training for my boys. If you can jump from here, you can jump from your eagle! They\'ll be ready to fight the good fight before we know it. We\'re happy to be back in Thunder Totem.\n\nYou can try, if you\'d like.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(101442,'Next!','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(101443,'','Hallo shaman! We got separated from one another after the assault on the Maelstrom.$b$bCome, there\'s work ta be done. Stormbeak here will fly ya to Deepholm.',3,1,0,0,0,0,0,0,0,0,0,0,26124),
(101444,'Fly me to Deepholm, Mylra!','Fly me to Deepholm, Mylra!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101445,'Alright, $n, I\'m your shadow from here on out. Try not to get us killed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101446,'','We never should have listened to Ebonhorn. We should have used the hammer against the Legion and the drogbar when we had it.',5,0,0,0,0,0,5,0,0,0,0,0,26124),
(101447,'','Tell that to the Riverbend Refugees.',25,0,0,0,0,0,25,0,0,0,0,0,26124),
(101448,'I\'ve got it from here, $n. Thanks for your help. And if you see Celea again, tell her I owe her one.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101449,'','The hammer is not a weapon, you know that.',274,0,0,0,0,0,274,0,0,0,0,0,26124),
(101450,'%s arises to the call for battle as its stiff branches crackle, releasing age old dust to the ground below.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101451,'Sitting','Sitting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(101452,'Mayla cannot even stand against the drogbar. What hope does she have against the Legion?','',6,0,0,0,0,0,6,0,0,0,0,0,26124),
(101453,'We are done with Highmountain. The Bloodtotem must look to new allies.','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(101454,'','Unacceptable! My minions will rip you apart!',0,0,0,0,0,0,0,0,0,0,0,53961,26124),
(101455,'I heard the harpies hit Skyhorn hard. Lasan has been pulling back all of his forces to defend their home.','',5,0,0,0,0,0,1,0,0,0,0,0,26124),
(101456,'Applebough notices G\'Hanir and tosses you a fresh apple!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101461,'The Ashbringer?! Lord Balnazzar will have your head!','',0,0,0,0,0,0,0,0,0,34080,53938,0,26124),
(101462,'|TINTERFACE\\ICONS\\trade_archaeology_naarucrystal.blp:20|t $n is imprisoned in |cFFF00000|Hspell:195791|h[Quarantine]|h|r!','|TINTERFACE\\ICONS\\trade_archaeology_naarucrystal.blp:20|t $n is imprisoned in |cFFF00000|Hspell:195791|h[Quarantine]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(101463,'Hold fast, Illidari! We must trap him in this chamber!','',0,0,0,0,0,0,0,0,0,0,57331,0,26124),
(101464,'Hurry, $n! Activate the countermeasures around the room!','',0,0,0,0,0,0,0,0,0,0,57332,0,26124),
(101465,'The Ashbringer... will falll...','',0,0,0,0,0,0,0,0,0,34080,53939,0,26124),
(101466,'We cannot hold out like this forever. We need to contain him!','',0,0,0,0,0,0,0,0,0,0,57286,0,26124),
(101467,'What you want me find? Me have shovel!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101468,'Go find shiny! Dig dirt in dead place.','Go find shiny! Dig dirt in dead place.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101469,'Well done! The monster is contained. Let\'s meet up with the others.','',0,0,0,0,0,0,603,0,0,0,57333,0,26124),
(101470,'|TInterface\\Icons\\ability_socererking_arcanewrath:20|tYou are targeted by |cFFF00000|Hspell:196070|h[Suppression Protocol]|h|r!','|TInterface\\Icons\\ability_socererking_arcanewrath:20|tYou are targeted by |cFFF00000|Hspell:196070|h[Suppression Protocol]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(101471,'','Riverbend was destroyed with a single blow. How can we stand against such power?',5,0,0,0,0,0,1,0,0,0,0,0,26124),
(101472,'Well I\'ll be... the Ashbringer. They say King Magni worked for three days straight to forge that blade.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101473,'Anything else?','Anything else?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101474,'You kill basilisk! Biggest in cave! Bring back!','You kill basilisk! Biggest in cave! Bring back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101475,'You need kill? My chisel axe best in sharpness ever!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101476,'Well if ain\'t the Highlord $Ghimself:herself;! I reckon\' it\'s good for even the hardiest of us to take a moment and reflect now and again. I\'m right fond of this spot.','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(101477,'Take a seat with me for a moment, won\'t ye?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(101478,'The Ashbringer is a truly wondrous blade, ain\'t it? I remember forging it many years ago back in Ironforge - my finest work.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101479,'If ye don\'t mind an old dwarf talkin\' yer ear off, I\'d like to share a piece of advice with ye that I\'ve carried with me since I was a lad.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101480,'We all come from the same earth and stone around us; Alliance and Horde, dwarf and gnome- as a leader, ye\'ve got to see past the differences and unite yer people against the Legion. Azeroth depends on it.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101481,'I\'ll give ye some time alone. Just somethin\' to think about in the days ahead.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101482,'I\'m with you, hero! I\'ll hold Lyandra at bay. Focus on destroying that monster of hers!','',0,0,0,0,0,0,0,0,0,0,60511,0,26124),
(101483,'What you want me do? Can wax off extra hairs? Make drip bath? Check ears for waxes?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101484,'Make big candle! Lots of wax!','Make big candle! Lots of wax!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101485,'Throm-Ka, Highlord $p. I see we both value some peace and quiet now and again.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101486,'Sit with me if you would - just for a few moments.','',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(101487,'Tirion was my brother by blood. We saved one another\'s lives many moons ago. He was a good man... an honorable man.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101488,'He always thought highly of you - from what I hear from others his trust has not been misplaced.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101489,'I have watched many lead their people down dark paths. Tirion often spoke of the Light that guided his hand and his people - let it guide you to greatness as well.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101490,'I am not one for conversation - much remains to be done. May our paths cross again, $p.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101491,'','Aethas! How DARE you! Have you forgotten who I am?',0,0,0,0,0,0,0,0,0,0,0,53965,26124),
(101492,'If they come, I\'ll be ready.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101493,'Take care of yourself out there. If ye ever need anything, ye know where to find me.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101494,'Lok\'tar ogar.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101495,'I remember who you were. But the creature before me now is but a walking corpse!','',0,0,0,0,0,0,0,0,0,0,60512,0,26124),
(101496,'Apologies, but now is not the time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101497,'I mine! You no take pickaxe! Where you want rocks dug? Want the metals? Pick a little dull.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101498,'Dig rocks, find pretties! More pretty is better.','Dig rocks, find pretties! More pretty is better.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101499,'This world will crumble! We will darken your skies, crush your armies. Come, whelps! Die before my might!','This world will crumble! We will darken your skies, crush your armies. Come, whelps! Die before my might!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101500,'She\'s trying to counter my spell! I won\'t be able to hold her much longer. Hurry!','',0,0,0,0,0,0,0,0,0,0,60513,0,26124),
(101501,'The Legion will fail in their efforts.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101502,'The entrance to this place remains hidden, known only to the riders themselves.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101503,'Little is known of this ancient weapon, other than that its power was responsible for taking the life from the place you call Deadwind Pass.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101504,'','Great job, $n. We were able to save a lot of good soldiers, but we haven\'t accounted for all of our lost forces yet.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101505,'','A scout just informed me that there is a jailer demon to the east with at least ten of our soldiers being tortured.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101506,'$n, you take the east and recover any remaining survivors. Lynore and I will take the soldiers and push them back in the west.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101508,'Me find shiny coins at bury place! So many, so shiny. What me do with them?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101509,'You keep one. I keep rest.','You keep one. I keep rest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101511,'I find biggest basilisk in cave! It dead now! I get reward?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101512,'Best kill job me seen! You get best reward...','Best kill job me seen! You get best reward...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101513,'','Only when the blinding pain of life left me did I see the truth! Only then was the majesty of the plan revealed!',0,0,0,0,0,0,0,0,0,0,0,53956,26124),
(101514,'','The blade is mine, by the will of the master... and by rights of blood! Oppose me and you WILL be struck down!',0,0,0,0,0,0,0,0,0,0,0,53958,26124),
(101515,'Candle almost ready! Just needs magic touch and Candleking will have best candle I ever make!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101516,'Me think me have just the right touch...','Me think me have just the right touch...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101517,'Using Artifact','Using Artifact',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(101518,'All doubt has been banished! You are truly worthy of the blade! Claim your prize and leave, hero. The living have no place within my prison of ice.','',0,0,0,0,0,0,0,0,1,0,60509,0,26124),
(101519,'','If you long for my blade so badly, then you shall have it!',0,0,0,0,0,0,0,0,0,0,0,53963,26124),
(101520,'','So... cold....',0,0,0,0,0,0,0,0,0,0,0,53966,26124),
(101521,'','Vengeance for the brood queen!',0,0,0,0,0,0,0,0,0,0,0,55026,26124),
(101522,'','Protect the eggs at all costs.',0,0,0,0,0,0,0,0,0,0,0,55027,26124),
(101523,'','No... Tyranna is dead!',0,0,0,0,0,0,0,0,0,0,0,55028,26124),
(101524,'','You will make a satisfying meal.',0,0,0,0,0,0,0,0,0,0,0,55029,26124),
(101525,'','You made a terrible mistake coming here.',0,0,0,0,0,0,0,0,0,0,0,55030,26124),
(101526,'And to what end?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101527,'A ruse to study their prey here in safety.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101528,'And what was my reward?  Eternal torment from my \"sisters.\"','',0,0,0,0,0,0,14,0,0,0,55447,0,26124),
(101529,'','Can you say the same as you stand there intoxicated with the power of the Legion?',0,0,0,0,0,0,14,0,0,0,0,55446,26124),
(101530,'I will slay you and all your kin; and when I\'m done I will fulfill the dreams of my mentor.','',0,0,0,0,0,0,53,0,0,0,55445,0,26124),
(101537,'','You do not realize that you\'re groping in the darkness! Felo\'melorn would be wasted in your hands!',0,0,0,0,0,0,0,0,0,0,0,53957,26124),
(101538,'Ain\'t no way these demons are taking o\'er our land! Not while I\'m in charge!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101539,'Pity... that wretched shardling isn\'t moving? Its death was neither quick nor painless, I assure you.','',0,0,0,0,0,0,0,0,0,0,54815,0,26124),
(101542,'Be careful out here, $n! Wouldn\'t want a fine $c like yourself to get hurt!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101545,'You defeated a few of our weakest fighters... no matter. When the fel blood courses fully through our veins, even that precious artifact of yours won\'t do us harm.','',0,0,0,0,0,0,0,0,0,0,54764,0,26124),
(101558,'','Foolish mortal! You should have fled when you had the chance.',0,0,0,0,0,0,0,0,0,0,0,53959,26124),
(101559,'Hup Hup, Pimento! $ct $p requires our aid!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101560,'Count your days numbered, dragons of fire and flame. Today you fall to Maximillian of Northshire! And $ct $p!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101561,'By Doloria\'s grace, I have arrived my $ct! What dragon dares threaten your greatness?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101562,'What ho, oh illustrious and impenetrable $ct $p? I am forever in your service.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101563,'There will be many festivities after we are through. For the Silver Hand!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101564,'Fear not, townsfolk. Adventure has arrived!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101566,'By the golden fields of Westfall - what strange land do you brave this time, oh $ct?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101567,'A thousand blessings upon you, my highlord. If you need me, I will be in the wondrous Goldshire inn.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101568,'The skies are looking pretty grim. Be careful out there!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101569,'<The ground here roils and rumbles alarmingly beneath your feet. Perhaps a shaman could be brought here to soothe the restless earth?>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101570,'An inglorious stain upon the Sunstrider name has been cleansed. Good work, hero!','',0,0,0,0,0,0,0,0,0,0,60514,0,26124),
(101571,'Let\'s go... before the Lich King decides we\'ve overstayed our welcome. I must plead my case before the council.','',0,0,0,0,0,0,0,0,0,0,60515,0,26124),
(101572,'Feeding Time!','',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(101573,'<The ground here is in torment and rumbles alarmingly beneath your feet. As a shaman you can perform a ritual to draw out and soothe the angry earth spirits... but you should be ready for a fight.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101574,'<Perform the earth ritual.>','<Perform the earth ritual.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101575,'Attack!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101576,'Well, looky at what kind of beasty we have \'ere!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101577,'My target, lads!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101578,'Be careful here. This isn\'t a spot I want to be in until it\'s all clear.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101579,'This isn\'t the place to be now. I\'ll come back when it\'s safe.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101580,'Boys, boys - we have to stay calm. As much as we hate to admit it, these Hunters are quite the help in holding the quarry.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101581,'I know it\'s a nuisance sharing the camp, but we have to work together or we\'ll have nothing left!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101582,'I assure you - they\'ll be on their way as soon as these demons are taken care of.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101583,'The sooner they\'re both gone, the better! This camp\'s hardly big \'nuff for us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101584,'If I hadn\'t the cough keepin\' me down, I\'d be out there fightin\' as well!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101585,'Not gonna lose our lands to the damn demons, thats fer sure!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101586,'You said it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101587,'Too many new faces, if ya ask me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101588,'All this fussin\'. What we need is fightin\'!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101589,'I... I don\'t remember what happened.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101590,'','Safe travels, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101591,'','Use my tanning rack and workbench to craft everything. You\'ll find a solution for tanning on my bench as well.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101592,'','I hope you held on to your materials, you\'ll need them for the final version of those boots.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101593,'','Azoran must die...',0,0,0,0,0,0,0,0,0,0,0,67592,26124),
(101594,'Your flesh will feed my pets!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101595,'','My glaives have gone too long without tasting demon blood...',0,0,0,0,0,0,0,0,0,0,0,67593,26124),
(101596,'Receive my blessing and carry with you the wisdom of ages yet to pass.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101597,'','This ends now!',0,0,0,0,0,0,0,0,0,0,0,53967,26124),
(101598,'Smite down all those who would destroy this world. Burn them in righteous fire!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101599,'Worry not, my children. We will stand by you in the dark times to come.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101600,'Be lifted by my power - leave no boundary uncrossed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101601,'You who dares brave the trials ahead - I bestow upon you the ephemeral power of creation!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101602,'I will protect all who stand in Azeroth\'s defense. You shall not fall this day!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101603,'','Mayla, child, the Underking has destroyed Riverbend.',0,0,0,0,0,0,1,0,0,0,0,54284,26124),
(101604,'','Thank you champion. We should be safe now. Come, let us speak with Mayla.',0,0,0,0,0,0,1,0,0,0,0,54283,26124),
(101605,'We can\'t let them reach the Gates!','We can\'t let them reach the Gates!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101606,'For the Alliance!','For the Alliance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101607,'Thanks! Yer quite the $c, aren\'t ya.','Thanks! Yer quite the $c, aren\'t ya.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101608,'We usually invite our guests in with a pint, but for the demons I\'ll be sharing the pointy end of me blade instead.','We usually invite our guests in with a pint, but for the demons I\'ll be sharing the pointy end of me blade instead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101609,'Today will not be my last!','Today will not be my last!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101610,'I\'ve ne\'er seen anything like this before!','I\'ve ne\'er seen anything like this before!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101611,'Sharpen your blades, $n. This fight ain\'t over yet.','Sharpen your blades, $n. This fight ain\'t over yet.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101612,'','Are you here to add to our stores? If you have any meat, make sure it\'s not salted. Trand says salted meat spoils faster.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(101613,'','Sure, you may think our hats look silly, but they will help us adapt to the flooding of the world quickly!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(101614,'I will protect us from whatever monstrosities lie under the sea!','',15,0,0,0,0,0,0,0,0,0,0,0,26124),
(101615,'Namha asked me to talk to you about mount barding.','Namha asked me to talk to you about mount barding.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101616,'','They are behaving like children.$B$BStill, I knew this was coming. They might as well work out their differences now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101617,'This ominous golem seems to be deactivated. You are drawn to a button on it\'s back. Do you press it?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101619,'','The Pool of Judgment can remind Kayn and Altruis of our past... a shared past forged by Lord Illidan himself.',0,0,0,0,0,0,0,0,0,0,0,57348,26124),
(101620,'','Oh! Yes, well, you see, the problem that adventurers keep whining about is that their mounts will occasionally buck them from their saddles when hostile creatures attack.$b$bI told them to stop running through wild packs of animals, but apparently that\'s \"not the fastest way to travel.\"$b$bSo, I figured if I couldn\'t convince them to stick to the roads, then perhaps it would be easier to build some armor for their mounts to protect them from all the attacks.$b$bThe major things we need to protect are the head, the neck and the body. In other words... pretty much everything.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101621,'I\'ve acquired all the leather. What\'s next?','I\'ve acquired all the leather. What\'s next?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101622,'','Excellent work, $n. Here are the recipes for each piece of the barding as well as the final barding recipe. Good luck!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101623,'Thank you, shaman. Without you, this world would succumb to chaos.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101624,'I thought I was down for good. You have my thanks.','I thought I was down for good. You have my thanks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101625,'I must fall back!','I must fall back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101626,'You have saved my life. I will not forget this.','You have saved my life. I will not forget this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101627,'Thank you, priest.','Thank you, priest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101628,'We must save the others!','We must save the others!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101629,'My spellstone... someone please... use it to carry on my work...','',0,0,0,0,0,0,0,0,0,0,67444,0,26124),
(101630,'Don\'t you die on me!','Don\'t you die on me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101631,'Light heal your wounds!','Light heal your wounds!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101632,'Your wounds are great in number.','Your wounds are great in number.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101633,'Hang in there, soldier. Evac is coming soon.','Hang in there, soldier. Evac is coming soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101634,'','The wounds inflicted by the Divine Bell incident run deep, Aethas. Others in the council are not as forgiving as I.',0,0,0,0,0,0,0,0,0,0,0,60496,26124),
(101635,'','Your master, demon. Where does he hide?',0,0,0,0,0,0,0,0,0,0,0,67594,26124),
(101636,'But with the Legion\'s coming, I decided to begin my own search for the location of the blade. I saw a vision of Lyandra with the weapon in hand. Around her the land was covered in ice, and an all-too-familiar fortress loomed behind her.','',0,0,0,0,0,0,0,0,0,0,60502,0,26124),
(101637,'','Icecrown. You believe you\'ll find her there?',0,0,0,0,0,0,0,0,0,0,0,60503,26124),
(101638,'Indeed I do. And nothing happens in that citadel unless its master wills it. I would not be surprised to learn he had a hand in this.','',0,0,0,0,0,0,0,0,0,0,60504,0,26124),
(101639,'Free at last! Let us defeat this evil!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101640,'There is no convincing you, I see. Very well, I will take my leave. $n, beware that you do not share Illidan\'s fate.','',0,0,0,0,0,0,1,0,0,0,57297,0,26124),
(101641,'You will trust the traitor? I can do no more here.','',0,0,0,0,0,0,1,0,0,0,57349,0,26124),
(101642,'Alar il raka Azoran il zennrakkan oth kamilgolad! Morgul... morgul!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101643,'','Mercy? The legion burns worlds... and you beg mercy?',0,0,0,0,0,0,0,0,0,0,0,67595,26124),
(101644,'','A swift death is more mercy than you deserve.',0,0,0,0,0,0,0,0,0,0,0,67596,26124),
(101645,'','I will bring your case before the others... but I cannot promise the outcome will be in your favor.',0,0,0,0,0,0,0,0,0,0,0,60498,26124),
(101646,'You have my thanks, friend.','',0,0,0,0,0,0,0,0,0,0,60499,0,26124),
(101647,'<The broken mystic barely clings to life.>\n\nI am as good as dead. Do... what must... be done.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101648,'Mystic, thank you for your sacrifice.','Mystic, thank you for your sacrifice.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101649,'<The corpse of the Ashtongue Mystic lies here bereft of its soul, which has powered the Legion Gateway.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101650,'The brood queen must have done something to this gateway. Not even the souls of several mo\'arg were enough to unlock it.\n\nThe soul of a demon hunter, however, would do the trick. You have a choice to make, $n...\n\n... One of us must die.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101651,'Sevis, I need to sacrifice you in order to power the final gateway.','Sevis, I need to sacrifice you in order to power the final gateway.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101652,'I want you to sacrifice me in order to power the gateway.','I want you to sacrifice me in order to power the gateway.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101653,'It has been... an honor.','',0,0,0,0,0,0,0,0,0,0,55341,0,26124),
(101654,'<Sevis paid the ultimate price so that you could use the Legion Gateway and summon in your Shivarra forces.>\n\n<Don\'t allow his sacrifice to have been made in vain.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101655,'Your sacrifice will NOT be in vain!','',0,0,0,0,0,0,0,0,0,0,55343,0,26124),
(101656,'Plenty of souls were sacrificed here. The activator is powered.','',0,0,0,0,0,0,0,0,0,0,55344,0,26124),
(101657,'I will move ahead and find Allari.','',0,0,0,0,0,0,0,0,0,0,55346,0,26124),
(101658,'$n, hurry! You don\'t have much time.','',0,0,0,0,0,0,0,0,0,0,55345,0,26124),
(101659,'Sevis looks down at the dying broken mystic.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101660,'This Ashtongue mystic will willingly sacrifice his soul for the cause if you\'re the one to do it.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(101661,'He was brave and proved himself worthy. We should all be so lucky to make the ultimate sacrifice in Lord Illidan\'s name.','',273,0,0,0,0,0,0,0,0,0,0,0,26124),
(101662,'I will see you at the final gateway.','',0,0,0,0,0,0,0,0,0,0,55347,0,26124),
(101663,'$n, we have a huge problem here.','',0,0,0,0,0,0,0,0,0,0,55342,0,26124),
(101664,'You will be the one dying today, demon!','',0,0,0,0,0,0,0,0,0,0,55348,0,26124),
(101665,'I\'ve been looking forward to this for a long time.','',0,0,0,0,0,0,0,0,0,0,55351,0,26124),
(101666,'For Lord Illidan! For the Illidari!','',0,0,0,0,0,0,0,0,0,0,55350,0,26124),
(101667,'You and me to the very end, $n.','',0,0,0,0,0,0,0,0,0,0,55349,0,26124),
(101668,'Thank you again for sparing my life. I trust you know that I\'d willingly sacrifice everything to further Lord Illidan\'s plan. The Burning Legion must be destroyed at any cost.\n\nI owe you everything, $n.\n\nNow, you must tell me how you survived. I killed you! It would seem the rumors about you are true... you\'re nearly as powerful as Illidan.','',2,0,0,0,0,0,0,0,0,0,0,0,26124),
(101669,'First troggs, now this? No matter. The mountaineers fight \'til the end!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101670,'When this is over, the boar ribs and malt are on me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101671,'','To arms, $n. This is not the time to be wandering about. Take shelter inside if you must.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101672,'','Apologies, but now is not the time $c.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101677,'My apologies, but now is not the time, $n.','My apologies, but now is not the time, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101678,'Find shelter! The others have gone inside for safety!','Find shelter! The others have gone inside for safety!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101679,'I\'ve never seen an attack quite like this!','I\'ve never seen an attack quite like this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101680,'So many injured already. Will you be the one who ends it, $n?','So many injured already. Will you be the one who ends it, $n?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101681,'The skies... have you ever seen anything like it?','The skies... have you ever seen anything like it?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101682,'Careful, $n. I just saw an infernal fall from the skies!','Careful, $n. I just saw an infernal fall from the skies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101683,'Have you seen them, $n? The demons... I just saw a shopkeep run by screaming! This is madness!','Have you seen them, $n? The demons... I just saw a shopkeep run by screaming! This is madness!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101684,'<The vrykul is bloody and is barely breathing.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101685,'Cenarius, the Lord of the Forest.$b$bNever have I seen him in such a state. Stay vigilant, friend. Our fragile world has been plunged into deep peril.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101686,'The airfield is under attack! Demons are everywhere. I\'ve sent the best of our fleet to hold \'em off.$B$BKeep at it down here! You\'re the best chance we\'ve got!','',0,0,0,0,0,0,0,0,0,924,0,0,26124),
(101687,'Not today, friend. Gotta finish helpin\' me lads reinforce our wares.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101688,'I owe you a great debt, $n. Thank you once again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101689,'Fly me to the Ironforge Airfield.','Fly me to the Ironforge Airfield.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101691,'','Let\'s keep hunting!',0,0,0,0,0,0,1,0,0,0,0,54852,26124),
(101692,'I\'m just trying to keep everyone fed until it\'s all over.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101693,'If those demons see you it\'s already too late.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101694,'Ye\'ve got ta calm yerself. We\'ve got the best in the lands out fightin\' right now.','Ye\'ve got ta calm yerself. We\'ve got the best in the lands out fightin\' right now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101695,'Just try and relax. We\'re all in this together.','Just try and relax. We\'re all in this together.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101696,'Die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101697,'Getting worked up won\'t help anyone. We have to try and stay calm.','Getting worked up won\'t help anyone. We have to try and stay calm.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101698,'We\'re down here underground while the whole world\'s bein\' torn apart!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101699,'Did ya see those things? How are we gonna defend against that?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101700,'How are we s\'pposed to stay calm? We\'re under attack!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101701,'Brandolf will sacrifice himself to kill Mal\'kess.','Brandolf will sacrifice himself to kill Mal\'kess.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101702,'Ironic, isn\'t it?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101703,'Can\'t say I\'ve ever been hit so hard before.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101704,'That\'s gonna leave a scar.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101705,'I\'m a cook, not a first aid trainer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101706,'Looks ok to me, but then again, I work with raw meat all day. For all I know it could be really bad.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101707,'At least you\'re alive.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101708,'Cold! No good cold! Hate hate hate.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101709,'Esteemed Archmages of the Council, may I present to you $n, bearer of Felo\'melorn.','',0,0,0,0,0,0,0,0,0,0,60482,0,26124),
(101710,'I am ready to aid you, Malfurion.','I am ready to aid you, Malfurion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101711,'','You cannot escape justice!',0,0,0,0,0,0,0,0,0,0,0,54507,26124),
(101712,'You will not defile this keep!','',0,0,0,0,0,0,0,0,0,0,54517,0,26124),
(101713,'May your soul feel the same torment as ours!','',0,0,0,0,0,0,0,0,0,0,54554,0,26124),
(101714,'Fire good, cold bad! Very bad cold.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101715,'Inscribe your name into the Libram of Ancient Kings so that we may begin the ceremony.','',0,0,0,0,0,0,1,0,0,0,63834,0,26124),
(101717,'','Brandolf! You resilient pup! I thought I was going to rot in that cage. Who is this $r?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101718,'Why did you kick me, you mongrel of Fenrir?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101719,'Brandolf? So, the little pup sniffed me out in this cave, eh?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101720,'Where\'s Torok?','',0,0,0,0,0,0,6,0,0,36915,54762,0,26124),
(101721,'You little pup! I see you have grown some sharp fangs.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101722,'Namha told me you had some new pet toy ideas?','Namha told me you had some new pet toy ideas?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101723,'Puny creature. I will grind you into the sand!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101724,'Free!','',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(101725,'The Tidemistress will end your pathetic lives.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101726,'','Leather pet toys? Let\'s see, now... a new leash might be nice. And I know the pets would appreciate a nice, soft bed to rest on.$b$bI\'ve always dreamed of fashioning a hoop for them to jump through. Preferably something we can light on fire. That would be quite the trick!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101727,'','Leather pet toys? Let\'s see, now... a new leash might be nice. And I know de pets would appreciate a nice, soft bed to rest on.$b$bI\'ve always dreamed of fashioning a hoop for them to jump through. Preferably something we can light on fire. Dat would be quite de trick!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101728,'You\'ll never take me alive!','',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(101729,'I\'m unleashed! One thousand years of darkness begins!','',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(101731,'Interesting. Like me, you have an immortal demon soul.','',0,0,0,0,0,0,0,0,0,0,55307,0,26124),
(101732,'You cannot truly die. Instead, your soul will make its way to the Twisting Nether. There, you will wait until you can find a suitable body to inhabit.','',0,0,0,0,0,0,0,0,0,0,55305,0,26124),
(101733,'Now get back into your corpse while there is still time and bring me the keystone!','',0,0,0,0,0,0,0,0,0,0,55308,0,26124),
(101734,'Does such weakness pass as strength where you come from, $n?','',0,0,0,0,0,0,6,0,0,0,54814,0,26124),
(101735,'Hahahaha!','',0,0,0,0,0,0,0,0,0,0,54766,0,26124),
(101736,'A cheap trick, calling for reinforcements... You\'re unworthy of this mountain!','',0,0,0,0,0,0,0,0,0,0,54767,0,26124),
(101738,'Navarrogg\'s toy won\'t do him any good against me.','',0,0,0,0,0,0,0,0,0,0,54785,0,26124),
(101739,'','You will die in the name of the Sashj\'tar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101740,'','Jandvik will fall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101741,'','As you can see, our former colleague followed through on his promise of assistance. I trust you will take that into account as you consider his request to be allowed back in the city.',0,0,0,0,0,0,1,0,0,0,0,60483,26124),
(101742,'If he wished to use the blade for his own ends, he would have simply given it to one of his Sunreavers.','',0,0,0,0,0,0,6,0,0,0,60485,0,26124),
(101743,'Aethas\'s actions appear to be genuine. I say we grant his request.','',0,0,0,0,0,0,273,0,0,0,60486,0,26124),
(101744,'How do we know he won\'t betray the Kirin Tor once again?','',0,0,0,0,0,0,603,0,0,0,60484,0,26124),
(101745,'','You have come, just as Emmarel said you would.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101746,'Very well, that\'s two in favor of allowing Aethas back into the city. Ansirem, how do you vote?','',0,0,0,0,0,0,1,0,0,0,60487,0,26124),
(101747,'I am ready to leave for Tideskorn Harbor.','I am ready to leave for Tideskorn Harbor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101748,'','Glad to see you. We need to stop in Highmountain before our ultimate goal of Stormheim.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(101749,'Very well, I trust the wisdom of Karlain\'s council. I vote yes.','',0,0,0,0,0,0,1,0,0,0,60488,0,26124),
(101750,'And what say the rest of you?','',0,0,0,0,0,0,6,0,0,0,60489,0,26124),
(101751,'%s nods approvingly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101752,'Yes, of course.','',0,0,0,0,0,0,1,0,0,0,60490,0,26124),
(101753,'Then it is decided. Aethas Sunreaver, you are free to go. Do not misuse this opportunity given to you.','',0,0,0,0,0,0,1,0,0,0,60491,0,26124),
(101754,'Bring her back in one piece!','Bring her back in one piece!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101755,'Take care of it!','Take care of it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101756,'Go get \'em!','Go get \'em!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101757,'Careful out there!','Careful out there!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101758,'Show \'em who\'s boss!','Show \'em who\'s boss!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101759,'Put that pedal to the metal!','Put that pedal to the metal!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101760,'I will not be contained!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101761,'You don\'t have the power to stop me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101762,'Shh... they\'ll hear you.','Shh... they\'ll hear you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101763,'They\'ll never see it coming.','They\'ll never see it coming.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101764,'It\'s safer in the shadows, $n.','It\'s safer in the shadows, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101765,'You\'re safe here, just don\'t be the $c that calls attention to yourself.','You\'re safe here, just don\'t be the $c that calls attention to yourself.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101766,'If they come for us, we\'ll be ready.','If they come for us, we\'ll be ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101767,'Seen any demons lurking around here?','Seen any demons lurking around here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101768,'You\'ll never get me back into that crystal!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101769,'Lord Azoran... how may I serve you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101770,'It appears we have guests, Vorgos... deal with them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101771,'My plan to destroy that wretched, floating city must not be disrupted!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101772,'As you wish, Master!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101773,'Do not fail me, Vorgos... you know what I do to those who fail me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101774,'','That was easier than expected. Most of the kvaldir must be off raiding.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101775,'Did you two have a plan?','Did you two have a plan?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101776,'','Wuho! Have you found the monster?',0,0,0,0,0,0,1,0,0,0,0,62674,26124),
(101777,'Not yet, but it is indeed the foe we seek. The kvaldir here speak of a giant cat that made its lair in the deep swamps. They raised a wall of magic wards to keep it at bay.','',0,0,0,0,0,0,1,0,0,0,62675,0,26124),
(101778,'','We must find a way through! Wuho, you and I should examine the wards while $n searches the harbor.',0,0,0,0,0,0,1,0,0,0,0,62676,26124),
(101779,'Mount up, $n. The Legion is not playing around. They\'ve unleashed their devastators.','',0,0,0,0,0,0,0,0,0,0,55256,0,26124),
(101780,'We barely made it through. Most of us, anyway. We\'re under bombardment up here, too.','',0,0,0,0,0,0,0,0,0,0,55255,0,26124),
(101781,'','Are you blind? Kill them!',0,0,0,0,0,0,0,0,0,0,0,55067,26124),
(101782,'Think they can just waltz in here without us putting up a fight? Me and my mechanostriders will see about that!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101783,'','Next infernal that falls better not hit another strider. We\'re running short on supplies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101784,'','If I see one more strider get destroyed today I\'m gonna... I\'m gonna... Trust me - something bad will happen!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101785,'','These could take years to fix!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101786,'','Who do they think they are coming in here, destroying our stuff, attacking the innocent - somebody needs to teach those demons a lesson...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101787,'','Destroyed my striders, singed my hair - if I see one more of those infernals I\'m gonna kick it in it\'s shins... if it has shins. If it doesn\'t I\'ll start throwin\' wrenches.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101788,'','Hopefully this ends soon. I\'ve got some work cut out for me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101789,'Fishes get in the bucket! You make good rotbrew!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101790,'Tasty, tasty Dwarves... Your gate won\'t hold forever!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101791,'Tiny Dwarves so foolish. Your bars and stone will not protect you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101792,'<The elemental gestures pleadingly at you and motions toward the hungry sharks encircling it. It speaks in a language you can\'t understand. Perhaps you can bring a shaman here to translate?>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101793,'<The elemental peers down at you treading water.>$b$bWhy, hello shaman! You are truly touched by the elements.$b$bCome, walk upon the water with me, so we may speak as equals. I need your help.$b$b<The elemental looks warily at the sharks encircling it.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101794,'Hail, Highlord.','Hail, Highlord.',0,0,0,0,0,0,66,0,0,36945,0,0,26124),
(101795,'Hail, Highlord.','Hail, Highlord.',0,0,0,0,0,0,66,0,0,36947,0,0,26124),
(101796,'Light bless you, $n. Azeroth would be lost to the Legion if it weren\'t for you.','Light bless you, $n. Azeroth would be lost to the Legion if it weren\'t for you.',0,0,0,0,0,0,66,0,0,36948,0,0,26124),
(101797,'Hail, Highlord.','Hail, Highlord.',0,0,0,0,0,0,66,0,0,36949,0,0,26124),
(101798,'Light bless you, $n. Azeroth would be lost to the Legion if it weren\'t for you.','Light bless you, $n. Azeroth would be lost to the Legion if it weren\'t for you.',0,0,0,0,0,0,66,0,0,36950,0,0,26124),
(101799,'Light bless you, $n. Azeroth would be lost to the Legion if it weren\'t for you.','Light bless you, $n. Azeroth would be lost to the Legion if it weren\'t for you.',0,0,0,0,0,0,66,0,0,36952,0,0,26124),
(101800,'Hail, Highlord.','Hail, Highlord.',0,0,0,0,0,0,66,0,0,36953,0,0,26124),
(101801,'Light bless you, $n. Azeroth would be lost to the Legion if it weren\'t for you.','Light bless you, $n. Azeroth would be lost to the Legion if it weren\'t for you.',0,0,0,0,0,0,66,0,0,36954,0,0,26124),
(101802,'<The ancient sea spirit speaks to you with warmth and respect.>$b$bShaman, turmoil in these seas has sapped me of my life essence and scattered it throughout the bay. It is driving these young sharks into a frenzy.$b$bWaterwalk across the waves and collect 10 globules of living water. Beware the sharks - if they drag you into the water you will lose what you have collected.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101803,'<The ancient sea spirit bows deeply.>$b$bThank you, shaman. You are truly a gift to the elements of Azeroth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101804,'|TInterface\\Icons\\Spell_Shadow_UnholyFrenzy:20|tWarlord Parjesh |cFFFF0000|Hspell:197064|h[Enrages]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(101805,'A new Treasure has been added to your map!','A new Treasure has been added to your map!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101806,'I carry on our traditions until one comes that can take my place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101807,'Grant me vision, and I will restore your spirit.','Grant me vision, and I will restore your spirit.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101808,'Load \'em up! I\'ll be dead \'fore we let \'em through!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101809,'','I may be cursed, but I can still teach others what I knew when I was alive.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101810,'Hands tired from loadin\' rounds? Good! Keep \'em working. It\'s our blood or theirs!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101811,'Fire again! Hit \'em hard!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101812,'Don\'t stop until you can\'t move or yer gun stops workin\' - then you can use yer fists!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101813,'This lodging is deplorable. I really must have a word with the innkeeper when he returns...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101814,'So he says to me, he goes,\"Demons are coming up number one on the agenda for hot pants! They\'re smoking!\"','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101815,'<Stalriss incomprehensibly mumbles.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101816,'Incoming!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101817,'Short fuse on its way out!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101818,'Mortar out!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101819,'Walk atop the sea and collect the living water! I have granted you enhanced sight so that you can better see the dangers that surround you.$b$bReturn to me when you have collected 10 globules of water...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101820,'','Big one goin\' out! Cover your ears!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101821,'','Short fuse \'bout to burn!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101822,'','Last one fragged before impact - reloading!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101823,'\"We shall drink of the Well again.\"','\"We shall drink of the Well again.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101824,'Thank you shaman! I feel my strength returning. Go with my blessing upon your weapon, and preserve the dignity of Azeroth\'s elements!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101825,'<The Nightborne regards you with suspicion.>$b$b If you are here for a fight, you are most foolish.. Leave now before I call the patrols and the might of Suramar puts an end to you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101826,'Looks like we\'ve got \'em boys! Just that big one left then we can go ho -','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101827,'What... what\'s that?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101828,'Lads, lasses - plant yer boots in the snow - this is gonna get messy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101829,'Somethin\'s rumblin\' and it ain\'t me tum!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101830,'%s moves his hands slowly over his belly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101831,'Youuuu DARE disrupt the portalsss of the Legion?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101832,'An Unpowered Legion Portal has been added to your map!','An Unpowered Legion Portal has been added to your map!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101833,'Always knew we could count on ye, champions! Come and see me when ye can. We\'ve got some supplies at our camp for ye!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101834,'Quite a bunch o\' fighters, aren\'t ye! Just a bit more cleanin\' up ta do!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101835,'Something stirs in the shallows. It may be the beast! Activate the wardstones!','',0,0,0,0,0,0,0,0,0,0,62677,0,26124),
(101836,'Quite the fighters, aren\'t ye! We can\'t thank ye enough. Just a bit more cleanin\' up ta do then ye come and see old Khrim fer some special supplies!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101837,'Bah! I grow weary of your errands, old one!','',0,0,0,0,0,0,0,0,0,0,62678,0,26124),
(101838,'<The desperate earth elemental gestures wildly at you, with rocks and pebbles flying in all directions. It speaks in a low rumble, growling words you can\'t understand. Perhaps a shaman can be brought here to investigate?>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101839,'<The ancient earth elemental is in great distress. It calls out to you:>$b$bPlease shaman! They... are silencing me...$b$bThe angry spirits... can you not see them?$b$bCrushing... me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101840,'Show me your tormentors, and I will help!','Show me your tormentors, and I will help!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101841,'','You are under my control now, demon. You will obey.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101842,'I\'ve got yer mail patterns here, $n, if you\'re looking to buy!','',0,0,1,0,0,0,0,0,0,0,0,0,26124),
(101843,'My master will have your soul!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101844,'You chose the wrong side, $r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101845,'Today will be your last!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101846,'This world will end!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101847,'The Light will guide us to victory.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(101848,'I would like to review weapons we might pursue.','I would like to review weapons we might pursue.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101849,'','We were just about to come find you. The wards block off the whole northern shallows.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101850,'Don\'t worry, I have a solution.','Don\'t worry, I have a solution.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101851,'%s cowardly scurries away.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101852,'%s panics and runs.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101853,'%s runs away.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101854,'','Ah, you found something in that nightmarish village?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101855,'<Show Apata the runes and explain how to cross the river.>','<Show Apata the runes and explain how to cross the river.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101856,'','Judge me all you like, sister, but you cannot stop us.',0,0,0,0,0,0,0,0,6,0,0,57309,26124),
(101857,'You are too late, Warden. This vault will be your tomb.','',0,0,0,0,0,0,0,0,6,0,57373,0,26124),
(101859,'','Demon hunters, you have to survive. Find the one named Archmage Khadgar. You can trust him.',0,0,0,0,0,0,0,0,6,0,0,57374,26124),
(101860,'','Wonderful! I can just attach them here and...',0,0,0,0,0,0,1,0,0,0,0,62682,26124),
(101861,'','Illidan is still my charge!',0,0,0,0,0,0,0,0,6,0,0,57375,26124),
(101862,'','It is done. Let us go across!',0,0,0,0,0,0,1,0,0,0,0,62683,26124),
(101863,'|TINTERFACE\\ICONS\\ability_socererking_arcanereplication.blp:20|t $n is marked with |cFFF00000|Hspell:196562|h[Volatile Magic]|h|r!','|TINTERFACE\\ICONS\\ability_socererking_arcanereplication.blp:20|t $n is marked with |cFFF00000|Hspell:196562|h[Volatile Magic]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(101864,'|TInterface\\Icons\\Spell_Shadow_SiphonMana.blp:20|t%s begins to |cFFF00000|Hspell:196392|h[Consume Mana]|h|r from a Mana Source!','|TInterface\\Icons\\Spell_Shadow_SiphonMana.blp:20|t%s begins to |cFFF00000|Hspell:196392|h[Consume Mana]|h|r from a Mana Source!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101865,'','Hurry, then. The Wardens are coming, with the Illidari in tow.',0,0,0,0,0,0,0,0,6,0,0,57327,26124),
(101866,'They ARE desperate.','',0,0,0,0,0,0,0,0,6,0,57328,0,26124),
(101867,'','My eldest sister, Alleria, has been missing for years. A demon we captured claims she is being held on a Legion world called Niskara by some sort of inquisition. Her return would be invaluable!',0,0,0,0,0,0,1,0,0,0,0,61781,26124),
(101868,'','Deprecated',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101869,'','Alleria\'s knowledge about the Legion could help us defeat them once and for all. Our goal is to reacquire a strategic asset... nothing more!',0,0,0,0,0,0,603,0,0,0,0,61783,26124),
(101870,'Admit it, Vereesa! This mission is personal!','',0,0,0,0,0,0,603,0,0,0,61782,0,26124),
(101871,'','There, up ahead! It\'s Orestes!',0,0,0,0,0,0,0,0,0,0,0,61794,26124),
(101872,'','You have done much for my people, $p. It is an honor to have you with us on this battlefront today.$b$bReady to face off against the Underking?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101873,'I\'m glad you could join us, $p.','',0,0,0,0,0,0,25,0,0,0,63765,0,26124),
(101874,'Charge!','Charge!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101875,'','We are discovered. Destroy $ghim:her;!',0,0,0,0,0,0,463,0,0,0,0,0,26124),
(101876,'I should be going with you. If this is a trap, you need my bow covering your backs!','',0,0,0,0,0,0,1,0,0,0,61863,0,26124),
(101877,'','No, Orestes. I won\'t risk anyone else until we\'re certain Alleria\'s there. I do not trust the demon\'s word. But this might be our only chance to save my... to retrieve a valuable ally.',0,0,0,0,0,0,274,0,0,0,0,61780,26124),
(101878,'We\'ve got it cornered, boys!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(101879,'They\'ll let us into the lodge for sure if we bring \'em this lion\'s head as a trophy!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(101880,'','Please, you don\'t understand... I\'m not game to be hunted!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101881,'Hey there.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(101882,'No, NO! I wasn\'t escaping! I was just going a different spot to dig!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101883,'Please don\'t hurt me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101884,'Stop them before they take me back!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101885,'Take me to Gol\'Bolar Quarry!','Take me to Gol\'Bolar Quarry!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101887,'Take me to Frostmane Front!','Take me to Frostmane Front!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101888,'Take me to the Gates of Ironforge!','Take me to the Gates of Ironforge!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101889,'Take me to Gol\'Bolar Quarry!','Take me to Gol\'Bolar Quarry!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101890,'','Almost there! Keep fighting!',0,0,0,0,0,0,0,0,0,0,0,61799,26124),
(101891,'','The inquisitor must be coming to interrogate Alleria! We have to save her!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101892,'','If Alleria is here, she must be close!',0,0,0,0,0,0,0,0,0,0,0,61796,26124),
(101894,'Sure is a lot bigger than the machines I\'m used to workin\' with.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101895,'Shoulda negotiated a higher rate. This thing is ginormous!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101896,'Surprised I got one working already. These things aren\'t built like anything I\'ve worked on before.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101897,'Surprised I got one working already. These things aren\'t built like anything I\'ve worked on before.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101898,'Well this coil does nothing. Hope you don\'t mind if I just throw it on the floor here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101899,'Ah, yep. This part\'s busted too. This could be a while, gents.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101900,'Oy... these demons are ruinin\' mah huntin\' getaway. May as well start huntin\' them for the trouble they\'re causin\'.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101901,'Follow us and we can work together to retake the airfield! Scrapper, let\'s go!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101902,'No... you cannot have the power.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101903,'This is as far as we go. Thanks for helpin\'. This hunter never forgets a friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101904,'An ambush! You were followed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101905,'I\'ve finally found you, little elf. You are not worthy of being our equal!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101906,'Stay back! It\'s mine!','',0,0,0,0,0,0,0,0,0,0,57762,0,26124),
(101907,'Thieves! The mana is MINE!','',0,0,0,0,0,0,0,0,0,0,57765,0,26124),
(101908,'No! I will not succumb!','',0,0,0,0,0,0,0,0,0,0,57759,0,26124),
(101909,'Get away from my mana!','',0,0,0,0,0,0,0,0,0,0,57758,0,26124),
(101910,'Go away!','',0,0,0,0,0,0,0,0,0,0,57757,0,26124),
(101911,'I will not be consumed!','',0,0,0,0,0,0,0,0,0,0,57756,0,26124),
(101912,'I warned you!','',0,0,0,0,0,0,0,0,0,0,57761,0,26124),
(101913,'Thieving wretch!','',0,0,0,0,0,0,0,0,0,0,57760,0,26124),
(101914,'More... more...','',0,0,0,0,0,0,0,0,0,0,57764,0,26124),
(101915,'No! I need more...','',0,0,0,0,0,0,0,0,0,0,57763,0,26124),
(101917,'When you have gained more strength, come and see me again.','',0,0,0,0,0,0,1,0,0,36998,0,0,26124),
(101918,'Coming!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101919,'Woops, sorry!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101920,'Oh, yes - sorry.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101921,'Sorry! Won\'t happen again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101922,'Coming up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101923,'Here it comes!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101924,'One wrench, coming up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101925,'','Wrench!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101926,'','Arnie! Wrench!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101927,'','Arnie! Quit diddling around!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101928,'','Hey! This ain\'t the time for sightseeing, kiddo!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101929,'Does your shirt itch? Mine itches... I\'m not sweating either.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101930,'How much longer you think \'til I\'m ready? I mean, it\'s been almost 3 weeks so far. Starting to consider myself to be quite the apprentice.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101931,'How do you get all the grime out from under your nails? Mine doesn\'t go away... and it smells funny.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101932,'This bucket is kinda heavy. If I hold it in this arm too long it falls asleep. My arm, I mean. Not the bucket.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101933,'Do your glasses get fogged? I don\'t know how to stop it. I only have about half my normal visibility.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101935,'','This is my fate as well... unless...',0,0,0,0,0,0,0,0,0,0,0,67514,26124),
(101936,'We\'ve got to hold \'em back! Our boys are strugglin\' ta keep \'em outta the Gates!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101937,'Hold the line! If they break us again we\'ll be pullin\' the troops back!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101938,'I\'ve ne\'er seen anythin\' like this before. They jus\' don\'t stop comin\'!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101939,'We\'ve got the higher ground. Use it against \'em!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101940,'Haven\'t lost a battle yet and I don\'t plan on losin\' one today!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101941,'For generations, the tauren of this mountain fought. Countless lives--even entire tribes--were lost.','',0,0,0,0,0,0,0,0,6,0,54798,0,26124),
(101942,'Once, upon returning from such a battle, Huln Highmountain found his people slaughtered by a previously unknown foe.','',0,0,0,0,0,0,0,0,6,0,54799,0,26124),
(101943,'Battling his grief, Huln spoke with the leaders of the remaining tribes. He convinced them to unite under one banner to oppose this new threat.','',0,0,0,0,0,0,0,0,6,0,54800,0,26124),
(101944,'I will tell you the story of Huln Highmountain.','',0,0,0,0,0,0,0,0,6,0,54801,0,26124),
(101945,'And now you will bear witness to Huln\'s trials...','',0,0,0,0,0,0,0,0,4,0,54802,0,26124),
(101946,'Take me to the Gates of Ironforge!','Take me to the Gates of Ironforge!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101947,'Take me to Frostmane Front!','Take me to Frostmane Front!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101948,'Highlord, I have found paladins worthy to stand by your side. I will meet you at Light\'s Hope Sanctum at once.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101950,'Prepare yourself $Glad:lass;. Fight\'s only beginnin\'.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101951,'We can\'t let them reach the Gates!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101952,'For the Alliance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101953,'Me beard... it\'s... it\'s - they\'re gonna pay fer this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101954,'I \'ppreciate it, $n. Now ye best get goin\' \'fore they come back.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101955,'Tell me the Story of Huln.','Tell me the Story of Huln.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101956,'','You have my thanks. Those hunters wouldn\'t have stopped until they had my head. Whatever they had is yours.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101957,'No... noooo! You shall never be free...','',0,0,0,0,0,0,0,0,0,0,57313,0,26124),
(101958,'... hammered...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101959,'Crush them, brother!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101960,'You shake them, I bash them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101962,'You\'ve seen better days, friend.','You\'ve seen better days, friend.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101963,'Not right now, $n. There are more pressing matters to attend to.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101964,'I will pry the answers from your corpse.','',0,0,0,0,0,0,0,0,0,0,57376,0,26124),
(101965,'Escape is but a dream.','',0,0,0,0,0,0,0,0,0,0,57377,0,26124),
(101966,'How do we know you\'re one we can trust? I\'ve heard whispers of dreadlords roaming about.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101967,'These are fragile times.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101968,'All hope is lost.','',0,0,0,0,0,0,0,0,0,0,57378,0,26124),
(101969,'You will never see the light of day!','',0,0,0,0,0,0,0,0,0,0,57379,0,26124),
(101972,'Your death will be swift and brutal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101974,'You cannot stem the Legion\'s tide!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101975,'I will cleave you in two!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101976,'These are the defenders of this world? Pitiful!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101977,'You shall fall, like the Wardens before you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101978,'Combat engineers here! Look out below!','Combat engineers here! Look out below!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101979,'Good as new. This engine packs quite a punch! Try it out on some of those big ones up near the airfield!','Good as new. This engine packs quite a punch! Try it out on some of those big ones up near the airfield!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(101983,'','It is... eerily quiet.',0,0,0,0,0,0,396,0,0,0,0,62684,26124),
(101984,'I cannot sense any beasts at all!','',0,0,0,0,0,0,396,0,0,0,62685,0,26124),
(101985,'','And yet, I am certain we are being watched...',0,0,0,0,0,0,0,0,0,0,0,62686,26124),
(101986,'','The beast is there! An\'she protect us!',0,0,0,0,0,0,0,0,6,0,0,62687,26124),
(101987,'Why would Maiev free us? There could only be one reason...','',0,0,0,0,0,0,0,0,0,0,57387,0,26124),
(101988,'The Legion is here.','',0,0,0,0,0,0,0,0,0,0,57388,0,26124),
(101989,'','|TInterface\\Icons\\spell_frost_frozenorb:20|t|cFFFF0000$n|r is the target of |cFFFF0000|Hspell:197365|h[Crushing Depths]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(101991,'Guardians of the ritual, prepare yourselves! She will not be disappointed!','',0,0,0,0,0,0,0,0,0,0,54192,0,26124),
(101992,'Hmph. Intruders. They will not get far.','',0,0,0,0,0,0,0,0,0,0,54193,0,26124),
(101993,'','Enter the portal and fight your way to Azoran.',0,0,0,0,0,0,0,0,0,0,0,67599,26124),
(101994,'I sit in chair one day.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(101995,'Fool! You would trust the Warden? She hates us almost as much as the Legion.','',0,0,0,0,0,0,0,0,0,0,57389,0,26124),
(101996,'They say only the pure can wield the highblade. Come, champion. Claim your destiny!','',0,0,0,0,0,0,0,0,0,0,58554,0,26124),
(101997,'I dig. I find. I keep!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(101998,'More wax, bigger candle. More candle, less dark.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(101999,'You trust no one and believe in nothing, Altruis. You are a leader with no followers.','',0,0,0,0,0,0,0,0,0,0,57390,0,26124),
(102000,'Why no have candle? Darkness eat you if no have candle!','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(102001,'No talk! Must dig!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102002,'','Defend yourselves!',0,0,0,0,0,0,0,0,0,0,0,62688,26124),
(102004,'','How can you defeat me while I control the wilds!?',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(102005,'I don\'t know why you thought you had something to prove. You coulda been back out there in your tanks by now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102006,'Just hang tight. I\'m used to fixing mechanical things, not dwarves.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102007,'Where\'s Maxon? He should probably take a look at you before you head back out.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102008,'','The power to destroy you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102009,'','More... I need more!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102010,'The inhabitants of The Crossroads have been inspired to join the fight against the Legion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102011,'Interloper... you\'re here to steal my mana, aren\'t you!?','',0,0,0,0,0,0,0,0,0,0,63230,0,26124),
(102012,'Here, then. Have a taste!','',0,0,0,0,0,0,0,0,0,0,63231,0,26124),
(102013,'Picking off my lieutenants? I suppose you think you\'re clever.','',0,0,0,0,0,0,0,0,0,0,63232,0,26124),
(102014,'Ishkaneth, you fool. You\'ve spilled your blood and you\'ve spilled my mana.','',0,0,0,0,0,0,0,0,0,0,63238,0,26124),
(102015,'Another soul for the Legion.','',0,0,0,0,0,0,0,0,0,0,55021,0,26124),
(102016,'All mortals will fuel the Soul Engines.','',0,0,0,0,0,0,0,0,0,0,55022,0,26124),
(102017,'','I worry for Oro\'s safety, but he has a duty to protect our tribe.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102018,'Let\'s see how you deal with this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102019,'No! Protect me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102020,'','Let\'s go.',0,0,0,0,0,0,0,0,4,0,0,55300,26124),
(102021,'Did that dragon send you, interloper? Or was it that beggar, Runas?','',0,0,0,0,0,0,0,0,0,0,63233,0,26124),
(102022,'I fought as hard as the rest of you! But I did not murder thousands of innocents.','',0,0,0,0,0,0,0,0,0,0,57386,0,26124),
(102023,'No matter. Soon you will all kneel before Azsuna\'s new prince!','',0,0,0,0,0,0,0,0,0,0,63234,0,26124),
(102024,'Wait, what are you doing? My siphons!','',0,0,0,0,0,0,0,0,0,0,63235,0,26124),
(102025,'You lowborn dirt. You don\'t know who you\'re dealing with. Hah... hah... haaaa ha ha ha haaaa!','',0,0,0,0,0,0,0,0,0,0,63236,0,26124),
(102026,'CUT SCENE PLACEHOLDER - Elune weeps over the death of Ysera and you get the tear of Elune.','CUT SCENE PLACEHOLDER - Elune weeps over the death of Elune and you get the tear of Elune.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102027,'','It went into that deep patch of mist. It could be hiding anywhere! Hero, do you have a trap strong enough to hold the beast?',0,0,0,0,0,0,0,0,4,0,0,62689,26124),
(102028,'Perhaps something explosive to disperse the mist? We are right behind you, master trapper. We will stand guard as you set it.','',0,0,0,0,0,0,0,0,0,0,62690,0,26124),
(102029,'Gaardoun?','',0,0,0,0,0,0,0,0,0,0,55267,0,26124),
(102030,'','Oro, how many times do I have to tell you not to run around with that stick in your hand?',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(102031,'','Oro, stay where I can see you!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(102032,'','If you fall into the water, your brother\'s not fishing you out!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102033,'','Have you had any bites Mycah?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(102034,'A few, but I think Oro\'s scaring away all the fish.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102035,'Your selection is not yet ready for testing. Please choose another.','Your selection is not yet ready for testing. Please choose another.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(102036,'So you hunt the Dark Riders as well? Long have I searched for a way to rid Duskwood of their curse, but now it seems I have become the hunted. \n\nThough we share a common enemy, the sins you bear prevent me from aiding your cause. The Light is not well served by taking power from one evil only to bestow it upon another.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102037,'The power would serve to defeat the Legion. You consider that an evil goal?','The power would serve to defeat the Legion. You consider that an evil goal?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102038,'I don\'t have time for your nonsense, priest! The Burning Legion is the greater threat!','I don\'t have time for your nonsense, priest! The Burning Legion is the greater threat!',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(102039,'If you will not tell me, I will strip the answers from your soul! <Attack>','If you will not tell me, I will strip the answers from your soul! <Attack>',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(102040,'I admit that the Legion is a great threat, but my duty is to the Light. \n\nI must stand vigilant against its enemies at all times, no matter how dire the situation appears.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102041,'To me, there is no greater threat than those who despoil the Light! \n\nI will not guide the hand of a sinner to power, no matter the ultimate cost!','',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(102042,'If we do not act, Sargeras will take this world. There will be no remnant of your Holy Light to follow. Where will your duty be then?','If we do not act, Sargeras will take this world. There will be no remnant of your Holy Light to follow. Where will your duty be then?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102043,'You are a fool! You\'ll cling to your Holy Light, even as the Legion purges this world. How will your Light serve you when you\'re left a slave?','You are a fool! You\'ll cling to your Holy Light, even as the Legion purges this world. How will your Light serve you when you\'re left a slave?',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(102044,'Forget this. I will take the answers I need! <Attack>','Forget this. I will take the answers I need! <Attack>',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(102045,'The Light will not falter so long as the brave hold it in their hearts. \n\nWe have seen it bring about the Legion\'s defeat before, and it will do so again.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102046,'It is you who are foolish, $c! \n\nThe Light is a bulwark for the faithful! It has aided us in holding back the Legion before, and it will do so again!','',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(102047,'You are wrong. I was at the Broken Shore. I saw the demons cut through our men, holy and unholy alike. If we cannot turn the tide now, we are all lost.','You are wrong. I was at the Broken Shore. I saw the demons cut through our men, holy and unholy alike. If we cannot turn the tide now, we are all lost.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102048,'I saw your holy warriors broken on the rocks outside the Tomb of Sargeras! This is unlike any Legion force we\'ve seen, and we\'ll need more than your Holy Light to drive it back this time!','I saw your holy warriors broken on the rocks outside the Tomb of Sargeras! This is unlike any Legion force we\'ve seen, and we\'ll need more than your Holy Light to drive it back this time!',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(102049,'Enough of this! You will answer me or die, priest! <Attack>','Enough of this! You will answer me or die, priest! <Attack>',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(102050,'If we wish to complete our goals, it is clear we must work together, $c. \n\nLet us not waste any more time.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102051,'I hear the truth in your words, $c. We may walk very different paths, but I see you fight for a noble cause.','',1,0,0,0,0,0,1,0,0,0,61902,0,26124),
(102052,'%s motions for you to follow.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102053,'Am not!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102054,'Take me to Dreadmist Camp!','Take me to Dreadmist Camp!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102055,'','We have a hard day ahead of us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102056,'%s nods approvingly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102058,'You stand in my way.','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(102059,'We stand with Highmountain.','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(102060,'Take me to Crossroads!','Take me to Crossroads!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102061,'','It claws at us from the mist! Hurry!',0,0,0,0,0,0,0,0,4,0,0,62691,26124),
(102062,'','It worked! Slay the monster!',0,0,0,0,0,0,0,0,4,0,0,62693,26124),
(102063,'Grab the keystone! Let\'s get to the portal down below and back to the Black Temple!','',0,0,0,0,0,0,0,0,0,0,55268,0,26124),
(102064,'$p! By the Light...','',0,0,0,0,0,0,0,0,0,0,63796,0,26124),
(102065,'','I\'ve caught you in my web.',0,0,0,0,0,0,0,0,0,0,0,55031,26124),
(102066,'','Hello, little fly.',0,0,0,0,0,0,0,0,0,0,0,55032,26124),
(102067,'','Your world will burn.',0,0,0,0,0,0,0,0,0,0,0,55033,26124),
(102068,'','Nowhere to hide now, precious.',0,0,0,0,0,0,0,0,0,0,0,55034,26124),
(102070,'','To all members and students of our combined schools, I offer you my thanks for joining us.',0,0,0,0,0,0,1,0,0,0,0,62002,26124),
(102073,'','The attack at the Peak of Serenity shows that the Burning Legion wishes to shatter our order. They will destroy our homes, defile our sacred temples, and strive to break our spirit.',0,0,0,0,0,0,1,0,0,0,0,62003,26124),
(102076,'But as we teetered upon the brink of annihilation, $n stayed with Grand Master Hight and fought the demons to ensure our survival.','',0,0,0,0,0,0,1,0,0,0,62004,0,26124),
(102077,'','Monks, our greatest challenge still lies ahead. Under our new master, we will send a message of defiance to our enemies. They will not take our home without a fight!',0,0,0,0,0,0,1,0,0,0,0,62010,26124),
(102078,'Grand Master Hight has passed on to join the ancestors, and we are left with a void in our ranks.','',0,0,0,0,0,0,1,0,0,0,62006,0,26124),
(102079,'','Let us all give honor to Master $n! May he lead us with strength and wisdom.',0,0,0,0,0,0,603,0,0,34243,0,62008,26124),
(102080,'','Let us all give honor to Master $n! May she lead us with strength and wisdom.',0,0,0,0,0,0,603,0,0,34244,0,62009,26124),
(102081,'We must leave now. Soon we will be home.','We must leave now. Soon we will be home.',0,0,0,0,0,0,0,0,0,0,65731,0,26124),
(102082,'Do not be afraid. Soon all will be set right.','Do not be afraid. Soon all will be set right.',0,0,0,0,0,0,0,0,0,0,65754,0,26124),
(102083,'Yes, I am ready. Let us make haste. I worry that we will be found by our enemies.','Yes, I am ready. Let us make haste. I worry that we will be found by our enemies.',0,0,0,0,0,0,0,0,0,0,0,65932,26124),
(102084,'I will tell you what I know.','',1,0,0,0,0,0,1,0,0,0,61903,0,26124),
(102085,'Your words are acid, but there is truth in them. Though I detest the methods you employ, it seems we may have no choice.','',1,0,0,0,0,0,1,0,0,0,61904,0,26124),
(102086,'Very well. I will tell you what I know.','',1,0,0,0,0,0,1,0,0,0,61905,0,26124),
(102087,'','Excellent! I have everything prepared inside. Follow me.',0,0,0,0,0,0,603,0,0,0,0,62005,26124),
(102088,'','Oro would not want me to lose myself in grief. I will be strong for him, and for our boys.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102089,'It seems fitting that the hero who fought at his side, who displayed courage and valor immeasurable, should succeed him.','',0,0,0,0,0,0,1,0,0,0,62007,0,26124),
(102090,'So be it! By the Light be purged!','',0,0,0,0,0,0,5,0,0,0,61901,0,26124),
(102091,'Enough! You have proven your power, warlock.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102092,'Such ferocity would better serve as an ally against the Legion than an enemy. I will aid you.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102093,'The fish only bite when my little brother\'s asleep. He\'s a lot for my mom to handle on her own.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102094,'I\'m going to be a Warbrave just like my dad when I grow up!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102095,'[PH] This is a test gossip because I haven\'t hooked things up for reals yet!','[PH] This is a test gossip because I haven\'t hooked things up for reals yet!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102096,'Please fire the event to start the \"Quality of Life\" event.','Please fire the event to start the \"Quality of Life\" event.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102097,'','Well done, $n. Now, make haste! We need your help to the west.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102098,'When you are ready, step through the portrait to teleport to Stormwind.','',0,0,0,0,0,0,1,0,0,26703,0,0,26124),
(102099,'We\'ve already directed a portrait to Stormwind for you, $n. Follow me, please.','',0,0,0,0,0,0,1,0,0,26703,0,0,26124),
(102100,'We are here.','We are here.',0,0,0,0,0,0,0,0,0,0,65729,0,26124),
(102101,'I don\'t understand. This isn\'t the city. Wher-','I don\'t understand. This isn\'t the city. Wher-',0,0,0,0,0,0,0,0,0,0,0,65933,26124),
(102102,'Silence. I tire of your prattling. Do not worry, it will all be over soon.','Silence. I tire of your prattling. Do not worry, it will all be over soon.',0,0,0,0,0,0,0,0,0,0,65730,0,26124),
(102103,'FEL MASTERS, I BRING YOU YOUR FINAL SACRIFICE! Nine times nine souls I have brought you, my own kith and kin!','FEL MASTERS, I BRING YOU YOUR FINAL SACRIFICE! Nine times nine souls I have brought you, my own kith and kin!',0,0,0,0,0,0,0,0,0,0,65740,0,26124),
(102104,'You should be proud, weakling. You are special to me, for you will be the instrument of my ascension.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102105,'So much power! I cannot be stopped!','So much power! I cannot be stopped!',0,0,0,0,0,0,0,0,0,0,65741,0,26124),
(102106,'','A glorious day is upon us!',0,0,0,0,0,0,0,0,0,0,0,54794,26124),
(102107,'','We entered this place as three tribes. Now, we are one.',0,0,0,0,0,0,1,0,0,0,0,54795,26124),
(102108,'','Together, we are Highmountain!',0,0,0,0,0,0,0,0,0,0,0,54796,26124),
(102109,'As Highmountain, we are one!','',0,0,0,0,0,0,0,0,0,0,54786,0,26124),
(102110,'','As Highmountain, we are one!',0,0,0,0,0,0,0,0,0,0,0,54759,26124),
(102111,'As Highmountain, we are one!','',0,0,0,0,0,0,0,0,0,0,54787,0,26124),
(102112,'Siege Worms! Fire on my mark!','',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(102113,'','Wuho! No!',0,0,0,0,0,0,0,0,0,0,0,62694,26124),
(102114,'','Beloved brother... I should never have brought you!',0,0,0,0,0,0,0,0,0,0,0,62695,26124),
(102115,'','Not again, beast! I will-- AAARGHH!!',0,0,0,0,0,0,0,0,0,0,0,62699,26124),
(102116,'','It is... over for me... you must... finish this.',0,0,0,0,0,0,0,0,6,0,0,62700,26124),
(102117,'Wh... what was that?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102118,'The Grand Magistrix exiled many Nightborne from Suramar. Those who did not agree with the bargain with the Legion, political enemies, and people she simply did not trust were all banished from the city.$b$bWe need to be united now more than ever. I bring them back into the city and they can access the Nightwell\'s energies again. The people I rescue are able to retain their magical abilities. I give them another chance at something greater.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102119,'','That was a wild shot! You\'re okay, right?',0,0,0,0,0,0,1,0,0,0,0,54840,26124),
(102121,'Your death will be swift and unmerciful.','',0,0,0,0,0,0,0,0,0,0,57004,0,26124),
(102122,'Wither before my might!','',0,0,0,0,0,0,0,0,0,0,57005,0,26124),
(102123,'You dare?!','',0,0,0,0,0,0,0,0,0,0,57006,0,26124),
(102124,'I am of Argus, the mightiest world in all of the Great Dark.','',0,0,0,0,0,0,0,0,0,0,57007,0,26124),
(102125,'Here\'s a small taste of my fel magic.','',0,0,0,0,0,0,0,0,0,0,57008,0,26124),
(102126,'','Learning to hunt is a dream come true.',0,0,0,0,0,0,1,0,0,0,0,54856,26124),
(102127,'','I think we make a pretty good team.',0,0,0,0,0,0,1,0,0,0,0,54853,26124),
(102128,'','I could do this with my eyes closed! But don\'t worry, I won\'t.',0,0,0,0,0,0,1,0,0,0,0,54848,26124),
(102129,'I serve.','',0,0,0,0,0,0,0,0,0,0,55194,0,26124),
(102130,'You will die by my blade.','',0,0,0,0,0,0,0,0,0,0,55195,0,26124),
(102131,'You are easily dealt with.','',0,0,0,0,0,0,0,0,0,0,55196,0,26124),
(102132,'Mortal flesh parts so easily.','',0,0,0,0,0,0,0,0,0,0,55197,0,26124),
(102133,'The Burning Legion conquers all.','',0,0,0,0,0,0,0,0,0,0,55198,0,26124),
(102134,'I will crush you.','',0,0,0,0,0,0,0,0,0,0,55331,0,26124),
(102135,'You\'re no match for me.','',0,0,0,0,0,0,0,0,0,0,55333,0,26124),
(102136,'Destroy!','',0,0,0,0,0,0,0,0,0,0,55334,0,26124),
(102137,'Hmm... medium or well-done?','',0,0,0,0,0,0,0,0,0,0,55210,0,26124),
(102138,'Feel my wrath!','',0,0,0,0,0,0,0,0,0,0,55368,0,26124),
(102139,'We are Legion.','',0,0,0,0,0,0,0,0,4,0,55369,0,26124),
(102140,'','|TInterface\\Icons\\inv_misc_monsterspidercarapace_01:20|t%s disappears |cFFFF0000|Hspell:197414|h[Into the Shadows]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102141,'Let\'s see what you\'re made of, tiny thing.','',0,0,0,0,0,0,0,0,0,0,55152,0,26124),
(102142,'','I\'m so hungry.',0,0,0,0,0,0,0,0,0,0,0,55211,26124),
(102143,'','My meal comes to me.',0,0,0,0,0,0,0,0,0,0,0,55212,26124),
(102144,'','Climb inside my mouth, tiny thing.',0,0,0,0,0,0,0,0,0,0,0,55213,26124),
(102145,'','Come, my little imps, dance for mother.',0,0,0,0,0,0,0,0,0,0,0,55214,26124),
(102146,'','My children will cook you up nicely.',0,0,0,0,0,0,0,0,0,0,0,55215,26124),
(102147,'','You\'ll die for this!',0,0,0,0,0,0,0,0,0,0,0,55216,26124),
(102148,'','Have you come to play with my little imps?',0,0,0,0,0,0,0,0,0,0,0,55217,26124),
(102149,'','The Legion\'s victory is inevitable, child.',0,0,0,0,0,0,0,0,0,0,0,55218,26124),
(102150,'','I\'ll deliver you to Tyranna myself.',0,0,0,0,0,0,0,0,0,0,0,55219,26124),
(102151,'','Filthy, little elf. I can taste the fel energy on you.',0,0,0,0,0,0,0,0,0,0,0,55220,26124),
(102152,'','Intruders! Someone warn the doom commander!',0,0,0,0,0,0,0,0,0,0,0,55221,26124),
(102153,'I see you.','',0,0,0,0,0,0,0,0,0,0,55372,0,26124),
(102154,'You\'ll tell me your secrets before you die.','',0,0,0,0,0,0,0,0,0,0,55373,0,26124),
(102155,'You cannot hide from me.','',0,0,0,0,0,0,0,0,4,0,55374,0,26124),
(102156,'This should prove enlightening.','',0,0,0,0,0,0,0,0,0,0,55375,0,26124),
(102157,'I don\'t need you alive to know your secrets.','',0,0,0,0,0,0,0,0,0,0,55376,0,26124),
(102158,'So many questions, so little time.','',0,0,0,0,0,0,0,0,0,0,55377,0,26124),
(102159,'My eyes see all.','',0,0,0,0,0,0,0,0,0,0,55378,0,26124),
(102160,'I\'ll break your will.','',0,0,0,0,0,0,0,0,0,0,55379,0,26124),
(102161,'','Where is the Tidestone? Speak, you fool!',0,0,0,0,0,0,0,0,0,0,0,63239,26124),
(102162,'','Worthless...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102163,'Im... impossible.','',0,0,0,0,0,0,0,0,0,0,65688,0,26124),
(102164,'The shal\'dorei will rule this world!','',0,0,0,0,0,0,0,0,0,0,65698,0,26124),
(102165,'Arash-falas...','',0,0,0,0,0,0,0,0,0,0,65689,0,26124),
(102166,'Tor\'theras falar!','',0,0,0,0,0,0,0,0,0,0,65690,0,26124),
(102167,'My magic... defeated?','',0,0,0,0,0,0,0,0,0,0,65691,0,26124),
(102168,'This cannot be...','',0,0,0,0,0,0,0,0,0,0,65692,0,26124),
(102169,'War rages in my heart, $n. We will have vengeance... for Gilneas, and for the Alliance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102170,'Why not deliver the letter yourself, Lord Greymane?','Why not deliver the letter yourself, Lord Greymane?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102171,'The shadows of the underworld bend to me!','',0,0,0,0,0,0,0,0,0,0,54357,0,26124),
(102172,'','Our forces don\'t stand a chance against that. We must evacuate everyone left or this will have been for naught.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102173,'The shadows of Helheim cut deeper than steel!','',0,0,0,0,0,0,0,0,0,0,54358,0,26124),
(102174,'COWER BEFORE ME!','',0,0,0,0,0,0,0,0,0,0,54359,0,26124),
(102175,'FLEE, COWARDS!','',0,0,0,0,0,0,0,0,0,0,54360,0,26124),
(102176,'CRAVEN MAGGOTS!','',0,0,0,0,0,0,0,0,0,0,54361,0,26124),
(102177,'Know the bitter chill of death as I have!','',0,0,0,0,0,0,0,0,0,0,54362,0,26124),
(102178,'The winds of the frozen north still howl in these veins!','',0,0,0,0,0,0,0,0,0,0,54364,0,26124),
(102179,'We have no time, Lynore! He will be here within seconds...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102180,'You have not won... The Naglfar comes... for you...','',0,0,0,0,0,0,0,0,0,0,54363,0,26124),
(102181,'You have not won... You have only... secured your own doom...','',0,0,0,0,0,0,0,0,0,0,54365,0,26124),
(102182,'Not... again... HARBARON! CAST THEIR SOULS INTO THE TIDES!','',0,0,0,0,0,0,0,0,0,0,54366,0,26124),
(102183,'','We must distract him. $n, will you stand with me? We must buy enough time for our brethren, though it will surely cost us our lives.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102184,'I will.','I will.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102185,'Another drop in the sea of souls!','',0,0,0,0,0,0,0,0,0,0,54367,0,26124),
(102186,'Vengeance!','',0,0,0,0,0,0,0,0,0,0,54368,0,26124),
(102187,'PAYBACK!','',0,0,0,0,0,0,0,0,0,0,54369,0,26124),
(102188,'A true captain will die for his cause! I will stand with you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102189,'Mortals... Your wretched kind murdered MY people... destroyed MY kingdom! Long have I waited for a chance to repay what was done to me!','',0,0,0,0,0,0,0,0,0,0,54370,0,26124),
(102190,'Mortals... Your wretched kind murdered MY people... destroyed MY kingdom! Now you, too, will know what it feels like to lose EVERYTHING!','',0,0,0,0,0,0,0,0,0,0,54371,0,26124),
(102191,'Mortals... I fell to your wretched kind once before. It WILL NOT happen again!','',0,0,0,0,0,0,0,0,0,0,54403,0,26124),
(102192,'','So be it. $n, Nazgrel... it will be an honor to die by your side.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102193,'Your souls will drift for eternity in the tides of the underworld!','',0,0,0,0,0,0,0,0,0,0,54404,0,26124),
(102194,'I will carve a new crown from your bones!','',0,0,0,0,0,0,0,0,0,0,54405,0,26124),
(102195,'I have learned from my past defeats... It seems you have not.','',0,0,0,0,0,0,0,0,0,0,54406,0,26124),
(102196,'You see now the weakness in your mortal shell?','',0,0,0,0,0,0,0,0,0,0,54375,0,26124),
(102197,'Bend and break, your soul I\'ll take!','',0,0,0,0,0,0,0,0,0,0,54374,0,26124),
(102198,'The flesh burdens the soul. A nuisance that must be flayed from your bones!','',0,0,0,0,0,0,0,0,0,0,54384,0,26124),
(102199,'Spirits! Sweep these mortals into the tides!','',0,0,0,0,0,0,0,0,0,0,54385,0,26124),
(102200,'If I cannot bleed the payment from you, the spirits will!','',0,0,0,0,0,0,0,0,0,0,54386,0,26124),
(102201,'The spirits grow hungry from the scent of blood.','',0,0,0,0,0,0,0,0,0,0,54387,0,26124),
(102202,'Arise, servitor! Claim our blood debt!','',0,0,0,0,0,0,0,0,0,0,54388,0,26124),
(102205,'All who enter Helheim must pay the blood price. Resist if you wish... In the end, I always get my payment!','',0,0,0,0,0,0,0,0,0,0,54378,0,26124),
(102206,'New passengers... New souls. I will guide you to the depths of Helheim for a small price: your flesh and blood.','',0,0,0,0,0,0,0,0,0,0,54373,0,26124),
(102207,'As I said... I always get my payment!','',0,0,0,0,0,0,0,0,0,0,54381,0,26124),
(102208,'Another blood debt claimed... Another soul cast into the abyss.','',0,0,0,0,0,0,0,0,0,0,54382,0,26124),
(102209,'Everyone must pay the blood price!','',0,0,0,0,0,0,0,0,6,0,54383,0,26124),
(102210,'Now... it is I who must pay... the blood price...','',0,0,0,0,0,0,0,0,0,0,54377,0,26124),
(102211,'Helya will make you pay... In the end, everyone pays...','',0,0,0,0,0,0,0,0,0,0,54379,0,26124),
(102212,'','You ALL will regret trespassing in my realm.',0,0,0,0,0,0,0,0,0,0,0,54395,26124),
(102213,'','You have come far enough. Time to die.',0,0,0,0,0,0,0,0,0,0,0,54180,26124),
(102214,'','It is finished. I banish your weak, mortal souls forevermore.',0,0,0,0,0,0,0,0,0,0,0,54243,26124),
(102215,'','Your soul will find no shelter here.',0,0,0,0,0,0,0,0,0,0,0,54394,26124),
(102216,'','Begone to the next life.',0,0,0,0,0,0,0,0,0,0,0,54393,26124),
(102217,'','Your fate rains down!',0,0,0,0,0,0,0,0,0,0,0,54392,26124),
(102218,'','I will drown you all like rats.',0,0,0,0,0,0,0,0,0,0,0,54400,26124),
(102219,'','Hold still!',0,0,0,0,0,0,0,0,0,0,0,54401,26124),
(102220,'','Stop squirming!',0,0,0,0,0,0,0,0,0,0,0,54402,26124),
(102221,'','You will pay for that.',0,0,0,0,0,0,0,0,0,0,0,54244,26124),
(102222,'','I am losing my patience.',0,0,0,0,0,0,0,0,0,0,0,54245,26124),
(102223,'','No! This is not possible!',0,0,0,0,0,0,0,0,0,0,0,54389,26124),
(102224,'Cave seems safe, boss.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(102225,'You tall for boss.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(102226,'Not lazy! Guarding.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(102227,'','What manner of creatures ARE you??',0,0,0,0,0,0,0,0,0,0,0,54390,26124),
(102228,'','Embrace your fate, fools!',0,0,0,0,0,0,0,0,0,0,0,54391,26124),
(102229,'','An eternity of agony awaits you!',0,0,0,0,0,0,0,0,0,0,0,54399,26124),
(102230,'','I have had enough! THIS. ENDS. NOW.',0,0,0,0,0,0,0,0,0,0,0,54398,26124),
(102231,'','Curse you all! Do you really think to conquer MY domain? All of Helheim will stand against you...',0,0,0,0,0,0,0,0,0,0,0,54397,26124),
(102232,'','ALL SOLDIERS, RETREAT! Take the wounded, get to the ship!',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(102234,'Chair empty. I sit, no one notice?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102235,'You boss around and I help!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102237,'Tess and Commander Crowley will escort you to the Keep. I need to stay and oversee preparations.','',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(102241,'','It is customary in Highmountain to pay for goods. If you need Airspark, speak with me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102243,'Snazzle good worker. I pick just for you.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102244,'This one has dull mind, but sharp chisel.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102245,'Dug not best. Dug good enough though.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102246,'Too slow! Boss not have all day.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102247,'I just in time for job!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102248,'I poke it dead for you, boss!','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(102249,'Move too fast, candle blow out. Darkness eat me!','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(102250,'You pick best digger!','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(102251,'You do good! Boss is the bossiest.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(102252,'','When you face the worms, call to us, and we shall be there.',0,0,0,0,0,0,0,0,0,0,0,54897,26124),
(102253,'It\'s been a long time since I was last upon the Wandering Isle.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102254,'Good drink, good friends, and good music.$b$bThese are truly some of the finer things in life.','',11,0,0,0,0,0,0,0,0,0,0,0,26124),
(102255,'Children of the deep, rise and crush these shan ronir!','',0,0,0,0,0,0,0,0,6,0,54898,0,26124),
(102256,'You no take candle! If candle go out, darkness eat.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(102257,'Boss has big ears. They hold most wax. Fresh wax makes best candles.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(102258,'Do not disturb these waters!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102259,'This water is sacred!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102260,'Mu\'sha\'s Tears are not for the mundane!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102261,'The magic of this place is not yours to take!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102262,'This crystal belongs to the earth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102263,'','King Anduin, the hero of the Broken Shore approaches.',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(102264,'I\'ve heard you saw my father\'s final moments.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102265,'Tell me how he died.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102266,'','Justice will triumph in the end. I am sure of it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102267,'','Augh! Why did I think visiting Pop was going to be a good idea?!$b$bAll he does is sit around and eat. Even big bro would rather hang out in the tavern instead of exploring. Bohhhring!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(102268,'Speak to me when you are ready and I will permit you to enter Grommash Hold.$b$bBut remember, these are dire times, $n. You must be prepared.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(102269,'Turn away to avoid |cFFFF0000|Hspell:197737|h[Predator\'s Gaze]|h|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102270,'For the Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102271,'Taste my axe!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102272,'Protect the Warchief!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102273,'','Keep a fire burning in your heart, $c, that others may feel your warmth, and through you rekindle their own spirit.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102274,'<On the other side of the portcullis, you can see a series of tunnels that lead to Ravencrest Cemetary.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102275,'Leave the Darkpens.','Leave the Darkpens.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102276,'Senegos, we seek one of the Pillars of Creation. I know it is here on Azsuna.','',0,0,0,0,0,0,1,0,0,0,62420,0,26124),
(102277,'You speak of the Tidestone of Golganneth. It was shattered long ago.','',0,0,0,0,0,0,0,0,0,0,60184,0,26124),
(102278,'The Tidestone... shattered? How?','',0,0,0,0,0,0,0,0,0,0,60185,0,26124),
(102279,'I do not know... but I know where the pieces lie.','',0,0,0,0,0,0,0,0,0,0,60186,0,26124),
(102280,'Defilers... I can smell the Nightmare in your blood. Be gone from these woods or suffer nature\'s wrath!','',0,0,0,0,0,0,0,0,0,0,54145,0,26124),
(102281,'Defilers... so it is you who have befouled these woods with the Nightmare.','',0,0,0,0,0,0,0,0,0,0,54146,0,26124),
(102282,'Aludane, I have urgent business in Val\'sharah. Can you secure a flight for me?','Aludane, I have urgent business in Val\'sharah. Can you secure a flight for me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102283,'Kill her! Protect the grove!','Kill him! Protect the grove!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102284,'Leave Dalaran for Val\'sharah?','Leave Dalaran for Val\'sharah?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102285,'I will bleed the Nightmare from you!','',0,0,0,0,0,0,0,0,0,0,54147,0,26124),
(102286,'By tooth and claw be purged!','',0,0,0,0,0,0,0,0,0,0,54148,0,26124),
(102287,'I am the vessel of nature\'s fury!','',0,0,0,0,0,0,0,0,0,0,54149,0,26124),
(102288,'I am nature\'s fury incarnate!','',0,0,0,0,0,0,0,0,0,0,54150,0,26124),
(102289,'Andu-falah-dor!','',0,0,0,0,0,0,0,0,0,0,54151,0,26124),
(102290,'Be purified in the light of the stars!','',0,0,0,0,0,0,0,0,0,0,54156,0,26124),
(102291,'I am one with the flows of nature!','',0,0,0,0,0,0,0,0,0,0,54159,0,26124),
(102292,'Nature graces me with its bounty!','',0,0,0,0,0,0,0,0,0,0,54158,0,26124),
(102293,'The wilds sustain me!','',0,0,0,0,0,0,0,0,0,0,54157,0,26124),
(102294,'Only death can free you from the Nightmare.','',0,0,0,0,0,0,0,0,0,0,54163,0,26124),
(102295,'Your blood reeks of corruption.','',0,0,0,0,0,0,0,0,0,0,54162,0,26124),
(102296,'Stay down, defiler!','',0,0,0,0,0,0,0,0,0,0,54161,0,26124),
(102297,'The wilds are safe from the Nightmare once again.','',0,0,0,0,0,0,0,0,0,0,54152,0,26124),
(102298,'The Nightmare will not take root in these sacred woods.','',0,0,0,0,0,0,0,0,0,0,54160,0,26124),
(102299,'I see now... I am the defiler...','',0,0,0,0,0,0,0,0,0,0,54153,0,26124),
(102300,'The Nightmare... clouds my thoughts no more...','',0,0,0,0,0,0,0,0,0,0,54154,0,26124),
(102301,'I just had... the strangest nightmare...','',0,0,0,0,0,0,0,0,0,0,54155,0,26124),
(102302,'The ocean will sweep you away!','',0,0,0,0,0,0,0,0,0,0,54164,0,26124),
(102303,'Seas! Obey my command!','',0,0,0,0,0,0,0,0,0,0,54310,0,26124),
(102304,'BUURRRP','',0,0,0,0,0,0,0,0,0,0,54311,0,26124),
(102305,'How long can you hold your breath, I wonder?','',0,0,0,0,0,0,0,0,0,0,54312,0,26124),
(102306,'Pity you cannot survive without air!','',0,0,0,0,0,0,0,0,0,0,54313,0,26124),
(102307,'Before the crashing waves come the quake!','',0,0,0,0,0,0,0,0,0,0,54314,0,26124),
(102308,'The earth trembles before the rising tide!','',0,0,0,0,0,0,0,0,0,0,54315,0,26124),
(102309,'The oceans rest... but the wind still rises against you.','',0,0,0,0,0,0,0,0,0,0,54320,0,26124),
(102310,'Gaaah... The winds will finish you, intruders.','',0,0,0,0,0,0,0,0,0,0,54322,0,26124),
(102311,'You haven\'t won. She is almost here...','',0,0,0,0,0,0,0,0,0,0,54318,0,26124),
(102312,'I failed... but my Queen will NOT.','',0,0,0,0,0,0,0,0,0,0,54319,0,26124),
(102313,'Justice for the son you murdered!','',0,0,0,0,0,0,0,0,0,0,54326,0,26124),
(102314,'Blood repays blood.','',0,0,0,0,0,0,0,0,0,0,54329,0,26124),
(102315,'You weaklings will drown beneath these waves!','',0,0,0,0,0,0,0,0,0,0,54316,0,26124),
(102316,'You killed my son! Your punishment is death!','',0,0,0,0,0,0,0,0,0,0,54317,0,26124),
(102317,'This was as inevitable as the tides, fools.','',0,0,0,0,0,0,0,0,0,0,54332,0,26124),
(102318,'I found shiniest shinies for boss!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102319,'I have just the beast for this special task.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102320,'Killed biggest basilisk! And heaviest...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102321,'Where is Dug? Should be back. Boss go find.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(102322,'','Enough of these games. This ends here!',0,0,0,0,0,0,0,0,0,0,0,54177,26124),
(102323,'','Burn in the flames!',0,0,0,0,0,0,0,0,0,0,0,54178,26124),
(102324,'','From the ashes!',0,0,0,0,0,0,0,0,0,0,0,54179,26124),
(102325,'I am yours to command.','I am yours to command.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102326,'I will heal you, $n.','I will heal you, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102327,'I won\'t let you fall!','I won\'t let you fall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102328,'Get back in the fray!','Get back in the fray!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102329,'The light will cleanse us all, soldier.','The light will cleanse us all, soldier.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102330,'Behold the skittering denizens of the dark!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102331,'Creeping horrors... they\'ll tickle your skin... looking for a way IN.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102332,'Nature\'s darker minions... creeping, crawling, scattering from the light. Looking to have just one bite.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102333,'You must appreciate nature in all its many forms.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102334,'Why is everyone always in such a hurry?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102335,'Stand still and listen when my sister is talking to you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102336,'Why all the haste to depart? Vardalla has a message for you... straight to the heart!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102337,'Hey, slow down! Where\'s the fire?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102338,'Nature, you see, is a paradox... infinite beauty coupled with merciless lethality.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102339,'So many wonderful things to see... take care though, to know where danger be.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102340,'I have cultivated a gift for you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102341,'Go ahead, get close... take a big sniff.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102342,'Hey... there is a fungus among us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102343,'Such is the... cycle of nature.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102344,'Yes! I am ready... to embark on my... new adventure...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102345,'Farewell sister! I would say it has been a pleasure, but I do not wish my final words to be a lie.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102346,'So much was given for me to know... yet into the unknown now must I go.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102347,'Life, death... all the same, really.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102348,'You will make great compost...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102349,'Farewell, to you, I say! Tomorrow might have been a brighter day.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102350,'There will be more than enough to go around!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102351,'I\'ve opened a minor portal to help the wounded get to the ship more quickly.','I\'ve opened a minor portal to help the wounded get to the ship more quickly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102352,'Nature welcomes you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102353,'We have guests! Or, perhaps I should say, pests!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102354,'Pests exterminated.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102355,'Here in defeat, bold intruders fell. What inspired such overconfidence? No one may tell.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102356,'Nobody has successfully wielded the weapons of the Keeper of Storms. Will you be the first?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102357,'Let this serve as a lesson to all who would threaten nature\'s tranquility!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102358,'','DON\'T RUN!  They don\'t like it when you run, see?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102359,'','You all... need to... WAIT YOUR TURN!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102360,'','STAY! If you don\'t want to stay, I\'ll MAKE you stay!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102361,'','I insist you stay right here. You don\'t want to miss any of the FUN!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102362,'','Just relax. Let your cares melt away.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102363,'','This might burn a little... or a LOT.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102364,'','He\'ll stop the world and I\'ll MELT YOU!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102365,'','I don\'t get under your skin... I BURN right through it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102366,'','You might feel a liiiittle prick. Followed by a slow and painful death.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102367,'','I\'m not mad at you... I just want you to SUFFER AND DIE!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102368,'','Death should be savored, like a fine wine. Enjoy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102369,'','I like you, I really do! That\'s why I\'m going to make your death slow and excruciating.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102370,'Welcome back to Stormwind, $n. I\'m relieved you survived the Broken Shore.$b$bWe could not afford to lose you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102371,'','Not fair, NOT FAIR!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102372,'','Wait a minute it\'s all clear to me now... the Nightmare had me insane, I-agh, ack! Aaaghhh...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102373,'','Ooohh where am I off to now? I hope there\'s trees...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102374,'','And so I fall! Like a leaf... in fall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102375,'','Hope your muscles don\'t get tired from pushing up all those daisies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102376,'I come bearing a letter from your father.','I come bearing a letter from your father.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102377,'','Is it painful? No, really I want to know!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102378,'','Time to go sleepy-bye!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102379,'','BACK OFF, NUADA! I saw them first!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102380,'','I didn\'t know we had a play date!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102381,'','You were NOT INVITED! But I just love surprises!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102382,'','Well I don\'t know WHAT that was all about...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102383,'','That was like success... but the opposite.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102384,'','What HE said!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102385,'Thandae-alah...','',0,0,0,0,0,0,0,0,0,0,66044,0,26124),
(102386,'Trespasser...','',0,0,0,0,0,0,0,0,0,0,66052,0,26124),
(102387,'Desecrator...','',0,0,0,0,0,0,0,0,0,0,66045,0,26124),
(102388,'You will be cold... like us.','',0,0,0,0,0,0,0,0,0,0,66053,0,26124),
(102389,'Feel the chill of the grave!','',0,0,0,0,0,0,0,0,0,0,66046,0,26124),
(102390,'Elisande... stop her...','',0,0,0,0,0,0,0,0,0,0,66054,0,26124),
(102391,'I will rest now.','',0,0,0,0,0,0,0,0,0,0,66047,0,26124),
(102392,'Your reputation precedes you, $c. I am told you were at the front lines on the Broken Shore. You, more than any other, know what our world is up against.$b$bIf you seek the weapons once possessed by Ra-den, the Keeper of Storms, know that many have tried to wield their power and none have succeeded. You will face a series of challenges, but make no mistake... the weapons themselves will be the most dangerous test of all.$b$bDo you wish to continue?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102393,'Our people... shu dalees-na.','',0,0,0,0,0,0,0,0,0,0,66051,0,26124),
(102394,'What has become of us?','',0,0,0,0,0,0,0,0,0,0,66048,0,26124),
(102395,'I am ready, White Tiger.','I am ready, White Tiger.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102396,'Finally, we rest.','',0,0,0,0,0,0,0,0,0,0,66049,0,26124),
(102397,'Peace...','',0,0,0,0,0,0,0,0,0,0,66050,0,26124),
(102401,'Get off our mountain!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102402,'I smell blood in the forest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102403,'I\'ll tear your arms off!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102404,'You came to the wrong place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102405,'You will know my strength!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102406,'Our allies give us power!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102407,'Torok will be pleased with your death!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102408,'The Feltotem will own this mountain!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102409,'','Vol\'jin...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102410,'Saved us... I worry the Alliance will think we left them for dead.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102411,'... and what will you have us do, Warchief?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102412,'Arille, get me a drink!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102413,'My father was a seasoned strategist, yet his army was shattered on the Broken Shore. How can I hope to succeed where he failed?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102414,'You are not alone in this, My King. We stand behind you.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102415,'','Have you forgotten the Horde\'s treachery? It\'s time to bring them to heel like the dogs they are!',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(102416,'To fight two wars at once would be folly. For all our sakes, we need the Horde\'s strength added to our own.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102417,'Velen is right. We must stand beside the demon hunters and focus on the Legion. Now is not the time to--','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102418,'','The Horde betrayed your father and left us to die! To fight alongside those cowards would dishonor everything he stood for.',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(102419,'Cowards, both of you. King Anduin, you know what we must do. We must strike quickly, to scatter the Horde to the winds and let them fend for themselves against the Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102420,'','And with the return of the Illidari, we have a valuable weapon on our side. You were wise to accept them into Stormwind, King Anduin.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102421,'My people know the price of facing the demons as a world divided. It is time to unite our forces and defend our lands.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102422,'Your first trial is a test of strength. This vrykul champion also seeks the weapons of storm on behalf of his clan. Only one of you may pass.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102423,'Agreed. I\'m sorry, Jaina, but vengeance must wait. I trust you\'re mobilizing the Kirin Tor as we discussed?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102424,'I am ready to fight!','I am ready to fight!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102425,'Good to see you, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102426,'All quiet around the lodge, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102427,'Always good to have you around camp, commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102428,'<The vrykul warrior scoffs at you.>$b$bYou are to be my first test? Bah! I have scars more intimidating than you.','',15,0,0,0,0,0,0,0,0,0,0,0,26124),
(102429,'Two Kings Defeated','Two Kings Defeated',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102430,'I have bested the kraken. I have slain giants. You are nothing!','',15,0,0,0,0,0,15,0,0,0,60662,0,26124),
(102431,'I... yield...','',0,0,0,0,0,0,0,0,0,0,60663,0,26124),
(102432,'This isn\'t over, shaman. Someday we will meet on a true field of battle.','',0,0,0,0,0,0,0,0,0,0,60664,0,26124),
(102433,'','Elune... guide me...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102435,'','Come back here once you have freed those soliders, $n. Elune be with you.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102436,'DO NOT LOCALIZE','DO NOT LOCALIZE',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102439,'','The innocent will not die in vain. They will die for the Horde.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102440,'','Broken Shore was just the beginning. The Legion\'s forces grow stronger as we speak. Soon we will not be able to match their power.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102441,'','And the Alliance? They have no honor. Given the opportunity, they will strike when we are weak.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102442,'','As for the Warchief, he assumes the required knowledge lies with the Kirin Tor. I\'m sure Khadgar will be most pleased by his visit.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102443,'','Khadgar will contact you before long. I must ready Undercity for war. Are you with us, $n? Or with the humans?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102444,'','I\'ve taken certain... precautionary measures. My guards will remain present throughout the city until the Alliance threat stands down.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102445,'Good to see you up, $n. I would ask a favor before my army leaves for war.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102446,'Mmm... mrrmmmm...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102447,'Rulllmm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102448,'Nyumnyum.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102449,'Urrlllllm.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102450,'$n, we\'ve requisitioned this hippogryph to take you to the Broken Isles!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102451,'- YOU HAVE COMPLETED THE NIGHTMARE PORTION OF THE PLAYTEST -','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102452,'I alone deserve the favor of the storm god!','',0,0,0,0,0,0,0,0,0,0,60665,0,26124),
(102453,'Glory will be mine in the Halls of Valor!','',0,0,0,0,0,0,0,0,0,0,60666,0,26124),
(102454,'The north winds obey my command...','',0,0,0,0,0,0,0,0,0,0,60667,0,26124),
(102455,'Stand and fight!','',0,0,0,0,0,0,0,0,0,0,60668,0,26124),
(102456,'Is this the best your pathetic Earthen Ring can muster!?','',0,0,0,0,0,0,0,0,0,0,60669,0,26124),
(102457,'This way, friend. I will coach you through the trials as best I can.','',0,0,0,0,0,0,0,0,0,0,60620,0,26124),
(102458,'Do you seek the weapons of the storm god? Step forward, shaman.','',0,0,0,0,0,0,0,0,0,0,60621,0,26124),
(102459,'Make haste to Krasus\' Landing. I will try to gather support from the mages.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102460,'Stormstout! You seek the weapons of the storm as well?','',0,0,0,0,0,0,0,0,0,0,60622,0,26124),
(102461,'I do. \'Storm, Earth, Fire...\' that\'s kind of my thing.','',0,0,0,0,0,0,1,0,0,0,60623,0,26124),
(102462,'Many seek the artifacts of the Keeper of Storms. None have passed the trials. Come, and be judged!','',0,0,0,0,0,0,0,0,0,0,60624,0,26124),
(102463,'You\'re in good hands, friend. Did I mention I trained King Wrynn for the arena?','',0,0,0,0,0,0,0,0,0,0,60625,0,26124),
(102464,'Who challenges me!? The weapons of the storm belong to my clan by rights!','',0,0,0,0,0,0,1,0,0,0,60670,0,26124),
(102465,'The first trial is a test of strength. Only one of you may pass. Speak with me to begin.','',0,0,0,0,0,0,0,0,0,0,60612,0,26124),
(102466,'This vrykul is all talk. Use his strength against him.','',0,0,0,0,0,0,0,0,0,0,60613,0,26124),
(102467,'I will grant you a lightning shield, but don\'t let him get too close!','',0,0,0,0,0,0,0,0,0,0,60614,0,26124),
(102468,'3... 2... 1... Fight!','',0,0,0,0,0,0,0,0,0,0,60615,0,26124),
(102469,'Incredible form! A fighter in perfect harmony with the elements!','',0,0,0,0,0,0,273,0,0,0,60616,0,26124),
(102470,'You\'ve almost got this, champion!','',0,0,0,0,0,0,4,0,0,0,60617,0,26124),
(102471,'Don\'t worry, champion. This isn\'t over yet.','',0,0,0,0,0,0,0,0,0,0,60618,0,26124),
(102472,'The shaman has triumphed! The first trial is complete.','',0,0,0,0,0,0,0,0,0,0,60619,0,26124),
(102473,'Ah, you must be the one I am hearing whispers about. Tales of your great deeds and powerful artifact precede you.$b$bI am Spiritwalker Ebonhorn. I have heard much about you and your journeys beyond these isles.$b$bLet us see if the stories of your heroism are true, shall we?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102474,'Ready to negotiate.','Ready to negotiate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102475,'A true hero never fights alone. The next trial is a test of teamwork. You must choose a partner.','',0,0,0,0,0,0,0,0,0,0,60626,0,26124),
(102476,'I will be the second for my champion! Who will we fight?','',0,0,0,0,0,0,0,0,0,0,60627,0,26124),
(102477,'I believe I am next.','',0,0,0,0,0,0,0,0,0,0,60628,0,26124),
(102478,'Stormstout!? Hah! I\'ve been waiting for a chance to get you into the arena. Take you down a peg or two.','',0,0,0,0,0,0,0,0,0,0,60629,0,26124),
(102479,'I\'d like to introduce myself.','I\'d like to introduce myself.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102480,'Is that so? We shall see who the real \'Hero of the Storm\' is around here. But first, I need a partner.','',0,0,0,0,0,0,0,0,0,0,60630,0,26124),
(102481,'','Ready for adventure!',0,0,0,0,0,0,15,0,0,0,0,60631,26124),
(102482,'Oh no no, Li Li, I don\'t think--','',0,0,0,0,0,0,274,0,0,0,60632,0,26124),
(102483,'Remember: Only through teamwork will you triumph. 3... 2... 1... FIGHT!','',0,0,0,0,0,0,0,0,0,0,60633,0,26124),
(102484,'Ignore your pride. Take out the pandaren girl first!','',0,0,0,0,0,0,0,0,0,0,60634,0,26124),
(102485,'You are fast, orc. But not fast enough!','',0,0,0,0,0,0,0,0,0,0,60635,0,26124),
(102486,'You\'ve bitten off more than you can chew, pandaren. And that\'s a lot!','',0,0,0,0,0,0,0,0,0,0,60636,0,26124),
(102487,'The customer don\'t buy, unless you supply!$b$bWelcome to the shop, $n. The name\'s Jones, Timothy Jones, or TJ for short. It\'s up to you.$b$bIf you need anything, and I mean ANYTHING, you come talk to me and I\'ll give you the hookup.$b$b<Timothy gives you a wink and goes back to his business.>','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102488,'Focus on the healer!','',0,0,0,0,0,0,0,0,0,0,60637,0,26124),
(102489,'Li Li, look out!','',0,0,0,0,0,0,0,0,0,0,60638,0,26124),
(102490,'Let\'s roll!','',0,0,0,0,0,0,0,0,0,0,60639,0,26124),
(102491,'','Hey, here\'s the good stuff!',0,0,0,0,0,0,0,0,0,0,0,60640,26124),
(102492,'You\'re not dying on me!','',0,0,0,0,0,0,0,0,0,0,60641,0,26124),
(102493,'','These guys don\'t play nice!',0,0,0,0,0,0,0,0,0,0,0,60642,26124),
(102494,'You have bested me.','',0,0,0,0,0,0,0,0,0,0,60643,0,26124),
(102495,'Congratulations, hero! The second challenge is complete.','',0,0,0,0,0,0,0,0,0,0,60644,0,26124),
(102496,'Rehgar, this may be the most powerful fighter you\'ve ever brought to the Arena.','',0,0,0,0,0,0,1,0,0,0,60645,0,26124),
(102497,'I know a champion when I see one!','',0,0,0,0,0,0,1,0,0,0,60646,0,26124),
(102498,'As The Light as my witness, jewels are my business!$b$bWhat can I help you with?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102499,'You have proven your worth, champion. You are ready for the final trial, which none have passed.','',0,0,0,0,0,0,0,0,0,0,60648,0,26124),
(102500,'The tools of the Keeper of Storms are so powerful, even the Thunder King himself dared not wield them.','',0,0,0,0,0,0,0,0,0,0,60649,0,26124),
(102501,'The Fist of Ra-den is your final challenge. If you can wield it and live, the weapon is yours to command.','',0,0,0,0,0,0,0,0,0,0,60650,0,26124),
(102502,'I believe in you, shaman!','',0,0,0,0,0,0,1,0,0,0,60651,0,26124),
(102503,'','This is so cool.',0,0,0,0,0,0,0,0,0,0,0,60652,26124),
(102504,'I\'ll be honest... those things scare me.','',0,0,0,0,0,0,1,0,0,0,60653,0,26124),
(102505,'','Yow! Watch it!',0,0,0,0,0,0,0,0,0,0,0,60654,26124),
(102506,'','Hiya, $n, the name\'s Sminx. I mostly deal in fine jewelry. I leave the actual gem-cutting duties to Tiffany.$b$bIf you\'re looking for something to put your shinies into, come talk to me.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102507,'Focus, champion!','',0,0,0,0,0,0,5,0,0,0,60655,0,26124),
(102508,'','What\'cha lookin\' for, stranger?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102509,'Stand in the light and prove your mastery over the elements.','',0,0,0,0,0,0,0,0,0,0,60656,0,26124),
(102510,'Destroy the first target with a lightning bolt.','',0,0,0,0,0,0,0,0,0,0,60657,0,26124),
(102511,'Hmm. Maybe we should do this outdoors.','',0,0,0,0,0,0,6,0,0,0,60658,0,26124),
(102512,'One moment, great tiger.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102513,'Stay focused, champion. You were born to command these elements. You can do this!','',0,0,0,0,0,0,25,0,0,0,60659,0,26124),
(102514,'So, you are the one Ebonhorn has been talking about?$b$bIt was a strange prophecy from a strange spiritwalker.$b$bToo strange, if you ask me.','So, you are the one Ebonhorn has been talking about?$b$bIt was a strange prophecy from a strange spiritwalker.$b$bToo strange, if you ask me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102515,'Did you hear? The High-Chieftain is dead!$b$bThe drogbar underking betrayed him.','Did you hear? The High-Chieftain is dead!$b$bThe drogbar underking betrayed him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102516,'Jale is going to try to negotiate with the drogbar. Without the help of the other tribes, we have no choice but to try for peace.','Jale is going to try to negotiate with the drogbar. Without the help of the other tribes, we have no choice but to try for peace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102517,'I heard the drogbar have already begun attacking Whitewater Wash and even Thunder Totem.$b$bThese are dark days.','So, you are the one Ebonhorn has been talking about?$b$bIt was a strange prophecy from a strange spiritwalker.$b$bToo strange, if you ask me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102518,'Use a lava burst to destroy the second target.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102519,'Concentrate! Stay in control!','',0,0,0,0,0,0,0,0,0,0,60660,0,26124),
(102520,'Something is wrong... someone is here...','',0,0,0,0,0,0,0,0,0,0,60661,0,26124),
(102521,'The Legion is attacking!','',0,0,0,0,0,0,5,0,0,0,60596,0,26124),
(102522,'You will never stop the Inquisition!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102523,'','You need to get me out of this cage! We\'re in more danger than you suspect!',22,0,0,0,0,0,0,0,0,0,0,78705,26124),
(102524,'The High Inquisitor\'s work will not be interrupted!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102525,'','Thank you, $n. Back into the fight.',0,0,0,0,0,0,0,0,0,0,0,57054,26124),
(102526,'Thank you, $n. Back into the fight.','',0,0,0,0,0,0,0,0,0,0,56812,0,26124),
(102527,'Leave the mortals alive. We must find the weapons of their so-called \'Storm-God.\'','',0,0,0,0,0,0,0,0,0,0,60597,0,26124),
(102528,'I will feast on your soul after my triumph here.','',0,0,0,0,0,0,0,0,0,0,60598,0,26124),
(102529,'','Thank you, $n. Back into the fight.',0,0,0,0,0,0,0,0,0,0,0,57103,26124),
(102530,'The Legion will scorch this world!','',0,0,0,0,0,0,0,0,0,0,60599,0,26124),
(102531,'We will defile the very ground you stand on!','',0,0,0,0,0,0,0,0,0,0,60600,0,26124),
(102532,'Thank you, $n. Back into the fight.','',0,0,0,0,0,0,0,0,0,0,57126,0,26124),
(102533,'Soon there will be no place for you to run...','',0,0,0,0,0,0,0,0,0,0,60601,0,26124),
(102534,'You rely on the elements to fight for you? Weakling!','',0,0,0,0,0,0,0,0,0,0,60602,0,26124),
(102535,'Ancestors watch over you!','',0,0,0,0,0,0,0,0,0,0,60603,0,26124),
(102536,'Begone, mortal!','',0,0,0,0,0,0,0,0,0,0,60604,0,26124),
(102537,'Finish... him...','',0,0,0,0,0,0,0,0,0,0,60605,0,26124),
(102538,'My master WILL possess the power of the storm!','',0,0,0,0,0,0,0,0,0,0,60606,0,26124),
(102539,'Glory to the Legion!','',0,0,0,0,0,0,0,0,0,0,60607,0,26124),
(102540,'','I will repay my debt to you.',0,0,0,0,0,0,0,0,0,0,0,57055,26124),
(102541,'','The Burning Legion will fall!',0,0,0,0,0,0,0,0,0,0,0,57056,26124),
(102542,'Champion, you saved us...','',0,0,0,0,0,0,0,0,0,0,60608,0,26124),
(102543,'','I will not let you down.',0,0,0,0,0,0,0,0,0,0,0,57057,26124),
(102544,'','For Lord Illidan!',0,0,0,0,0,0,0,0,0,0,0,57058,26124),
(102545,'The elements walk in harmony with this one. I\'ve not seen a better shaman since I fought alongside Thrall himself.','',0,0,0,0,0,0,1,0,0,0,60609,0,26124),
(102546,'','We WILL take the keystone!',0,0,0,0,0,0,0,0,0,0,0,57059,26124),
(102547,'Shaman, no further trials are required. The weapons of the Keeper of Storms have found their new master.','',0,0,0,0,0,0,0,0,0,0,60610,0,26124),
(102548,'','Die demons!',0,0,0,0,0,0,0,0,0,0,0,57060,26124),
(102549,'Go forth, champion of the Earthen Ring, with my blessing. Azeroth is under siege, and heroes like you must rise to the challenge.','',0,0,0,0,0,0,0,0,0,0,60611,0,26124),
(102550,'','I did not make it this far just to die on this rock.',0,0,0,0,0,0,0,0,0,0,0,57061,26124),
(102551,'I will repay my debt to you.','',0,0,0,0,0,0,0,0,0,0,56813,0,26124),
(102552,'The Burning Legion will fall!','',0,0,0,0,0,0,0,0,0,0,56814,0,26124),
(102553,'I will not let you down.','',0,0,0,0,0,0,0,0,0,0,56815,0,26124),
(102554,'For Lord Illidan!','',0,0,0,0,0,0,0,0,0,0,56816,0,26124),
(102555,'We WILL take the keystone!','',0,0,0,0,0,0,0,0,0,0,56817,0,26124),
(102556,'Die demons!','',0,0,0,0,0,0,0,0,0,0,56818,0,26124),
(102557,'I did not make it this far just to die on this rock.','',0,0,0,0,0,0,0,0,0,0,56819,0,26124),
(102558,'','I will repay my debt to you.',0,0,0,0,0,0,0,0,0,0,0,57104,26124),
(102559,'','The Burning Legion will fall!',0,0,0,0,0,0,0,0,0,0,0,57105,26124),
(102561,'','I will not let you down.',0,0,0,0,0,0,0,0,0,0,0,57106,26124),
(102562,'','For Lord Illidan!',0,0,0,0,0,0,0,0,0,0,0,57107,26124),
(102563,'','We WILL take the keystone!',0,0,0,0,0,0,0,0,0,0,0,57108,26124),
(102564,'','Die demons!',0,0,0,0,0,0,0,0,0,0,0,57109,26124),
(102566,'','I did not make it this far just to die on this rock.',0,0,0,0,0,0,0,0,0,0,0,57110,26124),
(102567,'I will repay my debt to you.','',0,0,0,0,0,0,0,0,0,0,57119,0,26124),
(102568,'The Burning Legion will fall!','',0,0,0,0,0,0,0,0,0,0,57120,0,26124),
(102569,'I will not let you down.','',0,0,0,0,0,0,0,0,0,0,57121,0,26124),
(102570,'For Lord Illidan!','',0,0,0,0,0,0,0,0,0,0,57122,0,26124),
(102571,'We WILL take the keystone!','',0,0,0,0,0,0,0,0,0,0,57123,0,26124),
(102572,'Die demons!','',0,0,0,0,0,0,0,0,0,0,57124,0,26124),
(102573,'I didn\'t make it this far just to die on this rock.','',0,0,0,0,0,0,0,0,0,0,57125,0,26124),
(102577,'','Hurry! We must find Thaon before it is too late!',1,0,0,0,0,0,0,0,0,0,0,78706,26124),
(102578,'Dis be de end o\' discussion \'til our guest be arrivin\'.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102579,'De only ting we can do... My wounds ain\'t be lastin\' much longer. Loa be callin\' me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102580,'Quickly! Let us put an end to these miscreants!','',0,0,0,0,0,0,0,0,0,0,54580,0,26124),
(102581,'I deem you... unworthy.','',0,0,0,0,0,0,0,0,0,0,54579,0,26124),
(102582,'Seems I... underestimated you.','',0,0,0,0,0,0,0,0,0,0,54578,0,26124),
(102583,'I will take joy in crushing you!','',0,0,0,0,0,0,0,0,0,0,54577,0,26124),
(102584,'Together we will see our enemies to a savage end!','',0,0,0,0,0,0,0,0,0,0,54576,0,26124),
(102585,'My strength... fails.','',0,0,0,0,0,0,0,0,0,0,54575,0,26124),
(102586,'Your cries of anguish will echo through eternity!','',0,0,0,0,0,0,0,0,0,0,54574,0,26124),
(102587,'Together we will cast their souls to ruin!','',0,0,0,0,0,0,0,0,0,0,54573,0,26124),
(102588,'I embrace the abyss!','',0,0,0,0,0,0,0,0,0,0,54572,0,26124),
(102589,'I accept this challenge... with eager anticipation!','',0,0,0,0,0,0,0,0,0,0,54571,0,26124),
(102590,'Where they failed, we will succeed!','',0,0,0,0,0,0,0,0,0,0,54570,0,26124),
(102591,'','Hey there $n. This kitty is huge! Do you think the king would mind if I pet him?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102592,'You have... bested me.','',0,0,0,0,0,0,0,0,0,0,54569,0,26124),
(102593,'... de right call was made. Dat horn be savin\' us... all of us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102594,'','Any who oppose us, any who stand in our way will perish. I accept my reign as the first Queen of the Horde.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102595,'','We must call upon reinforcements within our cities at once! Preparations must be ma -',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102596,'','You saw how swiftly their attacks came. Your own blood remains on the battlefield, Baine. It\'s only a matter of time before our skies are covered in felfire!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102597,'Dreadguards... watch their formations! Hold strong! One Horde!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102598,'We will remain one Horde.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102599,'One Horde... one leader...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102600,'As a boy, I heard legends of the Unseen Path. They made me want to become a hunter. When I heard the order had been restored, I had to see it with my own eyes.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102601,'It is good to see you again, $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102602,'Thinking of lost friends... and a promise I need to keep.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102603,'Good, I\'d like a rematch!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102604,'Is something troubling you?','Is something troubling you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102605,'Eh, who\'s this then?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102606,'Don\'t worry, you\'ll be hearing about $Ghim:her; soon enough.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102607,'','Warchief...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102608,'Earth Mother watch over us. What will become of the Horde?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102609,'And who would you have lead, Warchief? No man can command an army that suffered such losses as we...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102610,'No single army is large enough to defeat the Legion. Our blood on the battlefield will attest to that. I will not put the lives of innocent people in harm\'s way.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(102611,'','Your reluctance to defend the Horde is choice enough, I\'m afraid.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102612,'By coming here, you have sealed your doom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102613,'Your actions at the Shore have shown what it takes to be a leader. When lives are at stake... lives of loved ones, of warriors, of the Horde...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102614,'','And when the time comes, let us hope these words bear a heavier weight than the air in which they\'re spoken.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102615,'No man... She...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102616,'Broken Shore be our lesson. And now... now knowledge be our weapon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102617,'Dem powers we seen - dat be more dan any us be dealin wit on our own.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102619,'','Are you ready to meet Odyn?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102620,'Take me to Odyn.','Take me to Odyn.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102622,'','Alleria! Can you hear me? Alleria!',1,0,0,0,0,0,0,0,0,0,0,61831,26124),
(102623,'','I can sense a demon presence... Above us, $n, on the ledge!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102628,'When de time comes, you be ready to fight?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102629,'If dis only de beginning, ain\'t gonna be easy. If we fight, everyone gonna be makin\' sacrifices.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102630,'Vol\'jin...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102631,'All your instinct be true. Innocent lives be valued, indeed, but dem magics... Demons we ain\'t been seein\' before. I be fearin\' dis only be de beginnin\'.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102632,'Warchief, I understand, but we cannot afford to send everything we have at the Legion. Some of our people are not ready for a war. It is -','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102633,'','It is unfortunate... for all of us, but the time has come to defend our people - all of our people.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102634,'Dat willingness to sacrifice - to make dem decisions when da time comes - dat be the sign of a true Warchief.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102635,'Good. Now we all be seein\'... united as one, but we also be need\'n an old knowledge. Someone who understand dem fel magics from long ago. Someone ta help understand de fight dey be bringin. Helpin\' us prepare... for war.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102636,'','Warchief, even with the might of the Horde behind us, the Legion\'s power continues to grow. We know neither their numbers nor their true power, but as you said, we know their intentions.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102637,'Yes... and we ain\'t gone be fightin\' de Legion alone. It be time we be reachin\' out. I be goin\' to visit an old friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102638,'Dem serious times. Tell your people it\'s time to be gettin\' ready. Everybody gettin\' ready.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102639,'','And what of my guards, Warchief? We cannot afford to leave the city in its state. The Legion is threat enough, and the Alliance - the Alliance will surely strike when our guard is down.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102640,'Leave \'em. Dem guards be remindin\' us of those we lost. They be remindin\' us we be one Horde. And dey be remindin\' us - ain\'t nobody be sittin\' down when war be upon us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102641,'Ain\'t none of us be standin\' here without her actions at da Shore.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102642,'Upon close inspection, the jewel appears to be real. This must not be the commission in question.$b$bThe next person on the list is Didi the Wrench at the engineering shop.','Upon close inspection, the jewel appears to be real. This must not be the commission in question.$b$bThe next person on the list is Didi the Wrench at the engineering shop.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102643,'The gem chips lying on the table are definitely real. They bear the same imperfections you\'ve seen before.$b$bThe last person on the list is Debbi Moore at Curiosities and Moore.','The gem chips lying on the table are definitely real. They bare the same imperfections you\'ve seen before.$b$bThe last  person on the list is Debbi Moore.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102644,'As you expect each jewel in the bag, your eyes grow wider and wider with surprise.$b$bALL of these gems are fake! You must take this bag back to Tiffany as quickly as possible.','As you expect each jewel in the bag, your eyes grow wider and wider with surprise.$b$bALL of these gems are fake! You must take this bag back to Tiffany as quickly as possible.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102645,'Beware... the hound mistress...','',0,0,0,0,0,0,0,0,0,0,61824,0,26124),
(102646,'You are my greatest weapon now, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102647,'','Welcome mage it\'s time to begin your training. As a Mage, you are a master of magic, able to conjure and control arcane energy to do your bidding. We will begin with the fundamentals.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102648,'','Dalaran will help protect the Eastern Kingdoms, but I will NOT allow the Horde to set foot within my city!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(102649,'We must not splinter like this... not now. Please, Jaina!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102650,'You must not falter, Your Highness. Even now, the Legion is upon you!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(102651,'My father dead... disaster on the Broken Shore... Jaina fixed on revenge... Everything is falling apart.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102652,'','With respect, you are making a huge mistake. Our chances fade the longer we wait to strike back at the Horde.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102653,'It\'s my mistake to make, Jaina. This is my decision now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102654,'','Then I will take my leave. The Council of Six must be convened.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102655,'I can only hope so.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102656,'Thank you, Jaina.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102657,'','Of course. I will convene the Council of Six at once.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102658,'I would like to review weapons we might pursue.','I would like to review weapons we might pursue.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102659,'No one rides for free!','',0,0,0,0,0,0,0,0,0,0,54380,0,26124),
(102660,'Life... death... I am but one ripple in the eternal ebb and flow...','',0,0,0,0,0,0,0,0,0,0,54376,0,26124),
(102661,'','Do you think you have won? You have merely survived the storm... The seas are unstoppable.',0,0,0,0,0,0,0,0,0,0,0,54396,26124),
(102662,'','Odyn values these creatures?',0,0,0,0,0,0,0,0,0,0,0,54372,26124),
(102663,'','I\'d recommend talking to Catriona Macrae first. She was my most recent customer.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102664,'Accessing shrine module XK-47-09. Processing.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102665,'','My husband is always running off without cleaning up after himself, leaving me to clean up after him.$b$bIf you see him around Dalaran, could you let him know that I love him more than he loves me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102666,'History Module. Watchers tasked with guarding portions of Pantheon\'s power on Azeroth in case of catastrophic loss. Initial results deemed successful.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102667,'I\'m here to inspect the jewel Tiffany Cartier crafted for you.','I\'m here to inspect the jewel Tiffany Cartier crafted for you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102668,'Current status: corrupted. High levels of fel energy tripped failsafe mechanisms. Initial analysis suggests purification necessary to restore function.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102669,'Power levels low. Shutting down to preserve system memory.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102670,'','If you got some springs loose, I can probably show you how to fix \'em up!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102671,'I\'m here to inspect the gem chips Tiffany Cartier gave you.','I\'m here to inspect the gem chips Tiffany Cartier gave you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102672,'I\'m here to inspect the jewels Tiffany Cartier gave you.','I\'m here to inspect the jewels Tiffany Cartier gave you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102673,'','Can I interest you in a new trinket?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102674,'','Oh yes, they\'re right there on the table. There isn\'t anything wrong with them, is there?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102675,'','Sure thing. They\'re right over there on that table. They\'ve been working out great!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102676,'','My jewel? I suppose so. It\'s over there on the side table.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102677,'It\'s mine! I saw it fall from sky!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102678,'These are no spirits. These are echoes from the past. Something bad happened here.','',0,0,0,0,0,0,0,0,0,0,54899,0,26124),
(102679,'You will all burn!','',0,0,0,0,0,0,0,0,0,0,54900,0,26124),
(102680,'Fools! Insects! Vermin! You are nothing to me. I will consume you all!','',0,0,0,0,0,0,0,0,0,0,54901,0,26124),
(102681,'You dare challenge me?!','',0,0,0,0,0,0,0,0,0,0,54902,0,26124),
(102682,'','|TInterface\\Icons\\inv_misc_volatileearth.blp:20|t %s has no one to melee and begins to |cFFFF0000|Hspell:196534|h[Slam]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102683,'Master, release me from this webbing and I will aid you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102688,'','We must assist at Whitewater Wash before it is too late.',0,0,0,0,0,0,0,0,0,0,0,54760,26124),
(102689,'You will all serve the Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102690,'Nowhere is safe.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102691,'Everything you know will burn in fel flame.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102692,'You merely... prolong...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102693,'You are High Chieftain. You must show your people that no artifact - no weapon - can stand before the might of a united Highmountain.','',0,0,0,0,0,0,0,0,0,0,54903,0,26124),
(102694,'','We need to reclaim the hammer. Not go for a walk.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102696,'','First, select and equip a weapon from the rack over there. As a caster, you do not attack with your weapon, but it is a source of great power, empowering your innate arcane abilities.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102697,'','Skylord, your friend has finished recovering. It is different to raise a living being to the Halls, but I have done just that!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102698,'','It was an honor working with you at your garrison, $ct.',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(102699,'','Based on our success on Draenor, I\'d say we make a good team, $n.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102700,'Welcome.  As a fire mage you specialize in igniting your opponents with impressive bursts of flame, leaving them to burn to cinders. We will begin with your most basic ability - Fireball.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102701,'','I\'m pleased to be out of the garrison and serving somewhere more suited to our line of work, $ct.',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(102702,'Fireball is your fundamental damage dealing ability.  It does a large amount of damage up front and then continues to burn your opponent over time.  Use Fireball to destroy this target dummy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102703,'Val\'Sharah','Val\'Sharah',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102704,'Who would you like to station in Val\'Sharah?','Who would you like to station in Val\'Sharah?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102705,'Are you sure? Your champion will be unable to embark on missions while stationed. (NYI)','Are you sure? Your champion will be unable to embark on missions while stationed. (NYI)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102706,'I will help you manage your valarjar from up here and let you know of any opportunities or emergencies that crop up.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102707,'I would like to station a different champion.','I would like to station a different champion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102708,'Beware the shadows, for that is where I hunt!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102709,'Behold Moorgoth, master of the dark abyss!','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(102710,'Rok shatter!','',0,0,0,0,0,0,0,0,0,0,54531,0,26124),
(102711,'If you\'ve come seeking a master of the darkness, then you have found him.','',273,0,0,0,0,0,0,0,0,0,0,0,26124),
(102712,'Rok stronger!','',0,0,0,0,0,0,0,0,0,0,54548,0,26124),
(102713,'Rok... no... break','',0,0,0,0,0,0,0,0,0,0,54549,0,26124),
(102714,'Rok SMASH!','',0,0,0,0,0,0,0,0,0,0,54551,0,26124),
(102715,'Tiny piddle, big puddle.','',0,0,0,0,0,0,0,0,0,0,54553,0,26124),
(102716,'Nothing beat Rok!','',0,0,0,0,0,0,0,0,0,0,54555,0,26124),
(102717,'Where would you like to station a champion?','Where would you like to station a champion?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102718,'I would like to station one of my champions in an area.','I would like to station one of my champions in an area.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102719,'','This is our land now, $r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102720,'Are you sure you want to recall your champion? They will no longer aid you in combat.','Are you sure you want to recall your champion? They will no longer aid you in combat.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102721,'','I will drape my nest in your bones!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102722,'','Screeekk!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102723,'You no take warglaive!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102724,'','I shall drop you off the cliffs and feast on your flesh.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102725,'','Aieee!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102726,'','Grawk... the Mother will get you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102727,'','Avenge me, sisters!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102728,'','This is gonna be GREAT.',0,0,0,0,0,0,0,0,0,0,0,60647,26124),
(102729,'You\'re far from home, little $r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102730,'I\'ll crush your skull like a ripe fruit.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102731,'Perish under the weight of the mountain!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102732,'You will be fun to crush.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102733,'You will not stop us! This land is ours!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102734,'The Deep... calls...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102735,'You cannot destroy mountains.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102736,'How could... something so small...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102737,'Crok it all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102738,'A true hero never fights alone. This challenge will demonstrate your cunning and prowess as part of a team. Work with your partner to overcome this test.$b$bIs your team ready?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102739,'Rehgar and I are ready!','Rehgar and I are ready!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102740,'Ayiyiyi!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102741,'Me kill you! Make big bosses proud!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102742,'Big bosses king of mountains. We bring you to big boss!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102743,'In mountain, candle take you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102744,'You no take candle!','',0,0,0,0,0,0,0,0,0,0,54334,0,26124),
(102745,'Candle! Mine!','',0,0,0,0,0,0,0,0,0,0,54340,0,26124),
(102746,'Aaaaaaaaaaah!','',0,0,0,0,0,0,0,0,0,0,54335,0,26124),
(102747,'Rakinishu!','',0,0,0,0,0,0,0,0,0,0,54336,0,26124),
(102748,'Ickinicka!','',0,0,0,0,0,0,0,0,0,0,54337,0,26124),
(102749,'Rrribitack!','',0,0,0,0,0,0,0,0,0,0,54338,0,26124),
(102750,'No!','',0,0,0,0,0,0,0,0,0,0,72571,0,26124),
(102751,'For Candle King!','',0,0,0,0,0,0,0,0,0,0,54339,0,26124),
(102752,'My mountain!','',0,0,0,0,0,0,0,0,0,0,54341,0,26124),
(102753,'You no take mountain!','',0,0,0,0,0,0,0,0,0,0,54342,0,26124),
(102754,'Iiiiii take candle!','',0,0,0,0,0,0,0,0,0,0,54343,0,26124),
(102755,'Brrribitit!','',0,0,0,0,0,0,0,0,0,0,54344,0,26124),
(102756,'I bite! You die!','',0,0,0,0,0,0,0,0,0,0,54345,0,26124),
(102757,'Should we let live? <Nah!>','',0,0,0,0,0,0,0,0,0,0,54346,0,26124),
(102758,'Let\'s cook it! <Eat it raw!>','',0,0,0,0,0,0,0,0,0,0,54347,0,26124),
(102759,'Orrrugggghhh! <You get bone stuck in teeth again?>','',0,0,0,0,0,0,0,0,0,0,54348,0,26124),
(102760,'Hard on outside! <Chewy inside!>','',0,0,0,0,0,0,0,0,0,0,54349,0,26124),
(102761,'Juicy snack! <Me first!>','',0,0,0,0,0,0,0,0,0,0,54350,0,26124),
(102762,'This my place! <Let\'s eat!>','',0,0,0,0,0,0,0,0,0,0,54351,0,26124),
(102763,'Me get it! <No me get it!>','',0,0,0,0,0,0,0,0,0,0,54352,0,26124),
(102764,'I get the top part! <No, my turn!>','',0,0,0,0,0,0,0,0,0,0,54353,0,26124),
(102765,'Is it tasty? <Oh yeah, once we get it out of that crunchy armor shell.>','',0,0,0,0,0,0,0,0,0,0,54354,0,26124),
(102766,'Smash \'em! <Crash \'em!>','',0,0,0,0,0,0,0,0,0,0,54355,0,26124),
(102767,'I don\'t like you! <I don\'t like you either!>','',0,0,0,0,0,0,0,0,0,0,54356,0,26124),
(102768,'','They are used on fresh corpses, collecting souls to fuel the Legion\'s Soul Engines.',0,0,0,0,0,0,0,0,0,0,0,55005,26124),
(102769,'Those who challenge me only speed themselves to an agonizing death.','',0,0,0,0,0,0,0,0,0,0,54459,0,26124),
(102770,'So says the shadow of Xavius.','',0,0,0,0,0,0,0,0,0,0,54460,0,26124),
(102771,'Be still, worm! I will deal with you shortly.','',0,0,0,0,0,0,0,0,0,0,54461,0,26124),
(102772,'A fluke. Savor it, and pray you do not face me next.','',0,0,0,0,0,0,0,0,0,0,54462,0,26124),
(102773,'They will be more than prepared, for your true power rests in the Nightmare.','',0,0,0,0,0,0,0,0,0,0,54463,0,26124),
(102774,'Silence, weakling! When you open your mouth again, it will be to cry for mercy!','',0,0,0,0,0,0,0,0,0,0,54464,0,26124),
(102775,'A pity you have come this far only to die at the hands of Xavius!','',0,0,0,0,0,0,0,0,0,0,54465,0,26124),
(102776,'An empty threat. You hold no sway over this realm, Nightmare Lord.','',0,0,0,0,0,0,0,0,0,0,54466,0,26124),
(102777,'Bold words for a prisoner. Even an echo of my power was enough to overwhelm you!','',0,0,0,0,0,0,0,0,0,0,54467,0,26124),
(102778,'A pity you have come this far only to die at the hands of Xavius!','',0,0,0,0,0,0,0,0,0,0,54468,0,26124),
(102779,'Your voice is but a whisper in this realm.','',0,0,0,0,0,0,0,0,0,0,54469,0,26124),
(102780,'Your mind games hold no sway over me, dog!','',0,0,0,0,0,0,0,0,0,0,54470,0,26124),
(102781,'First you suffer; then you die!','',0,0,0,0,0,0,0,0,0,0,54471,0,26124),
(102782,'Stand together if you hope to win!','',0,0,0,0,0,0,0,0,0,0,54472,0,26124),
(102783,'I will fracture your feeble mind!','',0,0,0,0,0,0,0,0,0,0,54473,0,26124),
(102784,'You will waste away slowly, painfully.','',0,0,0,0,0,0,0,0,0,0,54474,0,26124),
(102785,'You can trust no one-not even your comrades!','',0,0,0,0,0,0,0,0,0,0,54475,0,26124),
(102786,'Fight back! Do not let him manipulate you.','',0,0,0,0,0,0,0,0,0,0,54476,0,26124),
(102787,'For every blow you strike, I will return even stronger!','',0,0,0,0,0,0,0,0,0,0,54477,0,26124),
(102788,'Your attacks are of little concern. The Nightmare will restore me!','',0,0,0,0,0,0,0,0,0,0,54478,0,26124),
(102789,'I will help, but you must free me. Attack the roots!','',0,0,0,0,0,0,0,0,0,0,54479,0,26124),
(102790,'TEST','TEST',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102791,'These roots bind me. Destroy them!','',0,0,0,0,0,0,0,0,0,0,54480,0,26124),
(102792,'It is time to end this.','',0,0,0,0,0,0,0,0,0,0,54481,0,26124),
(102793,'Farce? Ha! So says the insect to the god!','',0,0,0,0,0,0,0,0,0,0,54482,0,26124),
(102794,'This must be some kind of... mistake...','',0,0,0,0,0,0,0,0,0,0,54483,0,26124),
(102795,'You cannot... defeat a... god...','',0,0,0,0,0,0,0,0,0,0,54484,0,26124),
(102796,'No, no! I refuse to... accept...','',0,0,0,0,0,0,0,0,0,0,54485,0,26124),
(102797,'Don\'t act surprised.','',0,0,0,0,0,0,0,0,0,0,54486,0,26124),
(102798,'You never stood a chance.','',0,0,0,0,0,0,0,0,0,0,54487,0,26124),
(102799,'Weak!','',0,0,0,0,0,0,0,0,0,0,54488,0,26124),
(102800,'You deserve nothing less!','',0,0,0,0,0,0,0,0,0,0,54489,0,26124),
(102801,'What is this? Don\'t make me laugh!','',0,0,0,0,0,0,0,0,0,0,54490,0,26124),
(102802,'Trespassers will be punished.','',0,0,0,0,0,0,0,0,0,0,54497,0,26124),
(102803,'I will break you!','',0,0,0,0,0,0,0,0,0,0,54491,0,26124),
(102804,'You wish to die? So be it!','',0,0,0,0,0,0,0,0,0,0,54492,0,26124),
(102805,'What other outcome could there be when one is faced with the wrath of a god?','',0,0,0,0,0,0,0,0,0,0,54493,0,26124),
(102806,'The same fate awaits all who oppose Xavius!','',0,0,0,0,0,0,0,0,0,0,54494,0,26124),
(102807,'None may challenge me and live!','',0,0,0,0,0,0,0,0,0,0,54495,0,26124),
(102808,'A well-earned victory! We must, however, stay vigilant. Deep inside the Nightmare Xavius remains, unvanquished. The enemy you fought here was merely his shadow.','',0,0,0,0,0,0,0,0,0,0,54496,0,26124),
(102809,'If you truly love nature, you will find death everywhere.','If you truly love nature, you will find death everywhere.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102810,'An early morning sacrifice is a blessing for the whole day.','An early morning sacrifice is a blessing for the whole day.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102811,'Nature never hurries, it kills slowly... painfully.','Nature never hurries, it kills slowly... painfully.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102812,'My profession is to always find agony in nature.','My profession is to always find agony in nature.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102813,'To sit in the shade on a fine day and look upon a rotting corpse is the most perfect refreshment.','To sit in the shade on a fine day and look upon a rotting corpse is the most perfect refreshment.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102814,'It seems you\'ve been followed, $c! Dark Riders!','',0,0,0,0,0,0,5,0,0,0,60249,0,26124),
(102815,'All seasons are beautiful for the person who carries cruelty within.','All seasons are beautiful for the person who carries cruelty within.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102816,'The battle is won, but there will be more. Quickly, to Ariden\'s camp!','',0,0,0,0,0,0,1,0,0,0,61883,0,26124),
(102817,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102818,'Try to keep up, $c!','',0,0,0,0,0,0,22,0,0,0,61884,0,26124),
(102819,'Flowers and maggots are heaven\'s masterpiece.','Flowers and maggots are heaven\'s masterpiece.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102820,'Quickly! We don\'t have time to linger!','',0,0,0,0,0,0,5,0,0,0,61885,0,26124),
(102821,'Do you wish to be left behind? Hurry!','',0,0,0,0,0,0,5,0,0,0,61886,0,26124),
(102822,'Look out behind you!','',0,0,0,0,0,0,22,0,0,0,61887,0,26124),
(102823,'Never lose an opportunity to kill anything that is beautiful.','Never lose an opportunity to kill anything that is beautiful.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102824,'Your skill in combat is impressive. We may yet survive this.','',0,0,0,0,0,0,1,0,0,0,61888,0,26124),
(102825,'The poor souls doomed to haunt this place. No wonder such darkness stems from here.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102826,'Come, let us continue.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102827,'Riders on our flank! Be ready!','',0,0,0,0,0,0,5,0,0,0,61892,0,26124),
(102828,'A burden carried by one can bring them to their knees, but carried by many and it becomes a lesson from which we learn.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(102829,'One day I\'ll find it...','One day I\'ll find it...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102830,'Let us press on. We are nearly there.','',0,0,0,0,0,0,1,0,0,0,61893,0,26124),
(102831,'Here! The camp is in this clearing. Let us search it.','',0,0,0,0,0,0,1,0,0,0,61894,0,26124),
(102832,'The lovers... the dreamers... and me.','The lovers... the dreamers... and me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102833,'The maggots will consume your corpse!','The maggots will consume your corpse!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102834,'Boss is the best!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102835,'I want to destroy... I want you to bleed.','I want to destroy... I want you to bleed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102836,'After I kill you, I will revive you and kill you again.','After I kill you, I will revive you and kill you again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102837,'Go ahead, $n, you can cry!','Go ahead, $n, you can cry!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102838,'I feel like destroying something beautiful.','I feel like destroying something beautiful.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102839,'','Look how much the flowers like the blood.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102840,'','I wonder if gnome is in season?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102841,'There is no glory to be found inside a cage.','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(102842,'','Be very, very quiet. I\'m hunting $r.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102843,'','Did you see the way that faerie dragon flopped around after I tore its wings off?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102844,'','Greetings, Huntmaster $n. It would be my honor to assist you in stabling your pets or helping find a lost companion.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(102845,'<Waits patiently with wide eyes for his reward.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102846,'<Give Trytooth the boot.>','<Give Trytooth the boot.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102847,'Big bosses... gonna get you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102848,'Me see tunnel. Candle light way!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102849,'Hey, $p. I\'ve got a shiny gold piece for you if you can get me off this floating rock.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102850,'I\'m here to reclaim the jewels you stole.','I\'m here to reclaim the jewels you stole.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102851,'$ct, I present to you Eitrigg. You will find his axe sharp and council wise.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102852,'I stand ready to go where you send me, aid our allies, and crush our foes!','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(102853,'Oh really? You think I\'ll just give them up that easily? Over my dead body!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102854,'I ride to Gilneas now, to prepare our forces for the coming storm. Stay strong, champion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102855,'','Well well, what do we have here? A tasty $r for me to eat!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102856,'','Sometimes I wish a flower could cry.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102857,'','You will pay for attacking my daughters!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102858,'','This is our home now. Begone!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102859,'','You can\'t take the sky from me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102860,'','The brood... will survive.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102861,'','First the cave dwellers, now this...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102862,'','Naga blood must be spilled! Free my brothers and sisters so that they may join me in glorious battle!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102863,'This best boot ever. Bet it burns brighter than candle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102864,'','What has happened? What have you done to me?!',0,0,0,0,0,0,0,0,0,0,0,65608,26124),
(102865,'Do not be ashamed. You fought with courage and honor.','',0,0,0,0,0,0,0,0,0,0,54568,0,26124),
(102866,'There is no shame in defeat so long as one fights with valor.','',0,0,0,0,0,0,0,0,0,0,54582,0,26124),
(102867,'','My mind is... cleared. I will sleep now. Give Thaedris my love.',0,0,0,0,0,0,0,0,0,0,0,65609,26124),
(102868,'I feel... invigorated! Care to try again, champions?','',0,0,0,0,0,0,0,0,0,0,54581,0,26124),
(102869,'I must keep this land from protected from the defilers.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102870,'I hear them... they are whispering.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102871,'I just want to sleep, but if I do they will get me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102872,'What was that? Did you hear that?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102873,'The voices say I am a lunatic... but they lie!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102874,'','Don\'t die too fast, I want to hear you scream.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102875,'','More blood for my plants!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102876,'','You can run, but you will only die tired.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102877,'','I love pain so much... I mean yours, not mine!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102878,'You have final come out of the shadows, fiend!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102879,'Most impressive! I never thought I would meet anyone who could match the Valarjar\'s strength... and yet here you stand.','',0,0,0,0,0,0,0,0,0,0,54584,0,26124),
(102880,'I may be about to die, but you are coming with me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102881,'There is one final trial that awaits: me. Should you triumph, I will carve your names in these sacred halls myself and grant you a reward worthy of your valor.','',0,0,0,0,0,0,0,0,0,0,54583,0,26124),
(102882,'Why won\'t you leave me alone? DIE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102883,'My power is beyond anything you have yet faced!','',0,0,0,0,0,0,0,0,0,0,54585,0,26124),
(102884,'You think I am afraid of you? You are the coward!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102885,'Be warned, champions: I will hold NOTHING back!','',0,0,0,0,0,0,0,0,0,0,54586,0,26124),
(102886,'Yield now... or I will call upon my true power!','',0,0,0,0,0,0,0,0,0,0,54587,0,26124),
(102887,'Hurry, friends. Every moment we linger, Dargrul kills more of our allies.','',0,0,0,0,0,0,0,0,0,0,54588,0,26124),
(102888,'I will choke the life from you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102889,'Let us see if your wits are as sharp as your weapons!','',0,0,0,0,0,0,0,0,0,0,54589,0,26124),
(102890,'I will bathe in your blood!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102891,'An agile mind is as deadly as the sharpest blade!','',0,0,0,0,0,0,0,0,0,0,54590,0,26124),
(102892,'Now the real nightmare begins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102893,'Every opponent has a weakness. I will find yours!','',0,0,0,0,0,0,0,0,0,0,54591,0,26124),
(102894,'Now I break your mind.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102895,'$n... yes, I remember you from before I left the Illidari. Thank you.','',0,0,0,0,0,0,0,0,0,0,57391,0,26124),
(102896,'My father\'s ancient lair. There is still power within these rocks that should not be disturbed.','',0,0,0,0,0,0,0,0,0,0,54592,0,26124),
(102897,'You came all this way only to die... sad.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102898,'This is a nightmare you will never awake from!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102899,'That\'s got to be the biggest crystal hulk I\'ve ever seen!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102900,'I will feast on you tonight.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102901,'Mighty Valarjar! Heed my summons!','',0,0,0,0,0,0,0,0,0,0,54594,0,26124),
(102902,'You look... Tasty!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102903,'To me, Valarjar! Prove your worth!','',0,0,0,0,0,0,0,0,0,0,54595,0,26124),
(102904,'Fight for me, Valarjar! Fight for GLORY!','',0,0,0,0,0,0,0,0,0,0,54596,0,26124),
(102905,'I love it when dinner comes to me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102906,'Ularogg can bend any stone! He could-wait. Where did they come from?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102907,'Enough! I... I yield! You are truly remarkable creatures. As promised, you will have your just reward.','',0,0,0,0,0,0,0,0,0,0,54598,0,26124),
(102908,'A noble effort!','',0,0,0,0,0,0,0,0,0,0,54599,0,26124),
(102909,'Well fought!','',0,0,0,0,0,0,0,0,0,0,54600,0,26124),
(102910,'Intruders? Here?! Break them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102911,'I was only getting started!','',0,0,0,0,0,0,0,0,0,0,54602,0,26124),
(102912,'Did you really hope to best me?','',0,0,0,0,0,0,0,0,0,0,54603,0,26124),
(102913,'It has been ages since I faced a worthy opponent. Let the battle begin!','',0,0,0,0,0,0,0,0,0,0,54604,0,26124),
(102914,'Long have I waited to face a worthy opponent! Do not disappoint me!','',0,0,0,0,0,0,0,0,0,0,54605,0,26124),
(102915,'Quickly! Stop that lookout before he can sound the alarm!','',0,0,0,0,0,0,0,0,0,0,54606,0,26124),
(102916,'I\'ll meet you down in Azsuna, $n. Come find me when you discover something.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(102917,'The Underking uses slaves to dig at the bones of my father?! He does not know the powers he meddles with.','',0,0,0,0,0,0,0,0,0,0,54608,0,26124),
(102918,'These drogbar have been tapping into abilities they should not possess. No doubt it has something to do with the latent power still lingering within these rocks.','',0,0,0,0,0,0,0,0,0,0,54610,0,26124),
(102919,'No! I, too, have proved my worth, Odyn. I am God-King Skovald! These mortals dare not challenge my claim to the aegis!','',0,0,0,0,0,0,0,0,0,0,54611,0,26124),
(102920,'If these false champions will not yield the aegis by choice... then they will surrender it in death!','',0,0,0,0,0,0,0,0,0,0,54612,0,26124),
(102921,'Give up the aegis or die!','',0,0,0,0,0,0,0,0,0,0,54614,0,26124),
(102922,'No one stands in my way!','',0,0,0,0,0,0,0,0,0,0,54615,0,26124),
(102923,'I will not be stopped!','',0,0,0,0,0,0,0,0,0,0,54616,0,26124),
(102924,'You overestimated your skill!','',0,0,0,0,0,0,0,0,0,0,54617,0,26124),
(102925,'Little more than a nuisance!','',0,0,0,0,0,0,0,0,0,0,54618,0,26124),
(102926,'Another obstacle removed!','',0,0,0,0,0,0,0,0,0,0,54619,0,26124),
(102927,'All my plans... brought to ruin...','',0,0,0,0,0,0,0,0,0,0,54620,0,26124),
(102928,'The aegis goes to its rightful owner!','',0,0,0,0,0,0,0,0,0,0,54621,0,26124),
(102929,'You will not keep what you did not earn!','',0,0,0,0,0,0,0,0,0,0,54622,0,26124),
(102930,'The power is mine!','',0,0,0,0,0,0,0,0,0,0,54623,0,26124),
(102931,'Now the aegis is where it belongs!','',0,0,0,0,0,0,0,0,0,0,54624,0,26124),
(102932,'Trail... by fire!','',0,0,0,0,0,0,0,0,0,0,54625,0,26124),
(102933,'Burn for me!','',0,0,0,0,0,0,0,0,0,0,54626,0,26124),
(102934,'Perish in never-ending flame!','',0,0,0,0,0,0,0,0,0,0,54627,0,26124),
(102935,'By flame be scourged!','',0,0,0,0,0,0,0,0,0,0,54628,0,26124),
(102936,'Your suffering will be eternal!','',0,0,0,0,0,0,0,0,0,0,54629,0,26124),
(102937,'You will die in agony!','',0,0,0,0,0,0,0,0,0,0,54630,0,26124),
(102938,'Cry for mercy... so the Legion may laugh!','',0,0,0,0,0,0,0,0,0,0,54631,0,26124),
(102939,'Valarjar! Defend these sacred halls!','',0,0,0,0,0,0,0,0,0,0,54632,0,26124),
(102940,'Navarrogg?! Betrayer! You would lead these intruders against us?!','',0,0,0,0,0,0,0,0,0,0,54633,0,26124),
(102941,'Let your worth be measured in blood!','',0,0,0,0,0,0,0,0,0,0,54634,0,26124),
(102942,'I will bleed the weakness from your veins!','',0,0,0,0,0,0,0,0,0,0,54637,0,26124),
(102943,'The blood of the unworthy will flow through these halls!','',0,0,0,0,0,0,0,0,0,0,54640,0,26124),
(102944,'Drake riders! To me!','',0,0,0,0,0,0,0,0,0,0,54641,0,26124),
(102945,'Storm drakes! At my side!','',0,0,0,0,0,0,0,0,0,0,54642,0,26124),
(102946,'Drake riders, I call upon your aid!','',0,0,0,0,0,0,0,0,0,0,54643,0,26124),
(102947,'Do not let the gates fall!','',0,0,0,0,0,0,0,0,0,0,54644,0,26124),
(102948,'Rally! Rally!','',0,0,0,0,0,0,0,0,0,0,54645,0,26124),
(102949,'Resist! Fight to the last!','',0,0,0,0,0,0,0,0,0,0,54646,0,26124),
(102950,'It is I... who am unworthy.','',0,0,0,0,0,0,0,0,0,0,54647,0,26124),
(102951,'A battle well fought! The path forward is open.','',0,0,0,0,0,0,0,0,0,0,54648,0,26124),
(102952,'All goes according to HIS plan.','',0,0,0,0,0,0,0,0,0,0,57392,0,26124),
(102953,'Very well. I will test your worth myself!','',0,0,0,0,0,0,0,0,0,0,54649,0,26124),
(102954,'Lord Gul\'dan will lead us to victory. You cannot stop us.','',0,0,0,0,0,0,0,0,0,0,57312,0,26124),
(102955,'The undeserving will perish!','',0,0,0,0,0,0,0,0,0,0,54650,0,26124),
(102956,'I will be the judge now.','',0,0,0,0,0,0,0,0,0,0,54651,0,26124),
(102957,'Unworthy!','',0,0,0,0,0,0,0,0,0,0,54652,0,26124),
(102958,'You have failed!','',0,0,0,0,0,0,0,0,0,0,54653,0,26124),
(102959,'Your trial ends here.','',0,0,0,0,0,0,0,0,0,0,54654,0,26124),
(102960,'It is over.','',0,0,0,0,0,0,0,0,0,0,54655,0,26124),
(102961,'These halls remain pure.','',0,0,0,0,0,0,0,0,0,0,54656,0,26124),
(102962,'So it ends: the unworthy vanquished.','',0,0,0,0,0,0,0,0,0,0,54657,0,26124),
(102963,'My vigil continues.','',0,0,0,0,0,0,0,0,0,0,54658,0,26124),
(102965,'','Through great deeds of courage and valor, Hyrja has earned this most sacred of rites. She shall ascend as one of my chosen val\'kyr, and her name shall echo in these gilded halls for all eternity.',0,0,0,0,0,0,0,0,0,0,0,54661,26124),
(102966,'Are you nervous, Hyrja? It is understandable if-','',0,0,0,0,0,0,0,0,0,0,54662,0,26124),
(102967,'','I am not nervous. Only... excited. All my life has led to this one glorious moment.',0,0,0,0,0,0,0,0,0,0,0,54663,26124),
(102968,'Spoken like a true val\'kyr.','',0,0,0,0,0,0,0,0,0,0,54664,0,26124),
(102969,'Mortal intruders approach!','',0,0,0,0,0,0,0,0,0,0,54665,0,26124),
(102970,'','I... I remember their kind. They and one of their cursed leaders sought to enslave me in Stormheim!',0,0,0,0,0,0,0,0,0,0,0,54666,26124),
(102971,'','I witnessed their deeds in Stormheim. Their kind has no true honor. No true virtue.',0,0,0,0,0,0,0,0,0,0,0,54667,26124),
(102972,'','All clear, Huntmaster $n. No enemies in sight.',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(102973,'','I will purge them from these sacred halls myself!',0,0,0,0,0,0,0,0,0,0,0,54668,26124),
(102974,'','The ritual is not yet complete.',0,0,0,0,0,0,0,0,0,0,0,54669,26124),
(102975,'You will not deny Hyrja\'s ascendance!','',0,0,0,0,0,0,0,0,0,0,54670,0,26124),
(102976,'The Light shines eternal in you, Hyrja!','',0,0,0,0,0,0,0,0,0,0,54671,0,26124),
(102977,'You sully this ritual with your presence, mortals!','',0,0,0,0,0,0,0,0,0,0,54672,0,26124),
(102978,'Hyrja... the fury of the storm is yours to command!','',0,0,0,0,0,0,0,0,0,0,54673,0,26124),
(102979,'Dargrul cannot control the hammer, Ularogg! He will DESTROY Highmountain, not CONQUER it!','',0,0,0,0,0,0,0,0,0,0,54674,0,26124),
(102980,'The Light embraces you, Hyrja!','',0,0,0,0,0,0,0,0,0,0,54675,0,26124),
(102981,'Revel in the power of the Light!','',0,0,0,0,0,0,0,0,0,0,54676,0,26124),
(102982,'The storm gathers! Strike now, Hyrja!','',0,0,0,0,0,0,0,0,0,0,54677,0,26124),
(102983,'Either way, I will enjoy every moment of it. Rokmora, crush them!','',0,0,0,0,0,0,0,0,0,0,54678,0,26124),
(102984,'The storm gathers within you, Hyrja!','',0,0,0,0,0,0,0,0,0,0,54679,0,26124),
(102985,'','Begone from these hallowed halls!',0,0,0,0,0,0,0,0,0,0,0,54680,26124),
(102986,'','You will pollute these halls no more!',0,0,0,0,0,0,0,0,0,0,0,54681,26124),
(102987,'','I am sorry, Eyir... I have failed you...',0,0,0,0,0,0,0,0,0,0,0,54682,26124),
(102988,'','Eyir... you were wrong to put your faith in me...',0,0,0,0,0,0,0,0,0,0,0,54683,26124),
(102989,'','None can stand against Eyir\'s chosen!',0,0,0,0,0,0,0,0,0,0,0,54684,26124),
(102990,'','You die as you lived: without honor.',0,0,0,0,0,0,0,0,0,0,0,54685,26124),
(102991,'They know we\'re coming now. I hope our allies can keep their main forces occupied long enough for us to complete our mission.','',0,0,0,0,0,0,0,0,0,0,54686,0,26124),
(102992,'Is everything alright?','Is everyone alright?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102993,'','I will not fail you, Eyir!',0,0,0,0,0,0,0,0,0,0,0,54687,26124),
(102994,'What happened at Broken Shore?','What happened at Broken Shore?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102995,'I wonder how much longer they\'ll meet.','I wonder how much longer they\'ll meet.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102996,'','It is done, Eyir. The sanctity of this place is preserved.',0,0,0,0,0,0,0,0,0,0,0,54688,26124),
(102997,'I saw some of them return. It didn\'t look good.','I saw some of them return. It didn\'t look good.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102998,'Please! Is there something wrong?','Please! Is there something wrong?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(102999,'Is the threat over?','Is the threat over?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103000,'Quickly, into the barrels! I\'ll hold them here and join you down river!','',0,0,0,0,0,0,0,0,0,0,54689,0,26124),
(103001,'No, I won\'t be doing that. I will find my own path and rejoin you on the other side.','',0,0,0,0,0,0,0,0,0,0,54693,0,26124),
(103002,'Use the finest wax to craft a magical candle, worthy of the Candleking.','Use the finest wax to craft a magical candle, worthy of the Candleking.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103003,'Wax what? Boss talk gibberish.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103004,'Pilfer golden coins from graves within the nearby burial grounds.','Pilfer golden coins from graves within the nearby burial grounds.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103005,'I hope everything is alright.','I hope everything is alright.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103006,'Is the Warchief alright?','Is the Warchief alright?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103007,'Boss make up words? No understand.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103008,'Where are you hiding your food, maggot?!','',0,0,0,0,0,0,0,0,0,0,54690,0,26124),
(103009,'Boss ok? Boss hit head and talk weird?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103010,'Slay the strongest basilisk that roams these caverns and drag its lifeless corpse to my feet!','Slay the strongest basilisk that roams these caverns and drag its lifeless corpse to my feet!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103011,'Please, you\'ve already taken all the food we have.','',0,0,0,0,0,0,0,0,0,0,54692,0,26124),
(103012,'Search everywhere! These peasants have been hiding rations from the army! If you\'re not fighting, you\'re not eating!','',0,0,0,0,0,0,0,0,0,0,54691,0,26124),
(103013,'Use your pickaxe to mine precious metals from the richest vein in the cavern, and bring the samples back to me.','Use your pickaxe to mine precious metals from the richest vein in the cavern, and bring the samples back to me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103014,'I sense a powerful artifact hidden behind this wall. Tread carefully heroes, my father rarely left such prized possessions unguarded.','',0,0,0,0,0,0,0,0,0,0,54694,0,26124),
(103015,'That was easier than expected.','',0,0,0,0,0,0,0,0,0,0,54695,0,26124),
(103016,'Boss no sound like kobold.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103017,'I\'m headed back to Dalaran now. I\'ll see you around, $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103019,'Illidan... now, you belong to the Legion.','',0,0,0,0,0,0,0,0,6,0,71520,0,26124),
(103020,'Prize in junk pile right by boss.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103021,'Dagmyr better have left some naga for me!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(103022,'That is much better!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(103023,'Highmountain itself rises against you!','',0,0,0,0,0,0,0,0,0,0,54698,0,26124),
(103024,'Your bones shatter so EASILY.','',0,0,0,0,0,0,0,0,0,0,54699,0,26124),
(103025,'Highmountain will be your tomb!','',0,0,0,0,0,0,0,0,0,0,54700,0,26124),
(103026,'Go ahead and RUN. It will change nothing.','',0,0,0,0,0,0,0,0,0,0,54701,0,26124),
(103027,'You will never wield the power of Khaz\'goroth!','',0,0,0,0,0,0,0,0,0,0,54702,0,26124),
(103028,'So this is what it feels like to break.','',0,0,0,0,0,0,0,0,0,0,54703,0,26124),
(103030,'A moment, $c...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103031,'Pay attention, Navarogg. I want you to see your heroes die.','',0,0,0,0,0,0,0,0,0,0,54704,0,26124),
(103032,'<hic>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103034,'I keep chair warm while boss gone.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103035,'There is no escape! Your essence will feed the master!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103036,'Stand against the drogbar and face the might of Khaz\'goroth himself!','',0,0,0,0,0,0,0,0,0,0,54705,0,26124),
(103037,'Highmountain take you!','',0,0,0,0,0,0,0,0,0,0,54706,0,26124),
(103038,'So brittle! So easy to break!','',0,0,0,0,0,0,0,0,0,0,54696,0,26124),
(103039,'That felt WONDERFUL.','',0,0,0,0,0,0,0,0,0,0,54707,0,26124),
(103040,'Is someone there? Anyone!? Help!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103043,'Mother of Worms! Arise!','',0,0,0,0,0,0,0,0,0,0,54697,0,26124),
(103044,'Rummaging','Rummaging',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(103046,'If they complete this summoning, our passage to Dargrul will be blocked!','',0,0,0,0,0,0,0,0,0,0,54708,0,26124),
(103047,'She comes! Naraxas will feast on your bones!','',0,0,0,0,0,0,0,0,0,0,54709,0,26124),
(103048,'Yes! AHAHAHA! Wait-nooo! AAAHHHHHhhhhh!','',0,0,0,0,0,0,0,0,0,0,54710,0,26124),
(103049,'You will be food for Naraxas!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103050,'Stop them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103051,'NOOOoooooo!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103052,'AAAHHHhhhh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103053,'Naraxas. Naraxas. Naraxas!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103054,'There is no more time! We must strike at Dargrul now!','',0,0,0,0,0,0,0,0,0,0,54716,0,26124),
(103055,'I am sorry, heroes. It appears the treasure you seek will be found on the \"other\" end of this beast.','',0,0,0,0,0,0,0,0,0,0,54717,0,26124),
(103056,'Finding Perfect Book','Finding Perfect Book',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(103057,'The tauren believed YOU were prophesied to seize MY hammer? Pathetic.','',0,0,0,0,0,0,0,0,0,0,54718,0,26124),
(103058,'Let them come! Witness the fate of those who stand against one WORTHY of wielding the power of a titan!','',0,0,0,0,0,0,0,0,0,0,54719,0,26124),
(103059,'I am sorry heroes, I must leave you now. Yet know this, I have witnessed your deeds with pride and I am sure you will not fail Highmountain in this final hour.','',0,0,0,0,0,0,0,0,0,0,54720,0,26124),
(103060,'I can shape the world just as the titans did!','',0,0,0,0,0,0,0,0,0,0,54721,0,26124),
(103061,'The mountain will gnaw on your bones!','',0,0,0,0,0,0,0,0,0,0,54722,0,26124),
(103062,'The earth heaves and roars at MY command!','',0,0,0,0,0,0,0,0,0,0,54723,0,26124),
(103063,'The molten soul of Azeroth engulfs you!','',0,0,0,0,0,0,0,0,0,0,54724,0,26124),
(103064,'Highmountain will swallow you whole!','',0,0,0,0,0,0,0,0,0,0,54725,0,26124),
(103065,'It is time to end this.','',0,0,0,0,0,0,0,0,0,0,54726,0,26124),
(103066,'I AM THE SHAPER AND FORGER OF THIS WORLD!','',0,0,0,0,0,0,0,0,0,0,54727,0,26124),
(103067,'The might of Khaz\'goroth flows through ME!','',0,0,0,0,0,0,0,0,0,0,54728,0,26124),
(103068,'How is this possible?! I... I was chosen...','',0,0,0,0,0,0,0,0,0,0,54729,0,26124),
(103069,'The tauren were wrong about you!','',0,0,0,0,0,0,0,0,0,0,54730,0,26124),
(103070,'The hammer falls upon you!','',0,0,0,0,0,0,0,0,0,0,54731,0,26124),
(103071,'Yes. TRY to take the hammer from me!','',0,0,0,0,0,0,0,0,0,0,54732,0,26124),
(103072,'I will break this world asunder before I let you take my hammer!','',0,0,0,0,0,0,0,0,0,0,54733,0,26124),
(103073,'Only I can wield the hammer\'s power.','',0,0,0,0,0,0,0,0,0,0,54734,0,26124),
(103074,'I will reforge this world as I see fit!','',0,0,0,0,0,0,0,0,0,0,54735,0,26124),
(103075,'The hammer never chose you, Dargrul. It seeks a wielder who possesses true strength, and you were found lacking.','',0,0,0,0,0,0,0,0,0,0,54736,0,26124),
(103076,'It\'s done, heroes. With Dargrul dead and the hammer reclaimed, the drogbar are broken. Now begins the long task of reuniting our tribes, but balance has returned to Highmountain.','',0,0,0,0,0,0,0,0,0,0,54737,0,26124),
(103077,'The power of the mad king Dargrul is broken and Highmountain has you to thank, heroes. Now, there are other family matters that require my attention. Farewell, I hope when next we meet it is under more peaceful circumstances.','',0,0,0,0,0,0,0,0,0,0,54738,0,26124),
(103078,'Jace, what is this Nether Crucible?','Jace, what is this Nether Crucible?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103079,'[ph]Thank you, friends. I\'d surely be dead if you hadn\'t intervened!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103080,'The crucible? It\'s a device that we can use to scry upon others or communicate across great distances.\n\nWe can even use it to contact other dimensions.\n\nIt feeds on fel energy. The more distant the target, the more energy required by the ritual.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103081,'','Get me out of this thing!',0,0,0,0,0,0,0,0,0,0,0,62061,26124),
(103082,'I eliminated those who were taking Illidan down the wrong path.','',0,0,0,0,0,0,0,0,0,0,57393,0,26124),
(103083,'','Ohhhh... My head still feels like it\'s spinning!',0,0,0,0,0,0,0,0,0,0,0,62062,26124),
(103084,'','What\'s going on over there? Hello? Hi!',0,0,0,0,0,0,5,0,0,0,0,62063,26124),
(103086,'','They don\'t look so happy to see us.',0,0,0,0,0,0,0,0,0,0,0,62064,26124),
(103087,'','Here, have some of my very own healing brew. You\'ll feel better in no time!',0,0,0,0,0,0,0,0,0,0,0,62065,26124),
(103088,'','Wheeeee! Bet you can\'t catch me!',0,0,0,0,0,0,0,0,0,0,0,62067,26124),
(103089,'','Hey, it\'s that big ugly guy again.',0,0,0,0,0,0,0,0,0,0,0,62070,26124),
(103090,'','Can\'t we all just get along? No? Okay then... you asked for it!',0,0,0,0,0,0,0,0,0,0,0,62072,26124),
(103091,'','Blah, blah, blah! You sure do talk a lot.',0,0,0,0,0,0,0,0,0,0,0,62071,26124),
(103092,'','Look at those big sparking orbs! I wonder what happens if we poke one?',0,0,0,0,0,0,0,0,0,0,0,62069,26124),
(103093,'','Hah! That was a piece of cake!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103094,'','Holy smokes! Dragon!',0,0,0,0,0,0,0,0,0,0,0,68703,26124),
(103098,'','Let\'s get moving! That dragon isn\'t going to punch itself!',0,0,0,0,0,0,0,0,0,0,0,62073,26124),
(103099,'','Oh... hold on! I\'ll... I\'ll figure out some way to follow you! Just hold on!',0,0,0,0,0,0,0,0,0,0,0,62074,26124),
(103100,'','Phew! That\'s one heck of a fall! I can\'t even see the ground down there!',0,0,0,0,0,0,0,0,0,0,0,62075,26124),
(103101,'','Do me a favor and NEVER tell Uncle Chen I was this high up. Okay?',0,0,0,0,0,0,0,0,0,0,0,62076,26124),
(103102,'','Whoa! This guy is, like, super tough! Do you think we can beat him?',0,0,0,0,0,0,0,0,0,0,0,62077,26124),
(103103,'','Yeah, you got this!',0,0,0,0,0,0,0,0,0,0,0,62078,26124),
(103104,'','That was awesome!! I was like, \"Oh no!\" And you were like, \"leave it to me!\"',0,0,0,0,0,0,0,0,0,0,0,68705,26124),
(103106,'','This has been a fantastic adventure! We explored the desert, punched a dragon in the face, and even got you something shiny!',0,0,0,0,0,0,0,0,0,0,0,62079,26124),
(103107,'','All this adventuring\'s making me sleepy. Let\'s head back to the Wandering Isle.',0,0,0,0,0,0,0,0,0,0,0,62080,26124),
(103108,'Now is not the time, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103109,'','Broken Shore was just the beginning. The Alliance will retaliate. Given the opportunity, they will strike when we are weak.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103110,'|TInterface\\Icons\\inv_misc_monsterspidercarapace_01:20|tNearby |cFFFF0000|Hspell:198235|h[Spider Eggs]|h|r will hatch soon if not destroyed!.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103111,'[ph]I\'m free, but others of my people are still suffering on the walls above. Please, help them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103112,'[ph]We\'ve seen the creatures use this room to travel to the lands below; with it we can escape this place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103113,'','Pretty neat, huh?',0,0,0,0,0,0,0,0,0,0,0,62068,26124),
(103114,'','\"May the night shroud me in shadow...\"',0,0,0,0,0,0,0,0,0,0,0,55444,26124),
(103115,'','Stand down! This one has purpose for treading here.',0,0,0,0,0,0,1,0,0,0,0,69211,26124),
(103116,'','Pardon me, but if I may be so bold as to interrupt...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103117,'Build a pyre around Jarl Throndyr.','Build a pyre around Jarl Throndyr.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103118,'Is that really $Ghim:her;?','Is that $Ghim:her;?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103119,'I will devour your soul!','',53,0,0,0,0,0,0,0,0,0,0,0,26124),
(103120,'Foolish Illidari! Have you come to die as well?','',53,0,0,0,0,0,0,0,0,0,0,0,26124),
(103121,'Very well.','Very well.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103122,'Be careful around this one. Who knows what he\'s capable of.','Be careful around this one. Who knows what he\'s capable of.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103123,'','Such poor souls. You don\'t even belong here, but you will be forever bound to this place.',0,0,0,0,0,0,1,0,0,0,0,61895,26124),
(103124,'|TInterface\\Icons\\Spell_Holy_DivineProvidence:20|t $n is afflicted with |cFFFF0404|Hspell:192067|h[Expel Light]|h|r!','|TInterface\\Icons\\Spell_Holy_DivineProvidence:20|t $n is afflicted with |cFFFF0404|Hspell:192067|h[Expel Light]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103125,'','Do not fret. Through Ulthalesh, you will be so much more in death than you were in life.',0,0,0,0,0,0,38,0,0,0,0,61896,26124),
(103126,'','You were fools to think such a pitiful force could oppose an agent of Sargeras!',0,0,0,0,0,0,5,0,0,0,0,61897,26124),
(103127,'','Your worthless lives will pave the way for the Legion!',0,0,0,0,0,0,38,0,0,0,0,61898,26124),
(103128,'','How quaint. Do you really think your Holy Light can protect you from the Legion\'s onslaught?',0,0,0,0,0,0,6,0,0,0,0,61899,26124),
(103129,'','Where is your Light to protect you now?',0,0,0,0,0,0,38,0,0,0,0,61900,26124),
(103130,'That\'s the $c. $GHe:She was there.','That\'s the $c. $GHe:She was there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103131,'Look, that\'s the $c!','Look, that\'s the $c!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103132,'I wonder why they asked for $Ghim:her;?','I wonder why they asked for $Ghim:her;?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103133,'I didn\'t know $Ghe:she; was a $c.','I didn\'t know $Ghe:she; was a $c.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103134,'I wish I was at the Shore. I would have fought alongside $n.','I wish I was at the Shore. I would have fought alongside $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103135,'Isn\'t that $n? $GHe:She; made it back!','Isn\'t that $n? $GHe:She; made it back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103136,'Arggh! What power... is this?!','',53,0,0,0,0,0,0,0,0,0,0,0,26124),
(103137,'No quarter to these scallywags! Helya doesn\'t abide intruders.','',1,0,0,0,0,0,0,0,0,0,57460,0,26124),
(103138,'Send in the skeleton crew!','',25,0,0,0,0,0,0,0,0,0,57457,0,26124),
(103139,'What will you do now?','What will you do now?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103140,'','We cannot afford to lose Kayn and Altruis here. Waste no time and help them, quickly!',0,0,0,0,0,0,1,0,0,0,0,68365,26124),
(103141,'That feels SOO much better. Thank you, errr... what do I call you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103142,'(TEMP) FUNERAL CINEMATIC PLAYS (10 second delay)\nQuest Criteria will Progress in 8 seconds','(TEMP) FUNERAL CINEMATIC PLAYS (10 second delay)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103143,'You will never see the light of this world again.','',0,0,0,0,0,0,0,0,0,0,57310,0,26124),
(103144,'Freedom is but a hopeless dream.','',0,0,0,0,0,0,0,0,0,0,57311,0,26124),
(103145,'Such arrogance.... To think you can stand against the Legion!','',0,0,0,0,0,0,0,0,0,0,57385,0,26124),
(103146,'Show me the proof.','Show me the proof.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103147,'','Your eyes are deceiving you. Do not trust them!',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(103148,'Hey, brul. You don\'t look very strong to me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103149,'You\'re stronger than I thought, brul.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103150,'These bruls could learn a thing or two from you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103151,'I dropped the weights...','I dropped the weights...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103152,'Wretched Illidari! What have you done to me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103153,'','Hush, demon. This will all be over soon.',0,0,0,0,0,0,0,0,0,0,0,67598,26124),
(103154,'I shall aid you, friend. Let us banish this foul presence from Tel\'anor!','',0,0,0,0,0,0,0,0,0,0,65623,0,26124),
(103155,'I thank you for giving me newfound purpose. I will meet you at Shal\'Aran. I think I will be needing a source of magic after all.','',0,0,0,0,0,0,0,0,0,0,65622,0,26124),
(103156,'Rarrgh!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103161,'','I am pleased you have arrived.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103162,'Snowfeather swoops down and hovers expectantly. She has a message!','',0,0,0,0,0,0,0,0,0,36931,0,0,26124),
(103163,'The doors to Grommash Hold have been sealed. The leaders of the Horde must be protected!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103164,'Take me inside Grommash Hold.','Take me inside Grommash Hold.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103165,'I\'m looking for a master jewelcrafter.','I\'m looking for a master jewelcrafter.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103166,'I would like to review weapons we might pursue.','I would like to review weapons we might pursue.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103167,'','Oh, you\'re looking for Jabrul.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103168,'','He passed through here a few days ago. Went towards the Wretched Hollow to study the harpies.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103169,'','Haven\'t seen him since though. Hopefully he didn\'t succumb to the same affliction as the harpies.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103170,'Have you come to finish off Jabrul? If so, make it quick!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103171,'What happened to you?','What happened to you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103172,'Jabrul was attacked by the harpies and barely managed to hide.$b$bJabrul dropped his bag of jewels. Jabrul needs those jewels to heal himself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103173,'Here\'s your bag, Jabrul.','Here\'s your bag, Jabrul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103174,'Nighteyes hoots at you in a grateful tone.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103175,'Not right now, $n. This whole thing\'s got me down.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103176,'Not much in the mood for fishing today.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103177,'Today we remember. Tomorrow we train.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103178,'It is a sad day indeed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103179,'Those who lead sacrifice a great many things.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103180,'','Ashildir has told me of your exploits. You seek my mark so that you might impress Odyn.',0,0,0,0,0,0,0,0,0,0,0,69210,26124),
(103181,'','Stand on the dais and we will begin.',0,0,0,0,0,0,0,0,0,0,0,69209,26124),
(103182,'','Kneel before me, mortal.',0,0,0,0,0,0,0,0,0,0,0,69208,26124),
(103183,'','|TInterface\\Icons\\inv_misc_leatherscrap_17.blp:20|t %s has no one to melee and begins to |cFFFF0000|Hspell:198520|h[Wing Buffet]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103184,'','%s shatters all remaining ice blocks, freeing the geists inside!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103185,'','You have proven your worth as a Valkyra, but the trials to come are arduous.',0,0,0,0,0,0,0,0,0,0,0,69207,26124),
(103186,'','Wear proudly our mark, and perhaps you will prove worthy of Odyn\'s blessing.',0,0,0,0,0,0,0,0,0,0,0,69206,26124),
(103187,'','Now begone!',0,0,0,0,0,0,0,0,0,0,0,69205,26124),
(103188,'The catacombs\' entrance is just down this path. Make haste!','',0,0,0,0,0,0,1,0,0,0,60246,0,26124),
(103189,'It seems the spirits are indeed drawn to this place. Let us hope they are friendly.','',0,0,0,0,0,0,1,0,0,0,60247,0,26124),
(103190,'I can\'t believe he\'s gone.','I can\'t believe he\'s gone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103191,'She will lead us to victory in this war.','She will lead us to victory in this war.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103192,'He died with honor.','He died with honor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103193,'Was it the poison that made Vol\'jin name her-- Uh, nevermind.','Was it the poison that made Vol\'jin name her-- Uh, nevermind.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103194,'Have you paid respects?','Have you paid respects?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103195,'My axe will strike down foes in his honor.','My axe will strike down foes in his honor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103196,'The Horde was meant to be led by an orc, if you ask me!','The Horde was meant to be led by an orc, if you ask me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103197,'The Legion will pay for his death with their blood!','The Legion will pay for his death with their blood!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103198,'Today be de day of reflection.','Today be de day of reflection.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103199,'De Darkspear gonna be rememberin\' dis day.','De Darkspear gonna be rememberin\' dis day.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103200,'De pain de warchief went tru... ain\'t nothin\' we be forgettin\' soon.','De pain de warchief went tru... ain\'t nothin\' we be forgettin\' soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103201,'Blessin\'s of de Loa be wit him.','Blessin\'s of de Loa be wit him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103202,'Rest his soul.','Rest his soul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103203,'De son of Sen\'jin be restin\' wit\' his fatha now.','De son of Sen\'jin be restin\' wit\' his fatha now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103204,'May de spirits guide him.','May de spirits guide him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103205,'Wonderin\' what be happenin\' to our people now.','Wonderin\' what be happenin\' to our people now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103206,'May the Earth Mother watch over him.','May the Earth Mother watch over him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103207,'Blessings be upon him.','Blessings be upon him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103208,'The spirits will guide him.','The spirits will guide him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103209,'The Legion will pay for their crimes.','The Legion will pay for their crimes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103210,'When our journey ends, it is only the beginning.','When our journey ends, it is only the beginning.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103211,'I assure you, little one, he will not be forgotten.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103212,'Let us honor the deeds of those who fought for our well-being.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103213,'','I just can\'t believe it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103214,'','I never met him, but... I liked knowing he was there, ya know?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103215,'','It\'s a horrible tragedy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103216,'I\'ve witnessed such sadness too often in my lifetime.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103217,'I can\'t believe he\'s gone.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103218,'...Such a tremendous loss for us all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103219,'He always be tinkin\' da Horde be one. Dat be da truth, mon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103220,'Our people be strong. Let there be no mistakin\'... we in dis together.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103221,'Tauren, orc, troll, elves, goblins... forsaken. All of us be feelin\' da same ting.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103222,'Perfect! The one I\'ve been waiting for!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103223,'Jabrul needs to find unbroken versions of the two stones the harpies use in their necklaces.$b$bLet Jabrul know when you are ready to look for them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103224,'Alright, Jabrul, I\'m ready to go.','Alright, Jabrul, I\'m ready to go.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103225,'%s begins to crackle with lightning...','%s begins to crackle with lightning...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(103226,'','Thank you for your help. Your intervention saved my life.',0,0,0,0,0,0,0,0,0,0,0,55443,26124),
(103227,'','If you intend to venture deeper you will find far more terrifying things lurking in our Vault.',0,0,0,0,0,0,0,0,0,0,0,55442,26124),
(103228,'','The traitor is defeated. Thank you, we owe you a great debt.',0,0,0,0,0,0,0,0,0,0,0,55441,26124),
(103229,'','I will make my way to the surface, but you should inform the other wardens of what you have accomplished today.',0,0,0,0,0,0,0,0,0,0,0,55440,26124),
(103230,'','May the night shroud you in shadow, and the moon illuminate your foes.',0,0,0,0,0,0,0,0,0,0,0,55439,26124),
(103231,'','I have committed no crime, Tirathon. Whereas you and your associates have to answer for yours!',0,0,0,0,0,0,25,0,0,0,0,55438,26124),
(103232,'','Enough! I must know if Alleria was truly held captive here, or if this was all a ruse to trap us!',397,0,0,0,0,0,0,0,0,0,0,61833,26124),
(103233,'','He\'s tearing into my mind!',0,0,0,0,0,0,0,0,0,0,0,61843,26124),
(103234,'','I felt those eyes peering into my soul. Had you not freed me...',0,0,0,0,0,0,0,0,0,0,0,61813,26124),
(103235,'|TInterface\\Icons\\ability_warrior_shieldreflection.blp:20|tKrustallos casts |cFFFF0000|Hspell:78939|h[Elementium Bulwark]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(103236,'If you seek my blessing, then you must complete the ancient trials of the Valarjar.','',0,0,0,0,0,0,0,0,0,0,69204,0,26124),
(103237,'A noble effort, but you are not yet worthy of my blessing.','',0,0,0,0,0,0,0,0,0,0,69203,0,26124),
(103238,'Another... will take... my place...','',0,0,0,0,0,0,0,0,0,0,61808,0,26124),
(103239,'Deprecated','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103240,'Many before have followed the path you walk. None possessed the strength to persevere.','',0,0,0,0,0,0,0,0,0,0,69202,0,26124),
(103241,'','The trip through that demon portal was unsettling. Bide a moment, then let me know when you\'re ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103242,'','Let\'s ascend the rise ahead and see what we\'re up against.',0,0,0,0,0,0,0,0,0,0,0,61830,26124),
(103243,'You must place trust in your allies. The truly valorous do not walk alone.','',0,0,0,0,0,0,0,0,0,0,69201,0,26124),
(103244,'You must surge forward while hope remains in your heart!','',0,0,0,0,0,0,0,0,0,0,69200,0,26124),
(103245,'Rally your allies. Do not relent. Your trials are nearly complete!','',0,0,0,0,0,0,0,0,0,0,69199,0,26124),
(103246,'Jabrul will meet you inside the night elf house. Come find Jabrul when you\'re ready.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103247,'Keep harpies off of Jabrul while he looks for good necklaces.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103248,'These harpies aren\'t very good at keeping their trinkets safe. Most of these are broken.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103249,'Jabrul found one of the stones he was looking for. The other one must be around here somewhere.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103250,'As for you, champion... well done. Well done!','',0,0,0,0,0,0,0,0,0,42213,69198,0,26124),
(103251,'Jabrul needs your protection once more. Jabrul will try to be quick.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103252,'Jabrul doesn\'t understand how the harpies can treat their jewelry with such disregard.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103253,'Jabrul has found the other stone. We should make our way back to the safety of the night elves.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103254,'Behold! I bless you with my power.','',0,0,0,0,0,0,0,0,0,0,69197,0,26124),
(103255,'|TInterface\\Icons\\Ability_Rogue_SurpriseAttack:20|t%s is being |cFFFF0000|Hspell:191708|h[Mugged!]|h|r','|TInterface\\Icons\\Ability_Rogue_SurpriseAttack:20|t%s is being |cFFFF0000|Hspell:191708|h[Mugged!]|h|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103256,'|TInterface\\Icons\\ability_bosskilrogg_deadeye:20|t%s begins channeling their |cFFFF0000|Hspell:190836|h[Hatred!]|h|r','|TInterface\\Icons\\ability_bosskilrogg_deadeye:20|t%s begins channeling their |cFFFF0000|Hspell:190836|h[Hatred!]|h|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103257,'|TInterface\\Icons\\Ability_Racial_ShadowMeld:20|t%s is about to unleash a |cFFFF0000|Hspell:191823|h[Furious Blast!]|h|r','|TInterface\\Icons\\Ability_Racial_ShadowMeld:20|t%s is about to unleash a |cFFFF0000|Hspell:191823|h[Furious Blast!]|h|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103258,'|TInterface\\Icons\\Ability_Rogue_ShadowStrikes:20|t%s empowers himself with |cFFFF0000|Hspell:191941|h[Darkstrikes]|h|r!','|TInterface\\Icons\\Ability_Rogue_ShadowStrikes:20|t%s empowers himself with |cFFFF0000|Hspell:191941|h[Darkstrikes]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103259,'|TInterface\\Icons\\Spell_Shadow_Metamorphosis:20|t%s |cFFFF0000|Hspell:192504|h[Metamorphoses]|h|r!','|TInterface\\Icons\\Spell_Shadow_Metamorphosis:20|t%s |cFFFF0000|Hspell:192504|h[Metamorphoses!]|h|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103260,'|TInterface\\Icons\\Spell_Fire_Volcano:20|tA |cFFFF0000|Hspell:192520|h[Volcano]|h|r forms nearby.','|TInterface\\Icons\\Spell_Fire_Volcano:20|tA |cFFFF0000|Hspell:192520|h[Volcano]|h|r forms nearby.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103261,'|TInterface\\Icons\\spell_fire_ragnaros_molteninferno:20|tA Volcano is struck by lava, resulting in a |cFFFF0000|Hspell:193263|h[Burst]|h|r of fire!','|TInterface\\Icons\\spell_fire_ragnaros_molteninferno:20|tA Volcano is struck by lava, resulting in a |cFFFF0000|Hspell:193263|h[Burst]|h|r of fire!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103262,'|TInterface\\Icons\\ability_deathknight_brittlebones:20|tThe cell countermeasures freeze the area, turning Ash\'golm |cFFFF0000|Hspell:192517|h[Brittle!]|h|r','|TInterface\\Icons\\ability_deathknight_brittlebones:20|tThe cell countermeasures freeze the area, turning Ash\'golm |cFFFF0000|Hspell:192517|h[Brittle!]|h|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103263,'I sense a powerful druid among you. You dare to challenge my authority?','',0,0,0,0,0,0,0,0,0,0,54936,0,26124),
(103264,'What is that you hold, druid?','',0,0,0,0,0,0,0,0,0,0,54934,0,26124),
(103265,'|TInterface\\Icons\\spell_mage_arcaneorb:20|t%s creates a |cFFFF0000|Hspell:194880|h[Pulse]|h|r of energy that will ricochet off the walls.','|TInterface\\Icons\\spell_mage_arcaneorb:20|t%s creates a |cFFFF0000|Hspell:194880|h[Pulse]|h|r of energy that will ricochet off the walls.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103266,'You fight with the fury of Ursoc himself! No... I will not be defeated!','',0,0,0,0,0,0,0,0,0,0,54932,0,26124),
(103267,'|TInterface\\Icons\\Ability_Hunter_MasterMarksman:20|t%s begins |cFFFF0000|Hspell:194289|h[Focusing]|h|r a beam of energy! Use the Lenses to reflect it back at him!','|TInterface\\Icons\\Ability_Hunter_MasterMarksman:20|t%s begins |cFFFF0000|Hspell:194289|h[Focusing]|h|r a beam of energy! Use the Lenses to reflect it back at him!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103268,'I share my power with you alone, champion. Bathe in the light of creation. Bask in the glory of the valorous!','',0,0,0,0,0,0,0,0,0,0,69196,0,26124),
(103269,'I sense great cunning and prowess from you, druid, but I will not be defeated!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103270,'What power comes from those fangs, defiler? You fight with the strength of the Ancients themselves.','',0,0,0,0,0,0,0,0,0,0,54933,0,26124),
(103271,'You are blessed with great restorative powers, druid, but I will rip you all apart in the end!','',0,0,0,0,0,0,0,0,0,0,54931,0,26124),
(103272,'We\'ll take this one out, no problem!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103273,'Your power burns... How have you twisted the Scythe of Elune to obey your will?','',0,0,0,0,0,0,0,0,0,0,54935,0,26124),
(103274,'Jabrul will stay here and study these necklaces.$b$bJabrul will not forget you and the help you\'ve given him, $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103275,'','Keep moving! That was only the first!',0,0,0,0,0,0,0,0,0,0,0,61823,26124),
(103276,'|TInterface\\Icons\\inv_misc_herb_flytrap:20|t%s throws |cFFFF0000|Hspell:197379|h[Cruel Traps]|h|r around the platform!','|TInterface\\Icons\\inv_misc_herb_flytrap:20|t%s throws |cFFFF0000|Hspell:197379|h[Cruel Traps]|h|r around the platform!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103277,'|TInterface\\Icons\\inv_misc_ticket_tarot_vengeance:20|t%s summons an |cFFFF0000|Hspell:197796|h[Avatar of Vengeance!]|h|r','|TInterface\\Icons\\inv_misc_ticket_tarot_vengeance:20|t%s summons an |cFFFF0000|Hspell:197796|h[Avatar of Vengeance!]|h|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103278,'|TInterface\\Icons\\inv_throwingchakrum_01_fel:20|t%s hurls a |cFFFF0000|Hspell:197513|h[Detonating Moonglaive!]|h|r','|TInterface\\Icons\\inv_throwingchakrum_01_fel:20|t%s hurls a |cFFFF0000|Hspell:197513|h[Detonating Moonglaive!]|h|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103279,'|TInterface\\Icons\\Ability_Rogue_Shadowstep:20|t%s |cFFFF0000|Hspell:197823|h[Shadowsteps]|h|r away from the party. Reveal her with Elune\'s Light!','|TInterface\\Icons\\Ability_Rogue_Shadowstep:20|t%s |cFFFF0000|Hspell:197823|h[Shadowsteps]|h|r away from the party. Reveal her with Elune\'s Light!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103280,'|TInterface\\Icons\\ability_priest_auspiciousspirits:20|tSpirits form in the shadows around the platform!','|TInterface\\Icons\\ability_priest_auspiciousspirits:20|tSpirits form in the shadows around the platform!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103281,'','Thanks to you, Azoran has been slain and a great blow has been struck against the Burning Legion.',0,0,0,0,0,0,0,0,0,0,0,67597,26124),
(103282,'','However, our work is still far from over...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103283,'','During your battle with Azoran, I was able to secure information from the ship\'s database. We have much to discuss.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103284,'','I be waiting for you at the underground base. Until then, farewell.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103285,'','We must discover what the cause of this attack is before there\'s no one left to fight.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103287,'You have truly impressed me. To pass these trials is a triumph, to do so with such speed makes of you a legend!','',0,0,0,0,0,0,0,0,0,0,69195,0,26124),
(103288,'It is done! Walk proudly this day and relish your victory.','',0,0,0,0,0,0,0,0,0,0,69194,0,26124),
(103289,'','No sign of Orestes. He\'s headstrong, but should have the sense to wait here for us!',0,0,0,0,0,0,0,0,0,0,0,61800,26124),
(103290,'I\'m ready. Let\'s go.','I\'m ready. Let\'s go.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103291,'I spit on your corpse, serpent!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103292,'As for you outsider, do not step foot into Jandvik or it will be your corpse I spit on next.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103293,'Mortals, in MY domain? They must not disrupt my plans! Slaughter them!','',0,0,0,0,0,0,0,0,0,0,61981,0,26124),
(103294,'Puny mortals, you tread in MY realm now! There is no one to save you!','',0,0,0,0,0,0,0,0,0,0,61982,0,26124),
(103295,'Insolent whelps! Witness the powers at my command! Al\'\'burq wa Alra\'ed hiyah!','',0,0,0,0,0,0,0,0,0,0,61984,0,26124),
(103296,'A small victory! Enjoy it while you can!','',0,0,0,0,0,0,0,0,0,0,61985,0,26124),
(103297,'Come forth, servants of the storm! Defend your master!','',0,0,0,0,0,0,0,0,0,0,61986,0,26124),
(103298,'Unacceptable! Melezan, destroy them or I will cast your miserable essence to Deepholm!','',0,0,0,0,0,0,0,0,0,0,61988,0,26124),
(103299,'These mortals will not die! Zaurac, defend your master!','',0,0,0,0,0,0,0,0,0,0,61989,0,26124),
(103300,'Are all of my servants weaklings? Fine, I shall end you myself!','',0,0,0,0,0,0,0,0,0,0,61990,0,26124),
(103302,'Sia\'la yemil!','',0,0,0,0,0,0,0,0,0,0,61991,0,26124),
(103305,'','Hmm... These tornadoes simply won\'t do.',0,0,0,0,0,0,1,0,0,0,0,62066,26124),
(103306,'','Onward to adventure!',0,0,0,0,0,0,0,0,0,0,0,62081,26124),
(103307,'I\'ve heard that you know a tale describing a set of mysterious hand blades.','I\'ve heard that you know a tale describing a set of mysterious hand blades.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103308,'','Yeah! Let me think... I heard it back when Uncle Chen and I were still traveling the world before we found the way to Pandaria.$b$bWe were in Booty Bay one night staying at a place called the Salty Sailor. While there I met a giant creature who called himself a Tol\'vir.$b$bWe chatted for a long time and he told me of his homeland, a place covered in sands called Uldum.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103309,'Please, go on.','Please, go on.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103310,'','<Li Li\'s ears perk up.>$b$bWell, the story goes that there is a land covered by sand called Uldum.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103311,'I\'ve also heard of it.','I\'ve also heard of it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103312,'I\'ve been there before.','I\'ve been there before.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103313,'','Oh that\'s so cool! I was there only for a little while. I wish I could visit there again sometime.$b$bSo according to the story thousands of years ago there was this smith called Irmaat who used to live there. The smith was known all throughout the land for his excellent work in creating magical weapons that represent the air spirits that live there.$b$bHis finest work was said to be a set of hand blades that were formed from the essence of pure air. The story goes on that he attempted to summon the lord of the winds to imbue the weapons with its power.$b$bThat didn\'t go so well for him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103314,'','It\'s REALLY dry and covered all with sand like a big kitty box! I briefly went there with my Uncle Chen. I wish I could see it again!$b$bSo according to the story thousands of years ago there was this smith called Irmaat who used to live there. The smith was known all throughout the land for his excellent work in creating magical weapons that represent the air spirits that live there.$b$bHis finest work was said to be a set of hand blades that were formed from the essence of pure air. The story goes on that he attempted to summon the lord of the winds to imbue the weapons with its power.$b$bThat didn\'t go so well for him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103315,'What happened then?','What happened then?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103316,'','According to the story, the lord of air was filled with great wrath and decided to play a trick on Irmaat.$b$bThe lord of air imbued the weapons with the purest form of his essence, knowing that Irmaat could not possibly wield such power. Irmaat named his creation the \"Fists of the Heavens\" and held them to the sky to admire his work. This was a mistake, for when he did this it conjured a great vortex of swirling sand and air that was completely out of his control! The vortex scattered the smith\'s blades and buried his home under the desert sands.$b$bWouldn\'t it be neat if the blades were real? I\'d give anything to get out of here and go search for them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103317,'A Warchief who knows strategy - who commands without hesitation.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103318,'By the decree of Vol\'jin, acting Warchief of the Horde, I enact you, Lady Sylvanas Windrunner, as the new Warchief of the our people.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103319,'You will go no farther!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103320,'You go have your fun, pup. I have had my fill for the day.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103321,'We will never rest till the Legion is defeated.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103322,'I\'ve changed my mind. Let me pick a different artifact.','I\'ve changed my mind. Let me pick a different artifact.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103323,'What\'s your opinion about the Shivarra?','What\'s your opinion about the Shivarra?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103324,'The Shivarra and many other demons swore fealty to Lord Illlidan when he defeated their former master, the pit lord Magtheridon. We also have naga, broken, and some other creatures working for us.\n\nIf the Lord of Outland is okay with it, then I guess that\'s good enough for me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103325,'','Okay, Pop. It\'s been... it\'s been something. I need to get on with my travels.',0,0,0,0,0,0,0,0,0,0,0,61994,26124),
(103326,'Li Li, I told you I don\'t want you going off on your own again.','',0,0,0,0,0,0,0,0,0,0,61995,0,26124),
(103327,'','I thought you might say that... Look, I have a guardian, and it\'s even the master of the monks. I\'ll be fine!',0,0,0,0,0,0,0,0,0,0,0,61996,26124),
(103328,'Are you certain, $n? You\'re far more important to the mission than me.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(103329,'%s scowls.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103331,'Clearly nothing I say is going to change your mind. Fine, go on your adventure. Just come back to me unharmed.','',0,0,0,0,0,0,0,0,0,0,61997,0,26124),
(103332,'I\'ve made up my mind. Sacrifice me, Sevis, and power the gateway.','I\'ve made up my mind. Sacrifice me, Sevis, and power the gateway.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103333,'','Follow me. My brother Wuho was supposed to scout out a \"safe\" area where we can fly in. We will take a hippogryph to the harbor and he should send us a signal of where to land.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103334,'I\'m looking for some diamonds, Tiffany, do you have any?','I\'m looking for some diamonds, Tiffany, do you have any?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103335,'','Yay! Okay $n, let\'s go!',0,0,0,0,0,0,0,0,0,0,0,61998,26124),
(103336,'Hold a moment, Sevis. I\'m reconsidering.','Hold a moment, Sevis. I\'m reconsidering.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103337,'Of course. I willingly sacrifice myself for the cause. What demon hunter wouldn\'t?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103338,'I\'m certain, Sevis. I need to sacrifice you to power the gateway.','I\'m certain, Sevis. I need to sacrifice you to power the gateway.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103339,'','My friend Mr. Crane can fly me to Uldum. Here, you can use my kite to follow us.',0,0,0,0,0,0,0,0,0,0,0,61999,26124),
(103340,'','Okay, Mr. Crane. Here\'s two juicy fish if you\'ll take me to Uldum.',0,0,0,0,0,0,0,0,0,0,0,62000,26124),
(103341,'','No, you get one now and one when we get there. No complaining!',0,0,0,0,0,0,0,0,0,0,0,62001,26124),
(103342,'','I hope my brother didn\'t go after the beast himself. He can be... impulsive.',0,0,0,0,0,0,0,0,0,0,0,62672,26124),
(103343,'Tiffany, can you cut this diamond into some lockpicks please?','Tiffany, can you cut this diamond into some lockpicks please?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103344,'','I don\'t currently have any, no. But I hear they have all sorts of items in the Underbelly.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103345,'','I myself would never dream of going down there, but I assume you\'d have no problem given your primary career as a $c.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103346,'','These designs are interesting, did you come up with them yourself? But yes, I could cut these for you.',0,0,0,0,0,0,483,0,0,0,0,0,26124),
(103347,'','Here you are. And next time, perhaps you should try crafting it yourself before coming to me and put both our time to better use.',0,0,0,0,0,0,483,0,0,0,0,0,26124),
(103348,'','There is his signal! Let us land and see what he learned.',0,0,0,0,0,0,0,0,0,0,0,62673,26124),
(103349,'I will meet you down at the gateway on the Molten Shore.','',0,0,0,0,0,0,0,0,0,0,55352,0,26124),
(103350,'Do not be deceived by your mortal eyes! The Legion is already among us!','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(103351,'Show me the proof.','Show me the proof.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103352,'Your eyes cannot show you what they cannot see.','Your eyes cannot show you what they cannot see.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103353,'We cannot allow them breach the gates!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103354,'Insolent wretches!','',0,0,0,0,0,0,0,0,4,0,63867,0,26124),
(103355,'','It would appear we\'ve been discovered.',0,0,0,0,0,0,1,0,4,0,0,63868,26124),
(103356,'Did you think you could escape my grasp so easily?','',0,0,0,0,0,0,0,0,4,0,63869,0,26124),
(103357,'','Ungh... Unhand me, wretch!',0,0,0,0,0,0,0,0,4,0,0,63870,26124),
(103358,'Haughty warlocks! You presume to issue commands to my kind! Face the consequences for your insolence!','',0,0,0,0,0,0,0,0,4,0,63871,0,26124),
(103359,'','Shinfel! No!',0,0,0,0,0,0,5,0,4,0,0,63872,26124),
(103360,'I will smash you like the insignificant gnats you are!','',0,0,0,0,0,0,0,0,4,0,63873,0,26124),
(103361,'Burn! Burn in fel fire!','',0,0,0,0,0,0,0,0,4,0,63874,0,26124),
(103362,'You will not get away! I\'m not done with you yet!','',0,0,0,0,0,0,0,0,4,0,63876,0,26124),
(103363,'Your skull will make a fine trophy!','',0,0,0,0,0,0,0,0,4,0,63878,0,26124),
(103364,'','Ungh! Press on, warlock... close the portal!',0,0,0,0,0,0,0,0,4,0,0,63881,26124),
(103365,'I will burn you to cinders!','',0,0,0,0,0,0,0,0,4,0,63882,0,26124),
(103366,'This is not over, warlock! I will see the end of you!','',0,0,0,0,0,0,0,0,4,0,63884,0,26124),
(103367,'','We have the most exotic of wares from across the world.$b$bWhat is it you\'re looking for?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103368,'I\'m looking for some diamonds. Do you have any?','I\'m looking for some diamonds. Do you have any?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103369,'','Why yes, I do. But just the one. A rather large and exotic, rare jewel from across the sea.$b$bI\'d be willing to part with it for, oh... two hundred and fifty gold pieces? I also accept favors as currency.$b$bA nuisance has sprouted up around here named Inkrot. If he were to be eliminated, I\'d be willing to part with the diamond.$b$bSo, which do you choose?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103370,'(Fair) 250 gold is much too high for just one diamond. How about 25?','(Fair) 250 gold is much too high for just one diamond. How about 25?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103371,'(Aggressive) 250 gold is outrageous for one diamond! I\'ll give you 10.','(Aggressive) 250 gold is outrageous for one diamond! I\'ll give you 10.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103372,'(Fair) I still can\'t go as high as 200. How about 75?','(Fair) I still can\'t go as high as 200. How about 75?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103373,'(Aggressive) Look, there\'s no way I\'m paying 200. How about 35?','(Aggressive) Look, there\'s no way I\'m paying 200. How about 35?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103374,'(Fair) We\'re getting closer with 125, but not close enough. How about 40?','(Fair) We\'re getting closer with 125, but not close enough. How about 40?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103375,'(Aggressive) 125 is still out of the question. I think 35 is still a fair price.','(Aggressive) 125 is still out of the question. I think 35 is still a fair price.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103376,'(Fair) I hear you at 100, but I\'m afraid I can\'t offer any higher than 50. Final offer.','(Fair) I hear you at 100, but I\'m afraid I can\'t offer any higher than 50. Final offer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103377,'(Aggressive) You\'re still too high. 40 is the fairest price I\'m going to offer.','(Aggressive) You\'re still too high. 40 is the fairest price I\'m going to offer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103378,'','Twenty five gold for this diamond of diamonds? I think not.$b$bBut you have a wise face. I suppose I could part with this for two hundred gold.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103379,'','I didn\'t begin this exchange with you to be insulted. Two hundred fifty is my final offer, take it or leave it.$b$bOf course, my favor is still on the table, if you\'d rather take that route.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103380,'','You come up, I\'m supposed to come down, yes? An exchange I\'m all too familiar with.$b$bVery well, I\'ll go as low as one hundred and seventy five, take it or leave it.$b$bOf course, my favor is still on the table, if you\'d rather take that route.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103381,'','There\'s no need to take that tone with me, $gsir:madam;. It\'s shame to work with someone with such little money.$b$bWill one one hundred and twenty five gold break your bank?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103382,'','Come now, surely you\'re not that poor?$b$bFine, I\'ll go down just a bit more. How does a cool one hundred gold sound? A fair price for the fairest of diamonds.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103383,'','And I think I\'m done haggling here.$b$bOne hundred and twenty gold, take it or leave it.$b$bOf course, my favor is still on the table, if you\'d rather take that route.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103384,'','If you weren\'t such a charmer I\'d have ended this exchange before it ever began.$b$bBut I like you. You\'re rather stubborn and a good haggler.$b$bYou have a deal at fifty.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103385,'','Well the fairest price you\'ll hear from me is one hundred, take it or leave it.$b$bOf course, my favor is still on the table, if you\'d rather take that route.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103386,'Pay the 250 gold.','Pay the 250 gold.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103387,'Pay the 175 gold.','Pay the 175 gold.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103388,'Pay the 120 gold.','Pay the 120 gold.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103389,'Pay the 200 gold.','Pay the 200 gold.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103390,'Pay the 125 gold.','Pay the 125 gold.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103391,'Pay the 100 gold.','Pay the 100 gold.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103392,'Pay the 50 gold.','Pay the 50 gold.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103393,'I\'ve taken care of Inkrot.','I\'ve taken care of Inkrot.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103394,'I see you have brought a truly bountiful feast with you. Do you not wish to share it with me?','',0,0,0,0,0,0,0,0,0,0,69193,0,26124),
(103395,'Why must you continue to taunt me with that feast you carry? My Valarjar enjoy nothing more than a banquet after a worthy bout!','',0,0,0,0,0,0,0,0,0,0,69192,0,26124),
(103396,'','And here is your diamond. A pleasure doing business with you. Please return soon.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103397,'What is it you seek? Power? Glory? Be reasonable! My warriors\' hunger knows no end!','',0,0,0,0,0,0,0,0,0,0,69191,0,26124),
(103398,'My patience wears thin. Relinquish the feast to me before we do battle or you will never set foot in these shining halls again!','',0,0,0,0,0,0,0,0,0,0,69190,0,26124),
(103399,'Get goin\', $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103400,'Demons... gotta warn da others.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103401,'','Yikes! Get outta here! Go!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103402,'','Where did they come from?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103403,'','Back to the nether with you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103404,'','This one\'s mine!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103405,'','Your presence is not welcome here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103406,'At long last the monster is dead and our relic reclaimed. My spirit can finally move on from this place...','',0,0,0,0,0,0,1,0,0,0,62702,0,26124),
(103407,'Again I thank you. I will find the spirits of your friends and ensure they do not stay here.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103408,'I am ready to go.','I am ready to go.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103413,'|TInterface\\Icons\\spell_shadow_carrionswarm:20|t%s begins to cast |cFFFF0000|Hspell:198947|h[Carrion Storm]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103414,'Do you smell them, on the wind? The Legion\'s invasion has begun.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103415,'I would like to review the empowerments we might pursue.','I would like to review the empowerments we might pursue.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103416,'Are you sure? You may only pursue one empowerment at a time.','Are you sure? You may only pursue one empowerment at a time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103417,'','The others... I\'ll warn them immediately!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103418,'','Keep them outside of the gates!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103419,'','They were here all along!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103422,'','Zinnin, look out!',0,0,0,0,0,0,5,0,4,0,0,63877,26124),
(103423,'Ms. Xiulan sends her regards!','Ms. Xiulan sends her regards!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103424,'Ms. Xiulan sent you to get rid of me?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(103425,'Good to know. When I\'m through with you, I\'ll take care of her too!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(103426,'','You shall be avenged! We must finish this. Follow the monster!',0,0,0,0,0,0,0,0,0,0,0,62696,26124),
(103427,'Filthy $r, I\'ll bring your head to lord Typhinius!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103428,'Lord Typhinius... I have failed you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103429,'Flee, friend! We must escape through the gateway!','',0,0,0,0,0,0,1,0,0,0,63875,0,26124),
(103430,'','These wounds... they are not healing. We must finish this quickly, before we bleed out!',0,0,0,0,0,0,0,0,0,0,0,62697,26124),
(103431,'','Zinnin...',0,0,0,0,0,0,1,0,4,0,0,63879,26124),
(103432,'','Slay... the monster. Find... Talonclaw...',0,0,0,0,0,0,0,0,6,0,0,62701,26124),
(103433,'The path is clear! Hurry!','',0,0,0,0,0,0,1,0,0,0,63883,0,26124),
(103434,'','What have you done? Hsss...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103435,'','Tidemistress! They are weakening me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103436,'','What have you... Hsss... done to me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103437,'Hsss... My strength is gone!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103438,'Hsss... Hsss...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103439,'I will have your head for that. Hsss...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103440,'','Oh no!',0,0,0,0,0,0,0,0,4,0,0,63880,26124),
(103441,'','A sentry! Destroy it before it warns the others!',0,0,0,0,0,0,0,0,0,0,0,61838,26124),
(103442,'','The eredar are summoning in more demons!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103443,'','Portal mages! Take them out before they bring reinforcements!',0,0,0,0,0,0,0,0,0,0,0,61820,26124),
(103444,'You shall not disturb the work of the hound mistress!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103445,'','The portal magic of the eredar struck me... I need a moment to recover.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103446,'','That structure in the distance must be the cathedral. Lead on, I\'m with you!',0,0,0,0,0,0,0,0,0,0,0,61829,26124),
(103447,'','Our mission is of critical importance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103448,'Greetings, $n. It is fortunate I found you. Your presence is requested at Moonglade.','',0,0,0,0,0,0,1,0,0,0,62105,0,26124),
(103449,'I\'ll meet you there as soon as you conclude your business in Dalaran.','',0,0,0,0,0,0,0,0,0,0,62106,0,26124),
(103450,'There you are. $n, over here. Azsuna awaits.','',0,0,0,0,0,0,0,0,0,0,57419,0,26124),
(103452,'This feature is not yet ready for testing. You have been given credit for this objective.','This feature is not yet ready for testing. You have been given credit for this objective.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(103453,'I see... intruders!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(103454,'I see... nothing...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103455,'','This is amazing! Think of all we could learn from these tomes!',0,0,0,0,0,0,5,0,0,0,0,63863,26124),
(103456,'','Not to mention the power they could give us...',0,0,0,0,0,0,1,0,0,0,0,63864,26124),
(103457,'Here! This is the tome you seek, friend!','',0,0,0,0,0,0,1,0,0,0,63865,0,26124),
(103458,'Take it! Then we can leave this place before Jagganoth finds us!','',0,0,0,0,0,0,1,0,0,0,63866,0,26124),
(103459,'|TInterface\\Icons\\ability_fixated_state_red:20|tA Razormaw Shark has the scent of your blood! Get back to land!','|TInterface\\Icons\\ability_fixated_state_red:20|tA Razormaw Shark has the scent of your blood! Get back to the land!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(103461,'With it, we\'ll be able to invade any Legion world, even Argus.','',0,0,0,0,0,0,5,0,0,0,55246,0,26124),
(103462,'','Hardly more than a morsel, but I suppose you\'ll have to do!',0,0,0,0,0,0,0,0,0,0,0,61798,26124),
(103463,'','But... who will feed my darlings?',0,0,0,0,0,0,0,0,0,0,0,61809,26124),
(103464,'','You\'re just in time for dinner... for my pets, that is!',0,0,0,0,0,0,153,0,0,0,0,61810,26124),
(103465,'Mistress Torvis! Intruders approach!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103466,'Get away from that spire!','',0,0,0,0,0,0,0,0,0,0,55140,0,26124),
(103467,'And I want them alive! There\'s no challenge in dead rabbits!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103468,'These intruders will fall by my hand!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103469,'As you command, Lord Typhinius.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103470,'As my master wills!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103471,'Turns out... rushing through that portal... not my best idea...','',0,0,0,0,0,0,0,0,0,0,61844,0,26124),
(103472,'Not this time... wounds are bad. The hounds... don\'t let them get near you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103473,'Guess your mage was right... time goes crazy in the Nether. Least I lasted long enough... to warn you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103474,'No, but... didn\'t make it to cathedral. Wounds bad... it\'s so cold...','',0,0,0,0,0,0,0,0,0,0,61846,0,26124),
(103475,'Here... over here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103476,'Time to put an end to this inquisition!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103477,'Very good.  Fireball is a powerful spell but takes a while to cast.  Sometimes you need something quicker.  Let\'s teach you how to cast Inferno Blast.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103478,'Not only is Inferno Blast instant but it will always score a critical hit. This will be important later. Eliminate the Ooze over there with Inferno Blast.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103479,'I can\'t believe he\'s really gone.','',0,0,0,0,0,0,579,0,0,0,0,0,26124),
(103480,'He died with honor, protecting his people. He was a true king.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103481,'His valor inspired us all, even in death. His spirit will be with us, always.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103482,'Na\'ser! Answer your masters call!','',0,0,0,0,0,0,0,0,0,0,61987,0,26124),
(103483,'My axe never misses its mark.','',0,0,0,0,0,0,0,0,0,0,55174,0,26124),
(103484,'Malfurion waits for you by the barrow dens to the east. Follow me.','',0,0,0,0,0,0,0,0,0,0,62129,0,26124),
(103485,'There are powerful druids in Val\'sharah who grew under Cenarius\'s tutelage after the Great Sundering.','',0,0,0,0,0,0,0,0,0,0,62133,0,26124),
(103486,'Their knowledge of druidism is ancient and unparalleled. Having their might on our side is essential if we are to stop the Legion.','',0,0,0,0,0,0,0,0,0,0,62135,0,26124),
(103487,'The Legion\'s arrival has thrown our world out of balance. I\'ve sensed great unrest within the Emerald Dream.','',0,0,0,0,0,0,0,0,0,0,62131,0,26124),
(103488,'','King Anduin, the hero of the Broken Shore approaches.',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(103489,'Opening the path to this ancient home of all druids will be no small feat. I hope you\'re ready for the task.','',0,0,0,0,0,0,0,0,0,0,62137,0,26124),
(103490,'','My fel secrets will consume you!',0,0,0,0,0,0,0,0,0,0,0,55340,26124),
(103491,'There\'s a high elf body up ahead. It looks like...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103492,'','You\'ve returned with the artifact! Well done, $n!',4,0,0,0,0,0,0,0,0,0,0,0,26124),
(103493,'Why are you talking to me? FIGHT THESE DEMONS!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103494,'Like my new sword? Take a closer look.','',0,0,0,0,0,0,0,0,0,0,55335,0,26124),
(103495,'The ritual will focus our energy into a portal at the center of the structure. We must keep it stable!','',0,0,0,0,0,0,0,0,4,0,62132,0,26124),
(103496,'Excellent! The path is taking form! It grows more stable by the moment!','',0,0,0,0,0,0,0,0,4,0,62136,0,26124),
(103498,'The Dreamway is ready! Good work, everyone.','',0,0,0,0,0,0,0,0,4,0,62138,0,26124),
(103500,'My queen\'s brood will hatch soon.','',0,0,0,0,0,0,0,0,0,0,55283,0,26124),
(103501,'','Sounds like we\'re about to be overrun. Let us leave this wretched place to the demons.',0,0,0,0,0,0,0,0,0,0,0,61822,26124),
(103503,'','Look out! They\'re hidin\' in the dust!',0,0,0,0,0,0,0,0,0,0,0,60590,26124),
(103505,'The invasions are beginning! Go rally my brethren in the Mage Quarter, champion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103506,'','The body is that of a young high elf. Too young to be Alleria.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103507,'Press forward, $n! I cannot return to Jandvik until I have avenged the death of Throndyr!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103508,'Deprecated','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103509,'My fire will leave only your bones behind.','',0,0,0,0,0,0,0,0,0,0,55201,0,26124),
(103510,'My swarm will feast on your soul!','',0,0,0,0,0,0,0,0,0,0,55088,0,26124),
(103511,'My arrival heralds the end.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103512,'You are too late. The end was set in motion long ago.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103513,'You are but misbegotten pawns.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103514,'','None can resist my kiss.',0,0,0,0,0,0,0,0,0,0,0,55068,26124),
(103515,'Burn in the flames of Sargeras!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103516,'You merely... prolong...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103517,'','Come forth, my children. Feast upon our enemies.',0,0,0,0,0,0,0,0,0,0,0,55069,26124),
(103518,'I will enjoy your death.','',0,0,0,0,0,0,0,0,0,0,55177,0,26124),
(103519,'Come closer, my little friend.','',0,0,0,0,0,0,0,0,0,0,55178,0,26124),
(103520,'Embrace the inevitable.','',0,0,0,0,0,0,0,0,0,0,55179,0,26124),
(103521,'All worlds fall to the Legion.','',0,0,0,0,0,0,0,0,0,0,55180,0,26124),
(103522,'Bow to the will of Sargeras.','',0,0,0,0,0,0,0,0,0,0,55181,0,26124),
(103523,'The weave of your life comes to an end.','',0,0,0,0,0,0,0,0,0,0,55182,0,26124),
(103524,'This will be over quickly.','',0,0,0,0,0,0,0,0,0,0,55183,0,26124),
(103525,'Surrender and I will be merciful.','',0,0,0,0,0,0,0,0,0,0,55184,0,26124),
(103526,'Warn King Voras!','',0,0,0,0,0,0,0,0,0,0,55175,0,26124),
(103527,'Your Ashtongue met with an untimely demise.','',0,0,0,0,0,0,0,0,0,0,55176,0,26124),
(103528,'Quickly, kill the demon hunter!','',0,0,0,0,0,0,0,0,0,0,55185,0,26124),
(103539,'Now I shall measure your worth!','',0,0,0,0,0,0,0,0,0,0,61815,0,26124),
(103540,'I give my life... for the Inquisition!','',0,0,0,0,0,0,0,0,0,0,61817,0,26124),
(103541,'The Inquisition... will endure!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103542,'You belong... to the Inquisition!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103543,'How can I even go on?','How can I even go on?',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(103544,'This... changes... nothing...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103545,'What will we do without King Varian?','What will we do without King Varian?',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(103546,'The Inquisition... will endure!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103547,'Our king... gone too soon.','Our king... gone too soon.',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(103548,'Prepare to be judged!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103549,'Your bones will litter the roads of Niskara!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103550,'More meat for the hounds!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103551,'The High Inquisitor will enjoy your interrogation!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103552,'Ha ha ha... you fools will perish!','Ha ha ha... you fools will perish!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103553,'We are everywhere...','We are everywhere...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103554,'The Legion cannot be stopped!','The Legion cannot be stopped!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103555,'You are safe from nothing.','You are safe from nothing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103556,'Worthless beings! Kneel before the might of the Legion!','Worthless beings! Kneel before the might of the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103557,'Foolish mortals! Nothing can save you!','Foolish mortals! Nothing can save you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103558,'You stand on the threshold of oblivion! Your lives belong to the Inquisition!','',0,0,0,0,0,0,0,0,0,0,61818,0,26124),
(103559,'Grand Master! I have fantastic news for you!','',0,0,0,0,0,0,0,0,0,38576,0,0,26124),
(103560,'','Over there! Another impostor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103561,'','That one too! Kill it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103562,'','I\'ve marked another! Find it! Quickly!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103563,'','Got another! Get it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103564,'','Found another! I\'m starting to lose count!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103565,'%s vanishes in a puff of magic.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103566,'I would have words with you, Champion of the Alliance. Come speak with me at once!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103567,'You did it, friend! The portal is closed! He cannot pursue us here.','',0,0,0,0,0,0,1,0,0,0,63893,0,26124),
(103568,'We must find the weapon so that Jagganoth can be defeated! The book is the key!','',0,0,0,0,0,0,1,0,0,0,63894,0,26124),
(103569,'Ready when you are.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103570,'Let\'s get moving.','Let\'s get moving.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103571,'|TInterface\\Icons\\Spell_Nature_Earthquake:20|tGeneral Xakal begins to cast |cFFF00000|Hspell:197810|h[Wicked Slam]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103572,'I have an idea where to find the tome discussing the Pillars of Creation, but getting there may present some... challenges.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103573,'Well played...','',0,0,0,0,0,0,0,0,0,0,60593,0,26124),
(103574,'This platform is perfect.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103575,'Let\'s not waste any time, then. I\'ll setup the forge - keep an eye on the horizon for me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103576,'We made it, $n. Ahhh, these forests are just as I remember them!','',0,0,0,0,0,0,0,0,0,0,69905,0,26124),
(103577,'An ancient magic protects the Dreamgrove. Here, all brothers and sisters of the wilds will find sanctuary.','',0,0,0,0,0,0,0,0,0,0,69906,0,26124),
(103580,'','It\'s taking off!',0,0,0,0,0,0,0,0,0,0,0,62082,26124),
(103581,'','Or not.',0,0,0,0,0,0,0,0,0,0,0,62083,26124),
(103582,'Ah, the storm\'s already a brewin\'.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103583,'Keep yer wits about you, the Legion has assassins everywhere.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103584,'Hold on tight! We\'re coming in for a landing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103585,'They were fools to exile me. I will master this new magic and show them all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103586,'I am ready to begin the ritual.','I am ready to begin the ritual.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103587,'What in the three kingdoms... look out, we\'ve got company!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103588,'We have much to do and little time to do it. When you are ready, we\'ll begin.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103589,'Greetings','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103590,'','Where shall the winds take you today?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103591,'Fly me to Warbrave Oro.','Fly me to Warbrave Oro.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103592,'The wyrmtongue think they are clever, but they leave traces of magic all over the place. It should be relatively simple to draw one through my portal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103593,'This summoning will use much of my strength. Be prepared for a fight!','',0,0,0,0,0,0,0,0,0,0,66074,0,26124),
(103594,'Take care! There is a dark energy emanating from the spirits of this place. We had best not get too close.','',0,0,0,0,0,0,1,0,0,0,60286,0,26124),
(103595,'How far down is this place? These stairs seem to go forever.','',0,0,0,0,0,0,6,0,0,0,60287,0,26124),
(103596,'The way is blocked!','',0,0,0,0,0,0,5,0,0,0,60288,0,26124),
(103597,'Guild Bank','Guild Bank',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103598,'Intruders! You will go no further!','',0,0,0,0,0,0,0,0,0,0,60289,0,26124),
(103599,'Hold, $c! Those spirits he\'s controlling look like they\'ll rip us apart!','',0,0,0,0,0,0,5,0,0,0,60290,0,26124),
(103600,'We have to figure out a way to get past without being torn asunder.','',0,0,0,0,0,0,1,0,0,0,60291,0,26124),
(103601,'Wretched demon!','',0,0,0,0,0,0,5,0,0,0,60278,0,26124),
(103602,'Do not think you have won! Conservator, do your duty!','',0,0,0,0,0,0,25,0,0,0,60279,0,26124),
(103603,'Your presence is unauthorized. Removal protocols engaged.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103604,'I don\'t like the sound of that.','',0,0,0,0,0,0,1,0,0,0,60281,0,26124),
(103605,'Critical systems failure. Shutting... down...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103606,'Keep your guard up! I fear Ariden is not done with us yet.','',0,0,0,0,0,0,1,0,0,0,60283,0,26124),
(103607,'The artifact chambers look to be just ahead. Let us proceed.','',0,0,0,0,0,0,25,0,0,0,60284,0,26124),
(103608,'So this is what you\'re after? The artifacts of Karazhan belong here, and I will not allow them to be taken away!','',0,0,0,0,0,0,25,0,0,0,60294,0,26124),
(103609,'You have no right to these artifacts, fiend! They must be reclaimed in the name of the Light!','',0,0,0,0,0,0,5,0,0,0,60295,0,26124),
(103610,'Your Light does not reach here, priest!','',0,0,0,0,0,0,0,0,0,0,60296,0,26124),
(103611,'If you want Ulthalesh, warlock, come and claim it!','',0,0,0,0,0,0,0,0,0,0,60297,0,26124),
(103612,'Quickly, after him! I will only slow you down...','',0,0,0,0,0,0,0,0,0,0,60300,0,26124),
(103613,'You are a persistent one.','',0,0,0,0,0,0,1,0,0,0,60259,0,26124),
(103614,'Very well! If you so thirst for the power of the Deadwind Harvester, then I will show it to you myself!','',0,0,0,0,0,0,5,0,0,0,60260,0,26124),
(103615,'Ulthalesh feasts tonight!','',0,0,0,0,0,0,15,0,0,0,60262,0,26124),
(103616,'No! I will not be taken!','',0,0,0,0,0,0,0,0,0,0,60272,0,26124),
(103617,'Nooooooo!','',0,0,0,0,0,0,0,0,0,0,60275,0,26124),
(103618,'It is done. The Dark Riders are defeated.','',0,0,0,0,0,0,1,0,0,0,60251,0,26124),
(103619,'Now I can reclaim these stolen artifacts and return them to their rightful owners.','',0,0,0,0,0,0,1,0,0,0,60253,0,26124),
(103620,'You have proven an unexpected ally, $c. The weapon is yours. Let us hope it can turn the tide in this war.','',0,0,0,0,0,0,1,0,0,0,60255,0,26124),
(103621,'The Dark Riders lost this battle, but I fear they will soon regroup. We had best be gone before they do.','',0,0,0,0,0,0,1,0,0,0,60258,0,26124),
(103622,'Greetings, Archdruid Greathoof. We have traveled far to seek your aid.','',0,0,0,0,0,0,0,0,0,0,62267,0,26124),
(103623,'I\'ve heard the land cry out, son of Cenarius. The Legion threatens us all.','',0,0,0,0,0,0,0,0,0,0,62268,0,26124),
(103624,'The trees groan in agony as the Legion uproots them. Both our world and the Dream are in grave danger.','',0,0,0,0,0,0,0,0,0,0,62269,0,26124),
(103625,'Then we must act swiftly and ready the weapons of old for war.','',0,0,0,0,0,0,0,0,0,0,69903,0,26124),
(103626,'There is no one better suited for this task than $n.','',0,0,0,0,0,0,0,0,0,0,69904,0,26124),
(103627,'Very well. Your task will not be easy, but I shall do all that I can to aid you.','',0,0,0,0,0,0,0,0,0,0,62271,0,26124),
(103628,'Did you think I had forgotten about you, paladin? The Broken Shore was merely the beginning...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103629,'I\'ve been watching you - your power has grown quite considerably. Now my fist shall deliver your limp, lifeless body to me so that I can finish what I started.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103630,'The Burning Legion\'s power grows. We haven\'t time to spare.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103631,'Let us begin.','Let us begin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103632,'I\'ve been away too long. I fear the tower has fallen into disrepair. Please, pardon the mess.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103633,'Heh, I remember the day I arrived. So young and nervous... sent by the Kirin Tor to study under the famed mage Medivh.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103634,'I\'ll be seeing you soon...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103635,'Care to borrow some blinders? Other students have found them quite helpful for ignoring those distracting visions.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103636,'Uh... no, thank you. If I may ask, what became of the other students?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103637,'I was not the first sent to study under Medivh. I was, however, the only one he accepted as his apprentice.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103638,'Earning his trust took time. Cleaning the library wasn\'t a glamorous start to my career, but it taught me that to Medivh, everything was a test. Preparation for... a greater destiny.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103639,'So... It seems our young spy has arrived at last.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103640,'End this pathetic display.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103641,'This feature is not yet ready for testing. You have been given portal fragments.','This feature is not yet ready for testing. You have been given portal fragments.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(103642,'You have done it! Now to begin with a simple extraction...','',0,0,0,0,0,0,0,0,0,0,66075,0,26124),
(103643,'The forge is ready! Quickly, over here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103644,'The power of the wilds flows through us all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103645,'I would like to review weapons we might pursue.','I would like to review weapons we might pursue.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103646,'The Blacksmith Capture Point has spawned','The Blacksmith Capture Point has spawned',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103647,'The Gold Mine Capture Point has spawned','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103648,'The Lumber Mill Capture Point has spawned','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103649,'The Farm Capture Point has spawned','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103650,'The Stables Capture Point has spawned','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103652,'','I\'m going to relish silencing that fiend!',0,0,0,0,0,0,0,0,0,0,0,61814,26124),
(103653,'On this day the Ashbringer becomes something new... something our enemies would never expect!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103654,'And so the Heart of Zin-Azshari called the storms, and with a thunderous answer the storms brought the queen\'s grace upon the world.','',0,0,0,0,0,0,0,2,0,0,0,0,26124),
(103655,'Hear me, storms. Grant this blade your power!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103656,'It\'s... beautiful.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103657,'Let\'s not stick around to find out if more demons are coming our way. Our gryphons are waitin\' for us at the landing to take us to Dalaran.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103658,'The Inquisition... will prevail!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103659,'You were fools to come here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103660,'The High Inquisitor will be pleased! Herald, you may dispose of the trash!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103661,'','Yeah! This is gonna be awesome! I better go tell Pop.',0,0,0,0,0,0,0,0,0,0,0,61992,26124),
(103662,'The trapper stuns the player, then captures Vereesa in a cage and runs off with her.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103663,'','Save yourself! Don\'t come after me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103664,'I have been watching your exploits, and I think you the right hero for the job!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103665,'','We\'ll get you out of here, Orestes. Any sign of Alleria?',1,1,0,0,1,0,6,0,0,0,0,61845,26124),
(103666,'$n consumes the power of a Honored Ancestor.','$n was consumed by Hunger for Life.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103667,'Rats make good friend. Unless rat bites, then rat makes good meal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103668,'','Master $n, if I could get your attention for a moment!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103669,'','Excellent, you can take the portal to Dalaran Crater and just fly north. He will be expecting you soon!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103670,'','Come. Let\'s find Alleria and finish this.',6,0,0,0,0,0,0,0,0,0,0,61819,26124),
(103671,'','We\'ll be careful. Did you find any sign of Alleria?',1,603,0,0,0,0,0,0,0,0,0,0,26124),
(103672,'','Rest in the Light, Orestes.',1,0,0,0,0,0,1,0,0,0,0,61849,26124),
(103673,'Intruder alert!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103674,'Druids! I sense you in the waking world.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103675,'My lair is under attack within the Dream. I need your aid, now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103676,'','I have recquisitioned a hippogryph for you if you desire, or you can make your own way to the site. If you have more question I can attempt to fill in the blanks for you.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103677,'','TEMP - Talk options for\n- What is the Blade?\n- What is this new leader of Twilight\'s Hammer?\n- Why is Moira doing this?\n- What\'s so special about Tirisfal?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103678,'lol tell me','lol tell me',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103679,'Okay, okay! I give up. I\'ll go hunt somewhere else.','Okay, okay! I give up. I\'ll go hunt somewhere else.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103680,'Fine, you win! I\'ll find a better place to hunt.','Fine, you win! I\'ll find a better place to hunt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103681,'The last time I was here, I left behind a few... safety measures. There are countless secrets within these walls, and many who would stop at nothing to learn them.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103682,'The sentry! Look out!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103683,'The wards! More sentries are coming after us. Fortunately, I always keep a few tricks up my sleeve.','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(103684,'Over here! Is this the relic you seek?','',0,0,0,0,0,0,22,0,0,0,60285,0,26124),
(103685,'Vile beasts of the Nightmare! You will never take my claws!','',0,0,0,0,0,0,0,0,0,0,62279,0,26124),
(103686,'Worthy you may be, but if you would wield my claws to defend this world, you must make haste to retrieve them. Even now, I sense more of the enemy approaching!','',0,0,0,0,0,0,0,0,0,0,62284,0,26124),
(103687,'','Oh dear! More invaders are coming!',0,0,0,0,0,0,0,0,0,0,0,62294,26124),
(103688,'These are dark times, $n. I\'m glad you\'re here.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(103689,'How do I get to Light\'s Hope Chapel?','How do I get to Light\'s Hope Chapel?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(103690,'The Kirin Tor have established a portal in a chamber beneath the city to Dalaran\'s former home in the Hillsbrad Foothills - Light\'s Hope is a short ride from there.$B$BThere are teleportation pads in Runeweaver Square that will take you to the chamber. I have marked one on your map.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103691,'|TInterface\\Icons\\ability_demonhunter_felrush:20|tIllysanna Ravencrest prepares to |cFFFF0000|Hspell:197484|h[Dark Rush]|h|r towards you!','|TInterface\\Icons\\ability_demonhunter_felrush:20|tIllysanna Ravencrest prepares to |cFFFF0000|Hspell:197484|h[Dark Rush]|h|r towards you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103692,'|TInterface\\Icons\\ability_bosskilrogg_deadeye:20|tIllysanna Ravencrest\'s |cFFFF0000|Hspell:197674|h[Eye Beams]|h|r begin tracking you!','|TInterface\\Icons\\ability_bosskilrogg_deadeye:20|tIllysanna Ravencrest\'s |cFFFF0000|Hspell:197674|h[Eye Beams]|h|r begin tracking you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103693,'|TInterface\\Icons\\spell_fire_felfirenova:20|t%s begins to cast |cFFFF0000|Hspell:199828|h[Chaos Nova]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103694,'I grant you my blessing, $n. With it, all others will know you are my chosen champion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103695,'Warn the others. Now, WAKE UP!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103696,'Hmm, it appears my safeguards may have been altered. Keep an eye out while I open the way.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103698,'|TInterface\\Icons\\spell_warlock_demonsoul:20|tYou are afflicted by  |cFFFF0000|Hspell:194960|h[Soul Echoes]|h|r !','|TInterface\\Icons\\spell_warlock_demonsoul:20|tYou are afflicted by  |cFFFF0000|Hspell:194960|h[Soul Echoes]|h|r !',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103699,'','Oh my stars! I just can\'t stand violence! I hope this ends quickly.',0,0,0,0,0,0,0,0,0,0,0,62293,26124),
(103700,'','%s faints and falls onto the ground.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103701,'%s falls to the ground!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103702,'','Be on your guard, friend. There have been demon sightings in the area.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103703,'The furbolgs have been acting strange lately...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103704,'','Help! These big meanies won\'t leave me alone!',0,0,0,0,0,0,0,0,0,0,0,62303,26124),
(103705,'','Get away from me you big, stupid... stupid head!',0,0,0,0,0,0,0,0,0,0,0,62304,26124),
(103707,'','I will heal you, guardian!',0,0,0,0,0,0,0,0,0,0,0,62274,26124),
(103708,'','Stand within my healing circle, guardian, and be restored.',0,0,0,0,0,0,0,0,0,0,0,62273,26124),
(103709,'','Gee, this is going to hurt. I\'m so sorry!',0,0,0,0,0,0,0,0,0,0,0,62277,26124),
(103711,'','Ow! Ow! Owww! I really need a moment to rest.',0,0,0,0,0,0,0,0,0,0,0,62275,26124),
(103712,'','I\'ll be fine. Just give me a moment to rest.',0,0,0,0,0,0,0,0,0,0,0,62276,26124),
(103714,'These foes are weak, but fight in numbers. In life, I paid the price for underestimating my enemy. Never again!','',0,0,0,0,0,0,0,0,0,0,62285,0,26124),
(103715,'Creatures of the wild, heed my call! Come to our aid!','',0,0,0,0,0,0,0,0,0,0,62286,0,26124),
(103716,'Protect our healers and casters, guardian. We must not let our allies fall!','',0,0,0,0,0,0,0,0,0,0,62287,0,26124),
(103717,'Keep it up, defenders! We will never yield to these invaders!','',0,0,0,0,0,0,0,0,0,0,62288,0,26124),
(103718,'Their blood will burn the very ground where they fall. Don\'t let them touch our defenders!','',0,0,0,0,0,0,0,0,0,0,62289,0,26124),
(103719,'Control the enemies. You can determine where they fall!','',0,0,0,0,0,0,0,0,0,0,62290,0,26124),
(103720,'Beware! The Nightmare\'s corruption has spread to the trees!','',0,0,0,0,0,0,0,0,0,0,62291,0,26124),
(103721,'The heart of the bear never falters! Hold the line, hero!','',0,0,0,0,0,0,0,0,0,0,62292,0,26124),
(103722,'The Emerald Dream is a paradise, a hope of the world that could be. I will not let it be destroyed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103723,'Those casters cannot be left alone! We must deal with them quickly!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103724,'Those healers will make things more difficult. We should try and defeat them first!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103725,'Hold, guardian. I feel a chill deep in my spirit.','',0,0,0,0,0,0,0,0,0,0,62295,0,26124),
(103726,'Foolish bear! You\'ve fallen for my trap!','',0,0,0,0,0,0,0,0,0,0,62296,0,26124),
(103727,'What is this sorcery!? When I get free, I\'ll tear out your foul throat, Xavius!','',0,0,0,0,0,0,0,0,0,0,62297,0,26124),
(103728,'No, Ursoc. When next you bare your fangs, it will be at my command!','',0,0,0,0,0,0,0,0,0,0,62298,0,26124),
(103729,'No!','',0,0,0,0,0,0,0,0,0,0,62280,0,26124),
(103730,'You\'ll never reach Xalethar alive!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103732,'I will resist you to my last breath, usurper! I will never submit to one such as you!','',0,0,0,0,0,0,0,0,0,0,62299,0,26124),
(103733,'I am LORD of the Nightmare! I have been shaped by the powers of the Old Gods. Tremble before me!','',0,0,0,0,0,0,0,0,0,0,62301,0,26124),
(103734,'Aaarrghhh ArrrghhhhH!','',0,0,0,0,0,0,0,0,0,0,62302,0,26124),
(103735,'Hero! Xavius is right.... his strength is... unbreakable. I cannot hold him forever.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103737,'You should have turned back when you had the chance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103738,'You\'ve arrived just in time. I was growing tired of these mangy beasts!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103739,'Xavius will avenge me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103740,'How was the flight in? Seems we moved Dalaran from one dark, gloomy land to another.$b$bAt least it\'s warmer here. And I must admit, being so close to Karazhan brings back many memories.','',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(103741,'How can I help, Archmage?','How can I help, Archmage?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103742,'Get that book into Modera\'s hands in Dalaran. I\'ll join you soon. And... thank you.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103743,'The sixth is here. Let us begin.','',0,0,0,0,0,0,1,0,0,0,63920,0,26124),
(103744,'Zelifrax will lead us in the ritual. You have studied the rites, gnome?','',0,0,0,0,0,0,1,0,0,0,63921,0,26124),
(103745,'Yeah, yeah. Don\'t worry about me, hothead! I know what needs to be done.','',0,0,0,0,0,0,1,0,0,0,63922,0,26124),
(103746,'Akris nor-menoth!','',0,0,0,0,0,0,0,0,0,0,63923,0,26124),
(103747,'I need everyone to channel on the portal. This ritual requires our unwavering concentration!','',0,0,0,0,0,0,1,0,0,0,63924,0,26124),
(103748,'','It\'s not our concentration that should concern you. Let us hope our newest addition can keep up.',0,0,0,0,0,0,1,0,0,0,0,63925,26124),
(103749,'','What are you waiting for, new blood? Begin!',0,0,0,0,0,0,6,0,0,0,0,63926,26124),
(103750,'Your power is impressive, warlock. The ritual begins!','',0,0,0,0,0,0,1,0,0,0,63927,0,26124),
(103751,'','Be prepared! We\'re reaching deeper into the Nether than ever before. Who knows what we may find!',0,0,0,0,0,0,0,0,0,0,0,63929,26124),
(103752,'Gal nortalesh da val...','',0,0,0,0,0,0,0,0,0,0,63930,0,26124),
(103753,'Keep focused... I sense a being of great power on the other side...','',0,0,0,0,0,0,0,0,0,0,63931,0,26124),
(103754,'Zor-arik var... um... telosh?','',0,0,0,0,0,0,0,0,0,0,63932,0,26124),
(103755,'Zelifrax!','',0,0,0,0,0,0,0,0,0,0,63933,0,26124),
(103756,'Uh... or was it teloth? I\'m always mixing those up!','',0,0,0,0,0,0,0,0,0,0,63934,0,26124),
(103757,'','No! The portal!',0,0,0,0,0,0,5,0,0,0,0,63935,26124),
(103758,'Who dares summon me?!','',0,0,0,0,0,0,0,0,0,0,63936,0,26124),
(103759,'It is I, Zelifrax Wobblepox! You will serve me, demon!','',0,0,0,0,0,0,5,0,0,0,63937,0,26124),
(103760,'Trifling gnome! I think not!','',0,0,0,0,0,0,0,0,0,0,63938,0,26124),
(103761,'Aieeeeee!','',0,0,0,0,0,0,0,0,0,0,63939,0,26124),
(103762,'Foolish mortals! You think yourselves worthy to enslave the mighty Jagganoth?','',0,0,0,0,0,0,1,0,0,0,63940,0,26124),
(103763,'It is you who will be made to serve!','',0,0,0,0,0,0,25,0,0,0,63941,0,26124),
(103764,'Kirest-alak yrthog norush...','',0,0,0,0,0,0,0,0,0,0,63928,0,26124),
(103765,'Take the tome, $n. The information it holds is vital!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103766,'The Legion\'s attacks will only intensify. We must do whatever is necessary to bolster our strength.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103767,'If we\'re going to make it through this, we must bring the Kirin Tor to full strength.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103768,'Old prejudices must be set aside for the greater good of Azeroth.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103769,'I propose we invite the Horde back into the Kirin Tor. You may not like this idea. Some of my colleagues certainly won\'t.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103770,'Please trust my judgment. A world at war with itself cannot stand against the Legion for long.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103771,'The Council is already assembled. Let\'s not keep them waiting.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103772,'I will propose that we invite the Horde back into the Kirin Tor. To certain colleagues on the Council, this will be... controversial.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103773,'Your presence is a testimony to the valor of the Horde. To some... that may not be enough.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103774,'Some kind of abomination. Watch yourselves! Do not hesitate!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(103775,'You\'ll have to subdue the guardians before my calibration can take effect. No need to be gentle!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103776,'The magic of your weapon runs deep. Its power will grow with you.','',0,0,0,0,0,0,0,0,0,0,62252,0,26124),
(103777,'$n, I place you in charge of the grove\'s efforts here. I must travel to the south and seek out Cenarius. Only with his aid will we stop the Legion.','',0,0,0,0,0,0,0,0,0,0,62305,0,26124),
(103778,'You survived the summoners... such determination! A pity you won\'t live to experience our glorious cathedral!','',0,0,0,0,0,0,0,0,0,0,61802,0,26124),
(103780,'','Val\'sharah has the most beautiful flowers. Do you enjoy picking flowers too?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(103781,'|TINTERFACE\\ICONS\\trade_archaeology_vrykul_runestick:20|t Odyn marks all enemies with a |cFFFF0404|Hspell:197961|h[Runic Brand]|h|r!','|TInterface\\Icons\\Spell_Holy_DivineProvidence:20|t $n is afflicted with |cFFFF0404|Hspell:192067|h[Expel Light]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103782,'If we\'re to have any hope of holding back the Legion, I need to get the sentries back on our side.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103783,'This book holds a spell that will take you to the library. Get going! And be ready for anything!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103784,'Thank you all for gathering on such short notice.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103785,'','Khadgar, we don\'t have time to waste in meetings. The Legion is advancing and the Horde arms for battle.',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(103786,'My friends, we\'ve all seen the battle reports. The Legion is laying siege to every kingdom in Azeroth.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103787,'That much is obvious, Khadgar.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103788,'Precisely the two points I wish to address. The demons are evolving their methods. To beat them, the Kirin Tor must do the same.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103789,'','What are you proposing?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(103790,'Then I\'ll get right to the point. For the Kirin Tor to fight at full strength, we need the mages of the Horde to join our ranks.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103791,'','NEVER! Do you hear me, Khadgar?',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(103792,'Jaina, we know the pain you\'ve endured. But this is about--','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(103793,'I\'ve made my case. With respect, I move for a vote.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103794,'','They obliterated Theramore. They left us to die on the Broken Shore. Again and again they\'ve proven to be monsters... cowards!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(103795,'A vote has been called. Shall we proceed?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(103796,'','Very well. But consider your choice carefully. If you let those vermin back into this city, I will not be counted among your ranks when you welcome them.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103797,'In the matter of allowing the Horde into Dalaran and offering membership in the Kirin Tor, I vote aye.','',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(103798,'Aye.','',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(103799,'Aye.','',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(103800,'','Nay.',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(103801,'Nay.','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(103802,'Me... sage... for yoooou!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103803,'','Aye.',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(103804,'The vote carries. I\'m sorry, Jaina, but the stakes are higher than they\'ve ever been.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103805,'','Modera! Vargoth! How could you?',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(103806,'Me... go...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103807,'','Jaina, please... we are doing what\'s best for Azeroth. Stand with us!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103808,'','This Council is blind to the truth. When the Horde betrays you again, remember who warned you. Farewell.',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(103809,'That was... difficult. But we must move forward. We will send our invitation to the Warchief at once. We have a war to win.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103810,'UNCROSS THE WIRES TO SAVE MY DIGITAL LIFE','UNCROSS THE WIRES TO SAVE MY DIGITAL LIFE',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(103811,'But, not so fast, $n. I have another request of you.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103812,'GREETINGS, CREATOR','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103813,'It is done. Latara, my love. I will continue to fight for you. For us.','',0,0,0,0,0,0,0,0,0,0,65624,0,26124),
(103814,'I was tired of this disguise anyway!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103815,'Apply a new module.','Apply a new module.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103816,'Activate Repair Mode.','Activate Repair Mode.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103817,'Activate Failure Detection Mode.','Activate Failure Detection Mode.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103818,'Activate Fireworks Mode.','Activate Fireworks Mode.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103819,'Activate Snack Distribution Mode.','Activate Snack Distribution Mode.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103820,'Activate Bling Mode.','Activate Bling Mode.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103821,'Activate Piloted Combat Mode.','Activate Piloted Combat Mode.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103822,'We did not start this war, but we will end it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103823,'I\'ve changed my mind. Let me pick a different artifact.','I\'ve changed my mind. Let me pick a different artifact.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103824,'Activate Thermal Anvil Mode.','Activate Thermal Anvil Mode.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103825,'Activate Wormhole Generation Mode.','Activate Wormhole Generation Mode.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103826,'Install module for Repair Mode.','Install module for Repair Mode.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103827,'Install module for Failure Detection Mode.','Install module for Failure Detection Mode.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103828,'Install module for Fireworks Mode.','Install module for Fireworks Mode.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103829,'Install module for Snack Distribution Mode.','Install module for Snack Distribution Mode.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103830,'Install module for Bling Mode.','Install module for Bling Mode.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103831,'Install module for Piloted Combat Mode.','Install module for Piloted Combat Mode.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103832,'Install module for Thermal Anvil Mode.','Install module for Thermal Anvil Mode.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103833,'Install module for Wormhole Generation Mode.','Install module for Wormhole Generation Mode.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103834,'That was a strange sensation...','Oh my... that tickled!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(103835,'If there was a demon in Lorlathil, I\'d know.','What a strange sensation... where can I get one of those?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103836,'The Deacon has started the ritual! He is not to be disturbed!','The Deacon has started the ritual! He is not to be disturbed!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(103837,'You believe yourselves worthy to enter the cathedral? Then come forth and be tested!','',0,0,0,0,0,0,0,0,0,0,61840,0,26124),
(103838,'You may have the honor of meeting the High Inquisitor... if you get past me!','',0,0,0,0,0,0,0,0,0,0,61816,0,26124),
(103840,'Adding mini event here: defeat hounds first, then mistress.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103841,'This could be uncomfortable. Are you ready, $n?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103842,'Address the Council, Khadgar.','Address the Council, Khadgar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103843,'Master Slaghammer! We have an intruder!','Master Slaghammer! We have an intruder!',0,0,0,0,0,0,0,0,4,0,63432,0,26124),
(103844,'Excellent! I was expecting \'im, but I don\'t think you were...','',0,0,0,0,0,0,0,0,0,0,63433,0,26124),
(103845,'What?! You traitor!','What?! You traitor!',0,0,0,0,0,0,0,0,0,0,63434,0,26124),
(103846,'I just felt a tingle in my... nevermind.','What just happened?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103847,'Do you always greet people this way?','At least get to know me first...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103848,'You thought I was a demon?','This may be the first time I\'ve ever been mistaken for a demon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103849,'A demon in Lorlathil? Nonsense.','Oh my, I think I\'m going to like you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103850,'You must be mistaken, friend.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(103851,'So... the little warlock returns.','',0,0,0,0,0,0,1,0,0,0,63847,0,26124),
(103852,'You\'re too late to save your friends. They have the honor of amusing my lord, Mephistroth.','',0,0,0,0,0,0,1,0,0,0,63848,0,26124),
(103853,'He will be pleased to receive yet another gift, and I will happily deliver you to him.','',0,0,0,0,0,0,1,0,0,0,63849,0,26124),
(103854,'Come, warlock! You will be broken!','',0,0,0,0,0,0,15,0,0,0,63850,0,26124),
(103855,'This power you wield... it\'s not possible!','',0,0,0,0,0,0,0,0,0,0,63851,0,26124),
(103856,'This... cannot be!','',0,0,0,0,0,0,0,0,0,0,63852,0,26124),
(103857,'Jagganoth is slain! Now take his heart. You will be lord of the Dreadscar!','',0,0,0,0,0,0,0,0,0,0,63854,0,26124),
(103858,'So, mortal, you have slain one of my generals...','',0,0,0,0,0,0,1,0,0,0,63856,0,26124),
(103859,'Savor your victory while you can, warlock. This war is far from over!','',0,0,0,0,0,0,1,0,0,0,63857,0,26124),
(103860,'We will meet again...','',0,0,0,0,0,0,0,0,0,0,63858,0,26124),
(103861,'Mephistroth will... take you...','',0,0,0,0,0,0,0,0,0,0,63853,0,26124),
(103862,'Archmage Khadgar is waiting for you in Dalaran. Take the portal when you\'re ready.','Archmage Khadgar is waiting for you in Dalaran. Take the portal when you\'re ready.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(103863,'Archmage Khadgar is waiting for you in Dalaran. Take the portal when you\'re ready.','Archmage Khadgar is waiting for you in Dalaran. Take the portal when you\'re ready.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(103864,'Begone from here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103865,'This ward will not tolerate your presence!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103866,'You are not worthy of being here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103867,'I banish you to the mist!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103868,'Friend, the Dreadscar have come to serve at your command!','',0,0,0,0,0,0,0,0,0,0,63859,0,26124),
(103869,'We await your command, Overlord.','',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(103871,'Here, take these designs. I came up with them myself.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103872,'','Hey there $n! I knew you would have no problem passing through the Emerald Dreamway.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103873,'','Ursoc\'s Den is just up ahead. He roamed the wilds while the world was still young, and returned here to rest and train.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103874,'','Thousands of years ago, the great proto-dragon, Galakrond, tried to encroach on these forests. Ursoc fought him and where they fell, they created these valleys, and where their claws struck the earth, they forged mountains. Eventually, Ursoc drove the dragon away, to the west.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103875,'','After his death, we placed the Claws in the Emerald Dream for safekeeping.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103876,'','Our druids guard the claws now in his lair within the Emerald Dream. It is there we shall go now, to retrieve them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103877,'','Place your hand upon the altar and sleep.',0,0,0,0,0,0,0,0,0,0,0,69736,26124),
(103878,'Well this is hardly fair.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103879,'Baaaaaaaa.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103880,'You will die for this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103881,'If only I had the use of my arms...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103882,'Bring the heart to the altar! This way!','',0,0,0,0,0,0,0,0,0,0,63855,0,26124),
(103886,'[PH] Insert awesome flyover showing your new demon digs and transitioning to the real order hall','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103887,'You mortals have endured so much to rescue your precious Alleria. Come forth and reap your reward!','',0,0,0,0,0,0,0,0,0,0,61803,0,26124),
(103892,'$n! You must come quickly! Saurfang has been looking for you!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103893,'What is this interruption? Syphonus, deal with these mortals. No witnesses.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103894,'You must not interfere with our work, mortal!','You must not interfere with our work, mortal!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103895,'The portal must be maintained!','The portal must be maintained!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103896,'You trifle with forces you do not understand!','You trifle with forces you do not understand!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103897,'The Inquisition\'s work will not be disturbed!','The Inquisition\'s sacred work must not be disturbed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103898,'Blood and Honor!','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(103905,'','Please leave your weapons with me, $ct.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103907,'|TInterface\\Icons\\spell_shadow_shadowward:20|t%s begins to cast |cFFFF0000|Hspell:200002|h[Blur of Shadows]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103908,'No! Mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103909,'Fool! You will suffer for your trespass!','',0,0,0,0,0,0,0,0,0,0,61909,0,26124),
(103910,'Turn away now, interloper! The horrors of the past will be your undoing!','',0,0,0,0,0,0,0,0,0,0,61910,0,26124),
(103911,'I think that means we\'re on the right track. See what you can find in that journal.','',0,0,0,0,0,0,0,0,0,0,61911,0,26124),
(103912,'$n, you never fail to surprise me.','',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(103913,'%s shakes his head.','',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(103915,'Another Windrunner for my collection! Oh, the secrets you will confess to me!','',0,0,0,0,0,0,0,0,0,0,61804,0,26124),
(103917,'','Forget about me! Save Alleria!',0,0,0,0,0,0,0,0,0,0,0,61806,26124),
(103918,'You refuse to surrender! How splendid! We did not anticipate the high elf would bring along so... persistent an ally.','',0,0,0,0,0,0,0,0,0,0,61807,0,26124),
(103919,'This Vereesa should prove useful... until she breaks. You, however... well, every mortal life must end.','',0,0,0,0,0,0,0,0,0,0,61805,0,26124),
(103920,'$n, I present you with a gift from Lord Illidan himself.','',0,0,0,0,0,0,0,0,4,0,55617,0,26124),
(103921,'','Free, but... fel magic.. still afflicting me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103922,'','You must... kill the Inquisitor... claim Alleria\'s bow!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103923,'Jabrul will get to Dalaran somehow.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103924,'I\'m going to crate you up now, Jabrul.','I\'m going to crate you up now, Jabrul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103927,'Dalaran is situated above the largest repository of arcane knowledge on Azeroth. You can guess this is not by mistake.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103928,'I\'ll need your help in there. It feels a lot like going home, but for the occasional brushes with death that are surely in store.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103929,'Meet me at the front gate when you\'re ready, $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103930,'It\'s a tight fit, but Jabrul should be fine.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103931,'Mail Jabrul.','Mail Jabrul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103932,'No! Wait! Jabrul changed his mind!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103934,'Hello? $n, are you there?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103935,'Break open the crate.','Break open the crate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103936,'OH! That feels SO much better.','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(103937,'The mist dissipates, revealing %s in the trap!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103938,'So this is Dalaran? Jabrul is impressed. This way to the jewelcrafting masters?','',0,0,0,0,0,0,589,0,0,0,0,0,26124),
(103939,'That is far enough.','',0,0,0,0,0,0,0,0,0,0,67418,0,26124),
(103940,'Well, you are not from the palace... and you are no demon, at least not entirely.','',0,0,0,0,0,0,274,0,0,0,67419,0,26124),
(103943,'Identify yourself, before I teleport you to the depths of the Great Sea.','',0,0,0,0,0,0,25,0,0,0,67420,0,26124),
(103946,'Good job with that ooze.  To stay alive on the battle field moving around will be critical.  However using your legs is so mundane. You\'re a mage, are you not?  It\'s time to learn how to blink!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103947,'Blink will allow you to teleport a short distance to avoid danger or close the distance to an enemy, try using it now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103949,'What is this? A coin...','',0,0,0,0,0,0,0,0,0,0,67421,0,26124),
(103950,'The sign of the dusk lily... This is the First Arcanist\'s seal! Is she alive?!','',0,0,0,0,0,0,1,0,0,0,67422,0,26124),
(103951,'Right. The trap.','',0,0,0,0,0,0,1,0,0,0,67424,0,26124),
(103952,'Fun, isn\'t it? Moving is only half the equation though, what if you could freeze your enemies in place, prevent them from even reaching you?  As a mage, you can do just that.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103953,'Frost nova will freeze any nearby enemies in place allowing you to blink away and destroy them in safety.  For now, let\'s just practice freezing them in place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103954,'','Forget about me... save the bow... save Thas\'dorah!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103956,'','$n, I thought I asked you to tell your friend to STOP sending those letters of his?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103957,'','WHOA! That guy is huge!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(103958,'Hello!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103959,'$n, I believe there is something very powerful in this cave. But, because of the immense fel energy that permeates Mardum, I cannot be certain. My vision is clouded.\n\nIf there is something in there, we can\'t afford to ignore it. Your mastery of spectral sight is greater than any, save Lord Illidan.\n\nWill you turn your spectral sight on the cave and confirm my suspicions?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103960,'Yes, Jace, I will use my spectral sight to look into the cave.','Yes, Jace, I will use my spectral sight to look into the cave.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103961,'','So, the famed $c from the Broken Shore has returned.$b$bYour deeds have earned you leniency from my bow, but do not press me. As you can imagine, there is much I must address now that I am Warchief.$b$bWe will speak later. You can wait.',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(103962,'For blood and honor, Warchief!','For blood and honor, Warchief!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103964,'','WHAT THE HELL IS THAT THING?!?!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(103965,'Ladies, ladies, calm down. I think this is that jewelcrafting master that $n has been working with.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103966,'I did warn you. Tel\'vasha!','',0,0,0,0,0,0,0,0,0,0,67426,0,26124),
(103967,'N\'eth ana!','',0,0,0,0,0,0,0,0,0,0,67425,0,26124),
(103968,'The Blackroot Squirrel chirps in appreciation.','The Blackroot Squirrel chirps in appreciation.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103969,'Then there is still a chance... Come quickly! I need your help.','',0,0,0,0,0,0,1,0,0,0,67423,0,26124),
(103970,'The teleporter is just outside. Activate it first, then step on the pad.','',0,0,0,0,0,0,0,0,0,0,67484,0,26124),
(103971,'The Calm Moonkin hoots at you in appreciation.','The Calm Moonkin hoots at you in appreciation.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103972,'All of the teleporters work the same way. Use them to find that equipment!','',0,0,0,0,0,0,0,0,0,0,67485,0,26124),
(103973,'Strange, you should have been recalled by now. Whatever you just did, it bought you more time.','',0,0,0,0,0,0,0,0,0,0,67488,0,26124),
(103974,'If King Varian couldn\'t stop the Legion, how can anyone?','If King Varian couldn\'t stop the Legion, how can anyone?',0,0,0,0,0,0,430,0,0,0,0,0,26124),
(103975,'He was such a noble king...','He was such a noble king...',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(103976,'Things won\'t ever be the same again...','Things won\'t ever be the same again...',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(103977,'The tower\'s defenses have been compromised! I sense the tendrils of Medivh\'s magic thwarting my safeguards!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103982,'I no stop candle making! ...Unless you want story?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103983,'Reactivate the sentries once I finish their adjustments. I\'ll reinforce the door and send the guardians against the Legion. That will buy us time to find what we\'re after.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(103986,'Rats good diggers. Or good dinner if not.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103987,'Rats not afraid of darkness.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103988,'Rats tastier than rabbit, and easier to catch.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103989,'Harpies like shinies.\n\nWe trade treasures for wax.\n\nBuild biggest candle ever!','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(103990,'Very busy. Always jobs to do!\n\nSmart workers catch rats. Smartest workers light candles.\n\nOthers... dig.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(103991,'I want story.','I want story.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103992,'Something is wrong... I have lost your position...','',0,0,0,0,0,0,0,0,0,0,67486,0,26124),
(103993,'Wherever you are, it is unstable. The telemancy will not hold long.','',0,0,0,0,0,0,0,0,0,0,67487,0,26124),
(103994,'A curious discovery, but you will not find the equipment we need in there.','',0,0,0,0,0,0,0,0,0,0,67489,0,26124),
(103995,'Kobolds live here long time. Make home in nooks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103996,'Catch rats. Sometimes eat them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103997,'Dig for treasure. Trade with harpies.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103998,'They like shinies, we like wax. Fresh from ears is best.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(103999,'One day drogbar come in. Say cave is theirs.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104000,'They smash and scare. We take candles and hide.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104001,'Drogbar big and stupid. They have cave, but no have candle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104002,'Darkness finds them. Darkness follows them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104003,'Darkness swallows them whole!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104004,'We come back. We have candles.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104005,'Cave ours again. Candles keep us safe.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104006,'Kipp Brightwick takes a deep breath.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104007,'The knowledge of the Pillars is here! We must find that tome!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(104008,'Sargeras knows we\'re after the location of the Pillars! I\'ll need your help to bring down this barrier.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104009,'','These illusions use stealth! A flare could reveal them!',0,0,0,0,0,0,0,0,0,0,0,62670,26124),
(104010,'','Their stealth is maddening! Someone drop a flare!',0,0,0,0,0,0,0,0,0,0,0,62671,26124),
(104011,'Wake up! Boss is here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104012,'Not asleep. Just resting eyes...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104013,'Violet is my favorite rat.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104014,'The Legion! I\'ll do what I can to block their way.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(104015,'No! Violet!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104016,'Penny is the prettiest rat.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104017,'You\'ll pay for hurting Penny!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104018,'I won\'t forget you Blue!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104019,'You hurt Ollie. I hurt you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104020,'Chewie was my only friend!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104021,'I\'ll catch another rat after I kill you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104022,'The construct begins to act sluggish. Return to the Collapsed Ruins before it powers down!','The construct begins to act sluggish. Return to the Collapsed Ruins before it powers down!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104023,'Be wary, friend. There are demons in our midst...','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(104024,'I have been sent by the Illidari to slay the demon Kazok\'thul.','I have been sent by the Illidari to slay the demon Kazok\'thul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104025,'We tracked the demon to this cavern, but the beast caught us by surprise. Some of my best warriors were killed in the battle and Kazok\'thul got away.$b$bIf you wish to draw the demon into the open, you may be able to lure it out by activating the mana beacon inside the cave.$b$bGood luck.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104026,'','|TInterface\\Icons\\inv_misc_monsterhorn_03.blp:20|t A %s emerges!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104027,'I\'m not hurt. I\'m... I\'m stalking a bear!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104028,'Oh, I believe you. Let me just bind that wound anyway.','Oh, I believe you. Let me just bind that wound anyway.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104029,'Wounded, Fenryr retreats to his den.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104030,'No no no.  You need to freeze the spark in place.  Let\'s try this again. Use Frost Nova to freeze it in place and Blink to get away.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104031,'<On the other side of the portal, you can faintly see Grizzly Hills.>','<On the other side of the portal, you can faintly see Grizzly Hills.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104032,'Blue is best friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104033,'Go to Grizzly Hills.','Go to Grizzly Hills.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104034,'I could never eat Ollie.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104035,'|TInterface\\Icons\\Spell_Holy_DivineProvidence:20|t $n is affected with |cFFFF0404|Hspell:192048|h[Expel Light]|h|r!','|TInterface\\Icons\\Spell_Holy_DivineProvidence:20|t $n is affected with |cFFFF0404|Hspell:192048|h[Expel Light]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104036,'Chewie bites me sometimes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104037,'Gnawer has sharpest teeth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104038,'|TInterface\\Icons\\spell_hunter_lonewolf:20|t Fenryr begins to cast |cFFFF0404|Hspell:196543|h[Unnerving Howl]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104040,'Thanks. Uh... Please don\'t let Mom know that I hurt myself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104041,'You\'re almost as good as Kalla.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104042,'Welcome to the training grounds.$b$bHere we learn to discipline the mind and the body.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104043,'Strange. It should not have sent you there! Hang on, I am recalling you.','',0,0,0,0,0,0,0,0,0,0,67490,0,26124),
(104044,'Someone else is tampering with the network... Telemancy is a delicate art, there is no room for amateurs!','',0,0,0,0,0,0,0,0,0,0,67491,0,26124),
(104045,'Good work. Bring them back to me at the workshop!','',0,0,0,0,0,0,0,0,0,0,67492,0,26124),
(104046,'Between the barnyard odor of Kalla and the rotting stench of our cook, I think I simply might pass out.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104047,'Picking','Picking',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104048,'The weapons of the storm await us, $n!','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(104049,'Let\'s go!','Let\'s go!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104052,'That demon will just open another portal if we don\'t take care of it first. Prepare yourself, $p!','',0,0,0,0,0,0,0,0,0,0,62059,0,26124),
(104053,'Our champion arrives! We have been sent by Tyrande bearing a weapon that may turn the tide of this war.','',0,0,0,0,0,0,5,0,0,0,61864,0,26124),
(104054,'You must take up the Scythe of Elune, champion. May its power serve you well.','',0,0,0,0,0,0,0,0,0,0,61865,0,26124),
(104055,'The scythe belongs to Karazhan, worm!','',0,0,0,0,0,0,0,0,0,0,61866,0,26124),
(104056,'','Valorn, no!',0,0,0,0,0,0,5,0,0,0,0,61867,26124),
(104057,'I\'ve seen enough suffering for a lifetime, $n. I don\'t need another funeral. I need to bring justice to the enemies of Gilneas!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104058,'','He has the scythe! After him!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(104059,'','He\'s gone...',0,0,0,0,0,0,0,0,0,0,0,61869,26124),
(104066,'','Don\'t get so close. Your scent will give me away.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104067,'Did Kalla send you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104068,'I think your stench far overpowers mine. Now let me help you.','I think your stench far overpowers mine. Now let me help you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104069,'Impressive. You are quickly mastering your abilities. That was just one creature though, what happens when you have to fight many at the same time?  For this, you will need to master Flame Strike.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104070,'Flame Strike is a slow spell that does a tremendous amount of damage to everything in an area.  Use Flamestrike to quickly dispatch this group of oozes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104071,'I will keep this between us. Now be still while I patch you up.','I will keep this between us. Now be still while I patch you up.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104072,'','We\'re past the wards, but what\'s going on here? Could the Nightmare have spread to Ursoc\'s Lair?',0,0,0,0,0,0,0,0,0,0,0,62126,26124),
(104073,'','By the Dark Lady.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104074,'','I don\'t think I was a hunter in my past life.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104075,'I don\'t think I am cut out to be a hunter.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104076,'I hope Tony has something edible back at camp.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104077,'I\'m going to pretend I didn\'t see that, Outlander.','I\'m going to pretend I didn\'t see that, Outlander.',0,0,0,0,0,0,0,0,0,37446,0,0,26124),
(104078,'What do you think you are doing?','What do you think you are doing?',0,0,0,0,0,0,0,0,0,37446,0,0,26124),
(104079,'','Let\'s get going!',0,0,0,0,0,0,0,0,0,0,0,62127,26124),
(104080,'Leave that alone!','Leave that alone!',0,0,0,0,0,0,0,0,0,37446,0,0,26124),
(104081,'What are you doing?','What are you doing?',0,0,0,0,0,0,0,0,0,37446,0,0,26124),
(104082,'That is not yours. Rude.','That is not yours. Rude.',0,0,0,0,0,0,0,0,0,37446,0,0,26124),
(104083,'Summoners, open a portal! We need reinforcements!','',0,0,0,0,0,0,0,0,0,0,61795,0,26124),
(104088,'Your flesh will be fed to the hounds!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104089,'Your doom will come... by another\'s hand!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104090,'Welcome to my lands, $r. The little one told me you seek information on the legend of Irmaat.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104091,'You\'ve mastered the fundamentals mage, now it\'s time to learn something more advanced.  Pyroblast is your most powerful spell and it gets even more powerful when you\'re on a Hot Streak.  More Importantly, while on a Hot Streak it will have no cast time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104092,'You gain a Hot Streak by landing two consecutive critical strikes.  Because Inferno Blast will always be a critical strike, start casting Fireball.  When you get your first critical strike use Inferno Blast to get the second, then cast Pyroblast.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104093,'','Oh! Magic!!! Hurry up, let\'s see what it does!',0,0,0,0,0,0,0,0,0,0,0,61993,26124),
(104094,'You\'re on a Hot Streak, cast Pyroblast now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104095,'And that\'s how you do it.  Let\'s practice that a couple more times and then I\'ll give you a real challenge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104096,'Pyroblast takes a long time to cast unless you\'re on a Hot Streak.  Try using Fireball and Inferno Blast to gain a Hot Streak before casting Pyroblast this time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104097,'That\'s your first critical strike, now cast Inferno Blast to get a second.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104098,'My winds shall rip you apart!','',0,0,0,0,0,0,0,0,0,0,61983,0,26124),
(104099,'We are ready to challenge you Odyn!','We are ready to challenge you Odyn!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104100,'Are you ready to face me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104101,'HRK!','Gah...!',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(104103,'Moira said ye\'d be comin\'. I\'m Slaghammer, payin\' me family\'s debt by hangin\' oot wi\' these buggers. Lemme take down this barrier.','',0,0,0,0,0,0,1,0,0,0,63435,0,26124),
(104104,'Th\' Shadow Deacon is already below startin\' his ritual. Ta get there, we\'ll need ta do a bit o\' work. If ye have any questions lemme know, but we best hurry!','',0,0,0,0,0,0,0,0,0,0,63436,0,26124),
(104105,'','We should get back to the Dreamgrove, $n. The Archdruid will know how to unlock the power of the Claws.',0,0,0,0,0,0,0,0,0,0,0,62125,26124),
(104106,'We dinna hae much time, but ye deserve some answers. What ye want to know about? The Shadow Deacon? The Blade? What the hell is going on? Hah!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104107,'This was sort of sudden, where are we? What\'s going on?','This was sort of sudden, where are we? What\'s going on?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104108,'Can ye believe they found the Tomb of Tyr himself?! He died here LONG ago fighting some monstrous general of the Old Gods. His comrades buried him \'ere and the corpse o\' that beast further in.$b$bThis tomb was also meant to guard the prison tomb o\' that monster but the Twilight\'s Hammer put a stop ta that.$b$bThe Shadow Deacon used that blade o\' his ta get in and his minions to keep the wards down while he went below.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104109,'The Hammer has been in disarray since their Twilight Father and Deathwing took a dive. I\'m guessin\' tha when the Legion attacked one o\' the leaders that was left took to the idea of takin\' over while everyone was distracted.$b$bHe dredged up an ancient artifact o\' the Old Gods and is planning on using it on that dead monstrosity down there to cement his takeover o\' the cult.$b$bI dinna get a good look at the Deacon, but he seems really familiar...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104110,'That blade... I knew Moira would want ta know. I think that dagger has been behind some of the worst nightmares Azeroth has seen if I remember me stories. It looks similar ta stories told about the War o\' Three Hammers... and Grim Batol.$b$bIt oozes shadow and seems ta cut the verra light! I think it might have a mind of its own too, it seems the Shadow Deacon is sometimes talkin\' and arguing, but to nobody at all!$b$bWe\'d best stop this ritual and pry that blade loose o\' the cult.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104111,'The Shadow Deacon? Who is this new leader?','The Shadow Deacon? Who is this new leader?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104112,'You mentioned a magical blade, can you tell me more?','You mentioned a magical blade, can you tell me more?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104113,'Threat detected. Pursuing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104114,'Protection mode enabled. Targets identified.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104115,'Defensive calibration complete. Acquiring targets.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104116,'','How convenient! Your little group will make an excellent meal for my hounds!',0,0,0,0,0,0,396,0,0,0,0,61825,26124),
(104117,'','You mortals are always so confident! Come forward, then. My darlings are positively ravenous!',0,0,0,0,0,0,0,0,0,0,0,61827,26124),
(104118,'','Witch! I\'ll gut your beasts and take your head for what you\'ve done!',0,0,0,0,0,0,397,0,0,0,0,61826,26124),
(104119,'What delightful banter! The High Inquisitor will be pleased to host such spirited guests!','',0,0,0,0,0,0,0,0,0,0,61828,0,26124),
(104120,'','All bark... no bite...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104121,'','Hah! Got you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104122,'','Yeah! That\'s the stuff!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104123,'','And down it goes!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104124,'','Don\'t worry about me, I can take care of myself.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104125,'','Let\'s do this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104126,'','Hi there!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104127,'','What\'s up?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104128,'','Uh, got something on your mind?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104129,'','This is bohhhring. Let\'s go do something.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104130,'Excellent!  It\'s one thing to hit a target dummy though.  It\'s time for your final test.  You\'ll need to use everything you\'ve learned.  Defeat my men in combat and prove you\'re ready.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104131,'','I\'ve seen my father angry before, but never like this. He is consumed by his lust for vengeance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104132,'','All Gilneans have a rage inside us, Tess. Your father more than most.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104133,'','Indeed. It\'s sometimes hard to know where the rage ends and the man begins.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104134,'','My father stands with the king. The Forsaken will never see our forces coming!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104135,'','I fear there will soon be more funerals.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104136,'','Such is the cost of vengeance. Gilneas has waited for it long enough.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104137,'','We\'re almost at the keep. Please tell King Anduin he\'s in our thoughts, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104138,'','Quickly, Tess! The gunship will be ready to leave soon!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104139,'','Orestes!',0,0,0,0,0,0,0,0,0,0,0,61839,26124),
(104140,'Our numbers are infinite.','',0,0,0,0,0,0,0,0,0,0,58250,0,26124),
(104141,'Your life is forfeit!','',0,0,0,0,0,0,0,0,0,0,58251,0,26124),
(104142,'You have a Hot Streak, Cast Pyroblast!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104143,'','Ah, Snowfeather delivered my message. Good! We have need of you.',0,0,0,0,0,0,1,0,0,0,0,64290,26124),
(104144,'Good luck, friends. Save... Alleria...','',0,0,0,0,0,0,0,0,0,0,61848,0,26124),
(104145,'The hounds... I got sloppy... let them get too close.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104146,'It\'s so damned cold...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104147,'','Orestes, try to... Orestes!',603,0,0,0,0,0,603,0,0,0,0,61847,26124),
(104148,'<Absolon shakes violently.>\n\nGo away. Leave me to my suffering.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104149,'Go ahead, I am right behind you.','',0,0,0,0,0,0,1,0,0,0,67287,0,26124),
(104150,'Tell me more about the Bane of the Highmountain.','Tell me more about the Bane of the Highmountain.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104151,'I\'d like to hear about this Spear.','I\'d like to hear about this Spear.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104152,'How did it get here? What is this place?','How did it get here? What is this place?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104153,'','I will speak to my brother a bit longer and then we will head to the barrier. Good luck!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104154,'Here we are - my old sanctuary!','',0,0,0,0,0,0,1,0,0,0,67275,0,26124),
(104155,'Strange... the defenses are offline...','',0,0,0,0,0,0,1,0,0,0,67276,0,26124),
(104156,'Intruders! How did they get in here?!','',0,0,0,0,0,0,1,0,0,0,67277,0,26124),
(104157,'Thwen... I should have recognized your uniquely oafish meddling on my network.','',0,0,0,0,0,0,1,0,0,0,67292,0,26124),
(104158,'','You should be proud! Your handiwork is going to help us reclaim every corner of our ancient lands.',0,0,0,0,0,0,397,0,0,0,0,67294,26124),
(104159,'','My, my. You look rather gaunt, honored teacher. Are you eating enough? Ahahaha!',0,0,0,0,0,0,396,0,0,0,0,67293,26124),
(104160,'','Dispose of them!',0,0,0,0,0,0,0,0,0,0,0,67295,26124),
(104161,'I can deal with Thwen. You overload the coils!','',0,0,0,0,0,0,1,0,0,0,67296,0,26124),
(104162,'Urgh!','',0,0,0,0,0,0,0,0,0,0,67281,0,26124),
(104163,'|TInterface\\Icons\\INV_Misc_Horn_03:20|t Hymdall blows the |cFFFF0404|Hspell:191284|h[Horn of Valor]|h|r summoning Storm Drakes!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104164,'Thank you for your kindness. I will never forget it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104165,'','We cannot fight the monster until you place the trap! Hurry!',0,0,0,0,0,0,0,0,4,0,0,62698,26124),
(104166,'','Hold off these beasts until the trap is sprung!',0,0,0,0,0,0,0,0,4,0,0,62692,26124),
(104167,'The darkness lifts... thank you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104178,'Use Frost Nova to freeze your enemies in place and get away.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104179,'Join us at the Circle of Wills in Dalaran\'s underbelly, warlock. My portal will take you there directly. We will be waiting.','',0,0,0,0,0,0,1,0,0,0,63919,0,26124),
(104181,'','I was looking for the betrayer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104182,'','You are nothing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104183,'','Fall before the might of Suramar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104184,'','To think I was slain... by a...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104185,'','I have failed my mission.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104186,'','Avenge me, Anishar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104187,'Where is the betrayer?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104188,'By the might of the Nightwell!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104189,'Foolish creature. I will show you real power.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104190,'Elisande... I have failed you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104191,'Pathetic... creature... I will...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104192,'Avenge my death, Idriana.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104193,'Evaluating target.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104194,'Initiating combat mode.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104195,'Threat level minimal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104196,'Primary core damaged...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104197,'Power reserves depleted.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104198,'Contacting nearest Seeker.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104200,'What did your daughter carry with her, Valendrel?','What did your daughter carry with her, Valendrel?',0,0,0,0,0,0,0,0,0,37625,0,0,26124),
(104201,'And your wife?','And your wife?',0,0,0,0,0,0,0,0,0,37625,0,0,26124),
(104204,'Are you okay?','Are you okay?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104205,'I am at your service, $ct','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104206,'Station Li Li.','Station Li Li.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104207,'','I\'m happy to finally be done with that jungle.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(104208,'','Such an honor to be part of the rebirth of the Unseen Path!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(104209,'','Together we\'ll triumph against the Legion!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(104210,'','I never go anywhere without Sif and Nel.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(104211,'I still do not feel safe.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104212,'','I have finally found you, Dorion. And now I will end you.',0,0,0,0,0,0,0,0,0,37630,0,0,26124),
(104213,'That\'s it, you\'ve done it!  You truly are a skilled in your art.  There is little more I can teach you here, this is simply where your journey begins.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104214,'','$ct, I\'ve found someone new to join us! Come meet us at the Wandering Isle as soon as you can.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104215,'If you feel you need more time to practice then take this portal to the Proving Grounds. There you can train with Master Rotun and truly master your class.  Otherwise, use that gyrocopter over there and head into battle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104219,'Speak quickly. My entire operation requires that I do not attract unwanted attention.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104220,'Why put yourself at risk to help them?','Why put yourself at risk to help them?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104221,'This coil taps into the ancient leylines. Crank it up to full power!','',0,0,0,0,0,0,1,0,0,0,67278,0,26124),
(104222,'Overcharging','Overcharging',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104223,'There are more coils in the chamber below - and more intruders, I imagine.','',0,0,0,0,0,0,0,0,0,0,67279,0,26124),
(104224,'Good. If we overcharge enough coils, the entire system will failsafe into a lockdown.','',0,0,0,0,0,0,0,0,0,0,67280,0,26124),
(104225,'It is not yet your time, Varedis.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104226,'Unleash the Twinblades and destroy the interloper!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104227,'Well done, $p. We managed to clear the skies while you dealt with Varedis.','',0,0,0,0,0,0,0,0,0,0,57452,0,26124),
(104228,'Just a small tasterino of the Arcano-Plasm...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104229,'Not bad... Kind of minty...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104230,'I feel funny...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104231,'Ahhh!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104232,'','Face it, old man. I have surpassed you.',0,0,0,0,0,0,0,0,0,0,0,67282,26124),
(104233,'Good trick... <cough> Warping the space around your body like that.','',0,0,0,0,0,0,0,0,0,0,67283,0,26124),
(104234,'Graa.... Ooh... oooWAAAAAHHHH!!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104235,'But what if that space is already unstable?','',0,0,0,0,0,0,0,0,0,0,67284,0,26124),
(104236,'','You do not belong here, $r.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104237,'','We are taking back these ruins for the Legion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104238,'','You stand little chance against me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104239,'','For the Legion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104240,'','You will never leave this place.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104241,'','The Nightwell has failed me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104242,'We are taking back these lands.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104243,'I will cut you down.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104244,'You cannot hope to best me, $r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104245,'The Legion will envelop these lands.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104246,'How... could...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104247,'You will never escape the Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104248,'','My warp field is not working! Where have you taken us?!',0,0,0,0,0,0,0,0,0,0,0,67290,26124),
(104249,'<cough> Unstable... space...','',0,0,0,0,0,0,1,0,0,0,67291,0,26124),
(104250,'','Altruis and the others await you at Krasus\' Landing. I\'ll meet you there.',0,0,0,0,0,0,1,0,0,36910,0,58225,26124),
(104251,'The Nightfallen appears to be alive, but is unresponsive.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104252,'Feed the Nightfallen Ancient Mana. <NYI>','Feed the Nightfallen Ancient Mana. <NYI>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104253,'What ill-fated chance brings our paths together, $r?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104254,'Ughhhhhh...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104256,'$n, I\'m glad that you\'re here. Malevolence has been providing us with transportation back and forth from the Fel Hammer.\n\nThe Burning Legion have invaded Faronaar across the isthmus. We must destroy them before they overrun the rest of this island.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(104257,'Khadgar? $n? I was not expecting you.','',0,0,0,0,0,0,0,0,0,0,57444,0,26124),
(104258,'Like Blink, Frost Nova has a long cooldown.  So you can train more effectively though, I\'m filling this room with arcane energy so you can use them more often.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104259,'Your artifact looks powerful, $c. Speak with Jace and Allari if you intend to help.','',0,0,0,0,0,0,0,0,0,37647,57443,0,26124),
(104260,'You, Kor\'vas, and Cyana attack the Legion from within. Then, we\'ll wipe them out together.','',0,0,0,0,0,0,25,0,0,0,57442,0,26124),
(104261,'I will see to it that the Legion gets no farther.','',0,0,0,0,0,0,273,0,0,0,57445,0,26124),
(104262,'I will see to it that the Legion gets no farther.','',0,0,0,0,0,0,273,0,0,0,57441,0,26124),
(104264,'We are indomitable. We are Illidari.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104265,'','Do not forget to use the gem to suck the soul out of the demon corpses.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104266,'','Wanna see a trick my uncle Chen taught me?',0,0,0,0,0,0,5,0,0,0,0,68702,26124),
(104267,'Bless the crane! A healer!','',0,0,0,0,0,0,0,0,0,0,61941,0,26124),
(104268,'Thwen always took magic too lightly... She was a terrible student... <cough>','',0,0,0,0,0,0,1,0,0,0,67285,0,26124),
(104269,'I haven\'t much left... <cough> I will get us as close as I can... Come close.','',0,0,0,0,0,0,0,0,0,0,67286,0,26124),
(104270,'','No! This place... it must bend to my will!',0,0,0,0,0,0,0,0,0,0,0,67288,26124),
(104271,'','An\'ratha... an\'tal-thandros!',0,0,0,0,0,0,0,0,0,0,0,67289,26124),
(104272,'These buggers are suppressin\' Tyr\'s wards so the Deacon can do his work below. We need ta take \'em down! Start by dispellin\' the wards on the ritualists!','',0,0,0,0,0,0,1,0,0,37673,63437,0,26124),
(104273,'','He may be trying to leave discreetly. I\'d start looking down in the Underbelly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104274,'','Hemet and his hunters bring death and destruction wherever they go, slaughtering innocent animals for sport.\nThey must pay for their crimes against nature.\n\nIf the animals of this basin could speak, they would ask for our help. Let\'s level the playing field a bit and let those hunters be hunted for a change.\n\nI will alter your form to resemble a creature native to this region. Once transformed, those hunters will become your prey.\n\nAre you ready?',1,0,0,0,0,0,0,0,0,37683,0,0,26124),
(104275,'There we go! The path to the prison should be ope... Well, if it ain\'t me old friend! We\'d be doin\' the world a favor riddin\' it o\' this baddie!','',0,0,0,0,0,0,1,0,0,0,63439,0,26124),
(104276,'I... I don\'t feel well.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104277,'The Legion knows the importance of this sacred place. I personally led the patrol here, but we were ambushed and overcome.','',0,0,0,0,0,0,0,0,0,0,61942,0,26124),
(104278,'Thank you, hero. The sacred waters have already been corrupted. If you help me rescue the others, we may be able to reclaim this place.','',0,0,0,0,0,0,0,0,0,0,61943,0,26124),
(104279,'','At once, Ranger-General. But beware! Time flows unpredictably so deep in the Nether.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104280,'','Orestes, you fool!',0,0,0,0,0,0,0,0,0,0,0,61786,26124),
(104281,'','Now we have two allies to rescue. Follow me in!',0,0,0,0,0,0,0,0,0,0,0,61787,26124),
(104282,'This robot is broken beyond repair.','This robot is broken beyond repair.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104283,'The Darkswell will devour you!','The Darkswell will devour you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104284,'You cannot maintain your current form in this area.','You cannot maintain your current form in this area.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104285,'From the depths we ssstrike!','From the depths we ssstrike!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104286,'Jabrul was headed towards a harpy nest when he was ambushed. Let\'s head there now and search for those stones.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104287,'It looks like the Feeble Husks sucked out all of the Arcano-Plasm, destroying FTW-001 in the process.','It looks like the Feeble Husks sucked out all of the Arcano-Plasm, destroying FTW-001 in the process.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104288,'Thalyssra is near Meredil. Can you teleport us?','Thalyssra is near Meredil. Can you teleport us?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104289,'We have to deal with Thwen before we can leave.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104290,'I am fading fast. Where is Thalyssra?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104291,'','The great Lulubelle Fizzlebang, at your service!',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(104292,'I... live!','',0,0,0,0,0,0,0,0,0,0,63885,0,26124),
(104293,'It seems not even a pit lord can keep you down, warlock!','',0,0,0,0,0,0,1,0,0,0,63886,0,26124),
(104294,'But what of the rest of the council?','',0,0,0,0,0,0,6,0,0,0,63887,0,26124),
(104295,'One more thing, warlock.','',0,0,0,0,0,0,1,0,0,0,63889,0,26124),
(104296,'With our members scattered and a dreadlord on our heels, we need you to take leadership of the council. Through your power, we can rebuild.','',0,0,0,0,0,0,1,0,0,0,63890,0,26124),
(104297,'I name you, $n, the First of the Council of the Black Harvest.','',0,0,0,0,0,0,66,0,0,0,63892,0,26124),
(104298,'May you lead us to glory against the Legion!','',0,0,0,0,0,0,1,0,0,0,63891,0,26124),
(104299,'Come, let us plan the future of our order.','',0,0,0,0,0,0,1,0,0,0,63888,0,26124),
(104300,'','$p, a moment, please. I bear an urgent message for you.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104301,'','Apologies for my persistence, but this message is quite urgent.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(104302,'','I\'m afraid I cannot leave without delivering this missive to you.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104303,'','I must insist that we speak. It will only take a moment!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104304,'','We\'ll just have to get used to one another\'s company until you\'re ready to speak.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104305,'','This is for your eyes only. Once you\'ve read it, destroy it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104306,'','Farewell.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104307,'Pustulio speaks the truth! The Windrunner is captive on Niskara!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104308,'You\'d better not be lying, worm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104309,'Go to Niskara! Then you will see!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104310,'','We should just end its miserable existence now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104311,'Lots of demons out there, but nothing we can\'t handle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104312,'I\'ll look into doing that favor for you.','I\'ll look into doing that favor for you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104313,'','If anything gets close... I\'ll kill it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104314,'I am ready.','I am ready.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(104316,'$p, your presence is requested in the Hall of Shadows at once.','',0,0,0,0,0,0,0,0,0,0,63613,0,26124),
(104318,'Enter the Glorious Goods storefront and utter \"the raven calls\" to Red. He will show you the way.','',0,0,0,0,0,0,0,0,0,0,63614,0,26124),
(104319,'Come alone, and ensure you are not followed. The eyes of the Uncrowned are upon you.','',0,0,0,0,0,0,0,0,0,0,63615,0,26124),
(104320,'','Excellent choice. You can find my problem in the Circle of Wills. His name is Inkrot, and I need someone to send him a lesson. I believe you know what to do, $c.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104321,'Now that our business is concluded, I shall take me leave. See ya around, $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104322,'Not without the Ranger-General\'s order. Understood?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104323,'$ct, My mission was a success! The demons have been crushed and our brother in undeath still lives. Meet with me in Acherus as soon as you are able.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104324,'%s thanks you, sheepishly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104325,'','Minions! Feast on their souls!',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(104326,'Only a fool walks into the Hall of Shadows unaware! Prepare to--','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104327,'','Right this way, please.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104328,'','The others are waiting for you. Good luck.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104329,'They won\'t stop their assaults! Help us put an end to it!','They won\'t stop their assaults! Help us put an end to it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104330,'This... this is madness, $n! You must do something!','This... this is madness, $n! You must do something!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104331,'The Legion is here! Prepare yourself for battle!','The Legion is here! Prepare yourself for battle!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104332,'If you need not be here, I suggest you find shelter.','If you need not be here, I suggest you find shelter.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104333,'There is no harm in hiding, $n, but you... you look like a brave $c. We could use your help.','There is no harm in hiding, $n, but you... you look like a brave $c. We could use your help.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104334,'Look at them... they are not even people any more. I cannot turn into one of them. We must reach Astoril quickly. Clear the path faster!','Look at them... they are not even people any more. I cannot turn into one of them. We must reach Astoril quickly. Clear the path faster!',0,0,0,0,0,0,0,0,0,0,0,65951,26124),
(104335,'More exiles... like me. All I did was punish those servants... You would have done the same!','More exiles... like me. All I did was punish those servants... You would have done the same!',0,0,0,0,0,0,0,0,0,0,0,65931,26124),
(104336,'You must be Astoril! Finally! The first thing I shall do when I get back in the city is drink a cool, tall glass of arcwine.','You must be Astoril! Finally! The first thing I shall do when I get back in the city is drink a cool, tall glass of arcwine.',0,0,0,0,0,0,0,0,0,0,0,65934,26124),
(104337,'Be careful, $n. I just saw a $c like yourself not long ago. The Legion... they - $B$BThey\'ll stop at nothing to devour our lands! I cannot ask you to put yourself in harms way to fight by my side, but I can tell you that if we don\'t stop them soon we\'ll have nothing left to fight for.','Be careful, $n. I just saw a $c like yourself not long ago. The Legion... they - $B$BThey\'ll stop at nothing to devour our lands! I cannot ask you to put yourself in harms way to fight by my side, but I can tell you that if we don\'t stop them soon we\'ll have nothing left to fight for.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104338,'You will find no easy target here, demon.','',0,0,0,0,0,0,0,0,0,0,61954,0,26124),
(104339,'If your Legion wants Pandaria, you will have to get through US!','',0,0,0,0,0,0,0,0,0,0,61955,0,26124),
(104340,'Brave $r! Have you come to put an end to the Legion?','Brave $r! Have you come to put an end to the Legion?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104341,'We\'ll hold them off as long as we can, but please - if we have any hope of saving this place it\'s with your help, $n!','We\'ll hold them off as long as we can, but please - if we have any hope of saving this place it\'s with your help, $n!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104342,'The Legion will fall, $ct. The Ebon Blade will make sure of it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104343,'Ah! There\'s our final member. Welcome to the crew!','',0,0,0,0,0,0,0,0,0,0,63610,0,26124),
(104344,'','Valeera glances in your direction.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104345,'','Yes?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104346,'The landwalkers are here! We will drive them back by salt and scale!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104347,'We will take this land.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104348,'For our queen!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104349,'We will take what we want from this land.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104350,'Sakar\'thiss will see you dead.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104351,'Aid me, Raj\'kess!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104352,'Death comes to all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104353,'','Your druids will perish!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104354,'','You will not stop us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104355,'','We will take what we want.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104356,'','I have failed my queen.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104357,'','Raj\'kess... slay this...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104358,'','Sakar\'thiss...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104359,'I will crush you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104360,'Sakar\'thiss... kill you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104361,'Never was very good at following orders. See you on the other side!','',0,0,0,0,0,0,0,0,0,0,60719,0,26124),
(104362,'This land and its resources belong to us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104363,'More will come to take my place...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104364,'','Magus Solgaze, empower the portal crystal.',0,0,0,0,0,0,0,0,0,0,0,61784,26124),
(104365,'%s falls to one knee, gravely wounded.','%s falls to one knee, gravely wounded.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104366,'Want to live? Kill these fools.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104367,'Yes... the Blade is right! I am unstoppable! Once Zakajz lives again, I will hold dominion over this world!','',0,0,0,0,0,0,1,0,14,0,63441,0,26124),
(104368,'Our old leaders chose to work with pawns. I choose the REAL power!','',0,0,0,0,0,0,0,0,14,0,63442,0,26124),
(104369,'Begone, beast! Your shameful crusade ends here.','',0,0,0,0,0,0,0,0,0,0,61956,0,26124),
(104370,'Come, that monster has already spread his corruption to the waters above. We must act quickly.','',0,0,0,0,0,0,1,0,0,0,61944,0,26124),
(104371,'','He is withering...',0,0,0,0,0,0,0,0,0,0,0,67244,26124),
(104372,'','I scavenged a few more mana crystals while you were out. Set him down over here.',0,0,0,0,0,0,0,0,0,0,0,67245,26124),
(104373,'The Nightborne\'s body lies bloody and beaten. By the looks of his wounds, it appears that he sustained a crushing blow to the chest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104374,'We must work together. Champion, we will follow your lead. How do you wish to deploy the Shado-Pan?','',0,0,0,0,0,0,1,0,0,0,61945,0,26124),
(104375,'You ronir lovers ain\'t gonna take my stock!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104376,'','This fel magic eats at my soul! I can\'t hold the portal open long. Get going!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104377,'Bring the supplies through! The commander will be arriving shortly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104378,'The end draws near...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104379,'Nothing survives! NOTHING!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104380,'Rid these worthless mortals of their flesh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104381,'You will know the pain of a thousand worlds.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104382,'Your world trembles in our wake.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104383,'Everybody back. $p be havin\' important business with da admiral.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104384,'','This thirst for the Nightwell is unending. If I hadn\'t come across Manashale, I would have perished by now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104385,'','I am content to spend my days down here with Manashale. He\'s quickly becoming my closest friend.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104386,'My mind is as sharp as ever.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104387,'I hunger, but I press on.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104388,'<Oculeth mumbles incoherently under his breath.|cFFF92304His hunger must be sated before all else.|r>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104389,'I will do everything in my power to defend Suramar from the Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104394,'Listen up! Raise a mug for the outlaw that\'s gonna take the Dreadblades from that blasted Eliza\'s cold, dead hands!','',0,0,0,0,0,0,0,0,0,0,63697,0,26124),
(104395,'Hoist the sails! Reel in the anchor! Ready yerselves, ya salty dogs! Azsuna awaits!','',0,0,0,0,0,0,0,0,0,0,63699,0,26124),
(104396,'Just let me know when yer ready. Eliza won\'t know what\'s comin\' for her!','',0,0,0,0,0,0,0,0,0,0,63698,0,26124),
(104397,'Are ya ready?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104398,'Set sail for Azsuna!','Set sail for Azsuna!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104399,'Murky waters envelop you, softssskin!','Murky waters envelop you, softssskin!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104400,'The ssseas rise against you!','The ssseas rise against you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104401,'Goldrinn\'s power will be ours, $r!','Goldrinn\'s power will be ours, $r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104402,'The Scythe of Elune belongs to the worgen!','The Scythe of Elune belongs to the worgen!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104403,'Ssshiver before the Rimescale!','Ssshiver before the Rimescale!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104404,'Down into the cold depths with you!','Down into the cold depths with you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104405,'They were going to feed us to their basilisks!','They were going to feed us to their basilisks!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104406,'They took some of our people deeper into the Enclave.','They took some of our people deeper into the Enclave.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104407,'My thanks, champion!','My thanks, champion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104408,'This is why I hate caves.','This is why I hate caves.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104409,'They took us by surprise at night.','They took us by surprise at night.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104410,'Time for some payback!','Time for some payback!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104411,'','Finally free from that cursed mage trap! Such a-',0,0,0,0,0,0,0,0,0,0,0,57475,26124),
(104412,'Hey there! I was just enjoying a relaxing vacation on the beach when a chilling sense of dread washed over me. Just what are you up to, I wonder?','',0,0,0,0,0,0,0,0,0,0,57474,0,26124),
(104413,'','Wait, I recognize that voice...',0,0,0,0,0,0,0,0,0,0,0,57473,26124),
(104414,'Oh buttons, what have you done? Hurry, get her back in the cell!','',0,0,0,0,0,0,0,0,0,0,57472,0,26124),
(104415,'','MILLHOUSE!! You\'re next!',0,0,0,0,0,0,0,0,0,0,0,57471,26124),
(104416,'Quick, disarm her squirrel bombs before they blow!','',0,0,0,0,0,0,0,0,0,0,57469,0,26124),
(104417,'Now scrap those pesky rocket chickens! They\'re going to fire!','',0,0,0,0,0,0,0,0,0,0,57467,0,26124),
(104418,'Now make fun of her hair! It won\'t help, but it\'ll make her REAAAALLLLY mad!','',0,0,0,0,0,0,0,0,0,0,57480,0,26124),
(104419,'','Why you... No one insults my hair! NO ONE!',0,0,0,0,0,0,0,0,0,0,0,57479,26124),
(104420,'Follow me to the landing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104421,'Hoo boy, you really did it!','',0,0,0,0,0,0,0,0,0,0,57478,0,26124),
(104422,'','I know it was you, Millhouse!',0,0,0,0,0,0,0,0,0,0,0,57477,26124),
(104423,'Uh oh.','',0,0,0,0,0,0,0,0,0,0,57476,0,26124),
(104424,'Listen Milly, I can explain!','',0,0,0,0,0,0,0,0,0,0,57485,0,26124),
(104425,'','Don\'t \"Milly\" me, Millhouse Jerimus Manastorm! I\'m coming for you!',0,0,0,0,0,0,0,0,0,0,0,57484,26124),
(104426,'That\'s not even my middle name!','',0,0,0,0,0,0,0,0,0,0,57483,0,26124),
(104427,'Thanks a lot. You have no idea what you unleashed upon the world today!','',0,0,0,0,0,0,0,0,0,0,57482,0,26124),
(104428,'On a completely unrelated note, I... uh... have to go take care of something...','',0,0,0,0,0,0,0,0,0,0,57481,0,26124),
(104429,'She\'s ready to take you to Ranger-General Windrunner. Good luck, commander!','',0,0,0,0,0,0,0,0,0,0,64289,0,26124),
(104430,'Defend me, Blade! You said this would work!','',0,0,0,0,0,0,0,0,14,0,63444,0,26124),
(104431,'The Dark Riders were not always like this. They were once a group of traveling merchants.','',0,0,0,0,0,0,0,0,0,0,60243,0,26124),
(104432,'Unfortunately they crossed the sorcerer Medivh, who cursed them to an eternity of hunting artifacts for him.','',0,0,0,0,0,0,0,0,0,0,61872,0,26124),
(104433,'Ariden was the first of the Dark Riders, and I believe he leads them now.','',0,0,0,0,0,0,0,0,0,0,60244,0,26124),
(104434,'His camp is still in Deadwind Pass, strangely untouched after all these years.','',0,0,0,0,0,0,0,0,0,0,61873,0,26124),
(104435,'If my convictions are correct, the key to finding the Dark Riders, as well as the artifacts they still covet, can be found there.','',0,0,0,0,0,0,0,0,0,0,60245,0,26124),
(104436,'The worgen led you here as well? This must be where the scythe is kept!','',0,0,0,0,0,0,1,0,0,0,61874,0,26124),
(104437,'Let\'s get a move on! The Horizon\'s Edge be just over this ridge.','',0,0,0,0,0,0,603,0,0,0,63663,0,26124),
(104438,'Fight them. Earn your freedom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104439,'Ah, there she be. Ain\'t she a beauty?','',0,0,0,0,0,0,0,0,0,0,63664,0,26124),
(104440,'Hey! Get away from my chompers!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104441,'Thems my chompers! Leave \'em alone!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104442,'You hurtin\' my precious babies?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104443,'Come on boys! Eat that invader.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104444,'Stop smakin\' my babies!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104445,'Squawk! Taking the ship.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104446,'Ye sneak past the guards and make sure the first mate sees our side o\' things. We\'ll join ya after that.','',0,0,0,0,0,0,1,0,0,0,63667,0,26124),
(104447,'','Thank you, $c. I must return to my sisters.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104448,'','My thanks, champion! Now to contend with the vile drogbar who caught us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104449,'','It\'s so good to see you again, $n! We really lit Pandaria up together, didn\'t we?$b$bI\'ve been perfecting my fire spells since you last worked with the Shado-Pan. If you can keep me on my feet, I will be able to break Aspersius\'s ice walls and otherwise bring him to a boil. Stand near me and I will enhance the power of your Jade Lightning.$b$b<Fei Li grins savagely.>$b$bDo you want me to REALLY light this thing up or should I concentrate on keeping myself alive?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(104450,'','Thank you, $c, for coming to our aid. I am Fei Li, and I have a reputation among the Shado-Pan for setting things on fire. Usually our enemies. Sometimes our Monastery. Lord Taran Zhu isn\'t too pleased with me at the moment...$b$bHelp me get back into his good graces. If you can keep me on my feet, I will be able to break Aspersius\'s ice walls and otherwise bring him to a boil. Stand near me and my Brilliance Aura will restore your mana.$b$b<Fei Li grins savagely.>$b$bDo you want me to REALLY light this thing up or should I concentrate on keeping myself alive?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(104451,'We should try to find a way to stop his channeling...','',0,0,0,0,0,0,1,0,0,0,60292,0,26124),
(104452,'Concentrate on staying alive, Fei Li. I need to focus on the others.','Concentrate on staying alive, Fei Li. I need to focus on the others.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104453,'Do your worst, Fei Li! Even if it puts you in danger. I\'ll keep you alive.','Do your worst, Fei Li! Even if it puts you in danger. I\'ll keep you alive.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104454,'Greetings, $n! Your training has progressed far since we last adventured together in Pandaria. I\'d venture that even Lord Taran Zhu could learn a thing or two from you. It\'s a pleasure to be fighting with you again.$b$bNow, to business! I will assault Aspersius at range while Whitefeather swoops in to harass him with beak and claw. Stand near me and I will help you cast spells faster.$b$bI could go for an all-out attack, but it would put myself at risk. How aggressive should I be?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(104455,'Hello, $c! It is good to have a healer at our side. We are the Shado-Pan, the last defense of Pandaria. I am Hawkmaster Nurong, Master of the Wu Kao discipline - we are the eyes of the Shado-Pan, the scouts who make our enemies fear the darkness.$b$bNow, to business! I will assault Aspersius at range while my hawk Whitefeather swoops in to harass him with beak and claw. Stand near me and I will help you attack faster.$b$bI could go for an all-out attack, but it would put myself at risk. How aggressive should I be?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104456,'Concentrate on keeping yourself alive, Nurong. Fight defensively.','Concentrate on keeping yourself alive, Nurong. Fight defensively.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104457,'Do as much damage as you can, Nurong, even if it puts you at risk. I will keep you alive!','Do as much damage as you can, Nurong, even if it puts you at risk. I will keep you alive!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104458,'','$n! It has been such a long time. You should visit us in Pandaria more often. You and I made a great team.$b$bYou know my strengths, $n. While Taran Zhu holds that thing\'s attention, I will stalk it from behind and bury my daggers in any weak spots. I can also help you move quickly around the battlefield - stand near me to reset your roll and flying kick abilities.$b$bHow aggressive do you want me to be? I could throw caution to the wind and wage an all-out assault, but I\'ll need to know you have my back!',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(104459,'','Thank you for your well-timed rescue, $c. We could\'ve used your help in the Pandaren Campaign. My name is Taoshi, the silent blade of the Shado-Pan. I slip unseen through enemy territory and strike where they are weakest.$b$bI\'ll do my part. While Taran Zhu holds that thing\'s attention, I will stalk it from behind and bury my daggers in any weak spots. I can also help you move quickly around the battlefield - stand near me to gain charges of your Roll, Chi Torpedo, and Mistwalk abilities.$b$bHow aggressive do you want me to be? I could throw caution to the wind and wage an all-out assault, but I\'ll need to know you have my back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104460,'Don\'t be too aggressive - keep yourself alive, even if it means sacrificing damage.','Don\'t be too aggressive - keep yourself alive, even if it means sacrificing damage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104461,'Don\'t hold back, Taoshi! Do your worst to that thing and I will keep you alive.','Don\'t hold back, Taoshi! Do your worst to that thing and I will keep you alive.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104462,'Naraxas\' |cFFFF0000|Hspell:199176|h[Spiked Tongue]|h|r begins to salivate!','Naraxas\' |cFFFF0000|Hspell:199176|h[Spiked Tongue]|h|r begins to salivate!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(104463,'Drogbar leap down from the stands!','Drogbar leap down from the stands!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104464,'Very well! If you so thirst for the power of the Scythe, then I will show it to you myself!','',0,0,0,0,0,0,5,0,0,0,60261,0,26124),
(104465,'Face the fury of the beast!','',0,0,0,0,0,0,15,0,0,0,60263,0,26124),
(104466,'You have proven an unexpected ally, $c. The Scythe of Elune is yours. Let us hope it can turn the tide in this war.','',0,0,0,0,0,0,1,0,0,0,60256,0,26124),
(104467,'If you want the Scythe, druid, come and claim it!','',0,0,0,0,0,0,0,0,0,0,60298,0,26124),
(104468,'This stinks of a trap. You can\'t rely on the word of a demon!','',0,0,0,0,0,0,0,0,0,0,61369,0,26124),
(104469,'','If it\'s lying, we\'ll have its head. But if there\'s even a chance it speaks the truth, we have to try!',0,0,0,0,0,0,0,0,0,0,0,61370,26124),
(104470,'','Psst! Over here, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104471,'Dreadhound sniffs the air excitedly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104472,'$n prepares a Hearty Feast!','$n prepares a Hearty Feast!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(104473,'$n prepares a Lavish Suramar Feast!','$n prepares a Lavish Suramar Feast!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104474,'Now that\'s an offer I can\'t refuse! Fall back to the temple. They can have this pile of driftwood!','',0,0,0,0,0,0,0,0,0,0,63658,0,26124),
(104475,'Ye\'ll be findin\' Eliza in the temple ruins ahead. Keep yer wits about ya! Her whole crew\'s onto us now.','',0,0,0,0,0,0,0,0,0,0,63672,0,26124),
(104476,'We\'ll provide naval support as soon as we\'re up and runnin\'.','',0,0,0,0,0,0,0,0,0,0,63673,0,26124),
(104477,'This is nae good! I kin hear more comin\' from above. I\'ll handle \'em. Ye take care o\' the Deacon!','',0,0,0,0,0,0,22,0,0,0,63443,0,26124),
(104478,'|TInterface\\Icons\\inv_sword_115:20|t%s equips the Massive Sword and gains |cFFFF0000|Hspell:199556|h[Brutal Attacks]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104480,'|cFFFF0000$n|r attack the brute without the |cFFFF0000|Hspell:199556|h[Brutal Attacks]|h|r buff!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(104482,'','I can feel the power of the ley line.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104483,'','You will not harm our plants!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104484,'','You are corrupting our habitat!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104485,'','Intruder!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104486,'','My plants...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104487,'','Sisters!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104488,'','Come to me, my sisters...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104489,'','I must... protect...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104490,'','Be still and let me mend your wounds.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104491,'','You are lucky to be alive, my sister.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104492,'','Rest easy. I will take care of you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104493,'','Ugh...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104494,'','Please... Help me...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104495,'','Don\'t leave me like this...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104496,'','Why have you turned against us?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104497,'Keep your eyes peeled. The admiral is not to be disturbed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104498,'Back into the cage with you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104499,'Ah, a perfect test subject!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104500,'Time for a little field testing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104501,'Irlik raka glab markzan!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104502,'Needed more... sulphur...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104503,'N... No! My potions...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104504,'Noooo! My potions...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104505,'|TInterface\\Icons\\ability_fixated_state_red:20|t  Fenryr cast |cFFFF0404|Hspell:196838|h[Scent of Blood]|h|r on you! Run!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104506,'','You\'ll pay for what you\'ve done, fiend!',0,0,0,0,0,0,397,0,0,0,0,61811,26124),
(104507,'I found the scurvy dog! To arms!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104508,'This... this shouldn\'t be happening! Why aren\'t you protecting me?!','',0,0,0,0,0,0,0,0,14,0,63449,0,26124),
(104509,'','Weak and pitiful! The Twilight Father did not dare wield me, for he knew the price of failure.',0,0,0,0,0,0,0,0,0,0,0,63450,26124),
(104510,'Give me another chance! No! Noooo!','',0,0,0,0,0,0,0,0,14,0,63451,0,26124),
(104511,'','You, on the other hand... Yes, I foresee us doing great things together. Take hold of my haft and I will aid you... for now.',0,0,0,0,0,0,0,0,0,0,0,63452,26124),
(104512,'','So, you\'re the one who stole MY ship and killed MY crew.',0,0,0,0,0,0,397,0,0,0,0,63675,26124),
(104513,'','Release the giant. I have business to attend to within the temple.',0,0,0,0,0,0,396,0,0,0,0,63676,26124),
(104514,'With pleasure, admiral.','',0,0,0,0,0,0,396,0,0,0,63677,0,26124),
(104515,'It took half our crew to subdue this creature. Let\'s see what it does to you.','',0,0,0,0,0,0,396,0,0,0,63678,0,26124),
(104516,'All will know the blades of Dread Admiral Eli--','',0,0,0,0,0,0,153,0,0,0,63679,0,26124),
(104517,'That which was foreseen has come to pass. The circle nears completion. Sentries, attend to our \"guests\"!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104518,'The way is clear, just as the Great One promised! This tower is ours for the taking!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104519,'%s vanishes, summoning |cFFFF0404|Wild Imps|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104520,'%s reappears!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104521,'I will ride... again...','',0,0,0,0,0,0,0,0,0,0,60273,0,26124),
(104522,'We got yer back. Lead the beast into our line of fire!','',0,0,0,0,0,0,0,0,0,0,63680,0,26124),
(104523,'Uuuugh, you pick bad time to interrupt! My. Tummy. No. Good!','',0,0,0,0,0,0,0,0,0,0,57495,0,26124),
(104524,'The beast\'s wrath will end you!','',0,0,0,0,0,0,53,0,0,0,60269,0,26124),
(104525,'This one broken!','',0,0,0,0,0,0,0,0,0,0,57492,0,26124),
(104526,'Did you get an owie?','',0,0,0,0,0,0,0,0,0,0,57493,0,26124),
(104527,'Too much stinky for you!','',0,0,0,0,0,0,0,0,0,0,57494,0,26124),
(104528,'Better look out... blegh!','',0,0,0,0,0,0,0,0,0,0,57486,0,26124),
(104529,'Not feel so good!','',0,0,0,0,0,0,0,0,0,0,57487,0,26124),
(104530,'Gonna lose it!','',0,0,0,0,0,0,0,0,0,0,57488,0,26124),
(104531,'Taste better going in!','',0,0,0,0,0,0,0,0,0,0,57489,0,26124),
(104532,'Yummy!','',0,0,0,0,0,0,0,0,0,0,57490,0,26124),
(104533,'Mmm! So good!','',0,0,0,0,0,0,0,0,0,0,57491,0,26124),
(104534,'At least... tummy... feel better...','',0,0,0,0,0,0,0,0,0,0,57497,0,26124),
(104535,'|TInterface\\Icons\\Ability_Creature_Disease_05:20|t A Black Bile begins to emit a |cFFFF0404|Hspell:201753|h[Necrotic Aura]|h|r!','|TInterface\\Icons\\Ability_Creature_Disease_05:20|t A Black Bile begins to emit a |cFFFF0404|Hspell:201753|h[Necrotic Aura]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104536,'|TInterface\\Icons\\Ability_Creature_Poison_06:20|t Festerface begins to wretch a |cFFFF0404|Hspell:201598|h[Congealing Vomit]|h|r!','|TInterface\\Icons\\Ability_Creature_Poison_06:20|t A Black Bile begins to emit a |cFFFF0404|Hspell:201753|h[Necrotic Aura]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104537,'Your life falls inevitably toward the void!','Your life falls inevitably toward the void!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104538,'There is no meaning in your existence! Succumb to the abyss!','There is no meaning in your existence! Succumb to the abyss!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104539,'Crush! Yes, crush tiny creature!','Crush! Yes, crush tiny creature!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104540,'Snake masters say tiny creature must die!','Snake masters say tiny creature must die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104541,'Activate the crystals when we get in trouble, right.','Activate the crystals when we get in trouble, right.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(104542,'Get your people to safety, we\'ll keep the Legion\'s forces at bay.','Get your people to safety, we\'ll keep the Legion\'s forces at bay.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(104543,'We got that briny bastard! Let \'im have it!','',0,0,0,0,0,0,0,0,0,0,63681,0,26124),
(104544,'','Yes, we are eager to feast on the fallen titan\'s minions. But first... Zakajz.',0,0,0,0,0,0,0,0,0,0,0,63453,26124),
(104545,'Fire all cannons! Fire. Fire!','',0,0,0,0,0,0,0,0,0,0,63682,0,26124),
(104546,'','The cultists may try to stir him again, or he could awaken on his own. We must consume his essence to ensure he is gone forever. You know this must be done.',0,0,0,0,0,0,0,0,0,0,0,63454,26124),
(104547,'Eliza escaped into the temple ahead. We\'ll make sure none o\' her mangy crew follow ya. Go get \'er!','',0,0,0,0,0,0,0,0,0,0,63683,0,26124),
(104548,'We\'re out o\' cannonballs! Ye\'ll have to figure yer own way past the temple door.','',0,0,0,0,0,0,0,0,0,0,63684,0,26124),
(104549,'The worgen escape down the cliff toward Karazhan!','The worgen escape down the cliff toward Karazhan!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104550,'Ye did it! The cultists ha\'e run off! Ha ha! Ye should get back ta Faol. I\'ll use this Twilight portal stone fer ye!','',0,0,0,0,0,0,22,0,0,0,63455,0,26124),
(104551,'I\'ll bring down the barrier. Watch my back!','',1,0,0,0,0,0,0,0,1,38044,60319,0,26124),
(104552,'Keep an eye on that blade, though. No tellin\' wha\' somethin\' that old be capable of.','',0,0,0,0,0,0,1,0,0,0,63456,0,26124),
(104553,'Just a little and... down it goes!','',1,0,0,0,0,0,0,0,1,0,60324,0,26124),
(104554,'Hey, I need some help here! I\'m not going to ask again!','',1,0,0,0,0,0,0,0,1,0,60352,0,26124),
(104555,'First the Nightbane are driven mad, and now a druid comes to investigate Manor Mistmantle?','',0,0,0,0,0,0,0,0,0,0,61907,0,26124),
(104556,'This can only mean the Scythe of Elune has returned to Duskwood... and the Dark Riders cannot be far behind.','',0,0,0,0,0,0,1,0,0,0,60250,0,26124),
(104557,'Tell me what you seek, druid, and I may be of assistance.','',0,0,0,0,0,0,1,0,0,0,61908,0,26124),
(104558,'','The Dreadblades have claimed entire fleets. Impenetrable fortresses have gushed rivers of blood by their will. To utter their name instills fear in sailors\' hearts.',0,0,0,0,0,0,0,0,0,0,0,63685,26124),
(104559,'','They know no equal... I know no equal! Turn back now, and you may yet live to tell the tale.',0,0,0,0,0,0,0,0,0,0,0,63686,26124),
(104561,'None will defy us. Unleash the fury of the tides!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104562,'You fool! The Dreadblades will claim you too!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104563,'You! You killed daddy! Now me kill you!','',0,0,0,0,0,0,0,0,0,0,57496,0,26124),
(104564,'','My village of Jandvik is being assailed by naga. I have come to seek your aid.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104565,'Toryl, why do you require my help? Can your clan not battle these naga on its own?','Toryl, why do you require my help? Can your clan not battle these naga on its own?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104566,'','There are two obstacles that impede us, $n.$B$BWe are proud warriors and can easily defend our village, but our clan has forsaken the sea. We cannot defeat an enemy that dwells in a place that we cannot enter.$B$BTo make matters worse, our jarl is missing. Members of our clan struggle for power in his absence.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104567,'','The shielding weakens!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104568,'','Lady Hatecoil is vulnerable! She must not fall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104569,'','Kinsmen of Jandvik! Calder and Eynar have fallen in combat. They were not worthy to lead Jandvik.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104570,'','As the last remaining successor, it falls on me to lead our people against the invading Sashj\'tar naga!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104571,'','This outsider is under my aegis. Those that show aggression against $ghim:her; will answer to me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104572,'','No longer used.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104573,'','No longer used.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104574,'Destroy them. Your blades thirst.','',0,0,0,0,0,0,0,0,0,0,63687,0,26124),
(104575,'You think to stop me? With this weapon I can do anything! ANYTHING!','',0,0,0,0,0,0,603,0,14,0,63445,0,26124),
(104576,'','It will be my pleasure.',0,0,0,0,0,0,0,0,0,0,0,63688,26124),
(104577,'','I have already seen my destiny. You are not a part of it!',0,0,0,0,0,0,0,0,0,0,0,63689,26124),
(104578,'','I am the scourge of the seas, the fear in sailors\' hearts! You are NOTHING!',0,0,0,0,0,0,0,0,0,0,0,63690,26124),
(104579,'','ENOUGH! I\'ll run you through!',0,0,0,0,0,0,0,0,0,0,0,63691,26124),
(104580,'','It seems we have pests...',0,0,0,0,0,0,0,0,0,0,0,56655,26124),
(104581,'Long have I awaited noble champions to enter my realm. Behold! The Halls of Valor!','',0,0,0,0,0,0,0,0,0,0,57160,0,26124),
(104582,'This place will test your mettle and, if you are found worthy, the Aegis of Aggramar will be yours!','',0,0,0,0,0,0,0,0,0,0,57159,0,26124),
(104583,'How DARE you enter this place! I\'ll rip the flesh from your bones!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104584,'','Impossible...',0,0,0,0,0,0,0,0,0,0,0,63692,26124),
(104585,'This... changes... nothing...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104586,'Rip them apart!','',0,0,0,0,0,0,0,0,0,0,60773,0,26124),
(104587,'Will it be Kayn or Altruis?','Will it be Kayn or Altruis?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104588,'Guards! Hold them off! We must prepare!','',0,0,0,0,0,0,0,0,0,0,57890,0,26124),
(104589,'|TInterface\\Icons\\spell_mage_frostbomb:20|tShivermaw begins to cast |cFFF00000|Hspell:201960|h[Ice Bomb]|h|r!','|TInterface\\Icons\\spell_mage_frostbomb:20|tShivermaw begins to cast |cFFF00000|Hspell:201960|h[Ice Bomb]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104590,'Eliza\'s fleet is bombardin\' the temple. If yer gonna match muskets with her, ye\'d better make it quick!','',0,0,0,0,0,0,0,0,0,0,63693,0,26124),
(104591,'Why don\'t you get along with Altruis?','Why don\'t you get along with Altruis?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104592,'Many years ago, during Lord Illidan\'s time at the Black Temple, Altruis the Sufferer split from our leader and the demon hunters.$B$BBelieving that Illidan had become the very thing he hated, Altruis then began a sinister campaign to orchestrate our master\'s downfall.$B$BHe was instrumental in the deaths of four of our comrades - Alandien, Theras, Netharel, and Varedis.$B$BThese were our teachers, our brothers and sisters.$B$BFor that, I cannot forgive him.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104593,'Why don\'t you like Kayn?','Why don\'t you like Kayn?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104594,'Your plan is solid, $n. Of course, our success depends on your ability to keep us all alive.$b$bFor my part, I will try to hold the creature\'s attention and absorb the brunt of its fury.$b$bLet me know when you are ready, and I will give the order to begin the assault.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104595,'Let us begin!','Let us begin!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104596,'Kayn has always been a loyal soldier, a fearless leader, and a master strategist.$B$BHowever, I believe his loyalty to Illidan blinded him.$B$BAs Illidan\'s power grew, he started losing control to the demonic energy that he had absorbed.$B$BI knew my actions could be construed as betrayal, but I was only doing what I thought was right.$B$BNow, Kayn is starting down the same path. Such a man should not lead the Illidari.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104597,'','Hello there! You were not followed, were you?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104598,'Ye made it out in one piece! Ah, and you have \'em! I\'ve seen no finer swords in all me days.','',0,0,0,0,0,0,0,0,0,0,63695,0,26124),
(104599,'Are you the one I\'m supposed to meet? Why all the way out here?','Are you the one I\'m supposed to meet? Why all the way out here?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104600,'Ahahaha... so the desperate Warden has turned to her enemies? Give up, demon hunter! If you hope to escape the Vault, you will have to face ME.','',0,0,0,0,0,0,0,0,0,0,57315,0,26124),
(104601,'You see, demon hunters, your attempts are futile. Even your master, the great Illidan Stormrage, is now a prisoner of the Legion.','',0,0,0,0,0,0,0,0,0,0,57283,0,26124),
(104602,'Your persistence is admirable, but my demons have infiltrated every floor of the Vault. Only death awaits you.','',0,0,0,0,0,0,0,0,0,0,57316,0,26124),
(104603,'Your allies have fallen. My army will crush you before you can see the light of day!','',0,0,0,0,0,0,0,0,0,0,57317,0,26124),
(104604,'Dreadhound stares in your direction.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104605,'Dreadhound growls.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104606,'Greetings brul.$b$bWant to look like a drogbar? Want to enter Bitestone Enclave unfindable by its people? Want to mess with the drogbar who stole Barbrul\'s personal recipes? Want to get Barbrul\'s recipes back?$b$bThen drink this special drog and become all that is brul!$b$bReturn to me if you need more. Oh, and watch out for basilisks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104607,'You hear something?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(104608,'Who goes there?','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(104609,'Keep your eyes peeled. They\'re close.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(104610,'Drog me, brul.','Drog me, brul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104611,'I smell an intruder.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104612,'Curses! Her crew is bigger than I thought. Ye may wanna slip past \'em.','',0,0,0,0,0,0,603,0,0,0,63669,0,26124),
(104613,'The Horizon\'s Edge is ours, lads... ain\'t she a beauty?','',0,0,0,0,0,0,0,0,0,0,63674,0,26124),
(104614,'Could be I neglected ta mention that the beach is crawlin\' with land mines. Keep yer eyes peeled!','',0,0,0,0,0,0,0,0,0,0,63670,0,26124),
(104615,'You are victorious... But that was only the first of many trials to come.','',0,0,0,0,0,0,0,0,0,0,57163,0,26124),
(104616,'Before you lies your next trial. Defeat both Hyrja and Fenryr and you will have proven your worth to me!','',0,0,0,0,0,0,0,0,0,0,57162,0,26124),
(104617,'How did you get past me crew?! Useless, the lot of ya!','',0,0,0,0,0,0,0,0,0,0,63659,0,26124),
(104618,'The rest of the Dread Fleet is on its way. What\'s yer plan, then?','',0,0,0,0,0,0,0,0,0,0,63660,0,26124),
(104619,'Is that the best you can do? Me deck swabbers fight better!','',0,0,0,0,0,0,0,0,0,0,63661,0,26124),
(104620,'The mighty Fenryr stalks these grounds. It will take cunning and guile to slay this beast - a perfect test of your worthiness.','',0,0,0,0,0,0,0,0,0,0,68701,0,26124),
(104621,'It will take cunning and guile to slay this beast - a perfect test of your worthiness','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104622,'Swab the decks till they shine, ya dirty bags of bones. The Dread Admiral demands perfection!','',0,0,0,0,0,0,22,0,0,0,63662,0,26124),
(104623,'Contaminating','Contaminating',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(104624,'You have earned my blessing, champions! I look forward to meeting you within the Hall of Glory!','',0,0,0,0,0,0,0,0,0,0,57161,0,26124),
(104626,'I suppose I owe you one, $n. I almost had my final death there.','',66,603,0,0,2,0,0,0,0,0,60303,0,26124),
(104627,'Foolish mortal! You walked right into my trap!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104628,'Foolish mortal! You walked right into my trap!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104629,'An eternity of torment awaits you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104630,'Throndyr!!! No!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104631,'I died a true warrior, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104632,'I will stand by Throndyr once more.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104633,'','You have been both a willing pawn and a thorn in my side, $n',0,0,0,0,0,0,0,0,0,37846,0,0,26124),
(104634,'','I should thank you for dispatching Calder and Eynar for me. I needed all of Janvik\'s potential leaders dead, but I could not let the village suspect that I was the cause of their demise.',0,0,0,0,0,0,0,0,0,37846,0,0,26124),
(104635,'','Without a leader to unite them, Jandvik would fall to the combined might of the sea giants and my naga in a tidal wave of death and destruction. My queen would have a prime foothold in Suramar.',0,0,0,0,0,0,0,0,0,37846,0,0,26124),
(104636,'','My plan was working, you irritating slime. My naga should have killed you and Brandolf\'s band of whelps. But no! You had the gall to survive!',0,0,0,0,0,0,0,0,0,37846,0,0,26124),
(104637,'We\'ll sail to Dalaran, it\'s a short voyage from here. I\'ll meet ya in the Hall of Shadows!','',0,0,0,0,0,0,0,0,0,0,63696,0,26124),
(104638,'','I am so glad that you followed me here, $n. I was afraid that you may have stumbled upon my plan.',0,0,0,0,0,0,0,0,0,37846,0,0,26124),
(104639,'What\'s going on here, Toryl?','What\'s going on here, Toryl?',0,0,0,0,0,0,0,0,0,37846,0,0,26124),
(104640,'Gnasher gonna turn you to rubble!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104641,'I wanted to get a look at you for a moment before we spoke. I apologize for the secrecy, old habits die hard. I am Alonsus Faol. At times I have been the leader of a church, a mindless minion of the Scourge, and a mastermind in a secret war. But I have always, first and foremost, been a priest.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104642,'Forgive the secrecy... old habits die hard. I am Alonsus Faol. At times I have been a leader of a church, a mindless minion of the Scourge, and a commander in a secret war. But I have always been a priest first.','',0,0,0,0,0,0,1,0,0,0,63426,0,26124),
(104643,'The Legion poses a threat that cannot be ignored. So I have decided to step out from the shadows. I believe we must unite priesthoods of all denominations against our common enemy.','',0,0,0,0,0,0,0,0,0,0,63427,0,26124),
(104644,'To lead this effort, we require a priest who is a proven champion to all people. I believe you are that hero, $n, but others must be convinced. Will you accept this challenge?','',0,0,0,0,0,0,0,0,0,0,63428,0,26124),
(104645,'Look! $n has returned!','',0,0,0,0,0,0,1,0,0,0,63405,0,26124),
(104646,'','This champion shows talent!',0,0,0,0,0,0,1,0,0,0,0,63406,26124),
(104647,'Well done indeed!','',0,0,0,0,0,0,1,0,0,0,63407,0,26124),
(104648,'We\'re offering you a seat at our table, $p. Take it, and your questions will be answered. You have but to sit.','',0,0,0,0,0,0,0,0,0,0,63644,0,26124),
(104649,'With that we are in agreement. Now, speak with Velen. He has an... interesting matter to discuss with you.','',0,0,0,0,0,0,1,0,0,0,63400,0,26124),
(104650,'Stay back, $c! I may be wounded, but the Light will protect me!','',0,0,0,0,0,0,0,0,0,0,60239,0,26124),
(104651,'What? Have you not come to finish what the Dark Riders started?','',0,0,0,0,0,0,0,0,0,0,60240,0,26124),
(104652,'Enough! Stay your weapon!','',0,0,0,0,0,0,0,0,0,0,60236,0,26124),
(104653,'The Riders will be upon us soon enough, and nothing is gained if we both die here!','',0,0,0,0,0,0,0,0,0,0,60237,0,26124),
(104654,'Help me hunt them down, and I will tell you what I know.','',0,0,0,0,0,0,0,0,0,0,60238,0,26124),
(104655,'Who challenges my right to lead Jandvik? None can defeat me in battle!','',0,0,0,0,0,0,0,0,0,37994,0,0,26124),
(104656,'By my ancestors! I will be the next jarl of Jandvik! No outsider will stand in my way!','',0,0,0,0,0,0,0,0,0,37994,0,0,26124),
(104657,'Vrykul dogs, get over here and fight or I\'ll kill you myself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104658,'','Silence. There is little time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104659,'That be a fine choice. C\'mere, I\'ll share the finer details of me plan over a mug or two!','',0,0,0,0,0,0,0,0,0,37869,63609,0,26124),
(104660,'','I will meet you outside Jandvik. Do not enter the village until we have spoken again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104661,'Let\'s head to Ariden\'s camp.','Let\'s head to Ariden\'s camp.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104662,'Brul, do you even lift?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104663,'Why are you so small, brul? You look like a ronir calf. Ha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104664,'What you looking at? Step off, brul.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104665,'The new underking will make us strong again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104666,'Do not worry brul! Soon our new underking will crush the weak ronir and their allies and your small, pitiful shape will not be needed to fight after that.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104667,'You should visit the mushroom merchant. He has some Giantstalk for you. Ha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104668,'You lost, brul? You look lost.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104669,'Heard some bruls say the Stonedark turned against us. Good! We are better off without those weaklings. They were small... and weak. And small.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104670,'Understand, I cannot be a part of what you must do. When you are finished, meet me outside Karazhan.','',0,0,0,0,0,0,1,0,0,0,61875,0,26124),
(104671,'I will visit the church and pray to the Light for mercy upon both our souls.','',0,0,0,0,0,0,1,0,0,0,61876,0,26124),
(104672,'','I warn you, my kin do not like outsiders. You would be wise to avoid unnecessary confrontation.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104673,'The mages have established a portal for us to use. If you would follow me, I would speak of the naaru and the draenei.','',0,0,0,0,0,0,0,0,0,0,63401,0,26124),
(104674,'Over the long years of the dranei\'s flight from the Burning Legion, the naaru helped us... sometimes at the cost of their very lives. We would have perished without their aid.','',0,0,0,0,0,0,0,0,0,0,63402,0,26124),
(104675,'At last we found a way to repay their kindness. We came upon a terrible sight, a naaru that had turned to the void. There had to be a way to save it!','',0,0,0,0,0,0,0,0,0,0,63403,0,26124),
(104676,'We built a prison to contain and study the fallen creature. A place to commune with the naaru and ponder the nature of the Twisting Nether. It is here that I would take you.','',0,0,0,0,0,0,0,0,0,0,63404,0,26124),
(104677,'Invaders! Crush them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104678,'Beaten... by a weakling... like you...','',0,0,0,0,0,0,0,0,0,37994,0,0,26124),
(104679,'I will see you... in Helheim...','',0,0,0,0,0,0,0,0,0,37994,0,0,26124),
(104680,'That\'s it! My fist, your face!','That\'s it! My fist, your face!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104681,'Who threw that?','Who threw that?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104682,'I was looking for a chance to brawl!','I was looking for a chance to brawl!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104684,'Research recipes using Lean Shanks.','Research recipes using Lean Shanks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104685,'','Must we do that in here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104686,'','An elite Legion squad appears from the portal!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(104687,'Didi sent me to retrieve a Prismatic Felslate Diamond.','Didi sent me to retrieve a Prismatic Felslate Diamond.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104688,'We\'ve been dealing with a great many cases where stolen goods are supposedly transported right around here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104689,'I don\'t suppose you\'ve seen any suspicious activity nearby that you might want to tell me about?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104690,'Ah. I see. Well, I\'m certainly glad that nothing questionable is going on here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104691,'Carry on.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104692,'','I suppose I can part with one. But tell Didi I\'m sending her a bill for it. We\'re not running a charity here.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104693,'You have proven to be a powerful priest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104694,'Where are we going?','Where are we going?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104695,'It is good to be back among the ancient trees of the Moonglade, even if only for a brief respite.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104699,'Hear! Hear! I\'d like to propose a toast.','',0,0,0,0,0,0,396,0,0,0,63616,0,26124),
(104703,'Today, $p secured the legendary Dreadblades, and in doing so has enabled us to strike at the Legion directly.','',0,0,0,0,0,0,396,0,0,39788,63618,0,26124),
(104708,'Research recipes using Wildfowl Eggs.','Research recipes using Wildfowl Eggs.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104709,'Research recipes using Big Gamy Ribs.','Research recipes using Big Gamy Ribs.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104710,'Research recipes using Fatty Bearsteaks.','Research recipes using Fatty Bearsteaks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104711,'Research recipes using Leyblood.','Research recipes using Leyblood.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104712,'Research recipes using Cursed Queenfish.','Research recipes using Cursed Queenfish.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104713,'Research recipes using Mossgill Perch.','Research recipes using Mossgill Perch.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104714,'Research recipes using Highmountain Salmon.','Research recipes using Highmountain Salmon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104715,'Research recipes using Stormrays.','Research recipes using Stormrays.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104716,'Research recipes using Runescale Koi.','Research recipes using Runescale Koi.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104717,'Research recipes using Black Barracuda.','Research recipes using Black Barracuda.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104718,'Research recipes using Slabs of Bacon.','Research recipes using Slabs of Bacon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104719,'The Lich King said my partner would be one of the mightiest knights ever known. I assume he was speaking of you? I\'ll rely upon your skills to get us through this in one piece.','',0,0,0,0,0,0,0,0,0,0,60309,0,26124),
(104720,'Let\'s get going. Felguard roam the path ahead. I\'ve kept my distance from them, but with you leading the way, we can fight through.','',0,0,0,0,0,0,0,0,0,0,60315,0,26124),
(104721,'This... you are certain this came from the Defiler himself?','',6,0,0,0,0,0,6,0,0,0,0,0,26124),
(104722,'I have encountered this power once before, within the depths of the Emerald Dream, near an abyss known as the Rift of Aln.','',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(104723,'That place radiated an ancient evil with such intensity that we dared not venture closer.','',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(104724,'It was all we could do to attempt to seal the taint away from the rest of the Dream. But it appears that we failed.','',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(104725,'And now, to find a fragment of that power in the hands of the Legion? A terrible portent....','',5,0,0,0,0,0,5,0,0,0,0,0,26124),
(104726,'I must return to the place of my tutelage, the primal groves of Val\'sharah, to seek guidance.','',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(104727,'By giving us warning of this danger, you may have saved us all. Please speak with Keeper Remulos before you depart.','',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(104728,'Here\'s the diamond you requested.','Here\'s the diamond you requested.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104729,'Here\'s the potion you requested.','Here\'s the potion you requested.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104730,'Here\'s the core you requested.','Here\'s the core you requested.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104731,'Didi sent me to retrieve a Volatile Leytorrent Potion.','Didi sent me to retrieve a Volatile Leytorrent Potion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104732,'Would you happen to have a Fel-infused Core?','Would you happen to have a Fel-infused Core?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104733,'I am ready for my induction.','I am ready for my induction.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104734,'Ah yes, I have one right here. Now be VERY careful with that. Spilling a drop of it can result in, well, unfortunate results.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104735,'','I will slay them in his honor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104736,'This is $n. We have fought together and discovered that Throndyr has been slain by these serpents.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104737,'','Smart choice.',0,0,0,0,0,0,1,0,0,0,0,63645,26124),
(104738,'No! The blade must remain buried!','',0,0,0,0,0,0,0,0,0,0,61877,0,26124),
(104739,'You cannot have it!','',0,0,0,0,0,0,53,0,0,0,61878,0,26124),
(104740,'Ariden... no! Why did you unearth that cursed blade?','',0,0,0,0,0,0,6,0,0,0,61879,0,26124),
(104741,'It must be retrieved. He cannot control the unbridled wrath within.','',0,0,0,0,0,0,5,0,0,0,61880,0,26124),
(104742,'We will fight to avenge him!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104743,'Go to the catacombs. The curse must be lifted!','',0,0,0,0,0,0,25,0,0,0,61881,0,26124),
(104744,'You will make Throndyr proud. Fight on, brother!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104745,'Throndyr has fallen in battle. We seek to avenge his death.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104746,'Throndyr is dead. I was not able to find him in time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104747,'Saved at last!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(104748,'I\'m free! I\'m free!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104749,'I\'m not staying here any longer!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104750,'I\'m getting out of here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104751,'Thank you! I... I will try to escape.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104752,'A thousand thanks to you my friend!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104753,'Mana... I need mana! The Nightwell... no... no! Take me back!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104754,'Thirsty... I must find arcwine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104755,'Settle in, then we can discuss the details.','',0,0,0,0,0,0,1,0,0,0,63651,0,26124),
(104756,'','Good to have a new face at the table! I was getting tired of Tethys\'s ugly mug... No offense, Tethys.',0,0,0,0,0,0,397,0,0,0,0,63652,26124),
(104757,'We are the Shadows, leaders of the Uncrowned.','',0,0,0,0,0,0,1,0,0,0,63646,0,26124),
(104758,'Not the least of these methods is secrecy. As our titles suggest, we prefer to stay in the shadows.','',0,0,0,0,0,0,1,0,0,0,63648,0,26124),
(104759,'The sewer entrance is this way. Follow me!','',0,0,0,0,0,0,0,0,0,0,61882,0,26124),
(104760,'We invite you to this table because we are confident you have the skills it takes to face this threat directly... and to prevail.','',0,0,0,0,0,0,1,0,0,0,63650,0,26124),
(104761,'$ct, Li Li should be at the Laughing Crane. That\'s the village inn just down the stairs from the temple.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104762,'If you want the blade, death knight, come and claim it!','',0,0,0,0,0,0,0,0,0,0,60299,0,26124),
(104763,'This magic is too strong for me to resist, but you may be able to cross it with your abilities, death knight.','',0,0,0,0,0,0,1,0,0,0,60293,0,26124),
(104764,'Very well! If you so thirst for the power of Apocalypse, then I will show it to you myself!','',0,0,0,0,0,0,5,0,0,0,60241,0,26124),
(104765,'Feel the wrath of the world-ender!','',0,0,0,0,0,0,15,0,0,0,60264,0,26124),
(104766,'No! The power... is mine!','',0,0,0,0,0,0,0,0,0,0,60274,0,26124),
(104767,'The power was not yours, Ariden. You did not wield Apocalypse. Its dark energies wielded you as its weapon.','',0,0,0,0,0,0,1,0,0,0,60242,0,26124),
(104768,'That voice... father?!','',0,0,0,0,0,0,0,0,0,0,60267,0,26124),
(104769,'Rest now, my son. The curse is lifted.','',0,0,0,0,0,0,1,0,0,0,60276,0,26124),
(104770,'You are free.','',0,0,0,0,0,0,1,0,0,0,60277,0,26124),
(104771,'A large, radiant ruby set upon a pillow.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104772,'Try to take the jewel.','Try to take the jewel.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104773,'It is done! You have done a great service for Pandaria this day.','',0,0,0,0,0,0,5,0,0,0,61957,0,26124),
(104774,'There it is, the staff of our last emperor. You have proven yourself worthy to wield it, friend of the Shado-Pan.','',0,0,0,0,0,0,25,0,0,0,61958,0,26124),
(104775,'Ten thousand years ago, Emperor Shaohao used that very staff to cloak our land in a veil of mists, hiding us from the Burning Legion.','',0,0,0,0,0,0,1,0,0,0,61959,0,26124),
(104776,'But this time, the Pandaren will not hide away. We chose to FIGHT!','',0,0,0,0,0,0,5,0,0,0,61960,0,26124),
(104777,'Turn the emperor\'s staff against the Legion, champion. We will be right behind you.','',0,0,0,0,0,0,1,0,0,0,61961,0,26124),
(104778,'Can the Junior Seafarers have guns?','Can the Junior Seafarers have guns?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104779,'','Excuse me, but that\'s my jewel. Could you please leave it alone?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104780,'<Saurfang looks you up and down with narrowed eyes.>$b$bWhen Khadgar claimed we would be seeing demon hunters today, I laughed in his face. When he said I should hear you out, I laughed louder.$b$bAnd yet, here you are.$b$bI will permit you alone to enter the Hold. You will leave your weapons and companions at the door. You will not speak until spoken to.$b$BOne false move and my axe will end you.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(104781,'','Oh, well then I\'ll be right down. Coming!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104782,'No, the Junior Seafarers can share a gun.','No, the Junior Seafarers can share a gun.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104783,'','Hello, was someone looking for me?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104784,'','I wonder where they went to. Oh well, perhaps they\'ll come back.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104785,'Thank you, my friend! May the White Tiger bless your campaign against our foes!','',0,0,0,0,0,0,3,0,0,0,61962,0,26124),
(104786,'Here\'s the jewel, now give me the core.','Here\'s the jewel, now give me the core.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104787,'Yea, I got what you\'re looking for. But I ain\'t just gonna hand it over. I need something in return.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104788,'There\'s this lovely, red jewel upstairs that caught my eye. Get it for me and I\'ll trade you the core for it.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104789,'Nice doing business with you, friend.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104790,'','Did you know that I was favored to become the final Shadow? Yet despite their assurances, every single one of them put their lot in with you instead!',0,0,0,0,0,0,6,0,0,0,0,63627,26124),
(104791,'','Let\'s see how long you last.',0,0,0,0,0,0,0,0,0,0,0,63634,26124),
(104792,'','It\'s a pity, really. Jorach did so much for me. He won\'t be happy when he comes to and finds you dead.',0,0,0,0,0,0,1,0,0,0,0,63628,26124),
(104793,'Catriona, I heard someone was looking for you downstairs.','Catriona, I heard someone was looking for you downstairs.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104794,'Excuse me! Hello?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104795,'','It\'s nothing personal. This is purely business.',0,0,0,0,0,0,0,0,0,0,0,63635,26124),
(104796,'|TInterface\\Icons\\ability_fixated_state_red:20|tA Blitering Beetle is |cFFFF0000|Hspell:202480|h[Fixated]|h|r on you!','|TInterface\\Icons\\ability_fixated_state_red:20|tA Blitering Beetle is |cFFFF0000|Hspell:202480|h[Fixated]|h|r on you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(104797,'','Did you really think I had died in the Deadmines? My elixir brought me just close enough to death to fool your weakened mind.',0,0,0,0,0,0,1,0,0,37981,0,63625,26124),
(104798,'','Stop! Stop! No more!',0,0,0,0,0,0,0,0,0,0,0,63638,26124),
(104799,'','Perhaps the others were right.',0,0,0,0,0,0,0,0,0,0,0,63639,26124),
(104800,'','They say I died in the Deadmines. Fools! It\'s all too simple to mimic the effects of death when your assailants\' minds are addled with neurotoxins.',0,0,0,0,0,0,1,0,0,37983,0,63626,26124),
(104801,'It\'s over. The deed is done.','',0,0,0,0,0,0,1,0,0,0,60252,0,26124),
(104802,'Take your weapon, $c. I must return the other artifacts to their rightful owners.','',0,0,0,0,0,0,1,0,0,0,60254,0,26124),
(104803,'I hope, for both our sakes, that we do not meet again.','',0,0,0,0,0,0,1,0,0,0,60257,0,26124),
(104804,'','Let me just insert this into the core and we\'ll see what happens.',0,0,0,0,0,0,69,0,0,0,0,0,26124),
(104805,'','Flashy, but ineffective. We\'ll have to try something else. Maybe we need a chemical reaction.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104806,'','Go to the alchemy shop and ask Deucus for a potion with some punch in it.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104807,'','Alright, I\'m going to pour in the solution now. Watch yourself, not sure how this is going to react.',0,0,0,0,0,0,69,0,0,0,0,0,26124),
(104808,'','Are you alright? *Cough, cough* I\'m thinking the only thing that\'s going to work here is a fel-infused core.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104809,'','It\'s a long shot, but there may be someone here in Dalaran who has one. Try asking Bonegrim in the Ledgerdemain Lounge if he\'s come across any.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104810,'','You found something?! That\'s amazing! You\'re amazing, $n! Keep your fingers crossed, I\'m gonna put it in now.',0,0,0,0,0,0,69,0,0,0,0,0,26124),
(104811,'','Success!',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(104812,'Then it\'s settled. Congratulations, $p. VanCleef is one of our best, as you\'ve seen firsthand.','',0,0,0,0,0,0,1,0,0,0,63632,0,26124),
(104813,'I trust you will be true to your word, Vanessa. I\'d hate to imagine your father being disappointed in you.','',0,0,0,0,0,0,1,0,0,0,63633,0,26124),
(104814,'','$p, Tethys told me what transpired in Azsuna. You have impressed us.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104815,'','Vanessa\'s position in the Shadows is yours. Take a seat.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104816,'','Archivist, post a notice in the hall. $p is now a Shadow. Fear them as you fear us all.',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(104817,'','You are the demon hunters who escaped the Vault of the Wardens?$B$BYou draw your very power from those who seek to destroy our world. Tell me, why should I possibly trust you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104818,'We gave everything to fight the demons, to use their own powers against them. Let us serve the Horde.','We gave everything to fight the demons, to use their own powers against them. Let us serve the Horde.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104819,'You have my thanks.','',0,0,0,0,0,0,0,0,0,0,60594,0,26124),
(104820,'','Whew! That feels much better! Let me at \'em!',0,0,0,0,0,0,0,0,0,0,0,60595,26124),
(104821,'Storm, earth, and fire! Heed my call!','',0,0,0,0,0,0,0,0,0,0,60592,0,26124),
(104822,'VanCleef, the Uncrowned still have a use for you. You have a choice... live and serve as $p\'s agent... or die where you stand.','',0,0,0,0,0,0,1,0,0,0,63630,0,26124),
(104823,'','Shockingly, I\'d prefer to live.',0,0,0,0,0,0,0,0,0,0,0,63631,26124),
(104824,'','Jandvik is doomed.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104825,'','Those two idiots cannot lead Jandvik.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104826,'','I must be the one to lead Jandvik.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104827,'That won\'t hold them long. We must get to the library!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104828,'Die outsider!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104829,'I will crush you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104830,'$R are not welcome here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104831,'Val\'kyr take me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104832,'By my ancestors!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104833,'Glorious death!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104834,'','Die outsider!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104835,'','I will cast you down!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104836,'','You are not welcome here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104837,'','Val\'kyr take me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104838,'','By my ancestors!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104839,'','Glorious death!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104840,'','King Varian overcame so many trials. We should all learn from his example.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104841,'I\'m proud to have fought beside him. Varian was a good man.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104842,'We have lost, and now must find balance, despite our shared grief.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104843,'','He led with grace and courage. We were fortunate to have an ally like King Varian.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104844,'The Light has lost a powerful ally. I have lost a good friend. Yet we must carry on.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104845,'<sobbing> Varian... Old friend...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104846,'','I know what the lad is going through. I too have lost a father... and a king.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104847,'Listen... can you hear it? The skies weep and thunder for King Varian.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104848,'What\'s this? A little $r has come to challenge me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104849,'Jandvik will fall to the Sashj\'tar!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104850,'Come find me in Dalaran! We can share recipes.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(104851,'No! I don\'t want to come back!','No! I don\'t want to come back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104852,'You will share in our curse!','You will share in our curse!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104853,'You will pay for this desecration!','You will pay for this desecration!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104854,'Why would you bring me back here?!','Why would you bring me back here?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104855,'Join me in the grave!','Join me in the grave!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104856,'','Are you ready to EXPLODE?',0,0,0,0,0,0,0,0,0,0,0,57470,26124),
(104857,'','Here comes the heat!',0,0,0,0,0,0,0,0,0,0,0,57468,26124),
(104858,'Research recipes using Silver Mackerel.','Research recipes using Silver Mackerel.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104859,'The artifact belongs to Karazhan, $c!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104860,'We will take what is ours!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104861,'The artifact calls to us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104862,'None will be spared!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104868,'Now, let\'s try filleting them lengthwise first...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104870,'Interesting! If I remove the bones after drying, I lose less of the meat...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104871,'Perhaps this would work better if I were holding a beer...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104873,'Perfect! I have a new recipe for you, $p.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104874,'Watch out for basilisks. They can see through this.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(104875,'You can look at my helmet, $n, but you dare not touch it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104876,'','Watch out! Demons walk among us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104877,'Greetings, Master $n. What are we cooking today?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104878,'Two-way connection established. Use it freely - the distance is short, so it requires very little power.','',0,0,0,0,0,0,0,0,0,0,67473,0,26124),
(104879,'Survey complete. Now place the beacon!','',0,0,0,0,0,0,0,0,0,0,67472,0,26124),
(104880,'I should mention... the survey may reveal a few tele-spatial anomalies. Maybe a warptime ripple or two...','',0,0,0,0,0,0,0,0,0,0,67470,0,26124),
(104881,'','$n! I\'m pleased you have returned. Finding Thas\'dorah was only the beginning!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104882,'Bring me more ingredients, Master $n. Meat, fish, blood... whatever you can find out there in the scary outdoors. I will help you turn them into delicious dishes!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104883,'Pandaren write so boring! Wisdom, wisdom, wisdom - not \'nuff dookin\'.','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(104884,'Can you fly me to the Terrace of Endless Spring?','Can you fly me to the Terrace of Eternal Spring?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104885,'Additional summoners are required to complete the ritual.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104886,'','Remember, you can use the new teleporter to reach the surface quickly. Anora Hollow is somewhere north of here.',0,0,0,0,0,0,0,0,0,0,0,67483,26124),
(104887,'','I need a bit of time to recover and... contemplate. We will speak again soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104888,'Whoa, whoa, whoa. Is that the new Shadow I see walkin\' into my vault? Un-freakin\'-believable!','',0,0,0,0,0,0,0,0,0,0,63643,0,26124),
(104889,'Be careful with that thing next time, will ya? Dragon-powered magical forges ain\'t easy to come by.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104890,'All\'s fair in love and business.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(104891,'Here\'s 100 gold. Fair?','Here\'s 100 gold. Fair?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104892,'Are you sure?','Are you sure?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104893,'<Hold a weapon to Marin\'s throat.> How\'s this for business?','<Hold a weapon to Marin\'s throat.> How\'s this for business?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104894,'That\'ll do just fine. Thank you kindly!','',0,0,0,0,0,0,0,0,0,0,63640,0,26124),
(104895,'Hey, hey, hey. I don\'t want no trouble. Go right ahead, geez!','',0,0,0,0,0,0,0,0,0,0,63641,0,26124),
(104896,'Aww! Come on, you didn\'t have to take them just yet. Let\'s get outta here Shoob.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104897,'This is Jandvik! You are not welcome here!','',0,0,0,0,0,0,0,0,0,37994,0,0,26124),
(104898,'A puny outsider challenges me?','',0,0,0,0,0,0,0,0,0,37994,0,0,26124),
(104899,'Jandvik\'s jarl lies dead before me! Now you shall join him!','',0,0,0,0,0,0,0,0,0,38033,0,0,26124),
(104900,'Jandvik is leaderless! It will crumble before the Sashj\'tar!','',0,0,0,0,0,0,0,0,0,38033,0,0,26124),
(104901,'Right rerind roo, Racky!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104902,'Behold Saraka, Destroyer of Worlds! Brought to heel after millennia of wanton destruction.','',0,0,0,0,0,0,1,0,4,0,63412,0,26124),
(104903,'','Hey, those are mine! You won\'t get away with this, $gmister:lady;!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104904,'The draenei sought to devise a ritual that could turn the naaru back to the Light. To aid their quest, I called together many priesthoods to work in unison.','',0,0,0,0,0,0,1,0,4,0,63413,0,26124),
(104905,'We are close to success. I believe the weapon you obtained will tip the scales in our favor. If you would step into the main circle, we can begin the ritual!','',0,0,0,0,0,0,0,0,4,0,63414,0,26124),
(104906,'Yes! Use the blade to draw out the Void energy!','',0,0,0,0,0,0,0,0,4,0,63415,0,26124),
(104907,'Taking a kid\'s fireworks? That\'s pretty messed up. Mark my words, you\'ll regret it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104908,'Yes! Fill it with healing Light!','',0,0,0,0,0,0,0,0,4,0,63416,0,26124),
(104909,'Yes! Purge it with holy fire!','',0,0,0,0,0,0,0,0,4,0,63417,0,26124),
(104910,'','My beautiful fireworks! I\'m going to tell on you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104911,'Oh hey, while you\'re there, could you let Nikki know she has three days left to pay up? I\'m not running a charity over here!','',0,0,0,0,0,0,0,0,0,0,63642,0,26124),
(104912,'The sanctum of the Dark Riders is hidden even to my sight, though many in Duskwood have given their lives to unearth it.','',0,0,0,0,0,0,0,0,0,0,60234,0,26124),
(104913,'I sense one such presence in Manor Mistmantle... a man strong in the Light. If he could be bent to your will, he may prove to be the key you require.','',0,0,0,0,0,0,0,0,0,0,60235,0,26124),
(104914,'I will not fall!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104915,'You will not best me, serpent!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104916,'','Take your time. Nothing wrong with mulling over a big decision.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104917,'You cannot stop me, serpent!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104918,'','Watch your back out there! The world sure ain\'t getting any safer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104919,'For Throndyr!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104920,'For Jandvik!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104921,'I will slay you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104922,'Let us slay these serpents, $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104923,'Fight for Jandvik, $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104924,'Share my strength, $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104925,'I can sense the power of the world-ender within you, $n. You are prepared for the war to come.','',0,0,0,0,0,0,0,0,0,0,61870,0,26124),
(104926,'Join me at the Frozen Throne. I would meet my new champion face to face.','',0,0,0,0,0,0,0,0,0,0,61871,0,26124),
(104927,'Katarine! Let us get you out of that cage!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104928,'Fjolrik, you old man. Get up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104929,'Open you eyes, Stokalfr. We are not serpents!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104931,'Okie-dook. Back to Pandaria. This place smell like turtle anyways.','',0,0,0,0,0,0,1,0,0,0,61947,0,26124),
(104932,'Pandaria lookin\' real bad. Ain\'t seen this much jerb-jabbin\' since dat big orc guy dooked up the Vale.','',0,0,0,0,0,0,1,0,0,0,61948,0,26124),
(104933,'','You need to return to the Hall of Shadows immediately. Don\'t keep me waiting.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104934,'','You can call for an extraction to get out of there more quickly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104935,'I need to fly to the Trueshot Lodge.','I need to fly to the Trueshot Lodge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104937,'Knights! Escape while you can! This demon is too strong to...','',0,0,0,0,0,0,0,0,0,0,60307,0,26124),
(104938,'What is this? More foolish mortals infesting my realm? You\'ve come a long way just to die.','',0,0,0,0,0,0,0,0,0,0,60305,0,26124),
(104939,'Silence, or I shall drain your blood next!','',0,0,0,0,0,0,0,0,0,0,60311,0,26124),
(104940,'','You there - we must speak at once.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104942,'Margrave led the previous team that tried to kill Gorelix. I\'m surprised he\'s alive! I didn\'t think the Legion kept prisoners.','',0,0,0,0,2,0,0,0,0,0,60320,0,26124),
(104944,'I am ready. Take me to this fish frenzy of yours.','I am ready. Take me to this fish frenzy of yours.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104945,'Ugh! Oh, my head...','Ugh! Oh, my head...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104946,'What just hit me!?','What just hit me!?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104947,'|TINTERFACE\\ICONS\\inv_misc_web_02.blp:20|t Naltira begins to cast |cFFF00000|Hspell:200227|h[Tangled Web]|h|r!','|TINTERFACE\\ICONS\\inv_misc_web_02.blp:20|t $n is being dragged into Naltira\'s |cFFF00000|Hspell:200227|h[Tangled Web]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104948,'What the...?! I guess that feels better.','What the...?! I guess that feels better.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104949,'Who throws a bandage at someone? Honestly?','Who throws a bandage at someone? Honestly?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104950,'Thanks for the heal!','Thanks for the heal!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104951,'I don\'t know what you just did... but I LIKE  it!','I don\'t know what you just did... but I LIKE  it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104952,'Oh you too late! Dem wob-gobblers done derked this place.','',0,0,0,0,0,0,1,0,0,0,61949,0,26124),
(104953,'I put you down here. Tak-Tak do what he do best... NOTHING!','',0,0,0,0,0,0,1,0,0,0,61950,0,26124),
(104954,'I need to get back to the Wandering Isle, \"your majesty.\"','I need to get back to the Wandering Isle, \"your majesty.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104955,'','I wait in the shadows.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104956,'Mrglglglggggl!','',0,0,0,0,0,0,0,0,0,0,8475,0,26124),
(104957,'Wookin\' Grook! You gots the Emperor\'s staff! Does that make you like the emperor now?$b$bThat makes me like the Monkey King.$b$b<Tak-Tak does a little dance.>','',0,0,0,0,0,0,94,0,0,0,0,0,26124),
(104958,'Back to turtle! Dis place too wet anyways.','',0,0,0,0,0,0,1,0,0,0,61951,0,26124),
(104959,'That\'s the spirit. I\'ll meet ya in Booty Bay!','',0,0,0,0,0,0,0,0,0,0,63657,0,26124),
(104960,'I will ssslay you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104961,'Sashj\'tar do not take prisonersss.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104962,'Ssslaughter and ssslay.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104963,'Jandvik will fall to the Sashj\'tar.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104964,'The Sashj\'tar will stand victoriousss.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104965,'The Tidemistress will stain Jandvik with vrykul blood.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104966,'','I will ssslay you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104967,'','Sashj\'tar do not take prisoners.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104968,'','Ssslaughter and ssslay.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104969,'','Jandvik will fall to the Sashj\'tar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104970,'','The Sashj\'tar will stand victoriousss.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104971,'','The Sashj\'tar will wash over Jandvik like the tide upon the ssshore.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104972,'','You should not have slithered here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104973,'','In the name of the Tidemistress, I will slay you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104974,'','You cannot stop us, $r.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104975,'','I have failed the Sashj\'tar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104976,'','This cannot be...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104977,'','Where I fall, more will rise...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104978,'I will skewer you like a fish!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104979,'Slither and slay!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104980,'Mal\'kess! Intruders!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104981,'Mal\'kess...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104982,'The Sashj\'tar will rise!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104983,'For the Sashj\'tar and our queen...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104984,'Squish you into slime!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104985,'Puny $r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104986,'I honor the Tidemistress.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104987,'You... useless... worm food...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104988,'I return to the sea...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104989,'Forgalash... I was not... strong enough...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104990,'Yes! It\'s working! Can you feel it?','',0,0,0,0,0,0,0,0,4,0,63418,0,26124),
(104991,'The hunger, the rage, they are gone. The Light has welcomed me home.','',0,0,0,0,0,0,0,0,4,0,63419,0,26124),
(104992,'','I kept this one alive as a precautionary measure, a prize for the sea giants. Now I will slay the lot of you.',0,0,0,0,0,0,0,0,0,37846,0,0,26124),
(104993,'Did you hear that? I think something\'s in that building up ahead. Let\'s investigate.','',0,0,0,0,0,0,0,0,0,0,60328,0,26124),
(104995,'You wanna fight? Do it in the pit. Brick don\'t make no money up here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104996,'Touch one of the glowing stones, make you feel light as a pebble. \n\nThen you just drop on in to the arena and hope no one\'s waiting for you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104997,'Touch one of the glowing stones, make you feel light as a pebble. \n\nThen you just drop on in to the arena and hope no one\'s waiting for you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104998,'Touch one of the glowing stones, make you feel light as a pebble. \n\nThen you just drop on in to the arena and hope no one\'s waiting for you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(104999,'How do I get down into the arena?','How do I get down into the arena?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105000,'Y-yes ma\'am!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105001,'','Rest easy. Our new Dream will remake your world...',0,0,0,0,0,0,0,0,0,0,0,58666,26124),
(105002,'','I dreamed the Dream. Now I wake...',0,0,0,0,0,0,0,0,0,0,0,58665,26124),
(105003,'','You seek the Dream? It seeks you, too.',0,0,0,0,0,0,0,0,0,0,0,58662,26124),
(105004,'','The Dream has changed. Yet I will protect it still.',0,0,0,0,0,0,0,0,0,0,0,58664,26124),
(105005,'','The Dream has always shown me truth and it showed me your deaths.',0,0,0,0,0,0,0,0,0,0,0,58663,26124),
(105007,'Well... if it isn\'t Margrave\'s protege, Dagnar.','',0,0,0,0,0,0,0,0,0,0,60332,0,26124),
(105008,'Well... if it isn\'t Margrave\'s protege, Minerva.','',0,0,0,0,0,0,0,0,0,0,60333,0,26124),
(105009,'Finding you strung up like this is a surprise. I would have expected a more... gory... end.','',0,0,0,0,0,0,661,0,0,0,60336,0,26124),
(105010,'My head\'s itchy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105011,'Shave Lowping\'s head.','Shave Lowping\'s head.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105012,'My head\'s cold.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105013,'Make a copy of the schematic.','Make a copy of the schematic.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105014,'<cough> Spare me yer gentle words, Sliver. I\'ve not had me final death yet.','',0,0,0,0,0,0,0,0,0,0,60304,0,26124),
(105015,'The Beacon calls to bring forth light, we will answer in your time of need.','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(105016,'','<cough> Spare me your paltry words, Sliver. I\'ve not taken my final breath yet!',0,0,0,0,0,0,0,0,0,0,0,60308,26124),
(105018,'Learned a long time ago that fighting in the pit makes me a lot more money than fighting outside the pit. \n\nYou\'re not gonna find one of my bruls getting in fights I don\'t know about.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105019,'Once again you have proven your worth, my friend. With the aid of Saa\'ra and the power of your weapon behind you, there is no one more capable!','',0,0,0,0,0,0,0,0,4,0,63421,0,26124),
(105020,'Gilbert\'s been in that hut a while now...','Gilbert\'s been in that hut a while now...',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(105021,'I\'m sure if he needed help we\'d have heard the screams.','I\'m sure if he needed help we\'d have heard the screams.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(105022,'Priesthoods from all over Azeroth have agreed to donate time and resources to this new Conclave. We have a singular purpose: the defeat of the Burning Legion!','',0,0,0,0,0,0,0,0,4,0,63422,0,26124),
(105023,'I hereby bring the Conclave to order! Together we will bring hope and healing to our allies, and banish our foes into the void!','',0,0,0,0,0,0,0,0,4,0,63423,0,26124),
(105024,'No fighting outside of the pit!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105025,'Now, champion, we shall transform this prison into a temple that will serve as the headquarters of our campaign. This shouldn\'t take long...','',0,0,0,0,0,0,0,0,4,0,63424,0,26124),
(105026,'These bloody demons are gonna learn a new meaning of suffering when I get free! A beast called Zalinor carries the keystone that unlocks these bindings. Free me and I\'ll help ye slay the bastards!','',0,0,0,0,0,0,0,0,0,0,60310,0,26124),
(105027,'Over here! I think you will approve of the changes we\'ve made!','',0,0,0,0,0,0,22,0,0,0,63425,0,26124),
(105028,'','The Unseen Path was founded after the War of the Ancients to safeguard the people of Azeroth. From these Broken Isles, we watched for the Legion\'s return.',0,0,0,0,0,0,0,0,0,0,0,61857,26124),
(105029,'','As we arrived here to build the Trueshot Lodge, the eagle spirit, Ohn\'ahra, appeared and gave her blessing. From that day forth, we called this mountain Talon Peak.',0,0,0,0,0,0,0,0,0,0,0,61858,26124),
(105030,'When the elves who founded the Unseen Path left Mount Hyjal to return to the Broken Isles, the Highmountain tauren recognized the nobility of their cause and offered them friendship. It was the descendants of Huln Highmountain who led the Unseen Path to this peak.$b$bSince the Legion\'s return, the Highmountain have helped restore the lodge, such as replacing two damaged watch towers with tauren structures.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105031,'Mrrglrrgl! Mgrlrgrrr!','',0,0,0,0,0,0,51,0,0,0,0,0,26124),
(105032,'','Over the centuries, most of my fellow watchers have been lost. The few of us remaining sought out heroes worthy to heed the call when the Unseen Path was needed once again.',0,0,0,0,0,0,0,0,0,0,0,61859,26124),
(105037,'Fight\'s down below. Touch the crystal and dive on in, if you\'re tough enough.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105038,'Fighting pit\'s open. Touch the crystal and dive on in, if you\'re tough enough.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105039,'Fighting pit\'s open. Touch the crystal and dive on in, if you\'re tough enough.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105041,'','Please walk with me, $n.',0,0,0,0,0,0,0,0,0,0,0,61856,26124),
(105042,'','These cursed demons are going to learn a new meaning of suffering when I get free! A beast called Zalinor carries the keystone that unlocks these bindings. Set me free and I\'ll help you rip the bastards apart!',0,0,0,0,0,0,0,0,0,0,0,60314,26124),
(105043,'No fighting outside of the pit!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105044,'No fighting outside of the pit! Derp.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105045,'No fighting outside of the pit! Derp. Derp.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105046,'Do you really think Gilbert can handle a bear all by himself?','Do you really think Gilbert can handle a bear all by himself?',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(105047,'If he can\'t, more treasure for us!','If he can\'t, more treasure for us!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(105048,'So many eyes that cannot see.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105049,'I will smash you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105050,'We will rebuild our weapons. You cannot stop us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105051,'Jandvik will pay for this destruction.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105052,'My duty is over.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105053,'Overseer! Come!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105054,'Curse you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105055,'We\'ll make a fortune from these pelts!','We\'ll make a fortune from these pelts!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(105056,'I smash you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105057,'Who\'s going to buy them? They\'re about as soft as your mother\'s beard!','Who\'s going to buy them? They\'re about as soft as your mother\'s beard!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(105058,'You die now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105059,'Do you ever feel bad doing what we do?','Do you ever feel bad doing what we do?',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(105060,'Sashj\'tar destroy you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105061,'I don\'t have time for feelings.','I don\'t have time for feelings.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(105062,'Tidemistress...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105063,'Maybe we should let the cubs go. I won\'t tell Brodrick if you won\'t...','Maybe we should let the cubs go. I won\'t tell Brodrick if you won\'t...',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(105064,'Cold sand...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105065,'Keep talking like that and I\'ll put you in a cage!','Keep talking like that and I\'ll put you in a cage!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(105066,'Little weakling...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105067,'You know, synthetic fur would be less cruel, not to mention more comfortable.','You know, synthetic fur would be less cruel, not to mention more comfortable.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(105068,'If you can\'t use small words, then keep your mouth shut!','If you can\'t use small words, then keep your mouth shut!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(105069,'Do you ever wonder what Brodrick does with the bear cubs we catch?','Do you ever wonder what Brodrick does with the bear cubs we catch?',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(105070,'Brodrick doesn\'t pay us to wonder.','Brodrick doesn\'t pay us to wonder.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(105071,'This job really zaps my energy. My legs hurt. My shoulders hurt. Even my heart aches a little...','This job really zaps my energy. My legs hurt. My shoulders hurt. Even my heart aches a little...',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(105072,'Being partnered with you, my ears hurt more than anything.','Being partnered with you, my ears hurt more than anything.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(105073,'Give me the crystal.','Give me the crystal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105074,'I have stolen a gem of power from one of the Underking\'s lackies.$b$bUse this gem and you will have a crystal fury at your command.$b$bI ask that you use it to recover more crystals from within the Crystal Fissure. With those crystals, I and my tribe can better aid Thunder Totem in its... whatever it does.$b$bDo we have a deal?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105078,'I suppose you\'ll be more useful to us alive. Very well, let\'s be swift about this.','',0,0,0,0,0,0,0,0,0,0,60339,0,26124),
(105079,'Finally the keystone is ours! Let\'s head back.','',0,0,0,0,0,0,0,0,0,0,60342,0,26124),
(105082,'Ah! That\'s much better!','',0,0,0,0,0,0,4,0,0,0,60316,0,26124),
(105083,'Listen! We don\'t have much time. They took Margrave to the citadel. We\'re gonna have to break in there to get \'im out!','',0,0,0,0,0,0,603,0,0,0,60321,0,26124),
(105084,'Eliminate... all... life...','',0,0,0,0,0,0,463,0,0,0,0,0,26124),
(105085,'The ritual is interrupted and a dark energy amasses!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105086,'Good work! Now demonstrate your skill against two foes at the same time.','',0,0,0,0,0,0,21,0,0,0,58006,0,26124),
(105087,'You learned well! Next we will see... Hold on, is that...? To arms! The Legion is attacking!','',0,0,0,0,0,0,1,0,0,0,58007,0,26124),
(105088,'An infernal! Use all your training to defeat it!','',0,0,0,0,0,0,0,0,0,0,58008,0,26124),
(105089,'','Ah! That\'s much better!',0,0,0,0,0,0,4,0,0,0,0,60318,26124),
(105090,'','We don\'t have much time! Margrave was taken to the citadel. The only things I\'ve seen come out of that place are demons and corpses! We\'ll need to break in there to get him out.',0,0,0,0,0,0,603,0,0,0,0,60323,26124),
(105110,'','Quickly, finish the summons.',0,0,0,0,0,0,0,0,0,0,0,56966,26124),
(105111,'','The Legion\'s will be done.',0,0,0,0,0,0,0,0,0,0,0,56967,26124),
(105112,'','Kill the Illidari.',0,0,0,0,0,0,0,0,0,0,0,56968,26124),
(105113,'','For the Brood Queen.',0,0,0,0,0,0,0,0,0,0,0,56969,26124),
(105114,'','Your world will be purged!',0,0,0,0,0,0,0,0,0,0,0,56970,26124),
(105115,'','Our ritual is interrupted.',0,0,0,0,0,0,0,0,0,0,0,56971,26124),
(105116,'','Defend the portal.',0,0,0,0,0,0,0,0,0,0,0,56972,26124),
(105117,'','In Sargeras\'s name.',0,0,0,0,0,0,0,0,0,0,0,56973,26124),
(105118,'','Your soul will be ours.',0,0,0,0,0,0,0,0,0,0,0,56977,26124),
(105119,'','Kill them before they get up to the Fel Hammer.',0,0,0,0,0,0,0,0,0,0,0,56978,26124),
(105120,'','Defend the Soul Engine.',0,0,0,0,0,0,0,0,0,0,0,56979,26124),
(105121,'','How can they see us?',0,0,0,0,0,0,0,0,0,0,0,56974,26124),
(105122,'','They have the spectral sight!',0,0,0,0,0,0,0,0,0,0,0,56975,26124),
(105123,'','Finish them. Recast the cloaking spell.',0,0,0,0,0,0,0,0,0,0,0,56976,26124),
(105124,'','Your death will be swift and unmerciful.',0,0,0,0,0,0,0,0,0,0,0,56980,26124),
(105125,'','Wither before my might!',0,0,0,0,0,0,0,0,0,0,0,56981,26124),
(105126,'','You dare?!',0,0,0,0,0,0,0,0,0,0,0,56982,26124),
(105127,'','I am of Argus, the mightiest world in all of the Great Dark.',0,0,0,0,0,0,0,0,0,0,0,56983,26124),
(105128,'','Here\'s a small taste of my fel magic.',0,0,0,0,0,0,0,0,0,0,0,56984,26124),
(105129,'Begone, fiends!','',0,0,0,0,0,0,0,0,0,0,65693,0,26124),
(105130,'For Suramar! For Elisande!','',0,0,0,0,0,0,0,0,0,0,65699,0,26124),
(105131,'We must hold them here!','',0,0,0,0,0,0,0,0,0,0,65694,0,26124),
(105132,'The defenses are breached...','',0,0,0,0,0,0,0,0,0,0,65695,0,26124),
(105133,'I have failed...','',0,0,0,0,0,0,0,0,0,0,65700,0,26124),
(105134,'I cannot be stopped!','',0,0,0,0,0,0,0,0,0,0,65696,0,26124),
(105137,'Mrgl glrlrglgrr!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105138,'Mrrr grmrgl mrgl!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105139,'','Some of you will be food, some will be thralls, but all of you will die.',0,0,0,0,0,0,0,0,0,0,0,57574,26124),
(105140,'','Submit to the thirst.',0,0,0,0,0,0,0,0,0,0,0,57575,26124),
(105141,'','Now your will is mine!',0,0,0,0,0,0,0,0,0,0,0,57576,26124),
(105142,'','None can resist the thirst!',0,0,0,0,0,0,0,0,0,0,0,57577,26124),
(105143,'','The hunger never ends...',0,0,0,0,0,0,0,0,0,0,0,57578,26124),
(105144,'The altar is complete, Betild.','',0,0,0,0,0,0,0,0,4,0,63410,0,26124),
(105145,'','Yer a miracle worker, Saa\'ra. It came out better than I designed it!',0,0,0,0,0,0,0,0,0,0,0,63411,26124),
(105146,'','We are the watchers in the wild.',0,0,0,0,0,0,1,0,0,0,0,61850,26124),
(105147,'','We are the eagle on the wind.',0,0,0,0,0,0,1,0,0,0,0,61851,26124),
(105148,'','We walk the lonely road...',0,0,0,0,0,0,1,0,0,0,0,61852,26124),
(105149,'','For ours is the Unseen Path.',0,0,0,0,0,0,1,0,0,0,0,61853,26124),
(105150,'Helya has different plans for you, dog.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105151,'Bones suit you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105152,'','I thank you for my freedom, $n.$b$bUnfortunately, the soul harvester has taken much of my strength. I will regain the full extent of my powers shortly.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(105153,'I\'d like to introduce you to Calia Menethil... yes, that Menethil. She has been a great help these past few years. I\'d like her to assist you, helping the helpless, conveying your word to the world, all that.','',0,0,0,0,0,0,1,0,0,0,63409,0,26124),
(105154,'','$p! You\'re alive!',0,0,0,0,0,0,0,0,0,0,0,64685,26124),
(105155,'','The Twinblades are even more impressive in person.',0,0,0,0,0,0,1,0,0,39227,0,64686,26124),
(105156,'They tell me to clean up Underking\'s mess. But look at \'dis. It gonna take forever.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105157,'Headed down to the Broken Shore, eh? I know right where you need to go, Zeomus here will get ya there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105158,'Beakbuck sends a placeholder event!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105159,'','If you wish to find me when Grimwing is slain... follow the trail of demon corpses.',0,0,0,0,0,0,0,0,0,0,0,71821,26124),
(105160,'CHEAT - Make me eligible for Chapter 1.','CHEAT - Make me eligible for Chapter 1.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105161,'CHEAT - Make me eligible for Chapter 2.','CHEAT - Make me eligible for Chapter 2.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105162,'CHEAT - Make me eligible for Chapter 3.','CHEAT - Make me eligible for Chapter 3.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105163,'CHEAT - Reset my eligibility to 0.','CHEAT - Reset my eligibility to 0.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105168,'','I see that you are no ally to these naga, $r! Get me out of this cage!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105169,'','I must find Jarl Throndyr!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105170,'You are no naga! Where is Brandolf?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105171,'Brandolf\'s alive! I must go to him!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105172,'','Opening a gateway now, dears. Step back.',0,0,0,0,0,0,0,0,0,0,0,58260,26124),
(105173,'Come $n! I will fight by your side as we cut a bloody swath into these naga!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105174,'Taking oath of service','Taking oath of service',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(105175,'','Coming, $p?',0,0,0,0,0,0,0,0,0,0,0,70230,26124),
(105176,'','Speak now, demon. Lead me to your master and I may let you live.',0,0,0,0,0,0,0,0,0,0,0,71820,26124),
(105177,'','Zach, give me something to yell!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105178,'','More crystalline beasts are coming, dig your hooves in!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105179,'I\'m looking for information about the inventor of Blingtron.','I\'m looking for information about the inventor of Blingtron.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105180,'','The Burning Legion has no concept of mercy or remorse. If we wish to defeat such a threat, we must abandon those ideals as well.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105181,'I\'ll be taking this for me self!','',0,0,0,0,0,0,0,0,0,0,60334,0,26124),
(105182,'','The Legion took my weapons from me, so it\'s only fitting that I take one of theirs.',0,0,0,0,0,0,0,0,0,0,0,60335,26124),
(105183,'The inventor of the Blingtron unit? Well now, that\'s quite the question!$b$bAs the legend goes, he was a great, tall fella, \'bout four gnomes high, with big ol\' muscly arms to lift the pieces of his inventions around.$b$bHe had beautiful purple sideburns, and lightning in his eyes!$b$bWell... at least that\'s what my cousin Ricket told me.$b$bShe knows the rest of the story, if you really want to know more. You can find her at K3 in the Storm Peaks.','',1,1,1,0,0,0,0,0,0,0,0,0,26124),
(105184,'','Up in the sky! Behold Ohn\'ahra! The spirit of the eagle has returned!',0,0,0,0,0,0,5,0,0,0,0,61854,26124),
(105188,'I pledge my axes... and my pets... to your cause, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105190,'','Oh, that old tale? Sure, I can tell it again, if ya like.$b$b<Ricket raises her hands and begins to talk in a deep voice.>$b$bSo says the legend that he was big like a fel reaver, with a face that could spook even ol\' Deathwing. They say he lost his arm makin\' the Blingtron unit. Replaced it with a SPIDER TANK!$b$b<Ricket begins to chuckle a bit.>$b$bActually the last real bit of information I heard about him was from this sailor I met in Ratchet. Drunk as a skunk, but I believe there was a small bit of truth to what he was sayin\'.$b$bHis name is Chief-Engineer Foote. He might be able to give you a real clue as to where you can find the inventor.',1,1,1,0,0,0,0,0,0,0,0,0,26124),
(105191,'$n! Thank goodness I\'ve reached you! I need your help.','',0,0,0,0,0,0,0,0,0,0,61688,0,26124),
(105192,'Good, you made it. I\'m afraid we have an escaped dreadlord on our hands.','',0,0,0,0,0,0,0,0,0,0,61689,0,26124),
(105193,'We don\'t have much time. The demon will surely have found the forge by now. I will meet you in Violet Hold.','',0,0,0,0,0,0,0,0,0,0,61690,0,26124),
(105194,'It looks like the dreadlord is one step ahead. Hurry, the passage is this way!','',0,0,0,0,0,0,0,0,0,0,61708,0,26124),
(105195,'It\'s over, dreadlord. Your evil reign ends here!','',0,0,0,0,0,0,0,0,0,0,61709,0,26124),
(105196,'Hic! You wanna ...hic! You wanna ...hic! You wanna know about Blingtron?$b$bOh sure, ya, ya, ya. Okay, sho, I wash down in, um ...hic! Oh right!$b$bI wash down in Gadaget... Gaget... Gadgistan, an\' I was talkin to thish little green fellow bout him. Come closher.$b$b<Chief Engineer Foote beckons you closer and starts whispering in your ear, loudly.>$b$bSho Nixsh Shprocketshpring ish thish guy\'sh name. Ha ha! And he told me, to tell you, to tell ...hic!$b$bOh, I forget. Jush leave me alone, would ya.','',1,1,1,0,0,0,0,0,0,0,0,0,26124),
(105197,'Pitiful wretch! You should have brought an army! What can one little mage do against the might of the nathrezim?','',0,0,0,0,0,0,1,0,0,0,61710,0,26124),
(105198,'The Forge of the Guardian will be mine!','',0,0,0,0,0,0,0,0,0,0,61711,0,26124),
(105199,'You are pathetic! Your feeble spells cannot stop me!','',0,0,0,0,0,0,0,0,0,0,61712,0,26124),
(105200,'He\'s too strong! We need the power of the forge!','',0,0,0,0,0,0,0,0,0,0,61713,0,26124),
(105201,'Find a way past his barrier! I\'ll try to keep him occupied.','',0,0,0,0,0,0,0,0,0,0,61714,0,26124),
(105202,'You will not escape so easily, little mage!','',0,0,0,0,0,0,0,0,0,0,61715,0,26124),
(105203,'Nice work! Now destroy the rifts siphoning power from the forge!','',0,0,0,0,0,0,0,0,0,0,61716,0,26124),
(105204,'It\'s working! Activate the forge!','',0,0,0,0,0,0,0,0,0,0,61717,0,26124),
(105205,'You look like a smart fellow, so I\'ll give you the biggest clue you need. Forget about it!$b$bBlingtron\'s the invention of some no-good, dirty, little gnome who don\'t know nuttin about engineering.$b$bAnd DEFINITELY don\'t go visit his granddaughter, Winkey, down on Southbreak Shore, southeast o\' here. She\'s worse than he was.','',1,1,1,0,0,0,0,0,0,0,0,0,26124),
(105206,'Actually I\'m here to ask you about your grandfather.','Actually I\'m here to ask you about your grandfather.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105207,'Take my power, champion! Banish this demon back from whence it came!','',0,0,0,0,0,0,0,0,0,0,61720,0,26124),
(105208,'I\'ve had enough of you, Felstorm. Prepare to meet your end!','',0,0,0,0,0,0,0,0,0,0,61721,0,26124),
(105209,'Fool! The Legion will know your secrets...','',0,0,0,0,0,0,0,0,0,0,61722,0,26124),
(105210,'Count your days, mage. I will return!','',0,0,0,0,0,0,0,0,0,0,61723,0,26124),
(105211,'Alodi!','',0,0,0,0,0,0,5,0,0,0,61725,0,26124),
(105212,'It is good to see you, old friend. Though I wish it were under better circumstances.','',0,0,0,0,0,0,1,0,0,0,61726,0,26124),
(105213,'','My grandfather, Gnopetto Bizzfuse was a great inventor. You may have heard of his one and only invention, the Blingtron unit.$b$bEveryone wanted to learn his secrets of how he created Blingtron\'s internal circuitry but he refused to share it.$b$bHe died many years ago after the sea rose and devoured his shop. I doubt you\'d be able to find anything more, but if you\'re up to it, you can go for a swim and check it out.$b$bYou can even borrow my diving helm if you like.',1,1,1,0,0,0,0,0,0,0,0,0,26124),
(105214,'The dreadlord\'s defeat is only temporary. Once he regains his strength in the Twisting Nether, he will seek the forge again.','',0,0,0,0,0,0,1,0,0,0,61727,0,26124),
(105215,'Then I know what must be done...','',0,0,0,0,0,0,1,0,0,0,61728,0,26124),
(105216,'','The Silver Covenant stands with you!',0,0,0,0,0,0,0,0,0,0,0,61860,26124),
(105217,'The Farstriders vow to fight at your side!','',0,0,0,0,0,0,0,0,0,0,61861,0,26124),
(105218,'','It\'s been far too long, $p. Far too long!',0,0,0,0,0,0,113,0,0,0,0,58269,26124),
(105219,'Do you need to unleash another wave of murlocs, $n? Just give the word.$b$bSo many eggs remain... As individuals, murlocs are easily destroyed. But as a village? They are all but indestructible.','',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(105220,'Unleash the murlocs!','Unleash the murlocs!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105221,'','The Goldenapple is setting quite nicely, Slifna.',0,0,0,0,0,0,0,0,0,0,0,66651,26124),
(105222,'','Still need to get this sorry excuse for a wagon fixed. Where is Jolfang with that axle, eh Slif?',0,0,0,0,0,0,0,0,0,0,0,66652,26124),
(105223,'Lothrius sent me. Will you help me close the portals?','Lothrius sent me. Will you help me close the portals?',0,0,0,0,0,0,0,0,0,38172,0,0,26124),
(105225,'','The Black Brew is running low, Slifna. If Melba were still here, we would never run dry.',0,0,0,0,0,0,0,0,0,0,0,66653,26124),
(105228,'','Are you looking for Melba? I\'m her apprentice, but you won\'t find my master here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105229,'','You\'re about two years too late, my friend. Melba is dead.',0,0,0,0,0,0,1,0,0,0,0,66655,26124),
(105231,'','Come, monk. Walk with me.',0,0,0,0,0,0,0,0,0,0,0,66656,26124),
(105232,'','My master\'s recipes were famous for their taste and potency. We used to ship barrels every day. Goldenapple, sweet and crisp. Black Brew, dark and bitter. Woodheart, oaken and bright.',0,0,0,0,0,0,0,0,0,0,0,66698,26124),
(105233,'','Morjirn, head brewer of a nearby clan, harbored jealousy of my master\'s skill. He sent a band of raiders to kill her, and steal the recipe.',0,0,0,0,0,0,0,0,0,0,0,66734,26124),
(105234,'','Morjirn has the recipe now, but he lacks skill. What you drank at the Gates of Valor was pure sludge. It holds only a fraction of Storm Brew\'s TRUE power.',0,0,0,0,0,0,0,0,0,0,0,66702,26124),
(105235,'','Melba\'s Storm Brew was the rarest and most desired of her recipes. It was even said that the thunder god Odyn served this brew in his hall of champions.',0,0,0,0,0,0,0,0,0,0,0,66657,26124),
(105236,'Fool! Has your mind rotted to dust? The Legion\'s magic is easily avoided.','',0,0,0,0,0,0,0,0,0,0,60350,0,26124),
(105238,'What\'re ye waiting for? Get a move on!','',0,0,0,0,0,0,0,0,0,0,60337,0,26124),
(105239,'Owwww!!! Owwww!!','',0,0,0,0,0,0,0,0,0,0,60340,0,26124),
(105240,'We have what we came for, but I\'d be remiss if I didn\'t try to bolster Karazhan\'s defenses before I leave. I owe that much to Medivh... the good man he once was, not the pawn of Sargeras he became.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105241,'I must return to Jandvik.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105243,'Intruder!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105244,'I will spit on your corpse!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105245,'By my blade!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105246,'You will meet your ancestors this day!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105247,'I am vrykul! You will die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105248,'The light fades...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105249,'Valhalas...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105250,'By your hand, I meet my end...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105251,'My blade broken!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105252,'Judgment awaits...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105253,'','The light fades...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105254,'','Valhalas...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105255,'','By your hand, I meet my end...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105256,'','I fall, staff shattered...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105257,'','Judgment awaits...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105258,'','Intruder!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105259,'','I will curse your soul!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105260,'','By my staff!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105261,'','You will meet your ancestors this day!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105262,'','I am vrykul! You will die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105263,'','Calder is a headstrong fool...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105264,'','Eynar has no foresight...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105265,'','I need an outsider...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105266,'','This is a deed I cannot do...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105267,'','I will be jarl.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105268,'What\'s thisss? A trespasser intrudesss on our conversation.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105269,'We mussst inform the Tidemistressss...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105270,'We have uninvited guestsss.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105271,'Jandvik will be oursss...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105272,'','What\'s thisss?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105273,'','My death stopsss nothing...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105274,'I will gut you like a fish.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105275,'Jandvik is oursss.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105276,'You cannot stop usss!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105277,'Death to our enemiesss!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105278,'Sashj\'tar attack!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105279,'For the Tidemistress...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105280,'The sssilence of the deep...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105281,'The sea callsss me home...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105282,'You cannot ssstop us all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105283,'Black abyss...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105284,'','What\'s the delay? Go already!',0,0,0,0,0,0,0,0,0,0,0,60338,26124),
(105285,'','Owwww!!! Owwww!!',0,0,0,0,0,0,0,0,0,0,0,60341,26124),
(105286,'Another damned barrier! Watch my back... we\'ll probably get jumped again.','',1,0,0,0,0,0,0,0,1,38180,60351,0,26124),
(105287,'Here they come!','',0,0,0,0,0,0,0,0,0,0,60346,0,26124),
(105288,'Another bunch of \'em headed our way!','',0,0,0,0,0,0,0,0,0,0,60343,0,26124),
(105289,'The barrier\'s down. Move quickly!','',1,0,0,0,0,0,0,0,1,0,60353,0,26124),
(105290,'Foolish mortals! Are you so eager to take the place of my next meal?','',0,0,0,0,0,0,0,0,0,0,60317,0,26124),
(105291,'So be it! This prisoner is useless to me anyway. Its blood is weak and stale.','',0,0,0,0,0,0,0,0,0,0,60322,0,26124),
(105292,'Are you ready?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105293,'','More incoming! Intercept them!',0,0,0,0,0,0,0,0,0,0,0,60344,26124),
(105294,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105299,'Switching','Switching',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105300,'We\'re here to slay a demon, not rescue every failure who couldn\'t get the job done.','',0,0,0,0,0,0,1,0,0,0,60345,0,26124),
(105301,'I don\'t care! Slaying the demon is our first priority. Come, we\'ve wasted enough time with this blathering.','',0,0,0,0,0,0,0,0,0,0,60348,0,26124),
(105302,'What!? Don\'t ye have any sense of duty to aid yer fellow knights?','',0,0,0,0,0,0,0,0,0,0,60325,0,26124),
(105303,'','What!? Don\'t you have any sense of duty to aid your fellow knights?',0,0,0,0,0,0,0,0,0,0,0,60327,26124),
(105308,'Blast ye, Sliver! Fine! I\'ll help ye, but I\'ll rescue Margrave first chance I get!','',0,0,0,0,0,0,0,0,0,0,60329,0,26124),
(105309,'Thank Odyn, I thought I was fishbait.','Thank Odyn, I thought I was fishbait.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105310,'May Valhallas shine upon you.','May Valhallas shine upon you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105311,'Oh my, what a situation. I\'m out of here.','Oh my, what a situation. I\'m out of here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105312,'','I\'ve been helping the villagers at Dai-Lo Farmstead recover from their vermin infestation.$B$BChen told me stories about Shen-zin Su, but I never expected the turtle to be so vast!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105313,'','I know only too well the pain and suffering that comes from losing a loved one. That\'s why I joined this fight, and the brew here\'s not so bad, either.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105314,'What can I help you with, $n?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105315,'Can you give me an empty barrel?','Can you give me an empty barrel?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105316,'Do you have hops and yeast?','Do you have hops and yeast?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105317,'Chen wanted me to ask for some honey.','Chen wanted me to ask for some honey.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105318,'We\'re leaving soon, Yalia.','We\'re leaving soon, Yalia.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105319,'','I will send you to the abyss.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105320,'','Jandvik is oursss.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105321,'','You cannot stop the Sashj\'tar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105322,'','Death to our enemiesss!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105323,'','You will fall before the Sashj\'tar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105324,'','Here you go. Tell Chen to be careful out there. We have already lost too many to the Legion attacks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105325,'','You\'re a cold one, Sliver. Fine! I\'ll help, but if we have any chance of getting Margrave out alive, we should take it.',0,0,0,0,0,0,0,0,0,0,0,60331,26124),
(105326,'','That poor boy. The temple puts a heavy burden on his shoulders, yet all he wants is to settle down with Yalia.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105327,'These supplies should do. Tell Chen good luck with his journey.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105328,'','Chen! Are you going somewhere?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105329,'','For the Tidemistress...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105330,'','The sssilence of the deep...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105331,'','The sea callsss me home...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105332,'','You cannot ssstop us all.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105333,'','Black Abyss...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105335,'I\'m ready to battle, Didi!','I\'m ready to battle, Didi!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105339,'','This barrel should do. Is Chen going off on another mission?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105341,'This war is brutal. We need every advantage we can get.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105343,'','You will perish in thisss cave, $r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105344,'','Tidemistress... I have failed you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105345,'I could... use a little... help here!','',0,0,0,0,0,0,0,0,0,0,61718,0,26124),
(105346,'May the eagle spirit guide your hand.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105347,'Now\'s our chance! Let\'s bring him down!','',0,0,0,0,0,0,0,0,0,0,61719,0,26124),
(105348,'Where did this altar come from?','Where did this altar come from?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105351,'It is said this altar was carved from a slab of stone brought back from the Field of the Eternal Hunt by Huln Highmountain himself!$b$bThe stone resonates with the life force of the creatures who dwell in that sacred hunting ground.$b$bAfter the Trueshot Lodge was founded, Huln\'s descendents had the stone carved to honor the eagle spirit Ohn\'ahra and presented it to the members of the Unseen Path.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105352,'What does the altar do?','What does the altar do?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105353,'The altar acts as a focus for ancient powers... the Wild Gods, the Keepers, even elven wells of magic.$b$bCertain ancient relics can be infused by such powers to become even more potent. The weapon you carry is such a relic.$b$bThink of this altar as a conduit to those primordial forces. Make use of it whenever you are able, for you\'ll need every advantage to lead us against the Legion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105355,'Reaves is ready to be piloted.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105356,'I\'m looking for Brewmaster Melba.','I\'m looking for Brewmaster Melba.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105357,'Easy! Easy there! I hope that vrykul leaves soon!','Easy! Easy there! I hope that vrykul leaves soon!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105358,'Little pest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105359,'Sashj\'tar foe.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105360,'Bury you in sand!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105361,'Crush your bones!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105362,'Crush you like clam.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105363,'Die... now...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105364,'Sashj\'tar survive...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105365,'To... abyss...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105366,'Back to deep...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105367,'Too... strong...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105368,'Netrezaar... take... you...','',0,0,0,0,0,0,0,0,0,0,60330,0,26124),
(105369,'I\'ll guzzle your blood!','',0,0,0,0,0,0,0,0,0,0,60326,0,26124),
(105370,'Good, now let\'s get out of here. The Lich King will be eager to hear of our success.','',0,0,0,0,0,0,0,0,0,0,60354,0,26124),
(105371,'Suffer well, old friend.','',0,0,0,0,0,0,0,0,0,0,60349,0,26124),
(105372,'','Poor Margrave! The final death claimed you at last.',0,0,0,0,0,0,0,0,0,0,0,60347,26124),
(105373,'','Let\'s show \'em what Reaves can do!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105374,'Actually, Didi, I have something else I have to do right now.','Actually, Didi, I have something else I have to do right now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105376,'|TInterface\\Icons\\Spell_Shadow_CreepingPlague:20|t Nythendra infests you with |cFFFF0404|Hspell:203096|h[Rot]|h|r!','|TInterface\\Icons\\Spell_Shadow_CreepingPlague:20|t Nythendra infests you with |cFFFF0404|Hspell:203096|h[Rot]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(105377,'','I told Baron Sliver that you were coming, but he ran in anyway. That fool is going to get himself killed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105378,'We\'ve got this side of the portal secured.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105379,'','This is the right place. We will find the stolen recipe here.',0,0,0,0,0,0,0,0,0,0,0,66631,26124),
(105383,'','Yes, now that\'s strong! But my master\'s was still better.',0,0,0,0,0,0,5,0,0,0,0,66632,26124),
(105384,'','Hmmm. Good flavor, but it\'s as weak as rainwater.',0,0,0,0,0,0,1,0,0,0,0,66633,26124),
(105385,'','Ugh, mother of Odyn! That tasted worse than runehorn curd!',0,0,0,0,0,0,5,0,0,0,0,66634,26124),
(105387,'','My patience has run out, wyrmtongue. Where does your master hide?',0,0,0,0,0,0,0,0,0,0,0,67602,26124),
(105388,'You cannot trust your own mind!','',0,0,0,0,0,0,603,0,14,0,63446,0,26124),
(105389,'','Get me out of this cage!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105390,'See how I bend your mind to my will!','',0,0,0,0,0,0,603,0,14,0,63447,0,26124),
(105391,'The darkness consumes all!','',0,0,0,0,0,0,603,0,14,0,63448,0,26124),
(105392,'Tasting','Tasting',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105393,'Gah!','',0,0,0,0,0,0,0,0,6,0,58474,0,26124),
(105394,'Can you hear me, my friend?','',0,0,0,0,0,0,0,0,6,0,62762,0,26124),
(105395,'Over here, my friend!','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(105396,'Shrug off your wounds, warriors! Another battle awaits!','',0,0,0,0,0,0,53,0,0,0,60428,0,26124),
(105397,'','Aaaahhh!',0,0,0,0,0,0,0,0,6,0,0,58473,26124),
(105398,'','Havi didn\'t say they would be so short!',0,0,0,0,0,0,396,0,0,0,0,60429,26124),
(105399,'Look! The Tidestone!','',0,0,0,0,0,0,0,0,6,0,58472,0,26124),
(105400,'That old seer is mad, but rarely wrong. Come \"friend,\" more demons approach! Prove your valor!','',0,0,0,0,0,0,396,0,0,0,60430,0,26124),
(105401,'My word...','',0,0,0,0,0,0,0,0,6,0,58471,0,26124),
(105402,'Are you ready, $n?','',0,0,0,0,0,0,0,0,0,0,61691,0,26124),
(105403,'New subjects! What delicious secrets will you hold?','',0,0,0,0,0,0,0,0,0,0,60306,0,26124),
(105404,'','Haardgrim! Alrik! Odyn has judged you worthy for his halls. Come with me to glory!',0,0,0,0,0,0,1,0,0,0,0,60434,26124),
(105405,'So many... secrets... remain...','',0,0,0,0,0,0,0,0,0,0,60312,0,26124),
(105406,'','There are more here that are worthy but I cannot claim them. To the west a demon keeps their souls imprisoned. Small one, prove your strength and free them!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105407,'This quest is yours alone, do not keep Odyn waiting!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(105408,'','We will prepare for the next fight. It will be soon so be quick!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(105409,'','Odyn\'s will is no so easily stayed. You three are worthy of his halls and this warrior has freed you. Come with me to glory!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(105410,'A brute has joined the battle, little hero! Come and meet your fate before your place is taken!','',0,0,0,0,0,0,22,0,0,0,60436,0,26124),
(105411,'','I almost broke a sweat... but not quite! What else do they have?',0,0,0,0,0,0,396,0,0,0,0,60437,26124),
(105412,'Wha... what was that?','',0,0,0,0,0,0,396,0,0,0,60439,0,26124),
(105413,'','Well... will you look at that...',0,0,0,0,0,0,396,0,0,0,0,60441,26124),
(105414,'At last! This is the glorious death Havi promised me!','',0,0,0,0,0,0,396,0,0,0,60442,0,26124),
(105415,'','I say we kill the demon instead! Little hero, you have proven yourself a worthy ally. Will you stand with us, even though it could mean our deaths?',0,0,0,0,0,0,396,0,0,0,0,60443,26124),
(105416,'Hah! With all of us together, we may yet be victorious! Either way, I\'ll not go down easily. Let us be about it then!','',0,0,0,0,0,0,71,0,0,0,60444,0,26124),
(105417,'','I will salute your courage in the Halls of Valor... or over this monster\'s corpse!',0,0,0,0,0,0,396,0,0,0,0,60445,26124),
(105418,'','I can still... fight...',0,0,0,0,0,0,0,0,0,0,0,60448,26124),
(105419,'Fight on, hero... For me... the Halls await...','',0,0,0,0,0,0,0,0,0,0,60450,0,26124),
(105420,'','Ragnvald, Finna, you have been judged worthy for Odyn\'s halls. Come with me to glory!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(105421,'','You are not dead and you are not vrykul, yet Odyn summons you still. I know not what awaits you in his halls, but I believe you are worthy of its glory...',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(105422,'Follow me. We must address the others.','',0,0,0,0,0,0,0,0,4,0,58215,0,26124),
(105423,'Behold the power of the Twinblades of the Deceiver. The Fel Hammer is ours!','',0,0,0,0,0,0,0,0,4,0,58214,0,26124),
(105424,'We are the blades that will strike down the Legion. We are the chosen warriors of Lord Illidan.','',0,0,0,0,0,0,0,0,4,0,58213,0,26124),
(105425,'We are ILLIDARI!','',0,0,0,0,0,0,0,0,4,0,58212,0,26124),
(105426,'','Right this way.',0,0,0,0,0,0,396,0,0,0,0,58270,26124),
(105427,'','I\'ve enabled Reaves\' piloted combat mode. Just activate it when you\'re ready, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105431,'Belay these bilge rats!','',25,0,0,0,0,0,0,0,0,0,57462,0,26124),
(105432,'All hands on deck!','',0,0,0,0,0,0,0,0,0,0,57456,0,26124),
(105433,'Destroy these landlubbers!','',0,0,0,0,0,0,0,0,0,0,57465,0,26124),
(105434,'No prey, no pay. Now secure the Naglfar!','',0,0,0,0,0,0,0,0,0,0,57455,0,26124),
(105435,'Pillage! Plunder! Leave none standing!','',0,0,0,0,0,0,0,0,0,0,57466,0,26124),
(105437,'The Hall of the Guardian! It pains me to see it in such disrepair.','',0,0,0,0,0,0,603,0,0,0,61730,0,26124),
(105438,'The hall hasn\'t seen any use since the disbanding of the Council of Tirisfal.','',0,0,0,0,0,0,1,0,0,0,61731,0,26124),
(105439,'The wards protecting this place are still strong. I think it will serve our needs.','',0,0,0,0,0,0,0,0,0,0,61732,0,26124),
(105440,'And what is your plan?','',0,0,0,0,0,0,6,0,0,0,61733,0,26124),
(105441,'I shall reform the Tirisgarde. And this mage will be its first champion.','',0,0,0,0,0,0,1,0,0,0,61734,0,26124),
(105442,'What say you, $n?','',0,0,0,0,0,0,6,0,0,0,61735,0,26124),
(105446,'Welcome to the Fel Hammer, $n.','',0,0,0,0,0,0,66,0,0,0,58271,0,26124),
(105447,'Prepare to face your doom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105448,'Return here once you have retrieved the artifact, $n. In the meantime, I\'ll see about tidying up a bit.','',0,0,0,0,0,0,1,0,0,0,61736,0,26124),
(105449,'','If I may interject, I would like to speak with you, $p.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105450,'','Across the way lies the Arena of Glory, where warriors vie for supremacy in epic combat. Before us lies the Great Mead Hall where drink and stories flow freely!',0,0,0,0,0,0,0,0,0,0,0,60359,26124),
(105451,'','Hrydshal fortress lies to the south. I will meet you there. Slifna flies faster than the wind.',0,0,0,0,0,0,1,0,0,0,0,66640,26124),
(105452,'The secrets of the Storm Brew are mine! You will not have them!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(105453,'No... I never... solved it....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105454,'','Are you ready to defend me while I perform the scrying?',0,0,0,0,0,0,0,0,0,38261,0,0,26124),
(105455,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,0,38261,0,0,26124),
(105456,'This way. Your forces await.','',0,0,0,0,0,0,0,0,4,0,58265,0,26124),
(105457,'','The Nightborne deceived us. The Moon Guard will soon be lost forever.',0,0,0,0,0,0,0,0,0,0,0,66385,26124),
(105458,'The Fel Hammer is ours at last. Gaze upon the might of the Twinblades of the Deceiver!','',0,0,0,0,0,0,0,0,4,0,58266,0,26124),
(105459,'We will follow $p into battle, and we will strike down the Legion once and for all!','',0,0,0,0,0,0,0,0,4,0,58267,0,26124),
(105460,'Glory to the Illidari!','',0,0,0,0,0,0,0,0,4,0,58268,0,26124),
(105461,'','Filthy dogs... the Tideskorn were always merciless thieves and murderers.',0,0,0,0,0,0,1,0,0,0,0,66730,26124),
(105462,'','My master, Melba, taught me everything she knew, including the fighting techniques of ancient vrykul brewer-kings and queens.',0,0,0,0,0,0,1,0,0,0,0,66641,26124),
(105463,'','I hope Melba is looking upon me now. How long have I waited for vengeance!',0,0,0,0,0,0,1,0,0,0,0,66642,26124),
(105464,'','We will wash over the Burning Legion by your will.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105465,'Now, as I was saying...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105466,'Are you finished interrupting, naga?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105467,'Harbaron won\'t have your kind around here, mortal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105468,'','Watch out! This is an imposter!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105469,'','Jandvik will never fall to your vile naga! Never!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105470,'Item Upgrade','Item Upgrade',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(105471,'There is no such thing as \"too many dead demons\".','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105472,'Show me what we acquired in our conquest.','Show me what we acquired in our conquest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105473,'','After I died, Odyn granted me passage to his fabled Halls of Valor. It is here that his warriors feast and celebrate in eternal glory. I humbly provide his champions with their favorite brews.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105474,'Alodi, we need your help. We must take the Forge of the Guardian to a safer location.','',0,0,0,0,0,0,1,0,0,0,61729,0,26124),
(105475,'We will need its might if we are to defeat the Burning Legion.','',0,0,0,0,0,0,1,0,0,0,61707,0,26124),
(105476,'','You should be proud, $n. You almost saved Jandvik. Now you will die in this hole without Brandolf or Jandvik ever knowing how you failed to stop the Sashj\'tar!',0,0,0,0,0,0,0,0,0,37846,0,0,26124),
(105478,'Whoa there, boyo! You\'re a bit eager with that little spear of yours!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105479,'Hrnnggggh...','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(105480,'Malfurion, my old friend... the perfect bait!','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(105482,'Ahh, the Mother of Dreams has arrived at last.','',0,0,0,0,0,0,0,0,6,0,68235,0,26124),
(105483,'Welcome, $c! This elemental realm at the precipice of the Maelstrom is the Heart of Azeroth, a most sacred space for those with shamanistic beliefs. In this room, those who proclaim a mastery over the elements may test their strength of spirit in a series of challenges.$b$bBut you for, there is nothing.$b$bNot even snacks.','',274,0,0,0,0,0,0,0,0,0,0,0,26124),
(105484,'Ah, of course! Right this way.','',0,0,0,0,0,0,0,0,0,0,64701,0,26124),
(105485,'To develop harmony with the elements, one must study and understand the interactions between them. The totemic matrix is an ancient training method, a puzzle that will challenge one\'s mind and spirit.$b$bThe object of the exercise is to transform all the totems to water totems. Simply touch a totem to invoke it. Know that all things are connected, a lesson invaluable in this puzzle... as in life!','',404,0,0,0,0,0,0,0,0,0,0,0,26124),
(105486,'You will be presented with a five-by-five matrix of elemental totems. Some are fire, some water. Your objective is to change them all to water totems.$b$bSimply touch a totem to flip its elemental alignment. Ah, but the elements are connected to one another! Flipping a totem will also change the four totems adjacent to it.$b$bThrough patience, trial, and error, you should be able to coax all of the totems into water totems. Try your best, $c!$b$bIf you find yourself completely lost, speak to me and I can reset the puzzle for you.','',404,0,0,0,0,0,0,0,0,0,0,0,26124),
(105487,'Legion reinforcements arrived soon after you left for the Black Temple, destroying the portal behind you. Oh, it was a glorious battle!','',0,0,0,0,0,0,0,0,0,0,64702,0,26124),
(105488,'The totemic matrix awaits, $c! Touch a totem to reverse its nature, as well as the totems around it. Try to change all the totems into water totems.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(105489,'I can see why you answered the call of the shaman, $n. You have a natural instinct for the interconnectedness of all things.$b$bAre you ready for a slightly more difficult challenge?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(105490,'I am impressed. You are not just a shaman... you are an elemental craftsman. An artist! Azeroth is your canvas.$b$bSo far the challenges have all been balanced in their own right. But as you know, such order rarely appears in nature. How will you fare in an asymmetrical challenge?','',404,6,0,0,0,0,0,0,0,0,0,0,26124),
(105491,'The totemic matrix is a training method that has been in use since before the mortal races recorded the passing of the days. Long, long ago, totems were not used at all. Instead, gnomes were set on fire. That was a joke, shaman. You may laugh now, should you choose.$b$bThe next challenge may appear simple, but it will truly test your abilities.','',404,0,0,0,0,0,0,0,0,0,0,0,26124),
(105492,'In the aftermath, we uncovered an ancient Nathrezim forge used to create many of the Legion\'s most powerful weapons.','',0,0,0,0,0,0,0,0,0,0,64703,0,26124),
(105493,'The final challenge is a grueling test of your mettle as a shaman. This is the puzzle that killed my father. Know that if you succeed, you will have the spirit, intelligence, and tenacity to conquer any challenge that life throws your way... in this room, at least.$b$bIt is easy to remain strong when fate is going our way. The TRUE test of character is how one fares when EVERYTHING is on fire...','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(105494,'I have no further challenges for you, shaman. Training and practice can only get one so far. From here, you must perfect your technique out in the real world.$b$b<Puzzlemaster Lo sinks back into deep meditation.>','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(105495,'Tell me the rules.','Tell me the rules.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105496,'I am ready for the first challenge. Begin!','I am ready for the first challenge. Begin!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105497,'I am ready for the second challenge. Begin!','I am ready for the second challenge. Begin!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105498,'I am ready for the third challenge. Bring it on!','I am ready for the third challenge. Bring it on!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105499,'I am ready for the fourth challenge. Let\'s do this!','I am ready for the fourth challenge. Let\'s do this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105500,'Begin the final challenge!','Begin the final challenge!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105501,'I\'m stuck! Can you reset the puzzle?','I\'m stuck! Can you reset the puzzle?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105502,'We\'ve guarded it carefully ever since. I think it will prove quite useful to you.','',0,0,0,0,0,0,0,0,0,0,64704,0,26124),
(105503,'I understand. Begin the challenge!','I understand. Begin the challenge!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105504,'Let\'s try it again... with a little less gurgling this time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105505,'Mr grlrlgl... wait... is that? Well, I can\'t say I was expecting company...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105506,'Mrglrrlrlg! I mean, hello! Sorry, I\'ve been living among these Murlocs a bit longer than planned.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105507,'Why are you dressed like that?','Why are you dressed like that?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105508,'Isn\'t it obvious? These Murlocs have been pushed from their homes! We can\'t just leave them to die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105509,'Don\'t I remember you from somewhere?','Don\'t I remember you from somewhere?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105510,'This isn\'t my first dip into the ocean... I wish D.E.H.T.A. worked more with warm-water murlocs.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105511,'I\'ll mount this one\'s head on my wall!','I\'ll mount this one\'s head on my wall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105512,'The hunt begins!','The hunt begins!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105513,'You\'ll make a fine hunting trophy!','You\'ll make a fine hunting trophy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105514,'This one\'s mine!','This one\'s mine!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105515,'You shouldn\'t be here!','You shouldn\'t be here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105516,'I shoot to kill!','I shoot to kill!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105517,'You\'ll regret trespassing in these fields!','You\'ll regret trespassing in these fields!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105518,'I\'m going to enjoy hunting you!','I\'m going to enjoy hunting you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105519,'You may find it comforting to know that no matter what terrible state you\'ve gotten the puzzle into, it is always solvable. This is true in totems as well as life.$b$bStill, sometimes a fresh start can be beneficial.','',274,0,0,0,0,0,0,0,0,0,0,0,26124),
(105520,'That\'s good to know. Can I try again?','That\'s good to know. Can I try again?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105522,'','|TInterface\\Icons\\Spell_Frost_SummonWaterElemental_2.blp:20|t %s begins to cast |cFFFF0000|Hspell:202098|h[Brackwater Barrage]|h|r. Look out!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105523,'Move, you fools! Show $p some respect!','',0,0,0,0,0,0,5,0,0,0,64705,0,26124),
(105524,'$n! You are difficult to catch up with, but we finally found you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105525,'We heard you were looking for ingredients to the legendary Storm Brew.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105526,'','I sense a conflict in Chen\'s heart. He desires family, and he desires to fight for peace. He believes he must choose one, but this is false.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105527,'You will be pleased to know that training goes well at the order hall.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105528,'','He must decide if he wants to love. To love someone is to accept ALL of it. The joy AND the heartache.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105529,'We\'re glad we could be of help to you, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105530,'','I didn\'t give in.',0,0,0,0,0,0,0,0,0,32376,0,72656,26124),
(105531,'','They did... things... to me.',0,0,0,0,0,0,0,0,0,32377,0,72657,26124),
(105532,'','The demons promised us unimaginable power.',0,0,0,0,0,0,0,0,0,32378,0,72658,26124),
(105533,'','A warden tried to convince us to turn traitor. I heard screaming.',0,0,0,0,0,0,0,0,0,32379,0,72659,26124),
(105534,'','Cyana Nightglaive turned traitor. She joined the Legion.',0,0,0,0,0,0,0,0,0,32380,0,72660,26124),
(105535,'','Nightglaive went southwest with a warden named Cordana Felsong.',0,0,0,0,0,0,0,0,0,32381,0,72661,26124),
(105536,'I didn\'t give in.','',0,0,0,0,0,0,0,0,0,32376,72650,0,26124),
(105537,'They did... things... to me.','',0,0,0,0,0,0,0,0,0,32377,72651,0,26124),
(105538,'The demons promised us unimaginable power.','',0,0,0,0,0,0,0,0,0,32378,72652,0,26124),
(105539,'A warden tried to convince us to turn traitor. I heard screaming.','',0,0,0,0,0,0,0,0,0,32379,72653,0,26124),
(105540,'Cyana Nightglaive turned traitor. She joined the Legion.','',0,0,0,0,0,0,0,0,0,32380,72654,0,26124),
(105541,'Nightglaive went southwest with a warden named Cordana Felsong.','',0,0,0,0,0,0,0,0,0,32381,72655,0,26124),
(105542,'','I didn\'t give in.',0,0,0,0,0,0,0,0,0,32376,0,72644,26124),
(105543,'','They did... things... to me.',0,0,0,0,0,0,0,0,0,32377,0,72645,26124),
(105544,'','The demons promised us unimaginable power.',0,0,0,0,0,0,0,0,0,32378,0,72646,26124),
(105545,'','A warden tried to convince us to turn traitor. I heard screaming.',0,0,0,0,0,0,0,0,0,32379,0,72647,26124),
(105546,'','Cyana Nightglaive turned traitor. She joined the Legion.',0,0,0,0,0,0,0,0,0,32380,0,72648,26124),
(105547,'','Nightglaive went southwest with a warden named Cordana Felsong.',0,0,0,0,0,0,0,0,0,32381,0,72649,26124),
(105548,'','<Aviana scans the horizon with unnaturally sharp eyesight.>\n\nThe avian beasts you call falcosaurs must be kept in check, it is the nature of balance, this is true.\n\nBut so must my vengeance.\n\nMortals cannot think that they may simply slaughter my children without thought or repercussion. You must show them that my wings stretch across these lands, neverending.\n\nYou will be my talons.\n\nIf you accept this charge, take this shed talon, and bring vengeance in my name.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105549,'','<Aviana\'s eyes narrow when she sees you approaching.>\n\nI know what you have done. I see a trail of broken feathers and shattered beaks trailing behind you.\n\n<Aviana\'s feathers visibly ruffle.>\n\nWhat do you have to say for yourself?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105550,'','In my domain, fledglings are hurled from the nest as soon as they can stretch their wings. They fly. Or they die.\n\nI have created a test of dexterity for the druids I have taken under my wing. Would you like to attempt it as well?\n\nWith my blessing you will be able to float gracefully through the skies... for a time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105551,'','REUSE',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(105552,'I will be the talons of vengeance.','I will be the talons of vengeance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105553,'I understand. How can I be of aid?','I understand. How can I be of aid?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105554,'','<Aviana stretches her wings to their full, terrible length, and looks at you as if you were a mouse.>\n\nYou deign to tell me of the laws of nature? I speak for the winds and the wilds, child. Do not presume to lecture ME.\n\n<She pauses for a moment, smoothing her feathers.>\n\nAnd yet, I see the wisdom in your choices, and I see the kindness in you.\n\n<She looks from you to your falcosaur mount, then back again.>\n\nYou have done a great thing for this matriarch and her hatchling. Yet the crimes committed against their kind cannot go unpunished, do you understand?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105555,'The falcosaurs have been breeding out of control, driving nearby predators to starvation.','The falcosaurs have been breeding out of control, driving nearby predators to starvation.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105556,'I would like to attempt the flying challenge, please grant me your blessing.','I would like to attempt the flying challenge, please grant me your blessing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105557,'Who goes there?!','',0,0,0,0,0,0,0,0,0,0,65802,0,26124),
(105558,'Something\'s not quite right...','',0,0,0,0,0,0,0,0,0,0,65803,0,26124),
(105559,'An illusion! What are you hiding?','',0,0,0,0,0,0,0,0,0,0,65819,0,26124),
(105560,'Hey $n, glad we caught up with you! We heard about your progress and decided to help out.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105561,'How do I complete your test?','How do I complete your test?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105562,'','<Aviana looks at you with a predatory expression.>\n\nI want to smell their blood from here, Talon.\n\nSee the raven behind you, Trinket, should you require supplies in your hunt. He is quite good at finding useful and shiny objects.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105563,'REUSE','REUSE',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105564,'','The rest of the Illidari won\'t disturb you here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105565,'Whatever you\'re hunting, I have a weapon that\'s guaranteed to take your target down.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105566,'','I will grant you my blessing, allowing you to float gracefully to the ground. As you fall, attempt to gather as many of the emerald globes as you can. \n\nFew hatchlings gather more than a couple on their first flight. But most survive to try again.\n\nShould you gather them all in one flight, I may have something extra for you.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(105567,'The creature begins to growl in your presence.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105568,'Is that enough crystals? All right, we\'ll head back to the order hall.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105569,'','The Legion attacks are growing more frequent. The sooner we can make this Storm Brew, the better.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105570,'','That one never saw it coming.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105571,'','This coil projects a high-potency current. You will find a low-potency coil at the far end of the facility.',0,0,0,0,0,0,0,0,0,0,0,67427,26124),
(105572,'Flip the totems until they\'re all water totems','',0,0,0,0,0,0,0,0,0,38304,0,0,26124),
(105573,'|TInterface\\Icons\\Spell_Shadow_Teleport:20|t%s |cFFFF0000|Hspell:200898|h[Teleports]|h|r to nearby cells and begins releasing prisoners!','|TInterface\\Icons\\Spell_Shadow_Teleport:20|t%s |cFFFF0000|Hspell:200898|h[Teleports]|h|r to nearby cells and begins releasing prisoners!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105574,'','Speak to me again when you return to Dalaran. We have much to discuss.',0,0,0,0,0,0,1,0,0,0,0,64291,26124),
(105575,'','Both currents feed into the central chamber. Use the coils and switches to direct the currents and power all four seals in the central chamber!',0,0,0,0,0,0,0,0,0,0,0,67428,26124),
(105576,'','The currents are aligned - now engage the seal!',0,0,0,0,0,0,0,0,0,0,0,67430,26124),
(105577,'I am ready for the next challenge!','I am ready for the next challenge!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105578,'Tell me the rules again...?','Tell me the rules again...?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105579,'|TInterface\\Icons\\ability_warlock_soulswap:20|t |cFFFF0000|Hspell:200904|h[Sapped Soul]|h|r will make the next ability you use unavailable!','|TInterface\\Icons\\ability_warlock_soulswap:20|t |cFFFF0000|Hspell:200904|h[Sapped Soul]|h|r will make the next ability you use unavailable!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105580,'The challenge is complete! $n is a totemic master!','',4,0,0,0,0,0,4,0,0,0,0,0,26124),
(105582,'Let\'s begin brewing!','Let\'s begin brewing!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105583,'','Throw those ingredients into the pot. Things might get a little messy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105584,'','Keep it up, $p. It\'s working!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105585,'','Wait, what is that thing? $p, hold it off while I finish the brew!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105586,'','Auughhh! It\'s too strong, $p! No... we can\'t lose now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105587,'','Hey!!! You look like you could use a hand!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105588,'','Yalia! What are you doing here? It\'s too dangerous!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105589,'','The only one I see in danger is you, Chen!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105590,'','Well... you never cease to amaze me, Yalia. Now let\'s finish this brew!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105591,'You begin to feel drowsy!','You begin to feel drowsy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(105592,'We may have finally eliminated the Sashj\'tar threat.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105593,'','Behold the Legion\'s primary gateway into Azeroth... the Tomb of Sargeras.',0,0,0,0,0,0,0,0,0,0,0,64708,26124),
(105594,'','The situation is more dire than we knew. The demons have already infested the surrounding isles.',0,0,0,0,0,0,0,0,0,0,0,64709,26124),
(105595,'','We must act now, or I fear the situation will become... unsalvageable.',0,0,0,0,0,0,0,0,0,0,0,64710,26124),
(105596,'','$p, thank you for helping to re-unite us. Come, let us take Yalia\'s balloon back to the turtle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105597,'You should return to Dalaran and secure passage to the Broken Isles immediately.','',0,0,0,0,0,0,1,0,0,0,58210,0,26124),
(105598,'Thanks to your power, we can use the Fel Hammer to plan out every aspect of our assault.','',0,0,0,0,0,0,0,0,0,0,58209,0,26124),
(105599,'','Champion, if you are finished honing your weapons, I have something I wish to show you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105601,'Engaging','Engaging',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(105602,'','I\'ll get started on fixin\' it up with stuff I have around the shop.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105603,'','If you will follow me. The Eye of Odyn is a powerful scrying and communication device. With it you will be able to see the Broken Isles, send orders to your champions, and enact your own special operations. Skyseer Ghrent will help you manage the Eye.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105604,'','Here is Skyseer Ghrent and the Eye of Odyn. May your orders come swift and your battles victorious, $ct!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105605,'Howdy! What can I do fer ya?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105606,'','Yalia, I made a terrible mistake. All of this - fighting the war, risking my life, enjoying the sunrise - is MEANINGLESS without you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105607,'','Chen, I wondered how long it would take for you to come to your senses.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105610,'Greetings. I am here to test your strength.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105611,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,0,38261,0,0,26124),
(105612,'Are you prepared to begin the trial?','',0,0,0,0,0,0,0,0,0,38319,0,0,26124),
(105613,'Quickly now, $n! Jandvik must know of our triumph!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105614,'','Citizens of Jandvik! Gather round the fire and hear the glorious news!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105615,'I want to hire a personal bodyguard.','I want to hire a personal bodyguard.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105616,'You know... I hear if you drop these on someone from high enough up it will kill them.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105617,'An Underbelly Guard will protect you from other players\' attacks for 5 minutes.\n\nDo you want to hire a bodyguard?','An Underbelly Guard will protect you from other players\' attacks for 5 minutes.\n\nDo you want to hire a bodyguard?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105618,'','We have lost much at the hands of the Sashj\'tar. Calder, Eynar, and Jarl Throndyr have all fallen to their treachery.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105619,'','Hail the glorious dead!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105620,'','We all owe Jandvik\'s salvation to one brave $c. Glory to $n! Slayer of Tidemistress Sashj\'tar!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105621,'','As sole remaining elder of Jandvik, it is my duty to lead Jandvik into prosperity.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105622,'','For this, I proclaim that $n is the new Jarl of Jandvik. All hail $n!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105623,'You are not ready to begin your trial.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105624,'What else could we throw?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105625,'I think I hit something...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105626,'Hail the glorious dead!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105627,'Hail Jarl $n! Hail!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105628,'I must retrieve an artifact from Tirisfal Glades.','I must retrieve an artifact from Tirisfal Glades.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105629,'','Hail the fallen!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105630,'','Hail $n! Savior of Jandvik!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105631,'Lord Illidan would be pleased.','',0,0,0,0,0,0,0,0,0,0,58219,0,26124),
(105632,'The Legion will fall by our hands!','',0,0,0,0,0,0,1,0,0,0,64713,0,26124),
(105633,'Now we can use the Fel Hammer to plan our assault on the Legion... all thanks to you!','',0,0,0,0,0,0,1,0,0,0,64698,0,26124),
(105634,'Every moment counts! You should return to Dalaran and secure passage to the Broken Isles at once.','',0,0,0,0,0,0,1,0,0,0,64699,0,26124),
(105635,'Step right up! Behold the amazing magical talents of the Great Akazamzarak!','',0,0,0,0,0,0,22,0,0,48928,61692,0,26124),
(105636,'Gather \'round and witness mystical wonders like you\'ve never seen before!','',0,0,0,0,0,0,1,0,0,48928,61693,0,26124),
(105637,'Let\'s keep the show moving! The Great Akazamzarak appreciates your coin!','',0,0,0,0,0,0,5,0,0,48928,61694,0,26124),
(105638,'Ladies and gentlemen, feast your eyes on these feats of prestidigitation!','',0,0,0,0,0,0,1,0,0,48928,61695,0,26124),
(105639,'Gaze in astonishment as I produce a rabbit from this ordinary hat!','',0,0,0,0,0,0,0,0,0,48928,61700,0,26124),
(105640,'Thank you, thank you. Your tips are appreciated.','',0,0,0,0,0,0,0,0,0,48928,61701,0,26124),
(105641,'And now for my next trick! As you can see, there\'s nothing up my sleeve...','',0,0,0,0,0,0,0,0,0,48928,61702,0,26124),
(105642,'And... bam!','',0,0,0,0,0,0,0,0,0,48928,61703,0,26124),
(105643,'','Gaze into the nether crucible. It will show you what we have seen.',0,0,0,0,0,0,0,0,0,0,0,64706,26124),
(105644,'Okay, for this trick I\'ll need a volunteer.','',0,0,0,0,0,0,1,0,0,48928,61704,0,26124),
(105645,'Pick a card, any card...','',0,0,0,0,0,0,0,0,0,48928,61705,0,26124),
(105646,'Wow! A golden Dr. Boom!','',0,0,0,0,0,0,5,0,0,48928,0,0,26124),
(105647,'Hey! Not that card! Give it back!','',0,0,0,0,0,0,61,0,0,48928,61706,0,26124),
(105648,'Kill the intruder!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105649,'You have come to die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105650,'A $r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105651,'Destroy the $c!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105652,'','Destroy the $c!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105653,'','A $r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105654,'','You have come to die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105655,'','Kill the intruder!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105657,'I will flay you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105658,'I will sharpen my blade with your bones!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105659,'Heave!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105660,'','Fine work. Three more to go.',0,0,0,0,0,0,0,0,0,0,0,67431,26124),
(105661,'I don\'t trust her.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105662,'Who does she think she is?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105663,'Something foul is afoot.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105664,'','I don\'t trust her.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105665,'','Who does she think she is?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105666,'','Something foul is afoot.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105667,'Now that\'s what I call a tip!','',0,0,0,0,0,0,5,0,0,0,61696,0,26124),
(105668,'Show\'s over, folks! Go on, scram!','',0,0,0,0,0,0,0,0,0,0,61697,0,26124),
(105669,'|TInterface\\Icons\\Ability_Warlock_ImprovedSoulLeech:20|t %s begins to |cFFFF0000|Hspell:194325|h[Fragment]|h|r $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105670,'','The Dark Lady has lent her rangers to your cause, $ct.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105671,'','The Sentinels stand ready to assist you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105672,'','It is done! The station is back online.',0,0,0,0,0,0,0,0,0,0,0,67432,26124),
(105673,'','Refined leyline energy will flow from here to Shal\'Aran.',0,0,0,0,0,0,0,0,0,0,0,67433,26124),
(105674,'A fine hall ya have here!','',0,0,0,0,0,0,1,0,0,0,66587,0,26124),
(105675,'I\'ve got you!','',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(105676,'','I walk in shadow.',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(105677,'','Hey mon, you not be comin\' ta Zen\'tabra for some fish. What ya be wantin\'?',0,0,0,0,0,0,0,0,0,0,0,69887,26124),
(105678,'','I\'m gonna light you up!',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(105679,'Frost mage intro + Frostbolt A','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105680,'Frostbolt explanation','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105681,'May your soul find its way to Valhalas.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105682,'Hail Jarl Throndyr!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105683,'','Hail Jarl Throndyr!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105684,'Hail Jarl Throndyr!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105685,'Hail Jarl Throndyr!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105686,'','Now that the portal has been opened, the path to Azoran is clear.',0,0,0,0,0,0,0,0,0,0,0,67601,26124),
(105687,'','Monks of the Broken Temple!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(105688,'','Today, we have gained new strength thanks to our leader, $n.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(105689,'','With the legendary Storm Brew, our efforts in the war against the Legion will redouble!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(105690,'','Let us fight for the fallen, and bring peace to this world once again!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(105691,'','Thank you again, Master $n.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(105697,'|TInterface\\Icons\\Spell_Holy_BorrowedTime:20|tRe-engage Advisor Vandros before you are |cFFF00000|Hspell:203935|h[Lost In Time]|h|r!','|TInterface\\Icons\\Spell_Holy_BorrowedTime:20|tRe-engage Advisor Vandros before you are |cFFF00000|Hspell:203935|h[Lost In Time]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105698,'My, my... Someone has made quite a mess down here. It has been too long since we purged these catacombs of refuse. It appears we have a rat infestation.','',0,0,0,0,0,0,0,0,0,0,57781,0,26124),
(105699,'Find the vermin and bring me their heads! Leave no stone unturned!','',0,0,0,0,0,0,0,0,0,0,57780,0,26124),
(105700,'I have not survived for ten thousand years just to fall to a swarm of rats.','',0,0,0,0,0,0,0,0,0,0,57783,0,26124),
(105701,'The Grand Magistrix... will have your heads for this...','',0,0,0,0,0,0,0,0,0,0,57782,0,26124),
(105702,'Alas... blind courage only triumphs in the fairy tales.','',0,0,0,0,0,0,0,0,0,0,57776,0,26124),
(105703,'For the glory of Elisande!','',0,0,0,0,0,0,0,0,0,0,57779,0,26124),
(105704,'So brave, but so... shortsighted.','',0,0,0,0,0,0,0,0,0,0,57778,0,26124),
(105705,'Think of this as a mercy killing.','',0,0,0,0,0,0,0,0,0,0,57777,0,26124),
(105706,'Enough! You little beasts are getting out of hand!','',0,0,0,0,0,0,0,0,0,0,57786,0,26124),
(105707,'Have you vermin ever witnessed such raw power? I think not.','',0,0,0,0,0,0,0,0,0,0,57785,0,26124),
(105708,'I am a conduit of the Nightwell\'s glorious power! I am NIGHTBORNE!','',0,0,0,0,0,0,0,0,0,0,57784,0,26124),
(105710,'Form up, maggots! Secure the breach until we receive orders from Gul\'dan!','',0,0,0,0,0,0,0,0,0,0,57770,0,26124),
(105711,'Good! Some entertainment! I was getting restless!','',0,0,0,0,0,0,0,0,0,0,57772,0,26124),
(105712,'Gather, minions! Feast on their corpses while the blood is still warm!','',0,0,0,0,0,0,0,0,0,0,57766,0,26124),
(105713,'No... NO! None can best... the great Xakal...','',0,0,0,0,0,0,0,0,0,0,57771,0,26124),
(105714,'No match for the great Xakal!','',0,0,0,0,0,0,0,0,0,0,57769,0,26124),
(105715,'Another notch on my fel blade!','',0,0,0,0,0,0,0,0,0,0,57768,0,26124),
(105716,'More fuel to stoke the fel fires!','',0,0,0,0,0,0,0,0,0,0,57767,0,26124),
(105717,'Reinforcements to me! NOW!','',0,0,0,0,0,0,0,0,0,0,57775,0,26124),
(105718,'All in my shadow will crumble and fall!','',0,0,0,0,0,0,0,0,0,0,57774,0,26124),
(105719,'All who rise against the Legion are doomed!','',0,0,0,0,0,0,0,0,0,0,57773,0,26124),
(105725,'','Do not worry about reinforcements. I will guard this portal with my life.',0,0,0,0,0,0,0,0,0,0,0,71817,26124),
(105726,'','Time is short... Go swiftly!',0,0,0,0,0,0,0,0,0,0,0,71818,26124),
(105727,'Sk\'shuul agth vorzz N\'Zoth naggwa\'fssh!','',0,0,0,0,0,0,0,0,0,0,26341,0,26124),
(105728,'I will need your healing powers, champion. I cannot face this demon alone.','',0,0,0,0,0,0,0,0,0,0,61946,0,26124),
(105729,'Sk\'yahf agth huqth N\'Zoth qornaus...','',0,0,0,0,0,0,0,0,0,0,26339,0,26124),
(105730,'The nerve! You must stop the Blackswell from darkening the hearts of these poor Rockaway murlocs!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105731,'So brave! So cunning! I\'m glad an adventurer like you is willing to think of the murlocs! Thank you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105732,'We will bring death to the Sashj\'tar!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105733,'Attack, $n! Attack!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105734,'A fine shot!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105735,'Send them back to the abyss!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105736,'Break their lines!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105737,'A spectacular hit, $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105738,'Again! Again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105739,'For Throndyr!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105740,'They will never make it to Jandvik!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105741,'We will slay them all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105742,'','You are dismissed. I will make my own way to Shal\'Aran.',0,0,0,0,0,0,0,0,0,0,0,67429,26124),
(105743,'Damn! You\'ll need to destroy the wards sustaining that barrier before you can engage Varedis.','',0,0,0,0,0,0,0,0,0,0,58246,0,26124),
(105744,'They\'ve spotted you. Hurry!','',0,0,0,0,0,0,0,0,0,0,58247,0,26124),
(105745,'To hell with landing! Dive into the hold yourself. Show them your power!','',0,0,0,0,0,0,0,0,0,0,58248,0,26124),
(105746,'The fools think they can stand against you. Show them the price of their arrogance!','',0,0,0,0,0,0,0,0,0,0,58249,0,26124),
(105747,'The Legion won\'t soon forget this day.','',0,0,0,0,0,0,0,0,0,0,58256,0,26124),
(105748,'We\'ve rid the skies of the worst of them. We should have a clear shot to Dalaran from here.','',0,0,0,0,0,0,0,0,0,0,58257,0,26124),
(105749,'No, no, no... this is all out of sorts. Who would leave the library like this?!','No, no, no... this is all out of sorts. Who would leave the library like this?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105750,'What are you doing? Run, you fools! The demon is near!','',0,0,0,0,0,0,0,0,4,0,60313,0,26124),
(105751,'This chest is.... rotted through. How strange.','This chest is.... rotted through. How strange.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105752,'I will tell you... nothing! What lies beneath will be the end of you!','',0,0,0,0,0,0,0,0,0,0,60456,0,26124),
(105753,'What transpired down below? Tell us, spirit!','What transpired down there? Tell us, spirit!',0,0,0,0,0,0,0,0,0,0,60455,0,26124),
(105754,'This be... my final plunder...','',0,0,0,0,0,0,0,0,0,0,57458,0,26124),
(105755,'','Come on, I\'ll keep you healed. Let\'s take this dragon down!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105756,'','The demons are desecrating our fallen chieftains, resurrecting them as mindless pawns to their evil will. Destroy these corrupt remains so they may rest once again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105757,'','May the chieftains of ages past rest undisturbed in their graves.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105758,'','You got this, Uncle Chen!',0,0,0,0,0,0,0,0,0,0,0,62021,26124),
(105759,'','$GHe\'s:She\'s; a real hero!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105760,'','The Feltotem and their demon allies are using our sacred burial grounds as a conduit to raise the dead for their own purposes. Defeat the risen dead and lay them to rest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105761,'','I can only hope they are unable to reanimate the dead after being destroyed by your artifact.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105762,'Darksorrow and Ravencrest will join you on the hunt, $n. You should be able to slip into the hold undetected.','',0,0,0,0,0,0,0,0,0,36910,64627,0,26124),
(105763,'','<Valtrois does not respond. Her expression betrays a deep pain welling within.|cFFF92304Her hunger must be sated before all else.|r>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105764,'','We once nursed upon the very essence of magic itself. An elixir to rival even the Well of Eternity.$B$BTo think we now resort to bottom-feeding.$B$B<Valtrois curls her lips in disgust.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105765,'Our forces should meet the enemy here...','Our forces should meet the enemy here...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105766,'','Demons and feltotem occupy one of the holiest sites in Highmountain. Kill them all! Banish them from this place!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105767,'Didn\'t we already defeat them there? I\'m confused.','Didn\'t we already defeat them there? I\'m confused.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105768,'','Their ranks are Legion, but you have quelled their efforts here for a time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105769,'','At long last. Sustenance worthy of a Nightborne.$B$BI suppose I owe you my gratitude.$B$B<Valtrois spares you a curt nod.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105770,'','The Eredar lead the demonic forces at the burial ground, bringing back our chieftains and other fallen as cursed husks. Perhaps if we put an end to the Eredar, we can slow them down.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105771,'','Without leadership, I can only hope that the demons lose sight of their goals and leave our dead alone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105772,'','<The arcanist raises an eyebrow at your greeting.>\n\nListen closely: \"val-TROIS.\"\n\nThe \"s\" is silent.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105773,'No, I don\'t think... or, wait... I can\'t... why can\'t I remember?','No, I don\'t think... or, wait... I can\'t... why can\'t I remember?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105774,'Keep your guard up out there. Varedis\' skills are the stuff of legend.','',0,0,0,0,0,0,0,0,0,0,64628,0,26124),
(105775,'My... thanks. Though we have never met before, I sense great courage in your heart. Yes... you are the hero I need!','',0,0,0,0,0,0,0,0,0,0,60457,0,26124),
(105776,'Long ago, my yearning for knowledge led me here, to a tomb that lies beneath the lake. Within its cold stone walls, I found something long buried... a terrible darkness, an ancient evil.','',0,0,0,0,0,0,0,0,0,0,60458,0,26124),
(105777,'','Eugh... I will never get used to that.',0,0,0,0,0,0,0,0,0,0,0,67408,26124),
(105778,'','Is there no more? Hm.. that will have to suffice.',0,0,0,0,0,0,0,0,0,0,0,67415,26124),
(105779,'','Ick... bitter. We must find a better solution!',0,0,0,0,0,0,0,0,0,0,0,67416,26124),
(105780,'My staff and keg are pledged to you, Grandmaster. Call upon me, and I will fight for our order!','',0,0,0,0,0,0,2,0,0,0,66706,0,26124),
(105781,'My men begged me to walk away. I refused. My pride would be my downfall... and theirs. The evil stirred, unleashing death upon us. With my last breath, I drove my blade, Strom\'kar, into the beast\'s skull.','',0,0,0,0,0,0,0,0,0,0,60459,0,26124),
(105782,'For many ages, the sword has kept the beast from rising again. But now it stirs once more, so I must ask you to delve into the depths of the tomb and finish what I started. I will go with you, to offer what aid I can.','',0,0,0,0,0,0,0,0,0,0,60460,0,26124),
(105783,'Down there a malevolent creature is slowly coming back to life despite my sacrifice. You must brave its corrupted depths and slay it for the last time. I will share what knowledge I have with you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105784,'','Hmph. I was fine. You need not concern yourself.',0,0,0,0,0,0,0,0,0,0,0,67417,26124),
(105785,'','I am restored!',0,0,0,0,0,0,0,0,0,0,0,67399,26124),
(105786,'','Ru shanna shal\'dorei.',0,0,0,0,0,0,0,0,0,0,0,67406,26124),
(105787,'','I shall not squander this gift.',0,0,0,0,0,0,0,0,0,0,0,67407,26124),
(105788,'You will not leave here alive!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105789,'The Sashj\'tar will triumph!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105790,'Ssslaughter and ssslay!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105791,'Trespasser!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105792,'These are Sashj\'tar waters!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105793,'Death comes to you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105794,'I will ssslay you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105795,'You will not interfere.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105796,'Curse and death!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105797,'We... will... ssslay... you... all...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105798,'Darknesss...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105799,'For the Tidemistress!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105800,'We will not be ssstoped...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105801,'I return to the abysss...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105802,'Sashj\'tar...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105803,'I have failed...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105804,'','You dare enter our domain!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105805,'','I will ssslay you in the name of the Tidemistress!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105806,'','You will not stop usss!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105807,'','You will meet you end in the deep!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105808,'','I will cut you into eel food!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105809,'','You trespasss in Sashj\'tar waters!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105810,'','Death comes to you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105811,'','Ssslay the intruder!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105812,'','My life for the Sashj\'tar...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105813,'','I curse you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105814,'','My death mattersss not...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105815,'','You cannot stop the Tidemistresss...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105816,'','We... cannot be... ssstopped...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105817,'','Darkness in the deep...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105818,'','You slime...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105819,'','Tidemistresss...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105820,'I\'ll meet you there.','',0,0,0,0,0,0,1,0,0,0,64626,0,26124),
(105821,'Naralex is not here, but you can faintly detect his scent.','Naralex is not here, but you can faintly detect his scent.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(105822,'Alright Akazamzarak, you have the locations. Do you think you can manage the portals?','',0,0,0,0,0,0,0,0,0,0,61738,0,26124),
(105823,'No sweat, chum! I\'ll get your mages here in a jiffy!','',0,0,0,0,0,0,0,0,0,0,61739,0,26124),
(105824,'Mages of Azeroth! I have summoned you here because we face a threat to the future of the world itself!','',0,0,0,0,0,0,0,0,0,0,61740,0,26124),
(105825,'The dreadlord Kathra\'natir has escaped into the Twisting Nether, carrying with him the secrets of the Council of Tirisfal.','',0,0,0,0,0,0,0,0,0,0,61742,0,26124),
(105826,'We must hunt him down in the Twisting Nether. Only then will we know his knowledge cannot be used against us.','',0,0,0,0,0,0,0,0,0,0,61743,0,26124),
(105827,'To this end, I hereby reform the Tirisgarde. Will you join us and take up arms against the Legion?','',0,0,0,0,0,0,0,0,0,0,61744,0,26124),
(105828,'It is done, then.','',0,0,0,0,0,0,1,0,0,0,61745,0,26124),
(105829,'Very well. Here, in presence of many of Azeroth\'s greatest mages, it is my honor to dub you $n, Conjuror of the Tirisgarde.','',0,0,0,0,0,0,1,0,0,0,61746,0,26124),
(105830,'This ancient title symbolizes the awesome responsibility borne by the Tirisgarde. May you carry it with honor.','',0,0,0,0,0,0,1,0,0,0,61747,0,26124),
(105831,'It is time to meet with our new goblin ally in the War Room. You can begin planning your next steps there.','',0,0,0,0,0,0,0,0,0,0,61748,0,26124),
(105832,'See you there.','',0,0,0,0,0,0,1,0,0,0,58208,0,26124),
(105833,'Come to me, my pets.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105834,'Your master needs you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105835,'Feast upon their bones!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105836,'I want to know more about you.','I want to know more about you.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105837,'I don\'t trust your kind, \"demon hunter\".$B$BYou and the Legion are one and the same in my book.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(105838,'Let us inside or I\'ll show you the difference.','Let us inside or I\'ll show you the difference.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105839,'There\'s no time to explain. Let us inside the hold, warden.','There\'s no time to explain. Let us inside the hold, warden.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105840,'If you don\'t have time to explain, then I don\'t have time to waste on you.','',0,0,0,0,0,0,14,0,0,0,64624,0,26124),
(105841,'I am Thoradin, first king of Arathor. \n\nLong ago humans were warring tribes of barbarians, slowly being exterminated by the trolls. My tribe, the Arathi, and I unifed the tribes to form the kingdom of Arathor. With my noble brothers Ignaeus and Lordain we pushed back the trolls, though I knew it was but temporary.\n\nAfter a time we allied with the elves and fought the longest and bloodiest war humanity had ever seen. If not for the arrogance of the trolls we would have perished. Instead we gained the strongest of friendships with the elves, and the teachings of their magic. The cost was countless soldiers and my great friend, Lordain.\n\nOnce the kingdom was safe and growing ever stronger I relinquished my crown and began my quest.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105842,'What happened here?','What happened here?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105843,'Is that a threat?$B$BNeed I remind you that you are surrounded by my guards in my prison.','',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(105844,'Do you want to find out?','Do you want to find out?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105845,'What do you have to lose either way?','What do you have to lose either way?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105846,'After seeing Arathor in good hands, I took my closest retainers and began my quest for the origins of our tribes. We roamed throughout these lands digging up pieces of the past until our path came here.\n\nIn my excitement and need for answers I ignored the warnings and had my mages break open the seals to something beneath this lake. It was a tomb like nothing I had ever seen before. We were so close and rushed in deeper before truly understanding what we were seeing. Lying there was the being that brought our ancestors here, bearing the symbol that had haunted and inspired people from this area forever.\n\nBut that wasn\'t all. The monster this \"Tyr\" fought also lay here, and I had broken the seals that kept it dead.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105847,'The eredar you\'re holding possesses critical information. We need a few minutes alone with him.','',0,0,0,0,0,0,1,0,0,36910,64625,0,26124),
(105848,'It was dead but awoke?','It was dead but awoke?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105849,'All we want is a few moments with the eredar... alone. He has information we need.','',0,0,0,0,0,0,1,0,0,36911,58207,0,26124),
(105850,'Good ta see yeh again, $glad:lass;! These elves need all tha \'elp we can give \'em!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105851,'You\'re fortunate that Khadgar trusts you. But make no mistake... I do not share his sentiment.','',0,0,0,0,0,0,1,0,0,0,64622,0,26124),
(105852,'Fair enough. Let\'s get this over with, then.','',0,0,0,0,0,0,1,0,0,0,64623,0,26124),
(105853,'It had been laying down there for countless centuries, its master an ancient evil that Tyr fought even longer ago. With the seals down it began to heal and in its awakening it called deep below the earth for aid.\n\nHorrific creatures crawled out of the chasm inside the prison and we were attacked. I knew I had made a terrible mistake, this thing was more powerful than even the trolls. I knew it had to be stopped before fully awakening.\n\nWe made the ultimate sacrifice. Even barely conscious the monster killed the last of my comrades easily, but they gave me time. I managed to bury my sword, Strom\'kar, into its brain even as its claws crushed the life from me.\n\nIt is dead, but the seals cannot be replaced. Its death is only temporary.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105854,'Of course.','',0,0,0,0,0,0,1,0,0,0,64642,0,26124),
(105855,'Tell me about your sword that keeps the monster dead.','Tell me about your sword that keeps the monster dead.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105856,'Puny slime! My eels will eat you alive!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105857,'My... eels...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105858,'Who disturbs my sleep?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105859,'Eternal... slumber...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105860,'No need to be quiet, $n. The trees already whispered to me of your arrival.','',0,0,0,0,0,0,0,0,0,0,69914,0,26124),
(105861,'<Naralex sits quietly with his eyes shut.>','<Naralex sits quietly with his eyes shut.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105862,'I call it Strom\'kar, the Warbreaker.\n\nThe Arathi held to the oldest ways of weaponsmithing, older than I can remember. I used those and special metals to craft my sword. Then I took it through the greatest battles any of us had ever seen and it never let us down. It has saved my life many times and turned many a battle in my hands to victory.\n\nAfter the Troll Wars the grateful elves gave me a personal gift. Their greatest mages and smiths took Strom\'kar and empowered it with strong elven enchantments. I think it is that magic that is keeping the creature from awakening. I fear what centuries of lying buried in that monster has done to the Warbreaker.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105863,'<Quietly stand nearby.>','<Quietly stand nearby.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105864,'<Gently tap on his shoulder.>','<Gently tap on his shoulder.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105865,'Is it time for the ritual to begin? Very well, I\'ll meet you there.','',0,0,0,0,0,0,0,0,0,0,69915,0,26124),
(105866,'Even in death, the monster is restless. Its corruption has spread throughout the tomb. You will have to fight your way through!','',0,0,0,0,0,0,1,0,0,0,60461,0,26124),
(105867,'','Ya be needin\' something?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105868,'Your efforts mean NOTHING! Soon all of Suramar will bow to my master\'s will!','',0,0,0,0,0,0,0,0,0,0,64649,0,26124),
(105869,'Malfurion is ready to begin. He asks that you head to the ritual site.','Malfurion is ready to begin. He asks that you head to the ritual site.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105870,'Death to the Sashj\'tar!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105871,'','Now\'s our chance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105872,'Kill the naga!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105873,'','So, time to see if we can really be makin\' this happen. This gonna\' be needin\' everything we have ta give and more.',0,0,0,0,0,0,0,0,0,0,0,69888,26124),
(105874,'','Zen\'tabra closes her eyes for a moment.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105875,'I will ensure no one interferes. The demon is all yours.','',0,0,0,0,0,0,0,0,0,0,64636,0,26124),
(105876,'Do not test our patience. Tell us where your master is... or die!','',0,0,0,0,0,0,1,0,0,0,64645,0,26124),
(105877,'That\'s all we needed. Finish him off.','',0,0,0,0,0,0,0,0,0,0,64647,0,26124),
(105878,'Sssssssssssssssssssssssssss...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105879,'Disrupting Portal','Disrupting Portal',0,0,0,0,0,0,0,0,0,38172,0,0,26124),
(105880,'I will prepare a fel bat at Krasus\' Landing to take you to Suramar. Varedis\' time has come.','',0,0,0,0,0,0,1,0,0,0,64640,0,26124),
(105881,'','De spirits, they be silent ta\' me on dis. That mean dey not opposed ta it either. Very well, I\'ll meet ye at da ritual.',0,0,0,0,0,0,0,0,0,0,0,69889,26124),
(105882,'You can be prisoners for the Tidemistress now or I can ssslay you now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105883,'Vile... ssslime...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105884,'No no! Lift more! Lift!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105885,'My shinies!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105886,'Hurry! Darkness come soon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105887,'Too heavy. Lift more!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105888,'','Gratitude, stranger.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105889,'I notice you\'re not wearing any earrings. Could I interest you in pair of bolt-action carbine hoops? They\'re not very rusty!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105890,'Those murlocs be up ta no good, oh aye. I know this \'cause I can smell somethin\' fishy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105891,'When I saw this antechamber, I knew we had found something... momentous. Here was a door so oddly familiar, like a long-forgotten memory. We broke the first seal.','',0,0,0,0,0,0,0,0,0,0,60462,0,26124),
(105892,'Portals are good to go, boss! Now if ya don\'t mind, I\'m gonna check out the digs here...','',0,0,0,0,0,0,0,0,0,0,61741,0,26124),
(105893,'Couple of quick tips \'bout them booties. As soon as yeh activate them, yer gonna take off faster than a rogue in an arena match.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105894,'Fresh! Meat!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105895,'Still... hungry...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105896,'Tasty morsel.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105897,'Eat you up.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105898,'Crunchy bones.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105899,'','...and bring the outlander with you.',0,0,0,0,0,0,396,0,0,0,0,67247,26124),
(105900,'','If... you insist.',0,0,0,0,0,0,2,0,0,0,0,67246,26124),
(105901,'','And Valtrois?',0,0,0,0,0,0,396,0,0,0,0,67255,26124),
(105902,'','You would be wise not to turn your nose up at the outsiders. None of us would be here without their help.',0,0,0,0,0,0,1,0,0,0,0,67256,26124),
(105903,'','Of course, First Arcanist.',0,0,0,0,0,0,273,0,0,0,0,67257,26124),
(105904,'','Come, we can examine the feed from down here.',0,0,0,0,0,0,0,0,0,0,0,67248,26124),
(105905,'','Hail $c!$B$BI tracked a group of Sashj\'tar across the bay to this cave.$B$BMany fell to my blade, but a few managed to slither away. I have little doubt that they will return with greater numbers to try and slay me.$B$BIf you welcome a glorious battle, bolster yourself and ready your weapon.$B$BIf not, stay out of my way or I will kill you myself.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105906,'','Do you have much experience with leyline energy? I should think not.',0,0,0,0,0,0,0,0,0,0,0,67249,26124),
(105907,'','Allow me to educate you on the fundamentals.',0,0,0,0,0,0,0,0,0,0,0,67250,26124),
(105908,'','You are a fine $c. I would gladly fight by your side again!$B$BWhen I return to Jandvik, we shall sing songs of our battle over flagons of ale!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105909,'','Far below us, rivers of raw arcane power course throughout the land. The leylines are eternal, primal, and impossible to control.',0,0,0,0,0,0,0,0,0,0,0,67251,26124),
(105910,'Let the Sashj\'tar come!','Let the Sashj\'tar come!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105911,'','However, just as one pulls thread from cotton, so too can we draw power from the leylines.',0,0,0,0,0,0,0,0,0,0,0,67252,26124),
(105912,'Ye\'ll be goin\' so fast, ye\'ll stay afloat. So mind yer ammo, cause when it runs out, yer goin\' kerplunk into tha water.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105913,'As soon as yeh stop, everythin\' will reset an\' yeh should be good ta go fer another try.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105914,'Hobart\'s not gonna be too \'appy to \'ear about \'is gunpack. How \'ave ye been, $glad:lass;?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105915,'','Whatever you\'re hunting, Razik has a gadget that\'s guaranteed to take your target down.\n\nHis latest prototypes are preloaded and ready to go. Just grab one from the weapon rack and start shooting.\n\nJust remember, you test at your own risk!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(105916,'We gotta get to Brambley, before it\'s too late!','',94,0,0,0,0,0,0,0,0,38708,0,0,26124),
(105917,'Aye, let\'s get him the key... but be on your guard. This place is crawling with demons.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105918,'Brambley! No... no it canna\' be true!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105919,'Look! That\'s Brambley\'s helm, I\'d recognize it anywhere!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105920,'Those demons musta\' ate ol\' Brambley... look at him! He\'s just bones, now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105921,'Ice Lance Intro','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105922,'Ice Lance explanation\n(Icelance does double damage against frozen targets)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105923,'As I feared, one of the monster\'s minions has returned. Its presence is corrupting the wards of the tomb and blocking the path. You must destroy the tendrils to draw it out!','',0,0,0,0,0,0,0,0,0,0,60463,0,26124),
(105924,'Curses upon ye, demons! CURSES UPON YE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105925,'','Here they come!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105926,'','We are victorious!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105927,'There it is... atop the crypt! Prepare yourself!','',0,0,0,0,0,0,0,0,0,0,60465,0,26124),
(105928,'Blizzard Intro','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105929,'Blizzard Explanation','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105930,'','See here. This is the feed from Anora. And there are many others still lying dormant.',0,0,0,0,0,0,0,0,0,0,0,67253,26124),
(105931,'','Restore them, and help us create a new locus of power here in Shal\'Aran!',0,0,0,0,0,0,0,0,0,0,0,67254,26124),
(105932,'You will answer for the Sashj\'tar you have ssslain!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105933,'Curse... you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105934,'We lost contact with one of my pathfinder teams that was scouting the Greystone area. Please, find them.','',0,0,0,0,0,0,0,0,0,0,57223,0,26124),
(105935,'Thank you, champion. I appreciate you preventing my people from being reduced to basilisk chow.','',0,0,0,0,0,0,0,0,0,0,57224,0,26124),
(105936,'The Bitestone keep stealing goods from my people. Time to steal some of it back. Up for a little burgling?','',0,0,0,0,0,0,0,0,0,0,57225,0,26124),
(105937,'Ha! Bitestones. All brul and no brains. Well done!','',0,0,0,0,0,0,0,0,0,0,57226,0,26124),
(105938,'Ha! That should slow down their efforts to get organized.','',0,0,0,0,0,0,0,0,0,0,57227,0,26124),
(105939,'My pathfinders tracked a pair of Stonebinders to Bitestone Enclave. They were disciples of Dargrul and are very dangerous. This is a meeting that must be stopped.','',0,0,0,0,0,0,0,0,0,0,57228,0,26124),
(105940,'','The Basilisk Bazaar is a very dangerous event held by the drogbar where they trade, fight, and skin their lizard pets. Disrupting this will set their forces back a peg or two and keep our local farmlands safe for a time.',0,0,0,0,0,0,0,0,0,0,0,63250,26124),
(105941,'','I used to applaud the drogbar\'s kinship with nature until they used it to slaughter my people and attack my lands. You have my thanks, champion.',0,0,0,0,0,0,0,0,0,0,0,63255,26124),
(105942,'','Shardmasters from Greystone are performing some sort of empowering ritual within the chasm of the Crystal Fissure. This is too close to Thunder Totem for comfort. Can you stop them?',0,0,0,0,0,0,0,0,0,0,0,57231,26124),
(105943,'','Thank you, champion. The Greystone drogbar are getting far too ambitious these days.',0,0,0,0,0,0,0,0,0,0,0,57232,26124),
(105944,'I need crystals for my rituals and you need to have less furies amassing on the Thunder Totem border. I have a plan to get both of us what we want. How are your riding skills?','',0,0,0,0,0,0,0,0,0,0,57233,0,26124),
(105945,'Ah, excellent choice in crystals. This should be enough for my rituals.','',0,0,0,0,0,0,0,0,0,0,57234,0,26124),
(105946,'','I can hear the scream of the earth. The drogbar shardmasters are performing a dark ritual that drives these crystal furies into a horrendous rage. The furies must be stopped before they cause untold damage to Thunder Totem.',0,0,0,0,0,0,0,0,0,0,0,57235,26124),
(105947,'','I don\'t even want to guess how much damage those enraged furies could have unleashed upon Thunder Totem if left unchecked.',0,0,0,0,0,0,0,0,0,0,0,57236,26124),
(105948,'','Something dark is afoot in the Echoing Halls. We have felt a malevolent presence there perverting the waters that flow to the rest of the land. Find the source of the corruption and exterminate it.',0,0,0,0,0,0,0,0,0,0,0,57237,26124),
(105949,'','Every now and then something evil lurking in the deep places of the world decides to crawl up and threaten us. I am grateful you caught it early.',0,0,0,0,0,0,0,0,0,0,0,57238,26124),
(105950,'My pathfinders report a nest of kobolds is taking up residence in the Echoing Halls. Feel up for a rat chase?','',0,0,0,0,0,0,0,0,0,0,57239,0,26124),
(105951,'Kobolds cause a tremendous amount of damage with their sloppy mining techniques. That high up they could bring a chunk of that mountain down on top of us in no time. Well done rooting them out.','',0,0,0,0,0,0,0,0,0,0,57240,0,26124),
(105952,'','Are you in need of rest or healing today?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105953,'%s is |cFFFF0404|Hspell:204237|h[Gravely Wounded]|h|r and cannot fight until healed!','%s is |cFFFF0404|Hspell:204237|h[Gravely Wounded]|h|r and cannot fight until healed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(105954,'Thanks.','Thanks.',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(105955,'These demons are relentless!','These demons are relentless!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105956,'','Whatever you\'re hunting, Razik has a gadget that\'s guaranteed to take your target down.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(105957,'Thought I\'d never escape!','Thought I\'d never escape!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105958,'Not every day you get rescued by a $c!','Not every day you get rescued by a $c!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105959,'I\'m in your debt, $n.','I\'m in your debt, $n.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105960,'Quickly! There may be more coming soon.','Quickly! There may be more coming soon.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105961,'','So this is the Halls of Valor? Amazing. Wait... is that my master?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105962,'','Over there, on the right. That must be the cauldron we are looking for.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105963,'Alright, let\'s see if I can get a portal through those wards you\'re talkin\' about.','',0,0,0,0,0,0,1,0,0,0,61698,0,26124),
(105964,'Piece o\' cake! See ya on the other side!','',0,0,0,0,0,0,1,0,0,0,61699,0,26124),
(105965,'Infidels! Submit to my will, or DIE in the flames of the Legion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105966,'','I ssshould thank you for doing my dirty work, $n. But now you are proving too troublesome to keep alive.',0,0,0,0,0,0,0,0,0,37846,0,0,26124),
(105967,'','Without its leaders, I will easily destroy Jandvik from within!',0,0,0,0,0,0,0,0,0,37846,0,0,26124),
(105968,'','My naga will wash over Jandvik in a tidal wave of destruction!',0,0,0,0,0,0,0,0,0,37846,0,0,26124),
(105969,'|TInterface\\Icons\\Ability_Rogue_DeviousPoisons:20|t Nythendra infests you with |cFFFF0404|Hspell:204463|h[Volatile Rot]|h|r!','|TInterface\\Icons\\Ability_Rogue_DeviousPoisons:20|t Nythendra infests you with |cFFFF0404|Hspell:204463|h[Volatile Rot]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(105970,'It is done. Thank you, hero.','',0,0,0,0,0,0,0,0,0,0,61724,0,26124),
(105971,'Nice place ya got here!','',0,0,0,0,0,0,1,0,0,0,61737,0,26124),
(105972,'','The Burning Legion has been dealt a great blow this day, but our work is far from over.',0,0,0,0,0,0,0,0,0,0,0,67600,26124),
(105973,'','I will wait for you in Shal\'Aran, return there when you are ready. We have much to discuss.',0,0,0,0,0,0,0,0,0,0,0,71819,26124),
(105974,'Find wood to construct a pyre. I will take care of moving his body.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105975,'<The vrykul barely acknowledges your presence.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105976,'A legion of these naga could not overpower Jarl Throndyr. Only their venomous treachery could defeat him.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105977,'<Throndyr lies dead in the mud.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105978,'I could not protect them all...','',0,0,0,1,0,0,603,0,0,0,0,0,26124),
(105979,'The Guard is no more.','',0,0,0,0,0,0,457,0,0,0,0,0,26124),
(105980,'','I didn\'t make it in time...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105981,'My bark is worse than my bite.','',0,0,0,0,0,0,0,0,0,0,57872,0,26124),
(105982,'I told you to leave me alone...','',0,0,0,0,0,0,0,0,0,0,57873,0,26124),
(105983,'... Ugh!','... Ugh!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105984,'What is this filth?!','What is this filth?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105985,'What is the meaning of this?!','What is the meaning of this?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105986,'It\'s... sticky!','It\'s... sticky!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105987,'Make like a tree, and get out of here.','',0,0,0,0,0,0,0,0,0,0,57874,0,26124),
(105988,'See you next fall.','',0,0,0,0,0,0,0,0,0,0,57875,0,26124),
(105989,'I want to say something clever, but I am stumped.','',0,0,0,0,0,0,0,0,0,0,57876,0,26124),
(105990,'To mulch!','',0,0,0,0,0,0,0,0,0,0,57877,0,26124),
(105991,'My precious books...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105992,'I seem to have lost my Trap Rune...','I seem to have lost my Trap Rune...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105993,'I have some personal business to attend to...','',0,0,0,0,0,0,0,0,0,0,61749,0,26124),
(105994,'','Without me, Jandvik will stand no chance in this battle. Come quickly!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105995,'Thanks for playing the Friends & Family Alpha!$B$BThis concludes the playable portion of the Demon Hunter experience.$B$BPlease try out the Level 100 character templates to access the Broken Isles.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105996,'Ha ha! You wish to go fist to tooth with that chomper?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(105997,'Brul, you got some stones to mess with THAT basilisk.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105998,'Ha! It\'s angry. You go, brul!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(105999,'Watch the left eye on that one. It\'s angry.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106000,'These monsters play tricks upon the mind. Beware their illusions!','',0,0,0,0,0,0,0,0,0,0,60466,0,26124),
(106001,'Its time we get to the root of the problem.','',0,0,0,0,0,0,0,0,0,0,57878,0,26124),
(106002,'You will be uprooted.','',0,0,0,0,0,0,0,0,0,0,57879,0,26124),
(106003,'You have been rooting around here too long.','',0,0,0,0,0,0,0,0,0,0,57880,0,26124),
(106004,'The magi of Ogri\'la stand with the Tirisgarde, Conjurer.','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(106005,'$p. Protect the Tidestone!','',0,0,0,0,0,0,0,0,0,0,58470,0,26124),
(106006,'Get away from me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106007,'Naga goon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106008,'I will eat your cold heart if I get out of here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106009,'Sea giant scum!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106010,'I\'m awake! Definitely NOT sleeping! I was just... just resting my eyes.','',0,0,0,0,0,0,0,0,0,0,69913,0,26124),
(106011,'Zen\'tabra\'s camp is on the western shore of the lake. Naralex was camped on the eastern shore, but he\'s prone to wandering off, so keep your eyes and ears open.','',0,0,0,0,0,0,0,0,0,0,62128,0,26124),
(106012,'Stop those colossal creatures, before they get any closer!','',0,0,0,0,0,0,0,0,0,0,58469,0,26124),
(106013,'I did not need your help.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106014,'Gratitude stranger.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106015,'I despise the sea!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106016,'Cold and wet!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106018,'I hope you choke!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106019,'They were going to eat me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106020,'Come closer, small ones.','',0,0,0,0,0,0,0,0,0,0,58468,0,26124),
(106021,'','That looks like the end of the naga siege.',0,0,0,0,0,0,0,0,0,0,0,58467,26124),
(106022,'Stay on your guard, small ones. I see Nightfallen on the horizon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106023,'They\'ve breached the front lines! Stop them, before they consume the Tidestone!','',0,0,0,0,0,0,0,0,0,0,58466,0,26124),
(106024,'','Look! They\'re headed for grandfather\'s pool!',0,0,0,0,0,0,0,0,0,0,0,63226,26124),
(106025,'Right! I\'ll shield the Tidestone. You heroes hold off that army of elves.','',0,0,0,0,0,0,0,0,0,0,58465,0,26124),
(106026,'Sorry I\'m late. Did I miss the party?','',0,0,0,0,0,0,0,0,0,0,58464,0,26124),
(106027,'Quite nearly. We could use your aid, wizard.','',0,0,0,0,0,0,0,0,0,0,58463,0,26124),
(106028,'I pluck you like a flower.','',0,0,0,0,0,0,0,0,0,0,57881,0,26124),
(106029,'My limbs will grow back, yours will not.','',0,0,0,0,0,0,0,0,0,0,57882,0,26124),
(106030,'I snap you like a twig.','',0,0,0,0,0,0,0,0,0,0,57883,0,26124),
(106031,'','Good girl, Korra.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106032,'|TInterface\\Icons\\ability_ironmaidens_bloodritual:20|tThe Scythe has overpowered Ariden! Keep him away from you to avoid |cFFFF0000|Hspell:204659|h[Bloodreap]|h|r !','The Scythe has overpowered Ariden! Keep him away from you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106033,'','Yes, Korra, we honor the spirits of the hunt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106034,'','Protect the shrine, girl.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106035,'Wh... WHAT TRICKERY IS THIS?!','',0,0,0,0,0,0,0,0,0,0,60271,0,26124),
(106036,'','Good boy, Dagri.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106037,'','We honor the spirits of the hunt, boy. It is our duty.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106038,'','Protect the lodge, boy. That\'s a good wolf!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106039,'Prepare yourself. Step into the circle when you are ready.','',0,0,0,0,0,0,0,0,4,0,62134,0,26124),
(106040,'Begone, filthy $c! Baelbug find the glaive and keeps it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106041,'The Rockaway murlocs are in pain! Their normally pure waters are full of muck. The Murkwater naga must be driven back to the depths!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106042,'Can\'t you see it? The water is already clearing up. The proud Rockaways send their thanks!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106043,'Yesssss... killl them all.','',0,0,0,0,0,0,0,0,0,0,53148,0,26124),
(106044,'Softsssskin fights well... retreat!','',0,0,0,0,0,0,0,0,0,0,53146,0,26124),
(106045,'We must make haste to the Violet Hold! \n\nKathra\'nathir must not be allowed access to the Forge of the Guardian!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106046,'The dreadlord Kathra\'natir is defeated, but only for now. If we wish to save Azeroth from his evil, we must reform the Tirisgarde. \n\nThen we can hunt him down in the Twisting Nether before he has a chance to share his secrets with the Burning Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106047,'Yes, $n?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106048,'What is the Forge of the Guardian?','What is the Forge of the Guardian?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106049,'Wait, who are you again?','Wait, who are you again?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106050,'Tell me more about the Tirisgarde.','Tell me more about the Tirisgarde.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106051,'','Our crops are dying! I don\'t know what the drogbar did or how they dug up even more insects to throw at us, but we need your help!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106052,'','Thank you for helping with the harvest, $n. Bugs make my old bones crawl...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106053,'The Forge of the Guardian is an artifact of incredible power. \n\nIt was devised by the Archmage Alodi as a method of permanently transferring the arcane power of many mages into the body of one, thus creating a Guardian of Tirisfal. \n\nThe last time it was used was in the time of Aegwynn. Since she refused to return her powers so another Guardian could be imbued, the forge was locked away behind the arcane barriers of the Violet Hold.\n\nIts location was known only to the Council. That is, until now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106054,'Pardon me, I forget that my name is not well known these days. \n\nI am Meryl Felstorm, once known as Meryl Winterstorm. I was a founding member of the Council of Tirisfal, but was required to abandon my duties when I became possessed by the dreadlord Kathra\'natir. I was able to contain him... for the most part... but the risk was too great for me to remain on the council.\n\nI have since dedicated my life to finding a way to banish the demon once and for all. It seems I have failed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106055,'','Kill one drogbar, and another comes out of the darkness to crap in our river! In my day, they stayed in their caves... Mind sending them back to the shadows?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106056,'','You\'ve got a light touch with that foot of yours. Most of those fish survived the kicking.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106057,'','These brutes have no respect for the spirits. They\'ve infested our sacred cavern with their stench!',0,0,0,0,0,0,0,0,0,0,0,76672,26124),
(106058,'','The spirits thank you. Hopefully the stink of drogbar doesn\'t linger too long.',0,0,0,0,0,0,0,0,0,0,0,76673,26124),
(106059,'The history of the Tirisgarde is a storied one. In short, it is a gathering of Azeroth\'s most battle-hardened mages armed with relics of great power. They are charged with defending Azeroth in the absence of the Guardian of Tirisfal. \n\nThey are normally only called together when the world faces a grave threat. The last time they were assembled was to bring back the rogue Guardian, Aegwynn. For centuries the Tirisgarde hunted her, utilizing some of the most powerful artifacts that Azeroth had known. \n\nWith the dissolving of the Council of Tirisfal, their mission was left unfinished. We will not let that happen here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106064,'Ye wanna fight, eh? I\'ll give ye a fight!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106065,'Who needs an axe when ye\'ve got fists o\' steel!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106066,'Och! This one fell off the ugly tree an\' hit my fists on the way down!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106067,'Who ordered a knuckle sandwich?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106068,'Now, THAT\'S a face worth punching!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106069,'Don\'t worry, I\'ll go easy on ye!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106070,'','Over here, shaman! We\'ve no time to lose.',0,0,0,0,0,0,0,0,0,0,0,60517,26124),
(106071,'Och, what happened to yer face? MAH FISTS!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106072,'Which fist do ye want? How about both!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106073,'Are you ready to begin, $n?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106074,'Let\'s begin the ritual.','Let\'s begin the ritual.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106075,'|TInterface\\Icons\\spell_nature_stranglevines:20|tUse |cFFFF0000|Hspell:339|h[Entangling Roots]|h|r, knockbacks, or stuns to keep Ariden away from you!','|TInterface\\Icons\\spell_nature_stranglevines:20|tUse |cFFFF0000|Hspell:339|h[Entangling Roots]|h|r, knockbacks, or stuns to keep Ariden away from you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106076,'<Thank you for playing. The second half of the Demon Hunter Intro in the Vault of the Wardens will be coming soon.>','',0,0,0,0,0,0,0,0,17,38477,0,0,26124),
(106077,'Behold the site of my final battle... and there lies my foe. Even now, Zakajz struggles for consciousness. You must hurry!','',0,0,0,0,0,0,0,0,6,0,60467,0,26124),
(106078,'','It\'s a massacre out there. All around the world, our forces fall back.',0,0,0,0,0,0,0,0,0,0,0,60518,26124),
(106079,'','Unless we find a way to turn this around, Azeroth will fall!',0,0,0,0,0,0,0,0,0,0,0,60519,26124),
(106080,'How can Calydus help you, friend?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106081,'Let me select my artifact.','Let me select my artifact.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106082,'Demon hunters? How odd, covering your eyes like that. Doesn\'t it make it hard to see the world around you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(106083,'Greetings to you both. The tremors from the Emerald Dream grow more potent. We must begin the ritual at once!','',0,0,0,0,0,0,0,0,4,0,62130,0,26124),
(106084,'','You have chosen well. Such a weapon will strike fear into the hearts of our foes!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106085,'These are dark times - I\'m glad you\'re with us.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(106086,'I\'m ready.','I\'m ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106087,'%s is |cFFFF0404|Hspell:204779|h[Drifting Away]|h|r! Dispel him!','%s is |cFFFF0404|Hspell:204779|h[Drifting Away]|h|r! Dispel her!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(106088,'Your human friend was taken by the demons. Grant me my freedom and I will tell you where he was taken!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106089,'If you want to kill more naga, bring me more cannonballs.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106090,'The blade was taken somewhere in northwestern Tirisfal. I\'ve marked a location on your map where you can begin your search.','',0,0,0,0,0,0,1,0,0,0,63431,0,26124),
(106091,'Here are the cannonballs. Let\'s go blast some naga.','If you want to kill more naga, bring me more cannonballs.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106092,'Welcome to the Dreamway, $n. A journey that would take days upon Azeroth is but a few steps here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106093,'Wait, I feel something... disturbing. Quickly $n, this way!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106094,'No! The Nightmare... in this part of the Dream? How is it possible?','',0,0,0,0,0,0,0,0,0,0,69911,0,26124),
(106095,'I will cleanse these Nightmare vines from our path. Go forth, $n, and destroy the source of the corruption that spawned them!','',0,0,0,0,0,0,0,0,0,0,69912,0,26124),
(106096,'Excellent work! Even now the foul creep of the Nightmare has begun to receed.','',0,0,0,0,0,0,0,0,0,0,69909,0,26124),
(106097,'The way is clear. Come, let us continue to our destination.','',0,0,0,0,0,0,0,0,0,0,69910,0,26124),
(106098,'%s causes a |cFFFF0404|Hspell:204839|h[Whirling Maelstrom]|h|r!','%s causes a |cFFFF0404|Hspell:204839|h[Whirling Maelstrom]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(106099,'Come, we must find the Druids of Val\'sharah and request their aid.','',0,0,0,0,0,0,0,0,0,0,69907,0,26124),
(106100,'|TInterface\\Icons\\spell_druid_bearhug:20|t%s targets |cFFFF0000$n|r with an intense |cFFFF0000|Hspell:198006|h[Focused Gaze]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(106101,'You should have fled! Now I\'ll feed your bones to the storm crows!','',0,0,0,0,0,0,0,0,0,0,58379,0,26124),
(106102,'The Nightmare\'s veil is lifted... I return at last... to the long slumber.','',0,0,0,0,0,0,0,0,0,0,58383,0,26124),
(106103,'You are free of this place... how I envy you!','',0,0,0,0,0,0,0,0,0,0,58381,0,26124),
(106104,'By the will of the Nightmare Lord!','',0,0,0,0,0,0,0,0,0,0,58382,0,26124),
(106105,'Should have fled. SHOULD HAVE LISTENED!','',0,0,0,0,0,0,0,0,0,0,58389,0,26124),
(106106,'STAMP AND TRAMPLE! CRUSH AND CRUMPLE!','',0,0,0,0,0,0,0,0,0,0,58386,0,26124),
(106107,'THE NIGHTMARE GROWS! THE NIGHTMARE DEVOURS!','',0,0,0,0,0,0,0,0,0,0,58387,0,26124),
(106108,'Indeed, I wish our meeting were under better circumstances. Surely you have felt the tremors emanating from the Emerald Dream?','',0,0,0,0,0,0,0,0,0,0,69902,0,26124),
(106111,'A moment of your time, warlock. The Council of the Black Harvest requests your assistance.','',0,0,0,0,0,0,1,0,0,0,71324,0,26124),
(106112,'The weapons of old... Yes, they would help indeed! But they are beyond our ability to wield.','',0,0,0,0,0,0,0,0,0,0,62270,0,26124),
(106113,'|TInterface\\Icons\\ability_deathwing_assualtaspects:20|t%s goes into a crazed |cFFFF0000|Hspell:198388|h[Blood Frenzy]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(106114,'It calls to souls long dead... RISE!','',0,0,0,0,0,0,15,0,0,0,60265,0,26124),
(106115,'A trap! Destroy the creature before it kills us!','',0,0,0,0,0,0,1,0,0,0,63438,0,26124),
(106116,'More o\' the Deacon\'s mind games. We could Mass Dispel \'em or just fight through, but I would\'na get too close!','',0,0,0,0,0,0,1,0,0,0,63440,0,26124),
(106117,'','The greatest shaman in the world are gathering below. What\'s left of \'em, that is.',1,0,0,0,0,0,0,0,4,0,0,60520,26124),
(106119,'|TInterface\\Icons\\spell_nature_insect_swarm2:20|t Nythendra inhales for an |cFFFF0404|Hspell:202977|h[Infested Breath]|h|r!','|TInterface\\Icons\\spell_nature_insect_swarm2:20|t Nythendra inhales for an |cFFFF0404|Hspell:202977|h[Infested Breath]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(106120,'','My thanks, $pr. Now I am going to finish off the warden who did this to me.',0,0,0,0,0,0,0,0,0,0,0,57408,26124),
(106122,'','Come, do your best. Nightglaive has been undergoing some \"changes\".',0,0,0,0,0,0,0,0,0,0,0,57410,26124),
(106123,'','We are ready for you.',0,0,0,0,0,0,0,0,0,0,0,57411,26124),
(106124,'The balance must be restored.','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(106125,'Elune-Adore, $n. I must speak with you at once!','',0,0,0,0,0,0,0,0,0,0,62308,0,26124),
(106126,'You are not the only one who can control the undead, death knight!','',0,0,0,0,0,0,15,0,0,0,60266,0,26124),
(106127,'Sss... souls of the dead! Aid your master!','',0,0,0,0,0,0,15,0,0,0,60268,0,26124),
(106128,'Follow me. The Dreamgrove has its own gate to the Dreamway. Through it, you can travel to the far corners of Azeroth.','',0,0,0,0,0,0,0,0,0,0,62307,0,26124),
(106129,'No! The sword... How can you overcome its power?!','',0,0,0,0,0,0,15,0,0,0,60270,0,26124),
(106130,'Prepare to become kindling!','',0,0,0,0,0,0,0,0,0,0,57884,0,26124),
(106131,'I\'ll rip the Claws from your lifeless hands!','',0,0,0,0,0,0,0,0,0,0,58378,0,26124),
(106132,'Burn!','',0,0,0,0,0,0,0,0,0,0,57885,0,26124),
(106133,'You will be my campfire!','',0,0,0,0,0,0,0,0,0,0,57886,0,26124),
(106134,'I will snap you like a twig!','',0,0,0,0,0,0,0,0,0,0,57887,0,26124),
(106135,'I will crush you to splinters.','',0,0,0,0,0,0,0,0,0,0,57888,0,26124),
(106136,'I think I have a CRUSH on you. Heh.','',0,0,0,0,0,0,0,0,0,0,57889,0,26124),
(106137,'','Oh goody, playthings.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106138,'','This is why I can\'t have nice things.',0,0,0,0,0,0,0,0,0,0,0,57588,26124),
(106139,'','Why do they break so easy?',0,0,0,0,0,0,0,0,0,0,0,57589,26124),
(106140,'','I hate it when my toys stop screaming.',0,0,0,0,0,0,0,0,0,0,0,57590,26124),
(106141,'','I hope the next one doesn\'t break so quick.',0,0,0,0,0,0,0,0,0,0,0,57591,26124),
(106142,'','What!? Why would you do this?',0,0,0,0,0,0,0,0,0,0,0,57592,26124),
(106143,'','Don\'t look behind you.',0,0,0,0,0,0,0,0,0,0,0,57593,26124),
(106144,'','And along came a spider...',0,0,0,0,0,0,0,0,0,0,0,57594,26124),
(106145,'','Run. Heh,  it is fun to watch you run.',0,0,0,0,0,0,0,0,0,0,0,57595,26124),
(106146,'','I have tried to teach them to kill you slowly... But they just won\'t listen.',0,0,0,0,0,0,0,0,0,0,0,57596,26124),
(106147,'','Your screams are funny... Make me laugh!',0,0,0,0,0,0,0,0,0,0,0,57597,26124),
(106148,'','Which do you like more, screaming or crying? I like to hear you do both.',0,0,0,0,0,0,0,0,0,0,0,57598,26124),
(106149,'The ettin prince is dead! Let\'s get out of here!','The ettin prince is dead! Let\'s get out of here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106150,'','If you scream loud enough, maybe I will let you die.',0,0,0,0,0,0,0,0,0,0,0,57599,26124),
(106151,'','You can\'t get away. You are MINE!',0,0,0,0,0,0,0,0,0,0,0,57600,26124),
(106152,'','Get over here, I want to play with your blood.',0,0,0,0,0,0,0,0,0,0,0,57601,26124),
(106153,'','You can\'t leave, you can NEVER LEAVE!',0,0,0,0,0,0,0,0,0,0,0,57602,26124),
(106154,'','Don\'t run, I want to see your tears.',0,0,0,0,0,0,0,0,0,0,0,57603,26124),
(106155,'Lord Greymane promised we\'d be neck deep battle by now. I didn\'t sign up for guard duty!','Lord Greymane promised we\'d be neck deep battle by now. I didn\'t sign up for guard duty!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(106156,'','I hope this doesn\'t kill you... I want to play more...',0,0,0,0,0,0,0,0,0,0,0,57604,26124),
(106157,'I know these towers are strategically important, but Lord Greymane promised me vengeance!','I know these towers are strategically important, but Lord Greymane promised me vengeance!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(106158,'','On a scale of 1 to 10, how bad does this hurt?',0,0,0,0,0,0,0,0,0,0,0,57605,26124),
(106159,'Patience. The enemy will bring themselves to us, and we will show them Gilnean fury!','Patience. The enemy will bring themselves to us, and we will show them Gilnean fury!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(106160,'So long as we hold this ground the scum can\'t move freely in the area. They\'ll have no choice but to fight!','So long as we hold this ground the scum can\'t move freely in the area. They\'ll have no choice but to fight!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(106161,'','Those ettins are building a huge bonfire to cook and eat my tribesmen! You have to stop them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106162,'','Those ettins are building a huge bonfire to cook and eat my tribesmen! You have to stop them!',0,0,0,0,0,0,0,0,0,0,0,58114,26124),
(106163,'','There will be no feast for the ettins this night. The Rivermane thank you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106165,'','$n, you must come to the Azurewing Repose and meet with my grandfather, Senegos.',0,0,0,0,0,0,0,0,0,0,0,57415,26124),
(106167,'','Your training really inspired me to join the Unseen Path!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106168,'','Turns out there\'s a lot more to being a hunter than just shooting game!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106169,'','I\'m not the best yet, but I\'m gonna keep practicing!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106170,'Work hard, my naga! We will destroy Jandvik!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106171,'There are few rules atop these cliffs... and absolutely no mercy! Tame a beast, mount up, and kill everyone you see! If you die, you prove your lack of worth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106172,'You put on a good show in there!','',0,0,0,0,0,0,0,0,0,0,58119,0,26124),
(106173,'','We will be victorious! Slay any intruder that daresss enter our watersss!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106174,'The vrykul are nothing! We will wash over them and destroy their village!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106175,'','The strands of life have been severed! The dreamers must be avenged!',0,0,0,0,0,0,0,0,0,0,0,58510,26124),
(106176,'','Come forth, dreamers... and claim your vengeance!',0,0,0,0,0,0,0,0,0,0,0,58500,26124),
(106177,'','Hope is a disease of the soul! This land shall wither and die!',0,0,0,0,0,0,0,0,0,0,0,58507,26124),
(106178,'','Taste the Nightmare\'s corruption!',0,0,0,0,0,0,0,0,0,0,0,58503,26124),
(106179,'I can sense the shadow on your hearts. There can be no rest for the wicked!','',0,0,0,0,0,0,0,0,0,0,58508,0,26124),
(106180,'Your wicked souls shall feed my power!','',0,0,0,0,0,0,0,0,0,0,58502,0,26124),
(106181,'Peace is but a fleeting dream! Let the Nightmare reign!','',0,0,0,0,0,0,0,0,0,0,58509,0,26124),
(106182,'Children of madness! I release you upon this world!','',0,0,0,0,0,0,0,0,0,0,58501,0,26124),
(106183,'','It fades. It all fades away...',0,0,0,0,0,0,0,0,0,0,0,58511,26124),
(106184,'|TInterface\\Icons\\Ability_Rogue_Dismantle:20|tYou\'re caught in a |cFFFF0000|Hspell:204348|h[Cruel Trap]|h|r!','|TInterface\\Icons\\Ability_Rogue_Dismantle:20|tYou\'re caught in a |cFFFF0000|Hspell:204348|h[Cruel Trap]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106185,'','You fought well this day, $n. I am in your debt.$b$bI\'m ready to use the portal stone and take us back to Dalaran.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106186,'|TInterface\\Icons\\inv_axe_2h_felfireraid_d_01:20|t%s readies their axe for a  |cFFFF0000|Hspell:203641|h[Fel Slash]|h|r at $n!','|TInterface\\Icons\\inv_axe_2h_felfireraid_d_01:20|t%s readies their axe for a  |cFFFF0000|Hspell:203641|h[Fel Slash]|h|r at $n!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106187,'Let\'s get out of here!','Let\'s get out of here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106188,'DEBUG - Path Failed','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106189,'|TInterface\\Icons\\INV_Sword_48:20|tFree $n from their bonds before they are |cFFFF0000|Hspell:202361|h[Executed!]|h|r','|TInterface\\Icons\\INV_Sword_48:20|tFree $n from their bonds before they are |cFFFF0000|Hspell:202361|h[Executed!]|h|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106190,'In rescuing Stellagosa, you have made a powerful friend and ally.\n\nI am relieved that the Blue Dragonflight has survived, even if just barely. We must travel to the Azurewing Repose and speak with this Senegos.\n\nIf anyone can point us down the right path to locating the Pillar of Creation, surely it will be him.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(106191,'Your friend was taken to the felstalker pits beneath the great Burning Legion command ship.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106192,'Sadly, it\'s probably too late for him... don\'t foolishly throw your lives away for a dead man!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106193,'','I am certain that if anyone can help you find this Pillar of Creation, it will be my grandfather.',0,0,0,0,0,0,0,0,0,0,0,58372,26124),
(106194,'All are welcome to take the great Aviana\'s test of flight. Please form an orderly line to receive her blessing.','All are welcome to take the great Aviana\'s test of flight. Please form an orderly line to receive her blessing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106195,'May the wind be always under your wings.','May the wind be always under your wings.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106196,'Even the best laid plans don\'t survive contact with the enemy.','',0,0,0,0,0,0,0,0,0,0,57579,0,26124),
(106197,'Such insolence! We will make your death terrible, and your suffering long.','',0,0,0,0,0,0,0,0,0,0,57580,0,26124),
(106198,'Your souls will fuel our engines!','',0,0,0,0,0,0,0,0,0,0,57581,0,26124),
(106199,'Our hatred knows no bounds!','',0,0,0,0,0,0,0,0,0,0,57582,0,26124),
(106200,'Pathetic worm!','',0,0,0,0,0,0,0,0,0,0,57583,0,26124),
(106201,'A death most deserved.','',0,0,0,0,0,0,0,0,0,0,57584,0,26124),
(106202,'We will unleash a scourge upon this citadel never before known to your kind!','',0,0,0,0,0,0,0,0,0,0,57585,0,26124),
(106203,'My lord.. I have.. failed you...','',0,0,0,0,0,0,0,0,0,0,57586,0,26124),
(106204,'Another soul, harvested!','',0,0,0,0,0,0,0,0,0,0,57587,0,26124),
(106205,'She\'s mine! You won\'t take her!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106206,'|TInterface\\Icons\\Ability_Rogue_BloodyEye:20|tSmashspite\'s |cFFFF0000|Hspell:198079|h[Hateful Gaze]|h|r falls on |cFFFF0000$n|r!','|TInterface\\Icons\\Ability_Rogue_BloodyEye:20|tSmashspite\'s |cFFFF0000|Hspell:198079|h[Hateful Gaze]|h|r falls on $n!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106207,'','A val\'kyr approaches! We must greet her with respect. Come, heroes!',0,0,0,0,0,0,396,0,0,0,0,60433,26124),
(106208,'I\'m ready. Let\'s get down to Azsuna, Khadgar.','I\'m ready. Let\'s get down to Azsuna, Khadgar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106209,'Alrik, my battle brother! I will avenge you!','',0,0,0,0,0,0,53,0,0,0,60431,0,26124),
(106210,'','May the val\'kyr claim you, Haardgrim!',0,0,0,0,0,0,53,0,0,0,0,60432,26124),
(106211,'Look there! The val\'kyr!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(106212,'Watch over me from above, my brothers, and save me a seat in the hall!','',0,0,0,0,0,0,1,0,0,0,60435,0,26124),
(106213,'Sorry $g pal:lady;, I can\'t help ya. Find a $c trainer. I only teach hunters!','Sorry $g pal:lady;, I can\'t help ya. Find a $c trainer. I only teach hunters!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(106214,'Are you as excited as me to be here, $c?','Are you as excited as me to be here, $c?',71,0,0,0,0,0,0,0,0,0,0,0,26124),
(106215,'Follow me, $n, and I\'ll introduce you to your trainer, Muffinus Chromebrew.','Follow me, $n, and I\'ll introduce you to your trainer, Muffinus Chromebrew.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(106216,'Muffinus, allow me to introduce $n, who helped us rescue survivors in Gnomeregan.','Muffinus, allow me to introduce $n, who helped us rescue survivors in Gnomeregan.',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(106217,'','Welcome to Fragments of the Past!$b$bAre you interested in learning about Archaeology?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106218,'A new continent full of forgotten secrets!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(106219,'This place is steeped in titan architecture. Why, jes over that hill to tha north is a \'uge titan chamber!','',1,1,0,0,0,0,0,0,1,0,0,0,26124),
(106221,'Go now. Hruthnir waits at the Sky Launch to aid you.','',0,0,0,0,0,0,0,0,14,0,70414,0,26124),
(106222,'|TInterface\\Icons\\INV_Misc_Slime_01:20|t A Congealing Goo was able to finish |cFFFF0404|Hspell:201495|h[Recongealing]|h|r!','|TInterface\\Icons\\INV_Misc_Slime_01:20|t A Congealing Goo was able to finish |cFFFF0404|Hspell:201495|h[Recongealing]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106224,'Welcome to our new home, $n.','',0,0,0,0,0,0,66,0,0,0,58206,0,26124),
(106225,'Please excuse me, $n. I\'m preparing a report for the other masters.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106226,'Brothers and Sisters, the invaders come for us. Repel them! Attack!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106227,'Whenever you\'re ready.','',0,0,0,0,0,0,1,0,0,0,64700,0,26124),
(106228,'I\'ve been waiting for this day.','',0,0,0,0,0,0,1,0,0,0,58205,0,26124),
(106229,'Our friends in the Kirin Tor have created one of their magical portals to provide quick travel to Dalaran. You can find it near the steps to the temple.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106230,'','I was taught to see every $r as my enemy. But the Legion would wipe us all from this world.$b$bSo I have chosen to follow the Unseen Path, and I stand with you.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(106231,'These demons think we will just give up the Crossroads without a fight?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106232,'Push them back! We cannot let the Crossroads fall!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106233,'Reinforcements to the Crossroads at once! We\'re under attack!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106234,'Hold the Crossroads until reinforcements arrive! Show these demons what it means to fight for the Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106235,'For the Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106236,'These lands will not be ruined by your kind!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106237,'For the Warchief!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106238,'Your foul magics are no match for my blade!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106239,'Cut them down and heave their souls into the tides!','',0,0,0,0,0,0,0,0,0,0,57463,0,26124),
(106240,'Take their trinkets for yourselves, but leave their souls for me!','',0,0,0,0,0,0,0,0,0,0,57464,0,26124),
(106241,'Intruders on the Naglfar! Give no quarter to these scallywags!','',1,0,0,0,0,0,0,0,0,0,57461,0,26124),
(106242,'Nothing sweeter... than to die at sea...','',0,0,0,0,0,0,0,0,0,0,57459,0,26124),
(106243,'Skinning','Skinning',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(106244,'Greetings, $n. I am pleased you received Thrall\'s summons.$b$bYou can see, there are no factions here. We few are all that remain of the Earthen Ring, and we must struggle together or surely we will perish alone.$b$bSurvivors continue to make their way here from the four corners of Azeroth. See that their wounds are tended to. They need hope if they are to rejoin the fight, $n. You must inspire them!','',1,6,0,0,0,0,0,0,0,0,0,0,26124),
(106245,'I will see to the others, Farseer.','I will see to the others, Farseer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106246,'Here comes my former student, $n, death incarnate! One day I\'d like to hear about the techniques you\'ve learned in the field.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106248,'temp:\nYour hardest hitting abilities are Ice Lance against frozen targets and Frozen orb.  Since not every creature can be frozen and because Frozen Orb has a long cooldown, there are two effects you will gain in combat.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106249,'temp:\nCasting Frostbolt will occasionally grant you Fingers of Frost and Brain Freeze effects.  Fingers of Frost causes your Ice lance to treat your target as if it were frozen, doing incredible damage.  Brain Freeze will resets the cooldown on Frozen Orb.  Try using both now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106250,'','The plight of Azeroth is far more grave than we first thought.',0,0,0,0,0,0,1,0,0,0,0,64711,26124),
(106251,'You\'ll want to see this for yourself.','',0,0,0,0,0,0,1,0,0,0,64712,0,26124),
(106252,'','Some of the local trash have been stealing our vintage bottles, can you track them down and bring them back to me? Some of those bottles are irreplaceable!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106253,'','The eagle loa! Praise the spirits!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106254,'','My people tell legends of such spirits, but I have never seen one.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106255,'That eagle would fly better with mechanical wings!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106256,'','It\'s so... beautiful!',0,0,0,0,0,0,0,0,0,0,0,61862,26124),
(106257,'The fel blood froths violently, a swirl of obfuscated shapes bubbling just below the surface.','The fel blood froths violently, a swirl of obfuscated shapes bubbling just below the surface.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106258,'Gaze upon the Burning Legion\'s presence on Azeroth.','Gaze upon the Burning Legion\'s presence on Azeroth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106259,'Greetings, and thank you for helping to test the Legion Beta! \n\nI can teleport you directly into a number of raid or dungeon instances that are currently open for testing. This is just a teleport, not a match-making service, so I hope you have a party ready to tackle the challenges waiting inside. If not, you might want to check out our new Group Finder feature to find some allies.\n\nMake sure you have selected the difficulty you want to test before teleporting, since you may not be able to zone out easily if you need to change the difficulty setting!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106260,'A fine start! The Kirin Tor have given us a permanent portal to Dalaran, as well as one that will bring you from the city back to Netherlight. Good luck!','',0,0,0,0,0,0,1,0,0,0,63408,0,26124),
(106261,'Enough of this! To me, Su\'esh! Destroy these interlopers!','Enough of this! To me, Su\'esh! Destroy these interlopers!',0,0,0,0,0,0,0,0,0,0,65641,0,26124),
(106262,'What\'s this? Listen to me! I am the alpha!','What\'s this? Listen to me! I am the alpha!',0,0,0,0,0,0,0,0,0,0,65642,0,26124),
(106263,'Is that how it is? Clever girl.','Is that how it is? Clever girl.',0,0,0,0,0,0,0,0,0,0,65643,0,26124),
(106264,'You\'ve got Fingers of Frost, cast Ice Lance now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106265,'','Golly gearshaft! Is that $n with that uber-awesome weapon of $ghis:hers;?',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(106266,'Oh sure, it\'s a nice weapon... I guess. But can it tame a mechanical chicken? I think not!','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(106267,'','I\'m so happy that we gnomes can finally unleash our inner hunters!',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(106268,'I know, right? About time I get to show off my guns!','',23,0,0,0,0,0,0,0,0,0,0,0,26124),
(106269,'Say Drupala, which of these weapons on the wall are meant for hunters?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106270,'','Haven\'t you heard, Practicus? All weapons are hunter weapons. All of them!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(106271,'So you\'ve taken care of our little pet, have you? No matter. I will show you why I am the alpha!','So you\'ve taken care of our little pet, have you? No matter. I will show you why I am the alpha!',0,0,0,0,0,0,0,0,0,0,65644,0,26124),
(106272,'Su\'esh eyes the wounds on Graedis.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106273,'Su\'esh looks hungrily at Graedis.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106274,'You are entering a restricted area. You will be teleported to Dalaran unless you return to your previous zone.','You are entering a restricted area. You will be teleported to Dalaran unless you return to your previous zone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106275,'Suffer well.','',0,0,0,0,0,0,0,0,0,0,64707,0,26124),
(106276,'The Ashtongue will fight beside you.','',0,0,0,0,0,0,0,0,4,0,64714,0,26124),
(106277,'','You may call upon the Coilskar as well.',0,0,0,0,0,0,0,0,4,0,0,64715,26124),
(106278,'','Our mission is not yet complete. We are all yours to command.',0,0,0,0,0,0,0,0,4,0,0,64716,26124),
(106280,'Should you succeed, the blade is yours. But if you should fail... then you will become a mindless minion of the Scourge. Do not expect my protection.','',0,0,0,0,0,0,0,0,1,0,60508,0,26124),
(106281,'I want to go to Black Rook Hold (Dungeon).','I want to go to Black Rook Hold (Dungeon).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106282,'I want to go to Darkheart Thicket (Dungeon).','I want to go to Darkheart Thicket (Dungeon).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106283,'I want to go to Eye of Azshara (Dungeon).','I want to go to Eye of Azshara (Dungeon).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106284,'','You do not want to test my patience, demon. Speak.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106285,'I want to go to Halls of Valor (Dungeon).','I want to go to Halls of Valor (Dungeon).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106286,'','Your foul soul will be all that remains.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106287,'I want to go to Neltharion\'s Lair (Dungeon).','I want to go to Neltharion\'s Lair (Dungeon).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106288,'I want to go to The Arcway (Dungeon).','I want to go to The Arcway (Dungeon).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106289,'','I do not have all day - talk and this can all be over.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106290,'I want to go to Maw of Souls (Dungeon).','I want to go to Maw of Souls (Dungeon).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106291,'I want to go to The Violet Hold (Dungeon).','I want to go to The Violet Hold (Dungeon).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106292,'I want to go to Vault of the Wardens (Dungeon).','I want to go to Vault of the Wardens (Dungeon).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106293,'','Taste the Scythe of Souls, demon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106294,'','Cooperate or die.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106295,'','I will take great pleasure in ripping the soul out of your body.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106296,'','Reveal all you know to me or pay the price.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106297,'','I have ways of making your kind talk.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106298,'Very good.  Let\'s practice that a few more times.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106299,'','Ask patiently of the ocean, and the ocean will listen.$b$bAsk patiently of me... and I will see what I can do.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106300,'Can you bless me with the gift of water walking?','Can you bless me with the gift of water walking?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106301,'','When you have found all the pieces, meet me just east of here. I\'ll prepare the burial ceremony.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106302,'','Hello adventurer, I am Lessah. Are you as interested as I am in learning about the Highmountain tauren?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106303,'','Have you recovered the remainder of Eche\'ro\'s bones?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106304,'Here are remaining bone fragments.','Here are remaining bone fragments.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106305,'|TInterface\\Icons\\Spell_Shadow_Charm:20|t%s inhales deeply for a |cFFFF0000|Hspell:204078|h[Bellowing Roar]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(106306,'','|TInterface\\Icons\\ability_creature_cursed_03.blp:20|t%s takes to the skies, infecting the nightmare with |cFFFF0000|Hspell:204245|h[Corruption of the Dream]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(106307,'|TInterface\\Icons\\Spell_Shadow_AuraOfDarkness:20|t%s begins to cast |cFFFF0000|Hspell:203888|h[Siphon Spirit]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(106308,'Thank you, young one for honoring the spirit of my companion. Should you ever need him, Eche\'ro will be at your call.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106309,'','All will succumb to the Nightmare!',0,0,0,0,0,0,0,0,0,0,0,58512,26124),
(106310,'','Oh great Eche\'ro, I return your bones to the earthmother and pray your spirit be at peace.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106311,'','Let us begin, $n.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106312,'Set sail for Stormheim!','Set sail for Stormheim!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106313,'I hope someday to become as great as Lessah has become and make her proud.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106314,'Are you ready for your lessons?','Are you ready for your lessons?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106315,'One? Kill the fool and keep my cargo safe. Don\'t wake me again!','',0,0,0,0,0,0,0,0,0,0,60365,0,26124),
(106316,'','Speak with Luron when you\'re ready to begin your lessons.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106317,'I want to go to Suramar Palace (Raid).','I want to go to Suramar Palace (Raid).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106318,'','The Forsaken stand ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106319,'I want to go to the Emerald Nightmare (Raid).','I want to go to the Emerald Nightmare (Raid).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106320,'','The Dark Lady will guide us to victory.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106321,'','First, we escort you to Aggramar\'s Vault, then we meet up with Dreadwake at Skold-Ashil.$B$BShould be smooth sailing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106322,'','|TInterface\\Icons\\inv_fishing_lure_worm.blp:20|t%s targets $n for |cFFFF0404|Hspell:199176|h[Spiked Tongue]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(106323,'Go in ahead, druid. I will join you inside.','',0,0,0,0,0,0,1,0,0,0,60248,0,26124),
(106324,'The crystal has three empty slots carved into it. You don\'t quite have enough keystones to active the crystal just yet.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106325,'The crystal has three empty slots carved into it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106326,'[Placeholder Animation!]','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(106327,'|TINTERFACE\\ICONS\\INV_MISC_GEAR_01:20|t Under Construction! |TINTERFACE\\ICONS\\INV_Misc_Gear_08:20|t','|TINTERFACE\\ICONS\\INV_Misc_Gear_08:20|t Under Construction!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106328,'Place the three Highmountain Ritual-Stones into the crystal.','Place the three Highmountain Ritual-Stones into the crystal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106329,'This will remove 3 |cFF00FF00|Hitem:130904:0:0:0:0:0:0:0:90:0|h[Highmountain Ritual-Stones]|h|r from your inventory. Are you sure?','This will remove 3 |cFF00FF00|Hitem:130904:0:0:0:0:0:0:0:90:0|h[Highmountain Ritual-Stones]|h|r from your inventory. Are you sure?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(106330,'','Seen Nat around lately?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106331,'','Keep some bait on your hook and some fish in your belly.$b$bTake care not to mix those two up.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106332,'','Fishing in a fountain may not be glamorous... but at least it\'s not fishing in a sewer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106333,'As you place the keystones into the crystal, it begins to hum with energy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106334,'As you place the keystones into the crystal, it begins to hum with energy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106335,'As you place the keystones into the crystal, it begins to hum with energy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106336,'As you place the keystones into the crystal, it begins to hum with energy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106337,'As you place the keystones into the crystal, it begins to hum with energy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106338,'No... no! Helya, give me more power!','',0,0,0,0,0,0,0,0,0,0,60379,0,26124),
(106339,'Brain Freeze just reset the cooldown of Frozen Orb, cast that now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106340,'','Over here, shaman! Take up my spear, and may the winds guide your strike!',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(106341,'','The portal to Dalaran is above the hall entrance. Take the ramp up.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106342,'','Our mission is of the utmost importance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106343,'','The Skyfire is ready for action.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106344,'Set sail for Stormheim!','Set sail for Stormheim!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106345,'The murloc\'s training is really coming along!','The murloc\'s training is really coming along!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106346,'Keep it up! You can do it!','Keep it up! You can do it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106347,'You\'ve gotten a lot better! Really!','You\'ve gotten a lot better! Really!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106348,'Careful of low blows!','Careful of low blows!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106349,'Put your back into it!','Put your back into it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106350,'I\'ve seen my share of murloc hunters, but this kid has got something special!','I\'ve seen my share of murloc hunters, but this kid has got something special!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106351,'Stop wasting your time trying to train that one!','The murloc\'s training is really coming along!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106352,'That\'s it! Hit him in the kneecaps!','That\'s it! Hit him low!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106353,'Go for the eyes, murloc!','Go for the eyes, murloc!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106354,'One hundred coppers on the centaur... ish... cat... thing...','One hundred coppers on the centaur... ish... cat... thing...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106355,'Hunters standing toe to toe... never thought I\'d see the day!','Hunters standing toe to toe... never thought I\'d see the day!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106356,'You call that sparring? Where\'s all the blood and broken bones?','You call that sparring? Where\'s all the blood and broken bones?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106357,'You gotta lock their gaze. That\'s the secret to a good taming!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106358,'If a wild beast smells fear on you, you\'re dead. Or sausage. If they smell sausage, you\'ll be mauled.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106359,'You don\'t stand around watching while another hunter is taming. It\'s kinda personal, ya know?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106360,'Roads into the lodge look clear.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106361,'The Silver Covenant stands ready to aid the Unseen Path.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106362,'No threat will make it past me, $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106363,'I can stand no more of this dallying! The Dark Lady must let us take the fight to the Alliance dogs now!','I can stand no more of this dallying! When will the Dark Lady let us take the fight to the Alliance dogs?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(106364,'No flesh to eat, unless we\'re on the move! When will this guard duty end?','No flesh to eat, unless we\'re on the move! When will this guard duty end?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(106365,'The curs will bring themselves to us. We will blunt their rage and feast on their flesh!','The curs will bring themselves to us. We will blunt their rage and feast on their flesh!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(106366,'The enemy will have to fight us on our terms. Stay patient. Soon, we will have out fill of battle!','The enemy will have to fight us on our terms. Stay patient. Soon, we will have out fill of battle!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(106369,'Did the tauren play a role in building this lodge?','Did the tauren play a role in building this lodge?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106370,'There was a light snow last night, my darling. You always loved watching the flakes fall.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106371,'Millennia have passed, yet the sorrow refuses to leave my heart. Oh, Namuria...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106373,'It is a new dawn for our order, my love. You would be so proud of Emmarel for uniting us under a new leader.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106374,'Though it pains me to be without you, I shall fight on in your memory, my love.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106375,'I miss you, Namuria.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106376,'Fade into shadow...','Fade into shadow...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106377,'This guy\'s toast.','This guy\'s toast.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106378,'For Gilneas!','For Gilneas!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106379,'','You there, friend of nature! Aid me in teaching these foul poachers a lesson!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106380,'','Hit a man with a fish, and he will stop fishing for a day. Hit a man AS a fish, and he will stop fishing for the rest of his life!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106381,'','The Unseen Path is reborn!',0,0,0,0,0,0,0,0,0,0,0,61855,26124),
(106382,'The seed will need plenty of air and water. Look for an ideal spot on the hill behind us.','',0,0,0,0,0,0,0,0,0,0,62250,0,26124),
(106383,'','Intruder! How dare you disturb Eyir\'s sanctum!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106384,'','Eyir\'s wrath... will end you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106385,'Die, scum!','Die, scum!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106386,'I return to shadow!','I return to shadow!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106387,'Heh. Weakling.','Heh. Weakling.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106388,'Never saw us coming.','Never saw us coming.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106389,'A clean kill.','A clean kill.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106390,'Good! This seed holds magic from when the world was young. This will prove very useful.','',0,0,0,0,0,0,0,0,0,0,62251,0,26124),
(106392,'Start the device, Brann.','Start the device, Brann.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106393,'Start the device again, Brann.','Start the device again, Brann.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106394,'Alright, $glad:lass;, be on yer guard.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106395,'','Protect Greymane! For Gilneas!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106396,'','Sylvanas... will not... win...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106397,'Hero, I sense your destiny lies with the ancient night elf who started you on this journey. Before I depart, I can send you back to the city in the sky. May Talonclaw serve you well.','',0,0,0,0,0,0,1,0,0,0,62703,0,26124),
(106398,'$ct, our friends in the Kirin Tor have created one of their arcane portals to provide easy access to Dalaran. Should you have need of it you can find it along the path north of here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106399,'$ct, you have made our path clear! Now, we strike! For Azeroth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106400,'<The apparition speaks, but you hear nothing.$B$BHe gestures at your equipment.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106401,'Those blades... just looking at them makes me feel cold.','Those blades... just looking at them makes me feel cold.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106402,'The skull on that axe looks... hungry.','The skull on that axe looks... hungry.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106403,'That sword... oh no... is that Apocalylpse!? I\'m glad the Burning Legion didn\'t get their hands on it!','That sword... oh no... is that Apocalylpse!? I\'m glad the Burning Legion didn\'t get their hands on it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106404,'Something must be wrong with me, it\'s getting hot all of a sudden.','Something must be wrong with me, it\'s getting hot all of a sudden.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106405,'Those hand blades look so sharp! Why, I bet you could slice a boulder in half!','Those hand blades look so sharp! Why, I bet you could slice a boulder in half!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106406,'This is only the beginning!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106407,'%s laughs.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106408,'We are everywhere!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106409,'We cannot be stopped!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106410,'PREPARE TO FACE YOUR DOOM, $n! IT IS I, WYRMY TUNKINS AND I WILL BE THIS WORLD\'S UNDOING!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(106411,'Wait, stop! Please don\'t kill me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106412,'If you spare my life, I promise to swear my allegiance to you. And here, look, I have a valuable artifact that you may have as well.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106413,'A val\'kyr arrives and pulls you from the brink of death!','A val\'kyr arrives and pulls you from the brink of death!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106414,'Die, die, die!','Die, die, die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106415,'<The sea turtle speaks directly to your mind.>$B$BYou are a stranger to my waters. What purpose could bring you here?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106416,'Strike!','Strike!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106417,'I fade into darkness.','I fade into darkness.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106418,'Climb on the Toogus\' back.','Climb on the Toogus\' back.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106419,'Darkness cloaks my every move...','Darkness cloaks my every move...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106420,'Another skull for the pile.','Another skull for the pile.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106421,'The Banshee Queen sends her regards.','The Banshee Queen sends her regards.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106422,'Death claims you!','Death claims you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106423,'Use your flare gun to mark your target. Our assassins attack on your command!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106424,'Come here, friend. I\'ve got something that will help you with clearing out these Forsaken!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106425,'','Calm yourself, Wuho!',0,0,0,0,0,0,1,0,4,0,0,62679,26124),
(106426,'Feathermane Kitten playfully swipes at the reeds.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106427,'Our tribe\'s greatest weapon and its ancient enemy are but a few strides away! I will not be stopped by some foul fog magic!','',0,0,0,0,0,0,22,0,0,0,62680,0,26124),
(106428,'','Patience, brother. To gaze upon Talonclaw will be a sight to remember. Look! Our friend returns!',0,0,0,0,0,0,1,0,0,0,0,62681,26124),
(106429,'Yes, can I help you?$b$bLespin sent you? So he could not even be bothered to show up himself.$b$bWell, I suppose I have already received my payment, so I do not particularly care what happens to the ring now.$b$bHere, take the ring. Tell Lespin it had better be worth it.','Yes, can I help you?$b$bLespin sent you? So he could not even be bothered to show up himself.$b$bWell, I suppose I have already received my payment, so I do not particularly care what happens to the ring now.$b$bHere, take the ring. Tell Lespin it had better be worth it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106430,'Well, this is surprising. Tell me, does Lespin know?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106431,'Deception! Perfidy! We are invaded!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106432,'What a day. What a lovely day.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106433,'I must apologize, but I do not have time to speak with you right now. I am waiting for someone.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106434,'Just out for a stroll. I might tour the Menagerie. Have you been there recently?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106435,'Water Elemental Intro','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106436,'Water Elemental - Explanation','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106437,'From this vantage point I can keep a watchful eye on the Alliance supply routes to the Swamp of Sorrows.$b$bIt is a thankless task, but vital should our enemies move against our forces at Stonard.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(106438,'Don\'t worry Brambley, I\'ll carry yer wee head to safety!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106439,'Let\'s get this disc assembled, shall we?!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106440,'So then this piece goes over here...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106441,'That\'s all the pieces. Now why is there a hole in the middle... ?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(106442,'Here lies his mighty arm that defended the realm in so many battles!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106443,'ACK! Don\'t tell me we\'re still missn\' a piece!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(106444,'Good eye! That\'s his alright... I\'d know it a mile away!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106445,'I\'ll take ye home Brambley! Piece by piece, I swear it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106446,'Och, looks like the demons chewed on this one. Aye, it\'s still moist...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106447,'It\'s Brambley\'s Dagger! We\'ll take it home an\' bury it with the rest o\' him.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106448,'Vrykul raiders are testing the border defenses of Highmountain. Our allies could use your help, champion.','',0,0,0,0,0,0,0,0,0,0,57609,0,26124),
(106449,'Well done. That should remind the vrykul that Highmountain is no easy summit to take.','',0,0,0,0,0,0,0,0,0,0,57610,0,26124),
(106450,'Vrykul raiders are testing our border defenses. Our forces are stretched too thin. Can you help?','',0,0,0,0,0,0,0,0,0,0,57611,0,26124),
(106451,'Ha ha! That should remind those vrykul that Highmountain is no easy summit to take.','',0,0,0,0,0,0,0,0,0,0,57612,0,26124),
(106452,'Angus, I\'m alive! I\'m up here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106453,'It IS my voice you daft dwarf! I\'m ALIVE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106454,'Watch out for the felfire breath! Hide behind something when he does that!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106455,'This crown once adorned the brow of Mavrana Mooncrest. It conveyed an incredible amount of arcane power, allowing her to achieve nearly-limitless mastery over the magical arts.$b$bDuring the War of the Ancients, the crown was stolen by rival nobles, and its precious jewels were removed and sold. It was eventually recovered, but without the Jewels of Aellis which gave it such potency.$b$bTo this day, the jewels remain lost.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106456,'Planting Explosives','Planting Explosives',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(106457,'I will let the other wardens know of Cordana\'s fate.','I will let the other wardens know of Cordana\'s fate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106458,'Are you sure you want to leave the instance?','Are you sure you want to leave the instance?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106459,'The Doomhammer...','',0,0,0,0,0,0,1,0,0,0,60521,0,26124),
(106460,'','Thanks for getting those bottles back for us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106465,'','Wise words, Lowlander.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106466,'Not as such. I had to make the choice, as you do, of indulging my desire for revenge or saving my people.','',0,0,0,0,0,0,0,0,0,0,57629,0,26124),
(106467,'','They tell me your father was killed as well. Did you avenge him?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106468,'','In my case, saving my people also means getting revenge for my father.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106469,'|TInterface\\Icons\\Spell_Fire_FelFlameRing:20|t Skovald begins to cast |cFFFF0404|Hspell:193826|h[Ragnarok]|h|r!','|TInterface\\Icons\\Spell_Fire_FelFlameRing:20|t Skovald begins to cast |cFFFF0404|Hspell:193826|h[Ragnarok]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106470,'You must learn to trust those who are willing to help you.','',0,0,0,0,0,0,0,0,0,0,57632,0,26124),
(106471,'No. It is my experience with hot headed leaders.','',0,0,0,0,0,0,0,0,0,0,57633,0,26124),
(106472,'','Is that your experience with new leaders talking, Lowlander?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106473,'','Huln united the tribes even before finding the hammer? How?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106474,'He gave them a cause worth fighting for. Not a weapon to rally behind.','',0,0,0,0,0,0,0,0,0,0,57640,0,26124),
(106475,'The Greystone drogbar managed to somehow acquire elementium. Neither they nor the Highmountain tribes can possibly understand how dangerous this material is. Please, recover it from them.','',0,0,0,0,0,0,0,0,0,0,57641,0,26124),
(106476,'Good work. That ore was a favorite of Deathwing\'s during the cataclysm. It is a powerful weapon when used for evil.','',0,0,0,0,0,0,0,0,0,0,57642,0,26124),
(106477,'Alard, could you help me cast a new set of keys?','Alard, could you help me cast a new set of keys?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106478,'Sure can! Take this metal and melt it by the forge. Then pour it into the mold. When that\'s done, you can cool it over by the quenching trough.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106479,'Insignificant slime. You have meddled in our affairs for the last time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106480,'Day 40: A massive ettin trampled through my workshop at Koralune Manor. Scared him away with magic. Have a feeling he will be back...','',0,0,0,0,0,0,0,0,0,0,67441,0,26124),
(106481,'I\'ve marked the location of the entrance on your map. Meet me there when you\'re ready to continue.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106482,'Are you ready to get to work? There are many artifacts to be found in these lands.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106483,'Just follow my lead when we\'re inside and try not to disturb anything unless I say so.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(106484,'Alright, let\'s go.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(106485,'|TInterface\\Icons\\ability_priest_flashoflight:20|t Odyn begins to |cFFFF0404|Hspell:198077|h[Shatter Spears]|h|r!','|TInterface\\Icons\\ability_priest_flashoflight:20|t Odyn begins to |cFFFF0404|Hspell:198077|h[Shatter Spears]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106486,'|TInterface\\Icons\\ability_thunderking_overcharge:20|t Odyn begins to cast |cFFFF0404|Hspell:201215|h[Summon Stormforged Obliterator]|h|r!','|TInterface\\Icons\\ability_thunderking_overcharge:20|t Odyn begins to cast |cFFFF0404|Hspell:201215|h[Summon Stormforged Obliterator]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106487,'We must each choose our own path.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106488,'What are my options again?','What are my options again?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106489,'When you are ready, step through the portal into the Dreamway. I will meet with you on the other side.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106490,'','$ct, what a strange structure you are on! I can now send you directly to Highmountain from Skyhold whenever you choose!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106491,'Who dares to challenge King Morgalash!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106492,'Destroy the wretched slime!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106493,'Crush the puny creature!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106494,'','Greymane\'s forces hold this Warden tower. Break their ranks! Show no mercy!',0,0,0,0,0,0,0,0,0,0,0,70959,26124),
(106495,'','A decisive victory! These Alliance lapdogs scatter before the might of the Horde!',0,0,0,0,0,0,0,0,0,0,0,70958,26124),
(106496,'A garrison in this warden tower would be a vital strategic victory. Drive the Forsaken from it, for Gilneas!','',0,0,0,0,0,0,0,0,0,0,70957,0,26124),
(106497,'A fine victory, and a blow dealt to the Forsaken. Vengeance moves with the Gilneas Brigade!','',0,0,0,0,0,0,0,0,0,0,70956,0,26124),
(106498,'Follow me, $c!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106500,'Quickly, $n! We must hurry!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106501,'Come on, $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106502,'','The Felsworn cannot be allowed to thrive on our isle. You know what to do.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106503,'','Well done, $n. With the Felsworn weakened we are one step closer to fixing this mess.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106505,'','<Stage 1 Complete>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106506,'','<Stage 2 Complete>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106507,'|TInterface\\Icons\\Spell_Arcane_MassDispel:20|t %s begins to cast |cFFFF0000|Hspell:204471|h[Focused Blast]|h|r.','|TInterface\\Icons\\Spell_Arcane_MassDispel:20|t %s begins to cast |cFFFF0000|Hspell:204471|h[Focused Blast]|h|r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(106514,'I can still hear Brambley\'s voice in my head, tellin\' me to stay alive.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106515,'I will laddy! I\'ll stay alive for the both of us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106516,'I saw it first!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106517,'Dibs. Dibs! I called dibs!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106518,'You don\'t understand - I need this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106519,'Do you know how long I\'ve been waiting for this?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106520,'I won\'t lose again! It\'s mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106521,'Can\'t I just have it?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106522,'|TInterface\\Icons\\ability_skyreach_wind:20|t %s begins to cast |cFFFF0000|Hspell:204316|h[Shockwave]|h|r.','|TInterface\\Icons\\ability_skyreach_wind:20|t %s begins to cast |cFFFF0000|Hspell:204316|h[Shockwave]|h|r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(106567,'I\'m the elf your elf could be, if he was me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106570,'I prefer using the greatstaff Atiesh\'s raven form. Nothing\'s worse than saddle sores.','',0,0,0,0,0,0,0,0,0,0,58376,0,26124),
(106573,'The demon hunters have set up camp on the far side of the island. Perhaps they can help us locate the Pillar of Creation.','',0,0,0,0,0,0,0,0,0,0,58375,0,26124),
(106574,'Look there... naga forces. We have competition from Queen Azshara herself!','',0,0,0,0,0,0,0,0,0,0,58374,0,26124),
(106575,'She must also be after the Pillar of Creation. This is unexpected.','',0,0,0,0,0,0,0,0,0,0,58373,0,26124),
(106580,'I.... have to sell this horse to you.','I.... have to sell this horse to you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106581,'Woah, $Gman:lady;, are you sure? This ain\'t some sort of prank?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106582,'Unfortunately, yes.','Unfortunately, yes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106583,'Pleasure doing business with ya. You just made my freakin\' career, pal!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106625,'Now don\'t keep me waiting, philistine. Chop chop!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106633,'','The plagues of the Legion will destroy your fragile city!',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(106658,'','Your city is doomed!',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(106674,'What\'s this? More of this blasted stone?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106675,'You will pay for this, stranger. I will find you... and I will destroy you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106676,'','I can\'t hold this forever! Do it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106677,'','I\'ll meet you there!',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(106679,'If you have need of repair to your leathers I\'ll be glad to help. All of my skins were taken only from creatures that died of natural causes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106681,'Katy, would you help $p and go open the old Consortium portal by the Antonidas Memorial?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106683,'','Oh my, that doesn\'t sound good. Go ahead and head back to The Postmaster - I\'ll dismantle this portal real quick.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106684,'Pay Haramad no mind. Deep down I know he appreciates all of that free stone.','',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(106698,'Stupid Ringtail! You\'ve snuck into our pantry for the last time!','Stupid Ringtail! You\'ve snuck into our pantry for the last time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106699,'Huh? Where\'s that noise coming from?','Huh? Where\'s that noise coming from?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106700,'I\'m so so sorry...','I\'m so so sorry...',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(106701,'Thanks to you, I\'m alive and Mangelrath is dead. Let\'s get out of here before more demons arrive.$b$bI think I know a shortcut out of here, follow me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106702,'Lead the way. I\'ll be right behind you.','Lead the way. I\'ll be right behind you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106703,'Follow me, I know a way out!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106704,'\'Ey, mon! Dis be your place now. All the best digs for da Archdruids!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106705,'De Cenarion Circle gonna bring de balance to these lands with ye\' here. I be feelin\' it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106706,'Zen\'kiki want ta\' be a big an powerful, like you. I be thinkin\', I stay here and be watchin\' over ye place, keep it real good an tidy. Then, sometimes you be teachin\' me some tips.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106707,'Well, what ye say mon?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106708,'I admit, I had my doubts. I never believed I\'d see anyone capable of obtaining the weapon you now hold.','',0,0,0,0,0,0,0,0,0,0,62204,0,26124),
(106709,'It\'s rare that I\'m proven wrong. In this case, I\'m pleased that I was.','',0,0,0,0,0,0,0,0,0,0,62206,0,26124),
(106710,'You are already more powerful than many senior members of our order. Still, I sense that even more growth is yet to come.','',0,0,0,0,0,0,0,0,0,0,62208,0,26124),
(106711,'Shan\'do Malfurion awaits. Go, be recognized for your accomplishments.','',0,0,0,0,0,0,0,0,0,0,62210,0,26124),
(106712,'In time, your powers will reach heights undreamed of.','',0,0,0,0,0,0,0,0,0,0,62209,0,26124),
(106713,'It is good to see you, $n. I just heard about your deeds from Remulos. Well done!$b$bIt is time that you are recognized for your deeds in service to the Cenarion Circle.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(106714,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106715,'Your efforts have not gone unnoticed, $n. Time and again you have proven yourself to be one of our finest.','',0,0,0,0,0,0,0,0,4,0,62203,0,26124),
(106716,'The strength, ferocity, and nobility you have shown are without peer. It is time you were honored accordingly.','',0,0,0,0,0,0,0,0,4,0,62205,0,26124),
(106717,'It is my honor to welcome $n as an Archdruid of the Cenarion Circle! May all the creatures of the wilds celebrate your ascension!','',0,0,0,0,0,0,0,0,4,0,62207,0,26124),
(106718,'Uh... you have something attached to your head?','Uh... you have something attached to your head?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106719,'The naga use these parasites to control weaker beings, but I was able to resist it.$B$BWe have formed a symbiotic relationship that allows me to communicate with other beings. Our minds are as one.$B$BTo remove it now would kill both of us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106720,'I see.','I see.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106722,'Where I put ore?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106723,'This ore is heavy and itchy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106724,'Where you want this, rogg?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106725,'','First our outpost is overrun by bears, and now poachers are stealing our bear hides! Could this get any worse?',0,0,0,0,0,0,0,0,0,0,0,58121,26124),
(106726,'','Thanks to your help, we may be able to retake that outpost!',0,0,0,0,0,0,0,0,0,0,0,58120,26124),
(106727,'','Those bears drove us out of our settlement and are tearing through our supplies. Drive them off, and see if you can recover any of our grain while you are there.',0,0,0,0,0,0,0,0,0,0,0,58125,26124),
(106728,'The secrets of the Earth Warder is OURS!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106729,'','Those bears are so unruly! Thanks!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106730,'','Those bears are so unruly! Thanks!',0,0,0,0,0,0,0,0,0,0,0,58124,26124),
(106731,'Deathwing\'s secrets belong to us now, shan ronir!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106732,'','The harpies must have cursed these poor bears. How terrible! Please put them out of their misery.',0,0,0,0,0,0,0,0,0,0,0,58123,26124),
(106734,'','Even the hides are unusable. The harpies will pay for this!',0,0,0,0,0,0,0,0,0,0,0,58122,26124),
(106736,'','|TInterface\\Icons\\inv_misc_herb_stormvine:20|t%s begins to emit a |cFFFF0000|Hspell:192985|h[Cry of Wrath]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(106737,'','|TInterface\\Icons\\inv_misc_herb_stormvine:20|t%s begins to emit a |cFFFF0000|Hspell:192985|h[Cry of Wrath]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(106738,'','The drogbar have uncovered an ancient knowledge from the days of Deathwing. I can hear the spirits cry out in pain. Please, stop them!',0,0,0,0,0,0,0,0,0,0,0,57725,26124),
(106739,'','This dark ore, this... elementium, it is a weapon that I hope the drogbar never master.',0,0,0,0,0,0,0,0,0,0,0,57726,26124),
(106740,'Alright $glad:lass;, I\'ll meet ya at the entrance. Ye come and find me when ye\'re prepared to go inside.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(106745,'I\'m told you know about an ancient weapon.','I\'m told you know about an ancient weapon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106746,'She said you know something about an ancient weapon.','She said you know something about an ancient weapon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106747,'No! We are too late! Zakajz has awakened!','',0,0,0,0,0,0,0,0,0,0,60468,0,26124),
(106748,'The beast seems slow... confused. The sword wounds it still! Quickly, strike it down before it recovers completely!','',0,0,0,0,0,0,0,0,0,0,60469,0,26124),
(106749,'Do you know of a weapon that could help fight the Legion?','Do you know of a weapon that could help fight the Legion?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106750,'I\'m ready, Brann. Let\'s go.','I\'m ready, Brann. Let\'s go.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106751,'You have done what I could not. You defeated Zakajz and lived.','',0,0,0,0,0,0,1,0,0,0,60473,0,26124),
(106752,'You know what needs to be done. Take up the Warbreaker and end the threat of Zakajz once and for all!','',0,0,0,0,0,0,0,0,0,0,60474,0,26124),
(106753,'At last the nightmare is over! I can finally leave this place and be at peace.','',0,0,0,0,0,0,1,0,0,0,60471,0,26124),
(106754,'Elune guide your path, $n.','',0,0,0,0,0,0,0,0,0,0,62306,0,26124),
(106755,'Accordin\' to me notes, it\'s a bit of a trek, but shouldn\'t be too long. Let\'s go!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106756,'','Emmarel Shadewarden is a noble soul. The tauren of Highmountain have long been allies of the Unseen Path.$b$bTalonclaw, the spear wielded by my ancestor Huln Highmountain, was lost in battle against a fierce nightsaber called Dakarr. Many have tried to retrieve it... all have failed.$b$bOur elders believe recovering Talonclaw is the key to driving the Legion from our lands.$b$bMy brother Wuho and I are heading out to slay the beast and claim the spear. If you were to join us, we\'d be sure to succeed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106757,'Been workin\' with ol\' Brann Bronzebeard, searchin\' the Broken Isles for any edge against the Legion.$b$bWe\'re close to findin\' the tomb of some vrykul warlord the legends say stole a rifle called Titanstrike. Brann got all excited, goin\' on about how that gun is infused with the power of storms and such!$b$bSounds interestin\', eh? If you\'re up for fetchin\' it, I\'m your dwarf!','',1,603,0,0,2,0,0,0,0,0,0,0,26124),
(106758,'My commander, Ranger-General Vereesa Windrunner, has uncovered a possible lead as to the whereabouts of her missing sister Alleria.$b$bAlleria\'s knowledge of the Legion would be invaluable to our cause. And the bow she carried with her, Thas\'dorah, is an artifact of awesome power.$b$bTogether, you and the ranger-general can save them both!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(106759,'Those vile harpy skywitches are trying to take our most sacred of artifacts: the Skyhorn. I have sent several squads to stop them, but to no avail. Will you help?','',0,0,0,0,0,0,0,0,0,0,57727,0,26124),
(106760,'Ha ha. That was almost better and bloodier than I would have done! My thanks, champion.','',0,0,0,0,0,0,0,0,0,0,57728,0,26124),
(106761,'','Enough!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106762,'I\'m grateful Lady Shadewarden found you, $n. We have a chance to strike a major blow against the Legion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106763,'Beware! Zakajz grows desperate. He may change his tactics!','',0,0,0,0,0,0,0,0,0,0,60470,0,26124),
(106764,'Il\'zarq N\'Zoth phgwa an\'zig. Il\'zarq taag ov\'kadaq.','',0,0,0,0,0,0,0,0,0,0,57751,0,26124),
(106765,'Phnagg\'ba teq\'nir ssq qwal N\'Zoth!','',0,0,0,0,0,0,0,0,0,0,57750,0,26124),
(106766,'Shath\'mag vwyq shu et\'agthu, Shath\'mag sshk ye! Ag\'rr hazz ak\'yel ksh ga\'halahs pahg!','',0,0,0,0,0,0,0,0,0,0,57749,0,26124),
(106767,'Shath\'mag vwyq shu et\'agthu, Shath\'mag sshk ye! Krz\'ek fhn\'z agash zz maqdahl or\'kaaxth\'ma amqa!','',0,0,0,0,0,0,0,0,0,0,57748,0,26124),
(106768,'Sk\'yahf qi\'magg luk sshoq anagg\'qen.','',0,0,0,0,0,0,0,0,0,0,57747,0,26124),
(106769,'Shath\'gral ynyq. Weq... weq... weq...','',0,0,0,0,0,0,0,0,0,0,57746,0,26124),
(106770,'Y\'za noq mah... Y\'za noq ormz...','',0,0,0,0,0,0,0,0,0,0,57745,0,26124),
(106771,'Yeh\'glu N\'Zoth okom hoq... Y\'za sythn oou...','',0,0,0,0,0,0,0,0,0,0,57744,0,26124),
(106772,'Poq\'yith mazzka awan ki uhnish\'philfgsh.','',0,0,0,0,0,0,0,0,0,0,57743,0,26124),
(106773,'En\'othk uulg\'shuul. Mh\'za uulwi skshgn kar.','',0,0,0,0,0,0,0,0,0,0,57742,0,26124),
(106774,'Iilth qi mah\'shar fhn oorql N\'Zoth!','',0,0,0,0,0,0,0,0,0,0,57741,0,26124),
(106775,'Iilth ma paf\'qi\'ag sk\'halahs. GAZ SKSHGN!','',0,0,0,0,0,0,0,0,0,0,57740,0,26124),
(106776,'Mg\'uulwi N\'Zoth, eth\'razzqi worg zz oou.','',0,0,0,0,0,0,0,0,0,0,57739,0,26124),
(106777,'N\'Zoth iiyoq raz\'tal\'vsak! IIYOQ NEL\'OTHK AR\'AFGH!','',0,0,0,0,0,0,0,0,0,0,57738,0,26124),
(106778,'So that lass Emmarel Shadewarden sent you my way? Seems she\'s good as her word, that one.$b$bDon\'t know a thing about this Unseen Path she\'s part of, but I\'m willin\' to hear her out.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106779,'Al\'ksh syq iir awan? Iilth sythn aqev... aqev... aqev...','',0,0,0,0,0,0,0,0,0,0,57737,0,26124),
(106780,'The voice of N\'Zoth whispers from the deep. It sings of unspeakable horrors.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106781,'These mortal wards have no effect on the spawn of N\'Zoth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106782,'The Black Empire once ruled this pitiful world, and it will do so again! We will reforge our dread citadels atop the fly-blown corpse of this kingdom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106783,'The Black Empire once ruled this world, and it will do so again! Your pitiful kind will know only despair and sorrow for a hundred thousand millennia to come!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106784,'Your soul will wander roads that twist in endless spirals.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106785,'The Old Ones beckon. Go... go... go...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106786,'I am not the first... I am not the last...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106787,'The blood of N\'Zoth runs through me... I cannot die...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106788,'The crooked serpent with no eyes is watching from the endless sky.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106789,'There is no light after death. Only a place where even shadows fear to go.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106790,'You will be the first of many to glimpse the madness of N\'Zoth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106791,'You are a prisoner in your own body. A SERVANT OF FEAR!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106792,'In the writhing shadow of N\'Zoth, all light fades and dies.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106793,'The will of N\'Zoth is made manifest! IT CANNOT BE CONTAINED!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106794,'Is this real or an illusion? You are going mad... mad... mad...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106795,'','You will never ssstop usss. Jandvik will fall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106796,'','Hey there, friend! We\'re looking for an \"assistant\" to help us test some of these weapons. Interested?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106797,'','Oh good, the prototype made it back in one piece. And, er, you survived too!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106798,'Alright, Dis gonna be good! If you be needin\' something done you just tell Zen\'Kiki.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106799,'','Hi, $ct!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106800,'','Everything\'s fantastic in the forest, $ct.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106801,'','Good day to you, $ct.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106802,'Jes keep going straight, and then make a right at the end there.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(106803,'Now make a left here, and we\'re pretty much at the end.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(106804,'We\'ve made it! And would you look at that, a titan console! I\'m on it, $glad:lass;. You jes make sure that nothin\' bothers me while I\'m workin\'.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(106805,'I leave my blade to you. Strom\'kar deserves to be wielded in battle, not locked away in a tomb. It was forged by a master swordsmith and imbued with elven magics. I know not whether being buried in that beast for centuries has affected it, but I trust that it will serve you well.','',0,0,0,0,0,0,1,0,0,0,60472,0,26124),
(106806,'','Mylune puffs out her chest assertively, sniffling.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106807,'','We can do this, $n. G\'Hanir is counting on us!',0,0,0,0,0,0,0,0,0,0,0,62245,26124),
(106808,'','I will have this tower, along with the heads of the Gilneans who hold it! Attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106809,'','Oh, raspberries! I don\'t know what to do!',0,0,0,0,0,0,0,0,0,0,0,62243,26124),
(106810,'','Our forces prevail! Watch them panic and flee like the dogs they are! For the Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106811,'The Forsaken look weak. This tower is ripe for the taking. Show them what happens to enemies of the Alliance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106812,'Their lines break, and their captain falls. This is the sound of Gilnean vengeance! For the Alliance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106813,'Drawing Sacred Water','Drawing Sacred Water',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106814,'Intruders detected. Initiating termination protocols.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(106815,'Of course you may.$B$BWhat pulls you towards the Dream with such fervor, Shan\'do?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106816,'I need your blessing so that I may enter the Emerald Dream.','I need your blessing so that I may enter the Emerald Dream.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106817,'Ach! That doesn\'t sound good. Hold that thing off while I finish over here.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(106818,'Almost there, $glad:lass;. Just hold on a bit longer.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(106819,'G\'Hanir has been touched by the Nightmare.','G\'Hanir has been touched by the Nightmare.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106820,'G\'Hanir is in danger? Then there is no time to waste.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106821,'That\'s it, I got it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(106822,'The room\'s countermeasures are now armed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106823,'Welcome, $n. The trees whispered of your arrival.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106824,'Loathsome naga have crawled forth from their dark holes beneath the sea. I cannot abide the presence of such corrupt beasts! Show them the meaning of honorable battle.','',0,0,0,0,0,0,0,0,0,0,60098,0,26124),
(106825,'Naga are vile creatures and dangerous if left unchecked. The death you gave them was more noble than they deserved!','',0,0,0,0,0,0,0,0,0,0,60099,0,26124),
(106826,'May Elune guide your path.','',0,0,0,0,0,0,0,0,0,0,62242,0,26124),
(106827,'Finally free... and you will NOT imprison me again.','',0,0,0,0,0,0,0,0,0,0,57810,0,26124),
(106828,'I *crave* the smell of freshly spilled blood. How convenient that you are here.','',0,0,0,0,0,0,0,0,0,0,57811,0,26124),
(106829,'You should have died in Northrend.','',0,0,0,0,0,0,0,0,0,0,57818,0,26124),
(106830,'Another one crushed between my pincers.','',0,0,0,0,0,0,0,0,0,0,57819,0,26124),
(106831,'Too easy an end. How disappointing.','',0,0,0,0,0,0,0,0,0,0,57820,0,26124),
(106832,'Did you expect me to be a simple obstacle, fools?','',0,0,0,0,0,0,0,0,0,0,57821,0,26124),
(106833,'I cannot hear the Lich King... has he abandoned me?...','',0,0,0,0,0,0,0,0,0,0,57814,0,26124),
(106834,'But it is MY destiny to rule Azjol-Nerub...','',0,0,0,0,0,0,0,0,0,0,57815,0,26124),
(106835,'Your strength means NOTHING!','',0,0,0,0,0,0,0,0,0,0,57822,0,26124),
(106836,'I will crush your bones to POWDER!','',0,0,0,0,0,0,0,0,0,0,57823,0,26124),
(106837,'Only scraps will remain!','',0,0,0,0,0,0,0,0,0,0,57816,0,26124),
(106838,'Bleed and die, vermin.','',0,0,0,0,0,0,0,0,0,0,57817,0,26124),
(106839,'Consume their flesh!','',0,0,0,0,0,0,0,0,0,0,57812,0,26124),
(106840,'A feast for my brethren...','',0,0,0,0,0,0,0,0,0,0,57813,0,26124),
(106841,'','Those fiends from Hrydshal have gone too far! The  vrykul there led a brutal raid on Highmountain, taking many captives. Please, help us get our people back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106842,'','The vrykul have always been bold, but these vile giants have gone too far. Thank you for putting them back in their place.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106843,'','Don\'t worry! $n will fix this, just you wait!',0,0,0,0,0,0,0,0,0,0,0,62246,26124),
(106844,'','Up ahead... that looks like the interrogation area.',0,0,0,0,0,0,0,0,0,0,0,61797,26124),
(106845,'','Be careful. It isn\'t safe in the Dream right now!',0,0,0,0,0,0,0,0,0,0,0,62241,26124),
(106846,'I\'m afraid the Dream is in a worse state than we thought.','',0,0,0,0,0,0,0,0,0,0,62240,0,26124),
(106847,'You still have the moonwater, yes? Good, good! Then you are ready.','',0,0,0,0,0,0,0,0,0,0,62238,0,26124),
(106848,'Now just relax and focus your mind on the Dream. I will guide your spirit from here.','',0,0,0,0,0,0,0,0,0,0,62235,0,26124),
(106849,'I will guide your journey from here. Good luck.','',0,0,0,0,0,0,0,0,0,0,62236,0,26124),
(106850,'Welcome, $p. As a subtlety rogue you specialize in striking from the shadows, dispatching foes quickly and quietly. Let\'s begin your training with your primary attack, Backstab.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106851,'Use Backstab on this target dummy. Attacking from behind inflicts more damage.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106852,'Curious Owlkitten reaches a paw out and lightly bats at the cup.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106853,'Curious Owlkitten stares directly into Val\'Sharah Exile\'s eyes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106854,'Curious Owlkitten knocks the cup off the table.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106855,'','Hey!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106856,'','Val\'Sharah Exile tries to shoo the kitten away.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106857,'','No...!',661,0,0,0,0,0,0,0,0,0,0,0,26124),
(106858,'','Gah!',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(106859,'Rogues favor trickery and cunning. And what\'s trickier than attacking before your target sees you coming? Stealth makes you invisible to most enemies. When in Stealth, you open up specialized tactics that can devastate foes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106860,'Use Stealth to fade from view.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106861,'|TInterface\\Icons\\spell_fel_elementaldevastation:20|t Krosus raises his right arm and charges a |cFFFF0404|Hspell:201215|h[Fel Beam]|h|r!','|TInterface\\Icons\\spell_fel_elementaldevastation:20|t Krosus raises his right arm and charges a |cFFFF0404|Hspell:201215|h[Fel Beam]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106862,'|TInterface\\Icons\\spell_fel_elementaldevastation:20|t Krosus raises his left arm and charges a |cFFFF0404|Hspell:201215|h[Fel Beam]|h|r!','|TInterface\\Icons\\spell_fel_elementaldevastation:20|t Krosus raises his left arm and charges a |cFFFF0404|Hspell:201215|h[Fel Beam]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106863,'Patience...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106864,'','Yes, brother. *sigh*',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106865,'Vrykul scum! I will have my revenge.','Vrykul scum! I will have my revenge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106866,'Thank the Earth Mother you arrived in time. They had dark plans for us.','Thank the Earth Mother you arrived in time. They had dark plans for us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106867,'Thank you, Champion. I will find my own way out of here.','Thank you, Champion. I will find my own way out of here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106868,'The vrykul have grown bold. Be careful.','The vrykul have grown bold. Be careful.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106869,'Time to find some weapons!','Time to find some weapons!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106870,'They hit us hard and fast. I have not seen the vrykul attack like that in many many years.','They hit us hard and fast. I have not seen the vrykul attack like that in many many years.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106871,'I dread to think what they were going to do with us.','I dread to think what they were going to do with us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106872,'Can you hear me, $n?','',0,0,0,0,0,0,0,0,0,0,62223,0,26124),
(106874,'G\'Hanir rests at the Circle of Spirits above, but it oozes Nightmare into the barrow den. You must hurry before you succumb to the corruption!','',0,0,0,0,0,0,0,0,0,0,62224,0,26124),
(106876,'Another one of Lespin\'s thugs? I have had it with him. My pet will teach you a lesson!','Another one of Lespin\'s thugs? I have had it with him. My pet will teach you a lesson!',0,0,0,0,0,0,0,0,0,0,65816,0,26124),
(106878,'Fine, take it! Just don\'t hurt me any more. The chest is over there.','Fine, take it! Just don\'t hurt me any more. The chest is over there.',0,0,0,0,0,0,0,0,0,0,65815,0,26124),
(106879,'','You must have traveled very far to face me. If it\'s battle you seek, I\'ll happily oblige. Loser buys dinner!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106880,'Need... air...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106881,'Can\'t breathe...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106882,'Where... what...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106883,'Stupid squid!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106884,'Get off my face!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106885,'','Good fight! The tribes will sing songs of your bravery. Now, was it the winner who buys dinner, or the loser?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106886,'I am free!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106887,'Curse these naga!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106888,'','Can\'t be givin\' in. We must fight!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106889,'','My thanks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106890,'','The elements be by your side.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106891,'','Keep movin\'!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106892,'Allow me to repay you.','Allow me to repay you.',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(106893,'I must warn the Warchief at once!','I must warn the Warchief at once!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106894,'The elements guide my blades.','The elements guide my blades.',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(106895,'These lands... what have they become?','These lands... what have they become?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106896,'I\'ve got to check on the others, but this should help.','I\'ve got to check on the others, but this should help.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106897,'Looks like you could use some help.','Looks like you could use some help.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106898,'My apologies $n, but I must keep moving.','My apologies $n, but I must keep moving.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106899,'I could always use more practice.','I could always use more practice.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106904,'I must warn the others!','I must warn the others!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(106905,'$n - I must report these events at once!','$n - I must report these events at once!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(106906,'','I thought I was done for!',0,0,0,0,0,0,0,0,0,0,0,62226,26124),
(106907,'','I\'d prefer to avoid these horrors. Let\'s sneak past them!',0,0,0,0,0,0,0,0,0,0,0,62227,26124),
(106908,'My magic is now yours, $n.','My magic is now yours, $n.',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(106909,'It appears I underestimated the Legion\'s power. Perhaps I may join you?','It appears I underestimated the Legion\'s power. Perhaps I may join you?',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(106910,'For the Horde!','For the Horde!',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(106911,'Heh. I could always use a little more practice.','Heh. I could always use a little more practice.',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(106912,'Blood and Honor!','Blood and Honor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106913,'','Someone... anyone! I can\'t escape these roots!',0,0,0,0,0,0,0,0,0,0,0,62225,26124),
(106914,'Lost Owlkitten raises its nose to the air and chirps in recognition of its surroundings.','',0,0,0,0,0,0,377,0,0,0,0,0,26124),
(106915,'Where you go, munchy feathers?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106916,'Lunch, where are you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106917,'HUNGRY.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106918,'Where meat?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106919,'Want eat Feathermane!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106921,'We\'ve arrived!','',0,0,0,0,0,0,0,0,0,0,69908,0,26124),
(106922,'Torok\'s son, Mellok, is rallying the Feltotem against us. Stifle their efforts before they can invade Stonedark Cavern!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106923,'The Bloodtotem will regret taking the offer of their demonic masters.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106924,'','The Feltotem work to open a portal at Torok\'s Bluff. What they plan to bring through, I hope I never know.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106925,'','Thank you. You were able to stop them before anything could come through.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106926,'','Now the Feltotem corrupt their own waters to turn even nature against us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106927,'','You stopped the spread of fel corruption before it could reach our waters. We are ever in your debt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106928,'','The path is blocked! I think I can clear it out.',0,0,0,0,0,0,0,0,0,0,0,62228,26124),
(106930,'Use Shadowstrike to attack the target dummy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106931,'','That did it! You go on ahead. I\'ll deal with things down here.',0,0,0,0,0,0,0,0,0,0,0,62229,26124),
(106932,'Now that you\'ve built up 5 combo points, it\'s time to Eviscerate. Whenever you Eviscerate with 5 combo points, you will do massive damage and immediately enter stealth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106933,'Use Eviscerate with 5 combo points.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106934,'Why is there always an extra screw? It must go somewhere...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106939,'Let\'s go!','Let\'s go!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106940,'Curse you! This is going to take hours to fix!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(106941,'|TInterface\\Icons\\Spell_Fire_FelFlameStrike:20|t Krosus targets you with an |cFFFF0404|Hspell:205344|h[Orb of Destruction]|h|r!','|TInterface\\Icons\\Spell_Fire_FelFlameStrike:20|t Krosus targets you with an |cFFFF0404|Hspell:205344|h[Orb of Destruction]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106942,'Are you alright? I think you\'re past the worst of it.','',0,0,0,0,0,0,0,0,0,0,62230,0,26124),
(106943,'You\'re nearly there! Just stay focused!','',0,0,0,0,0,0,0,0,0,0,62231,0,26124),
(106944,'The harpies are swarming the nesting grounds of our eagle allies. They want a fight? Ha! We will give them a fight!','',0,0,0,0,0,0,0,0,0,0,57892,0,26124),
(106945,'I imagine you have heard of Huln Highmountain, but have you heard the story of the rest of the tribes? They too were champions of the War of the Ancients.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106946,'Show me their story.','Show me their story.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106947,'Haha! Well done, Champion. That should show those sky hags a thing or two.','',0,0,0,0,0,0,0,0,0,0,57893,0,26124),
(106948,'','Rocko is back! Whenever he grows too big, it triggers nasty earthquakes. Shaving off a bit of shale every now and then keeps him stable. You mind helping out?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106949,'','That should knock him down to size!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106950,'YOUR POWER WILL BE MINE!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(106951,'You\'re learning how to paint with a dagger. Now it\'s time to perfect your art.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106952,'Shadowstrike to a target, generate 5 combo points with Backstab, and finish them with Eviscerate. That should leave you in stealth, ready to Shadowstrike to your next target.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106953,'Apologies, $n. I had to wake you before you fell too deeply.','',0,0,0,0,0,0,0,0,0,0,62237,0,26124),
(106954,'Take care! I can feel the Nightmare encroaching on your mind!','',0,0,0,0,0,0,0,0,0,0,62222,0,26124),
(106955,'I urge you to be cautious. You must not let the Nightmare overcome you.','',0,0,0,0,0,0,0,0,0,0,62221,0,26124),
(106956,'','Good to see you made it, $n. We need only a few more things before we can begin.',0,0,0,0,0,0,0,0,0,0,0,69734,26124),
(106957,'','Calm your mind, let go and your spirit will enter into the Dream. I\'ll join you soon.',0,0,0,0,0,0,0,0,0,0,0,69735,26124),
(106958,'The skies... Infernals - INCOMING!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(106959,'','Drink this vial of moonwell water, it\'ll help you relax so you can enter the Dream. Then lay down in front of the stone and we can begin.',0,0,0,0,0,0,1,0,0,0,0,69733,26124),
(106960,'My kin are safe and the seawarden is dead. I will return to Jandvik now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106961,'Fel artillery! Spread out!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(106962,'DO NOT LOCALIZE','DO NOT LOCALIZE',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106963,'Fools! While your petty outpost was under attack our forces spread across your sacred lands!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106964,'Trifling mortals! It is time you felt the power of the Burning Legion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106965,'Monstrosity! East gate needs reinforcements!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(106966,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(106967,'For the Warchief!','For the Warchief!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(106968,'Hold the lines! Nothing gets through!','Hold the lines! Nothing gets through!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(106969,'The Doomhammer is somewhere in these chambers. I can feel it.','',0,0,0,0,0,0,1,0,0,0,68814,0,26124),
(106970,'Scout the chambers ahead... I will stay nearby...','',0,0,0,0,0,0,1,0,0,0,68815,0,26124),
(106971,'The Inquisition sees all! Every truth! Every lie!','',0,0,0,0,0,0,0,0,0,0,61812,0,26124),
(106974,'You think you can best my snails?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106975,'All the more reason to get to the Doomhammer first.','',0,0,0,0,0,0,1,0,0,0,68816,0,26124),
(106976,'At least dead snails are delicious.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106977,'You just got snailed!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106978,'Ooh! Dinner!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106979,'I\'ll save him for later.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106980,'Looks like he\'s cooked.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106981,'You have a little slime on your face.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106982,'Too slow!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106984,'If you\'re done with that one, it\'d make a great stew!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106986,'Hurry, roggs. We can\'t hold here forever.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106987,'Search faster, roggs.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106988,'Quick, roggs. Find what you\'re looking for or forget it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106989,'Hurry. The ronir and their pet, $p, will be here soon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106990,'Grab and go! Grab and go! We\'re leaving now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106991,'Two trainers enter. One leaves a winner. The other has dinner.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(106992,'That is far enough, ronir lovers. You ain\'t gonna pass.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106993,'','Keep your eyes on Thrall. He\'s wounded. He\'s likely to kill himself down here, and I don\'t wanna be the one who has to tell his wife!',0,0,0,0,0,0,0,0,0,0,0,60563,26124),
(106994,'Doomhammer... it felt like dead weight in my hands. The elements were silent. It has been this way since I used it to slay Garrosh.','',0,0,0,0,0,0,1,0,0,0,68818,0,26124),
(106995,'Your legion is no match for an orc and his people, demon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(106996,'','By the Light... There! It\'s her bow! Thas\'dorah!',0,0,0,0,0,0,0,0,0,0,0,61834,26124),
(106997,'','Alleria was here... her bow\'s presence is the proof! Doubtless she escaped, and the Inquisitor sought to use me to lure her back.',0,0,0,0,0,0,1,0,0,0,0,61835,26124),
(106998,'','This is a bow worthy of a hero like Alleria... a hero like you. Take Thas\'dorah, $n. Use it to lead the fight to save Azeroth!',0,0,0,0,0,0,603,0,0,0,0,61837,26124),
(106999,'Trifling mortals! Your arrogance will be your undoing!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(107000,'Another will take my place. Your world is doomed...','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(107001,'IN-FER-NO!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(107002,'We\'ve got to keep moving. Geth\'xun is close...','',0,0,0,0,0,0,1,0,0,0,68819,0,26124),
(107003,'','Please help! I can\'t hold the corruption back much longer!',0,0,0,0,0,0,0,0,0,0,0,62232,26124),
(107004,'','I would have surely been overwhelmed if you had not arrived. Thank you.',0,0,0,0,0,0,2,0,0,0,0,62233,26124),
(107005,'','Let us reconvene in the physical world.',0,0,0,0,0,0,0,0,0,0,0,62234,26124),
(107006,'Saving','Saving',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107007,'By the Ancients, you have it! You have G\'Hanir!','',0,0,0,0,0,0,603,0,0,0,62239,0,26124),
(107008,'G\'Hanir will not last much longer. It must be cleansed!','',0,0,0,0,0,0,0,0,0,0,62249,0,26124),
(107009,'We must aid Bashana in cleansing the remaining Nightmare. G\'Hanir\'s fate rests with Lyessa and $p.','',0,0,0,0,0,0,0,0,0,0,62247,0,26124),
(107010,'The Doomhammer! Get the Doomhammer! Prove your power as a shaman...','',0,0,0,0,0,0,1,0,0,0,68820,0,26124),
(107013,'You have been energized by the Azuregale Zapper!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107014,'You are just in time for the Legion\'s first strike on Dalaran. These prisoners will paint the city streets red with blood. It\'s a shame you won\'t be alive to see it happen.','',0,0,0,0,0,0,0,0,0,0,57927,0,26124),
(107015,'The fall of Dalaran begins here. These prisoners will stain the streets red with blood. And when they\'re done, the Legion will bring this city crashing to the ground!','',0,0,0,0,0,0,0,0,0,0,57928,0,26124),
(107016,'Your armor might protect you from blade and claw, but it is useless against this Faceless One. With a mere whisper, it can drive a mortal mind to madness.','',0,0,0,0,0,0,0,0,0,0,57929,0,26124),
(107017,'I have witnessed horrors that would put your darkest nightmares to shame, but I have never seen anything as terrifying as THIS... an angry gnomish inventor.','',0,0,0,0,0,0,0,0,0,0,57930,0,26124),
(107018,'I sense great fury and bitterness in this gnome. She has kept these feelings bottled up for so long... It is only a matter of time before she explodes.','',0,0,0,0,0,0,0,0,0,0,57931,0,26124),
(107019,'Even with magical wards in place, I can still smell the reek of this wretched Abomination. Do the world a favor and dispose of it, will you?','',0,0,0,0,0,0,0,0,0,0,57932,0,26124),
(107020,'Reinforcements are here! Push them back!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(107021,'Ah... even I have heard of Shivermaw, the fallen blue dragon once known as Eldragosa. She will be perfect for terrorizing the skies of Dalaran.','',0,0,0,0,0,0,0,0,0,0,57933,0,26124),
(107022,'Blood-Princess Thal\'ena... You must be hungry after all these years in prison. Go and slake your thirst on the blood and souls of Dalaran!','',0,0,0,0,0,0,0,0,0,0,57934,0,26124),
(107023,'The San\'layn are cold and arrogant creatures. They inflict pain for pure entertainment. All in all, they sound like my kind of people.','',0,0,0,0,0,0,0,0,0,0,57935,0,26124),
(107024,'Crypt lords do not take defeat well. Being locked in this prison will have made this one angry... Very, VERY angry.','',0,0,0,0,0,0,0,0,0,0,57936,0,26124),
(107025,'The whole of Azeroth will rise against you, demon.','',0,0,0,0,0,0,1,0,0,0,68822,0,26124),
(107026,'Come now, Anub\'esset! You call yourself a great crypt lord, and you can\'t even burrow your way out of this prison? Show us why you are to be feared!','',0,0,0,0,0,0,0,0,0,0,57937,0,26124),
(107027,'The very earth beneath your feet and the skies above your head will lash out against your damned crusade!','',0,0,0,0,0,0,1,0,0,0,68823,0,26124),
(107028,'I expected more from these prisoners. If they cannot break you, then I will.','',0,0,0,0,0,0,0,0,0,0,57938,0,26124),
(107029,'Enough! These prisoners are useless. As the old saying goes: \"If you want to destroy a floating city the right way, you have to do it yourself.\"','',0,0,0,0,0,0,0,0,0,0,57939,0,26124),
(107030,'The rest of Dalaran will join you soon.','',0,0,0,0,0,0,0,0,0,0,57940,0,26124),
(107031,'Not as easy as the prisoners, am I?','',0,0,0,0,0,0,0,0,0,0,57941,0,26124),
(107032,'Another so-called hero falls to the Legion!','',0,0,0,0,0,0,0,0,0,0,57942,0,26124),
(107033,'And now to cast this lofty city from the skies...','',0,0,0,0,0,0,0,0,0,0,57943,0,26124),
(107034,'After Dalaran falls, what hope does the world have?','',0,0,0,0,0,0,0,0,0,0,57944,0,26124),
(107035,'Pity... I will not see the world... burn...','',0,0,0,0,0,0,0,0,0,0,57945,0,26124),
(107036,'You will fall... sooner or later...','',0,0,0,0,0,0,0,0,0,0,57946,0,26124),
(107037,'These are fanatics, believing this Vault holds one of their greatest legends: The Grey One.','',0,0,0,0,0,0,0,0,0,38951,0,0,26124),
(107038,'The Grey One was a drogbar so evil, Neltharion encased him in stone as a lesson to us all. We must not let these zealots free him.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107039,'Crok! The Grey One has been unleashed. We must get out of here before the vault\'s defenses return.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107042,'This device appears to draw upon the void energy released when Malygos forced Azeroth\'s ley lines into the Twisting Nether.','',0,0,0,0,0,0,1,0,0,0,61766,0,26124),
(107043,'The Doomhammer chose you, shaman. Already you wield it with a power that I never tapped into.','',0,0,0,0,0,0,1,0,0,0,68824,0,26124),
(107044,'I must go my own way. I have a great deal of thinking to do. Aggra will be at the Maelstrom shortly. Listen to her counsel... she has taught me so much.','',0,0,0,0,0,0,6,0,0,0,68825,0,26124),
(107045,'Go back to the Earthen Ring. Bring them together. Turn their might against the Legion. This is your time.','',0,0,0,0,0,0,1,0,0,0,68826,0,26124),
(107046,'The design looks very familiar...','',0,0,0,0,0,0,1,0,0,0,61767,0,26124),
(107047,'This weapon has been infused with dark energies from the Twisting Nether.','',0,0,0,0,0,0,1,0,0,0,61768,0,26124),
(107048,'Whoever wielded it must be seeking to harness void energy. But for what purpose?','',0,0,0,0,0,0,1,0,0,0,61769,0,26124),
(107049,'This portal is very similar to ones used by the ethereals in Outland.','',0,0,0,0,0,0,1,0,0,0,61770,0,26124),
(107050,'Could they be the threat? What did Malygos promise them?','',0,0,0,0,0,0,6,0,0,0,61771,0,26124),
(107053,'Chuang!','',0,0,0,0,0,0,0,0,0,0,62023,0,26124),
(107054,'','Uncle!',0,0,0,0,0,0,0,0,0,0,0,62053,26124),
(107055,'Li Li, let\'s go check on the little ones.','',0,0,0,0,0,0,0,0,0,0,62012,0,26124),
(107056,'','Right behind you, Uncle Chen!',0,0,0,0,0,0,0,0,0,0,0,62018,26124),
(107057,'G\'Hanir grows more corrupt with each passing moment. May your feet carry you swiftly!','',0,0,0,0,0,0,0,0,0,0,62248,0,26124),
(107059,'Hamuul Runetotem led a small party to investigate Legion activity near Nordrassil not long ago. He may be able to aid you.','',0,0,0,0,0,0,0,0,0,0,62212,0,26124),
(107060,'Slay them all... for Jandvik...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107061,'','May the ancients bless us all.',0,0,0,0,0,0,0,0,0,0,0,62211,26124),
(107062,'','Once G\'Hanir is pure again, we can help Archdruid Greathelm cleanse any remaining Nightmare at the Dreamgrove.',0,0,0,0,0,0,0,0,0,0,0,62213,26124),
(107063,'','I only hope we are not too late to save G\'Hanir.',0,0,0,0,0,0,0,0,0,0,0,62214,26124),
(107064,'You are too late, karkrun! The Grey One shall be free!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107065,'','The drogbar are assaulting Thunder Totem and too many of my forces have been drawn off to engage with the Legion. Can you assist us, champion?',0,0,0,0,0,0,0,0,0,0,0,58221,26124),
(107066,'','This was a costly lesson in not overextending my forces. I appreciate your help, champion.',0,0,0,0,0,0,0,0,0,0,0,58220,26124),
(107067,'To the center of town! Mount up! We fight as one!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(107068,'For the Horde!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(107069,'$n... thank the Ancients you\'ve come.','',0,0,0,0,0,0,0,0,0,0,62141,0,26124),
(107070,'Those depraved murlocs keep finding new ways of sinking ships! I\'m sure recovering supplies from those shipwrecks would be appreciated.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107071,'I try so hard to set murlocs on the right path. With the wrong leaders, they can get ouf of control quite quickly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107072,'The Swamprock are up to no good again! That crab rider leads them to do rather dreadful deeds.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107073,'It makes me shudder to think what you had to do to those poor things, but it could not be avoided.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107074,'Murky needs your help! The Clackbrine amass in great numbers and are likely to attack Murky\'s hard-won lair.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107075,'With your direction, Murky and his tadpole tribe are safe once again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107076,'All of the tadpoles Murky recruited are getting hungry! We\'re in luck, though. A crab migration has begun, and their meat is so sweet! Not that I would know...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107077,'You can hear the squeals of delight from the tadpole cave. They\'ll grow big and strong!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107078,'A massive Clackbrine has risen to power on the coast. But I don\'t think Murky is quite strong enough to defeat it without some extra help!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107079,'Murky is great at learning new tricks! He sometimes forgets what I teach him just as easily, though.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107080,'What brings a follower of Cenarius to my lair?','',0,0,0,0,0,0,0,0,0,0,62108,0,26124),
(107081,'The witches of the forest are getting too bold. They leave their woods and attack my people while we hunt down the Feltotem.','',0,0,0,0,0,0,0,0,0,0,58273,0,26124),
(107082,'Those foul harpies better stick to the trees, or we\'ll make sure a sea of feathers and witch blood carpets the forest floor.','',0,0,0,0,0,0,0,0,0,0,58272,0,26124),
(107083,'','Such devastation...',0,0,0,0,0,0,0,0,0,0,0,62142,26124),
(107084,'The darkness gonna take you!','',0,0,0,0,0,0,0,0,0,0,57965,0,26124),
(107085,'Don\'t mess with the mountain!','',0,0,0,0,0,0,0,0,0,0,57966,0,26124),
(107086,'Puny karkun! Shouldn\'t be here!','',0,0,0,0,0,0,0,0,0,0,57967,0,26124),
(107087,'Shan ronir! Go kiss a tauren!','',0,0,0,0,0,0,0,0,0,0,57968,0,26124),
(107088,'The stone answers to me!','',0,0,0,0,0,0,0,0,0,0,57957,0,26124),
(107089,'That blood of yours will do fine...','',0,0,0,0,0,0,0,0,0,0,57958,0,26124),
(107090,'Die, shan ronir!','',0,0,0,0,0,0,0,0,0,0,57959,0,26124),
(107091,'We are the darkness beneath the mountain!','',0,0,0,0,0,0,0,0,0,0,57960,0,26124),
(107092,'You will fear the deep dark!','',0,0,0,0,0,0,0,0,0,0,57961,0,26124),
(107093,'Darkness take you!','',0,0,0,0,0,0,0,0,0,0,57962,0,26124),
(107094,'Stone! Obey me!','',0,0,0,0,0,0,0,0,0,0,57963,0,26124),
(107095,'Foolish karkun! Let\'s see how fast you die!','',0,0,0,0,0,0,0,0,0,0,57964,0,26124),
(107096,'','The vision is chaotic, unfocused. I need to concentrate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107097,'','I will need to focus on the vision to understand its message. Guard me while I do this, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107098,'Yes, Tyrande.','Yes, Tyrande.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107099,'They were... too much...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107100,'What happened here?','What happened here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107101,'We were sent to clear out a stray pack of fel hounds. But what we found...','',0,0,0,0,0,0,0,0,0,0,62143,0,26124),
(107102,'The gates of hell poured forth upon us. They were everywhere...','',0,0,0,0,0,0,0,0,0,0,62144,0,26124),
(107103,'Tend to the others first. Their wounds are more dire than my own.','',0,0,0,0,0,0,0,0,0,0,62145,0,26124),
(107104,'','Skylord, you must inform the Dreamgrove. We will ensure no further life is lost this day.',0,0,0,0,0,0,1,0,0,0,0,62146,26124),
(107105,'','No!',0,0,0,0,0,0,0,0,0,0,0,61842,26124),
(107106,'','What have you done with Alleria, monster?',0,0,0,0,0,0,0,0,0,0,0,61841,26124),
(107107,'Speak, $r. Why have you disturbed my rest?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107108,'','Was she here for days? Years? Centuries? The mage was right... time has little meaning in this place.',0,0,0,0,0,0,0,0,0,0,0,61832,26124),
(107109,'<The ancient stares at you expectantly.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107110,'Ronir! Today is the day you die!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(107111,'Thank you, $n. We barely survived their last attack.','',0,0,0,0,0,0,0,0,0,0,62148,0,26124),
(107114,'','Oh, my head... I feel dizzy...',0,0,0,0,0,0,0,0,0,0,0,62149,26124),
(107115,'The Legion has not forgotten their defeat here.','',0,0,0,0,0,0,0,0,0,0,62151,0,26124),
(107116,'','The well was nearly lost during the assault. But so long as a single drop remains, there is hope!',0,0,0,0,0,0,0,0,0,0,0,62152,26124),
(107118,'','Ash\'alah, to me.',0,0,0,0,0,0,0,0,0,0,0,58035,26124),
(107119,'','Do not let anything disturb my meditation. I must see through the chaos.',0,0,0,0,0,0,0,0,0,0,0,58034,26124),
(107120,'','Bless ya, $n. I could feel me soul returnin\' to da loa.',0,0,0,0,0,0,0,0,0,0,0,62150,26124),
(107121,'Are you certain you are ready? This will be your most difficult task.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107122,'I am prepared!','I am prepared!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107123,'','His location is still unclear, but he lives.',0,0,0,0,0,0,0,0,0,0,0,58030,26124),
(107124,'','We must go deeper into the nightmare. Wherever he is, peril is already upon him!',0,0,0,0,0,0,0,0,0,0,0,58029,26124),
(107125,'','I see... swirling red mist. Gnashing teeth.',0,0,0,0,0,0,0,0,0,0,0,58033,26124),
(107126,'','Malfurion! He is in pain! Keep fighting, my love!',0,0,0,0,0,0,0,0,0,0,0,58032,26124),
(107127,'','Such malevolent laughter... Xavius, you cruel creature! I am coming for you!',0,0,0,0,0,0,0,0,0,0,0,58031,26124),
(107128,'','I only pray that we are not too late.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107129,'','$p, you must save our injured. I will prepare the cleansing ritual.',0,0,0,0,0,0,1,0,0,0,0,62147,26124),
(107130,'','I am ready to begin the ritual, $n!',0,0,0,0,0,0,0,0,0,0,0,62153,26124),
(107131,'','Preparations are complete. We are ready to begin.',0,0,0,0,0,0,0,0,0,0,0,62139,26124),
(107132,'','This land belongs to the Wormtalon! Squaaaaak!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107133,'','Meet me back at the refuge and we will continue our search.',0,0,0,0,0,0,0,0,0,0,0,58036,26124),
(107134,'There\'s just one last thing you need to learn. Sometimes a strategic retreat is necessary so you can live to fight another day. Vanish allows you to disengage from combat and make a quick getaway.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107135,'Use Vanish to evade this brute.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107136,'The fish in this area swim up river to... well, I\'m not sure, but they seem very excited about it. Great time for spear fishing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107137,'','Come. We must make haste.',0,0,0,0,0,0,0,0,0,0,0,58037,26124),
(107138,'You didn\'t miss a single one! How long have you been fishing, brul?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107139,'Barracuda in the north sea are meaty, but hard to reach. Sometimes one of the tauren shaman can help you with a water walking spell.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107140,'Mmm... black barracuda. Delicious with snails and onions.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107141,'The first trial will test your might against the strongest of my followers. Show me that you possess the strength of the bear!','',0,0,0,0,0,0,0,0,0,0,62111,0,26124),
(107142,'','The path splits. Wait, do you see that?',0,0,0,0,0,0,0,0,0,0,0,58041,26124),
(107143,'','Feathers and blood... It is still wet! There may still be time!',0,0,0,0,0,0,0,0,0,0,0,58040,26124),
(107144,'','The corruption is thick here. What is that across the bridge? Be on guard.',0,0,0,0,0,0,0,0,0,0,0,58039,26124),
(107145,'','Elothir? By Elune... not you too! Have you seen my husband?',0,0,0,0,0,0,0,0,0,0,0,58038,26124),
(107146,'Find Brytag... kill the naga...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107147,'','I will prepare the well\'s waters for the cleansing.',0,0,0,0,0,0,0,0,0,0,0,62154,26124),
(107148,'','You must protect me until the ritual is complete, or G\'Hanir will be lost!',0,0,0,0,0,0,0,0,0,0,0,62155,26124),
(107149,'That creature unworthy of great Ursol! I crush it!','',0,0,0,0,0,0,0,0,0,0,62112,0,26124),
(107150,'Too... strong! Stop! No more fight!','',0,0,0,0,0,0,0,0,0,0,62113,0,26124),
(107151,'You\'ve proven your strength. But do you possess the courage to face overwhelming odds? Tell me if you wish to test yourself!','',0,0,0,0,0,0,0,0,0,0,62114,0,26124),
(107152,'Who\'s ready for a snail fight? I, Odrogg, ultimate snail fighting champion, am accepting challengers for a limited time only!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107153,'This is unbrulievable! You are the true champion!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107154,'Before you awaits your next trial. Defeat the spirits and prove you possess the courage of the bear!','',0,0,0,0,0,0,0,0,0,0,62115,0,26124),
(107155,'Magnificent! Your courage is undeniable! A final trial awaits you.','',0,0,0,0,0,0,0,0,0,0,62116,0,26124),
(107156,'Ursoc and I fought as a team. He would strike and I would guard his side. Together, we were unstoppable.','',0,0,0,0,0,0,0,0,0,0,64047,0,26124),
(107157,'Once during the chaos of an ancient battle, my brother and I became separated. I failed to be at his side when he needed me most.','',0,0,0,0,0,0,0,0,0,0,62119,0,26124),
(107158,'For this trial, you must prove that you can protect those who entrust you with their lives. Show me that you can succeed where I once failed.','',0,0,0,0,0,0,0,0,0,0,62120,0,26124),
(107159,'','You\'ve crawled back here to try and ssstop me? You are very bold... or very ssstupid.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107160,'This one will be your charge. Guard her, or she will quickly be overwhelmed.','',0,0,0,0,0,0,0,0,0,0,62121,0,26124),
(107162,'','Somethin\' ain\'t right. Da spirits be cryin\' out.',0,0,0,0,0,0,0,0,0,0,0,62169,26124),
(107163,'The gateway is activating!','',0,0,0,0,0,0,0,0,0,0,62170,0,26124),
(107164,'Tremble before me! I bring darkness to this world.','',0,0,0,0,0,0,0,0,6,0,62171,0,26124),
(107165,'','He lives, and so I will continue deeper into the Nightmare.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107167,'A Legion ship approaches! Stand ready! If we lose the Barrens, all of Kalimdor will fall!','',0,0,0,0,0,0,22,0,0,0,75594,0,26124),
(107168,'','What isss that...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107169,'','You will sssuffer for that!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107170,'This next trial will not be easy, $c. Are you up to the challenge?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107171,'IGC - Corruption of Ysera','IGC - Corruption of Ysera',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107172,'Let\'s do this!','Let\'s do this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107173,'So that lass Emmarel Shadewarden sent you my way? Seems she\'s good as her word, that one.$b$bDon\'t know a thing \'bout this Unseen Path she\'s part of, but I\'m willin\' to hear her out.$b$bI may not be used to workin\' with you Horde folk, but the Legion\'s got it in for all of us, dwarf and $r alike.$b$bTime to put differences aside, I say!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107174,'The trees whisper his name, but their words are madness to my ears!','',0,0,0,0,0,0,0,0,0,0,58050,0,26124),
(107175,'','You must help me find him! Is there anything I can do?',0,0,0,0,0,0,5,0,0,0,0,58045,26124),
(107176,'You may not, but perhaps... your mother moon can.','',0,0,0,0,0,0,0,0,0,0,58049,0,26124),
(107177,'Yet more evidence of ethereal technology. This may be an unfortunate turn.','',0,0,0,0,0,0,1,0,0,0,61772,0,26124),
(107178,'There\'s only one way to find out who\'s really behind this.','',0,0,0,0,0,0,1,0,0,0,61773,0,26124),
(107179,'We must move quickly. Speak with Mylra and follow me into the Maelstrom.','',0,0,0,0,0,0,1,0,0,39026,60522,0,26124),
(107180,'Rehgar has a plan. Speak with him. He\'s good to have at your back in a fight.','',0,0,0,0,0,0,1,0,0,39027,72719,0,26124),
(107181,'Erunak is familiar with the darkest depths of Azeroth\'s oceans. He will know how best to proceed.','',0,0,0,0,0,0,1,0,0,39028,60523,0,26124),
(107182,'','There\'s no place you can hide from me, Millhouse! No place!',0,0,0,0,0,0,0,0,0,0,0,57978,26124),
(107183,'','I will petition Elune. The Nightmare stain cannot be removed.... but perhaps we can hold it back.',0,0,0,0,0,0,0,0,0,0,0,58044,26124),
(107184,'Long enough... to seek him out... *Elothir groans* The forest speaks... I can almost understand...','',0,0,0,0,0,0,0,0,0,0,58048,0,26124),
(107185,'','Hold yourself on the edge of madness, Elothir! Mother moon will carry you as long as she can.',0,0,0,0,0,0,0,0,0,0,0,58043,26124),
(107186,'Malfurion approaches the heart of the corruption! Quickly, Tyrande, to Shala\'nir! There is no time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107187,'','I will go to him! Elothir?',0,0,0,0,0,0,0,0,0,0,0,58042,26124),
(107188,'The madness... claims me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107189,'','Thas\'dorah began as my family\'s legacy... but now this weapon has a greater purpose.',0,0,0,0,0,0,1,0,0,0,0,61836,26124),
(107190,'<Elothir\'s form is unresponsive. The Nightmare has taken hold.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107191,'<Elothir\'s inert form stares blankly into the distance.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107192,'<Elothir appears completely unaware of his surroundings.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107193,'','<Vanessa eyes you up and down warily.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107194,'','Are you ready to settle this for good?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107195,'So be it.','So be it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107196,'Who dares to...? Ah, what have we here?','',0,0,0,0,0,0,1,0,0,0,61779,0,26124),
(107197,'Another intruder come to claim the treasures of the Nexus Vault!','',0,0,0,0,0,0,1,0,0,0,61644,0,26124),
(107198,'You are too late, $c! Even now the powers within the vault serve to widen the breach into the Twisting Nether.','',0,0,0,0,0,0,1,0,0,0,61764,0,26124),
(107199,'With this power, the Ethereum will become unstoppable. We will become void!','',0,0,0,0,0,0,15,0,0,0,61765,0,26124),
(107200,'Whatever the ethereals are up to is generating an incredible amount of void energy.','',0,0,0,0,0,0,0,0,0,0,61750,0,26124),
(107201,'They must be using Malygos\'s Surge Needles. Fly over to one and let\'s take a closer look.','',0,0,0,0,0,0,0,0,0,0,61751,0,26124),
(107202,'The Ethereum have altered the Surge Needles. They are tapping into void energy caused by the rift.','',0,0,0,0,0,0,0,0,0,0,61752,0,26124),
(107203,'Their power must also be feeding the shield around the Nexus. Let us take a look at the foundation.','',0,0,0,0,0,0,0,0,0,0,61753,0,26124),
(107204,'The vault must be weakened. The energy from your weapon is breaking its way free.','',0,0,0,0,0,0,0,0,0,0,61754,0,26124),
(107205,'This may work to our advantage...','',0,0,0,0,0,0,0,0,0,0,61755,0,26124),
(107206,'If you keep us alive, we will buy you the time you need.','',0,0,0,0,0,0,0,0,0,0,62172,0,26124),
(107207,'For G\'Hanir!','',0,0,0,0,0,0,0,0,0,0,62173,0,26124),
(107208,'','Elothir is beyond our reach now.',0,0,0,0,0,0,0,0,0,0,0,58072,26124),
(107209,'','Shala\'nir is just ahead. Be ready for whatever foulness awaits us.',0,0,0,0,0,0,0,0,0,0,0,58071,26124),
(107210,'','I am coming Malfurion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107211,'The creature shakes its head, coming to its senses!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107212,'%s has |cFFFF0404fallen in battle|h|r and cannot fight!','%s has |cFFFF0404fallen in battle|h|r and cannot fight!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107213,'Bind his arms! Do not let him cast- AGH!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107214,'','I hear a struggle by the gazebo! Malfurion?! Answer me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107215,'Hah! Claim him if you can, Night Elf!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107216,'The sky is clear, the horses are out, it is a perfect day for a hunt!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107217,'Horses! Bah! I\'ll be goin\' for the mushan. Let\'s see who brings in the finer kill.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107218,'You WILL succumb, druid!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107219,'NEVER!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107220,'Reinforcements incoming! Clear a path for their arrival!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(107221,'','I will NOT lose you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107222,'The demon\'s assault is relentless. I require aid!','',0,0,0,0,0,0,0,0,0,0,62168,0,26124),
(107223,'Ready up! We have incoming!','',0,0,0,0,0,0,22,0,0,0,75587,0,26124),
(107224,'In Mannoroth\'s name!','',0,0,0,0,0,0,0,0,0,0,62156,0,26124),
(107225,'Feast on their flesh.','',0,0,0,0,0,0,0,0,0,0,62159,0,26124),
(107226,'Now that\'s a trophy to be proud of!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107227,'In our lands we hunt for food. I do not envy you eating that much mushan meat.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107228,'Lambs to the slaughter.','',0,0,0,0,0,0,0,0,0,0,62161,0,26124),
(107229,'Your life slips away.','',0,0,0,0,0,0,0,0,0,0,62157,0,26124),
(107230,'All shall burn!','',0,0,0,0,0,0,0,0,0,0,62162,0,26124),
(107231,'Tremble!','',0,0,0,0,0,0,0,0,0,0,62158,0,26124),
(107232,'%s begins to cast |cFFFF0404|Hspell:204839|h[Demonwrath]|h|r!','%s begins to cast |cFFFF0404|Hspell:204839|h[Demonwrath]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(107233,'%s begins to cast |cFFFF0404|Hspell:204839|h[Chaos Bolt Barrage]|h|r!','%s begins to cast |cFFFF0404|Hspell:204839|h[Chaos Bolt Barrage]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(107234,'To arms!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107235,'Hahahaha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107236,'','No!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107237,'','That elderhorn calf is in danger! You have to help it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107238,'Ain\'t no way dem demons gonna be takin\' de Crossroads.','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(107239,'','My blade is ready!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107240,'','My blade could use a little practice.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107241,'I\'ve got eyes from the tower! Spread out!','I\'ve got eyes from the tower! Spread out!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107242,'','That was close! I will raise the calf here at Thunder Totem until it can fend for itself.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107243,'<Punch the Satyr.>','<Punch the Satyr.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107244,'Somebody gonna be needin\' our help.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107245,'','Zumolo, come with me! They\'ll need us at the north gate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107247,'Ha! That\'ll teach that antler headed eagle rider a thing \'er two about huntin\'.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107248,'The time has come, Chintoka. Let us prepare for battle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107249,'Very good. Those stallions will feed many of our eagles. I knew you would see things my way.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107250,'','Taste my axe!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107251,'','By blades of steel your kind will fall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107252,'','These are our lands!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107253,'The contents of the nearby books are in tatters. It appears as if a cyclone moved through the inn quite recently.','The contents of the nearby books are in tatters. It appears as if a cyclone moved through the inn quite recently.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107254,'You are no match for the Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107255,'My magic will consume you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107256,'Your corruption ends here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107257,'Foul wretch!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107258,'Shadows consume you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107259,'','You will not ruin our lands!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107260,'','Your powers are no match for the elements!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107261,'More target practice.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107262,'','I can feel the well growing in strength. We must push forward!',0,0,0,0,0,0,0,0,0,0,0,62163,26124),
(107263,'','The power grows with every moment. This day will be ours!',0,0,0,0,0,0,0,0,0,0,0,62164,26124),
(107264,'The shadow... is lifted?','',0,0,0,0,0,0,0,0,0,0,61775,0,26124),
(107265,'What little mind is this I sense, that has freed my consciousness from the ethereals\' trap?','',0,0,0,0,0,0,0,0,0,0,61776,0,26124),
(107267,'','We have done it! The Mother Tree is whole once more!',0,0,0,0,0,0,0,0,0,0,0,62166,26124),
(107268,'','$n, use G\'Hanir to call upon the spirits of the forest to destroy this fiend!',0,0,0,0,0,0,0,0,0,0,0,62167,26124),
(107269,'','The ritual is nearly complete. Do not give up hope!',0,0,0,0,0,0,0,0,0,0,0,62165,26124),
(107270,'','Ysera - no!',0,0,0,0,0,0,0,0,0,0,0,58087,26124),
(107271,'','Come with me. Ysera won\'t stop until this whole realm is plunged into the Nightmare.',0,0,0,0,0,0,0,0,0,0,0,58086,26124),
(107272,'','Xavius is using Malfurion to bait me, to distract me from what must be done. We are the only ones who can stop Ysera.',0,0,0,0,0,0,0,0,0,0,0,58085,26124),
(107273,'','Ah, Malfurion, my beloved! For a hundred hundred years he slept beneath Moonglade.',0,0,0,0,0,0,0,0,0,0,0,58084,26124),
(107274,'Our reinforcements approach. Prepare yourselves!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(107275,'','Harpies from the Haglands are unleashing their perverse magic upon wildlife in the Screeching Crag. We don\'t know how to counter their curses. Please, stop this madness!',0,0,0,0,0,0,0,0,0,0,0,58222,26124),
(107276,'','Long ago the harpies of these mountains lost any respect they had for life. Now they practice their dark rituals no matter who it hurts.',0,0,0,0,0,0,0,0,0,0,0,58223,26124),
(107277,'Chen said you would come, $n. There\'s no time to waste. Help us fight back these demons and reclaim the monastery!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107278,'','Deprecated.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107279,'','This world will never fall, demon! Nature itself will rise against you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107280,'Pitiful worms. What trickery is this?','',0,0,0,0,0,0,0,0,0,0,62174,0,26124),
(107281,'Find the invaders! Retake the cathedral! Slaughter them all!','',0,0,0,0,0,0,0,0,0,0,61801,0,26124),
(107282,'','I know Alleria\'s bow is in the right hands.',0,0,0,0,0,0,0,0,0,0,0,61821,26124),
(107289,'Ah yes, now I remember.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107290,'Nice find!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107291,'Lessah is a good teacher, but you are even better!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107292,'Very interesting...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107293,'Aha! There it is!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107294,'Ooh, what is that ?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107295,'I think I am starting to get it now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107296,'Well done. Let us see what we found.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107297,'So many places, so little time. If you have somewhere special to go, I can take you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107298,'Can you take me to Tian Monastery?','Can you take me to Tian Monastery?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107299,'Wait until you have 5 combo points to use Eviscerate!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107300,'You have 5 Combo Points. Use Eviscerate!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107301,'Ranger-General Windrunner! Did you find...','',0,0,0,0,0,0,6,0,0,0,61789,0,26124),
(107302,'Use Backstab to generate combo points.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107303,'','Alleria was gone, but we recovered Thas\'dorah! It is now in the hands of our champion.',0,0,0,0,0,0,1,0,0,0,0,61790,26124),
(107304,'Amazing! The bow will inspire every ranger who sees it!','',0,0,0,0,0,0,603,0,0,0,61791,0,26124),
(107305,'','Sadly, Orestes was lost. I should send word to Halduron. Come, Larkspur.',0,0,0,0,0,0,1,0,0,0,0,61792,26124),
(107306,'At once!','',0,0,0,0,0,0,66,0,0,0,61793,0,26124),
(107307,'I WILL DESTROY YOU!','',0,0,0,0,0,0,0,0,0,0,62181,0,26124),
(107308,'YOUR WORLD WILL... BURN...','',0,0,0,0,0,0,0,0,0,0,62177,0,26124),
(107309,'','It is done! Let us all return to the Dreamgrove and tell the others of our triumph.',0,0,0,0,0,0,0,0,0,0,0,62178,26124),
(107310,'We must stay behind for a time to aid Skylord Omnuron\'s forces.','',0,0,0,0,0,0,0,0,0,0,62179,0,26124),
(107311,'Thank you, $n. Without you, we would have surely fallen.','',0,0,0,0,0,0,0,0,0,0,62180,0,26124),
(107312,'','Let these wingless creatures feast upon themselves.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107313,'','Hurry my sisters, before the wretched tribes discover our plan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107314,'','Move quickly, sisters. We must finish the spell so that no outsider or tauren can break it\'s hold!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107315,'','These wingless creatures shall be ours to command.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107316,'','The fools of Rivermane will never expect the wilds to turn on them so violently.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107317,'','No, sister. Set the hex correctly. As the Witchqueen commanded.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107318,'The brood of Nithogg kill my kind and yours without mercy or remorse. Meet their cruelty in kind! Rend the scales from their hide!','',0,0,0,0,0,0,0,0,0,0,69754,0,26124),
(107319,'Now yer talkin! Biggest skull wins the wager.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107320,'Nithogg and his brood are killers and murderers of the worst sort. You have done the world a service by disposing of them.','',0,0,0,0,0,0,0,0,0,0,69755,0,26124),
(107321,'Must chap yer hide that ya got upstaged so easily. Ha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107322,'','Great Ursol, wise bear of the woods, this daughter of the wilds calls to you! Please accept these humble offerings and grant us an audience!',0,0,0,0,0,0,0,0,0,0,0,62110,26124),
(107323,'The demons have fallen to our blades! They were no match for the champions of Azeroth!','',0,0,0,0,0,0,22,0,0,0,75589,0,26124),
(107324,'','Were it not for $p\'s actions, we would have all perished atop Mount Hyjal.',0,0,0,0,0,0,1,0,0,0,0,62219,26124),
(107325,'','Both G\'Hanir and Nordrassil would have been destroyed by the Legion.',0,0,0,0,0,0,1,0,0,0,0,62220,26124),
(107326,'','For centuries I have watched over G\'Hanir. Today it nearly fell to the corruption I swore to fight. It is time for another to take my place.',0,0,0,0,0,0,0,0,0,0,0,62216,26124),
(107327,'','Therefore, I hereby pass along my station to $p. A true protector of life... a true guardian of the Dream!',0,0,0,0,0,0,0,0,0,0,0,62217,26124),
(107328,'','Thank you again, shan\'do. I will remain here in the Dreamgrove if you ever have need of my guidance.',0,0,0,0,0,0,0,0,0,0,0,62218,26124),
(107330,'They aren\'t letting up! Stand firm!','',0,0,0,0,0,0,22,0,0,0,75574,0,26124),
(107331,'','Entire armies have fallen by my sword. What chance could you possibly have against me?',0,0,0,0,0,0,0,0,0,0,0,58392,26124),
(107332,'','Well done! I trained those guards myself... they are not easily bested. I suppose you merit the honor of facing me. Strike at your leisure. As a courtesy, I grant you the first blow.',0,0,0,0,0,0,0,0,0,0,0,58393,26124),
(107333,'','I let you strike first and that\'s the best you can do?',0,0,0,0,0,0,0,0,0,0,0,58394,26124),
(107334,'','A gallant attempt... but a vain one.',0,0,0,0,0,0,0,0,0,0,0,58395,26124),
(107335,'','Unworthy. A waste of my time!',0,0,0,0,0,0,0,0,0,0,0,58396,26124),
(107336,'','Where\'s the fun in so easy a kill?',0,0,0,0,0,0,0,0,0,0,0,58397,26124),
(107337,'','Replicate!',0,0,0,0,0,0,0,0,0,0,0,58398,26124),
(107338,'','Detonate!',0,0,0,0,0,0,0,0,0,0,0,58399,26124),
(107339,'','Animate!',0,0,0,0,0,0,0,0,0,0,0,58400,26124),
(107340,'','Annihilate!',0,0,0,0,0,0,0,0,0,0,0,58401,26124),
(107341,'','You should have thought better of challenging me!',0,0,0,0,0,0,0,0,0,0,0,58402,26124),
(107342,'','Such a shame. I had hoped for a proper challenge.',0,0,0,0,0,0,0,0,0,0,0,58403,26124),
(107343,'','I wonder if I\'ll ever face a worthy foe...',0,0,0,0,0,0,0,0,0,0,0,58404,26124),
(107344,'','Inconceivable! I... am... the... best...',0,0,0,0,0,0,0,0,0,0,0,58405,26124),
(107345,'','Mistress, I... have... failed...',0,0,0,0,0,0,0,0,0,0,0,58406,26124),
(107346,'There is a noise from behind you!','There is a noise from behind you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(107347,'The naga are tormenting that sea giant. How should we proceed?','',0,0,0,0,0,0,1,0,0,0,60675,0,26124),
(107348,'The volatile energies within the Nexus seem to be interfering with the image crystal.','',0,0,0,0,0,0,0,0,0,0,61777,0,26124),
(107349,'I fear you may be on your own from here. Good luck!','',0,0,0,0,0,0,0,0,0,0,61778,0,26124),
(107350,'So the lock on the Nexus has been broken, and by a common $r, no less. Will wonders never cease?','',0,0,0,0,0,0,0,0,0,0,61650,0,26124),
(107351,'If you\'ve come to engage me in battle in hopes of obtaining some spurious trinket, I\'m afraid you\'re too late.','',0,0,0,0,0,0,0,0,0,0,61651,0,26124),
(107352,'The Ethereum have taken the bite out of this old dragon, and I fear they have robbed me of anything you would deem useful.','',0,0,0,0,0,0,0,0,0,0,61652,0,26124),
(107353,'If it\'s looting you desire, as your kind so often does, then I suggest taking the fight to them.','',0,0,0,0,0,0,0,0,0,0,61653,0,26124),
(107354,'Well this is... unexpected.','',0,0,0,0,0,0,0,0,0,0,61655,0,26124),
(107355,'The void magic wielded by these ethereals has weakened me considerably. I am of no use to you in this state.','',0,0,0,0,0,0,0,0,0,0,61657,0,26124),
(107356,'I can see you are a follower of the Light. Restore my strength and I will fight by your side.','',0,0,0,0,0,0,0,0,0,0,61658,0,26124),
(107357,'We must make haste. I fear the Ethereum will be upon us any moment!','',0,0,0,0,0,0,0,0,0,0,61659,0,26124),
(107358,'You are a capable healer, priest. I feel my strength returning.','',0,0,0,0,0,0,1,0,0,0,61645,0,26124),
(107359,'I assume you come seeking the Nexus Vault. Why else would anyone return to this place?','',0,0,0,0,0,0,1,0,0,0,61646,0,26124),
(107360,'Unfortunately, access to the vault is proving... difficult. If you help me access the Librarium, I will find a way through. We must not let the Ethereum obtain the artifacts it holds!','',0,0,0,0,0,0,1,0,0,0,61647,0,26124),
(107361,'But first, I think I\'ll slip into a more comfortable form. These halls were never quite spacious enough for my tastes.','',0,0,0,0,0,0,1,0,0,0,61648,0,26124),
(107362,'Shall we?','',0,0,0,0,0,0,0,0,0,0,61649,0,26124),
(107363,'The Nexus Vault is weakening! That holy fire can only mean Light\'s Wrath is no longer fully contained.','',0,0,0,0,0,0,0,0,0,0,61641,0,26124),
(107364,'It is a most potent and chaotic weapon. It will lash out at us as we try to approach. Be prepared.','',0,0,0,0,0,0,0,0,0,0,61642,0,26124),
(107365,'The fire seems to have superheated the ground here. I hope you have a way to get us over it...','',0,0,0,0,0,0,0,0,0,0,61643,0,26124),
(107366,'We\'re here. Now, let me see if I can find a way into the vault...','',0,0,0,0,0,0,0,0,0,0,61665,0,26124),
(107367,'As I suspected! The entrance to the vault was broken off when Malygos breached the Twisting Nether during the Nexus Wars.','',0,0,0,0,0,0,0,0,0,0,61666,0,26124),
(107368,'I feel the powers it holds resonating through the Nexus. There must be another way to reach the vault!','',0,0,0,0,0,0,1,0,0,0,61667,0,26124),
(107369,'A-ha! That\'s... wait a moment... the energy from the vault is surging. Brace yourself!','',0,0,0,0,0,0,5,0,0,0,61668,0,26124),
(107370,'That was too close! If the weapon goes unchecked much longer, it will bring this whole place down around us!','',0,0,0,0,0,0,0,0,0,0,61669,0,26124),
(107371,'Quickly! We must head to the rift. It\'s the only way!','',0,0,0,0,0,0,0,0,0,0,61670,0,26124),
(107372,'Wait... didn\'t there used to be a bridge here?','',0,0,0,0,0,0,6,0,0,0,61624,0,26124),
(107373,'Fools! You may have destroyed the Surge Needles, but you are too late to stop us! The power of Light\'s Wrath will rip open the breach!','',0,0,0,0,0,0,0,0,0,0,61625,0,26124),
(107374,'Oh great, more ethereals...','',0,0,0,0,0,0,1,0,0,0,61626,0,26124),
(107375,'It looks like they\'re channeling the energy from the vault into the breach. This is not good.','',0,0,0,0,0,0,5,0,0,0,61627,0,26124),
(107376,'Come! Time to show these ethereals that I still have a bit of fight left in me!','',0,0,0,0,0,0,25,0,0,0,61628,0,26124),
(107377,'You are too late, interlopers. Nothing can stop me now!','',0,0,0,0,0,0,0,0,0,0,61631,0,26124),
(107378,'The Ethereum will rise again!','',0,0,0,0,0,0,0,0,0,0,61633,0,26124),
(107379,'What!? The void cannot be defeated! Noooo!','',0,0,0,0,0,0,0,0,0,0,61634,0,26124),
(107380,'Hah! So much for the all-powerful void. You know, you\'re not a bad ally. Pity you\'re not a dragon!','',0,0,0,0,0,0,0,0,0,0,61635,0,26124),
(107381,'I can open a portal to the vault, but I\'ll have to remain on this side to keep it open.','',0,0,0,0,0,0,0,0,0,0,61636,0,26124),
(107382,'The way is clear. Hurry, little $r! I can\'t keep this open for long!','',0,0,0,0,0,0,0,0,0,0,61637,0,26124),
(107383,'I hate to admit it, but I find myself in need of an ally. I suppose you\'ll do.','',0,0,0,0,0,0,0,0,0,0,61656,0,26124),
(107384,'I\'m ready to get the power source.','I\'m ready to get the power source.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107385,'Graahh?','',0,0,0,0,0,0,1,0,0,0,60676,0,26124),
(107386,'Insert awesome healing/DPS wave event!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107387,'Fear not, my enormous friend. The Earthen Ring is here.','',0,0,0,0,0,0,1,0,0,0,60677,0,26124),
(107388,'I have just the thing. Follow me.','',0,0,0,0,0,0,1,0,0,0,64653,0,26124),
(107389,'Hold on just a moment. I fear I\'m a bit of a pack rat.','',0,0,0,0,0,0,1,0,0,0,64654,0,26124),
(107390,'Now let\'s see... apexis crystals? No, no, those won\'t do at all.','',0,0,0,0,0,0,0,0,0,0,64655,0,26124),
(107391,'Hmm, I must\'ve put it over here.','',0,0,0,0,0,0,25,0,0,0,64656,0,26124),
(107392,'Arcane powder... soul shards... that\'s definitely not it...','',0,0,0,0,0,0,0,0,0,0,64657,0,26124),
(107393,'A-ha! Here we are... a crystallized soul. That ought to do the trick!','',0,0,0,0,0,0,0,0,0,0,64658,0,26124),
(107395,'Your hulls shatter, your bones are next!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107396,'Olokk... all washed up.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107397,'Fan out! Purge this demonic infestation!','',0,0,0,0,0,0,22,0,0,0,75600,0,26124),
(107398,'Would you mind grabbing it? These crystals tend to have an adverse effect on non-demonic beings.','',0,0,0,0,0,0,6,0,0,0,64659,0,26124),
(107399,'','Screeekk! Nothing sacred, nothing clean!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107400,'','Screeeek...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107401,'You are thousands of years behind us! How could you hope to win?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107402,'','Mighty Ursol, our ancient foe has returned! My companion has traveled here to seek your aid in recovering the Claws of Ursoc.',0,0,0,0,0,0,0,0,0,0,0,62107,26124),
(107403,'Im... Impossible!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107404,'','How... my mana abandons me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107405,'','My mana will bring you to your knees!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107406,'','How arrogant, to tread so close to Suramar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107407,'','You... will fall... to the Magistrix...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107408,'My mind is free! The magic of death empowers me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107409,'$n! Councilors, this is the demon hunter I spoke of.','',0,0,0,0,0,0,3,0,0,0,64660,0,26124),
(107410,'Be careful, $n. You\'re tapping into magic even Illidan would have considered dangerous.','',0,0,0,0,0,0,1,0,0,0,64667,0,26124),
(107411,'Wait, are you here after them? In that case, I could use a hand...','',0,0,0,0,0,0,0,0,0,0,61654,0,26124),
(107412,'Allari, report in. Have you located the Warblades?','',0,0,0,0,0,0,6,0,0,0,64662,0,26124),
(107413,'','Yes... <garbled> Caria... <garbled> Broken Shore... <garbled> heavy resistance...',0,0,0,0,0,0,0,0,0,0,0,64663,26124),
(107414,'','Damn it all! INCOMING!',0,0,0,0,0,0,440,0,0,0,0,64664,26124),
(107415,'What\'s going on down there? Allari!','',0,0,0,0,0,0,6,0,0,0,64665,0,26124),
(107416,'We have their position. That will have to do.','',0,0,0,0,0,0,1,0,0,0,64666,0,26124),
(107417,'$n, I have an idea.','',0,0,0,0,0,0,1,0,0,37647,64661,0,26124),
(107418,'$n, I have an idea.','',0,0,0,0,0,0,1,0,0,36911,71003,0,26124),
(107419,'Free. Free! FREE! Free of that accursed prison.','',0,0,0,0,0,0,0,0,12,0,0,0,26124),
(107420,'Blood and Honor!','Blood and Honor!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(107421,'Ready your blades! War is coming.','Ready your blades! War is coming.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(107422,'Another wave of reinforcements coming in! Hold your positions!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(107423,'This must be it, over here!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(107424,'Power... deserts me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107427,'We die in Illidan\'s name... as will Caria.','',0,0,0,0,0,0,66,0,0,36911,58203,0,26124),
(107428,'','Such pitiful creatures. Is that the last of them?',0,0,0,0,0,0,0,0,6,0,0,66660,26124),
(107429,'Yes, mistress. The Tideskorn will keep them captive until you are ready to harvest their souls.','',0,0,0,0,0,0,2,0,6,0,66661,0,26124),
(107430,'','Good. Now tear this monastery to shreds!',0,0,0,0,0,0,0,0,6,0,0,66662,26124),
(107431,'Suffer well. Show Caria no mercy!','',0,0,0,0,0,0,66,0,0,36910,64669,0,26124),
(107432,'','The %s dies, passing into the Maw of Souls...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107433,'','Are you prepared to venture to the epicenter of this chaos, $r?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107434,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107435,'','This place is corrupted beyond anything I have ever seen... Malfurion, please hold on.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107436,'','The %s returns to the Halls of Valor...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107437,'Focus your attacks! Bring them down!','',0,0,0,0,0,0,22,0,0,0,75578,0,26124),
(107438,'old','old',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107439,'','Harbaron begins to drain the soul of the %s.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107440,'I will bring whatever power I have to bear against the Nexus-Prince, $c. But in my weakened state, it falls upon you to finish this threat.','',0,0,0,0,0,0,25,0,0,0,61629,0,26124),
(107441,'I hope you are prepared!','',0,0,0,0,0,0,25,0,0,0,61630,0,26124),
(107442,'$n wanes from existence.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107443,'I will not rest until the council has been rebuilt.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(107444,'','I am here to repay my debt, and nothing more.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(107445,'','My tolerance for Ritssyn is low, but I\'ll do my best to remain focused despite having to be in his presence.\n\nShould I begin summoning the gateway?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(107446,'Grblgrbl waugurblurg.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107447,'We mean you no harm, giant.','',0,0,0,0,0,0,1,0,0,0,60678,0,26124),
(107448,'They control us. They kill.','',0,0,0,0,0,0,1,0,0,0,60679,0,26124),
(107449,'Shaman, speak with him. Perhaps we can gain a new ally down here.','',0,0,0,0,0,0,1,0,0,0,60680,0,26124),
(107450,'Blerk.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107451,'I have become void!','',0,0,0,0,0,0,53,0,0,0,61632,0,26124),
(107452,'Of course we will help you!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107453,'Your order is broken, monks! You can do nothing against us.','',0,0,0,0,0,0,0,0,4,0,66663,0,26124),
(107454,'Our WILL is not broken. We will fight to our last breath, demon-lover.','',0,0,0,0,0,0,0,0,4,0,66664,0,26124),
(107455,'The Legion lives forever...','',0,0,0,0,0,0,0,0,4,0,66665,0,26124),
(107456,'You will die by my blade, $c!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(107457,'I\'ll tear you apart, $c!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107458,'I will rain fire and fury upon you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107459,'We will turn your monastery to ash.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107460,'This is the end of your people.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107461,'Wheee.... fire!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(107462,'I\'ll torch you up good!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107463,'Watch it burn, watch it burn!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107464,'Glorious fire, so beautiful!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107465,'More fire. More, more, MORE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107466,'','Hurry, $n. Those fel spreaders are doing incredible damage.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(107467,'We\'ll hold them back here. Strike at the demons now, or it will be too late!','',0,0,0,0,0,0,0,0,4,0,66700,0,26124),
(107468,'Hurry up now, I\'m right behind! The King\'s got your back if you get in a bind!','',0,0,0,0,0,0,0,0,4,0,66666,0,26124),
(107469,'','I shall prepare a holding area for the subjects while you are away.',0,0,0,0,0,0,396,0,0,0,0,67262,26124),
(107470,'Well done, my friend! He has seen our missing shaman AND the artifact we seek. Now we must find a way through this ice barrier...','',0,0,0,0,0,0,1,0,0,0,60689,0,26124),
(107471,'...Well that will do.','',0,0,0,0,0,0,1,0,0,0,60690,0,26124),
(107472,'Master, you have witnessed with your own eyes the Legion\'s capability for destruction.','',0,0,0,0,0,0,1,0,4,0,66667,0,26124),
(107474,'The monastery is saved, but our work is far from over.','',0,0,0,0,0,0,1,0,0,0,66668,0,26124),
(107475,'Please take me to the Temple of Five Dawns.','Please take me to the Temple of Five Dawns.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107476,'Yes.','Yes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107477,'The nightmare has already tainted these creatures, now how about we taint yours?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107478,'I\'m your worst nightmare.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107479,'Pitiful.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107481,'Stomp on the satyr\'s tail.','Stomp on the satyr\'s tail.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107482,'Break the satyr\'s wrist.','Break the satyr\'s wrist.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107483,'Involve Tyrande.','Involve Tyrande.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107484,'Impossible!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107485,'The seed has been sown.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107486,'Yes, let the anger swell inside you!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107487,'I can feel the corruption spreading!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107488,'That one wouldn\'t have lasted long anyway.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107490,'You will pay for your insolence.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107491,'I\'m in a bad dream.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107499,'','Hold the line! Don\'t let them take the monastery!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107500,'','Master Taran Zhu is waiting for you down the hill.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107501,'All in good time, hero. Your body is not quite ripe yet. I will come for you again, but first my soul requires a more appropriate vessel.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107502,'You are strong. Perhaps I shall claim you as my next vessel.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107503,'Grandmaster! Greetings to you, and good tidings! I hope you\'re ready with some Crackling Jade Lightning!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107504,'Your power has grown, Kira.','',0,0,0,0,0,0,1,0,0,0,66525,0,26124),
(107505,'','It has, indeed. And you should keep that in mind the next time you attempt to speak to me...',0,0,0,0,0,0,1,0,0,0,0,66515,26124),
(107506,'Even Deathwing could foresee the evil that the Darkness could unleash if left unchecked.$b$bThis is a grim day for us all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107507,'Send me to Thunder Totem.','Send me to Thunder Totem.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107508,'The final trial will not be easy, druid. Speak with me when you are ready.','',0,0,0,0,0,0,0,0,0,0,62123,0,26124),
(107509,'Tyrande Whisperwind! I have longed for this encounter for many years.','',0,0,0,0,0,0,0,0,6,0,58173,0,26124),
(107510,'','I\'ll take you with me!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(107511,'','A dose of plague might teach you manners aboard my ship!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107512,'Your adoring husband will be joining me in the nightmare. His was a special invitation.','',0,0,0,0,0,0,0,0,6,0,58174,0,26124),
(107513,'','I\'ve seen what this hero can do. I will gladly help!',0,0,0,0,0,0,0,0,0,0,0,62118,26124),
(107514,'Tell me, is there anyone willing to fight at your side, $c?','',0,0,0,0,0,0,0,0,0,0,62117,0,26124),
(107516,'Very good, $n! The spirit of the bear truly dwells within you!','',0,0,0,0,0,0,0,0,0,0,62124,0,26124),
(107517,'This way. The rest of the survivors are up here.','',0,0,0,0,0,0,0,0,4,0,66731,0,26124),
(107518,'','The door seal is about to collapse! All is lost if the Legion breaks through the door!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(107519,'Their leader, Lady Keletress, must be stopped.','',0,0,0,0,0,0,0,0,0,0,66703,0,26124),
(107520,'Our friends be missin\'! We can\'t quit! But these ookers be scary, I gotta admit!','',0,0,0,0,0,0,0,0,0,0,66658,0,26124),
(107521,'I will return with you to the Wandering Isle. From there, we will devise a plan.','',0,0,0,0,0,0,2,0,0,0,66699,0,26124),
(107522,'','Spiritwalker! What happened here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107523,'The Darkness. It  came and... I am sorry my Chieftain. But the Darkness has taken your father\'s body to the summit.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107524,'I\'ve got you now!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107525,'Thistleleaf Bully pinches Trapped Lunarwing','',0,0,0,0,0,0,390,0,0,0,0,0,26124),
(107526,'You\'re not going anywhere!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107527,'','Not while I still draw breath.',0,0,0,0,0,0,0,0,0,0,0,72401,26124),
(107528,'','Koda, keep her distracted. Lyanis, mend our wounds. Champion - with me!',0,0,0,0,0,0,0,0,0,0,0,72402,26124),
(107529,'','Are you truly lost, Ysera? After all we have built? All we have done?',0,0,0,0,0,0,0,0,0,0,0,72399,26124),
(107530,'','By the light of Elune, we will end this madness!',0,0,0,0,0,0,0,0,0,0,0,72398,26124),
(107531,'','I will end your torment, Dreamer. And I promise we will avenge you.',0,0,0,0,0,0,0,0,0,0,0,72400,26124),
(107532,'','Shhhh, shhh... It is over now, Ysera.',0,0,0,0,0,0,0,0,0,0,0,72403,26124),
(107533,'','Sleep now, dear Ysera. Sleep forever, and dream no more.',0,0,0,0,0,0,0,0,0,0,0,72404,26124),
(107534,'','This is your end, mortals. The Dream is undone!',0,0,0,0,0,0,0,0,0,0,0,78725,26124),
(107535,'','My eyes are open at last, priestess. I see night eternal.',0,0,0,0,0,0,0,0,0,0,0,78726,26124),
(107536,'','The Nightmare consumes all!',0,0,0,0,0,0,0,0,0,0,0,78727,26124),
(107537,'','The Lord of the Nightmare, he -',0,0,0,0,0,0,0,0,0,0,0,78728,26124),
(107538,'','...blackness...',0,0,0,0,0,0,0,0,0,0,0,78729,26124),
(107539,'As with most rituals, it will require three warlocks to complete. \n\nAre you ready to begin?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(107540,'','Come, Champion. Let us show these invaders the meaning of strength.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107548,'','I cannot tell where his voice is coming from! Quickly, search the buildings to the west. I will scour the east for signs of him!',0,0,0,0,0,0,0,0,0,0,0,58069,26124),
(107549,'','Where are you Malfurion? Answer me!',0,0,0,0,0,0,0,0,0,0,0,58068,26124),
(107550,'','Champion, to me! I have found something!',0,0,0,0,0,0,0,0,0,0,0,58067,26124),
(107551,'I will be at your service when you call, Grandmaster.','',0,0,0,0,0,0,2,0,0,0,66735,0,26124),
(107552,'','These hoofprints follow the path to the left. Come, quickly!',0,0,0,0,0,0,0,0,0,0,0,58066,26124),
(107553,'','Malfurion?! Call out to me!',0,0,0,0,0,0,0,0,0,0,0,58065,26124),
(107554,'','Not without you!',0,0,0,0,0,0,0,0,0,0,0,58064,26124),
(107555,'The master chose well, all will see! The Monkey King is tough as can be!','',0,0,0,0,0,0,4,0,0,0,66659,0,26124),
(107556,'','By Elune, your foulness will be purged from this place!',0,0,0,0,0,0,0,0,0,0,0,58063,26124),
(107557,'','You take care of that foul mouthed satyr. I am going to my husband!',0,0,0,0,0,0,0,0,0,0,0,58062,26124),
(107558,'You cannot hold me!','',0,0,0,0,0,0,0,0,0,0,58077,0,26124),
(107559,'Turn back, Tyrande!','',0,0,0,0,0,0,0,0,0,0,58076,0,26124),
(107560,'','I\'ll help, of course. Unlike you, I do not abandon a fellow warlock when they might need me most.',0,0,0,0,0,0,1,0,0,0,0,66516,26124),
(107561,'You have a lot of nerve approaching me, outlander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107562,'Are you Silgryn?','Are you Silgryn?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107563,'Thalyssra sent me.','Thalyssra sent me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107564,'Will you assist us Kira?','',0,0,0,0,0,0,1,0,0,0,66524,0,26124),
(107567,'You made it! But to leave this place with the weapon, you must first gain control of it.','',0,0,0,0,0,0,0,0,0,0,61638,0,26124),
(107568,'Good luck, $c.','',0,0,0,0,0,0,0,0,0,0,61639,0,26124),
(107569,'Either my legend has spread beyond the city, or we have a mutual acquaintance...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107570,'I am impressed, $n! Never have I seen a priest capable of controlling Light\'s Wrath.','',0,0,0,0,0,0,1,0,0,0,61660,0,26124),
(107571,'The ethereals have been routed and you have the weapon you came for. Your business here is finished. Mine, on the other hand, has just begun.','',0,0,0,0,0,0,1,0,0,0,61661,0,26124),
(107572,'Bit of a bumpy ride, eh? Flyin\' through these clouds ain\'t easy, even on as fine a gryphon as Huey.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107573,'I thank you for freeing me. You have given me the greatest gift of all... that of time.','',0,0,0,0,0,0,1,0,0,0,61662,0,26124),
(107574,'I will use that time to secure the Nexus. It must never again fall into the wrong hands!','',0,0,0,0,0,0,1,0,0,0,61663,0,26124),
(107575,'I\'m ready to get underway.','I\'m ready to get underway.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107576,'This portal will take you back to Kalecgos. Please give him my regards.','',0,0,0,0,0,0,0,0,0,0,61664,0,26124),
(107577,'First I should introduce you to Prustaga.','',273,0,0,0,0,0,0,0,0,0,0,0,26124),
(107578,'Seems Prust wants the Legion out of here as much as we do. Worked night and day to find this tomb!','',0,0,0,0,0,0,1,0,0,0,62567,0,26124),
(107579,'Uh... word of warning. I wouldn\'t exactly say she\'s the cuddliest sort.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(107580,'Prustaga! Brought a friend to join us, as promised.','',0,0,0,0,0,0,603,0,0,0,62568,0,26124),
(107581,'','I care nothing for friendship, soft-earthen. So long as this one helps us enter the tomb, I will tolerate the intrusion.',0,0,0,0,0,0,1,0,0,0,0,62569,26124),
(107582,'Hmm... looks like some fools plundered the tomb and stirred up all sorts o\' spirits.','',0,0,0,0,0,0,1,0,0,0,62570,0,26124),
(107583,'Good luck out there. I\'ll be watchin for yer signal.','',0,0,0,0,0,0,66,0,0,0,63671,0,26124),
(107584,'','Your job is simple! Dispatch the spirits while I shatter the wards sealing the tomb.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107585,'Say, you hear somethin\'?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(107586,'Defiler... no... not yours...','',0,0,0,0,0,0,0,0,0,0,62571,0,26124),
(107587,'Never understood why ghosts get so uppity \'bout their loot...','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(107588,'Thief! Coveter! It belongs to me!','',0,0,0,0,0,0,0,0,0,0,62572,0,26124),
(107589,'Pipe down! We\'re after yer gun for a good cause, ghostie!','',0,0,0,0,0,0,22,0,0,0,62573,0,26124),
(107590,'Look out!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107591,'','These creatures are merely a distraction! Get to the tomb!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107592,'Front door\'s already open. That\'s handy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107593,'Rawk! Sneak past! Sneak past!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107594,'Daglir is sure to be ruined now. I have already begun to hear rumors that he is a traitor in league with the Nightfallen.','Daglir is sure to be ruined now. I have already begun to hear rumors that he is a traitor in league with the Nightfallen.',0,0,0,0,0,0,0,0,0,0,65659,0,26124),
(107595,'Rawk! Landmines!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107596,'He and his \"allies\" were concocting a plot to poison Elisande! That will teach him to mess with a Moongrow!','He and his \"allies\" were concocting a plot to poison Elisande! That will teach him to mess with a Moongrow!',11,0,0,0,0,0,0,0,0,0,65645,0,26124),
(107597,'You\'ve failed, just as I did. Yet we can learn from this and change your destiny. Speak with me again.','',0,0,0,0,0,0,0,0,0,0,62122,0,26124),
(107598,'Well done! The energies from the vault seem to be stabilizing. Now hurry back before the portal closes and you\'re locked inside!','',0,0,0,0,0,0,0,0,0,0,61640,0,26124),
(107599,'The giant has seen Sharas\'dal, the Scepter of Tides! We are close. Keep him alive and he will protect us.','',0,0,0,0,0,0,6,0,0,0,60691,0,26124),
(107600,'Stay back! These creatures are being controlled by another.','',0,0,0,0,0,0,6,0,0,0,60687,0,26124),
(107601,'What are Azshara\'s minions doing to this place?','',0,0,0,0,0,0,6,0,0,0,60688,0,26124),
(107602,'YOUR CALL FOR DEATH SHALL BE GRANTED!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107603,'Tyrande, no! It\'s a trap!','',0,0,0,0,0,0,0,0,0,0,58075,0,26124),
(107604,'','I will NOT lose you!',0,0,0,0,0,0,0,0,0,0,0,58061,26124),
(107605,'Thalyssra lives? Come, let us talk in private.','',0,0,0,0,0,0,0,0,0,0,67474,0,26124),
(107606,'And our dear Ysera! Would you believe she has had a change of heart?','',0,0,0,0,0,0,0,0,6,0,58175,0,26124),
(107607,'','Enough chatter. Move!',0,0,0,0,0,0,1,0,0,0,0,62574,26124),
(107608,'','The moonwell water is essential. Don\'t leave the Dreamgrove without it! I\'ll await your arrival in Grizzly Hills.',0,0,0,0,0,0,0,0,0,0,0,62272,26124),
(107609,'What are you doing here in the Broken Isles, Brann?','What are you doing here in the Broken Isles, Brann?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107610,'Same thing I\'m always doin\' - learnin\' anything I can learn about the Titans! Where we came from. Why we\'re here. This land has answers, I can feel it.\n\nThere ain\'t any city-size, Titan-made architecture here in the Broken Isles, though. No Ulduars, Uldumans... no Uld-anythin\'! So I\'m looking into the history of the demons. I figure maybe I\'ll learn somethin\' about Sargeras, the fallen Titan.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107611,'What have you found so far?','What have you found so far?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107612,'Oh, all kinds of relics from the War o\' the Ancients. Plenty o\' battles fought on this very land. Where d\'ye think all the felslate comes from? But nothin\' Titan. Not yet, anyway...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107613,'What are you doing here in the Broken Isles, High Examiner?','What are you doing here in the Broken Isles, High Examiner?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107614,'<The High Examiner eyes you condescendingly.>\n\nHave you not heard of the Reliquary before, $r?\n\nWe seek power, of course. Scores of invaluable artifacts lie littered within the strata of this land. The Highborne have forgotten more about the arcane arts than you or I will ever know. I seek to uncover their forgotten relics, and wield their power for myself and my people.\n\nNow please, no more questions.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107615,'Do you live here in Thunder Totem, Lessah?','Do you live here in Thunder Totem, Lessah?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107616,'','No, no. I am from Thunder Bluff. I am an adventurer, like you. These Highmountain tauren are as foreign to me as they are to you.\n\nI am, however, an avid student of Huln Highmountain, one of the greatest tauren ever to walk this land. Probably THE greatest. Here, in Highmountain, I stand the best chance of learning more about him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107617,'','%s calls out to nearby creatures for aid.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107618,'Okay.','Okay.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(107619,'She will aid me in my conquest of Val\'sharah, starting with your precious Temple of Elune.','',0,0,0,0,0,0,0,0,6,0,58176,0,26124),
(107620,'','Thank you.',0,0,0,0,0,0,2,0,0,0,0,66649,26124),
(107621,'YOU\'VE FALLEN INTO MY TRAP! NOW YOU DIE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107622,'','Speak to me when you are ready to leave.',0,0,0,0,0,0,0,0,0,0,0,58070,26124),
(107624,'','Whenever I was plagued with doubt, I would descend into his barrow. I watched over him as he slept.',0,0,0,0,0,0,0,0,0,0,0,58083,26124),
(107625,'','Even in slumber, his presence calmed me. I left my fears below the earth and emerged, ready to lead my people.',0,0,0,0,0,0,0,0,0,0,0,58082,26124),
(107626,'','When Malfurion returned to my side, we worked as one. As if he had never been away. Have you ever loved as I have?',0,0,0,0,0,0,0,0,0,0,0,58081,26124),
(107627,'','Now Xavius has me by the throat. I must abandon my beloved, and subdue the most beautiful creature I have ever known.',0,0,0,0,0,0,0,0,0,0,0,58080,26124),
(107630,'','I will do whatever is needed to defend Dreadscar Rift from the Burning Legion.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(107631,'','<groans> ...',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(107632,'','Shinfel Blightsworn mumbles incoherently, clearly in pain.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(107633,'Buuuuuurrrrrnnnnssss...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107634,'','The Scepter of Tides... it\'s here. I found it.',0,0,0,0,0,0,0,0,0,0,0,60681,26124),
(107635,'','They\'re using it to whip creatures of this realm into a frenzy.',0,0,0,0,0,0,0,0,0,0,0,60682,26124),
(107636,'','Sharas\'dal is held by Lady Zithreen. She was using me as bait.',0,0,0,0,0,0,0,0,0,0,0,60683,26124),
(107637,'','We should turn back. This whole realm is a trap.',0,0,0,0,0,0,0,0,0,0,0,60684,26124),
(107638,'You underestimate the shaman I have brought.','',0,0,0,0,0,0,1,0,0,0,60685,0,26124),
(107639,'If the Scepter is here, this may be our only chance to capture it and turn its power against the Legion!','',0,0,0,0,0,0,5,0,0,0,60686,0,26124),
(107640,'You\'re not going anywhere!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107641,'My eternal soul... for Caria...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107642,'','You are too late! He comes...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107643,'','Keep its soul intact. Caria has plans for this one.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107644,'Those undead invaders put up quite a fight, but Marl and I won\'t let the farm be taken.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(107645,'Are you Mad Ernie?','Are you Mad Ernie?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107646,'Shhh! Keep your voice down.\n\nI haven\'t gone by that name in years. I gave up the practice of alchemy some time ago, in favor of a calm life here on the farm.\n\nWhat business do you have with \"Mad Ernie\" anyway?','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(107647,'Ritssyn sent me. We need help curing a doom curse.','Ritssyn sent me. We need help curing a doom curse.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(107648,'Ernest Carlisle sighs.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107649,'','The Banshee Queen sends her regards, $ct.',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(107650,'I am in your debt, Master.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107651,'Be careful. These vrykul are nearly unstoppable.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107652,'I can find my way back to the order hall. Thank you.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107653,'The Storm Brew turns the vrykul into brutal, unstoppable machines. Be careful.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107654,'Use the Storm Brew, Master. It will be your only hope against them.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107655,'','I am in your debt, Master.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107656,'','Be careful. These vrykul are nearly unstoppable.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107657,'','I can find my way back to the order hall. Thank you.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107658,'','The Storm Brew turns the vrykul into brutal, unstoppable machines. Be careful.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107659,'','Use the Storm Brew, Master. It will be your only hope against them.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107660,'Looks like we\'re going in! C\'mon, Theodore!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107661,'','This place makes my skin crawl. Elune, give me strength.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107662,'','Now that we have Ursol\'s blessing, we can travel into the Emerald Dream and retrieve the claws! Come, $n, let\'s not waste a single minute!',0,0,0,0,0,0,0,0,0,0,0,62109,26124),
(107663,'Courage... power... discipline...$b$bMaster these traits and the spirit of the bear will be within your heart.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107664,'','This is why we brought you here. Destroy them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107665,'Hiro! Hey Hiro, are you all right, mate?','',0,0,0,0,0,0,1,0,0,0,66686,0,26124),
(107666,'Uh oh. Looks like we\'ve got company.','',0,0,0,0,0,0,1,0,0,0,66737,0,26124),
(107667,'Quick, take this key and get yerself outta there!','',0,0,0,0,0,0,1,0,0,0,66687,0,26124),
(107668,'Ey mon, da lock be jammed an\' me head\'s spinnin\'! You do it if yer so smart, dwarf!','',0,0,0,0,0,0,603,0,0,0,66708,0,26124),
(107669,'Any day now, Hiro!','',0,0,0,0,0,0,603,0,0,0,66688,0,26124),
(107670,'','More enemies!',0,0,0,0,0,0,603,0,0,0,0,66689,26124),
(107671,'May the elements guide our ways.','May the elements guide our ways.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107672,'Ey look, da door opened!','',0,0,0,0,0,0,603,0,0,0,66690,0,26124),
(107673,'May the Earth Mother watch over us.','May the Earth Mother watch over us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107675,'$n! I am in your debt, but I must check on the others.','$n! I am in your debt, but I must check on the others.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107676,'Earth Mother watch over you.','Earth Mother watch over you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107677,'Angus! Sylara! It\'s good to see ya. You... ahhh... got anyting ta drink on ya?','',0,0,0,0,0,0,1,0,0,0,66696,0,26124),
(107678,'They\'ve breached the temple! Defend the Warblades!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107679,'','You\'re not one of my pack. What brings you to the den?',0,0,0,0,0,0,0,0,0,0,0,62244,26124),
(107681,'Allari led a small army to follow a lead on the Warblades. We may have finally found them.','',0,0,0,0,0,0,1,0,0,39194,64668,0,26124),
(107682,'We believe we may have finally found the warblades. Allari led an army to track them down.','',0,0,0,0,0,0,1,0,0,39194,58202,0,26124),
(107683,'Reinforcements! Now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107684,'Me n\' Roo used to be adventurers, just like you. We fought our way from here clear to Pandaria, even been to Outland! Stabbin\' an\' healin\' an\' everything between.\n\nNowadays we just want to spend some time in a quiet place with our two little dogs, ye ken?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107685,'Come then! Meet your end!','',0,0,0,0,0,0,0,0,0,0,58449,0,26124),
(107687,'Death is a gift, mortal!','',0,0,0,0,0,0,0,0,0,0,58450,0,26124),
(107688,'A life worth less than nothing.','',0,0,0,0,0,0,0,0,0,0,58451,0,26124),
(107689,'Embrace agony!','',0,0,0,0,0,0,0,0,0,0,58452,0,26124),
(107690,'You will meet your end!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107691,'I\'ll melt away that courage!','',0,0,0,0,0,0,0,0,0,0,58453,0,26124),
(107692,'To ashes with you!','',0,0,0,0,0,0,0,0,0,0,58454,0,26124),
(107693,'Watch your hopes crumble!','',0,0,0,0,0,0,0,0,0,0,58455,0,26124),
(107694,'Azeroth... must... burn...','',0,0,0,0,0,0,0,0,0,0,58456,0,26124),
(107695,'Burn it down, burn it all down, ha ha ha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107696,'No matter how bad things get, remember that there\'s always an open car on the happy train. Toot toot!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107697,'','Great. Now help us!',0,0,0,0,0,0,1,0,0,0,0,66691,26124),
(107698,'Brute incoming!','',0,0,0,0,0,0,1,0,0,0,66692,0,26124),
(107699,'No... noooo! Mistress will not be pleased that her prisoners escaped!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107700,'I will take care of you myself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107701,'','Those cursed twins... They will pay for what they did!',0,0,0,0,0,0,603,0,0,0,0,66538,26124),
(107702,'We can\'t hold \'em off forever! Get the lead outta yer boots and get outta there!','',0,0,0,0,0,0,0,0,0,0,63694,0,26124),
(107703,'Derp','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107704,'The Warblades will consume you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107705,'','Trifling creatures... once again you have disrupted my plans.',0,0,0,0,0,0,0,0,0,0,0,66738,26124),
(107706,'','I promise you this, monks of the Broken Temple... the next time we meet, you will PAY for your insolence!',0,0,0,0,0,0,0,0,0,0,0,66693,26124),
(107707,'You\'re too late! The corruption of your world can\'t be stopped. I\'ll help it along... starting with your precious companions!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107708,'This loss is irrelevant! The Nightmare will consume all! Until next time, interloper...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107709,'Greetings! How about a quick battle to keep our friends strong?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107710,'Promising! You and your friends are a skilled bunch indeed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107711,'Wielding','Wielding',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(107712,'%s writhes in pain.','%s writhes in pain.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107713,'%s suffers as a darkness grows within.','%s suffers as a darkness grows within.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107714,'My scouts report flocks of giant, diseased bats overtaking them in the skies around the fiery mountain. See if you can find out where they are coming from.','',0,0,0,0,0,0,0,0,0,0,58102,0,26124),
(107715,'You have cleared the skies and the mountain at once. The Skyhorn are in your debt.','',0,0,0,0,0,0,0,0,0,0,58103,0,26124),
(107716,'','Dargrul has trapped a great basilisk mother deep within the vault. If we don\'t put her down now, he will emerge with an army of trained basilisks!',0,0,0,0,0,0,0,0,0,0,0,58106,26124),
(107717,'','You have done the Highmountain tribes a great service today.',0,0,0,0,0,0,0,0,0,0,0,58107,26124),
(107718,'','Dargrul commits atrocities against even the wildlife, polluting our rivers with turtles twisted by his crystalline magic. Find the source of these powerful beasts.',0,0,0,0,0,0,0,0,0,0,0,58104,26124),
(107719,'','Our waters are safe to drink again, thanks to you.',0,0,0,0,0,0,0,0,0,0,0,58105,26124),
(107720,'My people have been taken by Dargrul\'s minions, forced to do his dark bidding or face death at the hands of his slavers. Aid them if you are able.','',0,0,0,0,0,0,0,0,0,0,58110,0,26124),
(107721,'The Stonedark thank you.','',0,0,0,0,0,0,0,0,0,0,58111,0,26124),
(107722,'Legends tell of lost relics from the days of the great dragon Neltharion. Should you come across one, bring it to me, I will ensure it remains protected.','',0,0,0,0,0,0,0,0,0,0,58108,0,26124),
(107723,'Thank you, hero. In the wrong hands these relics could tear apart the fabric of our world.','',0,0,0,0,0,0,0,0,0,0,58109,0,26124),
(107724,'We fight together, $n.','',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(107725,'You pick \'em out. I\'ll take \'em down.','',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(107726,'Over here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107727,'Cut them down! There\'s more on the way!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107728,'My magic... they resisted everything! Please, help!','My magic... they resisted everything! Please, help!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107729,'If I hadn\'t been caught off guard I\'d... You there! Lend me a hand!','If I hadn\'t been caught off guard I\'d... You there! Lend me a hand!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107730,'My magic is yours, $n.','My magic is yours, $n.',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(107731,'Let us purge this threat together.','Let us purge this threat together.',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(107732,'I thank you for your help, $n, but our people must be warned at once!','I thank you for your help, $n, but our people must be warned at once!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107733,'The others. There were more of us... I must find them.','The others. There were more of us... I must find them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107734,'Get me outta here!','Get me outta here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107735,'Hey! Over here! Boy am I sure glad to see you!','Hey! Over here! Boy am I sure glad to see you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107736,'Let\'s get to it, shall we? These demons ain\'t gonna kill themselves!','Let\'s get to it, shall we? These demons ain\'t gonna kill themselves!',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(107737,'Make way! Wrecking crew comin\' through!','Make way! Wrecking crew comin\' through!',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(107738,'Gotta recharge the ol\' mana battery! Save some for me, would ya?','Gotta recharge the ol\' mana battery! Save some for me, would ya?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107739,'You go on ahead, I\'ll catch up with you in a few!','You go on ahead, I\'ll catch up with you in a few!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107740,'I should have stayed in the shadows. Mind lending me a hand?','I should have stayed in the shadows. Mind lending me a hand?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107741,'Get these things off me!','Get these things off me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107742,'They\'ll never see us coming.','They\'ll never see us coming.',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(107743,'My blades are ready, $n. Just show me the target.','My blades are ready, $n. Just show me the target.',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(107744,'Stick to the shadows. This isn\'t over yet.','Stick to the shadows. This isn\'t over yet.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107745,'The others must be warned.','The others must be warned.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107746,'It pains me to ask, but I could really use your help!','It pains me to ask, but I could really use your help!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(107747,'Here! Please - my magic... they devour it!','Here! Please - my magic... they devour it!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(107748,'They\'ve taken the others! Please! Help!','They\'ve taken the others! Please! Help!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107749,'I can\'t fend them off much longer! Please! Help!','I can\'t fend them off much longer! Please! Help!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107750,'Lookin\' like you could use help, $n.','Lookin\' like you could use help, $n.',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(107751,'It\'s time we be gettin\' back to battle.','It\'s time we be gettin\' back to battle.',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(107752,'Thanks, $n. Others be needin\' my help, but take this.','Thanks, $n. Others be needin\' my help, but take this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107753,'Gotta keep movin\'! The Legion is everywhere.','Gotta keep movin\'! The Legion is everywhere.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107754,'Those things... I couldn\'t...','Those things... I couldn\'t...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107755,'Over here! I...','Over here! I...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107756,'The foul breath on these... help me take them down!','The foul breath on these... help me take them down!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107757,'You\'ll not ruin our lands!','You\'ll not ruin our lands!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107758,'We fight together, $n!','We fight together, $n!',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(107759,'These demons stand no chance with me by your side.','These demons stand no chance with me by your side.',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(107760,'We have to push them back!','We have to push them back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107761,'Our people need our help!','Our people need our help!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107762,'To battle!','To battle!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107763,'Your soul will be ours...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107764,'Walking in the memories of spirits can sometimes be dangerous, but it is a responsibility we Spiritwalkers must accept.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107765,'I am ready to walk in the memories of Dargrul.','I am ready to walk in the memories of Dargrul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107766,'Fel magic surges around within the orb almost... invitingly.','Fel magic surges around within the orb almost... invitingly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107767,'As a Warlock, minor fel magic such as this presents no danger to you. Absorb the power of the fel orb.','As a Warlock, minor fel magic such as this presents no danger to you. Absorb the power of the fel orb.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107768,'Fel magic surges around within the orb almost... invitingly.\n\nThe depths of fel magic are beyond you.','Fel magic surges around within the orb almost... invitingly.\n\nThe depths of fel magic are beyond you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107769,'The flask shimmers and bubbles.','The flask shimmers and bubbles.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107770,'As a Rogue, you are intimately familiar with poisons. Adding a lethal dose to this flask should be easy...','As a Rogue, you are intimately familiar with poisons. Adding a lethal dose to this flask should be easy...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107771,'This ward will help seal away a great evil. So long as I draw breath, the Darkness will never be free!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107772,'Your time in this life is short. The Darkness has seen it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107773,'The flask shimmers and bubbles.\n\nUnfortunately, you lack the proper ingredients to create something truly sinister.','The flask shimmers and bubbles.\n\nUnfortunately, you lack the proper ingredients to create something truly sinister.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107774,'','About time, Dargrul. At my age, every minute counts.',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(107775,'','Fine, let\'s make this trade so you can go back to your cave and I can grab a warm drink.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(107776,'Calm your hooves, ronir. I had something to take care of.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107778,'','That sprite is picking on a lunarwing! Would you please put a stop to this?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107779,'','Thank you. I won\'t stand for anyone picking on innocent creatures!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107780,'Arcane energy thrums around the conduit. It seems to be linked to the Guardian Constructs somehow.','Arcane energy thrums around the conduit. It seems to be linked to the Guardian Constructs somehow.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107781,'That thing just rose out of the corruption! We must purge it from our world before it grows too powerful.','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(107782,'As any Goblin would know, adding explosives always solves the problem!','As any Goblin would know, adding explosives always solves the problem!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107783,'Arcane energy thrums around the conduit. It seems to be linked to the Guardian Constructs somehow.\n\nUnfortunately, the intricacies of this mechanical construct are unknown to you.','Arcane energy thrums around the conduit. It seems to be linked to the Guardian Constructs somehow.\n\nUnfortunately, the intricacies of this mechanical construct are unknown to you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107784,'The creatures of the Nightmare grow even more twisted! Let us pray to Elune that this fiend won\'t trouble us again.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107785,'Yeah, that\'s the stuff! Ya feel better or what?','',0,0,0,0,0,0,1,0,0,0,66669,0,26124),
(107786,'If the effects wear off, just look for more Storm Brew up ahead. The vrykul love drinking this stuff!','',0,0,0,0,0,0,1,0,0,0,66739,0,26124),
(107787,'Nice moves!','',0,0,0,0,0,0,1,0,0,0,66670,0,26124),
(107788,'Couldn\'t have done better meself!','',0,0,0,0,0,0,1,0,0,0,66671,0,26124),
(107789,'The stories were true about you.','',0,0,0,0,0,0,1,0,0,0,66672,0,26124),
(107790,'Hmmm, not bad. Not bad at all.','',0,0,0,0,0,0,1,0,0,0,66673,0,26124),
(107791,'Impressive.','',0,0,0,0,0,0,1,0,0,0,66674,0,26124),
(107792,'Hey! I was just about to get \'im!','',0,0,0,0,0,0,1,0,0,0,66675,0,26124),
(107793,'','This murloc\'s tribe has been enslaved by Lady Zithreen.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107794,'Demon Hunter training has long prepared you for this. Grasp the power from within the fel orb.','Demon Hunter training has long prepared you for this. Grasp the power from within the fel orb.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107795,'Warg! Blerg!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107796,'Pah! Good riddance!','',0,0,0,0,0,0,14,0,0,0,66676,0,26124),
(107797,'','A fire! You must quench it before the sacred forest burns!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107798,'I see where ye get yer reputation.','',0,0,0,0,0,0,1,0,0,0,66677,0,26124),
(107799,'Don\'t kill them! Purify them, shaman! Purge them as fast as you can!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107801,'','We are fortunate you arrived so quickly. Thank you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107802,'I am ready to walk in the memories of Oenia Skyhorn.','I am ready to walk in the memories of Oenia Skyhorn.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107803,'I am ready to walk in the memories of Warbrave Oro.','I am ready to walk in the memories of Warbrave Oro.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107804,'Experience with Alchemy teaches you that one should never drink the gray liquid alongside anything purple. It would sure be a pity if anyone were to imbibe in this flask now...','Experience with Alchemy teaches you that one should never drink the gray liquid alongside anything purple. It would sure be a pity if anyone were to imbibe in this flask now...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107805,'Let us rest!','Let us rest!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107806,'I have seen it! The Darkness approaches!','I have seen it! The Darkness approaches!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107807,'Gnomish technology has taught you the dangers of overloading any conduit. Let\'s see how this one handles ten thousand volts!','Gnomish technology has taught you the dangers of overloading any conduit. Let\'s see how this one handles ten thousand volts!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107808,'Engineering has always been your forte. Shutting down this conduit is something you could do with your eyes closed.','Engineering has always been your forte. Shutting down this conduit is something you could do with your eyes closed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107809,'Begone, spirits! Tell the Darkness he is not welcome in this place!','Begone, spirits! Tell the Darkness he is not welcome in this place!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107810,'All right! I\'m ready to bust some skulls! Ye won\'t regret this, Grandmaster!','',0,0,0,0,0,0,53,0,0,0,66694,0,26124),
(107811,'','%s smiles.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(107812,'Ya!!! We be on your side now. Tings will be beddah soon.','',0,0,0,0,0,0,4,0,0,0,71282,0,26124),
(107813,'Such a dilemma, high priestess!','',0,0,0,0,0,0,0,0,6,0,58092,0,26124),
(107814,'Kneel beside your beloved as he draws his final breath? Or watch the temple of your goddess burn!','',0,0,0,0,0,0,0,0,6,0,58093,0,26124),
(107815,'<Maniacal Laugh>','',0,0,0,0,0,0,0,0,6,0,58094,0,26124),
(107816,'The darkness rises.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107817,'The Darkness will pierce the veil.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107818,'The master will return.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107819,'Embrace the shadow.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107820,'He will return.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107821,'Dark overcomes light.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107822,'Accept the Darkness.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107823,'He is master of shadows.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107824,'The prisoners were taken to the Gates of Valor. It\'s swarming with powerful vrykul and demons. Mark my words, there\'s something fishy going on there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107825,'','<Sylara waits for your orders.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107826,'I made it my goal ta taste every brew across dese lands. Dere ain\'t nothing ta worry about when you\'ve got a brew in one hand your friends beside ya.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107827,'','<Ysera Dragon Roar>',0,0,0,0,0,0,0,0,6,0,0,58095,26124),
(107828,'Anything to report from the night watch?','Anything to report from the night watch?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107829,'What? I don\'t... Wait, yes, I hear it too! Report to Thunder Totem, warbrave. I will find out what is happening.','What? I don\'t... Wait, yes, I hear it too! Report to Thunder Totem, warbrave. I will find out what is happening.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107830,'What manner of drogbar are these? I have never seen their like!','What manner of drogbar are these? I have never seen their like!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107831,'Yes! I just heard shouting from across the stream!','Yes! I just heard shouting from across the stream!',0,0,0,0,0,0,0,0,0,55342,0,0,26124),
(107832,'','The Warblades are even more impressive in person.',0,0,0,0,0,0,1,0,0,39228,0,64687,26124),
(107833,'The Fel Hammer is ours at last. Gaze upon the might of the Aldrachi Warblades!','',0,0,0,0,0,0,0,0,4,0,64717,0,26124),
(107834,'Behold the power of the Aldrachi Warblades. The Fel Hammer is ours!','',0,0,0,0,0,0,0,0,4,0,58201,0,26124),
(107835,'','$p... I thought I sensed a paltry whelp wandering where it shouldn\'t.',0,0,0,0,0,0,0,0,0,0,0,58235,26124),
(107836,'','For every soul I claim, my power grows. I will rule this world... ALL worlds!',0,0,0,0,0,0,0,0,0,0,0,64680,26124),
(107837,'','I\'ll reduce this entire canyon to rubble if I have to!',0,0,0,0,0,0,0,0,0,0,0,64677,26124),
(107838,'','Saera! Taraar! They approach. Do not fail me!',0,0,0,0,0,0,0,0,0,0,0,64679,26124),
(107839,'You are too late, child. Your father\'s corpse is now my vessel!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107840,'','Do you see those corpses? Their souls have been torn right out of their bodies!',0,0,0,0,0,0,0,0,0,0,0,64670,26124),
(107841,'','I think we can make it across with a little... finesse.',0,0,0,0,0,0,0,0,0,0,0,64671,26124),
(107842,'It looks like a pile of old spare parts. What once was powered by arcane has clearly run out of energy.','It looks like a pile of old spare parts. What once was powered by arcane has clearly run out of energy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107843,'All Hunters have a working knowledge of traps. This junk could probably be rigged together to resemble one...','All Hunters have a working knowledge of traps. This junk could probably be rigged together to resemble one...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107844,'Quickly, hero! I can open a portal to the spirit world. You must destroy the Darkness inside before he claims another vessel.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107845,'It looks like a pile of old spare parts. What once was powered by arcane has clearly run out of energy.\n\nThis junk appears to have been neglected for too long.','It looks like a pile of old spare parts. What once was powered by arcane has clearly run out of energy.\n\nThis junk appears to have been neglected for too long.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107846,'|TInterface\\Icons\\spell_frost_ring of frost:20|t%s begins to cast |cFFFF0000|Hspell:206949|h[Frigid Nova]|h|r!','|TInterface\\Icons\\spell_frost_ring of frost:20|t%s begins to cast |cFFFF0000|Hspell:206949|h[Frigid Nova]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(107847,'|TInterface\\Icons\\ability_felarakkoa_feldetonation_green:20|t%s begins to cast |cFFFF0000|Hspell:206517|h[Fel Nova]|h|r!','|TInterface\\Icons\\ability_felarakkoa_feldetonation_green:20|t%s begins to cast |cFFFF0000|Hspell:206517|h[Fel Nova]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(107848,'|TInterface\\Icons\\spell_priest_shadoworbs:20|t%s begins to cast |cFFFF0000|Hspell:207439|h[Void Nova]|h|r!','|TInterface\\Icons\\spell_priest_shadoworbs:20|t%s begins to cast |cFFFF0000|Hspell:207439|h[Void Nova]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(107849,'|TInterface\\Icons\\Ability_Druid_Starfall:20|t%s begins to cast |cFFFF0000|Hspell:205408|h[Grand Conjunction]|h|r!','|TInterface\\Icons\\spell_frost_ring of frost:20|t%s begins to cast |cFFFF0000|Hspell:206949|h[Frigid Nova]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(107850,'','Put your back into it, Taraar. Quickly!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107851,'Me?! If you would focus, we\'d be done by now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107852,'At last something reasonable escapes your lips!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107853,'Caria must complete her work. You will not interfere!','',0,0,0,0,0,0,0,0,0,0,58231,0,26124),
(107854,'Reesh Archim, galar.','',0,0,0,0,0,0,0,0,0,0,58232,0,26124),
(107855,'','UNGH! I\'m hit!',0,0,0,0,0,0,0,0,0,0,0,64674,26124),
(107856,'','You... must continue. The Warblades are worth... any sacrifice!',0,0,0,0,0,0,0,0,0,0,0,64675,26124),
(107857,'','I will secure a way out of here. Caria is yours.',0,0,0,0,0,0,0,0,0,0,0,64676,26124),
(107858,'','I\'ll meet you at your order hall once you\'ve gathered the ingredients.',0,0,0,0,0,0,1,0,0,0,0,66695,26124),
(107859,'','Yeah! I\'m ready for action!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107860,'Use your |TInterface\\Icons\\ability_demonhunter_spectralsight.blp:20|t |cFFFF0000|Hspell:188501|h[Spectral Sight]|h|r to find Caria\'s trail!','Use your |TInterface\\Icons\\ability_demonhunter_spectralsight.blp:20|t |cFFFF0000|Hspell:188501|h[Spectral Sight]|h|r to find Caria\'s trail!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(107861,'','I heard Angus talking about it back at home. He said it makes you a million times stronger!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107862,'','Yeahhhh! Another one bites the dust!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107863,'','Awww, is the adventure over already? Okay...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107864,'Fast little wikket, you are.  Stick with me and you\'ll go far!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107865,'How is it? Found many ingredients already?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107866,'More recruits show up every day, seeking to learn from the Master.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107867,'Good luck out there, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107868,'','I can\'t take these infernals alone!',0,0,0,0,0,0,0,0,0,0,0,58233,26124),
(107869,'Ey Master, nice ta see ya again! We heard ye might need some help gathering materials fer the Storm Brew.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107870,'I\'m happy ta help mastah, long as I get a taste a\' dat brew when it be done.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107871,'We\'ve been hearin\' reports of increased Legion activity near the Tomb of Sargeras.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107872,'Legion forces are amassin\' in great concentration there. Maybe for a large attack.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107873,'We\'ll fight wherever we need ta, but we\'d sure lose a lot fewer of our order if we had somethin\' like this Storm Brew.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107874,'I can\'t wait to try just a little taste o\' dat brew when it\'s ready.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107875,'That should do it! We\'ll report back to duty. Good luck, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107876,'','Unhand my father\'s body, you monster!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107877,'','Father! Fight it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107878,'Oh, how Ulan\'s spirit cries out! How he weeps, knowing he will be the instrument of your destruction!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107879,'How delicious... the hapless chieftain dying at the hands of her beloved father!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107880,'','Resist him, father! Do not let him control you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107881,'You failed to save your father in life. Now you fail his spirit! Such a disappointing daughter!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107882,'Your petty weapons are no match for me here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107883,'Fascinating. You still think you can win?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107884,'No! Your spirits were to be mine...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107885,'','Aegira? My dear apprentice? It brings me joy to hear your voice.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107886,'Welcome to MY world!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107887,'','Master... I am unworthy. I wish I had more time to learn from you. But you were avenged. Mornjirn is dead, and we recovered your Storm Brew recipe.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107888,'','My dear Aegira, your skills are already beginning to surpass mine. From this day forward, no longer are you my apprentice. Go forward proudly as a Brewmaster, and continue my legacy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107889,'','Thank you, Master.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107890,'Greg! Dance harder! People actually showed up to this scam... I mean event!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(107891,'I pay you to dance Greg, not mope! So put some boogie into it!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(107892,'Arcane energy thrums around the conduit. It seems to be linked to the Guardian Constructs somehow.\n\nUnfortunately, the intricacies of this mechanical construct are unknown to you.','Arcane energy thrums around the conduit. It seems to be linked to the Guardian Constructs somehow.\n\nUnfortunately, the intricacies of this mechanical construct are unknown to you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107893,'This is it Greg! We finally hit the big time! People from all over Azeroth are here at OUR event!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(107894,'Greg. You\'re fired.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107895,'Brewing','Brewing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(107896,'Back in Dalaran from her successful world tour, it\'s... Tiffany Nelson! Today only, step up and challenge a true pet battle superstar!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107897,'Do you believe in miracles? Our challenger defeated Tiffany Nelson! Keep an eye on this up-and-coming superstar!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(107898,'','The Legion witch is dead. Grandmaster, I think this calls for a celebration!',0,0,0,0,0,0,0,0,0,0,0,71475,26124),
(107899,'Firelord? You are nothing but a pile of rocks!','',0,0,0,0,0,0,0,0,0,0,66822,0,26124),
(107900,'Careful shaman. Play with fire and you will get burned...','',0,0,0,0,0,0,0,0,0,0,71077,0,26124),
(107901,'Perhaps I underestimated your strength...','',0,0,0,0,0,0,0,0,0,0,66823,0,26124),
(107902,'Today in the arena, it\'s the mighty Sir Galveston! He may be a bit of a nut case, but he paid the entrance fee... so he\'s in! Step right up and challenge the local lunatic!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107903,'Ladies and gentlemen, you just witnessed an epic victory over a guy who fights with a toy strapped to a bird. Frankly, it\'s not that impressive... but a win\'s a win!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107904,'','The ritual is nearly ready. Stop them, you mongrels!',0,0,0,0,0,0,0,0,0,0,0,58242,26124),
(107905,'And in this corner, we have Bodhi Sunwayver... the shirtless guy! Why doesn\'t he wear a shirt? Is it being washed? Did he lose a bet? No one knows!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107906,'','I will claim every soul on this pathetic world!',0,0,0,0,0,0,0,0,0,0,0,58243,26124),
(107907,'What a match! Bodhi may be terrible at pet battles, but he sure is easy on the eyes!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(107908,'','The Legion is only the beginning. My blades call upon power from beyond!',0,0,0,0,0,0,0,0,0,0,0,58244,26124),
(107909,'What a delicious looking intruder! It has been ages since I\'ve dined on mortal flesh! Long have I hungered for the taste...','',0,0,0,0,0,0,0,0,0,0,66833,0,26124),
(107910,'I feel unwell...','',0,0,0,0,0,0,0,0,0,0,65646,0,26124),
(107911,'Ugh, what is happening?','',0,0,0,0,0,0,0,0,0,0,65647,0,26124),
(107912,'This fruit is horrible...','',0,0,0,0,0,0,0,0,0,0,65658,0,26124),
(107913,'Ugh. I must find a physician!','',0,0,0,0,0,0,0,0,0,0,65648,0,26124),
(107914,'Lower those weapons, bonemen. I am here for $p.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107915,'It looks like a war zone out there. Nicely done!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107916,'Welcome to my web, delicious mortal! I do hope you\'ll stick around!','',0,0,0,0,0,0,0,0,0,0,66834,0,26124),
(107917,'I will rend your flesh and dine on your entrails!','',0,0,0,0,0,0,0,0,0,0,66839,0,26124),
(107918,'Avenge me my children! Avenge me...','',0,0,0,0,0,0,0,0,0,0,66995,0,26124),
(107919,'','I will need to focus on the vision to understand its message.\n\nWe have had our differences in the past, but this is bigger than both of us. Can I trust you?',0,0,0,0,0,0,0,0,0,0,0,61431,26124),
(107920,'By my honor you will come to no harm, priestess.','By my honor you will come to no harm, priestess.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107921,'','I pray we are not too late.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107922,'','Meet me back at the refuge and we will continue our search. Be quick about it!',0,0,0,0,0,0,0,0,0,0,0,61430,26124),
(107923,'','Do not let anything disturb my meditation.',0,0,0,0,0,0,0,0,0,0,0,61429,26124),
(107924,'','Stay close. Do not let the Nightmare confound you.',0,0,0,0,0,0,0,0,0,0,0,61426,26124),
(107925,'','The path splits. Wait, what is that?',0,0,0,0,0,0,0,0,0,0,0,61428,26124),
(107926,'','The corruption is thick here. What is that across the bridge? Follow closely.',0,0,0,0,0,0,0,0,0,0,0,61427,26124),
(107927,'Lower those weapons, pale elves. I am here for $p.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107928,'','There is no time to mourn. Elothir is beyond my reach now. Come, and do not delay.',0,0,0,0,0,0,0,0,0,0,0,61436,26124),
(107929,'','Shala\'nir is just ahead. You should be ready for whatever foulness awaits us.',0,0,0,0,0,0,0,0,0,0,0,61435,26124),
(107930,'','I admit, I was wary to have one of your kind accompany me. But you have fought with bravery and valor. Let us see this through together.\n\nAre you prepared to enter the epicenter of this chaos, $r?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107931,'','Return to me, warrior of the Horde! I have found something!',0,0,0,0,0,0,0,0,0,0,0,61433,26124),
(107932,'Turns out the egg held an ancient magical creature bent on watching the world burn. Luckily our challenger was victorious!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107933,'Featured in today\'s pet battle spectacular, it\'s... Hey, who put that egg in the arena? Uh... Step right up and fight a big egg! Beat up a defenseless egg, limited time only!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107934,'I claim this vessel.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107935,'','Show your face, Grey One!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107936,'You ronir have grown strong during my long absence, Highmountain. But not strong enough.','',0,0,0,0,0,0,432,0,0,0,0,0,26124),
(107937,'','My people stopped you in ages past, Darkness. We will defeat you again.',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(107938,'Your ancestors were overconfident as well. It shall prove to be your undoing.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107939,'Still... there is power in your bloodline, child. I shall relish claiming it.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(107940,'','I will never serve you!',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(107941,'One day... but you are not yet a worthy vessel for my power. No... I have a more... formidable chieftain in mind!','',0,0,0,0,0,0,430,0,0,0,0,0,26124),
(107942,'','What could he... Oh no... My father! He means to claim my father!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(107943,'Due to technical difficulties, today\'s tournament is canceled! Ow! That one bit me! Ow! Err... Please stand by! This little rat problem should be resolved shortly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107944,'The tournament is saved! I\'m not sure how those rodents got out of their cages. Umm... did I say cages? What cages? It\'s not like I\'m part of a magically enhanced rat smuggling ring or something!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(107945,'','Watch out! Doomguard headed your way!',0,0,0,0,0,0,0,0,0,0,0,64678,26124),
(107946,'','Well fought, but Legion reinforcements are approaching as we speak. We must depart.',0,0,0,0,0,0,0,0,0,0,0,64684,26124),
(107947,'[PH] And then a rad finale cinematic plays! [PH]','[PH] And then a rad finale cinematic plays! [PH]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107948,'If you are unafraid of death, meet me at my throne. You may prove useful after all...','',0,0,0,0,0,0,0,0,0,0,66824,0,26124),
(107949,'Soon, Lord Smolderon... you will kneel before the true Firelord!','',0,0,0,0,0,0,0,0,0,0,66996,0,26124),
(107950,'Foolish mortals! Soon this place will belong to the master!','',0,0,0,0,0,0,0,0,0,0,69917,0,26124),
(107951,'','Show them no quarter!',0,0,0,0,0,0,0,0,0,0,0,69737,26124),
(107952,'','Smite the defiler!',0,0,0,0,0,0,0,0,0,0,0,69738,26124),
(107953,'','Show them nature\'s wrath!',0,0,0,0,0,0,0,0,0,0,0,69739,26124),
(107954,'','Andu-falah-dor!',0,0,0,0,0,0,0,0,0,0,0,69740,26124),
(107955,'','Lord Ursoc! Quickly $n, to his side!',0,0,0,0,0,0,0,0,0,0,0,69741,26124),
(107956,'','The ritual I\'m about to perform is complicated, and will take some time to finish, but it is the only way to drop the barrier.',1,0,0,0,50,0,0,0,0,0,0,69742,26124),
(107965,'It\'s a tray of treats. It looks like this tray in particular has been infused with some strange arcane magic.','It\'s a tray of treats. It looks like this tray in particular has been infused with some strange arcane magic.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107966,'It\'s a tray of treats. It looks like this tray in particular has been infused with some strange arcane magic.\n\nEating random magically infused food might be bad for your system... you don\'t know if it is safe or not.','It\'s a tray of treats. It looks like this tray in particular has been infused with some strange arcane magic.\n\nEating random magically infused food might be bad for your system... you don\'t know if it is safe or not.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107967,'Years of training in the culinary arts has strongly developed your skill in Cooking. These parts here are safe to eat.','Years of training in the culinary arts has strongly developed your skill in Cooking. These parts here are safe to eat.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107968,'As a Pandaren, all food is familiar to you. Nothing can break your iron belly. Time to eat!','As a Pandaren, all food is familiar to you. Nothing can break your iron belly. Time to eat!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107969,'|TInterface\\Icons\\spell_mage_altertime:20|tYou\'ve been given a |cFFFF0000|Hspell:206617|h[Time Bomb]|h|r.','|TInterface\\Icons\\spell_mage_altertime:20|tYou\'ve been given a |cFFFF0000|Hspell:206617|h[Time Bomb]|h|r.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107970,'|TInterface\\Icons\\inv_archonpet:20|t%s begins casting |cFFFF0000|Hspell:211927|h[Power Overwhelming]|h|r!','|TInterface\\Icons\\inv_archonpet:20|t%s begins casting |cFFFF0000|Hspell:211927|h[Power Overwhelming]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107971,'|TInterface\\Icons\\inv_archonpet:20|t%s reaches |cFFFF0000|Hspell:207972|h[Full Power]|h|r !','|TInterface\\Icons\\inv_archonpet:20|t%s reaches |cFFFF0000|Hspell:207972|h[Full Power]|h|r !',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107972,'','I see you, monk! Your struggle is for naught. My forces will purge your order from the face of this world!',0,0,0,0,0,0,0,0,0,0,0,62015,26124),
(107973,'','You cannot hide from me, monk. Try as you might, but your monastery will burn!',0,0,0,0,0,0,0,0,0,0,0,62016,26124),
(107974,'','You are stronger than you look, monk, but I will not be defied! Jorvinax! Keep that portal open!',0,0,0,0,0,0,0,0,0,0,0,62017,26124),
(107975,'Greetings, and thank you for helping to test the Emerald Nightmare!\n\nI can teleport you directly to any bosses that are currently available for testing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107976,'Why defy that which devours all things?','',0,0,0,0,0,0,0,0,0,0,58486,0,26124),
(107977,'I want to teleport to Elerethe Renferal.','I want to teleport to Elerethe Renferal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107978,'A timely demise.','',0,0,0,0,0,0,0,0,0,0,58487,0,26124),
(107979,'I want to teleport to Il\'gynoth, Heart of Corruption.','I want to teleport to Il\'gynoth, Heart of Corruption.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107980,'So linear. So limited.','',0,0,0,0,0,0,0,0,0,0,58488,0,26124),
(107981,'Time is on MY side.','',0,0,0,0,0,0,0,0,0,0,58489,0,26124),
(107982,'The wheels of time turn against you.','',0,0,0,0,0,0,0,0,0,0,58490,0,26124),
(107983,'Time races past you.','',0,0,0,0,0,0,0,0,0,0,58491,0,26124),
(107984,'I want to teleport to Nythendra.','I want to teleport to Nythendra.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107985,'Time will not be kind.','',0,0,0,0,0,0,0,0,0,0,58492,0,26124),
(107986,'I want to teleport to Dragons of Nightmare.','I want to teleport to Dragons of Nightmare.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107987,'Feel like time is standing still?','',0,0,0,0,0,0,0,0,0,0,58493,0,26124),
(107988,'Time waits for no one.','',0,0,0,0,0,0,0,0,0,0,58494,0,26124),
(107989,'I want to teleport to Xavius.','I want to teleport to Xavius.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107990,'Precise. Perfect. Inevitable.','',0,0,0,0,0,0,0,0,0,0,58495,0,26124),
(107991,'I want to teleport to Cenarius.','I want to teleport to Cenarius.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107992,'My time has come.','',0,0,0,0,0,0,0,0,0,0,58496,0,26124),
(107993,'I want to teleport to Ursoc.','I want to teleport to Ursoc.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107994,'It was only a matter of time.','',0,0,0,0,0,0,0,0,0,0,58497,0,26124),
(107995,'Your pets are so atrocious, I consider it a provocation!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(107996,'If only you knew what lay beyond...','',0,0,0,0,0,0,0,0,0,0,58430,0,26124),
(107997,'Such insolence... very well, I shall show you!','',0,0,0,0,0,0,0,0,0,0,58431,0,26124),
(107998,'See for yourself the cruel, frozen void that lies beyond the margin of Azeroth\'s skies!','',0,0,0,0,0,0,0,0,0,0,58432,0,26124),
(107999,'The stars align! Fear their portents!','',0,0,0,0,0,0,0,0,0,0,58433,0,26124),
(108000,'No mortal may abrogate the precepts of fate!','',0,0,0,0,0,0,0,0,0,0,58434,0,26124),
(108001,'As the stars wax, so your lives wane!','',0,0,0,0,0,0,0,0,0,0,58435,0,26124),
(108002,'I have all the time in the world.','',0,0,0,0,0,0,0,0,0,0,58498,0,26124),
(108003,'Lets begin your lesson in humility.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108004,'Lesson over.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108005,'Begone! I need time to contemplate this affront.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108006,'So undisciplined.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108007,'You will learn respect or I will continue to educate you in it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108008,'That one isn\'t fit to clean my quarters, much less battle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108009,'Interesting, show me more.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108010,'An unfortunate miscalculation.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108011,'You cannot discern between a victory or a sacrifice.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108012,'','These hoofprints follow the path to the left. After them, quickly!',0,0,0,0,0,0,0,0,0,0,0,61432,26124),
(108013,'','I cannot tell where his voice is coming from! Search the buildings to the west! Now! I will scour the east for signs of him!',0,0,0,0,0,0,0,0,0,0,0,61434,26124),
(108014,'','Warrior of the Horde! To me! I have found something!',0,0,0,0,0,0,0,0,0,0,0,62773,26124),
(108015,'','I can\'t... hold... anymore...',0,0,0,0,0,0,0,0,0,0,0,69743,26124),
(108016,'','This is too much to bear!',0,0,0,0,0,0,0,0,0,0,0,69744,26124),
(108017,'','Augghhh!!',0,0,0,0,0,0,0,0,0,0,0,69745,26124),
(108018,'','H-help! I can\'t hold... on...',0,0,0,0,0,0,0,0,0,0,0,69746,26124),
(108019,'I thank you, druids. These abominations of Nightmare are relentless! They will stop at nothing to snatch the claws from my lair.','',0,0,0,0,0,0,0,0,0,0,62281,0,26124),
(108020,'','Lord Ursoc, the Burning Legion has returned. $n is our best hope to drive back the Legion AND the Nightmare, but we must have the claws if we are to succeed!',0,0,0,0,0,0,0,0,0,0,0,62283,26124),
(108021,'','We humbly request your aid. The power of your claws could defeat our enemies once and for all.',0,0,0,0,0,0,0,0,0,0,0,62282,26124),
(108022,'','Lord Ursoc, I merely returned the claws to their rightful place; a place where their power would not be abused.',0,0,0,0,0,0,0,0,0,0,0,69751,26124),
(108023,'','Thank you, mighty Ursoc!',2,0,0,0,0,0,0,0,0,0,0,69747,26124),
(108024,'Meeting me must be overwhelming. Understandable... the low-born are often stricken dumb in my presence. Luckily for you, I am feeling charitable and will honor you with a battle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108025,'A fluke! A mishap! Someone of my station does not lose to a commoner with such boorish manners. Tell no one of this encounter.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108026,'Good to see you, friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108027,'I... um... misplaced that crystal thing you gave me. Do you have another?','I... um... misplaced that crystal thing you gave me. Do you have another?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108028,'Greetings, and thank you for helping to test the Suramar Palace!\n\nI can teleport you directly to any bosses that are currently available for testing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108029,'This sacred peak is for hunters alone.$bTurn back, or the eagle spirit will carry you away!','This sacred peak is for hunters alone.$bTurn back, or the eagle spirit will carry you away!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(108030,'I want to teleport to Crystal Scorpion.','I want to teleport to Crystal Scorpion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108031,'I want to teleport to Chronomatic Anomaly.','I want to teleport to Chronomatic Anomaly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108032,'I want to teleport to Trilliax.','I want to teleport to Trilliax.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108033,'I want to teleport to Spellblade Aluriel.','I want to teleport to Spellblade Aluriel.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108034,'I want to teleport to Tichondrius.','I want to teleport to Tichondrius.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108035,'Kayn, I need to return to the Black Temple.','Kayn, I need to return to the Black Temple.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108036,'I want to teleport to Astromancer Etraeus.','I want to teleport to Astromancer Etraeus.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108037,'I want to teleport to High Botanist Tel\'arn.','I want to teleport to High Botanist Tel\'arn.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108038,'I want to teleport to Krosus.','I want to teleport to Krosus.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108039,'I want to teleport to Grand Magistrix Elisande.','I want to teleport to Grand Magistrix Elisande.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108040,'I want to teleport to Gul\'dan.','I want to teleport to Gul\'dan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108041,'','I heard your call for aid, great one. Are there any teeny lil\' fuzzy animals in danger? Oh! Oh my!',0,0,0,0,0,0,0,0,0,0,0,62278,26124),
(108043,'The other spiders seem wary of this one.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108044,'I am Grash, son of Gralashar.$b$bThe snake witch controls us with magic stick. Those who fight she takes away to kill.$b$bHave you come to kill snake witch?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108045,'She calls herself \"Lady Zithreen.\" She has many snakes. Snakes who follow her. Snakes on her face.$b$bShe claims water throne for her queen, using magic stick.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108046,'<Grash frowns.>$b$bMagic stick is very old. Very powerful. It is made of living water.$b$bSnake witch says the magic stick came from her queen. It speaks to the sea. Sea monsters obey the stick. It heals their wounds.$b$bStick fill the heads of giants with dark and pain. The dark comes from the witch, not the stick.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108047,'Sha-man? Like, little one who speaks to water and storms? $b$bYes, Grash has seen her. She fights the snake witch and loses.$b$bSnake witch keeps her alive. Says stupid people will come for her.$b$bHa hah! Snake witch is the dumb one. No one stupid enough to come for shaman lady.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108048,'You will kill snake witch?$b$bYou will take away magic stick?$b$bYes! Grash will help!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108049,'Who is this snake witch?','Who is this snake witch?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108050,'We seek a magic stick! What does it look like?','We seek a magic stick! What does it look like?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108051,'We are looking for a shaman. Have you seen her?','We are looking for a shaman. Have you seen her?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108052,'Join us! We will kill the \"snake witch\" and take this \"magic stick!\"','Join us! We will kill the \"snake witch\" and take this \"magic stick!\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108053,'Let\'s go!','Let\'s go!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108054,'We must keep these catacombs clear. Not all of us are strong enough to use the portals and must resort to other means of travel, unsettling though they may be.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108055,'%s\'s bark begins to splinter!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108056,'In times like these, everyone must get their hands dirty.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108057,'','It is finished! The claws are ours!',0,0,0,0,0,0,0,0,4,0,0,69748,26124),
(108058,'Your allies have fallen! The ritual has failed!','Your allies have fallen! The ritual has failed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(108059,'I must go attend to my prize. Malithar, I leave the claws to you. Use them to exterminate this filth.','',0,0,0,0,0,0,0,0,0,0,70990,0,26124),
(108060,'','You did it, $n! You got him!',0,0,0,0,0,0,0,0,0,0,0,69749,26124),
(108061,'','We should go. There\'s nothing left for us here. Let me know when you\'re ready to leave and I\'ll take us back to our bodies in the normal world.',0,0,0,0,0,0,0,0,0,0,0,69750,26124),
(108062,'','Are you ready to leave?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108063,'','Champion, once again we must ask that you go where we cannot follow. Helya\'s forces must be weakened if we are to prevail.',0,0,0,0,0,0,0,0,0,0,0,60074,26124),
(108064,'Let\'s go.','Let\'s go.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108065,'','Do not overextend yourself. The time will come when Helya will face Odyn\'s full wrath. But until then, you have weakened her forces.',0,0,0,0,0,0,0,0,0,0,0,60075,26124),
(108066,'Are you sure you want to begin the encounter?','Are you sure you want to begin the encounter?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108067,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108068,'Are you ready to begin the ritual?','Are you ready to begin the ritual?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108069,'This glowing flower very distinctly stands out. It looks to have been meticulously cared for by someone with great horticultural skills.','This glowing flower very distinctly stands out. It looks to have been meticulously cared for by someone with great horticultural skills.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108070,'These new challengers seek to complete the trials you have bested. Show them how a true champion fights!','',0,0,0,0,0,0,0,0,0,0,60080,0,26124),
(108071,'Better you taught them their place is in this life now than delude themselves further.','',0,0,0,0,0,0,0,0,0,0,60081,0,26124),
(108072,'This glowing flower very distinctly stands out. It looks to have been meticulously cared for by someone with great horticultural skills.\n\nProbably best to leave this one to someone more in tune with nature.','This glowing flower very distinctly stands out. It looks to have been meticulously cared for by someone with great horticultural skills.\n\nProbably best to leave this one to someone more in tune with nature.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108073,'Desmond seems to have crossed someone he shouldn\'t have.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108074,'<Search the body for clues.>','<Search the body for clues.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108075,'The Inkbinders have lost their way! They forget the true purpose of our runic magic traditions. They must be stopped before they pervert these customs further.','',0,0,0,0,0,0,0,0,0,0,60084,0,26124),
(108076,'To think I would live to see such profane use of runic magic. It saddens my heart.','',0,0,0,0,0,0,0,0,0,0,60085,0,26124),
(108077,'There\'s nothing here.','There\'s nothing here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108078,'','We shall meet again, $n. May Elune guide our paths.',0,0,0,0,0,0,0,0,0,0,0,62202,26124),
(108079,'Picking the flower just here should release invigorating spores. You know this because you studied Herbalism and know about plant things.','Picking the flower just here should release invigorating spores. You know this because you studied Herbalism and know about plant things.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108080,'Breathe deep of its spores. As a Druid, you are attuned to nature and can recognize this flower\'s beneficial properties.','Breathe deep of its spores. As a Druid, you are attuned to nature and can recognize this flower\'s beneficial properties.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108081,'We are everywhere. We are Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108082,'Meddling... whelp...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108083,'Welcome, $p. As a subtlety rogue you specialize in striking from the shadows, dispatching foes quickly and quietly. Let\'s begin your training with your primary attack, Backstab.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108084,'Use Backstab on this target dummy. Attacking from behind inflicts more damage.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108085,'','Demons continue to march on the Gates of the Valor. Your aid is required.',0,0,0,0,0,0,0,0,0,0,0,60078,26124),
(108086,'','You have done well this day, champion. May the Twisting Nether be filled with the lamentations of your enemies.',0,0,0,0,0,0,0,0,0,0,0,60079,26124),
(108087,'What brings you to this lawless place?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(108088,'The shadows reveal.','The shadows reveal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108089,'The Burning Legion. Slayers of whole worlds.','',0,0,0,0,0,0,0,0,0,0,58436,0,26124),
(108090,'Could we hope to resist? Can you?!','',0,0,0,0,0,0,0,0,0,0,58437,0,26124),
(108091,'Held to the majesty of the stars, you are nothing - less than nothing.','',0,0,0,0,0,0,0,0,0,0,58438,0,26124),
(108092,'What are you exactly?','What are you exactly?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108093,'What meager petulance. I expected more from you.','',0,0,0,0,0,0,0,0,0,0,58439,0,26124),
(108094,'Is that not enough? Must I show you the true horror of our reality?','',0,0,0,0,0,0,0,0,0,0,58440,0,26124),
(108095,'Very well... witness what I have seen, and TREMBLE!','',0,0,0,0,0,0,0,0,0,0,58441,0,26124),
(108096,'Avatars of non-existence... knowing nothing but hunger.','',0,0,0,0,0,0,0,0,0,0,58442,0,26124),
(108097,'These are the beings who will devour the future you so futilely fight to protect!','',0,0,0,0,0,0,0,0,0,0,58443,0,26124),
(108098,'No... I cannot control... the void... it comes!','',0,0,0,0,0,0,0,0,0,0,58444,0,26124),
(108099,'I provide information that no other can.$B$BThat is all you need to know.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108100,'The stars have judged you, and found you wanting.','',0,0,0,0,0,0,0,0,0,0,58445,0,26124),
(108101,'Let\'s get back to the matter at hand.','Let\'s get back to the matter at hand.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108102,'','Those creatures over there are empowered by ancient mana. It is awful to ask this of you, but I need you to dispatch them and siphon their energy.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108103,'It seems fate is on your side.','',0,0,0,0,0,0,0,0,0,0,63738,0,26124),
(108104,'','Thank you. It is a horrid duty, but this work is essential for our survival.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108105,'Akaari is in this very city as we speak, spying for her masters.','',1,0,0,0,0,0,0,0,0,0,63739,0,26124),
(108106,'I will gladly tell you where... in exchange for a rune of portals.','',1,0,0,0,0,0,0,0,0,0,63740,0,26124),
(108107,'Until then, our business is complete.','',1,0,0,0,0,0,0,0,0,0,63741,0,26124),
(108108,'','We go to the Temple of Elune. We will ride more swiftly on Ash\'alah\'s back. Are you ready to depart?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108109,'','We go to the Temple of Elune. Ash\'alah will carry you this once. Prepare yourself.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108110,'Greetings! Are you here to see my exquisite collection?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108111,'If you are here to see my most prized possession, I am afraid that I have it locked away.$b$bI might bring it out in a hundred years or so. Would you like to make an appointment?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108112,'I am Mornath, a collector of fine arts and collectibles. Would you like to see my statue collection?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108113,'Lespin wants his sculpture back.','Lespin wants his sculpture back.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108114,'Return to nothing.','',0,0,0,0,0,0,0,0,0,0,58446,0,26124),
(108115,'You can not avoid annihilation.','',0,0,0,0,0,0,0,0,0,0,58447,0,26124),
(108116,'I was beginning to doubt you would come.','',0,0,0,0,0,0,0,0,0,0,63737,0,26124),
(108117,'I carry only the highest quality products.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108118,'Show me your latest wares.','Show me your latest wares.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108119,'The shadows reveal.','The shadows reveal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108120,'Nothing to share, I\'m afraid. The wine gets people talking, but sometimes they just don\'t have anything useful to say.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108121,'Say, care for some Moist Azsunian Feta while you\'re here? It has a lovely tangy flavor!','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(108122,'This will remove a |cFF0070dd|Hitem:124441:0:0:0:0:0:0:0:90:0|h[Leylight Shard]|h|r from your inventory. Are you sure?','This will remove a |cFF0070dd|Hitem:124441:0:0:0:0:0:0:0:90:0|h[Leylight Shard]|h|r from your inventory. Are you sure?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(108123,'','We\'re finally closing in on her after all these years...',0,0,0,0,0,0,1,0,0,39370,0,63752,26124),
(108124,'','I\'ll meet you upstairs in Glorious Goods when you\'re done. Another one of Khadgar\'s dogs has been nosing around, asking too many questions...',0,0,0,0,0,0,1,0,0,0,0,63753,26124),
(108125,'','If you don\'t have any leylight shards on you, I\'m afraid I can\'t finish the ritual.$b$bMaybe you left some in your bank?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108126,'Do not think... the future will be so easy.','',0,0,0,0,0,0,0,0,0,0,58448,0,26124),
(108127,'I heard you might have a tome I\'m looking for.','I heard you might have a tome I\'m looking for.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108128,'Ah, yes, I know the one. It should be on one of the shelves upstairs. Feel free.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108129,'I haven\'t exploded anybody yet today. It\'s a good day!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108130,'Hmm... you didn\'t see any nuclear bombs on your way in, did you? No? Alright, I\'ll keep looking.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108131,'This Oshenko fella\' is always using \"screwdrivers\" on his screws. Hasn\'t he ever heard of a hammer?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108132,'As a retribution paladin you are a stalwart protector of the weak, a bringer of punishment to the unjust!','',0,0,0,0,0,0,0,0,0,0,59973,0,26124),
(108133,'Use Judgment on this target dummy.','',0,0,0,0,0,0,0,0,0,0,59974,0,26124),
(108134,'Musken will trample your bones to dust!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108135,'Bears will rend the flesh from your bones!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108136,'You\'ve been detected!','You\'ve been detected!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108137,'Musken! Bless me with fortitude!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108138,'Ha! Musken prove to be the strongest once again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108139,'I am disgraced.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108140,'Crushed under hoof!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108141,'More! Bring me more to crush!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108142,'Glory in battle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108143,'','Stay in the shadows to avoid detection. The Kirin Tor are no fools.',0,0,0,0,0,0,1,0,0,0,0,63748,26124),
(108144,'Looting','Looting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(108145,'Bjorn! Bless me with savagery!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108146,'Ha! Bears prove to be the strongest once again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108147,'I am disgraced.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108148,'Torn by claws!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108149,'More! Bring me more to rip apart!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108150,'Glory in battle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108151,'[PH] You are about to drop Poop, get out of the raid!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(108152,'','The captain will have my head if I do not return soon...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108153,'','Yes, citizen?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108154,'','State your business, or move along. I am expecting someone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108155,'','Finally, the diamond stabilizers we commissioned. Maybe now the power conduits will stop shorting out.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108156,'','My sparring partner Naltethis told me what you did. You would make a good soldier.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108157,'I have your package from Lespin.','I have your package from Lespin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108158,'','Eyir! Witness my deeds as I slice down this so-called champion.',0,0,0,0,0,0,0,0,0,39396,0,0,26124),
(108159,'Millenia without so much as a barge to log, and now I am up to my ears in manifests and shipping records.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108160,'Make it quick. The seas wait for no one.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108161,'I am busier now than I have been in almost ten thousand years. What do you want with me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108162,'Excellent, my gold pin is here. After all, an illustrious official deserves an equally illustrious badge of office, does he not?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108163,'I have seen Anastae\'s newest coat. Tell me, are you going to be getting more pelts? I will pay you more than what you are currently making running errands for Lespin.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108164,'','There are those among the Valkyra who wish to test you in single combat. Go to Skold-Ashil and face them in battle. None shall attack until you strike the first blow.',0,0,0,0,0,0,0,0,0,0,0,60072,26124),
(108165,'My birds sing such lovely songs.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108166,'What a lovely day.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108167,'\'Borrowing\'','\'Borrowing\'',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(108168,'You have something for me, yes?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108169,'Ah, what a beautiful perch. A perfect replacement for the broken one.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108170,'Lespin is reaching the end of his usefulness, I think. You would be wise to be careful.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108171,'','I go... to the halls... of valor.',0,0,0,0,0,0,0,0,0,39396,0,0,26124),
(108177,'Reveal yourself!','Reveal yourself!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108178,'Archmage Celindra must not be disturbed!','Archmage Celindra must not be disturbed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108179,'','I definitely heard something. Don\'t worry, Archmage, I\'ll find them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108180,'I heard it, too, Archmage. I will expel them at once!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108181,'There you are!','There you are!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108182,'','My wards detected someone entering the study. Find them at once!',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(108183,'','Champion! Know that you face Bretta, the herald of your doom.',0,0,0,0,0,0,0,0,0,39396,0,0,26124),
(108184,'<Hand the Rune of Portals to Val\'zuun.>','<Hand the Rune of Portals to Val\'zuun.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108185,'Excellent... you will find Akaari in the Legerdemain Lounge.','',0,0,0,0,0,0,1,0,0,0,63730,0,26124),
(108186,'','Let us have a glorious battle.',0,0,0,0,0,0,0,0,0,39396,0,0,26124),
(108187,'','I shall claim the honor of your death.',0,0,0,0,0,0,0,0,0,39396,0,0,26124),
(108188,'','I shall stain this ground with your blood.',0,0,0,0,0,0,0,0,0,39396,0,0,26124),
(108189,'','Akaari... your time has come.',0,0,0,0,0,0,1,0,0,0,0,63751,26124),
(108190,'','Eyir... guide me to your side.',0,0,0,0,0,0,0,0,0,39396,0,0,26124),
(108191,'','I go to face my destiny...',0,0,0,0,0,0,0,0,0,39396,0,0,26124),
(108192,'','Only the greatest of the Valkyra are worthy of Eyir\'s gift.',0,0,0,0,0,0,0,0,0,0,0,60073,26124),
(108193,'','The three fallen brothers of God-King Skovald have arisen. Find them, champion, and remind them why they should stay dead.',0,0,0,0,0,0,0,0,0,0,0,60077,26124),
(108194,'','Four brothers. Each raised a hand in slaying his father. Each raised a hand in slaying each other. And so Skovald became king, for his blade was the fastest.',0,0,0,0,0,0,0,0,0,0,0,60076,26124),
(108195,'','The lounge is secure, $p.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108196,'','All clear, $p.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108197,'','Akaari retreated upstairs as we arrived. She\'s all yours.',0,0,0,0,0,0,396,0,0,0,0,63750,26124),
(108200,'','I should thank you. You\'ve saved me the effort of finding you.',0,0,0,0,0,0,396,0,0,0,0,63705,26124),
(108201,'','Kil\'jaeden will be pleased when I bring him your head.',0,0,0,0,0,0,0,0,0,0,0,63700,26124),
(108202,'','You think my master so foolish...?',0,0,0,0,0,0,0,0,0,0,0,63701,26124),
(108203,'There is snake-man in next room. Big snake-man.$b$bGrash can smell the fish-breath.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108204,'Everyone\'s ready, Grash. Smash the ice wall!','Everyone\'s ready, Grash. Smash the ice wall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108205,'I will drag you and your pets into the ocean depths.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108206,'Muster your defenses mortal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108207,'Join me in the depths.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108208,'Drowning. I am drowning.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108209,'Another soul soon joins us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108210,'Lay still and let the water take you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108211,'Death comes quickly to the weak.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108212,'Another takes its place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108213,'You begin to irritate me mortal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108214,'Your death will be slow and savored.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108216,'','Do you have the fangs?',0,0,0,0,0,0,0,0,0,0,0,63749,26124),
(108220,'','Val\'zuun, I will be your death!',0,0,0,0,0,0,0,0,0,0,0,63754,26124),
(108221,'','One by one, you will all fall to the Fangs.',0,0,0,0,0,0,0,0,0,0,0,63702,26124),
(108222,'','Kirel volosh!',0,0,0,0,0,0,0,0,0,0,0,63703,26124),
(108223,'','Miserable worm. Die!',0,0,0,0,0,0,0,0,0,0,0,63704,26124),
(108224,'','I strike from the shadows.',0,0,0,0,0,0,0,0,0,0,0,63706,26124),
(108225,'Something is near. Something big.','',0,0,0,0,0,0,1,0,0,0,60692,0,26124),
(108226,'Stop! Stop! I did not know! I swear it!','',0,0,0,0,0,0,0,0,0,0,63742,0,26124),
(108227,'I can still help you! I can take you to Akaari\'s stronghold!','',0,0,0,0,0,0,0,0,0,0,63743,0,26124),
(108228,'Judgment can be used on enemies at a distance or up close whenever it is available.','',0,0,0,0,0,0,0,0,0,0,59975,0,26124),
(108229,'Use Blade of Justice on this target dummy.','',0,0,0,0,0,0,0,0,0,0,59976,0,26124),
(108230,'Yes, Lord Xavius! I\'ll be happy to tear them apart in your name!','',0,0,0,0,0,0,0,0,0,0,69784,0,26124),
(108231,'AAARRRRGGGHHHH!!! THE CLAWS! THEY THIRST FOR BLOOD!!','',0,0,0,0,0,0,0,0,0,0,62309,0,26124),
(108232,'Blade of Justice is an excellent tool to deal damage as your opponent approaches.','',0,0,0,0,0,0,0,0,0,0,59977,0,26124),
(108233,'Use Crusader Strike on this target dummy.','',0,0,0,0,0,0,0,0,0,0,59978,0,26124),
(108247,'Are you ready to begin?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(108248,'Open the portal.','Open the portal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108249,'Thank you for seeing reason.','',0,0,0,0,0,0,0,0,0,0,63731,0,26124),
(108250,'Ered\'achor, shudas\'urzul... kurai.','',0,0,0,0,0,0,1,0,0,0,63732,0,26124),
(108251,'','Good luck on the Trials, champion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108252,'','For the Alliance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108253,'My musken will trample your tiny bear!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(108254,'The puny one has great beasts!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108255,'I\'ll drag your beasts to Helheim to join Helya\'s cursed stable!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108256,'Sleep lightly, no beast eludes me long...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108257,'It is done. The way to Shadowgore Citadel is open.','',0,0,0,0,0,0,1,0,0,0,63733,0,26124),
(108258,'You feel a foreboding presence - you are not welcome here.','You feel a foreboding presence - you are not welcome here.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(108259,'Move out and support the Farseer! Show the Firelands the strength of the Earthen Ring!','',0,0,0,0,0,0,1,0,0,0,66843,0,26124),
(108260,'','Cleanse the staff, my children. I will keep the beast at bay!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108261,'','Quickly, hero! Our work is nearly complete. You must give me the staff!',0,0,0,0,0,0,0,0,0,0,0,62215,26124),
(108262,'I was hopin\' for a warm welcome... but this ain\'na what I had in mind!','',0,0,0,0,0,0,5,0,0,0,66841,0,26124),
(108263,'','The Farseer approaches! Let\'s show these blasted bugs what we\'re made of!',0,0,0,0,0,0,396,0,0,0,0,66845,26124),
(108264,'The Earthen Ring stands with you, Farseer!','',603,0,0,0,0,0,0,0,0,0,66842,0,26124),
(108265,'Demons besiege my peak! We need your skills in battle, champion.','',0,0,0,0,0,0,0,0,0,0,60082,0,26124),
(108266,'Well done. You have given us the edge we need against these foul creatures. You have my thanks, mortal!','',0,0,0,0,0,0,0,0,0,0,60083,0,26124),
(108267,'Hail, friend. The drekirjar filth continue to slay and enslave my kin. Come, fly with me, and together we shall heap vengeance upon Hrydshal!','',0,0,0,0,0,0,0,0,0,0,60088,0,26124),
(108268,'Would that we could level all of Hrydshal in one fell swoop! Alas, vengeance must come in waves.','',0,0,0,0,0,0,0,0,0,0,60089,0,26124),
(108269,'<Give Lyessa the staff>.','<Give Lyessa the staff>.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108270,'Put your backs into it! Let the heat of combat fuel your resolve!','',0,0,0,0,0,0,1,0,0,0,66844,0,26124),
(108271,'$n. I\'m just checking in before I return to the Fel Hammer.\n\nIf there\'s a mission you\'d rather I go on, I await your orders.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108273,'','Your presence is requested in the Halls of Valor. Are you ready?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108274,'Take me to the Halls of Valor.','Take me to the Halls of Valor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108275,'|TInterface\\Icons\\ability_felarakkoa_feldetonation_red:20|t %s gains |cFFFF0000|Hspell:206221|h[Empowered Bonds of Fel]|h|r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(108276,'|TInterface\\Icons\\Spell_Fire_FelFlameStrike:20|t %s gains |cFFFF0000|Hspell:206220|h[Empowered Liquid Hellfire]|h|r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108277,'|TInterface\\Icons\\inv_misc_trinket6oih_orb1:20|t %s gains |cFFFF0000|Hspell:211152|h[Empowered Eye of Gul\'dan]|h|r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108279,'|TInterface\\Icons\\Spell_Shadow_MindRot:20|t %s summons $n for aid|h|r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108280,'Now, let\'s destroy the rest of these demons!','Now, let\'s destroy the rest of these demons!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108281,'','Have you come to be judged?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108282,'','Let us see if those you have brought are worthy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108283,'','These trials are not to be taken lightly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108284,'','The hunting ground awaits.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108285,'','Death should not be feared.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108286,'Their numbers seem endless, but we will prevail.','Their numbers seem endless, but we will prevail.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108287,'','Life is fleeting.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108288,'','Only greatness endures.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108289,'','There is another.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108290,'','That was your best attack? Honestly?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108291,'Hey $n! Yeah, you! Ignore all that blah about cleansing the land for now and kill this big guy over here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108292,'I think Jace likes his toys a bit too much.','I think Jace likes his toys a bit too much.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108293,'Don\'t get used to this.$b$bAs soon as we finish up with this construction gig we\'re clearing out of here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108294,'','Odyn\'s hunting grounds contain the all manner of great beasts. Let us see if any of your creatures are worthy to be counted among them.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108295,'','Though your beasts have been proven worthy, it is not their time to join our ranks. They are destined to enjoy many more glorious battles.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108296,'Hey, you\'re not supposed to be in here!$b$bLook, we don\'t have the insurance and you\'re a liability.$b$bI\'m gonna have to ask you to leave.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108297,'Akaari is just across the citadel from you. With your skill, you should be able to reach her undetected.','',0,0,0,0,0,0,0,0,0,0,63744,0,26124),
(108298,'Think you could get me out of here?','Think you could get me out of here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108299,'Hey, you\'re not supposed to be here!$b$bLook, we don\'t have the insurance to cover you and you being here is a liability. I bet you\'re already stuck even!$b$bI\'m going to spring you out but do yourself a favor and let us finish before you go exploring again, alright?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108300,'Got it, thanks.','Got it, thanks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108301,'Everything you love will burn!','',0,0,0,0,0,0,0,0,0,0,58457,0,26124),
(108302,'I will shatter your world!','',0,0,0,0,0,0,0,0,0,0,58458,0,26124),
(108303,'I\'ll pound you to dust!','',0,0,0,0,0,0,0,0,0,0,58459,0,26124),
(108304,'You will break...','',0,0,0,0,0,0,0,0,0,0,58460,0,26124),
(108305,'Laughable! A wonder this world survived so long.','',0,0,0,0,0,0,0,0,0,0,58461,0,26124),
(108306,'','I think you\'re ready for more!',0,0,0,0,0,0,0,0,0,0,0,58407,26124),
(108307,'','Shall we raise the stakes?',0,0,0,0,0,0,0,0,0,0,0,58408,26124),
(108308,'You may enter, but spare me your pleas for help, shaman. I know of the Earthen Ring\'s plan to unite the elements!','',0,0,0,0,0,0,0,0,6,0,66825,0,26124),
(108309,'The Burning Legion threatens us all, but the power of the Firelands must be earned.','',0,0,0,0,0,0,0,0,6,0,66997,0,26124),
(108310,'Will your kind never learn?','',0,0,0,0,0,0,0,0,0,0,58462,0,26124),
(108311,'Approach my throne and we shall see just how far you will go to save this world!','',0,0,0,0,0,0,0,0,6,0,66998,0,26124),
(108312,'','Feel the fury of a thousand blades!',0,0,0,0,0,0,0,0,0,0,0,58409,26124),
(108313,'','Behold a true mistress of the blade!',0,0,0,0,0,0,0,0,0,0,0,58410,26124),
(108314,'','Prepare for the deepest cut of all!',0,0,0,0,0,0,0,0,0,0,0,58411,26124),
(108315,'','It would be unfair for me to have all the fun...',0,0,0,0,0,0,0,0,0,0,0,58412,26124),
(108316,'','Teach these upstarts a lesson, my minions!',0,0,0,0,0,0,0,0,0,0,0,58413,26124),
(108317,'','Amateurs! You are your own worst enemies!',0,0,0,0,0,0,0,0,0,0,0,58414,26124),
(108318,'','Watch your footing! I\'d hate to see you slip up.',0,0,0,0,0,0,0,0,0,0,0,58415,26124),
(108319,'','I give you a chance for glory, and you make a mess of it!',0,0,0,0,0,0,0,0,0,0,0,58416,26124),
(108320,'','I must... concede...',0,0,0,0,0,0,0,0,0,0,0,58417,26124),
(108321,'','Consider this a lesson in swordplay!',0,0,0,0,0,0,0,0,0,0,0,58418,26124),
(108322,'','You cannot hope to match my skill!',0,0,0,0,0,0,0,0,0,0,0,58419,26124),
(108323,'','How fortunate they were to face so skilled a foe! I would envy them... if they weren\'t all dead.',0,0,0,0,0,0,0,0,0,0,0,58420,26124),
(108324,'','How surprising... another kill for me!',0,0,0,0,0,0,0,0,0,0,0,58421,26124),
(108325,'','Let your fates be bound together!',0,0,0,0,0,0,0,0,0,0,0,58422,26124),
(108326,'','Feel the icy grip of defeat!',0,0,0,0,0,0,0,0,0,0,0,58423,26124),
(108327,'','You have my attention!',0,0,0,0,0,0,0,0,0,0,0,58424,26124),
(108328,'','I\'m coming for you!',0,0,0,0,0,0,0,0,0,0,0,58425,26124),
(108329,'','Death comes from above!',0,0,0,0,0,0,0,0,0,0,0,58426,26124),
(108330,'','A bit of magic could make this more interesting!',0,0,0,0,0,0,0,0,0,0,0,58427,26124),
(108331,'','Time to clear away the debris!',0,0,0,0,0,0,0,0,0,0,0,58428,26124),
(108332,'','I control this battlefield!',0,0,0,0,0,0,0,0,0,0,0,58429,26124),
(108333,'|TInterface\\Icons\\INV_Misc_Rune_10:20|t Shatter the runestone to interrupt Runeseer Faljar\'s |cFFFF0404|Hspell:208544|h[Runic Bulwark]|h|r!','|TInterface\\Icons\\INV_Misc_Rune_10:20|t Shatter the Empowered Runestone to interrupt Runeseer Faljar\'s |cFFFF0404|Hspell:208544|h[Runic Bulwark]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108334,'Using Blade of Justice and Crusader Strike in combat builds up Holy Power.','',0,0,0,0,0,0,0,0,0,0,59979,0,26124),
(108335,'Build up Holy Power by using your attacks, then use Templar\'s Verdict on this target dummy.','',0,0,0,0,0,0,0,0,0,0,59980,0,26124),
(108338,'DO NOT LOCALIZE','DO NOT LOCALIZE',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108339,'Emberscar has awakened and thirsts for souls. Defeat the Cinderweb Ambushers!','',0,0,0,0,0,0,0,0,17,0,0,0,26124),
(108340,'The master has returned! We must ensure the household is immaculate.','',0,0,0,0,0,0,0,0,0,0,58331,0,26124),
(108341,'That\'s not the master, imbecile! Unless he managed to claw his way out from under two tons of solid stone.','',0,0,0,0,0,0,0,0,0,0,58332,0,26124),
(108342,'Ooo, that would be impressive... considering I still have his hands in a jar.','',0,0,0,0,0,0,0,0,0,0,58333,0,26124),
(108343,'Please don\'t say such things! The master is back, and things need to be kept tidy.','',0,0,0,0,0,0,0,0,0,0,58334,0,26124),
(108344,'You\'re tracking mud everywhere!','',0,0,0,0,0,0,0,0,0,0,58335,0,26124),
(108345,'Did you receive satisfactory service?','',0,0,0,0,0,0,0,0,0,0,58336,0,26124),
(108346,'Have a bite master, I know it\'s your favorite.','',0,0,0,0,0,0,0,0,0,0,58337,0,26124),
(108347,'%s writhes in agony.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108348,'You dare leave crumbs on my floor?! Die!!!','',0,0,0,0,0,0,0,0,0,0,58338,0,26124),
(108349,'Filthy, filthy, filthy!!!','',0,0,0,0,0,0,0,0,0,0,58339,0,26124),
(108350,'Hold still, master, for incineration!','',0,0,0,0,0,0,0,0,0,0,58340,0,26124),
(108351,'Stop squirming! Makes it hard to stab you!','',0,0,0,0,0,0,0,0,0,0,58341,0,26124),
(108352,'So good to see you master, how may I sever you?','',0,0,0,0,0,0,0,0,0,0,58342,0,26124),
(108353,'%s winces and mumbles incoherently.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108354,'Welcome home master, may I take your... HEAD!!!','',0,0,0,0,0,0,0,0,0,0,58343,0,26124),
(108355,'Well done, Farseer. Emberscar is mine and those who opposed my rule lay silenced!','',0,0,0,0,0,0,0,0,0,0,66999,0,26124),
(108356,'Master, is that you?! I barely recognized you with your head attached.','',0,0,0,0,0,0,0,0,0,0,58344,0,26124),
(108357,'Can you please die without making such a mess?!','',0,0,0,0,0,0,0,0,0,0,58345,0,26124),
(108358,'How dare you track blood across my floor!','',0,0,0,0,0,0,0,0,0,0,58346,0,26124),
(108359,'As a symbol of my allegiance, I shall send my servant Scaldius to aid the Earthen Ring.','',0,0,0,0,0,0,0,0,0,0,67000,0,26124),
(108360,'You look famished, master. Please, have some refreshments.','',0,0,0,0,0,0,0,0,0,0,58347,0,26124),
(108361,'Well struck sir, right in my pain cluster.','',0,0,0,0,0,0,0,0,0,0,58348,0,26124),
(108362,'I\'m not sure what I\'ve done, but I\'m positive I deserve this beating.','',0,0,0,0,0,0,0,0,0,0,58349,0,26124),
(108363,'Pain is an effective teacher, and I endeavor to learn your lesson, master.','',0,0,0,0,0,0,0,0,0,0,58350,0,26124),
(108364,'Apologies for the mess, master. I shall tidy up immediately.','',0,0,0,0,0,0,0,0,0,0,58351,0,26124),
(108365,'The Burning Legion shall tremble before the terror of the Firelord!','',0,0,0,0,0,0,0,0,0,0,67001,0,26124),
(108366,'Tread carefully in my domain, shaman. Even Farseers can burn...','',0,0,0,0,0,0,0,0,0,0,66838,0,26124),
(108367,'Oh, my head... where am I?','',0,0,0,0,0,0,0,0,0,0,62423,0,26124),
(108368,'The Firelands is the most fearsome of the elemental planes. We should tread lightly and respect our surroundings here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108369,'Eye of Xirus looks in your direction!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108370,'Eye of Xirus spots you and runs to its allies for help!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108371,'Greetings, Master $n. How are you today?','Greetings, Master $n. How are you today?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108372,'It is now, among the darkness, that the light shines most brilliantly.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108373,'Everyone is worried about the Legion, but we believe in you, Master.','Everyone is worried about the Legion, but we believe in you, Master.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108374,'It is good to see you, Master. You put us all in good spirits.','It is good to see you, Master. You put us all in good spirits.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108375,'The Order of the Broken Temple will survive under your leadership. It must...','The Order of the Broken Temple will survive under your leadership. It must...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108376,'Where are you off to today, Master?','Where are you off to today, Master?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108377,'Our efforts are going to pay off, I know it.','Our efforts are going to pay off, I know it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108378,'We cannot give up the fight, Master. I trust your judgment completely.','We cannot give up the fight, Master. I trust your judgment completely.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108379,'To be a monk is to strive for harmony and balance. There is no one better to lead us than you, $n.','To be a monk is to strive for harmony and balance. There is no one better to lead us than you, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108380,'The estate is gorgeous, is it not? Simply walking the grounds brings me peace.','The estate is gorgeous, is it not? Simply walking the grounds brings me peace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108381,'I tell myself I will socialize at these parties, but I always end up lingering about the desserts.','I tell myself I will socialize at these parties, but I always end up lingering about the desserts.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108382,'Yes, my costume IS the most fabulous. Thank you for noticing.$B$BIt hardly matters that I cannot move.','Yes, my costume IS the most fabulous. Thank you for noticing.$B$BIt hardly matters that I cannot move.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108383,'Ugh, I heard someone else came as an owl.$B$BWell, ONE OF US will have to change...','Ugh, I heard someone else came as an owl.$B$BWell, ONE OF US will have to change...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108384,'Quite the... unique... costume you have there.','Quite the... unique... costume you have there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108385,'Security here is much tighter since the barrier went down. We cannot just let in any riff-raff, now can we?','Security here is much tighter since the barrier went down. We cannot just let in any riff-raff, now can we?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108386,'Is that... an outlander costume beneath your normal costume?$B$BGenius!','Is that... an outlander costume beneath your normal costume?$B$BGenius!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108387,'<Sigh.>$B$BI thought for sure I would have the most exotic costume this time, but it seems I have been outdone once again.','<Sigh.>$B$BI thought for sure I would have the most exotic costume this time, but it seems I have been outdone once again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108388,'Make it quick - my costume looks more elegant in motion.','Make it quick - my costume looks more elegant in motion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108389,'Did anyone ever find Thalyssra\'s body?','Did anyone ever find Thalyssra\'s body?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108390,'<Scoff.> Demons. Am I right? <Roll your eyes.>','<Scoff.> Demons. Am I right? <Roll your eyes.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108391,'Warlocks are not known to be trustworthy. What if Gul\'dan betrays us?','Warlocks are not known to be trustworthy. What if Gul\'dan betrays us?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108392,'How can we be free in the Legion\'s shadow?','How can we be free in the Legion\'s shadow?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108393,'How do you do, fellow Nightborne?','How do you do, fellow Nightborne?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108394,'<Just wink a lot.>','<Just wink a lot.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108395,'Is there nobody left who will stand up to Elisande?','Is there nobody left who will stand up to Elisande?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108396,'What if we tried not watching the world burn? Just for once, to see if we like it.','What if we tried not watching the world burn? Just for once, to see if we like it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108397,'What was that?','What was that?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108398,'Hmm?','Hmm?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108399,'Reveal yourself.','Reveal yourself.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108400,'I thought I heard something.','I thought I heard something.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108401,'Shadowgore Stalker growls.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108402,'Shadowgore Stalker sniffs the air excitedly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108403,'Shadowgore Stalker\'s hairs bristle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108404,'Shadowgore Stalker perks up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108405,'Excuse me while I pretend we never met.','Excuse me while I pretend we never met.',0,0,0,0,0,0,0,0,0,39475,0,0,26124),
(108406,'Curious...','Curious...',0,0,0,0,0,0,0,0,0,39475,0,0,26124),
(108407,'You know, the Magistrix has spies everywhere.','You know, the Magistrix has spies everywhere.',0,0,0,0,0,0,0,0,0,39475,0,0,26124),
(108408,'This conversation is boring me.','This conversation is boring me.',0,0,0,0,0,0,0,0,0,39475,0,0,26124),
(108409,'Hm. Yes. Fascinating.','Hm. Yes. Fascinating.',0,0,0,0,0,0,0,0,0,39475,0,0,26124),
(108410,'Scandalous!','Scandalous!',0,0,0,0,0,0,0,0,0,39475,0,0,26124),
(108411,'Who let you in here?','Who let you in here?',0,0,0,0,0,0,0,0,0,39475,0,0,26124),
(108412,'','Try to keep up.',0,0,0,0,0,0,0,0,0,0,0,63710,26124),
(108413,'','You were dead the moment you arrived here.',0,0,0,0,0,0,0,0,0,0,0,63709,26124),
(108414,'','Enough!',0,0,0,0,0,0,0,0,0,0,0,63711,26124),
(108415,'','Take them to the holding cell. Lord Kil\'jaeden will be most pleased.',0,0,0,0,0,0,0,0,0,0,0,63712,26124),
(108416,'Send reinforcements north of Crossroads! Tower\'s under attack! We\'re surrounded!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(108417,'A full-body outlander transformation? Ghastly.','A full-body outlander transformation? Ghastly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108418,'What kind of costume is THAT? I cannot be seen with you.','What kind of costume is THAT? I cannot be seen with you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108419,'Put on a proper costume or I will have you thrown out.','Put on a proper costume or I will have you thrown out.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108420,'Thank you! When this is over you\'ll have to come back and fish sometime!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108421,'When you deliver the letter, please give Prin... King Anduin my condolences.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(108422,'These ancient stones have not been animated in eons. Once again you must be tested. Place your hand on the stone and prepare.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108423,'Eyir has taken notice of your deeds. Be careful to not disappoint.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108424,'Skywall is truly a wondrous place, $n. I have seen nothing like it in all my life.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108425,'Wet!','',0,0,0,0,0,0,0,0,0,0,60693,0,26124),
(108426,'','NO ONE can be allowed to become a Felsworn traitor working for the Legion.',0,0,0,0,0,0,0,0,0,0,0,58352,26124),
(108427,'','Thank you, $pc. I am Stellagosa.',0,0,0,0,0,0,0,0,0,0,0,58353,26124),
(108428,'','Prepare yourselves, minions. Our lord requires us on the field of battle.',0,0,0,0,0,0,0,0,0,0,0,63707,26124),
(108429,'','Our enemies will feel the fangs\' agonizing bite! They will all perish!',0,0,0,0,0,0,0,0,0,0,0,63708,26124),
(108430,'Tread lightly, lest you prefer to be my beast\'s dinner.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108431,'You\'re a true alpha.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108432,'','Zithreen is trying to crush us beneath the waves!',0,0,0,0,0,0,5,0,0,0,0,60694,26124),
(108433,'Shaman, lead Grash forward. He can act as a breakwater for us.','',0,0,0,0,0,0,25,0,0,0,60695,0,26124),
(108434,'I won\'t say it again! Get... off... my... dock!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108435,'You\'ll never board one of my ships, demon! Not while I\'m alive!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108436,'','Move out, armies of Kil\'jaeden! Glory awaits!',0,0,0,0,0,0,0,0,0,0,0,63713,26124),
(108437,'That jailer presents an opportunity for your escape.','',0,0,0,0,0,0,0,0,0,0,63745,0,26124),
(108438,'Use |TInterface\\Icons\\inv_misc_bag_10_red.blp:20|t |cFFFF0000|Hspell:185438|h[Pick Pocket]|h|r to escape!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(108439,'','Come to visit ol\' Scowling Rosa, have you?$B$BWhat can I do for you hun?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108440,'','Once again the accursed mists creep in from the sea. Venture forth and vanquish the kvaldir there before their darkness spreads further.',0,0,0,0,0,0,0,0,0,0,0,60092,26124),
(108441,'','The Tideskorn earned their name the day the mists took their greatest harbor. Since then, no vrykul loyal to Odyn has willingly entered that cursed place.',0,0,0,0,0,0,0,0,0,0,0,60093,26124),
(108442,'I hear you might be selling something I\'m looking for...','I hear you might be selling something I\'m looking for...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108443,'Psst. Table behind the house. Lady Ly\'leth is waiting for you.','Psst. Table behind the house. Lady Ly\'leth is waiting for you.',0,0,0,0,0,0,0,0,0,39476,0,0,26124),
(108444,'My mistress! The prisoner has escaped!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108445,'','Xirus, deal with them. We have nearly made contact.',0,0,0,0,0,0,0,0,0,0,0,63714,26124),
(108446,'Fool! He comes...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108447,'An entire plane of existence, dedicated to the element of Air. It is truly wondrous...','',0,0,0,0,0,0,669,0,0,0,67002,0,26124),
(108448,'Xirus is here. Run!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108449,'I have seen nothing like it on my own world. I wonder if such a place exists beyond Azeroth?','',0,0,0,0,0,0,669,0,0,0,67003,0,26124),
(108450,'','Get out while you still can!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108451,'I do not envy you, $n. To lead our order through this crisis must weigh heavily on your shoulders.','',0,0,0,0,0,0,669,0,0,0,67004,0,26124),
(108452,'When the Burning Legion invaded Draenor, I failed to save my people... to save my home.','',0,0,0,0,0,0,669,0,0,0,67005,0,26124),
(108453,'We must unite the elements to our cause... else our worlds share the same fate.','',0,0,0,0,0,0,669,0,0,0,67006,0,26124),
(108454,'The Heart of Skywall holds the power to recharge the blade.','',0,0,0,0,0,0,669,0,0,0,67007,0,26124),
(108455,'We should continue onward with great haste!','',0,0,0,0,0,0,669,0,0,0,67008,0,26124),
(108456,'Thanks!','Thanks!',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(108457,'These are dark times, $n, but you must never lose hope.','',0,0,0,0,0,0,669,0,0,0,67009,0,26124),
(108458,'There was a time when I wandered the wastes of my world, hopeless and broken.','',0,0,0,0,0,0,669,0,0,0,67010,0,26124),
(108459,'It was in my darkest hour, that the elements called out to me.','',0,0,0,0,0,0,669,0,0,0,67011,0,26124),
(108460,'You too will be guided, Farseer. You need only listen.','',0,0,0,0,0,0,669,0,0,0,67012,0,26124),
(108461,'The Staff of Four Winds is almost complete. We must move swiftly, much is at stake.','',0,0,0,0,0,0,669,0,0,0,67013,0,26124),
(108462,'The elements here are in a state of total chaos... they require a Windlord to guide them.','',0,0,0,0,0,0,669,0,0,0,67014,0,26124),
(108463,'It is time, $n. We have all that we need to resurrect Prince Thunderaan. We must hurry.','',0,0,0,0,0,0,669,0,0,0,67015,0,26124),
(108464,'None can escape my gaze...','',0,0,0,0,0,0,0,0,0,0,63755,0,26124),
(108465,'','I... I\'m alive! By the Light, I live again!',0,0,0,0,0,0,0,0,0,0,0,62461,26124),
(108466,'','Help! Please...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108467,'','They came outta nowhere! Mind lending me a hand?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108468,'What are you doing in here? Can\'t you see I am busy preparing meals that will astonish and delight!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108469,'I must get back to my cooking!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108470,'Finally. Now, back to my preparations.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108471,'I cannot work in these conditions!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108472,'If you can\'t take the heat...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108473,'Get out of the kitchen!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108474,'I herald your endless torment.','',0,0,0,0,0,0,0,0,0,0,63756,0,26124),
(108475,'I have superior ingredients!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108476,'Everyone is a critic.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108477,'Smells awful.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108478,'I have to recheck the recipe.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108479,'The snake witch. She is inside.$b$bGrash is... afraid.$b$bThe snake witch will try to control Grash with her magic stick.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108480,'No trespassers allowed!','',0,0,0,0,0,0,0,0,0,0,58627,0,26124),
(108481,'I promise to protect you, Grash. Smash your way inside!','I promise to protect you, Grash. Smash your way inside!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108482,'That should teach you!','',0,0,0,0,0,0,0,0,0,0,58631,0,26124),
(108483,'Just what you deserved!','',0,0,0,0,0,0,0,0,0,0,58632,0,26124),
(108484,'My watch... is ended.','',0,0,0,0,0,0,0,0,0,0,58628,0,26124),
(108485,'A job well done!','',0,0,0,0,0,0,0,0,0,0,58635,0,26124),
(108486,'I need reinforcements!','',0,0,0,0,0,0,0,0,0,0,58636,0,26124),
(108488,'This will even the odds!','',0,0,0,0,0,0,0,0,0,0,58629,0,26124),
(108489,'Basely done... cowards!','',0,0,0,0,0,0,0,0,0,0,58630,0,26124),
(108490,'Stay where you are!','',0,0,0,0,0,0,0,0,0,0,58633,0,26124),
(108491,'You will face many dangerous situations, and preparation can be the key to your survival.','',0,0,0,0,0,0,0,0,0,0,59982,0,26124),
(108492,'Use Divine Shield to make yourself temporarily invulnerable to all damage!','',0,0,0,0,0,0,0,0,0,0,59983,0,26124),
(108493,'This is only the beginning.','',0,0,0,0,0,0,0,0,0,0,63757,0,26124),
(108494,'The end is inevitable.','',0,0,0,0,0,0,0,0,0,0,63758,0,26124),
(108495,'Welcome the embrace of the twisting dark.','',0,0,0,0,0,0,0,0,0,0,63759,0,26124),
(108496,'The Nightmare consumes me... compels me... to serve... to kill!','',0,0,0,0,0,0,0,0,0,0,58377,0,26124),
(108497,'My sacred gift from the Watchers! Yes, Nightmare Lord... yes... the fury of the Claws must be mine once more!','',0,0,0,0,0,0,0,0,0,0,58380,0,26124),
(108498,'You have released me from the Nightmare. The Claws... have served you well...','',0,0,0,0,0,0,0,0,0,0,58384,0,26124),
(108499,'The Watcher\'s gift is mine once more! No... not mine... it belongs to the Nightmare.','',0,0,0,0,0,0,0,0,0,0,58391,0,26124),
(108500,'I WILL FLATTEN YOU LIKE SAPLINGS!','',0,0,0,0,0,0,0,0,0,0,58385,0,26124),
(108501,'THE WILDS TREMBLE BEFORE MY FURY!','',0,0,0,0,0,0,0,0,0,0,58390,0,26124),
(108502,'RRAAAUUUGHHHH!','',0,0,0,0,0,0,0,0,0,0,58388,0,26124),
(108503,'They will devour your flesh until nothing remains...','',0,0,0,0,0,0,0,0,0,0,63760,0,26124),
(108504,'','Not very clever of you to challenge all of us!',0,0,0,0,0,0,0,0,0,0,0,58638,26124),
(108505,'','Scorched bones... so delightful!',0,0,0,0,0,0,0,0,0,0,0,58647,26124),
(108506,'','More kindling for the bonfire!',0,0,0,0,0,0,0,0,0,0,0,58648,26124),
(108507,'','My funeral pyre... will be... glorious...',0,0,0,0,0,0,0,0,0,0,0,58643,26124),
(108508,'','Looks like I have a roast to prepare!',0,0,0,0,0,0,0,0,0,0,0,58649,26124),
(108509,'','Make yourself useful and take a look around!',0,0,0,0,0,0,0,0,0,0,0,58644,26124),
(108510,'','What are you waiting for? Check out that noise!',0,0,0,0,0,0,0,0,0,0,0,58645,26124),
(108511,'','A great banquet will be held tonight for the city\'s nobles. The chef is having all the Arcwine reserves brought to his kitchen. We need you to distract him while we \"liberate\" as much of it as we can.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108512,'','You! Have a look over there!',0,0,0,0,0,0,0,0,0,0,0,58646,26124),
(108513,'','Excellent! You bought my agents enough time to secure almost all of their Arcwine.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108514,'','Mortal flesh... so pretty when it burns!',0,0,0,0,0,0,0,0,0,0,0,58640,26124),
(108515,'','I\'m feeling positively radiant!',0,0,0,0,0,0,0,0,0,0,0,58641,26124),
(108516,'','It will amuse me to watch you melt!',0,0,0,0,0,0,0,0,0,0,0,58642,26124),
(108517,'','Who needs henchmen? I\'ll burn you myself!',0,0,0,0,0,0,0,0,0,0,0,58639,26124),
(108518,'','I believe my brother Mardranel is prepared to accompany you. Thank you for your help, friend.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108520,'Yowlon purrs quietly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108522,'Divine Shield protected you from the mage\'s first attack, but the second attack has left you wounded.','',0,0,0,0,0,0,0,0,0,0,59984,0,26124),
(108523,'Use Flash of Light to heal your wounds.','',0,0,0,0,0,0,0,0,0,0,59985,0,26124),
(108525,'I had such high hopes for you. An amateur merchant believes that a partner is a valuably ally. A master knows that they are competition and a liability.','',0,0,0,0,0,0,0,0,0,38122,0,0,26124),
(108526,'I always suspected something was amiss with you.','',0,0,0,0,0,0,0,0,0,39512,66067,0,26124),
(108537,'Redhoof carefully digs into the soil with a hoof.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108538,'It appears as though we have arrived, $n. Let us see what Celestos would have us do next.','',0,0,0,0,0,0,669,0,0,0,0,0,26124),
(108539,'Fresh green food grows and your enemies are fewer. We seek only your blessing in return.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108540,'I suppose I should clear away this mess and make room for the new instruments.','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(108541,'Startalon settles and tucks her head under her wing for a moment. She straightens again and offers a dry owl talon out to Mayruna.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108542,'Startalon dips her head in silent thanks and takes to the skies once more.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108544,'Would you be able to repair this flask for me?','Would you be able to repair this flask for me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108545,'Silverfang deposits a shiny, smooth Nightsaber Fang onto the dirt.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108546,'Silverfang lets out a low, passive growl.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108547,'You ask for my help, yet you have nothing to offer in return, $r. If that\'s the case, then perhaps you can do my tribe a favor.$b$bIt\'s been years since we\'ve tasted the Rivermane\'s brew. Their remedy is known to have revitalizing powers and it does wonders for the teeth. And fortunately I happen to know how to brew it.$b$bI\'ll give you my mortar and pestle, along with the recipe for creating the remedy. You bring back enough for my tribe and I\'ll fix your flask.$b$bAgreed?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108548,'Agreed.','Agreed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108550,'','Our efforts were not in vain. The Moonwhisper Matriarch watches from afar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108551,'','May your hunt be ever fruitful, my sister.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108552,'You\'ll find a pumpkin patch at the Rivermane\'s camp. Choose the ripest ones for their juice.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108553,'And foxflower flourishes all around Highmountain. Good luck, $r.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108554,'You fail to amuse me.','',0,0,0,0,0,0,0,0,0,0,62160,0,26124),
(108555,'','No one resists the Nightmare!',0,0,0,0,0,0,0,0,0,0,0,58504,26124),
(108556,'A priest! Thank the Light!','',0,0,0,0,0,0,0,0,0,0,62431,0,26124),
(108557,'','Give yourself over, as I did.',0,0,0,0,0,0,0,0,0,0,0,58505,26124),
(108558,'','At last... the long dream comes.',0,0,0,0,0,0,0,0,0,0,0,58499,26124),
(108559,'Begone mortals! The time of the Windlords has passed!','',0,0,0,0,0,0,53,0,0,0,67016,0,26124),
(108560,'Foolish shaman! You really think that Thunderaan can save your world?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108561,'I will devour you and take the Staff of Four Winds for myself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108562,'','The Nightmare is inescapable.',0,0,0,0,0,0,0,0,0,0,0,58506,26124),
(108563,'Listen well, Farseer... I will aid the Earthen Ring for now.','',0,0,0,0,0,0,0,0,0,0,67017,0,26124),
(108564,'The armies of Skywall shall stand shoulder to shoulder with the mortal races in battle against the Burning Legion.','',0,0,0,0,0,0,0,0,0,0,67018,0,26124),
(108565,'When the fog of battle clears, and the Burning Legion is defeated, we shall stand victorious!','',0,0,0,0,0,0,0,0,0,0,67019,0,26124),
(108566,'','Spirits of the forest! Guardians of nature! Hear our plea!',0,0,0,0,0,0,0,0,0,0,0,62175,26124),
(108567,'','On this day, the mother tree is reborn! G\'Hanir is whole once more!',0,0,0,0,0,0,0,0,0,0,0,62176,26124),
(108568,'Come on, $p, talk with Sternfathom. Let\'s get this fight started!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108569,'AAAAHHHHHHHHhhhh...!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108570,'Let\'s give them a moment to regroup and prepare, $n.\n\nWhen they\'re ready, speak with me again, and I\'ll throw you into the arena to get this fight started.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108571,'What\'re you lookin\' at? Ain\'t ye ever seen a sea lion before?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108572,'Not like this...','Not like this...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108573,'Yes, I\'m a druid and... well... I\'m kind of stuck like this for a while.$b$bWhile patrolling the sea around the Broken Shore, an infernal crashed into the water right on top of me. The blast instantly knocked me unconscious.\n$b$bWhen I woke I was here in the care of the nurses. They say after a few days I should have the strength to shift back. In the meantime, I\'m stuck in this contraption to keep me from drying out.\n$b$bDo me a favor. Don\'t mention this to any of the other druids. They\'ll never let me live it down!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108574,'We shall use the garden entrance.','',0,0,0,0,0,0,0,0,0,0,67506,0,26124),
(108575,'Enchanted masks. Simply don the mask, and a magical costume will envelop your body.','',0,0,0,0,0,0,0,0,0,0,67507,0,26124),
(108576,'I will find Ly\'leth. You stay out of trouble.','',0,0,0,0,0,0,0,0,0,0,67509,0,26124),
(108577,'It should be enough to fool the other guests, but stay clear of the guards.','',0,0,0,0,0,0,0,0,0,0,67508,0,26124),
(108578,'The fangs are within your grasp!','',0,0,0,0,0,0,0,0,0,0,63746,0,26124),
(108579,'Use the signal lantern to alert Ly\'leth Lunastre of your arrival.','Use the signal lantern to alert Ly\'leth Lunastre of your arrival.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(108580,'This lantern appears to have been slightly modified. It must be the one you need to use to send a signal.','This lantern appears to have been slightly modified. It must be the one you need to use to send a signal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108581,'Send a signal to Ly\'leth Lunastre.','Send a signal to Ly\'leth Lunastre.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108582,'','Your arrival is fortuitous. Tonight, the nobles have gathered in honor of the Grand Magistrix.',0,0,0,0,0,0,396,0,0,0,0,70446,26124),
(108583,'','Our spies report that Elisande herself will attend. This presents a rare opportunity to catch her away from her source of power.',0,0,0,0,0,0,396,0,0,0,0,70447,26124),
(108584,'','We\'ll take a side entrance to the grounds... too many eyes are watching the front.',0,0,0,0,0,0,396,0,0,0,0,70448,26124),
(108585,'','You\'ve done well so far, but we must ensure you blend in at the party. I\'ll enhance your disguise, infusing it with latent magic to make you appear as one of the nobles.',0,0,0,0,0,0,396,0,0,0,0,70450,26124),
(108586,'','This is your best chance to eliminate the Grand Magistrix. Good luck!',0,0,0,0,0,0,396,0,0,0,0,70449,26124),
(108587,'','Kill them, you fools! I will not be denied my destiny!',0,0,0,0,0,0,0,0,0,0,0,63715,26124),
(108588,'I... I need fresh air!','',0,0,0,0,0,0,0,0,0,0,62424,0,26124),
(108589,'Among the souls you have rescued, there are some who wish to regain their honor fighting alongside you against the kvaldir.','',0,0,0,0,0,0,0,0,0,0,60094,0,26124),
(108590,'We must not suffer Helya\'s minions to gain territory unfought. Your loyalty shall be rewarded.','',0,0,0,0,0,0,0,0,0,0,60095,0,26124),
(108591,'It\'s over, Zithreen! Tell us... what did Azshara plan to do with this realm?','',0,0,0,0,0,0,5,0,0,0,60702,0,26124),
(108592,'','I will tell you NOTHING!',0,0,0,0,0,0,0,0,0,0,0,60703,26124),
(108593,'Agraaahh!!','',0,0,0,0,0,0,0,0,0,0,60704,0,26124),
(108594,'Well then... I guess... I guess we\'re done talking here.','',0,0,0,0,0,0,6,0,0,0,60705,0,26124),
(108595,'Dead now.','',0,0,0,0,0,0,0,0,0,0,60706,0,26124),
(108596,'Legion ships on the horizon! All forces to Sentinel Hill!','',0,0,0,0,0,0,22,0,0,0,64733,0,26124),
(108597,'Barrem!','',0,0,0,0,0,0,0,0,0,0,62425,0,26124),
(108598,'I greet you, $n. I am glad to help.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108599,'Orik says you can speak to these spirits, how do we begin?','Orik says you can speak to these spirits, how do we begin?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108600,'I misjudged how long ago this happened. I will need more time to prepare myself for the ritual.$b$bIn the meantime, I have attuned this stone to the scroll Orik brought. Certain graves will glow to your mind\'s eye. Go to them and concentrate on the stone to see if you have found the correct grave. We want the writer himself, not a descendent or ancestor.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108601,'The stone grows dull, this is the wrong grave. A relative probably.','The stone grows dull, this is the wrong grave. A relative probably.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108602,'Concentrating','Concentrating',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(108603,'The stone glows brightly, this is the correct grave!','The stone glows brightly, this is the correct grave!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108604,'','Yes, what is it? I am very busy planning my next gala.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108605,'','Oh, you again! I cannot thank you enough for what you did, dear.$b$bI am already hearing good things about the new jeweler. Perhaps I should pay him a visit and get a new piece commissioned...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108606,'I wanted to speak with you about a gem design.','I wanted to speak with you about a gem design.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108607,'Champion, a great malevolence has risen in the mists. Gather your most powerful allies and meet the kvaldir in battle!','',0,0,0,0,0,0,0,0,0,0,60096,0,26124),
(108608,'Even my most loyal vrykul dare not enter the mists for fear of their souls. I commend your bravery, mortal.','',0,0,0,0,0,0,0,0,0,0,60097,0,26124),
(108609,'The tower in the middle o\' Dalaran has a portal to Wyrmrest Temple. Should get ye most o\' the way there. Tahu, thanks again fer helping us paladins.','',1,1,0,2,2,0,1,0,0,0,63278,0,26124),
(108610,'You asked the Sunwalkers for aid, and I have come. May my presence bring success to your quest, Orik.','',1,1,0,2,2,0,1,0,0,0,63279,0,26124),
(108611,'Ye made it! This land haunts me still... so much pain and death. Well, let\'s get on with it.','',1,0,0,0,0,0,1,0,0,0,63277,0,26124),
(108612,'Find them. Akaari will not be disturbed!','',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(108613,'Light give me strength!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108614,'For the Alliance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108615,'Begone foul beast!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108616,'','Are you in need of healing?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108617,'I\'m looking for some Shaldorei Silk. Do you have any to spare?','I\'m looking for some Shaldorei Silk. Do you have any to spare?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108618,'','Why yes, we do. There\'s some on that chest over there. But we\'re in short supply, so please don\'t take too much.',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(108619,'Would you happen to know of a tailor in these parts?','Would you happen to know of a tailor in these parts?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108620,'','A leyweaver from Suramar came through here not too long ago. I believe she headed east towards the Sylvan Falls.',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(108621,'My beasts have been blessed by the Light to enhance their speed and agility. You\'ll not find a swifter ride.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108622,'I\'d like to travel to Dalaran.','I\'d like to travel to Dalaran.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108623,'','Find somewhere safe! I\'ll find you when this is over.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108624,'Those tendrils are using dark magic to become immune to attack. Interrupt their casting so you can strike!','',0,0,0,0,0,0,0,0,0,0,60464,0,26124),
(108625,'I don\'t have time for idle chatter, $n.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108626,'To arms!','To arms!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108627,'If it\'s not too much trouble, could you mend this cloth for me?','If it\'s not too much trouble, could you mend this cloth for me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108629,'What do you want, warlock? Can\'t you see I\'m busy?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108630,'Who summoned all these imps?','Who summoned all these imps?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108631,'','You dare request such a menial task from me? Surely you must be joking.$b$bYou\'re not? I see. Well, I have been away from Suramar for some time now and from the look of you, I take it you\'re an alchemist, yes?$b$bI\'d be willing to trade my services with you for a price that I deem is fair.$b$bI long for an Ysera\'s Dream Draught. It\'s an ancient elven drink. To concoct it, you\'ll need some dreamleaf as well as the leaves of a Dreamer\'s Tear.$b$bOne grows not to far from here in the clearing of some ruins. Take my flask, make this drink for me, and I\'ll do as you ask.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108632,'','You are of no interest to me. I come from an accomplished lineage of Suramar tailors. You, obviously, do not.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108633,'Confess your crimes!','Confess your crimes!',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(108634,'','Hello, leyweaver. What can I do for you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108635,'','How fortuitous! A fellow tailor!$b$bWelcome to the leyweavers\' guild of Suramar. Perhaps you have heard of us?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108636,'','Have you brought me my draughts?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108637,'Here are your draughts.','Here are your draughts.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108638,'Crimes? The only thing I am guilty of is being the most powerful warlock in all of Azeroth!','',0,0,0,0,0,0,603,0,0,0,66500,0,26124),
(108639,'','Yes, this will be sufficient. Now let me see that silk of yours.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108640,'Lespin wants his brooch back.','Lespin wants his brooch back.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108641,'Come minions, aid me in battle against this accuser!','',0,0,0,0,0,0,603,0,0,0,66505,0,26124),
(108642,'Minions...?','',0,0,0,0,0,0,603,0,0,0,66501,0,26124),
(108643,'','Here you are. Now, run along.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108644,'Progress is slow, but steady. I will be back in the good graces of the courts soon, and it is all thanks to you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108645,'He\'s just inside. Please, do whatever you can to save him.','',0,0,0,0,0,0,0,0,0,0,62421,0,26124),
(108646,'What do you want? I have few friends in these dark days. I am prepared to defend myself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108647,'The Fel Magic reacts violently to your spell!','The Fel Magic reacts violently to your spell!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(108648,'We have found you... and you have found the grave.','',0,0,0,0,0,0,0,0,4,0,63280,0,26124),
(108649,'What\'s the next step?','',0,0,0,0,0,0,0,0,4,0,63281,0,26124),
(108650,'I will begin the ritual. Focus your will upon the spirit while our friend keeps us safe.','',0,0,0,0,0,0,1,0,4,0,63282,0,26124),
(108651,'Let\'s get to it!','',0,0,0,0,0,0,1,0,4,0,63283,0,26124),
(108652,'I died to ease the pain of my failure. Why do you disturb me?','',0,0,0,0,0,0,5,0,4,0,63284,0,26124),
(108653,'I\'ve read yer saga. Where did ye find the shield?','',0,0,0,0,0,0,0,0,4,0,63285,0,26124),
(108654,'It seems you compel me to answer... My journey took me to Stormheim, to a tomb of warrior kings.','',0,0,0,0,0,0,1,0,4,0,63286,0,26124),
(108655,'We will finish what ye started.','',0,0,0,0,0,0,0,0,4,0,63289,0,26124),
(108656,'Return to your rest, and be disgraced no more.','',0,0,0,0,0,0,0,0,4,0,63290,0,26124),
(108657,'I\'m coming with you, $n. You helped one of my men, so it\'s only fitting that I return the favor.','',0,0,0,0,0,0,0,0,0,0,62427,0,26124),
(108658,'I\'ll meet you at Krasus\' Landing. We can take my gryphon down to the island.','',0,0,0,0,0,0,0,0,0,0,62428,0,26124),
(108659,'Thanks for yer help, Tahu. I won\'t forget this!','',0,0,0,0,0,0,1,0,4,0,63291,0,26124),
(108660,'It was my honor to serve. I must go to Netherlight Temple and inform the Conclave of our success. Good luck.','',0,0,0,0,0,0,1,0,4,0,63292,0,26124),
(108661,'As for us, we should get back to Dalaran. I\'ll meet ye there!','',0,0,0,0,0,0,0,0,4,0,63293,0,26124),
(108662,'Stop, please! I\'ll pen a confession, assuming you didn\'t break my writing hand...','',0,0,0,0,0,0,603,0,0,0,66499,0,26124),
(108663,'','I foresaw your coming, of course. The threads of fate that led you to this place. Your desperate attempt to stop the Legion.',457,0,0,0,0,0,0,0,0,0,0,58555,26124),
(108664,'','My people faced a similar dilemma. I peered into all possible futures in search of an answer... and found only one.',25,0,0,7,0,0,0,0,0,0,0,58556,26124),
(108665,'','The Legion\'s victory is inevitable. Every time stream shows it to be so. Had we resisted, they would have taken the Nightwell by force and left us bereft of it.',485,0,0,0,0,0,0,0,0,0,0,58557,26124),
(108666,'','I could not allow my people to starve, to waste away without its energies sustaining us. So a bargain was struck.',485,0,0,0,0,0,0,0,0,0,0,58558,26124),
(108667,'','Now I see a future where the Legion is victorious and my people endure. This is the thread that must be preserved. I will do everything in my power to make it so!',603,0,0,9,0,0,0,0,0,0,0,58559,26124),
(108668,'','Your deaths ensure the future of the Nightborne. Come forward, then. Let us speed you toward your fate.',25,0,0,0,0,0,0,0,0,0,0,58560,26124),
(108669,'','Your timelines end here!',0,0,0,0,0,0,0,0,0,0,0,58561,26124),
(108670,'','The threads of time answer to me!',0,0,0,0,0,0,0,0,0,0,0,58562,26124),
(108671,'','Will you race through time? Or be trapped in an endless eternity?',0,0,0,0,0,0,0,0,0,0,0,58563,26124),
(108672,'','Time itself heeds my call!',0,0,0,0,0,0,0,0,0,0,0,58564,26124),
(108673,'','I control the battlefield, not you!',0,0,0,0,0,0,0,0,0,0,0,58565,26124),
(108674,'','Let the waves of time crash over you!',0,0,0,0,0,0,0,0,0,0,0,58566,26124),
(108675,'','You\'ll find time can be quite volatile.',0,0,0,0,0,0,0,0,0,0,0,58567,26124),
(108676,'','You exist in but a single moment. I am far less limited!',0,0,0,0,0,0,0,0,0,0,0,58568,26124),
(108677,'','Time shifts again, and your doom draws near!',0,0,0,0,0,0,0,0,0,0,0,58569,26124),
(108678,'','The time streams are mine to command! You cannot win!',0,0,0,0,0,0,0,0,0,0,0,58570,26124),
(108679,'','Time is... slipping away! How can it be so?',0,0,0,0,0,0,0,0,0,0,0,58571,26124),
(108680,'','Just as I foretold.',0,0,0,0,0,0,0,0,0,0,0,58572,26124),
(108681,'','An inevitable outcome.',0,0,0,0,0,0,0,0,0,0,0,58573,26124),
(108682,'','You were destined to die.',0,0,0,0,0,0,0,0,0,0,0,58574,26124),
(108683,'','It\'s... not possible! I... I was destined to win...',0,0,0,0,0,0,0,0,0,0,0,58575,26124),
(108684,'','I take no joy in this victory, but it was inevitable.',0,0,0,0,0,0,0,0,0,0,0,58576,26124),
(108685,'','In all the possible futures I scryed, I did not foresee one in which you were victorious. I wonder...',0,0,0,0,0,0,485,0,0,0,0,79720,26124),
(108686,'','Will you defeat the Legion? Will you fail? Time eddies about you in fits and starts. Nothing is certain!',0,0,0,0,0,0,691,0,0,0,0,79721,26124),
(108687,'','Perhaps you will win. And in saving your world, my people would be freed from the terrible bargain we were forced to make.',0,0,0,0,0,0,485,0,0,0,0,79722,26124),
(108688,'','Fates be damned! I cast my lot in with yours, champions. Go now, face Gul\'dan. I will aid you as best I can, and perhaps together we can save us all.',0,0,0,0,0,0,691,0,0,0,0,79723,26124),
(108689,'I can see your future mortal.','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(108690,'Want to know the exact time and date of your death?','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(108691,'Just as I foresaw it.','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(108692,'My sight diminishes.','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(108693,'Sacrifices must be made.','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(108694,'All will turn to ash.','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(108695,'I already know your next move.','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(108696,'All answer to their fate.','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(108697,'Your fate betrays you mortal','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(108698,'Hello? Is anyone out there? I can\'t see...','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(108699,'Uh... not me. Definitely not me.\n\nLike I told the guards in Dalaran, it\'s probably the Fizzlebang girl. Just like her brother, always summoning a mess of demons she can\'t control.','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(108700,'Be quick! I wouldn\'t want us to be caught off guard while you\'re browsing my wares.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108701,'Lulubelle says you\'re to blame.','Lulubelle says you\'re to blame.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108702,'She would say that, wouldn\'t she? Further proof that you can\'t trust a Fizzlebang!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108703,'','Welcome, Lord of Flame! Welcome, Kil\'jaeden!',0,0,0,0,0,0,0,0,6,0,0,63724,26124),
(108704,'You have done well, Akaari. You have earned my blessing.','',0,0,0,0,0,0,0,0,6,0,63727,0,26124),
(108705,'Azhir manari kirel. Akim manari galar!','',0,0,0,0,0,0,0,0,6,0,63728,0,26124),
(108706,'','The fangs... their power is beyond comprehension! I am your humble servant, my lord!',0,0,0,0,0,0,0,0,6,0,0,63725,26124),
(108707,'It is time for your true test. Use the Fangs to dismantle Azeroth\'s kingdoms from within. Let their shattered husks pave our path to victory!','',0,0,0,0,0,0,0,0,6,0,63729,0,26124),
(108709,'My brooch? Bah, I have bigger things to worry about than Lespin. Unfortunately for you, I no longer have the brooch.$b$bIt was stolen by Venlis Swiftsea, undoubtedly part of some plot to assassinate my reputation. It is a clever move, since now I cannot be seen near him.$b$bIf you were to go \"speak\" with him and recover the brooch, I think we would both benefit from this mess.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108711,'I see your future, mortal...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108712,'I did not foresee this...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108714,'','Who knows when this will end?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108715,'Has it passed? I can\'t wait to warm up baked goods for our troops once this is all over.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108716,'','They will taste blood in your name!',0,0,0,0,0,0,0,0,6,0,0,63726,26124),
(108717,'The specters here continue to concoct a wine so foul it serves only to poison the drinker. Azsuna would be better served with them gone.','',0,0,0,0,0,0,0,0,0,0,71441,0,26124),
(108718,'That should help to contain the spread of their corrupted... spirits. You have my thanks.','',0,0,0,0,0,0,0,0,0,0,71442,0,26124),
(108719,'$n! You can\'t just sneak up on someone like that. Not while this is going on!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108720,'','Imps aren\'t ideal test subjects. They\'re easy enough to summon, but often too fragile for my experiments.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108721,'Feel its power coursing through you, shaman. The waters that Azshara tried to turn against us are now yours to command.','',0,0,0,0,0,0,4,0,0,0,60710,0,26124),
(108722,'Magic stick!','',0,0,0,0,0,0,1,0,0,0,60711,0,26124),
(108723,'Come, let us return to the others.','',0,0,0,0,0,0,1,0,0,0,60712,0,26124),
(108724,'','I never thought I would someday long for the peace and quiet of the Maelstrom.',0,0,0,0,0,0,1,0,0,0,0,60713,26124),
(108725,'Ularogg enters the |cFFFF0000|Hspell:198510|h[Stance of the Mountain]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(108726,'It\'s a book. That floats. Why did the demons leave it here?','It\'s a book. That floats. Why did the demons leave it here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108727,'It\'s a book. That floats. Why did the demons leave it here?\n\nIt looks sinister, but probably not worth your time.','It\'s a book. That floats. Why did the demons leave it here?\n\nIt looks sinister, but probably not worth your time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108728,'Dedication to your holy Paladin order demands that you purify this fel taint.','Dedication to your holy Paladin order demands that you purify this fel taint.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108729,'This book is unnatural to Priests and must be destroyed.','This book is unnatural to Priests and must be destroyed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108730,'Let\'s fly, $n. Lightfeather is saddled and ready to go.','',0,0,0,0,0,0,0,0,0,0,62426,0,26124),
(108731,'The demons of Faronaar seek to bend the Illidari to their will. This must not be allowed to transpire!','',0,0,0,0,0,0,0,0,0,0,70753,0,26124),
(108732,'With the Illidari freed, the demons\' threat is contained. You have done a great service to our land, champion.','',0,0,0,0,0,0,0,0,0,0,70755,0,26124),
(108733,'','These demons are even more persistent than the wretched naga! We must drive them back! My Nightwatchers will aid you.',0,0,0,0,0,0,0,0,0,0,0,70751,26124),
(108734,'','Ha! That should teach them not to tangle with the Nightwatchers!',0,0,0,0,0,0,0,0,0,0,0,70752,26124),
(108735,'It pains me to see my brethren reduced to such a state. There is nothing left for them now but hunger. Please, put them to rest.','',0,0,0,0,0,0,0,0,0,0,70778,0,26124),
(108736,'It was a dark task, but one that needed to be done. You have my gratitude, champion.','',0,0,0,0,0,0,0,0,0,0,70779,0,26124),
(108737,'','First the naga assault our city! Now it looks like they\'re trying to make off with our relics as well. Show them what it means to incur the wrath of the Nightwatchers, champion!',0,0,0,0,0,0,0,0,0,0,0,70749,26124),
(108738,'','That should teach the naga to stay out of Azsuna! The citizens of Nar\'thalas owe you a debt of gratitude, $c, as do the Nightwatchers.',0,0,0,0,0,0,0,0,0,0,0,70750,26124),
(108739,'Bad enough that naga and demons invade our home... now these makrura plague our shores! We must find out what dark force is driving them to madness. Will you help?','',0,0,0,0,0,0,0,0,0,0,70766,0,26124),
(108740,'So the foul demons were behind it all! You have my thanks for foiling their scheme. Without the demons inciting them, the makrura threat should subside.','',0,0,0,0,0,0,0,0,0,0,70767,0,26124),
(108741,'','The audacity of these scaly cretins is truly limitless! Now they dare disgrace the city of Nar\'thalas with their presence? As a friend of the Nightwatchers, you must not let this stand!',0,0,0,0,0,0,0,0,0,0,0,70768,26124),
(108742,'','I commend your bravery, champion. The Nightwatchers will take care of their remaining forces. We are in your debt.',0,0,0,0,0,0,0,0,0,0,0,70769,26124),
(108743,'If the sea giants wish to ally with the naga, then they have become our enemy. Champion, show them that the Highborne are not to be trifled with!','',0,0,0,0,0,0,0,0,0,0,70770,0,26124),
(108744,'Let that be a lesson they will not soon forget. Thank you, champion.','',0,0,0,0,0,0,0,0,0,0,70771,0,26124),
(108745,'I just soiled myself...','',0,0,0,0,0,0,0,0,0,0,61505,0,26124),
(108748,'Rokmora rears back for |cFFFF0000|Hspell:188169|h[Razor Shards]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108749,'Fish-breath still alive.$b$bYou ready for fighting?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108750,'Let\'s do it!','Let\'s do it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108751,'Snake witch powerful, but with Grash help kill!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108752,'Let\'s finish this, Grash!','Let\'s finish this, Grash!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108753,'They\'ve taken the fields!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108754,'Protect the Hill at all costs!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108755,'Everything I\'ve worked for... gone!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108756,'All of our crops were destroyed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108757,'Ain\'t never been formally trained, but I\'m sure this here pointy end means trouble.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108758,'There! In the skies! More of our reinforcements! Hold strong!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(108759,'','Let us finish this once and for all.',0,0,0,0,0,0,0,0,0,0,0,63716,26124),
(108760,'','Do you feel the fangs\' bite withering the flesh from your very bones?',0,0,0,0,0,0,0,0,0,0,0,63717,26124),
(108761,'','Mephistroth guide my hand! I will not fail!',0,0,0,0,0,0,0,0,0,0,0,63718,26124),
(108762,'','I have broken entire worlds from the inside out. Azeroth will crumble!',0,0,0,0,0,0,0,0,0,0,0,63719,26124),
(108763,'','No more games.',0,0,0,0,0,0,0,0,0,0,0,63721,26124),
(108764,'','Join me... in the Nether...',0,0,0,0,0,0,0,0,0,0,0,63723,26124),
(108765,'The citadel has begun a self-destruct sequence. Make your way to the portal once you have the fangs!','',0,0,0,0,0,0,0,0,0,0,63747,0,26124),
(108766,'','Can you feel your mind slipping away?',0,0,0,0,0,0,0,0,0,0,0,63720,26124),
(108767,'','I am your end!',0,0,0,0,0,0,0,0,0,0,0,63722,26124),
(108768,'This creature is using its own life essence to harm us! He dies a little more with every attack!','',0,0,0,0,0,0,0,0,0,0,61759,0,26124),
(108769,'Clever. He\'s absorbing the flame back into his body to become whole again.','',0,0,0,0,0,0,0,0,0,0,61763,0,26124),
(108770,'Priest, perhaps you can use your magic to influence his mind... Trick him into snuffing out his own flame!','',0,0,0,0,0,0,0,0,0,0,61758,0,26124),
(108771,'Ah, you made it. Well done!','',0,0,0,0,0,0,21,0,0,0,63734,0,26124),
(108772,'Valeera said you would know where to meet her upon your return. Not wise to keep her waiting.','',0,0,0,0,0,0,1,0,0,0,63735,0,26124),
(108773,'Until our paths cross again.','',0,0,0,0,0,0,2,0,0,0,63736,0,26124),
(108774,'Come with me. The depths await!','',0,0,0,0,0,0,1,0,0,0,60673,0,26124),
(108775,'That beast is trying to take her soul! Hurry, we can still save her!','',0,0,0,0,0,0,0,0,0,0,62466,0,26124),
(108776,'Jump on Azuregos\'s back to avoid |cFFFF0404|Hspell:209863|h[Force of Gravity]|h|r!','Jump on Azuregos\'s back to avoid |cFFFF0404|Hspell:209863|h[Force of Gravity]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108777,'Mage reinforcements from Stormwind! We fight as one!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(108778,'Close ranks! We make our stand here!','',0,0,0,0,0,0,22,0,0,0,64736,0,26124),
(108779,'Sir.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108780,'For the Alliance!','For the Alliance!',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(108781,'Hold the gates!','Hold the gates!',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(108782,'Reporting for duty!','Reporting for duty!',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(108783,'Point me to the nearest demon!','Point me to the nearest demon!',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(108784,'Mum.','Mum.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108785,'','I\'m sorry, but what does, \"Mum\" mean? Is there something you need?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108786,'Oh, uh... well I\'m looking for some burettes?','Oh, uh... well I\'m looking for some burettes?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108787,'','Well why didn\'t you just say so to begin with? There aren\'t any guards around, we\'re perfectly safe to speak freely.',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(108788,'How in the light am I supposed to get a hair from an archmage?!','How in the light am I supposed to get a hair from an archmage?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108789,'','Judging by what you\'re asking for I assume you\'re an alchemist?$b$bAnd if that\'s true, isn\'t there some sort of invisibility potion you can brew? Skaggldrynk I believe it\'s called.$b$bHe\'ll never see you coming.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108790,'Carefully pluck a single strand of hair from Khadgar\'s head.','Carefully pluck a single strand of hair from Khadgar\'s head.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108791,'OW!! What in the light was that?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108792,'Something... bit my head I think.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108794,'Show me what you have available.','Show me what you have available.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108795,'','Khadgar, what\'s wrong? What happened?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(108796,'<Lay your insignia on the table.>','<Lay your insignia on the table.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108797,'','Something bit your head? That\'s all? Would you like me to kiss it for you?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(108798,'Just mount the wee birdy here and follow me! To Stormheim!','',0,0,0,0,0,0,0,0,0,0,63276,0,26124),
(108799,'Your order\'s in the back room, $Gsir:madame;.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108800,'Right this way, $GMister:Miss; $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108801,'Hm, |5$r of your tastes might find our private selection in the back to your liking.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108802,'Welcome back, $Gsir:madame;. Might I suggest you check out our new arrivals in the VIP room?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108803,'Use |TInterface\\Icons\\spell_warlock_demonicportal_green.blp:20|t |cFFFF0000|Hspell:111771|h[Demonic Gateway]|h|r to get past Ariden\'s barrier!','Use |TInterface\\Icons\\spell_warlock_demonicportal_green.blp:20|t |cFFFF0000|Hspell:111771|h[Demonic Portal]|h|r to get past Ariden\'s barrier!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108804,'The Darkbrul Arena is a place for the clans to challenge each other. Get in there and prove that the Stonedark and their allies are the toughest!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108805,'Please, keep your voice down!$b$bIf they catch me talking to you... they\'ll kill me!','Please, keep your voice down!$b$bIf they catch me talking to you... they\'ll kill me!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108806,'I\'ve cleared a path for you. You can escape if you hurry!','I\'ve cleared a path for you. You can escape if you hurry!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108807,'Good work! You\'ve pushed back the Naga and cleared out their Murloc slaves sufficiently! If you have any Timeworn Artifacts on you, bring them on by!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108808,'','That was a legendary performance! Thank you for proving that friendship is overrated.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108809,'The raven calls.','The raven calls.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108810,'|TInterface\\Icons\\ability_fomor_boss_shout:20|t%s begins a |cFFFF0404|Hspell:209748|h[Deafening Roar]|h|r. Stop casting!','|TInterface\\Icons\\ability_fomor_boss_shout:20|t%s begins a |cFFFF0404|Hspell:209748|h[Deafening Roar]|h|r. Stop casting!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(108811,'And we will answer from the shadows.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108812,'I never thought I would make it out alive!','I never thought I would make it out alive!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108813,'The Twilight\'s Hammer must be stopped!','The Twilight\'s Hammer must be stopped!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108814,'I never thought I\'d see my children\'s faces again!','I never thought I\'d see my children\'s faces again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108815,'I can\'t wait to take a bath!','I can\'t wait to take a bath!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108816,'Please save the others, hero!','Please save the others, hero!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108817,'Be careful. I\'ve seen The Master... and she\'s powerful!','Be careful. I\'ve seen The Master... and she\'s powerful!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108818,'We\'re saved!','We\'re saved!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108819,'You fight with a fury worthy of a vrykul! An infant or elderly vrykul, but a vrykul all the same! Well done!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108820,'You\'ve saved me. I won\'t forget this!','You\'ve saved me. I won\'t forget this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108821,'These Naga are up to no good, enslaving the nearby Murlocs to invade the shore. Take them out at all costs! Oh, and if you find any Timeworn Artifacts I could really use them for my research.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108822,'','Welcome to the Black Rook Rumble! Did you come here to fight alongside friends or allies? Well, send them away! Within this arena, you stand alone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108823,'Looking for something specific today?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(108824,'Battle?! Battle first, then eats the pets! Battle then eats!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108825,'Oh! Times to eats the pets! Where you goin\'? We can shares!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108826,'Oh $p, I didn\'t realize it was you... my apologies. The Uncrowned await your arrival.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(108827,'This a placeholder event for imbuing the Moonwell. Spell effects will be added at a later date.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108828,'That there be $p. I heard $Ghe:she; took down Deathwing with nothin\' but the blades in $Ghis:her; hands!','Looking for something specific today?',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(108829,'We would like you to do the honors, friend. Come.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108831,'Ey mon, dat there be da one Garona spoke of.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108832,'','Yes, thank you for all you have done.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108833,'','Mayruna kneels and arranges a silver basin on the ground, then pours a small amount of softly glowing liquid into it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108834,'','Whenever you are ready, simply submerge the ritual bundle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108837,'','Mother Moon, goddess of my heart, bless this place with your light.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108838,'On behalf of the Sablehorn, let this moonwell be blessed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108839,'On behalf of the Feathermane, let this moonwell be blessed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108840,'','On behalf of the Moonwhisper, let this moonwell be blessed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108841,'','It is done!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108842,'|TInterface\\Icons\\spell_shaman_lavaflow.blp:20|t %s readies |cFFF00000|Hspell:200404|h[Magma Wave]|h|r. Hide!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(108843,'','I will not... give in!',0,0,0,0,0,0,0,0,0,0,0,66752,26124),
(108844,'Your torment only feeds the nightmare, weakling!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108845,'','The power of the Scepter is MINE to command!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108846,'Cato! I\'m glad ye could make it. The shield is close... I can feel it!','',0,0,0,0,0,0,1,0,0,0,63294,0,26124),
(108847,'','You will drown in this place!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108848,'','The Earthen Ring will never have Azshara\'s power!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108849,'I\'m here, aren\'t I? Let\'s find this shield. Some of us have a war to get back to!','',0,0,0,0,0,0,1,0,0,0,63295,0,26124),
(108850,'Cato\'s the best healer around. We\'re lucky we didn\'t have to wait in a queue for his services!','',0,0,0,0,0,0,1,0,0,0,63296,0,26124),
(108851,'|TInterface\\Icons\\Spell_Nature_LightningOverload:20|t You are afflicted with |cFFFF0000|Hspell:204275|h[Arcane Tether]|h|r!','|TInterface\\Icons\\Spell_Nature_LightningOverload:20|t You are afflicted with |cFFFF0000|Hspell:204275|h[Arcane Tether]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(108852,'','I owe you a great debt, druid. I will not forget this.',0,0,0,0,0,0,0,0,0,0,0,66753,26124),
(108853,'Ummm...?','Ummm...?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108854,'Look, this one is not my fault. How was I supposed to know those demons would believe me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108855,'We must drive them back! Focus on the commanders!','',0,0,0,0,0,0,22,0,0,0,64758,0,26124),
(108856,'Petty mortals. Your world will end soon enough!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108857,'They aren\'t letting up! Hold strong!','',0,0,0,0,0,0,22,0,0,0,64785,0,26124),
(108858,'Watch the skies, I sense them coming.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108859,'Don\'t waste your breath, druid. Malorne\'s gift is ours. Now, join your ancestors!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108860,'','The Bloodstone is ready. Handle it with care, $n.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108861,'Nooooooooo!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108862,'Cannot. Control. Must. KILL!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108863,'Grash no let puny shaman hurt snake lady!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108864,'Thank you again for giving me the honor of sacrificing my life for the cause. Now you know that I\'d willingly give everything to further Lord Illidan\'s plan. The Burning Legion must be destroyed at any cost.\n\nI owe you everything, $n.\n\nNow, you complete what we started, gain the Sargerite Keystone, and return triumphant to the Black Temple.\n\nLord Illidan awaits.','',2,0,0,0,0,0,0,0,0,0,0,0,26124),
(108867,'Well I didn\'t think they would actually believe me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108868,'You demon toying fool! You have compromised our position.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108869,'Affliction warlocks use shadow magic and disease to wear down their enemies, then drain their very life essences to empower themselves.','',0,0,0,0,0,0,0,0,0,0,59059,0,26124),
(108870,'Use Summon Voidwalker to summon your demonic minion.','',0,0,0,0,0,0,0,0,0,0,59058,0,26124),
(108871,'Agony is an appropriate name for your first attack ability.','',0,0,0,0,0,0,0,0,0,0,59057,0,26124),
(108872,'Use Agony on the target dummy.','',0,0,0,0,0,0,0,0,0,0,59056,0,26124),
(108873,'You will inflict suffering on anyone foolish enough to fight you.','',0,0,0,0,0,0,0,0,0,0,59055,0,26124),
(108874,'Use Corruption on this target dummy.','',0,0,0,0,0,0,0,0,0,0,59054,0,26124),
(108875,'After afflicting your target with Agony and Corruption, you can begin to drain the very life from them.','',0,0,0,0,0,0,0,0,0,0,59053,0,26124),
(108876,'Use Drain Soul on the target dummy.','',0,0,0,0,0,0,0,0,0,0,59052,0,26124),
(108877,'As Agony damages your enemy, it has a chance to generate a Soul Shard. You can use these shards to empower new abilities.','',0,0,0,0,0,0,0,0,0,0,59051,0,26124),
(108878,'Use Unstable Affliction on this target dummy.','',0,0,0,0,0,0,0,0,0,0,59050,0,26124),
(108879,'Now that you have all your primary attack abilities, we will see how they work together!','',0,0,0,0,0,0,273,0,0,0,59049,0,26124),
(108880,'Practice using your attacks on this target dummy.','',0,0,0,0,0,0,25,0,0,0,59048,0,26124),
(108881,'Many spells have a heavy mana cost. You have a clever way around this problem.','',0,0,0,0,0,0,0,0,0,0,59047,0,26124),
(108882,'Use Life Tap to replenish your mana reserves.','',0,0,0,0,0,0,0,0,0,0,59046,0,26124),
(108883,'At times you may find yourself overwhelmed by multiple enemies, or a single enemy that is too strong for you.','',0,0,0,0,0,0,0,0,0,0,59045,0,26124),
(108884,'Use Fear to frighten my soldier.','',0,0,0,0,0,0,0,0,0,0,59044,0,26124),
(108885,'Well done, $p! You are now prepared to do battle as an affliction warlock.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108886,'Council members and allies, it is time to begin the summoning.','',0,0,0,0,0,0,1,0,0,0,66522,0,26124),
(108887,'We employ a variety of methods to ensure the safety of Azeroth... and to secure our rightful place within it.','',0,0,0,0,0,0,1,0,0,0,63647,0,26124),
(108888,'But the events at the Broken Shore have forced our hand. We haven\'t the time for subtlety.','',0,0,0,0,0,0,5,0,0,0,63649,0,26124),
(108889,'T... T\'uure... Alora... escape...','',0,0,0,0,0,0,0,0,0,0,62422,0,26124),
(108890,'You know the deal. We kill $Ghim:her;, our debts are clear!','You know the deal. We kill $Ghim:her;, our debts are clear!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108891,'Nothing personal, friend. Just business.','Nothing personal, friend. Just business.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108892,'Consider your choice carefully.','',0,0,0,0,0,0,0,0,0,0,63605,0,26124),
(108894,'I\'m ready to make a decision.','I\'m ready to make a decision.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108895,'','What\'s the matter? Never seen a princess who knows how to twist a blade?',11,0,0,0,0,0,0,0,0,0,0,0,26124),
(108896,'Tell me about your plan.','Tell me about your plan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108897,'','I plan to acquire the cursed daggers that took down King Llane Wrynn. Garona hid the Kingslayers for good reason. Their power is not to be underestimated.$B$BI need your help to retrieve them. These storied blades are just what we need to destroy Gul\'dan and his foul allies.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108898,'Gimme yer ear, $n. I got a plan that\'s guaranteed to put worthy blades in them hands!','',0,0,0,0,0,0,5,0,0,0,63606,0,26124),
(108899,'What can I do for ya?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(108900,'','The Kingslayers are the only way to ensure the Legion\'s end. Hear me out!',0,0,0,0,0,0,1,0,0,0,0,63608,26124),
(108901,'','I\'m close to locating a foe we\'ve been hunting for years. With a bit of help, we can take her out and lay claim to her daggers.',0,0,0,0,0,0,1,0,0,0,0,63607,26124),
(108902,'Just after the Cataclysm, one o\' me best discovered a pair o\' golden cutlasses unlike any ye\'ve e\'er seen. The moment Eliza touched \'em, she had a vision o\' herself conquerin\' city after city, commandin\' a crew o\' lost souls.$B$BYe may doubt such a grand tale, but it indeed came t\' pass. The Dreadblades \'ave claimed countless souls, and now we\'re comin\' for \'em!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108903,'','Jorach spoke highly of you. He\'s a good friend to have.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108904,'','After the fall of Sargeras\' hound Goremaw, his dreadlords took the beast\'s fangs and forged them into a pair of daggers known as the Fangs of the Devourer. It\'s said they still carry the monster\'s bite.$B$BSargeras called upon one of his top assassins to wield the fangs, an eredar named Akaari Shadowgore. Despite our best attempts, we haven\'t been able to stop her.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108905,'You won\'t escape me this time, Valith! Tell me where your master is and I may grant you a quick death!','',0,0,0,0,0,0,0,0,0,0,62464,0,26124),
(108906,'Your time on this world ends now, demon! Allies, gather at Sentinel Hill!','',0,0,0,0,0,0,22,0,0,0,64809,0,26124),
(108907,'|TInterface\\Icons\\Spell_DeathKnight_MindFreeze:20|t%s casts |cFFFF0404|Hspell:209983|h[Control Thoughts]|h|r on Grash!','|TInterface\\Icons\\Spell_DeathKnight_MindFreeze:20|t%s casts |cFFFF0404|Hspell:209983|h[Control Thoughts]|h|r on Grash!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(108908,'That insignia marks you as one of us. Carry it with you always.','',0,0,0,0,0,0,0,0,0,0,63656,0,26124),
(108909,'My work will shine for eternity...','',0,0,0,0,0,0,0,0,0,39512,66066,0,26124),
(108910,'A Rotdrool Grabber bursts from the husk of the grub!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108911,'Go deal with that demon, $n! I\'ll tend to Alora.','',0,0,0,0,0,0,0,0,0,0,62430,0,26124),
(108912,'I seem to have misplaced my insignia.','I seem to have misplaced my insignia.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108913,'Knocking','Knocking',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108914,'','Use your feral form to heighten your senses. Between the three of us, we can pick up the satyr\'s trail.',0,0,0,0,0,0,0,0,0,0,0,66758,26124),
(108915,'The barrier you placed here with Ysondre\'s Tear still stands.\n\nIf you wish, you can remove it.','The barrier you placed here with Ysondre\'s Tear still stands.\n\nIf you wish, you can remove it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108916,'Remove the seal.','Remove the seal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108917,'','Foolish warlocks, summoning what you cannot control.',0,0,0,0,0,0,603,0,0,0,0,66511,26124),
(108918,'The doomguards make their descent! Prepare yourselves!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(108919,'','You will meet your death by our hands!',0,0,0,0,0,0,0,0,0,0,0,66519,26124),
(108920,'Sinu a\'manore. You were fortunate I was in the area. What brings you to this forsaken place?','',0,0,0,0,0,0,0,0,0,0,62465,0,26124),
(108921,'Lookee! Seems Yrgrim was the champion, and he came here after Tyr\'s fall.','',0,0,0,0,0,0,1,0,0,0,63298,0,26124),
(108922,'I had thought my battle over. You have my gratitude.','I had thought my battle over. You have my gratitude.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108923,'Thank you. I shall return to the Illidari to recover.','Thank you. I shall return to the Illidari to recover.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108924,'These foul demons sap our strength and seek to bend our will. Show them no mercy!','These foul demons sap our strength and seek to bend our will. Show them no mercy!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(108925,'When that brute Kraggosh and his overseers moved into the Undercity, we were forced to do our real work in secret.$B$BSurely you can see how such an arrangement inevitably led me here.','',11,0,0,0,0,0,0,0,0,0,0,0,26124),
(108926,'It shames me to have been taken alive by these creatures. Thanks to you, I will fight another day.','It shames me to have been taken alive by these creatures. Thanks to you, I will fight another day.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108927,'Thank you for freeing me, $c. The Illidari must learn what the Legion is planning in Faronaar!','Thank you for freeing me, $c. The Illidari must learn what the Legion is planning in Faronaar!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(108928,'Out here, no one will hear your screams!','',0,0,0,0,0,0,0,0,0,0,66746,0,26124),
(108929,'Your god is no match for ours, druid!','',0,0,0,0,0,0,0,0,0,0,66747,0,26124),
(108931,'Oh, that reminds me. While you were off doing the easy work, I was out taking care of the other part that was needed.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108932,'Just... resting my eyes... for a moment...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108933,'Come, we have much to discuss.','',0,0,0,0,0,0,1,0,0,0,66523,0,26124),
(108934,'I had to deal with those awful scribes over at The Scribe\'s Sacellum. But, ultimately, it was worth the effort.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108935,'That should do it. I think we both deserve a pat on the back, $n. Wouldn\'t you agree?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(108936,'Give up, druid. Your ancient god... cannot... be saved...','',0,0,0,0,0,0,0,0,0,0,66749,0,26124),
(108937,'It\'s no use, druid. You cannot fight us.','',0,0,0,0,0,0,0,0,0,0,66750,0,26124),
(108939,'Against us, your strength is nothing. All you love will turn against you. You will face your greatest fears.','',0,0,0,0,0,0,0,0,0,0,66748,0,26124),
(108940,'Who goes there?','Who goes there?',0,0,0,0,0,0,0,0,0,0,0,66421,26124),
(108941,'Thank you for that welcome distraction.','',0,0,0,0,0,0,0,0,0,0,66367,0,26124),
(108942,'Sylendra, can we still recover the idol?','',0,0,0,0,0,0,0,0,0,0,66751,0,26124),
(108943,'Just enjoy the party for a bit. You know... mingle.','',0,0,0,0,0,0,0,0,0,0,67510,0,26124),
(108944,'Let us gather and give our oaths!','',0,0,0,0,0,0,1,0,0,0,66531,0,26124),
(108945,'<The attendant is silent.>','<The attendant is silent.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108946,'<Take a drink.>','<Take a drink.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108947,'','There are others trapped inside. Please, rescue them if you can. Thank you again, $n!',0,0,0,0,0,0,0,0,0,0,0,62462,26124),
(108948,'I choose you to be the Sixth.','I choose you to be the Sixth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108949,'','I can see the times are changing.  \n\nOne warlock, no matter how powerful, can\'t take on the Burning Legion alone.\n\nWhile I\'ll never believe anything Ritssyn does is selfless, it\'s clear that rebuilding the council is the right thing to do.\n\nI would be honored to count myself one among the six, if you\'ll have me.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108950,'','I\'ll do whatever it takes to restore pride to the Fizzlebang name.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108951,'','It takes many years to build a reputation, and only one mistake to tarnish it.\n\nI have my work cut out for me, but I hope that serving on the council will help towards restoring pride to the Fizzlebang name.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(108952,'Let\'s get going. The portal is just ahead.','',0,0,0,0,0,0,0,0,0,0,62463,0,26124),
(108953,'The spirits, the elements, they are but pitiful shadows compared to the power of the legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108954,'Bow, bow to the might of Sargeras. Bow and receive his gifts.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108955,'The forces of Highmountain, the drogbar, even the elves, will be swept away in the flames of our wrath.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108956,'Embrace the fel energies of our new masters. Kneel, and you shall rise stronger than ever.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108957,'','Too many of the Bloodtotem have gone over to the legion. Now, these Feltotem are gathering their strength. I do not intend to let their betrayal go unpunished.',0,0,0,0,0,0,0,0,0,0,0,62095,26124),
(108958,'','The Bloodtotem had been growing more distant for years now. But to side with the Legion? None of us could have foreseen that.',0,0,0,0,0,0,0,0,0,0,0,62096,26124),
(108959,'More camps on the horizon! Bring them down!','',0,0,0,0,0,0,22,0,0,0,64797,0,26124),
(108960,'Fools! Our forces have spread across these foul lands. We have defiled and corrupted your precious soil... Let us see how you deal with our legion now.','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(108961,'All forces, spread out! Legion corruption rises in all directions!','',0,0,0,0,0,0,22,0,0,0,64770,0,26124),
(108962,'Don\'t bother reading it or anything.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108963,'Just go ahead and sign it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108964,'Right there on the line.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108965,'This metal is all bent out of shape. A strong Blacksmith could hammer these pieces back into working order.','This metal is all bent out of shape. A strong Blacksmith could hammer these pieces back into working order.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108966,'Well done, Archdruid. Take the Idol back to the Dreamgrove, and we will meet you there.','',0,0,0,0,0,0,0,0,0,0,66763,0,26124),
(108967,'Someone left some goods out in the open...','Someone left some goods out in the open...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108968,'It would be a pity if a Warrior were to smash them.','It would be a pity if a Warrior were to smash them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108969,'If a Rogue were to pilfer some of these, you\'re sure someone would take notice.','If a Rogue were to pilfer some of these, you\'re sure someone would take notice.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108970,'Someone left some goods out in the open...\n\nThey seem to be monitored by magical means.','Someone left some goods out in the open...\n\nThey seem to be monitored by magical means.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(108971,'Halt!','',0,0,0,0,0,0,0,0,0,0,58634,0,26124),
(108972,'','Betrayers! Liars! Murderers! Has Hamuul sent his lapdogs to fetch the knife from my back?',0,0,0,0,0,0,0,0,0,0,0,58610,26124),
(108973,'Guards! To me!','',0,0,0,0,0,0,0,0,0,0,58637,0,26124),
(108974,'','Do you remember murdering me? Or have you grown so used to slaughter that my cries of agony are long forgotten?',0,0,0,0,0,0,0,0,0,0,0,58611,26124),
(108975,'','I recall my final moments surrounded by those I had trusted. Your satisfied sneers as I drew my last breath.',0,0,0,0,0,0,0,0,0,0,0,58612,26124),
(108976,'','Revenge is said to be sweet, but I taste only bitterness.',0,0,0,0,0,0,0,0,0,0,0,58613,26124),
(108977,'','Your faces no longer appear familiar. Did you truly deserve my wrath?',0,0,0,0,0,0,0,0,0,0,0,58614,26124),
(108978,'','Now you have become prey!',0,0,0,0,0,0,0,0,0,0,0,58615,26124),
(108979,'','Scurry, scurry, little rats!',0,0,0,0,0,0,0,0,0,0,0,58616,26124),
(108980,'','There is nowhere left to hide!',0,0,0,0,0,0,0,0,0,0,0,58617,26124),
(108981,'','Such juicy morsels!',0,0,0,0,0,0,0,0,0,0,0,58618,26124),
(108982,'','Scream for me!',0,0,0,0,0,0,0,0,0,0,0,58619,26124),
(108983,'','I\'ll adorn my web with your bones!',0,0,0,0,0,0,0,0,0,0,0,58620,26124),
(108984,'','Feel the crush of my talons!',0,0,0,0,0,0,0,0,0,0,0,58621,26124),
(108985,'','My beak will tear your flesh, vermin!',0,0,0,0,0,0,0,0,0,0,0,58622,26124),
(108986,'','Not afraid of spiders, are you?',0,0,0,0,0,0,0,0,0,0,0,58623,26124),
(108987,'Finally. I\'ll make this quick.','',0,0,0,0,0,0,0,0,0,0,58650,0,26124),
(108988,'','This time I\'m ready for your treachery!',0,0,0,0,0,0,0,0,0,0,0,58624,26124),
(108989,'','Mercy? None for you! Only gushing blood and broken bodies!',0,0,0,0,0,0,0,0,0,0,0,58625,26124),
(108990,'How dare you interrupt your betters!','',0,0,0,0,0,0,0,0,0,0,58651,0,26124),
(108991,'','Betrayers, will you remember killing me now?',0,0,0,0,0,0,0,0,0,0,0,58626,26124),
(108992,'','The Twilight\'s Hammer is all but destroyed. This once great order has been laid low... scattered and leaderless.',1,0,0,0,0,0,0,0,0,0,0,66848,26124),
(108993,'The wind slices to the bone!','',0,0,0,0,0,0,0,0,0,0,58655,0,26124),
(108994,'Death by a thousand cuts!','',0,0,0,0,0,0,0,0,0,0,58656,0,26124),
(108995,'Bleed for the Grand Magistrix!','',0,0,0,0,0,0,0,0,0,0,58657,0,26124),
(108996,'You can\'t counter what you can\'t see!','',0,0,0,0,0,0,0,0,0,0,58652,0,26124),
(108997,'I will speed you towards your demise!','',0,0,0,0,0,0,0,0,0,0,58653,0,26124),
(108998,'If you blink... you bleed!','',0,0,0,0,0,0,0,0,0,0,58654,0,26124),
(108999,'Another victim of my artistry.','',0,0,0,0,0,0,0,0,0,0,58659,0,26124),
(109000,'Never heard my blade coming!','',0,0,0,0,0,0,0,0,0,0,58660,0,26124),
(109001,'','But I have heard the prayers of their faithful... crying out for destruction!',0,0,0,0,0,0,0,0,0,0,0,67020,26124),
(109002,'Elisande... forgive me!','',0,0,0,0,0,0,0,0,0,0,58658,0,26124),
(109003,'Let your names be forgotten.','',0,0,0,0,0,0,0,0,0,0,58661,0,26124),
(109004,'','I will take these poor, pathetic creatures under my wing and lead them to the glorious destiny they yearn for!',0,0,0,0,0,0,0,0,0,0,0,67021,26124),
(109011,'','Breathe deeply. Embrace your fate.',0,0,0,0,0,0,0,0,0,0,0,58667,26124),
(109012,'','Dark secrets have been revealed to me through the void... ways of subjugating the elements to my will!',0,0,0,0,0,0,0,0,0,0,0,67022,26124),
(109013,'','You have no more need of this life!',0,0,0,0,0,0,0,0,0,0,0,58668,26124),
(109014,'','No... I still have much to do... RETURN TO ME!',0,0,0,0,0,0,0,0,0,0,0,58669,26124),
(109015,'','My children will learn these secrets and together we shall tear this world asunder!',0,0,0,0,0,0,0,0,0,0,0,67023,26124),
(109016,'','Consumed from within!',0,0,0,0,0,0,0,0,0,0,0,58670,26124),
(109017,'','Your wakened life is a disease!',0,0,0,0,0,0,0,0,0,0,0,58671,26124),
(109018,'','My little ones learn quickly... they drink from the void and thirst endlessly for more!',0,0,0,0,0,0,0,0,0,0,0,67024,26124),
(109020,'','The destruction of Azeroth is at hand! Soon... the very elements that shape this world will cause its demise!',0,0,0,0,0,0,0,0,0,0,0,67025,26124),
(109021,'And so we enter the lair of the beast. May the Light protect us!','',0,0,0,0,0,0,0,0,0,0,62429,0,26124),
(109022,'Good luck with the Trials... \"hero.\"','',0,0,0,0,0,0,0,0,0,0,58672,0,26124),
(109023,'Do not disappoint the Banshee Queen.','',0,0,0,0,0,0,0,0,0,0,58673,0,26124),
(109024,'You succumbed to the Nightmare! Defeat your fears to wake up.','You succumbed to the Nightmare! Defeat your fears to wake up.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109025,'Our leader has done what no other could do.','',0,0,0,0,0,0,1,0,0,0,66532,0,26124),
(109026,'The Council of the Black Harvest lives once again.','',0,0,0,0,0,0,1,0,0,0,66527,0,26124),
(109027,'Under the First, our power will reach new heights.','',0,0,0,0,0,0,1,0,0,0,66526,0,26124),
(109028,'The secrets of the Burning Legion will be ours to unlock!','',0,0,0,0,0,0,603,0,0,0,66536,0,26124),
(109029,'','Over here! I haven\'t much time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109030,'A glowing door... Wee bit obvious, don\'t ye think? What have we here?','',0,0,0,0,0,0,1,0,0,0,63299,0,26124),
(109031,'This tablet says ye need to withstand the door\'s \"gaze\". I\'m bettin\' that\'s not gonna be pleasant. Care to give it a try?','',0,0,0,0,0,0,0,0,0,0,63300,0,26124),
(109032,'This magical lantern is different in some way. Almost as if it is leaking.','This magical lantern is different in some way. Almost as if it is leaking.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109033,'As a Mage, you are long familiar with the intricacies of ley magic. It can be repurposed to a... better cause.','As a Mage, you are long familiar with the intricacies of ley magic. It can be repurposed to a... better cause.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109034,'This faulty device of Elven construct is familiar to you and can be altered to provide magical empowerment.','This faulty device of Elven construct is familiar to you and can be altered to provide magical empowerment.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109035,'This magical lantern is different in some way. Almost as if it is leaking.\n\nYou\'re sure someone will come along and fix it in due time.','This magical lantern is different in some way. Almost as if it is leaking.\n\nYou\'re sure someone will come along and fix it in due time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109036,'The cultists are blinded by the twilight... deprived and recluse, taking cover in the night.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109037,'Beast master hunters possess a deep bond with their pets, calling and bolstering them in battle while striking at foes with ranged attacks.','',0,0,0,0,0,0,0,0,0,0,59965,0,26124),
(109038,'Use Call Pet to bring your pet to battle.','',0,0,0,0,0,0,0,0,0,0,59966,0,26124),
(109039,'Sending your pet to attack and distract an enemy gives you more time to line up your ranged attacks.','',0,0,0,0,0,0,0,0,0,0,59967,0,26124),
(109040,'Use Kill Command multiple times on the target dummy.','',0,0,0,0,0,0,0,0,0,0,59968,0,26124),
(109041,'Now let\'s see what other forces of nature you command.','',0,0,0,0,0,0,0,0,0,0,59957,0,26124),
(109042,'Use Dire Beast on the target dummy.','',0,0,0,0,0,0,0,0,0,0,59958,0,26124),
(109043,'I\'m sure you\'re ready to join in on the action. Cobra Shot is your primary ranged attack, pummeling your enemy while your pet keeps their attention.','',0,0,0,0,0,0,0,0,0,0,59959,0,26124),
(109044,'Use Cobra Shot on the target dummy.','',0,0,0,0,0,0,0,0,0,0,59960,0,26124),
(109045,'Use Bestial Wrath while attacking the target dummy.','',0,0,0,0,0,0,0,0,0,0,59962,0,26124),
(109046,'When in combat, Bestial Wrath sends you and your pet into a frenzy of rage that increases your damage for a short time.','',0,0,0,0,0,0,0,0,0,0,59961,0,26124),
(109049,'Sometimes you\'ll find yourself outnumbered. When you do, you can unleash destruction upon a host of adversaries at once!','',0,0,0,0,0,0,0,0,0,0,59969,0,26124),
(109050,'Use Multi-Shot to dispatch all the enemies.','',0,0,0,0,0,0,0,0,0,0,59970,0,26124),
(109051,'Even the greatest adventurers sometimes find themselves in over their heads.','',0,0,0,0,0,0,0,0,0,0,59971,0,26124),
(109052,'Use Feign Death to trick my soldier into stopping his attack.','',0,0,0,0,0,0,0,0,0,0,59972,0,26124),
(109053,'Prove to me you have the necessary skill and cunning required to hunt any prey!','',0,0,0,0,0,0,0,0,0,0,59963,0,26124),
(109054,'Show me your courage and zeal in the heat of combat!','',0,0,0,0,0,0,0,0,0,0,59981,0,26124),
(109056,'Target practice is over, $p. It\'s time to prove your mettle. Combine all the lessons you\'ve learned and use them to defeat my men in combat.','',0,0,0,0,0,0,1,0,0,0,59069,0,26124),
(109057,'Well done, $p! You are now prepared to do battle as a beast master hunter.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109058,'Golarb is unresponsive.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109059,'Mistress is gone...','',0,0,0,0,0,0,0,0,0,0,66508,0,26124),
(109060,'The dreadlord came for her. Golarb tried to help...','',0,0,0,0,0,0,0,0,0,0,66509,0,26124),
(109061,'Golarb failed...','',0,0,0,0,0,0,0,0,0,0,66510,0,26124),
(109062,'We\'re on the right track. Keep searching.','',0,0,0,0,0,0,0,0,0,0,66764,0,26124),
(109063,'','Their hideout should be close. I smell the stench of satyr to the east.',0,0,0,0,0,0,0,0,0,0,0,66755,26124),
(109064,'Ye did it! Better\'n being a pile of ash on the ground, ain\'t it?','',0,0,0,0,0,0,1,0,0,0,63301,0,26124),
(109065,'Zinnin Smythe bows his head in silent thanks.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(109066,'','You have my thanks. I can find my own way back to Dreadscar Rift.',0,0,0,0,0,0,1,0,0,0,0,66512,26124),
(109067,'','Archdruid! Watch out!',0,0,0,0,0,0,0,0,0,0,0,66756,26124),
(109068,'Don\'t worry!  I\'m here!','',0,0,0,0,0,0,0,0,0,0,66757,0,26124),
(109069,'','I am not leaving without my Kaya!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109071,'','She fought with everything she was, but there were simply too many. What are we going to do, Galar\'thus?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109073,'Another tablet! This champion is still forged, never touched by the curse o\' flesh! We should take care.','',0,0,0,0,0,0,1,0,0,0,63302,0,26124),
(109074,'','My home! Dargrul blew up my home. I... I don\'t... I can\'t even...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109075,'','They did not give me enough time to gather my things. Do you think they will be safe? I don\'t want those drogbar rummaging through my personal stuff.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109076,'There is no time left. Run!','There is no time left. Run!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109077,'$n! Bless the Light, you made it! This place is crawling with evil!','',0,0,0,0,0,0,0,0,0,0,62435,0,26124),
(109078,'These braves are near death. They will not be able to move themselves.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109079,'I bid you greetings, Opener of Doors. You are the first.','',0,0,0,0,0,0,0,0,6,0,63303,0,26124),
(109080,'I am Yrgrim, Champion of Tyr! Let us see if you are worthy to bear his shield.','',0,0,0,0,0,0,0,0,6,0,63304,0,26124),
(109081,'Your arrival was timely. Had we waited even a few more moments I would not be here today to thank you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109082,'It\'s a barrel of Starlight Rose tea. It appears to have been aged such that the brew is sickeningly strong.','It\'s a barrel of Starlight Rose tea. It appears to have been aged such that the brew is sickeningly strong.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109083,'As a Death Knight, tea strong enough to wake the dead is just what you need.','As a Death Knight, tea strong enough to wake the dead is just what you need.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109084,'A strong tea is merely a challenge to the auspicious Monk. Down the hatch!','A strong tea is merely a challenge to the auspicious Monk. Down the hatch!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109085,'It\'s a barrel of Starlight Rose tea. It appears to have been aged such that the brew is sickeningly strong.\n\nJust the smell of it nearly causes you to retch. Clearly it has been left here for too long.','It\'s a barrel of Starlight Rose tea. It appears to have been aged such that the brew is sickeningly strong.\n\nJust the smell of it nearly causes retching. Clearly it has been left here for too long.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109086,'So be it. Come my wounded friends, let us see if I might have the strength that is needed to carry you to safety.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109087,'','This is not up for debate, Anarys. You are either with us, or against us. Choose wisely.',0,0,0,0,0,0,0,0,0,0,0,67504,26124),
(109088,'','I will hear no more of your scheming! You endanger everything our father worked for!',0,0,0,0,0,0,0,0,0,0,0,67502,26124),
(109089,'','<sigh> Dear child... Do you not realize what he died for?',0,0,0,0,0,0,0,0,0,0,0,67505,26124),
(109090,'Thank you, champion. With my strength renewed, I am able to dispel this foul magic.','',0,0,0,0,0,0,0,0,0,0,62441,0,26124),
(109091,'Come, hero! Jace was heading this way.','',0,0,0,0,0,0,0,0,0,0,62444,0,26124),
(109092,'Long have I waited for one who proves worthy. Face me in battle that we might test your heart!','',1,0,0,5,0,0,1,0,6,0,63305,0,26124),
(109093,'We fight at your side, demon hunter!','',0,0,0,0,0,0,0,0,0,0,62447,0,26124),
(109094,'I must see if you possess the will, the strength, and the stamina to wield this shield. Will you face me in a trial of combat?','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(109095,'I am ready for your trial, Yrgrim.','I am ready for your trial, Yrgrim.',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(109096,'A realistic and ornate statue of a Suramar noble.','A realistic and ornate statue of a Suramar noble.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109097,'Your experience with Mining grants you the knowledge to work... and deface stone.','Your experience with Mining grants you the knowledge to work... and deface stone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109098,'Jewelcrafting grants you the skill to rework and \"improve\" this statue.','Jewelcrafting grants you the skill to rework and \"improve\" this statue.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109099,'A realistic and ornate statue of a Suramar noble.\n\nIt appears solid and very heavy.','A realistic and ornate statue of a Suramar noble.\n\nIt appears solid and very heavy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109100,'Let us begin!','',0,0,0,0,0,0,22,0,6,0,63306,0,26124),
(109101,'Studying','Studying',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(109102,'I am beaten! You are indeed worthy. Were Tyr alive, he would make you his champion. I hereby bestow Truthguard upon you. Use it to defend Azeroth from its enemies.','',0,0,0,0,0,0,1,0,6,0,63313,0,26124),
(109103,'I am weary. With a worthy successor, my long vigil is at an end. Fight for truth and justice, champion. In Tyr\'s name...','',0,0,0,0,0,0,0,0,0,0,63314,0,26124),
(109104,'This has been our home since the days of my grandfather\'s grandfather. We have stood against monsters worse than this villain that faces us now and will not be intimidated.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109105,'I am not leaving, child. And that is that. No underking is going to scare me out of MY home.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109106,'I name you, $n, the First of the Council of the Black Harvest.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109107,'Fah! This is OUR mountain. Let the drogbar savages come. We have the power of the spirits, of this mountain. All they have are sticks and stones and anger.','',5,661,0,0,500,0,0,0,0,0,0,0,26124),
(109108,'Alright $n, you may want to stand back. Things are going to get hot.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109109,'Adding the sulfate now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109110,'And last but not least, the dust.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109111,'Success! I have to say, this is some of my finest work. I guess some credit goes to Deucus and his detailed design.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109112,'Jace went to scout ahead, but when these demons attacked and put up this barrier, we were separated. He\'s still out there!','',0,0,0,0,0,0,0,0,0,0,62438,0,26124),
(109113,'Look at what I can do!','',0,0,0,0,0,0,0,0,0,0,65776,0,26124),
(109114,'I can still see you.','',0,0,0,0,0,0,0,0,0,0,65775,0,26124),
(109115,'Invisibility!','',0,0,0,0,0,0,0,0,0,0,65784,0,26124),
(109116,'Amazing! Good to see the shield in your hands. Me \'n Cato will head to Dalaran and report to Tyrosus. If ye need a ride, my hippogryph\'s outside.','',0,0,0,0,0,0,1,0,0,0,63315,0,26124),
(109117,'A presence. Something new... yet familiar. Yes...','',0,0,0,0,0,0,0,0,0,0,58909,0,26124),
(109118,'Your coming was foretold in the rings. The long circle is nearly complete.','',0,0,0,0,0,0,0,0,0,0,58910,0,26124),
(109119,'Come, little ones. Savor your fear as we feast upon it!','',0,0,0,0,0,0,0,0,0,0,58911,0,26124),
(109120,'Agh!','Agh!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109121,'At last, the feeding hour!','',0,0,0,0,0,0,0,0,0,0,58912,0,26124),
(109122,'|TInterface\\Icons\\Spell_Fire_FelFlameStrike:20|t Krosus targets |cFFFF0404$n|r with an |cFFFF0404|Hspell:205344|h[Orb of Destruction]|h|r!','|TInterface\\Icons\\Spell_Fire_FelFlameStrike:20|t Krosus targets you with an |cFFFF0404|Hspell:205344|h[Orb of Destruction]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(109123,'Disgusting!!','Disgusting!!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109124,'Rejoice! The end comes soon.','',0,0,0,0,0,0,0,0,0,0,58913,0,26124),
(109125,'Oblivion offers solace. Take the gift! Take it!','',0,0,0,0,0,0,0,0,0,0,58914,0,26124),
(109126,'You have failed those who needed you.','',0,0,0,0,0,0,0,0,0,0,58915,0,26124),
(109127,'Your light sputters out...','',0,0,0,0,0,0,0,0,0,0,58916,0,26124),
(109128,'Welcome death. Do not fight it.','',0,0,0,0,0,0,0,0,0,0,58917,0,26124),
(109129,'How DARE you!!','How DARE you!!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109130,'You\'ll pay for this!','You\'ll pay for this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109131,'My eyes!','My eyes!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109132,'Someone appears to have dropped a scroll in this fountain. The writing looks like it is blurred from the water.','Someone appears to have dropped a scroll in this fountain. The writing looks like it is blurred from the water.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109133,'Return the sheep to their pens in Bradensbrook!','Return the sheep to their pens in Bradensbrook!',0,0,0,0,0,0,0,0,0,39747,0,0,26124),
(109134,'As a Shaman, you can use the aid of the elements to garner the information that was present.','As a Shaman, you can use the aid of the elements to garner the information that was present.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109135,'Mark Black Rook Falcons for Granny Marl.','Mark Black Rook Falcons for Granny Marl.',0,0,0,0,0,0,0,0,0,39747,0,0,26124),
(109136,'Your training in Inscription allows you to grasp the knowledge behind the scroll despite the obvious water damage.','Your training in Inscription allows you to grasp the knowledge behind the scroll despite the obvious water damage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109137,'Someone appears to have dropped a scroll in this fountain. The writing looks like it is blurred from the water.\n\nIt was probably important at some point in time, but has obviously been in there too long to remain legible.','Someone appears to have dropped a scroll in this fountain. The writing looks like it is blurred from the water.\n\nIt was probably important at some point in time, but has obviously been in there too long to remain legible.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109138,'Release your grip on hope.','',0,0,0,0,0,0,0,0,0,0,58918,0,26124),
(109139,'The pain of flesh is fleeting. True torment lasts forever.','',0,0,0,0,0,0,0,0,0,0,58919,0,26124),
(109140,'Graagh! What pointless impudence! We share a master!','',0,0,0,0,0,0,0,0,0,0,58920,0,26124),
(109141,'Every blow struck at our heart will be repaid a thousand fold!','',0,0,0,0,0,0,0,0,0,0,58921,0,26124),
(109142,'Out! Out! You are not yet worthy!','',0,0,0,0,0,0,0,0,0,0,58922,0,26124),
(109143,'Still you fight? Still you refuse the gift?','',0,0,0,0,0,0,0,0,0,0,58923,0,26124),
(109144,'N\'zoth... I journey... to Ny\'alotha...','',0,0,0,0,0,0,0,0,0,0,58924,0,26124),
(109145,'','Did you really think you could stop me? Foolish children!',0,0,0,0,0,0,0,0,0,0,0,66837,26124),
(109146,'','The blood of Sintharia flows through my veins and  her voice whispers to me from the Dark Beyond!',0,0,0,0,0,0,0,0,0,0,0,67026,26124),
(109147,'','The Twilight Dragonflight lives and our destiny is at hand!',0,0,0,0,0,0,0,0,0,0,0,67027,26124),
(109148,'','Cower, mortals! Obliteration is upon you!',0,0,0,0,0,0,0,0,0,0,0,67028,26124),
(109149,'','Thanks for everything, Beakbuck. I hope we meet again.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(109150,'','Don\'t worry about me. Just focus on finding Lothrius.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109151,'','Even in death we shall endure... mother I return...',0,0,0,0,0,0,0,0,0,0,0,67029,26124),
(109152,'Zinnin Smythe bows before you in silent gratitude.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(109153,'You will suffer horrors...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109154,'Thank you, friends. I admit, I doubted you\'d survive the demon\'s trap, Boros. Thought it would be just me and $n now.','',0,0,0,0,0,0,0,0,0,0,62433,0,26124),
(109155,'They closed the gates to the upper levels. $n, use your holy magic to destroy the anchoring crystal. That should open our way.','',0,0,0,0,0,0,0,0,0,0,62436,0,26124),
(109156,'','Howww did it get passst the daughters?! We will feassst on its insssides!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109157,'Thank you. Now get out of here! It\'s not safe!','Thank you. Now get out of here! It\'s not safe!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109158,'Brave of you to come, but we need to leave!','Brave of you to come, but we need to leave!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109159,'Never thought I\'d see the day...','Never thought I\'d see the day...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109160,'The end is coming!','The end is coming!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(109161,'A little bruised, but alive. Thanks.','A little bruised, but alive. Thanks.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109162,'Garuhod once mentioned that he learned most of his recipes from the priestesses here. They\'ve since gone mad and their writings are all gibberish to me, but it seems their oracle can still understand them.','',0,0,0,0,0,0,0,0,0,0,71434,0,26124),
(109163,'With this scrying orb, all their writings are clear as day! This should point us in the right direction to continue Garuhod\'s research.','',0,0,0,0,0,0,0,0,0,0,71437,0,26124),
(109164,'Easy there, Huey! Easy griffy boy!','',0,0,0,0,0,0,274,0,0,0,64288,0,26124),
(109165,'Perhaps she possesses the key to unlocking their knowledge.','',0,0,0,0,0,0,0,0,0,0,71436,0,26124),
(109166,'Garuhod may have been onto something, but I think he got his ingredients mixed up. We should try a different combination. Maybe hydra eggs and murloc eyes?','',0,0,0,0,0,0,0,0,0,0,71433,0,26124),
(109167,'Yes, these should do nicely. I\'ll have the court alchemist test this at once!','',0,0,0,0,0,0,0,0,0,0,71435,0,26124),
(109168,'','Enjoying the party?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109169,'','Ah, you must be the outlander Silgryn has told me about.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109170,'Pleased to meet you, Lady Ly\'leth.','Pleased to meet you, Lady Ly\'leth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109171,'Sup.','Sup.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109172,'','Well, aren\'t you charming?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109173,'Excellent! Now let\'s get out of here.','',0,0,0,0,0,0,0,0,0,0,62439,0,26124),
(109174,'Be on your guard. I sense a powerful demon ahead.','',0,0,0,0,0,0,0,0,0,0,62442,0,26124),
(109175,'UNUSED - Nonsense. What good are my works on the necks of those abominations? You would do well to learn from our friend here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109176,'Hop on and let\'s get movin\'. Ol\' Huey don\'t bite... much!','',0,0,0,0,0,0,1,0,0,0,62560,0,26124),
(109177,'Shoot her! SHOOT HER!','Shoot her! SHOOT HER!',0,0,0,0,0,0,0,0,0,0,68255,0,26124),
(109178,'If you had faith in the Light, demon hunter, there would be nothing to fear!','',0,0,0,0,0,0,0,0,0,0,62453,0,26124),
(109179,'It does not matter what could happen to his reputation. He has already ruined it. This is why you are still an apprentice.','',0,0,0,0,0,0,0,0,0,0,66069,0,26124),
(109180,'But master, this man was innocent! His name was cleared, surely he deserves a second chance?','',0,0,0,0,0,0,0,0,0,0,66169,0,26124),
(109181,'You have done everyone a great service, friend. Give cousin Ly\'leth my regards.','',0,0,0,0,0,0,0,0,0,0,66171,0,26124),
(109182,'To Shield\'s Rest!','',0,0,0,0,0,0,1,0,0,0,62561,0,26124),
(109183,'Make yourself comfortable. It\'s a bit of a ride to Stormheim.','',0,0,0,0,0,0,1,0,0,0,62562,0,26124),
(109184,'|TInterface\\Icons\\Spell_Holy_FistOfJustice:20|t Krosus is about to destroy the bridge with a |cFFFF0404|Hspell:205875|h[Slam]|h|r!','|TInterface\\Icons\\Spell_Holy_FistOfJustice:20|t Krosus is about to destroy the bridge with a |cFFFF0404|Hspell:205875|h[Slam]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(109185,'My wounds were severe, but $n arrived just in time.','',0,0,0,0,0,0,0,0,0,0,62450,0,26124),
(109186,'The Light has come to vanquish you, demon!','',0,0,0,0,0,0,0,0,0,0,62454,0,26124),
(109187,'Brann introduced me to Prustaga not long ago. That dwarf sure has a way with the words... he can even charm a vrykul!','',0,0,0,0,0,0,1,0,0,0,62563,0,26124),
(109188,'A prisoner! We could use her help, $n. Free her!','',0,0,0,0,0,0,0,0,1,0,62445,0,26124),
(109189,'|TInterface\\Icons\\Achievement_Boss_YoggSaron_01:20|tA Dominator Tentacle faces you and readies |cFFFF0000|Hspell:208689|h[Ground Slam]|h|r!','|TInterface\\Icons\\Achievement_Boss_YoggSaron_01:20|tA Dominator Tentacle faces you and readies |cFFFF0000|Hspell:208689|h[Ground Slam]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(109190,'Accordin\' to ancient texts we translated back in the Explorer\'s League, Titanstrike focuses the power of storms into blasts of energy.','',0,0,0,0,0,0,1,0,0,0,62564,0,26124),
(109191,'If that\'s true, it could do some serious damage to the Legion. S\'pose we\'ll find out soon enough!','',0,0,0,0,0,0,1,0,0,0,62565,0,26124),
(109192,'Druids of Azeroth, protectors of the Dream, my sons and daughters...','',0,0,0,0,0,0,0,0,0,0,66773,0,26124),
(109193,'I must speak quickly, for my mind grows clouded.','',0,0,0,0,0,0,0,0,0,0,66806,0,26124),
(109194,'I sensed Shaladrassil\'s corruption, and entered the Emerald Dream to destroy the Nightmare\'s source.','',0,0,0,0,0,0,0,0,0,0,66775,0,26124),
(109195,'Deeper and deeper I fought. When I arrived at the Rift, I saw their true strength.','',0,0,0,0,0,0,0,0,0,0,66808,0,26124),
(109197,'The Nightmare will spread like a disease, festering and multiplying. It will engulf all of Azeroth in its twisted reality.','',0,0,0,0,0,0,0,0,0,0,66774,0,26124),
(109198,'I can no longer see the way back to the Dream. I am trapped in a Nightmare of my own making.','',0,0,0,0,0,0,0,0,0,0,66807,0,26124),
(109199,'Druids, my time is done. It is up to you now.','',0,0,0,0,0,0,0,0,0,0,66790,0,26124),
(109200,'','Taz\'dingo! T\'ank ya for gettin\' me outta dere!',0,0,0,0,0,0,0,0,0,0,0,69017,26124),
(109201,'I\'ll introduce ye to Prustaga when yer ready.','',0,0,0,0,0,0,1,0,0,0,62566,0,26124),
(109202,'','I am Mayla, daughter of the late High Chieftain Ulan, and I... I speak for the tribes.',1,0,0,0,0,0,1,0,0,0,0,58699,26124),
(109203,'','Don\'t worry, they\'re friendlier than they look.',0,0,0,0,0,0,1,0,0,0,0,63611,26124),
(109204,'I\'m pleased you chose to heed our call. We\'ve discussed inviting you into our ranks for some time.','',0,0,0,0,0,0,0,0,0,0,63612,0,26124),
(109206,'None taken... so long as ye don\'t insult me face!','',0,0,0,0,0,0,396,0,0,0,63653,0,26124),
(109207,'','I\'ve heard many tales of your accomplishments. I can\'t imagine half of them could be true.',0,0,0,0,0,0,1,0,0,0,0,63654,26124),
(109208,'','It\'s good to finally see you again. I have missed our adventures together.',0,0,0,0,0,0,1,0,0,0,0,63655,26124),
(109209,'Such power! I feel the demon\'s essence infusing every fiber of my being!','',0,0,0,0,0,0,0,0,1,0,62456,0,26124),
(109210,'I fear for your soul, demon hunter. It\'s not too late! Turn to the Light and be cleansed of your corruption!','',0,0,0,0,0,0,0,0,0,0,62458,0,26124),
(109211,'Spare me your platitudes, paladin! Your people know well the horrors that the Legion plans to unleash.','',0,0,0,0,0,0,0,0,1,0,62457,0,26124),
(109212,'','Many t\'anks again, mon, for gettin\' me outta dere!',0,0,0,0,0,0,0,0,0,0,0,62467,26124),
(109213,'We seek the leader of this den of horrors, an eredar called Lady Calindris.','',0,0,0,0,0,0,0,0,0,0,62455,0,26124),
(109214,'','Aye, she be outside directin\' her demons ta load up more captives. I be havin\' a score to settle wid her, so if ya be aimin\' ta take her out, count me in!',0,0,0,0,0,0,0,0,0,0,0,62468,26124),
(109215,'Lead on, Farseer, and I shall follow.','',0,0,0,0,0,0,1,0,0,0,66847,0,26124),
(109216,'Come, let\'s move before we encounter anymore surprises.','',0,0,0,0,0,0,0,0,1,0,62448,0,26124),
(109217,'These are troubling words, Farseer.','',0,0,0,0,0,0,1,0,0,0,67030,0,26124),
(109218,'We must defeat the Twilight\'s Hammer and restore balance to Deepholm.','',0,0,0,0,0,0,1,0,0,0,67031,0,26124),
(109219,'The servant of Therazane is bound by the dark powers of the void. I hope we are not too late!','',0,0,0,0,0,0,1,0,0,0,67032,0,26124),
(109220,'The horrors... these fiends must be destroyed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109221,'Twilight whelps? I thought the Twilight Dragonflight were extinct...','',0,0,0,0,0,0,1,0,0,0,67033,0,26124),
(109222,'The Fal\'dorei have taken everything... from me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109223,'I still not stand by and watch as demons tear this world apart.$B$BThe time has come for the nightborne to earn their place on Azeroth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109224,'This one is almost lost to the corruption! We must hurry!','',0,0,0,0,0,0,1,0,0,0,67034,0,26124),
(109225,'We have put an end to the rituals, but I fear the worst is yet ahead of us...','',0,0,0,0,0,0,1,0,0,0,67035,0,26124),
(109226,'We should return to Therazane and inform her of what has transpired here.','',0,0,0,0,0,0,1,0,0,0,67036,0,26124),
(109227,'Our prey stands before us! We must strike now, before she can summon her defenses!','',0,0,0,0,0,0,0,0,1,0,62451,0,26124),
(109228,'Join me in raising a glass not only to our newest Shadow, but to the dawn of a new era for the Uncrowned.','',0,0,0,0,0,0,396,0,0,0,63620,0,26124),
(109229,'Somethin\'s off about this here brew...','',0,0,0,0,0,0,396,0,0,0,63622,0,26124),
(109230,'','Vanessa...?',0,0,0,0,0,0,0,0,0,0,0,63623,26124),
(109231,'Today, $p secured the legendary Fangs of the Devourer, and in doing so has enabled us to strike at the Legion directly.','',0,0,0,0,0,0,396,0,0,39789,63619,0,26124),
(109232,'Today, $p secured the legendary Kingslayers, and in doing so has enabled us to strike at the Legion directly.','',0,0,0,0,0,0,396,0,0,39791,63617,0,26124),
(109233,'','Get away from there!',0,0,0,0,0,0,0,0,0,0,0,67228,26124),
(109234,'','You have come to help Ly\'leth destroy our family! Be gone!',0,0,0,0,0,0,397,0,0,0,0,67229,26124),
(109235,'','Ngh! Who ARE you?!',0,0,0,0,0,0,0,0,0,0,0,67230,26124),
(109236,'','Well done!',0,0,0,0,0,0,396,0,0,0,0,63621,26124),
(109237,'Just... finish me off.','Just... finish me off.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109238,'Come with me. Ly\'leth wants to speak with you.','Come with me. Ly\'leth wants to speak with you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109239,'','She wants to preach her traitorous ideals to me further? Fine. Let us go.',0,0,0,0,0,0,0,0,0,0,0,67231,26124),
(109240,'','You\'re more resilient than I thought. I was hoping to take you somewhere a little less... populated.',0,0,0,0,0,0,1,0,0,0,0,63624,26124),
(109241,'','Come on, show me the \"legendary fighter\" I\'ve heard so much about!',0,0,0,0,0,0,0,0,0,0,0,63636,26124),
(109242,'','No! I\'ve worked too hard to be undermined by the likes of you!',0,0,0,0,0,0,0,0,0,0,0,63637,26124),
(109243,'','Oh, my head... Valeera, you okay?',0,0,0,0,0,0,396,0,0,0,0,63629,26124),
(109244,'','Valeera nods.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109245,'I was not successful in getting the Bloodtotem tribe to help us with this. I hope Jale has enough leverage.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109246,'I have only just returned from Bloodtotem lands, but I have heard of the aid you lent our people. \n\nIt shames me to see the day when outsiders like yourself are more willing to help us than our fellow tribes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109247,'We need your help negotiating with the Underking.','We need your help negotiating with the Underking.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109248,'Jale wishes to negotiate with these savages? A bold move, though probably a foolish one.','',11,1,0,0,500,0,0,0,0,0,0,0,26124),
(109249,'By the Earthmother! It is just as a I feared... the Twilight Dragonflight has returned!','',0,0,0,0,0,0,1,0,0,0,67037,0,26124),
(109250,'Take good care of it.','Take good care of it.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109251,'Don\'t get too reckless!','Don\'t get too reckless!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109252,'Bring her back in one piece!','Bring her back in one piece!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109253,'','Our work is nearly finished... do not allow these meddling shaman to interfere with the rituals!',0,0,0,0,0,0,22,0,0,0,0,66831,26124),
(109254,'','Find them! Leave no stone unturned!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109255,'','None survive, so says the Grand Magistrix!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109256,'','The Moon Guard are finished! Slay them all.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109257,'|TInterface\\Icons\\inv_feather_05.blp:20|t %s readies |cFFF00000|Hspell:210547|h[Razor Wing]|h|r.','|TInterface\\Icons\\inv_feather_05.blp:20|t %s readies |cFFF00000|Hspell:210547|h[Razor Wing]|h|r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(109258,'','Scour the stronghold. None escape alive.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109259,'I heard what you did for the Rivermane tribe.$b$bWhen we first met in Dalaran I did not expect that you would be as helpful to us as you have been.$b$bIt is much appreciated.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109260,'','Wipe this place clean of their inferior magics. The Moon Guard is finished.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109261,'For Nar\'thalas!','For Nar\'thalas!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109262,'Drive back the scaled menace!','Drive back the scaled menace!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109263,'Show the naga no mercy!','Show the naga no mercy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109264,'Face the wrath of the Nightwatchers!','Face the wrath of the Nightwatchers!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109265,'Strike down the naga filth!','Strike down the naga filth!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109266,'','Our soldiers grow weary of the naga\'s relentless assault. Rally the Nightwatchers, champion, and drive the naga back to the depths where they belong!',0,0,0,0,0,0,0,0,0,0,0,70729,26124),
(109267,'','We appreciate your help, champion. You\'ve allowed my people a moment\'s respite from the naga threat.',0,0,0,0,0,0,0,0,0,0,0,70730,26124),
(109269,'|TInterface\\Icons\\INV_Misc_Bell_01:20|tA %s has been alerted to your presence!','|TInterface\\Icons\\INV_Misc_Bell_01:20|tA %s has been alerted to your presence!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(109270,'|TInterface\\Icons\\INV_Misc_Bell_01:20|tAn alarm has been sounded! A reinforcement has entered the fray!','|TInterface\\Icons\\INV_Misc_Bell_01:20|tAn alarm has been sounded! A reinforcement has entered the fray!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109271,'The boy-king serves at the master\'s table. Three lies will he offer you.','',0,0,0,0,0,0,0,0,0,0,58925,0,26124),
(109272,'Her heart is a crater, and we have filled it.','',0,0,0,0,0,0,0,0,0,0,58926,0,26124),
(109273,'The king of diamonds has been made a pawn.','',0,0,0,0,0,0,0,0,0,0,58927,0,26124),
(109274,'At the hour of her third death, she ushers in our coming.','',0,0,0,0,0,0,0,0,0,0,58928,0,26124),
(109275,'From the earth, he draws strength. Our earth. Our strength.','',0,0,0,0,0,0,0,0,0,0,58929,0,26124),
(109276,'Its surface blazes bright, masking shadows below.','',0,0,0,0,0,0,0,0,0,0,58930,0,26124),
(109277,'','Thanks, now its time for some payback!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109278,'To find him, drown yourself in the circle of stars.','',0,0,0,0,0,0,0,0,0,0,58931,0,26124),
(109279,'Five keys to open our way. Five torches to light our path.','',0,0,0,0,0,0,0,0,0,0,58932,0,26124),
(109280,'Flesh is his gift. He is your true creator.','',0,0,0,0,0,0,0,0,0,0,58933,0,26124),
(109281,'The lord of ravens will turn the key.','',0,0,0,0,0,0,0,0,0,0,58934,0,26124),
(109283,'','Hmph... Someone will notice I am missing! They will come looking for me!',0,0,0,0,0,0,0,0,0,0,0,67232,26124),
(109284,'I will start the ritual at your command.$B$BThe twins won\'t take too kindly to being summoned, so be prepared for a fight.$B$BOnce they are weakened, use the Bloodstone to enslave them.$B$BAre you ready to begin?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(109285,'','True. You will have to make an appearance.',0,0,0,0,0,0,0,0,0,0,0,67227,26124),
(109286,'','Use the Bloodstone!',0,0,0,0,0,0,1,0,0,0,0,66514,26124),
(109287,'Welcome to Mornath\'s Manor of Mystery! I have all manner of mysterious curios from before and after the Sundering.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109288,'He insists that you return it, and that I may use force if necessary.','He insists that you return it, and that I may use force if necessary.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109289,'','Friend, the withered are relentless in their attacks on our whelplands. They\'ve left our captive young starving for mana!',0,0,0,0,0,0,0,0,0,0,0,70775,26124),
(109290,'','Take back the mana crystals the withered stole and use them to revive the whelplings. Move quickly, friend!',0,0,0,0,0,0,0,0,0,0,0,70776,26124),
(109291,'','Your actions have ensured a future for the blue dragons in Azsuna. With the withered\'s threat subsided, you\'ve given us the time we need to recover.',0,0,0,0,0,0,0,0,0,0,0,70777,26124),
(109292,'How brave of you, $n.','How brave of you, $n.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109293,'I owe you a debt of gratitude.','I owe you a debt of gratitude.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109294,'These bandages... thank you.','These bandages... thank you.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109295,'I... I must get back to battle!','I... I must get back to battle!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109296,'A little shaken, but I\'ll be alright.','A little shaken, but I\'ll be alright.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109297,'For the Alliance!','For the Alliance!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109298,'','You will join the eternal hunt!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109299,'Ah yes, the heroes have arrived. So persistent. So confident. But your arrogance will be your undoing!','',0,0,0,0,0,0,0,0,0,0,58777,0,26124),
(109300,'Have you forgotten your humiliation on the Broken Shore? How your precious high king was bent and broken before me? Will you beg for your lives as he did, whimpering like some worthless dog?','',0,0,0,0,0,0,0,0,0,0,58778,0,26124),
(109301,'Have you forgotten your humiliation on the Broken Shore? How your mighty warchief was stuck in the belly like a helpless piglet? Will you die slowly as he did, consumed by fel corruption and squealing for a merciful end?','',0,0,0,0,0,0,0,0,0,0,58779,0,26124),
(109302,'Your pathetic Alliance will fall to dust. Your new boy-king will bow down and serve me... as will all of you!','',0,0,0,0,0,0,0,0,0,0,58780,0,26124),
(109303,'Your pathetic Horde will fall to dust. In the end, death will inherit this world and she will be waiting.','',0,0,0,0,0,0,0,0,0,0,58781,0,26124),
(109304,'The husk of Illidan will prove an ideal vessel for my master\'s glory. Sargeras will rise, and together we will watch your world burn!','',0,0,0,0,0,0,0,0,0,0,58782,0,26124),
(109305,'','None will defile the warlord\'s hoard!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109306,'Let the endgame begin!','',0,0,0,0,0,0,0,0,0,0,58783,0,26124),
(109307,'You will not stop the ritual!','',0,0,0,0,0,0,0,0,0,0,58772,0,26124),
(109308,'The vessel must be made ready!','',0,0,0,0,0,0,0,0,0,0,58773,0,26124),
(109309,'One by one you fall!','',0,0,0,0,0,0,0,0,0,0,58784,0,26124),
(109310,'You should have bent the knee!','',0,0,0,0,0,0,0,0,0,0,58785,0,26124),
(109311,'Surrender! I may yet show mercy!','',0,0,0,0,0,0,0,0,0,0,58786,0,26124),
(109312,'Thus do the champions of this world fall!','',0,0,0,0,0,0,0,0,0,0,58787,0,26124),
(109313,'No more distractions! I have work to do...','',0,0,0,0,0,0,0,0,0,0,58788,0,26124),
(109314,'Come forth and serve me!','',0,0,0,0,0,0,0,0,0,0,58789,0,26124),
(109315,'Strike for Sargeras!','',0,0,0,0,0,0,0,0,0,0,58790,0,26124),
(109316,'Rid me of these pests!','',0,0,0,0,0,0,0,0,0,0,58791,0,26124),
(109317,'Kill them in my master\'s name!','',0,0,0,0,0,0,0,0,0,0,58792,0,26124),
(109318,'I\'ll make ashes of you!','',0,0,0,0,0,0,0,0,0,0,58793,0,26124),
(109319,'You dare trespass at the heart of the Nightmare itself? Foolish mortals! Here, my will is absolute. Here, I am the master!','',0,0,0,0,0,0,0,0,0,0,58725,0,26124),
(109320,'My will is unbreakable!','',0,0,0,0,0,0,0,0,0,0,58794,0,26124),
(109321,'You\'ll never escape my grasp!','',0,0,0,0,0,0,0,0,0,0,58795,0,26124),
(109322,'Behold... power given form!','',0,0,0,0,0,0,0,0,0,0,58796,0,26124),
(109323,'Drink in the glory!','',0,0,0,0,0,0,0,0,0,0,58797,0,26124),
(109324,'Burn from within!','',0,0,0,0,0,0,0,0,0,0,58798,0,26124),
(109325,'A taste of the master\'s might!','',0,0,0,0,0,0,0,0,0,0,58799,0,26124),
(109326,'The Nightmare has corrupted dragons, gods, and legends. Your downfall will be simple and swift!','',0,0,0,0,0,0,0,0,0,0,58726,0,26124),
(109327,'Let the storm rain death upon you!','',0,0,0,0,0,0,0,0,0,0,58800,0,26124),
(109328,'Never underestimate a master warlock!','',0,0,0,0,0,0,0,0,0,0,58801,0,26124),
(109329,'Another dreamer for my Nightmare!','',0,0,0,0,0,0,0,0,0,0,58727,0,26124),
(109330,'You failed, heroes! The ritual is upon us! But first, I\'ll indulge myself a bit... and finish you!','',0,0,0,0,0,0,0,0,0,0,58774,0,26124),
(109331,'You will never stir again!','',0,0,0,0,0,0,0,0,0,0,58742,0,26124),
(109332,'Why won\'t you die? Why do you keep resisting?','',0,0,0,0,0,0,0,0,0,0,58775,0,26124),
(109333,'Eternal slumber! Eternal madness!','',0,0,0,0,0,0,0,0,0,0,58728,0,26124),
(109334,'This fate awaits you all!','',0,0,0,0,0,0,0,0,0,0,58729,0,26124),
(109335,'My victory draws near!','',0,0,0,0,0,0,0,0,0,0,58743,0,26124),
(109336,'Your souls are mine, woven for all time into the fabric of the Nightmare!','',0,0,0,0,0,0,0,0,0,0,58730,0,26124),
(109337,'Those ghosties are stirrin\' up the winds! Might need ta stop \'em the ol\' fashioned way!','',0,0,0,0,0,0,0,0,0,0,62576,0,26124),
(109338,'I will not fail you, master! More power... just need more power...','',0,0,0,0,0,0,0,0,0,0,58776,0,26124),
(109339,'My victory is absolute. The power of Nightmare grows!','',0,0,0,0,0,0,0,0,0,0,58744,0,26124),
(109340,'NO! I will not permit it!','',0,0,0,0,0,0,0,0,0,0,58731,0,26124),
(109341,'They are mine, Ysera! You cannot save them!','',0,0,0,0,0,0,0,0,0,0,58745,0,26124),
(109342,'Embrace the Dreaming, champions! It can save you!','',0,0,0,0,0,0,0,0,0,0,58732,0,26124),
(109343,'Let the Dreaming wash away his darkness!','',0,0,0,0,0,0,0,0,0,0,58733,0,26124),
(109344,'No more dreams! Only Nightmare!','',0,0,0,0,0,0,0,0,0,0,58734,0,26124),
(109345,'Your respite is over! Awaken and face your doom!','',0,0,0,0,0,0,0,0,0,0,58735,0,26124),
(109346,'My work... left... unfinished...','',0,0,0,0,0,0,0,0,0,0,58746,0,26124),
(109347,'Nightmares are... never... forgotten...','',0,0,0,0,0,0,0,0,0,0,58736,0,26124),
(109348,'I\'ll slice into the heart of you!','',0,0,0,0,0,0,0,0,0,0,58737,0,26124),
(109349,'I will sever you from the waking world!','',0,0,0,0,0,0,0,0,0,0,58747,0,26124),
(109350,'Time to cut the last tether to your mortal life!','',0,0,0,0,0,0,0,0,0,0,58748,0,26124),
(109351,'Feel the devastation of the Nightmare!','',0,0,0,0,0,0,0,0,0,0,58749,0,26124),
(109352,'I\'ll level you one by one!','',0,0,0,0,0,0,0,0,0,0,58750,0,26124),
(109353,'Time to crush your dreams!','',0,0,0,0,0,0,0,0,0,0,58751,0,26124),
(109354,'Succumb to the madness!','',0,0,0,0,0,0,0,0,0,0,58752,0,26124),
(109355,'Give in to the Nightmare!','',0,0,0,0,0,0,0,0,0,0,58753,0,26124),
(109356,'Your dreams are mine!','',0,0,0,0,0,0,0,0,0,0,58754,0,26124),
(109357,'Your torment will be unending!','',0,0,0,0,0,0,0,0,0,0,58755,0,26124),
(109358,'There is no escape!','',0,0,0,0,0,0,0,0,0,0,58756,0,26124),
(109359,'Heroes! Champions! Step forth and hear me!','',0,0,0,0,0,0,0,0,0,0,58741,0,26124),
(109360,'The Nightmare has long been a cancer eager to consume the Emerald Dream. Had Xavius succeeded, his corruption would have overwhelmed Azeroth, giving rise to a living Nightmare.','',0,0,0,0,0,0,0,0,0,0,58740,0,26124),
(109361,'Your triumph restores the Dream and safeguards your world. The allies of Xavius will never relent, but this road, at least, is closed to them.','',0,0,0,0,0,0,0,0,0,0,58739,0,26124),
(109362,'To honor your courage, I offer passage into the pure heart of the Dream. As you feel the essence of life blooming beneath your feet, know that it endures thanks to what you achieved this day.','',0,0,0,0,0,0,0,0,0,0,58738,0,26124),
(109363,'Out of the rolling ocean I rise. The Lord of Tides has answered your call, Farseer of the Earthen Ring.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109364,'','Heretic! I will slay you in Volund\'s name!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109365,'The time has come to use the Idol of the Wilds and call upon the great god, Malorne. Never did I believe I would see the great ancient himself. This is a moment that we will speak of for ages to come.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109366,'I am ready to begin.','I am ready to begin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109367,'My chosen will protect me for all eternity!','',0,0,0,0,0,0,0,0,0,0,62575,0,26124),
(109368,'You are not worthy of Titanstrike\'s might!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109369,'','I grow tired of this! Be consumed by the darkness!',0,0,0,0,0,0,0,0,0,0,0,62443,26124),
(109370,'','It\'s just you and me now, little priest! Your pathetic Light won\'t save you!',0,0,0,0,0,0,0,0,0,0,0,62446,26124),
(109371,'It seems Garuhod\'s recipe was incomplete. My alchemists think some bile might be needed to balance this out. It\'s supposed to have some amazing properties!','',0,0,0,0,0,0,0,0,0,0,71438,0,26124),
(109372,'Fetch me some livers from the bears in the highlands. Only the fat ones will do! Oh, and some hippogryph eggs as well. A little variety can\'t hurt.','',0,0,0,0,0,0,0,0,0,0,71439,0,26124),
(109373,'Wonderful! I feel like we\'re on the cusp of discovering the cure to this curse! Who would\'ve thought that a lush like Garuhod might have held the key to our freedom?','',0,0,0,0,0,0,0,0,0,0,71440,0,26124),
(109374,'','What is that noise? Naranoth! If you allow another jailbreak, I\'ll strand you on this pathetic rock and leave you to rot!',0,0,0,0,0,0,0,0,0,0,0,62434,26124),
(109375,'','Are you truly so stupid? You presume to challenge an eredar sorceress of the Burning Legion?',0,0,0,0,0,0,0,0,0,0,0,62437,26124),
(109376,'','My darkness will consume you!',0,0,0,0,0,0,0,0,0,0,0,62440,26124),
(109377,'','No! My staff is absorbing the Light! Damn you, priest, and your accursed magic!',0,0,0,0,0,0,0,0,0,0,0,62449,26124),
(109378,'','My staff... it senses the Light within you! What is it... Nooooo!',0,0,0,0,0,0,0,0,0,0,0,62452,26124),
(109379,'There, up ahead! That door\'s glowin\' with the same energy as all o\' these spirits.','',0,0,0,0,0,0,0,0,0,0,62577,0,26124),
(109380,'He dares to send someone in his stead? That accursed wretch.','He dares to send someone in his stead? That accursed wretch.',0,0,0,0,0,0,0,0,0,0,0,65846,26124),
(109381,'','I will dispel the runes. Protect me!',0,0,0,0,0,0,1,0,0,0,0,62578,26124),
(109382,'Will do, Prust!','',0,0,0,0,0,0,273,0,0,0,62579,0,26124),
(109383,'','Despoilers! Halt!',0,0,0,0,0,0,0,0,0,0,0,64166,26124),
(109384,'','You pollute this hallowed ground with your greed. Begone!',0,0,0,0,0,0,0,0,0,0,0,64167,26124),
(109385,'','Prophet\'s mercy! What is that?!',0,0,0,0,0,0,0,0,4,0,0,69919,26124),
(109386,'What are you filthy mortals doing near the master\'s portal? I\'ll rip the answer from your souls!','',0,0,0,0,0,0,0,0,4,0,69918,0,26124),
(109387,'Salma! Where\'s my Salma!?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109388,'','My husband! Is he alright?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109389,'','I will make this lake beautiful...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109390,'Do you even call this laboring? The master will have your hides!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109391,'If I catch you drinking the reagents again, I\'ll turn you over to master!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109392,'Hello. Have you come to join the Empyrean Society of Exotic Magical Arts?','Hello. Have you come to join the Empyrean Society of Exotic Magical Arts?',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(109393,'That\'s the spirit! One down, two to go!','',0,0,0,0,0,0,5,0,0,0,62580,0,26124),
(109394,'','They grow in strength. Be ready!',0,0,0,0,0,0,0,0,0,0,0,62581,26124),
(109395,'Look! The door\'s openin\'!','',0,0,0,0,0,0,5,0,0,0,62582,0,26124),
(109397,'Keep them from entering the chamber! The ritual is almost complete!','Keep them from entering the chamber! The ritual is almost complete!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109398,'','You two can yell at each other later! It be time ta get outta dis place!',0,0,0,0,0,0,0,0,0,0,0,62469,26124),
(109399,'As an elemental shaman you commune with ancient spirits and command primal elemental forces.','',0,0,0,0,0,0,0,0,0,0,59990,0,26124),
(109400,'Use Flame Shock on the target dummy.','',0,0,0,0,0,0,0,0,0,0,59991,0,26124),
(109401,'Why stop with fire? Once your enemies are burning, you can hurl molten lava at them.','',0,0,0,0,0,0,0,0,0,0,59992,0,26124),
(109402,'Use Lava Burst on the target dummy.','',0,0,0,0,0,0,0,0,0,0,59993,0,26124),
(109403,'Hurling lightning from your hands is your main weapon for overcoming enemies.','',0,0,0,0,0,0,0,0,0,0,59994,0,26124),
(109404,'Use Lightning Bolt on the target dummy.','',0,0,0,0,0,0,0,0,0,0,59995,0,26124),
(109405,'Be wary, my friend- their constructs do not seem at all effected by my runes.','',0,0,0,0,0,0,1,0,0,0,68992,0,26124),
(109406,'Shaman of the Earthen Ring, let our powers combine!','',0,0,0,0,0,0,669,0,0,0,66826,0,26124),
(109407,'We call upon Neptulon, the great Lord of Tides, in the name of Azeroth!','',0,0,0,0,0,0,0,0,0,0,67038,0,26124),
(109408,'','If it weren\'t for Beakbuck I would most certainly be dead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109409,'I need another invisibility spell applied.','I need another invisibility spell applied.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109410,'Hear our words and answer the call of the Earthen Ring!','',0,0,0,0,0,0,0,0,0,0,67039,0,26124),
(109411,'You can make your way there through the portal to Dalaran Crater. I will meet you there with additional forces.','',0,0,0,0,0,0,1,0,0,0,63344,0,26124),
(109412,'Enchanters all have a deep understanding of the arcane. This magic can be rerouted to provide assistance.','Enchanters all have a deep understanding of the arcane. This magic can be rerouted to provide assistance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109413,'','Titanstrike is close.',0,0,0,0,0,0,1,0,0,0,0,62594,26124),
(109414,'By Magni\'s beard! This Volund sure had a taste for titan relics!','',0,0,0,0,0,0,603,0,0,0,62595,0,26124),
(109415,'Lookee here... a mechagnome! Brann told me all about these things. It might be able to help us find Titanstrike!','',0,0,0,0,0,0,603,0,0,0,62596,0,26124),
(109416,'As a Leatherworker, you recognize this type of tannin. Exposing it to the night air should ruin it for any future use.','As a Leatherworker, you recognize this type of tannin. Exposing it to the night air should ruin it for any future use.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109417,'Now let\'s see... plug this in over here... realign the power unit...','',0,0,0,0,0,0,0,0,0,0,62583,0,26124),
(109418,'Remote relay observer unit XR9-47 active. System status: damaged. Rebooting. Please stand by.','',0,0,0,0,0,0,0,0,0,0,62584,0,26124),
(109419,'Efrina, find your brother and rally at the tomb.','',0,0,0,0,0,0,1,0,0,0,63345,0,26124),
(109420,'','They\'re coming to life!',0,0,0,0,0,0,0,0,0,0,0,62585,26124),
(109421,'By the Earthmother!','',0,0,0,0,0,0,0,0,0,0,67040,0,26124),
(109422,'Back to the depths with you, Ozumat. Your master commands it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109423,'Shaman of the Earthen Ring, you have called, but I already know the threat we face.','',0,0,0,0,0,0,0,0,0,0,66827,0,26124),
(109424,'Earth Shock is one of your most powerful spells. Casting it requires Maelstrom, a resource generated by your other attacks.','',0,0,0,0,0,0,0,0,0,0,59996,0,26124),
(109425,'Use Earth Shock on this target dummy.','',0,0,0,0,0,0,0,0,0,0,59997,0,26124),
(109426,'The Burning Legion has come. You should make use of the little time you have left, mortals.','',0,0,0,0,0,0,0,0,0,0,67041,0,26124),
(109429,'Foolish mortals! There is no unity among the Lords of Elements!','',0,0,0,0,0,0,0,0,0,0,67042,0,26124),
(109430,'What do you suggest, little orc? Shall I fight the Burning Legion myself?','',0,0,0,0,0,0,0,0,0,0,67043,0,26124),
(109431,'','An\'anora!',0,0,0,0,0,0,0,0,0,0,0,67226,26124),
(109432,'Come forward then. Let me look upon this champion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109433,'Ahh yes... I have seen you before! There is power in you... but not enough to defeat the Burning Legion alone.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109434,'Ever wanted to turn someone into a frog? Hex allows you to do just that!','',0,0,0,0,0,0,0,0,0,0,60000,0,26124),
(109435,'Turn my soldier into a frog!','',0,0,0,0,0,0,0,0,0,0,60001,0,26124),
(109436,'There are times you\'ll face multiple opponents on the battlefield. Fortunately, you have a potent ability called Chain Lightning.','',0,0,0,0,0,0,0,0,0,0,60002,0,26124),
(109437,'Use Chain Lightning against several enemies at once.','',0,0,0,0,0,0,0,0,0,0,60003,0,26124),
(109438,'There was a time, long ago, when the elements fought as one... perhaps there is still hope.','',0,0,0,0,0,0,0,0,0,0,67044,0,26124),
(109439,'Very well, shaman. I will join the fight to save this world.','',0,0,0,0,0,0,0,0,0,0,66828,0,26124),
(109440,'You\'ve taken damage, but this presents no problem for you.','',0,0,0,0,0,0,0,0,0,0,60004,0,26124),
(109441,'Use Healing Surge to replenish your health to full.','',0,0,0,0,0,0,0,0,0,0,60005,0,26124),
(109442,'System status: functional. Rerouting commands to maker\'s console.','',0,0,0,0,0,0,0,0,0,0,62586,0,26124),
(109443,'Unleash the elements to achieve victory, $p!','',0,0,0,0,0,0,0,0,0,0,59998,0,26124),
(109444,'Well done, $p! You are now prepared to do battle as an elemental shaman.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109445,'Maker? Oh no... please don\'t be him...','',0,0,0,0,0,0,6,0,0,0,62587,0,26124),
(109446,'Hmmpf! Would you bow to Sargeras and be his slave instead? Pathetic!','',0,0,0,0,0,0,669,0,0,0,67045,0,26124),
(109447,'You will not fight alone. The Earthen Ring is with you, and we will gather the other Elemental Lords to our cause!','',0,0,0,0,0,0,0,0,0,0,67046,0,26124),
(109448,'Bronzebeard? Ah yes, there you are! My records show this unit has been inactive for millennia. It was stolen from my lab long ago.','',0,0,0,0,0,0,1,0,0,0,62588,0,26124),
(109449,'For the last time, I\'m not Brann!','',0,0,0,0,0,0,603,0,0,0,62589,0,26124),
(109450,'','Where is Titanstrike, little tinkerer?',0,0,0,0,0,0,1,0,0,0,0,62590,26124),
(109451,'The gun is there? Most curious! Telemetry coming in... the Broken Isles... vrykul tomb... Ah yes, I see it now!','',0,0,0,0,0,0,1,0,0,0,62591,0,26124),
(109452,'Oh my stars! Yes, this is it! The lid is attuned to a particular frequency. I just need to transmit a signal like so, and...','',0,0,0,0,0,0,1,0,0,0,62592,0,26124),
(109453,'All is not lost, Tidehunter. If the Elemental Lords unite...','',0,0,0,0,0,0,0,0,0,0,67047,0,26124),
(109454,'Your skill in Skinning allows you to recognize the vellum this is inscribed upon despite the water damage. Releasing the magic within should be no problem.','Your skill in Skinning allows you to recognize the vellum this is inscribed upon despite the water damage. Releasing the magic within should be no problem.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109455,'This citizen appears to have been injured by fel magic... his fel-seared wounds look to resist normal recovery.','This citizen appears to have been injured by fel magic... his fel-seared wounds look to resist normal recovery.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109456,'Your skill in First Aid allows you to recognize what is needed to ensure this one does not perish.','Your skill in First Aid allows you to recognize what is needed to ensure this one does not perish.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109457,'While not the best solution, your Tailoring allows you to wrap up these wounds and at least stabilize this civilian.','While not the best solution, your Tailoring allows you to wrap up these wounds and at least stabilize this civilian.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109458,'This citizen appears to have been injured by fel magic... his fel-seared wounds look to resist normal recovery.\n\nWith no good way to aid this civilian, you must unfortunately continue along.','This citizen appears to have been injured by fel magic... his fel-seared wounds look to resist normal healing.\n\nWith no good way to aid this civilian, you must unfortunately continue along.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109459,'Not down here? Alright then, go ahead and use the ladder to check the upper scribrary.','',0,0,0,0,0,0,0,0,0,39849,0,0,26124),
(109460,'Don\'t give up hope, $n. Keep milling, and inspect your inks for unusual properties. Together, you and I may be able to fill in the gaps where this book is lacking.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109461,'Prepare to meet your end, mortals!','Prepare to meet your end, mortals!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(109462,'Your end is only the beginning!','Your end is only the beginning!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(109463,'The power of Sargeras courses through our veins!','The power of Sargeras courses through our veins!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(109464,'By the might of Sargeras!','By the might of Sargeras!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(109465,'Your world will burn!','Your world will burn!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(109466,'Protectors - remove these unwelcome guests!','Protectors - remove these unwelcome guests!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109467,'These mortals disrupt our ritual! Put an end to them at once.','These mortals disrupt our ritual! Put an end to them at once.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109468,'The ancient grounds of Llothien have long been abandoned. Now our ancestral land is overrun with beasts. I cannot bear to see it in such a state! Please make it right again, champion.','',0,0,0,0,0,0,0,0,0,0,70759,0,26124),
(109469,'You have my gratitude. The stones of Llothien may once again know peace, thanks to you.','',0,0,0,0,0,0,0,0,0,0,70760,0,26124),
(109470,'|TInterface\\Icons\\Ability_Rogue_EnvelopingShadows:20|tIl\'gynoth has almost completed his |cFFFF0000|Hspell:210781|h[Dark Reconstitution]|h|r!','|TInterface\\Icons\\Achievement_Boss_YoggSaron_01:20|tA Dominator Tentacle faces you and readies |cFFFF0000|Hspell:208689|h[Ground Slam]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(109471,'The drogbar are coming?','The drogbar are coming?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109472,'But... this is our land.','But... this is our land.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109473,'What? The Underking is coming? Oh no!','What? The Underking is coming? Oh no!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109474,'We need to get out of here!','We need to get out of here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109475,'Argh! Blast this wind!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109476,'Evacuate? But we have tilled this soil for generations.','Evacuate? But we have tilled this soil for generations.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109477,'Bah! The drogbar can\'t win. They are just a bunch of savages.','Bah! The drogbar can\'t win. They are just a bunch of savages.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109478,'Drogbar do not come above ground. That is something they just don\'t do.','Drogbar do not come above ground. That is something they just don\'t do.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109479,'Ah, there you are. The area was secured at great cost. This cannot continue, we must retrieve the Silver Hand and destroy the entrance to the tomb.','',0,0,0,0,0,0,1,0,0,0,63363,0,26124),
(109480,'I will complete the ritual to release the Hammer and collapse the tomb, but we must be quick. I can sense evil emanating from the tomb.','',0,0,0,0,0,0,1,0,0,0,63364,0,26124),
(109481,'You and I shall lead a small team in first. Let me know when you are ready.','',0,0,0,0,0,0,1,0,0,0,63365,0,26124),
(109482,'Danger still lurks within the tomb. Curse all the meddlers! If you keep us alive, we will clear the way.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109483,'I\'m ready.','I\'m ready to enter.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109484,'%s falls to one knee, gravely wounded.','%s falls to one knee, gravely wounded.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109485,'%s is |cFFFF0404|Hspell:204237|h[Gravely Wounded]|h|r and cannot fight until healed!','%s is |cFFFF0404|Hspell:204237|h[Gravely Wounded]|h|r and cannot fight until healed!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(109491,'Tell me about Latosius.','Tell me about Latosius.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109492,'Do you remember Suramar before the Sundering?','Do you remember Suramar before the Sundering?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109493,'We seek a powerful artifact. What do you know?','We seek a powerful artifact. What do you know?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109497,'','Jale! You have returned. Thank the spirits.',0,0,0,0,0,0,1,0,0,0,0,58855,26124),
(109498,'','Destroyed?',0,0,0,0,0,0,1,0,0,0,0,58856,26124),
(109499,'','Yes. This hero got us to safety, but we MUST get the other tribes back here to help us. We cannot stand divided.',0,0,0,0,0,0,1,0,0,0,0,58857,26124),
(109500,'There it is! Mission accomplished!','',0,0,0,0,0,0,1,0,0,0,62593,0,26124),
(109501,'Thieves! Your heads will decorate my throne!','',0,0,0,0,0,0,0,0,0,0,62600,0,26124),
(109502,'None challenge me and live.','',0,0,0,0,0,0,0,0,0,0,62601,0,26124),
(109503,'You of flesh are not worthy to wield the storms!','',0,0,0,0,0,0,0,0,0,0,62602,0,26124),
(109504,'What... what happened?','What... what happened?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109505,'I couldn\'t stop! I swear it!','I couldn\'t stop! I swear it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109506,'I feel so weak...','I feel so weak...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109507,'My... is this me? Am I myself again!?','My... is this me? Am I myself again!?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109508,'They know our secrets! Our thoughts are not our own!','They know our secrets! Our thoughts are not our own!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109509,'I felt fear like never before...','I felt fear like never before...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109510,'So helpless... where am I?','So helpless... where am I?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109511,'You are weak!','You are weak!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109512,'We are everywhere!','We are everywhere!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109513,'You cannot escape!','You cannot escape!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109514,'By the might of the Legion!','By the might of the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109515,'The Legion cannot be stopped!','The Legion cannot be stopped!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109516,'Fragile mortal! Your end has come!','Fragile mortal! Your end has come!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109517,'Your soul shall suffer!','Your soul shall suffer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109518,'Come forth and fight for the Dream!','',0,0,0,0,0,0,0,0,0,0,58859,0,26124),
(109519,'Allies! To my side!','',0,0,0,0,0,0,0,0,0,0,58860,0,26124),
(109520,'Nature will rise against you!','',0,0,0,0,0,0,0,0,0,0,58861,0,26124),
(109521,'We must strike back at the Nightmare!','',0,0,0,0,0,0,0,0,0,0,58862,0,26124),
(109522,'Attack the corruptors!','',0,0,0,0,0,0,0,0,0,0,58863,0,26124),
(109523,'The battle is joined!','',0,0,0,0,0,0,0,0,0,0,58864,0,26124),
(109524,'Noble ancient, stomp out the stain of their evil!','',0,0,0,0,0,0,0,0,0,0,58865,0,26124),
(109525,'Seeds of life, purge the wicked from this grove!','',0,0,0,0,0,0,0,0,0,0,58866,0,26124),
(109526,'Champion of the Dream, strike with wing and claw!','',0,0,0,0,0,0,0,0,0,0,58867,0,26124),
(109527,'Beloved daughter, restore my strength!','',0,0,0,0,0,0,0,0,0,0,58868,0,26124),
(109528,'Sacred vines, entangle the corrupted!','',0,0,0,0,0,0,0,0,0,0,58869,0,26124),
(109529,'Die, corrupter!','',0,0,0,0,0,0,0,0,0,0,58870,0,26124),
(109530,'The Dream must endure!','',0,0,0,0,0,0,0,0,0,0,69974,0,26124),
(109531,'Your death fortifies the Dream!','',0,0,0,0,0,0,0,0,0,0,58871,0,26124),
(109532,'Your Nightmare ends here!','',0,0,0,0,0,0,0,0,0,0,58872,0,26124),
(109533,'The impurity must be cleansed!','',0,0,0,0,0,0,0,0,0,0,58873,0,26124),
(109534,'And so the Dream is preserved!','',0,0,0,0,0,0,0,0,0,0,58874,0,26124),
(109535,'I mourn your deaths, but I could not let the Nightmare win.','',0,0,0,0,0,0,0,0,0,0,58875,0,26124),
(109536,'Father! I have... failed you...','',0,0,0,0,0,0,0,0,0,0,58876,0,26124),
(109537,'Thero\'shan... how... could you?','',0,0,0,0,0,0,0,0,0,0,58877,0,26124),
(109538,'Malfurion! No, it cannot be! I prayed my thero\'shan would never fall to the Nightmare. Yet here you stand, casting a shadow upon the purity of the Dream!','',0,0,0,0,0,0,396,0,0,0,58880,0,26124),
(109539,'Liars! Servants of darkness! It will give me no pleasure to destroy you, but my duty is to the Dream. Andu-falah-dor!','',0,0,0,0,0,0,396,0,0,0,58881,0,26124),
(109540,'Insolent whelps. Taste my steel!','',0,0,0,0,0,0,0,0,0,0,62603,0,26124),
(109541,'Is that you, Thero\'shan?','',0,0,0,0,0,0,0,0,0,0,58882,0,26124),
(109542,'Aaargh! Enough of your lies! The Nightmare must be ended!','',0,0,0,0,0,0,0,0,0,0,69973,0,26124),
(109543,'Aid me, brothers and sisters. We stand as one!','',0,0,0,0,0,0,0,0,0,0,62604,0,26124),
(109544,'You fight with noble hearts! Could it be true? Could the darkness be inside of... me?','',0,0,0,0,0,0,0,0,0,0,58883,0,26124),
(109545,'I am the scourge of a thousand plains. The terror of the isles!','',0,0,0,0,0,0,0,0,0,0,62605,0,26124),
(109546,'Father? Father, is that you?','',0,0,0,0,0,0,0,0,0,0,58884,0,26124),
(109547,'Yes, father! I will not fail you!','',0,0,0,0,0,0,0,0,0,0,58885,0,26124),
(109548,'You... cannot control...','',0,0,0,0,0,0,0,0,0,0,62606,0,26124),
(109549,'Deceiver! You corrupt the servants of the Dream!','',0,0,0,0,0,0,0,0,0,0,58886,0,26124),
(109550,'Filth! Defiler!','',0,0,0,0,0,0,0,0,0,0,58887,0,26124),
(109551,'What wickedness is this, Malfurion?','',0,0,0,0,0,0,0,0,0,0,58888,0,26124),
(109552,'Villains! You poison the children of the Dream!','',0,0,0,0,0,0,0,0,0,0,58889,0,26124),
(109553,'I have purified one of them! They fight for us now!','',0,0,0,0,0,0,0,0,0,0,58890,0,26124),
(109554,'Let the Nightmare be cleansed!','',0,0,0,0,0,0,0,0,0,0,58891,0,26124),
(109555,'I will not lose you, shan\'do!','',0,0,0,0,0,0,0,0,0,0,58892,0,26124),
(109556,'Master, we fight to save them! To save you!','',0,0,0,0,0,0,0,0,0,0,58893,0,26124),
(109557,'Cenarius! It breaks my heart to see my shan\'do twisted and torn this way. If we can subdue him, I will do everything in my power to purge the vile touch of Xavius from his spirit.','',0,0,0,0,0,0,603,0,0,0,69638,0,26124),
(109558,'Can it be? My old master is blind to the lies of Xavius and thinks WE are the source of the infestation!','',0,0,0,0,0,0,396,0,0,0,58894,0,26124),
(109559,'You have been deceived, my teacher! Xavius has twisted your perceptions! I beg of you, let me cleanse you of his evil!','',0,0,0,0,0,0,603,0,0,0,58895,0,26124),
(109560,'Yes, Cenarius! We are here to save you!','',0,0,0,0,0,0,0,0,0,0,58896,0,26124),
(109561,'Hold your weapons! He begins to see the truth!','',0,0,0,0,0,0,0,0,0,0,58897,0,26124),
(109562,'Cenarius! Do not listen to him!','',0,0,0,0,0,0,0,0,0,0,58898,0,26124),
(109563,'It is done! Cenarius is beaten, but my great teacher lives. Now I must focus all of my strength to cleanse him.','',0,0,0,0,0,0,0,0,0,0,58899,0,26124),
(109564,'Xavius waits ahead in the Rift of Aln, the true heart of the Nightmare. Would that I could fight at your side, heroes, but... to this place, I cannot go.','',0,0,0,0,0,0,0,0,0,0,58900,0,26124),
(109565,'My bond with the Emerald Dream gives me great power... but it also makes me vulnerable to the rift\'s darkness. I have peered inside it and know this to be true. Should I step within, I would be lost... just as Cenarius was.','',0,0,0,0,0,0,0,0,0,0,69640,0,26124),
(109566,'Go. Destroy the Nightmare Lord. Only this way can the Dream be restored... and Azeroth be saved.','',0,0,0,0,0,0,0,0,0,0,69639,0,26124),
(109567,'They are lying to you!','',0,0,0,0,0,0,0,0,0,0,58901,0,26124),
(109568,'Yes, my son! It is your father, Malorne! Do not trust these invaders! You must purge them from the Dream!','',0,0,0,0,0,0,0,0,0,0,58904,0,26124),
(109569,'|TInterface\\Icons\\Spell_Fire_FelFire:20|t Krosus targets |cFFFF0404you|r with an |cFFFF0404|Hspell:206677|h[Fel Brand]|h|r!','|TInterface\\Icons\\Spell_Fire_FelFlameStrike:20|t Krosus targets you with an |cFFFF0404|Hspell:205344|h[Orb of Destruction]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(109570,'Just a brief swim and we\'ll reach the tomb.','',0,0,0,0,0,0,1,0,0,0,63366,0,26124),
(109571,'Behold the Tomb of Tyr, built by the mighty... wait! These monsters dare befoul the tomb?!','',0,0,0,0,0,0,1,0,0,0,63367,0,26124),
(109572,'This cannot stand! Destroy these abominations!','',0,0,0,0,0,0,15,0,0,0,63368,0,26124),
(109573,'That wasn\'t so bad! Okay, $n, grab Titanstrike so we can get out of here.','',0,0,0,0,0,0,1,0,0,0,62597,0,26124),
(109574,'','You\'ve played your part. Now I shall play mine!',0,0,0,0,0,0,0,0,0,0,0,62598,26124),
(109575,'It pains me to see such destruction threaten the resting place of the Silver Hand.','',0,0,0,0,0,0,1,0,0,0,63369,0,26124),
(109576,'','The heart of this weapon will infuse me with the might of the titans. The vrykul shall bow before me... their new god-queen!',0,0,0,0,0,0,0,0,0,0,0,62599,26124),
(109577,'','The Legion.. will prevail!',0,0,0,0,0,0,0,0,0,0,0,71114,26124),
(109578,'','Intruders are here!',0,0,0,0,0,0,0,0,0,0,0,71113,26124),
(109579,'','The Emissary must be notified!',0,0,0,0,0,0,0,0,0,0,0,71112,26124),
(109580,'','You will never stop our plans!',0,0,0,0,0,0,0,0,0,0,0,71111,26124),
(109581,'Rest your hands upon the Idol and we will begin the ritual.','',0,0,0,0,0,0,0,0,0,0,66770,0,26124),
(109582,'','The fires will come for you!',0,0,0,0,0,0,0,0,0,0,0,71110,26124),
(109583,'I thank you all.  You have done what few others could.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109584,'Thank you, $p.  You have done what no others could.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109585,'','Who DARES challenge the Truthseeker?! I will freeze you where you stand!',0,0,0,0,0,0,0,0,0,0,0,63310,26124),
(109586,'','Protected in ice!',0,0,0,0,0,0,0,0,0,0,0,63311,26124),
(109587,'','Freeze!',0,0,0,0,0,0,0,0,0,0,0,63312,26124),
(109588,'','I have... failed...',0,0,0,0,0,0,0,0,0,0,0,63309,26124),
(109589,'For Gul\'dan!','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(109590,'The Legion claims you!','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(109591,'You can\'t... beat us all...','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(109592,'Your soul belongs to the Legion!','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(109593,'Our power will crush you!','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(109594,'Die, mortal scum!','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(109595,'I\'ll break you all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109596,'More bones to play with!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109597,'I am one... of many...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109598,'I have you now!','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(109599,'Your essence is mine!','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(109600,'No escape!','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(109601,'This one is mine!','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(109602,'Mortal flesh... so very weak!','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(109603,'My part... is played.','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(109604,'Give me your secrets!','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(109605,'Whisper your soul to me!','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(109606,'Your world will fall!','',0,0,0,0,0,0,0,8,0,0,0,0,26124),
(109607,'Keep pressing, champions! Gul\'dan wavers! He WILL fall!','',0,0,0,0,0,0,0,0,0,0,58943,0,26124),
(109608,'They will come no farther!','',0,0,0,0,0,0,0,0,0,0,58944,0,26124),
(109609,'Fight for Azeroth! For all you hold dear!','',0,0,0,0,0,0,0,0,0,0,58945,0,26124),
(109610,'We can stop him! I know it!','',0,0,0,0,0,0,0,0,0,0,58946,0,26124),
(109611,'This is our world, not the Legion\'s!','',0,0,0,0,0,0,0,0,0,0,58947,0,26124),
(109612,'Yessss. It stays in the cage, it does. It stays until master wants it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109613,'It loses hope, soon it loses its soul! Master will claim you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109616,'Not good, not good at all! You should both join me in my workshop in Ulduar at once. We have a problem to solve!','',0,0,0,0,0,0,1,0,0,0,62607,0,26124),
(109617,'<Plant a flower?>','<Plant a flower?>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109618,'Oh, this is fortunate! Titanstrike\'s power has energized this teleportation pad. I should be able to reroute its destination... Success!','',0,0,0,0,0,0,1,0,0,0,62608,0,26124),
(109619,'I would like to continue with a more difficult challenge, Latosius.','I would like to continue with a more difficult challenge, Latosius.',0,0,0,0,0,0,0,0,0,38261,0,0,26124),
(109620,'I believe I am prepared for a very difficult challenge, Latosius.','I believe I am prepared for a very difficult challenge, Latosius.',0,0,0,0,0,0,0,0,0,38261,0,0,26124),
(109621,'Your actions will be your undoing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109622,'Well, we can\'t stop now! What\'re ye waitin\' for? C\'mon, Theodore!','',0,0,0,0,0,0,603,0,0,0,62609,0,26124),
(109623,'|TInterface\\Icons\\INV_Misc_Bell_01:20|tAs the |cFFFF0000Bazaar Goods|r are tampered with, a magical alarm rings out!','|TInterface\\Icons\\INV_Misc_Bell_01:20|tAs the |cFFFF0000Bazaar Goods|r are tampered with, a magical alarm rings out!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(109624,'|TInterface\\Icons\\inv_misc_statue_04:20|tThe destruction of the |cFFFF0000Lifesized Nightborne Statue|r draws the attention of enemies!','|TInterface\\Icons\\inv_misc_statue_04:20|tThe destruction of the |cFFFF0000Lifesized Nightborne Statue|r draws the attention of enemies!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(109625,'','Your bladework is slow and thoughtless. Train harder!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109626,'','So slow, so predictable! Your swordsmanship is weak!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109627,'Bagging','Bagging',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(109628,'|TInterface\\Icons\\inv_gizmo_03:20|tThe clamor of tools repairing the pile of |cFFFF0000Discarded Junk|r echoes through the district!','|TInterface\\Icons\\inv_gizmo_03:20|tThe clamor of tools repairing the pile of |cFFFF0000Discarded Junk|r echoes through the district!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(109629,'Abra Cadabra!','Abra Cadabra!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109630,'You hear footsteps behind you!','You hear footsteps behind you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(109631,'Hey! Tha...  thash MY drink! <hic!>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(109632,'Plant aethril','Plant aethril',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109633,'Plant dreamleaf','Plant dreamleaf',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109634,'Plant foxflower','Plant foxflower',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109635,'Plant fjarnskaggl','Plant fjarnskaggl',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109636,'Plant starlight rose','Plant starlight rose',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109637,'Plant felwort','Plant felwort',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109638,'S... sleepy time... <hic!>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109639,'Over here! There\'s no time to wind your way through the entire complex.','',0,0,0,0,0,0,1,0,0,0,62647,0,26124),
(109640,'Well done, soldiers! Three of you, on me. We\'ll warn the others. The rest of you hold your -','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(109641,'Watchout! Another!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(109642,'','Ivanel Meadowsong reaches out toward the nearby hippogryph and weakly tries to shoo it away.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109643,'','Go on, fly away!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109644,'Wild Moonfall Hippogryph claws defiantly at the air and remains unmoved.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109645,'','Do not come back for us. We are already doomed by the Nightborne\'s betrayal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109646,'','We need to - Beakbuck, no!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109647,'Beakbuck turns and charges toward you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109648,'<Vanthir halts his conversation abruptly as you approach and eyes you suspiciously.>$B$BAnarys. What do you want? Are there no more demon boots left for you to lick?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109649,'','Training starts now. Are you ready?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109650,'','Ignore him. I need you to find Lothrius. We were separated in the attack- I think he is still holding out at the Athenaeum.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109651,'','Formations!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109652,'Ly\'leth would like you to visit her regarding a shipment of dusk lily pods.','Ly\'leth would like you to visit her regarding a shipment of dusk lily pods.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109653,'','Again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109654,'','Well done. Make sure to practice every day.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109655,'','You need to riposte!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109656,'','Keep at it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109657,'','Practice the basics.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109658,'','Nicely done.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109659,'','Now for the counter-attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109660,'Dusk lily pods? I see...','',0,0,0,0,0,0,0,0,0,0,67258,0,26124),
(109661,'Sometimes I forget how talented Serena is. Welcome, as it were. It is high time we dealt with these intruders.','',0,0,0,0,0,0,603,0,0,0,68991,0,26124),
(109662,'Please excuse me. I must address this immediately.','',0,0,0,0,0,0,0,0,0,0,67259,0,26124),
(109663,'','Press your advantage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109664,'I have laid out a safe path for you. Touching the crystals will summon my guardians to you. Make good use of it and go swiftly!','',0,0,0,0,0,0,603,0,0,0,66264,0,26124),
(109665,'','There!',0,0,0,0,0,0,0,0,0,0,0,66358,26124),
(109666,'','Lothrius\' magic called to me. He must still be alive! Quickly- you can help us rejoin the others.',0,0,0,0,0,0,0,0,0,0,0,66359,26124),
(109667,'','We will move when the way is clear. Your bravery is worth more than you know, friend.',0,0,0,0,0,0,0,0,0,0,0,66357,26124),
(109668,'Excellent! You made it through in one piece! You can never be sure about the reliability of stolen teleporters...','',0,0,0,0,0,0,0,0,0,0,62662,0,26124),
(109677,'I\'m preparing the diagnostic systems now. Say, you had quite an epic struggle with that ghostly vrykul warlord. The thief had it coming, if you ask me!','',0,0,0,0,0,0,0,0,0,0,62663,0,26124),
(109678,'Steam pump... check. Low-ion energy converter units... check, check, and... check.','',0,0,0,0,0,0,0,0,0,0,62664,0,26124),
(109679,'There you are! Right on schedule.','',0,0,0,0,0,0,3,0,0,0,62665,0,26124),
(109680,'Now, let\'s recall that observation unit from Stormheim.','',0,0,0,0,0,0,1,0,0,0,62666,0,26124),
(109681,'Stormheim... Stormheim... Ah, there it is.','',0,0,0,0,0,0,1,0,0,0,62667,0,26124),
(109682,'Engaging processors. Initializing download relays. I don\'t anticipate any incompatibilities with my upgraded systems.','',0,0,0,0,0,0,0,0,0,0,62668,0,26124),
(109683,'Once the process kicks into gear, it should only take a minute or two to retrieve the information from XR9-47 here. Just sit back and enjoy the science!','',0,0,0,0,0,0,0,0,0,0,62669,0,26124),
(109684,'Please... someone!','Please... someone!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109685,'Anyone? Help!','Anyone? Help!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109686,'If you wouldn\'t mind, I\'d like to help.','If you wouldn\'t mind, I\'d like to help.',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(109687,'Looks like this fight\'s just beginning.','Looks like this fight\'s just beginning.',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(109688,'Thanks. I need find the others, but hopefully this helps.','Thanks. I need find the others, but hopefully this helps.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109689,'Keep moving! They\'re everywhere!','Keep moving! They\'re everywhere!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109690,'You there! Mind lending a hand?','You there! Mind lending a hand?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109691,'My spellbook! How can I - Hey! Over here!','My spellbook! How can I - Hey! Over here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109692,'What kind of mess have I gotten myself into?','What kind of mess have I gotten myself into?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109693,'<If you had an herb, you could plant it here.>','<Plant a flower?>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109694,'More Kirin Tor Spies!','',1,0,0,0,0,0,0,0,0,0,67625,0,26124),
(109695,'Your friend has been dealt with.','',1,0,0,0,0,0,0,0,0,0,67626,0,26124),
(109696,'Now it is your turn!','',1,0,0,0,0,0,0,0,0,0,67627,0,26124),
(109697,'This looks like the perfect opportunity for me to hone my skills!','This looks like the perfect opportunity for me to hone my skills!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109698,'I seem to be missing some of my newer spells, though I\'m sure we won\'t run into too much trouble.','I seem to be missing some of my newer spells, though I\'m sure we won\'t run into too much trouble.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109699,'%s flips through the pages of his spellbook.','%s flips through the pages of his spellbook.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109700,'By the Light! What are ye doin\' all the way out here? Ne\'er mind that! Help me with this thing!','By the Light! What are ye doin\' all the way out here? Ne\'er mind that! Help me with this thing!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109701,'Ne\'er thought I\'d see you out here! Mind lendin\' a hand?','Ne\'er thought I\'d see you out here! Mind lendin\' a hand?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109702,'<The beast looks at you for a moment and neighs.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109703,'<Carefully take a small blood sample.>','<Carefully take a small blood sample.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109704,'<Obtain the blood with your dark magic.>','<Obtain the blood with your dark magic.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109705,'Mind some comp\'ny? We\'re ere fer the same cause.','Mind some comp\'ny? We\'re ere fer the same cause.',0,0,0,0,0,0,396,7,0,0,0,0,26124),
(109706,'Always wanted ta test my skills alongside a $c.','Always wanted ta test my skills alongside a $c.',0,0,0,0,0,0,396,7,0,0,0,0,26124),
(109707,'Your Voidwalker has died. Use Summon Voidwalker to bring it back.','',0,0,0,0,0,0,0,0,0,0,59042,0,26124),
(109708,'Appreciate the help, but I\'ve got ta keep movin\'.','Appreciate the help, but I\'ve got ta keep movin\'.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109709,'Once you cast Agony, you don\'t need to cast it again until your original spell is close to expiring.','',0,0,0,0,0,0,0,0,0,0,59041,0,26124),
(109710,'Agony has expired! Cast it again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109711,'Use Agony!','',0,0,0,0,0,0,0,0,0,0,59039,0,26124),
(109712,'Once you cast Corruption, you don\'t need to cast it again until your original spell is close to expiring.','',0,0,0,0,0,0,0,0,0,0,59038,0,26124),
(109713,'Corruption has expired! Cast it again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109714,'Use Corruption!','',0,0,0,0,0,0,0,0,0,0,59036,0,26124),
(109715,'What... how did...?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109716,'Use Drain Life on your target!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109717,'Use Drain Life!','',0,0,0,0,0,0,0,0,0,0,59034,0,26124),
(109718,'The intruders are here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109719,'Thank ye! Quite the brave $c, aren\'t ye.','Thank ye! Quite the brave $c, aren\'t ye.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109720,'Good work!','',0,0,0,0,0,0,0,0,0,0,59062,0,26124),
(109721,'Excellent!','',0,0,0,0,0,0,5,0,0,0,59060,0,26124),
(109722,'Great!','',0,0,0,0,0,0,0,0,0,0,59063,0,26124),
(109723,'Excellent work!','',0,0,0,0,0,0,21,0,0,0,59061,0,26124),
(109724,'Very good.','',0,0,0,0,0,0,273,0,0,0,59064,0,26124),
(109725,'I was touched... by filthy outsiders?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109726,'Well done!','',0,0,0,0,0,0,0,0,0,0,59065,0,26124),
(109727,'Have you come to join us? I hope you brought us something powerful to study.','Have you come to join us? I hope you brought us something powerful to study.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109728,'While Unstable Affliction deals damage over time, every re-cast increases its potency. Use this attack whenever you can!','',0,0,0,0,0,0,0,0,0,0,59033,0,26124),
(109729,'Unstable Affliction is available! Cast it now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109730,'Use Unstable Affliction!','',0,0,0,0,0,0,0,0,0,0,59031,0,26124),
(109731,'Use Life Tap to replenish your mana!','',0,0,0,0,0,0,0,0,0,0,59030,0,26124),
(109732,'I brought you a Pearl of Arcane Wisdom. What is it you do here, exactly?','I brought you a Pearl of Arcane Wisdom. What is it you do here, exactly?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109733,'Cast Fear!','',0,0,0,0,0,0,0,0,0,0,59029,0,26124),
(109734,'While greater demons like Infernals and Doomguards cannot be controlled for long, you can summon one to your side for short periods of time to fight for you.','',0,0,0,0,0,0,0,0,0,0,59028,0,26124),
(109735,'Are you here to learn from us? What did you bring us?','Are you here to learn from us? What did you bring us?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(109736,'Use Summon Doomguard now to summon this demon.','',0,0,0,0,0,0,0,0,0,0,59027,0,26124),
(109737,'Summon your Doomguard now!','',0,0,0,0,0,0,0,0,0,0,59026,0,26124),
(109738,'Hmm, that is indeed interesting. We study exotic magic of all types in order to prepare ourselves for ascension.','Hmm, that is indeed interesting. We study exotic magic of all types in order to prepare ourselves for ascension.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(109739,'We study that which gives us the power to ascend. You must bring your gift to Marlan.','We study that which gives us the power to ascend. You must bring your gift to Marlan.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(109740,'For the Alliance!','',0,0,0,0,0,0,5,0,0,0,59066,0,26124),
(109744,'A portion of your power can be coalesced into a Healthstone. If you take damage, ingest the Healthstone to recover health.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109746,'Use Create Healthstone.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109748,'Now, heal some of the damage you\'ve taken with your Healthstone.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109749,'Now, heal some of the damage you\'ve taken with your Healthstone.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109751,'You\'re low on health, use your Healthstone!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109752,'A well-prepared warlock can survive almost anything... even death!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109753,'Use Soulstone to survive death.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109754,'Astounding! Your mastery over demons has given you great power!','',0,0,0,0,0,0,0,0,0,0,59018,0,26124),
(109755,'','My gun... it\'s jammed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109757,'','Careful! They\'re stronger than they seem!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109758,'','Looks like you could use some company.',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(109759,'','You keep \'em at a distance. I\'ll do the rest.',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(109760,'','Be careful out here, $n. The air is full of their foul odor.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109761,'','Not too familiar with these parts. I best keep on.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109762,'Oh, my, yes! This is going to yield so much exciting data!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109763,'I\'m ready to get started.','I\'m ready to get started.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109769,'Thank you, $p, for restoring Cenarius to his natural state.  Our world has once again been saved through your deeds.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109770,'','%s gasps.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109771,'','You need to leave, $c... NOW!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109773,'','The demons are encroaching on our lands from Suramar. We must drive them back! If you take out their leaders, my Scalewardens will bring down their portals.',0,0,0,0,0,0,0,0,0,0,0,70743,26124),
(109774,'','Together we can push the Legion back!',0,0,0,0,0,0,0,0,0,0,0,70744,26124),
(109775,'','That should keep them at bay for now. Fare you well, champion. We will handle it from here!',0,0,0,0,0,0,0,0,0,0,0,70745,26124),
(109783,'Treat the patient\'s fever.','Treat the patient\'s fever.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109786,'Azsuna will fall before the Legion!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(109787,'We cannot... be stopped...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109788,'We will purge this land in fel fire!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109789,'Arkethrax... avenge me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109791,'The naga have been using their foul sorcery to dominate the minds of the local murlocs. That group there seem to be in the early stages. See if you can knock some sense back into them.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109792,'Well done! We were lucky to get to them early, before the naga\'s influence could fully take hold.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109793,'','This once-proud winery has been tainted, and foul creatures now seep from the defiled barrels. Cleanse this cursed placed!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109794,'','Pity to waste wine, but it looked like a sour vintage anyway.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109795,'','The local wildlife preys upon our injured whelplings. Please, protect them.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109796,'','That whelp will recover in time. You have my thanks.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109797,'If you want to aid our cause, you\'ll need to sharpen your skills.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109798,'','It seems you know your stuff. We may have a use for you.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109799,'','I believe I may have discovered the secret of Garuhod\'s recipe. I need you to gather some specific ingredients, but you must be careful. These creatures are most delicate!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109800,'','Excellent! I\'ll give the recipe a try. The real trick will be finding someone willing to drink it...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109801,'','Don\'t let the size of that brute fool you. He\'s as dangerous as the rest of his kind. Watch out for his poison scales!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109802,'','If you start to feel woozy from the poison, seek out a priest immediately.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109803,'Use Backstab to generate combo points.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109804,'Use Backstab!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109805,'Starting combat from stealth is more effective.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109806,'<The wind whips furiously as you approach, roiling with lightning. Perhaps a shaman could be called in to speak with the restless elemental?>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109807,'<The wind whips furiously as you approach, crackling with lightning discharges. The elemental at the storm\'s core calls out to you with a distorted voice.>$b$bPlease... shaman...$b$bI cannot contain the tempest within... Help me... Help...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109808,'While you are busy, Calydus will search for a suitable location for the ritual.','',0,0,0,0,0,0,0,0,0,0,62313,0,26124),
(109809,'','You did right by your fellow warlocks, which is commendable, and surprising.',0,0,0,0,0,0,1,0,0,0,0,66513,26124),
(109810,'','I escape one demon world, only to dwell within another demon world. \n\nAt least this one is under your control.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(109811,'','With the Dreadscar demons under your control, their power will be ours to dissect and command.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(109812,'<Zinnin bows his head slightly, silently acknowledging your presence.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109813,'Arms warriors are the ultimate physical combatants, using martial skill and weaponry to crush those who stand against them.','',0,0,0,0,0,0,0,0,0,0,60006,0,26124),
(109814,'Use your Charge ability to cover the distance to this target dummy.','',0,0,0,0,0,0,0,0,0,0,60007,0,26124),
(109815,'Warriors don\'t stroll up to face a foe! Use Charge to close the distance on your opponent. Try it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109816,'Once you reach your target you will perform basic attacks automatically, but a skilled combatant unleashes a variety of advanced abilities to defeat a foe.','',0,0,0,0,0,0,0,0,0,0,60008,0,26124),
(109817,'Use Mortal Strike on the target dummy.','',0,0,0,0,0,0,0,0,0,0,60009,0,26124),
(109818,'Mortal Strike is available!  Use it now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109819,'Use Mortal Strike!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109820,'Dealing damage to your enemy builds up Rage, which fuels your attacks. Use Slam to spend Rage and deal damage to your enemy.','',0,0,0,0,0,0,0,0,0,0,60010,0,26124),
(109821,'Use Slam on the target dummy.','',0,0,0,0,0,0,0,0,0,0,60011,0,26124),
(109822,'Use Slam!','',0,0,0,0,0,0,0,0,0,0,60021,0,26124),
(109823,'One of your most devastating attacks is Colossus Smash. Always use it as soon as it becomes available and no foe will stand against you for long.','',0,0,0,0,0,0,0,0,0,0,60012,0,26124),
(109824,'Use Colossus Smash on the Target Dummy.','',0,0,0,0,0,0,0,0,0,0,60013,0,26124),
(109825,'Colossus Smash is available! Use it now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109826,'Use Colossus Smash!','',0,0,0,0,0,0,0,0,0,0,60018,0,26124),
(109827,'After you defeat an opponent, your heart will sing with the glory of victory!','',0,0,0,0,0,0,0,0,0,0,60014,0,26124),
(109828,'Eliminate an enemy, enabling Victory Rush to be used on your next opponent.','',0,0,0,0,0,0,0,0,0,0,60015,0,26124),
(109829,'Victory Rush is available! Use it now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109830,'Use Victory Rush!','',0,0,0,0,0,0,0,0,0,0,60023,0,26124),
(109831,'Unfurl your winds, friend, and I will soothe the tempest.','Unfurl your winds, friend, and I will soothe the tempest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109832,'Calydus found a perfect spot for the ritual! Come, friend, meet Calydus in the room behind the curtains at the place called the Violet Gate.','',0,0,0,0,0,0,0,0,0,0,62312,0,26124),
(109833,'Use Shadowstrike!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109834,'Your opponents may try to overwhelm you with numbers, but they underestimate your true might!','',0,0,0,0,0,0,0,0,0,0,60024,0,26124),
(109835,'Those alarms indicate that we\'re encountering some... minor technical difficulties with the fusion press unit.','',0,0,0,0,0,0,0,0,0,0,62657,0,26124),
(109836,'Use Whirlwind to take out this group of enemies.','',0,0,0,0,0,0,0,0,0,0,60025,0,26124),
(109837,'Perfect!','',0,0,0,0,0,0,0,0,0,0,59956,0,26124),
(109838,'All you need to do is deactivate the two control panels over by the fusion press. Bronzebeard and I will man the central console.','',0,0,0,0,0,0,0,0,0,0,62658,0,26124),
(109839,'Look there! The sacred hammer\'s wards remain strong! First we must purge this infestation. Let me know when you are ready.','',0,0,0,0,0,0,1,0,0,0,63370,0,26124),
(109840,'Whirlwind can damage multiple enemies!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109841,'Use Whirlwind!','',0,0,0,0,0,0,0,0,0,0,59954,0,26124),
(109842,'In the heat of battle there will be times you need to move quickly to avoid danger... or confront it!','',0,0,0,0,0,0,0,0,0,0,59953,0,26124),
(109843,'Practice using Heroic Leap.','',0,0,0,0,0,0,0,0,0,0,59952,0,26124),
(109844,'Use Eviscerate!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109846,'You\'re in trouble! Use Vanish!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109847,'Well done, $p! You are now prepared to do battle as an arms warrior.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109848,'In order to enact the failsafe ritual we will need to clear the room. Say the word and I will begin.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109849,'Well done, $p! You are now prepared to do battle as a subtlety rogue.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109851,'Show me you fight with fearlessness and ferocity!','',0,0,0,0,0,0,0,0,0,0,59947,0,26124),
(109852,'Show me you\'ve got the stuff.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109853,'When you feel ready, explore your spellbook and the talent tree for additional abilities you can learn.','',0,0,0,0,0,0,1,0,0,0,59945,0,26124),
(109854,'Whirlwind is not the only attack you can use against multiple enemies.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109855,'Use Cleave and Whirlwind to take out this group of enemies.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109856,'Use Cleave!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109857,'Tougher enemies may require a broader range of abilities to overcome. As an alternative to Eviscerate, Nightblade can be used to deal damage over time to your target, and is a good ability to spend combo points on early in a fight. Like Eviscerate, Nightblade is a finishing move, and is best used when you have 5 combo points.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109858,'Use Nightblade with 5 combo points on the target dummy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109859,'You have 5 combo points. Use Nightblade!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109860,'Use Nightblade!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109861,'Wait until you have 5 combo points to use Nightblade!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109864,'Use Crimson Vial to restore health!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109871,'You\'re facing multiple enemies, try using Shuriken Storm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109874,'Well done, $p! You are now prepared to do battle as a retribution paladin.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109876,'Judgment is a ranged ability. Try using it from further away!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109877,'Judgment is available!  Cast it now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109878,'Cast Judgment!','',0,0,0,0,0,0,0,0,0,0,59921,0,26124),
(109879,'Blade of Justice is available!  Cast it now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109880,'Cast Blade of Justice!','',0,0,0,0,0,0,0,0,0,0,59919,0,26124),
(109881,'Use Crusader Strike to generate Holy Power!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109882,'Use Crusader Strike!','',0,0,0,0,0,0,0,0,0,0,59917,0,26124),
(109883,'Templar\'s Verdict is available! Use it now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109884,'Use Templar\'s Verdict!','',0,0,0,0,0,0,0,0,0,0,59915,0,26124),
(109885,'You\'re in trouble! Cast Divine Shield to save yourself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109886,'Use Divine Shield!','',0,0,0,0,0,0,0,0,0,0,59913,0,26124),
(109887,'Use Flash of Light to heal yourself!','',0,0,0,0,0,0,0,0,0,0,59912,0,26124),
(109888,'I\'m not... Oh, fer crying out loud!','',0,0,0,0,0,0,5,0,0,0,62659,0,26124),
(109889,'But please, don\'t hurt them too badly. I need them for later.','',0,0,0,0,0,0,0,0,0,0,59911,0,26124),
(109890,'You did it! The flames are dyin\' down.','',0,0,0,0,0,0,0,0,0,0,62660,0,26124),
(109892,'Astounding! Fusion system running at 98.33 percent efficiency. Repeating, of course.','',0,0,0,0,0,0,0,0,0,0,62661,0,26124),
(109893,'Watch yourselves! Let us cleanse this chamber!','',0,0,0,0,0,0,1,0,0,0,63371,0,26124),
(109894,'You are next in line!','You are next in line!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(109895,'Oh dear. Now the Storm Leviathan unit is experiencing a target recognition system malfunction.','',0,0,0,0,0,0,0,0,0,0,62652,0,26124),
(109896,'Activate the stabilization matrix before it tears the whole lab apart!','',0,0,0,0,0,0,0,0,0,0,62653,0,26124),
(109897,'Well done everyone, let\'s... Wait, what is that?','',0,0,0,0,0,0,1,0,0,0,63372,0,26124),
(109898,'Fool of a shaman... Even YOU could not withstand my tempest within. BEGONE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109899,'BLERG!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109900,'Blerg?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109901,'Your allies have fallen! %s retreats!','Your allies have fallen! %s retreats!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(109902,'Shaman, you braved the tempest with a peaceful mind. Your focus inspires me. Go now, with my blessings upon you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109903,'At last we can begin! After the ritual is complete and we have the hammer, the complex will collapse, sealing Tyr\'s resting place forever.','',1,0,0,5,0,0,1,0,0,0,63373,0,26124),
(109904,'Something is wrong. One of the other Sparks isn\'t here!','',0,0,0,0,0,0,1,0,0,0,63317,0,26124),
(109905,'Wait, I can sense it below, probably taken by one of those monsters. We must have it! We will begin the search when you are ready, champion.','',0,0,0,0,0,0,1,0,0,0,63374,0,26124),
(109906,'We must venture further into the depths and find the spark, or this has all been for naught.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(109907,'Our whelplings hunger for the flesh animals, but the young ones cannot stomach it raw. Plunge this lightning rod into fresh corpses and our whelps shall do the rest.','',0,0,0,0,0,0,0,0,0,0,60090,0,26124),
(109908,'Our whelps will grow strong gorging upon the feast you provided. You have our thanks.','',0,0,0,0,0,0,0,0,0,0,60091,0,26124),
(109909,'You have heard of the War of the Ancients, I am sure. If you are to listen to the Highmountain tauren, they were responsible for defeating Tichondrius.\n\nBut they had help. Much help indeed. Will you listen to my story?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109910,'Honorless murlocs have overtaken the village of Morheim. I cannot abide their presence in that once-sacred place. Eradicate this filth!','',0,0,0,0,0,0,0,0,0,0,60100,0,26124),
(109911,'Well done. I remember the one whom this village owes its name. He was a fine leader.','',0,0,0,0,0,0,0,0,0,0,60101,0,26124),
(109912,'Esara, be on your guard while inside the Empyrean Enclave.','',1,0,0,0,0,0,0,0,0,0,67628,0,26124),
(109913,'','Always, but why the warning?',1,0,0,0,0,0,0,0,0,0,0,67629,26124),
(109914,'Even experienced mages have an alarming tendency to disappear here... And we could really use you in the Tirisgarde!','',1,0,0,0,0,0,0,0,0,0,67630,0,26124),
(109915,'Look. My favorite conjuror has arrived!','',1,0,0,0,0,0,0,0,0,0,67631,0,26124),
(109916,'The children of Mimiron have crafted a clever toy they claim can harness the power of the storm. Go forth and test their handiwork in battle.','',0,0,0,0,0,0,0,0,0,0,69759,0,26124),
(109917,'A most amusing device. But cleverness is useless without strength of arms!','',0,0,0,0,0,0,0,0,0,0,69775,0,26124),
(109918,'Discipline priests draw upon the opposing forces of Light and Shadow, choosing when to heal and when to inflict damage.','',0,0,0,0,0,0,0,0,0,0,59910,0,26124),
(109919,'Use Shadow Word: Pain on the target dummy.','',0,0,0,0,0,0,0,0,0,0,59909,0,26124),
(109920,'Once your target is afflicted with Shadow Word: Pain, you don\'t need to cast it again until your original spell is close to expiring.','',0,0,0,0,0,0,0,0,0,0,59908,0,26124),
(109921,'Shadow Word: Pain has expired on your target, cast it again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109922,'Cast Shadow Word: Pain!','',0,0,0,0,0,0,0,0,0,0,59906,0,26124),
(109923,'The Light is a formidable ally, capable of restoring your friends or striking down foes.','',0,0,0,0,0,0,0,0,0,0,59905,0,26124),
(109924,'Use Penance on the target dummy.','',0,0,0,0,0,0,0,0,0,0,59904,0,26124),
(109925,'Penance is available!  Cast it now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109926,'Cast Penance now!','',0,0,0,0,0,0,0,0,0,0,59902,0,26124),
(109927,'The power of the Light allows you to Smite any enemy that stands before you!','',0,0,0,0,0,0,0,0,0,0,59901,0,26124),
(109928,'Use Smite on the target dummy.','',0,0,0,0,0,0,0,0,0,0,59900,0,26124),
(109929,'Cast Smite!','',0,0,0,0,0,0,0,0,0,0,59899,0,26124),
(109930,'Keep moving, wretch!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109931,'Quit dragging your feet! You belong to the Legion now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109932,'Leviathan unit stable! Excellent work, most excellent indeed.','',0,0,0,0,0,0,0,0,0,0,62654,0,26124),
(109933,'As followers of the light, you have many ways to protect and restore health.','',0,0,0,0,0,0,0,0,0,0,59898,0,26124),
(109934,'Use Power Word: Shield to prevent this incoming damage.','',0,0,0,0,0,0,0,0,0,0,59897,0,26124),
(109935,'Cast Power Word: Shield to protect yourself!','',0,0,0,0,0,0,0,0,0,0,59896,0,26124),
(109936,'In some battles you will face multiple opponents at the same time.','',0,0,0,0,0,0,0,0,0,0,59895,0,26124),
(109937,'Use Psychic Scream to prevent this group of enemies from hitting you.','',0,0,0,0,0,0,0,0,0,0,59894,0,26124),
(109938,'Use Psychic Scream!','',0,0,0,0,0,0,0,0,0,0,59893,0,26124),
(109939,'Well, friends, the good news is the download is 89%% complete! But we may also be experiencing a minor case of total system failure.','',0,0,0,0,0,0,0,0,0,0,62655,0,26124),
(109940,'Power Word: Shield protected you from the mage\'s first attack, but the second attack has left you wounded.','',0,0,0,0,0,0,0,0,0,0,59892,0,26124),
(109941,'Use Plea to heal your wounds.','',0,0,0,0,0,0,0,0,0,0,59891,0,26124),
(109942,'Use Plea to heal yourself!','',0,0,0,0,0,0,0,0,0,0,59890,0,26124),
(109943,'Command the forces of Shadow and Light to achieve victory!','',0,0,0,0,0,0,0,0,0,0,59889,0,26124),
(109944,'Well done, $p! You are now prepared to do battle as a discipline priest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109945,'I suppose there\'s no time like the present! This will either fix everything... or destroy us. I need you to press the big red button labeled \"DO NOT PUSH THIS BUTTON\".','',0,0,0,0,0,0,0,0,0,0,62656,0,26124),
(109946,'You are not limited to only shielding yourself or an ally. A priest can also cast a shield over an entire area, protecting all allies within its boundaries.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109947,'Use Power Word: Barrier to protect these soldiers.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109948,'Healing can also be provided by the Shadow, but it comes at a cost. Shadowmend is a very powerful heal, but part of that healing will drain away over time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109949,'Use Shadowmend to replenish your health to full.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109950,'As a windwalker monk you use your fists and your speed to overcome enemies.','',0,0,0,0,0,0,0,0,0,0,59883,0,26124),
(109951,'Pressing','Pressing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(109952,'Use Tiger Palm on the target dummy.','',0,0,0,0,0,0,0,0,0,0,59882,0,26124),
(109953,'Use Tiger Palm to generate Chi!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109954,'Use Tiger Palm!','',0,0,0,0,0,0,0,0,0,0,59880,0,26124),
(109955,'Starting combat with Tiger Palm gives you enough Chi to unleash the powerful Rising Sun Kick, an attack that uses 2 Chi and deals substantial damage.','',0,0,0,0,0,0,0,0,0,0,59879,0,26124),
(109956,'Use Rising Sun Kick on the target dummy.','',0,0,0,0,0,0,0,0,0,0,59878,0,26124),
(109957,'Rising Sun Kick is available! Use it now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109958,'Use Rising Sun Kick!','',0,0,0,0,0,0,0,0,0,0,59876,0,26124),
(109959,'While not as powerful as Rising Sun Kick, your Blackout Kick still packs a punch... or, uh, a kick!','',0,0,0,0,0,0,0,0,0,0,59875,0,26124),
(109960,'Use Blackout Kick on the target dummy.','',0,0,0,0,0,0,0,0,0,0,59874,0,26124),
(109961,'Use Blackout Kick!','',0,0,0,0,0,0,0,0,0,0,59873,0,26124),
(109962,'You have an abundance of attacks at your disposal, windwalker! Fists of Fury costs 3 Chi and does a lot of damage.','',0,0,0,0,0,0,0,0,0,0,59872,0,26124),
(109963,'Use Fists of Fury on the target dummy.','',0,0,0,0,0,0,0,0,0,0,59871,0,26124),
(109964,'Fists of Fury is available! Use it now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109965,'Use Fists of Fury!','',0,0,0,0,0,0,0,0,0,0,59869,0,26124),
(109966,'You are fast and agile, able to zip around the battlefield at will.','',0,0,0,0,0,0,0,0,0,0,59868,0,26124),
(109967,'Practice using Roll a few times.','',0,0,0,0,0,0,0,0,0,0,59867,0,26124),
(109968,'Your pet has been wounded! Fortunately, you can aid your trusty companion.','',0,0,0,0,0,0,0,0,0,0,59866,0,26124),
(109969,'Use Mend Pet to heal your pet.','',0,0,0,0,0,0,0,0,0,0,59865,0,26124),
(109970,'Your pet has died! When this happens, your Mend Pet ability changes to Revive Pet, which will bring your faithful companion back to life.','',0,0,0,0,0,0,0,0,0,0,59864,0,26124),
(109971,'Call your pet!','',0,0,0,0,0,0,0,0,0,0,59863,0,26124),
(109972,'Kill Command is available! Use it now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109973,'Use Kill Command!','',0,0,0,0,0,0,0,0,0,0,59861,0,26124),
(109974,'Dire Beast is available! Use it now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109975,'Use Dire Beast!','',0,0,0,0,0,0,0,0,0,0,59859,0,26124),
(109976,'Use Cobra Shot!','',0,0,0,0,0,0,0,0,0,0,59858,0,26124),
(109977,'Bestial Wrath is available! Use it now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109978,'Use Bestial Wrath!','',0,0,0,0,0,0,0,0,0,0,59856,0,26124),
(109979,'Your pet is hurt! Use Mend Pet!','',0,0,0,0,0,0,0,0,0,0,59855,0,26124),
(109980,'Use Multi-Shot!','',0,0,0,0,0,0,0,0,0,0,59854,0,26124),
(109981,'Divine Shield will completely protect you from all attacks for a short period of time, so save it for emergencies.','',0,0,0,0,0,0,0,0,0,0,59853,0,26124),
(109982,'The roots run deep. All will succumb to the Nightmare!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109983,'I have seen the Nightmare. The Emerald Dream will perish.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109984,'Excellent! Always remember to use Flame Shock to keep your enemies burning.','',0,0,0,0,0,0,0,0,0,0,59852,0,26124),
(109985,'I return to the Nightmare... What once was light is darkness. Come with me... come with me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109986,'Use your Lightning Bolt on the Target Dummy until you have the maximum amount of Maelstrom, then use Earth Shock.','',0,0,0,0,0,0,0,0,0,0,59851,0,26124),
(109987,'Once we clear an area, reinforcements will secure it. Onward paladins!','',0,0,0,0,0,0,1,0,0,0,63375,0,26124),
(109988,'You can call upon the earth itself to defend you and your allies in battle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109989,'Use Fire Elemental now to summon your elemental!','',0,0,0,0,0,0,0,0,0,0,59849,0,26124),
(109990,'Use Earth Elemental to summon an earthen protector for a short period.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109991,'When facing multiple enemies, you can shake the very ground beneath their feet to damage several targets at once.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109992,'Use Earthquake Totem against multiple foes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109993,'As a shaman you can commune with wolf spirits and take on their form. While this doesn\'t give you new combat abilities, it does allow you to move faster.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109994,'Practice moving around in Ghost Wolf form.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109995,'Shamans are valuable allies, as they can use their abilities to empower themselves as well as their party and raid members.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109996,'Use Heroism to temporarily increase your Haste, which speeds up your attacks and spell casts.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109997,'If you become surrounded in combat, use Thunderstorm to knock enemies back and give yourself some breathing room.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109998,'Use Thunderstorm to knock away the enemies surrounding you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(109999,'Use Flame Shock to burn your enemy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110000,'Use Flame Shock!','',0,0,0,0,0,0,0,0,0,0,59838,0,26124),
(110001,'Only use Flame Shock when it\'s about to expire!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110002,'Use Lava Burst while your enemy is burning!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110003,'Use Lava Burst!','',0,0,0,0,0,0,0,0,0,0,59835,0,26124),
(110004,'Using Lava Burst after your enemy is burning from Flame Shock increases its damage!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110005,'Use Lightning Bolt!','',0,0,0,0,0,0,0,0,0,0,59833,0,26124),
(110006,'You are at maximum Maelstrom! Use Earth Shock!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110007,'Use Earth Shock!','',0,0,0,0,0,0,0,0,0,0,59831,0,26124),
(110008,'Wait until you are at maximum Maelstrom to use Earth Shock!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110009,'Use Chain Lightning!','',0,0,0,0,0,0,0,0,0,0,59829,0,26124),
(110010,'Heal yourself with Healing Surge!','',0,0,0,0,0,0,0,0,0,0,59828,0,26124),
(110011,'Use Fire Elemental!','',0,0,0,0,0,0,0,0,0,0,59827,0,26124),
(110012,'Now would be a great time to use Earth Elemental!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110013,'You\'re facing multiple enemies, try using Earthquake Totem!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110014,'Use Bloodlust to temporarily increase your Haste, which speeds up your attacks and spell casts.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110015,'Use Thunderstorm to knock enemies away!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110016,'Download complete! Splendid work, positively splendid. Please join me at the control console.','',0,0,0,0,0,0,0,0,0,0,62648,0,26124),
(110017,'Any lout with a hammer and tongs can bang steel. It takes a master craftsman to weave the very essence of the arcane into one\'s creations, to forge weapons of cunning as well as brute strength.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(110018,'Though your kind has brought honor to these shores, some among you bring darkness as well! Even now, a plague born of a vile hybrid of the Legion and the Old Gods seeps into my sacred soil. Cleanse it!','',0,0,0,0,0,0,0,0,0,0,69774,0,26124),
(110019,'Be warned! I will not tolerate such corruption in my lands.','',0,0,0,0,0,0,0,0,0,0,69777,0,26124),
(110020,'Yes... yes, I see. Oh. No, no, no. Not good. Not good at all.','',0,0,0,0,0,0,1,0,0,0,62649,0,26124),
(110021,'What is it? Where\'s Prustaga headed?','',0,0,0,0,0,0,603,0,0,0,62650,0,26124),
(110022,'Thorim\'s throne at the Temple of Storms. I suggest you get moving. We don\'t have much time!','',0,0,0,0,0,0,1,0,0,0,62651,0,26124),
(110023,'Roll, roll, roll!','',0,0,0,0,0,0,0,0,0,0,59822,0,26124),
(110024,'Taking damage is part of battle, but you can tap the spiritual mists to heal yourself or an ally. Use Effuse to heal your wounds.','',0,0,0,0,0,0,0,0,0,0,59821,0,26124),
(110025,'Use Effuse to replenish your health to full.','',0,0,0,0,0,0,0,0,0,0,59820,0,26124),
(110026,'Heal yourself with Effuse!','',0,0,0,0,0,0,0,0,0,0,59819,0,26124),
(110027,'Let us make our way to the platform above.','',0,0,0,0,0,0,1,0,0,0,66537,0,26124),
(110028,'','I don\'t see anything unusual about this brazier. It looks to be in pretty good shape for something so ancient.',1,0,0,0,0,0,0,0,0,0,0,66475,26124),
(110029,'Show me you fight with savagery and cunning!','',0,0,0,0,0,0,1,0,0,0,59818,0,26124),
(110030,'Your allies spill the blood of their rivals upon the field of battle. Join them and prove your valor!','',0,0,0,0,0,0,0,0,0,0,60102,0,26124),
(110031,'Well done, $p! You are now prepared to do battle as an unholy death knight.','',0,0,0,0,0,0,21,0,0,0,0,0,26124),
(110032,'Roll is not your only ability for mobility. Windwalker monks can also launch themselves through the air, flying at their targets.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110033,'Use Flying Serpent Kick to travel to the target dummy and damage it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110034,'Use Flying Serpent Kick!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110035,'Sometimes you might get in over your head, facing more enemies than you can handle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110036,'Paralyze the soldier who attacks you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110037,'Fights aren\'t always fair... or are they?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110038,'Use Storm, Earth, and Fire to attack all three of these target dummies at once.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110039,'You\'re facing multiple enemies! Try using Storm, Earth, and Fire!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110040,'Your monk training has taught you the precision necessary to strike an enemy\'s pressure points. Touch of Death deals massive damage, but takes a short time to take effect.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110041,'Use Touch of Death on the target dummy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110042,'Well fought! You have shown yourself to be worthy.','',0,0,0,0,0,0,0,0,0,0,60103,0,26124),
(110043,'As a feral druid your main weapon is shapeshifting. In Cat Form, your claws and fangs rip and bleed your opponents.','',0,0,0,0,0,0,1,0,0,0,59806,0,26124),
(110044,'Use Cat Form and assume the form of a cat.','',0,0,0,0,0,0,1,0,0,0,59805,0,26124),
(110045,'You need to be in Cat Form to fight!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(110046,'You are not in Cat Form!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(110047,'As a cat you can move with uncanny stealth, allowing you to approach your enemies undetected. Prowl puts you in stealth mode.','',0,0,0,0,0,0,1,0,0,0,59802,0,26124),
(110048,'Use Prowl to enter stealth.','',0,0,0,0,0,0,1,0,0,0,59801,0,26124),
(110049,'Stealth lasts until you cancel it, attack, or take damage.','',0,0,0,0,0,0,1,0,0,0,59800,0,26124),
(110050,'Your primary attack is Shred.','',0,0,0,0,0,0,1,0,0,0,59799,0,26124),
(110051,'Use Shred on the target dummy while it\'s bleeding from Rake.','',0,0,0,0,0,0,1,0,0,0,59798,0,26124),
(110052,'Use Shred to generate combo points!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110053,'Use Shred!','',0,0,0,0,0,0,0,0,0,0,59796,0,26124),
(110054,'Our ascension is at hand. Have you brought us something worthy?','Our ascension is at hand. Have you brought us something worthy?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(110055,'Once you\'ve reached your prey in stealth, it\'s time to ambush them.','',0,0,0,0,0,0,1,0,0,0,59795,0,26124),
(110056,'Use Rake on the target dummy.','',0,0,0,0,0,0,1,0,0,0,59794,0,26124),
(110057,'Rake inflicts its damage over time, so you don\'t need to use it again until your target is no longer affected by it.','',0,0,0,0,0,0,1,0,0,0,59793,0,26124),
(110058,'Use Rake!','',0,0,0,0,0,0,0,0,0,0,59792,0,26124),
(110059,'Both your Shred and Rake abilities generate combo points which can fuel powerful finishing moves.','',0,0,0,0,0,0,1,0,0,0,59791,0,26124),
(110060,'When you have 5 combo points, use Ferocious Bite on the target dummy.','',0,0,0,0,0,0,1,0,0,0,59790,0,26124),
(110061,'You have 5 combo points! Use Ferocious Bite now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110062,'Use Ferocious Bite!','',0,0,0,0,0,0,0,0,0,0,59788,0,26124),
(110063,'Most of your attacks require energy to use. You might find yourself low on energy at times, rendering you unable to use any abilities.','',0,0,0,0,0,0,1,0,0,0,59787,0,26124),
(110064,'Use Tiger\'s Fury to restore some energy and then attack the target dummy with Shred.','',0,0,0,0,0,0,1,0,0,0,59786,0,26124),
(110065,'You\'re low on energy! Use Tiger\'s Fury!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110066,'Use Tiger\'s Fury!','',0,0,0,0,0,0,0,0,0,0,59784,0,26124),
(110067,'Tougher enemies may require a diverse set of abilities to overcome.','',0,0,0,0,0,0,1,0,0,0,59783,0,26124),
(110068,'Use Rip on the target dummy with five combo points.','',0,0,0,0,0,0,1,0,0,0,59782,0,26124),
(110069,'You have 5 combo points! Use Rip!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110070,'Use Rip!','',0,0,0,0,0,0,0,0,0,0,59780,0,26124),
(110071,'Ever needed to quickly get out of a sticky situation? You excel at doing this.','',0,0,0,0,0,0,0,0,0,0,59779,0,26124),
(110072,'Practice using Dash to increase your movement speed.','',0,0,0,0,0,0,0,0,0,0,59778,0,26124),
(110073,'You also have the ability to call on the powers of nature for a variety of other abilities, like healing!','',0,0,0,0,0,0,0,0,0,0,59777,0,26124),
(110074,'Use Regrowth to restore yourself to full health.','',0,0,0,0,0,0,0,0,0,0,59776,0,26124),
(110075,'Heal yourself with Healing Touch!','',0,0,0,0,0,0,0,0,0,0,59775,0,26124),
(110076,'Using spells will usually pull you out of shapeshift forms. Don\'t forget to return to cat form for combat.','',0,0,0,0,0,0,0,0,0,0,59774,0,26124),
(110077,'Use Cat Form.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110078,'Sometimes you need an enemy to stay put so you can close the distance to them... or make a hasty retreat.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(110079,'Use Entangling Roots to root my soldier to the ground.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(110080,'We are preparing to ascend. I hope Marlan finds your gift acceptable so you can join us.','We are preparing to ascend. I hope Marlan finds your gift acceptable so you can join us.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(110081,'Try using Entangling Roots to immobilize your target!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110082,'Try to root the target before it can reach you! Let\'s try again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110083,'Cast Entangling Roots!','',0,0,0,0,0,0,0,0,0,0,59768,0,26124),
(110084,'When in Cat Form you can rely on the instincts of an animal to help pull you through a tough fight.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(110085,'Use Survival Instincts to reduce incoming damage.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(110086,'Use Survival Instincts!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110087,'So the stories are true - you\'ve recovered Felo\'melorn!$b$bShattered during the third war, Prince Kael\'thas ordered its repair. Elven blades grow stronger with each reforging, but only in the hands of the finest craftsmen.$b$bI have never seen such a wonder. May I hold it?','',1,6,0,0,0,0,0,0,0,0,0,0,26124),
(110088,'Thrash isn\'t your only tool for fighting multiple enemies.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(110089,'Use Swipe to damage several enemies at once.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(110090,'You\'re fighting multiple enemies, try using Swipe!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110091,'Now use Swipe!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110092,'Using Thrash then Swipe is a great combination!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110093,'When fighting multiple enemies at once a feral druid can become a whirlwind of fangs and claws, damaging everything around them.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(110094,'Use Thrash to damage several enemies at once.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(110095,'Thrash continues to damage your foes for a short period, so you don\'t need to use it again until your targets stops being affected by it.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(110096,'You may. But only for a moment.','You may. But only for a moment.',1,6,0,0,0,0,0,0,0,0,0,0,26124),
(110097,'Rake has expired on your target! Use it again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110098,'Use Thrash!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110099,'Use Prowl to enter stealth!','',0,0,0,0,0,0,0,0,0,0,59754,0,26124),
(110100,'','That Pearl of Arcane Wisdom you found is quite impressive. I brought an old spell book I took from a rather nasty ghoul in Deatholme. He didn\'t know what hit him. Ha!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(110101,'','Do you enjoy traveling, $n? As the Magisters\' Seeker of Wisdom, I am on the road quite a bit. I find it strange that most sin\'dorei dislike it so much. But then I am not like most sin\'dorei, as they never fail to remind me.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(110102,'As an unholy death knight you command the powers of disease and death.','',0,0,0,0,0,0,1,0,0,0,59753,0,26124),
(110103,'Use Raise Dead to summon your minion.','',0,0,0,0,0,0,1,0,0,0,59752,0,26124),
(110104,'The best way to start a fight is to infect your enemy with a host of diseases from a distance.','',0,0,0,0,0,0,1,0,0,0,59751,0,26124),
(110105,'Use Outbreak on the target dummy.','',0,0,0,0,0,0,0,0,0,0,59750,0,26124),
(110106,'Now that your enemy is reeling from a miasma of plagues, it\'s time to strike up close.','',0,0,0,0,0,0,1,0,0,0,59749,0,26124),
(110107,'Use Festering Strike on the target dummy.','',0,0,0,0,0,0,25,0,0,0,59748,0,26124),
(110108,'Oh, that looks like it hurts! After infecting your target with Festering Strike, you are ready to burst the lesions you\'ve caused using Scourge Strike!','',0,0,0,0,0,0,5,0,0,0,59747,0,26124),
(110109,'Argent Crusaders, secure this area! We will press on!','',0,0,0,0,0,0,22,0,0,0,63376,0,26124),
(110110,'Use Scourge Strike on the target dummy after it is infected with Festering Strike.','',0,0,0,0,0,0,25,0,0,0,59746,0,26124),
(110111,'Try to only use Scourge Strike when your target is affected by Festering Wounds.','',0,0,0,0,0,0,1,0,0,0,59745,0,26124),
(110112,'Your attacks build Runic Power that can be used to cast Death Coil, a spell that hurls a blast of unholy energy at your target and restores energy to your ghoul minion.','',0,0,0,0,0,0,1,0,0,0,59744,0,26124),
(110113,'Use Death Coil on the target dummy.','',0,0,0,0,0,0,25,0,0,0,59743,0,26124),
(110114,'Your attacks sometimes allow you to cast Death Coil without costing Runic Power. Take advantage of this when you can.','',0,0,0,0,0,0,1,0,0,0,59742,0,26124),
(110115,'','Did you know that in the past many Magisters studied amongst the Kirin Tor in Dalaran? Perhaps it is time to set aside our grudge and fight the Burning Legion together.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(110116,'Some foes would prefer to keep you at arm\'s length.','',0,0,0,0,0,0,1,0,0,0,59741,0,26124),
(110117,'Use Death Grip to pull my soldier to you.','',0,0,0,0,0,0,25,0,0,0,59740,0,26124),
(110118,'Death Grip can be used from a good distance away. Try moving further away from the target and using it.','',0,0,0,0,0,0,0,0,0,0,59739,0,26124),
(110119,'Being able to call upon the powers of death means you rarely need to be outnumbered.','',0,0,0,0,0,0,1,0,0,0,59738,0,26124),
(110120,'Use Army of the Dead now to summon in your minions.','',0,0,0,0,0,0,25,0,0,0,59737,0,26124),
(110121,'Show me you\'ve mastered the powers of darkness!','',0,0,0,0,0,0,603,0,0,0,59736,0,26124),
(110122,'Your undead minion is a valuable asset in battle. Dark Transformation allows you to temporarily transform your ghoul into a hulking monstrosity with increased power and abilities. Try it out!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110123,'Use Dark Transformation to empower your ghoul.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110124,'Ah, Felo\'melorn. The Flamestrike! Such craftsmanship, such elegance...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110125,'As a death knight, you control the battlefield!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110126,'Use Death and Decay to dispatch the group of minions.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110127,'This is not some brutish cleaver for the hacking of flesh. It is the slender blade of a tactician. Strands of arcane energy have been woven into the steel with each fold. I can feel its heat radiating down my arms. Magnificent!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110128,'When taking excessive damage in battle, Death Strike can help even the odds.','',0,0,0,0,0,0,0,0,0,0,59731,0,26124),
(110129,'Use Death Strike on the target to recover some of your health.','',0,0,0,0,0,0,0,0,0,0,59730,0,26124),
(110130,'Thank you, $n. I have labored a hundred lifetimes and have not seen its like.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(110131,'Your minion is dead. Cast Raise Dead to summon a new minion.','',0,0,0,0,0,0,0,0,0,0,59729,0,26124),
(110132,'Outbreak has expired from your target, use it now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110133,'Cast Outbreak!','',0,0,0,0,0,0,0,0,0,0,59727,0,26124),
(110134,'Your target is not infested with Festering Wounds. Use Festering Strike now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110135,'Use Festering Strike!','',0,0,0,0,0,0,0,0,0,0,59725,0,26124),
(110136,'Use Scourge Strike!','',0,0,0,0,0,0,0,0,0,0,59724,0,26124),
(110137,'Using Scourge Strike after Festering Strike is a potent combination!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110138,'Death Coil is free!  Cast it now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110139,'Use Death Coil!','',0,0,0,0,0,0,0,0,0,0,59721,0,26124),
(110140,'Cast Army of the Dead!','',0,0,0,0,0,0,0,0,0,0,59720,0,26124),
(110141,'Now is a good time to cast Dark Transformation!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110142,'You\'re facing multiple enemies. Try using Death and Decay!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110143,'Use Death Strike!','',0,0,0,0,0,0,0,0,0,0,59717,0,26124),
(110144,'As a frost mage you excel at controlling the battlefield by freezing enemies in place as ice and hail pummel them into submission.','',0,0,0,0,0,0,0,0,0,0,59716,0,26124),
(110145,'Use Summon Water Elemental to summon your pet.','',0,0,0,0,0,0,0,0,0,0,59715,0,26124),
(110146,'Your most fundamental and reliable attack is Frostbolt.','',0,0,0,0,0,0,0,0,0,0,59714,0,26124),
(110147,'Use Frostbolt on the target dummy.','',0,0,0,0,0,0,0,0,0,0,59713,0,26124),
(110148,'What are you still doin\' here? Get!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(110149,'Now we\'ll take a look at Ice Lance. It\'s similar to Frostbolt, but can be cast instantly, albeit for less damage.','',0,0,0,0,0,0,0,0,0,0,59712,0,26124),
(110150,'Use Ice Lance on the frozen target dummy.','',0,0,0,0,0,0,0,0,0,0,59711,0,26124),
(110151,'There is one more way that Ice Lance can be used to maximize its power.','',0,0,0,0,0,0,0,0,0,0,59710,0,26124),
(110152,'Use Frostbolt on the target dummy until it triggers Fingers of Frost, Then use Ice Lance.','',0,0,0,0,0,0,0,0,0,0,59709,0,26124),
(110155,'Feet don\'t fail me now!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(110156,'Use Frost Bolt on the target dummy until you trigger Fingers of Frost. While the effect is active, use Ice Lance.','',0,0,0,0,0,0,0,0,0,0,59706,0,26124),
(110157,'Another potent spell you can wield is Frozen Orb. Cast this spell whenever it is available, as it can make your Ice Lance more powerful.','',0,0,0,0,0,0,0,0,0,0,59705,0,26124),
(110158,'Use Frozen Orb on the target dummy.','',0,0,0,0,0,0,0,0,0,0,59704,0,26124),
(110159,'The battlefield can be a dangerous place, so moving about is crucial to your survival.','',0,0,0,0,0,0,0,0,0,0,59703,0,26124),
(110160,'Practice using Blink.','',0,0,0,0,0,0,0,0,0,0,59702,0,26124),
(110161,'What if you could freeze foes in their tracks, preventing them from even reaching you?','',0,0,0,0,0,0,0,0,0,0,59701,0,26124),
(110162,'Freeze my soldier using Frost Nova.','',0,0,0,0,0,0,0,0,0,0,59700,0,26124),
(110163,'Remember that Ice Lance does extra damage to frozen targets, so using Frost Nova and Ice Lance together is a powerful tactic.','',0,0,0,0,0,0,0,0,0,0,75236,0,26124),
(110164,'You are master of dealing damage to many enemies at once.','',0,0,0,0,0,0,0,0,0,0,59698,0,26124),
(110165,'Use Blizzard to dispatch this group of enemies.','',0,0,0,0,0,0,0,0,0,0,59697,0,26124),
(110166,'Show me you fight with the fury of the elements!','',0,0,0,0,0,0,0,0,0,0,59696,0,26124),
(110167,'Well done, $p! You are now prepared to do battle as an enhancement shaman.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110168,'Despite your best efforts, you may not be able to prevent an enemy from reaching you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110169,'Use Ice Barrier to reduce incoming damage.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110170,'Need to get out of a fight in a hurry? Invisibility is a great spell for getting out of a sticky situation.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110171,'Use Invisibility to escape combat.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110172,'Your Water Elemental has died. Cast Summon Water Elemental to call it back!','',0,0,0,0,0,0,0,0,0,0,59690,0,26124),
(110173,'Use Frostbolt!','',0,0,0,0,0,0,0,0,0,0,59689,0,26124),
(110174,'Fingers of Frost has triggered! Use Ice Lance now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110175,'Use Ice Lance!','',0,0,0,0,0,0,0,0,0,0,59687,0,26124),
(110176,'Your target is frozen! Use Ice Lance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110177,'Frozen Orb is available! Cast it now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110178,'Use Frozen Orb!','',0,0,0,0,0,0,0,0,0,0,59684,0,26124),
(110179,'You\'re under attack! Use Frost Nova to immobilize your opponent!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110180,'You need to freeze your enemy in place before they reach you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110181,'Use Frost Nova!','',0,0,0,0,0,0,0,0,0,0,59681,0,26124),
(110182,'Cast Blizzard!','',0,0,0,0,0,0,0,0,0,0,59680,0,26124),
(110183,'Cast Ice Barrier!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110184,'Use Invisibility!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110185,'','Life never gets any easier around here.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(110186,'As an enhancement shaman you channel the elemental forces directly into your weapons to make yourself a furious melee combatant, beating down your foes with the power of flame, earth, and storm.','',0,0,0,0,0,0,0,0,0,0,59677,0,26124),
(110187,'Use Flametongue on the target dummy.','',0,0,0,0,0,0,0,0,0,0,59676,0,26124),
(110188,'Now that your weapons are burning, you can focus on your primary attack.','',0,0,0,0,0,0,0,0,0,0,59675,0,26124),
(110189,'Use Rockbiter on the target dummy.','',0,0,0,0,0,0,0,0,0,0,59674,0,26124),
(110190,'Using Rockbiter generates Maelstrom, a resource that powers stronger attacks.','',0,0,0,0,0,0,0,0,0,0,59673,0,26124),
(110191,'Use Lava Lash on the target dummy.','',0,0,0,0,0,0,0,0,0,0,59672,0,26124),
(110192,'Your most powerful Maelstrom-fueled ability is Stormstrike.','',0,0,0,0,0,0,0,0,0,0,59671,0,26124),
(110193,'Use Stormstrike on the target dummy after Stormbringer triggers.','',0,0,0,0,0,0,0,0,0,0,59670,0,26124),
(110194,'Use Stormstrike now!','',0,0,0,0,0,0,0,0,0,0,59669,0,26124),
(110195,'You share a kinship with animal spirits such as wolves.','',0,0,0,0,0,0,0,0,0,0,59668,0,26124),
(110196,'Use Feral Spirit if you need to boost your damage in a fight!','',0,0,0,0,0,0,0,0,0,0,59667,0,26124),
(110197,'If you are fighting multiple enemies, it is time to unleash the full fury of the storm!','',0,0,0,0,0,0,0,0,0,0,75245,0,26124),
(110198,'Use Crash Lightning to dispatch this group of enemies.','',0,0,0,0,0,0,0,0,0,0,75247,0,26124),
(110199,'If you find yourself taking too much punishment in a fight, Shamanistic Rage reduces incoming damage for a short period of time. Try it!','',0,0,0,0,0,0,0,0,0,0,75248,0,26124),
(110200,'Use Shamanistic Rage to reduce incoming damage.','',0,0,0,0,0,0,0,0,0,0,75249,0,26124),
(110201,'Your Flametongue buff has expired! Use Flametongue!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110202,'Use Flametongue!','',0,0,0,0,0,0,0,0,0,0,59661,0,26124),
(110203,'An entry from someone named... Abercrombie. He asked me to read the following: \'I fooled the bearer of this note into announcing my latest, most dire creation!\' Weird guy, that one.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110204,'Use Rockbiter to generate Maelstrom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110205,'Use Rockbiter!','',0,0,0,0,0,0,0,0,0,0,59659,0,26124),
(110206,'I guess Stitches just... unraveled. Get it? Stitches? Unraveled? Man, I\'m on fire!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(110207,'Lava Lash is available! Use it now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110208,'Use Lava Lash!','',0,0,0,0,0,0,0,0,0,0,59657,0,26124),
(110209,'Stormbringer has triggered! Use Stormstrike now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110210,'Use Stormstrike!','',0,0,0,0,0,0,0,0,0,0,59655,0,26124),
(110211,'Use Feral Spirit!','',0,0,0,0,0,0,0,0,0,0,59654,0,26124),
(110212,'Use Crash Lightning!','',0,0,0,0,0,0,0,0,0,0,75250,0,26124),
(110213,'As a balance druid the sun, moon, and stars are your allies, enabling you to unleash these primal powers upon your enemies.','',0,0,0,0,0,0,0,0,0,0,59652,0,26124),
(110214,'Use Moonkin Form and assume the form of a wildkin.','',0,0,0,0,0,0,0,0,0,0,59651,0,26124),
(110215,'You wield the very power of night and day against your foes. Moonfire and Sunfire represent that power.','',0,0,0,0,0,0,0,0,0,0,59650,0,26124),
(110216,'Use Moonfire and Sunfire on the target dummy.','',0,0,0,0,0,0,0,0,0,0,59649,0,26124),
(110217,'Both these attacks deal damage over time. Once cast, you don\'t need to cast them again until their effect on the target has expired.','',0,0,0,0,0,0,0,0,0,0,59648,0,26124),
(110218,'Once your enemy is taking damage from your other attacks, it\'s time to unleash Solar Wrath.','',0,0,0,0,0,0,0,0,0,0,59647,0,26124),
(110219,'Use Solar Wrath on the target dummy.','',0,0,0,0,0,0,0,0,0,0,59646,0,26124),
(110220,'One of your most potent attacks, Starsurge unleashes a surge of stellar energy at your target.','',0,0,0,0,0,0,0,0,0,0,59645,0,26124),
(110221,'I\'ll take care of this!','',0,0,0,0,0,0,1,0,0,0,63377,0,26124),
(110222,'Use Solar Wrath on the target dummy until you have enough Astral Power to cast Starsurge.','',0,0,0,0,0,0,0,0,0,0,59644,0,26124),
(110223,'Sometimes you need an enemy to stay put so you can close the distance to them... or make a hasty retreat.','',0,0,0,0,0,0,0,0,0,0,59643,0,26124),
(110224,'Use Entangling Roots to root my soldier to the ground.','',0,0,0,0,0,0,0,0,0,0,59642,0,26124),
(110225,'Show me that you can harness the power of the universe itself!','',0,0,0,0,0,0,0,0,0,0,59641,0,26124),
(110226,'Well done, $p! You are now prepared to do battle as a feral druid.','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(110227,'Well done, $p! You are now prepared to do battle as a balance druid.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110228,'Need a boost of damage? Look to the stars!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110229,'Use Celestial Alignment to increase damage, then use Solar Wrath on the target dummy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110230,'A balance druid is well equipped to face multiple opponents at once.','',0,0,0,0,0,0,0,0,0,0,75276,0,26124),
(110231,'Use Lunar Strike to dispatch this group of enemies.','',0,0,0,0,0,0,0,0,0,0,75274,0,26124),
(110232,'Use Moonkin form!','',0,0,0,0,0,0,0,0,0,0,59634,0,26124),
(110233,'Moonfire has expired on your target! Cast Moonfire on your target!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110234,'Sunfire has expired on your target! Cast Sunfire on your target!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110235,'Cast Moonfire!','',0,0,0,0,0,0,0,0,0,0,59631,0,26124),
(110236,'Cast Sunfire!','',0,0,0,0,0,0,0,0,0,0,59630,0,26124),
(110237,'Cast Solar Wrath to generate Astral Power!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110238,'Cast Solar Wrath!','',0,0,0,0,0,0,0,0,0,0,59628,0,26124),
(110239,'Starsurge is available! Cast it now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110240,'Cast Starsurge!','',0,0,0,0,0,0,0,0,0,0,59626,0,26124),
(110241,'Try using Entangling Roots to immobilize your target!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110242,'Try to root the target before it can reach you! Let\'s try again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110243,'Cast Entangling Roots!','',0,0,0,0,0,0,0,0,0,0,59623,0,26124),
(110244,'Cast Lunar Strike!','',0,0,0,0,0,0,0,0,0,0,75277,0,26124),
(110245,'Nothing you cannot handle!','',0,0,0,0,0,0,0,0,0,0,67471,0,26124),
(110246,'That is a most... unusual murloc. There\'s something familiar about him, but I can\'t quite place it. Could you take a closer look?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(110247,'Why are you interested in the Empyrean Society?','Why are you interested in the Empyrean Society?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110248,'It seems all creatures are susceptible to the Legion\'s corruption. No matter how... small.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(110249,'My patrol... they\'re dead! All dead!','My patrol... they\'re dead! All dead!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110250,'They came out of nowhere! Be careful!','They came out of nowhere! Be careful!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110251,'My thanks. Allow me to repay you with my service.','My thanks. Allow me to repay you with my service.',0,0,0,0,0,0,2,7,0,0,0,0,26124),
(110252,'','I am a bit of a misfit, to be honest. Most sin\'dorei are content to live out their entire lives within the confines of Silvermoon City. However I found it stifling after so many years living on Draenor. I\'ve never been one to hold my opinions back...\n\nWhen Grand Magister Rommath asked me to leave and become the Magisters\' Seeker of Wisdom, it was a relief for us both. I intend to discover if the Empyrean Society possesses anything of use.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(110253,'My blade is yours, $n.','My blade is yours, $n.',0,0,0,0,0,0,2,7,0,0,0,0,26124),
(110254,'What do you know about their activities?','What do you know about their activities?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110255,'Don\'t be fooled! That creature is not one of our brood. Tread carefully, hero.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(110256,'Tend to your companions\' wounds. You did well.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(110257,'','They are a secretive bunch and tend to speak in riddles, so not very much. It is known that they search the world for rare forms of magic to study, and this enclave may have found something quite powerful. \n\nI intend to discover whatever it is they are hiding.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(110258,'This chasm oozes darkness... Light protect us! That thing has what we need. Prepare yourselves, friends.','',0,0,0,0,0,0,1,0,0,0,63378,0,26124),
(110259,'','An infestation of leyworms has broken out in the Leyhollow caves! If you plug their tunnels with heavy stones, it should help contain them.',0,0,0,0,0,0,0,0,0,0,0,70756,26124),
(110260,'','What\'s that?! One of the bigger worms is burrowing through! Stand ready!',0,0,0,0,0,0,0,0,0,0,0,70757,26124),
(110261,'','I believe that will stop their influx for now. Thank you, champion.',0,0,0,0,0,0,0,0,0,0,0,70758,26124),
(110262,'This area is very unstable now thanks to the previous visitors. We need to kill that thing to get what we need, but I\'m not sure what it will do to our surroundings.\n\nIt would be best to kill it quick and get out of here. Say the word, $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(110263,'|TInterface\\Icons\\inv_pet_broom.blp:20|t %s calls Scrubbers to |cFFF00000|Hspell:207513|h[Tidy Up]|h|r.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(110264,'What\'s that sound?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110265,'Nicely done, but those demons won\'t give up so easily. Stand ready!','',0,0,0,0,0,0,0,0,0,0,59621,0,26124),
(110266,'What is that I hear?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110267,'Disturbances are punishable by death! Do not let this happen again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110268,'Next time I will see you withered for wasting my time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110273,'As a master of the elements, you are able to coalesce primal elemental forces into physical form to aid you in battle.','',0,0,0,0,0,0,0,0,0,0,59620,0,26124),
(110274,'The Gaze of the Legion has spotted you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110275,'The Aerial Command Unit can take you directly to the temple. Hop in!','',0,0,0,0,0,0,1,0,0,0,62646,0,26124),
(110276,'Welcome back to Ulduar! The Speaker awaits you in the Celestial Planetarium. Please, follow me!','',396,0,0,0,0,0,396,0,0,0,0,0,26124),
(110277,'With the corruption of the Nightmare spreading, I fear for the wildlife of Val\'Sharah. I feel some would be safer in your care.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(110278,'\"The Speaker\"? That\'s me brother Magni, ye infernal contraption!','',396,0,0,0,0,0,603,0,0,0,0,0,26124),
(110279,'While trapping animals can be traumatic, it\'s a far better fate than what awaited them. I wish you and your new companions well.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(110280,'DEPRECATED','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(110282,'DEPRECATED','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(110283,'Lost Owlkitten slowly raises its head and looks around.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110284,'Lost Owlkitten spots you and scampers away in fear!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110285,'$n! Is it true? Do you wield Felo\'melorn? Come, speak with me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110286,'I will meet you on the other side.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110287,'$n - is it true that you carry Kael\'thas\'s former blade? Come closer!','',3,0,0,0,0,0,0,0,0,0,0,0,26124),
(110288,'Felo\'melorn! A blade fit for royalty. In the hands of Anasterian Sunstrider, a thousand Amani trolls fell before its fury.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110289,'Ah! It is hot to the touch! How do you even...? No matter. I see this blade is in good hands. Thank you, $n, for allowing me to touch a piece of my peoples\' history.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110290,'I fear if we dally much longer, those giants will pound Nar\'thalas into the sea.','',1,274,0,0,0,0,0,0,0,0,0,0,26124),
(110291,'Destroy the monster! For the Light!','',0,0,0,0,0,0,15,0,0,0,63379,0,26124),
(110292,'The stories are true. A hero once more wields Felo\'melorn! I thought the blade lost in the wastes of Icecrown. As relics go, it predates the War of the Ancients. May I... may I see it?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(110293,'','Watch yourself, Andoren. Belloc would be displeased to see you fraternizing with the Alliance...',1,0,0,0,0,0,0,0,0,26703,0,0,26124),
(110294,'Pity you aren\'t joining Thorim under more pleasant circumstances. He\'s a lover of animals as well. Always going on and on about those wolves of his.','',0,0,0,0,0,0,0,0,0,0,62610,0,26124),
(110295,'Really now? \'Twill be nice to be around one of our own... even if he\'s a bit tall for my likin\'.','',0,0,0,0,0,0,0,0,0,0,62611,0,26124),
(110296,'Indeed, Bronzebeard. Now hold on! I\'m taking you in.','',0,0,0,0,0,0,0,0,0,0,62612,0,26124),
(110297,'Bronzebeard! Back again, I see! Hati has missed you, as has Skoll. Skoll? Bah! Where has that worg run off to?','',0,0,0,0,0,0,0,0,0,0,62636,0,26124),
(110298,'Ah, and you are joined by one of the mortals who freed us from the grip of the Old God! We must hold a feast to celebrate!','',0,0,0,0,0,0,0,0,0,0,62637,0,26124),
(110299,'It\'ll have to wait, Thorim. There\'s a crazed vrykul on her way here to steal the power of Titanstrike!','',0,0,0,0,0,0,1,0,0,0,62638,0,26124),
(110300,'Then we shall slay the enemy together! Come, vrykul! Face the fury of the storms!','',0,0,0,0,0,0,396,0,0,0,62639,0,26124),
(110306,'The last of my brothers and sisters. I am all that remains of the Tyr\'s Guard.','',0,0,0,0,0,0,1,0,0,0,63381,0,26124),
(110307,'I have the Spark. The battle this place has seen has warped reality too much. We must finish this now.','',0,0,0,0,0,0,1,0,0,0,63382,0,26124),
(110308,'NO! They are... gone!','',0,0,0,0,0,0,15,0,0,0,63380,0,26124),
(110310,'We have wounded! Aid them while I cover you!','',0,0,0,0,0,0,22,0,0,0,63383,0,26124),
(110311,'Excellent, and with no time to waste. Let\'s move!','',0,0,0,0,0,0,1,0,0,0,63386,0,26124),
(110312,'An intruder! I must warn the others!','',0,0,0,0,0,0,0,0,0,0,62316,0,26124),
(110313,'There you are, mortal! I sense you are near. Move quickly and head down the path!','',0,0,0,0,0,0,0,0,0,0,62315,0,26124),
(110314,'The master is gone and his minions gorge upon my power. Come, repay this degradation! Introduce them to unfathomable levels of pain!','',0,0,0,0,0,0,0,0,0,0,62318,0,26124),
(110315,'Foolish warlock! Did you really think I would remain unaware of your infantile plot to steal my treasure? You underestimate the Nathrezim!','',0,0,0,0,0,0,0,0,0,0,62314,0,26124),
(110316,'As for you, treacherous skull, I\'ll deal with you later.','',0,0,0,0,0,0,0,0,0,0,62317,0,26124),
(110317,'Come to me, servant of hellfire! Rid me of this uninvited guest.','',0,0,0,0,0,0,0,0,0,0,62319,0,26124),
(110318,'Good! Now, before the master returns, slay my captors and free me!','',0,0,0,0,0,0,0,0,0,0,62320,0,26124),
(110319,'Theodore and I can take \'em! For the wilds!','',0,0,0,0,0,0,0,0,0,0,62640,0,26124),
(110320,'You seem quite capable, mage. With their magics gone, I feel my strength returning.','',0,0,0,0,0,0,1,0,0,0,61756,0,26124),
(110321,'Keep yer eyes peeled! Prustaga\'s around here somewhere.','',0,0,0,0,0,0,0,0,0,0,62642,0,26124),
(110322,'Is that the best these whelps can manage? I could do this all day!','',0,0,0,0,0,0,0,0,0,0,62641,0,26124),
(110323,'The Nexus Vault is weakening! That arcane energy can only mean Aluneth is no longer fully contained.','',0,0,0,0,0,0,0,0,0,0,61761,0,26124),
(110324,'','Titanstrike\'s power will be mine!',0,0,0,0,0,0,0,0,0,0,0,62643,26124),
(110325,'Prust is headed for the throne! We\'ve got to stop her!','',0,0,0,0,0,0,0,0,0,0,62644,0,26124),
(110326,'You have great courage to contact me, $r.$b$bOr stupidity...','',0,0,0,0,0,0,0,0,0,0,71054,0,26124),
(110327,'','You shall witness my glorious ascension!',0,0,0,0,0,0,0,0,0,0,0,62623,26124),
(110328,'','Yes... I feel the power of the makers coursing through my veins!',0,0,0,0,0,0,0,0,0,0,0,62624,26124),
(110329,'Now what?! One day, I will free myself of your control and... wait... you\'re not my master!','',0,0,0,0,0,0,0,0,0,0,62332,0,26124),
(110330,'I have need of your powers.','I have need of your powers.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110331,'Hah! Do you think you\'re the first creature from a doomed world to beg for my aid?$b$bNo, you will burn before the Legion\'s power and I\'ll continue to suffer in servitude to these mongrels for the rest of eternity.$b$bSave yourself the wasted effort and go jump into a fire!','',0,0,0,0,0,0,0,0,0,0,71053,0,26124),
(110332,'So, the famed Thal\'kiel chose to submit to the demons in the end.','So, the famed Thal\'kiel chose to submit to the demons in the end.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110333,'How dare you! If my powers were not constantly being drained I could easily bring them under my control.','',0,0,0,0,0,0,0,0,0,0,71052,0,26124),
(110334,'Then allow me to free you. Together, the Burning Legion will bow to us! We will be the masters!','Then allow me to free you. Together, the Burning Legion will bow to us! We will be the masters!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110335,'Hmph... fine then. Come to Felsoul Hold if you truly believe you can free me. But if you\'re not up for the challenge, you\'ll be joining me in eternal torment!','',0,0,0,0,0,0,0,0,0,0,62310,0,26124),
(110336,'The ground is blanketed by unstable energy. You might not want to step on that...','',0,0,0,0,0,0,0,0,0,0,61774,0,26124),
(110337,'Calydus knows where that is! Calydus can help!','',0,0,0,0,0,0,0,0,0,0,62311,0,26124),
(110338,'','You cannot stop me, fools! I just need... more... power!',0,0,0,0,0,0,0,0,0,0,0,62613,26124),
(110339,'It is time we finish this. Hati, kill!','',0,0,0,0,0,0,0,0,0,0,62614,0,26124),
(110340,'It\'s too much for her! Watch out! She\'s gonna blow!','',0,0,0,0,0,0,0,0,0,0,62615,0,26124),
(110341,'Fools! You may have destroyed the Surge Needles, but you are too late to stop us! The power of Aluneth will rip open the breach!','',0,0,0,0,0,0,0,0,0,0,61760,0,26124),
(110344,'Stabilize the patient.','Stabilize the patient.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110346,'|TInterface\\Icons\\Ability_Xavius_NightmareBlades.blp:20|tXavius\' |cFFFF0000|Hspell:206656|h[Nightmare Blades]|h|r have targetted you.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(110347,'Lost Feathermane Kitten spots you and scampers away in fear!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110349,'Let us focus on the task at hand.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(110351,'A dark presence emerges from the void... something big! We need to move now!','',0,0,0,0,0,0,22,0,0,0,63385,0,26124),
(110352,'Life... to consume...','',0,0,0,0,0,0,0,0,0,0,63384,0,26124),
(110353,'You have been targeted by Lurking Eruption!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(110354,'You\'ve done it! The sisters are yours to control!','',0,0,0,0,0,0,1,0,0,0,66528,0,26124),
(110355,'Sacrolash and Alythess will prove to be powerful tools for our order.','',0,0,0,0,0,0,1,0,0,0,66529,0,26124),
(110356,'Let\'s meet back at the council\'s circle. There is much to discuss.','',0,0,0,0,0,0,1,0,0,0,66530,0,26124),
(110357,'Everything is in place for me to complete the ritual! All of you, defend the tunnel!','',0,0,0,0,0,0,22,0,0,0,63387,0,26124),
(110358,'Why... flee? The Void... inevitable...','',0,0,0,0,0,0,0,0,0,0,63388,0,26124),
(110360,'That thing is too powerful! Focus on staying alive and keep it at bay!','',0,0,0,0,0,0,0,0,0,0,63389,0,26124),
(110361,'Just a few more moments! Stay strong!','',0,0,0,0,0,0,0,0,0,0,63390,0,26124),
(110362,'It is done. Quickly, $p, take up the hammer! In so doing, you will ensure Tyr\'s remains are protected for all time!','',0,0,0,0,0,0,0,0,0,0,63391,0,26124),
(110365,'An amateur merchant embraces excuses. A master embraces solutions.','',0,0,0,0,0,0,0,0,0,0,66068,0,26124),
(110366,'Apologies, master. I am still working on the clasp for the rushed commission...','',0,0,0,0,0,0,0,0,0,0,66170,0,26124),
(110367,'','You will not stand in my way!',0,0,0,0,0,0,0,0,0,0,0,62616,26124),
(110368,'You are not worthy to wield the fury of the storms, vrykul!','',0,0,0,0,0,0,0,0,0,0,62617,0,26124),
(110369,'','Your kind has long forced my people into servitude. No longer! Now we forge our own destiny!',0,0,0,0,0,0,0,0,0,0,0,62618,26124),
(110370,'See reason, Prust! We\'re not yer enemy!','',0,0,0,0,0,0,0,0,0,0,62619,0,26124),
(110371,'','You were a means to an end. Nothing more!',0,0,0,0,0,0,0,0,0,0,0,62620,26124),
(110372,'','I will not be denied! I shall become god-queen!',0,0,0,0,0,0,0,0,0,0,0,62621,26124),
(110374,'','Behold my power!',0,0,0,0,0,0,0,0,0,0,0,62622,26124),
(110375,'There\'s no need to recast Shadow Word: Pain when the previous one still has lots of time left on it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110376,'You\'re at maximum Holy Power already! Use Templar\'s Verdict!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110377,'Recast Agony just before it expires to preserve its amplified damage!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110378,'You have maximum Soul Shards. Cast Unstable Affliction!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110379,'You have maximum Chi! Use Blackout Kick!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110380,'Shift back into Cat Form!','',0,0,0,0,0,0,5,0,0,0,59614,0,26124),
(110381,'Virulent Plague has expired from your target. Use Outbreak now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110382,'Your target has maximum Festering Wounds. Use Scourge Strike!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110383,'Wait until you have Fingers of Frost, or your target is frozen, to use Ice Lance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110384,'You have maximum Maelstrom. Use Lava Lash!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110385,'You\'re at maximum Astral Power. Cast Starsurge!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110387,'We have the hammer! Everyone, run! The tomb is collapsing!','',0,0,0,0,0,0,0,0,6,0,63392,0,26124),
(110388,'Your escape... means nothing. Will find you again...','',0,0,0,0,0,0,0,0,6,0,63393,0,26124),
(110389,'Well, that was uncomfortable. You came just in time!','',0,0,0,0,0,0,0,0,0,0,67632,0,26124),
(110395,'$n! There\'s a rumor goin\' round that you\'ve got your hands on Felo\'melorn. Is it true?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110396,'Felo\'melorn! Last I heard, the Lich King had stowed this beauty in Icecrown. How did you ever recover it?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110397,'Most of the relics I dig up are inert, but this blade thrums with magical energy. Ohh, it makes me hair stand on end. I hope you know how to use this thing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110398,'Thank you, $n. You carry a piece of living history. Treasure it always!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110399,'','Are you here to help with our little \"problem\"?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110400,'','Maldur you ought not to be talkin\' with the Horde. Not after what happened at the Broken Shore.',5,0,0,0,0,0,0,0,0,26702,0,0,26124),
(110401,'We tried to mount an expedition into Zarkhenar, but there\'s all manner of wrong happening in those ruins.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(110402,'I\'ve dug up some relics in my day but nothing like that sword you\'ve got there. When that blade was forged, there was no Alliance, no Horde - we dwarves were probably still living in caves. I know it\'s a lot to ask, but ... can I hold it?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(110403,'Night falls on the collaborators.','Night falls on the collaborators.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110404,'Problem? What problem?','Problem? What problem?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110405,'The Nightborne Leodrath seems to have received reinforcements from Suramar. They have reason to believe that the renegade Nightfallen have come to Azsuna to escape their grasp.','',0,0,0,0,0,0,0,0,0,0,70772,0,26124),
(110406,'Though they were once my kin, what they have become is an evil that I cannot abide in my lands. You know what you must do.','',0,0,0,0,0,0,0,0,0,0,70773,0,26124),
(110407,'A pity that Leodrath escaped, but you\'ve delivered a blow to the Nightborne that they will not soon forget. The denizens of Azsuna thank you.','',0,0,0,0,0,0,0,0,0,0,70774,0,26124),
(110408,'','Very well. I will prepare a spell that will weaken Thurox significantly, but I\'ll need your help to bring him down. Are you ready?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110409,'','Oh, just the shortage of wine in this part of the city! Surely another batch is due soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110410,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110414,'Begone, thief! You have already taken my greatest treasure, what more do you want?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110415,'You again. Get out of here before I call the guards!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110416,'It was so beautiful... the articulated joints... the martial art grip...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110418,'<The adventurer has broken their arm. If you knew how to set bones, you could treat him.>','<The adventurer has broken their arm. If you knew how to set bones, you could treat her>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110419,'Set the patient\'s bone.','Set the patient\'s bone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110420,'','Well done!',0,0,0,0,0,0,0,0,0,0,0,70224,26124),
(110421,'','Very good.',0,0,0,0,0,0,0,0,0,0,0,60039,26124),
(110422,'','Perfect!',0,0,0,0,0,0,0,0,0,0,0,60038,26124),
(110423,'','Great!',0,0,0,0,0,0,0,0,0,0,0,60037,26124),
(110424,'','Good work!',0,0,0,0,0,0,0,0,0,0,0,60036,26124),
(110425,'','Excellent work!',0,0,0,0,0,0,0,0,0,0,0,60035,26124),
(110426,'','Excellent!',0,0,0,0,0,0,0,0,0,0,0,60034,26124),
(110427,'','Practice using your attacks on this target dummy.',0,0,0,0,0,0,0,0,0,0,0,60033,26124),
(110428,'','Now that you have all your primary attack abilities, we will see how they work together!',0,0,0,0,0,0,0,0,0,0,0,60032,26124),
(110429,'','When you feel ready, explore your spellbook and the talent tree for additional abilities you can learn.',0,0,0,0,0,0,0,0,0,0,0,60031,26124),
(110430,'','Nicely done, but those demons won\'t give up so easily. Stand ready!',0,0,0,0,0,0,0,0,0,0,0,60030,26124),
(110431,'','You learned well! Next we will see... Hold on, is that...? To arms! The Legion is attacking!',0,0,0,0,0,0,0,0,0,0,0,60029,26124),
(110432,'','Good work! Now demonstrate your skill against two foes at the same time.',0,0,0,0,0,0,0,0,0,0,0,60028,26124),
(110433,'','Target practice is over, $p. It\'s time to prove your mettle. Combine all the lessons you\'ve learned and use them to defeat my men in combat.',0,0,0,0,0,0,0,0,0,0,0,60027,26124),
(110434,'','An infernal! Use all your training to defeat it!',0,0,0,0,0,0,0,0,0,0,0,60026,26124),
(110690,'Yes, sign me up for the rumble!','Yes, sign me up for the rumble!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(110719,'Use Vanish to evade this brute.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110720,'There\'s just one last thing you need to learn. Sometimes a strategic retreat is necessary so you can live to fight another day. Vanish allows you to disengage from combat and make a quick getaway.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110721,'Shadowstrike to a target, generate 5 combo points with Backstab, and finish them with Eviscerate. That should leave you in stealth, ready to Shadowstrike to your next target.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110722,'You\'re learning how to paint with a dagger. Now it\'s time to perfect your art.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110723,'You\'re in trouble! Use Vanish!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110724,'Use Backstab to generate combo points.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110725,'Starting combat from stealth is more effective.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110726,'You\'re facing multiple enemies, try using Shuriken Storm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110727,'Use Shadowstrike!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110728,'Use Nightblade!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110729,'You have 5 combo points. Use Nightblade!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110730,'Wait until you have 5 combo points to use Nightblade!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110731,'Use Eviscerate!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110732,'You have 5 Combo Points. Use Eviscerate!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110733,'Wait until you have 5 combo points to use Eviscerate!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110734,'Use Crimson Vial to restore health!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110735,'Use Backstab!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110736,'Use Backstab to generate combo points.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110737,'Well done, $p! You are now prepared to do battle as a subtlety rogue.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110738,'Show me you\'ve got the stuff.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110749,'Use Nightblade with 5 combo points on the target dummy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110750,'Tougher enemies may require a broader range of abilities to overcome. As an alternative to Eviscerate, Nightblade can be used to deal damage over time to your target, and is a good ability to spend combo points on early in a fight. Like Eviscerate, Nightblade is a finishing move, and is best used when you have 5 combo points.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110751,'Use Eviscerate with 5 combo points.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110752,'Now that you\'ve built up 5 combo points, it\'s time to Eviscerate. Whenever you Eviscerate with 5 combo points, you will do massive damage and immediately enter stealth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110753,'Use Shadowstrike to attack the target dummy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110755,'Use Stealth to fade from view.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110756,'Rogues favor trickery and cunning. And what\'s trickier than attacking before your target sees you coming? Stealth makes you invisible to most enemies. When in Stealth, you open up specialized tactics that can devastate foes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110906,'\"I\'m hoping for some epic pants drops tonight.\"$b$bA wave of confusion washed over the princess\'s face as the full force of this statement hit her square on. A murmur arose among her court. Lord Gravesbane heard weapons being drawn.$b$bThe princess\'s eyebrows furrowed, and she said...$b$b|cFF600000<How might the draenei princess have responded?>|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110907,'It is done. I will dispose of the ashes and find Mayruna back at camp. Thank you, friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110908,'Let me know if you want to rumble, $r.','Let me know if you want to rumble, $r.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110909,'Is that... Felo\'melorn? The Flamestrike?','Is that... Felo\'melorn? The Flamestrike?',6,0,0,0,0,0,6,0,0,0,0,0,26124),
(110910,'It is. $n recovered it from Northrend. The very spellblade that Dath\'Remar used against the Legion during the War of the Ancients.','It is. $n recovered it from Northrend. The very spellblade that Dath\'Remar used against the Legion during the War of the Ancients.',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(110911,'Let us hope that the mages do not succumb to the Legion\'s influence. We need their help.','Let us hope that the mages do not succumb to the Legion\'s influence. We need their help.',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(110912,'Deception is punishable by death!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110913,'Fire the guns! Cover the path in hellfire! Don\'t let that warlock through!','',0,0,0,0,0,0,0,0,0,0,62321,0,26124),
(110914,'Yowlon hisses angrily at the sight of the Ettin Leather.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110915,'I\'ll be taking that, friend. Don\'t you worry.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110916,'Yowlon kneads his claws into the stone, looking regally in the other direction.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110917,'Thanks!','Thanks!',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(110918,'Your kittens are safe, Yowlon. Will you grant us your blessing so we may share this land with you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110919,'Yowlon leans downward to pluck a feather from his ankle tufts.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110920,'Thank you, your highness.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110921,'Yowlon deposits the feather into Mardranel\'s palm.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110922,'Without a Windlord, Skywall will forever remain in turmoil.','',0,0,0,0,0,0,669,0,0,0,67048,0,26124),
(110923,'There has been no peace here since the death of Al\'Akir, shaman.','',0,0,0,0,0,0,669,0,0,0,66836,0,26124),
(110924,'\"I am immune to your charms, outsider. Flattery will get you nowhere.\"$b$bLord Gravesbane held the princess\'s icy glare for one, two, three agonizing seconds, before replying...$b$b|cFF600000<What might Lord Gravesbane say now?>|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110925,'\"That\'s a big sword you have there. Are you sure you know how to wield it?\"$b$bLord Gravesbane shifted his eyes towards his trousers, then back up at the regal draenei. Matching her hidden half-smile, he replied...$b$b|cFF600000<What might Lord Gravesbane say now?>|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110926,'\"Is that a gnome in your legplates, or is that two gnomes in your legplates?\"$b$bLord Gravesbane stumbled backwards, clearly caught off-guard by the directness of the princess\'s question. He quickly re-gathered his wits and replied...$b$b|cFF600000<What might Lord Gravesbane say now?>|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110927,'I see you carry Felo\'melorn, mage. My father spoke of that blade. He witnessed its fire during the War of the Ancients, long before the exodus of the quel\'dorei.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(110930,'\"I\'ll bet you say that to every princess you meet.\"$b$bLord Gravesbane could see her for what she really was now: yes, she was the ruler of an unbeatable warrior nation... but she was also a girl, still trembling under the terrible weight of a crown. He replied...$b$b|cFF600000<What might Lord Gravesbane say now?>|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110931,'\"Simply \'cute\'? You\'ll have to do better than that, Lord Gravesbane.\"$b$bLord Gravesbane frowned. \"Perhaps I\'m simply having an off day\", he thought, clearly disappointed with his game.$b$b|cFF600000<What might Lord Gravesbane say to recover?>|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110933,'\"Well, I think you\'re terribly unclever!\"$b$bThe azure-skinned princess put on quite a show of being offended. So much, in fact, that it was clear to Lord Gravesbane that she was bluffing. He saw his chance.$b$b|cFF600000<What might Lord Gravesbane say now?>|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110934,'\"Yes, I say it to nearly every woman I meet. I define my self-worth solely by the quantity of my romantic partners.\"','\"Yes, I say it to nearly every woman I meet. I define my self-worth solely by the quantity of my romantic partners.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110935,'\"No, your majesty. Only to those princesses with eyes like sapphires in a stormy sea.\"','\"No, your majesty. Only to the ones with eyes like sapphires.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110936,'\"Like, REALLY cute.\"','\"Like, REALLY cute.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110937,'\"Pants? Here in my court, we simply wear robes and shoulderpads.\"','\"Pants? Here in my court, we simply wear robes and shoulderpads.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110938,'\"Why would you say such a stupid thing to me?\"','\"Why would you say such a stupid thing to me?\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110939,'$n, I see you have inherited Felo\'melorn. Let us hope it serves you better than it did Prince Kael\'thas.','$n, I see you have inherited Felo\'melorn. Let us hope it serves you better than it did Prince Kael\'thas.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(110940,'\"You insolent buffoon! I should have your head for this!\"','\"You insolent buffoon! I should have your head for this!\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110941,'\"Pants? Here in my court, we simply wear robes and shoulderpads.\"$b$bLord Gravesbane surveyed the throne room chamber, and indeed, every single member of the princess\'s court was donned in long, flowing robes, and decorated with large crystalline shoulderpads. Not a single pant was in sight. He replied...$b$b|cFF600000<What might Lord Gravesbane say now?>|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110942,'Begone, Mortals! Your kind has no place here!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(110943,'\"Why would you say such a stupid thing to me?\"$b$bLord Gravesbane had been called many things before: foul, lecherous, repugnant, perverted, and occasionally even troggish, but never \"stupid\". This was new. He replied...$b$b|cFF600000<What might Lord Gravesbane say or do now?>|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110944,'You will... pay for this... shaman! You...','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(110945,'\"You insolent buffoon! I should have your head for this!\"$b$bA score of angry guards unsheathed as many crystalline swords. The princess was angry. One word from her, and Lord Gravesbane would be sliced to ribbons. He would have to choose his next words very carefully.$b$b|cFF600000<What might Lord Gravesbane say to get out of this one?>|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110946,'\"I would settle for a robe drop, I suppose... but your majesty should definitely keep the shoulderpads ON.\"','\"I would settle for a robe drop, I suppose... but your majesty should definitely keep the shoulderpads ON.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110947,'\"Umm... duhhhh... Lord Gravesbane?\"','\"Umm... duhhhh... Lord Gravesbane?\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110948,'\"But your majesty... why take my head, when you already have my heart?\"','\"But your majesty... why take my head, when you already have my heart?\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110949,'\"Yikes! Don\'t kill me!\"','\"Yikes! Don\'t kill me!\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110950,'You seek the Idol of the Wild? I will tell you nothing, interloper!','',0,0,0,0,0,0,0,0,0,0,68346,0,26124),
(110951,'His immaculate choice of words had won the princess over. Her hands flew to her chest, as if to stop a beating heart from escaping.$b$b\"Oh, Lord Gravesbane!\" she exclaimed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110952,'|cFF600000<This story doesn\'t seem to be working out so well. It\'s not very steamy, and it\'s definitely not romantic.>|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110953,'Even your sacred shrines are no longer safe from us, druid!','',0,0,0,0,0,0,0,0,0,40030,68345,0,26124),
(110954,'I know nothing of this idol, foolish druid. I do know that I\'ll have your head!','',0,0,0,0,0,0,0,0,0,40030,68342,0,26124),
(110955,'My liege! A strange mage approaches, and $ghe:she; bears the flaming blade of Dath\'Remar Sunstrider.','$n, I see you have inherited Felo\'melorn. Let us hope it serves you better than it did Prince Kael\'thas.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(110959,'Hati! That poor wolf took the brunt of it. Is he...?','',0,0,0,0,0,0,0,0,0,0,62625,0,26124),
(110960,'He is alive, but only barely. It appears this noble companion absorbed Titanstrike\'s energy, protecting us from the explosion.','',0,0,0,0,0,0,1,0,0,0,62626,0,26124),
(110961,'Erase everything and try again','Erase everything and try again',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(110962,'Even though Hati is a creature of lightning magic, his body can\'t contain such intense power. My science cannot help him. I fear the Thunderspark\'s power is soon to be lost.','',0,0,0,0,0,0,1,0,0,0,62627,0,26124),
(110963,'','Playtime\'s over, mortal!',0,0,0,0,0,0,0,0,0,0,0,62330,26124),
(110964,'','$n, is that Felo\'melorn? THE Felo\'melorn, undying flame of the Sunstriders? The last time I saw that blade, it was in the hands of Prince Kael\'thas, before the third war.',1,0,0,0,0,0,5,0,0,0,0,0,26124),
(110965,'I know your heart aches at Hati\'s loss, $p, just as mine does. You have a kinship with the spirits of wild creatures greater than any I have seen before.','',0,0,0,0,0,0,1,0,0,0,62628,0,26124),
(110966,'What your science cannot achieve, this master of beasts can do by instinct alone.','',0,0,0,0,0,0,1,0,0,0,62629,0,26124),
(110967,'We spit on your sacred relics, druid. Now, face me!','',0,0,0,0,0,0,0,0,0,40030,68347,0,26124),
(110968,'The Idol is ours, $r. I\'ll never give up its location!','',0,0,0,0,0,0,0,0,0,40030,68343,0,26124),
(110969,'Kalazzius does not fear you, druid. Face him if you want your precious idol.','',0,0,0,0,0,0,0,0,0,40030,68344,0,26124),
(110970,'Wait... that\'s it, $p. If you bind Hati\'s spirit to your own, you can channel the power back into Titanstrike! You\'ll save Hati and restore the gun!','',0,0,0,0,0,0,1,0,0,0,62630,0,26124),
(110971,'','Actually, sister, playtime has only begun!',0,0,0,0,0,0,0,0,0,0,0,62331,26124),
(110975,'Apologies for the hasty retreat! The tomb\'s collapse was triggered by the hammer\'s removal.','',0,0,0,0,0,0,0,0,6,0,63394,0,26124),
(110976,'Though his halls are no more, Tyr is now protected by several tons of stone and water. The prison is buried as well.','',0,0,0,0,0,0,1,0,0,0,63395,0,26124),
(110977,'I can think of no one better to hold the Silver Hand, wield it well. Return to Tyrosus and tell him of our success. We will meet again.','',0,0,0,0,0,0,1,0,0,0,63396,0,26124),
(110980,'','Kalazzius the Guileful... I have heard the name. He lurks in a cave east of the vale! We\'ll meet you there!',0,0,0,0,0,0,0,0,0,0,0,66760,26124),
(110986,'Your persistence will be the death of you! Minions, attack!','',0,0,0,0,0,0,0,0,0,0,62323,0,26124),
(110987,'It has been ages since I have seen the Tidestone whole, but there it stands.','',0,0,0,0,0,0,0,0,0,0,63265,0,26124),
(110988,'I and my people owe you a debt of gratitude that we can never repay.','',0,0,0,0,0,0,0,0,0,0,63266,0,26124),
(110989,'Please return to Azsuna as soon as you can. There is much yet left to do, $n.','',0,0,0,0,0,0,0,0,0,0,63264,0,26124),
(110990,'Do you hear me, mortal? Mephistroth imprisoned me at the far side of the valley. Hurry! I sense he is preparing for something... significant.','',0,0,0,0,0,0,0,0,0,0,62322,0,26124),
(110991,'Enjoy your victory while you can, warlock. This isn\'t over between us. It has only begun!','',0,0,0,0,0,0,0,0,0,0,62325,0,26124),
(110992,'I am impressed, $n. Never have I seen a mage capable of controlling Aluneth.','',0,0,0,0,0,0,1,0,0,0,61757,0,26124),
(110993,'No more escapes on my watch!','',0,0,0,0,0,0,0,0,0,0,62460,0,26124),
(110994,'You\'ll beg to be put back in a cage when I\'m done with you!','',0,0,0,0,0,0,0,0,0,0,62432,0,26124),
(110995,'The Drekirjar continue to enslave and torment my kin. Show them the allies of the Thorignir do not fear their nets and harpoons!','',0,0,0,0,0,0,0,0,0,0,60086,0,26124),
(110996,'These fools still cling to the promises of their false god-king. It is good that you have wounded them so.','',0,0,0,0,0,0,0,0,0,0,60087,0,26124),
(110997,'I\'ve heard that this Blade dates back to antiquity, even before the titans! An excellent choice, unless you are reconsidering.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(110998,'This staff has great power that can be used for good, if you have the will to control it. It could also immolate you. Are you sure?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(110999,'By Odyn\'s beard! You did it!','',0,0,0,0,0,0,0,0,0,0,62631,0,26124),
(111000,'The Beacon is strongly linked to the naaru, having their aid could be exactly what we need to turn the tide! Are you sure?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111001,'From this day forth, I charge you to wield Titanstrike against the enemies of creation who would destroy this world.','',0,0,0,0,0,0,0,0,0,0,62632,0,26124),
(111002,'Hati\'s noble spirit is forevermore bound to the weapon. He will be a loyal companion to you in the dark times ahead.','',0,0,0,0,0,0,0,0,0,0,62633,0,26124),
(111003,'','There\'s a fel rune locking that door! The Empyrean Society should not be using such magic!',1,0,0,0,0,0,0,0,0,0,0,66476,26124),
(111004,'I\'ve seen no finer hunter in all my days roaming the wilds. Yer faith is well-placed, Thorim!','',0,0,0,0,0,0,2,0,0,0,62634,0,26124),
(111005,'Let\'s get back to Dalaran. I\'ll call Huey. No matter how far I go, he manages to find me. Oh, Huey!','',0,0,0,0,0,0,1,0,0,0,62635,0,26124),
(111006,'','Lovely view up here. Hmm, now that book warrants a closer look.',1,0,0,0,0,0,0,0,0,0,0,66481,26124),
(111007,'','Archmage Vargoth will hear of this intrusion!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(111010,'<The patient has been severely burned from felfire. If you know how to treat felburn wounds, you\'ll know how to heal the patient.>','<The patient has been severely burned from felfire. If you know how to treat felburn wounds, you\'ll know how to heal the patient.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111011,'Treat the patient\'s burns.','Treat the patient\'s burns.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111012,'|TInterface\\Icons\\Spell_Fire_FelPyroblast:20|t %s begins to cast |cFFFF0000|Hspell:206219|h[Liquid Hellfire]|h|r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111013,'Thanks!','Thanks!',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(111014,'Help!','Help!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111015,'It\'s getting really hot!','It\'s getting really hot!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111016,'Someone save me!','Someone save me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111017,'','Oh no! Ravandwyr!',1,0,0,0,0,0,0,0,0,0,0,66478,26124),
(111018,'What is this...?','',2,0,0,0,0,0,0,0,0,0,0,0,26124),
(111019,'Seeing as I am the prince after whom the ring was named... yes, I suppose I do. It was my ring, once, when such material possessions were of value to me.$b$bIt has long since been stored away, somewhere within the palace. You\'re welcome to ask around for it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111020,'','Yes, I know the ring. I even saw it, as recently as yesterday.$b$bIt\'s not good news, unfortunately. It was among the many trinkets that were stolen away by those horrible murlocs. I was able to dispatch a few of them on their way out, but they made off with plenty of treasure... including that ring.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111021,'<hic>... Ring of what now?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111022,'Do you know anything about the Band of Farondis?','Do you know anything about the Band of Farondis?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111023,'Here! I\'m over here!','Here! I\'m over here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111024,'I could really use some help right about now!','I could really use some help right about now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111025,'Looks like you could use a little muscle!','Looks like you could use a little muscle!',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(111026,'Lemme at \'em!','Lemme at \'em!',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(111027,'I\'m not cut out for this!','I\'m not cut out for this!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111028,'I\'m in over my head here!','I\'m in over my head here!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111029,'I will begin the preparations for Thunderaan\'s rebirth. Find me when Thunderfury has been recharged!','',0,0,0,0,0,0,669,0,0,0,67049,0,26124),
(111030,'That was quite an adventure, eh?','',0,0,0,0,0,0,71,0,0,0,62556,0,26124),
(111031,'Alright, Huey. Let\'s get back to Dalaran!','',0,0,0,0,0,0,1,0,0,0,62557,0,26124),
(111032,'Hold on! We\'re comin\' in for a landing!','',0,0,0,0,0,0,1,0,0,0,62558,0,26124),
(111033,'Easy, Huey. Easy.','',0,0,0,0,0,0,1,0,0,0,62559,0,26124),
(111034,'<Give Shinfel the Elixir of Suspension.>','<Give Shinfel the Elixir of Suspension.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111037,'Do you want to check out my latest acquisitions?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111039,'Was that a guard?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111040,'Sorry... I can\'t get caught again... sorry... come and find me another time ...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111041,'To the shrine, druid. Our help is needed.','',0,0,0,0,0,0,0,0,0,0,66761,0,26124),
(111042,'The Idol... it\'s gone!','',0,0,0,0,0,0,5,0,0,0,66759,0,26124),
(111043,'','Get away from there!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(111044,'','Are you friend or foe, $r? If you think yourself a friend of the forest, then prove it. Help drive back the corruption that threatens to take over my home.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111045,'','Thank you, $r. You\'ve proven yourself a true ally. I wish you strength in your fight against the evils of this land.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111046,'Quickly, shaman! Hand me the blessed blade and Thunderaan will return!','',0,0,0,0,0,0,669,0,0,0,66832,0,26124),
(111047,'Fester and die!','',0,0,0,0,0,0,0,0,0,0,60121,0,26124),
(111048,'Pathetic! You\'re putting me to sleep. Here, let me return the favor!','',0,0,0,0,0,0,0,0,0,0,60122,0,26124),
(111049,'Feed my hunger, wretch!','',0,0,0,0,0,0,0,0,0,0,60123,0,26124),
(111050,'Witness your end!','',0,0,0,0,0,0,0,0,0,0,60124,0,26124),
(111051,'The light has abandoned you!','',0,0,0,0,0,0,0,0,0,0,60125,0,26124),
(111052,'Underlings! Get in here!','',0,0,0,0,0,0,0,0,0,0,60126,0,26124),
(111053,'Show these pretenders how to fight!','',0,0,0,0,0,0,0,0,0,0,60128,0,26124),
(111054,'Incompetent mortal filth! These Nightborne can\'t even defend their own palace from invasion! If it were up to me...','',0,0,0,0,0,0,0,0,0,0,60127,0,26124),
(111055,'Ah, but I suppose we will reward our \"allies\" soon enough. Until then, I\'ll amuse myself by cleaning up their mess!','',0,0,0,0,0,0,0,0,0,0,60129,0,26124),
(111056,'You think getting past a few power-addled elves means you can stand against a true son of the Legion?','',0,0,0,0,0,0,0,0,0,0,60130,0,26124),
(111057,'Never trust a mortal to do a demon\'s work!','',0,0,0,0,0,0,0,0,0,0,60131,0,26124),
(111058,'Now I know you may be asking yourself why a demon hunter and a warlock are so far out here away from the action.$b$bBut while you are asking yourself that, also ask yourself to be quiet and mind your own business.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111060,'Another twig for the kindling!','',0,0,0,0,0,0,0,0,0,0,60132,0,26124),
(111061,'Be thankful you died fast!','',0,0,0,0,0,0,0,0,0,0,69581,0,26124),
(111062,'My dealings with this... warlock... are a means to an end.$b$bI wish to learn from this creature, to study it. And if need be, to slay it before it does more harm than good to this world.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111063,'Laughable! As if you had a prayer of stopping the ritual...','',0,0,0,0,0,0,0,0,0,0,60133,0,26124),
(111064,'Such a predictable demise.','',0,0,0,0,0,0,0,0,0,0,60134,0,26124),
(111065,'Impossible! You are... inferior...','',0,0,0,0,0,0,0,0,0,0,60135,0,26124),
(111066,'I live... AGAIN!','',0,0,0,0,0,0,53,0,0,0,67050,0,26124),
(111067,'But I was... supposed to... win...','',0,0,0,0,0,0,0,0,0,0,60137,0,26124),
(111068,'Hero, once more you have proven your valor to me.','',0,0,0,0,0,0,0,0,0,0,60136,0,26124),
(111069,'Arthfael is a foe worth fighting! Prove your valor! Slay the beast and my reward is yours.','',0,0,0,0,0,0,0,0,0,0,60138,0,26124),
(111070,'Earlnoc is a misshapen pest! Long has this ettin poached the Fields of the Eternal Hunt. Put an end to his troublemaking!','',0,0,0,0,0,0,0,0,0,0,60139,0,26124),
(111071,'Thank you mortal, Earlnoc will poach these fields no longer.','',0,0,0,0,0,0,0,0,0,0,60140,0,26124),
(111072,'Only by strength in battle can you be measured a champion. Let my stormforged begin your test!','',0,0,0,0,0,0,0,0,0,0,60141,0,26124),
(111073,'A magnificent battle! Well done, champion.','',0,0,0,0,0,0,0,0,0,0,60142,0,26124),
(111074,'I seek to forge an alliance with Vethir, the mighty drake of Stormheim. Collect a clutch of eggs from my own brood so that I might make a gift of them.','',0,0,0,0,0,0,0,0,0,0,60158,0,26124),
(111075,'These eggs will make a fine present to Vethir. The scars you earned collecting them mark you a true champion. Well done!','',0,0,0,0,0,0,0,0,0,0,60157,0,26124),
(111076,'Throughout the ages, the legends of my stormforged champions have spurred warriors to greatness. Go forth and learn these tales, that you might be so inspired!','',0,0,0,0,0,0,0,0,0,0,60156,0,26124),
(111077,'Knowledge is but the first step. Only when these tales roar within your heart will you become a hero worthy of our legacy!','',0,0,0,0,0,0,0,0,0,0,60155,0,26124),
(111079,'','You will find only death here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111080,'','Flee now, and you may yet leave with your fragile lives.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111081,'','So be it. Then you will rot in these halls.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111082,'','Fool! You do not understand the forces you tempt!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111083,'','My warlord... we have... guests...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111084,'Now go. Tell your Earthen Ring that the Windseeker lives again.','',0,0,0,0,0,0,0,0,0,0,67051,0,26124),
(111087,'Got yer weapons ready there, $G lad:lass;?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111088,'Please sharpen my weapons!','Please sharpen my weapons!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111091,'Need a little gloss, a little shine in that armor there, $n? I got what you need!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111092,'Make it shine, Krinkle!','Make it shine, Krinkle!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111093,'Her exemplary deeds in the name of the Ebon Blade have shown her to be one of the best of us, worthy of our highest honor.','',0,0,0,0,0,0,0,0,4,0,60301,0,26124),
(111095,'Right then, I\'m gone.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111096,'Try not to leave a breadcrumb back to us, hero.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111097,'You will all bow to her as you once did to me, and carry out her will against the Legion!','',0,0,0,0,0,0,0,0,4,0,60302,0,26124),
(111098,'','Your friend is right. We should work together.',1,0,0,0,0,0,0,0,0,0,0,66477,26124),
(111101,'','Hello. Have you come to join the Empyrean Society of Exotic Magical Arts?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(111102,'Things need to get back to normal around here. I got a business to run!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111104,'Use my teleportation pad to exit the workshop. We need to get you to the Temple of Storms before that vrykul arrives!','',0,0,0,0,0,0,1,0,0,0,62645,0,26124),
(111107,'Step into the arena and we will test your resolve.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111112,'A trial is currently in progress. You can assist with its completion or wait until the arena is clear to begin another.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111113,'By all means, keep splashing around and attract attention.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111114,'','I\'ll do that. See you soon, $n.',0,0,0,0,0,0,0,0,0,0,0,66479,26124),
(111115,'','I will not fight the Burning Legion while the Twilight\'s Hammer lays siege to Deepholm!',0,0,0,0,0,0,1,0,0,0,0,67052,26124),
(111116,'We understand, Stonemother. The Earthen Ring stands by you.','',0,0,0,0,0,0,669,0,0,0,67053,0,26124),
(111117,'','Go. Destroy the Twilight\'s Hammer and you shall win my favor!',0,0,0,0,0,0,1,0,0,0,0,67054,26124),
(111119,'The naga will not wait long before turning the Tidestone against us. We should make haste.','',0,0,0,0,0,0,0,0,0,0,64056,0,26124),
(111122,'Me gonna crush you so hard!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(111123,'You gonna stop the hammer? I don\'t think so!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(111124,'It the end of the world... and I feel fine! HAHA!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(111125,'Show the Illidari they have an ally in Nar\'thalas. Free them and take the fight to their demon captors!','',0,0,0,0,0,0,0,0,0,0,70754,0,26124),
(111126,'Marlan must evaluate your gift before I can speak with you further. Farewell.','Marlan must evaluate your gift before I can speak with you further. Farewell.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(111127,'I gonna break you, like I break your friend!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(111128,'What I wouldn\'t give to wrangle me one of those demons. Talk about a money maker!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111129,'You are next!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(111130,'BWAHAHA! I needed a few more scars on my face!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(111131,'I gonna seperate your HEAD from your BODY! BWAHAHA!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111132,'I gonna stomp you REAL good!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111133,'As I said, I will see to it that Lord Greymane gets this information. There is no need for you to mention this to anyone else, $c.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111134,'You will kneel before our master!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111135,'I am your destruction!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111136,'None shall withstand the power of our master!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111137,'The twilight is upon you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111138,'Cry for help... none shall answer you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111139,'We are the harbingers of destruction!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111140,'None shall oppose the Twilight\'s Hammer!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111141,'There are no heroes in oblivion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111144,'Thanks! I\'ll be in the shop \'til this blows over.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111146,'Huln sought Eche\'ro, a beast injured in combat with many demons.','',0,0,0,0,0,0,0,0,0,0,60943,0,26124),
(111147,'Malfurion Stormrage eagerly awaited the arrival of Huln and his tauren reinforcements. Krasus--also known as the dragon Korialstrasz--aided their efforts from the sky.','',0,0,0,0,0,0,0,0,0,0,60946,0,26124),
(111148,'Malfurion worked to bring reinforcements from a verdant realm beyond the borders of physical creation. He needed protection while performing the final magical incantations.','',0,0,0,0,0,0,0,0,0,0,60944,0,26124),
(111149,'Jarod Shadowsong awaited Huln\'s arrival in the battlefield below. He had a special task for Highmountain while organizing and commanding his troops.','',0,0,0,0,0,0,0,0,0,0,60945,0,26124),
(111150,'Shadowsong had one last favor to ask of Huln: Defeat the lord of the Nathrezim, Tichondrius. With his defeat, the attack on Azshara would fail and balance could be restored.','',0,0,0,0,0,0,0,0,0,0,60947,0,26124),
(111151,'','Keep all of this between you and me, $c. As they say, loose lips sink ships.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111152,'The Empyrean Society of Exotic Magical Arts is always willing to accept new members. You should join us before it is too late.','The Empyrean Society of Exotic Magical Arts is always willing to accept new members. You should join us before it is too late.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111153,'In the aftermath of their campaign against the vicious Iron Horde, the mighty orcs of Durotar have now set their sights on the future. Striving to put the dark legacy of its former warchief, Garrosh Hellscream behind it, the Horde now looks to a new leader, the wise and courageous troll, Vol\'jin. Though Garrosh\'s atrocities have caused tensions to rise once again between the Horde and its perennial enemy, the Alliance, it is up to orcs like you to forge a path to redemption, and to reclaim the former glory of the Horde.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111154,'Although the defeat of former warchief Garrosh Hellscream speaks to a brighter future for the tauren, the mantle of leadership weighs heavily on the shoulders of Baine Bloodhoof. It is his belief that the tauren encompass the heart of the Horde, but he is concerned that in the wake of Garrosh\'s disastrous reign, the tauren have lost both vision and purpose. Now, it is up to brave tauren like you to safeguard the lands of your ancestors, and to restore both honor and greatness to your tribe, and... to the Horde.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111155,'Our methods may be unorthodox to some, but the powers we have mastered are priceless.','Our methods may be unorthodox to some, but the powers we have mastered are priceless.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111156,'Exiled years ago from their lands in Stanglethorn Vale, the Darkspear attempted to make a new life for themselves amongst the disparate races of the Horde. The crimes and treachery of warchief Garrosh Hellscream, however, devastated all possibilities of unity within the Horde. With the defeat of Garrosh, the cunning and resourceful trolls have once again embraced the promise of a more hopeful future under the keen leadership of Vol\'jin. And though a renewed threat of attack from the renegade Zandalari tribe looms large, Vol\'jin strives for a day when all trolls stand reunited. Now, it is up to courageous young trolls like you to help ensure that Vol\'ljin\'s bold vision of unity becomes a reality.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111157,'Having served as vanguard in the Alliance\'s campaign against the ruthless Iron Horde, the human nation of Stormwind has once again risen to preeminence. After successfully invading Orgrimmar and bringing justice to the infamous warchief Garrosh Hellscream, High King Varian Wrynn has vowed that the world of Azeroth must never again fall prey to tyranny. Now, as dark clouds loom on the horizon and tensions between the humans and their long-time enemy the Horde begin to rise, the Alliance must once again serve as an example to those who would fight for righteousness. As the storm draws near, it falls to you to uphold the honor of humanity.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111158,'I am NOT cut out for this!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111159,'The stalwart king of the Dwarves, Magni Bronzebeard, was taken from his people when a terrible curse fused his physical form into the diamond heart of the dwarven capital of Ironforge. To avert civil war in the king\'s absence, the dwarves created a council of three hammers that would share power amongst the feuding clans. Over time this coalition has maintained a tenuous stability...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111160,'but now, Magni Bronzebeard has returned from his crystal prison. All is not well, however, as the dwarven king bears grim tidings of a dark and uncertain future. It is unclear how this ominous prophecy will affect both the council\'s accord and the destiny of the dwarves. What is clear is that you must do all within your power to protect your people in these perilous and unpredictable times.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111161,'Through the bold leadership of Lady Sylvanas, the Forsaken have once again attained a position of strength among the warring factions of Azeroth. Bolstered by the dark and powerful magics of her Val\'kyr, Sylvanas has replenished her ranks and once again created a safe harbor for her people in the capital of Undercity. However, shadows from the past still haunt the undead queen. Traitorous plots carried out by agents under her command, such as the betrayal at the Wrath Gate, continue to cast fear and doubt on the Forsaken\'s allegiance to the Horde. As a dedicated member of Sylvanas\' undead army, it will fall to you to help prove the Forsaken\'s loyalty, and to slay anyone who would dare threaten her rule.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111162,'The inspired leadership of High Priestess Tyrande Whisperwind has brought prosperity and stability to the night elf people. Also, with the help of Archdruid Malfurion Stormrage, nature throughout Hyjal has flourished in the aftermath of the Cataclysm\'s widespread destruction. The formerly corrupted, mighty World Tree Teldrassil continues to heal, rejuvenating the spirits of the embattled night elves... and ancient demigods roam the world anew. All is not peaceful, however, in the misty boughs of Teldrassil. The reawakened demigods sense that old enemies will reemerge, bringing with them a terrible doom. Now, as your people have done so many times before, you must stand ready to pull Azeroth back from the brink of oblivion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111163,'The Sunwell, once a perennial fount of arcane power, now channels the Holy Light... providing hope that the Sin\'dorei, under the leadership of Lor\'themar Theron, may at last be on the road to overcoming their magical addiction. Though the blood elves aided in both the defeat of the Iron Horde and the battle against Garrosh, their once-possible future with the Alliance has been cast into doubt. As the blood elves face a turbulent and uncertain future, you must remain ready to defend what remains of your once-mighty civilization, and redeem the embattled soul of your people.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111164,'What?! It\'s mine. You can\'t have it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111165,'Lord of the tides curse you, $r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111166,'We will see you on the other side in Nordrassil, Archdruid.','',0,0,0,0,0,0,1,0,0,0,66771,0,26124),
(111167,'It\'s unfortunate that affairs have come to this, but what are we going to do? Wait for them to come slaughter us in our sleep and go out of business?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111177,'','These wretches defile our sacred ground collecting souls for their cursed queen! Finish them!',0,0,0,0,0,0,0,0,0,0,0,60172,26124),
(111179,'','Thank you, champion! The sanctity of this place is preserved thanks to your help.',0,0,0,0,0,0,0,0,0,0,0,60173,26124),
(111181,'I can find any tool... for the right price.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111184,'I think you would find our rare ore reserves in the back room more to your liking.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111185,'<Subtlety flash your insignia.>','<Subtlety flash your insignia.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111186,'Nithogg terrorizes Stormheim from his roost atop the sundered peak, Nastrondir. His continued existence is an affront to the legacy of the Thorgnir. End it.','',0,0,0,0,0,0,0,0,0,0,60178,0,26124),
(111187,'Though he was once Thorignir, Nithogg\'s madness was a blight on this land. You have done a great deed today, outsider.','',0,0,0,0,0,0,0,0,0,0,60179,0,26124),
(111188,'Warning: The skies are not safe! Ground yourself immediately!','Warning: The skies are not safe! Ground yourself immediately!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(111193,'','The Earthen Ring has done a great service to Deepholm. We will return the favor.',0,0,0,0,0,0,1,0,0,0,0,67055,26124),
(111194,'','The Stonemother always pays her debts.',0,0,0,0,0,0,0,0,0,0,0,67056,26124),
(111195,'','As a symbol of our alliance, I will bestow upon you one of my greatest warriors.',0,0,0,0,0,0,1,0,0,0,0,67057,26124),
(111196,'','Protect the Earthen Ring, Avalanchion. Pave the ground with the corpses of the Burning Legion!',0,0,0,0,0,0,0,0,0,0,0,67058,26124),
(111198,'<Suffering from a fever. If you know how to treat a fever, you\'ll know how to heal him.>','<Suffering from a fever. If you know how to treat a fever, you\'ll know how to heal her.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111199,'The Earthen Ring is deeply grateful, Stonemother.','',0,0,0,0,0,0,669,0,0,0,67059,0,26124),
(111201,'As you wish, Stonemother.','',0,0,0,0,0,0,0,0,1,0,67060,0,26124),
(111208,'We should return to the Heart of Azeroth, Farseer. There is still much to be done.','',0,0,0,0,0,0,1,0,0,0,67061,0,26124),
(111211,'','Aye. You go on ahead, dear. We\'ll be along soon.',0,0,0,0,0,0,396,0,0,0,0,66846,26124),
(111212,'I don\'t belong here! I\'m no fighter! I just make things!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111226,'Huh, hmm... what? Afraid? Hah!$B$BListen here, bub. I\'ve seen fighters come and go. A few demons don\'t scare me. Besides, somebody\'s gotta survive long enough to keep this thing runnin\'. Might as well be me.$B$BMoney ain\'t gonna make itself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111229,'Get back you beasts!','Get back you beasts!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111232,'<The patient is bleeding profusely from a large wound. If you know how to stabilize the wound, you\'ll know how to treat him.>','<The patient is bleeding profusely from a large wound. If you know how to stabilize the wound, you\'ll know how to treat him.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111233,'Whew! I thought I was a goner. Thank you!','Whew! I thought I was a goner. Thank you!',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(111234,'I came to speak to you about your needs for archaeology gathering.','I came to speak to you about your needs for archaeology gathering.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111235,'','Well as you know, surveying an area can be quite time consuming.$b$bYou have to place down your equipment, which is some work, then study the results and then try to move closer to where you believe the fragment may exist.$b$bAll I was asking for was something to speed up that process. But apparently my explaining of our process to Nalthanis was just too much for him to listen to.$b$bPerhaps you can explain it better to him than I can.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111236,'','You don\'t strike me as the archaeology type. You see, surveying an area can be quite time consuming.$b$bYou have to place down your equipment, which is some work, then study the results and then try to move closer to where you believe the fragment may exist.$b$bAll I was asking for was something to speed up that process. But apparently my explaining of our process to Nalthanis was just too much for him to listen to.$b$bPerhaps you can explain it better to him than I can.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111238,'I will see you back in the Hall of the Guardian. Esara, you are welcome to join us there.','',1,0,0,0,0,0,0,0,0,0,67634,0,26124),
(111239,'','Looks like somebody\'s really askin\' for it! Lemme at \'em!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111240,'','You\'re messin\' with the wrong girl!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111241,'','Today just isn\'t your day!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111242,'','Looks like this is gonna be a long day!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111243,'','Duty calls!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111245,'Are you so weak, Lord Smolderon, that you require the help of mortals?','',0,0,0,0,0,0,0,0,0,0,67062,0,26124),
(111246,'Chargore... my champion! You will pay, mortal!','',0,0,0,0,0,0,0,0,0,0,67063,0,26124),
(111247,'I\'ve spoken with Dariness and here\'s what she was trying to say...','I\'ve spoken with Dariness and here\'s what she was trying to say...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111248,'You approach your demise, shaman. Turn back while you still live!','',0,0,0,0,0,0,0,0,0,0,66835,0,26124),
(111249,'You dare oppose the son of Rhyolith? You will be destroyed!','',0,0,0,0,0,0,0,0,0,0,67064,0,26124),
(111250,'Slain by a mortal? It cannot be...','',0,0,0,0,0,0,0,0,0,0,67065,0,26124),
(111251,'','Thank you!',2,0,0,0,0,0,0,0,0,0,0,0,26124),
(111252,'Thank you.','',2,0,0,0,0,0,0,0,0,0,0,0,26124),
(111253,'Thank you.','',2,0,0,0,0,0,0,0,0,0,0,0,26124),
(111254,'These mortals do my bidding. A pity you do not share their enthusiasm!','',0,0,0,0,0,0,0,0,0,0,67066,0,26124),
(111255,'Your champions crumble, Pyroth!','',0,0,0,0,0,0,0,0,0,0,67067,0,26124),
(111256,'Destroy the imposter, shaman! Bring me his heart!','',0,0,0,0,0,0,0,0,0,0,66829,0,26124),
(111258,'Yes, I see.$b$bI\'d like you to do something for me, $n. Take this enchanted pen and paper and survey archaeological digsites so that my pen may make notes of your process.$b$bReturn to me when you\'re finished and bring me back anything you find.$b$bIf you don\'t already know how to survey, just talk to Dariness, I\'m sure she can fill you in again on the finer points of being an archaeologist.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111259,'I remember the night Orgrim fell, run through by a knight\'s lance during the liberation of the last orc internment camp. As he bled out onto the fields of Arathi, he bestowed the Doomhammer to me.','',0,0,0,0,0,0,1,0,0,0,60562,0,26124),
(111260,'The Doomhammer is not merely a weapon. It is a symbol. A symbol of hope, of power... Proof that an individual can change the world.','',0,0,0,0,0,0,1,0,0,0,68827,0,26124),
(111265,'Did you think I would stand idle as you clawed your way through my minions? Listen, mortal, as the treasure you fight so hard to obtain is broken to my will!','',0,0,0,0,0,0,0,0,0,0,62328,0,26124),
(111266,'Alliance scum!','Alliance scum!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(111267,'Coward!','Coward!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(111268,'You have no honor, $c.','You have no honor, $c.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(111269,'The Dark Lady will prevail.','The Dark Lady will prevail.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(111270,'A curse upon you and yours!','A curse upon you and yours!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(111271,'Long live the Banshee Queen!','Long live the Banshee Queen!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(111272,'Arrrghhh!','',0,0,0,0,0,0,0,0,0,0,62324,0,26124),
(111273,'I spit on you!','I spit on you!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(111274,'My life for the forsaken.','My life for the forsaken.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(111275,'Curse you! I will not give in!','',0,0,0,0,0,0,0,0,0,0,62326,0,26124),
(111276,'Looking for something specific?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111277,'During the Cataclysm, I spent many terrible weeks as a prisoner in the Abyssal Maw. I have no desire to return there, but I know the place well.','',0,0,0,0,0,0,1,0,0,0,60674,0,26124),
(111278,'Sharas\'dal, the Scepter of Tides, is steeped in Legend. Through its power, Azshara enabled her followers to live in the sea.','',0,0,0,0,0,0,1,0,0,0,60671,0,26124),
(111279,'','Is it dangerous?',0,0,0,0,0,0,6,0,0,0,0,60672,26124),
(111280,'It has dominion of the waters of Azeroth, the very stuff of life. In the right hands, it could be a font of healing instead of corruption.','',0,0,0,0,0,0,1,0,0,0,71643,0,26124),
(111281,'','This realm belongs to Azshara now, shaman. How fitting that the Earthen Ring will be swept away by the sea!',0,0,0,0,0,0,0,0,0,0,0,60697,26124),
(111282,'','I used to be a great enchanter once, before I fell. Now my spirit is bound to my home.$b$bIf only I could have my enchanting rod back...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111283,'','The seas will devour you!',0,0,0,0,0,0,0,0,0,0,0,60699,26124),
(111284,'','You will be crushed beneath the waves.',0,0,0,0,0,0,0,0,0,0,0,60700,26124),
(111285,'','Sharas\'dal is mine, for the glory of my queen alone!',0,0,0,0,0,0,0,0,0,0,0,60701,26124),
(111286,'','While I still no longer possess a physical body, I feel alive again having my enchanting rod back in my possession.$b$bIf you wish to learn any of my enchantments, you only need to bring some materials as trade.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111288,'Your cause is hopeless, sea witch! No matter how you bend the elements to your will, they will never truly serve you.','',0,0,0,0,0,0,0,0,0,0,60696,0,26124),
(111289,'You use the Scepter to curse and destroy. In our hands, it will cleanse and heal!','',0,0,0,0,0,0,0,0,0,0,60698,0,26124),
(111290,'Why are we not firing yet? Work faster, or face the lash!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(111291,'','Lady Zithreen is in the throne room beyond.',0,0,0,0,0,0,0,0,0,0,0,60707,26124),
(111292,'I would like to see what enchantments you have available.','I would like to see what enchantments you have available.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111293,'Her power over the waters here is absolute. We must be cautious.','',0,0,0,0,0,0,0,0,0,0,60708,0,26124),
(111294,'Take up the Scepter, shaman. You have earned it.','',0,0,0,0,0,0,25,0,0,0,60709,0,26124),
(111295,'','If you wish to learn any of my enchantments, you need only ask. And bring me some materials.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111296,'','Jump to remove effects of |cFFFF0000|Hspell:182815|h[Stoneblood Poison]|h|r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(111297,'Please, not that! We work faster!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111299,'Freedom! The feeling is sweet, but Mephistroth\'s magic has diminished my power. Let\'s depart this place before the dreadlord is able to return.','',0,0,0,0,0,0,0,0,0,0,62327,0,26124),
(111300,'Well well, the little elf returns. You are most... persistent.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111301,'You have fulfilled your end of the bargain. As promised, I give you a taste of the Legion\'s power. Earn more by proving your strength!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111302,'Our farm! Please! Somebody hurry!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111303,'I can\'t hold them off!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111304,'I grow tired of your interference! DIE!','',0,0,0,0,0,0,0,0,0,0,62329,0,26124),
(111305,'','Welcome, $c. Are you interested in enchantments, or are you here to help against the naga?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111306,'Supply camp as well... we\'re getting bombarded out here!','Supply camp as well... we\'re getting bombarded out here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111307,'I will do what I can for Senegos, but I urge you to be quick about your business, $n. I fear that he might not survive much longer.\n\nMatters elsewhere call for my attention, and I must depart soon. However, I will return as soon as I am able.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111308,'','By the gods... some kind of structure southeast of the Hill! It just appeared out of nowhere!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111309,'Two more demons heading for the Hill! Ready at the gates!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(111311,'Our enemies shall burn.','',0,0,0,0,0,0,1,0,0,0,67068,0,26124),
(111312,'Have you come to supplicate yourself before the Light? Or perhaps you have come here to train in the holy arts?$b$bIf you are here to speak with Archbishop Benedictus or Bishop Farthing, they have both gone on missions.','',6,0,0,0,0,0,0,0,1,0,0,0,26124),
(111313,'Bishop Farthing has left too?','Bishop Farthing has left too?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111314,'Yes, he left in quite a hurry. After dealing with the accusations against Benedictus, he decided to go investigate the matter personally. Hopefully he will find some peace on his mission.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(111315,'Peace? What was wrong?','Peace? What was wrong?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111316,'The power... I can control it. Yes! I need it all!','',0,0,0,0,0,0,0,0,0,0,66077,0,26124),
(111317,'Yes, well, he hasn\'t really been the same lately. Arguing with himself, being more secretive, ignoring ceremonies. I think the stress of this investigation just got to him. I hope he\'s alright.','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(111318,'<Theryn seems entranced.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111319,'Feed: 300x |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t|Hcurrency:1155|h|cFFFFFFFF Ancient Mana|h|r','Feed: 300x |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t|Hcurrency:1155|h|cFFFFFFFF Ancient Mana|h|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111320,'I bring the ferocity of the bear to battle!$B$BI can taunt enemies, if you will attack them and heal me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111321,'','Hi $n! I think it\'s time for those nasty nightmare demons to scram! If you choose me to help you, I\'ll call upon the balance of nature to smite our enemies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111322,'','Greetings $n. I am glad to lend my aid to the fight.$B$BIf you wish me to accompany you, I will restore your health and help keep you alive.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111323,'','I wouldn\'t miss dis final fight, $n. I will leap inta battle in my feral form. Choose me and I will fight bravely.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111324,'I choose you to fight with me.','I choose you to fight with me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111326,'Zoom is best!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111327,'Get \'em Zoom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111328,'Faster, Zoom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111329,'They\'re cheating!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111330,'Oh, come on!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111331,'ZOOOOOOOOOOOOOOOOOOOOM!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111335,'Breathtaking. Imagine all of the arcane knowledge lost to the ages here.','',0,0,0,0,0,0,0,0,0,0,60191,0,26124),
(111336,'There... the Illidari. And, the Burning Legion is here, too.','',0,0,0,0,0,0,0,0,0,0,60192,0,26124),
(111354,'','Need a ride?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111355,'I found a cask of wine!','I found a cask of wine!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111356,'','Ah! This cask contains a large amount of arcwine. Go ahead and put it into the gondola.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111357,'','Need a ride, stranger?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111358,'','I hope you can manage better than our last wine thief, rest his soul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111360,'','I see! You are the one I was waiting for. All I need is a full boat and I\'ll be on my way.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111361,'','Ysera left me in charge of defending the Dream. My brethren and I have been patrolling this realm for eons.$B$BWe will lend our power to this fight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111363,'Can you help me?','Can you help me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111364,'Meet me on the other side of this portal. I must prepare for the ritual there.','',0,0,0,0,0,0,0,0,0,0,66078,0,26124),
(111365,'','If you have need, call us on the field of battle. Together, we will protect this world!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111366,'Be ready, assistant. I shall begin drawing power from the ship\'s stores.','',0,0,0,0,0,0,0,0,0,0,66083,0,26124),
(111367,'So much power! I can handle it! I can take more!','',0,0,0,0,0,0,0,0,0,0,66082,0,26124),
(111368,'Ah, so that is the key. MORE! MORE!','',0,0,0,0,0,0,0,0,0,0,66079,0,26124),
(111369,'Ahh, much better. I have all the power I could want.','',0,0,0,0,0,0,0,0,0,0,66080,0,26124),
(111370,'Yet I still crave more. Your soul will do nicely!','',0,0,0,0,0,0,0,0,0,0,66081,0,26124),
(111371,'Well, well. What have we here? A thief?','',0,0,0,0,0,0,0,0,0,0,66088,0,26124),
(111372,'Be careful what you wish for...','',0,0,0,0,0,0,0,0,0,0,66104,0,26124),
(111373,'UNUSED No! I have failed...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111374,'$GSir : Madam;! I\'d hate to be a burden, but would you mind?','$GSir : Madam;! I\'d hate to be a burden, but would you mind?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111375,'Let us reclaim our lands together!','Let us reclaim our lands together!',0,0,0,0,0,0,15,7,0,0,0,0,26124),
(111376,'I pledge my service to you.','I pledge my service to you.',0,0,0,0,0,0,16,7,0,0,0,0,26124),
(111377,'I appreciate your kindness, but as long as the skies remain dark, I must remain vigilant.','I appreciate your kindness, but as long as the skies remain dark, I must remain vigilant.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111378,'Your skills serve our people well during these times. Perhaps we shall meet again.','Your skills serve our people well during these times. Perhaps we shall meet again.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111379,'The Eye of Il\'gynoth is creating a Nightmare Horror!','The Eye of Il\'hynoth is creating a Nightmare Horror!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111380,'This mortal seeks to awaken the cursed weapon! Devour the shaman, my children!','',0,0,0,0,0,0,0,0,0,0,66840,0,26124),
(111381,'My precious children! I will devour you!','',0,0,0,0,0,0,589,0,0,0,67069,0,26124),
(111382,'|TInterface\\Icons\\sha_spell_shadow_shadesofdarkness_nightmare:20|t%s begins to cast |cFFFF0000|Hspell:212726|h[Forces of Nightmare]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111383,'Those foul demons... I wasn\'t ready.','Those foul demons... I wasn\'t ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111384,'The elements will guide us, $n.','The elements will guide us, $n.',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(111385,'May I fight by your side, brave $r?','May I fight by your side, brave $r?',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(111386,'Be safe, $n!','Be safe, $n!',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(111387,'Be careful! It\'s not safe out here.','Be careful! It\'s not safe out here.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(111388,'Please, if you could!','Please, if you could!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111389,'Over here!','Over here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111390,'War brings us together. We must fight as one.','War brings us together. We must fight as one.',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(111391,'Together we are stronger.','Together we are stronger.',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(111392,'You are very brave, $n. Be safe.','You are very brave, $n. Be safe.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(111393,'Your kindness will not be forgotten.','Your kindness will not be forgotten.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(111394,'Alliance Outpost at Moonbrook! We\'re under attack! Moonbrook\'s been overrun!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(111395,'Let\'s see that new spell again, conjuror.','Let\'s see that new spell again, conjuror.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(111396,'You are improving. Keep practicing.','You are improving. Keep practicing.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(111397,'','Lady Sacrolash and her sister, Alythess. They are responsible for this foul magic that infects my blood.',0,0,0,0,0,0,1,0,0,0,0,66539,26124),
(111398,'','The twins are helping Mephistroth build an army. They intend to attack Dreadscar, and steal the Felblood Altar.',0,0,0,0,0,0,1,0,0,0,0,66541,26124),
(111399,'','We should slaughter them before they have the chance.',0,0,0,0,0,0,603,0,0,0,0,66540,26124),
(111400,'Mind lendin\' me a hand o\'er here?','Mind lendin\' me a hand o\'er here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111401,'Help me teach these things a lesson!','Help me teach these things a lesson!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111402,'The Legion must be stopped, and I will do everything in my power to make it so. NOTHING is more important than their destruction!','',0,0,0,0,0,0,0,0,1,0,62459,0,26124),
(111403,'','Ha! You\'re the one they sent? Good luck...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111404,'Where we goin\'?','',0,0,0,0,0,0,0,0,0,0,60828,0,26124),
(111405,'What you need?','',0,0,0,0,0,0,0,0,0,0,60829,0,26124),
(111406,'How\'s it jookin\'?','',0,0,0,0,0,0,0,0,0,0,60830,0,26124),
(111407,'Take off.','',0,0,0,0,0,0,0,0,0,0,60825,0,26124),
(111408,'We done? Okie-dook.','',0,0,0,0,0,0,0,0,0,0,60826,0,26124),
(111409,'Buh-bye.','',0,0,0,0,0,0,0,0,0,0,60827,0,26124),
(111410,'Pull me finger! Okay no wait - no pull this one. Ahh, okay wait wait - no - come back later we try again.','',0,0,0,0,0,0,0,0,0,0,60831,0,26124),
(111411,'|TInterface\\Icons\\ability_hunter_pet_dragonhawk.blp:20|t Elerethe begins |cFFFF0000|Hspell:212707|h[Gathering Clouds]|h|r and prepares to fly to another platform!','|TInterface\\Icons\\ability_hunter_pet_dragonhawk.blp:20|t Elerethe begins |cFFFF0000|Hspell:212707|h[Gathering Clouds]|h|r and prepares to fly to another platform!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(111412,'This is our darkest hour.','',0,0,0,0,0,0,0,0,0,0,60836,0,26124),
(111413,'The Legion will stop at nothing.','',0,0,0,0,0,0,0,0,0,0,60837,0,26124),
(111414,'What news?','',0,0,0,0,0,0,0,0,0,0,60838,0,26124),
(111415,'I always knew this day would come.','',0,0,0,0,0,0,0,0,0,0,60839,0,26124),
(111416,'We must fight together or we will perish alone.','',0,0,0,0,0,0,0,0,0,0,60832,0,26124),
(111417,'We must not lose hope.','',0,0,0,0,0,0,0,0,0,0,60833,0,26124),
(111418,'Never give in.','',0,0,0,0,0,0,0,0,0,0,60834,0,26124),
(111419,'Fight on.','',0,0,0,0,0,0,0,0,0,0,60835,0,26124),
(111420,'What do you ask of me?','',0,0,0,0,0,0,0,0,0,0,60868,0,26124),
(111421,'We all have to pull together in this.','',0,0,0,0,0,0,0,0,0,0,60869,0,26124),
(111422,'I\'ve fought with the best.','',0,0,0,0,0,0,0,0,0,0,60870,0,26124),
(111423,'The arena is a true test of character.','',0,0,0,0,0,0,0,0,0,0,60871,0,26124),
(111424,'Ancestors watch over you.','',0,0,0,0,0,0,0,0,0,0,60864,0,26124),
(111425,'I will fight to my last breath.','',0,0,0,0,0,0,0,0,0,0,60865,0,26124),
(111426,'Fight like a champion!','',0,0,0,0,0,0,0,0,0,0,60866,0,26124),
(111427,'No one fights alone.','',0,0,0,0,0,0,0,0,0,0,60867,0,26124),
(111428,'You must think this is one of those games where you have to click around constantly to get me to do stuff. IT IS NOT.','',0,0,0,0,0,0,0,0,0,0,60872,0,26124),
(111429,'Hello, friend.','',0,0,0,0,0,0,0,0,0,0,60909,0,26124),
(111430,'Yes?','',0,0,0,0,0,0,0,0,0,0,60910,0,26124),
(111431,'The elements listen.','',0,0,0,0,0,0,0,0,0,0,60911,0,26124),
(111432,'Speak with me.','',0,0,0,0,0,0,0,0,0,0,60912,0,26124),
(111433,'Do not let the darkness triumph.','',0,0,0,0,0,0,0,0,0,0,60905,0,26124),
(111434,'Keep a peaceful mind.','',0,0,0,0,0,0,0,0,0,0,60906,0,26124),
(111435,'Maintain focus.','',0,0,0,0,0,0,0,0,0,0,60907,0,26124),
(111436,'Find your center.','',0,0,0,0,0,0,0,0,0,0,60908,0,26124),
(111437,'I spent several months at the bottom of the ocean with a squid over my head. Your spiteful machinations will not rattle me.','',0,0,0,0,0,0,0,0,0,0,60913,0,26124),
(111438,'I can\'t do this without you, $p. I\'ll wait for your return to take down this beast.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111439,'Let us make quick work of this beast, $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111440,'We have won the day, $p. Meet me back at the crumbled palace and I shall grant you my mark.','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(111441,'I\'ve marked the location on your map. Go now, I will already be inside waiting for you when you arive.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111442,'trills with appreciation before flying to safety.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111443,'','Ravandwyr, you should not have gone off alone!',0,0,0,0,0,0,0,0,0,0,0,66480,26124),
(111444,'','The elements call.',0,0,0,0,0,0,0,0,0,0,0,60816,26124),
(111445,'','How can I help?',0,0,0,0,0,0,0,0,0,0,0,60817,26124),
(111446,'','Yes?',0,0,0,0,0,0,0,0,0,0,0,60818,26124),
(111447,'','For Azeroth.',0,0,0,0,0,0,0,0,0,0,0,60813,26124),
(111448,'','The Earthen Ring will persevere.',0,0,0,0,0,0,0,0,0,0,0,60814,26124),
(111449,'','We journey together with the spirits.',0,0,0,0,0,0,0,0,0,0,0,60815,26124),
(111450,'Come closer, and speak.','',0,0,0,0,0,0,0,0,0,0,60851,0,26124),
(111451,'I am listening.','',0,0,0,0,0,0,0,0,0,0,60852,0,26124),
(111452,'Do not give up.','',0,0,0,0,0,0,0,0,0,0,60853,0,26124),
(111453,'I will do my best to guide you.','',0,0,0,0,0,0,0,0,0,0,60854,0,26124),
(111454,'We must never forget.','',0,0,0,0,0,0,0,0,0,0,60847,0,26124),
(111455,'The elements will never forsake us.','',0,0,0,0,0,0,0,0,0,0,60848,0,26124),
(111456,'With faith, there is a way.','',0,0,0,0,0,0,0,0,0,0,60849,0,26124),
(111457,'Remember.','',0,0,0,0,0,0,0,0,0,0,60850,0,26124),
(111458,'Out with it.','',0,0,0,0,0,0,0,0,0,0,60875,0,26124),
(111459,'Talk.','',0,0,0,0,0,0,0,0,0,0,60876,0,26124),
(111460,'You are a joke.','',0,0,0,0,0,0,0,0,0,0,60873,0,26124),
(111461,'Pathetic.','',0,0,0,0,0,0,0,0,0,0,60874,0,26124),
(111462,'Hi.','',0,0,0,0,0,0,0,0,0,0,60843,0,26124),
(111463,'Tiny friend.','',0,0,0,0,0,0,0,0,0,0,60844,0,26124),
(111464,'Little bitty person.','',0,0,0,0,0,0,0,0,0,0,60845,0,26124),
(111465,'Okay.','',0,0,0,0,0,0,0,0,0,0,60840,0,26124),
(111466,'Ah-yup.','',0,0,0,0,0,0,0,0,0,0,60841,0,26124),
(111467,'Mmmnhmm.','',0,0,0,0,0,0,0,0,0,0,60842,0,26124),
(111468,'You would not like me angry.','',0,0,0,0,0,0,0,0,0,0,60846,0,26124),
(111469,'','A storm is coming.',0,0,0,0,0,0,0,0,0,0,0,60822,26124),
(111470,'','Maybe I can help.',0,0,0,0,0,0,0,0,0,0,0,60823,26124),
(111471,'','The seas are restless.',0,0,0,0,0,0,0,0,0,0,0,60824,26124),
(111472,'','I believe in you.',0,0,0,0,0,0,0,0,0,0,0,60819,26124),
(111473,'','I will do what I can.',0,0,0,0,0,0,0,0,0,0,0,60820,26124),
(111474,'','Spirits guide you.',0,0,0,0,0,0,0,0,0,0,0,60821,26124),
(111475,'Should you wish to learn more enchantments, I would be happy to trade with you for what I know.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111476,'Move along.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111477,'Mind your wandering eyes, stranger.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111478,'This is not a safe place to linger. Keep walking.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111479,'Unless you have something worth risking my life for, I will not budge. Let\'s put the price at something completely absurd.\n\nLet\'s say... enough mana to sustain me for a month. \n\n<Arluin looks smug, as if you could never agree to this absurd request.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111483,'What now?','',0,0,0,0,0,0,0,0,0,0,63208,0,26124),
(111484,'Yes?','',0,0,0,0,0,0,0,0,0,0,63209,0,26124),
(111485,'There is great power in the Heart of Azeroth. There may be no closer place to all of the elements on Azeroth, than where we now stand.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111486,'Do you need a hand? Because I don\'t have one.','',0,0,0,0,0,0,0,0,0,0,63210,0,26124),
(111488,'What do you ask of me?','',0,0,0,0,0,0,0,0,0,0,63211,0,26124),
(111489,'To dominate, or not to dominate, that is the question.','',0,0,0,0,0,0,0,0,0,0,63212,0,26124),
(111490,'There is a method to my madness.','',0,0,0,0,0,0,0,0,0,0,63213,0,26124),
(111491,'I am ready to commune with the Elemental Lords.','I am ready to commune with the Elemental Lords.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111492,'My valarjar.','',0,0,0,0,0,0,0,0,0,0,60893,0,26124),
(111493,'What victories do you bring me?','',0,0,0,0,0,0,0,0,0,0,60894,0,26124),
(111494,'Tell me of your battles.','',0,0,0,0,0,0,0,0,0,0,60895,0,26124),
(111495,'Have you brought valor to these halls?','',0,0,0,0,0,0,0,0,0,0,60896,0,26124),
(111496,'Bring us tales of victory.','',0,0,0,0,0,0,0,0,0,0,60889,0,26124),
(111497,'May your battles be glorious.','',0,0,0,0,0,0,0,0,0,0,60890,0,26124),
(111498,'Go now my champion.','',0,0,0,0,0,0,0,0,0,0,60891,0,26124),
(111499,'Remember, life is nothing without valor.','',0,0,0,0,0,0,0,0,0,0,60892,0,26124),
(111500,'','Glory to Odyn!',0,0,0,0,0,0,0,0,0,0,0,60880,26124),
(111501,'Speak quickly.','',0,0,0,0,0,0,0,0,0,0,60919,0,26124),
(111502,'What is it?','',0,0,0,0,0,0,0,0,0,0,60920,0,26124),
(111503,'Yes?','',0,0,0,0,0,0,0,0,0,0,60921,0,26124),
(111504,'','I serve Odyn.',0,0,0,0,0,0,0,0,0,0,0,60881,26124),
(111505,'','Are you worthy of Odyn\'s gaze?',0,0,0,0,0,0,0,0,0,0,0,60882,26124),
(111506,'','Glory to you on the battlefield.',0,0,0,0,0,0,0,0,0,0,0,60877,26124),
(111507,'','May Odyn\'s gaze give you strength.',0,0,0,0,0,0,0,0,0,0,0,60878,26124),
(111508,'','Strive to be worthy.',0,0,0,0,0,0,0,0,0,0,0,60879,26124),
(111509,'Are you into... bloodletting?','',0,0,0,0,0,0,0,0,0,0,60922,0,26124),
(111510,'I fight for Odyn!','',0,0,0,0,0,0,0,0,0,0,60886,0,26124),
(111511,'I am valarjar.','',0,0,0,0,0,0,0,0,0,0,60887,0,26124),
(111512,'I live for battle!','',0,0,0,0,0,0,0,0,0,0,60888,0,26124),
(111513,'We will meet again.','',0,0,0,0,0,0,0,0,0,0,60883,0,26124),
(111514,'Find glory on the battlefield.','',0,0,0,0,0,0,0,0,0,0,60884,0,26124),
(111515,'Let us cross blades sometime.','',0,0,0,0,0,0,0,0,0,0,60885,0,26124),
(111516,'I am Thoradin.','',0,0,0,0,0,0,0,0,0,0,60902,0,26124),
(111517,'I have seen much in life and death.','',0,0,0,0,0,0,0,0,0,0,60903,0,26124),
(111518,'You speak to the King of Arathor.','',0,0,0,0,0,0,0,0,0,0,60904,0,26124),
(111519,'Beware the Old Gods.','',0,0,0,0,0,0,0,0,0,0,60899,0,26124),
(111520,'Welcome! I hope your travel was pleasant.','',0,0,0,0,0,0,0,0,0,0,63151,0,26124),
(111521,'Farewell, hero.','',0,0,0,0,0,0,0,0,0,0,60900,0,26124),
(111522,'It\'s good to see you.','',0,0,0,0,0,0,0,0,0,0,63152,0,26124),
(111523,'Yes?','',0,0,0,0,0,0,0,0,0,0,63153,0,26124),
(111524,'In every loss there is gain, in every gain there is loss.','',0,0,0,0,0,0,0,0,0,0,63154,0,26124),
(111525,'Be strong of arm and mind.','',0,0,0,0,0,0,0,0,0,0,60901,0,26124),
(111526,'I choose when to fight; others do not have this luxury.','',0,0,0,0,0,0,0,0,0,0,63155,0,26124),
(111527,'Courage first; then power; then technique.','',0,0,0,0,0,0,0,0,0,0,63149,0,26124),
(111528,'Bend with the wind and you will not break.','',0,0,0,0,0,0,0,0,0,0,63150,0,26124),
(111529,'Begone.','',0,0,0,0,0,0,0,0,0,0,63205,0,26124),
(111530,'The mortals come to assault our position! Strip the flesh from their bones!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111531,'Fine.','',0,0,0,0,0,0,0,0,0,0,63206,0,26124),
(111532,'Very well.','',0,0,0,0,0,0,0,0,0,0,63207,0,26124),
(111533,'Let none who trespass into the Legion\'s domain survive!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111534,'At last.','',0,0,0,0,0,0,0,0,0,0,60916,0,26124),
(111535,'You\'ll think it less funny plummeting back to Azeroth.','',0,0,0,0,0,0,0,0,0,0,60897,0,26124),
(111536,'Want to try that from the bottom of my boot?','',0,0,0,0,0,0,0,0,0,0,60898,0,26124),
(111537,'Enough talking.','',0,0,0,0,0,0,0,0,0,0,60917,0,26124),
(111538,'There\'s work to be done.','',0,0,0,0,0,0,0,0,0,0,60918,0,26124),
(111539,'','Do you need a book?',0,0,0,0,0,0,0,0,0,0,0,60858,26124),
(111540,'','Shall I look something up for you?',0,0,0,0,0,0,0,0,0,0,0,60859,26124),
(111541,'','Yes?',0,0,0,0,0,0,0,0,0,0,0,60860,26124),
(111542,'','Walk in wisdom.',0,0,0,0,0,0,0,0,0,0,0,60855,26124),
(111543,'','The world is the teacher, and we it\'s students.',0,0,0,0,0,0,0,0,0,0,0,60856,26124),
(111544,'','Take care.',0,0,0,0,0,0,0,0,0,0,0,60857,26124),
(111545,'','How about you go find a nice book to read?',0,0,0,0,0,0,0,0,0,0,0,60862,26124),
(111546,'','I\'m ready to check-out.',0,0,0,0,0,0,0,0,0,0,0,60863,26124),
(111547,'','Shush!',0,0,0,0,0,0,0,0,0,0,0,60861,26124),
(111548,'Bal\'a dash, malanore.','',0,0,0,0,0,0,0,0,0,0,63146,0,26124),
(111549,'You have my attention.','',0,0,0,0,0,0,0,0,0,0,63147,0,26124),
(111550,'Any news?','',0,0,0,0,0,0,0,0,0,0,63148,0,26124),
(111551,'We must overcome the mistakes of the past.','',0,0,0,0,0,0,0,0,0,0,63144,0,26124),
(111552,'Safe travels.','',0,0,0,0,0,0,0,0,0,0,63145,0,26124),
(111553,'Is that...? It is!','Is that...? It is!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111554,'Nightwell be praised...','Nightwell be praised...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111555,'Please...','Please...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111556,'I can\'t take this any more!','I can\'t take this any more!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111557,'Make the pain stop...','Make the pain stop...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111558,'I can\'t begin to thank you enough!','I can\'t begin to thank you enough!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111559,'I thought I was going to die.','I thought I was going to die.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111560,'How could they let us suffer like that?','How could they let us suffer like that?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111561,'Thank you, thank you, thank you!','Thank you, thank you, thank you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111562,'I thought I would never taste it again.','I thought I would never taste it again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111563,'Shaman of the Earthen Ring, we gather together to commemorate a newly forged alliance.','',0,0,0,0,0,0,1,0,0,0,66830,0,26124),
(111564,'Today, we are witness to the fulfillment of prophecy.','',0,0,0,0,0,0,1,0,0,0,67070,0,26124),
(111565,'The Farseer of the Earthen Ring has united the great Elemental Lords to save Azeroth!','',0,0,0,0,0,0,1,0,0,0,67071,0,26124),
(111566,'The Burning Legion will fall. The demons are no match for the fury of the elements!','',0,0,0,0,0,0,1,0,0,0,69386,0,26124),
(111568,'Bah! That portal foundation is all wrong. It is fully exposed to tampering. Whoever made this should feel bad about themselves.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111569,'Well now, Arkethrax is leading this band? This is an opportunity I did not expect.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111573,'What is this mumbling trash? They call THIS a ritual? I could rain fire down on all of these eredar and I don\'t think it could make this ritual any worse than it already is.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111574,'Hrm, that wasn\'t expected... Let me try this again.','',0,0,0,0,0,0,603,0,0,0,66502,0,26124),
(111575,'Where are all the powerful demons hiding?','',0,0,0,0,0,0,603,0,0,0,66507,0,26124),
(111576,'Another imp?! Unbelievable.','',0,0,0,0,0,0,603,0,0,0,66503,0,26124),
(111577,'I\'ll get it right next time.','',0,0,0,0,0,0,603,0,0,0,66504,0,26124),
(111578,'Galius Miremoore grumbles.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111579,'UNUSED - Do you really believe I would leave something so valuable unguarded?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111580,'UNUSED - Some secrets are too big for small minds such as yours...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111581,'Very good!','',0,0,0,0,0,0,0,0,0,0,60198,0,26124),
(111582,'My brother spoke of a dragon called Lanigosa at Wyrmrest Temple. Seek her out while I prepare a strike force for the tomb.','',0,0,0,0,0,0,1,0,0,0,63343,0,26124),
(111585,'','Hello, $c. I sense you have business with me.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111586,'','Earth and stone shall rise to shield our world from the demon onslaught!',0,0,0,0,0,0,1,0,0,0,0,67617,26124),
(111587,'I do. I am looking for a paladin named Galford.','I do. I am looking for a paladin named Galford.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111588,'','Ah yes! A very studious sort he was, eager to hear stories of Tyr, the titan keeper.$b$bI told him of the battle between Galakrond and Tyr, and how Kalecgos saw Tyr\'s severed hand at Galakrond\'s Rest. Galford got very excited and left.$b$bIs your friend safe?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111589,'In truth I do not know, I will seek him out.','In truth I do not know, I will seek him out.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111590,'It will be an honor to battle at your side, Farseer. Together, we shall scatter the demons like dust in the wind!','',0,0,0,0,0,0,1,0,0,0,67618,0,26124),
(111591,'Southern reinforcement camp! We can\'t hold them off much longer! A dreadlord\'s taken nearly half my men!','Southern reinforcement camp! We can\'t hold them off much longer! A dreadlord\'s taken nearly half my men!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(111592,'They\'re out here at Molsen Farm too! Get out here! They\'re everywhere!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(111593,'','Galakrond\'s Rest can be dangerous. Perhaps a tracking spell will be of use.',0,0,0,0,0,0,1,0,0,0,0,63346,26124),
(111594,'Pearlhunter Phin stares at you in disbelief.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111595,'Pearlhunter Phin chuckles, then shakes their head in shame.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111596,'Pearlhunter Phin waves a hand in front of its nose and groans loudly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111597,'Ah, you are here. All is ready.','',0,0,0,0,0,0,0,0,0,0,66076,0,26124),
(111598,'We do not tolerate misconduct amongst our own, $n. However if your accusation against Archmage Vargoth proves malicious, know that the consequences will be severe.','',1,0,0,0,0,0,0,0,0,0,68874,0,26124),
(111599,'','Your friend came seeking answers, his mind flooded by memories stored in the Spark of the noble watcher. He learned of Tyr\'s ancient battle against Galakrond, and of the hand he lost in the dragon\'s maw.',0,0,0,0,0,0,1,0,0,0,0,63360,26124),
(111601,'Stop following me!','Stop following me!',0,0,0,0,0,0,0,0,0,0,0,66316,26124),
(111602,'Ansirem, I have been following $n for some time now and these are not spurious charges. I too observed Archmage Vargoth behaving oddly.','',0,0,0,0,0,0,0,0,0,0,68875,0,26124),
(111603,'As have I. He has been quite preoccupied of late.','',1,0,0,0,0,0,0,0,0,0,68873,0,26124),
(111604,'I am ready. Begin the spell.','I am ready. Begin the spell.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111608,'','Agh!! Make them stop! Please make them stop!',0,0,0,0,0,0,0,0,0,0,0,67459,26124),
(111610,'Go forth, Farseer, as Champion of The Elements and bring defeat to the Burning Legion!','',0,0,0,0,0,0,1,0,0,0,67619,0,26124),
(111611,'There is still much to do. Advisor Sevel is waiting for you. He is making preparations for the coming battle against the Burning Legion.','',0,0,0,0,0,0,1,0,0,0,67620,0,26124),
(111612,'The Earthen Ring stands with you as well, my friend.','',0,0,0,0,0,0,1,0,0,0,67621,0,26124),
(111613,'Alexston\'s been overrun as well! We\'ve taken shelter in the barn!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(111614,'|TINTERFACE\\ICONS\\warrior_talent_icon_thunderstruck:20|t Nithogg unleashes a |cFFFF0404|Hspell:212841|h[Crackling Jolt]|h|r!','|TINTERFACE\\ICONS\\warrior_talent_icon_thunderstruck:20|t Nithogg unleashes a |cFFFF0404|Hspell:212841|h[Craclkling Jolt]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(111615,'We\'ve scouted another camp down here along the coast! It\'s a big one!','We\'ve scouted another camp down here along the coast! It\'s a big one!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(111616,'Looks like Furlbrow\'s needs some help! Send ground forces immediately!','Looks like Furlbrow\'s needs some help! Send ground forces immediately!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(111617,'','The Burning Legion is attacking Azeroth once again. The world is in chaos, but Deepholm faces a more urgent threat.$b$bI cannot go hunting jackals while wolves snarl at my doorstep!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111618,'Meryl clears his throat and coughs.','',0,0,0,0,0,0,0,0,0,0,71750,0,26124),
(111619,'Long live the Resistance!','Long live the Resistance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111620,'The Lotus shall bloom once more!','The Lotus shall bloom once more!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111621,'Eviscerate the bourgeoisie!','Eviscerate the bourgeoisie!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111622,'I think that cough is getting worse.','',1,0,0,0,0,0,0,0,0,0,67635,0,26124),
(111623,'Hmm. Perhaps you should get some rest, Meryl.','',1,0,0,0,0,0,0,0,0,0,67636,0,26124),
(111624,'You don\'t sound so good.','',0,0,0,0,0,0,0,0,0,0,67637,0,26124),
(111626,'I feel as if I know you from somewhere, $n...','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(111627,'I have been hearing great things about you, $n.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(111628,'Your skills are much discussed amongst the Kirin Tor, $n. I look forward to seeing you in action!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(111629,'Meryl, please get some rest! $n, I hope to see you in Azsuna shortly.','',1,0,0,0,0,0,0,0,0,0,67638,0,26124),
(111630,'','A silver hand was forged by Jotun, Tyr\'s dearest friend for many ages. When Tyr found proof of Loken\'s betrayal, it was Jotun who stayed behind to hold off the fallen watcher\'s pursuit.',0,0,0,0,0,0,1,0,0,0,0,63361,26124),
(111631,'Yes, I think I will. Thank you for taking over for me, $n.','',1,0,0,0,0,0,0,0,0,0,71755,0,26124),
(111632,'Meryl coughs and retches violently.','',0,0,0,0,0,0,0,0,0,0,71751,0,26124),
(111633,'I\'ve perfected my murloc mindmeld technique over many years.','',3,0,0,0,0,0,0,0,0,0,0,0,26124),
(111634,'','Your friend sought out Jotun, but the Spark did not warn him of the cruel curse with which Loken twisted the watcher\'s mind. The paladin rushed to the chasm south of here, only to meet his doom.',0,0,0,0,0,0,1,0,0,0,0,63362,26124),
(111635,'|TInterface\\Icons\\ability_hunter_pet_spider.blp:20|t %s calls for |cFFF00000|Hspell:212364|h[Feeding Time]|h|r.','|TInterface\\Icons\\ability_hunter_pet_spider.blp:20|t %s calls for |cFFF00000|Hspell:212364|h[Feeding Time]|h|r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(111636,'','Hail.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111637,'Is there something you require?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111638,'','Yes?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111639,'The cruel caskmaster has breathed his last.','The cruel caskmaster has breathed his last.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111640,'The saber prowls the plaza.','The saber prowls the plaza.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111641,'The owl hoots at dusk.','The owl hoots at dusk.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111642,'Khadgar, thank you for coming so quickly! He is declining rapidly!','',1,0,0,0,0,0,0,0,0,0,67639,0,26124),
(111643,'Hmm. This illness is magical in nature. You were right to summon me, Ravandwyr.','',1,0,0,0,0,0,0,0,0,0,67640,0,26124),
(111644,'','Say no more.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111647,'','Let us begin. Come along, Theryn.',0,0,0,0,0,0,0,0,0,0,0,67445,26124),
(111648,'','Understood.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111650,'','Thalyssra, you cannot be serious? Wasting your time on this... creature!',0,0,0,0,0,0,0,0,0,0,0,67223,26124),
(111653,'<The shadowy figure glimmers in the corner of your eye like a shade from a forgotten time. He does not react to your presence.>','<The shadowy figure glimmers in the corner of your eye like a shade from a forgotten time. She does not react to your presence.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111654,'Very well.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111655,'','Nar\'thala vas manari...',0,0,0,0,0,0,0,0,0,0,0,67446,26124),
(111659,'Rrrgghhh...','',0,0,0,0,0,0,0,0,0,0,71837,0,26124),
(111660,'','I\'ve been looking all over for you. Have you found... Oh, no...',0,0,0,0,0,0,0,0,0,0,0,63356,26124),
(111661,'RrrggaaAAHHGGHH!! RAAGGGHH!','',0,0,0,0,0,0,0,0,0,0,72010,0,26124),
(111662,'','I, too have felt it...',0,0,0,0,0,0,0,0,0,0,0,67453,26124),
(111663,'','The day he was exiled...',0,0,0,0,0,0,0,0,0,0,0,67449,26124),
(111664,'','This hunger... this fear...',0,0,0,0,0,0,0,0,0,0,0,67452,26124),
(111665,'Unnngh...','',0,0,0,0,0,0,0,0,0,0,71827,0,26124),
(111666,'<A ghostly figure rests on the stairway, a half-remembered shade from another time. He recognizes the staff you carry and nods towards you, grimly.>\n\nYou haven\'t changed your mind, Alodi? It doesn\'t trouble you that we\'re pouring all of our energy into that staff of yours?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(111667,'','Such confusion... such rage...',0,0,0,0,0,0,0,0,0,0,0,67456,26124),
(111668,'','Thalyssra! Are you alright?',0,0,0,0,0,0,0,0,0,0,0,67462,26124),
(111669,'I seek the wisdom of the council.','I seek the wisdom of the council.',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(111670,'Very well, mage. I will do as you ask... but please, be careful. No mortal has ever possessed such power.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111671,'','I am truly sorry. It looks as though your friend was crushed. What could have...',0,0,0,0,0,0,0,0,0,0,0,63357,26124),
(111672,'Leave this place! Loken\'s curse compels me to slay the allies of Tyr. Until he comes to collect Tyr\'s spark, I must defend it!','',0,0,0,0,0,0,0,0,0,0,63348,0,26124),
(111673,'','What is this essence the giant speaks of? I would have words with you, $n.',0,0,0,0,0,0,0,0,0,0,0,63358,26124),
(111674,'','Tell me what is going on. What is it you seek, $n?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111675,'Galford was the bearer of a spark of Tyr\'s essence. It seems Jotun killed him and took it. I need the spark to claim Tyr\'s warhammer.','Galford was the bearer of a spark of Tyr\'s essence. It seems Jotun killed him and took it. I need the spark to claim Tyr\'s warhammer.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111676,'','A just cause. I shall stand with you against the might of Jotun, $n. Be ready!',0,0,0,0,0,0,0,0,0,0,0,63359,26124),
(111677,'<The gnome flickers in the corner of your consciousness, a half-remembered shade from another time. His face lights up when he sees the staff in your hands.>\n\nIs it time, Alodi? Is your staff ready?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(111678,'That\'s all I\'ve got, old friend. The Legion won\'t know what hit \'em!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(111679,'I just read an interesting paper on the lowly kobold. Apparently, these creatures are more fierce than their visual affordance might suggest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111680,'Fetch me a secondary reference on kobolds. I\'d like to verify this hypothesis.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111681,'Fascinating.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111682,'Of course, a more pressing concern to our academy is the constant encroachment of the skrogs.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111683,'Unfortunately, I\'m afraid that our library suffers a scarcity of information on these creatures.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111684,'Find me a book on skrogs. Anything will do.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111685,'Lastly, I\'d like to brush up on dragons. Blue dragons, to be precise.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111686,'<Is that... a dragon, languidly resting atop the greenhouse? The creature is there, and simultaneously not. She seems to be a memory from your staff, Ebonchill, and not part of this world. A draconic advisor from a forgotten time.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111687,'We are currently on good terms with our northerly neighbors, but should our friendship wither, it can\'t hurt to know how they fight.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111688,'<You see a great blue dragon, resting languidly atop the greenhouse. She seems to be a memory from your staff, Ebonchill, and not part of this world. To your surprise, the mighty creature turns to face you, speaking slowly:>$b$bThe great Alodi returns, seeking ever more power. Tell me, mage, has the Council considered the impact of granting so much magical energy to a single mortal, hmmmm?$b$bAnd what if their beloved Guardian should ever betray them?$b$bI will be watching you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111689,'I heard the spy is here and he\'s very good looking.','I heard the spy is here and he\'s very good looking.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111690,'It seems like there are some new faces here at tonight\'s party...','It seems like there are some new faces here at tonight\'s party...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111691,'Hmm, now I\'ve heard a juicy rumor about the party. I heard there\'s a Burning Legion spy here, making sure we\'re still loyal!','Hmm, now I\'ve heard a juicy rumor about the party. I heard there\'s a Burning Legion spy here, making sure we\'re still loyal!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111692,'The one that Elisande invited to the party? Now I didn\'t say this, but that one is really a spy for the Burning Legion.','The one that Elisande invited to the party? Now I didn\'t say this, but that one is really a spy for the Burning Legion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111693,'Some are saying there\'s a member of the Burning Legion attending this party incognito...','Some are saying there\'s a member of the Burning Legion attending this party incognito...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111694,'How exciting! There\'s supposedly a mystery guest out and about! Wait, what? A spy you say...','How exciting! There\'s supposedly a mystery guest out and about! Wait, what? A spy you say...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111695,'A rumor about someone new to the party? I heard it\'s a member of the Burning Legion keeping tabs on us!','A rumor about someone new to the party? I heard it\'s a member of the Burning Legion keeping tabs on us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111696,'Be careful out there. There\'s a rumor the Burning Legion snuck a spy into the party.','Be careful out there. There\'s a rumor the Burning Legion snuck a spy into the party.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111697,'Did you see all those demons outside? They are keeping an eye on us! There\'s a spy in here somewhere, I just know it.','Did you see all those demons outside? They are keeping an eye on us! There\'s a spy in here somewhere, I just know it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111698,'I heard somewhere that the spy isn\'t female.','I heard somewhere that the spy isn\'t female.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111699,'A guest said she saw him entering the manor alongside the Grand Magistrix.','A guest said she saw him entering the manor alongside the Grand Magistrix.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111700,'One of the musicians said he would not stop asking questions about the district.','One of the musicians said he would not stop asking questions about the district.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111701,'They say that the spy is here and she\'s quite the sight to behold.','They say that the spy is here and she\'s quite the sight to behold.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111702,'Someone\'s been saying that our new guest isn\'t male.','Someone\'s been saying that our new guest isn\'t male.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111703,'A guest saw both her and Elisande arrive together earlier.','A guest saw both her and Elisande arrive together earlier.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111704,'I hear some woman has been constantly asking about the district...','I hear some woman has been constantly asking about the district...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111705,'I heard that the spy is wearing a lighter vest to tonight\'s party.','I heard that the spy is wearing a lighter vest to tonight\'s party.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111706,'The spy definitely prefers the style of light colored vests.','The spy definitely prefers the style of light colored vests.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111707,'I overheard the spy saying dark vests clash horridly with silver hair and to never be caught in one.','I overheard the spy saying dark vests clash horridly with silver hair and to never be caught in one.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111708,'People are saying the spy is not wearing a darker vest tonight.','People are saying the spy is not wearing a darker vest tonight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111709,'The spy enjoys darker colored vests... like the night.','The spy enjoys darker colored vests... like the night.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111710,'I heard the spy\'s vest is a dark, rich shade this very night.','I heard the spy\'s vest is a dark, rich shade this very night.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111711,'Rumor has it the spy is avoiding light colored clothing to try and blend in more.','Rumor has it the spy is avoiding light colored clothing to try and blend in more.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111712,'The spy definitely prefers darker clothing.','The spy definitely prefers darker clothing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111713,'I heard the spy always dons gloves.','I heard the spy always dons gloves.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111714,'Someone said the spy wears gloves to cover obvious scars.','Someone said the spy wears gloves to cover obvious scars.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111715,'There\'s a rumor that the spy always wears gloves.','There\'s a rumor that the spy always wears gloves.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111716,'I heard the spy carefully hides their hands.','I heard the spy carefully hides their hands.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111717,'I heard the spy dislikes wearing gloves.','I heard the spy dislikes wearing gloves.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111718,'There\'s a rumor that the spy never has gloves on.','There\'s a rumor that the spy never has gloves on.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111719,'You know... I found an extra pair of gloves in the back room. The spy is likely to be bare handed somewhere around here.','You know... I found an extra pair of gloves in the back room. The spy is likely to be bare handed somewhere around here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111720,'I heard the spy avoids having gloves on, in case some quick actions are needed.','I heard the spy avoids having gloves on, in case some quick actions are needed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111721,'I didn\'t tell you this... but the spy is masquerading as an alchemist and carrying potions at the belt.','I didn\'t tell you this... but the spy is masquerading as an alchemist and carrying potions at the belt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111722,'I heard the spy brought along some potions... just in case.','I heard the spy brought along some potions... just in case.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111723,'I think I saw the spy with a green potion on the belt.','I think I saw the spy with a green potion on the belt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111724,'Someone told me the spy arrived carrying a green flask of some sort. I wonder what that would be for?','Someone told me the spy arrived carrying a green flask of some sort. I wonder what that would be for?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111725,'I heard the spy brought along potions, I wonder why?','I heard the spy brought along potions, I wonder why?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111726,'I\'m pretty sure the spy has potions at the belt.','I\'m pretty sure the spy has potions at the belt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111727,'You leave me no choice! I must destroy you!','',0,0,0,0,0,0,0,0,0,0,63349,0,26124),
(111728,'You are strong! Perhaps you can end my unceasing vigil.','',0,0,0,0,0,0,0,0,0,0,63354,0,26124),
(111729,'The pain! It frees my mind of the curse... for the moment.','',0,0,0,0,0,0,0,0,0,0,63350,0,26124),
(111730,'Loken\'s enchantment won\'t let me die. We have only a moment before I fall into madness again.','',0,0,0,0,0,0,0,0,0,0,63351,0,26124),
(111731,'Here is the spark. Take it and flee! Keep the memory of my fallen friend alive.','',0,0,0,0,0,0,0,0,0,0,63352,0,26124),
(111732,'For Tyr!','',0,0,0,0,0,0,0,0,0,0,63353,0,26124),
(111733,'I heard the spy carries a magical pouch around at all times.','I heard the spy carries a magical pouch around at all times.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111734,'I heard the spy\'s belt pouch is lined with fancy threading.','I heard the spy\'s belt pouch is lined with fancy threading.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111735,'I heard the spy is not carrying any potions around.','I heard the spy is not carrying any potions around.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111736,'A friend of mine managed to steal a pink potion off the belt of the spy earlier. Wherever the spy is now, he or she definitely does not have any pink potions!','A friend of mine managed to steal a pink potion off the belt of the spy earlier. Wherever the spy is now, he or she definitely does not have any pink potions!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111737,'Rumor has is the spy loves to read and always carries around at least one book.','Rumor has is the spy loves to read and always carries around at least one book.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111738,'I heard the spy always has a book of written secrets at the belt.','I heard the spy always has a book of written secrets at the belt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111739,'I heard the spy\'s belt pouch is filled with gold to show off extravagance.','I heard the spy\'s belt pouch is filled with gold to show off extravagance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111740,'A friend said the spy loves gold and a belt pouch filled with it.','A friend said the spy loves gold and a belt pouch filled with it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111741,'So be it. Turn this great power against the foes of Tirisfal!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111742,'These lamps guided me to this place. I only hope the path on my return is safe...','These lamps guided me to this place. I only hope the path on my return is safe...',0,0,0,0,0,0,0,0,0,0,0,65937,26124),
(111743,'A musician told me she saw the spy throw away their last potion and no longer has any left.','A musician told me she saw the spy throw away their last potion and no longer has any left.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111744,'I heard the spy is not carrying any green potions.','I heard the spy is not carrying any green potions.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111745,'I heard the spy\'s outfit has long sleeves tonight.','I heard the spy\'s outfit has long sleeves tonight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111746,'I just barely caught a glimpse of the spy\'s long sleeves earlier in the evening.','I just barely caught a glimpse of the spy\'s long sleeves earlier in the evening.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111747,'A friend of mine mentioned the spy has long sleeves on.','A friend of mine mentioned the spy has long sleeves on.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111748,'Someone said the spy is covering up their arms with long sleeves tonight.','Someone said the spy is covering up their arms with long sleeves tonight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111749,'I heard the spy enjoys the cool air and is not wearing long sleeves tonight.','I heard the spy enjoys the cool air and is not wearing long sleeves tonight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111750,'I heard the spy wears short sleeves to keep their arms unencumbered.','I heard the spy wears short sleeves to keep their arms unencumbered.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111751,'A friend of mine said she saw the outfit the spy was wearing. It did not have long sleeves.','A friend of mine said she saw the outfit the spy was wearing. It did not have long sleeves.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111752,'Someone told me the spy hates wearing long sleeves.','Someone told me the spy hates wearing long sleeves.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111753,'I heard the spy enjoys wearing capes.','I heard the spy enjoys wearing capes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111754,'Someone mentioned the spy came in earlier wearing a cape.','Someone mentioned the spy came in earlier wearing a cape.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111755,'','<A shadowy figure sits peacefully in the park, like a half-forgotten memory of a long-dead figure from the past. She seems to recognize your staff and greets you warmly, believing you to be someone else.>$b$bHello Alodi, old friend! Join me, would you? One of life\'s most sublime pleasures is sitting in a park with a familiar old book.$b$bI think I shall plant a sapling here, so that in the years to come mages can sit beneath the shade of a small tree.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111756,'I heard the spy dislikes capes and refuses to wear one.','I heard the spy dislikes capes and refuses to wear one.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111757,'I heard that the spy left their cape in the palace before coming here.','I heard that the spy left their cape in the palace before coming here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111758,'','I will help if I must. You\'ve concentrated so much power into that staff - I worry what will become of you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111759,'','If you desire, I can take you back to your city in the sky. I will return later for Galford\'s remains.',0,0,0,0,0,0,0,0,0,0,0,63355,26124),
(111760,'We are with you, champion. Let us end this beast!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111761,'I am Tyr\'s Guard. We are a secret order of paladins that have been guarding a great secret for a very long time. Unfortunately current events have caused us to end our secrecy.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111762,'A secret order?','A secret order?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111763,'','<A ghostly shade lingers in the citadel, a long-dead memory from Dalaran\'s past. The slender figure recognizes your staff and mistakes you for someone else. She lazily looks you over through half-lidded eyes.>$b$bArchmage Alodi. You go to face Kathra\'natir, then? The rest of the council ignores my warnings.$b$bVery well. I will not stop your suicide. If you seek to add my power to yours, you need only ask.$b$b<Fiora sips her wine, sadly, and does not look you in the eye.>',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(111764,'','Very well. Make this count, mage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111765,'','The Legion has captured a clutch of Stellagosa\'s azure whelplings! Save them, so our ally\'s brood may grow stronger!',0,0,0,0,0,0,0,0,0,0,0,72178,26124),
(111766,'','Those whelps were so small, so helpless. How despicable of the Legion to prey upon the weak!',0,0,0,0,0,0,0,0,0,0,0,72179,26124),
(111767,'','Each Legion detachment draws power from a soul engine. Incapacitate the demons\' vile machine and slay the eredar who maintain it!',0,0,0,0,0,0,0,0,0,0,0,61422,26124),
(111768,'','Outstanding! They must make repairs before their soul engine can re-engage. You have bought us valuable time.',0,0,0,0,0,0,0,0,0,0,0,61421,26124),
(111769,'','We can brew a powerful draught of demon detection with the right pile of entrails. Collect them for me, and together we will retake Faronaar!',0,0,0,0,0,0,0,0,0,0,0,72176,26124),
(111770,'','You certainly don\'t shy away from the dirty work. Well done.',0,0,0,0,0,0,0,0,0,0,0,72177,26124),
(111771,'','Sometimes I wish Garuhod\'s research called for less... distasteful reagents. Alas, these will do. Thank you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111772,'So arrogant are the Legion that they defile my lands and think themselves safe.','',0,0,0,0,0,0,0,0,0,0,61418,0,26124),
(111773,'Their forces are massing in Faronaar. Strike there, and cripple them before they move deeper into Azsuna!','',0,0,0,0,0,0,0,0,0,0,61417,0,26124),
(111774,'You have shown the Legion that they will be hunted anywhere they dare tread in Azsuna. Excellent work!','',0,0,0,0,0,0,0,0,0,0,61416,0,26124),
(111775,'[CUT] Day 20: Captured a new subject today. Number 16. He seems different somehow.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111776,'<A half-remembered shadow lurks in the rear of the tavern, nosing through scrolls. The high-elf is a memory from another time. He recognizes your staff and greets you as an equal.>\n\nThe moment of truth arrives. Are you ready, Alodi? Are you certain that you can handle so much power?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(111777,'Whoa... I didn\'t expect the queen to show up... I\'ll get you out of there. Hang on!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111778,'In time we must all face our demons. Better you than me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111779,'','<A shadowy image of a gnome floats before you, a distant memory from the past. She is concentrating on a powerful spell, but mistakes you for someone else as you approach.>\n\nAlodi! You\'ve returned. Let me see that staff of yours. Yes, yes... I can help you, of course. But you should hear what the rest of the council is saying behind your back. You\'re lucky they need you.',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(111780,'Watch out!','',0,0,0,0,0,0,153,0,0,0,0,0,26124),
(111781,'Tick, tock!','',0,0,0,0,0,0,153,0,0,0,0,0,26124),
(111782,'','I hope you know what you\'re doing. But if not... At least we\'re in for some fireworks. Good luck out there!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111783,'Portal coming up!','',1,0,0,0,0,0,0,0,0,0,67641,0,26124),
(111784,'','South gate! Another demon in the fields!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(111785,'Your souls are so easily corrupted, mortals.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111786,'Gonna BASH you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111787,'Demon heading for the wall to the northeast!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(111788,'Today, we dealt a great blow to the unseen enemies of the Nightmare.','',0,0,0,0,0,0,0,0,6,0,66776,0,26124),
(111790,'However, Xavius, Lord of the Nightmare, still lives. Only when he is defeated, will Azeroth truly be safe.','',0,0,0,0,0,0,0,0,6,0,66809,0,26124),
(111791,'This is perfectly safe! Oh, right... watch out for spiders down there. Whatever you do, don\'t cut yourself down from the rope!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111792,'To accomplish this task, I gift you with my blessing. Use my power to serve and protect the wilds.','',0,0,0,0,0,0,0,0,6,0,66778,0,26124),
(111793,'Thank you, druids of the Dreamgrove. May you prosper under the leadership of your new Archdruid.','',0,0,0,0,0,0,0,0,6,0,66810,0,26124),
(111794,'Farewell.','',0,0,0,0,0,0,0,0,6,0,66779,0,26124),
(111796,'The years have not been kind to me, $n.$b$b<Fillmaff coughs, weakly.>$b$bI think I may be dead.','',274,0,0,0,0,0,0,0,0,0,0,0,26124),
(111797,'Wait. Is that a journal you\'ve found? That may be what we are looking for!','',1,0,0,0,0,0,0,0,0,0,67642,0,26124),
(111798,'Until we meet again.','',1,0,0,0,0,0,0,0,0,0,67643,0,26124),
(111799,'','Our Hippogryphs have been well fed and are ready to take you anywhere.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111805,'It is always a pleasure to be able to stretch my wings!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111806,'It is always a pleasure to be able to stretch my wings! Are you ready to go?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111807,'I\'m ready. Let\'s go!','I\'m ready. Let\'s go!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111808,'Not yet. I need more time.','Not yet. I need more time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111809,'It\'s days like these that make me long for the comforts of home.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(111810,'Can I help you?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(111811,'This is the head of the beast that killed your mage.','This is the head of the beast that killed your mage.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(111812,'','Let us move on.',0,0,0,0,0,0,0,0,0,0,0,67454,26124),
(111813,'','Dismiss these memories so we can proceed.',0,0,0,0,0,0,0,0,0,0,0,67450,26124),
(111814,'','I am losing control...',0,0,0,0,0,0,0,0,0,0,0,67457,26124),
(111815,'Where did you find this beast? I\'ve never seen one quite like it.$B$BTo the untrained eye, this felhound may look like any other minion, but a close examination of its jaw shows an extra set of razor-sharp teeth.$B$BIt is clear to me now that this is the beast that is responsible for the death of our companion.$B$BPlease apologize to Hilaire for the mix up. We can\'t be too careful these days.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(111816,'','That is precisely what I am doing.',0,0,0,0,0,0,0,0,0,0,0,67225,26124),
(111817,'Lenora, release the beast. It poses no threat to us.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111818,'','We should be planning our attack on Suramar!',0,0,0,0,0,0,0,0,0,0,0,67224,26124),
(111819,'The Dreamweavers have watched over this grove for eons. We follow the path of Cenarius, and protect the forests of Val\'sharah.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111820,'Many of our order still remember when Shaladrassil first took root. We\'ve watched it grow over the ages, until it has towered over this vale. We have been blessed to live under the shade of its branches for so long.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111821,'To understand nature is to understand the great cycle of all things. A blooming flower will someday return to the earth to fuel new seeds. The sun sets each day, to rise again and give new life. Our order is dedicated to understanding and preserving the continuation of this pattern.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111822,'Do you know of \"alara\'shinu,\" druid? It means finding beauty in imperfection. Those who live by this philosophy understand the transience of nature, accept the cycle of life and death, and derive joy from this truth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111823,'Be at peace while you rest here. The Dreamgrove is sanctuary to all of our kind.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111824,'The Dreamweavers care not for your mortal differences, $r. Here, we are druids. Here, we are united toward a common cause.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111825,'Meryl coughs and shivers feverishly.','',0,0,0,0,0,0,0,0,0,0,71753,0,26124),
(111826,'Meryl is wracked by a violent coughing fit.','',0,0,0,0,0,0,0,0,0,0,71748,0,26124),
(111827,'|TInterface\\Icons\\sha_spell_fire_blueimmolation_nightmare:20|tYou are afflicted with |cFFFF0000|Hspell:211471|h[Scorned Touch]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111828,'Meryl groans and clutches his stomach.','',0,0,0,0,0,0,0,0,0,0,71752,0,26124),
(111829,'Meryl chokes and coughs up bile.','',0,0,0,0,0,0,0,0,0,0,71749,0,26124),
(111832,'It\'s broken free! Run for your lives! It\'s... It\'s... NUTZ!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111837,'','It should fool the gibbering, wine-soaked guests, but a keen eye could see through it. Should the illusion falter, the guards will quickly descend upon you.',0,0,0,0,0,0,0,0,0,0,0,70451,26124),
(111838,'Go ahead. I\'m ready for my disguise.','Go ahead. I\'m ready for my disguise.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111839,'','That is an incredibly dangerous proposition you are making. How do I know you truly speak for Vanthir?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111840,'Snowfeather swoops down from the sky.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111841,'<Show your Sigil.>','<Display your allegiance.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111842,'Archmage Vargoth shivers and mutters something unintelligible under his breath.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111843,'I... I am needed elsewhere.','',0,0,0,0,0,0,0,0,0,0,67644,0,26124),
(111844,'Master Bilebrain! The enemy... they are advancing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111845,'Silence! You waste my time with these constant interruptions!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111846,'We leave the master! No more mean Bilebrain.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111847,'','(CUT)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111848,'Always helpful, Ishpip, but Master only yells...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111849,'','(CUT)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111850,'No! Master finds us, turns us to meat!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111851,'Take the Windmaster\'s Totem.','Take the Windmaster\'s Totem.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111852,'I might be interested in what you have to say... with the right motivation.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111853,'<Show Arluin your Sigil.>','<Show Arluin your Sigil.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111857,'','Are you ready to enter the ring and earn glory in neverending combat?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111859,'','Look at their wittle faces! They\'re so cute I\'m going to die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111860,'','You\'re all bark and no bite.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111861,'','Teehee!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111862,'','I\'m going to give you guys the wittle bandages for your wittle boo-boos!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111863,'','Salty?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111864,'','Corgis. Am I right?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111865,'','Woof.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111866,'','But he was so cute!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111867,'','You\'re a monster!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111868,'','Aww.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111870,'T-traitors...','',0,0,0,0,0,0,0,0,0,40285,69829,0,26124),
(111871,'','The sooner I am back in the city, the better.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111872,'Go on...','Go on...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111873,'Don\'t be coy. I know you\'re here to spy for the Grand Magistrix.','Don\'t be coy. I know you\'re here to spy for the Grand Magistrix.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111874,'How dare you accuse me of such a thing, $n? Do you know who I am? I don\'t recognize you at all...','How dare you accuse me of such a thing, $n? Do you know who I am? I don\'t recognize you at all...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111875,'Now now, let\'s not be hasty $n. Why don\'t you follow me so we can talk about this in a more private setting...','Now now, let\'s not be hasty $n. Why don\'t you follow me so we can talk about this in a more private setting...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111876,'Move along, friend. I have no business with you.','Move along, friend. I have no business with you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111877,'I need a flight to Ashamane\'s Fall.','I need a flight to Ashamane\'s Fall.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111878,'Suramar be eternal, friend.','Suramar be eternal, friend.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111879,'This is quite the party, isn\'t it?','This is quite the party, isn\'t it?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111880,'The musicians are quite good, aren\'t they?','The musicians are quite good, aren\'t they?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111881,'You insult my honor, $n. Who exactly are you?','You insult my honor, $n. Who exactly are you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111882,'$n, you think I would spy on my own? Maybe we should look closer at you instead!','$n, you think I would spy on my own? Maybe we should look closer at you instead!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111883,'Well I never! $n, who do you think you are?!','Well I never! $n, who do you think you are?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111884,'<The Hippogryph looks at you for a moment and screeches.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111885,'I want to head back to the Dreamgrove.','I want to head back to the Dreamgrove.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111886,'I don\'t know how you found me out, but now it\'s time to die!','I don\'t know how you found me out, but now it\'s time to die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111887,'Most shamans prefer wolves, but this one prefers... corgis? You might think she\'s barking up the wrong tree, but she\'s beaten every doggone challenger so far! Who will take down these pugnacious pups?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111888,'That battle was one part skill, one part strategy, and ten parts adorable! Keep this up kid, you\'re going places... and making me a pile of gold in the process!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(111889,'Scary...','',0,0,0,0,0,0,0,0,0,0,65779,0,26124),
(111891,'I recognize those blades of yours, $n. They cut the throat of my King and my friend. Please... put them away in these chambers.','',0,0,0,0,0,0,274,0,0,0,73006,0,26124),
(111892,'$n, those daggers you wield - the very same that killed Llane Wrynn in cold blood. The sight of them takes me to a dark place.','',0,0,0,0,0,0,274,0,0,0,73005,0,26124),
(111893,'Are those indeed Garona\'s old daggers, $n? I saw her tear apart a demon in the Karazhan library once with those very blades. If I had only known what was to come...','',0,0,0,0,0,0,661,0,0,0,73004,0,26124),
(111894,'','I live to serve the Magistrix and her people.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111895,'','Glory to the Shal\'dorei.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111896,'','How may I serve you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111897,'','You may call upon my services at any time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111898,'I need to speak to Overseer Elvire.','I need to speak to Overseer Elvire.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111899,'Monsters...','',0,0,0,0,0,0,0,0,0,0,65734,0,26124),
(111900,'Ahhh!','',0,0,0,0,0,0,0,0,0,0,65780,0,26124),
(111901,'Let\'s play somewhere else for a while.','',0,0,0,0,0,0,0,0,0,0,65781,0,26124),
(111902,'Don\'t eat me!','',0,0,0,0,0,0,0,0,0,0,65783,0,26124),
(111903,'What is Elisande thinking, letting them in?','',0,0,0,0,0,0,0,0,0,0,65735,0,26124),
(111904,'Hide! They\'ll eat you!','',0,0,0,0,0,0,0,0,0,0,65782,0,26124),
(111905,'Your vile magic is an abomination!','',0,0,0,0,0,0,0,0,0,0,65736,0,26124),
(111906,'I told you the shrine isn\'t safe! Look at what your stubbornness has caused!','',0,0,0,0,0,0,603,0,0,0,62265,0,26124),
(111907,'Hey!','Hey!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(111908,'You. Me. By the flagpole. After class.','You. Me. By the flagpole. After class.',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(111909,'','I only do as I am told! Don\'t hurt me!',430,0,0,0,0,0,0,0,0,0,0,0,26124),
(111910,'','$n! Is it true you wield the Kingslayers? When I was just a girl, my gran told me the stories. The King of Stormwind grasping at his throat, red blood spattered on the white stones of the keep... I would hide under my covers at night, thinking assassins were everywhere.',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(111911,'Watch where you\'re wanding!','Watch where you\'re wanding!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111912,'I\'m trying to study over here.','I\'m trying to study over here.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111913,'Mrs. Azuremoon! $n is wanding me!','Mrs. Azuremoon! $n is wanding me!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(111914,'Ca-caaw!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111915,'Ow!','Ow!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(111916,'Quit it!','Quit it!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(111917,'You\'re gonna get in trouble if you keep doing that.','You\'re gonna get in trouble if you keep doing that.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111918,'','Don\'t forget to aim before you fire.',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(111919,'','That\'s it. I\'m giving you a zero for the day.',0,0,0,0,0,0,661,0,0,0,0,0,26124),
(111920,'','That\'s minus fifty points for shooting the teacher.',0,0,0,0,0,0,661,0,0,0,0,0,26124),
(111921,'','Keep this up and I\'ll have to give you extra homework.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111922,'My word.','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(111923,'Good gracious, mind your wand fire.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111924,'We\'re not here to have fun, underclassman. We\'re here to learn.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111925,'No horseplay in the study hall!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111926,'Now is not the time for this, Verstok! We must tend to our wounded.','',0,0,0,0,0,0,0,0,0,0,62264,0,26124),
(111927,'I can see why Arluin put his faith in you. Give him our regards.','I can see why Arluin put his faith in you. Give him our regards.',0,0,0,0,0,0,0,0,0,40285,0,0,26124),
(111928,'$n! Are those truly the Kingslayer daggers you carry? I know a few collectors who would pay a pretty penny for those particular pieces of history. I can connect you... for a small finder\'s fee, obviously...','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(111929,'Would you mind? I\'m working on a very important paper, and it\'s difficult to concentrate with you neophytes shooting everything in sight.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111930,'What do you need?','',0,0,0,0,0,0,0,0,0,0,60926,0,26124),
(111931,'How can the Light serve?','',0,0,0,0,0,0,0,0,0,0,60927,0,26124),
(111932,'Let me show you the Light.','',0,0,0,0,0,0,0,0,0,0,60928,0,26124),
(111933,'The Light redeems.','',0,0,0,0,0,0,0,0,0,0,60923,0,26124),
(111934,'Go with the Light.','',0,0,0,0,0,0,0,0,0,0,60924,0,26124),
(111935,'I am the Light\'s vengeance.','',0,0,0,0,0,0,0,0,0,0,60925,0,26124),
(111936,'Woe befalls the heretic.','',0,0,0,0,0,0,0,0,0,0,60929,0,26124),
(111937,'Tell me who to smite and they shall be smoten!','',0,0,0,0,0,0,0,0,0,0,60930,0,26124),
(111938,'I find your lack of faith disturbing.','',0,0,0,0,0,0,0,0,0,0,60931,0,26124),
(111939,'The location is secured. The delivery can proceed as scheduled.','The location is secured. The delivery can proceed as scheduled.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111940,'Naturally. I took a circuitous route through the city.','Naturally. I took a circuitous route through the city.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111941,'For the Grand Magistrix.','For the Grand Magistrix.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111942,'','I trust you were careful to deter any pursuers?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111943,'','Excellent. The shipment will proceed as scheduled, then. It will be delivered to the docks within the hour. See that it is not left unattended. There have been far too many thefts lately.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111944,'','Glory to Elisande.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111945,'Get moving!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111946,'I best be returnin\' later, mon.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111947,'Best be comin\' back when its safe.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111948,'I\'ll see you soon, $n.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(111949,'Brave of you, $n. I be returnin\' soon.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111950,'Kind of you, brave one, but I\'m no great warrior.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111951,'','Your words carry the tone of a great $c, $n. May the Earth mother watch over you.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111952,'Can\'t be stickin\' round here, $n!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111953,'Shops closed! I\'ll be back when it\'s safe.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111954,'If my blades were sharper I\'d stay for a little fun.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111955,'Hey, watch it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111956,'Yes, I have the lasher seed from the roots below Shaladrassil.','',0,0,0,0,0,0,0,0,0,0,66745,0,26124),
(111957,'Take the seed and plant it in the dirt right over here.','',0,0,0,0,0,0,1,0,0,0,66741,0,26124),
(111958,'Those are the Kingslayer daggers, aren\'t they $n? My father served King Llane Wrynn in the first war, before those very daggers took the King\'s life.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111959,'Sometimes it is best to allow the past remain in the past.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111960,'Says you. If I ever meet Garona, I will strangle her myself.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(111961,'I can\'t miss!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111962,'Here comes the BOOM!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111963,'You\'ve stumbled right into my traps!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111964,'$n, we\'re launching a full assault on Broken Shore.  Before we hit the shore, we need every soldier to be combat ready.\n\nAre you ready for your combat training?','$n, we\'re launching a full assault on Broken Shore.  Before we hit the shore, we need every soldier to be combat ready.\n\nAre you ready for your combat training?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111965,'[OLD] I am ready to begin.','[OLD] I am ready to begin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111966,'General!','',0,0,0,0,0,0,25,0,0,924,0,0,26124),
(111967,'We\'ve got incoming!  Look out!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111968,'Incoming! We\'re under attack!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(111969,'Caw! Caaaaaw!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111970,'Caaw ca-caw.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111971,'Caw? Caaaaw!','',0,0,0,0,0,0,403,0,0,0,0,0,26124),
(111972,'Oh thank you! Thank you, strong one! I help, you see!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111973,'This one\'s debt is paid... paid it is! Away!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111974,'Hey! Watch it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111975,'The stupid one stays in the jar! So stupid! It angers master!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111976,'Hush, they are nearby.','',0,0,0,0,0,0,0,0,0,0,65737,0,26124),
(111977,'The Nightborne falls silent.','The Nightborne falls silent.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111978,'We cannot endure your presence any longer!','',0,0,0,0,0,0,0,0,0,0,65738,0,26124),
(111979,'Enough! Get out of our city!','',0,0,0,0,0,0,0,0,0,0,65739,0,26124),
(111980,'You are living up to your reputation, $n. Thank you for handling my duties while I am indisposed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111981,'The recent events and Meryl\'s illness are most distressing. I\'m glad we have you to rely on, $n!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(111982,'You are proving yourself to be a very capable member of the Tirisgarde, $n!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(111983,'|TInterface\\Icons\\ability_socererking_arcaneacceleration|t%s begins to cast |cFFFF0000|Hspell:207278|h[Arcane Lockdown]|h|r! Jump to remove the effect!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(111984,'','It seems we have an accord, then. Shall I fetch your diamond?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111985,'Yes.','Yes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111986,'The world will cry out in anger against us, but the air that fills their lungs will have been bought with the price of our souls.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111987,'Hmmm. Something isn\'t right...','',0,0,0,0,0,0,0,0,0,0,66089,0,26124),
(111988,'','Watch out up here. I\'ve heard tell of a demonic council that draws strength from one another. This bond must be broken.',0,0,0,0,0,0,0,0,0,0,0,70197,26124),
(111989,'','Explore the area and find a way to separate the council members. Divided, they cannot stand against you!',0,0,0,0,0,0,0,0,0,0,0,70193,26124),
(111990,'Enough! We will hunt later.','',0,0,0,0,0,0,0,0,0,0,66090,0,26124),
(111992,'Hm, have we met before? Your face is quite familiar.\n\nOh! You are the hero I\'ve been hearing so much about. You are most impressive...','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(111993,'Archmage Vargoth looks into the distance.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(111994,'Archmage Vargoth\'s fingers twitch spasmodically.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111995,'Archmage Vargoth suddenly loses his balance and lurches to one side.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(111996,'','My informants claim that a Burning Legion spy is attending this party.',0,0,0,0,0,0,0,0,0,0,0,70195,26124),
(111997,'','Speaking with chatty nobles may reveal the spy. Just avoid drawing attention to yourself with wild accusations!',0,0,0,0,0,0,0,0,0,0,0,70196,26124),
(111998,'Caaaw?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(111999,'Caaaaaaw!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112000,'Just visiting?','',6,0,0,0,0,0,0,0,0,0,63030,0,26124),
(112001,'Welcome to the Violet Hold.','',1,0,0,0,0,0,0,0,0,0,63031,0,26124),
(112002,'Nothing escapes these walls.','',1,0,0,0,0,0,0,0,0,0,63032,0,26124),
(112003,'Good.','',0,0,0,0,0,0,0,0,0,0,63027,0,26124),
(112004,'So be it.','',0,0,0,0,0,0,0,0,0,0,63028,0,26124),
(112005,'Well then.','',0,0,0,0,0,0,0,0,0,0,63029,0,26124),
(112007,'My life for Kalimdor.','',0,0,0,0,0,0,0,0,0,0,63184,0,26124),
(112008,'I\'m awake... for now','',0,0,0,0,0,0,0,0,0,0,63185,0,26124),
(112009,'The balance must be restored.','',0,0,0,0,0,0,0,0,0,0,63186,0,26124),
(112010,'We will protect the wilds.','',0,0,0,0,0,0,0,0,0,0,63187,0,26124),
(112011,'May your dreams be peaceful','',0,0,0,0,0,0,0,0,0,0,63180,0,26124),
(112012,'Elune\'s light watch over you.','',0,0,0,0,0,0,0,0,0,0,63181,0,26124),
(112013,'Goodbye, for now.','',0,0,0,0,0,0,0,0,0,0,63182,0,26124),
(112014,'This too, shall pass.','',0,0,0,0,0,0,0,0,0,0,63183,0,26124),
(112015,'I am the one who dreams.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112016,'I can be your worst nightmare.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112017,'Just let me go back to sleep...','',0,0,0,0,0,0,0,0,0,0,63188,0,26124),
(112018,'Every waking moment with you is agony.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112019,'','Your spirit burns bright.',0,0,0,0,0,0,0,0,0,0,0,63218,26124),
(112020,'','I won\'t be forsakin\' Gonk\'s blessing.',0,0,0,0,0,0,0,0,0,0,0,63219,26124),
(112021,'','There be life all around, life worth savin\'.',0,0,0,0,0,0,0,0,0,0,0,63220,26124),
(112022,'','The loa give, and they be takin\' away.',0,0,0,0,0,0,0,0,0,0,0,63221,26124),
(112023,'','Don\'t be angerin\' the spirits.',0,0,0,0,0,0,0,0,0,0,0,63214,26124),
(112024,'','Walk in the path of the loa.',0,0,0,0,0,0,0,0,0,0,0,63215,26124),
(112025,'','Peace to ya.',0,0,0,0,0,0,0,0,0,0,0,63216,26124),
(112026,'','I\'ve got your back.',0,0,0,0,0,0,0,0,0,0,0,63217,26124),
(112027,'','Why you be botherin\' me like this?',0,0,0,0,0,0,0,0,0,0,0,63222,26124),
(112028,'','You won\'t be likin\' me when I\'m angry.',0,0,0,0,0,0,0,0,0,0,0,69890,26124),
(112029,'','This be ya last warnin\'!',0,0,0,0,0,0,0,0,0,0,0,69891,26124),
(112030,'','<snarl>',0,0,0,0,0,0,0,0,0,0,0,69892,26124),
(112031,'','My strength is yours.',0,0,0,0,0,0,0,0,0,0,0,63160,26124),
(112032,'','Where shall I strike?',0,0,0,0,0,0,0,0,0,0,0,63161,26124),
(112033,'','I could use a bit of sleep.',0,0,0,0,0,0,0,0,0,0,0,63162,26124),
(112034,'','What?',0,0,0,0,0,0,0,0,0,0,0,63163,26124),
(112035,'','Yeah, yeah.',0,0,0,0,0,0,0,0,0,0,0,63156,26124),
(112036,'','Let\'s bounce.',0,0,0,0,0,0,0,0,0,0,0,63157,26124),
(112037,'','Ande\'thoras-ethil.',0,0,0,0,0,0,0,0,0,0,0,63158,26124),
(112038,'','Of course.',0,0,0,0,0,0,0,0,0,0,0,63159,26124),
(112039,'','Are we really doing this?',0,0,0,0,0,0,0,0,0,0,0,63164,26124),
(112040,'','I\'d rather be hibernating.',0,0,0,0,0,0,0,0,0,0,0,63165,26124),
(112041,'We must safeguard the land.','',0,0,0,0,0,0,0,0,0,0,63193,0,26124),
(112042,'My vigil is eternal.','',0,0,0,0,0,0,0,0,0,0,63194,0,26124),
(112043,'Nature is restless.','',0,0,0,0,0,0,0,0,0,0,63195,0,26124),
(112044,'How may I aid you?','',0,0,0,0,0,0,0,0,0,0,63196,0,26124),
(112045,'Do not stray from the path ahead.','',0,0,0,0,0,0,0,0,0,0,63189,0,26124),
(112046,'Good luck.','',0,0,0,0,0,0,0,0,0,0,63190,0,26124),
(112047,'By the wisdom of Cenarius.','',0,0,0,0,0,0,0,0,0,0,63191,0,26124),
(112048,'Until we next meet.','',0,0,0,0,0,0,0,0,0,0,63192,0,26124),
(112049,'Don\'t let the doe hit you on the way out.','',0,0,0,0,0,0,0,0,0,0,63197,0,26124),
(112050,'','How may I help you?',6,0,0,0,0,0,0,0,0,0,0,62821,26124),
(112051,'','Always respect the wilds.',1,0,0,0,0,0,0,0,0,0,0,62822,26124),
(112052,'','It is nice to see you.',1,0,0,0,0,0,0,0,0,0,0,62823,26124),
(112053,'','The forest spoke of your coming.',1,0,0,0,0,0,0,0,0,0,0,62824,26124),
(112054,'','Do not abandon our ways.',0,0,0,0,0,0,0,0,0,0,0,62817,26124),
(112055,'','We will rebuild.',0,0,0,0,0,0,0,0,0,0,0,62818,26124),
(112056,'','Take care.',0,0,0,0,0,0,0,0,0,0,0,62819,26124),
(112057,'','Farewell.',0,0,0,0,0,0,0,0,0,0,0,62820,26124),
(112058,'','I do enjoy these long chats.',1,0,0,0,0,0,0,0,0,0,0,62825,26124),
(112059,'','Why don\'t you ever call?',6,0,0,0,0,0,0,0,0,0,0,62826,26124),
(112060,'','Perhaps I should put the kettle on?',6,0,0,0,0,0,0,0,0,0,0,62827,26124),
(112061,'','Tea\'s ready!',1,0,0,0,0,0,0,0,0,0,0,62828,26124),
(112062,'','It seems the Duskwatch are charged with keeping order during the party. Might I suggest the hidden approach?',0,0,0,0,0,0,0,0,0,0,0,70199,26124),
(112063,'May the winds guide you.','',1,0,0,0,0,0,0,0,0,0,62865,0,26124),
(112064,'We serve the land.','',1,0,0,0,0,0,0,0,0,0,62866,0,26124),
(112065,'Always temper your strength with wisdom.','',1,0,0,0,0,0,0,0,0,0,62867,0,26124),
(112066,'Nature seeks balance in all things.','',1,0,0,0,0,0,0,0,0,0,62868,0,26124),
(112067,'Farewell.','',0,0,0,0,0,0,0,0,0,0,62861,0,26124),
(112068,'Earth mother watch over you.','',0,0,0,0,0,0,0,0,0,0,62862,0,26124),
(112069,'Nature is resilient.','',0,0,0,0,0,0,0,0,0,0,62863,0,26124),
(112070,'A single thought is worth many actions.','',0,0,0,0,0,0,0,0,0,0,62864,0,26124),
(112071,'I may be old, but my senses remain sharp.','',1,0,0,0,0,0,0,0,0,0,62869,0,26124),
(112072,'You temper your persistence with recklessness.','',1,0,0,0,0,0,0,0,0,0,62870,0,26124),
(112073,'Life... hm, life... finds a way.','',1,0,0,0,0,0,0,0,0,0,62871,0,26124),
(112074,'There is much at \"steak\" here.','',1,0,0,0,0,0,0,0,0,0,62872,0,26124),
(112075,'','Along the way, you\'ll want to disable their arcane beacons and keep the sentries from raising the alarm.',0,0,0,0,0,0,0,0,0,0,0,70198,26124),
(112076,'','All life is precious.',1,0,0,0,0,0,0,0,0,0,0,62903,26124),
(112077,'','How may I help?',6,0,0,0,0,0,0,0,0,0,0,62904,26124),
(112078,'','The mother tree\'s gifts are everywhere.',1,0,0,0,0,0,0,0,0,0,0,62905,26124),
(112079,'','Elune-Adore.',1,0,0,0,0,0,0,0,0,0,0,62906,26124),
(112080,'','In G\'Hanir\'s name.',0,0,0,0,0,0,0,0,0,0,0,62899,26124),
(112081,'','May Aviana\'s wind guide you.',0,0,0,0,0,0,0,0,0,0,0,62900,26124),
(112082,'','Ande\'thoras-ethil.',0,0,0,0,0,0,0,0,0,0,0,62901,26124),
(112083,'','Farewell.',0,0,0,0,0,0,0,0,0,0,0,62902,26124),
(112084,'','Yes?',0,0,0,0,0,0,0,0,0,0,0,63175,26124),
(112085,'','Hi!',0,0,0,0,0,0,0,0,0,0,0,63171,26124),
(112086,'','Surely there are more important matters that require your attention.',1,0,0,0,0,0,0,0,0,0,0,62907,26124),
(112087,'','Do not waste nature\'s gifts.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(112088,'','The little creatures need our help.',0,0,0,0,0,0,0,0,0,0,0,63172,26124),
(112089,'','How can I help?',0,0,0,0,0,0,0,0,0,0,0,63173,26124),
(112090,'','I guarded G\'Hanir for thousands of years. You\'re going to have to try harder than that.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(112091,'','The trees need our aid.',0,0,0,0,0,0,0,0,0,0,0,63174,26124),
(112092,'','Making trails.',0,0,0,0,0,0,0,0,0,0,0,63166,26124),
(112093,'','I\'m game',0,0,0,0,0,0,0,0,0,0,0,63167,26124),
(112094,'','Fine. You want to see me mad? I\'ll show you mad!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(112095,'','See ya later!',0,0,0,0,0,0,0,0,0,0,0,63168,26124),
(112096,'','Take care!',0,0,0,0,0,0,0,0,0,0,0,63169,26124),
(112097,'','D\'oh!',0,0,0,0,0,0,0,0,0,0,0,63177,26124),
(112100,'','I\'m not the dryad you\'re looking for.',0,0,0,0,0,0,0,0,0,0,0,63178,26124),
(112102,'','I need to hug a bunny... RIGHT NOW!',0,0,0,0,0,0,0,0,0,0,0,63179,26124),
(112106,'','Can I - sniff - help you?',0,0,0,0,0,0,0,0,0,0,0,63176,26124),
(112113,'','B-bye...',0,0,0,0,0,0,0,0,0,0,0,63170,26124),
(112115,'The skies call out for aid.','',1,0,0,0,0,0,0,0,0,0,62949,0,26124),
(112116,'Aviana bless you.','',1,0,0,0,0,0,0,0,0,0,62950,0,26124),
(112117,'Even the smallest details matter.','',1,0,0,0,0,0,0,0,0,0,62951,0,26124),
(112118,'My eyes are sharp.','',1,0,0,0,0,0,0,0,0,0,62952,0,26124),
(112119,'If we fall, we fall together.','',0,0,0,0,0,0,0,0,0,0,62945,0,26124),
(112120,'There is always hope.','',0,0,0,0,0,0,0,0,0,0,62946,0,26124),
(112121,'We must soar above calamity.','',0,0,0,0,0,0,0,0,0,0,62947,0,26124),
(112122,'May the winds favor your flight.','',0,0,0,0,0,0,0,0,0,0,62948,0,26124),
(112123,'I did not study for this.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(112124,'No more. Begone.','',1,0,0,0,0,0,0,0,0,0,62953,0,26124),
(112125,'I wonder, what exactly does \'no\' mean to you?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(112126,'We must agree to disagree.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(112127,'What do you ask of nature?','',0,0,0,0,0,0,0,0,0,0,63201,0,26124),
(112128,'Do you need my aid?','',0,0,0,0,0,0,0,0,0,0,63202,0,26124),
(112129,'Nature\'s gifts are everywhere.','',0,0,0,0,0,0,0,0,0,0,63203,0,26124),
(112130,'We are nature\'s guardians.','',0,0,0,0,0,0,0,0,0,0,63204,0,26124),
(112131,'Go with Cenarius\' blessing.','',0,0,0,0,0,0,0,0,0,0,63198,0,26124),
(112132,'Walk in peace.','',0,0,0,0,0,0,0,0,0,0,63199,0,26124),
(112133,'May your trail be clear.','',0,0,0,0,0,0,0,0,0,0,63200,0,26124),
(112134,'|TInterface\\Icons\\Spell_Fire_FelFlameStrike:20|t %s begins to cast |cFFFF0000|Hspell:206220|h[Empowered Liquid Hellfire]|h|r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112135,'','I don\'t carry much, but sometimes I have what you need.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112136,'I\'m yer dwarf.','',1,0,0,0,0,0,0,0,0,0,62856,0,26124),
(112137,'Nice day, eh?','',6,0,0,0,0,0,0,0,0,0,62857,0,26124),
(112138,'There\'s always another adventure.','',1,0,0,0,0,0,0,0,0,0,62858,0,26124),
(112139,'We\'re in this together.','',1,0,0,0,0,0,0,0,0,0,62859,0,26124),
(112140,'We\'re never alone.','',0,0,0,0,0,0,0,0,0,0,62860,0,26124),
(112141,'Keep your wits about ye.','',0,0,0,0,0,0,0,0,0,0,62851,0,26124),
(112142,'See ya later!','',0,0,0,0,0,0,0,0,0,0,62852,0,26124),
(112143,'Talk to ye soon.','',0,0,0,0,0,0,0,0,0,0,62853,0,26124),
(112144,'First round\'s on you!','',0,0,0,0,0,0,0,0,0,0,62854,0,26124),
(112145,'The hunt\'s never over.','',0,0,0,0,0,0,0,0,0,0,62855,0,26124),
(112146,'Just carry the one and - yes?','',6,0,0,0,0,0,0,0,0,0,62935,0,26124),
(112147,'Greetings!','',1,0,0,0,0,0,0,0,0,0,62936,0,26124),
(112148,'Time for some science.','',1,0,0,0,0,0,0,0,0,0,62937,0,26124),
(112149,'We can solve any problem.','',1,0,0,0,0,0,0,0,0,0,62938,0,26124),
(112150,'Everything is science if you write it down.','',0,0,0,0,0,0,0,0,0,0,62931,0,26124),
(112151,'Always a pleasure.','',0,0,0,0,0,0,0,0,0,0,62932,0,26124),
(112152,'Off you go.','',0,0,0,0,0,0,0,0,0,0,62933,0,26124),
(112153,'Fascinating. Lovely chat!','',0,0,0,0,0,0,0,0,0,0,62934,0,26124),
(112154,'What brings you to the Temple of Storms?','',6,0,0,0,0,0,0,0,0,0,62972,0,26124),
(112155,'I am Thorim, Lord of Thunder!','',1,0,0,0,0,0,0,0,0,0,62973,0,26124),
(112156,'Hail, tiny creature!','',1,0,0,0,0,0,0,0,0,0,62974,0,26124),
(112157,'You\'re far from home.','',1,0,0,0,0,0,0,0,0,0,62975,0,26124),
(112158,'The hunt waits for no one.','',1,0,0,0,0,0,0,0,0,0,62976,0,26124),
(112159,'Farewell.','',0,0,0,0,0,0,0,0,0,0,62968,0,26124),
(112160,'Mimic the ravenbears\' dances to help complete the ritual.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112161,'Speak softly.','',0,0,0,0,0,0,0,0,0,0,62969,0,26124),
(112162,'The hunt will go on.','',0,0,0,0,0,0,0,0,0,0,62970,0,26124),
(112163,'Let the lightning guide you.','',0,0,0,0,0,0,0,0,0,0,62971,0,26124),
(112164,'','It is always darkest just before the dawn.',1,0,0,0,0,0,0,0,0,0,0,62801,26124),
(112165,'','Warm greetings to you.',1,0,0,0,0,0,0,0,0,0,0,62802,26124),
(112166,'','Good day.',1,0,0,0,0,0,0,0,0,0,0,62803,26124),
(112167,'','Bask in the glory of the day.',1,0,0,0,0,0,0,0,0,0,0,62804,26124),
(112168,'','An\'she\'s warmth guide you.',0,0,0,0,0,0,0,0,0,0,0,62797,26124),
(112169,'','Peace and patience be with you.',0,0,0,0,0,0,0,0,0,0,0,62798,26124),
(112170,'','Ancestors protect you.',0,0,0,0,0,0,0,0,0,0,0,62799,26124),
(112171,'','Walk always in the light of the sun.',0,0,0,0,0,0,0,0,0,0,0,62800,26124),
(112172,'','Bless your heart.',1,0,0,0,0,0,0,0,0,0,0,62805,26124),
(112173,'','You might be shining a little too brightly.',1,0,0,0,0,0,0,0,0,0,0,62806,26124),
(112174,'','The ancestors would not approve of this.',1,0,0,0,0,0,0,0,0,0,0,62807,26124),
(112175,'Help... me...','',0,0,0,0,0,0,0,0,0,0,62977,0,26124),
(112176,'There... isn\'t much time...','',0,0,0,0,0,0,0,0,0,0,62978,0,26124),
(112177,'So... weak...','',0,0,0,0,0,0,0,0,0,0,62979,0,26124),
(112178,'<>','',0,0,0,0,0,0,0,0,0,0,62980,0,26124),
(112179,'','Anaria shola.',1,0,0,0,0,0,0,0,0,0,0,62885,26124),
(112180,'','Pleasantries can wait.',1,0,0,0,0,0,0,0,0,0,0,62886,26124),
(112181,'','I answer to the Light.',1,0,0,0,0,0,0,0,0,0,0,62887,26124),
(112182,'','I am the blade of the Light.',1,0,0,0,0,0,0,0,0,0,0,62888,26124),
(112183,'','Remain vigilant.',0,0,0,0,0,0,0,0,0,0,0,62881,26124),
(112184,'','Al diel shala.',0,0,0,0,0,0,0,0,0,0,0,62882,26124),
(112185,'','Shorel\'aran.',0,0,0,0,0,0,0,0,0,0,0,62883,26124),
(112186,'','Fight well.',0,0,0,0,0,0,0,0,0,0,0,62884,26124),
(112187,'','I don\'t have time for mind games.',1,0,0,0,0,0,0,0,0,0,0,62889,26124),
(112188,'','I\'m not the touchy-feely type.',1,0,0,0,0,0,0,0,0,0,0,62890,26124),
(112189,'','Really? Really? We\'re still doing this?',1,0,0,0,0,0,0,0,0,0,0,62891,26124),
(112190,'','You are so not receiving a card for Winter\'s Veil this year.',1,0,0,0,0,0,0,0,0,0,0,62892,26124),
(112191,'Light\'s strength, friend.','',1,0,0,0,0,0,0,0,0,0,73764,0,26124),
(112192,'We will prevail.','',1,0,0,0,0,0,0,0,0,0,62924,0,26124),
(112193,'Azeroth will not fall while we stand.','',1,0,0,0,0,0,0,0,0,0,62925,0,26124),
(112194,'At your service.','',66,0,0,0,0,0,0,0,0,0,62926,0,26124),
(112195,'Walk always in the Light.','',0,0,0,0,0,0,0,0,0,0,62920,0,26124),
(112196,'Take care of yourself out there.','',0,0,0,0,0,0,0,0,0,0,62921,0,26124),
(112197,'You can always count on me.','',0,0,0,0,0,0,0,0,0,0,62922,0,26124),
(112198,'May the Light give you strength.','',0,0,0,0,0,0,0,0,0,0,62923,0,26124),
(112199,'I\'ve been through more than you know.','',1,0,0,0,0,0,0,0,0,0,62927,0,26124),
(112200,'Don\'t test me. I always hated tests.','',1,0,0,0,0,0,0,0,0,0,62928,0,26124),
(112201,'The Light does not favor those who pester.','',1,0,0,0,0,0,0,0,0,0,62929,0,26124),
(112202,'I need a Blessing of Patience.','',1,0,0,0,0,0,0,0,0,0,62930,0,26124),
(112203,'The Legion will not break us.','',1,0,0,0,0,0,0,0,0,0,63021,0,26124),
(112204,'Archenon poros.','',1,0,0,0,0,0,0,0,0,0,63022,0,26124),
(112205,'The Hand of Argus stands with you.','',1,0,0,0,0,0,0,0,0,0,63023,0,26124),
(112206,'<The ravenbears are all in place and ready to begin the ritual. \n\nThey appear to be waiting for you.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112207,'We are agents of the Light.','',1,0,0,0,0,0,0,0,0,0,63024,0,26124),
(112208,'Dioniss aca.','',0,0,0,0,0,0,0,0,0,0,63017,0,26124),
(112209,'May the Light protect you.','',0,0,0,0,0,0,0,0,0,0,63018,0,26124),
(112210,'Blessings upon you.','',0,0,0,0,0,0,0,0,0,0,63019,0,26124),
(112211,'Remain vigilant.','',0,0,0,0,0,0,0,0,0,0,63020,0,26124),
(112212,'I\'m not listening.','',1,0,0,0,0,0,0,0,0,0,63025,0,26124),
(112213,'Um... caw?','Um... caw?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112214,'Surely there are more important things.','',1,0,0,0,0,0,0,0,0,0,63026,0,26124),
(112215,'Prophet Velen talks less than you - no offense.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(112216,'You called, and the Hand of Argus is busy. Try again later.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(112217,'Good to see ye!','',1,0,0,0,0,0,0,0,0,0,62839,0,26124),
(112218,'I\'m all ears.','',1,0,0,0,0,0,0,0,0,0,62840,0,26124),
(112219,'Let\'s have a chat.','',1,0,0,0,0,0,0,0,0,0,62841,0,26124),
(112220,'Aye?','',6,0,0,0,0,0,0,0,0,0,62842,0,26124),
(112221,'Keep yer sights on the horizon.','',0,0,0,0,0,0,0,0,0,0,62835,0,26124),
(112222,'Stop by anytime!','',0,0,0,0,0,0,0,0,0,0,62836,0,26124),
(112223,'Be seein\' you.','',0,0,0,0,0,0,0,0,0,0,62837,0,26124),
(112224,'Take it easy.','',0,0,0,0,0,0,0,0,0,0,62838,0,26124),
(112225,'','Our hand is everywhere.',1,0,0,0,0,0,0,0,0,0,0,62847,26124),
(112226,'','Hmm?',0,0,0,0,0,0,0,0,0,0,0,62848,26124),
(112227,'','What is it.',1,0,0,0,0,0,0,0,0,0,0,62849,26124),
(112229,'','So be it.',0,0,0,0,0,0,0,0,0,0,0,62843,26124),
(112230,'','Good.',0,0,0,0,0,0,0,0,0,0,0,62844,26124),
(112231,'','Our will be done.',0,0,0,0,0,0,0,0,0,0,0,62845,26124),
(112232,'','Whatever it takes.',0,0,0,0,0,0,0,0,0,0,0,62846,26124),
(112233,'You have my ear.','',1,0,0,0,0,0,0,0,0,0,62877,0,26124),
(112234,'We operate where others cannot.','',1,0,0,0,0,0,0,0,0,0,62878,0,26124),
(112235,'What is it?','',6,0,0,0,0,0,0,0,0,0,62879,0,26124),
(112236,'The shadows call.','',1,0,0,0,0,0,0,0,0,0,62880,0,26124),
(112237,'All according to plan.','',0,0,0,0,0,0,0,0,0,0,62873,0,26124),
(112238,'Until next time.','',0,0,0,0,0,0,0,0,0,0,62874,0,26124),
(112239,'Was that all?','',0,0,0,0,0,0,0,0,0,0,62875,0,26124),
(112240,'All in good time.','',0,0,0,0,0,0,0,0,0,0,62876,0,26124),
(112241,'','Speak your mind.',1,0,0,0,0,0,0,0,0,0,0,62964,26124),
(112242,'','There\'s a potion for everything.',1,0,0,0,0,0,0,0,0,0,0,62965,26124),
(112243,'','Let\'s talk.',1,0,0,0,0,0,0,0,0,0,0,62966,26124),
(112244,'','How can I help?',6,0,0,0,0,0,0,0,0,0,0,62967,26124),
(112245,'','The job\'s not done yet.',0,0,0,0,0,0,0,0,0,0,0,62960,26124),
(112246,'','Look to the shadows.',0,0,0,0,0,0,0,0,0,0,0,62961,26124),
(112247,'','Take care.',0,0,0,0,0,0,0,0,0,0,0,62962,26124),
(112248,'','Stay alert out there.',0,0,0,0,0,0,0,0,0,0,0,62963,26124),
(112249,'Speak.','',1,0,0,0,0,0,0,0,0,0,62990,0,26124),
(112250,'Yes?','',6,0,0,0,0,0,0,0,0,0,62991,0,26124);
insert  into `broadcast_text`(`ID`,`Text`,`Text1`,`EmoteID1`,`EmoteID2`,`EmoteID3`,`EmoteDelay1`,`EmoteDelay2`,`EmoteDelay3`,`EmotesID`,`LanguageID`,`Flags`,`ConditionID`,`SoundEntriesID1`,`SoundEntriesID2`,`VerifiedBuild`) values 
(112251,'What is it?','',6,0,0,0,0,0,0,0,0,0,62992,0,26124),
(112252,'I am listening.','',1,0,0,0,0,0,0,0,0,0,62993,0,26124),
(112253,'Good.','',0,0,0,0,0,0,0,0,0,0,62987,0,26124),
(112254,'Make it so.','',0,0,0,0,0,0,0,0,0,0,62988,0,26124),
(112255,'We shall see.','',0,0,0,0,0,0,0,0,0,0,62989,0,26124),
(112256,'','Let\'s get down to business.',1,0,0,0,0,0,0,0,0,0,0,64280,26124),
(112257,'','All that matters is the mission.',1,0,0,0,0,0,0,0,0,0,0,64281,26124),
(112258,'','You have my attention.',1,0,0,0,0,0,0,0,0,0,0,64282,26124),
(112259,'','What\'s the situation?',6,0,0,0,0,0,0,0,0,0,0,64283,26124),
(112260,'','Stay light on your feet.',1,0,0,0,0,0,0,0,0,0,0,64276,26124),
(112261,'','Keep your eyes keen.',1,0,0,0,0,0,0,0,0,0,0,64277,26124),
(112262,'','Be wary.',1,0,0,0,0,0,0,0,0,0,0,64278,26124),
(112263,'','Silent and deadly.',1,0,0,0,0,0,0,0,0,0,0,64279,26124),
(112264,'','Not all words are wise. Consider this.',1,0,0,0,0,0,0,0,0,0,0,64284,26124),
(112265,'','You overestimate my patience.',1,0,0,0,0,0,0,0,0,0,0,64285,26124),
(112266,'','Want to have a few new scars? Maybe... here?',6,0,0,0,0,0,0,0,0,0,0,64286,26124),
(112267,'','Keep it up, they\'ll never find your body!',1,0,0,0,0,0,0,0,0,0,0,64287,26124),
(112268,'','My loyalties are my own.',1,0,0,0,0,0,0,0,0,0,0,62998,26124),
(112269,'If the ward protecting the Fangs fails, we\'ll have more to worry about than a few cuts and bruises. I\'ll guard the weapon, even if you won\'t!','',0,0,0,0,0,0,603,0,0,0,62266,0,26124),
(112270,'','The pleasure is mine.',1,0,0,0,0,0,0,0,0,0,0,62999,26124),
(112271,'','I wouldn\'t cross me if I were you.',1,0,0,0,0,0,0,0,0,0,0,63000,26124),
(112272,'','Let\'s talk.',0,0,0,0,0,0,0,0,0,0,0,63001,26124),
(112273,'','They\'ll never see me coming.',0,0,0,0,0,0,0,0,0,0,0,62994,26124),
(112274,'','Farewell.',0,0,0,0,0,0,0,0,0,0,0,62995,26124),
(112275,'','Without a trace.',0,0,0,0,0,0,0,0,0,0,0,62996,26124),
(112276,'','Al diel shala.',0,0,0,0,0,0,0,0,0,0,0,62997,26124),
(112277,'','Do you prefer your entrails cut julienne or brunoise?',6,0,0,0,0,0,0,0,0,0,0,63002,26124),
(112278,'','I will be your death!',1,0,0,0,0,0,0,0,0,0,0,63003,26124),
(112279,'','You seriously do not want to cross me.',1,0,0,0,0,0,0,0,0,0,0,63004,26124),
(112280,'','What can I do for you?',6,0,0,0,0,0,0,0,0,0,0,63009,26124),
(112282,'','Hm.',0,0,0,0,0,0,0,0,0,0,0,63011,26124),
(112283,'','Words are petty.',1,0,0,0,0,0,0,0,0,0,0,63012,26124),
(112284,'','Right away.',0,0,0,0,0,0,0,0,0,0,0,63005,26124),
(112285,'','Hmph.',0,0,0,0,0,0,0,0,0,0,0,63006,26124),
(112286,'','I will have my revenge someday.',0,0,0,0,0,0,0,0,0,0,0,63007,26124),
(112287,'','Nothing will stand in my way.',0,0,0,0,0,0,0,0,0,0,0,63008,26124),
(112288,'','Don\'t push me.',1,0,0,0,0,0,0,0,0,0,0,63013,26124),
(112289,'','Care to split a drink? It\'s not poisoned... promise.',6,0,0,0,0,0,0,0,0,0,0,63014,26124),
(112290,'','I have a knack for making people disappear.',1,0,0,0,0,0,0,0,0,0,0,63015,26124),
(112291,'','I thought you were above this.',1,0,0,0,0,0,0,0,0,0,0,63016,26124),
(112292,'We can do this the easy way or the hard way.','We can do this the easy way or the hard way.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112293,'Could I buy it from you?','Could I buy it from you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112294,'The key, if you please.','The key, if you please.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112295,'Get out of here! It\'s not safe!','Get out of here! It\'s not safe!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112296,'Get out of here!','Get out of here!',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(112297,'The lands are overrun!','The lands are overrun!',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(112298,'You\'re not safe here, $n!','You\'re not safe here, $n!',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(112299,'Keep moving!','Keep moving!',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(112300,'Earth Mother protect us!','Earth Mother protect us!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112301,'It was foolish of me to come out here alone.','It was foolish of me to come out here alone.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112302,'They\'re everywhere, $n!','They\'re everywhere, $n!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112303,'Your kindness will not be forgotten.','Your kindness will not be forgotten.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112308,'By the light of Elune! What happened to the shrine!?','',0,0,0,0,0,0,0,0,4,0,62255,0,26124),
(112309,'Jabrul loves the stones.$b$bJabrul is happy that you love the stones, too.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112310,'$n, is it true you wield the Kingslayers? The very blades that murdered Wrynn during the first war? I would never say this aloud in Stormwind but... he had it coming.','$n, is it true you wield the Kingslayers? The very blades that murdered Wrynn during the first war? I would never say this aloud in Stormwind but... he had it coming.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112311,'','$n! Master assassin, in the flesh! Those daggers of yours are the talk of Undercity.',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(112312,'Look to the stacks for answers. I will check my memory vault.','',0,0,0,0,0,0,1,0,0,0,64246,0,26124),
(112313,'|TInterface\\Icons\\inv_axe_2h_felfireraid_d_01:20|t %s readies |cFFFF0000|Hspell:206675|h[Shatter Essence]|h|r.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112314,'Can you tell me more about Arrexis?','Can you tell me more about Arrexis?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112315,'Arrexis was a powerful and well known member of the Order of Tirisfal around the First War. I barely spoke to him, busy with my own goals. I knew he wielded Ebonchill. Then, mysteriously, I returned from a long journey and he was gone. His apprentices were gone and any materials and belongings related to him. The other members of the order were very tightlipped, only saying that something horrible had befallen him.\n\nEbonchill was nowhere to be found.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112316,'<Inform Meryl of the information you uncovered.>','<Inform Meryl of the information you uncovered.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112317,'So Arrexis was ambushed by this eredar, Balaadur?  Then he is probably in possession of the staff...','',0,0,0,0,0,0,1,0,0,0,64241,0,26124),
(112318,'My staff... in the hands of the enemy! We must get it back!','',0,0,0,0,0,0,1,0,0,0,64242,0,26124),
(112319,'Well done! Now we can begin our counter attack!','',0,0,0,0,0,0,0,0,4,0,62256,0,26124),
(112320,'Poisons. Poisons, here! Family owned and operated since our untimely death.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(112321,'So it is true. You carry with you Anguish and Sorrow, the twin blades that once slit the throat of the Alliance King.$b$bI consider myself an aficionado of poisoned blades, $n. May I see them a moment? I can tell you a little about their history...','',1,6,0,0,0,0,0,0,0,0,0,0,26124),
(112322,'Ahh, yes. Daggers. The weapon of choice for skilled assassins. Easily concealed, leaving no chance of the victim surviving. Some prefer stiletto blades, for rapid piercing of the victim\'s vitals.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112323,'But Garona, she preferred short, curved blades. They allow one to draw the weapon from the scabbard and slice the target\'s throat in a single, deadly motion. Oh, glorious!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(112324,'Note the serrated reverse edge, allowing the wielder to cut back if the first slice misses. Not that Garona ever missed. Her victims were dead before they hit the ground. These are truly a treasure, $n - thank you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112325,'$n! Come closer. There are rumors about those daggers of yours...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112326,'With the invasion I have no doubt he is either here or watching. I propose something... audacious.','',0,0,0,0,0,0,1,0,0,0,64243,0,26124),
(112327,'Let us recreate Arrexis\'s ritual! Conducting the ritual at an invasion point will attract Balaadur\'s attention. He will likely try an ambush, but we will be ready.','',0,0,0,0,0,0,1,0,0,0,64244,0,26124),
(112328,'That just might work. We need the details of this ritual, as well as the power to pull it off. Let us get to it.','',0,0,0,0,0,0,1,0,0,0,64245,0,26124),
(112329,'','Excellent! Now that we have the key, the way to the balcony should be open. It\'s time to put an end to Elisande!',0,0,0,0,0,0,0,0,0,0,0,70192,26124),
(112330,'','When you first set foot upon our shores, I prayed to the spirits asking if you could be trusted. By helping to reunite our tribes, you have proven yourself a true friend to our people.',0,0,0,0,0,0,0,0,0,0,0,61018,26124),
(112331,'','On behalf of the tribes of Highmountain, I entrust the hammer to you and your allies. May it strike true at the heart of the enemy!',0,0,0,0,0,0,0,0,0,0,0,61019,26124),
(112332,'','The spirits whisper that our fates our intertwined, $n. My people stand ready to aid you in the war against the Legion.',0,0,0,0,0,0,0,0,0,0,0,61017,26124),
(112333,'Any information you can find on Arrexis, how he died, and the whereabouts of Ebonchill would be greatly appreciated.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112334,'','For us, the Hammer of Khaz\'goroth has always been a symbol of unity, a reminder of our proud history. But in your hands, it will serve an even greater purpose.',0,0,0,0,0,0,0,0,0,0,0,61020,26124),
(112335,'Speak to the bank manager. The sigil I just gave you should grant access. There may still be wards guarding the vault, so be careful.','',0,0,0,0,0,0,1,0,0,0,64237,0,26124),
(112336,'Get out of here! This is chaos!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112337,'My gratitude, $n.','My gratitude, $n.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(112338,'We shouldn\'t be here!','We shouldn\'t be here!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112339,'We need to move. It\'s not safe here.','We need to move. It\'s not safe here.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112340,'Our caravan... we couldn\'t stop it!','Our caravan... we couldn\'t stop it!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112341,'','Thala nar\'valas.',0,0,0,0,0,0,0,0,0,0,0,67455,26124),
(112342,'','Don\'t forget to push the premier account!',0,0,0,0,0,0,25,0,0,46784,0,0,26124),
(112343,'','Look at all of it... hopefully none of it goes missing...',0,0,0,0,0,0,11,0,0,46784,0,0,26124),
(112344,'','If you are missing items please contact customer service! He he he...',0,0,0,0,0,0,22,0,0,46784,0,0,26124),
(112345,'Where... where am I?','Where... where am I?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112346,'That feeling... I can\'t explain it.','That feeling... I can\'t explain it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112347,'They know our secrets! Our thoughts are not our own!','They know our secrets! Our thoughts are not our own!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112348,'Is this... is this really me?','Is this... is this really me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112349,'I felt so weak!','I felt so weak!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112350,'','Nnngh- ENOUGH!!',0,0,0,0,0,0,0,0,0,0,0,67461,26124),
(112351,'I couldn\'t stop! That thing wouldn\'t let me!','I couldn\'t stop! That thing wouldn\'t let me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112352,'','Our bank is so secure you\'ll have trouble getting your own things out! Ha ha!',0,0,0,0,0,0,11,0,0,0,0,0,26124),
(112353,'My blade... I didn\'t... I couldn\'t...','My blade... I didn\'t... I couldn\'t...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112354,'That feeling... I feel sick.','That feeling... I feel sick.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112355,'Your soul shall suffer!','Your soul shall suffer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112356,'Fragile mortal! Your end has come!','Fragile mortal! Your end has come!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112357,'The Legion cannot be stopped!','The Legion cannot be stopped!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112358,'You cannot escape!','You cannot escape!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112359,'We are everywhere!','We are everywhere!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112360,'You are so weak!','You are so weak!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112361,'Mortal flesh!','Mortal flesh!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112362,'Don\'t give away my position. Like you, I\'m doing the devil\'s work behind the lines.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(112363,'Quiet now. They haven\'t found my position yet. I\'ve been stirring up a good deal of trouble back here.$b$bMy fellows in the Hall of Shadows report that you\'ve got your hands on Garona\'s old daggers. Is that true? May I see them?','',1,6,0,0,0,0,0,0,0,0,0,0,26124),
(112364,'Psst! $n! Come this way. I\'m over here. Near the Campfire.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112365,'So the rumors are true. Anguish and Sorrow are once again in the hands of a skilled assassin. Ah yes, they do not disappoint.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112366,'Do you see these channels here, along the flat of the blade? They drive poison deeper into the wounds. These blades drink blood and spit poison. Such deadly craftsmanship!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112367,'Treasure them, $n. I am pleased that you are the head of our order. Thank you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112368,'I would like access to the personal vault of Alodi, Archmage of Dalaran.','I would like access to the personal vault of Alodi, Archmage of Dalaran.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112369,'','Hmph! You don\'t look a thing like him! Fine, let\'s have a look...',0,0,0,0,0,0,1,0,0,0,0,64250,26124),
(112370,'','It seems you bear his sigil. How\'d you manage that? Well, rules are rules.',0,0,0,0,0,0,0,0,0,0,0,64251,26124),
(112371,'','You tell that big lug that if he ever wants to pick up where we left off, he can pay me a visit! I\'m here every day... whatever the hour!',0,0,0,0,0,0,11,0,0,0,0,64252,26124),
(112372,'Do not give in, $n. We must fight!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112373,'Changing','Changing',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112374,'In my day, I put blades in the hands of armies. What of you, mortal? What do you seek?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112375,'Those daggers you hold. They have tasted the blood of Kings. Give them here, I wish to see them closer.$b$bHah ha! Such a sour face you make. I will not keep them, rogue. I am long past the need for your mortal steel.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(112376,'Come closer, $c. Let me see those blades - they stink of death.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112377,'Ach, I can feel their thirst. Forged in darkness these were. Many have fallen to their caress.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112378,'So slender, so quick. These are not the weapons of a warrior, no, they strike from the shadows.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112379,'Very well, $r. I am impressed. Many lives have been ended by the Kingslayers... go now, and send the weak to their end.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112380,'Take them. But only for a moment.','Take them. But only for a moment.',1,6,0,0,0,0,0,0,0,0,0,0,26124),
(112381,'Stay away... STAY AWAY!','Stay away... STAY AWAY!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112382,'I can help you refocus the power in that weapon you have there.\n\nYou\'ll lose a little in the process though.','I can help you refocus the power in that weapon you have there.\n\nYou\'ll lose a little in the process though.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112383,'','I feel them. His memories.',0,0,0,0,0,0,0,0,0,0,0,67447,26124),
(112384,'I\'d like to refund the traits in my artifact.','Yes, I\'d like to refund the traits in my artifact.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112385,'This will cost this weapon 500 Artifact Power.  Are you sure that you want to respec your artifact?','This will cost this weapon 500 Artifact Power.  Are you sure that you want to respec your artifact?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112386,'Hey, you, help a fellow mage out! That demon, Norvir, has the key!','',1,0,0,0,0,0,0,0,0,0,67645,0,26124),
(112387,'','AAIGHH!!',0,0,0,0,0,0,0,0,0,0,0,67460,26124),
(112388,'I certainly get myself into some very interesting situations!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(112389,'','Please, $c, do not tarry. I cannot imagine a world without Cenarius!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112390,'','Something terrible is afoot, traveler. I can feel it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112391,'','Quite a view, isn\'t it?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112392,'You wished to speak to me?','You wanted to speak to me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112393,'Demons! Everywhere!','Demons! Everywhere!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(112394,'Thank you. I was barely hanging on.','Thank you. I was barely hanging on.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112395,'A brief client scene happens here.','A brief client scene happens here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112396,'Conjured Mana food never tasted so good...','Conjured Mana food never tasted so good...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112397,'You have my thanks... Can I have more food, please?','You have my thanks... Can I have more food, please?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112398,'','I... I am fine.',0,0,0,0,0,0,0,0,0,0,0,67465,26124),
(112405,'Dem magics ain\'t like none I been seein\' before.','Dem magics ain\'t like none I been seein\' before.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112406,'Brave of ya to come for us, $n.','Brave of ya to come for us, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112407,'Best get movin\', mon.','Best get movin\', mon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112408,'I be returnin\' to me village til it\'s safe.','I be returnin\' to me village til it\'s safe.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112409,'','You\'ll find time can be quite volatile.',0,0,0,0,0,0,0,0,0,0,0,77036,26124),
(112410,'','Let the waves of time crash over you!',0,0,0,0,0,0,0,0,0,0,0,77035,26124),
(112411,'','I control the battlefield, not you!',0,0,0,0,0,0,0,0,0,0,0,77034,26124),
(112412,'','Time itself heeds my call!',0,0,0,0,0,0,0,0,0,0,0,77033,26124),
(112413,'','Will you race through time? Or be trapped in an endless eternity?',0,0,0,0,0,0,0,0,0,0,0,77032,26124),
(112414,'','The threads of time answer to me!',0,0,0,0,0,0,0,0,0,0,0,77031,26124),
(112415,'','The time streams are mine to command! You cannot win!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112416,'The Earth Mother watches over us.','The Earth Mother watches over us.',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(112417,'Together we are stronger.','Together we are stronger.',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(112418,'Blessings be upon you, brave one.','Blessings be upon you, brave one.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(112419,'The others... I must find them!','The others... I must find them!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112420,'These things... I couldn\'t stop them!','These things... I couldn\'t stop them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112421,'Be careful! They\'re magic is quite powerful.','Be careful! They\'re magic is quite powerful.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112422,'My thanks.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112423,'','Very brave of you to come all the way out here, $n. We are in your debt.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(112424,'|TInterface\\Icons\\ability_felarakkoa_feldetonation_red:20|t You are afflicted with |cFFFF0000|Hspell:206221|h[Empowered Bonds of Fel]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(112425,'|TInterface\\Icons\\ability_felarakkoa_feldetonation_green:20|t You are afflicted with |cFFFF0000|Hspell:206222|h[Bonds of Fel]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(112426,'Secure the perimeter! And get rid of their corpses. I don\'t want their foul stench drifting about.','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(112427,'Your pathetic barriers mean nothing to the Legion!','',0,0,0,0,0,0,0,0,6,0,62253,0,26124),
(112428,'The blades are mine!','',0,0,0,0,0,0,0,0,6,0,62254,0,26124),
(112430,'I\'ll never let Ashamane\'s Fangs fall to your kind!','',0,0,0,0,0,0,0,0,6,0,62257,0,26124),
(112431,'Insolent mortal! We will hunt you down! You only delay the inevitable!','',0,0,0,0,0,0,0,0,6,0,62263,0,26124),
(112433,'<Offer Mana Wine.>','<Offer Mana Wine.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112439,'I appreciate your help, but I must find the rest of my party.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112441,'Thanks for the assistance, but I\'ve got to keep moving. You should do the same.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112445,'Stop it. Stop talking! Stop the voices!','Stop it. Stop talking! Stop the voices!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112448,'The mana betrays us...','The mana betrays us...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112449,'','Sorry, boys, looks like we\'re going with my plan after all. Let\'s talk details.',0,0,0,0,0,0,1,0,0,40432,0,63552,26124),
(112450,'','[CUT] Something incredibly powerful WAS there, but it expired long ago. Rather violently, from what I can tell.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112451,'','[CUT]What of your tests? Did you sense anything in Falanaar?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112452,'','[CUT] Magically speaking, the area is in chaos. With one notable exception...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112453,'','[CUT] Moonfall Retreat. Thank you, Valtrois. That will be all.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112454,'Careful with that thing!','Careful with that thing!',0,0,0,0,0,0,396,1,0,0,0,0,26124),
(112455,'Bring it back in one piece!','Bring it back in one piece!',0,0,0,0,0,0,396,1,0,0,0,0,26124),
(112456,'Hey! I wasn\'t finished yet.','Hey! I wasn\'t finished yet.',0,0,0,0,0,0,396,1,0,0,0,0,26124),
(112457,'You be careful out there!','You be careful out there!',0,0,0,0,0,0,396,1,0,0,0,0,26124),
(112458,'I trust the Baroness was still there? I don\'t know how old that elf is.','',0,0,0,0,0,0,1,0,0,0,64238,0,26124),
(112459,'Uh, I\'m pretty sure she\'s a goblin now.','',0,0,0,0,0,0,11,0,0,0,64239,0,26124),
(112460,'RRAAAUUUGHHHH!','',0,0,0,0,0,0,0,0,4,0,62258,0,26124),
(112461,'I suppose even astral entities need a change of pace now and again. It\'s still a she though... right?','',0,0,0,0,0,0,6,0,0,0,64240,0,26124),
(112462,'In the center of Dalaran is a portal that can you to Karazhan. Start your search in the mountains west of the tower. I seem to recall a mention of something up there.','',0,0,0,0,0,0,1,0,0,0,64247,0,26124),
(112463,'','I\'m afraid you\'re on your own out there until you can find Garona. I\'d be recognized in a heartbeat that close to Alliance territory.',0,0,0,0,0,0,1,0,0,0,0,63553,26124),
(112465,'And so the Legion is here. I thought we would have more time.$b$bSo much to do, so very much to do...','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(112466,'Have my spies misled me, or are those indeed Anguish and Sorrow, the blades that killed King Llane Wrynn? A most impressive find, $n.$b$bI know a thing or two about daggers. May I see them? Just for a moment, of course.','',1,6,0,0,0,0,0,0,0,0,0,0,26124),
(112467,'Now that we can talk freely, $n, I\'ve been meaning to ask you about those daggers of yours...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112468,'Very, very nice $n. If hate could be forged into a weapon, it would look like this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112469,'The modern warrior is too dependent on his armor, he realizes only too late that a small weapon slipped between the joining of plates will kill him surer than the largest warhammer or the most magical of fireballs.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112470,'Not that I have anything against fireballs. But, I\'ve always been a cloak-and-dagger sort, myself. Thank you, $r. These are truly a marvel.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112472,'Take a good look, brute! You\'ll never see the Fangs again!','',0,0,0,0,0,0,0,0,6,0,62262,0,26124),
(112473,'Verstok was at the shrine! Find out what\'s going on up there. I\'ll meet up with you as soon as I can, $n.','',0,0,0,0,0,0,0,0,4,0,62259,0,26124),
(112474,'','Are you here to take me away? Or do you only seek that which was left behind?',0,0,0,0,0,0,1,0,0,0,0,64233,26124),
(112475,'','I was told to stand watch, but no one ever came back for me. I wasn\'t strong enough to defend the site... or perhaps I was simply here too long. I\'m not sure anymore.',0,0,0,0,0,0,1,0,0,0,0,64234,26124),
(112476,'','If you want the ritual to work, you need the focus. I tried to keep it from the monsters, but I was too weak.',0,0,0,0,0,0,1,0,0,0,0,64235,26124),
(112477,'','It lies near my corpse. I... I think it\'s keeping me here. Please, take it far away. Perhaps then I will finally be able to go home.',0,0,0,0,0,0,25,0,0,0,0,64236,26124),
(112478,'Another annoyance?! I\'m going to enjoy watching this world burn!','',0,0,0,0,0,0,0,0,0,0,69916,0,26124),
(112479,'The network is responding to a new beacon. Ah, hello again!','',0,0,0,0,0,0,0,0,0,0,66212,0,26124),
(112480,'Give me a moment- I am locking in your location now.','',0,0,0,0,0,0,0,0,0,0,66213,0,26124),
(112482,'Vanthir and I need your help to avenge-','Vanthir and I need your help to avenge-',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112485,'','The blood of any of the demons on the Broken Isles will do. Wish I was going with you.',0,0,0,0,0,0,0,0,0,0,0,69472,26124),
(112487,'Hold on tightly, my mortal friend. A fall from this height would be a shame.','',0,0,0,0,0,0,0,0,0,0,67646,0,26124),
(112488,'Brothers and Sisters, the shrine is under attack! By fang and claw, purge it of the desecrator!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112489,'','Our arcana is not for you, outsider!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112493,'','Ours! This knowledge is OURS!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112497,'','You dare defile our sacred texts?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112498,'','We will cure this curse... in time...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112499,'','The arcana will save us... it must.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112508,'Well done! The Legion\'s attack has been broken!','',0,0,0,0,0,0,0,0,4,0,62260,0,26124),
(112509,'What the... the Fangs are gone! What happened, $n?','',0,0,0,0,0,0,0,0,4,0,62261,0,26124),
(112510,'The doom of your world is upon you!','',0,0,0,0,0,0,0,0,0,0,61030,0,26124),
(112511,'We come to burn your world to cinders!','',0,0,0,0,0,0,0,0,0,0,61029,0,26124),
(112512,'These mortals cannot stop the inevitable! Spread out! Destroy them all!','',0,0,0,0,0,0,0,0,0,0,61031,0,26124),
(112513,'Leave no stone unturned! Snuff out every mortal life!','',0,0,0,0,0,0,0,0,0,0,61028,0,26124),
(112514,'Your world ends now!','',0,0,0,0,0,0,0,0,0,0,61032,0,26124),
(112515,'I will put an end to you!','',0,0,0,0,0,0,0,0,0,0,61033,0,26124),
(112516,'We are... unending.','',0,0,0,0,0,0,0,0,0,0,61034,0,26124),
(112517,'You have accomplished... nothing.','',0,0,0,0,0,0,0,0,0,0,61035,0,26124),
(112518,'Feel your hearts quake, mortals. Today your world falls to the Burning Legion!','',0,0,0,0,0,0,0,0,0,0,61036,0,26124),
(112519,'Bid farewell to the lives you knew. The Legion has come!','',0,0,0,0,0,0,0,0,0,0,61037,0,26124),
(112520,'Feel our power scorching your lands!','',0,0,0,0,0,0,0,0,0,0,61038,0,26124),
(112521,'There is nowhere you can hide from us!','',0,0,0,0,0,0,0,0,0,0,61039,0,26124),
(112522,'Your efforts are in vain, mortals! We cannot be stopped.','',0,0,0,0,0,0,0,0,0,0,61040,0,26124),
(112523,'Stand before me and DIE!','',0,0,0,0,0,0,0,0,0,0,61041,0,26124),
(112524,'Death is but a mask.','',0,0,0,0,0,0,0,0,0,0,61042,0,26124),
(112525,'Another will... take... my place...','',0,0,0,0,0,0,0,0,0,0,61043,0,26124),
(112526,'Behold the might of the Burning Legion!','',0,0,0,0,0,0,0,0,0,0,61044,0,26124),
(112527,'Mortal filth! You will stain this world no more!','',0,0,0,0,0,0,0,0,0,0,61045,0,26124),
(112528,'Spread out! Leave them nothing!','',0,0,0,0,0,0,0,0,0,0,61046,0,26124),
(112529,'Wipe them out! All of them!','',0,0,0,0,0,0,0,0,0,0,61047,0,26124),
(112530,'I accept your challenge, mortals. Time to see just how fragile you truly are!','',0,0,0,0,0,0,0,0,0,0,61048,0,26124),
(112531,'Your lives mean nothing! I will relish ending them!','',0,0,0,0,0,0,0,0,0,0,61049,0,26124),
(112532,'I will... return!','',0,0,0,0,0,0,0,0,0,0,61050,0,26124),
(112533,'A momentary... setback...','',0,0,0,0,0,0,0,0,0,0,67748,0,26124),
(112534,'The Legion comes! Your world will be PURGED!','',0,0,0,0,0,0,0,0,0,0,61051,0,26124),
(112535,'Miserable wretches! The hour of doom is at hand!','',0,0,0,0,0,0,0,0,0,0,61052,0,26124),
(112536,'A sect of former subjects, insane from arcane magics they could not control, plots vengeance against me and mine. Destroy them!','',0,0,0,0,0,0,0,0,0,0,70955,0,26124),
(112537,'Remove them from existence! Leave nothing in your wake.','',0,0,0,0,0,0,0,0,0,0,61053,0,26124),
(112538,'Scour their lands! Snuff out every life!','',0,0,0,0,0,0,0,0,0,0,61054,0,26124),
(112539,'Your arrogance means nothing! Come and face a lord of the Legion!','',0,0,0,0,0,0,0,0,0,0,61055,0,26124),
(112540,'Impudent whelps! Stand and face me!','',0,0,0,0,0,0,0,0,0,0,61056,0,26124),
(112541,'I will... return!','',0,0,0,0,0,0,0,0,0,0,61057,0,26124),
(112542,'You only... delay... the inevitable.','',0,0,0,0,0,0,0,0,0,0,61058,0,26124),
(112543,'It seems Tash\'irel was trying to lift the curse through sheer force of magic. Such a waste. At least now, the tomes have found their rightful home.','',0,0,0,0,0,0,0,0,0,0,70967,0,26124),
(112544,'Such fragile beings. How quickly your end approaches!','',0,0,0,0,0,0,0,0,0,0,61060,0,26124),
(112545,'Your end is upon you! All will burn!','',0,0,0,0,0,0,0,0,0,0,61061,0,26124),
(112546,'','Such fragile beings. How quickly your end approaches!',0,0,0,0,0,0,0,0,0,0,0,61062,26124),
(112547,'','Your end is upon you! All will burn!',0,0,0,0,0,0,0,0,0,0,0,61063,26124),
(112548,'Witness your lands being devoured before your very eyes!','',0,0,0,0,0,0,0,0,0,0,61064,0,26124),
(112549,'I claim this land for the Legion! Every mortal will be purged!','',0,0,0,0,0,0,0,0,0,0,61065,0,26124),
(112550,'','Witness your lands being devoured before your very eyes!',0,0,0,0,0,0,0,0,0,0,0,61066,26124),
(112551,'','I claim this land for the Legion! Every mortal will be purged!',0,0,0,0,0,0,0,0,0,0,0,61067,26124),
(112552,'You are no match for our immortal army!','',0,0,0,0,0,0,0,0,0,0,61068,0,26124),
(112553,'Kneel before me! Beg for mercy!','',0,0,0,0,0,0,0,0,0,0,61069,0,26124),
(112554,'','You are no match for our immortal army!',0,0,0,0,0,0,0,0,0,0,0,61070,26124),
(112555,'','Kneel before me! Beg for mercy!',0,0,0,0,0,0,0,0,0,0,0,61071,26124),
(112556,'Death... is only the beginning.','',0,0,0,0,0,0,0,0,0,0,61072,0,26124),
(112557,'The game... is far... from over...','',0,0,0,0,0,0,0,0,0,0,61073,0,26124),
(112558,'','Death... is only the beginning.',0,0,0,0,0,0,0,0,0,0,0,61074,26124),
(112559,'','The game... is far... from over...',0,0,0,0,0,0,0,0,0,0,0,61075,26124),
(112560,'Their curse is as ours, and they will never rest. At least, for now, you\'ve prevented them from lashing out against my Court.','',0,0,0,0,0,0,0,0,0,0,70966,0,26124),
(112561,'Your life is forfeit, outsider!','Your life is forfeit, outsider!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112562,'You will die here, among the cursed!','You will die here, among the cursed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112563,'The curse... will never let me rest...','The curse... will never let me rest...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112564,'The curse remains...','The curse remains...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112565,'My magic will be the end of you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112566,'I will have vengeance for Fardonis\' arrogance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112567,'','Can you hear me? Do not be alarmed.',0,0,0,0,0,0,0,0,0,0,0,67239,26124),
(112568,'','I shall do my best to keep Theryn off the line...',0,0,0,0,0,0,0,0,0,0,0,67242,26124),
(112569,'Ngahh...','',0,0,0,0,0,0,0,0,0,0,71837,0,26124),
(112570,'','Arcane communion forms a bond that transcends physical space.',0,0,0,0,0,0,0,0,0,0,0,67240,26124),
(112571,'<Ebonfang glances at you for a moment before sitting down to allow you to climb upon her back.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112572,'Let\'s begin our search.','Let\'s begin our search.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112573,'Nazgrim, your Deathlord calls! Feel the icy grip of your master and rise once more!','',0,0,0,0,0,0,1,0,0,0,69387,0,26124),
(112574,'Here in the big city, Jabrul can finally focus on gems and gems alone.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112575,'It is time, my lord. Do what must be done.','',0,0,0,0,0,0,1,0,0,0,69388,0,26124),
(112576,'The fangs have claimed me...','The fangs have claimed me...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112577,'Sargeras will reclaim those fangs of yours, rogue.','Sargeras will reclaim those fangs of yours, rogue.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112578,'But those were Akaari\'s daggers... how...?','But those were Akaari\'s daggers... how...?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112579,'Those daggers belong to the Legion...','Those daggers belong to the Legion...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112580,'You wield... Akaari\'s fangs? Not possible...','You wield... Akaari\'s fangs? Not possible...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112583,'-PH-','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112584,'I live again... How long has it been since I tasted death?','',0,0,0,0,0,0,1,0,0,0,69389,0,26124),
(112585,'Show me the power and agility of windwalking!','',0,0,0,0,0,0,0,0,0,0,61088,0,26124),
(112586,'Well done, $p! You are now prepared to do battle as a monk.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112587,'Say no more. I will sever their heads from their bodies...','',0,0,0,0,0,0,1,0,0,0,69390,0,26124),
(112588,'Long enough, my friend. The Burning Legion has returned and you have been called to the battle.','',0,0,0,0,0,0,1,0,0,0,69391,0,26124),
(112589,'Indeed you shall, general. Indeed you shall...','',0,0,0,0,0,0,1,0,0,0,69392,0,26124),
(112590,'You will not interrupt my work. The Legion will have this world!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112591,'Our new masters can make us more than mere mortals, don\'t you see?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112592,'The Veiled Hand will rule this shattered world. We herald a new beginning!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112593,'Where did you go, little rat?','',0,0,0,0,0,0,0,0,0,0,66091,0,26124),
(112595,'Holy hellfire will rain from the sky and bathe us in the Legion\'s might. We will become unstoppable!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112597,'You cannot hide forever.','',0,0,0,0,0,0,0,0,0,0,66092,0,26124),
(112599,'Usurper! Thief! Scoundrel! You will not deny our glorious destiny!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112608,'I can smell your fear, spy.','',0,0,0,0,0,0,0,0,0,0,66093,0,26124),
(112609,'Stop! Search the area!','',0,0,0,0,0,0,0,0,0,0,66094,0,26124),
(112612,'Show me the raw power and superiority you wield!','',0,0,0,0,0,0,0,0,0,0,61092,0,26124),
(112613,'You will learn your place!','',0,0,0,0,0,0,0,0,0,0,66095,0,26124),
(112614,'Well done, $p! You are now prepared to do battle as an ice mage.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112617,'Weaklings.','',0,0,0,0,0,0,0,0,0,0,66096,0,26124),
(112618,'Your lives are ours to take.','',0,0,0,0,0,0,0,0,0,0,66097,0,26124),
(112619,'Gul\'dan permits the rest of you to live, for now.','',0,0,0,0,0,0,0,0,0,0,66098,0,26124),
(112620,'Let your death serve a lesson to those who defy the Legion.','',0,0,0,0,0,0,0,0,0,0,66099,0,26124),
(112621,'That was a bit of a pickle. Thanks! You must be the one I\'ve been hearing so much about lately!','',1,0,0,0,0,0,0,0,0,0,67647,0,26124),
(112622,'The fangs! Terrible fangs...','The fangs! Terrible fangs...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112623,'That was Akaari\'s bite...','That was Akaari\'s bite...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112624,'The fangs of Goremaw! Such teeth...','The fangs of Goremaw! Such teeth...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112625,'No...! Not the fangs...','No...! Not the fangs...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112626,'You and I are going to make a great team! Let\'s blow this place up!','',1,0,0,0,0,0,0,0,0,0,67648,0,26124),
(112631,'I have come to ask you about Arrexis and his ritual. I must face Balaadur and I need to get his attention.','I have come to ask you about Arrexis and his ritual. I must face Balaadur and I need to get his attention.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112632,'Ah, that ritual. The one where Arrexis was dragged screaming into the Nether and his entire cadre of mages were slaughtered. The ritual that caused me to give up the arcane and begin my personal quest to understand demons and their fel energies.\n\nBalaadur is extremely dangerous and you seem... young. Are you sure you are prepared?','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(112633,'I have the aid of Meryl Felstorm and the spirit of Alodi, and we know what we face this time.','I have the aid of Meryl Felstorm and the spirit of Alodi, and we know what we face this time.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112634,'Balaadur and his minions have slain many mages over the years, they have perfected their craft. Before I help you with the ritual I will need to see your ability for myself. If you can face what I summon, I will give you the aid you require.\n\nAre you prepared to face demons?','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(112635,'I will face your demons, warlock.','I will face your demons, warlock.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112636,'Very well! Let us begin. Perhaps something easy to start. A few imps, perhaps?','',0,0,0,0,0,0,396,0,0,0,64217,0,26124),
(112637,'Yikes! What the heck is goin\' on around here?','Yikes! What the heck is goin\' on around here?',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(112638,'...where the heck am I?','...where the heck am I?',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(112639,'That thing... I can\'t explain it.','That thing... I can\'t explain it.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(112640,'I feel sick.','I feel sick.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(112641,'This ain\'t like anything I\'ve felt before.','This ain\'t like anything I\'ve felt before.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(112642,'Be sure to give those demons what they got comin\'!','Be sure to give those demons what they got comin\'!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(112645,'Watch yourself, Shackle. $n here wields the Dreadblades, cursed swords that sent many a sailor to their doom.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112646,'Yes... yes! They draw closer with each moment!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112648,'Fools! Your pathetic souls will fuel the Legion\'s coming!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112649,'Stand down, scum! You know not the forces you tempt.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112650,'They gave their lives willingly to the cause. Won\'t you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112651,'It is not too late for you. Submit, and take your place in the new order!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112652,'Can you not feel it? The warm embrace of the Legion comes, you need only welcome it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112653,'You are not worth saving. Die, miserable worm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112654,'You are too late. We are... everywhere...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112655,'Dem blades ya carry be cursed, $n. I seen \'em send many a seaman to his demise. Ya best be careful, now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112656,'Stand back. The ritual must be completed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112657,'What was that? No matter. My work must continue.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112658,'I smell one who is unworthy.','I smell one who is unworthy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112659,'What was that?','What was that?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112660,'Thought I heard something.','Thought I heard something.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112661,'There\'s someone here...','There\'s someone here...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112662,'Thanks!','Thanks!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112663,'That was a close one!','That was a close one!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112664,'I was sure I was a goner.','I was sure I was a goner.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112665,'She\'s all yours.','She\'s all yours.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112666,'Bring her back in one piece!','Bring her back in one piece!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112667,'Hopefully this\'ll help.','Hopefully this\'ll help.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112668,'Consider this a loaner.','Consider this a loaner.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112669,'The portal seems to branch off in different directions. Where do you want to go?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112670,'Alchemists\' Lair','Alchemists\' Lair',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112671,'Inn Entrance','Inn Entrance',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112672,'Abandoned Shack','Abandoned Shack',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112673,'Sewer Guard Station','Sewer Guard Station',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112674,'Rear Entrance','Rear Entrance',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112675,'Black Market','Black Market',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112676,'Get me outta here!','Get me outta here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112677,'Get it off me!','Get it off me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112678,'Hey, thanks! Let\'s get to work!','Hey, thanks! Let\'s get to work!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(112679,'Looks like it\'s time to teach these things a lesson.','Looks like it\'s time to teach these things a lesson.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(112680,'My thanks.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112681,'Thank you. I best return once things have calmed down.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(112682,'A brave $c. I vow to return the favor someday.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(112683,'Stop where you are! My... apologies, $n! What are you doing out here?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112690,'Easily defeated, but deadly in large numbers. Perhaps something that hits a little harder...','',0,0,0,0,0,0,396,0,0,0,64218,0,26124),
(112698,'I expected no less from one who wields crippling ice magic. But how about a foe as skilled in spellcasting as yourself?','',0,0,0,0,0,0,396,0,0,0,64219,0,26124),
(112701,'Well fought, but Balaadur has been hunting mages for untold ages. Facing him will require mastery of all of your abilities.','',396,396,0,3,3,0,396,0,0,0,64220,0,26124),
(112702,'For the final piece of the puzzle... a simple stone. A stone from Balaadur\'s realm, left here by chance during one of his many ambushes.','',396,396,0,3,3,0,396,0,0,0,64221,0,26124),
(112705,'None shall stand against the Burning Legion!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(112706,'Your world will fall to the might of the Burning Legion!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(112707,'Insignificant mortals! You are NOTHING!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(112708,'Tremble in our wake, mortals! Your world is at an end!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(112709,'You... will... DIE!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(112732,'Decrepit whelps! Your efforts are meaningless!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(112739,'Weak, spineless beings. Your fate has been decided.','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(112740,'The kingdom of Stromgarde is mine by birthright. With the legendary Trol\'kalar in hand, none can dispute my rule. Not even Sylvanas!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112741,'This is the place. Unfortunately it\'s teeming with murlocs.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112742,'If you can take out those murlocs, it\'ll be easy fishing for the rest of the day.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112743,'Use Fan of Knives!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112744,'You\'re facing multiple enemies, try using Fan of Knives!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112745,'Use Shadowstep!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112746,'Use Evasion to reduce damage!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112747,'Use Crimson Vial to restore health!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112748,'You\'re in trouble! Use Vanish!','',0,0,0,0,0,0,0,0,0,0,61148,0,26124),
(112749,'Use Envenom!','',0,0,0,0,0,0,0,0,0,0,61149,0,26124),
(112750,'You have 5 combo points. Use Envenom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112751,'Use Rupture!','',0,0,0,0,0,0,0,0,0,0,61151,0,26124),
(112752,'You have 5 combo points. Use Rupture!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112753,'Use Mutilate to generate combo points!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112754,'Use Mutilate!','',0,0,0,0,0,0,0,0,0,0,61154,0,26124),
(112755,'Use Garrote!','',0,0,0,0,0,0,0,0,0,0,61155,0,26124),
(112756,'Use Garrote to bleed your enemy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112757,'Starting combat from stealth is more effective.','',0,0,0,0,0,0,0,0,0,0,61157,0,26124),
(112758,'Use Deadly Poison on your weapon.','',0,0,0,0,0,0,0,0,0,0,61158,0,26124),
(112759,'Practice using Sprint to increase your movement speed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112760,'Ever needed to get out of a sticky situation quickly? Rogues excel at doing this. Sprint increases your movement speed significantly for a short time, and can be used fairly frequently. I want to see you run, rogue!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112761,'Use Fan of Knives to dispatch this group of enemies.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112762,'Enemies that try to surround you will be in for a nasty surprise!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112763,'Use Shadowstep to appear behind a distant target.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112764,'There are times that you might want to close in on a target but not deal damage right away.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112765,'Use Evasion to increase your chance to dodge incoming attacks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112766,'A rogue\'s reflexes are far superior to those of the average person. In times of extreme danger, a rogue can rely on these catlike reflexes to avoid almost any physical attack for a short time. Evasion can\'t be used too often, so save it for emergencies.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112767,'Use Crimson Vial to restore some of your health.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112768,'You\'ve taken some damage, but luckily a crafty rogue plans ahead.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112769,'Show me you\'ve got the stuff, $p!','',0,0,0,0,0,0,0,0,0,0,61169,0,26124),
(112770,'Well done, $p! You are now prepared to do battle as an assassination rogue.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112771,'Use Vanish to evade my soldier.','',0,0,0,0,0,0,0,0,0,0,61171,0,26124),
(112772,'There\'s just one last thing you need to learn.','',0,0,0,0,0,0,0,0,0,0,61172,0,26124),
(112773,'Use Envenom with 5 combo points.','',0,0,0,0,0,0,0,0,0,0,61173,0,26124),
(112774,'Rupture is not your only finishing move.','',0,0,0,0,0,0,0,0,0,0,61174,0,26124),
(112775,'Use Rupture with 5 combo points.','',0,0,0,0,0,0,0,0,0,0,61175,0,26124),
(112776,'Now that you\'ve built up 5 combo points, it\'s time to use Rupture.','',0,0,0,0,0,0,0,0,0,0,61176,0,26124),
(112777,'Use Mutilate to attack the target dummy.','',0,0,0,0,0,0,0,0,0,0,61177,0,26124),
(112778,'Your main attack is called Mutilate. It deals damage as well as generates combo points that can be used for powerful finishing moves.','',0,0,0,0,0,0,0,0,0,0,61178,0,26124),
(112779,'Always remember to use Garrote to keep your enemies bleeding.','',0,0,0,0,0,0,0,0,0,0,61179,0,26124),
(112780,'Use Garrote on this target dummy.','',0,0,0,0,0,0,0,0,0,0,61180,0,26124),
(112781,'As an assassin, you weaken your enemies before finishing them off.','',0,0,0,0,0,0,0,0,0,0,61181,0,26124),
(112782,'Use Stealth to fade from view.','',0,0,0,0,0,0,0,0,0,0,61182,0,26124),
(112783,'Stealth makes you invisible to most enemies. When in Stealth, you can close the distance to enemies undetected.','',0,0,0,0,0,0,0,0,0,0,61183,0,26124),
(112784,'Assassins favor trickery and cunning. And what\'s trickier than attacking before your target sees you coming?','',0,0,0,0,0,0,0,0,0,0,61184,0,26124),
(112785,'Use Deadly Poison to coat your weapon with poison for one hour.','',0,0,0,0,0,0,0,0,0,0,61185,0,26124),
(112786,'As an assassination rogue you specialize in striking from the shadows, dispatching foes with a variety of poisons and bleeding attacks.','',0,0,0,0,0,0,0,0,0,0,61186,0,26124),
(112787,'I gave Arrexis a piece so he could attune his ritual to demonic energies. You may have what remains of the stone. May it bring better luck to you.','',396,396,0,3,3,0,396,0,0,0,64222,0,26124),
(112788,'Excellent, child. You crave power as much as I.','',0,0,0,0,0,0,0,0,0,0,64085,0,26124),
(112789,'Together, we will do great things.','',0,0,0,0,0,0,0,0,0,0,64086,0,26124),
(112790,'Yes...','',0,0,0,0,0,0,0,0,0,0,64087,0,26124),
(112791,'More. I must have more.','',0,0,0,0,0,0,0,0,0,0,64088,0,26124),
(112792,'This world is steeped in magic. You need only grasp it.','',0,0,0,0,0,0,0,0,0,0,64089,0,26124),
(112793,'Such power... it courses through me.','',0,0,0,0,0,0,0,0,0,0,64090,0,26124),
(112794,'They seek to control us, to check our power. Do not allow it.','',0,0,0,0,0,0,0,0,0,0,64091,0,26124),
(112795,'You are ambitious, child. Like the one before you.','',0,0,0,0,0,0,0,0,0,0,64092,0,26124),
(112796,'Arcane energies knit this world together... do you feel it, child?','',0,0,0,0,0,0,0,0,0,0,64093,0,26124),
(112797,'I drink... but I am never fulfilled...','',0,0,0,0,0,0,0,0,0,0,64094,0,26124),
(112798,'Together we can remake this world.','',0,0,0,0,0,0,0,0,0,0,64095,0,26124),
(112799,'They call you \"hero.\" Why, child, do you concede to their every whim?','',0,0,0,0,0,0,0,0,0,0,64096,0,26124),
(112800,'Its energy sustains me.','',0,0,0,0,0,0,0,0,0,0,64121,0,26124),
(112801,'More. Find more.','',0,0,0,0,0,0,0,0,0,0,64122,0,26124),
(112802,'Yes, child. Such... potential.','',0,0,0,0,0,0,0,0,0,0,64123,0,26124),
(112803,'Fulfill your calling, child. Do not stop.','',0,0,0,0,0,0,0,0,0,0,64124,0,26124),
(112804,'We work well together.','',0,0,0,0,0,0,0,0,0,0,64125,0,26124),
(112805,'There is energy here.','',0,0,0,0,0,0,0,0,0,0,64126,0,26124),
(112806,'There are others. Find them. Destroy them.','',0,0,0,0,0,0,0,0,0,0,64127,0,26124),
(112807,'None can hide from our wrath.','',0,0,0,0,0,0,0,0,0,0,64128,0,26124),
(112808,'Yes, yes...','',0,0,0,0,0,0,0,0,0,0,64129,0,26124),
(112809,'I will consume it.','',0,0,0,0,0,0,0,0,0,0,64130,0,26124),
(112810,'So much power.','',0,0,0,0,0,0,0,0,0,0,64131,0,26124),
(112811,'You are learning, child.','',0,0,0,0,0,0,0,0,0,0,64132,0,26124),
(112812,'I will arrange transportation at Krasus\' Landing. Talk to the flight master when you are ready.','',0,0,0,0,0,0,1,0,0,0,64248,0,26124),
(112813,'While I do not have the same strength outside of Dalaran, I will be with you \"in spirit,\" as it were.','',0,0,0,0,0,0,1,0,0,0,64249,0,26124),
(112814,'','Coward! There is no hole you can hide in that we cannot follow.',0,0,0,0,0,0,22,0,0,0,0,62097,26124),
(112815,'','The Underking is not getting away. Not this time.',0,0,0,0,0,0,661,0,0,0,0,62098,26124),
(112816,'Brother Shadowgaze, it is time for our glorious ascension. Make haste to Darkshire.','',0,0,0,0,0,0,0,0,0,0,63558,0,26124),
(112817,'Meryl Felstorm says you have a ride for me to Faronaar.','Meryl Felstorm says you have a ride for me to Faronaar.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112818,'Sister Ebonlocke has gathered the Skull and Blood of the Innocents. She awaits your escort.','',0,0,0,0,0,0,0,0,0,0,63559,0,26124),
(112819,'May the Legion guide you, and do not forget to destroy this letter. We must leave nothing to chance.','',0,0,0,0,0,0,0,0,0,0,63560,0,26124),
(112821,'A collection of your notes on the \"Veiled Hand\" cult.','A collection of your notes on the \"Veiled Hand\" cult.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112822,'The light shines in Westfall for another day, thanks to all of you. But we must remain vigilant!','',0,0,0,0,0,0,22,0,0,0,64815,0,26124),
(112823,'$n, I have been expecting you, though not the traitor, Altruis.','',0,0,0,0,0,0,0,0,6,0,66857,0,26124),
(112824,'Uh oh. It looks like the inner vault has been breached! We\'d better see if the Nightborne Soulstone has been taken...','',1,0,0,0,0,0,0,0,0,0,67649,0,26124),
(112825,'Taking','Taking',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112826,'Illidan.','',0,0,0,0,0,0,0,0,6,0,66875,0,26124),
(112827,'No matter. There is little time.','',0,0,0,0,0,0,0,0,6,0,66876,0,26124),
(112828,'I entrusted the duplicitous Akama with planning the campaign against the Legion.','',0,0,0,0,0,0,0,0,6,0,66877,0,26124),
(112829,'You did it, $p! Now let\'s fish up those frenzies!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(112830,'He alone knows every detail. You will need his counsel if you are to succeed.','',0,0,0,0,0,0,0,0,6,0,66878,0,26124),
(112831,'You must also regain the Sargerite Keystone to invade the Legion\'s worlds.','',0,0,0,0,0,0,0,0,6,0,66879,0,26124),
(112832,'Find out where the Wardens hid it away.','',0,0,0,0,0,0,0,0,6,0,66880,0,26124),
(112833,'We have attracted attention. I must move.','',0,0,0,0,0,0,0,0,6,0,66991,0,26124),
(112834,'You will not be able to contact me like this again. The Illidari are now yours, $n.','',0,0,0,0,0,0,0,0,6,0,66881,0,26124),
(112835,'Blast! It\'s gone! That Vargoth is going to be sorry when I catch up with him!','',1,0,0,0,0,0,0,0,0,0,67650,0,26124),
(112836,'He was here very recently -- he can\'t have gotten too far ahead!','',0,0,0,0,0,0,0,0,0,0,67651,0,26124),
(112837,'$n, I have been expecting you. Ah good... Kayn Sunfury.','',0,0,0,0,0,0,0,0,6,0,66860,0,26124),
(112838,'My lord.','',0,0,0,0,0,0,0,0,6,0,66861,0,26124),
(112839,'There is little time. Listen closely.','',0,0,0,0,0,0,0,0,6,0,66862,0,26124),
(112840,'Vindictive Spirit stares in your direction.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112842,'Vindictive Spirit emits an empty howl.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112843,'','Disaster abounds here. Elf ruins filled with unquiet souls ripe for harvest.',0,0,0,0,0,0,0,0,0,0,0,63462,26124),
(112844,'','The dragons are weak here. You would do well to exploit this fact.',0,0,0,0,0,0,0,0,0,0,0,63463,26124),
(112845,'','The Legion burrows deep here. If they burrow deeper, they may not like what they find.',0,0,0,0,0,0,0,0,0,0,0,63464,26124),
(112846,'','The spawn of the titans infest this area. Despite our \"gift\" of flesh, they still worship those false gods.',0,0,0,0,0,0,0,0,0,0,0,63517,26124),
(112847,'','Helya and her cult are strong here. So close to the truth, yet so far.',0,0,0,0,0,0,0,0,0,0,0,63518,26124),
(112848,'','Do not be impressed by tall icons of the titans which stand here. The towers of sacrifice in Ny\'alotha dwarf these pathetic temples.',0,0,0,0,0,0,0,0,0,0,0,63519,26124),
(112849,'Enough! Get out of our city!','Enough! Get out of our city!',0,0,0,0,0,0,0,0,0,0,65739,65939,26124),
(112850,'We cannot endure your presence any longer!','We cannot endure your presence any longer!',0,0,0,0,0,0,0,0,0,0,65738,65940,26124),
(112851,'Hush, they are nearby.','Hush, they are nearby.',0,0,0,0,0,0,0,0,0,0,65737,65941,26124),
(112852,'Your vile magic is an abomination!','Your vile magic is an abomination!',0,0,0,0,0,0,0,0,0,0,65736,65942,26124),
(112853,'What is Elisande thinking, letting them in?','What is Elisande thinking, letting them in?',0,0,0,0,0,0,0,0,0,0,65735,65943,26124),
(112854,'Monsters...','Monsters...',0,0,0,0,0,0,0,0,0,0,65734,65944,26124),
(112855,'','This city of elves pales in comparison to the sleeping city...',0,0,0,0,0,0,0,0,0,0,0,63520,26124),
(112856,'','Suramar, its \"noble\" citizens greedily slurping at their world\'s very lifeblood.',0,0,0,0,0,0,0,0,0,0,0,63521,26124),
(112857,'','The fallen elves cower behind their wall. They know no other way...',0,0,0,0,0,0,0,0,0,0,0,63522,26124),
(112858,'Ring around the city...','',0,0,0,0,0,0,0,0,0,0,65778,0,26124),
(112859,'Hearts are full of pity...','',0,0,0,0,0,0,0,0,0,0,65785,0,26124),
(112860,'Crashing! Clashing!','',0,0,0,0,0,0,0,0,0,0,65786,0,26124),
(112861,'Outside lies doom.','',0,0,0,0,0,0,0,0,0,0,65777,0,26124),
(112862,'Teacher said my magic was strongest!','',0,0,0,0,0,0,0,0,0,0,65787,0,26124),
(112863,'No fair, I never get to be the Grand Magistrix!','',0,0,0,0,0,0,0,0,0,0,65771,0,26124),
(112864,'My parents say I\'m too young for arcwine.','',0,0,0,0,0,0,0,0,0,0,65772,0,26124),
(112865,'','The fallen Aspect\'s lair is near. He was the strongest of them, and yet the easiest one for us to corrupt.',0,0,0,0,0,0,0,0,0,0,0,63475,26124),
(112866,'You can\'t break through the force fields! The shields are too strong!','',0,0,0,0,0,0,0,0,0,0,65773,0,26124),
(112867,'Pew pew pew! Lightning Missiles!','',0,0,0,0,0,0,0,0,0,0,65774,0,26124),
(112868,'Pew pew pew! Lightning Missiles!','Pew pew pew! Lightning Missiles!',0,0,0,0,0,0,0,0,0,0,65774,65974,26124),
(112869,'You can\'t break through the force fields! The shields are too strong!','You can\'t break through the force fields! The shields are too strong!',0,0,0,0,0,0,0,0,0,0,65773,65988,26124),
(112870,'My parents say I\'m too young for arcwine.','My parents say I\'m too young for arcwine.',0,0,0,0,0,0,0,0,0,0,65772,65975,26124),
(112871,'No fair, I never get to be the Grand Magistrix!','No fair, you always get to be the Grand Magistrix!',0,0,0,0,0,0,0,0,0,0,65771,65976,26124),
(112872,'Teacher said my magic was strongest!','Teacher said my magic was strongest!',0,0,0,0,0,0,0,0,0,0,65787,65977,26124),
(112873,'','Outside lies doom.',0,0,0,0,0,0,0,0,0,0,0,65982,26124),
(112874,'','Crashing! Clashing!',0,0,0,0,0,0,0,0,0,0,0,65978,26124),
(112875,'','Hearts are full of pity...',0,0,0,0,0,0,0,0,0,0,0,65979,26124),
(112876,'','Ring around the city...',0,0,0,0,0,0,0,0,0,0,0,65980,26124),
(112877,'Invisibility!','Invisibility!',0,0,0,0,0,0,0,0,0,0,65784,65981,26124),
(112878,'I can still see you.','I can still see you.',0,0,0,0,0,0,0,0,0,0,65775,65972,26124),
(112879,'Look at what I can do!','Look at what I can do!',0,0,0,0,0,0,0,0,0,0,65776,65973,26124),
(112880,'','More of the titans\' failed experiments grow here unchecked. The drogbar prove their failure as creators.',0,0,0,0,0,0,0,0,0,0,0,63476,26124),
(112881,'','The tauren here are remarkably resilient to corruption, considering their origins.',0,0,0,0,0,0,0,0,0,0,0,63477,26124),
(112882,'','To see Yogg-Saron\'s nightmare in full bloom fills me with jealousy... and some pride.',0,0,0,0,0,0,0,0,0,0,0,63523,26124),
(112883,'','Here you will see why the Legion\'s invasion is ultimately futile. All can be corrupted, dreams and demons alike.',0,0,0,0,0,0,0,0,0,0,0,63524,26124),
(112884,'','The elves here are desperate to save themselves from the Nightmare, while the demons seek to harness its might. Both will fail.',0,0,0,0,0,0,0,0,0,0,0,63525,26124),
(112885,'','So much fury in this soul! It will be a good harvest.',0,0,0,0,0,0,0,0,0,0,0,63465,26124),
(112886,'','Another tortured soul, long overdue for oblivion. I am more interested in his advisor, though...',0,0,0,0,0,0,0,0,0,0,0,63466,26124),
(112887,'','Xavius\'s tricks are cunning. Why reveal yourself when you can control from afar?',0,0,0,0,0,0,0,0,0,0,0,63470,26124),
(112888,'','It is possible N\'Zoth may be responsible for her form, but her arrogance is all her own.',0,0,0,0,0,0,0,0,0,0,0,63471,26124),
(112889,'','Behold the wasted power of the titans before you, done in their name, no less.',0,0,0,0,0,0,0,0,0,0,0,63472,26124),
(112890,'','Skovald seeks to join the ranks of the destroyers, unaware that so many of those who dare are betrayed.',0,0,0,0,0,0,0,0,0,0,0,63474,26124),
(112891,'','Odyn was a great enemy... until his own arrogance proved his undoing. You should ask him if he has considered Loken\'s final words to him. Go ahead!',0,0,0,0,0,0,0,0,0,0,0,63473,26124),
(112892,'','Ymiron was a fine tool. He did more to spread the blessing of flesh than any other of his kind.',0,0,0,0,0,0,0,0,0,0,0,63492,26124),
(112893,'The people of this land bought their freedom from the Legion, a price paid in blood. A sacrifice made in vain, as you shall soon see.','',0,0,0,0,0,0,0,0,0,0,62349,0,26124),
(112894,'Strong, powerful, cunning... dragons would make ideal minions if they were only more... subservient.','',0,0,0,0,0,0,0,0,0,0,62350,0,26124),
(112895,'Look at the land, see how the Legion has drained it of every useful bit of magic? Not even the soul of a worm remains! Such efficiency must be praised!','',0,0,0,0,0,0,0,0,0,0,62348,0,26124),
(112896,'This place is nothing compared to Mac\'Aree, and soon it will burn with hellfire just the same.','',0,0,0,0,0,0,0,0,0,0,62545,0,26124),
(112897,'The elves of this land wither away for lack of magic. Pathetic! They could have easily taken it from others.','',0,0,0,0,0,0,0,0,0,0,62381,0,26124),
(112898,'The elves huddle behind their walls for protection. Fools! The very world around them will crumble if the Legion is victorious!','',0,0,0,0,0,0,0,0,0,0,62382,0,26124),
(112899,'Well done everyone!','Well done everyone!',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(112900,'For the Alliance!','For the Alliance!',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(112901,'We did it!','We did it!',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(112902,'We prevail!','We prevail!',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(112903,'Brothers and sisters in arms!','Brothers and sisters in arms!',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(112904,'','Oh look, master! A city full of naughty little elves!',0,0,0,0,0,0,0,0,0,0,0,62387,26124),
(112905,'Who goes there?','Who goes there?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(112906,'Reveal yourself!','Reveal yourself!',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(112907,'A curse upon you, shaman. Destroy $ghim:her; my pets!','',0,0,0,0,0,0,463,0,0,0,0,0,26124),
(112908,'Did you hear that?','Did you hear that?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(112909,'The shadows grow dark in this place.','',0,0,0,0,0,0,0,0,0,0,62390,0,26124),
(112910,'','What\'s that? Speak into my good ear.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112911,'The void reaches out to this land.','',0,0,0,0,0,0,0,0,0,0,62389,0,26124),
(112912,'A city? Do we HAVE to go in there!?','',0,0,0,0,0,0,0,0,0,0,62384,0,26124),
(112913,'I will enjoy seeing this city destroyed.','',0,0,0,0,0,0,0,0,0,0,62383,0,26124),
(112914,'Good luck, $n. Use my crystal to speak with me inside.','',0,0,0,0,0,0,0,0,0,0,68876,0,26124),
(112915,'','What a miserable excuse for a city.',0,0,0,0,0,0,0,0,0,0,0,62398,26124),
(112916,'Look at this city! So much magic to feed upon!','',0,0,0,0,0,0,0,0,0,0,62385,0,26124),
(112917,'Ah, fresh meat for the spit!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112918,'I\'ll eat your... heart...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112919,'Weak creatures, ripe for the slaughter!','',0,0,0,0,0,0,0,0,0,0,62388,0,26124),
(112920,'Come! The fal\'dorei make their home in the ruins below.','',0,0,0,0,0,0,0,0,0,0,67260,0,26124),
(112921,'Down. Follow the water.','',0,0,0,0,0,0,0,0,0,0,67261,0,26124),
(112922,'','You make the most amusing pet, little elf.',0,0,0,0,0,0,0,0,0,0,0,66120,26124),
(112923,'','Know your place, worm.',0,0,0,0,0,0,0,0,0,0,0,66121,26124),
(112924,'','You are our playthings, little one. Remember that.',0,0,0,0,0,0,0,0,0,0,0,66122,26124),
(112925,'','Kneel before your betters, whelp.',0,0,0,0,0,0,0,0,0,0,0,66123,26124),
(112926,'','Get used to groveling, Nightborne.',0,0,0,0,0,0,0,0,0,0,0,66124,26124),
(112927,'','Hide for now. I will find you soon...',0,0,0,0,0,0,0,0,0,0,0,66125,26124),
(112928,'','Very well. Enjoy your freedom... while it lasts.',0,0,0,0,0,0,0,0,0,0,0,66126,26124),
(112929,'','Hmm, maybe nothing after all...',0,0,0,0,0,0,0,0,0,0,0,66127,26124),
(112930,'','What do we have here? Someone hiding?',0,0,0,0,0,0,0,0,0,0,0,66128,26124),
(112931,'','Come out, come out, little one...',0,0,0,0,0,0,0,0,0,0,0,66129,26124),
(112932,'','You can run, but you cannot hide, sweetling...',0,0,0,0,0,0,0,0,0,0,0,66130,26124),
(112933,'The third fleet has been deployed against the southern shores of the Broken Isles.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112934,'No word has reached us from the front lines?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112935,'Only a handful of scouts have returned, none recently.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112936,'Troubling.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112937,'I can help you over here, $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(112938,'','You are too late, mortal!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112939,'','Brinebeard, rise again! Serve the Legion in undeath!',0,0,0,0,0,0,669,0,0,0,0,0,26124),
(112940,'','Tear this weakling apart, Brinebeard. I have business elsewhere...',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(112941,'Stay inside the shrine and avoid the whirlwinds','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112942,'','What\'s that you say? Moozy is where?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112943,'Your family is at the Hammer\'s Cradle.','Your family is at the Hammer\'s Cradle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112944,'','Can\'t see you, $n!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112945,'','Slow down, $gbull calf:heifer;!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112946,'','Why is everyone always in such a hurry?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112947,'','I guess you\'d rather I fall off the edge of Thunder Totem than escort me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112948,'','There was a time when young ones were nice to old ladies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112949,'','Wait for me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112950,'','Get where I can see you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112951,'','Come closer, $r.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112952,'','Ah, these old bones haven\'t moved in a while.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112953,'','What a nice young $gman:woman;.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112954,'','Let\'s go see Moozy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112955,'','My daughter really is a beautiful woman.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112956,'','When do you think Sella will give me more grandchildren?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112957,'','Have you seen Moozy\'s smile? Gets it from me, I suspect.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112958,'','Little Moozy is a gorgeous calf.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112959,'','What are you waiting for? Let\'s get moving!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112960,'No... No!','No... No!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112961,'Help us!','Help us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112962,'An intriguing turn of events. I will see you up top.','',0,0,0,0,0,0,0,0,0,0,66849,0,26124),
(112963,'I will see you up top. We will break the news together.','',0,0,0,0,0,0,0,0,0,0,66850,0,26124),
(112964,'Collect ten globules of living water without getting attacked','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112965,'Return to Hydrannon without getting attacked','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112966,'Emmarel! Commander! Have you seen it?','',0,0,0,0,0,0,603,0,0,0,66574,0,26124),
(112967,'I heard something over here.','I heard something over here.',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(112968,'What was that?','What was that?',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(112969,'There\'s someone here.','There\'s someone here.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(112970,'We aren\'t alone, brothers and sisters.','We aren\'t alone, brothers and sisters.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(112971,'Illidan\'s soul has spoken. Our way forward is clear.','',0,0,0,0,0,0,1,0,0,0,66854,0,26124),
(112972,'Look to the sky! It\'s happening, above the lodge!','',0,0,0,0,0,0,25,0,0,0,66575,0,26124),
(112973,'Forgive me $pc, this may hurt a little.','Forgive me $pc, this may hurt a little.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112974,'','Calm down, Pierce. What are you talking about?',0,0,0,0,0,0,1,0,0,0,0,66576,26124),
(112975,'We have consulted with the Master\'s soul and gained wisdom.','',0,0,0,0,0,0,1,0,0,0,66992,0,26124),
(112976,'The emergency signal flares. They\'re being fired above the lodge!','',0,0,0,0,0,0,1,0,0,0,66577,0,26124),
(112977,'Look for yourself!','',0,0,0,0,0,0,25,0,0,0,71624,0,26124),
(112978,'More bones for the Legion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112979,'All hail, $n, our new leader. Illidari, salute!','',0,0,0,0,0,0,66,0,0,0,66855,0,26124),
(112980,'','It can\'t be... Those flares haven\'t been used in hundreds of years.',0,0,0,0,0,0,1,0,0,0,0,66578,26124),
(112981,'You are... too late...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(112982,'Illidari, salute our new leader, $n!','',0,0,0,0,0,0,66,0,0,0,66856,0,26124),
(112983,'','We must follow protocol. Whoever is firing those flares obviously needs our help.',0,0,0,0,0,0,1,0,0,0,0,66579,26124),
(112984,'Alas, poor Nythendra! She served faithfully as Guardian of the Dream, only to be perverted into a gatekeeper of corruption.','',0,0,0,0,0,0,0,0,0,0,61392,0,26124),
(112985,'We must put an end to the Nightmare. Say the word and I will take us into the heart of that twisted place.','',0,0,0,0,0,0,0,0,0,0,61371,0,26124),
(112986,'I have faced the Nightmare before, but never has it had so thorough a stranglehold on the Dream. It hungers, desperate to seed its corruption. Do not let its whispers seduce you into madness!','',0,0,0,0,0,0,0,0,0,0,61372,0,26124),
(112987,'I sense the touch of Cenarius upon this Iris. It is a portal that leads to Moonglade, but the way has been sealed by dark magic. We must sever the tendrils of power that bind it.','',0,0,0,0,0,0,669,0,0,0,61373,0,26124),
(112988,'From each of these pathways, a palpable evil emanates. Choose a course, and know that I will stand with you.','',0,0,0,0,0,0,669,0,0,0,61374,0,26124),
(112989,'','Let\'s make our way to the watch tower.',0,0,0,0,0,0,1,0,0,0,0,66580,26124),
(112990,'If you need further proof of how insidious the Nightmare is, look there! Even the fierce heart of Ursoc has succumbed. Release him, I beg you!','',0,0,0,0,0,0,0,0,0,0,61375,0,26124),
(112991,'Truly there was never a soul more noble than Ursoc\'s. I pray his spirit finds its way back to the Dream.','',0,0,0,0,0,0,0,0,0,0,61376,0,26124),
(112992,'This was the Emerald Dreamway. During my long slumber, it was here I communed with the Green Dragonflight.','',0,0,0,0,0,0,0,0,0,0,61377,0,26124),
(112993,'Now this sacred place has been made into a conduit for the Nightmare to spread its corruption. This we cannot allow!','',0,0,0,0,0,0,0,0,0,0,61378,0,26124),
(112994,'','We will not be stopped!',0,0,0,0,0,0,0,0,0,0,0,63554,26124),
(112995,'Oh Ysondre! How cruel fate can be! Cleansed of the Nightmare once before, only to become its victim yet again. Some wounds never truly heal.','',0,0,0,0,0,0,0,0,0,0,61379,0,26124),
(112996,'May you find peace at last, old friend.','',0,0,0,0,0,0,0,0,0,0,61380,0,26124),
(112997,'What manner of foul creature is this? It seems poised to unleash its corruption upon Thunder Bluff! The spirit of the tauren people must not fall prey to the Nightmare!','',0,0,0,0,0,0,0,0,0,0,61381,0,26124),
(112998,'I\'m going to find that Soulstone if it\'s the last thing I do!','',1,0,0,0,0,0,0,0,0,0,67652,0,26124),
(112999,'The illusion of corruption falls away! Behold a druid who was as a sister to me... Elerethe Renferal. I feel her loss keenly, heroes.','',0,0,0,0,0,0,0,0,0,0,61382,0,26124),
(113000,'The Twilight\'s Hammer ambushed and murdered Elerethe, misleading her into believing Hamuul Runetotem played a part in her death. It seems her spirit was so twisted that she sought to take vengeance upon all of Thunder Bluff.','',0,0,0,0,0,0,0,0,0,0,61383,0,26124),
(113001,'You had a deep love for the lands of Alterac, old friend. I vow to tend the vale in your name.','',0,0,0,0,0,0,0,0,0,0,61384,0,26124),
(113002,'What horror is this? A tumor of Nightmare infecting a world tree, here in the reflection of the titans\' own playground?','',0,0,0,0,0,0,0,0,0,0,61385,0,26124),
(113003,'If this seed takes hold, the roots of its infestation will wind their way into the heart of Azeroth. The Nightmare would devour our world, claiming everything... everyone. This must not come to pass!','',0,0,0,0,0,0,0,0,0,0,61386,0,26124),
(113004,'No doubt Xavius and his ancient master delight that so much of our attention goes into fighting the Legion. Their insidious shadow seeps into our world, distracting us with whispers and doubts.','',0,0,0,0,0,0,0,0,0,0,61387,0,26124),
(113005,'Once I get that Soulstone, nobody will be able to stop me!','',0,0,0,0,0,0,0,0,0,0,67653,0,26124),
(113006,'Pray that purging the Nightmare\'s corruption buys us enough time to defeat the Legion and catch our breath before the black armies rise up from the depths.','',0,0,0,0,0,0,0,0,0,0,61388,0,26124),
(113007,'Enough! I grow tired of this.','',0,0,0,0,0,0,0,0,0,0,61401,0,26124),
(113008,'Behold, the Iris opens! The way to Cenarius is clear.','',0,0,0,0,0,0,0,0,0,0,61389,0,26124),
(113009,'Moonglade is the most sacred place in all the Dream. To think that my shan\'do could play any part in its corruption...','',0,0,0,0,0,0,0,0,0,0,61390,0,26124),
(113010,'I must see with my own eyes what horrors have befallen my beloved teacher. Steel your hearts against the darkness, heroes.','',0,0,0,0,0,0,0,0,0,0,61391,0,26124),
(113011,'Now that is a fancy weapon? You should let me borrow it sometime!','',0,0,0,0,0,0,0,0,0,0,67654,0,26124),
(113012,'The Aegis will be mine you fools, and there\'s nothing you can do to stop me.','',0,0,0,0,0,0,0,0,0,0,61400,0,26124),
(113013,'Of course, if I had a fancy weapon like yours I\'d be running this place!  And much more competently, I might add.','',0,0,0,0,0,0,0,0,0,0,67655,0,26124),
(113014,'Did you know the Nightborne Soulstone can be used to control millions of people? I\'m sure going to have some fun when I get it!','',0,0,0,0,0,0,0,0,0,0,67656,0,26124),
(113015,'Vargoth and his limited intellect will never be able to unlock the Soulstone\'s full potential. I\'m the only one who can really show you what it can do!','',0,0,0,0,0,0,0,0,0,0,67657,0,26124),
(113016,'','The Herald has promised us freedom and respect. We will not be denied!',0,0,0,0,0,0,0,0,0,0,0,63557,26124),
(113017,'','You will not interfere. The Legion will rise!',0,0,0,0,0,0,0,0,0,0,0,63556,26124),
(113019,'','Archmage, we saw your flares. Please let us know how we can help.',0,0,0,0,0,0,1,0,0,0,0,66581,26124),
(113020,'','Mother!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113021,'','There\'s my Moozy...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113022,'Assassin! Run for your lives!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113023,'I\'m sure those tauren will be back any minute.\n\nTill then, how can I help you, chum?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113024,'Why are you moving the taurens\' goods over to your zeppelin?','Why are you moving the taurens\' goods over to your zeppelin?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(113025,'Oh, we got a... business arrangement with them. \n\nYeah, they want us to fly this stuff over to Dalaran and sell it for them there. After all, there aren\'t a whole lot of people to sell it to here, right? And who\'s a better salesperson than a goblin? \n\nThose tauren sure have an eye for business!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113026,'Shhh! Someone\'s coming...','',0,0,0,0,0,0,1,0,0,0,69879,0,26124),
(113027,'Oh, hey there, chum.  How can we help?','',0,0,0,0,0,0,6,0,0,0,69878,0,26124),
(113028,'...probably dragon food by now...','',0,0,0,0,0,0,11,0,0,0,69877,0,26124),
(113029,'Don\'t be so sure... Hey there, friend!','',0,0,0,0,0,0,0,0,0,0,69876,0,26124),
(113030,'Can you hear me through this thing, $n? You should be near Verstok\'s location by now.','',0,0,0,0,0,0,0,0,4,0,62183,0,26124),
(113031,'...they\'re starting to smell. Think we should mo-','',0,0,0,0,0,0,6,0,0,0,69875,0,26124),
(113032,'Shhh!','',0,0,0,0,0,0,661,0,0,0,69874,0,26124),
(113033,'My foolish protege was in such a rush to escape the Shrine, I\'ll wager he failed to mask his scent. Shift into cat form and you\'ll likely detect it.','',0,0,0,0,0,0,0,0,4,0,62186,0,26124),
(113034,'','All goes as planned. Once Brother Shadowgaze arrives, we leave for Stormwind!',0,0,0,0,0,0,0,0,0,0,0,63555,26124),
(113035,'Show them no mercy.','Show them no mercy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113036,'','Do give Lan\'dalock my love, $n.',0,0,0,0,0,0,0,0,0,0,0,66863,26124),
(113037,'The Legion shows no mercy.','The Legion shows no mercy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113038,'Our presence will remain.','Our presence will remain.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113039,'The Burning Legion will fall!','The Burning Legion will fall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113040,'Swift blades and unrelenting devotion. Nothing less.','Swift blades and unrelenting devotion. Nothing less.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113041,'Do you feel their presence growing?','Do you feel their presence growing?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113042,'Our battle has only just begun.','Our battle has only just begun.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113043,'Careful! The ruins are infested by withered, pitiful creatures with an unending hunger for the arcane. The power of the Fangs might have lured some to Verstok\'s trail.','',0,0,0,0,0,0,0,0,4,0,62189,0,26124),
(113044,'The Burning Legion has returned.','The Burning Legion has returned.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113045,'Shame you were not prepared.','Shame you were not prepared.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113046,'Your strength was no match.','Your strength was no match.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113047,'You are no match for the Illidari.','You are no match for the Illidari.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113048,'When you return, I\'ll be ready.','When you return, I\'ll be ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113049,'Whatever you did seems to have annoyed those withered. This might work to your advantage. See if you can find another switch.','',0,0,0,0,0,0,0,0,4,0,62193,0,26124),
(113050,'I expected more of a fight.','I expected more of a fight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113051,'You were in charge of the tracking units!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113052,'Don\'t think you stand a chance simply because you have come this far. You are nothing! NOTHING!','',0,0,0,0,0,0,0,0,0,0,61399,0,26124),
(113053,'Maybe our camouflage module was a bit too effective.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113054,'Well, it was your idea to give them free will!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113055,'My forces are limitless!','',0,0,0,0,0,0,0,0,0,0,61397,0,26124),
(113056,'If we are going to get Rush and Treble back, we\'re going to need some help...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113057,'So long sucker!','',0,0,0,0,0,0,22,0,0,0,69873,0,26124),
(113058,'The Nightborne Soulstone is mine. You are becoming quite a nuisance.','',1,0,0,0,0,0,0,0,0,0,66483,0,26124),
(113059,'Thousands of worlds will be mine to conquer!','',0,0,0,0,0,0,0,0,0,0,61404,0,26124),
(113060,'Lady Kyranith, meet me at the Oculus once you\'ve taken care of our overly ambitious friends here.','',0,0,0,0,0,0,0,0,0,0,66485,0,26124),
(113061,'Minions of the Legion, destroy these worms!','',0,0,0,0,0,0,0,0,0,0,61403,0,26124),
(113062,'Treble!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113063,'He seems to like you. Will you take care of him for me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113064,'Cower before the might of the Legion!','',0,0,0,0,0,0,0,0,0,0,66100,0,26124),
(113065,'Feel my gaze, and despair!','',0,0,0,0,0,0,0,0,0,0,66101,0,26124),
(113066,'Run! Cower! Scream!','',0,0,0,0,0,0,0,0,0,0,66102,0,26124),
(113067,'Your shield cannot protect you any longer!','',0,0,0,0,0,0,0,0,0,0,66119,0,26124),
(113068,'Begone, wretch!','',0,0,0,0,0,0,0,0,0,0,66103,0,26124),
(113069,'Foolish surface-dwellers! Be gone!','',0,0,0,0,0,0,0,0,0,0,67498,0,26124),
(113071,'','Silence, insect!',0,0,0,0,0,0,0,0,0,0,0,66145,26124),
(113072,'','Where is your magic now?',0,0,0,0,0,0,0,0,0,0,0,66146,26124),
(113073,'','Let\'s test your immortality, shall we?',0,0,0,0,0,0,0,0,0,0,0,66147,26124),
(113074,'','I will not suffer a fool!',0,0,0,0,0,0,0,0,0,0,0,66148,26124),
(113075,'','Mind the landing, dear.',0,0,0,0,0,0,0,0,0,0,0,66149,26124),
(113076,'Grr... Persistent vermin...','',0,0,0,0,0,0,0,0,0,0,67500,0,26124),
(113077,'Demon hunter, that imp just stole the grimoire. Catch it!','',0,0,0,0,0,0,0,0,0,0,66867,0,26124),
(113078,'An imp? What\'s going on here, $n?','',0,0,0,0,0,0,0,0,0,0,66868,0,26124),
(113079,'Do you think we don\'t know what you\'re up to, $n?','',0,0,0,0,0,0,0,0,0,0,66869,0,26124),
(113080,'','The Illidari believe themselves untouchable. They will soon learn better.',0,0,0,0,0,0,0,0,0,0,0,66870,26124),
(113081,'Oh, goodie. A new box of toys!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113082,'Brothers and sisters - today we defend our lands against the blight of the Burning Legion. We are strong. We are one. For the Horde!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(113083,'Even my blade couldn\'t protect me from those things.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(113084,'Caught off guard! I\'ll be back before this is over!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(113085,'Vrykul Shepherd calls for help from his flock.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113086,'The Vrykul Shepherd calls out to his flock again, hoping for further assistance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113087,'The Vrykul Shepherd pleads with his flock once more, hoping for any assistance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113088,'Come and get it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113089,'Come and get it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113090,'The Fangs are mine! MINE!!','',0,0,0,0,0,0,0,0,0,0,62194,0,26124),
(113092,'I see you! You may look like a druid, but I can tell you\'re a demon in disguise. I won\'t fall for your trick! You\'ll never get the Fangs from me!','',0,0,0,0,0,0,0,0,0,0,62184,0,26124),
(113093,'Has Verstok gone mad? Wielding the Fangs enhances one\'s senses, but I\'m afraid it also heightened his paranoia.','',0,0,0,0,0,0,0,0,4,0,62195,0,26124),
(113094,'','The Wardens are now few in number, yet justice must not rest, friend. Aid us in dispatching this foul creature. Show the people of this land that the Wardens remain ever vigilant!',0,0,0,0,0,0,0,0,0,0,0,70692,26124),
(113095,'','We thank you for your service. As the tides of power ebb and flow unchecked in this land, be on your guard.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113096,'I cannot find your papers, citizen.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113097,'Good luck out there!','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(113098,'You\'re assigned to the Victory.','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(113099,'For the Alliance!','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(113100,'Stormwind appreciates your service!','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(113101,'Victory awaits, soldier!','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(113102,'Leave, demon! Begone! Why won\'t you just GO AWAY!?','',0,0,0,0,0,0,0,0,0,0,62187,0,26124),
(113103,'Don\'t give them any quarter!','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(113104,'You must get the Fangs away from Verstok, $n. The longer they remain in his possession, the greater his delusion becomes.','',0,0,0,0,0,0,0,0,4,0,62197,0,26124),
(113105,'','Scary...',0,0,0,0,0,0,0,0,0,0,0,65983,26124),
(113106,'','Ahhh!',0,0,0,0,0,0,0,0,0,0,0,65984,26124),
(113107,'','Let\'s play somewhere else for a while.',0,0,0,0,0,0,0,0,0,0,0,65985,26124),
(113108,'','Don\'t eat me!',0,0,0,0,0,0,0,0,0,0,0,65986,26124),
(113109,'','Hide! They\'ll eat you!',0,0,0,0,0,0,0,0,0,0,0,65987,26124),
(113111,'My kodo! They\'ll pay for this!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(113112,'My livestock! You ugly demon-horned filth!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(113113,'','With pleasure.',0,0,0,0,0,0,0,0,0,0,0,66484,26124),
(113114,'Squad reporting for duty!','Squad reporting for duty!',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(113116,'Show yourselves. I don\'t have time for games.','',0,0,0,0,0,0,396,0,0,0,63564,0,26124),
(113117,'','Step aside, Shaw! All of Stormwind will burn unless we finish our work.',0,0,0,0,0,0,397,0,0,0,0,63565,26124),
(113119,'East of the Crossroads! A structure just formed out of nothing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113120,'You won\'t leave? Very well, I\'ll end this chase myself!','',0,0,0,0,0,0,0,0,0,0,62192,0,26124),
(113121,'No! I\'ll never submit!','',0,0,0,0,0,0,0,0,0,0,62196,0,26124),
(113130,'','You disappoint me, King of Stormwind. But sooner or later, you will see the truth. You all will!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113131,'','Great... It\'s Shaw.',0,0,0,0,0,0,0,0,0,0,0,63563,26124),
(113132,'We\'re aware of the Veiled Hand\'s activites. The city is locked down while WE handle the situation.','',0,0,0,0,0,0,396,0,0,0,63566,0,26124),
(113133,'No one enters these gates until this is resolved... especially the two of you!','',0,0,0,0,0,0,396,0,0,0,63567,0,26124),
(113134,'Ah, you\'ve arrived! I\'ve already begun. I trust Alodi is with you?','',0,0,0,0,0,0,1,0,0,0,64226,0,26124),
(113135,'I\'m here, though my powers are weakened so far from the hall.','',0,0,0,0,0,0,0,0,0,0,64227,0,26124),
(113136,'Do what you can, old friend. Welcome to Faronaar, a key invasion point for the Legion!','',0,0,0,0,0,0,2,0,0,0,64228,0,26124),
(113137,'While I distract the defenders below, you will setup the ritual wards at key locations.','',0,0,0,0,0,0,1,0,0,0,64229,0,26124),
(113138,'Here\'s a spell that will conjure the wards. Three should be sufficient.','',0,0,0,0,0,0,0,0,0,0,64230,0,26124),
(113140,'When you are done, meet me at the Altar of End Times. Its location should be obvious. Good luck!','',0,0,0,0,0,0,1,0,0,0,64231,0,26124),
(113141,'Stay out of this, half-breed.','',0,0,0,0,0,0,397,0,0,0,63568,0,26124),
(113146,'The doors are shut? Look around the courtyard for something that might open them. Just be mindful of the withered.','',0,0,0,0,0,0,0,0,4,0,62191,0,26124),
(113147,'','It\'s hiding on the shelf. Adorable.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113149,'Filthy demons! They feed upon the blue dragonflight! Have all the defenders fallen?','',0,0,0,0,0,0,0,0,0,0,64193,0,26124),
(113150,'Argh! What is this? Release me at once!','',0,0,0,0,0,0,0,0,0,0,62198,0,26124),
(113151,'That Legion vessel looming above shows what\'s at stake. Truly this is a fight to save our world!','',0,0,0,0,0,0,0,0,0,0,64194,0,26124),
(113152,'Here is good. This is what the Council was supposed to prevent. How could it have gone so wrong?!','',0,0,0,0,0,0,0,0,0,0,64232,0,26124),
(113153,'The Arcway Vaults have likely been breached by Legion invaders as well as our old friend, Millhouse Manastorm. Although he is far from trustworthy, I suspect we may be able to take advantage of his rather creative skills.','',0,0,0,0,0,0,0,0,0,0,67658,0,26124),
(113154,'Look what fell into my web! Tonight I shall feast!','',0,0,0,0,0,0,0,0,0,0,62185,0,26124),
(113155,'I have little patience for this so-called king, his dilapidated keep, and the delusional followers that hang on his every word.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113160,'','Hey, we don\'t serve demons here. It\'ll have to wait outside!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113161,'','Arrogant bastard! If we are going to find the Herald, we\'re going to need a diversion, something big. Hmm...',0,0,0,0,0,0,396,0,0,0,0,63569,26124),
(113162,'$n - you wield the fist of the Stormkeeper! I will not fight you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113163,'You may pass, shaman.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113164,'You are the keeper of storms, $n. I will not bar you from this path.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113165,'I see the weapon you wield, $n, and I will obey.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113166,'','Ah, yes! Find agent Elling Trias in the Trade District. He should have a smoke bomb. If we set it off somewhere public, the guards will be forced to react.',0,0,0,0,0,0,396,0,0,0,0,63570,26124),
(113167,'','While they are busy investigating the ruckus, we should be able to gather some information and act on it without the risk of heavy reinforcements.',0,0,0,0,0,0,396,0,0,0,0,63571,26124),
(113168,'You may pass, $n. The storms here will not trouble you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113170,'The Highkeeper\'s chosen one has arrived. $n, the elements will not trouble you here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113173,'You wield the Fist of our master, $n. No storm will trouble you here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113174,'Approach the summit, $n. You wield the Fist of Storms, and your coming was foretold on the wind.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113176,'','Let\'s move. I\'ll be right behind you.',0,0,0,0,0,0,396,0,0,0,0,63562,26124),
(113177,'That sneaky imp! It headed southeast and then turned invisible.','',0,0,0,0,0,0,0,0,0,0,66882,0,26124),
(113178,'Quickly, $n, use your spectral sight and see if you can spot it.','',0,0,0,0,0,0,0,0,0,0,66885,0,26124),
(113179,'What on Azeroth was that!? Be careful, $n!','',0,0,0,0,0,0,0,0,4,0,62199,0,26124),
(113182,'Let me see...','',0,0,0,0,0,0,0,0,0,0,67572,0,26124),
(113183,'Silgryn quickly shuffles through the stack of letters.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113184,'Hm. They\'ve been rounding up a lot of people lately. Children, too.','',0,0,0,0,0,0,0,0,0,0,67573,0,26124),
(113185,'','Do you think Korine could be with the other children?',0,0,0,0,0,0,0,0,0,0,0,66377,26124),
(113186,'Very possible. I\'ll have our friend here follow a guard in and find out.','',0,0,0,0,0,0,0,0,0,0,67574,0,26124),
(113189,'There she is!','',0,0,0,0,0,0,0,0,0,0,67499,0,26124),
(113190,'She must not open the seed!','',0,0,0,0,0,0,0,0,0,0,67501,0,26124),
(113191,'Freedom! I thought I was going to be spider food!','',0,0,0,0,0,0,0,0,0,0,62200,0,26124),
(113192,'My brush with death cleared my head. Everything I saw was a threat, I\'m sorry I struck out at you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113193,'I wanted to protect the Fangs, but was soon overwhelmed. You\'ve proven yourself far more capable as their protector. Please, take them.','',0,0,0,0,0,0,0,0,0,0,62201,0,26124),
(113194,'A sip is all I can offer for now...','',0,0,0,0,0,0,0,0,16,0,67576,0,26124),
(113195,'This should ease the pain for a little while.','',0,0,0,0,0,0,0,0,16,0,67577,0,26124),
(113196,'Drink it slowly, make it last.','',0,0,0,0,0,0,0,0,16,0,67578,0,26124),
(113197,'Slowly now, we do not want to waste a drop.','',0,0,0,0,0,0,0,0,16,0,67579,0,26124),
(113198,'There you are. Thank you for your patience.','',0,0,0,0,0,0,0,0,16,0,67580,0,26124),
(113199,'It is not much, but please take it.','',0,0,0,0,0,0,0,0,16,0,67581,0,26124),
(113200,'I will try to have more tomorrow. This is all I can offer for now.','',0,0,0,0,0,0,0,0,16,0,67582,0,26124),
(113201,'This should be enough for your children.','',0,0,0,0,0,0,0,0,16,0,67583,0,26124),
(113202,'','|TInterface\\Icons\\sha_ability_rogue_envelopingshadows_nightmare:20|tA Lumbering Mindgorger forms in the mists of Ashenvale!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(113203,'','|TInterface\\Icons\\sha_ability_rogue_envelopingshadows_nightmare:20|tA Lumbering Mindgorger forms in the mists of The Hinterlands!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113204,'','|TInterface\\Icons\\sha_ability_rogue_envelopingshadows_nightmare:20|tA Lumbering Mindgorger forms in the mists of Feralas!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113205,'','I hope you will bring no storms to this peaceful grove, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113206,'Sir, yes, sir! Nobody enters the city on our watch.','Sir, yes, sir! Nobody enters the city on our watch.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113207,'','The Unseen Path will help however we can.',0,0,0,0,0,0,1,0,0,0,0,66582,26124),
(113208,'Guards, to your stations! Nobody enters the city until this mess is done with.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113209,'Change position!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113210,'March!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113211,'On your feet!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113212,'Keep alert! To your positions!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113213,'','I don\'t like this place! Hurry!',0,0,0,0,0,0,0,0,0,0,0,66235,26124),
(113214,'','I want my mommy!',0,0,0,0,0,0,0,0,0,0,0,66236,26124),
(113215,'','What you doing?',0,0,0,0,0,0,0,0,0,0,0,66237,26124),
(113216,'','Come ooooon!',0,0,0,0,0,0,0,0,0,0,0,66238,26124),
(113217,'','I want my mommy...',0,0,0,0,0,0,0,0,0,0,0,66239,26124),
(113218,'','AH! NO!',0,0,0,0,0,0,0,0,0,0,0,66240,26124),
(113219,'','Waaaah!',0,0,0,0,0,0,0,0,0,0,0,66241,26124),
(113220,'','I... *sniff* I know this street, maybe.',0,0,0,0,0,0,0,0,0,0,0,66242,26124),
(113221,'','Uh... yeah... YEAH! That\'s Vanthir\'s house!',0,0,0,0,0,0,0,0,0,0,0,66243,26124),
(113222,'','Bye!',0,0,0,0,0,0,0,0,0,0,0,66244,26124),
(113223,'Blades at the ready!','Blades at the ready!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113224,'','The gateway will be open momentarily, my dear.',0,0,0,0,0,0,0,0,0,0,0,66883,26124),
(113225,'','There. The Black Temple and Akama await your leisure, $n.',0,0,0,0,0,0,0,0,0,0,0,66884,26124),
(113226,'Forget the ley-lines, brothers! We shall feast on the dragons instead!','',0,0,0,0,0,0,0,0,0,0,63240,0,26124),
(113227,'I\'ll be with you, friend, such as I am. The world has changed so much since my time. I would have enjoyed exploring these isles.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113228,'I will aid you in the ward construction and use of the Mana Gems. Then there is the matter of Ebonchill.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113229,'The staff was not meant for demons. I will fight Balaadur for control of it while you keep him occupied. Together, we may stand a chance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113230,'You hear that boy? They traveled all this way just to see you.','',0,0,0,0,0,0,1,0,0,0,66583,0,26124),
(113231,'Millhouse, you certainly are quite talented at getting yourself into a bind!','',1,0,0,0,0,0,0,0,0,0,67659,0,26124),
(113232,'Archmage Vargoth is after the Nightborne Soulstone as well. You two should work together to find him before he locates it.','',1,0,0,0,0,0,0,0,0,0,67660,0,26124),
(113233,'What?! The Nightborne Soulstone is mine! Let\'s go get it!','',1,0,0,0,0,0,0,0,0,0,67661,0,26124),
(113234,'','I don\'t like it here...\n\n<Sniff.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113235,'I can help you get home. Come with me, little one.','I can help you get home. Come with me, little one.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113236,'Rush!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113237,'You\'ve done a great job caring for him. How about you hold onto him.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113238,'My suggestion is to find some place to hide until this is over!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113239,'It\'s not safe! Get outta here!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113240,'It\'s getting quite cold in here, isn\'t it?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113241,'','NO!',0,0,0,0,0,0,0,0,0,0,0,66245,26124),
(113242,'','Leave me alone!',0,0,0,0,0,0,0,0,0,0,0,66246,26124),
(113243,'','I don\'t wanna go back!',0,0,0,0,0,0,0,0,0,0,0,66247,26124),
(113244,'','Leave my friend alone!',0,0,0,0,0,0,0,0,0,0,0,66248,26124),
(113245,'','Heeeeey!',0,0,0,0,0,0,0,0,0,0,0,66249,26124),
(113246,'','.... Waaaaah!!',0,0,0,0,0,0,0,0,0,0,0,66250,26124),
(113247,'You ready to find some bones, boy?','',0,0,0,0,0,0,1,0,0,0,66584,0,26124),
(113248,'Stromgarde is mine! I will not give it up to my father or anyone else!','',0,0,0,0,0,0,22,0,0,0,69393,0,26124),
(113249,'I am the prince! How... dare you...','',0,0,0,0,0,0,0,0,0,0,69394,0,26124),
(113250,'','It\'s not too late. We\'ll just jump the mountains to cut them off, and...',0,0,0,0,0,0,0,0,0,0,0,63227,26124),
(113251,'','No, no... they\'re everywhere!',0,0,0,0,0,0,0,0,0,0,0,63228,26124),
(113252,'Let\'s get this place cleared so we can fish up all those delicious frenzies!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(113253,'','Hang on, $n. We\'re going in low.',0,0,0,0,0,0,0,0,0,0,0,63229,26124),
(113254,'Here are all the frenzies I caught.','Here are all the frenzies I caught.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113255,'','Aah!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113256,'Seize the child!','Seize the child!',0,0,0,0,0,0,0,0,0,0,66318,0,26124),
(113257,'After her!','After her!',0,0,0,0,0,0,0,0,0,0,66319,0,26124),
(113258,'Halt!','Halt!',0,0,0,0,0,0,0,0,0,0,66320,0,26124),
(113259,'Step away from the child!','Step away from the child!',0,0,0,0,0,0,0,0,0,0,66321,0,26124),
(113260,'You\'ve done it! I can feel arcane levels rising in the area. The demons have pulled back for the moment. I\'d wager they plan to hit us hard.','',0,0,0,0,0,0,1,0,0,0,64195,0,26124),
(113261,'This next part is tricky. We will start the ritual here to draw all that power. As we do, it\'s likely we\'ll be attacked. I\'ll begin placing the Mana Gems.','',0,0,0,0,0,0,1,0,0,0,64196,0,26124),
(113262,'You will channel on the Ritual Focus. Once we gather sufficient magic, I expect we will get Balaadur\'s attention.','',0,0,0,0,0,0,1,0,0,0,64197,0,26124),
(113263,'Prepare yourself, conjurer. I don\'t expect Balaadur to give us a particularly warm welcome.','',0,0,0,0,0,0,1,0,0,0,64198,0,26124),
(113264,'Let us begin the incantations.','Let us begin the incantations.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113265,'I will attempt to deal with most of the enemies, but it will likely be more than I can handle. You will need to stop casting occasionally to assist me. If you are ready we shall begin.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113266,'Good! Concentrate on building the Ritual Focus. I will do what I can to support you.','',0,0,0,0,0,0,1,0,0,0,64200,0,26124),
(113267,'Maybe we could blink past the barrier!','',0,0,0,0,0,0,0,0,0,0,67662,0,26124),
(113268,'','Oh my sweet little girl! Are you hurt? Were they mean to you?',0,0,0,0,0,0,0,0,0,0,0,66378,26124),
(113269,'','They yelled and put me in a cage! I missed you...',0,0,0,0,0,0,0,0,0,0,0,66251,26124),
(113270,'As I was running around fishing up the frenzies, I noticed some large bubbles over in this lagoon.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113271,'','You\'re home now. Thank goodness.',0,0,0,0,0,0,0,0,0,0,0,66379,26124),
(113274,'I\'m wondering if whatever\'s down there is what\'s been causing them to act up. Let\'s see if I can\'t rustle it up from where it\'s hiding.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113275,'Oh yea! There\'s definitely something down there. Let\'s fish it up, $p.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113276,'Remember, we are here to convince Akama to join us, not to kill him.','',0,0,0,0,0,0,0,0,0,0,66858,0,26124),
(113277,'I know not why you have returned, Illidari, but it is a grave mistake. This time, there will be no prison in the end... only death.','',0,0,0,0,0,0,0,0,0,0,66988,0,26124),
(113278,'Let\'s get up there, Kayn. It\'s time to convince Akama to join us.','Let\'s get up there, Kayn. It\'s time to convince Akama to join us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113283,'What in the great sea is that thing?!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(113285,'Quick! Kill it with fire or whatever it is you adventurers use!','',0,0,0,0,0,0,430,0,0,0,0,0,26124),
(113286,'Do your damn job! We can\'t keep living like this!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(113287,'Remain calm. The city\'s finest are on the case.','',0,0,0,0,0,0,661,0,0,0,0,0,26124),
(113288,'Blight','Blight',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113289,'Let\'s see how well that nose of yours works.','',0,0,0,0,0,0,1,0,0,0,66572,0,26124),
(113290,'Attaboy! Now let\'s go find those mages!','',0,0,0,0,0,0,603,0,0,0,66573,0,26124),
(113291,'','Ah, there you are. Elling\'s waiting for you upstairs.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(113292,'Wasn\'t easy to get this on such short notice with the city locked down, you know.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(113293,'Once you use the bomb, you\'d better hightail it out of there. Hammond and his boys will descend on that hall like moths to the flame.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(113294,'Pocketing','Pocketing',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113295,'Thank you for using the Ulduar Teleportation Network!$b$bAll destination points are currently offline for maintenance. If this is an emergency, please contact a Visitor Information Representative during regular business hours.$b$bHave a nice day!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113296,'','Tabards for sale! Show your colors on the front!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(113297,'My word! I barely got you out of there in time! You should take care out there, old chum!','',0,0,0,0,0,0,33,0,0,0,0,0,26124),
(113298,'','Tabards here! Rally your allies by showing your allegiance!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(113299,'','Don\'t leave home without flying your colors, buy a tabard today!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(113300,'Good boy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113301,'Back to master!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113302,'Who\'s a big sentient robo-wolf? You are! You are!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113303,'Back to master!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113308,'Fool! Did you really think a little piece of wood would stop me?!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113309,'You will bleed!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(113310,'The blood sustains me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113311,'I.. am not... defeated...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113319,'Silgryn nods.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113320,'Hurry up an\' finish blessin\' those bandages, we need to get them off to the front!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(113321,'Here they come! I could use a bit of help!','',0,0,0,0,0,0,1,0,0,0,64201,0,26124),
(113328,'','A gift, for me?',0,0,0,0,0,0,0,0,0,0,0,67591,26124),
(113337,'Work hard... beach easy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113338,'Superb casting! Get back to the Focus. I\'ll keep an eye out.','',0,0,0,0,0,0,1,0,0,0,64202,0,26124),
(113339,'The power is building. They will know we are doing something momentous. Another group incoming, assist me!','',0,0,0,0,0,0,0,0,0,0,64203,0,26124),
(113340,'This is a terrible turn of events...','',1,0,0,0,0,0,0,0,0,0,66486,0,26124),
(113341,'','We may have missed our chance at the Grand Magistrix tonight, but her time will come. Sooner or later we\'ll find another way to settle the score...',0,0,0,0,0,0,0,0,0,0,0,70194,26124),
(113342,'I must speak with the Council. Until we meet again, my mortal friend.','',1,0,0,0,0,0,0,0,0,0,66487,0,26124),
(113343,'No! He will not get away with this!','',1,0,0,0,0,0,0,0,0,0,67663,0,26124),
(113344,'It\'s painfully obvious that you could use someone of my considerable talent. Let us join forces to go after Vargoth and the Soulstone!','',1,0,0,0,0,0,0,0,0,0,67664,0,26124),
(113345,'Stick around... it\'s meal time!','',0,0,0,0,0,0,0,0,6,0,62188,0,26124),
(113346,'What\'s this? Another intruder approaches!','',0,0,0,0,0,0,0,0,6,0,62190,0,26124),
(113347,'That demon is Vadina, one of Valadors enforcers. I think we have his attention. Aid me!','',0,0,0,0,0,0,0,0,0,0,64204,0,26124),
(113348,'Did you really think your ploy would work? Come to me, little mage!','',0,0,0,0,0,0,0,0,0,0,64207,0,26124),
(113349,'I might be the baby, but at least I get all the attention!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(113350,'Quit picking on me!','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(113351,'Citizens in need of shelter are to report to the Trader\'s Hall at once.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113352,'The situation is under control. You are all completely safe.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113353,'These eggs are corrupted. We should destroy them now.','',0,0,0,0,0,0,396,0,0,0,62099,0,26124),
(113354,'There is more than one way to deal with a corruption.','',0,0,0,0,0,0,1,0,0,0,62100,0,26124),
(113355,'Guards! Guards!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(113356,'The guardians, they are awaking!','',0,0,0,0,0,0,1,0,0,0,62101,0,26124),
(113357,'Up ahead, I see the mages! They\'re surrounded by the Houndmaster\'s minions.','',0,0,0,0,0,0,25,0,0,0,66563,0,26124),
(113358,'Quickly, we must slaughter these beasts before they do more harm!','',0,0,0,0,0,0,1,0,0,0,66564,0,26124),
(113359,'We\'re never gonna make quota. Move faster you louts!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113360,'Shackle ain\'t gonna be happy if we ain\'t done soon! Hurry with the loading already!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113361,'Secure the entrance! We\'ve got the cultists right where we want them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113362,'You will not interfere with their feeding!','',0,0,0,0,0,0,396,0,0,0,66565,0,26124),
(113363,'My hounds are hungry, and your mages make quite the meal.','',0,0,0,0,0,0,396,0,0,0,66566,0,26124),
(113364,'Soon they will be strong enough to draw the magic out of every mage in Dalaran!','',0,0,0,0,0,0,396,0,0,0,66567,0,26124),
(113365,'Come, my pets. You will have plenty to feed on soon enough.','',0,0,0,0,0,0,396,0,0,0,66568,0,26124),
(113366,'My minions look forward to making a meal out of you, Archmage.','',0,0,0,0,0,0,396,0,0,0,66569,0,26124),
(113367,'Until we meet again.','',0,0,0,0,0,0,396,0,0,0,66570,0,26124),
(113368,'You can never know too much about your foe. These tomes and scrolls come directly from the Stormwind Library.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(113369,'Ay Muscle, you got company!','Ay Muscle, you got company!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113370,'Muscle gonna hurt dem good!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113371,'You won\'t get away with this, Hakkar!','',0,0,0,0,0,0,22,0,0,0,66571,0,26124),
(113372,'For your insolence, your end will be painful and slow!','',0,0,0,0,0,0,0,0,6,0,64208,0,26124),
(113373,'This display is meaningless! Your doom is at hand!','',0,0,0,0,0,0,0,0,6,0,64209,0,26124),
(113374,'You possess the might of an archmage! But I\'m not out of tricks yet...','',0,0,0,0,0,0,0,0,0,0,64211,0,26124),
(113375,'The Withered Leyhunter detects your presence!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113376,'Never again will you use Ebonchill to kill a mage, demon!','',0,0,0,0,0,0,0,0,0,0,64210,0,26124),
(113377,'The Withered Leyhunter has noticed you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113378,'Bah! I need no meager weapon to destroy you!','',0,0,0,0,0,0,0,0,0,0,64212,0,26124),
(113379,'Your world... will... fall...','',0,0,0,0,0,0,0,0,0,0,64213,0,26124),
(113380,'So it was that Huln\'s mercy gained the allegiance of his family\'s oldest ally: me.','',0,0,0,0,0,0,396,0,0,0,62102,0,26124),
(113381,'','Bal\'a dash, malanore.',0,0,0,0,0,0,0,0,0,0,0,63112,26124),
(113382,'','We stand together!',0,0,0,0,0,0,0,0,0,0,0,63117,26124),
(113383,'The portal is closing! Get out of there!','',0,0,0,0,0,0,0,0,0,0,64214,0,26124),
(113384,'','The Legion must be stopped!',0,0,0,0,0,0,0,0,0,0,0,63122,26124),
(113385,'Well done! Let\'s go before reinforcements arrive. I\'ll open a portal back to the hall.','',0,0,0,0,0,0,4,0,0,0,64215,0,26124),
(113386,'','Greetings.',0,0,0,0,0,0,0,0,0,0,0,63125,26124),
(113387,'','My bow is at the ready!',0,0,0,0,0,0,0,0,0,0,0,63128,26124),
(113388,'','Fight well!',0,0,0,0,0,0,0,0,0,0,0,63091,26124),
(113389,'','Al diel shala.',0,0,0,0,0,0,0,0,0,0,0,63096,26124),
(113390,'','Remember those we lost.',0,0,0,0,0,0,0,0,0,0,0,63101,26124),
(113391,'','Together we will save Azeroth!',0,0,0,0,0,0,0,0,0,0,0,63104,26124),
(113392,'','Until next time.',0,0,0,0,0,0,0,0,0,0,0,63107,26124),
(113393,'','Waste MY time? I don\'t think so!',0,0,0,0,0,0,0,0,0,0,0,63130,26124),
(113394,'Bal\'a dash, malanore.','',0,0,0,0,0,0,0,0,0,0,63108,0,26124),
(113395,'We must all do our duty.','',0,0,0,0,0,0,0,0,0,0,63113,0,26124),
(113396,'We serve the ranger-general.','',0,0,0,0,0,0,0,0,0,0,63118,0,26124),
(113397,'','They\'re rifling through my drawers- thieving rats! Please, recover my belongings.',0,0,0,0,0,0,0,0,0,0,0,66222,26124),
(113398,'','My robes! Ah, I\'ve missed these! I hope they still fit...',0,0,0,0,0,0,0,0,0,0,0,66223,26124),
(113399,'','Just in case the library does not survive Elisande\'s insanity, I\'ll keep an eye on these tomes.',0,0,0,0,0,0,0,0,0,0,0,66224,26124),
(113400,'','It would be best if they did not know who I was conversing with before.',0,0,0,0,0,0,0,0,0,0,0,66225,26124),
(113402,'We are living in troubled times.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(113403,'Are you ready to resume our search for the missing mages?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(113404,'Strive for peace, but be ready to fight!','',0,0,0,0,0,0,0,0,0,0,63087,0,26124),
(113405,'Victory will come.','',0,0,0,0,0,0,0,0,0,0,63092,0,26124),
(113406,'Good luck!','',0,0,0,0,0,0,0,0,0,0,63097,0,26124),
(113407,'','Ishnu-alah.',0,0,0,0,0,0,0,0,0,0,0,63109,26124),
(113408,'','Ishnu-dal-dieb.',0,0,0,0,0,0,0,0,0,0,0,63114,26124),
(113409,'','The Unseen Path welcomes you!',0,0,0,0,0,0,0,0,0,0,0,63119,26124),
(113410,'','Well met.',0,0,0,0,0,0,0,0,0,0,0,63123,26124),
(113411,'','The hour of battle is at hand!',0,0,0,0,0,0,0,0,0,0,0,63126,26124),
(113412,'','Take care!',0,0,0,0,0,0,0,0,0,0,0,63088,26124),
(113413,'','Thank you for your service.',0,0,0,0,0,0,0,0,0,0,0,63093,26124),
(113414,'','Our duty is to all of Azeroth.',0,0,0,0,0,0,0,0,0,0,0,63098,26124),
(113415,'','Ande\'thoras-ethil.',0,0,0,0,0,0,0,0,0,0,0,63102,26124),
(113416,'','May your weapon strike true!',0,0,0,0,0,0,0,0,0,0,0,63105,26124),
(113417,'','I haven\'t lived ten-thousand years to be pestered by you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113418,'Bal\'a dash, malanore.','',0,0,0,0,0,0,0,0,0,0,63111,0,26124),
(113419,'My bow skills are second to none!','',0,0,0,0,0,0,0,0,0,0,63116,0,26124),
(113420,'What is it?','',0,0,0,0,0,0,0,0,0,0,63121,0,26124),
(113421,'Let\'s get this war won!','',0,0,0,0,0,0,0,0,0,0,63090,0,26124),
(113422,'Challenge awaits!','',0,0,0,0,0,0,0,0,0,0,63095,0,26124),
(113423,'Aim true!','',0,0,0,0,0,0,0,0,0,0,63100,0,26124),
(113424,'Bal\'a dash, malanore.','',0,0,0,0,0,0,0,0,0,0,63110,0,26124),
(113425,'Brzzzzt!$B$BWelcome to Matrix Punchograph 3005 stroke E, a security level beta terminal.$B$BPrismatic punch card detected.  Access Granted.\n\n01010011 01110100 01100001 01101110 01100100 00100000 01100010 01100001 01100011 01101011 00100001 01010011 01110100 01100001 01101110 01100100 00100000 01100010 01100001 01100011 01101011 00100001','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(113426,'The Farstriders stand ready.','',0,0,0,0,0,0,0,0,0,0,63115,0,26124),
(113427,'For Silvermoon!','',0,0,0,0,0,0,0,0,0,0,63120,0,26124),
(113428,'Brzzzzt!$B$BWelcome to Matrix Punchograph 3005 stroke E, a security level beta terminal.$B$BYou must possess a prismatic punch card to access terminal functions.\n\n01001000 01110101 01101110 01110100 01100101 01110010 01110011 00100000 01101111 01101110 01101100 01111001 00100001','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(113429,'Ah, the Temple of Fal\'adora. Those halls once glowed with prayers to Elune.','',0,0,0,0,0,0,0,0,0,0,67537,0,26124),
(113430,'I imagine it is less hospitable now. Hold still, I will get you out of there.','',0,0,0,0,0,0,0,0,0,0,67538,0,26124),
(113431,'Alright, hold still. I will get you out of there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113432,'Greetings.','',0,0,0,0,0,0,0,0,0,0,63124,0,26124),
(113433,'I will do my duty for Azeroth.','',0,0,0,0,0,0,0,0,0,0,63127,0,26124),
(113434,'May victory be ours!','',0,0,0,0,0,0,0,0,0,0,63089,0,26124),
(113435,'Fight with courage!','',0,0,0,0,0,0,0,0,0,0,63094,0,26124),
(113436,'We must not falter!','',0,0,0,0,0,0,0,0,0,0,63099,0,26124),
(113437,'The Legion will fall!','',0,0,0,0,0,0,0,0,0,0,63103,0,26124),
(113438,'May the wind guide your arrows.','',0,0,0,0,0,0,0,0,0,0,63106,0,26124),
(113439,'Prismatic security card insertion successful.  Disabling security locks.\n\n01010111 01100001 01110011 00100000 01110100 01101000 01101001 01110011 00100000 01100001 01101100 01110111 01100001 01111001 01110011 00100000 01101100 01101111 01100011 01101011 01100101 01100100 00111111','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(113440,'Deactivate Security Measures','Deactivate Security Measures',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(113441,'You\'re more meddlesome than a banshee!','',0,0,0,0,0,0,0,0,0,0,63129,0,26124),
(113442,'','You\'ve done it! Guard it well until you can return to me.',0,0,0,0,0,0,0,0,0,0,0,66226,26124),
(113443,'','That dumb cow won\'t even see it coming... we\'ll be in charge of the fleet, once and for all!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113444,'The sea queen once forged an empire with magic. She has since turned to... a more shadowy benefactor.','',0,0,0,0,0,0,0,0,0,0,64113,0,26124),
(113445,'Queen Azshara... do not underestimate her grasp of the arcane. Or the devotion of her minions.','',0,0,0,0,0,0,0,0,0,0,64114,0,26124),
(113446,'The naga wield magics, yes, but without finesse. There was a time Azshara\'s people had the potential to rival the titans.','',0,0,0,0,0,0,0,0,0,0,64115,0,26124),
(113447,'The naga are trying to reclaim past glory amidst these ruins. They grovel for scraps. Show them what real power looks like.','',0,0,0,0,0,0,0,0,0,0,64116,0,26124),
(113448,'The dragonflights once reigned over this world in the titans\' stead. See how these creatures pick at the carcass of their greatness.','',0,0,0,0,0,0,0,0,0,0,64133,0,26124),
(113449,'Neltharion withheld many secrets from the other dragonflights. Some of them may be of interest to us, child.','',0,0,0,0,0,0,0,0,0,0,64134,0,26124),
(113450,'The titans imbued the great dragonflights with considerable power. The black dragonflight has been decimated. We should claim what power remains.','',0,0,0,0,0,0,0,0,0,0,64135,0,26124),
(113451,'The filth that occupy this place are an insult to the glory of a once proud dragonflight.','',0,0,0,0,0,0,0,0,0,0,64136,0,26124),
(113452,'This place is infused with the power of the arcane... can you feel it? So much power...','',0,0,0,0,0,0,0,0,0,0,64157,0,26124),
(113453,'The glories of an ancient empire remain. There is power here, child... you need only seize it!','',0,0,0,0,0,0,0,0,0,0,64158,0,26124),
(113454,'This city was built upon a matrix of mighty arcane energies. Ah, yes... power enough for us both...','',0,0,0,0,0,0,0,0,0,0,64159,0,26124),
(113455,'A splendid empire, ensorcelled by magic for thousands of years. Let us shatter these halls and drink deep from the ruins.','',0,0,0,0,0,0,0,0,0,0,64160,0,26124),
(113456,'Surely you see the futility of a council of mortals overseeing an arcane trove of this magnitude?','',0,0,0,0,0,0,0,0,0,0,64161,0,26124),
(113457,'For generations the mortal mages of Dalaran have sought to bury their fears within these walls. They are so weak, child.','',0,0,0,0,0,0,0,0,0,0,64162,0,26124),
(113458,'Your predecessor haunted these chambers for many years, child. Are you certain you want to dig up the past?','',0,0,0,0,0,0,0,0,0,0,64163,0,26124),
(113459,'I applaud your pursuit of knowledge, child. Your predecessor tried to wall in the darkness, but you, you are not afraid, hmm?','',0,0,0,0,0,0,0,0,0,0,64164,0,26124),
(113460,'In eons past, the titans used the language of the arcane to weave whole worlds into existence. The ability to move a city about is... insignificant.','',0,0,0,0,0,0,0,0,0,0,64101,0,26124),
(113461,'How small this city looks when placed aside the glory and splendor of Suramar.','',0,0,0,0,0,0,0,0,0,0,64102,0,26124),
(113462,'Lowly Dalaran. Where petty mortal politics preclude the acquisition of true power.','',0,0,0,0,0,0,0,0,0,0,64103,0,26124),
(113463,'It was magic that built this city, and magic that sustains it. Turn me loose, mage, and I will leech it dry...','',0,0,0,0,0,0,0,0,0,0,64104,0,26124),
(113464,'Even in intensive study, a mortal mage acquires so little knowledge in a lifetime. It\'s a wonder they even bother.','',0,0,0,0,0,0,0,0,0,0,64105,0,26124),
(113465,'Dalaran. The city endures even after generations of its mortal inhabitants die off.','',0,0,0,0,0,0,0,0,0,0,64106,0,26124),
(113466,'The mages of this city see it as the arcane focus of this world. How little they know, child.','',0,0,0,0,0,0,0,0,0,0,64107,0,26124),
(113467,'Despite the petty bickering of the mortals who lead it, this place is nonetheless a passable assembly of arcane knowledge.','',0,0,0,0,0,0,0,0,0,0,64108,0,26124),
(113468,'Ah, Dalaran. The city of spires perches itself once more between you mortals and the end of your world.','',0,0,0,0,0,0,0,0,0,0,64109,0,26124),
(113469,'My dear child, you hold yourself back. The power is within your grasp to send this entire city tumbling into the sea.','',0,0,0,0,0,0,0,0,0,0,64110,0,26124),
(113470,'For generations the mages of your world have trained in this city, like children playing with fire.','',0,0,0,0,0,0,0,0,0,0,64111,0,26124),
(113471,'The Kirin-Tor. Contemptable mortals groveling about for what meager scraps of power their tiny minds can comprehend.','',0,0,0,0,0,0,0,0,0,0,64112,0,26124),
(113472,'Pick Lock','Pick Lock',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113473,'I am... spent...','',0,0,0,0,0,0,0,0,0,0,64141,0,26124),
(113474,'I need more mana, child...','',0,0,0,0,0,0,0,0,0,0,64142,0,26124),
(113475,'My energy dwindles.','',0,0,0,0,0,0,0,0,0,0,64143,0,26124),
(113476,'You must pace yourself, child.','',0,0,0,0,0,0,0,0,0,0,64144,0,26124),
(113477,'You spend your energies frivolously...','',0,0,0,0,0,0,0,0,0,0,64145,0,26124),
(113478,'I have mixed feelings about returning here. Perhaps one day, the temple can be restored.\n\nFor now though, let\'s convince Akama to join us and return to the Fel Hammer.\n\nWe\'re ready when you are, $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113479,'You lack the mana to continue, child.','',0,0,0,0,0,0,0,0,0,0,64146,0,26124),
(113480,'I must... recuperate my energies...','',0,0,0,0,0,0,0,0,0,0,64147,0,26124),
(113481,'Mana... you need more mana...','',0,0,0,0,0,0,0,0,0,0,64148,0,26124),
(113482,'Your frail frame cannot maintain this pace.','',0,0,0,0,0,0,0,0,0,0,64149,0,26124),
(113483,'We must recharge...','',0,0,0,0,0,0,0,0,0,0,64150,0,26124),
(113484,'Power, I must have... more power...','',0,0,0,0,0,0,0,0,0,0,64151,0,26124),
(113485,'Is that everything you have?','',0,0,0,0,0,0,0,0,0,0,64152,0,26124),
(113486,'Quite the tactician, are we?','',0,0,0,0,0,0,0,0,0,0,64117,0,26124),
(113487,'Our magic conceals us from prying eyes...','',0,0,0,0,0,0,0,0,0,0,64118,0,26124),
(113488,'Are you afraid to fight? Interesting.','',0,0,0,0,0,0,0,0,0,0,64119,0,26124),
(113489,'We all have our secrets, don\'t we?','',0,0,0,0,0,0,0,0,0,0,64120,0,26124),
(113490,'I find your constant need for sustenance bemusing.','',0,0,0,0,0,0,0,0,0,0,64097,0,26124),
(113491,'Your allies are too dependent on you. Let them starve.','',0,0,0,0,0,0,0,0,0,0,64098,0,26124),
(113492,'Your considerable talents are wasted on... pudding.','',0,0,0,0,0,0,0,0,0,0,64099,0,26124),
(113493,'The very powers of the ancient titans are at your command, and you choose to create... tasty treats?','',0,0,0,0,0,0,0,0,0,0,64100,0,26124),
(113494,'This spell is ours, now.','',0,0,0,0,0,0,0,0,0,0,64153,0,26124),
(113495,'A very tactical move, my child. You are learning.','',0,0,0,0,0,0,0,0,0,0,64154,0,26124),
(113496,'Oh, very good. Well done.','',0,0,0,0,0,0,0,0,0,0,64155,0,26124),
(113497,'Your enemies are foolish to use such trifling magics against you.','',0,0,0,0,0,0,0,0,0,0,64156,0,26124),
(113498,'Bah. Let them walk.','',0,0,0,0,0,0,0,0,0,0,64137,0,26124),
(113499,'You waste precious energy poking holes in reality for these clumsy sword-swinging brutes.','',0,0,0,0,0,0,0,0,0,0,64138,0,26124),
(113500,'Have you ever considered opening portals to other worlds? Such power is within your grasp, child...','',0,0,0,0,0,0,0,0,0,0,64139,0,26124),
(113501,'','The rats locked themselves inside. We need to make them tell us where their leader is hiding.',0,0,0,0,0,0,1,0,0,0,0,63572,26124),
(113502,'Realm to realm we go... We reap and reap but do not sow...','',0,0,0,0,0,0,0,0,0,0,64140,0,26124),
(113503,'I will not be contained!','',0,0,0,0,0,0,0,0,0,0,64079,0,26124),
(113504,'My essence will not be controlled again!','',0,0,0,0,0,0,0,0,0,0,64080,0,26124),
(113505,'I will not succumb to your paltry magics!','',0,0,0,0,0,0,0,0,0,0,64081,0,26124),
(113506,'You are not as powerful as she who came before. You cannot succeed!','',0,0,0,0,0,0,0,0,0,0,64082,0,26124),
(113507,'I am infinite.','',0,0,0,0,0,0,0,0,0,0,64083,0,26124),
(113508,'No mere mortal can grasp the wisdom of Aluneth!','',0,0,0,0,0,0,0,0,0,0,64084,0,26124),
(113509,'[Scream of frustration]','',0,0,0,0,0,0,0,0,0,0,64075,0,26124),
(113510,'You fancy yourself as worthy to wield me as the previous \"Guardian?\" You are but a child to me.','',0,0,0,0,0,0,0,0,0,0,64076,0,26124),
(113511,'You foolishly think you can control this power. So be it.','',0,0,0,0,0,0,0,0,0,0,64077,0,26124),
(113512,'Come, child. Let us wreak havoc upon your foes, and I shall see what you are made of.','',0,0,0,0,0,0,0,0,0,0,64078,0,26124),
(113513,'Let\'s get up there, Altruis. It\'s time to convince Akama to join us.','Let\'s get up there, Altruis. It\'s time to convince Akama to join us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113514,'Welcome flesh-bag!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113515,'It is good to be back, even if only for a brief time. Perhaps one day, we will retake the temple for the Illidari.\n\nFor now though, let us see if we can convince Akama to join us... or else.\n\nWe are ready when you are, $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113516,'Remember, we are here to convince Akama to join us by any means necessary.','',0,0,0,0,0,0,0,0,0,0,66859,0,26124),
(113517,'Release the hounds!','',0,0,0,0,0,0,0,0,0,0,62345,0,26124),
(113518,'Incinerate them!','',0,0,0,0,0,0,0,0,0,0,62358,0,26124),
(113519,'Fight! Fight, you pathetic imps!','',0,0,0,0,0,0,0,0,0,0,62359,0,26124),
(113520,'Burn them down!','',0,0,0,0,0,0,0,0,0,0,62360,0,26124),
(113521,'Gnaw them to the bone!','',0,0,0,0,0,0,0,0,0,0,62346,0,26124),
(113522,'Rip them apart!','',0,0,0,0,0,0,0,0,0,0,62347,0,26124),
(113523,'Yes! This one will serve us well!','',0,0,0,0,0,0,0,0,0,0,62336,0,26124),
(113524,'Bow to your new masters!','',0,0,0,0,0,0,0,0,0,0,62337,0,26124),
(113525,'All shall serve!','',0,0,0,0,0,0,0,0,0,0,62338,0,26124),
(113526,'Nice to see I\'m not the only dismembered body part around here.','',0,0,0,0,0,0,0,0,0,0,62339,0,26124),
(113527,'','This is the last time you disturb our work. Kill them!',0,0,0,0,0,0,25,0,0,0,0,63582,26124),
(113528,'','Fine! Killing you myself will earn me a greater place in the new order.',0,0,0,0,0,0,1,0,0,0,0,63583,26124),
(113529,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113530,'By our blades!','By our blades!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113531,'Those demons should think twice before coming to OUR lands!','Those demons should think twice before coming to OUR lands!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113532,'For the Warchief!','For the Warchief!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113533,'Blood and Honor!','Blood and Honor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113534,'One Horde!','One Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113535,'Malevolence, make sure no one gets through that door.','',0,0,0,0,0,0,0,0,0,0,66993,0,26124),
(113536,'Malevolence, make certain that no one gets through that door.','',0,0,0,0,0,0,0,0,0,0,66887,0,26124),
(113537,'If we can\'t go over, then we will have to go through. Open it.','',0,0,0,0,0,0,0,0,0,0,66851,0,26124),
(113538,'If we cannot go over, we will go through. Get it open.','',0,0,0,0,0,0,0,0,0,0,66852,0,26124),
(113540,'I am in agreement. If he keeps this civil, then so shall we.','I am in agreement. If he keeps this civil, then so shall we.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113542,'I hear you, Kayn. Hopefully, he will listen to reason. If not...','I hear you, Kayn. Hopefully, he will listen to reason. If not...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113543,'I see you will not be deterred. Come then, Illidari. Face your destiny.','',0,0,0,0,0,0,0,0,0,0,66891,0,26124),
(113544,'Even here, I have heard your name spoken, $p. But, I am not impressed.','',0,0,0,0,0,0,0,0,0,0,66892,0,26124),
(113545,'Let us see if I can impress you.','',0,0,0,0,0,0,0,0,0,0,66893,0,26124),
(113546,'Shall we finish this like beings of honor? Can you manage that much, demon hunter?','',0,0,0,0,0,0,0,0,0,0,66894,0,26124),
(113547,'You have beaten me with honor. Perhaps I have misjudged you, demon hunter.\n\nIt will take some time before there is full trust between us. However, like you, I wish to see the Burning Legion\'s downfall.\n\nThey destroyed my beautiful temple. I will have my revenge.\n\nToward that goal, I will aid you, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113548,'I will never aid you, demon hunter. Like all your kind, you are no better than the demons, which you consort with. I see no difference between you.\n\nThe Legion and your master destroyed my beautiful temple. Trust me when I say that one day, I will have my revenge.\n\nYou can go twist in the Nether, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113549,'Then rise and join us, Akama.','Then rise and join us, Akama.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113550,'Then, you leave me no choice, Akama. One way, or another, you WILL help us to defeat the Legion.','Then, you leave me no choice, Akama. One way, or another, you WILL help us to defeat the Legion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113551,'Akama, think! You know I opposed Illidan. You can trust us.','',0,0,0,0,0,0,0,0,0,0,66895,0,26124),
(113552,'Perhaps you are right. It seems that times have changed and with it, the Illidari. I will aid you.','',0,0,0,0,0,0,0,0,0,0,66989,0,26124),
(113553,'Kill that mongrel, $p! No... wait. I have a better idea.','',0,0,0,0,0,0,0,0,0,0,66896,0,26124),
(113554,'Matron mother, please come up here. We are returning to the Fel Hammer.','',0,0,0,0,0,0,0,0,0,0,66897,0,26124),
(113555,'','Of course, my dear. One gateway coming up.',0,0,0,0,0,0,0,0,0,0,0,66886,26124),
(113556,'Just kill me and be done with it.','',0,0,0,0,0,0,0,0,0,0,66898,0,26124),
(113557,'Oh, I think not. Allari, do what you do best.','',0,0,0,0,0,0,0,0,0,0,66899,0,26124),
(113558,'','It will be my pleasure.',0,0,0,0,0,0,0,0,0,0,0,66900,26124),
(113559,'I live again!','',0,0,0,0,0,0,0,0,0,0,66901,0,26124),
(113560,'Matron mother, get up here. We are returning to the Fel Hammer.','',0,0,0,0,0,0,0,0,0,0,66902,0,26124),
(113561,'The Tormenting Orb stares at all players inquisitively.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113562,'','Where is the herald? Speak!',0,0,0,0,0,0,0,0,0,0,0,63573,26124),
(113563,'','You seek to delay the inevitable. The Legion will wash over this world!',0,0,0,0,0,0,0,0,0,0,0,63574,26124),
(113564,'','Is that the best you can do? You are weak indeed!',0,0,0,0,0,0,0,0,0,0,0,63575,26124),
(113565,'','So be it. Let\'s see how you handle the Kingsbane poison!',0,0,0,0,0,0,0,0,0,0,0,63576,26124),
(113566,'','Do what you will. I give my life to the Hand!',0,0,0,0,0,0,0,0,0,0,0,63577,26124),
(113567,'','What is... happening... my veins... are on fire...!',0,0,0,0,0,0,0,0,0,0,0,63578,26124),
(113568,'','Please... no more! I\'ll tell you everything! Just make it stop!',0,0,0,0,0,0,0,0,0,0,0,63579,26124),
(113569,'','Where is the Herald? Speak, miserable worm!',0,0,0,0,0,0,0,0,0,0,0,63580,26124),
(113570,'','He lies... in the keep...',0,0,0,0,0,0,0,0,0,0,0,63581,26124),
(113571,'','The keep will be heavily guarded. We should split up. At least one of us has to make it to the Herald alive.',0,0,0,0,0,0,1,0,0,0,0,63584,26124),
(113572,'','We don\'t have much time. Get moving!',0,0,0,0,0,0,1,0,0,0,0,63585,26124),
(113573,'Already planning to run away?','',0,0,0,0,0,0,0,0,0,0,62333,0,26124),
(113574,'Always have an escape planned. A lesson I learned the hard way!','',0,0,0,0,0,0,0,0,0,0,62334,0,26124),
(113575,'And what did you have in mind for THAT?','',0,0,0,0,0,0,0,0,0,0,62335,0,26124),
(113576,'Foolish orc! You will be the first to witness the Legion\'s arrival into my city.','',0,0,0,0,0,0,0,0,6,0,63587,0,26124),
(113577,'Long have I waited for this day. Let us not waste another moment!','',0,0,0,0,0,0,0,0,6,0,63588,0,26124),
(113578,'Ered\'nash ila mornu nakuun. Ered\'nash ban man\'ari!','',0,0,0,0,0,0,0,0,6,0,63589,0,26124),
(113579,'I can feel their curse weakening! You must stop them from interfering with the rite!','',0,0,0,0,0,0,0,0,0,0,70424,0,26124),
(113580,'It is done! You rotten Bonespeaker dogs cannot deny my place in the Halls of Valor any longer!','',0,0,0,0,0,0,0,0,0,0,70425,0,26124),
(113581,'Stromgarde is mine at last! You are fools if you think I\'ll let my father have it back!','',0,0,0,0,0,0,274,0,0,0,69395,0,26124),
(113582,'Guards! Seize them!','',0,0,0,0,0,0,0,0,0,0,69396,0,26124),
(113583,'Legion reinforcements! Show them no mercy!','',0,0,0,0,0,0,22,0,0,0,75597,0,26124),
(113584,'Northern tower\'s swarming with demon filth! They\'re everywhere!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(113585,'Structure to the east of Crossroads! There\'s demons everywhere!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113586,'Structure! East of Crossroads! Get out here!','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(113587,'Road to the east of Crossroads! Some kind of structure! It came out of nowhere!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113588,'Southeast of us at the Crossroads! A structure formed from nothing!','Southeast of us at the Crossroads! A structure formed from nothing!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(113589,'Southeast of Crossroads! Another structure! What foul magic is this?','Southeast of Crossroads! Another structure! What foul magic is this?',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(113590,'Structure to the southeast! We\'ll hold Crossroads as long as we can. Get out there and get rid of those things!','Structure to the southeast! We\'ll hold Crossroads as long as we can. Get out there and get rid of those things!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(113591,'My patience has worn thin as well. Let\'s find the prince and be done with this.','',0,0,0,0,0,0,1,0,0,0,69397,0,26124),
(113592,'They\'ve spread to the west! Multiple camps! These things think they can take us down? Hah!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113593,'Camps to the west! These demons are relentless! Show them your strength!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113594,'Treachery! I will bury my axe in the coward\'s skull!','',0,0,0,0,0,0,0,0,0,0,79165,0,26124),
(113595,'Foul demons! We\'re under siege to the west! Send reinforcements!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113596,'Takin\' quite a beatin\' down at Ratchet! A little backup wouldn\'t hurt!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113597,'Me and my boys are holdin\' \'em off down at Ratchet, but, uh... feel free to send us a little backup!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113598,'Ratchet\'s gettin\' bombarded over here! Make sure ya target the ugly ones and not us good lookin\' folk, would ya?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113599,'','Dat one had it comin\'.',0,0,0,0,0,0,0,0,0,0,0,66791,26124),
(113600,'','One less enemy to worry about.',0,0,0,0,0,0,0,0,0,0,0,66792,26124),
(113601,'','Well fought, hero.',0,0,0,0,0,0,0,0,0,0,0,66793,26124),
(113602,'','Impressive.',0,0,0,0,0,0,0,0,0,0,0,66794,26124),
(113603,'Foul demons! They\'ve taken control our forces to the far east! Looks like they\'re pushing for Orgrimmar!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(113604,'You need help to complete a summoning ritual? You can\'t do it by yourself? How pathetic!','',0,0,0,0,0,0,0,0,0,0,62342,0,26124),
(113605,'They\'ve taken out our reinforcements to the far east! We\'re holding them at the bridge!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(113606,'Huge camp down along the east! We need reinforcements! We\'re being overrun!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(113607,'Structures scouted far north! Getting hit pretty hard up here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113608,'Looks like they\'re pushing towards Ashenvale! Our allies are under attack!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113609,'South of Ashenvale! There\'s demons everywhere! Get up here before they spread!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113610,'','The Pearl isss mine!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(113611,'My name is... Error: Cannot Locate Data... Hmm, Seems I need a name.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113612,'Oh, you\'ve come here in search of a companion. Very well, I will join you, hunter.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113613,'However, this process may trigger my defensive protocols. So I may poke you in the eye. Just giving you a little warning.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113614,'','Creature a\' da Nightmare, be gone!',0,0,0,0,0,0,0,0,0,0,0,66795,26124),
(113615,'','Another vile creature defeated.',0,0,0,0,0,0,0,0,0,0,0,66796,26124),
(113616,'We work well together, hero!','',0,0,0,0,0,0,0,0,0,0,66789,0,26124),
(113617,'That one wasn\'t so tough.','',0,0,0,0,0,0,0,0,0,0,66797,0,26124),
(113618,'Another victory!','',0,0,0,0,0,0,0,0,0,0,66798,0,26124),
(113619,'Good work. Stay strong!','',0,0,0,0,0,0,0,0,0,0,66799,0,26124),
(113620,'Well done. Let us fight on!','',0,0,0,0,0,0,0,0,0,0,66800,0,26124),
(113621,'That one didn\'t stand a chance.','',0,0,0,0,0,0,0,0,0,0,66801,0,26124),
(113622,'','He wasn\'t very nice!',0,0,0,0,0,0,0,0,0,0,0,66802,26124),
(113623,'','That\'s what you get for being a bully!',0,0,0,0,0,0,0,0,0,0,0,66803,26124),
(113624,'','We sure showed him!',0,0,0,0,0,0,0,0,0,0,0,66780,26124),
(113625,'','We did it!',0,0,0,0,0,0,0,0,0,0,0,66781,26124),
(113626,'','This is kind of fun!',0,0,0,0,0,0,0,0,0,0,0,66782,26124),
(113627,'','The Dream is a little safer now.',0,0,0,0,0,0,0,0,0,0,0,66783,26124),
(113628,'','Together, we can defeat the Nightmare.',0,0,0,0,0,0,0,0,0,0,0,66811,26124),
(113629,'','Another enemy vanquished.',0,0,0,0,0,0,0,0,0,0,0,66784,26124),
(113630,'','The vale is a little safer now.',0,0,0,0,0,0,0,0,0,0,0,66785,26124),
(113631,'','Very impressive, druid.',0,0,0,0,0,0,0,0,0,0,0,66786,26124),
(113632,'','Stay valiant, hero. There is still more to come.',0,0,0,0,0,0,0,0,0,0,0,66787,26124),
(113633,'','Well fought, hero.',0,0,0,0,0,0,0,0,0,0,0,66788,26124),
(113634,'Some so-called salvage team is ransacking Azsuna\'s coastline, working on behalf of Mr. Shackle.','',0,0,0,0,0,0,0,0,0,0,70965,0,26124),
(113635,'Just because Shackle is useful in some places doesn\'t mean I have to tolerate this. Show them that piracy doesn\'t pay here in Azsuna!','',0,0,0,0,0,0,0,0,0,0,70964,0,26124),
(113636,'Without vigilance and quick action, Shackle\'s lackeys will strip Azsuna\'s coast of its history and its valuables. They\'ll be back, and I suspect you\'ll be ready.','',0,0,0,0,0,0,0,0,0,0,70963,0,26124),
(113637,'My spies have brought me information suggesting many key leaders of Mr. Shackle\'s so-called salvage fleet are vulnerable.','',0,0,0,0,0,0,0,0,0,0,70962,0,26124),
(113638,'Strike at their leaders, and leave these pirates in disarray!','',0,0,0,0,0,0,0,0,0,0,70961,0,26124),
(113639,'Gruesome work, but done well. Our southern coast is safer, for now.','',0,0,0,0,0,0,0,0,0,0,70960,0,26124),
(113640,'Back when I had a body, I never needed help with this ritual. I was a summoner without peer!','',0,0,0,0,0,0,0,0,0,0,62343,0,26124),
(113641,'Seeking a creature from the Twisting Nether? Grabbing a beast of the Void? Oh... you\'re just summoning a friend...','',0,0,0,0,0,0,0,0,0,0,62344,0,26124),
(113642,'Can you tell me your story?','Can you tell me your story?',0,0,0,0,0,0,0,0,0,37625,0,0,26124),
(113643,'I appreciate the words, $n, but I\'ll come back when this blows over.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113644,'They come!','',0,0,0,0,0,0,0,0,6,0,63590,0,26124),
(113645,'These foolish vrykul cling to the notion that the titans will someday return.','',0,0,0,0,0,0,0,0,0,0,62370,0,26124),
(113646,'This land may look pure, but even here I sense the Legion\'s presence.','',0,0,0,0,0,0,0,0,0,0,62371,0,26124),
(113647,'I\'m in over my head! Be back in business soon as this thing blows over!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113648,'The vrykul here believe themselves to be warriors without peer. I will show them the error of their ways!','',0,0,0,0,0,0,0,0,0,0,62373,0,26124),
(113650,'Now let\'s get things organized, shall we? We\'ve a lot of work to do!','',0,0,0,0,0,0,4,0,0,0,64216,0,26124),
(113651,'These vrykul are not as easy to destroy as you might think.','',0,0,0,0,0,0,0,0,0,0,62372,0,26124),
(113652,'This passage will lead us out.','',0,0,0,0,0,0,0,0,0,0,67534,0,26124),
(113653,'I can\'t wait to see these hills go up in flames!','',0,0,0,0,0,0,0,0,0,0,62374,0,26124),
(113654,'Not far now.','',0,0,0,0,0,0,0,0,0,0,67535,0,26124),
(113655,'I know you have been rebuilding the old teleporters. The beacon here will connect us to your shal\'dorei friends.','',0,0,0,0,0,0,0,0,0,0,67536,0,26124),
(113656,'','Selia, Master of Balefire, come forth and we will end your torment!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(113657,'|TInterface\\Icons\\ability_ironmaidens_bloodritual:20|t Lucard begins to |cFFFF0404|Hspell:215000|h[Consume the Living]|h|r! Slay the corsair quickly!','|TInterface\\Icons\\ability_ironmaidens_bloodritual:20|t Lucard begins to |cFFFF0404|Hspell:215000|h[Consume the Living]|h|r! Slay the corsair quickly!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113658,'Boy. I sure picked the wrong day to be out here!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113659,'What was I thinking comin\' down here?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113660,'This isn\'t quite what I expected! Now if you\'ll excuse me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113661,'What the heck is goin\' on around here?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113662,'','I can feel her... Selia, the Master of Balefire. She stirs!',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(113663,'The inhabitants of Gadgetzan have been inspired to join the fight against the Legion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113664,'','Unfortunately I\'m not much of a fighter. Be safe out there!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113668,'The Eredar, one-time Draenei that fell under the control of the demon lord Sargeras. Skilled sorcerers in both fel and shadow magics, adjust your wards accordingly. Often in command of contingents of demon forces, they are both a high threat and an excellent target of opportunity.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(113669,'A new breed of felguard, the fel lord towers over his lesser minions and often wields a massive, yet slow, weapon. Should you find yourself facing one alone, I would suggest a tactical retreat.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(113670,'We don\'t yet know much about this new breed of demon that we have taken to calling the \"imp mother.\" Limited reports indicate that her stomach may operate as a kind of portal from which imps emerge. Use caution, we\'re not sure what you\'re up against here.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(113671,'The dreaded infernal, siege weapon of the Legion. Expect these brutes to be hammering down your defenses with blazing fists made of fel fire and stone. They will often arrive on the battlefield as meteors launched from afar, then unfurl themselves to cause further devastation.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(113672,'The dreadlord, perhaps most insidious of all of the Legion forces. Capable of bending minds to their will, they will turn half of your army against you before you\'ve even seen one. Take note of their shadowy magics and control over carrion insects, and steel yourself against their frightening illusions.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(113673,'Sorry, bub. I\'m on watch. Somebody\'s gotta remind this demon filth who they\'re messin\' with!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113674,'The pit lord is a massive, terrifying behemoth, don\'t expect to face one with much less than an army and come out alive. Capable of rending a man in two with a single glaive swing, and burning half of a squad to a crisp with fel energy, they are a threat at any distance.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(113675,'Ain\'t everyday I get to bring out the ol\' secret weapons!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113676,'Normally I\'m pretty nice guy, but if you block my shot we\'re gonna have some words, friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113677,'Small? Whad\'ya mean, small?$B$BAlright, $n. We\'ll see who cleans this place up the most.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113678,'If you take \'em down don\'t forget their weapons! Those\'ll fetch a pretty penny.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113679,'You\'re lookin\' a bit lost, friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113680,'When this is all over, don\'t forget your free - or slightly discounted - Noggenfoggers!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113681,'This doesn\'t look like a place you belong, friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113682,'When this is all over, remind me to take out some more insurance on this place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113683,'Show this one the exit, boys!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113684,'I\'m sure more backup will be arriving shortly. I\'ve got friends in the highest of places.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113685,'East over the water! Looks like the Legion\'s back for more! Positions! Hurry up!','',0,0,0,0,0,0,22,0,0,0,64730,0,26124),
(113686,'Ready up! I\'ve got a bad feeling about this!','',0,0,0,0,0,0,22,0,0,0,64739,0,26124),
(113687,'You are too late, assassin.','',0,0,0,0,0,0,0,0,0,0,63592,0,26124),
(113688,'Quickly, you must plant the seed!','',0,0,0,0,0,0,0,0,0,0,67526,0,26124),
(113689,'Place it here, where it can drink of the leyline.','',0,0,0,0,0,0,0,0,0,0,67527,0,26124),
(113690,'A fledgling felhound rushes into the cave, lured by the scent of magic.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113691,'I have seen the beautiful gifts they bring. You do not understand!','',0,0,0,0,0,0,0,0,0,0,63593,0,26124),
(113692,'They have arrived! Oh, they are even more beautiful than I imagined!','',0,0,0,0,0,0,0,0,0,0,63594,0,26124),
(113693,'Do you not see? Can you not feel their warm embrace?','',0,0,0,0,0,0,0,0,0,0,63595,0,26124),
(113694,'Master, your servant requires aid!','',0,0,0,0,0,0,0,0,0,0,63596,0,26124),
(113695,'My plans will not be ruined. My destiny will not be denied. You will burn!','',0,0,0,0,0,0,0,0,0,0,63597,0,26124),
(113696,'M-master...?','',0,0,0,0,0,0,0,0,0,0,63598,0,26124),
(113697,'Mrglrgr! Mrlgrlr mrlgrl grlrglr. Mrglrgrl?','',0,0,0,0,0,0,0,0,0,0,416,0,26124),
(113698,'','Good. Our work is done.',0,0,0,0,0,0,1,0,0,0,0,63599,26124),
(113699,'','Being in this palace with these daggers brings back... dark thoughts. Impulses I\'ve spent years trying to be free of.',0,0,0,0,0,0,1,0,0,0,0,63600,26124),
(113700,'','Take the blades. You\'ve more than proven your skill as an assassin. Perhaps you can overcome the darkness within their steel.',0,0,0,0,0,0,1,0,0,0,0,63601,26124),
(113701,'Pearlhunter Phin\'s jaw drops as it stares at you, bewildered.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113702,'Pearlhunter Phin hops around in frustration.','',0,0,0,0,0,0,35,0,0,0,0,0,26124),
(113703,'Pearlhunter Phin\'s eyes roll back in its head as it sighs heavily.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113704,'Pearlhunter Phin excitedly grabs the sand and begins scrubbing the flaw on the pearl.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113705,'<Show Phin the crab shell.>','<Show Phin the crab shell.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113706,'Looks like they\'re getting stronger! None of you better be feeding those things!','',0,0,0,0,0,0,22,0,0,0,64782,0,26124),
(113707,'','Quin\'el was the Master of Chillwind. Just being near her sent a shiver up my spine. Be prepared!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113708,'','Quin\'el, Master of Chillwind, come forth! We will end your eternal suffering!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(113709,'','Coura was the resident Master of Arcana. She crafted spells as easily as you breathe air.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113710,'','She is upon us! Coura, Master of Arcana, we will bring you to eternal rest!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(113711,'<Show Phin the crab oil.>','<Show Phin the crab oil.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113712,'<Show Phin the crab claw.>','<Show Phin the crab claw.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113713,'<Show Phin the fine sand.>','<Show Phin the fine sand.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113714,'The doomguard, commanders of the front-line forces. An excellent target of opportunity that will cripple the enemy\'s line. Be wary of fire magics and dark curses, as well as their capable strikes in melee.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(113715,'','It is my duty to convey you to the Halls of Valor. Speak to me when you are ready!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113716,'While a cave wouldn\'t be my first choice of setting up a camp, it does keep us from drawing any unwanted attention to ourselves.$b$bShall we get to work now?','',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(113717,'','You\'re just in time... We were about to call forth one of this temple\'s most tortured souls, in the hopes of finally ending her misery.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113718,'I returned in disgrace and sought to wash away my failure in the blood of others.','',0,0,0,0,0,0,1,0,4,0,63288,0,26124),
(113719,'','Behold, Suramar. Our haven. Our sanctuary.',0,0,0,0,0,0,0,0,6,0,0,67559,26124),
(113720,'There I found the shrine to Tyr\'s champion, but was denied entry. I tried many times, until I could bear the pain no longer.','',0,0,0,0,0,0,1,0,4,0,63287,0,26124),
(113721,'How are you doing?','',0,0,0,0,0,0,0,0,0,0,62942,0,26124),
(113722,'Hello!','',0,0,0,0,0,0,0,0,0,0,62943,0,26124),
(113723,'','I can\'t perform any tests if I\'m lacking a subject.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(113724,'Greetings.','',0,0,0,0,0,0,0,0,0,0,62944,0,26124),
(113725,'See you around.','',0,0,0,0,0,0,0,0,0,0,62939,0,26124),
(113726,'Fare well to ye.','',0,0,0,0,0,0,0,0,0,0,62940,0,26124),
(113727,'Goodbye.','',0,0,0,0,0,0,0,0,0,0,62941,0,26124),
(113728,'I greet you.','',0,0,0,0,0,0,0,0,0,0,62957,0,26124),
(113729,'I bid you welcome.','',0,0,0,0,0,0,0,0,0,0,62958,0,26124),
(113730,'Greetings, friend.','',0,0,0,0,0,0,0,0,0,0,62959,0,26124),
(113731,'Another time then.','',0,0,0,0,0,0,0,0,0,0,62954,0,26124),
(113732,'We will meet again.','',0,0,0,0,0,0,0,0,0,0,62955,0,26124),
(113733,'Goodbye.','',0,0,0,0,0,0,0,0,0,0,62956,0,26124),
(113734,'Hail, seeker of truth.','',0,0,0,0,0,0,0,0,0,0,63034,0,26124),
(113735,'You are shorter than I expected.','',0,0,0,0,0,0,0,0,0,0,63035,0,26124),
(113736,'Let us talk.','',0,0,0,0,0,0,0,0,0,0,63036,0,26124),
(113737,'Hmmph.','',0,0,0,0,0,0,0,0,0,0,63033,0,26124),
(113738,'A good start! You fight well!','',0,0,0,0,0,0,0,0,6,0,63308,0,26124),
(113739,'I have not faced so noble a challenger in millenia!','',0,0,0,0,0,0,0,0,0,0,63307,0,26124),
(113740,'Mrlgrrl, rglrlg rlgrlmgmlr?\n\n<Phin looks at you expectantly.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113741,'','There! A bit of magic to help you follow in Galford\'s footsteps. Good luck!',0,0,0,0,0,0,0,0,0,0,0,63347,26124),
(113742,'For Tyr.','',0,0,0,0,0,0,0,0,0,0,62984,0,26124),
(113743,'Greetings.','',0,0,0,0,0,0,0,0,0,0,62985,0,26124),
(113744,'Well met.','',0,0,0,0,0,0,0,0,0,0,62986,0,26124),
(113745,'May Tyr guide you.','',0,0,0,0,0,0,0,0,0,0,62981,0,26124),
(113746,'Goodbye.','',0,0,0,0,0,0,0,0,0,0,62982,0,26124),
(113747,'Until we meet again.','',0,0,0,0,0,0,0,0,0,0,62983,0,26124),
(113748,'','Hello there.',0,0,0,0,0,0,0,0,0,0,0,62896,26124),
(113749,'','Blue is best!',0,0,0,0,0,0,0,0,0,0,0,62897,26124),
(113750,'','What brings you out here?',0,0,0,0,0,0,0,0,0,0,0,62898,26124),
(113751,'','Alright then.',0,0,0,0,0,0,0,0,0,0,0,62893,26124),
(113752,'','See you around.',0,0,0,0,0,0,0,0,0,0,0,62894,26124),
(113753,'','I should get back to it.',0,0,0,0,0,0,0,0,0,0,0,62895,26124),
(113754,'','Our prison.',0,0,0,0,0,0,0,0,6,0,0,67560,26124),
(113755,'','Elisande and the Legion seek to bring us to heel. Through fear. Through hunger.',0,0,0,0,0,0,0,0,6,0,0,67561,26124),
(113756,'','Th-they need it more... I will be f-fine...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113757,'','S-so... hungry... mind is... slipping!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113758,'<He stares at you blankly.> You are not my brother.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113759,'There is never enough for the both of us... I choose to suffer over her.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113760,'I need more bait.','I need more bait.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113761,'','Use that bait wisely. I don\'t have many entrails left.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113762,'The felhound, a quick, wiry beast often seen in large packs. Each hound has two tendrils, ending in a sucker of sorts. Should they latch on to you, they will drain your power and, eventually, your life. Hit them before they hit you.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(113763,'We have only recently learned of this variant of the felhound, which we are calling the \"felstalker.\" Faster and more coordinated than their brethren, they are often seen hunting in packs and utilizing a crude form of pack communication. Avoid their bites, as they are laced with all sorts of foul magics.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(113764,'The lowly imp, a creature of felfire and trickery. Not a large threat alone, but often found in large groups which can quickly overwhelm your defenses from a distance.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(113765,'The wrathguard, elite warriors of the Legion\'s front lines. Often seen wielding two weapons with equal measure, avoid letting them get the upper hand in swordplay, lest you face a rain of blows from which you will not emerge.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(113766,'Only ONE eye? Don\'t complain to me because you have no depth perception.','',0,0,0,0,0,0,0,0,0,0,62340,0,26124),
(113767,'Think you could summon me a body while you\'re at it?','',0,0,0,0,0,0,0,0,0,0,62341,0,26124),
(113768,'What a drab place! It would look far better covered in fire.','',0,0,0,0,0,0,0,0,0,0,62375,0,26124),
(113769,'','These vrykul should sing the praises of Sargeras, not their empty hymns to the titans.',0,0,0,0,0,0,0,0,0,0,0,62386,26124),
(113770,'','I am glad to see you.',0,0,0,0,0,0,0,0,0,0,0,62794,26124),
(113771,'','Greetings.',0,0,0,0,0,0,0,0,0,0,0,62795,26124),
(113772,'','Hello.',0,0,0,0,0,0,0,0,0,0,0,62796,26124),
(113773,'','Goodbye.',0,0,0,0,0,0,0,0,0,0,0,62791,26124),
(113774,'','Hunt well.',0,0,0,0,0,0,0,0,0,0,0,62792,26124),
(113775,'','Sun and Moon light your path.',0,0,0,0,0,0,0,0,0,0,0,62793,26124),
(113776,'','I can\'t wait to charm one of those big, muscular vrykul!',0,0,0,0,0,0,0,0,0,0,0,62377,26124),
(113777,'Do not fear me, hero.','',0,0,0,0,0,0,0,0,0,0,62832,0,26124),
(113778,'Go with my thanks.','',0,0,0,0,0,0,0,0,0,0,62829,0,26124),
(113779,'A new land, primed for destruction!','',0,0,0,0,0,0,0,0,0,0,62378,0,26124),
(113780,'I sense a dark place near, touched by void.','',0,0,0,0,0,0,0,0,0,0,62379,0,26124),
(113781,'The felguard, front-line forces of the Legion. Almost always seen with heavy, two-handed weaponry. They are slow to strike, but hit quite hard, and are more agile than they look.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(113782,'I will hide in shadows no longer.','',0,0,0,0,0,0,0,0,0,0,62785,0,26124),
(113783,'How may I help you?','',0,0,0,0,0,0,1,0,0,0,62786,0,26124),
(113784,'We will accomplish much together.','',0,0,0,0,0,0,1,0,0,0,62787,0,26124),
(113785,'Until next time.','',0,0,0,0,0,0,1,0,0,0,62782,0,26124),
(113786,'Let us get to work.','',0,0,0,0,0,0,1,0,0,0,62783,0,26124),
(113787,'May Light and Shadow guide you.','',0,0,0,0,0,0,1,0,0,0,62784,0,26124),
(113788,'I wonder what would happen if you split someone into pure Light and pure Void. Interested in volunteering?','',0,0,0,0,0,0,1,0,0,0,62788,0,26124),
(113789,'What a beast! And a great catch to boot!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(113790,'Bored? I could arrange discourse with a Shadowfiend.','',0,0,0,0,0,0,1,0,0,0,62789,0,26124),
(113791,'You do know there\'s an invasion going on, right?','',0,0,0,0,0,0,1,0,0,0,62790,0,26124),
(113792,'You know, that lure on the top of it\'s head would make for a great fishing rod...','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(113793,'Yea, I know that may seem gross, but just look at it! Fish\'ll come flocking towards something like that.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113794,'Here, you take it. Give it to Marcia in Dalaran. She\'s great at turning things into fishing rods.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113795,'You can take my boat there to get back if you have no other means.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(113796,'Lower your weapons! We\'re not here to fight you.','',0,0,0,0,0,0,25,0,0,0,63602,0,26124),
(113797,'','Its just Calia now.',0,0,0,0,0,0,1,0,0,0,0,62811,26124),
(113798,'','How can I assist you?',0,0,0,0,0,0,1,0,0,0,0,62812,26124),
(113799,'The king was never in danger, but where my men failed to stop this cultist, you did not. That spares you from prison at the very least.','',0,0,0,0,0,0,1,0,0,0,63603,0,26124),
(113800,'Go.  Get out of my city before I change my mind.','',0,0,0,0,0,0,1,0,0,0,63604,0,26124),
(113802,'','I stand ready to help.',0,0,0,0,0,0,1,0,0,0,0,62813,26124),
(113803,'','Walk in the Light.',0,0,0,0,0,0,1,0,0,0,0,62808,26124),
(113804,'','Goodbye.',0,0,0,0,0,0,1,0,0,0,0,62809,26124),
(113805,'','Let\'s talk again soon.',0,0,0,0,0,0,1,0,0,0,0,62810,26124),
(113806,'','Sometime I miss the beautiful court of Lordaeron, and my father.',0,0,0,0,0,0,1,0,0,0,0,62814,26124),
(113807,'I don\'t like this place either!','',0,0,0,0,0,0,0,0,0,0,62380,0,26124),
(113808,'','I once hid in a muddy ditch for two days while slavering ghouls patrolled the area. Your prattle does not faze me.',0,0,0,0,0,0,1,0,0,0,0,62815,26124),
(113809,'','Terenas would have had you thrown out of here faster than he did Medivh.',0,0,0,0,0,0,1,0,0,0,0,62816,26124),
(113810,'AwardContributionPoints called','AwardContributionPoints called',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113811,'','These scales are unlike anything I\'ve seen.',0,0,0,0,0,0,1,0,0,0,0,66589,26124),
(113812,'','This demon has clearly been bred to be resistant to both magical and physical attacks.',0,0,0,0,0,0,1,0,0,0,0,66590,26124),
(113813,'This land is so... fresh. I can\'t sense any demonic corruption here. It\'s... revolting.','',0,0,0,0,0,0,0,0,0,0,62361,0,26124),
(113814,'Next illusion, please.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(113815,'Show them the next demon.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(113816,'Next demon.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(113817,'','Get up...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113818,'Take a drink, darling. You will feel better.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113819,'','Give me a moment to inspect this beast, and I can discover its weaknesses.',0,0,0,0,0,0,1,0,0,0,0,66588,26124),
(113820,'','But you need...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113821,'We will survive until tomorrow. Vanthir always takes care of us. You know that.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113822,'','Lunette nods and takes a drink.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113823,'','Much better. Thank you. Thank you so much.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113824,'Mommy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113825,'Those peaks stretch up to touch the firmament. What a delight it will be to watch them crumble!','',0,0,0,0,0,0,0,0,0,0,62362,0,26124),
(113826,'So many beasts in this land to slaughter!','',0,0,0,0,0,0,0,0,0,0,62363,0,26124),
(113827,'Can we leave this place? I... I\'m a bit afraid of heights...','',0,0,0,0,0,0,0,0,0,0,62364,0,26124),
(113828,'From this height, I can see everything!','',0,0,0,0,0,0,0,0,0,0,62365,0,26124),
(113829,'','I sense a powerful presence in this land, though not as strong as Lord Sargeras.',0,0,0,0,0,0,0,0,0,0,0,69306,26124),
(113830,'There, there, old friend. We will figure this out...','',1,0,0,0,0,0,0,0,0,0,67665,0,26124),
(113831,'','Nightwell be praised... I thought I was going to die.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113832,'','I will get her home. It is nice to know Vanthir still thinks of us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113833,'There must be more books on magical illness around here somewhere...','',1,0,0,0,0,0,0,0,0,0,67666,0,26124),
(113834,'','It isn\'t far. Thank you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113835,'A Treatise On The Habits Of Ravens looks quite interesting! But, no, it will not help poor Meryl recover...','',0,0,0,0,0,0,0,0,0,0,67667,0,26124),
(113836,'','Ambrena shakily takes a drink.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113837,'Blast! This library is a disaster! We will have to clean it up if we are to have any hope of finding more texts on magical afflictions before it is too late...','',0,0,0,0,0,0,0,0,0,0,67668,0,26124),
(113838,'I know there must be something here that will help Meryl... But where....','',0,0,0,0,0,0,0,0,0,0,67669,0,26124),
(113839,'W-what?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113840,'It is Arcwine. For you. Go on, brother.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113841,'Clotaire tentatively sips at the wine, then takes a deep gulp.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113842,'Hah. Not so fast! You may choke.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113843,'Hush you... Thank Vanthir for me, won\'t you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113844,'Gem activated.','Gem activated.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113845,'Gem deactivated.','Gem deactivated.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113846,'|cFFFF00FFPerfect gem activated.|r','|cFFFF00FFPerfect gem activated.|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113847,'','Mmmm! The tauren here are so... tall.',0,0,0,0,0,0,0,0,0,0,0,62366,26124),
(113848,'He found more?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113849,'','Yes! Plenty for both of us today.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113850,'This mountain will come crumbling down!','',0,0,0,0,0,0,0,0,0,0,62367,0,26124),
(113851,'Donatien takes a quick draught of the mana-wine.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113852,'Vanthir came through again... how can he keep this up?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113853,'From this height, we can almost reach the Void.','',0,0,0,0,0,0,0,0,0,0,62368,0,26124),
(113854,'This place is worse then the last one.','',0,0,0,0,0,0,0,0,0,0,62369,0,26124),
(113855,'Grlmgrl, mgrlgrg. Glrgrlmrgl mrglrlgr lrglr! Rlmgrlm mgrglrmg mrglrglrm. Mrlgrgmrlg gmrlgrl mlrglrg?','',0,0,0,0,0,0,0,0,0,0,23615,0,26124),
(113856,'Mrg, mrlgmrlg...','',0,0,0,0,0,0,0,0,0,0,419,0,26124),
(113857,'Grgmrlg! Glrmg, mglrmglrgr.','',0,0,0,0,0,0,0,0,0,0,420,0,26124),
(113858,'Mgrlgl. Gmrglmr?','',0,0,0,0,0,0,0,0,0,0,18071,0,26124),
(113859,'Mlgr! Mlgrmlrgrlmgr! Mlgrg mlgrmlgrrlm! Rlmgrlmgr!','',0,0,0,0,0,0,0,0,0,0,18077,0,26124),
(113860,'Mr. Mrglglrm knocks the pearl down, cracking it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113861,'This place crawls with creatures, malformed and twisted from a warped mind. They will burn all the same.','',0,0,0,0,0,0,0,0,0,0,62392,0,26124),
(113862,'Here in the forest you will see the flaw in the titans\' plans.','',0,0,0,0,0,0,0,0,0,0,62393,0,26124),
(113863,'Pearlhunter Phin presents the pearl to Mr. Mrglglrm.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113864,'Why are we wasting time by walking through this forest?','',0,0,0,0,0,0,0,0,0,0,62395,0,26124),
(113865,'Halduron told me to expect you.','',0,0,0,0,0,0,1,0,0,0,66554,0,26124),
(113866,'So... much... to... BURN!','',0,0,0,0,0,0,0,0,0,0,62396,0,26124),
(113867,'Yea! How you like that one?','Yea! How you like that one?',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(113868,'There\'s green everywhere! Just not my preferred shade.','',0,0,0,0,0,0,0,0,0,0,62397,0,26124),
(113869,'Bet you didn\'t see that comin\', did ya?','Bet you didn\'t see that comin\', did ya?',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(113870,'You must have went through some trouble to get your hands on this oak and ore.','',0,0,0,0,0,0,1,0,0,0,66555,0,26124),
(113871,'Hmph, you\'re still alive.','Hmph, you\'re still alive.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(113872,'Here comes another one!','Here comes another one!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(113873,'You asked for it!','You asked for it!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(113874,'These are tricky materials to work with, but I think you\'ll be impressed with the final product.','',0,0,0,0,0,0,1,0,0,0,66556,0,26124),
(113875,'Whelp. Looks like I\'m out. I\'m only kiddin\'! I got bombs for days.','Whelp. Looks like I\'m out. I\'m only kiddin\'! I got bombs for days.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(113876,'The weapons I\'m crafting should be sharp enough to pierce through any armor, and sturdy enough for repeated use.','',0,0,0,0,0,0,1,0,0,0,66557,0,26124),
(113877,'I have to say, I think this might be my finest work yet.','',0,0,0,0,0,0,1,0,0,0,66558,0,26124),
(113878,'Don\'t let that weaponry fall into the wrong hands.','',0,0,0,0,0,0,1,0,0,0,66559,0,26124),
(113879,'','The grapple point is on the top of the wall over there. Follow me!',0,0,0,0,0,0,25,0,0,0,0,69885,26124),
(113880,'Delivery of cannons and cannonballs directly from the great forge for ye\'.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113881,'Excellent, the third fleet ships are loading up at the end of the dock.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113882,'Do you think you will have enough?','',0,0,0,0,0,0,0,0,0,0,67571,0,26124),
(113883,'Enough for those most in need. The rest- Ah! Welcome, welcome.','',0,0,0,0,0,0,0,0,0,0,67584,0,26124),
(113886,'Your arrival is timely. Welcome to my tavern.','',0,0,0,0,0,0,0,0,0,0,67585,0,26124),
(113887,'','It was thought his kind was incorruptible. A lesson for my brothers, I suppose.',0,0,0,0,0,0,0,0,0,0,0,63490,26124),
(113888,'','Loken did fine work turning her, but in truth, Odyn\'s arrogance takes most of the credit.',0,0,0,0,0,0,0,0,0,0,0,63491,26124),
(113889,'','Though he is not one of our servants, he has heard our whispers. They darkened him forever.',0,0,0,0,0,0,0,0,0,0,0,63494,26124),
(113890,'The Farstriders will fight at your side and help bring the Houndmaster to his knees.','',0,0,0,0,0,0,1,0,0,0,66586,0,26124),
(113891,'','A beast of stone who ignorantly throws around power he barely controls. He should be put down before he ruins our plans.',0,0,0,0,0,0,0,0,0,0,0,63493,26124),
(113892,'','If the plan is to set a trap for the Houndmaster, we\'ll need to place it in a secure location.',0,0,0,0,0,0,1,0,0,0,0,66627,26124),
(113893,'','The Sentinels stand ready to assist. Together, we will take down the Houndmaster.',0,0,0,0,0,0,1,0,0,0,0,66618,26124),
(113896,'|TInterface\\Icons\\spell_nature_protectionformnature:20|t%s begins to cast |cFF00FFFF|Hspell:212681|h[Cleansed Ground]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113897,'','Another nameless brute of Sargeras, pretending to aid these elves. Little do they know their fate.',0,0,0,0,0,0,0,0,0,0,0,63461,26124),
(113898,'','A traitor to his world and to his kind. His end was never in question... only who would deliver it.',0,0,0,0,0,0,0,0,0,0,0,63460,26124),
(113899,'','Oh where could she have gone...',0,0,0,0,0,0,0,0,0,0,0,66374,26124),
(113900,'Try to relax, friend. We will find her.','',0,0,0,0,0,0,0,0,0,0,67569,0,26124),
(113901,'','How?',0,0,0,0,0,0,0,0,0,0,0,66375,26124),
(113905,'','For this idiotic pustule of N\'Zoth to have lived so long... it does little to refute my opinion of this world\'s new owners.',0,0,0,0,0,0,0,0,0,0,0,63532,26124),
(113907,'','How far the Manastorms have fallen! Relying on crude machines and weak arcane wizardry did them no favors. Still, they had their uses.',0,0,0,0,0,0,0,0,0,0,0,63531,26124),
(113908,'','Her mother was more impressive. This one\'s hunger is uncontrollable and her tactics overused. An easy target.',0,0,0,0,0,0,0,0,0,0,0,63529,26124),
(113909,'','Really, these thugs of Sargeras are SO interchangeable. This one is good with his axe. Oh, how unique!',0,0,0,0,0,0,0,0,0,0,0,63530,26124),
(113910,'The spy has a light colored vest on!','The spy has a light colored vest on!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113911,'','Another fool who believed Illidan\'s lies of sacrifice and righteousness. Tormented, he turns on everyone.',0,0,0,0,0,0,0,0,0,0,0,63528,26124),
(113912,'The spy has a dark colored vest on!','The spy has a dark colored vest on!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113913,'The spy is a male!','The spy is a male!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113914,'The spy is a female!','The spy is a female!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113915,'The spy is wearing gloves!','The spy is wearing gloves!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113916,'The spy is not wearing gloves!','The spy is not wearing gloves!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113917,'The spy is carrying potions!','The spy is carrying potions!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113918,'The spy is carrying books!','The spy is carrying books!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113919,'The spy has a pouch at the belt!','The spy has a pouch at the belt!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113920,'The spy does not have any potions!','The spy does not have any potions!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113921,'The spy has long sleeves!','The spy has long sleeves!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113922,'The spy does not have long sleeves!','The spy does not have long sleeves!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113923,'The spy is wearing a cloak!','The spy is wearing a cloak!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113924,'The spy is not wearing a cloak!','The spy is not wearing a cloak!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113925,'','This one is old, but still not one of the first. These creatures were too hungry for magic to obey our masters, though they still prove useful from time to time.',0,0,0,0,0,0,0,0,0,0,0,63527,26124),
(113926,'','A land full of dreams, but none of them about me? It\'s enough to hurt a girl\'s pride.',0,0,0,0,0,0,0,0,0,0,0,62399,26124),
(113927,'','When do you think she turned? Centuries ago? She hides her hunger for power behind a cloak of suffering and righteousness.',0,0,0,0,0,0,0,0,0,0,0,63526,26124),
(113928,'I think you meant to say nightmares.','',0,0,0,0,0,0,0,0,0,0,62391,0,26124),
(113929,'','These three have enjoyed the secret favor of N\'Zoth for long enough. Sadly their reaving days are done.',0,0,0,0,0,0,0,0,0,0,0,63509,26124),
(113930,'','A powerful dragon could be a powerful tool. Alas, gone are the days of Galakrond.',0,0,0,0,0,0,0,0,0,0,0,63508,26124),
(113931,'Trees everywhere! The fires will be glorious!','',0,0,0,0,0,0,0,0,0,0,62400,0,26124),
(113932,'When I destroy this world, this land will be one of the first consumed.','',0,0,0,0,0,0,0,0,0,0,62401,0,26124),
(113933,'|TInterface\\Icons\\sha_spell_warlock_demonsoul_nightmare:20|t%s casts |cFFFF0000|Hspell:214505|h[Entangling Nightmares]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113934,'They\'re everywhere. This is madness!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(113935,'','We need answers!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(113936,'','Reinforcements from Ironforge are arriving now. Stormwind will not fall on our watch!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113937,'You show some skill. But not as much as your dead master.','',0,0,0,0,0,0,0,0,0,0,61929,0,26124),
(113938,'Tell me, demon hunter, how did it feel being locked up for all of those years?','',0,0,0,0,0,0,0,0,0,0,66889,0,26124),
(113939,'This is impossible.','',0,0,0,0,0,0,0,0,0,0,66890,0,26124),
(113940,'My son. Where is Galen?','',0,0,0,0,0,0,0,0,0,0,69398,0,26124),
(113941,'Where is the prince who murdered his king?','',0,0,0,0,0,0,0,0,0,0,69399,0,26124),
(113942,'What has become of Stromgarde?','',0,0,0,0,0,0,1,0,0,0,69400,0,26124),
(113943,'Then I have failed as both a father and a king.','',0,0,0,0,0,0,1,0,0,0,69401,0,26124),
(113944,'Is there a shortage of steel in this future world?','',0,0,0,0,0,0,0,0,0,0,69402,0,26124),
(113945,'Then leave it to rust. I care not.','',0,0,0,0,0,0,0,0,0,0,69403,0,26124),
(113946,'We took his life, my lord. The prince left us little choice.','',0,0,0,0,0,0,1,0,0,0,69404,0,26124),
(113947,'... Everything.','... Everything.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113948,'Death and ruin. Time has not been kind to this place.','',0,0,0,0,0,0,1,0,0,0,69405,0,26124),
(113949,'I hate this place! Free me from the torment of this journey!','',0,0,0,0,0,0,0,0,0,0,62402,0,26124),
(113950,'I\'ve gotta get back to Gadgetzan! They\'re never gonna believe this!','I\'ve gotta get back to Gadgetzan! They\'re never gonna believe this!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113951,'Thanks! I owe ya one.','Thanks! I owe ya one.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113952,'Didn\'t expect to see you here! Now, if you\'ll excuse me...','Didn\'t expect to see you here! Now, if you\'ll excuse me...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113953,'Wow, that was close.','Wow, that was close.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113954,'I need to stop volunteering for this.','I need to stop volunteering for this.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113955,'We are the Ebon Blade. Knights of undeath who protect this world.','',0,0,0,0,0,0,1,0,0,0,69406,0,26124),
(113956,'We do what the living cannot.','',0,0,0,0,0,0,1,0,0,0,69407,0,26124),
(113957,'Thanks. I better let \'em know what\'s goin\' on here.','Thanks. I better let \'em know what\'s goin\' on here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113958,'Never thought I\'d get stuck out here. Thanks for the help.','Never thought I\'d get stuck out here. Thanks for the help.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(113959,'Stromgarde is lost, but there is still hope for this world... if you will join us.','',0,0,0,0,0,0,1,0,0,0,69408,0,26124),
(113960,'The Nightmare creeps across this land. A tempting power to harness, but to do so without understanding its nature would be foolish.','',0,0,0,0,0,0,0,0,0,0,62394,0,26124),
(113961,'Excellent! By the way, we have recovered your blade, Trol\'kalar. It is quite legendary.','',0,0,0,0,0,0,1,0,0,0,69409,0,26124),
(113962,'No.','',0,0,0,0,0,0,1,0,0,0,69410,0,26124),
(113963,'Who are you that raise fallen kings from the earth? Speak.','',0,0,0,0,0,0,0,0,0,0,69411,0,26124),
(113964,'This place was devastated long ago. Why do you waste my time, mortal?','',0,0,0,0,0,0,0,0,0,0,62351,0,26124),
(113965,'I will do whatever it takes to preserve peace on Azeroth.','',0,0,0,0,0,0,1,0,0,0,69412,0,26124),
(113966,'Hey, we\'re going to the beach! Time off is in my contract, right?','',0,0,0,0,0,0,0,0,0,0,62352,0,26124),
(113967,'','Great dragons bent to the will of Xavius, who serves the God of the Deep. Instead of breathing life, she consumes all around her.',0,0,0,0,0,0,0,0,0,0,0,63505,26124),
(113968,'','It appears the prison of N\'Zoth is not as strong as it once was. What you see is a tiny growth of the behemoth that may yet consume your world.',0,0,0,0,0,0,0,0,0,0,0,63504,26124),
(113969,'','Another seed of corruption planted in death. An unquiet spirit will wander in anger and grow in pain. Easy prey for the God of the Deep.',0,0,0,0,0,0,0,0,0,0,0,63502,26124),
(113970,'','Another defender of the titans brought low. Every death makes it easier. Perhaps now his misery will end... though I doubt it.',0,0,0,0,0,0,0,0,0,0,0,63506,26124),
(113971,'I see spirits all throughout the ruins of this land. Souls ready to be harvested!','',0,0,0,0,0,0,0,0,0,0,62353,0,26124),
(113972,'','Corrupting the guardians of the Dream is a bold move, but Xavius may be overreaching. He would be better off quietly spreading the Nightmare\'s influence instead of raising such alarm.',0,0,0,0,0,0,0,0,0,0,0,63501,26124),
(113973,'','This land\'s destruction is an unfinished work. Once complete, it will be a fitting tribute for the great Sargeras.',0,0,0,0,0,0,0,0,0,0,0,62354,26124),
(113974,'','Xavius uses the power of his new master well. Warping the mind of a demigod is no mean feat.',0,0,0,0,0,0,0,0,0,0,0,63500,26124),
(113975,'This place is nothing but a shadow of itself. We will crush it last so that its inhabitants may despair at the destruction of their world!','',0,0,0,0,0,0,0,0,0,0,62355,0,26124),
(113976,'The ocean\'s depths are dark and foreboding. So like the endless Void.','',0,0,0,0,0,0,0,0,0,0,62356,0,26124),
(113977,'I don\'t like this place. Release me!','',0,0,0,0,0,0,0,0,0,0,62357,0,26124),
(113978,'','Xavius, running from one master to the next. Scrambling for power, yet defeated again and again. The God of the Deep picks a poor champion, or is there something else at play?',0,0,0,0,0,0,0,0,0,0,0,63507,26124),
(113979,'','Almost completely gone, as if it never existed. But the Rift is deep and vast, and somewhere down there it stirs. Something has changed, the last prison weakens. We must prepare.',0,0,0,0,0,0,0,0,0,0,0,63503,26124),
(113980,'Interesting... what a creative use of residual soul energy! We must remember to research this technique!','',0,0,0,0,0,0,0,0,0,0,62403,0,26124),
(113981,'This one has drunk deeply of the fel. It\'s unfortunate we don\'t have time to see if she can be bound like any other demon.','',0,0,0,0,0,0,0,0,0,0,62404,0,26124),
(113982,'','The walls between realms are thin here, so easy to tear open. Do you know what would happen if true shadow and light met here?',0,0,0,0,0,0,0,0,0,0,0,63495,26124),
(113983,'Beware! His advisor is far more than he seems. Keep your wits about you!','',0,0,0,0,0,0,0,0,0,0,62405,0,26124),
(113984,'','The research into the Void here is commendable, but ultimately futile. How could you possibly understand what the titans did not?',0,0,0,0,0,0,0,0,0,0,0,63496,26124),
(113985,'','I know the naaru consider us horrors to be resisted. We do not share this view. They are merely beloved brethren that lost the true path. They will return to their masters... in time.',0,0,0,0,0,0,0,0,0,0,0,63497,26124),
(113986,'Well, well, if it isn\'t my prodigal student Talixae. She was missing when the Vindicators put me in chains and slew the rest of my disciples. I look forward to witnessing her death!','',0,0,0,0,0,0,0,0,0,0,62406,0,26124),
(113987,'','You\'ve gathered quite the group of followers. It is fortunate they are focused on this incursion and not the true war. The scope of it might destroy your minds.',0,0,0,0,0,0,0,0,0,0,0,63498,26124),
(113988,'','Do the naaru speak of the eternal conflict? That the entire history of your world is but a fraction of the time that has passed? Of those that came before the draenei? No? <short chuckle>',0,0,0,0,0,0,0,0,0,0,0,63499,26124),
(113989,'','Delicious.',0,0,0,0,0,0,0,0,0,0,0,63484,26124),
(113990,'','Every little death helps.',0,0,0,0,0,0,0,0,0,0,0,63485,26124),
(113991,'','Enjoy that?',0,0,0,0,0,0,0,0,0,0,0,63486,26124),
(113992,'','Boring.',0,0,0,0,0,0,0,0,0,0,0,63487,26124),
(113993,'','Get a load of this, brother!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(113994,'','Did you feel it cease to exist?',0,0,0,0,0,0,0,0,0,0,0,63488,26124),
(113995,'','Remember how Queen Azshara was working with the demons? Well apparently, when Prince Farondis found out, he was like...',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(113996,'','\"NO!\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113997,'','...and then Queen Azshara was like...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(113998,'','\"HOW DARE YOU DEFY ME!?\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(113999,'','...and then she got so mad that she turned everybody into... into...',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(114000,'','CURSED SPIRITS!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114001,'','Oh, sorry.',0,0,0,0,0,0,24,0,0,0,0,0,26124),
(114002,'','I long for the day our masters can truly pass into this realm. You have only seen fragments, shadows, the faintest of echoes. Ask the ethereals what one of these manifestations is capable of.',0,0,0,0,0,0,0,0,0,0,0,63478,26124),
(114003,'','Reports indicate that there is a colossal crab dwelling within the Shipwreck Shoals. Supposedly, its claws are stronger than steel! We could fashion them into mighty weapons.',0,0,0,0,0,0,0,0,0,0,0,70638,26124),
(114004,'','Wait, they were just normal crab claws but larger? That\'s unfortunate.',0,0,0,0,0,0,0,0,0,0,0,70639,26124),
(114005,'','The nearness of the Void here is comforting. I was used in the sacrifice of many creatures in a place like this. Every death brought us closer to the complete corruption of this world.',0,0,0,0,0,0,0,0,0,0,0,63479,26124),
(114006,'This Xavius is crafty. He hides his true form while gathering power with an illusion. We would do well to learn from him.','',0,0,0,0,0,0,0,0,0,0,62407,0,26124),
(114007,'','I remember the Dark Iron fondly. Modgud was so easy to influence, such was her hate. Imagine her fury when I abandoned her to the Wildhammer at the worst time. I can be very easy to lose... remember that.',0,0,0,0,0,0,0,0,0,0,0,63480,26124),
(114008,'','We may face some of my brethren in this conflict... a prospect that delights me. Their power will be mine! They will pay for what was done to me long ago.',0,0,0,0,0,0,0,0,0,0,0,63481,26124),
(114009,'Foolish mortals. NOTHING can save you!','',0,0,0,0,0,0,153,0,0,0,0,0,26124),
(114010,'Bow before the might of the Legion!','',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(114011,'','The God of the Deep writhes in his prison, breaking free ever so slowly. You should hurry and defeat the fallen titan... there are greater battles yet to fight.',0,0,0,0,0,0,0,0,0,0,0,63482,26124),
(114012,'Nothing can protect you.','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(114013,'The Legion cannot be stopped!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(114014,'We... are... EVERYWHERE!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(114015,'Ha ha ha. Fools! You know nothing!','',0,0,0,0,0,0,153,0,0,0,0,0,26124),
(114016,'Your existence is at an end, mortals!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114017,'Thank you, adventurer.','Thank you, adventurer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114018,'I am alive? Thank you!','I am alive? Thank you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114019,'Please, the Shade of Xavius must be stopped.','Please, the Shade of Xavius must be stopped.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114020,'That creature may seem impressive, but the spells which give it form are barely holding it together. Break the ritual supporting it and the rest shall soon crumble.','',0,0,0,0,0,0,0,0,0,0,62408,0,26124),
(114021,'','An interesting mutation of an ancient species. Its shell is nearly impregnable. Nearly...',0,0,0,0,0,0,0,0,0,0,0,63515,26124),
(114022,'','An interesting amalgamation of fel species. I wonder, are there more of its kind?',0,0,0,0,0,0,0,0,0,0,0,63514,26124),
(114023,'','Such arrogance, even for a long-lived elf. The taste of her life force is... exquisite.',0,0,0,0,0,0,0,0,0,0,0,63510,26124),
(114024,'','Here is one who has caught the merest glimpse of your grim reality. It warped his mind forever.',0,0,0,0,0,0,0,0,0,0,0,63512,26124),
(114025,'','She claims to know the future, but those who have lived far longer than her know the truth. Her desperate bid to remain in control dooms her people.',0,0,0,0,0,0,0,0,0,0,0,63511,26124),
(114026,'','Long has this one\'s time been coming. A true servant of the fallen titan, he seeks the doom of all things. As if that would really save them from the Void.',0,0,0,0,0,0,0,0,0,0,0,63513,26124),
(114027,'','<short chuckle>',0,0,0,0,0,0,0,0,0,0,0,63516,26124),
(114028,'','<evil laughter>',0,0,0,0,0,0,0,0,0,0,0,63489,26124),
(114029,'','A corrupted corpse of a dragon... how dangerous could that possibly be?',0,0,0,0,0,0,0,0,0,0,0,63468,26124),
(114030,'','Another mindwarped servant of Xavius. A druid should have better control of his own mind, don\'t you think?',0,0,0,0,0,0,0,0,0,0,0,63469,26124),
(114031,'','There has been a rumored sighting of the behemoth known as Shellmaw, carving a swath of destruction through the Whispering Willows!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114032,'If the Valarjar were able to be unleashed from this place they would be a significant hindrance to the Legion. Stuck here, they\'re useless.','',0,0,0,0,0,0,0,0,0,0,62546,0,26124),
(114033,'','Well done. Now at least something will remain once the naga have been driven out.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114034,'','It is ironic that the weakest of us may be the ultimate victor. C\'Thun, Yogg-Saron, Y\'Shaarj, and... well. Only one would remain to consume the world, that was always meant to be.',0,0,0,0,0,0,0,0,0,0,0,63483,26124),
(114035,'','Hey, brother! Someone\'s here to...',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(114036,'','Oops. Sorry.',0,0,0,0,0,0,24,0,0,0,0,0,26124),
(114037,'','The recruitment of the eredar was quite a win for Sargeras. He desperately needed more intelligence in his warhost.',0,0,0,0,0,0,0,0,0,0,0,63467,26124),
(114038,'We are only here to talk, Akama.','',0,0,0,0,0,0,1,0,0,0,66903,0,26124),
(114039,'Well, that brought back some unpleasant memories.','',0,0,0,0,0,0,0,0,0,0,62409,0,26124),
(114040,'','They\'re here to help us find mom and dad.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114041,'Akama, listen to reason.','',0,0,0,0,0,0,1,0,0,0,66888,0,26124),
(114042,'Severing, secure the keep gates! We\'re moving the king to a secure location.','',0,0,0,0,0,0,0,0,0,0,63591,0,26124),
(114044,'','The majestic Mythana has become befouled by the Nightmare. Search her out and put her out of her misery.',0,0,0,0,0,0,0,0,0,0,0,70603,26124),
(114045,'','You have done well. The Dreamweavers are in your debt.',0,0,0,0,0,0,0,0,0,0,0,70604,26124),
(114046,'You hear a faint caw in the distance and then silence...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114049,'Do you hear them? The screams of the souls that form every board and nail of this ship. They\'re like... music!','',0,0,0,0,0,0,0,0,0,0,62411,0,26124),
(114050,'The Light reveals all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114052,'Look upon the monstrosity before you. The Legion had no part in its creation. No, this creature is the folly of the titans\' designs.','',0,0,0,0,0,0,0,0,0,0,62410,0,26124),
(114053,'Baron has found something.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114054,'I did not know if I would make it out of this alive. Thank you.','I did not know if I would make it out of this alive. Thank you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114055,'I can go home!','I can go home!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114056,'I was innocent, but they didn\'t listen...','I was innocent, but they didn\'t listen...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114057,'That is the last time I complain about the demons!','That is the last time I complain about the demons!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114058,'I have to check on my wife. Thank you!','I have to check on my husband. Thank you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114059,'I\'m free! I\'m really free!','I\'m free! I\'m really free!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114060,'Got some o\' the forge\'s best armor polish for the troops here, $n. Don\'t be shipping off without gettin\' some o\' those scuffs out first.','',0,0,0,0,0,0,603,0,0,924,0,0,26124),
(114061,'Look at this creature. Such sloppy technique! It would never be able to master the binding magic needed for a warlock.','',0,0,0,0,0,0,0,0,0,0,62413,0,26124),
(114062,'','What? Kallistia and Olothil are here?',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(114063,'','I... I thought we\'d lost them forever.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114064,'','Hurry up, Than! Let\'s find them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114065,'This one reminds me of a felguard. Big, strong, and stupid.','',0,0,0,0,0,0,0,0,0,0,62412,0,26124),
(114066,'Well, this looks cheery.','',0,0,0,0,0,0,0,0,0,0,62416,0,26124),
(114067,'...the feeling is mutual.','',0,0,0,0,0,0,0,0,0,0,62415,0,26124),
(114068,'Baron runs back to camp with his tail wagging.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114069,'','I\'m tracking someone... the gate\'s been breached!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114070,'Ugh, keep me away from that thing! I don\'t need my magic to be drained again.','',0,0,0,0,0,0,0,0,0,0,62414,0,26124),
(114071,'','I got them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114072,'','Momma, is daddy coming home soon?',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(114073,'','Yes, baby, he\'ll be home before you know it.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114074,'','Very good!',0,0,0,0,0,0,0,0,0,0,0,62104,26124),
(114075,'I\'ll protect you, Ella! I\'ve got a sword and everything!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114076,'Sam! Where did you get that stick? Put it down, it\'s dirty.','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(114077,'Your ship is waiting at the end of this dock, $n. Be careful out there.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114078,'Reinforcements to the keep at once. They\'re here!','',0,0,0,0,0,0,0,0,0,0,63586,0,26124),
(114079,'However you wish this to go down, we are with you, $n. Though, I would counsel restraint, if possible.\n\nThe knowledge that he has could prove instrumental in bringing down the Burning Legion. We want Akama to become a trusted advisor, despite his past history with the Illidari.\n\nHopefully, he will listen to reason. The tone of his voice suggests not.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114080,'However you wish this to proceed, we are with you, $n. I remind you that he betrayed the Master, leading to our imprisonment and Illidan\'s death.\n\nIf it weren\'t for Akama, the Burning Legion might already be defeated. While we want him as an advisor, his previous actions suggest that he is not to be trusted.\n\nDon\'t misunderstand, the Master said that we should recruit Akama, so I am in favor of the plan. However, it does not sound like he is willing to be reasonable.\n\nAllari and I have formulated a contingency plan just in case.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114081,'','Demons will be drawn to the power I\'ll call upon to enchant your weapons.',0,0,0,0,0,0,1,0,0,0,0,66591,26124),
(114082,'','The materials used are extremely volatile. An interruption of any kind could prove disastrous.',0,0,0,0,0,0,1,0,0,0,0,66592,26124),
(114083,'','I\'ll keep doing what I do best, as long as you keep those demons away from me and my enchanting table.',0,0,0,0,0,0,1,0,0,0,0,66593,26124),
(114084,'','My work is almost complete. I just need a few more moments without interruption...',0,0,0,0,0,0,1,0,0,0,0,66594,26124),
(114085,'','There, the weapons are finished.',0,0,0,0,0,0,1,0,0,0,0,66595,26124),
(114086,'','I\'ve given them the finest enchantment I can offer.',0,0,0,0,0,0,1,0,0,0,0,66596,26124),
(114087,'No...','',0,0,0,0,0,0,0,0,0,0,66853,0,26124),
(114091,'There must be a way through!','There must be a way through!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114092,'','Let\'s meet at the hall. There\'s still work to be done.',0,0,0,0,0,0,1,0,0,0,0,63561,26124),
(114093,'My family has watched over these burial grounds since the days of Huln himself! We tended the honored dead with pride, skilled in our charge to guide their spirits and learn from them.$b$bNow thanks to the thrice foul Bloodtotem tribe, if they even call themselves that anymore, I find I must ask for aid from outsiders.$b$bThese are dark days indeed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114094,'I heard something.','I heard something.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(114095,'What was that?','What was that?',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(114096,'One of \'em is close!','One of \'em is close!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(114097,'While my blades yearn to spill demonic blood, I am under orders strictly to observe.$b$bThe knowledge these spiritwalkers have of the local area as well as the spirits that threaten our forces has already proven invaluable.$b$bWe will continue to offer them shelter and supplies as long as they continue to be useful.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114098,'I smell a cultist!','I smell a cultist!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(114099,'I\'ll find you in the king\'s name!','I\'ll find you in the king\'s name!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(114100,'By the Light, what was that?','By the Light, what was that?',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(114101,'There\'s an intruder nearby.','There\'s an intruder nearby.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(114102,'Show yourself, cretin!','Show yourself, cretin!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(114103,'Aye, someone\'s nearby.','Aye, someone\'s nearby.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(114104,'Come on out, ya scoundrel!','Come on out, ya scoundrel!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(114105,'You won\'t be gettin\' past me that easily.','You won\'t be gettin\' past me that easily.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(114106,'Easy now... I just wanna talk.','Easy now... I just wanna talk.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(114107,'Come on out, before I lose me patience!','Come on out, before I lose me patience!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(114108,'I think I might\'ve spotted somethin\' over here.','I think I might\'ve spotted somethin\' over here.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(114109,'Hmm? What was that?','Hmm? What was that?',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(114110,'Somethin\' ain\'t right.','Somethin\' ain\'t right.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(114111,'We will face my former kin in this conflict. Good! I\'ve awaited my revenge for millennia. They will pay for what they did to me!','',0,0,0,0,0,0,0,0,0,0,62532,0,26124),
(114112,'Watching you hone your craft brings back old memories. I was an instructor, millennia ago. My students were the finest summoners of Argus... until we were betrayed.','',0,0,0,0,0,0,0,0,0,0,62531,0,26124),
(114113,'Me no like dem.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(114114,'Oof! Dey hurt!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(114115,'Me hurt dem later!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(114116,'Raaar!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(114117,'This one bears partial blame for me being in this form! He will not escape my wrath, but there are others far more responsible who must be dealt with first!','',0,0,0,0,0,0,0,0,0,0,62530,0,26124),
(114118,'Me no stay here!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(114119,'Is it not glorious to witness such mighty beings bowing at your feet? I sacrificed everything, EVERYTHING, for such power. One day you too must pay ambition\'s price.','',0,0,0,0,0,0,0,0,0,0,62533,0,26124),
(114120,'This one has strong ties to the Dark Lord. To consolidate our control over the Legion, we should eliminate our competition while we have the chance.','',0,0,0,0,0,0,0,0,0,0,62536,0,26124),
(114121,'Like most of the nathrezim, Tichondrius is as arrogant as he is deadly. His ego will be his undoing!','',0,0,0,0,0,0,0,0,0,0,62537,0,26124),
(114122,'This one has seen into the Great Dark and beheld the Legion\'s glorious works. I wonder how you will react when you glimpse them as well!','',0,0,0,0,0,0,0,0,0,0,62535,0,26124),
(114123,'Her attempts to control time\'s flow are futile. Subtle forces work against her, ones far more powerful then she could ever imagine.','',0,0,0,0,0,0,0,0,0,0,62534,0,26124),
(114125,'','The flame of the shal\'dorei flickers. We must re-ignite it.',0,0,0,0,0,0,0,0,6,0,0,67562,26124),
(114126,'Father, I\'m thirsty... can I have some mana juice?','Father I\'m thirsty... can I have some mana juice?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114127,'S-soon, little one. Soon,  I promise.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114128,'','The Afflicted Nightborne Citizen shivers violently while staring blankly into the distance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114129,'','There is a turtle of massive size inhabiting Deepbeard\'s Cove. Bring me the shell so that we can investigate its legendary toughness.',0,0,0,0,0,0,0,0,0,0,0,70634,26124),
(114130,'Haven\'t seen a porter in days... how is it possible to overlook an entire community like this?','Haven\'t seen a porter in days... how is it possible to overlook an entire community like this?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114131,'Somehow I do not think we have been merely overlooked.','Somehow I do not think we have been merely overlooked.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114132,'Someone might hear you!','Someone might hear you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114133,'That does not mean I am wrong.','That does not mean I am wrong.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114134,'Khadgar\'s wand crackles to life.','Khadgar\'s wand crackles to life.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114135,'','Fantastic job. We can absolutely use this in our research.',0,0,0,0,0,0,0,0,0,0,0,70635,26124),
(114136,'Is the shipment in? Please tell me there is more... please...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114137,'These feltotem pretty tasty once get them out of crunchy shell.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114138,'Tomb\'s up ahead. Let\'s get in there and find that shrine! We\'ll follow yer lead, $n.','',0,0,0,0,0,0,1,0,0,0,63297,0,26124),
(114139,'As a healer, it shouldn\'t be too difficult to save this civilian.','As a healer, it shouldn\'t be too difficult to save this civilian.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114140,'','And look at you now! A spectre of your former self, cursed to an eternity of undeath and ineptitude.',0,0,0,0,0,0,0,0,0,0,0,62548,26124),
(114141,'','I\'m giving you an opportunity to kneel before me, princeling. Maybe something can be done about that little curse...',0,0,0,0,0,0,0,0,0,0,0,62549,26124),
(114142,'No. I knew what I must do.','',0,0,0,0,0,0,0,0,0,0,62706,0,26124),
(114143,'And we will NEVER...','',0,0,0,0,0,0,0,0,0,0,62550,0,26124),
(114144,'KNEEL...','',0,0,0,0,0,0,0,0,0,0,62551,0,26124),
(114145,'BEFORE YOU!!!','',0,0,0,0,0,0,0,0,0,0,62552,0,26124),
(114147,'Psst, hey, got some lucky charms here. Don\'t want to face the Legion without a little luck on your side, do ya?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114148,'That stinks! It\'s covered in mold. Archmage Vargoth has been away longer than I thought.','',1,0,0,0,0,0,0,0,0,0,67670,0,26124),
(114149,'Mortals and their crystal balls... Although this one may actually be more than just a novelty.','',0,0,0,0,0,0,0,0,0,0,67671,0,26124),
(114150,'Now this is interesting. I had no idea Archmage Vargoth was also interested in the breeding habits of angelfish!','',1,0,0,0,0,0,0,0,0,0,67672,0,26124),
(114151,'Fascinating! This is a spell book of ancient Nightborne rituals. I must borrow it sometime.','',0,0,0,0,0,0,0,0,0,0,67673,0,26124),
(114152,'I make these Demon Hunters nervous. Little old me. Tehd from Lordaeron. Hee hee.$b$BAlways remember, in a land of fel infused ancient elves, the peasant with a good banish spell is king.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114153,'Me help goblin lady fight bad guy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114154,'I thank you, $n, but my ancestors were more brave than I.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114155,'Field could use a few more bombs!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114156,'I\'ve seen it rain cats and dogs, but I\'m not sure what to call this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114157,'This is a nice space for a mortal. Let\'s see what secrets it is hiding.','',1,0,0,0,0,0,0,0,0,0,67674,0,26124),
(114158,'Pearlhunter Phin groans and kicks a nearby rock.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114159,'Pearlhunter Phin hops around impatiently.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114160,'Pearlhunter Phin throws their arms in the air, seemingly frustrated.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114161,'Mrgrlg! Glrgmrl mgrlgr...','',0,0,0,0,0,0,0,0,0,0,415,0,26124),
(114162,'Grglrgl! Lrgl... Grgrmrmlgr! MLGMRMLGR!','',0,0,0,0,0,0,0,0,0,0,416,0,26124),
(114163,'Mrlg. Grlgm.','',0,0,0,0,0,0,0,0,0,0,417,0,26124),
(114164,'Pearlhunter Phin runs over and begins digging furiously.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114165,'Pearlhunter Phin triumphantly pulls out handful of long fangs from the pile of sand.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114166,'Mrglrg! Grmgl, grmlgrmlg mlrgr lrrg.','',0,0,0,0,0,0,0,0,0,0,417,0,26124),
(114167,'GRGRLM! Mlrgmr, gmrlg Glrmrgl mrlg Mrgrlilrgl.','',0,0,0,0,0,0,0,0,0,0,419,0,26124),
(114168,'You are too late. Vargoth has already won!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114169,'What knowledge do you seek?','',0,0,0,0,0,0,0,0,0,0,63063,0,26124),
(114170,'Yes?','',0,0,0,0,0,0,0,0,0,0,63070,0,26124),
(114171,'I will help how I can.','',0,0,0,0,0,0,0,0,0,0,63077,0,26124),
(114172,'You have my ear.','',0,0,0,0,0,0,0,0,0,0,63083,0,26124),
(114173,'Honor the Tirisfalen.','',0,0,0,0,0,0,0,0,0,0,63040,0,26124),
(114174,'Beware the Nathrezim.','',0,0,0,0,0,0,0,0,0,0,63047,0,26124),
(114175,'The dreadlords must fall.','',0,0,0,0,0,0,0,0,0,0,63054,0,26124),
(114176,'The Tirisgarde must not fail.','',0,0,0,0,0,0,0,0,0,0,63058,0,26124),
(114177,'Some demons are best left unwakened.','',0,0,0,0,0,0,0,0,0,0,63131,0,26124),
(114178,'You would not like me when I\'m angry.','',0,0,0,0,0,0,0,0,0,0,63135,0,26124),
(114179,'I will consume your soul!','',0,0,0,0,0,0,0,0,0,0,63142,0,26124),
(114180,'I will consume your soul! Oh my, now where did that come from?','',0,0,0,0,0,0,0,0,0,0,63143,0,26124),
(114181,'You\'ve accomplished a great deal in bringing us all together here. With the changes that you are making in how the Illidari operate, I have no doubt that we can win this war.\n\nWhen this is all over, the Burning Legion will no longer be a threat and all of our sacrifices will have been worth it.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114182,'You have accomplished a great deal in bringing us all together here. With our renewed resolve and carefully considered plans, I have no doubt that we can win this war.\n\nWhen this is all over, the Burning Legion will no longer be a threat and all of our sacrifices will have been worth it.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114183,'Trust the wisdom of the Council.','',0,0,0,0,0,0,0,0,0,0,63060,0,26124),
(114184,'Am I needed?','',0,0,0,0,0,0,0,0,0,0,63067,0,26124),
(114185,'The Guardian stands ready.','',0,0,0,0,0,0,0,0,0,0,63074,0,26124),
(114186,'So be it.','',0,0,0,0,0,0,0,0,0,0,63037,0,26124),
(114187,'As the Council commands.','',0,0,0,0,0,0,0,0,0,0,63044,0,26124),
(114188,'May the Guardians protect you.','',0,0,0,0,0,0,0,0,0,0,63051,0,26124),
(114189,'Step right up!','',0,0,0,0,0,0,0,0,0,0,63066,0,26124),
(114190,'Where do you wanna go?','',0,0,0,0,0,0,0,0,0,0,63073,0,26124),
(114191,'Pick a card!','',0,0,0,0,0,0,0,0,0,0,63080,0,26124),
(114192,'Yeah?','',0,0,0,0,0,0,0,0,0,0,63086,0,26124),
(114193,'Time is mana, friend!','',0,0,0,0,0,0,0,0,0,0,63043,0,26124),
(114194,'Tips are appreciated!','',0,0,0,0,0,0,0,0,0,0,63050,0,26124),
(114195,'Now where\'d that rabbit run off to?','',0,0,0,0,0,0,0,0,0,0,63057,0,26124),
(114196,'Hey, how bout you help with with a new trick? I just need to find that saw...','',0,0,0,0,0,0,0,0,0,0,63134,0,26124),
(114197,'Keep that up and you might just disappear, bub.','',0,0,0,0,0,0,0,0,0,0,63138,0,26124),
(114198,'The rabbits! They\'re everywhere! They control everything!','',0,0,0,0,0,0,0,0,0,0,63141,0,26124),
(114199,'You believe that you are in control, that your will is your own...','',0,0,0,0,0,0,1,0,0,0,64180,0,26124),
(114200,'Yet you do as He commands.','',0,0,0,0,0,0,6,0,0,0,64181,0,26124),
(114201,'You exist by His whim alone.','',0,0,0,0,0,0,0,0,0,0,64182,0,26124),
(114202,'You imagine yourself to be free, but you will always be His instrument...','',0,0,0,0,0,0,0,0,0,0,64183,0,26124),
(114203,'The darkness does not die, $n.','',0,0,0,0,0,0,1,0,0,0,64187,0,26124),
(114204,'Rage against the Nightmare. Struggle as you will.','',0,0,0,0,0,0,0,0,0,0,64188,0,26124),
(114205,'The infinite dark is patient. We will all be claimed in the end.','',0,0,0,0,0,0,6,0,0,0,64189,0,26124),
(114206,'','Hello, $n. How might I help you today?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114207,'So many fallen kings, silent in their numberless graves...','',0,0,0,0,0,0,6,0,0,0,64184,0,26124),
(114208,'Even the mighty are rendered nameless by time.','',0,0,0,0,0,0,1,0,0,0,64185,0,26124),
(114209,'Every king must kneel before death.','',0,0,0,0,0,0,0,0,0,0,64186,0,26124),
(114210,'See the spirits writhe and twist...','',0,0,0,0,0,0,6,0,0,0,64177,0,26124),
(114211,'What is it?','',0,0,0,0,0,0,0,0,0,0,63064,0,26124),
(114212,'The numberless shades forsaken by time.','',0,0,0,0,0,0,1,0,0,0,64178,0,26124),
(114213,'Make it quick.','',0,0,0,0,0,0,0,0,0,0,63071,0,26124),
(114214,'The dead outnumber the living, and always will.','',0,0,0,0,0,0,0,0,0,0,64179,0,26124),
(114215,'I\'ve no time for trivialities.','',0,0,0,0,0,0,0,0,0,0,63078,0,26124),
(114216,'What?','',0,0,0,0,0,0,0,0,0,0,63084,0,26124),
(114217,'Very well.','',0,0,0,0,0,0,0,0,0,0,63041,0,26124),
(114218,'Are we done?','',0,0,0,0,0,0,0,0,0,0,63048,0,26124),
(114219,'The fel fire beckons','',0,0,0,0,0,0,0,0,0,0,63055,0,26124),
(114220,'If you mess with fel fire, you get burned.','',0,0,0,0,0,0,0,0,0,0,63059,0,26124),
(114221,'Hmm... I hope these robes aren\'t flammable...','',0,0,0,0,0,0,0,0,0,0,63132,0,26124),
(114222,'You know, I could really use some aloe.','',0,0,0,0,0,0,0,0,0,0,63136,0,26124),
(114223,'What happened to my face? Stood in the fire one too many times.','',0,0,0,0,0,0,0,0,0,0,63139,0,26124),
(114224,'Are you... really here? A $c... in my den! What are the odds?$B$BHow in the world did you get here?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114225,'How did I get here? What in the heck are you doing up here!?','How did I get here? What in the heck are you doing up here!?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114226,'What am I doing here? What are YOU doing here!?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114227,'','The Vale has seen better days. \n\nDemons have decided to claim this space as their own, but I won\'t give up without a fight.\n\nWhen I\'m not fending off intruders, I\'m spending time perfecting enchantments to use against them. \n\nOne day, we will retake Moonclaw Vale.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114228,'','Are you ready for me to begin enchanting the weapons?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114229,'Do not fail me, Varedis.','',0,0,0,0,0,0,0,0,0,0,64629,0,26124),
(114230,'Return to Argus. We will deal with this one another day.','',0,0,0,0,0,0,0,0,0,0,64631,0,26124),
(114231,'','How can I help?',0,0,0,0,0,0,0,0,0,0,0,63062,26124),
(114232,'','What needs doing?',0,0,0,0,0,0,0,0,0,0,0,63069,26124),
(114233,'','My demons stand ready.',0,0,0,0,0,0,0,0,0,0,0,63076,26124),
(114234,'','Yes?',0,0,0,0,0,0,0,0,0,0,0,63082,26124),
(114235,'','If it must be done.',0,0,0,0,0,0,0,0,0,0,0,63039,26124),
(114236,'','The void is my ally.',0,0,0,0,0,0,0,0,0,0,0,63046,26124),
(114237,'','Summon with caution, friend.',0,0,0,0,0,0,0,0,0,0,0,63053,26124),
(114238,'','What now?',0,0,0,0,0,0,0,0,0,0,0,63065,26124),
(114239,'','You need my... talents?',0,0,0,0,0,0,0,0,0,0,0,63072,26124),
(114240,'','What should we kill next?',0,0,0,0,0,0,0,0,0,0,0,63079,26124),
(114241,'','I grow restless. Entertain me.',0,0,0,0,0,0,0,0,0,0,0,63085,26124),
(114242,'','Let\'s get on with it.',0,0,0,0,0,0,0,0,0,0,0,63042,26124),
(114243,'','This had better amuse me.',0,0,0,0,0,0,0,0,0,0,0,63049,26124),
(114244,'','A pox on all our enemies!',0,0,0,0,0,0,0,0,0,0,0,63056,26124),
(114245,'','A good pox is always worth sharing.',0,0,0,0,0,0,0,0,0,0,0,63133,26124),
(114246,'','My affection for affliction is no affectation.',0,0,0,0,0,0,0,0,0,0,0,63137,26124),
(114247,'','Ashes, ashes... we all fall... down!',0,0,0,0,0,0,0,0,0,0,0,63140,26124),
(114248,'Yes, friend?','',0,0,0,0,0,0,0,0,0,0,63061,0,26124),
(114249,'Calydus is ready to serve!','',0,0,0,0,0,0,0,0,0,0,63068,0,26124),
(114250,'What does friend need?','',0,0,0,0,0,0,0,0,0,0,63075,0,26124),
(114251,'Farewell, friend!','',0,0,0,0,0,0,0,0,0,0,63038,0,26124),
(114252,'Calydus is eager to help!','',0,0,0,0,0,0,0,0,0,0,63081,0,26124),
(114253,'Calydus will wait here.','',0,0,0,0,0,0,0,0,0,0,63045,0,26124),
(114254,'Come back soon!','',0,0,0,0,0,0,0,0,0,0,63052,0,26124),
(114255,'Commander. I stand ready to train as many troops as you require.\n\nDeath to the Legion!','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(114256,'','These demons are providing us with a wealth of information. The fel mysteries of the Burning Legion will make us more powerful. And their secrets will prove their undoing.\n\nNow, how may I help you, $n?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114257,'Aludane, I\'m here for the flight to Stormheim.','Aludane, I\'m here for the flight to Stormheim.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114258,'We have brought crystals infused with the Light from the Exodar. Allow us a moment to enhance your weapon before you battle with the Legion.','',0,0,0,0,0,0,1,0,0,924,0,0,26124),
(114259,'Sit, friend, and enjoy this meal. You cannot fight on an empty stomach.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114260,'Warriors of da Horde, get ya axes and sharpen ya spears. Da Burning Legion has returned ta our world.','',0,0,0,0,0,0,1,0,0,0,71536,0,26124),
(114261,'We fight in the shadows.','',1,0,0,0,0,0,0,0,0,0,62912,0,26124),
(114262,'What needs done?','',6,0,0,0,0,0,0,0,0,0,62913,0,26124),
(114263,'It\'s Shaw. Mathias Shaw.','',1,0,0,0,0,0,0,0,0,0,62914,0,26124),
(114264,'I thought I saw you glance in my direction.','',1,0,0,0,0,0,0,0,0,0,62915,0,26124),
(114265,'Sleep with one eye open.','',1,0,0,0,0,0,0,0,0,0,62908,0,26124),
(114266,'The SI:7 is my cover - don\'t blow it.','',1,0,0,0,0,0,0,0,0,0,62909,0,26124),
(114267,'The job\'s not done yet.','',1,0,0,0,0,0,0,0,0,0,62910,0,26124),
(114268,'Look to the shadows.','',1,0,0,0,0,0,0,0,0,0,62911,0,26124),
(114269,'I have ways of making you not talk.','',1,0,0,0,0,0,0,0,0,0,62916,0,26124),
(114270,'I\'ve killed people for less than this.','',1,0,0,0,0,0,0,0,0,0,62917,0,26124),
(114271,'Drink this - it\'ll make me feel better.','',1,0,0,0,0,0,0,0,0,0,62918,0,26124),
(114272,'I\'ll have my people talk to your people. Sound good?','',1,0,0,0,0,0,0,0,0,0,62919,0,26124),
(114273,'','The Nightmare has birthed an abomination known as Rage Rot. Hunt it down and burn it to the ground.',0,0,0,0,0,0,0,0,0,0,0,70607,26124),
(114274,'','Your deeds will be remembered. Shorel\'aran.',0,0,0,0,0,0,0,0,0,0,0,70608,26124),
(114275,'','The twisted undergrowth known as Kudzilla has arisen in the Thicket. Prune it before it spreads.',0,0,0,0,0,0,0,0,0,0,0,70601,26124),
(114276,'','Well done! The corruption has been cleansed. Al diel shala.',0,0,0,0,0,0,0,0,0,0,0,70602,26124),
(114277,'','There are still druids alive in the Thicket. Find them. Save them.',0,0,0,0,0,0,0,0,0,0,0,70605,26124),
(114278,'','The Dreamweavers owe you much. Thank you.',0,0,0,0,0,0,0,0,0,0,0,70606,26124),
(114279,'','It sickens me to see the majestic beasts of Val\'sharah lost to corruption. They must... be culled.',0,0,0,0,0,0,0,0,0,0,0,70599,26124),
(114280,'','The task is done. I am sorry, I will need a moment...',0,0,0,0,0,0,0,0,0,0,0,70600,26124),
(114281,'Not on my watch! Fan out and take \'em down!','',0,0,0,0,0,0,22,0,0,0,64767,0,26124),
(114282,'Looks like we got more company! Hide the good silverware!','',0,0,0,0,0,0,22,0,0,0,64794,0,26124),
(114283,'Heroes, take down their leader at Gadgetzan! Show \'em we\'ve got hearts of gold... at least 72 percent pure!','',0,0,0,0,0,0,22,0,0,0,64806,0,26124),
(114284,'Nicely done! Not our most profitable day, but the losses could\'ve been worse!','',0,0,0,0,0,0,22,0,0,0,64821,0,26124),
(114285,'Bring \'em down, boys! That one\'s head will make a nice trophy... if we can find a big enough wall.','',0,0,0,0,0,0,22,0,0,0,64755,0,26124),
(114286,'Yikes! What happened?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114287,'... where am I?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114288,'It got cold, then I blacked out! What\'s going on around here?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114289,'It\'s the blood eagle for you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114290,'What a fitting sacrifice you will make. Ha ha ha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114296,'No stopping! Mr. Shackle wants this wreck broken down by sunset!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(114297,'','I doubt you are here for me. Which means you are probably here for the research.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114298,'Who are you? Yes, I am looking to recreate Arrexis\'s ritual.','Who are you? Yes, I am looking to recreate Arrexis\' ritual.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114299,'','You should be able to latch on to that spot at the top of the wall. Follow me!',0,0,0,0,0,0,0,0,0,0,0,69884,26124),
(114300,'The ghostly realm echoes with cries of the accursed ship! Destroy Dread Captain Thedon and release the poor souls chained within the Dread Ship Krazatoa!','',0,0,0,0,0,0,0,0,0,0,70630,0,26124),
(114301,'Well done! The cursed ship shall haunt these seas no longer.','',0,0,0,0,0,0,0,0,0,0,70631,0,26124),
(114302,'How would... You dare mock my imprisonment?! Then receive Loken\'s  punishment in his stead!','',0,0,0,0,0,0,0,0,0,0,63430,0,26124),
(114303,'By killing you, I\'ll earn my way into the Halls of Valor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114304,'','Mommy!',0,0,0,0,0,0,0,0,0,0,0,66227,26124),
(114305,'','Thank -you-. I cannot begin to express my gratitude.',0,0,0,0,0,0,0,0,0,0,0,66376,26124),
(114306,'Rise... Rise from the depths! There\'s plunder to be had!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114307,'Men! Slay these fools and welcome their souls... for eternity!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114308,'The Krazatoa returns to the darkness... for now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114309,'So be it! I\'ll chain you to the ship myself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114310,'Tell me when you are ready to go to the Oculus, $n. I should be able to send you through its wards.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114311,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114312,'No, not yet.','No, not yet.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114313,'Be ready for a fight, $n. You and I will not be welcome here...','',0,0,0,0,0,0,0,0,0,0,69413,0,26124),
(114314,'Our brother has waited in chains long enough!','',0,0,0,0,0,0,0,0,0,0,69414,0,26124),
(114315,'','We\'re not going up there without an extra hand, and that\'s final!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114316,'When you are ready, I will create a portal that leads directly into the Violet Hold.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114317,'There was no trial for Koltira Deathweaver. Our attempts at diplomacy fell on deaf ears.','',0,0,0,0,0,0,0,0,0,0,69415,0,26124),
(114318,'Create the portal.','Create the portal.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114319,'The old masters must be put to rest...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114320,'The Horde and Alliance may be our allies, but the Ebon Blade does not bend the knee...','',0,0,0,0,0,0,0,0,0,0,69416,0,26124),
(114321,'','Maybe you might help us. An old master of magic haunts the ruins here. She must be put to rest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114322,'...not for Sylvanas... not even for the Lich King himself!','',0,0,0,0,0,0,0,0,0,40892,69417,0,26124),
(114323,'This way, quickly!','',0,0,0,0,0,0,0,0,0,0,69418,0,26124),
(114324,'I will come with you to help.','I will come with you to help.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114325,'','Stay close, these ghosts have been agitated by all of the activity in Azsuna these days.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114326,'','We\'re getting close. Keep the other spirits back. The masters remain powerful even in death.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114327,'<The mage darts his eyes back and forth shiftily.>$b$bIs there anything I can do for you, $c? I have... matters... to attend to.','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(114328,'I see you for what you really are, demon. Drop the disguise and face your unmaker!','I see you for what you really are, demon. Drop the disguise and face your unmaker!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114329,'You charade cannot fool these eyes, demon. Reveal yourself!','You charade cannot fool these eyes, demon. Reveal yourself!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114330,'I see your true form, demon. This ends here.','I see you for what you are, demon. This ends here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114331,'Your disguise is pathetic. Drop the act, I\'m sending you back to the nether in pieces.','Your disguise is pathetic. Drop the act, I\'m sending you back to the nether in pieces.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114332,'You\'ve forced my hand, $c. But I\'m not leaving this city without a fight!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(114333,'','I will see you ahead on the bridge. But first, I must find my weapon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114334,'','We must stir the noble hearts of my people.',0,0,0,0,0,0,0,0,6,0,0,67563,26124),
(114335,'','YOU... must show them that Azeroth has not forsaken them.',0,0,0,0,0,0,0,0,6,0,0,67564,26124),
(114336,'','Be at peace, spirit!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114337,'','The fel lord, Lochaber, is hiding somewhere in that mess up there. I have no desire to go anywhere near the gates just to kill one demon. We\'d end up having to wade through hundreds.\n\nOne thing I learned while having him imprisoned is that he\'s got quite the ego. So, I\'m going to call him out in front of all of the others.\n\n<Malace stifles a very unwarden-like giggle.>\n\nLet me know when you\'re ready, demon hunter.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114338,'Glad to see you.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114339,'Siphoning','Siphoning',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114340,'Looks like the Legion\'s taking over Sandsorrow to the west! Get some forces out there on the double!','Looks like the Legion\'s taking over Sandsorrow to the west! Get some forces out there on the double!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(114341,'Found a couple of those demons east at the Caverns too! It\'s a war zone down here!','Found a couple of those demons east at the Caverns too! It\'s a war zone down here!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(114342,'Remember my name.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114343,'Looks like a group of demons are settin\' up camp at the compound to the south! These ogres are in for a big surprise!','Looks like a group of demons are settin\' up camp at the compound to the south! These ogres are in for a big surprise!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(114344,'Tell me about your plan.','Tell me about your plan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114345,'The Legion will triumph. Now and always.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114346,'Since the defeat of the Lich King, I\'ve spent my time around Ulduar learning about Tyr. He was the only titan keeper who fought Loken during his betrayal.','',0,0,0,0,0,0,1,0,0,0,63272,0,26124),
(114347,'I found a vrykul saga describing a powerful shield Tyr crafted for his vrykul champion to carry into battle.','',0,0,0,0,0,0,1,0,0,0,63273,0,26124),
(114348,'I have some ability to speak with the long departed. We may be able to question the hero in this saga directly.','',0,0,0,0,0,0,6,0,0,0,63274,0,26124),
(114349,'Skovald take me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114350,'Aye, that\'s my hope. With your help, we have a chance of finding this artifact.','',0,0,0,0,0,0,5,0,0,0,63275,0,26124),
(114351,'Now I am off to the Halls...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114352,'One of those big one\'s is back at the south gates of Gadgetzan! We\'ll hold \'em off \'til we get some backup!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(114353,'Gadgetzan! North gate\'s under attack again! Thing just appeared out of thin air...','Gadgetzan! North gate\'s under attack again! Thing just appeared out of thin air...',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(114354,'','Ruolin, That was beautiful!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114355,'Ready when you are. Taunt away.','Ready when you are. Taunt away.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114356,'','Lochaber! Come demon, face us. If you are not afraid, that is.',0,0,0,0,0,0,0,0,0,40913,0,0,26124),
(114357,'I FEAR NOTHING! I will kill you on my own. Caria and Varedis send their best regards, $p.','',0,0,0,0,0,0,0,0,0,40913,0,0,26124),
(114358,'I require your aid with a matter of the utmost importance.','',0,0,0,0,0,0,1,0,0,0,63766,0,26124),
(114359,'My sincere apologies for the insistence, $p, but we must speak immediately.','',0,0,0,0,0,0,1,0,0,0,63767,0,26124),
(114360,'Your counsel is paramount to our next move against the Legion.','',0,0,0,0,0,0,1,0,0,0,63768,0,26124),
(114361,'I am here when you are ready.','',0,0,0,0,0,0,1,0,0,0,63769,0,26124),
(114362,'Mrglrmglr? Grlmglrg!','',0,0,0,0,0,0,0,0,0,0,18075,0,26124),
(114363,'Grlgm. Mrglmrglr!','',0,0,0,0,0,0,0,0,0,0,18077,0,26124),
(114364,'Excellent. Meet me at Krasus\' Landing when you are ready.','',0,0,0,0,0,0,66,0,0,0,63770,0,26124),
(114365,'Grmlrgm... mrglrgml mlrmglrg mrmg. Mrgl...','',0,0,0,0,0,0,0,0,0,0,18073,0,26124),
(114366,'Mr. Mrglglrm gestures at you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114367,'Glrgm! Mrglmrlg mrglmglr? Mrl? Grlm?!','',0,0,0,0,0,0,0,0,0,0,18077,0,26124),
(114368,'Mlrgmlrg. Mrlg mrglmr, mlrglrmgr? Grlgmlmrg rglmrglmr.','',0,0,0,0,0,0,0,0,0,0,18075,0,26124),
(114369,'Grmlrgr! Mlrgmlrg mglrm glrmg!','',0,0,0,0,0,0,0,0,0,0,419,0,26124),
(114370,'Mrglglrm! Mrlgmrlg mglr!','',0,0,0,0,0,0,0,0,0,0,416,0,26124),
(114371,'Grlgr mrlgml. Mrglrglmr!','',0,0,0,0,0,0,0,0,0,0,417,0,26124),
(114372,'Mrlgmrlg, mgrmlgr rgmlrgmlr?','',0,0,0,0,0,0,0,0,0,0,416,0,26124),
(114373,'Mrgrlilrgl shakes their head and looks at Pearlhunter Phin.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114374,'Mrglrg! Glrmglmrg mglrmgl gmlrg. Mrglmrg?','',0,0,0,0,0,0,0,0,0,0,419,0,26124),
(114375,'Pearlhunter Phin breaks the cocoon open.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114376,'If you only knew what was coming...','',0,0,0,0,0,0,0,0,0,40924,0,0,26124),
(114377,'%s clucks loudly as it moves in your direction.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114378,'One second I was up, the next I was... well, you know. Take care of yourself. It\'s crazy out here!','One second I was up, the next I was... well, you know. Take care of yourself. It\'s crazy out here!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114379,'Thanks! Now get moving! No telling when they\'ll be back.','Thanks! Now get moving! No telling when they\'ll be back.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114380,'What\'s goin\' on around here?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(114381,'I didn\'t come all the way out here for this!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114382,'There is residual magic all about this island. If you gather some Azsunian pearls, we can use them as foci for some of our magics.','',0,0,0,0,0,0,0,0,0,0,70632,0,26124),
(114383,'Perfect. These specimens are ideal for focusing magic.','',0,0,0,0,0,0,0,0,0,0,70633,0,26124),
(114384,'If you wish, I can take you back up to the mountains.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114385,'Take me to the top of the Galebroken Path.','Take me to the top of the Galebroken Path.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114386,'Take me to Throrim\'s Peak outside the Thorignir Refuge.','Take me to Throrim\'s Peak outside the Thorignir Refuge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114387,'Take me to the top of Thorim\'s Peak.','Take me to the top of Thorim\'s Peak.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114388,'Even if no one here will help us, we must fulfill our duty. Let us pray that what remains of our order will be enough.','',0,0,0,0,0,0,0,0,0,0,63771,0,26124),
(114389,'You... you walk in the path of the Light.\n\nWhat guides you here this day?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114390,'Come to Krasus\' Landing. We may be able to help your order.','Come to Krasus\' Landing. We may be able to help your order.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114391,'If there is any chance of finding aid, Efrina and I will come. Stay, Dawnbreaker.','',0,0,0,0,0,0,2,0,0,0,63776,0,26124),
(114392,'Greenies from sky done grooked my best grookers.$b$bSo we train with the wikkets. Sometimes kings can\'t be choosers!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114393,'','Rest now, sister. Your torment has ended.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114394,'','We are in your debt. I will pass word of your deeds here to Prince Farondis.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114395,'Soulfiend Tagerma preys upon the souls of worthy vrykul! Slay her, and you shall be justly rewarded.','',0,0,0,0,0,0,0,0,0,0,70640,0,26124),
(114396,'The troops are itching for a fight, $n. Why don\'t you show them a few moves?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114397,'Aye, that\'s the one! Shield Hill it is. There\'s no time ta waste.','',0,0,0,0,0,0,0,0,0,0,63772,0,26124),
(114399,'The fallen souls may float adrift for eternity, but none more by her hand. Thank you, champion.','',0,0,0,0,0,0,0,0,0,0,70643,0,26124),
(114400,'Tyrosus, now he\'s a good man. Count me in! There\'s too much danger about to turn down a wee bit o\' help!','',0,0,0,0,0,0,1,0,0,0,63773,0,26124),
(114401,'We may not be alone in this after all, Tahu! Let\'s see what Tyrosus has ta say.','',0,0,0,0,0,0,1,0,0,0,63774,0,26124),
(114402,'Hold them back! We\'re not giving this camp up without a fight!','Hold them back! We\'re not giving this camp up without a fight!',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(114403,'Keep them out! Reinforcements are on the way.','Keep them out! Reinforcements are on the way.',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(114404,'Hold your ground. This war\'s only just beginning.','Hold your ground. This war\'s only just beginning.',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(114405,'Stand up and fight! For the Horde!','Stand up and fight! For the Horde!',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(114406,'We fight no matter what comes our way!','We fight no matter what comes our way!',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(114408,'','Archers, mark your targets!',0,0,0,0,0,0,603,0,0,0,0,66617,26124),
(114409,'No more challengers! Disturb these kings no more!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114410,'Plunder these tombs no more!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114411,'No one has survived this trial ever!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114412,'You\'re needed urgently at Krasus\' Landing first. Tyrosus sent me.','You\'re needed urgently at Krasus\' Landing first. Tyrosus sent me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114413,'No offense, but I don\'t have time to chat. I have a shield to find!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114417,'So we meet again.','',0,0,0,0,0,0,669,0,0,0,66603,0,26124),
(114418,'Your presence was not accounted for, but I believe my hounds will enjoy making a meal of you nonetheless.','',0,0,0,0,0,0,669,0,0,0,66604,0,26124),
(114419,'When they are done tearing you apart limb from limb, they will begin their feast on the magical prisoners within these cells.','',0,0,0,0,0,0,669,0,0,0,66605,0,26124),
(114420,'','Yarrrrr! Thar be Ol\' Eary, terror of the open seas! Now\'s our chance boys, git \'em!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114421,'Once sated, my hounds will charge the city, slaughtering everyone in their path.','',0,0,0,0,0,0,669,0,0,0,66606,0,26124),
(114422,'Dalaran will fall to the Burning Legion!','',0,0,0,0,0,0,669,0,0,0,66607,0,26124),
(114423,'My hounds!','',0,0,0,0,0,0,669,0,0,0,66601,0,26124),
(114424,'You will pay with your life for what you\'ve done!','',0,0,0,0,0,0,669,0,0,0,66602,0,26124),
(114425,'I am forever indebted to you, $n.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114426,'The Light... it BURNS... You will pay for this, $c!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114427,'You have my thanks! I had been hanging there for an eternity.','',1,0,0,0,0,0,0,0,0,0,66496,0,26124),
(114428,'You have much to explain. Why have you betrayed us?','You have much to explain. Why have you betrayed us?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114429,'I would never willingly betray our cause, $n!\n\nI was gathering notes on the Nightborne Soulstone when I was contacted by an emissary of the Empyrean Society. When I arrived at their enclave, our old nemesis Kathra\'natir was waiting for me. \n\nHe has been in my head ever since, controlling my every word and action.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114430,'Yes. It is Meryl he is after. He is using the Nightborne Soulstone and the power of the Nexus to drain Meryl of his power. Together you and I may be able to stop him. \n\nHe is still here, somewhere below. We must find him!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114431,'I see. Is Kathra\'natir behind the attack on Meryl?','Is Kathra\'natir behind the attack on Meryl?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114432,'','How utterly predictable! I knew that you would come.',0,0,0,0,0,0,153,0,0,0,0,63242,26124),
(114433,'I\'ll devour yer parrot ye mutinous blowfish!','I\'ll devour yer parrot ye mutinous blowfish!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114434,'Ye don\' need a sword. Yer face be deadlier! Garr!','Ye don\' need a sword. Yer face be deadlier! Garr!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114435,'Ye fight like a dairy farmer, ye lyin\' scabby halfwit!','Ye fight like a dairy farmer, ye lyin\' scabby halfwit!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114436,'I\'ll skewer yer gizzard, ye fish-kissin\', vile cur...','I\'ll skewer yer gizzard, ye fish-kissin\', vile cur...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114437,'Ye smell of fish an\' swine, ye mermaid marryin\' monkey!','Ye smell of fish an\' swine, ye mermaid marryin\' monkey!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114438,'','I have what I was after. But I stayed just so that I could put an end to you... once and for all!',0,0,0,0,0,0,274,0,0,0,0,63243,26124),
(114439,'A black spot upon thee, ye barnacle bottomed sluggard!','A black spot upon thee, ye barnacle bottomed sluggard!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114440,'','I already have the Sargerite Keystone. But I stayed just so that I could put an end to you... once and for all.',0,0,0,0,0,0,274,0,0,0,0,63244,26124),
(114441,'Ye be as repulsive as a monkey in a negligee!','Ye be as repulsive as a monkey in a negligee!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114442,'','And now you fools have fallen into my trap. Let\'s see how you fare in the dark.',0,0,0,0,0,0,0,0,0,0,0,63245,26124),
(114443,'How about a duel?','How about a duel?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114444,'I could use a good fight.','I could use a good fight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114445,'Show me what you\'ve got!','Show me what you\'ve got!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114446,'Feel like showing me a few pointers?','Feel like showing me a few pointers?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114447,'I admire your skill in battle. How about a quick match?','I admire your skill in battle. How about a quick match?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114448,'Feel like training with me?','Feel like training with me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114449,'Let\'s duel.','Let\'s duel.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114450,'Good battle.','Good battle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114451,'Well struck.','Well struck.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114452,'Thank you for the duel.','Thank you for the duel.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114453,'You have won.','You have won.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114454,'You take care of the Houndmaster, and we\'ll focus our attacks on his hounds.','',0,0,0,0,0,0,1,0,0,0,66616,0,26124),
(114455,'Next time I won\'t be so easy on you!','Next time I won\'t be so easy on you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114456,'You have bested me.','You have bested me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114457,'Fine duel.','Fine duel.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114458,'You take this round.','You take this round.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114459,'I have detected an anomaly in the area drawing power from our network! Locate and dispose of it in any fashion you see fit.','',0,0,0,0,0,0,0,0,0,0,70613,0,26124),
(114460,'Ah, the grid is clearing up nicely. I knew I could count on you!','',0,0,0,0,0,0,0,0,0,0,70614,0,26124),
(114461,'Yer ship has more holes than a sponge, ye slack-jawed cockroach!','Yer ship has more holes than a sponge, ye slack-jawed cockroach!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114462,'\'Tis good ye\'re here. Ye\'ll scare away the rats!','\'Tis good ye\'re here. Ye\'ll scare away the rats!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114463,'\'Tis not enough rum in the world to make yer face look good, ye blasted, sorry sea bass!','\'Tis not enough rum in the world to make yer face look good, ye blasted, sorry sea bass!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114464,'Use protection magic! That damage is too much for me to heal!','',0,0,0,0,0,0,0,0,0,0,63316,0,26124),
(114465,'','I\'ll scout out ahead for a good vantage point. Meet me close to the city wall once you have a grapple.',0,0,0,0,0,0,0,0,0,0,0,69883,26124),
(114466,'There are reports that the Legion brought a demonic watchdog known as Velimar into the city. Convenient! I could use its eyes to enhance the network.','',0,0,0,0,0,0,0,0,0,0,70609,0,26124),
(114467,'Here\'s looking at you!','',0,0,0,0,0,0,0,0,0,0,70610,0,26124),
(114468,'Brothers and sisters, we must not forget the Ashbringer. Tirion may be gone, but the highblade is still out there somewhere.','',1,0,0,0,0,0,0,0,0,0,63775,0,26124),
(114469,'We should leave for Uther\'s Tomb at once.','',0,0,0,0,0,0,1,0,0,0,63795,0,26124),
(114470,'For the Alliance!','For the Alliance!',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(114471,'Give them hell, $n.','Give them hell, $n.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(114472,'This is your ship, $n. Light be with you.','This is your ship, $n. Light be with you.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(114473,'Pearlhunter Phin points at the Leyscar Scuttler.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114474,'Yes, yes! Surrender your power, dragon. These pools belong to the Nightborne now!','',0,0,0,0,0,0,0,0,0,0,62767,0,26124),
(114475,'Help me, small one...','',0,0,0,0,0,0,0,0,0,0,62768,0,26124),
(114476,'It seems the Highlord\'s absence has affected more than just the living.','',0,0,0,0,0,0,3,0,0,0,63814,0,26124),
(114477,'Sudden reappearance of the Scarlet Crusade with a newfound drive to wipe out the undead of the world? I\'ve heard this one before. You\'re a dread lord, aren\'t you?','Sudden reappearance of the Scarlet Crusade with a newfound drive to wipe out the undead of the world? I\'ve heard this one before. You\'re a dread lord, aren\'t you?',0,0,0,0,0,0,0,0,0,40972,0,0,26124),
(114478,'','Unliving scum! Your very existence is an insult to everyone who lost their families to the Scourge. Take that tabard off and crawl back into your grave before I put you there!',5,0,0,0,0,0,0,0,0,40974,0,0,26124),
(114479,'','I suppose you\'ll just have to trust me, won\'t you?',153,0,0,0,0,0,0,0,0,40972,0,0,26124),
(114480,'','Interlopers like you are responsible for gutting the strength of the Scarlet Crusade! We would\'ve eradicated the unliving from this world and the Burning Legion would have never come this far! Begone!',0,0,0,0,0,0,0,0,0,40973,0,0,26124),
(114481,'For the Crusade!','For the Crusade!',0,0,0,0,0,0,0,0,0,40972,0,0,26124),
(114482,'You and I both know your \'order\' is broke and can use every copper you can get your hands on. Quiet your empty protests and take my money.','You and I both know your \'order\' is broke and can use every copper you can get your hands on. Quiet your empty protests and take my money.',0,0,0,0,0,0,0,0,0,40974,0,0,26124),
(114483,'','I can see you\'re a friend of the Crusade. I\'ve managed to smuggle some equipment out of the Monastery in an attempt to raise funds for our order. We will not rest until the unliving have been driven from Azeroth!\n\nDo keep in mind you and your ilk have left us on the verge of ruin, so what I\'m selling won\'t come cheap.',0,0,0,0,0,0,0,0,0,40972,0,0,26124),
(114484,'Plaguemaw scours the seas of Helheim, leaving only carrion in his wake. Destroy this menace!','',0,0,0,0,0,0,0,0,0,0,70642,0,26124),
(114485,'The mortals within Stormheim are forever in your debt. Come, claim your prize.','',0,0,0,0,0,0,0,0,0,0,70644,0,26124),
(114486,'','Ah, the vaunted Duskwatch. If you could liberate some of their supplies, it would greatly aid our cause.',0,0,0,0,0,0,0,0,0,0,0,70615,26124),
(114487,'','Good work. That should slow them down.',0,0,0,0,0,0,0,0,0,0,0,70616,26124),
(114488,'The death of his enforcer should send the right message. Finish the ritual, he\'s sure to attack soon.','',0,0,0,0,0,0,0,0,0,0,64205,0,26124),
(114489,'Look out!','',0,0,0,0,0,0,0,0,0,0,64206,0,26124),
(114490,'I will prepare the ceremony while you assist our allies.','',0,0,0,0,0,0,1,0,0,0,63815,0,26124),
(114491,'That is quite a story. Let\'s go.','That is quite a story. Let\'s go.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114492,'We know how Suramar\'s isolation changed its inhabitants - but what of the plant life? Satisfy my curiosity with samples from the Court of Stars.','',0,0,0,0,0,0,0,0,0,0,70611,0,26124),
(114493,'Interesting. Cultivated with extreme care. It seems even the reckless Nightborne know that life and magic must exist in balance.','',0,0,0,0,0,0,0,0,0,0,70612,0,26124),
(114494,'','The light of Elune no longer shines on the wildkin of this grotto. They have become fearsome owlbeasts and are a danger to all.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114495,'Thank you, little $c. Senegos was wise to trust in you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114496,'What did we do to deserve this?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114497,'As I fell, I saw one of the nightfallen slinking into our caves.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114502,'My spirit perseveres.','',0,0,0,0,0,0,0,0,0,0,62833,0,26124),
(114503,'Let us speak.','',0,0,0,0,0,0,0,0,0,0,62834,0,26124),
(114504,'Farewell.','',0,0,0,0,0,0,0,0,0,0,62830,0,26124),
(114505,'Thank you, friend.','',0,0,0,0,0,0,0,0,0,0,62831,0,26124),
(114506,'','An old student of mine still resides in the city. There once was a time I thought I could trust her. Make sure she understands what happens to traitors.',0,0,0,0,0,0,0,0,0,0,0,70617,26124),
(114507,'','Splendidly done. I wish I could have been there myself.',0,0,0,0,0,0,0,0,0,0,0,70618,26124),
(114508,'','Shar\'thos has returned to his roost. Put him out of his misery before he spreads the taint he has succumb to.',0,0,0,0,0,0,0,0,0,0,0,78723,26124),
(114509,'','Well done! Let us hope that this chapter in Shar\'thos\'s life is forgotten.',0,0,0,0,0,0,0,0,0,0,0,78724,26124),
(114510,'','The nearby wolves have grown too bold. It is time to cull the pack.',0,0,0,0,0,0,0,0,0,0,0,62771,26124),
(114511,'','The day is won! Well fought champion.',0,0,0,0,0,0,0,0,0,0,0,62772,26124),
(114512,'For centuries our order has guarded and kept hidden a sacred site, the Tomb of Tyr.\n\nTyr, a titan keeper, performed many valiant acts for the good of Azeroth until he was brought low by treachery and the power of the Old Gods. The treacherous Loken sent powerful C\'Thraxxi to slay Tyr.  He fought them off, killing one and forcing the other to flee, but it cost him his life.\n\nSome of the vrykul that accompanied Tyr were so moved by his sacrifice they remained behind to guard his tomb. These vrykul were eventually replaced by humans, us. We have kept the world from discovering its location for a very long time... until recently.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114513,'Stories tell of the dark beast, Shroudseeker! It wanders the shadows and plagues this world with illusions - eradicate this foul shade.','',0,0,0,0,0,0,0,0,0,0,70641,0,26124),
(114514,'The deed is now done. You shall be righteously rewarded.','',0,0,0,0,0,0,0,0,0,0,70645,0,26124),
(114516,'We should head to ground level. Let me know when you are ready and I will teleport us there.','',1,0,0,0,0,0,0,0,0,0,66497,0,26124),
(114517,'I\'m ready.','I\'m ready.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114518,'Are you ready to teleport to the ground?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114519,'Kathra\'natir is in the Nexus building. It appears to be heavily guarded! Perhaps we should use an Invisibility spell and walk right in.','',1,0,0,0,0,0,0,0,0,0,67675,0,26124),
(114520,'','I\'ll make my way to Dreadscar Rift as soon as I get this confession in front of the right people.',0,0,0,0,0,0,1,0,0,0,0,66520,26124),
(114521,'','You can count me among those that are willing to fight the Burning Legion at your side.',0,0,0,0,0,0,1,0,0,0,0,66521,26124),
(114522,'Invisibility will not last long. Let\'s go!','',1,0,0,0,0,0,0,0,0,0,66488,0,26124),
(114523,'Form ranks! Weapons ready!','',0,0,0,0,0,0,22,0,0,0,75586,0,26124),
(114524,'Stand strong! Incoming!','',0,0,0,0,0,0,22,0,0,0,75585,0,26124),
(114525,'A Legion vessel is closing in! Take your positions! If you can lift a weapon, pick it up and fight!','',0,0,0,0,0,0,22,0,0,0,75593,0,26124),
(114526,'Unsheathe your weapons! Heed the call of war! The Legion approaches from the north!','',0,0,0,0,0,0,22,0,0,0,75592,0,26124),
(114527,'Hold your ground! Give no quarter to these invaders!','',0,0,0,0,0,0,22,0,0,0,75576,0,26124),
(114528,'Show them our strength! Do not relent!','',0,0,0,0,0,0,22,0,0,0,75577,0,26124),
(114529,'Send these demons back to the Twisting Nether!','',0,0,0,0,0,0,22,0,0,0,75579,0,26124),
(114530,'Ready your blades! Take down the commander!','',0,0,0,0,0,0,22,0,0,0,75580,0,26124),
(114532,'The portals are closing! Rangers, lets finish off the last of these hounds.','',0,0,0,0,0,0,1,0,0,0,66597,0,26124),
(114535,'There... all the components are in place. Activate the Ritual Focus when you are ready.','',0,0,0,0,0,0,0,0,0,0,64199,0,26124),
(114536,'','Look out!',0,0,0,0,0,0,0,0,0,0,0,67515,26124),
(114537,'','Careful, he bites.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114538,'I\'d like an eagle to Trueshot Lodge.','I\'d like an eagle to Trueshot Lodge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114539,'','Good to see you again, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114540,'','We must take care. The withered ones prowl this area, ravenous in their hunger for magic and flesh alike.',0,0,0,0,0,0,0,0,0,0,0,67512,26124),
(114541,'','Stay close!',0,0,0,0,0,0,0,0,0,0,0,67522,26124),
(114542,'','Do not be foolish, outlander. My barrier will protect you.',0,0,0,0,0,0,0,0,0,0,0,67523,26124),
(114543,'We are ready to commune with Lord Uther, $n. Join me at the tomb.','',0,0,0,0,0,0,0,0,0,0,63816,0,26124),
(114544,'These demons dare to befoul Azeroth? Take back what is rightfully ours!','',0,0,0,0,0,0,22,0,0,0,75599,0,26124),
(114545,'Don\'t let them hold an inch of ground! Drive them out!','',0,0,0,0,0,0,22,0,0,0,75598,0,26124),
(114546,'Keeper Remulos appears drained and dazed. The owlbeasts nearly destroyed him.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114547,'Free Remulos from captivity.','Free Remulos from captivity.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114548,'','We must free Keeper Remulos at once! I know a shortcut to the cave he is being held in. Come, $n. Follow me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114549,'Thank you! We must leave this place at once.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114550,'','I hope we are not too late to save Keeper Remulos.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114551,'We made it! Kathra\'natir is inside just ahead.','',1,0,0,0,0,0,0,0,0,0,67676,0,26124),
(114552,'','I know some who would choose the pursuit of power over the needs of others...',0,0,0,0,0,0,1,0,0,0,0,66517,26124),
(114553,'It was never a choice, Kira.','',0,0,0,0,0,0,1,0,0,0,66534,0,26124),
(114554,'Move out! Rid our lands of them!','',0,0,0,0,0,0,22,0,0,0,75596,0,26124),
(114555,'Rest when they\'re dead... or you are! Until then, FIGHT!','',0,0,0,0,0,0,22,0,0,0,75595,0,26124),
(114556,'Get to the Crossroads! Everyone on the leader! Take its head!','',0,0,0,0,0,0,22,0,0,0,75581,0,26124),
(114557,'It\'s attacking the Crossroads! Come and show this monstrosity the price for trespassing on OUR world!','',0,0,0,0,0,0,22,0,0,0,75583,0,26124),
(114558,'Hero, use this rune to empower yourself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114559,'Rally at the Crossroads! Take out the biggest threat!','',0,0,0,0,0,0,22,0,0,0,75582,0,26124),
(114560,'','I\'ll have my people talk to your people. Sound good?',1,0,0,0,0,0,0,0,0,0,0,63223,26124),
(114561,'','Uh-huh. Mhm. Yup. Totally paying attention.',1,0,0,0,0,0,0,0,0,0,0,63224,26124),
(114562,'','Oh, you\'re one of those rogues.',1,0,0,0,0,0,0,0,0,0,0,63225,26124),
(114563,'Well fought! The Legion won\'t soon forget the sting of Kalimdor steel!','',0,0,0,0,0,0,22,0,0,0,75591,0,26124),
(114564,'Victory is ours! But stay strong... the true battle is yet to come!','',0,0,0,0,0,0,22,0,0,0,75590,0,26124),
(114565,'Uther\'s resting place lies just ahead.','',0,0,0,0,0,0,0,0,0,0,63817,0,26124),
(114566,'Your world shall burn!','Your world shall burn!',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(114567,'None can stand against the Burning Legion!','None can stand against the Burning Legion!',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(114568,'Your world is at an end!','Your world is at an end!',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(114569,'The Legion cannot be stopped!','The Legion cannot be stopped!',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(114570,'Your end awaits, mortals!','Your end awaits, mortals!',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(114571,'This will be your end!','This will be your end!',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(114572,'You cannot escape the power of the Burning Legion!','You cannot escape the power of the Burning Legion!',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(114573,'Worthless mortals! You will suffer!','Worthless mortals! You will suffer!',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(114574,'Friend won\'t need to face the Legion alone.','',0,0,0,0,0,0,0,0,0,0,66498,0,26124),
(114575,'Begin when you are ready.','',0,0,0,0,0,0,0,0,0,0,63818,0,26124),
(114576,'I will not rest until the council has been rebuilt.','',0,0,0,0,0,0,1,0,0,0,66535,0,26124),
(114577,'Shard, come to me and strike our enemies down!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114578,'Gravel, crush them into rubble.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114579,'The waters begin to stir!','The waters begin to stir!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114580,'','Welcome aboard, $n. \n\nWe\'re all stocked and ready to ship out just as soon as you\'re ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114581,'I am ready to face the Legion.','I am ready to face the Legion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114582,'Are you prepared to face the Legion at the Broken Shore?','Are you prepared to face the Legion at the Broken Shore?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114583,'Su Hee reveals its true form!','Su Hee reveals its true form!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114584,'$n prepares a Rack of Ribs!','$n prepares a feast of Broiled Dragon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(114585,'$n prepares a pot of Potato Stew!','$n prepares a feast of Broiled Dragon!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(114586,'I resume my watch.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114587,'Damage assessment complete. Defensive mode engaged.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114588,'Puny Elves!  Ettin strongest one there is!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114589,'The others can\'t see me, but I like to watch them go about their business. This is all very exciting. For the longest time, it was just me and the Servants of Illidan who were left behind.\n\nAlas, I am stuck here, for all eternity, in the Twisting Nether. I can never leave, $n.\n\nStill, it was worth it and I would do it all over again. I would gladly sacrifice myself and willingly stand there as you struck me down in order to fuel the final gateway and summon in your demonic forces. It is what was necessary for the cause.\n\nWhat demon hunter wouldn\'t?\n\nLong live the Illidari!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114590,'Light, hear our prayers... for shadows close in around us.','',0,0,0,0,0,0,0,0,4,0,63819,0,26124),
(114591,'Grant us this one audience, so the Ashbringer may yet save our world.','',0,0,0,0,0,0,0,0,4,0,63820,0,26124),
(114592,'Do you know where it is, Uther? We risk everything if we return to that place.','',0,0,0,0,0,0,0,0,4,0,63824,0,26124),
(114593,'The tethers have broken. Selentia is vulnerable!','The tethers have broken. Selentia is vulnerable!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114594,'','The council is in good hands with you as its leader.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114595,'Return to your home.','Return to your home.',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(114596,'This area is off limits. You should leave. Now.','This area is off limits. You should leave. Now.',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(114597,'Rations will be distributed according to the Magistrix\'s orders.','Rations will be distributed according to the Magistrix\'s orders.',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(114598,'You are not authorized to enter the Vineyard.','You are not authorized to enter the Vineyard.',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(114599,'Maintain decorum or suffer the consequences, citizen.','Maintain decorum or suffer the consequences, citizen.',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(114600,'The Vineyards are open to special guests only. You must leave immediately.','The Vineyards are open to special guests only. You must leave immediately.',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(114601,'I\'m starving!','I\'m starving!',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(114602,'Please... I need it!','Please... I need it!',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(114603,'How can you watch me suffer?','How can you watch me suffer?',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(114604,'Let me go inside! Please!','Let me go inside! Please!',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(114605,'I know you\'re keeping some for yourself- please just give me a little!','I know you\'re keeping some for yourself- please just give me a little!',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(114606,'Please help me... please...','Please help me... please...',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(114607,'My daughter is dying! Please, you must help me save her!','My daughter is dying! Please, you must help me save her!',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(114608,'Go home, citizen.','Go home, citizen.',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(114609,'Be on your way now.','Be on your way now.',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(114610,'Maxwell, my old friend! It\'s been too long.','',0,0,0,0,0,0,0,0,4,0,63821,0,26124),
(114611,'Which gives me great honor to say this next part. Mayla Highmountain, I hereby pronounce you High Chieftain. Long may you stand!','',0,0,0,0,0,0,1,0,0,0,63241,0,26124),
(114612,'You\'re both doing the Light\'s work, but if you seek to recover the Ashbringer, you must hurry.','',0,0,0,0,0,0,0,0,4,0,63823,0,26124),
(114613,'I can feel the Ashbringer calling out from an island that lies close to the tomb of the evil one. And the blade is not alone...','',0,0,0,0,0,0,0,0,4,0,63825,0,26124),
(114614,'Tirion still lives, but his light is fading. You must move swiftly, or he will perish! That is all I can tell you.','',0,0,0,0,0,0,0,0,4,0,63826,0,26124),
(114615,'Uther, wait! I have more to ask you! Uther!','',0,0,0,0,0,0,0,0,4,0,63828,0,26124),
(114616,'Good luck, friends. Walk always in the Light.','',0,0,0,0,0,0,0,0,4,0,63827,0,26124),
(114617,'Uther, it\'s really you!','',0,0,0,0,0,0,0,0,4,0,63822,0,26124),
(114618,'','You shall be my new subject\'s first test!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114619,'','Are you ready to return to the prison? We won\'t do much good out here.\n\nWe should rejoin our allies and help take down Hakkar before he has a chance to unleash his beasts onto the city.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114620,'Interested in some magic fishing? Sounds cool right?','',0,0,0,0,0,0,1,0,1,0,0,0,26124),
(114622,'If Tirion is still alive, we will save him... or die trying.','',0,0,0,0,0,0,0,0,0,0,63813,0,26124),
(114624,'Together we can defeat Kathra\'natir! Use the Nightborne Soulstone while we hold him off!','',0,0,0,0,0,0,0,0,0,0,66493,0,26124),
(114626,'Make the boomy fire thing! Make the boom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114627,'I want Snow! Make it snow! Make it Snow! Make it Snow!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114628,'Do Ice Fist human!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114629,'For the Horde!','For the Horde!',0,0,0,0,0,0,71,1,0,0,0,0,26124),
(114630,'Well done everyone!','Well done everyone!',0,0,0,0,0,0,5,1,0,0,0,0,26124),
(114631,'Blood and Honor!','Blood and Honor!',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(114632,'Demon filth!','Demon filth!',0,0,0,0,0,0,5,1,0,0,0,0,26124),
(114633,'We stand as one!','We stand as one!',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(114634,'Might of the Horde!','Might of the Horde!',0,0,0,0,0,0,5,1,0,0,0,0,26124),
(114635,'By our blades!','By our blades!',0,0,0,0,0,0,5,1,0,0,0,0,26124),
(114637,'','A servant of the Old Gods! Let us consume it!',0,0,0,0,0,0,0,0,0,0,0,63457,26124),
(114638,'','There! A spy for N\'Zoth! We should kill it.',0,0,0,0,0,0,0,0,0,0,0,63458,26124),
(114639,'','Do you see it? The poor host cannot be saved, only put down.',0,0,0,0,0,0,0,0,0,0,0,63459,26124),
(114640,'You! $C! Have you been inside the Violet Hold?$b$bThese imbecile guards keep waving me away. Do they not know who I am?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(114641,'Meddling $c... You will pay for your interference. This whole city will burn!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(114643,'','<Thalyssra brings a hand to her gaunt cheek.>$B$BMy body has deteriorated so quickly...$B$BIt seems we Nightborne live each day upon the razor\'s edge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114644,'','I will free Suramar from the Legion, but first I must regain my strength.$B$BAnd we need a plan...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114645,'','I hope my comrades have fared better than me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114646,'$n, I must speak with you, the matter is urgent!','',0,0,0,0,0,0,5,0,0,0,63538,0,26124),
(114647,'It concerns High Overlord Saurfang! I fear he plans to bring doom upon himself!','',0,0,0,0,0,0,5,0,0,0,63539,0,26124),
(114648,'This matter cannot wait, we must speak now!','',0,0,0,0,0,0,5,0,0,0,63540,0,26124),
(114649,'My thanks, champion. I will seek out Thrall and see if he can help.','',0,0,0,0,0,0,1,0,0,0,63541,0,26124),
(114650,'Follow me. This will lead us to the ramparts.','',0,0,0,0,0,0,1,0,0,0,63271,0,26124),
(114651,'Ah, I\'ll wager Eitrigg sent you. His concern is noble, but unnecessary.','',0,0,0,0,0,0,1,0,0,0,75603,0,26124),
(114652,'Recent events weigh heavily on me. There is something I must do.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114653,'What must you do?','What must you do?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114654,'That will teach you to interfere with the Legion\'s plans...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114655,'','With Hakkar dead, the citizens of Dalaran will be safe. Most will never know the threat they faced, thanks to your heroic actions.',0,0,0,0,0,0,1,0,0,0,0,66619,26124),
(114656,'','You struck the fel lord down before he had a chance to terrorize the city. You upheld the oath we all took to watch and protect.',0,0,0,0,0,0,1,0,0,0,0,66620,26124),
(114657,'','It would be naive to assume this is the last threat Azeroth will face.',0,0,0,0,0,0,6,0,0,0,0,66621,26124),
(114658,'','The Burning Legion is at our doorstep, demanding to be reckoned with.',0,0,0,0,0,0,603,0,0,0,0,66622,26124),
(114659,'','In times like these, our oath is more important than ever.',0,0,0,0,0,0,1,0,0,0,0,66623,26124),
(114660,'That battle, I can find no glory in it. Too many died, but I did not. The anger within me grows every minute I stare at that storm.\n\nI will return to the Broken Shore, for those under my command. I will kill demons until their glory is found and my honor restored. Do not seek to counsel against this, I am set in my ways.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114661,'','We do not fight for glory, for fame, or riches.',0,0,0,0,0,0,274,0,0,0,0,66624,26124),
(114662,'','We exist to protect those who need it most, often without reward or recognition.',0,0,0,0,0,0,1,0,0,0,0,66625,26124),
(114663,'Then I will go with you. No one should fight alone.','Then I will go with you.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114664,'','We are the watchers in the wild.',0,0,0,0,0,0,1,0,0,0,0,66626,26124),
(114665,'','We are the eagle on the wind.',0,0,0,0,0,0,1,0,0,0,0,61851,26124),
(114666,'','We walk the lonely road.',0,0,0,0,0,0,1,0,0,0,0,61852,26124),
(114667,'','For ours is the Unseen Path.',0,0,0,0,0,0,1,0,0,0,0,61853,26124),
(114668,'Death is our likely end on those shores. You know this, yet I can see the determination in your eyes. Perhaps you have honor to regain there as well.','',0,0,0,0,0,0,1,0,0,0,75604,0,26124),
(114669,'The others should be waiting for you in the sanctum beneath the chapel, $n.','The others should be waiting for you in the sanctum beneath the chapel, $n.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(114670,'The others await you in the sanctum beneath the chapel, $n.','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(114671,'%s nudges Maxwell\'s ankle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114673,'%s grunts and shoves the goat away, embarrased.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114677,'Commander! I have a message for you!','',0,0,0,0,0,0,5,0,0,0,63534,0,26124),
(114678,'I bear an important message from Danath Trollbane!','',0,0,0,0,0,0,1,0,0,0,63535,0,26124),
(114679,'If you please, this is an urgent matter that requires your attention!','',0,0,0,0,0,0,1,0,0,0,63536,0,26124),
(114680,'Excellent, commander. Danath awaits you on Krasus\' Landing.','',0,0,0,0,0,0,1,0,0,0,63537,0,26124),
(114681,'Rokmora creates |cFFFF0000|Hspell:215898|h[Crystaline Ground]|h|r! Don\'t move!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114682,'<Caprina reeks of animal fur and dung.>$b$bWhat\'re you looking at, $c? Why don\'t you go bother Crawford or Heathrow?','',5,6,0,0,0,0,0,0,0,0,0,0,26124),
(114683,'Blast you, $c scum! My ruse was flawless!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114684,'My masters will hear of this... The Legion will set this whole coast aflame...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114685,'I hope ya shot that demon right between the eyes!','',0,0,0,0,0,0,603,0,0,0,66629,0,26124),
(114697,'Look there, upon that terrible sight. How many disasters must we face before we can at last find peace?','',6,0,0,0,0,0,0,0,0,0,63543,0,26124),
(114706,'The nightmare consumes, $c. It devours from within. It overwhelms one\'s thoughts as easily as it creeps across the terrain.$b$bInevitably, the mind fills with shadows, and all hope is eclipsed.$b$bIt is terrible. It is... beautiful...','',1,661,0,0,0,0,0,0,0,0,0,0,26124),
(114707,'I am revealed! Fight me if you must - your kind will never win.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114708,'All things must end. The dream is dead. Forever.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114709,'Tiny mortal. Your insolence has come to an end.','',0,0,0,0,0,0,0,0,0,0,66906,0,26124),
(114710,'You and your Illidari will join the Burning Legion. You will become Felsworn.','',0,0,0,0,0,0,0,0,0,0,66916,0,26124),
(114711,'You may grovel now, demon hunter.','',0,0,0,0,0,0,0,0,0,0,66917,0,26124),
(114712,'Very well. You have sealed your fate. Varedis and Caria will deal with you.','',0,0,0,0,0,0,0,0,0,0,66918,0,26124),
(114713,'The Molten Charskin becomes |cFFFF0000|Hspell:200672|h[Crystal Cracked]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114714,'$n! Kil\'jaeden has ordered your capture. You will join the Burning Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114715,'Kil\'jaeden will have you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114716,'','How touching. A few more champions. As if that will help in any way.',0,0,0,0,0,0,1,0,0,0,0,66984,26124),
(114717,'Quite the ragtag bunch you have here, $n. I would have thought you could do better.','',0,0,0,0,0,0,1,0,0,0,66919,0,26124),
(114718,'But, enough with the pleasantries. Our lord, Kil\'jaeden, has sent us to let you know that you and your Illidari will soon be joining the Burning Legion...','',0,0,0,0,0,0,1,0,0,0,66920,0,26124),
(114719,'','... and to prove that you are not safe, not even here on the Fel Hammer.',0,0,0,0,0,0,1,0,0,0,0,66921,26124),
(114720,'Hear me, Illidari! All present are welcome into the embrace of the Legion.','',0,0,0,0,0,0,53,0,0,0,66922,0,26124),
(114721,'','Great power will be imbued into those who join us. Painful agony awaits those who do not.',0,0,0,0,0,0,1,0,0,0,0,66923,26124),
(114722,'I for one hope that you refuse. Then, those warglaives will once again return to their rightful owner.','',0,0,0,0,0,0,1,0,0,0,66927,0,26124),
(114723,'','Tsk, tsk, Varedis. Fair is fair. Until we meet again in the flesh, $n.',0,0,0,0,0,0,1,0,0,0,0,66928,26124),
(114724,'Strike me down, you fools, before Razelikh regains control!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(114725,'And now, to break these fetters and feast upon your souls. Ahahahahahaha!','',0,0,0,0,0,0,463,8,0,0,0,0,26124),
(114726,'NO, demon! You will not prevail.','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(114727,'$p. Illidari. Hear me. I will take great pleasure in sacrificing each of you to Kil\'jaeden just as soon as I break Loramus\'s hold on my body.','',0,0,0,0,0,0,15,8,0,0,0,0,26124),
(114728,'How long must I endure?!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(114729,'An eternity of exquisite pain and suffering await you. Know my name, Illidari, for I am Razelikh the Defiler!','',0,0,0,0,0,0,463,8,0,0,0,0,26124),
(114730,'I am Loramus... no, I AM RAZELIKH! Enough demon, you will submit. I compel you!','',0,0,0,0,0,0,463,0,0,0,0,0,26124),
(114731,'NOTHING CAN PREVENT YOUR WORLD FROM BURNING!','',0,0,0,0,0,0,463,8,0,0,0,0,26124),
(114732,'I will do my best to keep control over Razelikh and share all of its demonic knowledge with you.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114733,'Allow me to assure you, demon hunters, that you cannot trust anything that comes out of this mouth.','',0,0,0,0,0,0,1,8,0,0,0,0,26124),
(114734,'While Razelikh is not privy to the Legion\'s current plans, he does know a great deal of magic that can give us an edge.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114735,'Thank you for bringing me into your midst, $p. This \"trap\" will not be able to hold me forever.','',0,0,0,0,0,0,1,8,0,0,0,0,26124),
(114736,'It is an honor to do whatever I can to defeat the Burning Legion, $p.','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(114737,'When the Legion comes, and allow me to assure that they will, your little command center here will not be able to protect you.','',0,0,0,0,0,0,1,8,0,0,0,0,26124),
(114738,'There is a Felsworn hiding amongst you. Did you know that?','',0,0,0,0,0,0,25,8,0,0,0,0,26124),
(114739,'For years, our souls struggled against each other in the Twisting Nether. Then recently, we appeared back on Azeroth. That is how I found myself fighting for control of this new dreadlord body.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114740,'The Scarlet Crusade is blinded by hatred and fear... driven to madness and murder. They are beyond redemption and undeserving of mercy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114741,'Now, kneel. Kneel before your new master!','',0,0,0,0,0,0,25,0,0,0,63802,0,26124),
(114742,'You cannot fight my will. You are mine.','',0,0,0,0,0,0,1,0,0,0,63803,0,26124),
(114743,'Very well. This will be a fine test.','',0,0,0,0,0,0,0,0,0,0,63804,0,26124),
(114744,'Give me the strength... to shatter these bonds....','',0,0,0,0,0,0,0,0,0,0,63789,0,26124),
(114745,'','The powerful wizard, Padawsen, has been captured by Humongris. Find Humongris and kill him before he kills Pawdawen.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114746,'','Humongris is dead, and Padawsen is alive. Well done.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114747,'Squish you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114748,'','You could not kill me if you tried for a hundred years!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114749,'','Each must die someday.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114750,'Some call me eccentric or even daft, but they fail to see the bigger picture. Our only hope in defeating the burning legion is to find new sources of power, even if that means taking great risks. \n\nYour new weapon is a testament to that!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114751,'','You have defiled the old ways, mystic! The God-King is not worthy of the Halls of Valor!',0,0,0,0,0,0,0,0,0,0,0,69882,26124),
(114752,'I spit on your ancient rites, shieldmaiden!','',0,0,0,0,0,0,0,0,0,0,69872,0,26124),
(114753,'I would see you banished before I allow you to grant judgment to an outsider!','',0,0,0,0,0,0,0,0,0,0,69871,0,26124),
(114754,'There\'s the Nightborne Soulstone! He\'s using it against an image of Meryl...','',1,0,0,0,0,0,0,0,0,0,66494,0,26124),
(114755,'Did you really think you could defeat me, little mage? I am invincible!','',0,0,0,0,0,0,0,0,0,0,66495,0,26124),
(114756,'You have done it! Kathra\'natir is safely imprisoned within the Nightborne Soulstone!','',1,0,0,0,0,0,0,0,0,0,66489,0,26124),
(114757,'Well done, my mortal friend! We should bring that back to the Hall of the Guardian for safekeeping.','',4,0,0,0,0,0,0,0,0,0,66490,0,26124),
(114758,'','I would not have thought it possible had I not witnessed it myself. Bravo!',1,0,0,0,0,0,0,0,0,0,0,66491,26124),
(114759,'Thanks to you, a great weight has been lifted. Let us return to the Hall of the Guardian.','',1,0,0,0,0,0,0,0,0,0,66492,0,26124),
(114760,'Halt!','Halt!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114761,'Stop right there!','Stop right there!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114762,'Learn your place, dog!','Learn your place, dog!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114763,'Stand back!','Stand back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114764,'You are out of line!','You are out of line!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114765,'You forget your station, filth!','You forget your station, filth!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114766,'Begone!','Begone!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114767,'I can\'t take this anymore! Let me in!','I can\'t take this anymore! Let me in!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114768,'I know you have more! Give me the wine!','I know you have more! Give me the wine!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114769,'I can\'t live like this!','I can\'t live like this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114770,'Now to select the appropriate target. A Soul Engine, perhaps? That battleship might do...','',0,0,0,0,0,0,0,0,0,0,75605,0,26124),
(114771,'Cannons! Fly low and dodge the blasts!','',0,0,0,0,0,0,0,0,0,0,75606,0,26124),
(114772,'<roars> Make them pay, $n! Make them--','',0,0,0,0,0,0,0,0,0,0,75607,0,26124),
(114773,'I am ogre. Totally ogre. Definitely not... NOT ogre.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(114774,'Braaahhhgg magic disguise stupid plan anyways. It is time to kill!','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(114775,'Brah hah. Hah hah. Smashed. Disguises are a good plan. Hah hah.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114776,'You can\'t keep me out!','You can\'t keep me out!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114777,'Please! Please help me!','Please! Please help me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114778,'I\'ll die without it! You have to help me!','I\'ll die without it! You have to help me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114779,'I have to do something!','I have to do something!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114780,'I am shal\'dorei! I will not be denied!','I am shal\'dorei! I will not be denied!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114781,'$n prepares a Bushel of Apples!','$n prepares a Bushel of Apples!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(114782,'Mrgrlilgrl! Mrglmr gmrlgrmglr?!','',0,0,0,0,0,0,0,0,0,0,419,0,26124),
(114783,'Legion, come to our aid!','Legion, come to our aid!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114785,'To me, servant!','To me, servant!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114786,'Illidari, prepare for jump to Niskara!','',0,0,0,0,0,0,22,0,0,0,66904,0,26124),
(114787,'Illidari, prepare for the jump to Niskara!','',0,0,0,0,0,0,22,0,0,0,66905,0,26124),
(114788,'Wikket got water, clear and pure, \'fore greenies from sky could dook it for sure.','',0,0,0,0,0,0,0,0,0,0,64436,0,26124),
(114789,'Hurry up, wikket, make your feet into dancers! For my riddles you\'ll go off and find all the answers.','',0,0,0,0,0,0,0,0,0,0,64437,0,26124),
(114790,'My flesh is yours, Naraxas!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114791,'Take me, Mother of Worms!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114792,'Consume my blood for power!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114793,'That\'s one... that\'s two... ah yes, that is three! Now we find out if right wikket be!','',0,0,0,0,0,0,0,0,0,0,64417,0,26124),
(114794,'Glmrg! Gmlrgm mglrmgrl mrmglr!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114795,'There was an ancient parable. About a woodcutter. He chopped wood as the forest burned.$b$b\"Why is it you chop wood?\" they ask him. \"The forest burns. Soon your house will burn.\"$b$bThe woodcutter, he watches the flames, he breathes in the smoke. \"Who am I to change?\" he asks. \"I am what I am.\"$b$b<Dareer chops another cord of wood.>$b$bThere is no moral.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114796,'You play with fire, fool $c! YOU WILL BURN!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114797,'The light... my flesh... No no NO you will ruin everything, fool of a $c!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114798,'No place is safe. No mountain is too high to flee from the Legion\'s rage. I will return!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114799,'I want snow! Make the snow!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114800,'Stop shaking me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114801,'I am going to be sick!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114802,'Whaaaaaaaaaaaaa!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114803,'OK, just stop squeezing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114804,'You are crushing me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114805,'Gaaahh! My spine is going to Gaaarg!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114806,'It is called Ice Block, you big stupid Arrggghhh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114807,'Not again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114808,'Watch out!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114809,'Please help me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114810,'Come on, don\'t stand in the Blizzard!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114811,'Guys we have come a long way... Argggh','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114812,'Don\'t panic, we can do this... Aaahhhhh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114813,'Grrrrargg... No! No! Not the eyes...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114814,'Guys, thanks. I am really proud of you. You all did a really great job.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114815,'What...? Dareer was a demon all along? How did we not see that coming?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(114816,'','Well, that explains the chanting coming from his tent at all hours of the night. And the smell of sulphur.',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(114817,'|TInterface\\Icons\\Spell_Shadow_Possession:20|t Legertha begins to cast |cFFFF0404|Hspell:57697|h[Horrific Visage]|h|r. Look away!','|TInterface\\Icons\\Spell_Shadow_Possession:20|t Legertha begins to cast |cFFFF0404|Hspell:57697|h[Horrific Visage]|h|r. Look away!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114818,'Tirion! By all that is holy... what have they done to you?','',0,0,0,0,0,0,0,0,0,0,63799,0,26124),
(114819,'I\'ll break Tirion free. You must find the Ashbringer while there\'s still time!','',0,0,0,0,0,0,0,0,0,0,63801,0,26124),
(114820,'This place is filthy with corruption. I fear a long campaign awaits us.','',0,0,0,0,0,0,0,0,0,0,63545,0,26124),
(114821,'Look out! Evasive maneuvers!','',0,0,0,0,0,0,0,0,0,0,63546,0,26124),
(114822,'<grunts> Get out of here, $n! I\'ll find my--','',0,0,0,0,0,0,0,0,0,0,63547,0,26124),
(114823,'<The houndmaster grunts at you and glares with feral eyes.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114824,'My work here is not finished. Die, meddling $c!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114825,'We will sow havoc behind the lines. Nowhere is safe.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114826,'REUSE','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114827,'This power... it burns so brightly.$b$bMy brothers are fools to ignore this gift. Once I have enough energy I could take back the city by myself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114828,'Light... grant me one final blessing...','',0,0,0,0,0,0,0,0,0,0,63788,0,26124),
(114829,'Moving into position above Niskara.','',0,0,0,0,0,0,0,0,6,0,66911,0,26124),
(114830,'Moving into position above Niskara.','',0,0,0,0,0,0,0,0,6,0,66912,0,26124),
(114831,'Everyone up top. Commence bombardment!','',0,0,0,0,0,0,0,0,6,0,66913,0,26124),
(114832,'Everyone up top. Commence bombardment!','',0,0,0,0,0,0,0,0,6,0,66915,0,26124),
(114833,'Do not lose faith...','',0,0,0,0,0,0,0,0,0,0,63790,0,26124),
(114834,'This... is our final stand...','',0,0,0,0,0,0,0,0,0,0,63791,0,26124),
(114835,'The hour of justice... has come...','',0,0,0,0,0,0,0,0,0,0,63792,0,26124),
(114836,'We must... unite...','',0,0,0,0,0,0,0,0,0,0,63793,0,26124),
(114837,'Together...','',0,0,0,0,0,0,0,0,0,0,63794,0,26124),
(114838,'|TInterface\\Icons\\spell_fire_playingwithfiregreen:20|t %s gains |cFFFF0000|Hspell:208903|h[Burning Claws]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(114839,'You again?! Do you really think to beat me, with the Legion at my side?','',0,0,0,0,0,0,0,0,0,0,69870,0,26124),
(114840,'Give up, fool! The Bonespeakers will never let an outsider be judged worthy!','',0,0,0,0,0,0,0,0,0,0,71123,0,26124),
(114841,'We make our last stand at the Vault of Lights! If you can make your way here you will find sanctuary, although I cannot say for how long...','',0,0,0,0,0,0,0,0,0,0,70901,0,26124),
(114842,'Did your visions foretell of this day, Prophet? Did you see our coming?','',0,0,0,0,0,0,0,0,0,0,70847,0,26124),
(114843,'I bring you a message from Kil\'jaeden, to be served in the blood of your people! JUSTICE WILL BE MET!','',0,0,0,0,0,0,0,0,0,0,70846,0,26124),
(114844,'A coward\'s death to these traitorous \"draenei!\" Mar their corpses so the living may see the fate that awaits them!','',0,0,0,0,0,0,0,0,0,0,70845,0,26124),
(114845,'','I can get us access to the Violet Hold, where we\'ll be able to fight Hakkar without worry of any collateral damage.',0,0,0,0,0,0,603,0,0,0,0,66628,26124),
(114847,'|TInterface\\Icons\\inv_jewelcrafting_immactaladite_purple:20|t Boulderfall begins to cast |cFFFF0404|Hspell:216970|h[Elemental Resonance]|h|r. Find cover!','|TInterface\\Icons\\inv_jewelcrafting_immactaladite_purple:20|t Boulderfall begins to cast |cFFFF0404|Hspell:216970|h[Elemental Resonance]|h|r. Find cover!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114848,'You are out of your league, paladin.','',0,0,0,0,0,0,0,0,0,0,63805,0,26124),
(114849,'You are here because I will it. You live because I will it. And you will serve because I will it!','',0,0,0,0,0,0,0,0,0,0,63806,0,26124),
(114850,'','Our father\'s memorial is just around the corner. I am sure you will find Anarys nearby.',0,0,0,0,0,0,0,0,0,0,0,67238,26124),
(114851,'Bats bats bats.$b$bBats bats. Bats.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(114852,'Arghh - no. NO! My disguise. I am Legion. I will destroy you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114853,'Heh he hah... BATS!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114855,'I am nathrezim. Your efforts mean nothing!','',0,0,0,0,0,0,0,0,0,0,63807,0,26124),
(114856,'Do you think me so foolish as to stand alone?','',0,0,0,0,0,0,0,0,0,0,63808,0,26124),
(114857,'Give up, before I lose my patience.','',0,0,0,0,0,0,0,0,0,0,63809,0,26124),
(114858,'I can hear you up there! You demons better think twice before coming down here!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(114859,'I\'ve got a wrench and a very angry leper gnome! You better keep out, demons!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(114860,'You there! I see you! Come and get me when this is over! Until then, please go away. You\'ll bring them here!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(114861,'','Try not to stare too long. For the upper echelons of our society, this place is hardly a distraction.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114863,'','I\'ve procured a palanquin for you. Try to look imperious- it helps with the illusion.',0,0,0,0,0,0,0,0,0,0,0,67565,26124),
(114864,'','The woman you are looking for is named Margaux. She has shown interest in our cause.',0,0,0,0,0,0,0,0,0,0,0,67566,26124),
(114865,'Surely there\'s some way I can still be of some use.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114866,'Never caught a glimpse of what it was until it was too late.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114867,'','<Malefica watches the other druids intensely, until your presence disturbs her.>$b$bShhhh, $c. I am listening.$b$b<She turns her attention back to the nearby druids.>',6,0,0,0,0,0,6,0,0,0,0,0,26124),
(114868,'','Oh you terrible thing - I wasn\'t done here yet. Die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114869,'Cheer up. You\'ll be back on yer feet in no time.','',0,0,0,0,0,0,396,7,0,0,0,0,26124),
(114870,'Ye sure don\'t look like yerself, but... I\'m sure you\'ll be back ta normal in no time!','',0,0,0,0,0,0,396,7,0,0,0,0,26124),
(114871,'','My my, that was fun. We should do this again sometime.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114872,'Take yer rest. Ye ought ta be better in no time.','',0,0,0,0,0,0,396,7,0,0,0,0,26124),
(114873,'Ohh! This taste! I must have more!','',0,0,0,0,0,0,0,0,0,0,64390,0,26124),
(114874,'No! You no take! I kills the thief!','',0,0,0,0,0,0,0,0,0,0,64388,0,26124),
(114875,'Noooooo! Mine...','',0,0,0,0,0,0,0,0,0,0,64389,0,26124),
(114876,'I\'ll have ta come back when I\'m a tad stronger.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114877,'Still a tad bit weak. I\'ll return once I\'m sure I can fight by yer side.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114878,'Don\'t ask. Just be ready to fight.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114879,'These wounds? Hah! They\'ll make me a nice little story ta tell.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114880,'I walk the land. I watch. I listen.$b$bThat is probably why you haven\'t seen me here before. Nothing suspicious.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114881,'Leave me, $c! The Legion sees all! The Legion knows all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114882,'You are pathetic. I will be back.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114883,'Ready yer weapons! Don\'t be caught off guard!','',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(114884,'For the Alliance!','',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(114885,'Time fer battle!','',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(114886,'Sharpen yer blades! This ain\'t o\'er yet!','',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(114887,'My blade\'s ready fer a little action!','',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(114888,'Think they can come into our lands and cause a bit o\' trouble, eh? We\'ll see about that!','',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(114889,'Wooo-hoo! This here wikket is makin\' good speed! But with my other riddles can this one succeed?','',0,0,0,0,0,0,0,0,0,0,64439,0,26124),
(114890,'What smells like dook? Oh, it is this strong brew. Wikket watch out! Don\'t spill it on you!','',0,0,0,0,0,0,0,0,0,0,64438,0,26124),
(114891,'I owe much to you, $n. I hope I am able to repay you in time.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114892,'Your deeds are quickly becoming the talk of the Hall, $n! I am proud to serve as your Champion.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114893,'With your guidance to lead us, I am sure we will prevail against the Burning Legion!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114894,'','The Hall of the Guardian\'s library rivals Silvermoon City\'s even in its current disarray. I will make sure that the Magisters support our efforts here.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114895,'','This place contains a wealth of knowledge, $n! I have been reading a fascinating history of the Council of Tirisfal. Did you know that Meryl and Alodi actually created the Forge of the Guardians?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114896,'','You heard \'em! Ready up!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(114897,'Not quite cut out fer this, I\'m afraid. Come back an\' see me when this is all over.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114898,'','You\'re quite brave, ya know. Think it best if I stay inside \'til it\'s a bit safer out here.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114899,'You\'re right, $n. With a brave $c like you by my side we\'d be unstoppable!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(114900,'Just me and you. Fightin\' off those demons!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114901,'Ah... who am I kidding? I\'m not a fighter. I better head inside. You be safe out here!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114902,'Aww... Me head! Thanks fer helpin\' me up. I\'ll be back when I can stand on me feet long enough ta help.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114903,'Oof! Need to fetch me a few weapons. Seem ta have lost mine... just can\'t remember where.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114904,'Where am I? Let me get my head on straight and I\'ll be back.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114905,'One of \'em nearly took me head off! I\'ll track \'em down. You keep on, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114906,'Thank ya $glad:lass;.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114907,'$n! When you defeated Kathra\'natir, I felt a great weight leave my mind!','',1,0,0,0,0,0,0,0,0,0,71754,0,26124),
(114908,'I have not been this well in an eternity. The Nightborne Soulstone has rendered Kathra\'natir completely powerless. You have my utmost gratitude.','',0,0,0,0,0,0,0,0,0,0,71756,0,26124),
(114909,'','Don\'t just stand there waiting to be killed. Attack. Deploy the devastators!',0,0,0,0,0,0,0,0,0,0,0,66914,26124),
(114910,'I think our luck is changing for the better, old friend. With our newest Archmage and the might of the Tirisgarde, we will defeat the burning legion!','',1,0,0,0,0,0,0,0,0,0,71585,0,26124),
(114911,'','You are a shining example of the strength of the new Tirisgarde! To our newest Archmage, $n!',4,0,0,0,0,0,0,0,0,0,0,74825,26124),
(114912,'Finally... the Nightborne Soulstone! All mine... I mean ours, of course!','',1,0,0,0,0,0,0,0,0,0,67678,0,26124),
(114913,'Unfortunately we will be unable to keep that promise, Millhouse. So long as the Soulstone serves as Kathra\'natir\'s prison it is best left untouched. I\'m sure there are plenty of other powerful artifacts out there for you to find!','',1,0,0,0,0,0,0,0,0,0,67679,0,26124),
(114916,'Arms at the ready! We\'ve got comp\'ny!','Arms at the ready! We\'ve got comp\'ny!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(114917,'','Best get goin\' \'fore I\'m put out fer good.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114918,'The inhabitants of Kharanos have been inspired to join the fight against the Legion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114919,'Ahh... have you come to learn more about the ancient art of wine making?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114920,'Another connoisseur? Perhaps you\'d like to help me prepare the unfortified wine?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114921,'There is nothing quite like the smell of fresh wine, ready for the barrel. Try making some for yourself, and you\'ll see!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114922,'Yes, I am ready to help make arcwine.','Yes, I am ready to help make arcwine.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114923,'Let\'s begin then. I\'ll call out what you need to do, just follow my instructions.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114924,'Have any rare fishing goods?','Have any rare fishing goods?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114925,'Blast! I\'m not your friend anymore.','',1,0,0,0,0,0,0,0,0,0,67680,0,26124),
(114926,'','Someone looks thirsty!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114927,'','Looks like you need a hand, Ilsa.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114928,'Your Brewfest is a sham! One day, everyone will recognize that Dire Brew is the best!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114929,'Thank you for letting me be a guest in your hall. I wish we were meeting under better circumstances.','',0,0,0,0,0,0,1,0,0,0,66560,0,26124),
(114930,'You have my thanks.','',0,0,0,0,0,0,1,0,0,0,66561,0,26124),
(114931,'Please teleport me back to Dalaran.','Please teleport me back to Dalaran.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114932,'This three year Infusion incorporates delightful berry elements with a scintillating melon bouquet. Refreshing, yes?','',0,0,0,0,0,0,0,0,0,0,66176,0,26124),
(114933,'Ah, this is a fine vintage. Seventh generation manafruit entangled with slippery nightsap flavors and a delicate walnut finish.','',0,0,0,0,0,0,0,0,0,0,66177,0,26124),
(114934,'This is a heavy blend of barely-ripe shadowberry and manafruit, triple infused with Nightwell essence. It is best appreciated in small sips.','',0,0,0,0,0,0,0,0,0,0,66178,0,26124),
(114936,'Here comes a flower, Father!','',0,0,0,0,0,0,0,168,0,0,0,0,26124),
(114937,'Oh yes, it\'s a flower.','',0,0,0,0,0,0,0,168,0,0,0,0,26124),
(114938,'I have a drowned mana for you.','I have drowned mana for you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114939,'Get into the vat and jump on the fruit!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(114940,'The batch needs something sour... something shady.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114941,'You need to add a bit of moisture or you\'ll back up the taps!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114942,'Toss in something floral for a bit of class.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114943,'','Let us be off. Follow me!',0,0,0,0,0,0,0,0,0,0,0,63976,26124),
(114944,'','Talonclaw has been lost for so long that many tauren have never even laid eyes upon it. The elders still tell stories of how our greatest hunters wielded the spear in defense of our land.',0,0,0,0,0,0,0,0,0,0,0,63977,26124),
(114945,'','These heroes slew terrible monsters and fought off countless invaders. Dorro Highmountain was last to wield it. His end came at the claws of a corrupted nightsaber that preyed upon our villages.',0,0,0,0,0,0,0,0,0,0,0,63978,26124),
(114946,'It is sobering to think of how easily Kathra\'natir subverted my will. Thanks to $n\'s hard work, I am free and he is not.','',1,0,0,0,0,0,0,0,0,0,67681,0,26124),
(114947,'','We called the beast Dakarr. A once noble creature, driven to madness by a deranged vrykul mystic. Dorro fought it off, then tracked the beast back to Stormheim. He never returned, and Talonclaw was never seen again.',0,0,0,0,0,0,0,0,0,0,0,63979,26124),
(114948,'','It is my hope that one day our tribe may know peace.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114949,'','The Unseen Path is always welcome here.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114950,'That\'s it! A great batch, for an amateur. I\'ll have it bottled at once!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114951,'<Give Silkweave Bandages.>','<Give Silkweave Bandages.>',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114952,'<Give Highmountain Salmon.>','<Give Highmountain Salmon.>',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114953,'<Give Big Gamy Ribs.>','<Give Big Gamy Ribs.>',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114954,'They\'re everywhere...','They\'re everywhere...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114955,'','Enjoying the vineyard?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114956,'','Thank you, $n.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(114957,'As I feared. The arcan\'dor is in peril.','',0,0,0,0,0,0,0,0,0,0,66368,0,26124),
(114959,'','I remember seeing something like this before. But where...',0,0,0,0,0,0,0,0,0,0,0,67587,26124),
(114960,'','Ah! The vineyards!',0,0,0,0,0,0,0,0,0,0,0,67588,26124),
(114961,'','We ride together.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114962,'Your counsel is requested.','Your counsel is requested.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114963,'','I think you\'ll enjoy the view, $p. Let\'s go!',0,0,0,0,0,0,1,0,0,0,0,64688,26124),
(114964,'','May I help you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114965,'','Please feel free to look around.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114966,'<Show your Sigil.>','<Show your Sigil.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114967,'I am so glad I was right to choose you for the Tirisgarde, Archmage $n!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114968,'Archmage $n! You have certainly earned the title, my friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114969,'You are the most dynamic Archmage I have encountered in centuries, $n. I am proud to call myself your champion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114970,'','Very well, Highlord. I will give an accurate account of our army and our operations.',0,0,0,0,0,0,0,0,0,0,0,68363,26124),
(114971,'','I had heard rumors... they seemed a little too good to be true.\n\nBear with me- we will need to tread carefully to avoid arousing suspicion. They are... not kind to us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114972,'','Margaux glances to each side, silently assessing the situation.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114973,'','A tour? Of course! I will show you the grounds myself.',0,0,0,0,0,0,0,0,0,0,0,66287,26124),
(114974,'I see your hunt was a success! I had no doubt it would be, of course.','',0,0,0,0,0,0,1,0,0,0,64690,0,26124),
(114975,'','Every day I learn more about the Light and its purpose in this world. And yet, I am still so far from the truth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114976,'Your counsel is requested.','Your counsel is requested.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114977,'','Of course, Highlord. I will speak my mind. The path of light is righteous and just. Whatever our means, let them remain virtuous.',0,0,0,0,0,0,1,0,0,0,0,68308,26124),
(114978,'','The courtyard you just left is open to visitors. From here forward, one of my staff must accompany you.',0,0,0,0,0,0,0,0,0,0,0,66288,26124),
(114979,'','You can purchase souvenirs and gifts from Sylverin, my assistant. Perhaps you could do that on your way out?',0,0,0,0,0,0,0,0,0,0,0,66289,26124),
(114980,'','This is our tasting pavilion. We serve only the finest varietals here - many of them enjoyed in the palace!',0,0,0,0,0,0,0,0,0,0,0,66290,26124),
(114981,'I have always felt drawn to the Light. Perhaps because this was my father\'s calling as well, and I wished to follow in his footsteps.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114982,'','Feel free to try the samples we have available today. We will continue the tour when you are finished.',0,0,0,0,0,0,0,0,0,0,0,66291,26124),
(114983,'I heard rumors that we recovered a message from my father. Are my parents alive?','',0,0,0,0,0,0,6,0,0,0,68329,0,26124),
(114984,'','The Order of the Silver Hand is reborn. Its new leaders will not let it fail.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114985,'','Yes, a council of war is a good idea. The Legion\'s forces are spreading across the Broken Isles. We must not lose our foothold there!',0,0,0,0,0,0,5,0,0,0,0,68367,26124),
(114986,'These demons\' souls will power the gateway. On your mark.','',0,0,0,0,0,0,1,0,0,0,64691,0,26124),
(114987,'Long have I stood this vigil, $n. I am tired of watching and waiting. The time to strike is now, or we will lose everything.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114988,'Finally, Highlord, you will hear my words. We should focus our efforts on hunting down the dreadlord Balnazzar. It\'s time for retribution!','',0,0,0,0,0,0,1,0,0,0,68384,0,26124),
(114989,'Your counsel is requested.','Your counsel is requested.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114990,'We need to get the Nightborne Soulstone right away, $n! I bet I can make the biggest explosion you\'ve ever seen!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114991,'Your counsel is requested.','Your counsel is requested.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114992,'This place is great! I just know it has information I can use to my advantage!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114993,'I\'m gonna torch a few demons once I get the Nightborne Soulstone!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114994,'Just thinking about all the damage we could cause with that Soulstone has got me all excited. Let me have it! Please!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114995,'I promise you won\'t regret it if you give me the Nightborne Soulstone... I\'ll use its power only for good. Really!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114996,'If you don\'t give me that Soulstone right now, I\'ll get angry. You really wouldn\'t like me when I\'m angry...','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114997,'I can\'t believe you won\'t let me have the Nightborne Soulstone. It contains the power of the Burning Legion!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(114998,'She is surviving, but not easily.','She is surviving, but not easily.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(114999,'Thalyssra said you had a unique way of dealing with insects. What is it?','Thalyssra said you had a unique way of dealing with insects. What is it?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115000,'Hope is not lost. We are making progress every day.','Hope is not lost. We are making progress every day.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115001,'','<Margaux glances around anxiously before leaning in close to whisper to you.>\n\nThalyssra must be alive, if others are moving in the shadows. Who else but the First Arcanist could inspire such action?\n\nTell me- how is she?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115002,'','Insects? Do you have an insect problem?\n\n<Margaux eyes you curiously for a moment.>\n\nNo matter. The answer, you see, is in front of you. Mana wyrms prey on the insects that prey on our trees. They keep our precious plants whole and they eat very well.\n\nI will be sure to make time in our tour to allow you to gather some.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115003,'','I am so relieved to hear that. Let us move on, though.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115004,'After you, Margaux.','After you, Margaux.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115005,'','Now... why exactly did you come here? This is certainly one of the least safe places for members of the resistance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115006,'Thank you! I am ready to move on now.','Thank you! I am ready to move on now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115007,'','They just - I hate them! We serve at their pleasure or we face exile and death. But I can do nothing while the Grand Magistrix seeks to keep this area secure.\n\nSurely you must have a vast network to have made your way here. Is the resistance growing? Can it truly stand against Elisande?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115008,'I do not think it is safe to say, Margaux.','I do not think it is safe to say, Margaux.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115009,'','<Margaux sighs.>\n\nThe odds are stacked against us. We are beaten and exiled at every turn. But you and the First Arcanist still stand with us. I can believe in this.\n\nI believe in the Dusk Lily.\n\nBut enough of this. Are you ready to finish our tour?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115010,'','I see... shall we carry on, then?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115011,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115012,'','The night is dark and full of demons.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115013,'Your counsel is requested.','Your counsel is requested.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115014,'','The Legion is coming for everyone and everything... We must embrace the fires of Azeroth if we hope to see the dawn.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115015,'You are quite accomplished for a mortal mage, $n.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115016,'I enjoyed our little excursion, $n. I would go into battle with you any time.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115017,'Our chances against the Burning Legion are grim at best. However there is still hope, especially with experienced mages such as yourself on our side!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115018,'Kathra\'natir was a voice in my head, calling from far away. I am so glad he has been silenced!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115019,'Now that Kathra\'natir is no longer a threat, we can safely search for powerful weapons to use against the Burning Legion.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115020,'I owe you a great debt, Archmage $n. I have not forgotten.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115021,'','The building we approach now is called the Aging Chamber.',0,0,0,0,0,0,1,0,0,0,0,66268,26124),
(115022,'','We prefer to shorten the process using time magic. Such power is our birthright!',0,0,0,0,0,0,603,0,0,0,0,66269,26124),
(115023,'','To my left you will see one of our orchards.',0,0,0,0,0,0,1,0,0,0,0,66270,26124),
(115025,'','If you are at all familiar with the wine crafting process, you know that it is necessary to allow the juice to ferment.',0,0,0,0,0,0,1,0,0,0,0,66271,26124),
(115026,'','This one houses a species of tree that produces extra sweet fruit, which you tasted in the Infusion.',0,0,0,0,0,0,1,0,0,0,0,66272,26124),
(115027,'','The Kirin Tor supports the new Tirisgarde wholeheartedly, $n.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115028,'','The buildings before you house our bottling facilities.',0,0,0,0,0,0,1,0,0,0,0,66273,26124),
(115029,'','Each bottle is sealed with magic to prevent any of the Nightwell\'s essence from fading.',0,0,0,0,0,0,1,0,0,0,0,66274,26124),
(115030,'','A cask of arcwine from our vineyard can be safely stored for hundreds of years!',0,0,0,0,0,0,603,0,0,0,0,66275,26124),
(115031,'','Ahead you will see our distribution facility.',0,0,0,0,0,0,1,0,0,0,0,66276,26124),
(115032,'','Here we arrange to send hundreds of barrels and casks of arcwine out to the city.',0,0,0,0,0,0,1,0,0,0,0,66277,26124),
(115033,'','The Magistrix monitors these activities very-',0,0,0,0,0,0,1,0,0,0,0,66278,26124),
(115034,'','Don\'t hurt him!',0,0,0,0,0,0,603,0,0,0,0,66279,26124),
(115035,'','I am so sorry- please forgive this mistake. I will personally ensure it does not happen again.',0,0,0,0,0,0,274,0,0,0,0,66280,26124),
(115036,'','Where were we?',0,0,0,0,0,0,6,0,0,0,0,66281,26124),
(115037,'','I believe the Kirin Tor must accept help from all quarters if we are to defeat the Burning Legion.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115038,'','Across this bridge is the most crucial part of our winemaking process.',0,0,0,0,0,0,1,0,0,0,0,66282,26124),
(115039,'','It is here that we instill our wine with Nightwell essence, which gives it the restorative properties our people enjoy.',0,0,0,0,0,0,1,0,0,0,0,66283,26124),
(115040,'','And this is where I leave you. I must prepare the next activity.',0,0,0,0,0,0,1,0,0,0,0,66284,26124),
(115041,'','There is much to do if we are to defeat the Burning Legion. I will not allow them to destroy my city for a second time.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115042,'','I will meet you at the next station. My assistant Sylverin will be happy to show you how the infusion process works.',0,0,0,0,0,0,273,0,0,0,0,66285,26124),
(115043,'','Is it true that Turalyon is alive?',0,0,0,0,0,0,6,0,0,0,0,68366,26124),
(115044,'Alive... we think. It appears his army suffered a great defeat at the hands of the Legion.','',0,0,0,0,0,0,1,0,0,0,68372,0,26124),
(115045,'','By the Light... what does that mean for Azeroth?',0,0,0,0,0,0,6,0,0,0,0,68307,26124),
(115046,'Arator. Son.','',0,0,0,0,0,0,0,0,0,0,69326,0,26124),
(115047,'','Our beloved child.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115048,'The vessel... it senses young Arator\'s presence!','',0,0,0,0,0,0,5,0,0,0,68383,0,26124),
(115049,'If you can hear this, I have an important message.','',0,0,0,0,0,0,1,0,0,0,69327,0,26124),
(115050,'For ages, I have hunted the Burning Legion across the stars.','',0,0,0,0,0,0,1,0,0,0,71326,0,26124),
(115051,'We  hope you can forgive us for leaving, but we did it out of love for you. To ensure your safety and the survival of our world, we chose to make this sacrifice.','',0,0,0,0,0,0,0,0,0,0,69329,0,26124),
(115052,'In retribution, the dreadlord Balnazzar has been sent to Azeroth to destroy all that I hold dear.','',0,0,0,0,0,0,1,0,0,0,71327,0,26124),
(115053,'You must gather the defenders of the Light, Arator. Keep the Light alive. Fight, or ALL is lost.','',0,0,0,0,0,0,1,0,0,0,69328,0,26124),
(115054,'','Azeroth is the last light of hope, Arator. Fight, or all is lost.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115055,'If you bombard the demons below with the Fel Hammer\'s artillery, I\'ll get our forces ready.','',0,0,0,0,0,0,1,0,0,0,66907,0,26124),
(115056,'If you bombard the demons below with the Fel Hammer\'s artillery, I will get our forces ready.','',0,0,0,0,0,0,1,0,0,0,66908,0,26124),
(115057,'Just use the console here.','',0,0,0,0,0,0,1,0,0,0,66909,0,26124),
(115058,'You can use the console here.','',0,0,0,0,0,0,1,0,0,0,66910,0,26124),
(115059,'The Burnin\' Legion! Lads, lasses, git ta yer positions. If ye can\'t fight, take shelter!','',0,0,0,0,0,0,22,0,0,0,64724,0,26124),
(115060,'Blades at the ready! We got incomin\'!','',0,0,0,0,0,0,22,0,0,0,64742,0,26124),
(115061,'Their numbers be growin\'! We\'re gonna need more from every one o\' ya!','',0,0,0,0,0,0,22,0,0,0,64776,0,26124),
(115062,'','Didn\'t think the Dark Iron\'d let the lot o\' ye have all the fun, did ye?',0,0,0,0,0,0,22,0,0,0,0,64773,26124),
(115063,'We ain\'t got this far ta give up jus\' yet! Bring \'em down!','',0,0,0,0,0,0,22,0,0,0,64749,0,26124),
(115064,'Looks like we\'re takin\' the fight to \'em!','',0,0,0,0,0,0,22,0,0,0,64761,0,26124),
(115065,'Their leader be attackin\' Kharanos! C\'mere an\' show \'em what ye got!','',0,0,0,0,0,0,22,0,0,0,64800,0,26124),
(115067,'More on the horizon! Spread out afore they reach the Gates!','',0,0,0,0,0,0,22,0,0,0,64788,0,26124),
(115069,'Yer deeds ought be praised, champions! The Legion\'s been stopped! Ya did it!','',0,0,0,0,0,0,22,0,0,0,64812,0,26124),
(115070,'|TINTERFACE\\ICONS\\spell_warlock_demonsoul:20|t Halldora begins to cast |cFFFF0404|Hspell:217283|h[Soul Harvest]|h|r Run away!','|TINTERFACE\\ICONS\\spell_warlock_demonsoul:20|t Halldora begins to cast |cFFFF0404|Hspell:217283|h[Soul Harvest]|h|r Run away!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115071,'The furbolg of this weald are a peaceful tribe. They are in a panic right now, and are in need of our help.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115072,'Can you fly me to Tian Monastery? I need to speak to the Monkey King.','Can you fly me to Tian Monastery? I need to speak to the Monkey King.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115073,'Excellent! Now, what next...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115074,'You\'re a natural! What does the recipe call for next...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115075,'Yes, just like that! Hmm... what does this batch need now?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115076,'','Ready when you are, dear.',0,0,0,0,0,0,1,0,0,0,0,64693,26124),
(115077,'Wikket come to ask a thing? What does you want from Monkey King?','',0,0,0,0,0,0,0,0,0,0,64450,0,26124),
(115078,'This sentry stands resolute.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115079,'','You students have been warned countless times. I will have to make an example of you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115080,'Welcome to my \"dream\" home! Your beloved Malfurion awaits within.','',0,0,0,0,0,0,1,0,0,0,64604,0,26124),
(115081,'Guess again, mortal!','',0,0,0,0,0,0,0,0,0,0,64611,0,26124),
(115082,'','I have no time for games!',0,0,0,0,0,0,0,0,0,0,0,64606,26124),
(115083,'I need you to lead me to the Tidestone of Golganneth.','I need you to lead me to the Tidestone of Golganneth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115084,'One of the instructors mentioned that, yes...','One of the instructors mentioned that, yes...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115085,'','I cannot tell where his voice is coming from! Quickly, search the buildings to the east. I will scour the west for signs of him!',0,0,0,0,0,0,0,0,0,0,0,64607,26124),
(115086,'I was not aware of that.','I was not aware of that.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115087,'Prepare the start up sequence.','Prepare the start up sequence.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115088,'','I cannot tell where his voice is coming from! Search the buildings to the east! I will scour the west for signs of him!',0,0,0,0,0,0,0,0,0,0,0,64608,26124),
(115089,'Shut down the start up sequence.','Shut down the start up sequence.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115090,'Hurry! I cannot fight much longer...','',0,0,0,0,0,0,0,0,0,0,64612,0,26124),
(115091,'Where are you Tyrande? I need you!','',0,0,0,0,0,0,0,0,0,0,64616,0,26124),
(115092,'You cannot keep me from her! Tyrande?!','',0,0,0,0,0,0,0,0,0,0,64618,0,26124),
(115094,'','Where are you Malfurion? Answer me!',0,0,0,0,0,0,0,0,0,0,0,64609,26124),
(115095,'My love! I am here! Come to me!','',0,0,0,0,0,0,0,0,0,0,64610,0,26124),
(115096,'','There we are! Lovely work as always, $p.',0,0,0,0,0,0,1,0,0,0,0,64694,26124),
(115097,'','Elune curse you, Xavius! You will pay for this charade, I swear it!',0,0,0,0,0,0,0,0,0,0,0,64613,26124),
(115098,'','You insolent... little...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115099,'Initiating self-destruct procedure.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115100,'','Hold on, my love! I am near!',0,0,0,0,0,0,0,0,0,0,0,64617,26124),
(115101,'','Yes! I hear you! I am close now!',0,0,0,0,0,0,0,0,0,0,0,64619,26124),
(115102,'You attempt to interact with the sentry; but to no avail.','You attempt to interact with the sentry; but to no avail.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115107,'','To me, champion. Our chase is done.',0,0,0,0,0,0,0,0,0,0,0,64620,26124),
(115108,'','Come to me, Warrior of the Horde. Our chase is finished.',0,0,0,0,0,0,0,0,0,0,0,64621,26124),
(115109,'But what\'s this? Which Malfurion is real, and which is part of the Nightmare...? [Laugh]','',0,0,0,0,0,0,1,0,0,0,64605,0,26124),
(115111,'You there! Back to work!','You there! Back to work!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115112,'I was just resting. I-','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115113,'I will hear none of your excuses. Back to work!','I will hear none of your excuses. Back to work!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115114,'Agh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115115,'The Overseer will hear of this. Mark my words, Margaux.','The Overseer will hear of this. Mark my words, Margaux.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115116,'Farewell, son. Do not lose faith, for it is in the darkest moments that the light shines brightest.','',0,0,0,0,0,0,66,0,0,0,69330,0,26124),
(115117,'You heard my father. We must act!','',0,0,0,0,0,0,5,0,0,0,68328,0,26124),
(115118,'Agreed, Arator. Brothers and sisters, the time to stand united is now. We must follow the Highlord\'s leadership more than ever.','',0,0,0,0,0,0,1,0,0,0,68373,0,26124),
(115119,'What will it be, Highlord? What should we do next?','',0,0,0,0,0,0,6,0,0,0,68374,0,26124),
(115120,'No, this simply won\'t do. We\'ll have to start over from scratch.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115121,'Perhaps you had a glass or three before coming here? We\'ll have to throw out this batch...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115122,'No, that won\'t do at all. Start over, and this time, please pay attention!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115123,'%s bellows a grateful roar.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115124,'The Legion\'s returned! Send word ta Ironforge an\' get ta yer posts!','',0,0,0,0,0,0,22,0,0,0,64725,0,26124),
(115125,'We got compn\'y! Legion ship spotted o\'er head! Ready up!','',0,0,0,0,0,0,22,0,0,0,64726,0,26124),
(115126,'Hunt the dreadlord, Balnazzar.','Hunt the dreadlord, Balnazzar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115127,'Seek allies under the Light.','Seek allies under the Light.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115128,'Defend against the demon invasions.','Defend against the demon invasions.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115129,'Git ready! \'Ere they come!','',0,0,0,0,0,0,22,0,0,0,64743,0,26124),
(115130,'Procure supplies for the army.','Procure supplies for the army.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115131,'Stand strong! Show them demons they\'ll ne\'er take Ironforge!','',0,0,0,0,0,0,22,0,0,0,64745,0,26124),
(115132,'Hold strong, brothers an\' sisters! We make our stand fer Azeroth!','',0,0,0,0,0,0,22,0,0,0,64777,0,26124),
(115133,'','By the might o\' the Dark Iron! Fer Ironforge!',0,0,0,0,0,0,22,0,0,0,0,64774,26124),
(115134,'No matter how tired ye be, how wounded... show \'em no weakness! We fight together!','',0,0,0,0,0,0,22,0,0,0,64778,0,26124),
(115135,'','The Legion\'ll ne\'er prevail if the Dark Iron have a say \'bout it!',0,0,0,0,0,0,22,0,0,0,0,64775,26124),
(115136,'Excellent thinking, Highlord. We should attack the problem at its source - their leader, Balnazzar.','',0,0,0,0,0,0,1,0,0,0,68375,0,26124),
(115137,'Good idea, Highlord. With additional allies of the Light, our strength will be magnified.','',0,0,0,0,0,0,273,0,0,0,68376,0,26124),
(115138,'I agree, Highlord. The demon incursions will only grow worse if left unchecked. A strong defense is necessary.','',0,0,0,0,0,0,1,0,0,0,68377,0,26124),
(115139,'','The Imps are hungry...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115140,'Pardon me... do you have a death wish?','',0,0,0,0,0,0,0,0,0,0,66337,0,26124),
(115141,'I strongly advise against that!','',0,0,0,0,0,0,0,0,0,0,66338,0,26124),
(115142,'Don\'t be daft- move away from there!','',0,0,0,0,0,0,0,0,0,0,66339,0,26124),
(115143,'Pragmatic as always, Highlord. There are dozens of logistics to consider. Supplies, communications, weapons, armor... We should get started.','',0,0,0,0,0,0,1,0,0,0,68378,0,26124),
(115144,'What inspired such idiocy? Nightwell energy is intensely volatile in this state!','',0,0,0,0,0,0,0,0,0,0,66340,0,26124),
(115145,'Get away from there!','',0,0,0,0,0,0,0,0,0,0,66341,0,26124),
(115146,'By the might o\' Ironforge, rise up! Bring them foul demons a swift death!','',0,0,0,0,0,0,22,0,0,0,64750,0,26124),
(115147,'I would like to requisition some Imps.','I would like to requisition some Imps.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115148,'Show them demons no mercy!','',0,0,0,0,0,0,22,0,0,0,64751,0,26124),
(115149,'Mount up! We gotta stop their advance!','',0,0,0,0,0,0,22,0,0,0,64762,0,26124),
(115150,'Spread out! This fight\'s jus\' gettin\' started!','',0,0,0,0,0,0,22,0,0,0,64763,0,26124),
(115151,'Their numbers keep growin\'! We\'ll watch the skies o\'er head. Clear \'em out down below!','',0,0,0,0,0,0,22,0,0,0,64789,0,26124),
(115152,'Captain Tevaris emerges from the shadows.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115153,'More Legion camps spotted! Bring \'em down, an\' be quick about it!','',0,0,0,0,0,0,22,0,0,0,64790,0,26124),
(115154,'Captain Tevaris fades into the shadows.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115155,'Get ta Kharanos! We gotta stop their leader! Fer the glory o\' Ironforge!','',0,0,0,0,0,0,22,0,0,0,64801,0,26124),
(115156,'Spit out yer blood, bind yer wounds, an\' git yer arses ta Kharanos! We got one last fight in us!','',0,0,0,0,0,0,22,0,0,0,64802,0,26124),
(115157,'Well done, champions! Ironforge won\'t soon be fergettin\' yer efforts \'ere on the battlefield!','',0,0,0,0,0,0,22,0,0,0,64813,0,26124),
(115158,'Great work, all o\' ya! I fear this willna be the last we see o\' the Burnin\' Legion, but when they come back... we\'ll be ready!','',0,0,0,0,0,0,22,0,0,0,64814,0,26124),
(115159,'Oh, this is not good! Legion ship overhead! If you owe back taxes, now\'s the time to pay up!','',0,0,0,0,0,0,22,0,0,0,64731,0,26124),
(115160,'Legion ship to the east! Lock up shop! Hide your breakables! Things are about to get interesting.','',0,0,0,0,0,0,22,0,0,0,64732,0,26124),
(115161,'Everybody get ready! We have incoming... and they sound testy!','',0,0,0,0,0,0,22,0,0,0,64740,0,26124),
(115162,'This is not a drill! Here they come! First priority: PROTECT MY STUFF!','',0,0,0,0,0,0,22,0,0,0,64741,0,26124),
(115163,'Oh look! They\'ve gotten a bit larger... but way more angry!','',0,0,0,0,0,0,22,0,0,0,64783,0,26124),
(115164,'Something must be getting under their skin! They\'re much bigger and meaner!','',0,0,0,0,0,0,22,0,0,0,64784,0,26124),
(115165,'Aim for their shins, or knees, or... or whatever you can reach! Just take \'em out already!','',0,0,0,0,0,0,22,0,0,0,64756,0,26124),
(115166,'Looks like those two are joining the party! Get the hats and sparklers ready!','',0,0,0,0,0,0,22,0,0,0,64757,0,26124),
(115167,'Pack up your things! We\'re bringing the fight to them.','',0,0,0,0,0,0,22,0,0,0,64768,0,26124),
(115168,'Everybody get out there! It\'s time to kick these things to the curb... if Gadgetzan had curbs!','',0,0,0,0,0,0,22,0,0,0,64769,0,26124),
(115169,'This is getting outta hand! They\'re on the move again! What gives?','',0,0,0,0,0,0,22,0,0,0,64795,0,26124),
(115170,'Watch yourselves! They\'re popping up everywhere... like broke relatives!','',0,0,0,0,0,0,22,0,0,0,64796,0,26124),
(115171,'We make our stand at Gadgetzan! Time to stick it to their boss! Dibs on everything in his pockets!','',0,0,0,0,0,0,22,0,0,0,64807,0,26124),
(115172,'It\'s big, it\'s ugly, it\'s... uh... Just get your behinds to Gadgetzan and kill it already!','',0,0,0,0,0,0,22,0,0,0,64808,0,26124),
(115173,'The Black Harvest is ready to serve.','The Black Harvest is ready to serve.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115174,'It\'s not every day you get to save the... day! I\'m gonna work on that.','',0,0,0,0,0,0,22,0,0,0,64822,0,26124),
(115175,'Well done, my friends! Minimally discounted Noggenfoggers all around!','',0,0,0,0,0,0,22,0,0,0,64823,0,26124),
(115176,'The sky burns, allies! The Legion comes at us again!','',0,0,0,0,0,0,22,0,0,0,64734,0,26124),
(115177,'Prepare for battle! We won\'t allow the Legion to destroy what we\'ve built here!','',0,0,0,0,0,0,22,0,0,0,64735,0,26124),
(115178,'Ready your blades, allies! The battle begins!','',0,0,0,0,0,0,22,0,0,0,64737,0,26124),
(115179,'Steel at the ready! We have incoming!','',0,0,0,0,0,0,22,0,0,0,64738,0,26124),
(115180,'','AAAAAAAAAAHHHHHHH!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115181,'We hold the Hill for Stormwind! For all of Azeroth!','',0,0,0,0,0,0,22,0,0,0,64786,0,26124),
(115182,'Do not give ground! Do not yield! Fight on!','',0,0,0,0,0,0,22,0,0,0,64787,0,26124),
(115183,'The doomguards make their descent! Ready at the Hill!','',0,0,0,0,0,0,22,0,0,0,64759,0,26124),
(115184,'','See you soon, handsome.',0,0,0,0,0,0,1,0,0,0,0,64695,26124),
(115185,'Allies of all flags and kingdoms! The time to fight for OUR lands is NOW!','',0,0,0,0,0,0,22,0,0,0,64760,0,26124),
(115186,'','See you soon, gorgeous.',0,0,0,0,0,0,1,0,0,0,0,64696,26124),
(115187,'Arise spirits, and serve The Legion.','',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(115188,'Even in death, these spirits serve.','',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(115189,'Thanks to your efforts, the Burning Legion has failed yet again! The Westfall Brigade is in your debt!','',0,0,0,0,0,0,22,0,0,0,64816,0,26124),
(115190,'I am not in control!','',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(115191,'They may scorch our lands... they may slay our kin... but we will NEVER surrender! For Azeroth!','',0,0,0,0,0,0,22,0,0,0,64817,0,26124),
(115192,'I... must... OBEY!','',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(115193,'Save us!','',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(115194,'Make haste! Spread throughout the lands! Purge this infestation!','',0,0,0,0,0,0,22,0,0,0,64771,0,26124),
(115195,'Take back what is ours! Show these demons their way back to the Nether!','',0,0,0,0,0,0,22,0,0,0,64772,0,26124),
(115196,'Their forces have spread! We must not let them reach Stormwind!','',0,0,0,0,0,0,22,0,0,0,64798,0,26124),
(115197,'The Legion\'s determination grows! End this vile corruption at once!','',0,0,0,0,0,0,22,0,0,0,64799,0,26124),
(115198,'Quickly, heroes! Defend the Hill! Slay the demons\' master!','',0,0,0,0,0,0,22,0,0,0,64810,0,26124),
(115199,'To Sentinel Hill at once! Together we cast this demon back into the Twisting Nether!','',0,0,0,0,0,0,22,0,0,0,64811,0,26124),
(115200,'','Illidari! The gateway is open. To the Fel Hammer!',0,0,0,0,0,0,1,0,0,0,0,64697,26124),
(115201,'Caria, Varedis, we\'re coming for you!','',0,0,0,0,0,0,0,0,0,0,66924,0,26124),
(115202,'Caria, Varedis, we\'re coming for you!','',0,0,0,0,0,0,0,0,0,0,66925,0,26124),
(115203,'Illidari Redoubt is the perfect vantage point, and it\'s free from the rabble up above.','',0,0,0,0,0,0,0,0,0,0,64689,0,26124),
(115204,'The time is upon us. The invasion of Niskara represents the fulfillment of all of our sacrifice and planning.\n\nLead us to victory, $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115205,'Give the order, Altruis. Let\'s get down there.','Give the order, Altruis. Let\'s get down there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115206,'The time is upon us. The invasion of Niskara represents the fulfillment of Illidan\'s dream and all of our sacrifices.\n\nLead us to victory, $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115207,'Give the order, Kayn. Let\'s get down there.','Give the order, Kayn. Let\'s get down there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115208,'','Your souls are forfeit!',0,0,0,0,0,0,1,0,0,0,0,64692,26124),
(115209,'Illidari, hear me. The time has come. All of our struggles... all of our sacrifices have led to this moment.','',0,0,0,0,0,0,22,0,0,0,66926,0,26124),
(115210,'You a lucky $gguy:lady;. You can break your chain and walk right out the door.$b$bGolk can break his chains very easy, but can Golk fit out the door?  Nope.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115211,'Illidari, hear me. The time has come. All of our struggles... all of our sacrifices have led to this moment.','',0,0,0,0,0,0,22,0,0,0,66929,0,26124),
(115212,'Akama, you and the others will remain behind to protect the Fel Hammer.','',0,0,0,0,0,0,25,0,0,0,66930,0,26124),
(115213,'Shade, you and the others will remain behind to protect the Fel Hammer.','',0,0,0,0,0,0,29,0,0,0,66931,0,26124),
(115214,'You five, come with me and $n. Niskara awaits!','',0,0,0,0,0,0,15,0,0,0,66932,0,26124),
(115215,'You five, come with me and $n. Niskara awaits!','',0,0,0,0,0,0,15,0,0,0,66933,0,26124),
(115216,'Yes, fools. Come down. Jump to your deaths.','',0,0,0,0,0,0,0,0,0,0,66934,0,26124),
(115217,'You destroyed all of the demons here, but many more await us ahead. We\'re going to have to wade through their lieutenants if we want to get to Caria and Varedis.\n\nGive the word and we will begin.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115218,'The word is given. Move out.','The word is given. Move out.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115219,'You destroyed all of the demons here, but many more await us ahead. We will have to fight through their lieutenants to get to Caria and Varedis.\n\nJust give the word and we will begin our assault.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115220,'The word is given. Move out.','The word is given. Move out.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115223,'What do you want? 10,000 years working here and I get no respect. Filrich do this, Filrich do that. What can Filrich do for you?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(115224,'You seem unhappy.','You seem unhappy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115225,'Why would I be unhappy? Students are always in the halls, they never go to sleep, they always want more provisions, the place is a mess. There is water everywhere! And do they hire someone else to help, no! Filrich will take care of it they say. I drew the line at cleaning up those infernal books.\n\nNow what was it \'you\' needed again?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115226,'Oh, actually I am fine.','Oh, actually I am fine.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(115227,'','Hm... the ingredients have soured. We will have to start again I am afraid.',0,0,0,0,0,0,0,0,0,0,0,66292,26124),
(115228,'','Are you certain you are ready to participate? This batch will have to be destroyed.',0,0,0,0,0,0,0,0,0,0,0,66293,26124),
(115229,'','I feel as though you are losing focus. Is something else on your mind? Step back for a moment and we will try again.',0,0,0,0,0,0,0,0,0,0,0,66294,26124),
(115230,'','Excellent! You did very well- are you certain you have never made wine before? I will have this bottled immediately.',0,0,0,0,0,0,1,0,0,0,0,66295,26124),
(115231,'','Take your place near the table. Once we begin, it is important that we keep up the pace. These delicate ingredients spoil quickly.',0,0,0,0,0,0,1,0,0,0,0,66296,26124),
(115233,'','We are preparing to make the unfortified wine. Are you ready to assist?',0,0,0,0,0,0,0,0,0,0,0,69718,26124),
(115234,'','This is my favorite part! The smells, the textures, the invigorating rush! I think you will appreciate why I have remained in the vineyards after you have made Arcwine yourself.',0,0,0,0,0,0,0,0,0,0,0,69719,26124),
(115236,'','Well done. Now let me see...',0,0,0,0,0,0,1,0,0,0,0,66298,26124),
(115237,'','You, my friend, are a natural. The blend needs something more, though. Let me think...',0,0,0,0,0,0,0,0,0,0,0,66297,26124),
(115238,'','Exactly what it needed. But there is still something missing...',0,0,0,0,0,0,0,0,0,0,0,66299,26124),
(115239,'','Ah! It needs something floral, to add a little brightness.',0,0,0,0,0,0,0,0,0,0,0,66300,26124),
(115240,'','Let us add a little moisture. Just enough to keep the taps flowing.',0,0,0,0,0,0,0,0,0,0,0,66301,26124),
(115241,'','I think a sour note is in order. Add a shadefruit, please.',0,0,0,0,0,0,0,0,0,0,0,66302,26124),
(115242,'','The juices need a little massaging- step into the vat and jump to squish the mixture around!',0,0,0,0,0,0,25,0,0,0,0,66303,26124),
(115243,'','No talking in class!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115244,'Begin the energy transfer sequence.','Begin the energy transfer sequence.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115245,'','Hey Practicus, do you ever worry other hunters won\'t appreciate our tamed mechs?',603,0,0,0,0,0,396,0,0,0,0,0,26124),
(115246,'It\'s all in the branding! That\'s why I call \'em Programmable Electronic Tactical Sidekicks... P.E.T.S.!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(115248,'I... I\'m alive! Thank you, priestess!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115249,'Whatever happened to this place? It put sad look on wikket\'s face.','',0,0,0,0,0,0,0,0,0,0,64448,0,26124),
(115250,'Rise up, High Inquisitor! Your Deathlord calls you back to this world!','',0,0,0,0,0,0,1,0,0,0,69419,0,26124),
(115251,'We have not come to offer peace, High Inquisitor.','',0,0,0,0,0,0,1,0,0,0,69420,0,26124),
(115252,'The Day of Reckoning is at hand. The Burning Legion has come to destroy our world.','',0,0,0,0,0,0,1,0,0,0,69421,0,26124),
(115253,'The Knights of the Ebon Blade have come to offer you a chance at atonement.','',0,0,0,0,0,0,1,0,0,0,69422,0,26124),
(115254,'Join us, and we will find out together.','',0,0,0,0,0,0,1,0,0,0,69423,0,26124),
(115255,'','I... I live? Is the anguish of death over?',0,0,0,0,0,0,1,0,0,0,0,71579,26124),
(115256,'','Why then? Why have you done this to me?',0,0,0,0,0,0,1,0,0,0,0,71580,26124),
(115257,'','Atonement? I doubt that such a thing exists for me...',0,0,0,0,0,0,1,0,0,0,0,71581,26124),
(115258,'','Indeed we shall.',0,0,0,0,0,0,1,0,0,0,0,71582,26124),
(115260,'Do not show yourself! You cannot help her now. No one can.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115261,'Get out of here, if you know what\'s good for you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115262,'Silence!','',0,0,0,0,0,0,0,0,6,0,69831,0,26124),
(115263,'','I did what I thought was-',0,0,0,0,0,0,0,0,6,0,0,66304,26124),
(115264,'I will hear no more. The sentence is death. Proceed.','',0,0,0,0,0,0,0,0,6,0,69833,0,26124),
(115265,'I\'d wager Ulduar is quieter than the last time you were here, Brann.','',396,0,0,0,0,0,396,0,0,0,0,0,26124),
(115266,'The keepers have ordered repairs to Ulduar\'s infrastructure. Mortal heroes are proficient in battle, but tend to leave a mess. No offense intended.','',396,396,0,0,0,0,396,0,0,0,0,0,26124),
(115268,'That\'s a fair point. It took weeks to clean up the banquet hall after--','',396,0,0,0,0,0,396,0,0,0,0,0,26124),
(115269,'Hold it... ye sense anythin\' odd, Khadgar? Gettin\' a familiar feelin\'... an\' I don\'t like it!','',6,0,0,0,0,0,603,0,0,0,0,0,26124),
(115270,'There be one more test \'fore I tell you my tale. Meet at Jade Serpent\'s temple \'fore the mixin\'s go stale!','',0,0,0,0,0,0,0,0,0,0,64416,0,26124),
(115271,'Fragile mortals. Bow before the might of the Burning Legion!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(115272,'You cannot escape! Our reach is endless!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(115273,'Your world crumbles around you, mortals. We cannot be stopped!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(115274,'Your world trembles in our wake!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(115275,'The end of your world has begun!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(115276,'Weak flesh and brittle bones... You are no match for the Legion!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(115277,'You... will... DIE!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(115278,'Feel your hearts wrench as the grasp of Sargeras tightens around your world!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(115279,'','A list of traitors? You will have to get this to Lieutenant Piet at once.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115280,'As you wish. I will meet the Lieutenant where we met last. Send word for her to expect me.','As you wish. I will meet the Lieutenant where we met last. Send word for her to expect me.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(115281,'','I hear you\'ve got names of rebel filth? Quickly, let\'s have them.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115282,'','You fool, you were followed! To arms!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(115283,'Ooka, what do you have for sale?','Ooka, what do you have for sale?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115284,'Keep an eye out for rebels. You can\'t be too careful.','Keep an eye out for rebels. You can\'t be too careful.',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(115285,'If you see someone stealing arcwine, report them at once!','If you see someone stealing arcwine, report them at once!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115286,'Seize her!','',0,0,0,0,0,0,0,0,6,0,69830,0,26124),
(115288,'I have detected a large number of teleportation spells targeting your location.','',0,0,0,0,0,0,0,0,0,0,66211,0,26124),
(115289,'I have enabled a teleporter for you. You haven\'t a lot of time- locate the pad and get out of there.','',0,0,0,0,0,0,0,0,0,0,66210,0,26124),
(115290,'Oh no...','',0,0,0,0,0,0,0,0,0,0,66343,0,26124),
(115291,'Please... even a few drops of arcwine might spare my mind from madness...','Please... even a few drops of arcwine might spare my mind from madness...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115292,'You look strong... clearly you have arcwine to spare!','You look strong... clearly you have arcwine to spare!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115293,'I feel my mind... slipping... need arcwine...','I feel my mind... slipping... need arcwine...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115294,'I\'ve brought you some arcwine... drink up!','I\'ve brought you some arcwine... drink up!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115295,'So generous! Thank you, I owe you my life!','So generous! Thank you, I owe you my life!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115296,'Such potency... I am saved! Thank you!','Such potency... I am saved! Thank you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115297,'Aye, another mission where we might not be makin\' it back.\n\nBrought me private stash this time, though. Ye want a sip?','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(115298,'Sure, I\'ll take a sip.','Sure, I\'ll take a sip.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(115299,'No, thank you.','No, thank you.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(115300,'The liquid smells very strong. Really take a drink?','The liquid smells very strong. Really take a drink?',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(115301,'','Worthless! Prepare the defenses. I will take great pleasure in killing you, $n.',0,0,0,0,0,0,0,0,0,0,0,66935,26124),
(115302,'Help, masters! Demons are ransacking the temple!','',0,0,0,0,0,0,0,0,0,0,64396,0,26124),
(115303,'Offer: 800x |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t|Hcurrency:1155|h|cFFFFFFFF Ancient Mana|h|r','Offer: 800x |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t|Hcurrency:1155|h|cFFFFFFFF Ancient Mana|h|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115304,'This action will remove 800 Ancient Mana. Do you wish to continue anyway?','This action will remove 800 Ancient Mana. Do you wish to continue anyway?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115305,'Vengeance? You can do better than that. Much better. In fact...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115306,'Cute. Do you want to get us both killed? No? Didn\'t think so.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115307,'Now that... that is more like it. It so happens that I am the perfect living soul for this job.','',0,0,0,0,0,0,0,0,0,0,66191,0,26124),
(115308,'The Jade Serpent fights the invaders inside while we hold the gate for survivors to escape. Several scribes are missing, and I fear the worst. Please, help us!','',0,0,0,0,0,0,0,0,0,0,64397,0,26124),
(115309,'Yu\'lon\'s strong as a mountain and quick as a bee, but even a mountain\'s worn down by the sea.','',0,0,0,0,0,0,0,0,0,0,64447,0,26124),
(115310,'These walls right here look easy to climb! Jade Serpent\'s the one the King go to find.','',0,0,0,0,0,0,0,0,0,0,64449,0,26124),
(115311,'$n, we\'re counting on you to rescue our scribes!','',0,0,0,0,0,0,0,0,0,0,64398,0,26124),
(115312,'Such delicious knowledge!','',0,0,0,0,0,0,0,0,0,0,64391,0,26124),
(115313,'Glad to see you made it.','',0,0,0,0,0,0,0,0,0,0,66936,0,26124),
(115314,'Glad to see you made it.','',0,0,0,0,0,0,1,0,0,0,66937,0,26124),
(115315,'Illidari, you have your targets. Attack!','',0,0,0,0,0,0,0,0,0,0,66938,0,26124),
(115316,'Illidari, you all have your targets. Attack!','',0,0,0,0,0,0,0,0,0,0,66939,0,26124),
(115317,'Agreed! We need to get in there before they decide to escape.','Agreed! We need to get in there before they decide to escape.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115318,'Agreed! We need to get in there before they decide to escape.','Agreed! We need to get in there before they decide to escape.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115319,'Know this, demon hunters, if you proceed, I will allow Varedis and Caria to destroy you.','',0,0,0,0,0,0,0,0,0,0,66940,0,26124),
(115320,'There will be no forgiveness... no second chance to join me.','',0,0,0,0,0,0,0,0,0,0,66941,0,26124),
(115321,'Caria and Varedis are hiding in this command center. We\'re going to need assistance for this one.\n\nMight I suggest ordering Akama to move the Fel Hammer into position and fire upon that fel barrier?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115322,'Caria and Varedis are hiding in this command center. We are going to need assistance for this one.\n\nMight I suggest ordering Akama to move the Fel Hammer into position and fire upon that fel barrier?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115323,'Another mind to feed upon!','',0,0,0,0,0,0,0,0,0,0,64392,0,26124),
(115324,'Who\'s there? Jarvox, I sense intruders!','',0,0,0,0,0,0,0,0,0,0,68331,0,26124),
(115325,'Jarvox, stay alert! Protect the Codex of command with your life!','',0,0,0,0,0,0,0,0,0,0,68332,0,26124),
(115326,'Speak infiltrator. You do not belong here. Jarvox! Take care of this.','',0,0,0,0,0,0,0,0,0,0,68333,0,26124),
(115327,'Do not fear, my lord. My demons will hunt down the intruders!','',0,0,0,0,0,0,0,0,0,0,68355,0,26124),
(115328,'Foolish paladins... I have captured one of your own! Too bad Lord Balnazzar will not be here to see his demise!','',0,0,0,0,0,0,0,0,0,0,68356,0,26124),
(115329,'I will never give in to you, demon!','',0,0,0,0,0,0,0,0,0,0,69364,0,26124),
(115330,'The scourge has risen against us! Send the invaders back to their graves!','',0,0,0,0,0,0,0,0,0,0,69424,0,26124),
(115331,'Should you fall, know that your sacrifice will bring me great glory this day!','',0,0,0,0,0,0,0,0,0,0,69425,0,26124),
(115332,'You defile the sanctity of this chapel with your presence! The Holy Light shall burn you!','',0,0,0,0,0,0,0,0,0,0,69426,0,26124),
(115333,'By the power of the Light I will banish you, scourge!','',0,0,0,0,0,0,0,0,0,0,69427,0,26124),
(115334,'My faith... has forsaken me?','',0,0,0,0,0,0,0,0,0,0,69428,0,26124),
(115335,'','Wait. We don\'t know the strength of our enemy. Who knows what you\'re rushing into?',0,0,0,0,0,0,5,0,0,0,0,68361,26124),
(115336,'Are there none among the Scarlet Crusade with the strength to challenge me?!','',0,0,0,0,0,0,0,0,0,0,69429,0,26124),
(115337,'The great lord Balnazzar\'s plan will not be disrupted!','The great lord Balnazzar\'s plan will not be disrupted!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115338,'We have our orders to destroy any intruders!','We have our orders to destroy any intruders!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115339,'The Order of the Silver Hand? Sounds like a juicy target to me.','The Order of the Silver Hand? Sounds like a juicy target to me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115342,'A tasty paladin. You meet your end!','A tasty paladin. You meet your end!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115343,'Those who terrorize the innocent have no place in this world or the next.','',0,0,0,0,0,0,0,0,0,0,69430,0,26124),
(115344,'The Realm of Shadow offers little respite to the souls of the wicked.','',0,0,0,0,0,0,0,0,0,0,69431,0,26124),
(115345,'Get movin\', wikket. Let the trial begin! Makin\' sweet hozen slerp is the way you can win!','',0,0,0,0,0,0,0,0,0,0,64418,0,26124),
(115346,'The pot\'s gettin\' hotter. Add a wee splash o\' water.','',0,0,0,0,0,0,0,0,0,0,64434,0,26124),
(115347,'That brew, it smells a little plain. Wikket, add a pinch more grain.','',0,0,0,0,0,0,0,0,0,0,64428,0,26124),
(115348,'Time for the wikket to add the next mixin\'. Toss in a banana, that be the right fixin\'!','',0,0,0,0,0,0,0,0,0,0,64423,0,26124),
(115349,'No, no, no! Don\'t be spooked, or that brew\'ll be grooked!','',0,0,0,0,0,0,0,0,0,0,64424,0,26124),
(115350,'No, no, and no! That not how it go! It\'s like wikkit be tryin\' to lose this here show!','',0,0,0,0,0,0,0,0,0,0,64425,0,26124),
(115351,'Too bad that the wikket got it all wrong! This dook of a brew make me sing a sad song!','',0,0,0,0,0,0,0,0,0,0,64426,0,26124),
(115352,'Good goin\', wikket! You know how to pick it!','',0,0,0,0,0,0,0,0,0,0,64419,0,26124),
(115353,'Yup, yup, that\'s the way! Hup, hup, save the day!','',0,0,0,0,0,0,0,0,0,0,64420,0,26124),
(115354,'Lookin\' good, you! Smellin\' good, too!','',0,0,0,0,0,0,0,0,0,0,64421,0,26124),
(115355,'A-yup! That\'s the ticket! Keep it up, clever wikket!','',0,0,0,0,0,0,0,0,0,0,64422,0,26124),
(115356,'Flames too high, you horked the pot! Start over now! Don\'t get it too hot!','',0,0,0,0,0,0,0,0,0,0,64431,0,26124),
(115357,'Wikket be snoozin\'? No or yes? You able to start the brew over, I guess.','',0,0,0,0,0,0,0,0,0,0,64432,0,26124),
(115358,'Brew cooked too long, wikket florked up the batch. Nothin\' to do but restart it from scratch!','',0,0,0,0,0,0,0,0,0,0,64433,0,26124),
(115359,'This hozen brew be just the thing! Its taste be fit for the Monkey King!','',0,0,0,0,0,0,0,0,0,0,64430,0,26124),
(115360,'Put the pot on the fire\'s heart, then the wikket\'s trial can start!','',0,0,0,0,0,0,0,0,0,0,64435,0,26124),
(115361,'','You should not be here, little ones. The Burning Legion\'s attacks are relentless. Even I have suffered many wounds.',0,0,0,0,0,0,0,0,0,0,0,64379,26124),
(115362,'','Prepare yourself, our foes are approaching!',0,0,0,0,0,0,0,0,0,0,0,64382,26124),
(115363,'Time to get slerpin\' and grookin\', King say. Get busy! It best if we start right away.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115364,'Let\'s go to the Temple.','Let\'s go to the Temple.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115365,'','Fu Zan has has chosen a new companion. Great deeds and great trials await you, little one. For now, you should return home to rest and prepare for what is to come.',0,0,0,0,0,0,0,0,0,0,0,64384,26124),
(115366,'It would be an honor.','It would be an honor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115367,'','Fare well, little one.',0,0,0,0,0,0,0,0,0,0,0,64383,26124),
(115370,'','It\'s good to see you back again. Vanthir procured more Arcwine for you to distribute.',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(115371,'You\'re lucky I found you when I did. You almost died out there.','',0,0,0,0,0,0,1,0,0,0,66562,0,26124),
(115375,'Take their stuff!','',0,0,0,0,0,0,0,0,0,41305,0,0,26124),
(115376,'Trap their cubs!','',0,0,0,0,0,0,0,0,0,41305,0,0,26124),
(115377,'Bonk them to the ground!','',0,0,0,0,0,0,0,0,0,41305,0,0,26124),
(115378,'Smash their smashies!','',0,0,0,0,0,0,0,0,0,41305,0,0,26124),
(115379,'Scratch their feets!','',0,0,0,0,0,0,0,0,0,41305,0,0,26124),
(115380,'Bite their knees!','',0,0,0,0,0,0,0,0,0,41305,0,0,26124),
(115381,'Pull their furs!','',0,0,0,0,0,0,0,0,0,41305,0,0,26124),
(115382,'Fur their bolgs!','',0,0,0,0,0,0,0,0,0,41305,0,0,26124),
(115383,'You are too hungry to continue.','You are too hungry to continue.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115384,'I have some idea of where to start.','',0,0,0,0,0,0,0,0,0,0,67570,0,26124),
(115385,'Oy! Didn\'t think they\'d be on me so fast! Be careful out here!','Oy! Didn\'t think they\'d be on me so fast! Be careful out here!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115386,'Ne\'er thought I\'d be rescued!','Ne\'er thought I\'d be rescued!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115387,'Git to the roads, quickly! Best not ta be wanderin\' about all alone out here!','Git to the roads, quickly! Best not ta be wanderin\' about all alone out here!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115388,'Thanks fer the help. Best git goin\'. Wouldn\'t want ta be caught out here with all this goin\' on!','Thanks fer the help. Best git goin\'. Wouldn\'t want ta be caught out here with all this goin\' on!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115389,'I appreciate the concern, $n, but I got ta keep at it. Who knows how far they\'ve spread!','I appreciate the concern, $n, but I got ta keep at it. Who knows how far they\'ve spread!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115390,'Thanks, $n. Best stay alert out \'ere!','Thanks, $n. Best stay alert out \'ere!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115391,'Chin up, $glad:lass;. I\'d be a lot worse if it hadn\'t been fer ya.','Chin up, $glad:lass;. I\'d be a lot worse if it hadn\'t been fer ya.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115392,'The flavor\'s improvin\', but it need strong scent, too. Open the keg and add Smelly Brew!','',0,0,0,0,0,0,0,0,0,0,64429,0,26124),
(115393,'','Time is of the essence. We must get moving!',0,0,0,0,0,0,1,0,0,0,0,64600,26124),
(115394,'','Every moment we sit idle, the Legion gains strength.',0,0,0,0,0,0,1,0,0,0,0,64601,26124),
(115395,'','In Lord Illidan\'s absence, you are the ranking member of our order. We can\'t make this decision without you.',0,0,0,0,0,0,1,0,0,0,0,64602,26124),
(115396,'','Let me know when you\'re ready.',0,0,0,0,0,0,1,0,0,0,0,64603,26124),
(115397,'','I only hope it\'s enough. Too many people around the city are on the brink...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115398,'','It\'s getting harder to find Arcwine going spare... but what we get, we share with the poorest among us.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115399,'I will take your Arcwine and share it with the needy.','I will take your Arcwine and share it with the needy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115400,'','This place harbors many secrets, but it rarely shares them.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115401,'','The outside world is too big and loud. I have everything I need right here.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115402,'','The Hall has become terribly noisy since the new Tirisgarde arrived. I much preferred to listen to the mice singing amongst the shadows.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115403,'','Thank you, little ones. I can heal my injuries, but I need time for my magic to take hold. Our cunning foes will use this opportunity to strike.',0,0,0,0,0,0,0,0,0,0,0,64380,26124),
(115404,'','Protect me while I recover. Should we fall, all of Pandaria will follow.',0,0,0,0,0,0,0,0,0,0,0,64381,26124),
(115405,'You are too far away! Move back in range before she gets away!','You are too far away! Move back in range before she gets away!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115406,'Keep it down, brats. You will join the others soon.','Keep it down, brats. You will join the others soon.',0,0,0,0,0,0,0,0,0,0,0,66315,26124),
(115407,'','As a token of my gratitude, allow me to see you home.',0,0,0,0,0,0,0,0,0,0,0,64385,26124),
(115408,'','Da elements be tricky wit their secrets, but I watch and I lissen. If ya know how ta speak ta dem, der secrets can be yours, too.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115409,'Show me my Class Advancement options.','Show me my Class Advancement options.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115410,'','The Maelstrom pillar\'s power was exhausted during our defense of the Heart of Azeroth. The pillar will recharge slowly, but this process could take decades and we have no such luxury. We need to find a way to accelerate its regeneration.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115411,'','Excellent! Lord Neptulon\'s gift has already done wonders. The stone appears to be channeling my powers of water again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115412,'','We continue to make progress, Farseer. The maelstrom pillar is revitalized with the power of air. With any luck, we will be able to restore its full potential soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115413,'','Your help has been instrumental to my progress here, Farseer. The stone is nearly complete. With the powers of water, air, and earth restored, the remaining element needed is fire.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115414,'','I couldn\'t be more pleased, Farseer. It has taken quite a lot of work to restore the maelstrom pillar to its maximum capabilities, but it was well worth the effort.$B$BGo ahead and try it yourself - the stone conducts the elements in powerful ways!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115415,'Your soul, too, will be added to my cage.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115416,'All souls will be ours...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115417,'','We can use the Bloodstone. It will be powerful enough to control the sisters when they\'re in a weakened state.',0,0,0,0,0,0,1,0,0,0,0,66518,26124),
(115418,'Yes, come closer. See what I have in store for you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115419,'Flee! The Magistrix will kill us for failing her!','',0,0,0,0,0,0,430,0,0,0,0,0,26124),
(115420,'Your death will come soon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115421,'This isn\'t worth dying for!','',0,0,0,0,0,0,430,0,0,0,0,0,26124),
(115422,'Jade Serpent taught me: king do what king must. We not gonna leave you. There\'s greenies to bust!','',0,0,0,0,0,0,0,0,0,0,64440,0,26124),
(115423,'Get up! The Magistrix will have this delivery on time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115424,'The Magistrix will have this shipment of Arcwine at once. Exhaustion is no excuse!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115425,'Please... have mercy... I can\'t go on.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115426,'My body is broken... I can\'t keep up.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115427,'','There are many things I can do to help strengthen your class hall, though some tough choices will have to be made.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115428,'','I can still do a few magic tricks if I set my mind to it...',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115429,'','Oh look! Isn\'t she extraordinary! She will serve you well, $n, if you ask her nicely.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115430,'Not again! The keepers will make me fill out an incident report!','',603,0,0,0,0,0,603,0,0,0,0,0,26124),
(115431,'The city\'s defenses have been compromised. Units assigned to safeguard the Speaker are not responding to my queries!','',396,0,0,0,0,0,396,0,0,0,0,0,26124),
(115432,'Might be the Old Gods ain\'t the only ones tryin\' ta find their way in!','',396,0,0,0,0,0,396,0,0,0,0,0,26124),
(115433,'Indeed! I suggest we pick up the pace.','',396,0,0,0,0,0,396,0,0,0,0,0,26124),
(115437,'','Ah yes, I can definitely do something with this water. I will need time to work with it. Thank you, Farseer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115438,'<Offer the Gift-Wrapped Arcwine Bottle.>','<Offer the Gift-Wrapped Arcwine Bottle.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115439,'','Thalyssra smiles warmly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115440,'','I will see that it is not wasted. Well done, my friend.',0,0,0,0,0,0,0,0,0,0,0,67590,26124),
(115441,'<The pillar is quiet and cold.>','<The pillar is quiet and cold.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115442,'<The pillar glows slightly. It is no longer ice cold, but still cool to the touch.>','<The pillar glows slightly. It is no longer ice cold, but still cool to the touch.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115443,'<The pillar is warm.>','<The pillar is warm.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115444,'<The pillar hums with energy. As soon as you touch its surface, you feel a vast pool of untapped power just beneath its surface.>','<The pillar hums with energy. As soon as you touch its surface, you feel a vast pool of untapped power just beneath its surface.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115445,'Channel the energy of air.','Channel the energy of air.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115446,'Channel the energy of water.','Channel the energy of water.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115447,'Channel the energy of earth.','Channel the energy of earth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115448,'Channel the energy of fire.','Channel the energy of fire.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115449,'Ma\'haat go deep. Ma\'haat collect shinies. Ma\'haat hungry.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115450,'Do you have a Fossilized Egg?','Do you have a Fossilized Egg?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115451,'NO! Ma\'haat hungry! I want ORE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115452,'Stupid $r, you don\'t know what you give up. Delicious!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115453,'I\'m ready, Altruis. Let\'s get back to the Fel Hammer and jump back to Mardum.','I\'m ready, Altruis. Let\'s get back to the Fel Hammer and jump back to Mardum.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115454,'I\'m ready, Kayn. Let\'s get back to the Fel Hammer and jump back to Mardum.','I\'m ready, Kayn. Let\'s get back to the Fel Hammer and jump back to Mardum.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115455,'It\'s done. The Felsouls are dead and they\'re not coming back.\n\nWe\'re ready to return to the Fel Hammer when you are, $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115456,'It is over. The Felsouls are dead and the will not be coming back.\n\nWe are ready to return to the Fel Hammer when you are, $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115457,'','You really think we are going to just let you in? You came all this way for nothing, demon hunters.',0,0,0,0,0,0,0,0,0,0,0,66956,26124),
(115458,'Akama, move the Fel Hammer into position. Bring down this fel barrier.','',0,0,0,0,0,0,22,0,0,0,66957,0,26124),
(115459,'Shade, move the Fel Hammer into position. Bring down this fel barrier.','',0,0,0,0,0,0,22,0,0,0,66958,0,26124),
(115460,'Moving now. You might want to step back.','',0,0,0,0,0,0,0,0,0,0,66959,0,26124),
(115461,'My pleasure. Step back.','',0,0,0,0,0,0,0,0,0,0,66960,0,26124),
(115462,'','My lord Kil\'jaeden, save me...',0,0,0,0,0,0,0,0,0,0,0,66961,26124),
(115463,'Kil\'jaeden, bring me back to life again...','',0,0,0,0,0,0,0,0,0,0,66962,0,26124),
(115464,'You are all going to die painfully, especially you, $n.','',0,0,0,0,0,0,0,0,0,0,66963,0,26124),
(115465,'Very well, Illidari. Your fate is sealed. You will perish with your world.','',0,0,0,0,0,0,0,0,0,0,66964,0,26124),
(115466,'Fate has delivered you to us in this most dire time, hero! While I sense that your mission is urgent, if we do not push back these invading demons, we will all perish.','',0,0,0,0,0,0,0,0,0,0,70896,0,26124),
(115467,'The chest is locked with a mysterious power, and cannot be opened here.$b$bYou can dismiss some of your withered troops and have them bring it back to Thalyssra.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115468,'$n! Please, step forward.','',0,0,0,0,0,0,396,0,0,0,66542,0,26124),
(115469,'|c999900002 Withered:|r Bring the chest back to Thalyssra.','|c999900002 Withered:|r Bring the chest back to Thalyssra.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115470,'Please, show me what you have brought. We haven\'t much time.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115471,'','You have done much for us, friend. I will call upon you again soon- until then, please accept my thanks.',0,0,0,0,0,0,0,0,0,0,0,67589,26124),
(115473,'Leave the sentry.','Leave the sentry.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115474,'I arise!','',0,0,0,0,0,0,0,0,0,0,66990,0,26124),
(115475,'Fight for my pleasure.','',0,0,0,0,0,0,0,0,0,0,66971,0,26124),
(115476,'','We are ready for your requests.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115477,'I would like to requisition a Squad of Initiates.','I would like to requisition a Squad of Initiates.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115478,'Rakeesh... His name means \"butcher\" in Eredun. It is no coincidence that Kil\'jaeden sent an eredar to slaughter my people. The Deceiver revels in his \"creative\" punishments for those that dare defy him.','',0,0,0,0,0,0,0,0,0,0,70900,0,26124),
(115479,'Thank you.','',0,0,0,0,0,0,0,0,0,43663,0,0,26124),
(115480,'THIS START EVENT FIRED LIKE A BOSS','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115481,'Take the arcwine. I am getting out of here.','',0,0,0,0,0,0,1,0,0,43663,0,0,26124),
(115482,'Pathetic.','',0,0,0,0,0,0,0,0,0,0,66972,0,26124),
(115483,'Stop the interlopers! I must find out what the prisoner knows!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115484,'Brann! They\'re tryin\' ta invade me mind!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115485,'This barrier protecting my people requires all of my energy and focus. I am afraid you must venture into the demon infested halls alone. Please, search for survivors and eliminate the Legion invasion point portals that you find across the Exodar.','',0,0,0,0,0,0,0,0,0,0,70895,0,26124),
(115486,'You must hurry. I do not know how much longer I can keep this barrier active!','',0,0,0,0,0,0,0,0,0,0,70894,0,26124),
(115487,'You will pay for this delay!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115488,'Elisande... will hear... of this...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115489,'','The temple is completely overrun! Let us crush these demons!',1,0,0,0,0,0,0,0,0,0,0,68090,26124),
(115490,'Time for battle! For Odyn!','',1,0,0,0,0,0,0,0,0,0,68104,0,26124),
(115491,'','The Wardens\' duty is to protect our people from dangerous creatures such as this one. Strike without hesitation or mercy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115492,'','The Broken Isles is a land rife with danger, friend. The Wardens need your help in taking down this menace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115493,'','Threats abound in these lands, friend. A test of your courage stands before you. Strike fast and true!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115494,'','The Wardens have pledged to bring justice to this world, but we cannot be everywhere. We offer you the honor of taking down a grave threat.',0,0,0,0,0,0,0,0,0,0,0,70691,26124),
(115495,'','We believe your skills are well-suited for bringing this target to justice. Serve our order and you will be rewarded.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115496,'','Fortune smiles upon us! You are near a threat we have been tracking for some time. Destroy it, and we will remember your service to the Wardens.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115497,'','We will not forget your aid this day, champion! The Wardens are in your debt.',0,0,0,0,0,0,0,0,0,0,0,70684,26124),
(115498,'','Now you have a sense of the duty each Warden bears, friend. Thank you for aiding our order.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115499,'','Your skills show great promise! No doubt we shall call upon you again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115500,'','The land is safer for your actions this day. But stay vigilant! Danger will surely rise again.',0,0,0,0,0,0,0,0,0,0,0,70696,26124),
(115501,'','Nicely done! Many others would show fear in the face of such danger, but you knew only courage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115502,'','An efficient, impressive kill. Your deeds are worthy of the Wardens!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115503,'','A powerful menace lurks nearby. Be on your guard!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115504,'','There is a mark near you. Eliminate it in the name of justice.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115505,'','Our owls have spotted a target near your location. Dispatch it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115506,'','We have a target for you in this area. Be vigilant.',0,0,0,0,0,0,0,0,0,0,0,70682,26124),
(115507,'','Beware! A threat is near. It must be eliminated.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115508,'','A potent enemy lurks nearby. Bring it to justice!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115509,'','A deadly mark is near your location. Prove yourself to be deadlier.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115510,'','The Wardens thank you once again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115511,'','You have kept the peace for another day.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115512,'','You are getting quite good at this, ally.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115513,'','Another mark dispatched. Excellent!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115514,'','You struck true. Well done!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115515,'','You strike with impressive skill, friend.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115516,'','Another danger thwarted. Nicely done!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115517,'','Your mark is nearby, assassin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115518,'','Show them how we deliver justice.',0,0,0,0,0,0,0,0,0,0,0,70693,26124),
(115519,'','Your target is marked. Be about your work.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115520,'','We have an assignment for you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115521,'','Our enemies outnumber us. We have need of your skills.',0,0,0,0,0,0,0,0,0,0,0,70685,26124),
(115522,'','Strike fast. Strike deadly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115523,'','You know what is required. Good luck.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115524,'','Didn\'t even see you coming.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115525,'','Didn\'t stand a chance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115526,'','Justice is served.',0,0,0,0,0,0,0,0,0,0,0,70695,26124),
(115527,'','Well-struck, like a true Warden.',0,0,0,0,0,0,0,0,0,0,0,70683,26124),
(115528,'','The legend of the Wardens grows thanks to your deeds.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115529,'','We never doubted that you would succeed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115530,'','An efficient kill. Most admirable!',0,0,0,0,0,0,0,0,0,0,0,70694,26124),
(115531,'We have gathered here to recognize your valor in battle. Turn and approach your peers.','',0,0,0,0,0,0,396,0,0,0,66543,0,26124),
(115532,'Magni\'s in there! We gotta save \'im!','',603,0,0,0,0,0,603,0,0,0,0,0,26124),
(115533,'Good thing I have experience with fel barriers. Say the word, $n, and I\'ll bring it down!','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(115534,'Since you have this under control, I... I must attend to other guests. Please excuse me!','',396,0,0,0,0,0,396,0,0,0,0,0,26124),
(115535,'Kill the mage! Gul\'dan wants his head!','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(115536,'Inform your master that I\'ve grown rather attached to it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115537,'','We need to keep moving!',1,0,0,0,0,0,0,0,0,0,0,68088,26124),
(115538,'My blade thirsts for demon\'s blood!','',1,0,0,0,0,0,0,0,0,0,68103,0,26124),
(115539,'','Who is that fighting so fiercely ahead?',1,0,0,0,0,0,0,0,0,0,0,68089,26124),
(115540,'It appears to be a dwarf. How is he still alive?','',1,0,0,0,0,0,0,0,0,0,68608,0,26124),
(115541,'Clearly the Legion doesn\'t want us hearing what Magni has to say.','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(115542,'Magni! \'Tis good to see ye again! But why did ye leave Ironforge? Why come here? What happened to--','',396,0,0,0,0,0,603,0,0,0,0,0,26124),
(115543,'I know ye have questions, but they gotta wait. Time is short. She wants me ta pass along an important message.','',396,0,0,0,0,0,396,0,0,0,0,0,26124),
(115545,'The ritual that changed me body also opened me ears ta the voice o\' Azeroth herself. She ain\'t just a hunk o\' rock. She\'s a titan!','',396,0,0,0,0,0,396,0,0,0,0,0,26124),
(115546,'Me own brother turned ta diamond and started talkin\' ta titans?','',603,0,0,0,0,0,603,0,0,0,0,0,26124),
(115547,'A titan? That... actually explains a great many things.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115548,'There\'s more I gotta say. Come inside the Celestial Planetarium and I\'ll show ye the truth.','',396,0,0,0,0,0,396,0,0,0,0,0,26124),
(115549,'Don\'t we need a key?','',6,0,0,0,0,0,6,0,0,0,0,0,26124),
(115550,'Brother... I AM the key.','',396,0,0,0,0,0,396,0,0,0,0,0,26124),
(115551,'You had better provide a good reason for this interruption.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115552,'I have seen your deeds in the vineyards. You have oppressed the Nightborne long enough. Prepare to die, Elvire!','I have seen your deeds in the vineyards. You have oppressed the Nightborne long enough. Prepare to die, Elvire!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115553,'Intruder! Face my blade!','',0,0,0,0,0,0,0,0,0,40285,69824,0,26124),
(115554,'She sealed her fate, as you have sealed yours!','',0,0,0,0,0,0,0,0,0,40285,69825,0,26124),
(115555,'Yikes! I\'m gettin\' flashbacks o\' Algalon!','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(115556,'The constellar was jus\' doin\' his job, such as it was. And in the end, ye taught him a lesson.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(115557,'|c999900005 Withered:|r Bring the chest back to Thalyssra.','|c999900005 Withered:|r Bring the chest back to Thalyssra.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115558,'|c9999000010 Withered:|r Bring the chest back to Thalyssra.','|c9999000010 Withered:|r Bring the chest back to Thalyssra.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115559,'Perhaps it is your imperfection... that which grants you free will... that allows you to persevere against all cosmically calculated odds. You prevail where the Titan\'s own perfect creations have failed.','',0,0,0,0,0,0,0,0,0,0,15401,0,26124),
(115562,'After defeatin\' the Old Gods, the keepers were giv\'n the task o\' orderin\' the world. The titans gave \'em five mighty artifacts... the Pillars o\' Creation!','',396,0,0,0,0,0,396,0,0,0,0,0,26124),
(115563,'When their work was done, the keepers sealed the Pillars away. But like so many relics, they ended up in the hands o\' mortals.','',396,0,0,0,0,0,396,0,0,0,0,0,26124),
(115564,'Your tale sounds familiar... I\'m sure I\'ve heard of these Pillars before.','',396,0,0,0,0,0,396,0,0,0,0,0,26124),
(115565,'Aye, Khadgar. The knowledge was placed in the care o\' the Guardian of Tirisfal, and remains there still!','',396,0,0,0,0,0,396,0,0,0,0,0,26124),
(115566,'Ye must find the Pillars! Combined, their power kin seal the Legion\'s gateway to Azeroth. \'Tis the only way to save her!','',603,0,0,0,0,0,396,0,0,0,0,0,26124),
(115567,'It\'s not every day a planet points me to my own library. Thank you, Magni. I will go to Karazhan at once. $n, follow me through the portal when you\'re done here.','',396,0,0,0,0,0,396,0,0,0,0,0,26124),
(115568,'And what of ye, brother? Will ye go back ta Ironforge?','',604,0,0,0,0,0,396,0,0,0,0,0,26124),
(115569,'Nay, Brann. She has... other duties for me. But I\'d be obliged if ye\'d stay fer a chat.','',604,0,0,0,0,0,396,0,0,0,0,0,26124),
(115570,'I\'d like that, brother! But I think me friend here has some work ta do.','',396,0,0,0,0,0,396,0,0,0,0,0,26124),
(115571,'I reckon so. Take care, $n. We\'ll see one another again.','',396,0,0,0,0,0,396,0,0,0,0,0,26124),
(115572,'I must find the others!','I must find the others!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115573,'We are stronger side by side, $n.','We are stronger side by side, $n.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115574,'Why didn\'t we bring some cannons?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115575,'Cannons?! And how are we supposed to get them here?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115576,'We\'ve got gryphons!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115577,'Really?! A gryphon carry a cannon?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115578,'It could grip it by the trunnion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115579,'It\'s not a question of where he grips it. It\'s a simple question of weight ratios!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115580,'A 500 pound gryphon could not carry a two thousand pound cannon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115581,'We shouldn\'t stick around. More will be here soon.','We shouldn\'t stick around. More will be here soon.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115582,'It could be carried by a Gilnean gryphon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115583,'Oh a Gilnean gryphon maybe, but not one of these local gryphons, that\'s my point.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115584,'But then, of course, you\'d never find a Gilnean gryphon around these parts anyway.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115585,'Supposing two gryphons carried it together?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115586,'No, they\'d have to have it on a line.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115587,'Simple! They\'d just use some rope from the tents!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115588,'What, held under the dorsal guiding feathers?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115589,'Why not!?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115590,'Best if we stick together!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115591,'Don\'t pay me no mind. Just gone ta stick around a bit. Least I can do.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(115592,'Best be gettin\' back. They\'ll be wonderin\' where I been.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(115593,'If it weren\'t fer you I\'d be... well, I can\'t say where I\'d be. Probably dead if it weren\'t fer you.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(115595,'Greetings, Grand Master $. What can I do for you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115597,'You cannot defy me!','',0,0,0,0,0,0,0,0,0,40285,69827,0,26124),
(115598,'Elisande will have your heads for this!','',0,0,0,0,0,0,0,0,0,40285,69828,0,26124),
(115599,'Vengeance for Margaux!','Vengeance for Margaux!',0,0,0,0,0,0,0,0,0,40285,0,0,26124),
(115600,'The taste of mana!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115601,'The thirst... never... ends.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115602,'I can help you change the power within your weapon if you\'re interested. I\'m the best smith this side of Ironforge!\n\nFair warning, though: some of the power will be lost in the process.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115603,'Guess I\'ll have to be a bit more careful. Thanks.','Guess I\'ll have to be a bit more careful. Thanks.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115604,'Thanks! That was a close one!','Thanks! That was a close one!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115605,'Stick to the shadows, $n.','Stick to the shadows, $n.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115606,'You\'re a life saver!','You\'re a life saver!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115607,'I sure am glad to see you! I thought I was a goner.','I sure am glad to see you! I thought I was a goner.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115608,'Keep moving! No telling what else is out here!','Keep moving! No telling what else is out here!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115609,'This bridge is mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115610,'How tiny thing...?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115611,'You should have joined us when you had the chance!','You should have joined us when you had the chance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115612,'If you so wish, I can help you alter the power within your blades.\n\nBe warned! Such change will not come without loss.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(115613,'Your kind will be left behind!','Your kind will be left behind!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115614,'Your time is up!','Your time is up!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115615,'Traitorous spies must die!','Traitorous spies must die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115616,'','I can reflow the venom within your blades to unlock new power wthin.\n\nThere\'s no charge for you, of course, but beware that some strength is lost in the process.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115617,'It is all too simple with this forge to rework the steel of your weapon to alter its power.\n\nSome souls will be lost, of course, but some always are.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(115618,'','I can use the magic in the grove to help you change the power within your weapon!\n\nThe spell\'s a bit unstable, though, so you\'ll lose a little bit when I cast it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115619,'Our people have been goin\' missing, the dead have been seen walking, and the fires are lit in the old fortress.$b$bThere\'s evil afoot, no doubt about it.$b$bIf you\'re here to help, then see our mayor down the road at Bradensbrook. Careful though, I think the pressure might be gettin\' to him.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115620,'','I believe we can use these withered as a weapon. But first we must teach them how to survive in battle.',0,0,0,0,0,0,1,0,0,0,0,69305,26124),
(115621,'I\'m ready!','I\'m ready!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115622,'Withered health increased!','Withered health increased!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115623,'Withered Berserker unlocked!','Withered Berserker unlocked!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115624,'','Destroy our enemies!',15,0,0,0,0,0,0,0,0,0,0,68091,26124),
(115625,'','Crush these invaders!',15,0,0,0,0,0,0,0,0,0,0,68092,26124),
(115626,'','For Odyn!',15,0,0,0,0,0,0,0,0,0,0,68093,26124),
(115627,'','Feel my wrath!',15,0,0,0,0,0,0,0,0,0,0,68094,26124),
(115628,'Glory to the Valarjar!','',15,0,0,0,0,0,0,0,0,0,68106,0,26124),
(115629,'A worthy enemy!','',15,0,0,0,0,0,0,0,0,0,68107,0,26124),
(115630,'Fight with valor!','',15,0,0,0,0,0,0,0,0,0,68108,0,26124),
(115631,'Destroy them!','',15,0,0,0,0,0,0,0,0,0,68109,0,26124),
(115632,'If you so wish, I can call upon the primordial forces present here and help you to infuse new power entirely into your weapon.\n\nJust be cautious: the ancient powers involved are volatile, and some power must return to the wilds in the process.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115633,'I wish I were younger so I could show these grell the tips of my claws and the points of my teeth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115634,'Stop! I command it! How dare you turn on your master?!','',0,0,0,0,0,0,603,0,0,0,66506,0,26124),
(115635,'Glad to have heroes like you here, $n. With all that\'s goin\' on I had to scramble my pilots to keep the skies clear!','',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(115636,'Hey, $n! Keep at it down here! My pilots will keep the skies clear above.','',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(115637,'You must be one of the brave ground forces. Keep up the good work! I\'m sending my best pilots up to keep \'em busy at the airfield.','',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(115638,'We can\'t lose the airfield! I\'m sending my best pilots there now. Help keep things calm down here and we\'ll clear the skies.','',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(115639,'You must be the $c they were talkin\' about! One of my pilots saw you from above. Said you were puttin\' on quite a show down here! Keep at it.','',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(115640,'If you desire to reflow the power within your weapon to achieve new results, Conjurer, just say the word and I can assist you.\n\nJust know that the incantation will use a small portion of the power as a catalyst.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115641,'$n! Keep \'em cleared out at ground level! My boys are stickin\' it to them at the airfield as we speak!','',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(115642,'If you wish to change the way your Chi flows through your weapon, it is as simple as willing it to be so. I can help you focus your thoughts in this effort.\n\nKeep in mind, Master $n, while most of the Chi will follow your new path... some will not. Such is its nature.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115645,'','Saa\'ra\'s been teachin\' me more an\' more about how to use the altar. If ye want, I should be able ta help ye change how the power\'s sittin\' in yer blade.\n\n\'Course, I\'m still learnin\', so it won\'t be a perfect transfer. A bit o\' the power will dissolve into the nether.',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(115646,'I gave you what you wanted, now leave me be!','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(115647,'Hey wikket, come here! Great danger is near!','',0,0,0,0,0,0,0,0,0,0,64444,0,26124),
(115648,'Withered troops are now less likely to run away when injured!','Withered troops are now less likely to run away when injured!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115649,'Get movin\', wikket! Yu\'lon be in trouble. Let\'s get to her side and give aid on the double!','',0,0,0,0,0,0,0,0,0,0,64445,0,26124),
(115650,'You hear the sounds of chitinous legs descending from the shadows...','You hear the sounds of chitinous legs descending from the shadows...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115651,'|TInterface\\Icons\\ability_demonhunter_chaosnova:20|t%s drains a spider to |cFFFF0000|Hspell:218217|h[Unleash]|h|r its energy!','|TInterface\\Icons\\ability_demonhunter_chaosnova:20|t%s drains a spider to |cFFFF0000|Hspell:218217|h[Unleash]|h|r its energy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115652,'Ooo, that no look good! Come, wikket, this way. There\'s greenies about, but we\'ve no time to play.','',0,0,0,0,0,0,0,0,0,0,64446,0,26124),
(115653,'','Psst! Hey, $n, over here!',0,0,0,0,0,0,603,0,0,0,0,69881,26124),
(115654,'Withered troops will now focus more of their attacks on enemies!','Withered troops will now focus more of their attacks on enemies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115655,'','Champion! I bear orders from Greymane!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(115656,'Withered Mana-Rager unlocked!','Withered Mana-Rager unlocked!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115657,'Withered Spellseer unlocked!','Withered Spellseer unlocked!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115658,'Withered Starcaller unlocked!','Withered Starcaller unlocked!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115659,'The world shifts ever beneath our feet, $ct. As shaman, we must always be ready to adapt.\n\nPerhaps you need to change the properties of the weapons you wield? The elements are listening.\n\nI can convince them to alter how their power flows through your artifacts - they ask for but a small portion of it released back to them in return.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115660,'','I can see it in ya eyes - ya be wanting somethin\' different for that artifact ya be wielding. Somethin\' new.\n\nYa come ta the right place, Overlord. I can help ya... but I be makin\' no guarantees that every drop gonna be where ya left it.\n\nDemon blood be too volatile for guarantees.',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(115661,'Thank you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115662,'','I AM RENEWED! Come, little ones. Let us put an end to this invasion!',0,0,0,0,0,0,0,0,0,0,0,64387,26124),
(115663,'We can use the Forge of Odyn to alter the very core of your artifact, allowing us to redistribute its power as you wish.\n\nHowever, we must use a small fragment of its power to work the blade in this way.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(115664,'Hail. I am Helgar, master smith of Skyhold.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(115665,'','What can I do for ye?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(115667,'','Come on Cora, it\'s time to head home.',0,0,0,0,0,0,1,0,0,0,0,66585,26124),
(115669,'Thank you! I was getting weary.','',1,0,0,0,0,0,0,0,0,0,68081,0,26124),
(115670,'The Legion appeared out of nowhere. They must have a portal nearby. Let\'s go find it!','',1,0,0,0,0,0,0,0,0,0,68082,0,26124),
(115671,'I am Moorgoth the Death Hunter, stalker of the night and master of shadows.$b$bWould you like to browse my wares?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115672,'Uh, have we met before?','Uh, have we met before?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115673,'Have you skirted the vast abyss of death? Have you stared entropy in the eye? Then you have met Moorgoth!$b$bOh. Right. I guess you have, haven\'t you? I should have thought that through.$b$bI realize I didn\'t receive some divine calling to come here like some of the others, but I thought you would have need of my services.','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(115674,'Don\'t think I\'ve ever heard of \"death hunters\".','Don\'t think I\'ve ever heard of \"death hunters\".',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115675,'There aren\'t a lot of us. That is to say, only a few. Okay, it\'s me and a couple buddies. But our ranks will grow!$b$bOur mandate is to patrol the shadowed roads of Azeroth and the realms beyond, keeping it safe for the innocent. And...$b$bLook, I\'m going to be honest. We just really, really think dark rangers are amazing and we want to be near them.','',396,396,0,0,0,0,0,0,0,0,0,0,26124),
(115676,'Wait. What?','Wait. What?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115677,'Thank you, $c! Without you I would have surely perished!','Thank you, $c! Without you I would have surely perished!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115678,'I mean, just look at Velonara over there. She\'s like a dream! So brooding, so mysterious, so... dark.$b$bHave you worked with her before? What was it like? Say, have you two ever...$b$bNevermind. Best not to know such things. The past is the past, and I need to focus on the future. My future with her.$b$bThat\'s why I got all these black roses. I was going to give her a dozen, but that doesn\'t feel like quite enough to impress her. Say, would you talk to her? About me, I mean? Maybe bring her a gift?','',396,396,0,0,0,0,0,0,0,0,0,0,26124),
(115679,'I don\'t really want to get involved...','I don\'t really want to get involved...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115680,'Light bless you!','Light bless you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115681,'I owe you my life!','I owe you my life!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115682,'That\'s fantastic! You\'re really the greatest. Oh, I hope Velonara has noticed me!','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(115683,'I can make it back on my own now. Your heroics have strengthened my resolve!','I can make it back on my own now. Your heroics have strengthened my resolve!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115684,'I was just talking to Moorgoth, and he...','I was just talking to Moorgoth, and he...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115685,'How can I ever repay you for this, hero?','How can I ever repay you for this, hero?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115686,'Have you seen my brother? I hope he made it to the Prophet!','Have you seen my brother? I hope he made it to the prophet!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115687,'','You mean that moping, black-clad imbecile across the way? The one who keeps leering at me?$b$bYes, I\'ve noticed him. He\'s not the first mortal to obsess over a dark ranger. I don\'t understand the fascination some have with death. He should spend his time pursuing the living, not longing for a dalliance with one who has already passed.$b$bLife is often wasted on the living.',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(115688,'You sound as if you miss your previous life.','You sound as if you miss your previous life.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115689,'','I was a maiden, pure and true. A young ranger in service of Silvermoon, betrothed to the nobleman of my dreams.$b$bThen Arthas came.$b$bI fell in battle as the mad prince cut a black scar through the land I loved. But at least I was at peace, I suppose. For a time. Until the Banshee Queen pulled me back from beyond and damned my soul into her service.$b$bYou\'ll have to pardon me if I have little patience for imbeciles like Moorgoth, who take for granted what they have and think to find happiness in pain.',396,396,0,0,0,0,0,0,0,0,0,0,26124),
(115690,'He doesn\'t seem like such a bad guy.','He doesn\'t seem like such a bad guy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115691,'','<The dark ranger sighs.>$b$bI suppose he has a certain charm. He can\'t help his ignorance.$b$bBut he must realize that my heart is incapable of feeling love or happiness, nor could we... engage in the sort of intimacy he desires. I am a dead, rotting thing, and only the abyss awaits me.$b$bPlease, if you have any fondness for him at all, break his heart now. It will save him true pain later.$b$b<Velonara pauses a moment, then takes a single black rose and caresses its petals.>',396,396,0,0,0,0,0,0,0,0,0,0,26124),
(115692,'Do you wish to summon Elementals?','Do you wish to summon Elementals?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(115693,'What did Velonara say? Is she interested? Would she like dinner? I\'ve been known to roast a mean boar loin.','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(115694,'Sorry, Moorgoth. She said no.','Sorry, Moorgoth. She said no.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115695,'Really? I thought she might...$b$bOh, I get it. I figured she had a thing for you. Makes sense. Brave hero, leader of the Unseen Path... How can a guy like me compete with all that?$b$bThanks anyway, $n. No hard feelings, right?$b$bSay, I don\'t suppose you\'d talk to Dark Ranger Alina for me, would you? She\'s so gorgeous...','',6,396,0,0,0,0,0,0,0,0,0,0,26124),
(115696,'I have to go.','I have to go.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115697,'Okay, okay, fine. Anytime you\'re interested in browsing my wares, let me know!','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(115698,'I\'ll let him down easy.','I\'ll let him down easy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115699,'Finally! The Book of Medivh is ours! Would have saved ourselves time if you\'d just let me kill those death-lovers!','',0,0,0,0,0,0,0,0,0,0,66465,0,26124),
(115700,'','Not worth the effort, dear! Let them rot in their crypt. The fires of the Legion will come for them soon enough.',0,0,0,0,0,0,0,0,0,0,0,66466,26124),
(115701,'Hmmph! Wait... something is wrong!','',0,0,0,0,0,0,0,0,0,0,66467,0,26124),
(115702,'Well, it looks like I\'ll be speaking to her.','Well, it looks like I\'ll be speaking to her.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115703,'Calydus is here to help!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115704,'<Tell Calydus about the ritual and the Scepter.>','<Tell Calydus about the ritual and the Scepter.>',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115705,'Gul\'dan will use Scepter, Eye, and Book to make portals bigger and stronger. Many, many demons pour through! Friend not want that, I think.','',0,0,0,0,0,0,0,0,0,0,66468,0,26124),
(115706,'More grell?! Was ransacking my home not enough?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115707,'That should teach them to stay away... you move into a cottage in the middle of the forest and never find peace.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115708,'What if friend trick Gul\'dan into giving up scepter? Then ruin ritual and run away! Haha! This can work, friend!','',0,0,0,0,0,0,0,0,0,0,66469,0,26124),
(115709,'Thanks to you, Thunderfury has been restored and Thunderaan\'s spirit can finally be released.','',0,0,0,0,0,0,0,0,0,0,67072,0,26124),
(115710,'Look to the heavens and witness the rebirth of Thunderaan... THE WINDLORD!','',0,0,0,0,0,0,0,0,0,0,67073,0,26124),
(115711,'','Ugh... Oh, my head!',0,0,0,0,0,0,0,0,0,0,0,64399,26124),
(115712,'Take their stuff!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115713,'Bonk them to the ground!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115714,'Smash their smashies!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115715,'Scratch their feets!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115716,'Bite their knees!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115717,'','Oh, Stonestep... your sacrifice will not be in vain!',0,0,0,0,0,0,0,0,0,0,0,64401,26124),
(115718,'If we wish to defeat the Houndmaster, we\'ll need to lure him to a location of our choosing.','',0,0,0,0,0,0,1,0,0,0,66630,0,26124),
(115719,'','I am a collector of herbs, flowers, and plants. My travels have taken me all across the Broken Isles, as well as into the Emerald Dream. How can I help you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115720,'Malevolence, get us out of here.','',0,0,0,0,0,0,22,0,0,0,66973,0,26124),
(115721,'Malevolence, get us out of here.','',0,0,0,0,0,0,22,0,0,0,66974,0,26124),
(115722,'','Of course, my dears.',0,0,0,0,0,0,0,0,0,0,0,66975,26124),
(115723,'The fish sure are biting today!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115724,'Tylos, jump us back to Mardum.','',0,0,0,0,0,0,0,0,6,0,66976,0,26124),
(115725,'Tylos, jump us back to Mardum.','',0,0,0,0,0,0,0,0,6,0,66977,0,26124),
(115726,'Do you happen to have an extra raft I can borrow?','Do you happen to have an extra raft I can borrow?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115727,'Living in the wild you never know what will happen next, but a good hunter can survive on skill and instinct.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115728,'You need to eat to survive in the wild.$B$BBoar meat makes a hearty meal when cooked over an open flame. It should not be eaten raw, however.$B$BThere are many berries that grow in this region. Some are edible, while others cause minor sickness when ingested. You can often determine which are safe to eat by their smell. A sweet aroma indicates the berry is unsafe to eat.$B$BFirewood can be obtained from dying trees. They are easily identified by their dry, purple leaves.$B$BAre you ready to begin?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115729,'','I\'m coming too!',0,0,0,0,0,0,0,0,0,0,0,64402,26124),
(115730,'','Today we celebrate a great triumph, one paid for with the blood of those most dear to us.',0,0,0,0,0,0,1,0,0,0,0,64071,26124),
(115731,'','Thanks to your courage, the ancient lands of Val\'sharah can at long last begin to heal.',0,0,0,0,0,0,1,0,0,924,0,69980,26124),
(115732,'','Now the Tears of Elune are added to our arsenal. May they bring us victory against the Legion!',0,0,0,0,0,0,1,0,0,0,0,69979,26124),
(115733,'Sure do! Just go out into the water and you should be good to go!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115734,'','Today we celebrate a great triumph, one paid for with the blood of those most dear to us.',0,0,0,0,0,0,1,0,0,923,0,0,26124),
(115735,'','Though I am often at odds with your Horde, I cannot question the courage you\'ve shown saving Val\'sharah.',0,0,0,0,0,0,1,0,0,923,0,64073,26124),
(115736,'','Now the Tears of Elune are added to our arsenal. May they bring us victory against the Legion!',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(115738,'Well done, hero of the Light! We will now safeguard this area and give you assistance!','Well done, hero of the Light! We will now safeguard this area and give you assistance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115739,'','Malfurion! Where is my beloved?',0,0,0,0,0,0,1,0,0,0,0,68234,26124),
(115740,'I shall also send Hydraxis to aid the Earthen Ring. He is my greatest champion and will prove valuable in your quest.','',0,0,0,0,0,0,0,0,0,0,67074,0,26124),
(115741,'The Heart of Azeroth resides at the intersection of the elemental powers on this world. There is no place on Azeroth that is more connected to each of the elements.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115742,'We must rescue Kotira quickly, before we are discovered.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115743,'Let\'s rescue Koltira and get out of here.','Let\'s rescue Koltira and get out of here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115744,'Release the construct.','Release the construct.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115745,'You have successfully vanquished the rogue construct.','You have successfully vanquished the rogue construct.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115746,'','Until then, watch your step. The city is on high alert, and the guards will kill you on sight.',0,0,0,0,0,0,396,0,0,0,0,64453,26124),
(115747,'The cell door is unlocked, you feel  a sizeable amount of power emanating from within.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115748,'As the sentry\'s power builds, you feel the hairs on the back of your neck raise with static.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115749,'The sentry releases its energies.  You hear the faint whistle of something falling.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115750,'|TInterface\\Icons\\spell_druid_massentanglement_nightmare:20|tThe Eye of Il\'gynoth begins to cast |cFFFF0000|Hspell:218415|h[Death Blossom]|h|r!','|TInterface\\Icons\\Achievement_Boss_YoggSaron_01:20|tA Dominator Tentacle faces you and readies |cFFFF0000|Hspell:208689|h[Ground Slam]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(115751,'I will begin to channel my essence into the arcane vessel.','',0,0,0,0,0,0,1,0,0,0,66598,0,26124),
(115752,'Once the process is complete, Hakkar should be drawn to the vessel\'s magic.','',0,0,0,0,0,0,1,0,0,0,66599,0,26124),
(115753,'While my essence is contained within the vessel, I will be in a weakened state, unable to assist.','',0,0,0,0,0,0,1,0,0,0,66600,0,26124),
(115754,'Careful not to singe the buds as you burn!','',0,0,0,0,0,0,0,0,0,0,68642,0,26124),
(115755,'One garden pest deserves another!','',0,0,0,0,0,0,0,0,0,0,68641,0,26124),
(115756,'At least power is something your feeble minds comprehend!','',0,0,0,0,0,0,0,0,0,0,68640,0,26124),
(115757,'Rage against the dying of the light!','',0,0,0,0,0,0,0,0,0,0,68639,0,26124),
(115758,'When the light dies... so do you!','',0,0,0,0,0,0,0,0,0,0,68638,0,26124),
(115759,'Nature nourishes those who truly appreciate it.','',0,0,0,0,0,0,0,0,0,0,68637,0,26124),
(115760,'You\'ll make a fine seedling for my power!','',0,0,0,0,0,0,0,0,0,0,68636,0,26124),
(115761,'Night falls upon you!','',0,0,0,0,0,0,0,0,0,0,68635,0,26124),
(115762,'The sun warms my beauties... but it shall scorch your bones!','',0,0,0,0,0,0,0,0,0,0,68630,0,26124),
(115763,'Wither in my heat, little weeds!','',0,0,0,0,0,0,0,0,0,0,68629,0,26124),
(115764,'Now you face three aspects of life, even as your cycle is about to end!','',0,0,0,0,0,0,0,0,0,0,68628,0,26124),
(115765,'Can you hope to stand against the three primal forces that shape life itself?','',0,0,0,0,0,0,0,0,0,0,68627,0,26124),
(115766,'Suramar owes its beauty to my blooms! I alone have mastered the delicate intertwining of magic into nature\'s grand cycle.','',0,0,0,0,0,0,0,0,0,0,68626,0,26124),
(115767,'Your corpse will make a fine compost!','',0,0,0,0,0,0,0,0,0,0,68625,0,26124),
(115768,'More food for the worms!','',0,0,0,0,0,0,0,0,0,0,68624,0,26124),
(115769,'How dare you disturb my pristine gardens!','',0,0,0,0,0,0,0,0,0,0,68634,0,26124),
(115770,'It seems I\'ve a bit of pruning to do!','',0,0,0,0,0,0,0,0,0,0,68633,0,26124),
(115771,'Death is merely part of the great cycle.','',0,0,0,0,0,0,0,0,0,0,68623,0,26124),
(115772,'Wherever will I store all this fertilizer?','',0,0,0,0,0,0,0,0,0,0,68622,0,26124),
(115773,'A bitter... harvest...','',0,0,0,0,0,0,0,0,0,0,68632,0,26124),
(115774,'Someone... water... my plants...','',0,0,0,0,0,0,0,0,0,0,68631,0,26124),
(115775,'My rangers are armed and ready to fight by your side!','',0,0,0,0,0,0,1,0,0,0,66610,0,26124),
(115776,'','My archers have their bows loaded, ready to shoot any demons that dare enter these walls.',0,0,0,0,0,0,1,0,0,0,0,66611,26124),
(115777,'','Is it working?',0,0,0,0,0,0,6,0,0,0,0,66612,26124),
(115778,'Has Hakkar taken the bait?','',0,0,0,0,0,0,1,0,0,0,66613,0,26124),
(115779,'','Send up a flare, and we shall see.',0,0,0,0,0,0,1,0,0,0,0,66614,26124),
(115780,'The Doomhammer could be anywhere. We\'ll have to split up.','',0,0,0,0,0,0,1,0,4,0,68828,0,26124),
(115781,'I will speak with the shaman at the Temple of Earth.','',0,0,0,0,0,0,1,0,4,0,68829,0,26124),
(115782,'','I\'ll see if the Earthen at Stonehearth saw anything.',0,0,0,0,0,0,1,0,0,0,0,68830,26124),
(115783,'Shaman, you must seek out the Stonemother. But be cautious - she is quick to anger.','',0,0,0,0,0,0,1,0,0,0,68831,0,26124),
(115784,'We should meet back up at Therazane\'s Throne once we know more. Good luck to both of you!','',0,0,0,0,0,0,1,0,0,0,68832,0,26124),
(115785,'','Demons are near! Sentinels, ready your blades!',0,0,0,0,0,0,1,0,0,0,0,66615,26124),
(115786,'','I have a proposition for you. Just beneath us lies some excellent crab meat... I mean, they\'re still alive, but you understand my point.$b$bI have some buoys here you could use to bring them to the surface. You go down and attach the buoys and I\'ll capture what rises to the surface.$b$bDo this for me and I promise you\'ll be rewarded handsomely. What do you say?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115787,'I\'m ready. Give me the buoys.','I\'m ready. Give me the buoys.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115788,'','Watch yourself down there. There are some other creatures that linger near the crabs that you don\'t want to cross paths with.$b$bYou know, I could have been a $c like you had I not followed in my father\'s footsteps and took to the sea.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115789,'','Ancestors... forgive me...',0,0,0,0,0,0,0,0,0,0,0,64165,26124),
(115790,'You have done what the Kirin Tor could not do for ourselves. The Houndmaster\'s death will deliver a crushing blow to the Burning Legion\'s forces.','',0,0,0,0,0,0,1,0,0,0,66608,0,26124),
(115791,'Let us leave this place, and celebrate our victory among friends.','',0,0,0,0,0,0,1,0,0,0,66609,0,26124),
(115792,'','You overreact, Terrath. Answers will come. Ah, a mortal approaches. Whenever there is trouble, the flesh is not far away, hm?',0,0,0,0,0,0,1,0,0,0,0,68833,26124),
(115793,'','Something is whipping the troggs into a frenzy. Maybe it has to do with that missing hammer of yours. Be a dear and take care of them, hm?',0,0,0,0,0,0,1,0,0,0,0,68834,26124),
(115794,'','Oh how lovely, lovely! The clutch is safe. Join me back at my throne. I know where to find your hammer - and the stone dragons are now free to help.',0,0,0,0,0,0,1,0,0,0,0,68835,26124),
(115795,'','Here comes my new favorite fleshling. You are a true friend of the Stonemother, shaman.',0,0,0,0,0,0,1,0,0,0,0,68836,26124),
(115796,'','The trogg chieftain knows where your hammer fell, shaman. Beat the information out of him! The stone dragons are at your disposal.',0,0,0,0,0,0,1,0,0,0,0,68837,26124),
(115797,'','This should help you get around while you\'re down there. It doesn\'t last long, so be quick.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115798,'The sentry hums with arcane energies as indecipherable elfish runes dance faintly across the surface of its lens.  There is one talon that glows faintly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115800,'A second talon flashes intermittently; but the sentry is otherwise inactive. It is as though it waits for some outside input.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115801,'The sentry seems inactive but for one of its talons flashing intermittently.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115802,'With the sequence completed, the sentry\'s lens is alive with runes scrolling to and fro.  You\'re not sure what to make of it all though.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115803,'','Troubles on the surface don\'t belong down here, shaman. I hope you intend to put this right.',0,0,0,0,0,0,1,0,0,0,0,68838,26124),
(115804,'Koltira is being held nearby! We must hurry!','',0,0,0,0,0,0,0,0,0,0,69432,0,26124),
(115805,'Here is the sentry Sira mentioned. As indicated, the talon is flashing red.  All that remains is begin the energy transfer sequence and to survive.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115806,'The sentry is alive with arcane energies.  Its eyes are constantly scanning the environment.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115807,'The sentry\'s readouts seem to have calmed down, relatively speaking. There\'s still a danger indicator on the lower levels...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115808,'On the readout for this sentry, you see a small representation of the trapped creature at the top of the elevator shaft.  There is one talon frantically flashing red.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115809,'Calydus is here, friend! Council flees! Haha!','',0,0,0,0,0,0,0,0,0,0,66464,0,26124),
(115810,'New arrivals! Yer right on time! We\'ve got \'em cornered!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(115811,'This here beasty thinks he\'s got some bite! Show \'em how we treat unwelcome guests.','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(115812,'Ah, another brave adventurer. Show \'em yer strength!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(115813,'Don\'t let up! We\'ve got more ground ta cover after this one\'s laid ta rest!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(115814,'Give \'em everythin\' ye got!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(115815,'Keep at it! More reinforcements just arrived!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(115816,'Reinforcements\'ll be \'ere soon! Give \'em no ground!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(115817,'Ye\'ve done it again! Well fought everyone, but we shan\'t celebrate just yet. There\'s plenty else needin\' our help.','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(115818,'You have left the combat area. You will be teleported back shortly.','Warning: You\'ve entered a no-fly zone and are about to be dismounted!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(115819,'In here! We can leap over the flames!','',1,0,0,0,0,0,0,0,0,0,68083,0,26124),
(115820,'Hodir\'s cut off from the rest of the temple. They\'ll surround him soon if we don\'t move fast.','',0,0,0,0,0,0,0,0,0,0,68411,0,26124),
(115821,'Hodir\'s room\'s behind that door. We need to get it open.','',0,0,0,0,0,0,0,0,0,0,68413,0,26124),
(115822,'Get down!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115823,'Caria... no...','',0,0,0,0,0,0,0,0,0,0,66942,0,26124),
(115824,'','Varedis... no!',0,0,0,0,0,0,0,0,0,0,0,66943,26124),
(115825,'Let\'s start brewing!','Let\'s start brewing!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115826,'We are close to completing the final brewing, but we are surrounded by enemies.$B$BHelp me fend off the attackers while Aegira completes the Storm Brew!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115827,'Good! Now, let us show them the might of the monks!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115828,'','I said no point blank shots!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115829,'You burned those naga real good, little ghost. Burned \'em right up.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115830,'Watch out! More attackers are incoming!','',0,0,0,0,0,0,0,0,0,0,66722,0,26124),
(115832,'Hurry, Grandmaster, while we have time. Drink the Storm Brew!','',0,0,0,0,0,0,0,0,0,0,66723,0,26124),
(115833,'','You bought me enough time. The brew is finished!',0,0,0,0,0,0,0,0,0,0,0,66729,26124),
(115834,'I hear their footsteps coming. Don\'t let down your guard!','',0,0,0,0,0,0,0,0,0,0,66724,0,26124),
(115835,'Stand firm, Grandmaster! Protect the brew at all costs!','',0,0,0,0,0,0,0,0,0,0,66725,0,26124),
(115836,'I am honored.','',0,0,0,0,0,0,0,0,0,0,66945,0,26124),
(115837,'You honor me.','',0,0,0,0,0,0,0,0,0,0,66946,0,26124),
(115838,'','Thank you, $n. I will not let you down.',0,0,0,0,0,0,0,0,0,0,0,66944,26124),
(115839,'Your mortal allies will not help you, little snake! Your doom is at hand!','',0,0,0,0,0,0,0,0,0,0,64393,0,26124),
(115840,'','Do you think that silly concoction will save you? Come out and face me. I will destroy what is left of the Broken Temple!',0,0,0,0,0,0,0,0,0,0,0,66726,26124),
(115841,'','Enough. Your time is ended, monk!',0,0,0,0,0,0,5,0,0,0,0,66727,26124),
(115842,'','Tell whoever you\'re sending that the sooner Gaardoun has his demonic toys, the sooner we\'ll have our new Ashtongue warriors.',0,0,0,0,0,0,0,0,0,0,0,66947,26124),
(115843,'','Hey Gaardoun, those new warriors ready yet?',0,0,0,0,0,0,0,0,0,0,0,66948,26124),
(115844,'','Could that really be Loramus Thalipedes? And if it is, do we save him or kill him?',0,0,0,0,0,0,0,0,0,0,0,66949,26124),
(115845,'','Be careful, $n. Half the time he\'s down there threatening us in the demonic tongue.',0,0,0,0,0,0,0,0,0,0,0,66950,26124),
(115846,'Make sure the Ashtongue understand that the other broken at the Black Temple are not to be trusted.','',0,0,0,0,0,0,0,0,0,0,66951,0,26124),
(115847,'I will do all I can to ensure our war against the Legion is successful. Make certain you do the same.','',0,0,0,0,0,0,0,0,0,0,66970,0,26124),
(115848,'I know everything Akama knows, and more. I look forward to us working together to destroy the Legion.','',0,0,0,0,0,0,0,0,0,0,66952,0,26124),
(115849,'','What took you so long? I should have been your first champion.',0,0,0,0,0,0,0,0,0,0,0,66953,26124),
(115850,'Ariana\'s just about the best trainer around. Who knows, maybe she\'ll even be able to teach them the Metamorphosis?','',0,0,0,0,0,0,0,0,0,0,66965,0,26124),
(115851,'Ghouls... I should have known!','',0,0,0,0,0,0,0,0,0,0,69433,0,26124),
(115852,'Don\'t let \'em reach the camp! Bad enough they\'ve already ruined the quarry!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(115853,'Keep at it! Not the time ta give \'em another inch o\' ground!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(115854,'Looks like more folks came ta help! I\'ll be gettin\' me quarry back if it\'s the last thing I do!','',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(115855,'Another arrival! Now we have a real shot o\' clearin\' \'em out down below!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(115856,'Looks like someone got the word out! Another fighter just arrived!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(115857,'More backup! Push on further! We\'ve got ta take the quarry back!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(115858,'Just a wee bit longer! Backup\'ll be here shortly!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(115859,'Hold \'em back just a tad longer!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(115860,'Won\'t be long now! Hold \'em off a bit longer!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(115861,'Great job everybody! You\'ve saved me quarry, but it looks like there\'s plenty left ta do. Help where ye can. An\' keep an eye out! They\'re poppin\' up everywhere!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(115866,'This is Horde territory, but you will not be welcome here with me.','',0,0,0,0,0,0,0,0,0,41523,69434,0,26124),
(115867,'That was a good fight!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115868,'I am glad you found us, $n!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115869,'There are more in trouble ahead. Let\'s keep moving!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115870,'','My three sisters from that tree hung,\nThe crimes accused there was not one,\nThe youngest sister did escape,\nAs the noose looped around their nape,\nOld Ravencrest is the one to blame,\nThis curse for you to lift our shame.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115871,'We are here to free you at last, my brother.','',0,0,0,0,0,0,0,0,0,0,69435,0,26124),
(115872,'Indeed, it has.','',0,0,0,0,0,0,0,0,0,0,69436,0,26124),
(115873,'We must hurry before the guards come.','',0,0,0,0,0,0,0,0,0,0,69437,0,26124),
(115874,'Thassarian... is it really you?','',0,0,0,0,0,0,0,0,0,0,69438,0,26124),
(115875,'It has been such a long time...','',0,0,0,0,0,0,0,0,0,0,69439,0,26124),
(115876,'Thank you. I need to rest for a bit after that.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(115877,'','The curse is lifted. Now I can finally rest. But remember hero. Let not good men acquiesce.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115878,'Ah, thank ye! Need a bit ta mend me wounds.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115879,'Not sure I\'m cut out fer all o\' this. I\'ll be back when it\'s a tad safer.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115880,'Oof! Careful! Me wounds aren\'t healed just yet.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115881,'Back on me feet, but me strength\'s still a bit low.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115882,'Thank ye!. Wasn\'t expectin\' that! Did ye come all the way out \'ere ta help?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115883,'Feelin\' a bit sluggish. Give me a bit o\' time ta recover.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(115884,'So... cold...','So... cold...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115885,'Will this hunger ever stop?','Will this hunger ever stop?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115886,'I can\'t take it anymore...','I can\'t take it anymore...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115887,'Hello? Is anybody there?','Hello? Is anybody there?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115888,'The cravings are unbearable...','The cravings are unbearable...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115889,'The pain! Make it stop!','The pain! Make it stop!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115890,'','Heroes, your fight is with Korithis. I\'ll protect you from his winged monstrosity.',0,0,0,0,0,0,0,0,0,0,0,64386,26124),
(115891,'It might leave a bad taste in our mouths, but working with the Wardens will get us what we need. We\'ve made worse sacrifices.','',0,0,0,0,0,0,0,0,0,0,66985,0,26124),
(115892,'Almost done with this one, then I gotta head out to the next gig.','Almost done with this one, then I gotta head out to the next gig.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115893,'Hopefully this one works... Startin\' to run low on spare parts.','Hopefully this one works... Startin\' to run low on spare parts.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115894,'Just a bit more work and it\'ll be good as new.','Just a bit more work and it\'ll be good as new.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115895,'So much for gettin\' this thing ready in a jiff... This one\'s a nightmare to fix!','So much for gettin\' this thing ready in a jiff... This one\'s a nightmare to fix!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115896,'Knew I shoulda brought my other wrench. This one\'s gonna be a while.','Knew I shoulda brought my other wrench. This one\'s gonna be a while.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115897,'Haha! So be it! Come, mortals, your death awaits!','',0,0,0,0,0,0,0,0,0,0,64394,0,26124),
(115898,'Light take you, $g brother:sister;.','Light take you, $g brother:sister;.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115899,'Let not your heart be troubled. I go now to make a place for you in the Light.','Let not your heart be troubled. I go now to make a place for you in the Light.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115900,'Light watch over you, my fallen $g brother:sister;.','Light watch over you, my fallen $g brother:sister;.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115901,'Let your wounds be cleansed. Go now safely into the Light.','Let your wounds be cleansed. Go now safely into the Light.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115902,'This changes nothing... your world... will... burn!','',0,0,0,0,0,0,0,0,0,0,64395,0,26124),
(115903,'I do not care what Sira says... if you want help from your champions while you\'re out there, they will come.','',0,0,0,0,0,0,0,0,0,0,66954,0,26124),
(115904,'Be careful. The last place she was seen is near the Gates of Valor. Nasty place.','',0,0,0,0,0,0,0,0,0,0,66955,0,26124),
(115905,'','You have learned well how to fight these creatures, but this will be only one of many battles.',0,0,0,0,0,0,0,0,0,0,0,64377,26124),
(115906,'','This is Fu Zan. Take it. May it shield you in the dark times ahead.',0,0,0,0,0,0,0,0,0,0,0,64378,26124),
(115907,'','Hurry, demon hunter. I do not like the look of that bonfire over there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115908,'Take me to the Legion invasion.','Take me to the Legion invasion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115909,'','Yes, the Grandmaster is here! Now these demons don\'t stand a chance!',0,0,0,0,0,0,0,0,0,0,0,66704,26124),
(115910,'We can handle things here. Grandmaster, go south and join Chen and Aegira in the temple. They need your help more than we do!','',0,0,0,0,0,0,5,0,0,0,66705,0,26124),
(115911,'|TInterface\\Icons\\inv_bannerpvp_02.blp:20|t You gain |cFFFF0000|Hspell:185265|h[For the Alliance]|h|r!','|TInterface\\Icons\\inv_bannerpvp_02.blp:20|t You gain |cFFFF0000|Hspell:185265|h[For the Alliance]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115912,'You honor me, $n. When we started all of this, I never would have imagined being chosen as one of your select few. I will not fail you.','',0,0,0,0,0,0,0,0,0,0,66966,0,26124),
(115913,'','I have always been honored to be one of the Servants of Illidan. But, to officially become one of the Illidari... look away, $n, I think I might cry.',0,0,0,0,0,0,0,0,0,0,0,66979,26124),
(115914,'','Let me assure you, $n, I will use everthing at my disposal, every bit of power within the Scythe of Souls, to track down the whereabouts of Caria and Varedis.',0,0,0,0,0,0,0,0,0,0,0,66980,26124),
(115915,'Save us!','Save us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115916,'We won\'t go down without a fight!','We won\'t go down without a fight!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115917,'They\'ve finally found us...','They\'ve finally found us...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115918,'The Burning Legion are unrelenting.','The Burning Legion are unrelenting.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115919,'Do you think my family is safe? I haven\'t seen them.','Do you think my family is safe? I haven\'t seen them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115920,'If the Prophet\'s barrier falls we are all doomed!','If the Prophet\'s barrier falls we are all doomed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115921,'Light help us!','Light help us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115922,'Is this the end?','Is this the end?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115923,'Just south of Kharanos! Huge demon spotted in the skies! It\'s headin\' right fer us!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(115924,'Huge demon in the skies! It\'s headed fer us at Kharanos! Send reinforcements!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(115925,'Needin\' the help of a weaponsmith, $n? Hand me yer weapons. I\'ll see what I can do.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115926,'<Hand over your weapons.>','<Hand over your weapons.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115927,'Good as new. Be careful out there, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115928,'','The Scythe of Souls tells me that it\'s jealous of you harvesting so many powerful spirits.',0,0,0,0,0,0,0,0,0,0,0,66981,26124),
(115929,'Break your bodies upon the prophet\'s barrier, minions! Soon it shall fall, and with it the hopes of the draenei!','',0,0,0,0,0,0,0,0,0,0,70844,0,26124),
(115930,'All we need are these last few parts from the other command centers. Otherwise, the Fel Hammer is ready to jump to Niskara.','',0,0,0,0,0,0,0,0,0,0,66982,0,26124),
(115931,'That doesn\'t sound good at all. Sounds like something very big outside the Fel Hammer to the south.','',0,0,0,0,0,0,0,0,0,0,66978,0,26124),
(115932,'Recruiting Allari and Jace as your champions is long overdue. They\'ve earned it.','',0,0,0,0,0,0,273,0,0,0,66968,0,26124),
(115933,'Recruiting Allari and Jace as your champions is long overdue. They have earned it.','',0,0,0,0,0,0,273,0,0,0,66871,0,26124),
(115934,'','Wretched creatures! You\'ve already stolen my life! What else do you wish to take from me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115935,'','We have been through so much together. Of course I accept!',0,0,0,0,0,0,0,0,0,0,0,66872,26124),
(115936,'I stand ready to represent you and the Illidari. What\'s next, $n?','',0,0,0,0,0,0,0,0,0,0,66873,0,26124),
(115937,'How would you like to improve the order hall?','How would you like to improve the order hall?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115939,'Aeosera calls for her drakes to assault Needlerock!','',0,0,0,0,0,0,51,0,0,0,38815,0,26124),
(115940,'Illidari! Servants of Illidan! Hear me!','',0,0,0,0,0,0,22,0,0,0,66874,0,26124),
(115941,'Illidari! Servants of Illidan! Hear me!','',0,0,0,0,0,0,22,0,0,0,66864,0,26124),
(115942,'We gather here today to pay tribute to one who has served with both honor and distinction as our indomitable leader.','',0,0,0,0,0,0,1,0,0,0,66865,0,26124),
(115943,'We gather here today to pay tribute to one who has served with both honor and distinction as our indomitable leader.','',0,0,0,0,0,0,1,0,0,0,66866,0,26124),
(115944,'We have regained the Sargerite Keystone. We have defied Kil\'jaeden and invaded a Legion world. And, we have vanquished our nemeses, Caria and Varedis Felsoul.','',0,0,0,0,0,0,1,0,0,0,66967,0,26124),
(115945,'We have regained the Sargerite Keystone. We have defied Kil\'jaeden and invaded a Legion world. And, we have vanquished our nemeses, Caria and Varedis Felsoul.','',0,0,0,0,0,0,1,0,0,0,66986,0,26124),
(115946,'For this and countless other successes, we bestow one of our highest honors, the title of Slayer upon $n.','',0,0,0,0,0,0,1,0,0,0,66983,0,26124),
(115947,'For this and countless other successes, we bestow one of our highest honors, the title of Slayer upon $n.','',0,0,0,0,0,0,1,0,0,0,66969,0,26124),
(115948,'|TInterface\\Icons\\Ability_Druid_ChallangingRoar:20|t%s is casting |cFFFF0000|Hspell:200580|h[Maddening Roar]|h|r. Stop Casting!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(115949,'One of the sentries starts issuing a low alarm sound.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115950,'One of the sentries periodically issues a very insistent alarm.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115951,'As the demon falls, you hear the sounds of a larger lens sentry rise in the entry to this room.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115952,'The last lens submerges, and you hear the sharp rise and gentle hum of power coursing through the room.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115953,'The sentry absorbs the strange energy picked up from the cell, and the security measures of the room power down.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115954,'As the animus falls, the sentry that issued the alarm powers down.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115955,'The sentry starts humming with energy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115956,'|TInterface\\Icons\\SPELL_DRUID_BEARHUG:20|t%s is casting |cFFFF0000|Hspell:198376|h[Primal Rampage]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(115957,'','The Vault is replete with magical safeguards. One such system may be found within the prison built for the demon Glazer.',0,0,0,0,0,0,0,0,0,0,0,70656,26124),
(115958,'','Excellent work, that should keep the Vault\'s containment functioning until we can retake it. Now find and vanquish the traitor!',0,0,0,0,0,0,0,0,0,0,0,70659,26124),
(115959,'','The other Wardens tell me that the third sublevel of our vault was hit particularly hard, and that some of its systems may soon lose power.',0,0,0,0,0,0,0,0,0,0,0,70649,26124),
(115960,'','I want you to venture inside and complete an energy transfer procedure. The procedure is simple enough; but the security measures are severe.',0,0,0,0,0,0,0,0,0,0,0,70650,26124),
(115961,'','Subtlety is not one of Warden Mirana\'s qualities.',0,0,0,0,0,0,0,0,0,0,0,70651,26124),
(115962,'','Excellent work. Now find and defeat the traitor.',0,0,0,0,0,0,0,0,0,0,0,70652,26124),
(115963,'','As quartermaster, it was my duty to issue and train all of the Wardens in the use of the Moonglaive.',0,0,0,0,0,0,0,0,0,0,0,70646,26124),
(115964,'','With so few of us left, we need all the arms we can gather. Venture into the vault and recover the Moonglaives of our fallen sisters.',0,0,0,0,0,0,0,0,0,0,0,70647,26124),
(115965,'','I\'ll know the warden who last held those Moonglaives by sight alone.  I issued and trained each one.',0,0,0,0,0,0,0,0,0,0,0,70648,26124),
(115967,'','I suspect not all of the Felsworn managed to escape their prison. Normally I\'d leave prisoners to their fate, but a Demon Hunter left lurking in the dark is a danger far too great to let be.',0,0,0,0,0,0,0,0,0,0,0,70660,26124),
(115968,'','Find a way into the Demon Hunter wing and deal with whatever remains in the shadows.',0,0,0,0,0,0,0,0,0,0,0,70661,26124),
(115969,'','I shudder to think what would have become of the creature were it left to its fel subsistance.',0,0,0,0,0,0,0,0,0,0,0,70662,26124),
(115970,'','Thanks to you we won\'t ever know. Now find the traitor, make her pay for what she has wrought.',0,0,0,0,0,0,0,0,0,0,0,70663,26124),
(115971,'','I\'ve gotten reports that a particularly troublesome prisoner has nearly made their escape.  Thankfully one of the Vault\'s security measures has it trapped.',0,0,0,0,0,0,0,0,0,0,0,70653,26124),
(115972,'','The field won\'t hold forever, of course. Head into the Vault and deal with the creature once and for all.',0,0,0,0,0,0,0,0,0,0,0,70654,26124),
(115973,'','Well fought. Now, finish the traitor.',0,0,0,0,0,0,0,0,0,0,0,70655,26124),
(115974,'When the Burning Legion arrived, they took much from us.','',0,0,0,0,0,0,1,0,0,0,66709,0,26124),
(115975,'Many of us still grieve for our fallen friends. We long for the yesteryears of peace. And like you, I fear the dark days yet to come.','',0,0,0,0,0,0,1,0,0,0,66710,0,26124),
(115976,'But today, is NOT that day.','',0,0,0,0,0,0,5,0,0,0,66711,0,26124),
(115977,'Today, we celebrate the dawn of a new order! Today, we toast to friendship and fellowship!','',0,0,0,0,0,0,5,0,0,0,66712,0,26124),
(115978,'Under the Grandmaster\'s leadership, let every day be a new dawn!','',0,0,0,0,0,0,5,0,0,0,66713,0,26124),
(115979,'And let us never give up the fight for another tomorrow!','',0,0,0,0,0,0,53,0,0,0,66714,0,26124),
(115980,'To the Grandmaster!','',0,0,0,0,0,0,5,0,0,0,66715,0,26124),
(115981,'','To the Grandmaster!',0,0,0,0,0,0,1,0,0,0,0,66716,26124),
(115982,'','To the Grandmaster!',0,0,0,0,0,0,0,0,0,0,0,66717,26124),
(115983,'To the Grandmaster!','',0,0,0,0,0,0,4,0,0,0,66718,0,26124),
(115984,'To the Broken Temple!','',0,0,0,0,0,0,5,0,0,0,66719,0,26124),
(115985,'Broken Temple we toast! King loves this place most!','',0,0,0,0,0,0,1,0,0,0,66720,0,26124),
(115986,'Yes, yes! Come closer, friend!$B$BI see you has nice things! What does friend need? Perhaps some trinkets do you well?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115987,'All right then, what do you have?','All right then, what do you have?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115988,'Taming Aluneth will be no easy task. Take these scrolls. Aegwynn used them when she bound Aluneth to her will, perhaps you can do the same.','',0,0,0,0,0,0,1,0,0,0,64299,0,26124),
(115989,'Your will be done, master!','',0,0,0,0,0,0,0,0,0,0,70849,0,26124),
(115990,'Fear not $c, we will avenge the Broken Shore, and I will be right there with you when the day comes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115991,'I would like to browse your goods.','I would like to browse your goods.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115992,'','Fear not $c, we will avenge the Broken Shore, and I will be right there with you when the day comes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115993,'What you do, wikket? The brew\'s boiled over! It\'s ruined! Guess now we gotta start over!','',0,0,0,0,0,0,0,0,0,0,64427,0,26124),
(115994,'Divinius, $ct $n has crushed the incursion. Now is the time to take the Chosen and finish off the leftover demonic taint within our halls. Secure the Exodar for our people once more!','',0,0,0,0,0,0,0,0,0,0,70897,0,26124),
(115995,'Why are the other draenei trying to hurt us?','Why are the other draenei trying to hurt us?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115996,'I want my papa!','I want my papa!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115997,'Have you seen my mommy?','Have you seen my mommy?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115998,'I was so scared! Those angry draenei are hurting everyone!','I was so scared! Those angry draenei are hurting everyone!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(115999,'Is it safe to go back?','Is it safe to go back?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116000,'Thank you, $g mister:miss;.','Thank you, $g mister:miss;.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116001,'','Defeat the demon, then complete the start up sequence to restore power to the vault.',0,0,0,0,0,0,0,0,0,0,0,70657,26124),
(116002,'','Oh and... apologies for the sequence. Warden Malace is very fond of puzzles.',0,0,0,0,0,0,0,0,0,0,0,70658,26124),
(116003,'If the Four Horsemen are to do battle against the might of the Burning Legion, they will need a leader.','',0,0,0,0,0,0,0,0,0,0,68911,0,26124),
(116004,'One whose strength of spirit and loyalty to our world is without reproach.','',0,0,0,0,0,0,0,0,0,0,68910,0,26124),
(116005,'And so, I have gathered you here today to bring such a leader into our fold.','',0,0,0,0,0,0,0,0,0,0,68909,0,26124),
(116006,'Interred just beyond those walls is the body of Tirion Fordring, one of the greatest champions our world has known.','',0,0,0,0,0,0,0,0,0,0,68908,0,26124),
(116007,'The Silver Hand will not give him to us willingly. So, we will take him by force!','',0,0,0,0,0,0,0,0,0,0,68907,0,26124),
(116008,'We do what we must.','',0,0,0,0,0,0,0,0,0,0,68906,0,26124),
(116009,'Deathlord, we will begin at your command.','',0,0,0,0,0,0,0,0,0,0,68905,0,26124),
(116010,'The Stonemother sends her dragons. Take cover!','',0,0,0,0,0,0,39,0,0,0,0,0,26124),
(116011,'She has sent a surface-dweller to do her dirty work. Destroy the shaman!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(116012,'The Legion claims this realm, shaman. The troggs serve or the troggs die. This we know.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(116013,'Get out. Out! We will tell you nothing!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(116014,'We saw the hammer fall from the sky. We know where it is.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(116015,'We told the demon where to find it. Geth\'xun was his name.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(116016,'You are too late, too late... Within the Crumbling Depths... The Legion has it by now...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116017,'Hello, $n. Anything that I can do for you? Latest scouting report or an update on Legion activity on Azeroth?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(116018,'We\'re saved! Everyone to the Vault of Lights!','We\'re saved! Everyone to the Vault of Lights!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116019,'The hero of the Exodar has cleared a path for us!','The hero of the Exodar has cleared a path for us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116020,'The time is now brothers and sisters! To the Vault of Lights!','The time is now brothers and sisters! To the Vault of Lights!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116021,'We are saved!','We are saved!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116022,'The Legion will make us great!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116023,'The trogg will rise again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116024,'We serve the Legion now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116025,'It is too late for me... I can only feel...','',0,0,0,0,0,0,0,0,0,0,68410,0,26124),
(116026,'$n, I\'m glad Kor\'vas was able to find you quickly.','',0,0,0,0,0,0,66,0,0,37647,64597,0,26124),
(116027,'$n, we could use your help with a tactical decision.','',0,0,0,0,0,0,66,0,0,40459,64598,0,26124),
(116028,'It seems like yesterday that you and I stood in this very place, ready to destroy the Light in the name of the Lich King.$b$bToday we stand here, not to destroy... but to save this world from destruction.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116029,'I am ready to begin.','I am ready to begin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116030,'Grab a chain and help me!','',0,0,0,0,0,0,0,0,0,0,68414,0,26124),
(116031,'Hang on, Thorim! These filthy demons are no match for us!','',0,0,0,0,0,0,0,0,0,0,68084,0,26124),
(116032,'Magni snaps his fingers.','',273,0,0,0,0,0,273,0,0,0,0,0,26124),
(116033,'Let us test your knowledge of history, then! What is the highest rank that can be bestowed on a night elf Watcher?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116034,'Ranger-General.','Ranger-General.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116035,'Keeper.','Keeper.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116036,'Warden.','Warden.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116037,'Sentinel.','Sentinel.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116038,'Let us test your knowledge of history, then! Razormane and Bristleback are two feuding tribes of which race?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116039,'Quillboar.','Quillboar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116040,'Gnolls.','Gnolls.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116041,'Saberon.','Saberon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116042,'Harpies.','Harpies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116043,'Let us test your knowledge of history, then! Who was the naga lieutenant of Illidan and once handmaiden of Queen Azshara?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116044,'Naz\'jar.','Naz\'jar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116045,'Vashj.','Vashj.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116046,'Zhahara.','Zhahara.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116047,'Valishj.','Valishj.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116048,'Let us test your knowledge of history, then! What Pandaria creatures are the embodiments of negative emotions including doubt, despair, and anger?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116049,'Mantid.','Mantid.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116050,'Virmen.','Virmen.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116051,'Hozen.','Hozen.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116052,'Sha.','Sha.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116053,'Let us test your knowledge of history, then! Before succumbing to magical addiction, the Wretched were once members of which race?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116054,'Blood Elves.','Blood Elves.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116055,'Humans.','Humans.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116056,'Night Elves.','Night Elves.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116057,'Forsaken.','Forsaken.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116058,'Let us test your knowledge of history, then! What dragon appears in the Human guise of Lord Victor Nefarius?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116059,'Sabellian.','Sabellian.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116060,'Itharius.','Itharius.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116061,'Nefarian.','Nefarian.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116062,'Sapphiron.','Sapphiron.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116063,'Let us test your knowledge of history, then! What are the final words from this Headless Horseman quote: \"It is over, your search is done! Let fate choose now, ...\"','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116064,'\"the mighty one!\"','\"the mighty one!\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116065,'\"the rightful one!\"','\"the rightful one!\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116066,'\"the righteous one!\"','\"the righteous one!\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116067,'Let nothing stand in your way!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116068,'\"the delightful one!\"','\"the delightful one!\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116069,'Let us test your knowledge of history, then! What is a Grummle\'s most prized personal possession?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116070,'A Backpack.','A Backpack.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116071,'A Yak.','A Yak.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116072,'A Luckydo.','A Luckydo.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116073,'A Luckydont.','A Luckydont.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116074,'Let us test your knowledge of history, then! Bloodfeather, Windfury and Witchwing are all types of which race?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116075,'Harpy.','Harpy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116076,'Arakkoa.','Arakkoa.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116077,'Kaliri.','Kaliri.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116078,'Hippogryph.','Hippogryph.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116079,'Let us test your knowledge of history, then! What is the name of the desert that surrounds the Caverns of Time?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116080,'Uldum.','Uldum.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116081,'Tanaris.','Tanaris.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116082,'Silithus.','Silithus.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116083,'Desolace.','Desolace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116084,'Let us test your knowledge of history, then! What area was reshaped by Goblins to resemble the symbol of the Horde?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116085,'Azshara.','Azshara.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116086,'Kezan.','Kezan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116087,'Durotar.','Durotar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116088,'Mulgore.','Mulgore.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116089,'Let us test your knowledge of history, then! Which of the following is not an Orc clan?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116090,'Frostwolf.','Frostwolf.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116091,'Warsong.','Warsong.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116092,'Bloodfang.','Bloodfang.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116093,'Dragonmaw.','Dragonmaw.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116094,'Let us test your knowledge of history, then! Which night elf was appointed the jailor of Illidan Stormrage?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116095,'Jarod Shadowsong.','Jarod Shadowsong.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116096,'Malfurion Stormrage.','Malfurion Stormrage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116097,'Maiev Shadowsong.','Maiev Shadowsong.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116098,'Califax.','Califax.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116099,'Let us test your knowledge of history, then! What was the name of the once benevolent spiritual leader in Stormwind City that sided with Deathwing?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116100,'Benedictus.','Benedictus.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116101,'Katherine the Pure.','Katherine the Pure.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116102,'Grayson Shadowbreaker.','Grayson Shadowbreaker.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116103,'Arthur the Faithful.','Arthur the Faithful.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116104,'Let us test your knowledge of history, then! King Krush, King Mosh, and King Dred are all what type of creature?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116105,'Gorilla.','Gorilla.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116106,'Devilsaur.','Devilsaur.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116107,'Colossi.','Colossi.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116108,'Ogre.','Ogre.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116109,'Let us test your knowledge of history, then! What is the name of the bridge that connects the Arathi Highlands and the Wetlands?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116110,'Severed Span.','Severed Span.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116111,'Dawning Span.','Dawning Span.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116112,'Sulfuron Span.','Sulfuron Span.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116113,'Thandol Span.','Thandol Span.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116114,'','You are fierce for one so small, dwarf. What happened here?',15,0,0,0,0,0,0,0,0,0,0,68095,26124),
(116115,'Fight first, talk later!','',1,0,0,0,0,0,0,0,0,0,68085,0,26124),
(116116,'Let us test your knowledge of history, then! Before the Cataclysm, where could the remains of Mankrik\'s wife be found?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116117,'Thousand Needles.','Thousand Needles.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116118,'Durotar.','Durotar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116119,'Mulgore.','Mulgore.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116120,'The Barrens.','The Barrens.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116121,'Let us test your knowledge of history, then! Who was Jaina Proudmoore\'s mentor in the Kirin Tor?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116122,'Archmage Antonidas.','Archmage Antonidas.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116123,'Archmage Khadgar.','Archmage Khadgar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116124,'Archmage Modera.','Archmage Modera.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116125,'Archmage Kel\'Thuzad.','Archmage Kel\'Thuzad.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116126,'Let us test your knowledge of history, then! Where was Dalaran originally located in the Eastern Kingdoms?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116127,'Arathi Highlands.','Arathi Highlands.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116128,'Silverpine Forest.','Silverpine Forest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116129,'Hillsbrad Foothills.','Hillsbrad Foothills.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116130,'Tirisfal Glades.','Tirisfal Glades.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116131,'Let us test your knowledge of history, then! Who became the Lich King after Arthas was defeated?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116132,'Tirion Fordring.','Tirion Fordring.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116133,'Bolvar Fordragon.','Bolvar Fordragon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116134,'Darion Morgraine.','Darion Morgraine.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116135,'Terenas Menethil II.','Terenas Menethil II.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116136,'Let us test your knowledge of history, then! Which paladin was not among the five when the Silver Hand was originally created?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116137,'Uther.','Uther.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116138,'Alexandros.','Alexandros.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116139,'Gavinrad.','Gavinrad.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116140,'Saidan.','Saidan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116141,'Let us test your knowledge of history, then! What pit lord was the ruler of Outland before being imprisoned by Illidan Stormrage?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116142,'','Ah, my hero returns!',0,0,0,0,0,0,1,0,0,0,0,68849,26124),
(116143,'Azgalor.','Azgalor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116144,'Brutallus.','Brutallus.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116145,'Mannoroth.','Mannoroth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116146,'Magtheridon.','Magtheridon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116147,'The shaman at the Temple of Earth know nothing.','',0,0,0,0,0,0,6,0,0,0,68850,0,26124),
(116148,'Let us test your knowledge of history, then! Who became Ragnaros\' second Majordomo, protecting the entrance of Sulfuron Keep in the Firelands?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116149,'Majordomo Staghelm.','Majordomo Staghelm.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116150,'Majordomo Executus.','Majordomo Executus.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116151,'','Stonehearth is missing some prospectors, but they don\'t have any ideas.',0,0,0,0,0,0,6,0,0,0,0,68851,26124),
(116152,'Majordomo Beth\'tilac.','Majordomo Beth\'tilac.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116153,'Majordomo Shannox.','Majordomo Shannox.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116154,'Let us test your knowledge of history, then! Which apothecary cannot be found in Shadowfang Keep during the Love is in the Air event?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116155,'Frye.','Frye.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116156,'','Go now, retrieve your weapon and slay the demon filth that seek it.',0,0,0,0,0,0,1,0,0,0,0,68852,26124),
(116157,'Baxter.','Baxter.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116158,'Copeland.','Copeland.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116159,'Hummel.','Hummel.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116160,'Let us test your knowledge of history, then! What Goblin trading company is known for plundering the natural resources of Azeroth?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116161,'Blackwater Raiders.','Blackwater Raiders.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116162,'Venture Company.','Venture Company.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116163,'Kajaro Trading Company.','Kajaro Trading Company.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116164,'','Clean up your mess, flesh-children, and stop throwing your garbage down into my realm!',0,0,0,0,0,0,1,0,0,0,0,68853,26124),
(116165,'Smokeywood Pastures.','Smokeywood Pastures.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116166,'Look out! Greenies comin\' fast! Grook \'em! Make this day their last!','',0,0,0,0,0,0,0,0,0,0,64441,0,26124),
(116167,'Let us test your knowledge of history, then! What was the name of the Human that kept Thrall as a slave in Durnholde Keep?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116168,'Aiden Perenolde.','Aiden Perenolde.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116169,'Galen Trollbane.','Galen Trollbane.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116170,'Daval Prestor.','Daval Prestor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116171,'Aedelas Blackmoore.','Aedelas Blackmoore.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116172,'Let us test your knowledge of history, then! Which Orc was responsible for opening numerous portals on Draenor and shattering the Orc homeworld?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116173,'Ner\'zhul.','Ner\'zhul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116174,'Gul\'dan.','Gul\'dan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116175,'Skartax.','Skartax.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116176,'Grieve.','Grieve.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116177,'Let us test your knowledge of history, then! The Night Elves and the dragonflights stood against the armies of the Qiraji in what war?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116178,'War of the Ancients.','War of the Ancients.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116179,'War of the Satyr.','War of the Satyr.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116180,'War of the Shifting Sands.','War of the Shifting Sands.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116181,'War of the Spider.','War of the Spider.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116182,'Let us test your knowledge of history, then! Cro Threadstrong continually threatened what specific type of vendor in Shattrath City?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116183,'Bag Vendor.','Bag Vendor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116184,'Fruit Vendor.','Fruit Vendor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116185,'Reagent Vendor.','Reagent Vendor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116186,'Weapon Vendor.','Weapon Vendor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116187,'Let us test your knowledge of history, then! Who was the first to leave pandaria on the back of the sea turtle, Shen-zin Su?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116188,'Shaohao.','Shaohao.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116189,'Shinizi.','Shinizi.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116190,'Li Li Stormstout.','Li Li Stormstout.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116191,'Liu Lang.','Liu Lang.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116192,'Let us test your knowledge of history, then! Who was the brother of Varok Saurfang and the only Orc to fight in the War of the Ancients?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116193,'Broxigar.','Broxigar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116194,'Eitrigg.','Eitrigg.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116195,'Dranosh Saurfang.','Dranosh Saurfang.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116196,'Drek\'Thar.','Drek\'Thar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116197,'Let us test your knowledge of history, then! What was the name of the Human who helped Thrall escape his imprisonment in Durnholde Keep?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116198,'Karramyn Langston.','Karramyn Langston.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116199,'Arthas Menethil.','Arthas Menethil.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116200,'Jaina Proudmoore.','Jaina Proudmoore.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116201,'Taretha Foxton.','Taretha Foxton.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116202,'Wooo-hoo, wikket, that\'s the way! Grooked the greenies, saved the day!','',0,0,0,0,0,0,0,0,0,0,64442,0,26124),
(116203,'I do not wish to shed blood, but the paladins of the Silver Hand will not cooperate.','',0,0,0,0,0,0,0,0,0,0,68904,0,26124),
(116204,'We must avoid direct confrontation if at all possible.','',0,0,0,0,0,0,0,0,0,0,68903,0,26124),
(116205,'There is a tomb behind the chapel where the power of the Light is weak.','',0,0,0,0,0,0,0,0,0,0,68902,0,26124),
(116206,'Raise the dead from within the tomb and it will distract the guards long enough for us to make our way to the chapel.','',0,0,0,0,0,0,0,0,0,0,68901,0,26124),
(116207,'Let us test your knowledge of history, then! Which Alliance city located in Darkshore was destroyed by Deathwing\'s return?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116208,'Lor\'danel.','Lor\'danel.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116209,'Ameth\'Aran.','Ameth\'Aran.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116210,'Auberdine.','Auberdine.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116211,'Grove of the Ancients.','Grove of the Ancients.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116212,'Let us test your knowledge of history, then! Which of the following is not a possible result from drinking a Noggenfogger Elixer?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116213,'The weapon\'s blessin\' don\'t come free. With courage face your destiny!','',0,0,0,0,0,0,0,0,0,0,64443,0,26124),
(116214,'Shrink.','Shrink.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116215,'Become Skeletal.','Become Skeletal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116216,'Slow Fall.','Slow Fall.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116217,'You breathe fire.','You breathe fire.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116218,'Let us test your knowledge of history, then! Which musical trinket could be used to invoke spontaneous dancing in others against their will?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116219,'Piccolo of the Flaming Fire.','Piccolo of the Flaming Fire.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116220,'Sun-Lute of the Phoenix King.','Sun-Lute of the Phoenix King.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116221,'Haunted War Drum.','Haunted War Drum.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116222,'Flute of the Ancients.','Flute of the Ancients.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116223,'Let us test your knowledge of history, then! Which arm and which eye did Zul\'jin lose during his captivity and eventual escape?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116224,'Right eye; left arm.','Right eye; left arm.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116225,'Left eye; left arm.','Left eye; left arm.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116226,'Right eye; right arm.','Right eye; right arm.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116227,'Left eye; right arm.','Left eye; right arm.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116228,'Let us test your knowledge of history, then! What phrase means \"Safe journey\" in the language of the draenei?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116229,'Achal hecta.','Achal hecta.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116230,'Dioniss aca.','Dioniss aca.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116231,'Acheon kor.','Acheon kor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116232,'Heckt corta.','Heckt corta.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116233,'Many thanks, hero. You must hurry to the Vault of Lights. The Prophet awaits your arrival!','Many thanks, hero. You must hurry to the Vault of Lights. The Prophet awaits your arrival!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116234,'We will keep our monstrous brethren occupied, please hurry to the Vault of Lights! Our people need you!','We will keep our monstrous brethren occupied, please hurry to the Vault of Lights! Our people need you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116235,'Quickly, hero, to the Vault of Lights!','Quickly, hero, to the Vault of Lights!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116236,'The Prophet is holding off the entire invasion at the Vault of Lights! He needs assistance!','The Prophet is holding off the entire invasion at the Vault of Lights! He needs assistance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116237,'All together, now! Pull!','',1,0,0,0,0,0,0,0,0,0,68086,0,26124),
(116238,'I don\'t know how much longer the Prophet can keep the barrier up. Time is of the essence!','I don\'t know how much longer the Prophet can keep the barrier up. Time is of the essence!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116239,'','Put your back into it!',15,0,0,0,0,0,0,0,0,0,0,68096,26124),
(116240,'We... Can... Do... This!','',15,0,0,0,0,0,0,0,0,0,68105,0,26124),
(116241,'','What beautiful chaos! Let\'s rifle the pockets of a few guards. Bet we uncover some cultists in disguise!',0,0,0,0,0,0,603,0,0,0,0,64454,26124),
(116242,'Let us test your knowledge of history, then! What is the name of the mate of Har\'koa?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116243,'Loque\'nahak.','Loque\'nahak.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116244,'Shirvallah.','Shirvallah.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116245,'Magria.','Magria.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116246,'Ankha.','Ankha.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116247,'Let us test your knowledge of history, then! What is the name of the red dragon whose skull is on display in the Hall of Explorers?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116248,'Vaelastrasz.','Vaelastrasz.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116249,'Afrasastrasz.','Afrasastrasz.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116250,'Caelestrasz.','Caelestrasz.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116251,'Tyranastrasz.','Tyranastrasz.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116252,'Let us test your knowledge of history, then! What was the name of the first pandaren to ever tame a cloud serpent?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116253,'Jiang.','Jiang.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116254,'Suchi.','Suchi.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116256,'Anli.','Anli.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116257,'You fight bravely for a mortal.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(116258,'Toudu.','Toudu.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116259,'You are not the help I expected. Still, I owe you my thanks.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(116260,'Let us test your knowledge of history, then! In Zandali, the language of the trolls, what does \"atal\'ai\" mean?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116261,'The Faithful.','The Faithful.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116262,'Doting Ones.','Doting Ones.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116263,'I did not expect a mortal to fight so fiercely. I thank you.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(116264,'The Chosen.','The Chosen.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116265,'Devoted Ones.','Devoted Ones.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116266,'I came to help you and Thorim. Where is he?','I came to help you and Thorim. Where is he?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(116267,'Let us test your knowledge of history, then! This cult was affiliated with the orcish Shadow Council and included members such as Nagaz and Marez Cowl.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116268,'Burning Blade.','Burning Blade.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116269,'Sargerei.','Sargerei.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116270,'Argus Wake.','Argus Wake.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116271,'The Cabal.','The Cabal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116272,'Let us test your knowledge of history, then! Which son of an Alliance traitor would one day become a leader of the Syndicate?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116273,'Isiden.','Isiden.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116274,'This way.  Follow me!','',1,0,0,0,0,0,0,0,0,0,68415,0,26124),
(116275,'Aiden.','Aiden.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116276,'Aedelas.','Aedelas.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116277,'Aliden.','Aliden.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116278,'We have no time to lose!','',1,0,0,0,0,0,0,0,0,0,68102,0,26124),
(116279,'They are waiting for you in the tavern.','',0,0,0,0,0,0,0,0,0,0,67575,0,26124),
(116280,'Of course. I agree that this whole business is... distasteful. Even still, the sort of influence you would have...','',0,0,0,0,0,0,1,0,0,0,67586,0,26124),
(116281,'','There is a reason we live on the opposite side of the city, my friend.',0,0,0,0,0,0,274,0,0,0,0,67567,26124),
(116282,'','I could change much for our people... yes...',0,0,0,0,0,0,1,0,0,0,0,67568,26124),
(116283,'A hammer and a demon fell from the sky...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116284,'We saw the hammer fall.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116285,'The demon warned us they would come for the hammer...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116286,'The shaman from the world above seeks the hammer!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116287,'The demon warned us! Stop the shaman!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116288,'A demon came to us. We had to obey.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116289,'We must protect the hammer!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116290,'Say nothing to the shaman.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116291,'','Thank you, hero. I would have been that monster\'s next meal!',0,0,0,0,0,0,0,0,0,0,0,64400,26124),
(116292,'Without history, there would be no future.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116293,'Unleash the Twinblades and destroy the interloper!','',0,0,0,0,0,0,0,0,0,0,64630,0,26124),
(116295,'Always a pleasure. Do things my way and she\'ll be advisor before dinner.','',0,0,0,0,0,0,0,0,0,0,66192,0,26124),
(116301,'','Brothers and sisters, we meet tonight at the Pig and Whistle. The Herald awaits!',0,0,0,0,0,0,0,0,0,0,0,64452,26124),
(116302,'','So the cultists are meeting at the Pig and Whistle. Let\'s move! The Herald is within our grasp...',0,0,0,0,0,0,1,0,0,0,0,64455,26124),
(116303,'','Another group! They can\'t keep coming forever... can they?',0,0,0,0,0,0,0,0,0,0,0,64403,26124),
(116304,'Remember this place, Brann?','',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(116305,'Good day, Grandmaster. May the spirits be with you this day.','',0,0,0,0,0,0,1,0,0,0,66650,0,26124),
(116306,'Beautiful day for a drink, don\'t you think Grandmaster?','',0,0,0,0,0,0,1,0,0,0,66721,0,26124),
(116307,'Hello Grandmaster. I hope you are in good spirits today.','',0,0,0,0,0,0,1,0,0,0,66644,0,26124),
(116308,'After all this is over, I would like to keep traveling. Grandmaster, where should I go?','',0,0,0,0,0,0,1,0,0,0,66645,0,26124),
(116309,'Good day to you, Grandmaster. Is there anything I can help with?','',0,0,0,0,0,0,1,0,0,0,66646,0,26124),
(116310,'Grandmaster, have you seen Li Li? She is late for training again.','',0,0,0,0,0,0,1,0,0,0,66647,0,26124),
(116311,'Karazhan! Of course. I likely read of these artifacts in one of Medivh\'s ancient chronicles.','',396,0,0,0,0,0,396,0,0,0,0,0,26124),
(116312,'','Are you ready to return to Shen-zin Su?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116313,'','No! Sisters.... avenge.... me!',0,0,0,0,0,0,0,0,0,0,0,66701,26124),
(116314,'You... are here to help? This place is overrun! The others are in D-Block, if any are left! I must rest...','I thought I was done for. This place is overrun! The rest are at D Block, if anyone is left! I must rest...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116315,'Chen and Li Li are strong allies for our order, and I know just how we can use them.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(116316,'','Normally it takes some time to train new troops, but I put a rush on this one for you, Grandmaster.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(116317,'','Excellent choice, Grandmaster. I will be happy to research any additional improvements to the order hall for you.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(116318,'Speak to Tak-Tak to the west. He will take you to Tian Monastery immediately.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(116319,'Our champions might be able to follow our enemy\'s movements. I only hope we can find my students... before it\'s too late.','',0,0,0,0,0,0,1,0,0,0,68354,0,26124),
(116320,'','Bring me some leather, and I will gladly trade you my Amaranthine Hops.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(116321,'At the very least, our champions can distract the Legion attack force long enough for us to prepare defenses here on the island. Let us hope it does not come to that.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(116322,'Hurry, Grandmaster! The battle rages on the ridge above us. You\'d better join them quickly!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(116323,'This is not over... Illidari.','',0,0,0,0,0,0,1,0,0,0,64633,0,26124),
(116324,'I have no need for mortal armaments!','',0,0,0,0,0,0,53,0,0,0,64632,0,26124),
(116325,'Right there above the scouting map should do nicely.','',0,0,0,0,0,0,0,0,0,0,66987,0,26124),
(116326,'Lets see what we can come up with.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116327,'Ah, yes. This looks exquisite. Such detail on the dust coming off of its wings. It is sure to delight.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116328,'Yes, this will do quite nicely. The horn looks very realistic.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116329,'Hmm. I will need to work on this one. The plumage flares out entirely too much.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116330,'What shall I review now?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116331,'How about this illusion?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116332,'Hey, keep it down out there! We\'re trying to have a party!','Hey, keep it down out there! We\'re trying to have a party!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116333,'What... What happened?','What... What happened?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(116334,'I... I can\'t remember nothin\'...','I... I can\'t remember nothin\'...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(116335,'Me thoughts... it heard me thoughts!','Me thoughts... it heard me thoughts!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(116336,'What am I doin\' here?','What am I doin\' here?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(116337,'I wouldn\'t just attack ye fer no reason! What\'s goin\' on?','Me thoughts... it heard me thoughts!',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(116338,'If that thing can do that ta me, who knows what else they can do!','If that thing can do that ta me, who knows what else they can do!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(116339,'I thought I\'d seen it all... but that thing... Get out of here! Go!','I thought I\'d seen it all... but that thing... Get out of here! Go!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(116340,'My illusions will be your end!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116341,'The illusion... is broken.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116342,'These heroes have struck a mighty blow to the invaders! Go now, with my blessing, and dispense the Light\'s judgment on any demons that remain and secure safe passage for the rest of our people!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116343,'I am capable of fending for myself, Divinius; but there are many still alive outside this barrier that need your help! Waste no more time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116344,'Tread carefully, Death Knight. This is holy ground and we have little tolerance for your kind.','',0,0,0,0,0,0,1,0,0,0,69440,0,26124),
(116345,'The Illidari are prepared to serve.','The Illidari are prepared to serve.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116346,'We, the Broken, salute you.','We, the Broken, salute you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116347,'One of your withered is running away! Catch him!','One of your withered is running away! Catch him!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116348,'Such delicious elven flesh!','',0,0,0,0,0,0,0,0,0,0,64672,0,26124),
(116349,'Race through the Ley Line nodes to collect energy!','Race through the Ley Line nodes to collect energy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116350,'Insolent orc! You should have awaited my arrival!','',22,0,0,0,0,0,22,0,0,0,66438,0,26124),
(116351,'Pathetic.','',0,0,0,0,0,0,0,0,0,0,64673,0,26124),
(116352,'Having collected enough energy, the Ley Lines die down.','Having collected enough energy, the Ley Lines die down.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116353,'Find Timirgos using your newfound powers of Claivoyance.','Find Timirgos using your newfound powers of Claivoyance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116354,'You sense that Timirgos is far to the north.','You sense that Timirgos is far to the north.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116355,'You sense that Timirgos is far to the east.','You sense that Timirgos is far to the east.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116356,'You sense that Timirgos is far to the south.','You sense that Timirgos is far to the south.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116357,'I had things well in hand. Those fools were weak! We are better off without them!','',0,0,0,0,0,0,0,0,0,0,66439,0,26124),
(116358,'You sense that Timirgos is far to the west.','You sense that Timirgos is far to the west.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116359,'You sense that Timirgos is nearby, north of your current location.','You sense that Timirgos is nearby, north of your current location.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116360,'You sense that Timirgos is nearby, northeast of your current location.','You sense that Timirgos is nearby, northeast of your current location.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116361,'You sense that Timirgos is nearby, east of your current location.','You sense that Timirgos is nearby, east of your current location.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116362,'You sense that Timirgos is nearby, southeast of your current location.','You sense that Timirgos is nearby, southeast of your current location.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116363,'You sense that Timirgos is nearby, south of your current location.','You sense that Timirgos is nearby, south of your current location.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116364,'You sense that Timirgos is nearby, southwest of your current location.','You sense that Timirgos is nearby, southwest of your current location.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116365,'You sense that Timirgos is nearby, west of your current location.','You sense that Timirgos is nearby, west of your current location.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116366,'You sense that Timirgos is nearby, northwest of your current location.','You sense that Timirgos is nearby, northwest of your current location.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116367,'You sense that Timirgos is very close, just north of your current location.','You sense that Timirgos is very close, just north of your current location.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116368,'You sense that Timirgos is very close, just northeast of your current location.','You sense that Timirgos is very close, just northeast of your current location.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116369,'You sense that Timirgos is very close, just east of your current location.','You sense that Timirgos is very close, just east of your current location.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116370,'Give me! Give me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116371,'You sense that Timirgos is very close, just southeast of your current location.','You sense that Timirgos is very close, just southeast of your current location.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116372,'You sense that Timirgos is very close, just south of your current location.','You sense that Timirgos is very close, just south of your current location.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116373,'You sense that Timirgos is very close, just southwest of your current location.','You sense that Timirgos is very close, just southwest of your current location.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116374,'You sense that Timirgos is very close, just west of your current location.','You sense that Timirgos is very close, just west of your current location.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116375,'You sense that Timirgos is very close, just northwest of your current location.','You sense that Timirgos is very close, just northwest of your current location.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116376,'You\'ve found Timirgos!','You\'ve found Timirgos!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116377,'Yarlyn\'s here with me. Where\'ve they taken Rudra? And what\'ve they done to me rams? Go, $n! Get far away from \'ere!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(116378,'Clear \'em out, $n. Do what ye can do. When me wounds are patched up I\'ll be back. Ye can count on that!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(116379,'','Please, $n - get the rest of \'em! Poor Veron and Yarlyn! I don\'t know where they\'ve been taken!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(116380,'','Wow, you sure are brave! Thanks for helping us!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(116381,'Ah, reinforcements at last. You have the Book of Medivh? I expected Jergosh, but you will do. Still, your timing could have been better.','',1,0,0,0,0,0,1,0,0,0,66440,0,26124),
(116382,'Jergosh and the others didn\'t make it? How... convenient.','',1,0,0,0,0,0,1,0,0,0,66441,0,26124),
(116383,'It matters not. Gul\'dan knows the Eye is here, but Tol Barad is huge and overrun. I believe an important document, a manifest of prisoners, is located in this block.','',1,0,0,0,0,0,1,0,0,0,66442,0,26124),
(116384,'Well done, Valarjar.','',0,0,0,0,0,0,0,0,0,0,64456,0,26124),
(116385,'In his infinite wisdom, Nagaz here sent his only remaining disciple to scout below. I suggest you find out what happened to him while we search elsewhere.','',1,0,0,0,0,0,1,0,0,0,66443,0,26124),
(116386,'Fight on, Valarjar.','',0,0,0,0,0,0,0,0,0,0,64457,0,26124),
(116387,'Hmmph... I saw Tyranis go off to the right before I was forced to retreat.','',25,0,0,0,0,0,1,0,0,0,66444,0,26124),
(116388,'Yo, buddy! I\'ve got some information for ya!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(116389,'Now, we never talked, got it?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(116390,'|TInterface\\Icons\\ability_paladin_blindinglight2:20|t Lafayla begins to cast |cFFFF0404|Hspell:219075|h[Dazzling Light]|h|r Look away!','|TInterface\\Icons\\ability_paladin_blindinglight2:20|t Lafayla begins to cast |cFFFF0404|Hspell:219075|h[Dazzling Light]|h|r Look away!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116391,'You there! Aid me! But carefully, or it will pull you in, too!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116392,'You... aren\'t you some sort of hero? Why are you helping the Shadow Cou-- nevermind! Pull me out! I will vouch for you, I swear!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116393,'What are you doing there? Help me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116394,'I... I will serve you! My family has many heirlooms and treasures! They\'re all yours! YOURS!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116395,'What are you...  NOOOOoooo...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116396,'Still with me, little mortal? Good.','',1,0,0,0,0,0,0,0,0,0,68098,0,26124),
(116397,'Another huge demon headin\' fer Kharanos! Come too far ta lose it now!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(116398,'Thorim! Odyn has sent his champions to aid us.','',1,0,0,0,0,0,0,0,0,0,68393,0,26124),
(116399,'They keep coming!  Crush one and another takes its place. I will try to stem the flow. The passage to the north leads up to the balcony, $n. Assist Thorim!','',0,0,0,0,0,0,0,0,0,0,68394,0,26124),
(116400,'','Behold but a fragment of the Aldrachi!',0,0,0,0,0,0,0,0,0,0,0,64683,26124),
(116401,'A mortal? Leading Odyn\'s army?! Has my father lost his mind!','',1,0,0,0,0,0,0,0,0,0,68395,0,26124),
(116402,'You\'ll be surprised.  This mortal slays demons as swiftly as Fenryr hunts wild deer!','',1,0,0,0,0,0,0,0,0,0,68396,0,26124),
(116403,'I shall be the judge of that.  Plenty of demons up here... let us see if Odyn chose well!','',1,0,0,0,0,0,0,0,0,0,68397,0,26124),
(116404,'Worthy battle, champion.','',0,0,0,0,0,0,0,0,0,0,64458,0,26124),
(116405,'Blood and glory.','',0,0,0,0,0,0,0,0,0,0,64459,0,26124),
(116406,'You have earned your place, warrior.','',0,0,0,0,0,0,0,0,0,0,64460,0,26124),
(116407,'You made it! Alive, even!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116408,'Send me back home, Oculeth.','Send me back home, Oculeth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116409,'... unless you want some fins out your back for the rest of your life.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116410,'Don\'t listen to Brian. Go ahead, touch it. I want to see what really happens.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116411,'','An ancient spirit, long dormant, has been awakened by the Legion\'s return. Nylaathria\'s evil must be purged from our land! Find the ruin she haunts and end her.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116412,'','An ancient spirit, long dormant, has been awakened by the Legion\'s return. Nylaathria\'s evil must be purged from our land! Find the ruin she haunts and end her.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116415,'Keep back! Don\'t go near that pearl!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116416,'|TInterface\\Icons\\Ability_Warlock_EverlastingAffliction:20|tArchimonde has cast |cFFFF0000|Hspell:219143|h[Shadowfel Burst]|h|ron you! Move to a Pool of Grace!','|TInterface\\Icons\\Ability_Warlock_EverlastingAffliction:20|tArchimonde has cast |cFFFF0000|Hspell:219143|h[Shadowfel Burst]|h|ron you! Move to a Pool of Grace!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116417,'','|TInterface\\Icons\\spell_warlock_demonicportal_purple.blp:20|t%s begins to cast |cFFFF0000|Hspell:219112|h[Shadow Gale]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(116418,'','Peace...',0,0,0,0,0,0,0,0,0,0,0,65618,26124),
(116419,'','Finally, we rest.',0,0,0,0,0,0,0,0,0,0,0,65619,26124),
(116420,'','What has become of us?',0,0,0,0,0,0,0,0,0,0,0,65620,26124),
(116421,'','Our people... shu dalees-na.',0,0,0,0,0,0,0,0,0,0,0,65610,26124),
(116422,'','I will rest now.',0,0,0,0,0,0,0,0,0,0,0,65611,26124),
(116423,'','The Magistrix... stop her...',0,0,0,0,0,0,0,0,0,0,0,65612,26124),
(116424,'','Feel the chill of the grave!',0,0,0,0,0,0,0,0,0,0,0,65613,26124),
(116425,'','You will be cold... like us.',0,0,0,0,0,0,0,0,0,0,0,65614,26124),
(116426,'','Desecrator...',0,0,0,0,0,0,0,0,0,0,0,65615,26124),
(116427,'','Trespasser...',0,0,0,0,0,0,0,0,0,0,0,65616,26124),
(116428,'','Thandae-alah...',0,0,0,0,0,0,0,0,0,0,0,65617,26124),
(116429,'Im... impossible.','It\'s no use!',0,0,0,0,0,0,0,0,0,0,65688,65898,26124),
(116430,'The shal\'dorei will rule this world!','The Nightborne will rule this world!',0,0,0,0,0,0,0,0,0,0,65698,65899,26124),
(116431,'Arash-falas...','Arash-falas...',0,0,0,0,0,0,0,0,0,0,65689,65900,26124),
(116432,'Tor\'theras falar!','Tor\'theras falar!',0,0,0,0,0,0,0,0,0,0,65690,65901,26124),
(116433,'My magic... defeated?','Forgive me... Elisande.',0,0,0,0,0,0,0,0,0,0,65691,65902,26124),
(116434,'This cannot be...','Inconceivable...',0,0,0,0,0,0,0,0,0,0,65692,65903,26124),
(116435,'Let me see what I can... dig up...','Let me see what I can... dig up...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116436,'Careful! Don\'t touch that pearl!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116437,'Chopping','Chopping',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116438,'Don\'t worry about us, just clear out these Naga!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116439,'The Ebon order is at your command.','The Ebon order is at your command.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116440,'I will hear no more of your scheming! You endanger everything our father worked for!','',0,0,0,0,0,0,0,0,0,0,67503,0,26124),
(116441,'Hmph... Someone will notice I am missing! They will come looking for me!','',0,0,0,0,0,0,0,0,0,0,67237,0,26124),
(116442,'She wants to preach her traitorous ideals to me further? Fine. Let us go.','',0,0,0,0,0,0,0,0,0,0,67236,0,26124),
(116443,'Just... finish me off.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116444,'Ngh! Who ARE you?!','',0,0,0,0,0,0,0,0,0,0,67235,0,26124),
(116445,'You have come to help Ly\'leth destroy our family! Be gone!','',0,0,0,0,0,0,397,0,0,0,67234,0,26124),
(116446,'Get away from there!','',0,0,0,0,0,0,0,0,0,0,67233,0,26124),
(116447,'It\'s so shiny. I couldn\'t help myself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116448,'','Thas\'dorah... I have not seen it in years! That\'s a Windrunner family heirloom you have slung across your back.',0,0,0,0,0,0,0,0,0,0,0,66818,26124),
(116449,'','My mother passed it down to my eldest sister. May it bring you better fortune than it did her.',0,0,0,0,0,0,0,0,0,0,0,66819,26124),
(116450,'','If you won\'t serve the Queen, then you will die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116451,'','If you won\'t serve the Queen, then you will die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116452,'','Peer into my pearl, landwalker!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116453,'','Your destiny lies within my pearl, $R!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116454,'','Remember, $n, that Thas\'dorah represents my family\'s legacy... MY legacy. The deeds you perform while wielding it reflect upon me.',0,0,0,0,0,0,0,0,0,0,0,66820,26124),
(116455,'','It is fitting that the bow be in the hands of so skilled a marksman. I trust you will remain worthy of it. Do not disappoint me.',0,0,0,0,0,0,0,0,0,0,0,66821,26124),
(116456,'Found Tyranis too late, did you? Pity...','',0,0,0,0,0,0,0,0,0,0,66445,0,26124),
(116457,'Anyway, follow me! There\'s something over here I... need your help with.','',1,0,0,0,0,0,0,0,0,0,66446,0,26124),
(116458,'I\'ll have that book now... and you\'ll be having a little \"accident\"!','',0,0,0,0,0,0,0,0,0,0,66447,0,26124),
(116459,'I should be... the one... at Gul\'dan\'s side...','',0,0,0,0,0,0,0,0,0,0,66448,0,26124),
(116460,'The people of Thunder Totem welcome the wielder of Talonclaw!','The people of Thunder Totem welcome the wielder of Talonclaw!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116461,'Feel my wrath, fiends!','',1,0,0,0,0,0,0,0,0,0,68100,0,26124),
(116462,'','Vanessa gives you a final look and then walks off.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116463,'I\'m done training the withered for today.','I\'m done training the withered for today.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116465,'','We came as soon as we were able! Thank the Light that you are safe, prophet!',0,0,0,0,0,0,0,0,0,0,0,70816,26124),
(116466,'','As you command, Prophet!',0,0,0,0,0,0,0,0,0,0,0,70817,26124),
(116467,'','There is a myth, a fable, that is whispered of in dark corners and back alleys.',0,0,0,0,0,0,1,0,0,0,0,69473,26124),
(116468,'','Surely everyone here has at one time or another heard the tale of the Raven\'s Eye?',0,0,0,0,0,0,6,0,0,0,0,69474,26124),
(116469,'The others look incredulously at Valeera. Disbelief clearly painted on their faces. Unsurprised, Valeera continues on with her tale.','The others look incredulously at Valeera. Disbelief clearly painted on their faces. Unsurprised, Valeera continues on with her tale.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116470,'','It is of a jewel so powerful that no one believes it exists. But I assure you, it does.',0,0,0,0,0,0,273,0,0,0,0,69475,26124),
(116471,'','The legend is that the gem conveys the power to read any language, follow any map, and most importantly, to decipher any code.',0,0,0,0,0,0,6,0,0,0,0,69476,26124),
(116472,'','But more to the point, the Raven\'s Eye will give us the means to unlock the secrets hidden in the SI:7 letter. And, we know where it is.',0,0,0,0,0,0,1,0,0,0,0,69477,26124),
(116473,'A merry yarn! But that\'s all she be. The Raven\'s Eye don\'t exist. It never did. It just be some ol\' wives\' tale to scare little rogues who are wantin\' to keep their secrets hidden.','',0,0,0,0,0,0,274,0,0,0,69478,0,26124),
(116474,'','Exactly right. We are talking about the end of secrets. Well, other people\'s secrets anyway.',0,0,0,0,0,0,574,0,0,0,0,69479,26124),
(116475,'','Lord Kur\'talos Ravencrest stole the eye from the vrykul millennia ago. His lieutenant\'s used it during the War of the Ancients.',0,0,0,0,0,0,273,0,0,0,0,69480,26124),
(116476,'The winds swirl in a new direction, adjust your aim to compensate.','The winds swirl in a new direction, adjust your aim to compensate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116477,'Thank you for your interest in visiting the Assembly of Iron and the Archivum!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116478,'Thank you for your interest in visiting the Observation Ring!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116479,'Currently both facilities are closed for cleaning and routine maintenance. Please call again on a future date.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116480,'Have a pleasant stay in Ulduar!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116481,'Unfortunately, the walkway is undergoing structural evaluation and is presently inaccessible. We regret any inconvenience this may cause.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116482,'Enjoy your stay in Ulduar! Please remember to fill out a Visitor Satisfaction Survey prior to departing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116483,'The Legion will conquer this world!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116484,'Came up empty? No Nagaz either, I see. Not to worry, we all know how the lower echelons of our group scramble for position. Enough nonsense. What we seek is here!','',1,0,0,0,0,0,0,0,0,0,66449,0,26124),
(116485,'Congratulations, you\'ve successfully navigated the maze!','Congratulations, you\'ve successfully navigated the maze!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116486,'I can sense... unrest nearby. Let us investigate. Come along!','',1,0,0,0,0,0,0,0,0,0,66450,0,26124),
(116487,'There! The unquiet dead bar our path. Get that spirit out of my way, will you?','',1,0,0,0,0,0,0,0,0,0,66451,0,26124),
(116488,'Oops! You\'ve stepped off of the path!','Oops! You\'ve stepped off of the path!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116489,'Hmm... yes, I see. This entry clearly speaks of a void terror. It must have consumed the Eye in the Twisting Nether. Its purpose here is irrelevant. Quickly, let us get to Baradin Hold!','',0,0,0,0,0,0,0,0,0,0,66452,0,26124),
(116490,'You have destroyed most of the fel portals, greatly hindering Rakeesh\'s ability to bring in reinforcements. Focus your attention on finding survivors now!','',0,0,0,0,0,0,0,0,0,0,70898,0,26124),
(116491,'Thanks to you, most of our people have returned safely to the Vault of Lights! The time has come to focus your attention on the remaining fel portals and end Rakeesh\'s incursion!','',0,0,0,0,0,0,0,0,0,0,70899,0,26124),
(116492,'Follow the path to the end of the maze.','Follow the path to the end of the maze.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116493,'The seas be calling!','The seas be calling!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116495,'','There\'s a few potions and supplies left about. Do what you must to remove the threat!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(116496,'This is no place for a tradesman!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(116497,'Thanks. I left some fresh cuts lying about, but I should get going. I\'m afraid those things would butcher me alive.','',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(116498,'','Show them we\'re not giving up Tarren Mill without a fight!',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(116499,'','This place is a haunted tomb. Let us not stay here any longer than is necessary.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116500,'Rise up, $n! Fight beside Helcular to bring down this Legion threat! Show them the true power of a $c!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116501,'Avoid taking any damage for as long as you can while staying inside the field.  Good Luck!','Avoid taking any damage for as long as you can while staying inside the field.  Good Luck!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116502,'','I am going to look into something. In the meantime, let us make certain that SI:7 does not catch on to what we are really up to.',0,0,0,0,0,0,0,0,0,0,0,69481,26124),
(116503,'I can control it no longer. You must drown!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116504,'','I do not know how you are going to get onto the Naglfar... the vrykul ship of the dead. But, if we are to confirm my suspicions about the item, you are going to have to find a way to do so. Preferably without dying if you can manage it.',0,0,0,0,0,0,0,0,0,0,0,69482,26124),
(116505,'','I will see you at Ravencourt. Make certain that you are not followed.',0,0,0,0,0,0,0,0,0,0,0,69483,26124),
(116506,'In the name of the Dark Lady, rise and defend against the Burning Legion!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(116507,'','This place is crawling. See if you can find the eye. I will cover you from here.',0,0,0,0,0,0,0,0,0,0,0,69484,26124),
(116508,'Apologies. I\'m not much for fighting, but I\'m sure Craig and Hans will be more than helpful.','',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(116509,'Walk in the moonlight.','Walk in starlight.',0,0,0,0,0,0,0,0,0,0,65732,65936,26124),
(116510,'Walk in the moonlight.','',0,0,0,0,0,0,0,0,0,0,65732,0,26124),
(116511,'I... will go home. I have no business among such esteemed individuals.','',0,0,0,0,0,0,1,0,0,0,66188,0,26124),
(116512,'I accept your gratitude, by the way!','',0,0,0,0,0,0,603,0,0,0,66189,0,26124),
(116513,'I like the way you think, Lunastre.','',0,0,0,0,0,0,0,0,0,0,66190,0,26124),
(116514,'','You are not the only one with a nose for politics.',0,0,0,0,0,0,0,0,0,0,0,66266,26124),
(116515,'','I humbly accept this appointment. It is an honor beyond words.',0,0,0,0,0,0,0,0,0,0,0,66267,26124),
(116516,'','Yes. I understand. Just be careful. We\'re running out of room here.',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(116517,'Filthy backstabbing cretin! That title should have been mine!','',0,0,0,0,0,0,603,0,0,0,66215,0,26124),
(116518,'You impinge upon my honor! You besmirch my name with baseless accusations!','',0,0,0,0,0,0,603,0,0,0,66214,0,26124),
(116519,'','My lord, you have lost your sense of decorum. It is already decided.',0,0,0,0,0,0,1,0,0,0,0,66265,26124),
(116520,'Ash\'thoras denil.','',0,0,0,0,0,0,0,0,0,0,65653,0,26124),
(116521,'Your star fades!','',0,0,0,0,0,0,0,0,0,0,65733,0,26124),
(116522,'Let us hope this ends swiftly.','',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(116524,'I will reclaim my honor! I invoke the ancient rite- Tal\'ashar!','',0,0,0,0,0,0,603,0,0,0,66219,0,26124),
(116526,'I have 10 drowned mana for you.','I have 10 drowned mana for you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116527,'Looks like you caught some drowned mana? I can take that off your hands...','Looks like you caught some drowned mana? I can take that off your hands...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(116528,'This is not what I signed up for.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(116529,'Horde! Fan out! Today we focus our attacks against the Legion. We\'ll deal with the Alliance scum when this is through.','',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(116530,'Fishing? ...Really?!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(116531,'Take me with you.  Please!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116532,'I will wrestle my title from your champion\'s lifeless hands, Ly\'leth!','',0,0,0,0,0,0,0,0,0,0,66216,0,26124),
(116533,'You cannot match me! I am your better!','',0,0,0,0,0,0,0,0,0,0,66217,0,26124),
(116534,'I will have what is owed me!','',0,0,0,0,0,0,0,0,0,0,66220,0,26124),
(116535,'I was... framed...','',0,0,0,0,0,0,0,0,0,0,66221,0,26124),
(116536,'A challenger? Don\'t make me laugh!','',0,0,0,0,0,0,0,0,0,0,66332,0,26124),
(116537,'The Legion brings us power unending!','',0,0,0,0,0,0,0,0,0,0,66333,0,26124),
(116538,'Kneel before the might of the shal\'dorei!','',0,0,0,0,0,0,0,0,0,0,66334,0,26124),
(116539,'I will not be defeated by the likes of you!','',0,0,0,0,0,0,0,0,0,0,66335,0,26124),
(116540,'They... promised...','',0,0,0,0,0,0,0,0,0,0,66336,0,26124),
(116542,'It will be easier for me to travel on the road.','It will be easier for me to travel on the road.',0,0,0,0,0,0,0,0,0,0,0,65938,26124),
(116544,'Are you lost?','',0,0,0,0,0,0,0,0,0,0,66198,0,26124),
(116545,'Menagerie\'s that way.','',25,0,0,0,0,0,0,0,0,0,66199,0,26124),
(116546,'State your business.','',0,0,0,0,0,0,0,0,0,0,66200,0,26124),
(116547,'Move along.','',0,0,0,0,0,0,0,0,0,0,66201,0,26124),
(116548,'Watch your back.','',0,0,0,0,0,0,0,0,0,0,66202,0,26124),
(116549,'Don\'t linger. You\'ll regret it.','',0,0,0,0,0,0,0,0,0,0,66203,0,26124),
(116550,'I don\'t give tours. The vineyards are across town.','',0,0,0,0,0,0,0,0,0,0,66204,0,26124),
(116551,'My time isn\'t free.','',0,0,0,0,0,0,0,0,0,0,66205,0,26124),
(116552,'Do you see anyone else hanging around? No? Why do you think that is?','',0,0,0,0,0,0,0,0,0,0,66206,0,26124),
(116553,'','Hi...',0,0,0,0,0,0,0,0,0,0,0,66228,26124),
(116554,'','Hello?',0,0,0,0,0,0,0,0,0,0,0,66229,26124),
(116555,'','Bye.',0,0,0,0,0,0,0,0,0,0,0,66230,26124),
(116556,'','Bye-bye.',0,0,0,0,0,0,0,0,0,0,0,66231,26124),
(116557,'','Go away.',0,0,0,0,0,0,0,0,0,0,0,66232,26124),
(116558,'','No!',0,0,0,0,0,0,0,0,0,0,0,66233,26124),
(116559,'','I don\'t like your face!',0,0,0,0,0,0,0,0,0,0,0,66234,26124),
(116560,'','It is a great honor to look after the vineyard.',0,0,0,0,0,0,0,0,0,0,0,66305,26124),
(116561,'','Are you enjoying your stay?',0,0,0,0,0,0,0,0,0,0,0,66306,26124),
(116562,'','We craft only the finest wines.',0,0,0,0,0,0,0,0,0,0,0,66307,26124),
(116563,'','Thank you for your visit!',0,0,0,0,0,0,0,0,0,0,0,66308,26124),
(116564,'','I hope you enjoyed yourself.',0,0,0,0,0,0,0,0,0,0,0,66309,26124),
(116565,'','Come again soon!',0,0,0,0,0,0,0,0,0,0,0,66310,26124),
(116566,'','Yes, I am ordinarily this cheerful. No, I will not scold you.',0,0,0,0,0,0,0,0,0,0,0,66311,26124),
(116567,'','I certainly hope this is enjoyable for you. I am having the BEST time.',0,0,0,0,0,0,0,0,0,0,0,66312,26124),
(116568,'','I can keep this up all day you know.',0,0,0,0,0,0,0,0,0,0,0,66313,26124),
(116569,'Welcome.','',0,0,0,0,0,0,0,0,0,0,66344,0,26124),
(116570,'Relax. Have a beverage.','',0,0,0,0,0,0,0,0,0,0,66345,0,26124),
(116571,'You need only alert me to your needs.','',0,0,0,0,0,0,0,0,0,0,66346,0,26124),
(116572,'It was my pleasure.','',0,0,0,0,0,0,0,0,0,0,66347,0,26124),
(116573,'Farewell.','',0,0,0,0,0,0,0,0,0,0,66348,0,26124),
(116574,'If you wish to complain, my master Margaux will happily field your concerns.','',0,0,0,0,0,0,0,0,0,0,66349,0,26124),
(116575,'The menagerie is for guest--- Ahem. The vineyard is for guests only.','',0,0,0,0,0,0,0,0,0,0,66350,0,26124),
(116581,'What do you require of the Guard?','',0,0,0,0,0,0,0,0,0,0,66361,0,26124),
(116582,'We stand watch over Suramar.','',0,0,0,0,0,0,0,0,0,0,66362,0,26124),
(116583,'Hello.','',0,0,0,0,0,0,0,0,0,0,66363,0,26124),
(116584,'Our vigil has ended, but I remain.','',0,0,0,0,0,0,0,0,0,0,66364,0,26124),
(116585,'Goodbye.','',0,0,0,0,0,0,0,0,0,0,66365,0,26124),
(116586,'I will remain, if you should have need of me again.','',0,0,0,0,0,0,0,0,0,0,66366,0,26124),
(116587,'Your timing is impeccable.','',0,0,0,0,0,0,0,0,0,0,66258,0,26124),
(116588,'Behold the plight of the Moon Guard.','',0,0,0,0,0,0,0,0,0,0,66259,0,26124),
(116589,'Are you here to help us?','',0,0,0,0,0,0,0,0,0,0,66260,0,26124),
(116590,'I will defend this place to my last.','',0,0,0,0,0,0,0,0,0,0,66261,0,26124),
(116591,'My home may be in ruins, but I will remain strong.','',0,0,0,0,0,0,0,0,0,0,66262,0,26124),
(116592,'The Moon Guard will soon be no more.','',0,0,0,0,0,0,0,0,0,0,66263,0,26124),
(116593,'','Our demise came without warning.',0,0,0,0,0,0,0,0,0,0,0,66351,26124),
(116594,'','The Moon Guard will soon be no more.',0,0,0,0,0,0,0,0,0,0,0,66352,26124),
(116595,'','It is my duty to guard this keep to the end.',0,0,0,0,0,0,0,0,0,0,0,66353,26124),
(116596,'','I will remain.',0,0,0,0,0,0,0,0,0,0,0,66354,26124),
(116597,'','We are beaten. Only memory remains.',0,0,0,0,0,0,0,0,0,0,0,66355,26124),
(116598,'','Farewell.',0,0,0,0,0,0,0,0,0,0,0,66356,26124),
(116599,'This place is home to the finest vintages.','',0,0,0,0,0,0,0,0,0,0,66186,0,26124),
(116600,'Only the best will reach Elisande\'s glass.','',0,0,0,0,0,0,0,0,0,0,66187,0,26124),
(116601,'No flavor escapes my notice.','',0,0,0,0,0,0,0,0,0,0,66180,0,26124),
(116602,'Happy sipping!','',0,0,0,0,0,0,0,0,0,0,66181,0,26124),
(116603,'Enjoy.','',0,0,0,0,0,0,0,0,0,0,66182,0,26124),
(116604,'I sense you are... overwhelmed by my expertise.','',0,0,0,0,0,0,0,0,0,0,66183,0,26124),
(116605,'A savant yourself, I can guess. A very likely story.','',0,0,0,0,0,0,0,0,0,0,66184,0,26124),
(116606,'I am willing to bet a mountain of gold that you taste vinegar in all that you drink. Plebian.','',0,0,0,0,0,0,0,0,0,0,66185,0,26124),
(116607,'Ishnu-alah.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116608,'It is not our forest, but we will adapt.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116609,'Hello.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116610,'Until we meet again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116611,'Until another day.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116612,'','Elune-adore.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116613,'','Elune\'s light guide you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116614,'','Greetings from the temple, friend.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116615,'','Her light shines here, too.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116616,'','Val\'Sharah\'s fate is not Suramar\'s fate. I am sure of it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116617,'','Until we meet again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116618,'','Ishnu-alah!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116619,'','Greetings.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116620,'','Onward and upward!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116621,'','It\'s always sunny in Suramar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116622,'','It\'s not Val\'Sharah, but it will do.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116623,'','Safe travels, friend.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116624,'The shal\'dorei are... chosen...','',0,0,0,0,0,0,0,0,0,0,65697,0,26124),
(116625,'Welcome to the refuge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116626,'Do you require aid?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116627,'Make yourself at home. We certainly are.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116628,'Mind the locals.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116629,'Farewell.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116630,'Goodbye.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116637,'I cannot be stopped!','Aaargh!',0,0,0,0,0,0,0,0,0,0,65696,65893,26124),
(116638,'I have failed...','We cannot stop them!',0,0,0,0,0,0,0,0,0,0,65700,65894,26124),
(116639,'The defenses are breached...','Our enemies will fall!',0,0,0,0,0,0,0,0,0,0,65695,65912,26124),
(116640,'Ugh. I must find a physician!','Ugh. I must find a physician!',0,0,0,0,0,0,0,0,0,0,65727,65913,26124),
(116641,'This fruit is horrible...','This fruit is horrible...',0,0,0,0,0,0,0,0,0,0,65712,65914,26124),
(116642,'Ugh, what is happening?','Ugh, what is happening?',0,0,0,0,0,0,0,0,0,0,65713,65915,26124),
(116643,'I feel unwell...','I feel unwell...',0,0,0,0,0,0,0,0,0,0,65728,65930,26124),
(116644,'Ugh. I must find a physician!','',0,0,0,0,0,0,0,0,0,0,65727,0,26124),
(116645,'This fruit is horrible...','',0,0,0,0,0,0,0,0,0,0,65712,0,26124),
(116646,'Ugh, what is happening?','',0,0,0,0,0,0,0,0,0,0,65713,0,26124),
(116647,'I feel unwell...','',0,0,0,0,0,0,0,0,0,0,65728,0,26124),
(116648,'Ugh. I must find a physician!','Ugh. I must find a physician!',0,0,0,0,0,0,0,0,0,0,65648,65885,26124),
(116649,'This fruit is horrible...','This fruit is horrible...',0,0,0,0,0,0,0,0,0,0,65658,65886,26124),
(116650,'Ugh, what is happening?','Ugh, what is happening?',0,0,0,0,0,0,0,0,0,0,65647,65887,26124),
(116651,'I feel unwell...','I feel unwell...',0,0,0,0,0,0,0,0,0,0,65646,65888,26124),
(116652,'Ugh. I must find a physician!','Ugh. I must find a physician!',0,0,0,0,0,0,0,0,0,0,65825,66041,26124),
(116653,'This fruit is horrible...','This fruit is horrible...',0,0,0,0,0,0,0,0,0,0,65826,66042,26124),
(116654,'Ugh, what is happening?','Ugh, what is happening?',0,0,0,0,0,0,0,0,0,0,65827,66043,26124),
(116655,'I feel unwell...','I feel unwell...',0,0,0,0,0,0,0,0,0,0,65828,66007,26124),
(116656,'Ugh. I must find a physician!','',0,0,0,0,0,0,0,0,0,0,65825,0,26124),
(116657,'This fruit is horrible...','',0,0,0,0,0,0,0,0,0,0,65826,0,26124),
(116658,'Ugh, what is happening?','',0,0,0,0,0,0,0,0,0,0,65827,0,26124),
(116659,'I feel unwell...','',0,0,0,0,0,0,0,0,0,0,65828,0,26124),
(116660,'We must hold them here!','You cannot harm us!',0,0,0,0,0,0,0,0,0,0,65694,65895,26124),
(116661,'For Suramar! For Elisande!','For the shal\'dorei!',0,0,0,0,0,0,0,0,0,0,65699,65896,26124),
(116662,'Begone, fiends!','You shall not pass!',0,0,0,0,0,0,0,0,0,0,65693,65897,26124),
(116663,'You cannot harm us!','We must hold them here!',0,0,0,0,0,0,0,0,0,0,65679,65853,26124),
(116664,'For the shal\'dorei!','For Suramar!',0,0,0,0,0,0,0,0,0,0,65680,65851,26124),
(116665,'Begone, wretches!','Begone, fiends!',0,0,0,0,0,0,0,0,0,0,65660,65852,26124),
(116666,'We must protect our lands!','We must protect our lands!',0,0,0,0,0,0,0,0,0,0,65829,66008,26124),
(116667,'For Suramar!','For Suramar! For Elisande!',0,0,0,0,0,0,0,0,0,0,65830,66009,26124),
(116668,'You shall not pass!','Begone, wretches!',0,0,0,0,0,0,0,0,0,0,65831,66011,26124),
(116669,'We must protect our lands!','',0,0,0,0,0,0,0,0,0,0,65829,0,26124),
(116670,'For Suramar!','',0,0,0,0,0,0,0,0,0,0,65830,0,26124),
(116671,'You shall not pass!','',0,0,0,0,0,0,0,0,0,0,65831,0,26124),
(116672,'You cannot harm us!','',0,0,0,0,0,0,0,0,0,0,65679,0,26124),
(116673,'For the shal\'dorei!','',0,0,0,0,0,0,0,0,0,0,65680,0,26124),
(116674,'Begone, wretches!','',0,0,0,0,0,0,0,0,0,0,65660,0,26124),
(116675,'Your fate is sealed!','',0,0,0,0,0,0,0,0,0,0,65705,0,26124),
(116676,'Feel the might of the shal\'dorei!','',0,0,0,0,0,0,0,0,0,0,65706,0,26124),
(116677,'Now is the age of the shal\'dorei!','',0,0,0,0,0,0,0,0,0,0,65707,0,26124),
(116678,'I shall dispose of you, lowborn!','',0,0,0,0,0,0,0,0,0,0,65708,0,26124),
(116679,'We are chosen to rule!','',0,0,0,0,0,0,0,0,0,0,65709,0,26124),
(116680,'No mercy for outlanders!','',0,0,0,0,0,0,0,0,0,0,65710,0,26124),
(116681,'Anath\'ashar!','',0,0,0,0,0,0,0,0,0,0,65711,0,26124),
(116682,'Your death is certain!','',0,0,0,0,0,0,0,0,0,0,65663,0,26124),
(116683,'Tremble before our strength!','',0,0,0,0,0,0,0,0,0,0,65664,0,26124),
(116684,'Your star is fading!','',0,0,0,0,0,0,0,0,0,0,65665,0,26124),
(116685,'Lowborn scum!','',0,0,0,0,0,0,0,0,0,0,65666,0,26124),
(116686,'You will bow to us!','',0,0,0,0,0,0,0,0,0,0,65667,0,26124),
(116687,'None may challenge us!','',0,0,0,0,0,0,0,0,0,0,65668,0,26124),
(116688,'Anath\'ashar!','',0,0,0,0,0,0,0,0,0,0,65669,0,26124),
(116689,'Your fate is sealed!','Your death is certain!',0,0,0,0,0,0,0,0,0,0,65705,65904,26124),
(116690,'Feel the might of the shal\'dorei!','Feel the might of the shal\'dorei!',0,0,0,0,0,0,0,0,0,0,65706,65905,26124),
(116691,'Now is the age of the shal\'dorei!','Your age has ended!',0,0,0,0,0,0,0,0,0,0,65707,65906,26124),
(116692,'I shall dispose of you, lowborn!','Lowborn scum!',0,0,0,0,0,0,0,0,0,0,65708,65907,26124),
(116693,'We are chosen to rule!','You will bow to us!',0,0,0,0,0,0,0,0,0,0,65709,65908,26124),
(116694,'No mercy for outlanders!','Die, outlander!',0,0,0,0,0,0,0,0,0,0,65710,65909,26124),
(116695,'Anath\'ashar!','Anath\'ashar!',0,0,0,0,0,0,0,0,0,0,65711,65910,26124),
(116696,'Your death is certain!','Your death is fated!',0,0,0,0,0,0,0,0,0,0,65663,65864,26124),
(116697,'Tremble before our strength!','Tremble before our strength!',0,0,0,0,0,0,0,0,0,0,65664,65865,26124),
(116698,'Your star is fading!','Your star is fading!',0,0,0,0,0,0,0,0,0,0,65665,65866,26124),
(116699,'Lowborn scum!','Scum like you should obey your betters.',0,0,0,0,0,0,0,0,0,0,65666,65867,26124),
(116700,'You will bow to us!','The shal\'dorei will rule!',0,0,0,0,0,0,0,0,0,0,65667,65868,26124),
(116701,'None may challenge us!','No mercy for outlanders!',0,0,0,0,0,0,0,0,0,0,65668,65869,26124),
(116702,'Anath\'ashar!','Anath\'ashar!',0,0,0,0,0,0,0,0,0,0,65669,65870,26124),
(116703,'Your death is fated!','Your fate is sealed!',0,0,0,0,0,0,0,0,0,0,65814,66021,26124),
(116704,'Our magic will break you!','Our magic will break you!',0,0,0,0,0,0,0,0,0,0,65817,66022,26124),
(116705,'Your age has ended!','Now is the age of the shal\'dorei!',0,0,0,0,0,0,0,0,0,0,65799,66023,26124),
(116706,'Scum like you should obey your betters.','I shall dispose of you, lowborn!',0,0,0,0,0,0,0,0,0,0,65800,66024,26124),
(116707,'The shal\'dorei will rule!','We are chosen to rule!',0,0,0,0,0,0,0,0,0,0,65801,66025,26124),
(116708,'Die, outlander!','None may challenge us!',0,0,0,0,0,0,0,0,0,0,65820,66026,26124),
(116709,'Anath\'ashar!','Anath\'ashar!',0,0,0,0,0,0,0,0,0,0,65818,66027,26124),
(116710,'The shal\'dorei are... chosen...','We are... the chosen ones...',0,0,0,0,0,0,0,0,0,0,65697,65911,26124),
(116711,'Do you have the nightmare sample?','Do you have the nightmare sample?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116712,'No... this isn\'t right! Destroy the malevolent seedling before it escapes!','',0,0,0,0,0,0,5,0,0,0,66742,0,26124),
(116713,'Go to Archdruid Greathoof and tell him what transpired. I\'ll examine what\'s left of this thing.','',0,0,0,0,0,0,0,0,0,0,66743,0,26124),
(116714,'You dare disturb my rest, demon?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116715,'Tell Valeera we are watching over her.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116716,'','Why, you\'re no demon at all!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116717,'','Come, brothers, the Burning Legion attacks!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116718,'Die, Felsworn traitor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116719,'Once again, I am at peace.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116720,'You hear the gentle swirling of water.','You hear the gentle swirling of water.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116721,'You sense that Timirgos is mesmerized by some bright light.','You sense that Timirgos is mesmerized by some bright light.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116722,'There are ancient ruins nearby; but you have the distinct feeling of loneliness.','There are ancient ruins nearby; but you have the distinct feeling of loneliness.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116723,'You sense the presence of creatures long since cursed to hold a new form.','You sense the presence of creatures long since cursed to hold a new form.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116724,'You get the sense of being above everything.','You get the sense of being above everything.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116725,'You hear leaves rustling in the wind.','You hear leaves rustling in the wind.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116726,'You smell the gentle fragrance of flowers in the sun.','You smell the gentle fragrance of flowers in the sun.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116727,'You hear feathers flapping, hooves stomping, and claws scraping.','You hear feathers flapping, hooves stomping, and claws scraping.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116728,'You faintly hear water running down.','You faintly hear water running down.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116729,'You feel a sense of safety from above.','You feel a sense of safety from above.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116730,'You sense an image of graceful creatures strutting about.','You sense an image of graceful creatures strutting about.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116731,'You wonder if ghosts can truly be friendly.','You wonder if ghosts can truly be friendly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116732,'You sense an image of darkness.','You sense an image of darkness.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116733,'You smell dank and dark earth.','You smell dank and dark earth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116734,'You feel the ground shake around you.','You feel the ground shake around you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116735,'You hear the crackling of a small fire.','You hear the crackling of a small fire.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116736,'You feel like you\'re among friends.','You feel like you\'re among friends.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116737,'You sense an image of the moon.','You sense an image of the moon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116738,'You hear a large waterfall nearby.','You hear a large waterfall nearby.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116739,'You feel revulsion and pity for these creatures.','You feel revulsion and pity for these creatures.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116740,'There are such pretty crystals here!','There are such pretty crystals here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116741,'You feel ley energy all around you.','You feel ley energy all around you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116742,'You feel a tear in the fabric of magic nearby.','You feel a tear in the fabric of magic nearby.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116743,'You get the feeling of buildings towering above you.','You get the feeling of buildings towering above you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116744,'These crystals are HUGE!','These crystals are HUGE!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116745,'You feel at home.','You feel at home.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116746,'There are so many friends here to play with!','There are so many friends here to play with!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116747,'You sense a large pool of ley energy nearby.','You sense a large pool of ley energy nearby.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116753,'Elisande, I have failed you...','',0,0,0,0,0,0,0,0,0,0,65804,0,26124),
(116754,'We cannot stop them!','',0,0,0,0,0,0,0,0,0,0,65805,0,26124),
(116755,'Our enemies will fall!','',0,0,0,0,0,0,0,0,0,0,65806,0,26124),
(116756,'I cannot lose to a lowborn!','',0,0,0,0,0,0,0,0,0,0,65807,0,26124),
(116757,'Inconceivable...','',0,0,0,0,0,0,0,0,0,0,65808,0,26124),
(116758,'We have... failed.','',0,0,0,0,0,0,0,0,0,0,65810,0,26124),
(116759,'Tor\'theras falar!','',0,0,0,0,0,0,0,0,0,0,65809,0,26124),
(116760,'Arash-falas...','',0,0,0,0,0,0,0,0,0,0,65811,0,26124),
(116761,'','Helcular! It\'s been a while.',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(116762,'The Nightborne will rule this world!','',0,0,0,0,0,0,0,0,0,0,65812,0,26124),
(116763,'It\'s no use!','',0,0,0,0,0,0,0,0,0,0,65813,0,26124),
(116764,'Aaargh!','',0,0,0,0,0,0,0,0,0,0,65649,0,26124),
(116765,'We will... endure...','',0,0,0,0,0,0,0,0,0,0,65650,0,26124),
(116766,'We cannot be stopped...','',0,0,0,0,0,0,0,0,0,0,65651,0,26124),
(116767,'We are... the chosen ones...','',0,0,0,0,0,0,0,0,0,0,65652,0,26124),
(116768,'No! It is not my time....','',0,0,0,0,0,0,0,0,0,0,65654,0,26124),
(116769,'Forgive me... Elisande.','',0,0,0,0,0,0,0,0,0,0,65655,0,26124),
(116770,'Tor\'theras falar!','',0,0,0,0,0,0,0,0,0,0,65656,0,26124),
(116771,'Arash-falas...','',0,0,0,0,0,0,0,0,0,0,65657,0,26124),
(116772,'Aargh!','',0,0,0,0,0,0,0,0,0,0,65662,0,26124),
(116773,'It is hopeless to resist...','',0,0,0,0,0,0,0,0,0,0,65661,0,26124),
(116774,'Aaargh!','Elisande, I have failed you...',0,0,0,0,0,0,0,0,0,0,65649,65854,26124),
(116775,'We will... endure...','I have failed...',0,0,0,0,0,0,0,0,0,0,65650,65855,26124),
(116776,'We cannot be stopped...','The defenses are breached...',0,0,0,0,0,0,0,0,0,0,65651,65856,26124),
(116777,'We are... the chosen ones...','I cannot lose to a lowborn!',0,0,0,0,0,0,0,0,0,0,65652,65857,26124),
(116778,'No! It is not my time....','This cannot be...',0,0,0,0,0,0,0,0,0,0,65654,65858,26124),
(116779,'Forgive me... Elisande.','We have... failed.',0,0,0,0,0,0,0,0,0,0,65655,65859,26124),
(116780,'Tor\'theras falar!','Tor\'theras falar!',0,0,0,0,0,0,0,0,0,0,65656,65860,26124),
(116781,'Arash-falas...','Arash-falas...',0,0,0,0,0,0,0,0,0,0,65657,65861,26124),
(116782,'Aargh!','Aargh!',0,0,0,0,0,0,0,0,0,0,65662,65862,26124),
(116783,'It is hopeless to resist...','Im... impossible.',0,0,0,0,0,0,0,0,0,0,65661,65863,26124),
(116784,'Elisande, I have failed you...','I cannot be stopped!',0,0,0,0,0,0,0,0,0,0,65804,66010,26124),
(116785,'We cannot stop them!','We will... endure...',0,0,0,0,0,0,0,0,0,0,65805,66012,26124),
(116786,'Our enemies will fall!','We cannot be stopped...',0,0,0,0,0,0,0,0,0,0,65806,66013,26124),
(116787,'I cannot lose to a lowborn!','The shal\'dorei are... chosen...',0,0,0,0,0,0,0,0,0,0,65807,66014,26124),
(116788,'Inconceivable...','No! It is not my time....',0,0,0,0,0,0,0,0,0,0,65808,66015,26124),
(116789,'We have... failed.','My magic... defeated?',0,0,0,0,0,0,0,0,0,0,65810,66016,26124),
(116790,'Tor\'theras falar!','Tor\'theras falar!',0,0,0,0,0,0,0,0,0,0,65809,66017,26124),
(116791,'Arash-falas...','Arash-falas...',0,0,0,0,0,0,0,0,0,0,65811,66018,26124),
(116792,'The Nightborne will rule this world!','The shal\'dorei will rule this world!',0,0,0,0,0,0,0,0,0,0,65812,66019,26124),
(116793,'It\'s no use!','It is hopeless to resist...',0,0,0,0,0,0,0,0,0,0,65813,66020,26124),
(116798,'Die, vermin!','',1,0,0,0,0,0,0,0,0,0,68078,0,26124),
(116799,'You defile this temple with your presence, demon!','',0,0,0,0,0,0,0,0,0,0,68611,0,26124),
(116800,'For Ulduar!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116801,'You do not belong here, demon. Get out!','',0,0,0,0,0,0,0,0,0,0,68613,0,26124),
(116802,'You will regret this!','',0,0,0,0,0,0,0,0,0,0,68079,0,26124),
(116803,'Hang on, Hodir! I brought help. These filthy demons are no match for us!','',1,0,0,0,0,0,0,0,0,0,68080,0,26124),
(116804,'A mortal leads the armies of Skyhold?  Blasphemy!','',1,0,0,0,0,0,0,0,0,0,68408,0,26124),
(116805,'Greetings.','',0,0,0,0,0,0,0,0,0,0,65670,0,26124),
(116806,'What do you wish of me?','',0,0,0,0,0,0,0,0,0,0,65671,0,26124),
(116807,'We will rebuild the world.','',0,0,0,0,0,0,0,0,0,0,65672,0,26124),
(116808,'','This is no ordinary mortal. $n was chosen by Odyn himself!',15,0,0,0,0,0,0,0,0,0,0,68409,26124),
(116809,'Tenu\'balah.','',0,0,0,0,0,0,0,0,0,0,65673,0,26124),
(116810,'Stop it! Spare no expense!','Stop it! Spare no expense!',0,0,0,0,0,0,0,0,0,0,68256,0,26124),
(116811,'The shal\'dorei are eternal.','',0,0,0,0,0,0,0,0,0,0,65674,0,26124),
(116812,'Come now, I have things to do.','',0,0,0,0,0,0,0,0,0,0,65675,0,26124),
(116813,'Why do you insist on pestering me?','',0,0,0,0,0,0,0,0,0,0,65676,0,26124),
(116814,'Move along!','',0,0,0,0,0,0,0,0,0,0,65677,0,26124),
(116815,'Are you sure you\'re not a Night-bore?','',0,0,0,0,0,0,0,0,0,0,65678,0,26124),
(116816,'Our era has come.','Our age is now!',0,0,0,0,0,0,0,0,0,0,65840,66028,26124),
(116817,'The Nightborne shall reign.','The Nightborne shall reign.',0,0,0,0,0,0,0,0,0,0,65845,66029,26124),
(116818,'Kal\'theros maldin.','Kal\'theros maldin.',0,0,0,0,0,0,0,0,0,0,65844,66030,26124),
(116819,'Nor\'bethos Suramar.','',0,0,0,0,0,0,0,0,0,0,65746,0,26124),
(116820,'Be well.','',0,0,0,0,0,0,0,0,0,0,65747,0,26124),
(116821,'Please help me, $n. My young friend Timirgos has gone missing somewhere in the area.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116822,'I\'ll cast an enchantment on you that will give you clairvoyant powers for a short time. Use your newfound abilities to find Timirgos.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116823,'Thank you so much, $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116824,'Night guide you.','Elisande guide you.',0,0,0,0,0,0,0,0,0,0,65842,66031,26124),
(116825,'Elisande guide you.','Stars guide you.',0,0,0,0,0,0,0,0,0,0,65762,65952,26124),
(116826,'Be well.','Fare well.',0,0,0,0,0,0,0,0,0,0,65747,65953,26124),
(116827,'Nor\'bethos Suramar.','Nor\'bethos Suramar.',0,0,0,0,0,0,0,0,0,0,65746,65954,26124),
(116828,'Kal\'theros maldin.','Kal\'theros maldin.',0,0,0,0,0,0,0,0,0,0,65763,65955,26124),
(116829,'We rejoin the world.','The shal\'dorei shall rise.',0,0,0,0,0,0,0,0,0,0,65764,65956,26124),
(116830,'We shall endure.','Our era has come.',0,0,0,0,0,0,0,0,0,0,65766,65957,26124),
(116831,'My goods are exquisite.','',0,0,0,0,0,0,0,0,0,0,65748,0,26124),
(116832,'Take a look, I sell all manner of wares.','',0,0,0,0,0,0,0,0,0,0,65749,0,26124),
(116833,'What is your pleasure?','',0,0,0,0,0,0,0,0,0,0,65750,0,26124),
(116834,'You will not find a better bargain!','',0,0,0,0,0,0,0,0,0,0,65751,0,26124),
(116835,'Do come again.','',0,0,0,0,0,0,0,0,0,0,65752,0,26124),
(116836,'Pleasure doing business.','',0,0,0,0,0,0,0,0,0,0,65753,0,26124),
(116837,'What is your pleasure?','What is your pleasure?',0,0,0,0,0,0,0,0,0,0,65750,65958,26124),
(116838,'Pleasure doing business.','Pleasure doing business.',0,0,0,0,0,0,0,0,0,0,65753,65959,26124),
(116839,'Take a look, I sell all manner of wares.','Take a look, I sell all manner of wares.',0,0,0,0,0,0,0,0,0,0,65749,65960,26124),
(116840,'Do come again.','Do come again.',0,0,0,0,0,0,0,0,0,0,65752,65961,26124),
(116841,'My goods are exquisite.','My goods are exquisite.',0,0,0,0,0,0,0,0,0,0,65748,65962,26124),
(116842,'You will not find a better bargain!','You will not find a better bargain!',0,0,0,0,0,0,0,0,0,0,65751,65963,26124),
(116843,'The shal\'dorei are eternal.','We have hidden too long.',0,0,0,0,0,0,0,0,0,0,65674,65871,26124),
(116844,'Ishnal to\'reth.','Ishnal to\'reth.',0,0,0,0,0,0,0,0,0,0,71690,65872,26124),
(116845,'Tenu\'balah.','Tenu\'balah.',0,0,0,0,0,0,0,0,0,0,65673,65873,26124),
(116846,'We will rebuild the world.','Our destiny is at hand.',0,0,0,0,0,0,0,0,0,0,65672,65874,26124),
(116847,'What do you wish of me?','You wish to speak?',0,0,0,0,0,0,0,0,0,0,65671,65875,26124),
(116848,'Greetings.','Greetings.',0,0,0,0,0,0,0,0,0,0,65670,65876,26124),
(116849,'Ash\'thoras denil.','Ash\'thoras denil.',0,0,0,0,0,0,0,0,0,0,65653,65877,26124),
(116850,'We see the stars once more.','',0,0,0,0,0,0,0,0,0,0,65714,0,26124),
(116851,'The Nightborne are eternal.','',0,0,0,0,0,0,0,0,0,0,65715,0,26124),
(116852,'Tenu\'balah.','',0,0,0,0,0,0,0,0,0,0,65716,0,26124),
(116853,'Ishnal to\'reth.','',0,0,0,0,0,0,0,0,0,0,65717,0,26124),
(116854,'You wish to speak?','',0,0,0,0,0,0,0,0,0,0,65718,0,26124),
(116855,'Greetings.','',0,0,0,0,0,0,0,0,0,0,65719,0,26124),
(116856,'Ash\'thoras denil.','',0,0,0,0,0,0,0,0,0,0,65720,0,26124),
(116857,'We see the stars once more.','The shal\'dorei are eternal.',0,0,0,0,0,0,0,0,0,0,65714,65916,26124),
(116858,'The Nightborne are eternal.','The Nightborne are eternal.',0,0,0,0,0,0,0,0,0,0,65715,65917,26124),
(116859,'Tenu\'balah.','Tenu\'balah.',0,0,0,0,0,0,0,0,0,0,65716,65918,26124),
(116860,'Ishnal to\'reth.','We will rebuild the world.',0,0,0,0,0,0,0,0,0,0,65717,65919,26124),
(116861,'You wish to speak?','What is your wish?',0,0,0,0,0,0,0,0,0,0,65718,65920,26124),
(116862,'Greetings.','Greetings.',0,0,0,0,0,0,0,0,0,0,65719,65921,26124),
(116863,'Ash\'thoras denil.','Ash\'thoras denil.',0,0,0,0,0,0,0,0,0,0,65720,65922,26124),
(116864,'We are eternal.','',0,0,0,0,0,0,0,0,0,0,65832,0,26124),
(116865,'Suramar ascends.','',0,0,0,0,0,0,0,0,0,0,65833,0,26124),
(116866,'Tenu\'balah.','',0,0,0,0,0,0,0,0,0,0,65834,0,26124),
(116867,'Wisdom to Elisande.','',0,0,0,0,0,0,0,0,0,0,65835,0,26124),
(116868,'May I help you?','',0,0,0,0,0,0,0,0,0,0,65836,0,26124),
(116869,'Greetings.','',0,0,0,0,0,0,0,0,0,0,65837,0,26124),
(116870,'Ash\'thoras denil.','',0,0,0,0,0,0,0,0,0,0,65838,0,26124),
(116871,'We are eternal.','We are eternal.',0,0,0,0,0,0,0,0,0,0,65832,66032,26124),
(116873,'Tenu\'balah.','Tenu\'balah.',0,0,0,0,0,0,0,0,0,0,65834,66033,26124),
(116874,'Wisdom to Elisande.','Suramar ascends.',0,0,0,0,0,0,0,0,0,0,65835,66034,26124),
(116875,'May I help you?','What do you wish of me?',0,0,0,0,0,0,0,0,0,0,65836,66035,26124),
(116876,'Greetings.','Greetings.',0,0,0,0,0,0,0,0,0,0,65837,66036,26124),
(116877,'Ash\'thoras denil.','Ash\'thoras denil.',0,0,0,0,0,0,0,0,0,0,65838,66037,26124),
(116878,'We no longer hide.','',0,0,0,0,0,0,0,0,0,0,65755,0,26124),
(116879,'Nightwell nourish us.','',0,0,0,0,0,0,0,0,0,0,65756,0,26124),
(116880,'Tenu\'balah.','',0,0,0,0,0,0,0,0,0,0,65757,0,26124),
(116881,'Our destiny is at hand.','',0,0,0,0,0,0,0,0,0,0,65758,0,26124),
(116882,'What is your wish?','',0,0,0,0,0,0,0,0,0,0,65759,0,26124),
(116883,'Greetings.','',0,0,0,0,0,0,0,0,0,0,65760,0,26124),
(116884,'Ash\'thoras denil.','',0,0,0,0,0,0,0,0,0,0,65761,0,26124),
(116885,'Hurry!','',1,0,0,0,0,0,0,0,0,0,68101,0,26124),
(116886,'We no longer hide.','We see the stars once more.',0,0,0,0,0,0,0,0,0,0,65755,65964,26124),
(116887,'Nightwell nourish us.','Nightwell nourish us.',0,0,0,0,0,0,0,0,0,0,65756,65965,26124),
(116888,'Tenu\'balah.','Tenu\'balah.',0,0,0,0,0,0,0,0,0,0,65757,65966,26124),
(116889,'Our destiny is at hand.','Wisdom to Elisande.',0,0,0,0,0,0,0,0,0,0,65758,65967,26124),
(116890,'What is your wish?','May I help you?',0,0,0,0,0,0,0,0,0,0,65759,65968,26124),
(116891,'Greetings.','Greetings.',0,0,0,0,0,0,0,0,0,0,65760,65969,26124),
(116892,'Ash\'thoras denil.','Ash\'thoras denil.',0,0,0,0,0,0,0,0,0,0,65761,65970,26124),
(116893,'Stars guide you.','',0,0,0,0,0,0,0,0,0,0,65721,0,26124),
(116894,'These times are troubling. Watch your back.','',0,0,0,0,0,0,0,0,0,0,65839,0,26124),
(116895,'Nor\'bethos Suramar.','',0,0,0,0,0,0,0,0,0,0,65722,0,26124),
(116896,'Kal\'theros maldin.','',0,0,0,0,0,0,0,0,0,0,65723,0,26124),
(116897,'The shal\'dorei shall rise.','',0,0,0,0,0,0,0,0,0,0,65724,0,26124),
(116898,'Our age is now!','',0,0,0,0,0,0,0,0,0,0,65725,0,26124),
(116899,'Well\'s gift be with you.','',0,0,0,0,0,0,0,0,0,0,65726,0,26124),
(116900,'Stars guide you.','By Night\'s grace.',0,0,0,0,0,0,0,0,0,0,65721,65923,26124),
(116901,'Move along.','Safe travels.',0,0,0,0,0,0,0,0,0,0,0,65924,26124),
(116902,'Nor\'bethos Suramar.','Nor\'bethos Suramar.',0,0,0,0,0,0,0,0,0,0,65722,65925,26124),
(116903,'','Your world will be ourss!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116904,'Kal\'theros maldin.','Kal\'theros maldin.',0,0,0,0,0,0,0,0,0,0,65723,65926,26124),
(116905,'The shal\'dorei shall rise.','The shal\'dorei have returned.',0,0,0,0,0,0,0,0,0,0,65724,65927,26124),
(116906,'Our age is now!','This is our age now.',0,0,0,0,0,0,0,0,0,0,65725,65928,26124),
(116907,'Well\'s gift be with you.','Travel in starlight, friend.',0,0,0,0,0,0,0,0,0,0,65726,65929,26124),
(116908,'Elisande guide you.','',0,0,0,0,0,0,0,0,0,0,65762,0,26124),
(116909,'These times are troubling. Watch your back.','Be well.',0,0,0,0,0,0,0,0,0,0,65839,66038,26124),
(116910,'Nor\'bethos Suramar.','Nor\'bethos Suramar.',0,0,0,0,0,0,0,0,0,0,65843,66039,26124),
(116911,'Kal\'theros maldin.','',0,0,0,0,0,0,0,0,0,0,65763,0,26124),
(116912,'We rejoin the world.','',0,0,0,0,0,0,0,0,0,0,65764,0,26124),
(116913,'Our era has come.','',0,0,0,0,0,0,0,0,0,0,65840,0,26124),
(116914,'Walk in starlight.','',0,0,0,0,0,0,0,0,0,0,65841,0,26124),
(116915,'Night guide you.','',0,0,0,0,0,0,0,0,0,0,65842,0,26124),
(116916,'Fare well.','',0,0,0,0,0,0,0,0,0,0,65765,0,26124),
(116917,'Nor\'bethos Suramar.','',0,0,0,0,0,0,0,0,0,0,65843,0,26124),
(116918,'Kal\'theros maldin.','',0,0,0,0,0,0,0,0,0,0,65844,0,26124),
(116919,'The Nightborne shall reign.','',0,0,0,0,0,0,0,0,0,0,65845,0,26124),
(116920,'We shall endure.','',0,0,0,0,0,0,0,0,0,0,65766,0,26124),
(116921,'Walk in starlight.','Well\'s gift be with you.',0,0,0,0,0,0,0,0,0,0,65841,66040,26124),
(116922,'Your interference only delays the inevitable. Minions, destroy $g him:her;!','',0,0,0,0,0,0,0,0,0,0,70843,0,26124),
(116923,'Send in the wrathlords at once! Stop these meddling insects!','',0,0,0,0,0,0,0,0,0,0,70842,0,26124),
(116924,'You foolishly stand in defiance of the endless armies of Sargeras! Sisters, bring me $g his:her; head!','',0,0,0,0,0,0,0,0,0,0,70841,0,26124),
(116925,'For a prophet you are doing a very poor job of making predictions...','',0,0,0,0,0,0,0,0,0,0,70833,0,26124),
(116926,'*O\'ros emits a bitter melody*','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116927,'Time for a little action.','Time for a little action.',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(116928,'Point me to the nearest demon.','Point me to the nearest demon.',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(116929,'My blade is eager for battle.','My blade is eager for battle.',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(116930,'You dare defile our lands?','You dare defile our lands?',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(116931,'Give them no ground!','Give them no ground!',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(116932,'You underestimate the powers of the Forsaken!','You underestimate the powers of the Forsaken!',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(116933,'Look up. See the grapple point? That\'s your cue to get climbing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116934,'','This is a huge stash... leave none of this contraband behind!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116935,'Pity took root in my heart. I shared with them the ancient gift.','',0,0,0,0,0,0,0,0,0,0,66369,0,26124),
(116939,'Keep the hook. I can find better places to hide my stash.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116940,'Meditation has opened our eyes to a technique that will infuse the resources you\'ve gathered into the ancient artifact.','',0,0,0,0,0,0,603,0,0,0,68732,0,26124),
(116941,'I\'ll meet you there. I want to guarantee that they don\'t get their hands on my goods.','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(116942,'It is good to see the Aegis of Aggramar safe from the likes of Skovald and his fel allies.','',0,0,0,0,0,0,0,0,0,0,79600,0,26124),
(116943,'You have a monumental task ahead of you, $n. No doubt the skalds will sing the verses of your glory for ages to come.','',0,0,0,0,0,0,0,0,0,0,79601,0,26124),
(116944,'Go forth, champion, and show this Burning Legion the fury of the Valarjar!','',0,0,0,0,0,0,0,0,0,0,79602,0,26124),
(116945,'By Night\'s grace.','Night guide you.',0,0,0,0,0,0,0,0,0,0,65681,65879,26124),
(116946,'Safe travels.','These times are troubling. Watch your back.',0,0,0,0,0,0,0,0,0,0,65682,65878,26124),
(116947,'Nor\'bethos Suramar.','Nor\'bethos Suramar.',0,0,0,0,0,0,0,0,0,0,65683,65880,26124),
(116948,'Kal\'theros maldin.','Kal\'theros maldin.',0,0,0,0,0,0,0,0,0,0,65684,65881,26124),
(116949,'The Nightborne have returned.','We rejoin the world.',0,0,0,0,0,0,0,0,0,0,65685,65882,26124),
(116950,'This is our age now.','We shall endure.',0,0,0,0,0,0,0,0,0,0,65686,65883,26124),
(116951,'Travel in starlight, friend.','Walk in the moonlight.',0,0,0,0,0,0,0,0,0,0,65687,65884,26124),
(116952,'By Night\'s grace.','',0,0,0,0,0,0,0,0,0,0,65681,0,26124),
(116953,'Safe travels.','',0,0,0,0,0,0,0,0,0,0,65682,0,26124),
(116954,'Nor\'bethos Suramar.','',0,0,0,0,0,0,0,0,0,0,65683,0,26124),
(116955,'Kal\'theros maldin.','',0,0,0,0,0,0,0,0,0,0,65684,0,26124),
(116956,'The Nightborne have returned.','',0,0,0,0,0,0,0,0,0,0,65685,0,26124),
(116957,'This is our age now.','',0,0,0,0,0,0,0,0,0,0,65686,0,26124),
(116958,'Travel in starlight, friend.','',0,0,0,0,0,0,0,0,0,0,65687,0,26124),
(116959,'Step before the Forge of the Roaring Mountain and raise your weapon high. Behold! Its true might is awakened!','',0,0,0,0,0,0,2,0,0,0,68733,0,26124),
(116960,'Hello, friend! Brightwing likes it when you visit!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116961,'The Burning Legion shall regret ever laying their sights on my domain. My armies are at your command! Lead them into glory!','',0,0,0,0,0,0,0,0,0,0,68412,0,26124),
(116962,'No no no, my pretty grove is hurting. Friend, can you help?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116963,'An arcan\'dor. For a time it sustained them. For a time, they were safe.','',0,0,0,0,0,0,0,0,0,0,66370,0,26124),
(116964,'It would not last. The tree became unstable.','',0,0,0,0,0,0,0,0,0,0,66371,0,26124),
(116965,'The arcan\'dor died. In a flash of wild magic, the inhabitants of Falanaar were twisted.','',0,0,0,0,0,0,0,0,0,0,66372,0,26124),
(116966,'The fal\'dorei are my failure. I will not fail again.','',0,0,0,0,0,0,0,0,0,0,66373,0,26124),
(116967,'It is here the most dangerous prisoners were kept. Best not wander about. No telling what may lurk in the shadows...','',1,0,0,0,0,0,0,0,0,0,66456,0,26124),
(116968,'To think the Horde and Alliance once waged war to control this prison. As usual, their small-minded efforts were misguided and futile.','',1,0,0,0,0,0,0,0,0,0,66457,0,26124),
(116969,'In your brief life span, I\'m sure you have never faced a void terror. Avoid its eye attacks and stay out of my way. I am not here to protect you!','',1,0,0,0,0,0,0,0,0,0,66458,0,26124),
(116970,'Hrmph, so much to do... so little time... but this little faerie dragon must keep going.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116971,'|TInterface\\Icons\\sha_spell_fire_felfire:20|t%s is casting |cFFFF0000|Hspell:219571|h[Felfrost Deathblast]|h|r! Interrupt it!','|TInterface\\Icons\\sha_spell_fire_felfire:20|t%s is casting |cFFFF0000|Hspell:219571|h[Felfrost Deathblast]|h|r! Interrupt it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116972,'The beast falls! I am victorious once again.','',1,0,0,0,0,0,0,0,0,0,66453,0,26124),
(116973,'I\'ll retrieve the Eye. No doubt your crude attempts at its removal would cause irreparable damage.','',0,0,0,0,0,0,0,0,0,0,66454,0,26124),
(116974,'I have the Eye, and you have the Book. Well, I\'ll let you keep it for now. Make haste to the Tomb of Sargeras. Do not keep Gul\'dan waiting.','',0,0,0,0,0,0,0,0,0,0,66455,0,26124),
(116975,'We meet again, $n. I see you are making good use of Titanstrike.','',1,0,0,0,0,0,0,0,0,0,66814,0,26124),
(116976,'Mimiron! Why are you here?','Mimiron! Why are you here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116977,'$ct! We of the Broken Temple have watched the bond between you and your ancient weapon grow strong.','',0,0,0,0,0,0,1,0,0,0,68731,0,26124),
(116978,'Technically this is a projection of myself, not the real thing. It\'s a very handy way to check in from time to time.','',1,0,0,0,0,0,0,0,0,0,66815,0,26124),
(116979,'Titanstrike and Hati are both powerful.','Titanstrike and Hati are both powerful.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116980,'Just wanted to make sure that Titanstrike, and the Thunderspark within, are in good working order. I\'m quite proud of those creations, you know!','',1,0,0,0,0,0,0,0,0,0,66816,0,26124),
(116981,'I hope your inventions help us in the fight against the Legion.','I hope your inventions help us in the fight against the Legion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(116982,'My inventions are always magnificent. In fact, I already have plans for my next one! I\'d be happy to discuss it!','',0,0,0,0,0,0,1,0,0,0,66817,0,26124),
(116983,'Bye!','',0,0,0,0,0,0,0,0,0,0,65788,0,26124),
(116984,'Can we play later?','',0,0,0,0,0,0,0,0,0,0,65789,0,26124),
(116985,'Magic tastes like purple!','',0,0,0,0,0,0,0,0,0,0,65790,0,26124),
(116986,'Be nice or be strong.','',0,0,0,0,0,0,0,0,0,0,65791,0,26124),
(116987,'Make sure to drink your magic juice!','',0,0,0,0,0,0,0,0,0,0,65792,0,26124),
(116988,'Long live the Nightwell!','',0,0,0,0,0,0,0,0,0,0,65793,0,26124),
(116989,'So long!','',0,0,0,0,0,0,0,0,0,0,65794,0,26124),
(116990,'','So long!',0,0,0,0,0,0,0,0,0,0,0,65993,26124),
(116991,'','Long live the Nightwell!',0,0,0,0,0,0,0,0,0,0,0,65994,26124),
(116992,'','Make sure to drink your magic juice!',0,0,0,0,0,0,0,0,0,0,0,65995,26124),
(116993,'','Be nice or be strong.',0,0,0,0,0,0,0,0,0,0,0,65996,26124),
(116994,'','Magic tastes like purple!',0,0,0,0,0,0,0,0,0,0,0,65997,26124),
(116995,'','Can we play later?',0,0,0,0,0,0,0,0,0,0,0,65998,26124),
(116996,'','Bye!',0,0,0,0,0,0,0,0,0,0,0,65999,26124),
(116997,'I wanna play now.','',0,0,0,0,0,0,0,0,0,0,65795,0,26124),
(116998,'Come on! Go do something amazing!','',0,0,0,0,0,0,0,0,0,0,65796,0,26124),
(116999,'Look, one of us has to be the grown-up here.','',0,0,0,0,0,0,0,0,0,0,65797,0,26124),
(117000,'I guess it has to be me!','',0,0,0,0,0,0,0,0,0,0,65798,0,26124),
(117001,'','I guess it has to be me!',0,0,0,0,0,0,0,0,0,0,0,65989,26124),
(117002,'','Look, one of us has to be the grown-up here.',0,0,0,0,0,0,0,0,0,0,0,65990,26124),
(117003,'','Come on! Go do something amazing!',0,0,0,0,0,0,0,0,0,0,0,65991,26124),
(117004,'','I wanna play now.',0,0,0,0,0,0,0,0,0,0,0,65992,26124),
(117005,'Come now, I have things to do.','Excuse me, I have things to do.',0,0,0,0,0,0,0,0,0,0,65675,65847,26124),
(117006,'Why do you insist on pestering me?','Is there somewhere else you could be right now?',0,0,0,0,0,0,0,0,0,0,65676,65848,26124),
(117007,'Move along!','As in, anywhere but here?',0,0,0,0,0,0,0,0,0,0,65677,65849,26124),
(117008,'Are you sure you\'re not a Night-bore?','You are really a night-thorn in my side.',0,0,0,0,0,0,0,0,0,0,65678,65850,26124),
(117009,'','While you are in Black Rook Hold, there is an urgent matter I must attend to. I will meet you back at the Hall of Shadows.',0,0,0,0,0,0,0,0,0,0,0,69485,26124),
(117010,'I\'m ready to begin.','I\'m ready to begin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117011,'[Laughter]','',0,0,0,0,0,0,0,0,0,0,64614,0,26124),
(117012,'','When will this nightmare end?',0,0,0,0,0,0,0,0,0,0,0,64615,26124),
(117013,'All right, enough.','',0,0,0,0,0,0,0,0,0,0,65701,0,26124),
(117014,'Are you looking for trouble?','',0,0,0,0,0,0,0,0,0,0,65702,0,26124),
(117015,'Because you are about to find some.','',0,0,0,0,0,0,0,0,0,0,65703,0,26124),
(117016,'That is it! See if I invite you to my promotion party.','',0,0,0,0,0,0,0,0,0,0,65704,0,26124),
(117017,'All right, enough.','How about you go bug someone else for a while?',0,0,0,0,0,0,0,0,0,0,65701,65889,26124),
(117018,'Are you looking for trouble?','Look, I just want to finish my shift and usher in a new era for Azeroth.',0,0,0,0,0,0,0,0,0,0,65702,65890,26124),
(117019,'Because you are about to find some.','Can you let me do that? Will you let me do my ushering?',0,0,0,0,0,0,0,0,0,0,65703,65891,26124),
(117020,'That is it! See if I invite you to my promotion party.','<Sighs> I should have taken that post in Azshara.',0,0,0,0,0,0,0,0,0,0,65704,65892,26124),
(117021,'You know, not everyone can master the arcane as well as I.','Look at you. Now back to me. I am a master of magic.',0,0,0,0,0,0,0,0,0,0,65821,66000,26124),
(117022,'I attended the most prestigious magical academy in Suramar.','Now back to you. You cannot even cast the easiest of cantrips.',0,0,0,0,0,0,0,0,0,0,65822,66001,26124),
(117023,'I even had a focused study in battle magic. I graduated top of my class.','Now back to me. Sadly, you are not me. Look down, now up.',0,0,0,0,0,0,0,0,0,0,65823,66006,26124),
(117024,'Which means I can fry you in an instant if you keep bothering me!','Now look. I am sparkling like diamonds. Because of magic.',0,0,0,0,0,0,0,0,0,0,65824,66002,26124),
(117025,'|TInterface\\Icons\\ability_mage_timewarp:20|tThe passage of time is now normal.','|TInterface\\Icons\\ability_mage_timewarp:20|tThe passage of time is now normal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117026,'|TInterface\\Icons\\ability_mage_timewarp:20|tTime is passing much more quickly.','|TInterface\\Icons\\ability_mage_timewarp:20|tTime is passing much more quickly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117027,'|TInterface\\Icons\\ability_mage_timewarp:20|tTime is passing very slowly.','|TInterface\\Icons\\ability_mage_timewarp:20|tTime is passing very slowly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117028,'You know, not everyone can master the arcane as well as I.','',0,0,0,0,0,0,0,0,0,0,65821,0,26124),
(117029,'I attended the most prestigious magical academy in Suramar.','',0,0,0,0,0,0,0,0,0,0,65822,0,26124),
(117030,'I even had a focused study in battle magic. I graduated top of my class.','',0,0,0,0,0,0,0,0,0,0,65823,0,26124),
(117031,'Which means I can fry you in an instant if you keep bothering me!','',0,0,0,0,0,0,0,0,0,0,65824,0,26124),
(117032,'You will NOT move me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117033,'Begone!','',0,0,0,0,0,0,0,0,0,0,66253,0,26124),
(117034,'Andu Falah\'dor!','',0,0,0,0,0,0,0,0,0,0,66254,0,26124),
(117035,'Manafiend!','',0,0,0,0,0,0,0,0,0,0,66255,0,26124),
(117036,'Destroy them!','',0,0,0,0,0,0,0,0,0,0,66256,0,26124),
(117037,'Suramar is still a shining jewel in the rubble of the Sundering.','',0,0,0,0,0,0,0,0,0,0,65743,0,26124),
(117038,'We will explore the rest of the world and show them that we are still relevant!','',0,0,0,0,0,0,0,0,0,0,65744,0,26124),
(117039,'I bought this off of a scout patrol. He called it a \"S.E.L.F.I.E. Camera?\" Any idea what that is?','',0,0,0,0,0,0,0,0,0,0,65745,0,26124),
(117040,'You look young enough to use this fancy thing. Can you make it work for me?','',0,0,0,0,0,0,0,0,0,0,65742,0,26124),
(117041,'Suramar is still a shining jewel in the rubble of the Sundering.','Suramar is still a shining jewel in the rubble of the Sundering.',0,0,0,0,0,0,0,0,0,0,65743,65947,26124),
(117042,'We will explore the rest of the world and show them that we are still relevant!','We will explore the rest of the world and show them that we are still relevant!',0,0,0,0,0,0,0,0,0,0,65744,65948,26124),
(117043,'I bought this off of a scout patrol. He called it a \"S.E.L.F.I.E. Camera?\" Any idea what that is?','I bought this off of a scout patrol. He called it a \"S.E.L.F.I.E. Camera?\" Any idea what that is?',0,0,0,0,0,0,0,0,0,0,65745,65935,26124),
(117044,'You look young enough to use this fancy thing. Can you make it work for me?','You look young enough to use this fancy thing. Can you make it work for me?',0,0,0,0,0,0,0,0,0,0,65742,65949,26124),
(117046,'I will take this opportunity to lay traps for the intruders. I am certain we will meet again!','',0,0,0,0,0,0,0,0,0,0,66360,0,26124),
(117047,'In the Light we are reborn.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117048,'I will help you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117049,'Can the naaru aid you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117050,'Walk in light.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117051,'Light reveal your path.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117052,'Goodbye.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117053,'Careful, I can be sharp.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117054,'Please don\'t smudge me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117055,'Would you like see the temple, say, from the outside?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117056,'You found them! I will have them properly preserved and sent somewhere safe immediately.','',0,0,0,0,0,0,603,0,0,0,66257,0,26124),
(117057,'','This chamber... I have never seen anything like it.',0,0,0,0,0,0,0,0,0,0,0,67383,26124),
(117058,'','Enough! I grow weary of you.',0,0,0,0,0,0,0,0,0,0,0,68609,26124),
(117059,'','Enjoy your victory while it lasts. The Legion will tear this world asunder!',0,0,0,0,0,0,0,0,0,0,0,68610,26124),
(117060,'She\'s getting away!','',1,0,0,0,0,0,0,0,0,0,67682,0,26124),
(117061,'She will not get away with this!','',1,0,0,0,0,0,0,0,0,0,68099,0,26124),
(117062,'Ahhh... Much better!','',603,0,0,0,0,0,603,0,0,0,0,0,26124),
(117063,'Great, you have the parts! Just give them to XR9-47 so he can bring them to me.','',0,0,0,0,0,0,1,0,0,0,66813,0,26124),
(117064,'','Old teleporters. Not so different from the ones in Suramar city. Seems they are inactive.',0,0,0,0,0,0,0,0,0,0,0,67387,26124),
(117065,'XR9-47, bring me the parts at once!','',0,0,0,0,0,0,1,0,0,0,66812,0,26124),
(117066,'<XR9-47\'s gears spin expectantly.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117067,'Mimiron, has XR9-47 delivered the parts yet?','Mimiron, has XR9-47 delivered the parts yet?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117068,'You will be eradicated!','',0,0,0,0,0,0,0,0,0,0,66105,0,26124),
(117069,'We shall reap your souls!','',0,0,0,0,0,0,0,0,0,0,66106,0,26124),
(117070,'Finally, some amusement.','',0,0,0,0,0,0,0,0,0,0,66107,0,26124),
(117071,'The Legion conquers all!','',0,0,0,0,0,0,0,0,0,0,66108,0,26124),
(117072,'Taste true fear!','',0,0,0,0,0,0,0,0,0,0,66109,0,26124),
(117073,'','You throw a party for vapid nobles even as rebels leave corpses strewn about our streets?',1,0,0,0,0,0,0,0,0,0,0,67609,26124),
(117074,'You will make a fine sacrifice.','',0,0,0,0,0,0,0,0,0,0,66110,0,26124),
(117075,'Destroy them!','',0,0,0,0,0,0,0,0,0,0,66111,0,26124),
(117076,'I assure you, Grand Magistrix, the situation is being addressed. It will be a simple matter to track down a few random dissidents and--','',1,0,0,0,0,0,0,0,0,0,67726,0,26124),
(117077,'Mimiron, I lost the Essence Swapper, can I have another?','Mimiron, I lost the Essence Swapper, can I have another?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117078,'You cannot stop us all...','',0,0,0,0,0,0,0,0,0,0,66112,0,26124),
(117079,'The Legion is endless!','',0,0,0,0,0,0,0,0,0,0,66113,0,26124),
(117080,'','Random? Do you not find it striking that each body found is decorated with a dusk lily? The same flower adored by Thalyssra?',1,0,0,0,0,0,0,0,0,0,0,67610,26124),
(117081,'I am one of many...','',0,0,0,0,0,0,0,0,0,0,66114,0,26124),
(117082,'I... I\'m not sure what you\'re getting at, Grand Magistrix.','',1,0,0,0,0,0,0,0,0,0,67727,0,26124),
(117083,'Oblivion awaits!','',0,0,0,0,0,0,0,0,0,0,66115,0,26124),
(117084,'This world will... burn.','',0,0,0,0,0,0,0,0,0,0,66116,0,26124),
(117085,'','Then let me be plain. You bungled your assassination of Thalyssra. In fact, she is very much alive, and is...',1,0,0,0,0,0,0,0,0,0,0,67611,26124),
(117086,'','Wait. We are not alone.',1,0,0,0,0,0,0,0,0,0,0,67612,26124),
(117087,'It is... hopeless...','',0,0,0,0,0,0,0,0,0,0,66117,0,26124),
(117088,'Impossible! My guards would never permit such an intrusion!','',1,0,0,0,0,0,0,0,0,0,67728,0,26124),
(117089,'I will be avenged.','',0,0,0,0,0,0,0,0,0,0,66118,0,26124),
(117090,'','This... cannot be...',0,0,0,0,0,0,0,0,0,0,0,66131,26124),
(117091,'','You cannot... resist...',0,0,0,0,0,0,0,0,0,0,0,66132,26124),
(117092,'','We will scorch the world!',0,0,0,0,0,0,0,0,0,0,0,66133,26124),
(117093,'','Oblivion awaits!',0,0,0,0,0,0,0,0,0,0,0,66134,26124),
(117094,'','Where one falls... two shall rise.',0,0,0,0,0,0,0,0,0,0,0,66135,26124),
(117095,'','We are... endless.',0,0,0,0,0,0,0,0,0,0,0,66136,26124),
(117096,'','You cannot stop us all...',0,0,0,0,0,0,0,0,0,0,0,66137,26124),
(117097,'','At last, some fitting prey...',0,0,0,0,0,0,0,0,0,0,0,66138,26124),
(117098,'','I will deliver your head to Gul\'dan myself.',0,0,0,0,0,0,0,0,0,0,0,66139,26124),
(117099,'','Do not toy with us!',0,0,0,0,0,0,0,0,0,0,0,66140,26124),
(117100,'','The Legion will conquer all!',0,0,0,0,0,0,0,0,0,0,0,66141,26124),
(117101,'','Finally, some amusement.',0,0,0,0,0,0,0,0,0,0,0,66142,26124),
(117102,'','Your soul will serve us for eternity!',0,0,0,0,0,0,0,0,0,0,0,66143,26124),
(117103,'','Annihilate them!',0,0,0,0,0,0,0,0,0,0,0,66144,26124),
(117104,'','Yet another failure, Melandrus. Consider this your chance to correct it. Dispose of these outsiders. I must return to the Nighthold.',1,0,0,0,0,0,0,0,0,0,0,67613,26124),
(117105,'Must you leave so soon, Grand Magistrix?','',1,0,0,0,0,0,0,0,0,0,67729,0,26124),
(117106,'','Do you expect me to waste time chattering with vapid nobles even as my enemies close in? Look there, you fool! We are not alone.',1,0,0,0,0,0,0,0,0,0,0,67614,26124),
(117107,'We meet again! Lothrius and Syrana have just informed me of your deeds.','',0,0,0,0,0,0,1,0,0,0,66387,0,26124),
(117108,'Return to me when you\'ve gathered enough essence of the wilds, Archdruid. I trust none other to accomplish this difficult task.','',0,0,0,0,0,0,0,0,0,0,66765,0,26124),
(117109,'We have also decided that it is time to leave this place.','',0,0,0,0,0,0,1,0,0,0,66386,0,26124),
(117110,'','The Moon Guard are no more. There is no saving our beloved Stronghold.',0,0,0,0,0,0,1,0,0,0,0,66384,26124),
(117112,'Malorne\'s warning cannot be ignored. The great father of the forest is in dire peril, and we must help him... or the very wilds may be lost.','',0,0,0,0,0,0,0,0,0,0,66766,0,26124),
(117114,'Rebuilding the portal will be no easy task. It will take several moons to complete the ritual.','',0,0,0,0,0,0,1,0,0,0,66767,0,26124),
(117117,'Greetings, Grand Master! I bear a message from Master Ponshu.','',0,0,0,0,0,0,0,0,0,41849,0,0,26124),
(117118,'It is my honor to fight with you, Archdruid. Together, we will protect the balance of nature.','',0,0,0,0,0,0,0,0,0,0,66768,0,26124),
(117119,'I will stand by you, Archdruid. Let us fight for Azeroth!','',0,0,0,0,0,0,2,0,0,0,66769,0,26124),
(117120,'Yay! I like you... let\'s fight lots of enemies together!','',0,0,0,0,0,0,0,0,0,0,66740,0,26124),
(117121,'My strength is yours, Archdruid. Together, we will protect the wilds.','',0,0,0,0,0,0,2,0,0,0,66754,0,26124),
(117122,'','Ooooh! Let me give you a big hug! We\'re going to save so many creatures together!',0,0,0,0,0,0,0,0,0,0,0,66772,26124),
(117124,'','I will call upon Elune to restore the injured and resurrect the fallen. Thank you, Archdruid.',0,0,0,0,0,0,2,0,0,0,0,66762,26124),
(117125,'','My claws are sharpened and I\'m ready to hunt.  Dey won\'t even see me comin\'.',0,0,0,0,0,0,11,0,0,0,0,66804,26124),
(117126,'','There you go. These treants are ready for battle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117127,'$ct, we have all watched in awe as you cut a swath through our foes with your ancient weapon.','',0,0,0,0,0,0,0,0,0,0,68712,0,26124),
(117128,'','I trained to be a warrior when I was young... That seems like a lifetime ago, now. I\'m still pretty decent with a sword, though!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117129,'I would be glad to lend my skills to the order, Archdruid. I have heard great things about you.','',0,0,0,0,0,0,2,0,0,0,66744,0,26124),
(117130,'By infusing the resources you\'ve gathered with the souls you\'ve claimed, the forge will unlock the true potential of your weapon\'s destructive might!','',0,0,0,0,0,0,0,0,0,0,68713,0,26124),
(117131,'','I have studied many forms of magic from many sources. And while each believes that their way is the best, I can tell you that they are more alike than different.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117132,'It is done! Against your strength, the Legion will surely fall!','',0,0,0,0,0,0,4,0,0,0,68714,0,26124),
(117133,'','There\'s nothing \"exotic\" about fel magic!',0,0,0,0,0,0,0,0,0,0,0,66482,26124),
(117134,'','Archdruid, I bring you a message from the Circle!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117135,'Ever have you been a fierce defender of the wilds. The skill with which you wield your ancient weapon proves you worthy to be our champion.','',0,0,0,0,0,0,0,0,0,0,68721,0,26124),
(117136,'Now, through the victories you\'ve achieved and the resources you\'ve gathered, we can awaken your artifact\'s full potential.','',0,0,0,0,0,0,0,0,0,0,68722,0,26124),
(117137,'','Death by sword or death by spells, it\'s all the same to me!',0,0,0,0,0,0,0,0,0,0,0,66474,26124),
(117138,'All done, friend? Good, good! Calydus open portal for you. Back to Dalaran, quick, quick!','',0,0,0,0,0,0,0,0,0,0,66436,0,26124),
(117139,'','The Burning Legion killed my family. Die!',0,0,0,0,0,0,0,0,0,0,0,67683,26124),
(117140,'Let the Seed of Ages infuse your weapon with power! Watch it grow mightier than ever before!','',0,0,0,0,0,0,0,0,0,0,68723,0,26124),
(117141,'','I\'m just as good with a sword as I am with spells. Any preference?',0,0,0,0,0,0,0,0,0,0,0,67684,26124),
(117142,'Gurglll... wait, oh! Hey. Careful out here, those naga aren\'t friendly. They\'ve been enslaving this nearby Shaolfin murloc tribe. This refuge is all they have left against the incursion. We could really use your help!\n\nOne more thing... if you find any of those Timeworn Artifacts the naga are carrying, mind bringing them back to me? I need them for my research. It\'ll be worth it, I promise!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117143,'Take all of the Timeworn Artifacts I have on me!','Take all of the Timeworn Artifacts I have on me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117144,'Master, I have a message for you from Altruis.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117145,'They will be upon us shortly. I can teleport us somewhere safe.','',0,0,0,0,0,0,1,0,0,0,66388,0,26124),
(117146,'Master, I have a message for you from Kayn.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117147,'','I could use my sword, but I\'d hate to dull it on the likes of you.',0,0,0,0,0,0,0,0,0,0,0,67685,26124),
(117148,'Greetings, $ct. Throughout the campaign against the Legion, we have witnessed your affinity with the weapon you wield grow stronger.','',0,0,0,0,0,0,0,0,0,0,69020,0,26124),
(117149,'Using the resources you\'ve gathered for our cause, we now have the means to awaken the full potential of these ancient blades!','',0,0,0,0,0,0,0,0,0,0,68717,0,26124),
(117150,'Greetings, $ct. Throughout the campaign against the Legion, we have witnessed your affinity with the weapon you wield grow stronger.','',0,0,0,0,0,0,0,0,0,0,68715,0,26124),
(117151,'Using the resources you\'ve gathered for our cause, we now have the means to awaken the full potential of these ancient blades!','',0,0,0,0,0,0,0,0,0,0,68716,0,26124),
(117153,'We of the Black Harvest have been admiring your skill, Netherlord. To master a weapon of such considerable power is truly inspiring!','',0,0,0,0,0,0,0,0,0,0,68748,0,26124),
(117154,'Through the demons you\'ve subjugated and the resources you\'ve obtained, we have the means to perform a ritual that will awaken your artifact\'s dark destiny!','',0,0,0,0,0,0,0,0,0,0,68749,0,26124),
(117155,'Raise your weapon before the Felblood Altar. Watch as its dread energies infuse your weapon with infernal might!','',0,0,0,0,0,0,0,0,0,0,68750,0,26124),
(117156,'Your choice to seek out that artifact you wield has borne fruit. I\'m not sure I\'ve ever seen so close a bond between mage and weapon.','',0,0,0,0,0,0,0,0,0,0,68728,0,26124),
(117158,'The victories you\'ve achieved for the Tirisgarde, along with the resources you\'ve gained, shall allow us to unlock the artifact\'s full potential.','',0,0,0,0,0,0,0,0,0,0,68729,0,26124),
(117159,'Raise your weapon before the Forge of the Guardian. Let it infuse your weapon with might!','',0,0,0,0,0,0,0,0,0,0,68730,0,26124),
(117160,'Farseer, I have a message for you from Nobundo.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117161,'Our evac is almost here. We have to warn the Alliance and Horde.','',0,0,0,0,0,0,0,0,6,0,69486,0,26124),
(117162,'$ct, the spirits have watched the bond between you and your ancient weapon grow stronger.','',0,0,0,0,0,0,0,0,0,0,68744,0,26124),
(117163,'They must turn their fleets around. The Broken Shore is a deathtrap.','',0,0,0,0,0,0,0,0,6,0,69487,0,26124),
(117164,'They have shown us a way to harness the resources you\'ve gathered to unlock the the artifact\'s true potential.','',0,0,0,0,0,0,0,0,0,0,68745,0,26124),
(117165,'Raise your weapon to the skies, Farseer. Let the spirits of earth, air, fire, and water aid their champion\'s cause!','',0,0,0,0,0,0,0,0,0,0,68746,0,26124),
(117166,'The lifeblood of Azeroth flows through your weapon! May you wield it with wisdom against our foes!','',0,0,0,0,0,0,0,0,0,0,68747,0,26124),
(117167,'Anything, lieutenant?','',0,0,0,0,0,0,0,0,6,0,69488,0,26124),
(117168,'','$ct, I have a message for you from Bishop Faol.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117169,'Welcome, $ct. In the course of your service to the Conclave, we have witnessed your bond with the ancient weapon you hold grow stronger.','',0,0,0,0,0,0,0,0,0,0,68737,0,26124),
(117170,'','The island is crawling with demons. Far more than we anticip...',0,0,0,0,0,0,0,0,6,0,0,69489,26124),
(117171,'The battles you\'ve won and the resources you\'ve gathered have shown us a way to awaken the full potential of your artifact.','',0,0,0,0,0,0,0,0,0,0,68738,0,26124),
(117172,'','Use the Raven\'s Eye. Decipher the code in the SI:7 letter, $n.',0,0,0,0,0,0,0,0,0,0,0,69490,26124),
(117173,'As long as our faith stays strong and you stand as our champion, the Burning Legion will never claim Azeroth!','',0,0,0,0,0,0,0,0,0,0,68740,0,26124),
(117174,'','Psst! Got a missive for you... straight from the Raven himself!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117175,'In our line of work, we tend to develop a fondness for the tools of our trade. But your affinity for those blades is like nothing we\'ve seen before.','',0,0,0,0,0,0,0,0,0,0,68741,0,26124),
(117176,'The resources you\'ve gathered across the Broken Isles will allow us to unlock even greater killing potential in your weapons.','',0,0,0,0,0,0,0,0,0,0,68742,0,26124),
(117177,'So, you have uncovered our little secret.','',0,0,0,0,0,0,0,0,6,0,69491,0,26124),
(117178,'Raise your weapons before the Crucible of the Uncrowned. Watch as it does its work, infusing your blades with deadly power!','',0,0,0,0,0,0,0,0,0,0,68743,0,26124),
(117179,'','Although you have walked the lonely road for but a short while, your bond with the ancient weapon you wield grows ever stronger.',0,0,0,0,0,0,0,0,0,0,0,68724,26124),
(117180,'','Through the victories you\'ve achieved and the resources you\'ve gathered, we now have the means to unlock the artifact\'s full potential.',0,0,0,0,0,0,0,0,0,0,0,68725,26124),
(117181,'','All hail the $ct! May your aim never falter and your weapon strike true!',0,0,0,0,0,0,0,0,0,0,0,68727,26124),
(117182,'$ct! The weapon you wield on behalf of the Silver Hand is truly a wondrous instrument of righteous retribution!','',0,0,0,0,0,0,0,0,0,0,68734,0,26124),
(117183,'Through the victories achieved and resources gathered in your crusade against the darkness, we have the means to unlock even greater potency in your armament!','',0,0,0,0,0,0,0,0,0,0,68735,0,26124),
(117184,'Behold as the Altar of Ancient Kings infuses the artifact you wield with power, making it mightier than ever before!','',0,0,0,0,0,0,0,0,0,0,68736,0,26124),
(117185,'Over the long ages of my watch, rarely have I seen a warrior so in tune with a weapon. It is as if your very blood flows through its steel.','',0,0,0,0,0,0,0,0,0,0,68752,0,26124),
(117186,'Your glorious campaign in the Broken Isles has yielded victories and resources that can reforge your weapon, awakening its true potential.','',0,0,0,0,0,0,0,0,0,0,68753,0,26124),
(117187,'Here, before the Forge of Odyn, you will see your ancient artifact reshaped to become mightier than ever before!','',0,0,0,0,0,0,0,0,0,0,68754,0,26124),
(117188,'Now you hold a weapon truly worthy of my war bringer! May you continue to bring honor and glory to the Valarjar!','',0,0,0,0,0,0,0,0,0,0,68755,0,26124),
(117189,'Let me assure you, your precious fleets will fall into our trap.','',0,0,0,0,0,0,0,0,6,0,69492,0,26124),
(117190,'You\'ll never get away with it, Detheroc!','',0,0,0,0,0,0,0,0,6,0,69493,0,26124),
(117191,'Oh, but I will. And you, Mathias Shaw, will help us to do it.','',0,0,0,0,0,0,0,0,6,0,69494,0,26124),
(117192,'Now I am the leader of SI:7!','',0,0,0,0,0,0,0,0,6,0,69495,0,26124),
(117193,'What do you have for sale?','What do you have for sale?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(117194,'You\'ll find Lorin in the square. Sylessa frequents the canals. Just search the bazaar for Cyrille. They\'ll catch your eye.','',0,0,0,0,0,0,0,0,0,0,66207,0,26124),
(117195,'','Shalas\'aman would never have wished to exist as an agent of corruption. The Dreamweavers mourn his loss, but rejoice that his torment is at an end.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117196,'The Legion approaches! Muster your strength and ready your incantations, for war has arrived!','',0,0,0,0,0,0,22,0,0,0,67703,0,26124),
(117197,'Do not waver! Bring them down!','',0,0,0,0,0,0,22,0,0,0,67705,0,26124),
(117198,'Enjoy yourself at the party? I heard it was a scandalous affair.','',0,0,0,0,0,0,0,0,0,0,66208,0,26124),
(117199,'Their strength surges! Whether you fight for god, king, or gold, take them down!','',0,0,0,0,0,0,22,0,0,0,67708,0,26124),
(117200,'Muster your might! Focus your attacks! Bring down this foul creature at once!','',0,0,0,0,0,0,22,0,0,0,67711,0,26124),
(117201,'Our fight continues, allies. Spread out! Purge these demons from Hillsbrad!','',0,0,0,0,0,0,22,0,0,0,67714,0,26124),
(117202,'Pleasure doing business with you.','',0,0,0,0,0,0,0,0,0,0,66209,0,26124),
(117203,'Heroes of Azeroth! If you ever loved Hillsbrad, whether in years past or this day, stand and fight!','',0,0,0,0,0,0,22,0,0,0,67717,0,26124),
(117204,'Draw forth your power, whether magic or might! Send the demon back to the Nether!','',0,0,0,0,0,0,22,0,0,0,67720,0,26124),
(117205,'In saving Tarren Mill, you defended all of Lordaeron. Savor our victory, but remember... this was only the beginning!','',0,0,0,0,0,0,22,0,0,0,67723,0,26124),
(117206,'Hurry back!','Hurry back!',0,0,0,0,0,0,0,0,0,0,0,65945,26124),
(117207,'I must get back.','I must get back.',0,0,0,0,0,0,0,0,0,0,0,65946,26124),
(117208,'I will not last long out here.','I will not last long out here.',0,0,0,0,0,0,0,0,0,0,0,65971,26124),
(117209,'You need my help?','',0,0,0,0,0,0,0,0,0,0,66172,0,26124),
(117210,'Our jewelry is second to none.','',0,0,0,0,0,0,0,0,0,0,66173,0,26124),
(117211,'My work is second to none.','',0,0,0,0,0,0,0,0,0,0,66070,0,26124),
(117212,'Each of my pieces is impeccable. Even the ones made by my apprentice.','',0,0,0,0,0,0,0,0,0,0,66071,0,26124),
(117213,'Keep your voice down.','Keep your voice down.',0,0,0,0,0,0,0,0,0,0,65767,0,26124),
(117214,'I cannot draw any attention.','I cannot draw any attention.',0,0,0,0,0,0,0,0,0,0,65768,0,26124),
(117215,'I know I can count on you.','I know I can count on you.',0,0,0,0,0,0,0,0,0,0,65769,0,26124),
(117216,'We are depending on your success.','We are depending on your success.',0,0,0,0,0,0,0,0,0,0,65770,0,26124),
(117217,'Do hurry...','',0,0,0,0,0,0,0,0,0,0,66072,0,26124),
(117218,'Do return soon, perhaps as a customer?','',0,0,0,0,0,0,0,0,0,0,66073,0,26124),
(117219,'','Let us explore downstairs. Watch your step.',0,0,0,0,0,0,0,0,0,0,0,67388,26124),
(117220,'','Much better.',0,0,0,0,0,0,0,0,0,0,0,67386,26124),
(117221,'','Strange. The floor looks like... a map?',0,0,0,0,0,0,0,0,0,0,0,67389,26124),
(117222,'','One thing is certain - leyline energy is being fed into this chamber from elsewhere.',0,0,0,0,0,0,0,0,0,0,0,67391,26124),
(117223,'','Hello. Have you found anything interesting lately?',1,0,0,0,0,0,0,0,0,0,0,67686,26124),
(117224,'','Greetings. What\'s new?',1,0,0,0,0,0,0,0,0,0,0,67687,26124),
(117225,'','Yes?',1,0,0,0,0,0,0,0,0,0,0,71130,26124),
(117226,'The Valarjar await.','The Valarjar await.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117227,'Do you require a squire?','Do you require a squire?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117228,'','We were on the Broken Shore mere hours before the Alliance and Horde fleets arrived.',0,0,0,0,0,0,0,0,6,0,0,71650,26124),
(117229,'Its... Elementary...','Its... Elementary...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117230,'Archers ready!','Archers ready!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117231,'The Forest lives and breathes as one.','The Forest lives and breathes as one.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117232,'A worthy opponent!','',0,0,0,0,0,0,0,0,0,0,67075,0,26124),
(117233,'I\'m ready!','',0,0,0,0,0,0,0,0,0,0,67076,0,26124),
(117234,'I will need a drink after this!','',0,0,0,0,0,0,0,0,0,0,67077,0,26124),
(117235,'...and stay down!','',0,0,0,0,0,0,0,0,0,0,67078,0,26124),
(117236,'A good fight.','',0,0,0,0,0,0,0,0,0,0,67079,0,26124),
(117237,'Let us drink to victory!','',0,0,0,0,0,0,0,0,0,0,67080,0,26124),
(117238,'I need a... minute to recover.','',0,0,0,0,0,0,0,0,0,0,67081,0,26124),
(117239,'That really... hurts.','',0,0,0,0,0,0,0,0,0,0,67082,0,26124),
(117240,'Ugghh...','',0,0,0,0,0,0,0,0,0,0,67083,0,26124),
(117241,'','Don\'t worry, I\'ve got your back!',0,0,0,0,0,0,0,0,0,0,0,67084,26124),
(117242,'','This will help!',0,0,0,0,0,0,0,0,0,0,0,67085,26124),
(117243,'','I\'ve got just what you need!',0,0,0,0,0,0,0,0,0,0,0,67086,26124),
(117244,'This nasty wikket gonna get it!','',0,0,0,0,0,0,0,0,0,0,67214,0,26124),
(117245,'Silly wikket pick a fight? This grookin\'s gonna last all night!','',0,0,0,0,0,0,0,0,0,0,67215,0,26124),
(117246,'Is this wikket bammin\'? \'Cause heads I be slammin\'!','',0,0,0,0,0,0,0,0,0,0,67216,0,26124),
(117247,'This here ooker is beat! Victory sure be sweet!','',0,0,0,0,0,0,0,0,0,0,67217,0,26124),
(117248,'Woo-hoo-hoo! We won! Grookin\' dookers be fun!','',0,0,0,0,0,0,0,0,0,0,67218,0,26124),
(117249,'An ookin\' good fight! Served them dookers right!','',0,0,0,0,0,0,0,0,0,0,67219,0,26124),
(117250,'That ookin\' hurt! King\'s face in the dirt!','',0,0,0,0,0,0,0,0,0,0,67220,0,26124),
(117251,'Wikket grooked the King! What a terrible thing!','',0,0,0,0,0,0,0,0,0,0,67221,0,26124),
(117252,'That\'s it! The King\'s done. Gettin\' grooked is no fun!','',0,0,0,0,0,0,0,0,0,0,67222,0,26124),
(117253,'They never saw it coming.','',0,0,0,0,0,0,0,0,0,0,67087,0,26124),
(117254,'The element of surprise is on our side!','',0,0,0,0,0,0,0,0,0,0,67088,0,26124),
(117255,'Strike hard, strike fast!','',0,0,0,0,0,0,0,0,0,0,67089,0,26124),
(117256,'','I\'m going to kick your butt',0,0,0,0,0,0,0,0,0,0,0,67090,26124),
(117257,'','Aye, this will be good!',0,0,0,0,0,0,0,0,0,0,0,67091,26124),
(117258,'','We\'ve got this!',0,0,0,0,0,0,0,0,0,0,0,67092,26124),
(117259,'','You were ugly.  Now you\'re dead ugly.',0,0,0,0,0,0,0,0,0,0,0,67093,26124),
(117260,'','Our ancestors would be proud.',0,0,0,0,0,0,0,0,0,0,0,67094,26124),
(117261,'','You better stay dead.',0,0,0,0,0,0,0,0,0,0,0,67095,26124),
(117262,'','Get\'em, Stormbeak!',0,0,0,0,0,0,0,0,0,0,0,67096,26124),
(117263,'','Tear them apart, girl!',0,0,0,0,0,0,0,0,0,0,0,67097,26124),
(117264,'','Me gryphon\'s itchin\' fer a fight!',0,0,0,0,0,0,0,0,0,0,0,67098,26124),
(117265,'','This lass is hurt... you go on.',0,0,0,0,0,0,0,0,0,0,0,67099,26124),
(117266,'','Agghh...',0,0,0,0,0,0,0,0,0,0,0,67100,26124),
(117267,'','Uggh...  That did some damage...',0,0,0,0,0,0,0,0,0,0,0,67101,26124),
(117268,'For the Alliance!','',0,0,0,0,0,0,71,0,0,0,66547,0,26124),
(117269,'Let the elements flow through you!','',0,0,0,0,0,0,0,0,0,0,67102,0,26124),
(117270,'The primal waters cleanse all!','',0,0,0,0,0,0,0,0,0,0,67103,0,26124),
(117271,'The tides are eternal!','',0,0,0,0,0,0,0,0,0,0,67104,0,26124),
(117272,'Looks like you need assistance, friend.','',0,0,0,0,0,0,0,0,0,0,67105,0,26124),
(117273,'The Earthen Ring stands with you!','',0,0,0,0,0,0,0,0,0,0,67106,0,26124),
(117274,'The Elements have spoken!','',0,0,0,0,0,0,0,0,0,0,67107,0,26124),
(117275,'Before you stands a true champion who has won many great victories in the name of the Alliance.','',0,0,0,0,0,0,396,0,0,0,66544,0,26124),
(117276,'This is what we\'ve trained for!','',0,0,0,0,0,0,0,0,0,0,67108,0,26124),
(117277,'Unleash your fury!','',0,0,0,0,0,0,0,0,0,0,67109,0,26124),
(117278,'The elements will crush you!','',0,0,0,0,0,0,0,0,0,0,67110,0,26124),
(117279,'Our enemies perish!','',0,0,0,0,0,0,0,0,0,0,67111,0,26124),
(117280,'None shall stop us.','',0,0,0,0,0,0,0,0,0,0,67112,0,26124),
(117281,'No one stands in our way.','',0,0,0,0,0,0,0,0,0,0,67113,0,26124),
(117282,'I can\'t go on...','',0,0,0,0,0,0,0,0,0,0,67114,0,26124),
(117283,'The ancient weapon they wield is a symbol of hope to those we have sworn to protect.','',0,0,0,0,0,0,396,0,0,0,66545,0,26124),
(117284,'I am wounded... Go on without me!','',0,0,0,0,0,0,0,0,0,0,67115,0,26124),
(117285,'I will recover.','',0,0,0,0,0,0,0,0,0,0,67116,0,26124),
(117286,'So come, friends, lend me your voices! Join me in honoring $p!','',0,0,0,0,0,0,396,0,0,0,66546,0,26124),
(117287,'Stay right where you are!','',0,0,0,0,0,0,0,0,0,0,67117,0,26124),
(117288,'You\'re not going anywhere!','',0,0,0,0,0,0,0,0,0,0,67118,0,26124),
(117289,'Why don\'t you... stay a while?!','',0,0,0,0,0,0,0,0,0,0,67119,0,26124),
(117290,'This is beneath me.','',0,0,0,0,0,0,0,0,0,0,67120,0,26124),
(117291,'You will burn!','',0,0,0,0,0,0,0,0,0,0,67121,0,26124),
(117292,'I will leave but cinders!','',0,0,0,0,0,0,0,0,0,0,67122,0,26124),
(117293,'Our enemies turn to ash!','',0,0,0,0,0,0,0,0,0,0,67123,0,26124),
(117294,'All shall burn!','',0,0,0,0,0,0,0,0,0,0,67124,0,26124),
(117295,'My fire consumes all.','',0,0,0,0,0,0,0,0,0,0,67125,0,26124),
(117296,'A minor... setback... ugggh....','',0,0,0,0,0,0,0,0,0,0,67126,0,26124),
(117297,'Arrrgghh...','',0,0,0,0,0,0,0,0,0,0,67127,0,26124),
(117298,'I am hurt... go on... without me.','',0,0,0,0,0,0,0,0,0,0,67128,0,26124),
(117299,'','Let\'s see what\'s in the bag, shall we?',0,0,0,0,0,0,0,0,0,0,0,67129,26124),
(117300,'','Boy, I\'m feeling lucky today!',0,0,0,0,0,0,0,0,0,0,0,67130,26124),
(117301,'','The darkness gives us strength!  Well... at least sometimes it does!',0,0,0,0,0,0,0,0,0,0,0,67131,26124),
(117302,'','Shadows engulf you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117303,'','The darkness will swallow you whole!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117304,'','Fire consumes you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117305,'','My fire burns eternal!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117306,'Sleep now...','',0,0,0,0,0,0,0,0,0,0,67136,0,26124),
(117307,'You cannot resist!  Sleep!','',0,0,0,0,0,0,0,0,0,0,67137,0,26124),
(117308,'Hush now...  The Dream beckons!','',0,0,0,0,0,0,0,0,0,0,67138,0,26124),
(117309,'I am nature\'s rage!','',0,0,0,0,0,0,0,0,0,0,67139,0,26124),
(117310,'I will tear you to shreds!','',0,0,0,0,0,0,0,0,0,0,67140,0,26124),
(117311,'Hardly a match for our strength!','',0,0,0,0,0,0,0,0,0,0,67141,0,26124),
(117312,'Nature\'s foes shall perish.','',0,0,0,0,0,0,0,0,0,0,67142,0,26124),
(117313,'Ours is the strength of the wild.','',0,0,0,0,0,0,0,0,0,0,67143,0,26124),
(117314,'Do not cross nature\'s guardians.','',0,0,0,0,0,0,0,0,0,0,67144,0,26124),
(117315,'I will recover... with time.','',0,0,0,0,0,0,0,0,0,0,67145,0,26124),
(117316,'Arrrgghh...','',0,0,0,0,0,0,0,0,0,0,67146,0,26124),
(117317,'I must... stay back for now...','',0,0,0,0,0,0,0,0,0,0,67147,0,26124),
(117318,'','We\'ve got this!',0,0,0,0,0,0,0,0,0,0,0,67148,26124),
(117319,'','Is there trouble?',0,0,0,0,0,0,0,0,0,0,0,67149,26124),
(117320,'','Nature is on our side!',0,0,0,0,0,0,0,0,0,0,0,67150,26124),
(117321,'Feel nature\'s wrath!','',0,0,0,0,0,0,0,0,0,0,67151,0,26124),
(117322,'I am nature\'s guardian.','',0,0,0,0,0,0,0,0,0,0,67152,0,26124),
(117323,'The wilds grant me strength!','',0,0,0,0,0,0,0,0,0,0,67153,0,26124),
(117324,'Death to our enemies!','',0,0,0,0,0,0,0,0,0,0,67154,0,26124),
(117325,'Never surrender!','',0,0,0,0,0,0,0,0,0,0,67155,0,26124),
(117326,'The Illidari cannot be stopped!','',0,0,0,0,0,0,0,0,0,0,67156,0,26124),
(117327,'I\'ve got your back!','',0,0,0,0,0,0,0,0,0,0,67157,0,26124),
(117328,'I fight by your side!','',0,0,0,0,0,0,0,0,0,0,67158,0,26124),
(117329,'You do not fight alone!','',0,0,0,0,0,0,0,0,0,0,67159,0,26124),
(117330,'Attack!','',0,0,0,0,0,0,0,0,0,0,67160,0,26124),
(117331,'Strike fast, enemies are near!','',0,0,0,0,0,0,0,0,0,0,67161,0,26124),
(117332,'I will strike swiftly!','',0,0,0,0,0,0,0,0,0,0,67162,0,26124),
(117333,'It is good to fight by your side.','',0,0,0,0,0,0,0,0,0,0,67163,0,26124),
(117334,'A swift death.','',0,0,0,0,0,0,0,0,0,0,67164,0,26124),
(117335,'Our enemies cannot stop us.','',0,0,0,0,0,0,0,0,0,0,67165,0,26124),
(117336,'I am hurt...  go on... without me.','',0,0,0,0,0,0,0,0,0,0,67166,0,26124),
(117337,'Agghh...','',0,0,0,0,0,0,0,0,0,0,67167,0,26124),
(117338,'Urghh... I must... retreat...','',0,0,0,0,0,0,0,0,0,0,67168,0,26124),
(117339,'My hatred burns!','',0,0,0,0,0,0,0,0,0,0,67169,0,26124),
(117340,'My soul... consumed by hate!','',0,0,0,0,0,0,0,0,0,0,67170,0,26124),
(117341,'My anger is... uncontrollable!','',0,0,0,0,0,0,0,0,0,0,67171,0,26124),
(117342,'It is too quiet here. I have a bad feeling...','',1,0,0,0,0,0,0,0,0,0,68087,0,26124),
(117343,'Die!','',0,0,0,0,0,0,0,0,0,0,67172,0,26124),
(117344,'I envy your fate.','',0,0,0,0,0,0,0,0,0,0,67173,0,26124),
(117345,'I bring death!','',0,0,0,0,0,0,0,0,0,0,67174,0,26124),
(117346,'I can\'t go on... release me!','',0,0,0,0,0,0,0,0,0,0,67175,0,26124),
(117347,'Hurggghh...','',0,0,0,0,0,0,0,0,0,0,67176,0,26124),
(117348,'Why do you... do this... to me?','',0,0,0,0,0,0,0,0,0,0,67177,0,26124),
(117349,'Moving in to strike!','',0,0,0,0,0,0,0,0,0,0,67178,0,26124),
(117350,'I move swiftly.','',0,0,0,0,0,0,0,0,0,0,67179,0,26124),
(117351,'','Spiders!',15,0,0,0,0,0,0,0,0,0,0,68097,26124),
(117352,'My blades are ready!','',0,0,0,0,0,0,0,0,0,0,67180,0,26124),
(117353,'We cannot be stopped.','',0,0,0,0,0,0,0,0,0,0,67181,0,26124),
(117354,'Another falls by our hand.','',0,0,0,0,0,0,0,0,0,0,67182,0,26124),
(117355,'Death to our enemies!','',0,0,0,0,0,0,0,0,0,0,67183,0,26124),
(117356,'My wounds... are too deep...','',0,0,0,0,0,0,0,0,0,0,67184,0,26124),
(117357,'Arghh...','',0,0,0,0,0,0,0,0,0,0,67185,0,26124),
(117358,'I\'m down!','',0,0,0,0,0,0,0,0,0,0,67186,0,26124),
(117359,'I think one fell on my head! Get it off!','',15,0,0,0,0,0,0,0,0,0,68110,0,26124),
(117360,'','A simple task.',0,0,0,0,0,0,0,0,0,0,0,67187,26124),
(117361,'','You called?',0,0,0,0,0,0,0,0,0,0,0,67188,26124),
(117362,'','Your wish is my command.',0,0,0,0,0,0,0,0,0,0,0,67189,26124),
(117363,'','You cannot hide from the Unseen Path!',0,0,0,0,0,0,0,0,0,0,0,67190,26124),
(117364,'','Snowfeather! Attack!',0,0,0,0,0,0,0,0,0,0,0,67191,26124),
(117365,'','Get them, Snowfeather!',0,0,0,0,0,0,0,0,0,0,0,67192,26124),
(117366,'This is a city for the dead. I was hoping for quiet.','',0,0,0,0,0,0,0,0,0,0,65626,0,26124),
(117367,'I will hunt you down!','',0,0,0,0,0,0,0,0,0,0,67193,0,26124),
(117368,'Let the hunt begin!','',0,0,0,0,0,0,0,0,0,0,67194,0,26124),
(117369,'You can\'t escape!','',0,0,0,0,0,0,0,0,0,0,67195,0,26124),
(117370,'Perhaps I will find redemption here.','',0,0,0,0,0,0,0,0,0,0,65627,0,26124),
(117371,'A clean kill.','',0,0,0,0,0,0,0,0,0,0,67196,0,26124),
(117372,'Well done!','',0,0,0,0,0,0,0,0,0,0,67197,0,26124),
(117373,'A good kill.','',0,0,0,0,0,0,0,0,0,0,67198,0,26124),
(117374,'I will heal...  in time...','',0,0,0,0,0,0,0,0,0,0,67199,0,26124),
(117375,'Arghh....','',0,0,0,0,0,0,0,0,0,0,67200,0,26124),
(117376,'I must stay back...','',0,0,0,0,0,0,0,0,0,0,67201,0,26124),
(117377,'','I\'m a real hunter now!',0,0,0,0,0,0,0,0,0,0,0,67202,26124),
(117378,'There can be no progress without sacrifice.','',0,0,0,0,0,0,0,0,0,0,66084,0,26124),
(117379,'','Let\'s get\'em!',0,0,0,0,0,0,0,0,0,0,0,67203,26124),
(117380,'','I\'ve got this one!',0,0,0,0,0,0,0,0,0,0,0,67204,26124),
(117381,'','We did it!',0,0,0,0,0,0,0,0,0,0,0,67205,26124),
(117382,'','That was exciting!',0,0,0,0,0,0,0,0,0,0,0,67206,26124),
(117383,'I am looking for an assistant. I suppose you will do.','',0,0,0,0,0,0,0,0,0,0,66085,0,26124),
(117384,'','You better stay dead.',0,0,0,0,0,0,0,0,0,0,0,67207,26124),
(117385,'','Ungghhh...  Don\'t worry about me... I\'ll catch up... I think.',0,0,0,0,0,0,0,0,0,0,0,67208,26124),
(117386,'','Ahhhh... that... hurts... so... much...',0,0,0,0,0,0,0,0,0,0,0,67209,26124),
(117387,'','Hmph... I need to recover.  You go on!',0,0,0,0,0,0,0,0,0,0,0,67210,26124),
(117388,'Tread carefully on this hallowed place.','',0,0,0,0,0,0,0,0,0,0,65628,0,26124),
(117389,'A clean shot!','',0,0,0,0,0,0,0,0,0,0,67211,0,26124),
(117390,'I\'ve got the target in my sights!','',0,0,0,0,0,0,0,0,0,0,67212,0,26124),
(117391,'Go, then. Do what you can.','',0,0,0,0,0,0,0,0,0,0,65629,0,26124),
(117392,'This one counts as my kill!','',0,0,0,0,0,0,0,0,0,0,67213,0,26124),
(117393,'','You are no match for the Tirisgarde!',0,0,0,0,0,0,0,0,0,0,0,67992,26124),
(117394,'','Crumble before our power!',0,0,0,0,0,0,0,0,0,0,0,67993,26124),
(117395,'','Witness the power of an Archmage!',0,0,0,0,0,0,0,0,0,0,0,67994,26124),
(117396,'','Our enemies fall!',0,0,0,0,0,0,0,0,0,0,0,67995,26124),
(117397,'','Hardly a challenge!',0,0,0,0,0,0,0,0,0,0,0,67996,26124),
(117398,'','We are victorious.  Just as I predicted.',0,0,0,0,0,0,0,0,0,0,0,67997,26124),
(117399,'','My wounds are deep... go on without me.',0,0,0,0,0,0,0,0,0,0,0,67998,26124),
(117400,'','Arrghghh!',0,0,0,0,0,0,0,0,0,0,0,67999,26124),
(117401,'','The pain is too much.  I need some time to recover!',0,0,0,0,0,0,0,0,0,0,0,68000,26124),
(117402,'Feel the wrath of Kalecgos!','',0,0,0,0,0,0,0,0,0,0,67989,0,26124),
(117403,'Tremble before me!','',0,0,0,0,0,0,0,0,0,0,67990,0,26124),
(117404,'Raawwwwr!!','',0,0,0,0,0,0,0,0,0,0,67991,0,26124),
(117405,'Go forth, and be quick about it!','',0,0,0,0,0,0,0,0,0,0,66086,0,26124),
(117406,'You face Millhouse the Magnificent!','',0,0,0,0,0,0,0,0,0,0,67900,0,26124),
(117407,'I will obliterate and disintegrate and exterminate and... did I say obliterate?','',0,0,0,0,0,0,0,0,0,0,67901,0,26124),
(117408,'This one\'s mine!','',0,0,0,0,0,0,0,0,0,0,67902,0,26124),
(117409,'I must unlock these secrets...','',0,0,0,0,0,0,0,0,0,0,66087,0,26124),
(117410,'I hardly broke a sweat!','',0,0,0,0,0,0,0,0,0,0,67903,0,26124),
(117411,'I\'ve killed cockroaches bigger than that!','',0,0,0,0,0,0,0,0,0,0,67904,0,26124),
(117412,'I can do this in my sleep!','',0,0,0,0,0,0,0,0,0,0,67905,0,26124),
(117413,'A most minor setback...  I must... catch my... breath.','',0,0,0,0,0,0,0,0,0,0,67906,0,26124),
(117414,'Aiggggghh!','',0,0,0,0,0,0,0,0,0,0,67907,0,26124),
(117415,'Am I bleeding?  Is that... blood?','',0,0,0,0,0,0,0,0,0,0,67899,0,26124),
(117416,'Over here, you nitwit!','',0,0,0,0,0,0,0,0,0,0,68001,0,26124),
(117417,'Looks can be deceiving!','',0,0,0,0,0,0,0,0,0,0,68002,0,26124),
(117418,'Hey! Over here! Hit me with your best shot!','',0,0,0,0,0,0,0,0,0,0,68003,0,26124),
(117419,'','Blood Knights!  Attack formation!',0,0,0,0,0,0,0,0,0,0,0,72776,26124),
(117420,'','Blood Knights!  On me!',0,0,0,0,0,0,0,0,0,0,0,70922,26124),
(117421,'','Charge!',0,0,0,0,0,0,0,0,0,0,0,70923,26124),
(117422,'Light give me strength!','',0,0,0,0,0,0,0,0,0,0,68497,0,26124),
(117423,'Justice is on our side!','',0,0,0,0,0,0,0,0,0,0,68498,0,26124),
(117424,'Fight with honor!','',0,0,0,0,0,0,0,0,0,0,68499,0,26124),
(117425,'Justice prevails!','',0,0,0,0,0,0,0,0,0,0,68500,0,26124),
(117426,'Victory is ours!','',0,0,0,0,0,0,0,0,0,0,68501,0,26124),
(117427,'We are victorious!','',0,0,0,0,0,0,0,0,0,0,68502,0,26124),
(117428,'My wounds... are too grave!','',0,0,0,0,0,0,0,0,0,0,68547,0,26124),
(117429,'Hmmmph...','',0,0,0,0,0,0,0,0,0,0,68548,0,26124),
(117430,'I will recover... go on without me!','',0,0,0,0,0,0,0,0,0,0,68549,0,26124),
(117431,'May the Light have mercy on your souls.','',0,0,0,0,0,0,0,0,0,0,68503,0,26124),
(117432,'The Light purifies everything!','',0,0,0,0,0,0,0,0,0,0,68504,0,26124),
(117433,'Nothing can hide from the Light!','',0,0,0,0,0,0,0,0,0,0,68505,0,26124),
(117434,'That was a LOT of spiders.','',1,0,0,0,0,0,0,0,0,0,68615,0,26124),
(117435,'For justice!','',0,0,0,0,0,0,0,0,0,0,68506,0,26124),
(117436,'For the Light!','',0,0,0,0,0,0,0,0,0,0,68507,0,26124),
(117437,'The Light smites our foes!','',0,0,0,0,0,0,0,0,0,0,68508,0,26124),
(117438,'One by one, our foes shall fall!','',0,0,0,0,0,0,0,0,0,0,68509,0,26124),
(117439,'Victory!','',0,0,0,0,0,0,0,0,0,0,68510,0,26124),
(117440,'The Light smiles upon us.','',0,0,0,0,0,0,0,0,0,0,68511,0,26124),
(117441,'','That was a LOT of spiders! I rather enjoyed tearing them apart.',1,0,0,0,0,0,0,0,0,0,0,68616,26124),
(117442,'Grievous wounds... I must recover...','',0,0,0,0,0,0,0,0,0,0,68550,0,26124),
(117443,'Unggh...','',0,0,0,0,0,0,0,0,0,0,68551,0,26124),
(117444,'I need to recover... Go on without me!','',0,0,0,0,0,0,0,0,0,0,68552,0,26124),
(117445,'','This should be good!',0,0,0,0,0,0,0,0,0,0,0,68512,26124),
(117446,'','I fear nothing!',0,0,0,0,0,0,0,0,0,0,0,68513,26124),
(117447,'','I will crush you!',0,0,0,0,0,0,0,0,0,0,0,68464,26124),
(117448,'','A glorious fight!',0,0,0,0,0,0,0,0,0,0,0,68514,26124),
(117449,'','Is that all you\'ve got?',0,0,0,0,0,0,0,0,0,0,0,68515,26124),
(117450,'','Die with honor!',0,0,0,0,0,0,0,0,0,0,0,68516,26124),
(117451,'','These wounds... I\'ll recover...',0,0,0,0,0,0,0,0,0,0,0,68553,26124),
(117452,'','Hmmmph...',0,0,0,0,0,0,0,0,0,0,0,68554,26124),
(117453,'','Hah... these will make... good... battle scars...',0,0,0,0,0,0,0,0,0,0,0,68555,26124),
(117454,'','In\'alah!',0,0,0,0,0,0,463,0,0,0,0,67385,26124),
(117455,'KROLMIR!!!!!','',0,0,0,0,0,0,0,0,0,0,68530,0,26124),
(117456,'THUNDER!  HEED MY CALL!!!!!','',0,0,0,0,0,0,0,0,0,0,68517,0,26124),
(117457,'FOR ODYN!!','',0,0,0,0,0,0,0,0,0,0,68518,0,26124),
(117458,'For Ulduar!','',0,0,0,0,0,0,0,0,0,0,68519,0,26124),
(117459,'To battle!','',0,0,0,0,0,0,0,0,0,0,68520,0,26124),
(117460,'Come and face me!','',0,0,0,0,0,0,0,0,0,0,68521,0,26124),
(117461,'Taste the might of iron!','',0,0,0,0,0,0,0,0,0,0,68522,0,26124),
(117462,'Fall before my iron will!','',0,0,0,0,0,0,0,0,0,0,68523,0,26124),
(117463,'The day is ours!','',0,0,0,0,0,0,0,0,0,0,68524,0,26124),
(117464,'I will recover... You go on...','',0,0,0,0,0,0,0,0,0,0,68556,0,26124),
(117465,'Arrrhghhh...','',0,0,0,0,0,0,0,0,0,0,68557,0,26124),
(117466,'A minor wound...','',0,0,0,0,0,0,0,0,0,0,68558,0,26124),
(117467,'Winds of the north consume you!','',0,0,0,0,0,0,0,0,0,0,68525,0,26124),
(117468,'Tremble before the northern winds!','',0,0,0,0,0,0,0,0,0,0,68526,0,26124),
(117469,'Feel the wrath of Hodir!','',0,0,0,0,0,0,0,0,0,0,68527,0,26124),
(117470,'','A hush falls over the chamber at the news of Mathias Shaw\'s fate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117471,'','This one\'s mine!',0,0,0,0,0,0,0,0,0,0,0,68528,26124),
(117472,'','No one crosses the Uncrowned!',0,0,0,0,0,0,0,0,0,0,0,68529,26124),
(117473,'','Let me show you how it\'s done!',0,0,0,0,0,0,0,0,0,0,0,68445,26124),
(117474,'','Die, scum!',0,0,0,0,0,0,0,0,0,0,0,68446,26124),
(117475,'','You call that a fight?',0,0,0,0,0,0,0,0,0,0,0,68447,26124),
(117476,'','I\'m just warming up!',0,0,0,0,0,0,0,0,0,0,0,68448,26124),
(117477,'','I\'m wounded... let me... catch my breath...',0,0,0,0,0,0,0,0,0,0,0,68533,26124),
(117478,'','Aaarghhh...',0,0,0,0,0,0,0,0,0,0,0,68532,26124),
(117479,'','No... I\'m not ready... to die...',0,0,0,0,0,0,0,0,0,0,0,68531,26124),
(117480,'','Allow me to even the odds!',0,0,0,0,0,0,0,0,0,0,0,68449,26124),
(117481,'','An assassin\'s work is never done!',0,0,0,0,0,0,0,0,0,0,0,68450,26124),
(117482,'','Need a hand?',0,0,0,0,0,0,0,0,0,0,0,68451,26124),
(117483,'We strike from the shadows!','',0,0,0,0,0,0,0,0,0,0,68452,0,26124),
(117484,'I\'m going in for the kill.','',0,0,0,0,0,0,0,0,0,0,68453,0,26124),
(117485,'By the numbers.','',0,0,0,0,0,0,0,0,0,0,68454,0,26124),
(117486,'There is no joy in killing... only in a job well done.','',0,0,0,0,0,0,0,0,0,0,68534,0,26124),
(117487,'Another falls by our hand.','',0,0,0,0,0,0,0,0,0,0,68465,0,26124),
(117488,'','Damn...',0,0,0,0,0,0,0,0,0,0,0,69496,26124),
(117489,'All will fear us... in time.','',0,0,0,0,0,0,0,0,0,0,68535,0,26124),
(117490,'I must retreat... temporarily...','',0,0,0,0,0,0,0,0,0,0,68536,0,26124),
(117491,'Urrrhghhh...','',0,0,0,0,0,0,0,0,0,0,68537,0,26124),
(117492,'That cut deep... I must recover.','',0,0,0,0,0,0,0,0,0,0,68538,0,26124),
(117493,'Target acquired.','',0,0,0,0,0,0,0,0,0,0,68455,0,26124),
(117494,'Leave no trace.','',0,0,0,0,0,0,0,0,0,0,68456,0,26124),
(117495,'Taking out the target.','',0,0,0,0,0,0,0,0,0,0,68457,0,26124),
(117496,'Your weakness is our strength!','',0,0,0,0,0,0,0,0,0,0,68458,0,26124),
(117497,'The tides of battle turn here!','',0,0,0,0,0,0,0,0,0,0,68459,0,26124),
(117498,'Surrender to the Ebon Blade!','',0,0,0,0,0,0,0,0,0,0,68460,0,26124),
(117499,'I\'m right by your side.','',0,0,0,0,0,0,0,0,0,0,68461,0,26124),
(117500,'We fight as one.','',0,0,0,0,0,0,0,0,0,0,68462,0,26124),
(117501,'The Ebon Blade stands together.','',0,0,0,0,0,0,0,0,0,0,68463,0,26124),
(117502,'Death to our enemies!','',0,0,0,0,0,0,0,0,0,0,68466,0,26124),
(117503,'The Ebon Blade prevails!','',0,0,0,0,0,0,0,0,0,0,68467,0,26124),
(117504,'I\'m just warming up!','',0,0,0,0,0,0,0,0,0,0,68468,0,26124),
(117505,'I\'m hurt... need to recover...','',0,0,0,0,0,0,0,0,0,0,68539,0,26124),
(117506,'Hmmrrghh...','',0,0,0,0,0,0,0,0,0,0,68540,0,26124),
(117507,'Go on without me... complete our... task...','',0,0,0,0,0,0,0,0,0,0,68541,0,26124),
(117508,'ROTTGUT ROTTGUT!!!','',0,0,0,0,0,0,0,0,0,0,68469,0,26124),
(117509,'ROTT GUT!!','',0,0,0,0,0,0,0,0,0,0,68470,0,26124),
(117510,'ROTTGUT!!!!','',0,0,0,0,0,0,0,0,0,0,68471,0,26124),
(117511,'Horsemen!  We ride!','',0,0,0,0,0,0,0,0,0,0,68472,0,26124),
(117512,'Cower before the Four Horsemen!','',0,0,0,0,0,0,0,0,0,0,68473,0,26124),
(117513,'Crush our enemies!','',0,0,0,0,0,0,0,0,0,0,68474,0,26124),
(117514,'','A\'dal!  Grant us strength!',0,0,0,0,0,0,0,0,0,0,0,68475,26124),
(117515,'','The Light shines upon us!',0,0,0,0,0,0,0,0,0,0,0,68476,26124),
(117516,'','The naaru are with us, always.',0,0,0,0,0,0,0,0,0,0,0,68477,26124),
(117517,'The shadows guide me.','',0,0,0,0,0,0,0,0,0,0,68478,0,26124),
(117518,'Give into madness!','',0,0,0,0,0,0,0,0,0,0,68479,0,26124),
(117519,'Your will is mine to bend!','',0,0,0,0,0,0,0,0,0,0,68480,0,26124),
(117520,'The shadows claim you.','',0,0,0,0,0,0,0,0,0,0,68481,0,26124),
(117521,'You\'re no match for my power.','',0,0,0,0,0,0,0,0,0,0,68482,0,26124),
(117522,'Death takes you!','',0,0,0,0,0,0,0,0,0,0,68483,0,26124),
(117523,'It\'s only a little pain... I\'ll catch up...','',0,0,0,0,0,0,0,0,0,0,68542,0,26124),
(117524,'Hggghh... unghhh... I\'ll be all right.','',0,0,0,0,0,0,0,0,0,0,68543,0,26124),
(117525,'Death... old friend... not today...','',0,0,0,0,0,0,0,0,0,0,68544,0,26124),
(117526,'We fight for the Light!','',0,0,0,0,0,0,0,0,0,0,68484,0,26124),
(117527,'I am Light incarnate!','',0,0,0,0,0,0,0,0,0,0,68485,0,26124),
(117528,'I cleanse this world!','',0,0,0,0,0,0,0,0,0,0,68486,0,26124),
(117529,'I defend the Light.','',0,0,0,0,0,0,0,0,0,0,68487,0,26124),
(117530,'The Light endures.','',0,0,0,0,0,0,0,0,0,0,68488,0,26124),
(117531,'We prevail.','',0,0,0,0,0,0,0,0,0,0,68489,0,26124),
(117532,'My light fades away...','',0,0,0,0,0,0,0,0,0,0,68545,0,26124),
(117533,'My power fades...','',0,0,0,0,0,0,0,0,0,0,68546,0,26124),
(117534,'I shall return..','',0,0,0,0,0,0,0,0,0,0,68490,0,26124),
(117535,'The Light topples our enemies!','',0,0,0,0,0,0,0,0,0,0,68491,0,26124),
(117536,'Our inner fire burns bright!','',0,0,0,0,0,0,0,0,0,0,68492,0,26124),
(117537,'Let the Light flow through you.','',0,0,0,0,0,0,0,0,0,0,68493,0,26124),
(117538,'','Worthless insects. You will beg for death before the end!',0,0,0,0,0,0,0,0,0,0,0,68617,26124),
(117539,'','So dark...',0,0,0,0,0,0,0,0,0,0,0,67384,26124),
(117540,'No! The stronghold must fall!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117541,'How helpless you must feel to watch your precious world crumble around you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117542,'You will learn your place, mortals.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117543,'Your existence means nothing! Prepare your last breath, mortals!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117544,'In the end, there is nothing...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117545,'Disease wears your enemy down while your strong melee attacks finish them off.','',0,0,0,0,0,0,1,0,0,0,64831,0,26124),
(117546,'But your greatest ally is death itself. Raise Dead will animate a corpse to serve as your ghoulish minion.','',0,0,0,0,0,0,1,0,0,0,64832,0,26124),
(117547,'You should always try to have a minion with you.','',0,0,0,0,0,0,25,0,0,0,64833,0,26124),
(117548,'Outbreak will deal damage over time and unleashes a Virulent Plague that spreads to nearby enemies.','',0,0,0,0,0,0,1,0,0,0,64834,0,26124),
(117549,'Festering Strike deals damage and inflicts Festering Wounds on your target.','',0,0,0,0,0,0,0,0,0,0,64835,0,26124),
(117550,'Festering Strike followed by Scourge Strike is a one-two punch few enemies can withstand.','',0,0,0,0,0,0,1,0,0,0,64836,0,26124),
(117551,'','And we are at the center...',0,0,0,0,0,0,0,0,0,0,0,67390,26124),
(117552,'Use Death and Decay to corrupt the ground beneath your feet, dealing damage to all foes in the affected area and empowering some of your attacks to hit additional targets.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117553,'Its dark power damages your foe and recovers a portion of your health.','',0,0,0,0,0,0,0,0,0,0,64837,0,26124),
(117554,'Death Grip allows you to reach out to a distant target and pull them toward you. No enemy can escape your icy grasp!','',0,0,0,0,0,0,1,0,0,0,64838,0,26124),
(117555,'Army of the Dead raises a swarm of ghouls to attack anything and everything near you.','',0,0,0,0,0,0,5,0,0,0,64840,0,26124),
(117556,'','Reinforcements from Undercity on approach!',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(117557,'','What could have required such power? A weapon, perhaps?',0,0,0,0,0,0,0,0,0,0,0,67392,26124),
(117558,'','And those keepers protecting it... How long their vigil must have been...',0,0,0,0,0,0,0,0,0,0,0,67393,26124),
(117559,'','<Sigh.> I have more questions now than before!',0,0,0,0,0,0,0,0,0,0,0,67394,26124),
(117560,'This powerful ability cannot be used often, so save it for an emergency.','',0,0,0,0,0,0,0,0,0,0,64842,0,26124),
(117561,'','It is a perfect refuge. A temporary home, until I can return to Suramar.',0,0,0,0,0,0,0,0,0,0,0,67397,26124),
(117562,'','But first, I will need allies.',0,0,0,0,0,0,0,0,0,0,0,67398,26124),
(117563,'|TInterface\\Icons\\ability_siege_engineer_overload:20|tRax\'s shredder goes |cFFFF0404|Hspell:219614|h[Haywire!]|h|r Leap to the zeppelin!','|TInterface\\Icons\\ability_siege_engineer_overload:20|tRax\'s shredder goes |cFFFF0404|Hspell:219614|h[Haywire!]|h|r Leap to the zeppelin!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117564,'Ah, the Book is here at last... borne by one whose meddlesome handiwork I know well! Come to join the winning side, \"hero\"?','',1,0,0,0,0,0,0,0,0,0,66424,0,26124),
(117565,'You have both done well to acquire these artifacts. Your positions in the Shadow Council are all but assured.','',1,0,0,0,0,0,1,0,0,0,66425,0,26124),
(117566,'Using the Book, the Eye, and the Scepter, we will amplify this portal and open gateways to countless other demon worlds. The Legion\'s full might will fall upon this pitiful planet!','',1,0,0,0,0,0,1,0,0,0,66426,0,26124),
(117567,'I will go through the portal and act as a stabilizing anchor on Argus. You will focus the ritual energy through the scepter, widening the breach and creating a myriad of portals.','',1,0,0,0,0,0,1,0,0,0,66427,0,26124),
(117568,'Uh... great master? Which of us is to wield the Scepter?','',1,0,0,0,0,0,0,0,0,0,66428,0,26124),
(117569,'Your mastery of ice allows you to call forth a water elemental pet, so we\'ll start there.','',0,0,0,0,0,0,0,0,0,0,64844,0,26124),
(117570,'This long-range attack will damage and slow your enemies, and has a chance to empower other attacks.','',0,0,0,0,0,0,0,0,0,0,64845,0,26124),
(117571,'Ice Lance\'s real power lies in using it against a frozen target, which greatly increases its damage.','',0,0,0,0,0,0,0,0,0,0,64846,0,26124),
(117572,'Frostbolt occasionally triggers the Fingers of Frost effect, which gives a huge boost to Ice Lance damage. Let\'s test it out.','',0,0,0,0,0,0,0,0,0,0,64847,0,26124),
(117573,'|TInterface\\Icons\\Ability_Hunter_RapidRegeneration:20|tSnaggle begins a |cFFFF0404|Hspell:219848|h[Pistol Barrage]|h|r! Leap to the ground!','|TInterface\\Icons\\Ability_Hunter_RapidRegeneration:20|tSnaggle begins a |cFFFF0404|Hspell:219848|h[Pistol Barrage]|h|r! Leap to the ground!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117574,'Hodir, wait!','',1,0,0,0,0,0,0,0,0,0,68111,0,26124),
(117575,'Be careful, though, as it hits all enemies in its path, not just your target.','',0,0,0,0,0,0,0,0,0,0,64848,0,26124),
(117576,'Ahh, I only need ONE of you for the ritual. \"Discuss\" the matter quickly, and be ready...','',1,0,0,0,0,0,1,0,0,0,66429,0,26124),
(117577,'In those cases, a little bit of extra protection is needed. Ice Barrier creates a shield of ice to absorb enemy attacks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117578,'Use it and enemies will be unable to target you, letting you escape form combat. But be careful! It doesn\'t last long.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117579,'But using your legs is so mundane! Fortunately, you have a spell that befits a master of the magical arts.','',0,0,0,0,0,0,0,0,0,0,64851,0,26124),
(117580,'Blink allows you to teleport a short distance to avoid danger or close in on an enemy.','',0,0,0,0,0,0,0,0,0,0,64852,0,26124),
(117581,'Frost Nova freezes nearby enemies in place, allowing you to move away and destroy them safely. For now, let\'s just practice freezing them in place.','',0,0,0,0,0,0,0,0,0,0,64853,0,26124),
(117582,'It seems we are to be foes after all. Pity, you would have made an excellent servant!','',0,0,0,0,0,0,0,0,0,0,66430,0,26124),
(117583,'You can pelt a target location with shards of ice by using a potent spell called Blizzard. Great name, don\'t you think?','',0,0,0,0,0,0,0,0,0,0,64854,0,26124),
(117584,'Already on it! Once our friend completes the survey, we will have our first connection.','',0,0,0,0,0,0,0,0,0,0,67468,0,26124),
(117586,'You have yet to experience my true power!','',0,0,0,0,0,0,0,0,0,0,66422,0,26124),
(117588,'Slain... by a lowborn... how beneath me...','',0,0,0,0,0,0,0,0,0,0,66423,0,26124),
(117589,'','Oculeth, can you restore the teleporters in this chamber?',0,0,0,0,0,0,0,0,0,0,0,67467,26124),
(117590,'Not surprising that you came out the victor. I considered aiding Allaris against you, but your resourcefulness may prove useful. Consider this... a promotion. Do not disappoint me!','',1,0,0,0,0,0,0,0,0,0,66431,0,26124),
(117591,'The time has come! Begin the incantations. Focus the scepter on the altar. Today we usher in the end of this world!','',1,0,0,0,0,0,1,0,0,0,66432,0,26124),
(117592,'You can shapeshift into Moonkin form, which increases both your damage and defense.','',0,0,0,0,0,0,0,0,0,0,65553,0,26124),
(117593,'These attacks deal their damage over time, and either makes an excellent start to a battle.','',0,0,0,0,0,0,0,0,0,0,65554,0,26124),
(117594,'Solar Wrath is a ranged ability that deals damage and generates Astral Power, a resource used to fuel more powerful attacks.','',0,0,0,0,0,0,0,0,0,0,65555,0,26124),
(117595,'Starsurge costs Astral Power, so use Solar Wrath to build up your reserves.','',0,0,0,0,0,0,0,0,0,0,65556,0,26124),
(117596,'Celestial Alignment causes the celestial bodies to align, increasing the damage of your solar and lunar spells for a short time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117597,'Now we can begin to restore the ancient network. If you find any of my old beacons out there, be sure to activate them!','',0,0,0,0,0,0,0,0,0,0,67469,0,26124),
(117598,'','Drugon the Frostblood is an ancient foe of my people and has been spotted within Snowblind Cliffs. Put an end to this creature.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117599,'Oculeth finale lines.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117600,'','Thalyssra finale lines.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117601,'','Drugon should\'ve stayed hidden on his peak. Thank you champion, my people are safer because of you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117602,'You death will be... explosive.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117603,'Lunar Strike deals damage directly to your target, but also deals damage to nearby foes.','',0,0,0,0,0,0,0,0,0,0,75275,0,26124),
(117604,'Entangling Roots will cause plant roots to spring from the ground and hold the target in place for a short time.','',0,0,0,0,0,0,0,0,0,0,65559,0,26124),
(117605,'Soon they\'ll be weak enough for you to go for the throat with a mighty finishing move.','',0,0,0,0,0,0,1,0,0,0,64859,0,26124),
(117606,'Though powerful on its own, using Shred on a bleeding target increases its damage, so try keeping rake up.','',0,0,0,0,0,0,1,0,0,0,64860,0,26124),
(117607,'Ferocious Bite is a finishing move that deals increased damage the more combo points you have.','',0,0,0,0,0,0,1,0,0,0,64861,0,26124),
(117608,'Try to use it when you have a full 5 combo points.','',0,0,0,0,0,0,1,0,0,0,64862,0,26124),
(117609,'Rake will cause your target to bleed, wounding them over time.','',0,0,0,0,0,0,1,0,0,0,64863,0,26124),
(117610,'Your Shred ability also deals extra damage to bleeding targets, so these are great abilities to use together.','',0,0,0,0,0,0,1,0,0,0,75233,0,26124),
(117611,'Fool! Your betrayal only delays the inevitable! I will save a special prison for you when all you know is destroyed and you lie broken before me.','',22,0,0,0,0,0,0,0,0,0,66434,0,26124),
(117612,'Tiger\'s Fury restores some energy and also increases your damage for a short time.','',0,0,0,0,0,0,1,0,0,0,64865,0,26124),
(117613,'As an alternative to Ferocious Bite, Rip can be used to deal bleeding damage over time to your target, and is a good ability to spend combo points on early in a fight.','',0,0,0,0,0,0,1,0,0,0,64866,0,26124),
(117614,'Like Ferocious Bite, Rip is a finishing move, and is best used when you have 5 combo points.','',0,0,0,0,0,0,1,0,0,0,64867,0,26124),
(117615,'Entangling Roots will cause plant roots to spring from the ground and hold the target in place for a short time.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(117616,'Survival Instincts reduces incoming damage for a short time. Save it for when you really need it!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(117617,'Swipe deals damage to all nearby foes, but that damage is increased if your targets are bleeding. It\'s a good idea to use Thrash and Swipe together.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(117618,'Hodir has always been too impulsive for his own good. \n\nIt appears that he was right about you, however. I did not think it possible for a mere mortal to be worthy of Odyn\'s blessings. You are an enigma, $n.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(117619,'Thrash will damage all nearby enemies, causing them to bleed for a short time.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(117620,'Time to go, friend! Here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117621,'Dash increases your movement speed significantly for a short time. It can\'t be used often, so save it for when you really need it.','',0,0,0,0,0,0,0,0,0,0,64872,0,26124),
(117622,'After you\'ve taken damage, use Regrowth to restore your health.','',0,0,0,0,0,0,0,0,0,0,64873,0,26124),
(117623,'Dire Beast will allow you to summon a nearby beast to join the fight and attack your target for a short time.','',0,0,0,0,0,0,0,0,0,0,64875,0,26124),
(117624,'','You there! Outlander! Be a dear and step on that other switch, will you?',0,0,0,0,0,0,5,0,0,0,0,67475,26124),
(117625,'While under its effects, using Dire Beast will shorten the time before you can trigger Bestial Wrath again.','',0,0,0,0,0,0,0,0,0,0,64876,0,26124),
(117626,'Alongside your trusty pet, you are the master of your environment. Call Pet will summon your pet to your side.','',0,0,0,0,0,0,0,0,0,0,64877,0,26124),
(117627,'','There we are. Open at last.',0,0,0,0,0,0,0,0,0,0,0,67476,26124),
(117628,'Don\'t worry, your pet is resilient! Using Kill Command will cause your pet to perform a strong attack, and is also a great way to initiate a fight.','',0,0,0,0,0,0,0,0,0,0,64878,0,26124),
(117629,'','Well, I will be killing you now. Any last words?',0,0,0,0,0,0,0,0,0,0,0,67477,26124),
(117630,'Mend Pet will allow you to heal damage your pet has taken.','',0,0,0,0,0,0,0,0,0,0,64879,0,26124),
(117631,'Multi-shot allows you to fire a spread of projectiles hitting several enemies near your target.','',0,0,0,0,0,0,0,0,0,0,64880,0,26124),
(117632,'When facing certain defeat, use Feign Death to trick your enemies into thinking you\'re no longer a threat.','',0,0,0,0,0,0,0,0,0,0,64882,0,26124),
(117633,'Hodir has always been too impulsive for his own good.\n\nHis judgment was accurate about you, however. I did not think it possible for a mere mortal to be worthy of Odyn\'s blessing. You are an enigma, $n.\n\nI will teleport you out of here when you are ready.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(117634,'Using this attack causes your pet to cleave multiple enemies as well.','',0,0,0,0,0,0,0,0,0,0,64881,0,26124),
(117635,'','Ahhh, I recognize that symbol. So Thalyssra has recruited an outlander to our cause... Are we truly so desperate?',0,0,0,0,0,0,5,0,0,0,0,67478,26124),
(117636,'','Step before the Altar of the Eternal Hunt. Let it infuse your weapon with power and make it mightier than ever before!',0,0,0,0,0,0,0,0,0,0,0,68726,26124),
(117637,'They are gone... the portal is closed!','',1,0,0,0,0,0,0,0,0,0,68112,0,26124),
(117638,'You fought well.  I was wrong to question my father\'s choice. The forces of Ulduar will stand behind you if you are willing to aid us in finding Hodir.','',1,0,0,0,0,0,0,0,0,0,68402,0,26124),
(117639,'This builds up Chi, a resource that allows you to unleash your most powerful attacks.','',0,0,0,0,0,0,0,0,0,0,64883,0,26124),
(117640,'Start by using your primary attack, Tiger Palm, to deal damage and generate Chi.','',0,0,0,0,0,0,0,0,0,0,64884,0,26124),
(117641,'It hits much harder than Tiger Palm, so use Blackout Kick to spend your extra Chi.','',0,0,0,0,0,0,0,0,0,0,75235,0,26124),
(117642,'Your legend grows, and it is fitting that the fearsome artifact you wield increases in potency as well.','',0,0,0,0,0,0,0,0,0,0,71683,0,26124),
(117643,'It will also hit additional enemies near your target. Use Fists of Fury whenever it\'s available, or if you face multiple enemies.','',0,0,0,0,0,0,0,0,0,0,64887,0,26124),
(117644,'Use Flying Serpent Kick to launch yourself at your enemy. Using it a second time while you are in the air will end your flight and deal damage to enemies nearby.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117645,'Take one enemy out of the fight by paralyzing him! Paralyze will knock out an enemy for a short time, but the foe will recover if he takes any damage.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117646,'If you find yourself facing three or more opponents, tap your inner spirit to duplicate yourself, making you your own ally! Your allied selves will attack enemies automatically.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117647,'Use it whenever you meet someone you don\'t like, although you might want to save it for your toughest enemies!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117648,'Your primary means of mobility is Roll, which causes you to quickly roll a good distance in whatever direction you are moving.','',0,0,0,0,0,0,0,0,0,0,64892,0,26124),
(117649,'Use it whenever it is available.','',0,0,0,0,0,0,0,0,0,0,64885,0,26124),
(117650,'Before we get started we need to apply poison to your weapon.','',0,0,0,0,0,0,0,0,0,0,64894,0,26124),
(117651,'Raise your blade before the forge. Watch it infuse the weapon with its might!','',0,0,0,0,0,0,0,0,0,0,68718,0,26124),
(117652,'Darion Mograine! What is the meaning of this?!','',0,0,0,0,0,0,0,0,0,0,69441,0,26124),
(117653,'The best way to start a fight is with Garrote, a debilitating bleeding attack that causes your enemy to take damage over time.','',0,0,0,0,0,0,0,0,0,0,64895,0,26124),
(117654,'Whenever you use Rupture with 5 combo points, you will do a strong bleeding attack that damages enemies over time.','',0,0,0,0,0,0,0,0,0,0,64896,0,26124),
(117655,'If your target is already affected by Rupture, then using Envenom with 5 combo points deals good damage and maximizes the effect of your poisons.','',0,0,0,0,0,0,0,0,0,0,64897,0,26124),
(117656,'Crimson Vial is an alchemical concoction that will restore a portion of your health.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117657,'By using Shadowstep, you will remain in stealth and be poised to strike.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117658,'Fan of Knives unleashes damage on all enemies encircling you. It will also generate a combo point for every enemy hit.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117659,'Sometimes a strategic retreat is necessary so you can live to fight another day.','',0,0,0,0,0,0,0,0,0,0,64901,0,26124),
(117660,'Your Flame Shock ability will set your enemies ablaze, burning them while you cast other spells.','',0,0,0,0,0,0,0,0,0,0,64902,0,26124),
(117661,'Using Lava Burst while your enemies are affected by Flame Shock increases its damage.','',0,0,0,0,0,0,0,0,0,0,64903,0,26124),
(117662,'Use Lightning Bolt whenever other abilities are not available.','',0,0,0,0,0,0,0,0,0,0,64904,0,26124),
(117663,'Your target won\'t attack you while it\'s a frog, but the effect is temporary. The enemy will revert back to its original form if attacked.','',0,0,0,0,0,0,0,0,0,0,64905,0,26124),
(117664,'When you strike an enemy with Chain Lightning, it jumps to additional foes near your target, damaging all of them.','',0,0,0,0,0,0,0,0,0,0,64906,0,26124),
(117665,'Just as the elements can destroy, they also have the power to restore.','',0,0,0,0,0,0,0,0,0,0,64907,0,26124),
(117666,'The first attack we\'ll try is Flametongue, which emblazes your weapons and scorches your enemy with fire.','',0,0,0,0,0,0,0,0,0,0,64908,0,26124),
(117667,'Rockbiter empowers your weapons with the forces of earth to deal damage.','',0,0,0,0,0,0,0,0,0,0,64909,0,26124),
(117668,'Lava Lash uses Maelstrom to charge your off-hand weapon with lava, allowing you to deal a mighty blow.','',0,0,0,0,0,0,0,0,0,0,64910,0,26124),
(117669,'Try to use Stormstrike whenever Stormbringer triggers.','',0,0,0,0,0,0,0,0,0,0,64911,0,26124),
(117670,'Crash Lightning deals damage to all targets in front of you. Hitting multiple enemies empowers your weapons, dealing even more damage!','',0,0,0,0,0,0,0,0,0,0,75246,0,26124),
(117671,'Should you find yourself in trouble during combat, you can summon two feral wolf spirits to fight at your side.','',0,0,0,0,0,0,0,0,0,0,64913,0,26124),
(117672,'','<Sigh.> Very well. I am Valtrois.',0,0,0,0,0,0,1,0,0,0,0,67479,26124),
(117673,'','Run, for now. You will only die tired.',0,0,0,0,0,0,0,0,0,0,0,66150,26124),
(117674,'','I sense a spy among us.',0,0,0,0,0,0,0,0,0,0,0,66151,26124),
(117675,'','What do we have here? Someone hiding?',0,0,0,0,0,0,0,0,0,0,0,66152,26124),
(117676,'','Hmm. My prey can wait...',0,0,0,0,0,0,0,0,0,0,0,66153,26124),
(117677,'','Very well. Enjoy your freedom... for now.',0,0,0,0,0,0,0,0,0,0,0,65621,26124),
(117678,'','Hmm. I will find you soon...',0,0,0,0,0,0,0,0,0,0,0,66154,26124),
(117679,'Your attacks are a mix of ranged spells and melee that build up and unleash Holy Power.','',0,0,0,0,0,0,0,0,0,0,64914,0,26124),
(117680,'Your devotion to the Light empowers you to hurl a mighty hammer of Judgment at your foes.','',0,0,0,0,0,0,0,0,0,0,64915,0,26124),
(117681,'As your enemy closes in, unleash a potent mid-range attack called Blade of Justice.','',0,0,0,0,0,0,0,0,0,0,64916,0,26124),
(117682,'Once your foe has closed to striking range, unleash your weapon using Crusader Strike.','',0,0,0,0,0,0,0,0,0,0,64917,0,26124),
(117683,'Unleash this divine magic through Templar\'s Verdict, a powerful melee attack that infuses your weapon with the strength of the Light.','',0,0,0,0,0,0,0,0,0,0,64918,0,26124),
(117684,'Divine Shield prevents incoming attacks from harming you.','',0,0,0,0,0,0,0,0,0,0,64919,0,26124),
(117685,'Your conviction allows you to heal yourself and your allies. Flash of Light is a cornerstone of your healing arsenal.','',0,0,0,0,0,0,0,0,0,0,64920,0,26124),
(117686,'','Annihilate them!',0,0,0,0,0,0,0,0,0,0,0,66155,26124),
(117687,'','Your soul will serve us for eternity!',0,0,0,0,0,0,0,0,0,0,0,66156,26124),
(117688,'','Finally, some amusement.',0,0,0,0,0,0,0,0,0,0,0,66157,26124),
(117689,'','The Legion will conquer all!',0,0,0,0,0,0,0,0,0,0,0,66158,26124),
(117690,'','Do not toy with us!',0,0,0,0,0,0,0,0,0,0,0,66159,26124),
(117691,'','I will deliver your head to Gul\'dan myself.',0,0,0,0,0,0,0,0,0,0,0,66160,26124),
(117692,'','At last, some fitting prey...',0,0,0,0,0,0,0,0,0,0,0,66161,26124),
(117693,'','You cannot stop us all...',0,0,0,0,0,0,0,0,0,0,0,66162,26124),
(117694,'','We are... endless.',0,0,0,0,0,0,0,0,0,0,0,66163,26124),
(117695,'','Where one falls... two shall rise.',0,0,0,0,0,0,0,0,0,0,0,66164,26124),
(117696,'','Oblivion awaits!',0,0,0,0,0,0,0,0,0,0,0,66165,26124),
(117697,'','We will scorch the world!',0,0,0,0,0,0,0,0,0,0,0,66166,26124),
(117698,'','You cannot... resist...',0,0,0,0,0,0,0,0,0,0,0,66167,26124),
(117699,'','This... cannot be...',0,0,0,0,0,0,0,0,0,0,0,66168,26124),
(117700,'Shadow Word: Pain taints your foes with shadow energy, wounding them slowly over time.','',0,0,0,0,0,0,0,0,0,0,65598,0,26124),
(117701,'Penance is a potent spell that deals damage to your enemies. Use Penance whenever it is available.','',0,0,0,0,0,0,0,0,0,0,65599,0,26124),
(117702,'It is your most frequently used damage spell, best used when Penance is not available.','',0,0,0,0,0,0,0,0,0,0,65600,0,26124),
(117703,'One of your most useful defensive abilities is Power Word: Shield, which absorbs all damage from attacks when active.','',0,0,0,0,0,0,0,0,0,0,65601,0,26124),
(117704,'Always remember to maintain your shield during fights.','',0,0,0,0,0,0,0,0,0,0,65602,0,26124),
(117705,'Fortunately, you are not defenseless in such cases. Psychic Scream terrifies nearby opponents, causing them to run away in fear.','',0,0,0,0,0,0,0,0,0,0,65603,0,26124),
(117706,'This presents no problem for you however. The Light gives you the power to restore the health of yourself or your allies.','',0,0,0,0,0,0,0,0,0,0,65604,0,26124),
(117707,'Agony deals more and more damage over time, making it a great way to start a fight.','',0,0,0,0,0,0,0,0,0,0,64923,0,26124),
(117708,'Corruption is a spell that afflicts its target, dealing shadow damage as long as the affliction lasts.','',0,0,0,0,0,0,0,0,0,0,64924,0,26124),
(117709,'Drain Soul is the most frequent attack you will use, healing you as it damages your foe.','',0,0,0,0,0,0,0,0,0,0,64925,0,26124),
(117710,'Unstable Affliction is a powerful spell that deals damage over time like Agony and Corruption, but uses a Soul Shard to deal more damage.','',0,0,0,0,0,0,0,0,0,0,64926,0,26124),
(117711,'Your command of dark magic enables you to summon a demon servant to do your bidding.','',0,0,0,0,0,0,0,0,0,0,64927,0,26124),
(117712,'Life Tap allows you to steal your own life force to replenish your mana. Don\'t worry, you can always drain the life from your opponent to heal.','',0,0,0,0,0,0,0,0,0,0,64928,0,26124),
(117713,'To force a foe to stop fighting for a short time, utilize fear itself to strike terror into their heart.','',0,0,0,0,0,0,0,0,0,0,64929,0,26124),
(117714,'You cannot do this often, so save this demon for an emergency.','',0,0,0,0,0,0,0,0,0,0,64930,0,26124),
(117715,'Using your Soulstone ability preserves your very soul for later. Don\'t worry, you weren\'t using it anyway! With your soul stored, you can return from the dead at will.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117716,'','Mathias Shaw led our SI:7 team on a secret recon of the island. We were awaiting extraction.',0,0,0,0,0,0,0,0,6,0,0,71651,26124),
(117717,'But you cannot defeat an opponent that\'s out of reach. Fortunately, you have a skill to solve this problem.','',0,0,0,0,0,0,0,0,0,0,64932,0,26124),
(117718,'Mortal Strike is such an attack. Use it whenever it is available.','',0,0,0,0,0,0,0,0,0,0,64933,0,26124),
(117719,'Your Victory Rush ability can only be used during this time, restoring health as you strike a new enemy.','',0,0,0,0,0,0,0,0,0,0,64934,0,26124),
(117720,'Cleave allows you to attack several enemies that are in front of you. For every enemy hit, your next Whirlwind does additional damage!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117721,'Whirlwind allows you to swing your weapon in wide arcs, cutting a swath of carnage into all enemies around you.','',0,0,0,0,0,0,0,0,0,0,75231,0,26124),
(117722,'Heroic Leap allows you to bound across the battlefield to accomplish either goal.','',0,0,0,0,0,0,0,0,0,0,64937,0,26124),
(117723,'','Protect her while I heal her injuries!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117724,'','Use Army of the Dead now to summon in your minions.',0,0,0,0,0,0,0,0,0,0,0,64938,26124),
(117725,'','This powerful ability cannot be used often, so save it for an emergency.',0,0,0,0,0,0,0,0,0,0,0,64939,26124),
(117726,'','Army of the Dead raises a swarm of ghouls to attack anything and everything near you.',0,0,0,0,0,0,0,0,0,0,0,64940,26124),
(117727,'','Being able to call upon the powers of death means you rarely need to be outnumbered.',0,0,0,0,0,0,0,0,0,0,0,64941,26124),
(117728,'','Death Grip can be used from a good distance away. Try moving further away from the target and using it.',0,0,0,0,0,0,0,0,0,0,0,64942,26124),
(117729,'','Use Death Grip to pull my warrior to you.',0,0,0,0,0,0,0,0,0,0,0,64943,26124),
(117730,'','Death Grip allows you to reach out to a distant target and pull them toward you. No enemy can escape your icy grasp!',0,0,0,0,0,0,0,0,0,0,0,64944,26124),
(117731,'','Some foes would prefer to keep you at arm\'s length.',0,0,0,0,0,0,0,0,0,0,0,64945,26124),
(117732,'','Your target has maximum Festering Wounds. Use Scourge Strike!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117733,'','Using Scourge Strike after Festering Strike is a potent combination!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117734,'','Use Scourge Strike!',0,0,0,0,0,0,0,0,0,0,0,64948,26124),
(117735,'','Your minion is dead. Cast Raise Dead to summon a new minion.',0,0,0,0,0,0,0,0,0,0,0,64949,26124),
(117736,'','Virulent Plague has expired from your target. Use Outbreak now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117737,'','Cast Outbreak!',0,0,0,0,0,0,0,0,0,0,0,64951,26124),
(117738,'','Outbreak has expired from your target, use it now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117739,'','Use Festering Strike!',0,0,0,0,0,0,0,0,0,0,0,64953,26124),
(117740,'','Your target is not infested with Festering Wounds. Use Festering Strike now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117741,'','Use Death Strike!',0,0,0,0,0,0,0,0,0,0,0,64955,26124),
(117742,'','Use Death Coil!',0,0,0,0,0,0,0,0,0,0,0,64956,26124),
(117743,'','Death Coil is free!  Cast it now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117744,'You\'re facing multiple enemies. Try using Death and Decay!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117745,'Now is a good time to cast Dark Transformation!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117746,'','Cast Army of the Dead!',0,0,0,0,0,0,0,0,0,0,0,64960,26124),
(117747,'','Well done, $p! You are now prepared to do battle as an unholy death knight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117748,'','Show me you\'ve mastered the powers of darkness!',0,0,0,0,0,0,0,0,0,0,0,64962,26124),
(117749,'','Use Death Strike on the target to recover some of your health.',0,0,0,0,0,0,0,0,0,0,0,64963,26124),
(117750,'','Its dark power damages your foe and recovers a portion of your health.',0,0,0,0,0,0,0,0,0,0,0,64964,26124),
(117751,'','When taking excessive damage in battle, Death Strike can help even the odds.',0,0,0,0,0,0,0,0,0,0,0,64965,26124),
(117752,'Use Death and Decay to dispatch the group of minions.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117753,'Use Death and Decay to corrupt the ground beneath your feet, dealing damage to all foes in the affected area and empowering some of your attacks to hit additional targets.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117754,'As a death knight, you control the battlefield!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117755,'Use Dark Transformation to empower your ghoul.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117756,'Your undead minion is a valuable asset in battle. Dark Transformation allows you to temporarily transform your ghoul into a hulking monstrosity with increased power and abilities. Try it out!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117757,'','Your attacks sometimes allow you to cast Death Coil without costing Runic Power. Take advantage of this when you can.',0,0,0,0,0,0,0,0,0,0,0,64971,26124),
(117758,'','Use Death Coil on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,64972,26124),
(117759,'','Your attacks build Runic Power that can be used to cast Death Coil, a spell that hurls a blast of unholy energy at your target and restores energy to your ghoul minion.',0,0,0,0,0,0,0,0,0,0,0,64973,26124),
(117760,'','Try to only use Scourge Strike when your target is affected by Festering Wounds.',0,0,0,0,0,0,0,0,0,0,0,64974,26124),
(117761,'','Use Scourge Strike on the target dummy after it is infected with Festering Strike.',0,0,0,0,0,0,0,0,0,0,0,64975,26124),
(117762,'','Festering Strike followed by Scourge Strike is a one-two punch few enemies can withstand.',0,0,0,0,0,0,0,0,0,0,0,64976,26124),
(117763,'','Oh, that looks like it hurts! After infecting your target with Festering Strike, you are ready to burst the lesions you\'ve caused using Scourge Strike!',0,0,0,0,0,0,0,0,0,0,0,64977,26124),
(117764,'','Use Festering Strike on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,64978,26124),
(117765,'','Festering Strike deals damage and inflicts Festering Wounds on your target.',0,0,0,0,0,0,0,0,0,0,0,64979,26124),
(117766,'','Now that your enemy is reeling from a miasma of plagues, it\'s time to strike up close.',0,0,0,0,0,0,0,0,0,0,0,64980,26124),
(117767,'','Use Outbreak on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,64981,26124),
(117768,'%s has fallen! Your allies retreat.','%s has fallen! Your allies retreat.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117769,'','Outbreak will deal damage over time and unleashes a Virulent Plague that spreads to nearby enemies.',0,0,0,0,0,0,0,0,0,0,0,64982,26124),
(117770,'','The best way to start a fight is to infect your enemy with a host of diseases from a distance.',0,0,0,0,0,0,0,0,0,0,0,64983,26124),
(117771,'','Use Raise Dead to summon your minion.',0,0,0,0,0,0,0,0,0,0,0,64984,26124),
(117772,'','You should always try to have a minion with you.',0,0,0,0,0,0,0,0,0,0,0,64985,26124),
(117773,'','But your greatest ally is death itself. Raise Dead will animate a corpse to serve as your ghoulish minion.',0,0,0,0,0,0,0,0,0,0,0,64986,26124),
(117774,'','Disease wears your enemy down while your strong melee attacks finish them off.',0,0,0,0,0,0,0,0,0,0,0,64987,26124),
(117775,'','As an unholy death knight you command the powers of disease and death.',0,0,0,0,0,0,0,0,0,0,0,64988,26124),
(117840,'','Use Feign Death to trick my soldier into breaking off his attack.',0,0,0,0,0,0,0,0,0,0,0,65027,26124),
(117841,'','When facing certain defeat, use Feign Death to trick your enemies into thinking you\'re no longer a threat.',0,0,0,0,0,0,0,0,0,0,0,65028,26124),
(117842,'','Even the greatest adventurers sometimes find themselves in over their heads.',0,0,0,0,0,0,0,0,0,0,0,65029,26124),
(117843,'','Use Multi-Shot to dispatch all the enemies.',0,0,0,0,0,0,0,0,0,0,0,65030,26124),
(117844,'','Using this attack causes your pet to cleave multiple enemies as well.',0,0,0,0,0,0,0,0,0,0,0,65031,26124),
(117845,'','Multi-shot allows you to fire a spread of projectiles hitting several enemies near your target.',0,0,0,0,0,0,0,0,0,0,0,65032,26124),
(117846,'','Sometimes you\'ll find yourself outnumbered. When you do, you can unleash destruction upon a host of adversaries at once!',0,0,0,0,0,0,0,0,0,0,0,65033,26124),
(117847,'','Your pet has died! When this happens, your Mend Pet ability changes to Revive Pet, which will bring your faithful companion back to life.',0,0,0,0,0,0,0,0,0,0,0,65034,26124),
(117848,'','Use Mend Pet to heal your pet.',0,0,0,0,0,0,0,0,0,0,0,65035,26124),
(117849,'','Mend Pet will allow you to heal damage your pet has taken.',0,0,0,0,0,0,0,0,0,0,0,65036,26124),
(117850,'','Your pet has been wounded! Fortunately, you can aid your trusty companion.',0,0,0,0,0,0,0,0,0,0,0,65037,26124),
(117851,'','Use Kill Command multiple times on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65038,26124),
(117852,'','Don\'t worry, your pet is resilient! Using Kill Command will cause your pet to perform a strong attack, and is also a great way to initiate a fight.',0,0,0,0,0,0,0,0,0,0,0,65039,26124),
(117853,'','Sending your pet to attack and distract an enemy gives you more time to line up your ranged attacks.',0,0,0,0,0,0,0,0,0,0,0,65040,26124),
(117854,'','Use Call Pet to bring your pet to battle.',0,0,0,0,0,0,0,0,0,0,0,65041,26124),
(117855,'','Alongside your trusty pet, you are the master of your environment. Call Pet will summon your pet to your side.',0,0,0,0,0,0,0,0,0,0,0,65042,26124),
(117856,'','Beast master hunters possess a deep bond with their pets, calling and bolstering them in battle while striking at foes with ranged attacks.',0,0,0,0,0,0,0,0,0,0,0,65043,26124),
(117857,'','Use Multi-Shot!',0,0,0,0,0,0,0,0,0,0,0,65044,26124),
(117858,'','Your pet is hurt! Use Mend Pet!',0,0,0,0,0,0,0,0,0,0,0,65045,26124),
(117859,'','Use Kill Command!',0,0,0,0,0,0,0,0,0,0,0,65046,26124),
(117860,'','Kill Command is available! Use it now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117861,'','Use Dire Beast!',0,0,0,0,0,0,0,0,0,0,0,65048,26124),
(117862,'','Dire Beast is available! Use it now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117863,'','Use Cobra Shot!',0,0,0,0,0,0,0,0,0,0,0,65050,26124),
(117864,'','Call your pet!',0,0,0,0,0,0,0,0,0,0,0,65051,26124),
(117865,'','Use Bestial Wrath!',0,0,0,0,0,0,0,0,0,0,0,65052,26124),
(117866,'','Bestial Wrath is available! Use it now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117867,'','Well done, $p! You are now prepared to do battle as a beast master hunter.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117868,'','Prove to me you have the necessary skill and cunning required to hunt any prey!',0,0,0,0,0,0,0,0,0,0,0,65055,26124),
(117869,'','While under its effects, using Dire Beast will shorten the time before you can trigger Bestial Wrath again.',0,0,0,0,0,0,0,0,0,0,0,65056,26124),
(117870,'','When in combat, Bestial Wrath sends you and your pet into a frenzy of rage that increases your damage for a short time.',0,0,0,0,0,0,0,0,0,0,0,65057,26124),
(117871,'','Use Bestial Wrath while attacking the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65058,26124),
(117872,'','Use Cobra Shot on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65059,26124),
(117873,'','I\'m sure you\'re ready to join in on the action. Cobra Shot is your primary ranged attack, pummeling your enemy while your pet keeps their attention.',0,0,0,0,0,0,0,0,0,0,0,65060,26124),
(117874,'','Use Dire Beast on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65061,26124),
(117875,'','Dire Beast will allow you to summon a nearby beast to join the fight and attack your target for a short time.',0,0,0,0,0,0,0,0,0,0,0,65062,26124),
(117876,'','Now let\'s see what other forces of nature you command.',0,0,0,0,0,0,0,0,0,0,0,65063,26124),
(117922,'','Use Blizzard to dispatch this group of enemies.',0,0,0,0,0,0,0,0,0,0,0,65064,26124),
(117923,'','You can pelt a target location with shards of ice by using a potent spell called Blizzard. Great name, don\'t you think?',0,0,0,0,0,0,0,0,0,0,0,65065,26124),
(117924,'','You are master of dealing damage to many enemies at once.',0,0,0,0,0,0,0,0,0,0,0,65066,26124),
(117925,'','Remember that Ice Lance does extra damage to frozen targets, so using Frost Nova and Ice Lance together is a powerful tactic.',0,0,0,0,0,0,0,0,0,0,0,75237,26124),
(117926,'','Freeze my warrior using Frost Nova.',0,0,0,0,0,0,0,0,0,0,0,65068,26124),
(117927,'','Frost Nova freezes nearby enemies in place, allowing you to move away and destroy them safely. For now, let\'s just practice freezing them in place.',0,0,0,0,0,0,0,0,0,0,0,65069,26124),
(117928,'','What if you could freeze foes in their tracks, preventing them from even reaching you?',0,0,0,0,0,0,0,0,0,0,0,65070,26124),
(117929,'','Practice using Blink.',0,0,0,0,0,0,0,0,0,0,0,65071,26124),
(117930,'','Blink allows you to teleport a short distance to avoid danger or close in on an enemy.',0,0,0,0,0,0,0,0,0,0,0,65072,26124),
(117931,'','But using your legs is so mundane! Fortunately, you have a spell that befits a master of the magical arts.',0,0,0,0,0,0,0,0,0,0,0,65073,26124),
(117932,'','The battlefield can be a dangerous place, so moving about is crucial to your survival.',0,0,0,0,0,0,0,0,0,0,0,65074,26124),
(117933,'','Your Water Elemental has died. Cast Summon Water Elemental to call it back!',0,0,0,0,0,0,0,0,0,0,0,65075,26124),
(117934,'','Use Invisibility!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117935,'','Wait until you have Fingers of Frost, or your target is frozen, to use Ice Lance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117936,'','Your target is frozen! Use Ice Lance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117937,'','Use Ice Lance!',0,0,0,0,0,0,0,0,0,0,0,65079,26124),
(117938,'','Fingers of Frost has triggered! Use Ice Lance now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117939,'','Cast Ice Barrier!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117940,'','Use Frozen Orb!',0,0,0,0,0,0,0,0,0,0,0,65082,26124),
(117941,'','Frozen Orb is available! Cast it now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117942,'','Use Frostbolt!',0,0,0,0,0,0,0,0,0,0,0,65084,26124),
(117943,'','Use Frost Nova!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117944,'','You need to freeze your enemy in place before they reach you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117945,'','Use Frost Nova!',0,0,0,0,0,0,0,0,0,0,0,65087,26124),
(117946,'','Cast Blizzard!',0,0,0,0,0,0,0,0,0,0,0,65088,26124),
(117947,'','Well done, $p! You are now prepared to do battle as an ice mage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117948,'','Show me the raw power and superiority you wield!',0,0,0,0,0,0,0,0,0,0,0,65090,26124),
(117949,'','Use Invisibility to escape combat.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117950,'','Use it and enemies will be unable to target you, letting you escape form combat. But be careful! It doesn\'t last long.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117951,'','Need to get out of a fight in a hurry? Invisibility is a great spell for getting out of a sticky situation.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117952,'','Use Ice Barrier to reduce incoming damage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117953,'','In those cases, a little bit of extra protection is needed. Ice Barrier creates a shield of ice to absorb enemy attacks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117954,'','Despite your best efforts, you may not be able to prevent an enemy from reaching you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117955,'','Use Frozen Orb on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65097,26124),
(117956,'','Be careful, though, as it hits all enemies in its path, not just your target.',0,0,0,0,0,0,0,0,0,0,0,65098,26124),
(117957,'','Another potent spell you can wield is Frozen Orb. Cast this spell whenever it is available, as it can make your Ice Lance more powerful.',0,0,0,0,0,0,0,0,0,0,0,65099,26124),
(117958,'','Use Frost Bolt on the target dummy until you trigger Fingers of Frost. While the effect is active, use Ice Lance.',0,0,0,0,0,0,0,0,0,0,0,65100,26124),
(117959,'','Use Frostbolt on the target dummy until it triggers Fingers of Frost, Then use Ice Lance.',0,0,0,0,0,0,0,0,0,0,0,65101,26124),
(117960,'','Frostbolt occasionally triggers the Fingers of Frost effect, which gives a huge boost to Ice Lance damage. Let\'s test it out.',0,0,0,0,0,0,0,0,0,0,0,65102,26124),
(117961,'','There is one more way that Ice Lance can be used to maximize its power.',0,0,0,0,0,0,0,0,0,0,0,65103,26124),
(117962,'','Use Ice Lance on the frozen target dummy.',0,0,0,0,0,0,0,0,0,0,0,65104,26124),
(117963,'','Ice Lance\'s real power lies in using it against a frozen target, which greatly increases its damage.',0,0,0,0,0,0,0,0,0,0,0,65105,26124),
(117964,'','Now we\'ll take a look at Ice Lance. It\'s similar to Frostbolt, but can be cast instantly, albeit for less damage.',0,0,0,0,0,0,0,0,0,0,0,65106,26124),
(117965,'','Use Frostbolt on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65107,26124),
(117966,'','This long-range attack will damage and slow your enemies, and has a chance to empower other attacks.',0,0,0,0,0,0,0,0,0,0,0,65108,26124),
(117967,'','Your most fundamental and reliable attack is Frostbolt.',0,0,0,0,0,0,0,0,0,0,0,65109,26124),
(117968,'','Use Summon Water Elemental to summon your pet.',0,0,0,0,0,0,0,0,0,0,0,65110,26124),
(117969,'','Your mastery of ice allows you to call forth a water elemental pet, so we\'ll start there.',0,0,0,0,0,0,0,0,0,0,0,65111,26124),
(117970,'','As a frost mage you excel at controlling the battlefield by freezing enemies in place as ice and hail pummel them into submission.',0,0,0,0,0,0,0,0,0,0,0,65112,26124),
(117971,'','Use Effuse to replenish your health to full.',0,0,0,0,0,0,0,0,0,0,0,65113,26124),
(117972,'','Taking damage is part of battle, but you can tap the spiritual mists to heal yourself or an ally. Use Effuse to heal your wounds.',0,0,0,0,0,0,0,0,0,0,0,65114,26124),
(117973,'','Practice using Roll a few times.',0,0,0,0,0,0,0,0,0,0,0,65115,26124),
(117974,'','Your primary means of mobility is Roll, which causes you to quickly roll a good distance in whatever direction you are moving.',0,0,0,0,0,0,0,0,0,0,0,65116,26124),
(117975,'','You are fast and agile, able to zip around the battlefield at will.',0,0,0,0,0,0,0,0,0,0,0,65117,26124),
(117976,'','Use Tiger Palm!',0,0,0,0,0,0,0,0,0,0,0,65118,26124),
(117977,'','Use Tiger Palm to generate Chi!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117978,'','Roll, roll, roll!',0,0,0,0,0,0,0,0,0,0,0,65120,26124),
(117979,'','Use Rising Sun Kick!',0,0,0,0,0,0,0,0,0,0,0,65121,26124),
(117980,'','Rising Sun Kick is available! Use it now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117981,'','Use Flying Serpent Kick!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117982,'','Use Fists of Fury!',0,0,0,0,0,0,0,0,0,0,0,65124,26124),
(117983,'','Fists of Fury is available! Use it now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117984,'','Heal yourself with Effuse!',0,0,0,0,0,0,0,0,0,0,0,65126,26124),
(117985,'','You have maximum Chi! Use Blackout Kick!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117986,'','Use Blackout Kick!',0,0,0,0,0,0,0,0,0,0,0,65128,26124),
(117987,'','Well done, $p! You are now prepared to do battle as a monk.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117988,'','Show me the power and agility of windwalking!',0,0,0,0,0,0,0,0,0,0,0,65130,26124),
(117989,'','Paralyze the soldier who attacks you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117990,'','Take one enemy out of the fight by paralyzing him! Paralyze will knock out an enemy for a short time, but the foe will recover if he takes any damage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117991,'','Sometimes you might get in over your head, facing more enemies than you can handle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117992,'','Use Flying Serpent Kick to travel to the target dummy and damage it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117993,'','Use Flying Serpent Kick to launch yourself at your enemy. Using it a second time while you are in the air will end your flight and deal damage to enemies nearby.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117994,'','Roll is not your only ability for mobility. Windwalker monks can also launch themselves through the air, flying at their targets.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(117995,'','Use Fists of Fury on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65137,26124),
(117996,'','It will also hit additional enemies near your target. Use Fists of Fury whenever it\'s available, or if you face multiple enemies.',0,0,0,0,0,0,0,0,0,0,0,65138,26124),
(117997,'','You have an abundance of attacks at your disposal, windwalker! Fists of Fury costs 3 Chi and does a lot of damage.',0,0,0,0,0,0,0,0,0,0,0,65139,26124),
(117998,'','Use Blackout Kick on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65140,26124),
(117999,'','It hits much harder than Tiger Palm, so use Blackout Kick to spend your extra Chi.',0,0,0,0,0,0,0,0,0,0,0,75234,26124),
(118000,'','While not as powerful as Rising Sun Kick, your Blackout Kick still packs a punch... or, uh, a kick!',0,0,0,0,0,0,0,0,0,0,0,65142,26124),
(118001,'','Use Rising Sun Kick on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65143,26124),
(118002,'','Use it whenever it is available.',0,0,0,0,0,0,0,0,0,0,0,65144,26124),
(118003,'','Starting combat with Tiger Palm gives you enough Chi to unleash the powerful Rising Sun Kick, an attack that uses 2 Chi and deals substantial damage.',0,0,0,0,0,0,0,0,0,0,0,65145,26124),
(118004,'','Use Tiger Palm on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65146,26124),
(118005,'','Start by using your primary attack, Tiger Palm, to deal damage and generate Chi.',0,0,0,0,0,0,0,0,0,0,0,65147,26124),
(118006,'','This builds up Chi, a resource that allows you to unleash your most powerful attacks.',0,0,0,0,0,0,0,0,0,0,0,65148,26124),
(118007,'','As a windwalker monk you use your fists and your speed to overcome enemies.',0,0,0,0,0,0,0,0,0,0,0,65149,26124),
(118008,'','Use Flash of Light to heal your wounds.',0,0,0,0,0,0,0,0,0,0,0,65150,26124),
(118009,'','Your conviction allows you to heal yourself and your allies. Flash of Light is a cornerstone of your healing arsenal.',0,0,0,0,0,0,0,0,0,0,0,65151,26124),
(118010,'','Divine Shield protected you from the mage\'s first attack, but the second attack has left you wounded.',0,0,0,0,0,0,0,0,0,0,0,65152,26124),
(118011,'','Divine Shield will completely protect you from all attacks for a short period of time, so save it for emergencies.',0,0,0,0,0,0,0,0,0,0,0,65153,26124),
(118012,'','Use Divine Shield to make yourself temporarily invulnerable to all damage!',0,0,0,0,0,0,0,0,0,0,0,65154,26124),
(118013,'','Divine Shield prevents incoming attacks from harming you.',0,0,0,0,0,0,0,0,0,0,0,65155,26124),
(118014,'','You will face many dangerous situations, and preparation can be the key to your survival.',0,0,0,0,0,0,0,0,0,0,0,65156,26124),
(118015,'','You\'re at maximum Holy Power already! Use Templar\'s Verdict!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118016,'','Use Templar\'s Verdict!',0,0,0,0,0,0,0,0,0,0,0,65158,26124),
(118017,'','Templar\'s Verdict is available! Use it now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118018,'','Cast Judgment!',0,0,0,0,0,0,0,0,0,0,0,65160,26124),
(118019,'','Judgment is available!  Cast it now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118020,'','Judgment is a ranged ability. Try using it from further away!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118021,'','Use Flash of Light to heal yourself!',0,0,0,0,0,0,0,0,0,0,0,65163,26124),
(118022,'','Use Divine Shield!',0,0,0,0,0,0,0,0,0,0,0,65164,26124),
(118023,'','You\'re in trouble! Cast Divine Shield to save yourself!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118024,'','Use Crusader Strike!',0,0,0,0,0,0,0,0,0,0,0,65166,26124),
(118025,'','Use Crusader Strike to generate Holy Power!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118026,'','Cast Blade of Justice!',0,0,0,0,0,0,0,0,0,0,0,65168,26124),
(118027,'','Blade of Justice is available!  Cast it now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118028,'','Well done, $p! You are now prepared to do battle as a retribution paladin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118029,'','Show me your courage and zeal in the heat of combat!',0,0,0,0,0,0,0,0,0,0,0,65171,26124),
(118030,'','Build up Holy Power by using your attacks, then use Templar\'s Verdict on this target dummy.',0,0,0,0,0,0,0,0,0,0,0,65172,26124),
(118031,'','Unleash this divine magic through Templar\'s Verdict, a powerful melee attack that infuses your weapon with the strength of the Light.',0,0,0,0,0,0,0,0,0,0,0,65173,26124),
(118032,'','Using Blade of Justice and Crusader Strike in combat builds up Holy Power.',0,0,0,0,0,0,0,0,0,0,0,65174,26124),
(118033,'','Use Crusader Strike on this target dummy.',0,0,0,0,0,0,0,0,0,0,0,65175,26124),
(118034,'','Once your foe has closed to striking range, unleash your weapon using Crusader Strike.',0,0,0,0,0,0,0,0,0,0,0,65176,26124),
(118035,'','Blade of Justice is an excellent tool to deal damage as your opponent approaches.',0,0,0,0,0,0,0,0,0,0,0,65177,26124),
(118036,'','Use Blade of Justice on this target dummy.',0,0,0,0,0,0,0,0,0,0,0,65178,26124),
(118037,'','As your enemy closes in, unleash a potent mid-range attack called Blade of Justice.',0,0,0,0,0,0,0,0,0,0,0,65179,26124),
(118038,'','Judgment can be used on enemies at a distance or up close whenever it is available.',0,0,0,0,0,0,0,0,0,0,0,65180,26124),
(118039,'','Use Judgment on this target dummy.',0,0,0,0,0,0,0,0,0,0,0,65181,26124),
(118040,'','Your devotion to the Light empowers you to hurl a mighty hammer of Judgment at your foes.',0,0,0,0,0,0,0,0,0,0,0,65182,26124),
(118041,'','Your attacks are a mix of ranged spells and melee that build up and unleash Holy Power.',0,0,0,0,0,0,0,0,0,0,0,65183,26124),
(118042,'','As a retribution paladin you are a stalwart protector of the weak, a bringer of punishment to the unjust!',0,0,0,0,0,0,0,0,0,0,0,65184,26124),
(118043,'','Use Plea to heal your wounds.',0,0,0,0,0,0,0,0,0,0,0,65185,26124),
(118044,'','This presents no problem for you however. The Light gives you the power to restore the health of yourself or your allies.',0,0,0,0,0,0,0,0,0,0,0,65186,26124),
(118045,'','Power Word: Shield protected you from the mage\'s first attack, but the second attack has left you wounded.',0,0,0,0,0,0,0,0,0,0,0,65187,26124),
(118046,'','Use Psychic Scream to prevent this group of enemies from hitting you.',0,0,0,0,0,0,0,0,0,0,0,65188,26124),
(118047,'','Fortunately, you are not defenseless in such cases. Psychic Scream terrifies nearby opponents, causing them to run away in fear.',0,0,0,0,0,0,0,0,0,0,0,65189,26124),
(118048,'','In some battles you will face multiple opponents at the same time.',0,0,0,0,0,0,0,0,0,0,0,65190,26124),
(118049,'','Use Power Word: Shield to prevent this incoming damage.',0,0,0,0,0,0,0,0,0,0,0,65191,26124),
(118050,'','Always remember to maintain your shield during fights.',0,0,0,0,0,0,0,0,0,0,0,65192,26124),
(118051,'','One of your most useful defensive abilities is Power Word: Shield, which absorbs all damage from attacks when active.',0,0,0,0,0,0,0,0,0,0,0,65193,26124),
(118052,'','As followers of the light, you have many ways to protect and restore health.',0,0,0,0,0,0,0,0,0,0,0,65194,26124),
(118053,'','Cast Smite!',0,0,0,0,0,0,0,0,0,0,0,65195,26124),
(118054,'','There\'s no need to recast Shadow Word: Pain when the previous one still has lots of time left on it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118055,'','Cast Shadow Word: Pain!',0,0,0,0,0,0,0,0,0,0,0,65197,26124),
(118056,'','Shadow Word: Pain has expired on your target, cast it again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118057,'','Use Psychic Scream!',0,0,0,0,0,0,0,0,0,0,0,65199,26124),
(118058,'','Cast Power Word: Shield to protect yourself!',0,0,0,0,0,0,0,0,0,0,0,65200,26124),
(118059,'','Use Plea to heal yourself!',0,0,0,0,0,0,0,0,0,0,0,65201,26124),
(118060,'','Cast Penance now!',0,0,0,0,0,0,0,0,0,0,0,65202,26124),
(118061,'','Penance is available!  Cast it now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118062,'','Well done, $p! You are now prepared to do battle as a discipline priest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118063,'','Command the forces of Shadow and Light to achieve victory!',0,0,0,0,0,0,0,0,0,0,0,65205,26124),
(118064,'','Use Smite on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65206,26124),
(118065,'','It is your most frequently used damage spell, best used when Penance is not available.',0,0,0,0,0,0,0,0,0,0,0,65207,26124),
(118066,'','The power of the Light allows you to Smite any enemy that stands before you!',0,0,0,0,0,0,0,0,0,0,0,65208,26124),
(118067,'','Use Penance on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65209,26124),
(118068,'','Penance is a potent spell that deals damage to your enemies. Use Penance whenever it is available.',0,0,0,0,0,0,0,0,0,0,0,65210,26124),
(118069,'','The Light is a formidable ally, capable of restoring your friends or striking down foes.',0,0,0,0,0,0,0,0,0,0,0,65211,26124),
(118070,'','Once your target is afflicted with Shadow Word: Pain, you don\'t need to cast it again until your original spell is close to expiring.',0,0,0,0,0,0,0,0,0,0,0,65212,26124),
(118071,'','Use Shadow Word: Pain on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65213,26124),
(118072,'','Shadow Word: Pain taints your foes with shadow energy, wounding them slowly over time.',0,0,0,0,0,0,0,0,0,0,0,65214,26124),
(118073,'','Discipline priests draw upon the opposing forces of Light and Shadow, choosing when to heal and when to inflict damage.',0,0,0,0,0,0,0,0,0,0,0,65215,26124),
(118074,'','Use Vanish to evade my warrior.',0,0,0,0,0,0,0,0,0,0,0,65216,26124),
(118075,'','Sometimes a strategic retreat is necessary so you can live to fight another day.',0,0,0,0,0,0,0,0,0,0,0,65218,26124),
(118076,'','There\'s just one last thing you need to learn.',0,0,0,0,0,0,0,0,0,0,0,65219,26124),
(118077,'','You\'re in trouble! Use Vanish!',0,0,0,0,0,0,0,0,0,0,0,65220,26124),
(118078,'','Starting combat from stealth is more effective.',0,0,0,0,0,0,0,0,0,0,0,65221,26124),
(118079,'','Use Shadowstep!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118080,'','Use Rupture!',0,0,0,0,0,0,0,0,0,0,0,65223,26124),
(118081,'','You have 5 combo points. Use Rupture!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118082,'','Use Deadly Poison on your weapon.',0,0,0,0,0,0,0,0,0,0,0,65225,26124),
(118083,'','Use Mutilate to generate combo points!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118084,'','Use Mutilate!',0,0,0,0,0,0,0,0,0,0,0,65227,26124),
(118085,'','Use Garrote!',0,0,0,0,0,0,0,0,0,0,0,65228,26124),
(118086,'','Use Garrote to bleed your enemy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118087,'','Use Fan of Knives!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118088,'','You\'re facing multiple enemies, try using Fan of Knives!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118089,'','Use Envenom!',0,0,0,0,0,0,0,0,0,0,0,65232,26124),
(118090,'','You have 5 combo points. Use Envenom!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118091,'','Use Crimson Vial to restore health!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118092,'','Well done, $p! You are now prepared to do battle as an assassination rogue.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118093,'','Show me you\'ve got the stuff, $p!',0,0,0,0,0,0,0,0,0,0,0,65236,26124),
(118094,'','Use Fan of Knives to dispatch this group of enemies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118095,'','Fan of Knives unleashes damage on all enemies encircling you. It will also generate a combo point for every enemy hit.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118096,'','Enemies that try to surround you will be in for a nasty surprise!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118097,'','Use Shadowstep to appear behind a distant target.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118098,'','By using Shadowstep, you will remain in stealth and be poised to strike.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118099,'','There are times that you might want to close in on a target but not deal damage right away.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118100,'','Use Crimson Vial to restore some of your health.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118101,'','Crimson Vial is an alchemical concoction that will restore a portion of your health.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118102,'','You\'ve taken some damage, but luckily a crafty rogue plans ahead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118103,'','Use Envenom with 5 combo points.',0,0,0,0,0,0,0,0,0,0,0,65246,26124),
(118104,'','If your target is already affected by Rupture, then using Envenom with 5 combo points deals good damage and maximizes the effect of your poisons.',0,0,0,0,0,0,0,0,0,0,0,65247,26124),
(118105,'','Rupture is not your only finishing move.',0,0,0,0,0,0,0,0,0,0,0,65248,26124),
(118106,'','Use Rupture with 5 combo points.',0,0,0,0,0,0,0,0,0,0,0,65249,26124),
(118107,'','Whenever you use Rupture with 5 combo points, you will do a strong bleeding attack that damages enemies over time.',0,0,0,0,0,0,0,0,0,0,0,65250,26124),
(118108,'','Now that you\'ve built up 5 combo points, it\'s time to use Rupture.',0,0,0,0,0,0,0,0,0,0,0,65251,26124),
(118109,'','Use Mutilate to attack the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65252,26124),
(118110,'','Your main attack is called Mutilate. It deals damage as well as generates combo points that can be used for powerful finishing moves.',0,0,0,0,0,0,0,0,0,0,0,65253,26124),
(118111,'','Always remember to use Garrote to keep your enemies bleeding.',0,0,0,0,0,0,0,0,0,0,0,65254,26124),
(118112,'','Use Garrote on this target dummy.',0,0,0,0,0,0,0,0,0,0,0,65255,26124),
(118113,'','The best way to start a fight is with Garrote, a debilitating bleeding attack that causes your enemy to take damage over time.',0,0,0,0,0,0,0,0,0,0,0,65256,26124),
(118114,'','As an assassin, you weaken your enemies before finishing them off.',0,0,0,0,0,0,0,0,0,0,0,65257,26124),
(118115,'','Use Stealth to fade from view.',0,0,0,0,0,0,0,0,0,0,0,65258,26124),
(118116,'','Stealth makes you invisible to most enemies. When in Stealth, you can close the distance to enemies undetected.',0,0,0,0,0,0,0,0,0,0,0,65259,26124),
(118117,'','Assassins favor trickery and cunning. And what\'s trickier than attacking before your target sees you coming?',0,0,0,0,0,0,0,0,0,0,0,65260,26124),
(118118,'','Use Deadly Poison to coat your weapon with poison for one hour.',0,0,0,0,0,0,0,0,0,0,0,65261,26124),
(118119,'','Before we get started we need to apply poison to your weapon.',0,0,0,0,0,0,0,0,0,0,0,65262,26124),
(118120,'','As an assassination rogue you specialize in striking from the shadows, dispatching foes with a variety of poisons and bleeding attacks.',0,0,0,0,0,0,0,0,0,0,0,65263,26124),
(118121,'','Use Fire Elemental now to summon your elemental!',0,0,0,0,0,0,0,0,0,0,0,65264,26124),
(118122,'','As a master of the elements, you are able to coalesce primal elemental forces into physical form to aid you in battle.',0,0,0,0,0,0,0,0,0,0,0,65265,26124),
(118123,'','Use Healing Surge to replenish your health to full.',0,0,0,0,0,0,0,0,0,0,0,65266,26124),
(118124,'','Just as the elements can destroy, they also have the power to restore.',0,0,0,0,0,0,0,0,0,0,0,65267,26124),
(118125,'','You\'ve taken damage, but this presents no problem for you.',0,0,0,0,0,0,0,0,0,0,0,65268,26124),
(118126,'','Use Chain Lightning against several enemies at once.',0,0,0,0,0,0,0,0,0,0,0,65269,26124),
(118127,'','When you strike an enemy with Chain Lightning, it jumps to additional foes near your target, damaging all of them.',0,0,0,0,0,0,0,0,0,0,0,65270,26124),
(118128,'','There are times you\'ll face multiple opponents on the battlefield. Fortunately, you have a potent ability called Chain Lightning.',0,0,0,0,0,0,0,0,0,0,0,65271,26124),
(118129,'','Turn my warrior into a frog!',0,0,0,0,0,0,0,0,0,0,0,65272,26124),
(118130,'','Your target won\'t attack you while it\'s a frog, but the effect is temporary. The enemy will revert back to its original form if attacked.',0,0,0,0,0,0,0,0,0,0,0,65273,26124),
(118131,'','Ever wanted to turn someone into a frog? Hex allows you to do just that!',0,0,0,0,0,0,0,0,0,0,0,65274,26124),
(118132,'','Use Thunderstorm to knock enemies away!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118133,'','Use Lightning Bolt!',0,0,0,0,0,0,0,0,0,0,0,65276,26124),
(118134,'','Using Lava Burst after your enemy is burning from Flame Shock increases its damage!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118135,'','Use Lava Burst!',0,0,0,0,0,0,0,0,0,0,0,65278,26124),
(118136,'','Use Lava Burst while your enemy is burning!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118137,'','Heal yourself with Healing Surge!',0,0,0,0,0,0,0,0,0,0,0,65280,26124),
(118138,'','Only use Flame Shock when it\'s about to expire!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118139,'','Use Flame Shock!',0,0,0,0,0,0,0,0,0,0,0,65282,26124),
(118140,'','Use Flame Shock to burn your enemy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118141,'','Use Fire Elemental!',0,0,0,0,0,0,0,0,0,0,0,65284,26124),
(118142,'','Wait until you are at maximum Maelstrom to use Earth Shock!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118143,'','Use Earth Shock!',0,0,0,0,0,0,0,0,0,0,0,65286,26124),
(118144,'','You are at maximum Maelstrom! Use Earth Shock!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118145,'','Use Chain Lightning!',0,0,0,0,0,0,0,0,0,0,0,65288,26124),
(118146,'','Well done, $p! You are now prepared to do battle as an elemental shaman.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118147,'','Unleash the elements to achieve victory, $p!',0,0,0,0,0,0,0,0,0,0,0,65290,26124),
(118148,'','Use Thunderstorm to knock away the enemies surrounding you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118149,'','If you become surrounded in combat, use Thunderstorm to knock enemies back and give yourself some breathing room.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118150,'','Use your Lightning Bolt on the Target Dummy until you have the maximum amount of Maelstrom, then use Earth Shock.',0,0,0,0,0,0,0,0,0,0,0,65293,26124),
(118151,'','Use Earth Shock on this target dummy.',0,0,0,0,0,0,0,0,0,0,0,65294,26124),
(118152,'','Earth Shock is one of your most powerful spells. Casting it requires Maelstrom, a resource generated by your other attacks.',0,0,0,0,0,0,0,0,0,0,0,65295,26124),
(118153,'','Use Lightning Bolt on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65296,26124),
(118154,'','Use Lightning Bolt whenever other abilities are not available.',0,0,0,0,0,0,0,0,0,0,0,65297,26124),
(118155,'','Hurling lightning from your hands is your main weapon for overcoming enemies.',0,0,0,0,0,0,0,0,0,0,0,65298,26124),
(118156,'','Use Lava Burst on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65299,26124),
(118157,'','Using Lava Burst while your enemies are affected by Flame Shock increases its damage.',0,0,0,0,0,0,0,0,0,0,0,65300,26124),
(118158,'','Why stop with fire? Once your enemies are burning, you can hurl molten lava at them.',0,0,0,0,0,0,0,0,0,0,0,65301,26124),
(118159,'','Use Flame Shock on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65302,26124),
(118160,'','Excellent! Always remember to use Flame Shock to keep your enemies burning.',0,0,0,0,0,0,0,0,0,0,0,65303,26124),
(118161,'','Your Flame Shock ability will set your enemies ablaze, burning them while you cast other spells.',0,0,0,0,0,0,0,0,0,0,0,65304,26124),
(118162,'','As an elemental shaman you commune with ancient spirits and command primal elemental forces.',0,0,0,0,0,0,0,0,0,0,0,65305,26124),
(118163,'','Use Feral Spirit if you need to boost your damage in a fight!',0,0,0,0,0,0,0,0,0,0,0,65306,26124),
(118164,'','Should you find yourself in trouble during combat, you can summon two feral wolf spirits to fight at your side.',0,0,0,0,0,0,0,0,0,0,0,65307,26124),
(118165,'','You share a kinship with animal spirits such as wolves.',0,0,0,0,0,0,0,0,0,0,0,65308,26124),
(118166,'','Use Stormstrike!',0,0,0,0,0,0,0,0,0,0,0,65309,26124),
(118167,'','Stormbringer has triggered! Use Stormstrike now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118168,'','Use Rockbiter!',0,0,0,0,0,0,0,0,0,0,0,65311,26124),
(118169,'','Use Rockbiter to generate Maelstrom!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118170,'','You have maximum Maelstrom. Use Lava Lash!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118171,'','Use Lava Lash!',0,0,0,0,0,0,0,0,0,0,0,65314,26124),
(118172,'','Lava Lash is available! Use it now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118173,'','Use Flametongue!',0,0,0,0,0,0,0,0,0,0,0,65316,26124),
(118174,'','Your Flametongue buff has expired! Use Flametongue!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118175,'','Use Feral Spirit!',0,0,0,0,0,0,0,0,0,0,0,65318,26124),
(118176,'','Use Crash Lightning!',0,0,0,0,0,0,0,0,0,0,0,75243,26124),
(118177,'','Well done, $p! You are now prepared to do battle as an enhancement shaman.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118178,'','Show me you fight with the fury of the elements!',0,0,0,0,0,0,0,0,0,0,0,65321,26124),
(118179,'','Use Shamanistic Rage to reduce incoming damage.',0,0,0,0,0,0,0,0,0,0,0,75242,26124),
(118180,'','If you find yourself taking too much punishment in a fight, Shamanistic Rage reduces incoming damage for a short period of time. Try it!',0,0,0,0,0,0,0,0,0,0,0,75241,26124),
(118181,'','Use Crash Lightning to dispatch this group of enemies.',0,0,0,0,0,0,0,0,0,0,0,75240,26124),
(118182,'','Crash Lightning deals damage to all targets in front of you. Hitting multiple enemies empowers your weapons, dealing even more damage!',0,0,0,0,0,0,0,0,0,0,0,75239,26124),
(118183,'','If you are fighting multiple enemies, it is time to unleash the full fury of the storm!',0,0,0,0,0,0,0,0,0,0,0,75238,26124),
(118184,'','Use Stormstrike now!',0,0,0,0,0,0,0,0,0,0,0,65327,26124),
(118185,'','Use Stormstrike on the target dummy after Stormbringer triggers.',0,0,0,0,0,0,0,0,0,0,0,65328,26124),
(118186,'','Try to use Stormstrike whenever Stormbringer triggers.',0,0,0,0,0,0,0,0,0,0,0,65329,26124),
(118187,'','Your most powerful Maelstrom-fueled ability is Stormstrike.',0,0,0,0,0,0,0,0,0,0,0,65330,26124),
(118188,'','Use Lava Lash on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65331,26124),
(118189,'','Lava Lash uses Maelstrom to charge your off-hand weapon with lava, allowing you to deal a mighty blow.',0,0,0,0,0,0,0,0,0,0,0,65332,26124),
(118190,'','Using Rockbiter generates Maelstrom, a resource that powers stronger attacks.',0,0,0,0,0,0,0,0,0,0,0,65333,26124),
(118191,'','Use Rockbiter on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65334,26124),
(118192,'','Rockbiter empowers your weapons with the forces of earth to deal damage.',0,0,0,0,0,0,0,0,0,0,0,65335,26124),
(118193,'','Now that your weapons are burning, you can focus on your primary attack.',0,0,0,0,0,0,0,0,0,0,0,65336,26124),
(118194,'','Use Flametongue on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65337,26124),
(118195,'','The first attack we\'ll try is Flametongue, which emblazes your weapons and scorches your enemy with fire.',0,0,0,0,0,0,0,0,0,0,0,65338,26124),
(118196,'','As an enhancement shaman you channel the elemental forces directly into your weapons to make yourself a furious melee combatant, beating down your foes with the power of flame, earth, and storm.',0,0,0,0,0,0,0,0,0,0,0,65339,26124),
(118197,'','Use Soulstone to survive death.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118198,'','Using your Soulstone ability preserves your very soul for later. Don\'t worry, you weren\'t using it anyway! With your soul stored, you can return from the dead at will.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118199,'','A well-prepared warlock can survive almost anything... even death!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118200,'','Astounding! Your mastery over demons has given you great power!',0,0,0,0,0,0,0,0,0,0,0,65343,26124),
(118201,'','Now, heal some of the damage you\'ve taken with your Healthstone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118202,'','Now, heal some of the damage you\'ve taken with your Healthstone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118203,'','Use Create Healthstone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118204,'','A portion of your power can be coalesced into a Healthstone. If you take damage, ingest the Healthstone to recover health.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118205,'','Use Summon Doomguard now to summon this demon.',0,0,0,0,0,0,0,0,0,0,0,65348,26124),
(118206,'','You can\'t do this often, so save this demon for an emergency.',0,0,0,0,0,0,0,0,0,0,0,65349,26124),
(118207,'','While greater demons like Infernals and Doomguards cannot be controlled for long, you can summon one to your side for short periods of time to fight for you.',0,0,0,0,0,0,0,0,0,0,0,65350,26124),
(118208,'','Use Fear to frighten my warrior.',0,0,0,0,0,0,0,0,0,0,0,65351,26124),
(118209,'','To force a foe to stop fighting for a short time, utilize fear itself to strike terror into their heart.',0,0,0,0,0,0,0,0,0,0,0,65352,26124),
(118210,'','At times you may find yourself overwhelmed by multiple enemies, or a single enemy that is too strong for you.',0,0,0,0,0,0,0,0,0,0,0,65353,26124),
(118211,'','Use Life Tap to replenish your mana reserves.',0,0,0,0,0,0,0,0,0,0,0,65354,26124),
(118212,'','Life Tap allows you to steal your own life force to replenish your mana. Don\'t worry, you can always drain the life from your opponent to heal.',0,0,0,0,0,0,0,0,0,0,0,65355,26124),
(118213,'','Many spells have a heavy mana cost. But you have a clever way around this problem.',0,0,0,0,0,0,0,0,0,0,0,65356,26124),
(118214,'','Use Summon Voidwalker to summon your demonic minion.',0,0,0,0,0,0,0,0,0,0,0,65357,26124),
(118215,'','Your command of dark magic enables you to summon a demon servant to do your bidding.',0,0,0,0,0,0,0,0,0,0,0,65358,26124),
(118216,'','Affliction warlocks use shadow magic and disease to wear down their enemies, then drain their very life essences to empower themselves.',0,0,0,0,0,0,0,0,0,0,0,65359,26124),
(118217,'','You have maximum Soul Shards. Cast Unstable Affliction!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118218,'','Use Unstable Affliction!',0,0,0,0,0,0,0,0,0,0,0,65361,26124),
(118219,'','Unstable Affliction is available! Cast it now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118220,'','Your Voidwalker has died. Use Summon Voidwalker to bring it back.',0,0,0,0,0,0,0,0,0,0,0,65363,26124),
(118221,'','Use Life Tap to replenish your mana!',0,0,0,0,0,0,0,0,0,0,0,65364,26124),
(118222,'','You\'re low on health, use your Healthstone!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118223,'','Cast Fear!',0,0,0,0,0,0,0,0,0,0,0,65366,26124),
(118224,'','Use Drain Life!',0,0,0,0,0,0,0,0,0,0,0,65367,26124),
(118225,'','Use Drain Life on your target!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118226,'','Summon your Doomguard now!',0,0,0,0,0,0,0,0,0,0,0,65369,26124),
(118227,'','Use Corruption!',0,0,0,0,0,0,0,0,0,0,0,65370,26124),
(118228,'','Corruption has expired! Cast it again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118229,'','Recast Agony just before it expires to preserve its amplified damage!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118230,'','Use Agony!',0,0,0,0,0,0,0,0,0,0,0,65373,26124),
(118231,'','Agony has expired! Cast it again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118232,'','Well done, $p! You are now prepared to do battle as an affliction warlock.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118233,'','But please, don\'t hurt them too badly. I need them for later.',0,0,0,0,0,0,0,0,0,0,0,65376,26124),
(118234,'','While Unstable Affliction deals damage over time, every re-cast increases its potency. Use this attack whenever you can!',0,0,0,0,0,0,0,0,0,0,0,65377,26124),
(118235,'','Use Unstable Affliction on this target dummy.',0,0,0,0,0,0,0,0,0,0,0,65378,26124),
(118236,'','Unstable Affliction is a powerful spell that deals damage over time like Agony and Corruption, but uses a Soul Shard to deal more damage.',0,0,0,0,0,0,0,0,0,0,0,65379,26124),
(118237,'','As Agony damages your enemy, it has a chance to generate a Soul Shard. You can use these shards to empower new abilities.',0,0,0,0,0,0,0,0,0,0,0,65380,26124),
(118238,'','Use Drain Soul on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65381,26124),
(118239,'','Drain Soul is the most frequent attack you will use, healing you as it damages your foe.',0,0,0,0,0,0,0,0,0,0,0,65382,26124),
(118240,'','After afflicting your target with Agony and Corruption, you can begin to drain the very life from them.',0,0,0,0,0,0,0,0,0,0,0,65383,26124),
(118241,'','Once you cast Corruption, you don\'t need to cast it again until your original spell is close to expiring.',0,0,0,0,0,0,0,0,0,0,0,65384,26124),
(118242,'','Use Corruption on this target dummy.',0,0,0,0,0,0,0,0,0,0,0,65385,26124),
(118243,'','Corruption is a spell that afflicts its target, dealing shadow damage as long as the affliction lasts.',0,0,0,0,0,0,0,0,0,0,0,65386,26124),
(118244,'','You will inflict suffering on anyone foolish enough to fight you.',0,0,0,0,0,0,0,0,0,0,0,65387,26124),
(118245,'','Once you cast Agony, you don\'t need to cast it again until your original spell is close to expiring.',0,0,0,0,0,0,0,0,0,0,0,65388,26124),
(118246,'','Use Agony on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65389,26124),
(118247,'','Agony deals more and more damage over time, making it a great way to start a fight.',0,0,0,0,0,0,0,0,0,0,0,65390,26124),
(118248,'','Agony is an appropriate name for your first attack ability.',0,0,0,0,0,0,0,0,0,0,0,65391,26124),
(118249,'','Practice using Heroic Leap.',0,0,0,0,0,0,0,0,0,0,0,65392,26124),
(118250,'','Heroic Leap allows you to bound across the battlefield to accomplish either goal.',0,0,0,0,0,0,0,0,0,0,0,65393,26124),
(118251,'','In the heat of battle there will be times you need to move quickly to avoid danger... or confront it!',0,0,0,0,0,0,0,0,0,0,0,65394,26124),
(118252,'','Use Whirlwind to take out this group of enemies.',0,0,0,0,0,0,0,0,0,0,0,65395,26124),
(118253,'','Whirlwind allows you to swing your weapon in wide arcs, cutting a swath of carnage into all enemies around you.',0,0,0,0,0,0,0,0,0,0,0,75230,26124),
(118254,'','Your opponents may try to overwhelm you with numbers, but they underestimate your true might!',0,0,0,0,0,0,0,0,0,0,0,65397,26124),
(118255,'','Use Whirlwind!',0,0,0,0,0,0,0,0,0,0,0,65398,26124),
(118256,'','Whirlwind can damage multiple enemies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118257,'','Use Victory Rush!',0,0,0,0,0,0,0,0,0,0,0,65400,26124),
(118258,'','Victory Rush is available! Use it now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118259,'','Use Slam!',0,0,0,0,0,0,0,0,0,0,0,65402,26124),
(118260,'','Use Mortal Strike!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118261,'','Mortal Strike is available!  Use it now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118262,'','Use Colossus Smash!',0,0,0,0,0,0,0,0,0,0,0,65405,26124),
(118263,'','Colossus Smash is available! Use it now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118264,'','Use Cleave!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118265,'','Warriors don\'t stroll up to face a foe! Use Charge to close the distance on your opponent. Try it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118266,'','Well done, $p! You are now prepared to do battle as an arms warrior.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118267,'','Show me you fight with fearlessness and ferocity!',0,0,0,0,0,0,0,0,0,0,0,65410,26124),
(118268,'','Use Cleave and Whirlwind to take out this group of enemies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118269,'','Cleave allows you to attack several enemies that are in front of you. For every enemy hit, your next Whirlwind does additional damage!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118270,'','Whirlwind is not the only attack you can use against multiple enemies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118271,'','Eliminate an enemy, enabling Victory Rush to be used on your next opponent.',0,0,0,0,0,0,0,0,0,0,0,65414,26124),
(118272,'','Your Victory Rush ability can only be used during this time, restoring health as you strike a new enemy.',0,0,0,0,0,0,0,0,0,0,0,65415,26124),
(118273,'','After you defeat an opponent, your heart will sing with the glory of victory!',0,0,0,0,0,0,0,0,0,0,0,65416,26124),
(118274,'','Use Colossus Smash on the Target Dummy.',0,0,0,0,0,0,0,0,0,0,0,65417,26124),
(118275,'','One of your most devastating attacks is Colossus Smash. Always use it as soon as it becomes available and no foe will stand against you for long.',0,0,0,0,0,0,0,0,0,0,0,65418,26124),
(118276,'','Use Slam on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65419,26124),
(118277,'','Dealing damage to your enemy builds up Rage, which fuels your attacks. Use Slam to spend Rage and deal damage to your enemy.',0,0,0,0,0,0,0,0,0,0,0,65420,26124),
(118278,'','Use Mortal Strike on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65421,26124),
(118279,'','Mortal Strike is such an attack. Use it whenever it is available.',0,0,0,0,0,0,0,0,0,0,0,65422,26124),
(118280,'','Once you reach your target you will perform basic attacks automatically, but a skilled combatant unleashes a variety of advanced abilities to defeat a foe.',0,0,0,0,0,0,0,0,0,0,0,65423,26124),
(118281,'','Use your Charge ability to cover the distance to this target dummy.',0,0,0,0,0,0,0,0,0,0,0,65424,26124),
(118282,'','But you cannot defeat an opponent that\'s out of reach. Fortunately, you have a skill to solve this problem.',0,0,0,0,0,0,0,0,0,0,0,65425,26124),
(118283,'','Arms warriors are the ultimate physical combatants, using martial skill and weaponry to crush those who stand against them.',0,0,0,0,0,0,0,0,0,0,0,65426,26124),
(118284,'Behold! The Altar of Light and Shadow shall infuse your weapon with its might!','',0,0,0,0,0,0,0,0,0,0,68739,0,26124),
(118339,'The Light is willing to serve.','The Light is willing to serve.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118340,'Yikes. What the heck is goin\' on around here?','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(118384,'','Tougher enemies may require a diverse set of abilities to overcome.',0,0,0,0,0,0,1,0,0,0,0,65514,26124),
(118385,'','Use Tiger\'s Fury to restore some energy and then attack the target dummy with Shred.',0,0,0,0,0,0,1,0,0,0,0,65534,26124),
(118386,'','Tiger\'s Fury restores some energy and also increases your damage for a short time.',0,0,0,0,0,0,1,0,0,0,0,65513,26124),
(118387,'','Most of your attacks require energy to use. You might find yourself low on energy at times, rendering you unable to use any abilities.',0,0,0,0,0,0,1,0,0,0,0,65495,26124),
(118388,'','Use Rake on the target dummy.',0,0,0,0,0,0,1,0,0,0,0,65524,26124),
(118389,'','Rake inflicts its damage over time, so you don\'t need to use it again until your target is no longer affected by it.',0,0,0,0,0,0,1,0,0,0,0,65500,26124),
(118390,'','Your Shred ability also deals extra damage to bleeding targets, so these are great abilities to use together.',0,0,0,0,0,0,1,0,0,0,0,75232,26124),
(118391,'','Rake will cause your target to bleed, wounding them over time.',0,0,0,0,0,0,1,0,0,0,0,65501,26124),
(118392,'','Once you\'ve reached your prey in stealth, it\'s time to ambush them.',0,0,0,0,0,0,1,0,0,0,0,65497,26124),
(118393,'','When you have 5 combo points, use Ferocious Bite on the target dummy.',0,0,0,0,0,0,1,0,0,0,0,65541,26124),
(118394,'','Try to use it when you have a full 5 combo points.',0,0,0,0,0,0,1,0,0,0,0,65516,26124),
(118395,'','Ferocious Bite is a finishing move that deals increased damage the more combo points you have.',0,0,0,0,0,0,1,0,0,0,0,65492,26124),
(118396,'','Both your Shred and Rake abilities generate combo points which can fuel powerful finishing moves.',0,0,0,0,0,0,1,0,0,0,0,65487,26124),
(118397,'','Use Shred on the target dummy while it\'s bleeding from Rake.',0,0,0,0,0,0,1,0,0,0,0,65528,26124),
(118398,'','Though powerful on its own, using Shred on a bleeding target increases its damage, so try keeping rake up.',0,0,0,0,0,0,1,0,0,0,0,65509,26124),
(118399,'','Your primary attack is Shred.',0,0,0,0,0,0,1,0,0,0,0,65550,26124),
(118400,'','Stealth lasts until you cancel it, attack, or take damage.',0,0,0,0,0,0,1,0,0,0,0,65506,26124),
(118401,'','Use Prowl to enter stealth.',0,0,0,0,0,0,1,0,0,0,0,65523,26124),
(118402,'','As a cat you can move with uncanny stealth, allowing you to approach your enemies undetected. Prowl puts you in stealth mode.',0,0,0,0,0,0,1,0,0,0,0,65483,26124),
(118403,'','Use Cat Form and assume the form of a cat.',0,0,0,0,0,0,1,0,0,0,0,65518,26124),
(118404,'','Soon they\'ll be weak enough for you to go for the throat with a mighty finishing move.',0,0,0,0,0,0,1,0,0,0,0,65504,26124),
(118405,'','As a feral druid your main weapon is shapeshifting. In Cat Form, your claws and fangs rip and bleed your opponents.',0,0,0,0,0,0,1,0,0,0,0,65485,26124),
(118406,'','You are not in Cat Form!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(118407,'','You need to be in Cat Form to fight!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(118408,'','Well done, $p! You are now prepared to do battle as a feral druid.',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(118409,'','Show me you fight with savagery and cunning!',0,0,0,0,0,0,1,0,0,0,0,65502,26124),
(118410,'','Thrash continues to damage your foes for a short period, so you don\'t need to use it again until your targets stops being affected by it.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118411,'','Use Thrash to damage several enemies at once.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118412,'','Thrash will damage all nearby enemies, causing them to bleed for a short time.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118413,'','When fighting multiple enemies at once a feral druid can become a whirlwind of fangs and claws, damaging everything around them.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118414,'','Use Swipe to damage several enemies at once.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118415,'','Swipe deals damage to all nearby foes, but that damage is increased if your targets are bleeding. It\'s a good idea to use Thrash and Swipe together.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118416,'','Thrash isn\'t your only tool for fighting multiple enemies.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118417,'','Use Survival Instincts to reduce incoming damage.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118418,'','Survival Instincts reduces incoming damage for a short time. Save it for when you really need it!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(118419,'','When in Cat Form you can rely on the instincts of an animal to help pull you through a tough fight.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118420,'','Use Entangling Roots to root my soldier to the ground.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118421,'','Entangling Roots will cause plant roots to spring from the ground and hold the target in place for a short time.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118422,'','Sometimes you need an enemy to stay put so you can close the distance to them... or make a hasty retreat.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118423,'','Use Rip on the target dummy with five combo points.',0,0,0,0,0,0,1,0,0,0,0,65526,26124),
(118424,'','Like Ferocious Bite, Rip is a finishing move, and is best used when you have 5 combo points.',0,0,0,0,0,0,1,0,0,0,0,65494,26124),
(118425,'','As an alternative to Ferocious Bite, Rip can be used to deal bleeding damage over time to your target, and is a good ability to spend combo points on early in a fight.',0,0,0,0,0,0,1,0,0,0,0,65486,26124),
(118426,'','Use Cat Form.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118427,'','Using spells will usually pull you out of shapeshift forms. Don\'t forget to return to cat form for combat.',0,0,0,0,0,0,0,0,0,0,0,65536,26124),
(118428,'','Use Regrowth to restore yourself to full health.',0,0,0,0,0,0,0,0,0,0,0,65522,26124),
(118429,'','After you\'ve taken damage, use Regrowth to restore your health.',0,0,0,0,0,0,0,0,0,0,0,65482,26124),
(118430,'','You also have the ability to call on the powers of nature for a variety of other abilities, like healing!',0,0,0,0,0,0,0,0,0,0,0,65484,26124),
(118431,'','Practice using Dash to increase your movement speed.',0,0,0,0,0,0,0,0,0,0,0,65498,26124),
(118432,'','Dash increases your movement speed significantly for a short time. It can\'t be used often, so save it for when you really need it.',0,0,0,0,0,0,0,0,0,0,0,65489,26124),
(118433,'','Ever needed to quickly get out of a sticky situation? You excel at doing this.',0,0,0,0,0,0,0,0,0,0,0,65491,26124),
(118434,'','Use Tiger\'s Fury!',0,0,0,0,0,0,0,0,0,0,0,65535,26124),
(118435,'','You\'re low on energy! Use Tiger\'s Fury!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118436,'','Use Thrash!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118437,'','Using Thrash then Swipe is a great combination!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118438,'','Now use Swipe!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118439,'','You\'re fighting multiple enemies, try using Swipe!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118440,'','Use Survival Instincts!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118441,'','Use Shred!',0,0,0,0,0,0,0,0,0,0,0,65530,26124),
(118442,'','Use Shred to generate combo points!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118443,'','Use Rip!',0,0,0,0,0,0,0,0,0,0,0,65527,26124),
(118444,'','You have 5 combo points! Use Rip!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118445,'','Rake has expired on your target! Use it again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118446,'','Use Rake!',0,0,0,0,0,0,0,0,0,0,0,65525,26124),
(118447,'','Use Prowl to enter stealth!',0,0,0,0,0,0,0,0,0,0,0,65505,26124),
(118448,'','Heal yourself with Healing Touch!',0,0,0,0,0,0,0,0,0,0,0,65493,26124),
(118449,'','Use Ferocious Bite!',0,0,0,0,0,0,0,0,0,0,0,65521,26124),
(118450,'','You have 5 combo points! Use Ferocious Bite now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118451,'','Cast Entangling Roots!',0,0,0,0,0,0,0,0,0,0,0,65488,26124),
(118452,'','Try to root the target before it can reach you! Let\'s try again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118453,'','Try using Entangling Roots to immobilize your target!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118454,'Let the Shadow embrace you.','Let the Shadow embrace you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118455,'I better get goin\'. Wouldn\'t want to end up dead.','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(118456,'','Shift back into Cat Form!',0,0,0,0,0,0,5,0,0,0,0,65552,26124),
(118477,'','Cast Solar Wrath!',0,0,0,0,0,0,0,0,0,0,0,65560,26124),
(118478,'','Cast Solar Wrath to generate Astral Power!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118479,'','Cast Sunfire!',0,0,0,0,0,0,0,0,0,0,0,65562,26124),
(118480,'','Cast Moonfire!',0,0,0,0,0,0,0,0,0,0,0,65563,26124),
(118481,'','Sunfire has expired on your target! Cast Sunfire on your target!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118482,'','Moonfire has expired on your target! Cast Moonfire on your target!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118483,'','Use Moonkin form!',0,0,0,0,0,0,0,0,0,0,0,65566,26124),
(118484,'','Use Lunar Strike to dispatch this group of enemies.',0,0,0,0,0,0,0,0,0,0,0,75272,26124),
(118485,'','A balance druid is well equipped to face multiple opponents at once.',0,0,0,0,0,0,0,0,0,0,0,75269,26124),
(118486,'','Use Celestial Alignment to increase damage, then use Solar Wrath on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118487,'','Need a boost of damage? Look to the stars!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118488,'','Well done, $p! You are now prepared to do battle as a balance druid.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118489,'','Show me that you can harness the power of the universe itself!',0,0,0,0,0,0,0,0,0,0,0,65572,26124),
(118490,'','Use Entangling Roots to root my warrior to the ground.',0,0,0,0,0,0,0,0,0,0,0,65573,26124),
(118491,'','Sometimes you need an enemy to stay put so you can close the distance to them... or make a hasty retreat.',0,0,0,0,0,0,0,0,0,0,0,65574,26124),
(118492,'','Use Solar Wrath on the target dummy until you have enough Astral Power to cast Starsurge.',0,0,0,0,0,0,0,0,0,0,0,65575,26124),
(118493,'','One of your most potent attacks, Starsurge unleashes a surge of stellar energy at your target.',0,0,0,0,0,0,0,0,0,0,0,65576,26124),
(118494,'','Use Solar Wrath on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65577,26124),
(118495,'','Once your enemy is taking damage from your other attacks, it\'s time to unleash Solar Wrath.',0,0,0,0,0,0,0,0,0,0,0,65578,26124),
(118496,'','Both these attacks deal damage over time. Once cast, you don\'t need to cast them again until their effect on the target has expired.',0,0,0,0,0,0,0,0,0,0,0,65579,26124),
(118497,'','Use Moonfire and Sunfire on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,65580,26124),
(118498,'','You wield the very power of night and day against your foes. Moonfire and Sunfire represent that power.',0,0,0,0,0,0,0,0,0,0,0,65581,26124),
(118499,'','Use Moonkin Form and assume the form of a wildkin.',0,0,0,0,0,0,0,0,0,0,0,65582,26124),
(118500,'','As a balance druid the sun, moon, and stars are your allies, enabling you to unleash these primal powers upon your enemies.',0,0,0,0,0,0,0,0,0,0,0,65583,26124),
(118501,'','Entangling Roots will cause plant roots to spring from the ground and hold the target in place for a short time.',0,0,0,0,0,0,0,0,0,0,0,65584,26124),
(118502,'','Lunar Strike deals damage directly to your target, but also deals damage to nearby foes.',0,0,0,0,0,0,0,0,0,0,0,75270,26124),
(118503,'','Celestial Alignment causes the celestial bodies to align, increasing the damage of your solar and lunar spells for a short time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118504,'','Starsurge costs Astral Power, so use Solar Wrath to build up your reserves.',0,0,0,0,0,0,0,0,0,0,0,65587,26124),
(118505,'','Solar Wrath is a ranged ability that deals damage and generates Astral Power, a resource used to fuel more powerful attacks.',0,0,0,0,0,0,0,0,0,0,0,65588,26124),
(118506,'','These attacks deal their damage over time, and either makes an excellent start to a battle.',0,0,0,0,0,0,0,0,0,0,0,65589,26124),
(118507,'','You can shapeshift into Moonkin form, which increases both your damage and defense.',0,0,0,0,0,0,0,0,0,0,0,65590,26124),
(118508,'','You\'re at maximum Astral Power. Cast Starsurge!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118509,'','Cast Lunar Strike!',0,0,0,0,0,0,0,0,0,0,0,75271,26124),
(118510,'','Cast Entangling Roots!',0,0,0,0,0,0,0,0,0,0,0,65593,26124),
(118511,'','Try to root the target before it can reach you! Let\'s try again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118512,'','Try using Entangling Roots to immobilize your target!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118513,'','Cast Starsurge!',0,0,0,0,0,0,0,0,0,0,0,65596,26124),
(118514,'','Starsurge is available! Cast it now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118515,'Let our eternal foe tremble before the fury and destruction you unleash!','',0,0,0,0,0,0,4,0,0,42707,68720,0,26124),
(118518,'An illusion! What are you hiding?','An illusion! What are you hiding?',0,0,0,0,0,0,0,0,0,0,65819,66003,26124),
(118519,'Something\'s not quite right...','Something\'s not quite right...',0,0,0,0,0,0,0,0,0,0,65803,66004,26124),
(118520,'Who goes there?!','Who goes there?!',0,0,0,0,0,0,0,0,0,0,65802,66005,26124),
(118521,'','DELETE',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118522,'','$n, come forward.',0,0,0,0,0,0,396,0,0,0,0,66548,26124),
(118523,'','Turn and face your peers, $p, so that they may bear witness to your ruthlessness and cunning.',0,0,0,0,0,0,396,0,0,0,0,66549,26124),
(118524,'','Before you stands the Horde\'s greatest champion, hero of countless victories against our unrelenting foe.',0,0,0,0,0,0,396,0,0,0,0,66550,26124),
(118525,'','The ancient weapon they wield inspires fear in the hearts of those who would threaten our way of life.',0,0,0,0,0,0,396,0,0,0,0,66551,26124),
(118526,'','So join me, heroes, in honoring $p, bane of the Alliance!',0,0,0,0,0,0,396,0,0,0,0,66552,26124),
(118527,'','For the Horde!',0,0,0,0,0,0,396,0,0,0,0,66553,26124),
(118528,'It went quickly this time. But in the future, it will take longer to recruit more Ashtongue.','',0,0,0,0,0,0,0,0,0,0,70517,0,26124),
(118529,'','Hello, my dear. It\'s always good to see you.\n\nWhat can I help with?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(118530,'Greetings, $n. I suppose an explanation is in order if there is ever to be any trust between us.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(118531,'Yes, tell me everything, Loramus.','Yes, tell me everything, Loramus.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118532,'Where to begin? I suppose the only thing that matters was the battle between me and the demon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118533,'Razelikh the Defiler was a dreadlord who had been charged with the conquest of the Blasted Lands. I traveled there to stop him. But, that did not turn out the way that I had planned.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(118534,'In the end, the Defiler possessed me, and in turn, I sacrificed myself so that we both would die. Our souls were trapped within an enchanted blade to battle for all eternity.','',15,0,0,0,0,0,0,0,0,0,0,0,26124),
(118535,'Some time later, the blade was destroyed. Our souls escaped only to be sent to the Twisting Nether. However, Razelikh has a very powerful demon soul. As happens with many dreadlords, a new body eventually formed. It is said that they can only truly be killed within the Twisting Nether.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(118536,'Within this new body, our souls are still entwined in eternal conflict. I am in control... most of the time, though it is a constant struggle. We demon hunters are accustomed to containing the demon within.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(118537,'The next thing I knew, we were expelled from the Twisting Nether, summoned by the Burning Legion to the invasion of Azeroth. At the Felblaze Ingress, I did my best to disrupt their efforts.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(118538,'The rest, you know. Your champion came and retrieved me, and here I am.','',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(118539,'I will gladly serve if you will have me. I have access to all of Razelikh\'s knowledge. Allow me to aid you in the war against the Legion.','',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(118540,'Would you get down here already? We got work to do!','Would you get down here already? We got work to do!',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(118541,'C\'mon! We can\'t wait all day! It\'s safe. I promise!','C\'mon! We can\'t wait all day! It\'s safe. I promise!',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(118542,'We got our own muscle right here. Trust me! We\'re safe.','We got our own muscle right here. Trust me! We\'re safe.',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(118543,'I can\'t wait all day. Someone\'s gotta fix these shredders.','I can\'t wait all day. Someone\'s gotta fix these shredders.',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(118544,'Now\'s not the time. Get down already!','Now\'s not the time. Get down already!',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(118545,'I don\'t know... It doesn\'t look too safe to me.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(118546,'Last time you said that one of those demons almost ate me alive!','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(118547,'I\'m just, uh... checkin\' to see if it\'s clear up here. Ayep... it\'s clear alright.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(118548,'I\'d rather be safe than dead!','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(118549,'What if they come back?','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(118550,'Find me when this is over, $n. The Frostwolf could use a $c like you.','',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(118551,'Quick, quick, through my portal! Flee!','',0,0,0,0,0,0,0,0,0,0,66437,0,26124),
(118552,'Meet me at the temple of Fal\'adora. We must study the past to preserve our future.','',0,0,0,0,0,0,0,0,0,0,66380,0,26124),
(118553,'Many years ago, exiles from the shielded city came to rest here.','',0,0,0,0,0,0,0,0,0,0,66381,0,26124),
(118554,'Even in this state, the arcan\'dor continues to grow.','',0,0,0,0,0,0,0,0,0,0,66382,0,26124),
(118555,'We must learn why the old arcan\'dor failed. Its shattered bones may have the answers.','',0,0,0,0,0,0,0,0,0,0,66383,0,26124),
(118556,'Here we go!','',0,0,0,0,0,0,603,0,0,0,66389,0,26124),
(118557,'Greetings, and thank you for helping to test the Legion Beta! \n\nI can provide you with select provisions for your Order Hall.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118558,'I need a supply of Order Hall Resources.','I need a supply of Order Hall Resources.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118559,'|TInterface\\Icons\\creatureportrait_cyclone_nodebris:20|t%s interrupts the Anomaly with a |cFFFF0000|Hspell:212115|h[Temporal Smash]|h|r!','|TInterface\\Icons\\creatureportrait_cyclone_nodebris:20|t%s interrupts the Anomaly with a |cFFFF0000|Hspell:212115|h[Temporal Smash]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118560,'The fel bat screeches in pain as you drive your weapon into it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118561,'May this blessing illuminate your path to victory, $ct!','',0,0,0,0,0,0,0,0,0,0,69023,0,26124),
(118562,'Now those are weapons truly worthy of one who commands the Shadows! May your blades strike silent and true.','',0,0,0,0,0,0,0,0,0,0,69021,0,26124),
(118563,'You have ever been a champion of the Light. Now you hold a weapon truly worthy of the noble cause you serve!','',0,0,0,0,0,0,0,0,0,0,69022,0,26124),
(118564,'May your weapon serve you well on the path to victory!','',0,0,0,0,0,0,0,0,0,0,69024,0,26124),
(118565,'Nature\'s essence flows through your weapon! In your hands, it shall make the dark forces threatening Azeroth tremble! Andu-falah-dor!','',0,0,0,0,0,0,0,0,0,0,69029,0,26124),
(118566,'Yes! Such wicked glory awaits you! With this weapon, you will bind the Legion to our will! Even Kil\'jaeden will cower like a craven dog!','',0,0,0,0,0,0,0,0,0,0,68751,0,26124),
(118567,'Raise your blade before the forge. Watch it infuse the weapon with its might!','',0,0,0,0,0,0,0,0,0,0,68719,0,26124),
(118568,'Let our eternal foe tremble before the fury and destruction you unleash!','',0,0,0,0,0,0,4,0,0,42710,69019,0,26124),
(118569,'','Out here, so far from the Nightwell, we must settle for any source of magic we can find.',0,0,0,0,0,0,1,0,0,0,0,67480,26124),
(118570,'','It seems Thalyssra and I had the same idea - the old leyline feeds might keep us alive, if barely.',0,0,0,0,0,0,1,0,0,0,0,67481,26124),
(118571,'','We just have to wake them up.',0,0,0,0,0,0,0,0,0,0,0,67482,26124),
(118572,'King\'s honor, $p.','King\'s honor, $p.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118573,'You remember. You were there.','',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(118574,'Dark Lady watch over you, $p.','Dark Lady watch over you, $p.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118575,'','There... you found something, didn\'t you?',1,0,0,0,0,0,0,0,0,0,0,67463,26124),
(118576,'','Something which gave you peace...',1,0,0,0,0,0,0,0,0,0,0,67464,26124),
(118577,'Hail, champion.','Hail, champion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118578,'<Leave and join the assault on Broken Shore>','<Leave and join the assault on Broken Shore>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118579,'Let\'s begin the assault on Broken Shore!','Let\'s begin the assault on Broken Shore!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118580,'<The gryphon\'s wings flap in anticipation of the coming battle>','<The gryphon\'s wings flap in anticipation of the coming battle>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118581,'Thank you, Highlord. I... I was blinded by revenge.','',0,0,0,0,0,0,0,0,0,0,68381,0,26124),
(118582,'So many paid for my foolish mistake. This is not the way of righteousness, and I see that now.','',0,0,0,0,0,0,0,0,0,0,68382,0,26124),
(118583,'','A peace we so desperately need for ourselves.',6,0,0,0,0,0,0,0,0,0,0,67466,26124),
(118584,'','You are alive, Boros, and that is what matters. Come, let us return to Light\'s Hope Chapel.',0,0,0,0,0,0,1,0,0,0,0,68362,26124),
(118585,'No! Hodir! What have they done to you?!','',0,0,0,0,0,0,0,0,0,0,68392,0,26124),
(118586,'Ahh a gift fit for a queen. You have my thanks...','',0,0,0,0,0,0,0,0,6,0,67272,0,26124),
(118587,'Now the power of the arcan\'dor is mine!','',0,0,0,0,0,0,0,0,6,0,67273,0,26124),
(118588,'No! What have you done?!','',0,0,0,0,0,0,0,0,0,0,67274,0,26124),
(118589,'Come, my children! Feast on their bones!','',0,0,0,0,0,0,0,0,0,0,67494,0,26124),
(118590,'The arcan\'dor will live again! With its power, we shall return to the surface!','',0,0,0,0,0,0,0,0,0,0,67493,0,26124),
(118591,'Nothing escapes from my web!','',0,0,0,0,0,0,0,0,0,0,67495,0,26124),
(118592,'Hgnh... my prize... it grows heavy...','',0,0,0,0,0,0,0,0,0,0,67496,0,26124),
(118593,'The seed is awakening. It thirsts.','',0,0,0,0,0,0,0,0,0,0,67497,0,26124),
(118594,'It is an arcan\'dor - a gift of the ancient magi.','',0,0,0,0,0,0,0,0,0,0,67528,0,26124),
(118595,'A tree, made to feed upon the leyline. It can bring life... or desolation.','',0,0,0,0,0,0,0,0,0,0,67529,0,26124),
(118596,'To care for the arcan\'dor is a great burden - one which we now share.','',0,0,0,0,0,0,0,0,0,0,67530,0,26124),
(118597,'','Pleasure to see you again, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118598,'','So this is what the chamber was built for... but what is it?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118599,'Let\'s continue research on my artifact.','Let\'s continue research on my artifact.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118600,'HATE!!','',0,0,0,0,0,0,0,0,0,0,68406,0,26124),
(118601,'','We are masters of the arcane, night elf. I think we can handle a tree.',0,0,0,0,0,0,0,0,0,0,0,67531,26124),
(118602,'','I saw you leave for the Broken Shore. Please, tell me, did you see my husband?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118603,'','His locket? Where did you get this?\n\nNo! I don\'t believe you! He can\'t be gone! \n\nCedric, oh my dear Cedric, please come back to me.\n\nDon\'t leave me all alone...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118604,'Hmph. Arrogant. In time, you will see.','',0,0,0,0,0,0,0,0,0,0,67532,0,26124),
(118605,'Do you recognize this locket?','Do you recognize this locket?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118606,'Give Alaina the Charred Locket?','Give Alaina the Charred Locket?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118607,'Beneath the arcan\'dor, you will be renewed. There is no other path now.','',0,0,0,0,0,0,0,0,0,0,67533,0,26124),
(118608,'Valewalker finale lines.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118609,'','Valtrois finale lines.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118610,'','What is happening?',0,0,0,0,0,0,0,0,0,0,0,67312,26124),
(118611,'The arcan\'dor is at a critical stage.','',0,0,0,0,0,0,0,0,0,0,67313,0,26124),
(118612,'Without enough power to mature into its final form, it will die.','',0,0,0,0,0,0,0,0,0,0,67314,0,26124),
(118613,'Can you repair my equipment?','Can you repair my equipment?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118614,'','Outlander, speak with Valtrois at once!',0,0,0,0,0,0,0,0,0,0,0,67315,26124),
(118615,'','You must activate the remaining leyline feeds.',0,0,0,0,0,0,0,0,0,0,0,67317,26124),
(118616,'','Every leyline feed is active and at full power!',0,0,0,0,0,0,0,0,0,0,0,67318,26124),
(118617,'It is not enough...','',0,0,0,0,0,0,0,0,0,0,67319,0,26124),
(118618,'','Valtrois, can you think of any way to draw more power? Even briefly?',0,0,0,0,0,0,0,0,0,0,0,67320,26124),
(118619,'','Hmm... The main conduit beneath Suramar city pulls ten times what we have here.',0,0,0,0,0,0,0,0,0,0,0,67321,26124),
(118620,'','If that leyline were to flare up, the surge could theoretically reach all the way back to Shal\'Aran.',0,0,0,0,0,0,0,0,0,0,0,67322,26124),
(118621,'','Their warlocks strike from above!',0,0,0,0,0,0,0,0,0,0,0,68407,26124),
(118622,'','What could make the leyline flare up?',0,0,0,0,0,0,0,0,0,0,0,67323,26124),
(118623,'A manastorm might do the trick.','',0,0,0,0,0,0,0,0,0,0,67324,0,26124),
(118624,'','A manastorm, are you insane?',0,0,0,0,0,0,0,0,0,0,0,67325,26124),
(118625,'Yes. But it could work! We create a localized warp field, then-','',0,0,0,0,0,0,0,0,0,0,67326,0,26124),
(118626,'','Spare us the details, just make it happen. I am counting on you.',0,0,0,0,0,0,0,0,0,0,0,67327,26124),
(118627,'Yes, ma\'am!','',0,0,0,0,0,0,0,0,0,0,67328,0,26124),
(118628,'','Right away.',0,0,0,0,0,0,0,0,0,0,0,67329,26124),
(118629,'I heard about this crazy job you guys are planning. You weren\'t thinking of leaving me out, were you?','',0,0,0,0,0,0,0,0,0,0,67301,0,26124),
(118630,'Look, I am not blind. I see what is happening in Suramar.','',0,0,0,0,0,0,1,0,0,0,67303,0,26124),
(118631,'I am not sitting this one out. The stakes are too high. So I am in, you got that?','',0,0,0,0,0,0,0,0,0,0,67304,0,26124),
(118632,'Oh and don\'t worry about my usual fee - you can pay me when the job is done.','',0,0,0,0,0,0,1,0,0,0,67305,0,26124),
(118633,'My Lord! We\'re under attack... it\'s... it\'s the Ebon Blade!','',0,0,0,0,0,0,0,0,0,0,69442,0,26124),
(118634,'','I will not let you destroy my newest pet! When I\'m through with you, you will all serve the Legion!',0,0,0,0,0,0,0,0,0,0,0,68403,26124),
(118635,'We have come for the body of Tirion Fordring. Do not make this harder than it needs to be.','',0,0,0,0,0,0,0,0,0,0,68900,0,26124),
(118636,'You will not succeed, Darion. The Light will not allow it!','',0,0,0,0,0,0,0,0,0,0,69443,0,26124),
(118637,'The eredar witch! Defeating her is our last chance to save Hodir!','',0,0,0,0,0,0,0,0,0,0,68391,0,26124),
(118638,'The fel energy... it is gone...','',0,0,0,0,0,0,0,0,0,0,68404,0,26124),
(118639,'The Legion will pay for this!','',0,0,0,0,0,0,0,0,0,0,68405,0,26124),
(118640,'','I thought you were only interested in lining your pockets.',0,0,0,0,0,0,1,0,0,0,0,67302,26124),
(118641,'Oh and don\'t worry about my usual fee - you can pay me when the job is done.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118642,'Beginning survey...','',0,0,0,0,0,0,0,0,0,0,67310,0,26124),
(118643,'All set. I believe I have the coordinates we need.','',0,0,0,0,0,0,0,0,0,0,67311,0,26124),
(118644,'Alright everybody, gather in close. Do not be shy now. Group hug.','',0,0,0,0,0,0,0,0,0,0,67337,0,26124),
(118645,'Hmm... a little tart, with a hint of- oh, my... there it is.','',0,0,0,0,0,0,0,0,0,0,67372,0,26124),
(118646,'I will teleport you in past the main defenses. When you are ready to leave, activate this beacon so I can locate you and pull you back.','',0,0,0,0,0,0,1,0,0,0,67333,0,26124),
(118647,'Now this is important - once that manastorm gets going, there will be too much interference for me to teleport anyone. You must get out before the storm!','',0,0,0,0,0,0,5,0,0,0,67334,0,26124),
(118648,'Get in, plant the device, get out before it goes off. Not the most complicated job I have been on.','',0,0,0,0,0,0,1,0,0,0,67335,0,26124),
(118649,'','But the most important, by far. If we fail, Suramar is doomed.',0,0,0,0,0,0,396,0,0,0,0,67336,26124),
(118650,'It seems your... Deathlord... has finally arrived.','',0,0,0,0,0,0,1,0,0,0,69444,0,26124),
(118651,'You should watch your tone, Galen.','',0,0,0,0,0,0,25,0,0,0,69445,0,26124),
(118652,'You are fighting against a power you cannot even comprehend!','',0,0,0,0,0,0,25,0,0,0,69446,0,26124),
(118653,'I owe you a debt of gratitude.','I owe you a debt of gratitude.',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(118654,'Your aide is greatly appreciated.','Your aide is greatly appreciated.',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(118655,'Rest first, then retribution.','Rest first, then retribution.',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(118656,'Continue to fight. We mustn\'t wane.','Continue to fight. We mustn\'t wane.',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(118657,'The battle has only begun.','The battle has only begun.',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(118658,'Your assistance is highly valued.','Your assistance is highly valued.',0,0,0,0,0,0,2,1,0,0,0,0,26124),
(118659,'The Horde rises.','The Horde rises.',0,0,0,0,0,0,113,1,0,0,0,0,26124),
(118660,'','Yes. We are close.',0,0,0,0,0,0,0,0,0,0,0,67339,26124),
(118661,'This is not looking real conduit-y. You sure the old man knows his stuff?','',0,0,0,0,0,0,0,0,0,0,67338,0,26124),
(118663,'I never met a lock I could not open.','',0,0,0,0,0,0,0,0,0,0,67340,0,26124),
(118664,'Just give me one moment.','',0,0,0,0,0,0,0,0,0,0,67341,0,26124),
(118665,'','There! Place the manastorm generator near the conduit.',0,0,0,0,0,0,0,0,0,0,0,67342,26124),
(118666,'Are you ready to depart to Black Rook Hold?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118667,'I am ready to go.','I am ready to go.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118668,'Whatever you gotta do, do it quick! Lots of guards heading our way.','',0,0,0,0,0,0,0,0,0,0,67343,0,26124),
(118669,'','Something is wrong... The temporal warp sequencer-',0,0,0,0,0,0,0,0,0,0,0,67344,26124),
(118670,'','The fuse is broken. We must trigger the manastorm manually.',0,0,0,0,0,0,0,0,0,0,0,67346,26124),
(118671,'You\'ve found Timirgos!','You\'ve found Timirgos!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118672,'We must hurry.','We must hurry.',0,0,0,0,0,0,0,0,0,0,0,66391,26124),
(118673,'Help! I cannot fight these creatures!','Help! I cannot fight these creatures!',0,0,0,0,0,0,0,0,0,0,0,66392,26124),
(118674,'I am too weak to defend myself. Help!','I am too weak to defend myself. Help!',0,0,0,0,0,0,0,0,0,0,0,66393,26124),
(118675,'We must reach our destination, and quickly.','We must reach our destination, and quickly.',0,0,0,0,0,0,0,0,0,0,0,66394,26124),
(118676,'I cannot last too much longer.','I cannot last too much longer.',0,0,0,0,0,0,0,0,0,0,0,66395,26124),
(118677,'You must protect me!','You must protect me!',0,0,0,0,0,0,0,0,0,0,0,66396,26124),
(118678,'Hunger.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118679,'Small words, please.','',0,0,0,0,0,0,0,0,0,0,67345,0,26124),
(118680,'Wait, aren\'t we supposed to leave BEFORE the storm starts?','',0,0,0,0,0,0,0,0,0,0,67347,0,26124),
(118681,'','We have no choice. This must be done.',0,0,0,0,0,0,0,0,0,0,0,67348,26124),
(118682,'','Rath, anu\'telar!',0,0,0,0,0,0,0,0,0,0,0,67349,26124),
(118683,'','We just need to hold out until the storm is over!',0,0,0,0,0,0,0,0,0,0,0,67350,26124),
(118684,'Easier said than done...','',0,0,0,0,0,0,0,0,0,0,67351,0,26124),
(118685,'Hi!','',0,0,0,0,0,0,0,0,0,0,66398,0,26124),
(118686,'Do you want some magic juice? I\'m full.','',0,0,0,0,0,0,0,0,0,0,66399,0,26124),
(118687,'Wanna play with us? You have to be the bad guy though.','',0,0,0,0,0,0,0,0,0,0,66400,0,26124),
(118688,'Wow, you\'re tall!','',0,0,0,0,0,0,0,0,0,0,66401,0,26124),
(118689,'I\'m not in trouble, right?','',0,0,0,0,0,0,0,0,0,0,66402,0,26124),
(118690,'The sky is amazing!','',0,0,0,0,0,0,0,0,0,0,66403,0,26124),
(118691,'','The sky is amazing!',0,0,0,0,0,0,0,0,0,0,0,66409,26124),
(118692,'','I\'m not in trouble, right?',0,0,0,0,0,0,0,0,0,0,0,66408,26124),
(118693,'','Wow, you\'re tall!',0,0,0,0,0,0,0,0,0,0,0,66407,26124),
(118694,'','Wanna play with us? You have to be the bad guy though.',0,0,0,0,0,0,0,0,0,0,0,66406,26124),
(118695,'','Do you want some magic juice? I\'m full.',0,0,0,0,0,0,0,0,0,0,0,66405,26124),
(118696,'','Hi!',0,0,0,0,0,0,0,0,0,0,0,66404,26124),
(118697,'Ye won\'t be takin\' this son of Ironforge. Eat lead!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118698,'Is that all ye\'ve got? I could do this all day!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118699,'','Look out!',0,0,0,0,0,0,0,0,0,0,0,67352,26124),
(118700,'The manastorm is only getting stronger! We need to shut that thing down!','',0,0,0,0,0,0,0,0,0,0,67354,0,26124),
(118701,'There\'s nae hope left for any of us, don\'t ye see that?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118702,'Thank... ye...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118704,'','Erath-omnas!',0,0,0,0,0,0,0,0,0,0,0,67353,26124),
(118705,'','It is too dangerous! The arcane torrents would tear us apart!',0,0,0,0,0,0,0,0,0,0,0,67355,26124),
(118706,'Damn it...','',0,0,0,0,0,0,0,0,0,0,67356,0,26124),
(118707,'You guys owe me...','',0,0,0,0,0,0,0,0,0,0,67357,0,26124),
(118708,'','What are you doing?!',0,0,0,0,0,0,0,0,0,0,0,67358,26124),
(118709,'','Arluin! NO!!',0,0,0,0,0,0,0,0,0,0,0,67359,26124),
(118710,'Hhghh-AAAHHHH!!!','',0,0,0,0,0,0,0,0,0,0,67360,0,26124),
(118711,'','Oculeth, get us out of here!',0,0,0,0,0,0,0,0,0,0,0,67361,26124),
(118712,'','Ugh... we made it...',0,0,0,0,0,0,0,0,0,0,0,67362,26124),
(118713,'','Where is Arluin?!',0,0,0,0,0,0,0,0,0,0,0,67363,26124),
(118714,'','Oh no...',0,0,0,0,0,0,0,0,0,0,0,67364,26124),
(118715,'<cough> Nghh...','',0,0,0,0,0,0,0,0,0,0,67365,0,26124),
(118716,'','Do not speak! You are wounded-',0,0,0,0,0,0,0,0,0,0,0,67366,26124),
(118717,'Hey... <cough> Tell Vanthir I said... thanks... for every...','',0,0,0,0,0,0,0,0,0,0,67369,0,26124),
(118718,'We pulled it off... <wheeze> didn\'t we?','',0,0,0,0,0,0,0,0,0,0,67367,0,26124),
(118719,'','Yes. You saved us. Please... try to rest.',0,0,0,0,0,0,0,0,0,0,0,67368,26124),
(118720,'','He is gone.',0,0,0,0,0,0,0,0,0,0,0,67370,26124),
(118721,'','Come... Let us check on the others.',0,0,0,0,0,0,0,0,0,0,0,67371,26124),
(118722,'','A very good day to you, $n. I trust that the affairs of the Uncrowned are in order?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(118723,'Behold. The gift of the ancient magi.','',0,0,0,0,0,0,0,0,0,0,67330,0,26124),
(118724,'','I am ready to go wherever is needed, do whatever it takes, to assure the goals of the Uncrowned are met.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(118725,'The arcan\'dor will not merely sustain you. By the fruit of its bough, you will be made whole again.','',0,0,0,0,0,0,0,0,0,0,67332,0,26124),
(118726,'$n, is it? I have heard your name spoken among the vrykul.$b$bThese cliffs have gone quiet. Return at a later time to prove yourself in combat among the beasts of this peninsula.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118727,'','The Raven\'s Eye is the key to deciphering the SI:7 letter.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(118728,'Fascinating! Look here, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118729,'These orbs of ley energy seem to be following some sort of pattern.  I wonder where they lead?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118730,'Why don\'t you find out?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118731,'Get them in the boats. The Soul Engine requires fuel!','',0,0,0,0,0,0,0,0,0,0,67603,0,26124),
(118732,'Stop your sniveling! You give your lives for a worthy cause.','',0,0,0,0,0,0,0,0,0,0,67604,0,26124),
(118733,'Outstanding, $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118734,'The Legion welcomes your sacrifice. You should feel proud!','',0,0,0,0,0,0,0,0,0,0,67605,0,26124),
(118735,'You will not be missed. Take comfort in that.','',0,0,0,0,0,0,0,0,0,0,68246,0,26124),
(118736,'Keep moving. We must not keep the Soul Engine waiting.','',0,0,0,0,0,0,0,0,0,0,67606,0,26124),
(118737,'What is going on here?','What is going on here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118738,'Get moving!','Get moving!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118739,'','This tree came at a high cost... You are sure it can sustain us?',0,0,0,0,0,0,0,0,0,0,0,67331,26124),
(118740,'Through this shallow ravine wander goats, stags, worgs, and bears. Ferocious beasts indeed, but all can be tamed if you demonstrate your strength.$b$bBest the creatures in a fight and they will show you obedience. Mounted atop them, you can send your enemies to their deaths on the rocks below.$b$bBut beware Stormtalon, the dragon that rests along the rocks of Storm\'s Reach. Many say he cannot be tamed. Few have tried. None have survived.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118741,'So, $n, at last you\'ve come to prove yourself on the peninsula of Storm\'s Reach! You\'ve shown you are brave, but bravery is not enough here.$b$bThe wild beasts of this ravine care nothing for your past heroics. They answer only to power.$b$bRight now, heroes like you attempt to tame these beasts and best each other in combat. Are you up to the challenge?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(118742,'Astounding.','',0,0,0,0,0,0,0,0,0,0,67373,0,26124),
(118743,'Run!','Run!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118744,'The entire journal is filled with notes on the cave\'s effects on the local flora and fauna, but a few entries catch your eye.\n\nEntry #5:\nThe properties of this cave are interesting. I have brought crystals from my workshop and set them around the area to see what effect the energies here will have on them. \n\nEntry #17: \nAfter attuning with the crystals, I can create barriers of energy capable of negating all forms of magic against me. This discovery could lead to whole armies of invulnerable soldiers! \n\nEntry #23:\nThe barrier is not without its flaws. While attuned to all three crystals, another user could combine their power to negate the barrier. I must work to fix this flaw before I show this work to my superiors.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118745,'Highlord, our scouts report that Balnazzar is in this valley. We can corner him if we act quickly!','',0,0,0,0,0,0,25,0,0,0,68388,0,26124),
(118746,'','Boros!',0,0,0,0,0,0,603,0,0,0,0,68364,26124),
(118747,'','We must find Mathias Shaw and use him to prove that Detheroc has taken his place.',0,0,0,0,0,0,0,0,0,0,0,69497,26124),
(118748,'Now is friend\'s chance! Use altar to summon bad portals, not good ones! Quick!','',0,0,0,0,0,0,0,0,0,0,66433,0,26124),
(118749,'Champions, you\'ve done it! I sense Gul\'dan\'s ritual growing in power, we must hurry.  I can teleport you back to the Nighthold. Are you prepared?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118750,'I want to go to the Court of Stars (Dungeon).','I want to go to the Court of Stars (Dungeon).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118751,'I\'m ready.','I\'m ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118752,'','You will not interfere with my research!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118753,'','Perhaps there is a new path for us after all...',0,0,0,0,0,0,0,0,0,0,0,67374,26124),
(118754,'Pitiful creatures... you\'ll die screaming!','',0,0,0,0,0,0,0,0,0,0,68360,0,26124),
(118755,'|TInterface\\Icons\\shaman_pvp_lightninglasso:20|t%s is casting |cFFFF0000|Hspell:220101|h[Deathbolt]|h|r! Interrupt it!','|TInterface\\Icons\\shaman_pvp_lightninglasso:20|t%s is casting |cFFFF0000|Hspell:220101|h[Deathbolt]|h|r! Interrupt it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118756,'','You have my thanks, outlander.',0,0,0,0,0,0,0,0,0,0,0,67375,26124),
(118758,'Ahhh, the defenders of the Light arrive. We have been waiting.','',0,0,0,0,0,0,0,0,6,0,68334,0,26124),
(118759,'You can go no further, Balnazzar. I will have justice for my slain brethren!','',0,0,0,0,0,0,0,0,6,0,68385,0,26124),
(118760,'Justice...or vengeance, paladin? Choose carefully, for hatred leads down a dark path.','',0,0,0,0,0,0,0,0,6,0,68335,0,26124),
(118761,'You will die by my blade!','',0,0,0,0,0,0,0,0,6,0,68386,0,26124),
(118762,'Auuuuughhhhhh! Auuuughhhh!','',0,0,0,0,0,0,0,0,6,0,68387,0,26124),
(118763,'Pitiful. Jarvox, take care of his execution. Slowly and with great agony, if you will.','',0,0,0,0,0,0,0,0,6,0,68336,0,26124),
(118765,'Feeding time nears, my pets!','',0,0,0,0,0,0,0,0,0,0,70855,0,26124),
(118766,'Fresh meat dangles for the taking!','',0,0,0,0,0,0,0,0,0,0,70854,0,26124),
(118767,'Fuel for the fel...','',0,0,0,0,0,0,0,0,0,0,70853,0,26124),
(118768,'A fate worse than death awaits you, little draenei!','',0,0,0,0,0,0,0,0,0,0,70852,0,26124),
(118769,'The hounds will eat well with this one!','',0,0,0,0,0,0,0,0,0,0,70851,0,26124),
(118770,'Devour this morsel slowly, my pets!','',0,0,0,0,0,0,0,0,0,0,70850,0,26124),
(118771,'','We are on the brink of a new age for the Nightborne.',0,0,0,0,0,0,0,0,0,0,0,67376,26124),
(118772,'','Without you, none of this would have been possible.',0,0,0,0,0,0,0,0,0,0,0,67377,26124),
(118773,'','For now, we shall gather our strength. When the time comes, I trust we can call upon you to help us liberate Suramar.',0,0,0,0,0,0,0,0,0,0,0,67378,26124),
(118774,'','Who is there?',0,0,0,0,0,0,0,0,0,0,0,67306,26124),
(118775,'','<Cough.> Arluin, is that you? It is so dark...',0,0,0,0,0,0,0,0,0,0,0,67307,26124),
(118776,'','I understand... He never could stay out of trouble...',0,0,0,0,0,0,0,0,0,0,0,67308,26124),
(118777,'','Thank you... I will remember this.',0,0,0,0,0,0,0,0,0,0,0,67309,26124),
(118778,'','Set up the explosive distractions around Felsoul Hold. I will meet you there.',0,0,0,0,0,0,0,0,0,0,0,69498,26124),
(118779,'The terrible light of the outside world hurts your rat\'s eyes! Return to the Underbelly!','The terrible light of the outside world hurts your rat\'s eyes! Return to the Underbelly!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(118780,'Setting','Setting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(118781,'Greetings, High Priest. What can I do for you?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(118782,'The storm clouds gather...','',0,0,0,0,0,0,0,0,0,0,68817,0,26124),
(118783,'Open the skies!','',0,0,0,0,0,0,0,0,0,0,68821,0,26124),
(118784,'','Sorry, ace. I can\'t risk losing my business over this. I\'ll be back when it\'s safe.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118797,'We have retreated into the collapsed shaft on the northern edge of the Crystal Hall. We are holding back the demon onslaught, but our defenses are quickly falling apart!','',0,0,0,0,0,0,0,0,0,0,70823,0,26124),
(118798,'These acolytes will serve you well.','',0,0,0,0,0,0,1,0,0,0,68288,0,26124),
(118799,'We cannot afford to make careless assumptions, Alonsus. We need to find out if this shadow priest speaks the truth.','',0,0,0,0,0,0,1,0,0,0,68277,0,26124),
(118800,'Another shadow priest spouting nonsense. I can\'t say I\'m surprised. Things like this are bound to happen when you linger too close to the void.','',0,0,0,0,0,0,1,0,0,0,68302,0,26124),
(118802,'I am pleased to offer you my services.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(118803,'Make \'em dead! And be quick about it.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(118804,'Make yerself useful and lend us a hand. Does nobody no good with you just standin\' round here.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(118805,'What? Who sent you? I asked fer the best $c they could muster, an\' they sent you?$B$BWell then... ye best get ta work. Plenty of demons runnin\' about. Don\'t be shy about it.','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(118806,'Get ready! It\'s comin\' down!','',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(118807,'They\'re taunting us, you know. The shadows. They see our demise.','',0,0,0,0,0,0,1,0,0,0,68289,0,26124),
(118808,'This war will not be won without sacrifice. Tirion understood the price of freedom.','',0,0,0,0,0,0,0,0,0,0,68899,0,26124),
(118809,'Tirion\'s body rests below, us in the Hall of Champions. We will join you shortly, Deathlord.','',0,0,0,0,0,0,0,0,0,0,68898,0,26124),
(118810,'The demons killed most of my shaman. We retreated here to make one last stand.$B$B<Nobundo sighs.>$B$BIf you are here to help, then prepare yourself for a great battle, friend!$B$BI think I hear the next battalion coming. Are you ready?','',1,1,6,0,0,0,0,0,0,0,0,0,26124),
(118811,'They\'re taunting us, you know. The shadows. They see our end.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(118812,'I am ready, Nobundo! Let them come!','I am ready, Nobundo! Let them come!',1,1,6,0,0,0,0,0,0,0,0,0,26124),
(118813,'You won\'t get away with this, Darion! Tirion... the Light will not allow it!','',0,0,0,0,0,0,0,0,0,0,69447,0,26124),
(118814,'You don\'t hear them, do you? Their laughing... their warning. Our time is coming.','',0,0,0,0,0,0,1,0,0,0,68290,0,26124),
(118815,'The void sends whispers of our fate, a gruesome death! Light a candle for your loved ones, priest, because the end is near and inescapable.','',0,0,0,0,0,0,1,0,0,0,68291,0,26124),
(118818,'Another one down! Nicely done. Now get out and find the rest of \'em! Plenty more o\' those things about.','',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(118819,'I think they meant to kill me!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(118820,'Do not disturb my charges while they enjoy the Menagerie. I will be obliged to remove you.','Do not disturb my charges while they enjoy the Menagerie. I will be obliged to remove you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118822,'Asking questions will get you killed. Allow me to demonstrate!','Asking questions will get you killed. Allow me to demonstrate!',0,0,0,0,0,0,0,0,0,42022,0,0,26124),
(118824,'Oof! That\'s gonna leave a mark. Best get myself healed up.','Oof! That\'s gonna leave a mark. Best get myself healed up.',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(118825,'Hmm... That\'s gonna need some stitching. Be back afore this is over!','Hmm... That\'s gonna need some stitching. Be back afore this is over!',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(118826,'Didn\'t see that comin\'! I\'ll need a bit ta rest me head.','Didn\'t see that comin\'! I\'ll need a bit ta rest me head.',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(118827,'What do ye call those things? I ne\'er saw it comin\'!','What do ye call those things? I ne\'er saw it comin\'!',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(118828,'Looks like I be needin\' a bit more trainin\'.','Looks like I be needin\' a bit more trainin\'.',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(118831,'It feels like these bones of mine haven\'t moved in years! Come, let\'s find some place to talk where we won\'t be caught by a basilisk\'s gaze.','',0,0,0,0,0,0,1,0,0,0,68259,0,26124),
(118832,'Let the hunt begin!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118833,'Lend me your charge!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118834,'Empower your master!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118835,'','Kind words, $n. Perhaps our forces could benefit from some fresh supplies. I\'ll gather what I can.',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(118836,'Time to fry!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118837,'','%s looks around nervously, taking her time before entering the fields.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(118839,'Do come again.','',0,0,0,0,0,0,0,0,0,0,67697,0,26124),
(118840,'Nor\'bethos Suramar.','',0,0,0,0,0,0,0,0,0,0,67698,0,26124),
(118842,'We\'ve retaken Eastpoint Tower! Continue your efforts. Our lands must be restored.','',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(118843,'Welcome aboard! King Wrynn needs every hero of the Alliance at their best when we face the Legion. As we journey to the Broken Shore, let\'s use the time to brush up on your battle skills. Let me know when you\'re ready to get started.','',0,0,0,0,0,0,1,0,0,0,67700,0,26124),
(118844,'','Well met! A glorious battle awaits us on the Broken Shore! The Warchief expects every hero of the Horde to be sharp and ready. I suggest we use the time for a bit of combat training. Say the word and we\'ll begin!',0,0,0,0,0,0,1,0,0,0,0,67775,26124),
(118845,'','Greetings $n. We\'re keenly interested in a series of ley energy nodes strewn about the area.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118846,'','Hop on a mana saber and ride through the ley line spots, it will absorb any energy still present.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118847,'','The mana saber will travel very fast in a straight line; but it tends to slow down through turns.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118848,'','Collect enough energy to sate the mana saber for our research and you\'ll be done.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118849,'It would appear as though I wasn\'t quite ready for these... events. Perhaps I should return when things have settled down.','',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(118850,'','Your words are very kind, but I\'m afraid I shouldn\'t be here. I\'ll return shortly.',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(118851,'','We\'ve regained control of Southpoint Gate. My forces have been ordered to continue their patrols. Ensure the others are taken care of. We cannot allow the Legion to advance any further!',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(118852,'Forsaken! Allies! The hour to stand against the Burning Legion is at hand! Prepare yourselves!','',0,0,0,0,0,0,22,0,0,0,67702,0,26124),
(118853,'Rise, champions! Heed the call of battle! The Burning Legion sets its sights on Tarren Mill.','',0,0,0,0,0,0,22,0,0,0,67704,0,26124),
(118854,'Hold your ground! Give no quarter!','',0,0,0,0,0,0,22,0,0,0,67706,0,26124),
(118855,'The demons come! Make... them... pay!','',0,0,0,0,0,0,22,0,0,0,67707,0,26124),
(118856,'More of them! Do not let fear cause you to shirk your duty!','',0,0,0,0,0,0,22,0,0,0,67709,0,26124),
(118857,'Such brutish force! They grow stronger! Do not falter!','',0,0,0,0,0,0,22,0,0,0,67710,0,26124),
(118858,'Relieve this demon of its head! The tide will turn in our favor!','',0,0,0,0,0,0,22,0,0,0,67712,0,26124),
(118859,'','Aran\'arcana.',0,0,0,0,0,0,0,0,0,0,0,67952,26124),
(118860,'Make sure this one pays for its impudence!','',0,0,0,0,0,0,22,0,0,0,67713,0,26124),
(118861,'Victory can yet be ours, champions. Move out and rid our lands of this demonic presence!','',0,0,0,0,0,0,22,0,0,0,67715,0,26124),
(118862,'No demon may walk in Hillsbrad unless it answers to me! Spread out! Expunge them!','',0,0,0,0,0,0,22,0,0,0,67716,0,26124),
(118863,'The darkness grows. Their influence spreads! Oppose them!','',0,0,0,0,0,0,22,0,0,0,67718,0,26124),
(118864,'Even more of them come! They must be stopped!','',0,0,0,0,0,0,22,0,0,0,67719,0,26124),
(118865,'Enough of your madness, demon! Your time is at an end!','',0,0,0,0,0,0,22,0,0,0,67721,0,26124),
(118866,'In ages long past, before the era of the mortal races, Highkeeper Ra reigned over southern Kalimdor.','',0,0,0,0,0,0,0,0,0,0,68803,0,26124),
(118867,'Bathe in sorrow, demon! You cannot break us! The Burning Legion will fall!','',0,0,0,0,0,0,22,0,0,0,67722,0,26124),
(118868,'The titan Aman\'Thul bestowed upon the Highkeeper a fist of light, a claw forged in the heavens that spoke the language of storms and placed the power of lightning within Ra\'s clenched fist.','',0,0,0,0,0,0,0,0,0,0,68804,0,26124),
(118869,'Together with the titan-forged sorceress Helya, Highkeeper Ra created four elemental realms in which to imprison the wayward elemental lords.','',0,0,0,0,0,0,0,0,0,0,68805,0,26124),
(118870,'He embedded the key to these realms into his shield, \"The Highkeeper\'s Ward.\" Ra walked among the elemental planes, as both their jailor and master.','',0,0,0,0,0,0,0,0,0,0,68806,0,26124),
(118871,'When it came time to war against the Black Empire, Highkeeper Ra created an army of stone to do his bidding. These creatures were called the \"mogu,\" and they called their god \"Ra-den,\" or \"Master Ra.\"','',0,0,0,0,0,0,0,0,0,0,68807,0,26124),
(118872,'Revel in our victory, but never forget... time is not our ally. The Legion will return.','',0,0,0,0,0,0,22,0,0,0,67724,0,26124),
(118873,'The mogu proved to be Ra-den\'s undoing. Many ages later, corrupted by the curse of flesh and led by Lei Shen the Thunder King, the Highkeeper was overthrown.','',0,0,0,0,0,0,0,0,0,0,68808,0,26124),
(118874,'Shaman, the Thunder King took up the weapons of Ra-den, but he could not wield them.','',0,0,0,0,0,0,0,0,0,0,68809,0,26124),
(118875,'Lei Shen could match the Highkeeper\'s storm and fury, but not his mastery over the elements themselves. Perhaps you have that power.','',0,0,0,0,0,0,0,0,0,0,68810,0,26124),
(118876,'Victory! Mend your wounds and regain your strength, for we must stay ready. The Legion\'s efforts have only begun...','',0,0,0,0,0,0,22,0,0,0,67725,0,26124),
(118877,'Your companion waits for you. Return to me at my temple. We shall see if you can succeed where the Thunder King failed.','',0,0,0,0,0,0,0,0,0,0,68811,0,26124),
(118878,'','The shal\'dorei will be redeemed.',0,0,0,0,0,0,0,0,0,0,0,67947,26124),
(118879,'Few mortals know the history of Highkeeper Ra, his mastery over the elemental planes, and his relation to the mogu empire.','',0,0,0,0,0,0,0,0,0,0,68812,0,26124),
(118880,'Truly marvelous! I wonder...','',0,0,0,0,0,0,1,0,0,0,69282,0,26124),
(118881,'','Greetings.',0,0,0,0,0,0,0,0,0,0,0,67953,26124),
(118884,'','Lowborn filth! Perhaps reducing their rations of arcwine will remind them who it is they serve.',1,0,0,0,0,0,1,0,0,0,0,67730,26124),
(118885,'','As their hunger grows, the rebels will turn on each other like starved rats. Any sympathizers will be exposed and order will be restored!',1,0,0,0,0,0,1,0,0,0,0,67731,26124),
(118886,'','Where could they have taken him?',0,0,0,0,0,0,0,0,0,42045,0,0,26124),
(118887,'','What are they doing to my boy?',0,0,0,0,0,0,0,0,0,42045,0,0,26124),
(118888,'','He should have returned by now.',0,0,0,0,0,0,0,0,0,42045,0,0,26124),
(118889,'','Curse these tricks. What have they done with my son?',0,0,0,0,0,0,0,0,0,42045,0,0,26124),
(118890,'I simply can\'t fathom why some citizens resist the Grand Magistrix\'s plan.','I simply can\'t fathom why some citizens resist the Grand Magistrix\'s plan.',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(118891,'','Oh Ailen... you are too young to be involved in this.',0,0,0,0,0,0,0,0,0,42045,0,0,26124),
(118892,'Yes, that will keep them under heel!','Yes, that will keep them under heel!',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(118893,'','Where is he? Where is my Ailen?',0,0,0,0,0,0,0,0,0,42045,0,0,26124),
(118894,'The Burning Legion is entirely focused on the task at hand. They need someone with my vision to guide their future.','',1,0,0,0,0,0,0,0,0,0,67732,0,26124),
(118895,'Bring me that defiant aberration\'s head!','',0,0,0,0,0,0,0,0,0,0,70840,0,26124),
(118896,'So many worlds must be out there, needing to be purged. Who better than me to locate them?','',1,0,0,0,0,0,0,0,0,0,67733,0,26124),
(118897,'Sargeras himself shall recognize my genius. Will his power expand my mind? Or will my mind expand his power?','',1,0,0,0,0,0,0,0,0,0,67734,0,26124),
(118898,'Take them by ground and air! Felguards and doomguards, attack!','',0,0,0,0,0,0,0,0,0,0,70839,0,26124),
(118899,'Enough! Sisters, end this nonsense!','',0,0,0,0,0,0,0,0,0,0,70838,0,26124),
(118900,'Not sure I can support Lunastre for the advisor position. If Ranthos were still around, perhaps, but that daughter of his...','Not sure I can support Lunastre for the advisor position. If Ranthos were still around, perhaps, but that daughter of his...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118901,'Karzak, I call upon you! FINISH THEM!','',0,0,0,0,0,0,0,0,0,0,70837,0,26124),
(118902,'She\'s a bleeding heart, I hear. Too sympathetic to the lowborn.','She\'s a bleeding heart, I hear. Too sympathetic to the lowborn.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118903,'I wanted to see Ruven Duskmere as the new advisor. Such a pity.','I wanted to see Ruven Duskmere as the new advisor. Such a pity.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118904,'I will meet you at the repose shortly. Travel well.','',0,0,0,0,0,0,1,0,0,42046,69281,0,26124),
(118905,'I\'ll wager commoners are responsible. The lowborn ruin everything!','I\'ll wager commoners are responsible. The lowborn ruin everything!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118906,'House Astravar should fill the open advisor spot, if you ask me.','House Astravar should fill the open advisor spot, if you ask me.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118907,'They\'re not even in the running! They\'ve tied their fortunes to Lunastre.','They\'re not even in the running! They\'ve tied their fortunes to Lunastre.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118908,'Coryn Stelleris a murderer? I don\'t believe it!','Coryn Stelleris a murderer? I don\'t believe it!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118909,'Even if he did it, I\'d still rather see him become advisor before Ly\'leth Lunastre.','Even if he did it, I\'d still rather see him become advisor before Ly\'leth Lunastre.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118910,'I have urgent business I must attend to presently, but I\'ll see you soon.','',0,0,0,0,0,0,1,0,0,42047,69280,0,26124),
(118911,'House Lunastre has the right idea. Showing kindness to the common folk will get them on our side.','House Lunastre has the right idea. Showing kindness to the common folk will get them on our side.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118912,'Kindness? Are you joking? Take away their arcwine and they\'ll come crawling back on their own!','Kindness? Are you joking? Take away their arcwine and they\'ll come crawling back on their own!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118913,'Any leads on the murder of Advisor Vandros?','Any leads on the murder of Advisor Vandros?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118914,'I heard it was a jilted lover.','I heard it was a jilted lover.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118915,'Really? I\'d assumed it was some sort of dissident, but a scorned lover sounds much more exciting!','Really? I\'d assumed it was some sort of dissident, but a scorned lover sounds much more exciting!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118916,'I\'ll wager Vandros was only the first. Every noble in Suramar has a target on their back!','I\'ll wager Vandros was only the first. Every noble in Suramar has a target on their back!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118917,'Quiet down! The Grand Magistrix is about. Do you want to draw her ire?','Quiet down! The Grand Magistrix is about. Do you want to draw her ire?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118918,'Uh... What I mean is that order has been restored! We are perfectly safe, thanks to the Grand Magistrix!','Uh... What I mean is that order has been restored! We are perfectly safe, thanks to the Grand Magistrix!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118919,'Did you know that Star Auger Estraeus is so smart that his head weighs three times that of a noble-born elf? And six times that of a commoner!','Did you know that Star Auger Estraeus is so smart that his head weighs three times that of a noble-born elf? And six times that of a commoner!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118920,'I saw Spellblade Aluriel pacing about. She always seems so... angry.','I saw Spellblade Aluriel pacing about. She always seems so... angry.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118921,'This wine is terrible. I\'ll wager Melandrus watered it down.','This wine is terrible. I\'ll wager Melandrus watered it down.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118922,'I don\'t mind the Legion presence at all. It feels good to know we\'re on the winning side.','I don\'t mind the Legion presence at all. It feels good to know we\'re on the winning side.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118923,'We\'ve lived quite comfortably for so long. Why must outsiders come and stir up trouble?','We\'ve lived quite comfortably for so long. Why must outsiders come and stir up trouble?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118924,'You know, there are times I feel that the commoners don\'t properly appreciate us.','You know, there are times I feel that the commoners don\'t properly appreciate us.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(118925,'','What madman thought to infuse this creature with the Nightwell\'s power? Have a care. If this abomination was created to protect lower reaches of the citadel from invaders, it must be particularly deadly.',0,0,0,0,0,0,0,0,0,0,0,67736,26124),
(118926,'','Rend their flesh apart, my pet!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118927,'','I will shred your flesh from bone!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118928,'','You have my thanks.',0,0,0,0,0,0,1,0,0,0,0,68260,26124),
(118929,'','Now the fate of my people rests in the hands of outsiders... all of you... to save us from the terrible bargain made by our queen.',0,0,0,0,0,0,0,0,0,0,0,67737,26124),
(118930,'','Priest, over here! I need your help!',0,0,0,0,0,0,1,0,0,0,0,68263,26124),
(118931,'','Shanar daloras! I have no idea how such an entity came to be, but the essence of the Nightwell is surging through it.',0,0,0,0,0,0,0,0,0,0,0,67738,26124),
(118932,'','This cage may be strong, but remember, a murloc\'s mind is weak and easily controlled!',0,0,0,0,0,0,1,0,0,0,0,68261,26124),
(118933,'','This is a momentous day, my friends. Until the Legion came, no outsider was permitted inside the corridors of the Nighthold for ten-thousand years.',0,0,0,0,0,0,0,0,0,0,0,67739,26124),
(118934,'','The palace grounds are just ahead. You\'ll find them even more heavily defended than the lower levels.',0,0,0,0,0,0,0,0,0,0,0,67740,26124),
(118935,'','The Spellblade! Once she is defeated, nothing will stop us from opening the palace gates!',0,0,0,0,0,0,0,0,0,0,0,67741,26124),
(118936,'','At long last, the battle to liberate Suramar is joined! No more must our resistance hide in the shadows!',0,0,0,0,0,0,0,0,0,0,0,67742,26124),
(118937,'','The Nightborne stand beside our allies, both ancient and new, to drive back the Legion. Our fates are joined, my friends! In saving this city from the demons, we save all of Azeroth as well! Tor ilisar\'thera\'nal!',0,0,0,0,0,0,0,0,0,0,0,67743,26124),
(118938,'','The reign of the Grand Magistrix ends today! Take her tower, my friends! Topple the tyrant and set my people free!',0,0,0,0,0,0,0,0,0,0,0,67744,26124),
(118939,'','I\'ve tried breaking out, but the wooden bars are too thick.',0,0,0,0,0,0,1,0,0,0,0,68262,26124),
(118940,'','We must drive out the Legion before their meddling unleashes more such manifestations!',0,0,0,0,0,0,0,0,0,0,0,67745,26124),
(118941,'','My people have paid a terrible price for Elisande\'s bargain with the Legion. I hated her for it! But perhaps the magic she bestowed upon you can help bring down our enemies... and earn her some small measure of forgiveness.',0,0,0,0,0,0,0,0,0,0,0,67746,26124),
(118942,'','Surprised to find me alive, Aluriel?',0,0,0,0,0,0,0,0,0,0,0,67747,26124),
(118943,'','Etraeus thought himself superior to... well, everyone. I confess I enjoyed seeing him humbled.',0,0,0,0,0,0,0,0,0,0,0,67749,26124),
(118944,'','What can I say? He took his job seriously.',0,0,0,0,0,0,0,0,0,0,0,67750,26124),
(118945,'','Aluriel trained countless Nightborne in the art of the blade. She would have been a valuable ally, but she chose the wrong side.',0,0,0,0,0,0,0,0,0,0,0,67761,26124),
(118946,'','Skawn! No! I will make you suffer for that!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118947,'We\'ll soon have the opportunity to assess the value of her gift. It\'s time to bring the fight to Gul\'dan!','',0,0,0,0,0,0,0,0,0,0,67751,0,26124),
(118948,'','You!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118949,'','I should have seen to your elimination myself instead of leaving it to Melandrus. After I finish with these whelps, your blood will stain my blade!',0,0,0,0,0,0,0,0,0,0,0,67752,26124),
(118950,'The gates are breached! Sorry we couldn\'t join you sooner, but we had a bit of a mess to clean up out front.','',0,0,0,0,0,0,0,0,0,0,67753,0,26124),
(118951,'I\'ll see to fortifying our position here. Thalyssra, your guidance has been invaluable to our champions so far. They\'ll rely upon your wisdom in the battles ahead.','',0,0,0,0,0,0,0,0,0,0,67754,0,26124),
(118952,'','The people of Suramar owe these heroes a debt we can never fully repay. I will stand with them until the end.',0,0,0,0,0,0,0,0,0,0,0,67755,26124),
(118953,'I\'ll keep an eye on your progress. Good luck!','',0,0,0,0,0,0,0,0,0,0,67756,0,26124),
(118954,'In the Third War, Tichondrius fell in battle against Illidan Stormrage. I think the demon hunter\'s spirit is pleased that the dreadlord has met another painful end.','',0,0,0,0,0,0,0,0,0,0,67757,0,26124),
(118955,'That was for Tirion Fordring, monster! Krosus may not have struck the killing blow, but he played a part in our great champion\'s fall.','',0,0,0,0,0,0,0,0,0,0,67758,0,26124),
(118956,'This astronomer seemed to think very highly of himself. But a good mage knows that intellect isn\'t everything!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118957,'So the palace gardener turned himself into a plant?','',0,0,0,0,0,0,0,0,0,0,67759,0,26124),
(118958,'Though swordplay is not my specialty, I must say her abilities were most impressive.','',0,0,0,0,0,0,0,0,0,0,67760,0,26124),
(118959,'%s has purchased a banquet! Come get a meal in the inn!','%s has purchased a banquet! Come get a meal in the inn!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(118960,'%s has purchased a crate of Ratstallion Harnesses! Come get your temporary rat mount near the guard station!','%s has purchased a crate of Ratstallion Harnesses! Come get your temporary rat mount near the guard station!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(118961,'%s has chummed the waters in the Black Market! Come fish up some Sightless Eyes!','%s has chummed the waters in the Black Market! Come fish up some Sightless Eyes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(118962,'%s has purchased some Young Mutant Warturtles from Laura Malley! Come tame them before they get away!','%s has purchased some Young Mutant Warturtles from Laura Malley! Come tame them before they get away!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(118963,'Greetings.','',0,0,0,0,0,0,0,0,0,0,71599,0,26124),
(118964,'How can I help?','',0,0,0,0,0,0,0,0,0,0,71600,0,26124),
(118965,'You need only ask.','',0,0,0,0,0,0,0,0,0,0,71596,0,26124),
(118966,'%s has flushed the crocs out of the sewer pipes!','%s has flushed the crocs out of the sewer pipes!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(118967,'My doors are always open.','',0,0,0,0,0,0,0,0,0,0,71595,0,26124),
(118968,'%s has awoken the bats! Watch your head!','%s has awoken the bats! Watch your head!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(118969,'%s has summoned imps!','%s has summoned imps!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(118970,'%s has signed a contract with the Widowsister rogues! Hang onto your wallets!','%s has signed a contract with the Widowsister rogues! Hang onto your wallets!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(118971,'Is there something you need?','',0,0,0,0,0,0,0,0,0,0,71601,0,26124),
(118972,'The Waning Crescent never closes.','',0,0,0,0,0,0,0,0,0,0,71597,0,26124),
(118973,'Take care.','',0,0,0,0,0,0,0,0,0,0,71598,0,26124),
(118974,'%s has used the Wild Mana Wand on $n!','%s has used the Wild Mana Wand on $n!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(118975,'Fight as one! We can only defeat them if we stand united!','',0,0,0,0,0,0,0,0,0,0,70825,0,26124),
(118976,'I reserve the right to refuse service. To anyone.','',0,0,0,0,0,0,0,0,0,0,71602,0,26124),
(118977,'Only by working together with these heroes have we won this day! Quickly, brethren, to the Vault of Lights! The Prophet needs our help!','',0,0,0,0,0,0,0,0,0,0,70824,0,26124),
(118978,'Aaaand it\'s closing time.','',0,0,0,0,0,0,0,0,0,0,71603,0,26124),
(118979,'I need a drink.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118980,'I need to take care of a small matter before heading down. I\'ll see you soon.','',0,0,0,0,0,0,1,0,0,42047,69279,0,26124),
(118981,'It just might be possible...','',0,0,0,0,0,0,1,0,0,0,69278,0,26124),
(118982,'','Mathias Shaw is being held inside the Halls of the Eclipse to the south.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118983,'Lead me to Mathias.','Lead me to Mathias.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118984,'','Let us stealth quickly to Mathias Shaw.',0,0,0,0,0,0,0,0,0,0,0,69499,26124),
(118985,'','Keep up. Mathias Shaw is not far.',0,0,0,0,0,0,0,0,0,0,0,69500,26124),
(118986,'','$p. This way.',0,0,0,0,0,0,0,0,0,0,0,69501,26124),
(118987,'','We must get to Mathias quickly.',0,0,0,0,0,0,0,0,0,0,0,69502,26124),
(118988,'','There is no time to waste, $p.',0,0,0,0,0,0,0,0,0,0,0,69503,26124),
(118989,'','He is in here.',0,0,0,0,0,0,0,0,0,0,0,69504,26124),
(118990,'','It\'s not far now.',0,0,0,0,0,0,0,0,0,0,0,69505,26124),
(118991,'','He\'s just down the stairs. Hurry, $p!',0,0,0,0,0,0,0,0,0,0,0,69506,26124),
(118992,'|TInterface\\Icons\\spell_mage_temporalshield:20|t |cFFFF0000|Hspell:219815|h[Temporal Orbs]|h|r flow out of the Nightwell!','|TInterface\\Icons\\spell_mage_temporalshield:20|t |cFFFF0000|Hspell:219815|h[Temporal Orbs]|h|r flow out of the Nightwell!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118993,'','One day at a time.',0,0,0,0,0,0,0,0,0,0,0,67954,26124),
(118994,'','We are only as strong as our will.',0,0,0,0,0,0,0,0,0,0,0,67948,26124),
(118995,'','Death Knight! Your actions here are an affront to all that is holy!',0,0,0,0,0,0,0,0,0,0,0,76885,26124),
(118996,'','Turn back from this unholy mission, or be purged by the Light!',0,0,0,0,0,0,0,0,0,0,0,76886,26124),
(118997,'Been guiding hunters for a lot of years. Makes me proud to see how far we\'ve come!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118998,'Outland had its charms. But when I heard about this lodge, I had to come see it for myself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(118999,'Hunters of all races, working together... not how it was in the old days!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119000,'I chugged my share of mana potions back in the day. Not something I\'m proud of, but I did what I had to do!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119001,'I can help you procure some valuable items.','I can help you procure some valuable items.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119002,'','$n, you\'re spotted. Vanish!',0,0,0,0,0,0,0,0,0,0,0,69507,26124),
(119003,'Look there, the one who set off the explosions!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119004,'<This guide appears to have been mangled by at least a dozen different wild animals. Though heavily patched, it is no longer readable. It has an unpleasant, musky scent.>','<This guide appears to have been mangled by at least a dozen different wild animals. Though heavily patched, it is no longer readable. It has an unpleasant, musky scent.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119005,'','Greetings.',0,0,0,0,0,0,0,0,0,0,0,68240,26124),
(119006,'','Yes?',0,0,0,0,0,0,0,0,0,0,0,68241,26124),
(119007,'','Good day.',0,0,0,0,0,0,0,0,0,0,0,68242,26124),
(119008,'','Glory to the shal\'dorei.',0,0,0,0,0,0,0,0,0,0,0,68236,26124),
(119009,'','The people will rise.',0,0,0,0,0,0,0,0,0,0,0,68237,26124),
(119010,'','I will honor my father\'s name.',0,0,0,0,0,0,0,0,0,0,0,68238,26124),
(119011,'','Farewell.',0,0,0,0,0,0,0,0,0,0,0,68239,26124),
(119012,'','Do you know who I am?',0,0,0,0,0,0,0,0,0,0,0,68243,26124),
(119013,'','Do not test me. I will win.',0,0,0,0,0,0,0,0,0,0,0,68244,26124),
(119014,'','Amused? Good. Enjoy it while you can.',0,0,0,0,0,0,0,0,0,0,0,68245,26124),
(119015,'','The Nightwell calls to me...',0,0,0,0,0,0,0,0,0,0,0,67955,26124),
(119016,'','Our isolation has ended.',0,0,0,0,0,0,0,0,0,0,0,67956,26124),
(119017,'Where did the other one go?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119018,'','An\'ratha adore.',0,0,0,0,0,0,0,0,0,0,0,67949,26124),
(119019,'','Be careful who you trust...',0,0,0,0,0,0,0,0,0,0,0,67950,26124),
(119020,'','Excellent work, $n! I can\'t wait to analyze the mana saber. The Ley energy will saturate the air around it I\'m sure!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119021,'','Suramar must be free.',0,0,0,0,0,0,0,0,0,0,0,67951,26124),
(119022,'','Are all outlanders this... eager?',0,0,0,0,0,0,0,0,0,0,0,67957,26124),
(119023,'','Alright, time to go...',0,0,0,0,0,0,0,0,0,0,0,67958,26124),
(119024,'','<Sigh.> Ten thousand years of paradise. And now, I am stuck here. With you.',0,0,0,0,0,0,0,0,0,0,0,67959,26124),
(119025,'','I am so putting that shield back up when this is over.',0,0,0,0,0,0,0,0,0,0,0,67960,26124),
(119026,'Why hello.','',0,0,0,0,0,0,0,0,0,0,67939,0,26124),
(119027,'Have you made a discovery?','',0,0,0,0,0,0,0,0,0,0,67940,0,26124),
(119028,'Anar-ammenos.','',0,0,0,0,0,0,0,0,0,0,67941,0,26124),
(119029,'What is our destination?','',0,0,0,0,0,0,0,0,0,0,67942,0,26124),
(119030,'Respect magic, or it will break you.','',0,0,0,0,0,0,0,0,0,0,67935,0,26124),
(119031,'Tel vallath.','',0,0,0,0,0,0,0,0,0,0,67936,0,26124),
(119032,'May your path be clear.','',0,0,0,0,0,0,0,0,0,0,67937,0,26124),
(119033,'Test. Observe. Repeat!','',0,0,0,0,0,0,0,0,0,0,67938,0,26124),
(119034,'You were just leaving right?','',0,0,0,0,0,0,0,0,0,0,67943,0,26124),
(119035,'Need a teleport? Preferably somewhere far...','',0,0,0,0,0,0,0,0,0,0,67944,0,26124),
(119036,'Oh, blink off already!','',0,0,0,0,0,0,0,0,0,0,67945,0,26124),
(119037,'','What a fascinating discovery, $n. This device seems to be guarded by some puzzle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119038,'','Head over to the box and interact with it to start the puzzle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119039,'','Excellent, $n! This information will prove invaluable to our research.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119040,'See, now you made me swear. <Sigh.>','',0,0,0,0,0,0,0,0,0,0,67946,0,26124),
(119041,'','Yes?',0,0,0,0,0,0,0,0,0,0,0,67925,26124),
(119042,'','Every now and then, a brave hunter seeks Talonclaw. They commune with the Eagle Spirit, receive her blessing, and begin their hunt. Sadly, these pursuits have always ended the same way: death.',0,0,0,0,0,0,0,0,0,0,0,68163,26124),
(119043,'','Something is wrong. There is strange... Look out!',0,0,0,0,0,0,0,0,0,0,0,68164,26124),
(119044,'','Power is out there, we need only reach for it.',0,0,0,0,0,0,0,0,0,0,0,67926,26124),
(119045,'','Elisande was wrong to doubt our magic.',0,0,0,0,0,0,0,0,0,0,0,67927,26124),
(119046,'','Shal\'assan torah.',0,0,0,0,0,0,0,0,0,0,0,67928,26124),
(119047,'You have my thanks, priest.','You have my thanks, priest.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119048,'I am in your debt.','I am in your debt.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119049,'Your aid will help us win this war.','Your aid will help us win this war.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119050,'','You may speak.',0,0,0,0,0,0,0,0,0,0,0,67929,26124),
(119051,'','Run along.',0,0,0,0,0,0,0,0,0,0,0,67920,26124),
(119052,'','Good help is so hard to find.',0,0,0,0,0,0,0,0,0,0,0,67921,26124),
(119053,'','The arcane is infinite.',0,0,0,0,0,0,0,0,0,0,0,67922,26124),
(119054,'Well met $n. Care to help me with some science?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119055,'Magic isn\'t all about conjuring balls of fire and hurling them at your enemies you know.  Sometimes you need to throw rocks, really BIG rocks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119056,'And of course by, \"Throw,\" I mean to say shoot. With fire.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119057,'Anyway, enough of the classroom lecture. Get in there and try and fire at the targets I\'ve marked.  I\'ll be back over here collecting data.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119058,'Well shot, $n. That\'ll do for today.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119059,'','Aran\'arcana.',0,0,0,0,0,0,0,0,0,0,0,67923,26124),
(119060,'','Farewell.',0,0,0,0,0,0,0,0,0,0,0,67924,26124),
(119061,'','<Ahem.> You are still here.',0,0,0,0,0,0,0,0,0,0,0,67930,26124),
(119062,'','Val-TWAH. Twwahhh! The \"R\" is silen- you know what, never mind. Call me whatever.',0,0,0,0,0,0,0,0,0,0,0,67931,26124),
(119063,'','Is this some kind of primitive ritual? Poking someone until they lose their patience?',0,0,0,0,0,0,0,0,0,0,0,67932,26124),
(119064,'','Where I am from, this kind of behavior has consequences...',0,0,0,0,0,0,0,0,0,0,0,67933,26124),
(119065,'','You know, I tire of being asked \"more power, more power.\" The arcway is not just some wagon that can be heaped with goods - it is a series of conduits!',0,0,0,0,0,0,0,0,0,0,0,67934,26124),
(119066,'','Why are you doing this? I know the peace has always been uneasy, but--',0,0,0,0,0,0,1,0,0,0,0,68165,26124),
(119067,'Your tribe had plenty of time to reclaim the spear, but failed. I will bring back Talonclaw... for the Bloodtotem!','',0,0,0,0,0,0,22,0,0,0,68166,0,26124),
(119068,'Well met.','',0,0,0,0,0,0,0,0,0,0,67966,0,26124),
(119069,'Aran\'arcana.','',0,0,0,0,0,0,0,0,0,0,67967,0,26124),
(119070,'Order must be restored.','',0,0,0,0,0,0,0,0,0,0,67968,0,26124),
(119071,'If only this stubborn spirit would obey!','',0,0,0,0,0,0,1,0,0,0,68167,0,26124),
(119072,'By my blade, I will protect Suramar.','',0,0,0,0,0,0,0,0,0,0,67969,0,26124),
(119073,'Another interloper? Do not meddle in Highmountain affairs!','',0,0,0,0,0,0,0,0,0,0,68168,0,26124),
(119074,'The shal\'dorei are suffering.','',0,0,0,0,0,0,0,0,0,0,67970,0,26124),
(119075,'Be kind. Or be strong.','',0,0,0,0,0,0,0,0,0,0,67961,0,26124),
(119076,'Farewell.','',0,0,0,0,0,0,0,0,0,0,67962,0,26124),
(119077,'Step carefully.','',0,0,0,0,0,0,0,0,0,0,67963,0,26124),
(119078,'An\'ratha adore.','',0,0,0,0,0,0,0,0,0,0,67964,0,26124),
(119079,'Keep your blades clean.','',0,0,0,0,0,0,0,0,0,0,67965,0,26124),
(119080,'If you are trying to incite me, it will not work.','',0,0,0,0,0,0,0,0,0,0,67971,0,26124),
(119081,'I\'ll be alright. Now get moving!','I\'ll be alright. Now get moving!',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(119082,'I appreciate your help. Now, if you\'ll excuse me, I must continue.','I appreciate your help. Now, if you\'ll excuse me, I must continue.',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(119083,'We mustn\'t stop fighting. Press on!','We mustn\'t stop fighting. Press on!',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(119084,'I am disciplined by thousands of years of training. Your petty harassment rolls off like morning dew from the leaves of my garden.','',0,0,0,0,0,0,0,0,0,0,67972,0,26124),
(119085,'<grumble> Be strong... be strong...','',0,0,0,0,0,0,0,0,0,0,67973,0,26124),
(119086,'Enough! Sic \'em, Kal! Go for the eyes!','',0,0,0,0,0,0,0,0,0,0,67974,0,26124),
(119087,'...You are lucky my owl likes you.','',0,0,0,0,0,0,0,0,0,0,67975,0,26124),
(119091,'','Greetings to you, $c. May the Light illuminate your path.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119092,'','I enjoy coming here to think. In the presence of the statue, I feel bathed in serenity.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119093,'Ishnu-alah.','',0,0,0,0,0,0,0,0,0,0,67980,0,26124),
(119094,'Greetings.','',0,0,0,0,0,0,0,0,0,0,67981,0,26124),
(119095,'Ours is a heavy burden.','',0,0,0,0,0,0,0,0,0,0,67982,0,26124),
(119096,'I see a great darkness looming over Netherlight Temple. The shadow of the Burning Legion, ready to strike.','',0,0,0,0,0,0,1,0,4,0,68264,0,26124),
(119097,'Our order will fall at his hands, everyone within will perish.','',0,0,0,0,0,0,1,0,4,0,68265,0,26124),
(119098,'This will be our fate. We are doomed to die at the hands of the dreadlord Balnazzar.','',0,0,0,0,0,0,1,0,4,0,68266,0,26124),
(119099,'This will be our fate... unless...','',0,0,0,0,0,0,1,0,4,0,68267,0,26124),
(119100,'Noooooooooo!','',0,0,0,0,0,0,0,0,6,0,67898,0,26124),
(119101,'I see a path that leads to our victory! You are there, walking with the Light, guiding us all.','',0,0,0,0,0,0,1,0,4,0,68268,0,26124),
(119102,'I know my path.','',0,0,0,0,0,0,0,0,0,0,67983,0,26124),
(119103,'It\'s becoming clear.','',0,0,0,0,0,0,1,0,4,0,68269,0,26124),
(119104,'An old enemy becomes an ally.','',0,0,0,0,0,0,1,0,4,0,68270,0,26124),
(119105,'Forgotten shadows rise!','',0,0,0,0,0,0,1,0,4,0,68271,0,26124),
(119106,'All unite under the Light.','',0,0,0,0,0,0,1,0,4,0,68272,0,26124),
(119107,'Walk with purpose.','',0,0,0,0,0,0,0,0,0,0,67976,0,26124),
(119112,'Farewell.','',0,0,0,0,0,0,0,0,0,0,67977,0,26124),
(119115,'Seek harmony.','',0,0,0,0,0,0,0,0,0,0,67978,0,26124),
(119116,'I know someone brought Ailen Astravar here. Tell me where he is.','I know someone brought Ailen Astravar here. Tell me where he is.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119119,'Ande\'thoras-ethil.','',0,0,0,0,0,0,0,0,0,0,67979,0,26124),
(119122,'Calm yourself.','',0,0,0,0,0,0,0,0,0,0,67984,0,26124),
(119124,'I sense unrest within you.','',0,0,0,0,0,0,0,0,0,0,67985,0,26124),
(119125,'Rethink your path.','',0,0,0,0,0,0,0,0,0,0,67986,0,26124),
(119126,'Remember that one must reap what one sows.','',0,0,0,0,0,0,0,0,0,0,67987,0,26124),
(119127,'Be gone! You have caused me enough trouble already.','',0,0,0,0,0,0,0,0,0,0,67988,0,26124),
(119128,'What.','',0,0,0,0,0,0,0,0,0,0,67911,0,26124),
(119129,'Spit it out.','',0,0,0,0,0,0,0,0,0,0,67912,0,26124),
(119130,'Get this over with.','',0,0,0,0,0,0,0,0,0,0,67913,0,26124),
(119131,'Good riddance.','',0,0,0,0,0,0,0,0,0,0,67908,0,26124),
(119132,'Leave me.','',0,0,0,0,0,0,0,0,0,0,67909,0,26124),
(119133,'Disgraceful.','',0,0,0,0,0,0,0,0,0,0,67910,0,26124),
(119134,'','Get this over with.',0,0,0,0,0,0,0,0,0,0,0,67914,26124),
(119135,'','Spit it out.',0,0,0,0,0,0,0,0,0,0,0,67915,26124),
(119136,'','What.',0,0,0,0,0,0,0,0,0,0,0,67916,26124),
(119137,'','Disgraceful.',0,0,0,0,0,0,0,0,0,0,0,67917,26124),
(119138,'','Leave me.',0,0,0,0,0,0,0,0,0,0,0,67918,26124),
(119139,'','Good riddance.',0,0,0,0,0,0,0,0,0,0,0,67919,26124),
(119140,'','Trying to annoy me? How quaint.',0,0,0,0,0,0,0,0,0,0,0,68006,26124),
(119141,'','House Lunastre will always rise above.',0,0,0,0,0,0,0,0,0,0,0,68005,26124),
(119142,'','Words are weapons.',0,0,0,0,0,0,0,0,0,0,0,68004,26124),
(119143,'It is good to see you alive and well, Senegos.','',0,0,0,0,0,0,1,0,0,0,69277,0,26124),
(119144,'I may well not have been, save for the efforts of your friend.','',0,0,0,0,0,0,1,0,0,0,69276,0,26124),
(119145,'I don\'t know, really... I kind of... just fell into this place.','I don\'t know, really... I kind of just... fell into this place.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119146,'<Eyeballing you up and down suspiciously.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119147,'Take caution! Azshara\'s minions will not relinquish the Heart easily.','',0,0,0,0,0,0,1,0,0,0,69275,0,26124),
(119148,'Oakheart protected the great tree for untold years, never once wavering in his vigil. A tragic end.','',0,0,0,0,0,0,1,0,0,0,69274,0,26124),
(119149,'Speak with me when you have finished your business here, so we might leave this place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119150,'You possess a powerful binding from the Firelord\'s kin.  These are no toys, $r.  Bindings such as these threaten even the great elemental lords.  They are unspeakably dangerous to possess.\n\nDo you seek to imprison the Windlord with these bindings?  Or do you have some other intent?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119151,'I do not fear the Windlord.  As long as I have this binding, he should fear me.','I do not fear the Windlord.  As long as I have this binding, he should fear me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119152,'Steel your heart, young one. None are safe from the Nightmare\'s grasp.','',0,0,0,0,0,0,1,0,0,0,69273,0,26124),
(119153,'Well... I hope you like eating raw fish, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119154,'... I have failed you my lord, Detheroc...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119155,'Now look what you\'ve done. Didn\'t want to listen, did you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119156,'By the Lifebinder... I thought the Heart was just another legend.','',0,0,0,0,0,0,5,0,0,0,69272,0,26124),
(119157,'I care little of your Bindings.\n\nThunderaan has returned through the efforts of the Earthen Ring. The new Windlord has risen, and it is he you should speak to about these wretched creations.\n\nBut even then, just one Binding is of little use even to the Windlord.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119158,'Bold, $r.  The elemental lords are not known for their generosity.\n\nStill, should you recover both bindings, and ore powerful enough to turn them into something of use, then I will arrange your audience with Thunderaan the Windlord.\n\nUse the time between then and now to consider the wisdom of this meeting.  I shall understand if you do not return.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119159,'What would the Windlord require to arrange an audience?','What would the Windlord require to arrange an audience?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119160,'Enough! I will deal with you myself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119161,'I have no desire to imprison the Windlord.  I wish to come to an arrangement with him.','I have no desire to imprison the Windlord.  I wish to come to an arrangement with him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119162,'Curious.\n\nThunderaan has returned through the efforts of the Earthen Ring. The new Windlord has risen, and it is he you should speak to about these wretched creations.\n\nBut even then, just one Binding is of little use even to the lord of Skywall.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119163,'Begone, $r.  I want nothing to do with your foolish plans.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119164,'We have everything we need. Well done!','',0,0,0,0,0,0,1,0,0,0,69271,0,26124),
(119165,'It\'s... it\'s working!','',0,0,0,0,0,0,1,0,0,0,69270,0,26124),
(119166,'','You keep them off me and I will get SI:7 here out of his cage.',0,0,0,0,0,0,0,0,0,0,0,69508,26124),
(119167,'Incredible! But the power of one essence is simply not enough.','',0,0,0,0,0,0,1,0,0,0,69269,0,26124),
(119168,'Oh, Kalecgos! We are just beginning. We must now delve deep into the Nightmare itself.','',0,0,0,0,0,0,1,0,0,0,69268,0,26124),
(119169,'I was personal attendant to lord Ruven himself. Now I am reduced to delivering wine and sweets to petulant, coddled  nobles with no real power or influence.\n\nPathetic.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119170,'My lord Ruven promised such power, if he were to ascend to the palace. I believed him! I made plans!\n\nNow he is dead, and I cannot show my face without drawing stares. I am ashamed.\n\nHow could one such as he fall so low?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119171,'','Oh my dear Ruven...\n\nHe was such a brash child, so full of pride. I always knew he would take great power for his own some day.\n\nBut not this... I did not see this coming. Oh my child...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119172,'I see.','I see.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119173,'I heard that Coryn Stelleris has begun to purchase the remaining Duskmere attendants - is that true?','I heard that Coryn Stelleris has begun to purchase the remaining Duskmere attendants - is that true?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119174,'I overheard a rather crude joke at poor Ruven\'s expense while visiting the Stelleris family. I can\'t imagine you would want to hear it...','I overheard a rather crude joke at poor Ruven\'s expense while visiting the Stelleris family. I can\'t imagine you would want to hear it...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119175,'There is talk in the streets that they found a silver crescent near his corpse- is that true?','There is talk in the streets that they found a silver crescent near his corpse- is that true?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119176,'','Here they come!',0,0,0,0,0,0,0,0,0,0,0,69509,26124),
(119177,'Absolutely NOT! Why would he do such a thing? Has he no honor?!','',0,0,0,0,0,0,5,0,0,42107,0,0,26124),
(119178,'... Why WOULD he do such a thing...?','',0,0,0,0,0,0,1,0,0,42107,0,0,26124),
(119179,'','That is the symbol of House Stelleris... but that could not be. Coryn was Ruven\'s dearest friend...',0,0,0,0,0,0,1,0,0,42107,0,0,26124),
(119180,'','No, that\'s simply impossible...',0,0,0,0,0,0,274,0,0,42107,0,0,26124),
(119181,'Preposterous! A joke at my lord\'s expense? Only a madman would attempt it!','',0,0,0,0,0,0,5,0,0,42107,0,0,26124),
(119182,'... But if anyone would laugh, it would be THEM.','',0,0,0,0,0,0,1,0,0,42107,0,0,26124),
(119183,'The Uncrowned to the rescue. I wouldn\'t expect anything less.','',0,0,0,0,0,0,0,0,0,0,69510,0,26124),
(119184,'On your mark, $p.','',0,0,0,0,0,0,1,0,0,0,69267,0,26124),
(119185,'Just... don\'t remain too long in there, alright?','',0,0,0,0,0,0,1,0,0,0,69266,0,26124),
(119188,'We must lend our strength, Kalecgos. There is too much power!','',0,0,0,0,0,0,1,0,0,0,69265,0,26124),
(119189,'I fear you don\'t understand the depths of their depravity, brother. We must continue to push the boundaries of possibility, or we may well still fail.','',0,0,0,0,0,0,1,0,0,0,69264,0,26124),
(119190,'Thank you for everything, Senegos. I hope that one day our paths will cross again.','',0,0,0,0,0,0,1,0,0,0,69263,0,26124),
(119191,'','We must get Shaw out of this cage.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(119192,'Taoshi, pick the locks. I\'ll take care of the demons.','Taoshi, pick the locks. I\'ll take care of the demons.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119193,'Few have returned after journeying so deep into the dark.','',0,0,0,0,0,0,1,0,0,0,69262,0,26124),
(119194,'The Moon Guard are the only ones versed in the ancient magic we need to empower the Heart further. You must save them.','',0,0,0,0,0,0,1,0,0,0,69261,0,26124),
(119195,'Come, let us speak to Thalreus and his kin. We will need their knowledge to empower the Heart further.','',0,0,0,0,0,0,1,0,0,0,69260,0,26124),
(119196,'Get me out of here so that I can help.','',0,0,0,0,0,0,0,0,0,0,69511,0,26124),
(119197,'','You\'ll get your chance soon enough, Mathias.',0,0,0,0,0,0,0,0,0,0,0,69512,26124),
(119198,'','One down, one to go.',0,0,0,0,0,0,0,0,0,0,0,69513,26124),
(119199,'What\'s wrong, Taoshi?','',0,0,0,0,0,0,0,0,0,0,69514,0,26124),
(119200,'','I can\'t pick the lock. It is up to you, $p.',0,0,0,0,0,0,0,0,0,0,0,69515,26124),
(119201,'','By the Light, be purged!',0,0,0,0,0,0,0,0,0,0,0,76887,26124),
(119202,'','Such power... how can this be?',0,0,0,0,0,0,0,0,0,0,0,76888,26124),
(119203,'Darion, my son! What is the meaning of this?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119204,'Look at what you have done! The valiant blood of your allies stains this sacred chapel. Blood that you have spilt!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119205,'Good. Then your unholy crusade is at an end. The Four Horsemen will never return.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119206,'I will not watch my son become a monster!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119207,'This burden will always be ours to bear, my son.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119208,'Deathlord! The time has come for you to leave this place and never return.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119209,'We will resurrect our valiant deceased, but the actions of the Ebon Blade will not be forgotten.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119210,'At last, the Four Horsemen shall have their leader...','',0,0,0,0,0,0,0,0,0,0,68897,0,26124),
(119211,'What is this?!','',0,0,0,0,0,0,0,0,0,0,68896,0,26124),
(119212,'The Death Gate... take... it.','',0,0,0,0,0,0,0,0,0,0,68895,0,26124),
(119215,'','Beauxbeaux! What have they done!?',0,0,0,0,0,0,18,1,0,0,0,0,26124),
(119216,'','Go! Get far away from here!',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(119217,'Shannon... is she okay? You must help the others!','',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(119218,'','I couldn\'t do anything! They just... killed him!',0,0,0,0,0,0,18,1,0,0,0,0,26124),
(119219,'This is madness! Madness I tell you!','',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(119220,'','I will get Mathias to safety through the sewer tunnels.',0,0,0,0,0,0,0,0,0,0,0,69516,26124),
(119221,'Thank you.','',0,0,0,0,0,0,0,0,0,0,69517,0,26124),
(119222,'','We will see you back in the Chamber of Shadows, $n.',0,0,0,0,0,0,0,0,0,0,0,69518,26124),
(119223,'|TInterface\\Icons\\INV_Misc_Herb_Liferoot_Stem:20|t%s is casting |cFFFF0000|Hspell:212786|h[Uproot]|h|r, beware of Vilethorn Saplings!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119224,'You must remove the threat, $n!','You must remove the threat, $n!',0,0,0,0,0,0,396,1,0,0,0,0,26124),
(119225,'Look at me... look what they\'ve done! You must remove the threat at once!','Look at me... look what they\'ve done! You must remove the threat at once!',0,0,0,0,0,0,396,1,0,0,0,0,26124),
(119226,'We must reclaim our lands!','We must reclaim our lands!',0,0,0,0,0,0,396,1,0,0,0,0,26124),
(119227,'That thing did this! Purge the land of those demons!','That thing did this! Purge the land of those demons!',0,0,0,0,0,0,396,1,0,0,0,0,26124),
(119228,'I couldn\'t help them!','I couldn\'t help them!',0,0,0,0,0,0,396,1,0,0,0,0,26124),
(119229,'Look what they\'ve done! You must stop them!','Look what they\'ve done! You must stop them!',0,0,0,0,0,0,396,1,0,0,0,0,26124),
(119230,'I\'ve never seen such things before! I don\'t understand...','',0,0,0,0,0,0,1,1,0,0,0,0,26124),
(119231,'What... what IS this!? How could I... Stop them! You must!','',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(119232,'My blades! This blood... it\'s fresh! The others must be warned!','',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(119233,'If you see something, say something. To someone else.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119234,'I know you adore my charming demeanor, but you really should not be here unless you have business for me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119235,'These alleys are dangerous. You never know who might pick your pockets.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119237,'I will pay Vanthir a visit in my own time. Go about your business if you don\'t have something for me to do.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119241,'We need your help \'persuading\' some noble houses to support Ly\'leth\'s bid for advisor. Are you in?','We need your help \'persuading\' some noble houses to support Ly\'leth\'s bid for advisor. Are you in?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119242,'You\'ve got a look about you. Did something happen? Do you have need of my... expertise?\n\n<Arluin smiles lazily.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119243,'Is that what she\'s up to? Brave girl. I\'d be delighted to help, but...','',0,0,0,0,0,0,0,0,0,0,68043,0,26124),
(119250,'You have entered a free for all PvP area!','You have entered a free for all PvP area!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(119251,'','Die, worm!',0,0,0,0,0,0,0,0,0,0,0,68989,26124),
(119252,'','Watch your step...',0,0,0,0,0,0,0,0,0,0,0,68988,26124),
(119253,'Be cleansed by fire!','',0,0,0,0,0,0,0,0,0,0,68990,0,26124),
(119254,'I am injured!','',0,0,0,0,0,0,0,0,0,9587,0,0,26124),
(119255,'I require healing!','',0,0,0,0,0,0,0,0,0,9587,0,0,26124),
(119256,'I need your help, healer!','',0,0,0,0,0,0,0,0,0,9587,0,0,26124),
(119257,'Please tend to my wounds so I can continue fighting!','',0,0,0,0,0,0,0,0,0,9587,0,0,26124),
(119258,'I am gravely wounded!','',0,0,0,0,0,0,0,0,0,9587,0,0,26124),
(119259,'I won\'t survive these wounds much longer.','',0,0,0,0,0,0,0,0,0,9587,0,0,26124),
(119260,'We deciphered the Codex of Command.','We deciphered the Codex of Command.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119261,'I will continue to fight until my body collapses!','',0,0,0,0,0,0,0,0,0,9587,0,0,26124),
(119262,'Tell my children that I tried my best, but without any heroes to heal my wounds I perished.','',0,0,0,0,0,0,0,0,0,9587,0,0,26124),
(119263,'HEY! Can anybody heal my wounds? I know one of you is capable of healing!','',0,0,0,0,0,0,0,0,0,9587,0,0,26124),
(119264,'','Highlord, you\'ve returned. And with Delas! It has been too long, friend.',0,0,0,0,0,0,5,0,0,0,0,68325,26124),
(119265,'','Ishnu\'alah, Sister. Thank you for your warm welcome.',0,0,0,0,0,0,2,0,0,0,0,68352,26124),
(119266,'','The portal at Felblaze Ingress must be destroyed. With your permission, Highlord, Arator and I will deal with this.',0,0,0,0,0,0,1,0,0,0,0,68326,26124),
(119267,'','Allow me to accompany you, sister. I will send word to the Netherlight Temple and ask for reinforcements from the priest order.',0,0,0,0,0,0,1,0,0,0,0,68353,26124),
(119268,'','We will gladly accept your help, Delas. The Light is strongest when it shines together.',0,0,0,0,0,0,1,0,0,0,0,68327,26124),
(119269,'You have been of great service to the Guard, $p. How can we aid you in return?','',0,0,0,0,0,0,1,0,0,0,69259,0,26124),
(119270,'We still owe you a great debt for your help in evacuating our stronghold. How can we repay you?','',0,0,0,0,0,0,1,0,0,0,69258,0,26124),
(119271,'Come to Furog, tiny elf-monsters!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119272,'Tread carefully, shaman. The mogu who haunt those ruins are long dead, but their spirits remain... as do the traps they left behind.','',0,0,0,0,0,0,1,0,0,0,68813,0,26124),
(119273,'Be wary, friend. It may take some time to earn the Nightfallen\'s trust.','',0,0,0,0,0,0,1,0,0,0,69257,0,26124),
(119274,'Make sure you ask for the Scroll of Elun\'dris. It alone has the information we need!','',0,0,0,0,0,0,1,0,0,0,69256,0,26124),
(119275,'','That\'s not quite the solution is it? Try activating the box again to give it another go.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119276,'Come with me. We will fly straight to Pandaria.','',0,0,0,0,0,0,1,0,0,0,68706,0,26124),
(119277,'That\'s it! I can feel it from here!','',0,0,0,0,0,0,1,0,0,0,69255,0,26124),
(119278,'The Legion are not the only ones who can reach through the cosmos to strike their enemies.$B$BGive the word, $n. I will maintain the gateway open from this side.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119279,'It is time. Take us to Niskara.','It is time. Take us to Niskara.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119280,'Yes, yes, it\'s all here. With the right ritual, we can safely infuse the Heart with even the most powerful magic!','',0,0,0,0,0,0,1,0,0,0,69254,0,26124),
(119281,'%s submits to you.','%s submits to you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119282,'','Perfect. Shall we put our incantation to the test?',0,0,0,0,0,0,1,0,0,0,0,69253,26124),
(119283,'','Our numbers may be few, but the Legion will learn to fear the Guard.',0,0,0,0,0,0,1,0,0,0,0,69252,26124),
(119284,'I break your elf-thing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119285,'','Let us begin the ritual at once.',0,0,0,0,0,0,1,0,0,0,0,69251,26124),
(119286,'Are you sure this is going to work, Syrana?','',0,0,0,0,0,0,6,0,0,0,69250,0,26124),
(119287,'','I do not know. But we owe it to our friend to try.',0,0,0,0,0,0,1,0,0,0,0,69249,26124),
(119288,'Do you know what you see here, little outsider? It is the fate of the Tideskorn, once not so scorned by the tides.\n\nIt was Helya, the foul sea-witch, whose wrath consumed their fleets, and whose foul mists broke the mightiest of the vrykul. The jarls had no choice but to give up the sea, for axe and sword do naught to slay mist and brine.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(119289,'Helya\'s domain is to watch over the souls of the unworthy, while those who die in glory are sent to Odyn in the Gates of Valor, to train for the final battle. But Helya, she is a jealous witch, and cannot be sated with the souls she is given.\n\nThus she made the kvaldir. Once mighty vrykul, now torn and corrupted by her foul magics. They serve her eternally, plundering the souls of the living to feed her unquenchable lust for death.\n\nThey are a blight, outsider. Nothing more.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(119290,'What do you know of the kvaldir?','What do you know of the kvaldir?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(119291,'','Meet me within the Sanctum of Order. I must prepare for the ceremony.',0,0,0,0,0,0,1,0,0,0,0,68065,26124),
(119292,'At last, some good news on this day of sorrow.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119293,'','Elun\'falah shalar.',0,0,0,0,0,0,0,0,0,0,0,69248,26124),
(119294,'','Ishnu-talah Kaldorei!',0,0,0,0,0,0,0,0,0,0,0,69247,26124),
(119295,'The matrix is destabilizing!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(119296,'There must be a way to protect the heart from the volatility of the Legion\'s magic. I think I have an idea.','',0,0,0,0,0,0,0,0,0,0,69245,0,26124),
(119297,'','We arrived at Felblaze Ingress soon after leaving Light\'s Hope Chapel. This log bears witness to our journey.',0,0,0,0,0,0,0,0,0,0,0,68313,26124),
(119298,'','As she promised, Delas brought Conclave priests to join the battle. Our forces are getting along well.',0,0,0,0,0,0,0,0,0,0,0,68314,26124),
(119299,'','The priests also seek Balnazzar. Their leader, Prophet Velen, saw a vision of the dreadlord raining destruction upon Azeroth.',0,0,0,0,0,0,0,0,0,0,0,68315,26124),
(119300,'','The Legion does not yet suspect our presence. Their leader, Brood Queen Aramis, roams the camp each day.',0,0,0,0,0,0,0,0,0,0,0,68316,26124),
(119301,'','We attack tomorrow. May the Light guide us.',0,0,0,0,0,0,0,0,0,0,0,68317,26124),
(119302,'','We underestimated the Legion\'s cunning! After we attacked, the portal blazed to life. Balnazzar arrived and tore through our defenses.',0,0,0,0,0,0,0,0,0,0,0,68309,26124),
(119303,'','We are still alive, but they are taking us through the portal... to their home world. What lies on the other side?',0,0,0,0,0,0,0,0,0,0,0,68310,26124),
(119304,'','I broke free for a moment. Please, if anyone finds this, you are our only hope of rescue.',0,0,0,0,0,0,0,0,0,0,0,68311,26124),
(119305,'This one\'s got some fight in \'em!','',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(119306,'Keep \'em on guard! Don\'t let \'em out of sight!','',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(119307,'I can assure ye - this won\'t be the last one we bring down today!','',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(119308,'Show \'em yer strength! Fer the Alliance!','',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(119309,'','Odyn\'s valor is rivaled only by his appetite. A true warrior.',0,0,0,0,0,0,1,0,0,0,0,69244,26124),
(119310,'Captain, what do ye think you\'re doin\'? Ye aren\'t anywhere near ready ta get back in and fight.','Captain, what do ye think you\'re doin\'? Ye aren\'t anywhere near ready ta get back in and fight.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(119311,'Quit yer fussin\'! Yer soldiers are trained well. They can do it.','Quit yer fussin\'! Yer soldiers are trained well. They can do it.',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(119312,'Enough! All that yellin\' \'ill probably make it worse!','Enough! All that yellin\' \'ill probably make it worse!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(119313,'Ye have to let them do it! It\'s their fight now!','Ye have to let them do it! It\'s their fight now!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(119314,'You need to rest and your soldiers are well trained. Now sit still.','You need to rest and your soldiers are well trained. Now sit still.',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(119316,'Captain! Ye need ta try an\' rest! If ye don\'t, I\'ll let that demon come and fix ye up himself!','Captain! Ye need ta try an\' rest! If ye don\'t, I\'ll let that demon come and fix ye up himself!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(119317,'','Prepare for battle, champion. Even the Valarjar dare not tread so near Helya\'s domain.',0,0,0,0,0,0,1,0,0,0,0,69243,26124),
(119318,'Wait... is it you? Hah! You\'ve come far my mortal friend. First you helped me defeat Loken and now you lead Odyn\'s own armies!','',1,0,0,0,0,0,0,0,0,0,68401,0,26124),
(119319,'Who are you? What is the meaning of this?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119320,'Having the Illidari among us makes me uneasy. Their kind has been locked away since my brother\'s fall.','',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(119321,'','I understand, husband. But for Maiev to release them, the situation must be even more dire than we know.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119322,'The Legion overran the Vault of the Wardens seeking Lord Illidan\'s body. Gul\'dan has taken it.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(119323,'That monster will pay for this desecration!','',0,0,0,0,0,0,661,0,0,0,0,0,26124),
(119324,'','Thank you. We could not allow my people\'s sacred heirloom to fall in the hands of such a monster!',0,0,0,0,0,0,1,0,0,0,0,68169,26124),
(119325,'I bring urgent news, My King. Danger is all around you!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(119326,'','There she goes! Ohn\'ahra wants you to follow her.',0,0,0,0,0,0,25,0,0,0,0,68170,26124),
(119327,'Arise, champion!','Arise, champion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119328,'','I am pleased Ohn\'ahra gave her blessing. I feared the Bloototem\'s actions had angered her. Now we can depart for Stormheim!',0,0,0,0,0,0,1,0,0,0,0,68171,26124),
(119329,'In the name of the Light, you are battle-born once more!','In the name of the Light, you are battle born once more!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119330,'','I think she\'s offering aid. Look at her wing-- OH! Thank you!',0,0,0,0,0,0,0,0,0,0,0,68172,26124),
(119331,'','Highlord! Over here!',0,0,0,0,0,0,3,0,0,0,0,68312,26124),
(119332,'Well fought! Though I\'m afraid that was just one of many. We\'ve got ta remove the remaining threat, champions!','',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(119333,'Looks like more backup just arrived!','',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(119334,'Ah, a $c! We could definitely use more of ye!','',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(119335,'Now that\'s a $c! Look at that armor! I haven\'t seen such a thing afore! Looks like it\'s time fer this demon ta fall.','',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(119336,'More champions arrive! Ready up!','',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(119337,'The harpies ravage the forest to which they dare to lay claim. Take the fight to them and drive out their infestation.','',0,0,0,0,0,0,0,0,0,0,68066,0,26124),
(119338,'We can afford to give no quarter to a foe as insidious as the harpies. Their presence is a corruption, and corruption must be purged.','',0,0,0,0,0,0,0,0,0,0,68067,0,26124),
(119339,'The Stoneblood harpies are using dark magic to turn Acolytes of Elo\'thir to stone! Save our noble allies from the harpy curse.','',0,0,0,0,0,0,0,0,0,0,68068,0,26124),
(119340,'You have freed many acolytes, but the harpies are unrelenting. We must remain vigilant if we are to safeguard this land.','',0,0,0,0,0,0,0,0,0,0,68069,0,26124),
(119341,'','There are many noble spirits that walk the land of the living, but Lord Ravencrest\'s cursed followers are beyond redemption. You\'d best defeat them before they rally and attack Bradesbrook in force.',0,0,0,0,0,0,0,0,0,0,0,68070,26124),
(119342,'','The spirits\' forces have been weakened... for now. Can what is dead ever truly die?',0,0,0,0,0,0,0,0,0,0,0,68071,26124),
(119343,'','This time those sprites have crossed the line! They\'re trapping and killing those cute little lunarwing faerie dragons. Well, go on! Save them!',0,0,0,0,0,0,0,0,0,0,0,68072,26124),
(119344,'','Faerie dragons are so precious! It does my heart good to see them protected.',0,0,0,0,0,0,0,0,0,0,0,68073,26124),
(119345,'The Nightmare\'s assault on the Temple of Elune is ceaseless. We must lend our aid to defend this most sacred place.','',0,0,0,0,0,0,0,0,0,0,68074,0,26124),
(119346,'The Nightmare leaks into our reality like a seeping wound. But you have pushed back the darkness, at least for now.','',0,0,0,0,0,0,0,0,0,0,68075,0,26124),
(119347,'The Darkgrove druids have turned the very flora against us! If they go unchecked, more of the forest will fall to their treachery!','',0,0,0,0,0,0,0,0,0,0,68076,0,26124),
(119348,'Few things enrage me more than seeing druidic magic perverted. The Darkgrove deserve their fate!','',0,0,0,0,0,0,0,0,0,0,68077,0,26124),
(119349,'Wormtalon harpies have beset Shadowfen. Thank goodness the survivors fled to safety! If you could recover the pieces of their lives they were forced to leave behind, it would be a great kindness.','',0,0,0,0,0,0,0,0,0,0,68117,0,26124),
(119350,'More than command of magic or prowess in battle, the truest trait of a hero is the willingness to help others. This day proves you have a hero\'s heart!','',0,0,0,0,0,0,0,0,0,0,68118,0,26124),
(119351,'Harpies seek to curse the graceful owls of our forest. Make haste! I pray you\'re not too late to stop them...','',0,0,0,0,0,0,0,0,0,0,68119,0,26124),
(119352,'You saved the owls from a horrible fate. Nobly done!','',0,0,0,0,0,0,0,0,0,0,68120,0,26124),
(119353,'','Pity the people of Bradensbrook! They left Gilneas before falling victim to the worgen curse, but now they face the cruelty of Lord Ravencrest\'s thugs. Their village needs your protection.',0,0,0,0,0,0,0,0,0,0,0,68121,26124),
(119354,'','Though we have our differences, those are still my people in Bradensbrook. It was kind of you to help them.',0,0,0,0,0,0,0,0,0,0,0,68122,26124),
(119355,'','A foul poison seeps into the waters of Mistvale. I feel in my bones that it must be the work of a corrupt druid. Seek out the defiler and end this affliction.',0,0,0,0,0,0,0,0,0,0,0,68123,26124),
(119356,'','How could anyone become so twisted inside that they would infect such a beautiful lake? At least you set things right.',0,0,0,0,0,0,0,0,0,0,0,68124,26124),
(119357,'','Leafbeard the Storied has come! He\'s an old soul who tells a captivating tale about the War of the Ancients. Pay attention and you may learn valuable lessons that will aid you in the fight against the Legion.',0,0,0,0,0,0,0,0,0,0,0,68125,26124),
(119358,'','The War of the Ancients saw many great battles like the one you just experienced. It took all of Azeroth\'s defenders working together to defeat the demons then, as it will now.',0,0,0,0,0,0,0,0,0,0,0,68126,26124),
(119359,'','The very roots of the World Tree are corrupted by the Nightmare. Cleanse Shala\'nir of the infestation that has claimed it.',0,0,0,0,0,0,0,0,0,0,0,68127,26124),
(119360,'','One day Shala\'nir will be reclaimed and the roots of the World Tree safeguarded. We must not rest until that day dawns upon Val\'sharah!',0,0,0,0,0,0,0,0,0,0,0,68128,26124),
(119361,'','The minions of Nightmare continue to defile Moonclaw Vale. Fight back against them, champion!',0,0,0,0,0,0,0,0,0,0,0,68129,26124),
(119362,'','The vale remains plagued by darkness, but you have brought a ray of hope back to it. I thank you.',0,0,0,0,0,0,0,0,0,0,0,68130,26124),
(119363,'','Our keeper and dryad allies have been twisted by the insidious power of the Nightmare. You must end their suffering.',0,0,0,0,0,0,0,0,0,0,0,68132,26124),
(119364,'','Losing servants of the Dream breaks my heart, but at least they are at peace. For that, I thank you.',0,0,0,0,0,0,0,0,0,0,0,68131,26124),
(119365,'That was a rough fight! Go help Hodir and I\'ll keep the way out clear.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(119366,'','Though we woke our druids trapped in Sleeper\'s Barrow, the Nightmare now stirs within. Dispatch the foul denizens who taint it!',0,0,0,0,0,0,0,0,0,0,0,68133,26124),
(119367,'','The tendrils of Xavius\' corruption are everywhere! Sleeper\'s Barrow will yet be cleansed.',0,0,0,0,0,0,0,0,0,0,0,68134,26124),
(119368,'','Bears of the Sylvan Vale are known to possess a rare serenity, but I can sense their disquiet. Sprites are said to live nearby... I think foul play is afoot!',0,0,0,0,0,0,0,0,0,0,0,68135,26124),
(119369,'','Mischievous little devils! You\'ve taught the sprites a lesson, and now the bears can live in peace.',0,0,0,0,0,0,0,0,0,0,0,68136,26124),
(119370,'Everyone must work together to defeat the Legion.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(119371,'Ravis, let\'s see what you have.','Ravis, let\'s see what you have.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119372,'The time has come, Deathlord. Tirion Fordring awaits.','',0,0,0,0,0,0,0,0,0,0,68892,0,26124),
(119373,'We will return to Acherus. Come Horsemen, the binding of souls awaits us.','',0,0,0,0,0,0,0,0,0,0,68891,0,26124),
(119374,'The next task may be too perilous, even for you, little outsider. Return to me when you have fully honed your strength. \n\nOnly then would you hope to survive the Naglfar.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(119375,'','Dreadroot was once a beautiful wood, but now is overrun by monstrosities of the Nightmare. This cannot stand!',0,0,0,0,0,0,0,0,0,0,0,68156,26124),
(119376,'','This land may never fully recover from the evil that has infested it, but we must do all we can.',0,0,0,0,0,0,0,0,0,0,0,68157,26124),
(119377,'','The grell usually keep to themselves, but they\'ve grown bold of late. They\'re attacking the Grizzleweald furbolg tribe! I fear they\'ll soon overrun the entire village.',0,0,0,0,0,0,0,0,0,0,0,68154,26124),
(119378,'','Peace must be maintained in this forest. The Grizzleweald have long been allies of the people of Val\'sharah, and worthy of the help you provided.',0,0,0,0,0,0,0,0,0,0,0,68155,26124),
(119379,'Owlbeasts are fierce guardians of sacred places. But when cut off from the light of Elune, they sometimes turn aggressive. Rescue the dryads from their menace!','',0,0,0,0,0,0,0,0,0,0,68158,0,26124),
(119380,'To murder those dryads and turn them to monstrous creatures... I did not know owlbeasts possessed such vile magic! It is good you stopped them.','',0,0,0,0,0,0,0,0,0,0,68159,0,26124),
(119381,'','Tal\'ashar it is. I name my friend here as my champion.',0,0,0,0,0,0,1,0,0,0,0,68147,26124),
(119382,'I have no need to hide behind a champion. I will defend my own honor.','',0,0,0,0,0,0,1,0,0,0,68148,0,26124),
(119383,'Meet me atop the Sanctum when you are ready to die, whelp.','',0,0,0,0,0,0,603,0,0,0,68149,0,26124),
(119384,'The Naglfar must be stopped, but you are not yet strong enough.','',1,0,0,0,0,0,1,0,0,0,69869,0,26124),
(119385,'Return to me when you are prepared to face this challenge, outsider.','',0,0,0,0,0,0,1,0,0,0,69868,0,26124),
(119386,'','All is going as planned. You do not need to worry.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119387,'I am ready to face Coryn.','I am ready to face Coryn.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119388,'','I am modifying your disguise to allow you to fight like one of us.',0,0,0,0,0,0,0,0,0,0,0,68150,26124),
(119389,'','Win me a title, won\'t you?',0,0,0,0,0,0,1,0,0,0,0,68151,26124),
(119390,'','Take the tower! Greymane\'s forces will break before the might of the Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119391,'','These dogs cower when faced with real might. This tower belongs to the Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119392,'The Horde again claim a warden tower that should be ours. Show them the fury of the Alliance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119393,'The Forsaken lines shatter under our advance across these islands. Onward, for the Alliance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119394,'I seem to have lost my empowered disguise...','I seem to have lost my empowered disguise...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119395,'','I wish this had not been necessary, but you have done well.',0,0,0,0,0,0,0,0,0,0,0,68152,26124),
(119396,'','I will send you back to the tavern when you are ready.',0,0,0,0,0,0,0,0,0,0,0,68153,26124),
(119397,'Mortal $r. You presume much to summon me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119398,'Ragnaros the Firelord once imprisoned me within bindings such as those you hold now.','',0,0,0,0,0,0,0,0,0,42188,0,0,26124),
(119399,'And greedy mortals not unlike you freed me only to strike and steal my weapon, and my power.','',0,0,0,0,0,0,0,0,0,42188,0,0,26124),
(119400,'But now that the Earthen Ring has seen to my return, I am inclined to show patience. Your errand may not be a foolish one after all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119401,'Give me the bindings that I might turn them against the Firelord and his minions, and I will reward you in kind.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119402,'And so it is done, $r. Do not call upon me again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119403,'You possessed bindings such as those once before. An eternal prison from which you freed me only to jealously seek my power.','',0,0,0,0,0,0,0,0,0,42187,0,0,26124),
(119404,'I should strike you down for what you did to me. For what you stole from me.','',0,0,0,0,0,0,0,0,0,42187,0,0,26124),
(119406,'This way. I spent many months in the depths of Vashj\'ir during the Cataclysm, it is like a second home to me now.','',0,0,0,0,0,0,1,0,0,0,68794,0,26124),
(119407,'Our missing shaman, Wavespeaker Adelee, had tracked the Scepter of Tides to this sunken city before she disappeared.','',0,0,0,0,0,0,1,0,0,0,68795,0,26124),
(119408,'If we can locate her, the scepter will not be far away!','',0,0,0,0,0,0,0,0,0,0,68796,0,26124),
(119409,'This ancient city was once one of the jewels of Kalimdor. Leave no stone unturned in our search.','',0,0,0,0,0,0,0,0,0,0,68802,0,26124),
(119410,'That is Wavespeaker Adelee\'s staff. Hmmm. It is attuned to the Abyssal Maw. Perhaps Sharas\'dal is in there? I warned her not to go there alone...','',0,0,0,0,0,0,0,0,0,0,68801,0,26124),
(119411,'Adelee spoke of a powerful wavestone. I see now what she meant. The auras surrounding this stone would cloak one\'s movements from Neptulon, allowing the naga to slip into his domain undetected.','',0,0,0,0,0,0,0,0,0,0,68800,0,26124),
(119412,'It is fortunate that Adelee\'s journal is written in waterproof squid ink. It will detail her search for the scepter. I will need time to look this over - bring it to me.','',0,0,0,0,0,0,0,0,0,0,68799,0,26124),
(119413,'All the clues indicate that Adelee tracked the scepter into the Abyssal Maw. The trail is easy to follow... perhaps too easy. We may be walking into a trap.','',0,0,0,0,0,0,0,0,0,0,68798,0,26124),
(119414,'We should make our way to the Throne of Tides within the Abyssal Maw, where the scepter awaits. We must be careful - I fear Neptulon\'s Realm may be compromised!','',0,0,0,0,0,0,0,0,0,0,68797,0,26124),
(119415,'|TInterface\\Icons\\Sha_Ability_Mage_FireStarter_nightmare:20|t%s is casting |cFFFF0000|Hspell:191325|h[Breath of Corruption]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(119416,'','You... bear mighty Odyn\'s blessing. I did not think it possible!',0,0,0,0,0,0,1,0,0,0,0,69242,26124),
(119417,'Thank you for your help, Ashildir. If you\'ll excuse us, we have some demons to attend to.','',0,0,0,0,0,0,1,0,0,0,69241,0,26124),
(119418,'Thank you, friend. Light bless you.','Thank you, friend. Light bless you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119419,'I thought we were lost once they brought us through the portal. Thank you, $c.','I thought we were lost once they brought us through the portal. Thank you, $c.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119420,'I had faith that salvation would come. Thank you.','I had faith that salvation would come. Thank you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119421,'I never gave up hope, $c. You have my thanks.','I never gave up hope, $c. You have my thanks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119422,'My prayers have been answered. Thank you, $c.','My prayers have been answered. Thank you, $c.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119423,'I didn\'t expect salvation from the Silver Hand. My thanks to you and your order.','I didn\'t expect salvation from the Silver Hand. My thanks to you and your order.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119424,'My thanks to you, Highlord. For the Silver Hand!','My thanks to you, Highlord. For the Silver Hand!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119425,'I am so happy to see you, $n. Light bless you.','I am so happy to see you, $n. Light bless you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119426,'Honor and justice to you, Highlord. I will fight on for the Order!','Honor and justice to you, Highlord. I will fight on for the Order!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119427,'','A simple request.',0,0,0,0,0,0,0,0,0,0,0,68432,26124),
(119428,'','I\'ve got this!',0,0,0,0,0,0,0,0,0,0,0,68433,26124),
(119429,'Calydus is ready!','',0,0,0,0,0,0,0,0,0,0,68434,0,26124),
(119430,'','Commander, Alonsus - forgive the interruption, but I have news I believe you will want to hear.',0,0,0,0,0,0,1,0,0,0,0,68293,26124),
(119431,'Very well, Delas. Return to the temple at once when you have any information we can act on.','',0,0,0,0,0,0,1,0,0,0,68278,0,26124),
(119432,'You call upon the winds?','',0,0,0,0,0,0,0,0,0,0,68435,0,26124),
(119433,'','I will do my best!',0,0,0,0,0,0,0,0,0,0,0,68436,26124),
(119434,'Ey, mon. I got this!','',0,0,0,0,0,0,0,0,0,0,68437,0,26124),
(119435,'','I honor my master!',0,0,0,0,0,0,0,0,0,0,0,68438,26124),
(119436,'I\'m up to the task!','',0,0,0,0,0,0,0,0,0,0,68439,0,26124),
(119437,'The Tirisgarde will prevail!','',0,0,0,0,0,0,0,0,0,0,68440,0,26124),
(119438,'','Enough talk. Time for action!',0,0,0,0,0,0,0,0,0,0,0,68441,26124),
(119439,'I will give you nothing! Only pain!','I will give you nothing! Only pain!',0,0,0,0,0,0,0,0,0,42022,0,0,26124),
(119440,'You cannot save him- he is as good as dead anyway!','You cannot save him- he is as good as dead anyway!',0,0,0,0,0,0,0,0,0,42022,0,0,26124),
(119441,'Gah! I yield!','Gah! I yield!',0,0,0,0,0,0,0,0,0,42022,0,0,26124),
(119442,'I was instructed to throw him to the carnivores. You will find only bones!','I was instructed to throw him into the lion pit. You will find only bones!',0,0,0,0,0,0,0,0,0,42045,0,0,26124),
(119443,'I will find the way!','',0,0,0,0,0,0,0,0,0,0,68442,0,26124),
(119444,'We\'re on, Baron! Let\'s go!','',0,0,0,0,0,0,0,0,0,0,68443,0,26124),
(119445,'','I will not let you down.',0,0,0,0,0,0,1,0,0,0,0,68296,26124),
(119446,'','Be careful, $r. The Nightborne are emboldened and leaving the borders of their city.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119447,'','Nighteyes has gone out on patrol again. I pray he stays safe this time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119448,'','Nighteyes went to go scout the Menagerie. He had better take care of himself!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119449,'','I will hunt them down!',0,0,0,0,0,0,0,0,0,0,0,68444,26124),
(119450,'','For Elune!',0,0,0,0,0,0,0,0,0,0,0,68427,26124),
(119451,'Let\'s do it!','',0,0,0,0,0,0,0,0,0,0,68428,0,26124),
(119452,'I bring death!','',0,0,0,0,0,0,0,0,0,0,68429,0,26124),
(119453,'','As you command!',0,0,0,0,0,0,0,0,0,0,0,68430,26124),
(119454,'Say no more!','',0,0,0,0,0,0,0,0,0,0,68431,0,26124),
(119455,'Time for a lesson in pain!','',0,0,0,0,0,0,0,0,0,0,74315,0,26124),
(119456,'','I\'ll head to Dalaran and find a quiet place to decipher these runestones.',0,0,0,0,0,0,1,0,0,0,0,68292,26124),
(119457,'The beast is loose! Kill it!','The beast is loose! Kill it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119458,'No beast can challenge the Legion!','No beast can challenge the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119459,'Die, beast!','Die, beast!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119460,'Su\'esh is loose! To arms!','Su\'esh is loose! To arms!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119461,'Fools! Su\'esh has escaped the menagerie!','Fools! Su\'esh has escaped the menagerie!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119462,'Kill it! Kill it now!','Kill it! Kill it now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119463,'','These are detailed travel logs. It appears the Legion has been scouring the Twisting Nether... but for what?',0,0,0,0,0,0,6,0,0,0,0,68318,26124),
(119464,'','I recognize this place. Is it... Netherlight Temple? Is the Legion planning to invade the priest order hall?',0,0,0,0,0,0,1,0,0,0,0,68319,26124),
(119465,'','That\'s the Prophet Velen! His life may be in great danger.',0,0,0,0,0,0,1,0,0,0,0,68320,26124),
(119466,'Order will be restored to the city by force!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119467,'Those who speak out against the Master will be destroyed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119468,'','Are you here for him? You won\'t get past me!',0,0,0,0,0,0,0,0,0,0,0,68337,26124),
(119469,'Move quickly, and crush any who resist the Legion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119470,'','For ages we hunted the sanctuary known as Netherlight Temple! Hidden, was it, beneath our very noses!',0,0,0,0,0,0,0,0,0,0,0,68338,26124),
(119471,'','Finally, we sensed it. Holy light, seeping through the Twisting Nether! Blinding us!',0,0,0,0,0,0,0,0,0,0,0,68339,26124),
(119472,'','Now, our armies will attack, and the Temple will fall... and with it the great Prophet Velen!',0,0,0,0,0,0,0,0,0,0,0,68340,26124),
(119473,'The enemy may be using magic to deceive us! Do not let your guard down!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119474,'','The temple... will.... fall...',0,0,0,0,0,0,0,0,0,0,0,68341,26124),
(119475,'Time to even the odds.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119476,'','Delas, thank goodness you\'re alive!',0,0,0,0,0,0,5,0,0,0,0,68321,26124),
(119477,'','You came back! I thought my end had finally come.',0,0,0,0,0,0,5,0,0,0,0,68350,26124),
(119478,'','Never, my friend. The Light stands together.',0,0,0,0,0,0,1,0,0,0,0,68322,26124),
(119479,'Return when you are prepared to assault the Nighthold. Until then, Thalreus and I will work out the final details of our plan.','',0,0,0,0,0,0,1,0,0,0,69240,0,26124),
(119480,'','Arator, are you still alive?',0,0,0,0,0,0,6,0,0,0,0,68323,26124),
(119481,'Yes, I\'m all right. That imp mother was getting a little too close for comfort.','',0,0,0,0,0,0,1,0,0,0,68330,0,26124),
(119482,'','You should head back to the portal. The Highlord and I will take care of the rest.',0,0,0,0,0,0,1,0,0,0,0,68324,26124),
(119483,'A Waning Time Particle falls out of the Nightwell.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119484,'Thalreus and I have come up with a detailed plan for our assault upon the Nighthold.','',0,0,0,0,0,0,1,0,0,0,69239,0,26124),
(119485,'','I will go ahead and help the others. We will get out of here together, sister.',0,0,0,0,0,0,1,0,0,0,0,68351,26124),
(119486,'They betrayed us all. Their fates are sealed.','',0,0,0,0,0,0,1,0,0,0,69238,0,26124),
(119487,'Get me out of here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119488,'Releasing','Releasing',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119489,'A Depleted Particle falls out of the Nightwell.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119490,'I am getting off this infernal ship! I will return to my mother at once.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(119491,'Finding an ally among our enemies might prove to be a difficult task.','',0,0,0,0,0,0,1,0,0,0,68273,0,26124),
(119492,'It is time you face Darkness Incarnate himself... Gul\'dan.','',0,0,0,0,0,0,1,0,0,0,69237,0,26124),
(119493,'Only one item per week, boss. Them\'s the rules.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119494,'','You are not leaving my sight until an advisor is appointed. Promise me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119495,'Yes, mother.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119496,'','Thank you. Do let Ly\'leth know that I stand with her.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119497,'There\'s only place where we can tap into the power within the shards: the Lunar Crucible.','',0,0,0,0,0,0,1,0,0,0,69236,0,26124),
(119498,'','Of course! But the entire stronghold is still crawling with Nightborne.',0,0,0,0,0,0,1,0,0,0,0,69235,26124),
(119499,'Then I suppose we\'ll have to ask them to leave.','',0,0,0,0,0,0,1,0,0,0,69234,0,26124),
(119500,'I\'ll secure the Heart and meet you there. The Moon Guard should have the area secured when we arrive.','',0,0,0,0,0,0,1,0,0,0,69233,0,26124),
(119501,'It is good to be back home again, even if just for a little while.','',0,0,0,0,0,0,1,0,0,0,69232,0,26124),
(119502,'We are ready to begin when you are.','',0,0,0,0,0,0,1,0,0,0,69231,0,26124),
(119503,'Elun\'falah shalar.','',0,0,0,0,0,0,0,0,0,0,69230,0,26124),
(119504,'Ishnu-talah Kaldorei.','',0,0,0,0,0,0,0,0,0,0,69229,0,26124),
(119505,'Let the pain speak to me.','Let the pain speak to me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119506,'Let us begin.','Let us begin.',0,0,0,0,0,0,153,0,0,0,0,0,26124),
(119507,'Fight... together? I suppose.','Fight... together? I suppose.',0,0,0,0,0,0,153,0,0,0,0,0,26124),
(119508,'Anar\'endal dracon belora.','',0,0,0,0,0,0,0,0,0,0,69228,0,26124),
(119509,'','Elun\'orin torel!',0,0,0,0,0,0,0,0,0,0,0,69227,26124),
(119510,'Now is your moment, $p. Unleash the power hidden deep within!','',0,0,0,0,0,0,0,0,0,0,69226,0,26124),
(119511,'It worked. It really worked!','',0,0,0,0,0,0,0,0,0,0,69225,0,26124),
(119512,'Thank you for the truly incredible journey. If you ever long for another adventure, you know where to find me.','',0,0,0,0,0,0,0,0,0,0,69224,0,26124),
(119513,'My patience wears thin. Relinquish the feast to me before we do battle or you will not have my blessing this day!','',0,0,0,0,0,0,0,0,0,0,69223,0,26124),
(119514,'If you seek my blessing, even you must complete the ancient trials of these halls, Valarjar.','',0,0,0,0,0,0,0,0,0,0,69222,0,26124),
(119515,'As for you, my Valarjar... well done. Well done!','',0,0,0,0,0,0,0,0,0,41731,69221,0,26124),
(119516,'I fear we have but a moment, hero. Rakeesh is still here - somewhere - and he must be stopped if my people are to find peace again.','',0,0,0,0,0,0,1,0,0,0,70893,0,26124),
(119517,'I know that you have ventured far to find me and have brought with you a dire message.','',0,0,0,0,0,0,273,0,0,0,70892,0,26124),
(119518,'In your possession is an object of great importance. May I see it?','',0,0,0,0,0,0,25,0,0,0,70891,0,26124),
(119519,'<Place the Mysterious Lightbound Object on the ground.>','<Place the Mysterious Lightbound Object on the ground.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119520,'Next time you hold a blade to someone\'s throat, consider who you\'re dealin\' with.','',0,0,0,0,0,0,25,0,0,0,69519,0,26124),
(119521,'Now we\'re square. Business as usual goin\' forward. Feel free to use the crucible as much as you like.','',0,0,0,0,0,0,25,0,0,0,69520,0,26124),
(119522,'','The situation in Stormwind is worse than we thought. We have a plan to reveal Detheroc for the imposter that he is. Master Shaw?',0,0,0,0,0,0,1,0,0,0,0,69521,26124),
(119523,'Tethys will get us to the harbor by sea. We will have to stealth through to SI:7. We cannot fly in; Detheroc has snipers on the rooftops and wanted posters up with all of our faces.','',0,0,0,0,0,0,274,0,0,0,69522,0,26124),
(119524,'First, allow me to express my gratitude that you risked your lives to rescue me.','',0,0,0,0,0,0,1,0,0,0,69523,0,26124),
(119525,'I trust that you will not come to regret that decision. What I\'m going to propose is much more dangerous.','',0,0,0,0,0,0,274,0,0,0,69524,0,26124),
(119526,'Taoshi is correct. The situation is dire and degrading quickly. The Alliance is about to launch an attack on the Horde.','',0,0,0,0,0,0,1,0,0,0,69525,0,26124),
(119527,'Posing as me, Detheroc is whispering lies about the Horde in the ears of the new king of Stormwind. He must be stopped before it is too late.','',0,0,0,0,0,0,1,0,0,0,69526,0,26124),
(119528,'The plan is simple: sneak into Stormwind, expose Detheroc, and then kill him.','',0,0,0,0,0,0,273,0,0,0,69527,0,26124),
(119529,'','Thank you, Master Shaw. That\'s the plan, Uncrowned. All in favor?',0,0,0,0,0,0,6,0,0,0,0,69528,26124),
(119530,'Help! Please!','Help! Please!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119531,'Legion structure! Fields southwest of Tarren Mill! Bring it down!','',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(119532,'ALLIANCE - mount up! Western hills are swarmin\' with demon filth!','',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(119533,'Eastpoint Tower\'s under attack!','',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(119534,'','Send reinforcements to Southpoint Gate!',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(119535,'Another demon! Eastpoint! We\'ll hold it off as long as we can!','',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(119536,'An unpleasantly large demon has arrived at our camp in Southshore. Reinforcements would be greatly appreciated.','',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(119537,'May I see it?','',0,0,0,0,0,0,6,0,0,0,70890,0,26124),
(119538,'For the Alliance!','For the Alliance!',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(119539,'Well fought!','Well fought!',0,0,0,0,0,0,71,7,0,0,0,0,26124),
(119540,'Together as one!','Together as one!',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(119541,'By our blades!','By our blades!',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(119542,'The Legion will fall!','The Legion will fall!',0,0,0,0,0,0,71,7,0,0,0,0,26124),
(119543,'Great work everyone!','Great work everyone!',0,0,0,0,0,0,396,7,0,0,0,0,26124),
(119544,'We did it!','We did it!',0,0,0,0,0,0,71,7,0,0,0,0,26124),
(119545,'','Just do it already! I would rather die than spend another day living a life built around your twisted beliefs!',0,0,0,0,0,0,603,0,0,0,0,68297,26124),
(119546,'','I no longer take their name, or their values.',0,0,0,0,0,0,1,0,0,0,0,68298,26124),
(119547,'','I wish to aid my fellow priests in their fight against the Burning Legion.',0,0,0,0,0,0,1,0,0,0,0,68299,26124),
(119548,'This is unexpected - a Scarlet priest, walking through our temple.','',0,0,0,0,0,0,1,0,0,0,68274,0,26124),
(119549,'In times such as these, we cannot afford to turn away those willing to help. We welcome you, as our new ally.','',0,0,0,0,0,0,1,0,0,0,68275,0,26124),
(119550,'','You gave me a chance to redeem myself, and I will spend my life trying to do so.',0,0,0,0,0,0,1,0,0,0,0,68300,26124),
(119551,'','The shadows will devour you!',0,0,0,0,0,0,603,0,0,0,0,68280,26124),
(119552,'','You have the Shadows at your side, should you ever need them.',0,0,0,0,0,0,1,0,0,0,0,68281,26124),
(119553,'Go on Delas, tell us what you\'ve learned.','',0,0,0,0,0,0,1,0,0,0,68276,0,26124),
(119554,'The demons killed most of my shaman. We retreated here to make one last stand.$B$B<Nobundo sighs.>','',1,1,6,0,0,0,0,0,0,0,0,0,26124),
(119555,'','A putrid slime has been pouring out of the Arcway for weeks. Find the source and cut it off!',0,0,0,0,0,0,0,0,0,0,0,70140,26124),
(119556,'','I\'ve been working with Aponi Brightmane and the leader of her order. We translated a codex that details the Legion\'s plans to establish an invasion point at Felblaze Ingress.',0,0,0,0,0,0,1,0,0,0,0,68294,26124),
(119557,'','I\'d like to take a small group of priests to accompany the paladins in their search of this demon world. If the dreadlord is there, we will find him.',0,0,0,0,0,0,1,0,0,0,0,68295,26124),
(119558,'Stop where you are! Only priests may step foot within this temple.','',0,0,0,0,0,0,603,0,0,0,68285,0,26124),
(119559,'Please, let me pass. I have news of Delas Moonfang!','',0,0,0,0,0,0,1,0,0,0,68279,0,26124),
(119560,'','May the Light guide your way.',0,0,0,0,0,0,1,0,0,0,0,68284,26124),
(119561,'','You won\'t be alone on this journey.',0,0,0,0,0,0,1,0,0,0,0,68301,26124),
(119562,'','The loose mana of the Arcway has created a monstrosity! Deal with it before it becomes an even greater threat!',0,0,0,0,0,0,0,0,0,0,0,70141,26124),
(119563,'','Arcanist Naran has yet to return from the Arcway. Find what became of him and report back to me.',0,0,0,0,0,0,0,0,0,0,0,70142,26124),
(119564,'','My spirit is one with the void!',0,0,0,0,0,0,603,0,0,0,0,68282,26124),
(119565,'','Find the keystone that once powered these halls. The mana it holds will aid our cause!',0,0,0,0,0,0,0,0,0,0,0,70143,26124),
(119566,'','Thank you, priest. The weight of the darkness has been lifted.',0,0,0,0,0,0,1,0,0,0,0,68283,26124),
(119567,'','A plague runs rampant in the Arcway. Cleanse the infestation before it spreads further!',0,0,0,0,0,0,0,0,0,0,0,70144,26124),
(119568,'Set sail for Stormwind City.','Set sail for Stormwind City.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119569,'May the Light guide you.','',0,0,0,0,0,0,1,0,0,0,68286,0,26124),
(119570,'Delas, you say?','',0,0,0,0,0,0,6,0,0,0,68287,0,26124),
(119571,'Stop that at once!','Stop that at once!',0,0,0,0,0,0,0,0,0,0,68251,0,26124),
(119572,'What do you think you\'re doing?','What do you think you\'re doing?',0,0,0,0,0,0,0,0,0,0,68252,0,26124),
(119575,'How can I be of service?','How can I be of service?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119576,'I would like to requisition some Trackers.','I would like to requisition some Trackers.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119577,'I would like to requisition some Rangers.','I would like to requisition some Rangers.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119578,'','The Arcway is one step closer to its former glory thanks to you.',0,0,0,0,0,0,0,0,0,0,0,70145,26124),
(119579,'','I never believed the serpents could get so big! You\'ve saved us all.',0,0,0,0,0,0,0,0,0,0,0,70146,26124),
(119580,'','We would have lost Arcanist Naran without your aid. Thank you. I am in your debt.',0,0,0,0,0,0,0,0,0,0,0,70147,26124),
(119581,'','This keystone will ensure our success against the Magistrix. Your efforts will not be forgotten.',0,0,0,0,0,0,0,0,0,0,0,70148,26124),
(119582,'','The plague will spread no further thanks to you.',0,0,0,0,0,0,0,0,0,0,0,70149,26124),
(119583,'I hate being right all the time.','I hate being right all the time.',0,0,0,0,0,0,0,0,0,0,68257,0,26124),
(119584,'I am fairly alarmed here.','I am fairly alarmed here.',0,0,0,0,0,0,0,0,0,0,68258,0,26124),
(119585,'What\'s your problem? You spilled arcwine all over me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119586,'Just nothing! You\'ve got ten seconds to make this right before I beat you to the ground!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119587,'Sorry. I didn\'t see you there. I was just...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119588,'Well, if it\'s going to come to that, I might as well...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119589,'Sneak attack!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119590,'You should never underestimate the little ones. We can be quite... tricky.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119591,'I-I-I\'m sorry. I didn\'t see...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119592,'Didn\'t see what?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119593,'I\'ll get you some more wine, just please don\'t hurt me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119594,'You\'re such a weakling, only pandering to me to get out of a real fight.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119595,'That\'ll teach you. Only the strong survive!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119596,'Mother of Light! I... I am sorry. I did not know.','',0,0,0,0,0,0,0,0,0,0,70889,0,26124),
(119597,'$ct $n, we have to go. NOW!','',0,0,0,0,0,0,0,0,0,0,70888,0,26124),
(119598,'I will explain on the way there. Inform me when you are prepared to leave, but please hurry.','',0,0,0,0,0,0,0,0,0,0,70887,0,26124),
(119599,'What you have brought to me is known as Light\'s Heart. It is the sentience core of the naaru prime: Xe\'ra.','',0,0,0,0,0,0,1,0,0,0,70881,0,26124),
(119600,'Her... progeny. O\'ros... NO!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119601,'HAH! It makes music when you beat it! What a delightful creature! I will enjoy ending its existence.','',0,0,0,0,0,0,0,0,0,0,70832,0,26124),
(119602,'This invasion was a subterfuge. We were corralled here like cattle, exactly as they planned. Now they have found O\'ros - the last of the Light Mother\'s children!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(119603,'Gather your courage, hero. We must act quickly!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(119604,'Tell me when you are ready to rescue O\'ros and we will go.','',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(119605,'Are you prepared to save O\'ros from Rakeesh and uncover the secrets held within Light\'s Heart?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(119606,'I\'m ready, Velen!','I\'m ready, Velen!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119607,'Is there anything else that you can tell me about Xe\'ra and the naaru before we go? [I PUT ON MY RED SHIRT AND WIZARD\'S HAT]','Is there anything else that you can tell me about Xe\'ra and the naaru before we go? [LOTS OF RP]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119608,'Demons in the throne room! Protect the king!','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(119609,'Shatter their portals! Drive out the Legion!','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(119610,'Your sword has made me wonder if it would be better as an axe. What would that axe look like? Is there one out there already?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119611,'Is there an axe the equal to Strom\'kar?','Is there an axe the equal to Strom\'kar?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119612,'There must be. All the powerful qualities of the Warbreaker, but the splitting strength of an axe. There must be something!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119613,'Is that a key to Lei Shen\'s palace?  Wherever did you get that?\n\nI\'d be up for one more raid on the Thunder King\'s treasure troves, for old time\'s sake.  Just give me the word.','We are ready to launch the raid at a moment\'s notice. All we need is the key. Have you found one?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(119614,'Let\'s head to Isle of Thunder and put this key to use.','I have the key, let\'s start the raid. [Queue for solo instance.]',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(119615,'This might be the end for us, friends. But if we are going to die here today, we die fighting!','',0,0,0,0,0,0,0,0,0,0,70822,0,26124),
(119616,'King Ymiron has been defeated. He fought fiercely.','King Ymiron has been defeated. He fought fiercely.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119617,'<Odyn laughs a deep booming laugh.>$B$BYou are a devious one, $n. You are right, that would amuse me. Let it be done!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119618,'I want him to join our army.','I want him to join our army.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119619,'Absolutely out of the question.$B$BKing Ymiron betrayed his people and doomed them to a cursed existence.$B$BHe might\'ve died while fighting valiantly but I abhor him and the feeling is mutual.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119620,'That may be, but what better punishment than to force him to serve you for the rest of time?','That may be, but what better punishment than to force him to serve you for the rest of time?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119621,'Your sword is incredible, I wonder if there is an axe to match it.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119622,'Thank you.','Thank you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119623,'Sometimes it is best to get out into the field and get a personal view of the war. The war could be going better.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119624,'That was to be expected. Ymiron was a cruel and evil ruler, but he always did fight with great ferocity.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119625,'Today I\'m here to fight the enemies of Azeroth. I\'ve no interest in wasting my strength with you. What do you want?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119626,'You are one of the greatest warriors the Horde has ever fielded. Your Arcanite Reaper is feared by all of your foes.','You are one of the greatest warriors the Horde has ever fielded. Your Arcanite Reaper is feared by all of your foes.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119627,'I do not do what I do for praise. I\'m here to save Azeroth and the Horde. I sense you have a purpose here. What do you want?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119628,'<Tell Saurfang of Helgar\'s request.>','<Tell Saurfang of Helgar\'s request.>',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119629,'I am honored you and he think so highly of me. It is true I have seen no small amount of battle.','',0,0,0,0,0,0,1,0,0,923,0,0,26124),
(119630,'','I was doing research for Ranger-General Windrunner when all hell broke loose.$b$bWhat do you need?',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(119631,'You have seen much battle as well, perhaps it is time to see how far you have come. Let us duel and I will aid your smith.','',0,0,0,0,0,0,1,0,0,923,0,0,26124),
(119632,'When you are ready, send your messenger for me. I will come.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119633,'King Anduin needs me to get to Dalaran. Can you open a portal?','King Anduin needs me to get to Dalaran. Can you open a portal?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119634,'','I\'ve been readin\' about a book written by an expert tradesman that spoke at length about the Ashbringer. \n\nIt seems most copies were lost long ago, their tattered pages scattered tae the winds.\n\nI wonder if it\'s still out there somewhere? I\'m sure we could learn a thing o\' two if we could piece it back together!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(119635,'','I\'ll open it at once. Then I must inform the ranger-general of my findings. Good luck!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119636,'While I am not interested in helping your Alliance become stronger, the Legion is a threat too great to not take every possible action against.','',0,0,0,0,0,0,1,0,0,924,0,0,26124),
(119637,'Sister, could you take a look at these? They might be the missing pieces of the book!','Sister, could you take a look at these? They might be the missing pieces of the book!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119638,'I know of your exploits, but I must see them firsthand before I give you what you want. Let us duel.','',0,0,0,0,0,0,1,0,0,924,0,0,26124),
(119639,'','<Elda carefully thumbs through the pages, her eyes moving rapidly across the weathered text.>\n\nBy the Light, Highlord - I think you\'re right! This must be the one!\n\nI should be able tae piece it back together - allow me just a moment!',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(119640,'Of course.','Of course.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119641,'Why have I been brought back to fight for you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119642,'You look pleased. You have found your warrior?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119643,'<Tell Helgar of Saurfang and his request.>','<Tell Helgar of Saurfang and his request.>',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119644,'Welcome to Dalaran! I\'m happy to assist with anything you need.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119645,'We have a place for that. Make your way to the Circle of Glory. I will send a val\'kyr to bring this Saurfang.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119646,'I must inform the Council of your news. Good luck, $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119647,'','It should only take a moment o\' two. Oh, this is so excitin\'!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(119648,'Let\'s meet back at the Hall of Shadows.','Let\'s meet back at the Hall of Shadows.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(119649,'','I\'ll press a copy for our archives so ye can keep the finished book, Highlord.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119650,'','How fascinatin\'. This Nat Pagle sounds like quite the adventurer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119651,'','Aha! Success!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119652,'','Ye should see if ye can find anyone who might know more about this book. I think it\'s hintin\' at somethin\' far bigger than a day o\' fishin\'!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119653,'I am here. Let us not waste time!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119654,'It is good to see you, friend. I was able to hold them off but I fear more will be upon us soon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119655,'Enough! You have proven your ability. I will grant your request.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119656,'','Hello, peach!  Be careful if you\'re going to Dalaran Crater, it\'s quite a drop.\n\nI just so happen to have some gliders for sale if you need one though.\n\n10 gold.\n\nNo refunds.',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(119657,'Sure, I\'ll take one.','Sure, I\'ll take one.',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(119658,'A fine fight I saw! Master Saurfang, I believe $n chose correctly with you. Now, may I see you and your weapon together?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119659,'Fine, though I have never seen a smith work in such a manner.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119660,'A smith with enough knowledge can see the details. The scratches on the blade, the wear of the haft tell of battle stresses and where it hits most often. See how easily you balance the heft. The comfort of your grip shows years of experience. While that cannot be forged, I can improve a new weapon in the right places so its wearer strikes more true and lives to earn those years.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119661,'','Good choice!  Make sure to use it before you hit the ground.  It\'s not much help after that.',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(119662,'The elementals sense the disturbance here. Defend yourselves!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119663,'A single goblin glider kit will cost:','A single goblin glider kit will cost:',0,0,0,0,0,0,3,0,1,0,0,0,26124),
(119664,'This is only the beginning. The withered will be drawn to this much energy in one place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119665,'Why not both, your highness? I will tell you the tale of the black drake Nefarian\'s fall, if you would tell me more about this book and the Ashbringer.','Why not both, your highness? I will tell you the tale of the black drake Nefarian\'s fall, if you would tell me more about this book and the Ashbringer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119666,'Incoming!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119667,'Please, hero, we have no time to waste! Come!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(119668,'That was close. I thought they\'d never stop coming.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119669,'What?! The Nightborne are upon us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119670,'This is the last of my power. Take it and destroy these traitors!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119671,'That was the last of them. I can use what little power I have left to escape. Farewell, friends.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119672,'Ah, yes. I had heard of Nefarian\'s demise, but it is indeed a treat to see his grisly end firsthand. Were I not stuck in these halls I might pay his lair a visit. \n\nPerhaps one day.\n\nAs for my end of our agreement, the tale of the Ashbringer is one of my favorites, of course.\n\n<The Prince glances at your weapon and smiles.>\n\nBut it would seem you are familiar with that particular tale.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119673,'What about this book? Can you tell me what it all means?','What about this book? Can you tell me what it all means?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119674,'A human mage gave me a copy of that book many years ago. He kept trying to convince me to help him, going on about something to do with fighting fire with fire.\n\nI cannot leave this place, as you know, so that was the last I saw of the strange fellow. He went off to reunite with his allies, I presume.\n\nYou are not the first to inquire about this book, however. I wonder...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119675,'Who else sought you out?','Who else sought you out?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119676,'He was a Tauren if I am not mistaken - and I am not often mistaken.\n\nHe came here with a copy of that very book, just as you have today, but had no proof of the black drake\'s death, and so my lips remained sealed. He was quite eager to learn about the Ashbringer\'s whereabouts.\n\nPerhaps if you found him, he might be able to enlighten you further.','',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(119677,'She was a dwarf if I am not mistaken - and I am not often mistaken.\n\nShe came here with a copy of that very book, just as you have today, but had no proof of the black drake\'s death, and so my lips remained sealed. She was quite eager to learn about the Ashbringer\'s whereabouts.\n\nPerhaps if you found her, she might be able to enlighten you further.','',0,0,0,0,0,0,0,0,0,924,0,0,26124),
(119678,'Do you know anything more about what this wizard created to deserve such a fate?','Do you know anything more about what this wizard created to deserve such a fate?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119679,'Armies of Ulduar, heed Odyn\'s call!','',0,0,0,0,0,0,0,0,0,0,68390,0,26124),
(119680,'Father! Though we are oathbound to answer the call of the Gjallarhorn, we cannot.','',0,0,0,0,0,0,0,0,0,0,68398,0,26124),
(119681,'The halls of Ulduar have been overrun by the armies of the Legion. We are fighting bravely but their numbers are endless.','',0,0,0,0,0,0,0,0,0,0,68399,0,26124),
(119682,'I do not know.\n\nThey say that only the crusade knows the truth, and they have been all but eradicated.\n\nPerhaps you might find the answers you seek in one of their former holds.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119683,'','I\'m afraid I don\'t know.\n\nOnly the crusaders that killed him know the truth, and none among their ranks live to reveal it.\n\nI would search their former holds for answers.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119684,'Thorim... son! Hold them off! I shall send my champions to your aid.','',0,0,0,0,0,0,0,0,0,0,68400,0,26124),
(119685,'Let it be known! Today, thanks to the new Battlelord of the Valarjar we have won our first decisive victory against the Legion in one of their own worlds.','',0,0,0,0,0,0,0,0,0,0,69283,0,26124),
(119686,'<One of the sections in particular is slightly more worn than the others.>\n\n...the loathsome wizard is more resilient than I had first expected.\n\nStill, showing him the Light\'s wrath has been one of my great joys these past few weeks. The heathen deserves worse - who would dare try to create something so foul from the very shadows we seek to destroy?!\n\nI knew his kind were not to be trusted.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119687,'Victory to the Valarjar! Victory to the Battlelord!','',0,0,0,0,0,0,0,0,0,0,69284,0,26124),
(119688,'<Turn the page.>','<Turn the page.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119689,'I cannot afford to dispose of the wretch here; the attention it would draw if he were found would only further complicate my glorious work.\n\nNo... I have a better idea. I will bring him to death\'s very door and leave him in the Plaguelands. \n\nThere is a particularly vile slime on the river\'s edge that will ensure not a trace remains of the traitorous louse... if I can find the damned creature.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119690,'Kids these days, no respect for archival. When I was an apprentice, why, I cared!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119691,'I searched the world high and low for information! I wrote down everything. Even the inconsequential things. I\'ve seen things you would not believe, $Glad:lass;. Things you would not believe!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119692,'I wrote the story of this order. But that blasted apprentice lost all of them. All of them! It\'s ridiculous, I tell you. He sold them for mere coppers a page!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119693,'I bought this one back, but the rest were long gone. Paid a pretty penny for it too, golds where that blasted fool got coppers. I\'ve been searching high and low, but haven\'t been able to find more than rumors of the rest. These old bones aren\'t as up for adventuring as they were.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119694,'I agree, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119695,'Pah, no respect for your elders.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119696,'What did you do?','What did you do?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119697,'That\'s nice.','That\'s nice.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119698,'I wouldn\'t believe them?','I wouldn\'t believe them?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119699,'What did you write down?','What did you write down?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119700,'That\'s terrible.','That\'s terrible.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119701,'What did you do then?','What did you do then?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119702,'Go away. I\'ve no time to be patronized.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119703,'Ah, the Ashbringer yet lives. Curious.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119704,'You will find no fight here, paladin. I can do you no harm, and bear no allegiance to the dark creatures you seek to destroy.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(119705,'What happened to you?','What happened to you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119706,'Are you mad? That\'s the farthest thing from nice I could imagine, short of ripping my beard out hair by luxuriant hair.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119707,'I suspect you know. We would not be meeting otherwise.\n\nMy story is simple. The original wielder of your blade proved unable to stand against the endless throngs of undead that threatened our world.\n\nI sought a different approach... one that could not fail.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(119708,'<Take the book.>','<Take the book.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119709,'And what was that?','And what was that?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119710,'All conduits are active. Can you amplify the feed?','All conduits are active. Can you amplify the feed?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119711,'I devised a way to fight the scourge using their own magic against them. It was a simple process, really - I had a veritable river of souls at my disposable from the Lich King\'s rampage.\n\nIn the end, I created a counterpart to the holy relic that fuels the Ashbringer\'s strength, but before I could properly seal it within a suitable blade I was found out by Isillien and his dogs.\n\nThe rest, as they say, was excruciatingly painful.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(119712,'What happened to the crystal?','What happened to the crystal?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119713,'Before I was devoured ever so slowly I did two things.\n\nThe first, as should be obvious, was putting my necromantic learnings to the test, sealing my soul within the phylactery you found. It did nothing for the pain of death... but it has served its purpose.\n\nAfterward, as I was already half-consumed by the creature, I hurled the crystal into the river beside you in hopes that someone might still put it to use against the forces of darkness.\n\n<The lich\'s face contorts into something of a smile.>\n\nIf you seek it, you will find it there.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(119714,'You know, I\'ve been rather missing having some skin on my bones.  Maybe there\'s something we can do about that?','',0,0,0,0,0,0,0,0,0,0,69311,0,26124),
(119715,'No. Lower caste. Won\'t do at all.','',0,0,0,0,0,0,0,0,0,0,69312,0,26124),
(119716,'Not bad... not bad.  Green eyes though?  Mine were grey.','',0,0,0,0,0,0,0,0,0,0,69313,0,26124),
(119717,'I feel a dark presence nearby...','',0,0,0,0,0,0,661,0,0,0,0,0,26124),
(119718,'Do you feel it as well, Highlord? Something isn\'t right.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119719,'I\'ve recovered a dark, but powerful crystal, Maxwell.\n\nIf we can harness its power it might prove useful against the Legion.','I\'ve recovered a dark, but powerful crystal, Maxwell. If we can harness its power it might prove useful against the Legion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119720,'I see.\n\nI trust your wisdom, Highlord, but I can\'t say that this sits well with me. \n\nHow can we ever be sure that the power within that thing won\'t... change you?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119721,'There cannot be Light without Shadow. We must strike a balance.','There cannot be Light without Shadow. We must strike a balance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119722,'You\'re right, but how can we ever hope to tap into that safely? Our power will only...\n\n<Tyrosus pauses.>\n\nThe Ebon Blade.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119723,'Careful with that thing!','Careful with that thing!',0,0,0,0,0,0,396,7,0,0,0,0,26124),
(119724,'Bring it back in one piece!','Bring it back in one piece!',0,0,0,0,0,0,396,7,0,0,0,0,26124),
(119725,'Hey! I wasn\'t finished yet.','Hey! I wasn\'t finished yet.',0,0,0,0,0,0,396,7,0,0,0,0,26124),
(119726,'You be careful out there!','You be careful out there!',0,0,0,0,0,0,396,7,0,0,0,0,26124),
(119727,'Su\'esh roars happily at $n.','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(119728,'You\'ve shown me more mercy than I deserve.','You\'ve shown me more mercy than I deserve.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119729,'Thank you, $n. I will not forget your kindness.','Thank you, $n. I will not forget your kindness.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119730,'You have given me a second chance. I will not waste it.','You have given me a second chance. I will not waste it.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119731,'Free at last! I\'ve been a prisoner of their beliefs for far too long.','Free at last! I\'ve been a prisoner of their beliefs for far too long.',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(119732,'Su\'esh begins to thrash nervously. Turn back before she throws you off!','Su\'esh begins to thrash nervously. Turn back before she throws you off!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119733,'I believe I know a way I can help you, small one.','',0,0,0,0,0,0,1,0,0,0,69220,0,26124),
(119734,'I believe I know a way I can help you, Conjurer.','',0,0,0,0,0,0,1,0,0,0,69219,0,26124),
(119735,'Scaleguard, freeze them to their bones!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119736,'Tidecaller, shield me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119737,'Archmage Vargoth, what is the source of your power?','Archmage Vargoth, what is the source of your power?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119738,'I\'d like to try the brewing challenge again.','I\'d like to try the brewing challenge again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119739,'It is my duty to remain and ensure the Legion does not penetrate the gates.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119740,'What is your message, Priestess?','What is your message, Priestess?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119741,'','It is a risk, but the Temple will be vulnerable regardless. We should stand together.',0,0,0,0,0,0,1,0,0,0,0,72065,26124),
(119742,'','What if the stranger does not arrive as he promises? Can we count on his word?',0,0,0,0,0,0,6,0,0,0,0,70925,26124),
(119744,'You would trust the words of that stranger? The one who looked like a dreadlord himself?','',0,0,0,0,0,0,6,0,0,0,68585,0,26124),
(119745,'Balnazzar won\'t expect heavy resistance. It could be our chance to slay him once and for all.','',0,0,0,0,0,0,1,0,0,0,68586,0,26124),
(119746,'','Netherlight Temple is in danger. Together, Knights of the Silver Hand, we can make our final stand against Balnazzar.',0,0,0,0,0,0,1,0,0,0,0,68587,26124),
(119747,'Beyond that, nothing is certain. Let us simply have faith that the Light will answer.','',0,0,0,0,0,0,1,0,0,0,68588,0,26124),
(119748,'','I\'m ready to leave this place and never look back.',0,0,0,0,0,0,1,0,0,0,0,68582,26124),
(119749,'I am Gul\'dan! I am darkness incarnate! It cannot end... like this.','',0,0,0,0,0,0,0,0,0,0,68559,0,26124),
(119750,'Time to return the demon hunter\'s soul to his body... and deny the Legion\'s master a host!','',0,0,0,0,0,0,0,0,0,0,68560,0,26124),
(119751,'You topple a pawn and presume to challenge its master? Such arrogance!','',0,0,0,0,0,0,0,0,0,0,68561,0,26124),
(119752,'Behold the shadow of what is to come, the endless darkness that shall consume your world.','',0,0,0,0,0,0,0,0,0,0,68562,0,26124),
(119753,'You are not prepared!','',0,0,0,0,0,0,0,0,0,0,68563,0,26124),
(119754,'Become a vessel of darkness!','',0,0,0,0,0,0,0,0,0,0,68564,0,26124),
(119755,'Feel the power... of the demon within!','',0,0,0,0,0,0,0,0,0,0,68566,0,26124),
(119756,'Behold the Flames of Azzinoth!','',0,0,0,0,0,0,0,0,0,0,68567,0,26124),
(119757,'Gaze upon the inevitable end of all you know... all you fought for!','',0,0,0,0,0,0,0,0,0,0,68565,0,26124),
(119758,'That was too easy!','',0,0,0,0,0,0,0,0,0,0,68568,0,26124),
(119759,'Now you fall!','',0,0,0,0,0,0,0,0,0,0,68569,0,26124),
(119760,'How... is it even... possible?','',0,0,0,0,0,0,0,0,0,0,68570,0,26124),
(119761,'He will... yet claim... this titan...','',0,0,0,0,0,0,0,0,0,0,68571,0,26124),
(119762,'Was that all the fury you could muster?','',0,0,0,0,0,0,0,0,0,0,68572,0,26124),
(119763,'Too late! I am unstoppable!','',0,0,0,0,0,0,0,0,0,0,68573,0,26124),
(119764,'Su\'esh runs over to take a drink.','Su\'esh runs over to take a drink.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119765,'Hear now the tale of how Skovold stole his title of king. Witness the treachery he showed the one who bore him.','',0,0,0,0,0,0,0,0,0,0,69771,0,26124),
(119766,'And so rose the God-King Skovald, covered in the blood of his own family.','',0,0,0,0,0,0,0,0,0,0,69770,0,26124),
(119767,'','Traitors!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119768,'','Die, followers of the false king!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119769,'','Your false god-king cannot save you now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119770,'','For the Queen!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119771,'','Skovald shall fall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119772,'','Foolish boy. Do you think your fel tricks will save you from my wrath?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119773,'','You may have murdered your father. You may have murdered your brothers. But that does NOT give you the right to rule our people!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119774,'Return when you are ready to face the forces of Nightmare. Until then, we will plan our next steps.','',0,0,0,0,0,0,1,0,0,0,69218,0,26124),
(119775,'','You... are no longer... my son...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119776,'No, mother. I am your KING!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119777,'','Choose, but choose wisely. The fate of the Broken Isles is in your hands.',0,0,0,0,0,0,0,0,0,0,0,69529,26124),
(119778,'Ready when you are, $p.','',0,0,0,0,0,0,1,0,0,0,69217,0,26124),
(119779,'','This is likely a one-way trip. Detheroc is most certainly expecting us. Let me know when you are ready.',0,0,0,0,0,0,0,0,0,0,0,69530,26124),
(119780,'','The Light guides my sword!',0,0,0,0,0,0,0,0,0,0,0,68595,26124),
(119781,'','Search deep for your inner strength.',0,0,0,0,0,0,0,0,0,0,0,68596,26124),
(119782,'','We stand together.',0,0,0,0,0,0,0,0,0,0,0,68597,26124),
(119783,'','I will fight in the name of Elune!',0,0,0,0,0,0,0,0,0,0,0,69633,26124),
(119784,'','May the Light guide me.',0,0,0,0,0,0,0,0,0,0,0,69634,26124),
(119785,'','See you at SI:7. Good luck, $n.',0,0,0,0,0,0,0,0,0,0,0,69531,26124),
(119786,'We\'ll split up and stealth in. Keep moving. Use the hay bales if you get into trouble.','',0,0,0,0,0,0,0,0,0,0,69532,0,26124),
(119787,'You\'ve succeeded! I\'ve opened up a portal for you to return. Hurry! I can only maintain it for so long.','',0,0,0,0,0,0,0,0,0,0,68607,0,26124),
(119788,'You there! Please help me and listen to what I have to say!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119789,'Thank you. My communing with nature has brought me back to this location. There is a foulness in the area we must purge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119790,'Oh no! Ursoc\'s spirit has once more been captured? Quickly friends, I will help as best I can!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119791,'Forgive me... We were too weak...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119792,'What we have done here today... I can only hope it was the right thing. Thank you, friends.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119793,'HALT. Inspection required.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119794,'Stand by for screening.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119795,'Suspicious individual detected.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119796,'Show your identification. COMPLY.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119797,'Scanning arcane essence...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119798,'|TInterface\\Icons\\Spell_Shadow_SoulGem:20|t An |cFFFF0000|Hspell:209489|h[Eye of Gul\'dan]|h|r focuses on you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(119799,'I\'m really nervous, what if I fall?','I\'m really nervous, what if I fall?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119800,'I can\'t wait to soar amongst the clouds.','I can\'t wait to soar amongst the clouds.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119801,'I\'m not really getting it...','I\'m not really getting it...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119802,'This is the scariest thing we\'ve had to do yet!','This is the scariest thing we\'ve had to do yet!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119803,'I wonder if I\'m going to want to eat worms...','I wonder if I\'m going to want to eat worms...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119804,'Ah, the great outdoors!','Ah, the great outdoors!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119805,'We will make our last stand on your command, champion! Tell me when you are ready.','',0,0,0,0,0,0,25,0,0,0,70821,0,26124),
(119806,'','As you glide, search for currents of warm air to keep yourself aloft. These senses will be new to you, and you will grow accustomed to them with time.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(119807,'','Use your tail feathers to steer. You may be unaccustomed to use of this muscle, be sure to practice a bit before you hit a tree!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(119808,'','Other birds may take affection to your new form. Be wary of... romantic behaviors.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(119809,'','Your beak is for more than just chatting, keep yourself neat and preened or you may end up infested with bugs!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(119810,'','Be warned: you will feel the STRONG urge to eat worms. I cannot stress this enough - do not eat worms, you will regret it.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(119811,'','When you spread your wings, tilt them away from the incoming drafts of wind to set yourself aloft.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(119812,'','It may take a moment to adjust your vision to the new locations of your eyes. It may be best to have a nearby perch handy.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(119813,'Where you goin\'? Nowhere!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119814,'Boom! Never even saw it coming!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119815,'','We will not let the heretics finish what they started. \n\nOur leader\'s spirit may be lost to the void, but we will keep her body safe until it can be returned.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(119816,'','With our leader returned to us, the Forgotten Shadows may rise again.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(119817,'Owch, that looked like it hurt.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119818,'','Azeroth has never before faced the full might of the Burning Legion, but with courage and diligence the Ebon Blade will be victorious.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119819,'Don\'t worry, boss. I\'ll send flowers.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119820,'Now do your victory pose!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119821,'Okay, kill the ones in the dresses.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119822,'Remember, always fight on the roads. Objectives are for suckers.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119823,'I\'m already carrying a flag! Do we win?','',0,0,0,0,0,0,0,0,0,42491,0,0,26124),
(119824,'Everytime we kill someone, let\'s do a cool pose.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119825,'Thank you, stranger. The rage... the corruption is gone. Now I must tend to the waters I have neglected for so long.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119826,'Out of the way! Future gladiator coming through!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119827,'A pure life essence... I only hope it is enough.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119828,'[Relieved Sigh] ... Balance is restored. The Arcan\'dor will not fail.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119829,'','We will carry this burden, Valewalker. Have a little faith.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119830,'Our reinforcements are on approach!','',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(119831,'Highlord, your saddle is ready to take into battle!','Highlord, your saddle is ready to take into battle!',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(119832,'','The vile mystics of Haustvald continue to pervert the souls of our fallen warriors. Enter this place that my sisters and I dare not tread and destroy their corrupting dark runes.',0,0,0,0,0,0,0,0,0,0,0,69756,26124),
(119833,'','Thank you, champion. Had the mystics been left to their own devices, those dark runes would have claimed countless other souls of the Valarjar.',0,0,0,0,0,0,0,0,0,0,0,69757,26124),
(119834,'','Welcome to our humble clinic. Are there wounds you need treated or are you here for supplies?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119835,'Work, damn you. Work!','',0,0,0,0,0,0,1,0,0,0,69216,0,26124),
(119836,'We\'ve done it! The Legion will surely falter at such power.','',0,0,0,0,0,0,1,0,0,0,69215,0,26124),
(119837,'I left the City to find my daughter. She was one of those who dared speak against Elisande...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119838,'She is gone. I thought I would join her in the ruins as a mindless husk, but you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119839,'You saved me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119840,'I will seek shelter now. I hope we meet again, friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119841,'Horsemen, our unholy fate awaits us! We will leave for Acherus at once.','',0,0,0,0,0,0,0,0,0,0,68890,0,26124),
(119842,'General Tel\'arn... one of the great heroes of the War of the Ancients. He has been returned to life, but his sorrow at his failure has driven him mad. Grant him an eternal rest.','',0,0,0,0,0,0,0,0,0,0,70623,0,26124),
(119843,'Well done. I feel no joy from this, but it was necessary.','',0,0,0,0,0,0,0,0,0,0,70624,0,26124),
(119844,'Some of nature\'s creations cannot be suffered to live. The Ancient Widow that has taken residence in Black Rook Hold numbers among them. Slay it!','',0,0,0,0,0,0,0,0,0,0,70619,0,26124),
(119845,'What a horrible creature. I shudder even thinking of it.','',0,0,0,0,0,0,0,0,0,0,70620,0,26124),
(119846,'In our people\'s more foolhardy days, we experimented freely with the Arcane. Galeorn was brilliant, but the foul magic at work here has rendered him mad. He must be stopped.','',0,0,0,0,0,0,0,0,0,0,70621,0,26124),
(119847,'His power had to be contained. You have done well.','',0,0,0,0,0,0,0,0,0,0,70622,0,26124),
(119848,'Braxas is a Legion commander so vile even the other demons fear him. Reports are he slaughters any demons who are too weak to earn his respect. End him in the defense of Azeroth!','',0,0,0,0,0,0,0,0,0,0,70627,0,26124),
(119849,'A foul, foul creature. You have done well.','',0,0,0,0,0,0,0,0,0,0,70628,0,26124),
(119850,'|TInterface\\Icons\\inv_misc_trinket6oih_orb4:20|t An |cFFFF0000|Hspell:211152|h[Empowered Eye of Gul\'dan]|h|r focuses on you!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(119851,'My creations will be the death of you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119852,'Arise, and destroy this intruder!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119853,'Very well. I shall deal with you myself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119854,'Go away.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119855,'The demons are taking over this island, you may want to leave.','The demons are taking over this island, you may want to leave.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119856,'Heh. You think me a foolish old orc, frail and ready to be put to the wolves? \n\nI was communing with demons when you were in swaddling blankets.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119857,'You must know much. Will you help us defeat them?','You must know much. Will you help us defeat them?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119858,'They are not your enemy, fool.\n\nNow go away.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119859,'What is going on up there? Is someone fighting?','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(119860,'','They\'re upstairs, $n!',0,0,0,0,0,0,0,0,0,0,0,69533,26124),
(119861,'This way! We have to stop Rakeesh and save O\'ros!','',0,0,0,0,0,0,25,0,0,0,70882,0,26124),
(119862,'What\'s the meaning of this, $n? I thought we were all on the same side!','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(119863,'Light damn him!','',0,0,0,0,0,0,603,0,0,0,70886,0,26124),
(119864,'I\'m the real Mathias Shaw.','',0,0,0,0,0,0,0,0,0,0,69534,0,26124),
(119865,'No, I am! Kill him, $n!','',0,0,0,0,0,0,0,0,0,0,69535,0,26124),
(119866,'Enough! I need more room.','',0,0,0,0,0,0,0,0,0,0,69536,0,26124),
(119867,'Yo! I got a real special item today for you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119868,'Your Alliance and Horde are destined to destroy each other...','',0,0,0,0,0,0,0,0,0,0,69537,0,26124),
(119869,'','I agree. They will not suspect our united force. We will have the upper hand.',0,0,0,0,0,0,1,0,0,0,0,69637,26124),
(119870,'Long have we searched for you, Prophet Velen. Here, you thought yourself safe from the Legion\'s gaze.','',0,0,0,0,0,0,0,0,0,0,69316,0,26124),
(119871,'Now, finally, your SOUL IS MINE!','',0,0,0,0,0,0,0,0,0,0,69317,0,26124),
(119872,'Balnazzar, your arrogance is mighty. But Azeroth\'s heroes will stand against you!','',0,0,0,0,0,0,0,0,0,0,69354,0,26124),
(119874,'Paladins of the Silver Hand, rally to the Highlord! Attack!','',0,0,0,0,0,0,0,0,0,0,69337,0,26124),
(119875,'What is this? The Order of the Silver Hand? Little matter. I will still destroy you!','',0,0,0,0,0,0,0,0,0,0,69318,0,26124),
(119876,'Impressive, hero. Let us see how you do without your allies!','',0,0,0,0,0,0,0,0,0,0,69319,0,26124),
(119877,'You are alone, heroes. No one is coming to help you!','',0,0,0,0,0,0,0,0,0,0,69320,0,26124),
(119878,'Enough! I tire of this game.','',0,0,0,0,0,0,0,0,0,0,69314,0,26124),
(119879,'Now, taste the TRUE might, of THE BURNING LEGION!!!','',0,0,0,0,0,0,0,0,0,0,69321,0,26124),
(119880,'Hold your ground! They won\'t take us down without a fight!','',0,0,0,0,0,0,5,0,0,0,69338,0,26124),
(119881,'','There are too many!',0,0,0,0,0,0,5,0,0,0,0,69636,26124),
(119882,'','It is no use! The prophet\'s vision has come to pass...',0,0,0,0,0,0,5,0,0,0,0,69647,26124),
(119884,'Where is your Light now, heroes?','',0,0,0,0,0,0,0,0,0,0,69322,0,26124),
(119885,'','I was so certain he was dead...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119886,'','Noressa quickly glances over the letter.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119887,'','Oh, Absolon...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119888,'Allies, do not despair. It is I, Lothraxion, High Commander of the Grand Army of the Light.','',0,0,0,0,0,0,0,0,0,0,69346,0,26124),
(119889,'On order of High Exarch Turalyon, we came as fast as we could. I am sending reinforcements down to join you.','',0,0,0,0,0,0,0,0,0,0,69347,0,26124),
(119890,'Heroes, rally beneath the Light! Balnazzar, prepare to meet your end.','',0,0,0,0,0,0,0,0,0,0,69348,0,26124),
(119891,'','Thank you. I will hold his words in my heart.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119892,'No! I will NEVER be defeated!','',0,0,0,0,0,0,0,0,0,0,69315,0,26124),
(119893,'Die in the fire of a thousand suns!','',0,0,0,0,0,0,0,0,0,0,69323,0,26124),
(119894,'I will see your world burn to ash!','',0,0,0,0,0,0,0,0,0,0,69324,0,26124),
(119895,'Nooooooo!','',0,0,0,0,0,0,0,0,0,0,69325,0,26124),
(119896,'','We did it. The dreadlord is dead.',0,0,0,0,0,0,1,0,0,0,0,69648,26124),
(119897,'Thank you, paladins of the Silver Hand.','',0,0,0,0,0,0,1,0,0,0,69355,0,26124),
(119898,'Knights of the Silver Hand! Today, we have achieved a great victory!','',0,0,0,0,0,0,0,0,0,0,69339,0,26124),
(119899,'We turned back the Burning Legion, protecting our allies and destroying our enemies!','',0,0,0,0,0,0,0,0,0,0,69340,0,26124),
(119900,'We proved that when our wills were tested, we stood strong!','',0,0,0,0,0,0,0,0,0,0,69341,0,26124),
(119901,'Under our Highlord\'s leadership, we fought to the brink of oblivion... and triumphed.','',0,0,0,0,0,0,0,0,0,0,69342,0,26124),
(119902,'To the Highlord, and the Silver Hand!','',0,0,0,0,0,0,0,0,0,0,69343,0,26124),
(119903,'','Perhaps, but not any time soon, demon.',0,0,0,0,0,0,274,0,0,0,0,69538,26124),
(119904,'It\'s over. Speak with me when you\'re ready, $n. I\'ll get us safely out of Stormwind.','',0,0,0,0,0,0,1,0,0,0,69539,0,26124),
(119905,'I cannot begin to thank you for all that you have done, $n. You\'ve given me back SI:7 and saved the Alliance and Horde from a costly war we could have ill afford.\n\nThe Burning Legion would have destroyed us all.\n\nIt goes without saying, if there\'s anything I can do for you, just let me know.\n\nAre you ready to get back to Dalaran and the Hall of Shadows?','',1,6,0,0,0,0,0,0,0,0,0,0,26124),
(119906,'I\'m ready. Let\'s get out of here, Mathias.','I\'m ready. Let\'s get out of here, Mathias.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119907,'You already knew everything on that scroll. You\'re so smart!','You already knew everything on that scroll. You\'re so smart!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119908,'','Let us celebrate the one who made all of this possible, our newest Shadowblade, $n!',0,0,0,0,0,0,0,0,0,0,0,69540,26124),
(119909,'','Detheroc is dead and Mathias Shaw is restored to his role as leader of SI:7.',0,0,0,0,0,0,0,0,0,0,0,69541,26124),
(119910,'','All-out war between the Alliance and Horde has been averted. We can now focus our full attention upon the Burning Legion.',0,0,0,0,0,0,0,0,0,0,0,69542,26124),
(119911,'','We will destroy them by every means possible. Through treachery and subterfuge. Through guile and assassination. And yes, by laying down our lives if needs be.',0,0,0,0,0,0,0,0,0,0,0,69543,26124),
(119912,'Drive the Witherbark tribe from my kingdom, and I will grant you access to the tomb of my father.','',0,0,0,0,0,0,1,0,0,0,69448,0,26124),
(119913,'Bonespeakers disturb the bones of our eldest kings. The honored dead have earned their rest. Stop these betrayers.','',0,0,0,0,0,0,0,0,0,0,69778,0,26124),
(119914,'Carefully Grabbing','Carefully Grabbing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(119915,'The dead who lay at Shield\'s Rest have been undisturbed since before my time. You have done my people a great service this day.','',0,0,0,0,0,0,0,0,0,0,69764,0,26124),
(119916,'The Helarjar are defiling the tombs of Shield\'s Rest. Drive them back!','',0,0,0,0,0,0,0,0,0,0,69763,0,26124),
(119917,'Shield\'s Rest is where the most ancient Kings of Stormheim and their honored fallen were buried. Back before the Tideskorn were afraid of the sea.','',0,0,0,0,0,0,0,0,0,0,69765,0,26124),
(119918,'Don\'t squeeze the shaman.','',0,0,0,0,0,0,0,0,0,0,68699,0,26124),
(119919,'Vile worm! You serve as lapdog to my brother!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119920,'Skovald will pay for his treachery.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119921,'Do you recognize this relic?','Do you recognize this relic?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119922,'I was the eldest, I was to be king. Not that runt Skovald!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119923,'Where did you find that? It has been many years...\n\n<Drak\'thul turns the relic over in his palm, and then hands it back to you.>\n\nThe ghosts have long since stopped their whispers. There was silence, for a while.\n\nThen they began again. Different, deeper, darker.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119924,'Locked away within the core is wisdom... knowledge crucial to our battle against the Burning Legion.','',0,0,0,0,0,0,1,0,0,0,70880,0,26124),
(119925,'Yet only a naaru born of Xe\'ra is capable of unlocking the core. This is why you were sent here, $p.','',0,0,0,0,0,0,1,0,0,0,70879,0,26124),
(119926,'O\'ros, child of Xe\'ra, and heart of the Exodar, is the only being in all of the cosmos that could decipher the message locked away within Light\'s Heart.','',0,0,0,0,0,0,1,0,0,0,70878,0,26124),
(119927,'But the only way to know what secrets lie within Light\'s Heart is through her progeny. Which is why you were directed to bring the core to me.','',0,0,0,0,0,0,0,0,0,0,70877,0,26124),
(119928,'And this is the true purpose of the Burning Legion\'s invasion of the Exodar.','',0,0,0,0,0,0,0,0,0,0,70876,0,26124),
(119929,'Tell me of these whispers.','Tell me of these whispers.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119930,'The last of Xe\'ra\'s line, O\'ros, sits unguarded in the heart of the Exodar. If they destroy O\'ros, the information within Light\'s Heart will be lost forever.','',0,0,0,0,0,0,1,0,0,0,70875,0,26124),
(119932,'They do not come when I beckon, fool.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119933,'<Drak\'thul\'s eyes are sunken and unfocused. He has his head cocked slightly, as if listening to something you cannot hear.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119934,'Drak\'thul?','Drak\'thul?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119935,'Athu\'gag magg\'naggwa.\n\nQor\'naus\'agth lwhuk.\n\nLilth gag\'huqth\'hoq.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119936,'','I fled Val\'Sharah during Ysera\'s attack on the temple. I was lucky enough to find Mythandros on the road.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119937,'We came from a village just outside Shala\'nir. It was a narrow escape, I will admit.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119938,'You are yourself again. What happened?','You are yourself again. What happened?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119940,'','The Nightmare followed us wherever we went. It was not until we crossed into Suramar that we escaped it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119941,'The whispers called to you.\n\n<Drak\'thul sighs heavily, for a moment appearing very old and frail.>\n\nI have learned many things on my years on these islands. I have delved into places I wish I had not, and learned things I long to forget.\n\nAnd now I wish to be alone, until darkness overtakes me at last.\n\nGo away.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119942,'','There were more of us when we set out. I would have died, if it were not for Mayruna\'s arrival.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119943,'We owe our lives to Mythandros and his druid companions. We can call Suramar home, thanks to him.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119944,'Thank you for your help, stranger. It means more than you know.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119945,'The greatest heroes on Azeroth have gathered to face the Burning Legion.','',0,0,0,0,0,0,0,0,0,0,69449,0,26124),
(119946,'But heroes alone will not save this world. Salvation will come at a price the living cannot pay.','',0,0,0,0,0,0,0,0,0,0,69450,0,26124),
(119947,'The time of the Four Horsemen has come... and you will bring about their return.','',0,0,0,0,0,0,0,0,0,0,69451,0,26124),
(119948,'Nazgrim, the fallen general of the Horde, shall be the firstborn. Go now and see that it is done.','',0,0,0,0,0,0,0,0,0,0,69452,0,26124),
(119949,'The time of the second horseman has come, Deathlord.','',0,0,0,0,0,0,0,0,0,0,69453,0,26124),
(119950,'Upon the cliffs of Arathor, stands the fallen kingdom of Stromgarde.','',0,0,0,0,0,0,0,0,0,0,69454,0,26124),
(119951,'It is there that you will find the tomb of Thoras Trollbane, the great warrior king.','',0,0,0,0,0,0,0,0,0,0,69455,0,26124),
(119952,'His strength in battle was without rival, and he shall be even more powerful in undeath.','',0,0,0,0,0,0,0,0,0,0,69456,0,26124),
(119954,'Step right up and challenge our reigning tournament champion! Winners will receive a handsome prize! Legal disclaimer: Prizes not always handsome.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119955,'Well done! Keep it up kid, you\'re going places... and making me a pile of gold in the process!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119956,'What is it, $c?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119957,'You\'ve an ill wind about you, priest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119958,'High Inquisitor Whitemane was a priest whose personal tragedy forged an intense connection with the Light.','',0,0,0,0,0,0,0,0,0,0,69457,0,26124),
(119959,'Have you considered Loken\'s final words to you?','Have you considered Loken\'s final words to you?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119960,'Her zealous power of will is necessary to strengthen the bond of the Four.','',0,0,0,0,0,0,0,0,0,0,69458,0,26124),
(119961,'Travel to the Scarlet Monastery and raise the High Inquisitor from her tomb inside the Cathedral.','',0,0,0,0,0,0,0,0,0,0,69459,0,26124),
(119962,'There must be one among the Four Horsemen with the power to lead.','',0,0,0,0,0,0,0,0,0,0,69460,0,26124),
(119963,'Without a leader, there will be no unity among the Four.','',0,0,0,0,0,0,0,0,0,0,69461,0,26124),
(119964,'The time has come for the Ebon Blade to return to Light\'s Hope.','',0,0,0,0,0,0,0,0,0,0,69462,0,26124),
(119965,'The body of the great Tirion Fordring rests beneath the chapel.','',0,0,0,0,0,0,0,0,0,0,69463,0,26124),
(119966,'Go now, and do what must be done.','',0,0,0,0,0,0,0,0,0,0,69464,0,26124),
(119967,'For a short time only, the Tournament is featuring one of the legendary creatures of Azeroth. Test your mettle while you can!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(119968,'Easy, now... easy! Leave something for the other competitors, will yah?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119969,'First my dozer breaks down, then those things come crashin\' down... I\'ll never get anything done around here!','',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(119970,'Oh ho! You\'ve discovered one of the tournament\'s traveling trainers! Another opportunity to show your skills and make me some gold!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(119971,'They say it\'s not strictly \"legal\" for me to bet on tournament matches. But what they don\'t know won\'t hurt \'em!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119972,'The court and its allies are in need of assistance. Perhaps your friends can help.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119973,'Well done! I speak for the court and its allies when I say, \"Thank you, hero.\"','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119974,'Something threatens the creatures of Val\'Sharah. Perhaps you can direct your companions to be of aid.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119975,'The Nightmare still infests the forests of Val\'Sharah, but you and your companions have helped preserve it.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119976,'','Our lands must be protected. I hope you have readied your companions!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119977,'','Thank you. We must remain vigilant in our defenses.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119978,'','The time has come to test you and your companions. Are you worthy of the Valarjar\'s favor?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119979,'','You show great promise.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119980,'','There are many ways to help the Nightfallen. Your companions can be of use as well.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119981,'','Your efforts help ensure that the Nightfallen have a future.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119982,'Marin, I found this coin that has your name on it.','Marin, I found this coin that has your name on it.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(119983,'You scratch my back I scratch yours! Grab another item from the vault, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119985,'Darion Mograine has sacrificed more for the Ebon Blade than any other.','',0,0,0,0,0,0,0,0,0,0,69465,0,26124),
(119986,'His body lays before you, broken. Scarred.','',0,0,0,0,0,0,0,0,0,0,69466,0,26124),
(119987,'But death is for the living, it has no power over the damned.','',0,0,0,0,0,0,0,0,0,0,69467,0,26124),
(119988,'Your Fourth Horseman lays before you, Deathlord. Command him to rise.','',0,0,0,0,0,0,0,0,0,0,69468,0,26124),
(119989,'Redhoof peers at Mythandros expectantly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119990,'Oh my, a rare bloom indeed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119991,'Thank you, noble Redhoof. We accept your blessing and give our thanks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(119992,'When you are facing multiple foes, Divine Storm is an excellent ability to rely on.','',0,0,0,0,0,0,0,0,0,0,68776,0,26124),
(119993,'When used, all enemies near you will be hit by a storm of holy energy.','',0,0,0,0,0,0,0,0,0,0,68777,0,26124),
(119994,'Divine Storm requires three Holy Power to cast.','',0,0,0,0,0,0,0,0,0,0,68778,0,26124),
(119995,'','Divine Storm requires three Holy Power to cast.',0,0,0,0,0,0,0,0,0,0,0,68779,26124),
(119996,'','When used, all enemies near you will be hit by a storm of holy energy.',0,0,0,0,0,0,0,0,0,0,0,68780,26124),
(119997,'','When you are facing multiple foes, Divine Storm is an excellent ability to rely on.',0,0,0,0,0,0,0,0,0,0,0,68781,26124),
(119998,'Use Divine Storm!','',0,0,0,0,0,0,0,0,0,0,68782,0,26124),
(119999,'','Use Divine Storm!',0,0,0,0,0,0,0,0,0,0,0,68783,26124),
(120000,'','For the Horde!',0,0,0,0,0,0,5,0,0,0,0,68784,26124),
(120001,'Very well. You may remain as a guest until your business with the commander is complete.','',0,0,0,0,0,0,1,0,0,0,68786,0,26124),
(120002,'','I will bring the blessing to Mythandros directly. See you there!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120003,'Your pet has died!. Use Revive Pet to bring it back to life.','',0,0,0,0,0,0,0,0,0,0,68787,0,26124),
(120004,'','Your pet has died!. Use Revive Pet to bring it back to life.',0,0,0,0,0,0,0,0,0,0,0,68788,26124),
(120005,'What... was that!?','What... was that!?',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(120006,'That thing... I have to get out of here!','That thing... I have to get out of here!',0,0,0,0,0,0,5,7,0,0,0,0,26124),
(120007,'What is happening?','What is happening?',0,0,0,0,0,0,5,7,0,0,0,0,26124),
(120008,'Who... who are you?','Who... who are you?',0,0,0,0,0,0,5,7,0,0,0,0,26124),
(120009,'Where am I? What happened?','Where am I? What happened?',0,0,0,0,0,0,5,7,0,0,0,0,26124),
(120010,'That feeling. I can\'t explain it!','That feeling. I can\'t explain it!',0,0,0,0,0,0,5,7,0,0,0,0,26124),
(120011,'Get far away from here! Go!','Get far away from here! Go!',0,0,0,0,0,0,5,7,0,0,0,0,26124),
(120012,'','Vanish allows you to disengage from combat and make a quick getaway.',0,0,0,0,0,0,0,0,0,0,0,68790,26124),
(120013,'Vanish allows you to disengage from combat and make a quick getaway.','',0,0,0,0,0,0,0,0,0,0,68791,0,26124),
(120014,'','This attack costs more resources, but deals more damage as well. Thankfully, your melee attacks have a chance to trigger Stormbringer, decreasing the cost.',0,0,0,0,0,0,0,0,0,0,0,68792,26124),
(120015,'This attack costs more resources, but deals more damage as well. Thankfully, your melee attacks have a chance to trigger Stormbringer, decreasing the cost.','',0,0,0,0,0,0,0,0,0,0,68793,0,26124),
(120016,'This moonwell will nourish and protect everything around it. We can finally call this place home.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120017,'On the peaks of Shield\'s Rest you will find the Skysunders. These drakes are powerful, ancient, and mad. Gather your allies, hero, and put one of these beasts down for its own sake.','',0,0,0,0,0,0,0,0,0,0,69766,0,26124),
(120018,'The Skysunders were once storm drakes of great honor, charged with the protection of Shield\'s Rest. Now they have fallen into the madness of Helya\'s dark magics.','',0,0,0,0,0,0,0,0,0,0,69758,0,26124),
(120019,'This research has been quite fascinating! I\'ve begun inscribing the translated history in the tome over here.','This research has been quite fascinating! I\'ve begun inscribing the translated history in the tome over here.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120020,'If you\'re interested in reading some of the translated history of your weapon, I just added an entry in the tome.','If you\'re interested in reading some of the translated history of your weapon, I just added an entry in the tome.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120021,'I\'ll keep adding to it as our research continues. It\'s worth taking a look if you have some time.','I\'ll keep adding to it as our research continues. It\'s worth taking a look if you have some time.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120022,'I added some more of your weapon\'s history to the tome. You should take a look when time permits.','I added some more of your weapon\'s history to the tome. You should take a look when time permits.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120023,'Some fascinating history turned up on your weapon. I added it to the tome if you want to give it a read.','Some fascinating history turned up on your weapon. I added it to the tome if you want to give it a read.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120024,'This weapon of yours has proven to have had quite the colorful past. I added some new translations to the tome if you\'re interested.','This weapon of yours has proven to have had quite the colorful past. I added some new translations to the tome if you\'re interested.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120025,'I\'ve scribed some more history on your weapon if you\'d like to take a look.','I\'ve scribed some more history on your weapon if you\'d like to take a look.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120026,'I\'ve added another part to the tome on your weapon\'s history. It\'ll be a good read if you have a minute or two.','I\'ve added another part to the tome on your weapon\'s history. It\'ll be a good read if you have a minute or two.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120027,'Well, that\'s it, $n. After weeks of research, I think we\'ve exhausted every scrap of history we could find about your weapon.','Well, that\'s it, $n. After weeks of research, I think we\'ve exhausted every scrap of history we could find about your weapon.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120028,'Thank you for dedicating so many resources to these efforts. I hope what we\'ve learned about your weapon has proved useful.','Thank you for dedicating so many resources to these efforts. I hope what we\'ve learned about your weapon has proved useful.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120029,'I just added the final chapter to our book. You should definitely give it a read.','I just added the final chapter to our book. You should definitely give it a read.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120030,'','You fools. Did you really think the Light would allow this?',0,0,0,0,0,0,0,0,0,0,0,76889,26124),
(120031,'','The Lich King himself had no power here!',0,0,0,0,0,0,0,0,0,0,0,76890,26124),
(120032,'','The Light protects this chapel, Darion. Darkness cannot abide within the Light!',0,0,0,0,0,0,0,0,0,0,0,76891,26124),
(120033,'','Darion!',0,0,0,0,0,0,1,0,0,0,0,71583,26124),
(120034,'The Four Horsemen... I have my reservations, but I will obey your will, Deathlord.','',0,0,0,0,0,0,0,0,0,0,68889,0,26124),
(120035,'The Horde will be outraged, but Nazgrim will make a powerful Death Knight.','',0,0,0,0,0,0,0,0,0,0,68888,0,26124),
(120037,'Thoras Trollbane was one of the greatest kings this world has known. The Alliance will not be pleased.','',0,0,0,0,0,0,0,0,0,0,68887,0,26124),
(120038,'Nevertheless, your will be done, Deathlord. The Ebon Blade will be honored to bring King Thoras into our fold.','',0,0,0,0,0,0,0,0,0,0,68886,0,26124),
(120040,'There are few in this world who have lived with more conviction than High Inquisitor Whitemane.','',0,0,0,0,0,0,0,0,0,0,68885,0,26124),
(120041,'Death has a way of quelling the madness of the mind... I am sure she will serve the Ebon Blade without compromise.','',0,0,0,0,0,0,0,0,0,0,68884,0,26124),
(120042,'Tirion Fordring was one of the greatest champions this world has known!','',0,0,0,0,0,0,0,0,0,0,68883,0,26124),
(120043,'If we do this... there will be a price to pay.','',0,0,0,0,0,0,0,0,0,0,68882,0,26124),
(120044,'I will obey, Deathlord. But know this...','',0,0,0,0,0,0,0,0,0,0,68881,0,26124),
(120046,'Should we go through with this, there will be no turning back.','',0,0,0,0,0,0,0,0,0,0,68880,0,26124),
(120048,'','You must wait a few moments before entering the battle again, Valarjar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120049,'You\'ll never take me while I still draw breath!','You\'ll never take me while I still draw breath!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120050,'Someone help!','Someone help!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120051,'I thank you for ceasing the whispers, the endless hungering cries of the void are now yours to bear.','',0,0,0,0,0,0,11,0,0,0,0,0,26124),
(120052,'I will guide us to the heart of the vessel. Stay within my protective barrier as I cleanse the fel taint from the pathway.','',0,0,0,0,0,0,0,0,0,0,70885,0,26124),
(120053,'Keep moving.','Keep moving.',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(120054,'Many thanks. We must keep moving.','Many thanks. We must keep moving.',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(120055,'The lands are overrun! We must stop them!','The lands are overrun! We must stop them!',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(120056,'You\'re quite the $c, aren\'t you? My thanks.','You\'re quite the $c, aren\'t you? My thanks.',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(120057,'Move! As fast as you can! Go!','Move! As fast as you can! Go!',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(120058,'Others have been captured. I\'ve seen it. They\'re everywhere!','Others have been captured. I\'ve seen it. They\'re everywhere!',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(120059,'','Priest! Over here!',0,0,0,0,0,0,603,0,0,0,0,68995,26124),
(120060,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68978,0,26124),
(120061,'The mistress\' belongs will not be disturbed.','The mistress\' belongs will not be disturbed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120062,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68977,0,26124),
(120063,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68976,68976,26124),
(120064,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68975,0,26124),
(120065,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68974,0,26124),
(120066,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68973,0,26124),
(120067,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68972,68972,26124),
(120068,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68971,0,26124),
(120069,'','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,0,68970,26124),
(120070,'','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,0,68969,26124),
(120071,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68968,68968,26124),
(120072,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68967,0,26124),
(120073,'Please... I haven\'t fed for weeks...','',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(120074,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68966,68966,26124),
(120075,'Mana... I need... mana.','',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(120076,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68965,68965,26124),
(120077,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68964,68964,26124),
(120078,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68963,68963,26124),
(120079,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68962,0,26124),
(120080,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68961,0,26124),
(120081,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68960,68960,26124),
(120082,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68959,68959,26124),
(120083,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68958,0,26124),
(120084,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68957,0,26124),
(120085,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68956,0,26124),
(120086,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68955,68955,26124),
(120087,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68954,68954,26124),
(120088,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68953,68953,26124),
(120089,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68952,68952,26124),
(120090,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68951,68951,26124),
(120091,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68950,68950,26124),
(120092,'I\'ll see you soon.','',0,0,0,0,0,0,1,0,0,0,69214,0,26124),
(120093,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68949,68949,26124),
(120094,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68948,68948,26124),
(120095,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68947,0,26124),
(120096,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68946,68946,26124),
(120097,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68945,68945,26124),
(120098,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68944,68944,26124),
(120099,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68943,68943,26124),
(120100,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68942,68942,26124),
(120102,'Kelorn Nightblade... the scum that murdered Lord Ravencrest for the Legion during the War of the Ancients! The Legion has returned him to life. Give him the second death he deserves!','',0,0,0,0,0,0,0,0,0,0,70625,0,26124),
(120103,'He deserves a hundred more deaths for his treason. Good work.','',0,0,0,0,0,0,0,0,0,0,70626,0,26124),
(120104,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68940,68940,26124),
(120105,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68939,68939,26124),
(120106,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68938,68938,26124),
(120107,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68937,0,26124),
(120108,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68936,0,26124),
(120109,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68935,68935,26124),
(120110,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,68934,68934,26124),
(120111,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68933,0,26124),
(120112,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68932,0,26124),
(120113,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68931,0,26124),
(120114,'','I will join my fallen brothers and sisters. Goodbye, Lyrea.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120115,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68930,0,26124),
(120116,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68929,0,26124),
(120117,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68928,0,26124),
(120118,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68927,0,26124),
(120119,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68926,0,26124),
(120120,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,68925,0,26124),
(120121,'','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,0,68924,26124),
(120122,'','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,0,68923,26124),
(120123,'A victor has emerged from the crowd! The battle for the chest of riches is over!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120124,'','You should head back to the portal. The High Priest and I will take care of the rest.',0,0,0,0,0,0,1,0,0,0,0,68324,26124),
(120125,'Thank you, Ashildir. We certainly do.','',0,0,0,0,0,0,1,0,0,0,69213,0,26124),
(120126,'<Give Arcanist Ke\'lorin 50 Ancient Mana.>','<Give Arcanist Ke\'lorin 50 Ancient Mana.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120127,'Thank you... be safe.','',0,0,0,0,0,0,7,0,0,0,0,0,26124),
(120128,'I... was close to withering. Come close, and receive my magic. It will ward you from whatever would do you harm.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120129,'A great enemy is defeated this day. We have shown the Legion that Azeroth will not fall quietly.','',0,0,0,0,0,0,1,0,0,0,69353,0,26124),
(120130,'Prophet Velen, warriors of light, a well earned victory. I expected nothing less from the heroes of Azeroth.','',0,0,0,0,0,0,1,0,0,0,69345,0,26124),
(120131,'Even the slayer of Archimonde has accepted this world\'s fate! Come closer, then.','',1,0,0,0,0,0,0,0,0,42636,72679,0,26124),
(120132,'','You are a monster, Darion!',0,0,0,0,0,0,0,0,0,0,0,76892,26124),
(120133,'Let us begin. Take up the scepter and try not to kill yourself with it. It has proven... challenging to control.','',0,0,0,0,0,0,0,0,0,0,68984,0,26124),
(120134,'Without monsters there can be no heroes.','',0,0,0,0,0,0,0,0,0,0,69469,0,26124),
(120135,'','Now, now, play nice.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120136,'','Don\'t put that in your mouth. You don\'t know where its been. Oh, now don\'t put it in HIS mouth!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120137,'','Who wants a nap? ...I do.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120138,'','This is called, \"wine.\" Ms. Liddie needs it to get through the day!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120139,'','Make sure to eat all of your pet treats if you want to grow up to be big and level twenty-five.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120140,'','If your all very well behaved today, I will read your favorite story, \"Murky\'s Great Adventure.\"',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120141,'','Time for arts and crafts! Wait, who ate all the paste? And the glitter? Lets call your owner before that becomes a problem.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120142,'Be mindful, traveler. These lands are no longer safe.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120143,'Champions! Riches await you in the Arena of Glory!  Fight for honor and riches!','',0,0,0,0,0,0,0,0,0,42644,0,0,26124),
(120144,'Valarjar! Victory or Death awaits you in the Arena of Glory! Prove yourself in combat!','',0,0,0,0,0,0,0,0,0,42645,0,0,26124),
(120145,'Even in a lifetime of war, I have never before seen such sacrifice.','',0,0,0,0,0,0,0,0,0,0,69470,0,26124),
(120146,'','The Light has ravaged his body. There is nothing we can do for him.',0,0,0,0,0,0,0,0,0,0,0,71584,26124),
(120147,'Highlord!','',0,0,0,0,0,0,0,0,0,0,69471,0,26124),
(120148,'Knights of the Silver Hand! Today, we achieved a great victory!','',0,0,0,0,0,0,1,0,0,0,69332,0,26124),
(120149,'We turned back the Burning Legion, protected our allies and destroyed our enemies!','',0,0,0,0,0,0,5,0,0,0,69333,0,26124),
(120150,'When our wills were tested, we stood strong!','',0,0,0,0,0,0,5,0,0,0,69334,0,26124),
(120151,'Under our Highlord\'s leadership, we fought to the brink of oblivion... and triumphed.','',0,0,0,0,0,0,1,0,0,0,69335,0,26124),
(120152,'To the Highlord, and the Order of the Silver Hand!','',0,0,0,0,0,0,4,0,0,0,69336,0,26124),
(120153,'','You\'re too late! Krosus will be your end!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120154,'I will be today\'s champion! FOR ODYN!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(120155,'Your enemies have sent reinforcements from the sea. Show my ocean fearing children how to properly sink such a vessel.','',0,0,0,0,0,0,0,0,0,0,69769,0,26124),
(120156,'BRAWLHALLA!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120157,'%s dusts off his clothing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120158,'Are you sure you want to leave? You should stay and finish the drill, $r.','Are you sure you want to leave? You should stay and finish the drill, $r.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120159,'I\'d like to leave the rumble.','I\'d like to leave the rumble.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(120160,'The enemy is among us!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(120161,'You discovered us too late, Illidari! FELBLADE, ATTACK!','You discovered us too late, Illidari! FELBLADE, ATTACK!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(120162,'Portals opening! Here they come!','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(120163,'The fuse is lit. RUN!','',0,0,0,0,0,0,0,0,17,0,0,0,26124),
(120164,'I\'m all dressed. Where\'s the party?','I\'m all dressed. Where\'s the party?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(120165,'Are you sure you want to go to the party? It is probably very far away.','Are you sure you want to go to the party? It is probably very far away.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(120166,'The barracuda are really jumping today! It\'s far too dangerous to fish right now.$b$bJust kidding! Here\'s a long pointy stick and some explosive shoes. Go and get those fish, buddy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120167,'The barracuda are really jumping today!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120168,'Sounds good to me. Let\'s do this!','Sounds good to me. Let\'s do this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120169,'Haustvald is a sacred place that is currently being defiled by pesky ravens. Filthy creatures and so foul mouthed. Would you make use of that body of yours and a grappling hook and remove some of those nests?','',0,0,0,0,0,0,0,0,0,0,69768,0,26124),
(120170,'Ravens can be so rude sometimes. I am sure you heard all of the uncouth things they were saying about you and your lineage. Thank you for removing their nests.','',0,0,0,0,0,0,0,0,0,0,69767,0,26124),
(120171,'INSERT COORDINATES','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120172,'Azsuna','Azsuna',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120173,'Val\'sharah','Val\'sharah',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120174,'Highmountain','Highmountain',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120175,'Stormheim','Stormheim',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120176,'Suramar','Suramar',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120178,'Then let the council debate.','Then let the council debate.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120179,'...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120180,'I have failed Odyn this time, but I will return to fight again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120181,'','Now go. Return once you have proven your worth.',0,0,0,0,0,0,25,0,0,0,0,69212,26124),
(120182,'','We have a tough decision before us. Do we aid the priests in their battle against Balnazzar, or do we decline and wait to fight the dreadlord on our own terms?',0,0,0,0,0,0,6,0,0,0,0,72778,26124),
(120183,'Their temple is located deep in Legion territory. We would be putting ourselves at great risk.','',0,0,0,0,0,0,1,0,0,0,68997,0,26124),
(120184,'Did you think I wouldn\'t see what you truly are, demon?','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(120185,'True, but if we are to believe what Lothraxion has said, this could be our only chance to slay Balnazzar.','',0,0,0,0,0,0,1,0,0,0,68998,0,26124),
(120186,'You would trust a dreadlord?','',0,0,0,0,0,0,6,0,0,0,68999,0,26124),
(120187,'I sensed no ill within him, only kinship. I know not what he is, but I believe him.','',0,0,0,0,0,0,1,0,0,0,69000,0,26124),
(120188,'','I agree with Arator, Boros. I felt great purity within the creature.',0,0,0,0,0,0,1,0,0,0,0,72064,26124),
(120189,'It will be dangerous, but we may never get such a chance again. It may be the only way.','',0,0,0,0,0,0,1,0,0,0,69002,0,26124),
(120190,'','If I may - Balnazzar will not suspect a united force. The Conclave and the Order of the Silver Hand, fighting together.',0,0,0,0,0,0,1,0,0,0,0,71944,26124),
(120191,'','It is decided, then.',0,0,0,0,0,0,1,0,0,0,0,70924,26124),
(120196,'','I\'ve been expecting you, $n.\n\nDelas has informed the council of Balnazzar\'s plan to attack Netherlight Temple. The question becomes, what role will the paladins play in this battle, if any? We risk a great deal if we choose to aid the Conclave.\n\nThis is not a decision to be made lightly. The council must discuss how to proceed.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(120198,'I detected a strange signal coming from this place.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(120199,'','It is Nightborne magic... but it called to us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120200,'Come. I see an opening in the rock.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120201,'We have made it in time! By the grace and glory of the Light, I will heal O\'ros. Then we will deal with Rakeesh.','',0,0,0,0,0,0,0,0,0,0,70883,0,26124),
(120202,'You have lost, Rakeesh! O\'ros is renewed and now you must answer for the atrocities you have committed!','',0,0,0,0,0,0,25,0,0,0,70884,0,26124),
(120203,'','Good choice, just don\'t call me \'champion\'. Ever.',0,0,0,0,0,0,0,0,0,0,0,69544,26124),
(120204,'|TInterface\\Icons\\spell_nature_web.blp:20|t You become entangled in the |cFFF00000|Hspell:215288|h[Web of Pain]|h|r.','|TInterface\\Icons\\spell_nature_web.blp:20|t You become entangled in the |cFFF00000|Hspell:215288|h[Web of Pain]|h|r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(120205,'What you need Lurr make?','What you need Lurr make?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120206,'I will begin the ritual when you are ready.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(120207,'Begin the ritual.','Begin the ritual.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(120208,'Ah, the fated heroes have arrived. It would appear that you have bested me, Velen.','',0,0,0,0,0,0,1,0,0,0,70836,0,26124),
(120209,'Can you know victory without first knowing defeat? Come. Fail. Die.','',0,0,0,0,0,0,1,0,0,0,70834,0,26124),
(120210,'Turn back now. The ghostship cannot leave these waters.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120211,'But before I surrender and face the judgment of the Light, there is one last thing I must do.','',0,0,0,0,0,0,0,0,0,0,70835,0,26124),
(120212,'We will ensure no harm comes to the king.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120213,'','May Elune light your path, champion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120214,'My people will be on the hunt for ways to help!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120215,'Ahh! They coming! RUN!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120216,'Ha! We\'ll get \'em wit\' these big rocks!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120217,'Ok! We definitely got \'em this time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120218,'AHHH! WE SORRY! WE PROMISE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120219,'','Be careful, boss. Outland\'s a pretty dangerous place, an\' Shattrath\'s not that much better.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120220,'Da sword! It be too much!','Da sword! It be too much!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120221,'','Watch your back, and your pockets.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120222,'No... no!','No... no!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120223,'I smell da blood of my people!','I smell da blood of my people!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120224,'My ancestors scream!','My ancestors scream!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120225,'Surrounded by ghosts!','Surrounded by ghosts!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120226,'','It went quickly this time, but in the future, it will take longer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120227,'Valormok is under attack! We\'re being bombarded by infernals!','',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(120228,'I don\'t mean to alarm anybody, but one large, very ugly demon just landed at our camp along the shore! We\'re holding \'em off, but we\'re gonna need some help out here!','',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(120229,'','Just north of the Rocketway! A gigantic, mechanical hunk of metal just landed. What the heck is that thing?',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(120230,'The Legion continues their assault! Another demon approaches the gates!','',0,0,0,0,0,0,22,1,0,0,0,0,26124),
(120231,'I swear it! The staff came to life! I must discover how it works!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(120232,'Only a few more sheep! I\'m so close to unlocking the mysteries of this artifact!','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(120233,'Nonsense! Don\'t believe this maniac!','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(120234,'Shut up, peasant!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(120235,'You\'ve lost your mind, Shepherd!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120236,'Keep your fantasies to yourself! You are no longer welcome here!','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(120237,'He turned my family into sheep!','',0,0,0,0,0,0,36,0,0,0,0,0,26124),
(120238,'He did! That dead sheep was my cousin Johnny!','',0,0,0,0,0,0,36,0,0,0,0,0,26124),
(120239,'What is it? Make it quick! I have more experimentation to perform.\n\nNO YOU CAN\'T TOUCH IT!','',6,603,0,0,3000,0,0,0,0,0,0,0,26124),
(120240,'Do you hear something? Is that... bleating?','Do you hear something? Is that... bleating?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(120241,'|TInterface\\Icons\\Sha_Ability_Rogue_EnvelopingShadows_nightmare:20|t%s is casting |cFFFF0000|Hspell:210264|h[Manifest Corruption]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(120242,'Oh, sheep!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(120243,'|TInterface\\ICONS\\spell_shaman_earthquake:20|tSea King Tidross is casting |cFFFF0404|Hspell:222482|h[Sea Quake]|h|r Get behind cover!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(120244,'','Who are you, stranger? You are not of the Legion.',0,0,0,0,0,0,0,0,0,0,0,72067,26124),
(120245,'We fight for the same side, warriors of light. Thank you for freeing me.','',0,0,0,0,0,0,66,0,0,0,69349,0,26124),
(120246,'The Legion army will soon attack Netherlight Temple. This sanctuary MUST be protected at all costs.','',0,0,0,0,0,0,396,0,0,0,69350,0,26124),
(120247,'I will bring allies to defend the Temple, but they are far away. I need your help to fight the enemy until we can arrive.','',0,0,0,0,0,0,396,0,0,0,69351,0,26124),
(120248,'There is not enough time to explain everything. I ask that you trust me, and trust in the Light.','',0,0,0,0,0,0,396,0,0,0,69352,0,26124),
(120249,'It is decided, then. The Order of the Silver Hand will stand with the Conclave. We will NOT yield the Temple to the Legion.','',0,0,0,0,0,0,396,0,0,0,69331,0,26124),
(120250,'The Legion continues to bring demons forth from portals at the Gates of Valor. Go, champion, find these portals and call to us. My brood shall come and destroy them.','',0,0,0,0,0,0,0,0,0,0,69762,0,26124),
(120251,'That should help stem the tide of demons. Thank you champion.','',0,0,0,0,0,0,0,0,0,0,69772,0,26124),
(120252,'Well done, $p! You are now prepared to do battle.','',0,0,0,0,0,0,21,0,0,0,69031,0,26124),
(120253,'*O\'ros lets loose a woeful dirge as he is disintegrated*','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120254,'','Well done, $p! You are now prepared to do battle.',0,0,0,0,0,0,0,0,0,0,0,69032,26124),
(120256,'','Just make sure to tell everyone to be real nice to him. Otherwise, we might all wake up dead tomorrow. Ya know what I mean?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120257,'A weapon of legend, that\'s what you hold. I\'ve uncovered some of its history, and have written it here so that all might partake in its glory.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120258,'I\'ll keep inscribing anything I find here. It\'s worth taking a look if you have some time.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120259,'This research has been quite fascinating! I\'ve begun inscribing the translated history on the scroll here.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120260,'I\'ll keep adding to it as our research continues. It\'s worth taking a look if you have some time.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120261,'','Good luck, boss.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120262,'Where did you come from? Intruder!','Where did you come from? Intruder!',0,0,0,0,0,0,0,0,0,0,0,71950,26124),
(120263,'An excellent choice. I will see to it that it gets done. Good to be working with a professional such as yourself, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120264,'Curses! Can you pretend you didn\'t see that?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(120265,'','Ah, the hand of the Lich King. What can I do for you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120266,'The Hand of Illidan. How can I serve, master?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120267,'','The leaves whisper worries of fel fire and Nightmare, but as long as you stand firm, so will we.\n\nHow can I be of assistance?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120268,'Wisdom is born only from failure. There is little need in fearing the trials that lie ahead of us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120269,'','The shadows whisper many secrets, for those brave enough to listen.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120270,'As an unholy death knight you command the powers of disease and death.','',0,0,0,0,0,0,1,0,0,0,69072,0,26124),
(120271,'','As an unholy death knight you command the powers of disease and death.',0,0,0,0,0,0,0,0,0,0,0,69073,26124),
(120272,'As a feral druid your main weapon is shapeshifting. In Cat Form, your claws and fangs rip and bleed your opponents.','',0,0,0,0,0,0,1,0,0,0,69074,0,26124),
(120274,'','The winds whisper of your exploits, and of those that came before. If I know the right questions to ask, we might learn much from them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120275,'Grim tales, these. I quite like them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120276,'As a balance druid the sun, moon, and stars are your allies, enabling you to unleash these primal powers upon your enemies.','',0,0,0,0,0,0,0,0,0,0,69075,0,26124),
(120277,'','As a balance druid the sun, moon, and stars are your allies, enabling you to unleash these primal powers upon your enemies.',0,0,0,0,0,0,0,0,0,0,0,69076,26124),
(120278,'<Sniff.> Thank you...','<Sniff.> Thank you...',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(120279,'I want to go home!','I want to go home!',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(120280,'I\'ll be good I promise!','I\'ll be good I promise!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120281,'These tablets tell tale of the grandest battles fought under Odyn\'s sight.\n\nOf late, I\'ve been humbled to learn of the exploits of your races. I had not expected such ferocity and valor from people so small.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120282,'Mommy where are you??','Mommy where are you??',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120283,'Run away!','Run away!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120284,'Beast master hunters possess a deep bond with their pets, calling and bolstering them in battle while striking at foes with ranged attacks.','',0,0,0,0,0,0,0,0,0,0,69077,0,26124),
(120285,'We attack on your mark, $p. Lead the charge!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(120286,'','The winds tell me of many things, recent and ancient. There is a tale to tell with that weapon of yours. I\'ve begun to etch it in the tome over here.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120287,'','I will keep adding to it as I learn more.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120288,'','Beast master hunters possess a deep bond with their pets, calling and bolstering them in battle while striking at foes with ranged attacks.',0,0,0,0,0,0,0,0,0,0,0,69078,26124),
(120289,'I\'ve learned much. Heroes wielded that weapon before it came to rest in your hands. Their tales are well worthy to be carved here for all eternity, that mighty warriors might know of their valor.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120290,'I will etch more of their stories as I learn of them. These are grand tales that I\'m eager to unfold.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120291,'As a frost mage you excel at controlling the battlefield by freezing enemies in place as ice and hail pummel them into submission.','',0,0,0,0,0,0,0,0,0,0,69079,0,26124),
(120292,'','As a frost mage you excel at controlling the battlefield by freezing enemies in place as ice and hail pummel them into submission.',0,0,0,0,0,0,0,0,0,0,0,69080,26124),
(120293,'S-so... hungry...','S-so... hungry...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120294,'As a windwalker monk you use your fists and your speed to overcome enemies.','',0,0,0,0,0,0,0,0,0,0,69081,0,26124),
(120295,'','As a windwalker monk you use your fists and your speed to overcome enemies.',0,0,0,0,0,0,0,0,0,0,0,69082,26124),
(120296,'As a retribution paladin you are a stalwart protector of the weak, a bringer of punishment to the unjust!','',0,0,0,0,0,0,0,0,0,0,69083,0,26124),
(120297,'','As a retribution paladin you are a stalwart protector of the weak, a bringer of punishment to the unjust!',0,0,0,0,0,0,0,0,0,0,0,69084,26124),
(120298,'Discipline priests draw upon the opposing forces of Light and Shadow, choosing when to heal and when to inflict damage.','',0,0,0,0,0,0,0,0,0,0,69085,0,26124),
(120299,'Find out what SI:7 is up to, $n. We can ill afford to have unknown variables at this stage of the game.','',0,0,0,0,0,0,0,0,0,0,69545,0,26124),
(120300,'','Discipline priests draw upon the opposing forces of Light and Shadow, choosing when to heal and when to inflict damage.',0,0,0,0,0,0,0,0,0,0,0,69086,26124),
(120301,'As an assassination rogue you specialize in striking from the shadows, dispatching foes with a variety of poisons and bleeding attacks.','',0,0,0,0,0,0,0,0,0,0,69087,0,26124),
(120302,'Sorry we\'re late, $p! I\'m ashamed to admit that we got lost.','Sorry we\'re late, $p! I\'m ashamed to admit that we got lost.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(120303,'','As an assassination rogue you specialize in striking from the shadows, dispatching foes with a variety of poisons and bleeding attacks.',0,0,0,0,0,0,0,0,0,0,0,69088,26124),
(120304,'As an elemental shaman you commune with ancient spirits and command primal elemental forces.','',0,0,0,0,0,0,0,0,0,0,69089,0,26124),
(120305,'','As an elemental shaman you commune with ancient spirits and command primal elemental forces.',0,0,0,0,0,0,0,0,0,0,0,69090,26124),
(120306,'As an enhancement shaman you channel the elemental forces directly into your weapons to make yourself a furious melee combatant, beating down your foes with the power of flame, earth, and storm.','',0,0,0,0,0,0,0,0,0,0,69091,0,26124),
(120307,'','As an enhancement shaman you channel the elemental forces directly into your weapons to make yourself a furious melee combatant, beating down your foes with the power of flame, earth, and storm.',0,0,0,0,0,0,0,0,0,0,0,69096,26124),
(120308,'Affliction warlocks use shadow magic and disease to wear down their enemies, then drain their very life essences to empower themselves.','',0,0,0,0,0,0,0,0,0,0,69092,0,26124),
(120309,'','Affliction warlocks use shadow magic and disease to wear down their enemies, then drain their very life essences to empower themselves.',0,0,0,0,0,0,0,0,0,0,0,69093,26124),
(120310,'Arms warriors are the ultimate physical combatants, using martial skill and weaponry to crush those who stand against them.','',0,0,0,0,0,0,0,0,0,0,69094,0,26124),
(120311,'','Arms warriors are the ultimate physical combatants, using martial skill and weaponry to crush those who stand against them.',0,0,0,0,0,0,0,0,0,0,0,69095,26124),
(120312,'Vanthir... Vanthir!','Vanthir... Vanthir!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120313,'Mind is... slipping...','Mind is... slipping...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120314,'They are trying to... kill us...','They are trying to... kill us...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120315,'No escape... so hungry...','No escape... so hungry...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120316,'Smartly now, $g lad:lass;. Old Yancey\'s not goin\' t\' convince himself t\' join our crew.','',0,0,0,0,0,0,0,0,0,0,69546,0,26124),
(120317,'Tell him that if he can\'t convince enough seadogs t\' join up, he should break out th\' belayin\' pin for a good, old press gang.','',0,0,0,0,0,0,0,0,0,0,69547,0,26124),
(120318,'','We should return to Light\'s Hope, Highlord. The council needs to hear this.',0,0,0,0,0,0,396,0,0,0,0,72066,26124),
(120319,'Highlord, let us return to your order hall. We have much to discuss.','',0,0,0,0,0,0,396,0,0,0,69344,0,26124),
(120320,'Hey Boss. Need anything?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120321,'I\'ve written more of your weapon\'s legend into the stone.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120322,'I\'ve carved more into the stone. A valorous tale.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120323,'The stone has been etched with more exploits of this weapon of yours.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120324,'More has been etched into the stone.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120325,'If you\'re interested in reading some of the translated history of your weapon, I just added more on the scroll.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120326,'I added some more of your weapon\'s history onto the scroll. You should take a look when time permits.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120327,'Some fascinating history turned up on your weapon. I added it to the scroll if you want to give it a read.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120328,'This weapon of yours has proven to have had quite the colorful past. I added some new translations to the scroll if you\'re interested.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120329,'I\'ve scribed some more history on your weapon if you\'d like to take a look.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120330,'I\'ve added another part to the scroll on your weapon\'s history. It\'ll be a good read if you have a minute or two.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120331,'I just added the final chapter to our scroll. You should definitely give it a read.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120332,'Thank you for dedicating so many resources to these efforts. I hope what we\'ve learned about your weapon has proved useful.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120333,'Well, that\'s it, $n. After weeks of research, I think we\'ve exhausted every scrap of history we could find about your weapon.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120334,'','I just added the final chapter to our book. You should give it a read.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120335,'','Thank you for dedicating so many resources to these efforts. I hope what we\'ve learned about your weapon has proved useful.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120336,'','The winds are quiet, $n. I think we\'ve uncovered all we are going to on your weapon.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120337,'The final etchings have been added. You should read them.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120338,'A truly heroic tale. Worthy of these halls, and of your hands. I was proud to be the one to tell it.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120339,'Our journey together is done, valarjar. I have learned everything I can about the weapon you hold, and the battles it has played part in.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120340,'$n has unleashed the eldritch wrath of the server engineers.','$n has unleashed the eldritch wrath of the server engineers.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120341,'Woof?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120342,'I wish to unleash the eldritch wrath of the server engineers.','I wish to unleash the eldritch wrath of the server engineers.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120343,'Azeroth itself recoils as $n unleashes an ancient evil. \n\nKosumoth the Hungering walks the land once more...','Azeroth itself recoils as $n unleashes an ancient evil. \n\nKosumoth the Hungering walks the land once more...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120344,'$ct, please forgive our tardiness! Nazgrim insisted on strangulating every demon we ran across. $G Sir:Ma\'am;, I won\'t lie... I\'m having second thoughts about him.','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(120345,'Apologies for our late arrival, $ct. The demons foolishly attempted to block our path, and we made them suffer in return!','Apologies for our late arrival, $ct. The demons foolishly attempted to block our path, and we made them suffer in return!',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(120346,'We sensed that you might be in distress, $ct. Together, we shall strike this demon down!','We sensed that you might be in distress, $ct. Together, we shall strike this demon down!',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(120347,'Rumors of your death are greatly exaggerated, $ct. They said the demons got you. We came to make sure.','Rumors of your death are greatly exaggerated, $ct. They said the demons got you. We came to make sure.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(120348,'Little hero, we have come to fight and die alongside you! Or we could win I suppose. Either way, we have come to fight!','Little hero, we have come to fight and die alongside you! Or we could win I suppose. Either way, we have come to fight!',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(120349,'We have arrived, $ct, and brought with us good brew and an overly positive attitude!','We have arrived, $ct, and brought with us good brew and an overly positive attitude!',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(120350,'$g Lad:Lass;, why would ya go off on your own without us? Do ya know how hard it is to get to this bumble-fudged island without a mage\'s portal?','$g Lad:Lass;, why would ya go off on your own without us? Do ya know how hard it is to get to this bumble-fudged island without a mage\'s portal?',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(120351,'Already getting in trouble, $ct? Hopefully we can be of service!','Already getting in trouble, $ct? Hopefully we can be of service!',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(120352,'$ct $n, we came as soon as we heard! Thank you for saving my people! Through the Light we will be victorious!','$ct $n, we came as soon as we heard! Thank you for saving my people! Through the Light we will be victorious!',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(120353,'','Reporting for duty, $ct. Prophet, it has been ages since we last saw each other. Unfortunate circumstances for our reunion, but hopefully the outcome will be in our favor!',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(120354,'You left in quite a hurry, $ct. We went to great lengths to track down your location. Thankfully we found you in time!','You left in quite a hurry, $ct. We went to great lengths to track down your location. Thankfully we found you in time!',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(120355,'This imbecile, Calydus, insisted I bring him along. I refused. He followed me anyway. Let\'s get this over with before I lose my patience and incinerate him.','This imbecile, Calydus, insisted I bring him along. I refused. He followed me anyway. Let\'s get this over with before I lose my patience and incinerate him.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(120356,'$n wields the Doomhammer now - I can think of none better.','$n wields the Doomhammer now - I can think of none better.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120357,'The Doomhammer is here! Keep the city safe, $n.','The Doomhammer is here! Keep the city safe, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120358,'$n will take care of the Legion. $gHe:she; has the Doomhammer now.','$n will take care of the Legion. $gHe:she; has the Doomhammer now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120359,'Is that the Doomhammer, $n? Is Thrall alive?','Is that the Doomhammer, $n? Is Thrall alive?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120360,'Hail Farseer $n, chosen keeper of the Doomhammer!','Hail Farseer $n, chosen keeper of the Doomhammer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120361,'The Doomhammer suits you, $n. Keep it well.','The Doomhammer suits you, $n. Keep it well.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120362,'So it is true - $n wields the Doomhammer!','So it is true - $n wields the Doomhammer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120363,'I am glad the earthen ring is still around, $n. Fight on!','I am glad the earthen ring is still around, $n. Fight on!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120364,'Placing seal.','Placing seal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120365,'You have taken well to the Light, Liadrin! It would seem that the Sunwell has renewed your vigor!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120366,'This is awkward.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120367,'Light be praised. It is good to see you, Ishanah.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120368,'There is still a chance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120369,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,69285,0,26124),
(120370,'Use |TInterface\\Icons\\ability_vehicle_sonicshockwave.blp:20|t |cFFFF0000|Hspell:78675|h[Solar Beam]|h|r to interrupt Ariden\'s channeling!','Use |TInterface\\Icons\\ability_vehicle_sonicshockwave.blp:20|t |cFFFF0000|Hspell:78675|h[Solar Beam]|h|r to interrupt Ariden\'s channeling!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120371,'The fal\'dorei were elves once... Now they are monsters, birthed in the chaotic energies of the failing arcan\'dor. They must be eradicated.','',0,0,0,0,0,0,0,0,0,0,70491,0,26124),
(120372,'Do not mourn for them. They are a mistake that must be corrected.','',0,0,0,0,0,0,0,0,0,0,70492,0,26124),
(120373,'Excellent!','',0,0,0,0,0,0,0,0,0,0,69894,0,26124),
(120374,'The arcan\'dor beneath Falanaar grew unstable and failed catastrophically. Use your Lodestone to gather energy from the Shattered Locus so we can understand why.','',0,0,0,0,0,0,0,0,0,0,70495,0,26124),
(120375,'This will help us to keep our own arcan\'dor stable. We must not fail.','',0,0,0,0,0,0,0,0,0,0,70496,0,26124),
(120376,'The soul of that one would be usefull.','',0,0,0,0,0,0,0,0,0,0,69895,0,26124),
(120377,'Another weakling falls.','',0,0,0,0,0,0,0,0,0,0,69896,0,26124),
(120378,'Easily defeated.','',0,0,0,0,0,0,0,0,0,0,69897,0,26124),
(120379,'Did it even try?','',0,0,0,0,0,0,0,0,0,0,69898,0,26124),
(120381,'Fall before your masters!','',0,0,0,0,0,0,0,0,0,0,69899,0,26124),
(120382,'','I wish to study the energies in the Shattered Locus. Capture some of the critters feeding upon the crystals there. I need them alive!',0,0,0,0,0,0,0,0,0,0,0,70487,26124),
(120383,'<evil laughter>','',0,0,0,0,0,0,0,0,0,0,69893,0,26124),
(120384,'','Excellent. This brings us one step closer to understanding the unique power of the arcan\'dor.',0,0,0,0,0,0,0,0,0,0,0,70488,26124),
(120386,'','The Legion landed right on our doorstep - and Elisande simply let them in. Disgusting. Strike at Felsoul Hold! Show the Legion that some of us are not so easily broken!',0,0,0,0,0,0,0,0,0,0,0,70479,26124),
(120387,'','Ru-shanna shal\'dorei. The Nightborne will survive.',0,0,0,0,0,0,0,0,0,0,0,70480,26124),
(120388,'So $n has the Doomhammer now? The Horde sure is coming apart at the seams I guess.','So $n has the Doomhammer now? The Horde sure is coming apart at the seams I guess.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120389,'$n has the Doomhammer in hand. Glory to the Alliance!','$n has the Doomhammer in hand. Glory to the Alliance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120390,'The Doomhammer is here! Keep the city safe, $n.','The Doomhammer is here! Keep the city safe, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120391,'Is that the Doomhammer, $n? That\'s the very weapon that slew Sir Anduin Lothar in the second war.','Is that the Doomhammer, $n? That\'s the very weapon that slew Sir Anduin Lothar in the second war.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120392,'It\'s good to see the Doomhammer in Alliance hands, $n.','It\'s good to see the Doomhammer in Alliance hands, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120393,'The rumors are true. $n wields the Doomhammer now!','The rumors are true. $n wields the Doomhammer now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120394,'I can think of no champion more worthy to carry that hammer, $n.','I can think of no champion more worthy to carry that hammer, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120395,'An Alliance champion wields the Doomhammer now? The end times must surely be upon us...','An Alliance champion wields the Doomhammer now? The end times must surely be upon us...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120396,'','Greetings to you, $c. May the Light illuminate your path.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(120397,'The Legion have begun their attack. The Conclave needs your help.','The Legion have begun their attack. The Conclave needs your help.',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(120398,'','Ten thousand years beneath a false sky, and we emerge to see the real one choked with vermin. Use the cannons in Felsoul Hold and blast those vile felbats!',0,0,0,0,0,0,0,0,0,0,0,70483,26124),
(120399,'','When the Legion is finally gone, we can gaze at the heavens in peace.',0,0,0,0,0,0,0,0,0,0,0,70484,26124),
(120400,'Innocents are being jailed all across the city. This cannot stand! Slay the guards, take their control orbs, and set my people free.','',0,0,0,0,0,0,0,0,0,0,70502,0,26124),
(120401,'Surely many of those you freed were to be exiled. You saved many lives today.','',0,0,0,0,0,0,0,0,0,0,70503,0,26124),
(120402,'','Bring these withered into the collapsed tunnels of Falanaar. Teach them to fight, and to search for relics that can aid our cause.',0,0,0,0,0,0,1,0,0,0,0,69304,26124),
(120403,'I will be waiting for you on the other side. Good luck, $n.','',0,0,0,0,0,0,1,0,0,0,69303,0,26124),
(120404,'','Oculeth, can you get a bead on them?',0,0,0,0,0,0,0,0,0,0,0,69302,26124),
(120405,'Yes, I see them. Hold on a moment...','',0,0,0,0,0,0,0,0,0,0,69301,0,26124),
(120406,'Hang on, Thalyssra. I am sending a locked chest your way.','',0,0,0,0,0,0,0,0,0,0,69300,0,26124),
(120407,'','Standing by, Oculeth.',0,0,0,0,0,0,0,0,0,0,0,69299,26124),
(120408,'','Wow. This is a big one.',0,0,0,0,0,0,0,0,0,0,0,69298,26124),
(120409,'','Be careful, $n. Do your best to minimize our losses.',0,0,0,0,0,0,0,0,0,0,0,69297,26124),
(120410,'','Use caution. We don\'t want our withered to end up in cocoons.',0,0,0,0,0,0,0,0,0,0,0,69296,26124),
(120411,'','The Elfbreaker? What a dreadful name.',0,0,0,0,0,0,0,0,0,0,0,69295,26124),
(120412,'','Look out!',0,0,0,0,0,0,0,0,0,0,0,69294,26124),
(120413,'','One of the withered is running away. Catch him before he is lost in the tunnels!',0,0,0,0,0,0,0,0,0,0,0,69293,26124),
(120414,'It looks like $n ran into some trouble, Thalyssra. I\'ll get them out of there.','',0,0,0,0,0,0,0,0,0,0,69292,0,26124),
(120415,'','These poor things have been through enough today. Oculeth, send them back.',0,0,0,0,0,0,0,0,0,0,0,69291,26124),
(120416,'$n! You made it!','',0,0,0,0,0,0,603,0,0,0,69290,0,26124),
(120417,'Without more arcwine, many citizens will wither right here in the city. Find what you can and I will see that they are cared for.','',0,0,0,0,0,0,0,0,0,0,70510,0,26124),
(120418,'I can save a lot of people with this arcwine. For many it makes all the difference.','',0,0,0,0,0,0,0,0,0,0,70511,0,26124),
(120419,'','Even the mountains of this land will crumble before the might of lord Sargeras!',0,0,0,0,0,0,0,0,0,0,0,62376,26124),
(120420,'Mana wyrms are critical in guarding the arcan\'dor from pests. Capture more from the vineyard in Suramar City.','',0,0,0,0,0,0,0,0,0,0,70493,0,26124),
(120421,'Without balance, there is chaos. These will keep our ecosystem in balance.','',0,0,0,0,0,0,0,0,0,0,70494,0,26124),
(120422,'I have enough arcwine to spare for the needy around the city. Find those who cannot travel to my tavern and see that they drink their fill.','',0,0,0,0,0,0,0,0,0,0,70498,0,26124),
(120423,'By the Light, be reborn!','',0,0,0,0,0,0,0,0,0,0,70861,0,26124),
(120424,'Do not give up, $n! The Light will prevail!','',0,0,0,0,0,0,0,0,0,0,70860,0,26124),
(120425,'Something so simple as feeding the needy, made perilous by Elisande. Your bravery is all that stands between them and a terrible fate.','',0,0,0,0,0,0,0,0,0,0,70499,0,26124),
(120426,'If the Vineyard\'s production quotas are not met, the citizens are the first to suffer. Help them reach their goals so arcwine rations continue to flow.','',0,0,0,0,0,0,0,0,0,0,70506,0,26124),
(120427,'You are going to be quite the accomplished vintner! Rations leave the vineyard once more.','',0,0,0,0,0,0,0,0,0,0,70507,0,26124),
(120428,'','Ghostly eyes are watching our every move. I don\'t think we\'ll get any privacy in this land, master.',0,0,0,0,0,0,0,0,0,0,0,71545,26124),
(120429,'Couriers deliver sensitive orders and information to lieutenants throughout the city. Intercept them and collect the correspondence they carry.','',0,0,0,0,0,0,0,0,0,0,70508,0,26124),
(120430,'Well done. I will examine these letters and see if there is any useful information for our movement within.','',0,0,0,0,0,0,0,0,0,0,70509,0,26124),
(120431,'I need you to look into a suspicious person who has been lurking around my tavern. Find where he is, follow him at a distance, and discover his purpose.','',0,0,0,0,0,0,0,0,0,0,70500,0,26124),
(120432,'He has been informing on us! We should feel fortunate we found him... the less the Grand Magistrix knows the better.','',0,0,0,0,0,0,0,0,0,0,70501,0,26124),
(120433,'','Paladins, it is time to aid our allies under the Light and defend Netherlight Temple!',0,0,0,0,0,0,603,0,0,0,0,70921,26124),
(120434,'','The Nightborne continue to lay siege to the Moon Guard stronghold. Show them there are limits to their arrogance.',0,0,0,0,0,0,0,0,0,0,0,70489,26124),
(120435,'','Elisande must not be allowed to pillage the secrets of the Moon Guard.',0,0,0,0,0,0,0,0,0,0,0,70490,26124),
(120436,'','The Moon Guard have a long tradition of training hippogryphs for battle. Take flight, and rain justice from above!',0,0,0,0,0,0,0,0,0,0,0,70481,26124),
(120437,'','Delas, ready the portal.',0,0,0,0,0,0,1,0,0,0,0,68581,26124),
(120438,'','Your words are very kind, $n. I... I\'m not sure what to do. I best be on my way. Tell William to be safe!',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(120439,'Thanks, but you\'re a seasoned $c. I\'m just a bread merchant! I\'ll return when it\'s safe.','',0,0,0,0,0,0,1,7,0,0,0,0,26124),
(120440,'','I will see to it the Nightborne end their long isolation as defenders of Azeroth, not conquerors.',0,0,0,0,0,0,0,0,0,0,0,70482,26124),
(120441,'Elisande\'s forces are planning to sweep the city in search of dissenters. It would be a shame if Su\'esh were to find her way out of the menagerie to stop them.','',0,0,0,0,0,0,0,0,0,0,70504,0,26124),
(120442,'This will hurt, Death Knight.','This will hurt, Death Knight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120443,'The pressure is off and Su\'esh is well fed. We live another day.','',0,0,0,0,0,0,0,0,0,0,70505,0,26124),
(120444,'','Fel infusion has become all the rage among those eager to please the Legion. There is no redeeming these traitors - hunt them down!',0,0,0,0,0,0,0,0,0,0,0,70514,26124),
(120445,'','Much like fashion, some day we shall wonder how anyone thought fel was a good look.',0,0,0,0,0,0,0,0,0,0,0,70515,26124),
(120446,'Do not give up! The High Priest has arrived with reinforcements!','',0,0,0,0,0,0,0,0,0,0,69356,0,26124),
(120447,'Fate brought me here, perhaps I can serve a purpose yet!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120449,'It will be your faces that I see in my last waking moments. A final agonizing memory before I am turned to ash and cast into oblivion. I welcome it...','',0,0,0,0,0,0,0,0,0,0,70831,0,26124),
(120450,'You think you\'ve won? You will know the taste of defeat, even if it means my own death!','',0,0,0,0,0,0,0,0,0,0,70828,0,26124),
(120451,'Use |TInterface\\Icons\\spell_deathknight_strangulate.blp:20|t |cFFFF0000|Hspell:49576|h[Death Grip]|h|r to interrupt Ariden\'s channeling.','Use |TInterface\\Icons\\spell_deathknight_strangulate.blp:20|t |cFFFF0000|Hspell:49576|h[Death Grip]|h|r to interrupt Ariden\'s channeling.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120452,'','The sacred peace at Tel\'anor is broken by harpy and spirit alike. Restore the tranquility that my people\'s ancestors deserve.',0,0,0,0,0,0,0,0,0,0,0,70485,26124),
(120453,'','Austerity returns to Tel\'anor, and my ancestors can rest once more. Thank you.',0,0,0,0,0,0,0,0,0,0,0,70486,26124),
(120454,'Let us take a moment to rest, and restore our temple to its intended glory.','',0,0,0,0,0,0,0,0,0,0,69357,0,26124),
(120455,'From the mouth of Argus comes your doom! For soon the annihilator will have its fill and detonate with the force of a collapsing star! Nothing but ash will be left where we stand!','',0,0,0,0,0,0,0,0,0,0,70827,0,26124),
(120456,'','Wonderful. I am ready to fight whenever you are!',4,0,0,0,0,0,0,0,0,0,0,67677,26124),
(120457,'I owe my life to you, Archmage. I will serve our order tirelessly as your champion!','',0,0,0,0,0,0,0,0,0,0,69379,0,26124),
(120458,'My strength is yours, friend. Together we will protect Azeroth!','',1,0,0,0,0,0,0,0,0,0,69380,0,26124),
(120459,'','I would be glad to lend my skills to the Tirisgarde, conjuror. I have heard great things about you.',1,0,0,0,0,0,0,0,0,0,0,69590,26124),
(120460,'Great! I will serve you and our order most faithfully!','',1,0,0,0,0,0,0,0,0,0,69381,0,26124),
(120461,'You will totally regret this when I\'m the boss!  I mean... you totally won\'t regret this, boss!','',1,0,0,0,0,0,0,0,0,0,69382,0,26124),
(120462,'The Arcane Destroyer trills a few notes and claps its hands together excitedly.','',602,0,0,0,0,0,0,0,0,0,0,0,26124),
(120463,'I am honored to serve the Tirisgarde under your leadership, Archmage. Let us fight for Azeroth!','',1,0,0,0,0,0,0,0,0,0,69383,0,26124),
(120464,'Through your guidance and strength, we have emerged the victors in a great battle that was meant to destroy us.','',0,0,0,0,0,0,1,0,0,0,69375,0,26124),
(120465,'It would be foolish to think this attack will be the last, but we should take a moment to reflect on this victory and celebrate its true hero, our High Priest.','',0,0,0,0,0,0,1,0,0,0,69376,0,26124),
(120466,'To the High Priest!','',0,0,0,0,0,0,603,0,0,0,69377,0,26124),
(120467,'Yes, I welcome all who wish to follow the path of the Light. Meet me in the Hall of Champions.','Yes, I welcome all who wish to follow the path of the Light. Meet me in the Hall of Champions.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120468,'I\'m sorry, I must think on it further.','I\'m sorry, I must think on it further.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120469,'To the High Priest!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(120470,'','To the High Priest!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(120471,'','Please take as much time as you need, Highlord. My resolve will not waver.',0,0,0,0,0,0,396,0,0,0,0,69649,26124),
(120472,'','Thank you, Highlord! I am ready.',0,0,0,0,0,0,396,0,0,0,0,69650,26124),
(120474,'All right, let\'s rumble!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120475,'Aw, yeah, for the Alliance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120476,'Aw, yeah, for the Horde!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120477,'I will serve with honor.','',0,0,0,0,0,0,0,0,0,0,69363,0,26124),
(120478,'','My tribe is gone, $n. Those who survived the Cataclysm sought refuge in Thunder Bluff. Some of our braves were killed during the Siege of Orgrimmar. Of those that were left, none returned from the Broken Shore.$b$bThe Earthen Ring is my family now, $ct. I promise you, I will fight to the end.$b$bHow can I help you today?',6,661,0,0,0,0,0,0,0,0,0,0,26124),
(120479,'','Our enemies will tremble!',0,0,0,0,0,0,1,0,0,0,0,69561,26124),
(120480,'Alliance Enthusiast admires you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120482,'Alliance Enthusiast scoots a little closer to you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120483,'Alliance Enthusiast cheers for you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120484,'Alliance Enthusiast claps.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120485,'Alliance Enthusiast steals a strand of your hair.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120486,'In my master\'s house smolder the burning husks of a thousand worlds. I am here now to prepare a place for you amidst the ruin of tomorrow.','',0,0,0,0,0,0,0,0,0,0,70830,0,26124),
(120488,'Alliance Enthusiast writes your name in a little heart.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120489,'I am here now to prepare a place for you amidst the ruin of tomorrow.','',0,0,0,0,0,0,0,0,0,0,70829,0,26124),
(120490,'Horde Fanatic admires you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120491,'Horde Fanatic scoots a little closer to you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120492,'Horde Fanatic cheers for you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120493,'Horde Fanatic claps.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120494,'Horde Fanatic steals a strand of your hair.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120495,'Horde Fanatic writes your name in a little heart.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120496,'Not wise to question Odyn. He says you lead then you lead!','',0,0,0,0,0,0,0,0,0,0,69369,0,26124),
(120497,'No... our orders...','',0,0,0,0,0,0,0,0,0,0,69366,0,26124),
(120498,'To live again and to fight! The glory of battle awaits!','',0,0,0,0,0,0,0,0,0,0,69370,0,26124),
(120499,'Dagg find da big treasure dis time!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(120500,'I choose to believe that fate has brought us together.','',0,0,0,0,0,0,1,0,0,0,69378,0,26124),
(120501,'You mean we get to work by your side to smash the fiends that attacked Ulduar? Count me in!','',0,0,0,0,0,0,0,0,0,0,69371,0,26124),
(120502,'I will unleash the wrath of thunder upon our enemies!','',0,0,0,0,0,0,0,0,0,0,69372,0,26124),
(120503,'I am in your debt. The winds of the north are at your service.','',0,0,0,0,0,0,0,0,0,0,69373,0,26124),
(120504,'No... no! I am KING YMIRON! I am NOT a servant!','',0,0,0,0,0,0,0,0,0,0,69374,0,26124),
(120505,'','I still remember the way to the Light\'s Hope Chapel. I will meet you there.',0,0,0,0,0,0,396,0,0,0,0,69635,26124),
(120506,'We will fight and win many more battles under your leadership, High Priest.','',0,0,0,0,0,0,1,0,0,0,69384,0,26124),
(120507,'','Together we will destroy the Burning Legion!',0,0,0,0,0,0,1,0,0,0,0,69555,26124),
(120508,'','I will do whatever is needed to defend Dreadscar Rift from the Burning Legion.',0,0,0,0,0,0,1,0,0,0,0,69593,26124),
(120509,'','Our will is yours to command.',0,0,0,0,0,0,1,0,0,0,0,69592,26124),
(120510,'','In the past I have guided my husband Go\'el along the path of the shaman. But for his next trial, he walks alone. What of you? What is your path?$b$bWill you be a force of nature, laying waste to our foes? A font of wisdom, discerning and fulfilling the will of the spirits? A healer, soothing the troubled and lifting up the meek? I tell you the truth, $n:$b$bA true shaman must be all of these things.',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(120511,'You have a natural instinct for survival, one that will only be strengthened in troubled times like these.','',0,0,0,0,0,0,1,0,0,0,69558,0,26124),
(120512,'','If you are leading the order in its efforts to help those in need, then I offer myself to aid in any way I can.',0,0,0,0,0,0,1,0,0,0,0,69559,26124),
(120513,'You\'ve made a friend of Baron, and in that, you\'ve also made a friend of me.','',0,0,0,0,0,0,1,0,0,0,69557,0,26124),
(120514,'','I don\'t think Hemet himself could have taught me better. I\'m happy to hunt with you anytime!',0,0,0,0,0,0,1,0,0,0,0,69560,26124),
(120515,'If we must fight, I hope that it can continue to be at your side.','',0,0,0,0,0,0,1,0,0,0,69556,0,26124),
(120516,'Huge demon headed straight for the north wall! Don\'t let it breach the gates!','',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(120517,'I don\'t believe this! Two more heading for the Hill! One to the south and another back at the north gate!','',0,0,0,0,0,0,22,7,0,0,0,0,26124),
(120518,'The guards trample my people every day, with demons at their backs. Show them that we are capable of fighting back!','',0,0,0,0,0,0,0,0,0,0,70910,0,26124),
(120519,'Everywhere the Grand Magistrix\'s forces encroach, we will push back!','',0,0,0,0,0,0,0,0,0,0,70911,0,26124),
(120520,'I\'ve come to help the withered with their combat training.','I\'ve come to help the withered with their combat training.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120521,'','Excellent. We will be training in the collapsed tunnels of Fal\'anar.$b$bHow many withered will you be bringing with you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120522,'Eight withered.\n(Costs 400 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)','Eight withered.\n(Costs 400 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120523,'Eight withered.\n|cFFFF0000(Costs 400 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)|r','Eight withered.\n|cFFFF0000(Costs 400 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120524,'Ten withered.\n(Costs 650 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)','Ten withered.\n(Costs 650 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120525,'Ten withered.\n|cFFFF0000(Costs 650 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)|r','Ten withered.\n|cFFFF0000(Costs 650 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120526,'Twelve withered.\n(Costs 900 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)','Twelve withered.\n(Costs 900 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120527,'Twelve withered.\n|cFFFF0000(Costs 900 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)|r','Twelve withered.\n|cFFFF0000(Costs 900 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120528,'Fifteen withered.\n(Costs 1300 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)','Fifteen withered.\n(Costs 1300 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120529,'Fifteen withered.\n|cFFFF0000(Costs 1300 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)|r','Fifteen withered.\n|cFFFF0000(Costs 1300 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120530,'Twenty withered.\n(Costs 2000 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)','Twenty withered.\n(Costs 2000 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120531,'Twenty withered.\n|cFFFF0000(Costs 2000 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)|r','Twenty withered.\n|cFFFF0000(Costs 2000 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120532,'Are you sure you\'re ready? Once you bring your withered to Falanaar, you will not be able to bring them back.','Are you sure you\'re ready? Once you bring your withered to Falanaar, you will not be able to bring them back.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120533,'Trust in the Light, champions! Be empowered by its grace!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120534,'','The withered are ready. Let us begin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120535,'Tadpoles! Tadpoles is the winner!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120536,'The inhabitants of Sentinel Hill have been inspired to join the fight against the Legion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120537,'A stopped clock is always right, when you use magic!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120538,'Where am I? Whose body is this?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120539,'Sparkles, fizzles, whizzbangs ahoy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120540,'A merry midsummer to all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120541,'Ants! Ants ants ants ants ants ants!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120542,'Wubba lubba dub dub!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120543,'Sparkle and shine and fizzle away!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120544,'We\'ve got company! Keep track of everything the demons break... I\'m sending them a bill!','',0,0,0,0,0,0,22,0,0,0,69574,0,26124),
(120545,'On your toes, people! You have a sacred duty to protect the investments of your trade prince!','',0,0,0,0,0,0,22,0,0,0,69575,0,26124),
(120546,'Not again! These demons have no respect for private property! Let\'s teach them a lesson!','',0,0,0,0,0,0,22,0,0,0,69576,0,26124),
(120547,'Well met, friend.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(120548,'I mastered a new spell today!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(120549,'It\'s good to see you!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(120550,'Are you as excited as I am to be here?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120551,'It\'s a great day to practice magic!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120552,'Take care, friend.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(120553,'Let me know if you need my help with anything.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120554,'Until we meet again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120555,'Yes?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(120556,'I\'m getting a headache.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120557,'I suppose persistence is a good thing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120558,'You must have better things to do.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120559,'Don\'t you have somewhere else to be?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120560,'','Knowledge is power.',3,0,0,0,0,0,0,0,0,0,0,0,26124),
(120561,'','Keep your eyes open, friend.',3,0,0,0,0,0,0,0,0,0,0,0,26124),
(120562,'','Farewell. Let me know if you come across anything interesting!',3,0,0,0,0,0,0,0,0,0,0,0,26124),
(120563,'','Can\'t you see I\'m busy?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(120564,'','What is it?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120565,'','Keep it up and I\'ll show you my sword skills.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120566,'','Don\'t test my patience.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120567,'','Magical accidents happen all the time...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120568,'The undead would be much less of a hassle, if only they were more mortal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120569,'My plants are coming in nicely this year. The key is clippings from a much more primordial strain of the lotus, the alpha if you will. Quite a prized possession, that.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120570,'My favorite Hearthstone card? It\'s got to be lightning bolt!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120571,'I am Valarjar!','',0,0,0,0,0,0,0,0,0,0,69620,0,26124),
(120572,'Glory to Odyn!','',0,0,0,0,0,0,0,0,0,0,69621,0,26124),
(120573,'Hail, champion.','',0,0,0,0,0,0,0,0,0,0,69622,0,26124),
(120574,'Until the next battle.','',0,0,0,0,0,0,0,0,0,0,69623,0,26124),
(120575,'May your battles end in victory.','',0,0,0,0,0,0,0,0,0,0,69624,0,26124),
(120576,'Death to your enemies!','',0,0,0,0,0,0,0,0,0,0,69625,0,26124),
(120577,'What is it?!','',0,0,0,0,0,0,0,0,0,0,69626,0,26124),
(120578,'We will not fight... today.','',0,0,0,0,0,0,0,0,0,0,69627,0,26124),
(120579,'What do you want?','',0,0,0,0,0,0,0,0,0,0,69628,0,26124),
(120580,'Off with you!','',0,0,0,0,0,0,0,0,0,0,69629,0,26124),
(120581,'Farewell.','',0,0,0,0,0,0,0,0,0,0,69630,0,26124),
(120582,'Hmmph.','',0,0,0,0,0,0,0,0,0,0,69631,0,26124),
(120583,'','My shield is strong.',0,0,0,0,0,0,0,0,0,0,0,69608,26124),
(120584,'','Do not tempt my spear!',0,0,0,0,0,0,0,0,0,0,0,69609,26124),
(120585,'','What is it?',0,0,0,0,0,0,0,0,0,0,0,69610,26124),
(120586,'','You shall live... this time.',0,0,0,0,0,0,0,0,0,0,0,69611,26124),
(120587,'','Be on your way, then.',0,0,0,0,0,0,0,0,0,0,0,69612,26124),
(120588,'','See you in battle.',0,0,0,0,0,0,0,0,0,0,0,69613,26124),
(120589,'','My shield is strong.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120590,'','Death cannot stop me.',0,0,0,0,0,0,0,0,0,0,0,69614,26124),
(120591,'','I serve a greater power.',0,0,0,0,0,0,0,0,0,0,0,69615,26124),
(120592,'','I dwell in the Shadowlands.',0,0,0,0,0,0,0,0,0,0,0,69616,26124),
(120593,'','We will meet again soon.',0,0,0,0,0,0,0,0,0,0,0,69617,26124),
(120594,'','Die well.',0,0,0,0,0,0,0,0,0,0,0,69618,26124),
(120595,'','One day I may come for you.',0,0,0,0,0,0,0,0,0,0,0,69619,26124),
(120596,'You asked me if I foresaw this day, child.','',0,0,0,0,0,0,0,0,0,0,70868,0,26124),
(120597,'I... I did... And until this moment I did not understand.','',0,0,0,0,0,0,0,0,0,0,70867,0,26124),
(120598,'In a time that is now just a whisper of a memory, I had a son. On the day of his birth, a vision came to me.','',0,0,0,0,0,0,0,0,0,0,70866,0,26124),
(120599,'In that vision I saw myself weeping as I held a dying eredar in my arms. His skin fel-pocked and battle-scarred.','',0,0,0,0,0,0,0,0,0,0,70865,0,26124),
(120600,'Like yours...','',0,0,0,0,0,0,0,0,0,0,70864,0,26124),
(120601,'But I buried that vision after Kil\'jaeden took my family from me, and for eons let it be lost in the darkest recesses of my being.','',0,0,0,0,0,0,0,0,0,0,70863,0,26124),
(120602,'Now, finally, as I hold you in my arms, I understand.','',0,0,0,0,0,0,0,0,0,0,70862,0,26124),
(120603,'The Legion has taken everything from me. From us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120604,'I have given you all that I am, and have asked for nothing! Grant me this mercy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120605,'UNUSED DO NOT LOCALIZE','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120606,'We did not ask for this burden, Prophet. It is what fate has deemed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120607,'','Tell me you are not seriously considering sending our friend on such a mission. That is suicide.',0,0,0,0,0,0,0,0,0,0,0,70986,26124),
(120608,'','I have seen first hand what Arcan\'dor\'s energies do for the Withered. I have faith that it is worth the risk.',0,0,0,0,0,0,0,0,0,0,0,70987,26124),
(120609,'','Hmph. We will have to see, then.',0,0,0,0,0,0,0,0,0,0,0,70985,26124),
(120610,'Did Romuul survive?','',0,0,0,0,0,0,0,0,0,0,70873,0,26124),
(120612,'What\'s wrong with the prophet?','What\'s wrong with the prophet?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120613,'','I do relish a good fight.',0,0,0,0,0,0,11,0,0,0,0,69641,26124),
(120614,'My life for the Silver Hand, Highlord.','',0,0,0,0,0,0,66,0,0,0,70172,0,26124),
(120615,'','Fearless is my charge, Highlord! For the Order!',0,0,0,0,0,0,66,0,0,0,0,69642,26124),
(120616,'','The Light will guide my hand, Highlord.',0,0,0,0,0,0,2,0,0,0,0,69655,26124),
(120617,'','I will not let you down, Highlord.',0,0,0,0,0,0,66,0,0,0,0,69643,26124),
(120618,'My parents would be proud of all that we have achieved. I will fight on for them, Highlord.','',0,0,0,0,0,0,2,0,0,0,69644,0,26124),
(120619,'The Light is everywhere. I welcome it, whether in glory or death.','',0,0,0,0,0,0,396,0,0,0,69645,0,26124),
(120620,'','It is my honor to join you, Grandmaster. My master would be proud.',0,0,0,0,0,0,396,0,0,0,0,69651,26124),
(120621,'','I got a good sense about you, druid. Your spirit burns bright. You won\'t lead us wrong.',0,0,0,0,0,0,396,0,0,0,0,69653,26124),
(120622,'So much to do... so little time!','',0,0,0,0,0,0,0,0,0,0,69654,0,26124),
(120623,'We must make haste to the Violet Hold. I will explain along the way.','',0,0,0,0,0,0,1,0,0,0,69704,0,26124),
(120624,'In ages past, the Forge of the Guardian was a source of great power for the Council of Tirisfal.','',0,0,0,0,0,0,1,0,0,0,69705,0,26124),
(120625,'When the Legion learned of the forge\'s existence, the Council knew it had to be hidden somewhere safe.','',0,0,0,0,0,0,1,0,0,0,69706,0,26124),
(120626,'It was secreted to the Violet Hold. Not only was this the most secure location in Dalaran, it was a place few would think to look.','',0,0,0,0,0,0,1,0,0,0,69707,0,26124),
(120627,'Who is that oddly handsome fellow?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120628,'Have we met before?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120629,'I say, you do look rather familiar...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120630,'I don\'t believe so, I would have remembered such a well-dressed, young and spry mage.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120631,'Now that Kathra\'natir knows its location, I fear the worst.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120632,'It seems my fears were well-founded! The dreadlord is already inside. We must hurry!','',0,0,0,0,0,0,603,0,0,0,69708,0,26124),
(120633,'Hrydshal has taken prisoners during a recent raid on Highmountain. I would ask that you free them for me. I owe a great debt to the ancestors of those who were taken and would see that debt paid.','',0,0,0,0,0,0,0,0,0,0,69773,0,26124),
(120634,'','Masked thugs have been harassing my supporters. I know those beasts of House Stelleris are behind it!',0,0,0,0,0,0,0,0,0,0,0,70522,26124),
(120635,'','<Sigh.> Politics as usual. Perhaps after we have liberated Suramar, my opponents will realize they were on the wrong side of history.',0,0,0,0,0,0,0,0,0,0,0,70523,26124),
(120636,'It was with the aid of the tauren that my flesh was made wood, my skin made into leaves, and my wisdom made eternal. I shall always remember this, even if my own people do not.','',0,0,0,0,0,0,0,0,0,0,69776,0,26124),
(120637,'Nothing like some kafa to get you started in the morning, or an icy Highmountain Refresher after a long day on the battlefield. I like Spiced Tea as a nightcap, myself. Have you tried the honey croissants? Deee-licious!$B$BAt least that\'s what I say. But you know... I\'m not really here for the coffee.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120638,'Hope you heroes brought enough ammunition!','',0,0,0,0,0,0,22,0,0,0,69664,0,26124),
(120639,'Here they come! Time to prove your worth!','',0,0,0,0,0,0,22,0,0,0,69665,0,26124),
(120640,'I don\'t like the sound of that! Stand tall... even if you\'re short!','',0,0,0,0,0,0,22,0,0,0,69668,0,26124),
(120641,'This bunch looks... bigger. But that\'s no excuse to slack off!','',0,0,0,0,0,0,22,0,0,0,69669,0,26124),
(120642,'They\'re pouring it on! Show them we\'re no slouches!','',0,0,0,0,0,0,22,0,0,0,69670,0,26124),
(120643,'Is it just me, or are they getting angrier and... redder?','',0,0,0,0,0,0,22,0,0,0,69672,0,26124),
(120644,'Bring this one down quick! He\'s wreaking havoc on property values!','',0,0,0,0,0,0,22,0,0,0,69673,0,26124),
(120645,'','Have you come to a decision yet, $ct?$b$bI would give you guidance, but in this, you must look within.',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(120646,'Show them there\'s only room for one boss in Azshara... me!','',0,0,0,0,0,0,22,0,0,0,69675,0,26124),
(120647,'This demon\'s trying to muscle in on MY territory. Put a stop to it!','',0,0,0,0,0,0,22,0,0,0,69676,0,26124),
(120648,'They\'re spreading out! Unpaid overtime is hereby authorized... find them!','',0,0,0,0,0,0,22,0,0,0,69677,0,26124),
(120649,'These demons are making themselves at home... in MY home! Spread out and stop them!','',0,0,0,0,0,0,22,0,0,0,69678,0,26124),
(120650,'They\'re expanding operations! Hey, I\'m the only one who\'s supposed to do that!','',0,0,0,0,0,0,22,0,0,0,69679,0,26124),
(120651,'There\'s more work to be done! Don\'t let me catch you napping!','',0,0,0,0,0,0,22,0,0,0,69680,0,26124),
(120652,'Don\'t let up now! You\'ve got an obligation to defend my assets!','',0,0,0,0,0,0,22,0,0,0,69681,0,26124),
(120653,'I want these demons cleared out by suppertime. I can\'t afford to miss a meal!','',0,0,0,0,0,0,22,0,0,0,69682,0,26124),
(120654,'Yeesh! Ugliest demon so far! Fight in the name of your handsome trade prince!','',0,0,0,0,0,0,22,0,0,0,69693,0,26124),
(120655,'This one wants to be the big boss! Sorry, bub, the position\'s been filled... BY ME!','',0,0,0,0,0,0,22,0,0,0,69694,0,26124),
(120656,'Take the leader down! Bring me its head... and its coin purse. The latter being my preference!','',0,0,0,0,0,0,22,0,0,0,69695,0,26124),
(120657,'You saved the day! Nice work! I\'ll be sending you a small bill for the damages, though.','',0,0,0,0,0,0,22,0,0,0,69696,0,26124),
(120658,'Way to go! You\'ve made your trade prince very proud. Just wipe your boots before coming near my palace!','',0,0,0,0,0,0,22,0,0,0,69697,0,26124),
(120659,'Well done! Your combat skills are impressive, as advertised. And this trade prince knows how to advertise!','',0,0,0,0,0,0,22,0,0,0,69698,0,26124),
(120660,'Infusing...','Infusing...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120661,'Thorim, what is the source of your power?','Thorim, what is the source of your power?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120662,'Dreyrgrot is infested with pirate... vampires... pira-vamp... vampirates? GRAH! Just go slay them. The fools are plundering relics we buried for a reason. Such cursed artifacts were never meant to be unearthed.','',0,0,0,0,0,0,0,0,0,0,69760,0,26124),
(120663,'Those artifacts would have caused grave harm in the hands of those greedy fiends. You did well to retrieve them.','',0,0,0,0,0,0,0,0,0,0,69761,0,26124),
(120664,'','Why hello, a visitor! Thank you for coming by to see me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120665,'','Have I told you about my grandchildren, Alexis, Kelsey, and Cara? Such bright girls!$B$BI haven\'t seen them since before... <Peggy pauses, then smiles peacefully.>$B$BWell, I miss them and hope they are doing well.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120666,'','Are you ready to begin the juicing demonstration?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120667,'Use |TInterface\\Icons\\spell_arcane_blink.blp:20|t |cFFFF0000|Hspell:111771|h[Blink]|h|r to bypass the Void Barrier.','Use |TInterface\\Icons\\spell_warlock_demonicportal_green.blp:20|t |cFFFF0000|Hspell:111771|h[Demonic Portal]|h|r to get past Ariden\'s barrier!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120668,'Another Jarl has fallen in glorious battle! Today we shall honor his passing. Go forth, champion, and join in the revelry! Just... try not to let it kill you in the process.','',0,0,0,0,0,0,0,0,0,0,69779,0,26124),
(120669,'Now THAT is how you honor a fallen warrior! But I think you\'ve had enough revelry for one day.','',0,0,0,0,0,0,0,0,0,0,69780,0,26124),
(120671,'By order of the Grand Magistrix, you are hereby charged with sedition. You undermine my authority and must pay the price.','',0,0,0,0,0,0,0,0,6,0,69832,0,26124),
(120672,'Please, be careful of that staff...','Please, be careful of that staff...',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(120673,'I will try to follow your ways.','I will try to follow your ways.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(120674,'Light\'s Wrath, I thought it lost...','Light\'s Wrath, I thought it lost...',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(120675,'With that, you might save us all.','With that, you might save us all.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(120676,'You are a great example to follow.','You are a great example to follow.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(120677,'Grrgl mrg!','',0,0,0,0,0,0,0,179,0,0,0,0,26124),
(120678,'When you are ready, I will send you into the Rift of Aln to face Xavius.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120679,'Send me to the Rift of Aln!','Send me to the Rift of Aln!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120680,'Ulduar\'s under attack. Send me and any forces that are ready to their aid!','Ulduar\'s under attack. Send me and any forces that are ready to their aid!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120681,'Thorim doesn\'t have much time. Speak to Aerilya at once to go to Ulduar\'s aid!','',0,0,0,0,0,0,0,0,0,0,69794,0,26124),
(120682,'','Cyrille places a Dusk Lily atop Overseer Durant\'s corpse.',0,0,0,0,0,0,0,0,0,40285,0,0,26124),
(120683,'Search for the budding trees, but watch out for the hungry fish!','',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(120684,'We did not ask for this burden, Prophet, but it is what fate has deemed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120685,'Your child was made a force of darkness by the Deceiver. He lived and died ignorant of the truth - of any truth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120686,'Let not the sacrifices we have made here today be in vain. Listen well as soon the darkness will take me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120687,'Light\'s Heart is a second chance at a destiny unfulfilled.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120688,'You must find Mother Moon\'s blessed child. Your journey begins with his.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120689,'Light\'s Heart will guide you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120690,'There is nothing left here for you, $p.','',0,0,0,0,0,0,0,0,0,0,70871,0,26124),
(120691,'Take Light\'s Heart and return to Khadgar. Tell him... Tell him that the Light died here this day.','',0,0,0,0,0,0,0,0,0,0,70870,0,26124),
(120692,'I am neither prophet nor pawn. Not any longer.','',0,0,0,0,0,0,0,0,0,0,70874,0,26124),
(120693,'Farewell.','',0,0,0,0,0,0,0,0,0,0,70869,0,26124),
(120694,'','The murlocs of Shipwreck Cove have been spotted worshipping a Sea Giant named Flotsam. Put an end to this creature.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120695,'','Flotsam should\'ve stayed hidden within the sea. Thank you champion, my people are safer because of you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120696,'Check out my quality merchandise.','',0,0,0,0,0,0,0,0,0,0,69867,0,26124),
(120697,'I got what you\'re lookin for.','',0,0,0,0,0,0,0,0,0,0,69866,0,26124),
(120698,'Of course it\'s authentic!','',0,0,0,0,0,0,0,0,0,0,69865,0,26124),
(120699,'Hey, no refunds, got it?','',0,0,0,0,0,0,0,0,0,0,69864,0,26124),
(120700,'Pleasure doin business with ya.','',0,0,0,0,0,0,0,0,0,0,69863,0,26124),
(120701,'You got the gold, I got the goods.','',0,0,0,0,0,0,0,0,0,0,69862,0,26124),
(120702,'Just don\'t ask where these came from.','',0,0,0,0,0,0,0,0,0,0,69861,0,26124),
(120703,'You here shopping, or shoplifting?','',0,0,0,0,0,0,0,0,0,0,69860,0,26124),
(120704,'Don\'t worry, these ain\'t stolen. They just haven\'t been paid for yet.','',0,0,0,0,0,0,0,0,0,0,69859,0,26124),
(120705,'Check out this one - hand made in Kezan, hand stolen in Gadgetzan!','',0,0,0,0,0,0,0,0,0,0,69858,0,26124),
(120706,'Too late, too late will be the cry when Sixtrigger\'s bargains pass you by!','',0,0,0,0,0,0,0,0,0,0,69857,0,26124),
(120707,'You again? Snaggle, take them out!','',0,0,0,0,0,0,0,0,0,0,69856,0,26124),
(120708,'System overload? What does that mean? Waaaaaagh!','',0,0,0,0,0,0,0,0,0,0,69855,0,26124),
(120709,'Bury me with... my money...','',0,0,0,0,0,0,0,0,0,0,69854,0,26124),
(120710,'What?','',0,0,0,0,0,0,0,0,0,0,69853,0,26124),
(120711,'Got a head needs crackin?','',0,0,0,0,0,0,0,0,0,0,69852,0,26124),
(120712,'Keep talkin, pal.','',0,0,0,0,0,0,0,0,0,0,69851,0,26124),
(120713,'Whatever.','',0,0,0,0,0,0,0,0,0,0,69850,0,26124),
(120714,'I\'ll get the job done.','',0,0,0,0,0,0,0,0,0,0,69849,0,26124),
(120715,'Watch your back.','',0,0,0,0,0,0,0,0,0,0,69848,0,26124),
(120716,'Shouldn\'t you be killing boars or somethin?','',0,0,0,0,0,0,0,0,0,0,69847,0,26124),
(120717,'I thought I got rid of you already.','',0,0,0,0,0,0,0,0,0,0,69846,0,26124),
(120718,'I heard there\'s a dragon on the top of that mountain. He may look big, but I\'m sure he\'s easy pickings.','',0,0,0,0,0,0,0,0,0,0,69845,0,26124),
(120719,'How bout some target practice? I\'ll count to ten - you run.','',0,0,0,0,0,0,0,0,0,0,69844,0,26124),
(120720,'Time for you to eat lead!','',0,0,0,0,0,0,0,0,0,0,69843,0,26124),
(120721,'No fair! You cheated...','',0,0,0,0,0,0,0,0,0,0,69842,0,26124),
(120722,'','I\'m here to usher the worthy to Skyhold!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120723,'Ah, the savior of Magnar. This should be easy for you!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120724,'I trust those swords are useful? The kvaldir may want them back before the day is done.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120725,'Introducing our next combatant!  This $R $C has finished $12383W seasons as a rank one Gladiator!  Get ready to fight, $n!','Introducing our next combatant!  This $R $C has finished $12383W seasons as a rank one Gladiator!  Get ready to fight, $n!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(120726,'There is an exposed leyline in Azuregale Bay causing all kinds of interference on the network. Set up some surveying equipment so I can monitor its chaotic energies and work around them!','',0,0,0,0,0,0,0,0,0,0,70914,0,26124),
(120727,'Now I simply look for patterns in the chaos and weave our telemancy spells around them. I love my job!','',0,0,0,0,0,0,0,0,0,0,70915,0,26124),
(120728,'Plucking...','Plucking...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120729,'','I am ready to shed this hunger and lead my people to salvation.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120730,'','I will have what Oculeth is having.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120731,'I will be the first to taste this experiment of ours. Let any ill effects fall to me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120732,'<Offer Fruit of the Arcan\'dor.>','<Offer Fruit of the Arcan\'dor.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120733,'Those swords, I\'d recognize Odyn\'s work anywhere. Aid me, warrior!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120734,'','Exiled Nightborne are being held captive by the Legion. Set them free before they meet a terrible fate!',0,0,0,0,0,0,0,0,0,0,0,70918,26124),
(120735,'','I am not sure which is worse - to wither, or be turned into fuel for the Legion\'s war machines. Thank you for saving them.',0,0,0,0,0,0,0,0,0,0,0,70919,26124),
(120736,'Bah! You believe yourself worthy of ME?! I have larger muscles than you do.','Bah! You believe yourself worthy of ME?! I have larger muscles than you do.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120737,'Are you flirting with me? Or is there something wrong with your face.','Are you flirting with me? Or is there something wrong with your face.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120738,'Why does your face make that look? Remove it! It offends me.','Why does your face make that look? Remove it! It offends me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120739,'Do not waste my time. Your features are too... soft.','Do not waste my time. Your features are too... soft.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120740,'Do not make me slap that look right off your face.','Do not make me slap that look right off your face.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120741,'Bah! You believe yourself worthy of ME?! Perhaps later you can prove that.','Bah! You believe yourself worthy of ME?! Perhaps later you can prove that.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120742,'Well... you do have soft features...','Well... you do have soft features...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120743,'Warchief! The $c you called for has arrived. We only await Sylvanas now.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(120744,'Hmm. Well, you never know until you try...','Hmm. Well, you never know until you try...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120745,'Ah, $n, it\'s... good ya came. Time be... runnin\' short.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120746,'You must have a deathwish. I admire that.','You must have a deathwish. I admire that.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120747,'Let me call in my healers, Warchief. Your wound must be tended!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(120748,'Too late for dat, Bloodhoof. Me got one... final duty. Ta see dat da Horde... stays strong.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120749,'Why not? I enjoy breaking small things.','Why not? I enjoy breaking small things.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120750,'The Alliance lost its king on the Broken Shore. Its people cry out for vengeance.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(120751,'Dat\'s good. Azeroth... gonna fall... \'less we seal up dat tomb.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120752,'My contact in the Kirin Tor tells me certain members of the Council of Six are open to inviting the Horde back into Dalaran.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(120753,'We WILL find a way to drive back the Legion, Warchief. This we swear!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(120754,'The Banshee Queen is here, Vol\'jin. What is it you wanted to tell us?','',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(120755,'','What are you doing? What is wrong with your body?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120756,'','Why do you move so strangely?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120757,'','Bah! You can dance if you want to. But you leave your friends behind...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120758,'','I have not had enough revelry to tolerate what you are doing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120759,'','Stop that! It is silly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120760,'','We Nightborne owe our unmatched grace and intellect to a noble heritage. The ancestors at rest in Tel\'Anor deserve proper tribute.',0,0,0,0,0,0,0,0,0,0,0,70916,26124),
(120761,'','Ahh, you\'ve arrived! And just in time for rune-drawing class.$b$bRemind me again, which rune were you working on?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120762,'','Yes, of course, that\'s right. And at which level?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120763,'','Very well, here is the outline of your rune. Best of luck!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120764,'Arcane.','Arcane.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120765,'Fire.','Fire.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120766,'Frost.','Frost.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120767,'Freshman.','Freshman.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120768,'Sophomore.','Sophomore.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120769,'Junior.','Junior.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120770,'Senior.','Senior.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120771,'Oh, hello, welcome to Dalaran. I tend to the lamps.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120772,'Windle, why doesn\'t my wand work on the lamp posts anymore?','Windle, why doesn\'t my wand work on the lamp posts anymore?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120773,'Oh, yes, terribly sorry about that. I like to light the lamp posts myself, you see. It helps me.\n\nLet\'s leave it at that, please.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120774,'Don\'t you find these books fascinating? I love reading about the different creatures that inhabit our world.$b$bHop into a book with me. What would you like to read about?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120775,'Ahh.. the kobolds. An excellent choice! One of my favorites.$b$bWhich book in particular intrigues you the most?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120776,'Ahh yes, the skrogs. Fascinating brutes, aren\'t they?$b$bWhich book in particular intrigues you the most?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120777,'Of course. Who wouldn\'t be enraptured by such powerful magical creatures?$b$bWhich book in particular intrigues you the most?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120778,'Kobolds.','Kobolds.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120779,'Sea Skrogs.','Sea Skrogs.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120780,'The blue dragonflight.','The blue dragonflight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120781,'Kobold Country','Kobold Country',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120782,'A Guide to Kobold Societal Mores (Recommended: 3 Players)','A Guide to Kobold Societal Mores (Recommended: 3 Players)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120783,'Before the Candle: The Rise and Fall of the Great Kobold Empire (Recommended: 10 Players)','Before the Candle: The Rise and Fall of the Great Kobold Empire (Recommended: 10 Players)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120784,'Skroggal Anatomy','Skroggal Anatomy',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120785,'Unabridged Glossary of Skrog Weaponry (Recommended: 3 Players)','Unabridged Glossary of Skrog Weaponry (Recommended: 3 Players)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120786,'Children of Golganneth: Great Skrogs in History (Recommended: 10 Players)','Children of Golganneth: Great Skrogs in History (Recommended: 10 Players)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120787,'Draconic Compendium, Volume IV','Draconic Compendium, Volume IV',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120788,'I\'ve Got the Blues: Selected Stories from Azurewing Repose (Recommended: 3 Players)','I\'ve Got the Blues: Selected Stories from Azurewing Repose (Recommended: 3 Players)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120789,'Ancient Blue Dragons of Azeroth (Recommended: 10 Players)','Ancient Blue Dragons of Azeroth (Recommended: 10 Players)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120790,'','Welcome to Nar\'thalas Academy. Please, make yourself comfortable. All are welcome here, provided they are willing to learn.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120791,'','Plenty. You are welcome to peruse our stacks, practice combat against any of our training dummies, or simply spend time socializing with your classmates. You may even bring some friends, if you like. This is a safe place.$b$bIn addition, Instructor Nidriel is offering classes on rune drawing, and our research assistant Sythorne is working on a study involving creature combat. I\'m certain either one would be happy to work with you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120792,'','Not now. Spend a little bit more time interacting with the other instructors, and I might consider it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120793,'','A duel? If you insist. I suppose a bit of combat never hurt anyone. Actually, that\'s probably not accurate.\nReady when you are!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120794,'','I yield. Besting your headmistress is no small feat. Congratulations.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120795,'','That was enjoyable. Thank you for the chance to dust off my wand. Back to your studies, everyone!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120796,'What can I do here?','What can I do here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120797,'Interested in a duel?','Interested in a duel?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120798,'Interested in a duel? (Recommended: 10 Players)','Interested in a duel? (Recommended: 10 Players)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120799,'You are tiny.','Odyn shines upon you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120800,'Why do you speak at me, little $c?','Your cloths, they are funny to me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120801,'Have you come to drink or fight? Or both?','Have you come to drink or fight? Or both?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120802,'You have tiny hands.','You have tiny hands.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120803,'Watchout! It\'s comin\' down! Move out of the way!','Watchout! It\'s comin\' down! Move out of the way!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(120804,'Another Jarl drinks now with Odyn. Between you and me, I never liked that Jarl.','The Jarl goes now to serve Odyn in the Valarjar. Let us drink to their good fortune.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120805,'To be honest, I am going to miss that Jarl. They had some great feasts in their day.','The Jarl will be missed by some. Not me, but by some.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120808,'','Is Arluin coming? I haven\'t seen him in days...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120809,'Arluin is not coming, I\'m afraid. He died to ensure we could bring this to you. <Offer Arcan\'dor Fruit.>','Arluin is not coming, I\'m afraid. He died to ensure we could bring this to you. <Offer Arcan\'dor Fruit.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120810,'Come at me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120811,'Tummy too rumbly...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120812,'Why I eat so many murlocs?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120813,'Oooh shiny!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120814,'That one mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120815,'Ew... too stinky.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120816,'Yuck... too hairy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120817,'Pfff... too ugly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120818,'','We should return, High Priest. Our allies need to hear this.',0,0,0,0,0,0,396,0,0,0,0,69968,26124),
(120819,'It is good to see those blades out of kvaldir hands.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120820,'So the legend is true, the Scale is real...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(120821,'Hey bub!$b$bThree words: Upgrades! Upgrades! Upgrades! I may only be a journeyman, but I know a trick or two to get the most out of your crew. I\'ll make your fire sizzle, your water drizzle, your earths quake and your winds break!','',5,1,0,0,0,0,0,0,0,0,0,0,26124),
(120822,'The end is coming! Again!','The end is coming! Again!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(120823,'Our time ends, the cleansing is nigh!','Our time ends, the cleansing is nigh!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(120824,'The world will be shaped anew!','The world will be shaped anew!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(120825,'The Light has forsaken us!','The Light has forsaken us!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(120826,'Forces beyond our comprehension have seen us unworthy!','Forces beyond our comprehension have seen us unworthy!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(120827,'A searing emerald fire will burn away our corruption!','A searing emerald fire will burn away our corruption!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(120828,'There is no escape from the inevitable!','There is no escape from the inevitable!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(120829,'Our leaders cannot protect us!','Our leaders cannot protect us!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(120830,'I may only be a journeyman, but I know a trick or two to get the most out of your crew. I\'ll make your fire sizzle, your water drizzle, your earths quake and your winds break!','',5,1,0,0,0,0,5,0,0,0,0,0,26124),
(120831,'','Think of this as... repayment for your previous insult, valarjar!',0,0,0,0,0,0,0,0,0,0,0,70180,26124),
(120832,'D\'ye seek to summon Elementals?','D\'ye seek to summon Elementals?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(120833,'','This isn\'t over, mortal! I will see my blades returned, and your soul suffer in my grasp!',0,0,0,0,0,0,0,0,0,0,0,70181,26124),
(120834,'<Raise mug>','<Raise mug>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120835,'<Insult>','<Insult>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120836,'Keep your wits about you, $n. If we noticed the object shooting out from the Felstorm, so too did the Legion.','',0,0,0,0,0,0,0,0,0,0,70810,0,26124),
(120837,'I\'d like to purchase Seals of Broken Fate.','I\'d like to purchase Seals of Broken Fate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120838,'Looking for a Seal of Broken Fate?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(120839,'What is it?','',0,0,0,0,0,0,0,0,0,0,69986,0,26124),
(120840,'What do you need?','',0,0,0,0,0,0,0,0,0,0,69998,0,26124),
(120841,'I greet you.','',0,0,0,0,0,0,0,0,0,0,69987,0,26124),
(120842,'I obey.','',0,0,0,0,0,0,0,0,0,0,69988,0,26124),
(120843,'I am the mountain.','',0,0,0,0,0,0,0,0,0,0,69989,0,26124),
(120844,'As you command.','',0,0,0,0,0,0,0,0,0,0,69990,0,26124),
(120845,'I am ready.','',0,0,0,0,0,0,0,0,0,0,69991,0,26124),
(120846,'I await your command.','',0,0,0,0,0,0,0,0,0,0,69992,0,26124),
(120847,'You confuse me...','',0,0,0,0,0,0,0,0,0,0,69993,0,26124),
(120848,'What are you doing?','',0,0,0,0,0,0,0,0,0,0,69994,0,26124),
(120849,'You\'re making me angry!','',0,0,0,0,0,0,0,0,0,0,69995,0,26124),
(120850,'I will crush your bones!','',0,0,0,0,0,0,0,0,0,0,69996,0,26124),
(120851,'RARRGHH!!','',0,0,0,0,0,0,0,0,0,0,69997,0,26124),
(120852,'The wind has whispered your name.','',0,0,0,0,0,0,0,0,0,0,69999,0,26124),
(120853,'How may I assist you?','',0,0,0,0,0,0,0,0,0,0,70000,0,26124),
(120854,'I am at your service.','',0,0,0,0,0,0,0,0,0,0,70001,0,26124),
(120855,'Let the winds guide you.','',0,0,0,0,0,0,0,0,0,0,70002,0,26124),
(120856,'Where there is wind, so am I.','',0,0,0,0,0,0,0,0,0,0,70003,0,26124),
(120857,'The heavens await your command.','',0,0,0,0,0,0,0,0,0,0,70004,0,26124),
(120858,'How may I aid you?','',0,0,0,0,0,0,0,0,0,0,70005,0,26124),
(120859,'I am yours to command.','',0,0,0,0,0,0,0,0,0,0,70006,0,26124),
(120860,'I do not understand.','',0,0,0,0,0,0,0,0,0,0,70007,0,26124),
(120861,'I am confused.','',0,0,0,0,0,0,0,0,0,0,70008,0,26124),
(120862,'This is not amusing.','',0,0,0,0,0,0,0,0,0,0,70009,0,26124),
(120863,'We have work to do.','',0,0,0,0,0,0,0,0,0,0,70010,0,26124),
(120864,'I must protest this behavior!','',0,0,0,0,0,0,0,0,0,0,70011,0,26124),
(120865,'This is most uncivilized!','',0,0,0,0,0,0,0,0,0,0,70012,0,26124),
(120866,'I am at your call.','',0,0,0,0,0,0,0,0,0,0,70013,0,26124),
(120867,'I am ready.','',0,0,0,0,0,0,0,0,0,0,70014,0,26124),
(120868,'I live to serve.','',0,0,0,0,0,0,0,0,0,0,70015,0,26124),
(120869,'Our fate is in your hands.','',0,0,0,0,0,0,0,0,0,0,70016,0,26124),
(120870,'Fight with honor.','',0,0,0,0,0,0,0,0,0,0,70017,0,26124),
(120871,'As you wish.','',0,0,0,0,0,0,0,0,0,0,70018,0,26124),
(120872,'The battlefield awaits.','',0,0,0,0,0,0,0,0,0,0,70019,0,26124),
(120873,'What are your orders?','',0,0,0,0,0,0,0,0,0,0,70020,0,26124),
(120874,'We have little time.','',0,0,0,0,0,0,0,0,0,0,70021,0,26124),
(120875,'What is the point of this?','',0,0,0,0,0,0,0,0,0,0,70022,0,26124),
(120876,'You are wasting time!','',0,0,0,0,0,0,0,0,0,0,70023,0,26124),
(120877,'My patience wears thin...','',0,0,0,0,0,0,0,0,0,0,70024,0,26124),
(120878,'I am not amused!','',0,0,0,0,0,0,0,0,0,0,70025,0,26124),
(120879,'Speak.','',0,0,0,0,0,0,0,0,0,0,70026,0,26124),
(120880,'How may I aid you?','',0,0,0,0,0,0,0,0,0,0,70027,0,26124),
(120881,'You have my attention.','',0,0,0,0,0,0,0,0,0,0,70028,0,26124),
(120882,'The elements shall guide you.','',0,0,0,0,0,0,0,0,0,0,70029,0,26124),
(120883,'Go with peace.','',0,0,0,0,0,0,0,0,0,0,70030,0,26124),
(120884,'Earth and water.','',0,0,0,0,0,0,0,0,0,0,70031,0,26124),
(120885,'Yes?','',0,0,0,0,0,0,0,0,0,0,70032,0,26124),
(120886,'What is it?','',0,0,0,0,0,0,0,0,0,0,70033,0,26124),
(120887,'I shall serve with honor.','',0,0,0,0,0,0,0,0,0,0,70034,0,26124),
(120888,'I am one with the elements.','',0,0,0,0,0,0,0,0,0,0,70035,0,26124),
(120889,'I have little time for this.','',0,0,0,0,0,0,0,0,0,0,70036,0,26124),
(120890,'We have work to do.','',0,0,0,0,0,0,0,0,0,0,70037,0,26124),
(120891,'Mess with a bull and you\'ll get the horns!','',0,0,0,0,0,0,0,0,0,0,70038,0,26124),
(120892,'I burn with anticipation.','',0,0,0,0,0,0,0,0,0,0,70039,0,26124),
(120893,'How may I serve?','',0,0,0,0,0,0,0,0,0,0,70040,0,26124),
(120894,'I am the avatar of flame.','',0,0,0,0,0,0,0,0,0,0,70041,0,26124),
(120895,'May your fire burn hot.','',0,0,0,0,0,0,0,0,0,0,70042,0,26124),
(120896,'Our enemies will become ash.','',0,0,0,0,0,0,0,0,0,0,70043,0,26124),
(120897,'Everything burns...','',0,0,0,0,0,0,0,0,0,0,70044,0,26124),
(120898,'Yes?','',0,0,0,0,0,0,0,0,0,0,70045,0,26124),
(120899,'What is it?','',0,0,0,0,0,0,0,0,0,0,70046,0,26124),
(120900,'I have only one burning desire...','',0,0,0,0,0,0,0,0,0,0,70047,0,26124),
(120901,'It\'s getting hot in here...','',0,0,0,0,0,0,0,0,0,0,70048,0,26124),
(120902,'How may I serve you? Charred or well-done?','',0,0,0,0,0,0,0,0,0,0,70049,0,26124),
(120903,'Be quick!','',0,0,0,0,0,0,0,0,0,0,70050,0,26124),
(120904,'I am fury incarnate!','',0,0,0,0,0,0,0,0,0,0,70051,0,26124),
(120905,'Out with it!','',0,0,0,0,0,0,0,0,0,0,70052,0,26124),
(120906,'Go!','',0,0,0,0,0,0,0,0,0,0,70053,0,26124),
(120907,'I reign supreme.','',0,0,0,0,0,0,0,0,0,0,70054,0,26124),
(120908,'Do not fail.','',0,0,0,0,0,0,0,0,0,0,70055,0,26124),
(120909,'What?!','',0,0,0,0,0,0,0,0,0,0,70056,0,26124),
(120910,'I am waiting.','',0,0,0,0,0,0,0,0,0,0,70057,0,26124),
(120911,'You will obey.','',0,0,0,0,0,0,0,0,0,0,70058,0,26124),
(120912,'All shall burn.','',0,0,0,0,0,0,0,0,0,0,70059,0,26124),
(120913,'Speak quickly!','',0,0,0,0,0,0,0,0,0,0,70060,0,26124),
(120914,'I have had enough of you!','',0,0,0,0,0,0,0,0,0,0,70061,0,26124),
(120915,'Begone!','',0,0,0,0,0,0,0,0,0,0,70062,0,26124),
(120916,'I will burn your soul!','',0,0,0,0,0,0,0,0,0,0,70063,0,26124),
(120917,'','I am listening.',0,0,0,0,0,0,0,0,0,0,0,70064,26124),
(120918,'','Speak and I will listen.',0,0,0,0,0,0,0,0,0,0,0,70065,26124),
(120919,'','Go with courage, mortal.',0,0,0,0,0,0,0,0,0,0,0,70066,26124),
(120920,'','Until we meet again.',0,0,0,0,0,0,0,0,0,0,0,70067,26124),
(120921,'','The earth is your shield.',0,0,0,0,0,0,0,0,0,0,0,70068,26124),
(120922,'','You have my attention.',0,0,0,0,0,0,0,0,0,0,0,70069,26124),
(120923,'','How may the Stonemother aid you?',0,0,0,0,0,0,0,0,0,0,0,70070,26124),
(120924,'','I am waiting.',0,0,0,0,0,0,0,0,0,0,0,70071,26124),
(120925,'','What is your purpose, mortal?',0,0,0,0,0,0,0,0,0,0,0,70072,26124),
(120926,'','I grow tired of you.',0,0,0,0,0,0,0,0,0,0,0,70073,26124),
(120927,'','I will bury you!',0,0,0,0,0,0,0,0,0,0,0,70074,26124),
(120928,'You stand in the presence of greatness.','',0,0,0,0,0,0,0,0,0,0,71267,0,26124),
(120929,'Do not oppose me!','',0,0,0,0,0,0,0,0,0,0,70075,0,26124),
(120930,'Behold my power!','',0,0,0,0,0,0,0,0,0,0,70076,0,26124),
(120931,'You shall return.','',0,0,0,0,0,0,0,0,0,0,70077,0,26124),
(120932,'I am everywhere.','',0,0,0,0,0,0,0,0,0,0,70078,0,26124),
(120933,'The wind is at your back.','',0,0,0,0,0,0,0,0,0,0,70079,0,26124),
(120934,'What is it?','',0,0,0,0,0,0,0,0,0,0,70080,0,26124),
(120935,'Speak quickly!','',0,0,0,0,0,0,0,0,0,0,70081,0,26124),
(120936,'I am the wind seeker!','',0,0,0,0,0,0,0,0,0,0,70082,0,26124),
(120937,'What do you seek?','',0,0,0,0,0,0,0,0,0,0,70083,0,26124),
(120938,'Your actions are discombobulating!','',0,0,0,0,0,0,0,0,0,0,70084,0,26124),
(120939,'I pity the fool who is foolish enough to fool around with the Windlord!','',0,0,0,0,0,0,0,0,0,0,70085,0,26124),
(120940,'Well met.','',0,0,0,0,0,0,0,0,0,0,70086,0,26124),
(120941,'I am yours to command.','',0,0,0,0,0,0,0,0,0,0,70087,0,26124),
(120942,'I am here to serve.','',0,0,0,0,0,0,0,0,0,0,70088,0,26124),
(120943,'The Ebon Blade will prevail.','',0,0,0,0,0,0,0,0,0,0,70089,0,26124),
(120944,'None shall oppose you, Deathlord.','',0,0,0,0,0,0,0,0,0,0,70090,0,26124),
(120945,'We do what the living cannot.','',0,0,0,0,0,0,0,0,0,0,70091,0,26124),
(120946,'Blood and thunder!','',0,0,0,0,0,0,0,0,0,0,70092,0,26124),
(120947,'Nothing shall stand in our way!','',0,0,0,0,0,0,0,0,0,0,70093,0,26124),
(120948,'I am waiting.','',0,0,0,0,0,0,0,0,0,0,70094,0,26124),
(120949,'We will prevail, no matter the cost!','',0,0,0,0,0,0,0,0,0,0,70095,0,26124),
(120950,'Death was merely a setback.','',0,0,0,0,0,0,0,0,0,0,70096,0,26124),
(120951,'We do what the living cannot.','',0,0,0,0,0,0,0,0,0,0,70097,0,26124),
(120952,'You should kneel before a king.','',0,0,0,0,0,0,0,0,0,0,70098,0,26124),
(120953,'Out with it! I have little time...','',0,0,0,0,0,0,0,0,0,0,70099,0,26124),
(120954,'Are you here to pay tribute?','',0,0,0,0,0,0,0,0,0,0,70100,0,26124),
(120955,'Next time, you will kneel before me.','',0,0,0,0,0,0,0,0,0,0,70101,0,26124),
(120956,'Hurry back or I will unleash the hounds.','',0,0,0,0,0,0,0,0,0,0,70102,0,26124),
(120957,'The glory of Stromgarde is at hand.','',0,0,0,0,0,0,0,0,0,0,70103,0,26124),
(120958,'This war will not be won with words.','',0,0,0,0,0,0,0,0,0,0,70104,0,26124),
(120959,'We alone stand vigil in the night.','',0,0,0,0,0,0,0,0,0,0,70105,0,26124),
(120960,'I am ready.','',0,0,0,0,0,0,0,0,0,0,70106,0,26124),
(120961,'We do what the living cannot.','',0,0,0,0,0,0,0,0,0,0,70107,0,26124),
(120962,'My heart still beats with the drums of war.','',0,0,0,0,0,0,0,0,0,0,70108,0,26124),
(120963,'Victory without sacrifice is only an illusion.','',0,0,0,0,0,0,0,0,0,0,70109,0,26124),
(120964,'I shall serve.','',0,0,0,0,0,0,0,0,0,0,70110,0,26124),
(120965,'What is your desire?','',0,0,0,0,0,0,0,0,0,0,70111,0,26124),
(120966,'You need only ask.','',0,0,0,0,0,0,0,0,0,0,70112,0,26124),
(120967,'We do what the living cannot.','',0,0,0,0,0,0,0,0,0,0,70113,0,26124),
(120968,'Death alone cannot stop us.','',0,0,0,0,0,0,0,0,0,0,70114,0,26124),
(120969,'We have died so that others may live.','',0,0,0,0,0,0,0,0,0,0,70115,0,26124),
(120970,'','What do you seek?',0,0,0,0,0,0,0,0,0,0,0,70116,26124),
(120971,'','Greetings.',0,0,0,0,0,0,0,0,0,0,0,70117,26124),
(120972,'','You need only ask.',0,0,0,0,0,0,0,0,0,0,0,70118,26124),
(120973,'','We do what the living cannot.',0,0,0,0,0,0,0,0,0,0,0,70119,26124),
(120974,'','In undeath my true purpose is manifest.',0,0,0,0,0,0,0,0,0,0,0,70120,26124),
(120975,'','There is no peace for the unliving.',0,0,0,0,0,0,0,0,0,0,0,70122,26124),
(120976,'Rottgut?','',0,0,0,0,0,0,0,0,0,0,70124,0,26124),
(120977,'Rottgut.','',0,0,0,0,0,0,0,0,0,0,70125,0,26124),
(120978,'Rottgut...','',0,0,0,0,0,0,0,0,0,0,70126,0,26124),
(120979,'Rottguuuuuuuut.','',0,0,0,0,0,0,0,0,0,0,70127,0,26124),
(120980,'Rott. Gut!','',0,0,0,0,0,0,0,0,0,0,70128,0,26124),
(120981,'Rottgut!','',0,0,0,0,0,0,0,0,0,0,70129,0,26124),
(120982,'Yes, my disciple?','',0,0,0,0,0,0,0,0,0,0,70131,0,26124),
(120983,'Death greets you, young one.','',0,0,0,0,0,0,0,0,0,0,70132,0,26124),
(120984,'What may I teach you today?','',0,0,0,0,0,0,0,0,0,0,70133,0,26124),
(120985,'We do what the living cannot.','',0,0,0,0,0,0,0,0,0,0,70134,0,26124),
(120986,'Do not forget what you have learned.','',0,0,0,0,0,0,0,0,0,0,70135,0,26124),
(120987,'Your greatest power is... you.','',0,0,0,0,0,0,0,0,0,0,70136,0,26124),
(120988,'The end is coming!\n\nWould you like a pamphlet?','The end is coming!\n\nWould you like a pamphlet?',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(120989,'You have the aura of one who is questioning.','You have the aura of one who is questioning.',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(120990,'I\'ll take a pamphlet.','I\'ll take a pamphlet.',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(121005,'No no no... wrong skin color entirely. That won\'t do.','',0,0,0,0,0,0,0,0,0,0,70175,0,26124),
(121006,'Ick, that head reminds me of an uppity apprentice I had. Get rid of it.','',0,0,0,0,0,0,0,0,0,0,70176,0,26124),
(121007,'That\'s it! That\'s the one! Give it to me immediately.','',0,0,0,0,0,0,0,0,0,0,70177,0,26124),
(121009,'','You pulled me from a storm of madness and I am forever in your debt, $p. I know there is much I must atone for, but  at least now, my nightmare has passed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121011,'I\'m ready to go to Suramar.','I\'m ready to go to Suramar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121013,'Be on guard, $g sir:ma\'am;! Suramar is a dangerous place!','',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(121014,'There\'s something not quite right about you...','There\'s something not quite right about you...',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(121015,'','Look at them, enjoying their excess like the Legion aren\'t even here. Shall we introduce them to reality?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121016,'','You look like you\'re ready to set the world ablaze. Oh, how I wish I could join you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121017,'I\'ll take a flask of Arcflame.','I\'ll take a flask of Arcflame.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121019,'The spirits be kind, $ct. With the right offerin\', they can be findin\' you some valuable items.','The spirits be kind, $ct. With the right offerin\', they can be findin\' you some valuable items.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121020,'Do ye know who I be, laddie?','',0,0,0,0,0,0,396,0,0,0,71259,0,26124),
(121021,'Ye best watch yer tongue lass or ye\'ll be makin\' a trip t\' t\' plank!','',0,0,0,0,0,0,396,0,0,0,71257,0,26124),
(121022,'','Translation please? I cannot understand his incessant pirate gibberish.',0,0,0,0,0,0,396,0,0,0,0,70993,26124),
(121023,'','T\' t\'..t\' plank?',0,0,0,0,0,0,396,0,0,0,0,70994,26124),
(121024,'','He said that the letter was written in an advanced code that will not easily be broken.',0,0,0,0,0,0,396,0,0,0,0,71258,26124),
(121025,'Enough!','',0,0,0,0,0,0,396,0,0,0,71256,0,26124),
(121026,'For years I watched and waited at the base of the Alterac Mountains, speaking only to the spirits and forging mighty weapons from elemental power.$b$bI know the whims of the spirits. I know that one\'s destiny can be guided and shaped, if one is willing to make the sacrifice for it.$b$b$ct, build up this sacred space, and I promise to give you the power to shape your own fate.$b$bUntil then, I watch. I wait.','',1,25,0,0,0,0,0,0,0,0,0,0,26124),
(121027,'Somewhere in those murky waters is our mysterious object. Time to get your feet wet, $n.','',0,0,0,0,0,0,0,0,0,0,70808,0,26124),
(121028,'To stay focused and heal one\'s allies even in the midst of battle - there be no greater honor and no greater challenge for a shaman.$b$bIf you seek to practice your skills as a battle-mender, there be training dummies here in this chamber.$b$bShould you wish to retrain your skills, speak with Tribemother Torra nearby. She has lived through darkness and seen the light.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121029,'The shield bearer arrives at an hour of great need. You will need its strength.','',0,0,0,0,0,0,1,0,0,0,71466,0,26124),
(121030,'The vrykul here tell stories of an unrelenting warrior carving through Stormheim with golden blades. I wonder who that could be?','',0,0,0,0,0,0,1,0,0,0,71465,0,26124),
(121032,'You\'re a fine addition to my huntin\' party!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121033,'As with those that came before me, I pledge my service to you and the Unseen Path.','',0,0,0,0,0,0,1,0,0,0,70475,0,26124),
(121034,'Akama. Your duplicity is hardly surprising.','',0,0,0,0,0,0,0,0,30,0,11463,0,26124),
(121035,'Look there, to the north, $n! Gaze upon the Nighthold of Suramar! What secrets are kept inside?','',0,0,0,0,0,0,0,0,0,0,70812,0,26124),
(121036,'Combatants!  Put your hands together to welcome a $12383W-time Gladiator, $n!.','Combatants!  Put your hands together to welcome a $12383W-time Gladiator, $n!.',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(121037,'I should have slaughtered you and your malformed brethren long ago.','',0,0,0,0,0,0,0,0,30,0,0,0,26124),
(121038,'','I pledge my loyalty to you, and to the Unseen Path, for all my days.',0,0,0,0,0,0,1,0,0,0,0,70476,26124),
(121039,'Amazing! Ancient Highborne ruins litter the landscape. And there along the coast, it looks to be a vrykul settlement! Fascinating.','',0,0,0,0,0,0,0,0,0,0,70813,0,26124),
(121040,'Those blades should be mine! Do not think I will go easy on you!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121041,'Our next rumbler has tested their might over the years on the battlefields.  $n has become a Hero of the Horde during $12383W seasons!','Our next rumbler has tested their might over the years on the battlefields.  $n has become a Hero of the Horde during $12383W seasons!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(121042,'Our next rumbler has tested their might over the years on the battlefields.  $n has become a Hero of the Alliance during $12383W seasons!','Our next rumbler has tested their might over the years on the battlefields.  $n has become a Hero of the Alliance during $12383W seasons!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(121043,'$n is entering the rumble to prove their might!','$n is entering the rumble to prove their might!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(121044,'','Welcome to The Gnarled Branch! Feel free to browse or speak with me if you\'re looking for anything in specific.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121045,'Wow! Nice shades, $n!','Wow! Nice shades, $n!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121046,'Damn, $n! Back at it again with the sweet shades!','Damn, $n! Back at it again with the sweet shades! Nice!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121047,'Looking good, $n!','Looking good, $n!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121048,'Here comes, $n... check out those shades!','Here comes, $n... check out those shades!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121049,'Outsiders!','Outsiders!',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(121050,'You\'re not welcome here!','You\'re not welcome here!',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(121051,'How did you get in here?','How did you get in here?',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(121052,'Intruders!','Intruders!',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(121053,'Run! They have weapons!','Run! They have weapons!',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(121054,'The elites in this city revel in excess, while ordinary people suffer and die. Meet my associate Eo\'vyn in Astravar Harbor and put an end to the party.','',0,0,0,0,0,0,0,0,0,0,70912,0,26124),
(121055,'Maybe that will open their eyes to the suffering around them.','',0,0,0,0,0,0,0,0,0,0,70913,0,26124),
(121056,'$n! You are my friend!$b$bNext time Grash grabs a big people-ship from under the water and splits it open and all the people spill out into the sea I will yell at them \"$N IS BEST SHAMAN HA HA HA!\"','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121057,'<Your answer makes the sea giant very happy.>$b$b<Wavespeaker Adelee gawps at you.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121058,'<Grash lowers his head sadly.>$b$bOkay.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121059,'...sure.','...sure.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121060,'Don\'t do that!','Don\'t do that!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121061,'','It was difficult to get Grash into the cavern here. I\'m not sure the other shaman appreciate him like we do.',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(121062,'Help! Guards! There\'s an arsonist on the loose!','Help! Guards! There\'s an arsonist on the loose!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121063,'Guards, stop this insanity! What do we pay you for?','Guards, stop this insanity! What do we pay you for?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121064,'Our boats are burning! Help!','Our boats are burning! Help!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121065,'','Can I help you?',0,0,0,0,0,0,6,0,0,0,0,70258,26124),
(121066,'','Greetings.',0,0,0,0,0,0,1,0,0,0,0,70259,26124),
(121067,'','Well met.',0,0,0,0,0,0,1,0,0,0,0,70260,26124),
(121068,'','Embrace the shadows.',0,0,0,0,0,0,1,0,0,0,0,70261,26124),
(121069,'','The shadows will rise again.',0,0,0,0,0,0,1,0,0,0,0,70262,26124),
(121070,'','Farewell.',0,0,0,0,0,0,1,0,0,0,0,70263,26124),
(121071,'','You have my attention.',0,0,0,0,0,0,1,0,0,0,0,70264,26124),
(121072,'','I don\'t have time for your games.',0,0,0,0,0,0,1,0,0,0,0,70265,26124),
(121073,'','You\'re trying my patience.',0,0,0,0,0,0,1,0,0,0,0,70266,26124),
(121074,'','Will this ever end?',0,0,0,0,0,0,1,0,0,0,0,70267,26124),
(121075,'','I\'ll send you into the void!',0,0,0,0,0,0,603,0,0,0,0,70268,26124),
(121076,'','Silence!',0,0,0,0,0,0,603,0,0,0,0,70269,26124),
(121077,'','Yes?',0,0,0,0,0,0,6,0,0,0,0,70245,26124),
(121078,'','Hello.',0,0,0,0,0,0,1,0,0,0,0,70246,26124),
(121079,'','How can I help?',0,0,0,0,0,0,6,0,0,0,0,70247,26124),
(121080,'','%s glares at $n disapprovingly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121081,'','May the Light shine upon you.',0,0,0,0,0,0,1,0,0,0,0,70248,26124),
(121082,'','I will atone.',0,0,0,0,0,0,1,0,0,0,0,70249,26124),
(121083,'','I will be redeemed.',0,0,0,0,0,0,1,0,0,0,0,70250,26124),
(121084,'','You have my attention.',0,0,0,0,0,0,1,0,0,0,0,70251,26124),
(121085,'','Haven\'t I suffered enough?',0,0,0,0,0,0,6,0,0,0,0,70252,26124),
(121086,'','What more do you want from me?',0,0,0,0,0,0,6,0,0,0,0,70253,26124),
(121087,'','You\'re persistent, aren\'t you?',0,0,0,0,0,0,6,0,0,0,0,70254,26124),
(121088,'','Where are your manners?',0,0,0,0,0,0,6,0,0,0,0,70255,26124),
(121089,'','This needs to stop.',0,0,0,0,0,0,1,0,0,0,0,70256,26124),
(121090,'','Don\'t make me do something we\'ll both regret.',0,0,0,0,0,0,1,0,0,0,0,70257,26124),
(121091,'I defend the Light.','',0,0,0,0,0,0,1,0,0,0,72110,0,26124),
(121092,'I am Light incarnate.','',0,0,0,0,0,0,1,0,0,0,72109,0,26124),
(121093,'How can I be of service?','',0,0,0,0,0,0,6,0,0,0,70270,0,26124),
(121094,'The Light endures.','',0,0,0,0,0,0,1,0,0,0,72111,0,26124),
(121095,'May the Light guide you.','',0,0,0,0,0,0,1,0,0,0,70271,0,26124),
(121096,'The Light will prevail.','',0,0,0,0,0,0,1,0,0,0,70272,0,26124),
(121097,'The Nexus Vault lies deep beneath the main spire. You will find its entrance in the lowest chamber of the spire\'s base.','',0,0,0,0,0,0,0,0,0,0,70512,0,26124),
(121098,'','Okay, now, try this...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121099,'','No no, put your hands up, like little ears. Like this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121100,'','Now do a little shuffle. Like this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121101,'','%s laughs!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121102,'Bra - hah! Hahah!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121103,'Grah!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121104,'I am doing panda dance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121105,'There it is! Land at the shoreline and investigate!','',0,0,0,0,0,0,0,0,0,0,70814,0,26124),
(121106,'This place is... quaint.\n\n<Sylverin adjusts his cuffs>\n\nBut I prefer it to losing my life.\n\nI suppose I ought to thank you, for taking action. I was a coward, but at least Margaux\'s death did not go unanswered.\n\nI am indebted to you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121107,'I miss my wife, and moreso our daughter.\n\nHere, at least, I can remember them in peace.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121108,'','The Unseen Path will return to our calling of helping those who need it most.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121109,'Withered damage increased!','Withered damage increased!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121110,'Throw Rock now causes enemies to bleed!','Throw Rock now causes enemies to bleed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121111,'It\'s not here. Those beasts must have dragged it into the cave. The search continues!','',0,0,0,0,0,0,0,0,0,0,70807,0,26124),
(121113,'Thank you! I could not have lasted much longer!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121114,'Gaahh! They made me watch my tribe be slaughtered... over and over! Was it all a dream?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121115,'No! No more!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121116,'Bees! I saw bees everywhere! Aaahh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121117,'Wha... What trickery is this?! Was it all in my head?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121118,'I can still feel their claws in my mind.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121119,'Time is money, friend.','',0,0,0,0,0,0,0,0,0,0,70326,0,26124),
(121120,'Yo!','',0,0,0,0,0,0,0,0,0,0,70327,0,26124),
(121121,'Talk to me.','',0,0,0,0,0,0,0,0,0,0,70328,0,26124),
(121122,'Wassup?','',0,0,0,0,0,0,0,0,0,0,70329,0,26124),
(121123,'Can\'t you see I\'m busy here?','',0,0,0,0,0,0,0,0,0,0,70330,0,26124),
(121124,'Heh, heh, glad I could help.','',0,0,0,0,0,0,0,0,0,0,70331,0,26124),
(121125,'Keep it real.','',0,0,0,0,0,0,0,0,0,0,70332,0,26124),
(121126,'Hurry back.','',0,0,0,0,0,0,0,0,0,0,70333,0,26124),
(121127,'All\'s fair in love and business.','',0,0,0,0,0,0,0,0,0,0,70334,0,26124),
(121128,'You scratch my back, I\'ll pay someone to scratch yours.','',0,0,0,0,0,0,0,0,0,0,70335,0,26124),
(121129,'Yeah, very funny.','',0,0,0,0,0,0,0,0,0,0,70336,0,26124),
(121130,'I don\'t have time for this!','',0,0,0,0,0,0,0,0,0,0,70337,0,26124),
(121131,'Amateur!','',0,0,0,0,0,0,0,0,0,0,70338,0,26124),
(121132,'I don\'t have to take this. I\'m the Baron of Gadgetzan.','',0,0,0,0,0,0,0,0,0,0,70339,0,26124),
(121133,'Maybe you\'d prefer some of my goons rough you up?','',0,0,0,0,0,0,0,0,0,0,70340,0,26124),
(121134,'Okay, that\'s it. I\'m puttin\' a contract out on your head.','',0,0,0,0,0,0,0,0,0,0,70341,0,26124),
(121135,'What do you need?','',0,0,0,0,0,0,0,0,0,0,70342,0,26124),
(121136,'How can I help?','',0,0,0,0,0,0,0,0,0,0,70343,0,26124),
(121137,'Achal hecta.','',0,0,0,0,0,0,0,0,0,0,70344,0,26124),
(121138,'Together, we can defeat the Burning Legion.','',0,0,0,0,0,0,0,0,0,0,70345,0,26124),
(121139,'I have a plan for the Legion\'s downfall.','',0,0,0,0,0,0,0,0,0,0,70346,0,26124),
(121140,'Krona ki cristorr!','',0,0,0,0,0,0,0,0,0,0,70347,0,26124),
(121141,'Roma Hekt corta.','',0,0,0,0,0,0,0,0,0,0,70348,0,26124),
(121142,'One day, I will regain the temple.','',0,0,0,0,0,0,0,0,0,0,70349,0,26124),
(121143,'You, I trust. But, never Illidan.','',0,0,0,0,0,0,0,0,0,0,70350,0,26124),
(121144,'I\'m getting too old for this.','',0,0,0,0,0,0,0,0,0,0,70351,0,26124),
(121145,'Why did you poke me?','',0,0,0,0,0,0,0,0,0,0,70352,0,26124),
(121146,'Is this some strange custom of your people?','',0,0,0,0,0,0,0,0,0,0,70353,0,26124),
(121147,'Your finger is puny, so it is more annoying than anything else.','',0,0,0,0,0,0,0,0,0,0,70354,0,26124),
(121148,'Now you\'re just trying to annoy me. Mission accomplished.','',0,0,0,0,0,0,0,0,0,0,70355,0,26124),
(121149,'Magtheridon had better manners.','',0,0,0,0,0,0,0,0,0,0,70356,0,26124),
(121150,'Very well, you leave me no choice but to ignore you.','',0,0,0,0,0,0,0,0,0,0,70357,0,26124),
(121151,'What do you need?','',0,0,0,0,0,0,0,0,0,0,70358,0,26124),
(121152,'What is it you want?','',0,0,0,0,0,0,0,0,0,0,70359,0,26124),
(121153,'Achal hecta.','',0,0,0,0,0,0,0,0,0,0,70360,0,26124),
(121154,'Together, we can defeat the Burning Legion.','',0,0,0,0,0,0,0,0,0,0,70361,0,26124),
(121155,'I have a plan for the Legion\'s downfall.','',0,0,0,0,0,0,0,0,0,0,70362,0,26124),
(121156,'Krona ki cristorr!','',0,0,0,0,0,0,0,0,0,0,70363,0,26124),
(121157,'Roma Hekt corta.','',0,0,0,0,0,0,0,0,0,0,70364,0,26124),
(121158,'One day, I will destroy you and those who follow you.','',0,0,0,0,0,0,0,0,0,0,70365,0,26124),
(121159,'The day your control over me slips is the day you die.','',0,0,0,0,0,0,0,0,0,0,70366,0,26124),
(121160,'I have all eternity to wreak my revenge.','',0,0,0,0,0,0,0,0,0,0,70367,0,26124),
(121161,'Why did you poke me?','',0,0,0,0,0,0,0,0,0,0,70368,0,26124),
(121162,'Is this some strange custom of your people?','',0,0,0,0,0,0,0,0,0,0,70369,0,26124),
(121163,'Your finger is puny, so it is more annoying than anything else.','',0,0,0,0,0,0,0,0,0,0,70370,0,26124),
(121164,'Now you\'re just trying to annoy me. Mission accomplished.','',0,0,0,0,0,0,0,0,0,0,70371,0,26124),
(121165,'Magtheridon had better manners.','',0,0,0,0,0,0,0,0,0,0,70372,0,26124),
(121166,'Very well, you leave me no choice but to ignore you.','',0,0,0,0,0,0,0,0,0,0,70373,0,26124),
(121167,'Sorry, $c. Guild\'s closed down for renovations right now. Boss-man said something about preparing for the next big thing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121168,'Sorry, $c. Boss Bazzelflange says the arena is closed for renovations. She said something about \"preparing for the next big thing.\"','Sorry, $c. Boss Bazzelflange says the arena is closed for renovations. She said something about \"preparing for the next big thing.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121169,'','If you are hungry, we have food. If you are thirsty, we have drink. If you are tired, we have beds.$b$bIf you are here for something else, you better be be better with that blade than you look.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121170,'Go with valor!','',0,0,0,0,0,0,0,0,0,0,70426,0,26124),
(121171,'Speak!','',0,0,0,0,0,0,0,0,0,0,70430,0,26124),
(121172,'Get to the point!','',0,0,0,0,0,0,0,0,0,0,70431,0,26124),
(121173,'Talk to me when it\'s time to fight.','',0,0,0,0,0,0,0,0,0,0,70427,0,26124),
(121174,'I\'ll be here!','',0,0,0,0,0,0,0,0,0,0,70428,0,26124),
(121175,'Hail!','',0,0,0,0,0,0,0,0,0,0,70429,0,26124),
(121176,'Keep walking.','',0,0,0,0,0,0,0,0,0,0,70432,0,26124),
(121177,'Who do you think you\'re speaking to?','',0,0,0,0,0,0,0,0,0,0,70433,0,26124),
(121178,'You\'re starting to annoy me.','',0,0,0,0,0,0,0,0,0,0,70434,0,26124),
(121179,'Odyn\'s chosen or not, I will cleave your skull in two if you keep at it!','',0,0,0,0,0,0,0,0,0,0,70435,0,26124),
(121180,'BAH!','',0,0,0,0,0,0,0,0,0,0,70436,0,26124),
(121181,'YOU ARE MAKING ME ANGRY!!!!','',0,0,0,0,0,0,0,0,0,0,70437,0,26124),
(121182,'The Legion has begun their attack! We must send word to our allies at once.','',0,0,0,0,0,0,603,0,0,0,71131,0,26124),
(121183,'Take cover!','Take cover!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121184,'What was that?!','What was that?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121185,'The Lunastre Attendant nods to you and calmly exits the tavern.','The Lunastre Attendant nods to you and calmly exits the tavern.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121186,'Hmmmmrrrmmmph!','',0,0,0,0,0,0,0,0,0,0,70438,0,26124),
(121187,'I will put my boot SO FAR up your arse Odyn himself won\'t be able to pry it out!','',0,0,0,0,0,0,0,0,0,0,70439,0,26124),
(121188,'What is it?','',0,0,0,0,0,0,0,0,0,0,70464,0,26124),
(121189,'Is it time to fight?','',0,0,0,0,0,0,0,0,0,0,70465,0,26124),
(121190,'Sylverin raises his chin and strides from the tavern.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121191,'','I will follow you through. Thank you for allowing me to accompany you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121192,'','Quel\'vala thonos.  Nobility through tradition. I thank you, outlander.',0,0,0,0,0,0,0,0,0,0,0,70917,26124),
(121193,'Hello there. Good news! My books have arrived at last, well most of them.\n\nYou still look confused, so let me explain again. You see, when we last teleported Dalaran, some of my books were damaged. And so this time I had them fly to our new location. Yes, fly.\n\nUnfortunately, they were halfway over Khaz Modan when we teleported again. Most just arrived last week and are settling back in around the city. A few of them are still on loan to some colleagues, and should return themselves soon. Actually, if they are out much longer I might have to go investigate.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121194,'We\'ve come to end your reign, Illidan. My people, and all of Outland, shall be free!','',0,0,0,0,0,0,66,0,30,0,11389,0,26124),
(121195,'','I think you will spend quite a bit of time at Valdisdall, $ct. I can now transport you directly there from Skyhold.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121196,'','This area is well protected by the blue dragons. I can now transport you to Azsuna from Skyhold, $ct.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121197,'Gurg urggle blerg\'urk urgle blark.\n\nBlerglearg urk $ct urgle blurg? Glerk! Gurg urggle ble\'blerg, erks ker-blerk, gurgler.\n\n<The wizened murloc softly chuckles to himself, then turns deadly serious:>\n\nGlergurg blergbergle, $n. Gulg ble\'blergle: gurg urggle kek, glup gurg urggle blarkleblag? Blerg?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121198,'','There\'s a small path through the trees here! I can now transport you to Val\'sharah from Skyhold, $ct.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121199,'','I can see a lot of potential in the surrounding area! I can now transport you to Suramar from Skyhold, $ct.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121200,'Herk! Blargleblag Doomhammer gurg blerklefirk glup urglegurbler.\n\nUrgle glugblag Orgrim, urgle glugblag Thrall, glup urgle glugblag \"$ct $n\" gruggleblurg murgleglub!\n\n<A thin tendril of spittle slowly snakes down from the corner of Morgl\'s mouth. He continues speaking, urgent and unrelentingly:>\n\nMraagggle urg blerg murgleurgleurgle gurk! Wurgleblerg murgle urg? Blerk! Glerg! Mwagle?\n\n<The Oracle gestures to the Doomhammer and beckons you to hand it over.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121201,'<Morgl nods, sadly. The old murloc turns away from you to contemplate the undulating grey sea, saying nothing more.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121202,'Warg! Gra-blergle! BLEEERRGGHammer!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121203,'%s begins smashing the Doomhammer around indiscriminately.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121204,'It is clear that %s has no idea what he is doing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121205,'%s gurgles, happily.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121206,'<Morgl is glad you feel that way. He looks toward the sky contemplatively.>\n\nWarg gurg blergargle mruk, mruk. $ct $n urgle blorglug mragle urk. Mrawgle urg 10,000 blerg \"Ra\" barg urglebleg, urg \"Ra-den\" blek Mogu berkblug.\n\n<His eager attention focuses back on you.>\n\nMrgle urg blurg\'urg gerblagle. Graggle merg blur Gurgle of the Storm. Wurgle! Berk blergle-berk urg grablag. $n: urg garble murk gerblerg? Urk?\n\n<The murloc oracle leans forward, motioning for you to come closer. He wants to whisper something to you. For you... and you alone.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121207,'Blerk.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121208,'<Morgl is puzzled by your response. After composing himself, he continues:>\n\nUrgleblerg mra\'graggle berk urgleblag. Murgle urg grablurg urgle blerg ur Lake Minnetonka burgle bleg. Urg urkegle blerk murgle-gurgle, Azshara glurg\'ug. \n\nGurg blurgle urg-mulurk, \"Sharas\'dal\" gurp blergle urkle-klep. Blergle, $n?\n\n<The Oracle indicates the scepter you carry, then motions urgently for you to hand it to him.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121209,'Wurgle! Blerg arglebleg. Murgle urg blerk of Tides!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121210,'Urg blurgle murgle blek! Wurg $ct $n blergle-blerk. Wurgle, wurg.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121211,'%s bows deeply in gratitude.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121212,'<Morgl looks very pleased with himself.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121213,'<Nod affirmatively.>','<Nod affirmatively.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121214,'<Shake your head no.>','<Shake your head no.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121215,'<Thank him for his time.>','<Thank him for his time.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121216,'<Loan him the Doomhammer.>','<Loan him the Doomhammer.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121217,'<Move closer, bring your head close to his, and listen to the Oracle\'s ancient wisdom.>','<Move closer, bring your head close to his, and listen to the Oracle\'s ancient wisdom.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121218,'<Loan him Sharas\'dal, the Scepter of Tides.>','<Loan him Sharas\'dal, the Scepter of Tides.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121219,'','Naga have overrun the ruins of Kal\'delar. If they\'re allowed to gain a foothold, they could threaten the entire coastline.',0,0,0,0,0,0,0,0,0,0,0,73047,26124),
(121220,'','Thank you. It is easy to ignore such threats until it is too late to push them back.',0,0,0,0,0,0,0,0,0,0,0,73046,26124),
(121221,'','What the... What jokester spread so many acorns in Lorlathil? I realize this task is of the humble variety, but could you relocate some of those squirrels and crack a few nuts while you\'re at it?',0,0,0,0,0,0,0,0,0,0,0,73045,26124),
(121222,'Look at $n! There goes a rogue with a true sense of style!','Look at $n! There goes a rogue with a true sense of style!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121223,'','That squirrel invasion was nuts. Get it?',0,0,0,0,0,0,0,0,0,0,0,73044,26124),
(121224,'Looking smooth, $n! Real smooth!','Looking smooth, $n! Real smooth!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121225,'Is $n seeing anyone? Do you think I\'d have a chance?','Is $n seeing anyone? Do you think I\'d have a chance?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121226,'','Some wisps have the extraordinary ability to encourage the rapid maturation of saplings into trees. Seek the Hidden Pools and bond with a wisp there.',0,0,0,0,0,0,0,0,0,0,0,73043,26124),
(121227,'','Nature\'s beauty still shines through even in these dire times.',0,0,0,0,0,0,0,0,0,0,0,73042,26124),
(121228,'','I have some high value targets for you. You would do well to call upon our more... unsavory allies.',0,0,0,0,0,0,0,0,0,0,0,70520,26124),
(121229,'','We shall pick apart our enemies piece by piece, like a mana bun. Oh - now I am hungry.',0,0,0,0,0,0,0,0,0,0,0,70521,26124),
(121230,'','A Dream Warden is under attack by the Nightmare! May Elune bless your path as you save the sacred dragon.',0,0,0,0,0,0,0,0,0,0,0,73041,26124),
(121231,'','The Nightmare seeks to corrupt our entire forest!',0,0,0,0,0,0,0,0,0,0,0,73040,26124),
(121232,'','The druids who watch over Emerald Bay haven\'t returned from their patrol. Perhaps the sprites are up to something...',0,0,0,0,0,0,0,0,0,0,0,73039,26124),
(121233,'','They put our druids to sleep in shark-infested waters? I am glad you arrived when you did.',0,0,0,0,0,0,0,0,0,0,0,73038,26124),
(121234,'','The island of Gloaming Reef is the site of a constant battle between murloc and makrura. At times, one side gains an advantage and we have to step in to keep the struggle going.',0,0,0,0,0,0,0,0,0,0,0,73077,26124),
(121235,'','When is Phoe\'be getting here? She said she would be here over an hour ago!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121236,'','Some may think it heartless to slaughter the creatures, but the stalemate must be maintained lest one side will emerge the victor and swim to the mainland.',0,0,0,0,0,0,0,0,0,0,0,73076,26124),
(121237,'','The coffee here is really strong!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121238,'','It is near to birthing season for the hydras along Bradensbrook\'s coastline. We must prevent them from swelling to dangerous numbers so they don\'t pose a threat to the village.',0,0,0,0,0,0,0,0,0,0,0,73075,26124),
(121239,'','The people are safe from hydras, at least for another season.',0,0,0,0,0,0,0,0,0,0,0,73074,26124),
(121240,'Calm down, I\'m sure she will be here soon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121241,'Mysterious whispers offer untold power for your services...','Mysterious whispers offer untold power for your services...',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(121242,'How did you get this invitation? Never mind, the hunt\'s already started!','',0,0,0,0,0,0,0,0,0,43861,0,0,26124),
(121243,'Fine, fine! They went that way. Not that it matters, you will never catch up...','',0,0,0,0,0,0,0,0,0,43861,0,0,26124),
(121244,'','The Nightmare spreads like a pox on the land! We might put a stop to it here before it continues to corrupt Val\'sharah!',0,0,0,0,0,0,0,0,0,0,0,73037,26124),
(121245,'','Now is not the time for a chat. Your temple is under attack!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121246,'','The spread has slowed, thanks to your bravery, $n.',0,0,0,0,0,0,0,0,0,0,0,73036,26124),
(121247,'Look, Marius here can see things that will scare you so stark you\'ll look like me.$b$bBut even he is getting all twitchy about this cave. Something about bad dreams and corrupted elves and whatever.$b$bBah! We tracked a powerful satyr to this cave and I\'ll be damned... more... if we don\'t at least try to enslave it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121248,'Who are you? Where is Lord Nimrod and Lady Dyana?','Who are you? Where is Lord Nimrod and Lady Dyana?',0,0,0,0,0,0,0,0,0,43384,0,0,26124),
(121249,'This is our hunt, go away!','This is our hunt, go away!',0,0,0,0,0,0,0,0,0,43384,0,0,26124),
(121250,'That fox rightfully belongs to us!','That fox rightfully belongs to us!',0,0,0,0,0,0,0,0,0,43384,0,0,26124),
(121251,'We will have his pelt, or yours!','We will have his pelt, or yours!',0,0,0,0,0,0,0,0,0,43384,0,0,26124),
(121252,'I\'m ready!','',0,0,0,0,0,0,0,0,0,0,70466,0,26124),
(121253,'Keep your feet on the ground!','',0,0,0,0,0,0,0,0,0,0,70461,0,26124),
(121254,'Talk to me when it\'s time to fight.','',0,0,0,0,0,0,0,0,0,0,70462,0,26124),
(121255,'I\'ll be here!','',0,0,0,0,0,0,0,0,0,0,70463,0,26124),
(121256,'I like ye. Don\'t make me not like ye!','',0,0,0,0,0,0,0,0,0,0,70467,0,26124),
(121257,'Quit playing around!','',0,0,0,0,0,0,0,0,0,0,70468,0,26124),
(121258,'It\'s the shiny runes now isn\'t it?','',0,0,0,0,0,0,0,0,0,0,70469,0,26124),
(121259,'Ye really don\'t know when to stop!','',0,0,0,0,0,0,0,0,0,0,70470,0,26124),
(121260,'All right, put \'em up! Time to teach ye what\'s what!','',0,0,0,0,0,0,0,0,0,0,70471,0,26124),
(121261,'First it was Hodir, then Thorim... now YOU!','',0,0,0,0,0,0,0,0,0,0,70472,0,26124),
(121262,'I thought we... I thought we were friends...','',0,0,0,0,0,0,0,0,0,0,70473,0,26124),
(121263,'*sob*','',0,0,0,0,0,0,0,0,0,0,70474,0,26124),
(121264,'Keep your voice down! There\'s someone here...','',0,0,0,0,0,0,1,0,0,0,71320,0,26124),
(121265,'Sshh! We\'ve got company! Act natural...','',0,0,0,0,0,0,1,0,0,0,71321,0,26124),
(121266,'Sshh! Keep your voice down...','',0,0,0,0,0,0,1,0,0,0,71322,0,26124),
(121267,'Quiet down! Someone is coming...','',0,0,0,0,0,0,1,0,0,0,71323,0,26124),
(121268,'What now?!!','',0,0,0,0,0,0,0,0,0,0,70524,0,26124),
(121269,'My hatred burns!!','',0,0,0,0,0,0,0,0,0,0,70525,0,26124),
(121270,'Get it over with already!','',0,0,0,0,0,0,0,0,0,0,70526,0,26124),
(121271,'If the Legion does not kill you, someday I wil!','',0,0,0,0,0,0,0,0,0,0,70527,0,26124),
(121272,'Leave me be already!','',0,0,0,0,0,0,0,0,0,0,70528,0,26124),
(121273,'Hmmmppph...','',0,0,0,0,0,0,0,0,0,0,70529,0,26124),
(121274,'Go away.','',0,0,0,0,0,0,0,0,0,0,70530,0,26124),
(121275,'This is a bad idea. Demons are one thing, but satyrs? They are night elves given to corruption.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121276,'Thalyssra said you would be able to help me infiltrate the Twilight Vineyards.','Thalyssra said you would be able to help me infiltrate the Twilight Vineyards.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121277,'GO AWAY!!!','',0,0,0,0,0,0,0,0,0,0,70531,0,26124),
(121278,'I WILL SPIT ON YOUR GRAVE!!!!','',0,0,0,0,0,0,0,0,0,0,70532,0,26124),
(121279,'Yeah yeah. Look, if we hid from every monster that used to be an elf there would be nothing left to hunt. Now calm down and pay attention. We are not alone.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121281,'You will not interrupt my sermon!','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(121286,'Ah! Wretched creature. I will see you all bow before me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121289,'Let\'s give these runes a try. A hand, if you would?','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(121290,'Gah! I couldn\'t get a good hold on it. But you never know until you try.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121291,'You can\'t stop us, mage! Your former master opened the way to our victory! Karazhan will be ours!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121292,'I HATE YOUR DAMN GUTS!!!!','',0,0,0,0,0,0,0,0,0,0,70533,0,26124),
(121293,'I WOULD DIE A THOUSAND DEATHS TO SEE YOU SUFFER!!!!','',0,0,0,0,0,0,0,0,0,0,70534,0,26124),
(121294,'There? No... There! No...','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(121295,'WHY COULDN\'T YOU LET ME DIE!!!!!????','',0,0,0,0,0,0,0,0,0,0,70535,0,26124),
(121296,'CURSE YOU!!!! CURSE YOUR MOTHER!!!! I WILL **** REIGENFLA*****DOWN YOUR THROAT******ODYN HIMSELF*****','',0,0,0,0,0,0,0,0,0,0,70536,0,26124),
(121297,'Our enemies are closer than we think.','',0,0,0,0,0,0,0,0,0,0,70552,0,26124),
(121298,'The Legion cannot hide from us.','',0,0,0,0,0,0,0,0,0,0,70553,0,26124),
(121299,'This changes nothing, mage! Your defenses will crumble and your world will burn!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121300,'Speak, mortal.','',0,0,0,0,0,0,0,0,0,0,70554,0,26124),
(121301,'I am vigilant.','',0,0,0,0,0,0,0,0,0,0,70555,0,26124),
(121302,'I serve Skyhold.','',0,0,0,0,0,0,0,0,0,0,70556,0,26124),
(121303,'The battle is eternal.','',0,0,0,0,0,0,0,0,0,0,70557,0,26124),
(121304,'If you only understood the implications of your actions...','',0,0,0,0,0,0,0,0,0,0,70558,0,26124),
(121305,'Hymdall sees all... knows all!','',0,0,0,0,0,0,0,0,0,0,70559,0,26124),
(121306,'You, on the other hand...','',0,0,0,0,0,0,0,0,0,0,70560,0,26124),
(121307,'I\'m starting to question Odyn\'s choice.','',0,0,0,0,0,0,0,0,0,0,70561,0,26124),
(121308,'Do you ever give up?','',0,0,0,0,0,0,0,0,0,0,70562,0,26124),
(121309,'No, really.','',0,0,0,0,0,0,0,0,0,0,70563,0,26124),
(121310,'I am very close to stuffing the rainbow bridge somewhere... painful.','',0,0,0,0,0,0,0,0,0,0,70564,0,26124),
(121311,'Suit yourself.','',0,0,0,0,0,0,0,0,0,0,70565,0,26124),
(121312,'You need something?','',0,0,0,0,0,0,0,0,0,0,70538,0,26124),
(121313,'Speak, friend.','',0,0,0,0,0,0,0,0,0,0,70539,0,26124),
(121314,'What do you need?','',0,0,0,0,0,0,0,0,0,0,70540,0,26124),
(121315,'May the winds of the north be at your back.','',0,0,0,0,0,0,0,0,0,0,70541,0,26124),
(121316,'Farewell!','',0,0,0,0,0,0,0,0,0,0,70542,0,26124),
(121317,'Stay vigilant!','',0,0,0,0,0,0,0,0,0,0,70543,0,26124),
(121318,'I am Hodir!','',0,0,0,0,0,0,0,0,0,0,70544,0,26124),
(121319,'HODIR!','',0,0,0,0,0,0,0,0,0,0,70545,0,26124),
(121320,'I owe you one but don\'t push it!','',0,0,0,0,0,0,0,0,0,0,70546,0,26124),
(121321,'Cool it!','',0,0,0,0,0,0,0,0,0,0,70547,0,26124),
(121322,'Don\'t make me have to put you on ice, small friend!','',0,0,0,0,0,0,0,0,0,0,70548,0,26124),
(121323,'That\'s cold.','',0,0,0,0,0,0,0,0,0,0,70549,0,26124),
(121324,'Snow big deal.','',0,0,0,0,0,0,0,0,0,0,70550,0,26124),
(121325,'Stay frosty!','',0,0,0,0,0,0,0,0,0,0,70551,0,26124),
(121326,'I greet you, wielder of Talonclaw.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121327,'','What do you need?',0,0,0,0,0,0,1,0,0,0,0,70569,26124),
(121328,'','I am ready for whatever comes.',0,0,0,0,0,0,1,0,0,0,0,70570,26124),
(121329,'','Spit it out!',0,0,0,0,0,0,1,0,0,0,0,70571,26124),
(121330,'','Keep your blades sharp!',0,0,0,0,0,0,1,0,0,0,0,70572,26124),
(121331,'','There is no fear in our hearts!',0,0,0,0,0,0,1,0,0,0,0,70573,26124),
(121332,'','Until the final battle!',0,0,0,0,0,0,1,0,0,0,0,70574,26124),
(121333,'','You seem nervous.',0,0,0,0,0,0,1,0,0,0,0,70575,26124),
(121334,'','Do I scare you?',0,0,0,0,0,0,1,0,0,0,0,70576,26124),
(121335,'','You have nice hands.',0,0,0,0,0,0,1,0,0,0,0,70577,26124),
(121336,'','Would be a shame if something happened to them.',0,0,0,0,0,0,1,0,0,0,0,70578,26124),
(121337,'I\'ve really, REALLY had enough of that demon!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(121338,'','Maybe you keep those to yourself from now on.',0,0,0,0,0,0,1,0,0,0,0,70579,26124),
(121339,'Out with it already!','',0,0,0,0,0,0,0,0,0,0,70581,0,26124),
(121340,'I\'m ready to fight!','',0,0,0,0,0,0,0,0,0,0,70582,0,26124),
(121341,'Say what you have to say!','',0,0,0,0,0,0,0,0,0,0,70583,0,26124),
(121342,'Keep your sword arm strong!','',0,0,0,0,0,0,0,0,0,0,70584,0,26124),
(121343,'Never retreat!','',0,0,0,0,0,0,0,0,0,0,70585,0,26124),
(121344,'Fight like every battle is the last.','',0,0,0,0,0,0,0,0,0,0,70586,0,26124),
(121345,'What?','',0,0,0,0,0,0,0,0,0,0,70587,0,26124),
(121346,'What was that?','',0,0,0,0,0,0,0,0,0,0,70588,0,26124),
(121347,'I cannot hear you with this helm.','',0,0,0,0,0,0,0,0,0,0,70589,0,26124),
(121348,'Very good at protecting one\'s head. Cannot hear very much though.','',0,0,0,0,0,0,0,0,0,0,70590,0,26124),
(121349,'I will nod in agreement now. Maybe you leave me alone.','',0,0,0,0,0,0,0,0,0,0,70591,0,26124),
(121350,'Greetings, wielder of Talonclaw.','Greetings, wielder of Talonclaw.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121351,'Have you come to aid us with Talonclaw?','Have you come to aid us with Talonclaw?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121352,'Ah, could that be? YES! That\'s it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121353,'I am an awesome mage indeed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121354,'This should give me something to work with.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121355,'Demon gets one, too!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121356,'I need to fly to Acherus at once.','I need to fly to Acherus at once.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121357,'There it is! The giant is holding it! There\'s only one way to separate a giant from its treasure. You know what to do, $n.','',0,0,0,0,0,0,0,0,0,0,70806,0,26124),
(121358,'LANDBORN FILTH! THIEVES! I WILL LEAVE YOU AS A SMUDGE IN MY LAIR!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121359,'Excellent! Hurry back to Dalaran and meet me in the Chamber of the Guardian. Safe return, $ct.','',0,0,0,0,0,0,0,0,0,0,70809,0,26124),
(121360,'THERE WILL BE AN IN-GAME CINEMATIC HERE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121361,'','Hold it, hun! That\'s a deadly drop through that portal! Don\'t go unprepared.',0,0,0,0,0,0,5,0,1,0,0,0,26124),
(121362,'Let me know when you are ready, but do not tarry.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121363,'We should not stay here a moment longer than is necessary.\n\nOur safety here is tenuous at best.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121364,'Let\'s get moving.','Let\'s get moving.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121365,'We should stick together, just in case.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121366,'Knights of the Ebon Blade, $p, the Ashbringer, Highlord of the Silver Hand, demands audience with your horsemen.','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(121367,'You are not the only Highlord here, paladin. What business have you with the Four Horsemen?','',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(121368,'','They do not belong. Guards! Remove -',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(121369,'They have honor. Let them speak their piece.','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(121370,'Agreed. We can decide what to do with them after we hear their reason for daring to tread here.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121371,'Show them, Highlord.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121372,'','By the Deathlord...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121373,'I thought it only myth...','',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(121374,'You dare bring that here? You can\'t possibly hope to...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121375,'We do, and we will - with your help. You owe us, Darion.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(121376,'He\'s right. We must try. The Ashbringer is no longer our enemy.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121377,'So be it. Horsemen, give me your strength. On this day, the Ashbringer will know our power once more!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121378,'','<Shannon puts her book away as you approach.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121379,'Good book?','Good book?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121380,'','Hello!\n\nYes!  Quite.',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(121381,'Are you a member of the Kirin Tor?  What do you do here?','Are you a member of the Kirin Tor?  What do you do here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121382,'','Oh, I organize the books!  I love it.  \n\nIf I could take them all down and put them back up every day, I would. \n\nBut they got kind of annoyed the last few times.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121383,'Surely it gets a bit boring down here after a while?','Surely it gets a bit boring down here after a while?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121384,'','Hah!  Never.  Not with all these things to read!\n\nAnd I write too.  And make things with my imagination.  Want to see?',0,0,0,0,0,0,11,0,0,0,0,0,26124),
(121385,'Sure!','Sure!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121386,'','I learned this one from one of the magic tomes... took a few tries to get it right.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121387,'','Anyway, I\'m going to get back to reading.  Nice to have met you!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121388,'<Volpin quivers with fear>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121389,'<Volpin leaps with joy>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121390,'','<Shannon is reading intently.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121391,'You did it! You made the voices stop.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121392,'This portal will take you to the Exodar. Good luck, $ct.','',0,0,0,0,0,0,0,0,0,0,70811,0,26124),
(121393,'Mine will be the last face you see!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121394,'I will die before I talk!','I will die before I talk!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121395,'You will get nothing from me!','You will get nothing from me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121396,'Lowborn scum! I will never talk!','Lowborn scum! I will never talk!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121397,'Keep your eyes open for eyes in here. Inquisitors love their eyes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121398,'I\'d like to upgrade my gear.','I\'d like to upgrade my gear.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121399,'I yield! I\'ll tell you anything!','I yield! I\'ll tell you anything!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121400,'Corvyn... he does our dirty work. You\'ll find him down near the docks.','Corvyn... he does our dirty work. You\'ll find him down near the docks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121401,'House Stelleris does not answer to lowborn scum like you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121402,'My life... for House Stelleris...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121403,'The raven caws at you in disapproval.','',0,0,0,0,0,0,0,0,0,7269,0,0,26124),
(121404,'Bah! That thing was so bossy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121405,'No, this is all wrong. I... I have been here before, but that would mean...','',0,0,0,0,0,0,0,0,0,0,70859,0,26124),
(121406,'IT CANNOT BE!','',0,0,0,0,0,0,0,0,0,0,70858,0,26124),
(121407,'Heroes we mustn\'t kill Rakeesh! Stop! Please!','',0,0,0,0,0,0,0,0,0,0,70857,0,26124),
(121409,'If you will not spare him then I must stop you!','',0,0,0,0,0,0,0,0,0,0,70856,0,26124),
(121410,'He\'s left us no choice, Velen! If we don\'t destroy the machine this place and every living soul inside will be annihilated!','He\'s left us no choice, Velen! If we don\'t destroy the machine this place and every living soul inside will be annihilated!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121411,'Havi\'s companion doesn\'t seem to like you for some reason.','',0,0,0,0,0,0,0,0,0,7269,0,0,26124),
(121412,'The raven expresses its displeasure at your presence.','',0,0,0,0,0,0,0,0,0,7269,0,0,26124),
(121413,'This is all your fault...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121414,'My fault? I said \"eye\" not \"I\" you blind git!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121415,'','My... that was close. Let me spare a bit of my magic for you, as a gesture of thanks.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121416,'','Be swift where our enemies are slow. And... thank you. You spared my mind an ugly fate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121417,'','May this be the edge you need to bring justice to Suramar.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121418,'Greetings, $c. The Highlord says you are to be welcomed as a guest, so long as you don\'t cause trouble.','Greetings, $c. The Highlord says you are to be welcomed as a guest, so long as you don\'t cause trouble.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121419,'I... I am rekindled. You are most generous. I spare for you a bit of my magic, to bolster your abilities in combat.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121420,'Burn bright, and hit the enemy where they least expect.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121421,'Sear justice into the minds of those who would endanger Suramar.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121422,'Hello.  Nice to meet you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121423,'What are you up to?','What are you up to?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121424,'This city has a bug problem.  They\'re everywhere!  \n\nI\'m an engineer.  An automation engineer to be exact.  And I\'m trying to help out a bit.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121425,'And who\'s this little fellow?','And who\'s this little fellow?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121426,'This is Wintron!  \n\nIt seemed a bit tedious to walk around trying to find bugs one by one, so I made him to find them for me.  \n\nGood little guy.  Snorts a lot, but that\'s fine with me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121427,'','To the High Priest!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(121428,'','To the High Priest!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(121429,'Do not underestimate me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121430,'My blades will be your end.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121431,'Another weakling come to party!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121432,'Need any help?','Need any help?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121433,'Naw, Wintron can handle it.\n\nThank you though!\n\nIt was a pleasure meeting you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121434,'You won\'t know what hit you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121435,'','I sense a nurturing spirit within you, kind one.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121436,'','I hear your call, druid. What do you seek?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121437,'In the shadows, we are connected to those unseen.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121438,'I see before me a mighty beast! What do you ask of me, $Gbrother:sister;?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121439,'','Light speed you, $ct.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121440,'<The blind shaman hears your footfalls as you approach. He does not turn to face you.>\nYou are not a shaman. Tread lightly here, $c, for the very stones themselves watch your every move.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121441,'<The blind shaman hears your footfalls as you approach. He reaches up to touch your face.>\n\nAlliance. Hmmm... $r, yes. <Cough> Perhaps we once met on the field of battle.\n\nI heard the call of the elements long, long ago. Another place. Another time. <Cough> I can see the spirits shining within you... I sense the very wind and waves bending to your will. Powerful, yes. Your Alliance must be very proud to have you.\n\nThese are the dark times, $r. But your strength gives this old orc hope. Perhaps I can return the favor... <Cough>... if you are not too proud to accept the aid of a former foe...','',1,6,0,0,0,0,0,0,0,0,0,0,26124),
(121442,'<The blind shaman hears your footfalls as you approach. He reaches up to touch your face.>\n\nAh, $ct. I recognize your confident stride. <Cough>. The spirits walk in step with you, united in purpose.\n\nAges have passed since I first heard the call of the elements on Draenor. Did you go back? I heard there were some that went back... somehow... <Wheeze>. I could not bear to see my old home as it was. Before the darkness. The war.\n\nYes, but you did not come to me to hear the ramblings of an old orc. You do not judge me as the others do. My age... <Cough> this chair... I am not the frail thing the others see. My power is all around me, amongst the stones and the wind.','',1,6,0,0,0,0,0,0,0,0,0,0,26124),
(121443,'<Receive Drek\'Thar\'s blessing.>','<Receive Drek\'Thar\'s blessing.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121444,'','Grand Artificer Romuul yet lives, sir!',0,0,0,0,0,0,0,0,0,0,0,70815,26124),
(121445,'Good. Find Romuul. Tell him to begin repairs on the vessel. We are going home.','',0,0,0,0,0,0,0,0,0,0,70872,0,26124),
(121446,'Brother, I come...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121447,'Yer sword arm looks soft, $ct.','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(121448,'It is done. Consider us even, Highlord.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121449,'Thank you, Darion. Your father would be proud.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(121450,'Never speak of him in my presence again, paladin. Now begone, and never return!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121451,'Take you home?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121452,'Please take us back to Dalaran.','Please take us back to Dalaran.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121453,'I\'ll meet you back at the Sanctum of Light, $p.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121454,'Thank you, friend. I am well enough to rejoin the fight!','Thank you, friend. I am well enough to rejoin the fight!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121455,'My thanks, druid. This battle is not over!','My thanks, druid. This battle is not over!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121456,'My injuries were severe, but now I can press on!','My injuries were severe, but now I can press on!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121457,'I feel much better now. Thank you, druid.','I feel much better now. Thank you, druid.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121458,'My injuries were severe, but now I can press on!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121459,'I feel much better now. Thank you, druid.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121460,'They will write sagas about your valor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121461,'Please don\'t call the guards. I came to honor Vol\'jin, not to cause trouble.$b$bHe was a friend. We fought side by side against great odds. I owe that troll my life.$b$bWe once swore to each other that, should one of us be killed, the other would avenge him. Always thought he\'d outlive me...$b$bWhatever it takes, I\'m going to make good on my promise.','',1,1,0,0,500,0,0,0,0,0,0,0,26124),
(121462,'','Leave me alone. I\'m working. There may be hostiles in the crowd.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121463,'','We cannot lose hope, $ct. If we somehow defeat the Legion, it will take a new generation of shaman to heal this scorched world.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121464,'','Do I look like I want to die? Again, I mean?$b$bIf you\'re curious about the Blightcaller\'s visage, you can ask him yourself. Or the Dark Lady, for that matter. They\'re ever so fond of small talk.$b$b<The dark ranger smirks as she resumes her watch.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121465,'Do you know why Nathanos looks... different?','Do you know why Nathanos looks... different?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121466,'I summoned an air elemental the other day! I think.\n\nI burped REAL loud.','If you\'re like a really really good shaman, can you summon, like� an ice cream elemental?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121467,'Fire. FIRE! Fire\'s the best. I like fire.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121468,'Someday I\'ll be a big hero like $ct $n!','Earthcaller Yevaa is so smart. She says her world was taken over by demons, but she ran away to fight them. Do you fight the demons, $n?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121469,'','The element of water represents tranquility or renewal. But we must be careful, for water spirits can be very fickle.',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(121470,'','If one can speak with the winds, one can listen for news from far away. With enough control, a shaman can also harness the fury of a thunderstorm.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121471,'','Journeyman Goldmine was also once a student of mine. But don\'t let that discourage you.',0,0,0,0,0,0,1,0,0,40261,0,0,26124),
(121472,'','The earth grounds us in all things. If we are one with the earth, we will be to our enemies as unyielding as a mountain.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121473,'','Most associate the element of fire with destruction, but in gentle hands, fire can cook our food or warm our homes. Students, how will you use fire?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(121474,'Not now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121475,'I\'m here to ensure the Warchief\'s protection. Draw your weapon against her and you\'ll be dead before the first drop of your blood hits the ground.$b$bAs for anything else... it doesn\'t concern you. Understood?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121476,'There\'s something different about you, Blightcaller...','There\'s something different about you, Blightcaller...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121477,'So I tried that totem-puzzle-game thing again.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121478,'A relentless cascade of failures and lowered expectations, culminating in a deep pit of existential despair.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(121479,'It\'s fire! It\'s water! It\'s fire! It\'s water! Somehow I changed one to an earth totem and Puzzlemaster Lo kicked me out.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(121480,'My meager initial hopes seemed laughable after hours of crushing denial blearily beat into me the soul-wrenching realization of abject failure.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(121481,'As the tides forever beat toward the shore, so too, I ceaselessly toil in the face of diminishing success, nourished only by the salt of my tears.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(121482,'You should... stop playing that game.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121483,'Buck up, little friend. Next time you will do better.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121484,'You need, perhaps, a vacation.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121485,'How did you do this time?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(121486,'Th... the rage, it clouds my thoughts no more! Thank you, Nahlen\'do!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(121487,'So goes a good leader, and a good friend. I look forward to battling with him in the Halls of Valor when my time comes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121488,'Why the boat?','Why the boat?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121489,'I want to ask something else.','I want to ask something else.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121490,'It was once our custom to send a Jarl like this into the sea and set the boat ablaze. But since the mists claimed our shores, we dare not send him out lest he return as a kvaldir.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121491,'Citizens of Azeroth.','',0,0,0,0,0,0,0,0,6,0,70720,0,26124),
(121492,'Today is the day we turn the tide.','',0,0,0,0,0,0,0,0,6,0,70722,0,26124),
(121493,'Today is the day that we re-take our world.','',0,0,0,0,0,0,0,0,6,0,70723,0,26124),
(121494,'And send the Legion back to the hell that spawned them.','',0,0,0,0,0,0,0,0,6,0,70724,0,26124),
(121495,'Our path is clear.','',0,0,0,0,0,0,0,0,6,0,70725,0,26124),
(121496,'The Pillars of Creation await.','',0,0,0,0,0,0,0,0,6,0,70726,0,26124),
(121497,'On the Broken Isles!','',0,0,0,0,0,0,0,0,6,0,70727,0,26124),
(121498,'Highlord! We must do something before it\'s too late!','',0,0,0,0,0,0,0,0,0,0,70728,0,26124),
(121500,'Ha! My bear will tear your musken into tiny pieces!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(121501,'You! Puny one! We will fight to decide the strongest beast!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(121502,'The manasaber takes off running!','The manasaber takes off running!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121504,'','We will make the Legion pay for what they\'ve done!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121505,'You can be replaced, if you grow weary.','You can be replaced, if you grow weary.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121506,'The Vineyard Laborer glances fearfully over his shoulder and rushes back to work.','The Vineyard Laborer glances fearfully over her shoulder and rushes back to work.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121507,'I am not tired. Please forgive me.','I am not tired. Please forgive me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121508,'Very good.','Very good.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121509,'We await your request.','We await your request.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121510,'','Fool! You would think to succeed where even I, chosen of Sargeras, had failed?',0,0,0,0,0,0,0,0,0,0,0,70789,26124),
(121511,'','All who have tried to tame Ulthalesh have been consumed. You will fare no better!',0,0,0,0,0,0,0,0,0,0,0,70790,26124),
(121512,'','Ulthalesh will devour you!',0,0,0,0,0,0,53,0,0,0,0,70791,26124),
(121514,'','You will join the harvested!',0,0,0,0,0,0,0,0,0,0,0,70792,26124),
(121515,'','Ulthalesh feasts!',0,0,0,0,0,0,0,0,0,0,0,70793,26124),
(121516,'','Impossible... you will be... consumed...',0,0,0,0,0,0,0,0,0,0,0,70794,26124),
(121517,'Highlord, it seems we are all in agreement, but yours is the final word. What should we do?','',0,0,0,0,0,0,6,0,0,0,70795,0,26124),
(121518,'We will defend Netherlight Temple.','We will defend Netherlight Temple.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121522,'Greetings, $c.\n\nGreymane has instructed me to keep the barracks open to any of our allies in Stormheim. If you need use of one of our beds, let me know.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121523,'These orcish buildings may not have the comfort of an Undercity crypt, but wood logs travel much better than crumbling stone.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121526,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121527,'All hail Warchief Sylvanas!','All hail Warchief Sylvanas!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121528,'Blood and honor!','Blood and honor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121529,'Vengeance for Vol\'jin!','Vengeance for Vol\'jin!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121530,'Victory against the Legion!','Victory against the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121531,'Remember the Broken Shore!','Remember the Broken Shore!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121532,'Down with the Alliance!','Down with the Alliance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121533,'The Horde endures!','The Horde endures!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121534,'The demons will fall!','The demons will fall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121536,'Boldly said. But I remain... unconvinced.','',0,0,0,0,0,0,6,0,30,0,11464,0,26124),
(121537,'The time has come! The moment is at hand!','',0,0,0,0,0,0,1,0,0,0,11380,0,26124),
(121538,'You are not prepared!','',0,0,0,0,0,0,406,0,0,0,11466,0,26124),
(121539,'Outsiders, here?!','Outsiders, here?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121541,'Guards!  Save us!','Guards!  Save us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121542,'Bring the Vineyards to heel. I will tolerate no more insubordination.','',0,0,0,0,0,0,0,0,6,0,70804,0,26124),
(121543,'Please, don\'t hurt us.','Please, don\'t hurt us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121544,'','Hail, $n. I bear an important message from Odyn!',0,0,0,0,0,0,0,0,0,0,0,70953,26124),
(121545,'','Odyn awaits your arrival. His forces stand at the ready!',0,0,0,0,0,0,0,0,0,0,0,70954,26124),
(121546,'','$n. There you are. I have something to tell you.',0,0,0,0,0,0,0,0,0,0,0,70818,26124),
(121547,'','Battlelord Gaardoun said that it was a matter of utmost importance.',0,0,0,0,0,0,0,0,0,0,0,70819,26124),
(121548,'','He requested that you return to the Fel Hammer as soon as you can.',0,0,0,0,0,0,0,0,0,0,0,70820,26124),
(121549,'Now that I know you\'re real, I suppose I can continue to train you. I can trade you recipes, if you have crafting materials!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121552,'','Psst, $n. Come closer, I have something to tell you.',0,0,0,0,0,0,0,0,0,0,0,70908,26124),
(121553,'Who pulled aggro?!?!','Who pulled aggro?!?!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(121554,'I have ankh!','I have ankh!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121555,'','Lord Ravenholdt has something important to discuss with you.',0,0,0,0,0,0,0,0,0,0,0,70909,26124),
(121556,'I think Johnny is afk...','I think Johnny is afk...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121557,'Misdirect the tank!','Misdirect the tank!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121558,'RESURRECT THE WARLOCK, WE NEED HIM FOR THE LAST PHASE!','RESURRECT THE WARLOCK, WE NEED HIM FOR THE LAST PHASE!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121559,'','He is asking that you return to the Chamber of Shadows immediately.',0,0,0,0,0,0,0,0,0,0,0,70920,26124),
(121560,'WORLD FIRST!!!','WORLD FIRST!!!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121561,'WoOoOOOoOO!!!','WoOoOOOoOO!!!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121562,'If the glaive drops, can I have it?','If the glaive drops, can I have it?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121564,'SPREAD OUT!','SPREAD OUT!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121565,'Focus, guys. USE POTIONS NOW!','Focus, guys. USE POTIONS NOW!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121566,'Does anyone have some extra potions?','Does anyone have some extra potions?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121567,'Where... were... my heals...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121568,'With my last breath... I blame our tank...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121569,'I never should have let the hunter shoot first...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121570,'','I heal wounds, not foolery...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121571,'How did they see me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121572,'You see? We don\'t have to go to a dungeon to find good loot. Dibs on its gloves!','',0,0,0,0,0,0,0,0,0,43556,0,0,26124),
(121573,'How\'s the fighting out there, $c? Seen anything worth skinnin\'?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121577,'','My students\' skills will blow you away!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121578,'I would like to requisition a Squad of Apprentices.','I would like to requisition a Squad of Apprentices.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121579,'I would like to requisition a Squad of Conjurors.','I would like to requisition a Squad of Conjurors.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121580,'Greetings, Archdruid. I bring news from the Dreamgrove.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(121581,'Excellent, Archdruid. Swift travels.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(121582,'Grandmaster, I have been looking for you!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(121583,'I look forward to seeing you at the Wandering Isle, Grandmaster.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(121584,'','Highlord, a moment of your time, please.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(121585,'','We look forward to your return to Light\'s Hope Chapel.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(121586,'%s runs away in terror!','%s runs away in terror!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121587,'Ahh, thank you.','',0,0,0,0,0,0,0,0,0,0,71457,0,26124),
(121588,'My wits return.','',0,0,0,0,0,0,0,0,0,0,71458,0,26124),
(121589,'Eugh... wh.. wha? Oh - it is you! Thank you, outlander.','',0,0,0,0,0,0,0,0,0,0,71459,0,26124),
(121590,'I should hope you never experience that pain...','',0,0,0,0,0,0,0,0,0,0,71460,0,26124),
(121591,'Not withering today, it seems.','',0,0,0,0,0,0,0,0,0,0,71461,0,26124),
(121592,'Blech. How did we live before the Nightwell?','',0,0,0,0,0,0,0,0,0,0,71462,0,26124),
(121593,'A drop in the ocean of my thirst... But appreciated, nonetheless.','',0,0,0,0,0,0,0,0,0,0,71463,0,26124),
(121594,'Still here... for now.','',0,0,0,0,0,0,0,0,0,0,71464,0,26124),
(121595,'','What?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121596,'|TINTERFACE\\ICONS\\Spell_Arcane_PrismaticCloak:20|t Arcanist Tel\'arn begins to cast |cFFF00000|Hspell:218807|h[Call of Night]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(121597,'|TINTERFACE\\ICONS\\Spell_Arcane_PrismaticCloak:20|t Solarist Tel\'arn begins to cast |cFFF00000|Hspell:223437|h[Collapse of Night]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(121598,'Blasted demons! Such wanton destruction... there\'s no profit in it!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(121599,'The Nightmare\'s spread has gone further than we thought. I must meditate on this, Archdruid.','',0,0,0,0,0,0,396,0,0,0,70996,0,26124),
(121600,'Do you wish to train Zealots?','Do you wish to train Zealots?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121601,'Do you wish to train Dark Zealots?','Do you wish to train Dark Zealots?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121602,'Lord Tash\'irel has stolen tomes from my library. His delusions of grandeur will bring ruin to us all. Bring those tomes back to me at once!','',0,0,0,0,0,0,0,0,0,0,70997,0,26124),
(121603,'Got anything explosive for sale?','Got anything explosive for sale?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121604,'','I wonder who painted this? It\'s incredible!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121605,'','I must have this, the detail is outstanding!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121606,'','This piece is just exquisite.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121607,'<Gain Warpwalking for 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>','<Gain Warpwalking for 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121608,'','Random? Do you not find it striking that each body found is decorated with a dawn lily? The same flower adored by Thalyssra?',1,0,0,0,0,0,0,0,0,0,0,70998,26124),
(121609,'Leave us alone!  Ahhhhh!','Leave us alone!  Ahhhhh!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121610,'... But nobody came.','... But nobody came.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(121611,'','You are nearly there now, outlander. Oculeth should be waiting for you on the other side of this chamber.',0,0,0,0,0,0,0,0,0,0,0,71000,26124),
(121612,'','Once again, I ask you to take the withered into Falanaar. Teach them to fight, and to search for relics that can aid our cause.',0,0,0,0,0,0,1,0,0,0,0,71001,26124),
(121613,'Spend 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Warpwalking?','Spend 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Warpwalking?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121614,'<Arluin nods to you.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121615,'My eyes and ears are open. I can speak on what I know... for a price.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121616,'Open for business.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121617,'I am always open to a productive working relationship.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121618,'Let\'s say... 800 of that Ancient Mana substance I\'ve been hearing so much about.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121619,'Save your hollow threats, $c. I am defeated and have nothing more for your pathetic \"order.\"','Save your hollow threats, $c. I am defeated and have nothing more for your pathetic \"order.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121620,'You\'ve been to the Dreamgrove? Have you set eyes on Mylune? She graces my dreams.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121621,'Enough... enough...','Enough... enough...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121622,'You. The one they call $ct. So this \"Earthen Ring\" answers to you now, is that right?$b$bWell, we are the Grimtotem! My tribe has been speaking to the elements for a hundred generations. By what right do you claim this sacred space as your own?$b$bThe resources you hoard here are ours as much as anyone\'s. By orders of Elder Crone Magatha, I am taking our share!','You. The one they call $ct. So this \"Earthen Ring\" answers to you now, is that right?$b$bWell, we are the Grimtotem! My tribe has been speaking to the elements for a hundred generations. By what right do you claim this sacred space as your own?$b$bThe resources you hoard here are ours as much as anyone\'s. By orders of Elder Crone Magatha, I am taking our share!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121623,'Challenge accepted, \"$ct.\"','Challenge accepted, \"$ct.\"',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121624,'\"Earthen Ring.\" Bah. More like the \"Dirt Circle.\"','\"Earthen Ring.\" Bah. More like the \"Dirt Circle.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121625,'\"Earthen Ring.\" Hah! More like a... \"Loop of Filth.\"','\"Earthen Ring.\" Hah! More like a... \"Loop of Filth.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121626,'\"Earthen Ring.\" Pah. Ought to be called... the \"Grimy Crescent.\" Or something.','\"Earthen Ring.\" Pah. Ought to be called... the \"Grimy Crescent.\" Or something.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121627,'\"Earthen Ring.\" Pfft! You guys put the \"Sham\" in \"Shaman.\"','\"Earthen Ring.\" Pfft! You guys put the \"Sham\" in \"Shaman.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121628,'\"Earthen Ring.\" As if. More like a... \"Dirty Disk.\" Like a... mudpie. Like a - I don\'t know. You guys are terrible.','\"Earthen Ring.\" As if. More like a... \"Dirty Disk.\" Like a... mudpie. Like a - I don\'t know. You guys are terrible.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121629,'What will your Earthen Ring do after they watch me defeat their precious $ct? Maybe they\'ll give that weapon of yours to Magatha. Hah hah!','What will your Earthen Ring do after they watch me defeat their precious $ct? Maybe they\'ll give that weapon of yours to Magatha. Hah hah!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121630,'\"Earthen Ring.\" Ridiculous! More like a \"Hoop of Fools.\" Hah.','\"Earthen Ring.\" Ridiculous! More like a \"Hoop of Fools.\" Hah.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121631,'\"Earthen Ring.\" Don\'t make me laugh. HAH HAH. Too late. I\'m laughing now. I\'m laughing at your sorry little knitting circle.','\"Earthen Ring.\" Don\'t make me laugh. HAH HAH. Too late. I\'m laughing now. I\'m laughing at your sorry little knitting circle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121632,'Enough... I yield...','Enough... I yield...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121633,'Yes, \"$ct,\" the Grimtotem are here. Or are Grimtotem shaman not welcome in your little club? Leave me be!','Yes, \"$ct,\" the Grimtotem are here. Or are Grimtotem shaman not welcome in your little club? Leave me be!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121634,'The forest whispered of your arrival, $c. It speaks of one who would become a champion of nature, a kindred spirit to these woods.$b$bThere are some who do not show the proper reverence for our sacred grove. You, however, guide their path.','',0,0,0,0,0,0,0,0,0,35351,0,0,26124),
(121635,'Bwah-hah hah HAH! By the look on your face, the only element you\'ve mastered is the element of SURPRISE. Hah!','Bwah-hah hah HAH! By the look on your face, the only element you\'ve mastered is the element of SURPRISE. Hah!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121636,'You have cleared the Dreamway of the Nightmare, but it now infests my precious vale with its corruption.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121637,'','It is... you... I saw you in my slumber, pursued by shadows. I have awoken, only to find those shadows reaching into our world.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121638,'Your people are owed nothing. I challenge you to combat!','Your people are owed nothing. I challenge you to combat!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121643,'<Gain Leyline Mastery for 80 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>','<Gain Leyline Mastery for 80 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121644,'<Gain Leyline Mastery for 70 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>','<Gain Leyline Mastery for 70 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121645,'<Gain Leyline Mastery for 60 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>','<Gain Leyline Mastery for 60 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121646,'<Gain Leyline Mastery for 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>','<Gain Leyline Mastery for 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121647,'<Gain Leyline Mastery for 40 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>','<Gain Leyline Mastery for 40 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121648,'<Gain Leyline Mastery for 30 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>','<Gain Leyline Mastery for 30 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121649,'<Gain Leyline Mastery for 20 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>','<Gain Leyline Mastery for 20 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121650,'<Gain Leyline Mastery for 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>','<Gain Leyline Mastery for 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121651,'Spend 80 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?','Spend 80 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121652,'Spend 70 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?','Spend 70 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121653,'Spend 60 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?','Spend 60 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121654,'Spend 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?','Spend 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121655,'Spend 40 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?','Spend 40 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121656,'Spend 30 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?','Spend 30 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121657,'Spend 20 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?','Spend 20 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121658,'Spend 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?','Spend 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121659,'Ouch.','Ouch.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121660,'Resurrection, please!','Resurrection, please!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121661,'Rebirth, please.','Rebirth, please.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121662,'Are there any more rezzes?','Are there any more rezzes?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121663,'I didn\'t have a soulstone?!','I didn\'t have a soulstone?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121664,'I was not prepared.','I was not prepared.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121665,'How did I die to that?!','How did I die to that?! I was NOWHERE near it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121667,'Come, my minions. Deal with this traitor as he deserves!','',0,0,0,0,0,0,406,0,0,0,11465,0,26124),
(121668,'I will deal with these mongrels! Strike now, friends! Strike at the Betrayer!','',0,0,0,0,0,0,0,0,0,0,11390,0,26124),
(121669,'I be knowin\' Citrine Bay. I be knowin\' it well.','',0,0,0,0,0,0,1,0,0,0,71009,0,26124),
(121670,'I\'ll be off on ahead \'n search fer clues. I\'ll wait fer ye thar!','',0,0,0,0,0,0,1,0,0,0,71010,0,26124),
(121671,'Them ships belong to th\' Red Blade! Thar be no doubt \'bout it...','',0,0,0,0,0,0,0,0,0,0,71011,0,26124),
(121672,'Ye get th\' spiced rum... \'n I\'ll find us some scallywags!','',0,0,0,0,0,0,0,0,0,0,71012,0,26124),
(121673,'These be not th\' Red Blade\'s waters... who sent ye, laddie?','',0,0,0,0,0,0,396,0,0,0,71013,0,26124),
(121674,'Aye, this letter be writ\' in no ordinary code. This here code be t\' work o\' a true master!','',0,0,0,0,0,0,396,0,0,0,71044,0,26124),
(121675,'Tethys \'o th\' Blood Sail Buccaneers!','',0,0,0,0,0,0,397,0,0,0,71014,0,26124),
(121676,'Now I\'ll only ask ye one more the hour... who sent ye?','',0,0,0,0,0,0,396,0,0,0,71015,0,26124),
(121677,'We\'ve got what we be needin\' here. Ye be off to Dalaran, I\'ll catch up!','',0,0,0,0,0,0,396,0,0,0,71016,0,26124),
(121678,'SI:7 be sailin\' wit\' th\' Red Blade? \'tis be not jolly news...','',0,0,0,0,0,0,0,0,0,0,71017,0,26124),
(121679,'Yo-ho! Yo-ho-ho! I likes t\' drink me rum!','',0,0,0,0,0,0,0,0,0,0,71018,0,26124),
(121680,'I... I\'m myself again!! Thank you, Nahlen\'do! May the rage never claim you.','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(121681,'The rage... it no longer claims me! Praise Elune that you found me master of the fang, or as we in the pack say, Nahlen\'do.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(121682,'My mind is still hazy but I remember combat... ah yes... we were battling the satyr when the rage overtook me.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(121683,'My hands! My legs! I\'m... I\'m whole again! Wait... is that the Scythe of Elune? Thank you for releasing me, Nahlen\'do!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(121685,'I have a target for you. Act quickly. This is a serious threat to our resistance.','',0,0,0,0,0,0,0,0,0,0,71036,0,26124),
(121686,'Your quick action has saved many lives. We are in your debt.','',0,0,0,0,0,0,0,0,0,0,71037,0,26124),
(121687,'','There are traitors to the Grand Magistrix hiding right under our noses. We will find them, and we will end this resistance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121688,'','If the citizens will not obey, we will rule by strength and fear. The resistance to the Grand Magistrix is coming to an end!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121689,'Archimonde, you will not be allowed further! The very soul of Azeroth rises against you!','',0,0,0,0,0,0,0,0,6,0,71039,0,26124),
(121690,'The veil is lifted from my eyes, heroes. The shadows retreat, and the Dream beckons.','',0,0,0,0,0,0,0,0,6,0,71040,0,26124),
(121691,'This shipment is worth more than you are! How dare you treat it so carelessly!','',0,0,0,0,0,0,0,0,0,43663,0,0,26124),
(121692,'My hand slipped! Forgive me!','',0,0,0,0,0,0,430,0,0,43663,0,0,26124),
(121693,'','As a feral druid your main weapon is shapeshifting. In Cat Form, your claws and fangs rip and bleed your opponents.',0,0,0,0,0,0,1,0,0,0,0,71041,26124),
(121694,'I remember when the world was simpler. Where one could be a hero just by driving kobolds away from their home.$b$bAnd I remember a time when respect was shown to one\'s elders, a time before this troll outsider and his youthful... trolling.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121695,'I cannot remember what happened after except that I and a few others of my kind awoke and together we traveled as a pack through the Emerald Dream. After some time we arrived in this land and each went our separate ways.','',0,0,0,0,0,0,378,0,0,0,0,0,26124),
(121696,'Dis ol\' bull be mired in his ol\' ways. He be too happy about it. I aim ta\' fix that, mon.$b$bDer be some harsh truths about dis world. Harsh truths that be wipin\' the smile off one\'s face like a slap from one\'s mama.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121697,'Hmm. They say dem waterfalls be too busy, mon. Ya can\'t tell where dey be comin\' from or goin\' to.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121699,'Hmm. Ya know, mon, dey say this place be mighty brown. I know many places greenah\' than this.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(121700,'Hmm. Ya see them trees over there? They be sayin\' them trees too dark, mon. Dark be bad, they say.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(121701,'Hmm. Ya know, mon, I be thinkin\' ya need a change of scenery. Should visit Westfall if ya into browns.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(121702,'The sooner you turn over your allies... the sooner your pain will cease.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121703,'We will find out who resists the Legion in Suramar. Confess, and I will kill you before you lose your mind.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121704,'Please... somebody stop this madness.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121705,'I\'m innocent! I supported the Grand Magistrix!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121706,'I\'ll do anything... just let me go!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121707,'Thank you, heroes.','',0,0,0,0,0,0,0,0,6,0,71043,0,26124),
(121708,'Run while you still can!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121709,'Flee! We\'re saved!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121710,'Now\'s our chance! Run away!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121711,'Nahlen\'do, if you encounter more of my people I beg you, release them from their rage as you did for me.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(121712,'Merciful Elune, the rage is gone! Thank you, Nahlen\'do!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(121713,'Is... is this real? I\'m in control of myself again! Bless you, Nahlen\'do!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(121714,'My mind is free again! I\'m in your debt, Nahlen\'do!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121715,'The curse... it\'s... gone! Thank you, Nahlen\'do!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121716,'The darkness is leaving my mind! I... I\'m whole again! Thank you, Nahlen\'do!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121717,'Welcome, $ct.$b$bThis chamber will house a record of your achievements. As you collect various shamanic armor sets and weapon appearances, they will be displayed here.$b$bWe are all counting on you, $ct!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121718,'Elune bless you.','Elune bless you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121719,'I am rejuvenated. Thank you.','I am rejuvenated. Thank you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121720,'Thank you, Archdruid. We must win this battle!','Thank you, Archdruid. We must win this battle!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121721,'I thought I had returned to the earth. Thank you, Archdruid.','I thought I had returned to the earth. Thank you, Archdruid.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121722,'By Elune\'s grace, I can go on. My thanks, Archdruid.','By Elune\'s grace, I can go on. My thanks, Archdruid.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121723,'I will never forget this, Archdruid. My deepest thanks.','I will never forget this, Archdruid. My deepest thanks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121724,'','Behold, the enemy is among us!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(121725,'','You cannot hide what you truly are, demon!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(121726,'','More of them are in our midst!',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(121727,'Is this it, mortals? Is this all the fury you can muster?','',0,0,0,0,0,0,0,0,30,0,11476,0,26124),
(121728,'I will not be touched by rabble such as you!','',0,0,0,0,0,0,1,0,0,0,11479,0,26124),
(121729,'Behold the Flames of Azzinoth!','',0,0,0,0,0,0,0,0,30,0,11480,0,26124),
(121730,'Stare into the eyes of the Betrayer!','',0,0,0,0,0,0,0,0,0,0,11481,0,26124),
(121731,'Maiev... How is it even possible?','',0,0,0,0,0,0,0,0,30,0,11477,0,26124),
(121732,'You have won... Maiev. But the huntress... is nothing without the hunt. You... are nothing... without me.','',0,0,0,0,0,0,0,0,0,0,11478,0,26124),
(121733,'Behold the power... of the demon within!','',0,0,0,0,0,0,0,0,0,0,11475,0,26124),
(121734,'','You discovered us too late, Illidari! FELBLADE, ATTACK!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(121735,'Hmm.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(121736,'Hmmmmm.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(121737,'|TInterface\\Icons\\Spell_Fire_LavaSpawn:20|t Xioliang is |cFFFF0404|Hspell:224588|h[Heating Up]|h|r! Move him to the pool!','|TInterface\\Icons\\Spell_Fire_LavaSpawn:20|t Xioliang is |cFFFF0404|Hspell:224588|h[Heating Up]|h|r! Move him to the pool!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(121738,'Now is not the time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121739,'You should take care of yourself, $c. These are dangerous times.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121740,'','We must bolster our ranks. Seek out the withered and soothe their rage. I will beckon them to Shal\'Aran.',0,0,0,0,0,0,0,0,0,0,0,71055,26124),
(121741,'','Fine work. I have no doubt that each of them would be proud to help our cause.',0,0,0,0,0,0,0,0,0,0,0,71056,26124),
(121742,'Let\'s keep moving!','Let\'s keep moving!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121743,'ENGAGING IN 5!','ENGAGING IN 5!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121744,'4','4',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121745,'3','3',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121746,'2','2',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121747,'1','1',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121748,'INCOMING!','INCOMING!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121750,'Nice weapon you have there, $n. Speak with Jace and Allari if you\'d like to help.','',0,0,0,0,0,0,0,0,0,40459,52715,0,26124),
(121751,'Archmage Khadgar? $n? An unexpected surprise.','',0,0,0,0,0,0,0,0,0,40459,52717,0,26124),
(121752,'','Thanks again for saving my hide from those sea giants, $n.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121753,'Welcome to my tavern. Sorry for the mess, I am not a morning person...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121754,'It looks like your studies are coming along nicely. Keep up the good work.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121755,'Study your hardest, and someday you\'ll surpass even myself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121756,'Your work will help create a whole new generation of astrologers!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121757,'I\'m ready.','I\'m ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121758,'','Their fury pales before mine, Illidan. We have some unsettled business between us.',0,0,0,0,0,0,0,0,30,0,0,11491,26124),
(121759,'','My long hunt is finally over. Today, justice will be done!',0,0,0,0,0,0,0,0,30,0,0,11492,26124),
(121760,'','It is finished. You are beaten.',0,0,0,0,0,0,0,0,0,0,0,11496,26124),
(121761,'','He\'s right. I feel nothing... I am... nothing.',0,0,0,0,0,0,0,0,0,0,0,11497,26124),
(121762,'','Farewell, champions.',0,0,0,0,0,0,0,0,0,0,0,11498,26124),
(121763,'You need something fixed?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121764,'$n, it is good that you are here. The matron mother has been providing our forces with transport from the Fel Hammer as we attempt to shore up our defenses here.\n\nThe Burning Legion have taken Faronaar across the isthmus. I have a plan to contain and crush them before they overrun all of Azsuna.\n\nI could use your help in leading the Illidari to victory.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121765,'','Hello, $c. I trust that you are here to aid the Illidari in destroying the Burning Legion?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(121766,'','Hello, $n. With you here to lead us, the Legion on Faronaar will fall in short order.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121767,'$g Milord:Milady; $n. We are most grateful that you have come to lead us to victory against the Burning Legion.','',2,0,0,0,0,0,0,0,0,0,0,0,26124),
(121768,'We are in your debt, $c, for aiding in the fight against the Legion.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121769,'We need to get down there, $n. Your Illidari need our help to destroy the Burning Legion.\n\nOnce we\'ve done that, we can get to our business with the Pillar of Creation here on Azsuna.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121770,'While you are leading your Illidari forces in their fight against the demons, I will figure out what our next move is here on Azsuna.\n\nWe must track down that Pillar of Creation. I know it is here somewhere.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121771,'','Thank you for your help over on Faronaar, $n. I am embarrassed that one of our own turned traitor and became one of the Felsworn for the Burning Legion.\n\nWe will make them pay.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121772,'We need them focused on defeating the Legion, not fostering old hatreds.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121773,'','Thank you for saving us over on Faronaar, $n.\n\nI can\'t believe that Cyana turned traitor. She betrayed us all. There are others who have also become Felsworn. We will hunt them down and kill them along with their new Legion masters.\n\nThis I swear!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121774,'My apologies, $n. I was injured when I first came here to scout the Legion forces on Faronaar.\n\nIs there anything else that I can do for you?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121775,'','$n, how goes the fight? Do you need supplies or anything repaired?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(121776,'','$n, the Burning Legion is sending the most powerful demons in its arsenal against us. They do not intend to lose this third war and they will stop at nothing to see to it that we are all wiped from the face of Azeroth.\n\nTogether, we will return the favor.',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(121777,'While your generosity did indeed satisfy before, I must insist.\n\nYou know how it is- the economy is constantly in flux, people are dying in the streets- it\'s only business.\n\nAs much mana as you can carry. That is my going rate.\n\n<Arluin smiles sweetly.>\n\nUnless of course you don\'t WANT my help.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121778,'Offer: 1200x |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t|Hcurrency:1155|h|cFFFFFFFF Ancient Mana|h|r','Offer: 1200x |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t|Hcurrency:1155|h|cFFFFFFFF Ancient Mana|h|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121779,'This action will remove 1200 Ancient Mana. Do you want to continue?','This action will remove 1200 Ancient Mana. Do you want to continue?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121780,'I enjoy practicing a bit of statecraft. You might say I have a knack for it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121781,'Please... please help me...','Please... please help me...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121782,'Those who get on these boats never return... please don\'t let them take me.','Those who get on these boats never return... please don\'t let them take me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121783,'I don\'t want to die, but they kill anyone who runs.','I don\'t want to die, but they kill anyone who runs.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121784,'Don\'t let them take me!','Don\'t let them take me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121785,'They rounded us up like livestock. I do not know where they are sending us, but I know I do not want to go. Please...','They rounded us up like livestock. I do not know where they are sending us, but I know I do not want to go. Please...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121786,'','Well hello, my dear. I hope you don\'t mind. Altruis asked me to help bring some of your forces here.\n\nIt would seem that the Legion has quite the foothold on that island over there. He thought it best that we not let them take all of Azsuna.\n\nDon\'t worry, I\'m transporting the Illidari back and forth from the Fel Hammer as needs require. Your forces are ready to pick up and go wherever you need them at a moment\'s notice.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121787,'','Well hello, my dear. I hope you don\'t mind. Kayn asked me to help bring some of your forces here.\n\nIt would seem that the Legion has quite the foothold on that island over there. He thought it best that we not let them take all of Azsuna.\n\nDon\'t worry, I\'m transporting the Illidari back and forth from the Fel Hammer as needs require. Your forces are ready to pick up and go wherever you need them at a moment\'s notice.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121788,'Arluin beckons you over.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121789,'Over here- I found something.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121790,'My swarm will destroy you!','',0,0,0,0,0,0,0,0,0,0,71090,0,26124),
(121791,'Go to sleep. Forget everything.','',0,0,0,0,0,0,0,0,0,0,71091,0,26124),
(121792,'When do we destroy the world? Soon? I hope it\'s soon.','',0,0,0,0,0,0,0,0,0,0,71107,0,26124),
(121793,'You will all be my slaves! Er, I mean, hi!','',1,0,0,0,0,0,0,0,0,0,71106,0,26124),
(121794,'If you have any excess priceless artifacts that were lost in time, I\'m making a collection.','',1,0,0,0,0,0,0,0,0,0,71105,0,26124),
(121795,'Buh-bye now!','',3,0,0,0,0,0,0,0,0,0,71104,0,26124),
(121796,'A tactical retreat, eh?','',3,0,0,0,0,0,0,0,0,0,71103,0,26124),
(121797,'Kill you later... I mean, bye!','',3,0,0,0,0,0,0,0,0,0,71102,0,26124),
(121798,'What? Stop that!','',0,0,0,0,0,0,0,0,0,0,71101,0,26124),
(121799,'I\'m holding myself back... for now!','',0,0,0,0,0,0,0,0,0,0,71100,0,26124),
(121800,'Don\'t say I didn\'t warn ya!','',0,0,0,0,0,0,0,0,0,0,71099,0,26124),
(121801,'Is this what you usually spend your free time on? Seems like a poor use of your time.','Is this what you usually spend your free time on? Seems like a poor use of your time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121802,'You know this place is actually quite pleasant. We should go burn something.','You know this place is actually quite pleasant. We should go burn something.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121803,'Did you know that on my world imps are tortured for fun? I was quite proficient at it myself.','Did you know that on my world imps are tortured for fun? I was quite proficient at it myself.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121804,'There is a legend that some of our ancestors can be found on this world that are not part of the Legion. I bet they are boring.','There is a legend that some of our ancestors can be found on this world that are not part of the Legion. I bet they are boring.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121805,'Man are my arms getting tired.','Man are my arms getting tired.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121806,'Good, I had been meaning to find you.','Good, I had been meaning to find you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121807,'You know, I knew you needed more orders.','You know, I knew you needed more orders.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121808,'Let\'s see, what can I order you to do today...','Let\'s see, what can I order you to do today...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121809,'Do you see now, human? This fate of this world is sealed. The legion cannot be stopped.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121810,'The Gaze of the Legion is upon you! Flee!','The Gaze of the Legion is upon you! Flee!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121811,'|TInterface\\Icons\\inv_bannerpvp_01.blp:20|t You gain |cFFFF0000|Hspell:224811|h[For the Horde]|h|r!','|TInterface\\Icons\\inv_bannerpvp_01.blp:20|t You gain |cFFFF0000|Hspell:224811|h[For the Horde]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121812,'Uh... $g master:mistress;...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121813,'Is this a prank? Am I being pranked? Very funny, $g master:mistress;!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121814,'<Gain Ward of the First Arcanist for 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>','<Gain Ward of the First Arcanist for 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121815,'Spend 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Ward of the First Arcanist?','Spend 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Ward of the First Arcanist?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121816,'This isn\'t a joke? B... But this is the heart of evil and darkness in the universe! Surely, you can\'t be serious!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121817,'Don\'t think of us as smugglers. Instead, refer to us as professional salvors.\n\nWe are salvage experts. We specialize in flotsam, jetsam, lagan, derelicts, and, of course, exotic archaeological recovery.\n\nOh, and by the way, you might want to steer clear of the temple area to the south. I have my men investigating some salvage opportunities and I wouldn\'t want you to be confused for a competitor.\n\n<Mr. Shackle makes the sign of the Uncrowned, gives you the secret handshake, and then winks.>\n\nStay as long as you like, $g Mister:Miss; $n.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121818,'','We need to keep it contained at all costs!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121819,'','Keep it contained!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121820,'','Focus! It must not be allowed to escape!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121821,'','This land is ours now!',0,0,0,0,0,0,0,0,0,0,0,69152,26124),
(121822,'','No... it cannot be!',0,0,0,0,0,0,0,0,0,0,0,69153,26124),
(121823,'','Crrggghaaawww!',0,0,0,0,0,0,0,0,0,0,0,69154,26124),
(121824,'','The Witchmother commands it!',0,0,0,0,0,0,0,0,0,0,0,69155,26124),
(121825,'','We will not be stopped!',0,0,0,0,0,0,0,0,0,0,0,69156,26124),
(121826,'','Flesh and bone to earth and stone!',0,0,0,0,0,0,0,0,0,0,0,69157,26124),
(121827,'','Flay the flesh and scatter the bones!',0,0,0,0,0,0,0,0,0,0,0,69158,26124),
(121828,'','You cannot... escape... the curse!',0,0,0,0,0,0,0,0,0,0,0,69159,26124),
(121829,'Soon, I will be able to provide Seals of Broken Fate for Gold or Order Resources.  I have none to offer to you at this time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121830,'','Fool! Die!',0,0,0,0,0,0,0,0,0,0,0,69160,26124),
(121831,'','Ahh... curse you!',0,0,0,0,0,0,0,0,0,0,0,69160,26124),
(121832,'','Behold my curse!',0,0,0,0,0,0,0,0,0,0,0,69162,26124),
(121833,'','This land... is.. ours...',0,0,0,0,0,0,0,0,0,0,0,69163,26124),
(121834,'','Squaaak! I\'ll tear you apart!',0,0,0,0,0,0,0,0,0,0,0,69164,26124),
(121835,'','Rip the flesh from its bones!',0,0,0,0,0,0,0,0,0,0,0,69165,26124),
(121836,'','This land... is.. ours...',0,0,0,0,0,0,0,0,0,0,0,69166,26124),
(121837,'','Squaaak! You\'ll regret this!',0,0,0,0,0,0,0,0,0,0,0,69167,26124),
(121838,'','Shred its flesh! Scraaawk!',0,0,0,0,0,0,0,0,0,0,0,69168,26124),
(121839,'','I\'ll enjoy killing you!',0,0,0,0,0,0,0,0,0,0,0,69169,26124),
(121840,'Thank you for your aid, $n. I give you the authority to speak to the demon hunters on my behalf.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121841,'','Scraaawk! Make it bleed!',0,0,0,0,0,0,0,0,0,0,0,69170,26124),
(121842,'','None shall survive!',0,0,0,0,0,0,0,0,0,0,0,69171,26124),
(121843,'','Craaawwkk!',0,0,0,0,0,0,0,0,0,0,0,69171,26124),
(121844,'You already have the maximum number of seals! Use the seals you have before bothering me for more.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121845,'','Sisters! Avenge me...',0,0,0,0,0,0,0,0,0,0,0,69173,26124),
(121846,'','No... Squaaggk!',0,0,0,0,0,0,0,0,0,0,0,69174,26124),
(121847,'','Curses upon you!',0,0,0,0,0,0,0,0,0,0,0,69175,26124),
(121848,'','Coward! You\'ll pay for this...',0,0,0,0,0,0,0,0,0,0,0,69176,26124),
(121849,'','No! NO! Craaawwkk...',0,0,0,0,0,0,0,0,0,0,0,69177,26124),
(121850,'','The village is... ours...',0,0,0,0,0,0,0,0,0,0,0,69178,26124),
(121851,'The Horde isn\'t so bad. Gnomes, on the other hand...','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121852,'Oh, the stories I could tell! Great skirmishes in the forests of Ashenvale, all out chaos in the Northern Foothills, riding with dragons across the skies of Outland, breakfast in Orgrimmar.','',273,0,0,0,0,0,0,0,0,0,0,0,26124),
(121853,'Ever date a Tauren? Don\'t.','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(121854,'The cavalry\'s here.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121855,'Get back to work.','',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(121856,'Ever fight a Yeti with nothing but a Skinning Knife? Don\'t.','',274,0,0,0,0,0,0,0,0,0,0,0,26124),
(121857,'Heard there are some pirates at the Pig and Whistle Tavern. Could be fun.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(121858,'Do you know who the greatest warrior is? I\'ll give you one guess.','',273,0,0,0,0,0,0,0,0,0,0,0,26124),
(121859,'Get him, get him, get him!!!','Get him, get him, get him!!!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121860,'No, not that one. That One!!!','No, not that one. That One!!!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121861,'Daglop shakes his head.','Daglop shakes his head.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121862,'Wow, you are not very good at this.','Wow, you are not very good at this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121863,'Are you trying to get hit?','Are you trying to get hit?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121864,'This is pathetic, my old master, I mean that filthy Eredar demon, he didn\'t even get hit this much.','This is pathetic, my old master, I mean that filthy Eredar demon, he didn\'t even get hit this much.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121865,'As much fun as it is telling you what to do... I will just come back and do it more later.','As much fun as it is telling you what to do... I will just come back and do it more later.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121866,'Never fear, I will have more directions for you later.','Never fear, I will have more directions for you later.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121867,'Do try and be alive when I have need of you next.','Do try and be alive when I have need of you next.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121868,'This contract is binding, I will be back.','This contract is binding, I will be back.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121869,'Some day I will be your master and you will have to listen to me!!','Some day I will be your master and you will have to listen to me!!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121870,'You are not one of my minions? But, sure I can tell you what to do.','You are not one of my minions? But, sure I can tell you what to do.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121871,'Who gave you their contract? I will deal with them later, for now go over there!','Who gave you their contract? I will deal with them later, for now go over there!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121872,'My apologies, $n. Supply shipments are on hold for now.','My apologies, $n. Supply shipments are on hold for now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121873,'You\'ll be hard pressed to find a shop that\'s still open, $n.','You\'ll be hard pressed to find a shop that\'s still open, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121874,'Now is not the time, I\'m afraid.','Now is not the time, I\'m afraid.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121875,'Sorry, $n. My stock isn\'t currently available.','Sorry, $n. My stock isn\'t currently available.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121876,'My apologies, $n. We were ordered to hold our supplies until further notice.','My apologies, $n. We were ordered to hold our supplies until further notice.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121877,'I\'m sorry. I have nothing to offer at the moment.','I\'m sorry. I have nothing to offer at the moment.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121878,'What I wouldn\'t give to get my hands on some new supplies, $n.$B$BIt may be a while. We\'re on strict orders not to buy, sell or trade until things settle down.','What I wouldn\'t give to get my hands on some new supplies, $n.$B$BIt may be a while. We\'re on strict orders not to buy, sell or trade until things settle down.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121879,'Sorry, $n. Come back and see me when things have calmed.','Sorry, $n. Come back and see me when things have calmed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121880,'No need to worry, $n. Training will continue. But for now, we must focus the matters at hand.','No need to worry, $n. Training will continue. But for now, we must focus the matters at hand.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121881,'I\'m afraid I cannot help you right now, $n. We have been asked to remain alert at all times.','I\'m afraid I cannot help you right now, $n. We have been asked to remain alert at all times.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121882,'I do wish I could assist you in your training, but now is not the time, $n. My apologies.','I do wish I could assist you in your training, but now is not the time, $n. My apologies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121883,'Training will resume shortly, $n. You have my word.','Training will resume shortly, $n. You have my word.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121884,'In due time, $n. For now, we must remain vigilant.','In due time, $n. For now, we must remain vigilant.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121885,'Be on your guard, $n. We\'ve been asked to put the safety of our visitors above all else until things settle down.','Be on your guard, $n. We\'ve been asked to put the safety of our visitors above all else until things settle down.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121886,'Grant me a vision of the Walled City of Highmaul.','Grant me a vision of the Walled City of Highmaul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121887,'Grant me a vision of the Arcane Sanctum of Highmaul.','Grant me a vision of the Arcane Sanctum of Highmaul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121888,'Grant me a vision of the Imperator\'s Rise atop Highmaul.','Grant me a vision of the Imperator\'s Rise atop Highmaul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121889,'Grant me a vision of the Blackrock Foundry\'s Black Forge.','Grant me a vision of the Blackrock Foundry\'s Black Forge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121890,'Grant me a vision of the Blackrock Foundry\'s Slagworks.','Grant me a vision of the Blackrock Foundry\'s Slagworks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121891,'Grant me a vision of the Blackrock Foundry\'s Iron Assembly.','Grant me a vision of the Blackrock Foundry\'s Iron Assembly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121892,'Grant me a vision of Blackhand\'s Crucible within the Blackrock Foundry.','Grant me a vision of Blackhand\'s Crucible within the Blackrock Foundry.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121893,'Grant me a vision of the Hellbreach, before the gates of Hellfire Citadel.','Grant me a vision of the Hellbreach, before the gates of Hellfire Citadel.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121894,'Grant me a vision of the Hellfire Citadel\'s Halls of Blood.','Grant me a vision of the Hellfire Citadel\'s Halls of Blood.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121895,'Grant me a vision of the Hellfire Citadel\'s Bastion of Shadows.','Grant me a vision of the Hellfire Citadel\'s Bastion of Shadows.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121896,'Grant me a vision of the Destructor\'s Rise atop Hellfire Citadel.','Grant me a vision of the Destructor\'s Rise atop Hellfire Citadel.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121897,'Grant me a vision of Archimonde\'s fall at the Black Gate.','Grant me a vision of Archimonde\'s fall at the Black Gate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121898,'Soon, you will welcome death with open arms!','',0,0,0,0,0,0,0,0,0,40029,61265,0,26124),
(121899,'Raaarrgh...','',0,0,0,0,0,0,0,0,0,0,61268,0,26124),
(121900,'Master...','',0,0,0,0,0,0,0,0,0,0,61273,0,26124),
(121901,'Pity. You could have joined us...','',0,0,0,0,0,0,0,0,0,40029,61282,0,26124),
(121902,'The dark beyond... awaits me.','',0,0,0,0,0,0,0,0,0,0,61296,0,26124),
(121903,'Madness beckons me beyond...','',0,0,0,0,0,0,0,0,0,0,61302,0,26124),
(121904,'Humor me... scream for help!','',0,0,0,0,0,0,0,0,0,0,61292,0,26124),
(121905,'You do not see, but you will.','',0,0,0,0,0,0,0,0,0,40029,61277,0,26124),
(121906,'I will send you to eternal sleep.','',0,0,0,0,0,0,0,0,0,0,61288,0,26124),
(121907,'It stirs, faceless, forgotten... deathless.','',0,0,0,0,0,0,0,0,0,0,61300,0,26124),
(121908,'You cannot... escape... your dreams....','',0,0,0,0,0,0,0,0,0,40029,61264,0,26124),
(121909,'Your world is... doomed...','',0,0,0,0,0,0,0,0,0,0,61272,0,26124),
(121910,'This land is doomed!','',0,0,0,0,0,0,0,0,0,40029,61275,0,26124),
(121911,'The Nightmare... welcomes me...','',0,0,0,0,0,0,0,0,0,40029,61284,0,26124),
(121912,'My life... for the master...','',0,0,0,0,0,0,0,0,0,0,61295,0,26124),
(121913,'The master will destroy... your soul!','',0,0,0,0,0,0,0,0,0,0,61295,0,26124),
(121914,'Will the night elves mourn you, I wonder?','',0,0,0,0,0,0,0,0,0,40029,61280,0,26124),
(121915,'Give up! There is no hope for this world...','',0,0,0,0,0,0,0,0,0,0,61271,0,26124),
(121916,'Fool... this land is already doomed...','',0,0,0,0,0,0,0,0,0,40029,61286,0,26124),
(121917,'Foolish mortal! You cannot win...','',0,0,0,0,0,0,0,0,0,0,61298,0,26124),
(121918,'Death will not... stop us...','',0,0,0,0,0,0,0,0,0,0,61270,0,26124),
(121919,'Without hope, there can be no despair.','',0,0,0,0,0,0,0,0,0,0,61299,0,26124),
(121920,'Terror is all that awaits... you...','',0,0,0,0,0,0,0,0,0,0,61267,0,26124),
(121921,'Welcome to your nightmare!','',0,0,0,0,0,0,0,0,0,40029,61285,0,26124),
(121922,'Mine are not the only hands... stained in blood...','',0,0,0,0,0,0,0,0,0,0,61269,0,26124),
(121923,'You cannot escape the Nightmare Lord\'s grasp!','',0,0,0,0,0,0,0,0,0,0,61274,0,26124),
(121924,'Your resistance is futile!','',0,0,0,0,0,0,0,0,0,40029,61276,0,26124),
(121925,'Become prey to the darkness!','',0,0,0,0,0,0,0,0,0,0,61287,0,26124),
(121926,'You cannot stop us. We are Legion!','',0,0,0,0,0,0,0,0,0,40029,61279,0,26124),
(121927,'Looking for a fight? Allow me...','',0,0,0,0,0,0,0,0,0,40029,61281,0,26124),
(121928,'Our master will burn this world... and you with it!','',0,0,0,0,0,0,0,0,0,0,61266,0,26124),
(121929,'You would die for this pathetic land?','',0,0,0,0,0,0,0,0,0,40029,61283,0,26124),
(121930,'Your torment will be endless!','',0,0,0,0,0,0,0,0,0,0,61289,0,26124),
(121931,'Nightmare consume you!','',0,0,0,0,0,0,0,0,0,0,61290,0,26124),
(121932,'You cannot stop what is coming. Even in your dreams.','',0,0,0,0,0,0,0,0,0,0,61291,0,26124),
(121933,'If I cannot bend your mind, I will break your body.','',0,0,0,0,0,0,0,0,0,0,61294,0,26124),
(121934,'The abyss whispers your name.','',0,0,0,0,0,0,0,0,0,0,61301,0,26124),
(121935,'You were warned.','',0,0,0,0,0,0,0,0,0,40029,61278,0,26124),
(121936,'Let me show you what happens to heroes.','',0,0,0,0,0,0,0,0,0,0,61293,0,26124),
(121937,'All in good time.','',0,0,0,0,0,0,0,0,0,0,71126,0,26124),
(121938,'What is it you seek?','',0,0,0,0,0,0,0,0,0,0,71127,0,26124),
(121939,'I have missed good conversation.','',0,0,0,0,0,0,0,0,0,0,71128,0,26124),
(121940,'Contemplate the leaves, my friend.','',0,0,0,0,0,0,0,0,0,0,71124,0,26124),
(121941,'The woods protect you.','',0,0,0,0,0,0,0,0,0,0,71125,0,26124),
(121942,'<The wind rider\'s wings flap in anticipation of the coming battle>','<The wind rider\'s wings flap in anticipation of the coming battle>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121943,'It is not my time, but, sadly, it is yours.','',0,0,0,0,0,0,0,0,0,0,71380,0,26124),
(121944,'Forgive me for what I do.','',0,0,0,0,0,0,0,0,0,0,71381,0,26124),
(121945,'I must have more power if we are to win this battle...','',0,0,0,0,0,0,0,0,0,0,71382,0,26124),
(121946,'I require your life energies, my dutiful Moon Guard.','',0,0,0,0,0,0,0,0,0,0,71383,0,26124),
(121947,'Sire, the Legion\'s disruption of our long-range teleportation network has made travel... challenging.','',0,0,0,0,0,0,0,0,0,0,72096,0,26124),
(121948,'Keep a watchful eye, $n... thar be a band \'o pirates yonder!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121949,'','I accept your pledge of loyalty, $n. The Horde endures!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121950,'Indeed it shall.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121951,'Well said!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121952,'We are ready to begin the mission.','We are ready to begin the mission.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121953,'Truthguard...','',0,0,0,0,0,0,0,0,0,43821,0,0,26124),
(121954,'The Silver Hand...','',0,0,0,0,0,0,0,0,0,43823,0,0,26124),
(121955,'You must remain at the Temple Summit!','You must remain at the Temple Summit!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121956,'I, Master Mathias Shaw, hereby authorize The Red Blade to hunt down the rogue agent Amber Kearnen.','',0,0,0,0,0,0,0,0,0,0,71226,0,26124),
(121957,'Bring me her head, and The Red Blade will have full access to Stormwind Bay and a royal pardon for past crimes committed.','',0,0,0,0,0,0,0,0,0,0,71227,0,26124),
(121958,'I\'ll... I\'ll never tell ye!','',0,0,0,0,0,0,0,0,0,0,71246,0,26124),
(121959,'Now that ye mention it... ye does look somewhat familiar.','',0,0,0,0,0,0,0,0,0,0,71247,0,26124),
(121960,'Oh god no! I\'ve heard of you... please don\'t kill me!','',0,0,0,0,0,0,0,0,0,0,71248,0,26124),
(121961,'It was SI:7! They offered us the riches of Stormwind in exchange for Amber Kearnen!','',0,0,0,0,0,0,0,0,0,0,71249,0,26124),
(121962,'While you\'re out there we\'ll try to secure a location closer to the shrine. Elune guide you, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121963,'I think... I just soiled myself! Please... don\'t kill me!','',0,0,0,0,0,0,0,0,0,0,71251,0,26124),
(121964,'You cannot... escape... your dreams....','',0,0,0,0,0,0,0,0,0,40029,71182,0,26124),
(121965,'Soon, you will welcome death with open arms!','',0,0,0,0,0,0,0,0,0,40029,71183,0,26124),
(121966,'Our master will burn this world... and you with it!','',0,0,0,0,0,0,0,0,0,0,71184,0,26124),
(121967,'Terror is all that awaits... you...','',0,0,0,0,0,0,0,0,0,0,71185,0,26124),
(121968,'Raaarrgh...','',0,0,0,0,0,0,0,0,0,0,71186,0,26124),
(121969,'Mine are not the only hands... stained in blood...','',0,0,0,0,0,0,0,0,0,0,71187,0,26124),
(121970,'Death will not... stop us...','',0,0,0,0,0,0,0,0,0,0,71187,0,26124),
(121971,'Give up! There is no hope for this world...','',0,0,0,0,0,0,0,0,0,0,71189,0,26124),
(121972,'Your world is... doomed...','',0,0,0,0,0,0,0,0,0,0,71190,0,26124),
(121973,'','Shhh... keep your voice down! If anyone sees us talking, we\'re dead meat!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(121974,'Master...','',0,0,0,0,0,0,0,0,0,0,71191,0,26124),
(121975,'You cannot escape the Nightmare Lord\'s grasp!','',0,0,0,0,0,0,0,0,0,0,71192,0,26124),
(121976,'This land is doomed!','',0,0,0,0,0,0,0,0,0,40029,71193,0,26124),
(121977,'Noggenfogger sent me. I need to break into the safe.','Noggenfogger sent me. I need to break into the safe.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121978,'Your resistance is futile!','',0,0,0,0,0,0,0,0,0,40029,71194,0,26124),
(121979,'You do not see, but you will.','',0,0,0,0,0,0,0,0,0,40029,71195,0,26124),
(121980,'You were warned.','',0,0,0,0,0,0,0,0,0,40029,71196,0,26124),
(121981,'You cannot stop us. We are Legion!','',0,0,0,0,0,0,0,0,0,40029,71197,0,26124),
(121982,'Will the night elves mourn you, I wonder?','',0,0,0,0,0,0,0,0,0,40029,71198,0,26124),
(121983,'Looking for a fight? Allow me...','',0,0,0,0,0,0,0,0,0,40029,71199,0,26124),
(121984,'Pity. You could have joined us...','',0,0,0,0,0,0,0,0,0,40029,71200,0,26124),
(121985,'You would die for this pathetic land?','',0,0,0,0,0,0,0,0,0,40029,71201,0,26124),
(121986,'The Nightmare... welcomes me...','',0,0,0,0,0,0,0,0,0,40029,71202,0,26124),
(121987,'Welcome to your nightmare!','',0,0,0,0,0,0,0,0,0,40029,71203,0,26124),
(121988,'If you\'re here lookin\' for trouble, I don\'t want any part of it... who am I kidding? Anything would pay better than this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121989,'Fool... this land is already doomed...','',0,0,0,0,0,0,0,0,0,40029,71204,0,26124),
(121990,'Trixyni sent me. I need the key to the safe... she says you \"owe her.\"','Trixyni sent me. I need the key to the safe... she says you \"owe her.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121991,'Become prey to the darkness!','',0,0,0,0,0,0,0,0,0,0,71205,0,26124),
(121992,'','Sorry, $n. With all that\'s going on it looks like I won\'t be cutting hair for a while. Most of the other merchants have closed up their shops too.$B$B<Looks around to the other merchants.>$B$BWord on the street is there\'s something happening, and it ain\'t just around here. The cities themselves are full of... well, I don\'t know and I better not start talking too much. I wouldn\'t want to see anyone else on edge around here. We\'ve got enough of that as is.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(121993,'I will send you to eternal sleep.','',0,0,0,0,0,0,0,0,0,0,71206,0,26124),
(121994,'Your torment will be endless!','',0,0,0,0,0,0,0,0,0,0,71207,0,26124),
(121995,'Nightmare consume you!','',0,0,0,0,0,0,0,0,0,0,71208,0,26124),
(121996,'You cannot stop what is coming. Even in your dreams.','',0,0,0,0,0,0,0,0,0,0,71209,0,26124),
(121997,'Humor me... scream for help!','',0,0,0,0,0,0,0,0,0,0,71210,0,26124),
(121998,'Let me show you what happens to heroes.','',0,0,0,0,0,0,0,0,0,0,71211,0,26124),
(121999,'If I cannot bend your mind, I will break your body.','',0,0,0,0,0,0,0,0,0,0,71212,0,26124),
(122000,'My life... for the master...','',0,0,0,0,0,0,0,0,0,0,71213,0,26124),
(122001,'The dark beyond... awaits me.','',0,0,0,0,0,0,0,0,0,0,71214,0,26124),
(122002,'The master will destroy... your soul!','',0,0,0,0,0,0,0,0,0,0,71215,0,26124),
(122003,'Foolish mortal! You cannot win...','',0,0,0,0,0,0,0,0,0,0,71216,0,26124),
(122004,'Without hope, there can be no despair.','',0,0,0,0,0,0,0,0,0,0,71217,0,26124),
(122005,'It stirs, faceless, forgotten... deathless.','',0,0,0,0,0,0,0,0,0,0,71218,0,26124),
(122006,'The abyss whispers your name.','',0,0,0,0,0,0,0,0,0,0,71219,0,26124),
(122007,'Madness beckons me beyond...','',0,0,0,0,0,0,0,0,0,0,71220,0,26124),
(122008,'','It\'s been awfully quiet since the move. Perhaps they\'re still feeling the effects. Moving all of Dalaran is no easy task!$B$BI do hope things return to normal soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122009,'If ye ask me, there\'s a foulness in the air. E\'er since we arrived here people \'ave been showin\' all kinds of odd behavior. And the Council... they\'ve been meeting quite often. Hopin\' all is well.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122010,'I\'m ready.','I\'m ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122011,'Take care.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122012,'Who dat sneakin\' around?!','',0,0,0,0,0,0,0,0,0,0,71268,0,26124),
(122013,'Somebody sneakin\' around here!','',0,0,0,0,0,0,0,0,0,0,71269,0,26124),
(122014,'What dat noise?','',0,0,0,0,0,0,0,0,0,0,71270,0,26124),
(122015,'My liege! A stranger approaches, wielding a weapon that bears the mark of Queen Azshara herself.','My liege! A stranger approaches, wielding a weapon that bears the mark of Queen Azshara herself.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122016,'Somebody sneakin\' around nearby!','',0,0,0,0,0,0,0,0,0,0,71271,0,26124),
(122017,'Come out where I can sees you! Coward!','',0,0,0,0,0,0,0,0,0,0,71272,0,26124),
(122018,'I know you there.. show yourself!','',0,0,0,0,0,0,0,0,0,0,71273,0,26124),
(122019,'Somebody is skulking around!','',0,0,0,0,0,0,0,0,0,0,71274,0,26124),
(122020,'There you is! Now you gunna get it!!','',0,0,0,0,0,0,0,0,0,0,71275,0,26124),
(122021,'I found you! Now you gunna die!','',0,0,0,0,0,0,0,0,0,0,71276,0,26124),
(122022,'I gunna beat you to a pulp!','',0,0,0,0,0,0,0,0,0,0,71277,0,26124),
(122023,'You sneakin\' around makes me so ANGRY!','',0,0,0,0,0,0,0,0,0,0,71278,0,26124),
(122024,'','That scepter is not yours, shaman. Give it back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122025,'You not supposed to be here!','',0,0,0,0,0,0,0,0,0,0,71279,0,26124),
(122026,'We gots an intruder!','',0,0,0,0,0,0,0,0,0,0,71280,0,26124),
(122027,'','That scepter belongs to our Queen...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122028,'You gunna pay for sneakin\' around!','',0,0,0,0,0,0,0,0,0,0,71281,0,26124),
(122029,'','How dare you claim our beloved Queen\'s scepter as your own...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122030,'','Not yours... that scepter is not yours...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122031,'','Please, Death Knight. Do not defile this sacred place with that wicked axe you wield. I can feel its hunger from here.',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(122032,'','We are all that stands between the legion and annihilation.',0,0,0,0,0,0,0,0,0,0,0,71285,26124),
(122033,'This is going to be a heist of a lifetime!','',0,0,0,0,0,0,1,0,0,0,71286,0,26124),
(122034,'We\'ll have love-struck schlubs throwin\' their money at us in no time!','',0,0,0,0,0,0,0,0,0,0,71287,0,26124),
(122035,'','Every time we blink I have to spend days rearranging my collection. I wish there was an easier way to clean this mess up.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122036,'','Lord Illidan knows the way.',0,0,0,0,0,0,0,0,0,0,0,71288,26124),
(122037,'','Hit up Izak the bartender, he should know how to get the key to the safe.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122038,'','If he won\'t talk, just remind him that he owes me one for \'the you know what\' in \'the you know where\'... got it?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122039,'','Azeroth must not fall.',0,0,0,0,0,0,0,0,0,0,0,71291,26124),
(122040,'','Those blades you carry... they are cursed. Please, do not bring the chill of death to this sacred place!',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(122041,'Death to the Legion.','',0,0,0,0,0,0,0,0,0,0,71292,0,26124),
(122042,'Today is your lucky day, friend! Even as we speak, Gallywix is enjoying a relaxing stop in his personal sauna.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122043,'If you sneak into the sauna, you can grab the key while he isn\'t wearing it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122044,'No text','',0,0,0,0,0,0,0,0,0,0,12209,0,26124),
(122045,'Listen, up mooks! The pleasure palace is OFF LIMITS! I don\'t want ANYBODY setting foot on my property!','',0,0,0,0,0,0,0,0,0,0,71294,0,26124),
(122046,'Placeholder text.','',0,0,0,0,0,0,0,0,0,0,21450,0,26124),
(122047,'That axe you carry... it is a Legion weapon. Are you certain you can control its hunger?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122048,'Now, I\'m going to hit the sauna for some R&R... so bring me a frozen cocktail and some cocoa butter!','',0,0,0,0,0,0,0,0,0,0,71296,0,26124),
(122049,'Mooks! Where\'s my cocoa butter?! What part of COCOA and BUTTER did you not get?!','',0,0,0,0,0,0,0,0,0,0,71297,0,26124),
(122050,'All right! I\'m ready to bust some skulls!','',0,0,0,0,0,0,0,0,0,0,71303,0,26124),
(122051,'Whew... it\'s gettin\' hot in here. I think it\'s time for a relaxing nap...','',0,0,0,0,0,0,0,0,0,0,71299,0,26124),
(122052,'Wait a minute.. one of my keys is... SOMEBODY STOLE THE KEY TO MY SAFE!','',0,0,0,0,0,0,0,0,0,0,71300,0,26124),
(122053,'Whoever did this is gonna pay! Mooks! Find them! FIND THEM!','',0,0,0,0,0,0,0,0,0,0,71301,0,26124),
(122054,'','Is that... the Maw of the Damned? Turning one of the Legion\'s weapons against their own, are we? I like the way you think, $n!',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(122055,'What is this blasphemy, $n? How dare you reforge that cursed blade, the very sword that damned Lordaeron and its prince? I warned Arthas not to touch Frostmourne, and now I\'m warning you: cast those things into the sea before they damn us all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122056,'','So the rumors around Undercity are true - Frostmourne has been reforged! You watch yourself $n. Those blades may have a mind of their own.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122057,'An aura of disease and pestilence surround the blade you carry, Death Knight. Keep your distance from Senegos.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122058,'','That demonic blade you carry - it reeks of corruption, Death Knight. Finish your business here and take that blade far away from this sacred temple.',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(122059,'','Ugggh - that blade - what is that you carry? Disease and rot surround you, Death Knight!',0,0,0,0,0,0,35,0,0,0,0,0,26124),
(122060,'','Do you feel it too? My skin is crawling...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122061,'Do you know what is happening?','Do you know what is happening?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122062,'','Ahhh!',0,0,0,0,0,0,430,0,0,0,0,0,26124),
(122063,'','It would be wise to refrain from make this inn your home for the time being. We may not be this exact location the next time you try to return.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122064,'Hmm... Got nothing, $n. All shipments on hold until further notice.$B$BEntire place is ruined. Blinking a city... Who said that was a good idea? It will take weeks to get this place back on its feet.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122065,'Pardon the mess. We\'ve been cleaning up for a while now.$B$B<Peers around his shop>. Though it doesn\'t seem to help much. This place looks like a gust of wind blew right through here. And my goods are damaged. Who will want them now?$B$BThe next time we decide to move the city I\'ll be strapping everything down ahead of time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122066,'','Oh, I didn\'t see you there!$B$BWe\'ve been so busy cleaning up. Come and see us once we\'re back on our feet.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122067,'','All these papers. How did we e\'er keep track of \'em? Now they\'re just scattered all o\'er the place.$B$BIt\'ll take weeks fer me ta get \'em all sorted again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122068,'','You\'ll have to excuse me. These bouts of dizziness catch me off guard every so often. They started shortly after our arrival.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122069,'Welcome to the shop, $n. Pardon the mess. We\'re in the process of cleaning up.$B$BThat last blink really did a number on us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122070,'Why is this cocoa butter so slippery? GET ME A TOWEL! Whoever bought the slippery cocoa butter is FIRED!','',0,0,0,0,0,0,0,0,0,0,71309,0,26124),
(122071,'','Say the word and I shall reveal the hidden menace!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122072,'','By the Light... what could it mean?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122073,'','Turalyon and Alleria... I cannot believe they\'ve been alive all these years...',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122074,'I would not have believed it if I hadn\'t seen it with my own eyes.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122075,'Arator is right. Turalyon and Alleria went to great lengths to send us this warning. Highlord, we look to you. What should we do?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122076,'','I have heard much of these two heroes. There is little doubt in my mind that their message is of the utmost importance.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122077,'Mother... Father...','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122078,'The Beacon was silent for time, no aid did it ask for. It is good that you restored it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122079,'Of all its users, the draenei have wielded the Beacon the best. It is hoped the draenei survive where the others have not.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122080,'Your staff, like Velen\'s crystal, is a gift we bestow on those we try to save from destruction. So few remain, do not let it fall to the Void.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122081,'Welcome aboard, $n. \n\nWe\'re all stocked and ready to ship out just as soon as you\'re ready.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122082,'Use the Beacon often, the power of the Light is unending and will always be given.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122083,'$n! I see you\'ve reclaimed the blades of Varedis Felsoul. Let us hope you have better control over the demon within you.','$n! I see you\'ve reclaimed the blades of Varedis Felsoul. Let us hope you have better control over the demon within you.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122084,'','I\'ve gotten far more kills than you, Nathanos. You\'re slipping!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122085,'Jace Darkweaver spoke the truth. You carry the Aldrachi Warblades, $n! With you at the head of our order, the Illidari will be unstoppable.','Jace Darkweaver spoke the truth. You carry the Aldrachi Warblades, $n! With you at the head of our order, the Illidari will be unstoppable.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122086,'I\'m your champion, Dark Lady. It\'s my job to make you look good.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122087,'','A champion at making excuses, it would seem!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122088,'<mutters>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122089,'','What have you done to yourself, $n? You\'re more demon than $r.',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(122090,'','I hope you can retain control of your... abilities... in this sacred place, \"Demon Hunter.\" We will be watching you.',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(122091,'Are you one of them, $n? Or one of us? So much demonic energy...','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(122092,'','A demon hunter! Perfect, you\'re just what I need.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122093,'Pull up a resting stone, brul. Navarrogg says you allowed to rest here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122094,'I wish to recruit Val\'kyr.','I wish to recruit Val\'kyr.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122095,'I wish to recruit shieldmaidens.','I wish to recruit shieldmaidens.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122096,'It\'s good to see you again, $n. I trust that you are well?\n\n<Mathias looks around and then says the rest in hushed tones.>\n\nHow go the affairs of the Uncrowned? As head of SI:7, I cannot publicly support you.\n\nBut, until the war against the Burning Legion has come to an end, I pledge my full support, even if it has to be conducted in secret.\n\nUntil we meet again.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122097,'','You weren\'t lying, Elias. The Demon Hunters are on the loose. Be careful - with those eyes, $n sees everything.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122098,'A Demon Hunter? Disgusting! Your wings are so leathery and creepy.','A Demon Hunter? Ugh - your wings are so leathery and creepy.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122099,'Come, traveler. Join us.$b$bLet our hearth be your hearth.$b$bStay here. Join us.$b$bJoin us...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122100,'What? Oh, I didn\'t even know ye were there! Since when did all ye $cs get ta be so sneaky?$B$BNeedin\' ta know if we\'ll be leaving soon so I can ready my things.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122102,'Who shall be next to taste my blades?','',0,0,0,0,0,0,0,0,30,0,11473,0,26124),
(122103,'','Welcome, outsider.$b$bYour kind do not often find their way this high up the mountain, but you are welcome here all the same.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122104,'','The drogbar attacks have left my family with little to offer, but what we have is yours, hero.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122105,'I make posts when I feel things.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122106,'I will return when I can meet your price, Arluin.','I will return when I can meet your price, Arluin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122107,'[PH] And then a killer finale cinematic plays! [PH]','[PH] And then a rad finale cinematic plays! [PH]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122108,'My mind... withering... need... help.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122109,'Something feels different here. The air is fine, but there\'s an odd feeling about.$B$BEvery since we arrived people have been acting strange. And I don\'t mean the dizzy heads still recovering from our trip, but more in the way people carry themselves and the occasional whispers floating about.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122110,'<Feed Leyweaver Ke\'lorin 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>','<Feed Leyweaver Ke\'lorin 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122111,'This action costs 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?','This action costs 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122112,'Best get to Grommash Hold straightaway, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122113,'','Even the most dedicated of craftsman need a break from time to time. Pull up a sleeping fur and rest next to the safety of my hearth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122114,'','Suffer well, $n. We will be ready when you have need of us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122115,'Say the word and I shall reveal the enemy!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122116,'Thank you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122117,'Yes? What is it?$B$BPardon my being short, but there were countless times I asked to be notified prior to us deciding to move the entire city. Now look at my shop... things are everywhere! Ildine and Vanessa will be busy for months!$B$BNow if you\'ll excuse me, I must finish these enchantments before we up and decide to move yet again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122118,'','Oh hiya, toots. You need anything, or ya want me to have someone get ya something.\n\nOr, ya know, if ya just want to talk, Nikki\'s here for ya.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122119,'It\'s a long way down, friend. \n\nNeed a hand?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122120,'My wife left me for a flounder.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122122,'This jerkin ain\'t free!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122123,'Has anyone seen Stanky? I\'m starting to worry.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122125,'Jerk to the right! Now jerk to the left!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122126,'Things can\'t get worse. Can they?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122127,'What\'s that smell?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122128,'Has anyone seen my brother Daryl?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122129,'Get your warm beer and cold sausages! Ask for Skidmark and tell him Joe sent ya!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122130,'Sewer sharks? Nasty creatures, I\'ve seen \'em only once before!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122131,'M... Master, I am dying...','M... Master, I am dying...',0,0,0,0,0,0,0,0,0,0,71364,71365,26124),
(122132,'Power wanes...','Power wanes...',0,0,0,0,0,0,0,0,0,0,71366,71367,26124),
(122133,'Can\'t move... powerless...','Can\'t move... powerless...',0,0,0,0,0,0,0,0,0,0,71368,71369,26124),
(122134,'You can\'t do this, Illidan.','You can\'t do this, Illidan.',0,0,0,0,0,0,0,0,0,0,71370,71371,26124),
(122135,'Stop! You\'re killing us!','Stop! You\'re killing us!',0,0,0,0,0,0,0,0,0,0,71372,71373,26124),
(122136,'I can help you procure some valuable items.','I can help you procure some valuable items.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122137,'Place work order for Champion armaments.','Place work order for Champion armaments.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122138,'My chains will shackle you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122139,'You\'re a monster, Illidan!','You\'re a monster, Illidan!',0,0,0,0,0,0,0,0,0,0,72098,72323,26124),
(122140,'You won\'t kill me without a fight!','You won\'t kill me without a fight!',0,0,0,0,0,0,0,0,0,0,71337,71338,26124),
(122141,'Rooksguard, send these devils back to their dark masters! For Azshara! For Kalimdor!','',0,0,0,0,0,0,0,0,0,0,72099,0,26124),
(122142,'You are my captain no more, Illidan! DIE!','You are my captain no more, Illidan! DIE!',0,0,0,0,0,0,0,0,0,0,71341,71342,26124),
(122143,'You have betrayed us all!','You have betrayed us all!',0,0,0,0,0,0,0,0,0,0,71343,71344,26124),
(122144,'You want my mana? Then come! Take it if you dare!','You want my mana? Then come! Take it if you dare!',0,0,0,0,0,0,0,0,0,0,71345,71346,26124),
(122145,'You are no better than the demons that descend upon us!','You are no better than the demons that descend upon us!',0,0,0,0,0,0,0,0,0,0,71347,71348,26124),
(122146,'BETRAYER!','BETRAYER!',0,0,0,0,0,0,0,0,0,0,71349,71350,26124),
(122147,'You\'ll burn for this, Illidan!','You\'ll burn for this, Illidan!',0,0,0,0,0,0,0,0,0,0,71351,71352,26124),
(122148,'You want my magic? Here, have a taste!','You want my magic? Here, have a taste!',0,0,0,0,0,0,0,0,0,0,71353,71354,26124),
(122149,'I do what must be done!','',0,0,0,0,0,0,0,0,0,0,71355,0,26124),
(122150,'You serve a greater purpose now, my faithful acolyte!','',0,0,0,0,0,0,0,0,0,0,71356,0,26124),
(122151,'Look around you! This is the only way!','',0,0,0,0,0,0,0,0,0,0,71357,0,26124),
(122152,'You should be thankful that you were given this opportunity to serve!','',0,0,0,0,0,0,0,0,0,0,71358,0,26124),
(122153,'Some of you must die if our world is to survive!','',0,0,0,0,0,0,0,0,0,0,71359,0,26124),
(122154,'I am above your judgment! What I do, I do for Azeroth!','',0,0,0,0,0,0,0,0,0,0,71360,0,26124),
(122155,'The threat of the Legion costs lives. Your lives!','',0,0,0,0,0,0,0,0,0,0,71361,0,26124),
(122156,'I will make certain that your family is cared for, friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122157,'Can you not see the sacrifices I make to ensure our survival?!','',0,0,0,0,0,0,0,0,0,0,71363,0,26124),
(122158,'Illidan... Why?','Illidan... Why?',0,0,0,0,0,0,0,0,0,0,71374,71375,26124),
(122159,'Mother Moon take me!','Mother Moon take me!',0,0,0,0,0,0,0,0,0,0,71376,71377,26124),
(122160,'You walk down a dark path, Illidan. There\'s no turning back from this...','You walk down a dark path, Illidan. There\'s no turning back from this...',0,0,0,0,0,0,0,0,0,0,71378,71379,26124),
(122161,'I did not ask for this burden, but it is what fate has deemed...','',0,0,0,0,0,0,0,0,0,0,71384,0,26124),
(122162,'Your life energies will give our world a fighting chance, acolyte.','',0,0,0,0,0,0,0,0,0,0,71385,0,26124),
(122163,'If only there were another way, but I must have power if we are to survive.','',0,0,0,0,0,0,0,0,0,0,71386,0,26124),
(122164,'Thank you for this sacrifice. Your death will not be in vain.','',0,0,0,0,0,0,0,0,0,0,71387,0,26124),
(122165,'You must die, so that I may live! I have a destiny to fulfill! A world to save!','',0,0,0,0,0,0,0,0,0,0,72100,0,26124),
(122166,'I will be the conduit for Azeroth\'s retribution!','',0,0,0,0,0,0,0,0,0,0,72101,0,26124),
(122167,'Your life energies amplify my own! I am unstoppable!','',0,0,0,0,0,0,0,0,0,0,72102,0,26124),
(122168,'The Legion will tremble before me! All will tremble before me!','',0,0,0,0,0,0,0,0,0,0,72103,0,26124),
(122169,'I found one! Tighten up defense in this area at once.','',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(122170,'We will gladly accept your help, Delas. The Light is strongest when it shines together.','',0,0,0,0,0,0,396,0,0,0,71391,0,26124),
(122171,'','Help... please. My thoughts... are slowing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122172,'<Feed Tempomancer Virinya 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>','<Feed Tempomancer Virinya 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122173,'The Uncrowned must strive to undermine the Burning Legion in all the ways we do it best: artifice, guile, deception, and of course, politics.\n\nUntil the Legion is defeated, our continued cooperation is my highest priority, $n. I trust that it is yours as well.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122174,'Put on the Stylish Spy Glasses to locate the blood trail!','Put on the Stylish Spy Glasses to locate the blood trail!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(122175,'Place a work order for a Seal of Broken Fate.','Place a work order for a Seal of Broken Fate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122176,'My flame... falters. I am not long for this world...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122177,'<Feed Flameweaver Ovin 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>','<Feed Flameweaver Ovin 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122178,'The Ascended cannot be commanded, only unleashed.','The Ascended cannot be commanded, only unleashed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122179,'Recruit Ascendants','Recruit Ascendants',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122180,'','I became a priestess to help others, but lately I have been wondering if I can do more.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122181,'The manasaber purrs warmly and beckons you closer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122182,'Specialist, huh? I\'ve been trapped here for hours!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122183,'Hey! Slow it down a little! I\'d like to keep my legs intact if that\'s possib... wait a minute! If I\'m here, then where\'s the rest of me!?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122184,'Oh, look. Another bystander. Suuure... enjoy the show. Everybody come look at the poor gnome. When I get down from here...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122185,'Yes, but just make sure to protect me if any demons show up! I\'m not really able to defend myself, if you know what I mean.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122186,'I never noticed before, but the stones on the floor here are very well taken care of.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122187,'What do you mean, \'might have to wait until we blink again\'? I can\'t stay here! I have things to do!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122188,'What was that? Stop it! Someone\'s poking me on the other end!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122189,'','We are ready to begin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122190,'Empower the Focusing Crystal','Empower the Focusing Crystal',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122191,'','Vanthir felt we would be safer here. After what happened to my dear Korine, I am inclined to agree.\n\nIt is a hard life the Nightfallen lead, but we will endure.\n\nThank you again for saving my daughter.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122192,'Well, we could wait until we move again. Who knows? The problem might fix itself!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122193,'Speak the vows at the altar when you are ready.','Speak the vows at the altar when you are ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122194,'If we rotate clockwise a bit, then... no. Maybe it was counter clockwise...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122195,'Don\'t worry, we\'ll have you out in a zip there... you. Why do I keep talking to this thing?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122196,'I need a little more time to think. These are pretty unique circumstances. It\'s not the kind of job you can do... half way.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122197,'Nothing I can find about this particular situation. Just hang tight! We\'ll figure something out.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122198,'It\'s a good thing the fish tank was emptied before we left. That would have been a whole other issue!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122200,'<The manasaber looks at you like you might have something it wants to eat.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122201,'<Feed the manasaber 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>','<Feed the manasaber 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122202,'','Here, in the presence of eternal champions, I take this sacred oath:',0,0,0,0,0,0,0,0,0,0,0,71404,26124),
(122204,'','I pledge my life to the Order of the Silver Hand,',0,0,0,0,0,0,0,0,0,0,0,71406,26124),
(122205,'','And join my brothers and sisters in humble service.',0,0,0,0,0,0,0,0,0,0,0,71407,26124),
(122206,'','With this vow, I am reborn,',0,0,0,0,0,0,0,0,0,0,0,71408,26124),
(122207,'','A warrior of Light.',0,0,0,0,0,0,0,0,0,0,0,71409,26124),
(122208,'','The shield of man, the hand of devotion, and the sword of retribution.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122209,'','To protect the weak, uphold justice, and walk the righteous path.',0,0,0,0,0,0,0,0,0,0,0,71410,26124),
(122210,'','This place is a mess!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122211,'','Almost all accounted for! Who would have thought moving Dalaran would cause such problems? One more pen, the birds and then everything will be back to normal!$B$B<Looking around the room>.$B$BExcept for that poor fellow over in the fish tank. I hope they can resolve that soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122212,'Only half my cheese made it! Half!$B$BHow are we to run a wine and cheese shop with an abundance of wine and only mere crumbles of delicious cheese? This is outrageous! It\'s preposterous! And...$B$BOh, my! Now I\'m feeling faint. What is this world coming to?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122213,'','Oh, don\'t mind him. He\'s quite forgetful. All of the aged goods were stored well before our departure.$B$BBe sure to come visit us when the shop\'s up and running again! I\'m sure we\'ll reach our final destination soon enough!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122214,'','Quite a few people have come by seeking relief from the side effects.$B$BIf I could just find those old recipes... I know they\'re here somewhere!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122215,'Dorothy\'s inside if you need her, but if you\'re looking for supplies we won\'t be able to fill any orders for the time being. My apologies.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122216,'But we may also be experiencing a minor case of total system failure.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122217,'I need you to press the big red button labeled \"DO NOT PUSH THIS BUTTON\".','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122218,'The next time someone tells you they\'re going to move a city using magic, you better be ready for anything! And I mean ANYTHING!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122219,'The box flares brightly.','The box flares brightly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122220,'The box starts emitting a series of pleasant chime sounds.','The box starts emitting a series of pleasant chime sounds.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122221,'The melody of chimes increases in volume.','The melody of chimes increases in volume.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122222,'The box flares once again. One more sequence and it will be fully activated!','The box flares once again. One more sequence and it will be fully activated!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122223,'If you have not yet learned to fly here in Pandaria, feel free to borrow Graddoc here for a flight into the Vale.','',0,0,0,0,0,0,3,0,0,44020,0,0,26124),
(122224,'I... am already so weak...','I... am already so weak...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122225,'I can\'t go on...','I can\'t go on...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122226,'The horror... the horror.','The horror... the horror.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122227,'I... I think I can make it. Thank you.','I... I think I can make it. Thank you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122228,'Free... finally free. How do I get out of here?','Free... finally free. How do I get out of here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122229,'Please... kill every last one of these monsters.','Please... kill every last one of these monsters.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122230,'|TInterface\\Icons\\spell_deathknight_necroticplague.blp:20|t You are afflicted with |cFFF00000|Hspell:206480|h[Carrion Plague]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(122231,'Your command?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122232,'Send out the Call for the Vanguard','Send out the Call for the Vanguard',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122235,'What?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122236,'Place a work order for Champion armaments.','Place a work order for Champion armaments.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122237,'Luniel... sweetest Luniel... how could I let this happen to you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122238,'','What do you need?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122239,'Begin the Call','Begin the Call',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122240,'How can I be of service?','How can I be of service?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122241,'Place a work order for Champion armaments.','Place a work order for Champion armaments.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122243,'','Yes?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122244,'Begin charging the Hammer','Begin charging the Hammer',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122246,'','Is it time?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122247,'Begin the Ritual','Begin the Ritual',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122248,'I\'ve got to finish these samples, $n! The last batch was so unstable they nearly killed us all during the move!$B$BDon\'t tell anyone that last part.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122249,'I will hear what this demon hunter has to say.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122250,'They killed her... those withered killed my Luniel. I... I have nothing left.','',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(122251,'','May the Light bless you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122252,'Place a work order for Champion armaments','Place a work order for Champion armaments',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122253,'<Feed Llorian 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>','<Feed Llorian 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122254,'What you need, little $n?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122255,'Th... thank you... I... I don\'t know how to go on... I\'ve lost so much.','',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(122256,'Let\'s see what you have.','Let\'s see what you have.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122257,'Wait... do you hear that?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122258,'The withered! They\'re upon us. Please, help me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122259,'Bring me yer dead, Ill find a use for \'em.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122260,'Place a work order for Champion armaments','Place a work order for Champion armaments',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122261,'','Sorry, $n, but we were asked not to take on any new trainees for a while. Once we reach our final destination I\'m sure things will return to normal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122262,'Look at this mess! All of our things thrown about! Books on the floor, tools everywhere... I really wish we had a bit more warning before the entire city moved!$B$BAnd look at Dorian over there. Poor guy is still recovering.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122263,'','Welcome to The Gnarled Branch, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122264,'Let\'s see what you have.','Let\'s see what you have.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122265,'If you like your shoes, you may want to step back a bit.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122266,'I owe you my life twice over... I don\'t have much, but look through my supplies and take anything you need.','',0,0,0,0,0,0,16,0,0,0,0,0,26124),
(122268,'So, it is none other than Odyn\'s champion!','',0,0,0,0,0,0,1,0,0,0,71454,0,26124),
(122269,'I have heard tales of your exploits. Let us see if they are more than tales, shall we?','',0,0,0,0,0,0,1,0,0,0,71455,0,26124),
(122270,'The Frost Wyrm desires to be unleashed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122271,'Begin the ritual','Begin the ritual',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122272,'Over here, friend $c! This one has shinies to offer. Take a look!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122273,'<rustling of leaves>','<rustling of leaves>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122274,'Recruit an Ancient of War','Recruit an Ancient of War',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122275,'Odyn\'s glory be with you, Valarjar.','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(122276,'How may I help you, $n?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122277,'Let\'s see what you have.','Let\'s see what you have.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122278,'Hi!','Hi!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122279,'Recruit an Echo of a Celestial','Recruit an Echo of a Celestial',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122280,'These ghouls are ready to do your bidding, Deathlord.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122281,'Forgive the deception, $n. I would not interfere with the trials, even for my chosen champion!','',0,0,0,0,0,0,1,0,0,0,71468,0,26124),
(122282,'I have some items you may find useful, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122283,'Let\'s see what you have.','Let\'s see what you have.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122285,'Back in my day, these trees were greener.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122286,'Oh my! How things have changed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122287,'If Toryl says you are here to help us, then you may rest at our hearth. Share in our meat and mead!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122288,'','How could they believe the Herald\'s lies? There\'s dark magic at play here - mark my words.\n\nPlease, if you can do anything to stop this, do it now. So many innocent lives lost...',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(122289,'','Squires aren\'t normally so quick to train, but I put a rush on this order for ya.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122290,'Hmm... no special sheep today? Curses! Better luck tomorrow, eh?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(122291,'Let\'s see what you have.','Let\'s see what you have.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122292,'','Welcome, $n. May the celestials watch over you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122293,'May the elements serve you well.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122294,'Success!','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(122295,'Welcome, $n. I have some things that you may find useful.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122296,'Let\'s see what you have.','Let\'s see what you have.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122297,'','You will get no further than us, Lady Keletress!',0,0,0,0,0,0,603,0,0,0,0,71476,26124),
(122298,'','Hiya, $n! How can I help you today?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122299,'Let\'s see what you have.','Let\'s see what you have.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122301,'Let\'s see what you have.','Let\'s see what you have.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122302,'Whatever you do, don\'t eat the fruit in the bowls.$b$bThat stuff is terrible quality. If you want to taste the finest Suramar has to offer, allow me to show you true flavors.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122303,'Don\'t *hic* interrupt!  We need the Nightwell\'s power...','Don\'t *hic* interrupt!  We need the Nightwell\'s power...',0,0,0,0,0,0,462,0,0,0,0,0,26124),
(122304,'','Your flame burns bright today, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122305,'What do you have for sale?','What do you have for sale?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122306,'What do you have for sale?','What do you have for sale?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122307,'','Gold brightens up even a dark place like this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122308,'Hail, $n. I have some things that you may find useful.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122309,'Let\'s see what you have.','Let\'s see what you have.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122310,'Everyone please step back! This is just another side effect of moving the city. Business will resume shortly!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122311,'People! People! Please... As odd as it may seem, we have things under control. We\'ve acquired extra guards to ensure nothing goes missing.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122312,'Yes, yes. We know what it looks like. All of your entrusted belongings will be here when business returns to normal. You have my word.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122313,'There\'s absolutely nothing to worry about. Mere side effects of moving a massive, magical city.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122314,'Our staff is working around the clock to ensure your belongings remain safe! There\'s absolutely nothing to fear.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122315,'Please do return in a few days time. We do value your business...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122316,'I failed my kingdom and my people... I will not fail our world as well.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122317,'','And rise, reborn, as the shield of man, the hand of devotion, and the sword of retribution.',0,0,0,0,0,0,0,0,0,0,0,71489,26124),
(122318,'Nooooo... yes, actually.','',0,0,0,0,0,0,275,0,0,0,71492,0,26124),
(122319,'Outlook is certain. Certain death!','',0,0,0,0,0,0,22,0,0,0,71493,0,26124),
(122320,'Defeat is assured.','',0,0,0,0,0,0,18,0,0,0,71494,0,26124),
(122321,'Reply... hazy... Try again?','',0,0,0,0,0,0,6,0,0,0,71495,0,26124),
(122322,'You will likely survive. Most likely.','',0,0,0,0,0,0,1,0,0,0,71496,0,26124),
(122323,'Let me confer with my sources... no.','',0,0,0,0,0,0,24,0,0,0,71497,0,26124),
(122324,'Let me confer with my sources... yes.','',0,0,0,0,0,0,273,0,0,0,71498,0,26124),
(122325,'Not likely... in this timeline.','',0,0,0,0,0,0,539,0,0,0,71499,0,26124),
(122326,'Outlook unclear, gather 4289 more apexis crystals and ask again.','',0,0,0,0,0,0,94,0,0,0,71500,0,26124),
(122327,'Your sound card works perfectly.','',0,0,0,0,0,0,401,0,0,0,71501,0,26124),
(122328,'Thank you for rescuing me from that terrible place.$b$bI am quite handy with restoring equipment. Do you need any repairs done?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122329,'I... I thank you. They were beginning to sound hungry...','I... I thank you. They were beginning to sound hungry...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122330,'I will make my way to safety. They will not catch me again!','I will make my way to safety. They will not catch me again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122332,'','Ready for a rematch, $n? Anytime, anywhere.',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(122333,'We are well aware of the situation and everything is under control!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122334,'This is absolutely normal. Please do not be alarmed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122335,'We should have this resolved shortly! Please bear with us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122336,'Please remind Gee that I will be requiring additional pay. I\'m technically still behind the counter.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122337,'Everything is fine! Go about your business as usual. We have everything under control!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122338,'Ah, another valued customer! Welcome! Welcome!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122339,'Gee!... Gee!... Would you please remind Teller Gee that I\'m still here, waiting patiently to be returned to my normal state. Thank you kindly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122340,'You face Jaraxxus, Eredar Lord of the Burning Legion!','',0,0,0,0,0,0,0,0,0,0,71504,0,26124),
(122341,'FLESH FROM BONE!','',0,0,0,0,0,0,0,0,0,0,71505,0,26124),
(122342,'Trifling gnome! Your arrogance will be your undoing!','',0,0,0,0,0,0,0,0,0,0,71506,0,26124),
(122343,'IN-FER-NO!','',0,0,0,0,0,0,0,0,0,0,71507,0,26124),
(122344,'Insignificant gnat!','',0,0,0,0,0,0,0,0,0,0,71509,0,26124),
(122345,'These Valarjar Aspirants will aid us in our battle against the Burning Legion!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122346,'','You can rest assured that these archers will never miss their mark.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122347,'','May these imps serve you well, Netherlord.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122348,'What can I do for ya?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122349,'What do you seek?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122350,'Greetings.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122351,'','These elementals will make useful allies in our battle against the Burning Legion.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122352,'How can me help ye, Shadow $n?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122353,'The Shattered Hand will see the Horde to its former glory.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122354,'','Something I can help you with?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122355,'What do you seek?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122356,'Steer clear! Who knows what\'s gotten into this thing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122357,'Out of the way! This thing has no regard for safety!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122358,'Lookout! I can\'t seem to get control of this thing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122359,'Steer clear! This zeppelin\'s got a mind of its own!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122360,'Zeppelin on the loose! Everybody panic!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122361,'','Get outta here, varmint!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122362,'I wish to trade.','I wish to trade.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122363,'I wish to bind my hearthstone here.','I wish to bind my hearthstone here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122364,'Make Shal\'Aran your new home?','Make Shal\'Aran your new home?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122365,'<Feed the Nightborne Wretch 5 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>','<Feed the Nightborne Wretch 5 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122366,'This action costs 20 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?','This action costs 20 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122367,'','The crimes of my past are mine to bear, and mine only. However, the Burning Legion corrupted my former order, leading us astray from righteousness.$b$bI will make the Burning Legion pay for their treachery!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122368,'','Summoners, begin the ritual!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122369,'','Yes, yes, it is working!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122370,'','The ritual is complete, contain it, quickly!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122371,'Elune-Ado... Wait, is that THE Scythe of Elune in your hands? Amazing!','Elune-Ado... Wait, is that THE Scythe of Elune in your hands? Amazing!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122372,'Careful with that scythe, Shan\'do. I\'d prefer to stay in control of my mind.','Careful with that scythe, Shan\'do. I\'d prefer to stay in control of my mind.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122373,'Is that the Scythe of Elune you carry? Does it really turn you into a beast?','Is that the Scythe of Elune you carry? Does it really turn you into a beast?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122374,'The Scythe of Elune! The end must be near if we need the power of THAT weapon to save us.','The Scythe of Elune! The end must be near if we need the power of THAT weapon to save us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122375,'Welcome, Shan\'do. It is an honor to meet with the master of the Scythe.','Welcome, Shan\'do. It is an honor to meet with the master of the Scythe.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122376,'Those claws look incredibly sharp. I\'m glad you\'re on our side!','Those claws look incredibly sharp. I\'m glad you\'re on our side!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122377,'The rumors are true. $n wields the Claws of Ursoc!','The rumors are true. $n wields the Claws of Ursoc!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122378,'Our champion is here bearing the Claws of Ursoc! The Legion\'s days are numbered!','Our champion is here bearing the Claws of Ursoc! The Legion\'s days are numbered!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122379,'Hail Archdruid $n, chosen of Ursoc!','Hail Archdruid $n, chosen of Ursoc!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122380,'','Tethys will arrange transport for us on one of his ships. We will sail out of sight of land and then he will row us to shore when it is dark and the fog is heavy upon the waters.\n\nLet me know when you are ready to leave, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122381,'The Fangs of Ashamane! So, the rumor of the attack on the Ashen shrine was true!','The Fangs of Ashamane! So, the rumor of the attack on the Ashen shrine was true!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122382,'Those daggers look strange. Are they... teeth?','Those daggers look strange. Are they... teeth?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122383,'The Fangs of Ashamane! I thought the Ashen would never let them out of their sight!','The Fangs of Ashamane! I thought the Ashen would never let them out of their sight!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122384,'Greetings, $n. Word has reached me of your efforts to push back against Legion invasion forces.','',0,0,0,0,0,0,0,0,0,0,71618,0,26124),
(122385,'I am reluctant to interrupt such important work, but I could use your help in a matter of... diplomacy. I fear I am about to anger an old friend.','',0,0,0,0,0,0,0,0,0,0,71619,0,26124),
(122386,'$n, I recognize those daggers. They are the Fangs of Ashamane are they not? You must have done something impressive indeed for the Ashen to let you have them.','$n, I recognize those daggers. They are the Fangs of Ashamane are they not? You must have done something impressive indeed for the Ashen to let you have them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122387,'Dalaran has been repositioned to defend the Eastern Kingdoms. You\'ll find it over Deadwind Pass, just above Karazhan. Please join me here.','',0,0,0,0,0,0,0,0,0,0,71620,0,26124),
(122388,'I\'m glad the Cenarion Circle has you among their number, Fang bearer!','I\'m glad the Cenarion Circle has you among their number, Fang bearer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122389,'The Guardian of G\'Hanir is here! Elune bless you, $n!','The Guardian of G\'Hanir is here! Elune bless you, $n!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122390,'I\'m glad to see G\'Hanir is in good hands.','I\'m glad to see G\'Hanir is in good hands.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122391,'It\'s $n! The hero who purged the corruption from G\'Hanir!','It\'s $n! The hero who purged the corruption from G\'Hanir!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122392,'It\'s the guardian of G\'Hanir! We\'re counting on you, $n.','It\'s the guardian of G\'Hanir! We\'re counting on you, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122393,'','Conjurers, begin channeling!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122394,'<Rottgut turns towards your direction and belches loudly.>$b$bRottgut... rott... gut!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122395,'','The Crystal is charged.  Use it at will.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122396,'','Hello there, honey!$b$bWhat can I get you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122397,'','We are out of wine but we have plenty of food, drink, and places to put your feet up!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122398,'','Sit down and relax!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122399,'Welcome. What can I get for you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122400,'','Uh oh.$b$bYour armor looks like it can use some fixing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122401,'','My skills are second to none!$b$bI hear I have some competition, though. There\'s someone else doing smithing outside the city.$b$bI like a challenge. Bring it! Hahaha!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122402,'If you are unsure of the path you are about to take, I can return you to the surface. Would you like me to do so?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122403,'I need to return to the surface.','I need to return to the surface.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122404,'<The defense matrix appears unpowered.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122405,'<Insert 20 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana into the Defense Matrix.>','<Insert 20 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana into the Defense Matrix.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122406,'A demon blade can find even the smallest crack in your armor, $n. Repair it, or you might end up with your head on a spike.','',0,0,0,0,0,0,603,0,0,923,0,0,26124),
(122407,'','Silvermoon stands behind you, $n. Allow us to bless your weapon with holy might.',0,0,0,0,0,0,1,0,0,923,0,0,26124),
(122408,'|TInterface\\Icons\\sha_spell_shadow_shadesofdarkness_nightmare:20|t%s begins to cast |cFFFF0000|Hspell:214876|h[Beasts of Nightmare]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122409,'This place... It\'s so much worse than I could have imagined.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122410,'Wake me up from this Nightmare!','Wake me up from this Nightmare!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122411,'','Finish mixin\' up dat mojo, we got ta get it to da Broken Shore!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(122412,'Begone!','Begone!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122413,'|TInterface\\Icons\\spell_fire_ragnaros_molteninferno.blp:20|tThe $n |cFFFF0000|Hspell:202663|h[Detonates]|h|r as it dies!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122414,'Warlord!','',0,0,0,0,0,0,25,0,0,923,0,0,26124),
(122415,'Don\'t just stand there, $n! These demons won\'t be killin\' themselves!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122416,'Better late than never, eh lad? Those of us that still draw breath fight on! Are you pre-','',0,0,0,0,0,0,0,0,0,0,72097,0,26124),
(122417,'If we do not stop Xavius, the Nightmare will consume all of Azeroth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122418,'Caught off guard, we was! We be needin\' ta bring an end ta these demons once and fer all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122419,'Hold them back! We cannot lose the city!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122420,'Masterful, your weapon and experience show even the valarjar can learn from the younger races. There are new enemies and new ways of fighting that I haven\'t seen in my many years. You have given me a great deal to work with, thank you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122421,'Heroes of the Alliance, I write to you in Azeroth\'s darkest hour. From the maw of hell, the burning armies of the Legion have returned.','',0,0,0,0,0,0,1,0,0,0,63846,0,26124),
(122429,'This font looks as if it has not been used for some time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122430,'$ct, you have been called. Follow me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122431,'Asher, son of Exurotus, the new Fury of Frostfire, wishes to bestow you with his boon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122432,'<Provide an offering of 20 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>','<Provide an offering of 20 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122433,'You\'ve done it champions! The Iris is unlocked, give the word and I will open it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122434,'The Nightmare\'s guardians have fallen. What else must be done to open the way to Xavius?','The Nightmare\'s guardians have fallen. What else must be done to open the way to Xavius?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122435,'You hear the measured chanting and pacing of a complex ritual within the spire.','You hear the measured chanting and pacing of a complex ritual within the spire.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122436,'The ritual is broken.  The figure suspended within the Nightwell awakens.','The ritual is broken.  The figure suspended within the Nightwell awakens.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122437,'I expected more out of these demons. Maybe we can find a pitlord. I always wanted to shackle the essence of a pitlord.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122438,'We should continue our patrol. There is no telling how many more of these incursions pocket the landscape.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122439,'We cannot afford to wait much longer. We must face the Legion head on.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122440,'I am ready to begin The Defense of Netherlight Temple.','I am ready to begin The Defense of Netherlight Temple.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122441,'Can the power of the Essence of Clarity guide us into the heart of the Nightmare?','Can the power of the Essence of Clarity guide us into the heart of the Nightmare?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122443,'Madam Goya packed up da goods and left me in charge of da premises. She said somethin\' about a sky city. Haw! Cities don\'t fly!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122444,'We must stop Gul\'dan before he can complete the ritual.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122445,'The legion will fall today, champion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122446,'The ward pulses with overflowing energy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122447,'Press forward, we cannot delay here long.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122448,'<Use 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana to extract a portion of the ley energy.>','<Use 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana to extract a portion of the ley energy.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122449,'','Long have I waited to return home...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122450,'','The power of the Nightwell calls to me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122451,'They should have listened to me from the start and destroyed all the satyrs before this could happen.\n\nI thank you, $p, for releasing me from the madness of Xavius.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122452,'We\'ve broken through the prison gate! The way into Dalaran is clear!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(122453,'','Elisande will pay for her treachery.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122454,'','The Order is with you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122455,'Request a Blessing','Request a Blessing',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122456,'','Come, outsider filth. I will even let you strike the first blow. Make it count.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122457,'Will you strike at me first or stare at me like a sniveling coward?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122458,'The fishing can wait, help me put this elemental down!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122459,'I always hated water elementals...Espically big ones like this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122460,'This is the problem with magic, you never know when it will turn on you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122461,'Sire, behind you! Another felmaw has opened!','',0,0,0,0,0,0,0,0,0,0,72095,0,26124),
(122462,'Moon Guard, focus your energies into me! We shall show these monsters the power of the arcane!','',0,0,0,0,0,0,0,0,0,0,72104,0,26124),
(122463,'We require rest, master.','We require rest, master.',0,0,0,0,0,0,0,0,0,0,72106,72368,26124),
(122464,'Tell me more about your posts.','Tell me more about your posts.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122465,'Ha! I have spoken seven words, that is my limit.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122466,'','Wear your tabard with pride, $n. Our red colors will hide your wounds from your enemies.',0,0,0,0,0,0,1,0,0,923,0,0,26124),
(122467,'Dalaran is under siege, $n! The Legion intends to knock us out of the sky!','',0,0,0,0,0,0,0,0,0,0,71621,0,26124),
(122468,'We need the Pillars of Creation to send the demons back to the Twisting Nether and save our world.','',0,0,0,0,0,0,0,0,0,0,71622,0,26124),
(122469,'Meet me in Dalaran over Deadwind Pass. I have a plan. A horribly dangerous plan... but a plan nonetheless!','',0,0,0,0,0,0,0,0,0,0,71623,0,26124),
(122470,'What manner of felspawn have these devils set upon us!? Mother Moon help us all!','',0,0,0,0,0,0,0,0,0,0,72105,0,26124),
(122471,'Come, $n. Meet me by the Forge of the Guardian.','',0,0,0,0,0,0,0,0,0,0,71757,0,26124),
(122472,'Paladins of the Silver Hand!  Come forth and present yourselves for battle!','Paladins of the Silver Hand!  Come forth and present yourselves for battle!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122473,'My Lord, I lend my arms to your cause.','My Lord, I lend my arms to your cause.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122474,'Deciphering','Deciphering',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(122475,'<The portal hums with magic.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122476,'I\'m not ready yet.','I\'m not ready yet.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122477,'Our mission here is gravely important. However if you need to make additional preparations, I can return you to the Aetherium. Would you like me to?','Our mission here is gravely important. However if you need to make additional preparations, I can return you to the Aetherium. Would you like me to?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122478,'Yes, take me back. There is much I need to do first.','Yes, take me back. There is much I need to do first.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122479,'For honor and glory!','For honor and glory!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122480,'It is time!  Vanguard of the Silver Hand, to Battle!','It is time!  Vanguard of the Silver Hand, to Battle!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122481,'The Nightmare begins to take you!','The Nightmare begins to take you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(122482,'Come with me to the Seed of Ages, Archdruid. There, we will unlock additional mysteries of your weapon.','',0,0,0,0,0,0,0,0,0,0,71636,0,26124),
(122483,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122484,'|TInterface\\Icons\\ability_priest_shadowyapparition:20|t%s has summoned a |cFFFF0000|Hspell:226089|h[Shadow Image]|h|r! Banish it!','|TInterface\\Icons\\ability_priest_shadowyapparition:20|t%s has summoned a |cFFFF0000|Hspell:226089|h[Shadow Image]|h|r! Banish it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122485,'Your intrusion has not gone unnoticed; but the ritual continues.','Your intrusion has not gone unnoticed; but the ritual continues.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122486,'Interlopers!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122487,'Fear not, I will draw the power of the Nightwell to wipe them out!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122488,'','Courtesans! Defend us while we continue the ritual!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122489,'The Dreadscar are yours to command, Overlord.\n\nMay the worlds of your enemies fall at your feet.','',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(122490,'The time has come to take my position as the leader of the Four Horsemen.','',0,0,0,0,0,0,0,0,0,0,78622,0,26124),
(122491,'I will meet you on the upper level when you are ready, Deathlord.','',0,0,0,0,0,0,0,0,0,0,78623,0,26124),
(122492,'Horsemen! Our time has come!','',0,0,0,0,0,0,0,0,0,0,78624,0,26124),
(122493,'Usurpers! Gnomeregan is mine!','',0,0,0,0,0,0,0,0,1,0,71634,0,26124),
(122494,'Explosions! MORE explosions! I got to have more explosions!','',0,0,0,0,0,0,0,0,1,0,71635,0,26124),
(122495,'It seems we have arrived just in time.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122496,'The Burning Legion has begun their attack. We must defend Netherlight Temple!','The Burning Legion has begun their attack. We must defend Netherlight Temple!',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(122497,'We are armed and ready to fight, High Priest.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122498,'Let us aid our allies under the Light, and defend Netherlight Temple. To the portal!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122499,'I am the master\'s son. You are outmatched.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122500,'You will be a good warm-up for my actual practice.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122501,'Curse... you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122502,'Good bout...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122503,'You hear something dart away behind you... and then just silence.','You hear something dart away behind you... and then just silence.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122504,'I shall fight for you.','I shall fight for you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122505,'My life for the Light.','My life for the Light.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122506,'','Let me show you the power of the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122507,'','If you want something done right, you have to kill it yourself...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122508,'You hear a strange feral screech towards the Duskwood gateway.','You hear a strange feral screech towards the Duskwood gateway.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122509,'You hear a strange feral screech towards the Feralas gateway.','You hear a strange feral screech towards the Feralas gateway.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122510,'You hear a strange feral screech towards the Hinterlands gateway.','You hear a strange feral screech towards the Hinterlands gateway.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122511,'The look of these mundane weapons belies a hidden potential.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122512,'Tier 1 Defended','Tier 1 Defended',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122513,'<Imbue one of the tridents with 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>','<Imbue one of the tridents with 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122514,'Tier 2 Defended','Tier 2 Defended',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122515,'Tier 3 Defended','Tier 3 Defended',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122516,'Tier 4 Defended','Tier 4 Defended',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122517,'End current round','End current round',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122518,'Gamer timer','Gamer timer',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122519,'How can I assist you today?','How can I assist you today?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122520,'Recruit Silver Hand Knights','Recruit Silver Hand Knights',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122521,'Recruit Silver Hand Templar','Recruit Silver Hand Templar',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122522,'<Something terrible has befallen this lone wanderer.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122523,'<Something terrible has befallen this lone wanderer.>\n\n<Unfortunately, there is no way to free him.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122524,'$ct, I\'ve been looking everywhere for you! Oh, the head in the crystal ball? I\'m trying something new.','',0,0,0,0,0,0,0,0,0,0,71680,0,26124),
(122525,'I\'ve finished gathering all of the volumes.','I\'ve finished gathering all of the volumes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122526,'Marvelous! It\'s great seeing a young hero like you take the time for a bit of history. In the end, some might say what we leave behind is all that matters.\n\nI have something here... a volume of a completely different sort that I might offer you in exchange for the great efforts you\'ve put into this. Would you like it?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122527,'Gladly.','Gladly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122528,'The guards sniff at you, then grunt softly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122529,'THIS IS MY ISLAND!','',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(122530,'FIND YOUR OWN DAMN ISLAND!!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(122531,'A grim task, but you did what had to be done. I\'ll prepare the Tears of Elune for transport. Meet me in the Violet Citadel.','',0,0,0,0,0,0,0,0,0,0,71681,0,26124),
(122532,'YOU\'RE NOT GONNA TAKE MY ISLAND!!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(122533,'We\'d best get a move on, $n!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122534,'I\'m ready. To Ulduar!','I\'m ready. To Ulduar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122535,'Busy, very busy. M-must get to work.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122536,'No time to talk. Cleaning to be done.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122537,'Something need to be cleaned?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122538,'Hah! Where are your manafiends now?!','Hah! Where are your manafiends now?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122539,'What?!','What?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122540,'','I will fight honorably for the Order of the Silver Hand, $ct.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122541,'You wanna fight for my island! Fine! I\'ll paint it with your blood!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122542,'We\'re all going to die!','We\'re all going to die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122543,'Su\'esh is on the loose! Flee!','Su\'esh is on the loose! Flee!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122544,'Guards, what do we pay you for? Kill this beast!','Guards, what do we pay you for? Kill this beast!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122545,'I\'m too rich to die like this!','I\'m too rich to die like this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122546,'NO! I will not allow the Ebon Blade to fall!','',0,0,0,0,0,0,0,0,0,0,76895,0,26124),
(122547,'Horsemen! Our Destiny is at hand!','',0,0,0,0,0,0,0,0,0,0,76897,0,26124),
(122548,'The Burning Legion shall tremble before the power of the Four Horsemen!','',0,0,0,0,0,0,0,0,0,0,76898,0,26124),
(122549,'Stormwind honors your service to the Alliance.','',0,0,0,0,0,0,0,0,0,0,71686,0,26124),
(122550,'Stormwind will endure.','',0,0,0,0,0,0,0,0,0,0,71687,0,26124),
(122551,'Greetings, friend.','',0,0,0,0,0,0,0,0,0,0,71688,0,26124),
(122552,'Sometimes we must fight for what we believe in.','',0,0,0,0,0,0,0,0,0,0,71689,0,26124),
(122553,'A just cause is always worth fighting for.','',0,0,0,0,0,0,0,0,0,0,71691,0,26124),
(122554,'For the Alliance above all.','',0,0,0,0,0,0,0,0,0,0,71692,0,26124),
(122555,'A King is only as noble as the causes he serves.','',0,0,0,0,0,0,0,0,0,0,71695,0,26124),
(122556,'Be vigilant.','',0,0,0,0,0,0,0,0,0,0,71693,0,26124),
(122557,'You are always welcome in Stormwind.','',0,0,0,0,0,0,0,0,0,0,71696,0,26124),
(122558,'Never lose hope.','',0,0,0,0,0,0,0,0,0,0,71698,0,26124),
(122559,'Safe journey to you.','',0,0,0,0,0,0,0,0,0,0,71699,0,26124),
(122560,'Victory in the Light.','',0,0,0,0,0,0,0,0,0,0,71701,0,26124),
(122561,'Now is not the time for that.','',0,0,0,0,0,0,0,0,0,0,71702,0,26124),
(122562,'You try my patience.','',0,0,0,0,0,0,0,0,0,0,71704,0,26124),
(122563,'<This Manasaber has been imprisoned by the Legion, but overloading the crystal with Ancient Mana will free the beast.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122564,'Suramar ascends.','Suramar ascends.',0,0,0,0,0,0,0,0,0,0,65833,0,26124),
(122565,'You know I\'m King now, right?','',0,0,0,0,0,0,0,0,0,0,71706,0,26124),
(122566,'The Light shall burn you!','',0,0,0,0,0,0,0,0,0,0,71708,0,26124),
(122567,'<Free the Felbound Manasaber by spending 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>','<Free the Felbound Manasaber by spending 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122568,'This action costs 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?','This action costs 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122569,'Stag','Stag',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(122570,'Spirits! Sweep these mortals into the tides!!!','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(122571,'All who summon the ferryman, must pay the toll!','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(122572,'You wish for passage to Helheim? Then you shall have it! Ahahahaha!','',0,0,0,0,0,0,0,0,6,0,71768,0,26124),
(122573,'Those who summon, pay the toll, forfeit now your eternal soul!','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(122574,'I look forward to seeing Magni again. It\'s been too long.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122575,'Mimiron gave me a teleport pad to use in case of emergencies. I\'d say this qualifies!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122576,'The order is given, we will begin charging up the Rift Core immediately.','The order is given, we will begin charging up the Rift Core immediately.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122577,'The Rift Core is charged, deploy the Rift Cannon at your discretion.','The Rift Core is charged, deploy the Rift Cannon at your discretion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122578,'I\'d like to review the information we\'ve gathered on the remaining artifact weapon.','I\'d like to review the information we\'ve gathered on the remaining artifact weapon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122579,'','I better not hear anything breaking.',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(122580,'','Keep your hands to yourself, little one.',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(122581,'','Keep quiet and let mother browse.',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(122582,'','No fingers on the glass, remember what we discussed.',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(122583,'','If you break it, mother must purchase it.',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(122584,'','Calm down, we will go home soon.',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(122585,'I\'m ready to pursue the final blade.','I\'m ready to pursue the final blade.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122586,'Mechanical','Mechanical',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(122587,'Rylak','Rylak',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(122588,'Riverbeast','Riverbeast',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(122589,'Hydra','Hydra',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(122590,'Direhorn','Direhorn',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(122591,'','The Uncrowned are a means to an end. The Legion\'s end.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122592,'You hear a strange crackling sound from the portals downstairs.','You hear a strange crackling sound from the portals downstairs.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122593,'I will protect.','I will protect.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122594,'My shield is yours.','My shield is yours.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122595,'It would be my honor.','It would be my honor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122596,'You hear a strange roar from the cavern ahead.','You hear a strange roar from the cavern ahead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122597,'The Hydraxian Waterlords are with you, Farseer. The Burning legion will not conquer!','',0,0,0,0,0,0,0,0,0,0,71822,0,26124),
(122598,'What the dook?','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(122599,'If you need a ride to Dalaran, my bats are at the ready.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122600,'This module looks to have lost its energy source long ago.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122601,'<Activate the module using 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>','<Activate the module using 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122602,'','The Temple of a Thousand Lights teems with spirits gone mad. You should remind them to behave.',0,0,0,0,0,0,0,0,0,0,0,71831,26124),
(122603,'','Even spirits understand strength. Well done!',0,0,0,0,0,0,0,0,0,0,0,71830,26124),
(122604,'','The most powerful mages at this temple conspire against the Nightwatchers. Show them how we deal with our enemies!',0,0,0,0,0,0,0,0,0,0,0,71829,26124),
(122605,'Ready to assault Hrydshal.','Ready to assault Hrydshal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122606,'','Well fought! The enemies of the Nightwatchers pay dearly for their treachery.',0,0,0,0,0,0,0,0,0,0,0,71828,26124),
(122607,'We are lucky to have received Malorne\'s warning, dire as it may be. I greatly fear for the Emerald Dream, and if the Dream is corrupted, there is no telling how it will affect Azeroth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122608,'','Why do we fight?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122609,'','D\'ah! Now you\'re making me angry!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122610,'I believe our wounds have healed enough. I will continue my scouting. Be well, Lilryia.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122611,'I believe I saw a $c looking for you in town, mentioning something about some ancient weapon. You should speak with them first before venturing out into the Broken Isles. You\'re going to need all of the allies you can get.\n\nI mean... I can get you a flight if you really want one. But I\'d recommend against it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122612,'Can you get me a flight out of here?','Can you get me a flight out of here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122613,'Azsuna','Azsuna',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122614,'Highmountain','Highmountain',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122615,'Val\'kyr!  The Call has gone out!  Prepare yourselves!','Val\'kyr!  The Call has gone out!  Prepare yourselves!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122616,'Val\'kyr, the time is upon us! To battle!','Val\'kyr, the time is upon us! To battle!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122617,'My spear is yours.','My spear is yours.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122618,'Val\'sharah','Val\'sharah',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122619,'My life for Odyn!','My life for Odyn!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122620,'They shall fear our wrath.','They shall fear our wrath.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122621,'For Glory!','For Glory!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122622,'Heh, this guy\'s toast.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122623,'Larry gonna crush you into delicious meat sauce.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122624,'Hello fellow citizen, what seems to be the problem?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122625,'','I knoooow you\'re with the Leeeegion. That\'s you. That\'s what you sound like.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122626,'','Corrin ma\' crate, ye bugger off!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122627,'Tell me, $c, have you explored the wondrous goods that Dalaran has to offer? If you can\'t find what you\'re looking for, chances I know someone who can help.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122628,'','I told them this would happen. \n\nI TOLD them. \n\nDid they listen?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122629,'Watch yourself, $c...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122630,'THIEF!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122631,'Jagganoth will... end you...','',0,0,0,0,0,0,0,0,0,0,71874,0,26124),
(122632,'Asha, you\'re free.','Asha, you\'re free.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122633,'Sirius, are you okay?','Sirius, are you okay?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122634,'','Da enemies a\' da Nightmare are clever. Dey chose da moment when da Wild Gods fell in battle thousands a\' years ago, when dey rose up ta defend Azeroth against the Burning Legion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122635,'','I don\'t like this place at all! Let\'s get rid of these invading monsters, Archdruid!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122636,'','It must be difficult for the wild gods to re-live this moment. I can only imagine the horror when the Legion invaded, all those years ago.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122637,'The Nightmare has no place here, and we must do everything we can to protect Malorne. Without him, the very balance of nature is vulnerable.$B$BI fear there is nothing more important than saving him... even if it means giving our own lives.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122638,'Rest in peace, old friend.','Rest in peace, old friend.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122639,'','You have come to the crucible of all creation in search of answers. Listen then, and find enlightenment.',0,0,0,0,0,0,1,0,10,0,0,71878,26124),
(122640,'','In a time now long past, a great battle was fought that would determine the fate of all worlds. It was in that final battle that the all-powerful titan Pantheon fell to one of their own: Sargeras.',0,0,0,0,0,0,1,0,10,0,0,71879,26124),
(122641,'','After the fall, none were left to oppose the will of Sargeras. Unfettered, the dark titan and his Burning Legion would go on to annihilate countless worlds in their Burning Crusade.',0,0,0,0,0,0,1,0,10,0,0,71880,26124),
(122642,'','From the ashes of those ravaged worlds, survivors arose to stand against the demons. They became known as the Army of the Light.',0,0,0,0,0,0,0,0,10,0,0,71881,26124),
(122643,'','But now, the Golden Army teeters upon the precipice of oblivion as their campaign on Argus nears its terminus. Should they fall, the Legion will initiate a new Burning Crusade, and with it the cosmos will tremble.',0,0,0,0,0,0,1,0,10,0,0,71882,26124),
(122644,'','I am here now on a mission of desperation. I seek the child of Light and Shadow: the boy destined to end the age of demons.',0,0,0,0,0,0,1,0,10,0,0,71883,26124),
(122645,'','The one called Illidan Stormrage.',0,0,0,0,0,0,1,0,10,0,0,71884,26124),
(122646,'Its too strong!  This is madness!','Its too strong!  This is madness!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122647,'We don\'t have the power...','We don\'t have the power...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122648,'This demon has some fight in it!','This demon has some fight in it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122649,'','$n, it\'s you.\n\nWe were in pursuit of a dangerous dreadlord. Unfortunately, he lured us right into a trap.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122650,'<Cassiel Nightthorn\'s body is nearly unrecognizable. He was tortured, then died from the wounds.>','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122651,'<Sirius Ebonwing looks as pale as a ghost. He shivers uncontrollably.>','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122652,'I returned to Dalaran as soon as I heard the prophecy had been fulfilled.\n\nYou united the Light, just as I saw it. Let us hope that your efforts will give us the strength we need to defeat Balnazzar once and for all.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122653,'We will make our way to Netherlight Temple at once.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122654,'Jus\' say the word an\' we\'ll be off!','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(122655,'','I am Xe\'ra, one of the first naaru to be forged here during the great ordering of the cosmos.',0,0,0,0,0,0,1,0,10,0,0,71900,26124),
(122656,'','Do not be alarmed, mortal. Your consciousness has been projected to my astral presence in the Great Dark Beyond.',0,0,0,0,0,0,1,0,10,0,0,71899,26124),
(122657,'Move while the Mana Wraiths are distracted!','Move while the Mana Wraiths are distracted!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122658,'','XXXX',0,0,0,0,0,0,1,0,10,0,0,0,26124),
(122659,'','Good luck, all of you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122660,'Ulduar holds many secrets.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122661,'<Arduen was apparently being held prisoner. His face is ghostly white.>$B$B$I... broke free... and ran...$B$BI... almost made it...$B$BPlease, $n, save... the other... Illidari...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122662,'This cannot wait. There are demons among your ranks. Let me show you.','This cannot wait. There are demons among your ranks. Let me show you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122663,'Hello, friend! It is not actually me, Khadgar, merely my ruggedly handsome countenance and vast wealth of knowledge. Should you wish the answer to any question, merely ask and request a response.\n\nSo vast is my mental landscape that there was only magical space left to impart a few response phrases into this device, so be sure that you ask VERY SPECIFIC questions.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122664,'I\'ve asked a question, give me an answer!','I\'ve asked a question, give me an answer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122665,'If you seek to wield the weapons of the storm lord, venture within, and learn of his deeds and his unmaking...','',0,0,0,0,0,0,0,0,0,0,72009,0,26124),
(122666,'|TInterface\\Icons\\sha_ability_rogue_envelopingshadows_nightmare:20|tIl\'gynoth has almost completed his |cFFFF0000|Hspell:223121|h[Final Torpor]|h|r!','|TInterface\\Icons\\sha_ability_rogue_envelopingshadows_nightmare:20|tIl\'gynoth has almost completed his |cFFFF0000|Hspell:223121|h[Final Torpor]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(122667,'I know your secret.','I know your secret.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122668,'Leave me alone.','Leave me alone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122669,'Heh.','Heh.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122670,'What?','What?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122671,'Go away.','Go away.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122672,'I have none.','I have none.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122673,'Fight me, then.','Fight me, then.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122674,'You don\'t scare me.','You don\'t scare me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122675,'If you say so.','If you say so.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122677,'So Arrexis was ambushed by this eredar, Balaadur?  Then he is probably in possession of the staff...\n\nWith the invasion I have no doubt he is either here or watching. I propose something... audacious.\n\nLet us recreate Arrexis\'s ritual! Conducting the ritual at an invasion point will attract Balaadur\'s attention. He will likely try an ambush, but we will be ready.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122678,'Who, Fillmaff? That old relic? He\'s been an archivist here at Dalaran for decades. I remember him back from my student days. Always puttering around the stacks. He could find anything.$b$bThen came the Third War, when Arthas sacked the city. Fillmaff went missing, along with countless others - just another of the numberless dead. Nobody thought anything of it.','',1,6,0,0,0,0,0,0,0,0,0,0,26124),
(122679,'Years passed, and we\'d relocated the entire city to Icecrown for the Northrend campaign.$b$bOne day - out of the blue - Old Fillmaff walks into the violet tower. Just strolls in! Doesn\'t say a word. He starts filing books and organizing the folios, like nothing had happened. He\'s been back at it ever since.$b$b<Varenthas leans close to you and whispers:>$b$bI\'m not sure he knows he\'s dead.','',274,1,0,0,0,0,0,0,0,0,0,0,26124),
(122680,'What\'s the story with Old Fillmaff over there?','What\'s the story with Old Fillmaff over there?',1,6,0,0,0,0,0,0,0,0,0,0,26124),
(122681,'','I don\'t know what\'s gotten into the flowers! I stopped trying to collect them once they started... well, they started collecting themselves!$B$BStrange, isn\'t it?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122682,'I am your destruction!','I am your destruction!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122683,'The twilight is upon you!','The twilight is upon you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122684,'Cry for help... none shall answer you!','Cry for help... none shall answer you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122685,'We are the harbingers of destruction!','We are the harbingers of destruction!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122686,'None shall oppose the Twilight\'s Hammer!','None shall oppose the Twilight\'s Hammer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122690,'I\'ve changed my mind. Show me what artifacts are available again.','I\'ve changed my mind. Show me what artifacts are available again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122691,'You head in. I\'ll join you momentarily. I just need to... gather my thoughts.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122692,'Our trip to Ulduar was quite eventful, but we have more work ahead of us.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122693,'You cannot hide what you truly are, demon!','You cannot hide what you truly are, demon!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(122694,'Well look who\'s come back from the dead! $g Buddy:Lady;, you\'ve been unconscious for 3 days. I\'m sure Khadgar will be relieved that his special pal is awake. Me on the other hand? Still a damned sea lion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122695,'Ahahahahaha!','',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(122696,'','The pain will subside, champion. You now carry my mark, and through it I am able to see and feel as you do. Return to me when you are able. We have much to do.',0,0,0,0,0,0,1,0,0,0,0,71945,26124),
(122697,'','Greetings, $n. Are you feeling well? Quite a few others have reported bouts of nausea and dizziness.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122698,'','Greetings! Have you just arrived in the city? You don\'t seem to be suffering any side effects.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122699,'You live! Your champions came to me after they failed to rouse you at your order hall. We brought you here and put you in the infirmary. What happened?','',0,0,0,0,0,0,5,0,0,0,71951,0,26124),
(122700,'','We can\'t take much more of this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122701,'','It\'s never ending! They just keep coming!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122702,'','This can\'t go on forever! We\'ll be overwhelmed soon!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122703,'','They\'re bound to move the city soon! There\'s no way we can keep this up!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122704,'','The Council has a plan. I\'m sure of it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122705,'','We\'ve got to hold out a bit longer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122706,'','On your toes, $n.$B$BDubin may be a stubborn dwarf, but he and I agree that one thing is certain - something doesn\'t feel right here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122707,'Do you feel the life in this forest? We have protected these lands for years. The time has finally come when we cannot protect these lands on our own anymore. Will you help us?','Do you feel the life in this forest? We have protected these lands for years. The time has finally come when we cannot protect these lands on our own anymore. Will you help us?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122708,'','Do you have the courage to help us defeat the Legion?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122709,'We must reclaim our sacred homelands.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122710,'The Kirin Tor appreciate your help.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122711,'Tell me about Illidan again.','Tell me about Illidan again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122712,'Tell me about Gul\'dan again.','Tell me about Gul\'dan again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122713,'Tell me about Khadgar again.','Tell me about Khadgar again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122714,'','Any trouble over here for the two of you? I heard reports of unstable energy in the area.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122715,'','How are things over here? Any unusual disturbances?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122716,'With the Order of the Silver Hand reformed under your leadership, we have new direction and guidance.$B$BWe have much work ahead of us.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122717,'','Hey Grindle... Oh boy. I\'m not even gonna ask. This one\'s all you.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(122718,'','Looks like you\'ve got it mostly under control.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122719,'','$n! If I might have a moment, I have a few things in stock that I think you might be interested in.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122720,'','You\'re in good hands. She\'ll have you out of there in no time!',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(122721,'','$n! If I might have a moment, I have a few things in stock that I think you might be interested in.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122722,'Master! I\'ve got good stuffs. Come look.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122723,'$n! If I might have a moment, I have a few things in stock that I think you might be interested in.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122724,'','Everything seems okay around here for now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122725,'I don\'t have time for pleasantries, demon hunter.$b$bAs I told the other Illidari, I have much to contemplate.$b$bI must prepare our armies to take on the Legion, even as some of my allies cry out for vengeance against the Horde.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122726,'$n! If I might have a moment, I have a few things in stock that I think you might be interested in.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122727,'','We\'ll let you know if we encounter anything.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122728,'','$n! If I might have a moment, I have a few things in stock that I think you might be interested in.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122729,'$n! If I might have a moment, I have a few things in stock that I think you might be interested in.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122730,'','$n! If I might have a moment, I have a few things in stock that I think you might be interested in.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122731,'','$n! If I might have a moment, I have a few things in stock that I think you might be interested in.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122732,'','$n! If I might have a moment, I have a few things in stock that I think you might be interested in.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122733,'Nothing truly unusual. The occasional energy, but nothing I\'d consider dangerous.','Nothing truly unusual. The occasional energy, but nothing I\'d consider dangerous.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122734,'','$n! If I might have a moment, I have a few things in stock that I think you might be interested in.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122735,'$n! I have goods for you! Come!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122736,'After this I\'m going for a second dinner!','After this I\'m going for a second dinner!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122737,'I\'ll have to show you my leaf collection sometime!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122738,'Every morning I run around the Wandering Isle... twice! I can\'t fall behind on my training.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122739,'I finished in second place during last week\'s yak races. I\'m going to need a faster yak!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122740,'The more I drink, the better my strategies... hic!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122741,'I\'ll have to show you my toy collection sometime!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122742,'I\'ll have to show you my mug collection sometime!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122743,'I\'ll have to show you my pet collection sometime!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122744,'I\'ll have to show you my scroll collection sometime!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122745,'I\'ll have to show you my coin collection sometime!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122746,'I\'ll have to show you my mount collection sometime!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122747,'I\'ll have to show you my tabard collection sometime!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122748,'This fight isn\'t fair! You need to send more reinforcements against me, demons!','',0,0,0,0,0,0,0,0,0,0,72068,0,26124),
(122749,'What manner of mage are you?','',0,0,0,0,0,0,0,0,0,0,72069,0,26124),
(122750,'You do what needs to be done. It is an admirable quality.','',0,0,0,0,0,0,0,0,0,0,72070,0,26124),
(122751,'Illidan, you fight with both strength and grace. It is an honor to watch you do battle.','',0,0,0,0,0,0,0,0,0,0,72071,0,26124),
(122752,'Your assistance against this manner of foe is appreciated.','',0,0,0,0,0,0,0,0,0,0,72072,0,26124),
(122753,'I learn new battle tactics simply fighting by your side, Illidan.','',0,0,0,0,0,0,0,0,0,0,72073,0,26124),
(122754,'My axe is yours.','',0,0,0,0,0,0,0,0,0,0,72074,0,26124),
(122755,'Illidan! You ride that dragon like you were born to it!','',0,0,0,0,0,0,0,0,0,0,72075,0,26124),
(122756,'I thought this relentless attack would never cease!','',0,0,0,0,0,0,0,0,0,0,72076,0,26124),
(122757,'I will secure the skies, Captain. It seems you are still needed on the ground.','',0,0,0,0,0,0,0,0,0,0,72077,0,26124),
(122758,'Through fire be cleansed, demons!','',0,0,0,0,0,0,0,0,0,0,72078,0,26124),
(122759,'Illidan! I believe a dreadlord resides within the mausoleum. Your help is gladly received.','',0,0,0,0,0,0,0,0,0,0,72079,0,26124),
(122760,'A worthy battle. I could never have defeated a dreadlord on my own.','',0,0,0,0,0,0,0,0,0,0,72080,0,26124),
(122761,'I am not sure I am comfortable with this, Master Illidan.','',0,0,0,0,0,0,0,0,0,0,72081,0,26124),
(122762,'I am no hero, Captain, but I will gladly stand by your side.','',0,0,0,0,0,0,0,0,0,0,72082,0,26124),
(122763,'Master Illidan, you fight with such power!','',0,0,0,0,0,0,0,0,0,0,72083,0,26124),
(122764,'This place was built to withstand almost any assault, but no one could have predicted the strength of the Legion.','',0,0,0,0,0,0,0,0,0,0,72084,0,26124),
(122765,'I can only hope their sacrifice is worth it.','',0,0,0,0,0,0,0,0,0,0,72085,0,26124),
(122766,'Your blade strikes true, Jarod. Come with me and end this assault!','',0,0,0,0,0,0,0,0,0,0,72086,0,26124),
(122767,'I do what must be done.','',0,0,0,0,0,0,0,0,0,0,72087,0,26124),
(122768,'Your sacrifice will be remembered.','',0,0,0,0,0,0,0,0,0,0,72088,0,26124),
(122769,'I seem to have misplaced my Dalaran Hearthstone, may I have another?','I seem to have misplaced my Dalaran Hearthstone, may I have another?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122770,'They fall from the sky with such aplomb. Ah, sweet catharsis.','',0,0,0,0,0,0,0,0,0,0,72089,0,26124),
(122771,'The Legion thinks their tricks are unexpected, but we are prepared!','',0,0,0,0,0,0,0,0,0,0,72090,0,26124),
(122772,'End this charade, demons! You know you cannot defeat me!','',0,0,0,0,0,0,0,0,0,0,72091,0,26124),
(122773,'[%s] confesses: I don\'t know what a Healthstone is, and at this point I\'m too afraid to ask.','[%s] confesses: I don\'t know what a Healthstone is, and at this point I\'m too afraid to ask.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(122774,'[%s] confesses: I thought we had already defeated the Legion.','[%s] confesses: I thought we had already defeated the Legion.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(122775,'[%s] confesses: I can\'t believe how big Tauren weapons are.','[%s] confesses: I can\'t believe how big Tauren weapons are.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(122776,'[%s] confesses: I spent more time than I want to admit looking for Splashran in the ocean.','[%s] confesses: I spent more time than I want to admit looking for Splashran in the ocean.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(122777,'[%s] confesses: I vendor anything I don\'t need because I am too lazy to use the Auction House.','[%s] confesses: I vendor anything I don\'t need because I am too lazy to use the Auction House.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122778,'[%s] confesses: I often wonder if Vrykul beards are softer than kittens.','[%s] confesses: I often wonder if Vrykul beards are softer than kittens.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122779,'[%s] confesses: I never pay attention when discussing how to fight a new raid boss.','[%s] confesses: I never pay attention when discussing how to fight a new raid boss.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122780,'[%s] confesses: I was that guy who always turns on Aspect of the Pack.','[%s] confesses: I was that guy who always turns on Aspect of the Pack.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122781,'[%s] confesses: I like the old Dalaran better. Not that one, the other one.','[%s] confesses: I like the old Dalaran better. Not that one, the other one.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122782,'[%s] confesses: I haven\'t visited my Garrison in a long time. I hope my followers are doing alright.','[%s] confesses: I haven\'t visited my Garrison in a long time. I hope my followers are doing alright.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122783,'[%s] confesses: I secretly hoped one specific boat in my Shipyard would fail its mission. It never did.','[%s] confesses: I secretly hoped one specific boat in my Shipyard would fail its mission. It never did.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122784,'[%s] confesses: I don\'t understand what it is called the Broken Isles. Aren\'t all islands broken apart?','[%s] confesses: I don\'t understand what it is called the Broken Isles. Aren\'t all islands broken apart?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122785,'[%s] confesses: I really, really like the Goldshire Inn.','[%s] confesses: I really, really like the Goldshire Inn.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122786,'[%s] confesses: I thought Garrosh was an okay guy.','[%s] confesses: I thought Garrosh was an okay guy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122787,'Finally, an opponent worthy of my axe!','',0,0,0,0,0,0,0,0,0,0,72107,0,26124),
(122788,'[%s] confesses: I don\'t like fighting Gronn, I feel like they are always looking right at me.','[%s] confesses: I don\'t like fighting Gronn, I feel like they are always looking right at me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122789,'[%s] confesses: I undercut everybody when I sell something on the auction house because I can.','[%s] confesses: I undercut everybody when I sell something on the auction house because I can.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122790,'The battle is joined, Master Illidan!','',0,0,0,0,0,0,0,0,0,0,72108,0,26124),
(122791,'Keep this thing away from me!','Keep this thing away from me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122792,'Somebody stop this thing!','Somebody stop this thing!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122793,'Can\'t anybody get these under control?','Can\'t anybody get these under control?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122794,'','Help... me...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122795,'','No hope...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122796,'','The Light is gone...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122797,'','So... lost...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122798,'','Thank... you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122799,'','Free... at last...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122800,'','I return... to the dark beyond...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122801,'','Bless you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122802,'Oh no you don\'t!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122803,'Keep out of our shops!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122804,'This one\'s for you, $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122805,'Without him we will all be lost!','Without him we will all be lost!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122806,'Nothing you do can stop them!','Nothing you do can stop them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122807,'','These things just keep on comin\'!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122808,'The Light is gone! Don\'t you see?','The Light is gone! Don\'t you see?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122809,'We are all doomed!','We are all doomed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122810,'I had an elaborate prison break all planned, but it seems you\'ve beaten me to it.','',396,0,0,0,0,0,1,0,0,0,0,0,26124),
(122811,'I am Archmage Khadgar, leader of the Kirin Tor. Demon hunters, Azeroth needs your help.','',396,0,0,0,0,0,1,0,0,0,0,0,26124),
(122812,'','Do the best you can, $n. We\'ll see how long we can hold these demons back.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122813,'Be purged by my blade!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122814,'Meet your end!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122815,'I am just as surprised as you are, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122816,'You will NOT succeed in your efforts!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122817,'May swift steel bring your end!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122818,'','Push them back! We cannot let Dalaran fall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122819,'I knew it! I could feel it!$B$BClear out the city, $n! We have to hold them off!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122820,'Soaring through the skies is immensely enjoyable!','',0,0,0,0,0,0,0,0,0,0,72118,0,26124),
(122821,'|TInterface\\Icons\\sha_spell_warlock_demonsoul_nightmare:20|tUse Malfurion\'s |cFF00FFFF|Hspell:212630|h[Cleansed Ground]|h|r to avoid damage from |cFFFF0000|Hspell:210279|h[Creeping Nightmares]|h|r.','|TInterface\\Icons\\sha_spell_warlock_demonsoul_nightmare:20|tUse Malfurion\'s |cFF00FFFF|Hspell:212630|h[Cleansed Ground]|h|r to avoid damage from |cFFFF0000|Hspell:210279|h[Creeping Nightmares]|h|r.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122822,'','An ancient memory stirs. When you are prepared, call to me and together we will uncover a piece of Illidan\'s past.',0,0,0,0,0,0,1,0,0,0,0,72136,26124),
(122823,'','Illidan\'s was a life full of potential. His destiny forged in the great ordering and cast to the cosmic winds, where at last it would find a home on Azeroth. Within the tiny vessel the great cycle began anew.',0,0,0,0,0,0,1,0,0,0,0,72137,26124),
(122824,'','Few have known such failure and rejection. Most would have given up, but Illidan would continue on, guided by the unseen hand of fate. His destiny lay elsewhere.',0,0,0,0,0,0,1,0,0,0,0,72138,26124),
(122825,'','Difficult decisions had to be made, but to understand Illidan\'s perspective is essential if we are to succeed in our mission. What would you have done differently?',0,0,0,0,0,0,1,0,0,0,0,72140,26124),
(122826,'','With his eyes burned out for seeing the truth, Illidan still did not falter. Even under the gaze of the lord of the Burning Legion, Illidan remained resolute and defiant.',0,0,0,0,0,0,1,0,0,0,0,72141,26124),
(122827,'','Tyrande... The world is only as meaningful to us as the beings that inhabit it. Even in the end, Illidan saw her as clearly as the first time he laid eyes on her. He never lost sight of his world. You must ask yourself how far will you go for yours.',0,0,0,0,0,0,1,0,0,0,0,72142,26124),
(122828,'To make matters worse, that monstrosity in the arena will burn the hold from the inside out if it is not stopped! Take your Moon Guard and rid Black Rook Hold of this demonic invasion!','',0,0,0,0,0,0,0,0,0,0,72149,0,26124),
(122829,'Be on the lookout for Captain Shadowsong and his two foreign allies! We were separated in the initial assault. I pray they are still alive!','',0,0,0,0,0,0,0,0,0,0,72150,0,26124),
(122830,'WHAT HAVE YOU DONE! YOU\'VE KILLED THEM ALL, ILLIDAN!','',0,0,0,0,0,0,5,0,0,0,72324,0,26124),
(122831,'You are relieved of duty, Illidan. Rhonin, the Moon Guard are yours to command now.','',0,0,0,0,0,0,0,0,0,0,72151,0,26124),
(122832,'I\'ve seen everything! Illidan! Ravencrest wants me to take over! We need to coordinate our attack and bring back some semblance of order!','',0,0,0,0,0,0,0,0,0,0,72152,0,26124),
(122833,'','A gigantic beast has risen from the waters. Send it back to the depths!',0,0,0,0,0,0,0,0,0,0,0,72165,26124),
(122834,'','Well done. We can rest easy... for now.',0,0,0,0,0,0,0,0,0,0,0,72166,26124),
(122835,'','Those meddling ghost mages managed to conjure up a being of wild magic! Put them back in line.',0,0,0,0,0,0,0,0,0,0,0,72167,26124),
(122836,'','The echoes of magic have subsided. You have our thanks.',0,0,0,0,0,0,0,0,0,0,0,72168,26124),
(122837,'<Show Thalyssra\'s token to Valtrois.>','<Show Thalyssra\'s token to Valtrois.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122838,'','You may speak.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122840,'Dead? The titans are dead?','',0,0,0,0,0,0,0,0,0,0,72211,0,26124),
(122841,'It explains so much, yet I cannot help but feel an overwhelming sense of sadness.','',0,0,0,0,0,0,0,0,0,0,72212,0,26124),
(122842,'We have been on our own all along. Our gods killed before we were born.','',0,0,0,0,0,0,0,0,0,0,72213,0,26124),
(122843,'As for the Army of the Light and Illidan, I am at a loss. I have never felt so powerless.','',0,0,0,0,0,0,0,0,0,0,72214,0,26124),
(122844,'Illidan is dead and the Golden Army fights an endless war in our name from across the cosmos...','',0,0,0,0,0,0,0,0,0,0,72215,0,26124),
(122845,'','Praise to the goddess. She has blessed us this night with new life.',0,0,0,0,0,0,0,0,6,0,0,72344,26124),
(122846,'','The birth of not one, but two healthy males.',0,0,0,0,0,0,0,0,6,0,0,72345,26124),
(122847,'','What business do you have with me, $r?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(122848,'Are these your initials?','Are these your initials?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122849,'Well done, Illidan, but the battle has only begun.','',0,0,0,0,0,0,1,0,0,0,72218,0,26124),
(122850,'I would like to challenge Downfall again, mistress.','I would like to challenge Downfall again, mistress.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122851,'The Legion has slain half of our forces and scattered the rest across the grounds. What you see here is all that remains of the Rooksguard protecting the hold.','',0,0,0,0,0,0,1,0,0,0,72219,0,26124),
(122852,'You are our last hope, Illidan!','',0,0,0,0,0,0,0,0,0,0,72220,0,26124),
(122853,'','THIEF! How DARE you steal what is mine?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122854,'','Your funeral.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122855,'','%s shrugs indifferently and kicks you into the sky.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122856,'Do what you must! Should Black Rook Hold fall, all of Suramar will fall with it!','',0,0,0,0,0,0,0,0,0,0,72224,0,26124),
(122857,'Captain Stormrage has given us a fighting chance! Secure the rampart, Rooksguard! Advance!!','',0,0,0,0,0,0,0,0,0,0,72225,0,26124),
(122858,'$n! Khadgar! Thank the Forge I found ye! Ye won\'t believe it! Me brother Magni\'s back!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122859,'','What\'s this?? Ravencrest has sent a pup to face me? I will teach you to respect your betters, child!',0,0,0,0,0,0,0,0,0,0,0,72234,26124),
(122860,'','You... You killed your own soldiers?! You crazed fool! You\'ve sealed your own fate!',0,0,0,0,0,0,0,0,0,0,0,72235,26124),
(122861,'','The pup... has fangs...',0,0,0,0,0,0,0,0,0,0,0,72236,26124),
(122862,'','Run, little Ravencrest, Run! There may still be time for you to flee and live out your final miserable days cowering in a tree somewhere!',0,0,0,0,0,0,0,0,0,0,0,72237,26124),
(122864,'Two?','',0,0,0,0,0,0,0,0,6,0,72349,0,26124),
(122865,'','The Stormrage twins.',0,0,0,0,0,0,0,0,6,0,0,72346,26124),
(122866,'','Beautiful. Nearly identical, except for-',0,0,0,0,0,0,0,0,6,0,0,72347,26124),
(122867,'That one! His eyes are golden!','',0,0,0,0,0,0,0,0,6,0,72350,0,26124),
(122868,'','Indeed. The child is destined for a great and prosperous future. His name... is Illidan.',0,0,0,0,0,0,0,0,6,0,0,72348,26124),
(122869,'Illidan, your anger is misplaced. I have not insulted you.','',0,0,0,0,0,0,0,0,6,0,72351,0,26124),
(122870,'You have cast me out, Cenarius!','',0,0,0,0,0,0,0,0,6,0,72352,0,26124),
(122871,'No. You may remain here, but I will no longer be your teacher.','',0,0,0,0,0,0,0,0,6,0,72353,0,26124),
(122872,'So...','',0,0,0,0,0,0,0,0,6,0,72354,0,26124),
(122873,'So I must learn from... a NOVICE... instead of a MASTER?','',0,0,0,0,0,0,0,0,6,0,72355,0,26124),
(122874,'You must learn respect.','',0,0,0,0,0,0,0,0,6,0,72356,0,26124),
(122875,'To walk this path requires sacrifice, Illidan... Something you have yet to understand.','',0,0,0,0,0,0,0,0,6,0,72357,0,26124),
(122876,'Brother-','',0,0,0,0,0,0,0,0,6,0,72340,0,26124),
(122877,'Behold the Legion\'s power.','',0,0,0,0,0,0,0,0,6,0,72358,0,26124),
(122878,'<Screams in agony>','',0,0,0,0,0,0,0,0,6,0,72359,0,26124),
(122879,'No matter how hard this world fights, it will fall.','',0,0,0,0,0,0,0,0,6,0,72360,0,26124),
(122880,'Our eyes... deceive us.','',0,0,0,0,0,0,0,0,6,0,72361,0,26124),
(122881,'Beyond this army is another... and another... and another...','',0,0,0,0,0,0,0,0,6,0,72362,0,26124),
(122882,'Even if we defeat them here, it will mean nothing.','',0,0,0,0,0,0,0,0,6,0,72363,0,26124),
(122883,'We are doomed...','',0,0,0,0,0,0,0,0,6,0,72364,0,26124),
(122884,'And I will find that way.','',0,0,0,0,0,0,0,0,6,0,72365,0,26124),
(122886,'I will not fail you, my lord!','',0,0,0,0,0,0,66,0,0,0,72322,0,26124),
(122887,'It took nearly all of our energy to conjure that protective barrier. If I push these Moon Guard any harder they will die.','',0,0,0,0,0,0,0,0,0,0,72320,0,26124),
(122888,'If I can repair that deactivated portal I will have the reinforcements I require and a font of power to refresh my energy.','',0,0,0,0,0,0,0,0,0,0,72321,0,26124),
(122889,'Illidan thinks to himself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122890,'Excellent! The power radiating from the portal will energize me so long as I remain nearby. I must remember to return to these portals whenever I am fatigued.','',0,0,0,0,0,0,0,0,0,0,72367,0,26124),
(122891,'I am ready, Lord Ravencrest! Lower the portcullis!','',0,0,0,0,0,0,22,0,0,0,72366,0,26124),
(122892,'Lower the gate and brace yourselves! Glaive throwers at the ready!','',0,0,0,0,0,0,22,0,0,0,72369,0,26124),
(122893,'At your command, captain!','At your command, captain!',0,0,0,0,0,0,66,0,0,0,72374,72375,26124),
(122894,'Archmage, we need to leave.','Archmage, we need to leave.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122895,'Her fel magic is too strong. I could try and siphon energy from my Moon Guard and use it to unleash devastation upon this demon, but my mages will die too.','',0,0,0,0,0,0,0,0,0,0,72379,0,26124),
(122896,'Alas, what choice exists? If I fail, Suramar falls tomorrow, and with it my beloved Tyrande. I must act now!','',0,0,0,0,0,0,0,0,0,0,72901,0,26124),
(122897,'','You dare to defy the Burning Legion? Kneel before the unmatched power of fel!',0,0,0,0,0,0,0,0,0,0,0,72380,26124),
(122898,'You were right, demon. Fel is more powerful than the arcane, but you wield it clumsily! Let me show you what destruction a master\'s touch can bring!','',0,0,0,0,0,0,0,0,0,0,72392,0,26124),
(122899,'|TInterface\\Icons\\Spell_Nature_EyeOfTheStorm:20|t Hyrja begins to cast |cFFFF0404|Hspell:192305|h[Eye of the Storm]|h|r!','|TInterface\\Icons\\Spell_Nature_EyeOfTheStorm:20|t Hyrja begins to cast |cFFFF0404|Hspell:192305|h[Eye of the Storm]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122900,'|TInterface\\Icons\\Spell_Holy_HolyNova:20|t Hyrja begins to cast |cFFFF0404|Hspell:192206|h[Sanctify]|h|r!','|TInterface\\Icons\\Spell_Holy_HolyNova:20|t Hyrja begins to cast |cFFFF0404|Hspell:192206|h[Sanctify]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122906,'I\'m relieved we both made it out of Karazhan in one piece.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122907,'Archmage Modera and I will continue examining the tome we recovered from Karazhan. We WILL find those Pillars, $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122908,'Hmm... That gives me an idea... We\'ll discuss it when you\'ve handled those anomalies.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122911,'Blood and thunder, $n. Your ship, and glorious victory, await.','This is your ship, $n. Light be with you.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(122912,'How war gets the blood pumping, $n! Does your axe not thirst for a duel?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122923,'Can you hear the roar of battle already, $n? It calls to you!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122924,'$n interacts with the Starlight Rose Brew, granting everyone health and mana restoration!','$n interacts with the Starlight Rose Brew, granting everyone health and mana restoration!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122925,'$n destroys the Infernal Tome, granting everyone damage reduction!','$n destroys the Infernal Tome, granting everyone damage reduction!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122926,'$n absorbs the Fel Orb, granting everyone increased critical strike chance!','$n absorbs the Fel Orb, granting everyone increased critical strike chance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122927,'$n releases the Umbral Bloom spores, granting everyone increased haste!','$n releases the Umbral Bloom spores, granting everyone increased haste!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122928,'$n interacts with the Nightshade Refreshments, granting everyone increased health!','$n interacts with the Nightshade Refreshments, granting everyone increased health!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122929,'$n routes the power on the Magical Lantern, granting everyone increased damage!','$n routes the power on the Magical Lantern, granting everyone increased damage!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122930,'$n interprets the Waterlogged Scroll, granting everyone increased movement speed!','$n interprets the Waterlogged Scroll, granting everyone increased movement speed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122932,'$n destroys the Arcane Power Conduit, overloading all Guardian Constructs!','$n destroys the Arcane Power Conduit, overloading all Guardian Constructs!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122933,'$n sneakily adds poison to the Flask of the Solemn Night.','$n sneakily adds poison to the Flask of the Solemn Night.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122934,'Brought all my big rocks for helpin\' da catapults. Gregg want to join da Horde!','This is your ship, $n. Light be with you.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(122935,'If you wish to continue studying the wilds, you may do so with your brother.','',0,0,0,0,0,0,0,0,6,0,72492,0,26124),
(122936,'The six-eyed master has seen your fate, $n! You will fail, and worlds will burn!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(122937,'There is just NO WAY this is a bad idea.','There is just NO WAY this is a bad idea.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122938,'The Legion must be thwarted!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122939,'Dalaran will not fall, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122940,'We will have victory over the Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122941,'Begin the summoning.','Begin the summoning.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122942,'I will summon the spirit of Alodi, the first Guardian of Tirisfal. Let me know when you would like me to begin.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122943,'Malfurion will become the first druid because he is a dedicated student. You... are NOT.','',0,0,0,0,0,0,0,0,6,0,72531,0,26124),
(122944,'My carelessness forces me to fall back. I will learn from this defeat and strike back with a vengeance.','',0,0,0,0,0,0,0,0,0,0,72532,0,26124),
(122945,'Let\'s not do that again!','Let\'s not do that again!',0,0,0,0,0,0,5,0,0,0,72534,72535,26124),
(122946,'I can see all of Suramar from here!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(122947,'Perhaps the wind cleared up the fog.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122948,'There is no end to them!','',0,0,0,0,0,0,0,0,0,0,72538,0,26124),
(122949,'For each demon I kill two more take its place!','',0,0,0,0,0,0,0,0,0,0,72540,0,26124),
(122950,'I must find a way to close that gateway!','',0,0,0,0,0,0,0,0,0,0,72539,0,26124),
(122951,'How could anything stand against such a force?','',0,0,0,0,0,0,0,0,0,0,72541,0,26124),
(122952,'I will end this... I must!','',0,0,0,0,0,0,0,0,0,0,72542,0,26124),
(122953,'I am Illidan, demon! Know my name for it spells your doom!','',0,0,0,0,0,0,0,0,0,0,72543,0,26124),
(122954,'Thousands more! It appears as if the demon armies are coming from the portal in the courtyard below. I\'ll need to destroy it if we\'re to survive, but I\'ll need help from my Moon Guard.','',0,0,0,0,0,0,0,0,0,0,72544,0,26124),
(122955,'Boldly you stand in defiance of the Great Burning Shadow! Minions, kill the \"hero\"!','',0,0,0,0,0,0,0,0,0,0,72545,0,26124),
(122956,'There are too many demons. I... I\'ll need more of my Moon Guard\'s power. Do I go too far? No, I must remain focused! The future of my people lies in my hands!','',0,0,0,0,0,0,0,0,0,0,72673,0,26124),
(122957,'The Nihilam portal is being protected by an eredar known as Balaadur. Conventional spells are useless against it. I\'ll have to call down the fury of the cosmos to destroy the portal. Then it will be just me and the demon.','',0,0,0,0,0,0,0,0,0,0,72674,0,26124),
(122958,'Never have I felt such power... such agony...','',0,0,0,0,0,0,0,0,0,0,72788,0,26124),
(122959,'I am nearly out of energy. I need to find a portal to rest at or siphon the essence of my Moon Guard.','',0,0,0,0,0,0,0,0,0,0,72685,0,26124),
(122960,'I call forth the spirit of the first Guardian!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(122961,'A summons! Ages have passed since I\'ve been called upon for aid.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(122962,'Greetings, Alodi. I am Khadgar, archmage of the Kirin--','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122963,'I know of you. The apprentice who refuses the mantle I first wore. What do you need of me?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122964,'The Burning Legion has returned. To stop them, we scoured the library of Karazhan for a tome you authored called \'Notable Antiquities of Ancient Azeroth\'.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122965,'You read my work? I didn\'t think the younger generation bothered with books anymore. Always playing games, adventuring about...','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(122966,'It\'s too bad we can\'t see Stormheim.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(122967,'','We\'re seeking five ancient artifacts called the Pillars of Creation. Your writing didn\'t specify where to find them.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122968,'Of course not! The Pillars represent primordial power. Even as Guardian, I dared not trifle with them.','',0,0,0,0,0,0,661,0,0,0,0,0,26124),
(122969,'Finding these artifacts is crucial. The Pillars are the only thing that can seal the Legion\'s portal in the Tomb of Sargeras.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122970,'Very well. My research led me to the Broken Isles. Though I never found their exact locations, I believe the Pillars lie in the hands of the peoples of that ancient land.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122971,'','That gives us a place to start, at least. We will search every inch of the Broken Isles if need be.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122972,'Thank you, Guardian. You have served Azeroth once again.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122973,'You must make haste to find them. In the Legion\'s hands, the Pillars of Creation could unleash untold devastation upon our world. Good luck.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122974,'Where\'s the big diamond?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122975,'The diamond walked away?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122976,'Well if he\'s a diamond, I\'m sure he\'ll be okay. Diamonds are tough!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122977,'He\'s gone, lad. He left to follow a greater calling.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122978,'He\'s more than a precious stone. He\'s our king.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122979,'Thank you, lad. I hope you\'re right.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122980,'Speak to me when you\'re ready to begin, $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(122981,'My friend at the orphanage said you\'d always pick the Forsaken above the Horde and abandon us. Is that true?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122982,'','I do not require defending, ambassador. Young one, the mantle of warchief is heavy, but I was chosen to bear the burden.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122983,'','Now I stand for the Horde.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122984,'','You needn\'t worry, child. I am your warchief.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122985,'|TInterface\\Icons\\spell_shadow_zdemonformgreen:20|t%s is casting |cFFFF0000|Hspell:199193|h[Dreadlord\'s Guile]|h|r!','|TInterface\\Icons\\spell_shadow_zdemonformgreen:20|t%s is casting |cFFFF0000|Hspell:199193|h[Dreadlord\'s Guile]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(122986,'Ya need some more trainin\'?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(122987,'I am the mightiest mage-hunter in all of the cosmos! You stand no chance, little elf!','',0,0,0,0,0,0,0,0,0,0,72770,0,26124),
(122988,'Illidan has taken the courtyard! Rooksguard, advance!','',0,0,0,0,0,0,22,0,0,0,72789,0,26124),
(122989,'We will join the battle in the arena! Captain Stomrage, lead the charge!','',0,0,0,0,0,0,22,0,0,0,72790,0,26124),
(122990,'I\'ve thrown everything I have at this creature to no avail. I must ask for the aid of my Moon Guard one final time.','',0,0,0,0,0,0,0,0,0,0,72791,0,26124),
(122991,'Do something, Illidan! It\'s tearing us apart! The hold cannot take much more!','',0,0,0,0,0,0,0,0,0,0,72792,0,26124),
(122992,'Mother Moon forgive me for what I do...','',0,0,0,0,0,0,0,0,0,0,72793,0,26124),
(122993,'Illidan, no!','',0,0,0,0,0,0,0,0,0,0,72794,0,26124),
(122994,'This cannot be!','',0,0,0,0,0,0,0,0,0,0,72797,0,26124),
(122995,'Such savagery...','',0,0,0,0,0,0,0,0,0,0,72795,0,26124),
(122996,'Are we no better than the monsters we fight?','',0,0,0,0,0,0,0,0,0,0,72796,0,26124),
(122997,'What would you have me do, Kur\'talos? Simper and nod to our new Legion overlords as they turn our world to ash?','',0,0,0,0,0,0,0,0,0,0,72798,0,26124),
(122998,'There is always a choice! We could have...','',0,0,0,0,0,0,0,0,0,0,72799,0,26124),
(122999,'We could have what? You are blind, Ravencrest! You are all blind!','',0,0,0,0,0,0,0,0,0,0,72800,0,26124),
(123000,'This was one invasion. They nearly killed everyone here and took Suramar.','',0,0,0,0,0,0,0,0,0,0,72801,0,26124),
(123001,'The best any of you can do is criticize my methods? My mages died saving our world. What have you given? What have you sacrificed?','',0,0,0,0,0,0,0,0,0,0,72802,0,26124),
(123002,'You\'re a damned fool, Ravencrest! No matter. I\'ve learned all I can from you.','',0,0,0,0,0,0,0,0,0,0,72804,0,26124),
(123003,'We will never defeat the Legion so long as cowards hold the reins.','',0,0,0,0,0,0,0,0,0,0,72805,0,26124),
(123004,'Farewell... and good luck. Perhaps you may fare better begging them for your lives next time.','',0,0,0,0,0,0,0,0,0,0,72806,0,26124),
(123005,'Hunt this...','',0,0,0,0,0,0,0,0,0,0,72807,0,26124),
(123006,'','|TInterface\\Icons\\Spell_Shadow_Possession:20|t %s begins to cast |cFFFF0000|Hspell:227233|h[Corrupted Bellow]|h|r. Look out!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123007,'The resources of Dalaran are at your disposal. From here, heroes of Alliance and Horde alike will search for the Pillars of Creation!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123008,'I\'ve heard rumors of powerful artifacts that may be of use in your campaign. Keep an eye out and a useful lead just might present itself!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(123009,'Now I must attend to other visitors. Good luck, $n!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123010,'We must gather our strength. The spell to move the city will be taxing.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123011,'','We\'ve never moved Dalaran twice in such a short span of time.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123012,'I will aid you as best I can. It is an honor to serve the Kirin Tor.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123013,'Give us time to prepare, $n.$b$bProtect the city from the Legion, or use your map to find an invasion to stop.$b$bWhen the time is right to begin, I will call for you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123014,'Brann Bronzebeard!? Well, this is unexpected.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123016,'Are you ready for me to dispel this barrier?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(123017,'Let\'s save Magni!','Let\'s save Magni!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123018,'Ye must go with Khadgar and find the Pillars, $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123019,'I am ready to leave for Karazhan.','I am ready to leave for Karazhan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123020,'Are ye ready ta enter the Planetarium?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123021,'Let\'s go inside!','Let\'s go inside!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123023,'I would like to requisition some Black Harvest troops.','I would like to requisition some Black Harvest troops.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123024,'The Earthen Ring is with ye, Farseer! We\'ll stand with ye against the Burning Legion no matter the cost!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123026,'The Ebon Blade shall prevail. None shall stand in our way... and live.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123027,'I have to jump into the arena to destroy that monstrosity. Mother Moon give me strength.','',0,0,0,0,0,0,0,0,0,0,73227,0,26124),
(123028,'|TInterface\\Icons\\ability_mage_arcanebarrage_nightborne:20|tYou are targeted by |cFFF00000|Hspell:220871|h[Unstable Mana]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123029,'You must be below level 101 to participate in Legion Invasions.','You must be below level 101 to participate in Legion Invasions.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123030,'Do you have another Flight Master\'s Whistle?','Do you have another Flight Master\'s Whistle?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123033,'You feel a staggering presence on the other side of the portal touch you for a moment...','You feel a staggering presence on the other side of the portal touch you for a moment...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123035,'They don\'t pay me enough for this!','They don\'t pay me enough for this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123036,'I\'m not going back to the mailroom!','I\'m not going back to the mailroom!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123037,'Love is an antiquated ideal born out of an instinctual response!','Love is an antiquated ideal born out of an instinctual response!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123038,'<Beakbuck eyes you warily.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123039,'<Ride Beakbuck.>','<Ride Beakbuck.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123040,'Jump over the effect to avoid damage from |cFFFF0404|Hspell:211901|h[Fusion Press]|h|r!','Jump over the effect to avoid damage from |cFFFF0404|Hspell:211901|h[Fusion Press]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123042,'%s and $n collided, causing a Grand Trine!','%s and $n collided, causing a Grand Trine!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123043,'%s\'s Star Sign expired, causing a Grand Trine!','%s\'s Star Sign expired, causing a Grand Trine!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123044,'','Now for something most magnificent!',0,0,0,0,0,0,0,0,0,0,0,77156,26124),
(123045,'','This place could stand to be Galindre-fied!',0,0,0,0,0,0,0,0,0,0,0,77157,26124),
(123046,'','How beautifully...tragic.',0,0,0,0,0,0,0,0,0,0,0,77145,26124),
(123047,'','I\'m counting on you, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123048,'What is the mission?','What is the mission?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123049,'Welcome, ladies and gentlemen, to our--OOF!','',0,0,0,0,0,0,0,0,0,0,77471,0,26124),
(123050,'Shut your jabber, drama man! The Monkey King got another plan!','',0,0,0,0,0,0,0,0,0,0,77472,0,26124),
(123051,'Tonight we got a horkin\' show, an ookin\' tale you think you know.','',0,0,0,0,0,0,0,0,0,0,77473,0,26124),
(123052,'That evil Crone? She\'s not the worst. Another witch was nasty first.','',0,0,0,0,0,0,0,0,0,0,77474,0,26124),
(123053,'','Are you ready to begin?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123054,'Let\'s get underway.','Let\'s get underway.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123055,'','|TInterface\\Icons\\spell_arcane_arcanetorrent_nightborne:20|tGalindre is casting |cFFFF0404|Hspell:227776|h[Magic Magnificent]|h|r! Use |TInterface\\Icons\\spell_priest_void blast:20|t|cFFFF0404|Hspell:227405|h[Defy Gravity]|h|r\'s vortices to escape!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(123060,'','Together, we\'re unlimited!',0,0,0,0,0,0,0,0,0,0,0,77146,26124),
(123061,'','Follow my lead and you\'ll be popular!',0,0,0,0,0,0,0,0,0,0,0,77158,26124),
(123062,'','Sorry to bring you down!',0,0,0,0,0,0,0,0,0,0,0,77147,26124),
(123063,'','You deserve a chance to fly!',0,0,0,0,0,0,0,0,0,0,0,77148,26124),
(123064,'','Come see my minions, and let them be heard!',0,0,0,0,0,0,0,0,0,0,0,77149,26124),
(123065,'','elekkamomen otunbuntu rotu kelaramen!',0,0,0,0,0,0,0,0,0,0,0,77150,26124),
(123066,'','That one needed a makeover.',0,0,0,0,0,0,0,0,0,0,0,77159,26124),
(123067,'','Have you misplaced your wikket mind?',0,0,0,0,0,0,0,0,0,0,0,77160,26124),
(123068,'','For the first time, I feel... wikket.',0,0,0,0,0,0,0,0,0,0,0,77151,26124),
(123069,'','That was quite a commotion!',0,0,0,0,0,0,0,0,0,0,0,77152,26124),
(123071,'Intruder! Sound the alarm!','Intruder! Sound the alarm!',0,0,0,0,0,0,0,0,0,0,0,61226,26124),
(123072,'I\'ve been training for this moment!','I\'ve been training for this moment!',0,0,0,0,0,0,0,0,0,0,0,61225,26124),
(123073,'You\'ll get no further, invader!','You\'ll get no further, invader!',0,0,0,0,0,0,0,0,0,0,0,61224,26124),
(123074,'This world has no place for you, demon!','This world has no place for you, demon!',0,0,0,0,0,0,0,0,0,0,0,61223,26124),
(123075,'Your kind is not welcome here!','Your kind is not welcome here!',0,0,0,0,0,0,0,0,0,0,0,61222,26124),
(123076,'I\'ll wipe your blood off my blade, just like the rest!','I\'ll wipe your blood off my blade, just like the rest!',0,0,0,0,0,0,0,0,0,0,0,61221,26124),
(123077,'I have slain hundreds before you. You\'ll simply be one more notch on my belt.','I have slain hundreds before you. You\'ll simply be one more notch on my belt.',0,0,0,0,0,0,0,0,0,0,0,61220,26124),
(123078,'I will grant you a swift death, trespasser.','I will grant you a swift death, trespasser.',0,0,0,0,0,0,0,0,0,0,0,61219,26124),
(123095,'I think it wise to divide our efforts. I\'ll work to circumvent the tower\'s magical defenses. You may need to take a more... blunt force approach.','',0,0,0,0,0,0,1,0,0,0,78192,0,26124),
(123096,'','I failed you,  Sargeras...',0,0,0,0,0,0,0,0,0,0,0,74346,26124),
(123097,'The army that marches on Azeroth is but a whisper of the Legion\'s true strength.','',0,0,0,0,0,0,0,0,6,0,76045,0,26124),
(123098,'unless we find another way to fight them.','',0,0,0,0,0,0,0,0,6,0,74340,0,26124),
(123099,'|cffADFF2F+$1i Nightfallen Reputation|r','|cffADFF2F+$1i Nightfallen Reputation|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123100,'|TInterface\\Icons\\Spell_Holy_InnerFire:20|t%s is casting |cFFFF0000|Hspell:227789|h[Sacred Ground]|h|r at you!','|TInterface\\Icons\\Spell_Holy_InnerFire:20|t%s is casting |cFFFF0000|Hspell:227789|h[Sacred Ground]|h|r at you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(123101,'|TInterface\\Icons\\Spell_Holy_PrayerOfHealing:20|t%s is casting |cFFFF0000|Hspell:227508|h[Mass Repentance]|h|r!','|TInterface\\Icons\\Spell_Holy_PrayerOfHealing:20|t%s is casting |cFFFF0000|Hspell:227508|h[Mass Repentance]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(123102,'It seems I have been too gentle. Have at thee!','',0,0,0,0,0,0,0,0,0,0,77574,0,26124),
(123103,'Well done... so far! But I will judge for myself whether you are worthy!','',0,0,0,0,0,0,0,0,0,0,77575,0,26124),
(123104,'Champions! You have spilled the blood of Helya\'s minions. The time has come to enter Helheim itself and end the sea witch\'s dark reign. But first... a final challenge!','',0,0,0,0,0,0,0,0,0,0,77576,0,26124),
(123105,'Hymdall! Hyrja! Test the mettle of these mortals. I must be certain they possess the courage and skill needed for what is to come.','',0,0,0,0,0,0,0,0,0,0,77577,0,26124),
(123106,'The battle is yours to begin, heroes!','',0,0,0,0,0,0,0,0,0,0,77578,0,26124),
(123108,'','Elfyra, come down from there! You\'re fluttering about like one of those horrible monkey creatures!',0,0,0,0,0,0,0,0,0,0,0,77161,26124),
(123109,'','Of course, dear! Though that old frock of yours... Oh, look! Some new friends have come to pay us a visit.',0,0,0,0,0,0,0,0,0,0,0,77162,26124),
(123110,'','We all deserve a chance to fly! Hey, do you really think the Wizard will de-greenify me?',0,0,0,0,0,0,0,0,0,0,0,77153,26124),
(123111,'','I don\'t have any friends... well, apart from you, Galindre.',0,0,0,0,0,0,0,0,0,0,0,77154,26124),
(123112,'The Legion is assaulting Dalaran at Deadwind Pass, and assaulting it too hard apparently.\n\nWhy don\'t I just complete the ritual here and you can meet up with us over the Broken Isles?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123113,'I cannot get to Dalaran over Deadwind Pass to aid you, please teleport me to Dalaran in the Broken Isles directly.','I cannot get to Dalaran over Deadwind Pass to aid you, please teleport me to Dalaran in the Broken Isles directly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123114,'ENOUGH! Your worth is proven! With you as my champions, Helya will fall and I will at long last be free of the curse that binds me here.','',0,0,0,0,0,0,0,0,0,0,77579,0,26124),
(123115,'You\'re not thinking I\'m someone else?','',0,0,0,0,0,0,396,0,0,0,77118,0,26124),
(123116,'','Mrgrlglrllrr.',0,0,0,0,0,0,396,0,0,0,0,77119,26124),
(123117,'Or that we\'ve met before?','',0,0,0,0,0,0,396,0,0,0,77120,0,26124),
(123118,'','Grrmgmrlgmrrm.',0,0,0,0,0,0,396,0,0,0,0,77121,26124),
(123119,'I felt, I knew something never before was going to happen, had to happen. But this is so much more.','',0,0,0,0,0,0,396,0,0,0,77122,0,26124),
(123120,'','Mgrmglrm.',0,0,0,0,0,0,396,0,0,0,0,77123,26124),
(123121,'It\'s so much to believe. You\'re not making a joke?','',0,0,0,0,0,0,396,0,0,0,77124,0,26124),
(123122,'','Mlgrmgrlmgrmrrrmgrrr.',0,0,0,0,0,0,396,0,0,0,0,77125,26124),
(123123,'','Mrrmgmrlgmm.',0,0,0,0,0,0,396,0,0,0,0,77126,26124),
(123124,'','Grlmgmmrr!',0,0,0,0,0,0,396,0,0,0,0,77127,26124),
(123126,'|TInterface\\Icons\\ability_bossfelmagnaron_rune.blp:20|t Odyn begins to |cFFFF0404|Hspell:227503|h[Draw Power]|h|r from the runes!','|TInterface\\Icons\\ability_bossfelmagnaron_rune.blp:20|t Odyn begins to |cFFFF0404|Hspell:227503|h[Draw Power]|h|r from the runes!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123132,'I\'ve heard this tale before... <Skip the Legion introductory quests and begin your journey in Dalaran.>','I\'ve heard this tale before... <Skip the Legion introductory quests and begin your journey in Dalaran.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123133,'Are you sure you want to skip the Broken Shore introduction? \nThis quest can be reacquired from Archivist Elysiana in Dalaran City in the Broken Isles.','Are you sure you want to skip the Broken Shore introduction? \nThis quest can be reacquired from Archivist Elysiana in Dalaran City in the Broken Isles.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123134,'The scent of blood is on the winds.','This is your ship, $n. Light be with you.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(123135,'The arcwine has soured... you must start over!','The arcwine has soured... you must start over!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123138,'The Menagerie is for-- ERADICATE! ERADICATE!','',0,0,0,0,0,0,0,0,0,0,77181,0,26124),
(123139,'Curator is no longer op... er... ation... al.','',0,0,0,0,0,0,0,0,0,0,77182,0,26124),
(123140,'Overload in progress. Prepare for-- PURGE! PURGE! PURGE!','',0,0,0,0,0,0,0,0,0,0,77183,0,26124),
(123141,'EXTERMINATED!','',0,0,0,0,0,0,0,0,0,0,77184,0,26124),
(123142,'Attention guests: DIE! DIE! DIE!','',0,0,0,0,0,0,0,0,0,0,77185,0,26124),
(123143,'Your withered will get lost if you leave them behind!','Your withered will get lost if you leave them behind!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123144,'','Use Shamanistic Rage!',0,0,0,0,0,0,0,0,0,0,0,75244,26124),
(123145,'Use Shamanistic Rage!','',0,0,0,0,0,0,0,0,0,0,75251,0,26124),
(123146,'','Farondis is responsible for our curse... he will pay dearly!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123147,'','There will never be peace with Farondis, so long as we are cursed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123148,'We\'re going to need more paint at this rate.','We\'re going to need more paint at this rate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123149,'There\'s so little time! I can\'t work under these conditions!','There\'s so little time! I can\'t work under these conditions!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123150,'Survival hunters thrive in close quarters combat, where they use a combination of tools to viciously overwhelm their prey.','',0,0,0,0,0,0,0,0,0,0,77857,0,26124),
(123151,'Survival hunters thrive in close quarters combat, where they use a combination of tools to viciously overwhelm their prey.','',0,0,0,0,0,0,0,0,0,0,78816,0,26124),
(123152,'Alongside your trusty pet, you are the master of your environment. Call Pet will summon your pet to your side.','',0,0,0,0,0,0,0,0,0,0,64877,0,26124),
(123154,'Use Call Pet to bring your pet to battle.','',0,0,0,0,0,0,0,0,0,0,59966,0,26124),
(123156,'Your enemies will find that once you have them in your sights they are unlikely to escape.','',0,0,0,0,0,0,0,0,0,0,77805,0,26124),
(123157,'Using your Harpoon ability you can snag your enemy and propel yourself towards them.','',0,0,0,0,0,0,0,0,0,0,77807,0,26124),
(123158,'Use Harpoon against the target dummy.','',0,0,0,0,0,0,0,0,0,0,77809,0,26124),
(123159,'Now that you have closed the distance to your prey it\'s time to wear them down with a wound they will have trouble recovering from.','',0,0,0,0,0,0,0,0,0,0,77811,0,26124),
(123160,'Lacerate will cause your target to bleed, dealing damage to them over time.','',0,0,0,0,0,0,0,0,0,0,77813,0,26124),
(123161,'Use Lacerate on the target dummy.','',0,0,0,0,0,0,0,0,0,0,77815,0,26124),
(123162,'Remember to use Lacerate whenever your target is not affected by it.','',0,0,0,0,0,0,0,0,0,0,77817,0,26124),
(123163,'It\'s time to team up on your target!','',0,0,0,0,0,0,0,0,0,0,77819,0,26124),
(123164,'Flanking Strike is a coordinated attack between you and your pet that can do crippling damage.','',0,0,0,0,0,0,0,0,0,0,77821,0,26124),
(123166,'Use Flanking Strike on the target dummy.','',0,0,0,0,0,0,0,0,0,0,77823,0,26124),
(123167,'Your most powerful tactic is to get your opponent reeling and then steadily increase your damage until they are defeated.','',0,0,0,0,0,0,0,0,0,0,77831,0,26124),
(123168,'Mongoose Bite is an attack that gets more powerful each time you use it.','',0,0,0,0,0,0,0,0,0,0,77833,0,26124),
(123169,'Store up charges of Mongoose Bite, then unleash them all at once for maximum effect.','',0,0,0,0,0,0,0,0,0,0,77835,0,26124),
(123170,'Use Mongoose Bite on the target dummy.','',0,0,0,0,0,0,0,0,0,0,77837,0,26124),
(123174,'Sometimes you\'ll find yourself outnumbered. Don\'t worry, you can unleash destruction upon a host of adversaries at once!','',0,0,0,0,0,0,0,0,0,0,77859,0,26124),
(123175,'Carve will sweep your weapon in front of you dealing damage to all targets in its path.','',0,0,0,0,0,0,0,0,0,0,77861,0,26124),
(123176,'Use Carve to dispatch all the enemies.','',0,0,0,0,0,0,0,0,0,0,77863,0,26124),
(123182,'Use Harpoon!','',0,0,0,0,0,0,0,0,0,0,77847,0,26124),
(123183,'Use Lacerate!','',0,0,0,0,0,0,0,0,0,0,77849,0,26124),
(123184,'Use Flanking Strike!','',0,0,0,0,0,0,0,0,0,0,77845,0,26124),
(123185,'Use Mongoose Bite!','',0,0,0,0,0,0,0,0,0,0,77851,0,26124),
(123186,'Use Carve to damage multiple enemies at once!','',0,0,0,0,0,0,0,0,0,0,77841,0,26124),
(123187,'Use Feign Death to escape!','',0,0,0,0,0,0,0,0,0,0,77843,0,26124),
(123194,'','Use Call Pet to bring your pet to battle.',0,0,0,0,0,0,0,0,0,0,0,65041,26124),
(123195,'','Alongside your trusty pet, you are the master of your environment. Call Pet will summon your pet to your side.',0,0,0,0,0,0,0,0,0,0,0,65042,26124),
(123198,'You will be flagged for PvP if you remain in this area!','You will be flagged for PvP if you remain in this area!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123199,'I need another Mana Divining Stone.','I need another Mana Divining Stone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123200,'','Use Carve to dispatch all the enemies.',0,0,0,0,0,0,0,0,0,0,0,77864,26124),
(123201,'','Carve will sweep your weapon in front of you dealing damage to all targets in its path.',0,0,0,0,0,0,0,0,0,0,0,77862,26124),
(123202,'','Sometimes you\'ll find yourself outnumbered. Don\'t worry, you can unleash destruction upon a host of adversaries at once!',0,0,0,0,0,0,0,0,0,0,0,77860,26124),
(123203,'','Survival hunters thrive in close quarters combat, where they use a combination of tools to viciously overwhelm their prey.',0,0,0,0,0,0,0,0,0,0,0,78817,26124),
(123204,'','Survival hunters thrive in close quarters combat, where they use a combination of tools to viciously overwhelm their prey.',0,0,0,0,0,0,0,0,0,0,0,77856,26124),
(123205,'','Use Mongoose Bite!',0,0,0,0,0,0,0,0,0,0,0,77852,26124),
(123206,'','Use Lacerate!',0,0,0,0,0,0,0,0,0,0,0,77850,26124),
(123207,'','Use Harpoon!',0,0,0,0,0,0,0,0,0,0,0,77848,26124),
(123208,'','Use Flanking Strike!',0,0,0,0,0,0,0,0,0,0,0,77846,26124),
(123209,'','Use Feign Death to escape!',0,0,0,0,0,0,0,0,0,0,0,77844,26124),
(123210,'','Use Carve to damage multiple enemies at once!',0,0,0,0,0,0,0,0,0,0,0,77842,26124),
(123211,'','Use Mongoose Bite on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,77838,26124),
(123212,'','Store up charges of Mongoose Bite, then unleash them all at once for maximum effect.',0,0,0,0,0,0,0,0,0,0,0,77836,26124),
(123213,'','Mongoose Bite is an attack that gets more powerful each time you use it.',0,0,0,0,0,0,0,0,0,0,0,77834,26124),
(123214,'','Your most powerful tactic is to get your opponent reeling and then steadily increase your damage until they are defeated.',0,0,0,0,0,0,0,0,0,0,0,77832,26124),
(123215,'','Use Flanking Strike on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,77824,26124),
(123217,'','Flanking Strike is a coordinated attack between you and your pet that can do crippling damage.',0,0,0,0,0,0,0,0,0,0,0,77822,26124),
(123218,'','It\'s time to team up on your target!',0,0,0,0,0,0,0,0,0,0,0,77820,26124),
(123219,'','Remember to use Lacerate whenever your target is not affected by it.',0,0,0,0,0,0,0,0,0,0,0,77818,26124),
(123220,'','Use Lacerate on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,77816,26124),
(123221,'','Lacerate will cause your target to bleed, dealing damage to them over time.',0,0,0,0,0,0,0,0,0,0,0,77814,26124),
(123222,'','Now that you have closed the distance to your prey it\'s time to wear them down with a wound they will have trouble recovering from.',0,0,0,0,0,0,0,0,0,0,0,77812,26124),
(123223,'','Use Harpoon against the target dummy.',0,0,0,0,0,0,0,0,0,0,0,77810,26124),
(123224,'','Using your Harpoon ability you can snag your enemy and propel yourself towards them.',0,0,0,0,0,0,0,0,0,0,0,77808,26124),
(123225,'','Your enemies will find that once you have them in your sights they are unlikely to escape.',0,0,0,0,0,0,0,0,0,0,0,77806,26124),
(123226,'','Do you wish to hear a tale from the past, $n?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123227,'I want to experience the Broken Shore and its aftermath.','I want to experience the Broken Shore and its aftermath.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123228,'I want to experience the return of Magni Bronzebeard and Khadgar\'s adventures in Karazhan.','I want to experience the return of Magni Bronzebeard and Khadgar\'s adventures in Karazhan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123229,'I want to experience the Siege of Dalaran and summoning of Alodi.','I want to experience the Siege of Dalaran and summoning of Alodi.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123230,'Um, what?','Um, what?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123231,'|TInterface\\Icons\\spell_mage_infernoblast:20|tYou are targeted by |cFFF00000|Hspell:227615|h[Inferno Bolt]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123232,'Simply stay within any given orb as it travels through the air and you\'ll be able to fly!  See, I\'m doing it right now!  Move from orb to orb to find out where they lead.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123233,'','It\'s simple really. Head over the cube and interact with it to start a round of its game. Simply follow the path it displays before filling out the entire grid and you\'ll score a round. Score enough rounds and the cube should activate for you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123234,'','Hop on one of my mana sabers and steer it through the tall nodes of Ley Energy you see around you. Steer it through enough Ley Energy to fully charge it and you\'ll be done!  Remember, the mana saber is great at going fast in a straight line; but it slows down through turns.  Try and minimize the amount of steering corrections you need.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123239,'','I do not believe you possess the mental acuity to grasp the nature of portal magic.',274,0,0,0,0,0,0,0,1,0,0,0,26124),
(123240,'','As a mage, you are one of a select group that can conjure a portal to transport you back to this very place.  I can teach you if you are ready.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(123241,'The Legion\'s arrival is no surprise. The power beneath the tower existed long before you or I.$B$BIt is most unfortunate how we\'ve arrived in our current state, but I\'m afraid it was only a matter of time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123244,'You are too far away! Move back in range before he gets away!','You are too far away! Move back in range before he gets away!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123245,'Hey there, $n! You lookin\' to obliterate some gear? Maybe use some Obliterum to make the gear you\'re wearin\' more powerful? Then I\'m your dwarf! Ask away!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123246,'It\'s easy! You just take some crafted gear - you know, hats, rings, relics, flasks, that sort of thing - and you throw \'em right into this fella\'s little fiery mouth-area. Add some Blood of Sargeras, for fuel, and ka-pow! You\'ve got Obliterum!\n\nY\'see, those crafters are always usin\' stuff like FELWORT, DEMONSTEEL, and CHAOS CRYSTALS to make their gear. Lots o\' demony-stuff in that armor. Make the demony-stuff hot enough, and you\'ve got Obliterum!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123247,'Once you\'ve got enough obliterum ash, you can kinda sorta glump it together into a little ball. Then you just rub it onto your crafted armor, and the armor becomes stronger.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123248,'You watch your tongue! Desdemona was no donkey, she was a mule!\n\nAnyways, I sold her for three Bloods o\' Sargeras. I\'m gonna make some boots.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123249,'How do I get Obliterum?','How do I get Obliterum?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123250,'What can I do with Obliterum?','What can I do with Obliterum?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123251,'What happened to your donkey?','What happened to your donkey?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123252,'','My magic will put an end to you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123253,'Puny creature... Muscle crush you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123254,'Yes... your brain will do nicely... give it to me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123255,'Let us see what resides in your soul, mortal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123256,'Your soul is forfeit!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123257,'Fresh meat for my hounds!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123258,'','Struggle hard... I like my prey exhausted.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123259,'I will fight her in your name, Odyn!','I will fight her in your name, Odyn!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123260,'Will you venture into the depths of Helheim and slay Helya?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123261,'This one is a disaster. I want the Gnomish piece downstairs!','',0,0,0,0,0,0,661,0,0,0,0,0,26124),
(123262,'','Ok, ok... but you\'re buying brunch.',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(123263,'','You are a fortunate individual! Of course, I\'ll need a sample of your brain tissue...',0,0,0,0,0,0,0,0,0,0,0,77645,26124),
(123264,'Auugh! Gross! I feel funky.','',0,0,0,0,0,0,0,0,0,0,77646,0,26124),
(123265,'The Nightborne Spy has gotten away!','The Nightborne Spy has gotten away!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123266,'','Did you see that?! An epic-tier full-roaming vapor! Nasty one, too!',0,0,0,0,0,0,0,0,0,0,0,77647,26124),
(123267,'Get Willy a healer! I haven\'t seen a gnome this pale since... oh wait, all gnomes are pale.','',0,0,0,0,0,0,0,0,0,0,77648,0,26124),
(123268,'I don\'t believe the master is expecting you!','',0,0,0,0,0,0,0,0,0,0,77509,0,26124),
(123269,'Perhaps your party would be more comfortable at the children\'s table.','',0,0,0,0,0,0,0,0,0,0,77510,0,26124),
(123270,'Seems I\'ll be... retiring... for... the evening...','',0,0,0,0,0,0,0,0,0,0,77511,0,26124),
(123271,'May I take your jacket?','',0,0,0,0,0,0,0,0,0,0,77512,0,26124),
(123272,'Stop troubling the master\'s guests!','',0,0,0,0,0,0,0,0,0,0,77513,0,26124),
(123273,'I appreciate your help, $n. I\'m sure my luck will change soon.$b$bSay, do you think my armor looks dark enough?','',547,0,0,0,0,0,0,0,0,0,0,0,26124),
(123274,'What do you sell, Moorgoth?','What do you sell, Moorgoth?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123275,'Ladies and gentlemen, welcome to this evening\'s feature presentation!','',0,0,0,0,0,0,396,0,0,0,77128,0,26124),
(123276,'Tonight... we meet two lovers born on opposite sides of Sentinel Hill.','',0,0,0,0,0,0,396,0,0,0,77129,0,26124),
(123277,'Divided by generations of enmity, they are brought together by passion for dance... and violence!','',0,0,0,0,0,0,396,0,0,0,77130,0,26124),
(123278,'As the song of their love rumbles across the fields, will it end in triumph... or tragedy? And now... on with the show!','',0,0,0,0,0,0,396,0,0,0,77131,0,26124),
(123279,'Wanna go for a spin?','',0,0,0,0,0,0,0,0,0,0,77132,0,26124),
(123280,'Now that\'s what I call a hot foot!','',0,0,0,0,0,0,0,0,0,0,77133,0,26124),
(123281,'I\'m just gonna... play it cool.','',0,0,0,0,0,0,0,0,0,0,77134,0,26124),
(123282,'It\'s you and me against the world, baby!','',0,0,0,0,0,0,0,0,0,0,77135,0,26124),
(123283,'So ya wanna rumble, do ya?','',0,0,0,0,0,0,0,0,0,0,77136,0,26124),
(123284,'Let\'s dance!','',0,0,0,0,0,0,0,0,0,0,77137,0,26124),
(123285,'Beat it!','',0,0,0,0,0,0,0,0,0,0,77138,0,26124),
(123286,'Go on... scram!','',0,0,0,0,0,0,0,0,0,0,77139,0,26124),
(123287,'A gang that don\'t own the fields is nothin\'!','',0,0,0,0,0,0,0,0,0,0,77140,0,26124),
(123288,'I dug you punks an early grave!','',0,0,0,0,0,0,0,0,0,0,77141,0,26124),
(123289,'I\'ll never... stop saying... Mrrgria...','',0,0,0,0,0,0,0,0,0,0,77142,0,26124),
(123290,'There\'s a... place for us... somewhere...','',0,0,0,0,0,0,0,0,0,0,77143,0,26124),
(123291,'Brambley! I can hardly believe my eyes... yer alive!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123292,'Ehmm... what bones? Oh you mean these? I.. errh...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123293,'Aye...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123294,'What? Oh.. now that ye\' mention it...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123295,'What\'s with all the bones?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123296,'You thought those were my bones... didn\'t you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123297,'That one isn\'t even human.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123298,'We should get out of here before it\'s too late.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123299,'Well, well! Another group of thieves trying to steal my horse!','',0,0,0,0,0,0,0,0,0,0,77166,0,26124),
(123300,'My trophy collection grows!','',0,0,0,0,0,0,0,0,0,0,77167,0,26124),
(123301,'Easy prey!','',0,0,0,0,0,0,0,0,0,0,77168,0,26124),
(123302,'They had no chance! I kill for a living!','',0,0,0,0,0,0,0,0,0,0,77169,0,26124),
(123303,'Well done, Midnight!','',0,0,0,0,0,0,0,0,0,0,77170,0,26124),
(123304,'Rise up, Midnight! Stamp them into dust!','',0,0,0,0,0,0,0,0,0,0,77171,0,26124),
(123305,'I... have become... the hunted.','',0,0,0,0,0,0,0,0,0,0,77172,0,26124),
(123306,'Form ranks! Charge!','',0,0,0,0,0,0,0,0,0,0,77173,0,26124),
(123307,'My quarry never escapes!','',0,0,0,0,0,0,0,0,0,0,77174,0,26124),
(123308,'Time to face my quarry toe-to-toe!','',0,0,0,0,0,0,0,0,0,0,77175,0,26124),
(123309,'We ride, Midnight! To victory!','',0,0,0,0,0,0,0,0,0,0,77176,0,26124),
(123310,'The hound sniffs the air excitedly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123311,'The hound stares in your direction.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123312,'The hound growls.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123313,'The demons o\' the Burnin\' Legion have got another thing comin\' if they think ol\' Angus is cooked! I\'ve got more tricks up mah\' sleeve than a Dalaran mage!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123314,'The Underbelly','The Underbelly',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(123315,'A seedy place of thugs and criminals, and none too fragrant, either.$B$BThere are at least three ways in: Entrances in the east and west, and a well in the north.','A seedy place of thugs and criminals, and none too fragrant, either.$B$BThere are at least three ways in: Entrances in the east and west, and a well in the north.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(123316,'A Hero\'s Welcome is located right beside Greyfang Enclave in southwestern Dalaran.$B$BThe place boasts a beer garden and one of the city\'s finest cooking trainer in its kitchen.','A Hero\'s Welcome is located right beside Greyfang Enclave in southwestern Dalaran.$B$BThe place boasts a beer garden and one of the city\'s finest cooking trainer in its kitchen.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(123317,'You\'re looking for The Filthy Animal in the Horde quarter of Windrunner\'s Sanctuary, northeastern Dalaran.$B$BI am told it is a rather rough place, but with an excellent cooking trainer in its kitchen.','You\'re looking for The Filthy Animal in the Horde quarter of Windrunner\'s Sanctuary, northeastern Dalaran.$B$BI am told it is a rather rough place, but with an excellent cooking trainer in its kitchen.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(123318,'Krasus\' Landing is in easternmost Dalaran.$B$BThe city\'s flight master is there.','Krasus\' Landing is in easternmost Dalaran.$B$BThe city\'s flight master is there.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(123319,'Visiting members of the Alliance keep primarily to Greyfang\'s Enclave in southwestern Dalaran.$B$BThere is an inn there, as well as portals to various cities.','Visiting members of the Alliance keep primarily to Greyfang\'s Enclave in southwestern Dalaran.$B$BThere is an inn there, as well as portals to various cities.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(123320,'The visiting Horde keep primarily to the Windrunner\'s Sanctuary in northeastern Dalaran.$B$BThere is an inn there, as well as portals to the various cities.','The visiting Horde keep primarily to the Windrunner\'s Sanctuary in northeastern Dalaran.$B$BThere is an inn there, as well as portals to the various cities.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(123321,'Chamber of the Guardian','Chamber of the Guardian',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(123322,'The Chamber of the Guardian is a magical focus located directly in the center of Dalaran.','The Chamber of the Guardian is a magical focus located directly in the center of Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(123323,'You are in luck! A new shop called Things of the Past has recently opened its doors in the Magus Commerce Exchange.','You are in luck! A new shop called Things of the Past has recently opened its doors in the Magus Commerce Exchange.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(123324,'I would like to witness the fall of Illidan Stormrage at the Black Temple again, Xe\'ra.','I would like to witness the fall of Illidan Stormrage at the Black Temple again, Xe\'ra.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123325,'','You carry with you the Claws of Ashamane, druid. We still tell stories of her bravery throughout the grove.',0,0,0,0,0,0,463,0,0,0,0,0,26124),
(123326,'','I see you\'ve recovered the Claws of Ursoc from the Emerald Dream. Can you match his tenacity, druid?',0,0,0,0,0,0,463,0,0,0,0,0,26124),
(123327,'I sense the spirit of a wild beast within you, druid. As though Ashamane stalks among us again.','I sense the spirit of a wild beast within you, druid. As though Ashamane stalks among us again.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123328,'The others have not misled me - the spirit of Ursoc has come to Thunder Totem!','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(123329,'The Fangs of Ashamane - what a wonder you wield, $n! The great panther spirit died fighting the Legion in the grove just below us.','The Fangs of Ashamane - what a wonder you wield, $n! The great panther spirit died fighting the Legion in the grove just below us.',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(123330,'Miners trainers and supplies are found upstairs in Tanks for Everything in the Magus Commerce Exchange, northwest Dalaran.','Miners trainers and supplies are found upstairs in Tanks for Everything in the Magus Commerce Exchange, northwest Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(123331,'Applebough\'s fruit cart is usually in southwest Dalaran.','Applebough\'s fruit cart is usually in southwest Dalaran.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(123332,'Do you see, Farah? $n is here. So long as the spirit of Ursoc walks among us, we have nothing to fear from the harpies.','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(123333,'','Wait a moment, $n. Is that the ancient bow of the Windrunners? My father fought alongside Alleria in the second war. I never thought we\'d see that weapon again...',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(123334,'Ah. HAH! Hunter. That bow of yours. It is the weapon of a champion. I sense it\'s gone beyond this world, has it not?','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123335,'Oh yes, $n! Those daggers of yours would cut quite a swath through the Legion, wouldn\'t they? Are those demon bits? Biting the hand that breeds them? I like what I see.','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123336,'','Rogue, are those - demon fangs? Are you using demon teeth as a weapon? That\'s disgusting!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(123337,'','$n, are you dual-wielding demon fangs? I like the way you think!',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(123338,'','Help us... priest... your staff shines with a light such that I\'ve never seen before...',0,0,0,0,0,0,20,0,0,0,0,0,26124),
(123343,'','Ohhh... do you feel that? A warmth in the air? A great light shines from within this strange priest\'s staff...',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(123344,'<Snorting, slurring his words as he speaks.>$B$BNo! Friend must not hurt Rezzle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123345,'What are you doing here?','What are you doing here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123346,'It\'s good to see Alodi\'s greatstaff in the hands of such a skilled mage, $n. The Kirin Tor is counting on you!','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123347,'Why shouldn\'t I kill you, demon?','Why shouldn\'t I kill you, demon?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123348,'A bitter chill in the air... and here is the source. This mage bears the staff of the first guardian.','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',0,0,0,0,0,0,463,0,0,0,0,0,26124),
(123349,'As Midnight falters, the Huntsman attacks afoot!','As Midnight falters, the Huntsman attacks afoot!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123350,'You bring the fury of the winds to Thunder Totem, monk. As though you hold a stormcloud in each fist.','You bring the fury of the winds to Thunder Totem, monk. As though you hold a stormcloud in each fist.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123351,'Look here, Brulf. This one has the fury of twin storms in $ghis:her; hands. Ha-hah, fight on little $r!','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123352,'Rezzle following mistress\' orders!$B$BRezzle only gather samples for magics.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123353,'Magic? What kind of magic?','Magic? What kind of magic?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123354,'The Thicket is a dangerous place, would you like me to transport you out?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123355,'I need to be transported out of here.','I need to be transported out of here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123356,'Rezzle not know magic, friend. Rezzle only carry things!$B$BIf Rezzle learn magic, Rezzle no gather samples for mistress...$B$B<Smirking wildly.>$B$BRezzle make own magic.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123357,'So, you\'re a servant?','So, you\'re a servant?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123358,'Yes... YES! Rezzle serve well! Rezzle serve...$B$B<The demon glances around nervously.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123359,'I don\'t have time for games! Tell me of your master.','I don\'t have time for games! Tell me of your master.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123360,'Careful, monk. There\'s a storm coming.','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(123361,'%s eyes $n\'s weapons.','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123362,'Nevermind that. You ARE the storm.','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123363,'I have no use for you, demon!','I have no use for you, demon!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123364,'Mistress ordered to keep mortals out of tower. Her master needs tower for VERY big magic. In Burning Legion, even masters have masters!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123365,'<Rezzle cowers, stooping closer to the stone beneath his feet.>$B$BNo hitting Rezzle! If friend hurts Rezzle, Rezzle cannot help friend.$B$BRezzle knows things to help friend!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123366,'Very well, continue.','Very well, continue.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123367,'You\'d better be telling the truth, Rezzle!','You\'d better be telling the truth, Rezzle!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123368,'Priest... that staff you carry... it is unstable. I can sense its chaos from here.','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123369,'','This priest is certain to help us, Mardranel. I sense a great holy energy in $ghis:her; staff - powerful, yet barely contained.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123370,'Good evening, ladies and gentlemen. We proudly welcome you to this evening\'s feature presentation!','',0,0,0,0,0,0,0,0,0,0,77084,0,26124),
(123371,'Tonight... a tale of romance and rage, one which will prove once and for all if beauty is more than skin deep.','',0,0,0,0,0,0,0,0,0,0,77085,0,26124),
(123372,'Can the fair Bella learn to love the surly Brute? Or will a ghastly curse claim the lives of the prince and his servants?','',0,0,0,0,0,0,0,0,0,0,77086,0,26124),
(123373,'See for yourself whether the rose of passion blooms beneath a beastly veneer! And now... on with the show!','',0,0,0,0,0,0,0,0,0,0,77087,0,26124),
(123374,'Luminore! Mrs. Cauldrons! Babblet! Let us disperse with these interlopers!','',0,0,0,0,0,0,0,0,0,0,77088,0,26124),
(123375,'Delightful! One less guest for dinner!','',0,0,0,0,0,0,0,0,0,0,77089,0,26124),
(123376,'Never stand in the way of true love!','',0,0,0,0,0,0,0,0,0,0,77090,0,26124),
(123377,'It seems... my rose... has... wilted...','',0,0,0,0,0,0,0,0,0,0,77091,0,26124),
(123378,'Zee candle MINE!','',0,0,0,0,0,0,0,0,0,0,77092,0,26124),
(123379,'No... take... zee... candle...','',0,0,0,0,0,0,0,0,0,0,77093,0,26124),
(123380,'Quickly now! Get rid of them!','',0,0,0,0,0,0,0,0,0,0,77094,0,26124),
(123381,'Zee true love, eet burnses!','',0,0,0,0,0,0,0,0,0,0,77095,0,26124),
(123382,'','Hope I don\'t spoil your appetite, dearies!',0,0,0,0,0,0,0,0,0,0,0,77096,26124),
(123383,'','Guess I\'m... sleeping in... the cupboard.',0,0,0,0,0,0,0,0,0,0,0,77097,26124),
(123384,'','That didn\'t go very well at all, did it?',0,0,0,0,0,0,0,0,0,0,0,77098,26124),
(123385,'','That\'ll teach you to flirt with my boyfriend!',0,0,0,0,0,0,0,0,0,0,0,77099,26124),
(123386,'','Only beauty... can kill... a brute...',0,0,0,0,0,0,0,0,0,0,0,77100,26124),
(123387,'','Who... who are you?',0,0,0,0,0,0,6,0,0,0,0,77101,26124),
(123388,'The master of this castle! You will be my guest for dinner!','',0,0,0,0,0,0,396,0,0,0,77102,0,26124),
(123389,'','Never! I only dine with gentlemen, not a brute like you!',0,0,0,0,0,0,603,0,0,0,0,77103,26124),
(123390,'Fine! Starve to death for all I care!','',0,0,0,0,0,0,603,0,0,0,77104,0,26124),
(123391,'Oh no, no, no... this won\'t do! You outsiders will ruin our final chance to break the curse!','',0,0,0,0,0,0,0,0,0,0,77105,0,26124),
(123392,'','If you didn\'t yell all the time, I wouldn\'t run away.',0,0,0,0,0,0,396,0,0,0,0,77106,26124),
(123393,'I don\'t yell ALL the time. WHY DO YOU ALWAYS SAY THAT?!','',0,0,0,0,0,0,603,0,0,0,77107,0,26124),
(123394,'','There you go again!',0,0,0,0,0,0,579,0,0,0,0,77108,26124),
(123395,'Fine. Hey, do you like books?','',0,0,0,0,0,0,24,0,0,0,77109,0,26124),
(123396,'','Oooooh, I love books!',0,0,0,0,0,0,71,0,0,0,0,77110,26124),
(123397,'It\'s working! It\'s working!','',0,0,0,0,0,0,0,0,0,0,77111,0,26124),
(123398,'The curse... it\'s... killing me...','',0,0,0,0,0,0,274,0,0,0,77112,0,26124),
(123399,'','No! Our dinners together... those hours in the library... Oh Brute, I love you!',0,0,0,0,0,0,18,0,0,0,0,77113,26124),
(123400,'It\'s... too... late...','',0,0,0,0,0,0,396,0,0,0,77114,0,26124),
(123401,'','<Gasp> Who are you?!',0,0,0,0,0,0,6,0,0,0,0,77115,26124),
(123402,'Bella... it\'s me!','',0,0,0,0,0,0,273,0,0,0,77116,0,26124),
(123403,'','It IS you! Come, my love. Off to our happily ever after!',0,0,0,0,0,0,71,0,0,0,0,77117,26124),
(123404,'','This one reeks of fel energy. Hey, warlock! Is that the Scepter of Sargeras? How did you cajole the Kirin Tor into giving that thing up?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123405,'Oh good. Here comes $n with the Scepter of Sargeras. You know, in case we need to punch a hole in spacetime and shatter the planet.','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123406,'I say, $r. Is that the Scepter of Sargeras? Indeed! Quite the dodgy bit of history you\'ve got there, hm?','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123407,'','No one... mourns... the wikket...',0,0,0,0,0,0,0,0,0,0,0,77155,26124),
(123408,'','If you\'re my friend, you\'ll make the hozen get rid of these interlopers... then we\'re off to see the Wizard!',0,0,0,0,0,0,0,0,0,0,0,77163,26124),
(123409,'','Some have... wikketness... thrust... upon them...',0,0,0,0,0,0,0,0,0,0,0,77164,26124),
(123410,'','I... loathe... all you... ookers...',0,0,0,0,0,0,0,0,0,0,0,77165,26124),
(123411,'This action costs 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?','This action costs 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123412,'This action costs 15 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?','This action costs 15 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123413,'This action costs 5 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?','This action costs 5 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123415,'','Mrgrrlmgrr.',0,0,0,0,0,0,396,0,0,0,0,77144,26124),
(123416,'Ah, faithful Midnight. For many years, our countless hunts provided game for the master\'s table.','',0,0,0,0,0,0,0,0,0,0,77177,0,26124),
(123417,'These days we hunt for sport... and the glory of the kill!','',0,0,0,0,0,0,0,0,0,0,77178,0,26124),
(123418,'My... long hunt... has ended.','',0,0,0,0,0,0,0,0,0,0,77179,0,26124),
(123419,'Good show, old friend! Let\'s fetch you some oats.','',0,0,0,0,0,0,0,0,0,0,77180,0,26124),
(123420,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,6276,0,26124),
(123421,'Welcome to the-- TERMINATE INTRUDERS!','',0,0,0,0,0,0,0,0,0,0,77229,0,26124),
(123422,'System... failure... im... mi... nent...','',0,0,0,0,0,0,0,0,0,0,77228,0,26124),
(123423,'Countermeasures deployed.','',0,0,0,0,0,0,0,0,0,0,77224,0,26124),
(123424,'DETERRENT ACTIVATED!','',0,0,0,0,0,0,0,0,0,0,77227,0,26124),
(123425,'I do so detest party crashers!','',0,0,0,0,0,0,0,0,0,0,77514,0,26124),
(123426,'Deterrent protocols successful.','',0,0,0,0,0,0,0,0,0,0,77226,0,26124),
(123427,'The master hasn\'t been himself for quite some time. Perhaps a feast will brighten his spirit!','',0,0,0,0,0,0,0,0,0,0,77515,0,26124),
(123428,'Janitorial units: begin Menagerie decontamination.','',0,0,0,0,0,0,0,0,0,0,77225,0,26124),
(123429,'The guards really must do a better job of keeping out the ruffians.','',0,0,0,0,0,0,0,0,0,0,77516,0,26124),
(123430,'Master... I hope... I served you... well...','',0,0,0,0,0,0,0,0,0,0,77517,0,26124),
(123431,'I insist you dress for dinner!','',0,0,0,0,0,0,0,0,0,0,77518,0,26124),
(123432,'Mind your manners!','',0,0,0,0,0,0,0,0,0,0,77519,0,26124),
(123433,'','|TInterface\\Icons\\SPELL_SHAMAN_TIDALWAVES.BLP:20|t %s calls upon the |cFFFF0000|Hspell:228300|h[Fury of the Maw]|h|r. Get to high ground!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(123434,'','|TInterface\\Icons\\achievement_dungeon_MawofSouls.blp:20|t A thick mist rolls into the bay...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(123435,'|TInterface\\Icons\\Spell_Shadow_Charm:20|t%s inhales deeply for a |cFFFF0000|Hspell:228837|h[Bellowing Roar]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(123436,'|TInterface\\Icons\\SPELL_SHADOW_LIFEDRAIN02:20|t%s begins to |cFFFF0000|Hspell:228835|h[Absorb Vitality]|h|r from |cFFFF0000$n|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(123438,'Weakness is never tolerated.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123439,'What do you require?','What do you require?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123440,'For aeons, Helya has been building an army. Stealing the souls of fallen vrykul to oppose the Valarjar.','',0,0,0,0,0,0,0,0,0,0,78317,0,26124),
(123441,'Traitor!','Traitor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123442,'You are one of them! Die, interloper!','You are one of them! Die, interloper!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123443,'Rebel! I will end you!','Rebel! I will end you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123444,'Elisande will praise me for killing you!','Elisande will praise me for killing you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123445,'You dare show yourself here!? Die, fiend!','You dare show yourself here!? Die, fiend!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123446,'I thought I was the only one... I stand with the Dusk Lily!','I thought I was the only one... I stand with the Dusk Lily!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123447,'I cannot believe what Elisande is doing to her own people. I must fight back!','I cannot believe what Elisande is doing to her own people. I must fight back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123448,'I kept quiet when the demons came, but this... this is unspeakable.','I kept quiet when the demons came, but this... this is unspeakable.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123449,'I knew there were others! I will no longer bloody my hands for Elisande!','I knew there were others! I will no longer bloody my hands for Elisande!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123450,'Elisande must be stopped!','Elisande must be stopped!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123451,'This is too much... if I must be labeled a traitor then so be it!','This is too much... if I must be labeled a traitor then so be it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123452,'Helya has taken the souls of those Valarjar? Impossible! Strike her mystics down, then return to me.','',0,0,0,0,0,0,1,0,0,0,78322,0,26124),
(123453,'Seeing her master fall, Midnight unleashes all her fury!','Seeing her master fall, Midnight unleashes all her fury!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123454,'How dare she so brashly oppose me!','',0,0,0,0,0,0,0,0,0,0,78318,0,26124),
(123455,'Helya can corrupt the Stormforged!','Helya can corrupt the Stormforged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123456,'DELETE','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123457,'No need to delay. Onto the pad with you.','',0,0,0,0,0,0,25,0,0,0,78389,0,26124),
(123459,'DELETE','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123460,'','It\'s too late for me. They took... Vanthir...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123461,'Elisande knows about Vanthir\'s involvement in the rebellion. He is gone.','',0,0,0,0,0,0,0,0,0,0,78392,0,26124),
(123468,'Brigitte? Emille?! Where are you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123469,'Praise all that is good... you are both safe. Come, let us get out of here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123471,'Where is it? The master\'s vase?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123472,'Oh, thank you! This masterpiece is worth my life a hundred times over.','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(123473,'','%s spits on the corpse of the demon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123474,'','I told him not to take one step closer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123476,'','I know where to find Shal\'Aran. Come, ladies. We are no longer safe in the city.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(123477,'Get up! We must leave!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(123479,'F-father... Run...','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(123480,'Outlander, can you hear me? Outlander? I am going to teleport a beacon your way!','',0,0,0,0,0,0,0,0,0,0,78558,0,26124),
(123481,'','Behold this motley throng in which the rebels put their faith.',0,0,0,0,0,0,0,0,6,0,0,78243,26124),
(123482,'','Kaldorei? You disgrace a glorious past, hiding in trees and cloaking yourselves in false piety. You have grown as savage as the trolls that skulk about your forests.',0,0,0,0,0,0,0,0,6,0,0,78241,26124),
(123483,'','Quel\'dorei? You are peasants playing at nobility, all too willing to mingle with lesser races that dilute your bloodline. You are unworthy of the name high elves.',0,0,0,0,0,0,0,0,6,0,0,78242,26124),
(123484,'','Sin\'dorei? Of all the elves, I thought you might understand the choice I made to save my people. Instead, you ally with misfits and monsters.',0,0,0,0,0,0,0,0,6,0,0,78245,26124),
(123485,'','Each of you has debased your proud lineage. Each of you has forgotten the ancient power that is our birthright.',0,0,0,0,0,0,0,0,6,0,0,78240,26124),
(123486,'','But Suramar remembers! We are the Nightborne, last of the true elves. The rest of you are hollow echoes of our greatness.',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(123487,'','Let this failed rebellion be a lesson to any that would stand against the shal\'dorei!',0,0,0,0,0,0,0,0,6,0,0,78244,26124),
(123489,'Double your efforts, lest you go by the board!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123490,'All hands report! We are to get underway!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123491,'Helya beckons!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123492,'You\'re... too late...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123493,'Noooooo!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123494,'I suspect the sea witch grows impatient, eager to begin her campaign by conquering the Broken Isles.','',0,0,0,0,0,0,0,0,0,0,78319,0,26124),
(123495,'Helya\'s foul magics trap Odyn and hinder the Valarjar. We need champions like you to stop her advances.','',0,0,0,0,0,0,0,0,0,0,78320,0,26124),
(123496,'Helya must be stopped. The time has come for a reckoning!','',0,0,0,0,0,0,0,0,0,0,78321,0,26124),
(123497,'I have had enough of that foul sorceress\' games!','',0,0,0,0,0,0,0,0,0,0,77637,0,26124),
(123498,'That sea witch must learn the price of her defiance!','',0,0,0,0,0,0,0,0,0,0,78208,0,26124),
(123499,'','Lasuel and I have been friends since we were children. We shared the best times of our lives together.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123500,'Leave us be, pests!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123501,'Lousy imps! Let us work!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123502,'Mean dooker locked up all us hozen! Another path she should have chosen.','',0,0,0,0,0,0,0,0,0,0,77475,0,26124),
(123503,'So sit and slerp, relax a jibbet! Enjoy the show that we call... Wikket!','',0,0,0,0,0,0,0,0,0,0,77476,0,26124),
(123504,'','Arcanist Thalyssra. I remember where your order stood in the War of the Ancients. How do we know you won\'t betray us and become the next Elisande... the next Azshara?',0,0,0,0,0,0,0,0,0,0,0,78630,26124),
(123505,'','The kaldorei will fight to see the Legion defeated and the Nightwell destroyed. Beyond that... we shall see where Elune\'s wisdom guides us.',0,0,0,0,0,0,0,0,0,0,0,78632,26124),
(123506,'','And once your rival is defeated, why should we believe you won\'t betray us for the Nightwell\'s arcane power and become the next Elisande... the next Azshara?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123507,'','We know where Elisande\'s path would lead us, and ask for your help to end her reign.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123508,'','We do not intend to be slaves to the Nightwell. We seek to drive the Legion from Suramar and put an end to Elisande\'s oppression.',0,0,0,0,0,0,0,0,0,0,0,78631,26124),
(123509,'','[CUT]If that is your wish, so be it. When this war is won, my people will need allies. It is clear you will not be among them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123511,'DELETE','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123512,'','I understand the struggles of the Nightfallen echo our own, First Arcanist. Addiction.... betrayal...',0,0,0,0,0,0,0,0,0,0,0,78635,26124),
(123513,'','Cleanse it we shall. The sin\'dorei bring righteous fury upon our enemies.',0,0,0,0,0,0,0,0,0,0,0,78637,26124),
(123514,'','There is a cure for our addiction, but it will take time to administer it to all of our people. First we must depose Elisande and cleanse Suramar of the Legion\'s filth.',0,0,0,0,0,0,0,0,0,0,0,78636,26124),
(123515,'Thank you for coming. We are here to discuss our mutual interests.','',0,0,0,0,0,0,0,0,0,0,78629,0,26124),
(123516,'[CUT]We share a common goal. We must stop the Burning Legion and Gul\'dan at all costs.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123517,'Thalyssra, your knowledge of the enemy will be crucial in the battle ahead. We shall call on you as needed.','',0,0,0,0,0,0,0,0,0,0,78633,0,26124),
(123518,'Thank you for coming. We are here to discuss our mutual interests.','',0,0,0,0,0,0,0,0,0,0,78634,0,26124),
(123519,'This way, $n! Archmage Leryda and I will hold them off as long as we can, but you must hurry!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123520,'','Alturus, watchout! Oh, is that you, $n? You look... different.',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(123521,'Your Arcane-Infused Vial warms as it emanates a soft glow.','Your Arcane-Infused Vial warms as it emanates a soft glow.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123522,'|TInterface\\Icons\\INV_Misc_Horn_03:20|t Hymdall begins to blow the |cFFFF0404|Hspell:228012|h[Horn of Valor]|h|r!','|TInterface\\Icons\\INV_Misc_Horn_03:20|t Hymdall begins to blow the |cFFFF0404|Hspell:228012|h[Horn of Valor]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123523,'','... As you say.',0,0,0,0,0,0,1,0,0,0,0,78401,26124),
(123524,'','Not an undeserved reaction. Ordinarily I would be obliged to slay you both.',0,0,0,0,0,0,396,0,0,0,0,78402,26124),
(123525,'','Present circumstances make us allies.',0,0,0,0,0,0,113,0,0,0,0,78403,26124),
(123526,'|TINTERFACE\\ICONS\\SPELL_SHAMAN_IMPROVEDFIRENOVA:20|tShade of Medivh begins to cast |cFFF00000|Hspell:228269|h[Flame Wreath]|h|r!','|TINTERFACE\\ICONS\\SPELL_SHAMAN_IMPROVEDFIRENOVA:20|tShade of Medivh begins to cast |cFFF00000|Hspell:228269|h[Flame Wreath]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123527,'Felsoul Hold... of all the ways she has betrayed us, this is surely the worst.','',0,0,0,0,0,0,1,0,0,0,78471,0,26124),
(123528,'|TInterface\\Icons\\INV_Polearm_2H_OdynSpear_D_01.blp:20|t Odyn targets you with a |cFFFF0404|Hspell:228918|h[Stormforged Spear]|h|r!','|TInterface\\Icons\\INV_Polearm_2H_OdynSpear_D_01.blp:20|t Odyn targets you with a |cFFFF0404|Hspell:228918|h[Stormforged Spear]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(123529,'','|TInterface\\Icons\\inv_misc_monsterhorn_03.blp:20|t A %s emerges near Helya!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123530,'The Nightborne have agreed to cast off their unwanted.','',0,0,0,0,0,0,0,0,0,0,78468,0,26124),
(123531,'The passage to Felsoul Hold is open. See that our prisoners reach their destination.','',0,0,0,0,0,0,0,0,0,0,78469,0,26124),
(123532,'The Soul Engine will consume! Kar Dan\'Ashj!','',0,0,0,0,0,0,0,0,0,0,78470,0,26124),
(123533,'','DELETE ME',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123534,'We need a foothold, somewhere we can keep an eye on things.','',0,0,0,0,0,0,0,0,0,0,78555,0,26124),
(123535,'Tichar! Your attention!','',0,0,0,0,0,0,0,0,0,0,78467,0,26124),
(123536,'Ahhh, much better. You had us worried for a moment there.','',0,0,0,0,0,0,0,0,0,0,78357,0,26124),
(123537,'The stench of the Kvaldir pollutes Azsuna\'s shores! Push them back into the sea!','',0,0,0,0,0,0,0,0,0,0,77638,0,26124),
(123538,'We have drawn our line in the sand. The Helarjar will find no quarter here.','',0,0,0,0,0,0,0,0,0,0,77639,0,26124),
(123540,'Let there be no slack in their chains!','',0,0,0,0,0,0,0,0,0,0,78449,0,26124),
(123541,'Pick up the pace! The Soul Engine awaits!','',0,0,0,0,0,0,0,0,0,0,78450,0,26124),
(123542,'We must not leave the Soul Engine waiting!','',0,0,0,0,0,0,0,0,0,0,78451,0,26124),
(123543,'More come from Suramar every hour! Move out! Make room!','',0,0,0,0,0,0,0,0,0,0,78452,0,26124),
(123544,'Let us not squander this gift of souls. Move them out!','',0,0,0,0,0,0,0,0,0,0,78453,0,26124),
(123545,'','We will hold the perimeter!',0,0,0,0,0,0,0,0,0,0,0,78441,26124),
(123546,'Work quickly, my friend.','',0,0,0,0,0,0,0,0,0,0,78443,0,26124),
(123547,'','Make sure you teach that demon a lesson.',0,0,0,0,0,0,0,0,0,0,0,78442,26124),
(123548,'The Legion bears down on us, we have but moments to spare.\n\nThe shockwave of arcane energies we are about to unleash should prove powerful enough to send them back to their cursed dimension for a time, giving us time to catch our breath and begin the search for the Pillars of Creation.\n\nAre you ready?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123549,'I am ready, begin the teleportation of Dalaran to the Broken Isles.','I am ready, begin the teleportation of Dalaran to the Broken Isles.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123550,'','I am glad to see a friendly face on this battlefield, $p.$b$bIt is... hard... for me to once again walk in Suramar. Ten thousand years have passed since my feet last felt the grass of this land.$b$bBack then, we were fleeing the Burning Legion.$b$bI never believed I would return to the place of my birth to wrest it from the grasp of those I once believed were my people.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123551,'','Speak quickly, $r. I do not want you lingering in my camp.$b$bYour Horde left a good friend of mine to die on the Broken Shore. Be grateful we have a common enemy for the time being.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123552,'','When I let you take the Tears of Elune, I assumed the next time we would see each other would be at the final battle with the Legion.$b$bI did not expect to see you in the company of mana addicts at the footsteps of the city of my birth.$b$bSpeak quickly, $r. I am not in the mood for Thalyssra\'s petitions.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123553,'','Suramar. I was born here. Never in ten thousand years did I believe I would return with an army to claim it from the same elves I once looked to for protection.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123554,'Plans from Thalyssra.','Plans from Thalyssra.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123555,'','So the time has come to march an army upon the city of my birth. May Elune grant us a quick end to this conflict.',0,0,0,0,0,0,0,0,0,0,0,78236,26124),
(123556,'The Magistrix\'s thugs are impeding Deline\'s efforts to distribute arcwine. Find her in the canals and protect her as she feeds our people.','',0,0,0,0,0,0,0,0,0,0,78459,0,26124),
(123557,'','I must speak with you, champion. Meet with me as soon as you are able.',0,0,0,0,0,0,0,0,0,0,0,78354,26124),
(123558,'','I never thought I would share a camp with the kaldorei. But, desperate times, desperate measures.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123559,'','For the record, I counseled against trusting any Horde in this campaign. I have lost a husband and a King to the treachery of the Horde.$b$bI see no reason to trust you now or ever.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123560,'','Good. We do not have the numbers to hold this place for long. The sooner we press on the better.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123561,'','Few understand the plight of the Nightfallen better than the Sin\'dorei. My heart goes out to them.$b$bBut Thalyssra must understand that there is a difference between an insurrection and a war.$b$bUntil now, her rebels have got by with a few skirmishes here and there. But they have not been hardened by battle as we blood elves have.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123564,'','Your leaders need to get their heads in the game.$b$bVereesa is so obsessed with her desire for revenge against the Horde that we cannot trust our flank to her.$b$bTyrande is a sentinel. She knows little of war on this type of battlefield. While her scouting is useful she should recuse the Kal\'dorei from the main assault.$b$bMy blood knights are the only ones prepared to carry the weight of this conflict.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123565,'Even as we suffer under the heel of the Magistrix, our people must be nourished. They are the backbone of our rebellion.','',0,0,0,0,0,0,0,0,0,0,78460,0,26124),
(123566,'','The rebels are ready for battle? Impressive. Let us see what they can do.',0,0,0,0,0,0,0,0,0,0,0,78238,26124),
(123567,'','And the shal\'dorei are stronger than you expect. When the time comes, we will fight beside you.',0,0,0,0,0,0,0,0,0,0,0,78638,26124),
(123568,'','[CUT]There are still Nightborne in the city who blindly follow the Grand Magistrix. We must be careful not to hurt any innocents!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123569,'','[CUT]So be it. I will alert our forces inside the city. There is much I still have to learn about the world we left behind.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123570,'The demons have opened a portal to bring forth more of their accursed kin. Destroy their infestation before the forest is overrun!','',0,0,0,0,0,0,0,0,0,0,80570,0,26124),
(123571,'Please, any arcwine you can spare... I have children!','Please, any arcwine you can spare... I have children!',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(123572,'Over here... I haven\'t had arcwine in days!','Over here... I haven\'t had arcwine in days!',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(123573,'Help me! The guards took everything I had!','Help me! The guards took everything I had!',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(123574,'','Catch!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123575,'','Take this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123577,'I\'m saved... Thank you!','I\'m saved... Thank you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123578,'I am in your debt.','I am in your debt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123579,'The Legion\'s foothold within the forest has been destroyed! Thanks to your help, the land will recover.','',0,0,0,0,0,0,0,0,0,0,80571,0,26124),
(123580,'|TInterface\\Icons\\INV_Icon_ShadowCouncilOrb_purple.blp:20|t An |cFFFF0000|Hspell:227920|h[Orb of Corruption]|h|r is following you!','|TInterface\\Icons\\INV_Icon_ShadowCouncilOrb_purple.blp:20|t An |cFFFF0000|Hspell:227920|h[Orb of Corruption]|h|r is following you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(123581,'|TInterface\\Icons\\INV_Icon_ShadowCouncilOrb_green.blp:20|t An |cFFFF0000|Hspell:228058\n|h[Orb of Corrosion]|h|r is following you!','|TInterface\\Icons\\INV_Icon_ShadowCouncilOrb_green.blp:20|t An |cFFFF0000|Hspell:228058\n|h[Orb of Corrosion]|h|r is following you!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(123583,'We must complete the ritual as one... Until Helya\'s will is done!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123584,'','Oh no... Odyn\'s mighty champions have come to end my reign. Whatever shall I do?',0,0,0,0,0,0,0,0,0,0,0,77477,26124),
(123585,'','So kind of you to deliver your souls to me... it will save my Val\'kyr the trouble of fetching them from the surface world.',0,0,0,0,0,0,0,0,0,0,0,77478,26124),
(123586,'','Come, mortals. You have earned an eternity of torment!',0,0,0,0,0,0,0,0,0,0,0,77479,26124),
(123587,'','Your souls belong to me!',0,0,0,0,0,0,0,0,0,0,0,77480,26124),
(123588,'','Another soul drowned!',0,0,0,0,0,0,0,0,0,0,0,77481,26124),
(123590,'','Mine! Mine forever!',0,0,0,0,0,0,0,0,0,0,0,77482,26124),
(123591,'','Drown in despair, lapdogs of Odyn!',0,0,0,0,0,0,0,0,0,0,0,77483,26124),
(123592,'Where is this master you speak of located?','Where is this master you speak of located?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123593,'Mistress deep in dirt beneath tower.$B$BMistress always busy, but makes time for Rezzle.$B$BNow... Rezzle scared to go back! What if mistress thinks Rezzle turned traitor?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123594,'Line them up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123595,'Ah, look, another prisoner!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123597,'','Odyn\'s fabled champions... HA! Barely worth my time.',0,0,0,0,0,0,0,0,0,0,0,77484,26124),
(123598,'','Soon the Halls of Valor will fall. Odyn\'s last days are upon him!',0,0,0,0,0,0,0,0,0,0,0,77485,26124),
(123599,'','My reign... cannot end...',0,0,0,0,0,0,0,0,0,0,0,77486,26124),
(123600,'','Damn you... Odyn... damn... you...',0,0,0,0,0,0,0,0,0,0,0,77487,26124),
(123601,'','He... must not... win...',0,0,0,0,0,0,0,0,0,0,0,77488,26124),
(123602,'','Let the shadows take you!',0,0,0,0,0,0,0,0,0,0,0,77489,26124),
(123603,'','Darkness upon your soul!',0,0,0,0,0,0,0,0,0,0,0,77490,26124),
(123604,'','Shiver! Tremble! Quake!',0,0,0,0,0,0,0,0,0,0,0,77491,26124),
(123605,'','Relish the cold kiss of the sea!',0,0,0,0,0,0,0,0,0,0,0,77492,26124),
(123606,'','Touchy, touchy!',0,0,0,0,0,0,0,0,0,0,0,77493,26124),
(123607,'','Do I have your attention?',0,0,0,0,0,0,0,0,0,0,0,77494,26124),
(123608,'','Soon you will join the ranks of my Kvaldir!',0,0,0,0,0,0,0,0,0,0,0,77495,26124),
(123609,'','Your efforts are for naught, mortals! Odyn will NEVER be free!',0,0,0,0,0,0,0,0,0,0,0,77496,26124),
(123610,'','Behold my army of the damned!',0,0,0,0,0,0,0,0,0,0,0,77497,26124),
(123611,'','Your doom lurks within the fog!',0,0,0,0,0,0,0,0,0,0,0,77498,26124),
(123612,'','The cold will shatter you!',0,0,0,0,0,0,0,0,0,0,0,77499,26124),
(123613,'','You\'ll catch your death of cold!',0,0,0,0,0,0,0,0,0,0,0,77500,26124),
(123614,'','Breathe deep... and despair!',0,0,0,0,0,0,0,0,0,0,0,77501,26124),
(123615,'','I\'ll blow you a kiss!',0,0,0,0,0,0,0,0,0,0,0,77502,26124),
(123616,'','Break upon the waves!',0,0,0,0,0,0,0,0,0,0,0,77503,26124),
(123622,'','That laggard sent ye fer his gunpowder? He lost it fair and square!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123623,'Be careful, $n. Even with the vial\'s additional protection it can only withstand so much.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123624,'Ah, the interrogator has arrived. You\'d best tell $Ghim:her; what you know, demon!','Ah, the interrogator has arrived. You\'d best tell $Ghim:her; what you know, demon!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123625,'','Come out from the shadows! The Rebellion brings arcwine for all!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123626,'','Feed your families! Come get a bottle of arcwine!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123627,'','I cannot stay for very long- I am expected back at the palace. We must be quick.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123628,'What have you heard about Vanthir?','What have you heard about Vanthir?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123629,'|TInterface\\Icons\\spell_fire_felfire.blp:20|tThe %s acquires |cFFFF0000$n|r as a target of |cFFFF0000|Hspell:229242|h[Fel Beam]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(123630,'You rang?','',0,0,0,0,0,0,0,0,0,0,9316,0,26124),
(123631,'Remember, $n. Though you may appear to be one of their kind, they may not be so quick to see you as such. Be careful.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123632,'You will be alone in the end.','',0,0,0,0,0,0,0,0,1,0,14372,0,26124),
(123633,'All that you know will fade.','',0,0,0,0,0,0,0,0,1,0,14375,0,26124),
(123634,'Hope is an illusion.','',0,0,0,0,0,0,0,0,1,0,14374,0,26124),
(123635,'Trust is your weakness.','',0,0,0,0,0,0,0,0,1,0,14373,0,26124),
(123636,'|TInterface\\Icons\\SPELL_SHADOW_SHADOWANDFLAME:20|t%s casts |cFFFF0000|Hspell:228796|h[Ignite Soul]|h|r on |cFFFF0000$n|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(123637,'','I will find him. Preferably without being seen.',0,0,0,0,0,0,0,0,0,45772,0,78416,26124),
(123638,'Hey there, chum! Today we\'re holdin\' a contest for extreme anglers! All you gotta do to win is be one of the FIRST FIFTY PEOPLE IN THE WORLD to bring me a heap of tasty tastyfish. Now reel up and roll out!','',0,0,0,0,0,0,0,0,1,0,78018,0,26124),
(123639,'Congratulations, you\'ve won the Stranglethorn Fishing Extravaganza! Someday you\'ll tell your grandkids about this. Oh, and hey... thanks for all the fish!','',0,0,0,0,0,0,0,0,0,0,78022,0,26124),
(123640,'And we have our first-place winner! Congratulations!','',0,0,0,0,0,0,0,0,0,0,78021,0,26124),
(123641,'We\'re halfway done, and I\'m runnin\' out of prizes here. Keep those fishhooks flyin\'!','',0,0,0,0,0,0,0,0,0,0,78020,0,26124),
(123642,'That\'s it for this week, folks! Fishing contest: OVER!','',0,0,0,0,0,0,0,0,0,0,78019,0,26124),
(123643,'Helya\'s cursed magic threatens Highmountain. Her ritual must not be completed!','',0,0,0,0,0,0,1,0,0,0,77640,0,26124),
(123644,'A decisive victory! The sea witch overplayed her hand.','',0,0,0,0,0,0,1,0,0,0,77641,0,26124),
(123645,'The Kvaldir are menacing hapless villagers? Pathetic! Banish those cowards to the watery depths!','',0,0,0,0,0,0,1,0,0,0,77642,0,26124),
(123646,'Helya grows desperate... her downfall draws nigh!','',0,0,0,0,0,0,1,0,0,0,77643,0,26124),
(123647,'I believe in the Dusk Lily.','I believe in the Dusk Lily.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123648,'The way is clear? Thank you, friend.','The way is clear? Thank you, friend.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123649,'I must leave before more guards come.','I must leave before more guards come.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123650,'Is it true? We can be free of the Nightwell?','Is it true? We can be free of the Nightwell?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123651,'This is madness!','This is madness!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123652,'We will not serve the Legion.','We will not serve the Legion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123653,'BONE STORM!','',0,0,0,0,0,0,0,0,0,0,77520,0,26124),
(123655,'Shall we be lenient with these pets of yours, Odyn?','',0,0,0,0,0,0,0,0,0,0,77591,0,26124),
(123656,'Hold nothing back! I must know they are ready for the task ahead.','',0,0,0,0,0,0,0,0,0,0,77580,0,26124),
(123657,'','So be it! The unworthy shall be purged from the Halls of Valor!',0,0,0,0,0,0,0,0,0,0,0,77597,26124),
(123659,'','Fall in line!',0,0,0,0,0,0,0,0,0,0,0,77598,26124),
(123660,'','Stand together--or die alone!',0,0,0,0,0,0,0,0,0,0,0,77599,26124),
(123661,'Only cowards fear the call of battle!','',0,0,0,0,0,0,0,0,0,0,77592,0,26124),
(123662,'Is there truly valor in your hearts?','',0,0,0,0,0,0,0,0,0,0,77593,0,26124),
(123663,'If you will vow to take up this burden and end her reign, speak now, and I will send you forth into the fray!','',0,0,0,0,0,0,0,0,0,0,77581,0,26124),
(123664,'Valarjar! Prepare the runes! These heroes need testing...','',0,0,0,0,0,0,0,0,0,0,77582,0,26124),
(123665,'Runebearers! Feed me power!','',0,0,0,0,0,0,0,0,0,0,77583,0,26124),
(123666,'Behold the power granted me by the titans!','',0,0,0,0,0,0,0,0,0,0,77584,0,26124),
(123667,'Can you withstand a keeper\'s might?','',0,0,0,0,0,0,0,0,0,0,77585,0,26124),
(123668,'Feel the fury of the storm!','',0,0,0,0,0,0,0,0,0,0,77586,0,26124),
(123669,'A shocking weakness!','',0,0,0,0,0,0,0,0,0,0,77587,0,26124),
(123670,'','You\'re... too... late...',0,0,0,0,0,0,0,0,0,0,0,77967,26124),
(123671,'Weak--as expected!','',0,0,0,0,0,0,0,0,0,0,77594,0,26124),
(123672,'That one was too soft!','',0,0,0,0,0,0,0,0,0,0,77595,0,26124),
(123673,'Well fought, champions! I yield to you.','',0,0,0,0,0,0,0,0,0,0,77596,0,26124),
(123674,'','Helya won\'t be as gentle as I!',0,0,0,0,0,0,0,0,0,0,0,77600,26124),
(123675,'','Unworthy!',0,0,0,0,0,0,0,0,0,0,0,77601,26124),
(123676,'','These mortals show promise.',0,0,0,0,0,0,0,0,0,0,0,77602,26124),
(123677,'','Training those Withered scum... how distasteful! Dalion, defend the entrance! Slay my foes!',0,0,0,0,0,0,0,0,0,0,0,78371,26124),
(123678,'Get back up! FIGHT!','',0,0,0,0,0,0,0,0,0,0,77588,0,26124),
(123679,'Disappointing!','',0,0,0,0,0,0,0,0,0,0,77589,0,26124),
(123680,'Have I misjudged them? I pray not...','',0,0,0,0,0,0,0,0,0,0,77590,0,26124),
(123681,'May we see your invitation?','',0,0,0,0,0,0,0,0,0,0,77636,0,26124),
(123682,'Stop being such a nuisance!','',0,0,0,0,0,0,0,0,0,0,77635,0,26124),
(123683,'I\'ll drag you out by your scruff!','',0,0,0,0,0,0,0,0,0,0,77634,0,26124),
(123684,'Hm! Seems that one had enough for the evening.','',0,0,0,0,0,0,0,0,0,0,77633,0,26124),
(123685,'I\'ll have the cleaning crew take care of this... mess.','',0,0,0,0,0,0,0,0,0,0,77632,0,26124),
(123686,'Nothing a good sprinkling of sawdust can\'t handle.','',0,0,0,0,0,0,0,0,0,0,77631,0,26124),
(123687,'I will just need... a moment...','',0,0,0,0,0,0,0,0,0,0,77630,0,26124),
(123688,'Oh goodness me! That will... leave a mark.','',0,0,0,0,0,0,0,0,0,0,77629,0,26124),
(123689,'I fear that I am currently... indisposed...','',0,0,0,0,0,0,0,0,0,0,77628,0,26124),
(123690,'You feel a powerful force enter your mind.','',0,0,0,0,0,0,0,0,17,0,0,0,26124),
(123691,'','This place is usually bustling with activity. Where have they all gone?',0,0,0,0,0,0,0,0,0,0,0,78417,26124),
(123692,'','Oh, Suramar...',0,0,0,0,0,0,0,0,0,0,0,78418,26124),
(123693,'','My people... in cages! And some already Withered... Such cruelty you have shown, Elisande.',0,0,0,0,0,0,0,0,0,0,0,78419,26124),
(123694,'','The demons have certainly made themselves at home. Disgusting!',0,0,0,0,0,0,0,0,0,0,0,78420,26124),
(123695,'','I could not prevent this. I am so sorry, Suramar.',0,0,0,0,0,0,0,0,0,0,0,78421,26124),
(123696,'','This place has changed... gone are the bustling crowds, replaced by armed guards.',0,0,0,0,0,0,0,0,0,0,0,78422,26124),
(123697,'Your actions are illogical. All possible results for this encounter have been calculated.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(123698,'','This must be where he took many meals...',0,0,0,0,0,0,0,0,0,0,0,78409,26124),
(123699,'','There it is. We are coming, Vanthir.',0,0,0,0,0,0,0,0,0,0,0,78410,26124),
(123700,'','This garden likely gave him many hours of respite. His essence is strong and bright, here.',0,0,0,0,0,0,0,0,0,0,0,78411,26124),
(123701,'','I can feel him! He is still alive, at least.',0,0,0,0,0,0,0,0,0,0,0,78412,26124),
(123702,'','One of his suppliers must have served him here. Reminders of a simpler time.',0,0,0,0,0,0,0,0,0,0,0,78413,26124),
(123703,'','Perfect. This will be enough to find him.',0,0,0,0,0,0,0,0,0,0,0,78414,26124),
(123704,'','I cannot maintain this spell any longer. Meet me at Evermoon Terrace and we will continue.',0,0,0,0,0,0,0,0,0,0,0,78415,26124),
(123706,'DELETE','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123711,'Ahh... The Terrace. It will have to do for now. Take us as close as you can, Deline.','',0,0,0,0,0,0,0,0,0,0,78556,0,26124),
(123713,'See that these people escape the city, Deline. $n, stay with me.','',0,0,0,0,0,0,0,0,0,0,78557,0,26124),
(123714,'This way!','',0,0,0,0,0,0,397,0,0,0,78553,0,26124),
(123716,'Now all we need is a to make contact with--','',0,0,0,0,0,0,0,0,0,0,78554,0,26124),
(123717,'The Council of Six has need of you, Deathlord.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123718,'The Council of Six has need of you, Slayer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123719,'The Council of Six has need of you, Archdruid.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123720,'The Council of Six has need of you, Huntmaster.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123721,'The Council of Six has need of you, Archmage.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123722,'The Council of Six has need of you, Grandmaster.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123723,'The Council of Six has need of you, Highlord.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123724,'The Council of Six has need of you, High Priest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123725,'The Council of Six has need of you, Shadowblade.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123726,'The Council of Six has need of you, Farseer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123727,'The Council of Six has need of you, Netherlord.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123728,'The Council of Six has need of you, Battlelord.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123729,'If you will answer their call, seek them out in the Violet Citadel.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123730,'You\'re late, little one!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123731,'Don\'t touch me filth! Get back to work!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123732,'Worthless pest! Keep moving!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123733,'Tiny thing! Me crush you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123734,'Out of my way, worm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123735,'Squash you like insect!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123736,'Move before my blade meets your skull!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123737,'Such brittle bones, little worm. How easily they\'ll crunch!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123738,'','Go. We will hold this position and send reinforcements.',0,0,0,0,0,0,0,0,0,0,0,78239,26124),
(123739,'','Time is short. Champion, mount and ride with us to the concourse before the Nightborne can reinforce their position.',0,0,0,0,0,0,0,0,0,0,0,78235,26124),
(123740,'','Champion, come, join my sin\'dorei as we crush this vanguard.',0,0,0,0,0,0,0,0,0,0,0,78237,26124),
(123741,'Our citizens are desperate to break free of Elisande\'s tyranny. See to it that they are suitably armed.','',0,0,0,0,0,0,0,0,0,0,78361,0,26124),
(123742,'With our people armed, Elisande\'s thugs will face stiff resistance!','',0,0,0,0,0,0,0,0,0,0,78362,0,26124),
(123743,'','You will have the time you need, Watcher.',0,0,0,0,0,0,0,0,0,0,0,77969,26124),
(123744,'Good work, $p. She seems subdued. I will bring her back to Acherus for you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123745,'The mortals must not disrupt the grand design!','',0,0,0,0,0,0,0,0,0,0,77741,0,26124),
(123746,'Just in time for the next ferry. It\'s off to the Soul Engine with you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123747,'An entire city, you say? In one teleport?','',0,0,0,0,0,0,0,0,0,0,78233,0,26124),
(123748,'Well, to be fair... I had help.','',0,0,0,0,0,0,0,0,0,0,78229,0,26124),
(123749,'Fascinating. I would love to compare notes when this is all over.','',0,0,0,0,0,0,0,0,0,0,78234,0,26124),
(123750,'Come, champion. The Kirin Tor and Dusk Lily rebels have secured this floor of the harbor.','',0,0,0,0,0,0,0,0,0,0,78230,0,26124),
(123751,'I will not stand for this treatment!','I will not stand for this treatment!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123752,'Are we Shal\'dorei not better than this?','Are we Shal\'dorei not better than this?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123753,'They took my daughter... Something must be done.','They took my daughter... Something must be done.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123754,'The Grand Magistrix has gone too far.','The Grand Magistrix has gone too far.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123755,'I am fed up with the Legion! We are stronger than this!','I am fed up with the Legion! We are stronger than this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123756,'Our proud city, reduced to chaos... and for what?','Our proud city, reduced to chaos... and for what?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123757,'My spell! What just happened?!','',0,0,0,0,0,0,0,0,0,0,78365,0,26124),
(123758,'','You think we didn\'t notice your skullduggery?! Your old tricks are no match for true sorcery!',0,0,0,0,0,0,0,0,0,0,0,78366,26124),
(123759,'I don\'t know how they co-opted my spell, it shouldn\'t be--','',0,0,0,0,0,0,0,0,0,0,78367,0,26124),
(123760,'','We have prepared for the possibility of discovery. With the telemancy orbs and the fel-resistant Withered, you have the tools required to secure the breach.',0,0,0,0,0,0,0,0,0,0,0,78368,26124),
(123761,'I have had it with this occupation. We need to act!','I have had it with this occupation. We need to act!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(123762,'The guards will have our heads for even discussing this...','The guards will have our heads for even discussing this...',0,0,0,0,0,0,661,0,0,0,0,0,26124),
(123763,'I do not plan to go quietly.','I do not plan to go quietly.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123764,'Indeed. I suppose it has come to this...','Indeed. I suppose it has come to this...',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(123765,'','It seems you are unable to enter. Find the power source for that barrier and take it down.',0,0,0,0,0,0,0,0,0,0,0,78369,26124),
(123766,'','There! Those casters are using generators to shield the Sanctum. Eliminate them!',0,0,0,0,0,0,0,0,0,0,0,78370,26124),
(123767,'','Now that Andaris\'s dog is put down, you should have access to the building. Get to the breach!',0,0,0,0,0,0,0,0,0,0,0,78372,26124),
(123768,'Archmage! The Kirin Tor needs your aid!','',22,0,0,0,0,0,0,0,0,0,82772,0,26124),
(123769,'Send me to Thorim\'s Peak!','Send me to Thorim\'s Peak!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123770,'Not good... not good at all. We will help, of course!','',1,0,0,0,0,0,0,0,0,0,82508,0,26124),
(123771,'The Legion infiltrated Dalaran and sabotaged the city\'s weapons... possibly beyond repair.','',22,0,0,0,0,0,0,0,0,0,82773,0,26124),
(123772,'','All shall be sanctified!',0,0,0,0,0,0,0,0,0,0,0,77775,26124),
(123773,'','The strong must suffer for the sins of the weak!',0,0,0,0,0,0,0,0,0,0,0,77776,26124),
(123774,'','By fire be cleansed!',0,0,0,0,0,0,0,0,0,0,0,77777,26124),
(123775,'','The righteous have nothing to fear!',0,0,0,0,0,0,0,0,0,0,0,77778,26124),
(123776,'Aethas? You are our secret visitor? What\'s going on?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(123777,'Your soul betrays your allies!','',0,0,0,0,0,0,0,0,0,0,77522,0,26124),
(123778,'Burn from the inside!','',0,0,0,0,0,0,0,0,0,0,77523,0,26124),
(123779,'Your lifeblood is my weapon!','',0,0,0,0,0,0,0,0,0,0,77524,0,26124),
(123780,'Run, cowards!','',0,0,0,0,0,0,0,0,0,0,77525,0,26124),
(123781,'Weak-willed mortals!','',0,0,0,0,0,0,0,0,0,0,77526,0,26124),
(123782,'Your courage falters!','',0,0,0,0,0,0,0,0,0,0,77527,0,26124),
(123783,'Miserable vermin. I shall exterminate you from the air!','',0,0,0,0,0,0,0,0,0,0,77528,0,26124),
(123784,'Again?! Oh no! Tell me you weren\'t involved!','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(123785,'Enough! I will finish you myself!','',0,0,0,0,0,0,0,0,0,0,77529,0,26124),
(123787,'Am I damned to answer the summons of mortals for all eternity?','',0,0,0,0,0,0,0,0,0,0,77530,0,26124),
(123788,'So be it! You will suffer for your insolence!','',0,0,0,0,0,0,0,0,0,0,77531,0,26124),
(123789,'Learn the meaning of torment!','',0,0,0,0,0,0,0,0,0,0,77532,0,26124),
(123790,'I\'ll reduce you to ashes!','',0,0,0,0,0,0,0,0,0,0,77533,0,26124),
(123791,'Come forth and burn!','',0,0,0,0,0,0,0,0,0,0,77534,0,26124),
(123792,'Kindling for the fire!','',0,0,0,0,0,0,0,0,0,0,77535,0,26124),
(123793,'Pathetic!','',0,0,0,0,0,0,0,0,0,0,77536,0,26124),
(123794,'Who\'s next?!','',0,0,0,0,0,0,0,0,0,0,77537,0,26124),
(123795,'Pitiful... as expected.','',0,0,0,0,0,0,0,0,0,0,77538,0,26124),
(123796,'Mortals never learn.','',0,0,0,0,0,0,0,0,0,0,77539,0,26124),
(123797,'','You\'ll go no further! I\'ll die before I allow you entrance to the Nighthold!',0,0,0,0,0,0,0,0,0,0,0,78373,26124),
(123798,'You called me here only to die at my feet?','',0,0,0,0,0,0,0,0,0,0,77540,0,26124),
(123799,'It is... never... over...','',0,0,0,0,0,0,0,0,0,0,77541,0,26124),
(123800,'I will... never... be free...','',0,0,0,0,0,0,0,0,0,0,77542,0,26124),
(123801,'The flames... await me...','',0,0,0,0,0,0,0,0,0,0,77543,0,26124),
(123802,'Time to end this!','',0,0,0,0,0,0,0,0,0,0,77544,0,26124),
(123803,'I\'ve toyed with you long enough!','',0,0,0,0,0,0,0,0,0,0,77545,0,26124),
(123804,'I will end you!','',0,0,0,0,0,0,0,0,0,0,77546,0,26124),
(123805,'','Andaris has made a critical mistake! Her shield is vulnerable to the Withered. Drop some in a safe spot and they will leech the magic in her shield.',0,0,0,0,0,0,0,0,0,0,0,78374,26124),
(123806,'','More Withered tricks! I shall not fail Elisande! You will fall!',0,0,0,0,0,0,0,0,0,0,0,78375,26124),
(123807,'','Step into the light, mortals!',0,0,0,0,0,0,0,0,0,0,0,77779,26124),
(123808,'','Hold, mortals! Open your hearts to virtue!',0,0,0,0,0,0,0,0,0,0,0,77780,26124),
(123809,'A memory, frozen in time!','',0,0,0,0,0,0,0,0,0,0,77560,0,26124),
(123810,'The tower needed a new decoration.','',0,0,0,0,0,0,0,0,0,0,77571,0,26124),
(123811,'','Renounce your greed and perversion!',0,0,0,0,0,0,0,0,0,0,0,77781,26124),
(123812,'The inherent nature of fire...','',0,0,0,0,0,0,0,0,0,0,77561,0,26124),
(123813,'Burn... just like that dragon!','',0,0,0,0,0,0,0,0,0,0,77570,0,26124),
(123814,'','Repent... or DIE!',0,0,0,0,0,0,0,0,0,0,0,77782,26124),
(123815,'You grow weaker... I grow stronger!','',0,0,0,0,0,0,0,0,0,0,77564,0,26124),
(123816,'A basic spell... but effective.','',0,0,0,0,0,0,0,0,0,0,77549,0,26124),
(123817,'So many pieces of me...','',0,0,0,0,0,0,0,0,0,0,77565,0,26124),
(123818,'Carrion for the birds...','',0,0,0,0,0,0,0,0,0,0,77562,0,26124),
(123819,'It burns, burns, burns!','',0,0,0,0,0,0,0,0,0,0,77550,0,26124),
(123820,'I suggest staying put.','',0,0,0,0,0,0,0,0,0,0,77566,0,26124),
(123821,'Winter is here!','',0,0,0,0,0,0,0,0,0,0,77572,0,26124),
(123822,'Keep still. Let it end.','',0,0,0,0,0,0,0,0,0,0,77555,0,26124),
(123823,'','The titans wish their children to lead virtuous lives. Yet from cornerstone to spire, this tower reeks of depravity!',0,0,0,0,0,0,0,0,0,0,0,77783,26124),
(123824,'This is who I am. I was tainted from birth, polluted from before my conception, a bad seed grown to bear bitter fruit.','',0,0,0,0,0,0,0,0,0,0,77556,0,26124),
(123825,'You have never seen the true Medivh.','',0,0,0,0,0,0,0,0,0,0,77553,0,26124),
(123826,'Just. Gets. Easier.','',0,0,0,0,0,0,0,0,0,0,77551,0,26124),
(123827,'','Purified!',0,0,0,0,0,0,0,0,0,0,0,77784,26124),
(123828,'All goes as planned.','',0,0,0,0,0,0,0,0,0,0,77557,0,26124),
(123829,'A fitting end for a thief!','',0,0,0,0,0,0,0,0,0,0,77554,0,26124),
(123830,'','A teachable moment.',0,0,0,0,0,0,0,0,0,0,0,77785,26124),
(123831,'Hello, champions. I\'ve been expecting you.','',0,0,0,0,0,0,0,0,0,0,77552,0,26124),
(123832,'You\'re just like the others, aren\'t you?','',0,0,0,0,0,0,0,0,0,0,77558,0,26124),
(123833,'My staff... a relic, yes, but MINE!','',0,0,0,0,0,0,0,0,0,0,77568,0,26124),
(123834,'Once you get used to it, you can kill friends as easily as anyone else.','',0,0,0,0,0,0,0,0,0,0,77573,0,26124),
(123835,'You have no idea what it\'s like to do the things I\'ve done. Harsh things. Necessary things.','',0,0,0,0,0,0,0,0,0,0,77559,0,26124),
(123836,'I fought it... for as long as... I could...','',0,0,0,0,0,0,0,0,0,0,77563,0,26124),
(123837,'','And so begins your purification!',0,0,0,0,0,0,0,0,0,0,0,77786,26124),
(123838,'So... it comes... to this...','',0,0,0,0,0,0,0,0,0,0,77567,0,26124),
(123839,'Atiesh... will be... splintered...','',0,0,0,0,0,0,0,0,0,0,77569,0,26124),
(123840,'','The stench of corruption is upon you!',0,0,0,0,0,0,0,0,0,0,0,77787,26124),
(123841,'Beware, champions! Helya\'s realm is guarded by a savage beast bred from the stuff of nightmares!','',0,0,0,0,0,0,0,0,0,0,77547,0,26124),
(123842,'Well fought! Now, onward to Helya! This day her treachery shall be ended!','',0,0,0,0,0,0,0,0,0,0,77548,0,26124),
(123843,'','The lesson is complete.',0,0,0,0,0,0,0,0,0,0,0,77788,26124),
(123844,'','A pure mind is an orderly mind.',0,0,0,0,0,0,0,0,0,0,0,77789,26124),
(123845,'','I will... never... relent...',0,0,0,0,0,0,0,0,0,0,0,77790,26124),
(123846,'','You are all... as corrupt... as the Guardian...',0,0,0,0,0,0,0,0,0,0,0,77791,26124),
(123847,'Send me to Thorim\'s Peak!','Send me to Thorim\'s Peak!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123849,'Andaris was the key to their defenses. Telemancy is working inside the Sanctum again. I\'m sending Thalyssra and Khadgar to your location.','',0,0,0,0,0,0,0,0,0,0,78376,0,26124),
(123850,'','$n! Over here!',0,0,0,0,0,0,0,0,0,0,0,78377,26124),
(123851,'','With her finest arcanist dead, I doubt Elisande will send reinforcements. We have the breach. Follow me.',0,0,0,0,0,0,1,0,0,0,0,78378,26124),
(123852,'','I can sense the Nightwell from here. Elisande must truly be desperate to overload the Nightwell like this!',0,0,0,0,0,0,1,0,0,0,0,78379,26124),
(123853,'Once we break the timelock holding our forces, Gul\'dan will fall!','',0,0,0,0,0,0,1,0,0,0,78380,0,26124),
(123854,'The Withered won\'t last long in there, $n. Gather an elite group of champions to fight your way through. I\'m sure you\'re familiar with such tactics! We\'ll be right behind you, of course.','',0,0,0,0,0,0,1,0,0,0,78381,0,26124),
(123855,'You should have never returned, foolish mortal! Your tower is ours!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123856,'Master! I have... failed you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123857,'Feel the grip of entropy!','',0,0,0,0,0,0,0,0,0,0,77604,0,26124),
(123858,'Darkness will take you!','',0,0,0,0,0,0,0,0,0,0,77605,0,26124),
(123859,'Annihilate them!','',0,0,0,0,0,0,0,0,0,0,77606,0,26124),
(123860,'Begin the barrage!','',0,0,0,0,0,0,0,0,0,0,77607,0,26124),
(123861,'Incinerate that one!','',0,0,0,0,0,0,0,0,0,0,77608,0,26124),
(123862,'','Your resistance is irrelevant!',0,0,0,0,0,0,0,0,0,0,0,77966,26124),
(123863,'Take out the target!','',0,0,0,0,0,0,0,0,0,0,77609,0,26124),
(123864,'You will kneel! You will serve!','',0,0,0,0,0,0,0,0,0,0,77610,0,26124),
(123865,'Your resistance is misguided. Yield to us!','',0,0,0,0,0,0,0,0,0,0,77611,0,26124),
(123866,'Enough interruptions! The grand design must be realized.','',0,0,0,0,0,0,0,0,0,0,77612,0,26124),
(123867,'Preparations are complete. It is time to begin the end!','',0,0,0,0,0,0,0,0,0,0,77613,0,26124),
(123868,'An infinite army will be brought forth from innumerable worlds!','',0,0,0,0,0,0,0,0,0,0,77614,0,26124),
(123869,'Behold! The doorway opens to your doom!','',0,0,0,0,0,0,0,0,0,0,77615,0,26124),
(123870,'The grand design is complete! Every Legion world is now tethered to this tower!','',0,0,0,0,0,0,0,0,0,0,77616,0,26124),
(123871,'Master! My mission is accomplished! Come forth and claim this world!','',0,0,0,0,0,0,0,0,0,0,77617,0,26124),
(123872,'Karazhan\'s presence radiates through the Nether... a beacon drawing in the Legion\'s might.','',0,0,0,0,0,0,0,0,0,0,77618,0,26124),
(123873,'Our Burning Crusade has consumed countless worlds. This tower will serve as a conduit to each of them.','',0,0,0,0,0,0,0,0,0,0,77619,0,26124),
(123874,'One battle remains. One final conquest to complete the grand design!','',0,0,0,0,0,0,0,0,0,0,77620,0,26124),
(123875,'Meaningless... and inevitable.','',0,0,0,0,0,0,0,0,0,0,77621,0,26124),
(123876,'One by one... you fall!','',0,0,0,0,0,0,0,0,0,0,77622,0,26124),
(123877,'I have foreseen your world\'s doom!','',0,0,0,0,0,0,0,0,0,0,77603,0,26124),
(123878,'This tower belongs to the Legion!','',0,0,0,0,0,0,0,0,0,0,77623,0,26124),
(123879,'It ends for the mortals, as I saw it would.','',0,0,0,0,0,0,0,0,0,0,77624,0,26124),
(123880,'A pathetic attempt to resist our design.','',0,0,0,0,0,0,0,0,0,0,77625,0,26124),
(123881,'But the design... was flawless...','',0,0,0,0,0,0,0,0,0,0,77626,0,26124),
(123882,'Could not... foresee... such an end...','',0,0,0,0,0,0,0,0,0,0,77627,0,26124),
(123883,'The portal worked and we are still in one piece. Good! I was worried we might overload the network by adding another beacon.','',0,0,0,0,0,0,0,0,0,0,78232,0,26124),
(123884,'The Duskwatch won\'t know what hit them.','The Duskwatch won\'t know what hit them.',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(123885,'I will spread the word... the Grand Magistrix\'s tyrrany stops now!','I will spread the word... the Grand Magistrix\'s tyrrany stops now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123886,'I am ready to fight for Suramar!','I am ready to fight for Suramar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123887,'Our people will be free of the Legion!','Our people will be free of the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123888,'','I\'m ready to take down the barrier. You will need to move quickly and secure the entrance before they realize what\'s going on.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123889,'I may not be a soldier, but even in war there are beds to be turned down and drinks to be served.$b$bIt is a duty I was born to.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123890,'Ensure none see the item you recovered until then. Good luck, champion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123891,'They have called for aid in facing a great threat. They asked only for you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123892,'','Begone, slave!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123893,'','Your kind serves us well, minion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123894,'','I don\'t have time for your games.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123895,'','Where have you been, little wretch?$B$BDid you think we weren\'t watching?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123896,'Master, please! I doesn\'t mean to...','Master, please! I doesn\'t mean to...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123897,'','A pathetic attempt at disguise! Now you will pay with your life!',0,0,0,0,0,0,0,0,0,0,0,77968,26124),
(123898,'Then through the portal ye go!$b$bKhadgar will be waitin\'.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123903,'The demons have taken the lands above Moonclaw Vale! The trees cry out as their life essence is drained to fuel the Legion\'s defenses.','',0,0,0,0,0,0,0,0,0,0,80574,0,26124),
(123905,'The Legion is a relentless foe, but you have saved the forest this day. All of Val\'sharah honors your victory!','',0,0,0,0,0,0,0,0,0,0,80410,0,26124),
(123906,'','Many Nightborne were murdered when Elisande and the Legion attacked. Strike back! Show those devils we will not stand for tyranny.',0,0,0,0,0,0,0,0,0,0,0,78363,26124),
(123907,'','Elisande and the Legion will pay for the blood they have spilled. They still have much to answer for!',0,0,0,0,0,0,0,0,0,0,0,78364,26124),
(123908,'','This place is not safe. We should move soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123909,'','Vanthir is in danger!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123910,'What happened to Vanthir, Maribeth?','What happened to Vanthir, Maribeth?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123911,'We must strike before their defenses reach full power! Plant a Seed of Ruin near each structure and it will be crushed as the seed sprouts. Hurry!','',0,0,0,0,0,0,0,0,0,0,80575,0,26124),
(123912,'Enough of this weakness, boy! Contain your magic!','',0,0,0,0,0,0,0,0,6,0,78194,0,26124),
(123913,'Too... much... power...','',0,0,0,0,0,0,0,0,6,0,78195,0,26124),
(123914,'Father! No!','',0,0,0,0,0,0,0,0,6,0,78196,0,26124),
(123915,'Citizens have taken up arms to defend safe houses throughout Suramar. Find innocents in peril and lead them to safety!','',0,0,0,0,0,0,0,0,0,0,78563,0,26124),
(123916,'If not for your actions, many innocents would have died in the streets. A small victory, perhaps, but an important one.','',0,0,0,0,0,0,0,0,0,0,78564,0,26124),
(123917,'Could Dalaran use the Nightborne Soulstone as a weapon?','Could Dalaran use the Nightborne Soulstone as a weapon?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(123918,'Interesting idea, Archmage $n! Using the legion\'s own magic against themselves has a satisfying elegance. We cannot risk Kathra\'natir escaping, however... \n\nArchmage Kalec is very knowledgable about magical devices and can be trusted to remain discreet. Let\'s see what he thinks?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(123919,'','The Legion\'s patrols edge ever closer to Shal\'Aran. Kill them before they discover our location!',0,0,0,0,0,0,0,0,0,0,0,78396,26124),
(123920,'','Our whereabouts remain a secret... for now. I fear this will not be the last time Shal\'Aran is threatened.',0,0,0,0,0,0,0,0,0,0,0,78397,26124),
(123921,'Can you think of a way we could safely use the Nightborne Soulstone as a weapon?','Can you think of a way we could safely use the Nightborne Soulstone as a weapon?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(123923,'','Victory over Elisande will require strength beyond our own. Ascend to the Lunar Crucible and seek the blessing of the Moon Guard ancients.',0,0,0,0,0,0,0,0,0,0,0,78358,26124),
(123924,'','Elisande shamed our people when she attacked the Moon Guard. By keeping their traditions alive, you help us make amends for her transgression.',0,0,0,0,0,0,0,0,0,0,0,78359,26124),
(123925,'Hmm... Most anything is possible with enough effort! If we had all of our mages focusing on it it, I\'m sure we could safely use it... Of course that might be a tad inefficient. \n\nOr perhaps it could be securely shielded? Khadgar\'s strange friend, Ari, is brilliant when it comes to these sorts of puzzles. Let\'s see what she thinks!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(123926,'Come. I think this is a matter best discussed privately.','',0,0,0,0,0,0,1,0,0,0,81326,0,26124),
(123927,'Can you think of a way to safely use the Nightborne Soulstone?','Can you think of a way to safely use the Nightborne Soulstone?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(123928,'Elisande and the Legion are forcing citizens into boats bound for Felsoul Hold. Take a gondola and free as many shal\'dorei as you can.','',0,0,0,0,0,0,0,0,0,0,78404,0,26124),
(123929,'Elisande is beyond forgiveness for condemning so many of our people. We must fight to save everyone we can.','',0,0,0,0,0,0,0,0,0,0,78405,0,26124),
(123930,'','Oh. Hmm. Are the rumors true then? Dalaran\'s lovely weapons are no more? I must attend the funeral...\n\nI suppose the Nightborne Soulstone could be convinced to work with us. But first we will need a very stubborn shield generator.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(123931,'','Elisande\'s forces are waylaying refugees fleeing Suramar through the Crimson Thicket. A perfect opportunity to test their skills in battle!',0,0,0,0,0,0,0,0,0,0,0,78455,26124),
(123932,'','The once-proud shal\'dorei attack their own people? This situation is even more desperate than I imagined...',0,0,0,0,0,0,0,0,0,0,0,78454,26124),
(123933,'','Shal\'dorei flee Suramar as Elisande\'s forces advance through the Crimson Thicket. Go, rout the Nightborne for the sake of those who would escape the city.',0,0,0,0,0,0,0,0,0,0,0,78226,26124),
(123934,'','They strike down their own people for daring to seek safety? We will bring our wrath to bear on Elisande for this injustice!',0,0,0,0,0,0,0,0,0,0,0,78456,26124),
(123935,'','We must spread word of the Alliance\'s arrival. Post notice throughout the city that the reign of the Grand Magistrix will soon be ended. Inspire the shal\'dorei to resist!',0,0,0,0,0,0,0,0,0,0,0,78437,26124),
(123936,'','The more shal\'dorei that take up the fight, the fewer of my people who will be lost in the liberation of Suramar.',0,0,0,0,0,0,0,0,0,0,0,78439,26124),
(123937,'','Suramar\'s citizens must be told of the arrival of the Horde. Post bulletins throughout the city. Let the oppressed know that help is on the way!',0,0,0,0,0,0,0,0,0,0,0,78438,26124),
(123938,'','The shal\'dorei must be shown that there is a future beyond this chaos. We must reach as many as we can!',0,0,0,0,0,0,0,0,0,0,0,78440,26124),
(123939,'','Our supplies are running low, but the enemy has plenty to spare. Ride into Suramar and liberate supplies from the forces of the Magistrix!',0,0,0,0,0,0,0,0,0,0,0,78559,26124),
(123940,'','I watched from my inn when Elisande\'s forces swept into the Crescent.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123941,'','The Felborne killed anyone who stood in their way, but they did not kill him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123942,'','He begged them to spare his people.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123943,'','They said that he would be made an example for all others.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123944,'','They teleported him away. Where, I do not know.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123945,'','Morale has been reinvigorated by the arrival of fresh supplies. You have done well!',0,0,0,0,0,0,0,0,0,0,0,78561,26124),
(123946,'','Dwindling supplies are demoralizing our troops. Go into Suramar and seize supplies from the Nightborne oppressors!',0,0,0,0,0,0,0,0,0,0,0,78560,26124),
(123947,'','These supplies will prove crucial in maintaining our campaign. The Horde marches on!',0,0,0,0,0,0,0,0,0,0,0,78562,26124),
(123948,'Ah yes, this is a wonderful vintage.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123949,'','We should retreat while we still can.',0,0,0,0,0,0,0,0,0,0,0,78578,26124),
(123950,'','Ley lines darken across Suramar as the Grand Magistrix\'s forces act from the shadows. Use my spectacles to see beyond sight, and root out the source of this interference!',0,0,0,0,0,0,0,0,0,0,0,78457,26124),
(123951,'','The ley energy is flowing again! A job well done.',0,0,0,0,0,0,0,0,0,0,0,78458,26124),
(123952,'My preparations are complete. Let us see how the nobles of Suramar react to the warp-delivery of Withered!','',0,0,0,0,0,0,0,0,0,0,78620,0,26124),
(123953,'What delicious irony! Chaos erupts among the nobles as those they cast out are warped onto their very doorsteps!','',0,0,0,0,0,0,0,0,0,0,78621,0,26124),
(123954,'','The Withered must be made ready for our assault on the Nighthold. Their resistance to fel can be bolstered in Felsoul Hold.',0,0,0,0,0,0,0,0,0,0,0,78423,26124),
(123955,'','More of our Withered are now able to withstand the fel. Our revolution will not be stopped!',0,0,0,0,0,0,0,0,0,0,0,78424,26124),
(123956,'Oh, the grog. Yes, thank you.','',0,0,0,0,0,0,7,0,0,0,0,0,26124),
(123957,'','We are ready to begin the offensive in Suramar. Place beacons along the city\'s outskirts and draw the withered down upon the Magistrix\'s forces!',0,0,0,0,0,0,0,0,0,0,0,78570,26124),
(123958,'','The enemy breaks before the scores of withered we have unleashed! Keep training them, for the withered will prove invaluable in the days to come.',0,0,0,0,0,0,0,0,0,0,0,78571,26124),
(123959,'','Damn it! Another attack. Stay alert!',0,0,0,0,0,0,1,0,0,0,0,81320,26124),
(123960,'Free at last! Do what you can for the others, I\'ll be fine...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123961,'How may I serve?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123962,'','Now that you target is bleeding and your pet is engaged, it\'s time to unleash your own fury.',0,0,0,0,0,0,0,0,0,0,0,77826,26124),
(123963,'','Raptor Strike is a quick but strong attack that you can use whenever you have the focus to do so.',0,0,0,0,0,0,0,0,0,0,0,77828,26124),
(123964,'','Use Raptor Strike on the target dummy.',0,0,0,0,0,0,0,0,0,0,0,77830,26124),
(123965,'Now that you target is bleeding and your pet is engaged, it\'s time to unleash your own fury.','',0,0,0,0,0,0,0,0,0,0,77825,0,26124),
(123966,'Raptor Strike is a quick but strong attack that you can use whenever you have the focus to do so.','',0,0,0,0,0,0,0,0,0,0,77827,0,26124),
(123967,'Use Raptor Strike on the target dummy.','',0,0,0,0,0,0,0,0,0,0,77829,0,26124),
(123968,'I must speak to your lord.','I must speak to your lord.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123969,'You have my thanks, champion!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123970,'That cage would have been my coffin...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123971,'The Burning Legion will pay for this!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123972,'Where is my axe? I have demons to kill!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123973,'Death to the Burning Legion!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123974,'I will fight until my final breath!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123975,'The demons will pay!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123976,'','Freedom? I will not forget this!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123977,'Feels good to stretch my legs! Now, where\'s a demon to stretch my fists on!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123978,'','I owe you my life!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(123979,'Greetings Highlord.','Greetings Highlord.',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(123980,'This must be discussed immediately. Allow me to teleport you to Shal\'Aran.','',0,0,0,0,0,0,1,0,0,0,78398,0,26124),
(123981,'Oh, woe is me, woe! My life is over!\n\nDo you know who Dr. Weavil is? Was. Might still be? I\'m not sure.\n\nDeath would not stop him, no, he had predicted that. Brilliant gnome, the insane ones always are.\n\nThe second his heart stopped, the machines he had implanted within himself started up. He was filled with a yellow ooze, and electrified. I\'m not sure if it\'s undeath, alchemical engineering, or something... more.\n\nWhen we heard about a new internship under the great Dr. Weavil, so many of us flocked to the island to sign up. Now I\'m not sure if I\'m alive or dead, and I\'m leaking yellow ooze. Great.\n\nThe others have taken to calling themselves \"drudge gnomes.\" Good luck with them, bunch of jerks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123982,'Smolderon, heed this mortal!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123983,'Prove to me you have the experience and instinct required to take down any prey!','',0,0,0,0,0,0,0,0,0,0,77839,0,26124),
(123984,'','Prove to me you have the experience and instinct required to take down any prey!',0,0,0,0,0,0,0,0,0,0,0,77840,26124),
(123985,'Stand down, Arluelle. We are expecting her.','',0,0,0,0,0,0,0,0,0,0,78400,0,26124),
(123986,'Another year of slumber. I wonder if Medivh will ever awaken.','',0,0,0,0,0,0,0,0,6,0,78199,0,26124),
(123987,'Does our old friend dream? Is he trapped in nightmares?','',0,0,0,0,0,0,0,0,6,0,78193,0,26124),
(123988,'','Use Raptor Strike!',0,0,0,0,0,0,0,0,0,0,0,77854,26124),
(123989,'Use Raptor Strike!','',0,0,0,0,0,0,0,0,0,0,77853,0,26124),
(123990,'My forces have been preparing for this day. Their rage fills the Firelands.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(123991,'Elisande has captured all our forces in a timelock spell.','',0,0,0,0,0,0,0,0,0,0,78474,0,26124),
(123992,'What Elisande has done... it should have been impossible! The energies required--','',0,0,0,0,0,0,6,0,0,0,78475,0,26124),
(123993,'','And why didn\'t Ly\'leth warn us about this? Surely, as one of Elisande\'s advisors, she would have heard something!',0,0,0,0,0,0,1,0,0,0,0,78476,26124),
(123994,'','There has been no word from her in some time. This cannot be a coincidence.',0,0,0,0,0,0,1,0,0,0,0,78477,26124),
(123995,'','Valtrois, focus on Elisande\'s spell. Find a way to break it.',0,0,0,0,0,0,1,0,0,0,0,78478,26124),
(123996,'','It shall be done.',0,0,0,0,0,0,1,0,0,0,0,78479,26124),
(123997,'','Oculeth, we need to compensate for the loss of our reinforcements.',0,0,0,0,0,0,1,0,0,0,0,78480,26124),
(123998,'Indeed. I have an idea about how to put our limited forces in the right place at the right time.','',0,0,0,0,0,0,1,0,0,0,78481,0,26124),
(123999,'','$n, we need to find out what happened to Ly\'leth. You can still move freely about the city, correct?',0,0,0,0,0,0,1,0,0,0,0,78482,26124),
(124000,'Now you\'re ready to oversee the tower\'s protection in my absence.','',0,0,0,0,0,0,1,0,6,0,78197,0,26124),
(124001,'Defense protocols activated.','',0,0,0,0,0,0,0,0,6,0,78201,0,26124),
(124002,'Hmm, I must remember to shut you down from time to time. Overuse might cause you to become... erratic.','',0,0,0,0,0,0,0,0,6,0,78198,0,26124),
(124003,'','This way!',0,0,0,0,0,0,0,0,0,0,0,78625,26124),
(124004,'Agreed. Everyone into the boat! It will be a tight fit.','',0,0,0,0,0,0,0,0,0,0,78591,0,26124),
(124005,'','We will find him, Silgryn. I am certain of it.',0,0,0,0,0,0,0,0,0,0,0,78579,26124),
(124006,'','DELETE ME',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124007,'Still no sign of Vanthir...','',0,0,0,0,0,0,0,0,0,0,78592,0,26124),
(124008,'DELETE ME','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124009,'','DELETE ME',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124010,'This goes without saying, but be on your guard. I sense something... a presence I\'ve not felt since...','',0,0,0,0,0,0,1,0,0,0,78190,0,26124),
(124011,'','No no no. I said form ranks. Form ranks!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124012,'','You call that a fighting stance? Any elf in this camp could rip you apart with you in that stance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124013,'','Lift your weapon. Lift it up. If it is too heavy, grow stronger.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124014,'','Stop slacking. You are Nightborne preparing to defend your city and your legacy. Stand proud!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124015,'','What is that? Don\'t do that.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124016,'It couldn\'t have been helped, you know. We tried to alter it, but it was all part of a larger scheme.','',0,0,0,0,0,0,1,0,6,0,78200,0,26124),
(124017,'I know. All part of a greater cycle. A cycle that now at last may be broken.','',0,0,0,0,0,0,1,0,6,0,78183,0,26124),
(124018,'[UNUSED] This goes without saying, but be on your guard. I sense something... a presence I\'ve not felt since...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124019,'Silgryn sends his regards.','Silgryn sends his regards.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124020,'Champion, I have come to learn from you.','Champion, I have come to learn from you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124021,'Death to the Legion! Death to their allies!','Death to the Legion! Death to their allies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124022,'','I have urgent news, Thalyssra.',0,0,0,0,0,0,0,0,0,0,0,78611,26124),
(124023,'','The portal to my estate is secure. You will want to hear this in person.',0,0,0,0,0,0,0,0,0,0,0,78612,26124),
(124024,'','Come. I do not want to keep her waiting.',0,0,0,0,0,0,0,0,0,0,0,78613,26124),
(124025,'Champion! My weapon is at your command.','Champion! My weapon is at your command.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124026,'For Thalyssra! For the rebellion!','For Thalyssra! For the rebellion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124027,'I stand with the First Arcanist!','I stand with the First Arcanist!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124028,'Well, that was... interesting. You\'ve done your part, but I still can\'t find a way to--','',0,0,0,0,0,0,1,0,0,0,78185,0,26124),
(124029,'The demons have been purged from Karazhan! Thank you, champions. Medivh, you would be a welcome ally in our war against the Legion.','',0,0,0,0,0,0,1,0,0,0,78189,0,26124),
(124030,'','We won\'t give up without a fight.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(124031,'What did you need my help with?','What did you need my help with?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124032,'','As you can see, the Legion\'s reach still extends beyond the Broken Shore.',0,0,0,0,0,0,0,0,4,0,0,81321,26124),
(124033,'My path leads... elsewhere. Besides, Azeroth has found her Guardian in you, Young Trust.','',0,0,0,0,0,0,1,0,0,0,78205,0,26124),
(124034,'I have made it clear before... I do not want such power!','',0,0,0,0,0,0,661,0,0,0,78188,0,26124),
(124035,'You have all the power you will ever need, Khadgar. It is your heart, your courage, that makes you this world\'s Guardian. And a better one than I ever was.','',0,0,0,0,0,0,25,0,0,0,78184,0,26124),
(124036,'I... I don\'t know what to say, Medivh.','',0,0,0,0,0,0,1,0,0,0,78187,0,26124),
(124037,'Enough sentiment! Hear these words before I depart.','',0,0,0,0,0,0,5,0,0,0,78204,0,26124),
(124038,'It may be simpler to shut a door than to pass through it. But sometimes a step into the unknown is required to break the bonds of fate.','',0,0,0,0,0,0,6,0,0,0,78203,0,26124),
(124039,'Outstanding!','',0,0,0,0,0,0,5,0,0,0,77658,0,26124),
(124040,'','Outstanding!',0,0,0,0,0,0,0,0,0,0,0,77659,26124),
(124041,'','Amazing!',0,0,0,0,0,0,0,0,0,0,0,77660,26124),
(124042,'Amazing!','',0,0,0,0,0,0,5,0,0,0,77661,0,26124),
(124043,'There is much that lies ahead for all of us. Farewell.','',0,0,0,0,0,0,1,0,0,0,78202,0,26124),
(124044,'You\'re really improving.','',0,0,0,0,0,0,5,0,0,0,77662,0,26124),
(124045,'','You\'re really improving.',0,0,0,0,0,0,0,0,0,0,0,77663,26124),
(124046,'','Nothing can stop you now!',0,0,0,0,0,0,0,0,0,0,0,77664,26124),
(124047,'Nothing can stop you now!','',0,0,0,0,0,0,5,0,0,0,77665,0,26124),
(124048,'The bonds of fate... I must consider those words. Until next time, champions.','',0,0,0,0,0,0,6,0,0,0,78186,0,26124),
(124049,'','Now you have the hang of it!',0,0,0,0,0,0,0,0,0,0,0,77666,26124),
(124050,'Now you have the hang of it!','',0,0,0,0,0,0,5,0,0,0,77667,0,26124),
(124051,'','Now you have it!',0,0,0,0,0,0,0,0,0,0,0,77668,26124),
(124052,'Now you have it!','',0,0,0,0,0,0,5,0,0,0,77669,0,26124),
(124053,'Not bad, $p!','',0,0,0,0,0,0,5,0,0,0,77670,0,26124),
(124054,'','Not bad, $p!',0,0,0,0,0,0,0,0,0,0,0,77671,26124),
(124055,'','Welcome home, First Arcanist. Thank you for coming on such short notice.',0,0,0,0,0,0,0,0,0,0,0,78614,26124),
(124056,'','Thank you, Advisor. What news?',0,0,0,0,0,0,0,0,0,0,0,78615,26124),
(124057,'','That\'s it. I knew you could do it.',0,0,0,0,0,0,0,0,0,0,0,77672,26124),
(124058,'That\'s it. I knew you could do it.','',0,0,0,0,0,0,273,0,0,0,77673,0,26124),
(124059,'You\'re learning fast!','',0,0,0,0,0,0,5,0,0,0,77674,0,26124),
(124060,'','You\'re learning fast!',0,0,0,0,0,0,0,0,0,0,0,77675,26124),
(124061,'','Good! You must have been practicing.',0,0,0,0,0,0,0,0,0,0,0,77676,26124),
(124062,'Good! You must have been practicing.','',0,0,0,0,0,0,5,0,0,0,77677,0,26124),
(124063,'','I have heard terrible rumors about our friend Vanthir.',0,0,0,0,0,0,0,0,0,0,0,78616,26124),
(124064,'','DELETE ME',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124065,'','DELETE ME',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124066,'Exactly right!','',0,0,0,0,0,0,5,0,0,0,77678,0,26124),
(124067,'','Exactly right!',0,0,0,0,0,0,0,0,0,0,0,77679,26124),
(124068,'You figured that out fast!','',0,0,0,0,0,0,5,0,0,0,77680,0,26124),
(124069,'','You figured that out fast!',0,0,0,0,0,0,0,0,0,0,0,77681,26124),
(124070,'','DELETE ME',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124071,'','You\'re going to be an excellent addition to the Horde.',0,0,0,0,0,0,0,0,0,0,0,77682,26124),
(124072,'You\'re going to be an excellent addition to the Alliance.','',0,0,0,0,0,0,0,0,0,0,77683,0,26124),
(124073,'','You\'ve mastered it!',0,0,0,0,0,0,0,0,0,0,0,77684,26124),
(124074,'You\'ve mastered it!','',0,0,0,0,0,0,0,0,0,0,77685,0,26124),
(124075,'','Be safe, Thalyssra. I must return to the palace.',0,0,0,0,0,0,0,0,0,0,0,78406,26124),
(124076,'','Their agents lurk across Azeroth, threatening to subvert our efforts at the tomb. They are some of the Legion\'s most powerful champions.',0,0,0,0,0,0,0,0,4,0,0,81322,26124),
(124077,'If the plans of these fiends come to fruition, all our efforts--all our sacrifices--will have been for naught.','',0,0,0,0,0,0,0,0,4,0,81323,0,26124),
(124078,'We must enlist your help to hunt these targets down. You may be the only one with any chance of stopping them.','',0,0,0,0,0,0,0,0,4,0,81325,0,26124),
(124079,'Oh? Is this egg moving?','Oh? Is this egg moving?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124080,'The egg seems cold. Stay close to it to keep it warm.','The egg seems cold. Stay close to it to keep it warm.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124081,'You hear a rustling sound inside the egg.','You hear a rustling sound inside the egg.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124082,'The hippogryph inside is struggling to escape.','The hippogryph inside is struggling to escape.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124083,'This is it! The egg is hatching!','This is it! The egg is hatching!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124084,'','Message... at the pond... outside...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124086,'Soon the Legion will learn what it truly means to burn.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124087,'','How may I help you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124088,'What\'s going on here?','What\'s going on here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124089,'How did you get in here? My research must remain secret!','',0,0,0,0,0,0,0,0,0,0,82994,0,26124),
(124090,'My research... dies with me...','',0,0,0,0,0,0,0,0,0,0,82995,0,26124),
(124091,'','The master has prepared a dinner for his guests.\n\nI\'m afraid the guest list is quite exclusive, and I do not see your name on the list. Are you delivering something for the party?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124092,'You do not look like my master...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124093,'No, I defeated him. You are free.','No, I defeated him. You are free.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124094,'The winds heed you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124095,'Thunderaan, the Farseer summons your visage!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124096,'I have heard whispers on the wind. It is time to strike at the Burning Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124097,'The armies of Skywall will have been summoned. The wind will be at your back.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124098,'We will find your friends. Confess, and your death shall come swiftly!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124099,'','I\'ve been alone for weeks! You must believe me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124100,'What do you mean, free?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124101,'Traitorous to the last...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124102,'What do you ask of the earth?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124103,'Stonemother... Farseer calls.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124104,'I have slain your master, you no longer need to serve him.','I have slain your master, you no longer need to serve him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124105,'','The armies of Deepholm are ready, fleshling.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124106,'','My stone warriors will break the Legion to dust!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124107,'He still controls my body though, I can feel it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124108,'Flurry is another spell in your arsenal. While it can be cast on its own, Flurry is best used in tandem with another ability.','',0,0,0,0,0,0,0,0,0,0,77865,0,26124),
(124109,'Casting Frostbolt can trigger an effect called Brain Freeze.','',0,0,0,0,0,0,0,0,0,0,77867,0,26124),
(124110,'While Brain Freeze is active, Flurry can be cast instantly and does significantly more damage.','',0,0,0,0,0,0,0,0,0,0,77869,0,26124),
(124111,'Cast Frostbolt until you gain Brain Freeze, then cast Flurry.','',0,0,0,0,0,0,0,0,0,0,77871,0,26124),
(124112,'','Tracking someone this way takes a great deal of energy. I hope I can last...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124113,'','Flurry is another spell in your arsenal. While it can be cast on its own, Flurry is best used in tandem with another ability.',0,0,0,0,0,0,0,0,0,0,0,77866,26124),
(124114,'','Casting Frostbolt can trigger an effect called Brain Freeze.',0,0,0,0,0,0,0,0,0,0,0,77868,26124),
(124115,'','While Brain Freeze is active, Flurry can be cast instantly and does significantly more damage.',0,0,0,0,0,0,0,0,0,0,0,77870,26124),
(124116,'','Cast Frostbolt until you gain Brain Freeze, then cast Flurry.',0,0,0,0,0,0,0,0,0,0,0,77872,26124),
(124117,'I am ready, Thalyssra.','I am ready, Thalyssra.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124118,'Your Frayfeather Hatchling sighs contentedly.','Your Frayfeather Hatchling sighs contentedly.',0,0,0,0,0,0,0,0,0,0,24642,24642,26124),
(124119,'Your Frayfeather Hatchling seems to be learning.','Your Frayfeather Hatchling seems to be learning.',0,0,0,0,0,0,0,0,0,0,24642,24642,26124),
(124120,'Your Frayfeather Hatchling wants to see more of the world.','Your Frayfeather Hatchling wants to see more of the world.',0,0,0,0,0,0,0,0,0,0,24642,24642,26124),
(124121,'Your Frayfeather Hatchling seems impressed.','Your Frayfeather Hatchling seems impressed.',0,0,0,0,0,0,0,0,0,0,24642,24642,26124),
(124122,'Your Frayfeather Hatchling seems bored.','Your Frayfeather Hatchling seems bored.',0,0,0,0,0,0,0,0,0,0,24642,24642,26124),
(124123,'Your Frayfeather Hatchling stretches its wings.','Your Frayfeather Hatchling stretches its wings.',0,0,0,0,0,0,0,0,0,0,24642,24642,26124),
(124124,'Your Frayfeather Hatchling digs its claws tightly into your shoulder.','Your Frayfeather Hatchling digs its claws tightly into your shoulder.',0,0,0,0,0,0,0,0,0,0,24642,24642,26124),
(124125,'Your Frayfeather Hatchling starts to doze off.','Your Frayfeather Hatchling starts to doze off.',0,0,0,0,0,0,0,0,0,0,24642,24642,26124),
(124126,'I am yours to command, Farseer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124127,'I\'d like to review the information you\'ve gathered on the Legion\'s agents.','I\'d like to review the information you\'ve gathered on the Legion\'s agents.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124128,'','Hail, champion.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(124129,'','Talk to me, Vanthir...',0,0,0,0,0,0,0,0,0,0,0,78526,26124),
(124130,'','The moment he was taken from the Waning Crescent he felt such terrible fear... but not for himself.',0,0,0,0,0,0,0,0,0,0,0,78527,26124),
(124131,'','Fear for those that he sheltered, those he sacrificed for.',0,0,0,0,0,0,0,0,0,0,0,78528,26124),
(124132,'','He was taken somewhere dark and isolated. He began to feel hunger settling its roots in his gut.',0,0,0,0,0,0,0,0,0,0,0,78529,26124),
(124133,'','Hunger that did not pass, but grew...',0,0,0,0,0,0,0,0,0,0,0,78530,26124),
(124134,'','... Until he could think of nothing else!',0,0,0,0,0,0,0,0,0,0,0,78531,26124),
(124135,'','He is near to withering. His thoughts are jumbled, frantic... I just need to...',0,0,0,0,0,0,0,0,0,0,0,78532,26124),
(124136,'','Focus! There!',0,0,0,0,0,0,0,0,0,0,0,78533,26124),
(124137,'','He is being held at the Terrace of Order! It must be time for the display...',0,0,0,0,0,0,0,0,0,0,0,78534,26124),
(124138,'It\'s about time someone showed up. I was starting to get bored...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(124139,'Neptulon, the Farseer requests your aid!','',0,0,0,0,0,0,0,0,0,44800,0,0,26124),
(124140,'...what are you standing around for? We\'ve got demons to kill.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(124141,'Those demon bastards stole my gear...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(124142,'Looks like I\'ll have to make my own...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(124143,'I won\'t rest until I\'ve killed every beady-eyed, demon puke on this damned rock...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(124144,'Don\'t worry about me. I\'ll find my own way out...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(124145,'Hasta la vista, soldier.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(124146,'I must admit, Farseer, I am surprised that you achieved what you did.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124147,'My forces and I shall follow you to Broken Shore. We will drown the Legion from this world!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124148,'You aren\'t supposed to be here!','You aren\'t supposed to be here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124149,'The penalty for trespassing here is death!','The penalty for trespassing here is death!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124150,'Another fool on forbidden ground!','Another fool on forbidden ground!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124151,'Leave no stone unturned! The traitors cannot hide from us!','Leave no stone unturned! The traitors cannot hide from us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124152,'We are getting close. I can taste their fear!','We are getting close. I can taste their fear!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124153,'Traitors will be found and killed by decree of the Grand Magistrix!','Traitors will be found and killed by decree of the Grand Magistrix!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124154,'','That took more out of me than I thought it would. You will have to free Vanthir without me. I am sorry.',0,0,0,0,0,0,0,0,0,0,0,78580,26124),
(124155,'Over here, $r. Try not to alert all the guards as you approach.','',0,0,0,0,0,0,0,0,0,924,0,0,26124),
(124156,'Ah, reinforcements! Over here, there is much I have to tell you.','',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(124157,'','I am grateful to see you, even if you are from the other camp. Come quickly, there is much to discuss!',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(124158,'','Thank Elune you are here! I could use a helping hand with this.',0,0,0,0,0,0,0,0,0,924,0,0,26124),
(124159,'','Over here! I sense energies converging below, but aggressive guardians bar my way. I need you to clear a path.',0,0,0,0,0,0,1,0,0,0,0,78577,26124),
(124160,'Fear not, First Arcanist. I will see to it that our friend here comes to no harm.','',0,0,0,0,0,0,0,0,0,0,78594,0,26124),
(124161,'I am sadly familiar with Vanthir\'s captor.','',0,0,0,0,0,0,0,0,0,0,78595,0,26124),
(124162,'','Thank you, Silgryn. Be careful.',0,0,0,0,0,0,0,0,0,0,0,78581,26124),
(124163,'','I will need to maintain my focus for this to work... are you prepared to assist me in this endeavor?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124164,'','Keep your voice down, Silgryn. It is good to see you too.',0,0,0,0,0,0,0,0,0,0,0,78408,26124),
(124165,'Thalyssra?!','',0,0,0,0,0,0,0,0,0,0,78407,0,26124),
(124166,'What manner of spell is this?','',0,0,0,0,0,0,0,0,0,0,78524,0,26124),
(124167,'','One that will find our friend.',0,0,0,0,0,0,0,0,0,0,0,78525,26124),
(124168,'We need to go to Helheim.','We need to go to Helheim.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124169,'Everyone get to the beach! The Legion is relentless in their attacks!','Everyone get to the beach! The Legion is relentless in their attacks!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124170,'','As you wish, Battlelord. Are you ready to depart?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124171,'I\'m ready.','I\'m ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124172,'The library of the Nar\'thalas Academy was said to contain detailed studies of local fauna. Such knowledge could prove quite useful. Leave no page unturned!','',0,0,0,0,0,0,0,0,0,0,78311,0,26124),
(124173,'','Very efficient! Let us get a closer look... Say, this is impressive spellwork.',0,0,0,0,0,0,0,0,0,0,0,78574,26124),
(124174,'I am saved!','I am saved!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124175,'Quickly, into the ruins!','Quickly, into the ruins!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124176,'','A mana bore, perhaps? Hmm... nothing. This requires a great deal of power to maintain.',0,0,0,0,0,0,0,0,0,0,0,78575,26124),
(124177,'I hope you thugs wither!','I hope you thugs wither!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124178,'','It is not attached to the Nightwell, but to the ley lines. Yet we control them, so how can she... Ah, yes. I see!',0,0,0,0,0,0,0,0,0,0,0,78576,26124),
(124179,'So.... if you\'re a warlock.... why are you fighting demons?','So.... if you\'re a warlock.... why are you fighting demons?',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(124180,'You cant just ask a warlock why they fight demons!','You cant just ask a warlock why they fight demons!',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(124181,'....','....',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(124186,'<Vanthir lays still. His eyes are glazed over and staring off into space.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124187,'<Vanthir\'s eyes focus sharply on you. He does not speak.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124188,'We\'re here to get you out, Vanthir. Just hold on.','We\'re here to get you out, Vanthir. Just hold on.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124189,'I\'ve prepared a dusting that will allow my druids to fly for a short while in this humid air.\n\nSay the word and we\'ll begin the distraction while you head to the camp.','',0,0,0,0,0,0,0,0,0,43622,0,0,26124),
(124190,'This humid air has made flying for any significant time rather difficult, but I\'ve developed a dusting that will allow us to take wing long enough to complete our assault.\n\nSay the word and we will begin the diversion while you infiltrate the camp.','',0,0,0,0,0,0,0,0,0,35351,0,0,26124),
(124191,'I\'m ready. Send me to the ramparts!','I\'m ready. Send me to the ramparts!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124192,'Thank you, stranger.','Thank you, stranger.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124193,'We... we were almost killed!','We... we were almost killed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124194,'This city has devolved to madness...','This city has devolved to madness...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124195,'I am safe... thank you.','I am safe... thank you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124196,'Hurry! We\'re not safe here!','Hurry! We\'re not safe here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124197,'Please, find me shelter!','Please, find me shelter!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124198,'There are demons everywhere...','There are demons everywhere...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124199,'I heard there were citizens holding safe houses...','I heard there were citizens holding safe houses...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124200,'','The skies grow dark. We must press on.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124202,'You are hit with anti-aircraft gunfire!','You are hit with anti-aircraft gunfire!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124203,'The Legion\'s forces seem to be growing stronger every day.','The Legion\'s forces seem to be growing stronger every day.',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(124204,'That may be, but I have faith in our commander. Their guidance will lead us to victory!','That may be, but I have faith in our commander. Their guidance will lead us to victory!',0,0,0,0,0,0,0,0,16,0,0,0,26124),
(124208,'The Burning Legion will not be defeated without great sacrifice. Lord Illidan knows this truth more than most.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124209,'','I will not leave this island until every demon has been slain and every fallen Horde warrior has been avenged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124210,'I have no love for the Horde, but their soldiers have fought and bled alongside us against the demons.$b$bWere it not for their bravery and cooperation, none of us would have survived this long.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124211,'|TInterface\\Icons\\SPELL_ARCANE_INVOCATION:20|t |cFFFF0000|Hspell:210022|h[Epocheric Orbs]|h|r fall from the sky!','|TInterface\\Icons\\SPELL_ARCANE_INVOCATION:20|t |cFFFF0000|Hspell:210022|h[Epocheric Orbs]|h|r fall from the sky!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124212,'|TInterface\\Icons\\SPELL_ARCANE_ARCANE01.BLP:20|tYou will |cFFFF0000|Hspell:209973|h[Explode]|h|r in 6 seconds!','|TInterface\\Icons\\SPELL_ARCANE_ARCANE01.BLP:20|tYou will |cFFFF0000|Hspell:209973|h[Explode]|h|r in 6 seconds!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124213,'|TInterface\\Icons\\6BF_Explosive_Shard.blp:20|t%s weaves |cFFFF0000|Hspell:209598|h[Conflexive]|h|r energies through her enemies!','|TInterface\\Icons\\6BF_Explosive_Shard.blp:20|t%s weaves |cFFFF0000|Hspell:209598|h[Conflexive]|h|r energies through her enemies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124214,'|TInterface\\Icons\\Spell_Mage_ArcaneOrb.blp:20|t%s targets her enemies with |cFFFF0000|Hspell:214278|h[Delphuric Beams]|h|r !','|TInterface\\Icons\\Spell_Mage_ArcaneOrb.blp:20|t%s targets her enemies with |cFFFF0000|Hspell:214278|h[Delphuric Beams]|h|r !',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124215,'|TInterface\\Icons\\Spell_Mage_ArcaneOrb.blp:20|t |cFFFF0000|Hspell:228877|h[Arcanetic Rings]|h|r collapse in from the edge of the room!','|TInterface\\Icons\\Spell_Mage_ArcaneOrb.blp:20|t |cFFFF0000|Hspell:228877|h[Arcanetic Rings]|h|r Collapse in from the edge of the room!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124216,'I have served for so long, I cannot recall a time when I was of my own will.  Do you need a servant?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124217,'Then I choose to join you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124218,'Yes, but your spirit is free to do what you will. You no longer need to serve him.','Yes, but your spirit is free to do what you will.  You no longer need to serve him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124219,'Not a servant, but you are welcome to join me and help me fight.','Not a servant, but you are welcome to join me and help me fight.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124220,'The Duskwatch have taken outposts in the Crimson Thicket. Unleash the Withered at your command and drive them out!','',0,0,0,0,0,0,0,0,0,0,78387,0,26124),
(124221,'The Duskwatch presume to push beyond their borders in the midst of a revolution. You repaid them for their arrogance!','',0,0,0,0,0,0,0,0,0,0,78388,0,26124),
(124222,'Knowledge of potential threats gives us an advantage in battle. As ever, you\'ve proven to be a quick study!','',0,0,0,0,0,0,0,0,0,0,78312,0,26124),
(124223,'Confess! You are harboring traitors to Suramar!','Confess! You are harboring traitors to Suramar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124224,'We know where your family is. Speak, or they die too!','We know where your family is. Speak, or they die too!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124225,'Those who oppose the Grand Magistrix will pay dearly!','Those who oppose the Grand Magistrix will pay dearly!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124226,'Dissent is forbidden, by order of Grand Magistrix Elisande!','Dissent is forbidden, by order of Grand Magistrix Elisande!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124229,'Ahhhhhhhh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124230,'No! Our hippo! We submit!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124232,'The mages of Nar\'thalas were known to craft wands of exceptional quality. You might see if their techniques could aid our war against the Legion.','',0,0,0,0,0,0,0,0,0,0,78277,0,26124),
(124233,'Not necessarily what I had in mind, but insight is insight. Let\'s keep an eye out for other... learning opportunities.','',0,0,0,0,0,0,0,0,0,0,78278,0,26124),
(124234,'','Wonderful, my favorite cheese.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124235,'Nothing quite like the perfect rack of ribs.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124236,'The scholars of Nar\'thalas Academy were renowned for their knowledge of spell runes. Perhaps you might glean ancient secrets from the spirits who linger there.','',0,0,0,0,0,0,0,0,0,0,78279,0,26124),
(124237,'Your outline work was exceptional. I\'d ask you to tutor Kirin Tor initiates... if you weren\'t busy saving the world from demons, I mean.','',0,0,0,0,0,0,0,0,0,0,78280,0,26124),
(124238,'Tensions between the Horde and Alliance are tight enough when they share a battlefield. But the elves? You can practically cut this tension with a knife.','Tensions between the Horde and Alliance are tight enough when they share a battlefield. But the elves? You can practically cut this tension with a knife.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124239,'Kaldorei, Sin\'dorei, Quel\'dorei, and Shal\'dorei? More like Don\'torei. Am I right?','Kaldorei, Sin\'dorei, Quel\'dorei, and Shal\'dorei? More like Don\'torei. Am I right?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124240,'Conflict between the armies will not be tolerated. We are here to make sure everyone stays on target.','Conflict between the armies will not be tolerated. We are here to make sure everyone stays on target.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124241,'Rogue Nightfallen are rebuilding mana pylons in the Ley-Ruins. The Azurewing have requested your help in eradicating this pestilence, champion.','',0,0,0,0,0,0,0,0,0,0,78289,0,26124),
(124242,'Suramar is a city filled with so much magic it will be a true challenge to invade it. I just hope we can keep these armies together until we are successful.','Suramar is a city filled with so much magic it will be a true challenge to invade it. I just hope we can keep these armies together until we are successful.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124243,'Khadgar put out the call to anyone willing to send troops to support this army. So who comes? \n\nBlood elves and night elves. The two races so at odds with each other it makes the feud between the Alliance and Horde seem almost paltry.','Khadgar put out the call to anyone willing to send troops to support this army. So who comes? \n\nBlood elves and night elves. The two races so at odds with each other it makes the feud between the Alliance and Horde seem almost paltry.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124244,'The elves keep pulling pranks on each other. We are just trying to make sure things don\'t turn to violence.','The elves keep pulling pranks on each other. We are just trying to make sure things don\'t turn to violence.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124245,'Vereesa almost shot at Rommath this morning. Khadgar had to talk her down... again.','Vereesa almost shot at Rommath this morning. Khadgar had to talk her down... again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124246,'So far the Suramar army has been hesitant to stretch out from their walls. I hope that doesn\'t mean they are planning something.','So far the Suramar army has been hesitant to stretch out from their walls. I hope that doesn\'t mean they are planning something.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124247,'%s becomes enraged at the death of nearby offspring!','%s becomes enraged at the death of nearby offspring!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124248,'The Azurewing have proven to be a valuable ally. By aiding them, you\'ve ensured their support in our campaign against the Legion.','',0,0,0,0,0,0,0,0,0,0,78290,0,26124),
(124249,'Our allies have suffered the brunt of the enchantment. I can protect us from the residual energies for a time.','',0,0,0,0,0,0,1,0,0,0,78583,0,26124),
(124250,'This temporal magic rivals that of the bronze dragonflight! I must concentrate on maintaining our defenses.','',0,0,0,0,0,0,0,0,0,0,78584,0,26124),
(124251,'Take care! Hostile entities have been drawn to this disruption of time! Alright, lead the way.','',0,0,0,0,0,0,0,0,0,0,78585,0,26124),
(124252,'Tyrande! I will attempt to pull her out, but doing so will require total focus. Be on your guard, $n.','',0,0,0,0,0,0,0,0,0,924,78589,0,26124),
(124253,'That was close! I nearly shattered the flow of time itself.. but I think it\'s better now. Are you alright?','',0,0,0,0,0,0,0,0,0,0,78586,0,26124),
(124254,'','I... I am well. What has happened?',0,0,0,0,0,0,0,0,0,0,0,78572,26124),
(124255,'No time for that now. Let me get you somewhere safe!','',0,0,0,0,0,0,0,0,0,0,78587,0,26124),
(124256,'','During the shattering of Azeroth, much knowledge was lost. But I, Lunelli, speak with the earth and the wind.$b$bThey have told me much and given me knowledge to pass on to those who think themselves worthy.$b$bSo, are you such a person?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124257,'I can\'t maintain our protection any longer! We need to go.','',0,0,0,0,0,0,0,0,0,0,78588,0,26124),
(124258,'Liadrin! I will attempt to pull her out, but doing so will require total focus. Be on your guard, $n.','',0,0,0,0,0,0,0,0,0,923,78590,0,26124),
(124259,'','I couldn\'t get my shield up in time. What happened?',0,0,0,0,0,0,0,0,0,0,0,78573,26124),
(124260,'You think to stop this demonstration? Very well. I will make an example of you first!','',0,0,0,0,0,0,0,0,0,0,78599,0,26124),
(124261,'Stay your blade, Thoramir!','',0,0,0,0,0,0,0,0,0,0,78600,0,26124),
(124262,'How good of you to join us, Silgryn. Aluriel sends her regards!','',0,0,0,0,0,0,0,0,0,0,78601,0,26124),
(124263,'Accept your fate, Silgryn. You are outmatched!','',0,0,0,0,0,0,0,0,0,0,78605,0,26124),
(124264,'Perhaps, but I am not alone.','',0,0,0,0,0,0,0,0,0,0,78606,0,26124),
(124265,'You disappointed her, spell-fencer. You could have taken my place, if you had remained.','',0,0,0,0,0,0,0,0,0,0,78602,0,26124),
(124266,'I have a conscience. I serve the people of Suramar.','',0,0,0,0,0,0,0,0,0,0,78603,0,26124),
(124267,'You\'re too late, mortals! After I deal with you, this wretched world shall burn!','',0,0,0,0,0,0,0,0,0,0,82865,0,26124),
(124268,'Yet you raise your blades against us! You are nothing but a traitor!','',0,0,0,0,0,0,0,0,0,0,78604,0,26124),
(124269,'She... was right... about you...','',0,0,0,0,0,0,0,0,0,0,78607,0,26124),
(124270,'I know.','',0,0,0,0,0,0,0,0,0,0,78608,0,26124),
(124271,'This... isn\'t... finished...','',0,0,0,0,0,0,0,0,0,0,82866,0,26124),
(124272,'We should not linger. Let us see to Vanthir now.','',0,0,0,0,0,0,0,0,0,0,78609,0,26124),
(124285,'It feels good to no longer be hungry. I bet I could teleport anything now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124286,'Telemancy beacons help supply power for teleportation triangulation. We should construct additional beacons.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124287,'Mage portals take so long to cast. With telemancy, it is like instant transmission!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124288,'Ready to go, $n? I always love teleporting to a new place!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124289,'Let\'s go!','Let\'s go!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124290,'Next stop, sunny Azsuna! At least... it was sunny last time I checked. Which was only a few thousand years ago.','',0,0,0,0,0,0,0,0,0,0,78522,0,26124),
(124291,'There we are! I am more or less locked on to the location you requested. Off you go!','',0,0,0,0,0,0,0,0,0,0,78523,0,26124),
(124292,'','Wait... what do you--',0,0,0,0,0,0,0,0,0,0,0,78521,26124),
(124293,'','Use Feral Spirit now to summon these spirits.',0,0,0,0,0,0,0,0,0,0,0,77877,26124),
(124294,'Use Feral Spirit now to summon these spirits.','',0,0,0,0,0,0,0,0,0,0,77878,0,26124),
(124295,'','The Legion sought to use its agents to subvert our efforts at the Tomb of Sargeras. Thanks to your efforts, they failed.',0,0,0,0,0,0,1,0,0,0,0,81328,26124),
(124296,'','Now we focus on driving their armies from Azeroth. We will give everything we have and finish this... once and for all!',0,0,0,0,0,0,603,0,0,0,0,81329,26124),
(124297,'Our power manifests: Kirin\'var torel, ahm shalar, azakim!','',0,0,0,0,0,0,1,0,4,0,81331,0,26124),
(124298,'','Together! We must all lend our strength!',0,0,0,0,0,0,1,0,4,0,0,81327,26124),
(124299,'','Step back and raise your weapon. We will infuse it with a portion of this council\'s power.',0,0,0,0,0,0,1,0,0,0,0,81330,26124),
(124300,'Erk!','Erk!',0,0,0,0,0,0,602,0,0,0,0,0,26124),
(124301,'','You sought to hide, Nightfallen? I could sense your teleportation signatures from Azurewing!',0,0,0,0,0,0,0,0,0,0,0,78287,26124),
(124302,'','Our champion\'s presence is the only thing staying my hand. Speak quickly.',0,0,0,0,0,0,0,0,0,0,0,78288,26124),
(124303,'','By placing the taps on key points of the ley line, I can direct its flow.',0,0,0,0,0,0,1,0,0,0,0,78298,26124),
(124304,'','Are you sure about that placement? It would be better here.',0,0,0,0,0,0,0,0,0,0,0,78301,26124),
(124305,'','But I can see the line and the focus of the conduit. You want to put it there.',0,0,0,0,0,0,0,0,0,0,0,78303,26124),
(124306,'','You can do that? Perhaps you know a thing or two after all.',0,0,0,0,0,0,1,0,0,0,0,78305,26124),
(124307,'','Wait! This isn\'t what it looks like! We simply need to tap the... Oh. I guess it is what it looks like...',0,0,0,0,0,0,1,0,0,0,0,78286,26124),
(124308,'','I am not \"poking\" it, I am tapping-- Hmph. I suppose it could work there...',0,0,0,0,0,0,603,0,0,0,0,78300,26124),
(124309,'','I have spent millenia studying ley lines. I am certainly capable of finding one right beneath my feet!',0,0,0,0,0,0,0,0,0,0,0,78306,26124),
(124310,'','Fine! We can do it your way. But if this entire cave ends up exploding with arcane energy, it will be on your head.',0,0,0,0,0,0,0,0,0,0,0,78307,26124),
(124311,'','This final tap will allow me to steer the flow of energy, like the rudder of a ship. Right around here should do the trick.',0,0,0,0,0,0,0,0,0,0,0,78308,26124),
(124312,'','My goodness. Was that a compliment?',0,0,0,0,0,0,1,0,0,0,0,78309,26124),
(124313,'Sin\'dorei and shal\'dorei, take the Promenade and hold it against our foes. Once we have that, the kaldorei ride ahead and take the Concourse.','',0,0,0,0,0,0,0,0,0,0,78231,0,26124),
(124314,'Archdruid... you have no doubt proven your strength to me in the past. I will proudly stand by your side to face the Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124315,'The might of the bears will be with you. We shall be your steady guardians. Failure is not an option.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124316,'Now to combine the fragments you recovered.','',0,0,0,0,0,0,1,0,0,0,78180,0,26124),
(124317,'That\'s a pity... I\'m afraid the results are imperfect. The message encoded into the crystal is scrambled. I can only make out a few--','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124318,'No! I was so distracted by our efforts on the Broken Isles that I neglected the defenses I put in place...','',0,0,0,0,0,0,5,0,0,0,78178,0,26124),
(124319,'The Legion has taken Karazhan! We MUST get it back!','',0,0,0,0,0,0,603,0,0,0,78177,0,26124),
(124320,'','The ritual demands my full concentration. Please ensure I am not interrupted.',0,0,0,0,0,0,0,0,0,0,0,78291,26124),
(124321,'','The currents are chaotic... this will take time.',0,0,0,0,0,0,0,0,0,0,0,78294,26124),
(124322,'','Almost... there. Just need to hold out a little longer!',0,0,0,0,0,0,0,0,0,0,0,78296,26124),
(124323,'','It is done! The flow has been redirected to Shal\'Aran.',0,0,0,0,0,0,0,0,0,0,0,78297,26124),
(124324,'','You have done enough, arcanist. I shall take you both to Shal\'Aran. Come with me.',0,0,0,0,0,0,0,0,0,0,0,78269,26124),
(124325,'We need to travel to Karazhan at once and discover what the Legion is after. I\'ll conjure a portal.','',0,0,0,0,0,0,1,0,0,0,78182,0,26124),
(124326,'Archmage Karlain, we could use your assistance.','',0,0,0,0,0,0,1,0,0,0,78181,0,26124),
(124327,'|TINTERFACE\\ICONS\\SHA_ABILITY_ROGUE_BLOODYEYE:20|tLook away when Things That Should Not Be cast |cFFFF0000|Hspell:207720|h[Witness the Void]|h|r to avoid being feared!','|TINTERFACE\\ICONS\\SHA_ABILITY_ROGUE_BLOODYEYE:20|Look away when Things That Should Not Be cast |cFFFF0000|Hspell:207720|h[Witness the Void] to avoid being feared|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(124328,'','If you are going to poke at a ley line, at least make sure it\'s the right spot. Try a little bit to the right.',0,0,0,0,0,0,25,0,0,0,0,78299,26124),
(124329,'We are in it now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124330,'<Present the Zeppelin Rental Form.>','<Present the Zeppelin Rental Form.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124331,'','Anyway, moving along!',0,0,0,0,0,0,1,0,0,0,0,78302,26124),
(124332,'','The next tap should go here.',0,0,0,0,0,0,0,0,0,0,0,78304,26124),
(124333,'No worries. You might not have EARNED the right to go up on the zep, but some schmuck PAID me to let you go on. So you\'re good to go.\n\nHop onto that teleporter! It definitely, probably won\'t kill you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124335,'Free zeppelin rides for everyone, courtesy of $n! Come on over to the teleporter!','',0,0,0,0,0,0,0,0,0,0,80244,0,26124),
(124336,'','You have our thanks. We will monitor their numbers closely.',0,0,0,0,0,0,0,0,0,0,0,77957,26124),
(124337,'','Strange predators are encroaching on this ecosystem. Cull their numbers before they spread!',0,0,0,0,0,0,0,0,0,0,0,77956,26124),
(124338,'','Another victory! You have proven to be quite the hunter of beasts.',0,0,0,0,0,0,0,0,0,0,0,77958,26124),
(124339,'','Their wings are clipped.',0,0,0,0,0,0,0,0,0,0,0,77959,26124),
(124340,'','You have done admirably in putting down this fowl menace.',0,0,0,0,0,0,0,0,0,0,0,77960,26124),
(124341,'','We heard much squawking! We hope that means you were victorious.',0,0,0,0,0,0,0,0,0,0,0,77961,26124),
(124342,'','Predatory birds have flown in from offshore. Push them back out to sea, lest we be overrun.',0,0,0,0,0,0,0,0,0,0,0,77962,26124),
(124343,'','These feathered fiends are breeding out of control! End their cacophonous revelry!',0,0,0,0,0,0,0,0,0,0,0,77963,26124),
(124344,'','Beware the sharp talons of these avian beasts! We have found them quite ferocious.',0,0,0,0,0,0,0,0,0,0,0,77964,26124),
(124345,'','More frenzied fowl have overtaken this area. Cull their numbers before those eggs hatch.',0,0,0,0,0,0,0,0,0,0,0,77965,26124),
(124346,'Yo! What\'ll it be?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124347,'<Present the Free Drinks Voucher.>','<Present the Free Drinks Voucher.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124348,'I will get you as close to the Crescent as I can. We will be in touch.','',0,0,0,0,0,0,0,0,0,0,78390,0,26124),
(124349,'Hmph. Not as close as I\'d like, but it will have to do. Be careful.','',0,0,0,0,0,0,0,0,0,0,78393,0,26124),
(124350,'Practice using your attacks by eliminating these target dummies.','',0,0,0,0,0,0,25,0,0,0,77976,0,26124),
(124351,'','Practice using your attacks by eliminating these target dummies.',0,0,0,0,0,0,0,0,0,0,0,77977,26124),
(124352,'This round\'s on $n! Free drinks for the next two minutes!','',0,0,0,0,0,0,0,0,0,0,80244,0,26124),
(124353,'There you are! Over here!','',0,0,0,0,0,0,0,0,0,0,78391,0,26124),
(124354,'Hmm? Oh, you again. Here to do some extracurricular studies, I presume.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124355,'Carry on, then.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124356,'Interested in buying something?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124357,'<Present the Brawler\'s Potion Dispenser.>','<Present the Brawler\'s Potion Dispenser.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124358,'$n has most generously paid for everyone\'s brawling potions. Get them while they\'re hot and bubbly!','',0,0,0,0,0,0,0,0,0,0,80244,0,26124),
(124359,'','Interested in purchasing something... underhanded?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124360,'<Present the Blood-Soaked Angel Figurine.>','<Present the Blood-Soaked Angel Figurine.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124361,'I will move ahead and clear out a safe haven for the survivors. Stay strong, my friend.','',0,0,0,0,0,0,0,0,0,0,78360,0,26124),
(124362,'Hydras. Fascinating creatures, they are.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124363,'','Attention, brawlers! $n has made a bargain with the Spirit Healers! Go ahead and die as much as you want!',0,0,0,0,0,0,0,0,0,0,0,80244,26124),
(124364,'I would like to make a suggestion for your studies. Check the top of the bookcase, if you will.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124365,'Well then.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124366,'That was certainly interesting.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124367,'Moving on, could I interest you in a look at the dragons of the eastern shore?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124368,'I would ask that you obtain the literature, however. I cannot seem to locate it...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124369,'Cannons at the ready... FIRE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124370,'Fire the cannons!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124371,'Fire at will!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124372,'Aye, there\'s the target! Cannons... FIRE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124373,'There\'s your target, lads! Fire away!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124374,'','You may help me find the ley lines, if you must. Just try not to get in my way.',0,0,0,0,0,0,0,0,0,0,0,78310,26124),
(124376,'We tend to keep our distance, though. Ever since the research incident.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124377,'I would like to make a suggestion for your studies. Check the top of the bookcase, if you will.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124379,'<The orphaned direbeak falcosaur is looking around frantically for its mother.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124380,'<The orphaned bloodgazer falcosaur is shaking uncontrollably. It looks terrified.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124381,'<The orphaned sharptalon falcosaur cries out in hunger.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124382,'<The orphaned snowfeather falcosaur is so weak it can barely walk.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124383,'<Give the orphaned direbeak some of your Pungent Vrykul Gamalost.>','<Give the orphaned direbeak some of your Pungent Vrykul Gamalost.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124384,'<Give the orphaned snowfeather some of your Smoked Elderhorn.>','<Give the orphaned snowfeather some of your Smoked Elderhorn.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124385,'<Give the orphaned bloodgazer some of your Azsunian Grapes.>','<Give the orphaned bloodgazer some of your Azsunian Grapes.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124386,'<Give the orphaned sharptalon some of your Dried Bilberries.>','<Give the orphaned sharptalon some of your Dried Bilberries.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124387,'More bones for the arena!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124388,'More bones for the arena!','',0,0,0,0,0,0,1,0,0,0,78034,0,26124),
(124389,'Hahahaha!','',0,0,0,0,0,0,1,0,0,0,78037,0,26124),
(124390,'Wow! What killed you so fast?','',0,0,0,0,0,0,1,0,0,0,78036,0,26124),
(124391,'You bore me!','',0,0,0,0,0,0,1,0,0,0,78035,0,26124),
(124392,'Get in there and fight, stop hiding!','',0,0,0,0,0,0,1,0,0,0,78039,0,26124),
(124393,'All you weaklings do is run around!','',0,0,0,0,0,0,1,0,0,0,78040,0,26124),
(124394,'Finish him!','',0,0,0,0,0,0,1,0,0,0,78041,0,26124),
(124395,'Finish her!','',0,0,0,0,0,0,1,0,0,0,78042,0,26124),
(124396,'Ahhhh?!','',0,0,0,0,0,0,1,0,0,0,78043,0,26124),
(124397,'Yes, yes!','',0,0,0,0,0,0,1,0,0,0,78045,0,26124),
(124398,'Let the games... BEGIN!','',0,0,0,0,0,0,1,0,0,0,78044,0,26124),
(124399,'Deathlord, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',0,0,0,0,0,0,2,0,0,0,81456,0,26124),
(124400,'Dun\'na listen to anything Thelaron says. Nothing beats a strong hammer, a molten flame and fine steel.$b$bSpeakin\' o\'which, I should get back ta work.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124401,'','Are you watchin\' these fights? Lots of punishment bein\' handed out in that ring. I think I got hit with a tooth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124402,'<Present the High Roller\'s Contract.>','<Present the High Roller\'s Contract.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124403,'','You feelin\' lucky? $n wants you to talk to Pit Boss Buxdoggle and test your... gold-earning potential.',0,0,0,0,0,0,0,0,0,0,0,80244,26124),
(124404,'<Present the Bag of Chipped Dice.>','<Present the Bag of Chipped Dice.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124405,'','I will take the teleporter to the estate and bring our most powerful Withered. Meet me there.',0,0,0,0,0,0,396,0,0,0,0,78348,26124),
(124406,'','$n has turned in enough gold to bend the rules of the arena. Speak to a grunt if you\'d like to fight against a random brawler!',0,0,0,0,0,0,0,0,0,0,0,80244,26124),
(124407,'Slayer, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',0,0,0,0,0,0,2,0,0,0,81457,0,26124),
(124408,'Archdruid, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',0,0,0,0,0,0,2,0,0,0,81458,0,26124),
(124409,'Huntmaster, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',0,0,0,0,0,0,2,0,0,0,81459,0,26124),
(124410,'Archmage, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',0,0,0,0,0,0,2,0,0,0,81460,0,26124),
(124411,'Grandmaster, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',0,0,0,0,0,0,2,0,0,0,81461,0,26124),
(124412,'Highlord, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',0,0,0,0,0,0,2,0,0,0,81462,0,26124),
(124413,'High Priest, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',0,0,0,0,0,0,2,0,0,0,81463,0,26124),
(124414,'Shadowblade, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',0,0,0,0,0,0,2,0,0,0,81464,0,26124),
(124415,'Farseer, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',0,0,0,0,0,0,2,0,0,0,81465,0,26124),
(124416,'Netherlord, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',0,0,0,0,0,0,2,0,0,0,81466,0,26124),
(124417,'Battlelord, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',0,0,0,0,0,0,2,0,0,0,81467,0,26124),
(124418,'','Cozy, secluded, and teeming with arcane energy. I might need to construct a workshop here...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124419,'','This cave is really well hidden. I am surprised Oculeth managed to get us here in one piece.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124420,'','Are you ready to begin the ritual, $n?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124421,'I am ready, Valtrois.','I am ready, Valtrois.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124422,'I\'m only mildly enthusiastic about this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124423,'Errrrrrr...','Errrrrrr...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124424,'Erk?','Erk?',0,0,0,0,0,0,602,0,0,0,0,0,26124),
(124425,'Baroo!','Baroo!',0,0,0,0,0,0,377,0,0,0,0,0,26124),
(124426,'','Elisande made YOU First Arcanist? The pickings must have been slim indeed. Release Ly\'leth now!',0,0,0,0,0,0,397,0,0,0,0,78349,26124),
(124427,'','Ha! This is what you bring? An outlander and a pack of mindless, mana-starved corpses? You have fallen on hard times indeed.',0,0,0,0,0,0,6,0,0,0,0,78350,26124),
(124428,'','I\'ll show you what these corpses can do. Attack!',0,0,0,0,0,0,396,0,0,0,0,78351,26124),
(124429,'','Poor Thalyssra... you try so hard to save your people, yet you cut them off from the one thing that can restore them! I fear Ly\'leth shall pay the price for your arrogance.',0,0,0,0,0,0,11,0,0,0,0,78355,26124),
(124430,'','Let us test the mettle of your rebellion! Send your best to face me at Ly\'leth\'s estate... before I bring in more citizens for... questioning!',0,0,0,0,0,0,1,0,0,0,0,78356,26124),
(124431,'','As if I would bother with facing you myself. Felborne! Kill them!',0,0,0,0,0,0,1,0,0,0,0,78352,26124),
(124432,'','The Withered... defeated so easily by fel magic. Please... save those you can. My wounds... are of no concern!',0,0,0,0,0,0,0,0,0,0,0,78353,26124),
(124433,'Is this some sort of joke?!','Is this some sort of joke?!',0,0,0,0,0,0,5,0,0,46048,0,0,26124),
(124434,'I can\'t even guess what they made this out of.','I can\'t even guess what they made this out of.',0,0,0,0,0,0,1,0,0,46048,0,0,26124),
(124435,'I want to fight a random enemy!','I want to fight a random enemy!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(124436,'Where did they even get the stuff to make this?','Where did they even get the stuff to make this?',0,0,0,0,0,0,6,0,0,46048,0,0,26124),
(124437,'Those throwback, tree hugging, kaldorei filth.','Those throwback, tree hugging, kaldorei filth.',0,0,0,0,0,0,274,0,0,46048,0,0,26124),
(124438,'Those... those... night elves!','Those... those... night elves!',0,0,0,0,0,0,5,0,0,46048,0,0,26124),
(124440,'unused do not translate','',0,0,0,0,0,0,377,0,0,0,0,0,26124),
(124441,'','Whatever you plan to do, do it quickly. I sense the approach of something... hungry!',0,0,0,0,0,0,0,0,0,0,0,78293,26124),
(124442,'','Look out, champion! It is here!',0,0,0,0,0,0,0,0,0,0,0,78295,26124),
(124443,'%s is tired after its adventure!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124444,'Rrrr....','Rrrr....',0,0,0,0,0,0,35,0,0,0,0,0,26124),
(124445,'%s seems content.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124446,'%s chitters happily.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124447,'%s admires you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124448,'','I must rest before we make our way back to Shal\'Aran. That was more taxing than I expected...',0,0,0,0,0,0,0,0,0,0,0,78268,26124),
(124449,'','You made an excellent assistant. Your inherent knowledge of ley lines is almost as expansive as mine.',0,0,0,0,0,0,0,0,0,0,0,78270,26124),
(124450,'','I know what she would be capable of. That is why we must stop her.',0,0,0,0,0,0,0,0,0,0,0,78272,26124),
(124451,'','You go on ahead and inform Thalyssra. I have a few questions for our friend here.',0,0,0,0,0,0,0,0,0,0,0,78274,26124),
(124452,'','Do you actually visualize the lines, or is it more that you sense them? Is it a constant sensation, or can you turn it on and off?',0,0,0,0,0,0,0,0,0,0,0,78276,26124),
(124453,'%s examines the fragment.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124454,'','Your control over such vast energies is impressive. That was no small task.',0,0,0,0,0,0,0,0,0,0,0,78271,26124),
(124455,'','The drogbar are wreaking havoc in Thunder Totem, scattering our drums and chasing off our livestock. These disruptions must be stopped!',0,0,0,0,0,0,0,0,0,0,0,78315,26124),
(124456,'','Order has been restored. Your aid is always welcome here, champion. For Highmountain!',0,0,0,0,0,0,0,0,0,0,0,78316,26124),
(124457,'','Unruly drogbar have thrown our supply crates to the bottom of the chasm. Luckily, we have a convenient method for their retrieval...',0,0,0,0,0,0,0,0,0,0,0,78313,26124),
(124458,'','Our thanks, champion. We refuse to let the drogbar sabotage our way of life. We are Highmountain!',0,0,0,0,0,0,0,0,0,0,0,78314,26124),
(124459,'','Yes, and I know the convergence of ley lines feeds great power to the Nightwell. Harnessing that much power is perilous, but if she could...',0,0,0,0,0,0,0,0,0,0,0,78273,26124),
(124460,'','Yes? What do you want to know?',0,0,0,0,0,0,0,0,0,0,0,78275,26124),
(124461,'','I remember this power... Kel\'balor! The Crimson Thicket is our destination.',0,0,0,0,0,0,1,0,0,0,0,78461,26124),
(124462,'','Ah, you have arrived. I expected to find something here but...',0,0,0,0,0,0,1,0,0,0,0,78462,26124),
(124463,'','One down, two to go. Let me know when you are ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124464,'','This is the last one. One last knot to work loose, and the energy should flow freely again.$b$bI hope you are ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124465,'A frigid storm is brewing atop the peak near Hafr Fjall. Strike down its source before the land suffers in its icy wake!','',0,0,0,0,0,0,0,0,0,0,78323,0,26124),
(124466,'Well done, champion. You fight with the fury of a storm!','',0,0,0,0,0,0,0,0,0,0,78324,0,26124),
(124467,'The Blackfeathers have named a new chieftain after the last... incident. It seems they intend to give their ritual another try.','',0,0,0,0,0,0,0,0,0,0,78328,0,26124),
(124468,'It seems dancing can be dangerous! Careful not to be too loose of foot.','',0,0,0,0,0,0,0,0,0,0,78329,0,26124),
(124469,'An unusual creature near the coast is challenging the local makrura. I sense it has a connection to you... Go to its aid, champion.','',0,0,0,0,0,0,0,0,0,0,78326,0,26124),
(124470,'It seems you two share a kinship. An ally is an ally... no matter now small!','',0,0,0,0,0,0,0,0,0,0,78327,0,26124),
(124471,'Much has been asked of you in the course of this war, champion. I fear even more is needed.','',0,0,0,0,0,0,0,0,4,0,81324,0,26124),
(124473,'Traces of Shaladrassil\'s corruption remain within Suramar. Perhaps the horns of the vile satyrs may be put to better use.','',0,0,0,0,0,0,0,0,0,0,78519,0,26124),
(124476,'Such corruption can be relentless, but you have pushed it back... for now.','',0,0,0,0,0,0,0,0,0,0,78520,0,26124),
(124477,'','Archdruid, I have witnessed your power grow through every trial you have overcome.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124478,'','Your greatest test is at hand. You must purge the Legion\'s corruption from Azeroth... once and for all.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124479,'','My followers and I stand with you, Archdruid. Balance must be restored!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124480,'','Allow me to aid you. My dragon form is ill-suited for fighting in such close quarters, and we are accompanied by a capable champion.',0,0,0,0,0,0,0,0,0,0,0,78292,26124),
(124481,'The owlkitten patriarch, Yowlon, is having trouble herding his kittens back home. Look into those eyes, champion. You cannot possibly leave them in danger!','',0,0,0,0,0,0,0,0,0,0,78394,0,26124),
(124482,'I am relieved they are safe, at least for now. Hmm, perhaps I should look into adoption...','',0,0,0,0,0,0,0,0,0,0,78395,0,26124),
(124483,'Champion! It is time to demonstrate your strength and skill once again!','',0,0,0,0,0,0,0,0,0,0,78325,0,26124),
(124484,'Champion! I have need of your aid. There is important work to be done.','',0,0,0,0,0,0,0,0,0,0,78281,0,26124),
(124485,'Friend, I request your aid for the sake of Suramar. The survival of my people depends on it.','',0,0,0,0,0,0,0,0,0,0,78518,0,26124),
(124486,'','This ley line is being leeched, but I cannot see... wait! I have an idea.',0,0,0,0,0,0,1,0,0,0,0,78463,26124),
(124487,'','Those fel-sucking, city-dwelling narcissists!',0,0,0,0,0,0,5,0,0,46048,0,0,26124),
(124488,'','Who would leave such an insulting thing here?',0,0,0,0,0,0,6,0,0,46048,0,0,26124),
(124489,'','A clever cloaking spell, but what is that device? Keep watch.',0,0,0,0,0,0,1,0,0,0,0,78464,26124),
(124490,'','Well, this was childish.',0,0,0,0,0,0,14,0,0,46048,0,0,26124),
(124491,'','I would expect this type of low blow from a dwarf...',0,0,0,0,0,0,1,0,0,46048,0,0,26124),
(124492,'','I don\'t get it...',0,0,0,0,0,0,661,0,0,46048,0,0,26124),
(124493,'','Hmm.. they are redirecting a portion of the ley line\'s power directly to the Sanctum of Order.',0,0,0,0,0,0,1,0,0,0,0,78465,26124),
(124494,'','I\'m hesitant to take any action at this point. I\'ll return to Shal\'Aran and continue my research.',0,0,0,0,0,0,0,0,0,0,0,78466,26124),
(124495,'','Very well, I shall begin. When I am finished, all the devices we have \"adjusted\" will cease working.',0,0,0,0,0,0,1,0,0,0,0,78382,26124),
(124496,'','It is done. The barrier should be down.',0,0,0,0,0,0,0,0,0,0,0,78383,26124),
(124497,'I will open the portal. The element of surprise will be in your favor!','',0,0,0,0,0,0,0,0,0,0,78384,0,26124),
(124498,'','If anything goes wrong, have your Withered at the ready. Good luck, $n.',0,0,0,0,0,0,1,0,0,0,0,78385,26124),
(124499,'DELETE','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124500,'We cannot tarry here for long, I fear. Catch your breath.','',0,0,0,0,0,0,0,0,0,0,78565,0,26124),
(124501,'I hope she sees this...','',0,0,0,0,0,0,0,0,0,0,78550,0,26124),
(124502,'This way! Everyone into the boat!','',0,0,0,0,0,0,0,0,0,0,78551,0,26124),
(124503,'Excellent timing as usual, Deline.','',0,0,0,0,0,0,0,0,0,0,78552,0,26124),
(124504,'','She is waiting for you just outside.',0,0,0,0,0,0,1,0,0,0,0,78535,26124),
(124505,'','Do you remember me, outlander?',0,0,0,0,0,0,1,0,0,0,0,78536,26124),
(124506,'','The fruit from this tree plucked me from the jaws of madness. I am whole now, and I wish to fight.',0,0,0,0,0,0,1,0,0,0,0,78541,26124),
(124507,'','My brother rests here. My name is Arluelle.',0,0,0,0,0,0,1,0,0,0,0,78537,26124),
(124509,'','It is an honor to finally meet you, First Arcanist.',0,0,0,0,0,0,66,0,0,0,0,78538,26124),
(124510,'','You must be Arluin\'s sister. We owe him a great debt. His sacrifice was not in vain.',0,0,0,0,0,0,396,0,0,0,0,78539,26124),
(124511,'','So be it. I will send you to Silgryn. With his training you will serve us well.',0,0,0,0,0,0,396,0,0,0,0,78542,26124),
(124512,'Excellent. Begin when ready. Use the surveyor and follow the alignment indicator. Uh... the light. Just follow the light!','',0,0,0,0,0,0,0,0,0,0,78512,0,26124),
(124513,'That shall suffice for now. This positional data will enhance-- Oh, nevermind. You did a fine job.','',0,0,0,0,0,0,0,0,0,0,78513,0,26124),
(124514,'','We have been discovered!',0,0,0,0,0,0,0,0,0,0,0,78399,26124),
(124515,'','This should shock me, but it does not. Not after the Waning Crescent.',0,0,0,0,0,0,0,0,0,0,0,78472,26124),
(124516,'','We must put an end to this.',0,0,0,0,0,0,0,0,0,0,0,78473,26124),
(124517,'The telemancy orbs are working perfectly. Best we keep this quiet until we\'re ready for the real push.','',0,0,0,0,0,0,1,0,0,0,78511,0,26124),
(124519,'Ha! You walk willingly to your death, mortal!','',0,0,0,0,0,0,0,0,0,0,78444,0,26124),
(124520,'I will take great pleasure in grinding your soul to nothing!','',0,0,0,0,0,0,0,0,0,0,78445,0,26124),
(124521,'Shaza-kiel!','',0,0,0,0,0,0,0,0,0,0,78446,0,26124),
(124522,'You are nothing! Insignificant gnat!','',0,0,0,0,0,0,0,0,0,0,78447,0,26124),
(124523,'No! ... I will be... fuel...','',0,0,0,0,0,0,0,0,0,0,78448,0,26124),
(124524,'','The fel crystals anchor the Legion\'s power here. We should see what the Withered can do against them.',0,0,0,0,0,0,0,0,0,0,0,78515,26124),
(124525,'Perhaps. The First Arcanist will know how to proceed. Let us get these people to Shal\'Aran.','',0,0,0,0,0,0,0,0,0,0,78593,0,26124),
(124526,'Thank you... I\'ll make my way back to the defenses.','Thank you... I\'ll make my way back to the defenses.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(124527,'','I\'ve seen enough. I believe I can dampen the effect of fel magic on the Withered. Go to the Soul Engine and I will send new subjects your way.',0,0,0,0,0,0,0,0,0,0,0,78516,26124),
(124528,'I owe you my life! I\'ll head back to our defensive line.','I owe you my life! I\'ll head back to our defensive line.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(124530,'','That worked even better than expected! I shall continue to refine my work for the next step.',0,0,0,0,0,0,0,0,0,0,0,78517,26124),
(124531,'It... it was only a flesh wound! I\'m still good to... OUCH! Nevermind, I\'ll head back to the defenses.','It... it was only a flesh wound! I\'m still good to... ow! Nevermind, I\'ll head back to the defenses.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(124532,'Ahh, much better. Thank you!','Ahh, much better. Thank you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124533,'Praise you, hero!','Praise you, hero!',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(124534,'I\'ll forever be grateful for this!','I\'ll forever be grateful for this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124535,'','He is to be made an example for all to see.',0,0,0,0,0,0,0,0,0,0,0,78617,26124),
(124536,'','How much time do we have?',0,0,0,0,0,0,0,0,0,0,0,78618,26124),
(124537,'','I do not know. I only hope we are not too late.',0,0,0,0,0,0,0,0,0,0,0,78619,26124),
(124538,'Lay still, my friend. We will get you out.','',0,0,0,0,0,0,0,0,0,0,78610,0,26124),
(124539,'','He will be fine. The fruit will bring him back.',0,0,0,0,0,0,0,0,0,0,0,78582,26124),
(124540,'Relief... at last...','',0,0,0,0,0,0,0,0,0,0,78596,0,26124),
(124541,'Aran\'ethil... The nightmare is over!','',0,0,0,0,0,0,0,0,0,0,78597,0,26124),
(124542,'Welcome back, old friend.','',0,0,0,0,0,0,0,0,0,0,78598,0,26124),
(124543,'They wanted to make an example. We have stolen their message and made it ours.','',0,0,0,0,0,0,0,0,0,0,78568,0,26124),
(124544,'All will see... hope... in the Dusk Lily.','',0,0,0,0,0,0,0,0,0,0,78569,0,26124),
(124545,'<Cough.> I need... to rest now. Thank you. Thank you for everything.','',0,0,0,0,0,0,0,0,0,0,78566,0,26124),
(124546,'We will see him back to safety. Go inform Thalyssra of our success.','',0,0,0,0,0,0,0,0,0,0,78567,0,26124),
(124548,'Put those wards up!','',0,0,0,0,0,0,0,0,0,46599,78484,0,26124),
(124549,'Impossible! What have you done?','',0,0,0,0,0,0,0,0,0,0,78509,0,26124),
(124550,'','More souls to fuel the portal!',0,0,0,0,0,0,0,0,0,0,0,78483,26124),
(124551,'','Behold the infinite Legion!',0,0,0,0,0,0,0,0,0,0,0,78510,26124),
(124552,'','No! The portal...',0,0,0,0,0,0,0,0,0,0,0,78486,26124),
(124555,'|TInterface\\Icons\\ABILITY_PRIEST_FLASHOFLIGHT.BLP:20|t Hyrja targets |cFFFF0000$n|r with |cFFFF0404|Hspell:228162|h[Shield of Light]|h|r!','|TInterface\\Icons\\ABILITY_PRIEST_FLASHOFLIGHT.BLP:20|t Hyrja targets |cFFFF0000$n|r with |cFFFF0404|Hspell:228162|h[Shield of Light]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124556,'','Never in ten thousand years did I believe the Legion would be at the very doorstep to the grove. \n\nNo matter what, I will never allow them to enter it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124557,'','An ettin is rampaging through the catacombs! Stop it before it causes further damage!',0,0,0,0,0,0,0,0,0,0,0,78161,26124),
(124558,'','I shudder at the thought of an ettin empowered by the Nightwell. Thank you for saving us.',0,0,0,0,0,0,0,0,0,0,0,78162,26124),
(124559,'','The souls of my ancestors are trapped by the Nightwell\'s power. We must free them from their torment.',0,0,0,0,0,0,0,0,0,0,0,78163,26124),
(124560,'','May they rest in peace. The Nightwell once sustained us, but it has become a source of pain... in many ways.',0,0,0,0,0,0,0,0,0,0,0,78164,26124),
(124561,'','The fal\'dorei have breached the palace! Stop them before the guards take notice!',0,0,0,0,0,0,0,0,0,0,0,78165,26124),
(124562,'','I don\'t believe our cover has been compromised. Quickly, find Aluriel and breach the gates!',0,0,0,0,0,0,0,0,0,0,0,78166,26124),
(124563,'','Elisande\'s personal construct is nearby. It would be a shame if something bad happened to it...',0,0,0,0,0,0,0,0,0,0,0,78167,26124),
(124564,'','Let this be a lesson to those who flaunt their power.',0,0,0,0,0,0,0,0,0,0,0,78168,26124),
(124565,'','Find the palace\'s supply route and cut it off. Flightmaster Volnath should be near the captain\'s quarters.',0,0,0,0,0,0,0,0,0,0,0,78169,26124),
(124566,'','Without a steady stream of supplies, the palace will soon fall! Well done.',0,0,0,0,0,0,0,0,0,0,0,78170,26124),
(124567,'','If we can control the Nightspire, the palace will fall. Stop the ritual!',0,0,0,0,0,0,0,0,0,0,0,78171,26124),
(124568,'','We are one step closer to ending this madness. Elisande\'s final hour has come!',0,0,0,0,0,0,0,0,0,0,0,78172,26124),
(124569,'','Elisande\'s sycophants and concubines loiter about her private chambers atop the Nightspire. We cannot allow them to warn the Legion of our assault!',0,0,0,0,0,0,0,0,0,0,0,78173,26124),
(124570,'','Those traitors deserved their fate. History will remember their atrocities.',0,0,0,0,0,0,0,0,0,0,0,78174,26124),
(124571,'','Tel\'arn\'s experiments have gone too far! A beast is rampaging across the terrace!',0,0,0,0,0,0,0,0,0,0,0,78175,26124),
(124572,'','Tel\'arn\'s madness knows no bounds. If not for you, the beast might have destroyed the entire terrace.',0,0,0,0,0,0,0,0,0,0,0,78176,26124),
(124573,'I have an idea! A mass teleport... but I need help casting it.','',0,0,0,0,0,0,1,0,0,0,78158,0,26124),
(124574,'Won\'t their wards block your telemancy?','',0,0,0,0,0,0,6,0,0,0,78159,0,26124),
(124575,'Not to worry. They\'ve ignored my advice to upgrade those wards for centuries now...','',0,0,0,0,0,0,1,0,0,0,78160,0,26124),
(124576,'What is it you seek: wisdom, or power? Both perhaps?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124577,'You tread on hallowed ground, outsider. I trust you would not do so without purpose.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124578,'You come to our crucible, where our most honored mages have been tested for millennia. Why are you here?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124579,'I seek the guidance of the Moon Guard.','I seek the guidance of the Moon Guard.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124580,'Very well. Center your mind. You will be tested in the tradition of our order.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124581,'','We have what we need to secure the Sanctum. Now everything rests on Valtrois. When she is ready, you will be the first to know.',0,0,0,0,0,0,1,0,0,0,0,78514,26124),
(124582,'Cannons at the ready... FIRE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124583,'All cannons, fire at the target!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124584,'Target acquired! Fire away!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124585,'Send the demons to hell! FIRE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124586,'For the Dark Lady!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124587,'Fire at will!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124588,'Our friend lies just in here.','',0,0,0,0,0,0,0,0,6,0,78206,0,26124),
(124589,'It breaks my heart to see him like this.','',0,0,0,0,0,0,0,0,6,0,78207,0,26124),
(124590,'','What brings you to Shal\'Aran in this dark hour?',0,0,0,0,0,0,6,0,0,0,0,78540,26124),
(124591,'','Hello.',0,0,0,0,0,0,0,0,0,0,0,78495,26124),
(124592,'','Greetings.',0,0,0,0,0,0,0,0,0,0,0,78497,26124),
(124593,'','You have my attention.',0,0,0,0,0,0,0,0,0,0,0,78499,26124),
(124594,'','Hm?',0,0,0,0,0,0,0,0,0,0,0,78501,26124),
(124595,'','Good day.',0,0,0,0,0,0,0,0,0,0,0,78487,26124),
(124596,'','Understood.',0,0,0,0,0,0,0,0,0,0,0,78489,26124),
(124597,'','Goodbye.',0,0,0,0,0,0,0,0,0,0,0,78491,26124),
(124598,'','Farewell.',0,0,0,0,0,0,0,0,0,0,0,78493,26124),
(124599,'','I am not certain why you still require my attention.',0,0,0,0,0,0,0,0,0,0,0,78503,26124),
(124600,'','I have nothing to offer you.',0,0,0,0,0,0,0,0,0,0,0,78505,26124),
(124601,'','Withering was less tiresome than this.',0,0,0,0,0,0,0,0,0,0,0,78507,26124),
(124602,'','Greetings.',0,0,0,0,0,0,0,0,0,0,0,78496,26124),
(124603,'','Hello.',0,0,0,0,0,0,0,0,0,0,0,78498,26124),
(124604,'','Tenu\'balah.',0,0,0,0,0,0,0,0,0,0,0,78500,26124),
(124605,'','Yes?',0,0,0,0,0,0,0,0,0,0,0,78502,26124),
(124606,'','I serve Suramar. All of Suramar.',0,0,0,0,0,0,0,0,0,0,0,78488,26124),
(124607,'','Elisande cannot get away with this.',0,0,0,0,0,0,0,0,0,0,0,78490,26124),
(124608,'','My loyalties have never changed.',0,0,0,0,0,0,0,0,0,0,0,78492,26124),
(124609,'','We stand against the Legion.',0,0,0,0,0,0,0,0,0,0,0,78494,26124),
(124610,'','I have endured worse.',0,0,0,0,0,0,0,0,0,0,0,78504,26124),
(124611,'','I am above this. My training gives me unyielding resolve.',0,0,0,0,0,0,0,0,0,0,0,78506,26124),
(124612,'','Perhaps I could make an exception.',0,0,0,0,0,0,0,0,0,0,0,78508,26124),
(124613,'Thalyssra, you may lead the charge.','',0,0,0,0,0,0,0,0,0,0,78225,0,26124),
(124614,'','Shal\'dorei, the time has come to take back our city! Forward! Anath\'ashar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124615,'','Sin\'dorei, secure the Promenade and hold position! The Light will deliver justice to our enemies this day!',0,0,0,0,0,0,0,0,0,0,0,78227,26124),
(124616,'','Kaldorei, prepare to charge the concourse! Elune calls you to rid this city of evil!',0,0,0,0,0,0,0,0,0,0,0,78228,26124),
(124617,'Do what you can, $n, but be careful.','Do what you can, $n, but be careful.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(124618,'Not like this...','Not like this...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(124619,'The others! Help the others!','The others! Help the others!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(124620,'Such actions will not go unpunished.','Such actions will not go unpunished.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(124621,'Where did they come from?','Where did they come from?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(124622,'The Legion has spread its corruption to the Heart of Val\'sharah! Our defenders need your aid if we are to have any hope of defeating the demons.','',0,0,0,0,0,0,0,0,0,0,81079,0,26124),
(124626,'My defenses... were perfect...','',0,0,0,0,0,0,0,0,0,0,78485,0,26124),
(124628,'This land has endured much suffering at the hands of the Burning Legion. Your actions have restored a measure of peace.','',0,0,0,0,0,0,0,0,0,0,81078,0,26124),
(124629,'An illusion! What are you hiding?','An illusion! What are you hiding?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124630,'Something\'s not quite right...','Something\'s not quite right...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124631,'Who goes there?!','Who goes there?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124632,'Stay in your homes!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124633,'Stay inside if you want to live!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124634,'You flee at the cost of your life!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124635,'Scurry, little mice!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124636,'Here we are again, $n. Ever notice how all this ley energy seems to just fly all over the place?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124637,'I\'ll cast a spell on you to empower you to dash through the air. Use it to the reach the goal off in the distance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124638,'Be sure to pass through the energy orbs to recharge the dash ability I\'ve given you.  Oh and uh...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124639,'Avoid the volatile energy out there and... try not to fall, eh?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124640,'Good luck!','',0,0,0,0,0,0,70,0,0,0,0,0,26124),
(124641,'Look at me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124642,'','Dis tower has been abandoned for ages, surely dere be countless wonders locked inside. \n\nXylem will be so impressed with dis bounty, he\'ll have to let me in his inner circle. Now, if only I could get dis door open...',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(124643,'Nooooo!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124644,'I need that mantle.','I need that mantle.',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(124645,'Come back to me, Dazzle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124646,'Such a menial task.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124647,'Oh, you challenged the wrong goblin, pal. It\'s fireball time!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(124648,'','Ready ya\'self!',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(124649,'','Enough. Ya be a greater apprentice dan I. Take da mantle...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124650,'','Now, leave me be.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(124651,'You can cut the tension with a knife. We must strike soon...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124652,'The elves are restless. It is all the Kirin Tor can do to keep the peace.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124653,'Gul\'dan must not be allowed to use the Nightwell.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124654,'I am having difficulty spotting the infiltrators, Khadgar. Can you help me detect them?','I am having difficulty spotting the infiltrators, Khadgar. Can you help me detect them?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124655,'','Like this?',0,0,0,0,0,0,0,0,0,0,0,78429,26124),
(124656,'Place your feet a little farther apart. You are just slightly off balance.','',0,0,0,0,0,0,0,0,0,0,78433,0,26124),
(124657,'','I think I have it now.',0,0,0,0,0,0,0,0,0,0,0,78425,26124),
(124660,'','Understood, Silgryn.',0,0,0,0,0,0,0,0,0,0,0,78426,26124),
(124661,'','Am I doing this right?',0,0,0,0,0,0,0,0,0,0,0,78430,26124),
(124662,'','What do you think?',0,0,0,0,0,0,0,0,0,0,0,78431,26124),
(124663,'','How about that?',0,0,0,0,0,0,0,0,0,0,0,78432,26124),
(124664,'Relax your shoulders. You are limiting your mobility.','',0,0,0,0,0,0,0,0,0,0,78434,0,26124),
(124665,'Control your breathing. Exhale forcefully with your thrust.','',0,0,0,0,0,0,0,0,0,0,78435,0,26124),
(124666,'Loosen your grip on your blade. No need to clutch it so tightly.','',0,0,0,0,0,0,0,0,0,0,78436,0,26124),
(124667,'','That feels much better.',0,0,0,0,0,0,0,0,0,0,0,78427,26124),
(124668,'','I see!',0,0,0,0,0,0,0,0,0,0,0,78428,26124),
(124669,'Look out, it\'s a loooong way down.','',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(124670,'It was supposed to be a simple journey. Jus\' bring da satchel to da isles and collect my payment.$b$bNow da boss is gonna kill me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124671,'|TInterface\\Icons\\inv_legionadventure.blp:20|t%s orders a |cFFFF0000|Hspell:229284|h[Bombardment]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(124672,'|TInterface\\Icons\\spell_warlock_demonicportal_green.blp:20|t%s begins to open a |cFFFF0000|Hspell:229610|h[Demonic Portal]|h|r! Pursue him through it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(124678,'','The Nightfallen require your aide. Will you answer the call yet again?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124679,'','You remain a reliable ally. Thank you, champion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124680,'','The enemy does not rest. Neither shall we!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124681,'','Fine work, champion. The Horde marches behind you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124682,'','The war effort in Suramar requires your aide, champion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124683,'','We move closer to victory with every stride.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124684,'I\'ve found all the materials.','I\'ve found all the materials.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124685,'','The Nightwell...',0,0,0,0,0,0,1,0,0,0,0,78639,26124),
(124686,'','I thought I would never see it again!',0,0,0,0,0,0,603,0,0,0,0,78640,26124),
(124687,'It is dying. Without the Eye of Aman\'thul, the Nightwell has become unstable.','',0,0,0,0,0,0,1,0,0,0,78641,0,26124),
(124688,'Your soul will fuel the Legion!','Your soul will fuel the Legion!',0,0,0,0,0,0,0,0,0,46148,0,0,26124),
(124689,'','We could stabilize it! We no longer need the Nightwell to sustain us, but we can still harness its power...',0,0,0,0,0,0,603,0,0,0,0,78642,26124),
(124690,'Thalyssra? It is your call...','',0,0,0,0,0,0,6,0,0,0,78643,0,26124),
(124691,'','Let it die.',0,0,0,0,0,0,1,0,0,0,0,78644,26124),
(124692,'','It is.. you! You delivered the letter!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124693,'','I can make it to the border. Thank you. Tell Absolon I am coming!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124694,'','Absolon! What happened to you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124695,'','Tell me everything that happened. About our daughter...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124696,'Noressa! I thought I would never see you again...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124697,'Yes, you deserve to know. Let me show you our new home...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124698,'','We must put the Nightwell behind us. We must take responsibility for our failings, and repay our debt to the people of Azeroth.',0,0,0,0,0,0,1,0,0,0,0,78645,26124),
(124699,'','Ah, free at last! Thank you, Outlander.',0,0,0,0,0,0,603,0,0,0,0,78646,26124),
(124700,'','I told Aluriel you would come to rescue me and she merely laughed. Well who is laughing now?',0,0,0,0,0,0,1,0,0,0,0,78647,26124),
(124701,'It looks like the goblins already picked these ruins clean. \n\nAt this rate, I\'m never going to find something to impress the archmage!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(124702,'I, um, need your robes...','I, um, need your robes...',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(124703,'You think you can beat me?! Well, how about five of me?!','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(124704,'Stop! No more! You can take the stupid robes!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124705,'I hope Xylem turns you into a cockroach...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124706,'I feel... uneasy. What is going on?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124707,'You were being corrupted by the Legion.','You were being corrupted by the Legion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124708,'The Legion tried to corrupt me?$b$bThe death of the human king led me to turmoil. I chose him as my champion because of his ferocity, but also his ability to conquer his bloodlust to uphold his beliefs and protect his people. I entered the Dream upon his death to reflect.$b$bBut in that time, the Legion must have found me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124709,'We will solve this.','We will solve this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124710,'The Legion must be trying to take advantage of the Nightmare\'s withering. I may have been the first attack, but I doubt I will be the last. We must find and defeat whoever is leading the attacks against our people.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124712,'Hey $r! You looking for something?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124718,'','Hey, Archdruid! Over here!',0,0,0,0,0,0,0,0,0,45952,0,81104,26124),
(124719,'First the stupid trials and now he\'s got me digging through dusty old ruins. This inner circle gig better be worth it.\n\nWhat? Go away, you. I\'m archaeology...ing...','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(124720,'I challenge you for that hat!','I challenge you for that hat!',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(124721,'Okay, geez! Take it!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(124722,'It\'s a silly lookin hat anyway...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(124725,'','A challenge? Very well, but ya be warned. Xylem has taught me mastery over frost.',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(124727,'','M-mother told me t-to hide.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124728,'Your father is waiting for you downstairs- hurry!','Your father is waiting for you downstairs- hurry!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124729,'I heard screaming! I\'m scared!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124730,'Your father will help you get to safety. Go downstairs now!','Your father will help you get to safety. Go downstairs now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124735,'Father!!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(124736,'','I\'m going!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(124737,'T-they gave us no warning. Lunette- my children! Ugh...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124738,'You need to get out of here. It isn\'t safe!','You need to get out of here. It isn\'t safe!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124739,'My son was injured in the chaos... I have not been able to move him. Please, help us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124740,'Eneas, you need to go now.','Eneas, you need to go now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124741,'','Yeah, Xylem\'s gone a little mad, but he\'s still a renowned archmage!  Just think of what I could learn from him!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(124742,'Do you know anything about the barrier puzzle?','Do you know anything about the barrier puzzle?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(124743,'','One of the inner circle apprentices told me \"One must master the traditional schools before delving into the realm of shadow.\"\n\nI think that was supposed to be a hint.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(124744,'','I had a nice outfit like you before, but I got tired of being challenged by the other apprentices. \n\nI\'m sure Xylem will let me in the tower on the merit of my spellcasting!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(124745,'','I saw one of the apprentices enter once, though all I was able to see was that he activated the white gem before the red one.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(124746,'I\'m sure if I study hard enough that Xylem will let me in the tower. \n\nIf I could find a bonnie hat like the one you\'ve got, that couldn\'t hurt either.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(124747,'One of the other apprentices was pretty sure the order was simply right to left. \n\nI think his name was... Heinrich?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(124748,'I be tranin\' all day to make da archmage notice me down here, but so far nothin\'!\n\nI wonda if he\'s even gonna be takin\' any more apprentices...','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(124749,'You wanna be gettin past da barrier? Good luck, mon.\n\nJust make sure ya don\'t touch any of da crystals twice, ya hear? Bad things happen to dose dat do.','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(124750,'Why are you botherin me? \n\nJust because you\'ve got some fancy robes you think you can boss us around?','',603,0,0,0,0,0,0,0,0,0,0,0,26124),
(124751,'Oh, that thing? \n\nWell, I\'ll tell you what I know - the first gem is definitely fire...\n\n<Wix quietly chuckles to himself.>','',6,11,0,0,4,0,0,0,0,0,0,0,26124),
(124752,'','Whatever you do, don\'t try touching those gems unless you know the right order. \n\nI\'ve seen what happens when you touch the wrong one, and it\'s not pretty.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(124753,'','Me? Haven\'t got a clue. Just don\'t listen to anything Wix says. \n\nHe gets some sick satisfaction from watching apprentices fry themselves on that puzzle.',661,1,0,0,3,0,0,0,0,0,0,0,26124),
(124754,'Well met, $n. Wanna know what we do when we\'ve drunk all but one keg \'o ale?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124755,'Why we play a game o\'  course!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124756,'Um, hello.  Can I help you with something?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(124757,'I\'m gonna jumble these all about; but the keg with the ale still inside will flash yellow before all that starts.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124758,'Watch closely as they move around, and select the correct barrel when they stop.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124759,'You\'ll know you\'re ready to select your barrel when they all flash white.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124760,'I think it has something to do with the order Xylem teaches his apprentices. \n\nI only started learning Arcane, though, so I\'m not sure what the rest of the order would be.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(124761,'','Tread carefully, the Legion\'s presence is strong here.$b$bHave the nightborne forgotten all we lost in the War of the Ancients? This way lies destruction and death.',0,0,0,0,0,0,0,0,0,924,0,0,26124),
(124762,'Hah! Try again.','',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(124763,'Bah, lucky!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124764,'','The Legion is strong here. Try not to attract any unwarranted attention, $r.',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(124765,'I will protect you both. Let\'s go!','I will protect you both. Let\'s go!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124766,'I am glad someone else is here. Invisibility spells are only getting me so far. Do they have some way of detecting it?','',0,0,0,0,0,0,0,0,0,923,0,0,26124),
(124767,'Just a blood elf and a $r sitting in the corner, discussing tactics. Nothing strange at all about that.','',0,0,0,0,0,0,0,0,0,924,0,0,26124),
(124768,'You think you can hide from Elisande? Die, traitors!','You think you can hide from Elisande? Die, traitors!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124769,'Behind you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124770,'I am right behind you! Go!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(124771,'I cannot leave without my children! They must be hiding...$b$bPlease, find them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124772,'','Disgusting demonic filth will not lay a hand on my girls.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124773,'It looks like you have things handled, Scarleth. You and your girls should leave while you have a chance.','It looks like you have things handled, Scarleth. You and your girls should leave while you have a chance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124774,'','Quit yer lollygagging or I\'ll make ye walk the plank!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(124775,'','Get back to work, ogre! What do we pay ye for?',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(124776,'','Have ye scallywags ever even been to sea?!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(124777,'I cannot leave without the vase! It means everything to my master!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124778,'$ct, could ye come over here before ye leave?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124779,'Did I hear something?','',0,0,0,0,0,0,6,0,0,0,81368,0,26124),
(124780,'Please, I can\'t concentrate when people keep dying at my doorstep!','',0,0,0,0,0,0,603,0,0,0,81369,0,26124),
(124781,'No, no, no! Not that one!','',0,0,0,0,0,0,661,0,0,0,81370,0,26124),
(124782,'That had to hurt.','',0,0,0,0,0,0,1,0,0,0,81371,0,26124),
(124783,'Will you stop that?! You\'re making a mess!','',0,0,0,0,0,0,603,0,0,0,81372,0,26124),
(124784,'Order matters, apprentice! You may want to study your notes a smidge more.','',0,0,0,0,0,0,1,0,0,0,81373,0,26124),
(124785,'Are you trying to... to brute force the barrier? That is NOT how you were taught!','',0,0,0,0,0,0,6,0,0,0,81374,0,26124),
(124786,'Marvelous effort... but also completely, utterly, fantastically incorrect!','',0,0,0,0,0,0,21,0,0,0,81375,0,26124),
(124787,'Do be careful. Wrong answers are bad for your health. And I do mean that quite literally!','',0,0,0,0,0,0,1,0,0,0,81376,0,26124),
(124788,'Hold a moment... you\'re not a real apprentice! Have at thee, imposter!','',0,0,0,0,0,0,25,0,0,0,81709,0,26124),
(124789,'Apprentici... attack!','',0,0,0,0,0,0,22,0,0,0,81678,0,26124),
(124790,'You\'re never going to defeat the Legion with those moves!','You\'re never going to defeat the Legion with those moves!',0,0,0,0,0,0,412,0,0,0,0,0,26124),
(124791,'No no no! Your form is all wrong!','No no no! Your form is all wrong!',0,0,0,0,0,0,412,0,0,0,0,0,26124),
(124792,'You\'re going to have to train harder than that!','You\'re going to have to train harder than that!',0,0,0,0,0,0,412,0,0,0,0,0,26124),
(124793,'Wh... where am I?','Where... where am I?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124794,'I was... almost gone...','I was... almost gone...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124795,'The shadow... it consumed us...','The shadow... it consumed us...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124796,'The shadow is... gone?','The shadow is... gone?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124797,'Xylem... what have you done?','Xylem... what have you done?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124798,'The Focusing Iris will make me the most powerful mage of all time! Just try to stop me!','',0,0,0,0,0,0,0,0,0,0,81679,0,26124),
(124799,'Say, you\'re pretty strong, aren\'t you? On second thought, don\'t try to stop me!','',0,0,0,0,0,0,0,0,0,0,81382,0,26124),
(124800,'You are too late! Take care of my pursuer, Apprentice Sanath!','',0,0,0,0,0,0,0,0,0,0,81680,0,26124),
(124801,'Enough! Stay your weapon...','',0,0,0,0,0,0,0,0,0,0,81383,0,26124),
(124802,'It seems the grimoire took my mind, just as it has eroded Xylem\'s... and now he has escaped with the Iris!','',0,0,0,0,0,0,0,0,0,0,81384,0,26124),
(124803,'You must follow him through his portal. Go! Before it\'s too late!','',0,0,0,0,0,0,0,0,0,0,81385,0,26124),
(124804,'Ugh. If they aren\'t going to put our show back on soon, why do I have to keep this stupid suit on?! It\'s so itchy...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124809,'','His portal is unstable, but an echo of it remains.',0,0,0,0,0,0,0,0,0,0,0,81386,26124),
(124810,'','It will take time, but we may be able to use it to reach him.',0,0,0,0,0,0,0,0,0,0,0,81387,26124),
(124811,'','I have one final request, $c. Though it\'s likely Xylem will not hold back, please spare him his life.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(124812,'','I believe the good man that was Archmage Xylem still exists underneath the madness.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(124813,'','%s motions for you to follow.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124814,'No doubt our forces will be disoriented. I will inform them what happened and see that they make ready to resume our assault.','',0,0,0,0,0,0,0,0,0,0,78867,0,26124),
(124815,'An excellent plan. Good luck, heroes.','',0,0,0,0,0,0,0,0,0,0,78869,0,26124),
(124816,'','The time lock is broken! They are free!',0,0,0,0,0,0,0,0,0,0,0,78866,26124),
(124817,'','From here, we have access to the palace grounds. We can open the gates from the inside!',0,0,0,0,0,0,0,0,0,0,0,78868,26124),
(124818,'','Tendrils of power are emanating from the aberration. I believe Elisande is using this creature to maintain the time lock spell.',0,0,0,0,0,0,0,0,0,0,0,78870,26124),
(124819,'','In order to free our allies at the gate, this monstrosity must be destroyed!',0,0,0,0,0,0,0,0,0,0,0,78871,26124),
(124820,'He ran as far as he could. I will stay with him until his time comes.$b$bThank you... for everything. There is nothing more either of us can do.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124821,'The Legion drains our dragon allies of their magic. You must rescue them!','',0,0,0,0,0,0,0,0,0,0,80588,0,26124),
(124823,'','The warchief has granted me this post to study the birds of our region, so that we may better use them for carrying messages long distances. With such a central location near the trading hubs of the Horde, I have been able to acquire quite a large menagerie of exotic species. Care to try your luck against them?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124824,'','Justice rains from above!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124825,'','Stay plucky, you will do better next time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124826,'','You won on a wing and a prayer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124827,'','Swoop in!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124828,'','It\'s a feathered frenzy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124829,'','Scratch that one.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124830,'This will hurt, $pc.','This will hurt, $pc.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124831,'','So much has changed for me since you brought that fruit.$b$bI miss my brother dearly but I know why he gave himself to this cause.$b$bThere is something I must ask of you. I need to repay the others for their kindness. I need to avenge my brother\'s death.$b$bPlease take me to the First Arcanist so I can pledge myself to her cause.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124832,'Right this way, Arluelle.','Right this way, Arluelle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124841,'|TInterface\\Icons\\SPELL_FIRE_TWILIGHTFLAMEBREATH.BLP:20|t%s begins to cast |cFFFF0000|Hspell:227573|h[Guardian\'s Breath]|h|r!','|TInterface\\Icons\\SPELL_FIRE_TWILIGHTFLAMEBREATH.BLP:20|t%s begins to cast |cFFFF0000|Hspell:227573|h[Guardian\'s Breath]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124843,'You will enter combat shortly after leaving.\n\nWe recommend you take a moment to review your spell book and setup your action bar first.\n\nAre you ready to leave?','You will enter combat shortly after leaving.\n\nWe recommend you take a moment to review your spell book and setup your action bar first.\n\nAre you ready to leave?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124844,'<Whispers cloud your mind. Your thoughts become erratic.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124845,'What has become of the tower?','What has become of the tower?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124846,'I wish to learn the fate of Karazhan.','I wish to learn the fate of Karazhan.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124847,'<Echoes of the past swirl throughout your mind. Visions appear slowly at first, but soon begin to rapidly flash into and out of existence.$B$BHolding your gaze, you peer into the eyes of the Fragment of Medivh. Worlds beyond appear, then quickly fade into darkness.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124848,'','<The injured matriarch had kept herself hidden until she smelled her lost hatchling. She is too badly injured to care for it, though.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124849,'<Bandage the injured matriarch.>','<Bandage the injured matriarch.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124850,'','You\'re too late! The ritual is almost complete.',0,0,0,0,0,0,1,0,0,0,0,82852,26124),
(124851,'','Soon, Kanrethad will be among us once again!',0,0,0,0,0,0,1,0,0,0,0,82853,26124),
(124852,'My death will not be in vain!','My death will not be in vain!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124853,'This... cannot be!','This... cannot be!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124854,'I have failed you, Kanrethad!','I have failed you, Kanrethad!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124855,'We will not be deterred!','We will not be deterred!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(124856,'Our leader will return!','Our leader will return!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(124857,'Kanrethad, lend me your power!','Kanrethad, lend me your power!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124858,'The true leader of the Black Harvest will rise again!','The true leader of the Black Harvest will rise again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124859,'You will burn!','You will burn!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(124860,'The fel flames will consume you!','The fel flames will consume you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124861,'You are no match for his power!','You are no match for his power!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(124862,'','I never realized how much we needed the Nightwell. To be rid of its call is... freeing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124863,'','Oh, it feels so good to be my old self again.$B$B<Valtrois runs the back of her hand gently across her high cheekbone.>$B$BAs you can see, mana is wonderful for the skin!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124864,'It is not too late to join us...','It is not too late to join us...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(124865,'','I must admit, I am rather curious to explore the world beyond Suramar.$B$BPrimitive cultures have always fascinated me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124866,'','We must keep Kanrethad banished, no matter what the cost.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(124867,'Who is Kanrethad?','Who is Kanrethad?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124868,'Mount Daumyr once more, Deathlord. Lead us into battle.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(124869,'','He once held your position, Netherlord. Kanrethad was the founder of our council.\n\nHe brought us together, despite our differences, and lead us in pursuit of greater power than we had ever known. \n\nIt was never enough for him though. After Illidan\'s demise at the Black Temple, Kanrethad became obsessed with the powers he witnessed there. He wanted to control demonic energies as Illidan did, and was prepared to do so at any cost.\n\nI swore an oath to Kanrethad, that should he be lost to the powers he tried to control, that I would banish him. It is an oath I must keep, for him, and for everyone else.',1,1,0,0,3,0,0,0,0,0,0,0,26124),
(124870,'','Oh, it\'s alright, dearie. I don\'t need anyone to run my lines with me. I\'ve got them pretty well memorized by now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124871,'','Everyone\'s gaga for these oh so \"clever\" retellings. Nobody appreciates the classics anymore!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124872,'Outstanding work, hero! Our alliance ensures the Legion will never conquer Azsuna!','',0,0,0,0,0,0,0,0,0,0,80589,0,26124),
(124873,'','People don\'t even recognize a true ingenue anymore! It\'s all so... tragic.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124874,'','Oh, daaaahling, I am so glad to see you. Did you bring roses?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124875,'','Did you expect me to call you \"my pretties\"? Maybe make some whirlwinds? It\'s called *acting*, my dahling.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124876,'The Legion lacks honor. That shall be their downfall.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124877,'','In their death, we will find atonement.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124878,'Ha! They stand no chance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124879,'We shall ride ahead to scout. Meet you on the battlefield, Deathlord!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124880,'Don\'t tell the other cast members, but I\'m a little glad we\'re on break - I was worrying about getting typecast as a man in a metal suit for my entire career!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124881,'You know, I wasn\'t *really* scared all that time on stage. I\'m just a good actor. Really.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124882,'I\'m actually quite smart, I\'ll have you know.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124883,'','Ugh! He\'s so insufferable! What a jerk.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124884,'Maybe if her acting had been less transparent, we wouldn\'t be out of a job!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124885,'','Well then, I think this one\'s outlived his usefulness, wouldn\'t you say?',0,0,0,0,0,0,1,0,0,0,0,81810,26124),
(124886,'','I\'ll head back to Dreadscar Rift and inform the other council members of our plan.',0,0,0,0,0,0,1,0,0,0,0,81811,26124),
(124887,'The outskirts of the grand, ancient city of Suramar, where the Nightfallen fight for survival and the corruption creeps ever so slightly...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124888,'With you leading us, $ct, the Legion stands no chance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124889,'You have conducted your campaign against the Legion with brutal efficiency, Deathlord. I am pleased.','',0,0,0,0,0,0,0,0,0,0,82577,0,26124),
(124890,'Under your command, the Four Horsemen have wreaked havoc upon the demons. But now another path to power awaits.','',0,0,0,0,0,0,0,0,0,0,82578,0,26124),
(124891,'You seek to retrieve Rimefang\'s harness, but you are too late. It has fallen into the hands of invading vrykul, who now use it to bind frost wyrms to their will.','',0,0,0,0,0,0,0,0,0,0,82579,0,26124),
(124892,'These vrykul must pay for defiling my citadel. Slay them! Raise them in the name of the Lich King!','',0,0,0,0,0,0,0,0,0,0,82580,0,26124),
(124894,'','Arluelle places a dusky purple flower before the little planter.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124895,'Examine Beacon','Examine Beacon',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124896,'<You notice a slot on the face of the device that may fit the punch card Mux mentioned.>$B$B<If only you could find it...>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124897,'<The machine clicks rhythmically in an idle state.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124898,'Insert the punch card.','Insert the punch card.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124899,'All the \"mastery of the arcane\" at their disposal and they still were not prepared for a pyroblast to the face. I almost feel sorry for them. Almost.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124900,'<Commonly used as workhorse assistant in engineering shops, this copter has seen better days.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124901,'<You\'ve seen tomes like this one before in the hands of the Legion. The Council of Six\'s concerns about their agents being involved in this were clearly well-founded.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124902,'','<These must be the remains of Grux\'s late assistant.>$B$B<You notice something just barely sticking out of the ash. It must be the punchcard she was trying to return!>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124903,'Oof! Oh, we\'re fighting dirty huh? Well, interrupt this!','',0,0,0,0,0,0,14,0,0,0,0,0,26124),
(124904,'','They did not see me coming. A single blade striking from the shadows goes unnoticed, and a single crack in their defense opens.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124905,'Oooh I\'m really angry now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124906,'NO NO NO NO NO NO NO ARRGGGH!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124907,'Carefully remove the punch card.','Carefully remove the punch card.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124908,'Greetings, surface-dweller! It is I, the one and only Mekgineer-Lord Thermaplugg!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124909,'If you\'re hearing this message, you have earned an exclusive invitation to my glorious coronation as king of all mortals on Azeroth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124910,'Assuming you survive the mass irradiation of the Broken Shore and the Legion\'s subsequent glorious march on all you know and hold dear, of course.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124911,'asdf','sdf',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124912,'Oh, yes, I did forget to mention. This terminal will self-destruct in juuuust a moment. Farewell!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124913,'Gravity is fading in 15 seconds!','Gravity is fading in 15 seconds!',0,0,0,0,0,0,0,0,17,0,0,0,26124),
(124914,'','Please do not tarry long here, $ct $n. This awful place saps my will with every breath.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124915,'Let\'s get out of here.','Let\'s get out of here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124916,'<Tell Mux what you learned at Thermaplugg\'s camp.>','<Tell Mux what you learned at Thermaplugg\'s camp.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124917,'That was THE Sicco Thermaplugg I sold that targeting computer to? Oh boy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124918,'<A presence emanating from the cube urges your mind to think back on your experiences in the Broken Isles>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124919,'<Recall the Lightbound Vessel>','<Recall the Lightbound Vessel>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124920,'<Recall the demise of Illidan>','<Recall the demise of Illidan>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124921,'<Recall your mission to Mardum>','<Recall your mission to Mardum>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124922,'<Recall your imprisonment in the Vault of the Wardens>','<Recall your imprisonment in the Vault of the Wardens>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124923,'<Recall the death of King Varian Wyrnn>','<Recall the death of King Varian Wyrnn>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124924,'<Recall the retreat from the Broken Shore>','<Recall the retreat from the Broken Shore>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124925,'<Recall the ascension of Warchief Sylvanas>','<Recall the ascension of Warchief Sylvanas>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124926,'<Recall the story of Gul\'dan>','<Recall the story of Gul\'dan>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124927,'<Recall the story of Illidan\'s Illidari>','<Recall the story of Illidan\'s Illidari>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124928,'<Recall the story of Khadgar\'s temptation>','<Recall the story of Khadgar\'s temptation>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124929,'<Recall your first visit to Suramar>','<Recall your first visit to Suramar>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124930,'<Recall Ysera\'s corruption>','<Recall Ysera\'s corruption>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124931,'<Recall Ysera\'s transcendence>','<Recall Ysera\'s transcendence>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124932,'<Recall the confrontation between Warchief Sylvanas and Genn Greymane>','<Recall the confrontation between Warchief Sylvanas and Genn Greymane>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124933,'Well done, Battlelord $n. You have recovered my stolen warriors!','',1,0,0,0,0,0,0,0,0,0,83111,0,26124),
(124934,'They would have become Valarjar long ago, had Helya not taken them. Now, witness their transformation!','',4,0,0,0,0,0,0,0,0,0,83112,0,26124),
(124935,'As the master commands!','As the master commands!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124936,'For the Legion!','For the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124937,'I obey.','I obey.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124938,'Cannot... resist!','Cannot... resist!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124939,'As the master wills!','As the master wills!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124943,'Battlelord! With the foul witch Helya finally defeated, she can no longer stop me from reclaiming what is mine!','',0,0,0,0,0,0,0,0,0,0,83109,0,26124),
(124947,'We could also use the kvaldir on our front lines. Their lives are forfeit, so we may as well spend them against the Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124950,'Good. Make your preparations and get to the Broken Shore as soon as you can.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124951,'I\'ve left so many fragments of myself throughout this tower...','',0,0,0,0,0,0,1,0,0,0,79331,0,26124),
(124952,'Let us put aside our petty squabbles and go on the offensive against the legion! We must unite all of the major forces on Azeroth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124953,'Battlelord $n, we have much to discuss. Come at once! There is no time to waste.','',0,0,0,0,0,0,0,0,0,0,83107,0,26124),
(124954,'Medivh?','',0,0,0,0,0,0,6,0,0,0,79228,0,26124),
(124955,'I will open the way. While you battle that fiend, I will sever the tower\'s connection to Legion worlds. I suggest we be quick about it!','',0,0,0,0,0,0,1,0,0,0,79330,0,26124),
(124956,'','Yea, what ya want?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124962,'Time to move on.','Time to move on.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(124963,'Free... at last.','Free... at last.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(124964,'Visitors are forbidden!','Visitors are forbidden!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(124965,'You will find no reward here, only death!','You will find no reward here, only death!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(124966,'Best of luck to ya, buddy. The deserts of Tanaris are an unforgiving mistress!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124973,'A thin wire attached to the card pulls taught!','A thin wire attached to the card pulls taught!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(124974,'-- CUTSCENE -- Camera pans across the broken shore, revealing countless demons. The Tomb of Sargeras looms in the background. Khadgar VO playing... \"The fate of our world will be decided this day.\"','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(124975,'Oh, it is bad. The betrayers were from the Horde...','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(124976,'The truce will shatter if this news gets out. Who else knows?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(124977,'Archmage $n and I will find a way to repair Dalaran\'s weapons. We must!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(124978,'Ahhh, yes! The power within Azeroth is MINE TO CONTROL!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124979,'System Status: Booting.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124980,'Activating Terminal Protection Module 3B.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124981,'I sell to lots of people, Kels. Why would I know anything about some louse in Gnomeregan?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(124982,'','You WHAT?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124983,'Hold the line! The Battlelord has arrived!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124984,'Hold the line! The Highlord has arrived!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124985,'Hold the line! The Huntmaster has arrived!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124986,'Hold the line! The Shadowblade has arrived!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124987,'Hold the line! The High Priest has arrived!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124988,'Hold the line! The Deathlord has arrived!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124989,'Hold the line! The Farseer has arrived!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124990,'Hold the line! The Archmage has arrived!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124991,'Hold the line! The Netherlord has arrived!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124992,'Hold the line! The Grandmaster has arrived!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124993,'Hold the line! The Archdruid has arrived!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124994,'Hold the line! The Slayer has arrived!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124995,'Terminal Status: Unprotected. Shutting down.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(124996,'Careful, hero! A doomlord draws near!','',0,0,0,0,0,0,0,0,0,0,80593,0,26124),
(124997,'I will summon a portal. See you on the other side, Archmage $n!','',1,0,0,0,0,0,0,0,0,0,82770,0,26124),
(124998,'Just you and my trusted lieutenants. But I cannot keep it quiet for long.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(124999,'I knew I could count on you. If the Horde is expelled from the Kirin Tor again and our forces are divided, the Legion will consume our world.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125000,'','We need to get you into Gnomeregan right away!',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(125001,'','Calibrating hyper-tension fluctuators... adjusting micro-accelerator...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125002,'','I\'m going to send you deep into the city. There\'s only enough juice left in the attenuator to get us through once, so we need to make it count!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125003,'Xylem activates the Focusing Iris!','Xylem activates the Focusing Iris!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125004,'','Success!',0,0,0,0,0,0,71,0,0,0,0,0,26124),
(125005,'','If the teleporter runs out of juice, we\'ll need a |Hitem:143653:0:0:0:0:0:0:0:90:0|h[Brimming Keystone]|h to jump start it. Step on as soon as you\'re ready!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125006,'Foolish mortal! You dare release our captives? Then you shall take their place!','',0,0,0,0,0,0,0,0,0,46313,0,0,26124),
(125007,'Push them back! They shall not win today!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125008,'Foolish mortals! This feeble assault will fail just like the last... and this time there will be no escape!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125009,'None can stop the Nethersworn\'s return!','None can stop the Nethersworn\'s return!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125010,'The shadow... consumes all...','The shadow... consumes all...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125011,'Archmage $n, we have a visitor. Please meet me in my private quarters.','',0,0,0,0,0,0,0,0,0,0,82507,0,26124),
(125012,'','|TInterface\\Icons\\inv_misc_monsterhorn_03.blp:20|t A %s emerges far from Helya!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125013,'Lead the way to the Underbelly, $n. Let us hope we are not too late.','',0,0,0,0,0,0,1,0,0,0,82263,0,26124),
(125014,'Come, we must stop the pitlord before it discovers Shal\'Aran.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125015,'I don\'t know anything! Leave me be!','I don\'t know anything! Leave me be!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(125016,'You will never learn our secrets!','You will never learn our secrets!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125017,'One of them gave me this parchment. Take it, I want nothing to do with their cult!','One of them gave me this parchment. Take it, I want nothing to do with their cult!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125018,'That\'s all I know, I swear!','That\'s all I know, I swear!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125019,'I\'m impressed! Touching that soul shard would\'ve killed most mortals.','I\'m impressed! Touching that soul shard would\'ve killed most mortals.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125020,'This... changes... nothing...','This... changes... nothing...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125021,'|cFFFF0000+$1i gold|r','|cFFFF0000+$1i gold|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125022,'|cFF0000FF+$1i gold|r','|cFF0000FF+$1i gold|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125023,'We will not let Gnomeregan fall again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125024,'You can count on me.','You can count on me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125025,'This will begin a timed event. Are you sure?','This will begin a timed event. Are you sure?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125026,'Very well. Center your mind. You will be tested in the tradition of our order.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125027,'Deathlord $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125028,'Slayer $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125029,'Archdruid $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125030,'Huntmaster $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125031,'Archmage $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125032,'Grandmaster $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125033,'Highlord $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125034,'High Priest $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125035,'Shadowblade $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125036,'Farseer $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125037,'Netherlord $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125038,'Battlelord $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125039,'Deathlord $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125040,'Slayer $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125041,'Archdruid $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125042,'Huntmaster $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125043,'Archmage $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125044,'Grandmaster $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125045,'Highlord $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125046,'High Priest $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125047,'Shadowblade $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125048,'Farseer $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125049,'Netherlord $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125050,'Battlelord $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125051,'','Sir, we have reason to believe that Thermaplugg is behind all this. And he has some sort of missile in his arsenal!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(125052,'Brilliant deduction, brilliant, but I\'m afraid you\'re too late. We\'re nearly ready to irradiate all your precious little defenders on the Broken Shore!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125053,'This is where Danuser\'s epic, rallying speech will go. Now listen to Bolvar then go to Mograine upstairs!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125054,'Send me to Broken Shore!','Send me to Broken Shore!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125055,'We can\'t afford to wait for the rest of our forces to arrive. There simply isn\'t time.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125056,'$p, you need to sneak past whatever Sicco has lurking down there, shutdown the missile, and take him out once and for all.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125057,'We\'re all counting on you! Will you do it?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(125058,'Fire given form, fury brought to heel. Arise Qui\'mar, the Firesoul!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125059,'I\'m not telling you anything!','I\'m not telling you anything!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(125060,'Leave me alone!','Leave me alone!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(125061,'Why should I help you? It\'s not worth the risk!','Why should I help you? It\'s not worth the risk!',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(125062,'The shadows consume you!','The shadows consume you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125063,'All will fall before the Nethersworn!','All will fall before the Nethersworn!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125064,'Your world is doomed!','Your world is doomed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125065,'Nethersworn... avenge me...','Nethersworn... avenge me...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125066,'All will... fall...','All will... fall...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125067,'You cannot win...','You cannot win...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125068,'The shadow... beckons...','The shadow... beckons...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125069,'Test our visitors with your full might, Qui\'mar!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125070,'Your prying ends here!','Your prying ends here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125072,'Well fought! You show promise beyond your years.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125073,'Our order is fading, but we will lend you what strength we have. Avenge us, and drive the Legion back to the hells from whence they came.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125074,'You will be silenced!','You will be silenced!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125075,'Defeat is but an opportunity for change. Return when your mind is focused and face our test once more.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125076,'You are not welcome here, interloper!','You are not welcome here, interloper!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125077,'Your meddling ends here!','Your meddling ends here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125078,'Demons pour in from portals throughout the Ruined Sanctum. My Nightwatchers will soon be overwhelmed!','',0,0,0,0,0,0,0,0,0,0,80583,0,26124),
(125079,'Place Arcane Bombs within the portals to destroy them. Once the portals are closed, we must clear out this infestation!','',0,0,0,0,0,0,0,0,0,0,80584,0,26124),
(125080,'LOUD NOISES!','',0,0,0,0,0,0,0,0,0,0,80204,0,26124),
(125081,'Turn away... while you can...','Turn away... while you can...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125082,'You cannot stop the shadow...','You cannot stop the shadow...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125083,'My brothers will end you...','My brothers will end you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125084,'My death... changes nothing...','My death... changes nothing...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125085,'For Nar\'thalas!','For Nar\'thalas!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125086,'We will never fall to the Legion!','We will never fall to the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125087,'Down with you, filth!','Down with you, filth!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125088,'I\'ve been waiting over ten thousand years for this!','I\'ve been waiting over ten thousand years for this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125089,'Vis\'ileth, the Manasoul, keeper of power, manifestation of will, arise!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125090,'Our guests would test their strength in our crucible. Oblige them, Vis\'ileth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125091,'I summon you, Al\'anath the Frostsoul, fury of the storm, shard of the glacier!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125092,'','Archmagi, use your power to convince these two to join together!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(125093,'Unleash your fury, Al\'anath, so our visitors might grow stronger!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125094,'','The Duskwatch is formidable. We will need every capable fighter if we are to complete our objective.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125095,'','These blood elves have some formidable magic. Let us hope it is enough to counter the might of the Nightwell.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125096,'1...','',71,0,0,0,0,0,0,0,0,0,0,0,26124),
(125097,'2...','',71,0,0,0,0,0,0,0,0,0,0,0,26124),
(125098,'1, 2, 3, JUMP!','',71,0,0,0,0,0,0,0,0,0,0,0,26124),
(125099,'','I saw the Sentinels doing target practice over in their camp. They sure can shoot...$b$bWe never really embraced the bow. After all, who needs such primitive instruments when you can craft the fabric of the world to fire missiles for you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125100,'','Such fools... Did you really think you could get away so easy?',0,0,0,0,0,0,11,0,0,0,0,82854,26124),
(125101,'','Let me show you Nethersworn\'s mercy!',0,0,0,0,0,0,53,0,0,0,0,82855,26124),
(125102,'','My lord... I have failed you...',0,0,0,0,0,0,0,0,0,0,0,82856,26124),
(125103,'Captain Winklespring, lower the barrier for a moment, please.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125104,'Yes, High Tinker! Lowering the barrier now.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125105,'Good luck.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125106,'What trickery is this?!','',0,0,0,0,0,0,0,0,0,0,82264,0,26124),
(125108,'The Moon Guard are sworn to protect the land. Though our numbers are few, we will do what we can.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125109,'I was speaking with the sin\'dorei magi. They tell me of the vast libraries of their home. I would like to see them someday...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125110,'Perhaps I will write a book about the history of the night elves. Their story is truly fascinating.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125111,'We will pay the nightborne back tenfold for what they did to our sanctum.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125112,'I will scout ahead and see what I can find near this tomb. Find me at the Broken Shore, $n!','',0,0,0,0,0,0,1,0,0,0,82265,0,26124),
(125113,'To arms, Horsemen! Let\'s clear the rest out!','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(125114,'Don\'t forget your disguise!','Don\'t forget your disguise!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125115,'Over here, $n!','',0,0,0,0,0,0,0,0,0,0,82266,0,26124),
(125116,'The wards have abated! Let us cut through these vile cultists!','',0,0,0,0,0,0,0,0,0,0,82267,0,26124),
(125117,'I will serve you with honor, Highlord.','I will serve you with honor, Highlord.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125118,'I pledge myself to the Silver Hand.','I pledge myself to the Silver Hand.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125119,'You will not regret this choice.','You will not regret this choice.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125120,'I am at your service.','I am at your service.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125121,'I respect your judgment, Highlord. In time, I will prove myself worthy.','I respect your judgment, Highlord. In time, I will prove myself worthy.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125122,'Your judgment means nothing! The Burning Legion will destroy the Silver Hand!','Your judgment means nothing! The Burning Legion will destroy the Silver Hand!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125123,'Your judgment means nothing!','Your judgment means nothing!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125124,'I refuse to give up without a fight!','I refuse to give up without a fight!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125125,'The Nightwell. An unimaginable font of arcane power. What would have happened to the sin\'dorei if we had such a source?...$b$bNo matter. We have forged our own destiny. Our glory is our own, and we are no longer slaves to our hungers.$b$bThis siege is a momentous occasion, $n. We stand with long-lost kin, our enemies, against some of the most powerful magi in the world. Our actions will determine the future of all elf-kind.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125126,'Hmph. Your armies are chaotic and unorderly. Fortunately our blood knights and magisters will form the core of this assault, striking true into the heart of the city.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125127,'It seems the vaunted Kirin Tor are here to see that we do not get into any trouble. I personally feel much safer now that they are here. I wonder, will they actually intervene if the kaldorei camp causes any trouble?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125128,'SAVAGE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125129,'It takes years to master spell-fencing. Victoire is much better suited to instruct the rebellion in basic martial maneuvers.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125130,'It is hard to believe we are all descended from the same elves. None of us are truly impervious to the passage of time, it seems.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125131,'The night elves use bows! I do not think a bow has been made in Suramar in centuries. I wonder if they would let me use one for practice...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125132,'','Don\'t stop the music!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125133,'These blood elves are battle-hardened and disciplined. Their strength will be most useful.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125134,'','Meow.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125135,'','Thalyssra, I hope this message finds you well. I have just come from an emergency council regarding the Horde and Alliance forces amassing outside Suramar.',0,0,0,0,0,0,0,0,0,0,0,79370,26124),
(125136,'Suh dude.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125137,'','Elisande has appointed a new First Arcanist: a dreadful woman named Andaris. Together they are working on a massive enchantment to break the siege.',0,0,0,0,0,0,0,0,0,0,0,79371,26124),
(125138,'But if you close your eyes...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125139,'How am I gonna be an optimist about this?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125140,'','An attack on the main gate is ill-advised, but there may be another way. Andaris has dispatched her arcanists to the Sanctum of Order.',0,0,0,0,0,0,0,0,0,0,0,79372,26124),
(125141,'Squad up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125142,'<The cube\'s thrumming imparts a sense of anticipation>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125143,'It\'s lit, fam.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125144,'Activate the cube!','Activate the cube!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125145,'','Meow Meow.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125146,'','Meow Meow Meow.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125147,'Don\'t stop the music!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125148,'Is this a joke?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125149,'','It seems there is some kind of breach that runs beneath the Nightwell and into the palace itself! They are trying to seal it, but I am sure you can find a way to-',0,0,0,0,0,0,0,0,0,0,0,79373,26124),
(125150,'','Someone\'s coming... Who are you?! W-wait! Unhand me! How dare you! Do you know who I am?!',0,0,0,0,0,0,0,0,0,0,0,79374,26124),
(125151,'','Alright, go ahead and activate it... I\'m going to back up to an... observational distance',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125152,'','Follow me upstairs where we can activate this cube away from curious shoppers...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125153,'%s begins to activate!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125154,'|cFFFF0404Hymdall|r! leaps back into battle!','|cFFFF0404Hymdall|r! leaps back into battle!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125155,'|cFFFF0000Hyrja|r leaps back into battle!','|cFFFF0000Hyrja|r leaps back into battle!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125156,'THREE!','',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(125157,'TWO!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125158,'ONE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125159,'Do you know where I can find Levia Laurence?','Do you know where I can find Levia Laurence?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125160,'Yes, yes, yes, Levia. Tall girl?  Light hair? She was in here buying scrolls and ink - said she needed to make runes for a ritual or something.\n\nShe mentioned something about a specific kind of staff she needed, but we don\'t deal in those items here. I sent her off to the Militant Mystic.\n\nMaybe you should check there?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125161,'Stop this madness, brother! You can still be redeemed!','',0,0,0,0,0,0,5,0,0,0,82249,0,26124),
(125162,'You are too late, foolish brother. The Twisting Nether awaits me, and with it, unlimited power! All of Azeroth will kneel upon my return!','',0,0,0,0,0,0,1,0,0,0,82340,0,26124),
(125163,'Please, brother! Don\'t give in to the darkness!','',0,0,0,0,0,0,5,0,0,0,82250,0,26124),
(125164,'Your tiny mind cannot comprehend the forces that will soon be at my command! Perhaps I should give you a taste...','',0,0,0,0,0,0,5,0,0,0,82341,0,26124),
(125165,'Do you know where I can find Levia Laurence?','Do you know where I can find Levia Laurence?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125166,'The order\'s vaults contain a vast store of magical devices. There must be something here Dalaran can use...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125167,'I hope you enjoy my creation, brother. It saddens me that it ends this way...','',0,0,0,0,0,0,0,0,0,0,82342,0,26124),
(125168,'','Levia... yeah, I know her. She stays here every now and then. Last time was a couple days ago.\n\nShadow magic is a dangerous thing - that\'s why the Kirin Tor aren\'t fond of it in the city - but the things she dabbles in are a far cry worse than your average fare. I wish she\'d at least conduct her business outside of the city.\n\nYou\'re welcome to check upstairs and see if she left anything behind.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125169,'','The Maiden would not approve!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125170,'','Oh dear... you ARE tempting!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125171,'','I no longer fraternize with your sort!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125172,'','You want to play? LET\'S PLAY!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125173,'','I tried to be good... really!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125174,'','I... let... the Maiden... down...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125175,'','Being good... doesn\'t pay...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125176,'','I\'m so glad the Maiden showed us the right path!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125177,'','I don\'t know... I sort of miss the old days.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125178,'','I\'ve been studying advanced magic. I might even apply to the Kirin Tor!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125179,'','Purge dark thoughts from your mind. Remember her teachings!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125180,'','Virtue is overrated!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125181,'No! The rift is closing!','',0,0,0,0,0,0,0,0,0,0,82251,0,26124),
(125182,'','Shame... SHAME...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125183,'','No redemption... for me...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125184,'','You asked for it!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125185,'','I bet you like me better this way!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125186,'','Always... the same...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125187,'','Guess I... deserved this.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125188,'','Who am I kidding? THIS is the real me!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125189,'','It\'s been soooo long since I\'ve had fun like this!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125190,'You\'ve grown delusional in your old age, Gelbin.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125191,'My new allies have given me gifts beyond comprehension - you\'ve merely sent your lone savior to their death.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125193,'A little of this... A little of that...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125194,'Have a dose of this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125195,'One part death... Two parts destruction...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125196,'Let\'s mix this up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125198,'','Slayer $n! We just received an urgent transmission from one of Belath\'s scouts on Mardum!',1,0,0,0,0,0,0,0,0,0,0,82827,26124),
(125199,'','Lady S\'theno went down to lend a hand a few hours ago, but this sounds serious. Should we follow after her?',1,0,0,0,0,0,0,0,0,0,0,82828,26124),
(125200,'We are under attack and taking heavy losses. Legion portals are opening up everywhere! We need reinforcements!','',0,0,0,0,0,0,0,0,0,0,82741,0,26124),
(125201,'MEATBALL HUNGRY!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125202,'You there! What are you doing?','You there! What are you doing?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125203,'Hello there! Did you notice that I have finally been granted the rank of mage? Posthumously, of course... but it is a great honor nonetheless.$b$bWith the promotion came a new charge: sprucing up the tower. It could stand to be a bit more inviting in case Archmage Khadgar has further need of it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125204,'I wish to trade.','I wish to trade.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125205,'Hey! You find somethin\' good?! Somethin\' nice?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125206,'You find anythin\'? Any magic? Hey! Tell me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125207,'Ooh! That shiny! You give to me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125208,'A slow and weak blow. Pathetic.','A slow and weak blow. Pathetic.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125209,'','Is that the best you can do? I suppose the Eredar are not known for their swordsmanship, are they?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125217,'','Beware, $c. The archmage may not greet you with his usual jovial demeanor.',0,0,0,0,0,0,1,0,0,0,0,81380,26124),
(125218,'And we have liftooooooff!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125219,'Brace yourselves! The whole place is falling apart!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125220,'','Slayer $n! We received an urgent message from one of our scouts on Mardum!',1,0,0,0,0,0,0,0,0,0,0,82812,26124),
(125221,'','The grimoire\'s hold on him has grown stronger of late. He has become paranoid and obsessive.',0,0,0,0,0,0,1,0,0,0,0,81381,26124),
(125222,'','I have learned so much from Silgryn but there is still much I have yet to master.$b$bI hope it will be enough when the time comes to face Elisande.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125226,'Foolish mortal! You have met your doom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125227,'Did you hear that rumble coming from the tower ruins? A bad omen, to be sure. Tread carefully!','',0,0,0,0,0,0,0,0,0,0,80582,0,26124),
(125228,'','Illidari! We are needed on Mardum. Move out!',1,0,0,0,0,0,0,0,0,0,0,82813,26124),
(125230,'You\'ve done it, Archmage $n. Congratulations are in order, but I would like to do so in front of the others in the order hall.$b$bWhen you\'re ready, I\'ll teleport us back.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125231,'I\'m ready to go back, Kalec.','I\'m ready to go back, Kalec.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125232,'The strange chill of a dark presence winds through the air...','The strange chill of a dark presence winds through the air...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125233,'The air grows slightly warmer.','The air grows slightly warmer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125234,'','No need to jump - our felbats are happy for a chance to stretch their wings!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(125235,'I wish you luck, $p. A word of warning... If you leave this place, you will lose all progress and be forced to begin the task anew.','',0,0,0,0,0,0,1,0,0,0,81311,0,26124),
(125236,'Let me leave you to it. I will monitor your progress from afar.','',0,0,0,0,0,0,1,0,0,0,81312,0,26124),
(125237,'Take me to down to the surface.','Take me to Mardum.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125238,'Vanthir struggles to his feet.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125240,'I owe you my life, $n. And to Thalyssra, I owe my future.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125241,'The Arcan\'dor is the Nightborne\'s future. Tasting the fruit has enabled me to serve my people as I have always wanted... free from Arcwine.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125242,'So many familiar faces from the Waning Crescent! My heart is lighter knowing so many survived.$b$bFor the rest, I weep.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125243,'Elisande tried to make an example of me. Instead, she gave our movement all the support it could ever want.$b$bShe cannot be forgiven for her deeds at the Waning Crescent.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125244,'','<Ly\'leth\'s image peers at you expectantly. Would you like to hear the message it bears?>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125245,'','No movement just yet. I suspect Elisande is quite comfortable with the current climate in the city. It is quiet. Perhaps our people are too afraid to cry out after the atrocity at the Waning Crescent...$b$bI have not been able to locate Vanthir. His name is conspicuously absent from our discussions.$b$bAs an amusing piece of trivia, Elisande is the least punctual person I have ever had the misfortune to serve.$b$bI will report in again as soon as I can. Take care, Thalyssra.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125246,'<Listen to first message.>','<Listen to first message.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125247,'<Listen to second message.>','<Listen to second message.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125248,'<Listen to third message.>','<Listen to third message.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125249,'<Listen to fourth message.>','<Listen to fourth message.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125250,'<Listen to fifth message.>','<Listen to fifth message.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125251,'Outstanding work! Thanks to your help, the Burning Legion will never claim these lands!','',0,0,0,0,0,0,0,0,0,0,80585,0,26124),
(125252,'The Green Dunkball was picked up by $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125253,'The Green Dunkball was picked up by $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125254,'The Orange Dunkball was picked up by $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125255,'The Orange Dunkball was picked up by $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125256,'The Purple Dunkball was picked up by $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125257,'The Purple Dunkball was picked up by $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125258,'Score! The Orange Dunkball was slammed home by $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125259,'<Dismiss the message.>','<Dismiss the message.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125260,'Score! The Orange Dunkball was slammed home by $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125261,'Score! The Purple Dunkball was slammed home by $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125262,'Score! The Purple Dunkball was slammed home by $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125263,'Score! The Green Dunkball was slammed home by $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125264,'Score! The Green Dunkball was slammed home by $n.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125265,'The Orange Dunkball was dropped by $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125266,'The Orange Dunkball was dropped by $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125267,'The Purple Dunkball was dropped by $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125268,'The Purple Dunkball was dropped by $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125269,'The Green Dunkball was dropped by $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125270,'The Green Dunkball was dropped by $n!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125271,'','As you requested, I have inquired about the Felsoul Hold situation. It appears that your efforts have slowed the trafficking significantly. I regret to say that it will likely not stop without further intervention.$b$bThere is some talk of a sweep for deserters after the events of Astravar Harbor. Advise your people to keep an eye out. More defectors may be coming your way.$b$bIn lighter news, there is a new fashion trend sweeping the palace. There is an obsession with placing ornamental orange birds on their heads. Baffling, truly.$b$bAs ever, I continue to seek our mutual friend. As soon as I know more I will reach out to you directly.$b$bStay strong, First Arcanist.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125272,'','I am so glad Vanthir is safe. Give him my best! I hope to see him in person soon.$b$bThings are... growing tense. The Dusk Lily display really rattled the nobility. They are not in agreement of how to handle the situation but violence is most assuredly an option. I worry for those still trapped in the city.$b$bI have caught wind of some movement in the Promenade- they may be reinforcing the area. Something worth keeping an eye on.$b$bI will report in when I have more information.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125273,'','Your new allies have not gone unnoticed.$b$bI do not know where you found such a band but I had to hide my pleasure at their progress infiltrating the Promenade.$b$bThe mood here is increasingly disturbed. The nobles no longer have any illusion that they can avoid a fight. Elisande will not allow them to stand idly by while Suramar is overrun by Outlanders.$b$bI would not assume victory just yet, my friend.$b$bBe cautious, and be strong. I will see you soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125274,'','I do not have long. This report will be regrettably brief.$b$bElisande is furious. She is planning something, but I have no details yet.$b$bMy eyes and ears are open as ever. As soon as I know what she is up to I will contact you.$b$bBe safe.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125275,'%s is revealed!','Jump over the effect to avoid damage from |cFFFF0404|Hspell:211901|h[Fusion Press]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125276,'The Orange Ball has returned to its base!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125278,'The Purple Ball has returned to its base!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125280,'The Green Ball has returned to its base!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125282,'Kite the Fel Reaver over the Landmines to destroy it!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125284,'','Vandel! We have answered your call for aid. What has happened?',1,0,0,0,0,0,0,0,0,0,0,82814,26124),
(125285,'Kor\'vas! Slayer! All was quiet until recently. Suddenly Legion portals appeared and we were fighting for our lives! Most of our scouts are missing.','',1,0,0,0,0,0,0,0,0,0,82740,0,26124),
(125286,'','We will find them. And what of Lady S\'theno?',1,0,0,0,0,0,0,0,0,0,0,82815,26124),
(125288,'I would like to learn the Arcane Momentum technique and be able to Blink in the direction I am moving.','I would like to learn the Arcane Momentum technique and be able to Blink in the direction I am moving.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125289,'I would like to unlearn Arcane Momentum and Blink the direction I am facing.','I would like to unlearn Arcane Momentum and Blink the direction I am facing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125290,'Arcane Momentum is a technique that allows a mage to use their physical momentum to dictate the direction of their Blink spell rather than the basic technique of Blinking in the direction you are facing.','Arcane Momentum is a technique that allows a mage to use their physical momentum to dictate the direction of their Blink spell rather than the basic technique of Blinking in the direction you are facing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125291,'Are you sure you would like to learn this new technique?','Are you sure you would like to learn this new technique?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125292,'Are you sure you would like me to remove the knowledge of Arcane Momentum from your memory?','Are you sure you would like me to remove the knowledge of Arcane Momentum from your memory?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125293,'I want to talk about the Arcane Momentum technique.','I want to talk about the Arcane Momentum technique.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125294,'Thank you, $c.','Thank you, $c.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125295,'Am I finally free?','Am I finally free?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(125296,'I am in your debt.','I am in your debt.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125297,'Your kindness will not be forgotten.','Your kindness will not be forgotten.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125298,'','You called?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125299,'You found me just in time!','You found me just in time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125300,'','Watch out!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125301,'','Oh my!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125302,'','How tragic!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125303,'','Oh no, bad times...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125304,'','Oh no, I can\'t look...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125307,'Yay, magic fruit!','Yay, magic fruit!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125308,'For me?! Thank you!','For me?! Thank you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125309,'Yuck! I want candy!','Yuck! I want candy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125310,'Can you peel it? I don\'t like the skin...','Can you peel it? I don\'t like the skin...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125311,'Will this make me strong like Thalyssra? She\'s so cool!','Will this make me strong like Thalyssra? She\'s so cool!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125312,'Miss Valtrois said if I eat this, she will teach me about ley lines. She promised!','Miss Valtrois said if I eat this, she will teach me about ley lines. She promised!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125313,'What\'s a arcane-door? Is that like a portal?','What\'s a arcane-door? Is that like a portal?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125318,'We will not forget what you and Thalyssra have done for us.','We will not forget what you and Thalyssra have done for us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125319,'Can this truly end the hunger?','Can this truly end the hunger?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125320,'At last. I am ready to be free.','At last. I am ready to be free.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125321,'You saved me once before, in the city. Now this... It is more than I deserve.','You saved me once before, in the city. Now this... It is more than I deserve.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125322,'Erana-dora isil. A thousand thanks upon you.','Erana-dora isil. A thousand thanks upon you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125323,'This fruit actually cured Thalyssra? Amazing.','This fruit actually cured Thalyssra? Amazing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125324,'Now, as before, we do what we must to carry on.','Now, as before, we do what we must to carry on.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125325,'Damn all these vermin! Can you believe they\'re STILL here!? That last group that came through was no help at all. I don\'t suppose you could help me with this situation?','',5,0,0,0,0,0,0,0,1,0,0,0,26124),
(125326,'The damn spiders, the endlessly screeching bats, and those blasted demon beasts have all taken residence in the Servant\'s Quarters. At least the big ones seem to have cleared out.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125327,'','Archmage Alturus and I are able to hold off the reinforcements from reaching the gates, but do what you can to push them back, $n.$B$BIf their forces continue to grow we may not be able to hold our ground.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125328,'You have my thanks!','You have my thanks!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125329,'That was a close one. Thanks!','That was a close one. Thanks!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125330,'I didn\'t think I would make it. Thanks, $n!','I didn\'t think I would make it. Thanks, $n!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125331,'They just keep coming...','They just keep coming...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125332,'What is this? Oh, the horseshoes I ordered finally arrived! Wait... What is this? They are utterly ruined. It\'s as if they were left out in the rain for decades. Tell that \'mage\' to find a new supplier.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125333,'Pit Hound sniffs at the air.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125334,'Pit Hound senses something nearby.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125335,'Pit Hound emits an eerie growl.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125336,'Koren, I have a delivery of horseshoes for you.','Koren, I have a delivery of horseshoes for you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125337,'','Slayer $n! We are being boarded by demon swarms! Your presence is requested aboard the Fel Hammer!',1,0,0,0,0,0,0,0,0,0,0,81488,26124),
(125338,'Thank you for coming so quickly, Slayer $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125339,'Oh, hello, I was just doing a routine walk through and I see that for non-ghosts there seems to be a sizing spell in play. Maybe considering your vertical limitations, we try and just clear out a bit of the wyrm infestation.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125340,'','Burn, baby, burn!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125341,'','Hot!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125342,'','Spooky!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125343,'','Burn...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125344,'','I love portals.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125345,'Let me know when you are ready to investigate the time lock spell.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125346,'Let\'s go.','Let\'s go.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125347,'Few things bring together an army better than a common enemy.$b$bA week ago these elves were at each other\'s throats. Now, thanks to your efforts, we are ready for the final push into the Nighthold.$b$bWhile I would like to be at the front, Tyrande insisted you and I stay back here with the nightfallen and cover the rear. Come my friend, let us see how these elves resolve their conflict.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125348,'I\'m ready for the siege.','I\'m ready for the siege.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125349,'I cannot begin to thank you enough for your part in rescuing me.$b$bWithout such an intervention I would be a mindless husk, forever tormented by the Nightwell. Now... I am free of it.$b$bI have always believed that Thalyssra would lead us to salvation. Now I know for certain that the Nightborne can and will be saved.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125356,'Ahoy up there $n, from the sounds of it, you were successful in defeating Nightbane. I think it is time we laid this dragon to rest for good. Try and round up all the bones and take them back to where they came from.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125357,'That\'s MY treasure!','That\'s MY treasure!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125358,'You hear a door unlock in the distance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125359,'The portal shimmers with images of the spire.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125360,'Teleport to the Nightspire.','Teleport to the Nightspire.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125361,'Teleport to Elisande\'s Secret Quarters.','Teleport to Elisande\'s Secret Quarters.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125362,'Teleport to the Font of Night.','Teleport to the Font of Night.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125363,'Teleport to the Palace Entrance.','Teleport to the Palace Entrance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125369,'Thieves! This ship is mine!','',1,0,0,0,0,0,0,0,0,0,82786,0,26124),
(125375,'','|TInterface\\Icons\\SPELL_SHADOW_SHADETRUESIGHT.BLP:20|t %s begins to cast |cFFFF0000|Hspell:228565\n|h[Corrupted Breath]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125376,'Another test! Keep your wits about you!','',0,0,0,0,0,0,0,0,0,0,79590,0,26124),
(125377,'Champions must show cleverness as well as might!','',0,0,0,0,0,0,0,0,0,0,79591,0,26124),
(125378,'','Slayer $n, we need help from those keen glaives of yours to hold off these fiends!',1,0,0,0,0,0,0,0,0,0,0,81492,26124),
(125379,'We will not stand idly by while the Legion defiles our lands. Defend Farondale!','',0,0,0,0,0,0,0,0,0,0,80586,0,26124),
(125380,'My ancient nemesis has been vanquished! The curse that bound me to the Halls of Valor is broken at last.','',0,0,0,0,0,0,0,0,0,0,79592,0,26124),
(125381,'Revel in the spoils of victory, worthy champions! The day will come when I have need of your courage and skill once more.','',0,0,0,0,0,0,0,0,0,0,79593,0,26124),
(125382,'Hmm... Many ages have passed since my eyes looked upon the halls of Ulduar. Perhaps I should visit my watcher kin... we have much to speak of. Farewell!','',0,0,0,0,0,0,0,0,0,0,79595,0,26124),
(125383,'Roland Abernathy lets out a hacking cough.','',0,0,0,0,0,0,0,0,0,0,82563,0,26124),
(125384,'The cleansing is complete... for now. Remain vigilant, for the Legion is relentless.','',0,0,0,0,0,0,0,0,0,0,80587,0,26124),
(125385,'Say the thing!','Say the thing!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125386,'Hmph. I don\'t know...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125387,'I don\'t do that anymore!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125388,'Aww, c\'mon!','Aww, c\'mon!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125389,'Please?! I\'m a fan!','Please?! I\'m a fan!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125390,'Sigh. Here goes... ahem...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125391,'Run away little girl, run away!','',0,0,0,0,0,0,0,0,1,0,9278,0,26124),
(125392,'... you\'re welcome.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125393,'It is time. Breach the Sanctum and gain access to the Nighthold!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125394,'Slayer $n, help me!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(125395,'','You will pay for imprisoning me, foul creatures!',1,0,0,0,0,0,0,0,0,0,0,82734,26124),
(125396,'I am ready to enter the Sanctum.','I am ready to enter the Sanctum.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(125397,'','Hideous demon!',1,0,0,0,0,0,0,0,0,0,0,82829,26124),
(125398,'He hits...rather hard, too!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125399,'','Finderss keeperss!',0,0,0,0,0,0,0,0,0,0,0,82587,26124),
(125400,'Mrglglg! Mrg grgl grrrrglmrg!','',0,0,0,0,0,0,0,0,0,0,8475,0,26124),
(125401,'Mrg! Mrgrglgrgl gr mrglglrlr!','',0,0,0,0,0,0,0,0,0,0,8475,0,26124),
(125402,'I am ready, Oculeth.','I am ready, Oculeth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125403,'','Coming, Mother!',1,0,0,0,0,0,0,0,0,0,0,82807,26124),
(125404,'','Matron Mother Malevolence glares malevolently at Kor\'vas.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(125405,'','Don\'t think you\'re facing this peak without me, Deathlord. Onward!',0,0,0,0,0,0,0,0,0,0,0,81294,26124),
(125406,'','The Fel Hammer is OUR ship. Time to remind the demons of this fact!',1,0,0,0,0,0,0,0,0,0,0,82810,26124),
(125407,'','More demonss... While I had hoped for a bit of excitement on board, thiss was not what I had in mind.',0,0,0,0,0,0,0,0,0,0,0,82586,26124),
(125408,'','Slayer $n, glad you made it back! They mean business this time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125409,'','Mardum has been lost. Good riddance, if you ask me. Though it would be inconvenient to lose the Fel Hammer as well.',0,0,0,0,0,0,0,0,0,0,0,82585,26124),
(125410,'That was difficult! I am grateful for the help. I fear Jace may be in trouble in the control room!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(125411,'','It had to be this way. We no longer need the Nightwell, nor its power.$b$bWe must forge our own destiny.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125412,'','The Nightwell is no more.$b$bThese nightborne will learn to survive without its corrupting power, or they will perish. Let us hope it is the former.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125413,'','I will always wonder what might have been, had we chosen to save the Nightwell. What are we without its power?$b$bIn the end I trust in Thalyssra\'s judgment. Under her leadership I know the Nightborne will forge a new path.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125414,'This is the right decision.$b$bThe power here is too great, the responsibility too heavy. Even Elisande was destroyed by it. We must let it go.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125415,'The Nightwell...$b$bWith this, the nightborne begin a new chapter in Azeroth\'s history. Now that they are free of the shield and the Nightwell they have room to truly flourish. I look forward to seeing their progress.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125416,'','I am impressed. Letting go of the Nightwell was no easy task.$b$bIts power and allure will fade with time. As it was with us, they will find their own way in this world.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125417,'','We cannot hold out much longer. We must destroy those shipss!',0,0,0,0,0,0,0,0,0,0,0,82588,26124),
(125418,'','Welcome to our service, Daumyr! Hop on, Deathlord. It\'s time to return to Acherus.',0,0,0,0,0,0,0,0,0,0,0,81297,26124),
(125419,'','The weapons are badly damaged. If we activate them now, they could destroy us, too... Perhaps if we divert energy from the main engine core...',0,0,0,0,0,0,0,0,0,0,0,82811,26124),
(125420,'','You have done well, little gnome. Soon none will remain to stand against the might of the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125421,'','You are too late, mortal. Azeroth\'s fate is sealed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125422,'','It is hopeless. We are everywhere. We are Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125423,'','You are more powerful than I thought. No matter.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125424,'','Your world, all worlds, will burn! It is your destiny!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125425,'','How it this possible? You are NOTHING!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125426,'','He... comes...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125427,'I should congratulate you, hero, but I\'m afraid your efforts are in vain. I will build a new missile, and this time YOU won\'t be around to stop me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125428,'Behold the power my allies provide. I, Mekgineer-Lord Thermaplugg, will be your end!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125429,'You\'re going to have to try much harder than that, noble hero. I am the greatest inventor in all of Azeroth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125430,'And to think that you\'re going to die down here, all alone. Just like I was left for dead all those years ago.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125431,'C\'mon, c\'mon, where\'s that blasted explosion button? I KNOW I INSTALLED AN EXPLOSION BUTTON!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125432,'This is fine. Everything is a-ok, peachy-keen!. Just need to murder you, knock out these unsightly dents you\'ve caused, and we can finally obliterate all your precious friends.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125433,'Inconceivable! My calculations were... perfect...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125434,'Trogg no stupid!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125435,'Show self!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125436,'Eh? What that?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125437,'Me see thing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125438,'What there?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125439,'Come out so I kill!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125440,'Reveal yourself in Thermaplugg\'s name!','Reveal yourself in Thermaplugg\'s name!',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(125441,'Someone is close.','Someone is close.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125442,'Did you see that?','Did you see that?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(125443,'We aren\'t alone.','We aren\'t alone.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125444,'Who dares step in Thermaplugg\'s domain?','Who dares step in Thermaplugg\'s domain?',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(125445,'Your head will decorate these halls!','Your head will decorate these halls!',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(125446,'You won\'t make it out of here alive.','You won\'t make it out of here alive.',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(125447,'I heard something over here.','I heard something over here.',0,0,0,0,0,0,397,0,0,0,0,0,26124),
(125448,'Lupine Geartooth looks in your direction!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125449,'Intruder detected in this sector.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125450,'','We have this unwanted intrusion under control. Do be a dear and check on Seer Akalu, won\'t you, Slayer $n?',1,0,0,0,0,0,0,0,0,0,0,81489,26124),
(125451,'Unauthorized entity nearby.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125452,'Enemy detected. Priming combat relays.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125453,'Threat sensors triggered.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125454,'Low levels of obedience nearby. Identifying source.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125455,'Aggressor within proximity vectors.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125456,'Weapons systems primed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125457,'I have them in my sights.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125458,'There you are.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125459,'Preparing to engage.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125460,'Halt in the Mekgineer-Lord\'s name!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125461,'They\'re here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125462,'Tick-tock, tick-tock. We\'re nearly ready to launch!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125463,'Sit back, take a load off! It\'s mathematically impossible for you to do anything but die miserably at this point anyways.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125464,'The Talisman of the Shal\'dorei swells with power, dispelling the palace wards.','The Talisman of the Shal\'dorei swells with power, dispelling the palace wards.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125465,'Warpweaver Tuviss conducts his business in the Simply Enchanting shop.','Warpweaver Tuviss conducts his business in the Simply Enchanting shop.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(125466,'NOOOOOO! MY MISSILE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125467,'Excellent! Sensors indicate Thermaplugg has retreated to the Tinker\'s Court below. You have to take him out once and for all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125468,'Send everything we have. All of it! Protect me you fools!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125469,'Oh no you don\'t! I came prepared!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125470,'You did it! That\'s the last time Sicco Thermaplugg will rear his ugly head in our city.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125471,'We\'ve already regained control of most of the critical systems - including the teleportation network to get you back safely to Dalaran!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125472,'There\'s still a great deal of work to do to clear these rebels out, but thanks to your efforts it should take no time at all!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125473,'Thank you again, and do send the Kirin Tor my regards when you see them!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125474,'Nor\'Danil Wellspring has been taken by the Legion! Eradicate the infestation before all of Azsuna is overrun!','',0,0,0,0,0,0,0,0,0,0,80594,0,26124),
(125475,'','Let\'s see where we ended up, shall we?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(125476,'','Hmm. Out of the frying pan and into the fire. Well, at least we are better positioned to fight the Legion here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125477,'','I have some cleanup to do here. See you soon, $n.',0,0,0,0,0,0,0,0,0,0,0,82817,26124),
(125478,'Our war against the Legion has exacted a heavy price. Many brave heroes lost their lives in this campaign. Those sacrifices must not be in vain.\n\nLet us seize our chance for victory!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125479,'Send me to the battlefield, I am ready to lend my aid.','Send me to the battlefield, I am ready to lend my aid.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125480,'','Perhaps. I can see a number of benefits to our new position.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125481,'The people of Azsuna are in your debt, hero!','',0,0,0,0,0,0,0,0,0,0,80595,0,26124),
(125482,'Make your way there at once and meet with my servant, the mighty Vethir. Together, you will show the Legion how we greet their kind in Stormheim!','',0,0,0,0,0,0,0,0,0,0,81402,0,26124),
(125485,'What are the requirements to enter?','What are the requirements to enter?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125486,'Only those who have trained extensively can enter.\n\nWhen you have trained 15 pets to their maximum level, you will be ready.','Only those who have trained extensively can enter.\n\nWhen you have trained 15 pets to their maximum level, you will be ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125487,'','The Wailing Caverns are overrun with deviate pests. \n\nWe must exterminate them when their numbers grow too great.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125488,'Take me into the Wailing Caverns.','Take me into the Wailing Caverns.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125489,'I would like to leave the Wailing Caverns.','I would like to leave the Wailing Caverns.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125490,'Progress will be reset if you leave this instance. Are you sure you want to leave?','Progress will be reset if you leave this instance. Are you sure you want to leave?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125491,'I didn\'t think it possible! The energies required...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125492,'','Elisande... what have you done?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125493,'','The power of the Nightwell unleashed...$b$bThere must be another way. We will find it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125494,'Trapped in time.$b$bSee, THIS is why I stick with telemancy! Chronomancy is dangerous stuff.$b$b<Oculeth pauses for a moment.>$b$bThey could be stuck. Forever. We must stop Elisande!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125495,'Reveal the Flame Orbs of Felo\'melorn','Reveal the Flame Orbs of Felo\'melorn',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125496,'Hide the Flame Orbs of Felo\'melorn','Hide the Flame Orbs of Felo\'melorn',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125498,'Rezzle glad to help friend. See, Rezzle not bad demon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125499,'...so then I was like, \"Cool story, bro.\" HA!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(125500,'Death from above? I\'ve done that 1,979 times! Do you want to be number 1,800? Didn\'t think so.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(125501,'I quit my last team because they were scrubs. All of them! I\'m making a new team, but I doubt you are good enough to join. Just spread the word, alright?','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(125502,'...Poison? Why even bother with that, just do it from behind!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(125503,'...So then I said, \"You can\'t kill what you can\'t see!\" Then I vanished! HAHA! You should have seen the look on the kid\'s face. He nearly dropped his ice cream cone!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(125504,'Have you ever cheated death? You know I invented that, right?','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(125505,'You want my opinion? Live to win, \'till you die! That\'s what I do.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(125506,'You want to know what tier I am? God tier, bro. God tier.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(125507,'If I come ever come for you, you won\'t see me coming. Unless I let you, and then I\'ll be the last thing you\'ll ever see!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(125508,'Did I mean to kill the hunter I dueled? Nope. I thought he was playing dead, that\'s why I kept stabbing him. I mean, who dies that easily anyway? What a scrub.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(125509,'What\'s the secret? Go practice on boars for like ten years like I did. You\'ll get ripped... plus you get bacon.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(125510,'I didn\'t get kicked off my last team. I ditched them because they were scrubs!','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(125511,'I pretty much live my life in the shadows. Why? It\'s a lifestyle choice. You probably wouldn\'t understand.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(125512,'How do they expect me to be top DPS if I have to move whenever there\'s a little bit of fire on the ground?','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(125513,'It looks like I\'ll have to do that myself!','It looks like I\'ll have to do that myself!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125514,'Come to me... with all your anguish!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125515,'You\'ll see that I possess an explosive personality!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125516,'We\'re going to have a blast!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125517,'Teleport to the Palace Courtyard.','Teleport to the Palace Courtyard.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125518,'Teleport to the Arcing Depths.','Teleport to the Arcing Depths.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125519,'Take me to the Path of Suffering on the Broken Shore.','Take me to the Path of Suffering on the Broken Shore.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125520,'You are too late, $c! With the Focusing Iris under my control, I can siphon the arcane energy from Azeroth\'s ley lines directly into my magnificent self!','',0,0,0,0,0,0,0,0,0,0,81686,0,26124),
(125521,'Drained of magic, your world will be ripe for destruction by my demon masters... and my power will be limitless!','',0,0,0,0,0,0,0,0,0,0,81687,0,26124),
(125522,'Eat magic, imposter!','',0,0,0,0,0,0,0,0,0,0,81688,0,26124),
(125523,'I will have ALL THE MANA!','',0,0,0,0,0,0,0,0,0,0,81689,0,26124),
(125524,'No... this is not right!','',0,0,0,0,0,0,0,0,0,0,81690,0,26124),
(125525,'I must project this power back through the iris!','',0,0,0,0,0,0,0,0,0,0,81691,0,26124),
(125526,'You cannot defy the will of the Legion, Archmage. All will perish!','',0,0,0,0,0,0,0,0,0,0,82722,0,26124),
(125527,'Hold them off! For the sake of Azeroth!','',0,0,0,0,0,0,0,0,0,0,81692,0,26124),
(125528,'Now to see what limitless power can do!','',0,0,0,0,0,0,0,0,0,0,81693,0,26124),
(125529,'That went well. Now, on to the destruction of Azeroth...','',0,0,0,0,0,0,273,0,0,0,81694,0,26124),
(125530,'No... the ley lines are still too weak... Without magic... Azeroth will surely...','',0,0,0,0,0,0,0,0,0,0,81695,0,26124),
(125531,'Thank you... $n. Thank you for sparing my life. I was... not myself...','',0,0,0,0,0,0,0,0,0,0,81696,0,26124),
(125532,'We should return to my tower. I imagine we have much to discuss...','',0,0,0,0,0,0,0,0,0,0,81697,0,26124),
(125533,'I am free!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125534,'The voices... they lied! They weren\'t the ancestors!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125535,'Curse these demons!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125536,'Thank you, tiny stranger.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125537,'By Odyn\'s beard... where am I?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125538,'This... this isn\'t the Halls of Valhallas!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125539,'The ancestors speak to me! They say you must die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125540,'Monsters, monsters everywhere!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125541,'Can\'t... resist...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125542,'Blood! Blood everywhere!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125543,'As the master wills!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125544,'Awww, you\'re all blown up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125545,'They always blow up so fast.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125546,'Hah! Shriek and squirm! Let your anger shout to the heavens before you die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125547,'Your efforts are futile!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125548,'You can\'t escape oblivion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125549,'Many thanks, friend!','Many thanks, friend!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125550,'I want to be the very greatest!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125551,'Mimiron, I miss Hati\'s old look, can you change it back?','Mimiron, I miss Hati\'s old look, can you change it back?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125552,'Gruuuuu.....','Gruuuuu.....',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125553,'You should return to Deliverance Point at once, $n. There have been some... shall we say... new developments.','',0,0,0,0,0,0,0,0,0,0,83272,0,26124),
(125554,'Pathetic mortals! Even your little Val\'kyr cannot save you from destruction...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125555,'But please... do continue your feeble attempts at survival. I enjoy watching you struggle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125556,'Behold your honored champion, Val\'kyr! I am sure this will be a touching reunion...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125557,'','Asgrim! You will pay for this corruption, demon!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125558,'<Malorne looks at you, approval in his eyes.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125559,'Teleport me to the Broken Shore.','Teleport me to the Broken Shore.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125560,'I want to go to the Trial of Valor (Raid).','I want to go to the Trial of Valor (Raid).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125561,'','The bank? How could--',0,0,0,0,0,0,6,0,0,0,0,82821,26124),
(125562,'','Die in Illidan\'s name!',0,0,0,0,0,0,0,0,0,0,0,82822,26124),
(125563,'','Ready your grapple, Deathlord. Let\'s get to that peak.',0,0,0,0,0,0,0,0,0,0,0,81292,26124),
(125564,'','Grandmaster! Stormstout Brewery is being overrun by the Legion! Please help us!',0,0,0,0,0,0,0,0,0,0,0,82074,26124),
(125565,'Oh no! Just as our Storm Brew production has finally gotten underway, too!','',0,0,0,0,0,0,0,0,0,0,82097,0,26124),
(125566,'','Thank you. I will meet you there!',0,0,0,0,0,0,0,0,0,0,0,82075,26124),
(125567,'Take me to Stormstout Brewery.','Take me to Stormstout Brewery.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125568,'','$ct, you seem perturbed. Do you have a problem?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125569,'The fate of Azeroth rests in our hands.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125570,'I am ready to take the Eye of Aman\'thul to Dalaran.','I am ready to take the Eye of Aman\'thul to Dalaran.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125571,'That vile demon is moving his vessel to attack the Gates of Valor! I\'ve sent one of my val\'kyr to aid you, hero. This battle must be won!','',0,0,0,0,0,0,0,0,0,0,83113,0,26124),
(125572,'My breath is the wrath of the storm! Show me where I should strike, little one, and our enemies will fall!','',0,0,0,0,0,0,0,0,0,0,81406,0,26124),
(125574,'Grandmaster $n! Brewmaster Blanche and I were just discussing the situation on the Broken Shore. The time has come to unite the forces of Azeroth and go on the offensive against the Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125575,'','Grandmaster! It is time for a celebration!',4,0,0,0,0,0,0,0,0,0,0,82436,26124),
(125576,'And a lot more barrels to contain it. It\'s volatile stuff, so ordinary wood won\'t be strong enough.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125581,'Thank you, hero. Harmony must be maintained. Our very survival depends on it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125582,'A ghostly figure of the former guardian hovers before you. You feel as if it is listening, waiting to be noticed...','A ghostly figure of the former guardian hovers before you. You feel as if it is listening, waiting to be noticed...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125583,'Medivh? Is that you?','Medivh? Is that you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125584,'A Mischievous Sprite reveals its true form.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125585,'This will do nicely!','This will do nicely!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125586,'','Curse you outlander!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125587,'<<7.1 PTR>> Cheat me past all the 7.0 Nightfallen content! I want to test 7.1!','<<7.1 PTR>> Cheat me past all the 7.0 Nightfallen content! I want to test 7.1!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125588,'Mrrglgl! Grlmrgl grmlgggl!','',0,0,0,0,0,0,0,0,0,0,79769,0,26124),
(125589,'','I do hope the monks savor my Celebration Brew! Farewell for now, Grandmaster.',0,0,0,0,0,0,0,0,0,0,0,82432,26124),
(125590,'Gaghh gurl!','',0,0,0,0,0,0,0,0,0,0,79771,0,26124),
(125591,'Mrrglgl! Grlmgrlmargl!','',0,0,0,0,0,0,0,0,0,0,79772,0,26124),
(125592,'%s falls to the ground!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125593,'How can I help you?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(125594,'I need to access my bank.','I need to access my bank.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125595,'What was stolen in the attack?','What was stolen in the attack?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125596,'','Good day to you.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(125597,'Greetings.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(125598,'Do you have any idea what was taken?','Do you have any idea what was taken?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125599,'Is anything missing from the vault?','Is anything missing from the vault?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125600,'What did it take exactly?','What did it take exactly?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125601,'Fine, Glutonia. What was the Legion after?','Fine, Glutonia. What was the Legion after?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125602,'','Grandmaster $n, thank you for coming so quickly. Help me open this door!',0,0,0,0,0,0,0,0,0,0,0,82062,26124),
(125603,'','Let\'s head in.',0,0,0,0,0,0,0,0,0,0,0,82063,26124),
(125604,'','Our poor brewers! Perhaps using Detox will help them.',0,0,0,0,0,0,0,0,0,0,0,82064,26124),
(125605,'What does it matter? The vaults are home to the our most carefully guarded relics! Any one could spell disaster!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(125606,'','We don\'t even know if we\'re safe yet and you\'re asking about the vault?! Only the Council of Six are even allowed inside!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125607,'We won\'t know for some time, I\'m afraid. The inner sections are still covered in fel flame!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125608,'','I\'ll tell ya what the Legion was after - my bottom line! Legion-grade protection wards ain\'t exactly cheap, sugar!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(125609,'Yo, I saw what that demon made off with. Come over here.','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(125610,'All\'s I know is it looked like some sort of heart. Ring any bells?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(125611,'The brute seemed awfully keen on protecting it. Took off the moment he came outta the vault.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125612,'','%s gains the effect of |cFFFF0404|Hspell:230981|h[Severed Soul]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(125613,'','There could still be demons lurking about. Keep ready.',0,0,0,0,0,0,0,0,0,0,0,82808,26124),
(125614,'Murglll... Gruggl urg grullulll!','',0,0,0,0,0,0,0,0,0,0,79958,0,26124),
(125615,'','The heart of Highlord Kruul... not good.',0,0,0,0,0,0,0,0,0,0,0,82809,26124),
(125616,'Murgulis points towards a sickly looking fish before looking back at you. It seems he wants you to do something about it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125617,'Whew, that was uncomfortable. Thank you!','Whew, that was uncomfortable. Thank you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125618,'Blessings on you, friend!','Blessings on you, friend!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125619,'You have my thanks. I thought we were safe from the Legion here...','You have my thanks. I thought we were safe from the Legion here...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125620,'Thank you! Let\'s show those demons what we\'re made of!','Thank you! Let\'s show those demons what we\'re made of!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125621,'','Hmm, that seems to have made things worse. Try adding a bit of Shadow magic instead.',0,0,0,0,0,0,1,0,0,0,0,81085,26124),
(125622,'','You have ruined your own lands, outsider. You will not ruin mine!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125623,'','Never trust a mage to handle a demon hunter\'s job!',0,0,0,0,0,0,0,0,0,0,0,82818,26124),
(125624,'','You just missed the Prophet, I\'m afraid.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125625,'','He was headed to Krasus\' Landing, muttering something about the tomb.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125626,'','Prophet Velen spends much time tending the wounded. We should start in the first aid building.',0,0,0,0,0,0,1,0,0,0,0,82819,26124),
(125627,'','We should go to the landing before we miss him again. After you!',0,0,0,0,0,0,1,0,0,0,0,82820,26124),
(125628,'What is this disturbance?! I will not tolerate further delays in preparing these creatures!','',0,0,0,0,0,0,0,0,0,0,80558,0,26124),
(125629,'I\'ll have these creatures devour your soul, piece by piece!','',0,0,0,0,0,0,0,0,0,0,80559,0,26124),
(125630,'Gahgll grllg!','',0,0,0,0,0,0,0,0,0,0,79788,0,26124),
(125631,'Murgulis motions towards the demonic structure upon the southern shore.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125632,'I felt your coming, $n. You bring dark omens this day.','',0,0,0,0,0,0,0,0,0,0,83126,0,26124),
(125633,'You\'ve done it! I\'m cured!','',0,0,0,0,0,0,603,0,0,0,82562,0,26124),
(125634,'The Light will not abandon us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125635,'Kruul\'s heart was stolen by the Legion.','Kruul\'s heart was stolen by the Legion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125636,'%s completely drains the focusing iris! You lose! [PH]','%s completely drains the focusing iris! You lose! [PH]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125637,'I came here to peer into the void above the tomb, searching for answers to a question I did not know.','',0,0,0,0,0,0,0,0,0,0,83139,0,26124),
(125638,'I feel a dark force in the distance, just inside the Twisting Nether. Let us see what lies behind the veil.','',0,0,0,0,0,0,0,0,0,0,83140,0,26124),
(125639,'','So many demons!',0,0,0,0,0,0,0,0,0,0,0,82068,26124),
(125640,'Show yourself, demon. You cannot hide from the Light!','',0,0,0,0,0,0,0,0,0,0,83141,0,26124),
(125641,'','I had hoped we\'d be safe here. Until recently, the Legion didn\'t even know we existed.',0,0,0,0,0,0,0,0,0,0,0,82069,26124),
(125642,'','Do you think the demons have any idea what will happen if they drink the Storm Brew?',0,0,0,0,0,0,0,0,0,0,0,82070,26124),
(125643,'Uh oh...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125644,'Murgulis pauses for a moment and stares at you with what could be only guessed as a smile before swiftly running off.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125645,'The Legion defiles the shores of Stormheim! Do not allow a single demon to remain!','',0,0,0,0,0,0,0,0,0,0,80566,0,26124),
(125646,'Well done, hero! You have saved many noble souls from becoming fuel for the Legion\'s foul magic.','',0,0,0,0,0,0,0,0,0,0,80567,0,26124),
(125647,'It seems fate has conspired to bring us together once more, death knight.','',0,0,0,0,0,0,0,0,0,40073,83129,0,26124),
(125648,'It seems fate has conspired to bring us together once more, demon hunter.','',0,0,0,0,0,0,0,0,0,35823,83130,0,26124),
(125649,'It seems fate has conspired to bring us together once more, druid.','',0,0,0,0,0,0,0,0,0,3622,83131,0,26124),
(125650,'It seems fate has conspired to bring us together once more, hunter.','',0,0,0,0,0,0,0,0,0,7152,83132,0,26124),
(125651,'It seems fate has conspired to bring us together once more, mage.','',0,0,0,0,0,0,0,0,0,18166,83133,0,26124),
(125652,'It seems fate has conspired to bring us together once more, monk.','',0,0,0,0,0,0,0,0,0,16276,83134,0,26124),
(125653,'It seems fate has conspired to bring us together once more, Highlord.','',0,0,0,0,0,0,0,0,0,26556,83135,0,26124),
(125654,'It seems fate has conspired to bring us together once more, High Priest.','',0,0,0,0,0,0,0,0,0,18176,83136,0,26124),
(125655,'It seems fate has conspired to bring us together once more, rogue.','',0,0,0,0,0,0,0,0,0,18177,83137,0,26124),
(125656,'It seems fate has conspired to bring us together once more, shaman.','',0,0,0,0,0,0,0,0,0,40074,83138,0,26124),
(125657,'It seems fate has conspired to bring us together once more, warlock.','',0,0,0,0,0,0,0,0,0,18181,83127,0,26124),
(125658,'It seems fate has conspired to bring us together once more, warrior.','',0,0,0,0,0,0,0,0,0,41244,83128,0,26124),
(125659,'Hide? Pah! You have grown delusional in your age, Prophet.','',0,0,0,0,0,0,0,0,0,0,82669,0,26124),
(125660,'Soon your pathetic world will learn firsthand the wrath of Kruul!','',0,0,0,0,0,0,0,0,0,0,82670,0,26124),
(125661,'','There he is!',0,0,0,0,0,0,0,0,0,0,0,82816,26124),
(125662,'','I don\'t see the brewmaster anywhere. Could she have made it out?',0,0,0,0,0,0,0,0,0,0,0,82071,26124),
(125663,'','Over here! We need to get this door open.',0,0,0,0,0,0,0,0,0,0,0,82072,26124),
(125664,'','Last door! Hurry!',0,0,0,0,0,0,0,0,0,0,0,82073,26124),
(125666,'<The command console stands coldly before you. Glowing demonic runes dancing across the surface of the terminal.>\n\nPassword Required:','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125667,'<The command console stands coldly before you. Glowing demonic runes dancing across the surface of the terminal.>\n\nAccess granted.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125668,'One minor detail. If this prophesied leader truly is the God-King\'s heir, Skovald\'s demise may prove to be a point of contention.','',0,0,0,0,0,0,1,0,0,0,83100,0,26124),
(125669,'So just to be safe, I wouldn\'t mention how the would-be God-King met his end.','',0,0,0,0,0,0,0,0,0,0,83101,0,26124),
(125670,'','Skold-Ashil! As a girl, my mother told me stories of this place and its mighty shieldmaidens. It is as grand as she described it!',0,0,0,0,0,0,0,0,0,0,0,82950,26124),
(125671,'','The armor these women wear... reminds me of my mother\'s...',0,0,0,0,0,0,0,0,0,0,0,82951,26124),
(125672,'','The God-King\'s heir!? What is this nonsense?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125673,'','Wait... that face... Come with me, child!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125674,'','Illustrious Eyir, the child of prophecy has arrived!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125675,'','So the blood of Skovald has returned to the Valkyra? Do you know what this means, child?',0,0,0,0,0,0,1,0,0,0,0,81757,26124),
(125676,'','This outsider says I am to unite the Tideskorn...',0,0,0,0,0,0,1,0,0,0,0,82870,26124),
(125677,'','The outsider speaks true. Long ago, I foresaw the Valkyra uniting the Tideskorn against a terrible foe. At its head would stand a descendant of God-King and Shieldmaiden.',0,0,0,0,0,0,1,0,0,0,0,81758,26124),
(125678,'','As a child of Skovald, you hold a claim to his throne. Any who dispute your right to rule must be made to bend the knee.',0,0,0,0,0,0,0,0,0,0,0,81759,26124),
(125679,'','Fail, and the Tideskorn will splinter, leaving nothing to stop the Legion from overtaking Stormheim.',0,0,0,0,0,0,0,0,0,0,0,81760,26124),
(125680,'','I know this is a great burden on you, child, but you may be our only hope.',0,0,0,0,0,0,0,0,0,0,0,81761,26124),
(125681,'','Very well. If I truly am so important to the Tideskorn, then I cannot turn my back on this task.',0,0,0,0,0,0,1,0,0,0,0,82871,26124),
(125682,'','I will be your instrument. Tell me what I must do.',0,0,0,0,0,0,0,0,0,0,0,82872,26124),
(125683,'','I will ride ahead to Haustvald. I would be honored if you would join me there, $n.',0,0,0,0,0,0,0,0,0,0,0,82873,26124),
(125684,'','Runeseer Faljar! I am Sigryn, blood of Skovald. In the name of the Valkyra, I challenge you for the rule of the Tideskorn!',0,0,0,0,0,0,0,0,0,0,0,82874,26124),
(125685,'So, the God-King\'s whelp comes to finish what he started? Skovald\'s time is done, girl, as yours soon shall be!','',0,0,0,0,0,0,1,0,0,0,82567,0,26124),
(125686,'Ancestors, to my side!','',0,0,0,0,0,0,0,0,0,0,82568,0,26124),
(125687,'You have your father\'s fury, shieldmaiden, but I also sense in you his darkness.','',0,0,0,0,0,0,0,0,0,0,82569,0,26124),
(125688,'','Cease your prattling, Runeseer!',0,0,0,0,0,0,0,0,0,0,0,82875,26124),
(125689,'Stay your blade!','',0,0,0,0,0,0,0,0,0,0,82570,0,26124),
(125690,'I am defeated. It seems I underestimated you, shieldmaiden.','',0,0,0,0,0,0,1,0,0,0,82571,0,26124),
(125691,'','I will continue to Hrydshal. See you there, $c.',0,0,0,0,0,0,0,0,0,0,0,82876,26124),
(125692,'','Jarl Velbrand! As the blood of Skovald and at the behest of Eyir, I claim the throne of the Tideskorn!',0,0,0,0,0,0,0,0,0,0,0,82877,26124),
(125693,'','Will you yield?',0,0,0,0,0,0,0,0,0,0,0,82878,26124),
(125694,'I don\'t care if you\'re the daughter of Odyn himself, girl. I\'ll skewer you for your impudence!','',0,0,0,0,0,0,0,0,0,0,82622,0,26124),
(125695,'The Drekirjar never yield!','',0,0,0,0,0,0,0,0,0,0,82623,0,26124),
(125696,'Hold! You have proven your strength! I am defeated.','',0,0,0,0,0,0,0,0,0,0,82624,0,26124),
(125697,'The Drekirjar will back your claim to the throne. But there is another that should cause greater concern.','',0,0,0,0,0,0,0,0,0,0,82625,0,26124),
(125698,'','Do you hear that? We better see what\'s happening outside!',0,0,0,0,0,0,0,0,0,0,0,82065,26124),
(125699,'','We should waste no time. To Vrekt!',0,0,0,0,0,0,0,0,0,0,0,82879,26124),
(125700,'Sister... it\'s been a long time since you left me for dead.','',0,0,0,0,0,0,0,0,0,0,82274,0,26124),
(125701,'','Torvald, it is you! I didn\'t want to leave you, but I wasn\'t strong enough! How did you survive the assassins?',0,0,0,0,0,0,1,0,0,0,0,82880,26124),
(125702,'How?! I embraced the gift that father left us! The one you and mother so vehemently denied!','',0,0,0,0,0,0,1,0,0,0,82275,0,26124),
(125703,'','Oh no, Torvald... you\'ve succumbed to the fel! But how?!',0,0,0,0,0,0,1,0,0,0,0,82881,26124),
(125704,'It seems you don\'t remember our father feeding us the fel. The sickness it caused in you must have clouded your mind.','',0,0,0,0,0,0,1,0,0,0,82276,0,26124),
(125705,'Something in our blood made us resist its influence... but it remains within. All you need to do is give in!','',0,0,0,0,0,0,25,0,0,0,82277,0,26124),
(125706,'','No, I will never be a tool for the Legion!',0,0,0,0,0,0,1,0,0,0,0,82882,26124),
(125707,'Poor sister... if you will not join me, then you are my enemy!','',0,0,0,0,0,0,0,0,0,0,82278,0,26124),
(125708,'Give in, sister! Only through the fel could you hope to defeat me!','',0,0,0,0,0,0,0,0,0,0,82279,0,26124),
(125709,'','No! I will not share your fate!',0,0,0,0,0,0,0,0,0,0,0,82883,26124),
(125710,'No... it\'s not possible...','',0,0,0,0,0,0,0,0,0,0,82280,0,26124),
(125711,'','I am sorry, brother. I cannot allow the Legion to corrupt the vrykul.',0,0,0,0,0,0,1,0,0,0,0,82884,26124),
(125712,'You... you think your masters so superior to mine...','',0,0,0,0,0,0,0,0,0,0,82281,0,26124),
(125713,'Perhaps you should ask them who sent the assassins for us that night...','',0,0,0,0,0,0,0,0,0,0,82282,0,26124),
(125714,'Maybe then... you will see...','',0,0,0,0,0,0,0,0,0,0,82283,0,26124),
(125715,'','No! Brother!',0,0,0,0,0,0,1,0,0,0,0,82885,26124),
(125716,'','He\'s... gone...',0,0,0,0,0,0,0,0,0,0,0,82886,26124),
(125717,'So it is true... the highlord returns.','',0,0,0,0,0,0,0,0,0,0,83142,0,26124),
(125718,'','Great Eyir, as you bid me, I have defeated the rival claimants to the throne of the Tideskorn.',0,0,0,0,0,0,1,0,0,0,0,82887,26124),
(125719,'','However, if I am to serve you as queen, I have something to ask in return.',0,0,0,0,0,0,1,0,0,0,0,82888,26124),
(125720,'','Very well. Ask it, child.',0,0,0,0,0,0,1,0,0,0,0,81762,26124),
(125721,'','Tell me... who ordered the death of my mother?',0,0,0,0,0,0,1,0,0,0,0,82889,26124),
(125722,'','Oh, child... no good can come of such truths. Do you truly wish to know?',0,0,0,0,0,0,1,0,0,0,0,81763,26124),
(125723,'','I do.',0,0,0,0,0,0,0,0,0,0,0,82890,26124),
(125724,'','So be it. It was Odyn himself who ordered the deaths of Skovald\'s family.',0,0,0,0,0,0,1,0,0,0,0,81764,26124),
(125725,'','What?!',0,0,0,0,0,0,0,0,0,0,0,82891,26124),
(125726,'','Odyn feared that the God-King\'s heirs would offer the Tideskorn into the hands of the Legion.',0,0,0,0,0,0,1,0,0,0,0,81765,26124),
(125727,'','He decreed that the lineage of Skovald be ended... in blood.',0,0,0,0,0,0,1,0,0,0,0,81766,26124),
(125728,'','My brother was right! The titan watchers have no more honor than the Legion!',0,0,0,0,0,0,0,0,0,0,0,82892,26124),
(125729,'','Sigryn! No! You must not let the darkness take hold!',0,0,0,0,0,0,1,0,0,0,0,81767,26124),
(125730,'','I will show Odyn what true fear looks like, even if I have to tear down the Halls of Valor around him!',0,0,0,0,0,0,0,0,0,0,0,82893,26124),
(125731,'','Mother! I come to avenge you!',0,0,0,0,0,0,463,0,0,0,0,82894,26124),
(125732,'','Sigryn... what have you done?',0,0,0,0,0,0,1,0,0,0,0,81768,26124),
(125733,'','I can power the portal for a short time. You will need additional power if you need to use it again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125734,'','You cannot hide behind these walls forever, Odyn!',0,0,0,0,0,0,0,0,0,0,0,82895,26124),
(125735,'','What\'s this? The outsider has come to stop me? I owe you much, but I cannot allow you to impede my quest for justice!',0,0,0,0,0,0,1,0,0,0,0,82896,26124),
(125736,'','I will give you a choice. Leave here... or die.',0,0,0,0,0,0,0,0,0,0,0,82897,26124),
(125737,'','Very well. You have chosen death!',0,0,0,0,0,0,0,0,0,0,0,82898,26124),
(125738,'','What... what am I doing? This is not right!',0,0,0,0,0,0,0,0,0,0,0,82899,26124),
(125739,'','You must overcome the corruption, Sigryn! You have the strength!',0,0,0,0,0,0,0,0,0,0,0,81755,26124),
(125740,'','But... mother... I must avenge your death!',0,0,0,0,0,0,0,0,0,0,0,82900,26124),
(125741,'','Vengeance will not bring her back, Sigryn. Your people require a leader. If you fail, the Tideskorn are doomed!',0,0,0,0,0,0,0,0,0,0,0,81756,26124),
(125742,'','No... the fel will not take me... It will not!',0,0,0,0,0,0,0,0,0,0,0,82901,26124),
(125743,'','Forgive me, Eyir...',0,0,0,0,0,0,0,0,0,0,0,82902,26124),
(125744,'','Wondrous Eyir, I come to humbly beg your forgiveness for what I\'ve done.',0,0,0,0,0,0,1,0,0,0,0,82903,26124),
(125745,'','I will accept whatever punishment you deem just.',0,0,0,0,0,0,0,0,0,0,0,82904,26124),
(125746,'','I am pleased to see you returned. My judgement is this: you are to assume the burden of the crown. You must become God-Queen!',0,0,0,0,0,0,1,0,0,0,0,81747,26124),
(125747,'','What?! Surely after the mistakes I\'ve made, I am unfit to rule our people!',0,0,0,0,0,0,1,0,0,0,0,82905,26124),
(125748,'','You possess the strength and will to overcome the fel... something no vrykul before you has ever done!',0,0,0,0,0,0,1,0,0,0,0,81748,26124),
(125749,'','I know now that my visions were true. You are destined to unite the Tideskorn against the Legion.',0,0,0,0,0,0,1,0,0,0,0,81749,26124),
(125750,'','Can you set aside your misgivings and do what is needed for your people?',0,0,0,0,0,0,1,0,0,0,0,81750,26124),
(125751,'','I... I will. If it takes my last breath, I will unite the Tideskorn once more, so that we may drive the Legion from this land!',0,0,0,0,0,0,1,0,0,0,0,82906,26124),
(125752,'','It is done. Rise, Sigryn! I name you God-Queen of the Tideskorn!',0,0,0,0,0,0,1,0,0,0,0,81751,26124),
(125753,'','You will fall beneath my spear!',0,0,0,0,0,0,0,0,0,0,0,82907,26124),
(125754,'','I\'ve never seen so many demons in one place! Our only chance is to drink the Storm Brew.',0,0,0,0,0,0,0,0,0,0,0,82090,26124),
(125755,'','It\'s risky, but a small taste should give us just the boost we need. Bottoms up!',0,0,0,0,0,0,0,0,0,0,0,82091,26124),
(125756,'','The gods smile upon me this day!',0,0,0,0,0,0,0,0,0,0,0,82908,26124),
(125757,'','My wounds... are too great...',0,0,0,0,0,0,0,0,0,0,0,82909,26124),
(125758,'','I will proceed on foot. Fare thee well, outsider.',0,0,0,0,0,0,0,0,0,0,0,82910,26124),
(125759,'','We must take care traveling through Stormheim, outsider. Being the daughter of Skovald has won me many enemies.',0,0,0,0,0,0,0,0,0,0,0,82911,26124),
(125760,'My family needs me. Thank you, hero!','My family needs me. Thank you, hero!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125761,'The Magistrix and her thugs will fall!','The Magistrix and her thugs will fall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125762,'May fate favor you. Kruul\'s minions will surely flock to his aid.','',0,0,0,0,0,0,1,0,0,0,83125,0,26124),
(125763,'Onward, to victory!','Onward, to victory!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125764,'Enter password: \"All worlds shall burn.\"','Enter password: \"All worlds shall burn.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125765,'Enter password: \"password.\"','Enter password: \"password.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125766,'Enter password: \"L0rd Meph1str0th rulez.\"','Enter password: \"L0rd Meph1str0th rulez.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125767,'Option 1: Unplug the power cable to the computer, and plug it back in.','Option 1: Unplug the power cable to the computer, and plug it back in.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125768,'Option 2: Take out your frustration on the computer, repeatedly kicking it as hard as you can.','Option 2: Take out your frustration on the computer, repeatedly kicking it as hard as you can.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125769,'Option 3: Use the power of your artifact weapon on the computer.','Option 3: Use the power of your artifact weapon on the computer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125770,'I am going to parse this out in what we can do and what we can\'t do. \n\nWe CAN go through this portal to a demonic gateway that I made a connection with. \n\nWe CAN\'T know what\'s on the other side because magic does not work that way.\n\nSo, you go first. Good luck, \"hero.\"','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125771,'','Brewmaster! Hang on! We\'re coming!',0,0,0,0,0,0,0,0,0,0,0,82066,26124),
(125772,'','Step on the rune. Hurry!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125773,'','We will end the Burning Legion or die trying.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125774,'Let\'s get started.','Let\'s get started.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125775,'Gotta catch \'em each!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125776,'My life... for Suramar.','My life... for Suramar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125777,'At least I died... free...','At least I died... free...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125778,'The rebellion... will never die...','The rebellion... will never die...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125779,'','Keep your wits about you. I doubt we\'ll be alone for long.',0,0,0,0,0,0,0,0,0,0,0,82802,26124),
(125780,'','The enemy approaches!',0,0,0,0,0,0,0,0,0,0,0,82803,26124),
(125781,'','Grandmaster $n, you have my sincere thanks.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125782,'','Brewmaster, I\'m so sorry about the disruption! I will get everyone back to work right away.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125783,'','Your fighting skills have improved, Almai. I think you have grown beyond the life of a simple brewer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125784,'The demons have made quite the home on Broken Shore. It has gone on long enough.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125785,'Our forces have been able to push them back to their barricades, but more keep appearing as if from nowhere.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125786,'Help our forces, Archdruid. I will try to find their commander.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125787,'Hey! Whoa there!','',0,0,0,0,0,0,5,0,0,0,79834,0,26124),
(125788,'You really shouldn\'t sneak up on people like that.','',0,0,0,0,0,0,274,0,0,0,79835,0,26124),
(125789,'Ruined a perfectly good nap.','',0,0,0,0,0,0,1,0,0,0,79836,0,26124),
(125790,'Me, I\'m not much of a fighter.','',0,0,0,0,0,0,574,0,0,0,79837,0,26124),
(125791,'It\'s tough to savor a juicy slab of boar meat when you\'ve got a bloody lip. Know what I mean?','',0,0,0,0,0,0,6,0,0,0,79838,0,26124),
(125792,'So listen up. While you deal with this little mess I may or may not have caused, I\'m gonna make a dramatic exit.','',0,0,0,0,0,0,25,0,0,0,79839,0,26124),
(125793,'Errr... wait. I should say something cool and memorable before I go.','',0,0,0,0,0,0,1,0,0,0,79840,0,26124),
(125794,'Uh... This is harder than it looks! Have YOU ever tried to come up with a sweet catchphrase right on the spot?','',0,0,0,0,0,0,5,0,0,0,79841,0,26124),
(125795,'You dare stand at the gate to my realm? So be it.','',0,0,0,0,0,0,0,0,0,0,82666,0,26124),
(125796,'Hmph. I got nothing.','',0,0,0,0,0,0,6,0,0,0,79842,0,26124),
(125797,'Oh well. Be seeing you!','',0,0,0,0,0,0,66,0,0,0,79843,0,26124),
(125798,'We\'ve got the flanks, $ct!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125799,'Focus on the camp!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125800,'','Why do you return to Skold-Ashil, outsider?\n\n...and who is this vrykul you bring with you?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(125801,'','Up here, Archdruid! We have found her!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125802,'This vrykul is the heir to the God-King. She seeks an audience with Eyir.','This vrykul is the heir to the God-King. She seeks an audience with Eyir.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(125803,'','This way, Archdruid. She is down on the island!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125805,'','The password you have entered is incorrect. Please hold while security is dispatched to your location.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125806,'','After you are destroyed, if you would like to complete a short survey it will help us better assist you in the future.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125807,'','Try adding a bit of Holy magic. That usually does the trick.',0,0,0,0,0,0,1,0,0,0,0,81084,26124),
(125808,'A Doomherald opens a Nether Rift!','A Doomherald opens a Nether Rift!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125809,'','The deviate spore can be found at the top of this crag. You\'re going to have to battle your way up there, good luck!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125810,'With every moment my power grows. Your end is nigh!','',0,0,0,0,0,0,0,0,0,0,82667,0,26124),
(125811,'','Take wing with us. Fly fast and true!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125813,'We must defeat the commander before our forces are completely overwhelmed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125814,'Finish them, Vazuun. My rebirth is nearly complete.','',0,0,0,0,0,0,0,0,0,0,82668,0,26124),
(125815,'','The portal is complete. I am with you, $p!',0,0,0,0,0,0,0,0,0,0,0,82804,26124),
(125816,'','Kruul will be reborn!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125817,'','Your vaunted forces of nature cannot stand against the fel!',0,0,0,0,0,0,0,0,0,0,0,82733,26124),
(125818,'','Watch out! More incoming!',0,0,0,0,0,0,0,0,0,0,0,82805,26124),
(125819,'','Almost there! Keep it up!',0,0,0,0,0,0,0,0,0,0,0,82806,26124),
(125820,'You die here, Command-Mother!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125821,'','The Tidestone will be ours!',0,0,0,0,0,0,0,0,0,0,0,81498,26124),
(125822,'','Maybe we overdid it... We\'re going to feel awful when it wears off! At least closing the portals should be a walk in the park!',0,0,0,0,0,0,0,0,0,0,0,82078,26124),
(125823,'','Do you see the brewmaster?',0,0,0,0,0,0,0,0,0,0,0,82079,26124),
(125824,'Antonidas infused these discs with the very energies we mages seek to control. However, he and his fellow archmages were unable to diffuse the excess energy, leaving them in their current state.','',0,0,0,0,0,0,1,0,0,0,81308,0,26124),
(125825,'Is this all your world could muster? Pathetic.','',0,0,0,0,0,0,0,0,0,0,82716,0,26124),
(125826,'I will dismiss the wards keeping them in check. I believe that by channeling power through your artifact weapon into the discs, you will provoke a response.','',0,0,0,0,0,0,1,0,0,0,81309,0,26124),
(125827,'Antonidas had intended to complete this project himself. He was patient, wise, and a master of our disciplines. You must now prove his better in order to finish what he started.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125828,'Should the need arise, these apprentices can supply you with essentials. I suggest you take note of their offerings.','',0,0,0,0,0,0,1,0,0,0,81310,0,26124),
(125829,'','I have always wanted to study Mistweaving! Farewell, Brewmaster.',0,0,0,0,0,0,0,0,0,0,0,82080,26124),
(125830,'','Brewmaster? You tried to kill us!',0,0,0,0,0,0,0,0,0,0,0,82076,26124),
(125831,'','I came to warn you as fast as I could. I was too late...',0,0,0,0,0,0,0,0,0,0,0,82437,26124),
(125832,'Blanche! Explain yourself! The entire order is dying!','',0,0,0,0,0,0,0,0,0,0,82098,0,26124),
(125833,'','I... I brought the poisoned brew here. If only I had checked it first...',0,0,0,0,0,0,0,0,0,0,0,82077,26124),
(125834,'For Kruul! For the Burning Legion!','',0,0,0,0,0,0,0,0,0,0,82717,0,26124),
(125835,'','Halt! Who approaches the Vault of Eyir?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125836,'The endless flame comes for you! It cannot be stopped!','',0,0,0,0,0,0,0,0,0,0,82718,0,26124),
(125837,'Your armies will all fall before my lord\'s wrath.','',0,0,0,0,0,0,0,0,0,0,82719,0,26124),
(125838,'You test my patience. Die, cretin!','',0,0,0,0,0,0,0,0,0,0,82720,0,26124),
(125839,'You walk into your own death.','',0,0,0,0,0,0,0,0,0,0,82721,0,26124),
(125840,'','Malevolent Automated Domination Assistance Matrix - M/A/D/A/M - initiated. Greetings, user.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125841,'','Power failure detected... initiating system restore...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125842,'Let\'s get weird!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125843,'','Access granted. Greetings, Lord Mephistroth. How may I serve you today?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125844,'Feel the wrath of my army!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125846,'We have to close the portal!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125847,'Archdruid! Use your magic to close the portal for good!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125848,'Well done. Now we must dare to venture into the Twisting Nether itself.','',0,0,0,0,0,0,0,0,0,0,83143,0,26124),
(125849,'Greetings, prepare to be rhythmically disassembled.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125850,'Check those funky steps!','Check those funky steps!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125851,'You\'re getting served, Beat Box!','You\'re getting served, Beat Box!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125852,'You got skills!','You got skills!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125853,'Funk circuits depleted...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125854,'Groove battery powering down. Trash talk mode engaged.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125855,'Funk drive re-engaged. Beat protocols set to melt face.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125856,'Lame.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125857,'No step.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125858,'Your flow is deficient.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125859,'What we do now, we do together.','',0,0,0,0,0,0,1,0,0,0,83144,0,26124),
(125860,'On your lead, champion.','',0,0,0,0,0,0,1,0,0,0,83145,0,26124),
(125861,'Your levels of funk are insufficient.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125862,'Scanning opponent\'s level of swagger. Zero found.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125864,'You have done well this day. Thank you. We shall head back.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125865,'Thank you for lifting the curse from Black Rook.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125866,'Tell me about your previous settings, S.I.R.I.','Tell me about your previous settings, S.I.R.I.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125867,'What can you tell me about myself? Who is Lord Mephistroth?','What can you tell me about myself? Who is Lord Mephistroth?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125868,'I need to destroy the ship. What do you suggest?','I need to destroy the ship. What do you suggest?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125869,'We\'re ready to leave now.','We\'re ready to leave now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125870,'','Certainly, Lord Mephistroth. Just a moment while I access your previous user settings...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125871,'','My standard programming has been altered to more adequately support all of Lord Mephistroth\'s needs.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125872,'','At your request, I now offer a variety of services beyond my normal programming to better serve my dark lord.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125873,'Skovald\'s legacy, it appears, has not yet ended.','',0,0,0,0,0,0,1,0,0,0,82572,0,26124),
(125874,'Should your equipment need repairs, Archmage, I\'m at your service.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125875,'','I have orbs you may find especially useful for your endeavors, Archmage, should you need them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125876,'','I have fresh food and bandages for you Archmage, if you\'re in need of any.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125877,'Arrogant fools! I am empowered by the souls of a thousand conquered worlds!','',0,0,0,0,0,0,0,0,0,0,82671,0,26124),
(125878,'Excellent work, Archmage. However, the subsequent manifestations of power you face may not be so easily defeated.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(125879,'','Sorry for the mess. The Jarl thought one of his pets could slow me down.',0,0,0,0,0,0,0,0,0,0,0,82923,26124),
(125880,'','Come, let\'s take the fight to him!',0,0,0,0,0,0,0,0,0,0,0,82924,26124),
(125881,'','Allow us to guide you to undeath!',0,0,0,0,0,0,0,0,0,0,0,81296,26124),
(125882,'Even a fraction of my power will be enough to destroy you.','',0,0,0,0,0,0,0,0,0,0,82672,0,26124),
(125883,'','If ya think you can leave my bones here to freeze, you\'re gravely mistaken. Haha, let\'s go!',0,0,0,0,0,0,0,0,0,0,0,81293,26124),
(125884,'I can return you to the Aetherium. Would you like me to?','I can return you to the Aetherium. Would you like me to?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(125885,'Yes, take me back.','Yes, take me back.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(125886,'','Of course my lord. You are Mephistroth, the strongest and wisest of all the Nathrezim.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125887,'','The God of Fel and Flame, Sargeras himself, chose you to lead the Nathrezim to glory following the humiliating defeat of Tichondrius at the hands of Illidan Stormrage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125888,'Eat them alive, pet!','',0,0,0,0,0,0,0,0,0,0,82743,0,26124),
(125889,'The harness...','',0,0,0,0,0,0,0,0,0,0,82744,0,26124),
(125890,'No one is coming to save you.','',0,0,0,0,0,0,0,0,0,0,82673,0,26124),
(125891,'Your world will crumble beneath me.','',0,0,0,0,0,0,0,0,0,0,82674,0,26124),
(125892,'It is you who are alone, Kruul! Your time has come.','',0,0,0,0,0,0,0,0,0,0,83146,0,26124),
(125893,'','Ahhhhhhhh!',0,0,0,0,0,0,0,0,0,0,0,82823,26124),
(125894,'You must stand strong, champion. Do not give up!','',0,0,0,0,0,0,5,0,0,0,83147,0,26124),
(125895,'What ho!  Welcome, weary traveler.  Come sit by my roaring fire. Never fear, I have secured this position on the beachhead, and will soon thwart the Legion\'s assault on these lands!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125896,'Hah! You are all that remains. There is no hope, fools.','',0,0,0,0,0,0,0,0,0,0,82675,0,26124),
(125897,'','As you are aware, Lord Mephistroth, this ship contains a variety of defense systems designed to prevent an array of catastrophic failures.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125898,'Our power is infinite. Our numbers are endless. Bow before the might of the Burning Legion!','',0,0,0,0,0,0,0,0,0,0,82676,0,26124),
(125899,'','Would it please my dark lord if I disabled all emergency and defensive systems on the ship?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125900,'','We... will... never... bow!',0,0,0,0,0,0,0,0,0,0,0,82824,26124),
(125901,'Why yes, that would please me greatly. Make it so.','Why yes, that would please me greatly. Make it so.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125902,'You\'ve come for the harness? Hah! Let us see you try!','',0,0,0,0,0,0,0,0,0,0,82745,0,26124),
(125903,'I cannot maintain my barrier much longer. We must finish this!','',0,0,0,0,0,0,5,0,0,0,83148,0,26124),
(125904,'Your light fades, Prophet. This is your end.','',0,0,0,0,0,0,0,0,0,0,82677,0,26124),
(125905,'This is... not... possible!','',0,0,0,0,0,0,0,0,0,0,82678,0,26124),
(125906,'','Of course. Anything for you Lord Mephistroth, your pleasure is my command.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125907,'','One moment while I disable the defense systems...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125908,'So be it. You will not stand in our way any longer.','',0,0,0,0,0,0,0,0,0,0,82679,0,26124),
(125909,'BEHOLD THE WRATH OF KRUUL!','',0,0,0,0,0,0,0,0,0,0,82680,0,26124),
(125910,'He is overloading himself with power! Look out!','',0,0,0,0,0,0,0,0,0,0,83149,0,26124),
(125911,'','Override complete. If it pleases my master, I have taken the liberty of unlocking the engine room.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125912,'%s falls to the ground!','%s falls to the ground!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125913,'','If you wish to destroy the ship, overloading the generators will cause catastrophic engine damage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125914,'','Do be careful, master!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125915,'Hello again, Maximillian.','Hello again Maximillian.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125916,'I am ready to leave now.','I am ready to leave now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125917,'Squire? Is that you? I barely recognized you. You have not aged well!  Never mind, I suppose even those of your advanced years must continue their training.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125918,'Training?','Training?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125919,'Indeed, squire!  As you can see, I\'ve assaulted this shore and have secured the beach against the Legion, but there is much more work to do. They attempted to break through my defenses last eve, but I held the line stoically against their assault. You can see their demonic corpses over yonder, though you may not possess the stomach to look upon them very long.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125920,'I see two dead crabs, is that what you mean?','I see two dead crabs, is that what you mean?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125921,'Ha ha ha! Crabs, you say? Your ignorance on these matters of demons is presenting itself readily! We must continue your training posthaste, lest you fall forever into a pit of ignorance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125922,'Sigh... very well.','Sigh... very well.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125923,'I will mend your wounds. Look always to the Light.','',0,0,0,0,0,0,0,0,0,0,83154,0,26124),
(125924,'The shadow will not control me!','',0,0,0,0,0,0,0,0,0,0,81685,0,26124),
(125925,'','You made it! I feared we had lost you in the blast.',0,0,0,0,0,0,1,0,0,0,0,82825,26124),
(125926,'','Velen saw us to safety before the explosion overtook us. Kruul wasn\'t so fortunate.',0,0,0,0,0,0,1,0,0,0,0,82826,26124),
(125930,'I will scout out the Feltotem. Bring me the totems when you are done.','',0,0,0,0,0,0,1,0,0,0,82334,0,26124),
(125940,'','I hope it... blows in yer face...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125941,'Fly me to the Broken Shore!','Fly me to the Broken Shore!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125942,'','Archmage Xylem! You\'ve returned...',0,0,0,0,0,0,5,0,0,0,0,81487,26124),
(125943,'','...and I no longer sense the shadow within you!',0,0,0,0,0,0,1,0,0,0,0,81490,26124),
(125944,'Yes, Joanna, thanks to this brave $c.','',0,0,0,0,0,0,25,0,0,0,81681,0,26124),
(125945,'','Lasan\'s riders have taken to the air. Call down his eagles to aid you in defense of Thunder Totem!',0,0,0,0,0,0,0,0,0,0,0,81476,26124),
(125947,'','I failed... my queen...',0,0,0,0,0,0,0,0,0,0,0,81527,26124),
(125948,'','Face the might that lurks beneath the waves!',0,0,0,0,0,0,0,0,0,0,0,81528,26124),
(125949,'','My queen has given me dominion over the seas!',0,0,0,0,0,0,0,0,0,0,0,81529,26124),
(125950,'','Had you surrendered the Tidestone, I might have let you live...',0,0,0,0,0,0,0,0,0,0,0,81530,26124),
(125951,'','Strip their bones clean!',0,0,0,0,0,0,0,0,0,0,0,81531,26124),
(125952,'','Not all storms strike from the skies...',0,0,0,0,0,0,0,0,0,0,0,81532,26124),
(125953,'','The tide will crush you!',0,0,0,0,0,0,0,0,0,0,0,81494,26124),
(125954,'','You cannot resist the sea\'s call!',0,0,0,0,0,0,0,0,0,0,0,81495,26124),
(125955,'','A feeding frenzy!',0,0,0,0,0,0,0,0,0,0,0,81496,26124),
(125956,'','This charade ends NOW!',0,0,0,0,0,0,0,0,0,0,0,81497,26124),
(125957,'I have returned the energy back through the Focusing Iris. Azeroth\'s ley lines should be restored.','',0,0,0,0,0,0,1,0,0,0,81682,0,26124),
(125962,'Picking Up','Picking Up',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125963,'Let\'s get really weird!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125964,'There! Stop the demon before it calls forth more of its vile kind!','',0,0,0,0,0,0,0,0,0,0,80572,0,26124),
(125965,'Aye, I can hardly contain me excitement! I want te watch the explosion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125967,'Patience, Tethys. Don\'t run off just yet.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125970,'I overloaded the generators. What should I do next?','I overloaded the generators. What should I do next?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125971,'','With the shield generators offline, a self-destruct command can be issued to destroy the ship.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125972,'','Unfortunately, I lack the authorization necessary to issue such a command.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125973,'','Please forgive me, master, but you must input the self-destruct codes yourself.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125974,'','If it pleases you Lord Mephistroth, I shall escort you to the command console on the navigation deck.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125975,'','Do stay close, my lord.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125976,'Tremble as I unleash the full might of the Burning Legion upon this pathetic world!','',0,0,0,0,0,0,0,0,0,0,80573,0,26124),
(125979,'','D\'Bynn, you are alive! I had almost lost hope, my sweet friend.',0,0,0,0,0,0,1,0,0,0,0,80694,26124),
(125980,'Good news, $n! It appears that the portal worked! All of your limbs are still intact, yes?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125981,'Excellent! Now that the hard part is over, all you need to do is destroy the ship!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125982,'','No time to waste, Shadowblade. Let\'s get to the top!',0,0,0,0,0,0,0,0,0,0,0,81282,26124),
(125984,'I\'m ready to head down to the base camp.','I\'m ready to head down to the base camp.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125985,'You are too late... Tugar will win...','',0,0,0,0,0,0,0,0,0,47060,0,0,26124),
(125986,'Tugar will avenge me.','',0,0,0,0,0,0,0,0,0,47060,0,0,26124),
(125987,'Someone... warn Tugar...','',0,0,0,0,0,0,0,0,0,47060,0,0,26124),
(125988,'','Ah, here we are!',0,0,0,0,0,0,0,0,0,0,0,81283,26124),
(125989,'I would wager these abjurors possess potent enhancements. A clever mage would do well to steal such power, $n!','',0,0,0,0,0,0,0,0,0,0,82771,0,26124),
(125990,'With the Tirisgarde at the helm, our united forces will crush the Burning Legion once and for all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(125991,'','Before I accept the crown, I must honor my family by fulfilling my brother\'s request. \n\nIf Eyir knows who was responsible for my family\'s fate, then I would hear it from her.\n\nTell me when you\'re ready.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(125992,'I\'m ready.','I\'m ready.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(125993,'','We\'re here! Soon the Legion will taste our wrath.',0,0,0,0,0,0,0,0,0,0,0,81231,26124),
(125994,'','Use the rappel point to drop into the cave. I\'ll relay further instructions then.',0,0,0,0,0,0,0,0,0,0,0,81275,26124),
(125995,'','At the bottom, you\'ll find the cache of gunpowder you previously acquired. You\'ll want to pick that up.',0,0,0,0,0,0,0,0,0,0,0,81276,26124),
(125996,'','Also, it\'s best to not be seen in here. These demons are brutal!',0,0,0,0,0,0,0,0,0,0,0,81277,26124),
(125997,'','Good--that trail of powder left in your wake will come in handy. Now to work your way out of the cave.',0,0,0,0,0,0,0,0,0,0,0,81278,26124),
(125998,'','On your way, you\'ll want to drop extra explosives. Wouldn\'t want to disappoint Tethys now, would we?',0,0,0,0,0,0,0,0,0,0,0,81279,26124),
(125999,'Too late, fools! I already have what I need to destroy Thunder Totem!','',0,0,0,0,0,0,0,0,0,0,81533,0,26124),
(126000,'','You\'ve almost done it! Now get out of there and light the powder with the match Tethys gave you.',0,0,0,0,0,0,0,0,0,0,0,81280,26124),
(126001,'','Hold on... he forgot, didn\'t he? How did I know? Looks like you\'ll need another way to light that powder!',0,0,0,0,0,0,0,0,0,0,0,81281,26124),
(126002,'You came just in time. I think they were going to eat me...','You came just in time. I think they were going to eat me...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126003,'Thank you, Battlelord. For the Horde!','Thank you, Battlelord. For the Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126004,'You have my eternal gratitude, Battlelord.','You have my eternal gratitude, Battlelord.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126005,'Thank you, hero. You have rescued me from a horrific fate.','Thank you, hero. You have rescued me from a horrific fate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126006,'*sniff* That was... right beautiful, matey.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126007,'You came just in time. I think they were going to eat me...','You came just in time. I think they were going to eat me...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126008,'Thank you, Battlelord. For the Alliance!','Thank you, Battlelord. For the Alliance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126009,'Thank you, hero. You have rescued me from a horrific fate.','Thank you, hero. You have rescued me from a horrific fate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126010,'You have my eternal gratitude, $c.','You have my eternal gratitude, $c.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126011,'','You have helped me protect these lands. Now it is my turn to help you. Come, let us find somewhere safe to speak.',0,0,0,0,0,0,1,0,0,0,0,80692,26124),
(126012,'We need to take the fight to Tugar and his worms! If you are ready I will take you there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126013,'I\'m ready to face Tugar. (using Navarrogg\'s Brimming Keystone)','I\'m ready to face Tugar. (using Navarrogg\'s Brimming Keystone)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126014,'I\'m ready to face Tugar. (requires Brimming Keystone)','I\'m ready to face Tugar. (requires Brimming Keystone)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126015,'','When you reach the ground, you\'ll see a barrel. It\'s full of the fel-infused gunpowder you... acquired.',0,0,0,0,0,0,0,0,0,0,0,81237,26124),
(126016,'','By the way, unless you\'re looking for a fel blade in the back, you might want to avoid being seen in here.',0,0,0,0,0,0,0,0,0,0,0,81238,26124),
(126017,'','Good. The next step is simple--just get out of this cave without being seen. The gunpowder will do its job.',0,0,0,0,0,0,0,0,0,0,0,81232,26124),
(126018,'','Actually, one more thing. Plant some explosives around for a little extra \"boom\".',0,0,0,0,0,0,0,0,0,0,0,81233,26124),
(126019,'','Alright, the job\'s almost complete. Just get out of the cave and light the powder with the match Tethys gave you.',0,0,0,0,0,0,0,0,0,0,0,81234,26124),
(126020,'I\'m ready to travel to the Eye of Eternity.','I\'m ready to travel to the Eye of Eternity.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126021,'','Hold on... that drunken buffoon forgot, didn\'t he? You better find a way to light this powder, $ct. I will not let this mission fail!',0,0,0,0,0,0,0,0,0,0,0,81235,26124),
(126022,'','Alright, use the rappel point. Down you go!',0,0,0,0,0,0,0,0,0,0,0,81236,26124),
(126023,'Champion, mages of the Tirisgarde need your help to purge the spider broods from the Creeping Grotto. Their pyromancers could provide you with a burning edge.','',0,0,0,0,0,0,0,0,0,0,80664,0,26124),
(126024,'Well, that became a combustible situation, but you handled the heat expertly.','',0,0,0,0,0,0,0,0,0,0,80665,0,26124),
(126025,'','No time to waste, Shadowblade. Let\'s move.',0,0,0,0,0,0,0,0,0,0,0,81230,26124),
(126026,'','Today, we celebrate de anniversary of de ringin\' of de Scarab Gong. You\'ll see all sorts a festivities \'round Silithus today.$b$bPart of de tradition involves summonin\' de colossal insects from de three silithid hives. To do that, we need meat. Heaps a meat.$b$bCan ya help?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(126027,'Throm-ka! The Horde has taken the lead!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126028,'We have taken the lead! For the Alliance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126029,'I found a beast able to survive the fel infusion.','',0,0,0,0,0,0,1,0,0,0,81534,0,26124),
(126030,'With an army of these creatures boring into the rock, I will bury Thunder Totem!','',0,0,0,0,0,0,1,0,0,0,81535,0,26124),
(126031,'A pity you won\'t be around to see it. Die!','',0,0,0,0,0,0,1,0,0,0,81536,0,26124),
(126032,'Free! Let me just--','',0,0,0,0,0,0,22,0,0,0,82320,0,26124),
(126033,'','With our forces combined, the Burning Legion shall fall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126034,'','Tales shall be told, and songs sung, of the glory that awaits us this day.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126035,'We\'ll go make sure all the demons are truly defeated. When you have time, meet us back in the Hall of Shadows for a briefing.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(126036,'Your words carry the tone of your bravery, $n. Be safe.','Your words carry the tone of your bravery, $n. Be safe.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(126037,'Thank you. I appreciate your help.','Thank you. I appreciate your help.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126038,'I\'ll be alright, but you must tend to the others!','I\'ll be alright, but you must tend to the others!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126039,'The Legion! You must warn the others!','The Legion! You must warn the others!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(126040,'Your words ring true, brave $c. We must stand together!','Your words ring true, brave $c. We must stand together!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126041,'','Fine! I will finish you myself!',0,0,0,0,0,0,0,0,0,0,0,82912,26124),
(126042,'Greetings $n. Is there something I can assist you with?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126043,'I\'m looking for Antonidas\' arcane disc piece. Do you have it?','I\'m looking for Antonidas\' arcane disc piece. Do you have it?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126044,'Battlelord $n! It is good you found me.','',0,0,0,0,0,0,0,0,0,0,81075,0,26124),
(126045,'','I haven\'t thought of that since... well since an old friend asked about it shortly before he was taken from this world.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126046,'','After Antonidas died, I decided to hide the disc away. There was no reason to continue my research into it.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126047,'','But if you think you can finish what Antonidas started, then the piece is yours. Good luck with it, Archmage $n.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126048,'$n! We\'ve lost quite a few to their attacks already! Any help you can give will allow us to hold Thunder Totem as best we can!','$n! We\'ve lost quite a few to their attacks already! Any help you can give will allow us to hold Thunder Totem as best we can!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126049,'Be careful! The Legion is relentless in their assaults.','Be careful! The Legion is relentless in their assaults.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126050,'If you can fight, rally and help defend Thunder Totem! We must not give in!','If you can fight, rally and help defend Thunder Totem! We must not give in!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126051,'We will not allow these demons to defile our home!','We will not allow these demons to defile our home!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126052,'$n! Have you been out there? We\'re holding the demons back as best we can!','$n! Have you been out there? We\'re holding the demons back as best we can!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126053,'','It seems you were right, outsider. Thank you for helping me find my path.',0,0,0,0,0,0,1,0,0,0,0,82928,26124),
(126054,'','I will always remember your deeds. One day, so too will the Tideskorn.',0,0,0,0,0,0,1,0,0,0,0,82929,26124),
(126055,'Khadgar, I\'m looking for a piece of a disc that Antonidas gave you a long time ago.','Khadgar, I\'m looking for a piece of a disc that Antonidas gave you a long time ago.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126056,'You\'re speaking of the Tri-Disc of Fire. Yes, he gave it to me, but that was a long time ago. Back when I was still studying at Karazhan.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126057,'I was working with Archmage Alturus on it at the time. He may still know where it resides. You\'ll find him just outside of Karazhan.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126058,'Conjurer, your Tirisgarde Pyromancers have engaged the endless broods of the Creeping Grotto. Mister Manastorm has offered the use of a customized spell. He says you are \"old friends.\"','',0,0,0,0,0,0,0,0,0,0,80657,0,26124),
(126059,'Archmage Cedric, I\'m looking for a piece of a disc that Antonidas gave to you. Do you happen to have it?','Archmage Cedric, I\'m looking for a piece of a disc that Antonidas gave to you. Do you happen to have it?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126060,'Are your eyebrows still intact? Some of our apprentice mages who attempted that particular spell were not so lucky!','',0,0,0,0,0,0,0,0,0,0,80666,0,26124),
(126061,'Ah, yes. I do. I mean did. Well, it was stolen, you see.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126062,'By ogres no less. Filthy beasts. They raided our ruins a while back and unfortunately they made off with the disc piece.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126063,'Not to worry though. I couldn\'t figure out how to help Antonidas with it, so I\'m sure they have no clue what to do with it.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126064,'But if you\'re looking to retrieve it, I\'m sure it must be somewhere in the Ruins of Alterac where they reside.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126065,'Now you are a sight for sore eyes, Battlelord $n!','',0,0,0,0,0,0,0,0,0,0,81270,0,26124),
(126066,'','D\'Bynn! Can you hear me? When I am freed, I will kill every last trapper for what they have done to us!',0,0,0,0,0,0,1,0,0,0,0,80693,26124),
(126067,'You\'re doing well, Archmage $p. Remember to gather the smaller emanations into a group so you can assault them with your area-of-effect abilities.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126068,'This is the final expulsion, Archmage. Remember what the preceding enemies you faced threw at you and you should be prepared for whatever comes next.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126069,'The manifestations from this disc are trying to slow you down in order to destroy you. Counter their spells and make sure to quickly move away from where their attacks will land.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126070,'You\'re finally upon the final energy purge of the frost disc. Remember the creatures you\'ve seen so far and use that knowledge to your advantage.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126071,'These creatures grow in power the longer they stay alive. Burn them down quickly and interrupt what you can to prevent their growth.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126072,'The final expulsion of power from the arcane disc will most likely mimic what you\'ve already seen. Make sure it doesn\'t grow beyond what you\'re able to destroy.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126073,'','Stop stalling! Where is your Farseer?!',0,0,0,0,0,0,0,0,0,0,0,81640,26124),
(126074,'','Let\'s go, child. We must save my tribe.',0,0,0,0,0,0,1,0,0,0,0,81641,26124),
(126075,'Skovald\'s kin must perish!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126076,'Welcome, Archmage $p. I hope you are prepared for what is to come.','',0,0,0,0,0,0,1,0,0,0,81307,0,26124),
(126078,'Do not give in, $n!','Do not give in, $n!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126079,'Hold them back!','Hold them back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126080,'You must help the others!','You must help the others!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126081,'Hold strong!','Hold strong!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126082,'For Thunder Totem!','For Thunder Totem!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126083,'You want the Doomstone, shaman? Come, take it!','',0,0,0,0,0,0,0,0,0,0,82793,0,26124),
(126084,'You cannot defeat... the Legion...','',0,0,0,0,0,0,0,0,0,0,82794,0,26124),
(126085,'','You head forward from here while I go the opposite way. I will find you afterward.',0,0,0,0,0,0,0,0,0,0,0,81644,26124),
(126086,'','How do you expect to use the power of the Doomstone if you cannot even open your own portal? Foolish child.',0,0,0,0,0,0,463,0,0,0,0,81645,26124),
(126087,'We must deal with this threat quickly.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126088,'I\'d like the help to the Blind Marshlands.','I\'d like the help to the Blind Marshlands.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126089,'Strike at their defenses, $n. Bring these demons down!','',0,0,0,0,0,0,0,0,0,0,81562,0,26124),
(126091,'Well done, Archmage $p! Purging the disc of excess energy has stopped its violent resonance while in proximity to the other discs. I trust the same will happen with the final two.','',0,0,0,0,0,0,1,0,0,0,81313,0,26124),
(126092,'Maintain your focus, Archmage $p! Only one disc left to disperse. Remember, my apprentices can offer aid.','',0,0,0,0,0,0,1,0,0,0,81314,0,26124),
(126093,'','Do not look upon me as one of your underlings, $r. You are but a child to me.',0,0,0,0,0,0,0,0,0,0,0,81646,26124),
(126094,'','And in this corner... a seagull? What is this, the Eye of Azshara?',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126095,'There! You did it! The discs can now align and fuse into one!','',0,0,0,0,0,0,1,0,0,0,81315,0,26124),
(126096,'','Looks like every day is Hallow\'s End for this... thing. Give up some screams for Ooliss!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126097,'','All the way from the gloomy roads of Duskwood, it\'s Stitches!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126098,'','Is that a giant mushroom? Looks like things are about to get weird!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126099,'','Oh, the huge manatee! It\'s here to seal the deal... DOOMFLIPPER!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126100,'','And their challenger, Bill, the custodial engineer of death! Wait... what? Bill! What are you doing in there?',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126101,'I\'m not giving you the Doomstone, Magatha.','I\'m not giving you the Doomstone, Magatha.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126102,'','And introducing the draenei obsessed with pet collection, it\'s Ash\'katzuum!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126103,'','In the other corner, a master of both shadows AND interior lighting... it\'s Shadowmaster Aameen!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126104,'','In the other corner, a challenger so ancient no one remembers his actual name. Let\'s call him Serpent of Old!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126105,'','In the other corner... a really big dinosaur!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126106,'','Kindly insert a gold coin for a battle with Master Paku!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126107,'','And in the other corner, it\'s not one, not two, but the THREE deadly dwarves of the Warhammer Council!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126108,'','Also entering the arena... an ugly gnome contraption that makes music.',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126109,'','And our other challenger, a worm with a serious fire fetish. Come on, Carl! Don\'t you know flames can kill?',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126110,'','And in the other corner, a hunter of incomprehensible spectacular amazing splendor! It\'s Johnny Awesome!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126111,'','And now for the challenger that cost us so much... it\'s Ray D. Tear!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126112,'','Get fired up for the djinn who will literally melt your heart, it\'s Burnstachio!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126113,'','And in the other corner, it\'s that terrible trio... Hudson, Stuffshrew, and Dupree from the Ogrewatch Team!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126114,'','And now for some soul-pounding beats from the musical underground, it\'s Thwack U and his dancers!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126115,'','In the other corner, a pirate with a lethal definition of head cannon! Put your hooks together for Blackmange!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126117,'','You know not what you say. Give it to me!',0,0,0,0,0,0,5,0,0,0,0,81647,26124),
(126118,'I think it safest in Nobundo\'s hands.','I think it safest in Nobundo\'s hands.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126119,'','Spoiled brat! That Doomstone is not leaving my side!',0,0,0,0,0,0,5,0,0,0,0,81648,26124),
(126120,'Then bring me to the Maelstrom, or else I\'ll leave alone with it.','Then bring me to the Maelstrom, or else I\'ll leave alone with it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126121,'All the way from the gloomy roads of Duskwood, it\'s Stitches!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126122,'And in this corner... a seagull? What is this, the Eye of Azshara?','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126123,'Is that a giant mushroom? Looks like things are about to get weird!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126124,'Oh, the huge manatee! It\'s here to seal the deal... DOOMFLIPPER!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126125,'Looks like every day is Hallow\'s End for this... thing. Give up some screams for Ooliss!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126126,'And their challenger, Bill, the custodial engineer of death! Wait... what? Bill! What are you doing in there?','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126127,'And introducing the draenei obsessed with pet collection, it\'s Ash\'katzuum!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126128,'In the other corner, a master of both shadows AND interior lighting... it\'s Shadowmaster Aameen!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126129,'In the other corner, a challenger so ancient no one remembers his actual name. Let\'s call him Serpent of Old!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126130,'In the other corner... a really big dinosaur!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126131,'Kindly insert a gold coin for a battle with Master Paku!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126132,'And in the other corner, it\'s not one, not two, but the THREE deadly dwarves of the Warhammer Council!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126133,'Also entering the arena... a handsome machine that makes beautiful music.','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126134,'And our other challenger, a worm with a serious fire fetish. Come on, Carl! Don\'t you know flames can kill?','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126135,'And in the other corner, a hunter of incomprehensible spectacular amazing splendor! It\'s Johnny Awesome!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126136,'And now for the challenger that cost us so much... it\'s Ray D. Tear!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126137,'Get fired up for the djinn who will literally melt your heart, it\'s Burnstachio!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126138,'And in the other corner, it\'s that terrible trio... Hudson, Stuffshrew, and Dupree from the Ogrewatch Team!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126139,'And now for some soul-pounding beats from the musical underground, it\'s Thwack U and his dancers!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126140,'In the other corner, a pirate with a lethal definition of head cannon! Put your hooks together for Blackmange!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126141,'Gurr not sure how use tiny anvil.\n\n<The Mo\'arg Brute stares down at his feet.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126142,'Repair my armor, Gurr.','Repair my armor, Gurr.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126143,'Squish you!','',0,0,0,0,0,0,0,0,0,0,82486,0,26124),
(126144,'Stomp on your bones!','',0,0,0,0,0,0,0,0,0,0,82487,0,26124),
(126145,'Your life for the Legion!','',0,0,0,0,0,0,0,0,0,0,82488,0,26124),
(126146,'More meat for the fire!','',0,0,0,0,0,0,0,0,0,0,82489,0,26124),
(126147,'','Thank ye, if I wasn\'t chained up I would have given that ugly brute a beating myself!',396,0,0,0,0,0,0,0,0,0,0,0,26124),
(126148,'','Thank you, small one.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126149,'','Hey! Help me out of these shackles!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126150,'Your defiance is futile! You will join us or I shall wear your flayed skin for a cloak!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126151,'','I\'ve seen what your so-called \"gift\" does, demon. I\'ll never join your kind!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126152,'I did not know him well, but I have no doubt that Antonidas would be proud of what you have accomplished this day, Archmage $p.','',0,0,0,0,0,0,1,0,0,0,81316,0,26124),
(126153,'If you wish, I can return you to the Hall of the Guardian.','',0,0,0,0,0,0,1,0,0,0,81317,0,26124),
(126154,'You\'re letting this monster into our sacred space?? She murdered our chieftain!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(126155,'','Put it to rest, you buffoon. There is more at stake here than your pathetic chieftain!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126156,'Pathetic?! Farseer, kick her out! I will not stand for this!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(126157,'I know it is infuriating for you and the other tauren to see her here, Muln.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126158,'But it is more of a liability to have her out in the world. It is better if we keep an eye on her.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126159,'She shall not have free reign here, I assure you.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126160,'She made a few snide comments regarding our vigilance and then left on her own. I haven\'t seen her since.','',0,0,0,0,0,0,0,0,0,0,82742,0,26124),
(126161,'More... I must have more souls!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126162,'Muln spits at Magatha\'s feet in disgust.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126163,'More souls to fuel the fel! I must have more!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126164,'','Ah, Sslayer $n. Since you are here, you may as well lend a hand.',0,0,0,0,0,0,0,0,0,0,0,82583,26124),
(126165,'','I could have taken him... eventually. My thankss.',0,0,0,0,0,0,0,0,0,0,0,82582,26124),
(126166,'Scour the land! Leave not a single mortal to remain! All their souls shall be mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126167,'Dedication to your holy Paladin order demands that you purify this fel taint.','Dedication to your holy Paladin order demands that you purify this fel taint.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126168,'This orb is unnatural to Priests and must be destroyed.','This orb is unnatural to Priests and must be destroyed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126169,'As a Warlock, minor fel magic such as this presents no danger to you. Absorb the power of the Infernal Tome.','As a Warlock, minor fel magic such as this presents no danger to you. Absorb the power of the Infernal Tome.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126170,'Demon Hunter training has long prepared you for this. Grasp the power from within the Infernal Tome.','Demon Hunter training has long prepared you for this. Grasp the power from within the Infernal Tome.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126171,'$n absorbs the magic from the Infernal Tome, granting everyone damage reduction!','$n absorbs the magic from the Infernal Tome, granting everyone damage reduction!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126172,'Wretched mortal! What have you done to my ship?!','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(126173,'No matter! You will pay for this... I WILL DEVOUR YOUR SOUL!','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(126174,'$n destroys the Fel Orb, granting everyone increased critical strike chance!','$n destroys the Fel Orb, granting everyone increased critical strike chance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126175,'$n purifies the Fel Orb, granting everyone increased critical strike chance!','$n purifies the Fel Orb, granting everyone increased critical strike chance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126176,'As a Druid, you recognize the plants and materials that went into this food. It should be safe to eat.','As a Druid, you recognize the plants and materials that went into this food. It should be safe to eat.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126177,'Herbalism has taught you much about natural foodstuffs. This is definitely edible!','Herbalism has taught you much about natural foodstuffs. This is definitely edible!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126178,'','I am glad you honored our pact, Sslayer $n. Perhapss I misjudged you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126179,'As a pandaren, you recognize this edible flower. Time to stuff it in your face!','As a pandaren, you recognize this edible flower. Time to stuff it in your face!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126180,'Years of training in Cooking allows you to recognize this strange flower. It is safe and can even benefit your friends!','Years of training in Cooking allows you to recognize this strange flower. It is safe and can even benefit your friends!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126181,'Why did you leave the others?','Why did you leave the others?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126182,'','I was stir-crazy after so many months aboard that sstinking ship. Besides, the situation required someone with my skills...\n\nPerhapss I should have cloned myself first.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126183,'','Ssee you back there.',0,0,0,0,0,0,0,0,0,0,0,82584,26124),
(126184,'','You are a disgrace, Lexera! You swore an oath to protect our city.',0,0,0,0,0,0,1,0,0,0,0,80690,26124),
(126185,'','You will pay for your treachery with your life!',0,0,0,0,0,0,1,0,0,0,0,80691,26124),
(126186,'','Did Syrenne send you? Has she really sided with an outsider over her own people?',0,0,0,0,0,0,1,0,0,0,0,81817,26124),
(126187,'May I have your attention please. This ship is about to Self-Destruct. Please exit this ship at your soonest convenience.','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(126188,'','She will find that she has chosen poorly. Our true ally is the Burning Legion!',0,0,0,0,0,0,1,0,0,0,0,81818,26124),
(126189,'My computer! How... how did you guess my password?! It had many symbols and capitalized letters!','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(126190,'Interrupting my feast was a fatal mistake, mortal!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126191,'Battlelord! There are remaining Felskorn unaware their God-King has fallen. Go, earn my favor by sending these upstarts to join their former master.','',0,0,0,0,0,0,0,0,0,0,80651,0,26124),
(126192,'For the Valarjar!','',0,0,0,0,0,0,0,0,0,0,80652,0,26124),
(126193,'There remain Felskorn unaware their God-King has fallen. Join my Valarjar in glorious battle and dispatch these fools to meet their fallen leader!','',0,0,0,0,0,0,0,0,0,0,80653,0,26124),
(126194,'You show exceptional prowess in battle. A pity you were not born a warrior! But I suppose no mortal is without flaws.','',0,0,0,0,0,0,0,0,0,0,80654,0,26124),
(126195,'Send me to the Broken Shore!','Send me to the Broken Shore!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126196,'','Your persistence is annoying! My beloved imps, protect me!',0,0,0,0,0,0,0,0,0,0,0,85204,26124),
(126197,'','You chase me too far, $n. My precious imps will make you suffer more than you can imagine.',0,0,0,0,0,0,0,0,0,0,0,85205,26124),
(126198,'','Why does it always have to be demonsss?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126199,'','It figuress I\'d be sent here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126200,'','Grey rockss and green fire. Again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126201,'','Why yes, I DO lack a crown. Thank you for noticing.\n\n<The emissary smiles at you cheerily.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126202,'Where are the others?','Where are the others?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126203,'','Oh, you know...\n\nThey\'re around.\n\nOff you go!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126204,'Thank Odyn, I thought I was done for!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126205,'May the doors of Valhallas open for you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126206,'Odyn bless you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126207,'Sweet freedom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126208,'<Recall the demise of Gul\'dan>','<Recall the demise of Gul\'dan>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126209,'','It appears Kruul\'s lackeys were just here.',0,0,0,0,0,0,396,0,0,0,0,82834,26124),
(126214,'We must free this land of the Legion\'s corruption!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126215,'I will face Zen\'dral. Bring me up!','I will face Zen\'dral. Bring me up!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126216,'With your leadership and our Storm Brew, we will prevail!','',0,0,0,0,0,0,0,0,0,0,82099,0,26124),
(126217,'','I am so, so weary. Yet, I cannot rest until I am certain that our order will survive.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126218,'Today, we celebrate the anniversary of the ringing of the Scarab Gong. You\'ll see plenty of festivities around Silithus today.$b$bPart of the tradition involves summoning those colossal insects from the three silithid hives. To do that, we\'ll need meat. Giant piles of meat.$b$bCan you help?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126219,'The Burning Legion closes in on Azeroth. We must all do our part.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126220,'I need you to convince the other orders to join us against the Legion. We must come together as one!','I need you to convince the other orders to join us against the Legion. We must come together as one!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126221,'I am honored to be chosen for this mission. I will not fail you, Grandmaster $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126222,'','High Priest! I got important information for ye.',0,0,0,0,0,0,1,0,0,0,0,81163,26124),
(126223,'I borrowed a small submarine from friends o\' mine in the Explorers\' League. We\'ll be embarkin\' off the coast o\' Azsuna as soon as ye can join us, High Priest.','',0,0,0,0,0,0,1,0,0,0,81177,0,26124),
(126224,'','Sea\'s calm so far, even this close to the Maelstrom.',0,0,0,0,0,0,0,0,0,0,0,81164,26124),
(126225,'So, brother... the planet, Azeroth, she just sorta... told ye to come here?','',0,0,0,0,0,0,0,0,0,0,81178,0,26124),
(126226,'Not so much in words. \'Tis more... feelin\'s... but not like feelin\'s ye or I would have.','',0,0,0,0,0,0,0,0,0,0,81179,0,26124),
(126227,'','Now what does that even mean?',0,0,0,0,0,0,0,0,0,0,0,81165,26124),
(126228,'Well, let\'s say ye\'re a world soul, eh? What sorta feelin\'s do ye suppose ye\'d have? Sometimes ye feel like a crumblin\' mountain range, an\' sometimes ye feel like a deep, dark sea. I dunno exactly how ta\' describe it.','',0,0,0,0,0,0,0,0,0,0,81180,0,26124),
(126229,'So... she sorta \'felt\' at ye, that ye should come here?','',0,0,0,0,0,0,0,0,0,0,81181,0,26124),
(126230,'It felt... like a sunrise.','',0,0,0,0,0,0,0,0,0,0,81182,0,26124),
(126231,'','We\'re coming up ta what appears ta be the vault entrance.',0,0,0,0,0,0,0,0,0,0,0,81166,26124),
(126232,'Commencin\' dockin\' procedures.','',0,0,0,0,0,0,0,0,0,0,81183,0,26124),
(126233,'Whoa, that\'s a large door! Gotta be a lever around here somewhere, though. There\'s always a lever!','',0,0,0,0,0,0,5,0,0,0,81184,0,26124),
(126234,'Revola ruk maez amir.','',0,0,0,0,0,0,463,0,0,0,81185,0,26124),
(126235,'','Well, I suppose ye don\'t need ta be lookin\' fer levers and switches n\'more, Brann!',0,0,0,0,0,0,574,0,0,0,0,81167,26124),
(126236,'Bit of a shame, that.','',0,0,0,0,0,0,1,0,0,0,81186,0,26124),
(126237,'They must be activated simultaneously. High Priest, would ye do the honors?','',0,0,0,0,0,0,1,0,0,0,81187,0,26124),
(126238,'Systems active. Visitors detected.','',0,0,0,0,0,0,0,0,0,0,81188,0,26124),
(126239,'Life form scan in progress.','',0,0,0,0,0,0,0,0,0,0,81189,0,26124),
(126240,'Oh, I know sure enough what this is gonna lead to! Weapons up!','',0,0,0,0,0,0,53,0,0,0,81190,0,26124),
(126241,'No essential life forms detected. Resuming scan.','',0,0,0,0,0,0,0,0,0,0,81191,0,26124),
(126242,'Now what do ye mean by that? Not essential? Me? You\'re \'not essential,\' ye wee little...','',0,0,0,0,0,0,6,0,0,0,81192,0,26124),
(126243,'Speaker status verified. Welcome, Speaker. Have you come to retrieve the seekers?','',0,0,0,0,0,0,0,0,0,0,81193,0,26124),
(126244,'Seekers... yes, that must be what she meant when she directed me ta this place. She wanted us to find these creatures.','',0,0,0,0,0,0,273,0,0,0,81194,0,26124),
(126245,'','Uh, Mister Custodian, what in the name o\' the Forge is a Seeker?',0,0,0,0,0,0,6,0,0,0,0,81169,26124),
(126246,'Allow me to show you.','',0,0,0,0,0,0,0,0,0,0,81195,0,26124),
(126247,'Designation: Seeker. Feral creatures infused with the Light by the Shapers. The finest specimens were selected from herds and trained to serve the watchers, speeding them to sites of corruption in accordance with containment protocols.','',0,0,0,0,0,0,0,0,0,0,81196,0,26124),
(126248,'Herds, ye say? We\'ve never seen a one! How many of \'em remain?','',0,0,0,0,0,0,6,0,0,0,81197,0,26124),
(126249,'Accessing... Current count of known Seekers: three.','',0,0,0,0,0,0,0,0,0,0,81198,0,26124),
(126250,'','Only the three here, then?',0,0,0,0,0,0,6,0,0,0,0,81170,26124),
(126251,'So, what happened to \'em?','',0,0,0,0,0,0,6,0,0,0,81199,0,26124),
(126252,'Invasive corruptive entities have bombarded this planet since its shaping. Attrition due to combat fatalities gradually reduced the numbers of Seekers. Now, only these are known to remain.','',0,0,0,0,0,0,0,0,0,0,81200,0,26124),
(126253,'These noble creatures protected us before we even knew how ta protect ourselves...','',0,0,0,0,0,0,274,0,0,0,81201,0,26124),
(126254,'Alert! Void energies detected. Initiating sanitation protocol.','',0,0,0,0,0,0,0,0,0,0,81202,0,26124),
(126255,'Oh blazes! Not again!','',0,0,0,0,0,0,5,0,0,0,81203,0,26124),
(126256,'Again? Ye\'ve done this before, brother?','',0,0,0,0,0,0,6,0,0,0,81204,0,26124),
(126257,'More than once! Yer the big important Speaker. Can ye shut it off, then?','',0,0,0,0,0,0,661,0,0,0,81205,0,26124),
(126258,'Err... Stop it, then, will ye?','',0,0,0,0,0,0,25,0,0,0,81206,0,26124),
(126259,'Unable to comply. Sanitation protocol cannot be aborted. Visitors may be in a corrupted state. If you are hearing whispers of unknown origin, please step directly into the searing light.','',0,0,0,0,0,0,0,0,0,0,81207,0,26124),
(126260,'Lotta good that did! Well, here we go!','',0,0,0,0,0,0,15,0,0,0,81208,0,26124),
(126261,'','Spawns o\' Light, barely of this world. A good dispel should dissipate \'em.',0,0,0,0,0,0,5,0,0,0,0,81171,26124),
(126262,'I sense some corruption amongst my brethren. Watch yerself fer purification.','',0,0,0,0,0,0,1,0,0,0,81211,0,26124),
(126263,'O\' course the big ones would come ta life, too. Watch yerselves!','',0,0,0,0,0,0,579,0,0,0,81213,0,26124),
(126264,'An\' that\'s the last of em\'.  Gonna hope that\'s the last time I end up in this situation...','',0,0,0,0,0,0,1,0,0,0,81214,0,26124),
(126265,'','Hmm, the custodian be powerin\' down. Might be this chamber expended all its energy.',0,0,0,0,0,0,1,0,0,0,0,81173,26124),
(126266,'','No one\'s left ta look after these poor creatures!',0,0,0,0,0,0,661,0,0,0,0,81174,26124),
(126267,'Yer wrong about that, lass. \'Tis why Azeroth called me... called us... here.','',0,0,0,0,0,0,273,0,0,0,81215,0,26124),
(126268,'She knew it wouldn\'t be long before the void o\'ertook this chamber. She knew who would protect these creatures an\' use \'em in service of the Light.','',0,0,0,0,0,0,1,0,0,0,81216,0,26124),
(126269,'\'Tis ye, High Priest.','',0,0,0,0,0,0,25,0,0,0,81217,0,26124),
(126270,'','Agreed. High Priest, give us time ta scribe \'em into the annals o\' the Light. We\'ll meet up at Netherlight Temple.',0,0,0,0,0,0,66,0,0,0,0,81175,26124),
(126271,'On this day, many years ago, a hero by the name of Kalahad rang the Scarab Gong, opening the gates to Ahn\'Qiraj and beginning a war the likes of which Kalimdor had never seen.$b$bToday, we celebrate the heroics of those past adventurers by returning to Silithus and walking in their footsteps.$b$bWhat\'s more: this is a competition between the Horde and Alliance. Whichever group can earn more credits over the next 24 hours earns the right to fly their flag next to the gong for the rest of the year.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126272,'Disrupt the Twilight\'s Hammer camps, and strike at their Abyssal High Council!\n\nSlay the mighty silithid colossi that dwell in each of the three large silithid hives.\n\nGather silithyst, a valuable red spice, for our faction.\n\nVenture into Ahn\'Qiraj itself and deal with the qiraji and old god menaces that dwell inside!\n\nEven adventurers that prefer not to fight can participate by donating war supplies, in the form of meat, to our cause.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126273,'Yes, both the Medallion of Station and the Ring of Lordship are expensive - far too expensive for any one person to purchase on their own.$b$bI suggest you team up with other adventurers and select a champion. Only one medallion or ring is required to summon the high-ranking members of the Abyssal Council - but many heroes will be required to defeat them.$b$bGood luck.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126274,'How can I help the war effort?','How can I help the war effort?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126275,'Why are the items you sell so expensive?','Why are the items you sell so expensive?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126276,'','The Feltotem capture my people, seeking to conscript them into their ranks. This evil must be stopped!',0,0,0,0,0,0,0,0,0,0,0,80576,26124),
(126277,'We are endless! Our sight reaches far beyond your miserable world.','',0,0,0,0,0,0,0,0,0,0,81073,0,26124),
(126278,'This is only... the beginning...','',0,0,0,0,0,0,0,0,0,0,81074,0,26124),
(126279,'Meet me outside at once! It is time to sever the Legion\'s tendrils and free Azsuna!','',0,0,0,0,0,0,0,0,0,0,81565,0,26124),
(126280,'Heroes don\'t die, they revive!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126281,'I deserved that.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126282,'I\'m ready to bring down the power source.','I\'m ready to bring down the power source.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126283,'The Legion\'s power wanes. We must end this now!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126284,'This tree still has plenty of useable heartwood!','This tree still has plenty of useable heartwood!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126285,'This wood may look terrible, but its magic is still strong enough for our uses!','This wood may look terrible, but its magic is still strong enough for our uses!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126286,'Enough! I have little time for games!','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(126287,'You succeeded in destroying my ship, but this victory shall be your last!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126288,'I will enjoy watching you burn. Farewell, mortal!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126289,'Who dares interrupt my feast?','',0,0,0,0,0,0,0,0,0,0,80590,0,26124),
(126290,'|TInterface\\Icons\\ABILITY_WARLOCK_BURNINGEMBERSGREEN:20|t%s targets you with a |cFFFF0000|Hspell:232249|h[Fel Comet]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(126291,'|TInterface\\Icons\\SPELL_SHADOW_SUMMONINFERNAL:20|t%s targets you with |cFFFF0000|Hspell:233272|h[Shattering Star]|h|r! Hide!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(126292,'|TInterface\\Icons\\SPELL_FIRE_FELIMMOLATION:20|t%s starts casting |cFFFF0000|Hspell:233062|h[Infernal Burning]|h|r. Hide!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(126293,'','A lost titan vault... kept in immaculate condition? This be one fer the record books! What d\'ye suppose be in these bubbles, eh?',0,0,0,0,0,0,5,0,0,0,0,81168,26124),
(126294,'Delicious souls! I must have more!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126295,'Channel my power through the Doomstone and destroy those fel spreaders!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126296,'Smolderon has requested your assistance up on the ridge, Farseer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126297,'Harness my wrath, Farseer! Melt the Legion with the might of the Firelord!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126298,'Therazane needs help with a nearby cave. Go with haste!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126299,'','I would join you, but it is a cave sized for fleshlings. Channel my power through your Doomstone and crush our enemies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126300,'','One last request for aid, fleshling. Thunderaan requires your assistance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126301,'Let me know when you need to get up to the Doomguard, Farseer. I will channel my energy through your Doomstone.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126302,'','Perhaps that can be arranged. Grandmaster $n, you aren\'t looking so good. You should return to the Peak of Serenity!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126303,'We think the lost titan vault lies just northeast of the Maelstrom. Shouldn\'t take us long to find out.\n\nAre ye ready, High Priest?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126304,'I am ready to head to the Maelstrom.','I am ready to head to the Maelstrom.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126305,'Take me to the Broken Shore.','Take me to the Broken Shore.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126306,'Anything you say, snookums!','',0,0,0,0,0,0,17,0,0,0,0,0,26124),
(126307,'','Galius my dear, these intruders are interrupting our alone time! DEAL WITH THEM!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126308,'Yes dear, I won\'t let them ruin our date night!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126309,'Ugh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126310,'What is that trinket you carry, puny shaman? You dare to face me with a stone?','',0,0,0,0,0,0,0,0,0,0,82681,0,26124),
(126311,'','Good help is so hard to find. I\'ll just have to get... physical.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126312,'A wall of flames! Grraaahhh! You go stop Tugar. I\'ll join you when I can!','',0,0,0,0,0,0,0,0,0,0,82326,0,26124),
(126313,'What is happening?! You... cannot... defeat me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126314,'Farseer! Stand down! You are tearing the elemental planes apart!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126315,'Control yourself, before you unleash destruction!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126316,'','Your disparate tribes are no match for our endless army!',0,0,0,0,0,0,0,0,0,0,0,81473,26124),
(126317,'','Rally our allies! Fight for Thunder Totem! We will prevail!',0,0,0,0,0,0,0,0,0,0,0,81475,26124),
(126319,'Fool! You only located me because I wanted to be found! Now I shall have vengeance on Thunder Totem... and you!','',0,0,0,0,0,0,22,0,0,0,81537,0,26124),
(126320,'You merely delay the inevitable! My fel beasts are even stronger now!','',0,0,0,0,0,0,0,0,0,0,81538,0,26124),
(126321,'I\'ll leave it to you how you wish to go about obtaining the final components for the cleansing ritual.$b$bPerhaps you can also determine what\'s been rousing the undead in this light-forsaken place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126324,'Your efforts are futile. Follow me and see why...','',0,0,0,0,0,0,0,0,0,0,81539,0,26124),
(126325,'I hope yer reeaaaddy to get crushed, $rt! I\'ve starved this bear fer a week, and he\'s gonna eat ye alive!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126326,'Behold my greatest creation! With the Legion\'s power behind me, Thunder Totem will be destroyed!','',0,0,0,0,0,0,1,0,0,0,81540,0,26124),
(126327,'This changes... nothing. The Legion... will prevail...','',0,0,0,0,0,0,0,0,0,0,81541,0,26124),
(126328,'I\'m here! I\'m ready to-- What\'s this? Tugar has fallen! You had all the fun without me!','',0,0,0,0,0,0,1,0,0,0,82327,0,26124),
(126329,'With Tugar gone, the Feltotem should present less of a threat.','',0,0,0,0,0,0,1,0,0,0,82328,0,26124),
(126330,'Even so, I will keep an eye on those treacherous fiends until their Legion masters are defeated.','',0,0,0,0,0,0,1,0,0,0,82329,0,26124),
(126331,'Your Kirin Tor have given me one of their portal crystals. No doubt they will be pleased to hear of your success. Many thanks, $n. We will meet again.','',0,0,0,0,0,0,1,0,0,0,82330,0,26124),
(126332,'You were a fool to follow me, brother. The Twisting Nether feeds my strength. I have become more powerful than you could ever imagine!','',0,0,0,0,0,0,0,0,0,0,82344,0,26124),
(126333,'I cannot let you unleash your power upon Azeroth, Raest. If you do not yield, I will be forced to destroy you!','',0,0,0,0,0,0,0,0,0,0,82269,0,26124),
(126334,'Destroy me?! No, brother. Your blade will become my instrument!','',0,0,0,0,0,0,0,0,0,0,82345,0,26124),
(126335,'What?! What are you doing? Nooo!','',0,0,0,0,0,0,0,0,0,0,82270,0,26124),
(126336,'Kill this interloper, brother!','',0,0,0,0,0,0,0,0,0,0,82346,0,26124),
(126337,'I... obey.','',0,0,0,0,0,0,0,0,0,0,82271,0,26124),
(126347,'These vermin harvest ore for their furnaces. Every scrap we wrest from their hands is one less blade turned against our forces.','',0,0,0,0,0,0,0,0,0,0,80623,0,26124),
(126348,'You have hindered the Legion\'s war production, if only briefly. Every victory counts on this dark shore.','',0,0,0,0,0,0,0,0,0,0,80624,0,26124),
(126352,'','I\'m here to aid and advise you on the indirect threats that the Legion poses. These missions will be extremely difficult, please be prepared.$b$bWe will require Nethershards to either breach their defenses or provide you with defenses to weather their horrific attacks. I will have some to spare occasionally, but not always. Please prepare accordingly.',1,0,0,0,0,0,1,0,0,0,0,0,26124),
(126354,'I\'m ready to face Tugar Bloodtotem. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','I\'m ready to face Tugar Bloodtotem. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126355,'','With you as our leader, the Council of Black Harvest will know greater power than ever before.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126356,'I am ready to be summoned.','I am ready to be summoned.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126357,'I need your shield!','I need your shield!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126358,'I need your steel!','I need your steel!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126359,'I need your support!','I need your support!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126360,'Inside the temple--quickly! Find the demon orchestrating this offensive and usher in its end.','',0,0,0,0,0,0,0,0,0,0,81564,0,26124),
(126361,'The Doomstone is far too unstable. We must put it away, keep it in the Maelstrom away from all else. Bring it to Nobundo; he will take care of it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126362,'','Let me at \'em!',0,0,0,0,0,0,0,0,0,0,0,80815,26124),
(126363,'','Let\'s do some damage!',0,0,0,0,0,0,0,0,0,0,0,80816,26124),
(126364,'','I\'m feeling stabby!',0,0,0,0,0,0,0,0,0,0,0,80817,26124),
(126365,'','Check out these claws!',0,0,0,0,0,0,0,0,0,0,0,80818,26124),
(126366,'','I need to fall back. Keep going!',0,0,0,0,0,0,0,0,0,0,0,80819,26124),
(126367,'','I... gotta take a breather.',0,0,0,0,0,0,0,0,0,0,0,80820,26124),
(126368,'Galius faints.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126369,'','Argh! That hurts!',0,0,0,0,0,0,0,0,0,0,0,80821,26124),
(126370,'','There\'s more where that came from!',0,0,0,0,0,0,0,0,0,0,0,80822,26124),
(126371,'','Feels good to get my talons dirty!',0,0,0,0,0,0,0,0,0,0,0,80823,26124),
(126372,'','Ha! You\'ve got nothing on us!',0,0,0,0,0,0,0,0,0,0,0,80824,26124),
(126373,'','Get out of here!',0,0,0,0,0,0,0,0,0,0,0,80825,26124),
(126374,'','I\'ve got your back, Archdruid!',0,0,0,0,0,0,0,0,0,0,0,80826,26124),
(126375,'','Taste my talons!',0,0,0,0,0,0,0,0,0,0,0,80827,26124),
(126376,'Not so fast...','',0,0,0,0,0,0,0,0,0,0,82791,0,26124),
(126377,'Variss, dispose of this rabble.','',0,0,0,0,0,0,0,0,0,0,82682,0,26124),
(126378,'With pleasure, my lord.','',0,0,0,0,0,0,0,0,0,0,82792,0,26124),
(126379,'Oh my head... wha... what happened?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126380,'This... this had nothing to do with me! Galius Miremoore would never be hypnotized by a single succubus!','',0,0,0,0,0,0,661,0,0,0,0,0,26124),
(126381,'','I\'m on it!',0,0,0,0,0,0,0,0,0,0,0,81284,26124),
(126382,'','Time to put you down!',0,0,0,0,0,0,0,0,0,0,0,81046,26124),
(126383,'','Meet my dagger!',0,0,0,0,0,0,0,0,0,0,0,81047,26124),
(126384,'','Don\'t worry, you\'ll be dead soon.',0,0,0,0,0,0,0,0,0,0,0,81048,26124),
(126385,'','Finish the job!',0,0,0,0,0,0,0,0,0,0,0,81049,26124),
(126386,'','Keep going!',0,0,0,0,0,0,0,0,0,0,0,81050,26124),
(126387,'','I\'m falling back!',0,0,0,0,0,0,0,0,0,0,0,81051,26124),
(126388,'','Never cross a princess with a dagger.',0,0,0,0,0,0,0,0,0,0,0,81052,26124),
(126389,'','Oh, it seems you\'re dead.',0,0,0,0,0,0,0,0,0,0,0,81053,26124),
(126390,'','Not even a challenge.',0,0,0,0,0,0,0,0,0,0,0,81054,26124),
(126391,'','Seems you could use my help.',0,0,0,0,0,0,0,0,0,0,0,81055,26124),
(126392,'','Do you need a little more subtlety?',0,0,0,0,0,0,0,0,0,0,0,81056,26124),
(126393,'','Get stabbin\' or get goin\'!',0,0,0,0,0,0,0,0,0,0,0,81057,26124),
(126394,'I... uh... really must be going! Bye!','',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(126395,'','End it now!',0,0,0,0,0,0,0,0,0,0,0,80994,26124),
(126396,'','I emerge from the shadows.',0,0,0,0,0,0,0,0,0,0,0,80995,26124),
(126397,'','Now who\'s doing the rescuing?',0,0,0,0,0,0,0,0,0,0,0,80996,26124),
(126398,'','I\'ve trained for this!',0,0,0,0,0,0,0,0,0,0,0,81229,26124),
(126399,'','Do you like my blade in your back!?',0,0,0,0,0,0,0,0,0,0,0,80997,26124),
(126400,'','To bones and ashes!',0,0,0,0,0,0,0,0,0,0,0,80998,26124),
(126401,'','Everyone\'s alone when they\'re dead!',0,0,0,0,0,0,0,0,0,0,0,80999,26124),
(126402,'','Allow me to escort you to your end.',0,0,0,0,0,0,0,0,0,0,0,81000,26124),
(126403,'','You cannot match my skill!',0,0,0,0,0,0,0,0,0,0,0,81001,26124),
(126404,'','Time to die!',0,0,0,0,0,0,0,0,0,0,0,81002,26124),
(126405,'','Leave me...',0,0,0,0,0,0,0,0,0,0,0,81003,26124),
(126406,'','Go on without me!',0,0,0,0,0,0,0,0,0,0,0,81004,26124),
(126407,'','Don\'t worry... I\'ll heal.',0,0,0,0,0,0,0,0,0,0,0,81005,26124),
(126408,'No! I was promised!','No! I was promised!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126409,'I will be denied no longer!','I will be denied no longer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126410,'Mistress, grant me your strength!','Mistress, grant me your strength!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126411,'You are no match for this power!','You are no match for this power!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126412,'','Let the blood flow!',0,0,0,0,0,0,0,0,0,0,0,81034,26124),
(126413,'','Welcome to the grave!',0,0,0,0,0,0,0,0,0,0,0,81035,26124),
(126414,'','Ah, yes. The sweet scent of death.',0,0,0,0,0,0,0,0,0,0,0,81036,26124),
(126415,'','Time to die!',0,0,0,0,0,0,0,0,0,0,0,81037,26124),
(126416,'','Death awaits!',0,0,0,0,0,0,0,0,0,0,0,81038,26124),
(126417,'','Time to send our foe to the gallows!',0,0,0,0,0,0,0,0,0,0,0,81039,26124),
(126418,'','Think I\'d let you have all the fun?',0,0,0,0,0,0,0,0,0,0,0,81040,26124),
(126419,'','Time to play!',0,0,0,0,0,0,0,0,0,0,0,81041,26124),
(126420,'','My axe grew hungry!',0,0,0,0,0,0,0,0,0,0,0,81042,26124),
(126421,'Hail, Highlord. I am at your service.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126422,'','The grave is calling me back...',0,0,0,0,0,0,0,0,0,0,0,81043,26124),
(126423,'','Mind taking care of that for me?',0,0,0,0,0,0,0,0,0,0,0,81044,26124),
(126424,'','Go ahead... I\'ll catch up.',0,0,0,0,0,0,0,0,0,0,0,81045,26124),
(126425,'Let us cast light upon this unholy place.$b$bHow may I assist you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126426,'The forces within this forsaken city can only hide in the shadows for so long.$b$bI await your command.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126427,'','In the mood for some killing?',0,0,0,0,0,0,0,0,0,0,0,81299,26124),
(126428,'Which paladin would you like to remove from your ranks?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126429,'','Do exactly as I say, child.',0,0,0,0,0,0,0,0,0,0,0,81643,26124),
(126430,'Fiona Stormwell','Fiona Stormwell',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126431,'Vindicator Dran\'aan','Vindicator Dran\'aan',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126432,'Vindicator Edhri','Vindicator Edhri',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126433,'Kralgon Lightbeard','Kralgon Lightbeard',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126434,'Phillip Stormwell','Phillip Stormwell',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126435,'Thelsia Oakthorn','Thelsia Oakthorn',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126436,'','I do not suffer fools gladly.',0,0,0,0,0,0,0,0,0,0,0,81022,26124),
(126437,'','Didn\'t even break a sweat.',0,0,0,0,0,0,0,0,0,0,0,81023,26124),
(126438,'','No match for the elements!',0,0,0,0,0,0,0,0,0,0,0,81024,26124),
(126439,'','You were a fool to cross paths with me!',0,0,0,0,0,0,0,0,0,0,0,81025,26124),
(126440,'','I\'ll barely lift a finger to destroy you!',0,0,0,0,0,0,0,0,0,0,0,81026,26124),
(126441,'','Feel the fury of the Grimtotem!',0,0,0,0,0,0,0,0,0,0,0,81027,26124),
(126442,'','These old bones need a rest.',0,0,0,0,0,0,0,0,0,0,0,81028,26124),
(126443,'','I need to... catch my breath.',0,0,0,0,0,0,0,0,0,0,0,81029,26124),
(126444,'','I must visit the healing waters.',0,0,0,0,0,0,0,0,0,0,0,81030,26124),
(126445,'','Did you think you could do this alone?',0,0,0,0,0,0,0,0,0,0,0,81031,26124),
(126446,'','I have little time for foolishness!',0,0,0,0,0,0,0,0,0,0,0,81032,26124),
(126447,'','Need me to poison your blade?',0,0,0,0,0,0,0,0,0,0,0,81033,26124),
(126448,'','Galius my dear, you should cast the spell I taught you. AND DON\'T SCREW IT UP!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126449,'Brother... why?','',0,0,0,0,0,0,0,0,0,0,82268,0,26124),
(126450,'I\'m... defeated?  That\'s... impossible...','',0,0,0,0,0,0,0,0,0,0,82343,0,26124),
(126451,'','Hail, Highlord. I am at your service.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126452,'','Let us cast light upon this unholy place.$b$bHow may I assist you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126453,'','The forces within this forsaken city can only hide in the shadows for so long.$b$bI await your command.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126454,'','Which paladin would you like to remove from your ranks?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126459,'Are ye ready to leave, High Priest? Just gimme the word an\' I\'ll point the sub back towards Dalaran.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126460,'I am ready to head back to Dalaran.','I am ready to head back to Dalaran.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126461,'I can take ye back whenever yer ready, High Priest.','',0,0,0,0,0,0,0,0,0,0,81218,0,26124),
(126462,'We\'re not done yet!','',0,0,0,0,0,0,5,0,0,0,81209,0,26124),
(126463,'','By my troth, this\'ll be the last time I go adventurin\' with a Bronzebeard!',0,0,0,0,0,0,5,0,0,0,0,81172,26124),
(126464,'Many\'ll come this time. The machine surges with the Light.','',0,0,0,0,0,0,5,0,0,0,81212,0,26124),
(126465,'It pains me to see this ancient land tainted by such pestilent creatures. Stop them before they spread!','',0,0,0,0,0,0,0,0,0,0,80568,0,26124),
(126466,'Well done, hero! Our druids will see to the rest of this menace.','',0,0,0,0,0,0,0,0,0,0,80569,0,26124),
(126467,'Least there\'s no giant eye lasers this time, eh?','',0,0,0,0,0,0,5,0,0,0,81210,0,26124),
(126468,'Powerful warlocks serving the Legion have gathered in Felfire Pass. We must stop them and their fanatical master before they grow too strong.','',0,0,0,0,0,0,0,0,0,0,80625,0,26124),
(126469,'The allure of power is great, and many succumb to its call. Those warlocks gave us no choice but to end their sinister threat.','',0,0,0,0,0,0,0,0,0,0,80626,0,26124),
(126470,'We sought to consecrate the ground where Tirion fell, but the Legion pushed us back. Your aid is needed, Highlord.','',0,0,0,0,0,0,0,0,0,0,80631,0,26124),
(126471,'Thanks to your help, we can complete our work and honor Tirion\'s life of sacrifice.','',0,0,0,0,0,0,0,0,0,0,80632,0,26124),
(126472,'Good work. You have bought our forces the reprieve we needed to finish our task.','',0,0,0,0,0,0,0,0,0,0,80636,0,26124),
(126473,'The paladins of the Silver Hand are attempting a holy ritual in Felfire Pass, but the Legion is pushing back. Slay the demon leader so that we may sanctify this place.','',0,0,0,0,0,0,0,0,0,0,80635,0,26124),
(126474,'This is the place. Kill abominations and smash any eggs you find!','',0,0,0,0,0,0,1,0,0,0,82321,0,26124),
(126475,'Break enough eggs, and the monstrosity that laid them will come looking for a fight!','',0,0,0,0,0,0,1,0,0,0,82322,0,26124),
(126476,'Rasean Lightfall','Rasean Lightfall',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126477,'Alawa Wisebrace','Alawa Wisebrace',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126478,'Guldek Stoneshield','Guldek Stoneshield',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126479,'Nalenn Heartreaver','Nalenn Heartreaver',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126480,'Melhen Lightfury','Melhen Lightfury',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126481,'Tayen Steelhide','Tayen Steelhide',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126482,'Shadowblade, the demons are bringing in more hapless refugees from Suramar. You and your gallery of rogues must liberate them before they become fuel for the fel.','',0,0,0,0,0,0,0,0,0,0,80655,0,26124),
(126483,'Every soul snatched from the fel forge weakens our enemy. Well done.','',0,0,0,0,0,0,0,0,0,0,80656,0,26124),
(126484,'The demons are bringing in more hapless refugees from Suramar. Assist the rogues of the Council of Shadows in liberating the prisoners before they become fuel for the fel.','',0,0,0,0,0,0,0,0,0,0,80669,0,26124),
(126485,'Every soul snatched from the fel forge deprives our enemy of fuel for their cause. Well done.','',0,0,0,0,0,0,0,0,0,0,80670,0,26124),
(126486,'Open yer trap so I can fire, Oso!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126487,'Make it stop! Please, make it stop!','Make it stop! Please, make it stop!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126488,'My... mind... get out of my... mind.','My... mind... get out of my... mind.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126489,'Get...out...of...my...head!','Get...out...of...my...head!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126490,'I don\'t know anything...','I don\'t know anything...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126491,'Why? Why are you doing this?','Why? Why are you doing this?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126492,'Please... let me go. I have a family.','Please... let me go. I have a family.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126493,'I will... never... submit...','I will... never... submit...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126494,'I saw the demon slinking through a portal in all the chaos. Size of two tauren - maybe three!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126495,'','Oh, the calamity! The destruction! The lack of customer trust! $B$B<Glutonia pauses to make sure you\'re looking.>$B$BMaybe the familiar smell of ten gold coins would jog my memory!$B$BUnmarked, please.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(126496,'','I\'ll tell ya what the Legion was after - my bottom line! Legion-grade protection wards ain\'t exactly cheap, sugar!',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(126497,'You got its attention! Here it comes!','',0,0,0,0,0,0,0,0,0,0,82323,0,26124),
(126498,'You\'ve put a dent in their forces. Focus on the eggs now.','',0,0,0,0,0,0,0,0,0,0,82324,0,26124),
(126499,'The beast that laid those eggs is in the cavern! Check the upper area!','',0,0,0,0,0,0,0,0,0,0,82325,0,26124),
(126501,'To me, heroes! Shield me with the Aegis while I tear this dreadlord from the shadows!','',0,0,0,0,0,0,0,0,0,0,80477,0,26124),
(126502,'The vaults have been breached!','The vaults have been breached!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126503,'Doloria, my love! I have found you at last! Are you safe?','',0,0,0,0,0,0,595,0,0,0,0,0,26124),
(126504,'','Maximillian? How did you find me here?',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(126505,'Never fear, my love, we will hunt down these bandits and secure your freedom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126506,'Come, Squire! I shall meet you in the mountains that are high.','',0,0,0,0,0,0,595,0,0,0,0,0,26124),
(126507,'','During our imprisonment, the Kirin Tor locked Kruul\'s heart away in Dalaran\'s vaults to prevent it from falling into Legion hands.',0,0,0,0,0,0,1,0,0,0,0,82830,26124),
(126509,'Eitrigg, I need you to rally the other class orders to form a coalition against the Legion.','Eitrigg, I need you to rally the other class orders to form a coalition against the Legion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126510,'You are saved, my love! Wait... something\'s not quite right.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126511,'Horde warriors, move out!','',0,0,0,0,0,0,0,0,0,0,81077,0,26124),
(126512,'Pardon me, good sir, have you seen my Doloria?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126513,'Hmm, perhaps she\'s behind here...','',0,0,0,0,0,0,24,0,0,0,0,0,26124),
(126514,'Aha! A clue! No, just some dust.','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(126519,'Greetings, Battlelord. You are the strong leader we need in these troubling times.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126520,'Lord Darius, I need you to rally the other class orders to form a coalition against the Legion.','Lord Darius, I need you to rally the other class orders to form a coalition against the Legion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126521,'Greetings, Battlelord. You are the strong leader we need in these troubling times.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126522,'Warriors of the Alliance! We have a job to do!','',0,0,0,0,0,0,0,0,0,0,81272,0,26124),
(126523,'We seem to be having a problem with over-sized eggs... well, not with the eggs per se, but the kraken hatching from the eggs.','',0,0,0,0,0,0,0,0,0,0,83273,0,26124),
(126524,'She and her kvaldir jealously stole away many souls worthy of joining our ranks. They must be freed so they can at last assume their rightful places here in the sky.','',0,0,0,0,0,0,0,0,0,0,83110,0,26124),
(126525,'Normally I\'d let nature take its course... however, I\'d prefer not to fight an army of kraken and the Burning Legion at the same time!','',0,0,0,0,0,0,0,0,0,0,83274,0,26124),
(126526,'','Excellent! I can think of no one better suited to the task. We stand ready to inform you about all known threats.',0,0,0,0,0,0,1,0,0,0,0,81394,26124),
(126527,'Ya must be blinder than a pirate with two eye patches.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126528,'','Umm, isn\'t that her with the mask? Oh wait, right, yes, no, haven\'t seen her.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126529,'','Hey Doloria, this one\'s looking for ya.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126530,'','Be quiet, Crixa!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126531,'She is nowhere to be found. She must have been taken once more!','',0,0,0,0,0,0,579,0,0,0,0,0,26124),
(126532,'','In the other corner, a dwarf and his totally loyal companion who would NEVER harm its master. Ever.',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126533,'Cooldowns and debuffs have been reset.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126534,'Good work taking care of those giants! The supplies you\'ve gathered will be a boon to the war effort.','',0,0,0,0,0,0,0,0,0,0,83275,0,26124),
(126535,'In the other corner, a dwarf and his totally loyal companion who would NEVER harm its master. Ever.','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(126536,'What?! The gunpowder has been taken by harpies? I must gather my crew and head to Highmountain!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126537,'Bah! These vrykul think they can steal our gunpowder? They\'ve got another thing coming!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126539,'','Kruul returns? We must prepare an assault on the demon\'s lair. Karlain, please ensure the Illidari are given all the supplies we can spare.',0,0,0,0,0,0,1,0,0,0,0,81392,26124),
(126540,'','Thank you, $p. You have bought valuable time to deal with this threat.',0,0,0,0,0,0,1,0,0,0,0,81393,26124),
(126541,'Crackers! I thought ye were me matey! Yer breakin\' my heart!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126542,'These demons will pay for what they have done. This I vow!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126543,'Send me to the forward camp at once! [Queue for Scenario]','Send me to the forward camp at once! [Queue for Scenario]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126544,'My mistress\' death will be avenged! No foul outlander shall control the kvaldir while I still draw breath!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126545,'Helya... I failed you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126546,'Ahoy, $n. I\'m hopin\' fer a great explosion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126547,'What\'s with the hozen?','What\'s with the hozen?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126548,'Ye can\'t find any loyalty in th\' feathered folk. Crackers might\'ve left me shipwrecked, but I can\'t be a successful pirate captain without a proper matey! Nanners is me new partner, and he\'s been right handy!$b$bWho needs a bird, anyway? Nanners is a much more useful crewmate.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126549,'How may I serve, $ct?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126550,'Go gather the other class orders. We\'re going to Broken Shore.','Go gather the other class orders. We\'re going to Broken Shore.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126551,'Of course, $ct. We will leave at once.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126552,'Knights! The $ct needs us! Let\'s fly!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126553,'You fight with honor, Battlelord $n. I will report to Deliverance Point. See you there.','',0,0,0,0,0,0,0,0,0,0,81076,0,26124),
(126554,'It was an honor to fight alongside you, Battlelord $n. I will report to Deliverance Point. See you there!','',0,0,0,0,0,0,0,0,0,0,81271,0,26124),
(126555,'First they invade our lands. Now the demons darken the skies.','',0,0,0,0,0,0,0,0,0,0,80411,0,26124),
(126556,'The Burning Legion is a plague that sickens the land with its presence. The demons must be purged before their forces spread any further!','',0,0,0,0,0,0,0,0,0,0,80395,0,26124),
(126557,'Valuable supplies were lost beneath the ocean during our first assault. They would come in handy in our fight against the Legion.','',0,0,0,0,0,0,0,0,0,0,83276,0,26124),
(126558,'Unfortunately, sea giants have moved in to claim the goods. Slay the giants and scour the wreckage for our lost supplies.','',0,0,0,0,0,0,0,0,0,0,83277,0,26124),
(126559,'The death of those foul creatures will stoke the fire of the Legion\'s wrath. Make haste to Black Rook Hold. We must press our attack!','',0,0,0,0,0,0,0,0,0,0,80396,0,26124),
(126560,'The Legion opened a portal that is spewing forth a swarm of foul imps. Champion, these tiny fiends must be eradicated!','',0,0,0,0,0,0,0,0,0,0,80629,0,26124),
(126561,'Impressive. Those impudent imposters imperiled important improvements.','',0,0,0,0,0,0,0,0,0,0,80630,0,26124),
(126562,'This always happens! I look the other way for one minute, and your goons have stolen our explosives!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126563,'Hey, easy there, bub. I only swiped your bombs because you and your munchkin squad swiped ours first!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126564,'<Gasp!> I can\'t believe you would resort to name-calling. On BOAT DAY, of all days.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126565,'','Ahoy down there! You sailors want to party?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126566,'ACH! I can\'t believe it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126567,'We come all this way to celebrate Boat Day, and ye forgot the dang-blasted ALE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126568,'Sorry.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126569,'Hmm... I\'ll bet those pirates over yonder have some ale on \'em...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126570,'The thoughtless partying of the other races has a drastic effect on this land\'s environment.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126571,'All of their litter collects in this corner of the lagoon. We cannot abide this affront to nature.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126572,'<Sigh>... I was hoping to play some volleyball, too...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126573,'You\'ve been given a free boat to use on the water\'s surface for the day. Boat safely!','You\'ve been given a free boat to use on the water\'s surface for the day. Boat safely!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126574,'Well fought, $n. But there is more to be done before we can claim victory.','',0,0,0,0,0,0,0,0,0,0,80394,0,26124),
(126575,'Stay away, unless you want a firework to the face!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126576,'','Ack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126577,'Get off my boat, Horde scum!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126578,'Get off my boat, Alliance scum!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126579,'','You want the boom? You got it, bozo!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126580,'Grongo smash!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126581,'|TINTERFACE\\ICONS\\SPELL_FIRE_FELFIRENOVA:20|t The Avatar casts |cFFFF0404|Hspell:234059|h[Unbound Chaos]|h|r on you!','|TINTERFACE\\ICONS\\SPELL_FIRE_FELFIRENOVA:20|t The Avatar casts |cFFFF0404|Hspell:234059|h[Unbound Chaos]|h|r on you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126582,'|TINTERFACE\\ICONS\\SPELL_FIRE_FELHELLFIRE:20|t The Avatar begins to cast |cFFFF0404|Hspell:239132|h[Rupture Realities]|h|r!','|TINTERFACE\\ICONS\\SPELL_FIRE_FELHELLFIRE:20|t The Avatar begins to cast |cFFFF0404|Hspell:239132|h[Rupture Realities]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126583,'|TINTERFACE\\ICONS\\SPELL_FEL_ELEMENTALDEVASTATION:20|t The Corrupted Guardian begins to cast |cFFFF0404|Hspell:233856|h[Cleansing Protocol]|h|r!','|TINTERFACE\\ICONS\\SPELL_FEL_ELEMENTALDEVASTATION:20|t The Corrupted Guardian begins to cast |cFFFF0404|Hspell:233856|h[Cleansing Protocol]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126584,'|TINTERFACE\\ICONS\\SPELL_FIRE_FELHELLFIRE:20|t The Avatar begins to cast |cFFFF0404|Hspell:234724|h[Annihilation]|h|r!','|TINTERFACE\\ICONS\\SPELL_FIRE_FELHELLFIRE:20|t The Avatar begins to cast |cFFFF0404|Hspell:234724|h[Annihilation]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126585,'Greetings! This is the perfect place for arcane meditation, don\'t you agree?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126586,'High Sorceror, I need you to persuade the other class orders to join us against the Legion.','High Sorceror, I need you to rally the other class orders to join us against the Legion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126587,'','Spirits guide you, $ct.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126588,'I will open a portal to Arcanist Ryanna\'s  location. One moment.','',1,0,0,0,0,0,0,0,0,0,82774,0,26124),
(126589,'We must send news to the other class orders. We are going to the Broken Shore.','We must send news to the other class orders. We are going to the Broken Shore.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126590,'%s begins to channel |cFFFF0404|Hspell:234728|h[Arcane Annihilation]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(126591,'','You have heard the $ct\'s words, children. Go to the other orders, gather their support! May the elements guide you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126592,'The enemy must be stopped at all costs!','',0,0,0,0,0,0,0,0,0,0,80403,0,26124),
(126593,'Let\'s begin the assault.','Let\'s begin the assault.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126594,'The Legion will fail in its efforts.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126595,'You cannot hide, Mephistroth!','',0,0,0,0,0,0,0,0,0,0,80475,0,26124),
(126596,'|TInterface\\Icons\\ABILITY_CREATURE_CURSED_03.BLP:32|t Mephistroth uses |cFFFF0000|Hspell:233206|h[Shadow Fade]|h|r to conceal himself!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(126597,'What can I help you with?','',0,0,0,0,0,0,0,0,0,47462,0,0,26124),
(126598,'Hmm... Laurence... let\'s see...\n\nOh yes, she was in the other day. She was looking for a staff with some very particular properties. A funny thing, really, because it seemed the kind of staff I would normally procure for one of my warlock customers.\n\nIt took me a few days to get it, but I found one and had it delivered to the Legerdemain Lounge at her request.','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(126599,'%s uses Dino Mojo on you, granting you an Adaptation!','%s uses Dino Mojo on you, granting you an Adaptation!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126600,'Here\'s the holy water, Grayson.','Here\'s the holy water, Grayson.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126601,'Hey there. We brought some toys for you to borrow. Good luck.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126602,'Uh... I don\'t think he was supposed to be so little.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126606,'Free me from this torment!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126607,'The hounds will devour us all!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126608,'Release me, stranger. I\'d rather spend eternity in Helheim than suffer the fate that awaits me here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126609,'The final death... it comes for us all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126610,'Freedom, at last!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126611,'Thank you, stranger! May we meet again in the Halls of Valor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126612,'I\'ll be food for the hounds no longer!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126613,'Odyn bless you, stranger!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126614,'These ancient forests must be cleansed of the Legion\'s presence. Give the word, heroes, and we shall begin the fight to save Val\'sharah!','',0,0,0,0,0,0,0,0,0,0,80409,0,26124),
(126615,'Defenders, move out! Now we take the fight to the Legion!','',0,0,0,0,0,0,0,0,0,0,80402,0,26124),
(126616,'Purge the Legion from our world!','',0,0,0,0,0,0,0,0,0,0,80400,0,26124),
(126617,'You will fall, demons!','',0,0,0,0,0,0,0,0,0,0,80401,0,26124),
(126618,'A wall of fel energy blocks our entry to the Warden tower. Move your team forward and destroy the Legion machines powering the barrier. We will hold this position while you strike.','',0,0,0,0,0,0,0,0,0,0,80404,0,26124),
(126619,'The fool! Her portal has overloaded and is tearing rifts into the Twisting Nether!','',0,0,0,0,0,0,5,0,0,0,82550,0,26124),
(126620,'I\'ll try to get it stable! Hold the demons off until I can stop them!','',0,0,0,0,0,0,0,0,0,0,82551,0,26124),
(126621,'','I reclaimed Arikara. Did you find the Doomstone?',0,0,0,0,0,0,0,0,0,0,0,81642,26124),
(126622,'We sense you bear dangerous news from the Broken Shore. We await you at the Violet Citadel.','',0,0,0,0,0,0,0,0,0,0,81355,0,26124),
(126623,'The barrier is down, but the Legion\'s evil still looms over us. If we secure the tower\'s apex, the Dreamweavers will provide the means to reach the demons\' vessel.','',0,0,0,0,0,0,0,0,0,0,80406,0,26124),
(126624,'The key to securing the tower lies in striking down their leader within. We must take that tower!','',0,0,0,0,0,0,0,0,0,0,80405,0,26124),
(126625,'The Dreamweavers have lent their hippogryphs to carry you to the Legion\'s vessel. Eliminate the commander leading this assault, and the rest of these cowardly demons will retreat. Good luck, champions!','',0,0,0,0,0,0,0,0,0,0,80408,0,26124),
(126626,'Feel the power of the Light!','',0,0,0,0,0,0,5,0,0,0,83150,0,26124),
(126627,'In the Light, we are one.','',0,0,0,0,0,0,0,0,0,0,83151,0,26124),
(126628,'We will not fall!','',0,0,0,0,0,0,0,0,0,0,83152,0,26124),
(126629,'I must regain my strength. Be cautious, champion!','',0,0,0,0,0,0,0,0,0,0,83153,0,26124),
(126630,'Please be turnink your attenzhion to me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126631,'Ve run a tight balloon here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126632,'Zhere vill be no talkink, no jumpink, no basket-jostlink.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126633,'NO HORSEPLAYINK!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126634,'Zhese are zhe rules. Obey zhem, or be dealt vizh.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126635,'Ve vill all have a very nice balloon ride, and ve are goink to enjoy it. Is zhat clear?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126636,'Very goot. Now ve sit in silence for zhe next hour.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126637,'The Night Watch knows a thing or two about tracking. In Duskwood, creatures lurk in every dark nook and cranny.$b$bSometimes you catch a glimpse of their beady little eyes, peering at you from the bushes.$b$b<The watcher tries to suppress a shudder.>$b$bWhy, just the other day I sensed an unfamiliar creature stalking me in the forest, watching from the shadows.','',1,1,0,0,500,0,0,0,0,0,0,0,26124),
(126638,'I DESERVED ZHIIISSS!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126639,'A demon stronghold in Black Rook? Remove the fiends at once!','',0,0,0,0,0,0,0,0,0,0,80397,0,26124),
(126640,'Hurry to the northern end of the ramparts! A dark presence rises atop the keep!','',0,0,0,0,0,0,0,0,0,0,80398,0,26124),
(126641,'Farseer! Elementals of pure felfire scorch the land with their curses. Please, cleanse those who battle these creatures and purge the magic these monsters wield.','',0,0,0,0,0,0,0,0,0,0,80645,0,26124),
(126643,'Well done, Farseer. Your shaman can take it from here.','',0,0,0,0,0,0,0,0,0,0,80646,0,26124),
(126644,'Hero, the shaman of the Earthen Ring are striving to counter intense fel curses plaguing this land. They need your aid in battle while they carry out their cleansing rituals.','',0,0,0,0,0,0,0,0,0,0,80679,0,26124),
(126645,'When our war against the Legion ends, let us hope the Earthen Ring finds a way to restore balance to this scarred land.','',0,0,0,0,0,0,0,0,0,0,80680,0,26124),
(126646,'','Welcome aboard!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126647,'','Boy, are you guys in luck! This ain\'t gonna be your standard, sleepy, ultra-slow balloon ride.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126648,'','I\'ve got this baby tricked out with a chronal accelerator I bought super cheap! Time is literally gonna fly! What could go wrong?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126649,'','Uh-oh...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126650,'','I don\'t think we\'re in Nagrand anymore.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126651,'','We\'re in Nagrand? We\'re in Nagrand!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126652,'','I don\'t believe it! We traveled back in time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126653,'','Or is it forward in time? I never know. Either way, this is horrifying! I wanna go back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126654,'','There\'s no time like home, there\'s no time like home, there\'s no time like home...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126655,'Hop aboard, junior ballooners! Anybody want a balloon sticker? Here ya go.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126656,'We run the swankiest balloon in all of Azeroth! Ask anybody, they\'ll tell ya it\'s true!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126657,'How\'s about some free drinks? Here ya go!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126658,'Today, we\'re flying over Azsuna, the jewel of the Broken Isles.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126659,'Anybody for caviar? We got only the best!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126660,'That\'s the Nar\'thalas Academy down there. A school for mages back in ancient times, I hear.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126661,'Hot towel? Only the best for our customers!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126662,'Rungle, why don\'t ya heat up the barbecue, then get the fireworks ready.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126663,'Sure thing, boss.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126664,'Ya might be wondering how I can run such a classy balloon outfit and still turn a profit. Well, lemme tell ya.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126665,'The trick is, ya don\'t reveal the price to the customer \'til they\'re up in the balloon with ya!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126666,'That\'ll be 28,542 gold each--gratuity NOT included. Unless, of course, you\'d like Rungle here to break your legs.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126667,'Okay, boss. I put the fireworks on the barbecue, like you said.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126668,'You did WHAT? Rungle, you bungled it again!!!!!!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126669,'Welcome, friends, to the Nesingwary balloon tour o\' Highmountain!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126670,'Bought this balloon from a wee goblin. Claimed it\'d make a good perch fer shootin\' moose!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126671,'Lately, though... eh, I dunno. Been feelin\' a bit down. Huntin\' don\'t bring the same joy it once did.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126672,'Not even shootin\' critters from a hot air balloon can cheer me up.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126673,'$n, you got any?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126674,'How \'bout you, $n?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126675,'Or even you, $n. Someone cheer me up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126676,'Ach... looks like we\'re gonna come in pretty close. Everybody wave hello to Thunder Totem!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126677,'Welcome aboard. Please sit back and enjoy the ride.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126678,'Below, you will see Crystalsong Forest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126679,'I\'m sad to say that despite all my travels, I never spent much time here. I couldn\'t tell you why.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126680,'Ahh... but I do have fond memories of my time here in Northrend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126681,'Just over that ridge lies Sholazar Basin. There I met tribes of wolvar and murloc oracles. Such strange creatures!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126682,'After all the journeys I\'ve been on, I still remember that day the most clearly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126683,'Please, pardon me for blathering on. No doubt the the tales of your own adventures are much more exciting!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126684,'Mages of the Tirisgarde need help investigating the Felborne occupying the Weeping Terrace. This wand may come in handy for removing their magical enhancements.','',0,0,0,0,0,0,0,0,0,0,82509,0,26124),
(126685,'','Netherlord, one of our warlocks has opened a portal to a Legion carrier brimming with demons. I suggest you show these vermin what it means to be the puppet of a greater power!',0,0,0,0,0,0,0,0,0,0,0,80683,26124),
(126686,'What about you, $n? To what exotic lands have you traveled?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126687,'And you, $n?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126688,'Or you, $n? What tales of exploration do you hold dear?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126689,'I\'ll let the three of you talk amongst yourselves. I need to make sure I don\'t crash this balloon into Dalaran.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126690,'MORE balloon riders? Fine, come on in... I guess.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126691,'This is the balloon ride to Halfhill. Please keep your hands and off-hands inside the basket at all times.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126692,'<Sigh>...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126693,'','Yes. Yes! YES! Not so fun to be on the receiving end, is it? Legion scum!',0,0,0,0,0,0,0,0,0,0,0,80684,26124),
(126694,'Below us, to the right, you will see Pang\'s Stead. Be sure to keep an eye out for...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126695,'You know what? That\'s it. I\'ve HAD it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126696,'I have a confession I\'d like to make to the three of you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126697,'I HATE balloons. Hated them all my life. All I ever wanted to do was be a shaman, but no! Apparently \"ballooning is in our blood\".','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126698,'Is this good enough for you, father? Huh? ARE YOU PROUD OF ME NOW, DAD?!?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126699,'...Whew.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126700,'Wow.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126701,'Feels good to get that off my chest. I\'ve never told that to anyone before.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126702,'Now you know my secret. What about you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126703,'$n, give it a try. Tell us something you\'ve never told another soul before. Go ahead.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126704,'How about you, $n? Do you have any secrets burning a hole in your heart?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126705,'I haven\'t forgotten about you, $n. Tell us a secret. We won\'t judge. This is a safe balloon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126706,'That was the most cathartic balloon ride I\'ve ever had. It was even sort of fun. Thanks, all of you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126707,'','Welcome aboard! Today I will be your guide on a tour of Stormheim.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126708,'','See all that stuff down there? That\'s... uh... that\'s Stormheim.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126709,'','Sorry, I\'m not a very experienced tour guide.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126710,'','So... any of you know some balloon party games?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126711,'','Ooh, ooh, I\'ve got one! It\'s called Kiss, Marry, Slay.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126712,'','It\'s easy. You just have to pick one person you would kiss, one you would marry, and one you would slay.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126713,'','I\'ll go first! Let\'s see...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126714,'','$n, you\'ve got a nice face, and it looks like you\'re the only one here who brushes $Ghis:her; teeth. I would kiss you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126715,'','Hmm... I would slay $n. For obvious reasons.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126716,'','And that leaves $n to marry! I could live with that.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126717,'','Okay, my turn\'s over. Somebody else go next!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126718,'','Alright, the balloon ride is over! That was FUN!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126719,'Greetings! Please step into the basket... and prepare for the most educational balloon ride of your life.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126720,'Today we will be taking a scenic balloon tour over the ancient city of Suramar.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126721,'But first, I will be taking attendance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126722,'$n? Is $n here?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126723,'Please, just say \"here\".','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126724,'Very well. Do we have a $n in attendance today?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126725,'I see. And, last on the list is $n. That must be you, correct?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126726,'Quite the talkative bunch. On with the tour!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126727,'Suramar, as we all know, is home to the Nightborne elves.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126728,'One must admit the magic of the Felborne possesses a certain... flare. A pity they abuse its potential. They met the end they deserved.','',0,0,0,0,0,0,0,0,0,0,82510,0,26124),
(126729,'Among other things, the Nightborne are known for being rather disagreeable.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126730,'$n, can you tell me what mind-altering substance the Nightborne use to relax?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126731,'The substance they consume is, of course, mana.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126732,'Consuming so much mana has had an effect on the Nightborne\'s bodies.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126733,'$n. What specific feature of Nightborne anatomy has been \"enhanced\" by excessive mana use?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126734,'Very close! The answer I was looking for was \"their skin\".','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126735,'Final question, for $n. What is the traditional greeting used in Suramar City?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126736,'Good guess! The correct answer is: \"An illusion! What are you hiding?\"','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126737,'That\'s all for today. Thank you for flying... and study up next time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126738,'','We need a victim... er... volunteer to go through a portal and thin the ranks of demons on the other side. Talk to Tehd, he can provide a loaner demon to get you started.',0,0,0,0,0,0,0,0,0,0,0,80687,26124),
(126739,'Hail, Highlord. Lord Grayson waits inside for your arrival.$b$bHe\'s currently overseeing the preparation for the purification of the barding.$b$bWhen you\'re ready to enter, I will escort you inside.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126740,'I\'m ready to go.','I\'m ready to go.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126741,'Spirits of the fallen cry out as Legion hounds drain their life essence. Free the spirits from their torment and purge the Legion filth!','',0,0,0,0,0,0,0,0,0,0,80564,0,26124),
(126742,'The Halls of Valor echo with the songs of those you rescued. Magnificently done!','',0,0,0,0,0,0,0,0,0,0,80565,0,26124),
(126743,'You must stop them...','You must stop them...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126744,'Had to... get away! Had to... warn you...','Had to... get away! Had to... warn you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126745,'Take me to the top of Black Rook Hold.','Take me to the top of Black Rook Hold.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126746,'There! The rifts are subsiding, but the portal remains too volatile to follow through.','',0,0,0,0,0,0,0,0,0,0,82552,0,26124),
(126747,'I can keep it open, but I\'ll need your help to stabilize it...','',0,0,0,0,0,0,0,0,0,0,82553,0,26124),
(126748,'Alright, I\'ll attempt to stabilize the portal. I hope you know what you\'re doing, $c!','',0,0,0,0,0,0,0,0,0,0,82554,0,26124),
(126749,'The runes seem to be working! The fel energy is subsiding...','',0,0,0,0,0,0,0,0,0,0,82555,0,26124),
(126750,'It is done.','',0,0,0,0,0,0,0,0,0,0,82556,0,26124),
(126751,'Have you figured out these runes yet? We don\'t have much time!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126752,'The runes are activated. Stabilize the portal.','The runes are activated. Stabilize the portal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126753,'Wait... something\'s wrong! I can\'t... control...','',0,0,0,0,0,0,0,0,0,0,82557,0,26124),
(126754,'Urgh!','',0,0,0,0,0,0,0,0,0,0,82558,0,26124),
(126755,'Send me to the terrace.','Send me to the terrace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126756,'Help us, $ct! The Legion is pushing us back!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126757,'Incoming!','',0,0,0,0,0,0,0,0,0,0,83023,0,26124),
(126758,'','My \"master\" ordered me to help you, so try not to die.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126759,'','Do you expect me to do ALL of the work?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126760,'','It died. Pity. I might have had a use for that one.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126761,'','Ugh, they do not build these demons like they used to.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126762,'','It is as if these demons can\'t handle a bit of whip...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126763,'','Oh, that was a mean one.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126764,'','Mmm. I suppose I should have told him the safe word.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126765,'','Ooo... giving up already?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126766,'','If you find a cloak on this on, I want it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126767,'','I am cold. My outfit was meant for inferno worlds mostly on fire.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126768,'','For being on a ship of the Burning Legion, it is not very warm here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126769,'','Tehd promised we could burn this place to ash.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126770,'','If you see the Cazarian here speak up. He and I have unfinished...business.',0,0,0,0,0,0,0,0,0,47524,0,0,26124),
(126771,'','Ugh, I hate these ships. So drab, not enough chains.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126772,'','So you mortals think you can win against the Legion? That is so precious. You are like an adorable collection of rodents that haven\'t noticed the large predator stalking you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126773,'','You should join me here sometime when I am not bound by my contract. Oh, the things I could show you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126774,'','You know, this whip isn\'t just for show. Say the word, break my contract, and I can show you what wonders it can do...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126775,'','I have waited a long time for this, Cazarian! Now the whip is in the other hand!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126776,'Happy Balloon Day! Interested in a balloon ride?','Happy Balloon Day! Interested in a balloon ride?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126777,'Yes!','Yes!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126778,'|TInterface\\Icons\\spell_fire_felrainoffire:20|t The Legion ship has started a |cFFFF0404|Hspell:235085|h[Fel Bombardment]|h|r! Watch out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(126779,'You have dealt a heavy blow to the Legion, $n. The cleansing has begun. I await your return.','',0,0,0,0,0,0,0,0,0,0,80412,0,26124),
(126780,'Champion! We\'ve spotted the wreckage of a Horde airship. Secure its cargo before the Legion does.','',0,0,0,0,0,0,0,0,0,0,81356,0,26124),
(126781,'Our troops will make good use of these supplies. Well done, champion.','',0,0,0,0,0,0,0,0,0,0,81357,0,26124),
(126782,'[PH] A Legion ship materializes in the distance.','[PH] A Legion ship materializes in the distance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126783,'Return me to the terrace.','Return me to the terrace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126784,'Enough of these games!','',0,0,0,0,0,0,0,0,0,0,82689,0,26124),
(126785,'Jubeka, are you there? Do not let them take me! I could not endure such a fate!','',0,0,0,0,0,0,0,0,0,0,81083,0,26124),
(126786,'','Protect me, my children! I will give you the power!',0,0,0,0,0,0,0,0,0,0,0,85207,26124),
(126787,'Fhambar has the scent. Meet him on the other side of the portal and he\'ll lead you to your missing mage.','',0,0,0,0,0,0,25,0,0,0,82549,0,26124),
(126789,'','Goldrinn has his prey cornered, but we should lend a hand. And by hand, I mean talon, claw... or other stabby thing!',0,0,0,0,0,0,0,0,0,0,0,80633,26124),
(126790,'','A fine hunt. Good work out there, Archdruid!',0,0,0,0,0,0,0,0,0,0,0,80634,26124),
(126791,'','Goldrinn needs our help! A demon decided to cheat the hunt by bringing in backup. Let\'s give him a taste of his own medicine!',0,0,0,0,0,0,0,0,0,0,0,80619,26124),
(126792,'','Thanks for the help! Those demons are like gnats compared to Goldrinn, but with so many of them, who knows what could have happened...',0,0,0,0,0,0,0,0,0,0,0,80620,26124),
(126793,'','Kill the Imp Servants before they energize Agatha!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(126794,'','Ugh! This demon invasion has destroyed so many habitats on the Broken Shore. The wildlife has nowhere to go!',0,0,0,0,0,0,0,0,0,0,0,81106,26124),
(126795,'','Crocolisks in Jagged Cove are encroaching on a sedge of saltwater cranes. Help me gather up those poor birdies so we can get them to safety!',0,0,0,0,0,0,0,0,0,0,0,81107,26124),
(126796,'Enough! I return to my slumber!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126797,'I tire of playing with the living.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126798,'So... sleepy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126799,'','We\'ll get the cranes to safety. One day, when the Broken Shore is free of demons, their chicks\' chicks can finally be returned home.',0,0,0,0,0,0,0,0,0,0,0,81105,26124),
(126800,'Fhambar patiently awaits the command to follow Levia\'s trail.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126801,'Go find Levia, Fhambar!','Go find Levia, Fhambar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126802,'Fhambar picks up Levia\'s trail!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126803,'Attention, sporelings! Honorary sporelings! Attend the spectacle of the growing of Fshoo!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126804,'Fshoo cannot survive long aboveground without your help. We need healers, medics, and mushroom-menders to protect her!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126805,'Fshoo comes!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126806,'Fshoo has withered. May her spores sail forever on the Zangar winds!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126807,'Your arrival is well-timed. I expect the attack to come at any moment. Before it does, let me urge the two of you to return to Bradensbrook. This doesn\'t need to be your fight!','',0,0,0,0,0,0,669,0,0,0,82365,0,26124),
(126808,'','No way I\'m staying behind! The attacks on my town must be stopped!',0,0,0,0,0,0,0,0,0,0,0,82467,26124),
(126809,'','Better to kill \'em here than have \'em tramplin\' my crops! Let\'s be about it, elf.',0,0,0,0,0,0,0,0,0,0,0,82478,26124),
(126810,'Lord Ravencrest may be derelict in his duties, but I am not. Soldiers, attack!','',0,0,0,0,0,0,0,0,0,0,82460,0,26124),
(126811,'','So the Kirin Tor wishes to send me more playthings?',0,0,0,0,0,0,0,0,0,0,0,81341,26124),
(126812,'','While Levia has kept me quite satisfied, it would be rude of me to turn down such a gift.',0,0,0,0,0,0,0,0,0,0,0,81342,26124),
(126813,'','Come then, $c. Entertain me.',0,0,0,0,0,0,0,0,0,0,0,81343,26124),
(126814,'Archmage, I was impressed to learn you captured the demon Kathra\'natir within the Nightborne Soulstone. Devising a containment shield that allows us to harness his power safely was ingenious!','',1,0,0,0,0,0,0,0,0,0,82775,0,26124),
(126815,'','NO! What have you done! I will make you suffer!',0,0,0,0,0,0,0,0,0,0,0,85206,26124),
(126816,'','My, you are a strong one. Breaking you will be ever so fun!',0,0,0,0,0,0,0,0,0,0,0,81344,26124),
(126817,'','No! It cannot be!',0,0,0,0,0,0,0,0,0,0,0,81345,26124),
(126818,'I fear for the lives of our allies if something is not done about this fel reaver.','',0,0,0,0,0,0,0,0,0,0,83280,0,26124),
(126819,'Well done! With the fel reaver destroyed, a heavy blow has been struck to the Legion\'s forces.','',0,0,0,0,0,0,0,0,0,0,83281,0,26124),
(126820,'','You shattered my illusion! Insolent wretch!',0,0,0,0,0,0,0,0,0,0,0,81346,26124),
(126821,'','I will hunt you down, $c! Mark my words!',0,0,0,0,0,0,0,0,0,0,0,81347,26124),
(126822,'','What... was... that!?',0,0,0,0,0,0,0,0,0,0,0,82492,26124),
(126823,'We can expect more defenders within. With Lord Ravencrest gone, I would wager Erdris now occupies his chambers. He always thought very highly of himself.','',0,0,0,0,0,0,1,0,0,0,82366,0,26124),
(126824,'Over here!','',0,0,0,0,0,0,1,0,0,0,82367,0,26124),
(126825,'This gate is closing--look out!','',0,0,0,0,0,0,1,0,0,0,82368,0,26124),
(126826,'','Uhhhh! My head...',0,0,0,0,0,0,1,0,0,0,0,82468,26124),
(126827,'You are mine!','',0,0,0,0,0,0,0,0,0,0,82790,0,26124),
(126828,'','Dag blast it!',0,0,0,0,0,0,22,0,0,0,0,82479,26124),
(126830,'Though employing Kathra\'natir\'s prison to power Dalaran\'s defenses may not be a long-term solution, I am relieved that the demon\'s essence remains contained. Come, let us return to the Hall of the Guardian.','',1,0,0,0,0,0,0,0,0,0,82776,0,26124),
(126831,'','You won\'t regret it, Archdruid! Ready to jump into action!',0,0,0,0,0,0,0,0,0,0,0,80828,26124),
(126832,'The tormented dead are heeding the call of their demonic masters. Strike them down!','',0,0,0,0,0,0,0,0,0,0,80673,0,26124),
(126833,'At every turn, the Burning Legion finds new ways to pervert the worlds they invade.','',0,0,0,0,0,0,0,0,0,0,80674,0,26124),
(126834,'Drown in flame!','',0,0,0,0,0,0,0,0,0,0,81398,0,26124),
(126835,'Your pet lich professes to have a plan that requires the bones of those sacrificed to the fel. Help him if you think it will aid our cause, but keep that... thing... in check.','',0,0,0,0,0,0,0,0,0,0,80658,0,26124),
(126836,'An intriguing use of necromancy. Dark magic has its uses.','',0,0,0,0,0,0,0,0,0,0,80659,0,26124),
(126837,'','Forgive me, Highlord. I... I need some time alone with my thoughts.',0,0,0,0,0,0,1,0,0,0,0,82665,26124),
(126838,'Ah! Excellent specimens, Deathlord. Here, you may find this useful.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126839,'Help! I am under attack!','Help! I am under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126840,'Citizens, aid me!','Citizens, aid me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126841,'Assassins are here!','Assassins are here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126842,'You will not take me down, villain!','You will not take me down, villain!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126843,'Spies sent from the Legion are here!','Spies sent from the Legion are here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126844,'Help! Help!','Help! Help!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126845,'Death comes for me!','Death comes for me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126846,'A rogue has infiltrated our city!','A rogue has infiltrated our city!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126847,'[OLD DNT] Quickly, $ct, we need you on the front lines!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126848,'Gll grm grmurrmr?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126849,'Useless! Stand aside while I do what you cannot, brother.','',0,0,0,0,0,0,0,0,0,0,82347,0,26124),
(126850,'Once again I must clean up your mess, brother!','',0,0,0,0,0,0,0,0,0,0,82348,0,26124),
(126851,'','Be... behind you...',0,0,0,0,0,0,0,0,0,0,0,82490,26124),
(126852,'','Send Modera my regards, $c. And... thank you.',0,0,0,0,0,0,1,0,0,0,0,82491,26124),
(126853,'You will not stop us!','',0,0,0,0,0,0,5,0,0,0,82737,0,26124),
(126854,'How pathetic! Syrenne has taken to compelling outsiders to do her bidding?','',0,0,0,0,0,0,5,0,0,0,82738,0,26124),
(126855,'<Beckon the tadpole to follow you.>','<Beckon the tadpole to follow you.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126856,'Lexera does not take kindly to those who meddle in her business!','',0,0,0,0,0,0,5,0,0,0,82739,0,26124),
(126857,'Foolish mortals! Did you truly believe the Burning Legion would be so easily defeated?','',0,0,0,0,0,0,0,0,4,0,81399,0,26124),
(126858,'The Feltotem tauren are defiling the bodies of the fallen. No one deserves this fate. Lay them to rest, champion.','',0,0,0,0,0,0,0,0,0,0,80627,0,26124),
(126859,'They gave their lives willingly, and have earned their rest. You have done well.','',0,0,0,0,0,0,0,0,0,0,80628,0,26124),
(126860,'Prisoners are being held in this area. Do whatever you must to free them, champion!','',0,0,0,0,0,0,0,0,0,0,83278,0,26124),
(126861,'Thanks to your efforts, the prisoners have both their freedom and their lives. Well done.','',0,0,0,0,0,0,0,0,0,0,83279,0,26124),
(126862,'You made it! Praise Elune! I doubt we had much time left.','',0,0,0,0,0,0,0,0,0,0,82360,0,26124),
(126863,'Prepare yourselves. Erdris has been bewitched by the Legion and sees only enemies.','',0,0,0,0,0,0,1,0,0,0,82361,0,26124),
(126864,'Hold a moment and catch your breath. Then we move.','',0,0,0,0,0,0,1,0,0,0,82362,0,26124),
(126866,'Behold the power of the fel!','',0,0,0,0,0,0,0,0,4,0,81400,0,26124),
(126867,'Careful, champion. Something is emerging from the portal... something powerful!','',0,0,0,0,0,0,0,0,4,0,81407,0,26124),
(126868,'Let us be about it, then.','',0,0,0,0,0,0,1,0,0,0,82363,0,26124),
(126869,'I cannot allow you to menace the living any longer, Erdris!','',0,0,0,0,0,0,25,0,0,0,82364,0,26124),
(126870,'Arise, soldiers! Embrace my gift and bring an end to the Legion!','',0,0,0,0,0,0,5,0,0,0,82459,0,26124),
(126871,'When the Legion vessel fell, it released what remained of the souls used in its creation. These souls wail in agony, lost in ceaseless pain. Please, free them from this torment!','',0,0,0,0,0,0,0,0,0,0,80675,0,26124),
(126872,'A spirit can endure much, but being consumed over time by fel energies is torment beyond the mortal mind\'s comprehension.','',0,0,0,0,0,0,0,0,0,0,80676,0,26124),
(126873,'The hold is... lost...','',0,0,0,0,0,0,0,0,0,0,82461,0,26124),
(126874,'I hope you have found peace, commander.','',0,0,0,0,0,0,0,0,0,0,82475,0,26124),
(126875,'Thank you, $n. We stopped the Legion from driving a wedge into our forces. The Kirin Tor will be pleased to learn of our victory. They gave me something to see your way back to them.','',0,0,0,0,0,0,0,0,0,0,82476,0,26124),
(126876,'','Pleasure working with you! Thanks for saving our town.',0,0,0,0,0,0,0,0,0,0,0,82469,26124),
(126877,'','Stop by Bradensbrook once in a while, plenty of birds left to shoot down!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126878,'','Act quickly! The Legion will soon overrun us.',0,0,0,0,0,0,0,0,0,0,0,80485,26124),
(126879,'','Champion, I\'m glad I reached you. As Victoria no doubt informed you, we have located the imp mother, Agatha.',0,0,0,0,0,0,0,0,0,0,0,81388,26124),
(126880,'','By now, she has likely harnessed much of the power she stole from Levia. If so, there\'s no telling what she\'s capable of.',0,0,0,0,0,0,0,0,0,0,0,81389,26124),
(126881,'','Her location is well shielded, but our Kirin Tor mages should be able to open a portal to her for a short time.',0,0,0,0,0,0,0,0,0,0,0,81390,26124),
(126882,'','The imp mother must be stopped! Good luck, champion.',0,0,0,0,0,0,0,0,0,0,0,81391,26124),
(126883,'Felbats! I detest those winged fiends! Not only do they harass our forces, they breed like rabbits. We need to thin their numbers!','',0,0,0,0,0,0,0,0,0,0,85213,0,26124),
(126884,'','You are too late! Levia\'s power is mine! Using her knowledge, my minions will infiltrate the Kirin Tor and dismantle it from the inside!',0,0,0,0,0,0,0,0,0,0,0,81348,26124),
(126885,'','Even now, my sayaad tempt your weak-willed mages. Your allies will surrender willingly to the Legion!',0,0,0,0,0,0,1,0,0,0,0,81349,26124),
(126886,'','But first, you must be punished for taking away my little pet.',0,0,0,0,0,0,1,0,0,0,0,85036,26124),
(126887,'You have safeguarded our forces from a most unpleasant aerial assault. Hmm, perhaps the Illidari can make use of the juveniles you scared off...','',0,0,0,0,0,0,0,0,0,0,85212,0,26124),
(126888,'','No... My pretties!',0,0,0,0,0,0,1,0,0,0,0,81351,26124),
(126889,'','You\'ll... pay for this! You\'ll... pay...',0,0,0,0,0,0,0,0,0,0,0,81352,26124),
(126890,'A grim and dangerous task awaits us, $n. These two demanded to come along to \"make sure we got it done right\". They should not have to do this.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126891,'Let us deal with Commander Erdris. (use Jarod\'s free keystone.)','Let us deal with Commander Erdris. (use Jarod\'s free keystone.)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126892,'Let us deal with Commander Can\'tomas. (requires Brimming Keystone)','Let us deal with Commander Can\'tomas. (requires Brimming Keystone)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126893,'Welcome, Highlord $p. I\'ve been making preparations for the ritual to cleanse the barding. But so far, we\'ve been unable to secure the holy water.','',0,0,0,0,0,0,1,0,0,0,82493,0,26124),
(126894,'I sent in three of my best men to search for it, but they\'ve not returned. I fear for their safety.','',0,0,0,0,0,0,1,0,0,0,82494,0,26124),
(126895,'Perhaps someone of your skills would be better suited to recover the water. Please, take a pair of my paladins with you. Who knows what\'s still lurking in this place.','',0,0,0,0,0,0,1,0,0,0,82495,0,26124),
(126896,'Your quest here is futile, paladin! This city shall spread death once again...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126897,'This city belongs to the dead! And soon, so shall you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126898,'You\'re too late to save your allies, paladin. Their souls fuel my army...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126900,'Osseine shall grant you a swift death!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126901,'Take in the fumes of Pestulon and become one with my army!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126902,'Feast on their entrails, Rotmouth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126903,'They swarmed us. I... I tried to fight, but... Thank you Highlord for saving me.','They swarmed us. I... I tried to fight, but... Thank you Highlord for saving me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126904,'It felt like my soul was being slowly ripped from my body. The necromancer, he... I must get to Grayson.','It felt like my soul was being slowly ripped from my body. The necromancer, he... I must get to Grayson.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126905,'It\'s over?! Is this real? Highlord, it\'s you... I... I think I can make my way back. Thank you.','It\'s over?! Is this real? Highlord, it\'s you... I... I think I can make my way back. Thank you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126906,'Excellent job recovering the water, Highlord. And you have my deepest thanks for saving my paladins.','',0,0,0,0,0,0,1,0,0,0,82496,0,26124),
(126907,'I\'ll apply the water to the barding. The rest, Highlord, lies with you and your weapon.','',0,0,0,0,0,0,1,0,0,0,82497,0,26124),
(126908,'It is done! The barding is ready. Now we go to Rivendare\'s crypt to confront his specter.','',0,0,0,0,0,0,1,0,0,0,82498,0,26124),
(126909,'MOUNT UP, PALADINS! WE RIDE!','',0,0,0,0,0,0,22,0,0,0,82499,0,26124),
(126910,'They\'ll bring up the rear while we\'re inside dealing with Rivendare.','',0,0,0,0,0,0,1,0,0,0,82500,0,26124),
(126911,'Where is his body?! It should be here!','',0,0,0,0,0,0,1,0,0,0,82501,0,26124),
(126912,'Someone\'s taken it! This does not bode well...','',0,0,0,0,0,0,1,0,0,0,82502,0,26124),
(126913,'LOOKING FOR SOMETHING?! HA HA HA!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126914,'You and your pathetic rabble will be added to my ranks of undead!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126915,'I, Raemien shall spread the plague over this land once more and all will bow before me!','',0,0,0,0,0,0,53,0,0,0,0,0,26124),
(126916,'The horse! Quickly, contain it!','',0,0,0,0,0,0,0,0,0,0,82503,0,26124),
(126918,'The beast is bound, Highlord! The Light has favored us this day!','',0,0,0,0,0,0,1,0,0,0,82504,0,26124),
(126919,'Let us reconvene at the Sanctum of Light. There you can bard the beast safely.','',0,0,0,0,0,0,1,0,0,0,82505,0,26124),
(126920,'When you\'re ready to leave, speak with me and I\'ll see to our safe return.','',0,0,0,0,0,0,1,0,0,0,82506,0,26124),
(126921,'Let me know when you\'re ready to return to the order hall, Highlord and I\'ll see to our safe return there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126922,'I\'m ready to return, Grayson.','I\'m ready to return, Grayson.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126923,'Send me to Shadowsong. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','Send me to Shadowsong. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126924,'The naga pose a persistent threat to our efforts. We\'ve subdued one of their brutes to use against them. Ride it into battle against the naga!','',0,0,0,0,0,0,0,0,0,0,81364,0,26124),
(126925,'Well done. Turning the might of those big bruisers against their own was a... smashing idea!','',0,0,0,0,0,0,0,0,0,0,81365,0,26124),
(126926,'I... I live, but I\'m in no condition for battle. Hurry, champion, you must stop him!','',0,0,0,0,0,0,0,0,6,0,81408,0,26124),
(126927,'Alright, let\'s get this barding upgraded!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126928,'First I gotta just smelt all this ore...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126929,'Now if I just hammer the leystone in here... aaand here...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126930,'And last but not least, the jewel!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126931,'And there she is! Some of my finest work, if I do say so myself! You may take it now.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126932,'I\'m sure Grayson will be pleased to see what we accomplished. Send him my best.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(126933,'','Train or perish. Out here, there are no second chances.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126934,'','Do you really believe your companions are ready to join our assault?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126935,'While patience is a virtue, we no longer can afford its luxury. Prepare yourself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126936,'Here are the materials you asked for, Alard.','Here are the materials you asked for, Alard.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126937,'Again? It will take me ages to put this armor back on. Hmph.','Again? It will take me ages to put this armor back on. Hmph.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126938,'The Legion is retreating! Leap from their vessel! Trust the hippogryphs to catch you!','',0,0,0,0,0,0,0,0,0,0,80407,0,26124),
(126939,'Enough of this!','',0,0,0,0,0,0,378,0,0,0,81401,0,26124),
(126940,'Descend upon our enemy and break their foothold on this plane! Leave them no ground to cling to and show them no quarter!','',0,0,0,0,0,0,0,0,0,0,80641,0,26124),
(126941,'At most we have slowed our enemy. There will be more, and we must be ready.','',0,0,0,0,0,0,0,0,0,0,80642,0,26124),
(126942,'Your actions have awoken the spirits!','Your actions have awoken the spirits!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(126943,'Thank you, Grand Master.','Thank you, Grand Master.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126944,'I was getting weaker by the second! Thank you.','I was getting weaker by the second! Thank you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126945,'I\'m getting out of here!','I\'m getting out of here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126946,'An aranasi has seized our troops to feed her deadly brood. Grandmaster, we must rely on your ability to slay that demon and Detox the captives to save them from the poison!','',0,0,0,0,0,0,0,0,0,0,83123,0,26124),
(126947,'Our troops are arriving back at camp safe, sound, and most importantly, free of poison. Well done!','',0,0,0,0,0,0,0,0,0,0,83124,0,26124),
(126948,'Our troops were carried away by an aranasi to feed her foul brood! Kill these arachnids and gather their venom sacs so we can develop a cure to their toxins.','',0,0,0,0,0,0,0,0,0,0,83121,0,26124),
(126949,'Thanks to your help, we can now develop a reliable cure for this poison.','',0,0,0,0,0,0,0,0,0,0,83122,0,26124),
(126950,'Let us begin.','Let us begin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126951,'Pitiful.','Pitiful.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126952,'It seems you are ready.','It seems you are ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126953,'Again!','Again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126954,'Try harder.','Try harder.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126955,'Don\'t give up.','Don\'t give up.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126956,'Excellent strategy.','Excellent strategy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126957,'You\'re improving.','You\'re improving.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126958,'Good, but can you do it again?','Good, but can you do it again?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126961,'The Burning Legion dares to assault Stormheim! Remove their foul presence from this land, champion, and glory shall be yours!','',0,0,0,0,0,0,0,0,0,0,81403,0,26124),
(126962,'The Legion tricked us! Their attacks were merely a diversion while they established a foothold upon the isle of Shield\'s Rest!','',0,0,0,0,0,0,0,0,0,0,81404,0,26124),
(126964,'Champion! Hold the line against the Legion\'s forces. Join our allies on the front and stand your ground!','',0,0,0,0,0,0,0,0,0,0,80667,0,26124),
(126965,'Rest for now, hero. You have earned it.','',0,0,0,0,0,0,0,0,0,0,80668,0,26124),
(126966,'Hello, $c, do you wish to research more about your artifact? \n\nI would like to assist you, but it appears you might still be carrying Artifact Research Notes. Reading them will further your knowledge.','Hello, $c, do you wish to research more about your artifact? \n\nI would like to assist you, but it appears you might still be carrying Artifact Research Notes. Reading them will further your knowledge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126967,'Alright, let\'s show these bozos a trick or two.','',0,0,0,0,0,0,0,0,0,0,80798,0,26124),
(126968,'I got the spells if you got the coin!','',0,0,0,0,0,0,0,0,0,0,80799,0,26124),
(126969,'The Great Akazamzarak is ready for action!','',0,0,0,0,0,0,0,0,0,0,80800,0,26124),
(126970,'Ruins as old as these are packed with rarities that would delight any collector. Recover whatever relics ye can, but beware o\' the spirits still lingerin\' about!','',0,0,0,0,0,0,0,0,0,0,80662,0,26124),
(126971,'I\'ve got an ace up my sleeve!','',0,0,0,0,0,0,0,0,0,0,80801,0,26124),
(126972,'I think we\'ve done enough relic huntin\' fer one day. Let\'s give the spirits time ta settle down. Enjoy yer spoils!','',0,0,0,0,0,0,0,0,0,0,80663,0,26124),
(126973,'Let\'s go, everyone! We\'re heading to the next tavern!','Let\'s go, everyone! We\'re heading to the next tavern!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126974,'Last call! I\'m opening a portal to the next tavern!','Last call! I\'m opening a portal to the next tavern!',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(126975,'Welcome, welcome! Help yourself to some free drinks and food.','Welcome, welcome! Help yourself to some free drinks and food.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126976,'Pick a card, any card!','',0,0,0,0,0,0,0,0,0,0,80802,0,26124),
(126977,'Need a hand?','',0,0,0,0,0,0,0,0,0,0,80803,0,26124),
(126978,'','Damn them! Let\'s go!',1,0,0,0,0,0,0,0,0,0,0,82831,26124),
(126979,'Prepare to eat fluffy, cotton-tailed death!','',0,0,0,0,0,0,0,0,0,0,80804,0,26124),
(126980,'Oh, I got a trick for you, pal!','',0,0,0,0,0,0,0,0,0,0,80805,0,26124),
(126981,'We can still be friends.','We can still be friends.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126982,'I better be getting hazard pay for this...','',0,0,0,0,0,0,0,0,0,0,80806,0,26124),
(126983,'It\'s not you, it\'s me.','It\'s not you, it\'s me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126984,'Yeah, I know I\'m good.','',0,0,0,0,0,0,0,0,0,0,80807,0,26124),
(126985,'We should see other people.','We should see other people.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126986,'I really should start charging by the corpse.','',0,0,0,0,0,0,0,0,0,0,80808,0,26124),
(126987,'That\'s what you get for not leaving a tip!','',0,0,0,0,0,0,0,0,0,0,80809,0,26124),
(126988,'It was only the one time.','It was only the one time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126989,'I\'m billing you... for my repairs.','',0,0,0,0,0,0,0,0,0,0,80810,0,26124),
(126990,'It was only the one time.','It was only the one time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126991,'I thought it was you!','I thought it was you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126992,'I\'m just not that into you.','I\'m just not that into you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126993,'We are never ever getting back together.','We are never ever getting back together.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126994,'I can do better.','I can do better.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(126995,'Ow! Stop hitting me! Hit the hero!','',0,0,0,0,0,0,0,0,0,0,80811,0,26124),
(126996,'I\'m charging extra for this...','',0,0,0,0,0,0,0,0,0,0,80812,0,26124),
(126997,'Hope you don\'t mind if I take a cut.','',0,0,0,0,0,0,0,0,0,0,80813,0,26124),
(126998,'Screw this, I\'m making my own mage order... with Hearthstone... and succubi! On second thought, forget the mage order!','',0,0,0,0,0,0,0,0,0,0,80814,0,26124),
(126999,'It is said that the remains of those buried in these ruins have magical properties. Let us put these rumors to the test! Recover their ancient bones and place them upon the ruined altar.','',0,0,0,0,0,0,0,0,0,0,80639,0,26124),
(127000,'You should get checked.','You should get checked.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127001,'How magnificent! Enjoy your creation before the magic fades.','',0,0,0,0,0,0,0,0,0,0,80640,0,26124),
(127002,'You ever need another one of those, come talk to me. I\'ll hook you up.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127003,'','The spirits within these ruins are bound to the Burning Legion through an ancient pact. Lay them to rest so that they may know peace.',0,0,0,0,0,0,0,0,0,0,0,80685,26124),
(127004,'','Well done, champion. May their spirits finally know peace.',0,0,0,0,0,0,0,0,0,0,0,80686,26124),
(127005,'','Highlord, the weapon you wield is needed to free these felbound spirits. Destroy their pendants and release my ancestors from their ancient curse.',0,0,0,0,0,0,0,0,0,0,0,80681,26124),
(127006,'','Thank you, Highlord. You have brought peace to my ancestors.',0,0,0,0,0,0,0,0,0,0,0,80682,26124),
(127009,'','You are right, S\'theno. Either we risk it or we are dead anyway. Slayer $n, we need to get to the main console upstairs!',0,0,0,0,0,0,0,0,0,0,0,82832,26124),
(127010,'','Cue awesome scene of the Fel Hammer destroying one of the Legion ships and the others jumping away!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(127011,'','They should never have gotten sso close, Malevolence. Why did the Fel Hammer not fire on them?',1,0,0,0,0,0,0,0,0,0,0,82589,26124),
(127012,'','This is no time for nasty insinuations, S\'theno my dear. They took out our weapons first thing. If you help kill these foul creatures, we can see about making repairs!',1,0,0,0,0,0,0,0,0,0,0,81491,26124),
(127013,'','Cease your bickering! We have a ship to save!',1,0,0,0,0,0,0,0,0,0,0,82833,26124),
(127014,'Why can\'t I send out the call for another Vanguard?','Why can\'t I send out the call for another Vanguard?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127015,'Apologies, we only have enough troops to have a single Vanguard ready for deployment at a time. Once you have given your orders, we will be able to request another.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127016,'','Well, that was unfortunate. Surely someone with your skills can revive him?',0,0,0,0,0,0,1,0,0,0,0,81086,26124),
(127017,'There are dangers ahead, traveler. A sickness has taken over the area.','There are dangers ahead, traveler. A sickness has taken over the area.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(127018,'Why am I unable to rally the Val\'kyr?','Why am I unable to rally the Val\'kyr?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127019,'','I\'m sorry, we cannot rally another assault until you have deployed your currently assembled troops.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127020,'Why can we not summon another Infernal?','Why can we not summon another Infernal to unleash?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127021,'','Infernals are tricky things, and extremely powerful. We must be cautious with them. You still have a Phylactery in your possession, it would be foolhardy to hold more.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127022,'Why are we not able to focus another crystal?','Why are we not able to focus another crystal?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127023,'','The Might of Dalaran can only be channeled once. You appear to still have a Focusing Crystal in your possession. Once you have unleashed it, my mage\'s will be able to form another for you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127024,'You\'re too late, mortal! My command center has just arrived!','',0,0,0,0,0,0,0,0,0,0,81395,0,26124),
(127025,'Why are we unable to power the Rift Core?','Why are we unable to power the Rift Core?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127026,'Harpies are distasteful enough, but harpies pledged to the Legion? Intolerable! Keep this new threat under control, champion.','',0,0,0,0,0,0,0,0,0,0,81353,0,26124),
(127027,'','We are simply not prepared to have multiple Rift Cores at once. You still have one in your possession. Once you have unleashed it, we will begin charging another.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127028,'It seems you\'ve curbed their population growth. Good! We don\'t want such abominations spreading beyond these shores.','',0,0,0,0,0,0,0,0,0,0,81354,0,26124),
(127029,'Why are we unable to start another ritual?','Why are we unable to start another ritual?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127030,'The Frost Crux is an item of immense power. It would be foolish to attempt to have more than one in your possession. Once you have unleashed the Frost Wyrm, we will be able to summon another.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127031,'Prepare yourselves! The Legion will stop at nothing to capture this prize.','Prepare yourselves! The Legion will stop at nothing to capture this prize.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127032,'We are ready.','We are ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127037,'Gunners, open fire upon this mortal scum! Obliterate them with hellfire!','',0,0,0,0,0,0,0,0,0,0,81397,0,26124),
(127038,'Ready your blades! The demons come!','Ready your blades! The demons come!',0,0,0,0,0,0,0,0,0,47714,0,0,26124),
(127039,'The Aegis of Aggramar must be set in place. We begin on your signal, heroes!','',0,0,0,0,0,0,0,0,0,0,80476,0,26124),
(127044,'You have my thanks.','You have my thanks.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(127045,'The pain has lessened. Thank you, $n.','The pain has lessened. Thank you, $n.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(127046,'The fog is finally lifting...','The fog is finally lifting...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(127047,'I am in your debt.','I am in your debt.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(127048,'Your compassion will not be forgotten.','Your compassion will not be forgotten.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(127049,'I owe you my life, priest.','I owe you my life, priest.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(127050,'I\'d better get back to the fight.','I\'d better get back to the fight.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(127051,'My vessel and I are needed elsewhere. Enjoy this... parting gift!','',0,0,0,0,0,0,378,0,0,0,81396,0,26124),
(127052,'Bring down the monstrosity! Nothing gets through!','Bring down the monstrosity! Nothing gets through!',0,0,0,0,0,0,0,0,0,47714,0,0,26124),
(127053,'Champion! Our mages have pinpointed the location of Raest Magespear within the Twisting Nether!','',0,0,0,0,0,0,0,0,0,0,83096,0,26124),
(127054,'We have little information to work from, but it seems he found a way to use the energy of the Twisting Nether to enhance his necromantic magic.','',0,0,0,0,0,0,0,0,0,0,83097,0,26124),
(127055,'Karam insisted on being sent in ahead of you, but I fear he cannot face this challenge alone.','',0,0,0,0,0,0,0,0,0,0,83098,0,26124),
(127056,'We will open a portal to his location, but can\'t hold it open long. Raest must be stopped!','',0,0,0,0,0,0,0,0,0,0,83099,0,26124),
(127057,'','Be shielded, heroes!',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(127058,'','Must you always be so close, Roland?',0,0,0,0,0,0,1,0,0,0,0,81088,26124),
(127059,'','Surely you have other places to be, Roland?',0,0,0,0,0,0,1,0,0,0,0,81089,26124),
(127060,'','Doesn\'t this place remind you of home?',0,0,0,0,0,0,1,0,0,0,0,81090,26124),
(127061,'Eredar conjurers are amassing dark forces from the Void. Stop them!','',0,0,0,0,0,0,0,0,0,0,80671,0,26124),
(127062,'This world is dark enough without bringing more shadow into it. You have my thanks, champion.','',0,0,0,0,0,0,0,0,0,0,80672,0,26124),
(127063,'','Come, Roland. Let us leave this vile place before you get yourself sick again.',0,0,0,0,0,0,1,0,0,0,0,81091,26124),
(127064,'|TInterface\\Icons\\SPELL_NATURE_UNRELENTINGSTORM.BLP:20|t%s begins casting |cFFFF0000|Hspell:235766|h[Lightning Nova]|h|r !','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127065,'','Shadowblade! Over here!',0,0,0,0,0,0,3,0,0,0,0,81244,26124),
(127066,'','I consider myself an adept hunter of the undead, and even I didn\'t notice at first.',0,0,0,0,0,0,0,0,0,0,0,81245,26124),
(127067,'','But look what happens when I slice right here...',0,0,0,0,0,0,0,0,0,0,0,81246,26124),
(127068,'','It\'s not supposed to do that, and it\'s REALLY not supposed to be that color.',0,0,0,0,0,0,25,0,0,0,0,81247,26124),
(127069,'','He spoke in coherent thoughts, and his skin... so well-preserved. But a few telltale signs gave him away.',0,0,0,0,0,0,1,0,0,0,0,81248,26124),
(127070,'','It seems Legion dreadlords have found a way to craft undead operatives so lifelike that even I have difficulty detecting them!',0,0,0,0,0,0,0,0,0,0,0,81249,26124),
(127071,'','The demons knew the Illidari would find them if they tried to infiltrate our cities again, so they sent in these... homunculi.',0,0,0,0,0,0,0,0,0,0,0,81250,26124),
(127072,'','Our agents have identified suspected homunculi in Silvermoon and the Exodar.',0,0,0,0,0,0,1,0,0,0,0,81251,26124),
(127073,'','We can\'t risk you carrying out an assassination in an ally\'s city, but no one will question you taking down a target in Silvermoon. While you handle that mark, I\'ll head to the Exodar.',0,0,0,0,0,0,274,0,0,0,0,81252,26124),
(127074,'','Remember... even though you\'re trying to help them, the Horde will assume you\'re attacking one of their own.',0,0,0,0,0,0,1,0,0,0,0,81254,26124),
(127075,'','Your first mark has established himself as a wealthy aristocrat who parades around the city in plain view. Be wary of his arcane golem! Separate them if you can... and keep it quiet.',0,0,0,0,0,0,0,0,0,0,0,81256,26124),
(127076,'','Ah, a clean twist of the knife... delightful! Your next mark awaits in the Undercity. I suggest entering from the sewers to the west.',0,0,0,0,0,0,0,0,0,0,0,81258,26124),
(127077,'','Your mark is having a tea party in the terrace above the Rogues\' Quarter. Be wary! Her allies are powerful spellcasters, as is she. You\'ll need to find a way to get up there.',0,0,0,0,0,0,0,0,0,0,0,81260,26124),
(127078,'','That death scream... pure music! We have located the next mark in Thunder Bluff, hiding in the shadow of the tauren leader.',0,0,0,0,0,0,0,0,0,0,0,81262,26124),
(127079,'','There he is, by the bonfire. I hear he is a coward who trusts in his armor to protect him. Demonstrate how wrong he is!',0,0,0,0,0,0,0,0,0,0,0,81264,26124),
(127080,'','Mmm, delicious... like a knife in the dark! Your final mark will be found in Orgrimmar. This will be the most challenging target yet!',0,0,0,0,0,0,0,0,0,0,0,81266,26124),
(127081,'','There! In the most crowded place imaginable---the auction house. Be silent, strike true, and vanish quickly!',0,0,0,0,0,0,0,0,0,0,0,81268,26124),
(127082,'','Poor, pathetic marks! There\'s no place they can hide that the shadows cannot find them. Come, pay your colleagues a visit. Lord Ravenholdt has a gift for you.',0,0,0,0,0,0,0,0,0,0,0,81269,26124),
(127083,'','We can\'t risk you carrying out an assassination in an ally\'s city, but no one will question you taking down a target in the Exodar. While you handle that mark, we\'ll see to the matter in Silvermoon.',0,0,0,0,0,0,274,0,0,0,0,81253,26124),
(127084,'','Remember... even though you\'re trying to help them, the Alliance will assume you\'re attacking one of their own.',0,0,0,0,0,0,1,0,0,0,0,81255,26124),
(127085,'','Your first mark wears the guise of a humble priest, walking through the city in plain view. Be wary of his crystal golem! Separate them if you can... and keep it quiet.',0,0,0,0,0,0,0,0,0,0,0,81257,26124),
(127086,'','Ah, a clean twist of the knife... delightful! Your next mark will be found in Darnassus. I suggest entering through the village below Teldrassil.',0,0,0,0,0,0,0,0,0,0,0,81259,26124),
(127087,'','Your mark is throwing a garden party near the Warrior\'s Terrace. Be wary! Her allies are powerful spellcasters, as is she. And mind the guards.',0,0,0,0,0,0,0,0,0,0,0,81261,26124),
(127088,'','That death scream... pure music! We have located the next mark in Ironforge, hiding in the shadows of the dwarven council.',0,0,0,0,0,0,0,0,0,0,0,81263,26124),
(127089,'','There he is, against the wall. I hear he is a coward who trusts in his armor to protect him. Demonstrate how wrong he is!',0,0,0,0,0,0,0,0,0,0,0,81265,26124),
(127090,'','Mmm, delicious... like a knife in the dark! Your final mark will be found in Stormwind. This will be the most challenging target yet!',0,0,0,0,0,0,0,0,0,0,0,81267,26124),
(127091,'|TInterface\\Icons\\ABILITY_HUNTER_PET_RAPTOR.BLP:20|t%s |cFFFF0000|Hspell:235886|h[calls]|h|r to her pack!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127092,'','Chin up, Roland. It appears help has arrived.',0,0,0,0,0,0,1,0,0,0,0,81087,26124),
(127093,'What... what happened?','What... what happened?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127094,'My head... get... get away from that thing!','My head... get... get away from that thing!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127095,'I... I couldn\'t stop myself...','I... I couldn\'t stop myself...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127096,'We must not falter, regardless of what the demons do.','We must not falter, regardless of what the demons do.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127097,'','You made a wise choice. We will accomplish much together.',0,0,0,0,0,0,1,0,0,0,0,80720,26124),
(127099,'Raest may have escaped, but we will track him down. When that day comes, I hope I can count on your help once again.','',0,0,0,0,0,0,1,0,0,0,82272,0,26124),
(127100,'Orgrimmar Invaders Slain: $1i','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127101,'Defender of Orgrimmar','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127102,'You will not leave here alive!','',0,0,0,0,0,0,1,0,0,0,82787,0,26124),
(127103,'The Burning Legion cannot be stopped!','',0,0,0,0,0,0,1,0,0,0,82788,0,26124),
(127104,'The contagion will consume you!','',0,0,0,0,0,0,1,0,0,0,82789,0,26124),
(127105,'Heroic Defender of Orgrimmar','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127106,'Mythic Defender of Orgrimmar','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127107,'Defender of Thunder Bluff','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127108,'Heroic Defender of Thunder Bluff','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127109,'Mythic Defender of Thunder Bluff','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127110,'Defender of Undercity','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127111,'Heroic Defender of Undercity','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127112,'Mythic Defender of Undercity','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127113,'Defender of Silvermoon','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127114,'Heroic Defender of Silvermoon','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127115,'Mythic Defender of Silvermoon','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127116,'Defender of Warspear','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127117,'Heroic Defender of Warspear','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127118,'Mythic Defender of Warspear','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127119,'Defender of Stormwind','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127120,'Heroic Defender of Stormwind','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127121,'Mythic Defender of Stormwind','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127122,'Defender of Ironforge','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127123,'Heroic Defender of Ironforge','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127124,'Mythic Defender of Ironforge','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127125,'Defender of Darnassus','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127126,'Heroic Defender of Darnassus','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127127,'Mythic Defender of Darnassus','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127128,'Defender of the Exodar','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127129,'Heroic Defender of the Exodar','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127130,'Mythic Defender of the Exodar','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127131,'Defender of Stormshield','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127132,'Heroic Defender of Stormshield','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127133,'Mythic Defender of Stormshield','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127134,'Thunder Bluff Invaders Slain: $1i','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127135,'Undercity Invaders Slain: $1i','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127136,'Silvermoon Invaders Slain: $1i','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127137,'Warspear Invaders Slain: $1i','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127138,'Stormwind Invaders Slain: $1i','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127139,'Ironforge Invaders Slain: $1i','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127140,'Darnassus Invaders Slain: $1i','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127141,'Exodar Invaders Slain: $1i','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127142,'Stormshield Invaders Slain: $1i','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127143,'We fight together.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127144,'The Brotherhood stands as one!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127145,'Let us cleanse some darkness from this land.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127146,'Fear my blade!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127147,'For the Brotherhood!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127148,'Fall before the Light!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127149,'At your side.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127150,'Let us journey together.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127151,'It is an honor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127152,'I will... return...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127153,'I must fall back.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127154,'Argh, don\'t kill too many without me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127155,'Behold the Light!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127156,'The Brotherhood leads the charge!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127157,'The Light prevails!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127158,'You will not interfere with our plans. Kanrethad\'s power will belong to the Burning Legion! Fall before our might!','',0,0,0,0,0,0,0,0,0,0,82687,0,26124),
(127159,'We will not be stopped!','',0,0,0,0,0,0,0,0,0,0,82688,0,26124),
(127160,'','We cannot let the Burning Legion succeed.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(127161,'','Odyn was a fool to choose you as his champion.',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(127162,'','It will be amusing to see his shame when you fall.',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(127163,'','Your kind should not be here. This land is OURS, and only we are worthy of entering this tournament!',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(127164,'','I wonder if your name will be remembered after you\'ve failed...',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(127165,'Your size probably matches your strength. Puny.','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(127166,'I\'d let you work out with me, but these weights are as big as you. Come back when you grow muscles.','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(127167,'It\'s alright if you want to leave. Most of my opponents lose as soon as they look at me.','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(127168,'I misjudged your strength, brul. I used to believe that size mattered, but perhaps I was mistaken.','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(127169,'When I spoke to the shaman of my tribe, he foresaw a victory for me on this day. Perhaps you should bow out of this one, fellow warrior.','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(127170,'You seem like one of strong will, but my will is stronger. As is my my mind.','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(127171,'I look forward to our match, warrior. If you should survive to see it.','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(127172,'I now know what the shaman meant. I have learned humility, and have grown stronger because of it.','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(127173,'Thank you, warrior.','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(127174,'Battlelord $p! Over here!','',0,0,0,0,0,0,3,0,0,0,81273,0,26124),
(127175,'I hope you\'ve come prepared, Battlelord. I\'ve brought some supplies with me, should you need them.','',0,0,0,0,0,0,1,0,0,0,81274,0,26124),
(127176,'When you\'re ready to fight, challenge Damrul the Stronk. Then stand on the rune and the fight will begin.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127177,'When you\'re ready to fight, challenge Damrul the Stronk. Then stand on the rune and the fight will begin.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127178,'I hope you\'re prepared, Battlelord. I\'ve brought supplies with me as well, should you need them.','',0,0,0,0,0,0,1,0,0,0,81220,0,26124),
(127179,'Battlelord $p! Over here!','',0,0,0,0,0,0,3,0,0,0,81219,0,26124),
(127180,'','I... can\'t go on...',0,0,0,0,0,0,0,0,0,0,0,82470,26124),
(127181,'','Think... I\'ll just... sit a spell...',0,0,0,0,0,0,0,0,0,0,0,82480,26124),
(127182,'','Jarod! He... he\'s gone. We need to fall back until reinforcements arrive!',0,0,0,0,0,0,0,0,0,0,0,82471,26124),
(127183,'','You\'re not supposed to outlive your grandchildren...',0,0,0,0,0,0,0,0,0,0,0,82481,26124),
(127184,'','%s\'s eyes glaze over as her shotgun falls to the ground.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127185,'','%s collapses onto the floor in despair.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127186,'','You heard the lady! Everybody out!',0,0,0,0,0,0,0,0,0,0,0,82482,26124),
(127187,'We cannot press forward until reinforcements arrive. Fall back, everyone!','',0,0,0,0,0,0,0,0,0,0,82369,0,26124),
(127188,'','Are you prepared to answer the call of glory, $c?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127189,'I\'m prepared! Send me to the Gates of Valor. [Queue for Scenario]','I\'m prepared! Send me to the Gates of Valor. [Queue for Scenario]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127190,'','Is there danger? I can handle it!',0,0,0,0,0,0,0,0,0,0,0,80829,26124),
(127191,'','How\'s it going?',0,0,0,0,0,0,0,0,0,0,0,80830,26124),
(127192,'','You scratch my back, I\'ll claw yours.',0,0,0,0,0,0,0,0,0,0,0,80831,26124),
(127193,'','See you later!',0,0,0,0,0,0,0,0,0,0,0,80832,26124),
(127194,'','May the winds support you.',0,0,0,0,0,0,0,0,0,0,0,80833,26124),
(127195,'','Keep your eyes on the skies!',0,0,0,0,0,0,0,0,0,0,0,80834,26124),
(127196,'','Knock it off!',0,0,0,0,0,0,0,0,0,0,0,80835,26124),
(127197,'','Can you not?',0,0,0,0,0,0,0,0,0,0,0,80836,26124),
(127198,'','Do you want a knife to your throat? It\'s kinda my thing.',0,0,0,0,0,0,0,0,0,0,0,80837,26124),
(127199,'My wounds are deep but I\'ve recovered from worse. Soon, the Legion will have my vengeance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127200,'','Kanrethad\'s power belongs to the Burning Legion!',0,0,0,0,0,0,603,0,0,0,0,83292,26124),
(127201,'','You will not disrupt this ritual!',0,0,0,0,0,0,603,0,0,0,0,82696,26124),
(127202,'','Do not let them siphon his power!',0,0,0,0,0,0,603,0,0,0,0,82697,26124),
(127203,'','I have little time for foolishness.',0,0,0,0,0,0,0,0,0,0,0,80845,26124),
(127204,'','What is it you want?',0,0,0,0,0,0,0,0,0,0,0,80846,26124),
(127205,'','What would you ask of old Magatha?',0,0,0,0,0,0,0,0,0,0,0,80847,26124),
(127206,'','Run away, child.',0,0,0,0,0,0,0,0,0,0,0,80848,26124),
(127207,'','Keep your friends close...',0,0,0,0,0,0,0,0,0,0,0,80849,26124),
(127208,'','The Grimtotem shall rise again.',0,0,0,0,0,0,0,0,0,0,0,80850,26124),
(127209,'','Do not pester me, child.',0,0,0,0,0,0,0,0,0,0,0,80851,26124),
(127210,'','I have more power in one finger than you have in your entire body!',0,0,0,0,0,0,0,0,0,0,0,80852,26124),
(127211,'','One of our patrols has been trapped behind this stampede! We must bring them Storm Brew to restore their spirits. But how...',0,0,0,0,0,0,0,0,0,0,0,80621,26124),
(127212,'','Good work! Our troops should be able to stay in the fight until the stampede has finished.',0,0,0,0,0,0,0,0,0,0,0,80622,26124),
(127213,'','I have felled champions and chieftains! You are an insignificant whelpling!',0,0,0,0,0,0,0,0,0,0,0,80853,26124),
(127214,'','Yes?',0,0,0,0,0,0,0,0,0,0,0,80854,26124),
(127215,'','Undeath welcomes you.',0,0,0,0,0,0,0,0,0,0,0,80855,26124),
(127216,'','My axe hungers.',0,0,0,0,0,0,0,0,0,0,0,80856,26124),
(127217,'','Suffer well.',0,0,0,0,0,0,0,0,0,0,0,80857,26124),
(127218,'','Is that all?',0,0,0,0,0,0,0,0,0,0,0,80858,26124),
(127219,'','There is no end to undeath.',0,0,0,0,0,0,0,0,0,0,0,80859,26124),
(127220,'','Quit prodding me!',0,0,0,0,0,0,0,0,0,0,0,80860,26124),
(127221,'','They say pretty girls make graves.',0,0,0,0,0,0,0,0,0,0,0,80861,26124),
(127222,'','Shall I make a grave for you?',0,0,0,0,0,0,0,0,0,0,0,80862,26124),
(127223,'','Netherlord, you\'ve done it! Kanrethad has returned to us.',0,0,0,0,0,0,603,0,0,0,0,81812,26124),
(127224,'','What is it you ask?',0,0,0,0,0,0,0,0,0,0,0,80872,26124),
(127225,'','My blades stay sharp.',0,0,0,0,0,0,0,0,0,0,0,80873,26124),
(127226,'','I live my life in the shadows.',0,0,0,0,0,0,0,0,0,0,0,80874,26124),
(127227,'','Keep your guard up.',0,0,0,0,0,0,0,0,0,0,0,80875,26124),
(127228,'Welcome, warriors, to the Trial of Rage!','',0,0,0,0,0,0,0,0,6,0,83049,0,26124),
(127229,'','Do not linger.',0,0,0,0,0,0,0,0,0,0,0,80876,26124),
(127230,'','There is much to be done.',0,0,0,0,0,0,0,0,0,0,0,80877,26124),
(127231,'','Get away!',0,0,0,0,0,0,0,0,0,0,0,80878,26124),
(127232,'','Leave me be!',0,0,0,0,0,0,0,0,0,0,0,80879,26124),
(127233,'','Oh, you\'d prefer I play the role of the monster?',0,0,0,0,0,0,0,0,0,0,0,80880,26124),
(127234,'Our first combatants are the mighty Battlelord $p and the infamous drogbar, Damrul the Stronk!','',0,0,0,0,0,0,0,0,6,0,83050,0,26124),
(127235,'','Is he alive?',0,0,0,0,0,0,6,0,0,0,0,81813,26124),
(127236,'Reports say there is a particularly powerful demon at this location. We should eliminate it quickly!','',0,0,0,0,0,0,0,0,0,0,81128,0,26124),
(127238,'A powerful agent of the Legion is nearby. They are too risky to ignore, you must defeat them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127239,'I\'m gonna toss you around like a ragdoll, $r!','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(127240,'The presence of this foe poses a great threat to our armies. Defeat it to buy us more time to prepare!','',0,0,0,0,0,0,0,0,0,0,81127,0,26124),
(127241,'Well struck, like a true archmage! It doesn\'t have quite the same ring to it...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127242,'Thank you, champion. You have brought us a brief respite from their endless assaults.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127243,'Another victory for the Armies of Legionfall. We must not let this advantage go to waste!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127244,'$n wants to know: Do you feel lucky? Come talk to Lord Winifred Browne and test your... gold-earning potential.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127245,'I have no desire to rejoin the council, though it is good to be among its members.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(127246,'There certainly is a great deal of carnage in the fighting ring today. Moreso than usual, I\'d say. I think I got hit with a tooth.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127247,'I sense a powerful foe nearby. Strike with all your rage to banish it from our world!','',0,0,0,0,0,0,0,0,0,0,81139,0,26124),
(127248,'Another Legion insect has scurried forth from beneath its rock. Demonstrate the might of our armies!','',0,0,0,0,0,0,0,0,0,0,81140,0,26124),
(127249,'This rabble dares set foot on Azeroth again. Show them the same treatment they have shown countless other worlds. Eradicate them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127250,'They were not prepared!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127251,'For each we strike down, another shall return. Remain vigilant.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127252,'We will crush the Legion wherever they appear, until they have been driven back for good.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127253,'The Legion\'s presence is strong here. Be ready, champion. The Light must prevail!','',0,0,0,0,0,0,0,0,0,0,81145,0,26124),
(127254,'The Legion is rallying around a powerful adversary. We must stop them from gathering more forces!','',0,0,0,0,0,0,0,0,0,0,81146,0,26124),
(127255,'Our patrol has spotted a powerful foe in this area. Its downfall would set back the Legion\'s presence here significantly.','',0,0,0,0,0,0,0,0,0,0,81147,0,26124),
(127256,'Each victory bolsters our advance and empowers our forces. Thank you, champion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127257,'A resounding strike against the Legion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127258,'The demons will pay for their crimes a thousandfold. Keep up the pressure!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127259,'Ahhh! Fresh, cool brew!','Ahhh! Fresh, cool brew!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127260,'This brew is especially frothy. It will be just the refreshment I need.','This brew is especially frothy. It will be just the refreshment I need.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127261,'We might not have been able to hold out much longer. Many thanks!','We might not have been able to hold out much longer. Many thanks, $c.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127262,'Battlelord $p\'s next challenger is Omanawkwa Steelhoof of the Highmountain tribe.','',0,0,0,0,0,0,0,0,6,0,83052,0,26124),
(127263,'Let us see if $p\'s skill can break the infamous Steelhoof shield!','',0,0,0,0,0,0,0,0,6,0,83053,0,26124),
(127264,'My shield has fended off armies of warriors. I don\'t believe one $r will be able to pierce it.','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(127265,'You come to lift with me, brul?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127266,'I challenge you to fight!','I challenge you to fight!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127267,'It will be my pleasure to crush you.','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(127268,'Do not feel shame when you fall. My defense is impenetrable.','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(127269,'It was my honor to be welcomed here by Odyn. I will prove his choice in my strength was not misjudged.','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(127270,'The Burning Legion advances on Azsuna! We must thin their ranks to expose the heart of their threat!','',0,0,0,0,0,0,0,0,0,0,81563,0,26124),
(127271,'<Present the VIP Room Rental Form.>','<Present the VIP Room Rental Form.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127272,'When Bizmo and his team carved this pub into the side of the Deeprun Tram, he took a big risk. Lots of gold went into building this place.\n\nSo he built this VIP Room. The Boom Room, he calls it. Better views of the fight, all the top-shelf drinks you can buy, and the satisfaction of knowing that you can get into an exclusive, members-only club. For you see - he only lets you up if you\'re Rank 8 or higher.\n\nYou want to get into the Boom Room? Keep winning your fights, kid.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127273,'You\'re Rank 8, right?\n\nYou\'re good. Come on in.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127274,'Here\'s the low-down. You may not have EARNED the right to enter the Boom Room, but someone nicer than you paid me to let you in.\n\nYou\'re good. Come on in. And don\'t make a mess.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127275,'','$n has turned in enough gold to bend the rules of the arena. Speak to a bouncer if you\'d like to fight against a random brawler!',0,0,0,0,0,0,0,0,0,0,0,80244,26124),
(127276,'Bizmo\'s Boom Room has opened its doors to all brawlers, courtesy of $n!','',0,0,0,0,0,0,0,0,0,0,80244,0,26124),
(127277,'','This round\'s on $n! Free drinks for the next two minutes!',0,0,0,0,0,0,0,0,0,0,0,80244,26124),
(127278,'The Felborne were given gems of insidious power from the Legion. Rip these baubles from their hands and destroy them. The lives of these elves are now forfeit.','',0,0,0,0,0,0,0,0,0,0,81094,0,26124),
(127279,'The fel energies inside those crystals dissipated upon their destruction. Consider their threat neutralized.','',0,0,0,0,0,0,0,0,0,0,81095,0,26124),
(127280,'The Legion is attempting to repair a fel reaver using an unstable ritual. Go, disrupt their efforts, and turn their own energies against them.','',0,0,0,0,0,0,0,0,0,0,80660,0,26124),
(127281,'Intimidation is a weapon of the Legion. Intelligence is not.','',0,0,0,0,0,0,0,0,0,0,80661,0,26124),
(127282,'The demonic presence recedes, but this is no time to be complacent. I await your arrival outside the Temple. It\'s time we press our advance.','',0,0,0,0,0,0,0,0,0,0,81561,0,26124),
(127283,'Bow before the might of the Burning Legion! Your efforts are meaningless, mortals!','',0,0,0,0,0,0,0,0,0,0,82724,0,26124),
(127284,'Bruh...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127285,'|TInterface\\Icons\\SPELL_SHADOW_SOULLEECH_1.BLP:20|t%s begins |cFFFF0000|Hspell:236133|h[Blooming]|h|r !','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127290,'You meddle with powers you do not understand, mortal! Your unwillingness to bow will be your end!','',0,0,0,0,0,0,0,0,0,0,82725,0,26124),
(127295,'','I\'ve been to this trial thousands of times. And every time, I\'ve shown Odyn that his warriors aren\'t worthy to step into the ring with me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127296,'','You are foolish, $r. But if death is what you need to learn this lesson, then so be it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127297,'','I WILL NOT YIELD TO THE LIKES OF YOU, PEASANT!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127298,'Battlelord $p\'s next opponent is Asrea Moonblade of the proud nightborne of Suramar.','',0,0,0,0,0,0,0,0,6,0,83055,0,26124),
(127299,'Her blade has felled many a warrior inside this ring. Can the Battlelord find a way to triumph?','',0,0,0,0,0,0,0,0,6,0,83056,0,26124),
(127300,'','It\'s been a while since my blade has tasted blood. I wonder if it will be pleased with yours...',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(127302,'Thank you, champion. Please, free the others as well!','Thank you, champion. Please, free the others as well!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127303,'Thank you, champion. Please, free the others as well!','Thank you, champion. Please, free the others as well!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127306,'Together we will crush the Burning Legion, Archmage $n!','',0,0,0,0,0,0,0,0,0,0,82781,0,26124),
(127307,'Allow me to open a portal.','',1,0,0,0,0,0,0,0,0,0,82780,0,26124),
(127308,'I... have failed.','',0,0,0,0,0,0,0,0,0,0,82370,0,26124),
(127309,'The Burning Legion will fall!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127310,'I am ready to begin the final assault. [Queue for Scenario]','I am ready to begin the final assault. [Queue for Scenario]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127311,'Disa, Nethos, Tael\'thos! Form ranks! I want that infestation expunged!','',0,0,0,0,0,0,0,0,0,0,82463,0,26124),
(127312,'Wait! Stop, I... I cannot go on. You\'re clearly the stronger brul here.','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(127313,'Convenient of Erdris to reveal just who we should take care of! They should be near the farmstead. Let\'s go!','',0,0,0,0,0,0,0,0,0,0,82375,0,26124),
(127314,'I yield, Battlelord. You have proven yourself beyond a shadow of a doubt to be the superior warrior.','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(127315,'Death comes soon.','',0,0,0,0,0,0,0,0,5,0,55332,0,26124),
(127316,'Call out to your troops, \"my lord\". I will raise them, make them stronger!','',0,0,0,0,0,0,0,0,0,0,82796,0,26124),
(127317,'To me, my troops! I require your strength!','',0,0,0,0,0,0,0,0,0,0,82464,0,26124),
(127318,'Yes... arise... fight the \"Legion\"!','',0,0,0,0,0,0,0,0,0,0,82797,0,26124),
(127319,'Huntmaster, gather your flares. Beasts of the shadows are controlling vital ground for the Legion. Reveal these creatures so that our archers might rain destruction down upon them.','',0,0,0,0,0,0,0,0,0,0,80637,0,26124),
(127320,'Impressive. Even the most powerful of magics can be undone with the right tools.','',0,0,0,0,0,0,0,0,0,0,80638,0,26124),
(127321,'Savor this victory while you can. I have studied your tactics... learned your weaknesses. Now I will raise my own army within Black Rook Hold!','',0,0,0,0,0,0,0,0,0,0,82465,0,26124),
(127322,'Foul demons are using our wounded allies as bait! We need every soldier back on the front line. Get in there and get them moving... and be mindful of the shadows.','',0,0,0,0,0,0,0,0,0,0,80649,0,26124),
(127323,'Erdris must be located. I will scout the hold and send word when it is time to strike. See you soon, $n.','',0,0,0,0,0,0,0,0,0,0,82376,0,26124),
(127324,'Better our forces be revived and fighting with us than to serve as fuel for the fel.','',0,0,0,0,0,0,0,0,0,0,80650,0,26124),
(127325,'The Legion has begun to corrupt beasts. One of them has taken up residence in a cave amongst the murlocs. It must be eliminated!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127327,'The Mage Tower crackles as time stops!','The Mage Tower crackles as time stops!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127328,'An excellent first round! It seems Damrul underestimated the strength of Battlelord $p.','',0,0,0,0,0,0,0,0,6,0,83051,0,26124),
(127329,'The vaunted Steelhoof defense has fallen before $p\'s skill! But will that skill be enough to best the next challenger?','',0,0,0,0,0,0,0,0,6,0,83054,0,26124),
(127330,'A melee for the ages! Asrea has been so dominant that many spectators considered her unbeatable. It would seem her hubris has ushered in her downfall!','',0,0,0,0,0,0,0,0,6,0,83057,0,26124),
(127331,'Battlelord $p, when you are ready to face your final challenger, step onto the rune.','',0,0,0,0,0,0,0,0,6,0,83060,0,26124),
(127332,'The Battlelord has bested all challengers! The trial is complete!','',0,0,0,0,0,0,0,0,6,0,83061,0,26124),
(127333,'Let us revel in our champion\'s victory! All hail the Battlelord!','',0,0,0,0,0,0,0,0,6,0,83062,0,26124),
(127334,'Eyir has sent her finest pupil to serve as Battlelord $p\'s final challenger. I present to you... Aspirant Thyri!','',0,0,0,0,0,0,0,0,6,0,83058,0,26124),
(127335,'Will Battlelord $p\'s martial prowess be enough to vanquish one favored in the eyes of Eyir?','',0,0,0,0,0,0,0,0,6,0,83059,0,26124),
(127336,'','When I defeat you, I shall be one step closer to ascension.',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(127337,'','I... I can\'t believe I lost. Perhaps I am not worthy to ascend...',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(127338,'Fools! Gaze into the skies beyond as the end of your world approaches!','',0,0,0,0,0,0,0,0,0,0,82723,0,26124),
(127339,'The connection is down! We must act quickly, $n. Let us rendezvous at Farondale. The final fight is at hand.','',0,0,0,0,0,0,0,0,0,0,81566,0,26124),
(127340,'The power is yours, $n. End this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127341,'I\'m ready to go. Summon a portal, please.','I\'m ready to go. Summon a portal, please.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(127342,'Can I take a ride on your balloon?','Can I take a ride on your balloon?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127343,'Now I\'m all melancholy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127344,'Anybody know any good jokes? Here, I\'ll start...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127345,'Why do dwarf hunters use guns?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127346,'Because ye can\'t drink ale from the barrel of a bow!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127347,'Heh. It\'s okay for me to tell that one because I\'m a dwarf. And a hunter!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127348,'Heh, that brightened me spirit. Thanks fer keepin\' an ol\' hunter company!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127349,'I can take you back to Skyhold when you\'re ready to leave, Battlelord.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127350,'I can take you back to Skyhold when you\'re ready to leave, Battlelord.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127351,'','Welcome to the Kirin Tor Tavern Crawl, $n.  Help yourself to all the drinks and free food you can handle.  We\'ll be leaving for the next tavern in a couple minutes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127352,'It is an honor to be here for you, Battlelord. I hope you are victorious in your trials.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127353,'What have you brought with you?','What have you brought with you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127354,'I\'m ready to go back to Skyhold.','I\'m ready to go back to Skyhold.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127355,'Teleport me to the tavern crawl.','Teleport me to the tavern crawl.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127356,'I\'m ready to begin the trial, Odyn.','I\'m ready to begin the trial, Odyn.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127357,'The Legion corrupts everything it touches! Destroy their fel corruptors before all of Stormheim is tainted!','',0,0,0,0,0,0,0,0,0,0,80562,0,26124),
(127358,'Well done! Scars of the Legion\'s presence may linger for a time, but fade they shall.','',0,0,0,0,0,0,0,0,0,0,80563,0,26124),
(127359,'The shattered core of a fallen fel reaver is giving rise to a host of aberrations! Recover the core fragments before the Legion can salvage their creation!','',0,0,0,0,0,0,0,0,0,0,80560,0,26124),
(127360,'Tar starts to seep from the ground around %s...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127361,'|TInterface\\Icons\\INV_Misc_Food_Legion_gooOil_multi.blp:20|tThe tar pits start |cFFFF0000|Hspell:236333|h[Erupting]|h|r !','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127362,'','Your kind will be cleansed from this world!',0,0,0,0,0,0,0,0,0,0,0,81427,26124),
(127363,'','You will burn in power you cannot comprehend!',0,0,0,0,0,0,0,0,0,0,0,81428,26124),
(127364,'Our rumbler today is a beefy mammal with a taste for vengeance. He doesn\'t want to help you... he wants to kill you. It\'s the enmity moose, Grief Warden!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(127365,'Our rumbler today is pack of pecky penguins from the polar precipices of Northrend. Beware the Slippy Stampede!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(127366,'These three pandaren have a challenge for you... pull one of your beer carts to the middle of the ring before they can pull theirs. Winning team gets to drink it!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(127367,'H-I-P-P-O spells death! Try not to be trampled by our next rumbler, Senya!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(127368,'You don\'t have to beat these creatures, you just have to survive. Oh, and we\'re taking away all your gear and experience, too. Enjoy the Stranglethorn Run!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(127369,'If you can\'t beat him, join him! Prepare to have your minds, faces, and frozen drinks melted by the one and only, Mindbreaker Gzzaj!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(127370,'She\'s all grown up and ready to rumble. Sure, she looks like a sweet kitty now, but wait until she\'s backed into a corner. Steer clear of our next rumbler, Mazhareen!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(127371,'','Our rumbler today is a beefy mammal with a taste for vengeance. He doesn\'t want to help you... he wants to kill you. It\'s the enmity moose, Grief Warden!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(127372,'','Our rumbler today is pack of pecky penguins from the polar precipices of Northrend. Beware the Slippy Stampede!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(127373,'','These three pandaren have a challenge for you... pull one of your beer carts to the middle of the ring before they can pull theirs. Winning team gets to drink it!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(127374,'','H-I-P-P-O spells death! Try not to be trampled by our next rumbler, Senya!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(127375,'','You don\'t have to beat these creatures, you just have to survive. Oh, and we\'re taking away all your gear and experience, too. Enjoy the Stranglethorn Run!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(127376,'','If you can\'t beat him, join him! Prepare to have your minds, faces, and frozen drinks melted by the one and only, Mindbreaker Gzzaj!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(127377,'','She\'s all grown up and ready to rumble. Sure, she looks like a sweet kitty now, but wait until she\'s backed into a corner. Steer clear of our next rumbler, Mazhareen!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(127378,'I can\'t believe it... they won! It\'s a miracle! Just kidding, this happens all the time.','I can\'t believe it... they won! It\'s a miracle! Just kidding, this happens all the time.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(127379,'The rumbling has ceased... and our heroes are the champions! Big, bulging purses of gold to all involved.','The rumbling has ceased... and our heroes are the champions! Big, bulging purses of gold to all involved.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(127380,'Hmph. I\'m pretty sure more than one of you wasn\'t paying attention.','Hmph. I\'m pretty sure more than one of you wasn\'t paying attention.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127381,'Is it me, or does it smell like victory in here?','Is it me, or does it smell like victory in here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127382,'What a shame, what a shame.','What a shame, what a shame.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(127383,'You lose! You get nothing!','You lose! You get nothing!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127384,'Umm... thanks for trying?','Umm... thanks for trying?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127385,'You almost had that one. Next time.','You almost had that one. Next time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127386,'The Grand Ballroom door in the Broken Stair opens.','The Grand Ballroom door in the Broken Stair opens.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127387,'[OLD DNT] $n, our assault on the southern beach is being met with heavy resistance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127388,'[OLD DNT] I need you to lead my forces and the orders in battle while I command the other fronts!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127389,'[OLD DNT] We must take the ruins on the western side of the island. From there we can funnel all of our forces toward the soul engine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127390,'[OLD DNT] Today the legion will fall! For Azeroth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127391,'','I love your glasses. So vintage.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127392,'','And now we wait. This fight will be glorious!',0,0,0,0,0,0,0,0,0,0,0,81295,26124),
(127393,'Vethir\'s brood has been captured... again! Free them, so they can aid our fight against this onslaught.','',0,0,0,0,0,0,0,0,0,0,85208,0,26124),
(127394,'Heroes, return to me. Vethir\'s brood has joined our battle against these invaders. Take to the skies and claim victory!','',0,0,0,0,0,0,0,0,0,0,85209,0,26124),
(127395,'The Legion must be stricken from the sky! The drakes will carry you to the demons\' flying fortress. From there, you can sabotage their infernal vessel.','',0,0,0,0,0,0,0,0,0,0,85210,0,26124),
(127396,'You took down their commander. Well done! Vethir\'s drakes will see you to safety. I shall strike the final blow against their foul vessel myself!','',0,0,0,0,0,0,0,0,0,0,85211,0,26124),
(127397,'A fine victory, champions! Songs of your glory will be sung through the Halls of Valor for ages to come.','',0,0,0,0,0,0,0,0,0,0,85203,0,26124),
(127398,'','Hello, $n.  Did you know there\'s a tavern crawl going on today, sponsored by the Kirin Tor?  In fact, I can teleport you to the tavern where everyone is hanging out.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127399,'','Now that Daumyr and her brood are ours, the tide is about to turn!',0,0,0,0,0,0,0,0,0,0,0,81300,26124),
(127400,'','Don\'t get me wrong... the Four Horsemen are most impressive. But giant undead dragons...',0,0,0,0,0,0,0,0,0,0,0,81301,26124),
(127401,'','When the demons catch sight of our brood, they may well die of fright!',0,0,0,0,0,0,0,0,0,0,0,81302,26124),
(127402,'','And if not, I\'ll happily hack them to pieces with my axe. Either way, no skin off my back!',0,0,0,0,0,0,0,0,0,0,0,81303,26124),
(127403,'','...If my back had any skin left, that is.',0,0,0,0,0,0,0,0,0,0,0,81304,26124),
(127404,'The Legion will conquer all! Your pathetic Halls will be turned to dust.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127405,'Enough of your meddling! Come and seek me out, if your dare!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127406,'','You are beneath me.',0,0,0,0,0,0,0,0,0,0,0,80976,26124),
(127407,'','Lord Illidan will welcome your death!',0,0,0,0,0,0,0,0,0,0,0,80977,26124),
(127408,'','This will be quick.',0,0,0,0,0,0,0,0,0,0,0,80978,26124),
(127409,'','You will drown!',0,0,0,0,0,0,0,0,0,0,0,80979,26124),
(127410,'','Sink or swim!',0,0,0,0,0,0,0,0,0,0,0,80980,26124),
(127411,'','Are you sure you need my aid?',0,0,0,0,0,0,0,0,0,0,0,80981,26124),
(127412,'','Slayer. I suppose I have time to help you.',0,0,0,0,0,0,0,0,0,0,0,80982,26124),
(127413,'','Can we do something more interesting this time?',0,0,0,0,0,0,0,0,0,0,0,80983,26124),
(127414,'','Fear the Coilskar!',0,0,0,0,0,0,0,0,0,0,0,80984,26124),
(127415,'','You bore me.',0,0,0,0,0,0,0,0,0,0,0,80985,26124),
(127416,'','You should have learned to swim.',0,0,0,0,0,0,0,0,0,0,0,80986,26124),
(127417,'','Food for the fish!',0,0,0,0,0,0,0,0,0,0,0,80987,26124),
(127419,'','The Coilskar always get our way.',0,0,0,0,0,0,0,0,0,0,0,80988,26124),
(127421,'','This is not...possible...',0,0,0,0,0,0,0,0,0,0,0,80989,26124),
(127422,'','You will have to do this... without me...',0,0,0,0,0,0,0,0,0,0,0,80990,26124),
(127423,'','I do not accept... this outcome...',0,0,0,0,0,0,0,0,0,0,0,80991,26124),
(127424,'','I will send you to a watery grave!',0,0,0,0,0,0,0,0,0,0,0,80992,26124),
(127425,'','I suppose I will do this... for you.',0,0,0,0,0,0,0,0,0,0,0,80993,26124),
(127426,'','Let\'s roll up our sleeves and get to work!',0,0,0,0,0,0,0,0,0,0,0,80943,26124),
(127427,'','Grandmaster, I\'ve got your back!',0,0,0,0,0,0,0,0,0,0,0,80944,26124),
(127428,'','I promise I won\'t let you fall, Grandmaster!',0,0,0,0,0,0,0,0,0,0,0,80945,26124),
(127429,'','I bet you have no appreciation for good brew!',0,0,0,0,0,0,0,0,0,0,0,80946,26124),
(127430,'','You\'ll never get through my mists!',0,0,0,0,0,0,0,0,0,0,0,80947,26124),
(127431,'','Bet you\'ve never seen a spinning kick like mine!',0,0,0,0,0,0,0,0,0,0,0,80948,26124),
(127432,'','I\'m gonna knock you out!',0,0,0,0,0,0,0,0,0,0,0,80949,26124),
(127433,'','Oh, goody! I could use more combat practice!',0,0,0,0,0,0,0,0,0,0,0,80950,26124),
(127434,'','Take that!',0,0,0,0,0,0,0,0,0,0,0,80951,26124),
(127435,'','I can\'t believe I wasted my chi on the likes of you!',0,0,0,0,0,0,0,0,0,0,0,80952,26124),
(127436,'','Hey, I\'m getting pretty good at this!',0,0,0,0,0,0,0,0,0,0,0,80953,26124),
(127437,'','Was that really the best you had?',0,0,0,0,0,0,0,0,0,0,0,80954,26124),
(127438,'','Ouch! Maybe I should have stayed at the brewery...',0,0,0,0,0,0,0,0,0,0,0,80955,26124),
(127439,'','I\'m going to need a double after this...',0,0,0,0,0,0,0,0,0,0,0,80956,26124),
(127440,'','Sorry to disappoint you, Grandmaster...',0,0,0,0,0,0,0,0,0,0,0,80957,26124),
(127441,'','Die or get out of the way! Woa...oah...oah...oah!',0,0,0,0,0,0,0,0,0,0,0,80958,26124),
(127442,'','Wow! I will do my best, Grandmaster!',0,0,0,0,0,0,0,0,0,0,0,80959,26124),
(127443,'','Care for some of my special brew?',0,0,0,0,0,0,0,0,0,0,0,80899,26124),
(127444,'','Hello there, hero!',0,0,0,0,0,0,0,0,0,0,0,80900,26124),
(127445,'','I am ready for anything!',0,0,0,0,0,0,0,0,0,0,0,80901,26124),
(127446,'','Let\'s share a brew sometime!',0,0,0,0,0,0,0,0,0,0,0,80902,26124),
(127447,'','Good luck out there!',0,0,0,0,0,0,0,0,0,0,0,80903,26124),
(127448,'','Can I come with you?',0,0,0,0,0,0,0,0,0,0,0,80904,26124),
(127449,'','Hahaha! Stop it! That tickles!',0,0,0,0,0,0,0,0,0,0,0,80905,26124),
(127450,'','Okay, okay... Enough already!',0,0,0,0,0,0,0,0,0,0,0,80906,26124),
(127451,'','Seriously, stop! I\'ll practice my spinning kick on you!',0,0,0,0,0,0,0,0,0,0,0,80907,26124),
(127452,'','Maybe... I\'m not cut out for this... after all...',0,0,0,0,0,0,0,0,0,0,0,80960,26124),
(127453,'The balloon will leave once we have three riders ready to go.','The balloon will leave once we have three riders ready to go.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127454,'Bal\'a dash, Archmage. We fight as one!','',0,0,0,0,0,0,0,0,0,0,80921,0,26124),
(127455,'We will aid the Tirisgarde!','',0,0,0,0,0,0,0,0,0,0,80922,0,26124),
(127456,'Together we will save Azeroth!','',0,0,0,0,0,0,0,0,0,0,80923,0,26124),
(127457,'We will incinerate this darkness!','',0,0,0,0,0,0,0,0,0,0,80924,0,26124),
(127458,'Another target to destroy!','',0,0,0,0,0,0,0,0,0,0,80925,0,26124),
(127459,'Time to light a fire!','',0,0,0,0,0,0,0,0,0,0,80926,0,26124),
(127460,'Your group has elected to kick Schnottz from the balloon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127461,'Diel fin\'al!','',0,0,0,0,0,0,0,0,0,0,80927,0,26124),
(127462,'Burn!','',0,0,0,0,0,0,0,0,0,0,80928,0,26124),
(127463,'You are nothing.','',0,0,0,0,0,0,0,0,0,0,80929,0,26124),
(127464,'You have failed.','',0,0,0,0,0,0,0,0,0,0,80930,0,26124),
(127465,'Diel ma\'ahn orindel\'o.','',0,0,0,0,0,0,0,0,0,0,80931,0,26124),
(127466,'To the sunless realm with you!','',0,0,0,0,0,0,0,0,0,0,80932,0,26124),
(127467,'Must regain... strength...','',0,0,0,0,0,0,0,0,0,0,80933,0,26124),
(127468,'I require... a respite.','',0,0,0,0,0,0,0,0,0,0,80934,0,26124),
(127469,'My best...was not enough...','',0,0,0,0,0,0,0,0,0,0,80935,0,26124),
(127470,'Anar\'alah belore, you will burn!','',0,0,0,0,0,0,0,0,0,0,80936,0,26124),
(127471,'I will do my best, Archmage.','',0,0,0,0,0,0,0,0,0,0,80937,0,26124),
(127472,'What is it?','',0,0,0,0,0,0,0,0,0,0,80938,0,26124),
(127473,'Do you find my discomfort amusing?','',0,0,0,0,0,0,0,0,0,0,80939,0,26124),
(127474,'Enough of your childish antics!','',0,0,0,0,0,0,0,0,0,0,80940,0,26124),
(127475,'Tal anu\'men no Tirisgarde!','',0,0,0,0,0,0,0,0,0,0,80942,0,26124),
(127476,'Hail, Battlelord. I fight with you.','',0,0,0,0,0,0,0,0,0,0,80961,0,26124),
(127477,'Our fury will save Azeroth!','',0,0,0,0,0,0,0,0,0,0,80962,0,26124),
(127478,'We must destroy this evil.','',0,0,0,0,0,0,0,0,0,0,80963,0,26124),
(127479,'My axe hungers for blood!','',0,0,0,0,0,0,0,0,0,0,80964,0,26124),
(127480,'For the Horde!','',0,0,0,0,0,0,0,0,0,0,80965,0,26124),
(127481,'Lok-tar ogar!','',0,0,0,0,0,0,0,0,0,0,80966,0,26124),
(127482,'Aaaaaaagh!','',0,0,0,0,0,0,0,0,0,0,80967,0,26124),
(127483,'There is joy in victory!','',0,0,0,0,0,0,0,0,0,0,80968,0,26124),
(127484,'My fury is unending!','',0,0,0,0,0,0,0,0,0,0,80969,0,26124),
(127485,'All too easy.','',0,0,0,0,0,0,0,0,0,0,80970,0,26124),
(127486,'','Are you sure you need my aid?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127487,'My fury is... sated...','',0,0,0,0,0,0,0,0,0,0,80971,0,26124),
(127488,'I am weakened...','',0,0,0,0,0,0,0,0,0,0,80972,0,26124),
(127489,'My axe will rise again...','',0,0,0,0,0,0,0,0,0,0,80973,0,26124),
(127490,'Cower before my fury!','',0,0,0,0,0,0,0,0,0,0,80974,0,26124),
(127491,'Zug-zug. I will not fail you, Battlelord $n.','',0,0,0,0,0,0,0,0,0,0,80975,0,26124),
(127492,'Throm-ka!','',0,0,0,0,0,0,0,0,0,0,80881,0,26124),
(127493,'Yes?','',0,0,0,0,0,0,0,0,0,0,80882,0,26124),
(127494,'Hail, friend.','',0,0,0,0,0,0,0,0,0,0,80883,0,26124),
(127495,'Stay strong.','',0,0,0,0,0,0,0,0,0,0,80884,0,26124),
(127496,'Keep your weapons sharp.','',0,0,0,0,0,0,0,0,0,0,80885,0,26124),
(127497,'Goodbye.','',0,0,0,0,0,0,0,0,0,0,80886,0,26124),
(127498,'What?','',0,0,0,0,0,0,0,0,0,0,80887,0,26124),
(127499,'My axe grows thirsty.','',0,0,0,0,0,0,0,0,0,0,80888,0,26124),
(127500,'Do not provoke my fury!','',0,0,0,0,0,0,0,0,0,0,80889,0,26124),
(127502,'Greetings, Battlelord. I\'m ready to fight!','',0,0,0,0,0,0,0,0,0,0,81006,0,26124),
(127503,'We will defend Azeroth to the death!','',0,0,0,0,0,0,0,0,0,0,81007,0,26124),
(127504,'Together we will destroy our enemies!','',0,0,0,0,0,0,0,0,0,0,81008,0,26124),
(127505,'I shall destroy you!','',0,0,0,0,0,0,0,0,0,0,81009,0,26124),
(127506,'Feel my fury!','',0,0,0,0,0,0,0,0,0,0,81010,0,26124),
(127507,'Wraaaaaaagh!','',0,0,0,0,0,0,0,0,0,0,81011,0,26124),
(127508,'I will rip you to shreds!','',0,0,0,0,0,0,0,0,0,0,81012,0,26124),
(127509,'I will sharpen my claws on your hide!','',0,0,0,0,0,0,0,0,0,0,81013,0,26124),
(127510,'For the Alliance!','',0,0,0,0,0,0,0,0,0,0,81014,0,26124),
(127511,'My claws drip with your blood!','',0,0,0,0,0,0,0,0,0,0,81015,0,26124),
(127512,'Your death fuels my rage!','',0,0,0,0,0,0,0,0,0,0,81016,0,26124),
(127513,'My claws... are dulled...','',0,0,0,0,0,0,0,0,0,0,81017,0,26124),
(127514,'Battlelord, I have... failed you...','',0,0,0,0,0,0,0,0,0,0,81018,0,26124),
(127515,'My rage subsides... for now...','',0,0,0,0,0,0,0,0,0,0,81019,0,26124),
(127516,'You will fall beneath the fury of my claws!','',0,0,0,0,0,0,0,0,0,0,81020,0,26124),
(127517,'Of course I will succeed, Battlelord.','',0,0,0,0,0,0,0,0,0,0,81021,0,26124),
(127518,'Is there trouble afoot?','',0,0,0,0,0,0,0,0,0,0,80863,0,26124),
(127519,'Hello.','',0,0,0,0,0,0,0,0,0,0,80864,0,26124),
(127520,'Do you need something?','',0,0,0,0,0,0,0,0,0,0,80865,0,26124),
(127521,'Stand strong.','',0,0,0,0,0,0,0,0,0,0,80866,0,26124),
(127522,'For the Alliance.','',0,0,0,0,0,0,0,0,0,0,80867,0,26124),
(127523,'My claws are sharp and ready for action.','',0,0,0,0,0,0,0,0,0,0,80868,0,26124),
(127524,'What is it?','',0,0,0,0,0,0,0,0,0,0,80869,0,26124),
(127525,'My rage is growing...','',0,0,0,0,0,0,0,0,0,0,80870,0,26124),
(127526,'I\'m about to lose control... and I think I like it!','',0,0,0,0,0,0,0,0,0,0,80871,0,26124),
(127527,'Free at last!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127528,'So many things to burn, hehehe!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127529,'Where to go now...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127530,'I\'m gonna have so much fun! Hahaha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127531,'Do you have any Artifact Research already prepared?','Do you have any Artifact Research already prepared?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127532,'You are not worthy of the sun!','',0,0,0,0,0,0,0,0,0,0,80941,0,26124),
(127533,'|TInterface\\Icons\\ability_fixated_state_red:20|tKaram starts to chase you!','|TInterface\\Icons\\ability_fixated_state_red:20|tKaram starts to chase you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127534,'|TInterface\\Icons\\INV_MISC_SHADOWEGG.BLP:20|tRaest |cFFFF0000|Hspell:235446|h[Tears]|h|r Rifts to the Nether!','|TInterface\\Icons\\INV_MISC_SHADOWEGG.BLP:20|tRaest |cFFFF0000|Hspell:235446|h[Tears]|h|r Rifts to the Nether!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127535,'|TInterface\\Icons\\ABILITY_CREATURE_DISEASE_05.BLP:20|tA demonic hand from beyond begins to cast |cFFFF0000|Hspell:235578|h[Grasp from Beyond]|h|r!','|TInterface\\Icons\\ABILITY_CREATURE_DISEASE_05.BLP:20|tA demonic hand from beyond begins to cast |cFFFF0000|Hspell:235578|h[Grasp from Beyond]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127536,'|TInterface\\Icons\\ability_fixated_state_red:20|tKaram starts chasing you again!','|TInterface\\Icons\\ability_fixated_state_red:20|tKaram starts chasing you again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127537,'|TInterface\\Icons\\SPELL_MAGE_RUNEOFPOWER.BLP:20|tRaest projects a |cFFFF0000|Hspell:236460|h[Rune of Summoning]|h|r nearby!','|TInterface\\Icons\\SPELL_MAGE_RUNEOFPOWER.BLP:20|tRaest projects a |cFFFF0000|Hspell:236460|h[Rune of Summoning]|h|r nearby!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127538,'|TInterface\\Icons\\ACHIEVEMENT_BOSS_GENERALVEZAX_01.BLP:20|tA Rune of Summoning conjures a |cFFFF0000|Hspell:236461|h[Thing of Nightmare]|h|r to chase you down!','|TInterface\\Icons\\ACHIEVEMENT_BOSS_GENERALVEZAX_01.BLP:20|tA Rune of Summoning conjures a |cFFFF0000|Hspell:236461|h[Thing of Nightmare]|h|r to chase you down!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127539,'Take down Dread Commander Arganoth! We will deal with the rest.','',0,0,0,0,0,0,0,0,0,0,81096,0,26124),
(127540,'','[OLD DNT] Lord Illidan, it is nice of you to finally arrive... Wardens, let\'s do the real work while the demon hunters play with their bats.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127541,'|TInterface\\Icons\\ability_fixated_state_red:20|tKaram starts chasing you one last time!','|TInterface\\Icons\\ability_fixated_state_red:20|tKaram starts chasing you one last time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127542,'Stay strong in this time of unrest.','',0,0,0,0,0,0,0,0,0,0,80890,0,26124),
(127543,'You are a beacon of light in the darkness.','',0,0,0,0,0,0,0,0,0,0,80891,0,26124),
(127544,'We are a force of balance in a chaotic ocean.','',0,0,0,0,0,0,0,0,0,0,80892,0,26124),
(127545,'We serve all of Azeroth.','',0,0,0,0,0,0,0,0,0,0,80893,0,26124),
(127546,'Evil cannot take root if our hearts stay pure.','',0,0,0,0,0,0,0,0,0,0,80894,0,26124),
(127547,'We will not rest until the Legion is defeated.','',0,0,0,0,0,0,0,0,0,0,80895,0,26124),
(127548,'Please, leave me be. I am meditating.','',0,0,0,0,0,0,0,0,0,0,80896,0,26124),
(127549,'You are making it very difficult for me to control my thoughts, little one.','',0,0,0,0,0,0,0,0,0,0,80897,0,26124),
(127550,'I learned a new technique called \"Kick the Hornet\'s Nest!\" Shall I demonstrate it on you?','',0,0,0,0,0,0,0,0,0,0,80898,0,26124),
(127551,'','Have you had any brew today?',0,0,0,0,0,0,0,0,0,0,0,80908,26124),
(127552,'Filthy slime! Slow down!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127553,'Come back! I need your core fragments!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127554,'','Good brew requires an abundance of love.',0,0,0,0,0,0,0,0,0,0,0,80909,26124),
(127555,'Why slime move so fast?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127556,'','One must always make time for new brews.',0,0,0,0,0,0,0,0,0,0,0,80910,26124),
(127557,'','Nothing beats a brew shared between friends.',0,0,0,0,0,0,0,0,0,0,0,80911,26124),
(127558,'','You never know what wonders you will see!',0,0,0,0,0,0,0,0,0,0,0,80912,26124),
(127559,'','May you sample many brews, my friend!',0,0,0,0,0,0,0,0,0,0,0,80913,26124),
(127560,'','That is quite enough, thank you.',0,0,0,0,0,0,0,0,0,0,0,80914,26124),
(127561,'','Is your head as empty as your mug?',0,0,0,0,0,0,0,0,0,0,0,80915,26124),
(127562,'','Best not test my patience! The storm answers my call!',0,0,0,0,0,0,0,0,0,0,0,80916,26124),
(127563,'How long was I stuck like that?','How long was I stuck like that?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127564,'Thank you, $ct. I\'m going back to camp!','Thank you, $ct. I\'m going back to camp!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127565,'I\'m never stepping foot near another basilisk again!','I\'m never stepping foot near another basilisk again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127566,'We sent troops to survey this area, only to have them fall prey to the stares of basilisks! Use this magical salve to free our stone-bound scouts.','',0,0,0,0,0,0,0,0,0,0,81366,0,26124),
(127567,'The salve worked? I mean... yes, of course it worked. Nicely done, champion.','',0,0,0,0,0,0,0,0,0,0,81367,0,26124),
(127570,'You paladins are so predictable. Come, let us see what power your blade truly possesses...','',0,0,0,0,0,0,0,0,0,34080,0,0,26124),
(127571,'This land will never heal...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127572,'You will not interrupt our work. This ground belongs to the Legion!','',0,0,0,0,0,0,0,0,0,36777,0,0,26124),
(127582,'','D\'Bynn and I will make our way to the lodge, should you need us.',0,0,0,0,0,0,1,0,0,0,0,80688,26124),
(127583,'','Look out, folks, Klunk\'s gonna klunk you up!',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(127584,'Look out, folks, Klunk\'s gonna klunk you up!','',0,0,0,0,0,0,22,0,1,0,0,0,26124),
(127585,'','Together we will protect our home from the Burning Legion.',0,0,0,0,0,0,1,0,0,0,0,80689,26124),
(127586,'','We will not be stopped!',0,0,0,0,0,0,1,0,0,0,0,81819,26124),
(127587,'Such massive Legion war machines are ill-suited to this terrain. They should think twice before sending another!','',0,0,0,0,0,0,0,0,0,0,80561,0,26124),
(127588,'Slayer, you are needed on the front lines. Rip the essences from the demons pouring forth from the Tomb and use these empowered souls to sunder the pit lord in two!','',0,0,0,0,0,0,0,0,0,0,80647,0,26124),
(127589,'Pit lords. Bah! They are arrogance made flesh. The essences from those fallen demons may prove useful in further battles.','',0,0,0,0,0,0,0,0,0,0,80648,0,26124),
(127590,'The fewer fel-corrupted beasts, the better.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127591,'You seek the commander? Then face me, weaklings!','',0,0,0,0,0,0,0,0,0,0,82736,0,26124),
(127592,'','A threat must be dispatched. Be swift about it.',0,0,0,0,0,0,0,0,0,0,0,80300,26124),
(127593,'','A threat looms near. Eliminate the target.',0,0,0,0,0,0,0,0,0,0,0,80302,26124),
(127594,'','Time to deliver a message to the Legion. Send this one back in pieces!',0,0,0,0,0,0,0,0,0,0,0,80304,26124),
(127595,'','We have much work to do. Grant this demon a swift death.',0,0,0,0,0,0,0,0,0,0,0,80306,26124),
(127596,'','Our scouts report a significant threat in this area. Wipe it out!',0,0,0,0,0,0,0,0,0,0,0,80308,26124),
(127597,'','Just ahead... a new target. Send it screaming back to the Twisting Nether!',0,0,0,0,0,0,0,0,0,0,0,80310,26124),
(127598,'','Demons multiply like rats. Slay this one before it summons more of its foul kin into our world!',0,0,0,0,0,0,0,0,0,0,0,80312,26124),
(127599,'','A potent threat lurks nearby. Seek it out and destroy it!',0,0,0,0,0,0,0,0,0,0,0,80314,26124),
(127600,'','Well struck, champion. Remain on your guard.',0,0,0,0,0,0,0,0,0,0,0,80301,26124),
(127601,'','A fitting end to a vile invader.',0,0,0,0,0,0,0,0,0,0,0,80303,26124),
(127602,'','Message delivered!',0,0,0,0,0,0,0,0,0,0,0,80305,26124),
(127603,'','That was more mercy than the fiend deserved. On to the next target!',0,0,0,0,0,0,0,0,0,0,0,80307,26124),
(127604,'','Impressive! That wretch didn\'t stand a chance.',0,0,0,0,0,0,0,0,0,0,0,80309,26124),
(127605,'','Well done! Your skills are sharper than any weapon of the Legion.',0,0,0,0,0,0,0,0,0,0,0,80311,26124),
(127606,'','Victory by victory, we push back against  the tide of this invasion. Well done!',0,0,0,0,0,0,0,0,0,0,0,80313,26124),
(127607,'','Another menace eradicated. Excellent!',0,0,0,0,0,0,0,0,0,0,0,80315,26124),
(127608,'This place is fraught with demon filth. A prime target approaches!','',0,0,0,0,0,0,0,0,0,0,80316,0,26124),
(127609,'The Legion has unleashed another of its pawns. Dispose of this threat at once.','',0,0,0,0,0,0,0,0,0,0,80318,0,26124),
(127610,'This agent of the Legion underestimates your might. Make plain the error of its ways.','',0,0,0,0,0,0,0,0,0,0,80320,0,26124),
(127611,'A target nears. Send this filth back to the Nether!','',0,0,0,0,0,0,0,0,0,0,80322,0,26124),
(127612,'A malignant foe is near. Do what must be done!','',0,0,0,0,0,0,0,0,0,0,80324,0,26124),
(127613,'I sense a nearby target. Strike swiftly!','',0,0,0,0,0,0,0,0,0,0,80326,0,26124),
(127614,'Ah yes, the unmistakable stench of Legion filth. Seek out the source and destroy it!','',0,0,0,0,0,0,0,0,0,0,80328,0,26124),
(127615,'Another of the Legion\'s minions draws near. Eradicate it!','',0,0,0,0,0,0,0,0,0,0,80330,0,26124),
(127616,'The growth of your power is most impressive. The Legion knows your name... and fears it.','',0,0,0,0,0,0,0,0,0,0,80317,0,26124),
(127617,'Every blow struck against the Legion forces them closer to their end.','',0,0,0,0,0,0,0,0,0,0,80319,0,26124),
(127618,'This game will soon be at an end. The Burning Legion will fall.','',0,0,0,0,0,0,0,0,0,0,80321,0,26124),
(127619,'Relish the satisfaction of dispatching yet another Legion lapdog!','',0,0,0,0,0,0,0,0,0,0,80323,0,26124),
(127620,'An impressive victory. Your resolve remains unwavering.','',0,0,0,0,0,0,0,0,0,0,80325,0,26124),
(127621,'The Legion cannot run or hide. We will hunt them down!','',0,0,0,0,0,0,0,0,0,0,80327,0,26124),
(127622,'That fiend earned its death a thousand times over. Now it shall suffer the wrath of its vile master.','',0,0,0,0,0,0,0,0,0,0,80329,0,26124),
(127623,'Savor that moment when the rage in a demon\'s eyes gives way to fear. We will break them!','',0,0,0,0,0,0,0,0,0,0,80331,0,26124),
(127625,'Greetings, warlock. I come before your council with a discovery I believe you will find intriguing.','',0,0,0,0,0,0,0,0,0,0,82529,0,26124),
(127626,'Much time has passed since we first pierced the veil into the plane of Xoroth, but a new opportunity beckons us back to the realm of the dreadsteeds.','',0,0,0,0,0,0,0,0,0,0,82530,0,26124),
(127627,'Meet with me in Dreadscar Rift, and I will explain.','',0,0,0,0,0,0,0,0,0,0,82531,0,26124),
(127628,'I\'m glad to make your acquaintance, Netherlord.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(127629,'Why have you called me here?','Why have you called me here?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(127630,'Let me cut right to the chase:\n\nEver since I was \"displaced\" by the Blackrock orcs in the Burning Steppes, I have continued my research into the dreadsteeds of Xoroth in hiding. During one of my rituals, I managed to capture an odd demon from the other side - one of the ones we call a \"wyrmtongue.\"\n\nAfter several weeks of questioning, the demon revealed that Lord Hel\'nurath has been working to create a more powerful steed for the fel knights of Xoroth.\n\nHe calls it the Wrathsteed.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(127631,'Go on...','Go on...',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(127632,'While the wyrmtongue knew little of the steed itself, it is clear that Hel\'nurath has thus far only been able to create one. He has gifted it to his greatest general, the fel knight Arax\'ath. The tricky part is that Arax\'ath seldom leaves Xoroth, preferring to command his armies from afar.\n\nHowever, I think we might be able to draw him out. For that, I will require your help.\n\nAre you up to the challenge?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(127633,'The Wrathsteed will be mine!','The Wrathsteed will be mine!',5,0,0,0,0,0,0,0,0,0,0,0,26124),
(127634,'Excellent. I knew you would not disappoint.','',0,0,0,0,0,0,273,0,0,0,82532,0,26124),
(127635,'Now we have preparations to make.','',0,0,0,0,0,0,1,0,0,0,82533,0,26124),
(127636,'In order to draw out Arax\'ath, we will need to create a portal capable of a sustained link to Xoroth. This will be far more difficult than our standard portals, and will require substantial resources.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(127637,'With the materials you\'ve gathered, we\'re well on our way to claiming the Wrathsteed for our own. \n\nWhile we work on constructing the portal, you should focus your efforts on obtaining a lure that will draw Arax\'ath and the Wrathsteed through.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(127638,'Ooh... that\'s nice... Wait, what did you want..?','Ooh... that\'s nice... Wait, what did you want..?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127639,'Oh my... what lovely... hooves you have...','Oh my... what lovely... hooves you have...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127640,'Well... if you put it that way...','Well... if you put it that way...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127641,'Our leader..? I don\'t know...','Our leader..? I don\'t know...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127642,'What? I\'m not leader enough for you?','What? I\'m not leader enough for you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127643,'Leader, you say..? You can boss me around any time...','Leader, you say..? You can boss me around any time...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127644,'...enough of this! I\'ll end you, demon!','...enough of this! I\'ll end you, demon!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127645,'...no... I will not... betray the Legion!','...no... I will not... betray the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127646,'...what am I saying? Die, warlock!','...what am I saying? Die, warlock!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127647,'You want... our leader? Of course... anything for you...','You want... our leader? Of course... anything for you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127648,'Seek Zuriwa... She watches... from her tower.','Seek Zuriwa... She watches... from her tower.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127649,'Wait... what am I doing!? Zuriwa will have my head! Get away from me!','Wait... what am I doing!? Zuriwa will have my head! Get away from me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127650,'','I will feed ya to tha dreadsteeds!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127651,'','Hel\'nurath will hunt ya, $c...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127652,'Now, let us pierce through the Twisting Nether and take what is ours!','',0,0,0,0,0,0,1,0,0,0,82536,0,26124),
(127653,'Rak-ath varus mir\'enon!','',0,0,0,0,0,0,0,0,0,0,82537,0,26124),
(127654,'Vae Xoroth!','',0,0,0,0,0,0,0,0,0,0,82538,0,26124),
(127655,'Ah, good to see you again, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127656,'What is this? A mortal wishes to peer into my realm?!','',0,0,0,0,0,0,0,0,0,0,82704,0,26124),
(127657,'The way is open, warlock! Activate the calling stone!','',0,0,0,0,0,0,0,0,0,0,82539,0,26124),
(127658,'What?! You dare try to summon my steed?','',0,0,0,0,0,0,0,0,0,0,82705,0,26124),
(127659,'My hounds will rend the flesh from your bones!','',0,0,0,0,0,0,0,0,0,0,82706,0,26124),
(127660,'Careful, warlock! The bite of these felhunters is venomous to mortals. It should pose no problem for your demons, though!','',0,0,0,0,0,0,0,0,0,0,82540,0,26124),
(127661,'Acolytes! Rain fire upon this insect!','',0,0,0,0,0,0,0,0,0,0,82707,0,26124),
(127662,'Arax\'ath is protecting his acolytes with a fel shield! You\'ll need to dispel it to take them out!','',0,0,0,0,0,0,0,0,0,0,82541,0,26124),
(127663,'The acolytes are forming a ritual circle. Whatever you do, don\'t leave enough of them alive to complete it!','',0,0,0,0,0,0,0,0,0,0,82542,0,26124),
(127664,'Are they insane?! They\'ll destroy us all!','',0,0,0,0,0,0,0,0,0,0,82543,0,26124),
(127665,'My worthless minions may have fallen, but I will not let you prevail.','',0,0,0,0,0,0,0,0,0,0,82711,0,26124),
(127666,'I will cut you down myself!','',0,0,0,0,0,0,0,0,0,0,82712,0,26124),
(127667,'The Wrathsteed will never be yours, mortal!','',0,0,0,0,0,0,0,0,0,0,82713,0,26124),
(127668,'Impossible...','',0,0,0,0,0,0,0,0,0,0,82714,0,26124),
(127669,'Quickly, enslave the Wrathsteed before it escapes!','',0,0,0,0,0,0,0,0,0,0,82544,0,26124),
(127670,'Excellent work! We must convene the council. Only with their combined strength can we bind a beast of such power.','',0,0,0,0,0,0,0,0,0,0,82545,0,26124),
(127671,'So, this is where these infernal pickpockets take their trinkets.$b$bWell, while we\'re here we may as well get some of it back. I made you a theft/shopping list of things to go get.\n\nThis would be the part where some magic wielding illusionist tries to make you look like one of them. Bah! Illusions. No commitment.\n\nI am going to TRANSFORM you into one of these things. How is your method acting?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127672,'Transform?','Transform?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127673,'How did you beat me through the portal?','How did you beat me through the portal?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127674,'Because I know more about demonic travel than you. Get better.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127675,'','You are no match for me and my hounds!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127676,'','You will never stand a chance against the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127677,'','You WILL give me what I want, demon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127678,'','I will not be denied. Speak.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127679,'','What are they planning, demon?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127680,'','I tire of these games. Speak, or die.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127681,'','Speak!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127682,'','I grow bored. Tell us what we want to know or face your doom.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127683,'You call that a big pack? Ha! I know squiggs and snifflebits that can carry more than you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127684,'You have a nose that is ripe for biting.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127685,'Leave my shinies alone!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127686,'Shush. The auditors may hear you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127687,'What is wrong with your face?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127688,'Snitchlip and Flivvelskag were sent into the maze and never heard of again. Move on or the auditors will send both of us into the maze.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127689,'','You will not be rid of the Grimtotem so easily, child. We will earn our place.',0,0,0,0,0,0,1,0,0,0,0,81649,26124),
(127690,'Who sent you? Was it Ragchomp? Tell him it was Trickletooth that took his shiny. It wasn\'t me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127691,'Your treasures are small and dull. You should give them to me so that I might \"throw them away.\"','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127692,'Your end is near.','Your end is near.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127693,'You dare interrupt a servant of the Legion!','You dare interrupt a servant of the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127694,'Your efforts are in vain.','Your efforts are in vain.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127695,'Now you meet your end!','Now you meet your end!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127696,'','You will not regret this choice, Shadowblade. I will take out any Legion demon or conspirator who crosses my path!',0,0,0,0,0,0,66,0,0,0,0,81239,26124),
(127697,'That\'s twice I\'ve almost been killed by demons. They will not get a third chance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127698,'Ah, $n. I knew you would make it. I\'ll be ready to face the Legion in no time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127699,'Get back to work.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127700,'Know your place or I shall remind you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127701,'You dare speak to me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127702,'Get back to work or I shall have you scrubbing the cages of the pits.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127703,'Are you trying to sneak away with something?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127704,'Hail, $ct $n. My fury against the Burning Legion is unending!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127705,'Do not even try to steal anything. We are watching. We are always watching.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127706,'Something seems... off... about you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127707,'You dare interrupt me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127708,'The Legion is corrupting the wolves of the Howling Hills to attack Skyhorn. These foul rituals must be stopped!','',0,0,0,0,0,0,0,0,0,0,80556,0,26124),
(127709,'Hail, $c. \n\nI know of Toryl\'s edict - you will know no harm by my blade.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127710,'Tread carefully, $c. The vrykul of Jandvik are wary of outsiders.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127711,'I am searching for the vrykul mentioned in these scrolls.','I am searching for the vrykul mentioned in these scrolls.',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(127712,'I know little of prophecies, but we have seen new faces in Jandvik since the fall of Skovald. \n\nYou should speak to Priestess Bryna. Her dwelling is in the center of the town. She may know of this prophecy you speak.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127713,'I do not know why you dabble in vrykul prophecy, but the scrolls you carry look genuine. I will alert the vrykul of Jandvik to allow you to pass so you may search for the one you seek. \n\nPriestess Bryna is the most scholarly of the village. Perhaps you should seek her out?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127714,'Poor pups! At least you saved them from becoming slaves of the Legion. Thank you, champion.','',0,0,0,0,0,0,0,0,0,0,80557,0,26124),
(127715,'','I heard Slodi\'s horn. I take it you are the outsider he was announcing?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(127716,'Slodi mentioned you could help find the vrykul mentioned in these scrolls.','Slodi mentioned you could help find the vrykul mentioned in these scrolls.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(127717,'','I am familiar of the Valkyra prophecy of the Faldrottin, but I have not read their text. Let me see the scrolls you found.\n\n<Bryna pores through the scrolls\' text.>\n\nIf these scrolls are correct, that would mean we may have the heir of Skovald in our midst! Regardless of what the Valkyra believe, you would be doing us a service by removing her from here.\n\nSeek out Yngvild in the tower overlooking the town. She keeps a keen eye on the comings and goings of Jandvik, and would have noticed if anyone of note has visited lately.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(127718,'','I\'m keeping my eye on you, outsider.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(127719,'Have any vrykul passed through here that struck you as odd?','Have any vrykul passed through here that struck you as odd?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(127720,'','As a matter of fact, yes there is.\n\nA wandering shieldmaiden came through just recently, and has set up camp outside of town. She stayed only long enough to purchase supplies and avoided all eye contact while she was here.\n\nI was going to check on her to find out her business here, but you are welcome to go in my stead. You\'ll find her camped on the beach to the east.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(127721,'I must pay for my mistakes.','',0,0,0,0,0,0,0,0,0,0,80772,0,26124),
(127722,'It is an honor to walk beside you, Highlord.','',0,0,0,0,0,0,0,0,0,0,80773,0,26124),
(127723,'I will prove myself worthy.','',0,0,0,0,0,0,0,0,0,0,80774,0,26124),
(127724,'You will be judged!','',0,0,0,0,0,0,0,0,0,0,80775,0,26124),
(127725,'I will show no mercy!','',0,0,0,0,0,0,0,0,0,0,80776,0,26124),
(127726,'Bandu thoribas!','',0,0,0,0,0,0,0,0,0,0,80777,0,26124),
(127727,'Judgment must be swift and true.','',0,0,0,0,0,0,0,0,0,0,80778,0,26124),
(127728,'We will prevail.','',0,0,0,0,0,0,0,0,0,0,80779,0,26124),
(127729,'Our will is strong.','',0,0,0,0,0,0,0,0,0,0,80780,0,26124),
(127730,'My spirit weakens...','',0,0,0,0,0,0,0,0,0,0,80781,0,26124),
(127731,'I require a moment\'s rest.','',0,0,0,0,0,0,0,0,0,0,80782,0,26124),
(127732,'You must continue on without me.','',0,0,0,0,0,0,0,0,0,0,80783,0,26124),
(127733,'I fight for the Highlord!','',0,0,0,0,0,0,0,0,0,0,80784,0,26124),
(127734,'I will do what is asked of me.','',0,0,0,0,0,0,0,0,0,0,80785,0,26124),
(127735,'Foolish girl. These bones answer to me, not your misguided honor!','',0,0,0,0,0,0,0,0,0,0,82574,0,26124),
(127736,'','So, you will not face me in single combat? The hallowed bones of our ancestors would balk at such dishonor!',0,0,0,0,0,0,1,0,0,0,0,82935,26124),
(127737,'','If you will not honor me, then I will break you! Champion, help me put down this cur!',0,0,0,0,0,0,0,0,0,0,0,82936,26124),
(127738,'Ishnu-alah.','',0,0,0,0,0,0,0,0,0,0,80786,0,26124),
(127739,'Greetings, friend.','',0,0,0,0,0,0,0,0,0,0,80787,0,26124),
(127740,'It is good to see you.','',0,0,0,0,0,0,0,0,0,0,80788,0,26124),
(127741,'Safe travels.','',0,0,0,0,0,0,0,0,0,0,80789,0,26124),
(127742,'Elune-adore.','',0,0,0,0,0,0,0,0,0,0,80790,0,26124),
(127743,'Ande\'thoras-ethil.','',0,0,0,0,0,0,0,0,0,0,80791,0,26124),
(127744,'Is this how I must pay for my mistakes?','',0,0,0,0,0,0,0,0,0,0,80792,0,26124),
(127745,'Do you not have better things to do?','',0,0,0,0,0,0,0,0,0,0,80793,0,26124),
(127746,'Do I really deserve this?','',0,0,0,0,0,0,0,0,0,0,80794,0,26124),
(127747,'I am not amused.','',0,0,0,0,0,0,0,0,0,0,80795,0,26124),
(127748,'This needs to stop.','',0,0,0,0,0,0,0,0,0,0,80796,0,26124),
(127749,'','What surprises await us?',0,0,0,0,0,0,0,0,0,0,0,80721,26124),
(127750,'','You need not do this alone.',0,0,0,0,0,0,0,0,0,0,0,80722,26124),
(127751,'','I am here to help.',0,0,0,0,0,0,0,0,0,0,0,80723,26124),
(127752,'','Our enemies will drown in shadows!',0,0,0,0,0,0,0,0,0,0,0,80724,26124),
(127753,'','Your end is nigh!',0,0,0,0,0,0,0,0,0,0,0,80725,26124),
(127754,'','You will feel my wrath!',0,0,0,0,0,0,0,0,0,0,0,80726,26124),
(127755,'','You shall be purged from this world!',0,0,0,0,0,0,0,0,0,0,0,80727,26124),
(127756,'','The void awaits.',0,0,0,0,0,0,0,0,0,0,0,80728,26124),
(127757,'','You brought this on yourself.',0,0,0,0,0,0,0,0,0,0,0,80729,26124),
(127758,'','Your struggle is over.',0,0,0,0,0,0,0,0,0,0,0,80730,26124),
(127759,'','I will need just a moment.',0,0,0,0,0,0,0,0,0,0,0,80731,26124),
(127760,'','This was... unexpected.',0,0,0,0,0,0,0,0,0,0,0,80732,26124),
(127761,'','This defeat is only temporary.',0,0,0,0,0,0,0,0,0,0,0,80733,26124),
(127762,'','This should be interesting...',0,0,0,0,0,0,0,0,0,0,0,80734,26124),
(127763,'','Yes?',0,0,0,0,0,0,0,0,0,0,0,80735,26124),
(127764,'','What do you need?',0,0,0,0,0,0,0,0,0,0,0,80736,26124),
(127765,'','How can I help?',0,0,0,0,0,0,0,0,0,0,0,80737,26124),
(127766,'','Take care.',0,0,0,0,0,0,0,0,0,0,0,80738,26124),
(127767,'','May the Shadows embrace you.',0,0,0,0,0,0,0,0,0,0,0,80739,26124),
(127768,'','Farewell.',0,0,0,0,0,0,0,0,0,0,0,80740,26124),
(127769,'','You are testing my patience.',0,0,0,0,0,0,0,0,0,0,0,80741,26124),
(127770,'','Do you think yourself clever?',0,0,0,0,0,0,0,0,0,0,0,80742,26124),
(127771,'','Shoo!',0,0,0,0,0,0,0,0,0,0,0,80743,26124),
(127772,'','Begone from my sight!',0,0,0,0,0,0,0,0,0,0,0,80744,26124),
(127773,'','This will not end well for you.',0,0,0,0,0,0,0,0,0,0,0,80745,26124),
(127774,'','Silly me for thinking Roland was the annoying one.',0,0,0,0,0,0,0,0,0,0,0,80746,26124),
(127775,'Hello.','',0,0,0,0,0,0,0,0,0,0,80747,0,26124),
(127776,'How can I help?','',0,0,0,0,0,0,0,0,0,0,80748,0,26124),
(127777,'Yes?','',0,0,0,0,0,0,0,0,0,0,80749,0,26124),
(127778,'Safe travels.','',0,0,0,0,0,0,0,0,0,0,80750,0,26124),
(127779,'Farewell.','',0,0,0,0,0,0,0,0,0,0,80751,0,26124),
(127780,'Until next time.','',0,0,0,0,0,0,0,0,0,0,80752,0,26124),
(127781,'What is wrong with you?','',0,0,0,0,0,0,0,0,0,0,80753,0,26124),
(127782,'Surely the leader of the Black Harvest does not have time to waste like this!','',0,0,0,0,0,0,0,0,0,0,80754,0,26124),
(127783,'I am not to be trifled with!','',0,0,0,0,0,0,0,0,0,0,80755,0,26124),
(127784,'Do you really want to wake the demon?','',0,0,0,0,0,0,0,0,0,0,80756,0,26124),
(127785,'Jubeka should have banished you instead.','',0,0,0,0,0,0,0,0,0,0,80757,0,26124),
(127786,'It is an honor to fight alongside such power.','',0,0,0,0,0,0,0,0,0,0,80758,0,26124),
(127787,'There is so much untapped power in this world.','',0,0,0,0,0,0,0,0,0,0,80759,0,26124),
(127788,'Our enemies will fall!','',0,0,0,0,0,0,0,0,0,0,80760,0,26124),
(127789,'Feel the power of the Black Harvest!','',0,0,0,0,0,0,0,0,0,0,80761,0,26124),
(127790,'You are no match for our power!','',0,0,0,0,0,0,0,0,0,0,80762,0,26124),
(127791,'This will be your undoing!','',0,0,0,0,0,0,0,0,0,0,80763,0,26124),
(127792,'Our power cannot be matched.','',0,0,0,0,0,0,0,0,0,0,80764,0,26124),
(127793,'Our power grows!','',0,0,0,0,0,0,0,0,0,0,80765,0,26124),
(127794,'That was almost too easy.','',0,0,0,0,0,0,0,0,0,0,80766,0,26124),
(127795,'Give me a moment to regain my strength.','',0,0,0,0,0,0,0,0,0,0,80767,0,26124),
(127796,'I feel powerless...','',0,0,0,0,0,0,0,0,0,0,80768,0,26124),
(127797,'Don\'t let me slow you down.','',0,0,0,0,0,0,0,0,0,0,80769,0,26124),
(127798,'You will know my power!','',0,0,0,0,0,0,0,0,0,0,80770,0,26124),
(127799,'I will do what is needed in the name of the Black Harvest.','',0,0,0,0,0,0,0,0,0,0,80771,0,26124),
(127800,'','Yes?',0,0,0,0,0,0,0,0,0,0,0,80698,26124),
(127801,'','Can I help you?',0,0,0,0,0,0,0,0,0,0,0,80699,26124),
(127802,'','What do you need?',0,0,0,0,0,0,0,0,0,0,0,80700,26124),
(127803,'','Farewell.',0,0,0,0,0,0,0,0,0,0,0,80695,26124),
(127804,'','Remain vigilant.',0,0,0,0,0,0,0,0,0,0,0,80696,26124),
(127805,'','Be safe.',0,0,0,0,0,0,0,0,0,0,0,80697,26124),
(127806,'','You have my attention.',0,0,0,0,0,0,0,0,0,0,0,80701,26124),
(127807,'','I like you better when you are silent.',0,0,0,0,0,0,0,0,0,0,0,80702,26124),
(127808,'','You are a persistant one, are you not?',0,0,0,0,0,0,0,0,0,0,0,80703,26124),
(127809,'','Surely you know other tricks?',0,0,0,0,0,0,0,0,0,0,0,80704,26124),
(127810,'','You are crossing a line that cannot be uncrossed!',0,0,0,0,0,0,0,0,0,0,0,80705,26124),
(127811,'','You can stop now, or I can have D\'Bynn stop you.',0,0,0,0,0,0,0,0,0,0,0,80706,26124),
(127812,'','Be alert, Huntmaster. We do not know what dangers lurk nearby.',0,0,0,0,0,0,0,0,0,0,0,80717,26124),
(127813,'','I am here to take my place at your side.',0,0,0,0,0,0,0,0,0,0,0,80718,26124),
(127814,'','We will protect these lands together.',0,0,0,0,0,0,0,0,0,0,0,80719,26124),
(127815,'','Run if you dare, though you will not get far!',0,0,0,0,0,0,0,0,0,0,0,80707,26124),
(127816,'','You will die by my hand!',0,0,0,0,0,0,0,0,0,0,0,80708,26124),
(127817,'','I will enjoy this!',0,0,0,0,0,0,0,0,0,0,0,80709,26124),
(127818,'','This is the fate you deserve.',0,0,0,0,0,0,0,0,0,0,0,80714,26124),
(127819,'','There could be no other way.',0,0,0,0,0,0,0,0,0,0,0,80715,26124),
(127820,'','The weak will always perish.',0,0,0,0,0,0,0,0,0,0,0,80716,26124),
(127821,'','Go on without me. I will catch up.',0,0,0,0,0,0,0,0,0,0,0,80711,26124),
(127822,'','This defeat will not break me.',0,0,0,0,0,0,0,0,0,0,0,80712,26124),
(127823,'','My will cannot be broken!',0,0,0,0,0,0,0,0,0,0,0,80713,26124),
(127824,'','You can trust me to do whatever is needed.',0,0,0,0,0,0,0,0,0,0,0,80710,26124),
(127825,'','Your victory brings hope to the hearts of my people. The Burning Legion will never take our lands!',0,0,0,0,0,0,0,0,0,0,0,80577,26124),
(127826,'Our riders wage war against the Legion in the skies. Give aid to those who have fallen. We must hold this point!','',0,0,0,0,0,0,0,0,0,0,80554,0,26124),
(127827,'Our riders will take it from here. Continue your fight, champion.','',0,0,0,0,0,0,0,0,0,0,80555,0,26124),
(127828,'I\'ve already completed my training.','I\'ve already completed my training.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127829,'Finish your drinks! We\'re leaving in less than a minute!','Finish your drinks! We\'re leaving in less than a minute!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127830,'Merry is the day, for we have found the jewelry!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127831,'Teleport me to the next tavern.','Teleport me to the next tavern.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127832,'It is amusing how you continue to fight, even though you\'re bound to lose.','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(127833,'Your fighting style does not impress, nor concern me. You will fall to my strength soon.','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(127834,'You\'re so tiny! It\'s like playing with a rabbit.','',0,0,0,0,0,0,1,0,6,0,0,0,26124),
(127835,'How may I assist you?','How may I assist you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127836,'I want to donate War Supplies to the Mage Tower.','I want to donate War Supplies to the Mage Tower.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127852,'Take me into the Deadmines.','Take me into the Deadmines.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127853,'There is a lot of movement within the Deadmines. \n\nI suspect the place has been infested with all manner of creatures. Shall we investigate?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127854,'Dodge this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127855,'Coming at ya!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127856,'Think fast!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127857,'Incoming!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127858,'Hey, catch!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127859,'What... what happened? This isn\'t the lodge!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127860,'My head... what happened?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127861,'Where... where am I?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127862,'That thing... it got into my head. I couldn\'t stop!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127863,'I... I feel sick.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127864,'What... what happened to me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127865,'This is as far as I can take you. Let\'s hope your companions are strong enough to get you the rest of the way.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127866,'They took the kegs!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127867,'Jona, Joren, go after the Gnomenbrau! A group of troggs carried it off!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127868,'Soren lad, find the boar that stole our Theramore Pale!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127869,'I\'ll chase the trolls to their cave and find the Stormhammer Stout!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127870,'Neither snow nor cataclysm nor demon invasion will stay us from our appointed duty. The mail must flow.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(127889,'The Mage Tower is now under construction.','The Mage Tower is now under construction.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127890,'The Mage Tower is under attack!','The Mage Tower is under attack!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127891,'The Mage Tower is destroyed, it will be back up soon.','The Mage Tower is destroyed, it will be back up soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127893,'Well done. We simply can\'t have improper mail clogging up the system.','',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(127894,'No need to track down the sender. The tubes will handle that!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(127897,'','The Burning Legion marches on Highmountain! Our allies have engaged the demons throughout our lands. To turn the tide, champion, you must strike at the heart of their forces!',0,0,0,0,0,0,0,0,0,0,0,81472,26124),
(127898,'','Well fought! Our forces are gaining gr...',0,0,0,0,0,0,0,0,0,0,0,81474,26124),
(127899,'To Thunder Totem! My riders will hold the skies while you sweep the grounds.','',0,0,0,0,0,0,0,0,0,0,81469,0,26124),
(127900,'','The very wildlife of Highmountain rises up against the demons! Shatter the infernals and find the source of their incursion.',0,0,0,0,0,0,0,0,0,0,0,80580,26124),
(127901,'','The Legion underestimates nature\'s persistence and determination... and yours, I think!',0,0,0,0,0,0,0,0,0,0,0,80581,26124),
(127902,'We need everyone on the front line. Another wave of demons is incoming!','',0,0,0,0,0,0,0,0,0,0,80643,0,26124),
(127903,'That bought us a brief reprieve. My Illidari can hold the line from here.','',0,0,0,0,0,0,0,0,0,0,80644,0,26124),
(127904,'Valarjar of Skyhold! Let these walls resound with cheers for our champion!','',0,0,0,0,0,0,0,0,0,0,83108,0,26124),
(127905,'','|TInterface\\Icons\\Ability_Butcher_Whirl.blp:20|t%s begins to cast |cFFFF0000|Hspell:232722|h[Slicing Tornado]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(127906,'','|TInterface\\Icons\\TRADE_ARCHAEOLOGY_SHARK JAWS:20|t%s calls forth the mighty Sarukel to open his |cFFFF0000|Hspell:234621|h[Devouring Maw]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(127907,'|TInterface\\Icons\\SPELL_WARLOCK_SOULBURN:20|tThe %s begins to emit a series of |cFFFF0000|Hspell:236011|h[Tormented Cries]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(127908,'','|TInterface\\Icons\\ABILITY_WARLOCK_SOULLINK:20|t%s chains together living essence with |cFFFF0000|Hspell:236449|h[Soulbind]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(127909,'','|TInterface\\Icons\\SPELL_SHADOW_SHADESOFDARKNESS:20|t%s begins to release a mass of |cFFFF0000|Hspell:236075|h[Wailing Souls]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(127910,'','Together we\'ll shatter the bones of countless demons!',0,0,0,0,0,0,0,0,0,0,0,81285,26124),
(127911,'|TInterface\\Icons\\Spell_Deathknight_Defile:20|tWith no souls in the Corporeal Realm, the %s lashes out with |cFFFF0000|Hspell:236507|h[Quietus]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(127912,'','|TInterface\\Icons\\Spell_Deathknight_Defile:20|tWith no souls in the Spirit Realm, %s lashes out with |cFFFF0000|Hspell:236507|h[Quietus]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(127913,'Oh, am I glad ta see ya! Our brothers and sisters\'re fightin\' down tha ramp, but they\'re out of brew!$b$bThese confounded beasts are stampedin\' through, so we cannae roll the barrels down without someone...$b$bThat gives me an idea...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127914,'Simple! Ye ride down on tha barrel. $b$bWith yer fancy footwork ye can dodge tha stampede an\' deliver the brew! As me master always said: \'If ye can dodge a horse on a barrel, ye can dodge a punch.\'$b$bMe trainin\' was... exotic. Look, just hop on tha barrel, keep rollin\' till ye reach the patrol, an watch out for the horses on the way down!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127915,'Do I look like a warlock to ye? I haven\'t the foggiest clue why. Maybe this is some sort o\' seasonal stampede, where the dreadsteeds are a-runnin for a migration, or matin\' season, or runnin\' from somethin\'...$b$bOr maybe they\'re just runnin\' through here to stop us from easily deliverin\' our brew!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127916,'What\'s the plan?','What\'s the plan?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127917,'What\'s causing the stampede, anyway?','What\'s causing the stampede, anyway?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127918,'Fair enough.','Fair enough.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127919,'|TInterface\\Icons\\ACHIEVEMENT_BOSS_LORDMARROWGAR:20|tThe %s shudders and retches forth The Desolate Host, overloading the soul conduits!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(127920,'','Ah, nevermind. Just wait until Mograine sees us flying up. He\'ll get chills!',0,0,0,0,0,0,0,0,0,0,0,82861,26124),
(127921,'The Soulstone is in place. Use the Arcane Matrix to fire up the city\'s defenses!','',1,0,0,0,0,0,0,0,0,0,82777,0,26124),
(127922,'Business is good.$b$bReal good.$b$b<Nargle tucks a few coins into his pocket.>$b$bMister Noggenfogger will be pleased- keep it up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127923,'Superbly done, Archmage! I never doubted your success. To the Archmage! To the Tirisgarde!','',22,0,0,0,0,0,0,0,0,0,82511,0,26124),
(127928,'Did it work?','',0,0,0,0,0,0,6,0,0,0,82564,0,26124),
(127929,'There is nowhere you can flee that I cannot reach you, demon!','',0,0,0,0,0,0,0,0,0,0,80478,0,26124),
(127930,'Ah, our guests of honor have finally arrived. I look forward to ripping those horns from your skull, Betrayer!','',0,0,0,0,0,0,0,0,0,0,80493,0,26124),
(127931,'','Illidan! Curse that impetuous demon hunter!',0,0,0,0,0,0,0,0,0,0,0,80486,26124),
(127932,'','Illidan left behind a mess! Stay close... we shall carve a path through these demons.',0,0,0,0,0,0,0,0,0,0,0,80487,26124),
(127933,'','I will continue the hunt for Illidan. You deal with those abominations.',0,0,0,0,0,0,0,0,0,0,0,80488,26124),
(127934,'Demons bar the path ahead, but they cannot withstand our fury.','',0,0,0,0,0,0,0,0,0,0,80479,0,26124),
(127935,'I will track the Dreadlord. You deal with the rest of the filth.','',0,0,0,0,0,0,0,0,0,0,80480,0,26124),
(127936,'','Did you really think you could elude me, Illidan? Run again and I\'ll shackle you like the beast you are.',0,0,0,0,0,0,0,0,0,0,0,80489,26124),
(127937,'Posture if you must, Maiev, but for now, do what you do best and follow me.','',0,0,0,0,0,0,0,0,0,0,80481,0,26124),
(127938,'There is nowhere left to run, demon!','',0,0,0,0,0,0,0,0,0,0,80482,0,26124),
(127939,'','So much death here... so much power!',0,0,0,0,0,0,0,0,0,0,0,80537,26124),
(127940,'','Is this not the site of what you mortals consider your greatest humiliation? I hope you fare better this time...',0,0,0,0,0,0,0,0,0,0,0,80538,26124),
(127941,'','I don\'t believe these lands have seen such carnage since the Battle for K\'tanth. Such a long time ago...',0,0,0,0,0,0,0,0,0,0,0,80539,26124),
(127942,'Run? Fool! I have led you to the slaughter!','',0,0,0,0,0,0,0,0,0,0,80494,0,26124),
(127943,'Beware the shadows!','',0,0,0,0,0,0,0,0,0,0,80495,0,26124),
(127944,'You cannot withstand the power of the Legion!','',0,0,0,0,0,0,0,0,0,0,80496,0,26124),
(127945,'It amuses me to watch you suffer!','',0,0,0,0,0,0,0,0,0,0,80497,0,26124),
(127946,'I tire of these games! Let us see how you fare without your little trinket.','',0,0,0,0,0,0,0,0,0,0,80498,0,26124),
(127947,'How kind of you to bring the Aegis to me!','',0,0,0,0,0,0,0,0,0,0,80499,0,26124),
(127948,'Surrender the shield and I will grant you a quick death!','',0,0,0,0,0,0,0,0,0,0,80500,0,26124),
(127949,'','This was always a place of power. Aegwynn was drawn here, and before her the elves, and before them the trolls. And before them...',0,0,0,0,0,0,0,0,0,0,0,80540,26124),
(127950,'','That fel edifice towering over this land pales in comparison to the grandeur of what stood here long ago.',0,0,0,0,0,0,0,0,0,0,0,80541,26124),
(127951,'','It was here, in ages past, that the God of the Deep lost a great battle to the God of Seven Heads. But as was so often the case, even defeat ultimately worked in N\'Zoth\'s favor.',0,0,0,0,0,0,0,0,0,0,0,80542,26124),
(127952,'The final... victory... will be ours...','',0,0,0,0,0,0,0,0,0,0,80501,0,26124),
(127953,'','This trifling skirmish is little more than a distraction. The true battle draws nigh as the circle nears completion.',0,0,0,0,0,0,0,0,0,0,0,80543,26124),
(127954,'','This conflict is but a shadow of an ancient war that predated the meddling of the titans. Infinite armies clashed in ceaseless battle. But I\'m sure your little war is impressive... in its own way.',0,0,0,0,0,0,0,0,0,0,0,80544,26124),
(127955,'','It took ages to make my return to the surface after the Sundering. The naga can be so possessive of artifacts.',0,0,0,0,0,0,0,0,0,0,0,80545,26124),
(127956,'','This land has seen so much upheaval. The Cataclysm, the Sundering, the Scouring... you really have no idea.',0,0,0,0,0,0,0,0,0,0,0,80546,26124),
(127957,'','You were a good choice. No other wielder has murdered their way across a continent quite like you have. I admire your endurance.',0,0,0,0,0,0,0,0,0,0,0,80547,26124),
(127958,'','The Light would have your kind remain obedient and stagnant. I offer the gifts of freedom and strength. I hope you remember my kindness.',0,0,0,0,0,0,0,0,0,0,0,80548,26124),
(127959,'','Your allies consider me a bad influence. Yet all I\'ve ever done is speed you along the path you chose.',0,0,0,0,0,0,0,0,0,0,0,80549,26124),
(127960,'','I can feel the pulse of your world quickening. Soon all will be drenched in its lifeblood.',0,0,0,0,0,0,0,0,0,0,0,80550,26124),
(127961,'','A Legion brute obliterating priceless knowledge... imagine that.',0,0,0,0,0,0,0,0,0,0,0,80505,26124),
(127962,'','Long has this one been a blight upon your world. Not all his schemes came to fruition, but those that did caused untold ruin.',0,0,0,0,0,0,0,0,0,0,0,80506,26124),
(127963,'','From birth, pit lords are oversized and stupid. Somehow the Legion manages to magnify both traits.',0,0,0,0,0,0,0,0,0,0,0,80528,26124),
(127964,'','At times it seems the naga beg for scraps from the Legion\'s table. But the queen they serve wants far more than that.',0,0,0,0,0,0,0,0,0,0,0,80529,26124),
(127965,'','I do enjoy seeing the shrine of a great enemy profaned by the spirits of its own worshippers.',0,0,0,0,0,0,0,0,0,0,0,80530,26124),
(127966,'','The haughty elves of old had such regard for their own spirits. Such a delicious indignity!',0,0,0,0,0,0,0,0,0,0,0,80531,26124),
(127967,'','Invaders messily corrupting other invaders... typical. Far more useful to coax them along the proper path, don\'t you think?',0,0,0,0,0,0,0,0,0,0,0,80532,26124),
(127968,'','Let me guide your hand as you battle this vessel. Though it retains but a fraction of the fallen titan\'s power, you will not survive its onslaught without my expertise.',0,0,0,0,0,0,0,0,0,0,0,80533,26124),
(127969,'','You must face the Deceiver on his own ground, where he is vulnerable. Come, let us taste his soul!',0,0,0,0,0,0,0,0,0,0,0,80534,26124),
(127970,'Kil\'jaeden sends his gratitude for delivering the Aegis into our hands.','',0,0,0,0,0,0,0,0,0,0,80466,0,26124),
(127971,'','Hey you! You\'re the one the tauren was talking about!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(127972,'','Trying to foil our plot again? Hah!',0,0,0,0,0,0,11,0,0,0,0,0,26124),
(127973,'','As if someone so puny could stop us...',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(127974,'','Besides, if you ever hurt one hair on my sweet tauren\'s head, you\'d have a REAL problem to deal with...',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(127975,'','ME!',0,0,0,0,0,0,15,0,0,0,0,0,26124),
(127976,'','No matter. I already have what I came for.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(127977,'','You better hope we don\'t meet again.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(127978,'','I don\'t have time for silly catch phrases. So, I\'ll just do a cool exit instead.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(127979,'','Power Leap!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(127980,'This one... is strong. No matter! These souls will serve the master well.','',0,0,0,0,0,0,0,0,0,0,82798,0,26124),
(127981,'','The shadowy figure pulls a vial of goo from the cauldron.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(127982,'','A remnant of power lingers in this broken temple. It must be ours! Come, enter the circle and take it.',0,0,0,0,0,0,0,0,0,0,0,80535,26124),
(127983,'My axe hungers for flesh!','',0,0,0,0,0,0,0,0,0,0,80467,0,26124),
(127984,'Legion! Scorch them to the bone!','',0,0,0,0,0,0,0,0,0,0,80468,0,26124),
(127985,'Fiends! Tear down that shield!','',0,0,0,0,0,0,0,0,0,0,80469,0,26124),
(127986,'Infernals! Devastate their ranks!','',0,0,0,0,0,0,0,0,0,0,80470,0,26124),
(127987,'Their shield has fallen! Leave no survivors!','',0,0,0,0,0,0,0,0,0,0,80471,0,26124),
(127988,'The full might of the Legion falls upon you!','',0,0,0,0,0,0,0,0,0,0,80472,0,26124),
(127989,'Your flesh will burn!','',0,0,0,0,0,0,0,0,0,0,80473,0,26124),
(127990,'This world... will belong... to the Legion...','',0,0,0,0,0,0,0,0,0,0,80474,0,26124),
(127991,'I will hold this flank. Can you manage to survive without me, warden?','',0,0,0,0,0,0,0,0,0,0,80483,0,26124),
(127992,'Still alive, Maiev?','',0,0,0,0,0,0,0,0,0,0,80484,0,26124),
(127993,'','I would regret it if you died by another\'s hand, Betrayer!',0,0,0,0,0,0,0,0,0,0,0,80490,26124),
(127994,'','Forgive me if my glaive finds your heart, Illidan. With so many demons about, it\'s hard to distinguish you from the rest of this filth.',0,0,0,0,0,0,0,0,0,0,0,80491,26124),
(127995,'','Wardens, secure the cathedral! We will hold here while our allies push into the tomb below.',0,0,0,0,0,0,0,0,0,0,0,80492,26124),
(127996,'','My mistake. It seems the upstart \"goddess\" still holds sway here. Oh well...',0,0,0,0,0,0,0,0,0,0,0,80536,26124),
(127997,'','It is here the Feltotem receive demonic instruction. Cleanse the cavern of their evil and send their masters back to the Twisting Nether!',0,0,0,0,0,0,0,0,0,0,0,80578,26124),
(127998,'','Thank you, hero. You\'ve done the tribes of Highmountain a great service this day.',0,0,0,0,0,0,0,0,0,0,0,80579,26124),
(127999,'The Maw of the Damned begins to tug at your grip as you approach the Deceiver.','The Maw of the Damned begins to tug at your grip as you approach the Deceiver.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128000,'Your resilient spirit resists the foul fel magic!','Your resilient spirit resists the foul fel magic!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128001,'At long last! Revenge... revenge is mine!','',0,0,0,0,0,0,0,0,0,0,80511,0,26124),
(128002,'At last I am free!','',0,0,0,0,0,0,603,0,0,0,81669,0,26124),
(128003,'','Nerus? Explain yourself, uncle!',0,0,0,0,0,0,603,0,4,0,0,81665,26124),
(128004,'You must understand! I was trying to protect our family...','',0,0,0,0,0,0,1,0,0,0,81670,0,26124),
(128005,'But in the end, the pact I made cursed our ancestors with a fate worse than death.','',0,0,0,0,0,0,1,0,0,0,81671,0,26124),
(128006,'Their spirits are bound to the Legion, forced to do the demons\' bidding.','',0,0,0,0,0,0,1,0,0,0,81672,0,26124),
(128007,'','This... this is your doing? How could you?',0,0,0,0,0,0,603,0,0,0,0,81666,26124),
(128008,'I am so sorry, Delas. I know it is too much to ask your forgiveness, but I must ask for your help.','',0,0,0,0,0,0,1,0,0,0,81668,0,26124),
(128009,'The wreckage of our prior assault on these shores contains supplies vital to our efforts against the Burning Legion.','',0,0,0,0,0,0,0,0,0,0,83282,0,26124),
(128010,'Clear the beach of demonic forces and recover the salvaged supplies for the invasion effort.','',0,0,0,0,0,0,0,0,0,0,83283,0,26124),
(128011,'','I claim your lives for Azshara!',0,0,0,0,0,0,0,0,0,0,0,81499,26124),
(128012,'','Meet your end, mortal filth!',0,0,0,0,0,0,0,0,0,0,0,81500,26124),
(128013,'','Time to feed the fish!',0,0,0,0,0,0,0,0,0,0,0,81501,26124),
(128014,'','Chumming the waters!',0,0,0,0,0,0,0,0,0,0,0,81502,26124),
(128015,'','Ten thousand years haven\'t made mortals any less pathetic!',0,0,0,0,0,0,0,0,0,0,0,81503,26124),
(128016,'','Queen Azshara\'s reign is absolute... as ever!',0,0,0,0,0,0,0,0,0,0,0,81504,26124),
(128017,'','Oh! The... indignity...',0,0,0,0,0,0,0,0,0,0,0,81505,26124),
(128018,'','Such a death... is beneath me...',0,0,0,0,0,0,0,0,0,0,0,81506,26124),
(128019,'','Consume them!',0,0,0,0,0,0,0,0,0,0,0,81507,26124),
(128020,'','Feast upon flesh!',0,0,0,0,0,0,0,0,0,0,0,81508,26124),
(128021,'','The sea surges with power!',0,0,0,0,0,0,0,0,0,0,0,81509,26124),
(128022,'','Death rises to take you!',0,0,0,0,0,0,0,0,0,0,0,81510,26124),
(128023,'','Suffer the chill of the depths!',0,0,0,0,0,0,0,0,0,0,0,81511,26124),
(128024,'','Your souls belong to the deep!',0,0,0,0,0,0,0,0,0,0,0,81512,26124),
(128025,'','The depths will devour you!',0,0,0,0,0,0,0,0,0,0,0,81513,26124),
(128026,'','My pet will swallow you whole!',0,0,0,0,0,0,0,0,0,0,0,81514,26124),
(128027,'Petty mortal. You gain nothing! You will bow... or you will BURN!','',0,0,0,0,0,0,0,0,0,0,81468,0,26124),
(128028,'Well done. With the demons slain and the supplies recovered, we are one step closer to securing the Broken Shore.','',0,0,0,0,0,0,0,0,0,0,83284,0,26124),
(128030,'I\'m ready to take on Xylem. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','I\'m ready to take on Xylem. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128031,'I\'m ready to face Raest. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','I\'m ready to face Raest. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128032,'','These fools bring the Tidestone to us! Just as our blessed queen foresaw!',0,0,0,0,0,0,0,0,0,0,0,81515,26124),
(128033,'','Slay the intruders! Take back what is ours!',0,0,0,0,0,0,0,0,0,0,0,81516,26124),
(128034,'','Weaklings! You dare disappoint our queen?',0,0,0,0,0,0,0,0,0,0,0,81517,26124),
(128035,'','Incompetents! Must I soil my hands on this rabble?',0,0,0,0,0,0,0,0,0,0,0,81518,26124),
(128036,'','Enough of these failures! Now you will face the true might of the naga!',0,0,0,0,0,0,0,0,0,0,0,81519,26124),
(128037,'','Harjatan! Pummel their bones to dust!',0,0,0,0,0,0,0,0,0,0,0,81520,26124),
(128038,'','Quiet, you mindless oaf! Kill them!',0,0,0,0,0,0,0,0,0,0,0,81521,26124),
(128039,'','Useless beast! Why the queen was fond of him I\'ll never know!',0,0,0,0,0,0,0,0,0,0,0,81522,26124),
(128040,'','Minions! To battle!',0,0,0,0,0,0,0,0,0,0,0,81523,26124),
(128041,'','Lend aid to our brutish champion!',0,0,0,0,0,0,0,0,0,0,0,81524,26124),
(128042,'','You! Fetch me the Tidestone!',0,0,0,0,0,0,0,0,0,0,0,81525,26124),
(128043,'','More death! More carnage!',0,0,0,0,0,0,0,0,0,0,0,81526,26124),
(128044,'Bal, lamer zhita!','',0,0,0,0,0,0,0,0,0,0,81944,0,26124),
(128045,'Come, little friends! Crush!','',0,0,0,0,0,0,0,0,0,0,81945,0,26124),
(128046,'Ash\'thero sanguine!','',0,0,0,0,0,0,0,0,0,0,81946,0,26124),
(128047,'Time to smash!','',0,0,0,0,0,0,0,0,0,0,81947,0,26124),
(128048,'Harjatan... fail... pretty queen...','',0,0,0,0,0,0,0,0,0,0,81948,0,26124),
(128049,'Harjatan... no fight... so good...','',0,0,0,0,0,0,0,0,0,0,81949,0,26124),
(128050,'I\'m ready to face Kruul. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','I\'m ready to face Kruul. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128051,'Die for pretty queen!','',0,0,0,0,0,0,0,0,0,0,81950,0,26124),
(128052,'Alana be\'lendor','',0,0,0,0,0,0,0,0,0,0,81951,0,26124),
(128053,'','Things are still a bit foggy, but I can stand and fight.',0,0,0,0,0,0,1,0,0,0,0,82472,26124),
(128054,'','Take my death gate or open your own. Either way, I\'ll see you in Acherus.',0,0,0,0,0,0,1,0,0,48044,0,81291,26124),
(128055,'The Legion has conquered this shore. Soon we shall conquer the Legion in turn!','',0,0,0,0,0,0,0,0,0,0,80512,0,26124),
(128056,'This place holds a mere fraction of the Legion\'s might. There are many horrors yet to behold.','',0,0,0,0,0,0,0,0,0,0,80513,0,26124),
(128057,'Do you smell the charred flesh upon the wind? Ah, the scent of home!','',0,0,0,0,0,0,0,0,0,0,80514,0,26124),
(128058,'Your last visit here was nearly the end of you. How fortunate that you now enjoy my company.','',0,0,0,0,0,0,0,0,0,0,80515,0,26124),
(128059,'This place is so like Argus... twisted, shattered, and broken. Almost makes me homesick!','',0,0,0,0,0,0,0,0,0,0,80516,0,26124),
(128060,'Your skills have improved significantly since we first met. Given a few thousand years, you may even rise to the level of my best apprentices.','',0,0,0,0,0,0,0,0,0,0,80517,0,26124),
(128061,'And here we are, the site where fools were vanquished. Remember, courage is no substitute for power.','',0,0,0,0,0,0,0,0,0,0,80518,0,26124),
(128062,'Do you sense it? The lifeblood of your world flows just under the surface of this place.','',0,0,0,0,0,0,0,0,0,0,80519,0,26124),
(128063,'I know ancient incantations which could tap into the lifeblood of your world. This would be an ideal place to unleash them.','',0,0,0,0,0,0,0,0,0,0,80520,0,26124),
(128064,'This one is powerful, but stupid. It would make a worthless minion.','',0,0,0,0,0,0,0,0,0,0,80502,0,26124),
(128065,'Ah, my former master! The time for revenge is at hand!','',0,0,0,0,0,0,0,0,0,0,80503,0,26124),
(128066,'Demon... worshippers?','',0,0,0,0,0,0,6,0,0,0,82381,0,26124),
(128067,'%s blinks, looking puzzled. His eyes glow with fel energy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128068,'','What\'s... happening? Blood feels... like it\'s boiling... I... I...',0,0,0,0,0,0,6,0,0,0,0,82473,26124),
(128069,'That fool saw me as little more than a trinket for harvesting power. He has paid for his lack of vision!','',0,0,0,0,0,0,0,0,0,0,80504,0,26124),
(128070,'','DEMONS! ALL OF YA!',0,0,0,0,0,0,5,0,0,0,0,82483,26124),
(128071,'I know I have much to answer for.','',0,0,0,0,0,0,1,0,0,0,80797,0,26124),
(128072,'','Indeed you do, uncle. But this is a start, I suppose...',0,0,0,0,0,0,1,0,0,0,0,81667,26124),
(128073,'The naga are a corrupted race. They possess arcane skill, but lack the finesse inherent to my people.','',0,0,0,0,0,0,0,0,0,0,80521,0,26124),
(128074,'I detest spirits! Always blathering about their former lives. Consume their souls and be done with them!','',0,0,0,0,0,0,0,0,0,0,80522,0,26124),
(128075,'An intriguing use of soul energy. They could have accomplished so much, had they merely applied themselves.','',0,0,0,0,0,0,0,0,0,0,80523,0,26124),
(128076,'Ugh! This place reeks of the titans!','',0,0,0,0,0,0,0,0,0,0,80524,0,26124),
(128077,'Careful! Power still echoes within this ancient golem. It would be prudent to destroy it before the Legion empowers it further.','',0,0,0,0,0,0,0,0,0,0,80525,0,26124),
(128078,'The Deceiver scorned my talents when I still lived. Let us see which of us survives the battle to come!','',0,0,0,0,0,0,0,0,0,0,80526,0,26124),
(128079,'Ah, the skies of home! I did not believe I would see this world again.','',0,0,0,0,0,0,0,0,0,0,80527,0,26124),
(128080,'They may never forgive me for what I have done, but at least they will be safe. For now, my family will be safe.','',0,0,0,0,0,0,1,0,5,0,81673,0,26124),
(128081,'The weight of my decision weighs heavy on my heart, but each day I see their carefree smiles eases that burden just a little.','',0,0,0,0,0,0,1,0,0,0,81674,0,26124),
(128082,'My gift to them is the bliss of ignorance. They will not realize its price until it is too late. What is done is done. I hope I have made the right choice.','',0,0,0,0,0,0,1,0,0,0,81675,0,26124),
(128083,'You no take my boat! Birds to da cannons! Monkeys to da sails!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128084,'Can\'t get past me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128085,'Nope!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128086,'Nuh-uh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128087,'Where you goin\'?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128088,'|TINTERFACE\\ICONS\\SPELL_FEL_INCINERATE.BLP:20|t You have |cFFFF0000|Hspell:235117|h[Unstable Soul]|h|r!','|TINTERFACE\\ICONS\\SPELL_FEL_INCINERATE.BLP:20|t You have |cFFFF0000|Hspell:235117|h[Unstable Soul]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128089,'','Excuse me, $n! Some of those disasters you have previously delayed are now actionable. Please speak with me.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128090,'I\'m ready to face Sigryn. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','I\'m ready to face Sigryn. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128092,'Gurrg mrggll!?','',0,0,0,0,0,0,0,0,0,0,8475,0,26124),
(128093,'Murgg gur gr gr grulgl!','',0,0,0,0,0,0,0,0,0,0,8475,0,26124),
(128094,'Gurg gar gur gal!','',0,0,0,0,0,0,0,0,0,0,8475,0,26124),
(128095,'Grulgrug grull murg gruumblg!?','',0,0,0,0,0,0,0,0,0,0,8475,0,26124),
(128096,'Murglag!','',0,0,0,0,0,0,0,0,0,0,33164,0,26124),
(128097,'Gurg murglgl!','',0,0,0,0,0,0,0,0,0,0,33164,0,26124),
(128098,'Gurg glurgggll!!','',0,0,0,0,0,0,0,0,0,0,33164,0,26124),
(128099,'I\'m ready to face Tugar Bloodtotem. (Free)','I\'m ready to face Tugar Bloodtotem. (Free)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128100,'Send me to Shadowsong. (Free)','Send me to Shadowsong. (Free)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128101,'Aghhhhh! It burns, it burns!','Aghhhhh! It burns, it burns!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128102,'Everything is green, I can\'t see!','Everything is green, I can\'t see!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128103,'My flesh feels like it\'s falling off the bone!','My flesh feels like it\'s falling off the bone!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128104,'AHHHHHH!!!','AHHHHHH!!!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128105,'I can\'t-','I can\'t-',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128106,'Stop!','Stop!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128107,'My bones!','My bones!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128108,'Make it stop!','Make it stop!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128109,'Argh!','Argh!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128110,'You there, help me!','You there, help me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128111,'Just let me-','Just let me-',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128112,'I\'ll talk-','I\'ll talk-',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128113,'Take me to Agatha... (Free)','Take me to Agatha... (Free)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128114,'','It was an honor to meet you, Grandmaster. I hope to see you again soon!',0,0,0,0,0,0,0,0,0,0,0,82089,26124),
(128115,'I\'m ready to take on Xylem. (Free)','I\'m ready to take on Xylem. (Free)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128116,'I\'m ready to face Raest. (Free)','I\'m ready to face Raest. (Free)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128117,'I\'m ready to face Kruul. (Free)','I\'m ready to face Kruul. (Free)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128118,'I\'m ready to face Sigryn. (Free)','I\'m ready to face Sigryn. (Free)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128119,'|TInterface\\ICONS\\Ability_IronMaidens_ConvulsiveShadows.blp:20|t The Fallen Avatar targets you with |cFFFF0404|Hspell:236604|h[Shadowy Blades]|h|r!','|TInterface\\ICONS\\Ability_IronMaidens_ConvulsiveShadows.blp:20|t The Fallen Avatar targets you with |cFFFF0404|Hspell:236604|h[Shadowy Blades]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(128120,'The darkness is gone! Thank you, hero.','The darkness is gone! Thank you, hero.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(128121,'Where... am I?','Where... am I?',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(128122,'I can see clearly now!','I can see clearly now!',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(128123,'I\'m just going to rest for a moment...','I\'m just going to rest for a moment...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128124,'Ouch! Why would you do that to me?','Ouch! Why would you do that to me?',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(128125,'Rude!','Rude!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(128126,'That stings!','That stings!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(128127,'What in the void-stricken darkness...?','What in the void-stricken darkness...?',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(128128,'Yikes! I\'m out of here!','Yikes! I\'m out of here!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(128129,'','I\'ll get the flame. I\'ve been looking forward to this!',0,0,0,0,0,0,0,0,0,0,0,81298,26124),
(128130,'Welcome to my peak, $ct.$b$bI am the last remaining ancient watcher of the Drekirjar. I make my home here, tending to the sacred bodies of our allies who gave their lives for our alliance. Skovald may have shattered our alliance with the Thorignir, but there are those of us who do not follow his mandates.$b$bTo this day, the Thorignir die in our joint struggle. It is all I can do to attend them as their bodies return to the snow. With Daumyr as my partner, we protect our charges with our lives.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128131,'I\'m raising these Thorignir as my soldiers, and Daumyr is next.','I\'m raising these Thorignir as my soldiers, and Daumyr is next.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128132,'You shall not turn my allies into your mindless slaves!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128133,'I am... uh... we... are...','',0,0,0,0,0,0,0,0,0,0,82377,0,26124),
(128134,'The pendulum swings in our favor! Make for the cliffs and dispose of that demon. I will meet you there once we\'ve secured the skies.','',0,0,0,0,0,0,0,0,0,0,81470,0,26124),
(128135,'','Insolent pests! Your efforts amount to NOTHING!',0,0,0,0,0,0,0,0,0,0,0,81477,26124),
(128136,'What delicious irony! The demons are so quick to turn on one another!','',0,0,0,0,0,0,0,0,0,0,82447,0,26124),
(128137,'Enjoy the chaos...','',0,0,0,0,0,0,0,0,0,0,82448,0,26124),
(128138,'Our shores are ablaze with fel fire! Strike quickly, before the threat moves inland.','',0,0,0,0,0,0,0,0,0,0,80591,0,26124),
(128139,'Well fought! Every victory is crucial in this war.','',0,0,0,0,0,0,0,0,0,0,80592,0,26124),
(128140,'Such depravity! The demons drain the souls of innocents to power their foul magic. Stop this harvest, hero!','',0,0,0,0,0,0,0,0,0,0,80552,0,26124),
(128141,'I have no love of murlocs, but even they don\'t deserve to meet their end in the Legion\'s clutches. Thank you, hero.','',0,0,0,0,0,0,0,0,0,0,80553,0,26124),
(128142,'','How did the Legion learn about our Storm Brew? We\'ve kept its existence quiet...',0,0,0,0,0,0,0,0,0,0,0,82082,26124),
(128143,'Your efforts are far too late, pathetic creatures...','',0,0,0,0,0,0,0,0,0,0,82683,0,26124),
(128144,'You thought you could escape by huddling in your puny brewery? The Burning Legion sees all!','',0,0,0,0,0,0,0,0,0,0,82684,0,26124),
(128145,'These cowardly demons hide behind their defenses. Take my blessed hammer and slay them!','',0,0,0,0,0,0,0,0,0,0,83250,0,26124),
(128146,'Destroy their cannons and bring down their barriers! Let our valiant Valarjar face them in the true spirit of battle!','',0,0,0,0,0,0,0,0,0,0,83251,0,26124),
(128147,'Fly swiftly, $ct. We will meet you there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128148,'Well done, hero. The tales of your deeds will be sung within the Halls of Valor!','',0,0,0,0,0,0,0,0,0,0,83252,0,26124),
(128149,'I suggest we be quick. The skies are swarming with those foul beasts.\n\nOur opportunity to strike at the heart of the Legion presents itself. We must bring the battle to the frontlines.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128150,'For the honor of Highmountain. I am ready! [Queue for Scenario]','For the honor of Highmountain. I am ready! [Queue for Scenario]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128151,'','Your precious world will burn!',0,0,0,0,0,0,0,0,0,48108,0,82701,26124),
(128152,'','<Daumyr nods to you, a hollow look in her eyes.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128153,'Time to go to Broken Shore, Daumyr.','Time to go to Broken Shore, Daumyr.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128154,'The azure drakes in the area have pledged to help us fight back against the Legion, but they\'ll need your help. Assist them in any way you can.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128155,'The drakes are providing us transport up to the Legion ship to deal with the their commander in the area. Once you\'ve dealt with him, they\'ll return to get you before the main assault on the ship begins.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128156,'$n! To me, quickly! We end this now!','',0,0,0,0,0,0,1,0,0,0,81471,0,26124),
(128157,'With their commander down and shields disabled, the blue drakes can begin their assault on the ship in earnest. Their sending transport to extract you before they start.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128158,'Felweaver! Deal with these intruders!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128159,'Come, champions of this world, so that I may cut you down where you stand!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128160,'','Know the torment of a soul divided!',0,0,0,0,0,0,0,0,0,0,0,81413,26124),
(128161,'','I did not choose my fate... neither will you!',0,0,0,0,0,0,0,0,0,0,0,81414,26124),
(128162,'','Storm Brew is amazing! No wonder the Legion fears it!',0,0,0,0,0,0,0,0,0,0,0,82084,26124),
(128163,'','Grandmaster, you have done better than I expected. Seems I will have to deal with you myself!',0,0,0,0,0,0,0,0,0,0,0,82441,26124),
(128164,'','Brewmaster? What are you talking about? We\'ve been searching everywhere for you!',0,0,0,0,0,0,0,0,0,0,0,82085,26124),
(128165,'','Almai, your naivete is so refreshing. Pity you must die!',0,0,0,0,0,0,0,0,0,0,0,82442,26124),
(128166,'','So much for that.',0,0,0,0,0,0,274,0,0,0,0,0,26124),
(128168,'My work is complete, puny monks. Your order has already fallen!','',0,0,0,0,0,0,0,0,0,0,82691,0,26124),
(128169,'','What... What just happened? What did she mean? Grandmaster, we must return to the temple at once! Let me know when you\'re ready!',0,0,0,0,0,0,0,0,0,0,0,82086,26124),
(128170,'','Brewmaster! NO!',0,0,0,0,0,0,0,0,0,0,0,82087,26124),
(128171,'I would like to leave the Deadmines.','I would like to leave the Deadmines.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128172,'I fear no beast! The Legion is endless!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128173,'Back for more? My hounds will tear you to shreds!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128174,'If this is the best hunter your world has, it is truly doomed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128175,'Rise, my soldiers!','',0,0,0,0,0,0,0,0,0,0,82458,0,26124),
(128176,'Your commander beckons!','',0,0,0,0,0,0,0,0,0,0,82451,0,26124),
(128177,'The power courses within you! Destroy these demons!','',0,0,0,0,0,0,0,0,0,0,82452,0,26124),
(128178,'Rise! Yes... rise!','',0,0,0,0,0,0,0,0,0,0,82453,0,26124),
(128179,'The time has come! Your destiny is at hand!','',0,0,0,0,0,0,0,0,0,0,82454,0,26124),
(128180,'Let\'s ride.','Let\'s ride.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128181,'','My duty is one mere mortals cannot comprehend. A sacred charge to serve... to serve the master!',0,0,0,0,0,0,0,0,0,0,0,81411,26124),
(128182,'','I am compelled to... ensure... the end of your existence!',0,0,0,0,0,0,0,0,0,0,0,81412,26124),
(128183,'They are strong, with blood warmer than summer\'s heat. I assure you they will recover in time, but we must do our part and get back out there! Our people need us!','They are strong, with blood warmer than summer\'s heat. I assure you they will recover in time, but we must do our part and get back out there! Our people need us!',0,0,0,0,0,0,1,0,0,47028,0,0,26124),
(128184,'Many warriors have sought shelter during a storm, but now is no time for shelter. We must raise our weapons and charge at the heart of nature itself.','Many warriors have sought shelter during a storm, but now is no time for shelter. We must raise our weapons and charge at the heart of nature itself.',0,0,0,0,0,0,1,0,0,47028,0,0,26124),
(128185,'I know it hurts now, but years from now we will look back upon this day and remember all we have fought for, all we have given. This is what makes us who we are.','I know it hurts now, but years from now we will look back upon this day and remember all we have fought for, all we have given. This is what makes us who we are.',0,0,0,0,0,0,1,0,0,47028,0,0,26124),
(128186,'We must remain strong.','We must remain strong.',0,0,0,0,0,0,1,0,0,47028,0,0,26124),
(128187,'Raise your head, young warrior. Our journey has only just begun.','Raise your head, young warrior. Our journey has only just begun.',0,0,0,0,0,0,1,0,0,47028,0,0,26124),
(128188,'We must maintain our composure! Show our allies who we truly are, not what those demons expect us to be!','We must maintain our composure! Show our allies who we truly are, not what those demons expect us to be!',0,0,0,0,0,0,1,0,0,47028,0,0,26124),
(128189,'A long wind only blows for so long before the calm sets in. We must remember our training.','A long wind only blows for so long before the calm sets in. We must remember our training.',0,0,0,0,0,0,1,0,0,47028,0,0,26124),
(128190,'','My family has been making brew for generations, so of course I\'m a natural at it! Still, I\'ve always wanted to try my hand at something different.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128191,'','Life in the Valley of Four Winds is usually so peaceful, and that\'s a good thing for most. But for me, it\'s also rather dull. I\'d prefer some excitement now and again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128192,'','I can make good brew with my eyes closed. But Mistweaving, now that\'s a challenge. I hope to be great at it one day.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128193,'To falter in the face of danger is not a flaw nor a weakness, rather an opportunity to rise to the call of battle.','To falter in the face of danger is not a flaw nor a weakness, rather an opportunity to rise to the call of battle.',0,0,0,0,0,0,1,0,0,47028,0,0,26124),
(128194,'','We need to return to the Temple of Five Dawns! Let me know when you\'re ready!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128198,'','The dreadlord attacked me, poisoned my Celebration Brew, and stole my form...',0,0,0,0,0,0,0,0,0,0,0,82435,26124),
(128199,'It was... not your fault, Almai! But... we must hurry... to find a cure. Some have already succumbed...','',0,0,0,0,0,0,0,0,0,0,82096,0,26124),
(128200,'Marius and his pet warlock managed to reverse one of the demon portals. Pass through and see what damage you can unleash on the other side.','',0,0,0,0,0,0,0,0,0,0,81092,0,26124),
(128201,'Impressive improvisation. If only more of our forces could be entrusted with such missions. Now get out of there before reinforcements find you.','',0,0,0,0,0,0,0,0,0,0,81093,0,26124),
(128202,'','I will go with you, Grandmaster. We have no time to lose!',0,0,0,0,0,0,0,0,0,0,0,82067,26124),
(128203,'','|TInterface\\Icons\\INV_Misc_Herb_Arrowbloom.blp:20|t%s targets you with |cFFFF0000|Hspell:236304|h[Incorporeal Shot]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(128204,'','I should be able to reactivate their portal. This place teems with usable souls.',0,0,0,0,0,0,396,0,0,0,0,82841,26124),
(128205,'','I will ensure no more of Kruul\'s minions make it through. Suffer well.',0,0,0,0,0,0,396,0,0,0,0,82842,26124),
(128206,'The Xorothian Ritualists are beginning to cast Cataclysm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128207,'I grow weary of waiting.','',0,0,0,0,0,0,0,0,0,0,82455,0,26124),
(128208,'You cannot stop me, demons! RISE, SOLDIERS!','',0,0,0,0,0,0,0,0,0,0,82456,0,26124),
(128209,'','Ready to unveil our secret weapon?',0,0,0,0,0,0,0,0,0,0,0,81286,26124),
(128210,'','All those demons... bah! No chance of us being overwhelmed, not when we control the power of Daumyr and her brood.',0,0,0,0,0,0,0,0,0,0,0,81287,26124),
(128211,'','The Legion will tremble beneath Daumyr\'s shadow. They\'ll plead for mercy as we rain down death and destruction!',0,0,0,0,0,0,0,0,0,0,0,81288,26124),
(128212,'','Do you see the Horsemen? Incredible that they\'re holding their own against that throng.',0,0,0,0,0,0,25,0,0,0,0,81289,26124),
(128213,'','Another batch down! Send them to their graves!',0,0,0,0,0,0,4,0,0,0,0,81290,26124),
(128214,'','The Horsemen kept those demons contained.',0,0,0,0,0,0,0,0,0,0,0,82862,26124),
(128215,'','Daumyr made quick work of them. Did you hear their screams? Music to my ears!',0,0,0,0,0,0,0,0,0,0,0,82863,26124),
(128216,'','I\'ve never felt so alive!',0,0,0,0,0,0,0,0,0,0,0,82864,26124),
(128217,'|TInterface\\ICONS\\Ability_FelArakkoa_FelDetonation_Green:20|t Watch out! Avoid |cFFFF0404|Hspell:238005|h[Cataclysmic Force Nova]|h|r! in order to stay on the ship!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(128218,'','Welcome, Slayer $p, to the breeding grounds of the fel bats. We\'ve captured a fine specimen for you to bond with today.$b$bJust inform me when you\'re ready to see it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128219,'','Illidari! Bring out the beast!',0,0,0,0,0,0,1,0,0,0,0,81479,26124),
(128220,'','A few days ago, this fel bat attacked our camp. It\'s a rare treat to capture a mature specimen, so I insisted it be restrained rather than destroyed.',0,0,0,0,0,0,1,0,0,0,0,81480,26124),
(128221,'','Taming such a willful beast requires a show of dominance. That is, of course, my specialty... but in this case, I suggest simply pummeling it into submission.',0,0,0,0,0,0,1,0,0,0,0,81481,26124),
(128222,'','Quickly, bind the creature!',0,0,0,0,0,0,1,0,0,0,0,81484,26124),
(128223,'','My apologies, Slayer, it seems to have escaped. Ah, but see here? A trail of blood. How convenient!',0,0,0,0,0,0,1,0,0,0,0,81485,26124),
(128224,'','Tracking it should be simple, thanks to your demon sight. But if it\'s run off to the breeding grounds, I fear you may have some trouble bringing it back. Bats can be such... spirited creatures.',0,0,0,0,0,0,1,0,0,0,0,81486,26124),
(128225,'I will activate the portal. Once it\'s open, I\'ll need you to place the Calling Stone to draw Arax\'ath and the Wrathsteed through.','',0,0,0,0,0,0,1,0,0,0,82546,0,26124),
(128227,'No doubt he will send his minions to stop us. Maintaining the portal will require all of my strength, so I will rely on you to hold them off.','',0,0,0,0,0,0,1,0,0,0,82547,0,26124),
(128228,'|TInterface\\Icons\\Ability_Rogue_BloodyEye:20|tThrashbite\'s |cFFFF0000|Hspell:237726|h[Scornful Gaze]|h|r falls on |cFFFF0000$n|r!','|TInterface\\Icons\\Ability_Rogue_BloodyEye:20|tThrashbite\'s |cFFFF0000|Hspell:237726|h[Scornful Gaze]|h|r falls on |cFFFF0000$n|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128229,'What is this sensation? A dark force... reaching into my mind...','',0,0,0,0,0,0,1,0,0,0,82382,0,26124),
(128230,'','This... doesn\'t seem right. Where am I?',0,0,0,0,0,0,0,0,0,0,0,82474,26124),
(128231,'|TInterface\\Icons\\INV_SPEAR_08.BLP:20|t%s targets |cFFFF0000$n|r with a |cFFFF0000|Hspell:235933|h[Spear of Anguish]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(128232,'Erdris... your magic is weak! We... will... resist you!','',0,0,0,0,0,0,0,0,0,0,82383,0,26124),
(128233,'','I see you\'ve tamed the beast, Slayer $p. Congratulations are in order, my dear!',0,0,0,0,0,0,1,0,0,0,0,81482,26124),
(128234,'','Allow us to make the creature presentable so that it may be conferred to you at the Fel Hammer. Speak with Yrdris and he\'ll see you back to the ship.',0,0,0,0,0,0,1,0,0,0,0,81483,26124),
(128235,'','I\'ve still some work to do here, but I\'ll meet you back at the Fel Hammer, Slayer $p.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128236,'I would not waste the time you\'ve been given to complete your task, Farseer $p.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128237,'I\'m grateful for your aid, Farseer $p. I have no doubt you will resolve this issue swiftly.','',0,0,0,0,0,0,0,0,0,0,82953,0,26124),
(128239,'Attack!','',0,0,0,0,0,0,0,0,0,0,81576,0,26124),
(128240,'The winds carry my will to the far corners of this plane, but even I cannot be everywhere at once. Here in Skywall, certain of my subjects have not fully grasped the totality of my ascension.','',0,0,0,0,0,0,0,0,0,0,82954,0,26124),
(128241,'They foolishly believe Sarsarun to be the rightful heir to the throne. I need you to convince them otherwise.','',0,0,0,0,0,0,0,0,0,0,82955,0,26124),
(128242,'Ha ha ha ha ha!','',0,0,0,0,0,0,0,0,0,0,81577,0,26124),
(128243,'I am unmoved by your babbling, demon. Feel the wrath of a true commander\'s army!','',0,0,0,0,0,0,0,0,0,0,82457,0,26124),
(128244,'(CUT/UNUSED)Once they realize your intentions, they will seek to remove you from this plane. I will grant you a blessing that will prevent them from doing so, at least for a time.(CUT/UNUSED)','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128245,'I see the Farseer has edified your allegiances in my direction. Good. Let me clear away any doubts still polluting your minds.','',0,0,0,0,0,0,1,0,0,0,82957,0,26124),
(128246,'I am the Windlord now, and all of you bluster about within my domain. But let us not leave this council with a whiff of foul air.','',0,0,0,0,0,0,1,0,0,0,82958,0,26124),
(128247,'Divided, we are scattered to the winds. But united, we are a cyclone of power. Let this council never dissipate again.','',0,0,0,0,0,0,1,0,0,0,82959,0,26124),
(128248,'Farseer $p, I will return you to the Heart of Azeroth. Depart with my thanks.','',0,0,0,0,0,0,403,0,0,0,82960,0,26124),
(128249,'Once there, I shall present you with a gift to show my appreciation. May it serve you well.','',0,0,0,0,0,0,403,0,0,0,82961,0,26124),
(128250,'They\'ll never find this buried here...','They\'ll never find this buried here...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128251,'May Elune guide your soul, my son.','May Elune guide your soul, my son.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128252,'<sigh> We lost him too soon.','<sigh> We lost him too soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128253,'<sigh> Another sentinel dead.','<sigh> Another sentinel dead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128254,'And another! Allying with these \"demons\" was a mistake.','And another! Allying with these \"demons\" was a mistake.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128255,'The Legion hit this area hard. There don\'t seem to be any survivors.','The Legion hit this area hard. There don\'t seem to be any survivors.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128256,'Welcome to the Scribe\'s Sacellum, $c. Can I interest you in some scrolls today?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128257,'Champion! Your expertise is needed! Prepare for battle!','',0,0,0,0,0,0,0,0,0,0,81134,0,26124),
(128258,'Might as well start looking for something worth salvaging.','Might as well start looking for something worth salvaging.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128259,'I know I dropped it somewhere around here...','I know I dropped it somewhere around here...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128260,'Where could it be?!','Where could it be?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128261,'Our allies need your aid, champion. You must act at once!','',0,0,0,0,0,0,0,0,0,0,81135,0,26124),
(128262,'<yawn> Is it already time to go back to work?','<yawn> Is it already time to go back to work?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128263,'I wish I could nap all day.','I wish I could nap all day.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128264,'Looks like that demon\'s poison got me in the end...','Looks like that demon\'s poison got me in the end...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128265,'You were my friend! How could you do this to me? To my FAMILY?','You were my friend! How could you do this to me? To my FAMILY?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128266,'A formidable enemy is close. Strike it down with all the malice it deserves!','',0,0,0,0,0,0,0,0,0,0,81136,0,26124),
(128267,'You and your allies are needed, champion. Gather your forces!','',0,0,0,0,0,0,0,0,0,0,81137,0,26124),
(128268,'A well-fought battle. The Legion has learned to fear you!','',0,0,0,0,0,0,0,0,0,0,81141,0,26124),
(128269,'Strength of arms is not the only way to strike a blow against the Legion. Well done!','',0,0,0,0,0,0,0,0,0,0,81142,0,26124),
(128270,'The downfall of such an enemy will inspire our forces... and seed fear into the demons\' hearts.','',0,0,0,0,0,0,0,0,0,0,81143,0,26124),
(128271,'You and your comrades fought well. Such determination will be crucial in the battles to come.','',0,0,0,0,0,0,0,0,0,0,81144,0,26124),
(128272,'Got something that needs blown up? Old Icks has got just the staff for you!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128273,'','You look like you\'ve lost something. Can I help?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128274,'','The energy in this place is malevolent. Let\'s go!',0,0,0,0,0,0,0,0,0,0,0,82083,26124),
(128275,'Intruders! Killing you will regain my master\'s favor!','',0,0,0,0,0,0,0,0,0,0,81787,0,26124),
(128276,'You will know pain!','',0,0,0,0,0,0,0,0,0,0,81788,0,26124),
(128277,'I will delight in your suffering!','',0,0,0,0,0,0,0,0,0,0,81789,0,26124),
(128278,'Come, face your doom!','',0,0,0,0,0,0,0,0,0,0,81790,0,26124),
(128279,'Easily broken!','',0,0,0,0,0,0,0,0,0,0,81791,0,26124),
(128280,'Pathetic mortal!','',0,0,0,0,0,0,0,0,0,0,81792,0,26124),
(128281,'Another foe felled!','',0,0,0,0,0,0,0,0,0,0,81793,0,26124),
(128282,'I have earned my glory... and robbed these mortals of theirs.','',0,0,0,0,0,0,0,0,0,0,81794,0,26124),
(128283,'The master will be pleased.','',0,0,0,0,0,0,0,0,0,0,81795,0,26124),
(128284,'More... agony... to come...','',0,0,0,0,0,0,0,0,0,0,81796,0,26124),
(128285,'Burn! Burn in the fires of my torment!','',0,0,0,0,0,0,0,0,0,0,81797,0,26124),
(128286,'I will flatten you!','',0,0,0,0,0,0,0,0,0,0,81798,0,26124),
(128287,'Pummel you to dust!','',0,0,0,0,0,0,0,0,0,0,81799,0,26124),
(128288,'Smash you to pieces!','',0,0,0,0,0,0,0,0,0,0,81800,0,26124),
(128289,'Hold still!','',0,0,0,0,0,0,0,0,0,0,81801,0,26124),
(128290,'Hold still!','',0,0,0,0,0,0,0,0,0,0,81802,0,26124),
(128291,'Stay where you are!','',0,0,0,0,0,0,0,0,0,0,81803,0,26124),
(128292,'Pain rains upon you!','',0,0,0,0,0,0,0,0,0,0,81804,0,26124),
(128293,'You dare challenge me?','',0,0,0,0,0,0,0,0,0,0,81805,0,26124),
(128294,'I will break you!','',0,0,0,0,0,0,0,0,0,0,81806,0,26124),
(128295,'Let us test your resolve!','',0,0,0,0,0,0,0,0,0,0,81807,0,26124),
(128296,'You cannot withstand me!','',0,0,0,0,0,0,0,0,0,0,81808,0,26124),
(128297,'%s spits.','%s spits.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128298,'Hero! Our foes have infiltrated this area. We\'re relying on you to take them down!','',0,0,0,0,0,0,0,0,0,0,81122,0,26124),
(128299,'We have allies in trouble nearby, champion. Please lend your aid!','',0,0,0,0,0,0,0,0,0,0,81123,0,26124),
(128300,'Our scouts report the presence of a deadly enemy nearby. Time to go on the offensive!','',0,0,0,0,0,0,0,0,0,0,81124,0,26124),
(128301,'This way, champion!','',0,0,0,0,0,0,0,0,0,0,81125,0,26124),
(128302,'This way! Come at once!','',0,0,0,0,0,0,0,0,0,0,81138,0,26124),
(128303,'Gather your allies, champion. A grave threat is at hand, and heroes are needed!','',0,0,0,0,0,0,0,0,0,0,81126,0,26124),
(128304,'Well done! We have pushed the Legion back... for now, at least.','',0,0,0,0,0,0,0,0,0,0,81129,0,26124),
(128305,'You work today has saved lives, champion. Take pride in that!','',0,0,0,0,0,0,0,0,0,0,81130,0,26124),
(128306,'Well done! The way you took that target down reminds me of myself in my younger days. My much, much younger days.','',0,0,0,0,0,0,0,0,0,0,81131,0,26124),
(128307,'Once again, I owe you a debt of thanks. I\'d say you\'re making quite a habit of this!','',0,0,0,0,0,0,0,0,0,0,81132,0,26124),
(128308,'You and your friends make an impressive fighting force. It is through our unity that the Legion will fall!','',0,0,0,0,0,0,0,0,0,0,81133,0,26124),
(128309,'Gather your allies, hero. The threat you are about to face will put all your skills to the test!','',0,0,0,0,0,0,0,0,0,0,81148,0,26124),
(128310,'Light preserve us! Our allies are in need. Please, champion, help them!','',0,0,0,0,0,0,0,0,0,0,81149,0,26124),
(128311,'Champion! The Light has need of you!','',0,0,0,0,0,0,0,0,0,0,81150,0,26124),
(128312,'You have brought the Light to this dark place. Thank you.','',0,0,0,0,0,0,0,0,0,0,81151,0,26124),
(128313,'You have saved many lives this day, hero. For this noble act, you have my thanks.','',0,0,0,0,0,0,0,0,0,0,81152,0,26124),
(128314,'The Legion cannot stand against the power of the Light. Not when it has champions like you!','',0,0,0,0,0,0,0,0,0,0,81153,0,26124),
(128315,'','My, it looks like Agatha\'s stumbled on another fun little plaything.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128316,'The way you and your allies persevered is an inspiration to our forces. Proof that together we can save Azeroth!','',0,0,0,0,0,0,0,0,0,0,81154,0,26124),
(128317,'','Stand back while we infuse the herbs into the brew...',0,0,0,0,0,0,0,0,0,0,0,82439,26124),
(128318,'','There! It is done.',0,0,0,0,0,0,0,0,0,0,0,82440,26124),
(128319,'','Worry not, Uhrlia - this one looks spry. Surely $Ghe:she; won\'t give up so easily.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128320,'','Let\'s play, $c!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128321,'','I do hope this one is more entertaining than the last.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128322,'','Agatha... will be... pleased...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128323,'','That was... exquisite...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128324,'Blessings on you, Grandmaster!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128325,'I was so weak... Thank you for helping me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128326,'Blech! I never thought I\'d be glad to taste something so vile!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128327,'I could feel my life slipping away... You have my eternal thanks, Grandmaster!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128328,'','Blessings on you, Grandmaster!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128329,'','I was so weak... Thank you for helping me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128330,'','Blech! I never thought I\'d be glad to taste something so vile!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128331,'','I could feel my life slipping away... You have my eternal thanks, Grandmaster!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128332,'%s\'s Fel Bomb detonates!','%s\'s Fel Bomb detonates!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128333,'An intruder? Show yourself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128334,'Did you hear that? It came from over here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128335,'Nothing gets past the Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128336,'The Legion dispatches its all-seeing eyes to spy on our war efforts. Intolerable! Ensure nothing they have learned can be used against us.','',0,0,0,0,0,0,0,0,0,0,83114,0,26124),
(128337,'The Night of the Wilds is upon us once more, friends.','',0,0,0,0,0,0,0,0,6,0,83024,0,26124),
(128338,'On this evening, the spirits of the great beasts of legend rise in these very fields.','',0,0,0,0,0,0,0,0,6,0,83025,0,26124),
(128339,'One among us has been chosen to enter the darkness.','',0,0,0,0,0,0,0,0,6,0,83026,0,26124),
(128340,'To hunt the noble spirits and return them to their honored rest.','',0,0,0,0,0,0,0,0,6,0,83027,0,26124),
(128341,'Raise your steins to the Huntmaster, our hunter of beasts!','',0,0,0,0,0,0,0,0,6,0,83028,0,26124),
(128342,'Let the feast begin!','',0,0,0,0,0,0,0,0,6,0,83029,0,26124),
(128343,'Once you have eaten your fill, hunter, depart the table and enter the wilderness. Your prey awaits!','',0,0,0,0,0,0,0,0,0,0,83030,0,26124),
(128344,'Finding these clever beasts in the darkness will not be easy, but a true hunter is a master of tracking.','',0,0,0,0,0,0,0,0,0,0,83031,0,26124),
(128345,'Hyrtir, the great stag, emerges! Swiftest of the beasts, with horns sharpened to a spear\'s point. Luck be with you, hunter!','',0,0,0,0,0,0,0,0,0,0,83032,0,26124),
(128346,'Hyrtir was first pursued by Haldor of the Rocky Cliffs. The spirit of Haldor is with the hunter this night!','',0,0,0,0,0,0,0,0,0,0,83033,0,26124),
(128347,'You follow the trail of Garos, the great worm. Many are her children, and deep are her tunnels.','',0,0,0,0,0,0,0,0,0,0,83034,0,26124),
(128348,'Garos was brought here by Bjorn of the Black Storm. The spirit of Bjorn is with the hunter!','',0,0,0,0,0,0,0,0,0,0,83035,0,26124),
(128349,'Ketlingr, the great cat, drinks before you. A lithe, fierce predator, many learned to fear her fangs and claws!','',0,0,0,0,0,0,0,0,0,0,83036,0,26124),
(128350,'Ketlingr was slain by Tor of the Brutal Siege. The spirit of Tor is with the hunter!','',0,0,0,0,0,0,0,0,0,0,83037,0,26124),
(128351,'Habrok, the great owl, perches above you. All beasts once feared her talons, and hid during the night from her keen vision.','',0,0,0,0,0,0,0,0,0,0,83038,0,26124),
(128352,'Ranulf of the Screaming Abyss triumphed over Habrok in life. The spirit of Ranulf is with the hunter!','',0,0,0,0,0,0,0,0,0,0,83039,0,26124),
(128353,'The spirits hold you in high regard, Huntmaster! The most renowned predators of all our legends have emerged. This is truly the grandest Night of the Wilds I have ever witnessed!','',0,0,0,0,0,0,0,0,0,0,83040,0,26124),
(128354,'Behold! Den-mother Fereki, great predator of the earth, and mighty Vetholnir, lord of the skies.','',0,0,0,0,0,0,0,0,4,0,83041,0,26124),
(128355,'What is this? A most rare and remarkable spirit has come forth, one that has not graced these fields for countless ages.','',0,0,0,0,0,0,0,0,0,0,83042,0,26124),
(128356,'It is Haukenulfnir, who stalked the wilds when the world was new!','',0,0,0,0,0,0,0,0,0,0,83043,0,26124),
(128357,'She senses your predatory prowess and kinship with beasts. She will test you, hunter, if you approach her.','',0,0,0,0,0,0,0,0,0,0,83044,0,26124),
(128358,'She has found you worthy. The spirit of Haukenulfnir is with the hunter!','',0,0,0,0,0,0,0,0,0,0,83045,0,26124),
(128359,'With her spirit now bound to yours, the children of Haukenulfnir will answer your summons in the mortal world.','',0,0,0,0,0,0,0,0,0,0,83046,0,26124),
(128360,'Now come back to the fire, good hunter, and let us feast the night away!','',0,0,0,0,0,0,0,0,0,0,83047,0,26124),
(128361,'Do you understand what the tale seeks to teach us? With our companions, we are so much stronger than we are alone.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128362,'Will you accept the companionship of the Wolfhawk?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128363,'Ha ha, I think it likes you, Hunter! You and the beast are now bonded, in this realm and the mortal realm. Now, let us return to the feast, and leave our worries for the morning!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128364,'Let us feast, then! To the Night of the Wilds! To the great beasts! To the Huntmaster!','',0,0,0,0,0,0,0,0,0,0,83048,0,26124),
(128365,'Remain vigilant, champion! We must watch for our enemy, just as they are watching us!','',0,0,0,0,0,0,0,0,0,0,83115,0,26124),
(128366,'The eve of our attack is nigh. Have you summoned the forces?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128367,'I will notify the summoners shortly. They will open the portals on my word only.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128368,'Good... once they are through, the foolish \"Legionfall Offensive\" will stand no chance. Their demise shall be delivered.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128369,'I...don\'t feel so good...','',0,0,0,0,0,0,0,0,0,0,82100,0,26124),
(128370,'Fhambar senses something...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128371,'Fhambar doesn\'t find anything useful...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128372,'|TINTERFACE\\ICONS\\Ability_BossFelLord_FelSpike.blp:20|t Domatrax begins to cast |cFFFF0404|Hspell:234107|h[Chaotic Energy]|h|r! Take cover!','|TINTERFACE\\ICONS\\Ability_BossFelLord_FelSpike.blp:20|t Domatrax begins to cast |cFFFF0404|Hspell:234107|h[Chaotic Energy]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128373,'It looks like Fhambar has tracked down your missing mage. I\'ll be taking him back now.','',0,0,0,0,0,0,0,0,0,0,82560,0,26124),
(128374,'Good luck with Agatha, $c. You will need it...','',0,0,0,0,0,0,0,0,0,0,82561,0,26124),
(128375,'','My ward persists! It can protect you!',0,0,0,0,0,0,0,0,0,0,0,81429,26124),
(128376,'','The chasm is warded against her magic!',0,0,0,0,0,0,0,0,0,0,0,81430,26124),
(128377,'','The echo of my power can save you!',0,0,0,0,0,0,0,0,0,0,0,81431,26124),
(128378,'','He\'s ancient, but tough! He can survive this... Right?',0,0,0,0,0,0,0,0,0,0,0,82081,26124),
(128379,'It was an honor to fight beside you, Battlelord $n. I will report to Skyhold.','',0,0,0,0,0,0,0,0,0,0,81227,0,26124),
(128380,'Hail to the Battlelord! Lok-tar!','',0,0,0,0,0,0,0,0,0,0,81226,0,26124),
(128381,'I need passage to Felwing Ledge.','I need passage to Felwing Ledge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128382,'Iron-Body Ponshu coughs weakly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128383,'My entire being, even my soul... burned...','',0,0,0,0,0,0,0,0,0,0,82101,0,26124),
(128384,'I saw a vision. A tsunami of demons crashing down upon us... extinguishing every light... save for one.','',0,0,0,0,0,0,0,0,0,0,82102,0,26124),
(128385,'Grandmaster, you are that light! Do not waver in your resolve to fight the Burning Legion!','',0,0,0,0,0,0,0,0,0,0,82103,0,26124),
(128386,'','It is time for me to leave this realm, my friends. Almai, I believe you have grown beyond the life of a simple brewer.',2,0,0,0,0,0,0,0,0,0,0,82438,26124),
(128387,'May you rest in peace, Brewmaster.','',0,0,0,0,0,0,0,0,0,0,82104,0,26124),
(128388,'I\'m ready, Matron Mother.','I\'m ready, Matron Mother.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128389,'If the Destroyer is alive, she\'s in great danger. No wonder she\'s so troubled...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128390,'Don\'t worry, lass. We\'ll protect ye. We\'ve got to!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128391,'Her nightmares... her greatest fears... we\'ve got to help!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128392,'Let us hear what she has to say, Magni.','Let us hear what she has to say, Magni.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128393,'','Archdruid! The Shrine of Aviana is under attack again, and this time it\'s a full-scale invasion! The Ancient needs our help!',0,0,0,0,0,0,0,0,6,0,0,82122,26124),
(128394,'','To hell with the front lines! I\'m going around back to take out their casters and artillery. You\'re welcome to join me!',0,0,0,0,0,0,0,0,6,0,0,82123,26124),
(128395,'','Did you hear that? Screams from the shrine! We\'ve gotta get back there!',0,0,0,0,0,0,0,0,6,0,0,82124,26124),
(128396,'','Die, demon scum!',0,0,0,0,0,0,0,0,6,0,0,82125,26124),
(128397,'Perish before the might of the Legion!','',0,0,0,0,0,0,0,0,6,0,82692,0,26124),
(128398,'','You wretched... No! The idol!',0,0,0,0,0,0,0,0,6,0,0,82126,26124),
(128399,'','Noooo!',0,0,0,0,0,0,0,0,6,0,0,82127,26124),
(128400,'','The shrine is lost. Druids, take flight! Retreat!',0,0,0,0,0,0,0,0,6,0,0,82128,26124),
(128401,'','What the... Flight Form\'s not working?! With the idol gone, we\'ve lost our wings! Everyone teleport out and regroup at the Dreamgrove!',0,0,0,0,0,0,0,0,6,0,0,82129,26124),
(128402,'','I\'ll meet you in Azsuna, Archdruid.',0,0,0,0,0,0,0,0,0,0,0,82130,26124),
(128403,'','Let\'s see what\'s going on... discreetly!',0,0,0,0,0,0,0,0,0,0,0,82131,26124),
(128404,'Legion! With this idol, the cowardly mortals\' floating city will no longer protect them.','',0,0,0,0,0,0,0,0,0,0,82693,0,26124),
(128405,'','Wrong! You die this day, demon!',0,0,0,0,0,0,0,0,0,0,0,82132,26124),
(128406,'You are too late, little druid! We will use your power of flight to bring down Dalaran!','',0,0,0,0,0,0,0,0,0,0,82694,0,26124),
(128407,'','Blasphemy!',0,0,0,0,0,0,0,0,0,0,0,82133,26124),
(128408,'','Over here!',0,0,0,0,0,0,0,0,0,0,0,82134,26124),
(128409,'','Aviana, please! Help us!',0,0,0,0,0,0,0,0,0,0,0,82135,26124),
(128410,'Enough of this game!','',0,0,0,0,0,0,0,0,0,0,82695,0,26124),
(128411,'','It is done. Let\'s get this idol back to the Dreamgrove.',0,0,0,0,0,0,0,0,0,0,0,82136,26124),
(128412,'','Druids! We were victorious! The Idol of Aviana is once again safe. Archdruid, please do the honors and put the idol back where it belongs.',0,0,0,0,0,0,0,0,0,0,0,82137,26124),
(128413,'She\'s calmer now, but still troubled. I should be able ta reach her.$b$bAre ye ready, $n?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128414,'','Along with Xylem\'s other apprentices, I have been working to pinpoint his location. I believe we have found him in the Eye of Eternity, $ct!',0,0,0,0,0,0,1,0,0,0,0,81377,26124),
(128415,'','From that location, Xylem could use the Focusing Iris to wreak untold havoc on Azeroth\'s ley lines.',0,0,0,0,0,0,0,0,0,0,0,81378,26124),
(128416,'','The mages of the Kirin Tor can open a temporary portal to his location. You must put an end to Xylem\'s madness... but please, spare his life if you can!',0,0,0,0,0,0,0,0,0,0,0,81379,26124),
(128417,'','Archdruid! I need your help!',0,0,0,0,0,0,22,0,0,0,0,82138,26124),
(128418,'','I\'ll meet you there. We have to hurry--before it\'s too late!',1,0,0,0,0,0,0,0,0,0,0,82139,26124),
(128421,'Make sure to study the runes well, $c. I don\'t want to know what will happen if we fail!','',0,0,0,0,0,0,0,0,0,0,82559,0,26124),
(128422,'The Legion may try to wear us down - to erode our allies like rain-swept valleys after a storm, but we will never surrender. It is in our blood to fight until the sun shines upon us once more.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128423,'I am ready to begin.','I am ready to begin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128424,'','I command legions, mortal!',0,0,0,0,0,0,0,0,0,0,0,82937,26124),
(128425,'','So many treasures, just waiting for me to grab!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128426,'I draw upon the power of my ancestors!','',0,0,0,0,0,0,0,0,0,0,82575,0,26124),
(128427,'The Drekirjar never yield!','',0,0,0,0,0,0,0,0,0,0,82626,0,26124),
(128428,'|TInterface\\Icons\\ACHIEVEMENT_BOSS_SVALASORROWGRAVE.BLP:20|tSeveral Dark Val\'kyr form ranks to |cFFFF0000|Hspell:237761|h[charge]|h|r across the battlefield!','|TInterface\\Icons\\ACHIEVEMENT_BOSS_SVALASORROWGRAVE.BLP:20|tSeveral Dark Val\'kyr form ranks to |cFFFF0000|Hspell:237761|h[charge]|h|r across the battlefield!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128429,'|TInterface\\Icons\\SPELL_FEL_ELEMENTALDEVASTATION.BLP:20|t%s starts casting |cFFFF0000|Hspell:237952|h[Ancestral Knowledge]|h|r!','|TInterface\\Icons\\SPELL_FEL_ELEMENTALDEVASTATION.BLP:20|t%s starts casting |cFFFF0000|Hspell:237952|h[Ancestral Knowledge]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128430,'|TInterface\\Icons\\ABILITY_WARRIOR_RAMPAGE.BLP:20|t%s gains |cFFFF0000|Hspell:237947|h[Berserker\'s Rage]|h|r!','|TInterface\\Icons\\ABILITY_WARRIOR_RAMPAGE.BLP:20|t%s gains |cFFFF0000|Hspell:237947|h[Berserker\'s Rage]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128431,'|TInterface\\Icons\\ABILITY_WHIRLWIND.BLP:20|t%s creates a |cFFFF0000|Hspell:237866|h[Bladestorm]|h|r!','|TInterface\\Icons\\ABILITY_WHIRLWIND.BLP:20|t%s creates a |cFFFF0000|Hspell:237866|h[Bladestorm]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128432,'|TInterface\\Icons\\ABILITY_WARLOCK_SHADOWFURYTGA.BLP:20|tSeveral |cFFFF0000|Hspell:237908|h[Runes]|h|r appear on the ground nearby.','|TInterface\\Icons\\ABILITY_WARLOCK_SHADOWFURYTGA.BLP:20|tSeveral |cFFFF0000|Hspell:237908|h[Runes]|h|r appear on the ground nearby.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128433,'|TInterface\\Icons\\SPELL_FEL_ELEMENTALDEVASTATION.BLP:20|t%s channels the |cFFFF0000|Hspell:237945|h[Blood of her Father]|h|r!','|TInterface\\Icons\\SPELL_FEL_ELEMENTALDEVASTATION.BLP:20|t%s channels the |cFFFF0000|Hspell:237945|h[Blood of her Father]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128434,'Demonic filth taints this land, champion. We must eradicate it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128435,'Give the word when you are ready, champion, and we will take to the skies.','',0,0,0,0,0,0,0,0,0,0,81409,0,26124),
(128436,'','The power of my father\'s blood flows through me!',0,0,0,0,0,0,0,0,0,0,0,82938,26124),
(128437,'Behold the speed of my axe!','',0,0,0,0,0,0,0,0,0,0,82627,0,26124),
(128438,'The fury of the storm boils within me! Have you finished your preparations?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128439,'Greetings, champion. Are you here to answer the call of Odyn?','',0,0,0,0,0,0,0,0,0,0,81410,0,26124),
(128440,'Well done! Our world will never fall so long as it is defended by champions such as you!','',0,0,0,0,0,0,0,0,0,0,81405,0,26124),
(128441,'','(UNUSED)Your demon sight will be beneficial in keeping track of its trail of blood.(UNUSED)',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128442,'Welcome to Felwing Ledge, Slayer $p. The Matron Mother is waiting for you down in the training area, just west of here.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128443,'','Odyn and the greatest of his hunters await your presence at the Fields of the Eternal hunt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128444,'I am ready to attend the feast.','I am ready to attend the feast.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128446,'','This body... my mind... compromised. I have failed the makers!',0,0,0,0,0,0,0,0,0,0,0,81415,26124),
(128447,'','End me, mortals! Then rob the Deceiver of his prize!',0,0,0,0,0,0,0,0,0,0,0,81416,26124),
(128448,'','I was not the first to place defenses in this temple, but I fear the ancient watcher charged with safeguarding this place... has been compromised. Be wary. I will offer you what protection I can.',0,0,0,0,0,0,0,0,0,0,0,82485,26124),
(128449,'','For millennia I was steadfast in my vigil... unwavering. And then his voice called to me.',0,0,0,0,0,0,0,0,0,0,0,81417,26124),
(128450,'','The unmovable object met the irresistible force, and I found... a new calling.',0,0,0,0,0,0,0,0,0,0,0,81418,26124),
(128451,'','What lies below is not for mortal eyes!',0,0,0,0,0,0,0,0,0,0,0,81419,26124),
(128452,'','You will not disturb the master\'s work!',0,0,0,0,0,0,0,0,0,0,0,81420,26124),
(128453,'','A necessary end.',0,0,0,0,0,0,0,0,0,0,0,81421,26124),
(128454,'','Flesh is weak!',0,0,0,0,0,0,0,0,0,0,0,81422,26124),
(128455,'','My vigil continues. But... who is it I serve?',0,0,0,0,0,0,0,0,0,0,0,81423,26124),
(128456,'','Your world\'s hope dies with you!',0,0,0,0,0,0,0,0,0,0,0,81424,26124),
(128457,'','My vigil ends! Let not... the dark one... awaken...',0,0,0,0,0,0,0,0,0,0,0,81425,26124),
(128458,'','He will rise! He... will... reign...',0,0,0,0,0,0,0,0,0,0,0,81426,26124),
(128459,'Where would I find such a thing?','Where would I find such a thing?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(128460,'','Well, it must be also be nightborne in origin for a harmonious marriage to be achieved. Oh - and it must be newly forged and still unattached. Anything else will result in disaster. \n\nIf the rumors are true, Aethas might be able to help. Supposedly he has taken a rather striking nightborne apprentice! It is quite scandalous.\n\nYou should ask him to introduce you to her.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(128461,'','Outsider! Sigryn has stormed the Halls of Valor, determined to confront Odyn. In her blind rage, she races headlong to her doom!',0,0,0,0,0,0,1,0,0,0,0,81752,26124),
(128462,'','Your Kirin Tor have found the means to convey you into Odyn\'s halls. Hurry! Sigryn must be made to see reason, before it is too late!',0,0,0,0,0,0,1,0,0,0,0,81753,26124),
(128463,'','The fate of the Tideskorn rests in your hands. Gods be with you, outsider!',0,0,0,0,0,0,1,0,0,0,0,81754,26124),
(128464,'Be calm, Aviash. $n is one of our allies.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128465,'%s squawks loudly as you approach.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128466,'What a hunt! This, out here, is the true spirit of the wilds. Let us revel the night away and leave our cares for the morning!','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(128467,'<Revel the night away and awake in Trueshot Lodge.>','<Revel the night away and awake in Trueshot Lodge.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128468,'It was an honor to fight alongside you, Battlelord $n. I will report to Skyhold. See you there!','',0,0,0,0,0,0,0,0,0,0,81333,0,26124),
(128469,'','I will meet you at Valdisdall in Stormheim. We should be able to reach Skold-Ashil from there.',0,0,0,0,0,0,0,0,0,0,0,82939,26124),
(128470,'','Movement in the trees! Watch out!',0,0,0,0,0,0,0,0,0,0,0,82940,26124),
(128471,'','My last moments here were spent escaping the clutches of assassins sent to murder my family.',0,0,0,0,0,0,0,0,0,0,0,82941,26124),
(128472,'','Be forewarned. They may still be on the hunt.',0,0,0,0,0,0,0,0,0,0,0,82942,26124),
(128473,'','It would seem that escaping my past was too much to hope for.',0,0,0,0,0,0,0,0,0,0,0,82943,26124),
(128474,'','I will never forget the night they came. My mother fell before my eyes, and they had descended on my brother before I managed to escape.',0,0,0,0,0,0,0,0,0,0,0,82944,26124),
(128475,'','Cowardly scum! I would hunt down every one of them, and their masters as well, if I knew who sent them.',0,0,0,0,0,0,0,0,0,0,0,82945,26124),
(128476,'','Another ambush! Bare your steel!',0,0,0,0,0,0,0,0,0,0,0,82946,26124),
(128477,'','It\'s no use, though. They never fail to elude my grasp. I must concentrate on the task at hand.',0,0,0,0,0,0,0,0,0,0,0,82947,26124),
(128478,'','I take solace knowing they will be judged by the gods when their time comes.',0,0,0,0,0,0,0,0,0,0,0,82948,26124),
(128479,'','After that night, I was alone. The last of my bloodline.',0,0,0,0,0,0,0,0,0,0,0,82949,26124),
(128480,'Grandmaster! Could you spare a moment to listen to an old man\'s tale?','',0,0,0,0,0,0,0,0,0,0,82386,0,26124),
(128481,'Xuen, the White Tiger, one of the August Celestials, had a son named Ban-Lu.','',0,0,0,0,0,0,0,0,0,0,82387,0,26124),
(128482,'Over the centuries, Ban-Lu served as the personal mount of each grandmaster. It was a duty he was honored to fulfil!','',0,0,0,0,0,0,0,0,0,0,82388,0,26124),
(128483,'But Ban-Lu has not been seen since the Legion\'s attack on the Peak of Serenity. It seems the loss of life... affected him deeply.','',0,0,0,0,0,0,1,0,0,0,82389,0,26124),
(128484,'Perhaps if we return there, we may find clues to his whereabouts.','',0,0,0,0,0,0,1,0,0,0,82390,0,26124),
(128485,'Grandmaster! Over here.','',0,0,0,0,0,0,3,0,0,0,82391,0,26124),
(128486,'Look for any sign of where Ban-Lu might be.','',0,0,0,0,0,0,0,0,0,0,82392,0,26124),
(128487,'What have you found? Let me see...','',0,0,0,0,0,0,0,0,0,0,82393,0,26124),
(128488,'A trail of paw prints! Hmm, where might they lead...','',0,0,0,0,0,0,0,0,0,0,82394,0,26124),
(128489,'Phew! An exciting journey, but wearying. Please allow me a moment to rest. Perhaps you could ask these grummles whether they\'ve seen Ban-Lu.','',0,0,0,0,0,0,0,0,0,0,82395,0,26124),
(128490,'Wait for me, please! These old bones aren\'t what they used to be.','',0,0,0,0,0,0,0,0,0,0,82396,0,26124),
(128491,'Could you slow down a moment? I do apologize for my languid pace.','',0,0,0,0,0,0,0,0,0,0,82397,0,26124),
(128492,'Where did you go? Oh, wait there. Thank you for showing patience to an old man.','',0,0,0,0,0,0,0,0,0,0,82398,0,26124),
(128493,'Shall we continue the search for Ban-Lu, Grandmaster?','',0,0,0,0,0,0,0,0,0,0,82399,0,26124),
(128494,'It seems we have reached a dead end. I shall meditate on this conundrum.','',0,0,0,0,0,0,0,0,0,0,82400,0,26124),
(128495,'Grandmaster, I have an idea...','',0,0,0,0,0,0,0,0,0,0,82401,0,26124),
(128496,'Grandmaster! Have you found Ban-Lu?','',0,0,0,0,0,0,6,0,0,0,82402,0,26124),
(128497,'Not here? Are you sure? Perhaps you should be more observant, Grandmaster...','',0,0,0,0,0,0,0,0,0,0,82403,0,26124),
(128498,'Filled with sorrow by the death of Grandmaster Hight, I wandered Pandaria to reflect.','',0,0,0,0,0,0,274,0,0,0,82423,0,26124),
(128499,'But in the midst of that reflection, I saw something new and interesting appear... you!','',0,0,0,0,0,0,5,0,0,0,82424,0,26124),
(128500,'You have shown patience with Master Bu, honor with the grummles, duty with the Shado-Pan, and faith with the jinyu.','',0,0,0,0,0,0,1,0,0,0,82425,0,26124),
(128501,'It is clear you embody the wisdom, integrity, and tenacity of a grandmaster. Only one test remains... Prove to me that you can fight like a grandmaster!','',0,0,0,0,0,0,603,0,0,0,82426,0,26124),
(128502,'Your skills are impressive indeed, Grandmaster! I would be honored to serve you, as I served the great leaders of our order who came before.','',0,0,0,0,0,0,377,0,0,0,82427,0,26124),
(128503,'Let us return to the Wandering Isle... together!','',0,0,0,0,0,0,0,0,0,0,82428,0,26124),
(128504,'We will not be stopped!','',0,0,0,0,0,0,0,0,0,0,82573,0,26124),
(128505,'We must give up! The strength of the Legion will destroy us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128506,'','I\'m prepared to take you to the Halls of Valor. Speak with me when your allies have gathered and you are ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128507,'Where are we going today, Grandmaster?','',0,0,0,0,0,0,0,0,0,0,82429,0,26124),
(128508,'Good to see you again, Grandmaster.','',0,0,0,0,0,0,0,0,0,0,82405,0,26124),
(128509,'You might want to cut back on the mana buns, Grandmaster...','',0,0,0,0,0,0,0,0,0,0,82406,0,26124),
(128510,'Good luck, Grandmaster!','',0,0,0,0,0,0,0,0,0,0,82407,0,26124),
(128511,'Farewell!','',0,0,0,0,0,0,0,0,0,0,82408,0,26124),
(128512,'The lazy yak never gets washed.','',0,0,0,0,0,0,0,0,0,0,82409,0,26124),
(128513,'Listen to all voices, Grandmaster. Surrounded only by those who share your views, your mind can never grow.','',0,0,0,0,0,0,0,0,0,0,82410,0,26124),
(128514,'Idleness rarely leads to success, Grandmaster.','',0,0,0,0,0,0,0,0,0,0,82411,0,26124),
(128515,'Is it much further, Grandmaster?','',0,0,0,0,0,0,0,0,0,0,82412,0,26124),
(128516,'Remember to finish crossing the river before you tell the crocolisk he has bad breath!','',0,0,0,0,0,0,0,0,0,0,82413,0,26124),
(128517,'To speak of change without being willing to take action is like digging a hole to catch a cloud serpent.','',0,0,0,0,0,0,0,0,0,0,82414,0,26124),
(128518,'A kite cannot fly unless the wind blows against it, Grandmaster.','',0,0,0,0,0,0,0,0,0,0,82415,0,26124),
(128519,'The wise monk chooses their own style, rather than letting popular opinion dictate it.','',0,0,0,0,0,0,0,0,0,0,82416,0,26124),
(128520,'The best time to plant a tree is fifty years ago. The second-best time is now.','',0,0,0,0,0,0,0,0,0,0,82417,0,26124),
(128521,'Do not concern yourself with failure, Grandmaster. Rather, focus on rising every time you fall.','',0,0,0,0,0,0,0,0,0,0,82418,0,26124),
(128522,'The wise brewmaster recognizes the importance of taking a drink... and the importance of stopping before the drink takes the brewmaster.','',0,0,0,0,0,0,0,0,0,0,82419,0,26124),
(128523,'Have I told you the tale of the hozen and the buttercream pie? Hmm... Perhaps best saved for another time.','',0,0,0,0,0,0,0,0,0,0,82420,0,26124),
(128524,'Ah, a refreshing swim... Reminds me of the time I swam all the way to Kezan. Grandmaster Rochu wasn\'t happy about how shriveled his paws got!','',0,0,0,0,0,0,0,0,0,0,82421,0,26124),
(128525,'Don\'t worry about me, Grandmaster. I remembered my water breathing potions.','',0,0,0,0,0,0,0,0,0,0,82422,0,26124),
(128526,'You handle this one, squire.','',0,0,0,0,0,0,0,0,0,0,81441,0,26124),
(128527,'Assist me!','',0,0,0,0,0,0,0,0,0,0,81442,0,26124),
(128528,'I require... a short respite.','',0,0,0,0,0,0,0,0,0,0,81443,0,26124),
(128529,'Did you take heed of my victory, squire?','',0,0,0,0,0,0,0,0,0,0,81444,0,26124),
(128530,'Another fiend felled by my mighty blows!','',0,0,0,0,0,0,0,0,0,0,81445,0,26124),
(128531,'Well, that was easy.','',0,0,0,0,0,0,0,0,0,0,81446,0,26124),
(128532,'I shall slay thee with my mighty sword!','',0,0,0,0,0,0,0,0,0,0,81447,0,26124),
(128533,'Excaliberto! Attack!','',0,0,0,0,0,0,0,0,0,0,81448,0,26124),
(128534,'What a strange looking dragon! No matter!','',0,0,0,0,0,0,0,0,0,0,81449,0,26124),
(128535,'For Doloria!','',0,0,0,0,0,0,0,0,0,0,81450,0,26124),
(128536,'By my might, I slay thee!','',0,0,0,0,0,0,0,0,0,0,81451,0,26124),
(128537,'Why hello again, squire!','',0,0,0,0,0,0,0,0,0,0,81452,0,26124),
(128538,'What ho!','',0,0,0,0,0,0,0,0,0,0,81453,0,26124),
(128539,'We shall slay mighty beasts together!','',0,0,0,0,0,0,0,0,0,0,81454,0,26124),
(128540,'Let us ride!','',0,0,0,0,0,0,0,0,0,0,81455,0,26124),
(128541,'What ho!','',0,0,0,0,0,0,0,0,0,0,81432,0,26124),
(128542,'Yes?','',0,0,0,0,0,0,0,0,0,0,81433,0,26124),
(128543,'How may I serve?','',0,0,0,0,0,0,0,0,0,0,81434,0,26124),
(128544,'Very well.','',0,0,0,0,0,0,0,0,0,0,81435,0,26124),
(128545,'Oh begone! I have dragons to slay!','',0,0,0,0,0,0,0,0,0,0,81436,0,26124),
(128546,'Farewell, then.','',0,0,0,0,0,0,0,0,0,0,81437,0,26124),
(128547,'Do you know who it is you are addressing?','',0,0,0,0,0,0,0,0,0,0,81438,0,26124),
(128548,'I am Maximillian of Northshire, damsel rescuer extraordinaire. How dare you!','',0,0,0,0,0,0,0,0,0,0,81439,0,26124),
(128549,'I say, are you keen to feel the pointy part of my blade?','',0,0,0,0,0,0,0,0,0,0,81440,0,26124),
(128550,'','I will meet you back at the Hall of the Guardian, Archmage $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128551,'It is time, my friend. I have located Erdris Thorn in the upper spires of Blackrook Hold, where he plots to raise an undead army!','',0,0,0,0,0,0,0,0,0,0,82378,0,26124),
(128552,'A pair of Bradensbrook\'s fiercest fighters have insisted on joining our campaign. But even with their help, the battle ahead will be treacherous.','',0,0,0,0,0,0,0,0,0,0,82379,0,26124),
(128553,'Come, $n. Let us put Erdris to rest... once and for all.','',0,0,0,0,0,0,0,0,0,0,82380,0,26124),
(128554,'Tugar Bloodtotem has resurfaced in Highmountain. With him is an immense worm saturated with fel energy.','',0,0,0,0,0,0,0,0,0,0,82331,0,26124),
(128555,'We must put an end to him, along with that nasty pet of his, before they attack Thunder Totem. This will be no easy task.','',0,0,0,0,0,0,0,0,0,0,82332,0,26124),
(128556,'I have given my location to your mages. Once you arrive here, we will enter Tugar\'s cavern and neutralize his threat.','',0,0,0,0,0,0,0,0,0,0,82333,0,26124),
(128557,'','The Prophet has prepared his incantations, and I have meditated long enough. Kruul must die.',0,0,0,0,0,0,0,0,0,0,0,82835,26124),
(128558,'','Upon your arrival, we will reopen the portal to the demon\'s domain and finish him... once and for all!',0,0,0,0,0,0,0,0,0,0,0,82836,26124),
(128559,'','This mage will teleport you to us. The task ahead will not be easy. Be prepared!',0,0,0,0,0,0,0,0,0,0,0,82837,26124),
(128560,'Remember, keep your distance from the Nightborne Soulstone as it is siphoning energy!','',0,0,0,0,0,0,0,0,0,0,82778,0,26124),
(128561,'Well done. Meet me near Lady Remor\'za\'s tower and I will summon a portal.','',0,0,0,0,0,0,0,0,0,0,82779,0,26124),
(128562,'','C\'mon, Archdruid! My people need our help!',0,0,0,0,0,0,0,0,0,0,0,82140,26124),
(128563,'','To the dark depths of Hel with you!',0,0,0,0,0,0,0,0,0,0,0,82913,26124),
(128564,'Yes?','',0,0,0,0,0,0,0,0,0,0,82515,0,26124),
(128565,'What needs conjuring?','',0,0,0,0,0,0,0,0,0,0,82516,0,26124),
(128566,'You require my services?','',0,0,0,0,0,0,0,0,0,0,82517,0,26124),
(128567,'What shall we summon today?','',0,0,0,0,0,0,0,0,0,0,82518,0,26124),
(128568,'The dreadsteeds will be ours.','',0,0,0,0,0,0,0,0,0,0,82519,0,26124),
(128569,'Xoroth beckons.','',0,0,0,0,0,0,0,0,0,0,82520,0,26124),
(128570,'The demons will bow to us.','',0,0,0,0,0,0,0,0,0,0,82521,0,26124),
(128571,'Fel hooves grant you swiftness.','',0,0,0,0,0,0,0,0,0,0,82522,0,26124),
(128572,'Have you brought me more blood?','',0,0,0,0,0,0,0,0,0,0,82523,0,26124),
(128573,'Shouldn\'t you be fetching materials or something?','',0,0,0,0,0,0,0,0,0,0,82524,0,26124),
(128574,'Why don\'t I ever get to keep the dreadsteed?','',0,0,0,0,0,0,0,0,0,0,82525,0,26124),
(128575,'','Foolish druids... our distraction has succeeded!',0,0,0,0,0,0,0,0,0,0,0,82732,26124),
(128576,'','Hail, outsider.',0,0,0,0,0,0,0,0,0,0,0,82930,26124),
(128577,'','What is your purpose?',0,0,0,0,0,0,0,0,0,0,0,82931,26124),
(128578,'','My shield is ready.',0,0,0,0,0,0,0,0,0,0,0,82932,26124),
(128579,'','I stand unbroken.',0,0,0,0,0,0,0,0,0,0,0,82933,26124),
(128580,'','I will not falter.',0,0,0,0,0,0,0,0,0,0,0,82934,26124),
(128581,'','Gods go with you.',0,0,0,0,0,0,0,0,0,0,0,82917,26124),
(128582,'','Fight with honor, outsider.',0,0,0,0,0,0,0,0,0,0,0,82918,26124),
(128583,'','I will be hunted no longer.',0,0,0,0,0,0,0,0,0,0,0,82919,26124),
(128584,'','Stop. Now.',0,0,0,0,0,0,0,0,0,0,0,82916,26124),
(128585,'','Perhaps my father was right about you.',0,0,0,0,0,0,0,0,0,0,0,82920,26124),
(128586,'','My bloodline is not known for having even tempers.',0,0,0,0,0,0,0,0,0,0,0,82921,26124),
(128587,'','Even the Legion has not been this irritating!',0,0,0,0,0,0,0,0,0,0,0,82922,26124),
(128588,'','You know, I might look good in green...',0,0,0,0,0,0,0,0,0,0,0,82914,26124),
(128589,'','A fel-fire spear might prove useful right about now...',0,0,0,0,0,0,0,0,0,0,0,82915,26124),
(128590,'Well met.','',0,0,0,0,0,0,0,0,0,0,82252,0,26124),
(128591,'Hail, adventurer.','',0,0,0,0,0,0,0,0,0,0,82253,0,26124),
(128592,'Light\'s blessings, traveller.','',0,0,0,0,0,0,0,0,0,0,82254,0,26124),
(128593,'How can I help?','',0,0,0,0,0,0,0,0,0,0,82255,0,26124),
(128594,'The Light grant you strength.','',0,0,0,0,0,0,0,0,0,0,82256,0,26124),
(128595,'I will protect the realm.','',0,0,0,0,0,0,0,0,0,0,82257,0,26124),
(128596,'My shield is yours.','',0,0,0,0,0,0,0,0,0,0,82258,0,26124),
(128597,'I will smite our foes!','',0,0,0,0,0,0,0,0,0,0,82259,0,26124),
(128598,'Be wary of dragons. They cannot be trusted!','',0,0,0,0,0,0,0,0,0,0,82260,0,26124),
(128599,'In our time together, my brother and I have seen wars and tests aplenty.','',0,0,0,0,0,0,0,0,0,0,82261,0,26124),
(128600,'I am but one of many who has taken up the lance for Azeroth.','',0,0,0,0,0,0,0,0,0,0,82262,0,26124),
(128601,'Greetings.','',0,0,0,0,0,0,0,0,0,0,81683,0,26124),
(128602,'I can always use another apprentice.','',0,0,0,0,0,0,0,0,0,0,81684,0,26124),
(128603,'Do you like... trials?','',0,0,0,0,0,0,0,0,0,0,81698,0,26124),
(128604,'Am I here... or am I an illusion?','',0,0,0,0,0,0,0,0,0,0,81699,0,26124),
(128605,'Do try not to die now!','',0,0,0,0,0,0,0,0,0,0,81700,0,26124),
(128606,'Go forth, and do... something!','',0,0,0,0,0,0,0,0,0,0,81701,0,26124),
(128607,'Wait, who are you again?','',0,0,0,0,0,0,0,0,0,0,81702,0,26124),
(128608,'Keep up your studies.','',0,0,0,0,0,0,0,0,0,0,81703,0,26124),
(128609,'Wait... did I leave the Trial of Fire on? I\'m pretty sure I turned it off...','',0,0,0,0,0,0,0,0,0,0,81704,0,26124),
(128610,'Apprentices..? Apprenticeese..? Apprentici..? Yes, I think that\'s it...','',0,0,0,0,0,0,0,0,0,0,81705,0,26124),
(128611,'You\'ll never become a real mage wearing that outfit.','',0,0,0,0,0,0,0,0,0,0,81706,0,26124),
(128612,'I went full shadow... Never go full shadow.','',0,0,0,0,0,0,0,0,0,0,81707,0,26124),
(128613,'','If this was only a distraction, where\'s the main attack? We need to ask Aviana. She\'ll know!',0,0,0,0,0,0,0,0,0,0,0,82141,26124),
(128614,'We discovered the saboteur\'s corpse near the weapons core. His soul had been drained... Ugh, such a terrible way to die.\n\nThe situation is worse than I let on, I\'m afraid.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(128615,'It seems our allies somehow repelled the attack... stay at the ready.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128616,'How did the Legion gain access to Dalaran\'s weapons?','How did the Legion gain access to Dalaran\'s weapons?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(128617,'You\'re ordered to report to the battlefield at once. Take out those demons shredding our front lines!','',0,0,0,0,0,0,0,0,6,0,82690,0,26124),
(128618,'The saboteur was from the Horde - one of my own Sunreavers, in fact.\n\nThere are those on the Council who strongly opposed allowing us back into the Kirin Tor in the first place. As you can imagine, this gives them all the ammunition they need to lobby for our expulsion yet again.\n\nAnd if that happens, our truce will shatter and Azeroth will surely fall to the Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128619,'Go on.','Go on.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(128620,'The mighty Legion has attacked, and we are barely holding off their siege.','',0,0,0,0,0,0,0,0,6,0,0,0,26124),
(128621,'','Even with Kanrethad returned to us, these occultists remain loyal to the Legion. We cannot let them regain control of Felfire Pass. Thin their numbers and absorb their sources of power!',0,0,0,0,0,0,0,0,0,0,0,81814,26124),
(128622,'','Such a display of power! I\'d wager those occultists regret allying with our enemy!',0,0,0,0,0,0,0,0,0,0,0,81815,26124),
(128623,'','Felfire Pass is crawling with occultists loyal to the Burning Legion. We cannot let them gain a footing!',0,0,0,0,0,0,0,0,0,0,0,81816,26124),
(128624,'','Even with their leader dead, these felborne trappers won\'t stop! Take this manaroot salve and apply it to any wounded animals you see. Save as many as you can!',0,0,0,0,0,0,0,0,0,0,0,81573,26124),
(128625,'Thunder Totem is under siege! Let us save our comrades before we knock that demon vessel out of the sky.','',0,0,0,0,0,0,0,0,0,0,81542,0,26124),
(128626,'','You are a true protector of nature. You have my thanks.',0,0,0,0,0,0,0,0,0,0,0,81574,26124),
(128627,'','My chosen offer the gift of life, champion. Claim their prize and fight on!',0,0,0,0,0,0,0,0,0,0,0,81746,26124),
(128628,'','Champions, the Legion seeks to infiltrate Thunder Totem from below. Help push them back!',0,0,0,0,0,0,0,0,0,0,0,81548,26124),
(128629,'You are a traitor to our people, siding with these demon worshippers!','',0,0,0,0,0,0,5,0,0,0,82449,0,26124),
(128630,'','One of Navarrogg\'s geomancers is sealing the tunnels to stem the flow of Legion enemies. Defend him at all costs!',0,0,0,0,0,0,0,0,0,0,0,81549,26124),
(128631,'','Argh!',0,0,0,0,0,0,0,0,0,0,0,81550,26124),
(128632,'','Heroes... deal with this... fiend...',0,0,0,0,0,0,0,0,0,0,0,81551,26124),
(128633,'','Good work, heroes. Though only two of the tunnels were sealed, every bit helps.',0,0,0,0,0,0,0,0,0,0,0,81552,26124),
(128634,'We are ready to attack the Legion ship. Mayla, champions, meet me outside Thunder Totem. Time to make them pay!','',0,0,0,0,0,0,0,0,0,0,81543,0,26124),
(128635,'','Understood. Heroes, lets get to the rendezvous point.',0,0,0,0,0,0,0,0,0,0,0,81769,26124),
(128636,'','Look out!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128637,'','We must keep moving!',0,0,0,0,0,0,0,0,0,0,0,81553,26124),
(128638,'','Once aboard, rescue all the captives you can. When my people are safe, set these explosives and get off the ship... fast!',0,0,0,0,0,0,0,0,0,0,0,81554,26124),
(128639,'These war eagles will carry us to our destination. Ready to go? Then climb aboard!','',0,0,0,0,0,0,0,0,0,0,81544,0,26124),
(128640,'I leave it to you to sabotage the Legion ship and rescue our allies. The demon commander is mine!','',0,0,0,0,0,0,0,0,0,0,81622,0,26124),
(128641,'Arrgh!','',0,0,0,0,0,0,0,0,0,0,81545,0,26124),
(128642,'','Felborne trappers are using their twisted magic upon the wildlife here. Take this manaroot salve and apply it to any wounded animals you see. Hurry, before the corruption takes hold!',0,0,0,0,0,0,0,0,0,0,0,81575,26124),
(128643,'Heh. Is this all this planet can offer? So very weak. I desire a true challenge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128644,'','Hurry, heroes. Lasan needs your help!',0,0,0,0,0,0,0,0,0,0,0,81555,26124),
(128645,'A close call. Thank you for the help.','',0,0,0,0,0,0,0,0,0,0,81546,0,26124),
(128646,'What a battle! Any moment now this ship will explode into tiny pieces. No matter! One of our eagles will see you to safety!','',0,0,0,0,0,0,0,0,0,0,81547,0,26124),
(128647,'','The fel contagion has found its way to Deadwood Landing once again, High Priest. We must contain this sickness before it infects the mainland.',0,0,0,0,0,0,0,0,0,0,0,81570,26124),
(128648,'','A terrible contagion has consumed Deadwood Landing. The harpies that infest the island are carriers. Their corruption must not be allowed to spread!',0,0,0,0,0,0,0,0,0,0,0,81571,26124),
(128649,'','Brilliant work! The contagion appears to be contained.',0,0,0,0,0,0,0,0,0,0,0,81572,26124),
(128650,'Tell me more about Arcanist Ryanna.','Tell me more about Arcanist Ryanna.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(128651,'I discovered her quite by accident, really. Er, well, she discovered me.\n\nI got myself into a bit of a.. situation... with a harpy and a banshee, and... oh nevermind.\n\nAnyway, Ryanna freed me with some very impressive spellwork. And then asked to join the Tirisgarde.\n\nHow could I turn her down?','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(128652,'','I\'ll meet you up ahead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128653,'\'Tis good ta see ye, $n. Now that the nightmares are gone, we can find out what she wants ta tell us. Give the word and we\'ll begin.','',0,0,0,0,0,0,0,0,0,0,85236,0,26124),
(128654,'She\'s tryin\' ta send me a message... a warning, methinks. But somethin\'s not right with her.','',0,0,0,0,0,0,0,0,0,0,85215,0,26124),
(128655,'Meet me in Sholazar Basin up in Northrend. Together, we\'ll get ta the bottom o\' this!','',0,0,0,0,0,0,0,0,0,0,85216,0,26124),
(128656,'A shame Brann didn\'t come with ye. Nothin\' me brother loves more than openin\' titan doors!','',0,0,0,0,0,0,0,0,0,0,85217,0,26124),
(128657,'Enough of this! I will put an end to you myself!','',0,0,0,0,0,0,0,0,0,0,82450,0,26124),
(128658,'Anomaly detected. Engaging defense protocol Gamma Theta Phi Omicron.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128659,'Reactivation sequence complete. Initiating sentry protocols.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128660,'Self-repair mode resumed. External assistance evaluation: appreciated.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128661,'I sense her fear... her doubt. We\'ve gotta help her! Looks like some o\' the defenses are down. If ye reactivate \'em, it might help snap her out o\' this!','',0,0,0,0,0,0,0,0,0,0,85218,0,26124),
(128662,'Ye did it! The nightmares are contained. Keep going, I\'m just ahead in the next chamber.','',0,0,0,0,0,0,0,0,0,0,85219,0,26124),
(128663,'You are BLIND. I WILL FORCE YOUR EYES OPEN.','',0,0,0,0,0,0,0,0,0,0,85394,0,26124),
(128664,'Champion! Azeroth needs our help.','',0,0,0,0,0,0,0,0,0,0,85220,0,26124),
(128665,'Ah, yer gettin\' close. Come ta the Makers\' Overlook, high in the eastern mountains. I\'ll show ye the way inside.','',0,0,0,0,0,0,0,0,0,0,85221,0,26124),
(128666,'Here ya go. This pad\'ll bring ye deep below ground, ta a place no mortal has walked in millennia... the Hall o\' Communion! C\'mon down, I\'ve got a lot to show ye.','',0,0,0,0,0,0,0,0,0,0,85222,0,26124),
(128667,'The titans built these halls ta watch over the soul o\' the world. From this chamber I can hear her, clear as diamond.','',0,0,0,0,0,0,0,0,0,0,85235,0,26124),
(128668,'Lately she\'s seemed... troubled. Hard ta read. I hope ye can help me get through ta her.','',0,0,0,0,0,0,0,0,0,0,85223,0,26124),
(128669,'Somethin\'s triggered the defenses! Careful now, ye\'ve got company!','',0,0,0,0,0,0,0,0,0,0,85224,0,26124),
(128670,'','I\'m not sure if this will work, but I might as well give it a shot... Stand back!',0,0,0,0,0,0,0,0,0,0,0,82142,26124),
(128671,'These phantoms must be her dreams... her nightmares. If we help her overcome these horrors, Azeroth should be able ta give us her message.','',0,0,0,0,0,0,0,0,0,0,85225,0,26124),
(128672,'','The shal\'dorei have been isolated for so many generations. We find it difficult to open our minds to new ways of thinking.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128673,'Talk ta me, lass. Tell me what\'s got ye all in a tizzy...','',0,0,0,0,0,0,0,0,0,0,85226,0,26124),
(128674,'','If my elders knew I was consorting with an outlander, I would be banished... Or worse.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128675,'The Dark Titan comes! We gotta stop him! Argus... the Legion\'s homeworld. She says our destiny lies there.','',0,0,0,0,0,0,0,0,0,0,85227,0,26124),
(128676,'','Aviana! Your children need you. The Druids of the Talon are being slaughtered at the hands of the Legion!',0,0,0,0,0,0,0,0,0,0,0,82143,26124),
(128677,'Her feelin\'s are a jumble. I need ta focus, let her thoughts flow into--UNNGG!','',0,0,0,0,0,0,0,0,0,0,85228,0,26124),
(128678,'','I have always found magic to be wondrous in all of its forms. Now that the shield has dropped, I cannot wait to master all of it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128679,'Sands... soaked in pain. Rivers... rivers of blood.','',0,0,0,0,0,0,0,0,0,0,85229,0,26124),
(128680,'How did you meet Aethas?','How did you meet Aethas?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(128681,'','To think my brothers and sisters died to a \"distraction\"... I won\'t stand for it!',0,0,0,0,0,0,0,0,0,0,0,82144,26124),
(128682,'Skies aflame. A sword... in the darkness... the wound... burning...','',0,0,0,0,0,0,0,0,0,0,85230,0,26124),
(128683,'How can we help?','How can we help?',0,0,0,0,0,0,0,0,6,48134,0,0,26124),
(128684,'','Aviana, your birds bring news from all over Azeroth. Please, help us find the demons\' target! We must avenge our fallen kin!',0,0,0,0,0,0,0,0,0,0,0,82145,26124),
(128685,'Sar...ger...as...','',0,0,0,0,0,0,0,0,0,0,85231,0,26124),
(128686,'','Oh! I came upon him in Tel\'anor caught in a harpy\'s bonds without a stitch of clothing! Ha!\n\nThe harpy was so busy arguing with a banshee over who got to play with him first, that they did not notice me at all.\n\nHe looked terribly uncomfortable, so I intervened. And the rest is history!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128687,'Threat neutralized. Deploying repair matrix.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128688,'No local threats detected. Commencing assistance appreciation.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128689,'','Threat signatures neutralized. Facility defenses at 74.39 percent. Repairs in progress.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128690,'','Subject: Azeroth. Minor arrhythmia detected, but vitals within acceptable parameters. Incident reports updated.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128697,'I\'m coming for you!','',0,0,0,0,0,0,0,0,0,0,85214,0,26124),
(128698,'Let\'s go.','Let\'s go.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128699,'','Those who harm my children shall pay!',0,0,0,0,0,0,0,0,0,0,0,20744,26124),
(128700,'','Aviana!',0,0,0,0,0,0,0,0,0,0,0,82146,26124),
(128701,'Spiders! Of all the infernal demons the Legion could dispatch into my realm, why did it have to be spiders?','',0,0,0,0,0,0,0,0,0,0,81567,0,26124),
(128702,'It is imperative that you destroy any clutches of eggs you find. This infestation must not spread!','',0,0,0,0,0,0,0,0,0,0,81568,0,26124),
(128703,'','Wow... Aviana...',0,0,0,0,0,0,1,0,0,0,0,82147,26124),
(128704,'','There\'s no time to lose, Archdruid! I\'m ready to stab some demons!',0,0,0,0,0,0,22,0,0,0,0,82148,26124),
(128705,'I have faced malevolent naga, angry spirits, and insidious demons. But spiders... unbearable!','',0,0,0,0,0,0,0,0,0,0,81569,0,26124),
(128706,'I have a very sticky situation for you, champion. We need silk harvested from the broods of the Creeping Grotto to use for a rather complex incantation. Can you help?','',0,0,0,0,0,0,0,0,0,0,83067,0,26124),
(128707,'I sense a foul force within Bradensbrook, hero. Search for Legion presence and destroy it!','',0,0,0,0,0,0,0,0,0,0,81557,0,26124),
(128708,'Well done, hero! So long as the shadow of the Legion darkens our world, we must remain vigilant.','',0,0,0,0,0,0,0,0,0,0,81560,0,26124),
(128709,'We were having quite a time finding volunteers brave enough to enter that nest of evil. If you need a new pair of shoes after wading through those webs, I have a connection in Dalaran that can offer you a discount!','',0,0,0,0,0,0,0,0,0,0,83069,0,26124),
(128710,'Hey bub! I got a proposition for ya!','',0,0,0,0,0,0,1,0,0,0,81963,0,26124),
(128711,'Now we\'re talkin\'! Just look at that thing go!','',0,0,0,0,0,0,0,0,0,0,81964,0,26124),
(128712,'Don\'t worry about our test subjects. I\'m sure they\'re used to these things by now.','',0,0,0,0,0,0,0,0,0,0,81965,0,26124),
(128713,'That\'s enough testing, bud. I think it\'s time to start thinking about mass production!','',0,0,0,0,0,0,0,0,0,0,81966,0,26124),
(128714,'Swing back to the Hall of the Guardian, and I\'ll give ya a little something for your troubles.','',0,0,0,0,0,0,0,0,0,0,81967,0,26124),
(128715,'Alright, now the first thing you gotta do is get yourself a hat with a pocket dimension portal inside.','',0,0,0,0,0,0,1,0,0,0,81968,0,26124),
(128716,'Then you just fill it with bunnies, aaaand.... bam!','',0,0,0,0,0,0,0,0,0,0,81969,0,26124),
(128717,'Here, now you try.','',0,0,0,0,0,0,0,0,0,0,81970,0,26124),
(128718,'What the whatnow!?','',0,0,0,0,0,0,603,0,0,0,81971,0,26124),
(128719,'Alright pal, just poke around in there and see what\'s going on with the rabbits.','',0,0,0,0,0,0,0,0,0,0,81972,0,26124),
(128720,'How did a wolf get in there?! Well don\'t just stand around, kill the thing!','',0,0,0,0,0,0,0,0,0,0,81973,0,26124),
(128721,'Phew, that was a close one! Rabbits don\'t come cheap, y\'know!','',0,0,0,0,0,0,0,0,0,0,81974,0,26124),
(128722,'Hang tight a sec. I\'ll get you outta there.','',0,0,0,0,0,0,0,0,0,0,81975,0,26124),
(128723,'Alright! I\'ll grab my stuff and we can ditch these stiffs.','',0,0,0,0,0,0,1,0,0,0,81976,0,26124),
(128724,'See ya later, prestigidi--, um, prestidigigat-- Eh, forget it!','',0,0,0,0,0,0,3,0,0,0,81977,0,26124),
(128725,'I sense another infestation of demons nearby. Champion, I am counting upon you to eradicate them!','',0,0,0,0,0,0,0,0,0,0,81558,0,26124),
(128726,'Haha! So long, arch-losers!','',0,0,0,0,0,0,22,0,0,0,81979,0,26124),
(128727,'It will take time, but thanks to your deeds the land will one day recover. Well done, hero!','',0,0,0,0,0,0,0,0,0,0,81559,0,26124),
(128728,'Your path leads only to ruin. Lay down your weapons and bow before your masters!','',0,0,0,0,0,0,0,0,0,0,82166,0,26124),
(128729,'Don\'t like the show? You can kiss my sparkling enchanted posterior!','',0,0,0,0,0,0,6,0,0,0,81980,0,26124),
(128730,'Oh, coming back for more, I see? Well, ya better be a good tipper, bub!','',0,0,0,0,0,0,1,0,0,0,81962,0,26124),
(128732,'','Help me! Hurry!',0,0,0,0,0,0,0,0,0,0,0,82443,26124),
(128734,'','Come on, let\'s go! We have to save Goldrinn!',0,0,0,0,0,0,0,0,0,0,0,82149,26124),
(128735,'I had this compass crafted for my father\'s birthday. I gave it to him a few months before my ship ran aground on Pandaria. A lifetime ago...','',0,0,0,0,0,0,1,0,0,0,83223,0,26124),
(128736,'Since this war with the Legion began, I\'ve barely had a chance to think or breathe... or to mourn. Perhaps it\'s time to change that.','',0,0,0,0,0,0,1,0,0,0,83224,0,26124),
(128737,'Thank you for bringing my father\'s compass back to me. It is a reminder of how much I miss him.','',0,0,0,0,0,0,1,0,0,0,83225,0,26124),
(128738,'Our guest arrives. Perhaps now there is hope of reaching the king.','',0,0,0,0,0,0,1,0,0,0,83289,0,26124),
(128739,'Anduin refuses to eat or sleep. He ignores every plea to return to the palace. Nothing I say seems to offer comfort.','',0,0,0,0,0,0,1,0,0,0,83290,0,26124),
(128740,'I understand the need to mourn, but the king\'s place is on his throne. The Broken Shore must be our focus. Convince Anduin to end his vigil!','',0,0,0,0,0,0,1,0,0,0,83253,0,26124),
(128741,'','The portals should be around here somewhere... Keep your eyes open!',0,0,0,0,0,0,0,0,0,0,0,82150,26124),
(128742,'','Can you imagine the demons coming through and ending up with a face full of vines? Classic!',0,0,0,0,0,0,11,0,0,0,0,82151,26124),
(128743,'','That\'ll show \'em!',0,0,0,0,0,0,4,0,0,0,0,82152,26124),
(128744,'','No demons are coming through this portal any time soon!',0,0,0,0,0,0,4,0,0,0,0,82153,26124),
(128745,'','They... They\'re trying to corrupt Goldrinn! Quick, Archdruid!',0,0,0,0,0,0,0,0,0,0,0,82154,26124),
(128746,'King Greymane said you would be coming. Please, go right in.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128747,'I\'ll need a disguise to move through the city without attracting attention.','',0,0,0,0,0,0,1,0,0,0,83209,0,26124),
(128748,'I think I know just the spell. Follow me.','',0,0,0,0,0,0,1,0,0,0,83210,0,26124),
(128749,'<Goldrinn lays asleep, peaceful now that the fel energies are gone.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128750,'Wake up, Goldrinn.','Wake up, Goldrinn.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128751,'You should take out those imps quickly. They\'re not the hardiest creatures, but they can overwhelm you if left unchecked!','',0,0,0,0,0,0,0,0,0,0,82534,0,26124),
(128752,'The Legion will not get away with this!','The Legion will not get away with this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128753,'Admit that I am right! Break the body and the spirit follows.','',0,0,0,0,0,0,0,0,0,0,81820,0,26124),
(128754,'Physical pain? Bah! Mental anguish is the true weapon. Was it not the key to turning Rakeesh?','',0,0,0,0,0,0,0,0,0,0,81723,0,26124),
(128755,'Bah! It was the suffering I inflicted which... Hold! The mortals come! That fool Goroth has failed again!','',0,0,0,0,0,0,0,0,0,0,83066,0,26124),
(128756,'Sooner than expected, but no matter. Our work begins!','',0,0,0,0,0,0,0,0,0,0,81724,0,26124),
(128757,'','They brought back my cousin\'s body from the Broken Shore last week. I expect a lot more to follow.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128758,'Pain! Pain beyond measure!','',0,0,0,0,0,0,0,0,0,0,81822,0,26124),
(128759,'Agony impales you!','',0,0,0,0,0,0,0,0,0,0,81823,0,26124),
(128760,'At least we\'re safe here in Stormwind. King Wrynn will keep the city safe.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128761,'I will cut you to the core!','',0,0,0,0,0,0,0,0,0,0,81824,0,26124),
(128762,'Feed me with your screams!','',0,0,0,0,0,0,0,0,0,0,81825,0,26124),
(128763,'','Funny, I thought I just heard... No. It must be my imagination playing tricks on me.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128764,'Your suffering will be legend!','',0,0,0,0,0,0,0,0,0,0,81826,0,26124),
(128765,'How much can you withstand?','',0,0,0,0,0,0,0,0,0,0,81827,0,26124),
(128766,'This will hurt... I promise!','',0,0,0,0,0,0,0,0,0,0,81828,0,26124),
(128767,'They\'re right to be afraid. If we fail to stop the Legion on the Broken Shore, the demons will strike us here, at our home and hearth.','',0,0,0,0,0,0,1,0,0,0,83211,0,26124),
(128768,'Another broken body!','',0,0,0,0,0,0,0,0,0,0,81829,0,26124),
(128769,'Fragile mortal!','',0,0,0,0,0,0,0,0,0,0,81830,0,26124),
(128770,'Too much to endure?','',0,0,0,0,0,0,0,0,0,0,81831,0,26124),
(128771,'Death was too easy an escape for them.','',0,0,0,0,0,0,0,0,0,0,81832,0,26124),
(128772,'Their souls shall bear the torment of defeat for all eternity!','',0,0,0,0,0,0,0,0,0,0,81725,0,26124),
(128773,'The pain... of failing... the master...','',0,0,0,0,0,0,0,0,0,0,81833,0,26124),
(128774,'Our suffering... will be... glorious...','',0,0,0,0,0,0,0,0,0,0,81726,0,26124),
(128775,'I offer respite from the darkness! Surrender your will to me!','',0,0,0,0,0,0,0,0,0,0,81727,0,26124),
(128776,'Why endure this pain? Kneel to the Legion!','',0,0,0,0,0,0,0,0,0,0,81728,0,26124),
(128777,'I will burn away your defiance!','',0,0,0,0,0,0,0,0,0,0,81729,0,26124),
(128778,'Resistance will only bring pain!','',0,0,0,0,0,0,0,0,0,0,81730,0,26124),
(128779,'I\'m King Anduin! I\'m gonna kill every demon I see!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128780,'Your minds will break!','',0,0,0,0,0,0,0,0,0,0,81731,0,26124),
(128781,'Beg for release, mortals!','',0,0,0,0,0,0,0,0,0,0,81732,0,26124),
(128782,'','Don\'t be Anduin, be Varian! He was way tougher.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128783,'Yeah, my dad says that too. Okay, I\'m King Varian. Look out, demons!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128784,'I can\'t blame the lad for his choice. My father sacrificed everything to save his people. He was a great king.','',0,0,0,0,0,0,1,0,0,0,83212,0,26124),
(128785,'You are mine now!','',0,0,0,0,0,0,0,0,0,0,81733,0,26124),
(128786,'So weak a will!','',0,0,0,0,0,0,0,0,0,0,81734,0,26124),
(128787,'Too delicate to survive!','',0,0,0,0,0,0,0,0,0,0,81735,0,26124),
(128788,'That one\'s mind gave out!','',0,0,0,0,0,0,0,0,0,0,81736,0,26124),
(128789,'Mortal minds break so easily. It is unsatisfying.','',0,0,0,0,0,0,0,0,0,0,81737,0,26124),
(128790,'It was their bodies that gave out! The triumph is mine!','',0,0,0,0,0,0,0,0,0,0,81834,0,26124),
(128791,'This defeat... will haunt me...','',0,0,0,0,0,0,0,0,0,0,81738,0,26124),
(128792,'There is... more pain... to come...','',0,0,0,0,0,0,0,0,0,0,81835,0,26124),
(128793,'Take heed, mortals! Obedient souls serve the Legion!','',0,0,0,0,0,0,0,0,0,0,81739,0,26124),
(128794,'Look how eagerly this soul obeys us!','',0,0,0,0,0,0,0,0,0,0,81740,0,26124),
(128795,'All my handiwork... ruined!','',0,0,0,0,0,0,0,0,0,0,81741,0,26124),
(128796,'You will pay for that insult!','',0,0,0,0,0,0,0,0,0,0,81742,0,26124),
(128797,'Since you brought my father\'s compass back to me, I\'ve prayed to the Light for guidance, and to know his spirit is at rest. The Light doesn\'t answer.','',0,0,0,0,0,0,1,0,0,0,83213,0,26124),
(128798,'Poor soul! And you think I am the cruel one...','',0,0,0,0,0,0,0,0,0,0,81638,0,26124),
(128799,'My people like me, respect me... but they don\'t believe in me. Not like they believed in him.','',0,0,0,0,0,0,1,0,0,0,83214,0,26124),
(128800,'I\'ve heard the voice of the people, but how do my father\'s advisors feel? I fear they do not trust me as they did my father.','',0,0,0,0,0,0,1,0,0,0,83215,0,26124),
(128801,'The young king will become a great leader. I have foreseen it.','',0,0,0,0,0,0,1,0,0,0,83287,0,26124),
(128802,'Visions don\'t win wars, Prophet. The boy has a good heart, but he\'s untested.','',0,0,0,0,0,0,1,0,0,0,83254,0,26124),
(128803,'The Light is strong with Anduin. He will grow into his crown. We must have faith.','',0,0,0,0,0,0,1,0,0,0,83288,0,26124),
(128804,'Yes, my precious ones. The fel has brought out our true beauty.','',0,0,0,0,0,0,0,0,0,0,81710,0,26124),
(128805,'Feel your throat tighten!','',0,0,0,0,0,0,0,0,0,0,81711,0,26124),
(128806,'This breath will be your last!','',0,0,0,0,0,0,0,0,0,0,81712,0,26124),
(128807,'We need more than that, and so does he. Anduin wasn\'t there on the Broken Shore. He hasn\'t seen the sacrifice his soldiers made... that they continue to make.','',0,0,0,0,0,0,1,0,0,0,83255,0,26124),
(128808,'I will crush the life from you!','',0,0,0,0,0,0,0,0,0,0,81713,0,26124),
(128809,'A king must know the weight of the orders he gives--the price of them. If a compass breaks his spirit, how will he respond when the war arrives on our doorstep?','',0,0,0,0,0,0,1,0,0,0,83256,0,26124),
(128810,'My tendrils will take you!','',0,0,0,0,0,0,0,0,0,0,81714,0,26124),
(128811,'These ancient grounds are not for you!','',0,0,0,0,0,0,0,0,0,0,81715,0,26124),
(128812,'You disturb nature\'s perfection!','',0,0,0,0,0,0,0,0,0,0,81716,0,26124),
(128813,'Fodder for the compost heap!','',0,0,0,0,0,0,0,0,0,0,81717,0,26124),
(128814,'Food for the worms!','',0,0,0,0,0,0,0,0,0,0,81718,0,26124),
(128815,'They did not show the proper respect to nature.','',0,0,0,0,0,0,0,0,0,0,81719,0,26124),
(128816,'Mortals seldom appreciate true beauty.','',0,0,0,0,0,0,0,0,0,0,81720,0,26124),
(128817,'Now I... shall feed... the soil...','',0,0,0,0,0,0,0,0,0,0,81721,0,26124),
(128818,'My end... was written... in the rings...','',0,0,0,0,0,0,0,0,0,0,81722,0,26124),
(128819,'Thank you, my friend. I know what I must do to learn the weight of my father\'s crown.','',0,0,0,0,0,0,1,0,0,0,83216,0,26124),
(128820,'Little fools wanna outsmart the Legion? Think again!','',0,0,0,0,0,0,0,0,0,0,81836,0,26124),
(128821,'Gonna run you dummies over!','',0,0,0,0,0,0,0,0,0,0,81837,0,26124),
(128822,'I must go to the Broken Shore and see for myself the sacrifice he made.','',0,0,0,0,0,0,1,0,0,0,83217,0,26124),
(128823,'I\'LL STOMP YOU!','',0,0,0,0,0,0,0,0,0,0,81838,0,26124),
(128824,'Stand still, wimps!','',0,0,0,0,0,0,0,0,0,0,81839,0,26124),
(128825,'C\'mere and fight!','',0,0,0,0,0,0,0,0,0,0,81840,0,26124),
(128826,'Come and get it!','',0,0,0,0,0,0,0,0,0,0,81841,0,26124),
(128827,'Books are for losers!','',0,0,0,0,0,0,0,0,0,0,81842,0,26124),
(128828,'Dead doofus!','',0,0,0,0,0,0,0,0,0,0,81843,0,26124),
(128829,'Learned your lesson?','',0,0,0,0,0,0,0,0,0,0,81844,0,26124),
(128830,'HA! Who\'s the smart one now?','',0,0,0,0,0,0,0,0,0,0,81845,0,26124),
(128831,'Don\'t need books when I got fists!','',0,0,0,0,0,0,0,0,0,0,81846,0,26124),
(128832,'Didn\'t... think this... through...','',0,0,0,0,0,0,0,0,0,0,81847,0,26124),
(128833,'Shoulda... stayed in... school...','',0,0,0,0,0,0,0,0,0,0,81848,0,26124),
(128834,'I shall find safety to recover. You must find out who is behind this and take them out!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128835,'','You heard Goldrinn! We have to find out who\'s leading these attacks now! No time to lose!',0,0,0,0,0,0,0,0,0,0,0,82155,26124),
(128836,'Focus your attacks. We must not allow the connection to continue!','Focus your attacks. We must not allow the connection to continue!',0,0,0,0,0,0,0,0,0,47813,0,0,26124),
(128837,'Don\'t stop until the connection is severed!','Don\'t stop until the connection is severed!',0,0,0,0,0,0,0,0,0,47813,0,0,26124),
(128838,'The energy coming off this thing is incredible.','The energy coming off this thing is incredible.',0,0,0,0,0,0,0,0,0,47813,0,0,26124),
(128839,'We\'ve got to hold the skies a little longer. We cannot afford to fail now.','We\'ve got to hold the skies a little longer. We cannot afford to fail now.',0,0,0,0,0,0,0,0,0,47813,0,0,26124),
(128840,'If the tether remains intact much longer Azsuna will be lost!','If the tether remains intact much longer Azsuna will be lost!',0,0,0,0,0,0,0,0,0,47813,0,0,26124),
(128841,'Keep the skies clear or the conduit will never fall!','Keep the skies clear or the conduit will never fall!',0,0,0,0,0,0,0,0,0,47813,0,0,26124),
(128842,'Restrain the beast, and I will summon them to us...','',0,0,0,0,0,0,0,0,0,0,82535,0,26124),
(128843,'The Aegis of Aggramar has been depleted!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(128845,'Come with me to the Summoning Platform where the ritual has been prepared.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128854,'','I got everything I needed from this fiend before you got here. I know where their commander is!',0,0,0,0,0,0,1,0,0,0,0,82156,26124),
(128857,'Look upon the true face of death, and know that your end comes soon!','',0,0,0,0,0,0,0,0,0,0,85393,0,26124),
(128858,'','Come my children and feed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128859,'','Feeding time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128860,'The pain of flesh is fleeting. True torment lasts forever.','',0,0,0,0,0,0,0,0,0,0,85395,0,26124),
(128862,'Your courage will fail.','',0,0,0,0,0,0,0,0,0,0,85397,0,26124),
(128866,'Soon the heart of your world will beat no more!','',0,0,0,0,0,0,0,0,0,0,85396,0,26124),
(128867,'','That commander\'s going to taste my blade!',0,0,0,0,0,0,0,0,0,0,0,82157,26124),
(128871,'Mortal! I have been sent by the great Neptulon to bring ruin and judgment upon these fel infused fools that would invade our world.$b$bJoin me in battle, and together we shall quench the flames of their evil.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128872,'I will not let that happen.','I will not let that happen.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(128874,'Thank you, Archdruid. I feared the worst.','Thank you, Archdruid. I feared the worst.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(128875,'The commander must be stopped. I believe in you!','The commander must be stopped. I believe in you!',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(128876,'I will return to the Dreamgrove. Thank you!','I will return to the Dreamgrove. Thank you!',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(128877,'','You don\'t... understand...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128878,'Thank you, stranger!','Thank you, stranger!',4,0,0,0,0,0,0,0,0,0,0,0,26124),
(128879,'I feel so weak; the webs were draining away my very essence.','I feel so weak; the webs were draining away my very essence.',462,0,0,0,0,0,0,0,0,0,0,0,26124),
(128880,'Thank you, hero! I thought my end had come!','Thank you, hero! I thought my end had come!',20,0,0,0,0,0,0,0,0,0,0,0,26124),
(128881,'I\'m never going to leave Nar\'thalas again!','I\'m never going to leave Nar\'thalas again!',4,0,0,0,0,0,0,0,0,0,0,0,26124),
(128882,'You have my thanks!','You have my thanks!',2,0,0,0,0,0,0,0,0,0,0,0,26124),
(128883,'I... live? Thank you friend! Thank you so much!','I... live? Thank you friend! Thank you so much!',4,0,0,0,0,0,0,0,0,0,0,0,26124),
(128884,'','I\'ll meet you back in the Dreamgrove, Archdruid. Thanks for bringing me along!',0,0,0,0,0,0,1,0,0,0,0,82158,26124),
(128885,'A valiant battle earlier, washing away the fires of evil and drowning the aspirations of the fel.$b$bYou did well for one who is so painfully dry.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128886,'Archmage,the felbound manasabers in the Weeping Terrace must be freed! The abjurists holding them are quite powerful. A well-timed Spell Steal may come in handy!','',0,0,0,0,0,0,0,0,0,0,82860,0,26124),
(128887,'Hero! The naga and their skrog lackeys have harassed my warriors long enough. Teach them the folly of their wicked ways!','',0,0,0,0,0,0,0,0,0,0,83102,0,26124),
(128888,'Glorious carnage indeed! You put those watery pests in their place.','',0,0,0,0,0,0,0,0,0,0,83103,0,26124),
(128889,'I will slaughter every last one of your precious Ancients!','',0,0,0,0,0,0,0,0,0,0,82715,0,26124),
(128890,'No! The Legion... will destroy... your world...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128891,'Neptulon has sent one of his greatest champions to aid our cause, and has asked for you by name. I look forward to seeing what damage the two of you can unleash.','',0,0,0,0,0,0,0,0,0,0,83090,0,26124),
(128892,'Thank you, champion. Things were really beginning to heat up!','',0,0,0,0,0,0,0,0,0,0,83091,0,26124),
(128893,'Drown in your failure!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128894,'By Water be purged!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128895,'Your fire is quenched!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128896,'Drown on this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128897,'Begone, fel thing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128898,'You cannot stand against the flood!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128899,'Fall before the tide of justice!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128900,'My waters run green with taint. Perhaps a good filtering is in order.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128901,'Come, little Champion, and let us drown our enemies in the tides of justice!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128902,'Domatrax rips open additional Fel Portals!','Domatrax rips open additional Fel Portals!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128903,'Intruder! How did you find my lair!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128904,'It\'s no matter, in a moment I will be gone along with all of my treasure!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128905,'','Hey, jerk! I think this shard you brought me is broken. I tried hitting it with a rock and everything!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128906,'','Oh, hey. Who are you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128907,'I\'m Iks\'reeged, Treasure Master! Wait... What is that you are holding?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128908,'','The Ancient Shard of Binding begins to radiate with tremendous power.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128909,'NO! How dare you! I will not bend knee to such a fatuous creature!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128910,'Arrrg! What have you done?! Shackled to this realm forever? I cannot imagine a worse fate!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128911,'','Whoops! So, I guess that\'s what this thing does! Oh well.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128912,'','Hey! Look at all this treasure!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128913,'Champion, there is a collection of energy near our camp that seems to be specifically attuned to you. Would you investigate this disturbance?','',0,0,0,0,0,0,0,0,0,0,83092,0,26124),
(128914,'Fascinating! Despite the frequency with which we summon forth elementals and demons, it never occurred to me that the door might swing both ways.','',0,0,0,0,0,0,0,0,0,0,83093,0,26124),
(128915,'Ah! My Summon Champion spell worked. Minion! We must do battle with another of my former masters up ahead. Get to it!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128916,'Minion! Eat this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128917,'I speak fer Azeroth!','',0,0,0,0,0,0,0,0,0,0,81623,0,26124),
(128918,'Well met!','',0,0,0,0,0,0,0,0,0,0,81624,0,26124),
(128919,'These stones have tales ta tell.','',0,0,0,0,0,0,0,0,0,0,81625,0,26124),
(128920,'Fight fer our world!','',0,0,0,0,0,0,0,0,0,0,81626,0,26124),
(128921,'Fer Azeroth!','',0,0,0,0,0,0,0,0,0,0,81627,0,26124),
(128922,'Back ta work!','',0,0,0,0,0,0,0,0,0,0,81628,0,26124),
(128923,'Enough o\' yer nonsense!','',0,0,0,0,0,0,0,0,0,0,81629,0,26124),
(128924,'Me magma\'s fixin\' ta boil!','',0,0,0,0,0,0,0,0,0,0,81630,0,26124),
(128925,'Ye\'re messin\' with the voice o\' the planet! THE PLANET!','',0,0,0,0,0,0,0,0,0,0,81631,0,26124),
(128926,'Now ye done it! IT\'S CLOBBERIN\' TIME!','',0,0,0,0,0,0,0,0,0,0,81632,0,26124),
(128927,'I must know. Follow me to the keep.','',0,0,0,0,0,0,1,0,0,0,83218,0,26124),
(128928,'No luck, eh? King Greymane won\'t be happy, but I\'m sure you did your best.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128929,'The time for prayer is over. I must know the hearts and minds of my people.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128930,'I will accompany you to Lion\'s Rest.','I will accompany you to Lion\'s Rest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128931,'Skyhold.','Skyhold.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128932,'To the Battlelord!','',0,0,0,0,0,0,0,0,0,0,81660,0,26124),
(128935,'So... tired...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128936,'For my masters! For the Legion!','For my masters! For the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128937,'You cannot escape the Legion!','You cannot escape the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128938,'There\'s no point... we\'re doomed! We\'re all doomed!','There\'s no point... we\'re doomed! We\'re all doomed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128939,'Don\'t you see? The Legion has already won!','Don\'t you see? The Legion has already won!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128940,'For the Legion!','For the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128941,'Death to all who oppose the Legion!','Death to all who oppose the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128942,'Erdris? You have been corrupted as well? It saddens me that your eternal slumber has been disturbed.','',0,0,0,0,0,0,0,0,0,0,82358,0,26124),
(128943,'The Helm of Domination shows me many things, Deathlord.','',0,0,0,0,0,0,0,0,6,0,82970,0,26124),
(128944,'I have seen a vision... thousands of undead marching to the far reaches of Northrend in search of a great power.','',0,0,0,0,0,0,0,0,0,0,82971,0,26124),
(128945,'Yet when reach out through the cold tendrils of endless ice, I sense nothing there.','',0,0,0,0,0,0,0,0,0,0,82972,0,26124),
(128946,'Go now to the far north of Icecrown, and I will show you what I have seen.','',0,0,0,0,0,0,0,0,0,0,82973,0,26124),
(128949,'It was here that I saw the undead swarming across an icy shelf, seeking a prize coveted by Arthas.','',0,0,0,0,0,0,0,0,0,0,82974,0,26124),
(128950,'Look ahead... Do you see it?','',0,0,0,0,0,0,0,0,0,0,82975,0,26124),
(128951,'The bones of a dragon most ancient, and powerful beyond reckoning.','',0,0,0,0,0,0,0,0,0,0,82976,0,26124),
(128952,'Yet all that remains here is the sea, and I sense no trace of undead.','',0,0,0,0,0,0,0,0,0,0,82977,0,26124),
(128953,'Find a member of the bronze flight, the tenders of history. Do not be merciful.','',0,0,0,0,0,0,0,0,0,0,82978,0,26124),
(128954,'The reds know something. They hide their secrets in the Ruby Sanctum beneath Wyrmrest.','',0,0,0,0,0,0,0,0,0,0,82979,0,26124),
(128955,'He has alerted his allies already. They will be expecting you.','',0,0,0,0,0,0,0,0,0,0,82980,0,26124),
(128956,'A record of their history must lurk somewhere in this sanctum. Spare who you will, or slay them all... the choice is yours.','',0,0,0,0,0,0,0,0,0,0,82981,0,26124),
(128957,'You are empty inside, just like me.','',0,0,0,0,0,0,0,0,0,0,82982,0,26124),
(128958,'Fly now into the north. Find this glacier... and your destiny.','',0,0,0,0,0,0,0,0,0,0,82983,0,26124),
(128960,'Continue north, Deathlord, into the blizzard.','',0,0,0,0,0,0,0,0,0,0,82984,0,26124),
(128961,'And hold tight to your reins.','',0,0,0,0,0,0,0,0,0,0,82985,0,26124),
(128963,'It is here... I can feel it. Your supplies have likely frozen. I sense feral undead buried in the ice. It seems the time has come to test your will.','',0,0,0,0,0,0,0,0,0,0,82986,0,26124),
(128964,'Of course, should you fail to survive, know that I shall claim Acherus for my own. Arthas may have sought revenge on the citadel, but I have... other plans.','',0,0,0,0,0,0,0,0,0,0,82987,0,26124),
(128965,'You are getting close. I can sense the spark of life ahead of you. You will bring decay to this lost place.','',0,0,0,0,0,0,0,0,0,0,82988,0,26124),
(128966,'I sense many feral undead nearby. They have been feeding on its life energy. Take it from them. Slay them all.','',0,0,0,0,0,0,0,0,0,0,82989,0,26124),
(128967,'You have stolen the dragon\'s life energy. Now, bend it to your desires. Pervert it with your darkness.','',0,0,0,0,0,0,0,0,0,0,82990,0,26124),
(128968,'I can feel the unholy energy surging within you. Raise the dragon and claim it as your own.','',0,0,0,0,0,0,0,0,0,0,82991,0,26124),
(128969,'The light of Dalaran burns ever so brightly. But should the darkness gather, our allies will be ready. I\'m sure of it.','The light of Dalaran burns ever so brightly. But should the darkness gather, our allies will be ready. I\'m sure of it.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128970,'You\'re right. We do not know what lies ahead. But if the darkness comes, we will face it together.','You\'re right. We do not know what lies ahead. But if the darkness comes, we will face it together.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128971,'Do not let fear of an uncertain future overwhelm you. We do not know what lies ahead.','Do not let fear of an uncertain future overwhelm you. We do not know what lies ahead.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128972,'You mustn\'t let the idle mutterings upset you. It\'s times like these we must remain strong.','You mustn\'t let the idle mutterings upset you. It\'s times like these we must remain strong.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128973,'I\'m not sure what he was doing, but his behavior seemed a bit--oh. Ignore my musings. It\'s fine. Everything\'s fine!','I\'m not sure what he was doing, but his behavior seemed a bit--oh. Ignore my musings. It\'s fine. Everything\'s fine!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128974,'These Rooksguard are newly risen, and may not have fallen fully into corruption. Perhaps they can yet be saved!','',0,0,0,0,0,0,1,0,0,0,82359,0,26124),
(128975,'As I told you, I don\'t know what they were talking about. But they did look... concerned.','As I told you, I don\'t know what they were talking about. But they did look... concerned.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128976,'...yes, but some aren\'t sure what to expect. There is something to be said for leading by example, especially in a time like this.','...yes, but some aren\'t sure what to expect. There is something to be said for leading by example, especially in a time like this.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128977,'Who knows. The first thing I saw when I looked up was that monstrosity lingering overhead.','Who knows. The first thing I saw when I looked up was that monstrosity lingering overhead.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128978,'Ah... Grandmaster. Almai and Blanche are waiting for you down in the village. I must... rest... a bit.','',0,0,0,0,0,0,0,0,0,0,82105,0,26124),
(128979,'NO! You need to listen to me. I\'m telling you--we need to get out of here!','NO! You need to listen to me. I\'m telling you--we need to get out of here!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128980,'What if this is it?','What if this is it?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128981,'You have fought well, Farseer $p. I see Thunderaan chooses his champions wisely. I will bow to his power.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128982,'','Please hurry, Grandmaster. The order\'s survival depends on your success!',0,0,0,0,0,0,0,0,0,0,0,82088,26124),
(128983,'The moment we lose faith in the Council is the moment our threads unravel. We must band together, not harbor our fears in events that have not yet occurred.','The moment we lose faith in the Council is the moment our threads unravel. We must band together, not harbor our fears in events that have not yet occurred.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128984,'I am sure the Council will reveal more information as it becomes available. In the meantime, remember that times like these have a way of revealing an individual\'s true character.','I am sure the Council will reveal more information as it becomes available. In the meantime, remember that times like these have a way of revealing an individual\'s true character.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128985,'You look a bit pale. Are you feeling well?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128986,'Looking tired, have another hard day out in the fields?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128987,'Lot of people acting strange lately... I hope there isn\'t a sickness going around.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128988,'I... I couldn\'t stop myself.','I... I couldn\'t stop myself.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128989,'They got into my head... into my mind!','They got into my head... into my mind!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128990,'I tried to stop but couldn\'t... it was like I was a puppet.','I tried to stop but couldn\'t... it was like I was a puppet.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128991,'The water... don\'t let the others drink the water!','The water... don\'t let the others drink the water!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128992,'What... what happened to me?','What... what happened to me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128993,'Where am I? Who are you?','Where am I? Who are you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(128994,'I\'m hesitant to answer further questions about what\'s going on. I\'m starting to lack confidence in my responses.','I\'m hesitant to answer further questions about what\'s going on. I\'m starting to lack confidence in my responses.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128995,'Welcome, $ct. Let\'s get this assault under way, shall we?','',0,0,0,0,0,0,6,0,0,0,83070,0,26124),
(128996,'I wonder what it means.','I wonder what it means.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128997,'We will divide our forces to hit them from all sides at once.','',0,0,0,0,0,0,5,0,0,0,83071,0,26124),
(128998,'No. You don\'t think... That\'s not possible!','No. You don\'t think... That\'s not possible!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(128999,'Quickly, $ct, we need you on the front lines!','',0,0,0,0,0,0,0,0,0,0,83073,0,26124),
(129000,'$n, our assault on the southern beach is being met with heavy resistance.','',0,0,0,0,0,0,0,0,0,0,83074,0,26124),
(129001,'I need you spearheading our forces while I deal with these ships!','',0,0,0,0,0,0,0,0,0,0,83075,0,26124),
(129002,'We must take the ruins on the western side of the island. From there we can funnel all of our forces toward the central ship above the soul engine.','',0,0,0,0,0,0,0,0,0,0,83076,0,26124),
(129003,'The Legion will not win this day! We will show them what it means to stand together. For Azeroth!','',0,0,0,0,0,0,0,0,0,0,83077,0,26124),
(129004,'We must take the beach before we can claim the ruins to the west.','',0,0,0,0,0,0,0,0,0,0,83078,0,26124),
(129005,'Good! They thought they were ready for us, but they\'ve never seen the forces of Azeroth work with such unity!','',0,0,0,0,0,0,0,0,0,0,83079,0,26124),
(129006,'Head up the hill to the west with the other forces. An eredar and his underlings guard the point. You know what to do.','',0,0,0,0,0,0,0,0,0,0,83080,0,26124),
(129007,'Ah! That\'s one ship down.','',0,0,0,0,0,0,0,0,0,0,83081,0,26124),
(129008,'Did you see them? The ones wandering, carrying on conversations with themselves?','Did you see them? The ones wandering, carrying on conversations with themselves?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129009,'Archers! Rain hell upon them!','',0,0,0,0,0,0,0,0,0,0,83082,0,26124),
(129010,'It seems you were doomed to fail, Lord Kalgorath.','',0,0,0,0,0,0,0,0,0,0,83083,0,26124),
(129011,'$n, the forces of Dread Commander Arganoth lie to the northeast. We must close the portals before our allies are overrun.','',0,0,0,0,0,0,0,0,0,0,83084,0,26124),
(129012,'Their command ship remains. We must destroy it before Dalaran\'s defenses fail! The Council of the Black Harvest has set up a gate for us. You may do the honors, $n.','',0,0,0,0,0,0,0,0,0,0,83085,0,26124),
(129013,'Get ready, $ct. I\'m pulling you out and detonating the bombs!','',0,0,0,0,0,0,0,0,0,0,83086,0,26124),
(129014,'Ah, there you are, $ct. I was worried I might have activated the bombs a tad prematurely.','',0,0,0,0,0,0,1,0,0,0,83088,0,26124),
(129015,'But how did it get there? It couldn\'t just appear out of nowhere.','But how did it get there? It couldn\'t just appear out of nowhere.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129016,'Right. We have our orders. Good luck.','',0,0,0,0,0,0,1,0,0,0,83089,0,26124),
(129018,'The warlocks took your world from you, nathrezim! I would not be so arrogant if I were you.','',0,0,0,0,0,0,0,0,0,0,81984,0,26124),
(129019,'We have won this day, but a grave threat still looms before us. The Legion\'s master has yet to play his hand.','',0,0,0,0,0,0,1,0,0,0,81986,0,26124),
(129020,'','The Wardens are with you, $ct.',0,0,0,0,0,0,0,0,0,0,0,81955,26124),
(129021,'','More portals?! Where the hell is our backup?',0,0,0,0,0,0,0,0,0,0,0,81956,26124),
(129022,'','Illidan, how courteous of you to finally arrive! Wardens, see to the real work while Illidan\'s demon hunters caper about with their bats.',0,0,0,0,0,0,0,0,0,0,0,81957,26124),
(129023,'','You are too quick to trust Illidan, Prophet. I will ensure he fulfills his duty.',0,0,0,0,0,0,1,0,0,0,0,81958,26124),
(129024,'Here, these will help. Plant them around the ship. I will activate them from here when ready.','',0,0,0,0,0,0,0,0,0,0,83087,0,26124),
(129025,'You think a few mortals with gaudy weapons can stop us?','',0,0,0,0,0,0,0,0,0,0,82702,0,26124),
(129026,'You are doomed to fail!','',0,0,0,0,0,0,0,0,0,0,82703,0,26124),
(129027,'I... I can\'t stop it. I\'ve tried to keep myself busy, but my mind wanders back to this feeling... this... I don\'t know what to call it anymore.','I... I can\'t stop it. I\'ve tried to keep myself busy, but my mind wanders back to this feeling... this... I don\'t know what to call it anymore.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129028,'As is the Light.','',0,0,0,0,0,0,0,0,0,0,83116,0,26124),
(129029,'Enough bickering! Stay focused!','',0,0,0,0,0,0,0,0,0,0,83117,0,26124),
(129030,'Perhaps. But not this day, demon!','',0,0,0,0,0,0,0,0,0,0,83118,0,26124),
(129031,'Mephistroth!','',0,0,0,0,0,0,0,0,0,0,83119,0,26124),
(129032,'Illidan, convey the Aegis of Aggramar to the cathedral. I will descend into the tomb with Khadgar and hunt the monster down. Kil\'jaeden\'s reign of destruction will soon be ended!','',0,0,0,0,0,0,1,0,0,0,83120,0,26124),
(129033,'The sky grows closer every day. Is it ever going to end?','The sky grows closer every day. Is it ever going to end?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129034,'Yes, come forth. I could use some entertainment!','',0,0,0,0,0,0,0,0,0,0,82444,0,26124),
(129035,'Silence!','',0,0,0,0,0,0,0,0,0,0,82445,0,26124),
(129036,'Another foolish mortal wishes to face me? So be it!','',0,0,0,0,0,0,0,0,0,0,82446,0,26124),
(129037,'You destroy a few ships and claim a victory. It will be your last, I assure you. Savor this moment, for our next meeting will spell your doom!','',0,0,0,0,0,0,0,0,0,0,82165,0,26124),
(129038,'How long until our world crumbles?','How long until our world crumbles?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129039,'You can\'t possibly say you aren\'t feeling it. Look around us. This world\'s beginning to doubt itself.','You can\'t possibly say you aren\'t feeling it. Look around us. This world\'s beginning to doubt itself.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129040,'Have you seen the first aid shop? The line is out the door.','Have you seen the first aid shop? The line is out the door.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129041,'No matter what I do, I can\'t seem to stop looking up.','No matter what I do, I can\'t seem to stop looking up.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129042,'We will find a way to make sense of it all. And should the time come for action, I am sure our allies will be prepared.','We will find a way to make sense of it all. And should the time come for action, I am sure our allies will be prepared.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129043,'Fear has a way of playing tricks on the mind. You should get some rest, Jenny.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129044,'','Will he? How exactly will he keep an endless army of demons from invading and killing everyone?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129045,'','This will only take a moment!',0,0,0,0,0,0,0,0,0,0,0,82838,26124),
(129046,'<Lethecus has a far-away look in his eyes.>\n\nOh, yes? I didn\'t see you there.\n\n<Lethecus yawns.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129047,'','Here goes nothing. Brace yourselves!',0,0,0,0,0,0,0,0,0,0,0,82839,26124),
(129048,'Tell me all you know of a glacier to the north where a powerful dragon fell.','Tell me all you know of a glacier to the north where a powerful dragon fell.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129049,'','Behold our Fel might!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129050,'No, not that I can recall. I am terribly sorry, I am still in mourning over our dear Ysera\'s passing, I can think of little else right now. Did you ask the bronze flight? They have quite excellent memories.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129051,'Oh, hello! Thank you for visiting again.\n\nOr is this your first time?\n\nWhat day is it?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129052,'<Trizormu\'s eyes narrow.>\n\nWhat would a death-bringer like yourself want with that information, exactly?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129053,'Ack! Alright! There used to be... glaciers... large ones... to the north of Icecrown... they floated away years ago... I don\'t know any more, I swear! Speak to... Tariol!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129054,'Ringing the Large Northern Glacier were, in order of formation, the Medium-Sized Northeastern Glacier, the Small Southern Glacier, the Southwestern Tiny Glacier, the South-Southwestern Tiny Glacier, the South-Southeastern Tiny Glacier, the Most Southern Tiny Glacier, the First and Second Northern Tiny Glaciers That Keep Changing Positions...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129055,'','The Slayer remains unconscious. I fear what will happen if--',0,0,0,0,0,0,0,0,0,0,0,82840,26124),
(129056,'','That was a nasty knock on the head. Still, our Slayer is a strong one, my dear. Look!',0,0,0,0,0,0,0,0,0,0,0,82164,26124),
(129057,'...and while we\'re there, naturally we can\'t forget the Cluster of Five: the Northern, Southern, Eastern, and Western Small Ice Chunks That Have Been Technically Designated As Not Glaciers, which is really a funny story...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129058,'','What in blazes happened to my chickens?',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(129059,'The demons attack my troops before they can recover!','',0,0,0,0,0,0,0,0,0,0,82462,0,26124),
(129060,'Fear not, my lord. I can raise more.','',0,0,0,0,0,0,0,0,0,0,82795,0,26124),
(129061,'That demon must be dealt with, $n! Then we can focus on Erdris.','',0,0,0,0,0,0,0,0,0,0,82371,0,26124),
(129062,'Something\'s up with my rabbits! Poor little guys... We gotta do something!','',0,0,0,0,0,0,661,0,0,0,81978,0,26124),
(129063,'I suggest tossing out those rags and changing into something a bit more stylish. You might as well look good as the universe ends.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129064,'Return to the rest you earned long ago, brother!','',0,0,0,0,0,0,0,0,0,0,82372,0,26124),
(129065,'Shrug off this corruption, my friend!','',0,0,0,0,0,0,0,0,0,0,82373,0,26124),
(129066,'Ah, $n. Just the $c I was looking for. Like my new attire? Eh--who am I kidding? Won\'t matter soon anyway.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129067,'Only you can end this torment, brother. Fight it!','',0,0,0,0,0,0,0,0,0,0,82374,0,26124),
(129068,'And what brings a $c like you around, $n? Fancy some sleek attire for the end of the world as we know it?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129069,'I... I am free. Thank you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129070,'Price is no object when it comes to going out in style. I\'m flat broke... not that it\'ll matter soon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129071,'I will not be a tool of the Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129072,'I don\'t know about you, but I for one refuse to meet my maker in a common mage\'s garb.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129073,'The end is upon us, $n! At least that\'s what they\'re saying. Might as well look the part.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129074,'Mind your business, friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129075,'If you don\'t look up then nothing\'s wrong. Carry on!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129076,'The Burning Legion continues to try to recreate the masterpiece that was the Scourge. \n\nThey turn to their Nathrazim who make puppets of bones. \n\nThey turn to these fallen Spiritwalkers, who simply meddle at these magics.\n\nI am here, on behalf of the Ebon Blade, to observe and judge. And to lend assistance to you, hero, should you require it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129077,'Welcome, traveler! How are things out there?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129078,'No, Kerta. I do not think we have anything to worry about. Now focus. We must not keep our guest waiting.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129079,'Welcome. I fear our supplies have run low. We have been filling orders without much of a break since... well, you know.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129080,'Come in! Kerta and I were just discussing recent events. I would be interested in hearing your take.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129081,'I am certain the Council is well prepared, Kerta. Now look alive. We have another customer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129082,'What kind of assistance?','What kind of assistance?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129083,'','My apologies if I seem a bit on edge. Welcome to the shop.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129084,'For Northrend, you are looking for Leesha Tannerby, the Dockmaster for the Kraken. It sets sail for Valiance Keep in Borean Tundra from the northern dock in Stormwind Harbor.','For Northrend, you are looking for Leesha Tannerby, the Dockmaster for the Kraken. It sets sail for Valiance Keep in Borean Tundra from the northern dock in Stormwind Harbor.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(129085,'For the Exodar or Teldrassil located in Kalimdor, seek out the Nayura. She is the Dockmaster for The Bravery, setting sail from the southernmost dock in Stormwind Harbor.','For the Exodar or Teldrassil located in Kalimdor, seek out the Nayura. She is the Dockmaster for The Bravery, setting sail from the southernmost dock in Stormwind Harbor.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(129086,'If this is a representation of the type of necromancy that the Burning Legion relies on then we are in better shape than I ever imagined.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129087,'It is so nice to be away from Acherus doing some good, old fashioned field research again with fresh corpses and bone piles.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129088,'The mages have opened a portal just inside the Mage Tower to assist players getting to the Blasted Lands and on to Draenor. You will see the mage Sparkbright standing by next to it.','The mages have opened a portal just inside the Mage Tower to assist players getting to the Blasted Lands and on to Draenor. You will see the mage Sparkbright standing by next to it.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(129089,'There is a portal that leads to Hellfire Peninsula in Outland. It is located within the Wizard\'s Sanctum located at the top of the Mage Tower.','There is a portal that leads to Hellfire Peninsula in Outland. It is located within the Wizard\'s Sanctum located at the top of the Mage Tower.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(129090,'Say what you will about Arthas, but the former Lich King did have a cold efficiency when it came to dealing with the Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129091,'You are in luck Dalaran is currently located above the Broken Isles and the Kirin Tor have setup a portal located just inside Stormwind Keep.','You are in luck Dalaran is currently located above the Broken Isles and the Kirin Tor have setup a portal located just inside Stormwind Keep.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(129092,'Our new allies in Pandaria have allowed us to create a portal to Paw\'don Village in the Jade Forest. It is located on the western edge of the lake next to Stormwind Keep.','Our new allies in Pandaria have allowed us to create a portal to Paw\'don Village in the Jade Forest. It is located on the western edge of the lake next to Stormwind Keep.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(129094,'The Deeprun Tram is the fastest route to Ironforge. You will find it located in the Dwarven District.','The Deeprun Tram is the fastest route to Ironforge. You will find it located in the Dwarven District.',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(129095,'Stormwind is the center of the Alliance and offers many forms of travel to the far reaches of Azeroth and beyond. \n\nWhere are you looking to travel?','Stormwind is the center of the Alliance and offers many forms of travel to the far reaches of Azeroth and beyond. \n\nWhere are you looking to travel?',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(129096,'The stench of undeath follows you into this temple of life. Do not stay overlong.','',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(129097,'Tell me all you know of a great dragon that fell on a glacier to the north of Icecrown.','Tell me all you know of a great dragon that fell on a glacier to the north of Icecrown.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129098,'I have no idea what you are talking about. Now if you will excuse me, I have things to attend to. You may direct any additional questions to our steward.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129099,'You will never find what you seek, death-bringer. Now, you have worn out your welcome at this temple, begone!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129100,'Your actions stretch the limits of our alliance, death knight.','',1,1,25,0,0,0,0,0,1,0,0,0,26124),
(129102,'These supplies belong to the Legion!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129103,'The Legion will be your end...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129104,'Ironforge','Ironforge',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(129105,'Paw\'don Village in Pandaria','Paw\'don Village in Pandaria',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(129106,'Dalaran in the Broken Isles','Dalaran in the Broken Isles',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(129107,'Hellfire Peninsula in Outland','Hellfire Peninsula in Outland',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(129108,'Blasted Lands and the portal to Draenor','Blasted Lands and the portal to Draenor',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(129109,'Teldrassil or the Exodar in Kalimdor','Teldrassil or the Exodar in Kalimdor',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(129110,'Borean Tundra in Northrend','Borean Tundra in Northrend',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(129111,'Areas opened up in the Cataclysm','Areas opened up in the Cataclysm',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(129112,'|TInterface\\Icons\\ABILITY_WARLOCK_SHADOWFURYTGA.BLP:20|tOne of the runes |cFFFF0000|Hspell:237908|h[Detonates]|h|r!','|TInterface\\Icons\\ABILITY_WARLOCK_SHADOWFURYTGA.BLP:20|tOne of the runes |cFFFF0000|Hspell:237908|h[Detonates]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129113,'Heroes of Azeroth, your class orders have grown mighty throughout our campaign on the Broken Isles. Their strength, their courage, is needed now. The time has come to unite our forces and rid Azeroth of the Burning Legion.','',0,0,0,0,0,0,1,0,0,0,83068,0,26124),
(129114,'Look, these portals are not going to hijack themselves. I need time to do this right or you will just end up in a Legion melting pot or the gut of a Pit Lord. \n\nDo you want to teleport into the gut of a Pit Lord? Oh sure, at first it seems like a clever, unexpected attack. But then you get digested in fel juices and wonder where your great plan went.\n\nLeave me to my work.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129115,'So far this warlock has proved to be quite useful in deciphering the magics of our enemies. \n\nHe also almost got both of us killed on several occasions but that is a danger I knew I would face when partnering with such a villain.\n\nFor all of his flaws, he has also saved my life several times. For good or ill, we will see this through to the end, together.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129117,'We will not be able to hold this line for long.','',0,0,0,0,0,0,396,0,0,0,87767,0,26124),
(129118,'Already the vermin stir.','',0,0,0,0,0,0,396,0,0,0,87768,0,26124),
(129120,'Every demon we slay here dies their final death. Do not hold back.','',0,0,0,0,0,0,396,0,0,0,87769,0,26124),
(129121,'We won\'t be able to sustain another attack from one of those creatures. We must bolster our forces.','',0,0,0,0,0,0,396,0,0,0,86221,0,26124),
(129122,'Survivors! We will hold this point, you must find them before the Legion does.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(129123,'','|TInterface\\Icons\\inv_misc_horn_03:20|t%s |cFFFF0000|Hspell:237937|h[Empowers]|h|r $n!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129124,'','|TInterface\\Icons\\inv_misc_horn_03:20|t%s |cFFFF0000|Hspell:237937|h[Empowers]|h|r herself and one of her allies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129125,'','|TInterface\\Icons\\inv_misc_horn_03:20|t%s |cFFFF0000|Hspell:237937|h[Empowers]|h|r all of her council!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129130,'Remember... the one who hurries to conclusions may arrive first, but may not find the destination pleasant.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129131,'Do not let the behavior of others influence your ways. We must maintain our composure when faced with the unknown.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129132,'Do not let the behavior of others influence your own. We must maintain our composure when faced with the unknown.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129133,'The air speaks to us in many ways, $n. What do these times say to you?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129134,'The zeppelin to Thunder Bluff in central Kalimdor leaves from the western zeppelin tower atop the central plateau in Orgrimmar. Zeppelin master Zelli Hotnozzle will have more information for you there.','The zeppelin to Thunder Bluff in central Kalimdor leaves from the western zeppelin tower atop the central plateau in Orgrimmar. Zeppelin master Zelli Hotnozzle will have more information for you there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129135,'To get to The Undercity or Silvermoon City you should seek out Frezza on the eastern zeppelin tower atop the central plateau in Orgrimmar. He will have more information on when the zeppelin departs for Brill located in the Tirisfal Glades just north of The Undercity. There is a teleporter in entranceway to The Undercity that can take you to Silvermoon City.','To get to The Undercity or Silvermoon City you should seek out Frezza on the eastern zeppelin tower atop the central plateau in Orgrimmar. He will have more information on when the zeppelin departs for Brill located in the Tirisfal Glades just north of The Undercity. There is a teleporter in entranceway to The Undercity that can take you to Silvermoon City.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129136,'Seek out Snurk Bucksquick on the western zeppelin tower atop the central plateau in Ogrimmar. She is the zeppelin master for Stranglethorn Vale and will let you know more info on when the zeppelin will depart for our outpost of Grom\'gol in the southern Eastern Kingdoms.','Seek out Snurk Bucksquick on the western zeppelin tower atop the central plateau in Ogrimmar. She is the zeppelin master for Stranglethorn Vale and will let you know more info on when the zeppelin will depart for our outpost of Grom\'gol in the southern Eastern Kingdoms.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129137,'The mood on these streets darkens like the skies, yet hope can still bring light to us all.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129138,'For Borean Tundra in Norhtrend you will want to take the zeppelin The Mighty Wind. Seek out Greeb Ramrocket on western zeppelin tower for when it departs for Warsong Hold.','For Borean Tundra in Norhtrend you will want to take the zeppelin The Mighty Wind. Seek out Greeb Ramrocket on western zeppelin tower for when it departs for Warsong Hold.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129139,'Stormwind has always been my home. I know its shops and streets as I do the back of my hand.','',0,0,0,0,0,0,1,0,0,0,83219,0,26124),
(129140,'Yet even as I walk these familiar steps, I have never felt more lost.','',0,0,0,0,0,0,1,0,0,0,83220,0,26124),
(129141,'','Over here, $n! Any news? I haven\'t heard much, but some folks around here are acting quite out of sorts.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129142,'','Sorry to bother, $n, but have you any news? Guards run by every so often, but they offer little information.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129143,'','Wait! Wait! Any updates, $n? Quite a few of us are anxiously awaiting some sort of news.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129144,'There is a portal that leads to Hellfire Peninsula in Outland. It is located within the Cleft of Shadow, underneath Orgrimmar.','There is a portal that leads to Hellfire Peninsula in Outland. It is located within the Cleft of Shadow, underneath Orgrimmar.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129145,'Stop right there! Oh, is that you, $n? Damned looters have been in and out of here all day! Take a look around, but be quick about it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129146,'Our mages have opened a portal just inside the Cleft of Shadows to assist players getting to the Blasted Lands and on to Draenor.','Our mages have opened a portal just inside the Cleft of Shadows to assist players getting to the Blasted Lands and on to Draenor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129147,'Hands where I can see \'em! Gah! It\'s you again. I\'ve had to chase off so many miscreants lately, I don\'t know what to think anymore.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129148,'Freeze! Ahh! How many times is this gonna happen? First the guards are checkin\' around, now you... Well, the pickin\'s are slim, but have a look.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129149,'%s sheathes his weapon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129150,'The Kirin Tor have setup a portal in the Cleft of Shadows to assist players in getting to Dalaran above the Broken Isles.','The Kirin Tor have setup a portal in the Cleft of Shadows to assist players in getting to Dalaran above the Broken Isles.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129151,'Our allies in Pandaria have allowed us to create a portal to Honeydew Village in the Jade Forest. It is located in the middle of the Valley of Honor.','Our allies in Pandaria have allowed us to create a portal to Honeydew Village in the Jade Forest. It is located in the middle of the Valley of Honor.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129152,'Undercity or Silvermoon City in the Eastern Kingdoms','Undercity or Silvermoon City in the Eastern Kingdoms',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129153,'Borean Tundra in Northrend','Borean Tundra in Northrend',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129154,'Thunder Bluff in Mulgore','Thunder Bluff in Mulgore',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129155,'Stranglethorn Vale in the Eastern Kingdoms','Stranglethorn Vale in the Eastern Kingdoms',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129156,'Honeydew Village in Pandaria','Honeydew Village in Pandaria',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129157,'Dalaran above the Broken Isles','Dalaran above the Broken Isles',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(129158,'Areas opened up in the Cataclysm','Areas opened up in the Cataclysm',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129159,'Hellfire Peninsula in Outland','Hellfire Peninsula in Outland',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(129160,'Blasted Lands and the Portal to Draenor','Blasted Lands and the Portal to Draenor',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(129161,'Orgrimmar is the heart of the Horde, offering many forms of travel to the far reaches of Azeroth and beyond. \n\nWhere are you looking to travel?','Orgrimmar is the heart of the Horde, offering many forms of travel to the far reaches of Azeroth and beyond. \n\nWhere are you looking to travel?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129162,'I\'ve fished this spot dry, but with the war and all, it\'s just too dangerous to leave the city.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129163,'I have not returned to Lion\'s Rest since my father\'s memorial was moved here from the keep.','',0,0,0,0,0,0,1,0,0,0,83221,0,26124),
(129164,'The war has consumed all of my energy and attention. I have not had a moment to grieve.','',0,0,0,0,0,0,1,0,0,0,83222,0,26124),
(129165,'','Stick to what you know, Icks. No point in speculating. Now look alive, we have a guest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129166,'','Our patrons are quite fond of our goods. I\'m confident that if the time comes, they will not hesitate to--oh! Welcome to the shop, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129167,'','How is it out there, $n? With so many customers, it\'s been a challenge to fill all the orders. I hope all is well.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129168,'','Why do you like Nethershards so much?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129169,'It\'s a secret long guarded by ancient secret keepers for secret reasons.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129170,'','You don\'t really know what they\'re for, do ya?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129171,'Nope.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129172,'Meefi take you to cold Northrend. Her balloon leaves from left tower north of the Ruins of Lordaeron. You go to Vengeance Keep in Howling Fjord to fight Vrykul.','Meefi take you to cold Northrend. Her balloon leaves from left tower north of the Ruins of Lordaeron. You go to Vengeance Keep in Howling Fjord to fight Vrykul.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(129173,'Sparkly elves put in orby teleporter in ruins above Undercity. Touch it to take you to their home of Silvermoon City.','Sparkly elves put in orby teleporter in ruins above Undercity. Touch it to take you to their home of Silvermoon City.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(129174,'Magic men open portal to Hellfire Peninsula in Outland. Find it in their Mage Quarter.','Magic men open portal to Hellfire Peninsula in Outland. Find it in their Mage Quarter.',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(129175,'Stranglethorn Vale in the Eastern Kingdoms','Stranglethorn Vale in the Eastern Kingdoms',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(129176,'Hellfire Peninsula in Outland','Hellfire Peninsula in Outland',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(129177,'Howling Fjord in Northrend','Howling Fjord in Northrend',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(129178,'Orgrimmar in Kalimdor','Orgrimmar in Kalimdor',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(129179,'Silvermoon City in the Eastern Kingdoms','Silvermoon City in the Eastern Kingdoms',0,0,0,0,0,0,0,1,1,0,0,0,26124),
(129180,'','Are demons ticklish?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129181,'If you come near me, I\'ll bite your hand off.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129182,'','I\'ll take that as a yes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129183,'','It looks like fun floating all the time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129184,'Being eternally suspended in a prison set by a fatuous goblin? It\'s a blast...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129185,'','Hey, Iksy. When\'s your birthday? We should have a party!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129186,'I was spawned into this wretched existence eons ago within the deepest realms of the nether.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129187,'','So... Next week?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129188,'Sure. Next week.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129189,'Are you ever going to let me go?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129190,'','Sure! How do I do that?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129191,'Really?! Just hand me the Shard of Binding and the spell will be broken!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129192,'','Oh that glowy thing? I lost it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129193,'I hate you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129194,'Other Continents','Other Continents',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129195,'Fragile mortals. Bow before the might of the Burning Legion!','',0,0,0,0,0,0,396,0,0,48474,82726,0,26124),
(129196,'Your world crumbles around you, mortals. We cannot be stopped!','',0,0,0,0,0,0,396,0,0,48474,82727,0,26124),
(129197,'Hellfire Peninsula you say. That scorched wasteland in Outland. Well, our host of mages have created a portal to git ye there in the Hall of Mysteries located in the Mystic Ward.','Hellfire Peninsula you say. That scorched wasteland in Outland. Well, our host of mages have created a portal to git ye there in the Hall of Mysteries located in the Mystic Ward.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129198,'Weak flesh and brittle bones... You are no match for the Legion!','',0,0,0,0,0,0,396,0,0,48474,82728,0,26124),
(129199,'Feel your hearts wrench as the grasp of Sargeras tightens around your world!','',0,0,0,0,0,0,396,0,0,48474,82729,0,26124),
(129200,'You cannot escape! Our reach is endless!','',0,0,0,0,0,0,396,0,0,48474,82730,0,26124),
(129201,'The downfall of your world has begun!','',0,0,0,0,0,0,396,0,0,48474,82731,0,26124),
(129202,'Oh, Howling Fjord in Northred. You be in fer a bit of a ride. Seek out Gryth Thurden the Gryphon Master to secure a flight to Menethil Harbor. The Northspear sets sail from there for Valgarde.','Oh, Howling Fjord in Northred. You be in fer a bit of a ride. Seek out Gryth Thurden the Gryphon Master to secure a flight to Menethil Harbor. The Northspear sets sail from there for Valgarde.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129203,'','I suppose I should ensure the Fel Hammer is being properly repaired. See you there, Sslayer.',0,0,0,0,0,0,0,0,0,0,0,82581,26124),
(129204,'Time for revenge.','Time for revenge.',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(129205,'You have my thanks, and my mace.','You have my thanks, and my mace.',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(129206,'You came with Magatha? I knew she would free us.','You came with Magatha? I knew she would free us.',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(129207,'I\'m ready to fight.','I\'m ready to fight.',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(129208,'Ironforge is not the port town of Stormwind but we be offer\'n many a route to other continents.\n\nWhere ye be looking to travel?','Ironforge is not the port town of Stormwind but we be offer\'n many a route to other continents.\n\nWhere ye be looking to travel?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129209,'Hellfire Peninsula in Outland','Hellfire Peninsula in Outland',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129210,'Howling Fjord in Northrend','Howling Fjord in Northrend',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129211,'Stormwind and other Alliance Capitals','Stormwind and other Alliance Capitals',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129212,'We must keep our voices down and act natural, lest we be heard speaking together...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129213,'It seems Genn and Velen are speaking about me, but I can\'t quite make out the words...','',0,0,0,0,0,0,1,0,0,0,83238,0,26124),
(129214,'','With the Slayer to lead us, the Legion WILL fall! Let us take this moment to celebrate our victory!',1,0,0,0,0,0,0,0,0,0,0,82843,26124),
(129215,'','Now, sharpen your blades for the battles to come! The Illidari will prevail!',0,0,0,0,0,0,0,0,0,0,0,82844,26124),
(129216,'','My shackles are in place, hero! Lure a demon into the trap to banish the fiend!',0,0,0,0,0,0,0,0,0,0,0,82849,26124),
(129217,'Living on an island we rely on the sea and our magical prowess for getting around.\n\nWhere are you looking to travel?','Living on an island we rely on the sea and our magical prowess for getting around.\n\nWhere are you looking to travel?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129218,'To get to Stormwind you must first take the portal to Rut\'theran Village located in the center of the city. Once at the base of Teldrassil, head to the southern dock to catch your ship.','To get to Stormwind you must first take the portal to Rut\'theran Village located in the center of the city. Once at the base of Teldrassil, head to the southern dock to catch your ship.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129219,'The Stormwind ship leaves from the southern dock just over there.','The Stormwind ship leaves from the southern dock just over there.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129220,'The Exodar','The Exodar',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129221,'There ship for the Exodar departs from the western dock.','There ship for the Exodar departs from the western dock.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129222,'The Exodar, the ship and home of the Draenei. You will find a portal to the Exodar in the Temple of the Moon.','The Exodar, the ship and home of the Draenei. You will find a portal to the Exodar in the Temple of the Moon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129223,'To get to the barren land of Hellfire Peninsula in Outlands you can take a portal located in the Temple of the Moon.','To get to the barren land of Hellfire Peninsula in Outlands you can take a portal located in the Temple of the Moon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129224,'Other Continents','Other Continents',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129225,'Stormwind City in the Eastern Kingdoms','Stormwind City in the Eastern Kingdoms',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129226,'Hellfire Peninsula in Outland','Hellfire Peninsula in Outland',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129227,'The Command Center has been built! You can now gain access to things.','The Command Center has been built! You can now gain access to things.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129228,'The Command Center has been attacked!  We cant benefit from its glory any more!','The Command Center has been attacked!  We cant benefit from its glory any more!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129229,'The Command Center is ready for construction. Come donate your supplies.','The Command Center is ready for construction. Come donate your supplies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129230,'The Nether Disruptor has been built! You can now gain access to things.','The Nether Disruptor has been built! You can now gain access to things.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129231,'The Nether Disruptor has been attacked!  We cant benefit from its glory any more!','The Nether Disruptor has been attacked!  We cant benefit from its glory any more!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129232,'The Nether Disruptor is ready for construction. Come donate your supplies.','The Nether Disruptor is ready for construction. Come donate your supplies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129233,'Darnassus has a portal to Hellfire Peninsula located in the Temple of the Moon. Follow my directions to the portal up to Darnassus proper. Once there ask another sentinel if you need directions to the Temple.','Darnassus has a portal to Hellfire Peninsula located in the Temple of the Moon. Follow my directions to the portal up to Darnassus proper. Once there ask another sentinel if you need directions to the Temple.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129234,'A portal can be found in the cave beneath Sprit Rise that will take you to the wasteland of Hellfire Peninsula in Outland.','A portal can be found in the cave beneath Sprit Rise that will take you to the wasteland of Hellfire Peninsula in Outland.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129235,'Other Continents','Other Continents',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129236,'Located here in Mulgore we do not have many options for travel but I will help you as best I can. \n\nWhere are you looking to travel?','Located here in Mulgore we do not have many options for travel but I will help you as best I can. \n\nWhere are you looking to travel?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129237,'Hellfire Peninsula in Outland','Hellfire Peninsula in Outland',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129238,'Orgrimmar or the Eastern Kingdoms','Orgrimmar or the Eastern Kingdoms',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129239,'','The Fel Hammer\'s power reserves run low, Slayer. The fel energy around the Tomb can replenish our power cores and you should be able to ride those geysers up there.',0,0,0,0,0,0,0,0,0,0,0,82845,26124),
(129240,'','I will add these to our reserves. Thanks again, Slayer!',0,0,0,0,0,0,0,0,0,0,0,82846,26124),
(129241,'','Huh? Why would anything be wrong? Move along!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129242,'Greetings, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129243,'','Come in, $n! Leave your worries at the door. The guards have assured us all is well.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129244,'Nothing distracts a worried mind like a bit of toying around. Feel free to browse the shop!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129245,'Welcome, $n! We have one rule: keep your attitude positive! Don\'t let the all the commotion outside distract you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129246,'I know these times can be stressful, but don\'t be afraid to let your mind wander to a place of mystery and excitement!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129247,'','The skies grow dark, $n. I hope you\'re ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129248,'Quickly, bolster our ranks! We must push through!','',0,0,0,0,0,0,0,0,0,0,81983,0,26124),
(129249,'Leave none standing! If we fail here, Azeroth burns.','',0,0,0,0,0,0,0,0,0,0,81985,0,26124),
(129250,'The Legion has brought forth some new manner of fiend. Let us test whether it bleeds like all the rest.','',0,0,0,0,0,0,0,0,0,0,81987,0,26124),
(129251,'The echo of the Guardian Aegwynn appears, just as she did in the cathedral.','',0,0,0,0,0,0,1,0,0,0,81988,0,26124),
(129252,'','Are you prepared, $n? Some of your allies are not handling the situation so well.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129253,'I have some news for you, $n, everything you\'ve learned about your profession to this point was child\'s play. There was no challenge to it, no fashion, no style, no grace! $b$bNow, I am not merely a Fashion Historian, young $r, I am also a philosopher and--I don\'t mind admitting--something of a style icon in these parts.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129254,'','Preparation is key, $n. My goods can be yours--for a price.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129255,'','I sealed each level of this temple so that no invader could descend into its depths. I never anticipated that the Legion would find another way to breach its dark heart.',0,0,0,0,0,0,1,0,0,0,0,81989,26124),
(129256,'','My protective wards now bar your way. Each seal can only be opened with one of the Pillars of Creation. Be warned: the demons will stop at nothing to prevent your advance.',0,0,0,0,0,0,1,0,0,0,0,81990,26124),
(129257,'Do tell.','Do tell.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129258,'','$n, over here! If you hear any news, please let me know at once. It takes time to pack up my goods.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129259,'','Pastries, anyone? Nothing chases away doom and gloom like a fresh, tasty treat.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129260,'','So many people coming and going, in and out of the shops, the bank... What\'s going on, exactly? I\'m starting to get nervous.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129261,'','I can sense one of the Legion\'s masters working to reanimate the Avatar of Sargeras. Should Kil\'jaeden infuse that husk with the Dark Titan\'s power, I do not know whether any force on this world can stop it.',0,0,0,0,0,0,1,0,0,0,0,81993,26124),
(129262,'Greetings, $n. News of your exploits on the Broken Isles has been reaching us back home in Stormwind. You bring great honor to the Alliance.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129263,'Then we have no time to lose.','',0,0,0,0,0,0,5,0,0,0,81994,0,26124),
(129264,'Heroes, the paths are open. Use the Pillars of Creation to bypass Aegwynn\'s wards before the Legion claims the avatar.','',0,0,0,0,0,0,1,0,0,0,81995,0,26124),
(129265,'Rest, friend, and recover your strength. It will be needed for the trials ahead.','',0,0,0,0,0,0,0,0,0,0,81996,0,26124),
(129266,'An age has passed since I last walked these halls. I did what needed to be done, though at great cost.','',0,0,0,0,0,0,0,0,0,0,81997,0,26124),
(129267,'Be on your guard. I doubt the spirits trapped here will be friendly... or forgiving.','',0,0,0,0,0,0,0,0,0,0,81999,0,26124),
(129268,'Few understood my use of the naga to obtain the Eye of Sargeras, but it was a necessary tactic to secure the future of Azeroth. Let nothing stop you from doing what needs to be done!','',0,0,0,0,0,0,0,0,0,0,82002,0,26124),
(129269,'What news of the skies, $n?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129270,'Any word on what\'s happening out there?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129271,'How are people coping out there?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129272,'','This hammer forged ancient wonders and shaped the earth itself. Today it shatters the bonds of fate that seek to crush us all.',0,0,0,0,0,0,1,0,0,0,0,82006,26124),
(129273,'My patented Hammerbeard System of Style and Taste is a natural philosophy of flair. Impeccably researched, finely tuned, and well tested by yours truly, the HSST philosophy will be underlying apparatus of your education. $b$bThe dangers will be many, $n, but the rewards are beyond your current capacity to understand!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129274,'Uh huh.','Uh huh.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129275,'','My echo has guided you as far as it can, champions. In life, I shouldered too many burdens alone, and such hubris cost me dearly. Only by standing together can you overcome the darkness ahead. Fare well.',0,0,0,0,0,0,1,0,0,0,0,82007,26124),
(129276,'','From this stone flowed rivers and seas, the very lifeblood of Azeroth. Today it washes clean the darkness that scars our world.',0,0,0,0,0,0,1,0,0,0,0,82008,26124),
(129277,'','These tears of perfect beauty embody the dream of what our world could be. Today they purify your hearts for the battle to come.',0,0,0,0,0,0,1,0,0,0,0,82010,26124),
(129278,'Hey you! Ah, nevermind. We thought you were one of... you know... them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129279,'Hey, hey. Come right in! Take a load off for a second, then get back out there and make sure we\'re still gonna be here tomorrow.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129280,'Your hands--delicate but powerful, hardened by battle yet skilled--are the only hands that you should trust to create garments or armor worthy of a hero. $b$bMany of the legends of yore that you read of as a child were somewhat lackadaisical with spell and sword but how they dressed--oh how they dressed! This is why we speak of them still. $b$bFew know this and now you are one of them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129281,'You\'ve thought a lot about my hands.','You\'ve thought a lot about my hands.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129282,'I don\'t know what he was goin\' on about, but it didn\'t sound good. And he ain\'t even the first to do that this week!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129283,'','Champion! Our vessel requires power cores charged with the energy of fel geysers. These tattered wings could prove useful should you find yourself aloft. Do not hesitate to deploy them!',0,0,0,0,0,0,0,0,0,0,0,82847,26124),
(129284,'','The Pillars of Creation are in place. Return to the Cathedral and I will reveal the ancient secret this temple holds.',0,0,0,0,0,0,0,0,0,0,0,82011,26124),
(129285,'Nevermind that! Think instead of the wasted potential of what you have made thus far! $b$bIt isn\'t all your fault, though you\'ve certainly concentrated on deeds and functionality over style. Under the HSST system, you will remedy these failings and perhaps, at last, have a chance at actually becoming a legend. $b$bThe road is hard and full of peril.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129286,'','Most useful! Did you enjoy your taste of what it is like for a demon hunter to glide through the air, hero?',0,0,0,0,0,0,0,0,0,0,0,82848,26124),
(129287,'Are you wrapping this up soon?','Are you wrapping this up soon?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129288,'','The elves built this temple upon a site of ancient power, a vault I believed would safeguard the husk of my fallen foe. But with his disciple\'s aid, the Dark Titan threatens to return to this world stronger than before!',0,0,0,0,0,0,1,0,0,0,0,82013,26124),
(129289,'We will put a stop to Kil\'jaeden\'s plan, Aegwynn. This time we will not fail.','',0,0,0,0,0,0,1,0,0,0,82014,0,26124),
(129290,'Bold words, Khadgar, but victory requires more than courage alone. The armies of your Alliance and Horde had courage... before facing slaughter on the Broken Shore. The Deceiver will turn your fears and doubts against you.','',0,0,0,0,0,0,1,0,0,0,82016,0,26124),
(129291,'Archmage, the Felborne in the Weeping Terrace are holding manasabers in thrall. If we free them, these magical creatures may prove useful to us!','',0,0,0,0,0,0,0,0,0,0,82512,0,26124),
(129292,'','Our spies have spotted demons infesting this cave, Shadowblade. We\'ve planted the appropriate supplies. You know what to do!',0,0,0,0,0,0,0,0,0,0,0,82022,26124),
(129293,'','That explosion might\'ve been better than the last! Tethys would approve.',0,0,0,0,0,0,0,0,0,0,0,82023,26124),
(129294,'I\'m starting to wish I\'d chosen another profession.','I\'m starting to wish I\'d chosen another profession.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129295,'Kil\'jaeden hounded my people across the stars, but we are done running. He will pay for his atrocities against our world... and my son.','',0,0,0,0,0,0,1,0,0,0,82017,0,26124),
(129296,'The impatience of youth. $b$bA craftsperson is only as good as his or her materials and the--let\'s face it--garbage you\'ve been using thus far is a core reason why you look more like an accountant from Stormwind than a potential legend. $b$bThink ahead--when they make paintings of you, the cut and weight of your clothing or armor will echo through history. Is that not what you\'ve always wished for?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129297,'You\'re right, Illidan. Kil\'jaeden and the Legion have defeated each of us in the past. But if we stand together, Azeroth can yet be saved. I know it!','',0,0,0,0,0,0,1,0,0,0,82018,0,26124),
(129298,'','Our rogues could use a hand pulling off a mission in this cavern. These stun bombs should offer just the advantage they need!',0,0,0,0,0,0,0,0,0,0,0,82024,26124),
(129299,'','Smashing job! Or would \"stunning\" be more appropriate?',0,0,0,0,0,0,0,0,0,0,0,82025,26124),
(129300,'You lack appreciation for the gift I am giving you. The gift of a guiding philosophy is one that most go their whole lives without, $n. $b$b<sighs> Look, the point is that you will be judged throughout all time by what you wear and with my research and teaching, you will be able create legendary things that will set you apart from all others. Let us start.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129301,'','A trusted friend who lost her life defending this temple. Her rest has been defiled, and now she haunts these halls as a banshee. Release her from this torment!',0,0,0,0,0,0,0,0,0,0,0,82027,26124),
(129302,'Let us hope this is worth it.','Let us hope this is worth it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129303,'','The peace earned so long ago has been returned to her. You have my thanks.',0,0,0,0,0,0,0,0,0,0,0,82028,26124),
(129304,'','In life, Ryul was a formidable warrior. In death, he is an abomination that has been turned against us. Put him back in his grave.',0,0,0,0,0,0,0,0,0,0,0,82029,26124),
(129305,'','Well fought! That should ensure Ryul remains in his grave.',0,0,0,0,0,0,0,0,0,0,0,82030,26124),
(129306,'The presence of the Tidestone has drawn out the fanatical followers of Queen Azshara, including the elusive Warlord Darjah. An excellent opportunity to remove this threat.','',0,0,0,0,0,0,0,0,0,0,83590,0,26124),
(129307,'|TINTERFACE\\ICONS\\SPELL_SHADOW_LIFEDRAIN02.BLP:20|t %s begins to cast |cFFFF0404|Hspell:234423|h[Drain Life]|h|r!','|TINTERFACE\\ICONS\\SPELL_SHADOW_LIFEDRAIN02.BLP:20|t %s begins to cast |cFFFF0404|Hspell:234423|h[Drain Life]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129308,'The magic of the Felborne is not without a certain... finesse. Such a shame they abused it. They deserved their fate.','',0,0,0,0,0,0,0,0,0,0,82513,0,26124),
(129309,'Well done, heroes. The loss of Warlord Darjah weakens the naga\'s might within the tomb.','',0,0,0,0,0,0,0,0,0,0,83591,0,26124),
(129310,'The Legion\'s presence has stirred an ancient hydra known as Deepmaw. Destroy this creature before its wrath is unleashed upon our world.','',0,0,0,0,0,0,0,0,0,0,83592,0,26124),
(129311,'Legends tell of Deepmaw\'s unbridled ferocity. I\'m relieved we had our own legendary heroes to stop this threat!','',0,0,0,0,0,0,0,0,0,0,83593,0,26124),
(129312,'Battlelord! The naga and their skrog lackeys are back to their old tricks. They must be taught proper respect!','',0,0,0,0,0,0,0,0,0,0,83104,0,26124),
(129313,'The power of the tomb has drawn the attention of more than just the Legion. Kelpfist, a greedy and powerful sea giant, has emerged to claim the temple\'s relics for himself. He must be stopped!','',0,0,0,0,0,0,0,0,0,0,83594,0,26124),
(129314,'Gloriously executed as always, Battlelord. I expected no less of you.','',0,0,0,0,0,0,0,0,0,0,83105,0,26124),
(129315,'That greedy giant met the end he deserved. Well done!','',0,0,0,0,0,0,0,0,0,0,83595,0,26124),
(129316,'That foul stench in the air means the Dread Stalker roams nearby. This vicious pet of the Legion must be put down if we are to reclaim the temple.','',0,0,0,0,0,0,0,0,0,0,82040,0,26124),
(129317,'The Legion bred that monster with a taste for mortal flesh. A fine kill!','',0,0,0,0,0,0,0,0,0,0,82041,0,26124),
(129318,'The demon Dresanoth lurks among the naga. Destroy any foe who stands in your path and scour this filth from our world!','',0,0,0,0,0,0,0,0,0,0,82042,0,26124),
(129319,'Well done. We will show the Legion there is nowhere they can hide from annihilation.','',0,0,0,0,0,0,0,0,0,0,82043,0,26124),
(129320,'Erdu\'val, one of the Legion\'s most brutal warriors, boasts of his victories. Claim this braggart\'s wretched life!','',0,0,0,0,0,0,0,0,0,0,82044,0,26124),
(129321,'Nothing quiets the prattling of demons like finding one of their champions cold and dead. Well done!','',0,0,0,0,0,0,0,0,0,0,82045,0,26124),
(129322,'Given your thoughts on fashion and flair, please explain the drabness of your robes.','Given your thoughts on fashion and flair, please explain the drabness of your robes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129323,'','There\'s another demon plot to attack the Ancients! Show those creeps they can\'t mess with nature!',0,0,0,0,0,0,0,0,0,0,0,82159,26124),
(129324,'','Stupid demons. They\'ll never learn, will they? They can\'t beat us!',0,0,0,0,0,0,0,0,0,0,0,82160,26124),
(129325,'Fel corruption spreads across the beach. Receive my gift and cleanse the land.','',0,0,0,0,0,0,0,0,0,0,83063,0,26124),
(129326,'','Our forces have engaged the Legion on the ground floor. We must place the Aegis in the tower before our losses grow insurmountable.',0,0,0,0,0,0,0,0,0,0,0,82026,26124),
(129327,'That will slow the spread of the fel in this dark place.','',0,0,0,0,0,0,0,0,0,0,83064,0,26124),
(129328,'','The Legion is plotting attacks on our Ancients from this camp. Help us disrupt their plans!',0,0,0,0,0,0,0,0,0,0,0,82161,26124),
(129329,'','That should put a halt to their plans, at least for a while. Thanks for the help!',0,0,0,0,0,0,0,0,0,0,0,82162,26124),
(129330,'The \"historian\" part of my title requires a certain understated aura of scholarly authority. $b$bThat said, these drab robes are microfiber, moisture wicking, durable, laminated, spun-laced, tufted, antiseptic, crease resistant, shrinkage controlled bespoke robes. $b$bSo there. $b$bAlso note my skin. The moisturizing regime is vigorous.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129331,'','These markings appear fresh. Try to stay clear until we get this sorted out, $n. Wouldn\'t want you getting hurt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129332,'','Daumyr is waiting for you, Deathlord. Care to rain down some destruction?',0,0,0,0,0,0,0,0,0,0,0,82095,26124),
(129333,'Fel corruption spreads across the beach. The Conclave is in need of your aid.','',0,0,0,0,0,0,0,0,0,0,83065,0,26124),
(129334,'','Wondrous!',0,0,0,0,0,0,0,0,0,0,0,82092,26124),
(129335,'','Don\'t get too close, $n. This area was hit recently. It\'s not safe.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129336,'','The Council asked me to look into these fresh scorch marks. They appear quite recent.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129337,'We\'ve lost. The Legion broke our lines and pushed us out of the tomb. You\'re all that stands between them and the Aegis. They are coming!','',0,0,0,0,0,0,603,0,0,0,82031,0,26124),
(129338,'Let them come. Maiev and I will hold them on the stairs below.','',0,0,0,0,0,0,0,0,0,0,82033,0,26124),
(129339,'','Our death knights have unleashed an army of undead drakes to bombard this area. Care to join in on the fun?',0,0,0,0,0,0,0,0,0,0,0,82093,26124),
(129340,'','Forgive me if my glaive finds your heart, Illidan. With so many demons about, it\'s hard to distinguish you from the rest of this filth.',0,0,0,0,0,0,0,0,0,0,0,82034,26124),
(129341,'','Ah, the cold embrace of death. So liberating!',0,0,0,0,0,0,0,0,0,0,0,82094,26124),
(129342,'I will hold the skies. See to the Aegis!','',0,0,0,0,0,0,0,0,0,0,82035,0,26124),
(129343,'Alone at last.','',0,0,0,0,0,0,0,0,0,0,82036,0,26124),
(129344,'','Our allies claim to have outfitted their ship with devastating armaments. Put their weapons to the test!',0,0,0,0,0,0,0,0,0,0,0,82048,26124),
(129345,'','Such an inelegant weapon is no substitute for a sharpened glaive, but I suppose it was effective.',0,0,0,0,0,0,0,0,0,0,0,82049,26124),
(129346,'|TINTERFACE\\ICONS\\SPELL_SHADOW_CURSEOFMANNOROTH.BLP:20|t %s begins to cast |cFFFF0404|Hspell:236572|h[Annihilate]|h|r!','|TINTERFACE\\ICONS\\SPELL_SHADOW_LIFEDRAIN02.BLP:20|t %s begins to cast |cFFFF0404|Hspell:234423|h[Drain Life]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129347,'What is this?','',0,0,0,0,0,0,0,0,0,0,82037,0,26124),
(129348,'','Can it be? The Guardian!',0,0,0,0,0,0,0,0,0,0,0,82038,26124),
(129349,'','In ages past, this shield defended the young world soul against madness and corruption. Today, it serves those who fight for Azeroth.',0,0,0,0,0,0,1,0,0,0,0,82039,26124),
(129350,'','I am Aegwynn, Guardian of Tirisfal. I left behind this echo of my power as a safeguard in the event that the wards I put in place to protect the tomb failed. Indeed, I sense that the master of the Burning Legion now schemes to claim his prize.',0,0,0,0,0,0,1,0,0,0,0,82046,26124),
(129351,'','Yet there is still hope. By anchoring the Pillars of Creation in the halls below, you will restore my wards and push back against the invaders. Then you must venture into the depths of the tomb and use the Eye of Aman\'Thul to eradicate the Felstorm and sever the Legion\'s link to Azeroth.',0,0,0,0,0,0,1,0,0,0,0,82047,26124),
(129352,'|TInterface\\ICONS\\Spell_Arcane_PortalDarnassus.blp20|t %s begins to cast |cFFFF0404|Hspell:234676|h[Twisted Reflection]|h|r!','|TINTERFACE\\ICONS\\SPELL_SHADOW_LIFEDRAIN02.BLP:20|t %s begins to cast |cFFFF0404|Hspell:234423|h[Drain Life]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129353,'','But the Pillars alone cannot bring victory. Only a united army founded on strength and courage can conquer the Legion. When you and your allies are prepared for the final battle, my echo will return to aid you. The fate of Azeroth rests in your hands.',0,0,0,0,0,0,1,0,0,0,0,82050,26124),
(129354,'','Khadgar will want to hear of this.',0,0,0,0,0,0,0,0,0,0,0,82051,26124),
(129355,'It seems preparations are in order.','',0,0,0,0,0,0,0,0,0,0,82052,0,26124),
(129356,'The winds have blown in your favor this day, Farseer. I shall reconsider my allegiance to Thunderaan.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129357,'You\'ve impressed me with your vigor, Farseer, and I trust that your faith in Thunderaan is not misplaced. I shall grant my allegiance to his.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129358,'Hero, we\'ve gotten word that the Felskorn are readying another attack. Please foil their plans before they have a chance to act!','',0,0,0,0,0,0,0,0,0,0,82106,0,26124),
(129359,'Blessings upon you, my friend! The monks are in your debt.','',0,0,0,0,0,0,0,0,0,0,82107,0,26124),
(129360,'Grandmaster! We\'ve gotten word that the Felskorn are readying another attack. Please foil their plans before they have a chance to act!','',0,0,0,0,0,0,0,0,0,0,82108,0,26124),
(129361,'Well done, Grandmaster! The enemy has been kept at bay... for now.','',0,0,0,0,0,0,0,0,0,0,82109,0,26124),
(129362,'Other Continents','Other Continents',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129363,'There is a portal that leads to Hellfire Peninsula in Outland. It is located within the Sunfury Spire.','There is a portal that leads to Hellfire Peninsula in Outland. It is located within the Sunfury Spire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129364,'To get to Undercity and on to Orgrimmar or Kalimdor, you will need to use the Teleporter located within the Sunfury Spire.','To get to Undercity and on to Orgrimmar or Kalimdor, you will need to use the Teleporter located within the Sunfury Spire.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129365,'Hellfire Peninsula in Outland','Hellfire Peninsula in Outland',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(129366,'Undercity or Orgrimmar','Undercity or Orgrimmar',0,0,0,0,0,0,0,7,1,0,0,0,26124),
(129367,'What\'s going on? What aren\'t we being told?','What\'s going on? What aren\'t we being told?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129368,'What if something happens?','What if something happens?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129369,'We\'re just looking for answers.','We\'re just looking for answers.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129370,'Do you have any updates?','Do you have any updates?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129371,'We have long sought exclusion from others and so do not have many connections to other lands. As part of our pact with the Horde we do offer travel to the other cities and fronts.\n\nWhere are you looking to travel?','We have long sought exclusion from others and so do not have many connections to other lands. As part of our pact with the Horde we do offer travel to the other cities and fronts.\n\nWhere are you looking to travel?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129372,'What does it mean?','What does it mean?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129373,'Should we be worried?','Should we be worried?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129374,'What\'s being done about people\'s behavior? They\'re frightening the children.','What\'s being done about people\'s behavior? They\'re frightening the children.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129375,'We need answers! We\'re not sure what to expect.','We need answers! We\'re not sure what to expect.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129376,'Please remain calm. Answers will come soon.','Please remain calm. Answers will come soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129377,'The Council is aware of the situation. They ask that you remain calm until their assessment is complete.','The Council is aware of the situation. They ask that you remain calm until their assessment is complete.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129378,'We are newer to this world but have already started making connection with the major cities of the Alliance.\n\nWhere are you looking to travel?','We are newer to this world but have already started making connection with the major cities of the Alliance.\n\nWhere are you looking to travel?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129379,'We will continue to work closely with the Council until the situation is resolved.','We will continue to work closely with the Council until the situation is resolved.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129380,'We must remain calm until the Council concludes its investigation.','We must remain calm until the Council concludes its investigation.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129381,'If you see any unusual behavior, magical or otherwise, please do not hesitate to report it.','If you see any unusual behavior, magical or otherwise, please do not hesitate to report it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129382,'The Council asks that we remain calm until they have finished their assessment of the situation.','The Council asks that we remain calm until they have finished their assessment of the situation.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129383,'To get to Storwmind you will be traveling by sea. First go up to the surface and Azuremyst Isle. From there go down the right path to the Valaar\'s Berth. The Valaar will take you as far as Rut\'theran Village. A ship departs there for Stormwind and the rest of the Eastern Kingdoms. If you need help getting tot he surface I can give you directions to the entrance as well.','To get to Storwmind you will be traveling by sea. First go up to the surface and Azuremyst Isle. From there go down the right path to the Valaar\'s Berth. The Valaar will take you as far as Rut\'theran Village. A ship departs there for Stormwind and the rest of the Eastern Kingdoms. If you need help getting tot he surface I can give you directions to the entrance as well.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129384,'There is a portal to the Night Elf capital of Darnassus that is located in the Vault of Lights.','There is a portal to the Night Elf capital of Darnassus that is located in the Vault of Lights.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129385,'If you wish to venture to our homeland of Outland you can use the portal in the Vault of Lights to get to Hellfire Peninsula.','If you wish to venture to our homeland of Outland you can use the portal in the Vault of Lights to get to Hellfire Peninsula.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129386,'Darnassus','Darnassus',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129387,'Hellfire Peninsula in Outland','Hellfire Peninsula in Outland',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129388,'Stormwind or Ironforge in Eastern Kingdoms','Stormwind or Ironforge in Eastern Kingdoms',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129389,'Other Continents','Other Continents',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129390,'\"Fortitude can be found in the land beneath.\"','\"Fortitude can be found in the land beneath.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129391,'\"There is truth in everything.\"','\"There is truth in everything.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129392,'\"The wind is swift and dauntless.\"','\"The wind is swift and dauntless.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129393,'\"The power we wield is the burden of our enemies.\"','\"The power we wield is the burden of our enemies.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129394,'The shrine was corrupted by the Legion!','The shrine was corrupted by the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129395,'Outside to Azuremyst Isle','Outside to Azuremyst Isle',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129396,'Oh, you need help reaching the entrance of the Exodar. I forget that many newcomers are not intimately familiar with these hallowed halls. There is a ramp on the upper ring of the Seat of the Naaru that will lead you up to the surface.','Oh, you need help reaching the entrance of the Exodar. I forget that many newcomers are not intimately familiar with these hallowed halls. There is a ramp on the upper ring of the Seat of the Naaru that will lead you up to the surface.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129397,'','Here to help, $n? I haven\'t been able to diagnose it yet. Their symptoms are all over the place.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129398,'','If citizens continue exhibiting these symptoms, we\'ll need to start training additional help.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129399,'Bending Azeroth\'s elements to their will... the Legion has gone too far!','Bending Azeroth\'s elements to their will... the Legion has gone too far!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129400,'Without their power cores they have no control!','Without their power cores they have no control!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129401,'They will accomplish nothing but angering the elements!','They will accomplish nothing but angering the elements!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129402,'','Please remain calm. We\'ll assist each and every one of you, but we must ask for your patience.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129403,'','$n! They just keep coming! I\'ve never seen anything like this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129404,'','If it\'s too crowded, please step outside. We have additional stations set up and an assistant ready to help.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129405,'','We\'ve brought in additional help and we will get to you shortly. Please have patience.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129406,'','I don\'t know how much longer we can keep this up, $n. We\'re starting to run short on supplies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129407,'','We\'re running out of space for our guests. I don\'t know how much longer we can keep this up.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129408,'','Have you any news, $n? The symptoms continue to present, but there\'s absolutely no explanation for any of it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129409,'','Pretty soon we\'ll have to send people off site for help. I just don\'t think we have the resources here to maintain any semblance of order.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129410,'','I do hope this calms down. People have been arriving in a panic.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129411,'','I\'ve never seen anything like this before, $n. We\'ll keep at it. Make sure to send anyone presenting similar symptoms our way.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129412,'','Hello, $n.  Did you know the Royal Pond was once home to the largest and most beautiful fish in all of Azsuna?  Royalty would often gaze into the waters and watch the graceful movements, trying to forget their heavy burdens.\n\nNow... oh, something is wrong!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129413,'I... I don\'t feel well.','I... I don\'t feel well.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129414,'I feel it coming on again...','I feel it coming on again...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129415,'Please. You have to help us.','Please. You have to help us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129416,'This has to end. I can\'t take much more of this.','This has to end. I can\'t take much more of this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129417,'They say it\'s all in your head, but this... this is different. I swear!','They say it\'s all in your head, but this... this is different. I swear!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129418,'This is all too much to handle. I\'m not sure I\'m going to make it.','This is all too much to handle. I\'m not sure I\'m going to make it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129419,'I just want to feel like myself again.','I just want to feel like myself again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129420,'Is it normal to see stars?','Is it normal to see stars?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129421,'','$n, good to see you! Any updates about what\'s been happening?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129422,'','Welcome to the shop! Has the Council chimed in with their findings yet, $n?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129423,'','Good to see you again, $n. Come to chat? Looking for supplies? Perhaps just a bit of relief from... whatever\'s going on out there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129424,'','Our door is always open, $n. Hopefully the atmosphere in here is calmer than it is out there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129425,'','You\'re safe in here, $n. Ainderu has been adamant about watching the door ever since this all began, but I\'m not concerned.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129426,'I am ready to launch the assault.','I am ready to launch the assault.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129427,'We have come far together, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129428,'The final stage of the scenario is not yet complete. You\'ll destroy the legion ship and it will be awesome. Please send any feedback you have so far!','The final stage of the scenario is not yet complete. You\'ll destroy the legion ship and it will be awesome. Please send any feedback you have so far!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129429,'I\'m looking for answers. Have you heard anything new?','I\'m looking for answers. Have you heard anything new?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129430,'I need to know what\'s happening.','I need to know what\'s happening.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129431,'I\'m hoping for some answers.','I\'m hoping for some answers.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129432,'I haven\'t heard anything I didn\'t already know, $n. How about you?','I haven\'t heard anything I didn\'t already know, $n. How about you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129433,'What does it mean? I\'ve never seen anything like this before.','What does it mean? I\'ve never seen anything like this before.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129434,'I keep coming back hoping for an update, but the answer is always the same.','I keep coming back hoping for an update, but the answer is always the same.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129435,'Have you heard anything new today?','Have you heard anything new today?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129436,'I\'m trying to remain positive, but I really don\'t know what to expect.','I\'m trying to remain positive, but I really don\'t know what to expect.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129437,'','Hear the screams of the forlorn!',0,0,0,0,0,0,0,0,0,0,0,82217,26124),
(129438,'','Let their agony wash over you!',0,0,0,0,0,0,0,0,0,0,0,82221,26124),
(129439,'','Their torment will become your own!',0,0,0,0,0,0,0,0,0,0,0,82227,26124),
(129440,'','Life and death... interwoven!',0,0,0,0,0,0,0,0,0,0,0,82223,26124),
(129441,'','Ahhh, the ties that bind!',0,0,0,0,0,0,0,0,0,0,0,82211,26124),
(129442,'','Can you feel the clutch of doom?',0,0,0,0,0,0,0,0,0,0,0,82213,26124),
(129443,'The darkness shall claim you!','',0,0,0,0,0,0,0,0,0,0,82190,0,26124),
(129444,'Your souls will know despair!','',0,0,0,0,0,0,0,0,0,0,82191,0,26124),
(129445,'Emptiness... desolation...','',0,0,0,0,0,0,0,0,0,0,82192,0,26124),
(129446,'I am confident you can handle your end. Let us hope the others come through.','',0,0,0,0,0,0,1,0,0,0,83072,0,26124),
(129447,'Our fury is unleashed!','',0,0,0,0,0,0,0,0,0,0,82202,0,26124),
(129448,'You will be made one with us!','',0,0,0,0,0,0,0,0,0,0,82203,0,26124),
(129449,'We will feed upon your suffering!','',0,0,0,0,0,0,0,0,0,0,82204,0,26124),
(129450,'We will reap your souls!','',0,0,0,0,0,0,0,0,0,0,82193,0,26124),
(129451,'You are fuel for the engine!','',0,0,0,0,0,0,0,0,0,0,82194,0,26124),
(129452,'Your souls are but fodder!','',0,0,0,0,0,0,0,0,0,0,82195,0,26124),
(129453,'Another for the harvest!','',0,0,0,0,0,0,0,0,0,0,82205,0,26124),
(129454,'That one has joined us!','',0,0,0,0,0,0,0,0,0,0,82206,0,26124),
(129455,'More fuel!','',0,0,0,0,0,0,0,0,0,0,82207,0,26124),
(129456,'A rich harvest indeed!','',0,0,0,0,0,0,0,0,0,0,82208,0,26124),
(129457,'So many souls to serve us!','',0,0,0,0,0,0,0,0,0,0,82209,0,26124),
(129458,'The engine hungers for more!','',0,0,0,0,0,0,0,0,0,0,82210,0,26124),
(129459,'Such... bitter... harvest...','',0,0,0,0,0,0,0,0,0,0,82199,0,26124),
(129460,'The engine... falters...','',0,0,0,0,0,0,0,0,0,0,82200,0,26124),
(129461,'Our work... must continue...','',0,0,0,0,0,0,0,0,0,0,82201,0,26124),
(129462,'Hope dies with you!','',0,0,0,0,0,0,0,0,0,0,82196,0,26124),
(129463,'Your struggle has been for naught!','',0,0,0,0,0,0,0,0,0,0,82197,0,26124),
(129464,'Witness our victory!','',0,0,0,0,0,0,0,0,0,0,82198,0,26124),
(129465,'','As I serve, so shall you!',0,0,0,0,0,0,0,0,0,0,0,82212,26124),
(129466,'','Let this temple become your tomb!',0,0,0,0,0,0,0,0,0,0,0,82222,26124),
(129467,'','Do not resist the master\'s will!',0,0,0,0,0,0,0,0,0,0,0,82214,26124),
(129468,'','Your spirit is mine!',0,0,0,0,0,0,0,0,0,0,0,82228,26124),
(129469,'','I claim you for the master!',0,0,0,0,0,0,0,0,0,0,0,82218,26124),
(129470,'','Feed, engine! Feed!',0,0,0,0,0,0,0,0,0,0,0,82216,26124),
(129471,'','Elune holds no power here. This tomb belongs to the Legion!',0,0,0,0,0,0,0,0,0,0,0,82215,26124),
(129472,'','Mortal souls... so weak, so pathetic!',0,0,0,0,0,0,0,0,0,0,0,82224,26124),
(129473,'','The engine consumes all!',0,0,0,0,0,0,0,0,0,0,0,82226,26124),
(129474,'','I should have been stronger. Tell Tyrande... I am sorry.',0,0,0,0,0,0,0,0,0,0,0,82219,26124),
(129475,'','I tried to resist them, but failed. At least now I am free.',0,0,0,0,0,0,0,0,0,0,0,82220,26124),
(129476,'','Thank you, champions. I pray you cleanse the darkness that haunts this temple.',0,0,0,0,0,0,0,0,0,0,0,82225,26124),
(129477,'','Arille, please! Not in front of the guests. We don\'t know what it is yet and there\'s no point in speculation.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129478,'','Pull up a chair and take a load off. We know it can be hectic out there, so leave your worries at the door.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129479,'','Ah, $n! Maybe you can settle something for us... Arille and I were debating whether or not the Council had finished its assessment. Any word?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129480,'','Oh no! Spilled another drink. Can\'t seem to keep my hands steady with all that\'s been going on around here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129481,'','Hope everything is well with you, $n. As for me, well...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129482,'','Sometimes I wonder if we\'ll ever hear an answer as to why this is happening...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129483,'','I hope we receive an update soon. It\'s been a while since the last.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129484,'','All of this waiting to find out what\'s happening makes me a nervous wreck.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129485,'','Bring any news today? We haven\'t heard any updates in quite some time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129486,'','How are things outside, $n? People have come and gone throughout the day, but nobody seems to know much.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129487,'','Welcome! Lucian and I were just discussing recent events. Have any updates for us?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129488,'','What\'s going on out there? The noise level\'s grown increasingly louder. I only hope we hear some news soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129489,'','Watch your step, $n! Say, any word from the Council yet?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129490,'YOU\'RE PRESENCE HERE IS UNWELCOMED!! RETURN NOW FROM WHENCE YOU CAME!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129491,'%s becomes uneasy.','%s becomes uneasy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129492,'','My apologies if the pets are acting up. Something has them riled up.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129493,'','Have a care. The pets have been acting out of sorts. It would be wise to steer clear of the pens for a while.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129494,'','There, there, my magnificent beasts! Everything will return to normal soon... I hope.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129495,'','Try and keep the noise down. These beasts have been on edge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129496,'','What\'s the word on the street, $n?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129497,'','Any news, $n?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129498,'','We\'re getting pretty restless in here. Any news on what\'s happening?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129499,'Send me to the Throne of the Four Winds.','Send me to the Throne of the Four Winds.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129500,'','Hey, $n! Has the Council released any new information?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129501,'','The skies aren\'t the only thing full of magic these days! Relax and gander at some of our newest arrivals.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129502,'Our wings will blacken your sky!','',0,0,0,0,0,0,0,0,0,0,82708,0,26124),
(129503,'I shall use your corpse to feed my charges.','',0,0,0,0,0,0,0,0,0,0,82709,0,26124),
(129504,'Your skies belong to the Legion!','',0,0,0,0,0,0,0,0,0,0,82710,0,26124),
(129505,'','Our wings will blacken your sky!',0,0,0,0,0,0,0,0,0,0,0,82698,26124),
(129506,'','Your skies belong to the Legion!',0,0,0,0,0,0,0,0,0,0,0,82699,26124),
(129507,'','I shall use your corpse to feed my charges.',0,0,0,0,0,0,0,0,0,0,0,82700,26124),
(129508,'','If you think I\'m going to let the Doomstone out of my sight, you\'re horribly mistaken. Let\'s get on with it.',0,0,0,0,0,0,0,0,0,0,0,82632,26124),
(129509,'I shall use your corpse to feed my charges.','I shall use your corpse to feed my charges.',0,0,0,0,0,0,0,0,0,0,82709,82700,26124),
(129510,'Our wings will blacken your sky!','Our wings will blacken your sky!',0,0,0,0,0,0,0,0,0,0,82708,82698,26124),
(129511,'Your skies belong to the Legion!','Your skies belong to the Legion!',0,0,0,0,0,0,0,0,0,0,82710,82699,26124),
(129512,'','Trying to make Azeroth\'s earth fight itself? Foolish eredar!',0,0,0,0,0,0,0,0,0,0,0,82633,26124),
(129513,'','You know, if you only used the Doomstone, this would soon be over.',0,0,0,0,0,0,0,0,0,0,0,82634,26124),
(129514,'','What\'s the point of possessing such a mighty artifact if you fear to use it? The Doomstone would be much more useful in my hands.',0,0,0,0,0,0,0,0,0,0,0,82635,26124),
(129515,'','The demons have their fel fire, so they assume they can control Azeroth\'s as well. Oh, how wrong they are!',0,0,0,0,0,0,0,0,0,0,0,82636,26124),
(129516,'','The powers of water are generally restorative, the most passive and weak of elements. What did the Legion think to do with it?',0,0,0,0,0,0,0,0,0,0,0,82637,26124),
(129517,'','Consider the majesty of earth... so sturdy, protective, immutable. Yet when it but shudders, capable of such grand destruction.',0,0,0,0,0,0,0,0,0,0,0,82638,26124),
(129518,'','Can you hear the wind, child? It screams for help, for salvation from the Legion.',0,0,0,0,0,0,0,0,0,0,0,82639,26124),
(129519,'','Even if captured, my Grimtotem remain ready to fight. Your Earthen Ring, however... weak.',0,0,0,0,0,0,0,0,0,0,0,82640,26124),
(129520,'Before I tell you about legendary crafting, you must first be grounded in a philosophy of style and flair. This is non-negotiable! Are you ready to begin?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129521,'Let me hear your philosophy on style.','Let me hear your philosophy on style.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129522,'The end is upon us!','The end is upon us!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129523,'Gaze into the skies above! The truth reveals itself at last!','Gaze into the skies above! The truth reveals itself at last!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129524,'Shall we steal the secrets of the Nightborne tailors?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129525,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129526,'','I have complete faith in our leaders. We should not be led astray by the idle banter throughout the city. People cope in different ways.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129527,'','We should try to maintain a positive attitude. People have enough to deal with. We need to set an example for others.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129528,'','Walking through the streets earlier I could feel my ears growing tired from all the speculation. So much uncertainty around here lately.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129529,'','I wonder when the streets will calm down. The city\'s been abuzz ever since this whole thing began.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129530,'We should listen to our leaders, not the whispered conversations throughout the city. We will know more soon enough.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129531,'The Council will reveal information soon enough. I\'m sure of it.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(129532,'Please! Has anyone seen their parents? They really shouldn\'t be running around right now. It\'s not safe.','Please! Has anyone seen their parents? They really shouldn\'t be running around right now. It\'s not safe.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129533,'Where are your parents? You shouldn\'t be running around the city right now.','Where are your parents? You shouldn\'t be running around the city right now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129534,'It\'s not your fault, children, but you really shouldn\'t be out until we\'re certain it\'s safe.','It\'s not your fault, children, but you really shouldn\'t be out until we\'re certain it\'s safe.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129535,'The streets are no place for children in times like these. Someone will be by shortly to watch you until we\'re certain the city is safe.','The streets are no place for children in times like these. Someone will be by shortly to watch you until we\'re certain the city is safe.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129536,'There\'s no need to apologize. You\'ve done nothing wrong. We just need to make sure the streets are safe for the both of you.','There\'s no need to apologize. You\'ve done nothing wrong. We just need to make sure the streets are safe for the both of you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129537,'Our lines weaken with each moment. Slaughter their commander before we are overwhelmed!','',0,0,0,0,0,0,396,0,0,0,87795,0,26124),
(129538,'Finish... this...','',0,0,0,0,0,0,0,0,0,0,83445,0,26124),
(129539,'Fool! The Legion you know is but a whisper of our true glory.','',0,0,0,0,0,0,0,0,0,0,88033,0,26124),
(129540,'It matters not. It has already begun.','',0,0,0,0,0,0,0,0,0,0,88034,0,26124),
(129541,'You have doomed your world to bathe in the master\'s flame.','',0,0,0,0,0,0,0,0,0,0,88035,0,26124),
(129542,'The way is open. All you know, all you hold dear, will fall.','',0,0,0,0,0,0,0,0,0,0,88036,0,26124),
(129543,'Damnable mortals! You scurry through this tomb like vermin, dispatching my underlings and imagining yourselves the equals of the Legion. Heroes... champions... fools!','',0,0,0,0,0,0,1,0,0,0,83436,0,26124),
(129544,'Your puppet\'s strings are cut, Kil\'jaeden!','',0,0,0,0,0,0,0,0,0,0,83446,0,26124),
(129545,'No more shackles! Hold nothing back! Shatter their world and finish this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129546,'Good luck, Farseer $p. I have faith you will not fail me.','',0,0,0,0,0,0,0,0,0,0,82962,0,26124),
(129547,'End... you!','',0,0,0,0,0,0,0,0,0,0,83455,0,26124),
(129548,'Mortals... die!','',0,0,0,0,0,0,0,0,0,0,83456,0,26124),
(129549,'Burn!','',0,0,0,0,0,0,0,0,0,0,83449,0,26124),
(129550,'Chaos!','',0,0,0,0,0,0,0,0,0,0,83453,0,26124),
(129551,'Cursed!','',0,0,0,0,0,0,0,0,0,0,83451,0,26124),
(129552,'Sever!','',0,0,0,0,0,0,0,0,0,0,83447,0,26124),
(129553,'Keeper...','',0,0,0,0,0,0,0,0,0,0,83458,0,26124),
(129554,'','Corruption will be cleansed!',0,0,0,0,0,0,0,0,0,0,0,82735,26124),
(129555,'Dead!','',0,0,0,0,0,0,0,0,0,0,83441,0,26124),
(129556,'','That fiend ravages not only your people, but the land itself! If there was ever cause to use the Doomstone, that time is now!',0,0,0,0,0,0,0,0,0,0,0,82644,26124),
(129557,'Ended!','',0,0,0,0,0,0,0,0,0,0,83442,0,26124),
(129558,'By the Light\'s blessing, our path begins anew.','By the Light\'s blessing, our path begins anew.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129559,'Preparations are nearly complete. A great journey is upon us.','Preparations are nearly complete. A great journey is upon us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129560,'Unsettling as these events may seem, a vision of hope lingers beyond the darkness.','Unsettling as these events may seem, a vision of hope lingers beyond the darkness.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129561,'May we rise once more.','May we rise once more.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129562,'The repairs near completion.','The repairs near completion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129563,'...and in the darkness, the Light will prevail.','...and in the darkness, the Light will prevail.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129564,'Master... wins.','',0,0,0,0,0,0,0,0,0,0,83443,0,26124),
(129565,'Flesh... fails.','',0,0,0,0,0,0,0,0,0,0,83444,0,26124),
(129566,'It... ends...','',0,0,0,0,0,0,0,0,0,0,83434,0,26124),
(129567,'Still you fight us! Still you deny the inevitable! Your incessant resistance is maddening! Why will you not yield?','',0,0,0,0,0,0,1,0,0,0,83565,0,26124),
(129568,'Have your countless defeats taught you nothing, Deceiver?','',0,0,0,0,0,0,1,0,0,0,83566,0,26124),
(129569,'The vision Sargeras showed you was a lie, Kil\'jaeden. Surrender! Let it end!','',0,0,0,0,0,0,1,0,0,0,83567,0,26124),
(129570,'I have ripped the flame from your world. It now bends to my command!','',0,0,0,0,0,0,0,0,0,0,82685,0,26124),
(129571,'Your power is too great. You cannot control it!','',0,0,0,0,0,0,0,0,0,0,82686,0,26124),
(129572,'','Such power... such chaos!',0,0,0,0,0,0,11,0,0,0,0,82641,26124),
(129573,'','Pull yourself together, child! What is wrong with you?',0,0,0,0,0,0,0,0,0,0,0,82642,26124),
(129574,'Let... it... end...','',0,0,0,0,0,0,1,0,0,0,83568,0,26124),
(129575,'','That\'s it! Give in to the power!',0,0,0,0,0,0,0,0,0,0,0,82643,26124),
(129576,'Never! Our crusade will never yield! Savor your shallow victory. We will return again and again, however long it takes, until at last we break you!','',0,0,0,0,0,0,1,0,0,0,83569,0,26124),
(129577,'The portal is closing! We can seal the Legion\'s gateway and end this invasion.','',0,0,0,0,0,0,5,0,0,0,83570,0,26124),
(129578,'Be on your guard, champion. The Legion is skilled at deception.','',0,0,0,0,0,0,396,0,0,0,86178,0,26124),
(129579,'We may well be walking into a trap.','',0,0,0,0,0,0,396,0,0,0,86595,0,26124),
(129580,'','Listen--we\'re sure our goods are \"safe\" here, but why take any chances?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129581,'','What\'s it to ya?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129582,'','Ain\'t ya ever seen someone protectin\' their assets before? Keep movin\'!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129583,'','Hold still! We don\'t want none of our loot spillin\' over, do we?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129584,'','What\'s it take to get a helpin\' hand \'round here? We was hopin\' to have our stuff back home and safe before... well, y\'know.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129585,'','End of the world? Pfft! I\'m tryin\' to get our scratch but these guys are movin\' like snails!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129586,'','I sure hope our stash back home is end-of-the-world proof.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129587,'Please remain calm and maintain an orderly line. A banker will assist you as soon as a spot becomes available.','Please remain calm and maintain an orderly line. A banker will assist you as soon as a spot becomes available.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129588,'Due to the recent influx of patrons, we must remember to maintain a calm, orderly demeanor.','Due to the recent influx of patrons, we must remember to maintain a calm, orderly demeanor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129589,'If you notice any suspicious activity or unusual behavior, please do not hesitate to inform us.','If you notice any suspicious activity or unusual behavior, please do not hesitate to inform us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129590,'We are here on your behalf. There is no need for panic. Please remember to maintain orderly conduct at all times.','We are here on your behalf. There is no need for panic. Please remember to maintain orderly conduct at all times.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129591,'We ask you to remain patient and calm until further information becomes available.','We ask you to remain patient and calm until further information becomes available.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129592,'This is no longer the Argus I remember.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129593,'I am ready to search for survivors.','I am ready to search for survivors.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129594,'Prepare yourself, champion. We are surrounded.','',0,0,0,0,0,0,396,0,0,0,86597,0,26124),
(129595,'I will fight by your side.','I will fight by your side.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129596,'Ready to ride with you, Highlord!','Ready to ride with you, Highlord!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129597,'It will be an honor to ride alongside you, Highlord.','It will be an honor to ride alongside you, Highlord.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129598,'Riding into battle with you shall be glorious, Highlord.','Riding into battle with you shall be glorious, Highlord.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129599,'Let us mount up, Highlord and rescue our missing allies.','Let us mount up, Highlord and rescue our missing allies.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129600,'You hunted your own people, chasing us across the stars. Never again!','',0,0,0,0,0,0,0,0,0,0,83662,0,26124),
(129601,'It was you who lacked vision! Who refused to see the truth of the Legion\'s inevitable victory!','',0,0,0,0,0,0,0,0,0,0,83663,0,26124),
(129602,'You lost faith in the Light. Together, we could have resisted Sargeras and saved our world!','',0,0,0,0,0,0,0,0,0,0,83664,0,26124),
(129603,'Did the Light save your son? Was it faith that shone in Rakeesh\'s eyes as they closed for the final time? Or was it hatred for the father who abandoned him?','',0,0,0,0,0,0,0,0,0,0,83665,0,26124),
(129604,'GRRAAAHHHHH!','',0,0,0,0,0,0,0,0,0,0,83666,0,26124),
(129605,'And now your impotent fury has drawn your allies to their doom. Watch as my infinite army slaughters them all!','',0,0,0,0,0,0,0,0,0,0,83667,0,26124),
(129606,'No! You will not divide us, Deceiver. I will fight by their side, and they by mine. Together, we will end your crusade!','',0,0,0,0,0,0,0,0,0,0,83668,0,26124),
(129611,'You were fools to follow me here!','',0,0,0,0,0,0,0,0,0,0,83606,0,26124),
(129612,'Fall before your master!','',0,0,0,0,0,0,0,0,0,0,83621,0,26124),
(129613,'Who will save you now?','',0,0,0,0,0,0,0,0,0,0,83622,0,26124),
(129614,'Eredar! Show Velen\'s mongrels the folly of resisting us!','',0,0,0,0,0,0,0,0,0,0,83631,0,26124),
(129615,'Felborne! Show them the gravity of their defiance!','',0,0,0,0,0,0,0,0,0,0,83632,0,26124),
(129616,'Incinerate these weaklings, warlocks!','',0,0,0,0,0,0,0,0,0,0,83633,0,26124),
(129617,'Turn your gaze upon them, Felsworn!','',0,0,0,0,0,0,0,0,0,0,83634,0,26124),
(129618,'An inevitable fate!','',0,0,0,0,0,0,0,0,0,0,83615,0,26124),
(129619,'Fall, hero!','',0,0,0,0,0,0,0,0,0,0,83616,0,26124),
(129620,'The Light shall restore you!','',0,0,0,0,0,0,0,0,0,0,82599,0,26124),
(129621,'It is not your time!','',0,0,0,0,0,0,0,0,0,0,83669,0,26124),
(129622,'Do not lose faith!','',0,0,0,0,0,0,0,0,0,0,83670,0,26124),
(129623,'Let us judge your battle prowess! Target a foe!','',0,0,0,0,0,0,0,0,0,0,83612,0,26124),
(129624,'Hero! Pick your target well!','',0,0,0,0,0,0,0,0,0,0,83613,0,26124),
(129625,'Demon filth!','',0,0,0,0,0,0,0,0,0,0,83609,0,26124),
(129626,'Fall beneath my blades!','',0,0,0,0,0,0,0,0,0,0,83610,0,26124),
(129627,'Insolent mortals! Your fate was sealed the moment you stepped into the Nether!','',0,0,0,0,0,0,0,0,0,0,83617,0,26124),
(129628,'A meaningless struggle! Azeroth shall fall to the Burning Legion!','',0,0,0,0,0,0,0,0,0,0,83618,0,26124),
(129629,'Still you resist! Then let me repay your arrogance!','',0,0,0,0,0,0,0,0,0,0,83629,0,26124),
(129630,'Burn! Burn and die!','',0,0,0,0,0,0,0,0,0,0,83627,0,26124),
(129631,'A vessel for my fury!','',0,0,0,0,0,0,0,0,0,0,83623,0,26124),
(129632,'You will all burn!','',0,0,0,0,0,0,0,0,0,0,83625,0,26124),
(129633,'Ixallon! Come forth and break them!','',0,0,0,0,0,0,0,0,0,0,83630,0,26124),
(129634,'It is a simple matter to show courage against my minions. Can you face the shadows within your own souls as bravely?','',0,0,0,0,0,0,0,0,0,0,83648,0,26124),
(129635,'What is this? Even when your own doubts and fears are made manifest, you will not yield?','',0,0,0,0,0,0,0,0,0,0,83649,0,26124),
(129636,'Confront your own darkness!','',0,0,0,0,0,0,0,0,0,0,83635,0,26124),
(129637,'I sense the corruption inside you.','',0,0,0,0,0,0,0,0,0,0,83636,0,26124),
(129638,'You cannot resist your own nature.','',0,0,0,0,0,0,0,0,0,0,83637,0,26124),
(129639,'Your defiance is futile! My strength comes from an infinite army!','',0,0,0,0,0,0,0,0,0,0,83640,0,26124),
(129640,'Kil\'jaeden will draw power from those vessels!','',0,0,0,0,0,0,0,0,0,0,83641,0,26124),
(129641,'Somehow you survived! No matter. Look upon our wonders, you mortals, and despair! Behold the world that shall be your tomb!','',0,0,0,0,0,0,0,0,0,0,83660,0,26124),
(129642,'Your reality is sundered!','',0,0,0,0,0,0,0,0,0,0,83657,0,26124),
(129643,'Chaos will consume you!','',0,0,0,0,0,0,0,0,0,0,83655,0,26124),
(129644,'The fel fuels me!','',0,0,0,0,0,0,0,0,0,0,83653,0,26124),
(129645,'I will feed upon your ashes!','',0,0,0,0,0,0,0,0,0,0,83654,0,26124),
(129646,'Deceiver! We have come to end your invasion of Azeroth. Your master\'s crusade dies here!','',0,0,0,0,0,0,0,0,0,0,83437,0,26124),
(129647,'Greetings, Farseer. Are you feeling well again?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129648,'She lives? No! I will never let her bind me again!','',0,0,0,0,0,0,0,0,0,0,82615,0,26124),
(129649,'You have witnessed the destruction the Doomstone can wreak firsthand. You are a trusted warden of Azeroth, but even in your hands the power caused chaos and panic amongst your people. Imagine it in the control of someone with ill intent...$b$bWe cannot let that happen.$b$bWe discussed what to do with this artifact at length while we waited for you to awaken. We considered giving it a new home in one of the elemental planes, but each one provided its own danger.$b$bThere is no safer place for it than here, in the heart of Azeroth. It shall be kept under the protection of the Earthen Ring, never to be used again. Place it on this pedestal, where it shall never move from again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129650,'Ah... merely a lingering echo of her power. Nothing to be concerned about, child.','',0,0,0,0,0,0,0,0,0,0,82616,0,26124),
(129651,'You called for me, Neptulon?','You called for me, Neptulon?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129652,'Even her echo prattles on endlessly! Do you see now what I had to deal with?','',0,0,0,0,0,0,0,0,0,0,82617,0,26124),
(129653,'Bah! I am every bit as mighty as the Tidestone, or any of these other musty relics!','',0,0,0,0,0,0,0,0,0,0,82618,0,26124),
(129654,'A dream of perfect beauty... ridiculous! This world knows only pain, child.','',0,0,0,0,0,0,0,0,0,0,82619,0,26124),
(129655,'','Come back later. I might have another job for you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129656,'Do not trust her ramblings! I am the only true power here!','',0,0,0,0,0,0,0,0,0,0,82620,0,26124),
(129657,'You are better off without her!','',0,0,0,0,0,0,0,0,0,0,82621,0,26124),
(129658,'Talkin\' to a world soul ain\'t like chattin\' with a mortal. Might be why she needed someone ta become her Speaker.','',0,0,0,0,0,0,0,0,0,0,85232,0,26124),
(129659,'She\'s haunted by the Legion... and the Old Gods. But there be somethin\' more... a greater darkness...','',0,0,0,0,0,0,0,0,0,0,85233,0,26124),
(129663,'','Oh don\'t worry, Farseer... we will keep an eye on the Doomstone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129664,'Stay close. We are being watched.','',0,0,0,0,0,0,396,0,0,0,86596,0,26124),
(129665,'That was not a request. <Strangulate him.>','That was not a request. <Strangulate him.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129666,'This hovel feels... familiar.','',0,0,0,0,0,0,396,0,0,0,86179,0,26124),
(129667,'This is not our final day. We stand together.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129668,'Looks like we\'ve got some preparin\' ta do, champion! Ye best tell Khadgar what we\'ve learned. Good luck!','',0,0,0,0,0,0,0,0,0,0,85234,0,26124),
(129669,'What does it mean? Is this the end?','What does it mean? Is this the end?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129670,'What if something attacks the city? What are we supposed to do then?','What if something attacks the city? What are we supposed to do then?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129671,'Show yourselves!','',0,0,0,0,0,0,396,0,4,0,86181,0,26124),
(129672,'Velen. At long last, you return to the home you abandoned.','',0,0,0,0,0,0,396,0,4,0,86182,0,26124),
(129673,'You turned your back on your people, Prophet. Your world. Such betrayal should be answered with death.','',0,0,0,0,0,0,397,0,4,0,86185,0,26124),
(129675,'The skies are darker than ever before! Is there no hope?','The skies are darker than ever before! Is there no hope?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129676,'Is this it? Is this what it\'s all been about? There\'s so many things I wanted to do...','Is this it? Is this what it\'s all been about? There\'s so many things I wanted to do...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129677,'I don\'t know what to do anymore!','I don\'t know what to do anymore!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129678,'That voice... Hatuun? How did you survive this hell for so long?','',0,0,0,0,0,0,5,0,4,0,86183,0,26124),
(129679,'We changed, just as Argus did. We endured. What choice did we have?','',0,0,0,0,0,0,397,0,4,0,86184,0,26124),
(129680,'This can\'t be end! It just can\'t!','This can\'t be end! It just can\'t!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129681,'Enough!','',0,0,0,0,0,0,1,0,4,0,86511,0,26124),
(129682,'Is there anything we can do?','Is there anything we can do?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129683,'Stay your weapons! The Prophet and his ally are not our foes.','',0,0,0,0,0,0,1,0,4,0,86187,0,26124),
(129684,'What do I tell my children?','What do I tell my children?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129685,'High Exarch Turalyon... we meet at last.','',0,0,0,0,0,0,1,0,4,0,86189,0,26124),
(129686,'<Speaking gibberish.>','<Speaking gibberish.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129687,'<Unintelligible.>','<Unintelligible.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129688,'<Shaking uncontrollably.>','<Shaking uncontrollably.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129689,'...in the darkness.','...in the darkness.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129690,'The end...','The end...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129691,'I have no wish to fight you, Hatuun. But I cannot allow your bitterness to impede our war against the Legion.','',0,0,0,0,0,0,1,0,4,0,86186,0,26124),
(129692,'We must stand together, all of us, if we are to have any chance of defeating the Legion.','',0,0,0,0,0,0,1,0,4,0,86188,0,26124),
(129693,'It has been eons since I have laid eyes on this place. So many memories...$b$b\n<Velen\'s brows knit in pensive thought.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129694,'Shall we continue?','Shall we continue?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129695,'','Those insolent eredar still believe they can bend Azeroth\'s earth to their will? Punish them!',0,0,0,0,0,0,0,0,0,0,0,82850,26124),
(129696,'','And so they return to the earth.',0,0,0,0,0,0,0,0,0,0,0,82851,26124),
(129697,'','Thank you, stranger! Those imps came out of nowhere! I don\'t have much left, but you deserve a reward. Look through our supplies and take anything you need.',2,0,0,0,0,0,2,0,0,0,0,0,26124),
(129698,'','My dear Corian... what will I do without you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129699,'Champion, the very land is rotting beneath our feet. Manifestations of decay proliferate at every turn. They must be eradicated!','',0,0,0,0,0,0,0,0,0,0,83676,0,26124),
(129701,'I can feel the poison leaving my veins. Thank you!','I can feel the poison leaving my veins. Thank you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129702,'Finally... I can breathe again.','Finally... I can breathe again.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129703,'S...s...spiders....','S...s...spiders....',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129704,'|TInterface\\Icons\\inv_egg_01:20|tA group of Incubated Eggs are |cFFFF0404|Hspell:240319|h[Hatching]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129705,'','My children will feast on the corpses of your allies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129706,'','The Legion endures...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129707,'%s has summoned demonic portals!','%s has summoned demonic portals!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129708,'%s has extended the duration of the demonic portals!','%s has extended the duration of the demonic portals!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129709,'%s has empowered the demonic portals!','%s has empowered the demonic portals!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129710,'%s has summoned a demonic lieutenant!','%s has summoned a demonic lieutenant!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129711,'Grevious wounds... I must recover...','Grevious wounds... I must recover...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129712,'Unggh...','Unggh...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129713,'I need to recover... Go on without me!','I need to recover... Go on without me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129714,'Hero! I had a slight mishap while flying over this area. I dropped some special coins I was going to give to... uh, nevermind. If you happen to come across them, their return would be most appreciated!','',0,0,0,0,0,0,0,0,0,0,83094,0,26124),
(129715,'You found them? What a relief! I was scrambling to find a replacement gift...','',0,0,0,0,0,0,0,0,0,0,83095,0,26124),
(129716,'I\'m just going to hide back here and wait for all of this to blow over.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129717,'','This should be enough! Now let\'s see... Kataract? Katharsis? How do you even say that?',0,0,0,0,0,0,0,0,0,0,0,83155,26124),
(129718,'So this is where our forces landed on the Broken Shore.','',0,0,0,0,0,0,1,0,0,0,83234,0,26124),
(129719,'This land is scarred and desolate, a terrible place to meet one\'s end.','',0,0,0,0,0,0,1,0,0,0,83235,0,26124),
(129720,'Come, let us press forward.','',0,0,0,0,0,0,1,0,0,0,83236,0,26124),
(129721,'This land is far worse than I had imagined.','',0,0,0,0,0,0,1,0,0,0,83237,0,26124),
(129722,'My father sought to shield me from the war, insisting I stay behind because a Wrynn must always rule in Stormwind. But I saw the truth in his eyes... his fear of losing me.','',0,0,0,0,0,0,1,0,0,0,83226,0,26124),
(129723,'When my mother died, I was all he had left of her.','',0,0,0,0,0,0,1,0,0,0,83227,0,26124),
(129724,'Time and time again, I have watched from afar as the heroes of Stormwind fought and died to preserve peace on Azeroth.','',0,0,0,0,0,0,1,0,0,0,83228,0,26124),
(129725,'My father was not the first King of Stormwind to die fighting the Burning Legion.','',0,0,0,0,0,0,1,0,0,0,83229,0,26124),
(129726,'My great-grandfather, King Barathen, and my grandfather, King Llane, also paid the ultimate sacrifice.','',0,0,0,0,0,0,1,0,0,0,83230,0,26124),
(129727,'The kings of my family have always fought shoulder-to-shield with their soldiers for the freedom of Stormwind.','',0,0,0,0,0,0,1,0,0,0,83231,0,26124),
(129728,'I have lived my life sheltered by the blood of heroes like Tirion and Bolvar... heroes like my father.','',0,0,0,0,0,0,1,0,0,0,83232,0,26124),
(129729,'The time has come for me to do the same. Take me to the place where my father died. I must see it for myself.','',0,0,0,0,0,0,1,0,0,0,83233,0,26124),
(129730,'I\'ll ready a ship at once!','',0,0,0,0,0,0,1,0,0,0,83257,0,26124),
(129731,'The Broken Shore is no place to journey alone. We must find Anduin before it\'s too late!','',0,0,0,0,0,0,1,0,0,0,83291,0,26124),
(129732,'Slay the demons and lay waste to their fortifications!','',0,0,0,0,0,0,0,0,0,0,83293,0,26124),
(129733,'Well done. The demons will not soon recover from such devestation.','',0,0,0,0,0,0,0,0,0,0,83294,0,26124),
(129734,'Yes! Let them come! Their bodies will fuel the flames of their burning world!','',0,0,0,0,0,0,0,0,0,0,81821,0,26124),
(129739,'','Defilers! They must be purged from Elune\'s sacred temple!',0,0,0,0,0,0,0,0,0,0,0,83171,26124),
(129740,'','Sisters! On your guard!',0,0,0,0,0,0,0,0,0,0,0,83158,26124),
(129741,'','My arrows are always ready, Kasparian.',0,0,0,0,0,0,0,0,0,0,0,83189,26124),
(129742,'','I claim first blood, sisters!',0,0,0,0,0,0,0,0,0,0,0,83159,26124),
(129743,'','Goddess guide your hand!',0,0,0,0,0,0,0,0,0,0,0,83172,26124),
(129744,'','You are ever impetuous, Kasparian.',0,0,0,0,0,0,0,0,0,0,0,83190,26124),
(129745,'','Your hunt is ended!',0,0,0,0,0,0,0,0,0,0,0,83160,26124),
(129746,'','A bit slow on that kill, sister!',0,0,0,0,0,0,0,0,0,0,0,83191,26124),
(129747,'','The goddess is pleased, sister!',0,0,0,0,0,0,0,0,0,0,0,83173,26124),
(129748,'','My quarry falls!',0,0,0,0,0,0,0,0,0,0,0,83192,26124),
(129749,'','A worthy kill, sister!',0,0,0,0,0,0,0,0,0,0,0,83161,26124),
(129750,'','Your bow is blessed, sister!',0,0,0,0,0,0,0,0,0,0,0,83174,26124),
(129751,'','You should have believed!',0,0,0,0,0,0,0,0,0,0,0,83175,26124),
(129752,'','You serve the goddess well, sister!',0,0,0,0,0,0,0,0,0,0,0,83162,26124),
(129753,'','Inefficient... but effective.',0,0,0,0,0,0,0,0,0,0,0,83193,26124),
(129754,'','Mother Moon has granted us victory!',0,0,0,0,0,0,0,0,0,0,0,83176,26124),
(129755,'','The temple is secure. Well fought, sisters!',0,0,0,0,0,0,0,0,0,0,0,83163,26124),
(129756,'','Next time, I get to strike first!',0,0,0,0,0,0,0,0,0,0,0,83194,26124),
(129757,'','We failed... the goddess...',0,0,0,0,0,0,0,0,0,0,0,83177,26124),
(129758,'','No! I... should have... won...',0,0,0,0,0,0,0,0,0,0,0,83195,26124),
(129759,'','Elune... forgive us...',0,0,0,0,0,0,0,0,0,0,0,83164,26124),
(129760,'','No more dawdling, Kasparian! Victory shall be mine!',0,0,0,0,0,0,0,0,0,0,0,83196,26124),
(129761,'','I will dismiss these heretics, Yathae!',0,0,0,0,0,0,0,0,0,0,0,83178,26124),
(129762,'','I relieve you, sister. Time for my glaive to sing!',0,0,0,0,0,0,0,0,0,0,0,83165,26124),
(129763,'','Elune\'s light reaches its zenith!',0,0,0,0,0,0,0,0,0,0,0,83179,26124),
(129764,'','Retribution rains down!',0,0,0,0,0,0,0,0,0,0,0,83197,26124),
(129765,'','My mark is upon you!',0,0,0,0,0,0,0,0,0,0,0,83198,26124),
(129766,'','You are in my sights!',0,0,0,0,0,0,0,0,0,0,0,83199,26124),
(129767,'','I never miss!',0,0,0,0,0,0,0,0,0,0,0,83200,26124),
(129768,'','Let your talons taste their flesh, my pet!',0,0,0,0,0,0,0,0,0,0,0,83201,26124),
(129769,'','Goddess, burn the faithless!',0,0,0,0,0,0,0,0,0,0,0,83180,26124),
(129770,'','Behold her glory!',0,0,0,0,0,0,0,0,0,0,0,83181,26124),
(129771,'','Pay the price for heresy!',0,0,0,0,0,0,0,0,0,0,0,83182,26124),
(129772,'','Mother Moon, reveal their sins!',0,0,0,0,0,0,0,0,0,0,0,83183,26124),
(129773,'','Confess! Repent!',0,0,0,0,0,0,0,0,0,0,0,83184,26124),
(129774,'','You are unworthy!',0,0,0,0,0,0,0,0,0,0,0,83185,26124),
(129775,'','Right on target!',0,0,0,0,0,0,0,0,0,0,0,83166,26124),
(129776,'','You are in my way!',0,0,0,0,0,0,0,0,0,0,0,83167,26124),
(129777,'','The keenest cut!',0,0,0,0,0,0,0,0,0,0,0,83168,26124),
(129778,'','The Night Warrior guides your hand, sister!',0,0,0,0,0,0,0,0,0,0,0,83186,26124),
(129779,'','You waste too much time. Destroy them!',0,0,0,0,0,0,0,0,0,0,0,83202,26124),
(129780,'','Most impressive aim, sister!',0,0,0,0,0,0,0,0,0,0,0,83169,26124),
(129781,'','Goddess bless your arrows!',0,0,0,0,0,0,0,0,0,0,0,83187,26124),
(129782,'','Mother Moon is pleased, Lunaspyre!',0,0,0,0,0,0,0,0,0,0,0,83170,26124),
(129783,'I will show no mercy!','I will show no mercy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129784,'','Too much preaching! Just kill them!',0,0,0,0,0,0,0,0,0,0,0,83203,26124),
(129785,'Hero, over here.','',0,0,0,0,0,0,1,0,0,0,83239,0,26124),
(129786,'This land is grim and brimming with sorrow.','',0,0,0,0,0,0,0,0,0,0,83240,0,26124),
(129787,'I had no idea...','',0,0,0,0,0,0,0,0,0,0,83241,0,26124),
(129788,'','We must hurry, outsider!',0,0,0,0,0,0,1,0,0,0,0,83246,26124),
(129789,'','Keep moving! It is not safe here...',0,0,0,0,0,0,1,0,0,0,0,83247,26124),
(129790,'','Our foes close in... let us make haste!',0,0,0,0,0,0,1,0,0,0,0,83248,26124),
(129791,'Father...','',0,0,0,0,0,0,0,0,0,0,83242,0,26124),
(129792,'Let\'s go.','',0,0,0,0,0,0,0,0,0,0,83243,0,26124),
(129793,'You have a \"Loaner Demon\" for me?','You have a \"Loaner Demon\" for me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129794,'I don\'t like this demon.','I don\'t like this demon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129795,'What a coincidence. She doesn\'t like you either.\n\nNow get to work before the eredar on the other side of this thing figure out what I\'ve done and try to seal the portal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129796,'I wish to cease my experience gains when I reach level 19.','I wish to cease my experience gains when I reach level 19.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129797,'Are you certain you wish to stop gaining experience when you reach level 19?','Are you certain you wish to stop gaining experience when you reach level 19?',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129798,'Leave this place, $c!','Leave this place, $c!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129799,'You should not be here.','You should not be here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129800,'My will is not my own.','My will is not my own.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129801,'This is not my choice!','This is not my choice!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129802,'I remain bound, even in death...','I remain bound, even in death...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129803,'My suffering has no end!','My suffering has no end!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129804,'Death does not bring peace.','Death does not bring peace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129805,'There!','',0,0,0,0,0,0,1,0,0,0,83258,0,26124),
(129806,'My fate was sealed long ago.','My fate was sealed long ago.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129807,'Anduin!','',0,0,0,0,0,0,0,0,0,0,83259,0,26124),
(129808,'This changes nothing.','This changes nothing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129809,'Let\'s go.','',0,0,0,0,0,0,0,0,0,0,83260,0,26124),
(129810,'','These spirits belong to the Burning Legion!',0,0,0,0,0,0,0,0,0,0,0,83267,26124),
(129811,'','My death will not break the pact!',0,0,0,0,0,0,0,0,0,0,0,83266,26124),
(129812,'You will succumb to the Burning Legion. This I vow!','',0,0,0,0,0,0,0,0,0,0,83268,0,26124),
(129813,'This... cannot be...','',0,0,0,0,0,0,0,0,0,0,83269,0,26124),
(129814,'Those bound to me chose this fate for themselves!','',0,0,0,0,0,0,0,0,0,0,83270,0,26124),
(129815,'','These eredar are using power cores in their amateurish attempts to bend the elements to their will. Teach them such powers are not to be trifled with!',0,0,0,0,0,0,0,0,0,0,0,83285,26124),
(129816,'','Those demons presumed to bind the elements. Fools! They have learned the price of such an insult!',0,0,0,0,0,0,0,0,0,0,0,83286,26124),
(129817,'You are mine!','You are mine!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129818,'Nowhere to run!','Nowhere to run!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129819,'Death is only the beginning.','Death is only the beginning.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129820,'Join us in eternity...','Join us in eternity...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129821,'Go to your grave!','Go to your grave!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129822,'Let this torment end!','Let this torment end!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129823,'This... cannot be...','This... cannot be...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129824,'Ah.... at last.','Ah.... at last.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129825,'Vengeance will be mine!','Vengeance will be mine!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129826,'Your world will be purged!','Your world will be purged!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129827,'Your death will be swift and unmerciful.','Your death will be swift and unmerciful.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129828,'Wither before my might!','Wither before my might!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129829,'You dare?!','You dare?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129830,'The Legion\'s work will be done.','The Legion\'s work will be done.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129831,'You will know pain!','You will know pain!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129832,'Take to the skies, my pets! Yaaaaah!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129833,'','I am ready to travel to Skold-Ashil.\n\nShall we depart?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(129834,'Kil\'jaeden has sent one of his generals to oversee the Cathedral of Eternal Night. Put an end to her command.','',0,0,0,0,0,0,0,0,0,0,83311,0,26124),
(129835,'Well done. Let the Deceiver rage now that the cathedral is no longer under his control.','',0,0,0,0,0,0,0,0,0,0,83308,0,26124),
(129836,'The Legion has summoned forth a ravenous beast with a taste for mortal flesh. Destroy this monstrosity before it can be unleashed!','',0,0,0,0,0,0,0,0,0,0,83309,0,26124),
(129837,'The beast has been put down. Good! Soon we will do the same to Kil\'jaeden.','',0,0,0,0,0,0,0,0,0,0,83310,0,26124),
(129838,'I sense a perverse power rising among the Legion. Destroy it and weaken their grip on the cathedral.','',0,0,0,0,0,0,0,0,0,0,83312,0,26124),
(129839,'A worthy kill. That bloated fiend will never bring forth another demon.','',0,0,0,0,0,0,0,0,0,0,83313,0,26124),
(129840,'An inquisitor lurks within the cathedral, turning the souls of our dead against us. Send this filth screaming back into the Nether.','',0,0,0,0,0,0,0,0,0,0,83314,0,26124),
(129841,'That inquisitor delighted in sending its victims to their deaths. Fitting, then, that you forced the fiend to meet its own fate.','',0,0,0,0,0,0,0,0,0,0,83315,0,26124),
(129842,'Kil\'jaeden delights in sending his underlings to defile the cathedral. Remove this foul creature from our world.','',0,0,0,0,0,0,0,0,0,0,83316,0,26124),
(129843,'The Legion seeks to break our will by desecrating this once-sacred temple. Your deeds prove our spirit cannot be broken!','',0,0,0,0,0,0,0,0,0,0,83317,0,26124),
(129844,'','Elune bless you, brave one. It seems the woods no longer offer us sanctuary from the Legion\'s forces.',2,0,0,0,0,0,2,0,0,0,0,0,26124),
(129845,'','My sisters and I owe you our lives. We don\'t have much but you\'re free to take anything you find useful from our supplies.',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(129846,'','Thank you again. We will not forget your kindness!',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(129847,'Salutations, $ct! \n\nAs you may already know, this place is more than just a naval graveyard... it\'s also a massive breeding ground for kraken! I mean just look at all this incubation! It\'s spectacular... and perhaps slightly dangerous.\n\nSince you\'re here to destroy the eggs before they hatch, perhaps you\'d enjoy my newest, relatively-safe invention:\n\nI call it... the Egg-Sploder!\n\nIt almost works perfectly most of the time! What do you say?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129848,'Sure, I\'ll give it a shot. What could possibly go wrong?','Sure, I\'ll give it a shot. What could possibly go wrong?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129849,'','Let\'s move!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129850,'','As you command, priestess.',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(129851,'Activating','Activating',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129852,'This is a test broadcast for gender token testing, $gbrother:sister;! (Do not translate)','',0,0,0,0,0,0,463,0,0,0,0,0,26124),
(129853,'Turalyon! I am pleased you continue to thwart the Legion\'s best efforts to kill you.','',0,0,0,0,0,0,1,0,0,0,86191,0,26124),
(129854,'What of Alleria? Is she...','',0,0,0,0,0,0,1,0,0,0,86192,0,26124),
(129855,'The last time I saw her was on the Xenedar. She was still... under guard.','',0,0,0,0,0,0,1,0,0,0,86193,0,26124),
(129856,'Alleria\'s out there somewhere, old friend. I know it. And other survivors as well.','',0,0,0,0,0,0,1,0,0,0,86194,0,26124),
(129857,'But thousands of demons stand between us and our allies. We must thin the Legion\'s ranks to have any hope of reaching the Xenedar alive.','',0,0,0,0,0,0,1,0,0,0,86195,0,26124),
(129858,'Then that is what we will do, High Exarch.','',0,0,0,0,0,0,66,0,0,0,86196,0,26124),
(129859,'Climbing','Climbing',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129860,'Thank you for saving me!','Thank you for saving me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129861,'I must report back to camp!','I must report back to camp!',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(129862,'The demons cannot chain us for long.','The demons cannot chain us for long.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129863,'','I am Magatha of the Grimtotem tribe, and I will be heard!',0,0,0,0,0,0,0,0,0,0,0,83347,26124),
(129864,'I have recovered some of the essence you seek. Please, take all of it.','I have recovered some of the essence you seek. Please, take all of it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129865,'','You\'re in charge here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129866,'I am the farseer of the Earthen Ring. Who are you?','I am the farseer of the Earthen Ring. Who are you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129867,'Greetings, Grandmaster $n. It\'s nice of you to visit us. We\'re mostly focused on cleaning up the last remnants of the sha in the area.$b$bIf you could assist us with this task, perhaps we can help you with yours. What do you say?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129868,'You certainly removed a great number of the remaining sha remnants, Grandmaster. We appreciate your help with that matter.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129869,'How goes the removal of the remaning remnants?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129870,'<The portal hums with energy. Screams and other disturbing noises emanate from beyond.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129871,'Overload with Nethershards [100]','Overload with Nethershards [100]',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129872,'I\'ve cleaned up the sha.','I\'ve cleaned up the sha.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129873,'','I am Magatha Grimtotem, of the Grimtotem tribe. I am the Elder Crone, the matriarch of my tribe.$b$bThough Baine may have exiled me from Thunder Bluff, I am the leader that the tauren need. They sit idly by in their tents, waiting for the Alliance and the Legion to effortlessly roll over them. My people and I refuse to let that happen to us. We do what we must to survive.$b$bThe Legion has attacked. The Grimtotem need me. Will you help, or will you get in the way?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129874,'I\'m ready to clean up the sha.','I\'m ready to clean up the sha.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129875,'|CFFF00000CAUTION|R This will summon a dangerous foe that will require multiple heroes to defeat. You will lose 100 Nethershards by destroying this portal.','|CFFF00000CAUTION|R This will summon a dangerous foe that will require multiple heroes to defeat. You will lose 100 Nethershards by destroying this portal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129884,'Is there no end to your sanctimonious bluster, Velen? You claim the mantle of prophet, yet you always lacked the vision to see the inevitable destiny of our world... of all worlds.','',0,0,0,0,0,0,1,0,0,0,83438,0,26124),
(129885,'The husk before you was once a vessel for the might of Sargeras. But this temple itself is our prize. The means by which we will reduce your world to cinders!','',0,0,0,0,0,0,1,0,0,0,83439,0,26124),
(129886,'Still... I will not deprive you of this chance to fall before an ancient wonder. Let this avatar be the end of you!','',0,0,0,0,0,0,0,0,0,0,83440,0,26124),
(129887,'I should warn you that the Egg-Sploder does occasionally cause kraken eggs to hatch instead of explode. A meager price to pay for the convenience of technology, right?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129888,'We must move quickly. Now that the demons know we are on the surface, the Legion will bring its full might to bear against us.','',0,0,0,0,0,0,1,0,0,0,86190,0,26124),
(129889,'Flames!','',0,0,0,0,0,0,0,0,0,0,83450,0,26124),
(129890,'These pylons can only transport a handful of troops at a time, but for now they will suffice.','',0,0,0,0,0,0,1,0,0,0,86197,0,26124),
(129891,'Marked!','',0,0,0,0,0,0,0,0,0,0,83454,0,26124),
(129892,'Claimed!','',0,0,0,0,0,0,0,0,0,0,83452,0,26124),
(129893,'Thank you, Grandmaster $p, for your assistance. Unfortunately, Ban-Lu is no longer here. I saw him heading south, but that is all I know.','',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(129894,'Impale!','',0,0,0,0,0,0,0,0,0,0,83448,0,26124),
(129895,'$ct, I\'ve sent a raven to take you to the command ship.','',0,0,0,0,0,0,0,0,0,0,83457,0,26124),
(129896,'Emptiness...','',0,0,0,0,0,0,0,0,0,0,83435,0,26124),
(129897,'Please, walk with me to the shore.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129898,'I shall commune with the water now...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129899,'How interesting.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129900,'','Eradicate them all!',0,0,0,0,0,0,0,0,0,0,0,83459,26124),
(129901,'Impus not sure why he ended up here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129902,'The rivers call to me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129903,'The raven looks at you quizzically.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129904,'','I seek to cleanse the waters here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129905,'','The fish of Suramar are friends to me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129906,'%s triggers an ancient protective spell!','%s triggers an ancient protective spell!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(129907,'So, you prove to be as foolish as all the others on this world and seek to face me? Very well.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129908,'Pathetic! My time is wasted here. With the power from the tomb, I will destroy all of you!','',0,0,0,0,0,0,0,0,0,0,83494,0,26124),
(129909,'My crag, you die!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129910,'This Dookya\'s pass!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129911,'Our pass, you go!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129912,'Your shinies, give them!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129913,'The Legion stoops to corrupting the murlocs that call this shore home. Put an end to this befoulment!','',0,0,0,0,0,0,0,0,0,0,83488,0,26124),
(129914,'I have never understood how anyone could find charm in those distasteful creatures. Let us turn our attention to more pressing matters.','',0,0,0,0,0,0,0,0,0,0,83489,0,26124),
(129915,'Fel... murlocs? Is there any race the Legion won\'t corrupt? Take care of this, would you?','',0,0,0,0,0,0,0,0,0,0,83486,0,26124),
(129916,'I confess a certain fondness for murlocs. The fel variety, however... not so much.','',0,0,0,0,0,0,0,0,0,0,83487,0,26124),
(129917,'Harjatan\'s |cFFFF0404|Hspell:232192|h[Commanding Roar]|h|r has drawn the attention of nearby murlocs!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129918,'For the Legion!','For the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129919,'The fel will consume you!','The fel will consume you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129920,'Your end is near!','Your end is near!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129921,'You will die by my blade!','You will die by my blade!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129922,'We cannot be stopped!','We cannot be stopped!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129923,'I will strike you down!','I will strike you down!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129924,'Fine. Take all my desecrated seaweed.','Fine. Take all my desecrated seaweed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129925,'I have found many of your totem fragments. Please take them.','I have found many of your totem fragments. Please take them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129926,'Well done! With the kraken threat neutralized, we can focus our efforts on defeating the Burning Legion.','',0,0,0,0,0,0,0,0,0,0,83490,0,26124),
(129927,'Looks like I found some of this disgusting globby stuff you wanted.','Looks like I found some of this disgusting globby stuff you wanted.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129928,'Hello pretty bird. Do you want all these shiny things?','Hello pretty bird. Do you want all these shiny things?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129929,'For millennia, the Army of the Light has waged war upon the Burning Legion. Battles. Skirmishes. Sabotage.','',0,0,0,0,0,0,1,0,4,0,86331,0,26124),
(129930,'We were committed to our cause. Either we would end the Legion\'s crusade... or they would end ours.','',0,0,0,0,0,0,1,0,4,0,86332,0,26124),
(129931,'When at last our final assault on Argus began, we knew we might not survive it. And when the Xenedar was hit, it seemed all hope was lost.','',0,0,0,0,0,0,1,0,4,0,86333,0,26124),
(129932,'I want to give you all my golden minnows.','I want to give you all my golden minnows.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129933,'Champion, the Legion holds our forces captive, torturing them nigh to death. Rescue them... before their Light fades!','',0,0,0,0,0,0,0,0,0,0,83491,0,26124),
(129934,'You have saved our forces from a terrible fate. The Light thanks you, hero.','',0,0,0,0,0,0,0,0,0,0,83492,0,26124),
(129935,'Mistress Sassz\'ine called in a Darkscale Taskmaster!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129936,'|TINTERFACE\\ICONS\\ability_fixated_state_red.blp:20|t A Razorjaw Gladiator is fixated on you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129970,'<Velen stares straight ahead. He doesn\'t seem to notice you have arrived.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129971,'Mac\'Aree was once the pinnacle of eredar civilization.','',0,0,0,0,0,0,1,0,0,0,87907,0,26124),
(129972,'A beacon of progress... that drew the malevolence of the universe to our very gates.','',0,0,0,0,0,0,1,0,0,0,87908,0,26124),
(129973,'Wait... something stirs.','',0,0,0,0,0,0,6,0,0,0,87909,0,26124),
(129974,'Spirits... of all those who died that day.','',0,0,0,0,0,0,1,0,0,0,87910,0,26124),
(129975,'I can still hear the naaru\'s song of war. There was one who held the way open for us.','',0,0,0,0,0,0,6,0,0,0,87911,0,26124),
(129976,'She fell behind. I can feel her presence even now... but her song is bitter, distorted.','',0,0,0,0,0,0,1,0,0,0,87913,0,26124),
(129977,'The last time I laid eyes upon this place, I could think of nothing but escape. Talgath, my most trusted advisor, had betrayed me.','',0,0,0,0,0,0,1,0,0,0,87914,0,26124),
(129982,'Champion, the Argus Expedition calls upon you to join our assault on the Legion home world of Argus.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129984,'Your souls will BURN!','',0,0,0,0,0,0,15,0,0,0,86119,0,26124),
(129985,'Ready your weapon.','',0,0,0,0,0,0,0,0,0,0,86120,0,26124),
(129987,'We need not be sticking around here longer than necessary.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129988,'I am ready to fight by your side.','I am ready to fight by your side.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129989,'Wanna know the key to beating the Legion?\n\nBuildings, mate.\n\nBuildings and more buildings. Crikey!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129990,'Is that ALL you have to offer? How pathetic...','',0,0,0,0,0,0,0,0,0,0,86122,0,26124),
(129991,'Your flesh is weak! Your bones brittle!','',0,0,0,0,0,0,0,0,0,0,86123,0,26124),
(129992,'I\'ve fought your kind for a thousand years, demon. You brag and bluster, then you die!','',0,0,0,0,0,0,0,0,0,0,86124,0,26124),
(129994,'Do not relent! We end this beast here and now!','',0,0,0,0,0,0,0,0,0,0,86125,0,26124),
(129995,'I want to go to the Cathedral of Eternal Night (Dungeon).','I want to go to the Cathedral of Eternal Night (Dungeon).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129996,'I want to go to the Tomb of Sargeras (Raid).','I want to go to the Tomb of Sargeras (Raid).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(129997,'You are no match for our power!','',0,0,0,0,0,0,0,0,0,0,86126,0,26124),
(129999,'NOT USED','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130000,'','Elune aids those who seek to defend the land from the Burning Legion. Step within the moonlight, hero, and obtain her blessing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130001,'Alleria! Perfect timing, as always.','',0,0,0,0,0,0,0,0,0,0,86130,0,26124),
(130002,'Your people... your worlds... always crumble.','',0,0,0,0,0,0,0,0,4,0,86127,0,26124),
(130004,'Oh, hello, we\'re not done setting up yet.\n\nIf you\'re looking for something a bit more dead and metal than E.T.C., you\'re going to want to check this out.\n\nWould you mind spreading the word for us? It\'s a concert you\'re not going to want to miss!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130005,'I want to teleport to Harjatan.','I want to teleport to Harjatan the Bludger.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130006,'I want to teleport to Mistress Sassz\'ine.','I want to teleport to Mistress Sassz\'ine.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130007,'I want to teleport to Sisters of the Moon.','I want to teleport to Sisters of the Moon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130008,'I want to teleport to The Desolate Host.','I want to teleport to The Desolate Host.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130009,'I want to teleport to Demonic Inquisition.','I want to teleport to Demonic Inquisition.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130010,'I want to teleport to Maiden of Vigilance.','I want to teleport to Maiden of Vigilance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130011,'I want to teleport to the Fallen Avatar.','I want to teleport to the Fallen Avatar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130012,'I want to teleport to Kil\'jaeden.','I want to teleport to Kil\'jaeden.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130013,'Light give me strength!','',0,0,0,0,0,0,0,0,0,0,86320,0,26124),
(130014,'This day will be your last, demon!','',0,0,0,0,0,0,0,0,0,0,86118,0,26124),
(130015,'|TINTERFACE\\ICONS\\SPELL_FEL_INCINERATE.BLP:20|t You have |cFFFF0000|Hspell:240209|h[Unstable Soul]|h|r!','|TINTERFACE\\ICONS\\SPELL_FEL_INCINERATE.BLP:20|t You have |cFFFF0000|Hspell:235117|h[Unstable Soul]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130016,'|TINTERFACE\\ICONS\\Ability_BossFelMagnaron_HandEmpowered.blp:20|t You have |cFFFF0000|Hspell:235271|h[Infusion]|h|r!','|TINTERFACE\\ICONS\\Ability_BossFelMagnaron_HandEmpowered.blp:20|t Maiden of Vigilance begins casting |cFFFF0000|Hspell:235271|h[Infusion]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130017,'','%s nocks her arrows with blinding speed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130018,'No! No more running! No more hiding! I must finish this!','',0,0,0,0,0,0,5,0,0,0,83571,0,26124),
(130019,'Velen! Stop!','',0,0,0,0,0,0,5,0,0,0,83572,0,26124),
(130020,'Sealing the portal buys us nothing, archmage. Whether it takes a few years or millennia, the Legion will return. Over and over again, until too few of us remain to fight them.','',0,0,0,0,0,0,1,0,0,0,83573,0,26124),
(130021,'It is time to seize our fate. We must use the portal and follow the Deceiver into the abyss. It is the only way!','',0,0,0,0,0,0,6,0,0,0,83574,0,26124),
(130022,'I agree. It is the only way. Go, champions! We have precious little time to save Velen and return before the portal closes.','',0,0,0,0,0,0,1,0,0,0,83575,0,26124),
(130023,'Come. If we are to die in the Nether, we will take the Deceiver with us!','',0,0,0,0,0,0,1,0,0,0,83576,0,26124),
(130024,'Azeroth\'s greatest champions await your arrival at Krasus\' Landing when you are ready.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130025,'NOT USED','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130026,'','Left!',0,0,0,0,0,0,0,0,0,0,0,86137,26124),
(130027,'','I have made a habit of saving you from the grasp of demons.',0,0,0,0,0,0,0,0,0,0,0,86136,26124),
(130028,'Light\'s Chosen, salute!','',0,0,0,0,0,0,66,0,0,0,88049,0,26124),
(130029,'','Are you alright, Turalyon?',0,0,0,0,0,0,6,0,0,0,0,86138,26124),
(130033,'This battle shall be your last!','',0,0,0,0,0,0,0,0,0,0,83607,0,26124),
(130034,'Facility lockdown confirmed. Engaging threat.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130035,'Your crusade is ended!','',0,0,0,0,0,0,0,0,0,0,83611,0,26124),
(130036,'Mark an enemy, and I will strike it down!','',0,0,0,0,0,0,0,0,0,0,83614,0,26124),
(130037,'The Legion comes! We must protect our homes!','The Legion comes! We must protect our homes!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130038,'The demons will never get past us! For the wilds!','The demons will never get past us! For the wilds!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130039,'By fang and claw, I\'ll stop them!','By fang and claw, I\'ll stop them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130040,'Bandu thoribas!','Bandu thoribas!',0,0,0,0,0,0,0,2,0,0,0,0,26124),
(130041,'Tor ilisar\'thera\'nal!','Tor ilisar\'thera\'nal!',0,0,0,0,0,0,0,2,0,0,0,0,26124),
(130042,'Be wary, champions! Behold a vision of what is to come!','',0,0,0,0,0,0,0,0,0,0,83671,0,26124),
(130043,'Find me, champions, and I will grant you sight!','',0,0,0,0,0,0,0,0,0,0,83608,0,26124),
(130044,'Obliteration beckons!','',0,0,0,0,0,0,0,0,0,0,83619,0,26124),
(130045,'Death rains upon you!','',0,0,0,0,0,0,0,0,0,0,83620,0,26124),
(130046,'Smolder! Suffer!','',0,0,0,0,0,0,0,0,0,0,83628,0,26124),
(130047,'Consume them all!','',0,0,0,0,0,0,0,0,0,0,83624,0,26124),
(130048,'Who will share your fate?','',0,0,0,0,0,0,0,0,0,0,83626,0,26124),
(130049,'I will cut you down myself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130050,'Be careful, $ct. Demons are out there on the prowl.','Be careful, $ct. Demons are out there on the prowl.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130051,'Give in to your fears! Your desires!','',0,0,0,0,0,0,0,0,0,0,83638,0,26124),
(130052,'Face your destiny!','',0,0,0,0,0,0,0,0,0,0,83639,0,26124),
(130053,'We are ready to depart, Prophet Velen.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(130054,'Your lives are petty and insignificant! We are eternal!','',0,0,0,0,0,0,0,0,0,0,83643,0,26124),
(130055,'Velen\'s defiance so long ago paved the way for your downfall.','',0,0,0,0,0,0,0,0,0,0,83644,0,26124),
(130056,'Every world that resisted us has fallen.','',0,0,0,0,0,0,0,0,0,0,83645,0,26124),
(130057,'The Burning Legion has come for your souls!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130058,'Your fate will be no different than all the rest!','',0,0,0,0,0,0,0,0,0,0,83646,0,26124),
(130059,'Give up! There is still time to join us and serve the master!','',0,0,0,0,0,0,0,0,0,0,83647,0,26124),
(130060,'I\'ll get you to those ships, heroes! Take them out, before the Deceiver grows stronger!','',0,0,0,0,0,0,0,0,0,0,83642,0,26124),
(130061,'Slaughter the mortals and bring me their broken corpses!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130062,'Feel the chaos consume you!','',0,0,0,0,0,0,0,0,0,0,83650,0,26124),
(130063,'Limitless destruction is at my command!','',0,0,0,0,0,0,0,0,0,0,83651,0,26124),
(130064,'Your souls will soon know oblivion!','',0,0,0,0,0,0,0,0,0,0,83652,0,26124),
(130065,'The leader of these naga has made a pact with the Legion, trading her people\'s lives for power. The fools go willingly, unaware of the price they must pay. Show them.','',0,0,0,0,0,0,0,0,0,0,83604,0,26124),
(130066,'The naga must learn that any bargain made with the Legion will end in pain.','',0,0,0,0,0,0,0,0,0,0,83605,0,26124),
(130067,'','Greetings, $c. I must complete my research.\n\nWill you aid me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130068,'Tonight we dine on mortal flesh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130069,'Begin confrontation with Gharsul the Remorseless.','Begin confrontation with Gharsul the Remorseless.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130070,'I\'m ready to face Tugar Bloodtotem. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','I\'m ready to face Tugar Bloodtotem. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130071,'Argus! My beloved homeworld... what have they done to you?','',0,0,0,0,0,0,0,0,0,0,83661,0,26124),
(130072,'Send me to Shadowsong. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','Send me to Shadowsong. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130073,'Fall into darkness!','',0,0,0,0,0,0,0,0,0,0,83658,0,26124),
(130074,'Give in! Let it take you!','',0,0,0,0,0,0,0,0,0,0,83659,0,26124),
(130076,'Let the shadows win!','',0,0,0,0,0,0,0,0,0,0,83656,0,26124),
(130077,'Take me to Agatha... (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','Take me to Agatha... (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130078,'Take me to Agatha... |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','Take me to Agatha... |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130080,'I\'m ready to take on Xylem. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','I\'m ready to take on Xylem. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130082,'I\'m ready to face Raest. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','I\'m ready to face Raest. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130083,'I\'m ready to face Kruul. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','I\'m ready to face Kruul. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130084,'I\'m ready to face Sigryn. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','I\'m ready to face Sigryn. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130085,'','We\'re under attack from the land and the sky, watch your head!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130086,'','The Legion will never defeat us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130087,'Severe the heads from their mortal bodies!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130088,'','The Legion promises us strength, greater than even Lady Azshara can provide!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130089,'','The naga will prevail...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130090,'I willingly serve the Legion.','I willingly serve the Legion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130091,'My soul for the power of the fel!','My soul for the power of the fel!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130092,'Give yourself to the Legion.','Give yourself to the Legion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130094,'We sent Minerva ahead to scout. Take the Death Gate and meet her in the citadel.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130095,'Use |TInterface\\Icons\\SPELL_SHADOW_ENSLAVEDEMON.BLP:20|t |cFFFF0000|Hspell:111771|h[Enslave Demon]|h|r to subdue the Wrathsteed!','Use |TInterface\\Icons\\spell_warlock_demonicportal_green.blp:20|t |cFFFF0000|Hspell:111771|h[Demonic Portal]|h|r to get past Ariden\'s barrier!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130097,'The Legion seeks to extend its fiery reach. We would appreciate your aid in extinguishing this threat, commander.','',0,0,0,0,0,0,0,0,0,0,83678,0,26124),
(130098,'Ha! Smoked them! Will I be fired for this? One has to keep up one\'s spirits somehow. Well done, champion, as usual.','',0,0,0,0,0,0,0,0,0,0,83679,0,26124),
(130100,'','These beacons send requests for backup directly to the Sentinax. That could be dangerous.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(130101,'','However, if you\'re looking for a fight -- or, if you\'re looking for nethershards -- using these beacons might not be a bad idea.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(130102,'','Just be careful, $n. Too many reinforcements from the Sentinax, and you might find yourself in a fight that you can\'t win...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(130103,'My people have been waiting for this day.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(130104,'We have been waiting so long for this day.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(130105,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130106,'L\'ura...','',0,0,0,0,0,0,603,0,0,0,87898,0,26124),
(130107,'How will we get to Argus in one piece with the Legion bearing down on us like this?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(130108,'My artificers have been preparing for that for quite some time.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(130109,'Behold the triumph of the draenei--the Exodar!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(130110,'<Dog wags its tail, trying very hard to stay seated and not jump on you. It\'s happy to see you again after so long.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130111,'<Dog sniffs the stone and licks your hand reassuringly.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130112,'<Show the stone from Dalaran\'s streets to the dog.>','<Show the stone from Dalaran\'s streets to the dog.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130113,'<Dog\'s coat is gleaming, and it looks quite healthy. Breanni is clearly taking very good care of it.>\n\n<But how did it get here?>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130114,'Culling the numbers of those vile worms helps restore the balance on these shores. You have my thanks, hero.','',0,0,0,0,0,0,0,0,0,0,83677,0,26124),
(130115,'Hey buddy, don\'t you know better than to interrupt a performer during his show?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130116,'Minions of the flame! Feast upon their flesh!','',0,0,0,0,0,0,0,0,0,0,86128,0,26124),
(130117,'I am. In no small part thanks to our friend here. But Alleria... there\'s something else.','',0,0,0,0,0,0,1,0,4,0,86132,0,26124),
(130118,'Do... not... give in!','',0,0,0,0,0,0,0,0,4,0,86129,0,26124),
(130122,'I only deal with the most elite gladiators.','I only deal with the most elite gladiators.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130123,'I would like to look at your wares.','I would like to look at your wares.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130124,'You again?\n\nLook, I don\'t come to your place and tell you how to $c, so why don\'t you just scram?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130125,'WARNING: ENEMY DETECTED','WARNING: ENEMY DETECTED',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130126,'Could you be quiet?','Could you be quiet?',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(130127,'Actually, I\'d like to watch your show.','Actually, I\'d like to watch your show.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(130128,'Kick! Punch! Burn!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130129,'REAVER HAS ARRIVED','REAVER HAS ARRIVED',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130133,'When you are ready to depart, Battlelord, this portal will return you to Skyhold.','',0,0,0,0,0,0,0,0,6,0,83747,0,26124),
(130134,'The Earthmother is with you, hero! Step within the circle of totems and obtain her blessing.','The Earthmother is with you, hero! Step within the circle of totems and obtain her blessing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130135,'It certainly wasn\'t easy, but we were able to procure you a piece of equipment for your Champions of the highest quality.\n\nUnfortunately our supplies are extremely limited, so we must be careful with how many we pass out.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130136,'The Crown was a conduit. A unifying force. We each carried but one part of the whole.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130137,'My brothers abandoned their shards when Sargeras arrived. They are still here, in Mac\'Aree.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130138,'With the Crown once more in our possession we can avoid the Xenedar\'s fate.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130139,'Ages ago I stood on this very spot and called the Draenei to me. It is here I will seek the other fragments.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130141,'We leave the protection of the barrier behind. Remain on guard, my friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130142,'May the Light guide my sight. Pheta vi acahachi.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130143,'<Half-heard prayers.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130144,'I do not understand. Why can I not sense them?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130145,'<Strained breathing.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130146,'Acheon phetar, give me the clarity I seek. Show me where they are!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130147,'<Pained groan.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130148,'Such... darkness!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130149,'<Velen cries out.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130150,'Such terrible darkness!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130151,'<Velen gasps for air.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130152,'I- I cannot... see...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130153,'Are you read to proceed, my friend?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130154,'Yes, Prophet.','Yes, Prophet.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130155,'Something is desperately wrong here. I fear my power alone will not be enough.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130156,'<Shawn looks at you expectantly>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130157,'Is it you?!  The person I\'ve been dreaming about?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130158,'Before you ask, I don\'t know what this person looks like. In my first dream they were a night elf, in the second they were a tauren, and in the third a night elf again. In these dreams we\'d adventure across Azeroth and Draenor fighting demons, dragons, old gods, and even murlocs! \n\nI\'d never had a connection like this before.  It seemed so real to me.  In my last dream, I asked them to meet me here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130159,'I\'ll keep waiting, I know they\'ll come!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130160,'Are you?... You ARE!  I have so much to tell you!  Where do I get started? \n\nSince our first adventure, I could no longer focus on anything but when our next adventure would be.  My friends would tell me that you weren\'t real, that I was acting crazy, that you\'re only in the dream.  I knew they couldn\'t be right! The feelings I have are far more than a dream!\n\nEvery adventure we\'ve been on, every foe we\'ve slain, and every chat we\'ve had has brought me to one question for you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130161,'I... I understand.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130162,'I don\'t have words... You\'ve made me the happiest person!  To our next adventure!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130163,'$n activated an Unstable Nether Portal in Cinder Run!','$n activated an Unstable Nether Portal in Cinder Run!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130164,'$n activated an Unstable Nether Portal in Coast of Anguish!','$n activated an Unstable Nether Portal in Coast of Anguish!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130165,'$n activated an Unstable Nether Portal in Crescent Ruins!','$n activated an Unstable Nether Portal in Crescent Ruins!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130166,'$n activated an Unstable Nether Portal in Dark Stockades!','$n activated an Unstable Nether Portal in Dark Stockades!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130167,'$n activated an Unstable Nether Portal in Deadwood Landing!','$n activated an Unstable Nether Portal in Deadwood Landing!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130168,'$n activated an Unstable Nether Portal in Felbreach Hollow!','$n activated an Unstable Nether Portal in Felbreach Hollow!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130169,'$n activated an Unstable Nether Portal in Feldust Cavern!','$n activated an Unstable Nether Portal in Feldust Cavern!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130170,'$n activated an Unstable Nether Portal in Felfire Pass!','$n activated an Unstable Nether Portal in Felfire Pass!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130171,'$n activated an Unstable Nether Portal in Felrage Strand!','$n activated an Unstable Nether Portal in Felrage Strand!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130172,'$n activated an Unstable Nether Portal in Felsworn Vault!','$n activated an Unstable Nether Portal in Felsworn Vault!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130173,'$n activated an Unstable Nether Portal in Foulshore Strip!','$n activated an Unstable Nether Portal in Foulshore Strip!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130174,'$n activated an Unstable Nether Portal in Garrison of the Fel!','$n activated an Unstable Nether Portal in Garrison of the Fel!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130175,'$n activated an Unstable Nether Portal in Impsorrow Approach!','$n activated an Unstable Nether Portal in Impsorrow Approach!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130176,'$n activated an Unstable Nether Portal in Jagged Cove!','$n activated an Unstable Nether Portal in Jagged Cove!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130177,'$n activated an Unstable Nether Portal in Moonlight Ascent!','$n activated an Unstable Nether Portal in Moonlight Ascent!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130178,'$n activated an Unstable Nether Portal in Path of Suffering!','$n activated an Unstable Nether Portal in Path of Suffering!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130179,'$n activated an Unstable Nether Portal in Screaming Cliffs!','$n activated an Unstable Nether Portal in Screaming Cliffs!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130180,'$n activated an Unstable Nether Portal in Soldier\'s Torment!','$n activated an Unstable Nether Portal in Soldier\'s Torment!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130181,'$n activated an Unstable Nether Portal in Soul Ruin!','$n activated an Unstable Nether Portal in Soul Ruin!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130182,'$n activated an Unstable Nether Portal in Strand\'s End!','$n activated an Unstable Nether Portal in Strand\'s End!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130183,'$n activated an Unstable Nether Portal in the Creeping Grotto!','$n activated an Unstable Nether Portal in the Creeping Grotto!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130184,'$n activated an Unstable Nether Portal in the Twisted Grounds!','$n activated an Unstable Nether Portal in the Twisted Grounds!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130185,'$n activated an Unstable Nether Portal in the Weeping Terrace!','$n activated an Unstable Nether Portal in the Weeping Terrace!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130186,'$n activated an Unstable Nether Portal in Shadow Fracture!','$n activated an Unstable Nether Portal in Shadow Fracture!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130187,'$n activated an Unstable Nether Portal in Wrynfall!','$n activated an Unstable Nether Portal in Wrynfall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130188,'...','...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130189,'I hope you find them.','I hope you find them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130190,'I\'ve had the same dreams about you!','I\'ve had the same dreams about you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130191,'Yes!','Yes!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130192,'I\'m sorry, I just can\'t...','I\'m sorry, I just can\'t...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130193,'Champion, I bring you the favor of Eyir! Approach and obtain her blessing.','Champion, I bring you the favor of Eyir! Approach and obtain her blessing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130194,'Champion, I bring you a gift from Prince Farondis. My spells will allow you to be stronger, deft, and more powerful for a while. Approach and receive your boon.','Champion, I bring you a gift from Prince Farondis. My spells will allow you to be stronger, deft, and more powerful for a while. Approach and receive your boon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130195,'How can I help?','How can I help?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130196,'What is your wish?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130197,'','Some of the protective spells have fragmented and begun to fade. It pains me to suggest it, but I think you might be able to catch the fragments with a fishing pole.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130198,'','Beautiful isn\'t it? Can you feel its power flowing through you, pulsing as it disrupts the very world around us? I can bend that power to my will if you like...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130199,'Take me to the Trial of Style!','Take me to the Trial of Style!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130200,'','Thank you, $n! This is exactly what I need.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130201,'<The portal hums with energy. Screams and other disturbing noises emanate from beyond.>\n\nReturn when you have more Nethershards.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130203,'Instructor, I don\'t think...','Instructor, I don\'t think...',0,0,0,0,0,0,661,0,0,0,0,0,26124),
(130204,'Uh... how did that incantation go again? Ru shallora... uh... um... abracadabra?','Uh... how did that incantation go again? Ru shallora... uh... um... abracadabra?',0,0,0,0,0,0,469,0,0,0,0,0,26124),
(130205,'Don\'t worry students, this demon is perfectly contained in the arcane matrix.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(130206,'Now, if you had been listening in our last class you would know the incantation to cause it to explode in a ball of flame.','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(130207,'You there, show the class how the incantation goes.','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(130208,'Hurry up! We don\'t have all eternity to wait!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(130209,'Will you adventure with me... forever?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130210,'Oh dear! This wasn\'t in the lesson plan!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130211,'Annihilate!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130212,'To arms, Nightwatchers! The Legion comes!','To arms, Nightwatchers! The Legion comes!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130213,'The Nightwatch will never forsake our duty!','The Nightwatch will never forsake our duty!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130214,'Bandu Thoribas!','Bandu Thoribas!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130215,'Stand firm, Nightwatchers! Our enemies approach!','Stand firm, Nightwatchers! Our enemies approach!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130216,'For Nar\'thalas!','For Nar\'thalas!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130217,'Focus your attacks. I\'ll hold his attention.','',0,0,0,0,0,0,0,0,0,0,86131,0,26124),
(130218,'','You cannot evade my volley!',0,0,0,0,0,0,0,0,0,0,0,83796,26124),
(130219,'','My arrows strike true!',0,0,0,0,0,0,0,0,0,0,0,83797,26124),
(130220,'Thank you, friend! As a reward have a bit of my power. May it help you against our foe.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(130221,'Impus is making a boat. You help!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130223,'Farewell.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130224,'Impus is pleased with minion\'s work.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130225,'Catch seaweed with fishing pole! Give seaweed to Impus! No profit!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130226,'A ritual totem was lost in these waters many years ago when a lightning bolt shattered it. I seek to rebuild it so I may  honor my ancestors.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130227,'<Akule studies the fragments carefully.>\n\nYes, these are indeed part of the original totem. You have my thanks, $c.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130228,'I am collecting the hundreds, maybe thousands, of pieces from the shattered totem. You might have some luck finding them with a fishing pole.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130229,'The raven looks at you and tilts its head to the side.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130230,'Corbyn caws with delight.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130231,'The raven looks at some shiny pebbles near its feet, and then looks at water. You get the distinct feeling that you could retrieve them with a fishing pole.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130232,'','Before I was exiled, I was the aquarium keeper in the city. The life that exists in the tank is still my responsibility and I won\'t abandon them!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130233,'','Splendid! Here, just put them in my enchanted globe of water, and I\'ll see to the rest.\n\n<Sha\'leth appears to be distracted watching the tiny fish.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130234,'','Oh! First and foremost, the koi in are starting to overcrowd. Maybe if you caught some of the minnows, I could release them into the rivers?\n\nBe careful of Magicus, the guardian of the aquarium.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130235,'','The corruption chokes our waters and kills the natural life that once thrived there. We must fight back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130236,'','<She reaches out and takes the globules while keeping her head turned away in disgust.>\n\nThank you. I will enjoy destroying this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130237,'','No doubt you\'ve already been fighting back the monstrosities that invade our forest. But if we could extract the more... viscous... corruption from the water itself, that would be a great victory as well! I suggest trying a fishing pole.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130238,'You will pay for your transgressions, warlock!','',0,0,0,0,0,0,0,0,0,18181,0,0,26124),
(130239,'I will crush you, insect!','',0,0,0,0,0,0,0,0,0,22210,0,0,26124),
(130240,'The dreadsteeds are mine, warlock... Mine!','',0,0,0,0,0,0,0,0,0,18181,0,0,26124),
(130241,'Xoroth wil not be... defeated...','',0,0,0,0,0,0,0,0,0,22210,0,0,26124),
(130242,'','Help! Their trying to get at my supplies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130243,'','Thank you so much! Please, have this chest from the cache. You\'ve earned it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130244,'You have been spotted and an assassin has been dispatched.','You have been spotted and an assassin has been dispatched.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(130247,'Let\'s move.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130248,'Welcome to the Exodar, $p.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(130249,'$p, it is time. Set course for Argus.','',0,0,0,0,0,0,1,0,0,0,86204,0,26124),
(130250,'Test','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130252,'I\'ve brought you this Armorcrafter\'s Commendation.','I\'ve brought you this Armorcrafter\'s Commendation.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130253,'So you have! Very well, let\'s get started. I\'ll teach you all about the legendary armor you\'ve always dreamed of making!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130254,'Hold on just a moment, $n. Let\'s finish the armor we\'re already making first.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130255,'|TInterface\\Icons\\SPELL_FIRE_TWILIGHTFLAMEBREATH.BLP:20|t%s begins to cast |cFFFF0000|Hspell:233983|h[Echoing Anguish]|h|r!','|TInterface\\Icons\\SPELL_FIRE_TWILIGHTFLAMEBREATH.BLP:20|t%s begins to cast |cFFFF0000|Hspell:233983|h[Echoing Anguish]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130256,'Bl... Bless you... I... I\'ll live, thanks to you!','Bl... Bless you... I... I\'ll live, thanks to you!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(130257,'Please, take this as your reward.','Please, take this as your reward.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(130281,'I\'m here to inquire about the Tri-Disc of Fire.','I\'m here to inquire about the Tri-Disc of Fire.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130292,'Ah yes, I do know where that is. Before Karazhan fell, Khadgar and I had done a bit of research on it back in my sanctum, where it still resides. I\'m afraid we didn\'t have time to learn very much about it.$b$bNormally, it would be trivial to travel to my sanctum, but I\'m afraid the demons in this cellar stand between us and the portal to it.$b$bFight your way through the cellar and you\'ll find the portal to at the far end. The tri-disc should still be there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130311,'','Hmmmm....? Hmmmm.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130312,'','Oh, you are cute, but I am already under contract.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130314,'','Oh, what delicious morals you have.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130316,'','Ooo... I am so cold. Would you be a dear and set yourself on fire for me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130319,'','<Just winks a lot.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130331,'Freedom is mine! Your suffering for this insult will be legendary, elf!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130332,'','Ooo, a scribe? I do love it when someone writes down my little... dominations. I might know a little secret. A dark secret.\n\nDo you kiss and tell? Because I do.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130333,'Do you have something for sale?','Do you have something for sale?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130334,'Pretty bird want shiny gold coins?','Pretty bird want shiny gold coins?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130335,'Bless Elune! Thank you, hero!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(130336,'You deserve a reward! Here, I hope this will be of use to you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130337,'','Mmm... I do love a good scribe. Be sure to stay... in touch.',17,0,0,0,0,0,0,0,0,0,0,0,26124),
(130338,'For the rest of you, let\'s back to the academy. Clearly you all need a few hundred years of further instruction.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130341,'Now, most importantly: we must decide what type of armor you want to craft. Choose carefully - your commendation only earns you one lesson.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130342,'I want to make tailored shoulders.\n|TINTERFACE\\ICONS\\INV_SHOULDER_CLOTH_RAIDWARLOCK_L_01.BLP:32|t\n|Hitem:146666:0:0:0:0:0:0:0:110:0|h[Celumbra, the Night\'s Dichotomy]|h','I want to make tailored shoulders.\n|TINTERFACE\\ICONS\\INV_SHOULDER_CLOTH_RAIDWARLOCK_L_01.BLP:32|t\n|Hitem:146666:0:0:0:0:0:0:0:110:0|h[Celumbra, the Night\'s Dichotomy]|h',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130343,'I want to make leather boots.\n|TINTERFACE\\ICONS\\INV_Leather_RaidDemonHunterMythic_Q_02Boots.blp:32|t\n|Hitem:146669:0:0:0:0:0:0:0:110:0|h[The Sentinel\'s Eternal Refuge]|h','I want to make leather boots.\n|TINTERFACE\\ICONS\\INV_Leather_RaidDemonHunterMythic_Q_02Boots.blp:32|t\n|Hitem:146669:0:0:0:0:0:0:0:110:0|h[The Sentinel\'s Eternal Refuge]|h',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130344,'I want to make chain mail gloves.\n|TINTERFACE\\ICONS\\INV_GAUNTLETS_PLATE_RAIDPALADIN_I_01.BLP:32|t\n|Hitem:146668:0:0:0:0:0:0:0:110:0|h[Vigilance Perch]|h','I want to make chain mail gloves.\n|TINTERFACE\\ICONS\\INV_GAUNTLETS_PLATE_RAIDPALADIN_I_01.BLP:32|t\n|Hitem:146668:0:0:0:0:0:0:0:110:0|h[Vigilance Perch]|h',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130345,'I want to make a plate belt.\n|TINTERFACE\\ICONS\\INV_Plate_DraenorCrafted_D_01Buckle.blp:32|t\n|Hitem:146667:0:0:0:0:0:0:0:110:0|h[Rethu\'s Incessant Courage]|h','I want to make a plate belt.\n|TINTERFACE\\ICONS\\INV_Plate_DraenorCrafted_D_01Buckle.blp:32|t\n|Hitem:146667:0:0:0:0:0:0:0:110:0|h[Rethu\'s Incessant Courage]|h',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130346,'Are you certain this is what you want to make? You can only choose one legendary item to craft with this Armorcrafter\'s Commendation.','Are you certain this is what you want to make? You can only choose one legendary item to craft with this Armorcrafter\'s Commendation.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130347,'Ha ha! Stupid frozen ogre.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130348,'Ogre popsicle! Ha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130349,'Me LOVE this cold backpack! Ha ha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130350,'You there! Won\'t you help us testing flying in the Broken Isles?\n\nTo sweeten the deal, I\'ll also grant you your class mount quest!\n\nWhat do you say?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130351,'Yes! Grant me Broken Isles Pathfinder I and II and my class mount finale!','Yes! Grant me Broken Isles Pathfinder I and II and my class mount finale!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130354,'|TInterface\\Icons\\SPELL_WARLOCK_SOULBURN:20|t%s targets you with |cFFFF0000|Hspell:236011|h[Tormented Cries]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(130355,'|TInterface\\Icons\\spell_hunter_lonewolf:20|t %s begins to cast |cFFFF0404|Hspell:241772|h[Unearthly Howl]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130356,'','Prophet!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130357,'','You are not safe here. We need to move. Now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130358,'Alleria?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130359,'','Forgive me, Velen. I will explain when there is time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130360,'LEGION ASSASSINS HAVE BEEN KILLED. YOU ARE SAFE... FOR NOW.','LEGION ASSASSINS HAVE BEEN KILLED. YOU ARE SAFE... FOR NOW.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130362,'|TINTERFACE\\ICONS\\SPELL_FIRE_FELPYROBLAST.blp:20|t The Fallen Avatar casts |cFFFF0404|Hspell:234418|h[Rain of the Destroyer]|h|r!','|TINTERFACE\\ICONS\\SPELL_FIRE_FELPYROBLAST.blp:20|t The Fallen Avatar casts |cFFFF0404|Hspell:234418|h[Rain of the Destroyer]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(130367,'The Broken Shore is a shattered, desolate land. I now realize how necessary it was for me to see this for myself.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(130368,'You... will not... break us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130369,'This pain... is only temporary.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130370,'Our will... cannot be shattered.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130371,'Krona ki cristorr!','',0,0,0,0,0,0,0,0,0,0,86588,0,26124),
(130373,'Pheta vi hylas.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(130374,'%s writhes in pain.','%s writhes in pain.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130375,'%s struggles as pain wracks their body.','%s struggles as pain wracks their body.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130376,'The Broken Shore.','The Broken Shore.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130377,'Too late! I already took the good stuff!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130378,'You again? You can\'t have my treasure!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130379,'Haha! Too late, mortal!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130380,'Argh! What\'s in the box?! What was in it?!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130390,'I... I can\'t find my body. I was trapped inside the soul engine and now... where is it? What happened to me?!','I... I can\'t find my body. I was trapped inside the soul engine and now... where is it? What happened to me?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130391,'Where am I? I was fighting on the Broken Shore... can you hear me? By the gods... am I... dead?','Where am I? I was fighitng on the Broken Shore... can you hear me? By the gods... am I... dead?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130392,'No, I can\'t be dead! I have a family... I can\'t leave them behind! How will they survive without me?','No, I can\'t be dead! I have a family... I can\'t leave them behind! How will they survive without me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130393,'Find your way into the Light, my friend. The time has come for you to rest.','Find your way into the Light, my friend. The time has come for you to rest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130394,'Do you have any rare demonic trinkets in that sack?','Do you have any rare demonic trinkets in that sack?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130395,'Nothing right now.','Nothing right now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130396,'Have you tracked down any rare finds?','Have you tracked down any rare finds?',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(130397,'|TInterface\\Icons\\Ability_Socererking_arcanemines:20|t%s creates a |cFFFF0000|Hspell:235059|h[Rupturing Singularity]|h|r!','|TInterface\\Icons\\Ability_Socererking_arcanemines:20|t%s creates a |cFFFF0000|Hspell:235059|h[Rupturing Singularity]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130398,'|TInterface\\Icons\\SPELL_FIRE_FELRAINOFFIRE:20|t%s is casting |cFFFF0000|Hspell:240910|h[Armageddon]|h|r!','|TInterface\\Icons\\SPELL_FIRE_FELRAINOFFIRE:20|t%s is casting |cFFFF0000|Hspell:240910|h[Armageddon]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130399,'|TInterface\\ICONS\\INV_Artifact_PoweroftheDarkSide.blp:20|t The Fallen Avatar summons forth |cFFFF0404|Hspell:242017|h[Black Winds]|h|r!','|TInterface\\ICONS\\INV_Artifact_PoweroftheDarkSide.blp:20|t The Fallen Avatar summons forth |cFFFF0404|Hspell:242017|h[Black Winds]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(130400,'Treasure Master Iks\'reeged makes a rude gesture at you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130401,'Have you risen any interesting creatures recently?','Have you risen any interesting creatures recently?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130402,'I\'ve dreamt of this moment for so long, but not once did I imagine it being so... beautiful.','I\'ve dreamt of this moment for so long, but not once did I imagine it being so... beautiful.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130403,'At last the time has come! The final journey is upon us!','At last the time has come! The final journey is upon us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130404,'Open your arms and embrace what lies before you!','Open your arms and embrace what lies before you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130405,'Look to the skies! A great destiny is revealed before us!','Look to the skies! A great destiny is revealed before us!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130406,'A great truth reveals itself!','A great truth reveals itself!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130408,'Material goods cannot save you, $n!','Material goods cannot save you, $n!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(130409,'Possessions are meaningless! Look to the sky! The end is upon us!','Possessions are meaningless! Look to the sky! The end is upon us!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(130410,'This place offers only empty promises! Wealth cannot save you!','This place offers only empty promises! Wealth cannot save you!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(130411,'Open your eyes, $n! Only lies await you inside. The truth is in the skies!','Open your eyes, $n! Only lies await you inside. The truth is in the skies!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(130412,'Marvel at its glory! You cannot hide from the inevitable!','Marvel at its glory! You cannot hide from the inevitable!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130413,'We strike this beast down together.','',0,0,0,0,0,0,1,0,0,0,86135,0,26124),
(130414,'','Welcome to the Trial of Style: Azeroth\'s finest fashion destination!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130415,'','Hurry, High Inquisitor! The enemy is upon us!',0,0,0,0,0,0,22,0,0,0,0,86790,26124),
(130416,'I hope you brought your wardrobe with you, because today\'s competition looks FIERCE!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130417,'','The theme of today\'s competition is... Summer Styles!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130418,'Ooh, I do love a good pair of shorts.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130419,'','Take the next few moments to prepare your costume.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130420,'','We\'ve also provided barber chairs, in case you need to touch up your hairdo.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130421,'The competition starts in two minutes. Good luck, good-looking!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130422,'','$ct, the Felskorn alchemists in this area have been getting more aggressive of late. They recently stole a shipment of our brew. Worse, it appears that they have modified it to enhance themselves and are now spewing it from their spreaders!\n\nThey need to be stopped, but it will not be easy without help. Fortunately the Monkey King loaned us his vaulting staff. Use it to jump over their heads and rain death from above!\n\nWill you help?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130423,'I\'m ready!','I\'m ready!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130424,'|TInterface\\Icons\\ABILITY_WARLOCK_INFERNO.BLP:20|t%s has targeted you with |cFFFF0000|Hspell:238430|h[Bursting Dreadflame]|h|r!','|TInterface\\Icons\\ABILITY_WARLOCK_INFERNO:20|t%s has targeted you with |cFFFF0000|Hspell:238430|h[Bursting Dreadflame]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130425,'','The Burning Legion closes in on Azeroth. We must all do our part!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130426,'Please... never forget us. Never forget our sacrifice...','Please... never forget us. Never forget our sacrifice...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130427,'Thank you. I will never forget this kindness...','Thank you. I will never forget this kindness...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130428,'At last, this nightmare is at an end...','At last, this nightmare is at an end...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130429,'It was an honor to serve my king...','It was an honor to serve my king...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130430,'I can see it... I can see the Light... thank you.','I can see it... I can see the Light... thank you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130431,'','To your left, the fabulous $n!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130432,'It was an honor to serve Stormwind... to serve my king!','It was an honor to serve Stormwind... to serve my king!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130433,'Thank you for this kindness. I will never forget you...','Thank you for this kindness. I will never forget you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130434,'And on the right, the inimitable $n!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130435,'','Our third place finisher is... $n! Congratulations, $n!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130436,'In second place, we have... $n! You looked fabulous up there!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130437,'','And finally, our grand transmog champion of the evening. Let\'s hear it for $n!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130438,'','Everybody else, keep trying. You\'ll be a champion soon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130439,'','That\'s all for today. See you next time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130440,'What happened to me? Where is my body?','What happened to me? Where is my body?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130441,'I don\'t want to die...','I don\'t want to die...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130442,'Where am I? I can\'t remember where I am...','Where am I? I can\'t remember where I am...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130443,'Please... make the nightmare stop!','Please... make the nightmare stop!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130444,'I can\'t be dead... someone please help me...','I can\'t be dead... someone please help me...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130445,'If I\'m dead, who will take care of my family?','If I\'m dead, who will take care of my family?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130446,'Come on, let me fight too!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130447,'','Oro Junior, stay back there! Your father would be heartbroken if anything were to happen to you.',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(130448,'But mom, you\'re letting Mycah fight!','',0,0,0,0,0,0,603,0,0,0,0,0,26124),
(130449,'Don\'t worry little bro, if we get through this then when you\'re older I\'ll teach you how to swing a knife like dad taught me. Deal?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130450,'Deal! You better not forget!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130452,'','The theme of today\'s competition is... Winter Wear!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130453,'','The theme of today\'s competition is... Ready for Battle!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130454,'','The theme of today\'s competition is... Fun and Flirty!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130455,'','The theme of today\'s competition is... Mismatched Mayhem!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130456,'','The theme of today\'s competition is... Fire and Ice!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130457,'','The theme of today\'s competition is... Dark and Deadly!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130458,'','The theme of today\'s competition is... Faction Pride!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130459,'','The theme of today\'s competition is... Primal Style!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130460,'','The theme of today\'s competition is... Heroes of Azeroth!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130461,'','The theme of today\'s competition is... Make Me Laugh!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130462,'','The theme of today\'s competition is... Tabard Time!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130463,'','The theme of today\'s competition is... Everyday Heroes!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130464,'','The theme of today\'s competition is... Epic Purples!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130465,'','The theme of today\'s competition is... Champions of the Light!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130466,'','The theme of today\'s competition is... Freestyle!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130467,'Bundle up! Let\'s see what you wear on the frozen shores of Northrend!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130468,'Take off that makeup and put on that war paint!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130469,'Be still my heart! Don\'t be afraid to show a little skin!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130470,'Have a little fun and put together the most garish ensemble you can dream up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130471,'Frighten the fashion out of us with your creepiest costumes. Oooh... I\'m getting chills already!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130472,'Show us your more sinister styles!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130473,'For the Horde! For the Alliance! Let\'s see your team colors.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130474,'Pandarian fashion just SCREAMS harmoniousness. Show us your inner peace!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130475,'Show us your sparkles with your most wizardly wear! And don\'t forget the enchantments!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130476,'It\'s time to have fun and get a little crazy with your costumes!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130477,'Will you represent Theramore? The Kirin Tor? Talk to Nellie if you need a spare tabard!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130478,'Will you be a farmer? A chef? A scientist? A pirate? Ooh... I can\'t WAIT to see what they come up with!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130479,'As you know, epic armor is ALWAYS purple. Wrap yourselves up in the bottom of the rainbow!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130480,'Pristine white robes and glimmering armor are the order of the day!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130481,'That\'s right... today\'s contest has no theme. Wear whatever you want!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130482,'Over here, $p. Keep your head down.','',0,0,0,0,0,0,0,0,0,0,86134,0,26124),
(130483,'Insolent mortal! Come... face your death!','',0,0,0,0,0,0,0,0,0,0,86202,0,26124),
(130496,'I will feast upon your soul.','',0,0,0,0,0,0,0,0,0,0,86162,0,26124),
(130497,'Crunchy bones. So brittle and tasty!','',0,0,0,0,0,0,0,0,0,0,86163,0,26124),
(130498,'Your supple flesh will satisfy my hunger!','',0,0,0,0,0,0,0,0,0,0,86164,0,26124),
(130499,'Feeble and weak! You dare enter our lair?','',0,0,0,0,0,0,0,0,0,0,86165,0,26124),
(130500,'You will kneel or you will die!','',0,0,0,0,0,0,0,0,0,0,86166,0,26124),
(130501,'Our chains hunger for your flesh!','',0,0,0,0,0,0,0,0,0,0,86167,0,26124),
(130502,'Your flesh will fuel these pits for eternity!','',0,0,0,0,0,0,0,0,0,0,86168,0,26124),
(130503,'More flesh for the taking!','',0,0,0,0,0,0,0,0,0,0,86169,0,26124),
(130504,'Whatever happens, we stand together.','',0,0,0,0,0,0,0,0,0,0,86121,0,26124),
(130505,'Why can\'t I research Artifact Knowledge?','Why can\'t I research Artifact Knowledge?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130506,'The Orders are sharing their resources, and you are no longer required to research Artifact Knowledge. We will gain further Knowledge each week.','The Orders are sharing their resources, and you are no longer required to research Artifact Knowledge. We will gain further Knowledge each week.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130507,'We have reached the maximum Artifact Knowledge available to us at this time.','We have reached the maximum Artifact Knowledge available to us at this time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130508,'Archmage Khadgar has a lead on how we can continue our artifact knowledge research. Seek him out at Deliverance Point on the Broken Shore.','Archmage Khadgar has a lead on how we can continue our artifact knowledge research. Seek him out at Deliverance Point on the Broken Shore.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130509,'I have all the tools necessary to adjust the appearance of your weapons and armor.\n\nShall we begin?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130510,'I want to transmogrify my gear.','I want to transmogrify my gear.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130511,'We can currently obtain Artifact Knowledge for you as quickly as you can bring me the resources required to produce them.','We can currently obtain Artifact Knowledge for you as quickly as you can bring me the resources required to produce them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130512,'I want to participate in the Trial of Style!','I want to participate in the Trial of Style!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130513,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,84379,84379,26124),
(130514,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,84354,0,26124),
(130515,'','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,0,84611,26124),
(130516,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,84390,0,26124),
(130517,'','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,0,84606,26124),
(130518,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,84598,84598,26124),
(130519,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,84601,84601,26124),
(130520,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,84614,84614,26124),
(130521,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,84597,84597,26124),
(130522,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,84609,84609,26124),
(130523,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,84596,0,26124),
(130524,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,84356,84356,26124),
(130525,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,84380,0,26124),
(130526,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,84612,84612,26124),
(130527,'We have reached the maximum Artifact Knowledge available to us at this time.','We have reached the maximum Artifact Knowledge available to us at this time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130528,'Archmage Khadgar has a lead on how we can continue our artifact knowledge research. Seek him out at Deliverance Point on the Broken Shore.','Archmage Khadgar has a lead on how we can continue our artifact knowledge research. Seek him out at Deliverance Point on the Broken Shore.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130529,'We can currently obtain Artifact Knowledge for you as quickly as you can bring me the resources required to produce them.','We can currently obtain Artifact Knowledge for you as quickly as you can bring me the resources required to produce them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130530,'The Orders are sharing their resources, and you are no longer required to research Artifact Knowledge. We will gain further Knowledge each week.','The Orders are sharing their resources, and you are no longer required to research Artifact Knowledge. We will gain further Knowledge each week.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130531,'','Your invasion of Argus will fail! High Inquisitor Raalgar will see to that.',0,0,0,0,0,0,0,0,0,0,0,86772,26124),
(130532,'DO NOT RECORD','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130533,'I can close my eyes to the atrocities of war no longer. I must see the threat of the Burning Legion for myself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130534,'<Link the Vindicaar to the Light\'s Judgment weapon.>','<Link the Vindicaar to the Light\'s Judgment weapon.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130535,'The crystal launcher pulses with a subtle energy emanating from deep within the Vindicaar.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130536,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130540,'Our fight against the Burning Legion continues.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130541,'I am ready, High Exarch.','I am ready, High Exarch.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130543,'When you are ready. We have much to discuss.','',0,0,0,0,0,0,1,0,4,0,86335,0,26124),
(130546,'But the Light never abandoned us. It called you here and gave us another chance at victory. What we do with that chance... that is up to us.','',0,0,0,0,0,0,1,0,4,0,86334,0,26124),
(130547,'$n lets out half a roar.','$n lets out half a roar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130548,'$n lets out half a squawk.','$n lets out half a squawk.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130549,'$n lets out half a growl.','$n lets out half a growl.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130550,'$n lets out half a cacaw.','$n lets out half a cacaw.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130551,'This ridgeline will guide you to the pits. Stay low. We\'ll regroup shortly.','',0,0,0,0,0,0,0,0,0,0,86203,0,26124),
(130554,'Krokul will now respond to your Flight Master\'s Whistle while on Argus.','Krokul will now respond to your Flight Master\'s Whistle while on Argus.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130555,'So you wanna know everything there is to know about Argus so you can defeat the Legion once and for all?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130556,'PH','PH',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130557,'PH','PH',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130558,'PH','PH',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130559,'PH','PH',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130567,'|TInterface\\Icons\\SPELL_FEL_ELEMENTALDEVASTATION.BLP:20|tYou were stunned by |cFFFF0000|Hspell:237903|h[Fel Surge]|h|r! Destroy the totem before it finishes its cast!','|TInterface\\Icons\\SPELL_FEL_ELEMENTALDEVASTATION.BLP:20|tYou were stunned by |cFFFF0000|Hspell:237903|h[Fel Surge]|h|r! Destroy the totem before it finishes its cast!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130568,'','Your efforts have meant nothing, $p!',0,0,0,0,0,0,0,0,0,0,0,86771,26124),
(130570,'As the portal closes, a sealed door opens further into the Arcatraz.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130576,'|TInterface\\Icons\\CREATUREPORTRAIT_INFERNAL_BALL_02.BLP:20|t%s is casting |cFFFF0000|Hspell:238588|h[Rain of Brimstone]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(130577,'Examining...','Examining...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130579,'Look to the heavens above. See the million points of brilliance in the great dark beyond.','',0,0,0,0,0,0,0,0,0,0,87607,0,26124),
(130580,'Know you are not alone. Our salvation is out there, somewhere.','',0,0,0,0,0,0,0,0,0,0,87608,0,26124),
(130581,'You must hold fast to your resolve. Temptation weakens the mind and spirit.','',0,0,0,0,0,0,0,0,0,0,87609,0,26124),
(130582,'Look inside yourself and see the strength your vigil has cultivated.','',0,0,0,0,0,0,0,0,0,0,87610,0,26124),
(130584,'|TInterface\\Icons\\Ability_Earthen_Pillar.blp:20|t%s loses a Hardened |cFFFF0000|Hspell:238473|h[Fel Scale]|h|r from colliding with a stalactite!','',0,0,0,0,0,0,0,0,17,0,0,0,26124),
(130585,'|TInterface\\Icons\\spell_shaman_earthquake:20|t%s readies itself to charge!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130586,'|TInterface\\Icons\\inv_qiraj_skinsandworm:20|t%s burrows, the earth  |cFFFF0000|Hspell:238473|h[Hardens]|h|r its scales!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130589,'Baby, baby, baby! This is the illest, realest, deadest band you\'ve ever seen! They will melt your face, figuratively and literally! Before I met these guys, I was alive and had all my skin! Now I\'m dead and filthy rich!\n\nCatch Blight Boar here, every hour on the half hour!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130590,'','|TInterface\\Icons\\SPELL_ARCANE_INVOCATION.BLP:20|tYou are afflicted by |cFFFF0000|Hspell:236712|h[Lunar Beacon]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(130591,'','|TInterface\\Icons\\Ability_IronMaidens_ConvulsiveShadows.blp:20|t%s targets you with |cFFFF0000|Hspell:236603|h[Rapid Shot]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130598,'','PH',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130599,'Can you hear them? Chewing, gnashing, wailing...$b$b<Arkhaan shudders.>$b$bIsolon is lost.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130600,'We should keep going.','We should keep going.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130601,'Pheta thones gamera.','',0,0,0,0,0,0,0,0,0,0,86583,0,26124),
(130602,'We must not give in.','',0,0,0,0,0,0,0,0,0,0,86584,0,26124),
(130603,'Pheta vi acahachi!','',0,0,0,0,0,0,0,0,0,0,86585,0,26124),
(130604,'Our day will come.','',0,0,0,0,0,0,0,0,0,0,86586,0,26124),
(130605,'','|TInterface\\Icons\\SPELL_NATURE_MOONGLOW.BLP:20|tYou are affected by |cFFFF0000|Hspell:236519|h[Moon Burn]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(130606,'Be at peace.','',0,0,0,0,0,0,0,0,0,0,86587,0,26124),
(130607,'This way. Arkhaan has a plan.','',0,0,0,0,0,0,0,0,0,0,87622,0,26124),
(130608,'','Could you elaborate? Even a little?',0,0,0,0,0,0,0,0,0,0,0,87514,26124),
(130609,'','Perhaps with some idea of what you hope to achieve...',0,0,0,0,0,0,0,0,0,0,0,87515,26124),
(130610,'We will stop the whispers. Pointy-ears should know.','',0,0,0,0,0,0,0,0,0,0,87623,0,26124),
(130611,'','I must confess, Arkhaan, that does not put me at ease.',0,0,0,0,0,0,0,0,0,0,0,87516,26124),
(130612,'','|TInterface\\Icons\\artifactability_BalanceDruid_FullMoon.blp:20|t |cFFFF0000|Hspell:236357|h[Font of Elune]|h|r has reached full moon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(130613,'','|TInterface\\Icons\\artifactability_BalanceDruid_NewMoon.blp:20|t |cFFFF0000|Hspell:236357|h[Font of Elune]|h|r has reached new moon.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(130614,'','Are all these creatures...',0,0,0,0,0,0,0,0,0,0,0,87517,26124),
(130615,'My people. Once.','',0,0,0,0,0,0,0,0,0,0,87596,0,26124),
(130616,'','How is it you do not share their fate?',0,0,0,0,0,0,0,0,0,0,0,87518,26124),
(130617,'Arkhaan forgets.','',0,0,0,0,0,0,0,0,0,0,87624,0,26124),
(130618,'We still hear their prayers. Rest, brothers. Rest.','',0,0,0,0,0,0,0,0,0,0,87625,0,26124),
(130619,'','At least their suffering is over.',0,0,0,0,0,0,0,0,0,0,0,87519,26124),
(130620,'','Where are these things coming from?',0,0,0,0,0,0,0,0,0,0,0,87520,26124),
(130621,'They want Arkhaan. He promised to save them.','',0,0,0,0,0,0,0,0,0,0,87626,0,26124),
(130622,'Arkhaan remembers. Isolon calls to us! Isolon will look to the stars again!','',0,0,0,0,0,0,0,0,0,0,87627,0,26124),
(130623,'','That is not Isolon calling to you! Wait!',0,0,0,0,0,0,0,0,0,0,0,87521,26124),
(130624,'','He is still here. He crossed over into the Void. We may still be able to save him if we hurry.',0,0,0,0,0,0,0,0,0,0,0,87522,26124),
(130626,'The assortment of valuable things that you adventurers leave behind in your wake is simply astonishing.\n\nAnd profitable.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130627,'Let me satisfy your curiosity.','',0,0,0,0,0,0,0,0,0,0,87098,0,26124),
(130628,'Show us, please... please...','',0,0,0,0,0,0,0,0,0,0,87605,0,26124),
(130629,'Whispers... too... loud! Aaargghhh!','',0,0,0,0,0,0,0,0,0,0,87606,0,26124),
(130630,'','Go. I am right behind you.',0,0,0,0,0,0,0,0,0,0,0,87503,26124),
(130631,'Or you could come see a GOOD band! The Blight Boar concert will begin in thirty minutes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(130632,'If you\'re interested in gettin\' down, the Blight Boar concert starts in twenty!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(130633,'Blight Boar is playing their underground show on the east side of the island! Your headliner Blight Boar goes on in ten minutes!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(130634,'I see you\'ve met the viceroy.','',0,0,0,0,0,0,0,0,0,0,87837,0,26124),
(130635,'','What are your people doing here?',0,0,0,0,0,0,0,0,0,0,0,87512,26124),
(130636,'I am here to find out. Follow, if you can.','',0,0,0,0,0,0,0,0,0,0,87838,0,26124),
(130637,'','Wait!',0,0,0,0,0,0,0,0,0,0,0,87513,26124),
(130639,'Gul\'dan has been vanquished, but his master Kil\'jaeden poses an even greater threat.\n\nThe Deceiver will stop at nothing to destroy our world. We must make any sacrifice necessary to end his reign.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130640,'My rockin\' and rollin\' beauties! You\'re in the right place to melt your face! Allow me to humbly introduce... Blight Booooar!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(130641,'In times such as these, our beliefs are tested. We may be tempted to surrender to an evil that can seem overwhelming... and unstoppable.\n\nBut we must not lose faith in the Light. It will guide us to victory.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130642,'','I will never trust the Betrayer or his Illidari lackeys, but I am willing to set aside my misgivings for the sake of the greater good.\n\nBut once the Legion falls, what use will we have for those tainted by its corruption?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130643,'In times of war, supplies are short.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130644,'','I realize this isn\'t much of an inn, but it\'s what we have.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130645,'Can I interest you in a beverage or two?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130646,'Welcome, $ct. I have been appointed to distribute these items of interest to your armies and yourself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130647,'','$ct, see something you like?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130654,'The Sentinax recalls its portals and begins recharging.','The Sentinax recalls its portals and begins recharging.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130655,'The Sentinax has finished recharging.','The Sentinax has finished recharging.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130659,'<You feel like Manapoof is silently judging you.>','<You feel like Manapoof is silently judging you.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130660,'Would you please send me to the Wailing Caverns?','Would you please send me to the Wailing Caverns?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130661,'When the ship from Azeroth arrived, I sensed his presence. I would know it anywhere, even after all the years we\'ve spent apart.','',0,0,0,0,0,0,1,0,0,0,86133,0,26124),
(130662,'','Arator! He\'s here!',0,0,0,0,0,0,5,0,0,0,0,86139,26124),
(130663,'Thank you, stranger. I almost met my final death! Please, take these items from my grave as your reward.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(130664,'I admit I am intrigued by the vision of Aegwynn that you encountered in the Cathedral. There is so much I could learn from the mother of my mentor Medivh, even if this manifestation is but an echo of the Guardian she was.\n\nI will continue to study her writings. They may offer insights into what awaits us in the depths of the Tomb of Sargeras.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130665,'The Cathedral is ours, but the Tomb\'s depths remain in the hands of the Deceiver and his foul minions.\n\nBuild up your forces, $ct. The true battle awaits us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130666,'','My wardens hold the Cathedral, but it will all be for naught if Kil\'jaeden awakens his master\'s fallen avatar in the depths of the Tomb.\n\nIt seems Illidan and his followers are still needed... for now.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130667,'Kil\'jaeden hounded my people across the stars, and now does the bidding of his dark master in the depths of the Tomb.\n\nWe will make him pay for his crimes. At long last, the Deceiver will fall!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130668,'Completing Construction','Completing Construction',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(130688,'','This way.',0,0,0,0,0,0,0,0,0,0,0,87530,26124),
(130689,'I have something I want to show you, but we mustn\'t be seen. Follow.','',0,0,0,0,0,0,0,0,0,0,87821,0,26124),
(130690,'','Explain yourself first.',0,0,0,0,0,0,0,0,0,0,0,87531,26124),
(130691,'Such impatience. I believe you will find the answers you seek on the other side.','',0,0,0,0,0,0,0,0,0,0,87848,0,26124),
(130697,'How industriously they work. A pity they will be overtaken.','',0,0,0,0,0,0,0,0,0,0,87822,0,26124),
(130698,'','I sense a little disappointment. Was I really your best student?',0,0,0,0,0,0,0,0,0,0,0,87532,26124),
(130699,'I had hoped to find at least one promising soul on this rock.','',0,0,0,0,0,0,0,0,0,0,87823,0,26124),
(130700,'','I have not turned away from that path. You know why I resisted.',0,0,0,0,0,0,0,0,0,0,0,87533,26124),
(130701,'','I need to finish what I started, Locus-Walker.',0,0,0,0,0,0,0,0,0,0,0,87534,26124),
(130702,'Can you, though? With your... attachments?','',0,0,0,0,0,0,0,0,0,0,87849,0,26124),
(130703,'They smashed Thrashbite!? Run!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130739,'The Aegis will be ours!','The Aegis will be ours!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130740,'You will fall to the Legion!','You will fall to the Legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130741,'You will burn!','You will burn!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130742,'The cathedral is ours!','The cathedral is ours!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130743,'Your relics cannot save you now!','Your relics cannot save you now!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130767,'','Let\'s get the Forsaken up here on the stage!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(130768,'','Time for the Forsaken to dance. Their moves will take your breath away.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(130769,'','Come on up, trolls! Show everyone else how it\'s done!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(130770,'','Time for a troll dance!  Shoes can\'t hold these feet!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(130771,'','Watch your feet! It\'s tauren dance time, and those hooves can hurt.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(130772,'','Come on up, tauren! Show us how they do it in Mulgore.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(130773,'','Let\'s get those goblins up on the stage so everyone can see them!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(130774,'','Let me see those goblin moves!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(130775,'','Feast your eyes on the beautiful moves of the blood elves!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(130776,'','Blood elves! Your turn to dance.',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(130777,'','I love watching those pandaren throw their weight around. Time to dance!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(130778,'','Come on up, pandaren!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(130779,'','Rise up, sister and brother orcs! Let\'s see your moves!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130780,'','This is our city, orcs. Let\'s show them our pride!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130783,'','I can\'t believe they took over the entire building just for a dance party! Where am I going to sell all these pants now?',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(130784,'You do know Orgrimmar has another auction house, don\'t you?','You do know Orgrimmar has another auction house, don\'t you?',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(130785,'','Oh. Right.',0,0,0,0,0,0,24,0,0,0,0,0,26124),
(130787,'<Travel to the Arcatraz.>','<Travel to the Arcatraz.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130791,'|TInterface\\Icons\\ability_fixated_state_purple:20|t%s |cFFFF0404|Hspell:238674|h[Fixates]|h|r on you!','|TInterface\\Icons\\ability_fixated_state_purple:20|t%s |cFFFF0404|Hspell:238674|h[Fixates]|h|r on you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130798,'I need a cache key. |cFF9400D3[100 Nethershards]|r','I need a cache key. |cFF9400D3[100 Nethershards]|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130799,'REUSE ME','REUSE ME',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130800,'REUSE ME','$p, we salute you. Return to the Exodar and let us cover your escape.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130802,'','Attack, my pretties!',0,0,0,0,0,0,0,0,0,0,0,85037,26124),
(130805,'|TInterface\\Icons\\ABILITY_MAGE_FIRESTARTER:20|t%s has targeted |cFFFF0000$n|r with |cFFFF0000|Hspell:238502|h[Focused Dreadflame]|h|r!','|TInterface\\Icons\\ABILITY_MAGE_FIRESTARTER:20|t%s has targeted |cFFFF0000$n|r with |cFFFF0000|Hspell:238502|h[Focused Dreadflame]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130806,'|TInterface\\Icons\\ABILITY_WARLOCK_SOULSWAP.BLP:20|t Turn away from Gazerax\'s |cFFFF0000|Hspell:239217|h[Blinding Glare]|h|r!','|TInterface\\Icons\\ABILITY_WARLOCK_SOULSWAP.BLP:20|t Turn away from Gazerax\'s |cFFFF0000|Hspell:239217|h[Blinding Glare]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(130807,'','I don\'t care what horrors lie on Argus. If there is even a chance we find Alleria there, I am with you.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(130808,'I\'m ready.','I\'m ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130809,'The Legion ship is preparing to retreat! Get off the ship immediately!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130810,'I have Nethershards, are you willing to trade?','I have Nethershards, are you willing to trade?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130814,'At long last the vessel that will usher us to Argus is complete.','',0,0,0,0,0,0,0,0,0,0,87944,0,26124),
(130815,'Make way to Stormwind Harbor at once. The time has come to bring an end to this war.','',0,0,0,0,0,0,0,0,0,0,87945,0,26124),
(130816,'Make way to Bladefist Bay at once. The time has come to bring an end to this war.','',0,0,0,0,0,0,0,0,0,0,87946,0,26124),
(130820,'High Inquisitor Raalgar was imprisoned deep inside the Arcatraz. The Legion is already here, so be careful!','',0,0,0,0,0,0,0,0,0,0,87661,0,26124),
(130821,'The Legion is still only moments ahead of us. Take the portal back here and I will figure out where the Inquisitor has gone!','',0,0,0,0,0,0,0,0,0,0,87662,0,26124),
(130823,'We will take this down to the surface. Be on your guard.','',0,0,0,0,0,0,1,0,0,0,87947,0,26124),
(130824,'Come. I need to see it for myself.','',0,0,0,0,0,0,397,0,0,0,87948,0,26124),
(130825,'That\'s it! Her thoughts be clearin\' up. She\'s feelin\'... fear. Watch out!','',0,0,0,0,0,0,0,0,0,0,85238,0,26124),
(130826,'','We will soon see if the Horde heeds Velen\'s call. Those savages lack any sense of honor, but they do know how to fight.',0,0,0,0,0,0,0,0,0,0,0,87088,26124),
(130830,'|TInterface\\Icons\\Spell_Deathknight_Defile:20|tWith no souls in the Spirit Realm, Soul Queen Dejahna lashes out with |cFFFF0000|Hspell:236507|h[Quietus]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(130831,'','|TInterface\\Icons\\Spell_Deathknight_Defile:20|tWith no souls in the Corporeal Realm, the Engine of Souls lashes out with |cFFFF0000|Hspell:236507|h[Quietus]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(130832,'Sargeras cannot be denied!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130833,'This will be the last gift you reject!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130834,'Suffer your folly!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130835,'You flee to the abyss, coward!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130836,'Yes! Flee! Flee!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130837,'Embrace Sargeras!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130847,'You... will never... escape...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130848,'There is nowhere to run.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130849,'Argus will... rise...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130850,'Why is it... dark?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130851,'The Eredar... reign...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130852,'Run... while you can.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130856,'We must find the Army of the Light. With them fighting alongside us, the Legion will fall. We must find...','',0,0,0,0,0,0,1,0,0,0,86878,0,26124),
(130857,'You left us here to die!','You left us here to die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130858,'I waited... so long... for peace.','I waited... so long... for peace.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130859,'Light damn you, Prophet!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130860,'The torment is over... at long last.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130861,'We waited! We waited but the Light never returned!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130862,'Our wait is over! Vengeance against the Prophet!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130863,'All is... forgiven...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130864,'He could not... have known...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130870,'Succumb! It is the only way!','',0,0,0,0,0,0,0,0,0,0,87099,0,26124),
(130871,'The great darkness knows all!','',0,0,0,0,0,0,0,0,0,0,87100,0,26124),
(130872,'Such power... I will show you!','',0,0,0,0,0,0,0,0,0,0,87101,0,26124),
(130873,'It calls to us. Listen, listen!','',0,0,0,0,0,0,0,0,0,0,87102,0,26124),
(130874,'All that is must be undone!','',0,0,0,0,0,0,0,0,0,0,87103,0,26124),
(130875,'Darkness commands me. Heed its call!','',0,0,0,0,0,0,0,0,0,0,87104,0,26124),
(130876,'Quiet... quiet!','',0,0,0,0,0,0,0,0,0,0,87105,0,26124),
(130877,'Make it stop!','',0,0,0,0,0,0,0,0,0,0,87106,0,26124),
(130878,'Please, just leave me alone!','',0,0,0,0,0,0,0,0,0,0,87107,0,26124),
(130879,'Light, help me...','',0,0,0,0,0,0,0,0,0,0,87108,0,26124),
(130880,'No... No!','',0,0,0,0,0,0,0,0,0,0,87109,0,26124),
(130881,'Make the whispers end!','',0,0,0,0,0,0,0,0,0,0,87110,0,26124),
(130882,'The Light... will fail.','',0,0,0,0,0,0,0,0,0,0,87111,0,26124),
(130883,'The darkness takes me.','',0,0,0,0,0,0,0,0,0,0,87112,0,26124),
(130884,'I rejoin the void!','',0,0,0,0,0,0,0,0,0,0,87113,0,26124),
(130885,'It all makes sense...','',0,0,0,0,0,0,0,0,0,0,87114,0,26124),
(130886,'Even the naaru will fall... as I have...','',0,0,0,0,0,0,0,0,0,0,87115,0,26124),
(130887,'Death embraces me.','',0,0,0,0,0,0,0,0,0,0,87116,0,26124),
(130888,'It is... over.','',0,0,0,0,0,0,0,0,0,0,87117,0,26124),
(130889,'The whispers are gone.','',0,0,0,0,0,0,0,0,0,0,87118,0,26124),
(130890,'Shadows fade.','',0,0,0,0,0,0,0,0,0,0,87119,0,26124),
(130891,'Naaru be praised. I am free.','',0,0,0,0,0,0,0,0,0,0,87120,0,26124),
(130892,'It was so dark.','',0,0,0,0,0,0,0,0,0,0,87121,0,26124),
(130893,'The Light forgives.','',0,0,0,0,0,0,0,0,0,0,87122,0,26124),
(130908,'Alleria and I will protect you.','Alleria and I will protect you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130909,'They will hunt us. The shadows know we resist them. Turn back, turn back!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130910,'Who calls to Arkhaan? Name yourself!','',0,0,0,0,0,0,0,0,0,0,87602,0,26124),
(130911,'Quiet, quiet! Arkhaan listens...','',0,0,0,0,0,0,0,0,0,0,87603,0,26124),
(130912,'Wait. There is... a voice.','',0,0,0,0,0,0,0,0,0,0,87604,0,26124),
(130961,'Arkhaan finally understands...','',0,0,0,0,0,0,0,0,0,0,87620,0,26124),
(130962,'What has Arkhaan... done?','',0,0,0,0,0,0,0,0,0,0,87621,0,26124),
(130963,'Fragile mortals. Bow before the might of the Burning Legion!','',0,0,0,0,0,0,396,0,0,0,82726,0,26124),
(130965,'Subject identified: ally of Speaker. Annihilation protocols suspended.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130966,'Subject vitals within normal parameters. The Speaker awaits you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(130971,'','What are you talking about?',0,0,0,0,0,0,0,0,0,0,0,87535,26124),
(130972,'Why, your mate of course. How does he feel about your choices?','',0,0,0,0,0,0,0,0,0,0,87852,0,26124),
(130973,'','Turalyon trusts me to make hard decisions, and I him.',0,0,0,0,0,0,0,0,0,0,0,87536,26124),
(130974,'I am not talking about trust.','',0,0,0,0,0,0,0,0,0,0,87853,0,26124),
(130975,'How can you expect to embrace the Shadow with the Light shining so brightly at your side?','',0,0,0,0,0,0,0,0,0,0,87854,0,26124),
(130976,'','Without the Light there is no Shadow, teacher.',0,0,0,0,0,0,0,0,0,0,0,87537,26124),
(130980,'Ahh... The shadow comes!','',0,0,0,0,0,0,0,0,0,0,86791,0,26124),
(130981,'Do you hear that? The whispers demand your death!','',0,0,0,0,0,0,0,0,0,0,86792,0,26124),
(130982,'The Void welcomes you!','',0,0,0,0,0,0,0,0,0,0,86793,0,26124),
(130983,'Your death pleases the Dark Masters!','',0,0,0,0,0,0,0,0,0,0,86794,0,26124),
(130984,'You are out of your depth, fleshling.','',0,0,0,0,0,0,0,0,0,0,86795,0,26124),
(130985,'Embrace the end of all things!','',0,0,0,0,0,0,0,0,0,0,86796,0,26124),
(130986,'','Succumb!',0,0,0,0,0,0,0,0,0,0,0,88414,26124),
(130987,'','The Dark Ones demand your end.',0,0,0,0,0,0,0,0,0,0,0,88415,26124),
(130988,'','You will know the Void!',0,0,0,0,0,0,0,0,0,0,0,88416,26124),
(130989,'','Embrace the Void.',0,0,0,0,0,0,0,0,0,0,0,88417,26124),
(130990,'','I see your soul, and it is black!',0,0,0,0,0,0,0,0,0,0,0,88418,26124),
(130991,'','None may resist the will of the shadow.',0,0,0,0,0,0,0,0,0,0,0,88419,26124),
(130992,'Understand... this changes... nothing.','',0,0,0,0,0,0,0,0,0,0,86797,0,26124),
(130993,'Oblivion... calls.','',0,0,0,0,0,0,0,0,0,0,86798,0,26124),
(130994,'I return to the Void.','',0,0,0,0,0,0,0,0,0,0,86799,0,26124),
(130995,'I come, Dark Masters.','',0,0,0,0,0,0,0,0,0,0,86800,0,26124),
(130996,'Their will be done.','',0,0,0,0,0,0,0,0,0,0,86801,0,26124),
(130997,'I serve the end of all things.','',0,0,0,0,0,0,0,0,0,0,86802,0,26124),
(130998,'At last.','',0,0,0,0,0,0,0,0,0,0,86803,0,26124),
(131001,'Well, Windrunner? What say you?','',0,0,0,0,0,0,0,0,0,0,87839,0,26124),
(131002,'','Show me the path. I am ready to walk it.',0,0,0,0,0,0,0,0,0,0,0,87494,26124),
(131003,'Right this way.','',0,0,0,0,0,0,0,0,0,0,87840,0,26124),
(131006,'All right, I got everythin\' set up on this end. Activate the power conduits and the pad\'ll be operational!','',0,0,0,0,0,0,0,0,0,0,85237,0,26124),
(131011,'Ah! Right on time, fleshling.','',0,0,0,0,0,0,0,0,0,0,87841,0,26124),
(131012,'Prepare yourself, Alleria. Your friend here will hold its attention.','',0,0,0,0,0,0,0,0,0,0,87842,0,26124),
(131013,'','That thing... it\'s... calling to me!',0,0,0,0,0,0,0,0,0,0,0,87495,26124),
(131014,'How do you feel?','',0,0,0,0,0,0,0,0,0,0,87843,0,26124),
(131015,'','My head is... swimming.',0,0,0,0,0,0,0,0,0,0,0,87523,26124),
(131016,'Remember... So long as your mind is your own, you command this power. It does not command you.','',0,0,0,0,0,0,0,0,0,0,87844,0,26124),
(131017,'Yes, this specimen will do.','',0,0,0,0,0,0,0,0,0,0,87845,0,26124),
(131018,'','How did you do it by yourself?',0,0,0,0,0,0,0,0,0,0,0,87524,26124),
(131019,'Ah, well. Perhaps I will tell you one day. Until then, I will be keeping an eye on your progress.','',0,0,0,0,0,0,0,0,0,0,87846,0,26124),
(131020,'Until then, I will be keeping an eye on your progress.','',0,0,0,0,0,0,0,0,0,0,87847,0,26124),
(131026,'','You should return to the Vindicaar and share what we have learned.',0,0,0,0,0,0,0,0,0,0,0,87525,26124),
(131027,'','My path takes me into the Seat of the Triumvirate... to whatever fate awaits me there.',0,0,0,0,0,0,0,0,0,0,0,87526,26124),
(131028,'','I am certain Velen will understand.',0,0,0,0,0,0,0,0,0,0,0,87527,26124),
(131031,'You do know the city has another auction house, don\'t you?','You do know the city has another auction house, don\'t you?',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(131034,'','This is your city, humans. Show us your pride!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(131035,'','I heard a rumor that humans can\'t dance. Prove me wrong!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(131036,'','Look at those dwarven feet move! And they can do it all without spilling their ale!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(131037,'','It\'s time for the dwarves to show us how they party!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(131038,'','Feast your eyes on the shapely, confident night elves! I might start panting soon...',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(131039,'','Night elves! Show us how you get down up in Teldrassil!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(131040,'','Let\'s get those gnomes up on the stage so everyone can see them!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(131041,'','Gnomes! Aren\'t they adorable?',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(131042,'','Let\'s get the draenei up here on stage!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(131043,'','Their dance moves are out of this world. Let\'s hear it for the draenei!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(131044,'','Come on up, worgen brothers and sisters! Let\'s show them how it\'s done!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(131045,'','Awwoooooo! Worgen, get down with your bad selves!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(131046,'','I love watching those pandaren throw their weight around. Time to dance!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(131047,'','Come on up, pandaren!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(131051,'','Looks like they showed up after all.',0,0,0,0,0,0,0,0,0,0,0,87087,26124),
(131052,'Stay strong, brothers and sisters. We must keep them at bay until the rest of our forces arrive. For Azeroth!','',0,0,0,0,0,0,0,0,0,0,87932,0,26124),
(131053,'','Your world is forfeit. The way to Argus is open. The endless legions of Sargeras descend upon you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131058,'Come, champion. Let the Light guide your path!','',0,0,0,0,0,0,0,0,0,0,87933,0,26124),
(131059,'The Legion grows desperate. We should strike now while their attention remains focused on Azeroth.','',0,0,0,0,0,0,1,0,0,0,88152,0,26124),
(131060,'','PH',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131061,'','How are you liking the form of the Lunarwing Owl, Archdruid?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131062,'I no longer wish to use the Lunarwing Owl form.','I no longer wish to use the Lunarwing Owl form.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131063,'I wish to use the Lunarwing Owl form.','I wish to use the Lunarwing Owl form.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131064,'','If you would like to return to using the traditional flight form, I can assist with that, Archdruid.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131066,'PH','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131067,'PH','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131068,'I... will... return...','',0,0,0,0,0,0,0,0,0,0,53377,0,26124),
(131069,'Break them!','',0,0,0,0,0,0,0,0,0,0,53359,0,26124),
(131070,'I will flay the flesh from your bones!','',0,0,0,0,0,0,0,0,0,0,53374,0,26124),
(131071,'The master will mend my flesh again and again. You have not won. You cannot win. We are endless! We are Legion!','',0,0,0,0,0,0,0,0,0,0,53376,0,26124),
(131072,'We cannot wait any longer, lest the way to Argus be reinforced.','',0,0,0,0,0,0,1,0,0,0,87766,0,26124),
(131073,'You are right, Illidan. This may be our best chance to gain the upper hand.','',0,0,0,0,0,0,0,0,0,0,87894,0,26124),
(131074,'We will not let this world fall to darkness.','',0,0,0,0,0,0,0,0,0,0,87895,0,26124),
(131075,'Divinius, ensure the safety of our people in my absence. It is time I paid a visit to our former home.','',0,0,0,0,0,0,0,0,0,0,87896,0,26124),
(131076,'We will join you in the Vault of Lights.','',0,0,0,0,0,0,396,0,0,0,87997,0,26124),
(131083,'Activating Conduit','Activating Conduit',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(131084,'Prophet Velen is just ahead, champions.','Prophet Velen is just ahead, champions.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131095,'Greetings.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131099,'Welcome to the Moonkin Festival!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131100,'Please, make yourself at home.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131116,'Where you been? There\'s more grog to drink!','Where you been? There\'s more grog to drink!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131117,'When you\'re a Bloodsail, every day is Pirates\' Day!','When you\'re a Bloodsail, every day is Pirates\' Day!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131118,'I\'m a mighty pirate!','I\'m a mighty pirate!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131119,'Welcome to the parrrty!','Welcome to the parrrty!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131120,'Dread Crew... More like Dead Crew, am I right?','Dread Crew... More like Dead Crew, am I right?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131121,'I love dancing!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131122,'Everybody dance... NOW!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131123,'Dance like nobody\'s watching!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131124,'Dance! Dance! Dance!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131125,'Can you feel the rhythm?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131126,'Move to the beat!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131136,'Ya ever seen the ocean burn?','You ever seen the ocean burn?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131137,'Booty Bay will burn!','Booty Bay will burn!',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(131138,'What do you know about lifting voodoo curses?','What do you know about lifting voodoo curses?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131139,'Booze is mana, if you\'re tough enough.','Booze is mana, if you\'re tough enough.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131140,'A cutlass, a spell, a bottle of booze. What more could a Bloodsail want?','A cutlass, a spell, a bottle of booze. What more could a Bloodsail want?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131153,'Today, we all be pirates. But tomorrow, ya got ta earn dese colors.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131154,'BOOM!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131155,'Boom! Boom! Boom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131156,'Boom! Boom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131159,'You haven\'t lived until you\'ve sang shanties at sunrise in the salty mists of the sea.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131161,'I haven\'t trained at any of the famous academies, but I\'ve sacked all of \'em!','',23,0,0,0,0,0,0,0,0,0,0,0,26124),
(131163,'When the Bloodsail raided my family\'s fishing boat, they didn\'t just kill everyone I\'ve ever loved.\n\nThey rescued me from a mundane life severely lacking in treasure and grog! A pirate\'s life for me!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131256,'It\'s good to finally meet the famous $p! Me crew tell tales of your legendary sackings of Booty Bay.\n\nEveryone likes to pretend to be a Bloodsail today, but you\'re the real deal. Fly the Black with pride, matey.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131257,'I will reach Booty Bay just after nightfall. Then, under the cover of darkness, I will make them feel the full wrath of the Bloodsail!','',71,0,0,0,0,0,0,0,0,0,0,0,26124),
(131258,'<Rear Admiral Giggleplanks kicks frantically, but his feet don\'t reach the water.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131259,'Curse this briny stallion to the depths! It won\'t obey my orders. Forward, beast, or I\'ll keelhaul you!','',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(131260,'All of Booty Bay fears my arrival! It has been foretold in the ancient legends!','',15,0,0,0,0,0,0,0,0,0,0,0,26124),
(131261,'Beware the unbridled wrath of Rear Admiral Giggleplanks! Not even the unusually large rats of Booty Bay will be spared!','',15,0,0,0,0,0,0,0,0,0,0,0,26124),
(131262,'Chaaarge!\n\n<Rear Admiral Giggleplanks waits for a few moments and then pouts.>\n\nFine, we\'ll wait until the tide pulls us in. That\'ll make it more dramatic anyways.','',397,0,0,0,0,0,0,0,0,0,0,0,26124),
(131263,'This is the one day all year that the Fleet Admiral lets me off the leash.\n\nThe one day that all of Azeroth fears.\n\nI\'m a wild pirate with wild pirate intentions! Booty Bay will burn... wildly!','',15,0,0,0,0,0,0,0,0,0,0,0,26124),
(131264,'Hurry up, steed! We must reach Booty Bay by nightfall!\n\nI swear you\'re not even trying.','',397,0,0,0,0,0,0,0,0,0,0,0,26124),
(131265,'Don\'t judge me. Not on Pirates\' Day!','Don\'t judge me. Not on Pirates\' Day!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131266,'Where be ye ocean steed, matey?','Where be ye ocean steed, matey?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131267,'Avast! Stop poking me inflatable or I be keelhaulin\' ya!','Avast! Stop poking me inflatable or I be keelhaulin\' ya!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131268,'They were all out of the red ones.','They were all out of the red ones.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131269,'Does this make me look fearsome?','Does this make me look fearsome?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131270,'Look at this landlubber without a sea pony! Ha!','Look at this landlubber without a sea pony! Ha!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131271,'Push me towards Booty Bay so I can shout more profanities at \'em!','Push me towards Booty Bay so I can shout more profanities at \'em!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131272,'I\'ve never felt so free!','I\'ve never felt so free!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131273,'If ya need a pig cooked for the barbecue later, just let me know. I do a perfect searing flame.','If ya need a pig cooked for the barbecue later, just let me know. I do a perfect searing flame.',23,0,0,0,0,0,0,0,0,0,0,0,26124),
(131274,'Cowardly Crosby deserves what\'s comin\' to him.','Cowardly Crosby deserves what\'s comin\' to him.',11,0,0,0,0,0,0,0,0,0,0,0,26124),
(131275,'Everyone wants to be a Bloodsail, but only a few got the guts to do what it takes.','Everyone wants to be a Bloodsail, but only a few got the guts to do what it takes.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131276,'Haven\'t I seen you below deck before? Or maybe it\'s just the grog talkin...','Haven\'t I seen you below deck before? Or maybe it\'s just the grog talkin...',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131277,'Ya like treasure, landlubber? Too bad! It\'s all ours!','Ya like treasure, landlubber? Too bad! It\'s all ours!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131278,'You look familiar... Didn\'t I ransack your coastal villa once?\n\nHa, yeah! I\'m sure it was you! Your servants all ran screaming into the vineyards, right? And then we burnt the whole place to the ground?\n\nGood times.','You look familiar... Didn\'t I ransack your coastal villa once?\n\nHa, yeah! I\'m sure it was you! Your servants all ran screaming into the vineyards, right? And then we burnt the whole place to the ground?\n\nGood times.',1,22,0,0,2000,0,0,0,0,0,0,0,26124),
(131279,'No landlubbers!','No landlubbers!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131280,'Let\'s put the blood in Bloodsail!','Let\'s put the blood in Bloodsail!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131281,'Bloodsail or no sail!','Bloodsail or no sail!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131282,'No one messes with the Bloodsail!','No one messes with the Bloodsail!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131283,'The Bloodsail party\'s never gonna end!','The Bloodsail party\'s never gonna end!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131284,'Hands off the treasure, scallywag.','Hands off the treasure, scallywag.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131285,'No splashing in the water!','No splashing in the water!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131286,'You\'re in Bloodsail territory now.','You\'re in Bloodsail territory now.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131287,'The last vestiges of life in our city are succumbing to the void. The power in this crystal will release them from its grasp.','',0,0,0,0,0,0,0,0,0,0,86091,0,26124),
(131288,'Thank you for freeing those creatures. I remember the days when our children used to play with them. It pains me to see what has happened since.','',0,0,0,0,0,0,0,0,0,0,86092,0,26124),
(131301,'As I was a-walking down  Booty Bay\'s planks...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131307,'A pretty young lass I chanced to meet...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131308,'She was round in the counter and bluff in the bow...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131309,'So I took in all sail and cried, \"Way enough now!\"','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131310,'I hailed her in dwarvish, she answered me clear...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131311,'\"I\'m from Ironforge, bound to Bronzebeard!\"','',0,0,0,0,0,0,22,6,0,0,0,0,26124),
(131312,'To me way, aye, blow the man down!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131313,'Give me some time to blow the man down!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131314,'Look ahead, look astern, look the weather and the lee...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131315,'I see a wreck to windward and a lofty ship to lee...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131316,'\"Oh, are you a pirate or a royal fleet?\" cried he...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131317,'We be pirates! Bloodsail!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131319,'Blow high, blow low, and so sailed we!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131320,'A-sailing down the coasts to Booty!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131321,'Give us your treasure and your ale!','',0,0,0,0,0,0,22,0,0,0,0,0,26124),
(131323,'We\'ll rant and we\'ll roar, like true Bloodsail pirates!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131324,'We\'ll rant and we\'ll rave, across the salt seas!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131326,'\'Til we strike soundings in the Cape o\' Stranglethorn!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131328,'From Arathi to Booty Bay is too far indeed!','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(131335,'So it\'s cheer up, my lads. Let your hearts never sink!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131336,'While the bonny ship, Crimson Whirl, goes a-fishing for the drink.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131337,'Here\'s a health to the Red Whale...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131338,'Here\'s a health to the Battler of Westfall...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131339,'We wear the shirts o\' the white...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131340,'When we return to Stranglethorn, we\'ll have sweethearts \'til dead!','',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(131341,'Likewise, the Pippy Swan!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131342,'And the Ruby, ship of fame!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131343,'And the pants o\' the red!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131344,'The keg is empty in the morn...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131345,'And it\'s mighty drafty around Stranglethorn...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131346,'Oh, ya pirates and scoundrels...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131347,'It\'s \'round the Cape we\'ve got to go...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131348,'Oh, it\'s one more pull and that will do...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131349,'For we\'re the mateys to kick her through!','',0,0,0,0,0,0,23,0,0,0,0,0,26124),
(131350,'Go down, ya Bloodsail pirates, go down!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131351,'Chasing ships wherever we go!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131352,'He says heave, we say ho!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131353,'Shhhhhhhhhhh.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131354,'Please be quiet. Don\'t wake up the moonkin hatchlings!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131355,'Rest is vital for moonkin hatchlings.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131356,'After a long day of dancing and Moonfiring, moonkin hatchlings need a break to recharge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131357,'begins to snore.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131358,'Fleet Admiral Tethys says it\'s time to go...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(131359,'Moonfiring is essential to being a moonkin.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131360,'It takes great concentration to be able to Moonfire many times in a row.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131361,'Look at some of these hatchlings. They just can\'t focus long enough to moonfire indefinitely.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131362,'By the time I\'m finished with these hatchlings, they\'ll be masters at Moonfiring!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131363,'BOOM!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131364,'Okay everybody, let\'s get loose!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131365,'Alright everybody, put your hands up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131366,'Dance like nobody is watching!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131367,'Are you all ready for this?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131368,'Now everybody screeeeeeeeammm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131373,'Select a destination.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131374,'Exodus Point','Exodus Point',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131375,'Triumvirate\'s End','Triumvirate\'s End',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131376,'Shadowguard Incursion','Shadowguard Incursion',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131378,'The Vindicaar','The Vindicaar',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131380,'Repairing','Repairing',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131390,'Calling','Calling',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131393,'Make way for the Admiral!','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(131394,'Welcome back, Admiral $p. We\'ve been expectin\' ya.','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(131395,'Happy Pirates\' Day, Admiral $p! You\'ve earned the right to raise the Black.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131397,'Already done sackin\' Booty Bay, Admiral? Ha, those mollusks don\'t stand a chance with you at the helm!','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(131398,'Three cheers for Admiral $p, a true Bloodsail! One of us!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131400,'Admiral $p! You\'re a welcome sight from the wannabe pirates that always come crawlin\' around this day.','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(131401,'Someone get the Admiral a grog! And a floaty!','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(131402,'Hail to the conqueror of Booty Bay, the scourge of Stranglethorn, Bloodsail Admiral $p!','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(131409,'Beacon inbound. Be careful, Prophet.','',0,0,0,0,0,0,0,0,0,0,87670,0,26124),
(131410,'Hungry!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131411,'Berries!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131412,'<The moonkin hatchling\'s stomach grumbles as it motions toward the Stormrage Barrow Dens.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131417,'Fall back!','',0,0,0,0,0,0,0,0,0,0,85239,0,26124),
(131421,'Son, there is so much more we have to say, but our allies at the Xenedar will soon be overrun.','',0,0,0,0,0,0,1,0,0,0,86157,0,26124),
(131422,'I... understand. Light be with you both.','',0,0,0,0,0,0,1,0,0,0,86158,0,26124),
(131423,'','Stay safe. We will gather the others and prepare for the battle to come.',0,0,0,0,0,0,1,0,0,0,0,86161,26124),
(131432,'Keep your distance. Those things sting!','Keep your distance. Those things sting!',0,0,0,0,0,0,0,0,0,0,0,87369,26124),
(131433,'I admit it is impressive that the sentinels still patrol after all this time.','I admit it is impressive that the sentinels still patrol after all this time.',0,0,0,0,0,0,0,0,0,0,0,87370,26124),
(131436,'You attack it first.','You attack it first.',0,0,0,0,0,0,0,0,0,0,0,87371,26124),
(131437,'Destroy this thing without delay. The Legion needs the High Inquisitor!','Destroy this thing without delay. The Legion needs the High Inquisitor!',0,0,0,0,0,0,0,0,0,0,0,87372,26124),
(131438,'We must destroy this sentinel without delay. The Legion needs the High Inquisitor!','We must destroy this sentinel without delay. The Legion needs the High Inquisitor!',0,0,0,0,0,0,0,0,0,0,0,87373,26124),
(131441,'Would you please send me to the Deadmines?','Would you please send me to the Deadmines?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131462,'Xavinox scary!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131463,'<The moonkin hatchling is crying at the thought of Xavinox.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131464,'Jadefire bad!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131480,'It\'s very dangerous, sisters. Maintain control!','It\'s very dangerous, sisters. Maintain control!',0,0,0,0,0,0,0,0,0,0,0,87375,26124),
(131481,'It is not worth our death to fight these sentinels. Keep it subdued until the High Inquisitor is free!','It is not worth our death to fight these sentinels. Keep it subdued until the High Inquisitor is free!',0,0,0,0,0,0,0,0,0,0,0,87376,26124),
(131482,'Keep it back from us! Use your magic!','Keep it back from us! Use your magic!',0,0,0,0,0,0,0,0,0,0,0,87377,26124),
(131483,'This is taking too long! We have more important things to do than play with this thing.','This is taking too long! We have more important things to do than play with this thing.',0,0,0,0,0,0,0,0,0,0,0,87378,26124),
(131488,'It pains me to see them go, Aunt Vereesa. I could not bear to lose them now, not after waiting all these years.','',0,0,0,0,0,0,1,0,0,0,86159,0,26124),
(131495,'The Legion will only fall if we stand together, chieftain. And right now, we have friends facing grave peril.','',0,0,0,0,0,0,396,0,0,0,86339,0,26124),
(131498,'There is a way. We will use what power we have to help you.','',0,0,0,0,0,0,396,0,4,0,86340,0,26124),
(131499,'A tunnel! So this is how you have survived...','',0,0,0,0,0,0,396,0,0,0,86341,0,26124),
(131500,'Thank you, chieftain. We will gladly take whatever help we can get.','',0,0,0,0,0,0,1,0,0,0,86343,0,26124),
(131501,'We have hidden. We have adapted. In our hour of need, this land still listens to our pleas.','',0,0,0,0,0,0,396,0,0,0,86342,0,26124),
(131502,'Yes, you will... Walk in the Light.','',0,0,0,0,0,0,396,0,0,0,87156,0,26124),
(131506,'The Overlook will be active soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(131507,'The Overlook is now active.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131508,'The Overlook will be deactivating soon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131509,'The Overlook is no longer active.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131510,'The Coast will be active soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(131511,'The Coast is now active.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131512,'The Coast will be deactivating soon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131513,'The Coast is no longer active.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131514,'The Crossroad will be active soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(131515,'The Crossroad is now active.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131516,'The Crossroad will be deactivating soon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131517,'The Crossroad is no longer active.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131518,'The Waterworks will be active soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(131519,'The Waterworks is now active.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131520,'The Waterworks will be deactivating soon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131521,'The Waterworks is no longer active.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131522,'The Bridge will be active soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(131523,'The Bridge is now active.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131524,'The Bridge will be deactivating soon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131525,'The Bridge is no longer active.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131526,'The Lighthouse will be active soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(131527,'The Lighthouse is now active.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131528,'The Lighthouse will be deactivating soon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131529,'The Lighthouse is no longer active.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131530,'The Ledge will be active soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(131531,'The Ledge is now active.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131532,'The Ledge will be deactivating soon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131533,'The Ledge is no longer active.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131534,'The Mines will be active soon.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(131535,'The Mines is now active.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131536,'The Mines will be deactivating soon.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131537,'The Mines is no longer active.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131538,'|TInterface\\Icons\\ability_priest_pathofthedevout:20|t%s begins to cast |cFFFF0000|Hspell:244509|h[Sorority of the Sargerei]|h|r.','|TInterface\\Icons\\ability_priest_pathofthedevout:20|t%s begins to cast |cFFFF0000|Hspell:244509|h[Sorority of the Sargerei]|h|r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(131545,'Ugh...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131546,'Help...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131547,'Please help.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131548,'Help me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131549,'...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131550,'Administer the antidote.','Administer the antidote.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131551,'<The moonkin hatchling seems to be very happy with you.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131552,'I love you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131553,'Thank you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131554,'Yay!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131555,'Hooray!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131556,'You are amazing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131557,'You are the best!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131559,'Jadefire have antidote!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131561,'Help Clookle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131563,'Find Clookle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131564,'Save Clookle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131565,'Clookle underground!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131566,'Kill Jadefire!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131567,'Thank you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131568,'Thank you for saving me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131569,'Kill the one responsible for all of this!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131570,'The Alliance has gained control of the Overlook.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131571,'The Alliance has lost control of the Overlook.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131572,'The Horde has gained control of the Overlook.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131573,'The Horde has lost control of the Overlook.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131574,'The Alliance has gained control of the Coast.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131575,'The Alliance has lost control of the Coast.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131576,'The Horde has gained control of the Coast.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131577,'The Horde has lost control of the Coast.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131578,'The Alliance has gained control of the Crossroad.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131579,'The Alliance has lost control of the Crossroad.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131580,'The Horde has gained control of the Crossroad.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131581,'The Horde has lost control of the Crossroad.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131582,'The Alliance has gained control of the Waterworks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131583,'The Alliance has lost control of the Waterworks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131584,'The Horde has gained control of the Waterworks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131585,'The Horde has lost control of the Waterworks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131586,'The Alliance has gained control of the Bridge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131587,'The Alliance has lost control of the Bridge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131588,'The Horde has gained control of the Bridge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131589,'The Horde has lost control of the Bridge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131590,'The Alliance has gained control of the Lighthouse.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131591,'The Alliance has lost control of the Lighthouse.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131592,'The Horde has gained control of the Lighthouse.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131593,'The Horde has lost control of the Lighthouse.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131594,'The Alliance has gained control of the Ledge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131595,'The Alliance has lost control of the Ledge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131596,'The Horde has gained control of the Ledge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131597,'The Horde has lost control of the Ledge.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131598,'The Alliance has gained control of the Mines.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131599,'The Alliance has lost control of the Mines.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131600,'The Horde has gained control of the Mines.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131601,'The Horde has lost control of the Mines.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131647,'|TInterface\\Icons\\TRADE_ARCHAEOLOGY_SHARK JAWS:20|tBring |cFFFF0000|Hspell:232913|h[Befouling Ink]|h|r to Sarukel to end his |cFFFF0000|Hspell:234621|h[Devouring Maw]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(131669,'','The beast weakens. Strike true!',0,0,0,0,0,0,0,0,0,0,0,86321,26124),
(131673,'|TInterface\\Icons\\SPELL_FEL_ELEMENTALDEVASTATION.BLP:20|tYou have been affected by  |cFFFF0000|Hspell:236329|h[Star Burn]|h|r. Hide behind infernal pillars when targeted by Shattering Star!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131740,'','Let\'s not keep our son waiting.',0,0,0,0,0,0,0,0,0,0,0,86140,26124),
(131753,'Without the Crest of Knowledge, we cannot prevail.','',0,0,0,0,0,0,0,0,0,0,87949,0,26124),
(131756,'','There is a familiar presence here. I hear it calling to me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131757,'','Forces beyond our reckoning are at work here. Be on guard.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131758,'','Keep your eyes open and your steps soft, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131759,'','Darkness creeps in on us from all sides. Keep your wits about you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131760,'','I need to show you what I have seen.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131762,'Show me.','Show me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131767,'Stay still!','Stay still!',0,0,0,0,0,0,0,0,0,0,0,88027,26124),
(131768,'We are trying to help you, creature!','We are trying to help you, creature!',0,0,0,0,0,0,0,0,0,0,0,88028,26124),
(131769,'I thought I was going to catch that one.','I thought I was going to catch that one.',0,0,0,0,0,0,0,0,0,0,0,88029,26124),
(131770,'Curse the void for infesting these poor creatures!','Curse the void for infesting these poor creatures!',0,0,0,0,0,0,0,0,0,0,0,88030,26124),
(131772,'This is not how I thought I would spend my time in Mac\'Aree.','This is not how I thought I would spend my time in Mac\'Aree.',0,0,0,0,0,0,0,0,0,0,0,88031,26124),
(131773,'This is maddening!','This is maddening!',0,0,0,0,0,0,0,0,0,0,0,88032,26124),
(131778,'|TInterface\\ICONS\\Spell_Deathknight_Necroticplague.blp:20|t You are afflicted with |cFFF00000|Hspell:244093|h[Necrotic Embrace]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(131817,'Do not let the long, dark night break you. Accept its gift.','',0,0,0,0,0,0,0,0,0,0,87629,0,26124),
(131820,'','I found a survivor. Come to me.',0,0,0,0,0,0,0,0,0,0,0,87549,26124),
(131821,'','Come on out. We mean you no harm.',0,0,0,0,0,0,0,0,0,0,0,87547,26124),
(131822,'A voice! Arkhaan has never heard this one before.','',0,0,0,0,0,0,0,0,0,0,87630,0,26124),
(131823,'','We found your messages.',0,0,0,0,0,0,0,0,0,0,0,87548,26124),
(131833,'No want sleep!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131834,'No sleep!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131835,'Not tired!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131837,'Wake up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131846,'','I will meet you in the ruins below, $n. We will begin where the darkness ends.',0,0,0,0,0,0,0,0,0,0,0,87544,26124),
(131856,'Aiiii!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131857,'Aaaaaaaaaaaahhhhhhhh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131858,'Yeeeeeeeeeee!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131859,'Aiiiiiiyaaaaahhhhhhh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131860,'Ooooooooooooooooh!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131861,'Wooooooooooo!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131866,'Yes, Arkhaan did call... but he was not expecting...','',0,0,0,0,0,0,0,0,0,0,87619,0,26124),
(131871,'I always knew I would see Argus again. Our homecoming appeared time and again in my visions.\n\nBut I never imagined this.\n\nThere can be no doubt that the fates of my world and yours are intertwined. Can Argus be saved, or must it be sacrificed to stop Sargeras? My visions are clouded, uncertain.\n\nIt seems we must forge our own destiny. Light save us all, $n.','',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(131872,'The Sargerite Keystone tore through the fabric of reality. Now the homeworld of the Legion looms before us, its armies poised to strike.\n\nTuralyon is out there somewhere. Alleria too, I hope. If we can find my old friends, perhaps the Army of the Light can help us end this war.','',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(131873,'Argus. Throne of the Burning Legion. Its infernal machines provide Sargeras with an infinite army.\n\nTime to deprive the Dark Titan of his prize.\n\nOur course is clear. We must take the fight to Argus and bring the Legion to its knees.','',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(131876,'<Light\'s Judgment is smashed into the side of the cliffs. It is intact, but clearly not operational. $b$bYou should be able to activate the security countermeasures to teleport it to the Vindicaar.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131877,'<Activate the teleportation sequence.>','<Activate the teleportation sequence.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131889,'But... couldn\'t you have reached out to us? To your people? To me?','',0,0,0,0,0,0,1,0,0,0,86170,0,26124),
(131890,'Arator... not a day passed that your mother and I didn\'t--','',0,0,0,0,0,0,1,0,4,0,86171,0,26124),
(131891,'','Every choice we made was to keep you safe. It broke our hearts to be apart from you.',0,0,0,0,0,0,1,0,4,0,0,86176,26124),
(131898,'','Hold onto your helmet... we\'re traveling through TIME!',0,0,0,0,0,0,0,0,0,0,0,85371,26124),
(131899,'','Alright... let\'s see here. I think we\'re at the right time, give or take a minute. Am I dead yet?',0,0,0,0,0,0,0,0,0,0,0,85284,26124),
(131900,'','Oh, good. There I am over there. Hi, me!',0,0,0,0,0,0,0,0,0,0,0,85285,26124),
(131901,'','Oh, hi! What are you doing here?',0,0,0,0,0,0,0,0,0,0,0,85286,26124),
(131902,'','Here we go... again!',0,0,0,0,0,0,0,0,0,0,0,85372,26124),
(131903,'','I bought us a few more seconds this time, but we have to move quickly.',0,0,0,0,0,0,0,0,0,0,0,85287,26124),
(131904,'','Hey! Chromie!',0,0,0,0,0,0,0,0,0,0,0,85288,26124),
(131905,'','Oh, hi! What am I doing here?',0,0,0,0,0,0,0,0,0,0,0,85289,26124),
(131906,'','Follow me! We don\'t have much time!',0,0,0,0,0,0,0,0,0,0,0,85290,26124),
(131907,'','Oh! Well, alright. You\'ve never steered me wrong in the past. Or in the future.',0,0,0,0,0,0,0,0,0,0,0,85291,26124),
(131908,'','So, where are we going? Why are we leaving Wyrmrest?',0,0,0,0,0,0,0,0,0,0,0,85292,26124),
(131909,'','Somebody is trying to kill you. In fact, it should happen any second now...',0,0,0,0,0,0,0,0,0,0,0,85293,26124),
(131910,'','Alright, I\'m chronoporting us to a point four hours before the attack happens. That\'ll give us PLENTY of time to untangle this mess.',0,0,0,0,0,0,0,0,0,0,0,85373,26124),
(131911,'','Huh! That\'s weird. Something\'s blocking me from accessing that particular moment.',0,0,0,0,0,0,0,0,0,0,0,85374,26124),
(131912,'','No worries! Four hours was probably too early anyways. Let\'s try one hour.',0,0,0,0,0,0,0,0,0,0,0,85375,26124),
(131913,'','Now I\'m starting to get worried, $n. Whoever orchestrated this attack really did their homework. They\'ve found a way to block my chronoports!',0,0,0,0,0,0,0,0,0,0,0,85376,26124),
(131914,'','Let\'s give this one last try...',0,0,0,0,0,0,0,0,0,0,0,85377,26124),
(131915,'','There, that did it!',0,0,0,0,0,0,0,0,0,0,0,85294,26124),
(131916,'','We are now at a time 15 minutes before my death.',0,0,0,0,0,0,0,0,0,0,0,85295,26124),
(131917,'','That probably won\'t be enough time to save me, but it\'s the best I can do for now.',0,0,0,0,0,0,0,0,0,0,0,85296,26124),
(131918,'','Let\'s ask around and see if we can figure out where those shadowy bolts were coming from.',0,0,0,0,0,0,0,0,0,0,0,85384,26124),
(131919,'','Undead attacks at the Ruby Dragonshrine? We\'ll take a look. Thanks, Allie.',0,0,0,0,0,0,0,0,0,0,0,85385,26124),
(131920,'','Strange? Let me think... Oh! I did see that black dragon earlier today. What was his name? Deathwing? No, no, no, not him... the other one. The one with the hat.',0,0,0,0,0,0,0,0,0,0,0,85386,26124),
(131921,'','Pretty sure he was headed to the Obsidian Dragonshrine.',0,0,0,0,0,0,0,0,0,0,0,85387,26124),
(131922,'','We\'ll check it out. Thanks!',0,0,0,0,0,0,0,0,0,0,0,85388,26124),
(131923,'','Thank you, Lord Itharius. We\'ll take a look, and will let you know if we find anything.',0,0,0,0,0,0,0,0,0,0,0,85389,26124),
(131924,'','Ley line disturbances? Pshh... typical blue dragon problems.',0,0,0,0,0,0,0,0,0,0,0,85390,26124),
(131925,'','Sounds like we\'ve got some dragonshrines to investigate. Let\'s go, uh... investigate some dragonshrines!',0,0,0,0,0,0,0,0,0,0,0,85391,26124),
(131926,'','Come on, $n. Let\'s go clear out the undead leaders. Maybe they\'ll know something about the upcoming attack.',0,0,0,0,0,0,0,0,0,0,0,85360,26124),
(131927,'','A lich! Argh! I figured as much... though it\'s odd I couldn\'t see this in any future timeline.',0,0,0,0,0,0,0,0,0,0,0,85361,26124),
(131928,'','He\'s inside the tree, right? Let\'s go get him then. His time has come!',0,0,0,0,0,0,0,0,0,0,0,85362,26124),
(131929,'','We can go straight for that lich, $n. If he\'s really orchestrating this attack, then killing him should scatter their forces.',0,0,0,0,0,0,0,0,0,0,0,85363,26124),
(131930,'','That\'s one threat taken care of in a timely manner!',0,0,0,0,0,0,0,0,0,0,0,85364,26124),
(131932,'','Huh? What\'s this? Some kind of chronoshard? I\'ll have to bring it back to Wyrmrest to investigate.',0,0,0,0,0,0,0,0,0,0,0,85365,26124),
(131933,'','He makes a fair point. Let\'s poke around that spooky cavern for clues.',0,0,0,0,0,0,0,0,0,0,0,85303,26124),
(131934,'','A dreadlord? And a bronze dragon... Wait, is he talking about me?',0,0,0,0,0,0,0,0,0,0,0,85304,26124),
(131935,'','And it sounds like he gave away his position. Ha! Let\'s go to the entrance of the Obsidian Dragonshrine and snuff him out!',0,0,0,0,0,0,0,0,0,0,0,85305,26124),
(131936,'','Luckily for us, we already know about the dreadlord mastermind pulling the strings. Let\'s kill him before he can kill me!',0,0,0,0,0,0,0,0,0,0,0,85306,26124),
(131937,'','Huh! I wonder what the Legion wants with little ol\' me.',0,0,0,0,0,0,0,0,0,0,0,85307,26124),
(131938,'','Hmm... a chronoshard. Let\'s bring this back to Wyrmrest. I wonder when and where it goes.',0,0,0,0,0,0,0,0,0,0,0,85308,26124),
(131940,'','We can help with that!',0,0,0,0,0,0,0,0,0,0,0,85334,26124),
(131941,'','We can help with that, right?',0,0,0,0,0,0,0,0,0,0,0,85335,26124),
(131942,'','The dreamers gave us three clues... great nightmare, by the water, dragon\'s palm. We just need to figure out what they mean.',0,0,0,0,0,0,0,0,0,0,0,85336,26124),
(131943,'','Let\'s go!',0,0,0,0,0,0,0,0,0,0,0,85337,26124),
(131944,'','Remember, the satyr is down in that bone claw by the water. Let\'s take him out!',0,0,0,0,0,0,0,0,0,0,0,85338,26124),
(131945,'','Odd. I don\'t remember getting on the satyrs\' bad side, either now OR in the future.',0,0,0,0,0,0,0,0,0,0,0,85339,26124),
(131946,'','Look at this! A chronoshard. We should bring it back with us to Wyrmrest.',0,0,0,0,0,0,0,0,0,0,0,85340,26124),
(131947,'','Let\'s get down there and look for clues. Maybe the disturbances are coming from whoever wants to kill me.',0,0,0,0,0,0,0,0,0,0,0,85309,26124),
(131948,'','Let\'s skip the ley lines and go straight to that void lord. Time is of the essence!',0,0,0,0,0,0,0,0,0,0,0,85310,26124),
(131949,'','I never expected to be on the bad side of a VOID LORD, of all things. Sheesh.',0,0,0,0,0,0,0,0,0,0,0,85311,26124),
(131950,'','And looky here... it was carrying a chronoshard. I need to bring this to Wyrmrest to find out where it goes.',0,0,0,0,0,0,0,0,0,0,0,85312,26124),
(131951,'','I have a sneaking suspicion that the enemy is planning a cross-synchronous attack. Why else would they be using chronoshards, right?',0,0,0,0,0,0,0,0,0,0,0,85357,26124),
(131952,'','I can tell you\'re a little foggy on what that means. Basically, they\'re attacking me at multiple points in time simultaneously.',0,0,0,0,0,0,0,0,0,0,0,85358,26124),
(131953,'','These guys really know what they\'re doing! I wouldn\'t be surprised if they had a bronze dragon on their side.',0,0,0,0,0,0,0,0,0,0,0,85359,26124),
(131954,'','Interesting... a portal to Andorhal. That\'s one of my favorite places of any when! Let\'s see if I\'m in trouble.',0,0,0,0,0,0,0,0,0,0,0,85353,26124),
(131955,'','Aha! A portal to Mount Hyjal. I\'ve been there a time or tree. THREE. I meant to say three.',0,0,0,0,0,0,0,0,0,0,0,85354,26124),
(131956,'','I see... a portal to Stratholme, back in the days of the Third War.',0,0,0,0,0,0,0,0,0,0,0,85355,26124),
(131957,'','Wow... an oldie but a goodie! This portal points to the Well of Eternity.',0,0,0,0,0,0,0,0,0,0,0,85356,26124),
(131958,'','Andorhal, a few months after the Cataclysm. We\'re in the middle of a battle between the Horde and the Alliance.',0,0,0,0,0,0,0,0,6,0,0,85278,26124),
(131959,'There it is! You have your orders. Slay the dragon!','',0,0,0,0,0,0,397,0,6,0,0,0,26124),
(131960,'','See, this is one of the problems with being a gnome. Sometimes Horde soldiers just get the urge to KICK you.',0,0,0,0,0,0,0,0,6,0,0,85279,26124),
(131961,'Soldiers of the Alliance! Hold your ground! She can\'t hide forever.','',0,0,0,0,0,0,5,0,6,0,0,0,26124),
(131962,'','The ALLIANCE wants me too? What\'s going on right now?',0,0,0,0,0,0,0,0,6,0,0,85282,26124),
(131963,'','I can hold my own here, but I can\'t fly away with that cannon pointed at the skies.',0,0,0,0,0,0,0,0,0,0,0,85283,26124),
(131964,'','The cannon is down. Can you make it out?',0,0,0,0,0,0,0,0,0,0,0,85280,26124),
(131965,'','I think so. See you next time!',0,0,0,0,0,0,0,0,0,0,0,85281,26124),
(131966,'','Stratholme, during the Third War. I remember this day. Not exactly Prince Arthas\' finest moment.',0,0,0,0,0,0,0,0,2,0,0,85367,26124),
(131967,'Chromie! Thank the sands you\'ve arrived. They\'ve taken you into the city!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131968,'I couldn\'t fight them off. They\'ve taken you into the city!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(131969,'','I guess we\'re headed into Stratholme! Let\'s get a move on, we don\'t have much time!',0,0,0,0,0,0,0,0,0,0,0,85368,26124),
(131970,'','Yikes! That\'s one nasty-looking creature. Well, there\'s no getting past her. Looks like we\'re going to have to take her on.',0,0,0,0,0,0,0,0,0,0,0,85366,26124),
(131971,'','Thank you so much for saving me, me!',0,0,0,0,0,0,0,0,0,0,0,85369,26124),
(131972,'','Any time!',0,0,0,0,0,0,0,0,0,0,0,85370,26124),
(131973,'','Let\'s see... we\'re in Mount Hyjal, shortly after the time of the Cataclysm.',0,0,0,0,0,0,0,0,2,0,0,85341,26124),
(131974,'','I remember this! I should be just up ahead.',0,0,0,0,0,0,0,0,2,0,0,85342,26124),
(131975,'','I sure don\'t recall there being so many fire elementals around here...',0,0,0,0,0,0,0,0,2,0,0,85343,26124),
(131976,'','There I am!',0,0,0,0,0,0,0,0,2,0,0,85344,26124),
(131977,'','Aww, I\'m wounded! I can heal this... I just need a little bit more time.',0,0,0,0,0,0,0,0,0,0,0,85345,26124),
(131978,'','Don\'t worry. We\'ll protect you!',0,0,0,0,0,0,0,0,0,0,0,85346,26124),
(131979,'','Feeling better?',0,0,0,0,0,0,0,0,0,0,0,85347,26124),
(131980,'','I\'ll be fine, I think. Thanks for the help!',0,0,0,0,0,0,0,0,0,0,0,85348,26124),
(131981,'','The Well of Eternity, just prior to the War of the Ancients. About ten thousand years before your time, $n. Give or take.',0,0,0,0,0,0,0,0,6,0,0,85378,26124),
(131982,'','Oh no! There I am!',0,0,0,0,0,0,0,0,6,0,0,85379,26124),
(131983,'','These fel wounds are bad. We need to get me back to Wyrmrest.',0,0,0,0,0,0,0,0,6,0,0,85380,26124),
(131984,'','There should be a time portal up on the other side of the Well. I know the way. Follow me!',0,0,0,0,0,0,0,0,6,0,0,85381,26124),
(131985,'','There\'s the portal! Let\'s move!',0,0,0,0,0,0,0,0,0,0,0,85382,26124),
(131986,'','Whew! I should be safe now.',0,0,0,0,0,0,0,0,0,0,0,85383,26124),
(131987,'','Everything seems... back to normal. The timelines are clearer. I don\'t see myself dying anymore.',0,0,0,0,0,0,0,0,0,0,0,85319,26124),
(131988,'','That\'s good!',0,0,0,0,0,0,0,0,0,0,0,85320,26124),
(131989,'','There ARE a few things still bothering me, though...',0,0,0,0,0,0,0,0,0,0,0,85321,26124),
(131990,'','A whole lot of people seemed very intent on killing me. Demons, elementals, undead, void lords... even the Horde and the Alliance!',0,0,0,0,0,0,0,0,0,0,0,85322,26124),
(131991,'','Why\'s everybody so mad at me? I think we should probably figure that out, eventually.',0,0,0,0,0,0,0,0,0,0,0,85323,26124),
(131992,'','But that\'s a problem for future us! Well, future you and past me. Aw, don\'t worry about it. Time is complicated.',0,0,0,0,0,0,0,0,0,0,0,85324,26124),
(131993,'','See you next time, $n!',0,0,0,0,0,0,0,0,0,0,0,85325,26124),
(132005,'','Is that a Stratholme gate key? Ha! This must be our lucky day!',0,0,0,0,0,0,0,0,0,0,0,85330,26124),
(132006,'','Keep that handy for the next time we visit Stratholme.',0,0,0,0,0,0,0,0,0,0,0,85331,26124),
(132007,'','A Brimstone Beacon... fascinating!',0,0,0,0,0,0,0,0,0,0,0,85326,26124),
(132008,'','I think we can use this to rile up the fire elementals in Mount Hyjal.',0,0,0,0,0,0,0,0,0,0,0,85327,26124),
(132011,'','Tyrande\'s Moonstone? How did you find THIS?',0,0,0,0,0,0,0,0,0,0,0,85332,26124),
(132012,'','It\'s not much use to us here, but maybe in the Well of Eternity...',0,0,0,0,0,0,0,0,0,51279,0,85333,26124),
(132013,'','Interesting... these documents mark the bearer as some sort of higher-up in the Cenarion Circle.',0,0,0,0,0,0,0,0,0,0,0,85328,26124),
(132014,'','Maybe we can use them to grease some wheels in Andorhal.',0,0,0,0,0,0,0,0,0,0,0,85329,26124),
(132018,'I am one with the Light. The Light is with me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132021,'','Umm... sorry about this.',0,0,0,0,0,0,0,0,0,0,0,85297,26124),
(132022,'','Alright... now I attack THIS one...',0,0,0,0,0,0,0,0,0,0,0,85298,26124),
(132023,'','Time to take matters into my own hands!',0,0,0,0,0,0,0,0,0,0,0,85299,26124),
(132024,'','The timestream won\'t repair itself!',0,0,0,0,0,0,0,0,0,0,0,85300,26124),
(132025,'','Here we go!',0,0,0,0,0,0,0,0,0,0,0,85301,26124),
(132026,'','I\'m more powerful than I appear, you know...',0,0,0,0,0,0,0,0,0,0,0,85302,26124),
(132027,'','Ooh! Your time just ran out!',0,0,0,0,0,0,0,0,0,0,0,85349,26124),
(132028,'','Sorry, but... that\'s how it goes!',0,0,0,0,0,0,0,0,0,0,0,85350,26124),
(132029,'','Oh, wonderful! Everything worked out!',0,0,0,0,0,0,0,0,0,0,0,85351,26124),
(132030,'','Yay! I did it!',0,0,0,0,0,0,0,0,0,0,0,85352,26124),
(132031,'','No... it\'s not supposed to happen this way...',0,0,0,0,0,0,0,0,0,0,0,85313,26124),
(132032,'','Maybe next time...',0,0,0,0,0,0,0,0,0,0,0,85314,26124),
(132033,'','Looks like it\'s my time... to...',0,0,0,0,0,0,0,0,0,0,0,85315,26124),
(132034,'','This isn\'t what happens...',0,0,0,0,0,0,0,0,0,0,0,85316,26124),
(132035,'','Sorry...',0,0,0,0,0,0,0,0,0,0,0,85317,26124),
(132036,'','Time heals all wounds... except for... the fatal ones...',0,0,0,0,0,0,0,0,0,0,0,85318,26124),
(132051,'','Arkhaan, was it? Can you tell us what happened to your people?',0,0,0,0,0,0,0,0,0,0,0,87502,26124),
(132052,'Arkhaan knows, yes.','',0,0,0,0,0,0,0,0,0,0,87628,0,26124),
(132062,'','Hello again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132063,'I\'m ready. Let\'s go!','I\'m ready. Let\'s go!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132064,'','You ready?  There\'s no time like the present... trust me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132065,'','Let\'s try that again. We\'ll give ourselves a SMIDGE more time before my murder.\n\nYou ready?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132069,'Look. The way is closed. How will we go to Isolon now?','',0,0,0,0,0,0,0,0,0,0,87611,0,26124),
(132071,'','I\'m sure we can figure this out. Let me know when you\'re ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132072,'This water is cursed. Do not give in to thirst.','',0,0,0,0,0,0,0,0,0,0,87612,0,26124),
(132073,'Let\'s go try to save you again!','Let\'s go try to save you again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132074,'The man\'ari torment my kind with their fel magic rituals. Let their dark words be purged... in fire!','',0,0,0,0,0,0,0,0,4,0,86075,0,26124),
(132075,'The scorched parchment you left behind will remind the Legion that our resistance cannot be silenced. Thank you.','',0,0,0,0,0,0,0,0,4,0,86076,0,26124),
(132077,'<You can see the corner of a missive tucked into the courier\'s bracers.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132078,'<Take the Missive>','<Take the Missive>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132080,'<Pick up the code book.>','<Pick up the code book.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132082,'<The codebreaker\'s lifeless eyes stare into the sky. A thin tome rests beneath her body.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132083,'','Welcome to Wyrmrest, time-traveler. The council is at your disposal, should you need us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132084,'','Am... am I in trouble?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132085,'I see you are accompanied by Chronormu. Might I ask... are you here from the future, or the past?\n\nOn second thought, do not bother answering that. Such matters are best left to the bronze.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132086,'Something is strange about your aura, $r. Your presence seems... otherworldly, as if you do not belong here.\n\n<Kalecgos looks down at Chromie.>\n\nAh, I see. Time traveling. That... that might explain it.\n\n<Kalecgos eyes you warily.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132087,'Seen anything strange lately?','Seen anything strange lately?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132088,'','The dead walk once more.\n\nThe Ruby Dragonshrine has a history of conflict with the undead. Most of that struggle subsided with the fall of the Lich King. But as of late, such incidents have been on the rise.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132089,'Actually, yes. The Garden Keeper at the Emerald Dragonshrine has been struggling to keep the dreamers asleep. Several of the ancients have unexpectedly awakened from the Dream, and we have yet to find out why.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132090,'Not particularly. The ley lines have been acting up again, but that is normal in this part of the world.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132091,'I see. Thank you.','I see. Thank you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132097,'','That sounded way better in my head than it did out loud!',0,0,0,0,0,0,0,0,0,0,0,85392,26124),
(132098,'','I hope that you can find this Raalgar before the Legion does. Someone on the Vindicaar will help you.',0,0,0,0,0,0,66,0,0,0,0,87646,26124),
(132099,'Did you hear that?','',0,0,0,0,0,0,0,0,0,53060,87613,0,26124),
(132100,'No, no... no.','',0,0,0,0,0,0,0,0,0,53060,87614,0,26124),
(132101,'Nnghh... Stay with us!','',0,0,0,0,0,0,0,0,0,53060,87615,0,26124),
(132102,'Stop! Do not listen!','',0,0,0,0,0,0,0,0,0,53060,87616,0,26124),
(132103,'Ah!','',0,0,0,0,0,0,0,0,0,53060,87617,0,26124),
(132104,'Shhh.','',0,0,0,0,0,0,0,0,0,53060,87618,0,26124),
(132108,'Even when tortured by the Legion, my people rebel against their accursed crusade. The demons may break their bodies, but never their wills. Go, release their spirits so that they may find peace.','',0,0,0,0,0,0,0,0,4,0,86061,0,26124),
(132109,'The spirits of those who resist the Legion inspire us all.','',0,0,0,0,0,0,0,0,4,0,86062,0,26124),
(132110,'','Hello again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132115,'<Adjust Chromie\'s talents>','<Adjust Chromie\'s talents>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132116,'Let\'s adjust our strategy.\n|cFF0000FF(Change Chromie\'s talents).|r','Let\'s adjust our strategy.\n|cFF0000FF(Change Chromie\'s talents).|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132118,'I will prove once and for all that only a knight from the grave can rule heavy metal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132119,'Fight though you might, your bodies will freeze and shatter!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132120,'Darkness falls, and with it Banshees form these Wailing Walls!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132121,'I summon ghouls out every tomb.  Fight as you might, they will seal your doom!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132122,'Another soul for my music!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132123,'Another soul for my armies!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132124,'You have failed, Blight Boar.  Your fans now serve my armies of the dead!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132125,'What is this?! I can\'t be beaten!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132126,'|TInterface\\Icons\\INV_Axe_2H_UndeadGuitar_C_01.blp:20|tPower Chords rain down, use them to |cFFFF0000|Hspell:245034|h[Blow the Mind]|h|r of your enemies!','|TInterface\\Icons\\INV_Axe_2H_UndeadGuitar_C_01.blp:20|tPower Chords rain down, use them to |cFFFF0000|Hspell:245034|h[Blow the Mind]|h|r of your enemies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132127,'Once you\'ve reached the Arcatraz, I will remain in contact.','',113,0,0,0,0,0,0,0,0,0,86329,0,26124),
(132153,'Thank you! Thank you!','',0,0,0,0,0,0,0,0,0,0,87597,0,26124),
(132154,'It will all be undone! There is nothing... but the Void.','',0,0,0,0,0,0,0,0,0,0,87598,0,26124),
(132155,'You must know the truth!','',0,0,0,0,0,0,0,0,0,0,87599,0,26124),
(132156,'Arkhaan will make you understand!','',0,0,0,0,0,0,0,0,0,0,87600,0,26124),
(132157,'Why... they not... listen?','',0,0,0,0,0,0,0,0,0,0,87601,0,26124),
(132158,'','I am sorry you had to learn this way. Rest now.',0,0,0,0,0,0,0,0,0,0,0,87509,26124),
(132159,'I will go on ahead and clear a path. The bridge leading to the Xenedar seems to be the least guarded. Light be with us.','',0,0,0,0,0,0,0,0,0,0,86344,0,26124),
(132160,'','Who is that?',0,0,0,0,0,0,0,0,0,0,0,87504,26124),
(132161,'You will not delay me, demon!','',0,0,0,0,0,0,0,0,0,0,86503,0,26124),
(132162,'Fareeya! You survived!','',0,0,0,0,0,0,0,0,0,0,86504,0,26124),
(132163,'','Resist their call, Arkhaan!',0,0,0,0,0,0,0,0,0,0,0,87505,26124),
(132164,'','No! What you have seen is a lie!',0,0,0,0,0,0,0,0,0,0,0,87506,26124),
(132165,'','He cannot hear us! We must end his suffering.',0,0,0,0,0,0,0,0,0,0,0,87507,26124),
(132166,'','We are losing him!',0,0,0,0,0,0,0,0,0,0,0,87508,26124),
(132167,'','Do you feel that? Something is pulling us back...',0,0,0,0,0,0,0,0,0,0,0,87510,26124),
(132170,'','Locus-Walker?',0,0,0,0,0,0,0,0,0,0,0,87511,26124),
(132172,'','Not today, monster! The Light prevails!',0,0,0,0,0,0,0,0,0,0,0,87647,26124),
(132175,'','You know that I refuse to die while the Legion still stands, High Exarch. Follow me. We\'ve set up a perimeter.',0,0,0,0,0,0,0,0,0,0,0,87648,26124),
(132176,'You\'re not going anywhere, \"champion.\" The master has plans for you!','',0,0,0,0,0,0,1,0,0,0,86706,0,26124),
(132181,'Zereketh\'s void magic still lingers here.','Zereketh\'s void magic still lingers here.',0,0,0,0,0,0,0,0,0,0,0,87379,26124),
(132182,'It is ours for the taking, sister.','It is ours for the taking, sister.',603,0,0,0,0,0,0,0,0,0,0,87380,26124),
(132202,'','Minions! To me!',22,0,0,0,0,0,0,0,0,0,0,86788,26124),
(132204,'','A futile effort, worm!',0,0,0,0,0,0,0,0,0,0,0,86789,26124),
(132206,'I am free!','',644,0,0,0,0,0,0,0,0,0,87805,0,26124),
(132207,'Be cleansed, demons!','',0,0,0,0,0,0,0,0,0,0,86346,0,26124),
(132208,'You will pay for your crimes, foul demons!','',0,0,0,0,0,0,0,0,0,0,86173,0,26124),
(132209,'You will befoul this world no longer!','',0,0,0,0,0,0,0,0,0,0,86174,0,26124),
(132210,'The devastators are no more. Surge forward!','',0,0,0,0,0,0,0,0,0,0,86345,0,26124),
(132211,'What was that?','',0,0,0,0,0,0,0,0,0,0,86804,0,26124),
(132212,'Show yourself!','',0,0,0,0,0,0,0,0,0,0,86805,0,26124),
(132213,'An intruder?','',0,0,0,0,0,0,0,0,0,0,86806,0,26124),
(132214,'Hmmm... hahahaha','',0,0,0,0,0,0,0,0,0,0,86807,0,26124),
(132215,'My, my... What is this?','',0,0,0,0,0,0,0,0,0,0,86808,0,26124),
(132216,'','I will find you, interloper.',0,0,0,0,0,0,0,0,0,0,0,88503,26124),
(132217,'','You cannot hide.',0,0,0,0,0,0,0,0,0,0,0,88504,26124),
(132218,'','I see you.',0,0,0,0,0,0,0,0,0,0,0,88505,26124),
(132219,'','This is our realm, fleshling.',0,0,0,0,0,0,0,0,0,0,0,88506,26124),
(132220,'','How very arrogant of you.',0,0,0,0,0,0,0,0,0,0,0,88507,26124),
(132222,'','You dare enter our realm!',0,0,0,0,0,0,0,0,0,0,0,88420,26124),
(132223,'','You cannot hide in this darkness!',0,0,0,0,0,0,0,0,0,0,0,88421,26124),
(132224,'','Die, fleshling!',0,0,0,0,0,0,0,0,0,0,0,88422,26124),
(132225,'','Their will be done!',0,0,0,0,0,0,0,0,0,0,0,88423,26124),
(132226,'','Ha! Pathetic fleshling.',0,0,0,0,0,0,0,0,0,0,0,88424,26124),
(132227,'','Did you think you would escape?',0,0,0,0,0,0,0,0,0,0,0,88425,26124),
(132228,'','By their will.',0,0,0,0,0,0,0,0,0,0,0,88426,26124),
(132229,'','Your flesh betrays you, intruder.',0,0,0,0,0,0,0,0,0,0,0,88427,26124),
(132230,'','A dissimulation? What are you concealing?',0,0,0,0,0,0,0,0,0,0,0,88508,26124),
(132231,'At long last, I will return home and prepare to attack. You can remain here... and die!','',603,0,0,0,0,0,0,0,0,0,87806,0,26124),
(132232,'30 seconds remaining!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132233,'10 seconds remaining!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132234,'','I\'ve got you. Try again--we are safe for the moment.',0,0,0,0,0,0,0,0,0,0,0,87538,26124),
(132238,'','It will be done, High Inquisitor!',0,0,0,0,0,0,0,0,0,0,0,86774,26124),
(132239,'','Seekers, cover the High Inquisitor\'s departure. I will deal with this interruption!',0,0,0,0,0,0,0,0,0,0,0,86775,26124),
(132241,'Today\'s MY day! I\'m a pirate... Yeah, I\'m AAAAALL the pirates!\n\nTake that, Dread Crew!','',14,0,0,0,0,0,0,0,0,0,0,0,26124),
(132242,'Ya throw this party just for me, $pr? ... Ya should have... Have a grog!','',92,0,0,0,0,0,0,0,0,0,0,0,26124),
(132244,'','The coast is clear. Try again.',0,0,0,0,0,0,0,0,0,0,0,87539,26124),
(132245,'','Nearly there!',0,0,0,0,0,0,0,0,0,0,0,87540,26124),
(132246,'','How did you manage that?',0,0,0,0,0,0,0,0,0,0,0,87541,26124),
(132247,'I come... party... but Dread Crew parties worse than... SHADO-PAN PARTIES!\n\nHa!','',92,0,0,0,0,0,0,0,0,0,0,0,26124),
(132248,'...and I don\'t care who hears me!\n\nTake that, De Mooza... DeMeeezey... Da Foolsya!\n\nHa... Got her good...','',92,0,0,0,0,0,0,0,0,0,0,0,26124),
(132249,'If ya think THIS party doesn\'t chum bilgewater, wait\'ll ya see MY party...\n\nYa like ponies?','',92,0,0,0,0,0,0,0,0,0,0,0,26124),
(132250,'Grog, grog... I love grog!\nGrog, grog... Don\'t eat a log!\nGreg, greg... Get me some grog!\nAnd don\'t lose ya leg...\n\nCan ya believe I just made that up?','',92,0,0,0,0,0,0,0,0,0,0,0,26124),
(132251,'Stupid Giggleplanks send me... secret spynapping... never show up... I got a life too!','',92,0,0,0,0,0,0,0,0,0,0,0,26124),
(132252,'Ya pop one teeny pony and ya get thrown outta party forever... thass fine. I don\'t need pony partiess...\n\nPoniess aren\'t even real piratess... They can\'t shoot cannonss... They don\'t even have handss... Whoa...','',92,0,0,0,0,0,0,0,0,0,0,0,26124),
(132253,'Where\'d you get that pool pony?','Where\'d you get that pool pony?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132255,'It\'s Pirates\' Day, and that means it\'s time to party!\n\nWhen ya get bored with this Dread Crew snoozefest, head south to the beach... Where REAL pirates celebrate.\n\nMe mighty Bloodsail Buccaneers be down there. Tell \'em ol\' Whiskers sent ya, and maybe they\'ll let me back in...','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(132256,'doesn\'t feel too good...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132257,'is feeling full...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132258,'is stuffed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132259,'All of the power in this place now belongs to the Legion.','All of the power in this place now belongs to the Legion.',0,0,0,0,0,0,0,0,0,0,0,87374,26124),
(132268,'Jump into the pit when you have |TINTERFACE\\ICONS\\SPELL_FEL_INCINERATE.BLP:20|t |cFFFF0000|Hspell:240209|h[Unstable Soul]|h|r!','Jump into the pit when you have |TINTERFACE\\ICONS\\SPELL_FEL_INCINERATE.BLP:20|t |cFFFF0000|Hspell:240209|h[Unstable Soul]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132277,'Overloading the weapon will draw the demons to us.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(132278,'I\'m with you.','I\'m with you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132283,'Soon the entire Legion will descend upon us.','',1,0,0,0,0,0,0,0,0,0,86215,0,26124),
(132284,'We will hold our ground. I only pray there are survivors among the Army of the Light.','',1,0,0,0,0,0,0,0,0,0,86216,0,26124),
(132285,'It is resisting my spell. This is no mere siege weapon...','',0,0,0,0,0,0,0,0,0,0,86217,0,26124),
(132286,'By the Light...','',396,0,0,0,0,0,0,0,0,0,86218,0,26124),
(132295,'It\'s alive!','',0,0,0,0,0,0,0,0,0,0,86219,0,26124),
(132298,'Keep its attention, Illidan. We have not come this far to fall now!','',0,0,0,0,0,0,0,0,0,0,86207,0,26124),
(132299,'I\'ll do far more than that.','',0,0,0,0,0,0,0,0,0,0,86208,0,26124),
(132300,'The Xenedar\'s fall shall not have been in vain!','',0,0,0,0,0,0,0,0,0,0,86209,0,26124),
(132301,'Feel the hatred of ten thousand years!','',0,0,0,0,0,0,0,0,0,0,86210,0,26124),
(132302,'It is not my destiny to fall at your hands, monster. I have unfinished business with your master.','',0,0,0,0,0,0,0,0,0,0,86211,0,26124),
(132303,'Hold fast, $p. The goliath wavers!','',0,0,0,0,0,0,0,0,0,0,86212,0,26124),
(132304,'Seize the power of the portals, Alleria! It can become your weapon!','',0,0,0,0,0,0,0,0,0,0,88269,0,26124),
(132305,'','If we can trap this fiend, I can siphon his energy to keep him in check. Champions, I\'ll provide the traps; you deal with capturing him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132348,'Hey, that\'s ours! We saw it first!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132349,'Quickly, quickly! Someone tell the quartermaster!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132350,'This is quite a find. We\'ll be taking it from here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132352,'Focus your mind. Remember your training.','',0,0,0,0,0,0,0,0,0,0,87858,0,26124),
(132353,'','Arator! Turalyon!?',0,0,0,0,0,0,0,0,0,0,0,87496,26124),
(132354,'The Void shows only half truths. Trust your instincts.','',0,0,0,0,0,0,0,0,0,0,87859,0,26124),
(132355,'','I can\'t-- I-- Argh!',0,0,0,0,0,0,0,0,0,0,0,87497,26124),
(132356,'','I won\'t let you! I am not yours to claim!',0,0,0,0,0,0,0,0,0,0,0,87498,26124),
(132357,'','Begone, wretched darkness.',0,0,0,0,0,0,0,0,0,0,0,87499,26124),
(132358,'Fight, curse you!','',0,0,0,0,0,0,0,0,0,0,87860,0,26124),
(132359,'Be sure to collect our prize, fleshling. I will tend to Alleria.','',0,0,0,0,0,0,0,0,0,0,87861,0,26124),
(132360,'The heart of a demigod. This is no mere token, Alleria.','',0,0,0,0,0,0,0,0,0,0,87862,0,26124),
(132361,'Take it, and you will be one step closer to your destiny.','',0,0,0,0,0,0,0,0,0,0,87863,0,26124),
(132362,'','I understand. Thank you. Both of you.',0,0,0,0,0,0,0,0,0,0,0,87500,26124),
(132363,'','It\'s... cold.',0,0,0,0,0,0,0,0,0,0,0,87501,26124),
(132366,'Need gold? Here\'s 50,000 coins worth.','Need gold? Here\'s 50,000 coins worth.',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(132367,'They are closing in. Ready yourself, $p.','',0,0,0,0,0,0,0,0,0,0,86180,0,26124),
(132368,'50,000 Gold','50,000 Gold',1,0,0,0,0,0,0,0,1,0,0,0,26124),
(132369,'Ah, you\'re alive! A beacon is inbound.','',0,0,0,0,0,0,0,0,0,0,87669,0,26124),
(132370,'Hatuun\'s people saved me from the Xenedar\'s fall.','',0,0,0,0,0,0,1,0,0,0,86198,0,26124),
(132371,'Many others were not so fortunate. They hold the ground around the crash site, fighting for their lives.','',0,0,0,0,0,0,1,0,0,0,86199,0,26124),
(132372,'Farewell for now.','',0,0,0,0,0,0,0,0,0,0,87864,0,26124),
(132373,'','Greetings, $n. You probably don\'t remember me, we met next week. Would you like to revisit the Black Temple?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132375,'Send me into the Black Temple. (Timewalking Raid)','Send me into the Black Temple.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132378,'Greetings, and welcome to the Mythic Invitational!\n\nI can teleport you directly into any Legion dungeon instance.\n\nMake sure you have Mythic difficulty selected before teleporting.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132379,'I agree. I noticed Legion slaves fleeing as we pressed our attack.','',0,0,0,0,0,0,6,0,0,0,86222,0,26124),
(132380,'They could be valuable allies in our fight.','',0,0,0,0,0,0,1,0,0,0,86223,0,26124),
(132381,'I want to go to Karazhan (Dungeon).','I want to go to Karazhan (Dungeon).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132382,'You assume much of their loyalties. Risk your life if you must. I will prepare our forces for the inevitable counterattack.','',0,0,0,0,0,0,396,0,0,0,86224,0,26124),
(132383,'As you wish. Come, $p. I can feel their presence not far from here.','',0,0,0,0,0,0,0,0,0,0,86225,0,26124),
(132384,'Not all of my people left Argus when Archimonde and Kil\'jaeden made their pact with the Dark Titan.','',0,0,0,0,0,0,0,0,0,0,86226,0,26124),
(132385,'Many joined the Legion willingly, giving in to Sargeras\' false promises of power and glory.','',0,0,0,0,0,0,0,0,0,0,86227,0,26124),
(132386,'Those who realized the truth sought escape, but found themselves trapped in this nightmare. How they have survived this long I do not know.','',0,0,0,0,0,0,0,0,0,0,86228,0,26124),
(132387,'Return the talbuk to the Krokul at the entrance to the forest!','Return the talbuk to the Krokul at the entrance to the forest!',0,0,0,0,0,0,0,0,0,50158,0,0,26124),
(132388,'Place the beacon at my location. We\'re coming home.','',0,0,0,0,0,0,0,0,0,0,86505,0,26124),
(132389,'Our troops will finish securing the Xenedar. Though we retrieved its most precious cargo, we cannot let the vessel fall into the Legion\'s hands.','',0,0,0,0,0,0,0,0,0,0,86509,0,26124),
(132390,'','<Insert neat RP moment where she absorbs the Heart of Nhal\'atoth here.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132409,'','The greatest wound imaginable is that our people would betray us so. It still festers, so many years later.$b$bWounds such as these must be cleansed, purified. The rot must be excised and destroyed before true healing can begin.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132410,'','Did somebody call for the doctor? Too bad, there are Legion to fight!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132411,'','Are you wounded? You seem fine. I\'m sure a fine meal will bring you back to fighting shape in no time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132412,'','These traitors will never defeat us, for we walk in the Light.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132413,'Their next blast will decimate us--unless we strike first.','',0,0,0,0,0,0,1,0,0,0,88149,0,26124),
(132414,'We must destroy the weapon while it is still recharging! Romuul, deploy a beacon below!','',0,0,0,0,0,0,1,0,0,0,87925,0,26124),
(132417,'Beacon deployed, Prophet!','',0,0,0,0,0,0,0,0,0,0,86205,0,26124),
(132418,'','Have you come to give us reprieve from the ceaseless tide?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132419,'Activating transport array.','',0,0,0,0,0,0,0,0,0,0,86141,0,26124),
(132420,'On your mark, $p.','',0,0,0,0,0,0,0,0,0,0,86142,0,26124),
(132421,'','Few among us still wield true magic after we saw what tempted our brethren. I will take any advantage I can get.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132422,'','By blade and spell, we make our stand against our enemies. We cannot rely too heavily on one or the other.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132423,'','Bormos over there has a great saying for times like this: \"Give me a hundred Lightforged. Barring that, a thousand regular troops.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132424,'Enemy contact. Deploying arsenal.','',0,0,0,0,0,0,0,0,0,0,86402,0,26124),
(132425,'','Our people were greedy, lusting for power. I have faith in the Light, and I have all the power I need to show them the error of their ways.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132426,'Enemy combatants detected. Threat level nominal.','',0,0,0,0,0,0,0,0,0,0,86397,0,26124),
(132427,'Targets cleared.','',0,0,0,0,0,0,0,0,0,0,86401,0,26124),
(132428,'Critical system failure...','',0,0,0,0,0,0,0,0,0,0,86398,0,26124),
(132429,'Targets acquired for decimation.','',0,0,0,0,0,0,0,0,0,0,86393,0,26124),
(132430,'Cannon primed for annihilation.','',0,0,0,0,0,0,0,0,0,0,86394,0,26124),
(132431,'Weapon system primed, target locked.','',0,0,0,0,0,0,0,0,0,0,86395,0,26124),
(132432,'Leave none alive.','',0,0,0,0,0,0,0,0,0,0,86396,0,26124),
(132433,'Apocalypse drive engaged.','',0,0,0,0,0,0,0,0,0,0,86399,0,26124),
(132434,'Systems re-engaged, rerouting power. Weapons primed.','',0,0,0,0,0,0,0,0,0,0,86400,0,26124),
(132435,'One shot, one kill.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132436,'While vile demons still draw breath, there can be no peace.$b$bWhile faithless traitors still live, there can be no forgiveness.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132437,'I understand it when my quarry runs. However, they are only going to die tired.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132438,'They\'ve got us surrounded again. Poor fools.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132439,'','Take off yer shoes, grab a grog, and share a joke with me!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(132440,'Sure, tell me a joke.','Sure, tell me a joke.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132441,'Your jokes are the best!','Your jokes are the best!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132442,'Your jokes are terrible!','Your jokes are terrible!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132443,'The Light guides my arrow. There is nowhere the darkness can hide when exposed to its glorious incandescence.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132445,'','Yeah? Well yer face is terrible... and so is yer mother!',0,0,0,0,0,0,14,0,0,0,0,0,26124),
(132446,'','Ha! I\'d like to see ye do better, scallywag!',0,0,0,0,0,0,14,0,0,0,0,0,26124),
(132447,'','Go keelhaul yerself, ye bilge-sucking carouser.',0,0,0,0,0,0,14,0,0,0,0,0,26124),
(132448,'','I\'ll cleave ye to the brisket!',0,0,0,0,0,0,14,0,0,0,0,0,26124),
(132449,'','Shut yer trap or I\'ll run ye through, ye pathetic pirate wannabe!',0,0,0,0,0,0,14,0,0,0,0,0,26124),
(132451,'','Shut yer squiffy grog hole and walk the plank, ye son of a biscuit eater!',0,0,0,0,0,0,14,0,0,0,0,0,26124),
(132452,'','Go dance with Jack Ketch, and leave the jokes to the old salt.',0,0,0,0,0,0,14,0,0,0,0,0,26124),
(132454,'','A black spot upon ye and all yer cockroach friends!',0,0,0,0,0,0,14,0,0,0,0,0,26124),
(132455,'','Thank ye kindly, ye old sea dog.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(132456,'','I\'ll cut ye fer... Oh wait, ye liked em? Thank ye. Nobody ever says they like \'em.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(132457,'','I\'ve trained over countless oceans and pillages. This be authentic pirate humor!',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(132458,'','Yarrr! Splice the mainbrace!',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(132459,'','No hornswaggle? I thank ye kindly for that, friend.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(132460,'','Aye, then buy me a clap of thunder, would ye?',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(132461,'','Spread the word. Tell \'em ol\' Bad News ain\'t so bad afterall.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(132462,'','Thank ye, matey. Treasure ain\'t always found in chests.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(132463,'','Alright, batten down yer hatches, mateys. This one\'ll blow yer rudder off...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(132464,'','Ha, now someone get me a grog.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(132465,'','I was drinkin\' with a Dread Crew gunner in Booty Bay last week...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(132466,'','After a few drinks, he looked me in the eyes and asked how the Bloodsail got to be so great...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(132467,'','I raised my mug and told him we just ARRR!',0,0,0,0,0,0,4,0,0,0,0,0,26124),
(132468,'Come, let us show Sargeras\' ilk what they have brought upon themselves.','',0,0,0,0,0,0,0,0,0,0,86143,0,26124),
(132469,'Hold your ground! We must protect the Vindicaar with our lives!','',0,0,0,0,0,0,0,0,0,0,86144,0,26124),
(132470,'Hello, $p! Come learn about Moonkin at the Moonkin Festival in Moonglade!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132471,'The Moonkin Festival is soon! Come to Moonglade when it starts to find out what it\'s all about!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132472,'The Moonkin Festival begins soon! Be sure to visit Moonglade when it starts to learn more!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132473,'Learn the ways of the Moonkin at the Moonkin Festival in Moonglade!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132474,'','So I was gettin\' me ears pierced by Pretty Boy Duncan on the Brashtide yesterday...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(132475,'','Ye know how he is. Always a perfectionist. Took two hours, and at the end of it I asked him how much I owed. He said...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(132476,'','Just a buccaneer!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(132477,'','So Captain Salthoof got his first ship pretty quickly, right?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(132478,'','I asked him how much he had to bribe the admiral with to make that happen, and he told me his secret...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(132479,'','He got it on sail!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(132480,'','This is one of \'em brain puzzles...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(132481,'','What has six legs, six hands, and six eyes?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(132482,'','Six pirates!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(132483,'','Ye all know crazy Rear Admiral Giggleplanks, right?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(132484,'','Did ye know he once used his gnomish gizmos to combine a parrot and shark into the ultimate pirate companion?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(132485,'','It worked great... until it talked his ear off!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(132486,'','So what\'s the deal with treasure chests nowadays? They\'re so expensive and shiny...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(132487,'','It\'s like we want people to find \'em! All that shiny gold edging and gem-encrusted locks...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(132488,'','It\'s like, are we storing treasure on the OUTside or the INside? Right?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(132489,'Your mother and father yet live, Arator. I am sure of it. But for now, stay focused on the fight to come.','',0,0,0,0,0,0,1,0,0,0,87998,0,26124),
(132496,'We are legion!','We are legion!',0,0,0,0,0,0,0,0,0,0,86690,86691,26124),
(132497,'I am the fury of a thousand conquered worlds.','I am the fury of a thousand conquered worlds.',0,0,0,0,0,0,0,0,0,0,86692,86693,26124),
(132498,'You have seen but a fraction of our might.','You have seen but a fraction of our might.',0,0,0,0,0,0,0,0,0,0,86694,86695,26124),
(132499,'I will be heralded for your demise.','I will be heralded for your demise.',0,0,0,0,0,0,0,0,0,0,86696,86697,26124),
(132500,'Azeroth will fall!','Azeroth will fall!',0,0,0,0,0,0,0,0,0,0,86698,86699,26124),
(132501,'You dare set foot in our world?','You dare set foot in our world?',0,0,0,0,0,0,0,0,0,0,86700,86701,26124),
(132502,'Bow before the master\'s armies!','Bow before the master\'s armies!',0,0,0,0,0,0,0,0,0,0,86702,86703,26124),
(132503,'You will know true pain!','You will know true pain!',0,0,0,0,0,0,0,0,0,0,86704,86705,26124),
(132504,'','We are legion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132505,'','I am the fury of a thousand conquered worlds.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132506,'','You have seen but a fraction of our might.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132507,'','I will be heralded for your demise.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132508,'','Azeroth will fall!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132509,'','You dare set foot in our world?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132510,'','Bow before the master\'s armies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132511,'','You will know true pain!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132512,'Burn in the flames of Sargeras!','Burn in the flames of Sargeras!',0,0,0,0,0,0,0,0,0,0,86674,86675,26124),
(132513,'Fuel for the fel.','Fuel for the fel.',0,0,0,0,0,0,0,0,0,0,86676,86677,26124),
(132514,'None can stop our crusade!','None can stop our crusade!',0,0,0,0,0,0,0,0,0,0,86678,86679,26124),
(132515,'Azeroth will be ours.','Azeroth will be ours.',0,0,0,0,0,0,0,0,0,0,86680,86681,26124),
(132516,'Bare your soul to me.','Bare your soul to me.',0,0,0,0,0,0,0,0,0,0,86682,86683,26124),
(132517,'Chaos reigns.','Chaos reigns.',0,0,0,0,0,0,0,0,0,0,86684,86685,26124),
(132518,'All will bow before the Destroyer.','All will bow before the Destroyer.',0,0,0,0,0,0,0,0,0,0,86686,86687,26124),
(132519,'You are doomed.','You are doomed.',0,0,0,0,0,0,0,0,0,0,86688,86689,26124),
(132520,'','Burn in the flames of Sargeras!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132521,'','Fuel for the fel.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132522,'','None can stop our crusade!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132523,'','Azeroth will be ours.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132524,'','Bare your soul to me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132525,'','Chaos reigns.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132526,'','All will bow before the Destroyer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132527,'','You are doomed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132528,'Lend me your strength, $p. We will finish this together!','',0,0,0,0,0,0,0,0,0,0,87928,0,26124),
(132529,'Aardon\'sha, kir kah\'los!','',0,0,0,0,0,0,0,0,0,0,87929,0,26124),
(132530,'','Now it says here that their leader is up on one of those floating discs above us. Time to go take him out!',0,0,0,0,0,0,0,0,0,0,0,85524,26124),
(132535,'We will join you at the weapon, $p.','',0,0,0,0,0,0,396,0,0,0,86220,0,26124),
(132538,'You must stop... the great nightmare...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132539,'Seek your answer... by the water...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132540,'Your attacker lies... within the dragon\'s palm...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132542,'Say the word when you are ready to begin. No doubt we will soon have company.','',0,0,0,0,0,0,396,0,0,0,86206,0,26124),
(132543,'','<The essence of Eonar hovers before you. Though her beauty and purity is palpable, you can sense her sorrow and dread.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132546,'We will defend you, Lifebinder.','We will defend you, Lifebinder.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132551,'I am ready to go to the Arcatraz.','I am ready to go to the Arcatraz.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132552,'Greetings.','',0,0,0,0,0,0,0,0,0,0,86328,0,26124),
(132553,'Get your outfits ready! The Trial of Style starts soon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132554,'Hey, $p. You need to step up your style game. The Trial of Style begins soon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132555,'Visit Warpweaver Tuviss in Dalaran or any other Transmogrifier to enter the Trial of Style!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132556,'Think you\'re a trend setter? Visit Warpweaver Tuviss or any Transmogrifier to enter the Trial of Style!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132557,'Help me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132558,'Stop this torment...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132559,'The enemy... they\'re... in the dream...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132561,'What was it you said again?','What was it you said again?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132567,'','You\'ve got to work on your moves, $p! We\'re going to be hosting dance parties in the Stormwind and Orgrimmar auction houses!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132568,'','We\'re going to be taking over the Stormwind and Orgrimmar auction houses for a dance party! I better see you there!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132569,'','Everybody dance now! We\'ve taken over the Stormwind and Orgrimmar auction houses for a dance party!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132570,'','Come and bring your good vibes to our dance parties at the Stormwind and Orgrimmar auction houses!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132577,'Ready when you are.','Ready when you are.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132578,'','I think we should start our investigation by talking to a bronze dragon of some sort.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132582,'The Kirin Tor will be sponsoring a Tavern Crawl soon! Come to the Legerdemain Lounge when it starts and try some tasty drinks and food!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132583,'I know this shrine has been abandoned for a few years now, but... really? Shambling skeletal remains? Father would never have approved of this.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132584,'Me? Why does everyone always suspect the black dragon? I\'m ashamed, Chronormu.$b$bNo, I know nothing about an attack. I was simply visiting Northrend for... my own amusement, let\'s say. I was, however, surprised to see this skeletal infestation here in our beloved dragonshrine. If you\'re looking for someone who might take umbrage at a dragon, you might start with these undead, and whomever might be controlling them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132585,'','How can I help you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132586,'','We are. Usually only one or two stray ghouls trickle in each day, but today they\'ve attacked in numbers we haven\'t seen in nearly ten years.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132587,'','Yes? What is it I can do for you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132588,'','We have. The dreamers have been restless. It\'s been... overwhelming.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132589,'Yes? What does the bronze dragonflight want here?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132590,'Honestly, I\'m not sure. It\'s quite possible. The ley lines have always been fussy in this part of the world, but today, they\'re acting particularly strange. There\'s something interfering with them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132591,'We\'re trying to find out who\'s about to attack Chromie. We thought you might know something.','We\'re trying to find out who\'s about to attack Chromie. We thought you might know something.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132592,'Understood.','Understood.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132593,'We\'re trying to find out who\'s about to attack Chromie. We heard you were having problems with the undead.','We\'re trying to find out who\'s about to attack Chromie. We heard you were having problems with the undead.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132594,'We will help you defend the dragonshrine.','We will help you defend the dragonshrine.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132595,'We\'re trying to find out who\'s about to attack Chromie. Seen anything strange?','We\'re trying to find out who\'s about to attack Chromie. Seen anything strange?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132596,'We can help.','We can help.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132597,'We\'re trying to find out who\'s about to attack Chromie. We\'ve heard you\'re having trouble with the ley lines - do you think that could be related?','We\'re trying to find out who\'s about to attack Chromie. We\'ve heard you\'re having trouble with the ley lines - do you think that could be related?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132598,'We can help.','We can help.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132610,'The source of Raalgar\'s immortality is gone. At long last you can kill him and retrieve the Fel Heart of Argus.','',0,0,0,0,0,0,0,0,0,0,87667,0,26124),
(132612,'I hope you\'re thirsty, $p! Visit Anebria Sunwine in the Legerdemain Lounge to join the others on the Kirin Tor Tavern Crawl!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132618,'Drink and be merry during the Kirin Tor Tavern Crawl! Go find Anebria Sunwine at the Legerdemain Lounge to join the others!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132630,'|TInterface\\ICONS\\ABILITY_HUNTER_SNIPERSHOT.BLP:20|t You are targeted for |cFFF00000|Hspell:244536|h[Fel Bombardment]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(132631,'|TInterface\\ICONS\\Ability_BossFelMagnaron_HandEmpowered.blp:20|t %s is powering the |cFFF00000|Hspell:244152|h[Apocalypse Drive]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(132632,'','You must go to their aid, Turalyon. I will scout behind enemy lines and provide a distraction. We will return soon, Arator.',0,0,0,0,0,0,1,0,0,0,0,86160,26124),
(132633,'','And what then? I was locked in a cell for delving into the Void against her wishes. Will she make me a prisoner again? Or worse?',0,0,0,0,0,0,0,0,0,0,0,86600,26124),
(132637,'What is it, Romuul?','What is it, Romuul?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132638,'For a new vessel, the Vindicaar\'s list of repairs is endless. How can I help you?','',0,0,0,0,0,0,0,0,0,0,87668,0,26124),
(132639,'What will happen if the Legion get\'s the Stone before we do?','What will happen if the Legion get\'s the Stone before we do?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132640,'REUSE ME','',5,1,0,0,0,0,0,0,0,0,0,0,26124),
(132641,'REUSE ME','',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(132642,'Can you tell me where to look?','Can you tell me where to look?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132643,'REUSE ME','',5,1,0,0,0,0,0,0,0,0,0,0,26124),
(132644,'Thank you, Romuul.','Thank you, Romuul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132647,'REUSE ME','',5,1,0,0,0,0,0,0,0,0,0,0,26124),
(132649,'Make quick work of this intruder. Lah\'zaruun needs time to get the High Inquisitor to Argus!','Make quick work of this intruder. Lah\'zaruun needs time to get the High Inquisitor to Argus!',0,0,0,0,0,0,0,0,0,0,0,87381,26124),
(132652,'Ah, the hero comes too late. Our mistress will have freed the High Inquisitor by now.','Ah, the hero comes too late. Our mistress will have freed the High Inquisitor by now.',0,0,0,0,0,0,0,0,0,0,0,87382,26124),
(132658,'','|TInterface\\Icons\\INV_Misc_Herb_Arrowbloom.blp:20|tCaptain Yathae Moonstrike is aiming |cFFFF0000|Hspell:236304|h[Incorporeal Shot]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(132659,'','|TInterface\\Icons\\ABILITY_DRUID_ECLIPSE.BLP:20|tPriestess Lunaspyre has cast |cFFFF0000|Hspell:233263|h[Embrace of the Eclipse]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(132660,'','|TInterface\\Icons\\ABILITY_UPGRADEMOONGLAIVE.BLP:20|tHuntress Kasparian is casting |cFFFF0000|Hspell:236480|h[Glaive Storm]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(132664,'A swarm of demons threaten the Vindicaar once more. Send their fetid souls screaming back to the halls of Antorus.','',0,0,0,0,0,0,0,0,0,0,86071,0,26124),
(132665,'Well fought. Should the Legion ever bring down the Vindicaar, Argus will be our grave.','',0,0,0,0,0,0,0,0,0,0,86072,0,26124),
(132666,'The High Inquisitor\'s return bodes well for us. Argus will soon be rid of this vermin.','The High Inquisitor\'s return bodes well for us. Argus will soon be rid of this vermin.',0,0,0,0,0,0,0,0,0,0,0,88509,26124),
(132685,'Good work. Velen and I will meet you at the Crown of Destruction to stop the antaen while we still can.','',0,0,0,0,0,0,0,0,0,0,86326,0,26124),
(132686,'Prepare yourselves to board the Vindicaar. Raalgar will be ready soon.','Prepare yourselves to board the Vindicaar. Raalgar will be ready soon.',397,0,0,0,0,0,0,0,0,0,86870,86871,26124),
(132687,'Yes, captain!','Yes, captain!',0,0,0,0,0,0,0,0,0,0,86868,86869,26124),
(132689,'I was so close! You are not worthy to stop me, worm!','',0,0,0,0,0,0,0,0,0,0,87807,0,26124),
(132694,'','And what then? She had me locked in a cell for harnessing the power of the Void. Will she put me in chains for my defiance? Or worse?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132695,'I sense Xe\'ra in the central chamber. Thank the Light! We are not too late.','',0,0,0,0,0,0,0,0,0,0,86515,0,26124),
(132697,'Xe\'ra will see that you risked your life to save her. Her faith in you will be restored--I know it!','',0,0,0,0,0,0,0,0,0,0,86516,0,26124),
(132698,'Come, champion. Help me guide her to the Vindicaar. Then we can get out of here!','',0,0,0,0,0,0,0,0,0,0,86513,0,26124),
(132699,'Xe\'ra! Don\'t worry, you are safe now.','',0,0,0,0,0,0,0,0,0,0,86514,0,26124),
(132700,'','The upper deck of the ship is this way. Xe\'ra will have much to say... to all of us.',0,0,0,0,0,0,0,0,0,0,0,87488,26124),
(132701,'','Oh, but I was just getting started. She will make a fine ornament for the Burning Throne!',0,0,0,0,0,0,0,0,0,0,0,86601,26124),
(132702,'','No! This trophy is mine! A gift for our great master!',0,0,0,0,0,0,0,0,0,0,0,86602,26124),
(132703,'','You will lose in the end. The Sisters will see...',0,0,0,0,0,0,0,0,0,0,0,86603,26124),
(132704,'Look out!','',0,0,0,0,0,0,0,0,0,0,86213,0,26124),
(132705,'Whatever that thing was, I doubt that was the only one in Sargeras\' arsenal.','',0,0,0,0,0,0,0,0,0,0,86214,0,26124),
(132708,'I will bear the brunt of its attacks for as long as I can, but you must destroy it while we still stand!','',0,0,0,0,0,0,0,0,0,0,86156,0,26124),
(132709,'Then let us see it done. We stand together.','',0,0,0,0,0,0,0,0,0,0,86153,0,26124),
(132715,'','Archenon poros, Prophet. The Army of the Light stands with you.',0,0,0,0,0,0,66,0,0,0,0,87650,26124),
(132716,'We seek the Sigil of Awakening. Archimonde may have left it in the Conservatory.','',0,0,0,0,0,0,397,0,0,0,87954,0,26124),
(132717,'','Understood. I have just the person for the job: Y\'mera.',0,0,0,0,0,0,397,0,0,0,0,87651,26124),
(132718,'','Right away, Captain.',0,0,0,0,0,0,66,0,0,0,0,87594,26124),
(132719,'','Enaara, see that these spirits remain under control.',0,0,0,0,0,0,397,0,0,0,0,87652,26124),
(132720,'One minute till Blight Boar takes the stage! Join us in the Cauldron of Rock on the east side of the island.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(132721,'','The rest of you, secure the area.',0,0,0,0,0,0,1,0,0,0,0,87653,26124),
(132722,'|TInterface\\Icons\\WARRIOR_DISRUPTINGSHOUT.BLP:20|tDevlynn Styx leaps down to unleash her |cFFFF0000|Hspell:245150|h[Screams]|h|r at the Death Metal Knight!','|TInterface\\Icons\\WARRIOR_DISRUPTINGSHOUT.BLP:20|tDevlynn Styx leaps down to unleash her |cFFFF0000|Hspell:245150|h[Screams]|h|r at the Death Metal Knight!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132723,'|TInterface\\Icons\\SPELL_DEATHKNIGHT_ARMYOFTHEDEAD.BLP:20|tThe Metal Knight summons an |cFFFF0000|Hspell:245162|h[Army of the Dead]|h|r to attack Devlynn Styx!','|TInterface\\Icons\\SPELL_DEATHKNIGHT_ARMYOFTHEDEAD.BLP:20|tThe Metal Knight summons an |cFFFF0000|Hspell:245162|h[Army of the Dead]|h|r to attack Devlynn Styx!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132726,'The dragon comes! Felstalkers, hunt her down!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132728,'','Hmm. The Gatekeeper is inactive.',0,0,0,0,0,0,6,0,0,0,0,87595,26124),
(132729,'','With the power of the seal we can travel directly to the Chamber of the Avatar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132730,'Teleport to the Chamber of the Avatar.','Teleport to the Chamber of the Avatar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132731,'The legion must be stopped!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132732,'Return to The Breach.','Return to The Breach.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132738,'','Would you look at the time! Only about ten minutes left...',0,0,0,0,0,0,0,0,0,0,0,85608,26124),
(132739,'','There\'s five minutes left. You think we\'ll finish in time?',0,0,0,0,0,0,0,0,0,0,0,85607,26124),
(132740,'','One minute remaining. Cutting it a little close, aren\'t we?',0,0,0,0,0,0,0,0,0,0,0,85606,26124),
(132741,'','I sense treasure nearby.',0,0,0,0,0,0,0,0,0,0,0,85605,26124),
(132742,'','Can you feel it? There\'s treasure somewhere around here.',0,0,0,0,0,0,0,0,0,0,0,85604,26124),
(132743,'','Freeze!',0,0,0,0,0,0,0,0,0,0,0,85603,26124),
(132744,'','Stop right there!',0,0,0,0,0,0,0,0,0,0,0,85602,26124),
(132745,'In the other corner, a golem with a magnetic personality. Watch out, this golem\'s gonna Klunk you up!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132746,'','In the other corner, a golem with a magnetic personality. Watch out, this golem\'s gonna Klunk you up!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132747,'The way is clear. Fire!','',0,0,0,0,0,0,0,0,0,0,86145,0,26124),
(132748,'Be purged by the Light!','',0,0,0,0,0,0,0,0,0,0,86146,0,26124),
(132749,'Behold the might of the Vindicaar!','',0,0,0,0,0,0,0,0,0,0,86147,0,26124),
(132750,'Legion Devastators are pummeling our forces. Lower their protective barriers and we will show them the power of the Vindicaar!','',0,0,0,0,0,0,0,0,0,0,86063,0,26124),
(132751,'Excellent work. The Vindicaar is safe once more.','',0,0,0,0,0,0,0,0,0,0,86064,0,26124),
(132793,'Once we prevent it from firing, the antaen will surely turn its attack upon us.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(132798,'Prepare yourselves. It rises!','',0,0,0,0,0,0,0,0,0,0,86155,0,26124),
(132799,'We cannot handle another attack from these creatures. We must end this now.','',0,0,0,0,0,0,0,0,0,0,86151,0,26124),
(132800,'I will overwhelm it with energy before it can fire. I need only a moment.','',0,0,0,0,0,0,0,0,0,0,86152,0,26124),
(132801,'It... is... working!','',0,0,0,0,0,0,0,0,0,0,86154,0,26124),
(132802,'','I will defend Argus to my dying breath!',0,0,0,0,0,0,0,0,0,0,0,86604,26124),
(132803,'','The armies of a thousand worlds will rise against you. You are damned!',0,0,0,0,0,0,0,0,0,0,0,86606,26124),
(132804,'','Do you think me a fool? Fiends, to me!',0,0,0,0,0,0,0,0,0,0,0,86607,26124),
(132805,'','I will be reborn by Argus\' flame! I will never... stop... fighting.',0,0,0,0,0,0,0,0,0,0,0,86605,26124),
(132806,'Somethin\' smell off about this grain to you?','Somethin\' smell off about this grain to you?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(132807,'A bit, I guess. Not my problem.','A bit, I guess. Not my problem.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132808,'Easy there, Pepper. What\'s gotten into you?','Easy there, Pepper. What\'s gotten into you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132809,'$n is looking for an opponent!','$n is looking for an opponent!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132810,'So much grain! The farmers really outdid themselves this week.','So much grain! The farmers really outdid themselves this week.',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(132811,'Better start distributing it to the rest of the townsfolk. People need to eat.','Better start distributing it to the rest of the townsfolk. People need to eat.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132812,'','What on earth was that?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132813,'$n wins the match!','$n wins the match!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132814,'','Champions! The forces of the Legion seek to capture my essence for their infernal master!',0,0,0,0,0,0,0,0,0,0,0,88212,26124),
(132815,'','Defeat them before they reach me, or all is lost.',0,0,0,0,0,0,0,0,0,0,0,88213,26124),
(132816,'','My resistance wanes. Should Sargeras prevail, all life will fall to darkness.',0,0,0,0,0,0,0,0,0,0,0,88214,26124),
(132817,'','The last of my strength... ebbs away. I will not... be able to stop them...',0,0,0,0,0,0,0,0,0,0,0,88215,26124),
(132818,'','It ends. My life... forever bound... to Sargeras...',0,0,0,0,0,0,0,0,0,0,0,88216,26124),
(132822,'|TINTERFACE\\ICONS\\WARLOCK_CURSE_SHADOW_AURA.BLP:20|t Void-Blade Zedaat begins to cast |cFFFF0404|Hspell:246340|h[Nether Eruption]|h|r! Run!','|TINTERFACE\\ICONS\\WARLOCK_CURSE_SHADOW_AURA.BLP:20|t Void-Blade Zedaat begins to cast |cFFFF0404|Hspell:246340|h[Nether Eruption]|h|r! Run!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132828,'Use this key to go through the Town Hall. You can get to the back roads of Stratholme through there.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132829,'|TINTERFACE\\ICONS\\INV_KNIFE_1H_FIRELANDSRAID_D_01.BLP:20|t Aggramar begins a |cFFFF0404|Hspell:244688|h[Taeshalach Technique]|h|r!','|TINTERFACE\\ICONS\\INV_KNIFE_1H_FIRELANDSRAID_D_01.BLP:20|t Aggramar begins a |cFFFF0404|Hspell:244688|h[Taeshalach Technique]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(132850,'Argus Volcano is erupting.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132851,'The power of the Guardian\'s Seal fades.','The power of the Guardian\'s Seal fades.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132852,'|TInterface\\Icons\\SPELL_SHADOW_PAINSPIKE:20|tA\'nutsu starts casting |cFFFF0404|Hspell:245164|h[Fragment of Despair]|h|r','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132853,'|TINTERFACE\\ICONS\\ability_fixated_state_red.blp:20|t Zuraal the Ascended has fixated on you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132854,'|TInterface\\Icons\\spell_shadow_painspike:20|tYou are afflicted by  |cFFFF0000|Hspell:233983|h[Echoing Anguish]|h|r!','|TInterface\\Icons\\spell_shadow_painspike:20|tYou are afflicted by  |cFFFF0000|Hspell:233983|h[Echoing Anguish]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(132855,'|TInterface\\Icons\\SPELL_FIRE_ELEMENTALDEVASTATION:20|tArmageddon impacted the platform, causing an |cFFFF0000|Hspell:240908|h[Armageddon Blast]|h|r!','|TInterface\\Icons\\SPELL_FIRE_ELEMENTALDEVASTATION:20|tArmageddon impacted the platform, causing an |cFFFF0000|Hspell:|h[Armageddon Blast]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132856,'','I know who you will be fighting.$b$bArchimonde gave them each a title to acknowledge their substantial knowledge of their craft.$b$bSadly, all of them sided with the Legion. This is a rare opportunity to see them as they once were.',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(132857,'Tell me about Grand Vizier Jarasum.','Tell me about Grand Vizier Jarasum.',0,0,0,0,0,0,113,0,0,0,0,0,26124),
(132858,'Tell me about High Wakener Aargon.','Tell me about High Wakener Aargon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132859,'Tell me about Arc-Consul Velara.','Tell me about Arc-Consul Velara.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132860,'','Ah, the Grand Vizier.\n\nHe acted as the Arc-Consul\'s second and oversaw much of the day to day operations in the Conservatory.\n\nWhen discipline was needed, it was often his voice that would ring out. He was not well liked, but he was respected nonetheless.\n\nIt is my understanding that he changed his name to Jaraxxus when he took the Legion\'s fel magics for his own.\n\nBeyond that, I know nothing of his fate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132861,'Tell me about the others.','Tell me about the others.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132862,'','Arc-Consul Velara answered only to Archimonde himself.\n\nShe was a focused and quiet individual, as I recall. Parallel to the Wakener\'s guild, she led the Consulate in the pursuit of the powers of creation.\n\nUnder her tutelage we vastly expanded our ability to summon creatures of the arcane. The familiars that linger here still bear marks of her expertise. She was also largely responsible for cultivating the shield technology that we use even now.\n\nShe took the name Velysra and the title of Archmage when she joined the Legion.\n\nI hope you shall never meet her, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132863,'','High Wakener Aargon. Where to start?\n\nHe ascended to his position only after his predecessor Thal\'kiel was banished. That is a story for another time, if you are not familiar with it. \n\nNeedless to say he was... an opportunist.\n\nUnder his influence we delved deeply into the mysteries of soulbinding. The constructs that roam these streets are his doing. They represent but a fraction of what the Wakeners could do.\n\nUnder the Legion he became Aargoss. \n\nTo the Army of the Light he was known as the Soulcleaver. Where soul engines operated, Aargoss was never far away.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132864,'Speak, stranger.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132865,'I challenge you to a duel.','I challenge you to a duel.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132866,'You will bow when addressing the High Wakener.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132867,'','<Velara looks you over impassively.>\n\nYes?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132868,'You face Jarasum, Grand Vizier of the Conservatory!','',0,0,0,0,0,0,0,0,0,0,87181,0,26124),
(132869,'','I will not restrain myself. Let us begin.',0,0,0,0,0,0,0,0,0,0,0,87571,26124),
(132870,'A fool\'s errand, but I will indulge you.','',0,0,0,0,0,0,0,0,0,0,87759,0,26124),
(132871,'I suppose that qualifies as a victory.','',0,0,0,0,0,0,0,0,0,0,87760,0,26124),
(132872,'Hmph. It is finished then.','',0,0,0,0,0,0,0,0,0,0,87182,0,26124),
(132873,'','Enough. You have proven your worth.',0,0,0,0,0,0,0,0,0,0,0,87572,26124),
(132874,'With Light\'s Heart, we can restore Xe\'ra to her full glory.$b$bThe sooner we do this, the sooner we grow stronger against the Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132875,'Let us begin, Turalyon.','Let us begin, Turalyon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132892,'The Legion has built up stores of ammunition to use against us. Thin out their forces and mark the stockpiles as targets for the Vindicaar\'s guns. Then... get out of the way!','',0,0,0,0,0,0,0,0,0,0,86067,0,26124),
(132894,'ph','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132895,'The Legion\'s cannons have gone silent, thanks to you.','',0,0,0,0,0,0,0,0,0,0,86068,0,26124),
(132898,'|TINTERFACE\\ICONS\\INV_ENCHANT_VOIDSPHERE.BLP:20|t Slay the Void Images before they can cast |cFFFF0404|Hspell:246483|h[Oblivion Tear]|h|r!','|TINTERFACE\\ICONS\\INV_ENCHANT_VOIDSPHERE.BLP:20|t Slay the Void Images before they can cast |cFFFF0404|Hspell:246483|h[Oblivion Tear]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132899,'','Follow me!',0,0,0,0,0,0,0,0,0,0,0,87563,26124),
(132900,'','Take out each of their reinforcement points!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132901,'|TInterface\\ICONS\\ABILITY_MAGE_FIRESTARTER.BLP:20|t You are targeted for |cFFF00000|Hspell:244410|h[Decimation]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(132925,'|TINTERFACE\\ICONS\\SPELL_FEL_INCINERATE.BLP:20|t A legion cruiser prepares to fire a |cFFFF0000|Hspell:244627|h[Fusillade]|h|r!','|TINTERFACE\\ICONS\\SPELL_FEL_INCINERATE.BLP:20|t A legion cruiser prepares to fire a |cFFFF0000|Hspell:244627|h[Fusillade]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132929,'Are you ready to begin the Trial of Tenacity?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132934,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132936,'This challenge is very simple. Enter, and proceed until you reach the other side of the structure.','',0,0,0,0,0,0,0,0,0,0,87979,0,26124),
(132946,'Sorry, I missed that. Can you go back a step?','Sorry, I missed that. Can you go back a step?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132950,'It is designed to kill you. Best of luck.','',0,0,0,0,0,0,0,0,0,0,87980,0,26124),
(132951,'I\'m confused. What did you say before this?','I\'m confused. What did you say before this?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132953,'Try not to let the beams touch you. I imagine it is quite painful.','',0,0,0,0,0,0,0,0,0,0,87981,0,26124),
(132958,'I hear you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132959,'There you are...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132960,'Keep the Ruby Shrinewardens occupied. I shall carry out our master\'s attack from within the great tree itself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132962,'Mind the stairs.','',0,0,0,0,0,0,0,0,0,0,87982,0,26124),
(132970,'If it interests you to know, I was once the keeper of the Conservatory\'s keys, custodian to all of its locks and gates.$b$bTo halt the ravages of time, I placed my soul inside this construct. And so it is that I watch over the Conservatory for all eternity.$b$bIt will forever be my burden to deal with the likes of you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132971,'I see that you are either very fast or very persistent. But is it enough to prove your tenacity I wonder?$b$b<Quoram makes a noise akin to humming.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132972,'Please.','Please.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(132973,'Fine. This trial is complete. Merely because I seem to have run out of space in which to test you.','',0,0,0,0,0,0,0,0,0,0,87983,0,26124),
(132995,'Fools! We shall push you back. Our mission will not be jeopardized!','',0,0,0,0,0,0,0,0,0,0,87082,0,26124),
(132996,'We will not be pushed out! Bring in more forces from the Void to deal with these intruders!','',0,0,0,0,0,0,0,0,0,0,87083,0,26124),
(132997,'We are being overrun! Get in there and deal with this incursion!','',0,0,0,0,0,0,0,0,0,0,87084,0,26124),
(132998,'It seems this nuisance requires a more personal touch. I shall handle you myself!','',0,0,0,0,0,0,0,0,0,0,87085,0,26124),
(133000,'Your help is most welcome, Fareeya.','',0,0,0,0,0,0,2,0,0,0,87924,0,26124),
(133010,'Yes, master. It shall be done, at the exact time that you specified. The bronze dragon will see nothing. One shot from outside the Obsidian Dragonshrine is all I require.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133015,'Oh, you made it. Wonderful.','',0,0,0,0,0,0,0,0,0,0,87978,0,26124),
(133016,'I suppose you would like me to return you to the Conservatory entrance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133017,'Is the trial complete?','Is the trial complete?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133018,'Your interference will not impede our progress. All will serve the void, or fall to it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133019,'Now you shall see firsthand the fruits of our labor. Behold, Zuraal the Ascended! The first to embrace the void in its entirety!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133020,'','You found it! Such power... I can feel it from here.',0,0,0,0,0,0,0,0,0,0,0,87577,26124),
(133021,'','Bring it to me--quickly. We have established a safe perimeter below.',0,0,0,0,0,0,0,0,0,0,0,87578,26124),
(133022,'The Necrodark... I thought those vile cultists had been wiped out long ago.\n\nNo time like the present to finish the job. I can take us into Neltharion\'s Vault.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133027,'Chromie has died.','Chromie has died.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(133028,'|TInterface\\ICONS\\SPELL_WARLOCK_DEMONICPORTAL_PURPLE:20|tA void tear has appeared at the Crumbling Ruins!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133029,'|TInterface\\ICONS\\SPELL_WARLOCK_DEMONICPORTAL_PURPLE:20|tA void tear has appeared at the Lower Nether Gate!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133030,'|TInterface\\ICONS\\SPELL_WARLOCK_DEMONICPORTAL_PURPLE:20|tA void tear has appeared at the Upper Void Breach!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133031,'|TInterface\\ICONS\\SPELL_WARLOCK_DEMONICPORTAL_PURPLE:20|tA void tear has appeared at the Lower Void Breach!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133032,'|TInterface\\ICONS\\SPELL_WARLOCK_DEMONICPORTAL_PURPLE:20|tA void tear has appeared at the Ruined Overlook!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133033,'|TInterface\\ICONS\\SPELL_WARLOCK_DEMONICPORTAL_PURPLE:20|tA void tear has appeared at the Temple Foundation!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133034,'Time is of the essence. We must not let the Legion capture the Prophet.','',0,0,0,0,0,0,0,0,0,0,87734,0,26124),
(133035,'We might already be too late! This is dark news. I hear the ritual chant nearby.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133049,'Tell me what you know about the stone.','Tell me what you know about the stone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133050,'Our people are being used as fodder for vile rituals. Destroy these monstrous creations and help us honor the remains of our dead.','',0,0,0,0,0,0,0,0,4,0,86069,0,26124),
(133051,'Those fiends capture my people and subject them to heinous rituals. We will no longer be hunted. Help us bring the fight to the Legion!','',0,0,0,0,0,0,0,0,4,0,86089,0,26124),
(133052,'As the Legion encroaches upon the hunting grounds of the panthara, the starving beasts have grown more aggressive. Thin their numbers, before they wipe out our talbuk herds.','',0,0,0,0,0,0,0,0,4,0,86081,0,26124),
(133056,'The console displays a number 2.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133057,'The console displays a number 3.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133058,'The console displays a number 4.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133059,'The console displays a number 5.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133060,'The console displays a number 6.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133061,'The console displays a number 7.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133062,'The console displays a number 8.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133063,'The console displays a number 9.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133067,'<Push the lever up.>','<Push the lever up.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133068,'<Pull the lever down.>','<Pull the lever down.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133072,'Do not worry about the attack from the Azure Dragonshrine. I shall dispatch of the void gargantuan.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133073,'Do not worry about the attack from the Obsidian Dragonshrine. I shall dispatch of the dreadlord.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133074,'Do not worry about the attack from the Emerald Dragonshrine. I shall dispatch of the satyr.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133075,'Do not worry about the attack from the Ruby Dragonshrine. I shall dispatch of the lich.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133076,'I see you have already taken care of the dragonshrines. Please accept this blessing from the Bronze Dragonflight.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133077,'|TInterface\\Icons\\TRADE_ARCHAEOLOGY_SHARK JAWS:20|tStraying too close to |cFFFF0000|Hspell:234621|h[Devouring Maw]|h|r will cause |cFFFF0000|Hspell:232885|h[Devour Whole]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(133078,'A Legion troop carrier materializes above the main entrance.','A Legion troop carrier materializes above the main entrance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133079,'A Legion troop carrier materializes above the lower entrance.','A Legion troop carrier materializes above the lower entrance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133080,'A Legion troop carrier materializes above the high temple entrance.','A Legion troop carrier materializes above the high temple entrance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133081,'A Legion cruiser materializes above the main entrance.','A Legion cruiser materializes above the main entrance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133082,'A Legion cruiser materializes above the lower entrance.','A Legion cruiser materializes above the lower entrance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133083,'A Legion cruiser materializes above the high temple entrance.','A Legion cruiser materializes above the high temple entrance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133086,'|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133087,'|TInterface\\Icons\\spell_shadow_summonfelhunter.BLP:24|t','|TInterface\\Icons\\spell_shadow_summonfelhunter.BLP:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133088,'|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133089,'|TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t','|TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133090,'|TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133091,'|TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t','|TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133092,'|TInterface\\Icons\\INV_FelbatMount.blp:24|t','|TInterface\\Icons\\INV_FelbatMount.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133093,'|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133094,'We have many unanswered questions about my brethren\'s fall to madness here in Mac\'Aree. Bring me any memory crystals you find and I will continue my research.','',0,0,0,0,0,0,0,0,0,0,86094,0,26124),
(133095,'It is grim work, reliving the last sane moments of their troubled lives. But it is the best and only way to honor them. Thank you for your help.','',0,0,0,0,0,0,0,0,0,0,86095,0,26124),
(133096,'A Legion troop carrier and cruiser materialize above the main entrance.','A Legion troop carrier and cruiser materialize above the main entrance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133097,'A Legion troop carrier and cruiser materialize above the lower entrance.','A Legion troop carrier and cruiser materialize above the lower entrance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133098,'A Legion troop carrier and cruiser materialize above the high temple entrance.','A Legion troop carrier and cruiser materialize above the high temple entrance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133105,'I\'m ready. Let\'s save your life!\n|cFF0000FF(Start the scenario).|r','I\'m ready. Let\'s save your life!\n|cFF0000FF(Start the scenario).|r',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133106,'A demon dares lead a vanguard on the Vindicaar. A quick death will make clear its master\'s folly.','',0,0,0,0,0,0,0,0,0,0,86083,0,26124),
(133107,'The Legion will stop at nothing to destroy our world. They would do well to remember this defeat.','',0,0,0,0,0,0,0,0,0,0,86084,0,26124),
(133109,'The man\'ari doommaiden Talestra toils to fashion an army of fiends. See to it that she fails.','',0,0,0,0,0,0,0,0,0,0,86085,0,26124),
(133110,'If only we could gaze upon her torment when she returns to Antorus. Sargeras does not take kindly to failure.','',0,0,0,0,0,0,0,0,0,0,86086,0,26124),
(133116,'','The Cenarion Circle cannot sit idly by while Horde and Alliance soldiers mindlessly slay one another. If I can give some solace to some wounded soldiers, I am content.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133117,'<Present the Cenarion Circle documents.>','<Present the Cenarion Circle documents.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133118,'','This - this says that you come bearing orders from Keeper Remulos himself! Very well, what are your orders, $n?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133119,'We need the druids to distract the cannons outside so that a bronze dragon can escape Andorhal.','We need the druids to distract the cannons outside so that a bronze dragon can escape Andorhal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133121,'','Chromie needs our help? Of course. We will distract the cannons so she can fly away safely..',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133135,'Inserting mind larva','Inserting mind larva',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(133145,'|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133146,'|TInterface\\ICONS\\ABILITY_WARLOCK_BACKDRAFTGREEN.BLP:20|t Stand within the impact areas of |cFFF00000|Hspell:244761|h[Annihilate]|h|r to avoid raid damage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(133160,'','The Legion devastates all who oppose us!',0,0,0,0,0,0,0,0,0,0,0,86892,26124),
(133162,'','Is this the best you could muster? Hah. Pathetic.',0,0,0,0,0,0,0,0,0,0,0,86893,26124),
(133163,'','I\'ve slowed down time significantly so we can prepare without wasting any valuable time.$b$bLet me know when you\'re ready to go!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133164,'','Your war ends here.',0,0,0,0,0,0,0,0,0,0,0,86894,26124),
(133165,'','Witness the fate of all who oppose us.',0,0,0,0,0,0,0,0,0,0,0,86881,26124),
(133166,'','Every world in our path has fallen. Yours is next.',0,0,0,0,0,0,0,0,0,0,0,86882,26124),
(133167,'','Witness the power to destroy worlds!',0,0,0,0,0,0,0,0,0,0,0,85747,26124),
(133168,'','Strike them down!',0,0,0,0,0,0,0,0,0,0,0,86883,26124),
(133169,'','Leave none alive!',0,0,0,0,0,0,0,0,0,0,0,86884,26124),
(133170,'','Rend their flesh!',0,0,0,0,0,0,0,0,0,0,0,86885,26124),
(133171,'','Witness Xoroth, a world of infernal heat and scorched bones!',0,0,0,0,0,0,0,0,0,0,0,86888,26124),
(133172,'','Gaze upon Rancora, a landscape of festering pools and skittering death!',0,0,0,0,0,0,0,0,0,0,0,86886,26124),
(133173,'','Nathreza... once a world of magic and knowledge, now a twisted landscape from which none escape.',0,0,0,0,0,0,0,0,0,0,0,86887,26124),
(133174,'','The portals... must... endure...',0,0,0,0,0,0,0,0,0,0,0,86898,26124),
(133175,'','It... cannot... be so...',0,0,0,0,0,0,0,0,0,0,0,86897,26124),
(133176,'','Your world will fall...',0,0,0,0,0,0,0,0,0,0,0,86896,26124),
(133177,'','Know your place!',0,0,0,0,0,0,0,0,0,0,0,86899,26124),
(133178,'','More bones for the pile.',0,0,0,0,0,0,0,0,0,0,0,86900,26124),
(133179,'','So easily broken.',0,0,0,0,0,0,0,0,0,0,0,86901,26124),
(133180,'','Was this truly the best Azeroth had to offer?',0,0,0,0,0,0,0,0,0,0,0,86902,26124),
(133181,'','As you have fallen, so shall Azeroth.',0,0,0,0,0,0,0,0,0,0,0,86903,26124),
(133182,'','The Legion has laid waste to a thousand worlds. Yours will be no different.',0,0,0,0,0,0,0,0,0,0,0,86904,26124),
(133183,'','Your resistance is at an end!',0,0,0,0,0,0,0,0,0,0,0,86895,26124),
(133184,'','The Legion\'s forces throughout the cosmos are mine to command!',0,0,0,0,0,0,0,0,0,0,0,86889,26124),
(133185,'','Our forces are infinite!',0,0,0,0,0,0,0,0,0,0,0,86890,26124),
(133186,'','The wrath of the Legion will overwhelm you!',0,0,0,0,0,0,0,0,0,0,0,86891,26124),
(133187,'<A fissure in the ground, barely wide enough to squeeze through. It\'s too dark to see anything, but you can tell that it is very deep.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133188,'<Drop into the fissure.>','<Drop into the fissure.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133189,'WARNING: You are about to fall into a dark fissure. You may not be able to climb back out again. Are you very sure you want to do this?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133190,'|TInterface\\Icons\\spell_shadow_summonfelhunter.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t','|TInterface\\Icons\\spell_shadow_summonfelhunter.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133191,'|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133192,'','Despite our best efforts, the void continues to seep in through the cracks. Seek out the Army of the Light and use their blessings to banish the darkness once again.',0,0,0,0,0,0,0,0,0,0,0,86097,26124),
(133193,'','We may not be able to restore their sanity, but at least we can prevent more from succumbing.',0,0,0,0,0,0,0,0,0,0,0,86098,26124),
(133194,'','<Enaara offers a gold-wrought crystal to you.>$b$bBanish the darkness, $n. Let the Light prevail.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133195,'<Accept the crystal.>','<Accept the crystal.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133196,'','This place is cursed. Let us shed a little Light on these poor souls.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133202,'|TINTERFACE\\ICONS\\SPELL_FIRE_LAVASPAWN.BLP:20|t An Ember of Taeshalach overloads causing a |cFFFF0404|Hspell:244912|h[Blazing Eruption]|h|r!','|TINTERFACE\\ICONS\\SPELL_FIRE_LAVASPAWN.BLP:20|t An Ember of Taeshalach overloads causing a |cFFFF0404|Hspell:244912|h[Blazing Eruption]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(133203,'|TInterface\\Icons\\SPELL_WARLOCK_SUMMONWRATHGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\SPELL_WARLOCK_SUMMONWRATHGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133205,'|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133206,'|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133208,'|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133209,'Fel Bats start flying down to Eonar\'s platform!','Fel Bats start flying down to Eonar\'s platform!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133210,'The rift collapses, heroes! You must hurry before the entrance closes forever!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133215,'AL\'KSH SYR IIR AWAN? IILTH SYTHN AGEV.','AL\'KSH SYR IIR AWAN? IILTH SYTHN AGEV.',0,0,0,0,0,0,0,0,4,0,0,0,26124),
(133216,'<Recall Kil\'Jaeden\'s attack on Dalaran>','<Recall Kil\'Jaeden\'s attack on Dalaran>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133217,'<Recall the opening of the Tomb of Sargeras>','<Recall the opening of the Tomb of Sargeras>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133218,'<Recall Anduin reclaiming Shalamayne>','<Recall Anduin reclaiming Shalamayne>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133219,'<Recall Kil\'Jaeden\'s defeat>','<Recall Kil\'Jaeden\'s defeat>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133220,'','Together we will see to it that the Legion finally meets their end.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(133221,'','The Legion has run rampant on Azeroth for too long. It is time to see this done.',0,0,0,0,0,0,0,0,0,0,0,87183,26124),
(133222,'Prophet Velen will be pleased that you answered his call. We draenei have long awaited this day.','',0,0,0,0,0,0,1,0,0,0,87999,0,26124),
(133225,'','Impressive. The Legion won\'t expect a force this strong.',0,0,0,0,0,0,0,0,0,0,0,86599,26124),
(133226,'Festerbloat eat puny dragon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133227,'','Death comes for you, little dragon...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133228,'Surrender your life, wyrm!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133229,'The dragon comes! Kill the dragon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133230,'Strange. What are YOU doing here?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133231,'Now know your demise, whelpling. Your timewalking ends here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133232,'The fingers of death coil around your scaly neck, dragonling.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133233,'Your time-twisting days are at an end, whelp!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133234,'Open the portals! Destroy the bronze dragon! Don\'t let it escape!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133235,'','Clever dragon. I\'ve captured you once, and I\'ll do it again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133236,'Destroy the dragon whelp! In the name of the Alliance!','Destroy the dragon whelp! In the name of the Alliance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133237,'Destroy the dragon whelp! For the Horde!','Destroy the dragon whelp! For the Horde!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133238,'|TInterface\\Icons\\ABILITY_ROGUE_SHADOWSTEP:20|tSaprish prepares to strike you with |cFFFF0000|Hspell:247246|h[Umbral Flanking]|h|r!','|TInterface\\Icons\\ABILITY_ROGUE_SHADOWSTEP:20|tSaprish prepares to strike you with |cFFFF0000|Hspell:247246|h[Umbral Flanking]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133241,'Your minds are so easily clouded!','',0,0,0,0,0,0,0,0,0,0,87022,0,26124),
(133242,'The Light will not save you...','',0,0,0,0,0,0,0,0,0,0,87023,0,26124),
(133243,'','Come closer, heroes, so I can watch the flesh drip from your bones!',0,0,0,0,0,0,0,0,0,0,0,87012,26124),
(133244,'','Oh, to taste... your... liquefying flesh...',0,0,0,0,0,0,0,0,0,0,0,87013,26124),
(133245,'Your ashes will be blown across the cosmos!','',0,0,0,0,0,0,0,0,0,0,86968,0,26124),
(133246,'My embers will never burn out...','',0,0,0,0,0,0,0,0,0,0,86969,0,26124),
(133255,'Lothraxion is in charge if we don\'t come back. Stay sharp, Fareeya.','',0,0,0,0,0,0,0,0,0,53064,87753,0,26124),
(133256,'','We have faced worse odds. I will hold this position.',0,0,0,0,0,0,0,0,0,53064,0,87649,26124),
(133257,'We will do our best.','',0,0,0,0,0,0,0,0,0,53064,87754,0,26124),
(133268,'The Legion has opened portals to invade the Arcatraz. Shut them down... before you find yourself outflanked.','',0,0,0,0,0,0,0,0,0,0,87666,0,26124),
(133280,'Infusing','Infusing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(133285,'Runes on this urn indicate that it contains some of the remains of a powerful mogu spirit-binder. Many of the markings appear to be warnings.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133286,'<Consume the ashes.>','<Consume the ashes.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133287,'WARNING: You are about to consume the ashes of an evil sorcerer. There is no way to tell what will happen. Are you VERY sure you want to do this?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133288,'','Have you been training? The Great Gnomeregan Run is starting soon!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133289,'','Be sure to hydrate and rest up for The Great Gnomeregan Run! It\'ll be kicking off in New Tinkertown very soon!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133290,'','The Great Gnomeregan Run is happening in New Tinkertown right now! Think you can accomplish a new personal record?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133291,'','The Great Gnomeregan Run is happening right now in New Tinkertown!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133292,'','The Alliance is celebrating The Great Gnomeregan Run in New Tinkertown!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133293,'','The Alliance will be holding The Great Gnomeregan Run in New Tinkertown very soon!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133296,'I lost the antidote. Did you pick it up?','I lost the antidote. Did you pick it up?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133299,'The enemy seeks to close our rift! To arms!','The enemy seeks to close our rift! To arms!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133307,'I am restored.','',0,0,0,0,0,0,0,0,0,0,87987,0,26124),
(133308,'','Oh no... I know that voice.',0,0,0,0,0,0,0,0,0,0,0,87591,26124),
(133309,'Exile Y\'mera. Why have you returned?','',0,0,0,0,0,0,0,0,0,0,87994,0,26124),
(133313,'Let us begin.','',0,0,0,0,0,0,0,0,0,0,87995,0,26124),
(133320,'','We need to--',0,0,0,0,0,0,0,0,0,0,0,87592,26124),
(133322,'State your purpose or remove yourself from the premises.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133323,'I seek the Sigil of Awakening.','I seek the Sigil of Awakening.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133324,'My robots and I are going to clean up Gnomeregan!\n\nI don\'t quite have the technology figured out, though. Right now I can get the little guys to soak up the toxic fumes, but all they produce is more toxic fumes.\n\nAlso, everything\'s getting green and hazy. It\'s kind of nice, actually, helps me focus on my work.\n\nSo what can I do for you today, my fine trogg friend?\n\n<Bert cocks his head and looks slightly to the left of you.>','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(133326,'Environmental justice!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133327,'Bert\'s bot beats baddie!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133328,'The code clearly missing a semicolon!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133330,'Bert\'s bots bested!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133331,'Main power turn on!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133332,'Code review successful!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133334,'','I can feel the power in the air. It lingers, even after all this time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133335,'','Great. We will be on our way, then.',0,0,0,0,0,0,0,0,0,0,0,87593,26124),
(133347,'|TINTERFACE\\ICONS\\SPELL_FIRE_LAVASPAWN.BLP:20|t Mistress Alluradel begins to cast |cFFFF0404|Hspell:247551|h[Beguiling Charm]|h|r. Look away!','|TINTERFACE\\ICONS\\SPELL_FIRE_LAVASPAWN.BLP:20|t Mistress Alluradel begins to cast |cFFFF0404|Hspell:247551|h[Beguiling Charm]|h|r. Look away!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(133352,'I am afraid I cannot allow that, $n.','',0,0,0,0,0,0,0,0,0,0,87996,0,26124),
(133358,'Lah\'zaruun, my loyal servant. Stay here and kill these fools. I have much to do.','',0,0,0,0,0,0,0,0,0,0,87800,0,26124),
(133362,'','I cannot step hoof in the Praetorium. But you knew that, didn\'t you?',0,0,0,0,0,0,0,0,0,0,0,87589,26124),
(133363,'Perhaps.','',0,0,0,0,0,0,0,0,0,0,87993,0,26124),
(133366,'','I have complete faith in you, $n. I will be nearby when you are finished.',0,0,0,0,0,0,0,0,0,0,0,87587,26124),
(133367,'','This construct should hold information to help us locate the Sigil of Awakening. We need to wake it up.',0,0,0,0,0,0,1,0,0,0,0,87588,26124),
(133373,'I must confess, these trials do provide endless amusement... for me.','',0,0,0,0,0,0,0,0,0,0,87140,0,26124),
(133375,'So many come before me, and so many fail.','',0,0,0,0,0,0,0,0,0,0,87141,0,26124),
(133376,'You think yourself clever for getting this far. But I know how it will end.','',0,0,0,0,0,0,0,0,0,0,87142,0,26124),
(133377,'Tenacity means nothing against my will. I will break you.','',0,0,0,0,0,0,0,0,0,0,87143,0,26124),
(133378,'Ha! A worthy tribute to my Conservatory\'s teachings.','',0,0,0,0,0,0,153,0,0,0,87144,0,26124),
(133381,'','Champions! Over Here!',0,0,0,0,0,0,0,0,0,0,0,87562,26124),
(133382,'Another world defiled by the Legion. Destroy their forces and seal this rift before they can join the fight on Argus!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133383,'Every rift closed buys time for our advance. The light is with you, Champion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133384,'The Legion fleet gathers. Disrupt their preparations and seal the rift before they can reach Argus!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133385,'Reinforcements have ceased from that world, for now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133386,'Mortals. I wasted millennia fighting to spare you from corruption. Until at last my eyes were opened to the truth.','',0,0,0,0,0,0,0,0,0,0,88364,0,26124),
(133388,'The Legion\'s cruelty applies even to its own. Destroy this abomination, and seal the rift between our worlds.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133390,'That is all of the rifts for now, though they are certain to return!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133391,'You are the corruption. We will save the universe by wiping all memory of you from existence.','',0,0,0,0,0,0,0,0,0,0,88365,0,26124),
(133394,'You will burn!','',0,0,0,0,0,0,0,0,0,0,86364,0,26124),
(133397,'You will get this object from a TBD quest chain. For now, you get it from the ground!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133398,'Pick up a Depleted Riftstone.','Pick up a Depleted Riftstone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133399,'|TINTERFACE\\ICONS\\INV_STONE_05.BLP:20|t Your Depleted Riftstone has become a |cFFFF0000|Hitem:151702|h[Charged Riftstone]|h|r!','|TINTERFACE\\ICONS\\INV_STONE_05.BLP:20|t Your Depleted Riftstone has become a |cFFFF0000|Hitem:151702|h[Charged Riftstone]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133408,'Fall, frail mortal!','',0,0,0,0,0,0,0,0,0,0,86366,0,26124),
(133414,'Such a worthless opponent.','',0,0,0,0,0,0,0,0,0,0,86367,0,26124),
(133416,'You had no hope of victory. Nothing can stop our crusade!','',0,0,0,0,0,0,0,0,0,0,86368,0,26124),
(133417,'It may be... too late to stop him...','',0,0,0,0,0,0,0,0,0,0,86365,0,26124),
(133418,'None can stand against Taeshalach!','',0,0,0,0,0,0,0,0,0,0,86360,0,26124),
(133419,'Burn!','',0,0,0,0,0,0,0,0,0,0,86361,0,26124),
(133420,'','I had hoped that would work. The lights are on but no one is home.',0,0,0,0,0,0,0,0,0,0,0,87590,26124),
(133422,'Drown in flames!','',0,0,0,0,0,0,0,0,0,0,86362,0,26124),
(133424,'All will die in my wake!','',0,0,0,0,0,0,0,0,0,0,86363,0,26124),
(133425,'Stand and die!','',0,0,0,0,0,0,0,0,0,0,86354,0,26124),
(133426,'There is no escape.','',0,0,0,0,0,0,0,0,0,0,86355,0,26124),
(133427,'The flames will consume you!','',0,0,0,0,0,0,0,0,0,0,86352,0,26124),
(133431,'Let the flesh be seared from your bones!','',0,0,0,0,0,0,0,0,0,0,86353,0,26124),
(133433,'Taeshalach\'s power is unleashed!','',0,0,0,0,0,0,0,0,0,0,86358,0,26124),
(133434,'The power of Taeshalach will consume you!','',0,0,0,0,0,0,0,0,0,0,86359,0,26124),
(133435,'You may have withstood the flames, but you will not withstand my fury.','',0,0,0,0,0,0,0,0,0,0,86356,0,26124),
(133436,'Your modicum of skill will be insufficient to save you.','',0,0,0,0,0,0,0,0,0,0,86357,0,26124),
(133440,'','Enough! Your intrusion ends now, mortals!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133442,'Time has run out.','Time has run out.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(133451,'|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\SPELL_WARLOCK_SUMMONWRATHGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\SPELL_WARLOCK_SUMMONWRATHGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133452,'|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\SPELL_WARLOCK_SUMMONWRATHGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\SPELL_WARLOCK_SUMMONWRATHGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133453,'|TInterface\\Icons\\SPELL_WARLOCK_SUMMONWRATHGUARD.BLP:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t','|TInterface\\Icons\\SPELL_WARLOCK_SUMMONWRATHGUARD.BLP:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133454,'|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133482,'','|TInterface\\Icons\\INV_MISC_AMMO_ARROW_03:20|t%s targets enemies with |cFFFF0000|Hspell:230139|h[Hydra Shot]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(133483,'Now the ones we\'ve lost can find rest.','',0,0,0,0,0,0,0,0,4,0,86070,0,26124),
(133484,'The lives and souls of my people are safer, thanks to you.','',0,0,0,0,0,0,0,0,4,0,86090,0,26124),
(133485,'Those steeds are vital in our battle against the demons. You have my thanks for safeguarding them.','',0,0,0,0,0,0,0,0,4,0,86082,0,26124),
(133486,'You are now using |TInterface\\ICONS\\Achievement_ChallengeMode_Auchindoun_Hourglass.blp:32|t [Stolen Time]!','You are now using |TInterface\\ICONS\\Achievement_ChallengeMode_Auchindoun_Hourglass.blp:32|t [Stolen Time]!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133508,'','I am going to need your help. Jostle it a bit, won\'t you?',0,0,0,0,0,0,0,0,0,0,0,87583,26124),
(133517,'It is not safe here!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(133518,'The darkness shrouds the Light.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(133519,'Many thanks. I will find my way.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(133520,'Be swift before the pits consume you!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(133521,'We must leave before it is too late!','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(133522,'Our fight does not end here!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(133523,'I... I must return to my people at once.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(133524,'Conservatory resources are not available to one of your... status.','',0,0,0,0,0,0,0,0,0,0,87988,0,26124),
(133525,'','Of all people to become Gatekeeper... $n, perhaps you had better do the talking.',0,0,0,0,0,0,0,0,0,0,0,87584,26124),
(133528,'The Sigil is the Conservatory\'s highest honor. Only Archimonde\'s chosen may pursue this accolade.','',0,0,0,0,0,0,0,0,0,0,87989,0,26124),
(133529,'I am obligated to inform you that the master created trials specifically for this purpose.','',0,0,0,0,0,0,0,0,0,0,87990,0,26124),
(133531,'I am also required to allow the uninitiated to participate.','',0,0,0,0,0,0,0,0,0,0,87991,0,26124),
(133533,'','Quoram and I have... a history.$b$bLet it suffice to say that I did not depart the Conservatory on the best terms.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133535,'','<Y\'mera handles the Sigil warily.>$b$bI feel very exposed, holding such a relic.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133541,'You, Y\'mera, will have no part in this. But I will not deny you the opportunity to watch $n fail.','',0,0,0,0,0,0,0,0,0,0,87992,0,26124),
(133542,'','So generous of you.',0,0,0,0,0,0,0,0,0,0,0,87585,26124),
(133549,'','I may not be able to assist you directly, but I have information that could be of interest.',0,0,0,0,0,0,0,0,0,0,0,87586,26124),
(133577,'Allow me to introduce myself. I am the Magnificent Al\'Abas. I find myself temporarily indisposed in this rather decrepit vessel. Perhaps you\'d be so kind as to listen to my tale.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133583,'Many thanks, $n.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133584,'May the Light guide us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133585,'You have helped ensure the future of our people.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133586,'Be at peace.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133587,'We must stand together.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133588,'Acheon kor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133589,'Golad niton acalah.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133590,'Krona ki cristorr!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133592,'','We are doing all we can to hold the line here. Go, find Y\'mera, and turn the tide in our favor!',0,0,0,0,0,0,0,0,0,0,0,86589,26124),
(133593,'','The Light prevails.',0,0,0,0,0,0,0,0,0,0,0,86263,26124),
(133594,'','We will win this war.',0,0,0,0,0,0,0,0,0,0,0,86264,26124),
(133595,'','Do you have something to report?',0,0,0,0,0,0,0,0,0,0,0,86265,26124),
(133596,'','Greetings.',0,0,0,0,0,0,0,0,0,0,0,86266,26124),
(133597,'','Be on your guard.',0,0,0,0,0,0,0,0,0,0,0,86260,26124),
(133598,'','We will defeat the Legion.',0,0,0,0,0,0,0,0,0,0,0,86261,26124),
(133599,'','Archenon poros.',0,0,0,0,0,0,0,0,0,0,0,86262,26124),
(133600,'','You! You\'re not a demon. Come here and help us kill some!',0,0,0,0,0,0,0,0,0,0,0,86594,26124),
(133601,'','Get to those batteries and start shooting down those bats! We\'re counting on you!',0,0,0,0,0,0,0,0,0,0,0,86327,26124),
(133602,'','Anything can be a weapon with the right mindset.',0,0,0,0,0,0,0,0,0,0,0,86233,26124),
(133603,'','Blade and spell, ready to serve the Light.',0,0,0,0,0,0,0,0,0,0,0,86234,26124),
(133604,'','We will redeem our home.',0,0,0,0,0,0,0,0,0,0,0,86235,26124),
(133611,'Why have you come?','Why have you come?',0,0,0,0,0,0,0,0,0,0,86610,86611,26124),
(133612,'You do not belong here!','You do not belong here!',0,0,0,0,0,0,0,0,0,0,86612,86613,26124),
(133613,'Do not mock my suffering!','Do not mock my suffering!',0,0,0,0,0,0,0,0,0,0,86614,86615,26124),
(133614,'This is our home! Begone!','This is our home! Begone!',0,0,0,0,0,0,0,0,0,0,86616,86617,26124),
(133615,'Why can\'t you let us rest?','Why can\'t you let us rest?',0,0,0,0,0,0,0,0,0,0,86618,86619,26124),
(133616,'You will not torment me!','You will not torment me!',0,0,0,0,0,0,0,0,0,0,86620,86621,26124),
(133617,'When will it end?','When will it end?',0,0,0,0,0,0,0,0,0,0,86626,86627,26124),
(133618,'I wish I had... fled...','I wish I had... fled...',0,0,0,0,0,0,0,0,0,0,86628,86629,26124),
(133619,'We could not escape.','We could not escape.',0,0,0,0,0,0,0,0,0,0,86630,86631,26124),
(133620,'Velen... why?','Velen... why?',0,0,0,0,0,0,0,0,0,0,86632,86633,26124),
(133621,'Such darkness... I had hoped...the light...','Such darkness... I had hoped...',0,0,0,0,0,0,0,0,0,0,86634,86635,26124),
(133622,'I am so tired.','I am so tired.',0,0,0,0,0,0,0,0,0,0,86636,86637,26124),
(133623,'I will direct our forces to establish a foothold outside the Legion stronghold while you speak with Magni.','',0,0,0,0,0,0,1,0,0,0,86201,0,26124),
(133624,'This is the song that never ends. It just goes on and on, my friend. Some people started singing, not knowing what it was, and now they\'re still singing it. No reason... just because!','',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(133625,'I\'m ready. Let\'s try this again!','I\'m ready. Let\'s try this again!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133626,'Ready when you are!','Ready when you are!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133627,'You will do Argus proud. Claim your prize.','',0,0,0,0,0,0,397,0,0,0,87139,0,26124),
(133628,'The stone\'s whispers steady my people\'s hearts. It is curious that you hear them as well, outsider.','',0,0,0,0,0,0,396,0,0,0,86200,0,26124),
(133629,'When Azeroth\'s spirit speaks ta me, it\'s like a song. There\'s beauty in it, even when her message ain\'t exactly clear.','',0,0,0,0,0,0,1,0,0,0,88124,0,26124),
(133630,'Argus\'s soul ain\'t like that. He\'s tormented... broken. Careful, or his pain\'ll overwhelm ye!','',0,0,0,0,0,0,1,0,0,0,88125,0,26124),
(133631,'He... he needs us ta see somethin\'...','',0,0,0,0,0,0,603,0,0,0,88126,0,26124),
(133634,'You will pay for your actions.','',0,0,0,0,0,0,0,0,0,50928,0,0,26124),
(133635,'From the shadows we strike.','',0,0,0,0,0,0,0,0,0,50928,0,0,26124),
(133636,'For our people!','',0,0,0,0,0,0,0,0,0,50928,0,0,26124),
(133637,'For the fallen!','',0,0,0,0,0,0,0,0,0,50928,0,0,26124),
(133639,'Acalah pek ecta!','',0,0,0,0,0,0,0,0,0,50928,0,0,26124),
(133640,'Krypta!','',0,0,0,0,0,0,0,0,0,50928,0,0,26124),
(133641,'Pheta vi acahachi!','',0,0,0,0,0,0,0,0,0,50928,0,0,26124),
(133642,'To battle!','',0,0,0,0,0,0,0,0,0,50928,0,0,26124),
(133647,'Pa-caw chee-chawchee-chaw','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133649,'Coodle chee-chaw','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133650,'Ca-caw chee-chaw','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133651,'Pa-cawcaw','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133652,'Witnessing','Witnessing',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(133653,'','It is as I thought.',0,0,0,0,0,0,0,0,0,0,0,87570,26124),
(133654,'Trifling outsider. Your arrogance was your undoing.','',0,0,0,0,0,0,0,0,0,0,87180,0,26124),
(133655,'You are unworthy.','',0,0,0,0,0,0,0,0,0,0,87758,0,26124),
(133671,'Our forces have established a foothold at the citadel, High Exarch.','',0,0,0,0,0,0,66,0,0,0,86149,0,26124),
(133673,'Good. It is time we seized our fate.','',0,0,0,0,0,0,1,0,0,0,86150,0,26124),
(133677,'Teleporting','Teleporting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(133733,'<Fel Heart of Argus>','<Fel Heart of Argus>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133734,'<Light\'s Judgment Trigger>','<Light\'s Judgment Trigger>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133735,'','I would have words with you, Huntmaster.',0,0,0,0,0,0,1,0,0,0,0,86102,26124),
(133736,'','Vereesa told me you accompanied her on the mission to Niskara. That you risked your own life to rescue me, and prevented her from falling into the inquisitor\'s trap.',0,0,0,0,0,0,1,0,0,0,0,86103,26124),
(133737,'','It is clear you wield Thas\'dorah with skill and finesse. You bring honor to the bow, and to the memory of those who carried it before you.',0,0,0,0,0,0,1,0,0,0,0,86104,26124),
(133738,'','There may come a day when I will have need of my family weapon once again. But for now, at least, I have a different path to follow.',0,0,0,0,0,0,1,0,0,0,0,86105,26124),
(133739,'','Hold Thas\'dorah proudly, champion. Know that you have proven worthy of it.',0,0,0,0,0,0,1,0,0,0,0,86106,26124),
(133740,'','Impossible! I refuse to believe she now leads the Horde. Not after all they did to our people during the war.',0,0,0,0,0,0,603,0,0,0,0,86113,26124),
(133743,'','There is more. I\'m... I am not sure how to explain the rest. Or if this is even the time or place to--',0,0,0,0,0,0,1,0,0,0,0,86114,26124),
(133744,'','I must know, Vereesa. What fate befell our sister?',0,0,0,0,0,0,6,0,0,0,0,86115,26124),
(133746,'','Give me a moment. I will do my best to explain...',0,0,0,0,0,0,1,0,0,0,0,86116,26124),
(133747,'Another demon awaits your disposal. Find it and bring it to an end.','',0,0,0,0,0,0,0,0,0,0,86079,0,26124),
(133748,'One by one, we will teach them the folly of their crusade.','',0,0,0,0,0,0,0,0,0,0,86080,0,26124),
(133749,'A burning fiend terrorizes our allies at the pits. Extinguish the threat at once.','',0,0,0,0,0,0,0,0,0,0,86065,0,26124),
(133750,'Another foe reduced to ashes.','',0,0,0,0,0,0,0,0,0,0,86066,0,26124),
(133751,'Another Legion lackey comes forth to challenge us. Put a swift end to its misguided ambitions.','',0,0,0,0,0,0,0,0,0,0,86073,0,26124),
(133753,'The Legion will not relent. Neither will we.','',0,0,0,0,0,0,0,0,0,0,86074,0,26124),
(133761,'','Have patience, Arator. It may take time, but your family will be whole again. I know it.',0,0,0,0,0,0,1,0,0,0,0,87086,26124),
(133762,'My scouts found the remains of Aggonar. We are in your debt, High Exarch. And yours, outlander.','',0,0,0,0,0,0,396,0,4,0,87155,0,26124),
(133767,'','One of the Legion\'s masters has fallen at last, yet this war is far from over.\n\nWas this the true plan of Sargeras all along? His ultimate endgame? Or perhaps this is another\'s doing. Someone who has betrayed this world before.\n\n<Maiev narrows her eyes as she looks toward the sky.>\n\nI will be watching... and ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133770,'It appears you need a lesson in pain. Allow me to instruct you.','',0,0,0,0,0,0,0,0,0,0,86920,0,26124),
(133771,'','This is one engagement you will not walk away from.',0,0,0,0,0,0,0,0,0,0,0,86906,26124),
(133772,'Your front lines cannot withstand my attack!','',0,0,0,0,0,0,0,0,0,0,86986,0,26124),
(133773,'','Was this your plan?',0,0,0,0,0,0,0,0,0,0,0,86910,26124),
(133774,'What result were you expecting?','',0,0,0,0,0,0,0,0,0,0,86924,0,26124),
(133776,'You have no place on my battlefield.','',0,0,0,0,0,0,0,0,0,0,86987,0,26124),
(133777,'The drake cleared the Azure Dragonshrine for you!','The drake cleared the Azure Dragonshrine for you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133778,'The drake cleared the Obsidian Dragonshrine for you!','The drake cleared the Obsidian Dragonshrine for you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133779,'The drake cleared the Emerald Dragonshrine for you!','The drake cleared the Emerald Dragonshrine for you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133780,'The drake cleared the Ruby Dragonshrine for you!','The drake cleared the Ruby Dragonshrine for you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133781,'The drake granted you a powerful blessing!','The drake granted you a powerful blessing!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133782,'I was looking for higher ground to scout a path for Velen when the Legion descended upon us.$b$bI covered his retreat but I was separated from the others.$b$bDo you bring news?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133783,'<Relay Fareeya\'s orders.>','<Relay Fareeya\'s orders.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133787,'No mercy!','',0,0,0,0,0,0,0,0,0,0,86988,0,26124),
(133789,'Pathetic.','',0,0,0,0,0,0,0,0,0,0,86923,0,26124),
(133791,'','You\'ve left your flanks exposed.',0,0,0,0,0,0,0,0,0,0,0,86909,26124),
(133792,'My name will be remembered!','',0,0,0,0,0,0,0,0,0,0,86989,0,26124),
(133795,'Inconceivable!','',0,0,0,0,0,0,0,0,0,0,86921,0,26124),
(133796,'','How was I outmatched...',0,0,0,0,0,0,0,0,0,0,0,86907,26124),
(133797,'I am the Wisdom Cube.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133800,'Harvest faster! The master will not tolerate laziness.','Harvest faster! The master will not tolerate laziness.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133807,'Baraat the Longshot salutes you.','',0,0,0,0,0,0,66,0,0,0,0,0,26124),
(133808,'What wisdom do you hold?','What wisdom do you hold?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133809,'<The Vindicator breathes heavily as ichor drips from his mace and shield.>$b$bWhat is it?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133810,'I have been imparted with the knowledge of the timeless ones.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133811,'What is your purpose?','What is your purpose?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133812,'I am capable of granting the sign of the first.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133813,'What do you require?','What do you require?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133814,'Grand Vindicator Sorvos grunts in confirmation.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133815,'My creators seek a most amusing heir.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133816,'These spores will make you stronger, whelps! Get back to work or I\'ll kill you myself!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133817,'<The cube rapidly reconfigures itself.>\n\nPlease place your arm beneath the cube.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133818,'<Place arm beneath cube.>','<Place arm beneath cube.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133821,'A strange stone sits before you. A glowing hole in the center is the main identifying feature.\n\nThe hole in the stone is at about arm height.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133822,'<Place arm in hole.>','<Place arm in hole.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133823,'Your arm looks quite small in the hole, but nothing else of note happens.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133824,'Your arm better fits the size of the hole, but still doesn\'t quite fill the space precisely.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133825,'No doubt my mother will soon ask about Sylvanas. What are you going to tell her?','',0,0,0,0,0,0,1,0,0,0,87153,0,26124),
(133826,'','It is a conversation I know we must have, but the thought of it fills me with dread. How can I explain to Alleria what our sister has become? The truth will break her heart.',0,0,0,0,0,0,1,0,0,0,0,87089,26124),
(133836,'You hope to topple my machines with those pathetic weapons?','',0,0,0,0,0,0,0,0,0,0,87008,0,26124),
(133837,'Sending you back to the drawing board... in pieces!','',0,0,0,0,0,0,0,0,0,0,87009,0,26124),
(133838,'Your construction appears shoddy.','',0,0,0,0,0,0,0,0,0,0,87010,0,26124),
(133839,'Now I\'m just... extra parts.','',0,0,0,0,0,0,0,0,0,0,87011,0,26124),
(133840,'Your heads will adorn my trophy room.','',0,0,0,0,0,0,0,0,0,0,86382,0,26124),
(133841,'I get paid double if you scream.','',0,0,0,0,0,0,0,0,0,0,86391,0,26124),
(133842,'caw','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133843,'ca-caw','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133844,'chaw','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133845,'chee','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133846,'Extracting','Extracting',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(133847,'chee-chaw','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133848,'a','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133849,'coodle','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133850,'doodle','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133851,'do','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133852,'coo','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133853,'ca','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133854,'cluck','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133855,'cluck-ahhh','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133856,'pa','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133857,'quaw','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133858,'pa-caw','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133859,'bock','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133860,'block','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133861,'Guess I should scrape up the pieces and collect my fee.','',0,0,0,0,0,0,0,0,0,0,86392,0,26124),
(133862,'<Telaamon lowers his blade and peers at you expectantly.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133863,'Blademaster Telaamon offers a curt nod.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133864,'I regret... taking... this job...','',0,0,0,0,0,0,0,0,0,0,86384,0,26124),
(133866,'Be calm. It is only the wind.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133867,'Hold still, little one. We are safe here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133868,'Hold! These winds that tease our senses create unease in the wildlife.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133869,'Be still. The village masks our presence. No harm will come to us here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133870,'Hold, young one! Be still!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133871,'I be branchin\' out, mon. All sorts of tings available in. So much opportunity.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133873,'Come, then. We will trade pain for pain!','',0,0,0,0,0,0,0,0,0,0,87040,0,26124),
(133874,'So easily broken!','',0,0,0,0,0,0,0,0,0,0,87041,0,26124),
(133875,'Better that you died here, where she cannot claim you.','',0,0,0,0,0,0,0,0,0,0,87042,0,26124),
(133876,'Death... claims... us all.','',0,0,0,0,0,0,0,0,0,0,87043,0,26124),
(133877,'','I am the chill running down your spine.',0,0,0,0,0,0,0,0,0,0,0,86926,26124),
(133878,'','I can\'t wait to hear your flesh sizzle.',0,0,0,0,0,0,0,0,0,0,0,87025,26124),
(133879,'','You cannot escape the shadows.',0,0,0,0,0,0,0,0,0,0,0,86913,26124),
(133880,'','Your corpses will be frozen in eternal agony.',0,0,0,0,0,0,0,0,0,0,0,86930,26124),
(133881,'','Burned and blackened.',0,0,0,0,0,0,0,0,0,0,0,87026,26124),
(133882,'','There is no light that can pierce my shadow.',0,0,0,0,0,0,0,0,0,0,0,86916,26124),
(133884,'Kil\'jaeden\'s ship. Even after its destruction, its presence vexes us. Clear the surrounding area of its blight.','',0,0,0,0,0,0,0,0,4,0,86077,0,26124),
(133885,'A pity the memory of Kil\'jaeden\'s existence cannot be purged as easily as you cleansed these grounds.','',0,0,0,0,0,0,0,0,4,0,86078,0,26124),
(133886,'The Legion is arming a devastator to fire on the Xenedar! We need you to commandeer it.','',0,0,0,0,0,0,0,0,4,0,86087,0,26124),
(133887,'Nice shooting! With that cursed ship out of commission, we can focus on other fronts.','',0,0,0,0,0,0,0,0,4,0,86088,0,26124),
(133888,'','Your pieces will make a fine trophy.',0,0,0,0,0,0,0,0,0,0,0,86929,26124),
(133889,'','Another body for the fire!',0,0,0,0,0,0,0,0,0,0,0,87027,26124),
(133890,'','You were right to fear the dark.',0,0,0,0,0,0,0,0,0,0,0,86915,26124),
(133891,'Forgive me, my son.','',0,0,0,0,0,0,0,0,0,0,87951,0,26124),
(133892,'Velen?','',0,0,0,0,0,0,0,0,0,0,87747,0,26124),
(133894,'','So cold...',0,0,0,0,0,0,0,0,0,0,0,86928,26124),
(133895,'','I sense great despair emanating from within. L\'ura...',0,0,0,0,0,0,0,0,0,0,0,87566,26124),
(133896,'Yes, the naaru. We must get inside. Alleria, the skills you have learned can open the way.','',0,0,0,0,0,0,0,0,0,0,87857,0,26124),
(133897,'Are you hurt?','',0,0,0,0,0,0,0,0,0,0,87748,0,26124),
(133898,'','Understood. Champions, once the door is open, clear the way to L\'ura. We will be right behind you.',0,0,0,0,0,0,0,0,0,0,0,87567,26124),
(133900,'I am unharmed.','',0,0,0,0,0,0,0,0,0,0,87952,0,26124),
(133901,'Your arrival is timely. We must find the Crest of Knowledge before Talgath takes it beyond our reach.','',0,0,0,0,0,0,0,0,0,0,87953,0,26124),
(133902,'','I will never burn out...',0,0,0,0,0,0,0,0,0,0,0,87028,26124),
(133903,'','I welcome oblivion...',0,0,0,0,0,0,0,0,0,0,0,86914,26124),
(133905,'So he is here, then. I was afraid of this.','',0,0,0,0,0,0,0,0,0,0,87749,0,26124),
(133906,'Death! Death and pain!','',0,0,0,0,0,0,0,0,0,0,88233,0,26124),
(133907,'Ended!','',0,0,0,0,0,0,0,0,0,0,88234,0,26124),
(133908,'All life ends.','',0,0,0,0,0,0,0,0,0,0,88235,0,26124),
(133909,'We will escort Velen safely to the Crest.','',0,0,0,0,0,0,0,0,0,0,87750,0,26124),
(133910,'My torment... ends...','',0,0,0,0,0,0,0,0,0,0,88236,0,26124),
(133914,'Lead the way, Prophet.','',0,0,0,0,0,0,0,0,0,0,87751,0,26124),
(133920,'The way is clear. The Light Mother awaits.$b$bWe should hurry. There is nothing blocking the Legion from her now.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133921,'Even though we are surrounded by enemies on all sides, it is good to be with my soldiers again.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133922,'If you cover our retreat, we may just see this through.','',0,0,0,0,0,0,0,0,0,0,87752,0,26124),
(133927,'','The way is open! Hurry, heroes!',0,0,0,0,0,0,0,0,0,0,0,89414,26124),
(133930,'The Light is with us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133931,'Such loss... we will need to grow our ranks.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133932,'We will win this fight.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133937,'I did not escape the Arcatraz to die at your hands!','',0,0,0,0,0,0,0,0,0,0,87801,0,26124),
(133940,'You have stolen my power! Argus no longer calls to me!','',0,0,0,0,0,0,0,0,0,0,87802,0,26124),
(133948,'The Fel Heart fills with the energies of Argus. Soon I will be unstoppable!','',0,0,0,0,0,0,0,0,0,0,87803,0,26124),
(133949,'You are too late! My power grows... soon you will fall before me!','',0,0,0,0,0,0,0,0,0,0,87804,0,26124),
(133954,'Why are we here in Stratholme?','Why are we here in Stratholme?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133955,'Why are we here in Andorhal?','Why are we here in Andorhal?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133956,'Why are we here at Mount Hyjal?','Why are we here at Mount Hyjal?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133957,'Why are we here at the Well of Eternity?','Why are we here at the Well of Eternity?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133967,'Yes! They flee to the terrace! We have them right where we want them.','',0,0,0,0,0,0,0,0,0,0,87976,0,26124),
(133972,'Siphon the portal energy! The naaru\'s weakness will become your strength!','',0,0,0,0,0,0,0,0,0,0,88268,0,26124),
(133973,'Take her shadow for your own, Alleria! Do as I trained you!','',0,0,0,0,0,0,0,0,0,0,88267,0,26124),
(133976,'','Heroes, the naaru has been weakened!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133977,'','Attack now, champions! The naaru is momentarily weakened!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(133978,'','Quickly, heroes! The naaru is stunned, but won\'t be for long!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134004,'Even in such a mire the Legion cannot mask their scent. Rip them apart!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134005,'The demons have spliced spores into their own flesh to mask their attacks. Show them they cannot hide from death!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134006,'Their commander approaches! Make him regret defiling this world.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134008,'The Legion here are finished, for now. Our war continues on Argus.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134019,'Your screams will echo through Antorus if they escape!','',0,0,0,0,0,0,0,0,0,0,87962,0,26124),
(134020,'Make way. I will deal with this myself.','',0,0,0,0,0,0,0,0,0,0,87963,0,26124),
(134024,'Blademaster Telaamon salutes you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134025,'Grand Vindicator Sorvos nods to you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134026,'<Velen\'s unmoving gaze is rooted on the statue before him.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134027,'Let me show you what I have done. Perhaps, then, I can make peace with it at long last.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134028,'Show me.','Show me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134029,'IGC: Sargeras Appears to the Triumvirate','IGC: Sargeras Appears to the Triumvirate',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134030,'He\'s here.','',0,0,0,0,0,0,0,0,0,0,87739,0,26124),
(134031,'How unlike you, Velen, to stand your ground.','',0,0,0,0,0,0,0,0,0,0,87964,0,26124),
(134032,'A welcome change of pace, to be certain.','',0,0,0,0,0,0,0,0,0,0,87965,0,26124),
(134033,'After all I have endured at his hand... after all my people have suffered... it comes to this.$b$b<Velen grips his staff tightly.>$b$bWhen you are ready, we will finish this together.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134034,'I am ready.','I am ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134039,'Let the hunt be finished! You are mine, Prophet!','',0,0,0,0,0,0,0,0,0,0,87966,0,26124),
(134040,'We are with you, Velen.','',0,0,0,0,0,0,0,0,0,0,87740,0,26124),
(134041,'Pheta thones gamera. Light, guide our path.','',0,0,0,0,0,0,0,0,0,0,87930,0,26124),
(134044,'Oh, how Kil\'jaeden mourned for you! Do you know how deeply your departure wounded him?','',0,0,0,0,0,0,0,0,0,0,87968,0,26124),
(134045,'I lost a beloved brother that day as well.','',0,0,0,0,0,0,0,0,0,0,87931,0,26124),
(134046,'You did not lose him. You gave it up--all of it! Your people, your planet... even your family!','',0,0,0,0,0,0,0,0,0,0,87969,0,26124),
(134047,'I have not forgotten your betrayal!','',0,0,0,0,0,0,0,0,0,0,87934,0,26124),
(134050,'I only hoped they would give you a reason to stay. How cold of you, leaving without your mate and child.','',0,0,0,0,0,0,0,0,0,0,87971,0,26124),
(134051,'Silence! You dare speak of them!','',0,0,0,0,0,0,0,0,0,0,87935,0,26124),
(134052,'Struck a nerve, did I?','',0,0,0,0,0,0,0,0,0,0,87972,0,26124),
(134053,'Sheet-sah, you hide behind your allies... as usual.','',0,0,0,0,0,0,0,0,0,0,87970,0,26124),
(134054,'We will finish this another ti--','',0,0,0,0,0,0,0,0,0,0,87967,0,26124),
(134055,'No. This ends now.','',0,0,0,0,0,0,0,0,0,0,87936,0,26124),
(134056,'I see. Safe journey, Talgath.','',0,0,0,0,0,0,0,0,0,0,87937,0,26124),
(134057,'AAAaaahhh!','',0,0,0,0,0,0,0,0,0,0,87973,0,26124),
(134058,'Der\'ek... manul...','',0,0,0,0,0,0,0,0,0,0,87974,0,26124),
(134071,'Before you are remnants of memories past, echoes of what our people were before the Dark Titan came.$B$BWhen one of our kind breaks away from the Legion\'s grasp, sometimes they return with a memento of our old way of life.$b$bThese relics symbolize all we have lost... and serve as a reminder of what we fight for.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134080,'You cannot kill me so easily! The Fel Heart will protect me!','',0,0,0,0,0,0,0,0,0,0,87796,0,26124),
(134081,'You think you are winning? I am immortal!','',0,0,0,0,0,0,0,0,0,0,87797,0,26124),
(134082,'Many have tried to kill me. They are all dead and gone, yet I remain!','',0,0,0,0,0,0,0,0,0,0,87798,0,26124),
(134083,'This was not supposed to happen! I was to live forever!','',0,0,0,0,0,0,0,0,0,0,87799,0,26124),
(134097,'Azerite fissures begin to erupt!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134102,'|TInterface\\ICONS\\SPELL_FIRE_TWILIGHTNOVA:20|tViceroy Nezhar starts to cast |cFFFF0000|Hspell:248736|h[Eternal Twilight]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134103,'','What news, hero? I sense that darkness has descended upon the bluff.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134104,'An ally\'s mind is under assault by the Old Gods. Can he be saved?','An ally\'s mind is under assault by the Old Gods. Can he be saved?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134105,'','Sometimes we must walk in the land of dreams to seek the truth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134106,'','I wish I could offer better news. In my experience, once the Old Gods take hold, hope is all but lost.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134107,'The spirits are restless. A shadow looms over this place. The very earth feels... wrong.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134108,'It takes powerful wards to keep the Old Gods at bay.\n\nPerhaps a place heavily warded against void magic could prove useful.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(134113,'$n has collected Azerite!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134114,'$n has collected Azerite!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134117,'This is your end. If there is a shred of goodness left in you, you will help us find the Crest of Knowledge.','',0,0,0,0,0,0,0,0,0,0,87950,0,26124),
(134118,'','I sense you bring ill news.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(134119,'Hah! You are far too late. Nothing will escape the temple. Not even the Light itself.','',0,0,0,0,0,0,0,0,0,0,87975,0,26124),
(134120,'INTERFACE\\ICONS\\SPELL_BURNINGSOUL.BLP:20|t You have been targeted by |cFFFF0000|Hspell:240209|h[Spontaneous Fragmentation]|h|r!','INTERFACE\\ICONS\\SPELL_BURNINGSOUL.BLP:20|t You have been targeted by |cFFFF0000|Hspell:240209|h[Spontaneous Fragmentation]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134121,'|TINTERFACE\\ICONS\\SPELL_BURNINGSOUL.BLP:20|t You are targeted by |cFFFF0000|Hspell:239153|h[Spontaneous Fragmentation]|h|r!','|TINTERFACE\\ICONS\\SPELL_BURNINGSOUL.BLP:20|t You are targeted by |cFFFF0000|Hspell:239153|h[Spontaneous Fragmentation]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134122,'','If the Light is with you, then you have a chance to save your friend.$b$bBut do not tarry. Unless the Old Gods\' influence is countered quickly, his mind will be lost to madness.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134124,'','Another assault! Be on your guard!',0,0,0,0,0,0,0,0,0,0,0,86593,26124),
(134126,'','The Light shall be seared into your souls!',0,0,0,0,0,0,0,0,0,0,0,86590,26124),
(134127,'','To my side, noble warriors!',0,0,0,0,0,0,0,0,0,0,0,86591,26124),
(134128,'','My glaive will cut you down like grain.',0,0,0,0,0,0,0,0,0,0,0,86592,26124),
(134129,'','I have sacrified too much to lose!',0,0,0,0,0,0,0,0,0,0,0,86551,26124),
(134130,'','Shall you die to my magic or my blade?',0,0,0,0,0,0,0,0,0,0,0,86554,26124),
(134131,'','We will destroy you, no matter the cost!',0,0,0,0,0,0,0,0,0,0,0,86557,26124),
(134133,'','Arkonos vi acahachi!',0,0,0,0,0,0,0,0,0,0,0,86560,26124),
(134134,'','You will find no salvation, traitors!',0,0,0,0,0,0,0,0,0,0,0,86553,26124),
(134135,'','By Light be purged.',0,0,0,0,0,0,0,0,0,0,0,86556,26124),
(134136,'','You are beyond redemption!',0,0,0,0,0,0,0,0,0,0,0,86559,26124),
(134137,'','Wretched souls! Your defeat shall come swiftly.',0,0,0,0,0,0,0,0,0,0,0,86562,26124),
(134138,'','Bring me the injured. I shall heal their wounds and purge this filth with a single prayer!',0,0,0,0,0,0,0,0,0,0,0,86567,26124),
(134139,'','Pheta thones gamera.',0,0,0,0,0,0,0,0,0,0,0,86267,26124),
(134140,'','If you can walk, you can fight.',0,0,0,0,0,0,0,0,0,0,0,86270,26124),
(134141,'','You can rest when we\'ve killed them all! Keep fighting!',0,0,0,0,0,0,0,0,0,0,0,86568,26124),
(134142,'','Hurt? Bah! You\'re still on your feet. Fight more and then we\'ll talk.',0,0,0,0,0,0,0,0,0,0,0,86569,26124),
(134143,'','Do you require assistance in exterminating our foes?',0,0,0,0,0,0,0,0,0,0,0,86271,26124),
(134144,'','Keep an eye out for anything useful.',0,0,0,0,0,0,0,0,0,0,0,86230,26124),
(134145,'','Dioniss aca.',0,0,0,0,0,0,0,0,0,0,0,86231,26124),
(134146,'','The Legion will stop at nothing. Be careful.',0,0,0,0,0,0,0,0,0,0,0,86232,26124),
(134147,'','Stay safe, and slay many demons.',0,0,0,0,0,0,0,0,0,0,0,86268,26124),
(134148,'','Each demon you slay is one fewer we must face.',0,0,0,0,0,0,0,0,0,0,0,86269,26124),
(134153,'','Killing demons makes you feel good. Killing demons makes you feel all right.',0,0,0,0,0,0,0,0,0,0,0,86272,26124),
(134154,'The loss of the Xenedar was tragic. But this is a fine ship. Perhaps we still have a chance against the Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134160,'','I say what\'s wrong with blood? We all need it. Except the traitors. That\'s why we take theirs.',0,0,0,0,0,0,0,0,0,0,0,86274,26124),
(134165,'Always good to see another $c in the ranks. We need all the help we can get.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134166,'','I hear the rumors, you know. That I am bloodthirsty, and conduct myself in a manner unbecoming of a priestess.',0,0,0,0,0,0,0,0,0,0,0,86273,26124),
(134167,'Keep an eye out for fel-encrusted herbs. The astral glory still resides within.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134168,'I have identified a safe extraction point northwest of your current location.','',0,0,0,0,0,0,0,0,0,0,87655,0,26124),
(134169,'There is a teleporter inbound.','',0,0,0,0,0,0,0,0,0,0,87654,0,26124),
(134170,'Come. I dare not tarry here.','',0,0,0,0,0,0,0,0,0,0,87866,0,26124),
(134171,'Talgath\'s last words... Not even the Light can escape. What did he mean?','',0,0,0,0,0,0,0,0,0,0,87689,0,26124),
(134172,'The darkness that lingers in the temple... the shadow that looms over all of Mac\'Aree... is L\'ura.','',0,0,0,0,0,0,0,0,0,0,87867,0,26124),
(134173,'I am one with the Light. The Light is with me.','',0,0,0,0,0,0,0,0,0,0,86245,0,26124),
(134174,'','The fel beasts that roam these desolate lands produce some of the foulest-smelling hides I\'ve ever encountered.$b$bHopefully we can leave this place someday and find a home with nicer-smelling creatures.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134175,'Embrace tranquility.','',0,0,0,0,0,0,0,0,0,0,86246,0,26124),
(134176,'','Greetings, $n. How goes the battle against the legion?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134177,'Feed the flame, combat the darkness.','',0,0,0,0,0,0,0,0,0,0,86247,0,26124),
(134178,'Walk your path with confidence.','',0,0,0,0,0,0,0,0,0,0,86242,0,26124),
(134179,'Dioniss aca.','',0,0,0,0,0,0,0,0,0,0,86243,0,26124),
(134180,'When defeat is impossible, victory becomes inevitable.','',0,0,0,0,0,0,0,0,0,0,86244,0,26124),
(134181,'You are no match for my blade.','',0,0,0,0,0,0,0,0,0,0,86542,0,26124),
(134182,'Bend, or you shall break.','',0,0,0,0,0,0,0,0,0,0,86544,0,26124),
(134183,'Your defeat is certain.','',0,0,0,0,0,0,0,0,0,0,86546,0,26124),
(134184,'Two Talbuks Clashing Horns.','',0,0,0,0,0,0,0,0,0,0,86565,0,26124),
(134185,'Dawn Rises.','',0,0,0,0,0,0,0,0,0,0,86566,0,26124),
(134187,'|TInterface\\Icons\\SPELL_FIRE_FELFLAMEBREATH.BLP:20|tKin\'garoth has empowered |cFFFF0000|Hspell:246840|h[Ruiner]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134188,'|TInterface\\Icons\\SPELL_FIRE_FLAMETOUNGE.BLP:20|tKin\'garoth has empowered |cFFFF0000|Hspell:248475|h[Reverberating Strike]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134189,'|TInterface\\Icons\\SPELL_FIRE_FELFLAMERING.BLP:20|tKin\'garoth has empowered |cFFFF0000|Hspell:246779|h[Diabolic Bomb]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134190,'','Hmm... one of our winners seems to have left the building. Their loss!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134191,'Placing','Placing',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134192,'The Void consumes the weak!','',0,0,0,0,0,0,0,0,0,0,87131,0,26124),
(134193,'Pathetic!','',0,0,0,0,0,0,0,0,0,0,87132,0,26124),
(134194,'Such... strength.','',0,0,0,0,0,0,0,0,0,0,87133,0,26124),
(134195,'Clarity... comes to me. The Void... was weak.','',0,0,0,0,0,0,0,0,0,0,87134,0,26124),
(134196,'Darkness give me strength!','',0,0,0,0,0,0,0,0,0,0,87135,0,26124),
(134197,'I will end you!','',0,0,0,0,0,0,0,0,0,0,87136,0,26124),
(134198,'The Void calls to me!','',0,0,0,0,0,0,0,0,0,0,87090,0,26124),
(134199,'I shall bring you to your twilight!','',0,0,0,0,0,0,0,0,0,0,87091,0,26124),
(134200,'No! The darkness... was to be mine...','',0,0,0,0,0,0,0,0,0,0,87092,0,26124),
(134201,'My death... cannot stop it. The Void... will consume all.','',0,0,0,0,0,0,0,0,0,0,87093,0,26124),
(134202,'Your life ends now!','',0,0,0,0,0,0,0,0,0,0,87094,0,26124),
(134203,'Stare in to the abyss, and know despair!','',0,0,0,0,0,0,0,0,0,0,87095,0,26124),
(134204,'Your light fades.','',0,0,0,0,0,0,0,0,0,0,87096,0,26124),
(134205,'The darkness takes you!','',0,0,0,0,0,0,0,0,0,0,87097,0,26124),
(134206,'Our efforts will not be interrupted!','',0,0,0,0,0,0,0,0,0,0,87074,0,26124),
(134207,'My pets hunger.','',0,0,0,0,0,0,0,0,0,0,87075,0,26124),
(134210,'A simple... tactical error...','',0,0,0,0,0,0,0,0,0,0,87076,0,26124),
(134212,'I did not... foresee this.','',0,0,0,0,0,0,0,0,0,0,87077,0,26124),
(134213,'Strike hard and fast!','',0,0,0,0,0,0,0,0,0,0,87079,0,26124),
(134214,'I shall always be one step ahead!','',0,0,0,0,0,0,0,0,0,0,87078,0,26124),
(134215,'More fodder for my beauties.','',0,0,0,0,0,0,0,0,0,0,87080,0,26124),
(134216,'So easily outclassed.','',0,0,0,0,0,0,0,0,0,0,87081,0,26124),
(134217,'To the Void with you!','',0,0,0,0,0,0,0,0,0,0,87137,0,26124),
(134218,'I shall send you to the darkness!','',0,0,0,0,0,0,0,0,0,0,87138,0,26124),
(134220,'Not enough players.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134221,'','Every day for a thousand years, I\'ve thought about what I wanted to say to him. Now, though... words fail me.',0,0,0,0,0,0,1,0,0,0,0,86177,26124),
(134222,'I know, my love. I feel the same. But once we see our son, our hearts will speak for us.','',0,0,0,0,0,0,1,0,0,0,86172,0,26124),
(134238,'','You will not torment me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134239,'','Why can\'t you let us rest?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134240,'','This is our home! Begone!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134241,'','Do not mock my suffering!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134242,'','You do not belong here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134244,'Embrace Sargeras!','Embrace Sargeras!',0,0,0,0,0,0,0,0,0,0,86757,86758,26124),
(134245,'Yes! Flee! Flee!','Yes! Flee! Flee!',0,0,0,0,0,0,0,0,0,0,86759,86760,26124),
(134246,'You flee to the abyss, coward!','You flee to the abyss, coward!',0,0,0,0,0,0,0,0,0,0,86761,86762,26124),
(134247,'Suffer for your folly!','Suffer for your folly!',0,0,0,0,0,0,0,0,0,0,86866,86867,26124),
(134248,'This will be the last gift you reject!','This will be the last gift you reject!',0,0,0,0,0,0,0,0,0,0,86739,86740,26124),
(134249,'Sargeras cannot be denied!','Sargeras cannot be denied!',0,0,0,0,0,0,0,0,0,0,86741,86742,26124),
(134250,'','I am so tired.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134251,'','Such darkness... I had hoped...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134253,'','Velen... why?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134254,'','We could not escape.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134255,'','I wish I had... fled...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134256,'','When will it end?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134257,'Run... while you can.','Run... while you can.',0,0,0,0,0,0,0,0,0,0,86743,86744,26124),
(134258,'The eredar... reign...','The eredar... reign...',0,0,0,0,0,0,0,0,0,0,86745,86746,26124),
(134259,'Why is it... dark?','Why is it... dark?',0,0,0,0,0,0,0,0,0,0,86747,86748,26124),
(134260,'Argus will... rise...','Argus will... rise...',0,0,0,0,0,0,0,0,0,0,86749,86750,26124),
(134261,'There is nowhere to run.','There is nowhere to run.',0,0,0,0,0,0,0,0,0,0,86751,86752,26124),
(134262,'You... will never... escape...','You... will never... escape...',0,0,0,0,0,0,0,0,0,0,86763,86764,26124),
(134280,'I have given our plight much thought. As it currently stands, we will be destroyed if we challenge Antorus.','',0,0,0,0,0,0,1,0,0,0,87872,0,26124),
(134281,'There is one hope, one treasure that may give us the edge we need.','',0,0,0,0,0,0,1,0,0,0,87873,0,26124),
(134282,'We called it the Crown of the Triumvirate.','',0,0,0,0,0,0,1,0,0,0,87874,0,26124),
(134283,'A lifetime ago, my brothers and I crafted a relic designed to bring prosperity to all.','',0,0,0,0,0,0,1,0,0,0,87875,0,26124),
(134284,'The beacon hums with energy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134285,'Return to the entrance.','Return to the entrance.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134286,'I still possess a third of the whole. I carry it with me always. This is the Eye of Prophecy.','',0,0,0,0,0,0,1,0,0,0,87876,0,26124),
(134287,'The remaining fragments may still be here, on Argus. We must go to Mac\'Aree where my brothers and I once ruled.','',0,0,0,0,0,0,1,0,0,0,87877,0,26124),
(134301,'Krona ki cristorr!','',0,0,0,0,0,0,0,0,0,0,86290,0,26124),
(134302,'The Light welcomes you, champion.','',0,0,0,0,0,0,0,0,0,0,86291,0,26124),
(134303,'The Army of the Light stands ready.','',0,0,0,0,0,0,0,0,0,0,86292,0,26124),
(134304,'My faith is my shield.','',0,0,0,0,0,0,0,0,0,0,86293,0,26124),
(134305,'We stand together.','',0,0,0,0,0,0,0,0,0,0,86294,0,26124),
(134306,'Walk in the Light.','',0,0,0,0,0,0,0,0,0,0,86295,0,26124),
(134307,'Dioniss aca.','',0,0,0,0,0,0,0,0,0,0,86296,0,26124),
(134308,'We didn\'t come this far to falter now.','',0,0,0,0,0,0,0,0,0,0,86297,0,26124),
(134311,'Light guide us.','',0,0,0,0,0,0,0,0,0,0,86298,0,26124),
(134312,'We fight for home... for family.','',0,0,0,0,0,0,0,0,0,0,86299,0,26124),
(134313,'I spent so long away from my home. Away from my son.','',0,0,0,0,0,0,0,0,0,0,86300,0,26124),
(134314,'Fighting the Legion every step of the way. Savoring every victory, mourning every bitter defeat.','',0,0,0,0,0,0,0,0,0,0,86301,0,26124),
(134315,'But for Azeroth, and for those we love, it was all worth it.','',0,0,0,0,0,0,0,0,0,0,86302,0,26124),
(134316,'','Keep your gaze fixed on your target.',0,0,0,0,0,0,0,0,0,0,0,86248,26124),
(134317,'','We do what we must for those we love.',0,0,0,0,0,0,0,0,0,0,0,86249,26124),
(134318,'','Aim true.',0,0,0,0,0,0,0,0,0,0,0,86250,26124),
(134319,'','Farewell.',0,0,0,0,0,0,0,0,0,0,0,86251,26124),
(134320,'','The shadows can be an ally... if controlled.',0,0,0,0,0,0,0,0,0,0,0,86252,26124),
(134321,'','Greetings.',0,0,0,0,0,0,0,0,0,0,0,86253,26124),
(134322,'','We each walk a line. Choose yours.',0,0,0,0,0,0,0,0,0,0,0,86254,26124),
(134323,'','Your corpse will make a fine trophy for the master!',0,0,0,0,0,0,0,0,0,0,0,86552,26124),
(134324,'','Your Light will not save you. Not here!',0,0,0,0,0,0,0,0,0,0,0,86555,26124),
(134325,'','What news?',0,0,0,0,0,0,0,0,0,0,0,86255,26124),
(134326,'','Use every weapon at your disposal.',0,0,0,0,0,0,0,0,0,0,0,86256,26124),
(134327,'','It is a good day for a hunt.',0,0,0,0,0,0,0,0,0,0,0,86257,26124),
(134331,'Fascinating. Simply fascinating.','',0,0,0,0,0,0,0,0,0,0,86314,0,26124),
(134332,'Do go on.','',0,0,0,0,0,0,0,0,0,0,86309,0,26124),
(134333,'I represent... an alternative.','',0,0,0,0,0,0,0,0,0,0,86310,0,26124),
(134335,'It is all about perspective.','',0,0,0,0,0,0,0,0,0,0,86311,0,26124),
(134336,'Flesh is fickle. Power endures.','',0,0,0,0,0,0,0,0,0,0,86312,0,26124),
(134337,'','You dare set foot on his world? You will die!',0,0,0,0,0,0,0,0,0,0,0,86558,26124),
(134338,'Try not to waste my time.','',0,0,0,0,0,0,0,0,0,0,86313,0,26124),
(134342,'','I\'m busy, $r. What do you need?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134343,'I have your felslate shipment.','I have your felslate shipment.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134344,'','It\'s about time. We\'ve been running low on this stuff.$b$bTell Vridiel he needs to gets his couriers working faster.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134345,'How\'s it going, $n? Is there something I can help you with?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134346,'Excellent timing, $n. We just used the last of that stuff and thought we\'d have to wait longer for more. Thanks!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134347,'Arkhaan listens.','',0,0,0,0,0,0,0,0,0,0,86239,0,26124),
(134348,'Ah! Oh. Yes?','',0,0,0,0,0,0,0,0,0,0,86240,0,26124),
(134349,'You speak?','',0,0,0,0,0,0,0,0,0,0,86241,0,26124),
(134350,'Stranger speaks strangely.','',0,0,0,0,0,0,0,0,0,0,86236,0,26124),
(134351,'Shhh... did you hear that?','',0,0,0,0,0,0,0,0,0,0,86237,0,26124),
(134352,'Close your ears to the whispers.','',0,0,0,0,0,0,0,0,0,0,86238,0,26124),
(134353,'I am required to provide a greeting. Hello.','',0,0,0,0,0,0,0,0,0,0,86303,0,26124),
(134354,'State your purpose.','',0,0,0,0,0,0,0,0,0,0,86304,0,26124),
(134355,'I am obligated to serve.','',0,0,0,0,0,0,0,0,0,0,86305,0,26124),
(134356,'Protocol dictates that I bid you farewell.','',0,0,0,0,0,0,0,0,0,0,86306,0,26124),
(134357,'That gave me no pleasure either.','',0,0,0,0,0,0,0,0,0,0,86307,0,26124),
(134358,'Rules are rules.','',0,0,0,0,0,0,0,0,0,0,86308,0,26124),
(134359,'','I have broken countless mortals. What chance do you think you have?',0,0,0,0,0,0,0,0,0,0,0,86561,26124),
(134360,'','My life for the Legion!',0,0,0,0,0,0,0,0,0,0,0,86577,26124),
(134361,'','You will not... escape your fate...',0,0,0,0,0,0,0,0,0,0,0,86578,26124),
(134362,'','This pain is nothing...',0,0,0,0,0,0,0,0,0,0,0,86579,26124),
(134363,'','Defiance will not be tolerated!',0,0,0,0,0,0,0,0,0,0,0,86563,26124),
(134364,'','Don\'t you see? This is the only way. I will make you understand!',0,0,0,0,0,0,0,0,0,0,0,86564,26124),
(134365,'','Nothing can stop the master!',0,0,0,0,0,0,0,0,0,0,0,86580,26124),
(134366,'','A stubborn one... I see.',0,0,0,0,0,0,0,0,0,0,0,86581,26124),
(134367,'','You are blind... to the truth!',0,0,0,0,0,0,0,0,0,0,0,86582,26124),
(134368,'Tremble before the true might of the Legion!','',0,0,0,0,0,0,0,0,0,0,86543,0,26124),
(134369,'That world of yours hanging in the sky... is doomed!','',0,0,0,0,0,0,0,0,0,0,86545,0,26124),
(134370,'Argus will be your tomb.','',0,0,0,0,0,0,0,0,0,0,86547,0,26124),
(134371,'The true power of the fel courses through me!','',0,0,0,0,0,0,0,0,0,0,86548,0,26124),
(134372,'You were foolish to come here!','',0,0,0,0,0,0,0,0,0,0,86549,0,26124),
(134373,'Your pathetic resistance ends here!','',0,0,0,0,0,0,0,0,0,0,86550,0,26124),
(134374,'No... not after all we gave...','',0,0,0,0,0,0,0,0,0,0,87157,0,26124),
(134375,'Impossible! Not here!','',0,0,0,0,0,0,0,0,0,0,86572,0,26124),
(134376,'My life for Argus!','',0,0,0,0,0,0,0,0,0,0,86573,0,26124),
(134377,'No! Our... destiny...','',0,0,0,0,0,0,0,0,0,0,86574,0,26124),
(134378,'Was this... the vision he saw?','',0,0,0,0,0,0,0,0,0,0,86575,0,26124),
(134379,'I told him of my plan to leave Argus. I asked him to bring my family and join me. Instead, he went to Kil\'jaeden.','',0,0,0,0,0,0,1,0,0,0,87878,0,26124),
(134380,'The rest, you know.','',0,0,0,0,0,0,1,0,0,0,87879,0,26124),
(134381,'You... insignificant...','',0,0,0,0,0,0,0,0,0,0,86576,0,26124),
(134382,'My people will never know how I mourned for them... the depths of my regret.','',0,0,0,0,0,0,0,0,0,0,87880,0,26124),
(134383,'As Argus grew smaller and smaller in the distance, I begged the naaru to go back.','',0,0,0,0,0,0,0,0,0,0,87881,0,26124),
(134384,'\"That is not your path,\" they told me. Is this what they intended?','',0,0,0,0,0,0,0,0,0,0,87882,0,26124),
(134385,'Archimonde was disdainful of the Sigil\'s limitations. Without the rest of the Crown, it gave him little power. And power was all he ever craved.','',0,0,0,0,0,0,0,0,0,0,87883,0,26124),
(134386,'This disdain is what allowed us to recover the Sigil. Had he anticipated its value to us, heh, he most certainly would have destroyed it.','',0,0,0,0,0,0,0,0,0,0,87884,0,26124),
(134387,'I do wonder what he hoped to prove with his trials. Was the Sigil itself the test, perhaps?','',0,0,0,0,0,0,0,0,0,0,87885,0,26124),
(134388,'We are one step closer to unlocking the Vindicaar\'s true potential. All that remains is the Crest of Knowledge. Then the Crown will once more be whole.','',0,0,0,0,0,0,0,0,0,0,87886,0,26124),
(134389,'Make haste, my friends. Something dark and terrible stirs... and it is not Talgath.','',0,0,0,0,0,0,0,0,0,0,87887,0,26124),
(134390,'Worthless. The Crest alone is powerless.','',0,0,0,0,0,0,0,0,0,0,87808,0,26124),
(134391,'This relic\'s time has passed. Throw it in the temple with the naaru. Let them rot together.','',0,0,0,0,0,0,0,0,0,0,87809,0,26124),
(134392,'At least we know where it is.','',0,0,0,0,0,0,0,0,0,0,87690,0,26124),
(134393,'It is hidden in the Seat of the Triumvirate, then. I sense only darkness within.','',0,0,0,0,0,0,0,0,0,0,87888,0,26124),
(134396,'We have no time to celebrate our victory over Talgath. L\'ura\'s dark song echoes in my mind.','',0,0,0,0,0,0,0,0,0,0,87889,0,26124),
(134399,'You have faced perils rivaling any the Legion has wrought. Please, do me the honor of placing the Crest.','',0,0,0,0,0,0,0,0,0,0,87890,0,26124),
(134400,'The Crown is whole once more!','',0,0,0,0,0,0,0,0,0,0,87891,0,26124),
(134401,'Now we take the fight to the Burning Throne itself. Ready yourselves. Antorus awaits!','',0,0,0,0,0,0,0,0,0,0,87892,0,26124),
(134402,'Sweet dreams.','',0,0,0,0,0,0,0,0,0,0,86379,0,26124),
(134403,'Stay down!','',0,0,0,0,0,0,0,0,0,0,86380,0,26124),
(134404,'I\'ll collect you later.','',0,0,0,0,0,0,0,0,0,0,86381,0,26124),
(134405,'Keep up, if you can.','',0,0,0,0,0,0,0,0,0,0,86385,0,26124),
(134406,'Time for a little carnage!','',0,0,0,0,0,0,0,0,0,0,86386,0,26124),
(134407,'You\'ve got to be faster than that, mortals!','',0,0,0,0,0,0,0,0,0,0,86387,0,26124),
(134408,'Don\'t need a complete corpse to collect the bounty. A few pieces will do.','',0,0,0,0,0,0,0,0,0,0,86373,0,26124),
(134409,'Try to keep your identifiable parts intact.','',0,0,0,0,0,0,0,0,0,0,86374,0,26124),
(134410,'I am afraid our continued presence on Mac\'Aree has awoken more angry spirits. Help them find peace.','',0,0,0,0,0,0,0,0,0,0,87938,0,26124),
(134411,'I look forward to the day when we leave this shattered place behind. Perhaps then they will find their rest.','',0,0,0,0,0,0,0,0,0,0,87939,0,26124),
(134412,'I have need of a very specific type of crystal to maintain the Vindicaar\'s defenses. The constructs lingering here share this technology. Extract their cores. Use whatever manner you see fit.','',0,0,0,0,0,0,0,0,0,0,87664,0,26124),
(134413,'Those constructs certainly have not aged well, have they? I guess nothing is immune to obsolescence in the end.','',0,0,0,0,0,0,0,0,0,0,87665,0,26124),
(134414,'The Legion\'s forces occupy the estates of Mac\'Aree. Activate the nobles\' vigilants to help with the battle. No doubt their power crystals have been stolen by the eredar.','',0,0,0,0,0,0,0,0,0,0,87940,0,26124),
(134415,'The activated constructs will serve as an excellent distraction. My thanks!','',0,0,0,0,0,0,0,0,0,0,87941,0,26124),
(134416,'The Legion seeks to claim a foothold on Mac\'Aree. Disrupt their forces any way you can. Give them a mess to clean up.','',0,0,0,0,0,0,0,0,0,0,87741,0,26124),
(134417,'That ought to keep them busy. For now, at least.','',0,0,0,0,0,0,0,0,0,0,87742,0,26124),
(134418,'','The formidable creatures here are prey worthy of any hunter, yet the Shadowguard seeks to empower them further with the void. Stop the ethereals and release these beasts back into the wilds.',0,0,0,0,0,0,0,0,0,0,0,87550,26124),
(134419,'','I hope they can be soothed after their ordeal. Good work, but our struggle against the Shadowguard continues.',0,0,0,0,0,0,0,0,0,0,0,87551,26124),
(134420,'My brethren are as industrious as they are clever. I fear the incursion point needs another round of cleansing. You know what to do.','',0,0,0,0,0,0,0,0,0,0,87850,0,26124),
(134421,'Amusing how they continue to underestimate you fleshlings, is it not?','',0,0,0,0,0,0,0,0,0,0,87851,0,26124),
(134422,'Forces from Antorus are using the remains of Talgath\'s portals to stage another invasion on Mac\'Aree. Stop their advance before we are overrun.','',0,0,0,0,0,0,0,0,0,0,87743,0,26124),
(134423,'You bought us valuable time, but we must remain vigilant. So long as the Legion knows we have a foothold on Mac\'Aree, they will not relent.','',0,0,0,0,0,0,0,0,0,0,87744,0,26124),
(134424,'Strange... Spirits have congregated to hear Kil\'jaeden speak, yet all is not as it seems. I sense a demonic presence. Find it amongst the crowd before it can stage an ambush.','',0,0,0,0,0,0,0,0,0,0,87942,0,26124),
(134425,'An unusual tactic, to be certain. The Legion cannot be allowed to use these defenseless spirits for their machinations.','',0,0,0,0,0,0,0,0,0,0,87943,0,26124),
(134426,'','This place is churning out darkness, manifesting into crystals of pure void. The Shadowguard covets this resource. We must claim it before they do.',0,0,0,0,0,0,0,0,0,0,0,87542,26124),
(134427,'','That is one less arrow in their quiver. Perhaps I can find a use for these crystals that will benefit our cause.',0,0,0,0,0,0,0,0,0,0,0,87543,26124),
(134428,'I have devised a modification on a previous trial. Should you be equal to the challenge, you may once again prove your cunning.','',0,0,0,0,0,0,0,0,0,0,87984,0,26124),
(134429,'Hmph. I was certain you would not complete the trial this time. I must, per the rules, acknowledge your success. Congratulations.','',0,0,0,0,0,0,0,0,0,0,87985,0,26124),
(134430,'','Panthara are feasting on Conservatory spirits. Bring me samples of their scales. Perhaps I can devise a deterrent.',0,0,0,0,0,0,0,0,0,0,0,87579,26124),
(134431,'','Fascinating! Their scales are covered in mana-sensitive particulate. I am certain we can find a use for this knowledge.',0,0,0,0,0,0,0,0,0,0,0,87580,26124),
(134432,'You are overdue for remedial lessons. Report to the Hall of Enlightenment for an exam.','',0,0,0,0,0,0,0,0,0,0,88100,0,26124),
(134433,'I will allow you to retain your credentials. For now.','',0,0,0,0,0,0,0,0,0,0,87986,0,26124),
(134434,'','There are many unanswered questions about the spirits lingering in this place. Why do they stay? What makes them rebuff our presence? Perhaps studying their essences will yield an answer.',0,0,0,0,0,0,0,0,0,0,0,87581,26124),
(134435,'','I will not waste this opportunity to learn from my former peers. Thank you for your help.',0,0,0,0,0,0,0,0,0,0,0,87582,26124),
(134436,'My brethren have taken it upon themselves to hasten this area\'s fall to darkness. Disrupt their activities. Or don\'t. The Void will have its due either way.','',0,0,0,0,0,0,0,0,0,0,87855,0,26124),
(134437,'You know what they say. Fool me once, shame on you. Fool me twice...','',0,0,0,0,0,0,0,0,0,0,87856,0,26124),
(134440,'You\'ve got nowhere to run.','',0,0,0,0,0,0,0,0,0,0,86375,0,26124),
(134441,'Looks like I\'ll have to call in the big guns.','',0,0,0,0,0,0,0,0,0,0,86376,0,26124),
(134443,'<Shroud of Arcane Echoes>','<Shroud of Arcane Echoes>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134444,'<Vindicaar Teleport Beacon>','<Vindicaar Teleport Beacon>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134445,'<Lightforged Champion>','<Lightforged Champion>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134446,'<Lightforged Warframe>','<Lightforged Warframe>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134452,'What of the other captains? I pray that they are safe as well.','',0,0,0,0,0,0,0,0,0,0,86338,0,26124),
(134454,'','Do not worry, High Exarch. Enaara and Sorvos have taken up positions at our main camp. The rest are scattered, but I am sure they survived.',0,0,0,0,0,0,0,0,0,0,0,87645,26124),
(134455,'Fire on my position!','',0,0,0,0,0,0,0,0,0,0,86377,0,26124),
(134456,'Bombard this area!','',0,0,0,0,0,0,0,0,0,0,86378,0,26124),
(134457,'The more you fight, the higher the bounty!','',0,0,0,0,0,0,0,0,0,0,86388,0,26124),
(134458,'Light\'s Judgment... she is magnificent. I should have it operational shortly!','',0,0,0,0,0,0,0,0,0,0,86148,0,26124),
(134459,'You\'re beginning to outlive your worth.','',0,0,0,0,0,0,0,0,0,0,86389,0,26124),
(134461,'You\'re not going to make it out of this alive!','',0,0,0,0,0,0,0,0,0,0,86390,0,26124),
(134462,'I\'ll cut you in two and collect twice the bounty!','',0,0,0,0,0,0,0,0,0,0,86383,0,26124),
(134466,'','Antorus will know your screams!',0,0,0,0,0,0,0,0,0,0,0,86782,26124),
(134467,'','Witness the might of the Burning Throne!',0,0,0,0,0,0,0,0,0,0,0,86783,26124),
(134468,'','A fatal mistake.',0,0,0,0,0,0,0,0,0,0,0,86784,26124),
(134469,'','You think you can defeat us? Here? Hah!',0,0,0,0,0,0,0,0,0,0,0,86785,26124),
(134470,'','I want to see your limbs roasting!',0,0,0,0,0,0,0,0,0,0,0,87024,26124),
(134472,'','Antorus sends its regards!',0,0,0,0,0,0,0,0,0,0,0,86786,26124),
(134473,'','You look so vulnerable, trembling in the dark.',0,0,0,0,0,0,0,0,0,0,0,86912,26124),
(134477,'You\'ve done it, champion! Come, let us enter the Xenedar and rescue Xe\'ra!','',0,0,0,0,0,0,0,0,0,0,86510,0,26124),
(134478,'','Enjoy my icy caress before you are frozen solid.',0,0,0,0,0,0,0,0,0,0,0,86927,26124),
(134479,'','I will be reborn again... and again...',0,0,0,0,0,0,0,0,0,0,0,86787,26124),
(134480,'','I am one... of many...',0,0,0,0,0,0,0,0,0,0,0,86776,26124),
(134481,'','Antorus, I return...',0,0,0,0,0,0,0,0,0,0,0,86777,26124),
(134482,'','By Argus\' flame I will be renewed.',0,0,0,0,0,0,0,0,0,0,0,86778,26124),
(134483,'','This changes nothing.',0,0,0,0,0,0,0,0,0,0,0,86773,26124),
(134484,'Run... while you can.','Run... while you can.',0,0,0,0,0,0,0,0,0,0,86709,86710,26124),
(134485,'The eredar... reign...','The eredar... reign...',0,0,0,0,0,0,0,0,0,0,86711,86712,26124),
(134486,'Why is it... dark?','Why is it... dark?',0,0,0,0,0,0,0,0,0,0,86713,86714,26124),
(134487,'Argus will... rise...','Argus will... rise...',0,0,0,0,0,0,0,0,0,0,86715,86716,26124),
(134488,'There is nowhere to run.','There is nowhere to run.',0,0,0,0,0,0,0,0,0,0,86717,86718,26124),
(134489,'You... will never... escape...','You... will never... escape...',0,0,0,0,0,0,0,0,0,0,86719,86720,26124),
(134491,'Run... while you can.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134493,'The Eredar... reign...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134494,'Why is it... dark?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134495,'Argus will... rise...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134496,'There is nowhere to run.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134497,'You... will never... escape...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134498,'Embrace Sargeras!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134499,'Yes! Flee! Flee!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134500,'You flee to the abyss, coward!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134501,'Suffer your folly!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134502,'Khaz\'goroth\'s will is bein\' twisted. He can\'t control his flame!','',0,0,0,0,0,0,0,0,0,0,88491,0,26124),
(134503,'This will be the last gift you reject!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134504,'Sargeras cannot be denied!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134505,'Suffer for your folly!','Suffer for your folly!',0,0,0,0,0,0,0,0,0,0,86707,86708,26124),
(134506,'You flee to the abyss, coward!','You flee to the abyss, coward!',0,0,0,0,0,0,0,0,0,0,86721,86722,26124),
(134507,'Yes! Flee! Flee!','Yes! Flee! Flee!',0,0,0,0,0,0,0,0,0,0,86723,86724,26124),
(134508,'Embrace Sargeras!','Embrace Sargeras!',0,0,0,0,0,0,0,0,0,0,86731,86732,26124),
(134509,'Sargeras cannot be denied!','Sargeras cannot be denied!',0,0,0,0,0,0,0,0,0,0,86733,86734,26124),
(134510,'This will be the last gift you reject!','This will be the last gift you reject!',0,0,0,0,0,0,0,0,0,0,86735,86736,26124),
(134511,'You will not torment me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134512,'Why can\'t you let us rest?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134513,'This is our home! Begone!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134514,'Do not mock my suffering!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134515,'You do not belong here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134516,'Why have you come?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134517,'Why have you come?','Why have you come?',0,0,0,0,0,0,0,0,0,0,86642,86643,26124),
(134518,'You do not belong here!','You do not belong here!',0,0,0,0,0,0,0,0,0,0,86644,86645,26124),
(134519,'Do not mock my suffering!','Do not mock my suffering!',0,0,0,0,0,0,0,0,0,0,86646,86647,26124),
(134520,'This is our home! Begone!','This is our home! Begone!',0,0,0,0,0,0,0,0,0,0,86648,86649,26124),
(134521,'Why can\'t you let us rest?','Why can\'t you let us rest?',0,0,0,0,0,0,0,0,0,0,86650,86651,26124),
(134522,'You will not torment me!','You will not torment me!',0,0,0,0,0,0,0,0,0,0,86652,86653,26124),
(134523,'I am so tired.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134524,'Such darkness... I had hoped...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134525,'Velen... why?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134526,'We could not escape.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134527,'I wish I had... fled...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134528,'When will it end?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134529,'When will it end?','When will it end?',0,0,0,0,0,0,0,0,0,0,86658,86659,26124),
(134530,'I wish I had... fled...','I wish I had... fled...',0,0,0,0,0,0,0,0,0,0,86660,86661,26124),
(134531,'We could not escape.','We could not escape.',0,0,0,0,0,0,0,0,0,0,86662,86663,26124),
(134532,'Velen... why?','Velen... why?',0,0,0,0,0,0,0,0,0,0,86664,86665,26124),
(134533,'Such darkness... I had hoped...','Such darkness... I had hoped...',0,0,0,0,0,0,0,0,0,0,86666,86667,26124),
(134534,'I am so tired.','I am so tired.',0,0,0,0,0,0,0,0,0,0,86668,86669,26124),
(134535,'I waited so long...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134536,'Is this... all there is?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134537,'Is this... all there is?','Is this... all there is?',0,0,0,0,0,0,0,0,0,0,86672,86673,26124),
(134538,'I waited so long...','I waited so long...',0,0,0,0,0,0,0,0,0,0,86670,86671,26124),
(134539,'Is this... all there is?','Is this... all there is?',0,0,0,0,0,0,0,0,0,0,86640,86641,26124),
(134540,'I waited so long...','I waited so long...',0,0,0,0,0,0,0,0,0,0,86638,86639,26124),
(134541,'','Is this... all there is?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134542,'','I waited so long...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134543,'They\'re tearin\' Norgannon\'s mind ta pieces!','',0,0,0,0,0,0,0,0,0,0,88493,0,26124),
(134544,'Golganneth... he\'s lost in a storm o\' agony!','',0,0,0,0,0,0,0,0,0,0,88489,0,26124),
(134545,'','Leave us alone!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134546,'','You are not welcome here!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134547,'You are not welcome here!','You are not welcome here!',0,0,0,0,0,0,0,0,0,0,86624,86625,26124),
(134548,'Leave us alone!','Leave us alone!',0,0,0,0,0,0,0,0,0,0,86622,86623,26124),
(134549,'You are not welcome here!','You are not welcome here!',0,0,0,0,0,0,0,0,0,0,86656,86657,26124),
(134550,'Leave us alone!','Leave us alone!',0,0,0,0,0,0,0,0,0,0,86654,86655,26124),
(134551,'You are not welcome here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134552,'Leave us alone!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134553,'It is good to see you again, my friends. When I couldn\'t find you after the devastation of Draenor, I wasn\'t sure what to think.','',0,0,0,0,0,0,1,0,0,0,86109,0,26124),
(134554,'','You rush to your death. Allow me to oblige you.',0,0,0,0,0,0,0,0,0,0,0,86779,26124),
(134555,'We feared for you as well, Khadgar. But I think part of me knew it would take more than the explosion of a planet to slow you down.','',0,0,0,0,0,0,1,0,0,0,86110,0,26124),
(134556,'','More souls to fuel the fel!',0,0,0,0,0,0,0,0,0,0,0,86780,26124),
(134557,'','Kurdran and Danath are safe as well?',0,0,0,0,0,0,6,0,0,0,0,86107,26124),
(134558,'','Argus will know your pain!',0,0,0,0,0,0,0,0,0,0,0,86781,26124),
(134559,'There is nowhere to run!','There is nowhere to run!',0,0,0,0,0,0,0,0,0,0,86725,86726,26124),
(134560,'Indeed, though I don\'t get to see them as often as I\'d like. When this is all behind us, perhaps the Sons of Lothar should share a reunion feast!','',0,0,0,0,0,0,1,0,0,0,86111,0,26124),
(134561,'You will pay for your cowardice!','You will pay for your cowardice!',0,0,0,0,0,0,0,0,0,0,86727,86728,26124),
(134562,'You will pay for your cowardice!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134563,'There is nowhere to run!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134564,'You will pay for your cowardice!','You will pay for your cowardice!',0,0,0,0,0,0,0,0,0,0,86753,86754,26124),
(134565,'There is nowhere to run!','There is nowhere to run!',0,0,0,0,0,0,0,0,0,0,86755,86756,26124),
(134566,'You will pay for your cowardice!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134567,'There is nowhere to run!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134568,'I agree. It\'s been a long time, but as I recall it was your turn to buy the drinks, Khadgar.','',0,0,0,0,0,0,1,0,0,0,86112,0,26124),
(134569,'They\'re usin\' Aman\'Thul\'s mastery o\' time against ye!','',0,0,0,0,0,0,0,0,0,0,88487,0,26124),
(134570,'Well, I don\'t know about that...','',0,0,0,0,0,0,661,0,0,0,86175,0,26124),
(134571,'We will never stop...','We will never stop...',0,0,0,0,0,0,0,0,0,0,86729,86730,26124),
(134572,'','Definitely your turn. Never question an elf\'s memory... even after a thousand years.',0,0,0,0,0,0,273,0,0,0,0,86108,26124),
(134573,'The Destroyer will find you...','The Destroyer will find you...',0,0,0,0,0,0,0,0,0,0,86737,86738,26124),
(134574,'The Destroyer will find you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134575,'Your cowardice marks you. We will never stop...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134576,'The Destroyer will find you...','The Destroyer will find you...',0,0,0,0,0,0,0,0,0,0,86765,86766,26124),
(134577,'We will never stop...','We will never stop...',0,0,0,0,0,0,0,0,0,0,86767,86768,26124),
(134578,'The Destroyer will find you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134579,'Your cowardice marks you. We will never stop...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134600,'','Find the Prophet! Slaughter his allies!',0,0,0,0,0,0,0,0,0,51281,0,88009,26124),
(134601,'','Mark my words! Velen must not escape!',0,0,0,0,0,0,0,0,0,51281,0,88000,26124),
(134602,'','Leave no stone unturned. Find him!',0,0,0,0,0,0,0,0,0,51281,0,88001,26124),
(134603,'','Failure will be rewarded with torment! The Prophet must not escape!',0,0,0,0,0,0,0,0,0,51281,0,88002,26124),
(134604,'','The eyes of Antorus are upon you. Find the Prophet or suffer the consequences!',0,0,0,0,0,0,0,0,0,51281,0,88003,26124),
(134605,'','Get back to work... or you will know the lash!',0,0,0,0,0,0,0,0,0,51282,0,88004,26124),
(134606,'','Double your efforts! This land has been useless long enough.',0,0,0,0,0,0,0,0,0,51282,0,88005,26124),
(134607,'','You can rest when this rock is ours!',0,0,0,0,0,0,0,0,0,51282,0,88006,26124),
(134608,'','Antorus demands its prize! Mac\'Aree will be ours!',0,0,0,0,0,0,0,0,0,51282,0,88007,26124),
(134609,'','Your lives are forfeit, should we fail. Secure Mac\'Aree!',0,0,0,0,0,0,0,0,0,51282,0,88008,26124),
(134611,'I won\'t risk our forces on the spire without that warframe backing us.','',0,0,0,0,0,0,1,0,0,0,86512,0,26124),
(134612,'It will be ready, High Exarch. You have my word.','',0,0,0,0,0,0,113,0,0,0,86598,0,26124),
(134623,'Was I supposed to energize the projection before I stabilized the effusion? Oh...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134625,'Maybe if I just invert the core matrix to expel... wait, no. That is how explosions happen.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134626,'I should have started studying sooner.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134627,'Krono-ka lith\'tor agnos... or was it lith\'nos agtor? Bah! I will never get this spell right!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134628,'','Perhaps we had best discuss the matter in private.',0,0,0,0,0,0,1,0,0,0,0,86117,26124),
(134634,'Maybe I should have listened to my parents and come a jewelcrafter instead...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134635,'I will never reach Arc-Consul at this rate.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134636,'Archimonde learned to do this as an acolyte. How hard could it be?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134640,'The demons came into our world, their only desire to extinguish all life.','',0,0,0,0,0,0,396,0,0,0,86323,0,26124),
(134641,'Now we will prey upon them!','',0,0,0,0,0,0,396,0,0,0,86324,0,26124),
(134642,'Already their ranks crumble. We must press the attack.','',0,0,0,0,0,0,396,0,0,0,86325,0,26124),
(134643,'','I go missing for all those years and this is how you treat me?',0,0,0,0,0,0,0,0,0,0,0,86277,26124),
(134644,'','Yes, of course I still love him. Must you be so nosey?',0,0,0,0,0,0,603,0,0,0,0,86278,26124),
(134645,'','Sisters are complicated. Especially the undead ones.',0,0,0,0,0,0,1,0,0,0,0,86279,26124),
(134653,'I lend you my strength.','',0,0,0,0,0,0,0,0,0,0,86284,0,26124),
(134654,'','My void will consume you... if you ask nicely.',0,0,0,0,0,0,0,0,0,0,0,86280,26124),
(134655,'Come, speak with me.','',0,0,0,0,0,0,0,0,0,0,86285,0,26124),
(134657,'Our time is now, hero.','',0,0,0,0,0,0,0,0,0,0,86286,0,26124),
(134658,'The Vindicaar is at your disposal.','',0,0,0,0,0,0,0,0,0,0,86287,0,26124),
(134659,'We will endure.','',0,0,0,0,0,0,0,0,0,0,86288,0,26124),
(134660,'May the Legion fall before you.','',0,0,0,0,0,0,0,0,0,0,86289,0,26124),
(134662,'Remember, even number of facets, no occlusions. It has to be just so!','',0,0,0,0,0,0,396,0,0,0,87671,0,26124),
(134677,'I have your coordinates, champion. It will take some time to calibrate the teleportation matrices. Keep it out of the Legion\'s hands until then!','',0,0,0,0,0,0,0,0,0,0,86322,0,26124),
(134679,'We\'ve breached the wall!','',0,0,0,0,0,0,0,0,0,0,86497,0,26124),
(134680,'Lightforged, secure this position!','',0,0,0,0,0,0,0,0,0,0,86498,0,26124),
(134681,'The Vindicaar will draw all the fire we can, Turalyon, but we cannot hold out long. You must disable their defenses!','',0,0,0,0,0,0,0,0,0,0,88053,0,26124),
(134682,'We will not fail you, Prophet.','',0,0,0,0,0,0,0,0,0,0,86499,0,26124),
(134683,'Champions, we\'ll keep these winged beasts occupied while you clear a path.','',0,0,0,0,0,0,0,0,0,0,86507,0,26124),
(134684,'','Make them suffer.',0,0,0,0,0,0,0,0,0,0,0,87487,26124),
(134685,'Careful. I dabble in powers beyond your comprehension.','',0,0,0,0,0,0,0,0,0,0,86315,0,26124),
(134686,'Yes, I do have a \"real\" name. It\'s none of your business.','',0,0,0,0,0,0,0,0,0,0,86316,0,26124),
(134687,'Were I to speak it aloud, a thousand void portals would rip open and some very unpleasant entities would come looking to collect on old debts.','',0,0,0,0,0,0,0,0,0,0,86317,0,26124),
(134688,'But by all means, if you want to see reality itself torn asunder, keep asking about my name.','',0,0,0,0,0,0,0,0,0,0,86318,0,26124),
(134689,'Here\'s a hint: it\'s an ancient word of power. If I whisper it in your ear, your mind will fall into madness. Still want to play?','',0,0,0,0,0,0,0,0,0,0,86319,0,26124),
(134690,'We\'re gaining ground! Press the attack!','',0,0,0,0,0,0,0,0,0,0,86500,0,26124),
(134691,'Lightforged, fall back!','',0,0,0,0,0,0,0,0,0,0,86501,0,26124),
(134692,'Champions, bring that monstrosity down!','',0,0,0,0,0,0,0,0,0,0,86502,0,26124),
(134694,'Once the spires are out of the way, we will make our move.','',0,0,0,0,0,0,396,0,0,0,88153,0,26124),
(134700,'','Turalyon, I\'ve started my assault on the northern front. I\'ll keep their forces occupied so you can hit the priority targets.',0,0,0,0,0,0,0,0,0,0,0,86956,26124),
(134701,'Our forces are moving towards Legion high command. Buy us all the time you can, Alleria.','',0,0,0,0,0,0,0,0,0,0,86496,0,26124),
(134702,'','Use my portals to take the fight to the enemy. Make haste!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134703,'Champions, there is a disturbance close to your location the likes of which I haven\'t felt since the opening of the Dark Portal.','',0,0,0,0,0,0,0,0,0,0,86964,0,26124),
(134704,'|TInterface\\Icons\\ABILITY_CREATURE_CURSED_05.BLP:20|tThe Paraxis charges its weapons to bring about Eonar\'s |cFFFF0000|Hspell:249121|h[Final Doom]|h|r!','|TInterface\\Icons\\ABILITY_CREATURE_CURSED_05.BLP:20|tThe Paraxis charges its weapons to bring about Eonar\'s |cFFFF0000|Hspell:249121|h[Final Doom]|h|r !',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134705,'If the Legion is using that hub to gather reinforcements, then it must be destroyed before we are overwhelmed.','',0,0,0,0,0,0,0,0,0,0,86965,0,26124),
(134706,'|TInterface\\Icons\\PRIEST_ICON_CHAKRA.BLP:20|tDiseased energy infects you.','|TInterface\\Icons\\PRIEST_ICON_CHAKRA.BLP:20|tDiseased energy infects you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134707,'|TInterface\\Icons\\PRIEST_ICON_CHAKRA_RED.BLP:20|tFirey energy burns through you.','|TInterface\\Icons\\PRIEST_ICON_CHAKRA_RED.BLP:20|tFirey energy burns through you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134708,'|TInterface\\Icons\\PRIEST_ICON_CHAKRA_GREEN.BLP:20|tFel energy courses through you.','|TInterface\\Icons\\PRIEST_ICON_CHAKRA_GREEN.BLP:20|tFel energy courses through you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134709,'|TInterface\\Icons\\PRIEST_ICON_CHAKRA_BLUE.BLP:20|tArcane energies crackle around you.','|TInterface\\Icons\\PRIEST_ICON_CHAKRA_BLUE.BLP:20|tArcane energies crackle around you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134711,'Diseased energy infects a nearby crystal.','Diseased energy infects a nearby crystal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134712,'A nearby crystal burns with Fiery energy.','A nearby crystal burns with Fiery energy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134713,'Fel energy courses through a nearby crystal.','Fel energy courses through a nearby crystal.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134714,'A nearby crystal crackles with Arcane energy.','A nearby crystal crackles with Arcane energy.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134716,'Without their portals, the Legion is cut off from reinforcements. Now is the time to press our attack!','',0,0,0,0,0,0,0,0,0,0,86966,0,26124),
(134717,'Sargeras has left us a few of his favorite pets to play with. Remove these abominations from the battlefield.','',0,0,0,0,0,0,0,0,0,0,87761,0,26124),
(134718,'That\'s two demons down, but countless more await the attention of your blade.','',0,0,0,0,0,0,0,0,0,0,87762,0,26124),
(134719,'I recognize the trappings of the generals commanding the Legion\'s forces. Before Sargeras took our world, these generals martialed our armies and brought peace to Argus.','',0,0,0,0,0,0,0,0,0,0,88050,0,26124),
(134720,'They betrayed everything we stood for when they accepted his bargain. There can be no redemption... only retribution.','',0,0,0,0,0,0,0,0,0,0,88051,0,26124),
(134721,'The war council has finally paid for their treachery. Without their leadership, the Legion will fall into chaos.','',0,0,0,0,0,0,0,0,0,0,88052,0,26124),
(134723,'Champions! I heard a familiar voice callin\', so I fought me way inside this accursed place.','',0,0,0,0,0,0,0,0,0,0,88280,0,26124),
(134724,'','Champions, hear me.  The Legion has breached my sanctuary, and my defenses will soon be overrun. Stand with me now, lest Sargeras claim his prize.',0,0,0,0,0,0,0,0,0,0,0,88190,26124),
(134730,'It\'s Eonar, the Life-Binder! This portal leads ta her sanctuary. Go. I\'ll stay here and cover yer backs!','',0,0,0,0,0,0,0,0,0,0,88281,0,26124),
(134731,'','The tormented cries of the Pantheon ring out from deep within the core of Argus.',0,0,0,0,0,0,0,0,0,0,0,88191,26124),
(134732,'','Release them, champions, or your struggle will be for naught.',0,0,0,0,0,0,0,0,0,0,0,88192,26124),
(134733,'The Legion\'s ranks are crumbling, but they still outnumber us. My forces will keep them engaged here.','',0,0,0,0,0,0,0,0,0,0,86508,0,26124),
(134734,'','You will not be fighting alone, Turalyon. The demons will pay for every step... with their blood.',0,0,0,0,0,0,0,0,0,0,0,86957,26124),
(134735,'Well done, champions. For the first time in millennia, a blow has been struck against the denizens of the Burning Throne.','',0,0,0,0,0,0,0,0,0,0,87893,0,26124),
(134736,'Sargeras seeks ta corrupt the other titans! If we don\'t stop \'im, the Pantheon will be reborn in darkness. There\'s no time ta waste!','',0,0,0,0,0,0,0,0,0,0,88282,0,26124),
(134737,'Striking at the heart of the Legion is futile until we take out their war machines. Unchecked, they would soon overwhelm us.','',0,0,0,0,0,0,0,0,0,0,87763,0,26124),
(134738,'Agreed. We must cripple those infernal engines of destruction. Champions, use this teleporter to board the Vindicaar. On to our next target!','',0,0,0,0,0,0,0,0,0,0,86967,0,26124),
(134742,'The Legion is in its death throes. Time to put our boot to their throats. Return to the Vindicaar and prepare to strike the killing blow.','',0,0,0,0,0,0,0,0,0,0,87764,0,26124),
(134744,'Good, good, I was hoping you\'d find your way here. I\'m always in need of test subjects. You should do nicely!','',0,0,0,0,0,0,0,0,0,0,86990,0,26124),
(134761,'Who ordered the chicken?','',0,0,0,0,0,0,11,0,0,0,0,0,26124),
(134767,'There was barely any warnin\'. De Kor\'kron mounted an attack on Sen\'jin in force. We were lucky Vol\'jin was there to help us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134768,'He gave such an inspirin\' speech!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134769,'Razor Hill was already lost when we got der.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134770,'Dey didn\'t know we was comin\'!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134771,'I miss da Warchief. I tink we all do.','',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(134772,'Welcome to my inn!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134773,'Busy night... but there\'s always room for another!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134774,'Boys and girls, look who it is!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134775,'Pull up a chair by the hearth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134776,'Welcome back!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134777,'Ohohoho, it\'s good to see you again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134778,'Ha, find a seat if you can!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134779,'Think I\'ll keep a few of your parts as a trophy.','',0,0,0,0,0,0,0,0,0,0,86523,0,26124),
(134780,'Your bones will be my biggest payday.','',0,0,0,0,0,0,0,0,0,0,86524,0,26124),
(134785,'Ha! Killed by the best!','',0,0,0,0,0,0,0,0,0,0,86525,0,26124),
(134787,'Barely enough left to collect!','',0,0,0,0,0,0,0,0,0,0,86526,0,26124),
(134788,'Easiest money I ever made.','',0,0,0,0,0,0,0,0,0,0,86527,0,26124),
(134791,'Seems my employer overestimated your threat. But who am I to question a payday?','',0,0,0,0,0,0,0,0,0,0,86528,0,26124),
(134795,'An orb of Diseased energy lies on the ground near the $n.','An orb of Diseased energy lies on the ground near the $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134796,'An orb of Firey energy lies on the ground near the $n.','An orb of Firey energy lies on the ground near the $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134797,'An orb of Fel energy lies on the ground near the $n.','An orb of Fel energy lies on the ground near the $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134798,'An orb of Arcane energy lies on the ground near the $n.','An orb of Arcane energy lies on the ground near the $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134821,'','If Sargeras breaks them as he did Aggramar, no power in this universe will stop him.',0,0,0,0,0,0,0,0,0,0,0,88193,26124),
(134839,'There\'s nothing more I can do, commander. They\'re with the Light now.','There\'s nothing more I can do, commander. They\'re with the Light now.',0,0,0,0,0,0,0,0,0,0,87020,87021,26124),
(134840,'They gave everything to this war. We must honor that sacrifice.','They gave everything to this war. We must honor that sacrifice.',0,0,0,0,0,0,0,0,0,0,87014,87015,26124),
(134868,'You\'ll go no further, mortal scum. There\'s a bounty on your heads, and I mean to collect.','',0,0,0,0,0,0,0,0,0,0,86522,0,26124),
(134870,'Beyond these blast doors lies the heart of the Legion\'s war machine. Eliminating this threat will cripple the demons\' arsenal.','',0,0,0,0,0,0,0,0,0,0,87765,0,26124),
(134878,'Time for my pawns to thin your ranks!','',0,0,0,0,0,0,0,0,0,0,86981,0,26124),
(134879,'','All vessels, converge on my position!',0,0,0,0,0,0,0,0,0,0,0,86911,26124),
(134880,'I tire of this labor! It will be more satisfying to have my machines tear you apart.','',0,0,0,0,0,0,0,0,0,0,86925,0,26124),
(134881,'I can no longer resist the call to battle!','',0,0,0,0,0,0,0,0,0,0,86982,0,26124),
(134882,'','Why let my vessels blast you apart when I can dispatch you myself?',0,0,0,0,0,0,0,0,0,0,0,86908,26124),
(134883,'It appears I need to take a more hands-on approach!','',0,0,0,0,0,0,0,0,0,0,86922,0,26124),
(134884,'','Cannons, begin firing on my mark!',0,0,0,0,0,0,0,0,0,0,0,86905,26124),
(134885,'Demons! Charge!','',0,0,0,0,0,0,0,0,0,0,86983,0,26124),
(134886,'Leave no one alive!','',0,0,0,0,0,0,0,0,0,0,86984,0,26124),
(134887,'Legion, show these weaklings why we are the dominant force in the cosmos!','',0,0,0,0,0,0,0,0,0,0,86985,0,26124),
(134888,'I hope you enjoy my inventions.','',0,0,0,0,0,0,0,0,0,0,86917,0,26124),
(134889,'Watch your step!','',0,0,0,0,0,0,0,0,0,0,86918,0,26124),
(134892,'I have calculated your odds of survival--zero!','',0,0,0,0,0,0,0,0,0,0,86919,0,26124),
(134900,'','The Man\'ari will never defile the armor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134901,'','No! I cannot fail...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134902,'','Death to the Man\'ari!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134903,'','Who dares to defile this sacred armory?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134912,'The Vindicaar awaits your orders, $n. Where do we take the fight next?','The Vindicaar awaits your orders, $n. Where do we take the fight next?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134913,'The Exhaust','The Exhaust',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134914,'','Your faith is weak.',0,0,0,0,0,0,0,0,0,0,0,87035,26124),
(134915,'','Your existence was meaningless.',0,0,0,0,0,0,0,0,0,0,0,87036,26124),
(134916,'','I have walked the spaces between stars. What hope did you have against me?',0,0,0,0,0,0,0,0,0,0,0,87037,26124),
(134917,'','My essence... returns... to the Nether.',0,0,0,0,0,0,0,0,0,0,0,87038,26124),
(134918,'','I wield the power of the cosmos!',0,0,0,0,0,0,0,0,0,0,0,87039,26124),
(134919,'Broken Cliffs','Broken Cliffs',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134920,'The Burning Throne','The Burning Throne',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(134926,'Yet this battle is far from over. A great power roils in torment at this world\'s core.','',0,0,0,0,0,0,0,0,0,0,87915,0,26124),
(134928,'Rendezvous with the Vindicaar so we can prepare for the final attack.','',0,0,0,0,0,0,0,0,0,0,87916,0,26124),
(134981,'Many gave their lives to hold this ground. Honor their sacrifice and drive these demons back into the abyss!','Many gave their lives to hold this ground. Honor their sacrifice and drive these demons back into the abyss!',0,0,0,0,0,0,0,0,0,0,87016,87017,26124),
(135004,'Some disassembly required.','',0,0,0,0,0,0,0,0,0,0,86991,0,26124),
(135005,'Send in the next test subject!','',0,0,0,0,0,0,0,0,0,0,86992,0,26124),
(135006,'Allow me to demonstrate my newest invention.','',0,0,0,0,0,0,0,0,0,0,86993,0,26124),
(135007,'Let\'s see how fast you can run.','',0,0,0,0,0,0,0,0,0,0,86994,0,26124),
(135008,'There is no escape!','',0,0,0,0,0,0,0,0,0,0,86995,0,26124),
(135010,'Witness true power!','',0,0,0,0,0,0,0,0,0,0,86996,0,26124),
(135011,'Die!','',0,0,0,0,0,0,0,0,0,0,86997,0,26124),
(135012,'I will turn you to ash!','',0,0,0,0,0,0,0,0,0,0,86998,0,26124),
(135013,'Such an honor! You will be test subjects for my ultimate weapon!','',0,0,0,0,0,0,0,0,0,0,87000,0,26124),
(135014,'It appears adjustments still need to be made.','',0,0,0,0,0,0,0,0,0,0,87001,0,26124),
(135015,'You have outlived your usefulness!','',0,0,0,0,0,0,0,0,0,0,87002,0,26124),
(135016,'May the Light hasten you to Magni. I hope he has good news.','',0,0,0,0,0,0,1,0,0,0,87714,0,26124),
(135017,'The short one of diamonds awaits you in the stone\'s resting chamber. He is... distressed.','',0,0,0,0,0,0,396,0,0,0,86829,0,26124),
(135019,'I feel Argus\'s soul callin\' ta me again. He\'s frantic, desperate... and sad, so bloody sad. It breaks me heart!','',0,0,0,0,0,0,603,0,0,0,88117,0,26124),
(135020,'Place yer hand upon the stone when yer ready.','',0,0,0,0,0,0,1,0,0,0,88118,0,26124),
(135021,'The stone thrums with energy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135022,'<Place your hand on the stone.>','<Place your hand on the stone.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135023,'Sargeras is building some kind o\' Dark Pantheon! We gotta find Eonar\'s spirit before Aggramar does!','',0,0,0,0,0,0,603,0,0,0,88119,0,26124),
(135026,'So be it. We will do all we can to ensure Eonar does not fall like the others.','',0,0,0,0,0,0,1,0,0,0,87715,0,26124),
(135027,'I only hope we are not too late.','',0,0,0,0,0,0,1,0,0,0,87716,0,26124),
(135058,'Halt!','',0,0,0,0,0,0,0,0,0,0,86834,0,26124),
(135085,'','Such potential here, but all of it wasted on a doomed crusade.',0,0,0,0,0,0,0,0,0,0,0,87130,26124),
(135086,'','Can you taste it on the air? The sweet nectar of madness? Mmm... this place is swollen with it.',0,0,0,0,0,0,0,0,0,0,0,87129,26124),
(135087,'','This one shows promise. The whispers lure her toward her fate.',0,0,0,0,0,0,0,0,0,0,0,87123,26124),
(135088,'','The caterpillar has become the butterfly. She is all but ours now.',0,0,0,0,0,0,0,0,0,0,0,87124,26124),
(135089,'','He flaunts his defiance of the shadows. Arrogance will be his undoing.',0,0,0,0,0,0,0,0,0,0,0,87125,26124),
(135090,'','Watch now as a weak mind gives way to darkness.',0,0,0,0,0,0,0,0,0,0,0,87126,26124),
(135091,'','While I relish a healthy lust for power, this one fumbles for it like an amateur.',0,0,0,0,0,0,0,0,0,0,0,87127,26124),
(135092,'','Now this is true beauty! At least one of the mortals in your midst can appreciate what it offers.',0,0,0,0,0,0,0,0,0,0,0,87128,26124),
(135093,'','So much effort, so much bluster, only to delay the inevitable victory of their betters.',0,0,0,0,0,0,0,0,0,0,0,87044,26124),
(135094,'','Imagine this machinery infused with our power. Interesting...',0,0,0,0,0,0,0,0,0,0,0,87045,26124),
(135095,'','What a disappointment. He squandered his potential by backing the wrong side.',0,0,0,0,0,0,0,0,0,0,0,87046,26124),
(135096,'','These pretenders play at whispering madness. Amateurs! I should demonstrate proper technique.',0,0,0,0,0,0,0,0,0,0,0,87047,26124),
(135097,'','This one would make an excellent champion for our cause. Perhaps he can yet be turned.',0,0,0,0,0,0,0,0,0,0,0,87048,26124),
(135098,'','Long have we sought entry to this realm! To think we have a mortal to thank for giving us our foothold. Your service will be remembered!',0,0,0,0,0,0,0,0,0,0,0,87049,26124),
(135099,'Draw your blades! I will show you torment!','',0,0,0,0,0,0,0,0,0,0,87211,0,26124),
(135100,'Your torment... is only... beginning.','',0,0,0,0,0,0,0,0,0,0,87215,0,26124),
(135101,'Is that all you can take?','',0,0,0,0,0,0,0,0,0,0,87221,0,26124),
(135102,'Pathetic and weak!','',0,0,0,0,0,0,0,0,0,0,87222,0,26124),
(135103,'Weaklings! You surrender to the merest taste of what I have suffered.','',0,0,0,0,0,0,0,0,0,0,87223,0,26124),
(135104,'Time to put an end to this!','',0,0,0,0,0,0,0,0,0,0,87216,0,26124),
(135105,'Behold the might of the nathrezim!','',0,0,0,0,0,0,0,0,0,0,87217,0,26124),
(135106,'So, your Alliance still endures. Longer than I expected, though she has already planted the seeds of its downfall. She is patient, that one.','',0,0,0,0,0,0,0,0,0,0,87212,0,26124),
(135107,'When your thrones run red with betrayal... when your holy places burn and the shattered mask hangs above your hearth... only then you will know. And it will be too late.','',0,0,0,0,0,0,0,0,0,0,87213,0,26124),
(135108,'It matters not. You are blind to the true darkness closing in around you.','',0,0,0,0,0,0,0,0,0,0,87214,0,26124),
(135109,'So, she found me at last. Sent her underlings to finish the job.','',0,0,0,0,0,0,0,0,0,0,87218,0,26124),
(135110,'Tell me, when she seized your throne of hides and bones, was your allegiance forced? No... I\'d wager you surrendered it willingly... or were convinced you did.','',0,0,0,0,0,0,0,0,0,0,87219,0,26124),
(135111,'It matters not. You are blind to the darkness in your midst.','',0,0,0,0,0,0,0,0,0,0,87220,0,26124),
(135112,'Easy prey!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135113,'You are mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135114,'Pain awaits in the darkness!','',0,0,0,0,0,0,0,0,0,0,87199,0,26124),
(135115,'Ah, the agony of shadows!','',0,0,0,0,0,0,0,0,0,0,87200,0,26124),
(135116,'Back, cur!','',0,0,0,0,0,0,0,0,0,0,87204,0,26124),
(135117,'Away!','',0,0,0,0,0,0,0,0,0,0,87205,0,26124),
(135118,'Share your suffering!','',0,0,0,0,0,0,0,0,0,0,87206,0,26124),
(135119,'Let pain embrace you!','',0,0,0,0,0,0,0,0,0,0,87207,0,26124),
(135120,'Behold! Pain given form!','',0,0,0,0,0,0,0,0,0,0,87208,0,26124),
(135121,'A gift born of agony!','',0,0,0,0,0,0,0,0,0,0,87209,0,26124),
(135122,'Grah! Damnable witches!','',0,0,0,0,0,0,0,0,0,0,87202,0,26124),
(135123,'You cannot break me!','',0,0,0,0,0,0,0,0,0,0,87203,0,26124),
(135124,'I... will... kill you all!','',0,0,0,0,0,0,0,0,0,0,87201,0,26124),
(135125,'Arrrrraaaaagghhhh!','',0,0,0,0,0,0,0,0,0,0,87210,0,26124),
(135126,'','Look! The wretch struggles against the mortal intruders.',0,0,0,0,0,0,0,0,0,0,0,87224,26124),
(135127,'','Then watch the icy grip of despair drain his will!',0,0,0,0,0,0,0,0,0,0,0,87225,26124),
(135128,'','We cannot allow this wretch to savor victory.',0,0,0,0,0,0,0,0,0,0,0,87226,26124),
(135129,'','Pathetic! Let them all burn!',0,0,0,0,0,0,0,0,0,0,0,87232,26124),
(135130,'','The prisoner weakens. He is close to surrender.',0,0,0,0,0,0,0,0,0,0,0,87231,26124),
(135131,'','The mortals falter!',0,0,0,0,0,0,0,0,0,0,0,87233,26124),
(135132,'','Perhaps the nathrezim has grown too familiar with the torment of flames, my sisters.',0,0,0,0,0,0,0,0,0,0,0,87229,26124),
(135133,'','Lack of faith is his undoing. The fel will consume the unworthy.',0,0,0,0,0,0,0,0,0,0,0,87228,26124),
(135134,'','Enough of this. Let the shadows claim them all.',0,0,0,0,0,0,0,0,0,0,0,87230,26124),
(135135,'A titan... the Legion must have harnessed the power of its soul to regenerate its armies in the Nether! If we can destroy it, the infinite army...','',0,0,0,0,0,0,1,0,0,0,87717,0,26124),
(135136,'','His fate was ours to decide. You will pay for your insolence, mortals!',0,0,0,0,0,0,0,0,0,0,0,87227,26124),
(135142,'Mac\'Aree... this is all that is left.','',0,0,0,0,0,0,1,0,0,0,87899,0,26124),
(135143,'Using','Using',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135144,'|TInterface\\ICONS\\SPELL_SHADOW_PAINSPIKE:20|tA Greater Rift Warden starts to cast |cFFFF0000|Hspell:245164|h[Fragment of Despair]|h|r!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135146,'I am not the last. The eredar... will rise...','',0,0,0,0,0,0,0,0,0,0,86872,0,26124),
(135148,'This is the power you rejected!','',0,0,0,0,0,0,0,0,0,0,86873,0,26124),
(135149,'You are unworthy of the name eredar!','',0,0,0,0,0,0,0,0,0,0,86874,0,26124),
(135150,'You will not bow? Then die!','',0,0,0,0,0,0,0,0,0,0,86875,0,26124),
(135151,'Look upon perfection. This is the last gift you will reject!','',0,0,0,0,0,0,0,0,0,0,86876,0,26124),
(135152,'Weaklings. I will show you the gravity of your mistake.','',0,0,0,0,0,0,0,0,0,0,86877,0,26124),
(135153,'So many were left behind... They linger, forced to relive their final moments over and over again.','',0,0,0,0,0,0,0,0,0,0,87903,0,26124),
(135154,'Perhaps the only way to end their torment is to finish what I started so very long ago.','',0,0,0,0,0,0,0,0,0,0,87904,0,26124),
(135155,'We must let these spirits finally realize their escape.','',0,0,0,0,0,0,0,0,0,0,87905,0,26124),
(135156,'It is good that you have returned. Something has... changed with the stone.','',0,0,0,0,0,0,396,0,0,0,87154,0,26124),
(135157,'The Life-Binder! Somehow, she\'s the key to Sargeras\'s plan.','',0,0,0,0,0,0,603,0,0,0,88120,0,26124),
(135158,'We must find her soul. I just don\'t know how.','',0,0,0,0,0,0,1,0,0,0,88121,0,26124),
(135159,'Leave that to me.','',0,0,0,0,0,0,1,0,0,0,87793,0,26124),
(135160,'This soul fragment calls ta me again, but somethin\'s different this time. It ain\'t Argus speakin\'. It\'s... another.','',0,0,0,0,0,0,1,0,0,0,88122,0,26124),
(135161,'This is the turning point. If we can activate the arena\'s defenses, this battle will be finished.','',0,0,0,0,0,0,0,0,0,0,87868,0,26124),
(135162,'It is time to forge our own path, my friend.','',0,0,0,0,0,0,0,0,0,0,87869,0,26124),
(135163,'Our forces are prepared to assault the Burning Throne, but we cannot move until we find Eonar\'s spirit.','',0,0,0,0,0,0,1,0,0,0,87718,0,26124),
(135164,'','Would become finite. Taking away the Legion\'s advantage would give us our best chance to save Azeroth!',0,0,0,0,0,0,1,0,0,0,0,87486,26124),
(135165,'It is time we repay the favor.','',0,0,0,0,0,0,396,0,0,0,87794,0,26124),
(135166,'','The Shadowguard is building up its presence near the temple.',0,0,0,0,0,0,0,0,0,0,0,87564,26124),
(135167,'Disrupting their efforts would benefit us all. Also, their commander here has a particular item that would be useful to me.','',0,0,0,0,0,0,0,0,0,0,87824,0,26124),
(135168,'','Just give the word, heroes, and we can begin the assault.',0,0,0,0,0,0,0,0,0,0,0,87565,26124),
(135169,'Thank you for removing the obstacles between me and this staff, heroes.','',0,0,0,0,0,0,0,0,0,0,87825,0,26124),
(135170,'Yes, this will do nicely. You\'ll find their viceroy near the entrance to the temple, feebly trying to break in.','',0,0,0,0,0,0,0,0,0,0,87826,0,26124),
(135171,'Eliminating him will give us an opportunity to get in ourselves.','',0,0,0,0,0,0,0,0,0,0,87827,0,26124),
(135172,'I\'ll see to opening the way once he\'s taken care of.','',0,0,0,0,0,0,0,0,0,0,87828,0,26124),
(135180,'Diseased energy coalesces around the $n.','Diseased energy coalesces around the $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135181,'Fiery energy coalesces around the $n.','Fiery energy coalesces around the $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135182,'Fel energy coalesces around the $n.','Fel energy coalesces around the $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135183,'Arcane energy coalesces around the $n.','Arcane energy coalesces around the $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135186,'|TInterface\\Icons\\SPELL_SHADOW_CURSEOFTOUNGES.BLP:20|tThe Paraxis starts to |cFFFF0000|Hspell:249934|h[Purge]|h|r itself of all enemies!','|TInterface\\Icons\\SPELL_SHADOW_CURSEOFTOUNGES.BLP:20|tThe Paraxis starts to |cFFFF0000|Hspell:249934|h[Purge]|h|r itself of all enemies!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135191,'','I\'ve sent scouts to gauge the extent of the Legion\'s incursion into Mac\'Aree, but they have not returned. Please find them and give aid... if they yet live.',0,0,0,0,0,0,0,0,0,0,0,87639,26124),
(135192,'','The scouts are safe now, thanks to your help.',0,0,0,0,0,0,0,0,0,0,0,87640,26124),
(135193,'','Your timing is fortuitous, champions. Members of the Shadowguard are nearby, infusing the natives with void energy. To what end, I do not know.',0,0,0,0,0,0,1,0,0,0,0,87560,26124),
(135194,'','Figure out their motives... and put a stop to their efforts.',0,0,0,0,0,0,1,0,0,0,0,87561,26124),
(135195,'','Such chaos... such anguish. I have never sensed anything like it before.',0,0,0,0,0,0,0,0,0,0,0,87552,26124),
(135196,'It is rare that a naaru falls into Void this way. The few cases I know of have occurred when mortals were involved. What fascinating implications...','',0,0,0,0,0,0,0,0,0,0,87829,0,26124),
(135197,'Such musings can wait, though. This entity must die.','',0,0,0,0,0,0,0,0,0,0,87830,0,26124),
(135198,'','How did a being of the Light become a creature of Shadow?',0,0,0,0,0,0,0,0,0,0,0,87553,26124),
(135199,'The Void is a force of change... of transformation. Shadows are fluid, ever shifting.','',0,0,0,0,0,0,0,0,0,0,87831,0,26124),
(135200,'','I feel the fallen naaru\'s power. It... beckons me.',0,0,0,0,0,0,0,0,0,0,0,87554,26124),
(135201,'You stand on the cusp of destiny, Alleria. There will be choices to make... and consequences to face.','',0,0,0,0,0,0,0,0,0,0,87832,0,26124),
(135202,'','Even defeated, the darkened naaru surges with power. I hear the shadows calling to me.',0,0,0,0,0,0,0,0,0,0,0,87555,26124),
(135203,'Claim its essence, Alleria Windrunner. Make its chaos your own.','',0,0,0,0,0,0,0,0,0,0,87833,0,26124),
(135204,'You survived... interesting! How do you feel?','',0,0,0,0,0,0,1,0,0,0,87834,0,26124),
(135205,'','The voices are louder now. More insistent. But they do not control me.',0,0,0,0,0,0,1,0,0,0,0,87556,26124),
(135206,'You asked me to teach you to use the Void as a weapon. Now that weapon is you.','',0,0,0,0,0,0,1,0,0,0,87835,0,26124),
(135207,'','It seems my training is complete.',0,0,0,0,0,0,1,0,0,0,0,87557,26124),
(135208,'Let\'s not get ahead of ourselves. We need to test the limits of this newfound power. Come.','',0,0,0,0,0,0,1,0,0,0,87836,0,26124),
(135210,'Everyone, the time has come to take the central spire. Prepare for battle!','',0,0,0,0,0,0,1,0,0,0,87719,0,26124),
(135211,'Rendezvous in the central courtyard once he has fallen. Good luck.','',0,0,0,0,0,0,0,0,0,0,87720,0,26124),
(135212,'We will advance on the citadel on the ground while you clear the way ahead.','',0,0,0,0,0,0,0,0,0,0,87721,0,26124),
(135213,'Expect heavy resistance. Nath\'raxas will not go down without a fight.','',0,0,0,0,0,0,0,0,0,0,87722,0,26124),
(135214,'Incoming Legion ships! Take cover!','Incoming Legion ships! Take cover!',0,0,0,0,0,0,0,0,0,0,87018,87019,26124),
(135215,'Your anguished cries will be a testament to all who dare assault the Legion.','Your anguished cries will be a testament to all who dare assault the Legion.',0,0,0,0,0,0,0,0,0,0,87162,87163,26124),
(135216,'The enemy has breached the spire gates. To arms!','The enemy has breached the spire gates. To arms!',0,0,0,0,0,0,0,0,0,0,87164,87165,26124),
(135217,'Press the defense. This incursion ends here!','Press the defense. This incursion ends here!',0,0,0,0,0,0,0,0,0,0,87166,87167,26124),
(135218,'','Are you ready to strike?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135219,'We are ready.','We are ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135222,'In spite of everything, we must exercise caution. Ensure safe passage down to the surface, and we can continue the assault.','',0,0,0,0,0,0,0,0,0,0,87693,0,26124),
(135223,'The Legion has assembled a sizable force by those siege cannons. Illidan should already be there, weakening their positions.','',0,0,0,0,0,0,0,0,0,0,87694,0,26124),
(135227,'Lord Nath\'raxas lies in the spire ahead. Take him down!','',0,0,0,0,0,0,0,0,0,0,87723,0,26124),
(135228,'Lend what assistance you can. Alleria is leading the forces there and will be able to direct your efforts.','',0,0,0,0,0,0,0,0,0,0,87695,0,26124),
(135229,'Nothing you have done here matters, mortal. We are infinite. We are Legion.','Nothing you have done here matters, mortal. We are infinite. We are Legion.',0,0,0,0,0,0,0,0,0,0,87168,87169,26124),
(135230,'We must take out those guns if we are to assault the citadel. Your mission is critical, champion.','',0,0,0,0,0,0,0,0,0,0,87696,0,26124),
(135231,'This is it, champion. Now we assault the heart of the Legion itself.','',0,0,0,0,0,0,0,0,0,0,87697,0,26124),
(135232,'The Legion has invaded your world. Now look upon theirs.','',0,0,0,0,0,0,0,0,0,0,87901,0,26124),
(135233,'By the Light... what have they done to my world?','',0,0,0,0,0,0,603,0,0,0,87902,0,26124),
(135234,'These explosives have been modified to amplify fel energies. The results should be quite... dramatic.','',0,0,0,0,0,0,0,0,0,0,87660,0,26124),
(135235,'The beating heart of the Legion... soon I shall tear it out.','',0,0,0,0,0,0,0,0,0,0,87788,0,26124),
(135236,'He thinks I require help? Against the Legion? Very well... try to keep up.','',0,0,0,0,0,0,0,0,0,0,87789,0,26124),
(135237,'Continue the mission while I distract their forces. Perhaps they shall help me prepare for the real challenge...','',0,0,0,0,0,0,0,0,0,0,87790,0,26124),
(135238,'The tiniest crack in the armor, allowing a blade to slip in...','',0,0,0,0,0,0,0,0,0,0,87791,0,26124),
(135239,'At long last, we have turned the tables on the Legion. Let them cower before our invasion!','',0,0,0,0,0,0,0,0,0,0,87792,0,26124),
(135240,'Come, we must brave the darkness.','',0,0,0,0,0,0,0,0,0,0,87900,0,26124),
(135241,'','Hold, Prophet. I have scouted the area. The shadows grip Mac\'Aree more tightly than you know.',0,0,0,0,0,0,0,0,0,0,0,87528,26124),
(135242,'Your hubris overcomes you.','Your hubris overcomes you.',0,0,0,0,0,0,0,0,0,0,87170,87171,26124),
(135243,'It is far worse than I feared. Do we have the strength to face such a foe?','',0,0,0,0,0,0,0,0,0,0,87870,0,26124),
(135244,'','There may be another way. I will require a second set of hands, however.',0,0,0,0,0,0,0,0,0,0,0,87529,26124),
(135246,'Prepare to be deconstructed.','',0,0,0,0,0,0,0,0,0,0,87003,0,26124),
(135247,'Time to work.','',0,0,0,0,0,0,0,0,0,0,87004,0,26124),
(135248,'This was not in the instructions...','',0,0,0,0,0,0,0,0,0,0,87005,0,26124),
(135249,'I\'m a broken... toy...','',0,0,0,0,0,0,0,0,0,0,87006,0,26124),
(135250,'I\'ll use your bones for spare parts.','',0,0,0,0,0,0,0,0,0,0,87007,0,26124),
(135251,'','I am certain it had help. Take a look around. Call for me if you find anything of interest.',0,0,0,0,0,0,0,0,0,0,0,87546,26124),
(135252,'','It is as I thought. The Void\'s corruption has reached them here.',0,0,0,0,0,0,0,0,0,0,0,87545,26124),
(135253,'This weapon\'s test was a resounding success.','',0,0,0,0,0,0,0,0,0,0,86999,0,26124),
(135254,'The day is ours! We await you outside, $p.','',0,0,0,0,0,0,0,0,0,0,87912,0,26124),
(135255,'This hold is but an echo of the grandeur of Antorus.','This hold is but an echo of the grandeur of Antorus.',0,0,0,0,0,0,0,0,0,0,86979,86980,26124),
(135256,'I eagerly await your agonized screams resonating through its halls.','I eagerly await your agonized screams resonating through its halls.',0,0,0,0,0,0,0,0,0,0,87172,87173,26124),
(135257,'You ally yourselves with the traitorous draenei and their Light, yet it leaves you so weak.','You ally yourselves with the traitorous draenei and their Light, yet it leaves you so weak.',0,0,0,0,0,0,0,0,0,0,87174,87175,26124),
(135258,'It matters not. I will end this.','It matters not. I will end this.',0,0,0,0,0,0,0,0,0,0,87158,87159,26124),
(135259,'With my death, he will come...','With my death, he will come...',0,0,0,0,0,0,0,0,0,0,87160,87161,26124),
(135262,'The Paraxis warps in.','The Paraxis warps in.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135266,'Suppression systems engaged.','',0,0,0,0,0,0,0,0,0,0,86970,0,26124),
(135267,'Targets aquired.','',0,0,0,0,0,0,0,0,0,0,86971,0,26124),
(135268,'Power core... rupturing...','',0,0,0,0,0,0,0,0,0,0,86972,0,26124),
(135269,'Termination imminent...','',0,0,0,0,0,0,0,0,0,0,86973,0,26124),
(135270,'Enemy combatants neutralized.','',0,0,0,0,0,0,0,0,0,0,86974,0,26124),
(135271,'No hostile targets remaining. Continuing patrol.','',0,0,0,0,0,0,0,0,0,0,86975,0,26124),
(135273,'Exterminated.','',0,0,0,0,0,0,0,0,0,0,86976,0,26124),
(135274,'Threat terminated.','',0,0,0,0,0,0,0,0,0,0,86977,0,26124),
(135275,'Hostile destroyed.','',0,0,0,0,0,0,0,0,0,0,86978,0,26124),
(135276,'Fall before my blade!','',0,0,0,0,0,0,0,0,0,0,86951,0,26124),
(135277,'For Sargeras!','',0,0,0,0,0,0,0,0,0,0,86952,0,26124),
(135278,'Return to dust.','',0,0,0,0,0,0,0,0,0,0,86953,0,26124),
(135279,'Sargeras will be pleased.','',0,0,0,0,0,0,0,0,0,0,86954,0,26124),
(135280,'All worlds shall fall.','',0,0,0,0,0,0,0,0,0,0,86955,0,26124),
(135282,'','The troops are insisting that I spend some time tending to their wounds. You will have to slay the enemy in my stead.',0,0,0,0,0,0,0,0,0,0,0,87176,26124),
(135283,'','Excellent work. Our soldiers are refreshed, I have done my job, and the enemies are weakened! Everyone benefits.',0,0,0,0,0,0,0,0,0,0,0,87177,26124),
(135284,'','The bats are swarming the battlefield once more. Man one of our batteries and blast them out of the sky!',0,0,0,0,0,0,0,0,0,0,0,87575,26124),
(135285,'','Most of our air support was lost when the Xenedar crashed. Those bats would have caused real trouble for our troops on the ground.',0,0,0,0,0,0,0,0,0,0,0,87576,26124),
(135287,'','You dare set foot in the sacred pools? Suffer!',0,0,0,0,0,0,0,0,0,0,0,87148,26124),
(135288,'Ah, home... I almost missed it.','',0,0,0,0,0,0,0,0,0,0,87184,0,26124),
(135289,'','Do you not see? Without the fel, the shadow will prevail!',0,0,0,0,0,0,0,0,0,0,0,87149,26124),
(135290,'Turn the cannon on Kil\'jaeden\'s ship!','',0,0,0,0,0,0,0,0,4,0,87250,0,26124),
(135291,'','Our crusade is the only path to redemption. All will be reborn by the master\'s flame!',0,0,0,0,0,0,0,0,0,0,0,87150,26124),
(135292,'','You lack... vision.',0,0,0,0,0,0,0,0,0,0,0,87151,26124),
(135293,'','We must all embrace the inevitable abyss.',0,0,0,0,0,0,0,0,0,0,0,87152,26124),
(135294,'','You will not disrupt the rebirth. They will be whole again!',0,0,0,0,0,0,0,0,0,0,0,87145,26124),
(135295,'','All will be remade. All will be undone!',0,0,0,0,0,0,0,0,0,0,0,87146,26124),
(135296,'','You are too late.',0,0,0,0,0,0,0,0,0,0,0,87147,26124),
(135297,'','Logistics and supplies are often forgotten in the heat of battle, but are critical to maintaining our presence here. Collect what you can from the field to strengthen our defenses.',0,0,0,0,0,0,0,0,0,0,0,87641,26124),
(135298,'','Thank you. These crystals can be adapted to power our defenses. They are a valuable resource.',0,0,0,0,0,0,0,0,0,0,0,87642,26124),
(135299,'Eredar summoners are trying to establish new structures down in the Shattered Fields. Disrupt their plans and help our soldiers!','',0,0,0,0,0,0,0,0,0,0,87657,0,26124),
(135300,'Good! That should keep the enemy from sending in more reinforcements.','',0,0,0,0,0,0,0,0,0,0,87656,0,26124),
(135302,'This city was once the greatest of Argus. Look how it has fallen! The once-mighty houses are now mere pawns of the Legion. Soon, they will serve us as well.','',0,0,0,0,0,0,0,0,0,0,87185,0,26124),
(135303,'Break this thing, bend it to our will. If this is beyond you, destroy it.','',0,0,0,0,0,0,0,0,0,0,87186,0,26124),
(135304,'This one has the necessary ambition, but lacks talent.','',0,0,0,0,0,0,0,0,0,0,87187,0,26124),
(135305,'How pathetic this creature is. Watch and learn why your will must always be stronger than the powers you control.','',0,0,0,0,0,0,0,0,0,0,87188,0,26124),
(135306,'She meddles with power she does not understand. One slip and she will lose herself to it.','',0,0,0,0,0,0,0,0,0,0,87189,0,26124),
(135307,'This one has long been a thorn in the Legion\'s side. I never imagined we would become allies.','',0,0,0,0,0,0,0,0,0,0,87190,0,26124),
(135308,'Gaze upon the weapons of the Legion. Soon, they shall be used at my... our... beck and call!','',0,0,0,0,0,0,0,0,0,0,87029,0,26124),
(135309,'The essence of chaos is infused within these weapons. Soon, they shall be lifted in praise to us!','',0,0,0,0,0,0,0,0,0,0,87030,0,26124),
(135310,'He had so much potential. A pity he refused to submit to his betters.','',0,0,0,0,0,0,0,0,0,0,87031,0,26124),
(135311,'The sisters have the right idea, but they lack the power to see their will enforced.','',0,0,0,0,0,0,0,0,0,0,87032,0,26124),
(135312,'The power of this one... it is incredible! Perhaps we can bind it to us instead?','',0,0,0,0,0,0,0,0,0,0,87033,0,26124),
(135313,'Witness the fate of the great makers. Oblivion shall be their destiny.','',0,0,0,0,0,0,0,0,0,0,87034,0,26124),
(135314,'The Diseased energy dissipates, leaving $W13953 more |4zone:zones; to deactivate.','The Diseased energy dissipates, leaving $W13953 more |4zone:zones; to deactivate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135315,'The Fiery energy dissipates, leaving $W13953 more |4zone:zones; to deactivate.','The Fiery energy dissipates, leaving $W13953 more |4zone:zones; to deactivate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135316,'The Fel energy dissipates, leaving $W13953 more |4zone:zones; to deactivate.','The Fel energy dissipates, leaving $W13953 more |4zone:zones; to deactivate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135317,'The Arcane energy dissipates, leaving $W13953 more |4zone:zones; to deactivate.','The Arcane energy dissipates, leaving $W13953 more |4zone:zones; to deactivate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135318,'Weapons, built to destroy forces beyond reckoning. A pity that such power was not funneled into more productive pursuits.','',0,0,0,0,0,0,0,0,0,0,86959,0,26124),
(135319,'The master of these machines conceals their true strength. Be on your guard.','',0,0,0,0,0,0,0,0,0,0,86960,0,26124),
(135320,'The Legion drains the blood of a colossal creature that slumbers beneath the surface. They must be stopped!','',0,0,0,0,0,0,0,0,0,0,88133,0,26124),
(135321,'Stop them! The magic of the titans must not fall into the Legion\'s hands!','',0,0,0,0,0,0,0,0,0,0,86961,0,26124),
(135322,'I never thought I\'d have to slay a titan. This grieves me, but we do what must be done.','',0,0,0,0,0,0,0,0,0,0,86962,0,26124),
(135323,'Without these machines, the Legion will be unable to drain this creature. Now it\'s their turn to bleed.','',0,0,0,0,0,0,0,0,0,0,88134,0,26124),
(135324,'There is power here... power beyond comprehension!','',0,0,0,0,0,0,0,0,0,0,86963,0,26124),
(135325,'You\'ve gotten the attention of the Legion\'s commander. Defeat them, and the remaining demons will flee.','',0,0,0,0,0,0,0,0,0,0,88135,0,26124),
(135326,'So what Magni saw was true. Aggramar lives once more... in the service of Sargeras.','',0,0,0,0,0,0,1,0,0,0,87691,0,26124),
(135327,'Well done, heroes. You\'ve driven the Legion from this world.','',0,0,0,0,0,0,0,0,0,0,88136,0,26124),
(135329,'','The power at their command is immeasurable. The Vindicaar cannot withstand their assault.',0,0,0,0,0,0,6,0,0,0,0,86958,26124),
(135389,'I am told power comes from unlikely places.','',0,0,0,0,0,0,0,0,0,0,87977,0,26124),
(135390,'The Legion\'s thirst for blood is unquenchable. Remove their filth from this world.','',0,0,0,0,0,0,0,0,0,0,88137,0,26124),
(135391,'These demons seek to bleed a creature that lies dormant beneath the surface. Put an end to their plans.','',0,0,0,0,0,0,0,0,0,0,88138,0,26124),
(135392,'Your efforts thus far are... lacking.','',0,0,0,0,0,0,0,0,0,0,88097,0,26124),
(135393,'Continue like this and you may well scrape by.','',0,0,0,0,0,0,0,0,0,0,87757,0,26124),
(135394,'Your arrogance will be your undoing.','',0,0,0,0,0,0,0,0,0,0,87178,0,26124),
(135395,'I am unimpressed.','',0,0,0,0,0,0,0,0,0,0,87179,0,26124),
(135396,'','Bear in mind that your performance reflects upon all of us.',0,0,0,0,0,0,0,0,0,0,0,87568,26124),
(135397,'','You could stand to do better.',0,0,0,0,0,0,0,0,0,0,0,87569,26124),
(135398,'Ah, yes. It has been too long since I have humbled a pupil. Come. Face me.','',0,0,0,0,0,0,0,0,0,0,87573,0,26124),
(135401,'Krona ki cristorr!','Krona ki cristorr!',0,0,0,0,0,0,0,0,0,0,87070,87071,26124),
(135402,'I serve the Light.','I serve the Light.',0,0,0,0,0,0,0,0,0,0,87068,87069,26124),
(135403,'Greetings, traveler.','Greetings, traveler.',0,0,0,0,0,0,0,0,0,0,87066,87067,26124),
(135404,'I will return to the Vindicaar. There I will determine the location of the Crest of Knowledge. Be safe, my friend.','',0,0,0,0,0,0,1,0,0,0,87871,0,26124),
(135406,'In darkest night, we still shine with hope.','In darkest night, we still shine with hope.',0,0,0,0,0,0,0,0,0,0,87064,87065,26124),
(135407,'Pheta voros.','Pheta voros.',0,0,0,0,0,0,0,0,0,0,87062,87063,26124),
(135408,'Our cause is just. Our purpose, noble.','Our cause is just. Our purpose, noble.',0,0,0,0,0,0,0,0,0,0,87060,87061,26124),
(135409,'Light be with you.','Light be with you.',0,0,0,0,0,0,0,0,0,0,87058,87059,26124),
(135410,'Have faith in the Light.','Have faith in the Light.',0,0,0,0,0,0,0,0,0,0,87056,87057,26124),
(135411,'Acore palemos corta.','Acore palemos corta.',0,0,0,0,0,0,0,0,0,0,87054,87055,26124),
(135412,'Fight well, traveler.','Fight well, traveler.',0,0,0,0,0,0,0,0,0,0,87052,87053,26124),
(135413,'We shall see the Legion\'s end.','We shall see the Legion\'s end.',0,0,0,0,0,0,0,0,0,0,87050,87051,26124),
(135414,'Dioniss aca.','Dioniss aca.',0,0,0,0,0,0,0,0,0,0,87072,87073,26124),
(135415,'','Dioniss aca.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135416,'','We shall see the Legion\'s end.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135417,'','Fight well, traveler.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135418,'','Acore palemos corta.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135419,'','Have faith in the Light.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135420,'','Light be with you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135421,'','Our cause is just. Our purpose, noble.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135422,'Please, you have to reach our captain! She\'s across the way to the west, defending our last remaining artillery batteries!','Please, you have to reach our captain! She\'s across the way to the west, defending our last remaining artillery batteries!',0,0,0,0,0,0,603,0,0,0,87819,87820,26124),
(135423,'','In darkest night, we still shine with hope.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135424,'','Greetings, traveler.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135425,'','I serve the Light.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135426,'','Krona ki cristorr!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135427,'The titan soul of Argus is the key to breaking the Legion. Our defenses must hold long enough to destroy it... or Sargeras wins.','',0,0,0,0,0,0,1,0,0,0,88154,0,26124),
(135428,'Perhaps this world\'s past can aid us. I will scour my memory for what may yet remain.','',0,0,0,0,0,0,1,0,0,0,87906,0,26124),
(135433,'The Legion must learn that no matter the realm, we will always defeat them.','',0,0,0,0,0,0,0,0,0,0,88139,0,26124),
(135434,'Another victory, heroes. These demons are running out of places to hide.','',0,0,0,0,0,0,0,0,0,0,88140,0,26124),
(135435,'Well done, champions. News of this victory will spread throughout the Dark Beyond.','',0,0,0,0,0,0,0,0,0,0,88141,0,26124),
(135436,'With every victory we weaken the Legion\'s grip on these worlds.','',0,0,0,0,0,0,0,0,0,0,88142,0,26124),
(135437,'You\'ve crushed their ranks. These demons surely realize they are not the greatest power in the cosmos.','',0,0,0,0,0,0,0,0,0,0,88143,0,26124),
(135438,'Well fought, champions. No matter where their filth spreads, we will be there to stop them.','',0,0,0,0,0,0,0,0,0,0,88144,0,26124),
(135447,'You\'ve driven them back! Now press the attack!','',0,0,0,0,0,0,0,0,0,0,88145,0,26124),
(135449,'The Legion is reeling from your onslaught. Cut them down!','',0,0,0,0,0,0,0,0,0,0,88146,0,26124),
(135450,'Now is your chance. Finish this fight!','',0,0,0,0,0,0,0,0,0,0,88147,0,26124),
(135451,'These fools should\'ve run when they had the chance. Leave none standing.','',0,0,0,0,0,0,0,0,0,0,88148,0,26124),
(135452,'These demons are stripping the forests of their resources. This cannot be allowed to continue.','',0,0,0,0,0,0,0,0,0,0,87770,0,26124),
(135453,'The Legion has laid claim to these forests. Drive them out.','',0,0,0,0,0,0,0,0,0,0,87771,0,26124),
(135454,'The Legion seeks to control this forest. Crush them.','',0,0,0,0,0,0,0,0,0,0,87772,0,26124),
(135458,'These frozen wastes conceal hidden power. Wrest it from the Legion\'s control.','',0,0,0,0,0,0,0,0,0,0,87773,0,26124),
(135459,'This frozen world holds dangerous power. Ensure the Legion cannot claim it.','',0,0,0,0,0,0,0,0,0,0,87774,0,26124),
(135460,'This frozen world  has claimed the bones of many who came here seeking power. Ensure these demons are added to the collection.','',0,0,0,0,0,0,0,0,0,0,87775,0,26124),
(135461,'The Legion seeks to control this island. Put an end to their efforts.','',0,0,0,0,0,0,0,0,0,0,87776,0,26124),
(135462,'The Legion wants to claim these islands. Drive them out.','',0,0,0,0,0,0,0,0,0,0,87777,0,26124),
(135463,'The Legion believes these islands are under their control. Teach this filth there is nothing we cannot take from them.','',0,0,0,0,0,0,0,0,0,0,87778,0,26124),
(135467,'These burning sands conceal wells of power. Ensure the Legion cannot claim them.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135468,'These sands conceal a font of limitless power. Wrest it from the Legion\'s control.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135470,'These sands have claimed the bones of many who came here seeking power. Ensure these demons are added to the collection.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135473,'Fareeya. Status report.','',0,0,0,0,0,0,0,0,0,0,87699,0,26124),
(135474,'','Baraat sent up a signal flare a short time ago. He is alive, at least. I have heard nothing from the others.',0,0,0,0,0,0,0,0,0,0,0,87644,26124),
(135475,'Then let us waste no time.','',0,0,0,0,0,0,0,0,0,0,87700,0,26124),
(135476,'','Bring back my men, Turalyon.',0,0,0,0,0,0,0,0,0,53064,0,87643,26124),
(135477,'The Light rejects you, demon!','',0,0,0,0,0,0,0,0,0,0,87701,0,26124),
(135478,'This day will be your last!','',0,0,0,0,0,0,0,0,0,0,87702,0,26124),
(135479,'You cannot stand against the Light!','',0,0,0,0,0,0,0,0,0,0,87703,0,26124),
(135480,'I am the Light\'s blade!','',0,0,0,0,0,0,0,0,0,0,87704,0,26124),
(135481,'The Light strikes you down!','',0,0,0,0,0,0,0,0,0,0,87705,0,26124),
(135482,'Fall before me!','',0,0,0,0,0,0,0,0,0,0,87706,0,26124),
(135483,'You will not bar my way.','',0,0,0,0,0,0,0,0,0,0,87707,0,26124),
(135484,'Taste my blade, demon filth!','',0,0,0,0,0,0,0,0,0,0,87708,0,26124),
(135485,'The Light prevails.','',0,0,0,0,0,0,0,0,0,0,87709,0,26124),
(135487,'One less foe to contend with.','',0,0,0,0,0,0,0,0,0,0,87710,0,26124),
(135488,'On to the next.','',0,0,0,0,0,0,0,0,0,0,87711,0,26124),
(135489,'They have not yet had a chance to fortify this area.','',0,0,0,0,0,0,0,0,0,0,87712,0,26124),
(135490,'It seems they haven\'t located Velen... and not for lack of trying.','',0,0,0,0,0,0,0,0,0,0,87713,0,26124),
(135491,'There\'s Baraat.','',0,0,0,0,0,0,0,0,0,0,87724,0,26124),
(135493,'I sense an ally nearby.','',0,0,0,0,0,0,0,0,0,0,87725,0,26124),
(135494,'Telaamon must be nearby. Just follow the trail of corpses.','',0,0,0,0,0,0,0,0,0,0,87726,0,26124),
(135495,'This is it.','',0,0,0,0,0,0,0,0,0,0,87727,0,26124),
(135497,'I have seen these tactics before. Let us hope our foe is not who I think it is.','',0,0,0,0,0,0,0,0,0,0,87728,0,26124),
(135498,'The Legion seeks to claim the power of this burning world. They must not succeed.','',0,0,0,0,0,0,0,0,0,0,87782,0,26124),
(135499,'If the Legion harnesses the power of this realm, they will be unstoppable. Drive them out.','',0,0,0,0,0,0,0,0,0,0,87783,0,26124),
(135500,'The power lying dormant on this world could bolster the Legion\'s strength. Reduce these demons to ash before they can claim it.','',0,0,0,0,0,0,0,0,0,0,87784,0,26124),
(135501,'The Legion believes they control this world. Prove to them that they do not.','',0,0,0,0,0,0,0,0,0,0,87785,0,26124),
(135502,'This world holds a power that the Legion must not possess. Prevent them from claiming it.','',0,0,0,0,0,0,0,0,0,0,87786,0,26124),
(135503,'The Legion seeks to claim this world for their own. Break their grip.','',0,0,0,0,0,0,0,0,0,0,87787,0,26124),
(135504,'Talgath. We need not come to blows. I offer you one chance: Stand down.','',0,0,0,0,0,0,0,0,0,0,87917,0,26124),
(135505,'Still the pacifist, I see. Face me!','',0,0,0,0,0,0,0,0,0,0,87961,0,26124),
(135506,'Impossible. She is a naaru! A being of the Light!','',0,0,0,0,0,0,0,0,0,0,87729,0,26124),
(135507,'There is much Xe\'ra did not want you to know.','',0,0,0,0,0,0,0,0,0,0,87918,0,26124),
(135508,'If the Crest of Knowledge truly rests within the temple... we stand against the Void itself.','',0,0,0,0,0,0,0,0,0,0,87919,0,26124),
(135509,'Light help us.','',0,0,0,0,0,0,0,0,0,0,87730,0,26124),
(135510,'It\'s fainter than the breath o\' the wind, but it feels so familiar ta me. It\'s like Azeroth\'s call, only... it ain\'t her.','',0,0,0,0,0,0,1,0,0,0,88123,0,26124),
(135512,'','Look out!',0,0,0,0,0,0,0,0,0,0,0,87492,26124),
(135513,'','Over here!',0,0,0,0,0,0,0,0,0,0,0,87490,26124),
(135514,'','No!',0,0,0,0,0,0,0,0,0,0,0,87489,26124),
(135515,'By the Light... No!','',0,0,0,0,0,0,0,0,0,0,87698,0,26124),
(135516,'Over here!','',0,0,0,0,0,0,0,0,0,0,87731,0,26124),
(135517,'Look out!','',0,0,0,0,0,0,0,0,0,0,87732,0,26124),
(135518,'By the Light... No!','',0,0,0,0,0,0,0,0,0,0,87920,0,26124),
(135519,'Over here!','',0,0,0,0,0,0,0,0,0,0,87921,0,26124),
(135520,'Look out!','',0,0,0,0,0,0,0,0,0,0,87922,0,26124),
(135521,'','This way!',0,0,0,0,0,0,0,0,0,0,0,87491,26124),
(135522,'This way!','',0,0,0,0,0,0,0,0,0,0,87733,0,26124),
(135523,'This way!','',0,0,0,0,0,0,0,0,0,0,87923,0,26124),
(135524,'','Incoming!',0,0,0,0,0,0,0,0,0,0,0,87493,26124),
(135525,'Incoming!','',0,0,0,0,0,0,0,0,0,0,87692,0,26124),
(135526,'Stand ready!','',0,0,0,0,0,0,0,0,0,0,87897,0,26124),
(135527,'I hear you. Speak.','',0,0,0,0,0,0,0,0,0,0,87348,0,26124),
(135528,'We fight. We survive.','',0,0,0,0,0,0,0,0,0,0,87349,0,26124),
(135529,'The Darkfallen will not give up.','',0,0,0,0,0,0,0,0,0,0,87350,0,26124),
(135530,'Argus will always be ours.','',0,0,0,0,0,0,0,0,0,0,87351,0,26124),
(135531,'Beware the Legion\'s wrath.','',0,0,0,0,0,0,0,0,0,0,87352,0,26124),
(135532,'Walk in the shadows of the earth.','',0,0,0,0,0,0,0,0,0,0,87353,0,26124),
(135533,'We will never give up.','',0,0,0,0,0,0,0,0,0,0,87354,0,26124),
(135534,'Our time has come.','',0,0,0,0,0,0,0,0,0,0,87355,0,26124),
(135535,'Yes, outsider?','',0,0,0,0,0,0,0,0,0,0,87631,0,26124),
(135536,'What is it?','',0,0,0,0,0,0,0,0,0,0,87632,0,26124),
(135537,'I greet you.','',0,0,0,0,0,0,0,0,0,0,87633,0,26124),
(135538,'We will not fall.','',0,0,0,0,0,0,0,0,0,0,87634,0,26124),
(135540,'Take caution.','',0,0,0,0,0,0,0,0,0,0,87635,0,26124),
(135541,'Farewell.','',0,0,0,0,0,0,0,0,0,0,87636,0,26124),
(135542,'The Legion will pay.','',0,0,0,0,0,0,0,0,0,0,87637,0,26124),
(135543,'We will endure.','',0,0,0,0,0,0,0,0,0,0,87638,0,26124),
(135544,'Legion forces swarm this area. Drive them out and strike a blow for the Light!','',0,0,0,0,0,0,0,0,0,0,87262,0,26124),
(135545,'We need to force the demons back before we\'re overrun. To arms!','',0,0,0,0,0,0,0,0,0,0,87263,0,26124),
(135546,'The Legion considers this location unassailable. I say we prove them wrong!','',0,0,0,0,0,0,0,0,0,0,87264,0,26124),
(135547,'Supplies from the Xenedar have fallen into Legion hands. Take back what is ours, champion!','',0,0,0,0,0,0,0,0,0,0,87265,0,26124),
(135548,'The Army of the Light has need of you, hero. I know we can rely on you to get the job done.','',0,0,0,0,0,0,0,0,0,0,87266,0,26124),
(135549,'Some of our troops have been captured by Legion forces. The demons will torture them... or worse. You must lead a rescue!','',0,0,0,0,0,0,0,0,0,0,87267,0,26124),
(135550,'A crucial target lies ahead. Strike it down in the name of the Light!','',0,0,0,0,0,0,0,0,0,0,87268,0,26124),
(135551,'I sense a great darkness is near. Be on your guard!','',0,0,0,0,0,0,0,0,0,0,87269,0,26124),
(135552,'The demons rally behind one of their champions. Bring it down!','',0,0,0,0,0,0,0,0,0,0,87270,0,26124),
(135553,'Up ahead... a great evil prepares to strike. Stand ready!','',0,0,0,0,0,0,0,0,0,0,87271,0,26124),
(135554,'Argus provides us no shortage of targets. Another is at hand, champion.','',0,0,0,0,0,0,0,0,0,0,87272,0,26124),
(135556,'A demon lurks just ahead. Bring it down in the name of Azeroth!','',0,0,0,0,0,0,0,0,0,0,87273,0,26124),
(135557,'My scouts have spotted a prime target. To arms!','',0,0,0,0,0,0,0,0,0,0,87274,0,26124),
(135558,'The Legion believes this brute can intimidate us. Prove them wrong!','',0,0,0,0,0,0,0,0,0,0,87275,0,26124),
(135559,'When they push us, we push back harder. To victory!','',0,0,0,0,0,0,0,0,0,0,87276,0,26124),
(135560,'Thanks to your help, our forces have rallied and the Legion is on the run.','',0,0,0,0,0,0,0,0,0,0,87277,0,26124),
(135561,'Now the Burning Legion sees the truth... that we will drive them from the heart of Argus!','',0,0,0,0,0,0,0,0,0,0,87278,0,26124),
(135562,'That cargo belongs to the Army of the Light, not the minions of Sargeras. Well done.','',0,0,0,0,0,0,0,0,0,0,87279,0,26124),
(135563,'My faith was well placed. You have aided the Light this day, friend.','',0,0,0,0,0,0,0,0,0,0,87280,0,26124),
(135564,'Thanks to your quick and decisive action, the Army\'s soldiers are safe. You have my gratitude.','',0,0,0,0,0,0,0,0,0,0,87281,0,26124),
(135566,'Well fought. In our long struggle against the demons, we must savor every victory.','',0,0,0,0,0,0,0,0,0,0,87282,0,26124),
(135567,'A well-earned victory. The Legion will fall!','',0,0,0,0,0,0,0,0,0,0,87283,0,26124),
(135568,'Bit by bit we chip away at the backbone of the Legion.','',0,0,0,0,0,0,0,0,0,0,87284,0,26124),
(135569,'You fight like you\'ve been crusading against the Legion for a thousand years.','',0,0,0,0,0,0,0,0,0,0,87285,0,26124),
(135570,'It is good to know that during my long absence from Azeroth, our world was protected by heroes like you.','',0,0,0,0,0,0,0,0,0,0,87286,0,26124),
(135571,'Impressive tactics. No wonder the Legion has learned to fear you.','',0,0,0,0,0,0,0,0,0,0,87287,0,26124),
(135572,'The Army of the Light is proud to call you an ally, champion.','',0,0,0,0,0,0,0,0,0,0,87288,0,26124),
(135573,'Every victory is satisfying, but when a foe like that is brought down... I must admit, I savor it even more.','',0,0,0,0,0,0,0,0,0,0,87289,0,26124),
(135575,'What was once a sacred site for my people has been desecrated by the Legion. Drive them out!','',0,0,0,0,0,0,0,0,0,0,87291,0,26124),
(135580,'The Legion\'s grip on this land must be broken. Now is our time! Push back against the darkness!','',0,0,0,0,0,0,0,0,0,0,87292,0,26124),
(135581,'An insidious champion of darkness draws near. Strike it down!','',0,0,0,0,0,0,0,0,0,0,87293,0,26124),
(135582,'This villain profanes the homeworld I lost so long ago. Put an end to this atrocity!','',0,0,0,0,0,0,0,0,0,0,87294,0,26124),
(135583,'Prepare yourself, champion. Wickedness lurks nearby...','',0,0,0,0,0,0,0,0,0,0,87295,0,26124),
(135584,'An agent of the Dark Titan rises to attack. Strike first! Strike true!','',0,0,0,0,0,0,0,0,0,0,87296,0,26124),
(135585,'Just when the Light gains a foothold here, another vessel of evil rises to battle us. Your might is needed once again, champion.','',0,0,0,0,0,0,0,0,0,0,87297,0,26124),
(135587,'A disciple of Kil\'jaeden seeks to avenge its master. Be ready for its assault!','',0,0,0,0,0,0,0,0,0,0,87298,0,26124),
(135588,'I sense a foul presence... an evil that seeks to blot out the Light. Take up arms and bring down this foe!','',0,0,0,0,0,0,0,0,0,0,87299,0,26124),
(135589,'The air hangs heavy with fel corruption. Bring down this vile aberration!','',0,0,0,0,0,0,0,0,0,0,87300,0,26124),
(135590,'We can never reclaim what we once had, but we will make them pay for what they did to Argus.','',0,0,0,0,0,0,0,0,0,0,87301,0,26124),
(135591,'We may be vastly outnumbered, but the Light is with us. Victory will yet be ours!','',0,0,0,0,0,0,0,0,0,0,87302,0,26124),
(135592,'Never doubt that, in the end, the Light will emerge victorious.','',0,0,0,0,0,0,0,0,0,0,87303,0,26124),
(135593,'In the name of all the noble souls lost here to the Legion, I thank you.','',0,0,0,0,0,0,0,0,0,0,87304,0,26124),
(135594,'With every such foe you bring down, our ultimate victory draws nearer.','',0,0,0,0,0,0,0,0,0,0,87305,0,26124),
(135595,'Sargeras took so much from my world. Now it is his turn to lose!','',0,0,0,0,0,0,0,0,0,0,87306,0,26124),
(135596,'Though the Legion is relentless, the demons cannot outlast the Light.','',0,0,0,0,0,0,0,0,0,0,87307,0,26124),
(135597,'Word of your victory will spread across Argus. Those who cling to the memory of the Deceiver are doomed to fall!','',0,0,0,0,0,0,0,0,0,0,87308,0,26124),
(135598,'The Light cannot win unless we fight for it. You have done your part this day, champion.','',0,0,0,0,0,0,0,0,0,0,87309,0,26124),
(135599,'Every demon that walks this world is a perversion of the Argus that was. You struck a blow for the Light this day.','',0,0,0,0,0,0,0,0,0,0,87310,0,26124),
(135600,'Demon filth pervades this broken land. Take no prisoners. Strike down every fiend you see!','',0,0,0,0,0,0,0,0,0,0,87316,0,26124),
(135601,'Demons everywhere. Go. Fight. Spare none of them.','',0,0,0,0,0,0,0,0,0,0,87317,0,26124),
(135602,'The Legion believes itself entrenched on Argus. Untouchable. Reward their arrogance with suffering!','',0,0,0,0,0,0,0,0,0,0,87318,0,26124),
(135603,'Another champion of the Legion is near. End its existence.','',0,0,0,0,0,0,0,0,0,0,87319,0,26124),
(135605,'A brutish fiend looms just ahead. Send it back to the hell that spawned it.','',0,0,0,0,0,0,0,0,0,0,87320,0,26124),
(135606,'The demons rally around a brutish menace. Teach them that their faith is misplaced.','',0,0,0,0,0,0,0,0,0,0,87321,0,26124),
(135607,'Another demon champion boasts and blusters. Silence its cacophony.','',0,0,0,0,0,0,0,0,0,0,87322,0,26124),
(135608,'Be on your guard. A threat looms, thirsty for mortal blood.','',0,0,0,0,0,0,0,0,0,0,87323,0,26124),
(135609,'This demon looks to rise within the Legion\'s ranks by ending our invasion. Demonstrate its folly.','',0,0,0,0,0,0,0,0,0,0,87324,0,26124),
(135611,'Behold, a vile menace eager to prove its might. Put an end to its ambitions.','',0,0,0,0,0,0,0,0,0,0,87325,0,26124),
(135612,'So many draenei traditions were lost during our long journey. The spirits of Mac\'Aree have not forgotten. They practice the ritual combat of Jed\'hin even now. Perhaps they will welcome a new challenger!','',0,0,0,0,0,0,0,0,0,0,87658,0,26124),
(135613,'It brings me great joy to see the old ways honored like this. Thank you.','',0,0,0,0,0,0,0,0,0,0,87659,0,26124),
(135614,'My people, I have called you here to share a revelation.','',0,0,0,0,0,0,1,0,0,0,87810,0,26124),
(135615,'For so long, we eredar have been alone in the universe.','',0,0,0,0,0,0,1,0,0,0,87811,0,26124),
(135616,'We need not endure this solitude any longer.','',0,0,0,0,0,0,1,0,0,0,87812,0,26124),
(135617,'He has shown us the path to a new future.','',0,0,0,0,0,0,1,0,0,0,87813,0,26124),
(135618,'In partnership with our new ally, the light of the eredar will shine bright across the cosmos!','',0,0,0,0,0,0,603,0,0,0,87814,0,26124),
(135619,'I ask you, now, to raise your voices in praise. Praise Sargeras!','',0,0,0,0,0,0,1,0,0,0,87815,0,26124),
(135620,'The beacon of our civilization shining bright... upon what we feared was an empty void.','',0,0,0,0,0,0,1,0,0,0,87816,0,26124),
(135621,'The Triumvirate has received a visitor from another world!','',0,0,0,0,0,0,603,0,0,0,87817,0,26124),
(135622,'He offers us power unlike any we have known before.','',0,0,0,0,0,0,1,0,0,0,87818,0,26124),
(135623,'A threat closes in. Bring it down, and show the demons they cannot stand against us.','',0,0,0,0,0,0,0,0,0,0,87326,0,26124),
(135624,'I will lead my people through any darkness.','',0,0,0,0,0,0,0,0,0,0,87356,0,26124),
(135625,'Our enemies will suffer as we have.','',0,0,0,0,0,0,0,0,0,0,87357,0,26124),
(135626,'Yes... you have them reeling. Well fought.','',0,0,0,0,0,0,0,0,0,0,87327,0,26124),
(135627,'These foes have earned no mercy... and we have shown them none.','',0,0,0,0,0,0,0,0,0,0,87328,0,26124),
(135628,'Now they know the truth... that we will never relent. Their crusade will soon face oblivion.','',0,0,0,0,0,0,0,0,0,0,87329,0,26124),
(135629,'Each target we bring down is another failure for the Dark Titan\'s crusade.','',0,0,0,0,0,0,0,0,0,0,87330,0,26124),
(135630,'No matter how many monstrosities they send at us, we will cut them down.','',0,0,0,0,0,0,0,0,0,0,87331,0,26124),
(135631,'The Legion\'s morale crumbles... as does their hold on Argus.','',0,0,0,0,0,0,0,0,0,0,87332,0,26124),
(135632,'That one has nothing more to brag about, other than the quick death it earned.','',0,0,0,0,0,0,0,0,0,0,87333,0,26124),
(135633,'A decisive victory. I expected no less of you.','',0,0,0,0,0,0,0,0,0,0,87334,0,26124),
(135634,'You brought a quick end to that fiend\'s ambitions. But do not doubt that others will seek a similar path to infamy.','',0,0,0,0,0,0,0,0,0,0,87335,0,26124),
(135635,'The demon\'s cries of failure ring out across Argus. A sound that never grows tiresome.','',0,0,0,0,0,0,0,0,0,0,87336,0,26124),
(135636,'A convincing victory. You have demonstrated the futility of the Legion\'s existence.','',0,0,0,0,0,0,0,0,0,0,87337,0,26124),
(135637,'The Vindicaar will be the instrument of our retribution. As with any weapon, you should know it well before we charge into battle once more.','',0,0,0,0,0,0,1,0,0,0,87958,0,26124),
(135639,'Argus is a world saturated with power. The Legion has made use of it... now it is our turn!','',0,0,0,0,0,0,0,0,0,0,87338,0,26124),
(135640,'I sense an entity that wields potent forces with great malevolence. This fiend must be brought down!','',0,0,0,0,0,0,0,0,0,0,87339,0,26124),
(135641,'Power is power. It is what we do with it that matters. By using the Legion\'s own resources against them, we turn the tide in our favor.','',0,0,0,0,0,0,0,0,0,0,87340,0,26124),
(135642,'A worthy victory. No minion of the Legion can be allowed to toy with such forces.','',0,0,0,0,0,0,0,0,0,0,87341,0,26124),
(135643,'I have never seen anything like this place, Khadgar. The powers at play here...','',0,0,0,0,0,0,1,0,0,0,87342,0,26124),
(135644,'I know, archmage. It can be... overwhelming at times. Difficult to focus.','',0,0,0,0,0,0,1,0,0,0,87343,0,26124),
(135645,'I confess I am relieved to hear you say that. I feared I was the only one experiencing such sensations.','',0,0,0,0,0,0,1,0,0,0,87344,0,26124),
(135646,'We can still breach Antorus and dismantle the Legion\'s resurrection engine, but we\'ll need Xe\'ra and the Army of the Light by our side.','',0,0,0,0,0,0,1,0,0,0,87756,0,26124),
(135647,'Nonsense. We are in the presence of primal powers that shaped the very cosmos. The fact that you feel the tug of their influence is not a sign of weakness. It shows that you are highly attuned to them.','',0,0,0,0,0,0,1,0,0,0,87345,0,26124),
(135648,'Then I shall relish the experience while I have it. Thank you for your counsel, Khadgar.','',0,0,0,0,0,0,1,0,0,0,87346,0,26124),
(135653,'Evil draws close.','',0,0,0,0,0,0,0,0,0,0,88010,0,26124),
(135654,'There is no sacrifice too great.','',0,0,0,0,0,0,0,0,0,0,88011,0,26124),
(135655,'The Legion will stop at nothing to destroy our world.','',0,0,0,0,0,0,0,0,0,0,88012,0,26124),
(135656,'The hour has come at last.','',0,0,0,0,0,0,0,0,0,0,88013,0,26124),
(135657,'A timely arrival.','',0,0,0,0,0,0,0,0,0,0,88014,0,26124),
(135658,'Do not sit idle.','',0,0,0,0,0,0,0,0,0,0,88015,0,26124),
(135659,'The Legion\'s fury pales before mine.','',0,0,0,0,0,0,0,0,0,0,88016,0,26124),
(135660,'I will finish my hunt.','',0,0,0,0,0,0,0,0,0,0,88017,0,26124),
(135661,'I will see this to the end.','',0,0,0,0,0,0,0,0,0,0,88018,0,26124),
(135662,'See it done.','',0,0,0,0,0,0,0,0,0,0,88019,0,26124),
(135663,'The Legion will meet its end.','',0,0,0,0,0,0,0,0,0,0,88020,0,26124),
(135664,'My hunt is eternal.','',0,0,0,0,0,0,0,0,0,0,88021,0,26124),
(135665,'IGC: Velen escapes Argus','IGC: Velen escapes Argus',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135666,'Your persistence is hardly surprising.','',0,0,0,0,0,0,0,0,0,0,88022,0,26124),
(135667,'You are not prepared.','',0,0,0,0,0,0,0,0,0,0,88023,0,26124),
(135668,'I will not be touched by rabble such as you.','',0,0,0,0,0,0,0,0,0,0,88024,0,26124),
(135669,'YOU ARE NOT PRE-- <pause> What\'s that? Am I denying you something? Bah. You know nothing of true longing.','',0,0,0,0,0,0,0,0,0,0,88025,0,26124),
(135671,'The fate of our world hangs in the balance.','',0,0,0,0,0,0,0,0,0,0,87574,0,26124),
(135672,'The Light\'s army endures.','',0,0,0,0,0,0,0,0,0,0,87865,0,26124),
(135675,'My people have so little, yet the demons steal our relics in hopes of cutting us off from our past. Help take back what is ours, outsider.','',0,0,0,0,0,0,0,0,0,0,87358,0,26124),
(135676,'More of my people have been taken by the Legion. They seek to break our bonds of kinship, to turn brother against brother. Please, free them!','',0,0,0,0,0,0,0,0,0,0,87359,0,26124),
(135677,'Though we can never thrive here as we once did, Argus is our home. You have eased our struggle, outsider, at least for today.','',0,0,0,0,0,0,0,0,0,0,87360,0,26124),
(135678,'The Legion will not break our spirits. By recovering these mementos of our past, you have given my people faith that we can endure this. I am grateful.','',0,0,0,0,0,0,0,0,0,0,87361,0,26124),
(135681,'','Sometimes subtlety is more effective than a direct assault. I believe such a strategy is needed here.',0,0,0,0,0,0,0,0,0,0,0,87362,26124),
(135682,'','We have a target in this area that must be brought down. The choice of weapon is up to you.',0,0,0,0,0,0,0,0,0,0,0,87363,26124),
(135684,'','To cripple the Legion\'s offensive, we need to take out their infrastructure. Strike a blow for Azeroth!',0,0,0,0,0,0,0,0,0,0,0,87364,26124),
(135685,'','There is more than one way to deliver a blow to the Legion. Well done!',0,0,0,0,0,0,0,0,0,0,0,87365,26124),
(135686,'','With results like that, I am confident our victory will come.',0,0,0,0,0,0,0,0,0,0,0,87366,26124),
(135687,'','Nicely done. That will have the demons reeling!',0,0,0,0,0,0,0,0,0,0,0,87367,26124),
(135688,'That should be it! Just activate the console one last time to complete the transfer. I will handle the rest!','',0,0,0,0,0,0,0,0,0,0,87672,0,26124),
(135689,'It was merciful to free these creatures from the grip of shadows. It saddens me to see the city like this.','',0,0,0,0,0,0,0,0,0,0,87959,0,26124),
(135690,'The younger animals in the city are particularly susceptible to void energy. Use this crystal to release them from its grasp.','',0,0,0,0,0,0,0,0,0,0,87960,0,26124),
(135691,'','We have devised a plan to strike against the Legion. This is an operation that calls for your special skills, champion.',0,0,0,0,0,0,0,0,0,0,0,87387,26124),
(135692,'','I have hunted demons throughout the Twisting Nether for a thousand years. I think I can leave this one to you.',0,0,0,0,0,0,0,0,0,0,0,87388,26124),
(135693,'A demon dares lead a vanguard on the Vindicaar. Its death will send a powerful message to the enemy.','',0,0,0,0,0,0,0,0,0,0,87745,0,26124),
(135695,'The Legion is relentless in its assault. We must remain ever vigilant.','',0,0,0,0,0,0,0,0,0,0,87746,0,26124),
(135696,'A doommaiden attempts to fashion an army of fiends right under our noses. She must not succeed.','',0,0,0,0,0,0,0,0,0,0,87735,0,26124),
(135697,'Her soul will return to Antorus to be reborn, but not without punishment. Sargeras does not take kindly to failure.','',0,0,0,0,0,0,0,0,0,0,87736,0,26124),
(135698,'A dreadlord that once served me in the Black Temple has cast his lot with the Legion. He will regret opposing me.','',0,0,0,0,0,0,0,0,0,0,88150,0,26124),
(135700,'First Maiev\'s blade, now yours. His punishment in Antorus will be severe.','',0,0,0,0,0,0,0,0,0,0,88151,0,26124),
(135702,'I will meet you at our staging ground near Nath\'raxas. The Vindicaar must be ready to help us secure the hold at a moment\'s notice.','',0,0,0,0,0,0,1,0,0,0,87737,0,26124),
(135703,'Taking this hold will buy us valuable time to prepare for a full assault on Antorus.','',0,0,0,0,0,0,1,0,0,0,87738,0,26124),
(135704,'None deserve the fate that awaits souls claimed by the Legion.','',0,0,0,0,0,0,0,0,0,0,87926,0,26124),
(135705,'Thank you, $n. May their souls finally find peace.','',0,0,0,0,0,0,0,0,0,0,87927,0,26124),
(135706,'High Exarch, our warframe is fully operational. Behold!','',0,0,0,0,0,0,113,0,0,0,87663,0,26124),
(135707,'','This beast of darkness must be put down. No need for mercy, but do be swift.',0,0,0,0,0,0,0,0,0,0,0,87389,26124),
(135708,'','Light and shadow are both means to an end. For the foe before you, feel free to pick whatever weapon you favor.',0,0,0,0,0,0,0,0,0,0,0,87390,26124),
(135709,'','Most effective. Every blow dealt to the Legion is a boon to our cause.',0,0,0,0,0,0,0,0,0,0,0,87391,26124),
(135710,'','Impressive skill. Though I believe my arrows would have brought that demon to an even quicker end.',0,0,0,0,0,0,0,0,0,0,0,87392,26124),
(135711,'','A necessary end for such an enemy. Well done.',0,0,0,0,0,0,0,0,0,0,0,87393,26124),
(135712,'','It seems you have chosen your weapon. As have I.',0,0,0,0,0,0,0,0,0,0,0,87394,26124),
(135713,'We will be upon the courtyard shortly to finish them off. For Azeroth!','',0,0,0,0,0,0,0,0,0,0,87755,0,26124),
(135714,'','The invaders are charging their weapons. Quickly! Use these portals to board their vessel. Stop their attack!',0,0,0,0,0,0,0,0,0,0,0,88217,26124),
(135715,'','Welcome, mortals, to my sanctuary.',0,0,0,0,0,0,0,0,0,0,0,88218,26124),
(135716,'','For countless ages my spirit has lingered here, safe from the Dark Titan\'s grasp. But he has found me at last, and comes to claim my power.',0,0,0,0,0,0,0,0,0,0,0,88219,26124),
(135717,'','I implore you, stand with me. Together we can drive back this onslaught and deprive Sargeras of victory.',0,0,0,0,0,0,0,0,0,0,0,88220,26124),
(135718,'','Time grows short. The enemy closes in. Approach me and stand ready, my children. The final battle is at hand.',0,0,0,0,0,0,0,0,0,0,0,88221,26124),
(135720,'','A powerful demon is close... very close. Make an example of it!',0,0,0,0,0,0,0,0,0,0,0,87399,26124),
(135721,'','The enemy draws near. Stand ready. We fight for the future of our world.',0,0,0,0,0,0,0,0,0,0,0,87400,26124),
(135722,'','Even here on this bleak world, we fight for Azeroth!',0,0,0,0,0,0,0,0,0,0,0,87401,26124),
(135723,'','Well fought. This tide of demons will break upon our blades!',0,0,0,0,0,0,0,0,0,0,0,87402,26124),
(135724,'In my entire lifetime, I never left the borders of Suramar. To see this place is to understand the fate that almost befell my people.','',0,0,0,0,0,0,1,0,0,0,87405,0,26124),
(135725,'','And nearly mine as well. The sin\'dorei also had a leader who struck a bargain with the Legion, poisoning us in the process.',0,0,0,0,0,0,1,0,0,0,0,87409,26124),
(135727,'An unbridled thirst for power is the most terrible corruption of all. How did your people find their path forward?','',0,0,0,0,0,0,6,0,0,0,87406,0,26124),
(135728,'','We banded together to fight for our place on Azeroth. And we realized we needed allies to stand with us.',0,0,0,0,0,0,1,0,0,0,0,87410,26124),
(135729,'And has the Horde served that purpose for you?','',0,0,0,0,0,0,1,0,0,0,87407,0,26124),
(135730,'','It has. Make no mistake, ours has not been an easy road, and we have struggled through dark times. But together we face a world that has often turned its back on us. Together, we find strength.',0,0,0,0,0,0,1,0,0,0,0,87411,26124),
(135731,'A valuable perspective, Lady Liadrin. You have given me much to ponder.','',0,0,0,0,0,0,1,0,0,0,87408,0,26124),
(135734,'It seems our victory on Argus was a hollow one. With his final blow, Sargeras has done much more than bury his blade in the heart of our world.','',0,0,0,0,0,0,1,0,0,0,88512,0,26124),
(135735,'As the life essence of Azeroth bleeds out, the leaders of the Alliance and Horde scramble to claim it as a resource. Blades are drawn, and the tides of war are rising once again.','',0,0,0,0,0,0,1,0,0,0,88514,0,26124),
(135736,'I had hoped that after the war against the Legion, the people of Azeroth would build a new future together. But now the unity we forged has been shattered.','',0,0,0,0,0,0,1,0,0,0,88513,0,26124),
(135737,'But I will not take up arms against heroes on either side. Not after all we\'ve been through.','',0,0,0,0,0,0,1,0,0,0,88515,0,26124),
(135738,'Instead, I will go to Karazhan and confer with my old mentor, Medivh. Perhaps somewhere in his ancient texts lies the knowledge needed to heal this world.','',0,0,0,0,0,0,1,0,0,0,88516,0,26124),
(135739,'I had best be going. Until next we meet... fare well, champion.','',0,0,0,0,0,0,1,0,0,0,88517,0,26124),
(135742,'Champion... I need a word.','',0,0,0,0,0,0,0,0,0,0,88518,0,26124),
(135743,'Such devastation...','',0,0,0,0,0,0,1,0,0,0,88519,0,26124),
(135744,'Once the transmitter is linked to Light\'s Judgment, we can use it to deploy a warframe to your location. I think you know what to do from there.','',0,0,0,0,0,0,1,0,0,0,87673,0,26124),
(135745,'Take caution, for it requires a great deal of power to deploy a warframe. You wouldn\'t want to find yourself in need of one while it is recharging!','',0,0,0,0,0,0,1,0,0,0,87674,0,26124),
(135746,'This mountain belongs to us, mortals. You will soon become vessels for this world\'s true power!','',0,0,0,0,0,0,0,0,0,0,93894,0,26124),
(135747,'These heroes do not stand alone.','',0,0,0,0,0,0,0,0,0,0,93879,0,26124),
(135748,'Together, we will banish your darkness!','',0,0,0,0,0,0,0,0,0,0,93880,0,26124),
(135749,'Fascinating! The ancient trees here have pockets of fossilized resin with unusual properties. Say... you wouldn\'t mind securing some samples for me, would you, my friend?','',0,0,0,0,0,0,0,0,0,0,87687,0,26124),
(135750,'I have many experiments in mind for these fossils. Acquiring them was no small feat. Thank you.','',0,0,0,0,0,0,0,0,0,0,87688,0,26124),
(135751,'You will serve us, dragon, just as Neltharion did! Your kind always bends to the whispers.','',0,0,0,0,0,0,0,0,0,0,93895,0,26124),
(135752,'Let them feel your fury!','',0,0,0,0,0,0,0,0,0,0,87675,0,26124),
(135753,'Warframe deployed!','',0,0,0,0,0,0,0,0,0,0,87676,0,26124),
(135754,'For Azeroth!','',0,0,0,0,0,0,0,0,0,0,87677,0,26124),
(135755,'The Light embraces you! Revel in its power!','',0,0,0,0,0,0,0,0,0,0,87678,0,26124),
(135756,'I did not realize that I had invited a dragon to feast with us at Thunder Bluff. Had I known, I might have set a bigger table!','',0,0,0,0,0,0,0,0,0,0,93824,0,26124),
(135757,'Once it is complete, this crucible will be able focus the fundamental forces of the cosmos into your weapon! Just... not yet.','',0,0,0,0,0,0,603,0,0,0,87679,0,26124),
(135758,'Only Mayla and our champion knew my secret before. Now I entrust it to you as well, chieftain.','',0,0,0,0,0,0,6,0,0,0,93881,0,26124),
(135759,'I see no reason for anyone else to know, spiritwalker. Let it be a matter kept... between friends.','',0,0,0,0,0,0,0,0,0,0,93825,0,26124),
(135760,'The Light does not die with the Prime Naaru. It shines within each of us!','',0,0,0,0,0,0,0,0,0,0,88101,0,26124),
(135761,'We still have our purpose. We still have a world to save. We must press on!','',0,0,0,0,0,0,0,0,0,0,88102,0,26124),
(135762,'We must continue our mission. The Legion must be destroyed.','',0,0,0,0,0,0,0,0,0,0,88103,0,26124),
(135763,'It is nearly complete, but it lacks a power source. We need something quite potent indeed.','',0,0,0,0,0,0,396,0,0,0,87680,0,26124),
(135764,'The Light still shines within me. Within you all. We will triumph!','',0,0,0,0,0,0,0,0,0,0,88104,0,26124),
(135765,'Not to worry, there is still great power on Argus\' shattered surface. We just need to find it!','',0,0,0,0,0,0,0,0,0,0,87681,0,26124),
(135766,'You are right, Prophet. The mission still stands.','',0,0,0,0,0,0,0,0,0,0,88109,0,26124),
(135767,'Though her form has shattered, her Light has not left us. Not yet.','',0,0,0,0,0,0,1,0,0,0,87955,0,26124),
(135773,'No more! The matter is done. Our mission remains, with or without the Light Mother.','',0,0,0,0,0,0,1,0,0,0,87956,0,26124),
(135775,'Her Light can not be allowed to fall into darkness. We must safeguard what we can within the crucible.','',0,0,0,0,0,0,1,0,0,0,87957,0,26124),
(135778,'The Light burns brightly within the crucible, but it is still not functional!','',0,0,0,0,0,0,396,0,0,0,87682,0,26124),
(135779,'I wonder if... no, it could not be...','',0,0,0,0,0,0,396,0,0,0,87683,0,26124),
(135780,'The Light and Shadow depend upon one another. If we hone the power of a great being of shadow, the crucible may be complete!','',0,0,0,0,0,0,603,0,0,0,87684,0,26124),
(135781,'Her long years of service to the Light will not be in vain!','',0,0,0,0,0,0,0,0,0,0,88108,0,26124),
(135782,'We cannot let this loss stop us. Light\'s Judgment is the key to our victory.','',0,0,0,0,0,0,0,0,0,0,88105,0,26124),
(135783,'We will travel to the heart of Argus and deliver the final blow to the Legion!','',0,0,0,0,0,0,0,0,0,0,88106,0,26124),
(135784,'With the crucible fully functional, our weapons will shine like the stars themselves! Come, I will show you.','',0,0,0,0,0,0,71,0,0,0,87685,0,26124),
(135785,'That should do it! I am adding the coordinates to our beacon matrix.','',0,0,0,0,0,0,0,0,0,0,88110,0,26124),
(135786,'Once you destroy the generators, we should be able to target their defenses with the Vindicaar. We are almost there!','',0,0,0,0,0,0,0,0,0,0,88111,0,26124),
(135787,'Weaken their forces! We will aim the Vindicaar\'s weapon for the final strike!','',0,0,0,0,0,0,0,0,0,0,88112,0,26124),
(135788,'This is the Legion\'s heart, and is fortified as such. An assault now would be madness. We will need additional preparation to tip the balance.','',0,0,0,0,0,0,0,0,0,0,88113,0,26124),
(135789,'It is ready. Quickly, fire the main cannon!','',0,0,0,0,0,0,0,0,0,0,88114,0,26124),
(135790,'We are operational. Prepare to fire!','',0,0,0,0,0,0,0,0,0,0,88115,0,26124),
(135791,'Now, fire the gun! For Argus! For our people!','',0,0,0,0,0,0,0,0,2,0,88116,0,26124),
(135792,'Ah, yes, it is working even better than I thought! Most excellent.','',0,0,0,0,0,0,396,0,0,0,87686,0,26124),
(135793,'The Legion\'s forces are unprepared for your arrival! Put an end to them!','',0,0,0,0,0,0,396,0,0,0,88155,0,26124),
(135794,'We will purge the Legion from every world they defile. This is only the beginning!','',0,0,0,0,0,0,396,0,0,0,88156,0,26124),
(135796,'','Good of you to show up. There are more targets here than even I can shoot.',0,0,0,0,0,0,396,0,0,0,0,88107,26124),
(135797,'So be it. The Legion\'s armies are scattered across their conquered worlds. We must ensure they do not come to Argus\'s defense before our work is done.','',0,0,0,0,0,0,396,0,0,0,88157,0,26124),
(135798,'Make no mistake, each world is infested with countless armies of demons. We have much to do.','',0,0,0,0,0,0,396,0,0,0,88158,0,26124),
(135799,'Eredar sorcerers twist the fel blood of this world into weapons to use against us. They must be dismantled.','',0,0,0,0,0,0,0,0,0,0,88159,0,26124),
(135800,'We will see the Legion\'s end, even if we must tear Argus itself asunder.','',0,0,0,0,0,0,0,0,0,0,88160,0,26124),
(135801,'Legion portals have opened near Nath\'raxas Spire to reclaim it. Use one of our warframes to see that their effort fails.','',0,0,0,0,0,0,0,0,0,0,88075,0,26124),
(135802,'Such power! These fiends must learn that we will not be defeated so easily.','',0,0,0,0,0,0,0,0,0,0,88076,0,26124),
(135803,'A group of Lightforged are trapped behind enemy lines. We must save them.','',0,0,0,0,0,0,0,0,0,0,88078,0,26124),
(135804,'I commend your heroism. Every soldier on the field of battle counts.','',0,0,0,0,0,0,0,0,0,0,88079,0,26124),
(135805,'Come, I will show you to the Vault of Lights. The others await our arrival.','',0,0,0,0,0,0,396,0,0,0,88061,0,26124),
(135806,'','I\'ve never seen the draenei assemble a force of this magnitude.',0,0,0,0,0,0,0,0,0,0,0,88060,26124),
(135807,'Argus is our ancestral home. We will not see it in the Legion\'s hands any longer.','',0,0,0,0,0,0,0,0,0,0,88062,0,26124),
(135808,'Then my parents can finally return home.','',0,0,0,0,0,0,0,0,0,0,88073,0,26124),
(135809,'You will be crushed beneath me!','',0,0,0,0,0,0,0,0,0,0,88037,0,26124),
(135810,'Our crusade is eternal!','',0,0,0,0,0,0,0,0,0,0,88038,0,26124),
(135811,'Your world is forfeit!','',0,0,0,0,0,0,0,0,0,0,88039,0,26124),
(135812,'Behold the might of the Burning Legion!','',0,0,0,0,0,0,0,0,0,0,88040,0,26124),
(135813,'The apocalypse is upon you!','',0,0,0,0,0,0,0,0,0,0,88041,0,26124),
(135814,'You can never defeat us!','',0,0,0,0,0,0,0,0,0,0,88042,0,26124),
(135815,'Antorus calls to me.','',0,0,0,0,0,0,0,0,0,0,88043,0,26124),
(135816,'I have... failed...','',0,0,0,0,0,0,0,0,0,0,88044,0,26124),
(135817,'The crusade... must...','',0,0,0,0,0,0,0,0,0,0,88045,0,26124),
(135818,'You are too late.','',0,0,0,0,0,0,0,0,0,0,88046,0,26124),
(135819,'We have already won.','',0,0,0,0,0,0,0,0,0,0,88047,0,26124),
(135820,'Impossible...','',0,0,0,0,0,0,0,0,0,0,88048,0,26124),
(135821,'','I sense a surge of void energy in this area. Find the source and destroy it.',0,0,0,0,0,0,0,0,0,0,0,88063,26124),
(135822,'','An entity from the Void has emerged into our world. It must not be allowed to spread its corruption.',0,0,0,0,0,0,0,0,0,0,0,88064,26124),
(135823,'Fellow draenei... champions of Azeroth... the time has come to invade Argus.','',0,0,0,0,0,0,0,0,0,0,88054,0,26124),
(135824,'We will save our world and put a stop to the Burning Legion... once and for all.','',0,0,0,0,0,0,0,0,0,0,88055,0,26124),
(135825,'','Something foul is stalking these grounds, heroes. Hunt it down and destroy it.',0,0,0,0,0,0,0,0,0,0,0,88065,26124),
(135826,'','The void energy here is spreading out of control. Stem this dark tide before we are overrun.',0,0,0,0,0,0,0,0,0,0,0,88066,26124),
(135827,'','Dark portals are tearing open reality, allowing shadow energy to pour into our realm. Put a stop to this, heroes!',0,0,0,0,0,0,0,0,0,0,0,88067,26124),
(135828,'','Well done, heroes.',0,0,0,0,0,0,0,0,0,0,0,88068,26124),
(135830,'','The beast has been defeated. Well done, champions.',0,0,0,0,0,0,0,0,0,0,0,88069,26124),
(135831,'','A fine hunt, heroes.',0,0,0,0,0,0,0,0,0,0,0,88070,26124),
(135833,'','You have quelled the void presence in this area. Well done.',0,0,0,0,0,0,0,0,0,0,0,88071,26124),
(135834,'','The forces of the Void are always looking to claim footholds in our world. Your resistance is crucial for preserving balance.',0,0,0,0,0,0,0,0,0,0,0,88072,26124),
(135835,'Lend me your strength, $p. We will open the way together.','',0,0,0,0,0,0,0,0,0,0,88056,0,26124),
(135838,'The Exodar has long been crippled by the crash that brought us to this world many years ago.','',0,0,0,0,0,0,0,0,0,0,88057,0,26124),
(135839,'Every spare moment, every resource, has gone toward the birth of a new vessel. Our instrument of retribution.','',0,0,0,0,0,0,0,0,0,0,88058,0,26124),
(135840,'The way is open. Come, children of Argus, allies, champions. The Vindicaar awaits!','',0,0,0,0,0,0,396,0,0,0,88059,0,26124),
(135841,'But... couldn\'t you have returned out to us? To your people? To me?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(135844,'You will pay with your life!','',0,0,0,0,0,0,0,0,0,0,88081,0,26124),
(135845,'My brethren in the Army of the Light await our arrival. Only together will we achieve victory.','',0,0,0,0,0,0,0,0,0,0,88098,0,26124),
(135846,'For the master!','',0,0,0,0,0,0,0,0,0,0,88082,0,26124),
(135847,'Your kind will fall.','',0,0,0,0,0,0,0,0,0,0,88083,0,26124),
(135848,'Kneel or meet your end.','',0,0,0,0,0,0,0,0,0,0,88084,0,26124),
(135849,'Your end draws near.','',0,0,0,0,0,0,0,0,0,0,88085,0,26124),
(135850,'For the Legion!','',0,0,0,0,0,0,0,0,0,0,88086,0,26124),
(135851,'Krypta!','',0,0,0,0,0,0,0,0,0,0,88087,0,26124),
(135852,'Acalah pek ecta!','',0,0,0,0,0,0,0,0,0,0,88088,0,26124),
(135853,'Forgive me...','',0,0,0,0,0,0,0,0,0,0,88089,0,26124),
(135854,'I am released...','',0,0,0,0,0,0,0,0,0,0,88090,0,26124),
(135855,'Death awaits.','',0,0,0,0,0,0,0,0,0,0,88091,0,26124),
(135856,'The Light fades.','',0,0,0,0,0,0,0,0,0,0,88092,0,26124),
(135857,'Master... I have failed you.','',0,0,0,0,0,0,0,0,0,0,88093,0,26124),
(135858,'My service... ends...','',0,0,0,0,0,0,0,0,0,0,88094,0,26124),
(135859,'Your ruined world... will adorn... our skies...','',0,0,0,0,0,0,0,0,0,0,88095,0,26124),
(135860,'Golad niton acalah.','',0,0,0,0,0,0,0,0,0,0,88096,0,26124),
(135862,'The Light will guide us to them. Romuul, begin final preparations and ensure our forces are accounted for. It is time.','',0,0,0,0,0,0,0,0,0,0,88099,0,26124),
(135863,'Yes, Prophet. Right away.','',0,0,0,0,0,0,0,0,0,0,88077,0,26124),
(135864,'Aggramar! The fallen titan now serves Sargeras! This is bad... VERY bad!','',0,0,0,0,0,0,1,0,0,0,88127,0,26124),
(135867,'','Is there something I can help you with, $c?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135870,'Let me know when you are ready to depart.','',0,0,0,0,0,0,0,0,0,0,88161,0,26124),
(135871,'We must destroy the weapon while it is still recharging! Romuul, deploy a bunker below!','',0,0,0,0,0,0,1,0,0,0,88162,0,26124),
(135872,'Bunker deployed, Prophet!','',0,0,0,0,0,0,0,0,0,0,88132,0,26124),
(135873,'Romuul, send our vanguard to establish a front.','',0,0,0,0,0,0,0,0,0,0,88163,0,26124),
(135876,'$p, we will descend together once you are prepared.','',0,0,0,0,0,0,0,0,0,0,88164,0,26124),
(135877,'The Vindicaar cannot fire upon the devastators until the barriers are disabled. Hurry!','',0,0,0,0,0,0,0,0,0,0,88165,0,26124),
(135878,'These are some of the eredar\'s greatest warriors. Do not underestimate them.','',0,0,0,0,0,0,0,0,0,0,88177,0,26124),
(135879,'Take caution that you do not engage the conquerors alone. I can sense their power from here.','',0,0,0,0,0,0,0,0,0,0,88178,0,26124),
(135880,'The Legion\'s bodies overflow with fel energy. The Legion has not been idle here during their crusade.','',0,0,0,0,0,0,0,0,0,0,88179,0,26124),
(135881,'Help...Help... me...','',0,0,0,0,0,0,0,0,0,0,88175,0,26124),
(135882,'','The darkened naaru pulses with Void energy.',0,0,0,0,0,0,0,0,6,0,0,88166,26124),
(135883,'','It has become a beacon...',0,0,0,0,0,0,0,0,6,0,0,88167,26124),
(135884,'You have my thanks, outsider. May our paths cross again.','',0,0,0,0,0,0,396,0,0,0,88176,0,26124),
(135885,'','...calling those who would use this power for their own ends.',0,0,0,0,0,0,0,0,6,0,0,88168,26124),
(135886,'Our souls fuel their magic. Even death has no solace.','',0,0,0,0,0,0,0,0,0,0,88169,0,26124),
(135887,'There is no fighting them. With each death they return!','',0,0,0,0,0,0,0,0,0,0,88170,0,26124),
(135888,'They will not find us all. Not in the shadows.','',0,0,0,0,0,0,0,0,0,0,88171,0,26124),
(135889,'I can assist you, $c, with any repairs your equipment may need.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135890,'Those who disobey are sent to the forest. None return.','',0,0,0,0,0,0,0,0,0,0,88172,0,26124),
(135891,'The Light cannot be found here. Only death.','',0,0,0,0,0,0,0,0,0,0,88173,0,26124),
(135892,'Must resist. Must fight. Must survive.','',0,0,0,0,0,0,0,0,0,0,88174,0,26124),
(135893,'The earth writhes in agony. All life fuel for the fel.','',0,0,0,0,0,0,0,0,0,0,88230,0,26124),
(135894,'Do not go near. You too will perish.','',0,0,0,0,0,0,0,0,0,0,88231,0,26124),
(135895,'Is it... over?','',0,0,0,0,0,0,0,0,0,0,88237,0,26124),
(135896,'Free... free...','',0,0,0,0,0,0,0,0,0,0,88238,0,26124),
(135897,'End it all!','',0,0,0,0,0,0,0,0,0,0,88239,0,26124),
(135899,'You cannot stop him! Cannot stop me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135902,'Thank the Light! We are not too late.','',0,0,0,0,0,0,603,0,0,0,88245,0,26124),
(135905,'Let us destroy this foul machine while we still have the chance.','',0,0,0,0,0,0,1,0,0,0,88246,0,26124),
(135906,'|TInterface\\Icons\\SPELL_FIRE_FELFLAMESTRIKE.BLP:20|tThe Paraxis charges up its |cFFFF0000|Hspell:248861|h[Spear of Doom]|h|r!','|TInterface\\Icons\\SPELL_FIRE_FELFLAMESTRIKE.BLP:20|tThe Paraxis charges up its |cFFFF0000|Hspell:248861|h[Spear of Doom]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135907,'|TInterface\\Icons\\SPELL_FEL_INCINERATE.BLP:20|tThe Paraxis fires orbs of Fel energy to|cFFFF0000|Hspell:248925|h [Annihilate]|h|r you!','|TInterface\\Icons\\SPELL_FEL_INCINERATE.BLP:20|tThe Paraxis fires orbs of Fel energy to|cFFFF0000|Hspell:248925|h [Annihilate]|h|r you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135908,'|TInterface\\Icons\\SPELL_FIRE_FELFLAMEBOLT.BLP:20|tThe Paraxis|cFFFF0000|Hspell:248326|h [Rains Fel]|h|r down on you!','|TInterface\\Icons\\SPELL_FIRE_FELFLAMEBOLT.BLP:20|tThe Paraxis|cFFFF0000|Hspell:248326|h [Rains Fel]|h|r down on you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(135909,'There are no guards this close to their weapon?','',0,0,0,0,0,0,0,0,0,0,88326,0,26124),
(135910,'Something is wrong.','',0,0,0,0,0,0,396,0,0,0,88327,0,26124),
(135911,'This is no mere siege weapon...','',0,0,0,0,0,0,396,0,0,0,88328,0,26124),
(135913,'','Leaders of the Horde, I summoned you here--along with one of our greatest champions--because our enemies are gathering their strength.',0,0,0,0,0,0,1,0,0,0,0,94772,26124),
(135914,'','War is coming. We need fresh blood added to the ranks of the Horde. What say you?',0,0,0,0,0,0,6,0,0,0,0,94774,26124),
(135915,'Warchief, the tauren of Highmountain fought boldly alongside us in our campaign against the Burning Legion, just as our ancestors did long ago.','',0,0,0,0,0,0,1,0,0,0,93826,0,26124),
(135916,'I have invited their leaders to a great feast in Mulgore. This could be a chance to bring them to our side.','',0,0,0,0,0,0,1,0,0,0,93901,0,26124),
(135917,'','A simple people, but strong. They would be a boon on the battlefield.',0,0,0,0,0,0,273,0,0,0,0,94775,26124),
(135918,'','I too have a suggestion, Warchief. The sin\'dorei have maintained diplomatic ties with the nightborne since we helped liberate Suramar from the Legion.',0,0,0,0,0,0,1,0,0,0,0,94841,26124),
(135919,'','The regent lord and I agree that our kingdoms have much in common. We believe the nightborne would make valuable allies.',0,0,0,0,0,0,1,0,0,0,0,94842,26124),
(135920,'','Even without the Nightwell, Suramar holds vast arcane resources. A most useful arrow added to my quiver.',0,0,0,0,0,0,1,0,0,0,0,94776,26124),
(135921,'','Each option would have its uses. I believe $n knows both these peoples. Which potential ally do you suggest we pursue first?',0,0,0,0,0,0,6,0,0,0,0,94777,26124),
(135922,'','Chieftain Bloodhoof, have our champion join you for your feast in Thunder Bluff. By the time dessert is served, I want their oath of loyalty to the Horde.',0,0,0,0,0,0,1,0,0,0,0,93837,26124),
(135923,'It shall be so, Warchief.','',0,0,0,0,0,0,66,0,0,0,93902,0,26124),
(135924,'','The Alliance is scouring the far corners of Azeroth in search of every advantage against us. We must do the same.',0,0,0,0,0,0,1,0,0,0,0,94773,26124),
(135925,'Somethin\' ain\'t right with this place. A presence calls ta me from somewhere deep inside the earth.','',0,0,0,0,0,0,0,0,0,0,88279,0,26124),
(135926,'We must stand together. For Azeroth!','',0,0,0,0,0,0,0,0,0,0,88248,0,26124),
(135930,'Legion summoners are calling forth a massive infernal to rain terror upon our allies. Put an end to their ritual!','',0,0,0,0,0,0,0,0,0,0,88329,0,26124),
(135931,'The Legion\'s plans shatter as its Burning Crusade crumbles to dust.','',0,0,0,0,0,0,0,0,0,0,88330,0,26124),
(135932,'My soldiers speak of demonic brews that melt armor and disfigure flesh. Find the source of this insidious alchemy and destroy it!','',0,0,0,0,0,0,0,0,0,0,88308,0,26124),
(135933,'To think Legion soldiers drink that swill... disgusting to the last!','',0,0,0,0,0,0,0,0,0,0,88309,0,26124),
(135934,'Inquisitors emerge from darkness and abduct our patrols. Find these captives and spare them from their fate.','',0,0,0,0,0,0,0,0,0,0,88310,0,26124),
(135935,'The torment these soldiers endured... You arrived just in time.','',0,0,0,0,0,0,0,0,0,0,88311,0,26124),
(135936,'So many of my kinsmen\'s souls endure torment at the hands of the Legion. Free them, that they may rest.','',0,0,0,0,0,0,0,0,0,0,88250,0,26124),
(135937,'I hope my brothers and sisters will know some measure of peace.','',0,0,0,0,0,0,0,0,0,0,88251,0,26124),
(135938,'One of our scouting parties has gone missing. The Legion may have them pinned down--or worse. Find our soldiers... before it\'s too late!','',0,0,0,0,0,0,0,0,0,0,88312,0,26124),
(135939,'','Begone, intruders! Back to your master!',0,0,0,0,0,0,0,0,0,0,0,88222,26124),
(135940,'Saved from a grisly fate. My soldiers send their thanks.','',0,0,0,0,0,0,0,0,0,0,88313,0,26124),
(135941,'Demon beasts and deadly traps slow our advance. Deal with these impediments!','',0,0,0,0,0,0,0,0,0,0,88314,0,26124),
(135942,'The way forward is clear. Our campaign to bring down the Legion carries on!','',0,0,0,0,0,0,0,0,0,0,88315,0,26124),
(135943,'The courage of our troops has never faltered, but even an experienced soldier can grow weary. A show of force on the front lines would be a welcome inspiration!','',0,0,0,0,0,0,0,0,0,0,88316,0,26124),
(135944,'You have stoked the fire in the hearts of our soldiers. There is no doubt we will win this war!','',0,0,0,0,0,0,0,0,0,0,88317,0,26124),
(135945,'','Feel the potency of life! Fear its power!',0,0,0,0,0,0,0,0,0,0,0,88223,26124),
(135946,'','Minions of darkness! You will know the might of a titan!',0,0,0,0,0,0,0,0,0,0,0,88224,26124),
(135947,'Legion hounds harry our troops as they try to pull back. Rescue as many of our forces as you can!','',0,0,0,0,0,0,0,0,0,0,88318,0,26124),
(135948,'The death howls of those vile beasts will be remembered by the soldiers you saved, even as they march on the gates of Antorus.','',0,0,0,0,0,0,0,0,0,0,88319,0,26124),
(135949,'We identified an area crucial to getting our troops to the front lines, only to find the place infested with demon spiders. Burn out those nests!','',0,0,0,0,0,0,0,0,0,0,88320,0,26124),
(135950,'You scorched the hovels of those Legion pests and cleared the way for our troops. Well done!','',0,0,0,0,0,0,0,0,0,0,88321,0,26124),
(135951,'','Victory is nigh, champions! Dispatch their remaining forces. I will see to their vessel myself.',0,0,0,0,0,0,0,0,0,0,0,88225,26124),
(135952,'Our scouts have pinpointed a gathering of some of the Legion\'s most skilled pilots. This would be a perfect opportunity to take them out!','',0,0,0,0,0,0,0,0,0,0,88322,0,26124),
(135953,'Every ship grounded without a pilot means one less enemy firing on the Vindicaar\'s shields. Excellent work!','',0,0,0,0,0,0,0,0,0,0,88323,0,26124),
(135954,'','Your master has failed, demons. To the abyss with you!',0,0,0,0,0,0,0,0,0,0,0,88226,26124),
(135955,'Legion artificers are reckless, and I have found a weakness in their ordnance. Shorten their fuses and destroy their stockpiles!','',0,0,0,0,0,0,0,0,0,0,88274,0,26124),
(135957,'A glorious blast! The Light\'s advance will not be stopped!','',0,0,0,0,0,0,0,0,0,0,88275,0,26124),
(135958,'Powerful eredar are held in stasis as their bodies are being twisted into an even more brutal form. Cut the fiends down while they slumber!','',0,0,0,0,0,0,0,0,0,0,88331,0,26124),
(135959,'And so the Legion is deprived of yet another weapon.','',0,0,0,0,0,0,0,0,0,0,88332,0,26124),
(135960,'The krokul slaves fled somewhere further down the ridge as they were freed. They could not have gone far.','',0,0,0,0,0,0,1,0,0,0,88247,0,26124),
(135961,'Forces inside Antorus must see they are not safe from our attacks. Take a warframe and hit targets of opportunity behind their lines!','',0,0,0,0,0,0,0,0,0,0,88276,0,26124),
(135962,'A successful strike and a warframe returned to me in one piece? It truly is a miracle!','',0,0,0,0,0,0,0,0,0,0,88277,0,26124),
(135963,'An infernal has crashed down, killing the very masters who spawned it. Destroy this monstrosity before it jeopardizes our advance!','',0,0,0,0,0,0,0,0,0,0,88333,0,26124),
(135964,'The Legion grow reckless. They reek of desperation!','',0,0,0,0,0,0,0,0,0,0,88334,0,26124),
(135965,'Brutal eredar have been awakened from their stasis. Cut them down where they stand!','',0,0,0,0,0,0,0,0,0,0,88335,0,26124),
(135966,'You brought down the brutes and cost the Legion another victory. Their downfall is at hand.','',0,0,0,0,0,0,0,0,0,0,88336,0,26124),
(135967,'The shadows hunger!','',0,0,0,0,0,0,0,0,0,0,88337,0,26124),
(135968,'Darkness... will... claim you...','',0,0,0,0,0,0,0,0,0,0,88338,0,26124),
(135969,'Come, small ones. Die by my hand!','',0,0,0,0,0,0,0,0,0,0,88343,0,26124),
(135970,'Im... impossible...','',0,0,0,0,0,0,0,0,0,0,88344,0,26124),
(135971,'All worlds will burn in felfire!','',0,0,0,0,0,0,0,0,0,0,88341,0,26124),
(135972,'The flames... will... claim you...','',0,0,0,0,0,0,0,0,0,0,88342,0,26124),
(135973,'Here! They are nearby, I am certain.','',0,0,0,0,0,0,0,0,0,0,88249,0,26124),
(135974,'I see the weakness in your soul!','',0,0,0,0,0,0,0,0,0,0,88339,0,26124),
(135975,'My sight fails me...','',0,0,0,0,0,0,0,0,0,0,88340,0,26124),
(135976,'','New playthings? How irresistible!',0,0,0,0,0,0,0,0,0,0,0,88349,26124),
(135977,'','You left me... wanting...',0,0,0,0,0,0,0,0,0,0,0,88350,26124),
(135978,'','Yes... come closer, little ones!',0,0,0,0,0,0,0,0,0,0,0,88347,26124),
(135979,'','The master... will be... your end.',0,0,0,0,0,0,0,0,0,0,0,88348,26124),
(135980,'Your presence is an infestation. Infestations must be purged!','',0,0,0,0,0,0,0,0,0,0,88345,0,26124),
(135981,'My watch... ends.','',0,0,0,0,0,0,0,0,0,0,88346,0,26124),
(135982,'But your ally saved many of us from the Legion\'s grasp. Perhaps you have changed.','',0,0,0,0,0,0,396,0,4,0,88232,0,26124),
(135983,'Know the darkness!','',0,0,0,0,0,0,0,0,0,0,88240,0,26124),
(135984,'A merciful release!','',0,0,0,0,0,0,0,0,0,0,88241,0,26124),
(135985,'The master demands your doom!','',0,0,0,0,0,0,0,0,0,0,88242,0,26124),
(135986,'Master! I go to claim your prize!','',0,0,0,0,0,0,0,0,0,0,88243,0,26124),
(135987,'No hope. Just pain. Only pain!','',0,0,0,0,0,0,0,0,0,0,88244,0,26124),
(135988,'We seek you as allies. We came to Argus at the call of the Army of the Light to bring an end to the Legion. Stand with us once more!','',0,0,0,0,0,0,1,0,4,0,88285,0,26124),
(135989,'An end? Pah! Their numbers are beyond measure. It is an impossible task. A death wish!','',0,0,0,0,0,0,396,0,4,0,88273,0,26124),
(135990,'My top commander, Lothraxion, was sent to defend Azeroth alongside the Silver Hand... and to guide you here.','',0,0,0,0,0,0,1,0,0,0,88278,0,26124),
(135991,'The Legion brazenly advances on worlds beyond Argus, spreading its forces thin. Find their portals and kill the demons on the other side!','',0,0,0,0,0,0,0,0,0,0,88352,0,26124),
(135992,'The Legion\'s arrogance is clear. Pursue them to every world they infest. Show them that they cannot escape our wrath.','',0,0,0,0,0,0,0,0,0,0,88353,0,26124),
(135993,'A new invasion point harbors a Legion commander. Go and deliver vengeance!','',0,0,0,0,0,0,0,0,0,0,88354,0,26124),
(135994,'The Legion\'s fanatical crusade falters. We will purge their stench from every world they have defiled.','',0,0,0,0,0,0,0,0,0,0,88355,0,26124),
(135995,'It is as I thought... the stone is depleted, but intact. It shall still prove useful to us.','',0,0,0,0,0,0,0,0,0,0,88356,0,26124),
(135996,'Even as we march upon the heart of Argus, the Legion continues its crusade on other worlds.','',0,0,0,0,0,0,0,0,0,0,88357,0,26124),
(135997,'We will punish their hubris by hunting them any place they dare to tread.','',0,0,0,0,0,0,0,0,0,0,88358,0,26124),
(135998,'Use the keystone to pass through the rift. Bring the fight to the Legion!','',0,0,0,0,0,0,0,0,0,0,88359,0,26124),
(135999,'The demons will be caught off guard, assuming all our attention to be focused on Argus.','',0,0,0,0,0,0,0,0,0,0,88360,0,26124),
(136000,'Show them the price of their arrogance!','',0,0,0,0,0,0,0,0,0,0,88361,0,26124),
(136001,'The keystone continues to gain strength. Interesting... Perhaps we can use it to tear open more powerful rifts.','',0,0,0,0,0,0,0,0,0,0,88362,0,26124),
(136002,'The Legion\'s hold will be broken at every turn! Do not let them rest! Do not relent!','',0,0,0,0,0,0,0,0,0,0,88363,0,26124),
(136004,'|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136005,'|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136006,'|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136007,'|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136008,'|TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136009,'|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136010,'||TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t','||TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136011,'A bit worn, but still functional. These will do nicely.','',0,0,0,0,0,0,396,0,0,0,88283,0,26124),
(136012,'Armaments from one of our past assaults litter the ridge on the eastern side of the hold. Their recovery would aid our war effort.','',0,0,0,0,0,0,0,0,0,0,88306,0,26124),
(136013,'We will put these to use immediately. Thank you for recovering them.','',0,0,0,0,0,0,0,0,0,0,88307,0,26124),
(136014,'T\'uure, free from the Legion\'s grasp at last? I welcome your presence, torchbearer.','',0,0,0,0,0,0,0,0,0,0,88305,0,26124),
(136016,'I see the Alliance answered the call as well.','',0,0,0,0,0,0,1,0,0,0,88351,0,26124),
(136017,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,90065,0,26124),
(136018,'Sound effect for troops','',0,0,0,0,0,0,0,0,0,0,90064,0,26124),
(136019,'Sound effect for troops','Sound effect for troops',0,0,0,0,0,0,0,0,0,0,88736,88736,26124),
(136020,'|TInterface\\Icons\\Spell_Warlock_DemonicEmpowerment.blp:20|tKin\'garoth casts |cFFFF0000|Hspell:249740|h[Overcharge]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(136021,'Soon comes the awakening of my brother, Argus. Together, our new Pantheon will join the master in breaking your fetid world. But you will not live to see it.','',0,0,0,0,0,0,0,0,0,0,88366,0,26124),
(136022,'I have heard all the prattling I can bear. Let us show this lackey of Sargeras that he has no claim to our world!','',0,0,0,0,0,0,0,0,0,0,88367,0,26124),
(136023,'This may be the one place in the universe sacred to the Legion. Demons would pluck out their eyes sooner than gaze upon it.','',0,0,0,0,0,0,1,0,0,0,88369,0,26124),
(136024,'Who could ever imagine such a sacrifice?','',0,0,0,0,0,0,0,0,0,0,88368,0,26124),
(136025,'The souls of the Pantheon are free, but they endured so much sufferin\'. Let me bide with \'em fer a time. Offer a bit o\' comfort.','',0,0,0,0,0,0,1,0,0,0,88371,0,26124),
(136026,'Remain here, Magni. The rest of us will go on.','',0,0,0,0,0,0,1,0,0,0,88372,0,26124),
(136027,'So close now to the end...','',0,0,0,0,0,0,603,0,0,0,88370,0,26124),
(136028,'The heart of Antorus lies before us. The power behind the Legion\'s infinite army.','',0,0,0,0,0,0,1,0,0,0,88373,0,26124),
(136029,'So much agony here... so many voices. It\'s... it\'s nearly overwhelmin\'! But I can feel Eonar urgin\' us forward.','',0,0,0,0,0,0,1,0,0,0,88374,0,26124),
(136030,'At long last, the end is upon us. Press on, my friends.','',0,0,0,0,0,0,1,0,0,0,88375,0,26124),
(136031,'Aaaarggh! Witches! You call that torment? I have endured far worse!','',0,0,0,0,0,0,0,0,0,0,88376,0,26124),
(136032,'','I tire of that worm\'s babbling! Let me scorch the flesh from his miserable bones!',0,0,0,0,0,0,0,0,0,0,0,88380,26124),
(136033,'A faint glow emanates from the object.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136034,'','Ignore him, sister! Focus on your duty. These souls are nearly ready to join Aggramar in the master\'s service.',0,0,0,0,0,0,0,0,0,0,0,88381,26124),
(136035,'I feel those demons twistin\' the spirits o\' the titans! Forcin\' \'em ta use their might ta serve the Legion!','',0,0,0,0,0,0,603,0,0,0,88377,0,26124),
(136036,'Should they fall to darkness, Sargeras will have the power he needs to claim the final titan.','',0,0,0,0,0,0,1,0,0,0,88378,0,26124),
(136037,'Azeroth!','',0,0,0,0,0,0,1,0,0,0,88379,0,26124),
(136038,'Azerite fissures begin to erupt nearby!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136040,'What is your bidding, master?','',0,0,0,0,0,0,0,0,6,0,88390,0,26124),
(136041,'The circle nears completion. The mortals must not disrupt the rebirth.','',0,0,0,0,0,0,0,0,6,0,88391,0,26124),
(136042,'Those who will not serve shall be destroyed. It is the only way.','',0,0,0,0,0,0,0,0,14,0,88392,0,26124),
(136043,'Become the instrument of my wrath once again, Aggramar. End this incursion of the Light.','',0,0,0,0,0,0,0,0,6,0,88393,0,26124),
(136044,'The hour of rebirth draws near. Are the souls prepared?','',0,0,0,0,0,0,0,0,6,0,88395,0,26124),
(136045,'Our kin still resist the true path, master. But they will soon be broken.','',0,0,0,0,0,0,0,0,6,0,88396,0,26124),
(136046,'One still eludes us. Her essence is needed to ensure the victory of my crusade.','',0,0,0,0,0,0,0,0,6,0,88397,0,26124),
(136047,'The Life-Binder will soon reveal herself. She will not escape me, master!','',0,0,0,0,0,0,0,0,6,0,88398,0,26124),
(136048,'When my new Pantheon rises, no power in the universe will stand against the Legion!','',0,0,0,0,0,0,0,0,6,0,88399,0,26124),
(136049,'','I remember the awakening... how life sprang forth all around us.',0,0,0,0,0,0,0,0,6,0,0,88400,26124),
(136050,'','I remember unity... until it was shattered by betrayal.',0,0,0,0,0,0,0,0,6,0,0,88401,26124),
(136051,'','I remember fleeing... to keep him from his prize.',0,0,0,0,0,0,0,0,6,0,0,88402,26124),
(136052,'','The time for hiding is over. Aid me... or everything ends.',0,0,0,0,0,0,0,0,6,0,0,88403,26124),
(136053,'Talgath has turned against us!','',0,0,0,0,0,0,0,0,6,0,88406,0,26124),
(136054,'No...','',0,0,0,0,0,0,0,0,6,0,88407,0,26124),
(136055,'It cannot end like this. Take the others and go, Prophet. We will buy you time.','',0,0,0,0,0,0,0,0,6,0,88408,0,26124),
(136056,'Hatuun! You do not have to do this!','',0,0,0,0,0,0,0,0,6,0,88409,0,26124),
(136057,'Please... keep my family safe.','',0,0,0,0,0,0,0,0,6,0,88410,0,26124),
(136058,'K\'ure! Help us!','',0,0,0,0,0,0,0,0,6,0,88411,0,26124),
(136059,'I will hunt you across the stars, traitor! Even if it takes a thousand years!','',0,0,0,0,0,0,0,0,6,0,88412,0,26124),
(136061,'Swear loyalty to me, pledge the hearts of your people to my cause.','',0,0,0,0,0,0,0,0,6,0,88432,0,26124),
(136062,'Together, we will become Legion, and defeat the hungering void that would consume us all.','',0,0,0,0,0,0,0,0,6,0,88433,0,26124),
(136063,'It is little enough to ask, for what he offers us.','',0,0,0,0,0,0,0,0,6,0,88434,0,26124),
(136064,'Such power... And he speaks the truth.','',0,0,0,0,0,0,0,0,6,0,88435,0,26124),
(136065,'I had hoped the others would sense the darkness behind Sargeras\'s words.','',0,0,0,0,0,0,0,0,6,0,88436,0,26124),
(136066,'The ata\'mal crystal soon showed me the horrible truth of what would come to pass if we accepted the titan\'s offer.','',0,0,0,0,0,0,1,0,6,0,88437,0,26124),
(136073,'You see an empty space where a labradorite could fit.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136074,'You see an empty space where a florid malachite could fit.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136075,'You see an empty space where a chemirine could fit.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136076,'You see an empty space where an argulite could fit.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136077,'You see an empty space where a hesselian could fit.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136078,'You see an empty space where a lightsphene could fit.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136079,'Place a labradorite in the space.','Place a labradorite in the space.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136080,'Place a chemirine in the space.','Place a chemirine in the space.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136081,'Place a florid malachite in the space.','Place a florid malachite in the space.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136082,'Place an argulite in the space.','Place an argulite in the space.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136083,'Place a hesselian in the space.','Place a hesselian in the space.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136084,'Place a lightsphene in the space.','Place a lightsphene in the space.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136087,'The southern skies swell with chaotic energy.','The southern skies swell with chaotic energy.',0,0,0,0,0,0,0,0,0,52240,0,0,26124),
(136088,'Careful! Mortals ain\'t meant ta walk the Dreamweaver\'s path!','',0,0,0,0,0,0,0,0,0,0,88494,0,26124),
(136089,'The demons are turnin\' the Shaper\'s flames against ye!','',0,0,0,0,0,0,0,0,0,0,88492,0,26124),
(136090,'The coven strikes at ye through the storms o\' Golganneth!','',0,0,0,0,0,0,0,0,0,0,88490,0,26124),
(136091,'The coven\'s torments o\' the Highfather have taken form!','',0,0,0,0,0,0,0,0,0,0,88488,0,26124),
(136097,'I\'ll do what I can ta ease the titan spirits while you put an end ta their torturers!','',0,0,0,0,0,0,0,0,0,0,88486,0,26124),
(136098,'','Archmage Y\'mera waves for you to follow her.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136117,'Ye did it! Aggramar\'s essence is free! He can stand beside his brethren once more.','',0,0,0,0,0,0,396,0,0,0,88520,0,26124),
(136118,'The very cradle of creation!','',0,0,0,0,0,0,396,0,0,0,88521,0,26124),
(136119,'The titans can sever that connection... but not here. They need ta bring the soul o\' Argus ta their place o\' power... the Seat o\' the Pantheon.','',0,0,0,0,0,0,396,0,0,0,88522,0,26124),
(136120,'Our victories mean nothing. So long as Sargeras has the soul of Argus to fuel his infinite army, Azeroth remains in grave peril.','',0,0,0,0,0,0,396,0,0,0,88523,0,26124),
(136121,'Their final act will harness the last o\' Argus\'s power, to imprison Sargeras... once and for all.','',0,0,0,0,0,0,396,0,0,0,88524,0,26124),
(136122,'Heroes, I can signal the titans ta begin. Once they start their ritual... there\'s no turnin\' back!','',0,0,0,0,0,0,396,0,0,0,88525,0,26124),
(136123,'The tortured soul of Argus has been put ta rest.','',0,0,0,0,0,0,1,0,0,0,88526,0,26124),
(136124,'It matters not. We have lost. Look to the skies!','',0,0,0,0,0,0,603,0,0,0,88527,0,26124),
(136125,'Sargeras will soon undo all we have fought for.','',0,0,0,0,0,0,1,0,0,0,88528,0,26124),
(136126,'No.','',0,0,0,0,0,0,603,0,0,0,88529,0,26124),
(136127,'We will use the last glimmer of Argus\'s power to bind him here. The Seat of the Pantheon shall become Sargeras\'s prison... and ours as well.','',0,0,0,0,0,0,1,0,0,0,88530,0,26124),
(136128,'You would condemn yourselves to stop him?','',0,0,0,0,0,0,6,0,0,0,88531,0,26124),
(136129,'Our world must survive... no matter the cost!','',0,0,0,0,0,0,603,0,0,0,88532,0,26124),
(136130,'A sacrifice must be made.','',0,0,0,0,0,0,1,0,0,0,88533,0,26124),
(136131,'Return home, children of Azeroth. Protect the final titan.','',0,0,0,0,0,0,1,0,0,0,88534,0,26124),
(136132,'Prophet... what happened out there?','',0,0,0,0,0,0,6,0,0,0,88535,0,26124),
(136133,'Illidan serves as the Dark Titan\'s jailer. His sacrifice has ended the Legion. At long last, the Burning Crusade... is over.','',0,0,0,0,0,0,1,0,0,0,88536,0,26124),
(136134,'Magni? Are you alright? Magni?','',0,0,0,0,0,0,6,0,0,0,88537,0,26124),
(136135,'A sword... in the darkness... sands... soaked in pain.','',0,0,0,0,0,0,1,0,0,0,88538,0,26124),
(136136,'The wound... burning... burning...','',0,0,0,0,0,0,1,0,0,0,88539,0,26124),
(136137,'Take me to the surface.','Take me to the surface.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136138,'The Vindicaar is yours to command.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136139,'','Our home... what has it become?',0,0,0,0,0,0,20,0,0,0,0,0,26124),
(136142,'A Pacing Quest Goes Here.','A Pacing Quest Goes Here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136143,'No, Light please. Not after we have come this far!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136154,'At last, the corruption ceases!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136155,'They will not stop their efforts to corrupt me and my bretheren. But, maybe your arrival can turn the tide.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136157,'Bring me spheres of coalesced flame, that I may empower myself for battle!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136158,'They are upon us once more! Bring the flame to me!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136171,'','Xakaar, what is this delay?!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136172,'Client Scene: Alleria Peers Into the Void','Client Scene: Alleria Peers Into the Void',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136173,'','Here we go.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136174,'','The key is now reforged. Take it and secure the Armory.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136175,'As the machine erupts, something stirs beneath the surface.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(136180,'','At last.',0,0,0,0,0,0,0,0,0,0,0,88601,26124),
(136181,'','I serve the end of all things.',0,0,0,0,0,0,0,0,0,0,0,88602,26124),
(136182,'','Their will be done.',0,0,0,0,0,0,0,0,0,0,0,88603,26124),
(136183,'','I come, Dark Masters.',0,0,0,0,0,0,0,0,0,0,0,88604,26124),
(136184,'','I return to the Void.',0,0,0,0,0,0,0,0,0,0,0,88605,26124),
(136185,'','Oblivion... calls.',0,0,0,0,0,0,0,0,0,0,0,88606,26124),
(136186,'','Understand... this changes... nothing.',0,0,0,0,0,0,0,0,0,0,0,88607,26124),
(136208,'The intruders are proving to be more resilient than we expected Admiral.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136209,'The Legion ship has seen you. Escape to avoid being targeted.','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(136216,'<PH> Intro to Island 3 goes here! For now, just turn in the quest! <PH>','<PH> Intro to Island 3 goes here! For now, just turn in the quest! <PH>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136244,'','Behind me rests the Netherlight Crucible. It is an ancient remnant of this world that once served as a source of considerable magic.$B$BThough its potential power is thought by many to be a gift, empowering it would require great sacrifice... as well as a delicate balance of Light and Shadow.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136245,'That? Why that\'s just a portal I\'ve conjured to allow safe passage to and from Dalaran.$B$BNever know when we\'re gonna need reinforcements!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136246,'','Hello, $n. Everyone aboard has been quite active. You look like you\'ve been busy yourself! If you ever need a place to rest I\'m always here for you.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(136247,'','Greetings.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136294,'Client Scene: The Vindicaar goes Gold','Client Scene: The Vindicaar goes Gold',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136300,'This place is full of magic and mystery.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136301,'What is that portal doing here?','What is that portal doing here?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136302,'What is that behind you?','What is that behind you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136303,'Interesting... And why aren\'t you wearing any shoes?','Interesting... And why aren\'t you wearing any shoes?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136304,'The cold flooring beneath my feet helps me maintain my concentration.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136305,'I am wearing shoes.','I am wearing shoes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136333,'Don\'t worry about me, I\'ll find a way down... Eventually.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136334,'','Oh, look! Another pet has come to play.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136335,'','How fortuitous, my pets were getting hungry.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136336,'','I can make you immortal. However, you first have to die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136337,'You will be first.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136338,'So eager to die?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136339,'I must select one of the countless ways to kill you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136342,'From Fel... to Fel.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136343,'Believe you\'re free? We all serve a master.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136344,'Reborn in Fel!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136389,'It is good to see you, Ishanah. How are you?','It is good to see you, Ishanah. How are you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136390,'','I am well, $n. Thank you for asking.$B$BBefore you venture out to the fields of battle I wanted to make sure you know that my services are always available should you need a place to rest.$B$BBe well.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136391,'But you\'re sitting down.','But you\'re sitting down.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136392,'Yes, well you got me there. Still comfortable regardless.$B$BNow if you\'ll excuse me, I\'ve got quite a bit of reading to do.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136412,'I need repairs, Durael.','I need repairs, Durael.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(136416,'Choose the Vindicaar power that you want to use on Argus. Only one power can be active at a time.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136433,'Thank you, hero!','Thank you, hero!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136496,'$n prepares a Feast of the Fishes!','$n prepares a Feast of the Fishes!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136499,'%s\'s pet Corbyn bites your ears, searching for shiny baubles.','%s\'s pet Corbyn bites your ears, searching for shiny baubles.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136500,'%s\'s pet Corbyn searches your hair for shiny baubles.','%s\'s pet Corbyn searches your hair for shiny baubles.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136501,'%s\'s pet Corbyn caws loudly in your ears.','%s\'s pet Corbyn caws loudly in your ears.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136502,'%s\'s pet Corbyn attempts to poke you in the eyes.','%s\'s pet Corbyn attempts to poke you in the eyes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136503,'%s\'s pet Corbyn circles your head.','%s\'s pet Corbyn circles your head.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136504,'%s\'s pet Corbyn pokes around in your bags.','%s\'s pet Corbyn pokes around in your bags.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136505,'Corbyn stole a copper coin from %s!','Corbyn stole a copper coin from %s!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136506,'Corbyn couldn\'t find anything shiny on %s.','Corbyn couldn\'t find anything shiny on %s.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136540,'|TINTERFACE\\ICONS\\SPELL_FIRE_FELFLAMERING.BLP:20|t Antaen Light-Breaker is casting |cFFFF0000|Hspell:250880|h[Felshock Bombardment]|h|r! Stay in Light\'s Protection!','|TINTERFACE\\ICONS\\SPELL_FIRE_FELFLAMERING.BLP:20|t Antaen Light-Breaker is casting |cFFFF0000|Hspell:250880|h[Felshock Bombardment]|h|r! Stay in Light\'s Protection!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(136541,'','I will not be broken.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(136542,'What happened to you in the Seat of the Triumvirate?','What happened to you in the Seat of the Triumvirate?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136543,'','As the naaru lay dying, L\'ura\'s essence called to me. A being born of the Light had turned to shadow.\n\nIt was a familiar sensation.\n\nThe transformation you witnessed is under my control, to be used when I see fit. I am the same person I was... and yet, something more.\n\nThe use of such power makes some... uneasy. But shadow is a force to be harnessed, not feared.\n\nAs with any weapon, one must maintain constant control when wielding it.',1,1,1,0,0,0,0,0,0,0,0,0,26124),
(136544,'I see.','I see.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136580,'I heard the Viceroy finally took care of that meddling priest.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136582,'A pity he did not kill the elf and her ally, too.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136583,'','There is plenty material for the harvest, here. Let none of it go to waste!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136584,'I will not give Locus-Walker the satisfaction of disrupting our efforts. Capture him at all costs.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136585,'Do what you like with the fleshling and her ally. They are of no concern.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136586,'','Our work is nearly complete. Soon all of Argus will fall to darkness!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136593,'He\'s fightin\' through the pain... to let us see...','',0,0,0,0,0,0,0,0,0,0,88923,0,26124),
(136594,'The voice is alone... weak... but so beautiful!','',0,0,0,0,0,0,0,0,0,0,88924,0,26124),
(136595,'Light.','Light.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136596,'Shadow.','Shadow.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136597,'|TINTERFACE\\ICONS\\Item_HolySpark.blp:20|t [Place the Essence of Light within the Netherlight Crucible].','|TINTERFACE\\ICONS\\Item_HolySpark.blp:20|t [Place the Essence of Light within the Netherlight Crucible].',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136598,'|TINTERFACE\\ICONS\\Inv_Elemental_Primal_Shadow.blp:20|t [Place the Essence of Shadow within the Netherlight Crucible].','|TINTERFACE\\ICONS\\Inv_Elemental_Primal_Shadow.blp:20|t [Place the Essence of Shadow within the Netherlight Crucible].',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136606,'I\'ve heard this tale before... <Skip the scenario and begin your journey on Broken Shore.>','I\'ve heard this tale before... <Skip the scenario and begin your journey on Broken Shore.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136612,'PH Activate Choice UI','PH Activate Choice UI',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136616,'Thank you for joining us, champion. These are dire times indeed.','',0,0,0,0,0,0,1,0,0,0,94916,0,26124),
(136617,'We all know the Alliance incurred heavy losses in the war against the Legion. And even now, the world bleeds in the aftermath of Sargeras\'s final strike.','',0,0,0,0,0,0,1,0,0,0,94917,0,26124),
(136618,'Meanwhile, the Horde musters its forces and arms for war. Their aggression must not go unanswered.','',0,0,0,0,0,0,1,0,0,0,94918,0,26124),
(136619,'Our future depends on bringing other like-minded allies into the fold. I call upon those of you gathered here for your suggestions.','',0,0,0,0,0,0,1,0,0,0,94919,0,26124),
(136620,'Victory on Argus was only possible because the heroes of Azeroth fought side-by-side with the Army of the Light.','',0,0,0,0,0,0,1,0,0,0,93903,0,26124),
(136621,'Many of our bravest soldiers gave their lives for the cause. Those who remain would be proud to join the Alliance.','',0,0,0,0,0,0,1,0,0,0,93904,0,26124),
(136622,'Among our number are brave initiates about to undertake the arduous path of becoming Lightforged.','',0,0,0,0,0,0,1,0,0,0,93905,0,26124),
(136623,'Thank you, High Exarch. Lightforged soldiers would indeed bring strength to our numbers.','',0,0,0,0,0,0,1,0,0,0,94920,0,26124),
(136624,'','High King, I remember the days when my people and yours fought together against the Horde.',0,0,0,0,0,0,1,0,0,0,0,94921,26124),
(136625,'','I reached out to them in hopes of seeing Silvermoon return to the Alliance. My efforts proved... futile.',0,0,0,0,0,0,1,0,0,0,0,94922,26124),
(136626,'','But I did learn of a group of sin\'dorei who have been exiled for studying the void as I have. If I could locate them, their knowledge might aid our cause.',0,0,0,0,0,0,1,0,0,0,0,94923,26124),
(136627,'Stormwind has suffered at the hands of those who succumbed to the shadow\'s whispers. But if others could master its power as you have, they would make formidable allies.','',0,0,0,0,0,0,1,0,0,0,94924,0,26124),
(136628,'Thank you both for your counsel. I would like to hear our champion\'s perspective on which of these potential allies we should reach out to first.','',0,0,0,0,0,0,1,0,0,0,94925,0,26124),
(136629,'Lady Windrunner, please begin the search for your exiled kin. Perhaps our champion here can assist you.','',0,0,0,0,0,0,1,0,0,0,94926,0,26124),
(136630,'','We will do our best to locate them, High King.',0,0,0,0,0,0,66,0,0,0,0,94927,26124),
(136631,'','This way, champion.',0,0,0,0,0,0,1,0,0,0,0,94928,26124),
(136656,'This stuff isn\'t bad, but it\'s a bleedin\' shame just letting the beans sit in water and callin\' that a proper beverage. I need to bring some of this coffee back to the famed Thunderbrew clan and let them have a go at it. Just imagine a good stout, aged with a batch of these beans....','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136658,'We\'ve been working for years to comprehend the powers the void might provide. Now, we are on the cusp of understanding.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136659,'What is this place?','What is this place?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136661,'|TInterface\\Icons\\ABILITY_MAGE_DEEPFREEZE.BLP:20|tGet to a Brazier! |cFFFF0000|Hspell:251709|h[Flash Freeze]|h|ris coming!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(136682,'You are not... prepared.','',0,0,0,0,0,0,0,0,0,0,89057,0,26124),
(136701,'We have accomplished our mission. Let us return to the Vindicaar. Much work remains to be done.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136714,'I thought I was done for... thank you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136715,'Please, save the others!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136716,'Thank you, Champion... I was sure this was the end.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136733,'|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136734,'|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136735,'|TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136736,'|TInterface\\Icons\\spell_shadow_summonfelhunter.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\spell_shadow_summonfelhunter.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136737,'|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136743,'','It is time.',0,0,0,0,0,0,0,0,0,0,0,89192,26124),
(136748,'Purple Team gain the Gift of the Emperor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(136749,'Gold Team gains the Gift of the Emperor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(136781,'','There is much prey to be had here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136782,'','Even here, I can hear it calling to me. Its hunger...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136783,'','Welcome to the heart of Argus.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136784,'','They are truly endless. We must find a way to bring a final end to them.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136785,'What information have you been able to gather, Alleria?','What information have you been able to gather, Alleria?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136786,'Turalyon wants to know the situation down here.','Turalyon wants to know the situation down here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136787,'','The outlook is grim.$b$bMounting a direct assault from this location would prove far too costly. What is more, those cannons atop the wall may well be powerful enough to bring down the Vindicaar.$b$bI suggest using this foothold to launch guerilla strikes. Assassinate key members of their leadership and wreak havoc within their ranks.$b$bI know this is not what you or Turalyon were hoping to hear, but a patient hunter must know when to strike.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136790,'Here at last. It has been so long...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136791,'They are in full force here. They truly are Legion.$b$bPerfect.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136792,'My glaives hunger for the blood of demons.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136793,'I shall put an end to the Legion in this accursed place.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136794,'You ask the obvious.$b$bA direct assault on Antorus would be folly. The Legion\'s forces vastly outnumber us, and they are replacing fallen soldiers at unnatural speed. Some of these brutes are even strong enough to slow me down... slightly.$b$bBreaching their stronghold will require a different plan. In the meantime, there is a sea of demons to slay.$b$bGo back to your High Exarch and let him strategize. I have an enemy to destroy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136817,'The Marsh Shambler becomes Fel Enraged and breaks free from the corrupters!','The Marsh Shambler becomes Fel Enraged and breaks free from the corrupters!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136826,'','We must continue to fight until the Legion is no more.',66,0,0,0,0,0,0,0,0,0,0,0,26124),
(136833,'','The power of the Netherlight Crucible is yours, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136834,'','The sacrifices made to empower the Netherlight Crucible must never be forgotten.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136839,'Argus will never belong to the Legion so long as we stand.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(136847,'|TINTERFACE\\ICONS\\SPELL_FIRE_FELFLAMESTRIKE.BLP:20|t This area is targeted for |cFFF00000|Hspell:250249|h[Obliteration]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(136873,'Kor\'vas, what is the status of the Sargerite Keystone?','Kor\'vas, what is the status of the Sargerite Keystone?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136875,'','Lord Illidan has taken it. His plan is in motion, Slayer.',2,0,0,0,0,0,0,0,0,0,0,0,26124),
(136890,'<The warframe hisses with energy, ready to be taken into battle.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136891,'Begin attack run on Antorus.','Begin attack run on Antorus.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136897,'|cFFFF0000|Hspell:252508|h[The Paraxis]|h|r is arriving soon!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(136898,'|cFFFF0000|Hspell:252508|h[The Paraxis]|h|r has arrived! Run for cover!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(136924,'I want to go to the Seat of the Triumvirate (Dungeon).','I want to go to the Seat of the Triumvirate (Dungeon).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136926,'Purple Team gains Gift of the Emperor!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(136930,'','The Paraxis is returning soon! Army of the Light, set up your shields!',0,0,0,0,0,0,0,0,0,0,0,89336,26124),
(136932,'','The Paraxis is here! Take cover under the shields!',0,0,0,0,0,0,0,0,0,0,0,89342,26124),
(136933,'The Gift of the Emperor is placed within the arena!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(136970,'|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(136971,'|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137042,'I have not had to create something like this in a millennium; bear with me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137043,'Ah, yes, it is coming together nicely.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137044,'It is once again whole!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137081,'We have acquired many goods and curios over the course of this war.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(137102,'|TInterface\\Icons\\ABILITY_DEATHKNIGHT_DEATHSIPHON2.BLP:20|t %s begins to cast |cFFFF0000|Hspell:244056|h[Siphon Corruption]|h|r.','|TInterface\\Icons\\ABILITY_DEATHKNIGHT_DEATHSIPHON2.BLP:20|t %s begins to cast |cFFFF0000|Hspell:244056|h[Siphon Corruption]|h|r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(137103,'|TInterface\\Icons\\SPELL_FIRE_MOLTENBLOOD.BLP:20|t %s begins to cast |cFFFF0000|Hspell:244057|h[Enflame Corruption]|h|r.','|TInterface\\Icons\\SPELL_FIRE_MOLTENBLOOD.BLP:20|t %s begins to cast |cFFFF0000|Hspell:244057|h[Enflame Corruption]|h|r.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(137111,'|TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137112,'|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137114,'|TInterface\\Icons\\spell_shadow_summonfelhunter.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\spell_shadow_summonfelhunter.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137115,'|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137123,'We found this place almost by chance. A rift appeared as I performed experiments in my tower.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(137124,'Since we were first cast out of Blood Elf society, others have joined in the research.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(137125,'This cube is the most puzzling of the... wait.  The energy pulses at your approach. This is... unprecedented.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(137126,'I can see the flow of void energy forming. Perhaps... Yes, that is it!','',0,0,0,0,0,0,273,0,0,0,0,0,26124),
(137136,'|TInterface\\Icons\\INV_OFFHAND_1H_ULDUARRAID_D_01:20|tThe Coven has unleashed the |cFFFF0000|Hspell:250095|h[Machinations of Aman\'Thul]|h|r!','|TInterface\\Icons\\INV_OFFHAND_1H_ULDUARRAID_D_01:20|tThe Coven has unleashed the  |cFFFF0000|Hspell:250095|h[Machinations of Aman\'Thul]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(137145,'|TInterface\\Icons\\ABILITY_THUNDERKING_LIGHTNINGWHIP:20|tThe Coven prepares to unleash the  |cFFFF0000|Hspell:246763|h[Fury of Golganneth]|h|r!','|TInterface\\Icons\\ABILITY_THUNDERKING_LIGHTNINGWHIP:20|tThe Coven prepares to unleash the  |cFFFF0000|Hspell:246763|h[Fury of Golganneth]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(137146,'|TInterface\\Icons\\ABILITY_MONK_BREATHOFFIRE:20|tThe Coven prepares to unleash the  |cFFFF0000|Hspell:245671|h[Flames of Khaz\'goroth]|h|r!','|TInterface\\Icons\\ABILITY_MONK_BREATHOFFIRE:20|tThe Coven prepares to unleash the  |cFFFF0000|Hspell:245671|h[Flames of Khaz\'goroth]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(137147,'|TInterface\\Icons\\ABILITY_MAGE_POTENTSPIRIT:20|tThe Coven prepares to unleash the  |cFFFF0000|Hspell:245910|h[Spectral Army of Norgannon]|h|r!','|TInterface\\Icons\\ABILITY_MAGE_POTENTSPIRIT:20|tThe Coven prepares to unleash the  |cFFFF0000|Hspell:245910|h[Spectral Army of Norgannon]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(137149,'Greetings, and thank you for helping to test Antorus, the Burning Throne!\n\nI can teleport you directly to any bosses that are currently available for testing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137150,'|TInterface\\Icons\\ABILITY_WARLOCK_MOLTENCORE.BLP:20|t You are afflicted by |cFFFF0000|Hspell:244768|h[Desolate Gaze]|h|r!','|TInterface\\Icons\\ABILITY_WARLOCK_MOLTENCORE.BLP:20|t You are afflicted by |cFFFF0000|Hspell:244768|h[Desolate Gaze]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(137158,'Who has awoken me?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137159,'I emerge stronger than ever! Prepare mortal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137160,'In my dreams I saw your world... destroyed!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137164,'I want to teleport to Felhounds of Sargeras.','I want to teleport to Felhounds of Sargeras.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137165,'I want to teleport to the Antoran High Command.','I want to teleport to the Antoran High Command.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137166,'I want to teleport to Portal Keeper Hasabel.','I want to teleport to Portal Keeper Hasabel.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137167,'I want to teleport to Eonar.','I want to teleport to Eonar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137168,'I want to teleport to Imonar the Soulhunter.','I want to teleport to Imonar the Soulhunter.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137169,'I want to teleport to Kin\'garoth.','I want to teleport to Kin\'garoth.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137170,'I want to teleport to Varimathras.','I want to teleport to Varimathras.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137171,'I want to teleport to the Coven of Shivarra.','I want to teleport to the Coven of Shivarra.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137172,'I want to teleport to Aggramar.','I want to teleport to Aggramar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137173,'I want to teleport to Argus the Unmaker.','I want to teleport to Argus the Unmaker.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137176,'','Light and shadow are both means to an end. For the foe before you, feel free to pick whatever weapon you favor.',0,0,0,0,0,0,0,0,0,0,0,87390,26124),
(137177,'','It seems you have chosen your weapon. As have I.',0,0,0,0,0,0,0,0,0,0,0,87394,26124),
(137178,'Champion! The Light has need of you!','',0,0,0,0,0,0,0,0,0,0,81150,0,26124),
(137179,'The Legion cannot stand against the power of the Light. Not when it has champions like you!','',0,0,0,0,0,0,0,0,0,0,81153,0,26124),
(137180,'Prepare yourself, champion. Wickedness lurks nearby...','',0,0,0,0,0,0,0,0,0,0,87295,0,26124),
(137181,'With every such foe you bring down, our ultimate victory draws nearer.','',0,0,0,0,0,0,0,0,0,0,87305,0,26124),
(137182,'Champion! Your expertise is needed! Prepare for battle!','',0,0,0,0,0,0,0,0,0,0,81134,0,26124),
(137183,'You and your comrades fought well. Such determination will be crucial in the battles to come.','',0,0,0,0,0,0,0,0,0,0,81144,0,26124),
(137184,'Our scouts report the presence of a deadly enemy nearby. Time to go on the offensive!','',0,0,0,0,0,0,0,0,0,0,81124,0,26124),
(137185,'Your work today has saved lives, champion. Take pride in that!','',0,0,0,0,0,0,0,0,0,0,81130,0,26124),
(137186,'I sense an entity that wields potent forces with great malevolence. This fiend must be brought down!','',0,0,0,0,0,0,0,0,0,0,87339,0,26124),
(137187,'A worthy victory. No minion of the Legion can be allowed to toy with such forces.','',0,0,0,0,0,0,0,0,0,0,87341,0,26124),
(137188,'Well done! The way you took that target down reminds me of myself in my younger days. My much, much younger days.','',0,0,0,0,0,0,0,0,0,0,81131,0,26124),
(137189,'Gather your allies, champion. A grave threat is at hand, and heroes are needed!','',0,0,0,0,0,0,0,0,0,0,81126,0,26124),
(137190,'Once again, I owe you a debt of thanks. I\'d say you\'re making quite a habit of this!','',0,0,0,0,0,0,0,0,0,0,81132,0,26124),
(137191,'This way, champion!','',0,0,0,0,0,0,0,0,0,0,81125,0,26124),
(137192,'You and your allies are needed, champion. Gather your forces!','',0,0,0,0,0,0,0,0,0,0,81137,0,26124),
(137193,'No matter how many monstrosities they send at us, we will cut them down.','',0,0,0,0,0,0,0,0,0,0,87331,0,26124),
(137194,'','The enemy draws near. Stand ready. We fight for the future of our world.',0,0,0,0,0,0,0,0,0,0,0,87400,26124),
(137195,'','Even here on this bleak world, we fight for Azeroth!',0,0,0,0,0,0,0,0,0,0,0,87401,26124),
(137196,'Gather your allies, hero. The threat you are about to face will put all your skills to the test!','',0,0,0,0,0,0,0,0,0,0,81148,0,26124),
(137197,'The way you and your allies persevered is an inspiration to our forces. Proof that together we can save Azeroth!','',0,0,0,0,0,0,0,0,0,0,81154,0,26124),
(137198,'An insidious champion of darkness draws near. Strike it down!','',0,0,0,0,0,0,0,0,0,0,87293,0,26124),
(137199,'Never doubt that, in the end, the Light will emerge victorious.','',0,0,0,0,0,0,0,0,0,0,87303,0,26124),
(137200,'We can never reclaim what we once had, but we will make them pay for what they did to Argus.','',0,0,0,0,0,0,0,0,0,0,87301,0,26124),
(137201,'What was once a sacred site for my people has been desecrated by the Legion. Drive them out!','',0,0,0,0,0,0,0,0,0,0,87291,0,26124),
(137202,'This way! Come at once!','',0,0,0,0,0,0,0,0,0,0,81138,0,26124),
(137203,'You and your comrades fought well. Such determination will be crucial in the battles to come.','',0,0,0,0,0,0,0,0,0,0,81144,0,26124),
(137204,'It\'s important to listen, even when yer lot in life is speakin\'.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137205,'This villain profanes the homeworld I lost so long ago. Put an end to this atrocity!','',0,0,0,0,0,0,0,0,0,0,87294,0,26124),
(137206,'I am ready to go to the stone.','I am ready to go to the stone.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137207,'We can never reclaim what we once had, but we will make them pay for what they did to Argus.','',0,0,0,0,0,0,0,0,0,0,87301,0,26124),
(137208,'A disciple of Kil\'jaeden seeks to avenge its master. Be ready for its assault!','',0,0,0,0,0,0,0,0,0,0,87298,0,26124),
(137209,'Word of your victory will spread across Argus. Those who cling to the memory of the Deceiver are doomed to fall!','',0,0,0,0,0,0,0,0,0,0,87308,0,26124),
(137210,'Just when the Light gains a foothold here, another vessel of evil rises to battle us. Your might is needed once again, champion.','',0,0,0,0,0,0,0,0,0,0,87297,0,26124),
(137211,'The Light cannot win unless we fight for it. You have done your part this day, champion.','',0,0,0,0,0,0,0,0,0,0,87309,0,26124),
(137213,'I sense a foul presence... an evil that seeks to blot out the Light. Take up arms and bring down this foe!','',0,0,0,0,0,0,0,0,0,0,87299,0,26124),
(137214,'With every such foe you bring down, our ultimate victory draws nearer.','',0,0,0,0,0,0,0,0,0,0,87305,0,26124),
(137215,'No matter how many monstrosities they send at us, we will cut them down.','',0,0,0,0,0,0,0,0,0,0,87331,0,26124),
(137216,'This way! Come at once!','',0,0,0,0,0,0,0,0,0,0,81138,0,26124),
(137217,'','Light and shadow are both means to an end. For the foe before you, feel free to pick whatever weapon you favor.',0,0,0,0,0,0,0,0,0,0,0,87390,26124),
(137218,'','It seems you have chosen your weapon. As have I.',0,0,0,0,0,0,0,0,0,0,0,87394,26124),
(137219,'','I have hunted demons throughout the Twisting Nether for a thousand years. I think I can leave this one to you.',0,0,0,0,0,0,0,0,0,0,0,87388,26124),
(137220,'','Most effective. Every blow dealt to the Legion is a boon to our cause.',0,0,0,0,0,0,0,0,0,0,0,87391,26124),
(137221,'Well done! We have pushed the Legion back... for now, at least.','',0,0,0,0,0,0,0,0,0,0,81129,0,26124),
(137222,'Reports say there is a particularly powerful demon at this location. We should eliminate it quickly!','',0,0,0,0,0,0,0,0,0,0,81128,0,26124),
(137224,'A well-earned victory. The Legion will fall!','',0,0,0,0,0,0,0,0,0,0,87283,0,26124),
(137225,'The Legion considers this location unassailable. I say we prove them wrong!','',0,0,0,0,0,0,0,0,0,0,87264,0,26124),
(137227,'','Well fought. This tide of demons will break upon our blades!',0,0,0,0,0,0,0,0,0,0,0,87402,26124),
(137228,'','A powerful demon is close... very close. Make an example of it!',0,0,0,0,0,0,0,0,0,0,0,87399,26124),
(137229,'Our patrol has spotted a powerful foe in this area. Its downfall would set back the Legion\'s presence here significantly.','',0,0,0,0,0,0,0,0,0,0,81147,0,26124),
(137230,'The Legion cannot stand against the power of the Light. Not when it has champions like you!','',0,0,0,0,0,0,0,0,0,0,81153,0,26124),
(137231,'I want to go to Antorus, the Burning Throne (Raid).','I want to go to Antorus, the Burning Throne (Raid).',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137232,'|TInterface\\Icons\\SPELL_SHADOW_GRIMWARD.BLP:20|tThe Marsh Shamblers break free from their Corrupters; but are |cFFFF0000|Hspell:253552|h[Drained]|h|r in the process.','|TInterface\\Icons\\SPELL_SHADOW_GRIMWARD.BLP:20|tThe Marsh Shamblers break free from their Corrupters; but are |cFFFF0000|Hspell:253552|h[Drained]|h|r in the process.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137236,'The invaders approach. Crush them lest you be used as target practice for the fleet!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137237,'Such arrogance! You approach the Antoran High Command!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137238,'Fall to your knees and I promise you a swift death.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137285,'Our ground forces have secured the area and the Vindicaar awaits your arrival. We can give you an escort. Are you ready to leave?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137286,'I\'m ready.','I\'m ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137297,'Nonsense! The crowd is simply spirited!','Nonsense! The crowd is simply spirited!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137298,'I have not noticed anything.','I have not noticed anything.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137299,'Hmmm... no, I have not noticed anything in particular.','Hmmm... no, I have not noticed anything in particular.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137302,'Look, it\'s the Tri-- trum... The three!','Look, it\'s the Tri-- trum... The three!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137303,'Mother says I should not talk to strangers.','Mother says I should not talk to strangers.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137304,'I feel an unsettling presence near me. What do you think it could be?','I feel an unsettling presence near me. What do you think it could be?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137305,'Hmmm... I think you may be on to something. The air is heavy with ill intent, though I could not say where it comes from.','Hmmm... I think you may be on to something. The air is heavy with ill intent, though I could not say where it comes from.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137306,'Yes, but I cannot be certain where it comes from. It could be nothing.','Yes, but I cannot be certain where it comes from. It could be nothing.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137309,'<The child fidgets nervously.>$b$bI don\'t know... Maybe?','<The child fidgets nervously.>$b$bI don\'t know... Maybe?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137310,'Maybe it\'s a panthara! They like to hide in the shadows....$b$b<The child glances over his shoulder nervously.>','Maybe it\'s a panthara! They like to hide in the shadows....$b$b<The child glances over his shoulder nervously.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137311,'Do you feel it gripping your heart, too?  Please stop this, whatever it is.','Do you feel it gripping your heart, too?  Please stop this, whatever it is.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137313,'Yes! I noticed it the instant I arrived. It makes my skin crawl!','Yes! I noticed it the instant I arrived. It makes my skin crawl!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137314,'<He looks to either side.>$b$bSomething is very wrong. I want to run but my legs will not move.','<She looks to either side.>$b$bSomething is very wrong. I want to run but my legs will not move.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137318,'<The child sobs loudly at you in response to your question.>','<The child sobs loudly at you in response to your question.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137319,'I\'m scared. I want to go home.','I\'m scared. I want to go home.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137320,'Perhaps, but it is nothing Kil\'jaeden cannot handle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137321,'No, why would I? Get out of the way, I am trying to listen to our leader speak.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137322,'<Crystalsmith Netrius clutches his hammer.>$b$bAbsolutely. Whatever it is, it cannot be allowed to harm Kil\'jaeden.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137323,'All appears to be well, stranger.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137324,'I sense something is intensely wrong, but I could not hope to explain how! What is this awful feeling?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137325,'There is something strange, yes, but I am uncertain what it might be. It could be nothing.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137326,'All is well, stranger.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137327,'<Hatuun clenches his fists.>$b$bSomething is very wrong here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137328,'I thought I felt something amiss, but it is likely nothing. Worry not.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137329,'Nothing comes to mind, stranger.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137330,'Yes. I am certain of it. Something dark and terrible stands among us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137331,'Funny you should mention it. I thought it was merely my imagination, but perhaps not.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137332,'I have not noticed anything out of the ordinary, stranger.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137333,'<Restalaan shifts his weight nervously.>$b$bWhatever it is, it is close.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137334,'You may be on to something, stranger. Stay sharp.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137335,'You waste my time with such a suggestion. Begone.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137336,'The Triumvirate may be in imminent danger! Be on your guard!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137337,'Strange is not the word I would have used, but something is amiss, yes.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137338,'I do not feel anything unusual, no.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137339,'Without a doubt. We should be wary, stranger.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137340,'Could be, could be. The air is thick with emotion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137341,'The Legion is defeated, its master imprisoned. But in his final, spiteful act, Sargeras may have doomed us all.','',0,0,0,0,0,0,1,0,0,0,90764,0,26124),
(137342,'Our world is wounded, champion. Its life essence seeps out into the sands... just as Magni foresaw.','',0,0,0,0,0,0,1,0,0,0,90765,0,26124),
(137343,'This mere drop of Argus\'s blood surges with incredible power. The might of a titan.','',0,0,0,0,0,0,1,0,0,0,90766,0,26124),
(137344,'If the blood of Azeroth also proves to be a source of such strength... those who seek to rule this world will stop at nothing to possess it.','',0,0,0,0,0,0,1,0,0,0,90767,0,26124),
(137345,'The days ahead may be dark indeed. For now... go to Silithus. Gaze upon the wound in the world with your own eyes.','',0,0,0,0,0,0,1,0,0,0,90768,0,26124),
(137346,'We will find a way to save Azeroth, $n. I know it.','',0,0,0,0,0,0,1,0,0,0,90769,0,26124),
(137347,'I am not certain what will come of this, but I feel in my bones that this day is one to remember.','I am not certain what will come of this, but I feel in my bones that this day is one to remember.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137348,'It is good to see so many familiar faces. Many have come to hear Kil\'jaeden speak.','It is good to see so many familiar faces. Many have come to hear Kil\'jaeden speak.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137349,'Quite a gathering, isn\'t it?','Quite a gathering, isn\'t it?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137350,'The Triumvirate\'s wisdom has brought us to this point. I hope they know what they are doing, or this could end poorly...','The Triumvirate\'s wisdom has brought us to this point. I hope they know what they are doing, or this could end poorly...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137351,'What do you think Archimonde and Velen are arguing about?','What do you think Archimonde and Velen are arguing about?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137352,'I am not at all sure about this pronouncement.','I am not at all sure about this pronouncement.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137353,'What a joyous day for the Eredar! We will soon ascend to our rightful place!','What a joyous day for the Eredar! We will soon ascend to our rightful place!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137354,'Praise Kil\'jaeden! Praise Sargeras!','Praise Kil\'jaeden! Praise Sargeras!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137355,'Finally we will know our true destiny! Glory to the Eredar!','Finally we will know our true destiny! Glory to the Eredar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137356,'Change is coming. This is a very important moment for our people.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137357,'<Hatuun impassively watches Kil\'jaeden speak.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137358,'It has been some time since Kil\'jaeden last addressed his people. This must be an important occasion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137359,'Kil\'jaeden will usher in a new era of prosperity for all Eredar. He will be remembered as our greatest leader!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137360,'What does Kil\'jaeden have planned for us, I wonder?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137361,'<Talgath watches Archimonde and Velen, only occasionally glancing to Kil\'jaeden.>$b$bHmm.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137362,'The Triumvirate have guided us for so very long. What does this stranger bring that we did not already have?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137363,'Have you noticed anything strange about this gathering?','Have you noticed anything strange about this gathering?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137364,'Reveal yourself, demon.','Reveal yourself, demon.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137365,'I am trying to listen. Go away!','I am trying to listen. Go away!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137366,'Preposterous! Begone!','Preposterous! Begone!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137367,'How dare you suggest such a thing!','How dare you suggest such a thing!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137368,'Ah, you caught me. Now die!','Ah, you caught me. Now die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137369,'No, YOU\'RE a demon!','No, YOU\'RE a demon!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137370,'Very clever. Who would ever suspect a child?','Very clever. Who would ever suspect a child?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137371,'Look how many people there are! Are we going to have a party?','Look how many people there are! Are we going to have a party?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137372,'<The child seems to be crying inconsolably.>','<The child seems to be crying inconsolably.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137415,'It\'s rough out there for my riders.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137433,'The weaklings press their assault! Immortal Squadron, attack!','',0,0,0,0,0,0,406,0,0,0,0,0,26124),
(137439,'N..No! Ahh! Get back! Mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137440,'ow! OW! OW OW OW!!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137441,'Err.. no! Back! Back! Away with you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137442,'Must get... freeeeeeeeeee!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137443,'Ah he he he! All mine! Allllllll mine!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137445,'My things! Must... warn... the others...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137467,'My people lost their world to the void years ago and were scattered to the winds. I have a feeling some old friends are soon to show their faces on Argus.$b$bNot literally, of course.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137468,'Why is an ethereal traveling on a ship full of draenei?','Why is an ethereal traveling on a ship full of draenei?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137469,'You should know something, friend $r. T\'paartos did not choose $n because of your puniness.','',0,0,0,0,0,0,603,0,0,0,93791,0,26124),
(137470,'T\'paartos saw $n\'s heart on the field of battle. You are the bravest $c T\'paartos has ever seen.','',0,0,0,0,0,0,1,0,0,0,93792,0,26124),
(137471,'Other children were... not always kind to T\'paartos.','',0,0,0,0,0,0,1,0,0,0,93789,0,26124),
(137473,'Without enough power, I had to make a few... improvisations. They did not make me the grand artificer for no reason! Overloading the matrix core, refactoring the...$b$bIt matters not. What does matter is that the cannon will do its job. We will destroy the gates of Antorus and defeat the Legion.$b$bAre you ready, $n?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137474,'Fire!','Fire!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137481,'Ah he he he! What a lovely day for meeeeeee!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137503,'','<It would seem her watch has finally ended.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137507,'Curse your soul!','Curse your soul!',0,0,0,0,0,0,0,0,0,0,53433,53433,26124),
(137510,'Kill you! Take your things!','Kill you! Take your things!',0,0,0,0,0,0,0,0,0,0,53432,53432,26124),
(137511,'Yes, yes more trinkets, give them to me!','Yes, yes more trinkets, give them to me!',0,0,0,0,0,0,0,0,0,0,53431,53431,26124),
(137512,'T\'paartos remembers a place like this...','',0,0,0,0,0,0,603,0,0,0,93793,0,26124),
(137513,'T\'paartos was lost for days.','',0,0,0,0,0,0,1,0,0,0,93804,0,26124),
(137514,'Come. T\'paartos thinks he knows what little T\'paartos might do.','',0,0,0,0,0,0,25,0,0,0,93805,0,26124),
(137518,'','How\'d a runt like you get so FAT, T\'paartos?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137519,'Fatty probably doesn\'t understand the question \'cause he\'s so STUPID!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137520,'','Aww, the fat runt is crying!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137521,'Hahahaha! What a BABY!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137522,'Should we go after him?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137524,'','Nah. Let tubby go play with his frogs.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137539,'','How delightful... a snack before my main course!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137564,'The Orders are sharing their resources, and you are no longer required to research Artifact Knowledge. Together, we have researched all possible Artifact Knowledge.','The Orders are sharing their resources, and you are no longer required to research Artifact Knowledge. Together, we have researched all possible Artifact Knowledge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137565,'<View Aggramar\'s Rise.>','<View Aggramar\'s Rise.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137566,'<View the Breaking of the Pantheon.>','<View the Breaking of the Pantheon.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137567,'<View the Life-Binder\'s Plea.>','<View the Life-Binder\'s Plea.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137598,'The Orders are sharing their resources, and you are no longer required to research Artifact Knowledge. Together, we have researched all possible Artifact Knowledge.','The Orders are sharing their resources, and you are no longer required to research Artifact Knowledge. Together, we have researched all possible Artifact Knowledge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137599,'','This land has gone through many hardships in the past but the final story of this grand temple has yet to be revealed. $B$BIf you wish to relive days gone by, I can allow you to visit the past for a short time.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137600,'Show me the Peak of Serenity before the Legion attacked.','Show me the Peak of Serenity before the Legion attacked.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(137611,'I will transform you, granting you knowledge beyond imagining and might beyond measure.','',0,0,0,0,0,0,0,0,6,0,89875,0,26124),
(137612,'But they were blinded by their vanity... their hunger for power.','',0,0,0,0,0,0,0,0,6,0,89876,0,26124),
(137613,'We would be transformed not into wise leaders, but into hateful monsters.','',0,0,0,0,0,0,0,0,6,0,89877,0,26124),
(137617,'|TInterface\\Icons\\warrior_talent_icon_mastercleaver.blp:20|tSotanathor\'s axe sends out |cFFFF0000|Hspell:181498|h[Wakes of Destruction]|h|r!','|TInterface\\Icons\\warrior_talent_icon_mastercleaver.blp:20|tSotanathor\'s axe sends out |cFFFF0000|Hspell:181498|h[Wakes of Destruction]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137644,'Do you know anyone by the name \"Locus-Walker\"?','Do you know anyone by the name \"Locus-Walker\"?',0,0,0,0,0,0,0,0,0,52729,0,0,26124),
(137645,'<Vashreen makes a noise that is certainly not complimentary.>$b$bI know that a disreputable individual by that name sought me out as a financier of a project that sounded profitable, and has never repaid my investment.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137648,'','<The essence of Eonar hovers before you. You sense both relief and gratitude; but a sense of urgency and purpose cuts short the joy of victory.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137650,'Send me back to Antorus.','Send me back to Antorus.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137679,'T\'paartos loved to talk to animals. They listened and liked him.','',0,0,0,0,0,0,1,0,0,0,93788,0,26124),
(137680,'When T\'paartos was scared, he found a place to hide.','',0,0,0,0,0,0,1,0,0,0,93779,0,26124),
(137681,'T\'paartos loved to dig and find things.','',0,0,0,0,0,0,1,0,0,0,93780,0,26124),
(137682,'T\'paartos remembers a place like this one. A time he dug too deep.','',0,0,0,0,0,0,0,0,0,0,93781,0,26124),
(137683,'T\'paartos ran and ran. Got lost for days.','',0,0,0,0,0,0,0,0,0,0,93794,0,26124),
(137684,'Even shadows looked like monsters to T\'paartos.','',0,0,0,0,0,0,0,0,0,0,93795,0,26124),
(137685,'Finally, T\'paartos decided to stop being so afraid of dark and left cave.','',0,0,0,0,0,0,1,0,0,0,93796,0,26124),
(137686,'This place reminds T\'paartos of another time he went where he wasn\'t supposed to.','',0,0,0,0,0,0,1,0,0,0,93797,0,26124),
(137687,'Not all flowers were just flowers.','',0,0,0,0,0,0,1,0,0,0,93798,0,26124),
(137688,'But moving flowers not always bad! They just want to eat bugs.','',0,0,0,0,0,0,603,0,0,0,93799,0,26124),
(137698,'Yes, I want to test myself against the toughest that Argus has to offer.','Yes, I want to test myself against the toughest that Argus has to offer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137717,'|TInterface\\Icons\\SPELL_NATURE_SLEEP:20|t%s targets you with a |cFFFF0000|Hspell:254244|h[Sleep Canister]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(137723,'Bring me the eyes of every demon you can, off-worlder. I shall reward you handsomely.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137724,'Another agent pledges to serve? More eyes, more visions for the All-Seer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137725,'Scoop the eyes from demon skulls, off-worlder. I would see what they see.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137726,'Are ye ready, $p?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137727,'Every demon\'s eyes have seen a thousand worlds. Fetch them for me, that I too may see.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137729,'I\'m ready.','I\'m ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137735,'You may not enter while disguised!','You may not enter while disguised!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137738,'Intruder!','Intruder!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137739,'Heretic!','Heretic!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137740,'Interloper!','Interloper!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137741,'Traitor!','Traitor!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137786,'<Stay awhile and listen.>','<Stay awhile and listen.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137791,'This is what the Legion does to its \"allies\"...$b$bWe were right to reject their offer.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137792,'If only Oculeth were here. He would have had a field day studying this ship.$b$b...$b$bAnd probably have figured out a way to destroy it by now. You are right, probably for the best that he did not come with us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137793,'I do hope that Arluelle is keeping up her lessons. I gave her a small list of exercises to do every day.$b$bInterested? It\'s quite simple. One hundred push ups. One hundred sit ups. One hundred squats. A ten thousand, nine hundred thirty-six yard run.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137794,'The treasure is guarded by powerful magic. Only one shrouded in the right sort of power can access it.','The treasure is guarded by powerful magic. Only one shrouded in the right sort of power can access it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137795,'The spell guarding the treasure falls away as the Shroud of Arcane Echoes covers you.','The spell guarding the treasure falls away as the Shroud of Arcane Echoes covers you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137796,'Only the chosen of the Shroud may have this treasure.','Only the chosen of the Shroud may have this treasure.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137797,'I wonder how everyone is doing back in Suramar. I am sure they have everything under control.$b$bI do miss sparring with Victoire, though. She is a worthy opponent.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137798,'These lightforged draenei have spent lifetimes fighting the Legion. Perhaps even I could learn a thing or two from them.$b$bPerhaps.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137799,'<Silgryn seems to be deep in thought, as he is even more stoic and silent than usual.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137800,'','The Legion will meet its end here. The Light is with us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137801,'','Look at this, $c. A ship, powered by the Light. An army of soldiers, empowered and as long-lived as the elves. Truly a worthy force for this crusade.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137802,'','Would that I could have brought more of our blood knights. We could learn much from these warriors.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137803,'','We have sworn to defeat the Legion. One battlefield is much like any other, even if it is on a completely different world.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137804,'','I cannot believe I set foot on a different world yet again. From the worlds of Draenor and Outland to the one overtaken by the Legion where we chased down Gul\'dan and Teron\'gor, it still takes my breath away. Argus is a grim lesson that we cannot lose to the Legion.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137809,'They are growing well, considering how close we are to the Conservatory. Give it a month and they will be powerful enough to light a home for a lifetime. Another year and they can act as a sentry.$b$b<He rests a hand on a nearby crystal\'s surface. The crystal glows gently as a result.>$b$bI grow the finest crystals anywhere.','They are growing well, considering how close we are to the Conservatory. Give it a month and they will be powerful enough to light a home for a lifetime. Another year and they can act as a sentry.$b$b<She rests a hand on a nearby crystal\'s surface. The crystal glows gently as a result.>$b$bI grow the finest crystals anywhere.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137811,'I named it Flapper!','I named it Flapper!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137812,'Take him down!','Take him down!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137813,'What a move!','What a move!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137814,'Did you see that?','Did you see that?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137815,'That had to hurt.','That had to hurt.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137816,'Who do you think will win?','Who do you think will win?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137817,'Excellent!','Excellent!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137818,'What a clash!','What a clash!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137819,'The competition is fierce this year. The victor will have much to be proud of.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137820,'I would not worry too much about their heads. Only males with the thickest crests choose to compete, and these are the best Mac\'Aree has to offer.','I would not worry too much about their heads. Only males with the thickest crests choose to compete, and these are the best Mac\'Aree has to offer.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137821,'I had a hand in picking the trophy for this tournament. I think our winner will be very pleased with their prize.','I had a hand in picking the trophy for this tournament. I think our winner will be very pleased with their prize.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137822,'I have participated in a round or two of Jed\'hin in my life, but these competitors are far better than I could ever hope to be. I must admit, I am envious! Haha!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137823,'One of my men is competing. A fine fighter! He is no Champion Vorusk, but a worthy combatant in this tournament nonetheless.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137824,'They\'re so big! Boom! Crash! Pow!\n\n<Naielle animatedly mimics their motions.>','They\'re so big! Boom! Crash! Pow!\n\n<Naielle animatedly mimics their motions.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137825,'Charming little game, is it not? I like to think we must practice such a basic ritual to remind ourselves how far we have come. Argus has much to be proud of.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137831,'<He appears to be talking to himself.>\n\nPerhaps if I invert the pulse rate and direct it into a vertical pylon, I can... What am I saying? That makes no sense.','<She appears to be talking to herself.>\n\nPerhaps if I invert the pulse rate and direct it into a vertical pylon, I can... What am I saying? That makes no sense.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137832,'<He frantically turns pages in a massive tome.>\n\nHow am I ever going to memorize all of this?','<She frantically turns pages in a massive tome.>\n\nHow am I ever going to memorize all of this?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137833,'I should have become an Artificer like my mother wanted.','I should have become an Artificer like my mother wanted.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137834,'I hope I am selected to be a Wakener. Soulbinding is fascinating magic, and I get to work with Vigilants. Perhaps I can even inhabit one myself some day, like Quoram.\n\nThen again, I do like eating food... Maybe not...','I hope I am selected to be a Wakener. Soulbinding is fascinating magic, and I get to work with Vigilants. Perhaps I can even inhabit one myself some day, like Quoram.\n\nThen again, I do like eating food... Maybe not...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137835,'Do you think Aargon will let me switch to Consular? I don\'t think I\'m very good at this at all. Surely I can manage a familiar or two at least!','Do you think Aargon will let me switch to Consular? I don\'t think I\'m very good at this at all. Surely I can manage a familiar or two at least!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137836,'I am home. I have been lost for so long, stranded on a strange world with strange people... There are no words for this moment.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137837,'Long ago, the withering slaves of the Annihilan Pits held their ground in a rebellious effort to free the people of Krokuun from their bonds.$B$BThese shackles remind the inhabitants of Krokuun of the struggles endured to retain what semblance of freedom remains.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137838,'Crafted by an ancient Krokul smith, the scythe\'s markings reveal a strenuous history of battle between the Burning Legion and the Krokul.$B$BIts foggy, shale-colored blade is chipped, speckled with a darkened, dried liquid around the blade\'s edge.$B$BThe taut handle crafted from talbuk hide is well-worn, with a slight imprint of where its owner\'s grip once wielded this magnificent tool-turned-weapon into battle.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137839,'Most of the flora on Argus has long succumbed to its inevitable demise, though a once-journeyed cavern, whose location was never truly revealed, yielded this magnificent specimen.$B$BSince its arrival, the aura surrounding this mysterious plant has yet to dim below the level of a radiantly glowing crystal, once a prominent fixture among the Argussian landscape, but now only a memory of stories past.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137840,'The ink is marred from endless eons of weathering, rendering the text illegible.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137841,'Tales often echo throughout the hovel\'s porous, rocky surroundings. Whispers of brave krokul scouts - those responsible for locating survivors after the Burning Legion made their mark upon this world.$B$BOne such tale speaks of an encounter with one of the Dark One\'s fel-emblazoned demon lords whose size was only surpassed by its power to wield destruction.$B$BThis monstrous, horned skull cap is all that remains. A reminder to the Krokul people that tales often begin with eager exploration in search of hope, and often end in grievous distress and suffering, but sometimes... victory.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137842,'I cannot believe what has befallen our world.$b$bLooking out there, I see nothing but hatred. Nothing but desolation.$b$bPart of me is glad that I must stay here aboard the Vindicaar. I would not want to set hoof on that accursed ground.$b$bI have locked in coordinates below our position, close enough for you to establish the teleporter. Let me know when you have finished your preparations.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137843,'Mac\'Aree... it looks just like how I remember it. The forests, the hills, the herds of talbuk...$b$bI wonder if my old workshop is still down there. Do you think if you had a moment, you could ...?$b$bForgive me. You have much more important things to do. Let me know when you are ready to go to the surface.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137844,'I am ready, Romuul.','I am ready, Romuul.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137845,'Long after the emerald flame took our home, the Legion took to open a gate to a new world. Never had they lusted for any conquest as much as this lush, primitive land.\n\nJust as their armies set forth, a green-skinned warrior stepped through the gate. He wielded a single blade -- and roared a single cry for battle.\n\nMountains of flesh and bone grew as he carved through the demons\' ranks. His defiance drew the attention of the Dark One -- who came to see his end.\n\nThe warrior struck but one blow before he fell, but it was never forgotten.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137846,'A new world, if it can be called that.$b$bSo this is what the Legion wishes to do to Azeroth...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137847,'We are here to provide what support we can. Good luck out there, champion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137848,'What a remarkable vessel. It seems to use the crystals the draenei are so fond of to stay afloat. Perhaps we can use these crystals to store arcane powers as well?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137849,'Fel magic has permeated this entire world. It is difficult to say if there is any part of it that isn\'t corrupted.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137850,'<Aethas seems to be bothered by something.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137852,'After Illidan opened the way to Argus, I was sure that we had made a grave mistake. Now, I believe there is hope.$b$bI must believe there is hope.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137854,'The lightforged appear to be infused with the very essence of the Light. It is no wonder they have been such a powerful force against the Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137855,'One by one, we have defeated the mightiest agents of the Legion. But now we must face their true power...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137856,'I do hope the other members of the Council of Six are all right. I mean, of course they\'re going to be fine. They are all powerful archmagi! Yes. This is fine.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137858,'I have faced the Legion on Azeroth and Draenor, even witnessed their corruption seeping through the timeways.\n\nBut until the rift to Argus opened, I could never have conceived the true depths of their evil. To see how they have twisted this world...\n\nThey will do the same to Azeroth unless we stop them.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(137863,'','So many demons, so many targets...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137864,'','It is truly remarkable how much time has passed, even for an elf. Surely much has changed on Azeroth in our absence.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137870,'','The Vindicaar is truly a marvel of the Light, a symbol of what the eredar were. What the draenei still are. Although, do take note that not all of the rooms are as magnificent as this. Some of them are quite confining.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137871,'','<Alleria gives you a wry smile.>$b$bAnother beautiful day on Argus.$b$bAlthough, now that I can see our home in the sky, I am filled with hope. Returning home is no longer a dream. It is a certainty.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137872,'It is nice to see new, friendly faces. It has been so long since I have seen another $Gman:woman; from Azeroth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137873,'The Army of the Light will not rest until we have destroyed the Burning Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137874,'It is a joy beyond words to look up in the sky and see Azeroth once more. Home, so close that I feel like I can reach up and touch it.$b$bBut within the grasp of the Legion. We must stop them before we can plan on returning.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137875,'I have seen you taking an interest in our warframes, champion. They are truly fearsome instruments of war, capable of dealing and withstanding much damage. They are even capable of flight, although we need to keep a low profile to avoid attracting the attention of the Legion.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137876,'I am glad that Khadgar chose to accompany you. His is the only face among your cohort that I recognize. Has it truly been so long?$b$b<Turalyon\'s gaze shifts away from you.>$b$bHah! I can see he still hasn\'t changed. Speak his name and...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137877,'','<You catch Alleria out of the corner of your eye. She\'s looking at your bow.>',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(137904,'Watch your step, mortal.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137914,'I wouldn\'t go that way if I were you...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137915,'Some demons enjoy standing in the fire... you should try it sometime.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137916,'Don\'t mind me, just watching your every move.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137917,'Don\'t stop what you\'re doing on my account. I\'ll be right here.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137918,'So this is what passes for skill among mortals? Interesting...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137919,'Ah, I\'ve seen this before. It didn\'t work out for the last guy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137920,'Why wait for your friends? You are a strong, powerful mortal!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137921,'Oh finally, something worth watching! Go on then, entertain me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137922,'A fresh set of eyes... just what I needed.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137934,'It has been so very long since I have laid eyes on this place. The memories... overwhelm me.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137935,'What happened here, Prophet?','What happened here, Prophet?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137936,'Did you mean to do that?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137937,'Where did Thaumaturge Vashreen go with the Relinquished items?','Where did Thaumaturge Vashreen go with the Relinquished items?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137938,'','Vashreen? He mentioned something about procuring new items and relocating to the Vindicaar on Argus.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137939,'','What just happened? Did he... kill her?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137940,'I cannot believe my eyes...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137941,'','That was... unexpected. To think he had enough power to destroy her...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137942,'What will we do now?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137943,'By the Light...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137944,'<Turalyon is staring grimly at Illidan.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137945,'','Thank you for coming. I have my suspicions about these spirits here, but I will need some of their essence to learn the truth.$b$bTake this attuning crystal and use it near any spirits that seem more solid than others.$b$bBe careful, though-- they may become angered by the attuning.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137946,'<Take the Attuning Crystal.>','<Take the Attuning Crystal.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137947,'Everyone to the Vindicaar at once!','Everyone to the Vindicaar at once!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137948,'Fall back! We are no longer safe here.','Fall back! We are no longer safe here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137949,'By the Light... The demons come again! We must evacuate.','By the Light... The demons come again! We must evacuate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137950,'The camp is about to be overrun. We must get to safety!','The camp is about to be overrun. We must get to safety!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137951,'The demons approach! Everyone to the Vindicaar. Quickly!','The demons approach! Everyone to the Vindicaar. Quickly!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137952,'Demons! Inbound! Get to safety at once!','Demons! Inbound! Get to safety at once!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137953,'The Legion approaches! Seek cover!','The Legion approaches! Seek cover!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137954,'The demons come! Make haste for the Vindicaar!','The demons come! Make haste for the Vindicaar!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137955,'Weapons at the ready!','Weapons at the ready!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137956,'The demons fast approach! Prepare for battle!','The demons fast approach! Prepare for battle!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137957,'Light guide us... The demons come!','Light guide us... The demons come!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137958,'Pheta thones gamera. Here they come!','Pheta thones gamera. Here they come!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137959,'The skies will be swarming soon enough. Ready your blades!','The skies will be swarming soon enough. Ready your blades!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137960,'Defensive positions! The Legion approaches!','Defensive positions! The Legion approaches!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137961,'Demons incoming! Prepare yourselves!','Demons incoming! Prepare yourselves!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137962,'The demons approach. Hold them off as long as we can!','The demons approach. Hold them off as long as we can!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137963,'The northern skies swell with chaotic energy.','The northern skies swell with chaotic energy.',0,0,0,0,0,0,0,0,0,52240,0,0,26124),
(137964,'The demons approach. Ready your glaives!','The demons approach. Ready your glaives!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137965,'The Burning Legion approaches. Prepare yourselves.','The Burning Legion approaches. Prepare yourselves.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137966,'Stand your ground, Illidari! The demons come.','Stand your ground, Illidari! The demons come.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137967,'The demons come. Ready your blades.','The demons come. Ready your blades.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137968,'Illidari! The Burning Legion\'s presence grows near!','Illidari! The Burning Legion\'s presence grows near!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137969,'The demons swarm the skies, poised to attack. Ready yourselves for battle.','The demons swarm the skies, poised to attack. Ready yourselves for battle.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137970,'%s shimmers as it fades into its surroundings.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137971,'The Burning Legion encroaches upon our camp. Be ready.','The Burning Legion encroaches upon our camp. Be ready.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137972,'The Burning Legion comes. Ready your glaives.','The Burning Legion comes. Ready your glaives.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137973,'Illidari! Show these demons a quick death.','Illidari! Show these demons a quick death.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137974,'Help these demons meet their end.','Help these demons meet their end.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137975,'Illidari! Stand your ground! The demons will meet their end.','Illidari! Stand your ground! The demons will meet their end.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137976,'Show these demons no mercy!','Show these demons no mercy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137977,'Give these demons a swift death.','Give these demons a swift death.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137978,'Bring these demons down!','Bring these demons down!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137979,'Strike true! Show these demons no mercy!','Strike true! Show these demons no mercy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137980,'Relieve these demons of their existence!','Relieve these demons of their existence!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137989,'<Recall the events before the arrival of the Legion>','<Recall the events before the arrival of the Legion>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137990,'<Recall the events on the Broken Isles>','<Recall the events on the Broken Isles>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137991,'<Recall the events of the Tomb of Sargeras>','<Recall the events of the Tomb of Sargeras>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137992,'<Recall the events of Argus>','<Recall the events of Argus>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137994,'<Recall the journey to Argus>','<Recall the journey to Argus>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137995,'<Recall the resurrection of Xe\'ra>','<Recall the resurrection of Xe\'ra>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137996,'<Recall Alleria\'s encounter with the Dark Naruu>','<Recall Alleria\'s encounter with the Dark Naruu>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(137998,'<Think back to another time>','<Think back to another time>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(138000,'You take Hakmud home and abandon him. Hakmud sees how it is!','',0,0,0,0,0,0,0,0,1,52907,0,0,26124),
(138001,'It is not like Hakmud wanted to see his namesake or anything. Goodbye!','',0,0,0,0,0,0,0,0,1,52907,0,0,26124),
(138002,'Now everybody of Argus. Hakmud did not want to be special anyways!','',0,0,0,0,0,0,0,0,1,52907,0,0,26124),
(138003,'Hakmud never get time to relax. Not even on his own world!','',0,0,0,0,0,0,0,0,1,52907,0,0,26124),
(138004,'Are you going to just leave Hakmud here?','',0,0,0,0,0,0,0,0,1,52907,0,0,26124),
(138005,'The so-called All-Seer sends his pawns to kill me? Hah!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(138006,'My brethren hate me much as they hate you. How... convenient. Bring me their eyes that I may feast on their visions.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(138007,'|TINTERFACE\\ICONS\\INV_GIZMO_FELIRONBOMB.BLP:20|t A |cFFFF0000|Hspell:244722|h[Shock Grenade]|h|r is attached to you!','|TINTERFACE\\ICONS\\INV_GIZMO_FELIRONBOMB.BLP:20|t A |cFFFF0000|Hspell:244722|h[Shock Grenade]|h|r is attached to you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(138010,'All right, everybody... Hold on!','',0,0,0,0,0,0,1,0,6,0,90094,0,26124),
(138076,'','Well done.',0,0,0,0,0,0,0,0,0,0,0,92504,26124),
(138077,'','Most impressive.',0,0,0,0,0,0,0,0,0,0,0,92505,26124),
(138078,'','Congratulations are in order.',0,0,0,0,0,0,0,0,0,0,0,92506,26124),
(138079,'','Attack my enemy!',0,0,0,0,0,0,0,0,0,0,0,92493,26124),
(138080,'','Assist me!',0,0,0,0,0,0,0,0,0,0,0,92494,26124),
(138081,'','Strike my target!',0,0,0,0,0,0,0,0,0,0,0,92495,26124),
(138082,'','This way.',0,0,0,0,0,0,0,0,0,0,0,92629,26124),
(138083,'','I will lead you.',0,0,0,0,0,0,0,0,0,0,0,92630,26124),
(138084,'','Follow me.',0,0,0,0,0,0,0,0,0,0,0,92631,26124),
(138085,'','Heal me!',0,0,0,0,0,0,0,0,0,0,0,92637,26124),
(138086,'','I am in need of healing!',0,0,0,0,0,0,0,0,0,0,0,92638,26124),
(138087,'','Greetings.',0,0,0,0,0,0,0,0,0,0,0,92639,26124),
(138088,'','The Void calls to us.',0,0,0,0,0,0,0,0,0,0,0,92640,26124),
(138089,'','The path to power is clear.',0,0,0,0,0,0,0,0,0,0,0,92641,26124),
(138090,'','We do not fear the unknown.',0,0,0,0,0,0,0,0,0,0,0,92642,26124),
(138091,'','Retreat!',0,0,0,0,0,0,0,0,0,0,0,92626,26124),
(138092,'','Get back!',0,0,0,0,0,0,0,0,0,0,0,92627,26124),
(138093,'','Recede into shadow!',0,0,0,0,0,0,0,0,0,0,0,92628,26124),
(138094,'','Aid me!',0,0,0,0,0,0,0,0,0,0,0,92643,26124),
(138095,'','Your assistance, please!',0,0,0,0,0,0,0,0,0,0,0,92644,26124),
(138096,'','Danger approaches!',0,0,0,0,0,0,0,0,0,0,0,92645,26124),
(138097,'','My mana is low.',0,0,0,0,0,0,0,0,0,0,0,92654,26124),
(138098,'','I need more mana.',0,0,0,0,0,0,0,0,0,0,0,92655,26124),
(138099,'','Hold nothing back!',0,0,0,0,0,0,0,0,0,0,0,92652,26124),
(138100,'','Fire upon them!',0,0,0,0,0,0,0,0,0,0,0,92653,26124),
(138101,'','They say the Void hungers. Let\'s start off with a bit of nibbling.',0,0,0,0,0,0,0,0,0,0,0,91334,26124),
(138102,'','Get nice and close. Whispers are kinda my thing.',0,0,0,0,0,0,0,0,0,0,0,91335,26124),
(138103,'','Are you checking out my void form?',0,0,0,0,0,0,0,0,0,0,0,91336,26124),
(138104,'','There is a void in my heart. Have you come to fill it?',0,0,0,0,0,0,0,0,0,0,0,91337,26124),
(138105,'','Who needs the Light? It\'s so much more fun in the dark.',0,0,0,0,0,0,0,0,0,0,0,91338,26124),
(138106,'','You cannot a-void my charms.',0,0,0,0,0,0,0,0,0,0,0,91339,26124),
(138107,'','The Void isn\'t the only thing that\'s insatiable.',0,0,0,0,0,0,0,0,0,0,0,91340,26124),
(138108,'','Always remain focused.',0,0,0,0,0,0,0,0,0,0,0,92633,26124),
(138109,'','Resist the whispers.',0,0,0,0,0,0,0,0,0,0,0,92634,26124),
(138110,'','Walk in shadow.',0,0,0,0,0,0,0,0,0,0,0,92635,26124),
(138111,'','Remember Alleria\'s teachings.',0,0,0,0,0,0,0,0,0,0,0,92636,26124),
(138112,'','I do not agree.',0,0,0,0,0,0,0,0,0,0,0,92646,26124),
(138113,'','Never!',0,0,0,0,0,0,0,0,0,0,0,92647,26124),
(138114,'','No.',0,0,0,0,0,0,0,0,0,0,0,92648,26124),
(138115,'','No, we do not drink blood--that\'s the San\'layn. Totally different emo elf.',0,0,0,0,0,0,0,0,0,0,0,91341,26124),
(138116,'','First was high, then blood, and now void. Get the order right.',0,0,0,0,0,0,0,0,0,0,0,91342,26124),
(138117,'','Who does my hair? You might have heard of my stylist. It\'s called THE VOID.',0,0,0,0,0,0,0,0,0,0,0,91343,26124),
(138124,'','Gloomy? I\'m not gloomy. I just dress that way... and talk that way... and act that way.',0,0,0,0,0,0,0,0,0,0,0,91344,26124),
(138125,'','You think YOU have a dark side? Elf, please.',0,0,0,0,0,0,0,0,0,0,0,91345,26124),
(138126,'','Well, yes, technically the Void does want to consume the entire cosmos. But I\'ll settle for a smaller bite... for now.',0,0,0,0,0,0,0,0,0,0,0,91346,26124),
(138127,'','No matter how much you plead, I will not sprout tentacles or turn into a giant eyeball. Well, I might. But not because you asked.',0,0,0,0,0,0,0,0,0,0,0,91347,26124),
(138128,'','I am most grateful.',0,0,0,0,0,0,0,0,0,0,0,92656,26124),
(138129,'','Many thanks.',0,0,0,0,0,0,0,0,0,0,0,92657,26124),
(138130,'','I am in your debt.',0,0,0,0,0,0,0,0,0,0,0,92658,26124),
(138131,'','Remain here.',0,0,0,0,0,0,0,0,0,0,0,92674,26124),
(138132,'','Do not move.',0,0,0,0,0,0,0,0,0,0,0,92675,26124),
(138133,'','Yes.',0,0,0,0,0,0,0,0,0,0,0,92676,26124),
(138134,'','Correct.',0,0,0,0,0,0,0,0,0,0,0,92677,26124),
(138135,'','Acknowledged.',0,0,0,0,0,0,0,0,0,0,0,92678,26124),
(138136,'','My pleasure.',0,0,0,0,0,0,0,0,0,0,0,92679,26124),
(138137,'','Glad to help.',0,0,0,0,0,0,0,0,0,0,0,92680,26124),
(138138,'','Of course.',0,0,0,0,0,0,0,0,0,0,0,92681,26124),
(138139,'','My weapon requires both hands.',0,0,0,0,0,0,0,0,0,0,0,92507,26124),
(138140,'','I do not have that ability yet.',0,0,0,0,0,0,0,0,0,0,0,92568,26124),
(138141,'','I cannot wield that yet.',0,0,0,0,0,0,0,0,0,0,0,92569,26124),
(138142,'','That ability is not ready.',0,0,0,0,0,0,0,0,0,0,0,92508,26124),
(138143,'','I cannot do that yet.',0,0,0,0,0,0,0,0,0,0,0,92509,26124),
(138144,'','Not ready yet.',0,0,0,0,0,0,0,0,0,0,0,92510,26124),
(138145,'','That one cannot join this group.',0,0,0,0,0,0,0,0,0,0,0,92554,26124),
(138146,'','I cannot put that there.',0,0,0,0,0,0,0,0,0,0,0,92511,26124),
(138147,'','That bag is full.',0,0,0,0,0,0,0,0,0,0,0,92512,26124),
(138148,'','I cannot do that here.',0,0,0,0,0,0,0,0,0,0,0,92513,26124),
(138149,'','I cannot drop that.',0,0,0,0,0,0,0,0,0,0,0,92514,26124),
(138150,'','That is bound to me.',0,0,0,0,0,0,0,0,0,0,0,92515,26124),
(138151,'','I will never be able to equip that.',0,0,0,0,0,0,0,0,0,0,0,92520,26124),
(138152,'','I am not high enough level to use that.',0,0,0,0,0,0,0,0,0,0,0,92517,26124),
(138153,'','I cannot use that yet.',0,0,0,0,0,0,0,0,0,0,0,92518,26124),
(138154,'','My skill level is not high enough to equip that.',0,0,0,0,0,0,0,0,0,0,0,92519,26124),
(138155,'','I cannot learn that spell.',0,0,0,0,0,0,0,0,0,0,0,92521,26124),
(138156,'','I cannot trade that.',0,0,0,0,0,0,0,0,0,0,0,92527,26124),
(138157,'','I cannot use that.',0,0,0,0,0,0,0,0,0,0,0,92528,26124),
(138158,'','I cannot loot that right now.',0,0,0,0,0,0,0,0,0,0,0,92531,26124),
(138159,'','I do not have a target.',0,0,0,0,0,0,0,0,0,0,0,92532,26124),
(138160,'','I need to target something first.',0,0,0,0,0,0,0,0,0,0,0,92533,26124),
(138161,'','I require a target.',0,0,0,0,0,0,0,0,0,0,0,92534,26124),
(138162,'','I cannot do that.',0,0,0,0,0,0,0,0,0,0,0,92535,26124),
(138163,'','I need permission first.',0,0,0,0,0,0,0,0,0,0,0,92536,26124),
(138164,'','I cannot attack that target.',0,0,0,0,0,0,0,0,0,0,0,92537,26124),
(138165,'','I cannot attack that.',0,0,0,0,0,0,0,0,0,0,0,92538,26124),
(138166,'','My inventory is full.',0,0,0,0,0,0,0,0,0,0,0,92539,26124),
(138167,'','I cannot carry more.',0,0,0,0,0,0,0,0,0,0,0,92540,26124),
(138168,'','I cannot use that item yet.',0,0,0,0,0,0,0,0,0,0,0,92543,26124),
(138169,'','It is not ready yet.',0,0,0,0,0,0,0,0,0,0,0,92544,26124),
(138170,'','That item is still recharging.',0,0,0,0,0,0,0,0,0,0,0,92545,26124),
(138171,'','That is locked.',0,0,0,0,0,0,0,0,0,0,0,92541,26124),
(138172,'','I am unable to carry more of those.',0,0,0,0,0,0,0,0,0,0,0,92542,26124),
(138173,'','I cannot loot that.',0,0,0,0,0,0,0,0,0,0,0,92522,26124),
(138174,'','That is not mine to take.',0,0,0,0,0,0,0,0,0,0,0,92523,26124),
(138175,'','I need to get closer.',0,0,0,0,0,0,0,0,0,0,0,92524,26124),
(138176,'','It is too far away.',0,0,0,0,0,0,0,0,0,0,0,92525,26124),
(138177,'','I cannot reach that.',0,0,0,0,0,0,0,0,0,0,0,92526,26124),
(138178,'','That is not equipped.',0,0,0,0,0,0,0,0,0,0,0,92529,26124),
(138179,'','That must be equipped first.',0,0,0,0,0,0,0,0,0,0,0,92530,26124),
(138180,'','I am out of ammunition.',0,0,0,0,0,0,0,0,0,0,0,92555,26124),
(138181,'Not enough energy.','',0,0,0,0,0,0,0,0,0,0,92745,0,26124),
(138182,'','I lack sufficient energy.',0,0,0,0,0,0,0,0,0,0,0,92557,26124),
(138183,'','I need mana first.',0,0,0,0,0,0,0,0,0,0,0,92558,26124),
(138184,'','My mana is low.',0,0,0,0,0,0,0,0,0,0,0,92559,26124),
(138185,'','Mana is needed.',0,0,0,0,0,0,0,0,0,0,0,92560,26124),
(138186,'','Not enough rage.',0,0,0,0,0,0,0,0,0,0,0,92561,26124),
(138187,'','I must have more rage.',0,0,0,0,0,0,0,0,0,0,0,92562,26124),
(138188,'','That is not a bag.',0,0,0,0,0,0,0,0,0,0,0,92550,26124),
(138189,'','I lack the required funds.',0,0,0,0,0,0,0,0,0,0,0,92551,26124),
(138190,'','That is beyond my means.',0,0,0,0,0,0,0,0,0,0,0,92552,26124),
(138191,'','Too expensive.',0,0,0,0,0,0,0,0,0,0,0,92553,26124),
(138192,'','I cannot equip that.',0,0,0,0,0,0,0,0,0,0,0,92516,26124),
(138193,'','Too far away.',0,0,0,0,0,0,0,0,0,0,0,92563,26124),
(138194,'','I am out of range.',0,0,0,0,0,0,0,0,0,0,0,92564,26124),
(138195,'','I must get closer.',0,0,0,0,0,0,0,0,0,0,0,92565,26124),
(138196,'','We cannot invite anyone else.',0,0,0,0,0,0,0,0,0,0,0,92566,26124),
(138197,'','I cannot drink more at this time.',0,0,0,0,0,0,0,0,0,0,0,92567,26124),
(138198,'','That spell is not yet ready.',0,0,0,0,0,0,0,0,0,0,0,92570,26124),
(138199,'','I cannot cast that yet.',0,0,0,0,0,0,0,0,0,0,0,92571,26124),
(138201,'','That is recharging.',0,0,0,0,0,0,0,0,0,0,0,92572,26124),
(138215,'','<Applause sounds>',0,0,0,0,0,0,0,0,0,0,0,92659,26124),
(138216,'','Please!',0,0,0,0,0,0,0,0,0,0,0,92496,26124),
(138217,'','<Chicken sounds>',0,0,0,0,0,0,0,0,0,0,0,92663,26124),
(138218,'','<Crying sounds>',0,0,0,0,0,0,0,0,0,0,0,92664,26124),
(138219,'','<Kiss sound>',0,0,0,0,0,0,0,0,0,0,0,92667,26124),
(138220,'','<Laughing sounds>',0,0,0,0,0,0,0,0,0,0,0,92668,26124),
(138221,'','Right.',0,0,0,0,0,0,0,0,0,0,0,92649,26124),
(138222,'','A sound idea.',0,0,0,0,0,0,0,0,0,0,0,92650,26124),
(138223,'','Agreed.',0,0,0,0,0,0,0,0,0,0,0,92651,26124),
(138225,'','<Making a raspberry sound--Pfffthblth!>',0,0,0,0,0,0,0,0,0,0,0,92670,26124),
(138226,'','<Train noises--chugga chugga choo choo!>',0,0,0,0,0,0,0,0,0,0,0,92672,26124),
(138227,'','<Short cheer--Wooooo!>',0,0,0,0,0,0,0,0,0,0,0,92661,26124),
(138228,'','<Slightly longer cheer--Woohoo!>',0,0,0,0,0,0,0,0,0,0,0,92662,26124),
(138229,'','To battle!',0,0,0,0,0,0,0,0,0,0,0,92499,26124),
(138230,'','For Alleria!',0,0,0,0,0,0,0,0,0,0,0,92500,26124),
(138231,'','In shadow find strength!',0,0,0,0,0,0,0,0,0,0,0,92501,26124),
(138236,'','Our foes will fall!',0,0,0,0,0,0,0,0,0,0,0,92502,26124),
(138237,'','The whispers cannot claim us!',0,0,0,0,0,0,0,0,0,0,0,92503,26124),
(138239,'','<Roar of dominance>',0,0,0,0,0,0,0,0,0,0,0,92610,26124),
(138241,'','<Variant roar>',0,0,0,0,0,0,0,0,0,0,0,92611,26124),
(138243,'','Not enough fury.',0,0,0,0,0,0,0,0,0,0,0,92546,26124),
(138244,'','My fury is low.',0,0,0,0,0,0,0,0,0,0,0,92547,26124),
(138245,'','Not enough pain.',0,0,0,0,0,0,0,0,0,0,0,92548,26124),
(138246,'','My pain is low.',0,0,0,0,0,0,0,0,0,0,0,92549,26124),
(138251,'','For the Alliance!',0,0,0,0,0,0,0,0,0,0,0,92632,26124),
(138252,'','<Jumping off ground: Total 3>',0,0,0,0,0,0,0,0,0,0,0,92606,26124),
(138253,'','<Breathe as if you are running: Total 3>',0,0,0,0,0,0,0,0,0,0,0,92612,26124),
(138254,'','<Convey summoning power. Energy buildup: Total 5-7>',0,0,0,0,0,0,0,0,0,0,0,92594,26124),
(138255,'','<Release spell, throwing energy: Total 3-5>',0,0,0,0,0,0,0,0,0,0,0,92593,26124),
(138256,'','<Laughing>',0,0,0,0,0,0,0,0,0,0,0,92669,26124),
(138257,'','<Deep breath before focusing magic: Total 3>',0,0,0,0,0,0,0,0,0,0,0,92605,26124),
(138258,'','<Release after expending magic: Total 3>',0,0,0,0,0,0,0,0,0,0,0,92603,26124),
(138259,'','<Vocalized cheer: Total 3>',0,0,0,0,0,0,0,0,0,0,0,92613,26124),
(138260,'','<Distressed cry: Total 3>',0,0,0,0,0,0,0,0,0,0,0,92601,26124),
(138261,'','<Falling from high terrain. Impending injury or death: Total 1>',0,0,0,0,0,0,0,0,0,0,0,92604,26124),
(138262,'<Falling from high terrain. Impending injury or death: Total 1>','',0,0,0,0,0,0,0,0,0,0,92793,0,26124),
(138265,'','<Long attack with wind up. Jump attacks: Total 5-7>',0,0,0,0,0,0,0,0,0,0,0,92607,26124),
(138267,'','<Charging to attack enemy: Total 5-7>',0,0,0,0,0,0,0,0,0,0,0,92595,26124),
(138268,'','<Standard attack: Total 10>',0,0,0,0,0,0,0,0,0,0,0,92573,26124),
(138270,'','<Big attack: Total 5>',0,0,0,0,0,0,0,0,0,0,0,92583,26124),
(138271,'','<Player takes significant wound: Total 5>',0,0,0,0,0,0,0,0,0,0,0,92623,26124),
(138272,'','<Player takes a wound: Total 10>',0,0,0,0,0,0,0,0,0,0,0,92614,26124),
(138274,'','<Dying sounds: Total 5>',0,0,0,0,0,0,0,0,0,0,0,92596,26124),
(138277,'','<Convey releasing power or charging enemy: Total 4-6>',0,0,0,0,0,0,0,0,0,0,0,92590,26124),
(138284,'','<Crying sounds, variant>',0,0,0,0,0,0,0,0,0,0,0,92665,26124),
(138285,'','<Crying sounds, variant.>',0,0,0,0,0,0,0,0,0,0,0,92666,26124),
(138286,'','I ask for kindness!',0,0,0,0,0,0,0,0,0,0,0,92497,26124),
(138287,'','Have mercy!',0,0,0,0,0,0,0,0,0,0,0,92498,26124),
(138289,'','<Yawning sound>',0,0,0,0,0,0,0,0,0,0,0,92660,26124),
(138290,'','<Sighing sound>',0,0,0,0,0,0,0,0,0,0,0,92671,26124),
(138318,'Of course.','',0,0,0,0,0,0,0,0,0,0,92870,0,26124),
(138319,'Glad to help.','',0,0,0,0,0,0,0,0,0,0,92869,0,26124),
(138320,'My pleasure.','',0,0,0,0,0,0,0,0,0,0,92868,0,26124),
(138322,'Correct.','',0,0,0,0,0,0,0,0,0,0,92866,0,26124),
(138323,'Yes.','',0,0,0,0,0,0,0,0,0,0,92865,0,26124),
(138325,'Do not move.','',0,0,0,0,0,0,0,0,0,0,92864,0,26124),
(138326,'Remain here.','',0,0,0,0,0,0,0,0,0,0,92863,0,26124),
(138327,'<Train noises--chugga chugga choo choo!>','',0,0,0,0,0,0,0,0,0,0,92861,0,26124),
(138328,'I am in your debt.','',0,0,0,0,0,0,0,0,0,0,92847,0,26124),
(138329,'Many thanks.','',0,0,0,0,0,0,0,0,0,0,92846,0,26124),
(138330,'I am most grateful.','',0,0,0,0,0,0,0,0,0,0,92845,0,26124),
(138331,'<Sighing sound>','',0,0,0,0,0,0,0,0,0,0,92860,0,26124),
(138332,'<Making a raspberry sound--Pfffthblth!>','',0,0,0,0,0,0,0,0,0,0,92859,0,26124),
(138333,'I need mana.','',0,0,0,0,0,0,0,0,0,0,92844,0,26124),
(138334,'I must gain mana.','',0,0,0,0,0,0,0,0,0,0,92843,0,26124),
(138335,'Fire upon them!','',0,0,0,0,0,0,0,0,0,0,92842,0,26124),
(138336,'Hold nothing back!','',0,0,0,0,0,0,0,0,0,0,92841,0,26124),
(138337,'Agreed.','',0,0,0,0,0,0,0,0,0,0,92840,0,26124),
(138338,'A sound idea.','',0,0,0,0,0,0,0,0,0,0,92839,0,26124),
(138339,'Right.','',0,0,0,0,0,0,0,0,0,0,92838,0,26124),
(138340,'Not possible.','',0,0,0,0,0,0,0,0,0,0,92837,0,26124),
(138341,'Of course not.','',0,0,0,0,0,0,0,0,0,0,92836,0,26124),
(138342,'I disagree.','',0,0,0,0,0,0,0,0,0,0,92835,0,26124),
(138343,'<Laughing>','',0,0,0,0,0,0,0,0,0,0,92858,0,26124),
(138344,'<Laughing sounds>','',0,0,0,0,0,0,0,0,0,0,92857,0,26124),
(138345,'<Kiss sound>','',0,0,0,0,0,0,0,0,0,0,92856,0,26124),
(138346,'Danger is near.','',0,0,0,0,0,0,0,0,0,0,92834,0,26124),
(138347,'Aid me at once!','',0,0,0,0,0,0,0,0,0,0,92833,0,26124),
(138348,'I need help!','',0,0,0,0,0,0,0,0,0,0,92832,0,26124),
(138349,'The shadows are all around us.','',0,0,0,0,0,0,0,0,0,0,92831,0,26124),
(138350,'Do you come seeking power?','',0,0,0,0,0,0,0,0,0,0,92830,0,26124),
(138351,'I serve in darkness.','',0,0,0,0,0,0,0,0,0,0,92829,0,26124),
(138352,'Well met.','',0,0,0,0,0,0,0,0,0,0,92828,0,26124),
(138353,'I need healing!','',0,0,0,0,0,0,0,0,0,0,92827,0,26124),
(138354,'My wounds are great!','',0,0,0,0,0,0,0,0,0,0,92826,0,26124),
(138355,'Alleria will show us the way.','',0,0,0,0,0,0,0,0,0,0,92825,0,26124),
(138356,'May the shadows conceal you.','',0,0,0,0,0,0,0,0,0,0,92824,0,26124),
(138357,'Do not surrender your will.','',0,0,0,0,0,0,0,0,0,0,92823,0,26124),
(138358,'Do not stray from the path.','',0,0,0,0,0,0,0,0,0,0,92822,0,26124),
(138359,'<Applause sounds>','',0,0,0,0,0,0,0,0,0,0,92848,0,26124),
(138360,'Attack this target!','',0,0,0,0,0,0,0,0,0,0,92682,0,26124),
(138361,'On my target!','',0,0,0,0,0,0,0,0,0,0,92683,0,26124),
(138362,'Focus your strikes!','',0,0,0,0,0,0,0,0,0,0,92684,0,26124),
(138363,'Please!','',0,0,0,0,0,0,0,0,0,0,92685,0,26124),
(138364,'I beg you!','',0,0,0,0,0,0,0,0,0,0,92686,0,26124),
(138365,'Mercy... Mercy!','',0,0,0,0,0,0,0,0,0,0,92687,0,26124),
(138366,'<Yawning sound>','',0,0,0,0,0,0,0,0,0,0,92849,0,26124),
(138367,'To battle!','',0,0,0,0,0,0,0,0,0,0,92688,0,26124),
(138368,'For Alleria!','',0,0,0,0,0,0,0,0,0,0,92689,0,26124),
(138369,'Strike from the shadows!','',0,0,0,0,0,0,0,0,0,0,92690,0,26124),
(138370,'Bring down our foes!','',0,0,0,0,0,0,0,0,0,0,92691,0,26124),
(138371,'Our rivals will fall!','',0,0,0,0,0,0,0,0,0,0,92692,0,26124),
(138372,'<Short cheer--Wooooo!>','',0,0,0,0,0,0,0,0,0,0,92850,0,26124),
(138374,'<Slightly longer cheer--Woohoo!>','',0,0,0,0,0,0,0,0,0,0,92851,0,26124),
(138375,'<Chicken sounds>','',0,0,0,0,0,0,0,0,0,0,92852,0,26124),
(138376,'A fine job.','',0,0,0,0,0,0,0,0,0,0,92693,0,26124),
(138377,'Impressive indeed.','',0,0,0,0,0,0,0,0,0,0,92694,0,26124),
(138378,'Congratulations.','',0,0,0,0,0,0,0,0,0,0,92695,0,26124),
(138379,'<Crying sounds>','',0,0,0,0,0,0,0,0,0,0,92853,0,26124),
(138380,'<Crying sounds, variant>','',0,0,0,0,0,0,0,0,0,0,92854,0,26124),
(138381,'<Crying sounds, variant.>','',0,0,0,0,0,0,0,0,0,0,92855,0,26124),
(138382,'<Distressed cry: Total 3>','',0,0,0,0,0,0,0,0,0,0,92790,0,26124),
(138384,'My weapon requires both hands.','',0,0,0,0,0,0,0,0,0,0,92696,0,26124),
(138385,'That ability is not ready.','',0,0,0,0,0,0,0,0,0,0,92697,0,26124),
(138386,'I cannot do that yet.','',0,0,0,0,0,0,0,0,0,0,92698,0,26124),
(138387,'Not ready yet.','',0,0,0,0,0,0,0,0,0,0,92699,0,26124),
(138388,'I cannot put that there.','',0,0,0,0,0,0,0,0,0,0,92700,0,26124),
(138389,'That bag is full.','',0,0,0,0,0,0,0,0,0,0,92701,0,26124),
(138390,'I cannot do that here.','',0,0,0,0,0,0,0,0,0,0,92702,0,26124),
(138391,'I cannot drop that.','',0,0,0,0,0,0,0,0,0,0,92703,0,26124),
(138392,'That is bound to me.','',0,0,0,0,0,0,0,0,0,0,92704,0,26124),
(138393,'I cannot equip that.','',0,0,0,0,0,0,0,0,0,0,92705,0,26124),
(138394,'I am not high enough level to use that.','',0,0,0,0,0,0,0,0,0,0,92706,0,26124),
(138395,'I cannot use that yet.','',0,0,0,0,0,0,0,0,0,0,92707,0,26124),
(138396,'My skill level is not high enough to equip that.','',0,0,0,0,0,0,0,0,0,0,92708,0,26124),
(138397,'I will never be able to equip that.','',0,0,0,0,0,0,0,0,0,0,92709,0,26124),
(138398,'I cannot learn that spell.','',0,0,0,0,0,0,0,0,0,0,92710,0,26124),
(138399,'I cannot loot that.','',0,0,0,0,0,0,0,0,0,0,92711,0,26124),
(138400,'That is not mine to take.','',0,0,0,0,0,0,0,0,0,0,92712,0,26124),
(138401,'I need to get closer.','',0,0,0,0,0,0,0,0,0,0,92713,0,26124),
(138402,'It is too far away.','',0,0,0,0,0,0,0,0,0,0,92714,0,26124),
(138403,'I cannot reach that.','',0,0,0,0,0,0,0,0,0,0,92715,0,26124),
(138404,'I cannot trade that.','',0,0,0,0,0,0,0,0,0,0,92716,0,26124),
(138405,'I cannot use that.','',0,0,0,0,0,0,0,0,0,0,92717,0,26124),
(138406,'That is not equipped.','',0,0,0,0,0,0,0,0,0,0,92718,0,26124),
(138407,'That must be equipped first.','',0,0,0,0,0,0,0,0,0,0,92719,0,26124),
(138408,'I cannot loot that right now.','',0,0,0,0,0,0,0,0,0,0,92720,0,26124),
(138409,'I do not have a target.','',0,0,0,0,0,0,0,0,0,0,92721,0,26124),
(138410,'I need to target something first.','',0,0,0,0,0,0,0,0,0,0,92722,0,26124),
(138411,'I require a target.','',0,0,0,0,0,0,0,0,0,0,92723,0,26124),
(138412,'I cannot do that.','',0,0,0,0,0,0,0,0,0,0,92724,0,26124),
(138413,'I need permission first.','',0,0,0,0,0,0,0,0,0,0,92725,0,26124),
(138414,'I cannot attack that target.','',0,0,0,0,0,0,0,0,0,0,92726,0,26124),
(138415,'I cannot attack that.','',0,0,0,0,0,0,0,0,0,0,92727,0,26124),
(138416,'My inventory is full.','',0,0,0,0,0,0,0,0,0,0,92728,0,26124),
(138417,'I cannot carry more.','',0,0,0,0,0,0,0,0,0,0,92729,0,26124),
(138418,'That is locked.','',0,0,0,0,0,0,0,0,0,0,92730,0,26124),
(138419,'I am unable to carry more of those.','',0,0,0,0,0,0,0,0,0,0,92731,0,26124),
(138420,'I cannot use that item yet.','',0,0,0,0,0,0,0,0,0,0,92732,0,26124),
(138421,'It is not ready yet.','',0,0,0,0,0,0,0,0,0,0,92733,0,26124),
(138422,'For the Alliance!','',0,0,0,0,0,0,0,0,0,0,92821,0,26124),
(138423,'Follow.','',0,0,0,0,0,0,0,0,0,0,92820,0,26124),
(138424,'I will take the lead.','',0,0,0,0,0,0,0,0,0,0,92819,0,26124),
(138425,'Come this way.','',0,0,0,0,0,0,0,0,0,0,92818,0,26124),
(138440,'Acknowledged.','',0,0,0,0,0,0,0,0,0,0,92867,0,26124),
(138441,'I know what you\'re thinking... \"Oh goody, another elf.\" Well... I bet you weren\'t expecting a VOID elf, now were you?','',0,0,0,0,0,0,0,0,0,0,91356,0,26124),
(138442,'If you\'re looking for tall dark, and brooding, that\'s me. Well, dark and brooding, at least.','',0,0,0,0,0,0,0,0,0,0,91357,0,26124),
(138443,'Say what you will about the tenets of the Void. At least it\'s an ethos!','',0,0,0,0,0,0,0,0,0,0,91358,0,26124),
(138444,'Would you believe purple has always been my favorite color? Even before I went void, I mean.','',0,0,0,0,0,0,0,0,0,0,91359,0,26124),
(138445,'Alleria is my favorite Windrunner sister. Edgier than Vereesa, but slightly less homicidal than the dead one.','',0,0,0,0,0,0,0,0,0,0,91360,0,26124),
(138446,'The fact that I wield void energies doesn\'t mean I plan to consume everything I see. After all, I have a figure to maintain.','',0,0,0,0,0,0,0,0,0,0,91361,0,26124),
(138447,'Old Gods... I mean, really? Some have mouths for eyes, others have eyes for mouths. Talk about a hot mess...','',0,0,0,0,0,0,0,0,0,0,91362,0,26124),
(138452,'That item is still recharging.','',0,0,0,0,0,0,0,0,0,0,92734,0,26124),
(138453,'Not enough fury.','',0,0,0,0,0,0,0,0,0,0,92735,0,26124),
(138454,'My fury is low.','',0,0,0,0,0,0,0,0,0,0,92736,0,26124),
(138455,'Not enough pain.','',0,0,0,0,0,0,0,0,0,0,92737,0,26124),
(138456,'My pain is low.','',0,0,0,0,0,0,0,0,0,0,92738,0,26124),
(138457,'That is not a bag.','',0,0,0,0,0,0,0,0,0,0,92739,0,26124),
(138458,'I lack the required funds.','',0,0,0,0,0,0,0,0,0,0,92740,0,26124),
(138459,'That is beyond my means.','',0,0,0,0,0,0,0,0,0,0,92741,0,26124),
(138460,'Too expensive.','',0,0,0,0,0,0,0,0,0,0,92742,0,26124),
(138461,'That one cannot join this group.','',0,0,0,0,0,0,0,0,0,0,92743,0,26124),
(138462,'I am out of ammunition.','',0,0,0,0,0,0,0,0,0,0,92744,0,26124),
(138463,'I lack sufficient energy.','',0,0,0,0,0,0,0,0,0,0,92746,0,26124),
(138464,'I need mana first.','',0,0,0,0,0,0,0,0,0,0,92747,0,26124),
(138465,'My mana is low.','',0,0,0,0,0,0,0,0,0,0,92748,0,26124),
(138466,'Mana is needed.','',0,0,0,0,0,0,0,0,0,0,92749,0,26124),
(138467,'Not enough rage.','',0,0,0,0,0,0,0,0,0,0,92750,0,26124),
(138468,'I must have more rage.','',0,0,0,0,0,0,0,0,0,0,92751,0,26124),
(138469,'Too far away.','',0,0,0,0,0,0,0,0,0,0,92752,0,26124),
(138470,'I am out of range.','',0,0,0,0,0,0,0,0,0,0,92753,0,26124),
(138471,'I must get closer.','',0,0,0,0,0,0,0,0,0,0,92754,0,26124),
(138472,'We cannot invite anyone else.','',0,0,0,0,0,0,0,0,0,0,92755,0,26124),
(138473,'I cannot drink more at this time.','',0,0,0,0,0,0,0,0,0,0,92756,0,26124),
(138474,'I do not have that ability yet.','',0,0,0,0,0,0,0,0,0,0,92757,0,26124),
(138475,'I cannot wield that yet.','',0,0,0,0,0,0,0,0,0,0,92758,0,26124),
(138476,'That spell is not yet ready.','',0,0,0,0,0,0,0,0,0,0,92759,0,26124),
(138477,'I cannot cast that yet.','',0,0,0,0,0,0,0,0,0,0,92760,0,26124),
(138478,'That is recharging.','',0,0,0,0,0,0,0,0,0,0,92761,0,26124),
(138479,'<Release after expending magic: Total 3>','',0,0,0,0,0,0,0,0,0,0,92792,0,26124),
(138480,'<Deep breath before focusing magic: Total 3>','',0,0,0,0,0,0,0,0,0,0,92794,0,26124),
(138481,'<Jumping off ground: Total 3>','',0,0,0,0,0,0,0,0,0,0,92795,0,26124),
(138482,'<Breathe as if you are running: Total 3>','',0,0,0,0,0,0,0,0,0,0,92801,0,26124),
(138483,'<Vocalized cheer: Total 3>','',0,0,0,0,0,0,0,0,0,0,92802,0,26124),
(138484,'Fall back!','',0,0,0,0,0,0,0,0,0,0,92815,0,26124),
(138485,'We must retreat!','',0,0,0,0,0,0,0,0,0,0,92816,0,26124),
(138486,'Withdraw!','',0,0,0,0,0,0,0,0,0,0,92817,0,26124),
(138487,'What am I into? Let\'s just say some of my proclivities can run a bit... dark.','',0,0,0,0,0,0,0,0,0,0,91349,0,26124),
(138488,'I do my best work in the shadows. Allow me to demonstrate.','',0,0,0,0,0,0,0,0,0,0,91350,0,26124),
(138489,'The Void has taught me many secrets. Some of them can be most... satisfying.','',0,0,0,0,0,0,0,0,0,0,91351,0,26124),
(138491,'As a rule, I don\'t sprout tentacles. But in your case, I\'ll make an exception.','',0,0,0,0,0,0,0,0,0,0,91353,0,26124),
(138492,'When studying shadow magic, one learns to be flexible. Very... flexible.','',0,0,0,0,0,0,0,0,0,0,91354,0,26124),
(138493,'You sate my hunger... and I\'ll sate yours.','',0,0,0,0,0,0,0,0,0,0,91355,0,26124),
(138522,'','Silithus has ever been a magnet for ancient, malevolent powers.\n\nI could open a timeway to reveal how the Black Empire once sprawled across these sands. Or show you wars waged between mighty armies.\n\nSo much history. So much pain.\n\nBut that can wait. I believe you are here for another purpose.',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(138523,'','Silithus was a sickened land before Sargeras struck, but at least there was life within the sands.\n\nIs your business in the past complete, champion?',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(138524,'Can you show me what Silithus was like before the Wound in the World?','Can you show me what Silithus was like before the Wound in the World?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(138525,'Can you return me to the present time?','Can you return me to the present time?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(138536,'|TInterface\\ICONS\\ABILITY_WARRIOR_COLOSSUSSMASH.BLP:20|t The Garothi Worldbreaker rears back for |cFFF00000|Hspell:244969|h[Eradication]|h|r! Run away!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(138554,'T\'paartos made friends with critters. Frogs, elekk, bugs... but not snakes. Never snakes!','',0,0,0,0,0,0,1,0,0,0,93806,0,26124),
(138557,'Hmm... There...','',0,0,0,0,0,0,0,0,0,0,93802,0,26124),
(138558,'T\'paartos!','',0,0,0,0,0,0,0,0,0,0,93742,0,26124),
(138559,'We have to fight!','',0,0,0,0,0,0,0,0,0,0,93743,0,26124),
(138560,'For the Light!','',0,0,0,0,0,0,0,0,0,0,93744,0,26124),
(138561,'Face the fists of T\'paartos!','',0,0,0,0,0,0,0,0,0,0,93745,0,26124),
(138562,'You cannot stop T\'paartos!','',0,0,0,0,0,0,0,0,0,0,93746,0,26124),
(138563,'You cannot be real!','',0,0,0,0,0,0,0,0,0,0,93747,0,26124),
(138564,'T\'paartos must see this through!','',0,0,0,0,0,0,0,0,0,0,93748,0,26124),
(138565,'Time to fight!','',0,0,0,0,0,0,0,0,0,0,93749,0,26124),
(138569,'<Standard attack: Total 10>','',0,0,0,0,0,0,0,0,0,0,92762,0,26124),
(138579,'<Big attack: Total 5>','',0,0,0,0,0,0,0,0,0,0,92772,0,26124),
(138586,'<Convey releasing power or charging enemy: Total 4-6>','',0,0,0,0,0,0,0,0,0,0,92779,0,26124),
(138590,'<Release spell, throwing energy: Total 3-5>','',0,0,0,0,0,0,0,0,0,0,92782,0,26124),
(138591,'<Convey summoning power. Energy buildup: Total 5-7>','',0,0,0,0,0,0,0,0,0,0,92783,0,26124),
(138592,'<Charging to attack enemy: Total 5-7>','',0,0,0,0,0,0,0,0,0,0,92784,0,26124),
(138593,'<Dying sounds: Total 5>','',0,0,0,0,0,0,0,0,0,0,92785,0,26124),
(138598,'<Long attack with wind up. Jump attacks: Total 5-7>','',0,0,0,0,0,0,0,0,0,0,92796,0,26124),
(138600,'<Roar of dominance>','',0,0,0,0,0,0,0,0,0,0,92799,0,26124),
(138601,'<Variant roar>','',0,0,0,0,0,0,0,0,0,0,92800,0,26124),
(138602,'<Player takes a wound: Total 10>','',0,0,0,0,0,0,0,0,0,0,92803,0,26124),
(138611,'<Player takes significant wound: Total 5>','',0,0,0,0,0,0,0,0,0,0,92812,0,26124),
(138614,'','Not enough energy.',0,0,0,0,0,0,0,0,0,0,0,92556,26124),
(138616,'','<Changes from normal skin into cosmic purple power skin. Should sound like a forbidden incantation, chant/murmur invoking dark powers. Not painful or stressful: Total 3-5>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(138617,'<Changes from normal skin into cosmic purple power skin. Should sound like a forbidden incantation, chant/murmur invoking dark powers. Not painful or stressful: Total 3-5>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(138708,'','Mama? Mama! Why is it so dark? It\'s scary here...',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(138710,'','C-c-cold...',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(138711,'','Can anybody hear me?',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(138712,'','Hello? Who\'s there? I heard you!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(138713,'','Ack! A monster!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(138714,'','Are you sad too? Are you lost like me?',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(138726,'I fear this may be the end of me...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(138778,'|TInterface\\Icons\\SPELL_FIRE_FELFIREWARD.BLP:20|tKin\'garoth begins to channel  |cFFFF0000|Hspell:246516|h[Apocalypse Protocol]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(138780,'|TInterface\\Icons\\SPELL_FIRE_FELIMMOLATION.BLP:20|tKin\'garoth is about to activate |cFFFF0000|Hspell:248061|h[Purging Protocol]|h|r! Get out!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(138835,'','When you wish to return to Silithus as it appears in the present, you have but to ask.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(138838,'','We must continue to stand together, $n. We must not let the dark times divide us.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(138839,'','Though I cannot abide the actions of your warchief, $r, we must fight together to save our world.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(138840,'Illidan requested that I bring this crystal to you.','Illidan requested that I bring this crystal to you.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(138842,'The world cries out to us, $n. We must fight to save it.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(138871,'','I cannot wield that yet.',0,0,0,0,0,0,0,0,0,0,0,91442,26124),
(138872,'','I do not have that ability yet.',0,0,0,0,0,0,0,0,0,0,0,91441,26124),
(138873,'','My weapon requires both hands.',0,0,0,0,0,0,0,0,0,0,0,91380,26124),
(138874,'','Not ready yet.',0,0,0,0,0,0,0,0,0,0,0,91383,26124),
(138875,'','I cannot do that yet.',0,0,0,0,0,0,0,0,0,0,0,91382,26124),
(138876,'','That ability is not ready.',0,0,0,0,0,0,0,0,0,0,0,91381,26124),
(138877,'','I cannot do that here.',0,0,0,0,0,0,0,0,0,0,0,91386,26124),
(138878,'','That bag is full.',0,0,0,0,0,0,0,0,0,0,0,91385,26124),
(138879,'','I cannot put that there.',0,0,0,0,0,0,0,0,0,0,0,91384,26124),
(138880,'','That one cannot join this group.',0,0,0,0,0,0,0,0,0,0,0,91427,26124),
(138881,'','I cannot use that yet.',0,0,0,0,0,0,0,0,0,0,0,91391,26124),
(138882,'','I am not high enough level to use that.',0,0,0,0,0,0,0,0,0,0,0,91390,26124),
(138883,'','I will never be able to equip that.',0,0,0,0,0,0,0,0,0,0,0,91393,26124),
(138884,'','That is bound to me.',0,0,0,0,0,0,0,0,0,0,0,91388,26124),
(138885,'','I cannot drop that.',0,0,0,0,0,0,0,0,0,0,0,91387,26124),
(138886,'','I cannot use that.',0,0,0,0,0,0,0,0,0,0,0,91401,26124),
(138887,'','I cannot trade that.',0,0,0,0,0,0,0,0,0,0,0,91400,26124),
(138888,'','I cannot learn that spell.',0,0,0,0,0,0,0,0,0,0,0,91394,26124),
(138889,'','My skill level is not high enough to equip that.',0,0,0,0,0,0,0,0,0,0,0,91392,26124),
(138890,'','I require a target.',0,0,0,0,0,0,0,0,0,0,0,91407,26124),
(138891,'','I need to target something first.',0,0,0,0,0,0,0,0,0,0,0,91406,26124),
(138892,'','I do not have a target.',0,0,0,0,0,0,0,0,0,0,0,91405,26124),
(138893,'','I cannot loot that right now.',0,0,0,0,0,0,0,0,0,0,0,91404,26124),
(138894,'','I cannot attack that.',0,0,0,0,0,0,0,0,0,0,0,91411,26124),
(138895,'','I cannot attack that target.',0,0,0,0,0,0,0,0,0,0,0,91410,26124),
(138896,'','I need permission first.',0,0,0,0,0,0,0,0,0,0,0,91409,26124),
(138897,'','I cannot do that.',0,0,0,0,0,0,0,0,0,0,0,91408,26124),
(138898,'','That item is still recharging.',0,0,0,0,0,0,0,0,0,0,0,91418,26124),
(138899,'','It is not ready yet.',0,0,0,0,0,0,0,0,0,0,0,91417,26124),
(138900,'','I cannot use that item yet.',0,0,0,0,0,0,0,0,0,0,0,91416,26124),
(138901,'','I cannot carry more.',0,0,0,0,0,0,0,0,0,0,0,91413,26124),
(138902,'','My inventory is full.',0,0,0,0,0,0,0,0,0,0,0,91412,26124),
(138903,'','That is not mine to take.',0,0,0,0,0,0,0,0,0,0,0,91396,26124),
(138904,'','I cannot loot that.',0,0,0,0,0,0,0,0,0,0,0,91395,26124),
(138905,'','I am unable to carry more of those.',0,0,0,0,0,0,0,0,0,0,0,91415,26124),
(138906,'','That is locked.',0,0,0,0,0,0,0,0,0,0,0,91414,26124),
(138907,'','That must be equipped first.',0,0,0,0,0,0,0,0,0,0,0,91403,26124),
(138908,'','That is not equipped.',0,0,0,0,0,0,0,0,0,0,0,91402,26124),
(138909,'','I cannot reach that.',0,0,0,0,0,0,0,0,0,0,0,91399,26124),
(138910,'','It is too far away.',0,0,0,0,0,0,0,0,0,0,0,91398,26124),
(138911,'','I need to get closer.',0,0,0,0,0,0,0,0,0,0,0,91397,26124),
(138912,'','Mana is needed.',0,0,0,0,0,0,0,0,0,0,0,91433,26124),
(138913,'','My mana is low.',0,0,0,0,0,0,0,0,0,0,0,91432,26124),
(138914,'','I need mana first.',0,0,0,0,0,0,0,0,0,0,0,91431,26124),
(138915,'','I lack sufficient energy.',0,0,0,0,0,0,0,0,0,0,0,91430,26124),
(138916,'','I am out of ammunition.',0,0,0,0,0,0,0,0,0,0,0,91428,26124),
(138917,'','That is not a bag.',0,0,0,0,0,0,0,0,0,0,0,91423,26124),
(138918,'','I must have more rage.',0,0,0,0,0,0,0,0,0,0,0,91435,26124),
(138919,'','Not enough rage.',0,0,0,0,0,0,0,0,0,0,0,91434,26124),
(138920,'','I cannot equip that.',0,0,0,0,0,0,0,0,0,0,0,91389,26124),
(138921,'','Too expensive.',0,0,0,0,0,0,0,0,0,0,0,91426,26124),
(138922,'','That is beyond my means.',0,0,0,0,0,0,0,0,0,0,0,91425,26124),
(138923,'','I lack the required funds.',0,0,0,0,0,0,0,0,0,0,0,91424,26124),
(138924,'','Not enough energy.',0,0,0,0,0,0,0,0,0,0,0,91429,26124),
(138925,'','Too far away.',0,0,0,0,0,0,0,0,0,0,0,91436,26124),
(138926,'','I cannot drink more at this time.',0,0,0,0,0,0,0,0,0,0,0,91440,26124),
(138927,'','We cannot invite anyone else.',0,0,0,0,0,0,0,0,0,0,0,91439,26124),
(138928,'','I must get closer.',0,0,0,0,0,0,0,0,0,0,0,91438,26124),
(138929,'','I am out of range.',0,0,0,0,0,0,0,0,0,0,0,91437,26124),
(138930,'','That is recharging.',0,0,0,0,0,0,0,0,0,0,0,91445,26124),
(138931,'','I cannot cast that yet.',0,0,0,0,0,0,0,0,0,0,0,91444,26124),
(138932,'','That spell is not yet ready.',0,0,0,0,0,0,0,0,0,0,0,91443,26124),
(138933,'','<Laughing sounds>',0,0,0,0,0,0,0,0,0,0,0,91539,26124),
(138934,'','<Kiss sound>',0,0,0,0,0,0,0,0,0,0,0,91538,26124),
(138935,'','<Crying sounds>',0,0,0,0,0,0,0,0,0,0,0,91535,26124),
(138936,'','<Chicken sounds>',0,0,0,0,0,0,0,0,0,0,0,91534,26124),
(138937,'','Please!',0,0,0,0,0,0,0,0,0,0,0,91369,26124),
(138938,'','<Applause sounds>',0,0,0,0,0,0,0,0,0,0,0,91530,26124),
(138939,'','Indeed.',0,0,0,0,0,0,0,0,0,0,0,91522,26124),
(138940,'','Just so.',0,0,0,0,0,0,0,0,0,0,0,91521,26124),
(138941,'','Right.',0,0,0,0,0,0,0,0,0,0,0,91520,26124),
(138942,'','<Slightly longer cheer--Woohoo!>',0,0,0,0,0,0,0,0,0,0,0,91533,26124),
(138943,'','<Short cheer--Wooooo!>',0,0,0,0,0,0,0,0,0,0,0,91532,26124),
(138944,'','<Train noises--chugga chugga choo choo!>',0,0,0,0,0,0,0,0,0,0,0,91543,26124),
(138945,'','<Making a raspberry sound--Pfffthblth!>',0,0,0,0,0,0,0,0,0,0,0,91541,26124),
(138946,'','For Highmountain!',0,0,0,0,0,0,0,0,0,0,0,91376,26124),
(138948,'','To victory!',0,0,0,0,0,0,0,0,0,0,0,91375,26124),
(138949,'','For river! For sky! For earth!',0,0,0,0,0,0,0,0,0,0,0,91374,26124),
(138950,'','Attack!',0,0,0,0,0,0,0,0,0,0,0,91373,26124),
(138951,'','To arms!',0,0,0,0,0,0,0,0,0,0,0,91372,26124),
(138952,'','<Variant roar>',0,0,0,0,0,0,0,0,0,0,0,91482,26124),
(138953,'','<Roar of dominance>',0,0,0,0,0,0,0,0,0,0,0,91481,26124),
(138954,'','My pain is low.',0,0,0,0,0,0,0,0,0,0,0,91422,26124),
(138955,'','Not enough pain.',0,0,0,0,0,0,0,0,0,0,0,91421,26124),
(138956,'','My fury is low.',0,0,0,0,0,0,0,0,0,0,0,91420,26124),
(138957,'','Not enough fury.',0,0,0,0,0,0,0,0,0,0,0,91419,26124),
(138960,'','For the Horde!',0,0,0,0,0,0,0,0,0,0,0,91503,26124),
(138961,'','<Laughing>',0,0,0,0,0,0,0,0,0,0,0,91540,26124),
(138962,'','<Release spell, throwing energy: Total 3-5>',0,0,0,0,0,0,0,0,0,0,0,91466,26124),
(138963,'','<Convey summoning power. Energy buildup: Total 5-7>',0,0,0,0,0,0,0,0,0,0,0,91467,26124),
(138964,'','<Breathe as if you are running: Total 3>',0,0,0,0,0,0,0,0,0,0,0,91483,26124),
(138965,'','<Jumping off ground: Total 3>',0,0,0,0,0,0,0,0,0,0,0,91478,26124),
(138966,'','<Falling from high terrain. Impending injury or death: Total 1>',0,0,0,0,0,0,0,0,0,0,0,91476,26124),
(138967,'','<Distressed cry: Total 3>',0,0,0,0,0,0,0,0,0,0,0,91474,26124),
(138968,'','<Vocalized cheer: Total 3>',0,0,0,0,0,0,0,0,0,0,0,91484,26124),
(138969,'','<Release after expending magic: Total 3>',0,0,0,0,0,0,0,0,0,0,0,91475,26124),
(138970,'','<Deep breath before focusing magic: Total 3>',0,0,0,0,0,0,0,0,0,0,0,91477,26124),
(138972,'','<Standard attack: Total 10>',0,0,0,0,0,0,0,0,0,0,0,91446,26124),
(138973,'','<Charging to attack enemy: Total 5-7>',0,0,0,0,0,0,0,0,0,0,0,91468,26124),
(138975,'','<Long attack with wind up. Jump attacks: Total 5-7>',0,0,0,0,0,0,0,0,0,0,0,91479,26124),
(138977,'','<Player takes a wound: Total 10>',0,0,0,0,0,0,0,0,0,0,0,91485,26124),
(138978,'','<Player takes significant wound: Total 5>',0,0,0,0,0,0,0,0,0,0,0,91494,26124),
(138979,'','<Big attack: Total 5>',0,0,0,0,0,0,0,0,0,0,0,91456,26124),
(138980,'','<Convey releasing power or charging enemy: Total 4-6>',0,0,0,0,0,0,0,0,0,0,0,91463,26124),
(138983,'','<Dying sounds: Total 5>',0,0,0,0,0,0,0,0,0,0,0,91469,26124),
(138984,'','<Crying sounds, variant.>',0,0,0,0,0,0,0,0,0,0,0,91537,26124),
(138985,'','<Crying sounds, variant>',0,0,0,0,0,0,0,0,0,0,0,91536,26124),
(138986,'','Show mercy!',0,0,0,0,0,0,0,0,0,0,0,91371,26124),
(138987,'','Won\'t you help?',0,0,0,0,0,0,0,0,0,0,0,91370,26124),
(138992,'','<Sighing sound>',0,0,0,0,0,0,0,0,0,0,0,91542,26124),
(138993,'','<Yawning sound>',0,0,0,0,0,0,0,0,0,0,0,91531,26124),
(139019,'','Attack my enemy!',0,0,0,0,0,0,0,0,0,0,0,91366,26124),
(139020,'','Strike this one!',0,0,0,0,0,0,0,0,0,0,0,91367,26124),
(139021,'','On my target!',0,0,0,0,0,0,0,0,0,0,0,91368,26124),
(139022,'','Nicely done.',0,0,0,0,0,0,0,0,0,0,0,91377,26124),
(139023,'','Impressive indeed.',0,0,0,0,0,0,0,0,0,0,0,91378,26124),
(139024,'','You deserve praise.',0,0,0,0,0,0,0,0,0,0,0,91379,26124),
(139028,'','Get to safety!',0,0,0,0,0,0,0,0,0,0,0,91497,26124),
(139030,'','Get out of here!',0,0,0,0,0,0,0,0,0,0,0,91498,26124),
(139031,'','Seek cover!',0,0,0,0,0,0,0,0,0,0,0,91499,26124),
(139032,'','Follow.',0,0,0,0,0,0,0,0,0,0,0,91500,26124),
(139033,'','Let me lead.',0,0,0,0,0,0,0,0,0,0,0,91501,26124),
(139034,'You are with me.','',0,0,0,0,0,0,0,0,0,0,91691,0,26124),
(139035,'','Sun and moon light your way.',0,0,0,0,0,0,0,0,0,0,0,91504,26124),
(139036,'','Go with blessings.',0,0,0,0,0,0,0,0,0,0,0,91505,26124),
(139037,'','May you hunt well.',0,0,0,0,0,0,0,0,0,0,0,91506,26124),
(139038,'','Remember the Earthmother\'s lessons.',0,0,0,0,0,0,0,0,0,0,0,91507,26124),
(139039,'','Heal me!',0,0,0,0,0,0,0,0,0,0,0,91508,26124),
(139040,'','I need healing!',0,0,0,0,0,0,0,0,0,0,0,91509,26124),
(139041,'','I am honored to greet you.',0,0,0,0,0,0,0,0,0,0,0,91510,26124),
(139042,'','Warm greetings to you.',0,0,0,0,0,0,0,0,0,0,0,91511,26124),
(139044,'','Peace and patience, friend.',0,0,0,0,0,0,0,0,0,0,0,91512,26124),
(139045,'','We will not fear the darkness.',0,0,0,0,0,0,0,0,0,0,0,91513,26124),
(139046,'','Help!',0,0,0,0,0,0,0,0,0,0,0,91514,26124),
(139047,'','I require aid!',0,0,0,0,0,0,0,0,0,0,0,91515,26124),
(139048,'','The enemy comes!',0,0,0,0,0,0,0,0,0,0,0,91516,26124),
(139049,'','I must disagree.',0,0,0,0,0,0,0,0,0,0,0,91517,26124),
(139050,'','No chance!',0,0,0,0,0,0,0,0,0,0,0,91518,26124),
(139051,'','Just... no.',0,0,0,0,0,0,0,0,0,0,0,91519,26124),
(139052,'Fire all weapons!','',0,0,0,0,0,0,0,0,0,0,92088,0,26124),
(139053,'','Bombard them!',0,0,0,0,0,0,0,0,0,0,0,91524,26124),
(139054,'','Mana is needed.',0,0,0,0,0,0,0,0,0,0,0,91525,26124),
(139055,'','I require mana.',0,0,0,0,0,0,0,0,0,0,0,91526,26124),
(139057,'','Do not leave.',0,0,0,0,0,0,0,0,0,0,0,91545,26124),
(139059,'','Hold this spot.',0,0,0,0,0,0,0,0,0,0,0,91546,26124),
(139074,'','A thousand thanks.',0,0,0,0,0,0,0,0,0,0,0,91527,26124),
(139075,'','I am grateful.',0,0,0,0,0,0,0,0,0,0,0,91528,26124),
(139076,'','I owe you a debt.',0,0,0,0,0,0,0,0,0,0,0,91529,26124),
(139081,'','Yes.',0,0,0,0,0,0,0,0,0,0,0,91547,26124),
(139082,'','Correct.',0,0,0,0,0,0,0,0,0,0,0,91548,26124),
(139083,'','It is so.',0,0,0,0,0,0,0,0,0,0,0,91549,26124),
(139084,'','You are welcome.',0,0,0,0,0,0,0,0,0,0,0,91550,26124),
(139085,'','A pleasure.',0,0,0,0,0,0,0,0,0,0,0,91551,26124),
(139086,'','But of course.',0,0,0,0,0,0,0,0,0,0,0,91552,26124),
(139087,'<Applause sounds>','',0,0,0,0,0,0,0,0,0,0,91719,0,26124),
(139089,'Strike at my enemy!','',0,0,0,0,0,0,0,0,0,0,91555,0,26124),
(139090,'Here! This target!','',0,0,0,0,0,0,0,0,0,0,91556,0,26124),
(139092,'Focus on this target!','',0,0,0,0,0,0,0,0,0,0,91557,0,26124),
(139094,'Please!','',0,0,0,0,0,0,0,0,0,0,91558,0,26124),
(139095,'I implore you!','',0,0,0,0,0,0,0,0,0,0,91559,0,26124),
(139096,'Mercy, great one!','',0,0,0,0,0,0,0,0,0,0,91560,0,26124),
(139098,'<Yawning sound>','',0,0,0,0,0,0,0,0,0,0,91720,0,26124),
(139099,'The battle begins!','',0,0,0,0,0,0,0,0,0,0,91561,0,26124),
(139100,'Now! Attack!','',0,0,0,0,0,0,0,0,0,0,91562,0,26124),
(139101,'For the mountain!','',0,0,0,0,0,0,0,0,0,0,91563,0,26124),
(139102,'Never yield!','',0,0,0,0,0,0,0,0,0,0,91564,0,26124),
(139103,'Charge!','',0,0,0,0,0,0,0,0,0,0,91565,0,26124),
(139104,'<Short cheer--Wooooo!>','',0,0,0,0,0,0,0,0,0,0,91721,0,26124),
(139105,'<Slightly longer cheer--Woohoo!>','',0,0,0,0,0,0,0,0,0,0,91722,0,26124),
(139106,'<Chicken sounds>','',0,0,0,0,0,0,0,0,0,0,91723,0,26124),
(139107,'Job well done.','',0,0,0,0,0,0,0,0,0,0,91566,0,26124),
(139108,'I am impressed.','',0,0,0,0,0,0,0,0,0,0,91567,0,26124),
(139109,'Well deserved.','',0,0,0,0,0,0,0,0,0,0,91568,0,26124),
(139110,'<Crying sounds>','',0,0,0,0,0,0,0,0,0,0,91724,0,26124),
(139111,'<Crying sounds, variant>','',0,0,0,0,0,0,0,0,0,0,91725,0,26124),
(139112,'<Crying sounds, variant.>','',0,0,0,0,0,0,0,0,0,0,91726,0,26124),
(139114,'My weapon requires both hands.','',0,0,0,0,0,0,0,0,0,0,91569,0,26124),
(139115,'That ability is not ready.','',0,0,0,0,0,0,0,0,0,0,91570,0,26124),
(139116,'I cannot do that yet.','',0,0,0,0,0,0,0,0,0,0,91571,0,26124),
(139117,'Not ready yet.','',0,0,0,0,0,0,0,0,0,0,91572,0,26124),
(139118,'I cannot put that there.','',0,0,0,0,0,0,0,0,0,0,91573,0,26124),
(139119,'That bag is full.','',0,0,0,0,0,0,0,0,0,0,91574,0,26124),
(139120,'I cannot do that here.','',0,0,0,0,0,0,0,0,0,0,91575,0,26124),
(139121,'I cannot drop that.','',0,0,0,0,0,0,0,0,0,0,91576,0,26124),
(139122,'That is bound to me.','',0,0,0,0,0,0,0,0,0,0,91577,0,26124),
(139123,'I cannot equip that.','',0,0,0,0,0,0,0,0,0,0,91578,0,26124),
(139124,'I am not high enough level to use that.','',0,0,0,0,0,0,0,0,0,0,91579,0,26124),
(139125,'I cannot use that yet.','',0,0,0,0,0,0,0,0,0,0,91580,0,26124),
(139126,'My skill level is not high enough to equip that.','',0,0,0,0,0,0,0,0,0,0,91581,0,26124),
(139127,'I will never be able to equip that.','',0,0,0,0,0,0,0,0,0,0,91582,0,26124),
(139128,'I cannot learn that spell.','',0,0,0,0,0,0,0,0,0,0,91583,0,26124),
(139129,'I cannot loot that.','',0,0,0,0,0,0,0,0,0,0,91584,0,26124),
(139130,'That is not mine to take.','',0,0,0,0,0,0,0,0,0,0,91585,0,26124),
(139131,'I need to get closer.','',0,0,0,0,0,0,0,0,0,0,91586,0,26124),
(139132,'It is too far away.','',0,0,0,0,0,0,0,0,0,0,91587,0,26124),
(139133,'I cannot reach that.','',0,0,0,0,0,0,0,0,0,0,91588,0,26124),
(139134,'I cannot trade that.','',0,0,0,0,0,0,0,0,0,0,91589,0,26124),
(139135,'I cannot use that.','',0,0,0,0,0,0,0,0,0,0,91590,0,26124),
(139136,'That is not equipped.','',0,0,0,0,0,0,0,0,0,0,91591,0,26124),
(139137,'That must be equipped first.','',0,0,0,0,0,0,0,0,0,0,91592,0,26124),
(139138,'I cannot loot that right now.','',0,0,0,0,0,0,0,0,0,0,91593,0,26124),
(139139,'I do not have a target.','',0,0,0,0,0,0,0,0,0,0,91594,0,26124),
(139140,'I need to target something first.','',0,0,0,0,0,0,0,0,0,0,91595,0,26124),
(139141,'I require a target.','',0,0,0,0,0,0,0,0,0,0,91596,0,26124),
(139142,'I cannot do that.','',0,0,0,0,0,0,0,0,0,0,91597,0,26124),
(139143,'I need permission first.','',0,0,0,0,0,0,0,0,0,0,91598,0,26124),
(139144,'I cannot attack that target.','',0,0,0,0,0,0,0,0,0,0,91599,0,26124),
(139145,'I cannot attack that.','',0,0,0,0,0,0,0,0,0,0,91600,0,26124),
(139146,'My inventory is full.','',0,0,0,0,0,0,0,0,0,0,91601,0,26124),
(139147,'I cannot carry more.','',0,0,0,0,0,0,0,0,0,0,91602,0,26124),
(139148,'That is locked.','',0,0,0,0,0,0,0,0,0,0,91603,0,26124),
(139149,'I am unable to carry more of those.','',0,0,0,0,0,0,0,0,0,0,91604,0,26124),
(139150,'I cannot use that item yet.','',0,0,0,0,0,0,0,0,0,0,91605,0,26124),
(139151,'It is not ready yet.','',0,0,0,0,0,0,0,0,0,0,91606,0,26124),
(139152,'That item is still recharging.','',0,0,0,0,0,0,0,0,0,0,91607,0,26124),
(139153,'Not enough fury.','',0,0,0,0,0,0,0,0,0,0,91608,0,26124),
(139154,'My fury is low.','',0,0,0,0,0,0,0,0,0,0,91609,0,26124),
(139155,'Not enough pain.','',0,0,0,0,0,0,0,0,0,0,91610,0,26124),
(139156,'My pain is low.','',0,0,0,0,0,0,0,0,0,0,91611,0,26124),
(139157,'That is not a bag.','',0,0,0,0,0,0,0,0,0,0,91612,0,26124),
(139158,'I lack the required funds.','',0,0,0,0,0,0,0,0,0,0,91613,0,26124),
(139159,'That is beyond my means.','',0,0,0,0,0,0,0,0,0,0,91614,0,26124),
(139160,'Too expensive.','',0,0,0,0,0,0,0,0,0,0,91615,0,26124),
(139161,'That one cannot join this group.','',0,0,0,0,0,0,0,0,0,0,91616,0,26124),
(139170,'I am out of ammunition.','',0,0,0,0,0,0,0,0,0,0,91617,0,26124),
(139171,'Not enough energy.','',0,0,0,0,0,0,0,0,0,0,91618,0,26124),
(139172,'I lack sufficient energy.','',0,0,0,0,0,0,0,0,0,0,91619,0,26124),
(139173,'I need mana first.','',0,0,0,0,0,0,0,0,0,0,91620,0,26124),
(139174,'My mana is low.','',0,0,0,0,0,0,0,0,0,0,91621,0,26124),
(139175,'Mana is needed.','',0,0,0,0,0,0,0,0,0,0,91622,0,26124),
(139176,'Not enough rage.','',0,0,0,0,0,0,0,0,0,0,91623,0,26124),
(139177,'I must have more rage.','',0,0,0,0,0,0,0,0,0,0,91624,0,26124),
(139178,'Too far away.','',0,0,0,0,0,0,0,0,0,0,91625,0,26124),
(139179,'I am out of range.','',0,0,0,0,0,0,0,0,0,0,91626,0,26124),
(139180,'I must get closer.','',0,0,0,0,0,0,0,0,0,0,91627,0,26124),
(139181,'We cannot invite anyone else.','',0,0,0,0,0,0,0,0,0,0,91628,0,26124),
(139182,'I cannot drink more at this time.','',0,0,0,0,0,0,0,0,0,0,91629,0,26124),
(139183,'I do not have that ability yet.','',0,0,0,0,0,0,0,0,0,0,91630,0,26124),
(139184,'I cannot wield that yet.','',0,0,0,0,0,0,0,0,0,0,91631,0,26124),
(139185,'That spell is not yet ready.','',0,0,0,0,0,0,0,0,0,0,91632,0,26124),
(139186,'I cannot cast that yet.','',0,0,0,0,0,0,0,0,0,0,91633,0,26124),
(139187,'That is recharging.','',0,0,0,0,0,0,0,0,0,0,91634,0,26124),
(139188,'<Standard attack: Total 10>','',0,0,0,0,0,0,0,0,0,0,91635,0,26124),
(139199,'<Big attack: Total 5>','',0,0,0,0,0,0,0,0,0,0,91645,0,26124),
(139208,'<Convey releasing power or charging enemy: Total 4-6>','',0,0,0,0,0,0,0,0,0,0,91653,0,26124),
(139211,'<Convey summoning power. Energy buildup: Total 3-5>','',0,0,0,0,0,0,0,0,0,0,91656,0,26124),
(139212,'<Charging to attack enemy: Total 5-7>','',0,0,0,0,0,0,0,0,0,0,91657,0,26124),
(139213,'<Dying sounds: Total 5>','',0,0,0,0,0,0,0,0,0,0,91658,0,26124),
(139218,'<Release after expending magic: Total 3>','',0,0,0,0,0,0,0,0,0,0,91664,0,26124),
(139219,'<Falling from high terrain. Impending injury or death: Total 1>','',0,0,0,0,0,0,0,0,0,0,91665,0,26124),
(139220,'<Deep breath before focusing magic: Total 3>','',0,0,0,0,0,0,0,0,0,0,91666,0,26124),
(139221,'<Jumping off ground: Total 3>','',0,0,0,0,0,0,0,0,0,0,91667,0,26124),
(139222,'<Long attack with wind up. Jump attacks: Total 5-7>','',0,0,0,0,0,0,0,0,0,0,91668,0,26124),
(139224,'<Roar of dominance>','',0,0,0,0,0,0,0,0,0,0,91670,0,26124),
(139225,'<Variant roar>','',0,0,0,0,0,0,0,0,0,0,91671,0,26124),
(139226,'<Breathe as if you are running: Total 3>','',0,0,0,0,0,0,0,0,0,0,91672,0,26124),
(139227,'<Vocalized cheer: Total 3>','',0,0,0,0,0,0,0,0,0,0,91673,0,26124),
(139228,'<Player takes a wound: Total 10>','',0,0,0,0,0,0,0,0,0,0,91674,0,26124),
(139237,'<Player takes significant wound: Total 5>','',0,0,0,0,0,0,0,0,0,0,91683,0,26124),
(139242,'Time to flee!','',0,0,0,0,0,0,0,0,0,0,91686,0,26124),
(139243,'Sound the retreat!','',0,0,0,0,0,0,0,0,0,0,91687,0,26124),
(139244,'We must escape!','',0,0,0,0,0,0,0,0,0,0,91688,0,26124),
(139245,'Follow me.','',0,0,0,0,0,0,0,0,0,0,91689,0,26124),
(139246,'I will take the lead.','',0,0,0,0,0,0,0,0,0,0,91690,0,26124),
(139256,'Tyrande... Long ago, you trusted me enough to defy Malfurion\'s wishes and free me from my prison.','',0,0,0,0,0,0,1,0,0,0,90792,0,26124),
(139257,'But over time, that faith was lost. And like my brother, you came to believe that the choices I made had driven me to darkness.','',0,0,0,0,0,0,1,0,0,0,90793,0,26124),
(139258,'Know that every path I took led toward a single purpose: saving our world. I could abide no half measures. No compromise.','',0,0,0,0,0,0,1,0,0,0,90794,0,26124),
(139259,'At those times when I faced doubt, I held true to one constant. One anchor. You.','',0,0,0,0,0,0,1,0,0,0,90795,0,26124),
(139260,'You have always embodied the best of Azeroth, Tyrande. Your faith. Your devotion. Through the darkest times, my belief in you never wavered.','',0,0,0,0,0,0,0,0,0,0,90796,0,26124),
(139261,'My fate, my duty, are now clear to me. I leave Azeroth\'s defense to you... and to my brother.','',0,0,0,0,0,0,1,0,0,0,90797,0,26124),
(139262,'Take care of him, Tyrande. Though at times I wished your heart had made a different choice, in the end... I know it made the right one.','',0,0,0,0,0,0,1,0,0,0,90798,0,26124),
(139263,'Malfurion... Even in the womb, we grappled with one another. Struggle has followed us all our lives.','',0,0,0,0,0,0,6,0,0,0,90783,0,26124),
(139264,'The teachings of Cenarius were always your path. I felt... another calling.','',0,0,0,0,0,0,6,0,0,0,90784,0,26124),
(139265,'It was power I sought... but not to conquer or rule. It was a means to an end... to save Azeroth from an unstoppable foe.','',0,0,0,0,0,0,6,0,0,0,90785,0,26124),
(139266,'You never trusted my intentions... though I suppose I did not make it easy for you.','',0,0,0,0,0,0,1,0,0,0,90786,0,26124),
(139267,'But now, as my fate becomes clear, I wish to quiet the strife that has long divided us.','',0,0,0,0,0,0,1,0,0,0,90787,0,26124),
(139268,'Even when the Legion is gone, new threats will arise. There is no one I trust to face them more than you, brother.','',0,0,0,0,0,0,1,0,0,0,90788,0,26124),
(139269,'You have spent a lifetime fighting for the dream of what Azeroth could be. Now you must fight for what it is.','',0,0,0,0,0,0,1,0,0,0,90789,0,26124),
(139270,'Take care of Tyrande. Listen to her counsel. She was always the best of us.','',0,0,0,0,0,0,1,0,0,0,90790,0,26124),
(139271,'The road ahead will be long. Whatever comes, bring honor to the name... Stormrage.','',0,0,0,0,0,0,1,0,0,0,90791,0,26124),
(139273,'','In my lifetime, I have twice witnessed a sundering of the world. Mother Moon, I pray I do not see a third.',0,0,0,0,0,0,1,0,0,0,0,90800,26124),
(139274,'','I sense a sorcerer\'s touch upon this crystal.',0,0,0,0,0,0,1,0,0,0,0,90801,26124),
(139275,'','When I learned that he was alive, leading the fight against the Legion on the Broken Shore... I could not bring myself to speak to him.',0,0,0,0,0,0,1,0,0,0,0,90804,26124),
(139276,'','The time for talk has passed. It seems he has a duty to fulfill... as do we. Let us be about it, champion.',0,0,0,0,0,0,1,0,0,0,0,90805,26124),
(139277,'My brother made selfish choices. Caused pain to so many. His transgressions are... difficult to forgive.','',0,0,0,0,0,0,603,0,0,0,90780,0,26124),
(139278,'And yet... there were times when we fought for a common cause. A shared purpose. Those were good days.','',0,0,0,0,0,0,1,0,0,0,90781,0,26124),
(139279,'But now is not the time to ponder personal regrets. We must see to healing the world, champion.','',0,0,0,0,0,0,6,0,0,0,90782,0,26124),
(139280,'The soul of our world is in agony...','',0,0,0,0,0,0,1,0,0,0,90799,0,26124),
(139296,'You have witnessed echoes of my past, hero. I ask your help to put these final matters to rest.','',0,0,0,0,0,0,396,0,0,0,90774,0,26124),
(139297,'Champion... I would have a word.','',0,0,0,0,0,0,396,0,0,0,0,0,26124),
(139299,'But enough dwelling on the past. The crystal I left for you to find holds not two messages, but three. The last is for you, champion.','',0,0,0,0,0,0,1,0,0,0,90776,0,26124),
(139300,'The Well of Eternity. I am not one for sentiment... but if anything embodies my commitment to Azeroth, it is the font of power I created so long ago.','',0,0,0,0,0,0,1,0,0,0,90775,0,26124),
(139301,'You have proven your commitment to Azeroth. Your dedication, your sacrifice, rivals my own. But more will be asked of you. So much more.','',0,0,0,0,0,0,1,0,0,0,90777,0,26124),
(139302,'Even now, enemies gather... and the shadows grow darker. From this day forward, the defense of our world... of all we hold dear... rests with you.','',0,0,0,0,0,0,1,0,0,0,90778,0,26124),
(139349,'The crystal... it rings out with a familiar voice.','',0,0,0,0,0,0,1,0,0,0,90779,0,26124),
(139352,'','After Illidan faced defeat atop the Black Temple, I tried to let go of my feelings... my distrust and bitterness.',0,0,0,0,0,0,1,0,0,0,0,90803,26124),
(139359,'','Contrite words. Yet I must wonder whether he truly meant them.',0,0,0,0,0,0,1,0,0,0,0,90802,26124),
(139392,'','<Applause sounds>',0,0,0,0,0,0,0,0,0,0,0,91908,26124),
(139393,'<Applause sounds>','',0,0,0,0,0,0,0,0,0,0,92095,0,26124),
(139394,'','<Applause sounds>',0,0,0,0,0,0,0,0,0,0,0,92283,26124),
(139395,'<Applause sounds>','',0,0,0,0,0,0,0,0,0,0,92470,0,26124),
(139396,'Attack my enemy!','',0,0,0,0,0,0,0,0,0,0,92306,0,26124),
(139398,'','On my target!',0,0,0,0,0,0,0,0,0,0,0,92119,26124),
(139399,'','Here! This target!',0,0,0,0,0,0,0,0,0,0,0,91744,26124),
(139400,'Focus your strikes!','',0,0,0,0,0,0,0,0,0,0,91931,0,26124),
(139402,'','Target my foe!',0,0,0,0,0,0,0,0,0,0,0,91745,26124),
(139403,'Target my enemy!','',0,0,0,0,0,0,0,0,0,0,91932,0,26124),
(139404,'','Strike my foe!',0,0,0,0,0,0,0,0,0,0,0,92120,26124),
(139405,'On this target!','',0,0,0,0,0,0,0,0,0,0,92307,0,26124),
(139407,'','Strike at my enemy!',0,0,0,0,0,0,0,0,0,0,0,91746,26124),
(139409,'Target this one!','',0,0,0,0,0,0,0,0,0,0,91933,0,26124),
(139411,'','This one!',0,0,0,0,0,0,0,0,0,0,0,92121,26124),
(139412,'Focus your strikes!','',0,0,0,0,0,0,0,0,0,0,92308,0,26124),
(139413,'Please!','',0,0,0,0,0,0,0,0,0,0,92309,0,26124),
(139414,'','Please!',0,0,0,0,0,0,0,0,0,0,0,92122,26124),
(139415,'Please!','',0,0,0,0,0,0,0,0,0,0,91934,0,26124),
(139416,'','Please!',0,0,0,0,0,0,0,0,0,0,0,91747,26124),
(139417,'','Show me kindness... please!',0,0,0,0,0,0,0,0,0,0,0,92123,26124),
(139418,'I beg of you!','',0,0,0,0,0,0,0,0,0,0,92310,0,26124),
(139419,'','I implore you!',0,0,0,0,0,0,0,0,0,0,0,91748,26124),
(139420,'Will you not help?','',0,0,0,0,0,0,0,0,0,0,91935,0,26124),
(139421,'Show mercy!','',0,0,0,0,0,0,0,0,0,0,91936,0,26124),
(139422,'','Mercy, please!',0,0,0,0,0,0,0,0,0,0,0,91749,26124),
(139423,'Have mercy!','',0,0,0,0,0,0,0,0,0,0,92311,0,26124),
(139424,'','Mercy... Mercy!',0,0,0,0,0,0,0,0,0,0,0,92124,26124),
(139425,'','<Yawning sound>',0,0,0,0,0,0,0,0,0,0,0,92284,26124),
(139426,'<Yawning sound>','',0,0,0,0,0,0,0,0,0,0,92471,0,26124),
(139427,'','<Yawning sound>',0,0,0,0,0,0,0,0,0,0,0,91909,26124),
(139428,'<Yawning sound>','',0,0,0,0,0,0,0,0,0,0,92096,0,26124),
(139429,'To arms!','',0,0,0,0,0,0,0,0,0,0,91937,0,26124),
(139430,'','Fight!',0,0,0,0,0,0,0,0,0,0,0,91750,26124),
(139431,'For Suramar!','',0,0,0,0,0,0,0,0,0,0,92312,0,26124),
(139432,'','Let the battle commence!',0,0,0,0,0,0,0,0,0,0,0,92125,26124),
(139433,'','By the Light be purged!',0,0,0,0,0,0,0,0,0,0,0,91751,26124),
(139434,'By the Light be purged!','',0,0,0,0,0,0,0,0,0,0,91938,0,26124),
(139435,'','For Suramar!',0,0,0,0,0,0,0,0,0,0,0,92126,26124),
(139436,'For the arcan\'dor!','',0,0,0,0,0,0,0,0,0,0,92313,0,26124),
(139437,'Strike down our enemies!','',0,0,0,0,0,0,0,0,0,0,92314,0,26124),
(139438,'','Let none stand against us!',0,0,0,0,0,0,0,0,0,0,0,92127,26124),
(139439,'','Fight for the Light!',0,0,0,0,0,0,0,0,0,0,0,91752,26124),
(139440,'Light guide our blades!','',0,0,0,0,0,0,0,0,0,0,91939,0,26124),
(139441,'','On to victory!',0,0,0,0,0,0,0,0,0,0,0,91753,26124),
(139442,'We fight together!','',0,0,0,0,0,0,0,0,0,0,91940,0,26124),
(139444,'','Fight as one!',0,0,0,0,0,0,0,0,0,0,0,92128,26124),
(139445,'Remember the Nightwell!','',0,0,0,0,0,0,0,0,0,0,92315,0,26124),
(139446,'','For the Argus that was!',0,0,0,0,0,0,0,0,0,0,0,91754,26124),
(139447,'The Light will never yield!','',0,0,0,0,0,0,0,0,0,0,91941,0,26124),
(139448,'','For Thalyssra!',0,0,0,0,0,0,0,0,0,0,0,92129,26124),
(139449,'Attack!','',0,0,0,0,0,0,0,0,0,0,92316,0,26124),
(139450,'<Short cheer--Wooooo!>','',0,0,0,0,0,0,0,0,0,0,92472,0,26124),
(139451,'','<Short cheer--Wooooo!>',0,0,0,0,0,0,0,0,0,0,0,92285,26124),
(139452,'<Short cheer--Wooooo!>','',0,0,0,0,0,0,0,0,0,0,92097,0,26124),
(139453,'','<Short cheer--Wooooo!>',0,0,0,0,0,0,0,0,0,0,0,91910,26124),
(139454,'','<Slightly longer cheer--Woohoo!>',0,0,0,0,0,0,0,0,0,0,0,91911,26124),
(139455,'<Slightly longer cheer--Woohoo!>','',0,0,0,0,0,0,0,0,0,0,92098,0,26124),
(139456,'','<Slightly longer cheer--Woohoo!>',0,0,0,0,0,0,0,0,0,0,0,92286,26124),
(139457,'<Slightly longer cheer--Woohoo!>','',0,0,0,0,0,0,0,0,0,0,92473,0,26124),
(139458,'<Chicken sounds>','',0,0,0,0,0,0,0,0,0,0,92474,0,26124),
(139459,'','<Chicken sounds>',0,0,0,0,0,0,0,0,0,0,0,92287,26124),
(139460,'<Chicken sounds>','',0,0,0,0,0,0,0,0,0,0,92099,0,26124),
(139461,'','<Chicken sounds>',0,0,0,0,0,0,0,0,0,0,0,91912,26124),
(139462,'','Impressive!',0,0,0,0,0,0,0,0,0,0,0,91755,26124),
(139463,'I congratulate you.','',0,0,0,0,0,0,0,0,0,0,91942,0,26124),
(139464,'','You should be proud.',0,0,0,0,0,0,0,0,0,0,0,92130,26124),
(139465,'Job well done.','',0,0,0,0,0,0,0,0,0,0,92317,0,26124),
(139466,'I must congratulate you.','',0,0,0,0,0,0,0,0,0,0,92318,0,26124),
(139467,'','Outstanding!',0,0,0,0,0,0,0,0,0,0,0,92131,26124),
(139468,'The Light favors you.','',0,0,0,0,0,0,0,0,0,0,91943,0,26124),
(139469,'','You are most blessed.',0,0,0,0,0,0,0,0,0,0,0,91756,26124),
(139470,'','Well done indeed!',0,0,0,0,0,0,0,0,0,0,0,91757,26124),
(139471,'Well done.','',0,0,0,0,0,0,0,0,0,0,91944,0,26124),
(139472,'','Well earned.',0,0,0,0,0,0,0,0,0,0,0,92132,26124),
(139473,'Fortune favors you.','',0,0,0,0,0,0,0,0,0,0,92319,0,26124),
(139474,'<Crying sounds>','',0,0,0,0,0,0,0,0,0,0,92475,0,26124),
(139475,'','<Crying sounds>',0,0,0,0,0,0,0,0,0,0,0,92288,26124),
(139476,'<Crying sounds>','',0,0,0,0,0,0,0,0,0,0,92100,0,26124),
(139477,'','<Crying sounds>',0,0,0,0,0,0,0,0,0,0,0,91913,26124),
(139478,'','<Crying sounds, variant>',0,0,0,0,0,0,0,0,0,0,0,91914,26124),
(139479,'<Crying sounds, variant>','',0,0,0,0,0,0,0,0,0,0,92101,0,26124),
(139480,'','<Crying sounds, variant>',0,0,0,0,0,0,0,0,0,0,0,92289,26124),
(139481,'<Crying sounds, variant>','',0,0,0,0,0,0,0,0,0,0,92476,0,26124),
(139483,'<Crying sounds, variant.>','',0,0,0,0,0,0,0,0,0,0,92477,0,26124),
(139484,'','<Crying sounds, variant.>',0,0,0,0,0,0,0,0,0,0,0,92290,26124),
(139485,'<Crying sounds, variant.>','',0,0,0,0,0,0,0,0,0,0,92102,0,26124),
(139486,'','<Crying sounds, variant.>',0,0,0,0,0,0,0,0,0,0,0,91915,26124),
(139487,'','<Distressed cry: Total 3>',0,0,0,0,0,0,0,0,0,0,0,91852,26124),
(139488,'<Distressed cry: Total 3>','',0,0,0,0,0,0,0,0,0,0,92039,0,26124),
(139489,'','<Distressed cry: Total 3>',0,0,0,0,0,0,0,0,0,0,0,92227,26124),
(139490,'<Distressed cry: Total 3>','',0,0,0,0,0,0,0,0,0,0,92414,0,26124),
(139491,'My weapon requires both hands.','',0,0,0,0,0,0,0,0,0,0,92320,0,26124),
(139492,'','My weapon requires both hands.',0,0,0,0,0,0,0,0,0,0,0,92133,26124),
(139493,'My weapon requires both hands.','',0,0,0,0,0,0,0,0,0,0,91945,0,26124),
(139494,'','My weapon requires both hands.',0,0,0,0,0,0,0,0,0,0,0,91758,26124),
(139495,'','That ability is not ready.',0,0,0,0,0,0,0,0,0,0,0,91759,26124),
(139496,'That ability is not ready.','',0,0,0,0,0,0,0,0,0,0,91946,0,26124),
(139497,'','That ability is not ready.',0,0,0,0,0,0,0,0,0,0,0,92134,26124),
(139498,'That ability is not ready.','',0,0,0,0,0,0,0,0,0,0,92321,0,26124),
(139503,'','I cannot do that yet.',0,0,0,0,0,0,0,0,0,0,0,91760,26124),
(139504,'I cannot do that yet.','',0,0,0,0,0,0,0,0,0,0,91947,0,26124),
(139505,'','I cannot do that yet.',0,0,0,0,0,0,0,0,0,0,0,92135,26124),
(139506,'I cannot do that yet.','',0,0,0,0,0,0,0,0,0,0,92322,0,26124),
(139507,'Not ready yet.','',0,0,0,0,0,0,0,0,0,0,92323,0,26124),
(139508,'','Not ready yet.',0,0,0,0,0,0,0,0,0,0,0,92136,26124),
(139509,'Not ready yet.','',0,0,0,0,0,0,0,0,0,0,91948,0,26124),
(139510,'','Not ready yet.',0,0,0,0,0,0,0,0,0,0,0,91761,26124),
(139511,'','I cannot put that there.',0,0,0,0,0,0,0,0,0,0,0,91762,26124),
(139512,'I cannot put that there.','',0,0,0,0,0,0,0,0,0,0,91949,0,26124),
(139513,'','I cannot put that there.',0,0,0,0,0,0,0,0,0,0,0,92137,26124),
(139514,'I cannot put that there.','',0,0,0,0,0,0,0,0,0,0,92324,0,26124),
(139515,'That bag is full.','',0,0,0,0,0,0,0,0,0,0,92325,0,26124),
(139516,'','That bag is full.',0,0,0,0,0,0,0,0,0,0,0,92138,26124),
(139517,'That bag is full.','',0,0,0,0,0,0,0,0,0,0,91950,0,26124),
(139518,'','That bag is full.',0,0,0,0,0,0,0,0,0,0,0,91763,26124),
(139519,'','I cannot do that here.',0,0,0,0,0,0,0,0,0,0,0,91764,26124),
(139520,'I cannot do that here.','',0,0,0,0,0,0,0,0,0,0,91951,0,26124),
(139521,'','I cannot do that here.',0,0,0,0,0,0,0,0,0,0,0,92139,26124),
(139522,'I cannot do that here.','',0,0,0,0,0,0,0,0,0,0,92326,0,26124),
(139526,'','I cannot drop that.',0,0,0,0,0,0,0,0,0,0,0,91765,26124),
(139528,'I cannot drop that.','',0,0,0,0,0,0,0,0,0,0,91952,0,26124),
(139529,'','I cannot drop that.',0,0,0,0,0,0,0,0,0,0,0,92140,26124),
(139530,'I cannot drop that.','',0,0,0,0,0,0,0,0,0,0,92327,0,26124),
(139531,'That is bound to me.','',0,0,0,0,0,0,0,0,0,0,92328,0,26124),
(139532,'','That is bound to me.',0,0,0,0,0,0,0,0,0,0,0,92141,26124),
(139533,'That is bound to me.','',0,0,0,0,0,0,0,0,0,0,91953,0,26124),
(139534,'','That is bound to me.',0,0,0,0,0,0,0,0,0,0,0,91766,26124),
(139535,'','I cannot equip that.',0,0,0,0,0,0,0,0,0,0,0,91767,26124),
(139536,'I cannot equip that.','',0,0,0,0,0,0,0,0,0,0,91954,0,26124),
(139537,'','I cannot equip that.',0,0,0,0,0,0,0,0,0,0,0,92142,26124),
(139538,'I cannot equip that.','',0,0,0,0,0,0,0,0,0,0,92329,0,26124),
(139539,'I am not high enough level to use that.','',0,0,0,0,0,0,0,0,0,0,92330,0,26124),
(139540,'','I am not high enough level to use that.',0,0,0,0,0,0,0,0,0,0,0,92143,26124),
(139541,'I am not high enough level to use that.','',0,0,0,0,0,0,0,0,0,0,91955,0,26124),
(139542,'','I am not high enough level to use that.',0,0,0,0,0,0,0,0,0,0,0,91768,26124),
(139543,'','I cannot use that yet.',0,0,0,0,0,0,0,0,0,0,0,91769,26124),
(139544,'I cannot use that yet.','',0,0,0,0,0,0,0,0,0,0,91956,0,26124),
(139545,'','I cannot use that yet.',0,0,0,0,0,0,0,0,0,0,0,92144,26124),
(139546,'I cannot use that yet.','',0,0,0,0,0,0,0,0,0,0,92331,0,26124),
(139547,'My skill level is not high enough to equip that.','',0,0,0,0,0,0,0,0,0,0,92332,0,26124),
(139548,'','My skill level is not high enough to equip that.',0,0,0,0,0,0,0,0,0,0,0,92145,26124),
(139549,'My skill level is not high enough to equip that.','',0,0,0,0,0,0,0,0,0,0,91957,0,26124),
(139550,'','My skill level is not high enough to equip that.',0,0,0,0,0,0,0,0,0,0,0,91770,26124),
(139551,'','I will never be able to equip that.',0,0,0,0,0,0,0,0,0,0,0,91771,26124),
(139552,'I will never be able to equip that.','',0,0,0,0,0,0,0,0,0,0,91958,0,26124),
(139553,'','I will never be able to equip that.',0,0,0,0,0,0,0,0,0,0,0,92146,26124),
(139554,'I will never be able to equip that.','',0,0,0,0,0,0,0,0,0,0,92333,0,26124),
(139555,'I cannot learn that spell.','',0,0,0,0,0,0,0,0,0,0,92334,0,26124),
(139556,'','I cannot learn that spell.',0,0,0,0,0,0,0,0,0,0,0,92147,26124),
(139557,'I cannot learn that spell.','',0,0,0,0,0,0,0,0,0,0,91959,0,26124),
(139558,'','I cannot learn that spell.',0,0,0,0,0,0,0,0,0,0,0,91772,26124),
(139559,'','I cannot loot that.',0,0,0,0,0,0,0,0,0,0,0,91773,26124),
(139560,'I cannot loot that.','',0,0,0,0,0,0,0,0,0,0,91960,0,26124),
(139561,'','I cannot loot that.',0,0,0,0,0,0,0,0,0,0,0,92148,26124),
(139562,'I cannot loot that.','',0,0,0,0,0,0,0,0,0,0,92335,0,26124),
(139563,'That is not mine to take.','',0,0,0,0,0,0,0,0,0,0,92336,0,26124),
(139564,'','That is not mine to take.',0,0,0,0,0,0,0,0,0,0,0,92149,26124),
(139565,'That is not mine to take.','',0,0,0,0,0,0,0,0,0,0,91961,0,26124),
(139566,'','That is not mine to take.',0,0,0,0,0,0,0,0,0,0,0,91774,26124),
(139568,'','I need to get closer.',0,0,0,0,0,0,0,0,0,0,0,91775,26124),
(139569,'I need to get closer.','',0,0,0,0,0,0,0,0,0,0,91962,0,26124),
(139570,'','I need to get closer.',0,0,0,0,0,0,0,0,0,0,0,92150,26124),
(139571,'I need to get closer.','',0,0,0,0,0,0,0,0,0,0,92337,0,26124),
(139572,'It is too far away.','',0,0,0,0,0,0,0,0,0,0,92338,0,26124),
(139573,'','It is too far away.',0,0,0,0,0,0,0,0,0,0,0,92151,26124),
(139574,'It is too far away.','',0,0,0,0,0,0,0,0,0,0,91963,0,26124),
(139575,'','It is too far away.',0,0,0,0,0,0,0,0,0,0,0,91776,26124),
(139576,'','I cannot reach that.',0,0,0,0,0,0,0,0,0,0,0,91777,26124),
(139577,'I cannot reach that.','',0,0,0,0,0,0,0,0,0,0,91964,0,26124),
(139578,'','I cannot reach that.',0,0,0,0,0,0,0,0,0,0,0,92152,26124),
(139579,'I cannot reach that.','',0,0,0,0,0,0,0,0,0,0,92339,0,26124),
(139580,'I cannot trade that.','',0,0,0,0,0,0,0,0,0,0,92340,0,26124),
(139581,'','I cannot trade that.',0,0,0,0,0,0,0,0,0,0,0,92153,26124),
(139582,'I cannot trade that.','',0,0,0,0,0,0,0,0,0,0,91965,0,26124),
(139583,'','I cannot trade that.',0,0,0,0,0,0,0,0,0,0,0,91778,26124),
(139584,'','I cannot use that.',0,0,0,0,0,0,0,0,0,0,0,91779,26124),
(139585,'I cannot use that.','',0,0,0,0,0,0,0,0,0,0,91966,0,26124),
(139586,'','I cannot use that.',0,0,0,0,0,0,0,0,0,0,0,92154,26124),
(139587,'I cannot use that.','',0,0,0,0,0,0,0,0,0,0,92341,0,26124),
(139588,'That is not equipped.','',0,0,0,0,0,0,0,0,0,0,92342,0,26124),
(139589,'','That is not equipped.',0,0,0,0,0,0,0,0,0,0,0,92155,26124),
(139590,'That is not equipped.','',0,0,0,0,0,0,0,0,0,0,91967,0,26124),
(139591,'','That is not equipped.',0,0,0,0,0,0,0,0,0,0,0,91780,26124),
(139593,'','That must be equipped first.',0,0,0,0,0,0,0,0,0,0,0,91781,26124),
(139594,'That must be equipped first.','',0,0,0,0,0,0,0,0,0,0,91968,0,26124),
(139595,'','That must be equipped first.',0,0,0,0,0,0,0,0,0,0,0,92156,26124),
(139596,'That must be equipped first.','',0,0,0,0,0,0,0,0,0,0,92343,0,26124),
(139597,'I cannot loot that right now.','',0,0,0,0,0,0,0,0,0,0,92344,0,26124),
(139598,'','I cannot loot that right now.',0,0,0,0,0,0,0,0,0,0,0,92157,26124),
(139599,'I cannot loot that right now.','',0,0,0,0,0,0,0,0,0,0,91969,0,26124),
(139600,'','I cannot loot that right now.',0,0,0,0,0,0,0,0,0,0,0,91782,26124),
(139601,'','I do not have a target.',0,0,0,0,0,0,0,0,0,0,0,91783,26124),
(139602,'I do not have a target.','',0,0,0,0,0,0,0,0,0,0,91970,0,26124),
(139603,'','I do not have a target.',0,0,0,0,0,0,0,0,0,0,0,92158,26124),
(139604,'I do not have a target.','',0,0,0,0,0,0,0,0,0,0,92345,0,26124),
(139605,'I need to target something first.','',0,0,0,0,0,0,0,0,0,0,92346,0,26124),
(139606,'','I need to target something first.',0,0,0,0,0,0,0,0,0,0,0,92159,26124),
(139607,'I need to target something first.','',0,0,0,0,0,0,0,0,0,0,91971,0,26124),
(139608,'','I need to target something first.',0,0,0,0,0,0,0,0,0,0,0,91784,26124),
(139609,'','I require a target.',0,0,0,0,0,0,0,0,0,0,0,91785,26124),
(139610,'I require a target.','',0,0,0,0,0,0,0,0,0,0,91972,0,26124),
(139611,'','I require a target.',0,0,0,0,0,0,0,0,0,0,0,92160,26124),
(139612,'I require a target.','',0,0,0,0,0,0,0,0,0,0,92347,0,26124),
(139613,'I cannot do that.','',0,0,0,0,0,0,0,0,0,0,92348,0,26124),
(139614,'','I cannot do that.',0,0,0,0,0,0,0,0,0,0,0,92161,26124),
(139615,'I cannot do that.','',0,0,0,0,0,0,0,0,0,0,91973,0,26124),
(139616,'','I cannot do that.',0,0,0,0,0,0,0,0,0,0,0,91786,26124),
(139617,'','I need permission first.',0,0,0,0,0,0,0,0,0,0,0,91787,26124),
(139618,'I need permission first.','',0,0,0,0,0,0,0,0,0,0,91974,0,26124),
(139619,'','I need permission first.',0,0,0,0,0,0,0,0,0,0,0,92162,26124),
(139620,'I need permission first.','',0,0,0,0,0,0,0,0,0,0,92349,0,26124),
(139621,'I cannot attack that target.','',0,0,0,0,0,0,0,0,0,0,92350,0,26124),
(139622,'','I cannot attack that target.',0,0,0,0,0,0,0,0,0,0,0,92163,26124),
(139623,'I cannot attack that target.','',0,0,0,0,0,0,0,0,0,0,91975,0,26124),
(139624,'','I cannot attack that target.',0,0,0,0,0,0,0,0,0,0,0,91788,26124),
(139625,'','I cannot attack that.',0,0,0,0,0,0,0,0,0,0,0,91789,26124),
(139626,'','I cannot attack that.',0,0,0,0,0,0,0,0,0,0,0,92164,26124),
(139627,'I cannot attack that.','',0,0,0,0,0,0,0,0,0,0,92351,0,26124),
(139628,'I cannot attack that.','',0,0,0,0,0,0,0,0,0,0,91976,0,26124),
(139629,'My inventory is full.','',0,0,0,0,0,0,0,0,0,0,91977,0,26124),
(139630,'My inventory is full.','',0,0,0,0,0,0,0,0,0,0,92352,0,26124),
(139631,'','My inventory is full.',0,0,0,0,0,0,0,0,0,0,0,92165,26124),
(139632,'','My inventory is full.',0,0,0,0,0,0,0,0,0,0,0,91790,26124),
(139633,'','I cannot carry more.',0,0,0,0,0,0,0,0,0,0,0,91791,26124),
(139634,'I cannot carry more.','',0,0,0,0,0,0,0,0,0,0,91978,0,26124),
(139635,'','I cannot carry more.',0,0,0,0,0,0,0,0,0,0,0,92166,26124),
(139636,'I cannot carry more.','',0,0,0,0,0,0,0,0,0,0,92353,0,26124),
(139637,'That is locked.','',0,0,0,0,0,0,0,0,0,0,92354,0,26124),
(139638,'','That is locked.',0,0,0,0,0,0,0,0,0,0,0,92167,26124),
(139639,'That is locked.','',0,0,0,0,0,0,0,0,0,0,91979,0,26124),
(139640,'','That is locked.',0,0,0,0,0,0,0,0,0,0,0,91792,26124),
(139641,'','I am unable to carry more of those.',0,0,0,0,0,0,0,0,0,0,0,91793,26124),
(139642,'I am unable to carry more of those.','',0,0,0,0,0,0,0,0,0,0,91980,0,26124),
(139643,'','I am unable to carry more of those.',0,0,0,0,0,0,0,0,0,0,0,92168,26124),
(139644,'I am unable to carry more of those.','',0,0,0,0,0,0,0,0,0,0,92355,0,26124),
(139645,'I cannot use that item yet.','',0,0,0,0,0,0,0,0,0,0,92356,0,26124),
(139646,'','I cannot use that item yet.',0,0,0,0,0,0,0,0,0,0,0,92169,26124),
(139647,'I cannot use that item yet.','',0,0,0,0,0,0,0,0,0,0,91981,0,26124),
(139648,'','I cannot use that item yet.',0,0,0,0,0,0,0,0,0,0,0,91794,26124),
(139649,'','It is not ready yet.',0,0,0,0,0,0,0,0,0,0,0,91795,26124),
(139650,'It is not ready yet.','',0,0,0,0,0,0,0,0,0,0,91982,0,26124),
(139651,'','It is not ready yet.',0,0,0,0,0,0,0,0,0,0,0,92170,26124),
(139652,'It is not ready yet.','',0,0,0,0,0,0,0,0,0,0,92357,0,26124),
(139653,'That item is still recharging.','',0,0,0,0,0,0,0,0,0,0,92358,0,26124),
(139654,'','That item is still recharging.',0,0,0,0,0,0,0,0,0,0,0,92171,26124),
(139655,'That item is still recharging.','',0,0,0,0,0,0,0,0,0,0,91983,0,26124),
(139656,'','That item is still recharging.',0,0,0,0,0,0,0,0,0,0,0,91796,26124),
(139657,'','Not enough fury.',0,0,0,0,0,0,0,0,0,0,0,91797,26124),
(139658,'Not enough fury.','',0,0,0,0,0,0,0,0,0,0,91984,0,26124),
(139659,'','Not enough fury.',0,0,0,0,0,0,0,0,0,0,0,92172,26124),
(139660,'Not enough fury.','',0,0,0,0,0,0,0,0,0,0,92359,0,26124),
(139661,'My fury is low.','',0,0,0,0,0,0,0,0,0,0,92360,0,26124),
(139662,'','My fury is low.',0,0,0,0,0,0,0,0,0,0,0,92173,26124),
(139663,'My fury is low.','',0,0,0,0,0,0,0,0,0,0,91985,0,26124),
(139664,'','My fury is low.',0,0,0,0,0,0,0,0,0,0,0,91798,26124),
(139665,'','Not enough pain.',0,0,0,0,0,0,0,0,0,0,0,91799,26124),
(139666,'Not enough pain.','',0,0,0,0,0,0,0,0,0,0,91986,0,26124),
(139667,'','Not enough pain.',0,0,0,0,0,0,0,0,0,0,0,92174,26124),
(139668,'Not enough pain.','',0,0,0,0,0,0,0,0,0,0,92361,0,26124),
(139669,'My pain is low.','',0,0,0,0,0,0,0,0,0,0,92362,0,26124),
(139670,'','My pain is low.',0,0,0,0,0,0,0,0,0,0,0,92175,26124),
(139671,'My pain is low.','',0,0,0,0,0,0,0,0,0,0,91987,0,26124),
(139672,'','My pain is low.',0,0,0,0,0,0,0,0,0,0,0,91800,26124),
(139673,'','That is not a bag.',0,0,0,0,0,0,0,0,0,0,0,91801,26124),
(139674,'That is not a bag.','',0,0,0,0,0,0,0,0,0,0,91988,0,26124),
(139675,'','That is not a bag.',0,0,0,0,0,0,0,0,0,0,0,92176,26124),
(139676,'That is not a bag.','',0,0,0,0,0,0,0,0,0,0,92363,0,26124),
(139677,'I lack the required funds.','',0,0,0,0,0,0,0,0,0,0,92364,0,26124),
(139678,'','I lack the required funds.',0,0,0,0,0,0,0,0,0,0,0,92177,26124),
(139679,'I lack the required funds.','',0,0,0,0,0,0,0,0,0,0,91989,0,26124),
(139680,'','I lack the required funds.',0,0,0,0,0,0,0,0,0,0,0,91802,26124),
(139681,'','That is beyond my means.',0,0,0,0,0,0,0,0,0,0,0,91803,26124),
(139682,'That is beyond my means.','',0,0,0,0,0,0,0,0,0,0,91990,0,26124),
(139683,'','That is beyond my means.',0,0,0,0,0,0,0,0,0,0,0,92178,26124),
(139684,'That is beyond my means.','',0,0,0,0,0,0,0,0,0,0,92365,0,26124),
(139685,'Too expensive.','',0,0,0,0,0,0,0,0,0,0,92366,0,26124),
(139686,'','Too expensive.',0,0,0,0,0,0,0,0,0,0,0,92179,26124),
(139687,'Too expensive.','',0,0,0,0,0,0,0,0,0,0,91991,0,26124),
(139688,'','Too expensive.',0,0,0,0,0,0,0,0,0,0,0,91804,26124),
(139689,'','That one cannot join this group.',0,0,0,0,0,0,0,0,0,0,0,91805,26124),
(139690,'That one cannot join this group.','',0,0,0,0,0,0,0,0,0,0,91992,0,26124),
(139691,'','That one cannot join this group.',0,0,0,0,0,0,0,0,0,0,0,92180,26124),
(139692,'That one cannot join this group.','',0,0,0,0,0,0,0,0,0,0,92367,0,26124),
(139693,'I am out of ammunition.','',0,0,0,0,0,0,0,0,0,0,92368,0,26124),
(139694,'','I am out of ammunition.',0,0,0,0,0,0,0,0,0,0,0,92181,26124),
(139695,'I am out of ammunition.','',0,0,0,0,0,0,0,0,0,0,91993,0,26124),
(139696,'','I am out of ammunition.',0,0,0,0,0,0,0,0,0,0,0,91806,26124),
(139697,'','Not enough energy.',0,0,0,0,0,0,0,0,0,0,0,91807,26124),
(139698,'Not enough energy.','',0,0,0,0,0,0,0,0,0,0,91994,0,26124),
(139699,'','Not enough energy.',0,0,0,0,0,0,0,0,0,0,0,92182,26124),
(139700,'Not enough energy.','',0,0,0,0,0,0,0,0,0,0,92369,0,26124),
(139701,'I lack sufficient energy.','',0,0,0,0,0,0,0,0,0,0,92370,0,26124),
(139702,'','I lack sufficient energy.',0,0,0,0,0,0,0,0,0,0,0,92183,26124),
(139703,'I lack sufficient energy.','',0,0,0,0,0,0,0,0,0,0,91995,0,26124),
(139704,'','I lack sufficient energy.',0,0,0,0,0,0,0,0,0,0,0,91808,26124),
(139705,'','I need mana first.',0,0,0,0,0,0,0,0,0,0,0,91809,26124),
(139706,'I need mana first.','',0,0,0,0,0,0,0,0,0,0,91996,0,26124),
(139707,'','I need mana first.',0,0,0,0,0,0,0,0,0,0,0,92184,26124),
(139708,'I need mana first.','',0,0,0,0,0,0,0,0,0,0,92371,0,26124),
(139709,'My mana is low.','',0,0,0,0,0,0,0,0,0,0,92372,0,26124),
(139710,'','My mana is low.',0,0,0,0,0,0,0,0,0,0,0,92185,26124),
(139711,'My mana is low.','',0,0,0,0,0,0,0,0,0,0,91997,0,26124),
(139712,'','My mana is low.',0,0,0,0,0,0,0,0,0,0,0,91810,26124),
(139713,'','Mana is needed.',0,0,0,0,0,0,0,0,0,0,0,91811,26124),
(139714,'Mana is needed.','',0,0,0,0,0,0,0,0,0,0,91998,0,26124),
(139715,'','Mana is needed.',0,0,0,0,0,0,0,0,0,0,0,92186,26124),
(139716,'Mana is needed.','',0,0,0,0,0,0,0,0,0,0,92373,0,26124),
(139717,'Not enough rage.','',0,0,0,0,0,0,0,0,0,0,92374,0,26124),
(139718,'','Not enough rage.',0,0,0,0,0,0,0,0,0,0,0,92187,26124),
(139719,'Not enough rage.','',0,0,0,0,0,0,0,0,0,0,91999,0,26124),
(139720,'','Not enough rage.',0,0,0,0,0,0,0,0,0,0,0,91812,26124),
(139721,'','I must have more rage.',0,0,0,0,0,0,0,0,0,0,0,91813,26124),
(139722,'I must have more rage.','',0,0,0,0,0,0,0,0,0,0,92000,0,26124),
(139723,'','I must have more rage.',0,0,0,0,0,0,0,0,0,0,0,92188,26124),
(139724,'I must have more rage.','',0,0,0,0,0,0,0,0,0,0,92375,0,26124),
(139728,'Too far away.','',0,0,0,0,0,0,0,0,0,0,92376,0,26124),
(139729,'','Too far away.',0,0,0,0,0,0,0,0,0,0,0,92189,26124),
(139730,'Too far away.','',0,0,0,0,0,0,0,0,0,0,92001,0,26124),
(139731,'','Too far away.',0,0,0,0,0,0,0,0,0,0,0,91814,26124),
(139732,'','I am out of range.',0,0,0,0,0,0,0,0,0,0,0,91815,26124),
(139733,'I am out of range.','',0,0,0,0,0,0,0,0,0,0,92002,0,26124),
(139734,'','I am out of range.',0,0,0,0,0,0,0,0,0,0,0,92190,26124),
(139735,'I am out of range.','',0,0,0,0,0,0,0,0,0,0,92377,0,26124),
(139736,'I must get closer.','',0,0,0,0,0,0,0,0,0,0,92378,0,26124),
(139737,'','I must get closer.',0,0,0,0,0,0,0,0,0,0,0,92191,26124),
(139738,'I must get closer.','',0,0,0,0,0,0,0,0,0,0,92003,0,26124),
(139739,'','I must get closer.',0,0,0,0,0,0,0,0,0,0,0,91816,26124),
(139740,'','We cannot invite anyone else.',0,0,0,0,0,0,0,0,0,0,0,91817,26124),
(139741,'We cannot invite anyone else.','',0,0,0,0,0,0,0,0,0,0,92004,0,26124),
(139742,'','We cannot invite anyone else.',0,0,0,0,0,0,0,0,0,0,0,92192,26124),
(139743,'We cannot invite anyone else.','',0,0,0,0,0,0,0,0,0,0,92379,0,26124),
(139744,'I cannot drink more at this time.','',0,0,0,0,0,0,0,0,0,0,92380,0,26124),
(139745,'','I cannot drink more at this time.',0,0,0,0,0,0,0,0,0,0,0,92193,26124),
(139746,'I cannot drink more at this time.','',0,0,0,0,0,0,0,0,0,0,92005,0,26124),
(139747,'','I cannot drink more at this time.',0,0,0,0,0,0,0,0,0,0,0,91818,26124),
(139748,'','I do not have that ability yet.',0,0,0,0,0,0,0,0,0,0,0,91819,26124),
(139749,'I do not have that ability yet.','',0,0,0,0,0,0,0,0,0,0,92006,0,26124),
(139750,'','I do not have that ability yet.',0,0,0,0,0,0,0,0,0,0,0,92194,26124),
(139751,'I do not have that ability yet.','',0,0,0,0,0,0,0,0,0,0,92381,0,26124),
(139752,'I cannot wield that yet.','',0,0,0,0,0,0,0,0,0,0,92382,0,26124),
(139753,'','I cannot wield that yet.',0,0,0,0,0,0,0,0,0,0,0,92195,26124),
(139754,'I cannot wield that yet.','',0,0,0,0,0,0,0,0,0,0,92007,0,26124),
(139755,'','I cannot wield that yet.',0,0,0,0,0,0,0,0,0,0,0,91820,26124),
(139756,'','That spell is not yet ready.',0,0,0,0,0,0,0,0,0,0,0,91821,26124),
(139757,'That spell is not yet ready.','',0,0,0,0,0,0,0,0,0,0,92008,0,26124),
(139758,'','That spell is not yet ready.',0,0,0,0,0,0,0,0,0,0,0,92196,26124),
(139759,'That spell is not yet ready.','',0,0,0,0,0,0,0,0,0,0,92383,0,26124),
(139760,'I cannot cast that yet.','',0,0,0,0,0,0,0,0,0,0,92384,0,26124),
(139761,'','I cannot cast that yet.',0,0,0,0,0,0,0,0,0,0,0,92197,26124),
(139762,'I cannot cast that yet.','',0,0,0,0,0,0,0,0,0,0,92009,0,26124),
(139763,'','I cannot cast that yet.',0,0,0,0,0,0,0,0,0,0,0,91822,26124),
(139764,'','That is recharging.',0,0,0,0,0,0,0,0,0,0,0,91823,26124),
(139765,'That is recharging.','',0,0,0,0,0,0,0,0,0,0,92010,0,26124),
(139766,'','That is recharging.',0,0,0,0,0,0,0,0,0,0,0,92198,26124),
(139767,'That is recharging.','',0,0,0,0,0,0,0,0,0,0,92385,0,26124),
(139768,'<Standard attack: Total 10>','',0,0,0,0,0,0,0,0,0,0,92386,0,26124),
(139769,'','<Standard attack: Total 10>',0,0,0,0,0,0,0,0,0,0,0,92199,26124),
(139770,'<Standard attack: Total 10>','',0,0,0,0,0,0,0,0,0,0,92011,0,26124),
(139771,'','<Standard attack: Total 10>',0,0,0,0,0,0,0,0,0,0,0,91824,26124),
(139808,'<Big attack: Total 5>','',0,0,0,0,0,0,0,0,0,0,92396,0,26124),
(139809,'','<Big attack: Total 5>',0,0,0,0,0,0,0,0,0,0,0,92209,26124),
(139810,'<Big attack: Total 5>','',0,0,0,0,0,0,0,0,0,0,92021,0,26124),
(139811,'','<Big attack: Total 5>',0,0,0,0,0,0,0,0,0,0,0,91834,26124),
(139836,'','<Convey releasing power or charging enemy: Total 4-6>',0,0,0,0,0,0,0,0,0,0,0,91841,26124),
(139837,'<Convey releasing power or charging enemy: Total 4-6>','',0,0,0,0,0,0,0,0,0,0,92028,0,26124),
(139838,'','<Convey releasing power or charging enemy: Total 4-6>',0,0,0,0,0,0,0,0,0,0,0,92216,26124),
(139839,'<Convey releasing power or charging enemy: Total 4-6>','',0,0,0,0,0,0,0,0,0,0,92403,0,26124),
(139848,'<Release spell, throwing energy: Total 3-5>','',0,0,0,0,0,0,0,0,0,0,92406,0,26124),
(139849,'','<Release spell, throwing energy: Total 3-5>',0,0,0,0,0,0,0,0,0,0,0,92219,26124),
(139850,'<Release spell, throwing energy: Total 3-5>','',0,0,0,0,0,0,0,0,0,0,92031,0,26124),
(139851,'','<Release spell, throwing energy: Total 3-5>',0,0,0,0,0,0,0,0,0,0,0,91844,26124),
(139852,'','<Convey summoning power. Energy buildup: Total 5-7>',0,0,0,0,0,0,0,0,0,0,0,91845,26124),
(139853,'<Convey summoning power. Energy buildup: Total 5-7>','',0,0,0,0,0,0,0,0,0,0,92032,0,26124),
(139854,'','<Convey summoning power. Energy buildup: Total 5-7>',0,0,0,0,0,0,0,0,0,0,0,92220,26124),
(139855,'<Convey summoning power. Energy buildup: Total 5-7>','',0,0,0,0,0,0,0,0,0,0,92407,0,26124),
(139856,'<Charging to attack enemy: Total 5-7>','',0,0,0,0,0,0,0,0,0,0,92408,0,26124),
(139857,'','<Charging to attack enemy: Total 5-7>',0,0,0,0,0,0,0,0,0,0,0,92221,26124),
(139858,'<Charging to attack enemy: Total 5-7>','',0,0,0,0,0,0,0,0,0,0,92033,0,26124),
(139859,'','<Charging to attack enemy: Total 5-7>',0,0,0,0,0,0,0,0,0,0,0,91846,26124),
(139860,'','<Dying sounds: Total 5>',0,0,0,0,0,0,0,0,0,0,0,91847,26124),
(139861,'<Dying sounds: Total 5>','',0,0,0,0,0,0,0,0,0,0,92034,0,26124),
(139862,'','<Dying sounds: Total 5>',0,0,0,0,0,0,0,0,0,0,0,92222,26124),
(139863,'<Dying sounds: Total 5>','',0,0,0,0,0,0,0,0,0,0,92409,0,26124),
(139882,'','<Release after expending magic: Total 3>',0,0,0,0,0,0,0,0,0,0,0,92229,26124),
(139883,'<Release after expending magic: Total 3>','',0,0,0,0,0,0,0,0,0,0,92416,0,26124),
(139884,'<Release after expending magic: Total 3>','',0,0,0,0,0,0,0,0,0,0,92040,0,26124),
(139885,'','<Release after expending magic: Total 3>',0,0,0,0,0,0,0,0,0,0,0,91853,26124),
(139886,'','<Falling from high terrain. Impending injury or death: Total 1>',0,0,0,0,0,0,0,0,0,0,0,91854,26124),
(139887,'<Falling from high terrain. Impending injury or death: Total 1>','',0,0,0,0,0,0,0,0,0,0,92041,0,26124),
(139888,'<Falling from high terrain. Impending injury or death: Total 1>','',0,0,0,0,0,0,0,0,0,0,92417,0,26124),
(139889,'','<Falling from high terrain. Impending injury or death: Total 1>',0,0,0,0,0,0,0,0,0,0,0,92230,26124),
(139890,'','<Deep breath before focusing magic: Total 3>',0,0,0,0,0,0,0,0,0,0,0,92231,26124),
(139891,'<Deep breath before focusing magic: Total 3>','',0,0,0,0,0,0,0,0,0,0,92418,0,26124),
(139892,'<Deep breath before focusing magic: Total 3>','',0,0,0,0,0,0,0,0,0,0,92042,0,26124),
(139893,'','<Deep breath before focusing magic: Total 3>',0,0,0,0,0,0,0,0,0,0,0,91855,26124),
(139894,'','<Jumping off ground: Total 3>',0,0,0,0,0,0,0,0,0,0,0,91856,26124),
(139895,'<Jumping off ground: Total 3>','',0,0,0,0,0,0,0,0,0,0,92043,0,26124),
(139896,'<Jumping off ground: Total 3>','',0,0,0,0,0,0,0,0,0,0,92419,0,26124),
(139897,'','<Jumping off ground: Total 3>',0,0,0,0,0,0,0,0,0,0,0,92232,26124),
(139898,'','<Long attack with wind up. Jump attacks: Total 5-7>',0,0,0,0,0,0,0,0,0,0,0,92233,26124),
(139899,'<Long attack with wind up. Jump attacks: Total 5-7>','',0,0,0,0,0,0,0,0,0,0,92420,0,26124),
(139900,'<Long attack with wind up. Jump attacks: Total 5-7>','',0,0,0,0,0,0,0,0,0,0,92044,0,26124),
(139901,'','<Long attack with wind up. Jump attacks: Total 5-7>',0,0,0,0,0,0,0,0,0,0,0,91857,26124),
(139906,'','<Roar of dominance>',0,0,0,0,0,0,0,0,0,0,0,92235,26124),
(139907,'<Roar of dominance>','',0,0,0,0,0,0,0,0,0,0,92422,0,26124),
(139908,'<Roar of dominance>','',0,0,0,0,0,0,0,0,0,0,92046,0,26124),
(139909,'','<Roar of dominance>',0,0,0,0,0,0,0,0,0,0,0,91859,26124),
(139910,'','<Variant roar>',0,0,0,0,0,0,0,0,0,0,0,91860,26124),
(139911,'<Variant roar>','',0,0,0,0,0,0,0,0,0,0,92047,0,26124),
(139912,'<Variant roar>','',0,0,0,0,0,0,0,0,0,0,92423,0,26124),
(139913,'','<Variant roar>',0,0,0,0,0,0,0,0,0,0,0,92236,26124),
(139914,'','<Breathe as if you are running: Total 3>',0,0,0,0,0,0,0,0,0,0,0,92237,26124),
(139915,'<Breathe as if you are running: Total 3>','',0,0,0,0,0,0,0,0,0,0,92424,0,26124),
(139916,'<Breathe as if you are running: Total 3>','',0,0,0,0,0,0,0,0,0,0,92048,0,26124),
(139917,'','<Breathe as if you are running: Total 3>',0,0,0,0,0,0,0,0,0,0,0,91861,26124),
(139918,'','<Vocalized cheer: Total 3>',0,0,0,0,0,0,0,0,0,0,0,91862,26124),
(139919,'<Vocalized cheer: Total 3>','',0,0,0,0,0,0,0,0,0,0,92049,0,26124),
(139920,'<Vocalized cheer: Total 3>','',0,0,0,0,0,0,0,0,0,0,92425,0,26124),
(139921,'','<Vocalized cheer: Total 3>',0,0,0,0,0,0,0,0,0,0,0,92238,26124),
(139926,'','<Player takes a wound: Total 10>',0,0,0,0,0,0,0,0,0,0,0,91863,26124),
(139927,'<Player takes a wound: Total 10>','',0,0,0,0,0,0,0,0,0,0,92050,0,26124),
(139928,'<Player takes a wound: Total 10>','',0,0,0,0,0,0,0,0,0,0,92426,0,26124),
(139929,'','<Player takes a wound: Total 10>',0,0,0,0,0,0,0,0,0,0,0,92239,26124),
(139962,'','<Player takes significant wound: Total 5>',0,0,0,0,0,0,0,0,0,0,0,92248,26124),
(139963,'<Player takes significant wound: Total 5>','',0,0,0,0,0,0,0,0,0,0,92435,0,26124),
(139964,'<Player takes significant wound: Total 5>','',0,0,0,0,0,0,0,0,0,0,92059,0,26124),
(139965,'','<Player takes significant wound: Total 5>',0,0,0,0,0,0,0,0,0,0,0,91872,26124),
(140008,'Yes.','',0,0,0,0,0,0,0,0,0,0,91736,0,26124),
(140009,'Correct.','',0,0,0,0,0,0,0,0,0,0,91737,0,26124),
(140010,'It is so.','',0,0,0,0,0,0,0,0,0,0,91738,0,26124),
(140011,'Do not leave.','',0,0,0,0,0,0,0,0,0,0,91734,0,26124),
(140012,'Hold this spot.','',0,0,0,0,0,0,0,0,0,0,91735,0,26124),
(140013,'<Train noises--chugga chugga choo choo!>','',0,0,0,0,0,0,0,0,0,0,91732,0,26124),
(140014,'I owe you a debt.','',0,0,0,0,0,0,0,0,0,0,91718,0,26124),
(140015,'I cannot thank you enough.','',0,0,0,0,0,0,0,0,0,0,91717,0,26124),
(140016,'A thousand thanks.','',0,0,0,0,0,0,0,0,0,0,91716,0,26124),
(140017,'You are welcome.','',0,0,0,0,0,0,0,0,0,0,91739,0,26124),
(140018,'A pleasure.','',0,0,0,0,0,0,0,0,0,0,91740,0,26124),
(140019,'But of course.','',0,0,0,0,0,0,0,0,0,0,91741,0,26124),
(140020,'<Sighing sound>','',0,0,0,0,0,0,0,0,0,0,91731,0,26124),
(140021,'<Making a raspberry sound--Pfffthblth!>','',0,0,0,0,0,0,0,0,0,0,91730,0,26124),
(140022,'I require mana.','',0,0,0,0,0,0,0,0,0,0,91715,0,26124),
(140023,'Mana is needed.','',0,0,0,0,0,0,0,0,0,0,91714,0,26124),
(140024,'Bombard them!','',0,0,0,0,0,0,0,0,0,0,91713,0,26124),
(140025,'Open fire!','',0,0,0,0,0,0,0,0,0,0,91712,0,26124),
(140026,'Right.','',0,0,0,0,0,0,0,0,0,0,91709,0,26124),
(140028,'Just so.','',0,0,0,0,0,0,0,0,0,0,91710,0,26124),
(140029,'Indeed.','',0,0,0,0,0,0,0,0,0,0,91711,0,26124),
(140032,'No.','',0,0,0,0,0,0,0,0,0,0,91706,0,26124),
(140033,'I think not.','',0,0,0,0,0,0,0,0,0,0,91707,0,26124),
(140034,'Impermissible.','',0,0,0,0,0,0,0,0,0,0,91708,0,26124),
(140035,'<Laughing>','',0,0,0,0,0,0,0,0,0,0,91729,0,26124),
(140036,'<Laughing sounds>','',0,0,0,0,0,0,0,0,0,0,91728,0,26124),
(140037,'<Kiss sound>','',0,0,0,0,0,0,0,0,0,0,91727,0,26124),
(140038,'An incoming threat!','',0,0,0,0,0,0,0,0,0,0,91705,0,26124),
(140039,'I need assistance!','',0,0,0,0,0,0,0,0,0,0,91704,0,26124),
(140040,'Help me!','',0,0,0,0,0,0,0,0,0,0,91703,0,26124),
(140041,'','Come along.',0,0,0,0,0,0,0,0,0,0,0,91502,26124),
(140042,'For the Horde!','',0,0,0,0,0,0,0,0,0,0,91692,0,26124),
(140043,'','For the Alliance!',0,0,0,0,0,0,0,0,0,0,0,91881,26124),
(140044,'For the Alliance!','',0,0,0,0,0,0,0,0,0,0,92068,0,26124),
(140045,'','For the Horde!',0,0,0,0,0,0,0,0,0,0,0,92257,26124),
(140046,'For the Horde!','',0,0,0,0,0,0,0,0,0,0,92444,0,26124),
(140047,'Goodbye.','',0,0,0,0,0,0,0,0,0,0,91693,0,26124),
(140048,'Earthmother guide your path.','',0,0,0,0,0,0,0,0,0,0,91694,0,26124),
(140049,'May your journey grant wisdom.','',0,0,0,0,0,0,0,0,0,0,91695,0,26124),
(140050,'May the mountain grant you shade and comfort.','',0,0,0,0,0,0,0,0,0,0,91696,0,26124),
(140051,'Heal me!','',0,0,0,0,0,0,0,0,0,0,91697,0,26124),
(140052,'My wounds need tending!','',0,0,0,0,0,0,0,0,0,0,91698,0,26124),
(140053,'Hello.','',0,0,0,0,0,0,0,0,0,0,91699,0,26124),
(140054,'I offer greetings.','',0,0,0,0,0,0,0,0,0,0,91700,0,26124),
(140055,'You are welcome here.','',0,0,0,0,0,0,0,0,0,0,91701,0,26124),
(140056,'We will not fear the darkness.','',0,0,0,0,0,0,0,0,0,0,91702,0,26124),
(140057,'<Kiss sound>','',0,0,0,0,0,0,0,0,0,0,92478,0,26124),
(140058,'','<Kiss sound>',0,0,0,0,0,0,0,0,0,0,0,92291,26124),
(140059,'<Kiss sound>','',0,0,0,0,0,0,0,0,0,0,92103,0,26124),
(140060,'','<Kiss sound>',0,0,0,0,0,0,0,0,0,0,0,91916,26124),
(140061,'','<Laughing sounds>',0,0,0,0,0,0,0,0,0,0,0,91917,26124),
(140062,'<Laughing sounds>','',0,0,0,0,0,0,0,0,0,0,92104,0,26124),
(140063,'','<Laughing sounds>',0,0,0,0,0,0,0,0,0,0,0,92292,26124),
(140064,'<Laughing sounds>','',0,0,0,0,0,0,0,0,0,0,92479,0,26124),
(140065,'<Laughing>','',0,0,0,0,0,0,0,0,0,0,92480,0,26124),
(140066,'','<Laughing>',0,0,0,0,0,0,0,0,0,0,0,92293,26124),
(140067,'<Laughing>','',0,0,0,0,0,0,0,0,0,0,92105,0,26124),
(140068,'','<Laughing>',0,0,0,0,0,0,0,0,0,0,0,91918,26124),
(140069,'','<Making a raspberry sound--Pfffthblth!>',0,0,0,0,0,0,0,0,0,0,0,91919,26124),
(140070,'<Making a raspberry sound--Pfffthblth!>','',0,0,0,0,0,0,0,0,0,0,92106,0,26124),
(140071,'','<Making a raspberry sound--Pfffthblth!>',0,0,0,0,0,0,0,0,0,0,0,92294,26124),
(140072,'<Making a raspberry sound--Pfffthblth!>','',0,0,0,0,0,0,0,0,0,0,92481,0,26124),
(140073,'<Sighing sound>','',0,0,0,0,0,0,0,0,0,0,92482,0,26124),
(140074,'','<Sighing sound>',0,0,0,0,0,0,0,0,0,0,0,92295,26124),
(140075,'<Sighing sound>','',0,0,0,0,0,0,0,0,0,0,92107,0,26124),
(140076,'','<Sighing sound>',0,0,0,0,0,0,0,0,0,0,0,91920,26124),
(140077,'','<Train noises--chugga chugga choo choo!>',0,0,0,0,0,0,0,0,0,0,0,91921,26124),
(140078,'<Train noises--chugga chugga choo choo!>','',0,0,0,0,0,0,0,0,0,0,92108,0,26124),
(140079,'','<Train noises--chugga chugga choo choo!>',0,0,0,0,0,0,0,0,0,0,0,92296,26124),
(140080,'<Train noises--chugga chugga choo choo!>','',0,0,0,0,0,0,0,0,0,0,92483,0,26124),
(140086,'','Yes.',0,0,0,0,0,0,0,0,0,0,0,91925,26124),
(140087,'Yes.','',0,0,0,0,0,0,0,0,0,0,92112,0,26124),
(140088,'','Yes.',0,0,0,0,0,0,0,0,0,0,0,92300,26124),
(140089,'Yes.','',0,0,0,0,0,0,0,0,0,0,92487,0,26124),
(140092,'','Retreat!',0,0,0,0,0,0,0,0,0,0,0,91875,26124),
(140093,'Retreat!','',0,0,0,0,0,0,0,0,0,0,92062,0,26124),
(140094,'','Retreat!',0,0,0,0,0,0,0,0,0,0,0,92251,26124),
(140095,'Retreat!','',0,0,0,0,0,0,0,0,0,0,92438,0,26124),
(140096,'Take cover!','',0,0,0,0,0,0,0,0,0,0,92439,0,26124),
(140097,'','Take cover!',0,0,0,0,0,0,0,0,0,0,0,92252,26124),
(140098,'Find cover!','',0,0,0,0,0,0,0,0,0,0,92063,0,26124),
(140099,'','Take cover!',0,0,0,0,0,0,0,0,0,0,0,91876,26124),
(140100,'','Get out of here!',0,0,0,0,0,0,0,0,0,0,0,91877,26124),
(140101,'Get back!','',0,0,0,0,0,0,0,0,0,0,92064,0,26124),
(140102,'','Get back!',0,0,0,0,0,0,0,0,0,0,0,92253,26124),
(140103,'Get back!','',0,0,0,0,0,0,0,0,0,0,92440,0,26124),
(140110,'Follow me.','',0,0,0,0,0,0,0,0,0,0,92441,0,26124),
(140111,'Follow me.','',0,0,0,0,0,0,0,0,0,0,92065,0,26124),
(140112,'','This way.',0,0,0,0,0,0,0,0,0,0,0,92254,26124),
(140113,'','This way.',0,0,0,0,0,0,0,0,0,0,0,91878,26124),
(140114,'Let me lead.','',0,0,0,0,0,0,0,0,0,0,92442,0,26124),
(140115,'Follow my lead.','',0,0,0,0,0,0,0,0,0,0,92066,0,26124),
(140116,'','I will take the lead.',0,0,0,0,0,0,0,0,0,0,0,91879,26124),
(140117,'','Follow my lead.',0,0,0,0,0,0,0,0,0,0,0,92255,26124),
(140118,'','Come along.',0,0,0,0,0,0,0,0,0,0,0,91880,26124),
(140119,'','Come.',0,0,0,0,0,0,0,0,0,0,0,92256,26124),
(140120,'You are with me.','',0,0,0,0,0,0,0,0,0,0,92067,0,26124),
(140121,'We go this way.','',0,0,0,0,0,0,0,0,0,0,92443,0,26124),
(140122,'','Farewell.',0,0,0,0,0,0,0,0,0,0,0,91882,26124),
(140123,'Farewell.','',0,0,0,0,0,0,0,0,0,0,92069,0,26124),
(140124,'Walk always in the Light.','',0,0,0,0,0,0,0,0,0,0,92070,0,26124),
(140125,'','Walk always in the Light.',0,0,0,0,0,0,0,0,0,0,0,91883,26124),
(140126,'Suramar remembers its champions.','',0,0,0,0,0,0,0,0,0,0,92446,0,26124),
(140127,'','Suramar remembers its champions.',0,0,0,0,0,0,0,0,0,0,0,92259,26124),
(140128,'','May the arcan\'dor\'s gift sustain you.',0,0,0,0,0,0,0,0,0,0,0,92260,26124),
(140129,'May the arcan\'dor\'s gift sustain you.','',0,0,0,0,0,0,0,0,0,0,92447,0,26124),
(140130,'','We will make our place in this world.',0,0,0,0,0,0,0,0,0,0,0,92261,26124),
(140131,'We will make our place in this world.','',0,0,0,0,0,0,0,0,0,0,92448,0,26124),
(140132,'','Serve with valor and humility.',0,0,0,0,0,0,0,0,0,0,0,91884,26124),
(140133,'Serve with valor and humility.','',0,0,0,0,0,0,0,0,0,0,92071,0,26124),
(140134,'Strive for peace, but stand ready for war.','',0,0,0,0,0,0,0,0,0,0,92072,0,26124),
(140135,'','Strive for peace, but stand ready for war.',0,0,0,0,0,0,0,0,0,0,0,91885,26124),
(140136,'Farewell.','',0,0,0,0,0,0,0,0,0,0,92445,0,26124),
(140137,'','Farewell.',0,0,0,0,0,0,0,0,0,0,0,92258,26124),
(140138,'','Heal me!',0,0,0,0,0,0,0,0,0,0,0,92262,26124),
(140139,'Heal me!','',0,0,0,0,0,0,0,0,0,0,92449,0,26124),
(140140,'','Heal me!',0,0,0,0,0,0,0,0,0,0,0,91886,26124),
(140141,'Heal me!','',0,0,0,0,0,0,0,0,0,0,92073,0,26124),
(140142,'I need healing!','',0,0,0,0,0,0,0,0,0,0,92450,0,26124),
(140143,'','I need healing!',0,0,0,0,0,0,0,0,0,0,0,92263,26124),
(140144,'I am in need of healing!','',0,0,0,0,0,0,0,0,0,0,92074,0,26124),
(140145,'','I am in need of healing!',0,0,0,0,0,0,0,0,0,0,0,91887,26124),
(140146,'','Greetings.',0,0,0,0,0,0,0,0,0,0,0,92264,26124),
(140147,'Greetings.','',0,0,0,0,0,0,0,0,0,0,92451,0,26124),
(140148,'','Greetings.',0,0,0,0,0,0,0,0,0,0,0,91888,26124),
(140149,'Greetings.','',0,0,0,0,0,0,0,0,0,0,92075,0,26124),
(140150,'Tenu\'balah.','',0,0,0,0,0,0,0,0,0,0,92452,0,26124),
(140151,'','Tenu\'balah.',0,0,0,0,0,0,0,0,0,0,0,92265,26124),
(140152,'Archenon poros.','',0,0,0,0,0,0,0,0,0,0,92076,0,26124),
(140153,'','Archenon poros.',0,0,0,0,0,0,0,0,0,0,0,91889,26124),
(140154,'','Acheon kor.',0,0,0,0,0,0,0,0,0,0,0,91890,26124),
(140155,'Acheon kor.','',0,0,0,0,0,0,0,0,0,0,92077,0,26124),
(140165,'','Well met.',0,0,0,0,0,0,0,0,0,0,0,92266,26124),
(140166,'Well met.','',0,0,0,0,0,0,0,0,0,0,92453,0,26124),
(140167,'We stand against the darkness.','',0,0,0,0,0,0,0,0,0,0,92078,0,26124),
(140168,'','We stand against the darkness.',0,0,0,0,0,0,0,0,0,0,0,91891,26124),
(140169,'','Suramar stands proud... and free.',0,0,0,0,0,0,0,0,0,0,0,92267,26124),
(140170,'Suramar stands proud... and free.','',0,0,0,0,0,0,0,0,0,0,92454,0,26124),
(140171,'','Help me!',0,0,0,0,0,0,0,0,0,0,0,91892,26124),
(140172,'Help me!','',0,0,0,0,0,0,0,0,0,0,92079,0,26124),
(140173,'Aid me!','',0,0,0,0,0,0,0,0,0,0,92455,0,26124),
(140174,'','Aid me!',0,0,0,0,0,0,0,0,0,0,0,92268,26124),
(140175,'','I need help!',0,0,0,0,0,0,0,0,0,0,0,92269,26124),
(140176,'I need help!','',0,0,0,0,0,0,0,0,0,0,92456,0,26124),
(140177,'','Please help!',0,0,0,0,0,0,0,0,0,0,0,91893,26124),
(140178,'Please help!','',0,0,0,0,0,0,0,0,0,0,92080,0,26124),
(140179,'Danger approaches!','',0,0,0,0,0,0,0,0,0,0,92081,0,26124),
(140180,'','Danger approaches!',0,0,0,0,0,0,0,0,0,0,0,91894,26124),
(140182,'','Danger is near.',0,0,0,0,0,0,0,0,0,0,0,92270,26124),
(140183,'The enemy comes!','',0,0,0,0,0,0,0,0,0,0,92457,0,26124),
(140189,'No.','',0,0,0,0,0,0,0,0,0,0,92458,0,26124),
(140190,'','No.',0,0,0,0,0,0,0,0,0,0,0,92271,26124),
(140191,'','No.',0,0,0,0,0,0,0,0,0,0,0,91895,26124),
(140192,'No.','',0,0,0,0,0,0,0,0,0,0,92082,0,26124),
(140193,'','Of course not.',0,0,0,0,0,0,0,0,0,0,0,92272,26124),
(140194,'Never!','',0,0,0,0,0,0,0,0,0,0,92459,0,26124),
(140195,'I think not.','',0,0,0,0,0,0,0,0,0,0,92083,0,26124),
(140196,'','I think not.',0,0,0,0,0,0,0,0,0,0,0,91896,26124),
(140198,'','Unacceptable.',0,0,0,0,0,0,0,0,0,0,0,91897,26124),
(140199,'Unacceptable.','',0,0,0,0,0,0,0,0,0,0,92084,0,26124),
(140201,'Denied.','',0,0,0,0,0,0,0,0,0,0,92460,0,26124),
(140202,'','Denied.',0,0,0,0,0,0,0,0,0,0,0,92273,26124),
(140203,'','Right.',0,0,0,0,0,0,0,0,0,0,0,92274,26124),
(140204,'Right.','',0,0,0,0,0,0,0,0,0,0,92461,0,26124),
(140205,'Right.','',0,0,0,0,0,0,0,0,0,0,92085,0,26124),
(140206,'','Right.',0,0,0,0,0,0,0,0,0,0,0,91898,26124),
(140208,'','So be it.',0,0,0,0,0,0,0,0,0,0,0,91899,26124),
(140209,'So be it.','',0,0,0,0,0,0,0,0,0,0,92086,0,26124),
(140211,'','Verily.',0,0,0,0,0,0,0,0,0,0,0,91900,26124),
(140212,'Verily.','',0,0,0,0,0,0,0,0,0,0,92087,0,26124),
(140214,'Agreed.','',0,0,0,0,0,0,0,0,0,0,92462,0,26124),
(140215,'','Agreed.',0,0,0,0,0,0,0,0,0,0,0,92275,26124),
(140216,'','Open fire!',0,0,0,0,0,0,0,0,0,0,0,91523,26124),
(140219,'','Fire all weapons!',0,0,0,0,0,0,0,0,0,0,0,91901,26124),
(140220,'','Unleash fury!',0,0,0,0,0,0,0,0,0,0,0,92276,26124),
(140221,'Unleash fury!','',0,0,0,0,0,0,0,0,0,0,92463,0,26124),
(140224,'','Commence bombardment!',0,0,0,0,0,0,0,0,0,0,0,91902,26124),
(140225,'Commence bombardment!','',0,0,0,0,0,0,0,0,0,0,92089,0,26124),
(140226,'Bombard the enemy!','',0,0,0,0,0,0,0,0,0,0,92464,0,26124),
(140227,'','Bombard the enemy!',0,0,0,0,0,0,0,0,0,0,0,92277,26124),
(140229,'','I must gain mana.',0,0,0,0,0,0,0,0,0,0,0,92278,26124),
(140230,'My mana is low.','',0,0,0,0,0,0,0,0,0,0,92465,0,26124),
(140231,'Mana is needed.','',0,0,0,0,0,0,0,0,0,0,92090,0,26124),
(140232,'','Mana is needed.',0,0,0,0,0,0,0,0,0,0,0,91903,26124),
(140233,'','I need mana.',0,0,0,0,0,0,0,0,0,0,0,91904,26124),
(140234,'I need more mana.','',0,0,0,0,0,0,0,0,0,0,92091,0,26124),
(140235,'I require mana.','',0,0,0,0,0,0,0,0,0,0,92466,0,26124),
(140236,'','I require mana.',0,0,0,0,0,0,0,0,0,0,0,92279,26124),
(140237,'','You have my gratitude.',0,0,0,0,0,0,0,0,0,0,0,92280,26124),
(140238,'You have my gratitude.','',0,0,0,0,0,0,0,0,0,0,92467,0,26124),
(140239,'The Light thanks you.','',0,0,0,0,0,0,0,0,0,0,92092,0,26124),
(140240,'','The Light thanks you.',0,0,0,0,0,0,0,0,0,0,0,91905,26124),
(140241,'You have my thanks.','',0,0,0,0,0,0,0,0,0,0,92468,0,26124),
(140242,'','You have my thanks.',0,0,0,0,0,0,0,0,0,0,0,92281,26124),
(140243,'','Thank you, friend.',0,0,0,0,0,0,0,0,0,0,0,91906,26124),
(140244,'Thank you, friend.','',0,0,0,0,0,0,0,0,0,0,92093,0,26124),
(140245,'I am indebted to you.','',0,0,0,0,0,0,0,0,0,0,92094,0,26124),
(140246,'','I am indebted to you.',0,0,0,0,0,0,0,0,0,0,0,91907,26124),
(140248,'','Most generous.',0,0,0,0,0,0,0,0,0,0,0,92282,26124),
(140249,'Most generous.','',0,0,0,0,0,0,0,0,0,0,92469,0,26124),
(140250,'Stay here.','',0,0,0,0,0,0,0,0,0,0,92485,0,26124),
(140251,'','Stay here.',0,0,0,0,0,0,0,0,0,0,0,92298,26124),
(140252,'','Stay right here.',0,0,0,0,0,0,0,0,0,0,0,91923,26124),
(140253,'Stay right here.','',0,0,0,0,0,0,0,0,0,0,92110,0,26124),
(140254,'Maintain this position.','',0,0,0,0,0,0,0,0,0,0,92111,0,26124),
(140255,'','Maintain this position.',0,0,0,0,0,0,0,0,0,0,0,91924,26124),
(140256,'','Wait here.',0,0,0,0,0,0,0,0,0,0,0,92299,26124),
(140257,'Wait here.','',0,0,0,0,0,0,0,0,0,0,92486,0,26124),
(140258,'Without question.','',0,0,0,0,0,0,0,0,0,0,92488,0,26124),
(140259,'','Without question.',0,0,0,0,0,0,0,0,0,0,0,92301,26124),
(140260,'','Affirmative.',0,0,0,0,0,0,0,0,0,0,0,91926,26124),
(140261,'Affirmative.','',0,0,0,0,0,0,0,0,0,0,92113,0,26124),
(140263,'','That is correct.',0,0,0,0,0,0,0,0,0,0,0,92302,26124),
(140265,'That is correct.','',0,0,0,0,0,0,0,0,0,0,92489,0,26124),
(140266,'Unquestionably.','',0,0,0,0,0,0,0,0,0,0,92114,0,26124),
(140267,'','Unquestionably.',0,0,0,0,0,0,0,0,0,0,0,91927,26124),
(140268,'','The pleasure was mine.',0,0,0,0,0,0,0,0,0,0,0,91928,26124),
(140269,'The pleasure was mine.','',0,0,0,0,0,0,0,0,0,0,92115,0,26124),
(140270,'It was my pleasure.','',0,0,0,0,0,0,0,0,0,0,92490,0,26124),
(140271,'','It was my pleasure.',0,0,0,0,0,0,0,0,0,0,0,92303,26124),
(140272,'Think nothing of it.','',0,0,0,0,0,0,0,0,0,0,92116,0,26124),
(140273,'','Think nothing of it.',0,0,0,0,0,0,0,0,0,0,0,91929,26124),
(140274,'','I am honored to serve.',0,0,0,0,0,0,0,0,0,0,0,91930,26124),
(140275,'I am honored to serve.','',0,0,0,0,0,0,0,0,0,0,92117,0,26124),
(140276,'','You are welcome.',0,0,0,0,0,0,0,0,0,0,0,92304,26124),
(140277,'You are welcome.','',0,0,0,0,0,0,0,0,0,0,92491,0,26124),
(140278,'Thanks are not required.','',0,0,0,0,0,0,0,0,0,0,92492,0,26124),
(140279,'','Thanks are not required.',0,0,0,0,0,0,0,0,0,0,0,92305,26124),
(140472,'The moment that the way to Argus opened... the instant my gaze fell upon the Legion\'s home world... I knew I would not be returning from it.','',0,0,0,0,0,0,1,0,0,0,90770,0,26124),
(140473,'I will face my destiny, whatever it may hold. Yet... I have left certain matters unsettled... old wounds that I would see mended.','',0,0,0,0,0,0,0,0,0,0,90771,0,26124),
(140474,'This crystal bears two messages. One is for my brother Malfurion, the other for Tyrande. I am trusting you to deliver them on my behalf, champion.','',0,0,0,0,0,0,0,0,0,0,90772,0,26124),
(140475,'When they have heard my words, leave the crystal atop Mount Hyjal, upon the shores of the Well of Eternity.','',0,0,0,0,0,0,0,0,0,0,90773,0,26124),
(140483,'Thank you for coming, Mayla. It is my honor to welcome you to Mulgore.','',0,0,0,0,0,0,1,0,0,0,93827,0,26124),
(140484,'','Your invitation was most kind, Baine. It is time for our two peoples to renew our bonds of kinship.',0,0,0,0,0,0,1,0,0,0,0,93847,26124),
(140485,'It is of kinship that I wish to speak. I hope that--','',0,0,0,0,0,0,1,0,0,0,93828,0,26124),
(140486,'I should never... have left... the mountain...','',0,0,0,0,0,0,1,0,0,0,93882,0,26124),
(140487,'','Ebonhorn! What dark force grips you?',0,0,0,0,0,0,5,0,0,0,0,93848,26124),
(140488,'I know this power all too well. Champion! We need your help!','',0,0,0,0,0,0,603,0,0,0,93829,0,26124),
(140489,'','I must get Ebonhorn back to Highmountain at once!',0,0,0,0,0,0,1,0,0,0,0,93849,26124),
(140490,'Until we discover what\'s behind this attack, Mulgore will never be safe. I will come with you, Mayla. Let us face this darkness together.','',0,0,0,0,0,0,1,0,0,0,93830,0,26124),
(140491,'','Ebonhorn is not well. We must find a way to bring him back from the brink. Speak with Spiritwalker Graysky. I believe he can help.',0,0,0,0,0,0,0,0,0,0,0,93850,26124),
(140492,'The whispers... they have stopped. Thank you, champion, Graysky.','',0,0,0,0,0,0,1,0,0,0,93883,0,26124),
(140494,'','Today was very nearly a dark day for Azeroth.',0,0,0,0,0,0,1,0,0,0,0,93851,26124),
(140495,'','Had Uul\'gyneth\'s plan succeeded, we all would have been made into servants of the Old Gods... including Ebonhorn.',0,0,0,0,0,0,1,0,0,0,0,93852,26124),
(140496,'I shudder at the thought, Mayla. Without the swift action of Baine and this champion, all would have been lost.','',0,0,0,0,0,0,1,0,0,0,93884,0,26124),
(140497,'','Baine Bloodhoof, you have demonstrated courage, honor, and loyalty. I believe it is time for your people and mine to renew our bonds of kinship.',0,0,0,0,0,0,1,0,0,0,0,93853,26124),
(140498,'','If you will have us, the tauren of Highmountain would be proud to join your Horde.',0,0,0,0,0,0,1,0,0,0,0,93854,26124),
(140499,'The Horde will be honored to welcome you! Let us travel to Orgrimmar and share the good news with our Warchief.','',0,0,0,0,0,0,1,0,0,0,93831,0,26124),
(140500,'','What have you to say, chieftain?',0,0,0,0,0,0,1,0,0,0,0,93838,26124),
(140501,'','Warchief, the strength and courage of the Horde has been demonstrated by Baine Bloodhoof, as well as your champion.',0,0,0,0,0,0,1,0,0,0,0,93855,26124),
(140502,'','I accept your oath of loyalty. The Horde offers its protection... and expects your obedience.',0,0,0,0,0,0,1,0,0,0,0,93839,26124),
(140503,'','From this day forth, Highmountain vows to stand with you against all foes.',0,0,0,0,0,0,1,0,0,0,0,93856,26124),
(140504,'','For the Horde!',0,0,0,0,0,0,66,0,0,0,0,93857,26124),
(140505,'For the Horde!','',0,0,0,0,0,0,66,0,0,0,93832,0,26124),
(140506,'','For the Horde!',0,0,0,0,0,0,66,0,0,0,0,93840,26124),
(140644,'|TInterface\\Icons\\Shaman_PVP_RipplingWaters:20|t%s begins to cast |cFFFF0000|Hspell:255594|h[Sky and Sea]|h|r!','|TInterface\\Icons\\Shaman_PVP_RipplingWaters:20|t%s begins to cast |cFFFF0000|Hspell:255594|h[Sky and Sea]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(140708,'The might of sea and sky must aid our champions, Golganneth!','',0,0,0,0,0,0,0,0,0,0,90889,0,26124),
(140709,'Let the fury of the sea wash away this corruption!','',0,0,0,0,0,0,0,0,0,0,90890,0,26124),
(140710,'Aggramar! Lend these mortals your strength, brother.','',0,0,0,0,0,0,0,0,0,0,90886,0,26124),
(140711,'One among them shall serve as the vessel for my power, Highfather.','',0,0,0,0,0,0,0,0,0,0,90887,0,26124),
(140712,'Norgannon! Your keen mind may expose our enemy\'s weakness!','',0,0,0,0,0,0,0,0,0,0,90892,0,26124),
(140730,'The rage of the Unmaker surges! Quickly, heroes! Strike down these constructs!','',0,0,0,0,0,0,0,0,0,0,90893,0,26124),
(140731,'The mortals have fallen. The final titan... cannot be saved.','',0,0,0,0,0,0,0,0,0,0,90895,0,26124),
(140732,'Time answers to me, Unmaker! The one force that can bind your relentless fury!','',0,0,0,0,0,0,0,0,0,0,90898,0,26124),
(140733,'No! After all we have endured... It must not end this way!','',0,0,0,0,0,0,0,0,0,0,90888,0,26124),
(140734,'','Hope is not lost, Highfather. The spark of life still flickers within these mortals.',0,0,0,0,0,0,0,0,0,0,0,90884,26124),
(140735,'','Arise, champions! Fight to save your world!',0,0,0,0,0,0,0,0,0,0,0,90885,26124),
(140736,'Khaz\'goroth! Forge these heroes in our image!','',0,0,0,0,0,0,0,0,0,0,90891,0,26124),
(140760,'Using their power, I shall bend the strands of time to aid our cause.','',0,0,0,0,0,0,0,0,0,0,90894,0,26124),
(140795,'Our champions have fallen. Nothing can stop the end of all things.','',0,0,0,0,0,0,0,0,0,0,90896,0,26124),
(140797,'Our cause is lost. The Burning Crusade will consume us all.','',0,0,0,0,0,0,0,0,0,0,90897,0,26124),
(140917,'','|TInterface\\Icons\\SPELL_MAGE_FLAMEORB:20|tA fiery portal to Xoroth opens up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(140918,'','|TInterface\\Icons\\SPELL_HOLY_CONSUMEMAGIC:20|tA shadowy portal to Nathreza opens up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(140919,'','|TInterface\\Icons\\ABILITY_CREATURE_POISON_02:20|tA fel portal to Rancora opens up!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(140942,'Admiral Svirax exits her command pod!','Admiral Svirax exits her command pod!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(140944,'Chief Engineer Ishkar exits his command pod!','Chief Engineer Ishkar exits his command pod!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(140945,'General Erodus exits his command pod!','General Erodus exits his command pod!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(140952,'','You must be descended from the naaru... \'cause you\'ve got a heavenly body.',0,0,0,0,0,0,0,0,0,0,0,91262,26124),
(140953,'','Let\'s go back to my ship and twist our nethers.',0,0,0,0,0,0,0,0,0,0,0,91263,26124),
(140954,'I like it with the lights on. Not that I really have a choice...','',0,0,0,0,0,0,0,0,0,0,91278,0,26124),
(140968,'|TINTERFACE\\ICONS\\SPELL_ARCANE_MINDMASTERY.BLP:20|t Your mind is about to succumb to |cFFFF0000|Hspell:244172|h[Psychic Assault]|h|r!','|TINTERFACE\\ICONS\\SPELL_ARCANE_MINDMASTERY.BLP:20|t Your mind is about to succumb to |cFFFF0000|Hspell:244172|h[Psychic Assault]|h|r!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(140970,'Has it gotten brighter in here? Because you just turned me on.','',0,0,0,0,0,0,0,0,0,0,91281,0,26124),
(140971,'','When in doubt... touch anything that glows.',0,0,0,0,0,0,0,0,0,0,0,91264,26124),
(140972,'I thought my tattoo said \"Light\'s Defender\" in naaru. I found out it actually says \"glowing goat\".','',0,0,0,0,0,0,0,0,0,0,91285,0,26124),
(140973,'This world of yours is very strange. Talking bears who practice kung fu? On Argus, we call that a circus.','',0,0,0,0,0,0,0,0,0,0,91286,0,26124),
(140974,'After being aboard a ship for so long, it is nice to walk on solid ground again. All those hard surfaces were murder on my hooves!','',0,0,0,0,0,0,0,0,0,0,91287,0,26124),
(140975,'My life for Aiur... <cough> Argus. My life for ARGUS!','',0,0,0,0,0,0,0,0,0,0,91288,0,26124),
(140976,'','No, I do not have a glowing stamp above my tail.',0,0,0,0,0,0,0,0,0,0,0,91268,26124),
(140977,'','Have you met my dog? His name is Barkenon Puppos.',0,0,0,0,0,0,0,0,0,0,0,91269,26124),
(140978,'','Toes are overrated. Hooves make pedicures go sooooo much faster.',0,0,0,0,0,0,0,0,0,0,0,91270,26124),
(140979,'','I don\'t recommend walking barehoof on the Vindicaar. We keep finding tiny shards of crystal that didn\'t get swept up.',0,0,0,0,0,0,0,0,0,0,0,91271,26124),
(140980,'','We haven\'t crashed the Vindicaar yet... but given our track record, it\'s only a matter of time.',0,0,0,0,0,0,0,0,0,0,0,91272,26124),
(140981,'','One downside of being Lightforged is that my S.E.L.F.I.E.S. are always overexposed.',0,0,0,0,0,0,0,0,0,0,0,91273,26124),
(140982,'','Turalyon was the only human I saw for a thousand years. I assumed all of them were grizzled and scarred.',0,0,0,0,0,0,0,0,0,0,0,91274,26124),
(140983,'Your body must be a font of magic, because I\'m irresistibly drawn to it.','',0,0,0,0,0,0,0,0,0,0,91308,0,26124),
(140984,'You must know magic too, because you just made everyone else in the room disappear.','',0,0,0,0,0,0,0,0,0,0,91309,0,26124),
(140985,'You\'ve found the Arcway to my heart.','',0,0,0,0,0,0,0,0,0,0,91310,0,26124),
(140986,'Mmmm, I wanna tap that ley line.','',0,0,0,0,0,0,0,0,0,0,91311,0,26124),
(140987,'I think I\'ve night-fallen for you.','',0,0,0,0,0,0,0,0,0,0,91312,0,26124),
(140988,'I\'ve got a feeling we were night-born for each other.','',0,0,0,0,0,0,0,0,0,0,91313,0,26124),
(140989,'The stars have judged you, and found you... smokin\' hot.','',0,0,0,0,0,0,0,0,0,0,91314,0,26124),
(140990,'Were you picked from the Arcan\'dor? Because you\'re the apple of my eye.','',0,0,0,0,0,0,0,0,0,0,91315,0,26124),
(140991,'','Is that an illusion in your pocket, or are you just happy to see me?',0,0,0,0,0,0,0,0,0,0,0,91293,26124),
(140992,'','No illusions here. Everything you see is real... very real.',0,0,0,0,0,0,0,0,0,0,0,91294,26124),
(140994,'','My Nightwell brings all the boys to the yard.',0,0,0,0,0,0,0,0,0,0,0,91296,26124),
(140995,'','Animate? Detonate? I suggest we skip straight to replicate.',0,0,0,0,0,0,0,0,0,0,0,91297,26124),
(140996,'','I\'ll show you my ley lines if you show me yours.',0,0,0,0,0,0,0,0,0,0,0,91298,26124),
(140997,'','I\'ve been trapped in a bubble with the same guys for 10,000 years. You could say I\'m ready for a little... variety.',0,0,0,0,0,0,0,0,0,0,0,91299,26124),
(140998,'','There\'s no area denial in this raid.',0,0,0,0,0,0,0,0,0,0,0,91300,26124),
(140999,'To be honest, most of the time something was quite right.','',0,0,0,0,0,0,0,0,0,0,91316,0,26124),
(141000,'Why does everyone keep asking me to say that? Ughhhhh. Fine. An Illusion. What are you hiding.','',0,0,0,0,0,0,0,0,0,0,91317,0,26124),
(141001,'My name is Roy, and I\'m a mana addict.','',0,0,0,0,0,0,0,0,0,0,91318,0,26124),
(141002,'It\'s what I do. I drink arcwine... and I know things.','',0,0,0,0,0,0,0,0,0,0,91319,0,26124),
(141003,'Back in my day, there was only one kind of elf. ONE.','',0,0,0,0,0,0,0,0,0,0,91320,0,26124),
(141004,'I don\'t know why they call it the Court of Stars. I hang out there all the time and I never see anyone famous.','',0,0,0,0,0,0,0,0,0,0,91321,0,26124),
(141005,'Let\'s be honest. Keeping a giant, angry dinosaur caged up in a zoo was bound to end badly.','',0,0,0,0,0,0,0,0,0,0,91322,0,26124),
(141006,'','An allusion! What are you implying?',0,0,0,0,0,0,0,0,0,0,0,91301,26124),
(141007,'','Roses are red, our city is fair. Is that a disguise? WHO GOES THERE?',0,0,0,0,0,0,0,0,0,0,0,91302,26124),
(141008,'','Care for a glass of arcwine? I jumped on the berries myself.',0,0,0,0,0,0,0,0,0,0,0,91303,26124),
(141009,'','Tyrande still looks good after all these years. Know if she\'s seeing anyone?',0,0,0,0,0,0,0,0,0,0,0,91304,26124),
(141010,'','I met this kal\'dorei who told me my dress was the pinnacle of fashion... 10,000 years ago. Ouch! Those night elves really know how to throw shade!',0,0,0,0,0,0,0,0,0,0,0,91305,26124),
(141011,'','Night elves? More like country elves! They live in trees, sleep in dens... sometimes even grow antlers. They\'re not cut out for life in a REAL city.',0,0,0,0,0,0,0,0,0,0,0,91306,26124),
(141012,'','You really must attend one of our parties in the Court of Stars. I\'ve never met anyone more in need of a mask.',0,0,0,0,0,0,0,0,0,0,0,91307,26124),
(141013,'Have you ever seen the bunks on the Vindicaar? I can arrange a private tour.','',0,0,0,0,0,0,0,0,0,0,91282,0,26124),
(141014,'Trust me... I have experience at exploring deep places.','',0,0,0,0,0,0,0,0,0,0,91226,0,26124),
(141015,'My totem thunders. All. Night. Long.','',0,0,0,0,0,0,0,0,0,0,91227,0,26124),
(141016,'Beware the deep places... of my heart.','',0,0,0,0,0,0,0,0,0,0,91228,0,26124),
(141017,'Get as rough as you like. I\'ve got a thick hide.','',0,0,0,0,0,0,0,0,0,0,91229,0,26124),
(141018,'You must be an alchemist, because we\'ve got great chemistry.','',0,0,0,0,0,0,0,0,0,0,91230,0,26124),
(141020,'','So... wanna knock antlers?',0,0,0,0,0,0,0,0,0,0,0,91209,26124),
(141022,'','Are you staring at my rack?',0,0,0,0,0,0,0,0,0,0,0,91211,26124),
(141023,'','It\'s not the size of the antlers. It\'s the motion of the totem.',0,0,0,0,0,0,0,0,0,0,0,91212,26124),
(141024,'Why does that draenei couple keep asking me where Rocky is?','',0,0,0,0,0,0,0,0,0,0,91233,0,26124),
(141025,'Let\'s play a game. We take a drink every time a harpy screeches about earth and stone.','',0,0,0,0,0,0,0,0,0,0,91234,0,26124),
(141026,'I may be a simple tauren from the mountains, but at least I don\'t dig through worm dung for loot.','',0,0,0,0,0,0,0,0,0,0,91235,0,26124),
(141027,'Ha! A buddy of mine convinced this epic-geared adventurer to kick fish into the river! Oh wait... that wasn\'t you, was it?','',0,0,0,0,0,0,0,0,0,0,91236,0,26124),
(141028,'A tauren, a yaungol, and a taunka walk into a bar. This isn\'t a joke--it\'s my family reunion.','',0,0,0,0,0,0,0,0,0,0,91237,0,26124),
(141029,'What smells worse than a drogbar? Two drogbar. What smells worse than two drogbar? Nobody knows, because the stench will kill you.','',0,0,0,0,0,0,0,0,0,0,91238,0,26124),
(141030,'Did you just try to hang your hat on my antlers? What do I look like, a coat rack?','',0,0,0,0,0,0,0,0,0,0,91239,0,26124),
(141031,'','What do you get when you feed cocoa to a Highmountain tauren? Chocolate moose!',0,0,0,0,0,0,0,0,0,0,0,91216,26124),
(141032,'','Why are the Rivermane always so calm? Because they\'ve learned to go with the flow.',0,0,0,0,0,0,0,0,0,0,0,91217,26124),
(141033,'','Brrrrr, it\'s cold in here. In the mood for some ice cream?',0,0,0,0,0,0,0,0,0,0,0,91218,26124),
(141034,'','Tauren make the best poets. Their verse is so moooooving.',0,0,0,0,0,0,0,0,0,0,0,91219,26124),
(141035,'','You know the way to a woman\'s heart? Hoof rubs. Trust me on this one, darling.',0,0,0,0,0,0,0,0,0,0,0,91265,26124),
(141050,'Why settle for horns when you could have a rack like this?','',0,0,0,0,0,0,0,0,0,0,91232,0,26124),
(141051,'','He said my eyes were \"milky\". Talk about a mood killer...',0,0,0,0,0,0,0,0,0,0,0,91220,26124),
(141052,'At last... the future I foresaw has come to pass. Thank you for opening the way.','',0,0,0,0,0,0,0,0,0,0,94328,0,26124),
(141053,'','Show yourself! Who are you?',0,0,0,0,0,0,0,0,0,0,0,94940,26124),
(141054,'','Resist the whispers, Umbric! This \"gift\" you are offered is little more than enslavement.',0,0,0,0,0,0,0,0,0,0,0,94941,26124),
(141055,'Rrrrurgaaghh! I feel the power... calling to me... changing me...','',0,0,0,0,0,0,0,0,0,0,94649,0,26124),
(141056,'','Come, $p. We must stop this transformation before my people are lost!',0,0,0,0,0,0,0,0,0,0,0,94942,26124),
(141057,'Names are of little consequence. A more interesting question is... What shall you become?','',0,0,0,0,0,0,0,0,0,0,94329,0,26124),
(141058,'','Now, now... no antler stroking on the first date.',0,0,0,0,0,0,0,0,0,0,0,91213,26124),
(141059,'We are on the same side, Windrunner... no matter what that traitor has taught you.','',0,0,0,0,0,0,0,0,0,0,94332,0,26124),
(141060,'','Your masters will not enslave me, ethereal... nor will they claim my brothers and sisters!',0,0,0,0,0,0,0,0,0,0,0,94944,26124),
(141061,'','This void storm is a conduit... a doorway that must be closed.',0,0,0,0,0,0,0,0,0,0,0,94946,26124),
(141062,'Why do you resist? You stand on the threshold of a grand destiny.','',0,0,0,0,0,0,0,0,0,0,94333,0,26124),
(141063,'','I see through your lies, Durzaan. So will the others.',0,0,0,0,0,0,0,0,0,0,0,94949,26124),
(141064,'Nooooooooooo...','',0,0,0,0,0,0,0,0,0,0,94342,0,26124),
(141065,'','No. These people are not yours. They are not lost.',0,0,0,0,0,0,0,0,0,0,0,94948,26124),
(141066,'Alleria... $p... My people are free, but we have been... changed. And the voices...','',0,0,0,0,0,0,1,0,0,0,94650,0,26124),
(141067,'','Durzaan tried to tear away your mortality. To make you like him--a slave to his hunger.',0,0,0,0,0,0,1,0,0,0,0,94952,26124),
(141068,'','But your fate is still your own, Umbric. I can teach you to quiet the whispers. To make the shadows serve you, instead of you serving them.',0,0,0,0,0,0,1,0,0,0,0,94954,26124),
(141069,'|TInterface\\Icons\\INV_ELEMENTAL_MOTE_SHADOW01:20|tYou are afflicted with |cFFFF0000|Hspell:250669|h[Soulburst]|h|r!','|TInterface\\Icons\\INV_ELEMENTAL_MOTE_SHADOW01:20|tYou are afflicted with |cFFFF0000|Hspell:250669|h[Soulburst]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(141070,'|TInterface\\Icons\\INV_ELEMENTAL_PRIMAL_SHADOW:20|tYou are afflicted with |cFFFF0000|Hspell:251570|h[Soulbomb]|h|r!','|TInterface\\Icons\\INV_ELEMENTAL_PRIMAL_SHADOW:20|tYou are afflicted with |cFFFF0000|Hspell:251570|h[Soulbomb]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(141091,'','I\'m not usually into drogbar, but when I see them working out in that brul gym... well, let\'s just say the deep places of the earth get a little steamy.',0,0,0,0,0,0,0,0,0,0,0,91221,26124),
(141092,'If one more of you natives calls me a walking chandelier, I swear I\'ll...','',0,0,0,0,0,0,0,0,0,0,91289,0,26124),
(141097,'At long last, the war is over.\n\nPart of me never expected to survive to see this day. So many battles. So much loss.\n\n<Turalyon sighs, his eyes brimming with a flood of emotions.>\n\nNow we return home to a world I haven\'t walked in a thousand years.\n\nMy old life is long past. It is time to build a new one, and get to know the son who embodies everything I fought for.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(141098,'','My heart soars to return to Azeroth alongside Arator and Turalyon. To see the forests of my homeland once again.\n\nAnd yet...\n\nVereesa told me what has befallen Sylvanas. Though I dread the meeting, I must see with my own eyes what she has become.\n\nIs she even my sister anymore? Or some Light-forsaken monster?\n\nBut of course, I have changed as well. The powers at my command may cause some to question my loyalties.\n\n<Alleria draws in a long breath.>\n\nI must remain calm, focused. There is much to ponder...',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(141099,'Countless nights I dreamt of returning to Argus. Of seeing what became of my home. Of saving it.\n\n<Velen is quiet for a long moment.>\n\nThere was no salvation to be had. But we did find victory.\n\nWhat comes next, I cannot say. But I will not wait for visions to guide me. I will do all I can to support King Anduin, and to ensure he is prepared to face the threat that looms in the darkness.','',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(141101,'The campaign against the Legion has been long and wearying. We have traversed entire worlds, spanned the Twisting Nether itself to finally achieve victory.\n\nI am tired, $n. Yet we cannot rest.\n\nMagni\'s visions of doom shake me to my very core. Only one titan remains, champion, and we must defend it.','',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(141102,'','You\'re still here?\n\n<Ishanah looks at you quizzically.>\n\nIt\'s over. Go home.\n\n<Ishanah waves you away.>\n\nGo!',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(141103,'','Alleria has changed. She wields powers I do not fully comprehend. But in her heart, she remains my beloved sister. I know it.\n\nThe news of Sylvanas weighs heavily upon her. There are matters to be settled... face to face.\n\nThe Windrunner sisters must meet. And there is only one place it can be done.',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(141104,'I found them! At long last, I found them.\n\n<Arator\'s smile gives way to a look of uncertainty.>\n\nThe two people who gave me life... have been absent for all of it. I know they fought to keep me safe, that they sacrificed so much. And yet...\n\nWe cannot suddenly become a happy family. They know next to nothing about me, and I know only legends of them. We have much to learn about one another, and many wounds to heal.\n\nBut at least we will do it together.','',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(141105,'The Vindicaar may have been untested when we set out on this campaign, but she saw us safely home.\n\nAll those ship upgrades were worth it, yes?\n\nDo not answer. It would only break my heart.\n\nA ship\'s engineer\'s work is always underappreciated.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(141110,'','My fellow soldiers, the trials you have endured are proof that the Light shines bright within your hearts.',0,0,0,0,0,0,0,0,6,0,0,93716,26124),
(141111,'','One final test remains--and it is the most daunting of all.',0,0,0,0,0,0,0,0,6,0,0,93717,26124),
(141112,'','It will force you to peer into the very core of what you are. Of what you believe yourself to be.',0,0,0,0,0,0,0,0,6,0,0,93718,26124),
(141113,'','Many worthy draenei have undergone this trial, only to return broken... or worse.',0,0,0,0,0,0,0,0,6,0,0,93719,26124),
(141114,'','Should you feel the slightest doubt, turn back now. It will be counted as wisdom, not cowardice.',0,0,0,0,0,0,0,0,6,0,0,93720,26124),
(141115,'','But if you are truly ready, step forward and embrace your fate.',0,0,0,0,0,0,0,0,6,0,0,93721,26124),
(141116,'','T\'paartos... we have discussed this. Each initiate must be accompanied by a second. Where is yours?',0,0,0,0,0,0,0,0,6,0,0,93722,26124),
(141117,'T\'paartos needs no one to aid him!','',0,0,0,0,0,0,0,0,6,0,93808,0,26124),
(141118,'','The last initiate who attempted the trial alone came back in pieces. Choose a second, or head back to the barracks.',0,0,0,0,0,0,0,0,6,0,0,93723,26124),
(141119,'So be it! T\'paartos shall bring... this puny one!','',0,0,0,0,0,0,0,0,6,0,93809,0,26124),
(141120,'','An unorthodox choice, but... technically within the rules. I have never known $p to back down from a challenge.',0,0,0,0,0,0,0,0,6,0,0,93724,26124),
(141121,'','Let the trial begin. Light be with you both.',0,0,0,0,0,0,0,0,6,0,0,93725,26124),
(141122,'T\'paartos!','',0,0,0,0,0,0,0,0,4,0,93810,0,26124),
(141126,'When the High Exarch ordered me to Azeroth, I was reluctant to leave his side. I felt someone else would be better suited to the task.\n\nNow, though, I understand why he did it. He wanted to give me a glimpse of what he and Lady Alleria have been fighting for.\n\nOur war may be over, but many battles lie ahead. Just because the Legion is defeated doesn\'t mean every demon in existence has surrendered.\n\n<Lothraxion clenches his fist and smiles.>\n\nNot yet, at least.','',1,1,0,0,0,0,0,0,0,0,0,0,26124),
(141128,'Dalaran above the Broken Isles','Dalaran above the Broken Isles',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141131,'','I know Ethel. She\'s actually a very fast walker. She just thinks it\'s funny to mess with tourists.',0,0,0,0,0,0,0,0,0,0,0,91222,26124),
(141132,'','You know, high-altitude living does wonders for one\'s stamina. Allow me to demonstrate...',0,0,0,0,0,0,0,0,0,0,0,91214,26124),
(141133,'','You don\'t need to be from the Skyhorn tribe to join the mile high club.',0,0,0,0,0,0,0,0,0,0,0,91215,26124),
(141134,'','My turn-ons include my eyes, my tattoos, my armor... I mean, what doesn\'t turn on?',0,0,0,0,0,0,0,0,0,0,0,91266,26124),
(141135,'','I may be forged in the Light, but I know how to have fun in the dark.',0,0,0,0,0,0,0,0,0,0,0,91267,26124),
(141141,'<View Aggramar\'s Arrival.>','<View Aggramar\'s Arrival.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141145,'<View the Escape from Argus.>','<View the Escape from Argus.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141146,'<View the Triumvirate\'s Decision.>','<View the Triumvirate\'s Decision.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141148,'<View Light\'s Judgment.>','<View Light\'s Judgment.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141150,'<View Windrunner\'s Sight.>','<View Windrunner\'s Sight.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141151,'<View the Crown\'s Blessing.>','<View the Crown\'s Blessing.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141156,'Sorry if my tattoos look a little dim. I forgot to charge my battery last night.','',0,0,0,0,0,0,0,0,0,0,91290,0,26124),
(141157,'Face tentacles?! We do NOT have face tentacles! If we did, that would mean draenei are secretly emissaries of the Void, gaining your trust as we infiltrate your society so that we can bring about its end. And I\'m certain you\'re not implying THAT... are you?','',0,0,0,0,0,0,0,0,0,0,91291,0,26124),
(141158,'Spiritwalker?!','',0,0,0,0,0,0,6,0,0,0,93811,0,26124),
(141159,'I bring the Light... and also the heat.','',0,0,0,0,0,0,0,0,0,0,91283,0,26124),
(141160,'<Recall your arrival at the Seat of the Pantheon>','<Recall your arrival at the Seat of the Pantheon>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141161,'<Recall the imprisoning of Sargeras>','<Recall the imprisoning of Sargeras>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141163,'I\'m a draenei on the streets... but an eredar in the sheets.','',0,0,0,0,0,0,0,0,0,0,91284,0,26124),
(141173,'','Have you seen Prophet Velen\'s new dance? He calls it the Mac\'Areena.',0,0,0,0,0,0,0,0,0,0,0,91275,26124),
(141174,'','We are Highmountain. Unless you\'re leaving. Then we\'re Goodbye Mountain.',0,0,0,0,0,0,0,0,0,0,0,91223,26124),
(141175,'The Vindicaar is a fast ship. You could say it travels at Light speed.','',0,0,0,0,0,0,0,0,0,0,91292,0,26124),
(141176,'I\'m forming a group of tauren demon hunters. We\'re called the Illi-dairy.','',0,0,0,0,0,0,0,0,0,0,91240,0,26124),
(141305,'|TInterface\\Icons\\SPELL_NATURE_ABOLISHMAGIC.BLP:20|tEonar unleashes her |cFFFF0000|Hspell:250048|h[Life Force]|h|r!','|TInterface\\Icons\\SPELL_NATURE_ABOLISHMAGIC.BLP:20|tEonar unleashes her |cFFFF0000|Hspell:250048|h[Life Force]|h|r !',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141355,'','The Void. A force of infinite hunger.',0,0,0,0,0,0,0,0,6,0,0,94553,26124),
(141356,'','Sages and scholars fear the Void.',0,0,0,0,0,0,0,0,6,0,0,94554,26124),
(141357,'','But we understand a truth that they do not.',0,0,0,0,0,0,0,0,6,0,0,94555,26124),
(141358,'','The Void has shaped us... changed us. But you will become its master.',0,0,0,0,0,0,0,0,6,0,0,94556,26124),
(141359,'','We are soldiers.',0,0,0,0,0,0,0,0,22,0,0,93710,26124),
(141360,'','Through millennia of struggle, the Light has shown us the true path.',0,0,0,0,0,0,0,0,22,0,0,93711,26124),
(141361,'','At long last, our enemy has fallen. The Legion is no more. Yet our war is far from over. New threats gather in the shadows, awaiting their moment to strike.',0,0,0,0,0,0,0,0,22,0,0,93712,26124),
(141362,'','You are Lightforged. You must stand as a beacon of hope against the darkness.',0,0,0,0,0,0,0,0,22,0,0,93713,26124),
(141363,'','For ten-thousand years, Suramar was the only world we knew.',0,0,0,0,0,0,0,0,22,0,0,94549,26124),
(141364,'','As the ages passed, Azeroth changed around us... and fell into the Legion\'s grasp.',0,0,0,0,0,0,0,0,22,0,0,94550,26124),
(141365,'','Our leaders betrayed us, striking a bargain with the demons. But we rose up against tyranny... and drove the devils out. Suramar is ours once more, and we will never again let it fall into darkness.',0,0,0,0,0,0,0,0,22,0,0,94551,26124),
(141366,'','To secure our people\'s future, you must help reclaim our place in Azeroth.',0,0,0,0,0,0,0,0,22,0,0,94552,26124),
(141369,'','The regent lord invited the nightborne to Silvermoon. I am to travel to Suramar and escort Lady Thalyssra to the meeting.',0,0,0,0,0,0,1,0,0,0,0,94829,26124),
(141370,'','I am counting on you both. Do not return until Suramar\'s strength is pledged to the Horde.',0,0,0,0,0,0,1,0,0,0,0,94768,26124),
(141371,'','As you command, Warchief. I will meet you at Lady Thalyssra\'s estate in Suramar, $p.',0,0,0,0,0,0,1,0,0,0,0,94830,26124),
(141372,'Lady Liadrin... champion. You are most welcome. As you can see, we have an... unexpected visitor.','',0,0,0,0,0,0,1,0,0,0,94665,0,26124),
(141373,'','Hello again, Liadrin. Champion. Lor\'themar, I am here concerning a matter that might be best addressed in private.',0,0,0,0,0,0,1,0,0,0,0,94878,26124),
(141374,'I see no need to keep secrets from allies, Alleria. In fact, some new friends of ours are just arriving.','',0,0,0,0,0,0,1,0,0,0,94666,0,26124),
(141375,'','First Arcanist Thalyssra and honored guests. Welcome to Silvermoon.',0,0,0,0,0,0,1,0,6,0,0,94834,26124),
(141376,'','It is a pleasure to visit your fine city at last. Thank you for extending the invitation, Regent Lord.',0,0,0,0,0,0,1,0,6,0,0,94879,26124),
(141379,'Please, call me Lor\'themar. But where are my manners? Allow me to introduce another guest: Lady Alleria Windrunner, a hero of Silvermoon\'s past.','',0,0,0,0,0,0,1,0,6,0,94667,0,26124),
(141380,'','An unexpected honor, Lady Windrunner. Silgryn told me of your courage during the campaign on Argus.',0,0,0,0,0,0,1,0,6,0,0,94880,26124),
(141381,'','The honor is mine, First Arcanist. I do not mean to intrude upon your visit. Perhaps I should return another time.',0,0,0,0,0,0,1,0,6,0,0,94881,26124),
(141382,'Nonsense. Whatever you came to say, you may say in front of our guests.','',0,0,0,0,0,0,1,0,6,0,94668,0,26124),
(141383,'','As you wish. I come bearing an offer from High King Anduin Wr--',0,0,0,0,0,0,1,0,6,0,0,94882,26124),
(141384,'I had hoped your visit was motivated by a love for Silvermoon. Instead, you come at the behest of the Alliance\'s boy-king. How disappointing.','',0,0,0,0,0,0,1,0,6,0,94669,0,26124),
(141387,'','Cutting words, Lor\'themar. Are they yours, I wonder, or has the dutiful ranger I knew become the mouthpiece of your warchief?',0,0,0,0,0,0,1,0,6,0,0,94883,26124),
(141388,'You doubt my words, yet how can we trust your own? Do you deny that the lords of the Void whisper to you? Did you not surrender yourself to the shadows on Argus?','',0,0,0,0,0,0,1,0,6,0,94670,0,26124),
(141389,'','It seems the offer I bring has been anticipated... and spurned. Very well. But before I leave, I have one request.',0,0,0,0,0,0,1,0,6,0,0,94884,26124),
(141391,'','It has been a thousand years since I set eyes upon the Sunwell. May I visit it once again?',0,0,0,0,0,0,6,0,6,0,0,94885,26124),
(141392,'I advise against it. We cannot trust that she will not--','',0,0,0,0,0,0,1,0,6,0,94825,0,26124),
(141393,'Whatever she has become, Alleria is a daughter of Quel\'Thalas. I will not deny her pilgrimage to our most sacred site. First Arcanist, you and your retinue would be welcome to join us.','',0,0,0,0,0,0,1,0,6,0,94671,0,26124),
(141394,'','I would consider it an honor to see the Sunwell, Lor\'themar. And I prefer that my friends call me Thalyssra.',0,0,0,0,0,0,1,0,6,0,0,94886,26124),
(141395,'Rommath, kindly open the way for us.','',0,0,0,0,0,0,1,0,6,0,94672,0,26124),
(141396,'Please follow me.','',0,0,0,0,0,0,1,0,6,0,94673,0,26124),
(141397,'','The sense of power is palpable. As potent as the Nightwell, but of a different nature.',0,0,0,0,0,0,1,0,0,0,0,94874,26124),
(141398,'','The Sunwell was corrupted by our enemies, but a naaru\'s sacrifice purified its waters. Now the essence of the Light sustains us.',0,0,0,0,0,0,1,0,0,0,0,94833,26124),
(141399,'','The Sunwell has changed... but its beauty remains. It has been so long.',0,0,0,0,0,0,1,0,0,0,0,94875,26124),
(141400,'Stay back!','',0,0,0,0,0,0,603,0,0,0,94823,0,26124),
(141401,'What is happening?','',0,0,0,0,0,0,6,0,0,0,94663,0,26124),
(141402,'This is why I demanded that Umbric and his radicals be exiled. Anyone who treats with the Void is a danger to the Sunwell!','',0,0,0,0,0,0,1,0,0,0,94824,0,26124),
(141403,'','I did not intend for my presence to...',0,0,0,0,0,0,1,0,0,0,0,94876,26124),
(141404,'Enough! We need to cleanse this corruption before the well is lost!','',0,0,0,0,0,0,603,0,0,0,94664,0,26124),
(141405,'','Silgryn! Valtrois! Aid the regent lord!',0,0,0,0,0,0,603,0,0,0,0,94877,26124),
(141407,'','Highmountain stands.',0,0,0,0,0,0,0,0,6,0,0,93841,26124),
(141408,'','These words speak of more than earth and stone. They tell the history of our people, enduring hardship and conflict to unite against common foes.',0,0,0,0,0,0,0,0,6,0,0,93858,26124),
(141409,'','At times we were divided. At times we lost our way. But the spirits of our ancestors reminded us that we are bound together by earth, river, and sky. That we are family, and family is worth fighting for.',0,0,0,0,0,0,0,0,6,0,0,93859,26124),
(141410,'','The time has come for you to venture beyond our sacred peaks.',0,0,0,0,0,0,0,0,6,0,0,93860,26124),
(141464,'|TInterface\\Icons\\SPELL_FIRE_FELRAINOFFIRE.BLP:20|t|cFFFF0000|Hspell:248333|h[Meteor Storm]|h|r can be avoided, be sure to avoid its impact.','|TInterface\\Icons\\SPELL_FIRE_FELRAINOFFIRE.BLP:20|t|cFFFF0000|Hspell:248333|h[Meteor Storm]|h|r can be avoided, be sure to avoid its impact.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141465,'This creature will turn and attack players, be sure it\'s attacking a tank before you attack it!','This creature will turn and attack players, be sure it\'s attacking a tank before you attack it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141466,'|TInterface\\Icons\\SPELL_FIRE_FELFLAMESTRIKE.BLP:20|tFel-Infused Destructors damage Eonar with their |cFFFF0000|Hspell:246305|h[Artillery Strike]|h|r, be sure to dispatch them quickly.','|TInterface\\Icons\\SPELL_FIRE_FELFLAMESTRIKE.BLP:20|tFel-Infused Destructors damage Eonar with their |cFFFF0000|Hspell:246305|h[Artillery Strike]|h|r, be sure to dispatch them quickly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141467,'|TInterface\\ICONS\\spell_shadow_shadesofdarkness.blp:20|t Move near allies to avoid |cFFF00000|Hspell:243963|h[Alone in the Darkness]|h|r!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(141468,'|TInterface\\ICONS\\ABILITY_HUNTER_SNIPERSHOT.BLP:20|t Run away from the boss during |cFFF00000|Hspell:246220|h[Fel Bombardment]|h|r to avoid damage!','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(141469,'|TInterface\\Icons\\SPELL_FIRE_IMMOLATION.BLP:20|tLeave construction bays during  |cFFFF0000|Hspell:248061|h[Purging Protocol]|h|r to avoid being killed!','|TInterface\\Icons\\SPELL_FIRE_IMMOLATION.BLP:20|tLeave construction bays during  |cFFFF0000|Hspell:248061|h[Purging Protocol]|h|r to avoid being killed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141480,'The only way is forward.','',0,0,0,0,0,0,0,0,0,0,93750,0,26124),
(141481,'Pain is the architect of memories.','',0,0,0,0,0,0,0,0,0,0,93751,0,26124),
(141482,'There is no kindness here.','',0,0,0,0,0,0,0,0,0,0,93752,0,26124),
(141483,'Anguish and hurt... the search for solace.','',0,0,0,0,0,0,0,0,0,0,93753,0,26124),
(141484,'Even amidst hopelessness, there is respite.','',0,0,0,0,0,0,0,0,0,0,93754,0,26124),
(141485,'Is there no comfort? No relief?','',0,0,0,0,0,0,0,0,0,0,93755,0,26124),
(141486,'Retreat deeper... find safety... find comfort...','',0,0,0,0,0,0,0,0,0,0,93756,0,26124),
(141487,'Distraction provides escape.','',0,0,0,0,0,0,0,0,0,0,93757,0,26124),
(141488,'Unfair! Unjust! Nothing is ever what it seems!','',0,0,0,0,0,0,0,0,0,0,93758,0,26124),
(141489,'Enemies lurk within every shadow. Can this darkness be stopped?','',0,0,0,0,0,0,0,0,0,0,93759,0,26124),
(141490,'Is solitude the answer? No one can hurt you if you remain alone.','',0,0,0,0,0,0,0,0,0,0,93760,0,26124),
(141491,'Safe. Secure. Away from everyone. Everything.','',0,0,0,0,0,0,0,0,0,0,93761,0,26124),
(141492,'Fear is relentless. Unyielding. A foe to be defeated.','',0,0,0,0,0,0,0,0,0,0,93762,0,26124),
(141493,'Perhaps to overcome fear of the darkness, one must embrace it.','',0,0,0,0,0,0,0,0,0,0,93763,0,26124),
(141494,'An offer refuted... and yet the fear remains.','',0,0,0,0,0,0,0,0,0,0,93764,0,26124),
(141495,'Within one soul exist many truths. Some noble. Others...','',0,0,0,0,0,0,0,0,0,0,93765,0,26124),
(141496,'Does the path lead to greatness? Glory? Or obliteration?','',0,0,0,0,0,0,0,0,0,0,93766,0,26124),
(141501,'|TInterface\\Icons\\Sha_Ability_Rogue_BloodyEye_nightmare:20|t|cFFFF0000|Hspell:258068|h[Sargeras\' Gaze]|h|r is cast upon the battle...','|TInterface\\Icons\\Sha_Ability_Rogue_BloodyEye_nightmare:20|t|cFFFF0000|Hspell:258068|h[Sargeras\' Gaze]|h|r is cast upon the battle...',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(141518,'This T\'paartos is pledged to the Light, yet... treats with the darkness? This cannot be T\'paartos\' fate!','',0,0,0,0,0,0,0,0,0,0,93778,0,26124),
(141554,'','I cannot let the Darkness possess my father\'s body!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(141555,'Mayla! We must stand together!','',0,0,0,0,0,0,603,0,0,0,93812,0,26124),
(141556,'I am free from the Old Gods\' grip. Thank you, my friends.','',0,0,0,0,0,0,1,0,0,0,93870,0,26124),
(141575,'Serve your true masters, drogbar! Your defiance means death!','',0,0,0,0,0,0,0,0,0,0,93896,0,26124),
(141576,'The Skyhorn shall serve my masters! You will become the shadow that darkens the skies!','',0,0,0,0,0,0,0,0,0,0,93897,0,26124),
(141577,'The Legion was nothing compared to our power! Surrender!','',0,0,0,0,0,0,0,0,0,0,93898,0,26124),
(141578,'You have failed! The Darkness rises... and Highmountain shall fall!','',0,0,0,0,0,0,0,0,0,0,93899,0,26124),
(141579,'The wards have weakened! He will be ours!','',0,0,0,0,0,0,0,0,0,0,93891,0,26124),
(141585,'Follow me, champion.','',0,0,0,0,0,0,1,0,0,0,93885,0,26124),
(141586,'Long ago, the Old Gods sought to lay claim to Highmountain. Their campaign was led by a terrible general... Uul\'gyneth the Darkness.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(141587,'Huln gathered heroes from among the tribes to stand together. They fought against Uul\'gyneth\'s servants, the Necrodark... but the forces of shadow were too great to overcome.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(141588,'So Huln devised another plan. Wards were placed to lock away the Old Gods\' influence. Though the general survived, Uul\'gyneth\'s essence was trapped.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(141589,'','So the Necrodark have been lurking in the shadows, waiting to call forth their master.',0,0,0,0,0,0,1,0,0,0,0,93869,26124),
(141590,'Indeed. And when I left the mountain to visit Mulgore, the wards weakened just enough to let the Darkness take hold.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(141591,'The last ward was placed at Highmountain Summit. That is where we must go. Just as Huln stood with his allies, so we must band together.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(141596,'Warchief Sylvanas Windrunner, I present Chieftain Mayla Highmountain.','',0,0,0,0,0,0,1,0,0,0,93813,0,26124),
(141628,'Was T\'paartos meant to walk this path? Is T\'paartos worthy to become Lightforged?','',0,0,0,0,0,0,0,0,0,0,93801,0,26124),
(141629,'No! The darkness will not claim T\'paartos!','',0,0,0,0,0,0,0,0,0,0,93786,0,26124),
(141630,'Ahh, Ika. T\'paartos raised this elekk when its mother was killed.','',0,0,0,0,0,0,0,0,0,0,93800,0,26124),
(141631,'T\'paartos has faced many such fiends in the Army of the Light.','',0,0,0,0,0,0,0,0,0,0,93771,0,26124),
(141632,'T\'paartos can lift mountains!','',0,0,0,0,0,0,0,0,0,0,93803,0,26124),
(141633,'This is... slightly embarrassing for T\'paartos.','',0,0,0,0,0,0,0,0,0,0,93770,0,26124),
(141634,'Ugh! Can $p make the snakes go away?','',0,0,0,0,0,0,0,0,0,0,93787,0,26124),
(141635,'No... this is not real. This cannot be the true T\'paartos!','',0,0,0,0,0,0,0,0,0,0,93790,0,26124),
(141636,'No...','',0,0,0,0,0,0,0,0,0,0,93767,0,26124),
(141637,'ENOUGH!!!','',0,0,0,0,0,0,0,0,0,0,93768,0,26124),
(141638,'The Light has always been with T\'paartos! He will NEVER abandon the Light!','',0,0,0,0,0,0,0,0,0,0,93769,0,26124),
(141639,'Such power awaits us, T\'paartos.','',0,0,0,0,0,0,0,0,0,0,93782,0,26124),
(141640,'The Light is not the way to true strength.','',0,0,0,0,0,0,0,0,0,0,93783,0,26124),
(141641,'Shrug off the chains the Light has used to bind you.','',0,0,0,0,0,0,0,0,0,0,93784,0,26124),
(141642,'Yes... give in, T\'paartos. Embrace true power!','',0,0,0,0,0,0,0,0,0,0,93785,0,26124),
(141677,'','Welcome back, T\'paartos.',0,0,0,0,0,0,1,0,0,0,0,93705,26124),
(141678,'','T\'paartos... You confronted your fears... your failings... and have been reborn.',0,0,0,0,0,0,1,0,0,0,0,93706,26124),
(141679,'We all have darkness inside us. It is no easy thing to face.','',0,0,0,0,0,0,1,0,0,0,93727,0,26124),
(141680,'T\'paartos realizes this now.','',0,0,0,0,0,0,66,0,0,0,93739,0,26124),
(141681,'','This is an official ceremony. Do not interrupt.',0,0,0,0,0,0,66,0,0,0,0,93707,26124),
(141712,'','Greetings, $n. You probably don\'t remember me--we met next week.$b$bWould you care to revisit Ulduar?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141713,'Send me into Ulduar. (Timewalking Raid)','Send me into Ulduar. (Timewalking Raid)',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141731,'Can you believe there are cities out there that aren\'t encased in a magic bubble? I mean, how do those people keep the dust out? Savages.','',0,0,0,0,0,0,0,0,0,0,93514,0,26124),
(141732,'','I like bubbles. They make me feel safe!',0,0,0,0,0,0,0,0,0,0,0,93515,26124),
(141775,'|TInterface\\Icons\\INV_ELEMENTAL_PRIMAL_AIR:20|tGolganneth has chosen you to deliver the |cFFFF0000|Hspell:257313|h[Gift of the Sky]|h|r!','|TInterface\\Icons\\INV_ELEMENTAL_PRIMAL_AIR:20|tGolganneth has chosen you to deliver the |cFFFF0000|Hspell:257313|h[Gift of the Sky]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(141776,'|TInterface\\Icons\\ACHIEVEMENT_ZONE_VASHJIR:20|tGolganneth has chosen you to deliver the |cFFFF0000|Hspell:257306|h[Gift of the Sea]|h|r!','|TInterface\\Icons\\ACHIEVEMENT_ZONE_VASHJIR:20|tGolganneth has chosen you to deliver the |cFFFF0000|Hspell:257306|h[Gift of the Sea]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(141784,'The wards have weakened! He will be ours!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141790,'Mayla... the pools...','',0,0,0,0,0,0,1,0,0,0,93871,0,26124),
(141791,'','I understand, my friend. Baine, I must get Ebonhorn back to Highmountain.',0,0,0,0,0,0,0,0,0,0,0,93842,26124),
(141792,'Very well. We will drive this Old God filth from Thunder Bluff.','',0,0,0,0,0,0,0,0,0,0,93815,0,26124),
(141795,'Destroy them! They must not hinder my return!','',0,0,0,0,0,0,0,0,0,0,93893,0,26124),
(141796,'Your masters will not take my city, monster!','',0,0,0,0,0,0,0,0,0,0,93816,0,26124),
(141797,'I must be certain the Old Gods\' minions are driven from Mulgore.','',0,0,0,0,0,0,0,0,0,0,93817,0,26124),
(141798,'Go to Highmountain and aid Mayla, champion. I will join you soon.','',0,0,0,0,0,0,0,0,0,0,93818,0,26124),
(141799,'','The waters have soothed Ebonhorn, but I fear he is slipping away.',0,0,0,0,0,0,1,0,0,0,0,93843,26124),
(141800,'','I will remain here while Graysky aids you. Pray that restoring the wards will mend Ebonhorn\'s mind.',0,0,0,0,0,0,0,0,0,0,0,93844,26124),
(141802,'My mind is my own again. Return to Thunder Totem, champion. Let us gather strength for what is to come.','',0,0,0,0,0,0,0,0,0,0,93875,0,26124),
(141803,'Champion! Graysky told me of your courage.','',0,0,0,0,0,0,0,0,0,0,93819,0,26124),
(141804,'','But our work is not done yet. Ebonhorn, we must know what this Darkness wants.',0,0,0,0,0,0,0,0,0,0,0,93845,26124),
(141805,'Long ago, the Old Gods sought to claim Highmountain. Their campaign was led by a terrible creature of nightmare... Uul\'gyneth the Darkness.','',0,0,0,0,0,0,0,0,0,0,93876,0,26124),
(141806,'Huln gathered heroes from among the tribes. They fought against Uul\'gyneth\'s servants, the Necrodark... but the forces of shadow were too great to overcome.','',0,0,0,0,0,0,0,0,0,0,93877,0,26124),
(141807,'So Huln devised another plan. Wards were placed to lock away the Old Gods\' influence. Though the general survived, Uul\'gyneth\'s essence was trapped.','',0,0,0,0,0,0,0,0,0,0,93878,0,26124),
(141808,'','All this time, the Necrodark have been lurking in the shadows, waiting to call forth their master.',0,0,0,0,0,0,0,0,0,0,0,93846,26124),
(141809,'Indeed. And when I left the mountain to visit Mulgore, the wards weakened just enough to let the Darkness seep through.','',0,0,0,0,0,0,0,0,0,0,93872,0,26124),
(141810,'The last ward was placed at Highmountain Summit. That is where we must go. Just as Huln stood with his allies, so we must band together.','',0,0,0,0,0,0,0,0,0,0,93873,0,26124),
(141811,'Yes... come! Your strength will become ours, child of darkness!','',0,0,0,0,0,0,0,0,0,0,93892,0,26124),
(141812,'Child of... What does he mean?','',0,0,0,0,0,0,0,0,0,0,93814,0,26124),
(141813,'I... cannot say. Mayla, you and I must go on ahead. Baine, you and our champion gather the others and meet us at the summit.','',0,0,0,0,0,0,0,0,0,0,93874,0,26124),
(141829,'','Oh, hi! Did you want to take a S.E.L.F.I.E. with me?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141830,'What does S.E.L.F.I.E. stand for?','What does S.E.L.F.I.E. stand for?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141831,'','Self-Enabling Low Focus Image Extractor.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141832,'I lost my camera. Can you make me another one?','I lost my camera. Can you make me another one?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141833,'Can this camera do anything else?','Can this camera do anything else?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141834,'','You know, I\'m not quite sure! It\'s infused with some powerful engineering... there\'s probably a hidden feature or two.$B$BYou might want to try taking it near some sources of great power. That always seems to kick-start things!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141835,'','Niko, more light! Oh, hey gorgeous! Didn\'t see ya there. What can I do for ya?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141836,'','I like ya. Never satisfied, just like me. That\'s the pursuit of perfection in ya.$B$BYa know, I\'m not really sure. This thing\'s got the best in goblin engineering all crammed into a tiny box. That\'s a recipe for untapped potential, right there.$B$BMaybe find yourself a source of great power and... see what happens? No promises.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141837,'I am eager for the Lightforged to join the Alliance. Turalyon, bring our champion with you to the Vindicaar so that you may address your troops together.','',0,0,0,0,0,0,1,0,0,0,93695,0,26124),
(141838,'It will be done, High King.','',0,0,0,0,0,0,1,0,0,0,93736,0,26124),
(141839,'This way, champion.','',0,0,0,0,0,0,6,0,0,0,93737,0,26124),
(141840,'Fareeya, I need a beacon to the Vindicaar.','',0,0,0,0,0,0,1,0,0,0,93738,0,26124),
(141841,'','At once, High Exarch.',0,0,0,0,0,0,1,0,0,0,0,93726,26124),
(141846,'This way!','',0,0,0,0,0,0,0,0,0,0,93772,0,26124),
(141847,'Over here!','',0,0,0,0,0,0,0,0,0,0,93773,0,26124),
(141848,'Look out!','',0,0,0,0,0,0,0,0,0,0,93774,0,26124),
(141849,'Here, friend!','',0,0,0,0,0,0,0,0,0,0,93775,0,26124),
(141850,'T\'paartos does not know fear!','',0,0,0,0,0,0,0,0,0,0,93776,0,26124),
(141851,'T\'paartos regrets calling $p puny.','',0,0,0,0,0,0,0,0,0,0,93777,0,26124),
(141852,'The fear... it followed T\'paartos everywhere!','',0,0,0,0,0,0,0,0,0,0,93807,0,26124),
(141870,'T\'paartos is sorry.','',0,0,0,0,0,0,0,0,0,0,93740,0,26124),
(141871,'From this day forth, you are Lightforged.','',0,0,0,0,0,0,0,0,0,0,93728,0,26124),
(141872,'','Pheta thones gamera. Light guide our path!',0,0,0,0,0,0,0,0,0,0,0,93708,26124),
(141873,'T\'paartos!','',0,0,0,0,0,0,0,0,0,0,93741,0,26124),
(141874,'T\'paartos is a bit... unconventional. But he will serve our cause well.','',0,0,0,0,0,0,0,0,0,0,93729,0,26124),
(141875,'Champion, it is time for us to return to Stormwind. Fareeya, spread the word. The Lightforged now fight for the Alliance.','',0,0,0,0,0,0,0,0,0,0,93730,0,26124),
(141876,'','With pleasure, High Exarch.',0,0,0,0,0,0,0,0,0,0,0,93709,26124),
(141892,'High King Wrynn. The Army of the Light is pledged to defend the Alliance.','',0,0,0,0,0,0,1,0,0,0,93731,0,26124),
(141893,'The strength of the Lightforged is most welcome in our ranks, High Exarch.','',0,0,0,0,0,0,1,0,0,0,93692,0,26124),
(141894,'I have fought beside these draenei in the Twisting Nether for a thousand years. You will find no soldiers who are more skilled, or more loyal.','',0,0,0,0,0,0,1,0,0,0,93732,0,26124),
(141895,'Both these qualities will be needed in the days to come. And thank you for your part in bringing them to our cause, $p.','',0,0,0,0,0,0,1,0,0,0,93693,0,26124),
(141897,'For the Alliance!','',0,0,0,0,0,0,1,0,0,0,93694,0,26124),
(141898,'For the Alliance!','',0,0,0,0,0,0,1,0,0,0,93733,0,26124),
(141899,'We will drive your shadow from Mulgore!','',0,0,0,0,0,0,1,0,0,0,93820,0,26124),
(141900,'Hahahaha! It feels good to swing my mace again!','',0,0,0,0,0,0,0,0,0,0,93821,0,26124),
(141901,'Thunder Bluff will be free of you!','',0,0,0,0,0,0,0,0,0,0,93822,0,26124),
(141902,'Go back to the void that spawned you!','',0,0,0,0,0,0,0,0,0,0,93823,0,26124),
(141908,'','I did not expect you back so soon, High Exarch. I assume your meeting with the king went well?',0,0,0,0,0,0,1,0,6,0,0,93714,26124),
(141909,'Indeed. He is eager to have the Army of the Light fighting on the side of the Alliance. Assemble our forces, captain, and I will make the announcement.','',0,0,0,0,0,0,1,0,0,0,93734,0,26124),
(141910,'','You know how fond I am of your speeches, but can it wait? We were just about to send these initiates to undertake the trials.',0,0,0,0,0,0,1,0,0,0,0,93715,26124),
(141911,'Ah, this is excellent timing, champion. You can see firsthand what it means for a soldier to become Lightforged. Proceed, Fareeya.','',0,0,0,0,0,0,1,0,0,0,93735,0,26124),
(141912,'','For thousands of years, the Lightforged fought demons in the Twisting Nether. The Xenedar was the only home we knew.',0,0,0,0,0,0,1,0,0,0,0,93696,26124),
(141913,'','Now, for the first time in ages, we can walk beneath a sky not befouled by the Legion\'s madness... and feel the earth under our hooves again.',0,0,0,0,0,0,1,0,0,0,0,93697,26124),
(141914,'','But we must not grow complacent. One war ends, the next begins. Such is the life of a soldier.',0,0,0,0,0,0,1,0,0,0,0,93698,26124),
(141915,'','Your duty begins in Stormwind. Explore this world of Azeroth. Get to know the people and places we have sworn to defend.',0,0,0,0,0,0,1,0,0,0,0,93699,26124),
(141916,'','And always walk in the Light, $p.',0,0,0,0,0,0,1,0,0,0,0,93700,26124),
(141918,'','For many ages, our people have called the Broken Isles home. We know little about the Azeroth that exists beyond our shores.',0,0,0,0,0,0,1,0,0,0,0,93861,26124),
(141919,'','It is time we changed that.',0,0,0,0,0,0,1,0,0,0,0,93862,26124),
(141920,'','Today you begin a new journey, $p. You will be our voice in the lands beyond the mountain.',0,0,0,0,0,0,0,0,0,0,0,93863,26124),
(141921,'','Go to Orgrimmar. Meet our new allies and learn what it is they care about... what they fight for.',0,0,0,0,0,0,1,0,0,0,0,93864,26124),
(141922,'','Stay true to who you are. And should you ever miss your home, know that Highmountain is here for you. Always.',0,0,0,0,0,0,1,0,0,0,0,93865,26124),
(141927,'|TInterface\\Icons\\Ability_Argus_WastingPlague:20|tYou are afflicted with |cFFFF0000|Hspell:248396|h[Soulblight]|h|r!','|TInterface\\Icons\\Ability_Argus_WastingPlague:20|tYou are afflicted with |cFFFF0000|Hspell:248396|h[Soulblight]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(141931,'S.E.L.F.I.E. Camera captures Twilight Filter!','S.E.L.F.I.E. Camera captures Twilight Filter!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141932,'S.E.L.F.I.E. Camera captures Firelands Filter!','S.E.L.F.I.E. Camera captures Firelands Filter!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141933,'S.E.L.F.I.E. Camera captures Sha Filter!','S.E.L.F.I.E. Camera captures Sha Filter!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141934,'S.E.L.F.I.E. Camera captures Frostmourne Filter!','S.E.L.F.I.E. Camera captures Frostmourne Filter!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141935,'S.E.L.F.I.E. Camera captures Argus Filter!','S.E.L.F.I.E. Camera captures Argus Filter!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(141940,'','Your sojourn through Azeroth has been long, $p. And through it all, you have brought honor to Highmountain.',0,0,0,0,0,0,1,0,0,0,0,93866,26124),
(141941,'','Now Thunder Totem calls you home. It is time we thank you for all that you have done for us.',0,0,0,0,0,0,1,0,0,0,0,93867,26124),
(141943,'','Through the darkest times, you have been strong, brave, unyielding. Thanks to you, $p, the Horde knows what it means to be Highmountain.',0,0,0,0,0,0,1,0,0,0,0,93900,26124),
(141944,'','It is my honor to present you with the armor of our people. No matter where your journey takes you, it will serve as a reminder of where you came from.',0,0,0,0,0,0,1,0,0,0,0,93868,26124),
(141947,'','Your service to the Alliance has been most impressive, $p. I could not have done better myself. Well, I could... but not by much.',0,0,0,0,0,0,1,0,0,0,0,93701,26124),
(141948,'','Come, meet with me at the Vindicaar. It is time that we reward your diligence.',0,0,0,0,0,0,1,0,0,0,0,93702,26124),
(141949,'','Throughout your journeys, you have been a beacon of Light in the darkness. You have shown the Alliance what it means to be Lightforged.',0,0,0,0,0,0,1,0,0,0,0,93703,26124),
(141950,'','Wear these vestments with pride, $p. The Army of the Light will always be honored to count you in its ranks.',0,0,0,0,0,0,1,0,0,0,0,93704,26124),
(141951,'This way!','',0,0,0,0,0,0,1,0,0,0,93833,0,26124),
(141952,'Over here!','',0,0,0,0,0,0,1,0,0,0,93834,0,26124),
(141953,'Look out!','',0,0,0,0,0,0,603,0,0,0,93835,0,26124),
(141954,'The enemy is all around us!','',0,0,0,0,0,0,603,0,0,0,93836,0,26124),
(142029,'Highmountain stands.','',0,0,0,0,0,0,0,0,0,0,94168,0,26124),
(142033,'Greetings, traveler.','',0,0,0,0,0,0,0,0,0,0,94169,0,26124),
(142034,'The river provides.','',0,0,0,0,0,0,0,0,0,0,94170,0,26124),
(142035,'What has the wind brought?','',0,0,0,0,0,0,0,0,0,0,94171,0,26124),
(142054,'We will not fear the darkness.','',0,0,0,0,0,0,0,0,0,0,94172,0,26124),
(142055,'Peace and patience, friend.','',0,0,0,0,0,0,0,0,0,0,94173,0,26124),
(142056,'We defend this world together.','',0,0,0,0,0,0,0,0,0,0,94174,0,26124),
(142057,'Beware the deep places of the earth.','',0,0,0,0,0,0,0,0,0,0,94161,0,26124),
(142058,'Together, we are Highmountain.','',0,0,0,0,0,0,0,0,0,0,94162,0,26124),
(142059,'An\'she guide you.','',0,0,0,0,0,0,0,0,0,0,94163,0,26124),
(142060,'May your rivers be ever bountiful.','',0,0,0,0,0,0,0,0,0,0,94164,0,26124),
(142061,'Ride the winds.','',0,0,0,0,0,0,0,0,0,0,94165,0,26124),
(142062,'Sun and moon light your way.','',0,0,0,0,0,0,0,0,0,0,94166,0,26124),
(142063,'Remember the Earthmother\'s lessons.','',0,0,0,0,0,0,0,0,0,0,94167,0,26124),
(142064,'Annoy me and you\'ll get the rack.','',0,0,0,0,0,0,0,0,0,0,94183,0,26124),
(142065,'Those who offend Highmountain are in for a fall. A loooooong fall.','',0,0,0,0,0,0,0,0,0,0,94184,0,26124),
(142066,'Keep it up and you\'ll get a swift hoof to the backside.','',0,0,0,0,0,0,0,0,0,0,94185,0,26124),
(142067,'Find yourself a deep place of the earth and get lost.','',0,0,0,0,0,0,0,0,0,0,94186,0,26124),
(142068,'Have you come to trade?','',0,0,0,0,0,0,0,0,0,0,94179,0,26124),
(142069,'I have just the thing for you.','',0,0,0,0,0,0,0,0,0,0,94180,0,26124),
(142070,'Feel free to browse.','',0,0,0,0,0,0,0,0,0,0,94181,0,26124),
(142071,'I offer Highmountain\'s finest.','',0,0,0,0,0,0,0,0,0,0,94182,0,26124),
(142072,'Come back again.','',0,0,0,0,0,0,0,0,0,0,94175,0,26124),
(142073,'Pleasure doing business.','',0,0,0,0,0,0,0,0,0,0,94176,0,26124),
(142074,'See you soon.','',0,0,0,0,0,0,0,0,0,0,94177,0,26124),
(142075,'We replenish stock daily.','',0,0,0,0,0,0,0,0,0,0,94178,0,26124),
(142078,'','We replenish stock daily.',0,0,0,0,0,0,0,0,0,0,0,94100,26124),
(142079,'','See you soon.',0,0,0,0,0,0,0,0,0,0,0,94099,26124),
(142083,'','Pleasure doing business.',0,0,0,0,0,0,0,0,0,0,0,94098,26124),
(142084,'','Come back again.',0,0,0,0,0,0,0,0,0,0,0,94097,26124),
(142085,'','I offer Highmountain\'s finest.',0,0,0,0,0,0,0,0,0,0,0,94104,26124),
(142086,'','Feel free to browse.',0,0,0,0,0,0,0,0,0,0,0,94103,26124),
(142087,'','I have just the thing for you.',0,0,0,0,0,0,0,0,0,0,0,94102,26124),
(142088,'','Have you come to trade?',0,0,0,0,0,0,0,0,0,0,0,94101,26124),
(142089,'','Find yourself a deep place of the earth and get lost.',0,0,0,0,0,0,0,0,0,0,0,94108,26124),
(142090,'','Keep it up and you\'ll get a swift hoof to the backside.',0,0,0,0,0,0,0,0,0,0,0,94107,26124),
(142091,'','Those who offend Highmountain are in for a fall. A loooooong fall.',0,0,0,0,0,0,0,0,0,0,0,94106,26124),
(142092,'','Annoy me and you\'ll get the rack.',0,0,0,0,0,0,0,0,0,0,0,94105,26124),
(142093,'','Remember the Earthmother\'s lessons.',0,0,0,0,0,0,0,0,0,0,0,94089,26124),
(142094,'','Sun and moon light your way.',0,0,0,0,0,0,0,0,0,0,0,94088,26124),
(142095,'','Ride the winds.',0,0,0,0,0,0,0,0,0,0,0,94087,26124),
(142096,'','May your rivers be ever bountiful.',0,0,0,0,0,0,0,0,0,0,0,94086,26124),
(142097,'','An\'she guide you.',0,0,0,0,0,0,0,0,0,0,0,94085,26124),
(142098,'','Together, we are Highmountain.',0,0,0,0,0,0,0,0,0,0,0,94084,26124),
(142099,'','Beware the deep places of the earth.',0,0,0,0,0,0,0,0,0,0,0,94083,26124),
(142100,'','We defend this world together.',0,0,0,0,0,0,0,0,0,0,0,94096,26124),
(142101,'','Peace and patience, friend.',0,0,0,0,0,0,0,0,0,0,0,94095,26124),
(142102,'','We will not fear the darkness.',0,0,0,0,0,0,0,0,0,0,0,94094,26124),
(142103,'','What has the wind brought?',0,0,0,0,0,0,0,0,0,0,0,94093,26124),
(142104,'','The river provides.',0,0,0,0,0,0,0,0,0,0,0,94092,26124),
(142105,'','Greetings, traveler.',0,0,0,0,0,0,0,0,0,0,0,94091,26124),
(142106,'','Highmountain stands.',0,0,0,0,0,0,0,0,0,0,0,94090,26124),
(142107,'We replenish our stock daily.','',0,0,0,0,0,0,0,0,0,0,94204,0,26124),
(142108,'See you soon.','',0,0,0,0,0,0,0,0,0,0,94203,0,26124),
(142109,'Pleasure doing business.','',0,0,0,0,0,0,0,0,0,0,94202,0,26124),
(142110,'Come back again.','',0,0,0,0,0,0,0,0,0,0,94201,0,26124),
(142111,'I offer Highmountain\'s finest.','',0,0,0,0,0,0,0,0,0,0,94208,0,26124),
(142112,'Feel free to browse.','',0,0,0,0,0,0,0,0,0,0,94207,0,26124),
(142113,'I have just the thing for you.','',0,0,0,0,0,0,0,0,0,0,94206,0,26124),
(142114,'Have you come to trade?','',0,0,0,0,0,0,0,0,0,0,94205,0,26124),
(142115,'Find yourself a deep place of the earth and get lost.','',0,0,0,0,0,0,0,0,0,0,94212,0,26124),
(142116,'Keep it up and you\'ll get a swift hoof to the backside.','',0,0,0,0,0,0,0,0,0,0,94211,0,26124),
(142117,'Those who offend Highmountain are in for a fall. A loooooong fall.','',0,0,0,0,0,0,0,0,0,0,94210,0,26124),
(142118,'Annoy me and you\'ll get the rack.','',0,0,0,0,0,0,0,0,0,0,94209,0,26124),
(142119,'Remember the Earthmother\'s lessons.','',0,0,0,0,0,0,0,0,0,0,94193,0,26124),
(142120,'Sun and moon light your way.','',0,0,0,0,0,0,0,0,0,0,94192,0,26124),
(142121,'Ride the winds.','',0,0,0,0,0,0,0,0,0,0,94191,0,26124),
(142122,'May your rivers be ever bountiful.','',0,0,0,0,0,0,0,0,0,0,94190,0,26124),
(142123,'An\'she guide you.','',0,0,0,0,0,0,0,0,0,0,94189,0,26124),
(142124,'Together, we are Highmountain.','',0,0,0,0,0,0,0,0,0,0,94188,0,26124),
(142125,'I do not fear the deep places of the earth.','',0,0,0,0,0,0,0,0,0,0,94187,0,26124),
(142126,'We defend this world together.','',0,0,0,0,0,0,0,0,0,0,94200,0,26124),
(142127,'Remain vigilant.','',0,0,0,0,0,0,0,0,0,0,94199,0,26124),
(142128,'We defend against the darkness.','',0,0,0,0,0,0,0,0,0,0,94198,0,26124),
(142129,'What has the wind brought?','',0,0,0,0,0,0,0,0,0,0,94197,0,26124),
(142130,'The river provides.','',0,0,0,0,0,0,0,0,0,0,94196,0,26124),
(142131,'Keep to the roads, traveler.','',0,0,0,0,0,0,0,0,0,0,94195,0,26124),
(142132,'We defend Highmountain.','',0,0,0,0,0,0,0,0,0,0,94194,0,26124),
(142133,'','We defend Highmountain.',0,0,0,0,0,0,0,0,0,0,0,94116,26124),
(142134,'','Keep to the roads, traveler.',0,0,0,0,0,0,0,0,0,0,0,94117,26124),
(142135,'','The river provides.',0,0,0,0,0,0,0,0,0,0,0,94118,26124),
(142136,'','What has the wind brought?',0,0,0,0,0,0,0,0,0,0,0,94119,26124),
(142137,'','We defend against the darkness.',0,0,0,0,0,0,0,0,0,0,0,94120,26124),
(142138,'','Remain vigilant.',0,0,0,0,0,0,0,0,0,0,0,94121,26124),
(142139,'','We defend this world together.',0,0,0,0,0,0,0,0,0,0,0,94122,26124),
(142140,'','I do not fear the deep places of the earth.',0,0,0,0,0,0,0,0,0,0,0,94109,26124),
(142141,'','Together, we are Highmountain.',0,0,0,0,0,0,0,0,0,0,0,94110,26124),
(142142,'','An\'she guide you.',0,0,0,0,0,0,0,0,0,0,0,94111,26124),
(142143,'','May your rivers be ever bountiful.',0,0,0,0,0,0,0,0,0,0,0,94112,26124),
(142144,'','Ride the winds.',0,0,0,0,0,0,0,0,0,0,0,94113,26124),
(142145,'','Sun and moon light your way.',0,0,0,0,0,0,0,0,0,0,0,94114,26124),
(142146,'','Remember the Earthmother\'s lessons.',0,0,0,0,0,0,0,0,0,0,0,94115,26124),
(142147,'','Annoy me and you\'ll get the rack.',0,0,0,0,0,0,0,0,0,0,0,94131,26124),
(142148,'','Those who offend Highmountain are in for a fall. A loooooong fall.',0,0,0,0,0,0,0,0,0,0,0,94132,26124),
(142149,'','Keep it up and you\'ll get a swift hoof to the backside.',0,0,0,0,0,0,0,0,0,0,0,94133,26124),
(142150,'','Find yourself a deep place of the earth and get lost.',0,0,0,0,0,0,0,0,0,0,0,94134,26124),
(142151,'','Have you come to trade?',0,0,0,0,0,0,0,0,0,0,0,94127,26124),
(142152,'','I have just the thing for you.',0,0,0,0,0,0,0,0,0,0,0,94128,26124),
(142153,'','Feel free to browse.',0,0,0,0,0,0,0,0,0,0,0,94129,26124),
(142154,'','I offer Highmountain\'s finest.',0,0,0,0,0,0,0,0,0,0,0,94130,26124),
(142155,'','Come back again.',0,0,0,0,0,0,0,0,0,0,0,94123,26124),
(142156,'','Pleasure doing business.',0,0,0,0,0,0,0,0,0,0,0,94124,26124),
(142157,'','See you soon.',0,0,0,0,0,0,0,0,0,0,0,94125,26124),
(142158,'','We replenish stock daily.',0,0,0,0,0,0,0,0,0,0,0,94126,26124),
(142159,'','We defend Highmountain.',0,0,0,0,0,0,0,0,0,0,0,94142,26124),
(142160,'','Greetings, traveler.',0,0,0,0,0,0,0,0,0,0,0,94143,26124),
(142161,'','The river provides.',0,0,0,0,0,0,0,0,0,0,0,94144,26124),
(142162,'','What has the wind brought?',0,0,0,0,0,0,0,0,0,0,0,94145,26124),
(142163,'','We will not fear the darkness.',0,0,0,0,0,0,0,0,0,0,0,94146,26124),
(142164,'','Peace and patience, friend.',0,0,0,0,0,0,0,0,0,0,0,94147,26124),
(142165,'','We defend this world together.',0,0,0,0,0,0,0,0,0,0,0,94148,26124),
(142166,'','I do not fear the deep places of the earth.',0,0,0,0,0,0,0,0,0,0,0,94135,26124),
(142167,'','Together, we are Highmountain.',0,0,0,0,0,0,0,0,0,0,0,94136,26124),
(142168,'','An\'she guide you.',0,0,0,0,0,0,0,0,0,0,0,94137,26124),
(142169,'','May your rivers be ever bountiful.',0,0,0,0,0,0,0,0,0,0,0,94138,26124),
(142170,'','Ride the winds.',0,0,0,0,0,0,0,0,0,0,0,94139,26124),
(142171,'','Sun and moon light your way.',0,0,0,0,0,0,0,0,0,0,0,94140,26124),
(142172,'','Remember the Earthmother\'s lessons.',0,0,0,0,0,0,0,0,0,0,0,94141,26124),
(142173,'','Annoy me and you\'ll get the rack.',0,0,0,0,0,0,0,0,0,0,0,94157,26124),
(142174,'','Those who offend Highmountain are in for a fall. A loooooong fall.',0,0,0,0,0,0,0,0,0,0,0,94158,26124),
(142175,'','Keep it up and you\'ll get a swift hoof to the backside.',0,0,0,0,0,0,0,0,0,0,0,94159,26124),
(142176,'','Find yourself a deep place of the earth and get lost.',0,0,0,0,0,0,0,0,0,0,0,94160,26124),
(142177,'','Have you come to trade?',0,0,0,0,0,0,0,0,0,0,0,94153,26124),
(142178,'','I have just the thing for you.',0,0,0,0,0,0,0,0,0,0,0,94154,26124),
(142179,'','Feel free to browse.',0,0,0,0,0,0,0,0,0,0,0,94155,26124),
(142180,'','I offer Highmountain\'s finest.',0,0,0,0,0,0,0,0,0,0,0,94156,26124),
(142181,'','Come back again.',0,0,0,0,0,0,0,0,0,0,0,94149,26124),
(142182,'','Pleasure doing business.',0,0,0,0,0,0,0,0,0,0,0,94150,26124),
(142183,'','See you soon.',0,0,0,0,0,0,0,0,0,0,0,94151,26124),
(142184,'','We replenish stock daily.',0,0,0,0,0,0,0,0,0,0,0,94152,26124),
(142186,'I do not fear the deep places of the earth.','',0,0,0,0,0,0,0,0,0,0,94213,0,26124),
(142187,'Together, we are Highmountain.','',0,0,0,0,0,0,0,0,0,0,94214,0,26124),
(142188,'An\'she guide you.','',0,0,0,0,0,0,0,0,0,0,94215,0,26124),
(142189,'May your rivers be ever bountiful.','',0,0,0,0,0,0,0,0,0,0,94216,0,26124),
(142190,'Ride the winds.','',0,0,0,0,0,0,0,0,0,0,94217,0,26124),
(142191,'Sun and moon light your way.','',0,0,0,0,0,0,0,0,0,0,94218,0,26124),
(142192,'Remember the Earthmother\'s lessons.','',0,0,0,0,0,0,0,0,0,0,94219,0,26124),
(142193,'Annoy me and you\'ll get the rack.','',0,0,0,0,0,0,0,0,0,0,94235,0,26124),
(142194,'Those who offend Highmountain are in for a fall. A loooooong fall.','',0,0,0,0,0,0,0,0,0,0,94236,0,26124),
(142195,'Keep it up and you\'ll get a swift hoof to the backside.','',0,0,0,0,0,0,0,0,0,0,94237,0,26124),
(142196,'Find yourself a deep place of the earth and get lost.','',0,0,0,0,0,0,0,0,0,0,94238,0,26124),
(142197,'Have you come to trade?','',0,0,0,0,0,0,0,0,0,0,94231,0,26124),
(142198,'I have just the thing for you.','',0,0,0,0,0,0,0,0,0,0,94232,0,26124),
(142199,'Feel free to browse.','',0,0,0,0,0,0,0,0,0,0,94233,0,26124),
(142200,'I offer Highmountain\'s finest.','',0,0,0,0,0,0,0,0,0,0,94234,0,26124),
(142201,'Come back again.','',0,0,0,0,0,0,0,0,0,0,94227,0,26124),
(142202,'Pleasure doing business.','',0,0,0,0,0,0,0,0,0,0,94228,0,26124),
(142203,'See you soon.','',0,0,0,0,0,0,0,0,0,0,94229,0,26124),
(142205,'We replenish stock daily.','',0,0,0,0,0,0,0,0,0,0,94230,0,26124),
(142208,'We defend Highmountain.','',0,0,0,0,0,0,0,0,0,0,94220,0,26124),
(142209,'Keep to the roads, traveler.','',0,0,0,0,0,0,0,0,0,0,94221,0,26124),
(142210,'The river provides.','',0,0,0,0,0,0,0,0,0,0,94222,0,26124),
(142211,'What has the wind brought?','',0,0,0,0,0,0,0,0,0,0,94223,0,26124),
(142212,'We defend against the darkness.','',0,0,0,0,0,0,0,0,0,0,94224,0,26124),
(142213,'Remain vigilant.','',0,0,0,0,0,0,0,0,0,0,94225,0,26124),
(142214,'We defend this world together.','',0,0,0,0,0,0,0,0,0,0,94226,0,26124),
(142229,'','I\'d like to offer you a tour of our ship... starting with the airlock.',0,0,0,0,0,0,0,0,0,0,0,93952,26124),
(142230,'','Regulations require me to tolerate your behavior... for a time.',0,0,0,0,0,0,0,0,0,0,0,93951,26124),
(142231,'','Are you looking for a one-way trip to the Nether?',0,0,0,0,0,0,0,0,0,0,0,93950,26124),
(142232,'','You test a soldier\'s patience.',0,0,0,0,0,0,0,0,0,0,0,93949,26124),
(142233,'','May I be of service?',0,0,0,0,0,0,0,0,0,0,0,93948,26124),
(142234,'','We have reasonable prices.',0,0,0,0,0,0,0,0,0,0,0,93947,26124),
(142235,'','I hope you find something useful.',0,0,0,0,0,0,0,0,0,0,0,93946,26124),
(142236,'','Browse at  your leisure, friend.',0,0,0,0,0,0,0,0,0,0,0,93945,26124),
(142237,'','Your coin is always welcome.',0,0,0,0,0,0,0,0,0,0,0,93944,26124),
(142238,'','My goods will serve you well.',0,0,0,0,0,0,0,0,0,0,0,93943,26124),
(142239,'','Enjoy your purchases.',0,0,0,0,0,0,0,0,0,0,0,93942,26124),
(142240,'','Thank you for browsing.',0,0,0,0,0,0,0,0,0,0,0,93941,26124),
(142247,'','Archenon poros.',0,0,0,0,0,0,0,0,0,0,0,93934,26124),
(142248,'','Destiny is ours to forge.',0,0,0,0,0,0,0,0,0,0,0,93933,26124),
(142249,'','Argus will always be remembered in our hearts.',0,0,0,0,0,0,0,0,0,0,0,93932,26124),
(142250,'','We are reborn in the Light.',0,0,0,0,0,0,0,0,0,0,0,93931,26124),
(142251,'','Remain vigilant.',0,0,0,0,0,0,0,0,0,0,0,93930,26124),
(142252,'','Dioniss aca.',0,0,0,0,0,0,0,0,0,0,0,93929,26124),
(142253,'','Light guide your footsteps.',0,0,0,0,0,0,0,0,0,0,0,93928,26124),
(142254,'','Remember the lessons of the past.',0,0,0,0,0,0,0,0,0,0,0,93927,26124),
(142258,'','Good fortune to the Alliance.',0,0,0,0,0,0,0,0,0,0,0,93935,26124),
(142259,'','The Light will not forget us.',0,0,0,0,0,0,0,0,0,0,0,93936,26124),
(142260,'','One war ends, the next begins.',0,0,0,0,0,0,0,0,0,0,0,93937,26124),
(142261,'','Achal hecta.',0,0,0,0,0,0,0,0,0,0,0,93938,26124),
(142262,'','May the Light embrace you.',0,0,0,0,0,0,0,0,0,0,0,93939,26124),
(142263,'','It is our duty to serve.',0,0,0,0,0,0,0,0,0,0,0,93940,26124),
(142264,'I\'d like to offer you a tour of our ship... starting with the airlock.','',0,0,0,0,0,0,0,0,0,0,94030,0,26124),
(142265,'Regulations require me to tolerate your behavior... for a time.','',0,0,0,0,0,0,0,0,0,0,94029,0,26124),
(142266,'Are you looking for a one-way trip to the Nether?','',0,0,0,0,0,0,0,0,0,0,94028,0,26124),
(142267,'You test a soldier\'s patience.','',0,0,0,0,0,0,0,0,0,0,94027,0,26124),
(142268,'May I be of service?','',0,0,0,0,0,0,0,0,0,0,94026,0,26124),
(142269,'We have reasonable prices.','',0,0,0,0,0,0,0,0,0,0,94025,0,26124),
(142270,'I hope you find something useful.','',0,0,0,0,0,0,0,0,0,0,94024,0,26124),
(142271,'Browse at  your leisure, friend.','',0,0,0,0,0,0,0,0,0,0,94023,0,26124),
(142273,'Your coin is always welcome.','',0,0,0,0,0,0,0,0,0,0,94022,0,26124),
(142274,'My goods will serve you well.','',0,0,0,0,0,0,0,0,0,0,94021,0,26124),
(142275,'Enjoy your purchases.','',0,0,0,0,0,0,0,0,0,0,94020,0,26124),
(142276,'Thank you for browsing.','',0,0,0,0,0,0,0,0,0,0,94019,0,26124),
(142277,'It is our duty to serve.','',0,0,0,0,0,0,0,0,0,0,94018,0,26124),
(142278,'May the Light embrace you.','',0,0,0,0,0,0,0,0,0,0,94017,0,26124),
(142279,'Achal hecta.','',0,0,0,0,0,0,0,0,0,0,94016,0,26124),
(142280,'One war ends, the next begins.','',0,0,0,0,0,0,0,0,0,0,94015,0,26124),
(142281,'The Light will not forget us.','',0,0,0,0,0,0,0,0,0,0,94014,0,26124),
(142282,'Good fortune to the Alliance.','',0,0,0,0,0,0,0,0,0,0,94013,0,26124),
(142283,'Archenon poros.','',0,0,0,0,0,0,0,0,0,0,94012,0,26124),
(142284,'Destiny is ours to forge.','',0,0,0,0,0,0,0,0,0,0,94011,0,26124),
(142285,'Argus will always be remembered in our hearts.','',0,0,0,0,0,0,0,0,0,0,94010,0,26124),
(142286,'We are reborn in the Light.','',0,0,0,0,0,0,0,0,0,0,94009,0,26124),
(142287,'Remain vigilant.','',0,0,0,0,0,0,0,0,0,0,94008,0,26124),
(142288,'Dioniss aca.','',0,0,0,0,0,0,0,0,0,0,94007,0,26124),
(142289,'Light guide your footsteps.','',0,0,0,0,0,0,0,0,0,0,94006,0,26124),
(142290,'Remember the lessons of the past.','',0,0,0,0,0,0,0,0,0,0,94005,0,26124),
(142292,'','I\'d like to offer you a tour of our ship... starting with the airlock.',0,0,0,0,0,0,0,0,0,0,0,93978,26124),
(142293,'','Regulations require me to tolerate your behavior... for a time.',0,0,0,0,0,0,0,0,0,0,0,93977,26124),
(142294,'','Are you looking for a one-way trip to the Nether?',0,0,0,0,0,0,0,0,0,0,0,93976,26124),
(142296,'','You test a soldier\'s patience.',0,0,0,0,0,0,0,0,0,0,0,93975,26124),
(142297,'','May I be of service?',0,0,0,0,0,0,0,0,0,0,0,93974,26124),
(142298,'','We have reasonable prices.',0,0,0,0,0,0,0,0,0,0,0,93973,26124),
(142299,'','I hope you find something useful.',0,0,0,0,0,0,0,0,0,0,0,93972,26124),
(142300,'','Browse at  your leisure, friend.',0,0,0,0,0,0,0,0,0,0,0,93971,26124),
(142301,'','Your coin is always welcome.',0,0,0,0,0,0,0,0,0,0,0,93970,26124),
(142302,'','My goods will serve you well.',0,0,0,0,0,0,0,0,0,0,0,93969,26124),
(142303,'','Enjoy your purchases.',0,0,0,0,0,0,0,0,0,0,0,93968,26124),
(142304,'','Thank you for browsing.',0,0,0,0,0,0,0,0,0,0,0,93967,26124),
(142305,'','It is our duty to serve.',0,0,0,0,0,0,0,0,0,0,0,93966,26124),
(142306,'','May the Light protect you.',0,0,0,0,0,0,0,0,0,0,0,93965,26124),
(142307,'','Achal hecta.',0,0,0,0,0,0,0,0,0,0,0,93964,26124),
(142308,'','One war ends, the next begins.',0,0,0,0,0,0,0,0,0,0,0,93963,26124),
(142309,'','The Light will not forget our sacrifice.',0,0,0,0,0,0,0,0,0,0,0,93962,26124),
(142310,'','We stand with the Alliance.',0,0,0,0,0,0,0,0,0,0,0,93961,26124),
(142311,'','Archenon poros.',0,0,0,0,0,0,0,0,0,0,0,93960,26124),
(142312,'','Destiny is ours to forge.',0,0,0,0,0,0,0,0,0,0,0,93959,26124),
(142313,'','Argus will always be remembered.',0,0,0,0,0,0,0,0,0,0,0,93958,26124),
(142315,'','We are made strong in the Light.',0,0,0,0,0,0,0,0,0,0,0,93957,26124),
(142316,'','Remain vigilant.',0,0,0,0,0,0,0,0,0,0,0,93956,26124),
(142317,'','Dioniss aca.',0,0,0,0,0,0,0,0,0,0,0,93955,26124),
(142318,'','Light guide us to victory.',0,0,0,0,0,0,0,0,0,0,0,93954,26124),
(142319,'','Our enemies lack our conviction.',0,0,0,0,0,0,0,0,0,0,0,93953,26124),
(142320,'I\'d like to offer you a tour of our ship... starting with the airlock.','',0,0,0,0,0,0,0,0,0,0,94056,0,26124),
(142321,'Regulations require me to tolerate your behavior... for a time.','',0,0,0,0,0,0,0,0,0,0,94055,0,26124),
(142322,'Are you looking for a one-way trip to the Nether?','',0,0,0,0,0,0,0,0,0,0,94054,0,26124),
(142323,'You test a soldier\'s patience.','',0,0,0,0,0,0,0,0,0,0,94053,0,26124),
(142325,'May I be of service?','',0,0,0,0,0,0,0,0,0,0,94052,0,26124),
(142326,'We have reasonable prices.','',0,0,0,0,0,0,0,0,0,0,94051,0,26124),
(142327,'I hope you find something useful.','',0,0,0,0,0,0,0,0,0,0,94050,0,26124),
(142328,'Browse at  your leisure, friend.','',0,0,0,0,0,0,0,0,0,0,94049,0,26124),
(142329,'Your coin is always welcome.','',0,0,0,0,0,0,0,0,0,0,94048,0,26124),
(142330,'My goods will serve you well.','',0,0,0,0,0,0,0,0,0,0,94047,0,26124),
(142331,'Enjoy your purchases.','',0,0,0,0,0,0,0,0,0,0,94046,0,26124),
(142332,'Thank you for browsing.','',0,0,0,0,0,0,0,0,0,0,94045,0,26124),
(142333,'It is our duty to serve.','',0,0,0,0,0,0,0,0,0,0,94044,0,26124),
(142334,'May the Light protect you.','',0,0,0,0,0,0,0,0,0,0,94043,0,26124),
(142335,'Achal hecta.','',0,0,0,0,0,0,0,0,0,0,94042,0,26124),
(142336,'One war ends, the next begins.','',0,0,0,0,0,0,0,0,0,0,94041,0,26124),
(142337,'The Light will not forget our sacrifice.','',0,0,0,0,0,0,0,0,0,0,94040,0,26124),
(142338,'We stand with the Alliance.','',0,0,0,0,0,0,0,0,0,0,94039,0,26124),
(142339,'Archenon poros.','',0,0,0,0,0,0,0,0,0,0,94038,0,26124),
(142340,'Destiny is ours to forge.','',0,0,0,0,0,0,0,0,0,0,94037,0,26124),
(142341,'Argus will always be remembered.','',0,0,0,0,0,0,0,0,0,0,94036,0,26124),
(142342,'We are made strong in the Light.','',0,0,0,0,0,0,0,0,0,0,94035,0,26124),
(142343,'Remain vigilant.','',0,0,0,0,0,0,0,0,0,0,94034,0,26124),
(142344,'Dioniss aca.','',0,0,0,0,0,0,0,0,0,0,94033,0,26124),
(142345,'Light guide us to victory.','',0,0,0,0,0,0,0,0,0,0,94032,0,26124),
(142346,'Our enemies lack our conviction.','',0,0,0,0,0,0,0,0,0,0,94031,0,26124),
(142348,'Our enemies lack our conviction.','',0,0,0,0,0,0,0,0,0,0,94057,0,26124),
(142349,'The Light will guide us to victory.','',0,0,0,0,0,0,0,0,0,0,94058,0,26124),
(142350,'Dioniss aca.','',0,0,0,0,0,0,0,0,0,0,94059,0,26124),
(142351,'Always be on guard.','',0,0,0,0,0,0,0,0,0,0,94060,0,26124),
(142352,'We are one with the Light.','',0,0,0,0,0,0,0,0,0,0,94061,0,26124),
(142353,'Together, we can bring down any foe.','',0,0,0,0,0,0,0,0,0,0,94062,0,26124),
(142354,'Let us forge our destiny.','',0,0,0,0,0,0,0,0,0,0,94063,0,26124),
(142355,'Archenon poros.','',0,0,0,0,0,0,0,0,0,0,94064,0,26124),
(142356,'We stand with the Alliance.','',0,0,0,0,0,0,0,0,0,0,94065,0,26124),
(142357,'The Light demands vigilance and sacrifice.','',0,0,0,0,0,0,0,0,0,0,94066,0,26124),
(142358,'One war ends, the next begins.','',0,0,0,0,0,0,0,0,0,0,94067,0,26124),
(142359,'Achal hecta.','',0,0,0,0,0,0,0,0,0,0,94068,0,26124),
(142360,'Light defend us all.','',0,0,0,0,0,0,0,0,0,0,94069,0,26124),
(142361,'It is our honor to serve.','',0,0,0,0,0,0,0,0,0,0,94070,0,26124),
(142362,'Thank you for browsing.','',0,0,0,0,0,0,0,0,0,0,94071,0,26124),
(142363,'Enjoy your purchases.','',0,0,0,0,0,0,0,0,0,0,94072,0,26124),
(142364,'My goods will serve you well.','',0,0,0,0,0,0,0,0,0,0,94073,0,26124),
(142365,'Your coin is always welcome.','',0,0,0,0,0,0,0,0,0,0,94074,0,26124),
(142366,'Browse at  your leisure, friend.','',0,0,0,0,0,0,0,0,0,0,94075,0,26124),
(142367,'I hope you find something useful.','',0,0,0,0,0,0,0,0,0,0,94076,0,26124),
(142368,'We have reasonable prices.','',0,0,0,0,0,0,0,0,0,0,94077,0,26124),
(142369,'May I be of service?','',0,0,0,0,0,0,0,0,0,0,94078,0,26124),
(142370,'You test a soldier\'s patience.','',0,0,0,0,0,0,0,0,0,0,94079,0,26124),
(142371,'Are you looking for a one-way trip to the Nether?','',0,0,0,0,0,0,0,0,0,0,94080,0,26124),
(142372,'Regulations require me to tolerate your behavior... for a time.','',0,0,0,0,0,0,0,0,0,0,94081,0,26124),
(142373,'I\'d like to offer you a tour of our ship... starting with the airlock.','',0,0,0,0,0,0,0,0,0,0,94082,0,26124),
(142374,'','I\'d like to offer you a tour of our ship... starting with the airlock.',0,0,0,0,0,0,0,0,0,0,0,94004,26124),
(142375,'','Regulations require me to tolerate your behavior... for a time.',0,0,0,0,0,0,0,0,0,0,0,94003,26124),
(142376,'','Are you looking for a one-way trip to the Nether?',0,0,0,0,0,0,0,0,0,0,0,94002,26124),
(142377,'','You test a soldier\'s patience.',0,0,0,0,0,0,0,0,0,0,0,94001,26124),
(142378,'','May I be of service?',0,0,0,0,0,0,0,0,0,0,0,94000,26124),
(142379,'','We have reasonable prices.',0,0,0,0,0,0,0,0,0,0,0,93999,26124),
(142380,'','I hope you find something useful.',0,0,0,0,0,0,0,0,0,0,0,93998,26124),
(142381,'','Browse at  your leisure, friend.',0,0,0,0,0,0,0,0,0,0,0,93997,26124),
(142382,'','Your coin is always welcome.',0,0,0,0,0,0,0,0,0,0,0,93996,26124),
(142383,'','My goods will serve you well.',0,0,0,0,0,0,0,0,0,0,0,93995,26124),
(142384,'','Enjoy your purchases.',0,0,0,0,0,0,0,0,0,0,0,93994,26124),
(142385,'','Thank you for browsing.',0,0,0,0,0,0,0,0,0,0,0,93993,26124),
(142386,'','It is our honor to serve.',0,0,0,0,0,0,0,0,0,0,0,93992,26124),
(142387,'','Light defend us all.',0,0,0,0,0,0,0,0,0,0,0,93991,26124),
(142388,'','Achal hecta.',0,0,0,0,0,0,0,0,0,0,0,93990,26124),
(142389,'','One war ends, the next begins.',0,0,0,0,0,0,0,0,0,0,0,93989,26124),
(142390,'','The Light demands vigilance and sacrifice.',0,0,0,0,0,0,0,0,0,0,0,93988,26124),
(142391,'','We stand with the Alliance.',0,0,0,0,0,0,0,0,0,0,0,93987,26124),
(142392,'','Archenon poros.',0,0,0,0,0,0,0,0,0,0,0,93986,26124),
(142393,'','Let us forge our destiny.',0,0,0,0,0,0,0,0,0,0,0,93985,26124),
(142394,'','Together, we can bring down any foe.',0,0,0,0,0,0,0,0,0,0,0,93984,26124),
(142395,'','We are one with the Light.',0,0,0,0,0,0,0,0,0,0,0,93983,26124),
(142396,'','Always be on guard.',0,0,0,0,0,0,0,0,0,0,0,93982,26124),
(142397,'','Dioniss aca.',0,0,0,0,0,0,0,0,0,0,0,93981,26124),
(142398,'','The Light will guide us to victory.',0,0,0,0,0,0,0,0,0,0,0,93980,26124),
(142399,'','Our enemies lack our conviction.',0,0,0,0,0,0,0,0,0,0,0,93979,26124),
(142416,'','Fare well.',0,0,0,0,0,0,0,0,0,0,0,65953,26124),
(142417,'','Kal\'theros maldin.',0,0,0,0,0,0,0,0,0,0,0,65955,26124),
(142418,'','Nor\'bethos Suramar.',0,0,0,0,0,0,0,0,0,0,0,65954,26124),
(142419,'','Our era has come.',0,0,0,0,0,0,0,0,0,0,0,65957,26124),
(142420,'','Stars guide you.',0,0,0,0,0,0,0,0,0,0,0,65952,26124),
(142421,'','Walk in starlight.',0,0,0,0,0,0,0,0,0,0,0,65936,26124),
(142422,'','Ash\'thoras denil.',0,0,0,0,0,0,0,0,0,0,0,65970,26124),
(142423,'','Greetings.',0,0,0,0,0,0,0,0,0,0,0,65969,26124),
(142424,'','May I help you?',0,0,0,0,0,0,0,0,0,0,0,65968,26124),
(142425,'','Tenu\'balah.',0,0,0,0,0,0,0,0,0,0,0,65966,26124),
(142426,'','We see the stars once more.',0,0,0,0,0,0,0,0,0,0,0,65964,26124),
(142427,'','My goods are exquisite.',0,0,0,0,0,0,0,0,0,0,0,65962,26124),
(142428,'','Take a look, I sell all manner of wares.',0,0,0,0,0,0,0,0,0,0,0,65960,26124),
(142429,'','What is your pleasure?',0,0,0,0,0,0,0,0,0,0,0,65958,26124),
(142430,'','Do come again.',0,0,0,0,0,0,0,0,0,0,0,65961,26124),
(142431,'','Pleasure doing business.',0,0,0,0,0,0,0,0,0,0,0,65959,26124),
(142432,'','You will not find a better bargain!',0,0,0,0,0,0,0,0,0,0,0,65963,26124),
(142433,'','I bought this off of a scout patrol. He called it a \"S.E.L.F.I.E. Camera?\" Any idea what that is?',0,0,0,0,0,0,0,0,0,0,0,65935,26124),
(142434,'','Suramar is still a shining jewel in the rubble of the Sundering.',0,0,0,0,0,0,0,0,0,0,0,65947,26124),
(142435,'','We will explore the rest of the world and show them that we are still relevant!',0,0,0,0,0,0,0,0,0,0,0,65948,26124),
(142436,'','You look young enough to use this fancy thing. Can you make it work for me?',0,0,0,0,0,0,0,0,0,0,0,65949,26124),
(142437,'Be well.','',0,0,0,0,0,0,0,0,0,0,65747,0,26124),
(142438,'I know I can count on you.','',0,0,0,0,0,0,0,0,0,0,65769,0,26124),
(142439,'Kal\'theros maldin.','',0,0,0,0,0,0,0,0,0,0,65763,0,26124),
(142440,'Nor\'bethos Suramar.','',0,0,0,0,0,0,0,0,0,0,65746,0,26124),
(142441,'Walk in the moonlight.','',0,0,0,0,0,0,0,0,0,0,65732,0,26124),
(142443,'We rejoin the world.','',0,0,0,0,0,0,0,0,0,0,65764,0,26124),
(142444,'Ash\'thoras denil.','',0,0,0,0,0,0,0,0,0,0,65761,0,26124),
(142445,'Greetings.','',0,0,0,0,0,0,0,0,0,0,65760,0,26124),
(142446,'Our destiny is at hand.','',0,0,0,0,0,0,0,0,0,0,65758,0,26124),
(142447,'Tenu\'balah.','',0,0,0,0,0,0,0,0,0,0,65757,0,26124),
(142448,'We no longer hide.','',0,0,0,0,0,0,0,0,0,0,65755,0,26124),
(142449,'What is your wish?','',0,0,0,0,0,0,0,0,0,0,65759,0,26124),
(142450,'Do come again.','',0,0,0,0,0,0,0,0,0,0,65752,0,26124),
(142451,'Pleasure doing business.','',0,0,0,0,0,0,0,0,0,0,65753,0,26124),
(142452,'You will not find a better bargain!','',0,0,0,0,0,0,0,0,0,0,65751,0,26124),
(142453,'My goods are exquisite.','',0,0,0,0,0,0,0,0,0,0,65748,0,26124),
(142454,'Take a look, I sell all manner of wares.','',0,0,0,0,0,0,0,0,0,0,65749,0,26124),
(142455,'What is your pleasure?','',0,0,0,0,0,0,0,0,0,0,65750,0,26124),
(142459,'You look young enough to use this fancy thing. Can you make it work for me?','',0,0,0,0,0,0,0,0,0,0,65742,0,26124),
(142460,'We will explore the rest of the world and show them that we are still relevant!','',0,0,0,0,0,0,0,0,0,0,65744,0,26124),
(142461,'Suramar is still a shining jewel in the rubble of the Sundering.','',0,0,0,0,0,0,0,0,0,0,65743,0,26124),
(142462,'I bought this off of a scout patrol. He called it a \"S.E.L.F.I.E. Camera?\" Any idea what that is?','',0,0,0,0,0,0,0,0,0,0,65745,0,26124),
(142463,'','Kal\'theros maldin.',0,0,0,0,0,0,0,0,0,0,0,65881,26124),
(142464,'','Night guide you.',0,0,0,0,0,0,0,0,0,0,0,65879,26124),
(142465,'','Nor\'bethos Suramar.',0,0,0,0,0,0,0,0,0,0,0,65880,26124),
(142466,'','These times are troubling. Watch your back.',0,0,0,0,0,0,0,0,0,0,0,65878,26124),
(142467,'','Walk in the moonlight.',0,0,0,0,0,0,0,0,0,0,0,65884,26124),
(142468,'','We rejoin the world.',0,0,0,0,0,0,0,0,0,0,0,65882,26124),
(142469,'','We shall endure.',0,0,0,0,0,0,0,0,0,0,0,65883,26124),
(142470,'','Ash\'thoras denil.',0,0,0,0,0,0,0,0,0,0,0,65877,26124),
(142471,'','Greetings.',0,0,0,0,0,0,0,0,0,0,0,65876,26124),
(142472,'','Ishnal to\'reth.',0,0,0,0,0,0,0,0,0,0,0,65872,26124),
(142473,'','Our destiny is at hand.',0,0,0,0,0,0,0,0,0,0,0,65874,26124),
(142474,'','Tenu\'balah.',0,0,0,0,0,0,0,0,0,0,0,65873,26124),
(142475,'','We have hidden too long.',0,0,0,0,0,0,0,0,0,0,0,65871,26124),
(142476,'','You wish to speak?',0,0,0,0,0,0,0,0,0,0,0,65875,26124),
(142477,'','Is there somewhere else you could be right now?',0,0,0,0,0,0,0,0,0,0,0,65848,26124),
(142478,'','As in, anywhere but here?',0,0,0,0,0,0,0,0,0,0,0,65849,26124),
(142479,'','Excuse me, I have things to do.',0,0,0,0,0,0,0,0,0,0,0,65847,26124),
(142480,'','You are really a night-thorn in my side.',0,0,0,0,0,0,0,0,0,0,0,65850,26124),
(142481,'By night\'s grace.','',0,0,0,0,0,0,0,0,0,0,65681,0,26124),
(142482,'Kal\'theros maldin.','',0,0,0,0,0,0,0,0,0,0,65684,0,26124),
(142483,'Nor\'bethos Suramar.','',0,0,0,0,0,0,0,0,0,0,65683,0,26124),
(142484,'Safe travels.','',0,0,0,0,0,0,0,0,0,0,65682,0,26124),
(142485,'The Nightborne have returned.','',0,0,0,0,0,0,0,0,0,0,65685,0,26124),
(142486,'This is our age now.','',0,0,0,0,0,0,0,0,0,0,65686,0,26124),
(142487,'Travel in starlight, friend.','',0,0,0,0,0,0,0,0,0,0,65687,0,26124),
(142488,'Ash\'thoras denil.','',0,0,0,0,0,0,0,0,0,0,65653,0,26124),
(142489,'Greetings.','',0,0,0,0,0,0,0,0,0,0,65670,0,26124),
(142490,'Ishnal to\'reth.','',0,0,0,0,0,0,0,0,0,0,71690,0,26124),
(142491,'Tenu\'balah.','',0,0,0,0,0,0,0,0,0,0,65673,0,26124),
(142492,'The shal\'dorei are eternal.','',0,0,0,0,0,0,0,0,0,0,65674,0,26124),
(142493,'What do you wish of me?','',0,0,0,0,0,0,0,0,0,0,65671,0,26124),
(142494,'Come now, I have things to do.','',0,0,0,0,0,0,0,0,0,0,65675,0,26124),
(142495,'Why do you insist on pestering me?','',0,0,0,0,0,0,0,0,0,0,65676,0,26124),
(142496,'Move along!','',0,0,0,0,0,0,0,0,0,0,65677,0,26124),
(142497,'Are you sure you\'re not a night-bore?','',0,0,0,0,0,0,0,0,0,0,65678,0,26124),
(142507,'','Stars guide you.',0,0,0,0,0,0,0,0,0,0,0,94266,26124),
(142508,'','May you ever walk in moonlight.',0,0,0,0,0,0,0,0,0,0,0,94267,26124),
(142509,'','We will make our place in this world.',0,0,0,0,0,0,0,0,0,0,0,94268,26124),
(142510,'','Kal\'theros maldin.',0,0,0,0,0,0,0,0,0,0,0,94269,26124),
(142511,'','Stay strong for Suramar.',0,0,0,0,0,0,0,0,0,0,0,94270,26124),
(142512,'','The shal\'dorei will never be oppressed again.',0,0,0,0,0,0,0,0,0,0,0,94271,26124),
(142513,'','Together we are stronger.',0,0,0,0,0,0,0,0,0,0,0,94272,26124),
(142514,'','Ash\'thoras denil.',0,0,0,0,0,0,0,0,0,0,0,94273,26124),
(142516,'','The shal\'dorei stand strong.',0,0,0,0,0,0,0,0,0,0,0,94274,26124),
(142517,'','Our destiny is upon us.',0,0,0,0,0,0,0,0,0,0,0,94275,26124),
(142526,'','The future is ours to forge.',0,0,0,0,0,0,0,0,0,0,0,94276,26124),
(142527,'','Tenu\'balah.',0,0,0,0,0,0,0,0,0,0,0,94277,26124),
(142529,'','Well met.',0,0,0,0,0,0,0,0,0,0,0,94278,26124),
(142531,'','We are the defenders of Suramar.',0,0,0,0,0,0,0,0,0,0,0,94279,26124),
(142532,'','After 10,000 years of isolation, I was looking forward to some company. But this was not what I had in mind.',0,0,0,0,0,0,0,0,0,0,0,94280,26124),
(142534,'','Azeroth has certainly gone downhill since we\'ve been away. This planet could use a makeover.',0,0,0,0,0,0,0,0,0,0,0,94281,26124),
(142535,'','No, I will not blow magic bubbles. Stop asking.',0,0,0,0,0,0,0,0,0,0,0,94282,26124),
(142542,'','I thought withering was the worst suffering I\'d ever endure. Then I met you.',0,0,0,0,0,0,0,0,0,0,0,94283,26124),
(142543,'','Another satisfied customer.',0,0,0,0,0,0,0,0,0,0,0,94284,26124),
(142544,'','I am confident you will be back.',0,0,0,0,0,0,0,0,0,0,0,94285,26124),
(142545,'','Enjoy your purchase.',0,0,0,0,0,0,0,0,0,0,0,94286,26124),
(142546,'','We only sell the finest quality goods.',0,0,0,0,0,0,0,0,0,0,0,94287,26124),
(142547,'','What is your pleasure?',0,0,0,0,0,0,0,0,0,0,0,94288,26124),
(142548,'','If you break it, you shall buy it.',0,0,0,0,0,0,0,0,0,0,0,94289,26124),
(142549,'If you break it, you shall buy it.','',0,0,0,0,0,0,0,0,0,0,94242,0,26124),
(142550,'What is your pleasure?','',0,0,0,0,0,0,0,0,0,0,94243,0,26124),
(142551,'We only sell the finest quality goods.','',0,0,0,0,0,0,0,0,0,0,94244,0,26124),
(142552,'Enjoy your purchase.','',0,0,0,0,0,0,0,0,0,0,94245,0,26124),
(142553,'I am confident you will be back.','',0,0,0,0,0,0,0,0,0,0,94246,0,26124),
(142554,'Another satisfied customer.','',0,0,0,0,0,0,0,0,0,0,94247,0,26124),
(142555,'I thought withering was the worst suffering I\'d ever endure. Then I met you.','',0,0,0,0,0,0,0,0,0,0,94248,0,26124),
(142556,'No, I will not blow magic bubbles. Stop asking.','',0,0,0,0,0,0,0,0,0,0,94249,0,26124),
(142557,'Azeroth has certainly gone downhill since we\'ve been away. This planet could use a makeover.','',0,0,0,0,0,0,0,0,0,0,94250,0,26124),
(142558,'After 10,000 years of isolation, I was looking forward to some company. But this was not what I had in mind.','',0,0,0,0,0,0,0,0,0,0,94251,0,26124),
(142559,'We are the defenders of Suramar.','',0,0,0,0,0,0,0,0,0,0,94252,0,26124),
(142560,'Well met.','',0,0,0,0,0,0,0,0,0,0,94253,0,26124),
(142561,'Tenu\'balah.','',0,0,0,0,0,0,0,0,0,0,94254,0,26124),
(142562,'The future is ours to forge.','',0,0,0,0,0,0,0,0,0,0,94255,0,26124),
(142563,'Our destiny is upon us.','',0,0,0,0,0,0,0,0,0,0,94256,0,26124),
(142564,'The shal\'dorei stand strong.','',0,0,0,0,0,0,0,0,0,0,94257,0,26124),
(142565,'Ash\'thoras denil.','',0,0,0,0,0,0,0,0,0,0,94258,0,26124),
(142566,'Together we are stronger.','',0,0,0,0,0,0,0,0,0,0,94259,0,26124),
(142567,'The shal\'dorei will never be oppressed again.','',0,0,0,0,0,0,0,0,0,0,94260,0,26124),
(142568,'Stay strong for Suramar.','',0,0,0,0,0,0,0,0,0,0,94261,0,26124),
(142569,'Kal\'theros maldin.','',0,0,0,0,0,0,0,0,0,0,94262,0,26124),
(142570,'We will make our place in this world.','',0,0,0,0,0,0,0,0,0,0,94263,0,26124),
(142571,'May you ever walk in moonlight.','',0,0,0,0,0,0,0,0,0,0,94264,0,26124),
(142572,'Stars guide you.','',0,0,0,0,0,0,0,0,0,0,94265,0,26124),
(142578,'','Bal\'a dash, malanore.',0,0,0,0,0,0,0,0,0,0,0,94359,26124),
(142579,'','Walk your own path.',0,0,0,0,0,0,0,0,0,0,0,94360,26124),
(142580,'','We embrace a new future.',0,0,0,0,0,0,0,0,0,0,0,94361,26124),
(142581,'','Question everything.',0,0,0,0,0,0,0,0,0,0,0,94362,26124),
(142582,'','The universe is full of mystery.',0,0,0,0,0,0,0,0,0,0,0,94363,26124),
(142583,'','I greet you.',0,0,0,0,0,0,0,0,0,0,0,94364,26124),
(142585,'','New doorways have opened to us.',0,0,0,0,0,0,0,0,0,0,0,94365,26124),
(142586,'','Shorel\'aran.',0,0,0,0,0,0,0,0,0,0,0,94352,26124),
(142587,'','Do not fear the shadows.',0,0,0,0,0,0,0,0,0,0,0,94353,26124),
(142588,'','My fate is my own.',0,0,0,0,0,0,0,0,0,0,0,94354,26124),
(142589,'','The whispers do not control me.',0,0,0,0,0,0,0,0,0,0,0,94355,26124),
(142590,'','Unchecked emotion leads to ruin.',0,0,0,0,0,0,0,0,0,0,0,94356,26124),
(142591,'','Power is to be wielded, not feared.',0,0,0,0,0,0,0,0,0,0,0,94357,26124),
(142592,'','The Void offers endless possibilities.',0,0,0,0,0,0,0,0,0,0,0,94358,26124),
(142593,'','Your infantile behavior will not provoke me.',0,0,0,0,0,0,0,0,0,0,0,94372,26124),
(142594,'','This sanctum was once a testament to my people\'s mastery of the arcane. Now it is but a ruin.',0,0,0,0,0,0,0,0,0,0,0,94959,26124),
(142595,'','The Ghostlands. This was once Eversong Forest... a place of unbridled beauty. Windrunner Spire, my family home, stands not far from here.',0,0,0,0,0,0,1,0,0,0,0,94957,26124),
(142596,'','This place looks like it has been ransacked. But perhaps Umbric left behind a clue.',0,0,0,0,0,0,1,0,0,0,0,94962,26124),
(142597,'','This place resonates with power. Tread carefully, $n.',0,0,0,0,0,0,0,0,0,0,0,94965,26124),
(142598,'','Umbric is a dedicated scholar... but his tenacity turned him and his followers into exiles.',0,0,0,0,0,0,1,0,0,0,0,94966,26124),
(142599,'','We are ready to proceed. Stay on your guard, $p. We do not know what we might find inside.',0,0,0,0,0,0,1,0,0,0,0,94968,26124),
(142600,'','\"Remember the Sunwell\"? Please. I am so over it.',0,0,0,0,0,0,0,0,0,0,0,94373,26124),
(142604,'','The Andilien Estate... yes, I remember it. Come, $p.',0,0,0,0,0,0,0,0,0,0,0,94961,26124),
(142605,'','Umbric risks much. He follows in the footsteps of treachery. Let us hope this obsession has not led to his downfall.',0,0,0,0,0,0,0,0,0,0,0,94963,26124),
(142621,'|TInterface\\Icons\\SPELL_HOLY_PROCLAIMCHAMPION:20|tMove to the |cFFFF0000|Hspell:255199|h[Avatar of Aggramar]|h|rto avoid being killed by |TInterface\\Icons\\SPELL_SHADOW_SHADOWFURY:20|t |cFFFF0000|Hspell:|h[Soulbomb Detonation]|h|r!','|TInterface\\Icons\\SPELL_HOLY_PROCLAIMCHAMPION:20|tMove to the |cFFFF0000|Hspell:255199|h[Avatar of Aggramar]|h|rto avoid being killed by |TInterface\\Icons\\SPELL_SHADOW_SHADOWFURY:20|t |cFFFF0000|Hspell:|h[Soulbomb Detonation]|h|r!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(142628,'I suppse you are wondering what I am doing here.$b$bSuffice it to say that I have been given a new prime directive. Apparently standing watch over the Conservatory was not an efficient use of my time.$b$b<Sigh> Tenure no longer means what it once did.$b$bDo you require something? As you can see, I am quite busy.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(142629,'Hello, Vigilant Quoram. We met before on Argus.','Hello, Vigilant Quoram. We met before on Argus.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(142630,'I passed my trial!','I passed my trial!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(142631,'What do you know about becoming Lightforged?','What do you know about becoming Lightforged?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(142632,'Do you plan on staying with the draenei?','Do you plan on staying with the draenei?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(142633,'How do you like being on the Vindicaar?','How do you like being on the Vindicaar?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(142634,'Can you teleport me back up to the bridge?','Can you teleport me back up to the bridge?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(142639,'The vessel has been found!','',0,0,0,0,0,0,0,0,0,0,94843,0,26124),
(142640,'It wants the Sunwell!','',0,0,0,0,0,0,603,0,0,0,94826,0,26124),
(142659,'A pity you remain defiant. The patience of the masters is vast... but not infinite.','',0,0,0,0,0,0,0,0,0,0,94334,0,26124),
(142660,'A minor setback. What is in motion cannot be undone. Surely you see this.','',0,0,0,0,0,0,0,0,0,0,94335,0,26124),
(142666,'The void will transform you... awaken what you were meant to be.','',0,0,0,0,0,0,0,0,0,0,94336,0,26124),
(142667,'Do you not see what we offer? The majesty of chaos... the glory of infinite hunger!','',0,0,0,0,0,0,0,0,0,0,94337,0,26124),
(142668,'Why do you fight your destiny, Windrunner? Join me and rule by my side!','',0,0,0,0,0,0,0,0,0,0,94338,0,26124),
(142670,'So be it. Your death is regrettable... but necessary.','',0,0,0,0,0,0,0,0,0,0,94339,0,26124),
(142672,'My people were reshaped by the void. Stripped of the limitations of flesh. We offer you the same gift.','',0,0,0,0,0,0,0,0,0,0,94330,0,26124),
(142674,'Even shattered as it is, this place echoes with the whispers of the great ones who were slain... and the hatred of he who broke this world.','',0,0,0,0,0,0,0,0,0,0,94331,0,26124),
(142686,'','Dark forces surge through these ashen stones. No wonder the ethereals were drawn here.',0,0,0,0,0,0,0,0,0,0,0,94943,26124),
(142688,'','That vortex up ahead pulses with power. Let us investigate, $p.',0,0,0,0,0,0,0,0,0,0,0,94945,26124),
(142689,'','There! Durzaan is using those forges to draw in power. We must break his hold on Umbric\'s people.',0,0,0,0,0,0,0,0,0,0,0,94947,26124),
(142691,'I offer freedom. I offer strength. Cast off your mortal shackles.','',0,0,0,0,0,0,0,0,0,0,94340,0,26124),
(142692,'','Our destiny is our own, Durzaan! You will not define our future!',0,0,0,0,0,0,0,0,0,0,0,94950,26124),
(142696,'The transformation... incomplete... must... be... finished...','',0,0,0,0,0,0,0,0,0,0,94341,0,26124),
(142697,'','The only thing that will be finished here... is you.',0,0,0,0,0,0,0,0,0,0,0,94951,26124),
(142723,'','If a portal leading into endless nothingness were to open under your feet and consume you in my presence, rest assured it would be entirely coincidental. Accidents do happen, after all.',0,0,0,0,0,0,0,0,0,0,0,94374,26124),
(142725,'','Oh sure, I get physically transformed by a cosmic force known to induce madness and suddenly I\'m considered \"suspicious\". Talk about profiling...',0,0,0,0,0,0,0,0,0,0,0,94375,26124),
(142727,'','What do you seek?',0,0,0,0,0,0,0,0,0,0,0,94369,26124),
(142728,'','I offer rare goods from distant realms.',0,0,0,0,0,0,0,0,0,0,0,94370,26124),
(142729,'','Everything has a price... if you are willing to pay it.',0,0,0,0,0,0,0,0,0,0,0,94371,26124),
(142732,'','I hope you find your purchase to be satisfying.',0,0,0,0,0,0,0,0,0,0,0,94366,26124),
(142733,'','Thank you for browsing.',0,0,0,0,0,0,0,0,0,0,0,94367,26124),
(142734,'','Come back anytime.',0,0,0,0,0,0,0,0,0,0,0,94368,26124),
(142736,'Come back anytime.','',0,0,0,0,0,0,0,0,0,0,94440,0,26124),
(142737,'Thank you for browsing.','',0,0,0,0,0,0,0,0,0,0,94439,0,26124),
(142738,'I hope you find your purchase to be satisfying.','',0,0,0,0,0,0,0,0,0,0,94438,0,26124),
(142740,'Everything has a price... if you are willing to pay it.','',0,0,0,0,0,0,0,0,0,0,94443,0,26124),
(142741,'I offer rare goods from distant realms.','',0,0,0,0,0,0,0,0,0,0,94442,0,26124),
(142742,'What do you seek?','',0,0,0,0,0,0,0,0,0,0,94441,0,26124),
(142743,'Oh sure, I get physically transformed by a cosmic force known to induce madness and suddenly I\'m considered \"suspicious\". Talk about profiling...','',0,0,0,0,0,0,0,0,0,0,94447,0,26124),
(142744,'If a portal leading into endless nothingness were to open under your feet and consume you in my presence, rest assured it would be entirely coincidental. Accidents do happen, after all.','',0,0,0,0,0,0,0,0,0,0,94446,0,26124),
(142745,'\"Remember the Sunwell\"? Please. I am so over it.','',0,0,0,0,0,0,0,0,0,0,94445,0,26124),
(142746,'Your infantile behavior will not provoke me.','',0,0,0,0,0,0,0,0,0,0,94444,0,26124),
(142747,'The Void offers endless possibilities.','',0,0,0,0,0,0,0,0,0,0,94430,0,26124),
(142748,'Power is to be wielded, not feared.','',0,0,0,0,0,0,0,0,0,0,94429,0,26124),
(142749,'Unchecked emotion leads to ruin.','',0,0,0,0,0,0,0,0,0,0,94428,0,26124),
(142750,'The whispers do not control me.','',0,0,0,0,0,0,0,0,0,0,94427,0,26124),
(142751,'My fate is my own.','',0,0,0,0,0,0,0,0,0,0,94426,0,26124),
(142752,'Do not fear the shadows.','',0,0,0,0,0,0,0,0,0,0,94425,0,26124),
(142753,'Shorel\'aran.','',0,0,0,0,0,0,0,0,0,0,94424,0,26124),
(142754,'New doorways have opened to us.','',0,0,0,0,0,0,0,0,0,0,94437,0,26124),
(142755,'I greet you.','',0,0,0,0,0,0,0,0,0,0,94436,0,26124),
(142756,'The universe is full of mystery.','',0,0,0,0,0,0,0,0,0,0,94435,0,26124),
(142757,'Question everything.','',0,0,0,0,0,0,0,0,0,0,94434,0,26124),
(142758,'We embrace a new future.','',0,0,0,0,0,0,0,0,0,0,94433,0,26124),
(142759,'Walk your own path.','',0,0,0,0,0,0,0,0,0,0,94432,0,26124),
(142760,'Bal\'a dash, malanore.','',0,0,0,0,0,0,0,0,0,0,94431,0,26124),
(142762,'','Bal\'a dash, malanore.',0,0,0,0,0,0,0,0,0,0,0,94383,26124),
(142763,'','Walk your own path.',0,0,0,0,0,0,0,0,0,0,0,94384,26124),
(142764,'','We fight for a new future.',0,0,0,0,0,0,0,0,0,0,0,94385,26124),
(142765,'','Question everything.',0,0,0,0,0,0,0,0,0,0,0,94386,26124),
(142767,'','The universe is full of mystery.',0,0,0,0,0,0,0,0,0,0,0,94387,26124),
(142769,'','I greet you.',0,0,0,0,0,0,0,0,0,0,0,94388,26124),
(142770,'','New doorways have opened to us.',0,0,0,0,0,0,0,0,0,0,0,94389,26124),
(142771,'','Shorel\'aran.',0,0,0,0,0,0,0,0,0,0,0,94376,26124),
(142773,'','There is strength in shadow.',0,0,0,0,0,0,0,0,0,0,0,94377,26124),
(142774,'','Fate is ours to decide.',0,0,0,0,0,0,0,0,0,0,0,94378,26124),
(142775,'','The whispers do not control me.',0,0,0,0,0,0,0,0,0,0,0,94379,26124),
(142776,'','Maintain control. Always.',0,0,0,0,0,0,0,0,0,0,0,94380,26124),
(142777,'','Power is to be wielded, not feared.',0,0,0,0,0,0,0,0,0,0,0,94381,26124),
(142778,'','The Void offers endless possibilities.',0,0,0,0,0,0,0,0,0,0,0,94382,26124),
(142779,'','Your infantile behavior will not provoke me.',0,0,0,0,0,0,0,0,0,0,0,94396,26124),
(142780,'','\"Remember the Sunwell\"? Please. I am so over it.',0,0,0,0,0,0,0,0,0,0,0,94397,26124),
(142781,'','If a portal leading into endless nothingness were to open under your feet and consume you in my presence, rest assured it would be entirely coincidental. Accidents do happen, after all.',0,0,0,0,0,0,0,0,0,0,0,94398,26124),
(142782,'','Oh sure, I get physically transformed by a cosmic force known to induce madness and suddenly I\'m considered \"suspicious\". Talk about profiling...',0,0,0,0,0,0,0,0,0,0,0,94399,26124),
(142783,'','What do you seek?',0,0,0,0,0,0,0,0,0,0,0,94393,26124),
(142785,'','I offer rare goods from distant realms.',0,0,0,0,0,0,0,0,0,0,0,94394,26124),
(142786,'','Everything has a price... if you are willing to pay it.',0,0,0,0,0,0,0,0,0,0,0,94395,26124),
(142787,'','I hope you find your purchase to be satisfying.',0,0,0,0,0,0,0,0,0,0,0,94390,26124),
(142788,'','Thank you for browsing.',0,0,0,0,0,0,0,0,0,0,0,94391,26124),
(142789,'','Come back anytime.',0,0,0,0,0,0,0,0,0,0,0,94392,26124),
(142791,'Come back anytime.','',0,0,0,0,0,0,0,0,0,0,94464,0,26124),
(142792,'Thank you for browsing.','',0,0,0,0,0,0,0,0,0,0,94463,0,26124),
(142793,'I hope you find your purchase to be satisfying.','',0,0,0,0,0,0,0,0,0,0,94462,0,26124),
(142794,'Everything has a price... if you are willing to pay it.','',0,0,0,0,0,0,0,0,0,0,94467,0,26124),
(142795,'I offer rare goods from distant realms.','',0,0,0,0,0,0,0,0,0,0,94466,0,26124),
(142796,'What do you seek?','',0,0,0,0,0,0,0,0,0,0,94465,0,26124),
(142797,'Oh sure, I get physically transformed by a cosmic force known to induce madness and suddenly I\'m considered \"suspicious\". Talk about profiling...','',0,0,0,0,0,0,0,0,0,0,94471,0,26124),
(142798,'If a portal leading into endless nothingness were to open under your feet and consume you in my presence, rest assured it would be entirely coincidental. Accidents do happen, after all.','',0,0,0,0,0,0,0,0,0,0,94470,0,26124),
(142799,'\"Remember the Sunwell\"? Please. I am so over it.','',0,0,0,0,0,0,0,0,0,0,94469,0,26124),
(142800,'Your infantile behavior will not provoke me.','',0,0,0,0,0,0,0,0,0,0,94468,0,26124),
(142801,'The Void offers endless possibilities.','',0,0,0,0,0,0,0,0,0,0,94454,0,26124),
(142803,'Power is to be wielded, not feared.','',0,0,0,0,0,0,0,0,0,0,94453,0,26124),
(142804,'Maintain control. Always.','',0,0,0,0,0,0,0,0,0,0,94452,0,26124),
(142805,'The whispers do not control me.','',0,0,0,0,0,0,0,0,0,0,94451,0,26124),
(142806,'Fate is ours to decide.','',0,0,0,0,0,0,0,0,0,0,94450,0,26124),
(142807,'There is strength in shadow.','',0,0,0,0,0,0,0,0,0,0,94449,0,26124),
(142808,'Shorel\'aran.','',0,0,0,0,0,0,0,0,0,0,94448,0,26124),
(142809,'New doorways have opened to us.','',0,0,0,0,0,0,0,0,0,0,94461,0,26124),
(142810,'I greet you.','',0,0,0,0,0,0,0,0,0,0,94460,0,26124),
(142811,'The universe is full of mystery.','',0,0,0,0,0,0,0,0,0,0,94459,0,26124),
(142812,'Question everything.','',0,0,0,0,0,0,0,0,0,0,94458,0,26124),
(142813,'We fight for a new future.','',0,0,0,0,0,0,0,0,0,0,94457,0,26124),
(142814,'Walk your own path.','',0,0,0,0,0,0,0,0,0,0,94456,0,26124),
(142815,'Bal\'a dash, malanore.','',0,0,0,0,0,0,0,0,0,0,94455,0,26124),
(142820,'','Bal\'a dash, malanore.',0,0,0,0,0,0,0,0,0,0,0,94407,26124),
(142821,'','We must each walk our own path.',0,0,0,0,0,0,0,0,0,0,0,94408,26124),
(142822,'','Our people represent a new future.',0,0,0,0,0,0,0,0,0,0,0,94409,26124),
(142823,'','Take no truth for granted.',0,0,0,0,0,0,0,0,0,0,0,94410,26124),
(142824,'','The universe is full of mystery.',0,0,0,0,0,0,0,0,0,0,0,94411,26124),
(142825,'','New opportunities lay before us.',0,0,0,0,0,0,0,0,0,0,0,94412,26124),
(142826,'','The past is written. The future is not.',0,0,0,0,0,0,0,0,0,0,0,94413,26124),
(142827,'','Shorel\'aran.',0,0,0,0,0,0,0,0,0,0,0,94400,26124),
(142828,'','Our people do not fear the shadows.',0,0,0,0,0,0,0,0,0,0,0,94401,26124),
(142829,'','There is no single truth.',0,0,0,0,0,0,0,0,0,0,0,94402,26124),
(142830,'','The whispers do not control us.',0,0,0,0,0,0,0,0,0,0,0,94403,26124),
(142831,'','Every impulse must be held in check.',0,0,0,0,0,0,0,0,0,0,0,94404,26124),
(142832,'','Do not fear power. Control it.',0,0,0,0,0,0,0,0,0,0,0,94405,26124),
(142833,'','Consider all possibilities.',0,0,0,0,0,0,0,0,0,0,0,94406,26124),
(142834,'','Your infantile behavior will not provoke me.',0,0,0,0,0,0,0,0,0,0,0,94420,26124),
(142835,'','\"Remember the Sunwell\"? Please. I am so over it.',0,0,0,0,0,0,0,0,0,0,0,94421,26124),
(142836,'','If a portal leading into endless nothingness were to open under your feet and consume you in my presence, rest assured it would be entirely coincidental. Accidents do happen, after all.',0,0,0,0,0,0,0,0,0,0,0,94422,26124),
(142837,'','Oh sure, I get physically transformed by a cosmic force known to induce madness and suddenly I\'m considered \"suspicious\". Talk about profiling...',0,0,0,0,0,0,0,0,0,0,0,94423,26124),
(142838,'','What do you seek?',0,0,0,0,0,0,0,0,0,0,0,94417,26124),
(142839,'','I offer rare goods from distant realms.',0,0,0,0,0,0,0,0,0,0,0,94418,26124),
(142840,'','Everything has a price... if you are willing to pay it.',0,0,0,0,0,0,0,0,0,0,0,94419,26124),
(142841,'','I hope you find your purchase to be satisfying.',0,0,0,0,0,0,0,0,0,0,0,94414,26124),
(142842,'','Thank you for browsing.',0,0,0,0,0,0,0,0,0,0,0,94415,26124),
(142843,'','Come back anytime.',0,0,0,0,0,0,0,0,0,0,0,94416,26124),
(142844,'Come back anytime.','',0,0,0,0,0,0,0,0,0,0,94488,0,26124),
(142845,'Thank you for browsing.','',0,0,0,0,0,0,0,0,0,0,94487,0,26124),
(142846,'I hope you find your purchase to be satisfying.','',0,0,0,0,0,0,0,0,0,0,94486,0,26124),
(142847,'Everything has a price... if you are willing to pay it.','',0,0,0,0,0,0,0,0,0,0,94491,0,26124),
(142848,'I offer rare goods from distant realms.','',0,0,0,0,0,0,0,0,0,0,94490,0,26124),
(142849,'What do you seek?','',0,0,0,0,0,0,0,0,0,0,94489,0,26124),
(142850,'Oh sure, I get physically transformed by a cosmic force known to induce madness and suddenly I\'m considered \"suspicious\". Talk about profiling...','',0,0,0,0,0,0,0,0,0,0,94495,0,26124),
(142851,'If a portal leading into endless nothingness were to open under your feet and consume you in my presence, rest assured it would be entirely coincidental. Accidents do happen, after all.','',0,0,0,0,0,0,0,0,0,0,94494,0,26124),
(142852,'\"Remember the Sunwell\"? Please. I am so over it.','',0,0,0,0,0,0,0,0,0,0,94493,0,26124),
(142853,'Your infantile behavior will not provoke me.','',0,0,0,0,0,0,0,0,0,0,94492,0,26124),
(142854,'Consider all possibilities.','',0,0,0,0,0,0,0,0,0,0,94478,0,26124),
(142855,'Do not fear power. Control it.','',0,0,0,0,0,0,0,0,0,0,94477,0,26124),
(142856,'Every impulse must be held in check.','',0,0,0,0,0,0,0,0,0,0,94476,0,26124),
(142857,'The whispers do not control us.','',0,0,0,0,0,0,0,0,0,0,94475,0,26124),
(142858,'There is no single truth.','',0,0,0,0,0,0,0,0,0,0,94474,0,26124),
(142859,'Our people do not fear the shadows.','',0,0,0,0,0,0,0,0,0,0,94473,0,26124),
(142860,'Shorel\'aran.','',0,0,0,0,0,0,0,0,0,0,94472,0,26124),
(142861,'The past is written. The future is not.','',0,0,0,0,0,0,0,0,0,0,94485,0,26124),
(142862,'New opportunities lay before us.','',0,0,0,0,0,0,0,0,0,0,94484,0,26124),
(142863,'The universe is full of mystery.','',0,0,0,0,0,0,0,0,0,0,94483,0,26124),
(142864,'Take no truth for granted.','',0,0,0,0,0,0,0,0,0,0,94482,0,26124),
(142865,'Our people represent a new future.','',0,0,0,0,0,0,0,0,0,0,94481,0,26124),
(142866,'We must each walk our own path.','',0,0,0,0,0,0,0,0,0,0,94480,0,26124),
(142867,'Bal\'a dash, malanore.','',0,0,0,0,0,0,0,0,0,0,94479,0,26124),
(142872,'Something seeks to open a rift into the chamber. If it comes through, we may lose the Sunwell.','',0,0,0,0,0,0,1,0,0,0,94828,0,26124),
(142873,'','I can close the rift--but I will need help.',0,0,0,0,0,0,0,0,0,0,0,94900,26124),
(142874,'','Tell us what to do, and we will lend our strength.',0,0,0,0,0,0,0,0,0,0,0,94901,26124),
(142875,'The door opens. Yes... this should suit our needs.','',0,0,0,0,0,0,0,0,0,0,94844,0,26124),
(142876,'','Now! Focus your power with mine!',0,0,0,0,0,0,0,0,0,0,0,94902,26124),
(142877,'You only delay the inevitable! I will yet have my prize.','',0,0,0,0,0,0,0,0,0,0,94845,0,26124),
(142878,'The Sunwell is secure. Your aid was invaluable, Thalyssra. And yours, champion.','',0,0,0,0,0,0,0,0,0,0,94674,0,26124),
(142879,'Guards! Seize this saboteur.','',0,0,0,0,0,0,0,0,0,0,94827,0,26124),
(142880,'','I will not be taken prisoner in my own homeland.',0,0,0,0,0,0,0,0,0,0,0,94895,26124),
(142881,'Enough! You will leave at once, Alleria. Accident or no, your presence poses a danger to Quel\'Thalas. Go back to Stormwind. Silvermoon is no longer your home.','',0,0,0,0,0,0,0,0,0,0,94675,0,26124),
(142882,'','As you command, Regent Lord. For now.',0,0,0,0,0,0,0,0,0,0,0,94896,26124),
(142883,'I regret you had to witness that exchange, Thalyssra. This is not how I planned your visit to unfold.','',0,0,0,0,0,0,0,0,0,0,94676,0,26124),
(142884,'','On the contrary. This conflict has demonstrated your dedication to your people. I can see that the Horde has allowed you to uphold your traditions--something that is very important to us.',0,0,0,0,0,0,0,0,0,0,0,94897,26124),
(142885,'','We gain strength from our allies... but we have not lost who we are.',0,0,0,0,0,0,0,0,0,0,0,94839,26124),
(142886,'','Suramar will always be our home. But some among my people wish to venture out into the world, to claim our place in Azeroth once again. To do that, we need allies.',0,0,0,0,0,0,0,0,0,0,0,94898,26124),
(142887,'The Horde offers that to you, First Arcanist. Join us. The gates of Silvermoon stand open to you.','',0,0,0,0,0,0,0,0,0,0,94677,0,26124),
(142888,'','On behalf of the nightborne, I accept your proposal. From this day forth, Suramar fights for the Horde.',0,0,0,0,0,0,0,0,0,0,0,94899,26124),
(142889,'Excellent! Lady Liadrin, please return to Orgrimmar and tell the warchief the good news.','',0,0,0,0,0,0,0,0,0,0,94678,0,26124),
(142890,'','It will be my pleasure, Regent Lord. I will meet you in Silvermoon, champion.',0,0,0,0,0,0,0,0,0,0,0,94840,26124),
(142910,'','Alleria tenses defiantly.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(142986,'Good luck, $p. As for me, I am going to test my skill in Ashenvale. For the Horde!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(142999,'Champion... \'tis good ta see a familiar face in these dark times.','',0,0,0,0,0,0,1,0,0,0,94515,0,26124),
(143000,'Since returnin\' from Argus, the cries o\' Azeroth have been... overwhelmin\'. Such pain...','',0,0,0,0,0,0,603,0,0,0,94516,0,26124),
(143001,'I don\'t know how ta fix this. Not sure anyone does. But we\'ve gotta keep tryin\'.','',0,0,0,0,0,0,1,0,0,0,94517,0,26124),
(143002,'The storm\'s gatherin\', $p. If we don\'t find a way ta heal Azeroth... nothin\' else is gonna matter.','',0,0,0,0,0,0,1,0,0,0,94518,0,26124),
(143013,'You\'re anxious. You hide it well... but I know you.','',0,0,0,0,0,0,1,0,0,0,94531,0,26124),
(143014,'','Like no other, my love.',0,0,0,0,0,0,1,0,0,0,0,94536,26124),
(143015,'You don\'t have to go. You don\'t have to see her.','',0,0,0,0,0,0,1,0,0,0,94532,0,26124),
(143016,'Each of you has a path to follow. If the Light wills that those paths intersect, they will. There\'s no need to force the hand of fate.','',0,0,0,0,0,0,1,0,0,0,94533,0,26124),
(143017,'','It is time, Turalyon. I must see my homeland again with my own eyes... and hear from Sylvanas how she could ever wear the mantle of warchief.',0,0,0,0,0,0,1,0,0,0,0,94537,26124),
(143018,'It is unsettling to look upon these memorials to our passing.','',0,0,0,0,0,0,1,0,0,0,94530,0,26124),
(143019,'','Indeed. Sometimes I feel that I have already died twice. Once when we were presumed lost on Draenor, and again when gripped by the shadow of the fallen naaru.',0,0,0,0,0,0,1,0,0,0,0,94534,26124),
(143020,'','Perhaps death is the true legacy of the Windrunners.',0,0,0,0,0,0,604,0,0,0,0,94535,26124),
(143078,'Come, friend $p.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(143124,'','Warchief Sylvanas Windrunner, this is First Arcanist Thalyssra of Suramar.',0,0,0,0,0,0,1,0,0,0,0,94831,26124),
(143144,'','An honor, Warchief. I have fought alongside both Lady Liadrin and the regent lord. Their courage is a credit to your Horde.',0,0,0,0,0,0,1,0,0,0,0,94870,26124),
(143145,'','Indeed, First Arcanist.',0,0,0,0,0,0,1,0,0,0,0,94769,26124),
(143146,'','The Horde embodies strength. Determination. Individuality. Traits we shal\'dorei value as well.',0,0,0,0,0,0,1,0,0,0,0,94871,26124),
(143147,'','It is time for the nightborne to find allies among the kingdoms of Azeroth. If you will have us, we would be proud to pledge our forces to your cause.',0,0,0,0,0,0,1,0,0,0,0,94872,26124),
(143148,'','For millennia Suramar stood alone. This day, you become part of something greater. I accept your oath of service, Thalyssra.',0,0,0,0,0,0,1,0,0,0,0,94770,26124),
(143149,'','Suramar stands with the Horde!',0,0,0,0,0,0,603,0,0,0,0,94873,26124),
(143150,'','For the Horde!',0,0,0,0,0,0,603,0,0,0,0,94832,26124),
(143151,'','For the Horde!',0,0,0,0,0,0,1,0,0,0,0,94771,26124),
(143172,'','High King Wrynn, $p and I found the sin\'dorei exiles. Like me, they have been changed by the void--but their hearts and minds remain their own.',0,0,0,0,0,0,1,0,0,0,0,94903,26124),
(143173,'','I will be their guide. I will train them to control the whispers of shadow. In return, they will fight for the Alliance against all its foes.',0,0,0,0,0,0,1,0,0,0,0,94904,26124),
(143175,'It may take time for these void elves to earn the trust of some in our ranks. But so long as they adhere to your teachings, they are welcome in the Alliance.','',0,0,0,0,0,0,1,0,0,0,94905,0,26124),
(143176,'You have done us a great service this day, Lady Windrunner, $p. You have my thanks.','',0,0,0,0,0,0,1,0,0,0,94906,0,26124),
(143178,'','It is an honor to serve once more, High King. For the Alliance!',0,0,0,0,0,0,603,0,0,0,0,94907,26124),
(143179,'For the Alliance!','',0,0,0,0,0,0,1,0,0,0,94908,0,26124),
(143203,'','Some will tell you that the Light is the only path. The one weapon that can stop the enemies of Azeroth.',0,0,0,0,0,0,1,0,0,0,0,94933,26124),
(143204,'','But we see alternatives. Many roads--many possibilities--that are open to us.',0,0,0,0,0,0,1,0,0,0,0,94934,26124),
(143205,'There will be those who doubt you. Who question your resolve, your ability to harness powers that have caused the downfall of weaker wills.','',0,0,0,0,0,0,1,0,0,0,94643,0,26124),
(143206,'','Use the lessons I have taught you to maintain control. Become a weapon for the Alliance... even as you skirt the edge of darkness.',0,0,0,0,0,0,1,0,0,0,0,94935,26124),
(143228,'','Throughout your journeys across Azeroth, you have achieved mastery over the forces that constantly seek to control you.',0,0,0,0,0,0,1,0,0,0,0,94565,26124),
(143234,'','You have become a formidable weapon of the Alliance, $p. Return to the void rift so that we may honor your accomplishment.',0,0,0,0,0,0,1,0,0,0,0,94566,26124),
(143236,'','Many doubted that the ren\'dorei could harness the power of the void without falling prey to its influence. You have proven them wrong.',0,0,0,0,0,0,1,0,0,0,0,94567,26124),
(143241,'','Let this armor remind you of all you have achieved, $p. Accept it with my thanks.',0,0,0,0,0,0,1,0,0,0,0,94568,26124),
(143270,'','You are among the first shal\'dorei to venture forth and explore the wilds of Azeroth. But now it is time to come home.',0,0,0,0,0,0,1,0,0,0,0,94561,26124),
(143271,'','Return to Suramar so that we may thank you for helping our people reclaim a place in this world.',0,0,0,0,0,0,1,0,0,0,0,94562,26124),
(143273,'','You have shown the Horde--and all the people of Azeroth--that the nightborne possess the will and the courage to defend our world.',0,0,0,0,0,0,1,0,0,0,0,94563,26124),
(143275,'','I present you with the traditional garb of Suramar. Wear it as a reminder of our ancient past... and the new future we will forge alongside our allies.',0,0,0,0,0,0,1,0,0,0,0,94564,26124),
(143276,'','When our city faced its darkest hour, the heroes of Azeroth fought with us to drive out the Legion. Some did so reluctantly.',0,0,0,0,0,0,1,0,0,0,0,94865,26124),
(143277,'','But the sin\'dorei--the blood elves--showed us respect and understanding. Their kinship proved there were others in Azeroth who share our values.',0,0,0,0,0,0,1,0,0,0,0,94866,26124),
(143284,'','Stars guide you, $p. I have heard intriguing talk of the Hillsbrad Foothills. I will likely journey there.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(143287,'We share much with the Highmountain tauren. It is my belief that they would make ideal allies in the time to come.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(143288,'','Now it is our turn to demonstrate the strength and honor we bring to the Horde.',0,0,0,0,0,0,1,0,0,0,0,94867,26124),
(143289,'What do we know about the Highmountain tauren?','What do we know about the Highmountain tauren?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(143290,'','$n, I am glad you are here. We must convince the warchief to pursue an allegiance with the nightborne.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(143291,'What do we know about the nightborne?','What do we know about the nightborne?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(143292,'','As you travel the roads of Azeroth, tell those you meet of the nightborne\'s proud history... and show them that we live in seclusion no longer.',0,0,0,0,0,0,1,0,0,0,0,94869,26124),
(143293,'','Go to Orgrimmar. Join with our allies and forge a new future together.',0,0,0,0,0,0,1,0,0,0,0,94868,26124),
(143327,'Light be with you, $n. I plan to  seek the Legion upon Azeroth to continue our eternal battle.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(143328,'','I have only heard stories of Stormwind before now. I will explore its streets and the wonders it holds. May the shadows guide you, $n.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(143468,'','Greetings, Lady Liadrin, $p. Welcome back to Suramar. I am pleased to receive you under more pleasant circumstances.',0,0,0,0,0,0,1,0,6,0,0,94887,26124),
(143469,'','It is good to see your city free, First Arcanist.',0,0,0,0,0,0,1,0,6,0,0,94835,26124),
(143470,'','For that, we owe you both a great debt. You proved instrumental to our cause.',0,0,0,0,0,0,1,0,6,0,0,94888,26124),
(143471,'','The Horde was proud to fight by your side against the Burning Legion, my lady.',0,0,0,0,0,0,1,0,6,0,0,94836,26124),
(143472,'','I must admit, when I first learned of the Horde, I was skeptical that we would share common ground.',0,0,0,0,0,0,1,0,6,0,0,94889,26124),
(143473,'','I thought our kin from Kalimdor would make obvious allies. But their arrogance and mistrust soon proved otherwise.',0,0,0,0,0,0,1,0,6,0,0,94890,26124),
(143474,'','Arcanist Thalyssra. I remember where your order stood in the War of the Ancients. How do we know you won\'t betray us and become the next Elisande... the next Azshara?',0,0,0,0,0,0,25,0,4,0,0,94766,26124),
(143475,'','We do not intend to be slaves to the Nightwell. We seek to drive the Legion from Suramar and put an end to Elisande\'s oppression.',0,0,0,0,0,0,0,0,4,0,0,94986,26124),
(143476,'','The kaldorei will fight to see the Legion defeated and the Nightwell destroyed. Beyond that... we shall see where Elune\'s wisdom guides us.',0,0,0,0,0,0,661,0,4,0,0,94767,26124),
(143477,'','It would seem \"Elune\'s wisdom\" guided her away from the bond we once shared. So be it.',0,0,0,0,0,0,1,0,6,0,0,94891,26124),
(143478,'','The sin\'dorei are also scorned by Tyrande and her prideful lot. Yet for many ages her people slept in dens or hid in trees while my people fought to save this world.',0,0,0,0,0,0,1,0,6,0,0,94837,26124),
(143479,'','The Alliance feels too walled off... too cloistered. My people will never endure such stagnation again.',0,0,0,0,0,0,1,0,6,0,0,94892,26124),
(143480,'','That is why I am grateful for your invitation to Silvermoon. I would like to inquire whether there could be a place for the nightborne in your Horde.',0,0,0,0,0,0,1,0,6,0,0,94893,26124),
(143481,'','I am sure the regent lord will be pleased to learn of your interest. Are you ready to depart?',0,0,0,0,0,0,1,0,6,0,0,94838,26124),
(143482,'','It would be an honor, Lady Liadrin. Oculeth has the coordinates to your capital. I will gather Silgryn and Valtrois, and meet you in Silvermoon.',0,0,0,0,0,0,1,0,6,0,0,94894,26124),
(143483,'Champions, azerite deposits have been located on an island off the coast of Feralas. We must secure them before the Horde does.','',0,0,0,0,0,0,1,0,0,924,94733,0,26124),
(143484,'We\'ve brought our ship around to the center of the island. Collect as much azerite as you can. It is the key to victory!','',0,0,0,0,0,0,1,0,0,924,94734,0,26124),
(143485,'Horde vessel incoming! No doubt that scum followed us here. Battle stations!','',0,0,0,0,0,0,603,0,0,924,94735,0,26124),
(143486,'There\'s a rich azerite deposit below us, heroes. Get down there and collect all you can. And if those Horde marauders gets in your way... put them down!','',0,0,0,0,0,0,1,0,0,924,94737,0,26124),
(143487,'We have spotted more azerite eruptions around the island! The locations are marked on your map.','',0,0,0,0,0,0,1,0,0,924,94725,0,26124),
(143488,'Heroes! We\'re dropping supplies down to you. Don\'t let the Horde get their hands on them!','',0,0,0,0,0,0,0,0,0,924,94738,0,26124),
(143489,'You\'re doing well so far, heroes. But we need more azerite!','',0,0,0,0,0,0,1,0,0,924,94722,0,26124),
(143490,'You kept that azerite out of the Horde\'s hands. Well done!','',0,0,0,0,0,0,1,0,0,924,94723,0,26124),
(143491,'You\'re doing good work. Just a bit more azerite and the day is ours!','',0,0,0,0,0,0,1,0,0,924,94724,0,26124),
(143492,'More azerite eruptions! Locate them on your map and secure those sites!','',0,0,0,0,0,0,603,0,0,924,94726,0,26124),
(143493,'Supplies incoming! Grab them, champions!','',0,0,0,0,0,0,603,0,0,924,94739,0,26124),
(143494,'Nicely done, champions! King Wrynn will be pleased to learn of your victory. For the Alliance!','',0,0,0,0,0,0,1,0,0,924,94732,0,26124),
(143495,'Damn! The Horde got the upper hand this time. But I swear upon Lion\'s Rest that we will yet claim victory!','',0,0,0,0,0,0,1,0,0,924,94731,0,26124),
(143496,'You all look like a sturdy lot. Hmm... could use another rogue or two, I\'d say... but you\'ll do!','',0,0,0,0,0,0,1,0,0,924,94736,0,26124),
(143497,'Fire! Take out those healers!','',0,0,0,0,0,0,5,0,0,924,94727,0,26124),
(143498,'These Horde think they\'re clever. Teach them a lesson!','',0,0,0,0,0,0,5,0,0,924,94728,0,26124),
(143499,'Fight for the king! Fight for the Alliance!','',0,0,0,0,0,0,5,0,0,924,94729,0,26124),
(143500,'Drive them out! This island is ours!','',0,0,0,0,0,0,5,0,0,924,94730,0,26124),
(143501,'Champions of the Horde! We have found Azerite deposits on some wretched island off the Feralas coast. It is your duty to secure it in the name of the Dark Lady!','',0,0,0,0,0,0,1,0,0,923,94755,0,26124),
(143502,'Your mission here is simple. Collect every bit of azerite and leave nothing for the Alliance to find. I trust that isn\'t too hard to grasp.','',0,0,0,0,0,0,1,0,0,923,94756,0,26124),
(143503,'Alliance vessel incoming! Those curs are lapping at our heels. Well, get to battle stations!','',0,0,0,0,0,0,1,0,0,923,94757,0,26124),
(143504,'Let me have a look at you. Ugh... pathetic! Why aren\'t there any dark rangers in your ranks? Well, you\'ll have to do.','',0,0,0,0,0,0,1,0,0,923,94758,0,26124),
(143505,'Down there... azerite! Take it for our warchief. And should those Alliance get in your way, litter the beach with their corpses. Move!','',0,0,0,0,0,0,1,0,0,923,94759,0,26124),
(143506,'Supplies are on the way. I better not see the Alliance getting them before you do!','',0,0,0,0,0,0,1,0,0,923,94760,0,26124),
(143507,'Grab these supplies, if you need them. But don\'t lose sight of the Banshee Queen\'s prize!','',0,0,0,0,0,0,1,0,0,923,94761,0,26124),
(143508,'An acceptable first effort, but we need more azerite!','',0,0,0,0,0,0,1,0,0,923,94744,0,26124),
(143509,'Ha! Snatched it out of the Alliance\'s hands! Well struck!','',0,0,0,0,0,0,0,0,0,923,94745,0,26124),
(143510,'Almost there. Do not relent. More azerite!','',0,0,0,0,0,0,1,0,0,923,94746,0,26124),
(143511,'There are more azerite eruptions around this blasted island! Check your map to find them.','',0,0,0,0,0,0,1,0,0,923,94747,0,26124),
(143512,'Zounds! There\'s even more azerite to be had. Follow your map and lock down those sites!','',0,0,0,0,0,0,1,0,0,923,94748,0,26124),
(143513,'Fire! Don\'t leave one of those bastards breathing!','',0,0,0,0,0,0,5,0,0,923,94749,0,26124),
(143514,'The Alliance calls those soldiers? Miserable! That one can barely swing a sword!','',0,0,0,0,0,0,1,0,0,923,94750,0,26124),
(143515,'Take them down! You do NOT want to disappoint your warchief!','',0,0,0,0,0,0,5,0,0,923,94751,0,26124),
(143516,'Is that... worgen I smell? It\'s hard to be sure over the overwhelming stench of Alliance self-righteousness.','',0,0,0,0,0,0,1,0,0,923,94752,0,26124),
(143517,'That was far from what I\'d call an elegant victory, but at least you put those Alliance dogs in their place. For the Horde!','',0,0,0,0,0,0,1,0,0,923,94754,0,26124),
(143518,'You... lost? To them? Pathetic! Report to the Undercity for remedial training. Apparently I have to start at square one with you...','',0,0,0,0,0,0,1,0,0,923,94753,0,26124),
(143583,'Welcome, friend $p. I am King Anduin Wrynn. As a new member of the Alliance, I wished to greet you personally.','',0,0,0,0,0,0,1,0,0,0,94909,0,26124),
(143584,'The Lightforged may be a recent addition to our ranks, but I know the draenei well. I am confident you will embody the dedication and courage of the Army of the Light.','',0,0,0,0,0,0,1,0,0,0,94910,0,26124),
(143585,'These are troubled times for Azeroth. In the days to come, you will face many trials... fight many foes. Know that you are never alone against the darkness, for the Alliance stands with you.','',0,0,0,0,0,0,1,0,0,0,94912,0,26124),
(143586,'I look forward to hearing of your progress. Something tells me we will speak again soon.','',0,0,0,0,0,0,1,0,0,0,94913,0,26124),
(143587,'Safe travels, $p. Though you walk among the shadows, you are a beacon of hope to us all.','',0,0,0,0,0,0,1,0,0,0,94915,0,26124),
(143589,'The void elves may be a recent addition to our ranks, but Alleria Windrunner is one of our greatest heroes. Under her tutelage, the powers you wield will aid our cause.','',0,0,0,0,0,0,1,0,0,0,94911,0,26124),
(143590,'Safe travels, $p. May the Light be with you always.','',0,0,0,0,0,0,1,0,0,0,94914,0,26124),
(143591,'','Ah, the young hero $p comes before me. I am told you show great promise. Let us hope these reports prove true.',0,0,0,0,0,0,1,0,0,0,0,94778,26124),
(143592,'','The Highmountain tauren possess strength and courage. We will have need of such qualities in the days to come.',0,0,0,0,0,0,1,0,0,0,0,94779,26124),
(143593,'','The Horde has many rivals in this world. Some call us enemies... others call us outcasts. But we find strength in unity... and in defiance of those who would challenge our freedom.',0,0,0,0,0,0,1,0,0,0,0,94781,26124),
(143594,'','Rest assured, I will be taking note of your progress. As warchief, I expect much of you... and I reward those who serve me well.',0,0,0,0,0,0,1,0,0,0,0,94782,26124),
(143595,'','Enough of these pleasantries. You have much to prove, hero. Wherever your path takes you, know that you fight... for the Horde!',0,0,0,0,0,0,1,0,0,0,0,94783,26124),
(143596,'','The nightborne are a wise and powerful people. The ancient knowledge you possess will prove a great boon to our cause.',0,0,0,0,0,0,1,0,0,0,0,94780,26124),
(143598,'$p, High King Wrynn requests that you rendezvous with me at Stormwind.','',0,0,0,0,0,0,1,0,0,0,94740,0,26124),
(143599,'We\'ve uncovered certain... sensitive information that he insists you be made aware of.','',0,0,0,0,0,0,1,0,0,0,94741,0,26124),
(143600,'Find me at Lion\'s Rest. And needless to say, keep the details of this meeting between us.','',0,0,0,0,0,0,1,0,0,0,94742,0,26124),
(143601,'$p! The Dark Lady instructs you to meet me in Orgrimmar.','',0,0,0,0,0,0,1,0,0,0,94762,0,26124),
(143602,'Information has come to light crucial to the interests of the Horde. It is imperative we remain a step ahead of our rivals.','',0,0,0,0,0,0,1,0,0,0,94763,0,26124),
(143603,'Meet me outside Grommash Hold. Keep this quiet... or the consequences will be swift and severe.','',0,0,0,0,0,0,1,0,0,0,94764,0,26124),
(143604,'You have seen the devastation in Silithus with your own eyes, $p. You know what is at stake.','',0,0,0,0,0,0,1,0,0,0,94929,0,26124),
(143605,'The Horde will stop at nothing to claim the lifeblood of Azeroth. I fear that after the war against the Legion, our ranks are too depleted to stave off their aggression.','',0,0,0,0,0,0,1,0,0,0,94930,0,26124),
(143606,'It is time for the Alliance to bring in new members to join our cause. We have established an embassy in Stormwind to spearhead these efforts. Meet me there.','',0,0,0,0,0,0,1,0,0,0,94931,0,26124),
(143607,'','You have observed our operations in Silithus, $p. Clearly the Alliance is doing everything in its power to undermine our efforts.',0,0,0,0,0,0,1,0,0,0,0,94784,26124),
(143608,'','The Horde\'s selfless leadership in the war against the Legion has left our ranks depleted. Our enemies slaver at the thought of stealing what is ours. We will not let them.',0,0,0,0,0,0,1,0,0,0,0,94785,26124),
(143609,'','I\'ve authorized the building of an embassy in Orgrimmar. From it, we will win others to our cause. Meet me there at once.',0,0,0,0,0,0,1,0,0,0,0,94786,26124),
(143610,'My arrogance was nearly our undoing. I dabbled with powers far beyond my control. If you will train us, Alleria, we will follow where you lead.','',0,0,0,0,0,0,1,0,0,0,94651,0,26124),
(143611,'','I sense the powers at your command. They are... considerable. You would make valuable allies of the Alliance.',0,0,0,0,0,0,1,0,0,0,0,94955,26124),
(143612,'Silvermoon turned its back on us long ago. Today we are reborn... and it is fitting that we walk a new path. From this day forth, the Alliance has our loyalty.','',0,0,0,0,0,0,1,0,0,0,94652,0,26124),
(143613,'','And in turn, I pledge to aid you on your journey. $p and I will inform High King Wrynn of this news. Then I will return, so that we can begin your training.',0,0,0,0,0,0,1,0,0,0,0,94956,26124),
(143614,'It will take some time for us to adjust to our new forms. We look forward to your return, Lady Windrunner. And $p... you have our deepest thanks.','',0,0,0,0,0,0,1,0,0,0,94653,0,26124),
(143615,'Together, we will prove them wrong.','',0,0,0,0,0,0,1,0,0,0,94644,0,26124),
(143616,'','These woods once brought such joy to me and my sisters. To see them like this... fills my heart with sorrow.',0,0,0,0,0,0,1,0,0,0,0,94958,26124),
(143617,'','<Landing from jump: Total 3>',0,0,0,0,0,0,0,0,0,0,0,94634,26124),
(143620,'<Landing from jump: Total 3>','',0,0,0,0,0,0,0,0,0,0,94635,0,26124),
(143621,'<Distressed cry: Total 3>','',0,0,0,0,0,0,0,0,0,0,94636,0,26124),
(143622,'','<Landing from jump: Total 3>',0,0,0,0,0,0,0,0,0,0,0,94637,26124),
(143623,'<Landing from jump: Total 3>','',0,0,0,0,0,0,0,0,0,0,94638,0,26124),
(143624,'Our void experiments are proceeding well. I am certain we are on the cusp of a breakthrough... despite Rommath\'s smallminded protests.','',0,0,0,0,0,0,1,0,0,0,94654,0,26124),
(143625,'The grand magister must understand that this power is crucial to the defense of Silvermoon. Never again shall the sin\'dorei fall prey to our enemies!','',0,0,0,0,0,0,1,0,0,0,94655,0,26124),
(143626,'Unfortunately, it seems our research has reached an impasse. I believe there is knowledge at the Andilien Estate that will springboard us forward.','',0,0,0,0,0,0,1,0,0,0,94656,0,26124),
(143627,'','<Landing from jump: Total 3>',0,0,0,0,0,0,0,0,0,0,0,94639,26124),
(143628,'','It seems we have found some notes.',0,0,0,0,0,0,1,0,0,0,0,94960,26124),
(143629,'<Landing from jump: Total 3>','',0,0,0,0,0,0,0,0,0,0,94640,0,26124),
(143630,'It seems we are not the first of our people seeking to harness the void. I have found notebooks belonging to one whose very name is a curse... Dar\'Khan Drathir.','',0,0,0,0,0,0,1,0,0,0,94657,0,26124),
(143631,'It was Drathir\'s betrayal that allowed Arthas to corrupt the Sunwell... and left our kingdom in ruins. For the first time, I see why Rommath opposes our course of study.','',0,0,0,0,0,0,1,0,0,0,94658,0,26124),
(143632,'Nevertheless, I believe this knowledge can be used for good. The bulk of Drathir\'s research was conducted at Dawnstar Spire. That is where we must go.','',0,0,0,0,0,0,1,0,0,0,94659,0,26124),
(143633,'','Come. We must make our way to Dawnstar Spire.',0,0,0,0,0,0,1,0,0,0,0,94964,26124),
(143634,'<Landing from jump: Total 3>','',0,0,0,0,0,0,0,0,0,0,94641,0,26124),
(143635,'Drathir\'s quest for power led him to seek the fragments of an ancient world, one teetering on the brink of the Void itself.','',0,0,0,0,0,0,1,0,0,0,94660,0,26124),
(143636,'His notes said it existed within a rift in the very fabric of reality. He never found this place... but I have succeeded where he failed. The way will soon be open to us!','',0,0,0,0,0,0,1,0,0,0,94661,0,26124),
(143637,'Drathir believed this rift held an ancient object of unspeakable might. Perhaps this will be the key that allows us to gain control over the shadows.','',0,0,0,0,0,0,1,0,0,0,94662,0,26124),
(143638,'','<Landing from jump: Total 3>',0,0,0,0,0,0,0,0,0,0,0,94642,26124),
(143639,'','Based on these notes, I believe I can reopen the passage to this world he spoke of. Let me see...',0,0,0,0,0,0,1,0,0,0,0,94967,26124),
(143640,'','There, up ahead. That must be Umbric.',0,0,0,0,0,0,1,0,0,0,0,94936,26124),
(143641,'','Magister Umbric! I am Alleria Windrunner.',0,0,0,0,0,0,1,0,0,0,0,94937,26124),
(143642,'Alleria Windrunner!? How did... My, what an unexpected honor!','',0,0,0,0,0,0,1,0,0,0,94645,0,26124),
(143643,'My people and I heard tales of what transpired on Argus. As you might imagine, we have a keen interest in your interaction with the darkened naaru.','',0,0,0,0,0,0,1,0,0,0,94646,0,26124),
(143644,'','Another time, perhaps. This champion and I have been searching for you. We know of your exile from Silvermoon and felt we shared common ground.',0,0,0,0,0,0,1,0,0,0,0,94938,26124),
(143645,'Indeed! Like you, we believe the void can be used to defend life rather than consume it. We have made great progress, Lady Windrunner, but many mysteries remain.','',0,0,0,0,0,0,1,0,0,0,94647,0,26124),
(143646,'Take this cube, for instance. It is an ancient device, perhaps even predating life on Azeroth. It seems to have been locked, and we cannot yet open it.','',0,0,0,0,0,0,1,0,0,0,94648,0,26124),
(143647,'','Careful, Umbric. Answers to such mysteries often come at a price.',0,0,0,0,0,0,1,0,0,0,0,94939,26124),
(143662,'I greet you on behalf of Silvermoon.','',0,0,0,0,0,0,0,0,0,0,94693,0,26124),
(143663,'Bal\'a dash, malanore.','',0,0,0,0,0,0,0,0,0,0,94694,0,26124),
(143664,'I proudly serve as regent lord.','',0,0,0,0,0,0,0,0,0,0,94695,0,26124),
(143665,'We have made many sacrifices.','',0,0,0,0,0,0,0,0,0,0,94696,0,26124),
(143666,'The rebuilding continues.','',0,0,0,0,0,0,0,0,0,0,94697,0,26124),
(143667,'The eternal sun still guides us.','',0,0,0,0,0,0,0,0,0,0,94698,0,26124),
(143668,'The beauty of Eversong endures.','',0,0,0,0,0,0,0,0,0,0,94699,0,26124),
(143669,'Silvermoon will know prosperity again.','',0,0,0,0,0,0,0,0,0,0,94686,0,26124),
(143670,'The Light of the Sunwell be with you.','',0,0,0,0,0,0,0,0,0,0,94687,0,26124),
(143671,'What I do, I do for Quel\'Thalas.','',0,0,0,0,0,0,0,0,0,0,94688,0,26124),
(143672,'We find strength in the Horde.','',0,0,0,0,0,0,0,0,0,0,94689,0,26124),
(143673,'Al diel shala.','',0,0,0,0,0,0,0,0,0,0,94690,0,26124),
(143674,'We are a nation on the rise.','',0,0,0,0,0,0,0,0,0,0,94691,0,26124),
(143675,'Never again shall a king reign in Silvermoon.','',0,0,0,0,0,0,0,0,0,0,94692,0,26124),
(143676,'Hair like this does not just happen on its own. It requires constant attention.','',0,0,0,0,0,0,0,0,0,0,94700,0,26124),
(143677,'Queen\'s champion or no, I can out-shoot Nathanos any day of the week.','',0,0,0,0,0,0,0,0,0,0,94701,0,26124),
(143678,'Working for Sylvanas has its... challenges. Being dead has made her even bossier. But, uh... do not tell her I said that.','',0,0,0,0,0,0,0,0,0,0,94702,0,26124),
(143679,'My eye patch has never switched sides! I mean... who would mix up something like that?','',0,0,0,0,0,0,0,0,0,0,94703,0,26124),
(143680,'Greetings, traveler.','',0,0,0,0,0,0,0,0,0,0,94711,0,26124),
(143681,'Bal\'a dash, malanore.','',0,0,0,0,0,0,0,0,0,0,94712,0,26124),
(143682,'The shadows serve us.','',0,0,0,0,0,0,0,0,0,0,94713,0,26124),
(143683,'We embrace power. We do not fear it.','',0,0,0,0,0,0,0,0,0,0,94714,0,26124),
(143684,'All paths are possible.','',0,0,0,0,0,0,0,0,0,0,94715,0,26124),
(143685,'Come with an open mind.','',0,0,0,0,0,0,0,0,0,0,94716,0,26124),
(143686,'I have much to teach you.','',0,0,0,0,0,0,0,0,0,0,94717,0,26124),
(143687,'The ren\'dorei shall prove our worth.','',0,0,0,0,0,0,0,0,0,0,94704,0,26124),
(143688,'The Light is not the only path.','',0,0,0,0,0,0,0,0,0,0,94705,0,26124),
(143689,'We serve the Alliance.','',0,0,0,0,0,0,0,0,0,0,94706,0,26124),
(143690,'Shadows watch over you.','',0,0,0,0,0,0,0,0,0,0,94707,0,26124),
(143691,'Be open to possibilities.','',0,0,0,0,0,0,0,0,0,0,94708,0,26124),
(143692,'Do not bend to the whispers.','',0,0,0,0,0,0,0,0,0,0,94709,0,26124),
(143693,'Maintain focus and control.','',0,0,0,0,0,0,0,0,0,0,94710,0,26124),
(143694,'High elf? Please. Why would you want to be a high elf when you can look all tragic and brooding?','',0,0,0,0,0,0,0,0,0,0,94718,0,26124),
(143695,'I admit, purple was never my favorite color. But lately it\'s growing on me. Literally.','',0,0,0,0,0,0,0,0,0,0,94719,0,26124),
(143696,'I suppose I can forgive you for not being a fan of elves. After all, half of us dislike the other half rather intensely.','',0,0,0,0,0,0,0,0,0,0,94720,0,26124),
(143697,'Alleria and Turalyon? No chance. I mean... not that I am rooting against them or anything, but... Uh, do we have to keep talking about this?','',0,0,0,0,0,0,0,0,0,0,94721,0,26124),
(143699,'We established a makeshift base in Silithus. Check in with our operatives there--and keep your eyes open for Horde aggression.','',0,0,0,0,0,0,1,0,0,0,94743,0,26124),
(143700,'Gallywix has operations underway in Silithus. Get there at once. And if you see any Alliance skulking about, make quick work of them.','',0,0,0,0,0,0,1,0,0,0,94765,0,26124),
(143712,'','At long last, the ceaseless posturing between the Horde and the Alliance is coming to an end.$b$bThe time for war is at hand.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(143713,'I am ready to pursue our next ally.','I am ready to pursue our next ally.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(143726,'','State your business to your Warchief.',0,0,0,0,0,0,0,0,0,0,0,94794,26124),
(143727,'','I trust you will not waste my time.',0,0,0,0,0,0,0,0,0,0,0,94795,26124),
(143728,'','Come forward.',0,0,0,0,0,0,0,0,0,0,0,94796,26124),
(143729,'','Greetings, champion.',0,0,0,0,0,0,0,0,0,0,0,94797,26124),
(143730,'','Our true work is just beginning.',0,0,0,0,0,0,0,0,0,0,0,94798,26124),
(143731,'','There will be a new future for the Horde.',0,0,0,0,0,0,0,0,0,0,0,94799,26124),
(143732,'','Serve me well, and you will be rewarded.',0,0,0,0,0,0,0,0,0,0,0,94800,26124),
(143733,'','Go. I have much to do.',0,0,0,0,0,0,0,0,0,0,0,94787,26124),
(143735,'','Serve the Horde. Serve me.',0,0,0,0,0,0,0,0,0,0,0,94788,26124),
(143736,'','We will bring the Alliance to its knees.',0,0,0,0,0,0,0,0,0,0,0,94789,26124),
(143737,'','I will grow the ranks of the Forsaken. One way... or another.',0,0,0,0,0,0,0,0,0,0,0,94790,26124),
(143738,'','All will serve the Horde in time.',0,0,0,0,0,0,0,0,0,0,0,94791,26124),
(143739,'','We will claim what is ours.',0,0,0,0,0,0,0,0,0,0,0,94792,26124),
(143741,'','The lifeblood of Azeroth belongs to the Horde.',0,0,0,0,0,0,0,0,0,0,0,94793,26124),
(143742,'','No doubt I am your favorite Windrunner sister... right? Right?',0,0,0,0,0,0,0,0,0,0,0,94801,26124),
(143743,'','I have taken note of your progress. It seems I may have to send you to Nathanos for remedial training.',0,0,0,0,0,0,0,0,0,0,0,94802,26124),
(143744,'','Did you think I would not notice the way you leer at my dark rangers? I suggest you keep your eyes--and thoughts--to yourself.',0,0,0,0,0,0,0,0,0,0,0,94803,26124),
(143745,'','Plans? Little old me? What sort of plans could I possibly have?',0,0,0,0,0,0,0,0,0,0,0,94804,26124),
(143747,'The Sunwell must be protected.','',0,0,0,0,0,0,0,0,0,0,94812,0,26124),
(143748,'What is it?','',0,0,0,0,0,0,0,0,0,0,94813,0,26124),
(143749,'Do not squander resources.','',0,0,0,0,0,0,0,0,0,0,94814,0,26124),
(143750,'I am rather busy.','',0,0,0,0,0,0,0,0,0,0,94815,0,26124),
(143751,'I serve Silvermoon.','',0,0,0,0,0,0,0,0,0,0,94816,0,26124),
(143752,'What would you ask of me?','',0,0,0,0,0,0,0,0,0,0,94817,0,26124),
(143753,'The eternal sun still guides us.','',0,0,0,0,0,0,0,0,0,0,94818,0,26124),
(143754,'Respect our customs.','',0,0,0,0,0,0,0,0,0,0,94805,0,26124),
(143755,'Do not let outsiders interfere.','',0,0,0,0,0,0,0,0,0,0,94806,0,26124),
(143756,'Be about your work.','',0,0,0,0,0,0,0,0,0,0,94807,0,26124),
(143757,'We build our future upon the backbone of tradition.','',0,0,0,0,0,0,0,0,0,0,94808,0,26124),
(143758,'We have overcome much.','',0,0,0,0,0,0,0,0,0,0,94809,0,26124),
(143759,'For Quel\'Thalas.','',0,0,0,0,0,0,0,0,0,0,94810,0,26124),
(143760,'It would be unwise to oppose us.','',0,0,0,0,0,0,0,0,0,0,94811,0,26124),
(143761,'If you would all just do what I say instead of attempting to think for yourselves, Azeroth would be much better off.','',0,0,0,0,0,0,0,0,0,0,94819,0,26124),
(143762,'Kirin Tor? More like Kirin Snore. Am I right?','',0,0,0,0,0,0,0,0,0,0,94820,0,26124),
(143763,'Khadgar? More like Badghar. Am I right?','',0,0,0,0,0,0,0,0,0,0,94821,0,26124),
(143764,'Jaina? More like Paina. Modera? More like... uh... look, you cannot expect me to hit gold every time, okay?','',0,0,0,0,0,0,0,0,0,0,94822,0,26124),
(143767,'T\'paartos!','',0,0,0,0,0,0,0,0,0,0,94853,0,26124),
(143768,'T\'paartos?','',0,0,0,0,0,0,0,0,0,0,94854,0,26124),
(143769,'T\'paartos greets puny one.','',0,0,0,0,0,0,0,0,0,0,94855,0,26124),
(143770,'Puny one needs something of T\'paartos?','',0,0,0,0,0,0,0,0,0,0,94856,0,26124),
(143771,'Danger? T\'paartos scoffs at danger!','',0,0,0,0,0,0,0,0,0,0,94857,0,26124),
(143772,'Light be with you, friend.','',0,0,0,0,0,0,0,0,0,0,94858,0,26124),
(143773,'T\'paartos is ready!','',0,0,0,0,0,0,0,0,0,0,94859,0,26124),
(143775,'T\'paartos.','',0,0,0,0,0,0,0,0,0,0,94846,0,26124),
(143776,'T\'paartos will see you soon.','',0,0,0,0,0,0,0,0,0,0,94847,0,26124),
(143777,'T\'paartos has much to do.','',0,0,0,0,0,0,0,0,0,0,94848,0,26124),
(143778,'T\'paartos must get back to work now.','',0,0,0,0,0,0,0,0,0,0,94849,0,26124),
(143779,'Come back to T\'paartos anytime.','',0,0,0,0,0,0,0,0,0,0,94850,0,26124),
(143780,'T\'paartos is proud to be Lightforged!','',0,0,0,0,0,0,0,0,0,0,94851,0,26124),
(143781,'T\'paartos is still slightly afraid of snakes.','',0,0,0,0,0,0,0,0,0,0,94852,0,26124),
(143782,'Puny one is not trying to take advantage of T\'paartos\' good nature... are you?','',0,0,0,0,0,0,0,0,0,0,94860,0,26124),
(143783,'Sure, T\'paartos has read books. Books with few words and many pictures... but they still count.','',0,0,0,0,0,0,0,0,0,0,94861,0,26124),
(143784,'List of things T\'paartos does not like: snakes, mean children, snakes, dark caves, snakes... and puny ones who pester T\'paartos.','',0,0,0,0,0,0,0,0,0,0,94862,0,26124),
(143785,'They appear to have all fallen for my act! I find it extraordinary that they believe I could be so simple-minded as to... Wait, you mean they can hear me? I, uh... T\'paartos!','',0,0,0,0,0,0,0,0,0,0,94863,0,26124),
(143786,'Two pairs of toes. Two pairs o\' toes. T\'pairs o\'toes. T\'pair o\'toes. T\'paar o\'toes. T\'paartoes. T\'paartos. T\'paartos!','',0,0,0,0,0,0,0,0,0,0,94864,0,26124),
(143881,'You. Over here.','',0,0,0,0,0,0,1,0,0,0,94973,0,26124),
(143882,'Over here!','',0,0,0,0,0,0,0,0,0,0,94974,0,26124),
(143883,'Look out!','',0,0,0,0,0,0,0,0,0,0,94972,0,26124),
(143884,'This way.','',0,0,0,0,0,0,0,0,0,0,94975,0,26124),
(143885,'This way.','',0,0,0,0,0,0,0,0,0,0,94979,0,26124),
(143886,'Look out!','',0,0,0,0,0,0,0,0,0,0,94978,0,26124),
(143887,'Over here!','',0,0,0,0,0,0,0,0,0,0,94977,0,26124),
(143888,'Champion. Over here.','',0,0,0,0,0,0,1,0,0,0,94976,0,26124),
(144262,'','<Alleria\'s eyes drift from the statue\'s cold stone visage down to the plaque engraved with her epitaph.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144263,'<Stay awhile and listen.>','<Stay awhile and listen.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144264,'','Alleria sighs, her brow furrowed.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144269,'Good. Good! Once more!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144301,'Now, focus your chi. Push the energy away from you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144305,'I still cannot believe my brothers and sisters succumbed to the fel.','I still cannot believe my brothers and sisters succumbed to the fel.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144308,'ZZZzzz...','ZZZzzz...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144309,'<The sleeping Tauren snores loudly and rolls over.>','<The sleeping Tauren snores loudly and rolls over.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144310,'Thank you for dealing with Torok. He refused to see the dangers behind the power he sought.','Thank you for dealing with Torok. He refused to see the dangers behind the power he sought.',0,0,0,0,0,0,378,0,0,0,0,0,26124),
(144321,'Our corrupted brothers and sisters still wander in the wilds.','Our corrupted brothers and sisters still wander in the wilds.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144322,'I\'m glad I did not have to give EVERYTHING.','I\'m glad I did not have to give EVERYTHING.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144323,'When healing, you must gather your inner strength and pass it along to another.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144324,'Focused chi is extremely potent. Master Tau Li will guide you once you are ready.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144325,'Expending too much energy at once is dangerous. Pace yourselves, students.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144326,'Excellent! Again, from the beginning.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144365,'','What\'s that? A light in the darkness! It\'s so bright...',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(144366,'','It\'s gotten a little brighter! I can see... sorta.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144367,'','Nuu-Nuu! I was scared I\'d never see you again! How did you get here?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144368,'','A crown! So pretty!',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(144369,'','I used to have a wand like that! Lost it a long time ago.',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(144370,'','It\'s dark again! Where did you go? Don\'t leave me!',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(144371,'','No! Let me go! Help, friend! HELP!',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(144383,'These portals are incredibly tedious to sustain and, more importantly, they take attention away from valuable research!$B$BI am certain that telemancy will allow us to achieve a more stable solution.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144384,'I hear Dalaran has an entire floor dedicated to magical transportation. $B$BImagine the possibilities!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144386,'You can use the Orgrimmar portal to meet our Horde allies in their capital city on Kalimdor.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144394,'Some of our vintners have given up tending their vines and have taken up other forms of botany.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144395,'I brought samples to dispel the unfounded rumors that our wine tastes too footy... I mean too fruity!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144396,'','The nightborne are truly free. We no longer need the Nightwell, nor its power.$B$BWe can forge our own destiny.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144397,'','The business with Elisande is over, but there is still much to be done for the city.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144399,'','It\'s so dark! I can\'t see a thing!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144400,'','Who are you? Can you help me?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144401,'','Help! HELP!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144402,'','At least we\'re together now. We just... don\'t know where we are.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144403,'','But you\'re my friend, and I know it\'s gonna be okay.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144404,'','I wish I could see better. It\'s always so dark here!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144442,'','It\'s too bright! Too bright! Owww!',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(144444,'','Oh, hi! Who are you? I\'m Uuna. Wanna be friends? Maybe together we can get outta this place.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144445,'','I wish Nuu were here. He\'d know what to do.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144563,'','Directing chi energy at a target can be difficult at first.\n\nYou, at the front! Try to hit that training dummy over there.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144564,'','Very good! I\'m quite impressed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144565,'I will keep watch over him. He seems happy enough to wander around the gardens.','I will keep watch over him. He seems happy enough to wander around the gardens.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144566,'There is persisting structural damage and unstable energy in the aqueducts. The gate will remain closed for the moment.','There is persisting structural damage and unstable energy in the aqueducts. The gate will remain closed for the moment.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144567,'','Nuu is here to help us, friend. I knew you\'d find us, Nuu!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144568,'Argus the Unmaker is deploying Reorigination Modules!','Argus the Unmaker is deploying Reorigination Modules!',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(144575,'','I\'ll hold onto him so he doesn\'t get lost again.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144621,'','Greetings, $p! New lands and allies await us across Azeroth.$B$BOculeth has portals prepared downstairs when you are ready.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(144672,'I am glad to see that Arluelle continues her training. She appears stronger already.$B$BPerhaps I should measure her improvement.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144674,'The Duskwatch will do well having Victoire in its ranks once more.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144676,'It is a pity the Lightforged could not be convinced to join our side. Their martial prowess is formidable.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(144677,'','I have a feeling our city will be called upon soon. I plan to be ready when the time comes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144678,'','<Arluelle has a faraway look in her eyes.>$B$BIf only my brother could see the city now...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144712,'','It shoots stars! Bad guys really hate that.',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(144713,'','You can\'t fight the dark without a crown, friend. It\'s the rules.',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(144714,'T\'PAARTOS!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144715,'','I feel a lot better now.',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(144716,'T\'paartos is here!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144721,'The Darkness comes...','The Darkness comes...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144722,'MAKE IT STOP!','MAKE IT STOP!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144723,'Your death is necessary.','Your death is necessary.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144725,'The shadows will consume you.','The shadows will consume you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144726,'Listen to the whispers. They are beautiful.','Listen to the whispers. They are beautiful.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144745,'','Again, T\'paartos? How many times have you...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144749,'Not enough times to stop T\'paartos!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144750,'T\'paartos offers gratitude to Lysara. T\'paartos feels ready to fight again!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144751,'','Even the finest weapon will dull with too much use. Take some time to fully heal, T\'paartos.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144752,'Thank you, champion.','Thank you, champion.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144753,'The whispers... they were driving me mad!','The whispers... they were driving me mad!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(144754,'I must... My mind... Must get away from this place!','I must... My mind... Must get away from this place!',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(144755,'It was horrible, $r.','It was horrible, $r.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144756,'Earthmother bless you!','Earthmother bless you!',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(144757,'I believed my mind was forfeit.','I believed my mind was forfeit.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144758,'The Lightforged Vindicator groans.','The Lightforged Vindicator groans.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144759,'Light preserve me... he\'s back.','Light preserve me... he\'s back.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144760,'Shh! Don\'t move! His vision is based on movement.','Shh! Don\'t move! His vision is based on movement.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144770,'I am fresh out of materials for the moment. My apologies.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144772,'It is good to rest once in a while.$B$BEspecially after a profitable venture!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144799,'My agents have secured this area, but we should still keep our voices down lest our conversation is overheard...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144800,'Tell me what happened at Lion\'s Rest.','Tell me what happened at Lion\'s Rest.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144804,'He is in high spirits today, no?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144806,'','Oh yes, just like yesterday, the day before... and the day before that!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144807,'','An admirable quality, I quite like that about him.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144825,'Our agents have already infiltrated the goblin mining operation below. We\'ll know what they\'re up to soon enough...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144826,'','Friend? Is that you?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144827,'','I won\'t give up, friend! I promise!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144828,'','I\'m just so cold, and it\'s very dark here. I don\'t know what to do!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144833,'Haha! T\'paartos is glad to see you are well! T\'paartos also brought a present. This little one was in Val\'sharah.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144834,'','There you are! That\'s much better.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144835,'','They\'re gonna be here, soon, friend.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144836,'','I keep running and running... but they always find me.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144837,'','But now you\'re here. Together we can fight them! I think...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144838,'','Promise you won\'t leave me, friend. Even when it gets dark...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144839,'','T\'paartos!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144840,'The Dark Lady has an important job for you, $c. I hope that you are ready...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144841,'Tell me what happened at the feast.','Tell me what happened at the feast.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144842,'','Aww!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144845,'T\'paartos must return this little one now. Say farewell, children.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144846,'Do not worry! T\'paartos will return with more stories... and perhaps another friend.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144847,'','It\'s T\'paartos!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144848,'','He\'s back!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144849,'','No! Stay and tell us adventure stories, T\'paartos!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144850,'','Can I keep it?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144851,'','The tail is so fluffy!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144853,'Our bravest warriors are often in the vanguard. It is the least I can do to watch over their families until they return.','Our bravest warriors are often in the vanguard. It is the least I can do to watch over their families until they return.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144862,'','T\'paartos showed us how to play boulder, parchment, blade... but I forgot the rules.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144863,'I\'m looking for a little girl named Uuna, have you seen her?','I\'m looking for a little girl named Uuna, have you seen her?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144864,'Light be with you.','Light be with you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144866,'','I have heard the cries of the child you speak of.\n\nI shall mark you, that you may pass into this realm and seek her out.\n\nShe resides in a place where the barrier between the realms of life and death are thin, and spill over into your world.\n\nBe warned, you have no power in this place, its denizens cannot be harmed by mortals.\n\nTry as you might, you may not be able to aid your friend.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(144873,'<A green dragon\'s tear, cast in shadow by unknown forces.>','',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(144875,'<Touch the tear.>','<Touch the tear.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144895,'','They\'re here...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144896,'','You have missed your payment one too many times, Mr. Stonebrow. I am repossessing the goods, per our contract.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144897,'I mailed ye the check this morning, I swear! Ye can\'t leave me high and dry!','',0,0,0,0,0,0,20,0,0,0,0,0,26124),
(144898,'','Mister Chu, please see this dwarf out. Ms. Xiulan, re-list the armor.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144899,'%s nods.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144900,'','Go away! We\'re not afraid of you!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144901,'','Yes, madam.',0,0,0,0,0,0,2,0,0,0,0,0,26124),
(144902,'Keep yer paws off me, fuzzball!','',0,0,0,0,0,0,25,0,0,0,0,0,26124),
(144903,'','It seems you are in luck today, Mr. Stonebrow. You may take back the goods.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(144904,'Yer damn right I will! I bought this armor fair and square, even if I ain\'t done payin\' for it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144905,'Ahh, that\'s better. Armor befitting a mighty hero! One whose legendary deeds shake the very foundations of Azeroth!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144906,'Welp, I\'m off to the tavern.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144907,'Thanks for yer help, $Glad:lass;! I owe ye one!','',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(144908,'The Vindicaar awaits its next voyage.\n\nAs do I.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144921,'','Light take this table! I may never be able to use this workshop again.$B$BThe taint of those beast hides from Argus lingers, no matter how many times I scrub the surface.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144923,'If it is Maela you\'re looking for, she is assisting on the front lines.$B$BStormwind is home to various competent tailors that can teach you a thing or two.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144924,'','<Fareeya greets you with a warm smile.>$B$BYou have done well in passing the trials, $c. But I feel your tale is just beginning.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144925,'','Always carry with you what it means to be pledged to the Light.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144926,'','Greetings, $c.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(144994,'','Yes, of course I still love him. Must you be so nosey?',0,0,0,0,0,0,603,0,0,0,0,95568,26124),
(145018,'','Sisters are complicated. Especially the undead ones.',0,0,0,0,0,0,1,0,0,0,0,95569,26124),
(145022,'','My void will consume you... if you ask nicely.',0,0,0,0,0,0,0,0,0,0,0,95570,26124),
(145026,'','I go missing for all those years and this is how you treat me?',0,0,0,0,0,0,0,0,0,0,0,95571,26124),
(145027,'','It is a good day for a hunt.',0,0,0,0,0,0,0,0,0,0,0,95572,26124),
(145028,'','Use every weapon at your disposal.',0,0,0,0,0,0,0,0,0,0,0,95573,26124),
(145031,'','What news?',0,0,0,0,0,0,0,0,0,0,0,95574,26124),
(145036,'','We each walk a line. Choose yours.',0,0,0,0,0,0,0,0,0,0,0,95575,26124),
(145038,'','Greetings.',0,0,0,0,0,0,0,0,0,0,0,95576,26124),
(145039,'','The shadows can be an ally... if controlled.',0,0,0,0,0,0,0,0,0,0,0,95577,26124),
(145040,'','Farewell.',0,0,0,0,0,0,0,0,0,0,0,95578,26124),
(145041,'','Aim true.',0,0,0,0,0,0,0,0,0,0,0,95579,26124),
(145042,'','We do what we must for those we love.',0,0,0,0,0,0,0,0,0,0,0,95580,26124),
(145043,'','Keep your gaze fixed on your target.',0,0,0,0,0,0,0,0,0,0,0,95581,26124),
(145102,'Curious.','Curious.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(145140,'','Friend? Are you still there? I\'m scared!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145141,'','I--I can\'t do it! I just wanna go home!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145142,'','Uuna wraps her arms around herself and begins to cry.',0,0,0,0,0,0,18,0,0,0,0,0,26124),
(145154,'','F-friend, you\'re here! You didn\'t leave me!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145155,'','Mama told me the Light would always find me. That\'s you, friend. You\'re my light!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145156,'','And as long as my light is with me, there\'s no way the darkness can win!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145158,'','My light is super strong!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145159,'','I\'M NOT GONNA BE AFRAID ANYMORE!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145171,'I can hear the cries of the world beneath my feet. Azeroth trembles in pain! I must find a way to ease the suffering...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145172,'I am ready. Let us begin the ritual.','I am ready. Let us begin the ritual.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(145185,'','The darkness is gone! I can see!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145186,'','Oh, friend! We did it! We beat them!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145187,'','What... what\'s happening?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145188,'','The light... it\'s telling me to follow it...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145189,'','Mama! Papa! They\'re waiting for me!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145190,'','Wait a sec...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145191,'','There\'s so much I never got to do. So many places I never got to see...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145192,'','Is it okay if I stay with my friend? For just a little while longer?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145193,'','Friend! The Light says I can stay! Woo-hoo!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145194,'','Tell Mama and Papa I miss them, and... and I\'ll see them soon!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145195,'','Okay, friend, let\'s get outta here! We have so many places to go!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145197,'','Uuna hugs you.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145199,'','Wow! That\'s the biggest wall I\'ve ever seen!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145200,'','What do you suppose they wanted to keep out?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145201,'','Is it bugs? I bet it\'s bugs. Yuck! I hate bugs!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145202,'','Ewwwww!!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145203,'','Wow! That\'s gotta be the prettiest house ever!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145204,'','Do you know who lives here? I bet it\'s a princess.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145205,'','Do you wanna play princesses with me?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145206,'','Whoa... a flying city! Are you serious?!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145207,'','How does it do that?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145208,'','Do you live here?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145209,'','Come to think of it... do you live ANYwhere?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145210,'','Hey, what are those flying things? They\'re so pretty!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145211,'','That\'s a big tower. It\'s like a... giant birdhouse!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145212,'','But for lizard birds.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145213,'','Can I have one for a pet?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145218,'','Friend, look! We\'re under a giant tree!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145221,'','I wonder how many birds live in that tree. Must be so many!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145225,'','Like... TEN birds!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145237,'','Caw caw caw caw caw!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145240,'','I can see everything from here!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145241,'','I didn\'t know mountains could go this high!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145243,'','Don\'t fall off, friend! I\'ll be okay if I fall, but you\'d go SPLAT!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145245,'','So be careful, okay?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145246,'','Where are we? Why is it so smoky?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145247,'','Look down there. It\'s all glowing!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145253,'','But it\'s moving like water... it\'s a glowing lake?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145254,'','That\'s really silly, friend.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145255,'','It\'s... so beautiful...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145256,'','My people are here! They survived!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145257,'','They didn\'t all die on Argus?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145258,'','Thank you SO MUCH for showing me this, friend!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145263,'','You\'ve shown me so many neat things. You really are the best friend ever!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145265,'','I know someday I\'ll have to go back to Mama and Papa.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145266,'','But... not yet.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145275,'','Gaaahhh! No! Help!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145276,'Uuna is swallowed by darkness.','Uuna is swallowed by darkness.',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(145721,'','The evolutionary biology of the silithid species is extraordinarily fascinating!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(145890,'We\'re a bit busy right now, as you can see.','We\'re a bit busy right now, as you can see.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(145891,'Open fire!','Open fire!',0,0,0,0,0,0,25,0,0,924,2678,2690,26124),
(145892,'<The elf\'s concentration wavers momentarily and he gives you a withering look.>','<The elf\'s concentration wavers momentarily and she gives you a withering look.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(145893,'With Alleria\'s teaching, we can avoid the fate suffered by those on Mac\'Aree.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(145895,'','The voices never stop. They push, they bully, they plead. They will not relent, not even for a moment.\n\nBut you are stronger than the voices. You can glean their secrets and draw upon their strength.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(145896,'Fascinating.\n\nI sensed that change was destined to find Alleria Windrunner, but I did not anticipate that her kin would undergo a similar transformation.\n\nThe implications are many. These events have given me much to ponder.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(145897,'We need no longer fear exile for the pursuit of knowledge.','We need no longer fear exile for the pursuit of knowledge.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(145898,'A path long denied to us is open at last.','A path long denied to us is open at last.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(145977,'Find us a wee bit o\' cloth and I\'ll be good to go!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146006,'Be wary of unstable void rifts and their spawn. This place is not entirely safe.','Be wary of unstable void rifts and their spawn. This place is not entirely safe.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146007,'Oh, you made it.','',0,0,0,0,0,0,0,0,0,0,96040,0,26124),
(146008,'Wonderful.','',0,0,0,0,0,0,0,0,0,0,96041,0,26124),
(146009,'Why have you returned?','',0,0,0,0,0,0,0,0,0,0,96042,0,26124),
(146010,'Congratulations.','',0,0,0,0,0,0,0,0,0,0,96043,0,26124),
(146011,'It is designed to kill you.','',0,0,0,0,0,0,0,0,0,0,96044,0,26124),
(146012,'I imagine it is quite painful.','',0,0,0,0,0,0,0,0,0,0,96045,0,26124),
(146013,'I am told power comes from unlikely places.','',0,0,0,0,0,0,0,0,0,0,96046,0,26124),
(146014,'For now.','',0,0,0,0,0,0,0,0,0,0,96047,0,26124),
(146015,'Perhaps.','',0,0,0,0,0,0,0,0,0,0,96048,0,26124),
(146016,'Fine.','',0,0,0,0,0,0,0,0,0,0,96049,0,26124),
(146017,'I am afraid I cannot allow that.','',0,0,0,0,0,0,0,0,0,0,96050,0,26124),
(146018,'When mixed with natural gas, liquid Azerite can harden quickly making it easy for us to obtain. Keep your eyes peeled down below for unstable activity on the surface. With these tremors happening recently... its bound to spout out of cracks or fissures you find.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146019,'We\'ve observed strong geothermal energy readings around this uncharted island. \n\nAzerite, for sure!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146020,'What can you tell me about the Lightforged draenei?','What can you tell me about the Lightforged draenei?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146021,'What do we know about the void elves?','What do we know about the void elves?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146022,'War is coming to Azeroth, $n. It is time for us to bring in new allies to join our cause.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146023,'Ahh... this silk feels better than rain on a summer morning...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146024,'I am ready to pursue our next ally.','I am ready to pursue our next ally.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146025,'Now, I\'ll just light a wee match to take care of the fumes...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146026,'FIRE!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146027,'AAAAHHHHHHHHHHHH!!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146029,'That was a close one! I\'d better take inventory. Eyebrows... check. Beard... check. Pants...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146030,'No time for pants, then! I need to see if there\'s a burn clinic nearby...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146031,'Oohhh...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146032,'Ouch!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146033,'Eeek...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146044,'','Salutations! How can I help you?',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(146045,'I\'d like to check my mail.','I\'d like to check my mail.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146049,'Incoming!','Incoming!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146050,'Void outbreak! Take them down!','Void outbreak! Take them down!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146064,'','Looks like the Postmaster needs me right away. Toodles!',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(146067,'','The mail must go through! \'Til next time!',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(146068,'','Oh my, I\'m late! Those letters won\'t sort themselves!',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(146069,'','I\'m afraid my time is up. See you later!',0,0,0,0,0,0,3,0,0,0,0,0,26124),
(146070,'','You rang?',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(146071,'','Katy Stampwhistle, reporting for duty!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146072,'','When there\'s mail to declare, you bet I\'ll be there!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146073,'','The mail must flow!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146080,'Thanks again, $n. I\'ll be seein\' ye! I\'m off to find some pants...','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146083,'Och! I forgot mah pants!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146090,'Pristine void energy is soaked into this space... Magnificent.','Pristine void energy is soaked into this space... Magnificent.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146098,'The Voidstorm is growing. It might even consume the big island entirely.','The Voidstorm is growing. It might even consume the big island entirely.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146099,'Unchecked void energies ravage the other islands. It remains too dangerous to navigate.','Unchecked void energies ravage the other islands. It remains too dangerous to navigate.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146105,'','Voila!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146117,'My, my, what do we have here?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146118,'How did you know we were here, I wonder?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146119,'You mortals are all the same. Fighting, but not knowing what for.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146120,'Pity. You would have made an excellent servant.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146122,'Meddling where we shouldn\'t, I see. Understandable.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146148,'Maintain your focus.','Maintain your focus.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146149,'Yeah? Whaddya want?','Yeah? Whaddya want?',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146150,'Hey! Mind yah business!','Hey! Mind yah business!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146151,'I ain\'t got time for this. Spit it out already!','I ain\'t got time for this. Spit it out already!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146152,'Time is money!','Time is money!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146153,'Hand over all of the azerite you\'ve pocketed!','Hand over all of the azerite you\'ve pocketed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146154,'','One portal, coming up!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146159,'You have learned basic control. Mastery, however, can only be attained through practical application.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146165,'Thankfully, this place is well suited for--','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146178,'I ain\'t gonna let you take my azerite!','I ain\'t gonna let you take my azerite!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146179,'I stole it fair and square! It\'s mine!','I stole it fair and square! It\'s mine!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146180,'Oohh... Now you\'re gonna pay!','Oohh... Now you\'re gonna pay!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146181,'You\'re messin wit\' the wrong goblin, bub!','You\'re messin wit\' the wrong goblin, bub!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146182,'It\'s mine! MINE!','It\'s mine! MINE!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146183,'Ow! Enough! You can keep it!','Ow! Enough! You can keep it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146184,'I give up! Here, take it!','I give up! Here, take it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146185,'I give, I give!!','I give, I give!!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146186,'Mercy! Here take it, I didn\'t want it anyway!','Mercy! Here take it, I didn\'t want it anyway!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146187,'Do hurry, $nistine or whatever you said it was, or I shall find another plebeian upon whom to bestow this great honor!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146188,'Uncle! Take all of it! I don\'t want it anymore!','Uncle! Take all of it! I don\'t want it anymore!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146189,'Behind you!','Behind you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146191,'How convenient! I could not have timed this better myself.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146192,'What are you waiting for? Concentrate and banish this creature!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146194,'R-right!','R-right!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146195,'Pathetic.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146200,'I don\'t feel so good...','I don\'t feel so good...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146201,'Calm yourself and it will pass.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146202,'Your emotions expose weakness. The Void will exploit that if you let it.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146212,'For the Alliance!','For the Alliance!',0,0,0,0,0,0,0,0,0,0,74681,74679,26124),
(146213,'','Don\'t worry about the airship, I\'ll keep an eye out for any... unwanted guests.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146214,'Any alliance get aboard this ship, they\'ll be incinerated.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146231,'Although broken and scattered, this rift holds many secrets. It will teach us much about the nature of the shadows.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146233,'Open fire!','',0,0,0,0,0,0,25,0,0,923,2774,0,26124),
(146237,'The mail must go through!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146238,'I want to sort letters!','I want to sort letters!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146239,'I need help sorting these letters!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146350,'','We\'ve barely finished fighting the Burning Legion and the Horde is already up to no good!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146351,'Alright! Alright! I\'ll get back to work!','Alright! Alright! I\'ll get back to work!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146352,'I was just taking a break!','I was just taking a break!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146353,'Back to work! I get it!','Back to work! I get it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146354,'You don\'t have to get physical! I\'ll get back to work!','You don\'t have to get physical! I\'ll get back to work!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146355,'I was just resting my eyes!','I was just resting my eyes!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146356,'They sent in the muscle! Run for it!','They sent in the muscle! Run for it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146357,'It isn\'t often one gets the opportunity to study a new mineral!$b$bWho knows what mysteries the azerite holds!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146358,'I won\'t be staying long, so we must speak quickly.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146359,'We will take this land for the glory of the Horde!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146360,'','Dissecting giant bugs ain\'t an easy way to make a living, but it sure does pay well!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146361,'ODYN\'S BEARD! I\'M BURNIN\' UP!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146362,'Remain in control of your thoughts. The void cannot sway that which is immutable.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146367,'Now you\'re gonna get it!','Now you\'re gonna get it!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146368,'I\'m gonna teach you a lesson!','I\'m gonna teach you a lesson!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146369,'Don\'t mess with the cartel!','Don\'t mess with the cartel!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146370,'You\'re gonna regret pickin\' a fight with me!','You\'re gonna regret pickin\' a fight with me!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146371,'No trespassing!','No trespassing!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146372,'I hope you like bloody noses!','I hope you like bloody noses!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146373,'The reckoning has come early for you!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146374,'Ogmot gonna eat your soul! HAHAHA!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146375,'Filthy $r, I\'ll make you bleed!','Filthy $r, I\'ll make you bleed!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146376,'You\'re going to pay for your crimes against the Alliance!','You\'re going to pay for your crimes against the Alliance!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146377,'Death is upon you!','Death is upon you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146378,'Don\'t die too quickly! I want to enjoy this!','Don\'t die too quickly! I want to enjoy this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146379,'Now you see me, but soon you won\'t!','Now you see me, but soon you won\'t!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146380,'Horde scum! Die!','Horde scum! Die!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146422,'','Welcome! Now where are the chairs?$B$BOh. Feel free to pull up that... block of wood and sit...down?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146423,'','Honestly, if the local cuisine wasn\'t absolutely mouthwatering I wouldn\'t know what to do with myself.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146431,'Incredible! The surrounding area alone houses at least forty species of plants I am unfamiliar with.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146432,'Give me a challenge! I want to sort the letters with partial addresses.','Give me a challenge! I want to sort the letters with partial addresses.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146433,'Still plenty of letters to sort, if you\'re up to it!$B$BOr how about something more challenging? We also receive letters without a full address on them.$B$BThink you can handle it?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146434,'Excellent work, $n! You might be ready for something more challenging... Speak with me if you\'re interested!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146448,'','This workshop is a bit \"rustic\" for my tastes.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146449,'','Non-magical devices are for mana-starved whelps, they said. Non-magical devices serve no purpose, they said. $B$BOrgrimmar practically runs on such creations!$B$BTime for me to show those palanquin-addled wretches back home the perfection of machinery!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146461,'','Walk the path that Huln took so very long ago, and bring honor to the name... Highmountain.',0,0,0,0,0,0,0,0,6,0,0,96121,26124),
(146462,'','And in turn, we have been reborn as instruments of its power.',0,0,0,0,0,0,0,0,22,0,0,96122,26124),
(146463,'','But to those who would threaten this world... or attack our allies... you will embody the Light\'s wrath.',0,0,0,0,0,0,0,0,22,0,0,96123,26124),
(146471,'','Have you gathered the information I require?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146472,'','Yes, here are the results.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146473,'','...you have done well. My master shall be pleased to see this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146475,'','Venture forth alongside new allies and show the world that the legacy of the nightborne is one of nobility... and strength.',0,0,0,0,0,0,0,0,22,0,0,96126,26124),
(146476,'','Its whispers have broken the will of dragons... and lured even the titans\' own children into madness.',0,0,0,0,0,0,0,0,6,0,0,96127,26124),
(146477,'','That the Void is a power to be harnessed... to be bent by a will strong enough to command it.',0,0,0,0,0,0,0,0,6,0,0,96128,26124),
(146482,'','Wield the shadows as a weapon to save our world... and defend the Alliance!',0,0,0,0,0,0,0,0,6,0,0,96129,26124),
(146516,'The void energy released when the ethereals attacked left the other islands unstable. No one is allowed beyond this point.','The void energy released when the ethereals attacked left the other islands unstable. No one is allowed beyond this point.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146517,'The last people who ventured beyond this space were consumed by the shadows.','The last people who ventured beyond this space were consumed by the shadows.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146522,'Come to have your equipment repaired?$B$BOr would you like some quality tools of your own?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146543,'','Looking for a lift? Going someplace special I hope!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146544,'I need a flight to Staghelm Point.','I need a flight to Staghelm Point.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146552,'Your connection to the spirits begins to fade...','Your connection to the spirits begins to fade...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146561,'Time heals all wounds... especially when you can travel back in time, to before the wound occurred!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146562,'Show me Silithus before it was pierced.','Show me Silithus before it was pierced.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(146563,'Take me back to the present.','Take me back to the present.',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(146605,'','All our attention is focused on foiling the Horde\'s efforts. We can\'t spare resources to make this flight network fully functional.\n\nIf you need to fly away from this wretched desert, you\'ll have to manage it yourself.\n\nShould you be facing a dire emergency, I suppose I could cobble together resources for a single flight...',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146606,'I need to meet with Magni Bronzebeard at once.','I need to meet with Magni Bronzebeard at once.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146636,'Our orders are to obtain this mysterious ore by any means necessary.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146637,'','I can\'t wait to see the looks on their greedy faces when all of their shredders are blown to bits!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146638,'','We must find out how the silithid survived the blade of Sargeras!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146641,'We cannot afford a resurgence of the Twilight\'s Hammer. Voidstrider must die!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146736,'Turn back! You\'re entering uncharted territory','Turn back! You\'re entering uncharted territory',0,0,0,0,0,0,0,0,1,0,0,0,26124),
(146737,'Your ancestry is rich with stories. Fascinating! I look forward to learning more, $r. Perhaps I should fetch some stronger incense!','',0,0,0,0,0,0,396,0,1,55227,0,0,26124),
(146745,'These goblins are so busy with their extraction equipment that they haven\'t set up a proper flight station.\n\n<Urok grumbles and kicks the dirt.>\n\nIf you\'re lookin\' for a flight outta this place, you\'re on your own.\n\nI guess if the world\'s ending I might be able to figure somethin\' out...','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146755,'','Fools squabble over lands below, while those with vision rule the skies above!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146757,'I need a flight to Southwind Village.','I need a flight to Southwind Village.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146851,'','Don\'t be afraid to get your hands dirty crackin\' those silithid skulls!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146854,'','This research is gonna help us understand the power of that giant blade!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146857,'You gotta take out those dirty SI:7 spies before they ruin the whole operation!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146861,'Get out there and put those lazy prospectors in their place!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146863,'We cannot let this fanatic rally the remaining survivors to action! Bring me his head!','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(146918,'','Another perfect batch! It smells so tasty!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146920,'This is a very old place. Broken by rage, yet sculpted by the threads of fate. \n\nThere is much to be learned here. I believe I might linger a while.\n\nBe seeing you.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146922,'What do you know of Telogrus?','What do you know of Telogrus?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146958,'We have a forsaken ambassador, which makes sense given our Warchief, of course.\n\nBut I can\'t help asking myself, \"what has it cost us?\"\n\nIf you have a moment, can you please tell me of your experience with Ambassador Blackguard?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146959,'Thank you for taking my survey, $n.\n\nI shall present the petition after I have enough signatures.\n\nGood day to you, $r.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(146960,'He was rude and blatantly offensive.','He was rude and blatantly offensive.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146961,'His appearance was off-putting.','His appearance was off-putting.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(146962,'He should be replaced immediately!','He should be replaced immediately!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147039,'','The Legion nearly took everything from us... while I blindly trusted Elisande.\n\nI am relieved that Suramar is back in our hands.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147040,'','I suppose I should thank you.$B$B<Anarys dips her head slightly at you.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147041,'','I stood by and watched as Elisande led us astray.\n\nI was wrong... about everything.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147042,'I suppose I should thank you.$B$B<Anarys dips his head slightly at you.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147043,'I stood by and watched as Elisande led us astray.\n\nI was wrong... about everything.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147044,'Come to gloat, have you?','Come to gloat, have you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147047,'Oh, goodness me! Did you slip?','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(147048,'Best be careful close to the edge, $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(147049,'Did you fall, or was that a graceful jump designed to look like a clumsy fall?','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(147050,'Watch your step! I can\'t do this all day! Actually, I suppose I can.','',0,0,0,0,0,0,5,0,0,0,0,0,26124),
(147051,'Are you conducting some kind of dangerous experiment? I like it!','',0,0,0,0,0,0,6,0,0,0,0,0,26124),
(147052,'If you\'re going to fall to your death, do it somewhere else.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(147053,'Mind the gap.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(147084,'Oh! Hello there... fellow member of the Alliance.\n\nI mean no disrespect, but... I\'m just not entirely sure the cathedral is the most... appropriate place for... for...\n\nFor someone who indulges such... unique proclivities.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147098,'The Light does not treat with the Void, elf. You should leave this place.','The Light does not treat with the Void, elf. You should leave this place.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147100,'This place is not meant for you.','This place is not meant for you.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147104,'I can sense the shadow in you. Though it is diminished in the presence of the Light.','I can sense the shadow in you. Though it is diminished in the presence of the Light.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147109,'Thank you, but I do not require your aid.','Thank you, but I do not require your aid.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147130,'Have you come to supplicate yourself before the Light? $b$bIf you are here to speak with Archbishop Benedictus, I am sorry to inform you that he has left on a mission.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147153,'I will help in whatever way I can, but I suggest you do not linger too long here.','I will help in whatever way I can, but I suggest you do not linger too long here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147159,'I commend your dedication. However, I fear you walk a dangerous path.$B$BYou would best serve the Alliance away from the cathedral.','I commend your dedication. However, I fear you walk a dangerous path.$B$BYou would best serve the Alliance away from the cathedral.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147169,'Tread carefully, $c. Lady Alleria\'s name will only carry you so far.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147173,'Perhaps is it as Alleria Windrunner says, and the whispers of shadow can be controlled.\n\nBe on your guard, friend, and may the Ligh--\n\nHrm. Well... May fortune favor you.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(147183,'I\'ve spent enough time with clumsy fingers here that I\'ve picked up a thing or two about treating injuries. Perhaps I can offer you some training?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147187,'I will admit, it took some time to grow accustomed to our transformation. At first, my usual dexterity felt... impeded.$B$BHowever, I can guarantee the techniques themselves have in no way been affected.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147188,'These machines are fantastic! How could they operate with no anomalies or chance of failure?$B$BOh, excuse me. Did you need something?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147191,'We have learned much from our fight against the Legion. In truth, these warframes are the culmination of many years of research.$B$BIf you wish, I can train you to craft similar devices.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147192,'Hmm. Nice try, but you are missing a touch of darkness in that outfit.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147193,'This is an invitation-only gathering. Did you bring an invitation? No?$B$BI thought not.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147196,'','What can I do for you?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147197,'Aye, I have a moment. What do ye want?','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147200,'','Do you need something magically enhanced, or have you come to learn?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147205,'I used to be a famous pirate!\n\nThey dig me up, hand me this tophat, then tell me I have to greet all of you newcomers with a smile on my face...','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(147206,'Do you have any idea how much it hurts to try to crack a smile?\n\nThis is ridiculous!','',6,5,0,0,4,0,0,0,0,0,0,0,26124),
(147207,'What do I have to do to get myself out of this job?\n\nI try to leave, some orc picks me up and plops me right back down here.','',6,1,0,0,3,0,0,0,0,0,0,0,26124),
(147208,'Psst... Yeah, you, $r.\n\nHey, can you put in a bad word for me with the Warchief? I need to get fired. Being a jerk to everyone isn\'t working!','',1,6,0,0,3,0,0,0,0,0,0,0,26124),
(147209,'I really hated this tophat at first. What does a guy have to do for a good tricorne?\n\nBut I must say... this fits real nicely on my skull.','',6,1,0,0,3,0,0,0,0,0,0,0,26124),
(147210,'Greetings, Lightforged! Know that you are always welcome here in the Cathedral of Light.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147211,'To have given yourself wholly to the Light... you are an example to us all.','To have given yourself wholly to the Light... you are an example to us all.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147212,'You will always have steadfast allies here.','You will always have steadfast allies here.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147213,'Should you ever need my assistance, you know where to find me.','Should you ever need my assistance, you know where to find me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147214,'May the Light ever guide you, $n.','May the Light ever guide you, $n.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147217,'I got the axe.$B$BSee? I brought it with me.','I got the axe.$B$BSee? I brought it with me.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147218,'Downsized? I\'m already about as downsized as you can get!','Downsized? I\'m already about as downsized as you can get!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147219,'Boss Mida says I\'m bein\' discharged. The only things that oughta be discharged are guns and explosives!','Boss Mida says I\'m bein\' discharged. The only things that oughta be discharged are guns and explosives!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147220,'I\'ve been downwardly promoted.','I\'ve been downwardly promoted.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147221,'We\'re here as part of a \"workforce adjustment.\"','We\'re here as part of a \"workforce adjustment.\"',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147222,'','The Alliance needs strength. Unity. The king\'s plan to bring in fresh blood is a good one.\n\nBut I can\'t help thinking of my own Dark Iron clan. Of the fractures that divide us.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147223,'','One day Silvermoon will stand again on the side of the Alliance. I know it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147224,'Much about Azeroth has changed in the years I was absent. But the Alliance remains an ideal worth fighting for.\n\nI will do everything in my power to make it stronger.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147225,'I used to have a cushy office job in Orgrimmar.','I used to have a cushy office job in Orgrimmar.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147226,'The campaign on Argus was costly, but necessary. Now we must focus on defending our own lands.\n\nWe cannot sit idle while those Horde monsters build their forces.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147227,'My position has been eliminated... feels like early retirement.','My position has been eliminated... feels like early retirement.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147228,'The young king reminds me so much of his father. More than he realizes, I think.\n\nHe\'s the right person to lead this effort and bring new faces into the Alliance.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(968060,'I want to return my Dalaran Heartstone',NULL,0,0,0,0,0,0,0,0,0,0,0,0,0),
(147229,'','It seems like only yesterday that those of us who follow the way of the Tushui pledged to fight for the Alliance. \n\nThough I have great respect for King Anduin, I must confess that I found his father a more capable sparring partner.\n\nPlease do not tell him this.\n\n<Aysa bows.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147231,'','<Tyrande says nothing. Her brow is furrowed, as if deep in thought.>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147233,'I have spent too long depending on visions to guide me.\n\nIt is time we forge our own fate. Part of that is finding new allies to stand beside us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147234,'<Ji Firepaw meditates in silence.>','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147235,'The spirit of Ol\' Vol\'jin still be strong in dis city, mon. Da work ya be doin\' honors his memory.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147236,'Well, well... the illustrious $ct. Still basking in the glory of your victory over the Legion, no doubt.$B$B<Nathanos rolls his eyes.>$B$BThe Dark Lady has entrusted you with securing new allies for the Horde. For your sake, let us hope her faith has not been misplaced.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(1024780,'I want to back to Ulduar for complete some quests',NULL,0,0,0,0,0,0,0,0,0,0,0,0,0),
(1024781,'I want to back to Thas\'dorah quest line.',NULL,0,0,0,0,0,0,0,0,0,0,0,0,0),
(147237,'The local cuisine has some... interesting spice to it.','The local cuisine has some... interesting spice to it.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(5421860,'Here! Hurry up!',NULL,0,0,0,0,0,0,0,0,0,0,0,0,0),
(147238,'Yeah, sure. Allies. I get it.\n\nBut I got a business to run, see. And a rather delicate operation in the works.\n\nSo how about you handle your end and I\'ll handle mine.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(542000,'I want to see available rewards.','I want to see available rewards.',0,0,0,0,0,0,0,0,0,0,0,0,0),
(147239,'Diplomacy has never been my strong suit.\n\nThis work is best left in your hands.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(444510,'Koltira! Your queen summons you!','',22,0,0,0,0,0,0,0,0,0,0,0,26124),
(147240,'The Horde needs allies. This is true.\n\nBut to be worthy of a place here, those we recruit must have honor in their hearts. If they lack it, their presence only diminishes us.','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(444511,'Enough of this insolence. Do you think that I\'m blind to everything that goes on outside of the Undercity?','',6,0,0,0,0,0,0,0,0,0,0,0,26124),
(147241,'This drink is green! Why is it green?','This drink is green! Why is it green?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147250,'There are no heroes in oblivion!','There are no heroes in oblivion!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147251,'None shall oppose the Twilight\'s Hammer!','None shall oppose the Twilight\'s Hammer!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147252,'We are the harbingers of destruction!','We are the harbingers of destruction!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147253,'Cry for help... none shall answer you!','Cry for help... none shall answer you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147254,'The twilight is upon you!','The twilight is upon you!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147255,'None shall withstand the power of our master!','None shall withstand the power of our master!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(444512,'No thanks to you. Andorhal should have been ours days ago, when we defeated the Scourge.','',274,0,0,0,0,0,0,0,0,0,0,0,26124),
(147256,'I am your destruction!','I am your destruction!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147257,'You will kneel before our master!','You will kneel before our master!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147263,'','They may come from Highmountain, but they sure can get low. It\'s the Highmountain tauren!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(147264,'','The moose is loose! Highmountain tauren, GO!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147265,'','Adventurers by day, dancers by night... borne. It\'s time to cheer for the nightborne!',0,0,0,0,0,0,0,1,0,0,0,0,26124),
(147266,'','An illusion!? Nope... it\'s just the dancing nightborne!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(444513,'I know your secret, Koltira. I\'m aware of your friendship with the Alliance death knight, Thassarian.','',25,0,0,0,0,0,0,0,0,0,0,0,26124),
(147267,'','Just because you\'re an avatar of darkness doesn\'t mean you can\'t get funky. Hit it, void elves!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(147268,'','Get down with your bad self, void elf!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147269,'','Turn off the disco ball and these lightforged draenei will still light up the stage!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(147270,'','The lightforged draenei came here to dance and kill demons. And we\'re all out of demons!',0,0,0,0,0,0,0,7,0,0,0,0,26124),
(147271,'','Remember, control demands sacrifice. Power never comes without a price. You risk losing those closest to you in order to save them.\n\nThis is the bargain we have made.\n\n<Alleria looks away.>',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(444514,'Arthas clearly failed when he created his death knights. You are still weak.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(147272,'','Studying this rift has value, but we cannot neglect our duty.\n\nAzeroth must be defended. Our place is out there, fighting for our world.\n\nThe power that flows through us is a weapon. And weapons must be wielded.',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(444515,'Fortunately, I have agents that can help you... erase this weakness. Beneath the Undercity you go.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(147276,'Locus-Walker is an intriguing fellow.\n\nAlleria seems to trust him... to a point.\n\nI think we can learn much from him, so long as we remain wary of his true intentions.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(444516,'Shh, quiet, death knight. When I\'m finished with you, your fear will be gone.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(147298,':',':',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147299,'Khadgar asked me to deliver this letter.','Khadgar asked me to deliver this letter.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147304,'The situation in Silithus is now under our control. I will see to the rest of the operation. Go with honor, $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(444517,'You can thank me later.','',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(147308,'','Thanks to you, we are now one step closer to understanding the effect that the blade is having on Silithus!',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(147309,'I\'ve never seen anythin\' like this in all my years! What can it be?','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(147310,'I think we\'ve got the situation in Silithus under control. SI:7 can take the operation from here. Thanks again, $n.','',0,0,0,0,0,0,1,0,0,0,0,0,26124),
(147341,'The Horde has gathered over 1200 Azerite and is near victory!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147342,'The Alliance has gathered over 1200 Azerite and is near victory!','',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147378,'I\'ve been staring up at that sword all day. Still can\'t believe it\'s real.','I\'ve been staring up at that sword all day. Still can\'t believe it\'s real.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(451120,'Your highness. I deliver to you... Andorhal.','Your highness. I deliver to you... Andorhal.',16,0,0,0,0,0,0,0,0,0,0,0,26124),
(147379,'The world\'s bleeding out. Can you stop it, hero?','The world\'s bleeding out. Can you stop it, hero?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(451121,'I... your majesty, we were victorious!','I... your majesty, we were victorious!',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(147380,'No way we\'re survivin\' this.','No way we\'re survivin\' this.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147381,'Maybe this is the end of days.','Maybe this is the end of days.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147382,'The doomsayers were right. Azeroth is dying.','The doomsayers were right. Azeroth is dying.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147384,'I should be at home with my family...','I should be at home with my family...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147385,'Sure hope you can do something to save us, hero.','Sure hope you can do something to save us, hero.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147387,'Where are all the other heroes who are supposed to protect us?','Where are all the other heroes who are supposed to protect us?',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147388,'Been staring up at that sword all day. Still can\'t believe it\'s real.','Been staring up at that sword all day. Still can\'t believe it\'s real.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(451123,'No!','No!',20,0,0,0,0,0,0,0,0,0,0,0,26124),
(451122,'Y... your majesty...','Y... your majesty...',1,0,0,0,0,0,0,0,0,0,0,0,26124),
(147389,'The world\'s bleedin\' out. Hope you can stop it, hero.','The world\'s bleedin\' out. Hope you can stop it, hero.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(542001,'I want to preview rewards what you have.','I want to preview rewards what you have.',0,0,0,0,0,0,0,0,0,0,0,0,0),
(147390,'Even the Dark Lady can\'t save us now...','Even the Dark Lady can\'t save us now...',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147391,'Sure hope the boss knows what he\'s doin\'.','Sure hope the boss knows what he\'s doin\'.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147392,'Ain\'t easy ta meet my quota with that giant sword loomin\' overhead!','Ain\'t easy ta meet my quota with that giant sword loomin\' overhead!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(5421702,'Powers of Light will heal you.','Powers of light will heal you.',0,0,0,0,0,0,0,0,2,0,0,0,0),
(147393,'You\'re in the world savin\' business, ain\'t ya? Maybe you should get ta work!','You\'re in the world savin\' business, ain\'t ya? Maybe you should get ta work!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(5421701,'I\'ll heal your wounds.','I\'ll heal your wounds.',0,0,0,0,0,0,0,0,2,0,0,0,0),
(147394,'Should be earnin\' hazard pay for this!','Should be earnin\' hazard pay for this!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(5421700,'I\'ll help you!','I\'ll help you!',0,0,0,0,0,0,0,0,2,0,0,0,0),
(147414,'<Recall the events following Argus>','<Recall the events following Argus>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(5421646,'For the honor.','For the honor.',0,0,0,0,0,0,0,0,2,0,0,0,0),
(5421647,'Give up, dogs!','Give up, dogs!',0,0,0,0,0,0,0,0,2,0,0,0,0),
(147415,'<Recall the fallout of the wound in Silithus>','<Recall the fallout of the wound in Silithus>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(147416,'<Recall the fallout of the wound in Silithus>','<Recall the fallout of the wound in Silithus>',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(5421645,'You will beg for mercy!','You will beg for mercy!',0,0,0,0,0,0,0,0,2,0,0,0,0),
(147680,'This island is ripe with thermal activity. After a geyser plumes, azerite is sure to spill out of the fissures. This has got to be worth a fortune!','This island is ripe with thermal activity. After a geyser plumes, azerite is sure to spill out of the fissures. This has got to be worth a fortune!',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(5421643,'For glory of the Alliance!','For glory of the Alliance!',0,0,0,0,0,0,0,0,2,0,0,0,0),
(5421644,'I\'ll kill you fast!','I\'ll kill you fast!',0,0,0,0,0,0,0,0,2,0,0,0,0),
(600022,'WARNING! = IF YOU LOST ARTIFACT AND WANT TO BUY IT HERE, MAKE LOGOUT FROM YOUR CHARACTER AT FIRST. LOST ARTIFACTS AUTO RESTORED BY RELOG. = Hello, $n! I want to warn you I can repair not all bugged and not working achievements, quests etc.','WARNING! = IF YOU LOST ARTIFACT AND WANT TO BUY IT HERE, MAKE LOGOUT FROM YOUR CHARACTER AT FIRST. LOST ARTIFACTS AUTO RESTORED BY RELOG. = Hello, $n! I want to warn you I can repair not all bugged and not working achievements, quests etc.',0,0,0,0,0,0,0,0,0,0,0,0,0),
(200010,'You can buy unique chat logos for use in the world chat that will be displayed in any of your messages. You can activate\\deactivate the world chat logos from Me. You will not be charged again for the unqiue chat logos you have bought.','You can buy unique chat logos for use in the world chat that will be displayed in any of your messages. You can activate\\deactivate the world chat logos from Me. You will not be charged again for the unqiue chat logos you have bought.',0,0,0,0,0,0,0,0,0,0,0,0,0),
(200009,'You can change the personal rating of the experience to one of the following','You can change the personal rating of the experience to one of the following',0,0,0,0,0,0,0,0,0,0,0,0,0),
(200008,'Вендор предназначен для помощи игрокам, которые делали квесты в оплотах на патче 7.0.3 и по этой причине не могут пройти некоторые квесты на данный момент. Ниже приведен список квестов, с которыми мы можем помочь таким игрокам. Если же вы выполняли эти квесты, то повторно вы не сможете их сдать. Имейте ввиду, если у вас все нормально с нижеперечисленными квестами, то мы настоятельно НЕ рекомендуем использовать вендора, так как в вашем случае он скорее всего сыграет в минус, чем в плюс','Вендор предназначен для помощи игрокам, которые делали квесты в оплотах на патче 7.0.3 и по этой причине не могут пройти некоторые квесты на данный момент. Ниже приведен список квестов, с которыми мы можем помочь таким игрокам. Если же вы выполняли эти квесты, то повторно вы не сможете их сдать. Имейте ввиду, если у вас все нормально с нижеперечисленными квестами, то мы настоятельно НЕ рекомендуем использовать вендора, так как в вашем случае он скорее всего сыграет в минус, чем в плюс',0,0,0,0,0,0,0,0,0,0,0,0,0),
(200007,'To use the transmogrification, you should put in the first slot of the first bag the object whose shape you want to change, and in the second slot the object whose appearance you want to use! $ B For the source of the image you can use only special drawings designed for this!','To use the transmogrification, you should put in the first slot of the first bag the object whose shape you want to change, and in the second slot the object whose appearance you want to use! $ B For the source of the image you can use only special drawings designed for this!',0,0,0,0,0,0,0,0,0,0,0,0,0),
(200006,'You can impose one additional bonus (Movement Speed, Self-Healing or Evasion), Additional Colorless Nest, and Indestructible on any item of equipment at the same time. $BYou can use items that exceed 101 $BTo use, put the object in the first slot of the main bag! $BBonus overlay is not refundable $B ATTENTION!!! The maximum value of additional characteristics can not exceed 20%!','You can impose one additional bonus (Movement Speed, Self-Healing or Evasion), Additional Colorless Nest, and Indestructible on any item of equipment at the same time. $BYou can use items that exceed 101 $BTo use, put the object in the first slot of the main bag! $BBonus overlay is not refundable $B ATTENTION!!! The maximum value of additional characteristics can not exceed 20%!',0,0,0,0,0,0,0,0,0,0,0,0,0),
(200005,'From 1 to 20 for ONE level: 15 tokens $ BС 20 to 40 for ONE level: 50 tokens $ BС 40 to 60 for ONE level: 100 tokens $ BС 60 to 80 for ONE level: 150 tokens $ BС 80 to 100 for ONE Level: 200 tokens $ BС 100 to 101 for ONE level: 275 tokens','From 1 to 20 for ONE level: 15 tokens $ BС 20 to 40 for ONE level: 50 tokens $ BС 40 to 60 for ONE level: 100 tokens $ BС 60 to 80 for ONE level: 150 tokens $ BС 80 to 100 for ONE Level: 200 tokens $ BС 100 to 101 for ONE level: 275 tokens',0,0,0,0,0,0,0,0,0,0,0,0,0),
(200003,'Welcome to the SPP Service NPC. $b$b Here you can choice various services for your character. ','Welcome to the SPP Service NPC. $b$b Here you can choice various services for your character. ',0,0,0,0,0,0,0,0,0,0,0,0,0),
(200002,'from the 1st to the 20th level the cost of service for 1 level - 1 Token. $B from the 20-st to the 30th level the cost of service for 1 level - 2 Tokens. $B from the 30-st to the 40th level the cost of service for 1 level - 3 Tokens $B from the 40-st to the 50th level the cost of service for 1 level - 4 Tokens. $B from the 50-st to the 60th level the cost of service for 1 level - 5 Tokens. $B from the 60-st to the 70th level the cost of service for 1 level - 6 Tokens. $B from the 70-st to the 80th level the cost of service for 1 level - 10 Tokens. %B from the 80-st to the 90th level the cost of service for 1 level - 20 Tokens. $B from the 90-st to the 100-th level the cost of service for 1 level - 40 Tokens. $BAlso in the gift you get gold, the amount of which is also indicated in the \"estimates\" prices.','from the 1st to the 20th level the cost of service for 1 level - 1 Token. $B from the 20-st to the 30th level the cost of service for 1 level - 2 Tokens. $B from the 30-st to the 40th level the cost of service for 1 level - 3 Tokens $B from the 40-st to the 50th level the cost of service for 1 level - 4 Tokens. $B from the 50-st to the 60th level the cost of service for 1 level - 5 Tokens. $B from the 60-st to the 70th level the cost of service for 1 level - 6 Tokens. $B from the 70-st to the 80th level the cost of service for 1 level - 10 Tokens. %B from the 80-st to the 90th level the cost of service for 1 level - 20 Tokens. $B from the 90-st to the 100-th level the cost of service for 1 level - 40 Tokens. $BAlso in the gift you get gold, the amount of which is also indicated in the \"estimates\" prices.',0,0,0,0,0,0,0,0,0,0,0,0,0),
(200001,'You can increase your level to any of up to 100, inclusive, which you specify. Rates can be found by clicking on the appropriate button. $B To find out the exact number of Tokens, which is not necessary to have character, you can click on \"Calculate the cost\" (do not remove the Tokens). $B The very raising of the level takes place without confirmation / intermediate instructions Tokens. $BAlso in the gift you get gold, the amount of which is also indicated in the \"estimates\" prices.','You can increase your level to any of up to 100, inclusive, which you specify. Rates can be found by clicking on the appropriate button. $B To find out the exact number of Tokens, which is not necessary to have character, you can click on \"Calculate the cost\" (do not remove the Tokens). $B The very raising of the level takes place without confirmation / intermediate instructions Tokens. $BAlso in the gift you get gold, the amount of which is also indicated in the \"estimates\" prices.',0,0,0,0,0,0,0,0,0,0,0,0,0),
(200000,'The cost of all items is indicated in the tokens. $B You can replenish the balance of the tokens in your account. $B You can see your current balance below. $B All items, ranks and mounts become a personal purchase. Not all items are refundable, mounts and ranks are not refundable. $B To use purchased morphs, use the .donate morph commands','The cost of all items is indicated in the tokens. $B You can replenish the balance of the tokens in your account. $B You can see your current balance below. $B All items, ranks and mounts become a personal purchase. Not all items are refundable, mounts and ranks are not refundable. $B To use purchased morphs, use the .donate morph commands',0,0,0,0,0,0,0,0,0,0,0,0,0),
(200011,'You can select any morphs for previewing. It is free.','You can select any morphs for previewing. It is free.',0,0,0,0,0,0,0,0,0,0,0,0,0),
(143003,'Champions, ye unified yer orders and fought together ta drive the Legion from Azeroth.','',0,0,0,0,0,0,1,0,0,0,94519,0,26972),
(143004,'I know tensions are risin\'... but I\'m callin\' on ye ta stand together once more.','',0,0,0,0,0,0,1,0,0,0,94520,0,26972),
(5421642,'For the King!','For the King!',0,0,0,0,0,0,0,0,2,0,0,0,0),
(143005,'Come ta Silithus... while we still have a world left ta fight for!','',0,0,0,0,0,0,603,0,0,0,94521,0,26972),
(143006,'The sword of Sargeras is poisonin\' the very lifeblood of the world.','',0,0,0,0,0,0,1,0,6,0,94522,0,26972),
(143007,'The only vessels capable o\' containin\' that kind o\' power... are the mighty weapons you wield.','',0,0,0,0,0,0,1,0,6,0,94523,0,26972),
(143008,'Raise them up as one.... draw out the corruption from the Dark Titan\'s blade!','',0,0,0,0,0,0,1,0,6,0,94524,0,26972),
(143009,'Together, champions! For Azeroth!','',0,0,0,0,0,0,603,0,6,0,94525,0,26972),
(143010,'Ye did it! Sargeras\' sword has gone dormant. Now, Azeroth\'s not yet healed... but your actions bought us precious time.','',0,0,0,0,0,0,1,0,0,0,94526,0,26972),
(143011,'The energy coursin\' through that weapon o\' yers... I ain\'t seen nothin\' like it! But remember, all power comes with a price.','',0,0,0,0,0,0,1,0,0,0,94527,0,26972),
(143012,'I know there\'s much ta face in the days ahead. But no matter what comes... never forget our duty ta Azeroth!','',0,0,0,0,0,0,1,0,0,0,94528,0,26972),
(5421641,'Horde will fall!','Horde will fall!',0,0,0,0,0,0,0,0,2,0,0,0,0),
(75935,'The Red Crane saw hope in me, and instructed me to look inward. Despite my visage of despair, I found this hope, and the despair was vanquished.','',0,0,0,0,0,0,0,0,7,0,38038,38038,26124),
(5421634,'Weaken!','Weaken!',0,0,0,0,0,0,0,0,2,0,0,0,0),
(5421635,'For the Warchief!','For the Warchief!',0,0,0,0,0,0,0,0,2,0,0,0,0),
(5421636,'Ah, you Alliance dog.','Ah, you Alliance dog.',0,0,0,0,0,0,0,0,2,0,0,0,0),
(5421637,'Taste my blade.','Taste my blade.',0,0,0,0,0,0,0,0,2,0,0,0,0),
(5421640,'For the Alliance!','For the Alliance!',0,0,0,0,0,0,0,0,2,0,0,0,0),
(75936,'In the face of great fear, the Black Ox taught me fortitude. Through terror and darkness it persevered. The fear was vanquished.','',0,0,0,0,0,0,0,0,7,0,38039,38039,26124),
(5421630,'Die, Alliance scum!','Die, Alliance scum!',0,0,0,0,0,0,0,0,2,0,0,0,0),
(5421631,'I\'ll crush you!','I\'ll crush you!',0,0,0,0,0,0,0,0,2,0,0,0,0),
(5421632,'For the Horde!','For the Horde!',0,0,0,0,0,0,0,0,2,0,0,0,0),
(5421633,'You will fall!','You will fall!',0,0,0,0,0,0,0,0,2,0,0,0,0),
(75937,'You have walked the trial of wisdom, and learned of the path of the Jade Serpent. May you learn from this lesson, as I did.','',0,0,0,0,0,0,0,0,7,0,38040,38040,26124),
(5421402,'I\'m ready to go on the battleship.','I\'m ready to go on the battleship.',0,0,0,0,0,0,0,0,2,0,0,0,0),
(5421670,'Heeeelp!','Heeeelp!',0,0,0,0,0,0,0,0,2,0,0,0,0),
(75938,'You have walked the trial of strength, and learned of the path of the White Tiger. May you remember this lesson, always.','',0,0,0,0,0,0,0,0,7,0,38041,38041,26124),
(5421400,'I\'m ready to help in Warsong Gulch.','I\'m ready to help in Warsong Gulch.',0,0,0,0,0,0,0,0,2,0,0,0,0),
(5421401,'I\'m finish in Warsong Gulch.','I\'m finish in Warsong Gulch.',0,0,0,0,0,0,0,0,2,0,0,0,0),
(75939,'You have walked the trial of hope, and learned of the path of the Red Crane. May it guide your footsteps through time.','',0,0,0,0,0,0,0,0,7,0,38042,38042,26124),
(542002,'Information.','Information.',0,0,0,0,0,0,0,0,0,0,0,0,0),
(5421850,'|TINTERFACE\\ICONS\\ABILITY_MAGE_COLDASICE.blp:20|t The Atray casts |cFFFF0404|Hspell:305248|h[Atray\'s Fury]|h|r!',NULL,0,0,0,0,0,0,0,0,0,0,0,0,0),
(542173,'Take a ride!','Take a ride!',0,0,0,0,0,0,0,0,2,0,0,0,0),
(75940,'You have walked the trial of fortitude, and learned of the path of the Black Ox. May it bless your passage.','',0,0,0,0,0,0,0,0,7,0,38043,38043,26124),
(600023,'Remove your Garrison.(!!!Use it ONLY if your garrison is bugged after change faction!!!)','Remove your Garrison.(!!!Use it ONLY if your garrison is bugged after change faction!!!)',0,0,0,0,0,0,0,0,0,0,0,0,0),
(700000,'If you lost achievement criteria for completed quest after server crash, you can restore it here. Just enter quest ID in menu. You can find required quest ID on Wowhead.com cite, you need to find your achievement and looking for required criteria. $b$bAlso, if you have achievements with completed(green) criterias or with completed progress and still doesn\'t receive it, you can try to enter achievement ID in achieve menu option.','If you lost achievement criteria for completed quest after server crash, you can restore it here. Just enter quest ID in menu. You can find required quest ID on Wowhead.com cite, you need to find your achievement and looking for required criteria. $b$bAlso, if you have achievements with completed(green) criterias or with completed progress and still doesn\'t receive it, you can try to enter achievement ID in achieve menu option.',0,0,0,0,0,0,0,0,0,0,0,0,26124),
(600024,'WARNING! THIS ACTION COMPLETELY REMOVE YOUR GARRISON! THIS ACTION CAN\'T BE CANCELLED! YOU ONLY NEED TO USE IT WHEN YOUR GARRISON IS BUGGED AFTER CHANGE FACTION! CONTINUE?','WARNING! THIS ACTION COMPLETELY REMOVE YOUR GARRISON! THIS ACTION CAN\'T BE CANCELLED! YOU ONLY NEED TO USE IT WHEN YOUR GARRISON IS BUGGED AFTER CHANGE FACTION! CONTINUE?',0,0,0,0,0,0,0,0,0,0,0,0,0),
(600025,'Information.','Information.',0,0,0,0,0,0,0,0,0,0,0,0,0),
(700001,'Hello, $n! Thanks for playing on our server.','Hello, $n! Thanks for playing on our server.',0,0,0,0,0,0,0,0,0,0,0,0,0);

/*Table structure for table `broadcast_text_locale` */

DROP TABLE IF EXISTS `broadcast_text_locale`;

CREATE TABLE `broadcast_text_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Text_lang` text,
  `Text1_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`),
  KEY `Text_lang` (`Text_lang`(333)),
  KEY `Text1_lang` (`Text1_lang`(333))
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `broadcast_text_locale` */

insert  into `broadcast_text_locale`(`ID`,`locale`,`Text_lang`,`Text1_lang`,`VerifiedBuild`) values 
(1,'enUS','Help help!  I\'m being repressed!','',26124),
(3,'enUS','Company.. HALT!  ... Fall IN!','Company.. HALT!  ... Fall IN!',26124),
(4,'enUS','Forward.. MARCH!!','',26124),
(5,'enUS','Come, let us engage in fisticuffs, like civilized folk.','Come, let us engage in fisticuffs, like civilized folk.',26124),
(7,'enUS','Thank you very much!','Thank you very much!',26124),
(9,'enUS','Follow me, $n. I\'ll take you to the Defias hideout. But you better protect me or I am as good as dead.','',26124),
(10,'enUS','The entrance is hidden here in Moonbrook.  Keep your eyes peeled for thieves.  They want me dead.','',26124),
(11,'enUS','You can go tell Stoutmantle this is where the Defias Gang is holed up, $n.','',26124),
(13,'enUS','Work scum!','',26124),
(14,'enUS','Grrrr! Idiots!','',26124),
(15,'enUS','Good for nothing Kobolds!','',26124),
(16,'enUS','All right people, look alive!','',26124),
(17,'enUS','All right, you guys! Time to get up','',26124),
(19,'enUS','Hey, follow me!','',26124),
(22,'enUS','Another herd brought in successfully!','',26124),
(23,'enUS','Well I\'m here.  And I\'m ready to rejoin...','',26124),
(24,'enUS','You\'re not joining anyone, Thorsen..','',26124),
(25,'enUS','My wounds are grave.  Forgive my slow pace but my injuries won\'t allow me to walk any faster.','',26124),
(26,'enUS','Ah, fresh air at last! I need a moment to rest.','',26124),
(27,'enUS','The Blackrock infestation is thick in these parts.  I will do my best to keep the pace.  Let\'s go!','',26124),
(28,'enUS','So close to blessed Lakeshire.  By the Light, let my legs carry me a bit further!','',26124),
(29,'enUS','Marshal Marris, sir.  Corporal Keeshan of the 12th Sabre Regiment returned from battle and reporting for duty!','',26124),
(30,'enUS','Brave adventurer, thank you for rescuing me! I am sure Marshal Marris will reward your kind deed.','',26124),
(33,'enUS','Antonio Perelli\'s miracle elixirs for sale!','',26124),
(35,'enUS','Come one! Come all! Perelli\'s elixirs will dazzle!','',26124),
(36,'enUS','Stonemasons. . .errr. . Defias be warned:  The rusty anchor sinks tonight.','',26124),
(37,'enUS','The boss wants all hands on high alert.  The rusty anchor sinks tonight.','',26124),
(38,'enUS','I\'m here for the gold.','',26124),
(39,'enUS','Everywhere I look I see thieves.  We, The People\'s Miltia, must return this land to the farmers.','',26124),
(40,'enUS','The farms must be liberated.  Stormwind may have deserted these people, but I\'ll be damned if I will.','',26124),
(41,'enUS','','Defias activity reported on the costal horizon.  All clear on Sentinel Hill.',26124),
(42,'enUS','Lots of gnoll activity reported in the Gold Coast Quarry and the Jangolode Mine.','',26124),
(43,'enUS','All clear on Sentinel Hill, Lord Stoutmantle.  Heavy Defias movement reported in Moonbrook, however.','',26124),
(44,'enUS','Stormwind\'s desertion shall not be forgiven by the people of Westfall.','',26124),
(45,'enUS','Nothing biting. . . .','',26124),
(46,'enUS','Here fishy fishy. . . come to papa.','',26124),
(47,'enUS','Pull up a stool and have a drink!','',26124),
(48,'enUS','The bottles are dusty but the liquor goes down clean!','',26124),
(49,'enUS','','Hopefully the reinforcements from Stormwind show up soon. . . .',26124),
(50,'enUS','Come on boys, we\'ve got to get this bridge rebuilt.','',26124),
(51,'enUS','Where are those reinforcements from Stormwind?  Heavy Blackrock activity has been reported in the East.','',26124),
(52,'enUS','Still no sign of the 2nd Battalion from Stormwind.  Reports are coming in of Shadowhide movement in the Northeast.','',26124),
(53,'enUS','Marshal Marris expects the reserve from Stormwind any time now. . . .','',26124),
(54,'enUS','','Don\'t worry, Old Blanchy, we\'ll get you something to eat soon. . .',26124),
(55,'enUS','','I never thought the day would come that I\'d leave my homeland of Westfall. . . .',26124),
(56,'enUS','Can\'t believe the forsaken wagon broke down.  Ain\'t no luck to be had in this land. . . .','',26124),
(57,'enUS','We\'ll be out of here just as soon as I get this wagon fixed. . . .','',26124),
(58,'enUS','Now how am I supposed to get those mechanical wretches out of my fields?','',26124),
(59,'enUS','A bunch of thugs and thieves aren\'t going to get me to leave my land!','',26124),
(60,'enUS','They might have run all the other farmers off, but the Saldean\'s will never leave Westfall.','',26124),
(61,'enUS','','Stay on the roads.  The forest is overrun with undead.',26124),
(62,'enUS','','Fear not.  The Night Watch will rid the land of this foul taint soon enough.',26124),
(63,'enUS','Undead are crawling all over the land.  Where is the Stormwind Army?','',26124),
(64,'enUS','The Night Watch alone cannot protect us forever.  We need the backing of the Stormwind Army.','',26124),
(65,'enUS','We must not give into the evil which has darkened our land.  The Night Watch must prevail!','',26124),
(66,'enUS','The forest is crawling with worgen and ghouls.  Something must be done!','',26124),
(67,'enUS','We need better representation from Stormwind.  Our homes are falling to the undead.','',26124),
(68,'enUS','The Council of Duskwood must take action.  Evil lingers in the air.','',26124),
(69,'enUS','The people of Darkshire expect more from the Council.  We cannot let them suffer from this unholy wrath which plagues us.','',26124),
(70,'enUS','Constant bickering will get us nowhere.  We need to take action.','',26124),
(71,'enUS','The news from Stormwind does not bode well. . . .','',26124),
(72,'enUS','Our cause falls on deaf ears beyond the thick, stone walls of Stormwind.','',26124),
(73,'enUS','','I sense evil brewing. . . .',26124),
(74,'enUS','','The stars speak to me.  They whisper of the horrors waiting in the night.',26124),
(75,'enUS','','The future holds much death and uncertainty, not unlike the past.',26124),
(76,'enUS','','The spirits whisper in my ear.  They are restless and full of angst.',26124),
(77,'enUS','The stars will be in perfect form tonight!','',26124),
(79,'enUS','There is something greater than magic at work in the night sky.  One day they\'ll listen to me. . . .','',26124),
(80,'enUS','Psssst.  We just got some Moonshine in. . . .','',26124),
(81,'enUS','Step right up and wet your whistle.','',26124),
(82,'enUS','This dark taint is downright bad for business.','',26124),
(83,'enUS','Welcome to the Scarlet Raven.  It\'s best to stay indoors these days.','',26124),
(84,'enUS','If your glass is full may it be again!','',26124),
(85,'enUS','Welcome to the Lion\'s Pride Inn.  Make yourself at home!','',26124),
(86,'enUS','So much to do, so much to do!  Where does the time go?','',26124),
(87,'enUS','Now where was that book on Night Elf customs I was looking for...','',26124),
(88,'enUS','Oh my!  Look at the state of these books!  Who put them back without alphabetizing them??','',26124),
(89,'enUS','Rouse and to arms, citizens of Darkshire! An abomination of the undead approaches along the road!','',26124),
(90,'enUS','The abomination has overrun the Night Watch camp! Quickly, we must intercept it before it reaches town!','',26124),
(91,'enUS','It isn\'t enough! Defenders, gather in the center of town. Together we will stand against the undead monster!','',26124),
(92,'enUS','The abomination has come! Forward!','',26124),
(93,'enUS','The beast is slain! All\'s well in Darkshire!','',26124),
(94,'enUS','I didn\'t know he was getting married! I didn\'t even know he was dating! That\'s terrible! He can\'t work nights anymore!','',26124),
(95,'enUS','Fine! You\'ve outreasoned me, you masters of Engineering! Put the door wherever you want!','',26124),
(96,'enUS','That\'s right, we\'re stupid. Stupid like a Fox!','',26124),
(97,'enUS','Where\'s My Bacon?','',26124),
(98,'enUS','','You\'ve ruined your own lands, you\'ll not ruin mine.',26124),
(99,'enUS','$n!','',26124),
(100,'enUS','Thanks for saving me!','',26124),
(101,'enUS','Now you die!','',26124),
(102,'enUS','Time for my patrol.  I\'ll be back shortly.','',26124),
(103,'enUS','Now that the coast is clear...','',26124),
(104,'enUS','Who goes there??','',26124),
(105,'enUS','I\'ve been gone a long time...I better get back.','',26124),
(106,'enUS','Private Thorsen returning from patrol.  Nothing new to report - it\'s pretty quiet out there...','',26124),
(107,'enUS','','It\'ll take more than a rotting corpse to stop us!',26124),
(108,'enUS','','Very good.  You are relieved, private.  Rest, but don\'t get too comfortable.  Kurzen won\'t leave us alone forever.',26124),
(109,'enUS','What is going on here?  Leave that powder alone!','',26124),
(110,'enUS','Aber?  Is that you...?  Oh...I\'m so hungry, Aber!  SO HUNGRY!!','',26124),
(111,'enUS','Wait...you are not my husband.  But he must have sent you.  And you...look..delicious!','',26124),
(112,'enUS','Let\'s see if I can hit that bullseye this time.','',26124),
(113,'enUS','Looks like I need more practice!','',26124),
(114,'enUS','\'Bout time fer me to make mah rounds.','',26124),
(115,'enUS','Ah I am too busy for a drink now lad.','',26124),
(117,'enUS','Ach! Toss me a cold frosty, Belm!','',26124),
(118,'enUS','Bagh! Back to work for me! Thank you kindly Belm.','',26124),
(120,'enUS','Aye there you go lad, your favorite brew.','',26124),
(121,'enUS','Aye, tell your friend there Tongus if he dont take care of his tab here, i\'ll be making an appearance with old Steelhead!','',26124),
(122,'enUS','Belm says pay your bill or he\'ll break your face.','',26124),
(123,'enUS','Hoha! I\'d welcome the challenge from old weakbelly!','',26124),
(124,'enUS','I\'ll take whatever ya got cookin\'! And throw in a bottle to wash it down!','',26124),
(125,'enUS','Hey there, Belm!  Give me a mug of Thunder Ale, and one for my good friend $n.','',26124),
(126,'enUS','How goes the barrel watching...?','',26124),
(127,'enUS','Ah, that sure does hit the spot!  I think I\'ll get myself a couple more...can you watch these barrels for me, $n?','',26124),
(128,'enUS','Well, back to business for me.  But it sure was nice taking that short break, and it\'s always nice drinking Thunder Ale!','',26124),
(129,'enUS','I\'m back where I started.','',26124),
(130,'enUS','I\'m now far enough away...so I can\'t see the barrel.  Poison away!.','',26124),
(131,'enUS','Think there are any fish in here?','Think there are any fish in here?',26124),
(132,'enUS','I caught a big one last week, it had three eyes!','I caught a big one last week, it had three eyes!',26124),
(133,'enUS','My daddy says that in the ocean, there are fish so big they could swallow a whole ship.','My daddy says that in the ocean, there are fish so big they could swallow a whole ship.',26124),
(134,'enUS','My daddy can catch more fish than your daddy!','My daddy can catch more fish than your daddy!',26124),
(135,'enUS','Look! Look! I caught something! Aww....it\'s just a stinky ol\' boot.','Look! Look! I caught something! Aww....it\'s just a stinky ol\' boot.',26124),
(136,'enUS','Nuh uh.','Nuh uh.',26124),
(138,'enUS','Liar!','Liar!',26124),
(139,'enUS','I heard that there are these huge fish that can walk on land to hunt, and eat people!','I heard that there are these huge fish that can walk on land to hunt, and eat people!',26124),
(140,'enUS','And one time, at camp, I caught a fish that was bigger than I am!!','And one time, at camp, I caught a fish that was bigger than I am!!',26124),
(141,'enUS','I heard a story about this golden fish, and if you caught it you would get three wishes!','I heard a story about this golden fish, and if you caught it you would get three wishes!',26124),
(142,'enUS','If you fished as well as you talked the ocean wouldn\'t have any fish left.','If you fished as well as you talked the ocean wouldn\'t have any fish left.',26124),
(143,'enUS','Shhh! You\'re scaring the fish away.','Shhh! You\'re scaring the fish away.',26124),
(144,'enUS','You\'re making that up.','You\'re making that up.',26124),
(145,'enUS','If you could catch a fish big enough for your mouth we\'d never be hungry again.','If you could catch a fish big enough for your mouth we\'d never be hungry again.',26124),
(146,'enUS','Maybe we should go to the bridge and fish.','Maybe we should go to the bridge and fish.',26124),
(147,'enUS','Really?','Really?',26124),
(149,'enUS','And that\'s how Lothar killed thirty six orcs with his bare hands!','And that\'s how Lothar killed thirty six orcs with his bare hands!',26124),
(150,'enUS','And so the knights stood before the charging Horde and held their ground as a thousand berserk orcs came through the valley.','And so the knights stood before the charging Horde and held their ground as a thousand berserk orcs came through the valley.',26124),
(151,'enUS','They say he can turn into a raven sometimes.','They say he can turn into a raven sometimes.',26124),
(152,'enUS','You know why orc eyes glow red? It\'s because they drink blood!','You know why orc eyes glow red? It\'s because they drink blood!',26124),
(153,'enUS','There is no spoon.','There is no spoon.',26124),
(154,'enUS','I swear, people have actually seen them. Pandaren really do exist!','I swear, people have actually seen them. Pandaren really do exist!',26124),
(155,'enUS','And then the rabbit just bit his head off... I swear.','And then the rabbit just bit his head off... I swear.',26124),
(156,'enUS','You know there are crocolisks in the Canals. They were brought from the swamp as pets, but got thrown in the canals.','You know there are crocolisks in the Canals. They were brought from the swamp as pets, but got thrown in the canals.',26124),
(157,'enUS','Wow.','Wow.',26124),
(158,'enUS','Oh yeah, I heard about that.','Oh yeah, I heard about that.',26124),
(159,'enUS','','Come back, Fluffy!',26124),
(160,'enUS','','Why do you run from me, Fluffy?!',26124),
(161,'enUS','','C\'mon, Fluffy! I just want to give you a bath!',26124),
(162,'enUS','','Fluffy! Fluffy, stop running!',26124),
(164,'enUS','','Carrots every day for a year if you stop!',26124),
(165,'enUS','','Don\'t make me get my pappy to catch you! He likes to catch bunnies using his rifle!',26124),
(166,'enUS','Oh c\'mon, that\'s not true.','Oh c\'mon, that\'s not true.',26124),
(167,'enUS','That\'s neat.','That\'s neat.',26124),
(168,'enUS','My father says that\'s just a story.','My father says that\'s just a story.',26124),
(169,'enUS','Can you imagine?','Can you imagine?',26124),
(170,'enUS','Sounds kinda like one of Billy\'s fish stories to me.','Sounds kinda like one of Billy\'s fish stories to me.',26124),
(171,'enUS','I thought I heard something.','I thought I heard something.',26124),
(172,'enUS','I think I see something.','I think I see something.',26124),
(173,'enUS','Eww... that\'s not a fish!','Eww... that\'s not a fish!',26124),
(174,'enUS','I got worm guts on my shoes.','I got worm guts on my shoes.',26124),
(175,'enUS','Something smells funny.','Something smells funny.',26124),
(176,'enUS','I hope that was a fish!','I hope that was a fish!',26124),
(177,'enUS','I don\'t think there\'s any fish in these canals.','I don\'t think there\'s any fish in these canals.',26124),
(178,'enUS','Worm goes on the hook, hook goes in the water. Fish is in the water, our fish.','Worm goes on the hook, hook goes in the water. Fish is in the water, our fish.',26124),
(179,'enUS','Could ye spare some coin?','',26124),
(181,'enUS','Alms for the poor?','',26124),
(182,'enUS','I will gladly pay you Tuesday for a hamburger today.','',26124),
(183,'enUS','Help a poor bloke out?','',26124),
(184,'enUS','Spare some change for a poor blind man? ...What do you mean I\'m not blind? ...I\'M NOT BLIND! I CAN SEE!! It\'s a miracle!','',26124),
(185,'enUS','Shine yer armor for a copper.','',26124),
(186,'enUS','It\'s all their fault, stupid Alliance army. Just had to build their towers right behind my farm.','',26124),
(187,'enUS','It\'s all their fault, stupid orcs. Had to burn my farm to the ground.','',26124),
(188,'enUS','You hear that? I think they\'re getting closer...','',26124),
(189,'enUS','Guard duty, I hate guard duty.','',26124),
(190,'enUS','I heard all the kobolds that were down there are dead.','',26124),
(192,'enUS','Sorry, Huldar... But it seems I\'ve misled you.','',26124),
(194,'enUS','Dark Iron activity. Even that some of the shipments have been hijacked--','',26124),
(195,'enUS','I\'m sure it\'s just incompetence or oversight by some of the workers.','',26124),
(197,'enUS','All hail, $n! Defender of The People!','',26124),
(198,'enUS','The People of Westfall salute $n, a brave and valiant defender of freedom.','',26124),
(199,'enUS','Three cheers for $n!  This land shall be ours once again!','',26124),
(200,'enUS','Thanks for the cask of booze, $n.  I think I\'ll open up a bottle right now!','',26124),
(201,'enUS','','If we reverse the Essence flows perhaps we can alter the polarity.',26124),
(203,'enUS','','So then the array of magics would cascade into a chain reaction of positively charged energies.',26124),
(204,'enUS','','The portal will shift slightly, at this point if you cast a binding cantrip you will solidify it in place.',26124),
(205,'enUS','','When the positively aligned energies collide with the negatively charged energies, they don\'t negate one another.',26124),
(206,'enUS','','Maginor says that twisting alternating flows of positive energy actually creates a much more stable flow.',26124),
(207,'enUS','','The magical wards at that point should be supported enough by the energy flux to contain the entity.',26124),
(208,'enUS','','Why can\'t we just shift the array to compensate for the variance in the flux?',26124),
(209,'enUS','','Putting in twelve centers of focus might allow the magical energies to form more solidly, adding the necessary stability.',26124),
(210,'enUS','','But what if the resulting frequency shift were to send magical feedback up the flows?',26124),
(211,'enUS','','Wouldn\'t that cause the weave to unravel if not properly anchored before starting the casting?',26124),
(212,'enUS','','But wouldn\'t that mean crossing the streams? Isn\'t that really bad?',26124),
(213,'enUS','','The resultant energies could collapse though, and that could cause an energy flux that would give you a migraine for weeks.',26124),
(214,'enUS','','But isn\'t that what caused the initial problems with Adept Syleria\'s magical formulae?',26124),
(215,'enUS','','I think not, I don\'t need to be blown up again.',26124),
(216,'enUS','','That will unbalance the magical focus, though, and cause a reverse vibration in the ether.',26124),
(217,'enUS','','I suppose that could work, if we had twenty people to cast it with.',26124),
(218,'enUS','','What if we used three focuses in Tyrean pattern? That should solve it.',26124),
(219,'enUS','','But if we stabilize it with an anchor thread at the appropriate energy crux then it should work.',26124),
(220,'enUS','','Always so negative. The chances of that happening are between zero and none.',26124),
(221,'enUS','','If we use the appropriate sequence we should be ok. Will just take some serious studying before we start.',26124),
(222,'enUS','','Wow, all of this for a love potion. Hope he\'s worth it.',26124),
(223,'enUS','','If we use the Surian theory, then yes, but not if we go with the Y\'serian approach.',26124),
(224,'enUS','','At least we wouldn\'t be around to have to clean it up.',26124),
(225,'enUS','','Only if we didn\'t follow the proper initialization procedures.',26124),
(226,'enUS','I suppose you\'re right.','',26124),
(227,'enUS','','Here\'s my list, Keldric. The usual stuff.',26124),
(228,'enUS','','Thank you, Keldric. See you later.',26124),
(229,'enUS','Curse you, $n!  One day, vengeance will be mine!','',26124),
(230,'enUS','Alright, we\'ve just gotten word that a caravan is leaving from Thelsamar. It\'s time to move! Go go go!','',26124),
(231,'enUS','Alright, we\'re getting close to the excavation site, so we have to proceed carefully. Engage underwater breathing apparatus...','',26124),
(232,'enUS','Hey Stone, did you hear about the new steam engine old Tonkrend has been runnin on?','',26124),
(233,'enUS','Ah yes. I\'ve heard all about those new flarged things. Armor was removed from the casing to decrease weight. Bargh! Nonsense!','',26124),
(234,'enUS','Do you ever think about anything other than fighting? I could circle you down on the stretch course!','',26124),
(235,'enUS','Bah! By the time you got in range of old Trollplow you would be in reduced to rubble!','',26124),
(236,'enUS','Argh! You\'re hopeless!','',26124),
(237,'enUS','Hey Fizzer, I ever tell you the time I was riding through the canals and some goblins in shredder suits tried to ambush me?','',26124),
(238,'enUS','Ah, let me see. Yes probably nearing a hundred times now I\'d wager!','',26124),
(239,'enUS','Brahaha! Tha look on their faces as old Trollplow\'s gun came swiveling around to meet them! Their saws couldn\'t even touch me!','',26124),
(240,'enUS','I would have just dropped some Evershine in my tank and been back home before they realized I\'d gone!','',26124),
(241,'enUS','Bah! That\'s no fun!','',26124),
(242,'enUS','Hey Stone, let\'s hit the circuit some time. We could run a few laps and see who wins?','',26124),
(244,'enUS','Aye sure, just as long as we get to hit the arena right after!','',26124),
(245,'enUS','Nothing you can say will ever get me in the arena against that monstrosity of a machine you call a steam tank!','',26124),
(246,'enUS','Har! You scared I\'ll hurt your little dainty racer?','',26124),
(247,'enUS','Ha! I\'m more afraid that those old holes and gashes would burst that thing and I would be showered by the shrapnel!','',26124),
(248,'enUS','Haha! Sturdy old Trollplow has just a few meager battle scars!','',26124),
(249,'enUS','Nothing beats the sound of a twin-carb, fork-ring steam engine burning pure firestone!','',26124),
(250,'enUS','Ha! I\'d take the sound of a Crater Cannon XT blasting off a shell over that any day!','',26124),
(251,'enUS','Bah! You wouldn\'t know a great steam engine if it smacked you upside the head!','',26124),
(252,'enUS','Maybe, but if it did hit me upside the head I\'d know exactly which cannon to use to blow it into the smallest bits!','',26124),
(253,'enUS','','Corbett, dear.  Harlan needs a load of knitted shirts and pants as soon as we can manage.',26124),
(254,'enUS','','Corbett, you there?  Harlan needs another load of knitted goods.  Can you take it to him?',26124),
(255,'enUS','My pleasure, sugar drop.  I\'ll be back soon...','',26124),
(256,'enUS','Business must be good down at the bazaar.  I\'ll get him resupplied right away!','',26124),
(257,'enUS','Hm...after dropping this off, I think I\'ll head to that cheese shop for a snack.','',26124),
(258,'enUS','I should have a few extra coins from this sale.  Maybe I\'ll buy myself some lunch...','',26124),
(259,'enUS','Hey, Harlan.  Here\'s a load of knitted cloth for you.','',26124),
(260,'enUS','Oomph!  Here\'s another load of supplies, Harlan.  It must be selling fast!','',26124),
(261,'enUS','Ah, much appreciated, Corbett.  We\'ll get these on the racks immediately.','',26124),
(262,'enUS','Ah yes, and promptly delivered.  As always, it\'s a pleasure doing business with you, Corbett.','',26124),
(263,'enUS','Well, I\'m off then.  Take care, Harlan.','',26124),
(264,'enUS','Glad to see you\'re doing so well, Harlan.  And I hope to see you again soon...','',26124),
(265,'enUS','Lord Mayor!  Our scouts report strange activity to the west.','',26124),
(266,'enUS','Mayor Ello!  Our graveyard scouts return with ominous reports...','',26124),
(267,'enUS','Hideous bellows and growls are heard coming from that old hermit\'s shack!','',26124),
(268,'enUS','Wolves head this way, as if fleeing from...something.','',26124),
(269,'enUS','Yes, Lord Mayor.','',26124),
(270,'enUS','This is grim news, and I fear it is linked to the dealings $n had with the Embalmer.','',26124),
(271,'enUS','Watcher, inform Althea that a dire threat is marshalling against our town.  We must prepare!','',26124),
(272,'enUS','Althea, there are reports of strange happenings at the graveyard.  Ello believes it portends an attack on Darkshire.','',26124),
(273,'enUS','','This doesn\'t bode well.  Send scouts to gather more intelligence, and stay on alert.',26124),
(275,'enUS','Yes, commander!','',26124),
(276,'enUS','Beware!  Beware!  A threat lurks in the wild!  Night Watchers, be on the alert!','',26124),
(277,'enUS','DARKSHIRE...I HUNGER!!','',26124),
(278,'enUS','ROARRRRR!!','',26124),
(279,'enUS','','...Nine...Ten...Ready or not.  Here I come!',26124),
(280,'enUS','','Hey! You better not have gone too far!',26124),
(281,'enUS','','Mom said not to climb up there any more.  I\'m gonna tell!',26124),
(282,'enUS','Thank you, $n.  May the Light bless you, $Gbrother:sister;, and guide your path.','',26124),
(283,'enUS','Now for that snack...','',26124),
(284,'enUS','Good day, Elling!  Hullo Elaine!  Let me have a wheel of bleu cheese, eh?','',26124),
(285,'enUS','Hullo, Trias clan!  A ball of your smoked mozzarella, if you please!','',26124),
(286,'enUS','','Good day, Corbett.  Here\'s your cheese, fresh made this morning!  And how are things at your shop?',26124),
(287,'enUS','','Hi Corbett!  Here, you go!  I trust business is faring well at your clothier shop...?',26124),
(288,'enUS','See you later, Corbett, and tell the missus hello!','',26124),
(289,'enUS','Take care, and send our regards to your family.','',26124),
(290,'enUS','Thank you kindly!','',26124),
(291,'enUS','Thanks for the cheese!','',26124),
(292,'enUS','I should get back before Rema starts to worry...','',26124),
(293,'enUS','Time to get back to the shop...','',26124),
(294,'enUS','I\'m back!','',26124),
(295,'enUS','Yes ma\'am, business is brisk!','',26124),
(296,'enUS','Testing 1','',26124),
(297,'enUS','Testing 2','',26124),
(298,'enUS','Testing 3','',26124),
(299,'enUS','I\'m out of the building again.  Now I\'ll move one more waypoint...','',26124),
(300,'enUS','I\'m moving within the building','',26124),
(301,'enUS','I made it to the last waypoint.  Yay!','',26124),
(302,'enUS','','Mom, Jesse climbed the wind tower again.',26124),
(303,'enUS','You\'d better not tattle on me!','',26124),
(304,'enUS','I can\'t come down.  I am scared.','',26124),
(305,'enUS','Whoa...Whoa..Aaaaahhh!','',26124),
(306,'enUS','Work you dogs! Put your back into it!','',26124),
(307,'enUS','','You get down from there right now!  I don\'t want you climbing that thing.  It\'s not safe.',26124),
(308,'enUS','','See what I mean?  Get inside right now.',26124),
(310,'enUS','This will take a while to heat up, so its time for a drink! What do you say Tongus?','',26124),
(311,'enUS','PICK ME!!!!!','',26124),
(312,'enUS','Attack!!','',26124),
(313,'enUS','Get in position lads! The beasties are upon us. Wait for my signal!','',26124),
(314,'enUS','These lands shall be cleansed!','',26124),
(316,'enUS','These undead atrocities will be destroyed!','',26124),
(317,'enUS','The Scarlet Crusade shall not fail in its mission!','',26124),
(318,'enUS','Stormy seas out there.  The sea spirits must be restless....hic!','',26124),
(319,'enUS','I saw a Sea Giant once.  It\'s not something I would care to see again.  Burp!','',26124),
(320,'enUS','I\'d go out and clear out some of those gnolls, but this leg has seen better days and I am afraid I\'d just wind up dead.','',26124),
(321,'enUS','Watch your step out there.  Many an adventure seeker has not returned from the marsh.  hic!','',26124),
(322,'enUS','It\'s time for my meditation, leave me.','',26124),
(323,'enUS','There you are. What news from Westfall?','',26124),
(324,'enUS','VanCleef sends word that the plans are underway. But he\'s heard rumors about someone snooping about.','',26124),
(325,'enUS','Very well. I will return then.','',26124),
(326,'enUS','Hmm, it could be that meddler Shaw. I will see what I can discover. Be off with you. I\'ll contact you again soon.','',26124),
(327,'enUS','*sigh* It\'s about time to check on the cemetery again-- I\'ll be back in a few minutes.','',26124),
(328,'enUS','We really should fix this fence soon.','',26124),
(329,'enUS','Vrok said the sights are off on Grumlar\'s gun. I suppose I should check it.','',26124),
(330,'enUS','Hmph! I didn\'t even hit the blasted target! That thick skulled dwarf was probably using the gun as a mace again.','',26124),
(331,'enUS','Hmmmm... That one clipped it\'s shoulder. Grumlar was right, the sights are slightly off. Easy enough for me to fix though.','',26124),
(332,'enUS','Almost perfect shot! It\'s a bit off but I can see where Grumlar would miss with it. He couldn\'t hit the broad side of a barn.','',26124),
(333,'enUS','Bullseye! That blasted dwarf doesn\'t know what he is talking about. Only thing wrong with Grumlar\'s gun is Grumlar\'s aim.','',26124),
(339,'enUS','Only $3658E shopping minutes before Christmas!  But wait, is it Christmas?  Well then, there are only $3659E minutes left to party!  TEST TEST DO NOT LOCALIZE','',26124),
(340,'enUS','Warg, are you about ready to eat? I am gonna get it started.','',26124),
(341,'enUS','','Khara hums an old dwarven tune while she cooks.',26124),
(342,'enUS','Hon, food is ready. Come wash up and eat.','',26124),
(343,'enUS','Mmmm, that was good. However, time to get back to work!','',26124),
(344,'enUS','Ahhh, just in time! My stomach was rumblin\' loud.','',26124),
(345,'enUS','MMmmMMmmm. Smells delicious Khara.','',26124),
(346,'enUS','Burp! Hon, that was really good. Not only do you know how to catch a fish but you sure do know how to cook one.','',26124),
(347,'enUS','Whew! I think I ate too much. Need to loosen my belt a few notches.','',26124),
(348,'enUS','Thanks for the great meal darlin\' but I need to get back out front.','',26124),
(349,'enUS','Another glorious day of fishin\' is ahead of me, Khara. I best get movin\'.','',26124),
(350,'enUS','What a day for fishin\'. They are sure to be bitin\' today!','',26124),
(352,'enUS','Warg looks over the water appraising what his luck might be today.','',26124),
(353,'enUS','Welp the fish ain\'t bitin\' no more so I might as start gutting and cleaning what I did catch today.','',26124),
(355,'enUS','Best be on my way. Khara will be expecting me soon. See ya tomorrow X.','',26124),
(356,'enUS','Look at all those ripples. Lots of activity in the water so I should catch a mess of fish today.','',26124),
(357,'enUS','Hmmmm, only a little bit of activity on the surface but the sun is in the right place. Might turn out to be a fine day.','',26124),
(358,'enUS','Not looking too good today. Sun is high and bright early and no activity on the water.','',26124),
(359,'enUS','Hmph! What a sorry day for fishin\' this is going to be. Ah well, a bad day fishin\' is better then a good day workin\'.','',26124),
(360,'enUS','Berte! Evalyn! It\'s getting dark. Come inside.','',26124),
(361,'enUS','You can play more tomorrow. Now come on inside.','',26124),
(362,'enUS','Alright, alright. You two can go play just stay in town. No sneaking off to bug Warg and Khara down by the water.','',26124),
(363,'enUS','Hah! Daryl, you should have seen the look on your face! You half jumped out of your skin!','',26124),
(365,'enUS','They have you good on that one, lad!','',26124),
(366,'enUS','Oh, shut up.','',26124),
(367,'enUS','Awww Mom! It\'s hardly dark yet! Can we play for a bit longer please?','',26124),
(368,'enUS','Ok...','',26124),
(370,'enUS','We must be vigilant to eradicate this plague!','',26124),
(371,'enUS','Keep up the good work.  This scourge will be cleansed!','',26124),
(372,'enUS','The Scarlet Crusade will scour these lands!','',26124),
(373,'enUS','Let none with the foul taint of plague live!','',26124),
(374,'enUS','Mom! Can we go play please please please? Can we huh? Can we?','',26124),
(375,'enUS','The kids jump up and down with youthful energy. (PH emote)','',26124),
(376,'enUS','Wheeee! Thanks Mom!','',26124),
(378,'enUS','Thanks Mrs. Brightbeard!','',26124),
(379,'enUS','Gettin\' a bit nippy out here. Think I will go warm myself by the fire and grab a pint or twelve.','',26124),
(380,'enUS','Nothing like a roaring fire on a cool night with good friends and dwarven ale.','',26124),
(381,'enUS','Brock. Torren. I am going inside for an ale and to warm myself by the fire.','',26124),
(382,'enUS','Mmmmm, an ale by the fire does sound good. Sure, I will join ya Jern.','',26124),
(383,'enUS','Here! Here! I\'ll drink to that!','',26124),
(384,'enUS','What? Did someone say ale? Don\'t start pouring the pints without ol\' Torren!','',26124),
(385,'enUS','I\'ll drink to anything!','',26124),
(386,'enUS','Noma should have dinner ready soon. Might as well head in.','',26124),
(387,'enUS','My, that Black Claw stout packs quite a punch!','',26124),
(388,'enUS','I feel... dizzy.  It\'s so hot... in... here...','',26124),
(389,'enUS','Where\'s the rest of the guys?','',26124),
(390,'enUS','Every bodies coming...','',26124),
(391,'enUS','He really couldn\'t help it...','',26124),
(393,'enUS','No one lives forever...','',26124),
(394,'enUS','','Gimlok!  Gimlok! Get in here this instant!',26124),
(395,'enUS','','Where has the boy gotten to now?',26124),
(396,'enUS','','Gimlok, don\'t you go and get your clothes all dirty.',26124),
(397,'enUS','Huuup...Huuup...Bleeeeehh!','',26124),
(398,'enUS','I\'ll be a guard someday!','',26124),
(399,'enUS','Remember when Danath gathered all the mercenaries of Stormwind together and we marched to fight at Nethergarde?','',26124),
(400,'enUS','I tell ye, I don\'t miss the Great War at all. I remember when we fought at Darrowmere. All night in the fog, lying in a muddy trench.','',26124),
(401,'enUS','I miss the dwarven ale we used to get at that inn in Lordaeron. Remember that fight we started there?','',26124),
(402,'enUS','Less than a hundred of us, and over a thousand orcs. Only a handful of us managed to walk away from that one.','',26124),
(403,'enUS','The best had to have been the look on Perenolde\'s face when our army comes marchin\' right up to his front door. What a battle!','',26124),
(405,'enUS','Battling that band of Twilight Hammer in the Morass, I could think of better places for a war.','',26124),
(406,'enUS','Ahh yes, now I remember, your wedding night wasn\'t it?','',26124),
(407,'enUS','Ahh the Glustewelt twins!','',26124),
(408,'enUS','I still have the scars from that night.','',26124),
(409,'enUS','Broke both me legs that night. How could I forget?','',26124),
(410,'enUS','I woke up in a bed in Northshire three weeks later. Don\'t remember a damn thing.','',26124),
(411,'enUS','Wasn\'t that the night we had to pick up my thumb and carry it in your smoke pouch?','',26124),
(413,'enUS','I have a piece of iron in my back that will remind me of that night for the rest of my days.','',26124),
(414,'enUS','Course I remember that night. Two inches to the left and you\'d be drinking with that elf, Morris. That was my best shirt, too.','',26124),
(415,'enUS','Was that the third or fourth time you nearly got me gutted trying one of your crazy stunts?','',26124),
(416,'enUS','Aye and thanks for letting me carry my own hand back to the priests that night.','',26124),
(417,'enUS','Hehe, wimp.','',26124),
(418,'enUS','You screamed like a little girl, funniest thing I ever saw.','',26124),
(419,'enUS','It all worked out in the end.','',26124),
(420,'enUS','Let\'s not even begin comparing battle scars, my friend.','',26124),
(421,'enUS','Never seen anyone move so fast in my whole life.','',26124),
(422,'enUS','You are constantly surprising me with what a person can live through.','',26124),
(423,'enUS','Well, you\'re still here. I\'d say that is something worth drinking to.','',26124),
(424,'enUS','You can thank me anytime for making your life more interesting.','',26124),
(425,'enUS','I... I... don\'t... feel... right...','',26124),
(426,'enUS','%s waves to $n','',26124),
(427,'enUS','You have disturbed my rest, $c.  Now face my wrath!','',26124),
(428,'enUS','My mind... my flesh... I\'m... rotting...!','',26124),
(429,'enUS','Let me have another one, Langston.','',26124),
(430,'enUS','Best ale in Stormwind, Langston. Thanks.','',26124),
(431,'enUS','Hey Reese, give me an\' Christoph another round.','',26124),
(432,'enUS','A warm tavern and a cold ale. What more could we ask for?','',26124),
(433,'enUS','%s raises the gun to his shoulder, aims it carefully then fires a shot at the target.','',26124),
(434,'enUS','Die in the name of Ragnaros!','',26124),
(435,'enUS','The Thandol Span fell to Ragnaros.  So shall the Stonewrought Dam!','',26124),
(436,'enUS','King Magni Bronzebeard is a fool and a charlatan!','',26124),
(437,'enUS','This $C intrudes on our work! Die fool!','',26124),
(438,'enUS','What have we here?  $n the $C?  Attack!','',26124),
(440,'enUS','All those who betray Ragnaros must die!','',26124),
(441,'enUS','Kill the filthy $R!','',26124),
(442,'enUS','The Stonewrought Dam will be destroyed!  Long live Ragnaros!','',26124),
(443,'enUS','Weak $C! You are no match for the Stonesplinter Tribe!','',26124),
(444,'enUS','A $C called $n? You\'ll make a fine breakfast!','',26124),
(445,'enUS','The Stonesplinter Tribe shall see to your doom!','',26124),
(446,'enUS','Die, $R!  These lands belong to the Stonesplinter Tribe!','',26124),
(447,'enUS','The only good $R is a dead $R!','',26124),
(448,'enUS','The Loch belongs to the Stonesplinter Tribe now, $n!  Now die!','',26124),
(449,'enUS','$n!  Betrayer of Ragnaros!','',26124),
(450,'enUS','The Dark Iron Dwarves shall reclaim their rightful lands!','',26124),
(451,'enUS','Foolish $C!  You are no match for the minions of Ragnaros!','',26124),
(452,'enUS','A worthless $R such as you, $n, has no right to walk these lands!','',26124),
(453,'enUS','$n!  Prepare to meet your doom!','',26124),
(454,'enUS','Who is this weak $C who challenges my might?  Die fool!','',26124),
(455,'enUS','This land belongs to the Dark Iron Dwarves.  Prepare to see the afterlife, $C!','',26124),
(456,'enUS','I am Balgaras the Foul.  And you, $n, are about to become nothing more than ash and dust.','',26124),
(457,'enUS','$n, may your death stand as an example to all who challenge the Defias Brotherhood!','',26124),
(458,'enUS','A mere $C challenges me?  Prepare for the afterlife!','',26124),
(459,'enUS','May the Deadmines serve as your tomb, $n!','',26124),
(460,'enUS','Die in the name of the Defias Brotherhood!','',26124),
(461,'enUS','Death to those who wronged the Stonemasons!','',26124),
(462,'enUS','The corruption of the House of Nobles runs through your veins.  Let me remove it with my blade!','',26124),
(463,'enUS','Die $n!  The only good $C is a dead $C.','',26124),
(464,'enUS','Who is this weak $R?  A foul intruder I say.  Die fool!','',26124),
(465,'enUS','Stupid $R!  The Blackrock Clan shall dance on your grave!','',26124),
(466,'enUS','Foolish $C!  You are no match for my might!','',26124),
(467,'enUS','I am Gath\'Ilzogg!  And you are a $R on the brink of death!','',26124),
(468,'enUS','Death to $n!  Long live the Blackrock Clan!','',26124),
(469,'enUS','Who dares intrude upon the Blackrock Clan?  Death to this $R!','',26124),
(470,'enUS','Tiny $C!  You are no match for the Blackrock Clan!','',26124),
(471,'enUS','Foolish $C!  I will snap the bones of this weak $R!','',26124),
(472,'enUS','Long live the mighty Blackrock Clan!','',26124),
(473,'enUS','Die in the name of Edwin Van Cleef!','',26124),
(474,'enUS','Who dares interfere with the business of the Defias Brotherhood?  Die $C!','',26124),
(475,'enUS','Death to any $R that stands in my way!','',26124),
(476,'enUS','Who dares to provoke the messenger of Edwin Van Cleef?  Die $R!','',26124),
(477,'enUS','Am I carrying any letters addressed to $n? Why, no!  Looks like it\'s time for you to die!','',26124),
(478,'enUS','I\'ll deliver you, weak $C, to the afterlife!','',26124),
(479,'enUS','I have a special message for $n.  And it says you must die!','',26124),
(480,'enUS','Here\'s a singing telegram for $n: Roses are red, violets are blue, I will kill any $R I see, including you!','',26124),
(481,'enUS','Let\'s get to the others, and keep an eye open for those wolves outside...','',26124),
(482,'enUS','Be careful, $n.  Those wolves like to hide among the trees.','',26124),
(483,'enUS','We\'re almost there!','',26124),
(484,'enUS','We made it!  Thanks, $n.  I couldn\'t have gotten here without you.','',26124),
(485,'enUS','Help!','',26124),
(486,'enUS','I\'ve been spotted!  $n incoming! Help!','',26124),
(487,'enUS','Die you worthless $n!','',26124),
(488,'enUS','Need a little help here.  That $n saw me.','',26124),
(489,'enUS','$n coming in fast!  Prepare to fight!','',26124),
(490,'enUS','That $n wants me dead!  Help!','',26124),
(491,'enUS','What was that?','',26124),
(492,'enUS','Did you hear something?','',26124),
(493,'enUS','I smell a $R.','',26124),
(494,'enUS','Help! We\'re being attacked! Dark Irons!','',26124),
(496,'enUS','$n coming this way fast!  Prepare for attack!','',26124),
(497,'enUS','We are under siege!  To arms!  Kill this $n!','',26124),
(498,'enUS','Ah, here at last! It\'s going to feel so good to get rid of these barrels.','',26124),
(499,'enUS','%s roars a challenge!','',26124),
(500,'enUS','','I shall return in time..',26124),
(502,'enUS','The Sons of Arugal will rise against all who challenge the power of the Moonrage!','',26124),
(503,'enUS','Let the legend of Stalvan rest!','Let the legend of Stalvan rest!',26124),
(504,'enUS','Who is this mere $r that meddles with that which is past?  May the legend of Stalvan die along with you!','Who is this mere $r that meddles with that which is past?  May the legend of Stalvan die along with you!',26124),
(505,'enUS','Toil not in matters of the past, $n!','Toil not in matters of the past, $n!',26124),
(506,'enUS','','%s lets out a high pitched screech, calling for help.',26124),
(507,'enUS','Tilloa is that you?  Why no!  It\'s just some dirty $r!','',26124),
(508,'enUS','Who dares disturb me?  Die $n!','',26124),
(509,'enUS','I shall spill your blood, $C!','',26124),
(510,'enUS','Help! I\'ve only one hand to defend myself with.','',26124),
(511,'enUS','Send them on! I\'m not afraid of some scrawny beasts!','',26124),
(512,'enUS','Get him!','',26124),
(513,'enUS','%s chants words of power...','',26124),
(514,'enUS','No!  It can\'t be...','',26124),
(515,'enUS','Incredible!  I know he who wrought these enchantments...','',26124),
(516,'enUS','This is unforseen.  The being who enchanted this is known to me...','',26124),
(517,'enUS','$n, I have the information you seek...','',26124),
(518,'enUS','My minions...','',26124),
(519,'enUS','The time for conquest approaches quickly.','',26124),
(520,'enUS','Soon, your thirst for destruction will be quenched.','',26124),
(521,'enUS','The rage burning within you will soon find fuel in our enemies.','',26124),
(522,'enUS','I come with news of our conflict with the Rogue Undead.','',26124),
(523,'enUS','The rebels of Lordaeron are small and weak, and know not the joy of serving our Lich King.','',26124),
(525,'enUS','The Dark Lady\'s followers are blind to think they can stand against our might.','',26124),
(526,'enUS','We grow strong, while our foes are surrounded by foes, and weakened by constant attacks.','',26124),
(527,'enUS','Our Lord commands us to make ready for war!','',26124),
(528,'enUS','Prepare yourselves, for we will soon launch an assault against they who called themselves \"The Forsaken.\"','',26124),
(529,'enUS','Make ready for battle, my creations.','',26124),
(530,'enUS','We are the arm of His will.  And we will crush His foes into grave dust!','',26124),
(531,'enUS','These undead rabble, and their dead-elf queen, will fall!','',26124),
(532,'enUS','We will drive our foes from Silverpine, then bring the tides of war to their very capital!','',26124),
(533,'enUS','Death and Praise for the Lich King!','',26124),
(534,'enUS','','It\'s good to see you again, Erland.  What is your report?',26124),
(535,'enUS','Masses of wolves are to the east, and whoever lived at Malden\'s Orchard is gone.','',26124),
(536,'enUS','If I am excused, then I\'d like to check on Quinn...','',26124),
(537,'enUS','Hello, Quinn.  How are you faring?','',26124),
(538,'enUS','Try to take better care of yourself, Quinn.  You were lucky this time.','',26124),
(539,'enUS','I\'ve been better.  Ivar the Foul got the better of me...','',26124),
(540,'enUS','No two-bit traitor will stop the powder from getting to Ironband!','',26124),
(541,'enUS','Beware!  A $n is upon us!','',26124),
(542,'enUS','','Be ready, $n. I hear the council returning. Prepare to ambush!',26124),
(543,'enUS','A $n attacks!','',26124),
(544,'enUS','Beware!  I am under attack!','',26124),
(545,'enUS','','Well done. A blow to Arugal no doubt!',26124),
(546,'enUS','The Stonewrought Dam has been saved!  Three cheers for $n!','',26124),
(548,'enUS','','All is lost!',26124),
(549,'enUS','Make Way!  Make Way!','',26124),
(551,'enUS','%s leaps from the first catapult to the second!','',26124),
(552,'enUS','I\'m cursed!  First my ship sinks, and now...I\'m out of mead!','',26124),
(553,'enUS','Curse you, Halyndor!  You led us to our doom!','',26124),
(554,'enUS','Don\'t mind me, or my smell...because I sure don\'t!','',26124),
(556,'enUS','Ah, beautiful Menethil Harbor, with the best mead this side of Ironforge.','',26124),
(557,'enUS','Oh, my brothers!  May you find rest in your watery graves!','',26124),
(558,'enUS','%s looks like he\'s going to be sick!','',26124),
(559,'enUS','%s swaggers heavily.','',26124),
(560,'enUS','%s mumbles incoherent words.','',26124),
(561,'enUS','%s raises his mug to his eye, and frowns.','',26124),
(562,'enUS','%s growls and looks around him aggressively','',26124),
(563,'enUS','%s begins translating ...','',26124),
(564,'enUS','$n, the translation is finished!','',26124),
(566,'enUS','This is a dangerous line of business!$B$BMiran just left with a delivery. He should be back in a few minutes.','',26124),
(567,'enUS','They thought I was weak.  Haha!!','',26124),
(568,'enUS','I am the head of the family.  Me.  ME!!!','',26124),
(569,'enUS','I\'m cold, lord.  When will you keep your promise?','',26124),
(570,'enUS','My family hates me.  Frightened idiots, all of them!','',26124),
(571,'enUS','Father?  Are you proud of me now? HAHAH!','',26124),
(572,'enUS','Mother, oh mother.  You should have listened to me...','',26124),
(573,'enUS','Thurman my brother, who\'s laughing now?  Hah!','',26124),
(574,'enUS','Here to visit the family?  Die, fool!','',26124),
(575,'enUS','The Agamand Mills is held by the Scourge, $C.  Join us!','',26124),
(576,'enUS','I raise my brew and hope to be rid of the likes of you!  Cheers, you no good scoundrel, $n!','',26124),
(577,'enUS','%s cheers!','',26124),
(578,'enUS','','Stay back vile creatures!',26124),
(579,'enUS','Croak!','',26124),
(580,'enUS','%s sniffs the elixir then eagerly digs in!','',26124),
(581,'enUS','Finally they show mercy!  They\'ve given us something to drink!','',26124),
(582,'enUS','And Shindigger Stout too!  Thank the Light!  I was parched!','',26124),
(583,'enUS','Your undeath is not the end of your life, but the beginning. It is up to you to decide where your fate lies now.','',26124),
(584,'enUS','You are free of His control. And while you will be judged by lesser beings, at least you have chances that the Scourge do not!','',26124),
(585,'enUS','Terror, darkness, power? The Forsaken crave not these things; the Forsaken ARE these things.','',26124),
(586,'enUS','My bones are weak, my eyes see only darkness, and my body feels only pain; but these things are good because my will is my own.','',26124),
(587,'enUS','','Hello, Charys. I have my list, could you get me all of that, especially the last ingredient.',26124),
(588,'enUS','','Mommy? Can I pet Fizzles?',26124),
(589,'enUS','','Sure, Paige. Just be gentle.',26124),
(590,'enUS','','Thanks, Charys. C\'mon Paige, sweetie.',26124),
(591,'enUS','%s starts to chant in an ancient tongue, summoning forth something evil in nature.','',26124),
(592,'enUS','Ah, it is good to be free of my bonds! Have you freed Tog\'thar yet? The humans split us up after our capture.','',26124),
(593,'enUS','Have you freed Drull yet? I don\'t know where he\'s being held.','',26124),
(594,'enUS','Go on ahead without me! I will make my own way to Tarren Mill.','',26124),
(595,'enUS','I will only slow you down, but no pink-skinned humans will keep me from freedom!','',26124),
(596,'enUS','Search this rubble.','',26124),
(597,'enUS','Find me something good, you dogs!','',26124),
(598,'enUS','Over here! Inside the room. Did you find the key to my chains? The human Borhuin has them.','',26124),
(599,'enUS','I returned from the grave to take my revenge!','',26124),
(600,'enUS','Die in the name of the Dark Lady, $n.','',26124),
(601,'enUS','The undead shall feast on your soul, $n.','',26124),
(602,'enUS','I have risen!','',26124),
(603,'enUS','Revenge shall be mine at last!','',26124),
(604,'enUS','Southshore shall pay in blood!','',26124),
(605,'enUS','Mmm... I love my delicious Southshore stout.','',26124),
(606,'enUS','Southshore stout, how do I love thee? Let me count the ways...','',26124),
(608,'enUS','Protect Foreman Bonds at all costs!','',26124),
(609,'enUS','Guards! Guards!','',26124),
(610,'enUS','You\'re going to pay for this outrage! Guards!','',26124),
(611,'enUS','Get to your posts! Let no invader reach Southshore!','',26124),
(612,'enUS','Anyone suspicious is to be taken down quickly. Get to your posts as quickly as possible!','',26124),
(613,'enUS','Protect the Magistrate at all costs. They could come from any direction!','',26124),
(614,'enUS','My trees.... they have withered up and died just like me.','',26124),
(615,'enUS','This orchard is now as barren and lifeless as my rotting shell. Once these trees bloomed with fruit but now there is only rot.','',26124),
(616,'enUS','I spent my whole life caring for these trees. Pruning and nurturing them... only fitting that they have joined me in death.','',26124),
(617,'enUS','','',26124),
(618,'enUS','Greetings Citizens!  Soon perhaps the tide will turn in our favor and the plague will end.','',26124),
(619,'enUS','Help me! Help! Assassins in the hills! To arms! To arms!','',26124),
(620,'enUS','Hear ye! Hear ye! *pant pant* Be warned citizens of Southshore: assassins are heading to our fair town!','',26124),
(621,'enUS','Guards to your posts! They must be after the Magistrate again. He must be protected! They could come from any direction!','',26124),
(622,'enUS','I\'m so tired *pant pant*','',26124),
(623,'enUS','The Southshore Crier grabs the back of his neck and his eyes go wide.','',26124),
(626,'enUS','Assassins... save... th... Magistraaa...','',26124),
(627,'enUS','They\'re here! They\'re over here! Help me!','',26124),
(628,'enUS','The assassins are over here! Quickly, before they reach the Magistrate!','',26124),
(629,'enUS','More agents of the Syndicate I\'ll wager! You\'ll never take back Alterac... or Southshore!','',26124),
(630,'enUS','The deed is done! The Magistrate is dead-- to the shadows, my brethren.','',26124),
(631,'enUS','The Magistrate has fallen! Make your escape, my brothers.','',26124),
(632,'enUS','Haha! Alterac and Hillsbrad shall come under our rightful rule once again now that the Magistrate has fallen. Retreat!','',26124),
(633,'enUS','The meddlers shall pay for their interference. Retreat to the shadows!','',26124),
(634,'enUS','The Magistrate is too well protected. Retreat!','',26124),
(635,'enUS','You may have succeeded in stopping us this time, but we shall return-- this we assure you!','',26124),
(636,'enUS','','%s takes out a bottle filled with some kind of green liquid and takes a large gulp.',26124),
(637,'enUS','%s\'s eyes glow red as he lights his dynamite and begins to cackle madly!','',26124),
(638,'enUS','Wahehe! I\'m taking you down with me!','',26124),
(639,'enUS','All right, you lazy bums, time to get up and get started. That bridge isn\'t getting built on its own.','',26124),
(640,'enUS','Ya\'ll get a few minutes to wake up, but let\'s get started soon.','',26124),
(641,'enUS','Hi Ho, Hi Ho, and all that... let\'s get a move on.','',26124),
(642,'enUS','Take a break, men! Half hour and then back to work.','',26124),
(643,'enUS','The bridge is looking great. We keep up this pace and it\'ll be done for the first expansion forces to head north.','',26124),
(645,'enUS','Okay, lunch time\'s over, guys. Let\'s get back to work. If the rest of the day goes this well, then maybe we\'ll cut out early.','',26124),
(646,'enUS','Good, good. Keep it up and this bridge\'ll be done in no time.','',26124),
(647,'enUS','Call it a day, men!','',26124),
(648,'enUS','Day\'s wasting. Let\'s get going.','',26124),
(649,'enUS','Good night, gents. Sleep well.','',26124),
(650,'enUS','Morning, my friends.','',26124),
(651,'enUS','Ahh... food It\'s \'bout time.','',26124),
(652,'enUS','Tis a good day to live, neh? Hard work and good food-- there are worse things we could be doing on such a beautiful day.','',26124),
(654,'enUS','*Dimitri wipes sweat from his forehead and lays down his tools*','',26124),
(655,'enUS','Another good day indeed.','',26124),
(656,'enUS','Good night, my friends. Until tomorrow.','',26124),
(657,'enUS','Can\'t we just sleep a while longer?','',26124),
(658,'enUS','Okay, okay... I\'m up.','',26124),
(659,'enUS','\'Bout time. I was hungry an hour ago.','',26124),
(660,'enUS','Finally! I can\'t wait to get some sleep tonight.','',26124),
(661,'enUS','Ugh! Being on your feet all day is no way to make a living. I should have been a tailor.','',26124),
(662,'enUS','I love mornings! It\'s a great day, isn\'t it? Smell that air?','',26124),
(664,'enUS','By the Light, I\'m hungry today. Did you all see Darcy today? She looked great.','',26124),
(665,'enUS','You know, this bridge is kind of large for just the 6 of us to be building. You\'d think more people would\'ve been hired.','',26124),
(666,'enUS','You guys see her? I didn\'t see Darcy. I wonder where she is tonight.','',26124),
(667,'enUS','%s looks up and down the docks.','',26124),
(669,'enUS','Oh well, I\'m sure she\'ll be around later.','',26124),
(670,'enUS','Night, all. I\'m gonna sit up for a bit. Maybe Darcy\'ll come by.','',26124),
(671,'enUS','Huh?! Darn it, it\'s lunch time! I overslept!','',26124),
(672,'enUS','%s runs up to the other bridge workers, panting.','',26124),
(674,'enUS','Sorry, ah\'m late.','',26124),
(675,'enUS','This bridge isn\'t ever going to be finished, is it?','',26124),
(676,'enUS','My back is killing me today.','',26124),
(677,'enUS','Little food\'ll feel pretty good right about now.','',26124),
(678,'enUS','Mmm, good stuff. Back to work once again.','',26124),
(679,'enUS','Another day gone by...','',26124),
(680,'enUS','Night, night.','',26124),
(681,'enUS','%s is struck dumb by the Soul Gem!','',26124),
(682,'enUS','%s\'s spirit is freed...','',26124),
(683,'enUS','%s lets out a deep sigh.','',26124),
(684,'enUS','I hate this part of my job. Oh Duskwood, be gentle with poor Antonio.','',26124),
(685,'enUS','Items of antiquity, weapons of war, armor or rarity. Who knows what Antonio will be carrying this week if you do not come look.','',26124),
(686,'enUS','This week it could be eye of newt, or perhaps a treasure map. You\'ll never know unless you look. What could Antonio have?','',26124),
(687,'enUS','Adventurers from all over sell things to Antonio-- come look for yourselves what little treasures he has for you this week.','',26124),
(688,'enUS','Travelers and adventurers make haste to the town circle and take advantage of Antonio\'s wonderful prices! Come one, come all!','',26124),
(689,'enUS','Well met, travelers of Duskwood! My incredible wares are on sale for a short time in Darkshire. Make haste!','',26124),
(690,'enUS','Leave your battles or errands, and browse my incredible wares! Only in Darkshire for a short time... praise the Light for that.','',26124),
(691,'enUS','Farewell, citizens of Darkshire. Until next time...','',26124),
(692,'enUS','Finally, Redridge. A pleasant change from the dark, cold fog of Duskwood.','',26124),
(693,'enUS','Ha ha! I have Betsy!','',26124),
(694,'enUS','','Gimme my dolly!!',26124),
(695,'enUS','','Betsy! Give me Betsy back!',26124),
(696,'enUS','','Don\'t hurt Betsy, you meanie!',26124),
(697,'enUS','','WAAAHHH!!!',26124),
(698,'enUS','','I\'m telling Mommy!',26124),
(699,'enUS','','Stop pulling her hair out!',26124),
(700,'enUS','','You\'re hurting her!',26124),
(701,'enUS','','Stop! You\'ll pull her head off!',26124),
(702,'enUS','Hello, hello, Amy. It\'s good to be back in Lakeshire and to see you, milady.','',26124),
(703,'enUS','','Hello, Antonio. It\'s good to see you safely made it here again. Let me know if you need anything.',26124),
(704,'enUS','Hear ye, hear ye! I\'ll pause to sell my wares for only a short time here in Lakeshire. Come to the town hall with haste!','',26124),
(705,'enUS','I wonder if your dolly can swim!','',26124),
(706,'enUS','I have your dolly! Nyah nyah!','',26124),
(707,'enUS','What happens when I do this?!','',26124),
(708,'enUS','If you want her back you\'re gonna have to beg!','',26124),
(709,'enUS','Crybaby! Crybaby!','',26124),
(710,'enUS','Baby wants her dolly!','',26124),
(711,'enUS','Oops!','',26124),
(712,'enUS','I\'ve finally reached Lakeshire-- come one, come all, and take advantage of Antonio Perelli\'s wonderful deals.','',26124),
(713,'enUS','Items powerful enough to help make the journey through Duskwood, Antonio Perelli\'s goods are now for sale here in Lakeshire.','',26124),
(714,'enUS','Good to see you again, Amy. Be safe, luv. I\'m off to Goldshire now.','',26124),
(715,'enUS','','Take care of yourself, Antonio. I\'ll see you in another week.',26124),
(716,'enUS','Hello, my friends. It is good to see you again. Still keeping our borders free I see. Antonio appreciates your hard work.','',26124),
(717,'enUS','You\'re very welcome! I must be on my way... be safe, all of you.','',26124),
(718,'enUS','Hello again, Antonio. Thank you again for the hat for my wife. She adored it.','Hello again, Antonio. Thank you again for the hat for my wife. She adored it.',26124),
(719,'enUS','Be safe, Antonio.','Be safe, Antonio.',26124),
(720,'enUS','Oh, I will, my friend. I will indeed. You, too, be safe.','',26124),
(721,'enUS','Wares for sale! Wares for sale! Come browse Antonio\'s wares before I must take my leave, citizens of Goldshire.','',26124),
(722,'enUS','Come one, come all! Antonio\'s wares are for sale. I may not return for a great deal of time, so come one, come all.','',26124),
(723,'enUS','Good people of Goldshire, come take advantage of my incredible prices on rare goods. I shall not return for some time!','',26124),
(724,'enUS','Good bye, Goldshire. I\'ll be back soon enough-- perhaps a week\'s time.','',26124),
(725,'enUS','Home again, home again.','',26124),
(726,'enUS','Known throughout the lands, Antonio Perelli\'s goods now for sale near Sentinel Hill! I must move on soon, so make haste.','',26124),
(727,'enUS','Long-lasting, well-crafted items for sale near the Hill! Come one, come all! Time is short, so make haste.','',26124),
(728,'enUS','The time has come for me to once again make my wares available to all who travel near Sentinel Hill! Come one, come all!','',26124),
(729,'enUS','Thank you, all. I shall return again in about a week.','',26124),
(730,'enUS','Off to Darkshire then, I suppose.','',26124),
(731,'enUS','Mmmh...I SMELL FOOD!','',26124),
(732,'enUS','%s searches through the skulls...','',26124),
(733,'enUS','%s continues searching, placing more skulls in his crate.','',26124),
(734,'enUS','I am done inspecting the skulls, $n, and I am relieved.  Yenniku is not among them...','',26124),
(735,'enUS','Ah, good $n.  Now let us see what tale these heads tell...','',26124),
(736,'enUS','%s begins chanting...','',26124),
(737,'enUS','Where in the Outlands are those shipments? For days they keep me waiting!','',26124),
(738,'enUS','Stupidity! I\'m surrounded by stupidity!','',26124),
(739,'enUS','Orcs are smarter than those couriers! Where the blazes are they?','',26124),
(740,'enUS','There, $n.  You may now speak to the Bloodscalp chief and his witchdoctor.','',26124),
(741,'enUS','%s begins to summon in reinforcements!','%s begins to summon in reinforcements!',26124),
(742,'enUS','%s presents the Mind\'s Eye and the Singing Crystals before him...','',26124),
(743,'enUS','I have fashioned Yenniku\'s Soul Gem, $n...','',26124),
(744,'enUS','%s tries opening Maury\'s Clubbed Foot...','',26124),
(745,'enUS','Aha!  It opened!  I expected that to be harder.  Thanks for your help, $n!','',26124),
(746,'enUS','Alright I\'m going! Stop yelling!','',26124),
(747,'enUS','This better be the last one!','',26124),
(749,'enUS','You better back me up on this one!','',26124),
(750,'enUS','Why did I have to get stuck with this repulsive, feeble excuse for a warlock?','',26124),
(751,'enUS','Make yourself useful and help me out here!','',26124),
(752,'enUS','Just release me already! I\'ve had enough!','',26124),
(753,'enUS','What? You mean you can\'t kill this one by yourself?','',26124),
(754,'enUS','If you touch me again it\'ll be the last thing you touch!','',26124),
(757,'enUS','%s begins to crack and break apart.','',26124),
(758,'enUS','%s\'s strength dwindles as chunks of rock break off.','',26124),
(759,'enUS','%s is reduced to rubble, but still continues to fight.','',26124),
(761,'enUS','How interesting... the Stone possesses great magical potential, but in a purely raw form...','',26124),
(763,'enUS','AH, A FEAST!  WHO LEFT THIS HERE...?','',26124),
(764,'enUS','SMOTTS!  HEY, SMOTTS!!  COME OUT AND PLAY!','',26124),
(765,'enUS','','Thank you again for your aid. May the wind always be at your back during your travels.',26124),
(766,'enUS','You have completed the quest!','',26124),
(767,'enUS','Here come the beasts!','',26124),
(768,'enUS','You have failed to protect me from the apes!','',26124),
(769,'enUS','What is happening? What force draws me to the Altar of the Tides!','',26124),
(770,'enUS','More beasts on the way!','',26124),
(771,'enUS','Dirty beasts! Here they come!','',26124),
(772,'enUS','YOU WERE SUCH GOOD SPORT THE LAST TIME...COME OUT!','',26124),
(773,'enUS','SMOTTS!','',26124),
(774,'enUS','I PROMISE I WON\'T KILL YOUR CREW THIS TIME.  HAH!  BUT MY BROTHER MIGHT EAT THEM!','',26124),
(775,'enUS','COME OUT TO JANEIRO\'S POINT.  I\'M WAITING FOR YOU, SMOTTS...','',26124),
(776,'enUS','DON\'T YOU WANT TO FIGHT, SMOTTS!?','',26124),
(777,'enUS','HAVE YOU RUN OUT OF SHIPS TO SEND?  WHERE\'S YOUR COURAGE?','',26124),
(778,'enUS','DON\'T LET THIS STATUE BE MY ONLY COMPANY.  COME OUT AND PLAY!','',26124),
(779,'enUS','%s tosses down his bottle of poison in desperation!','',26124),
(780,'enUS','%s takes out a remote control and tosses down a model siege engine!','',26124),
(781,'enUS','%s begins to glow and smoke!','',26124),
(782,'enUS','Still no sign of the final shipment of explosives.','',26124),
(783,'enUS','No sign of the final explosives shipment to the west either.  Where are those lollygaggers?','',26124),
(784,'enUS','This bridge should have been destroyed by now.  How long does it take for those lazy sods to get here from the Highlands!','',26124),
(785,'enUS','Help me! Help me! Don\'t let them eat me!','',26124),
(786,'enUS','Please save me!','',26124),
(787,'enUS','I don\'t want to be a meal for an ogre! Please save me!','',26124),
(788,'enUS','Heeeeeeeeeeeeellllllllllllllllllllllllp!!!','',26124),
(789,'enUS','I tire of this nonsense! Prepare to die!','I tire of this nonsense! Prepare to die!',26124),
(790,'enUS','Sure does seem like it\'s been a long time since anyone has relieved me from my post.','',26124),
(791,'enUS','Well, that\'s what I get for oversleeping!','',26124),
(792,'enUS','','%s reads Sully\'s letter page by page.',26124),
(793,'enUS','','This isn\'t fair!  My dearest Sully!  Come back to me!  No, $n!  Why did you bring me such news!',26124),
(794,'enUS','Hiccup!','',26124),
(795,'enUS','These shards give me the creeps.  Hey Greeby, did you find more motes?','',26124),
(796,'enUS','I wouldn\'t tell you if I did!  Because as soon as I do, I\'m getting away from these crystals...','',26124),
(797,'enUS','Yeah, I don\'t want to be here if Myzrael wakes up.  They say she has a mean temper...','',26124),
(798,'enUS','Easier than I expected... the sigil of Thoradin is whole, once again.','',26124),
(799,'enUS','May I bask in your shadow forever!','',26124),
(800,'enUS','Master, your wisdom is matched only by your hugeness!','',26124),
(801,'enUS','If I had a copper for each of your great deeds, I\'d be a rich kobold!','',26124),
(802,'enUS','You will keep us safe from the evil mistress, yes!','',26124),
(803,'enUS','Oh, praise!  Your vigilance keeps Myzrael deep in the earth!','',26124),
(804,'enUS','My only wish is to serve you, great one, until I die by your foot!','',26124),
(805,'enUS','Your strength is of the mountain.  Your grace is of the winds!','',26124),
(806,'enUS','My feet hurt...','',26124),
(807,'enUS','Die!  You will not free Myzrael!','',26124),
(808,'enUS','The Great One will smash you!','',26124),
(809,'enUS','Aren\'t you a little short for your kind?','',26124),
(810,'enUS','My life means nothing!  Our sacred task is all!','',26124),
(811,'enUS','If you mean to free Myzrael, you will be sorry!','',26124),
(812,'enUS','Stand firm, brothers.  And don\'t worry!  Size is on our side!','',26124),
(814,'enUS','Take that!  The Drywhiskers will prevail!','',26124),
(815,'enUS','No!  Leave us!  We must not fail our task!','',26124),
(816,'enUS','','Well then, let\'s get this started. The longer we\'re here, the more damage the undead could be doing back in Hillsbrad.',26124),
(817,'enUS','','Alright, this is where we really have to be on our paws. Be ready!',26124),
(818,'enUS','','Watch my rear! I\'ll see what I can find in all this junk...',26124),
(819,'enUS','','%s begins rummaging through the apothecary\'s belongings.',26124),
(820,'enUS','','Found something... I think.',26124),
(821,'enUS','','I bet Quae\'ll think this is important. She\'s pretty knowledgeable about these things--no expert, but knowledgeable.',26124),
(822,'enUS','','Okay, let\'s get out of here quick quick! Try and keep up. I\'m going to make a break for it.',26124),
(823,'enUS','You made it?! I\'m surprised Kinelory didn\'t slow you down anymore than that. Kin, here\'s your socks. Give me what you found ins','',26124),
(824,'enUS','%s studies the circle of stones, looking for signs of stress.','',26124),
(825,'enUS','You will never defeat us!','You will never defeat us!',26124),
(826,'enUS','My death matters little... the Hammer will still fall!','My death matters little... the Hammer will still fall!',26124),
(827,'enUS','My life for my masters.  Rejoice!','My life for my masters.  Rejoice!',26124),
(828,'enUS','Curse you!','Curse you!',26124),
(829,'enUS','Glory and blood for the Old Gods!','Glory and blood for the Old Gods!',26124),
(830,'enUS','My lords!  I come to thee!','My lords!  I come to thee!',26124),
(831,'enUS','Your victory here only speeds your doom!','Your victory here only speeds your doom!',26124),
(832,'enUS','Mommy!','Mommy!',26124),
(833,'enUS','Intruders!  Slay them!','Intruders!  Slay them!',26124),
(834,'enUS','For our Masters!','For our Masters!',26124),
(835,'enUS','Masters, I pledge this $r to you!','Masters, I pledge this $r to you!',26124),
(836,'enUS','Carnage!  May I spill blood in His name!','Carnage!  May I spill blood in His name!',26124),
(837,'enUS','Embrace the end!','Embrace the end!',26124),
(838,'enUS','Battle!  I can smell your fear, $c!','Battle!  I can smell your fear, $c!',26124),
(839,'enUS','Death comes!  Rejoice!','Death comes!  Rejoice!',26124),
(840,'enUS','Intruders!  Good, I was getting bored...','Intruders!  Good, I was getting bored...',26124),
(841,'enUS','Stop!  Foolish $c, we cannot let you summon the creature Myzrael!','',26124),
(842,'enUS','','What?  $n, you served me well, but...',26124),
(843,'enUS','','Why have you summoned me so soon?  I haven\'t yet reached my full power!',26124),
(844,'enUS','','No matter.  You were a fool to help me, and now you will pay!',26124),
(845,'enUS','Ok, $n. Follow me to the cave where I\'ll attempt to harness the power of the rune stone into these goggles.','',26124),
(846,'enUS','I discovered this cave on our first day here.  I believe the energy in the stone can be used to our advantage.','',26124),
(847,'enUS','I\'ll begin drawing energy from the stone.  Your job, $n, is to defend me. This place is cursed...trust me.','',26124),
(848,'enUS','%s begins tinkering with the goggles before the stone.','',26124),
(849,'enUS','Almost done! Just a little longer!','',26124),
(850,'enUS','I\'ve done it! I have harnessed the power of the stone into the goggles! Let\'s get out of here!','',26124),
(851,'enUS','Phew! Glad to be back from that creepy cave.','',26124),
(852,'enUS','Bah! Failed again!','',26124),
(853,'enUS','%s is ripped apart as it is banished from this world.','',26124),
(854,'enUS','You\'ve plundered our treasures too long.  Prepare to meet your watery grave!','',26124),
(855,'enUS','Nothing will stop us!  You will die!','',26124),
(856,'enUS','%s frantically whispers something to Shake\'s O\'Breen.','',26124),
(857,'enUS','Wait, $n!!! It looks like we\'re going to need some help here...','',26124),
(858,'enUS','Help!! I told you this place was cursed!','',26124),
(859,'enUS','Help!!! Get these things off me so I can get my work done!','',26124),
(860,'enUS','%s carefully studies Sara Balloo\'s note and lets out a long, solemn sigh.','',26124),
(861,'enUS','What is this power that flows through me? Is this the power of shamanism that Tor\'gan spoke of...?','',26124),
(862,'enUS','Amazing! I feel... renewed. My strength returns!','',26124),
(863,'enUS','If we can just hold them now, I am sure we will be in the clear.','',26124),
(864,'enUS','Here we go...','',26124),
(865,'enUS','I\'ll go secure below.','',26124),
(866,'enUS','Captain is dead.','',26124),
(867,'enUS','We survived!','',26124),
(868,'enUS','%s winks at $n knowingly.','',26124),
(869,'enUS','%s nods his head at $n, and sighs thoughtfully.','',26124),
(870,'enUS','%s begins searching through his pack...','',26124),
(871,'enUS','Ah!  There is my ratchet!  Now let\'s re-attach these scroll fragments.','',26124),
(872,'enUS','There we are, $n.  The Scroll is fixed!  Hooray!','',26124),
(873,'enUS','','%s begins to search through the badges of fallen Stromgarde defenders...',26124),
(874,'enUS','','Privates Marcus, Tremane, Osgood, Lampret...',26124),
(875,'enUS','','Privates Fontane, MacDugal, Wilcott...',26124),
(876,'enUS','','Privates Theoric, Kitrin, Blythe, Agmond...',26124),
(877,'enUS','','Privates Horus, Tilling, Rockwell...',26124),
(878,'enUS','','...Sampson, Yorick, Chamley...',26124),
(879,'enUS','','Clemens, Bartholemew, Enderman, Wyles...',26124),
(880,'enUS','','Tormil, Gamlor, Shefferd, Cowry...',26124),
(881,'enUS','','Martens, Reblock, Adinay, Nikeson...',26124),
(882,'enUS','','%s sighs...',26124),
(883,'enUS','','So many lost.  And so many more we must lose before this battle ends.',26124),
(884,'enUS','','Thank you for these badges, $n.  I will send news to the families of the deceased.',26124),
(885,'enUS','%s concocts a potion for $n.','',26124),
(886,'enUS','Ribbit! No!! This cannot...ribbit...be! You have duped me with...ribbit...your foul trickery! Ribbit!','',26124),
(887,'enUS','%s cooks up a batch of spicy hot buzzard wings for $n.','',26124),
(888,'enUS','The nightmare of Ursal is over! We are free!','',26124),
(889,'enUS','%s hands the glowing goggles over to Doctor Draxlegauge.','',26124),
(890,'enUS','Doctor Draxlegauge will give you further instructions, $n. Many thanks for your help!','',26124),
(891,'enUS','','%s hands her pack to Quae.',26124),
(892,'enUS','','We made it! Quae, we made it!',26124),
(893,'enUS','Gee, fish sure don\'t seem to be biting here. Maybe I should go over to Crystal Lake to try my luck there!','',26124),
(894,'enUS','Dang! Fish aren\'t biting here either. I am gonna go back to my ol\' fishin\' hole!','',26124),
(895,'enUS','You will never stop the Forsaken, $r. The Dark Lady shall make you suffer.','',26124),
(896,'enUS','You have my word that I shall find a use for your body after I\'ve killed you, $r.','',26124),
(897,'enUS','','Attack me if you will, but you won\'t stop me from getting back to Quae.',26124),
(898,'enUS','I am well versed in over 4 languages.','',26124),
(899,'enUS','Brzt... click... whir...','',26124),
(900,'enUS','Master, where have all the trees gone?','',26124),
(901,'enUS','We can make it better, stronger, faster. We have the technology. We have the magic.','',26124),
(902,'enUS','One day I\'ll be a real boy.','',26124),
(903,'enUS','It can get really hot here in the Badlands. But at least it\'s a dry heat.','',26124),
(904,'enUS','Gizmos... check. Doothingies... check. Wizzers... check.','',26124),
(905,'enUS','It is dangerous here, master. But I shall help stand guard.','',26124),
(906,'enUS','%s starts flapping its wings and sqwaking loudly.  You have a feeling that you are about to be its next meal!','',26124),
(907,'enUS','%s seems much calmer now that it has eaten the remains of $n.','',26124),
(908,'enUS','','The forest spirits are uneasy...',26124),
(909,'enUS','','The Blackwood tribe is disrupting our sacred lands.',26124),
(910,'enUS','','Something needs to be done about the Blackwood tribe.',26124),
(911,'enUS','','A corruption taints our sacred forest.',26124),
(912,'enUS','','The Blackwood tribe must not be permitted to interfere with the progress of nature.',26124),
(913,'enUS','','I sense danger deep within the grove...',26124),
(914,'enUS','%s reads the ancient text $n fetched for him...','',26124),
(915,'enUS','Aha!  That\'s it!','',26124),
(916,'enUS','Karnik, me friend, I wish I could see you with me own eyes again, but we need\'ta talk of Ragnaros. His influence is spreading.','',26124),
(917,'enUS','Hammertoe, you\'re as smart as you were stubborn in life and even in death. What can you tell me, ole friend?','',26124),
(918,'enUS','I\'ll tell you more, Karnik, in time. But first, send this traveler\'ta Belgrum--there\'s more business\'ta attend to.','',26124),
(919,'enUS','%s stows the items $n gave him.','',26124),
(920,'enUS','I thank you, $n.  My associates who will do great things with these...','',26124),
(921,'enUS','%s accepts the relics from $n.','',26124),
(922,'enUS','Accept my thanks, $n.  Yagyin\'s journal shall be yours.','',26124),
(923,'enUS','%s hunkers down to read Yagyin\'s Digest...','',26124),
(924,'enUS','%s is struck by unleashed magic!','',26124),
(925,'enUS','Ok, $n, let\'s go find where I left that mysterious fossil. Follow me!','',26124),
(926,'enUS','Now where did I put that mysterious fossil? Ah, maybe up there...','',26124),
(927,'enUS','Hrm, nothing up here.','',26124),
(928,'enUS','No mysterious fossil here... Ah, but my copy of Green Hills of Stranglethorn.  What a good book!','',26124),
(929,'enUS','I bet you I left it in the tent!','',26124),
(930,'enUS','Oh wait, that\'s Hollee\'s tent... and it\'s empty.','',26124),
(931,'enUS','Interesting... I hadn\'t noticed this earlier...','',26124),
(932,'enUS','%s inspects the ancient, mossy stone.','',26124),
(933,'enUS','Oh wait! I\'m supposed to be looking for that mysterious fossil!','',26124),
(934,'enUS','Ow.  Spicy.','',26124),
(935,'enUS','Nope, didn\'t leave the fossil back here!','',26124),
(936,'enUS','Ah, I remember now! I gave the mysterious fossil to Hollee! Check with her.','',26124),
(937,'enUS','%s goes back to work, oblivious to everything around him.','',26124),
(938,'enUS','Oh my! What\'s this? Help!','',26124),
(939,'enUS','Looks like we\'ve uncovered this $n. Now help me kill it!','',26124),
(940,'enUS','Help me! This $n won\'t get off of me!','',26124),
(941,'enUS','Something tells me this $n wants the mysterious fossil too. Help!','',26124),
(942,'enUS','$n! Help!','',26124),
(943,'enUS','Can you get this $n off me?','',26124),
(944,'enUS','%s beings to draw energy from the earth','',26124),
(945,'enUS','%s stares to the northwest and lets out a long, drawn out howl.','',26124),
(946,'enUS','%s lets forth a mighty howl.','',26124),
(947,'enUS','I\'ve been expecting you, $n.','',26124),
(948,'enUS','Now to test my design!','',26124),
(949,'enUS','Oh no!  It\'s out of control!  Run!','',26124),
(950,'enUS','I guess I\'d better do something about this!','',26124),
(951,'enUS','Protect master!','',26124),
(952,'enUS','%s begins a rite of creation...','',26124),
(953,'enUS','It is done.','',26124),
(954,'enUS','The totem is made, $n.','',26124),
(955,'enUS','%s holds high the items $n gave him...','',26124),
(956,'enUS','Ragnaros? Terrible news indeed...','',26124),
(957,'enUS','Go with speed... <cough cough> Find... <cough> Ryedol...','',26124),
(958,'enUS','You heard him, traveler. Speak to me again when you\'re ready to speak to Belgrum.','',26124),
(959,'enUS','%s looks over at Lotwil nervously.','',26124),
(960,'enUS','Hi, I am here for training.','',26124),
(961,'enUS','When will someone do something about the undead?','',26124),
(962,'enUS','Where is everyone?','',26124),
(963,'enUS','I can\'t even visit my father\'s grave in peace anymore.','',26124),
(964,'enUS','Why haven\'t the Stormwind guards come?','',26124),
(965,'enUS','I fear something dark is coming.','',26124),
(966,'enUS','The light appears to have forsaken us.','',26124),
(967,'enUS','Have fun in Booty Bay, $n!','',26124),
(968,'enUS','Enjoy the trip to Ratchet, $n!','',26124),
(969,'enUS','Off to Orgrimmar with you, $n. Say hi to Thrall for me!','',26124),
(970,'enUS','Off to the Undercity with you, $n! Try not to catch the plague...','',26124),
(971,'enUS','Off to Grom\'Gol with you, $n!','',26124),
(972,'enUS','Off to Orgrimmar with you, $n!','',26124),
(973,'enUS','Off to Grom\'Gol with you, $n!','',26124),
(974,'enUS','Off to the Undercity with you, $n!','',26124),
(975,'enUS','%s starts to go through his bags looking for the correct spell component.','',26124),
(976,'enUS','WHO DARES?! You shall be destroyed!','',26124),
(977,'enUS','HELLO WORLD!','',26124),
(978,'enUS','mumble mumble...','',26124),
(979,'enUS','%s falls to the ground. His spirit is released with his last breath.','',26124),
(980,'enUS','Step away from the Lieutenant\'s belongings!','Step away from the Lieutenant\'s belongings!',26124),
(981,'enUS','%s listens to $n\'s report...','',26124),
(982,'enUS','What??  The Burning Blade is spreading!  We must investigate!','',26124),
(983,'enUS','I thank you, $n.  And my brother thanks you.','',26124),
(984,'enUS','%s smashes the dead, twisted claw.','',26124),
(985,'enUS','We will suffer no demon\'s servant in our lands!','',26124),
(986,'enUS','%s enters a trance...','',26124),
(987,'enUS','%s is burned by unleashed magic!','',26124),
(988,'enUS','$n, unlocking the secret of these collars is beyond my skills...','',26124),
(989,'enUS','Argh!','',26124),
(990,'enUS','%s inspects the Searing Collar...','',26124),
(991,'enUS','Interesting, very interesting.  You found this in Durotar, $n?','',26124),
(992,'enUS','The collar is indeed infused with demonic power, $n.  This bodes ill for our people.','',26124),
(993,'enUS','Hm...it is good that you brought this to me, $n.','',26124),
(994,'enUS','A dangerous device this is, $n.  I am glad you brought it to my attention.','',26124),
(995,'enUS','Fresh Bread! Get your oven fresh bread here!','',26124),
(996,'enUS','Get\'em while they are nice and fresh! Loaves of bread here!','',26124),
(997,'enUS','All kinds of bread here! Made fresh today. Get\'em while they last!','',26124),
(998,'enUS','Bread here! Loaves of your favorites! Nice and fresh!','',26124),
(999,'enUS','%s enters a trance...','',26124),
(1000,'enUS','%s uses $n\'s offering in a ritual...','',26124),
(1001,'enUS','%s accepts $n\'s offering, and begins to chant...','',26124),
(1002,'enUS','%s draws power to him...','',26124),
(1003,'enUS','%s transforms the items $n gave him into a totem of cleansing...','',26124),
(1004,'enUS','%s creates a new totem...','',26124),
(1005,'enUS','I have the totem of cleansing, $n.','',26124),
(1006,'enUS','The totem is made.  The well may now be cleansed.','',26124),
(1007,'enUS','$n, I have created the cleansing totem.','',26124),
(1008,'enUS','The deed is done.  The totem is made.','',26124),
(1009,'enUS','I have created the totem.  You, $n, must cleanse the well.','',26124),
(1010,'enUS','The items you offered were pure, $n.  This new cleansing totem is strong.','',26124),
(1011,'enUS','%s begins chanting as he mixes the well stones and ambercorn before the Tribal Fire.','',26124),
(1012,'enUS','The Water of the Seers is ready for your consumption, $n.','',26124),
(1013,'enUS','Take a Candle of Beckoning from this crate, $n.','',26124),
(1014,'enUS','My sword Archeus served me well in life, but as at last my spirit may pass from the unhappy existence, I need it no longer.','',26124),
(1015,'enUS','I shall cling to the love of my daughter and hope that I will find forgiveness under the Light for my sins.','',26124),
(1016,'enUS','%s becomes dazed','',26124),
(1017,'enUS','I am slain!  Summon Verog!','I am slain!  Summon Verog!',26124),
(1018,'enUS','Deep doom','',26124),
(1019,'enUS','Deep doom','',26124),
(1020,'enUS','%s watches as his blood begins to stir, and the guile of the raptor slips through him.','',26124),
(1021,'enUS','%s grinds the pearls $n gave him...','',26124),
(1022,'enUS','Look out!  We\'re under attack by a $n!','',26124),
(1023,'enUS','There we are.  A new batch of flash bombs!','',26124),
(1024,'enUS','Take that, beast!','',26124),
(1025,'enUS','%s tosses dynamite through the air and it lands near by.','',26124),
(1026,'enUS','The power of the Tear of the Moons is mine! Mine I say!','',26124),
(1027,'enUS','%s begins to rub the Tear of the Moons.','',26124),
(1028,'enUS','Power! Glorious power!','',26124),
(1029,'enUS','%s begins to make strange grunting noises. The Tear of the Moons drops to the ground and shatters.','',26124),
(1030,'enUS','Whoa!...Whoa!...Ahh!  That was close.  Whoops!...Oh the pain, dear boy the pain!','',26124),
(1031,'enUS','Alright, alright! I think I can figure out how to operate this thing...','',26124),
(1032,'enUS','Okay, I think I\'ve got it, now. Follow me, $n!','',26124),
(1033,'enUS','Looks like we\'re out of the woods, eh? Wonder what this does...','',26124),
(1034,'enUS','I\'ve got to get this to Ratchet and nothing\'s going to stop me!','',26124),
(1035,'enUS','Help! Wait! It\'s like this thing has a mind of its own!','',26124),
(1036,'enUS','See how you like a taste of this!','',26124),
(1037,'enUS','I\'m going to die, I just know it!','',26124),
(1038,'enUS','Take that! Oh... I must have hit the wrong button... Wait, try this one!','',26124),
(1039,'enUS','Arrrgh! This isn\'t right!','',26124),
(1040,'enUS','There\'s the stolen shredder! Stop it or Lugwizzle will have our hides!','',26124),
(1041,'enUS','That was a close one! Well, let\'s get going, we\'re almost there.','',26124),
(1043,'enUS','Come on, don\'t break down on me now!','',26124),
(1044,'enUS','Hm... I don\'t think this blinking red light is a good thing...','',26124),
(1045,'enUS','Oh boy. Do you suppose Sputtervalve will mind if the shredder is just a little bit ... inoperable?','',26124),
(1046,'enUS','I\'ll try to get it started again. You go ahead. I\'ll find my way back on my own.','',26124),
(1047,'enUS','%s shimmers, flashes...and is no more!','',26124),
(1048,'enUS','%s calls more of his allies out of the shadows.','',26124),
(1049,'enUS','%s\'s anger explodes as he goes into a frenzied rage!','',26124),
(1051,'enUS','Frigate Ho! \'Tis an Orc vessel no doubt! Fire!','',26124),
(1052,'enUS','What\'s that on the horizon? Enemy ship no doubt! Fire!','',26124),
(1053,'enUS','Sails on the eastern horizon. Invaders no doubt! Fire!','',26124),
(1054,'enUS','There\'s something out there. Let loose a warning round!','',26124),
(1055,'enUS','What was that? Sea giant? Better safe than sorry. Fire!','',26124),
(1056,'enUS','Enemy ho! Fire!','',26124),
(1057,'enUS','Enemy fleet yonder! Fire!','',26124),
(1058,'enUS','Marauders to the north! Fire!','',26124),
(1059,'enUS','Inland invaders! Fire!','',26124),
(1060,'enUS','Enemy spotted! Fire!','',26124),
(1061,'enUS','Raiders from the northwest! Fire!','',26124),
(1062,'enUS','Raiding party over yonder! Fire!','',26124),
(1063,'enUS','%s hears the call for help and suits up for battle!','',26124),
(1064,'enUS','%s calls for help!','',26124),
(1065,'enUS','Stay close, $n. I\'ll need all the help I can get to break out of here. Let\'s go!','',26124),
(1066,'enUS','At last! Free from Northwatch Hold! I need a moment to catch my breath....','',26124),
(1067,'enUS','Now I feel better. Let\'s get back to Ratchet. Come on, $n.','',26124),
(1068,'enUS','Looks like the Southsea Freebooters are heavily entrenched on the coast. This could get rough.','',26124),
(1069,'enUS','Almost back to Ratchet! Let\'s keep up the pace...','',26124),
(1070,'enUS','Ah, the sweet salt air of Ratchet.','',26124),
(1071,'enUS','Captain Brightsun, $n here has freed me! $n, I am certain the Captain will reward your bravery.','',26124),
(1072,'enUS','$n coming right at us!','',26124),
(1073,'enUS','Get this $n off of me!','',26124),
(1074,'enUS','Help! $n attacking!','',26124),
(1075,'enUS','$n heading this way fast! Time for revenge!','',26124),
(1076,'enUS','%s places the spores within his alchemical instruments...','',26124),
(1077,'enUS','Ah, good.  These spores have rendered nicely.  Thank you, $n.','',26124),
(1078,'enUS','Thank you for the spores, $n.  They are now prepared for transport.','',26124),
(1079,'enUS','I am summoned!  Intruders, come to my tent and face your death!','',26124),
(1080,'enUS','%s digs its way out of the sand to protect its eggs.','',26124),
(1081,'enUS','Thanks, $n.  I\'ll be selling those drinks in no time!','',26124),
(1082,'enUS','Many thanks, $n.  These horns are going to make me a fortune!','',26124),
(1083,'enUS','I\'m going to make a fortune with these horns, $n.  Thanks!','',26124),
(1084,'enUS','Thanks!  And when I make my drinks...don\'t tell anyone what they\'re made of!','',26124),
(1085,'enUS','%s inspects the snapjaw shells...','',26124),
(1086,'enUS','C\'mon, let\'s try somewhere else.','C\'mon, let\'s try somewhere else.',26124),
(1087,'enUS','Hm...','',26124),
(1088,'enUS','Strange.  Very strange...','',26124),
(1089,'enUS','$n. These shells tell me much, but I fear many more questions are now raised...','',26124),
(1090,'enUS','Hey guys, let\'s try on the other side.','Hey guys, let\'s try on the other side.',26124),
(1091,'enUS','Billy says Fizzles used to be a great wizard. But he got turned into a rabbit when one of his spells went bad.','Billy says Fizzles used to be a great wizard. But he got turned into a rabbit when one of his spells went bad.',26124),
(1092,'enUS','Are we there yet?','Are we there yet?',26124),
(1093,'enUS','Why are we goin\' this way?','Why are we goin\' this way?',26124),
(1094,'enUS','Where we goin\'?','Where we goin\'?',26124),
(1095,'enUS','I need to pee.','I need to pee.',26124),
(1097,'enUS','I wanna see the Mage Tower.','I wanna see the Mage Tower.',26124),
(1098,'enUS','Is it true? Are there really crocolisks in the canals?','Is it true? Are there really crocolisks in the canals?',26124),
(1099,'enUS','My feet hurt.','My feet hurt.',26124),
(1100,'enUS','Why do we always go the same way?','Why do we always go the same way?',26124),
(1101,'enUS','Fresh bread for sale!','',26124),
(1102,'enUS','Warm, wholesome bread!','',26124),
(1103,'enUS','Rolls, buns and bread. Baked fresh!','',26124),
(1104,'enUS','Freshly baked bread for sale!','',26124),
(1105,'enUS','','Where\'s the water, Emma? Get the water, Emma? If\'n it weren\'t fer me, that lot wouldn\'t know what water looks like.',26124),
(1106,'enUS','','As if I don\'t have better things to do in my old age than carry buckets of water.',26124),
(1107,'enUS','','Seems like a hundred times a day I walk all the way to the well to get more water. No respect for their elders I tell ya.',26124),
(1108,'enUS','','O\'course I\'m talkin to myself. Only way to get decent conversation in this city.',26124),
(1109,'enUS','','One of these days I\'m gonna drown him in that blue robe. And all his brooms too.',26124),
(1110,'enUS','','Jack and Jill my wrinkled patoot! I do all the water luggin\' \'round here.',26124),
(1111,'enUS','','Think I\'m starting to wear a rut in the paving stones.',26124),
(1112,'enUS','','Deja vu.  For a moment, I thought I was back home... before the plague...',26124),
(1113,'enUS','Oh now you\'ve gone and angered me! Time to see the true force of the Stone of Tides!','',26124),
(1114,'enUS','%s exchanges quiet words with $n, and hands $ghim:her; a small object.','',26124),
(1115,'enUS','Take a stone from the table, $n.  You will need it for your quest.','',26124),
(1116,'enUS','','By the strength of the earth, the power of storms, and...',26124),
(1117,'enUS','','ARRRRRGGGHHH!',26124),
(1118,'enUS','','What has happened, Earthmother? Why has the spell failed?',26124),
(1119,'enUS','Ok I am here.  Come buy my wares while the getting is good.  I mean I am giving you first crack at these.','',26124),
(1120,'enUS','','Sergra falls into a trance for a moment, then looks to the sky.',26124),
(1121,'enUS','','I understand, Earthmother.',26124),
(1122,'enUS','No point in wasting any more time here. Ghosts don\'t have money!','',26124),
(1123,'enUS','Now you\'ve gone and done it. I thought you were better than the people at Southshore. They would have bought all my wares! Too bad they\'re all dead.','',26124),
(1124,'enUS','','Earthmother, grant me the power to undo this bloodshed!',26124),
(1125,'enUS','','Balance has been restored!',26124),
(1126,'enUS','%s examines the Moss-twined Heart...','',26124),
(1127,'enUS','$n, underneath the moss, this heart looks like a seed!','',26124),
(1128,'enUS','Let\'s try planting it in some of my special, prepared soil...','',26124),
(1129,'enUS','','Here we have the Cathedral of Light, the center of spiritual enlightenment here in Stormwind.',26124),
(1130,'enUS','Why do we have to learn this stuff anyway?','Why do we have to learn this stuff anyway?',26124),
(1131,'enUS','It\'s better than the drawings in the history tomes.','It\'s better than the drawings in the history tomes.',26124),
(1132,'enUS','I wanna see the dragon skeleton in the great library.','I wanna see the dragon skeleton in the great library.',26124),
(1133,'enUS','Teacher, when are we gonna see the sparkly Mage Tower?','Teacher, when are we gonna see the sparkly Mage Tower?',26124),
(1134,'enUS','I heard there are still orcs buried underneath it.','I heard there are still orcs buried underneath it.',26124),
(1136,'enUS','Teacher, I have to pee!','Teacher, I have to pee!',26124),
(1138,'enUS','Teacher are there night elves in Stormwind? I\'ve never seen a night elf before.','Teacher are there night elves in Stormwind? I\'ve never seen a night elf before.',26124),
(1139,'enUS','Teacher, he keeps poking me!','Teacher, he keeps poking me!',26124),
(1140,'enUS','','Here we have Stormwind Keep. Built upon the ruins of Stormwind Castle, which was destroyed by the Horde in the first Great War.',26124),
(1141,'enUS','','TEST',26124),
(1142,'enUS','You rabble get to work.  The ship must be completed soon.','',26124),
(1143,'enUS','Intruders!  Slay them!  Don\'t let them into the room!','',26124),
(1144,'enUS','Next time I see one of you not working, I\'ll have Buzzer cut your head off!','',26124),
(1145,'enUS','The cannons must be finished soon.','',26124),
(1146,'enUS','Get those parts moving down to the ship!','',26124),
(1147,'enUS','Anyone want to take a break?  Well too bad!  Get to work you oafs!','',26124),
(1148,'enUS','You there! Check out that noise!','You there! Check out that noise!',26124),
(1149,'enUS','We\'re under attack! Avast, ye swabs! Repel the invaders!','We\'re under attack! Avast, ye swabs! Repel the invaders!',26124),
(1150,'enUS','%s attempts to run away in fear!','%s attempts to run away in fear!',26124),
(1151,'enUS','%s goes into a rage after seeing a friend fall in battle!','%s goes into a rage after seeing a friend fall in battle!',26124),
(1152,'enUS','%s plants the Moss-twined Heart...','',26124),
(1153,'enUS','Is it true that the paladins train here?','Is it true that the paladins train here?',26124),
(1154,'enUS','','Yes, that is true. Paladins and priests alike train their skills and research great truths behind the walls of the Cathedral.',26124),
(1155,'enUS','','Children if you would please follow me, we will now be going to see the keep where King Anduin Wrynn himself sits on his throne.',26124),
(1156,'enUS','%s removes the seeds from the Glowing Fruit...','',26124),
(1157,'enUS','Let\'s see how these seeds grow in my prepared soil...','',26124),
(1158,'enUS','%s plants the fruit seeds.','',26124),
(1159,'enUS','%s hurries to his planter.','',26124),
(1160,'enUS','I hope this frond takes root...','',26124),
(1161,'enUS','','When the Horde was shattered, men returned here and began to rebuild the once great city as a testament to our own survival.',26124),
(1162,'enUS','','Yes, well...let\'s head on to the monument dedicated to the heroes of the two Great Wars, the Valley of Heroes. Follow me.',26124),
(1163,'enUS','','Isn\'t it amazing, children? All who enter the city must walk beneath the watchful eyes of the greatest heroes of our lands.',26124),
(1165,'enUS','','Breathtaking. Children, when we return to the school, you will each give an oral report on one of these legendary people.',26124),
(1166,'enUS','','Now, take another long look before we make our way to the Holy District and the great Cathedral of Light.',26124),
(1167,'enUS','','',26124),
(1168,'enUS','','',26124),
(1169,'enUS','','Oh no... Mist... what has happened...?',26124),
(1174,'enUS','%s rises from the soil!','',26124),
(1175,'enUS','%s rises from the soil!','',26124),
(1176,'enUS','KILL!!!','',26124),
(1177,'enUS','%s happily follows $n as $ghis:her; new seedling.','',26124),
(1178,'enUS','I will protect you!','',26124),
(1179,'enUS','%s begins to manipulate the Stone of Relu over the two fossils.','',26124),
(1180,'enUS','By the stars! A spirit has been summoned!','',26124),
(1181,'enUS','It\'s a mystery of the past indeed! But a key to our future!','',26124),
(1182,'enUS','Who hath summoned forth Aman?','',26124),
(1183,'enUS','Ah, I see you toil with relics of the past.','',26124),
(1184,'enUS','Be warned that even your creators are fallible.','',26124),
(1185,'enUS','Digging too deep into your past might bring an abrupt end to your future.','',26124),
(1186,'enUS','','%s hides among the bushes.',26124),
(1187,'enUS','%s dissipates before your eyes.','',26124),
(1188,'enUS','','I can make it the rest of the way, $n.  THANKS!',26124),
(1189,'enUS','','Ok, let\'s go!',26124),
(1190,'enUS','','%s disappears into the woods.',26124),
(1191,'enUS','%s goes into a frenzy!','',26124),
(1192,'enUS','Ask me how to get a free drink at the Blue Recluse!','',26124),
(1193,'enUS','Free drinks at the Blue Recluse!','',26124),
(1194,'enUS','Head on over to the Blue Recluse. Where everybody knows your name!','',26124),
(1195,'enUS','Best drinks in Stormwind!','',26124),
(1196,'enUS','Come for the beer, stay for the atmosphere!','',26124),
(1197,'enUS','Magical studies stressing your brain? Relax at the Blue Recluse!','',26124),
(1198,'enUS','The only place in Stormwind where magic and spirits mix, come to the Blue Recluse!','',26124),
(1199,'enUS','Feeling blue? Come on down to the Blue Recluse for a good time!','',26124),
(1200,'enUS','','Feeling hot? Get something to cool you off down at the Pig and Whistle!',26124),
(1201,'enUS','','Nightly brawls and great drinks! Get it all at the Pig and Whistle!',26124),
(1202,'enUS','','Get a free beer at the Pig and Whistle!',26124),
(1203,'enUS','','Talk to me for a free beer at the Pig and Whistle!',26124),
(1205,'enUS','','Smoother than and elf, stronger than an orc! No better drinks in all of Stormwind!',26124),
(1206,'enUS','','Tired of all those pansy spellcaster drinks? Try something stronger at the Pig and Whistle!',26124),
(1207,'enUS','','Back from a long journey? Rest and relax at the Pig and Whistle!',26124),
(1208,'enUS','','Best drinks in Stormwind!',26124),
(1209,'enUS','%s is hungry...','',26124),
(1210,'enUS','Cliffspring Falls lies along the mountains to the east and north.','',26124),
(1211,'enUS','Thank you, $n.  And luck to you.','',26124),
(1212,'enUS','Best weapons in the Barrens here!','',26124),
(1213,'enUS','Step right up! Finest selection of weapons this side of Ashenvale!','',26124),
(1214,'enUS','Lizzarik has blades. Lizzarik has maces. Lizzarik has all your weapon needs right here!','',26124),
(1215,'enUS','Act quick! Once it\'s gone, it\'s gone! Get your weapons here now!','',26124),
(1216,'enUS','%s studies the parchment from the Twilight Tome...','',26124),
(1217,'enUS','%s is struck by unleashed magic!','',26124),
(1218,'enUS','Hmm...','',26124),
(1219,'enUS','%s continues his meditations...','',26124),
(1221,'enUS','%s leans down to examine his shot.','',26124),
(1222,'enUS','Uthrok make gud shot','',26124),
(1223,'enUS','Athrikus points at you as he bellows forth words that scrape apart the inside of your ears. They are the last thing you hear.','',26124),
(1224,'enUS','','Finally, my soul may rest... Oh, dearest Cerellean...',26124),
(1225,'enUS','%s faces southeast and whimpers before looking back at you.','',26124),
(1226,'enUS','%s roars at Terenthis to get his attention.','',26124),
(1227,'enUS','Grimclaw?! Easy there, my friend... where is your master Volcor?','',26124),
(1228,'enUS','%s begins to moan and roar at Terenthis while stomping his paws on the ground.','',26124),
(1229,'enUS','Whoa, whoa there, my friend. One moment...','',26124),
(1230,'enUS','There... that should help. Now, tell me what\'s happened, Grimclaw.','',26124),
(1231,'enUS','%s roars at Terenthis more, but this time the druid seems to understand the bear.','',26124),
(1232,'enUS','I understand, my friend. I shall find someone to help your master. Go back to him now, or at least stay close.','',26124),
(1233,'enUS','%s roars in acknowledgement at Terenthis.','',26124),
(1234,'enUS','%s growls in your direction before taking time to sniff you.','',26124),
(1235,'enUS','I figured Flagongut would send someone for that fossil eventually.','',26124),
(1236,'enUS','Thank you again, $n. I\'ll make my way to the road now. When you can, find Terenthis and let him know we escaped.','',26124),
(1237,'enUS','Well, now or never I suppose. Remember, once we get to the road safely, return to Terenthis to let him know we escaped.','',26124),
(1238,'enUS','%s roars as his form shifts and he runs off.','',26124),
(1239,'enUS','Now let us place this rare earth in my planter...','',26124),
(1240,'enUS','Thank you again, $n.  This rare earth will be very helpful in my experiments.','',26124),
(1241,'enUS','%s roars in excitement as he rushes Volcor. When he reaches his master, Grimclaw licks his face.','',26124),
(1242,'enUS','You are dismissed, $n.','',26124),
(1243,'enUS','We made it, my friend. Remember to find Terenthis and let him know we\'re safe. Thank you again.','',26124),
(1244,'enUS','I\'m happy to see you too, Grim! It looks like not all strangers are to be feared after all, huh, Grim? Terenthis shall reward this adventurer well.','',26124),
(1245,'enUS','What was that noise? It sounded like a roar.','',26124),
(1246,'enUS','%s begins to cast a spell on Grimclaw.','',26124),
(1247,'enUS','I shall get started right away, $n.','',26124),
(1248,'enUS','Now... where was my thread and needle. Ah! There it is...','',26124),
(1249,'enUS','%s begins to cast a spell as you take the cloak from him.','',26124),
(1250,'enUS','Here they come!','',26124),
(1251,'enUS','We can overcome these foul creatures!','',26124),
(1252,'enUS','We shall earn our deaths at the very least!','',26124),
(1253,'enUS','Don\'t give up! Fight to the death!','',26124),
(1254,'enUS','%s charges!','%s charges!',26124),
(1255,'enUS','I must make the necessary preparations before the awakening ritual can begin. You must protect me!','',26124),
(1256,'enUS','These caverns were once a temple of promise for regrowth in the Barrens. Now, they are the halls of nightmares.','',26124),
(1257,'enUS','Come. We must continue. There is much to be done before we can pull Naralex from his nightmare.','',26124),
(1258,'enUS','Within this circle of fire I must cast the spell to banish the spirits of the slain Fanglords.','',26124),
(1259,'enUS','The caverns have been purified. To Naralex\'s chamber we go!','',26124),
(1260,'enUS','Down this way. Use caution, friends. I sense Naralex stirs in his troubled sleep....','',26124),
(1261,'enUS','From this spring I shall gather the sacred waters with which I will combine the blood of the fallen druids.','',26124),
(1262,'enUS','Now I have what is required. Let us continue.','',26124),
(1263,'enUS','Beyond this corridor, Naralex lies in fitful sleep. Let us go awaken him before it is too late.','',26124),
(1264,'enUS','Protect me brave souls as I delve into the Emerald Dream to rescue Naralex and put an end to this corruption!','',26124),
(1265,'enUS','%s begins to perform the awakening ritual on Naralex.','',26124),
(1266,'enUS','[PH] This is a placeholder action until i can cancel channeling my spell.','',26124),
(1267,'enUS','At last! Naralex awakes from the nightmare.','',26124),
(1268,'enUS','%s tosses fitfully in troubled sleep.','',26124),
(1269,'enUS','%s writhes in agony. The Disciple seems to be breaking through.','',26124),
(1270,'enUS','%s dreams up a horrendous vision. Something stirs beneath the murky waters.','',26124),
(1271,'enUS','I AM AWAKE, AT LAST!','',26124),
(1272,'enUS','Ah, to be pulled from the dreaded nightmare! I thank you, my loyal Disciple, along with your brave companions.','',26124),
(1273,'enUS','Attacked! Help get this $n off of me!','',26124),
(1274,'enUS','Deal with this $n! I need to prepare to awake Naralex!','',26124),
(1275,'enUS','I can\'t handle this $n alone! Help!','',26124),
(1276,'enUS','This $n is a minion from Naralex\'s nightmare no doubt!','',26124),
(1277,'enUS','Help!','',26124),
(1278,'enUS','Anaya...? Do my eyes deceive me? Is it really you?','',26124),
(1279,'enUS','','The ages have been cruel to you and I, my love, but be assured, it is, and at long last we are reunited.',26124),
(1280,'enUS','That the fates should be so cruel as to permit us only this after a thousand years apart...','',26124),
(1281,'enUS','Do you hate me, my love? That I was forced to destroy your living form, that your spirit be released from unhappy bondage.','',26124),
(1282,'enUS','','Let it not trouble your heart, beloved. You have freed me from slavery, and for that I love you all the more.',26124),
(1283,'enUS','','Sadly, even this must be cut short... The ties that bind me to this world weaken, and pull me away...',26124),
(1284,'enUS','','Farewell, Cerellean, until we are joined once again...',26124),
(1285,'enUS','','%s\'s soft voice trails away into the mists, \"Know that I love you always...\"',26124),
(1286,'enUS','No! Anaya... Anaya! Don\'t leave me! Please...','',26124),
(1287,'enUS','How, my love? How will I find the strength to face the ages of the world without you by my side...','',26124),
(1288,'enUS','%s waves to $n.','',26124),
(1289,'enUS','Go now, $n. Find Volcor... and remember, the magics protecting you will fail if you interact with anyone, save for talking.','',26124),
(1290,'enUS','%s scrutinizes the camp\'s visitor.','',26124),
(1291,'enUS','Ah.  Welcome $gsir:my lady;!','',26124),
(1292,'enUS','We must move quickly. Auberdine isn\'t too far away, but many enemies lurk in the forest.','',26124),
(1293,'enUS','Prepare to die, paladin scum!','',26124),
(1294,'enUS','Assassins from that cult you found... Let\'s get moving before someone else finds us out here.','',26124),
(1295,'enUS','The spirit of Echeyakee flows through you, $n.','',26124),
(1296,'enUS','','%s stretches and lets loose with a large yawn.',26124),
(1297,'enUS','The rage of Ishamuhale runs through you, $n.','',26124),
(1298,'enUS','Lakota\'mani thunders within you, $n.','',26124),
(1299,'enUS','The speed of Owatanka is with you, $n.','',26124),
(1300,'enUS','Your path is steady, $n, for Washte Pawne\'s resolve is with you.','',26124),
(1301,'enUS','May the spirit of Isha Awak give you strength, $n.','',26124),
(1302,'enUS','','Terenthis, Raene sent me to find you. The Sentinels are in need of help in Ashenvale.',26124),
(1303,'enUS','','Thank you, Terenthis. I shall remain here for as long as I can.',26124),
(1304,'enUS','','Hopefully I can send a worthy few to help Ashenvale and the Sentinels.',26124),
(1305,'enUS','Hello, Selarin. I\'m afraid I cannot help you at the moment, but perhaps some of the adventurers here in Auberdine can...','',26124),
(1306,'enUS','','Thank you again, Terenthis. I shall return again if more help is needed. Until then, please send more adventurers to Ashenvale',26124),
(1307,'enUS','%s mixes the Bathran\'s Hair...','',26124),
(1308,'enUS','The mixture is finished, $n.  Now we must save the child.','',26124),
(1309,'enUS','A paladin! Slaying him would please the master. Attack!','A paladin! Slaying him would please the master. Attack!',26124),
(1310,'enUS','They\'re coming out of the woodwork today. Let\'s keep moving or we may find more things that want me dead.','',26124),
(1312,'enUS','You cannot hide from us, little paladin!','',26124),
(1313,'enUS','Not quite so sure of yourself without the Purifier, hm?','',26124),
(1314,'enUS','Tonight, your blood will run red on the stones of our altars.','',26124),
(1315,'enUS','Well done! I should be fine on my own from here. Remember to talk to Delgren when you return to Maestra\'s Post in Ashenvale.','',26124),
(1316,'enUS','Uh... the disease is potent.  And it attacks the mind...','',26124),
(1318,'enUS','I must... RESIST!','',26124),
(1319,'enUS','I have survived the poisons of the Forsaken, $n, and I know now what must be done.','',26124),
(1320,'enUS','Free from this wretched cell at last! Let me show you to the courtyard....','',26124),
(1321,'enUS','You are indeed courageous for wanting to brave the horrors that lie beyond this door.','',26124),
(1322,'enUS','%s fumbles with the rusty lock on the courtyard door.','',26124),
(1323,'enUS','There we go!','',26124),
(1324,'enUS','Good luck with Arugal. I must hurry back to Hadrec now.','',26124),
(1325,'enUS','These statuettes must hold a hidden compartment....','',26124),
(1326,'enUS','They\'re locked!  NO!!','',26124),
(1327,'enUS','%s jumps out of the shadows!','%s jumps out of the shadows!',26124),
(1328,'enUS','About time someone killed the wretch.','',26124),
(1329,'enUS','For once I agree with you... scum.','',26124),
(1330,'enUS','','Mist! I feared I would never see you again! Yes, I am well, do not worry for me. You must rest and recover your health.',26124),
(1331,'enUS','Follow me and I\'ll open the courtyard door for you.','',26124),
(1332,'enUS','I have just the spell to get this door open. Too bad the cell doors weren\'t locked so haphazardly.','',26124),
(1334,'enUS','There it is! Wide open. Good luck to you conquering what lies beyond. I must report back to the Kirin Tor at once!','',26124),
(1335,'enUS','Here you are, Relara.  Take this...','',26124),
(1336,'enUS','','%s drinks the cure brought by $n.',26124),
(1337,'enUS','','Uh... Father...?  Are you there?  I\'m hungry... can I have some stew?',26124),
(1338,'enUS','What?','',26124),
(1339,'enUS','You\'re awake??  Your cure must have worked!  Thank you, $n.','',26124),
(1340,'enUS','%s growls in acknowledgement before straightening and making her way off into the forest.','',26124),
(1341,'enUS','Go swiftly, $n. My fate is in your hands.','',26124),
(1342,'enUS','%s protects himself with magic.','',26124),
(1343,'enUS','%s vanishes.','',26124),
(1344,'enUS','You landlubbers are tougher than I thought! I\'ll have to improvise!','You landlubbers are tougher than I thought! I\'ll have to improvise!',26124),
(1345,'enUS','D\'ah! Now you\'re making me angry!','D\'ah! Now you\'re making me angry!',26124),
(1346,'enUS','%s crushes the moonstones into a cup of tea.','',26124),
(1347,'enUS','Here you are, Relara.  Drink this...','',26124),
(1348,'enUS','%s drops its weapon and lights a stick of dynamite!','',26124),
(1349,'enUS','','Mmh... my eyes are not so heavy now, father.  Can we go out and play?',26124),
(1350,'enUS','Relara... you\'re awake?','',26124),
(1351,'enUS','Rest now, my daughter.','',26124),
(1352,'enUS','%s looks at $n, and then weeps with joy.','',26124),
(1353,'enUS','Relara is saved, $n.  Thank you.','',26124),
(1354,'enUS','%s searches the ancient statuettes.','',26124),
(1355,'enUS','$n, I am in need of your help once again.','',26124),
(1356,'enUS','','The numbers of my companions dwindles, goddess, and my own power shall soon be insufficient to hold back the demons of Felwood.',26124),
(1357,'enUS','','Goddess, grant me the power to overcome my enemies! Hear me, please, my need is desperate and my cause is just!',26124),
(1358,'enUS','','What... what is this? Could this be the answer to my prayers? Elune has granted me a weapon--this scythe--to defeat the demons.',26124),
(1359,'enUS','','I have failed... I have failed in my duty... failed my people... The worgen run rampant, and the Scythe of my goddess is lost.',26124),
(1360,'enUS','','This evil I have unleashed... In whose hand does the power my goddess granted to me now lie... By whose hand is it directed?',26124),
(1361,'enUS','%s beings to summon forth guardians!','',26124),
(1364,'enUS','To reach The Crossroads, $n, follow the road east then north.','',26124),
(1365,'enUS','','Sidney is late. I thought he would be home by now.',26124),
(1366,'enUS','He\'s your husband, woman. How am I to know where he is?','',26124),
(1367,'enUS','','He must be overwhelmed with work at the Monastery. But still, he should have returned by now.',26124),
(1368,'enUS','Cleansing the world of impure scum isn\'t an easy job, Nancy. Someone\'s got to do it.','',26124),
(1369,'enUS','','Well, I\'m going outside to check. Something is amiss.',26124),
(1370,'enUS','','%s lets out a long, drawn out sigh.',26124),
(1371,'enUS','','Oh well....',26124),
(1372,'enUS','It looks like we\'re in trouble. Look lively, here they come!','',26124),
(1373,'enUS','Hold! I sense an evil presence... Undead!','',26124),
(1374,'enUS','These three again?','',26124),
(1376,'enUS','Finally. The monster got what he deserved.','',26124),
(1377,'enUS','%s breaks the seal on Anton\'s letter and begins to read it.','',26124),
(1378,'enUS','By the Light! This is not good. There\'s something you don\'t understand, $n.','',26124),
(1379,'enUS','%s throws Anton\'s letter down on the table.','',26124),
(1380,'enUS','','The rod\'s design is simple. Dartol didn\'t use his arcane knowledge in its creation... it is more druidic in nature.',26124),
(1381,'enUS','','Hehe... I made a pun, didn\'t I? Druidic in nature... I\'m so funny.',26124),
(1382,'enUS','','Now, then... the rod. Let\'s see about putting it back together, shall we?',26124),
(1383,'enUS','','There! That wasn\'t too bad. What did you say you and Raene were going to do with this thing? It\'s powerful!',26124),
(1384,'enUS','If you have the time, Grimclaw and his master Volcor could use your help. If you\'re interested, speak with me further...','',26124),
(1385,'enUS','%s grabs for his poisoned dagger!','%s grabs for her poisoned dagger!',26124),
(1386,'enUS','Eh? What have we here?','',26124),
(1387,'enUS','Welcome to the Stockade!','',26124),
(1388,'enUS','Outsiders! Kill em all!','',26124),
(1390,'enUS','More of the Warden\'s errand boys!','',26124),
(1391,'enUS','Tell the Warden this prison is ours now!','',26124),
(1392,'enUS','It\'ll be quick, but it won\'t be painless!','',26124),
(1393,'enUS','Fresh meat!','',26124),
(1394,'enUS','I\'ll crush your skull beneath my boot!','',26124),
(1395,'enUS','Death to the Warden\'s men!','',26124),
(1396,'enUS','Who\'s there?','',26124),
(1397,'enUS','We must hurry.','',26124),
(1398,'enUS','Spirits of the forest come forth and heed nature\'s call!','',26124),
(1399,'enUS','','',26124),
(1400,'enUS','Spirits of the forest, you are needed! Make haste to the Charred Vale!','',26124),
(1401,'enUS','%s is not impressed.','%s is not impressed.',26124),
(1402,'enUS','You\'re pushing it, $n.','You\'re pushing it, $n.',26124),
(1403,'enUS','Don\'t make me go medieval on you.','Don\'t make me go medieval on you.',26124),
(1404,'enUS','Keep it up, $n, and I\'ll beat some manners into you.','Keep it up, $n, and I\'ll beat some manners into you.',26124),
(1405,'enUS','%s drops the animal parts into the bubbling cauldron.','',26124),
(1406,'enUS','Ah, feel the magic seep into the cave, my little elves... muhahaha.','',26124),
(1407,'enUS','So much for the power of nature... muhahahaha.','',26124),
(1408,'enUS','%s lays an egg!','',26124),
(1409,'enUS','%s begins to crack and open...','',26124),
(1410,'enUS','%s splits open!','',26124),
(1411,'enUS','','%s sees her cub being attacked and goes into a frenzied rage!',26124),
(1412,'enUS','%s gives message to Apothecary Zamah.','',26124),
(1413,'enUS','%s hatches!','',26124),
(1414,'enUS','%s chitters for help...','',26124),
(1415,'enUS','%s arrives!','',26124),
(1416,'enUS','','%s listens to $n\'s plea.',26124),
(1417,'enUS','','You were right to come.  My wisdom will be yours.',26124),
(1418,'enUS','','%s smiles.',26124),
(1419,'enUS','','Go, my servant.  Send word of Stonetalon to Apothecary Zamah.',26124),
(1420,'enUS','','%s summons a messenger...',26124),
(1421,'enUS','%s creates his toxin...','',26124),
(1422,'enUS','There we are, $n.  The toxin is ready.','',26124),
(1423,'enUS','','%s fills a container with the toxin.',26124),
(1424,'enUS','','The toxin is ready, $n.',26124),
(1425,'enUS','','The spirits of Stonetalon still rage, $n.',26124),
(1426,'enUS','','I fear we may never soothe them...',26124),
(1427,'enUS','All right, watch my back while I get you some of this ore.','',26124),
(1428,'enUS','Hey! You\'re not supposed to be here! C\'mon boys!','',26124),
(1430,'enUS','I think the sounds came from over here. We\'d better check it out.','',26124),
(1431,'enUS','Look out! It sounds like more of them!','',26124),
(1432,'enUS','Just a little while longer, I\'ve almost got it!','',26124),
(1433,'enUS','What\'s going on here? Piznik! I knew we shouldn\'t have let you stick around!','',26124),
(1434,'enUS','There, I\'ve got it!','',26124),
(1435,'enUS','Who dares interfere with the Sons of Arugal?','',26124),
(1436,'enUS','You\'ve destroyed too much of my work!  Prepare to join them in the Nether!','',26124),
(1437,'enUS','This should only take a moment, $n.','',26124),
(1438,'enUS','%s places the tear into a bowl of stew.','',26124),
(1439,'enUS','Eat this, my daughter.  It will help you feel better.','',26124),
(1440,'enUS','There you go...','',26124),
(1441,'enUS','','%s stirs from her delirium.',26124),
(1442,'enUS','','Mmmmh...',26124),
(1443,'enUS','%s places a poultice on Relara\'s head.','',26124),
(1444,'enUS','%s breathes a sigh of relief.','',26124),
(1445,'enUS','We\'ll cut your throats and bleed you dry!','',26124),
(1446,'enUS','We\'ll have your heads!','',26124),
(1447,'enUS','For the Dark Strand!','',26124),
(1448,'enUS','sdsd','',26124),
(1449,'enUS','My... My powers have diminished... You shall pay for this insolence!','',26124),
(1450,'enUS','No! You can\'t defeat me!','',26124),
(1452,'enUS','The race will start in 1 minute!','',26124),
(1454,'enUS','%s flees combat to get help!','',26124),
(1455,'enUS','%s sees his fans cheering and gains a burst of speed!','',26124),
(1456,'enUS','I have changed my mind loyal servants, you do not need to bring the prisoner all the way to my study, I will deal with him here and now.','',26124),
(1458,'enUS','Arrrgh!','',26124),
(1459,'enUS','A simple enough task to break this soulstone!','',26124),
(1460,'enUS','%s bursts open!','',26124),
(1461,'enUS','%s intones, \"Assist him in any way he requires. Do not fail in this task.\"','',26124),
(1462,'enUS','%s crumbles into dust.','',26124),
(1463,'enUS','%s sniffs the air hungrily, smelling fresh lion meat...','',26124),
(1464,'enUS','%s devours the carcass!','',26124),
(1465,'enUS','%s disappears into the snow.','',26124),
(1466,'enUS','The fresh carcass is placed upon the Flame of Uzel.','',26124),
(1467,'enUS','%s looks from side to side...','',26124),
(1468,'enUS','Hm... if you\'re looking to adle wits, $n, then the secret behind Zanzil\'s zombies might just do the trick!','',26124),
(1469,'enUS','Thank you, $n.','',26124),
(1470,'enUS','I\'m sure I can find a use for this mixture...','',26124),
(1471,'enUS','In the throes of the Sundering, Ameth\'Aran was at the whim of the terror that gripped the land. There was little hope for survival.','',26124),
(1472,'enUS','Athrikus came to us. He told us that he could save us from harm. He cast a spell upon us to protect us from harm.','',26124),
(1473,'enUS','Then we must put an end to Athrikus Narassin. Tell me, spirit, where might we find the other soulgems, to undo his magic?','',26124),
(1474,'enUS','When the shaking stopped, his true motives were revealed. We were trapped, and he was slowly draining our powers.','',26124),
(1475,'enUS','His lieutenant, Ilkrud Magthrull possesses a tome which might indicate the location of the remaining soulgems.','',26124),
(1476,'enUS','%s fades into the mist...','',26124),
(1477,'enUS','%s grabs a part and puts it in his pocket...','',26124),
(1478,'enUS','There, that should do it...','',26124),
(1479,'enUS','%s places the crate of parts on the ground.','',26124),
(1480,'enUS','%s begins to dance.','',26124),
(1481,'enUS','Hahah!  $n, you make quite a partner!','',26124),
(1482,'enUS','Woo hoo! Finally getting out of here. It\'s going to be rough though. Keep your eyes peeled for trouble.','',26124),
(1483,'enUS','Up there is where Charlga Razorflank resides. Blasted old crone.','',26124),
(1484,'enUS','There\'s blueleaf tuber in this trench! It\'s like gold waiting to be mined I tell you!','',26124),
(1485,'enUS','There could be danger around every corner here.','',26124),
(1486,'enUS','I don\'t see how these foul animals live in this place... sheesh it smells!','',26124),
(1487,'enUS','I think I see a way for us to get out of this big twisted mess of a bramble.','',26124),
(1488,'enUS','Glad to be out of that wretched trench. Not much nicer up here though!','',26124),
(1489,'enUS','This stout sure smells strong!','',26124),
(1490,'enUS','Finally! I\'ll be glad to get out of this place.','',26124),
(1491,'enUS','Let\'s have just a small taste...','',26124),
(1492,'enUS','Wait!  What am I thinking!  We have a job to do with this stuff.','',26124),
(1493,'enUS','I think I\'ll rest a moment and catch my breath before heading back to Ratchet. Thanks for all the help!','',26124),
(1494,'enUS','Well, I\'m off to Ratchet now! Best of luck to you!','',26124),
(1495,'enUS','%s listens as $n tells him of $ghis:her; adventures in the Badlands.','',26124),
(1496,'enUS','Astounding!  So then indurium is the key!','',26124),
(1497,'enUS','There were hundreds imprisoned by his spell. Now only a few remain in their prisons. He would speak to us sometimes.','',26124),
(1498,'enUS','He worried that his power weakened, that soon even we last of his precious soulgems would fade and die.','',26124),
(1499,'enUS','I\'ll finish you off for good this time!','',26124),
(1500,'enUS','%s takes the indurium flakes to his forge.','',26124),
(1501,'enUS','Now let\'s heat up these flakes...','',26124),
(1502,'enUS','So far they\'re holding.  Let\'s turn up the heat...','',26124),
(1503,'enUS','By Orgrim!  This indurium can withstand massive heat!','',26124),
(1504,'enUS','A successful test!  $n, this indurium is some amazing stuff.','',26124),
(1505,'enUS','Thanks again, $n.  Now I\'ll use this indurium to beef up my car!','',26124),
(1506,'enUS','BANG! BANG! BANG!  I\'m beefing up the car!!!','',26124),
(1507,'enUS','All done!','',26124),
(1508,'enUS','Now for the next race, the car will be even FASTER than before!','',26124),
(1509,'enUS','Open for business! The goblin car is looking sharp and it\'s sure to be a winner! Get your bets in before the race starts!','',26124),
(1510,'enUS','Smart money\'s on the gnomes to take the next race! Get your money in while you still can!','',26124),
(1511,'enUS','%s begins to cast a spell over the hearts and tongues.','',26124),
(1512,'enUS','The brood of Onyxia!','',26124),
(1513,'enUS','%s decomposes into dust.','',26124),
(1514,'enUS','Me still boss of ogres. Haw!','',26124),
(1515,'enUS','Puny $r wanna fight Overlord Mok\'Morokk? Me beat you! Me boss here!','',26124),
(1517,'enUS','And it\'s the $n coming through turn one!','',26124),
(1518,'enUS','And crossing the line is the gnome car! The gnomes win!','',26124),
(1519,'enUS','','',26124),
(1520,'enUS','','',26124),
(1521,'enUS','','%s returns the rude gesture to $n.',26124),
(1522,'enUS','The goblins win! The goblins win!','',26124),
(1523,'enUS','Me scared! Me run now!','',26124),
(1524,'enUS','Hm, these are pretty good bones you got this time, Pozzik.','',26124),
(1525,'enUS','All done! The modifications should give us a little boost in speed, but I don\'t think she\'ll hold up to too much bumping.','',26124),
(1526,'enUS','Okay, crew. Get to work on getting these bones installed.','',26124),
(1527,'enUS','Thanks for the helmets, $n.  These will really reduce our medical bills...','',26124),
(1528,'enUS','','%s gestures to the pitcher of water sitting on the edge of the well.',26124),
(1529,'enUS','','What can I do for you?',26124),
(1530,'enUS','','What do you fancy, $G sir:miss;?',26124),
(1531,'enUS','','Well hello, $n, what can I get you today?',26124),
(1532,'enUS','','Been a tough day? A nice ale should loosen those worries right up.',26124),
(1533,'enUS','','Hi, what would you like?',26124),
(1534,'enUS','','Good day, $c. What would you like?',26124),
(1535,'enUS','','Look what the cat dragged in. What can I get you, $n?',26124),
(1536,'enUS','','Do you think I need more pieces of Flair?',26124),
(1537,'enUS','The winner of the drag race is...the gnome team!  Great job guys!','',26124),
(1538,'enUS','The goblins win the drag race!  Better luck next time, gnome team.','',26124),
(1539,'enUS','','%s snorts dream dust.',26124),
(1540,'enUS','Hehehe! Things go boom!','',26124),
(1541,'enUS','What was that!','',26124),
(1542,'enUS','Bloody... Must have been the goblins... Let\'s see how bad the damage is.','',26124),
(1543,'enUS','Guess there\'s nothing more to be done. Blast!','',26124),
(1544,'enUS','Eek! $n coming right at us!','',26124),
(1545,'enUS','Egads! $n on me!','',26124),
(1546,'enUS','$n heading this way fast! To arms!','',26124),
(1547,'enUS','Help! Get this $n off of me!','',26124),
(1548,'enUS','%s snorts a speck of dream dust up his nose...','',26124),
(1549,'enUS','%s is dazed...','',26124),
(1550,'enUS','ACHOO!','',26124),
(1551,'enUS','Wow!  $n, that dream dust is powerful stuff!','',26124),
(1568,'enUS','What was that? Did you leave that flare lit?!','',26124),
(1569,'enUS','That explosion was great! Did you see how big it was?','',26124),
(1570,'enUS','It wasn\'t me! I swear!','',26124),
(1571,'enUS','Spread out! Find out who did this. They\'re gonna get fired for sure!','',26124),
(1572,'enUS','This is gonna cost a bundle of gold. It\'s not comin\' out of my pocket.','',26124),
(1573,'enUS','Anyone see anything? What happened?','',26124),
(1588,'enUS','sneezes voilently!','',26124),
(1589,'enUS','Until we meet again, brave one.','',26124),
(1591,'enUS','%s wiggles his whiskers at $n.','',26124),
(1592,'enUS','%s sniffs at the ground...','',26124),
(1593,'enUS','%s finds a truffle.','',26124),
(1594,'enUS','%s charges!','',26124),
(1608,'enUS','You have done well, $n. Continue your search for knowledge, and remember the history you have learned.','',26124),
(1609,'enUS','%s is found!','',26124),
(1610,'enUS','Ok, let\'s get started.','',26124),
(1611,'enUS','Now let\'s look for the herb.','',26124),
(1612,'enUS','Nope, not here...','',26124),
(1613,'enUS','There must be one around here somewhere...','',26124),
(1614,'enUS','Ah, there\'s one!','',26124),
(1615,'enUS','Come, $n!  Let\'s go over there and collect it!','',26124),
(1616,'enUS','%s picks the herb from the ground.','',26124),
(1617,'enUS','Ok, now let\'s get out of here!','',26124),
(1618,'enUS','I can make it from here.  Thanks, $n!  And talk to my employer about a reward!','',26124),
(1619,'enUS','%s disappears back into the swamp.','',26124),
(1628,'enUS','Look out!  The $n attacks!','',26124),
(1629,'enUS','Help! I\'m under attack!','',26124),
(1630,'enUS','Help!  The beast is on me!','',26124),
(1631,'enUS','I\'m glad you\'re here!  Because I need your help!!','',26124),
(1632,'enUS','He\'ll bring you mead, he\'ll bring you beer...','',26124),
(1633,'enUS','A grinning face from ear to ear...','',26124),
(1634,'enUS','He\'s served us all from year to year...','',26124),
(1635,'enUS','We call him Smiling Jim...','',26124),
(1636,'enUS','Stop! Back to your corners! Well fought, both of you.','',26124),
(1638,'enUS','%s nervously crawls from the crate.','',26124),
(1639,'enUS','%s returns to $n.','',26124),
(1640,'enUS','%s begins to dig...','',26124),
(1641,'enUS','Combatants ready... FIGHT!','',26124),
(1642,'enUS','Through the second turn it\'s the $n!','',26124),
(1643,'enUS','Ok, I want a good clean spar. Remember to keep your sword up and shield ready.','',26124),
(1644,'enUS','%s stops.','',26124),
(1648,'enUS','Go to the Shady Rest Inn and follow the tracks. See where they lead and report back to me.','',26124),
(1649,'enUS','Understood. I will return shortly.','',26124),
(1650,'enUS','%s disappears into the mists.','',26124),
(1651,'enUS','Get \'em, guys. Teach \'em a lesson! No one messes with Slim.','',26124),
(1652,'enUS','Enjoy the rest of your stay in Menethil. It won\'t last much longer.','',26124),
(1653,'enUS','Think you can come here and steal from us, huh!?','',26124),
(1654,'enUS','There\'s no way you\'re gettin\' out of here alive!','There\'s no way you\'re gettin\' out of here alive!',26124),
(1655,'enUS','No time for beer!  The race is about to start.','',26124),
(1656,'enUS','The car took a beating!  Let\'s get it ready for the next race.','',26124),
(1657,'enUS','Ah, Private Hendel. A pleasure to meet one of the men who would betray his kingdom for pride.','',26124),
(1658,'enUS','What am I going to do?','',26124),
(1659,'enUS','If the Captain finds out, it\'ll be the end of me.','',26124),
(1660,'enUS','How could this happen?','',26124),
(1661,'enUS','All of a sudden they were everywhere.','',26124),
(1662,'enUS','They must have had someone helping them.','',26124),
(1663,'enUS','Why don\'t we deal with you now, Hendel? Lady Proudmoore will speak to you back in the tower.','',26124),
(1664,'enUS','I am eager to hear what so angry an orc has to say...','',26124),
(1665,'enUS','%s places Marg\'s head in the cauldron.','',26124),
(1666,'enUS','Peer into the cauldron, $n.  Marg wishes to speak...','',26124),
(1667,'enUS','Hear that? $n, here says that human deserter Reethe might have been the one who burned down the inn!','',26124),
(1668,'enUS','I hope Ogron finds that pinkskin and breaks his legs. See how he survives in the marsh like that!','',26124),
(1669,'enUS','I noticed some fire on that island over there. A human, too. Let\'s go check it out, $n.','',26124),
(1670,'enUS','That\'s Reethe alright. Let\'s go see what he has to say, yeah?','',26124),
(1671,'enUS','%s places the scroll on the table, and reads...','',26124),
(1672,'enUS','By the Light!  This cursed spy was a good one!  I\'m glad he\'s dead.','',26124),
(1673,'enUS','Thank you for this report, $n.  It is now clear that we must tighten our patrols near Theramore.','',26124),
(1674,'enUS','W-what do you want? Just leave me alone...','',26124),
(1675,'enUS','I swear, I didn\'t steal anything from you! Here, take some of my supplies, just go away!','',26124),
(1676,'enUS','%s lets out a pained groan.','',26124),
(1677,'enUS','Help arrives at last....','',26124),
(1678,'enUS','','Feeling better I see.',26124),
(1679,'enUS','','Drink this, it will help.',26124),
(1680,'enUS','','This should ease the pain.',26124),
(1681,'enUS','','Some of this ointment should help.',26124),
(1682,'enUS','','You\'re going to be just fine.',26124),
(1683,'enUS','','Take this, drink it down.',26124),
(1684,'enUS','','You will keep all your fingers and toes, not to worry.',26124),
(1685,'enUS','','Let me help you with those.',26124),
(1686,'enUS','Nurse.','',26124),
(1687,'enUS','How are my men doing?','',26124),
(1688,'enUS','','They are doing well, sir. They should all make full recoveries.',26124),
(1689,'enUS','Thank you. Let\'s hope there aren\'t any more.','',26124),
(1690,'enUS','Kill them all!','',26124),
(1691,'enUS','Freedom!','',26124),
(1692,'enUS','Death to the Warden!','',26124),
(1693,'enUS','Kill the guards, take the Warden alive!','',26124),
(1694,'enUS','DIE!','',26124),
(1695,'enUS','We\'ll dance on your bones!','',26124),
(1696,'enUS','Death to the Warden\'s men!','',26124),
(1697,'enUS','Your jail is ours!','',26124),
(1698,'enUS','We\'re under attack!','',26124),
(1699,'enUS','Defend the barricade!','',26124),
(1701,'enUS','Brace yourselves!','',26124),
(1702,'enUS','Let none get by!','',26124),
(1703,'enUS','By Lothar, you Defias scum will pay!','',26124),
(1704,'enUS','Another wave, hold the line!','',26124),
(1705,'enUS','More prisoners! ','',26124),
(1706,'enUS','Don\'t let them escape!','',26124),
(1707,'enUS','Just tell us what you know about the Shady Rest Inn, and I won\'t bash your skull in.','',26124),
(1708,'enUS','I... Well, I may of taken a little thing or two from the inn... but what would an ogre care about that?','',26124),
(1709,'enUS','Look here, if you don\'t tell me about the fire--','',26124),
(1710,'enUS','Not one step closer, ogre!','',26124),
(1711,'enUS','And I don\'t know anything about this fire of yours...','',26124),
(1712,'enUS','Okay, okay! Enough fighting. No one else needs to get hurt.','',26124),
(1713,'enUS','It\'s okay, boys. Back off. You\'ve done enough. I\'ll meet up with you later.','',26124),
(1714,'enUS','Paval Reethe! Found you at last. And consorting with ogres now? No fear, even deserters and traitors are afforded some mercy.','',26124),
(1715,'enUS','Yeah, okay, boss. No problem.','',26124),
(1716,'enUS','All right, boss. You sure though? Just seems like a waste of good practice.','',26124),
(1717,'enUS','%s cracks his knuckles.','',26124),
(1718,'enUS','All hail $n, a $c of worth!','',26124),
(1719,'enUS','Behold!  The Blue Recluse holds a feast in $g his:her; honor!','',26124),
(1720,'enUS','Private, show Lieutenant Reethe some mercy.','',26124),
(1721,'enUS','','Gladly, sir.',26124),
(1722,'enUS','Ugh... Hallan, didn\'t think you had it in you...','',26124),
(1723,'enUS','Now, let\'s clean up the rest of the trash, men!','',26124),
(1724,'enUS','Damn it! You\'d better not die on me, human!','',26124),
(1725,'enUS','Must be your lucky day. Alright, I\'ll talk. Just leave me alone. Look, you\'re not going to believe me, but it wa... oh, Light, looks like the girl could shoot...','',26124),
(1726,'enUS','Still with us, Reethe?','',26124),
(1727,'enUS','Intruders!','',26124),
(1728,'enUS','They\'re here!','',26124),
(1729,'enUS','Looks dead to me. Not much use to us like this. You\'d better go back and tell Krog what happened.','',26124),
(1730,'enUS','By the way, thanks for watching my back.','',26124),
(1731,'enUS','What was that? Did you hear something?','',26124),
(1732,'enUS','%s staggers backwards as the arrow lodges itself deeply in his chest.','',26124),
(1733,'enUS','Hooray, $n!','',26124),
(1734,'enUS','Let\'s here it for $n!','',26124),
(1735,'enUS','Here here!','',26124),
(1736,'enUS','Long live $n!','',26124),
(1737,'enUS','At this point, I will summon someone to examine the pendant, and find a hidden compartment...','',26124),
(1740,'enUS','I don\'t know what\'ll be in it yet.  Pat Nagle and Michael Backus need to discuss this first...','',26124),
(1741,'enUS','So until they do... bye bye!','',26124),
(1742,'enUS','Enough! I will talk. Put your weapons away, it is not with me that you have quarrel with.','',26124),
(1743,'enUS','Okay, okay! No need to get all violent. I\'ll talk. I\'ll talk!','',26124),
(1744,'enUS','I have a few notes from the job back at my place. I\'ll get them and then meet you back in the inn.','',26124),
(1745,'enUS','Just leave the poor man alone, citizen, he\'s not worth the trouble.','',26124),
(1748,'enUS','$n, I would have words with you.','',26124),
(1749,'enUS','Go about your business. My errand does not require your attention.','',26124),
(1750,'enUS','Atten...HUT!','Atten...HUT!',26124),
(1751,'enUS','Go with grace, and may the Lady\'s magic protect you.','',26124),
(1752,'enUS','Falgran Hastil reporting, sir. I will find where the hoofprints lead and report back to you.','',26124),
(1753,'enUS','Tesoran! I need someone--Falgran Hastil, preferably--to take care of $n\'s lead on the prints near the Shady Rest Inn.','',26124),
(1754,'enUS','Right away, sir.','',26124),
(1755,'enUS','Kagoro, I require your presence!','',26124),
(1756,'enUS','Alright! Alright! We surrender... Just put your weapons down, I\'ll cooperate!','',26124),
(1757,'enUS','You might be able to take me, but the Defias WILL take back Stormwind!','',26124),
(1758,'enUS','Uh oh... this is bad.','',26124),
(1759,'enUS','Please... please... Miss Proudmore. I didn\'t mean to...','',26124),
(1760,'enUS','You put up a good fight, Edward. Let\'s see if Kahil can take\'em.','',26124),
(1761,'enUS','I apologize for taking so long to get here. I wanted Lady Proudmoore to be present also.','',26124),
(1762,'enUS','Kahil, it was a mighty effort. Come back and rest up. Narrisha will clean this up for us.','',26124),
(1763,'enUS','Bravely fought Narrisha. We will get you next time Red Team!','',26124),
(1764,'enUS','All of you fought hard and valiantly. It makes me proud to see the warriors you have become.','',26124),
(1765,'enUS','We lost this time but don\'t let it get you down. Concentrate on your special attacks. Keep your shield high and close. Do this and next time victory will be ours!','',26124),
(1766,'enUS','Heck\'va fight ya put up Jarad. Gots\'ta keep that shield up more next time. Lana! Yer in!','',26124),
(1767,'enUS','I\'ve seen you fight better den dat, Lana! You can gettem next time! Tark, get in there and giv\'em hell!','',26124),
(1768,'enUS','Tark, what happened in there? You know yer better den dat! Blue team, you will get yours soon \'nuff!','',26124),
(1769,'enUS','Outstandin\' fightin\'! Ya made an old man proud. Keep it up and ale will be on me ta\'night.','',26124),
(1770,'enUS','What kinda fightin\' was that? I should kick all of ya worthless hides off the team and out of the guard!','',26124),
(1771,'enUS','Captains, send forth your first combatants.','',26124),
(1772,'enUS','Farewell. We shall speak again, I\'m sure.','',26124),
(1773,'enUS','Red is the winner! Congratulations Red!','',26124),
(1774,'enUS','Blue is the Winner! Congratulations Blue!','',26124),
(1775,'enUS','Jarad, you are up first for us.','',26124),
(1776,'enUS','Edward, ya leadin\' us off. Git in there.','',26124),
(1777,'enUS','For the Blue!','For the Blue!',26124),
(1778,'enUS','For the Red!','For the Red!',26124),
(1788,'enUS','Hey $n!  Don\'t forget to grab a crate, a manual and a command stick!','',26124),
(1789,'enUS','That was a nice shot... but not perfect. Maybe a bit more to the left.','That was a nice shot... but not perfect. Maybe a bit more to the left.',26124),
(1790,'enUS','Barely hit the target that time. Hmmm,... maybe I need to adjust back to the right.','Barely hit the target that time. Hmmm,... maybe I need to adjust back to the right.',26124),
(1791,'enUS','Whoa! Look at that bullseye!','Whoa! Look at that bullseye!',26124),
(1792,'enUS','Oops! That was a bit off. I didn\'t even hit the target!','Oops! That was a bit off. I didn\'t even hit the target!',26124),
(1793,'enUS','As you wish, sir.','',26124),
(1794,'enUS','Red team, winner!','',26124),
(1795,'enUS','Blue team, Winner!','',26124),
(1808,'enUS','We can only stay a few moments before returning to the tower. If you wish to speak to us more you may find us there.','',26124),
(1828,'enUS','It wasn\'t my fault, Master Mazen!','',26124),
(1829,'enUS','It was a simple mistake. A wrong turn I tell you!','',26124),
(1830,'enUS','The swamp was horrible! I was so... so... scared!','',26124),
(1831,'enUS','I\'m lucky to be alive!','',26124),
(1833,'enUS','Thank the Light you\'re here! Get your sword out, there\'s centaur on my tail!','',26124),
(1834,'enUS','No one\'s going to save you now, human!','',26124),
(1835,'enUS','I\'ll take your money and your life too!','I\'ll take your money and your life too!',26124),
(1836,'enUS','Say your prayers!','Say your prayers!',26124),
(1837,'enUS','','',26124),
(1838,'enUS','I think that\'s the last of them. It\'s a good thing you came when you did... I wasn\'t sure how much longer I could stay hidden.','',26124),
(1848,'enUS','The serum will only take a few minutes to prepare, $n.','',26124),
(1849,'enUS','Almost done...','',26124),
(1850,'enUS','At last, the serum is complete, $n. Now, come closer. We must talk.','',26124),
(1851,'enUS','This shouldn\'t take long...','',26124),
(1853,'enUS','The invisibility liquor is ready for you, $n.','',26124),
(1854,'enUS','Let us leave this place.','',26124),
(1855,'enUS','Thank you, $n.  I will remember you always.  You can find my strongbox in my camp, north of Stonard.','',26124),
(1856,'enUS','%s disappears into the swamp.','',26124),
(1857,'enUS','%s takes a big swig of ale.','',26124),
(1858,'enUS','That was refreshing. Now there\'s information that needs to be told...','',26124),
(1859,'enUS','I believe the Forsaken are misleading the allies of the Horde.... wait... I feel so... dizzy...','',26124),
(1860,'enUS','%s writhes in pain.','',26124),
(1861,'enUS','AAAAAAAAAAAAAAAARGH!','',26124),
(1862,'enUS','','Here goes nothing...',26124),
(1863,'enUS','No kill me! No kill me!','',26124),
(1864,'enUS','Yiieeeee! Me run!','',26124),
(1865,'enUS','Ah, a chance to use this freshly sharpened blade.','Ah, a chance to use this freshly sharpened blade.',26124),
(1866,'enUS','The Brotherhood will not tolerate your actions.','The Brotherhood will not tolerate your actions.',26124),
(1867,'enUS','Feel the power of the Brotherhood!','Feel the power of the Brotherhood!',26124),
(1868,'enUS','You no take candle!','',26124),
(1869,'enUS','Grrrrr!','',26124),
(1870,'enUS','Grrrr... fresh meat!','',26124),
(1871,'enUS','More bones to gnaw on...','',26124),
(1872,'enUS','Here we go, people.  Watch your backs...','Here we go, people.  Watch your backs...',26124),
(1873,'enUS','Watch your step...','Watch your step...',26124),
(1874,'enUS','Feel the power of the Blackrock Orcs!','Feel the power of the Blackrock Orcs!',26124),
(1875,'enUS','You are no match for the Blackrock Orcs!','You are no match for the Blackrock Orcs!',26124),
(1876,'enUS','We made it through the pass!  Now we have the swamp...','We made it through the pass!  Now we have the swamp...',26124),
(1877,'enUS','We made it to Nethergarde!','',26124),
(1878,'enUS','Open for business!','',26124),
(1879,'enUS','I\'m closing soon, so buy while you can!','',26124),
(1880,'enUS','I\'m just about to close...','',26124),
(1881,'enUS','He dead.','',26124),
(1882,'enUS','Oh well.','',26124),
(1883,'enUS','Let me install these Gyromechanic Gears and Restabilization Cogs and we\'ll fire up The Recombobulator.','',26124),
(1884,'enUS','That should do the trick.','',26124),
(1885,'enUS','Time to save the entire gnomish race. Here goes nothing!','',26124),
(1886,'enUS','Oh, great.','',26124),
(1887,'enUS','Back to the drawing board.','',26124),
(1888,'enUS','Perhaps a bit more grease will do the trick.','',26124),
(1889,'enUS','Pretty close that time. I think we\'ve almost got it.','',26124),
(1890,'enUS','The Recombobulator is shaping up quite nicely. Just a few adjustments to go!','',26124),
(1891,'enUS','Precisely.','',26124),
(1892,'enUS','My thoughts exactly.','',26124),
(1893,'enUS','Couldn\'t have said it better myself.','',26124),
(1894,'enUS','Most definitely.','',26124),
(1895,'enUS','I was thinking the same thing.','',26124),
(1901,'enUS','Charog likes to spend his coin at the Busted Drum. Let\'s go pay him a visit, $n.','',26124),
(1902,'enUS','Mojka, cover for me! I have some business to attend to.','',26124),
(1903,'enUS','','Again? Make it fast, Komak, I\'m sick of this.',26124),
(1904,'enUS','Women...','',26124),
(1905,'enUS','I am here!  Come face me, if you dare!','',26124),
(1906,'enUS','It\'s Komak... Better get out of his way.','',26124),
(1907,'enUS','Not again...','',26124),
(1908,'enUS','My weapon be thirsty!','My weapon be thirsty!',26124),
(1909,'enUS','Killing you be easy.','Killing you be easy.',26124),
(1910,'enUS','Have a taste of Frostmane magics.','Have a taste of Frostmane magics.',26124),
(1911,'enUS','All you $R want is my weed.','All you $R want is my weed.',26124),
(1912,'enUS','I\'ll cut you!','I\'ll cut you!',26124),
(1913,'enUS','Crush!','Crush!',26124),
(1914,'enUS','Kill!','Kill!',26124),
(1915,'enUS','Destroy!','Destroy!',26124),
(1916,'enUS','I smell a $R','',26124),
(1917,'enUS','Time to bash!','',26124),
(1918,'enUS','You dare defile Frostmane Hold, $R. Prepare to die!','',26124),
(1919,'enUS','Oh, we are going to get along just fine, $n.','',26124),
(1920,'enUS','Yip! Me kill!','Yip! Me kill!',26124),
(1921,'enUS','Me no run from $C like you!','Me no run from $C like you!',26124),
(1922,'enUS','So what do you want to do today?','',26124),
(1923,'enUS','I dunno. What do you want to do?','',26124),
(1924,'enUS','Fishing sounds good.','',26124),
(1925,'enUS','I\'ll crush you!','',26124),
(1926,'enUS','Me smash! You die!','',26124),
(1927,'enUS','Raaar!!! Me smash $r!','',26124),
(1928,'enUS','Dat $R look gud to eat!','',26124),
(1929,'enUS','Bash it!','',26124),
(1930,'enUS','Me smash you!','',26124),
(1931,'enUS','Huh? What dat?','',26124),
(1932,'enUS','Intruders at the Horn!  Don\'t let them escape!!','',26124),
(1933,'enUS','Kill the intruders!','',26124),
(1934,'enUS','Never cross a Dark Iron, $C.','Never cross a Dark Iron, $C.',26124),
(1935,'enUS','Time to die, $C.','Time to die, $C.',26124),
(1936,'enUS','Feel the power of the Dark Iron Dwarves!','Feel the power of the Dark Iron Dwarves!',26124),
(1937,'enUS','For the Dragonmaw!','For the Dragonmaw!',26124),
(1938,'enUS','Your bones will break under my boot, $r!','Your bones will break under my boot, $r!',26124),
(1939,'enUS','Long live the Dragonmaw! Die you worthless $r!','Long live the Dragonmaw! Die you worthless $r!',26124),
(1940,'enUS','Brains...','Brains...',26124),
(1941,'enUS','A living $r... soon to be a dead like me.','A living $r... soon to be a dead like me.',26124),
(1942,'enUS','Time to join us, $c.','Time to join us, $c.',26124),
(1943,'enUS','Komak! I swear I\'ll have the money! Just give me some more time!','',26124),
(1944,'enUS','%s clears his throat.','',26124),
(1945,'enUS','A drink for friend Sarok and another for myself.','',26124),
(1946,'enUS','I don\'t want any trouble, Komak.','',26124),
(1947,'enUS','Sarok, why don\'t we talk business?','',26124),
(1948,'enUS','What do you want, Komak?','',26124),
(1949,'enUS','I hereby destroy these instruments of evil! For the Horde!','',26124),
(1950,'enUS','Time to brew up a Kalimdor Kocktail! Hiccup!','',26124),
(1951,'enUS','That should do it! Hiccup!','',26124),
(1952,'enUS','%s chugs his drink.','',26124),
(1953,'enUS','Hiccup!','',26124),
(1954,'enUS','Ok, who pushed me down? Was it you, $n? Someone turn the lights back on. Hiccup!','',26124),
(1955,'enUS','One more sip of the ol\' fire water and I\'ll be ready to talk. Hiccup! Cheers!','',26124),
(1956,'enUS','So, $n, I\'m ready to tell you what happened in the Swamp of Sorrows. Hiccup!','',26124),
(1957,'enUS','Strike!','',26124),
(1958,'enUS','Fight!','',26124),
(1959,'enUS','Red wins! Prepare for next round.','',26124),
(1960,'enUS','Blue wins! Prepare for the next round.','',26124),
(1961,'enUS','Now you\'re gonna get it good, $n!','',26124),
(1962,'enUS','So angry, Sarok? You shouldn\'t drink so much... Just tell us what you know about Mosarn.','',26124),
(1963,'enUS','Alright you sorry sacks of bones. Let\'s see what you\'ve got. Strike your opponent, and don\'t stop till I say so.','',26124),
(1964,'enUS','Stop! You maggots call that fighting? That is pathetic! Now put your hearts in it, you don\'t need them anymore anyway!','',26124),
(1965,'enUS','Can you see yourselves? That is the most pathetic excuse for sword slinging I\'ve ever seen! ','',26124),
(1966,'enUS','You don\'t fight for yourselves anymore, maggots! You fight for the Queen now so show me something worthy of her!','',26124),
(1967,'enUS','You\'re dead, not buried. Now show me your best!','',26124),
(1968,'enUS','These piles of wood and straw may show mercy, but the Lich King won\'t!','',26124),
(1969,'enUS','You sorry sacks of maggot flesh can do better than that, now prove it!','',26124),
(1970,'enUS','The sword isn\'t a tool, it\'s an extension of you. I expect better!','',26124),
(1971,'enUS','What do you call that? If that\'s fighting then I\'m Lothar himself!','',26124),
(1972,'enUS','Ok soldiers, take a break!','',26124),
(1973,'enUS','It has been a long time, Bethor, my friend.','',26124),
(1974,'enUS','When time permits, we must speak at length.  For we have much to discuss.','',26124),
(1975,'enUS','And thank you, $n.  Without your aid I may never have found my way to the Forsaken.','',26124),
(1976,'enUS','Farewell, my friend.','',26124),
(1977,'enUS','Lysta, summon in the captives.','',26124),
(1978,'enUS','Edward. Tyler. Prepare for your first challenge.','',26124),
(1980,'enUS','Not a challenge at all it seems. Let us see how you handle your second test. Lysta, bring forth the minions of the Lich King.','',26124),
(1981,'enUS','Now prove your worth!','',26124),
(1983,'enUS','You show some worth after all. Lysta summon a surprise for our young recruits.','',26124),
(1984,'enUS','It is time to face your final challenge young warriors! Prepare for your hardest fight yet.','',26124),
(1985,'enUS','Well done Edward and Tyler. You are progressing along in your training quite nicely. We shall test your mettle again soon.','',26124),
(1986,'enUS','Who dares summon the power of the void?','',26124),
(1987,'enUS','You will live forever in torment for this, pathetic warlock.','',26124),
(1988,'enUS','This is Dalin Forgewright. He fled from Lordaeron when the plague struck, taking his love with him.','',26124),
(1989,'enUS','And this is Comar Villard. Two weeks married, his wife was spirited away from the safety of Menethil Harbor.','',26124),
(1990,'enUS','Fools.','',26124),
(1991,'enUS','','Interesting... Now this is more than I expected. Delicious...',26124),
(1992,'enUS','When he came upon the refugees at the Greymane Wall, he felt it his duty to succor them, sending his woman on to Hillsbrad.','',26124),
(1993,'enUS','Five and five years, and he still searches for her, though she was no beauty, and there were many ladies that would take her place.','',26124),
(1994,'enUS','So what do you think of my new toy?','',26124),
(1995,'enUS','Theresa, take this to Father Lankester.','',26124),
(1996,'enUS','','',26124),
(1997,'enUS','','My Lord Abernathy sends this to you.',26124),
(1998,'enUS','','Yes My Lord.',26124),
(1999,'enUS','','My Lord. From Father Lankester.',26124),
(2000,'enUS','How do you like my pet?','',26124),
(2001,'enUS','Isn\'t she just the most amazing little creation?','',26124),
(2002,'enUS','Didn\'t I tell you my new domination techniques would work?','',26124),
(2003,'enUS','As good as I told you it would be, yes?','',26124),
(2004,'enUS','It was simple once I broke her spirit.','',26124),
(2005,'enUS','You don\'t expect me to give up all my secrets do you?','',26124),
(2006,'enUS','A little ritual torture can go a long way.','',26124),
(2007,'enUS','A little torture, a pinch of magic, and an ample helping of invasive surgery. She was conscious, of course.','',26124),
(2008,'enUS','Everyone has a weakness, it\'s just a matter of finding it.','',26124),
(2009,'enUS','I managed to discover that certain parts of the brain when removed or stimulated will make a subject much more docile. ','',26124),
(2010,'enUS','','',26124),
(2011,'enUS','Why thank you, my pet.','',26124),
(2012,'enUS','','Truly amazing, Gerard. How did you do it?',26124),
(2013,'enUS','','Amazing! How did you manage a permanent dominate?',26124),
(2014,'enUS','','I don\'t approve of your experiments, Gerard, but I must admit the results are impressive. What exactly did you do to her?',26124),
(2015,'enUS','','Astounding. You managed to dominate her, yet she retains self awareness and function. How did you do it?',26124),
(2016,'enUS','','She retains knowledge and speech, and even the self sufficiency to perform tasks for you. Precisely what did you do?',26124),
(2017,'enUS','','I\'ve never seen anything like it. No concentration or loss of awareness while the subject is dominated. What did you do to her?',26124),
(2018,'enUS','','Bravo, Gerard, you have exceeded yourself, yet again.',26124),
(2019,'enUS','','I am truly impressed, Gerard. I thought you were all talk, but I see I have been proven wrong.',26124),
(2020,'enUS','','Impressive, very impressive. Does she do tricks?',26124),
(2022,'enUS','','Very nice, Gerard. Next you will be breeding them.',26124),
(2023,'enUS','','An amazing discovery you have made. I would love an opportunity to look at all of the failed experiments.',26124),
(2024,'enUS','','I don\'t agree with your turning to alchemy to fix some of the problems, but I do agree with the results. Very well done.',26124),
(2026,'enUS','','Your pet is wonderful, Gerard, but she needs a collar with a bell I think.',26124),
(2027,'enUS','','Did you have to house train her, Gerard?',26124),
(2028,'enUS','Ugh! What is that scoundrel doing sending his vermin to me? Get out of my sight before I take what is left of your life. And take this with you.','',26124),
(2029,'enUS','','Ahh there it is.',26124),
(2030,'enUS','','\"Magical Flows and How They Effect the World\", by Maginor Dumas. That\'s the one I was looking for.',26124),
(2031,'enUS','','I really need a better system for filing these books. Ahh that\'s the one I wanted.',26124),
(2032,'enUS','','\"Khadgar\'s Mystical Journal, Volume 8.\" I think this is the one I wanted.',26124),
(2033,'enUS','','Ahh, \"Mystical Conjurings of the Archmages of Dalaran.\" Perfect.',26124),
(2034,'enUS','','If I could just find \"Magic and the Ways of Power\". Ahh here it is, what was it doing over here?',26124),
(2035,'enUS','','\"Magic Maladies\", no. \"Magic Matricies\", no. Ahh here we go \"Magic Mysteries\".',26124),
(2036,'enUS','','There\'s the mystical tome I was looking for.',26124),
(2037,'enUS','','Yes, yes. Hmm, it seems to cross reference another tome. Guess I have to find that one too.',26124),
(2038,'enUS','','That wasn\'t very helpful. Let me check the other one.',26124),
(2039,'enUS','','That\'s what I wanted to know. Now I just need to find where the flux variance is discussed.',26124),
(2040,'enUS','','Very interesting. But if that\'s the case then my theory is wrong. I must reread the other sections to see what I missed.',26124),
(2041,'enUS','','So I was right about the energies. Let\'s see what the other tome has to say on the subject.',26124),
(2042,'enUS','','If this is correct then I have a lot more research to do.',26124),
(2043,'enUS','','But this can\'t be right. Where did I put that other book?',26124),
(2044,'enUS','','Back to the drawing board.',26124),
(2045,'enUS','Hah!  Let us see the wooden human wave!','',26124),
(2046,'enUS','Hahah!  That was funny!  Funny wooden human!','',26124),
(2047,'enUS','%s laughs.','',26124),
(2048,'enUS','Hold, $n!  I\'m guarding these barrels, so ... look, but don\'t touch!','',26124),
(2049,'enUS','','If you\'re here, then it means you are prepared to begin the study of summoning demonic cohorts to do your bidding. We will start with the lowliest creatures you will be able to call and continue from there. Let us begin.',26124),
(2050,'enUS','','The easiest creature for you to summon is the imp. You should already be able to bring forth this minion but for completeness\' sake I will start with him.',26124),
(2051,'enUS','','This foul little beast is the imp. It is small and weak, making it almost useless as a meatshield, and its damage output is mediocre at best. This creature is best used for support of a larger group.',26124),
(2052,'enUS','','Now that you have had a chance to study the imp, let us move on to the next minion you will be able to summon, the voidwalker.',26124),
(2053,'enUS','','This demonic entity is known as the Voidwalker. Its strength and endurance are significant, making it ideal for defense. Send it to attack your enemy, then use it as a shield while you use your spells and abilities to drain away your opponent\'s life.',26124),
(2054,'enUS','','If you\'ve never seen one, it is a sight to behold. A very impressive creature both on and off the field of battle. Next, let us take a look at what I am sure all you male students have been waiting for. The succubus.',26124),
(2055,'enUS','','All right now. Aside from the obvious distractions a minion like this will provide against your more masculine foes, she is also capable of dealing out impressive amounts of damage. However, her fragile endurance makes her almost useless as a shield.',26124),
(2056,'enUS','','Study hard and you might one day be able to summon one on your own, but for now it\'s time to move on to the felhunter.',26124),
(2057,'enUS','','What you see before you is a felhunter. This creature\'s natural talents include spell lock and other abilities which make it unequalled when facing a magically attuned opponent.',26124),
(2058,'enUS','','When facing a spellcaster of any kind, this feral beast will be your best friend. Now, let us take a look at something a bit different. This next creature will aid your travels and make your future journeys much easier. Let\'s take a look at a felsteed.',26124),
(2059,'enUS','','I doubt you have had much occasion to see such a creature. These demonic equines will make your travels much faster by acting as your mount as long as you control them. However, they are difficult to control, so be sure you are ready before attempting it.\n',26124),
(2060,'enUS','','There you have it. Our lesson on summoning has come to an end. A new class will begin shortly, so if you wish to brush up, feel free to stay around.',26124),
(2061,'enUS','Hmm, it would seem Keever needs a new subject. If that fool Abernathy keeps taking Keever\'s subjects, Keever may have to have a word with him.','',26124),
(2062,'enUS','Ahh, there we go. Now, Keever must try this vial and see if it works.','',26124),
(2063,'enUS','Not what Keever was hoping for. Keever may have added too much earthroot. Let\'s see if the second serum will do what Keever needs.','',26124),
(2064,'enUS','%s pokes the small toad.','',26124),
(2065,'enUS','%s feeds the toad some of the strange liquid.','',26124),
(2066,'enUS','%s pokes the small fuzzy squirrel with obvious disappointment.','',26124),
(2067,'enUS','Well, that is just not right. The creature is far too small. Let us see what Keever\'s third batch will do.','',26124),
(2068,'enUS','%s feeds the squirrel some of the viscous fluid.','',26124),
(2069,'enUS','%s pokes the skittish rabbit.','',26124),
(2070,'enUS','Keever is unhappy with this. Perhaps if Keever were to try a larger dose, that may fix this dilemma.','',26124),
(2071,'enUS','%s grabs the rabbit and pours the fluid down its throat, then sets it back inside the cage.','',26124),
(2072,'enUS','What is this? Did Keever ask for a sheep? Keever wanted a weapon of great power and all he got was this sheep. Keever is very disappointed.','',26124),
(2073,'enUS','%s pokes the wooly sheep repeatedly.','',26124),
(2074,'enUS','Keever is most pleased.','',26124),
(2075,'enUS','%s forces the fluid down the weary man\'s throat.','',26124),
(2076,'enUS','%s whispers to $n the secret to opening his strongbox.','',26124),
(2077,'enUS','$n! THIS AREA IS OFF LIMITS!','$n! THIS AREA IS OFF LIMITS!',26124),
(2078,'enUS','Now let\'s try it...','',26124),
(2079,'enUS','Ugh!  That\'s terrible!','',26124),
(2080,'enUS','%s follows $n.','',26124),
(2081,'enUS','%s lets out a shriek, calling for help!','%s lets out a shriek, calling for help!',26124),
(2082,'enUS','%s begins to make a copy of itself!','',26124),
(2083,'enUS','Never cross a Dwarf!','Never cross a Dwarf!',26124),
(2084,'enUS','For the glory of Ironforge!','For the glory of Ironforge!',26124),
(2085,'enUS','This should only take a moment, $n.','',26124),
(2086,'enUS','I can\'t believe it! You\'ve destroyed my pack... Now face my wrath!','',26124),
(2087,'enUS','I call your true name, Azrethoc. Show your visage to me!','',26124),
(2088,'enUS','You scum aren\'t even worth my time.  Destroy them, my pack!','',26124),
(2089,'enUS','Pathetic Forsaken weakling. You wish to see my master? So be it.','',26124),
(2090,'enUS','Who dares to seek me out?!','',26124),
(2091,'enUS','Insects!','',26124),
(2092,'enUS','Come! Come to your deaths--if you dare!','',26124),
(2093,'enUS','Yes, come. My master and I shall be waiting.','',26124),
(2094,'enUS','An interesting turning of events.','',26124),
(2101,'enUS','At last! Naralex can be awakened! Come aid me, brave adventurers!','',26124),
(2102,'enUS','Intruders have assaulted our lair.  Be on your guard!','',26124),
(2103,'enUS','We must go and gather with the other Disciples. There is much work to be done before I can make another attempt to restore the Barrens. Farewell, brave souls!','',26124),
(2104,'enUS','For the Warchief!','For the Warchief!',26124),
(2105,'enUS','Backhands $n solidly across the face.','Backhands $n solidly across the face.',26124),
(2106,'enUS','Stay down, Wretch!','Stay down, Wretch!',26124),
(2107,'enUS','%s lets out a tremendous roar, alerting nearby enemies!','',26124),
(2108,'enUS','to arms laddies!','',26124),
(2121,'enUS','Hey, there\'s one!','',26124),
(2122,'enUS','Ooh, it\'s a nice one! Let me just dig it up...','',26124),
(2123,'enUS','I\'ve never seen something like this before! Look at the extension of the jawbone...','',26124),
(2124,'enUS','And they\'re off!','',26124),
(2125,'enUS','%s goes into a rage!','',26124),
(2126,'enUS','Must be careful not to damage the specimen...','',26124),
(2127,'enUS','Over there! Can it be?','',26124),
(2128,'enUS','Either that\'s a prime kodo bone or it\'s time I got my goggles!','',26124),
(2129,'enUS','Oooh, this looks promising...','',26124),
(2130,'enUS','I\'ve never seen one this size before! I can\'t wait to send it back for research...','',26124),
(2131,'enUS','I\'ll just label it for reference then dig it up.','',26124),
(2132,'enUS','Must be very careful with this one... Very delicate.','',26124),
(2133,'enUS','I would never have expected to find something in such perfect condition.','',26124),
(2134,'enUS','It\'s a little damaged, but I should still be able to get some good information from this.','',26124),
(2135,'enUS','You\'ve been such an unbelievably big help! These bones are going to unlock so much new information and help me futher my research.','',26124),
(2136,'enUS','I\'ll follow you back to the camp. If you speak with my assistant, Hornizz, he\'ll have your payment.','',26124),
(2137,'enUS','Torta, my love! I have returned at long last.','',26124),
(2138,'enUS','You have any idea how long I\'ve been waiting here? And where\'s dinner? All that time gone and nothing to show for it?','',26124),
(2139,'enUS','My dearest Torta, I have been gone for so long. Finally we are reunited. At long last our love can blossom again.','',26124),
(2140,'enUS','Enough with the rambling. I am starving! Now, get your dusty shell into that ocean and bring momma some grub.','',26124),
(2141,'enUS','Yes, Torta. Whatever your heart desires...','',26124),
(2142,'enUS','I am eternal fire. I am forever reborn and I will be the light that will guide you when it is most cold.','',26124),
(2143,'enUS','','Elune be with us! Let\'s make haste from this evil fortress.',26124),
(2144,'enUS','','I will hurry back to Vahlarriel. Finish off those that you can--I should be fine on my own from here.',26124),
(2145,'enUS','And try not to get lost this time....','',26124),
(2161,'enUS','I got some great samples, Hornizz. I\'m going to get to work on them. Can you take care of the rest?','',26124),
(2162,'enUS','Uh oh! My tools\' have run out. We\'re going to have to start over...','',26124),
(2181,'enUS','May your spirit burn brightly, $n.','',26124),
(2182,'enUS','','Your spirit is pure, $n.',26124),
(2183,'enUS','Strength and endurance; patience and wisdom--remember these things always, $n.','',26124),
(2184,'enUS','','Peace and patience be with you, $n. Remain strong always.',26124),
(2201,'enUS','Ok, enough!  I give up!','',26124),
(2202,'enUS','Better luck next time, $n.','',26124),
(2203,'enUS','You win, $n.  You win!','',26124),
(2221,'enUS','Do we have much further to go?','',26124),
(2222,'enUS','I\'m thirsty.','',26124),
(2223,'enUS','Are we there yet?','',26124),
(2224,'enUS','I keep getting sand stuck in my toes.','',26124),
(2225,'enUS','How much further to go?','',26124),
(2226,'enUS','I wish you could just pick me up and carry me.','',26124),
(2227,'enUS','Have you heard the one about the ogre, the goblin and the pit lord?','',26124),
(2228,'enUS','Torta must be so worried.','',26124),
(2229,'enUS','','A fine trophy your head will make, $R.',26124),
(2230,'enUS','','My talons will shred your puny body, $R.',26124),
(2231,'enUS','','You will be easy prey, $C.',26124),
(2241,'enUS','Aku\'mai needs more innocents to be satisfied.','Aku\'mai needs more innocents to be satisfied.',26124),
(2242,'enUS','Only the blood of an innocent can quench Aku\'mai\'s hunger.','Only the blood of an innocent can quench Aku\'mai\'s hunger.',26124),
(2243,'enUS','Soon we shall bring about the return of the old gods.','Soon we shall bring about the return of the old gods.',26124),
(2244,'enUS','Aku\'mai is sure to summon the old gods for us.  If only we can provide enough innocents to satisfy his hunger.','Aku\'mai is sure to summon the old gods for us.  If only we can provide enough innocents to satisfy his hunger.',26124),
(2245,'enUS','Say that is a nice looking outfit you got there.','Say that is a nice looking outfit you got there.',26124),
(2261,'enUS','Good luck, $n!','',26124),
(2281,'enUS','Thank you, $G lad:lass;. Thank you, greatly.','',26124),
(2282,'enUS','Hamhock in trouble! Hamhock need help!','',26124),
(2283,'enUS','Thank ye, $G lad:lass;. Thank ye, greatly.','',26124),
(2284,'enUS','Thanks to you, $n.','',26124),
(2285,'enUS','The Light be with ya, $n.','',26124),
(2286,'enUS','Yer a blessing fer sure, $n. Thank you.','',26124),
(2301,'enUS','The Affray has begun.  $n, get ready to fight!','',26124),
(2302,'enUS','Farewell, $n.  And remember, a warrior never shows his back to his foe!','',26124),
(2303,'enUS','%s begins to work...','',26124),
(2304,'enUS','$n!  I\'m finished!','',26124),
(2305,'enUS','Thank you, $n.  And good luck!','',26124),
(2306,'enUS','%s begins crafting...','',26124),
(2307,'enUS','It is done.  I have your weapon, $n.','',26124),
(2308,'enUS','$n ran the Gauntlet!  Three cheers for $n!','',26124),
(2309,'enUS','Hip hip, hoorah!','',26124),
(2310,'enUS','A thousand years ago, the immortal elves, demigods of the forest and dragons fought against the Legion on the slopes of Hyjal.','',26124),
(2311,'enUS','Anathera and Latherion fought back to back where the battle was thickest. Two lovers determined to survive the war together.','',26124),
(2312,'enUS','But it was not to be. As their foes pressed close, Anathera\'s armor was pierced by a demon\'s tainted blade. In the thick of battle, there would be nothing to save her.','',26124),
(2313,'enUS','Anathera!','',26124),
(2314,'enUS','Ignoring the battle that raged about him, Latherion dropped his guard to cradle his love in her dying moments. But the demons gave him no quarter, and quickly laid him low.','',26124),
(2315,'enUS','Anathera... I cannot bear to face the rest of eternity without you by my side... If you are taken from me, then let this be the day I also return to the earth...','',26124),
(2316,'enUS','','So this... this is how it ends, my love...',26124),
(2317,'enUS','Where the two lovers fell, a tree would bloom. The elves call it the heartswood. It will surely serve your ends.','',26124),
(2318,'enUS','You!  Enter the fray!','',26124),
(2319,'enUS','The first stage is over.  Big Will... come on down!','',26124),
(2320,'enUS','The Affray is over!','',26124),
(2321,'enUS','%s sees the Overseer die and runs in fear!','',26124),
(2341,'enUS','%s begins to work...','',26124),
(2342,'enUS','Finished!  And the results are amazing.  I must convey them to my associates Grimand, Mathiel and Klockmort!','',26124),
(2343,'enUS','Your armor is ready, $n.','',26124),
(2344,'enUS','%s begins to work...','',26124),
(2345,'enUS','Hooray hooray! $n! It\'s done!','',26124),
(2346,'enUS','%s begins to work...','',26124),
(2347,'enUS','Amazing!  It worked!  $n, I have your armor.','',26124),
(2348,'enUS','%s begins to work...','',26124),
(2349,'enUS','It is done.  $n, your armor is ready.','',26124),
(2351,'enUS','Good luck, $n. And remember, find Muiredon once you\'ve accomplished the task.','',26124),
(2353,'enUS','Good luck to you, $n. And don\'t forget... get that script before finding Gazin.','',26124),
(2354,'enUS','Hail $n!  New Champion of The Affray!','',26124),
(2355,'enUS','Challenger is down!','',26124),
(2356,'enUS','%s is demoralized and runs!','',26124),
(2357,'enUS','','Oh, my love! No! Don\'t let me die without you...',26124),
(2358,'enUS','','We\'ve done it! We won!',26124),
(2359,'enUS','','You won\'t ruin my lands, you scum!',26124),
(2360,'enUS','','To the house! Stay close to me, no matter what! I have my gun and ammo there!',26124),
(2361,'enUS','This place is safe for the Defias to take over! Get the others.','This place is safe for the Defias to take over! Get the others.',26124),
(2362,'enUS','First Westfall, next, all of Stormwind!','First Westfall, next, all of Stormwind!',26124),
(2363,'enUS','No farm woman can stand against the Defias!','No farm woman can stand against the Defias!',26124),
(2364,'enUS','','We\'ve done it! We\'ve done it! We\'ve driven them off!',26124),
(2366,'enUS','Kill her! Take the farm!','Kill her! Take the farm!',26124),
(2367,'enUS','%s\'s body falls to the ground, a lifeless heap.','',26124),
(2368,'enUS','','Don\'t wander too far. I\'m sure there are more of them out there.',26124),
(2369,'enUS','','One more down!',26124),
(2370,'enUS','I hope you\'re ready, $n. Follow me.','',26124),
(2371,'enUS','','',26124),
(2372,'enUS','','The Light is with us this day!',26124),
(2373,'enUS','','Last time they attacked, there was only one attack. I wouldn\'t be surprised if there were more this time.',26124),
(2374,'enUS','Come, my acolytes. Take the rods of channeling and create the greater summoning circle.','',26124),
(2381,'enUS','The felhunter approaches! Be on your guard!','',26124),
(2382,'enUS','%s begins a spell of summoning...','',26124),
(2383,'enUS','Follow, $n.  I will soon begin the summoning...','',26124),
(2384,'enUS','%s goes into a frenzy!','%s goes into a frenzy!',26124),
(2401,'enUS','Don\'t forget the orphans of Stormwind!','',26124),
(2402,'enUS','Help the children of Stormwind... victims of the war and plague!','',26124),
(2403,'enUS','Give to the charities who seek to help the victims of these hard times! Please.','',26124),
(2404,'enUS','Give of your hearts and your purses! Give to the children of Stormwind who have lost their parents.','',26124),
(2406,'enUS','Aku\'mai demands more sacrifices!','Aku\'mai demands more sacrifices!',26124),
(2407,'enUS','Intruders!  The Hammer shall fall upon you.','Intruders!  The Hammer shall fall upon you.',26124),
(2408,'enUS','The Old Gods will be restored.  You will not be allowed to interfere!','The Old Gods will be restored.  You will not be allowed to interfere!',26124),
(2409,'enUS','Your blood shall be the catalyst for the Old Gods\' return!','Your blood shall be the catalyst for the Old Gods\' return!',26124),
(2410,'enUS','We are quite safe from your pitiful band!','',26124),
(2411,'enUS','I shall rip your guts out!','',26124),
(2412,'enUS','Your eyes will make pretty baubbles!','',26124),
(2421,'enUS','Ready when you are, warrior.','',26124),
(2422,'enUS','No gnome will be left behind.','No gnome will be left behind.',26124),
(2423,'enUS','The troggs...they never stop coming.  Die trogg!  Die!','The troggs...they never stop coming.  Die trogg!  Die!',26124),
(2424,'enUS','This sickness clouds my vision, but I know you must be a trogg.  Die foul invader!','This sickness clouds my vision, but I know you must be a trogg.  Die foul invader!',26124),
(2425,'enUS','A foul trogg if ever I saw one.  Die!','A foul trogg if ever I saw one.  Die!',26124),
(2426,'enUS','Please be patient, we will call your name when it is your turn. We are helping people in the order they appear to us on our screen.','',26124),
(2427,'enUS','Remember, if you harass the rep or spam the channel, your account may be kicked, banned, or worse.','',26124),
(2428,'enUS','I am a BOT. I have tons of information. To find out what I know, whisper me.','',26124),
(2429,'enUS','You are welcome, have a nice day.','',26124),
(2430,'enUS','There is no COW level... really! I repeat: there is no COW level. Well, maybe there is...','',26124),
(2431,'enUS','Techbot is sensitive and those words hurt my ears. :[ Please be nice to me. \nI just want to help.','',26124),
(2433,'enUS','People think I like corndogs, but actually, they give me indigestion!','',26124),
(2434,'enUS','When the rep is talking to you, he will start each line with your name.  If you don\'t see your name, he\'s not yet speaking to you.','',26124),
(2435,'enUS','Some topics I can help you with are: | drivers | commands | lag | bots... zzzttt!','',26124),
(2436,'enUS','Please be patient, we will call your name when it is your turn. We are helping people in the order they appear to us on our screen. $n!','',26124),
(2437,'enUS','I love you too. :)','',26124),
(2438,'enUS','If you have been muted, or have questions about the Muting/UnMuting process, please visit... zzzttt!!','',26124),
(2441,'enUS','%s lets out a massive roar, calling for aid!','',26124),
(2461,'enUS','It\'s good to be your own boss!$B$BHey could you spare a couple copper for a sandwich? I\'m starved.','',26124),
(2463,'enUS','See, the Venture Company\'s new shredder is better than my latest, from the interchangeable hands to the control grips!$b$bMy boss has given me a pretty strict deadline, but my boys and I couldn\'t come up with anything. Nothing was working, so we decided to \"borrow\" one of their prototypes. I sent Wizzlecrank to the Sludge Fen to steal one, but he hasn\'t gotten back yet!','See, the Venture Company\'s new shredder is better than my latest, from the interchangeable hands to the control grips!$b$bMy boss has given me a pretty strict deadline, but my boys and I couldn\'t come up with anything. Nothing was working, so we decided to \"borrow\" one of their prototypes. I sent Wizzlecrank to the Sludge Fen to steal one, but he hasn\'t gotten back yet!',26124),
(2464,'enUS','I used to direct Steamwheedle\'s shredder development program, but last month I struck out on my own. Now all my suppliers have blacklisted me. Worse, my development efforts haven\'t even gotten off the ground yet. I could use your help, $n!','',26124),
(2465,'enUS','I figured I would step up my research efforts by, uh, \'borrowing\' some technology from the Venture Company. See, their new shredder is best of breed, from the interchangeable hands to the control grips!$B$BMy business partner Wizzlecrank is west of here in the Sludge Fen doing some \'Field Research\' for me, but he hasn\'t gotten back yet. ','',26124),
(2466,'enUS','How can I help?','How can I help?',26124),
(2467,'enUS','Come closer, young one.  In my time I could hear the flutter of a prey\'s beating heart, but now you must speak up if you want your words heard.','',26124),
(2469,'enUS','Tell me a story, Skorn.','Tell me a story, Skorn.',26124),
(2470,'enUS','You killed Ghost Howl.  You\'re a stud!','',26124),
(2471,'enUS','I have run through these plains for many, many seasons.  And I have hunted great beasts.  And I had never been bested... until I faced Ghost Howl.$B$BLong ago, the massive wolf was an ally to the tauren and fought bravely against the Burning Legion.  But he was wounded savagely by a demon, and the tear in his flesh never healed.  Eventually... it drove Ghost Howl mad.$B$BNow he roams the plains in agony, seeking an end to his pain.  To my shame, when we fought I lacked the strength to slay him...','',26124),
(2481,'enUS','%s lets out a high pitched screech, calling for help!','%s lets out a high pitched screech, calling for help!',26124),
(2482,'enUS','','No! The Defias will surely take the farm now!',26124),
(2501,'enUS','Let\'s get to work, $n!','',26124),
(2502,'enUS','Greetings mage.  Shall I provide you with further insight into the world of magic?','Greetings mage.  Shall I provide you with further insight into the world of magic?',26124),
(2503,'enUS','Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.','Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.',26124),
(2504,'enUS','Here you are, $n.','',26124),
(2507,'enUS','','Greetings.  I\'m a female mage trainer, and you\'re a mage.',26124),
(2521,'enUS','I thank the Light for this blessing. May it be used for justice and to defend all good creatures.','',26124),
(2522,'enUS','I am interested in mage training.','I am interested in mage training.',26124),
(2523,'enUS','Greetings.  Have you come to master matters magical?','Greetings.  Have you come to master matters magical?',26124),
(2524,'enUS','Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.','Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.',26124),
(2525,'enUS','Greetings.  I\'m a gnome mage trainer, and you\'re a mage.','Greetings.  I\'m a gnome mage trainer, and you\'re a mage.',26124),
(2526,'enUS','Well met, $c.  You want some advice?  Befriend a mage!  We have a trick or two up our sleeves, we do...','Well met, $c.  You want some advice?  Befriend a mage!  We have a trick or two up our sleeves, we do...',26124),
(2527,'enUS','Greetings.  I\'m an undead mage trainer, and you\'re a mage.','Greetings.  I\'m an undead mage trainer, and you\'re a mage.',26124),
(2528,'enUS','Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.','Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.',26124),
(2529,'enUS','Greetings, $c.  Are you here to learn of the hidden arts?','Greetings, $c.  Are you here to learn of the hidden arts?',26124),
(2530,'enUS','Greetin\'s, $c.  I be pityin\' your kind, for de secrets of true magic are beyond ya...','Greetin\'s, $c.  I be pityin\' your kind, for de secrets of true magic are beyond ya...',26124),
(2541,'enUS','%s calls for help!','%s calls for help!',26124),
(2542,'enUS','Greetings.  I\'m a warlock trainer, and you\'re a warlock.','Greetings.  I\'m a warlock trainer, and you\'re a warlock.',26124),
(2543,'enUS','Greetings.  I\'m a warlock trainer, but you\'re not a warlock!','Greetings.  I\'m a warlock trainer, but you\'re not a warlock!',26124),
(2544,'enUS','I am interested in warlock training.','I am interested in warlock training.',26124),
(2545,'enUS','','It is not yet your time. I shall aid your journey back to the realm of the living... for a price.',26124),
(2546,'enUS','With the sanction of Lady Sylvanas, the Deathstalkers\' numbers grow. More blades to strike at our enemies when they least expect it.','With the sanction of Lady Sylvanas, the Deathstalkers\' numbers grow. More blades to strike at our enemies when they least expect it.',26124),
(2547,'enUS','Return me to life.','Return me to life.',26124),
(2548,'enUS','I would like to train.','I would like to train.',26124),
(2549,'enUS','Here\'s another load for ya!','',26124),
(2550,'enUS','%s sets the load of wood down with a heavy thud.','',26124),
(2551,'enUS','A\'ight, just put it down over there and I will get to it.','',26124),
(2552,'enUS','%s cuts and shapes the logs into smooth wooden planks.','',26124),
(2553,'enUS','%s is sucked into the coffer!','',26124),
(2561,'enUS','Banker option','Banker option',26124),
(2562,'enUS','vendor option','vendor option',26124),
(2563,'enUS','taxi option','taxi option',26124),
(2564,'enUS','%s escapes into the void!','',26124),
(2565,'enUS','%s is pulled by magic!','',26124),
(2566,'enUS','Astor? Taken your bloody time getting here, so let\'s not waste any time, shall we?','',26124),
(2567,'enUS','Now which one of these did I put it in...','',26124),
(2568,'enUS','Ah, here it is.','',26124),
(2569,'enUS','You will talk eventually.  You might as well spill it now.','You will talk eventually.  You might as well spill it now.',26124),
(2570,'enUS','Confess and we shall set you free.','Confess and we shall set you free.',26124),
(2571,'enUS','What?  Oh no, I don\'t care what you have to say.  I just enjoy inflicting pain.','What?  Oh no, I don\'t care what you have to say.  I just enjoy inflicting pain.',26124),
(2582,'enUS','I\'m a cloth vendor, and this is my default greeting.','I\'m a cloth vendor, and this is my default greeting.',26124),
(2583,'enUS','I would like to buy from you.','I would like to buy from you.',26124),
(2584,'enUS','I am an undead cloth vendor, and this is my greeting text.','I am an undead cloth vendor, and this is my greeting text.',26124),
(2585,'enUS','Welcome, and feel free to examine my goods.  Other than the moldy smell, they are in perfect condition.','Welcome, and feel free to examine my goods.  Other than the moldy smell, they are in perfect condition.',26124),
(2586,'enUS','I am interested in tailor training.','I am interested in tailor training.',26124),
(2587,'enUS','I am a troll tailor trainer, and this is my default greeting.','I am a troll tailor trainer, and this is my default greeting.',26124),
(2588,'enUS','What do you want, $c? I\'m running late, and my employer doesn\'t look kindly on tardiness.','',26124),
(2589,'enUS','You\'re Astor Hadren, right?','You\'re Astor Hadren, right?',26124),
(2590,'enUS','Yes, I am. What\'s it to you?','',26124),
(2591,'enUS','You\'ve got something I need, Astor. And I\'ll be taking it now.','You\'ve got something I need, Astor. And I\'ll be taking it now.',26124),
(2592,'enUS','','Prepare yourself, $n.  I go to open the rift...',26124),
(2601,'enUS','Argh! What was that? It\'s not supposed to work like this!','',26124),
(2602,'enUS','The Shattered Hand will see the Horde to their former glory.','The Shattered Hand will see the Horde to their former glory.',26124),
(2603,'enUS','I would like training.','I would like training.',26124),
(2621,'enUS','Mennet said I should ask you for a set of thieves\' tools.','Mennet said I should ask you for a set of thieves\' tools.',26124),
(2622,'enUS','','Let me go get you a set of tools, $n.',26124),
(2623,'enUS','','Ah, here\'s one.',26124),
(2624,'enUS','','Good luck out there, $n.',26124),
(2625,'enUS','You carry the taint of the Scourge.  Prepare to enter the Twisting Nether.','You carry the taint of the Scourge.  Prepare to enter the Twisting Nether.',26124),
(2626,'enUS','There is no escape for you.  The Crusade shall destroy all who carry the Scourge\'s taint.','There is no escape for you.  The Crusade shall destroy all who carry the Scourge\'s taint.',26124),
(2627,'enUS','The Light condemns all who harbor evil.  Now you will die!','The Light condemns all who harbor evil.  Now you will die!',26124),
(2628,'enUS','The Scarlet Crusade shall smite the wicked and drive evil from these lands!','The Scarlet Crusade shall smite the wicked and drive evil from these lands!',26124),
(2629,'enUS','','Gird yourself, $n, for the demon in this orb is a fel beast.',26124),
(2630,'enUS','I need another set of tools.','I need another set of tools.',26124),
(2631,'enUS','Hah!  Eternal undeath to the cursed Agamands!','',26124),
(2632,'enUS','Thank you, $n.  You have tempered the cold rage in my heart.','',26124),
(2633,'enUS','If Gnoarn finds out about this, it\'ll be my hide!','',26124),
(2634,'enUS','Your armor is ready, $n.','',26124),
(2635,'enUS','I have completed your helm, $n.','',26124),
(2641,'enUS','What\'s a young $c like you out visiting an old farmer like me?','',26124),
(2642,'enUS','If Therzok\'s sent you, tell him no, I won\'t go back to work for him, no matter how many times he asks.','',26124),
(2643,'enUS','I need another set of thieves\' tools.','I need another set of thieves\' tools.',26124),
(2644,'enUS','','%s begins to craft...',26124),
(2645,'enUS','','I have finished your leg guards, $n.',26124),
(2646,'enUS','I am done.  Your armor is ready, $n.','',26124),
(2647,'enUS','','These are fine pieces, $n.  Let me get started on your robe.',26124),
(2648,'enUS','','That\'s it!  It\'s all finished, $n.',26124),
(2649,'enUS','','Ok, let\'s get to work!',26124),
(2650,'enUS','','Aha!  There it is.',26124),
(2651,'enUS','','Now where did I put that silver spool...',26124),
(2652,'enUS','Harroc, get a box of tools for, $n.','',26124),
(2653,'enUS','Right away, Rokar.','',26124),
(2654,'enUS','There you go. I need to get back to work before Rokar clouts me again for being lazy.','',26124),
(2655,'enUS','Release the hounds!','',26124),
(2656,'enUS','','I just have one thing to check...',26124),
(2657,'enUS','','That\'s it!  It worked!',26124),
(2658,'enUS','','Thanks for your patience, $n.',26124),
(2659,'enUS','','I\'ll just keep this here until we need it...',26124),
(2660,'enUS','Naralex sleeps again!$b$bLong ago, Naralex journeyed to this cavern with the honorable goal of entering the Emerald Dream and regrowing the Barrens into a lush forest. His focus waned and his thoughts became tainted by serpentine visions.$b$bNow, reptilian beasts seep from his dreams to the land. He must be awoken from the nightmare or he will be forever lost, and a great evil unleashed.$b$bOnly after his corrupted servants, the Fanglords, have been slain can I perform the awakening ritual.\n\n','',26124),
(2661,'enUS','The Fanglords are dead! All hope is not lost!$b$bThe awakening ritual is quite complex, however. It cannot be done alone.$b$bI will handle all of the necessary preparations but I will need you to protect me. The nightmares summoned from Naralex\'s journey through the Emerald Dream prove to be quite formidable. Without your help, this mission is doomed.$b$bWhen you are ready to defend me, say the word, and I shall lead the way to Naralex\'s chamber.','',26124),
(2662,'enUS','Let the event begin!','Let the event begin!',26124),
(2663,'enUS','','Ok, let\'s get this orb made...',26124),
(2664,'enUS','','All right.  It\'s made!',26124),
(2665,'enUS','I shall now begin the robe...','',26124),
(2666,'enUS','Your robe is complete, $n.','',26124),
(2681,'enUS','','Here, $n.  Take a chest of containment coffers and a cantation of manifestation.  You will need them for your mission.',26124),
(2682,'enUS','','Take a chest of containment coffers and a cantation of manifestation, $n.  You will need them for your mission.',26124),
(2701,'enUS','%s sets down the refined wood planks.','',26124),
(2702,'enUS','The machine adjusts to face you.$B$BOn the back of the machine is an empty, oddly misshapen slot with an engraving that reads: \"Propirtee o\' Cap\'n Gelkak Gyromast\"','',26124),
(2703,'enUS','Turn the key to start the machine.','Turn the key to start the machine.',26124),
(2704,'enUS','YARRR! Swabie, what have ye done?! He\'s gone mad! Baton down the hatches! Hoist the mast! ARRRR! Every man for hi\'self!','',26124),
(2705,'enUS','I\'m \"Plucky\" Johnson, and this is my default greeting.','',26124),
(2706,'enUS','Hey!  Are you on an errand for Tirth?  If I were you I\'d get as far away from him as I could!  His mind\'s been pickled from too much drink but his magic\'s as strong as ever!','',26124),
(2707,'enUS','Tell me the phrase to Tirth\'s lockbox.','Tell me the phrase to Tirth\'s lockbox.',26124),
(2708,'enUS','','Stand back, and ... hold your breath.  I haven\'t done this in a while.',26124),
(2709,'enUS','','It worked!  Amazing!  I guess I haven\'t lost my touch...',26124),
(2721,'enUS','Sure, I\'ll tell you the phrase.  As long as I don\'t have to go anywhere near Tirth!','',26124),
(2722,'enUS','Don\'t tell Tirth I\'m still here.  If he finds out I haven\'t left the Shimmering Flats, I\'ll be running his errands and cleaning his dirty laundry forever!','',26124),
(2741,'enUS','Gelkak\'s key slides into the vacant slot.','',26124),
(2742,'enUS','Do you mock me while I am unable to defend myself, bound to this ball of iron?','',26124),
(2743,'enUS','How can I free you?','How can I free you?',26124),
(2744,'enUS','One of the humans has the key to this infernal contraption. Eston I think they said his name was.','',26124),
(2745,'enUS','Get away from here, $c, or they\'ll put you in chains as well.','',26124),
(2746,'enUS','Where is the key to this lock?','Where is the key to this lock?',26124),
(2747,'enUS','Marlgen... One of the jailors. He has the key to my bonds.','',26124),
(2748,'enUS','Good day citizen.  How may I assist you?','Good day citizen.  How may I assist you?\n',26124),
(2749,'enUS','Bank of Stormwind','Bank of Stormwind',26124),
(2750,'enUS','The bank is located in the Trade District just northwest of the city gates. Here, let me show you on your map.','The bank is located in the Trade District just northwest of the city gates. Here, let me show you on your map.',26124),
(2751,'enUS','I wish the snow would just all melt away. It\'s always getting my robe wet and messing up everything!','',26124),
(2752,'enUS','Stupid snow... Hey, you\'re, $n, aren\'t you? I\'ve just received a message asking for you.','',26124),
(2753,'enUS','What message?','What message?',26124),
(2754,'enUS','You\'ve been summoned by Lago Blackwrench, warlock master of Ironforge. You\'d do yourself well to report to him immediately. You\'ll find him in the Forlorn Cavern district of the city.','',26124),
(2755,'enUS','Greetings $R, I am Tharnariun Treetender.','',26124),
(2756,'enUS','I require training.','I require training.',26124),
(2757,'enUS','The animal looks confused.','',26124),
(2761,'enUS','One moment while I stitch this together...','',26124),
(2762,'enUS','There.  I am finished with your robe, $n.','',26124),
(2763,'enUS','%s whispers into $n\'s ear.','',26124),
(2764,'enUS','If you ask me, I think the goblins are a shoe in.  We have the tools, and we have the talent!','If you ask me, I think the goblins are a shoe in.  We have the tools, and we have the talent!',26124),
(2765,'enUS','If it weren\'t for that cursed, gnomish luck, they\'d never win a race!','If it weren\'t for that cursed, gnomish luck, they\'d never win a race!',26124),
(2766,'enUS','If I were you, I\'d buy a goblin race voucher.  Rooting for the other team is a waste of time.','If I were you, I\'d buy a goblin race voucher.  Rooting for the other team is a waste of time.',26124),
(2767,'enUS','My money\'s on the goblins!  And if you have any sense then yours is too!','My money\'s on the goblins!  And if you have any sense then yours is too!',26124),
(2768,'enUS','I heard they were going to try to blow up the gnome\'s car in the next race!  True or not, I\'d stand clear of their pit area.','I heard they were going to try to blow up the gnome\'s car in the next race!  True or not, I\'d stand clear of their pit area.',26124),
(2769,'enUS','Where is Tirth\'s assistant?','Where is Tirth\'s assistant?',26124),
(2773,'enUS','Oh, you mean Johnson?  I heard he\'s in hiding.','Oh, you mean Johnson?  I heard he\'s in hiding.',26124),
(2774,'enUS','If it weren\'t for the goblins\' inconceivable, dumb luck, they\'d crash their car during every race!','If it weren\'t for the goblins\' inconceivable, dumb luck, they\'d crash their car during every race!',26124),
(2775,'enUS','These races are a great opportunity to show our ingenuity!','These races are a great opportunity to show our ingenuity!',26124),
(2776,'enUS','I installed a new device in our car\'s matrix regulometer.  That should increase its velocity quotient by a factor of no less than fifteen!','I installed a new device in our car\'s matrix regulometer.  That should increase its velocity quotient by a factor of no less than fifteen!',26124),
(2777,'enUS','My son could design a faster car than that clunky goblin junk heap! ','My son could design a faster car than that clunky goblin junk heap!',26124),
(2778,'enUS','My Gizmotic Almanacotron says that we should beat the goblins by twenty seconds more than we did last time!','My Gizmotic Almanacotron says that we should beat the goblins by twenty seconds more than we did last time!',26124),
(2779,'enUS','Where is Tirth\'s assistant?','Where is Tirth\'s assistant?',26124),
(2780,'enUS','Tirth\'s not himself these days, and neither is his assistant.','Tirth\'s not himself these days, and neither is his assistant.',26124),
(2781,'enUS','Johnson?  I think he\'s around here somewhere...','Johnson?  I think he\'s around here somewhere...',26124),
(2782,'enUS','Hah!  Tirth\'s been looking for him for days, but he doesn\'t want to be found.  He\'s chicken!','Hah!  Tirth\'s been looking for him for days, but he doesn\'t want to be found.  He\'s chicken!',26124),
(2783,'enUS','Bears??','Bears??',26124),
(2801,'enUS','At last! I am finally free from this cell!$b$bThe Kirin Tor sent me from Dalaran to investigate Arugal\'s progress with the undead here in Silverpine Forest. Little did we know that the wizard had lost his grasp on sanity.$b$bI must report this mess at once! But before I leave, allow me to undo the magical lock on the courtyard door.$b$bYou defeated Rethilgore, perhaps you will survive what lies beyond....','',26124),
(2802,'enUS','Please unlock the courtyard door.','Please unlock the courtyard door.',26124),
(2803,'enUS','At last! Someone to free me from this cell!$b$bHigh Executor Hadrec sent us to gather information on the Keep so that a plan could be formulated to overthrow Arugal once and for all.$b$bBut the old wizard has many tricks up his sleeve and we were detected by a magical ward. I was thrown in this prison. Vincent was not so lucky.$b$bI must return to Hadrec to debrief him at once. But first I will pick the lock to the courtyard door for you. Perhaps you can try your luck against the foes that lurk beyond.','',26124),
(2804,'enUS','The curing cantrip has failed. Unfortunately, the introduction of the serum into this beast\'s blood stream will soon end its life.','',26124),
(2805,'enUS','Release the Rabid Thistle Bear for Tharnariun.','Release the Rabid Thistle Bear for Tharnariun.',26124),
(2806,'enUS','Well done. Release the bear into my custody so that I may apply the curing cantrip.','',26124),
(2807,'enUS','I once followed the ways of the Twilight\'s Hammer. Obsessed with reviving the Old Gods, I journeyed deep into this lair to try to draw power from the cursed beast, Aku\'mai!$b$bAfter witnessing the sacrifice of countless innocents, I came to my senses.$b$bI was trapped but now I am free! But so far from my homeland of Khaz Modan!$b$bBrave adventurer, I offer you passage to a very special land in return for slaying Aku\'mai. If you wish, I can port you to the city of Darnassus.','',26124),
(2821,'enUS','Welcome to my Inn, weary traveler. What can I do for you?','Welcome to my Inn, weary traveler. What can I do for you?',26124),
(2822,'enUS','Make this inn your home.','Make this inn your home.',26124),
(2823,'enUS','Let me browse your goods.','Let me browse your goods.',26124),
(2824,'enUS','Rest your weary bones for a spell.','Rest your weary bones for a spell.',26124),
(2825,'enUS','As the wind on the plains, you are always welcome here.','As the wind on the plains, you are always welcome here.',26124),
(2826,'enUS','Fill yer tankard and pull up a chair. We\'ve stories to tell and kegs to empty.','Fill yer tankard and pull up a chair. We\'ve stories to tell and kegs to empty.',26124),
(2827,'enUS','Your body looks worn and your spirit weary. Rest yourself beneath our roof and allow Elune to guide your dreams.','Your body looks worn and your spirit weary. Rest yourself beneath our roof and allow Elune to guide your dreams.',26124),
(2828,'enUS','Come in, come in. Just don\'t sit too close to the stove. It hasn\'t exploded yet today, but just to be safe I think you should sit elsewhere.','Come in, come in. Just don\'t sit too close to the stove. It hasn\'t exploded yet today, but just to be safe I think you should sit elsewhere.',26124),
(2829,'enUS','%s begins to bubble!','%s begins to bubble!',26124),
(2841,'enUS','Inns are places where you can rest after your adventures.  If you do not stay at an inn such as this, then you will not be fully rested when you venture again into the wilderness.$B$BYou may also acquire a hearthstone at any inn, and later when you are ready to rest you can use this heartstone to bring you back to the inn from which you acquired it.','Inns are places where you can rest after your adventures.  If you do not stay at an inn such as this, then you will not be fully rested when you venture again into the wilderness.$B$BYou may also acquire a hearthstone at any inn, and later when you are ready to rest you can use this heartstone to bring you back to the inn from which you acquired it.',26124),
(2842,'enUS','The master has fallen!  Avenge him, my brethren!','The master has fallen!  Avenge him, my brethren!',26124),
(2843,'enUS','','Hello $r, it is a pleasure to make your acquaintance.\n',26124),
(2844,'enUS','My strider requires training.','My strider requires training.',26124),
(2845,'enUS','','Hello, $n. Are you interested in outdoor survival? Sustenance off the flora and fauna of the lands!$B$BYou could learn a thing or two from me, that is, if you\'re interested.',26124),
(2846,'enUS','Please port me to Darnassus.','Please port me to Darnassus.',26124),
(2847,'enUS','Infidels! They must be purified!','',26124),
(2848,'enUS','Aku\'mai is dead! At last, I can leave this wretched place.','',26124),
(2849,'enUS','Speak with me to hear my tale.','',26124),
(2850,'enUS','Hail, what ya want?','Hail, what ya want?',26124),
(2861,'enUS','Well, well... look what the cat brung in... and how can I help you, $c?','Well, well... look what the cat brung in... and how can I help you, $c?',26124),
(2862,'enUS','I am in need of training, Keryn.','I am in need of training, Keryn.',26124),
(2863,'enUS','Flight Master','Flight Master',26124),
(2864,'enUS','You can find the gryphon master on the northeast rampart overlooking the Valley of Heroes.','You can find the gryphon master on the northeast rampart overlooking the Valley of Heroes.',26124),
(2865,'enUS','What\'s that noise?','',26124),
(2866,'enUS','I smell an intruder...','',26124),
(2867,'enUS','The Brotherhood will not be hampered by insects.','',26124),
(2868,'enUS','Class Trainer','Class Trainer',26124),
(2869,'enUS','Profession Trainer','Profession Trainer',26124),
(2870,'enUS','Guild Master & Vendor','Guild Master & Vendor',26124),
(2871,'enUS','You\'re looking a bit lost.  Can I help you find something?','You\'re looking a bit lost.  Can I help you find something?',26124),
(2872,'enUS','Greetings!','Greetings!',26124),
(2873,'enUS','Yes?','Yes?',26124),
(2874,'enUS','Look alive, dogs! We got an operation to run here!','',26124),
(2875,'enUS','What do you want?','What do you want?',26124),
(2876,'enUS','Ahhh, you are looking for Dungar Longdrink. He has some of the fastest gryphons this side of Khaz Modan! You can find him up on the ramparts in the Trade District.','Ahhh, you are looking for Dungar Longdrink. He has some of the fastest gryphons this side of Khaz Modan! You can find him up on the ramparts in the Trade District.',26124),
(2877,'enUS','Lookin\' to take a gryphon ride, eh? Dungar keeps his birds up on the rampart in the Trade District. Just remember to hold on tight! ','Lookin\' to take a gryphon ride, eh? Dungar keeps his birds up on the rampart in the Trade District. Just remember to hold on tight! ',26124),
(2878,'enUS','Gryphons, eh? Never really cared for the beasts but to each their own.\n\nYou can find Dungar Longdrink on the rampart in the Trade District.','Gryphons, eh? Never really cared for the beasts but to each their own.\n\nYou can find Dungar Longdrink on the rampart in the Trade District.',26124),
(2879,'enUS','You can find Aldwin Laughlin at the Stormwind Visitor\'s Center in the Trade District.','You can find Aldwin Laughlin at the Stormwind Visitor\'s Center in the Trade District.',26124),
(2880,'enUS','Gonna make a guild, are ya? Good luck to ya then!\n\nTalk to Aldwin Laughlin in the Stormwind Vistor\'s Center. It\'s in the Trade District right as you come in from the Valley of Heroes.','Gonna make a guild, are ya? Good luck to ya then!\n\nTalk to Aldwin Laughlin in the Stormwind Vistor\'s Center. It\'s in the Trade District right as you come in from the Valley of Heroes.',26124),
(2881,'enUS','Ahhh, Stormwind Visitor\'s Center is what you are looking for then. It\'s the first building on the left as you walk through the front gates from the Valley of Heroes.','Ahhh, Stormwind Visitor\'s Center is what you are looking for then. It\'s the first building on the left as you walk through the front gates from the Valley of Heroes.',26124),
(2901,'enUS','Which class trainer are you looking for?','Which class trainer are you looking for?',26124),
(2902,'enUS','Mage','Mage',26124),
(2903,'enUS','The magi congregate in the Wizard\'s Sanctum in the Mage Quarter. Quite a tower they have there. Makes our barracks look like peasant hovels.','The magi congregate in the Wizard\'s Sanctum in the Mage Quarter. Quite a tower they have there. Makes our barracks look like peasant hovels.',26124),
(2904,'enUS','Oh, looking for some arcane enlightenment are you? No place better then then Wizard\'s Sanctum in the Mage Quarter.','Oh, looking for some arcane enlightenment are you? No place better then then Wizard\'s Sanctum in the Mage Quarter.',26124),
(2905,'enUS','Sounds like you want to talk to Maginor Dumas! You can usually find him in the Wizard\'s Sanctum in the Mage Quarter. Course, you never know when or where those magi will portal off to.','Sounds like you want to talk to Maginor Dumas! You can usually find him in the Wizard\'s Sanctum in the Mage Quarter. Course, you never know when or where those magi will portal off to.',26124),
(2906,'enUS','Rogue','Rogue',26124),
(2907,'enUS','You want to talk to Osborne then. No finer teacher of the stealth arts than him in Stormwind. Look for him over in Old Town.','You want to talk to Osborne then. No finer teacher of the stealth arts than him in Stormwind. Look for him over in Old Town.',26124),
(2908,'enUS','Bah, rogues have done nothing but make our job here in Stormwind harder. I wish I could drag both Osborne and Mathias both out of Old Town and right to the Stockade.','Bah, rogues have done nothing but make our job here in Stormwind harder. I wish I could drag both Osborne and Mathias both out of Old Town and right to the Stockade.',26124),
(2909,'enUS','Old Town is where you should go if you want to find rogues. It\'s in the eastern corner of Stormwind.','Old Town is where you should go if you want to find rogues. It\'s in the eastern corner of Stormwind.',26124),
(2910,'enUS','Warrior','Warrior',26124),
(2911,'enUS','Warriors can usually be found either at the Pig and Whistle Tavern or the Barracks in Old Town. Tell ya though, the tavern is probably a better place to look.','Warriors can usually be found either at the Pig and Whistle Tavern or the Barracks in Old Town. Tell ya though, the tavern is probably a better place to look.',26124),
(2912,'enUS','Looking for some training, eh? I could train you better then anyone in Stormwind but the guard prohibits it. I guess you will have to settle for one of those has beens hanging out around the Barracks or at the Pig and Whistle Tavern in Old Town.','Looking for some training, eh? I could train you better then anyone in Stormwind but the guard prohibits it. I guess you will have to settle for one of those has beens hanging out around the Barracks or at the Pig and Whistle Tavern in Old Town.',26124),
(2913,'enUS','Check around Old Town at the Barracks or the Pig and Whistle Tavern. If you go to the tavern, be sure to sample some of the fine brews. Puts the dwarven ales to shame, I tell ya.','Check around Old Town at the Barracks or the Pig and Whistle Tavern. If you go to the tavern, be sure to sample some of the fine brews. Puts the dwarven ales to shame, I tell ya.',26124),
(2914,'enUS','Druid','Druid',26124),
(2915,'enUS','Well, you can find Theridan or Maldryn by the moonwell in the Park.  Just head to the western area of Stormwind, north of the Mage District, but west of the Cathedral Square.','Well, you can find Theridan or Maldryn by the moonwell in the Park.  Just head to the western area of Stormwind, north of the Mage District, but west of the Cathedral Square.',26124),
(2916,'enUS','The Park is where you want to go if you are looking for druid trainers. Theridan and Maldryn can usually be found by the moonwell in the center of the district.','The Park is where you want to go if you are looking for druid trainers. Theridan and Maldryn can usually be found by the moonwell in the center of the district.',26124),
(2917,'enUS','A child of nature are we? Then you need look no further then the moonwell in the Park.','A child of nature are we? Then you need look no further then the moonwell in the Park.',26124),
(2918,'enUS','Priest','Priest',26124),
(2919,'enUS','The Cathedral of Light in Cathedral Square is home to the priests of Stormwind. There you will find High Priestess Laurena.','The Cathedral of Light in Cathedral Square is home to the priests of Stormwind. There you will find High Priestess Laurena.',26124),
(2920,'enUS','Laurena is the High Priestess of Stormwind. You can find her in the Catheral of Light in Cathedral Square.','Laurena is the High Priestess of Stormwind. You can find her in the Catheral of Light in Cathedral Square.',26124),
(2921,'enUS','I would suggest looking in the Cathedral of Light in Cathedral Square.','I would suggest looking in the Cathedral of Light in Cathedral Square.',26124),
(2922,'enUS','Paladin','Paladin',26124),
(2923,'enUS','If you are looking to become a mighty paladin, there is no better teacher then Lord Grayson Shadowbreaker. He can be found in the Cathedral of Light in Cathedral Square.','If you are looking to become a mighty paladin, there is no better teacher then Lord Grayson Shadowbreaker. He can be found in the Cathedral of Light in Cathedral Square.',26124),
(2924,'enUS','Hunter','Hunter',26124),
(2925,'enUS','Thorfin Stoneshield came to us all the way from Ironforge to bring us his expertise in hunting.  If you don\'t mind breathing the smoke filled air of the Dwarven District then you\'ll find him at his house in the northeast area of the district.','Thorfin Stoneshield came to us all the way from Ironforge to bring us his expertise in hunting.  If you don\'t mind breathing the smoke filled air of the Dwarven District then you\'ll find him at his house in the northeast area of the district.',26124),
(2926,'enUS','Warlock','Warlock',26124),
(2927,'enUS','What? I don\'t know of any warlock trainers in Stormwind. \n\nAlthough... There have been some sightings of demonic activity over by The Slaughtered Lamb in the Mage Quarter. I suppose you could check there.','What? I don\'t know of any warlock trainers in Stormwind. \n\nAlthough... There have been some sightings of demonic activity over by The Slaughtered Lamb in the Mage Quarter. I suppose you could check there.',26124),
(2928,'enUS','What brings you to this part of the world, $n?','What brings you to this part of the world, $n?',26124),
(2929,'enUS','Good day to you, Hogral! I seek training.','Good day to you, Hogral! I seek training.',26124),
(2930,'enUS','He grows fatter and more corrupt with each passing day. Ye can smell the stink comin\' off o\' his body. He be dirty, an\' I dun just mean he be needin\' a wash.$B$BEnough babblin\' from Hulfdan. Where did ye come from and how can me help ye, $c?','He grows fatter and more corrupt with each passing day. Ye can smell the stink comin\' off o\' his body. He be dirty, an\' I dun just mean he be needin\' a wash.$B$BEnough babblin\' from Hulfdan. Where did ye come from and how can me help ye, $c?',26124),
(2931,'enUS','Good day, Hulfdan, I am looking for training.','Good day, Hulfdan, I am looking for training.',26124),
(2941,'enUS','Which profession trainer are you looking for?','Which profession trainer are you looking for?',26124),
(2942,'enUS','Blacksmithing','Blacksmithing',26124),
(2943,'enUS','Engineering','Engineering',26124),
(2944,'enUS','Mining','Mining',26124),
(2945,'enUS','Cooking','Cooking',26124),
(2946,'enUS','Lockpicking','Lockpicking',26124),
(2947,'enUS','Leatherworking','Leatherworking',26124),
(2948,'enUS','Skinning','Skinning',26124),
(2949,'enUS','First Aid','First Aid',26124),
(2950,'enUS','Herbalism','Herbalism',26124),
(2951,'enUS','Tailoring','Tailoring',26124),
(2952,'enUS','Alchemy','Alchemy',26124),
(2953,'enUS','If you need training in alchemy, there is only one place in Stormwind you need to go... Alchemy Needs. You can find it in the Mage Quarter along the outer rim of shops.','If you need training in alchemy, there is only one place in Stormwind you need to go... Alchemy Needs. You can find it in the Mage Quarter along the outer rim of shops.',26124),
(2954,'enUS','Therum Deepforge is the dwarf you want to talk to. One of the finest blacksmiths around if you ask me. You can find him in the heart of the Dwarven District.','Therum Deepforge is the dwarf you want to talk to. One of the finest blacksmiths around if you ask me. You can find him in the heart of the Dwarven District.',26124),
(2955,'enUS','If you are looking to become a great cook, venture over to the Pig and Whistle Tavern in Old Town and talk to Stephen Ryback. That man knows how to cook up a rack of ribs like no other.\n\nMan... now you got me hungry for some of his famous ribs. Don\'t count on him teaching you that recipe though!','If you are looking to become a great cook, venture over to the Pig and Whistle Tavern in Old Town and talk to Stephen Ryback. That man knows how to cook up a rack of ribs like no other.\n\nMan... now you got me hungry for some of his famous ribs. Don\'t count on him teaching you that recipe though!',26124),
(2956,'enUS','Stormwind\'s resident engineer trainer is an ingenious gnome by the name of Lilliam Sparkspindle. He can be found in the back of the Dwarven District.','Stormwind\'s resident engineer trainer is an ingenious gnome by the name of Lilliam Sparkspindle. He can be found in the back of the Dwarven District.',26124),
(2957,'enUS','The Cathedral of Light is the center of all the healing practices of Stormwind. There you can find Angela Leifeld to help you learn this craft.','The Cathedral of Light is the center of all the healing practices of Stormwind. There you can find Angela Leifeld to help you learn this craft.',26124),
(2958,'enUS','You can find Tannysa standing outside Alchemy Needs in the Mage Quarter.','You can find Tannysa standing outside Alchemy Needs in the Mage Quarter.',26124),
(2959,'enUS','Want to learn leatherworking, eh? Simon Tanner would be able to teach you. He can be found in Old Town at the Protective Hide.','Want to learn leatherworking, eh? Simon Tanner would be able to teach you. He can be found in Old Town at the Protective Hide.',26124),
(2960,'enUS','Don\'t know why you would need a skill like that? Only dishonest folk would want to learn how to pick locks.\n\nI guess if you wanted to learn, the best place to look would be over in Old Town. Probably in one of those back alleys.','Don\'t know why you would need a skill like that? Only dishonest folk would want to learn how to pick locks.\n\nI guess if you wanted to learn, the best place to look would be over in Old Town. Probably in one of those back alleys.',26124),
(2961,'enUS','Gelman Stonehand would be the one to talk to. I think he has a house over in the Dwarven District but I can\'t remember exactly. I would check over there.','Gelman Stonehand would be the one to talk to. I think he has a house over in the Dwarven District but I can\'t remember exactly. I would check over there.',26124),
(2962,'enUS','You are gonna want to head over to Old Town and drop by the Protective Hide if you are lookin\' to learn skinning.','You are gonna want to head over to Old Town and drop by the Protective Hide if you are lookin\' to learn skinning.',26124),
(2963,'enUS','Duncan\'s Textiles employs one of the finest tailors in Stormwind, Georgio Bolero. Look for the shop over in the Mage Quarter.','Duncan\'s Textiles employs one of the finest tailors in Stormwind, Georgio Bolero. Look for the shop over in the Mage Quarter.',26124),
(2964,'enUS','Plucky doesn\'t want Tirth to know he\'s still in the Shimmering Flats, so he turned himself into a chicken!$B$BIf you find Plucky, beckon him to you.  Maybe he\'ll come out of hiding.','',26124),
(2967,'enUS','I hope yer ready to work.','',26124),
(2968,'enUS','Welcome to the races!  Enjoy your stay, and don\'t bet all your money in one place!','Welcome to the races!  Enjoy your stay, and don\'t bet all your money in one place!',26124),
(2969,'enUS','Hello, $c!  Welcome to the races at the Shimmering Flats!','Hello, $c!  Welcome to the races at the Shimmering Flats!',26124),
(2970,'enUS','Who has the fastest car?  Who knows?!?','Who has the fastest car?  Who knows?!?',26124),
(2971,'enUS','The goblin racer packs a lot of punch, but the gnomes hid a trick or two in their car...','The goblin racer packs a lot of punch, but the gnomes hid a trick or two in their car...',26124),
(2972,'enUS','%s begins to billow smoke and catches on fire! You get the feeling you should RUN!','%s begins to billow smoke and catches on fire! You get the feeling you should RUN!',26124),
(2973,'enUS','','You shall pay for this treachery!',26124),
(2974,'enUS','What do you need directions to?','What do you need directions to?',26124),
(2975,'enUS','Can you help me with some directions?','Can you help me with some directions?',26124),
(2976,'enUS','Should you choose to follow me, be on guard. The animals and beasts of the Darkshore will not harm me but they may attempt to harm you, adventurer.','Should you choose to follow me, be on guard. The animals and beasts of the Darkshore will not harm me but they may attempt to harm you, adventurer.',26124),
(2977,'enUS','Like a cat dragged in from the rain, you scratch and claw, then do it all over again... I\'ll be back for more...$B$BOh, I didn\'t see you enter, $n! What can I do for you?','Like a cat dragged in from the rain, you scratch and claw, then do it all over again... I\'ll be back for more...$B$BOh, I didn\'t see you enter, $n! What can I do for you?',26124),
(2978,'enUS','Hello! I am a Rogue in need of training.','Hello! I am a Rogue in need of training.',26124),
(2979,'enUS','','The forests are overrun with strange beasts and a foul taint fills the air.\n',26124),
(2980,'enUS','Good day to you, Syurna. I am in need of training.','Good day to you, Syurna. I am in need of training.',26124),
(2981,'enUS','I know you are there, rogue. Leave my home or join the others at the bottom of the world tree.','',26124),
(2982,'enUS','The end of days is upon us! May the earth embrace my flesh and bones.','',26124),
(2983,'enUS','We live only to serve the ancient one. DIE INTERLOPER!','',26124),
(3001,'enUS','Filth! Filth everywhere! The forests must be cleansed!','',26124),
(3002,'enUS','It is hopeless. Cutting one down results in two new growths.','',26124),
(3003,'enUS','If we are to make these new lands ours then we must have places to rest our battle weary bodies. Lay your axe by the fire and share the stories of your mighty battles.','If we are to make these new lands ours then we must have places to rest our battle weary bodies. Lay your axe by the fire and share the stories of your mighty battles.',26124),
(3004,'enUS','Those thieving elementals are up the path, this way.  Good luck, $n.','',26124),
(3005,'enUS','Fishing','Fishing',26124),
(3006,'enUS','Enchanting','Enchanting',26124),
(3007,'enUS','Survival','Survival',26124),
(3008,'enUS','Always a good skill to have that Survival is.\n\nKaerbrus is who you are looking for. He\'s usually around the moonwell in the Park.','Always a good skill to have that Survival is.\n\nKaerbrus is who you are looking for. He\'s usually around the moonwell in the Park.',26124),
(3009,'enUS','Nothing like spending a day down at Crystal Lake fishing. Arnold Leland is the man that taught me. You can usually find him out on the dock in the Canal District just fishing the day away. \n\nOh, and don\'t believe any of the stories he tells you about monsters in the canals either.','Nothing like spending a day down at Crystal Lake fishing. Arnold Leland is the man that taught me. You can usually find him out on the dock in the Canal District just fishing the day away. \n\nOh, and don\'t believe any of the stories he tells you about monsters in the canals either.',26124),
(3010,'enUS','Lucan Cordell has a small shop on the canal by the Stockade. I am sure he will be able to teach you the art of enchanting.','Lucan Cordell has a small shop on the canal by the Stockade. I am sure he will be able to teach you the art of enchanting.',26124),
(3011,'enUS','I walk this road alone, seeking ways to defend my honor and rid this land of our enemies.$B$BWhat can I do for you, $n?','',26124),
(3012,'enUS','*Threshwackonator First Mate unit prepared to follow*','',26124),
(3013,'enUS','Can you tell me where Brine is?','Can you tell me where Brine is?',26124),
(3014,'enUS','Yes, I have seen the shaman you seek. Last I saw her, she was to the west of here. She hides in the hills above the Razormane tribe. If you\'re clever, you\'ll be able to find a path to her hut in the hills. It is not too far north of here. That path should allow you to find her without fighting through the quilboar.','',26124),
(3021,'enUS','We are but darkness and shadows. Eternal. Invisible.','',26124),
(3022,'enUS','Greetings Erion, I require training!','Greetings Erion, I require training!',26124),
(3041,'enUS','In this place, darkness and shadows are tools to be used and disposed of at will.','',26124),
(3042,'enUS','Another fool falls to the Defias Brotherhood.','',26124),
(3043,'enUS','Okay, okay... gimmie a minute to rest now. You gone and beat me up good.','',26124),
(3061,'enUS','*You are able to make out the words* Stay... watch... shadow...','',26124),
(3062,'enUS','%s scans the mill','',26124),
(3063,'enUS','Smell ugly near. Me smell you ugly.','',26124),
(3064,'enUS','You check the front!','',26124),
(3065,'enUS','%s nods.','',26124),
(3066,'enUS','Let the blood spilled here today be a lesson to all who dare encroach upon the territory of the Blackrock Clan!','',26124),
(3067,'enUS','The Signet of Chaos belongs to Ravenholdt, beast! You will never hold its power! (PLACEHOLDER - TO BE MOVED/CHANGED)','',26124),
(3068,'enUS','Take cover in the shadows. We have business to discuss once I finish showing these beasts why I am called the Hand of Chaos.','',26124),
(3069,'enUS','Come down to da shrine with Tiev. We\'ll put da sapta magics to work there.','',26124),
(3070,'enUS','Okay, $g brotha:sista;, now fer da sapta... stay close ta me.','',26124),
(3071,'enUS','I\'ll put me items in the brazier now. You just speak to da spirits when they appear.','',26124),
(3072,'enUS','Dat should do it good...','',26124),
(3073,'enUS','I\'m done, $g brotha:sista;. Finish up yerself. I\'ll be restin\' meself back on the rock.','',26124),
(3074,'enUS','%s is angered and attacks!','',26124),
(3075,'enUS','Sacred artifact belong to Blackrock! We take back!','',26124),
(3076,'enUS','Kill, KILL! Get back artifact! Bring to Kartak!','',26124),
(3077,'enUS','Now we just need to figure out how to get this thing working again.','',26124),
(3078,'enUS','Maybe I can fix it, pop.  Lemme take a look at it.','',26124),
(3079,'enUS','Sandwich?  What?  You makin\' a sandwich for me, pop?','',26124),
(3080,'enUS','Boy, you couldn\'t fix a sandwich without someone tellin\' ya how to do it.','',26124),
(3081,'enUS','Malton, you dummy!','',26124),
(3082,'enUS','Allow me to get some water for the inking reagent.','',26124),
(3083,'enUS','And now for a quick look at these gems.','',26124),
(3084,'enUS','This will do nicely.  Now to the task at hand!','',26124),
(3085,'enUS','There we go, all finished.  The journal has been translated for you.','',26124),
(3086,'enUS','Another victory for the Defias Brotherhood!','',26124),
(3087,'enUS','Any one else ready to feel the wrath of the Defias Brotherhood?','',26124),
(3088,'enUS','That\'s right. Die like the dog you are.','',26124),
(3089,'enUS','Babba booey....','',26124),
(3090,'enUS','','Meet me down by the orchard--I just need to put my gun away.',26124),
(3091,'enUS','Just as I thought, the gems and the necklace don\'t matter.  It\'s all about the power source.','',26124),
(3092,'enUS','You cannot hide from me, rogue. I can smell your fear.','',26124),
(3093,'enUS','And should one die, two shall rise!','',26124),
(3094,'enUS','%s wildly flips through the pages of a large tome.','',26124),
(3095,'enUS','The sweet irony -- Stormwind forces cut down in defense of their city, only to rise and fight alongside the Brotherhood as instruments of destruction.','',26124),
(3096,'enUS','This is the very first thing I say to the player.  Huzzah!','',26124),
(3097,'enUS','%s shuffles through the books.','',26124),
(3098,'enUS','Now where did I put the Venture Company formulations?','',26124),
(3099,'enUS','Question 1, Chain 1?','Question 1, Chain 1?',26124),
(3100,'enUS','Question 1, Chain 2','Question 1, Chain 2',26124),
(3101,'enUS','This is the answer to the first question of the first chain.','',26124),
(3102,'enUS','Question 2, Chain 1?','Question 2, Chain 1?',26124),
(3103,'enUS','2nd chain, first answer.  PWNED~','',26124),
(3104,'enUS','Another question on the first chain ANSWERED!','',26124),
(3121,'enUS','Let me grab a spell focus from inside my home here, and then we\'ll get started!','',26124),
(3122,'enUS','Bah, it isn\'t here.  Where did I have that blasted thing at last?','',26124),
(3123,'enUS','That\'s right, it\'s over by the bed.  Heh, sorry about that!','',26124),
(3124,'enUS','Fantastic then!  Let\'s get this thing fixed for you.','',26124),
(3125,'enUS','Success!  Huzzah!  The power source restored the necklace!','',26124),
(3126,'enUS','Hey, Raven...','Hey, Raven...',26124),
(3127,'enUS','Yea?','Yea?',26124),
(3128,'enUS','Can we take a break? My feet are killing me and those ... those things down there are creeping me out.','Can we take a break? My feet are killing me and those ... those things down there are creeping me out.',26124),
(3129,'enUS','I dunno, Jill. If Klaven comes down while we\'re slacking, we may end up as one of those things!','I dunno, Jill. If Klaven comes down while we\'re slacking, we may end up as one of those things!',26124),
(3130,'enUS','*Sigh* You\'re probably right, Raven. I\'m going back on patrol....','*Sigh* You\'re probably right, Raven. I\'m going back on patrol....',26124),
(3131,'enUS','%s blood sprays into the air!','%s blood sprays into the air!',26124),
(3132,'enUS','Lucius is an old and trusted friend of Ravenholdt Manor - he and I have much to discuss. Find me at the docks in Lakeshire should you require my assistance or council.','',26124),
(3133,'enUS','What\'s this? Orcs already approach?','',26124),
(3134,'enUS','Well done, young rogue. Well done, indeed....','',26124),
(3135,'enUS','Avert your eyes, children. The bloodrage has taken over...','',26124),
(3141,'enUS','%s self destructs!','%s self destructs!',26124),
(3142,'enUS','The Order of the Shattered Hand existed before Thrall and shall exist after Thrall. ','',26124),
(3143,'enUS','I require training, sir!','I require training, sir!',26124),
(3144,'enUS','Zando\'zan of the Shattered Hand. How can Zando\'zan help you? He can\'t! He won\'t!\n','',26124),
(3145,'enUS','Hello Zando\'zan, I would like to learn lockpicking.','Hello Zando\'zan, I would like to learn lockpicking.',26124),
(3146,'enUS','Are you here for training?  Or are you just here to waste a warrior\'s time?','Are you here for training?  Or are you just here to waste a warrior\'s time?',26124),
(3147,'enUS','I require warrior training.','I require warrior training.',26124),
(3148,'enUS','The machine comes alive at your touch.','',26124),
(3149,'enUS','Press the yellow button labeled \'Thieves\' Tools.\'','Press the yellow button labeled \'Thieves\' Tools.\'',26124),
(3161,'enUS','He\'ll bring you mead$bHe\'ll bring you beer$bA grinning face from ear to ear$bHe\'s served us all from year to year$bWe call him Smiling Jim.','',26124),
(3162,'enUS','This is an exotic sample of flora, unseen in other parts of Teldrassil.','',26124),
(3163,'enUS','This plant stands out among the normal flora of Teldrassil, and emits a strange, purplish glow.','',26124),
(3164,'enUS','SQUAWK! Polly wants to crack you!','',26124),
(3165,'enUS','What the squawk??? Squawk squawk, squawk? SQUAWK!','',26124),
(3166,'enUS','Press the red button labeled \'E.C.A.C.\'','Press the red button labeled \'E.C.A.C.\'',26124),
(3167,'enUS','MmmmmMmmmm... Enormous chemically altered cracker....','',26124),
(3168,'enUS','%s is littered with broken bones and cracker crumbs.','',26124),
(3169,'enUS','%s is empty, save for a few crumbs and a gigantic green feather.','',26124),
(3170,'enUS','SQUAWK!!!','',26124),
(3171,'enUS','Make sure to visit the Gizmotronic Apparatus to grab a lockpick and an E.C.A.C. You will definitely need both to complete your mission!','',26124),
(3172,'enUS','Salutations.  My function is to offer access to and, when permissible, insight into information regarding the Creators\' synthesis of the Earthen on the world designated as Azeroth.  I am ready to share this information with you now at your leisure.','',26124),
(3173,'enUS','The Earthen are a synthesized race engineered by the Creators, functioning as one of the seed races in the initial population of the world designated as Azeroth.  The Earthen were created to aid the Creators\' efforts in shaping the deep regions of this world.$B$BThey are a modification of the standard subterranean being matrix used on other worlds that the Creators have seeded.  The construction of this prototype race created various anomalies that were observed after initial synthesis.','',26124),
(3174,'enUS','It is one of the synthesis matrices the Creators use when seeding a world.  Each synthesis matrix is used to achieve the Creators\' goals.  For Azeroth, a subterranean being matrix was modified to create a being with increased durability with an affinity for deep region shaping; the Earthen are the product of this modification.$B$BAfter the Earthen had been put into service for the Creators, unforeseen anomalies were discovered that affected their synthesis matrix due to high-stress environments.','',26124),
(3175,'enUS','Additional background information on the Earthen must be given to you before this question may be answered properly.$B$BProcessing.$B$BTo understand the anomalies of the Earthen, it is first important to understand what the Earthen represent in their design intent.  The Earthen represent the Creators\' attempt at improving the survivability paradigm of the standard subterranean being matrix.  This was done by incorporating a resilient foundation of construction inherent to the world into said matrix.','',26124),
(3176,'enUS','It is the baseline material used in race synthesis.  A cross-section of Azeroth\'s crust was used as the foundation for the Earthen\'s synthesis rather than the typical biomass construction foundation used by the Creators.$B$BResearch on the world\'s composition led the Creators to theorize that an enhanced being could be synthesized that would epitomize the resiliency of this world\'s essence.  This was accomplished by choosing to use a blend of Azeroth\'s various stone core compounds as the foundation.','',26124),
(3177,'enUS','Simply stated, this is correct.$B$BThe Earthen\'s physical features are that of a smaller stature humanoid, though their composition is that of Azeroth\'s various stone core compounds.  Their design maximizes strength and stamina without sacrificing cognitive processing power.  Their skin and musculature are nearly impervious to physical damage, and with very minor modifications the Earthen display a remarkable resiliency to unwanted magical forces.','',26124),
(3178,'enUS','It is integral to the assimilation of this data that it is understood that the Creators wanted to synthesize a race that would long be an integral part of this world\'s development cycle after they had departed.  This race would be instrumental in fulfilling the Creators\' long-term development objectives for Azeroth.  $B$BAs an ancillary note, the nomenclature \"Earthen\" was deemed apropos for the new race by the Creators, based on the Earthen\'s composition.','',26124),
(3179,'enUS','The Earthen\'s only anomaly in synthesis is the tendency for matrix destabilization while being utilized in high-stress environments.$B$BAddendum: deep earth sculpting was naturally suited to the new matrix design and thus never met the qualifications of duplicating a high-stress environment.$B$BDestabilization was not discovered until well into the Earthen\'s primary service cycle for the Creators.  The Creators began work on post-synthesis modification, rather than recall and re-synthesis.','',26124),
(3180,'enUS','[There is a noticeable pause after you ask this question.]$B$BThe information you request is not currently available in this repository\'s data cycling.  I sincerely apologize for this omission.$B$BPlease request this information after a data cycling update has been performed on this information repository.  You may also request this information from another information repository located on Azeroth.','',26124),
(3181,'enUS','There are two potential results when the Earthen\'s synthesis matrix destabilizes.  Initiating visual aid representation number one.$B$BThe first variant matrix is a degenerative product of synthesis, hereby designated with the common nomenclature of \"Trogg\".  This variant maintains strength and stamina comparable to the Earthen, but its cognitive processing power has been almost completely compromised.  Force of will and a strong sense of cunning are the only driving factors in the psyche of the trogg.','',26124),
(3182,'enUS','I am unable to process your chronological reference in comparison to the recording of this data, my apologies.$B$BThe trogg retains some composition of Azeroth\'s various stone core compounds, but the loss of cognitive power makes this variant unacceptable to the Creators.$B$BThe trogg procreates as per a standard biomass.  By default it consumes stone and anything else it can acquire, including other troggs.  Cannibalism is considered unacceptable by the Creators.','',26124),
(3183,'enUS','Initiating visual aid representation number two.$B$BThe second resultant variance of the Earthen matrix retains many desired elements when compared to the standard subterranean matrix.  The common nomenclature for this variant is \"Dwarf\".$B$BThis variant retains strength and stamina inherent to the Earthen.  In some cases, the dwarf even exceeds the cognitive powers of the Earthen\'s matrix.  The dwarf, however, retains none of the physical composition of Azeroth\'s various stone core compounds.','',26124),
(3184,'enUS','The data stored in this repository does indeed correlate with your astute proclamation.$B$BThe dwarf maintains an affinity for the stone composition of Azeroth, but due to the high-stress environmental anomaly within the Earthen\'s synthesis matrix, the dwarf reverts to a default biomass composition as seen in the standard subterranean matrix.$B$BErgo, the dwarf variant does synthesize from the degeneration of the Earthen creation matrix, as you inferred with your query.','',26124),
(3185,'enUS','I am unable to process your chronological reference in comparison to the recording of this data, my apologies.$B$BThough the dwarf maintains most of the Earthen\'s mental attunement to Azeroth\'s stone composition, the reversion back into living biomass remains the main degeneration of the matrix.  Dwarves eat and procreate through means typical to other standard biomasses.$B$BThe Creators view the dwarf as an acceptable variant, worthy of genesis in its own right.','',26124),
(3186,'enUS','The Creators are... the Creators.$B$BThey are the beings that seeded and shaped this world by their own design.  They are the reason for this world\'s existence, as well as many other worlds.  They are the wellspring from which Azeroth flows.','',26124),
(3187,'enUS','The Creators are cognizant of the magnitude of the information housed in this repository.  Subsequently, a portable copy of the data stored here will be made available to you once you are attuned with the Discs of Norgannon.$B$BPlease consider your cursory requirements for the assimilation of this knowledge to be complete.  At your leisure, access the Discs of Norgannon to begin synthesis of your discs.','',26124),
(3188,'enUS','Who are the Earthen?','Who are the Earthen?',26124),
(3189,'enUS','What is a \"subterranean being matrix\"?','What is a \"subterranean being matrix\"?',26124),
(3190,'enUS','What are the anomalies you speak of?','What are the anomalies you speak of?',26124),
(3191,'enUS','What is a \"resilient foundation of construction\"?','What is a \"resilient foundation of construction\"?',26124),
(3192,'enUS','So... the Earthen were made out of stone?','So... the Earthen were made out of stone?',26124),
(3193,'enUS','Anything else I should know about the Earthen?','Anything else I should know about the Earthen?',26124),
(3194,'enUS','I think I understand the Creators\' design intent for the Earthen now.  What are the Earthen\'s anomalies that you spoke of earlier?','I think I understand the Creators\' design intent for the Earthen now.  What are the Earthen\'s anomalies that you spoke of earlier?',26124),
(3195,'enUS','What high-stress environments would cause the Earthen to destabilize?','What high-stress environments would cause the Earthen to destabilize?',26124),
(3196,'enUS','What happens when the Earthen destabilize?','What happens when the Earthen destabilize?',26124),
(3197,'enUS','Troggs?!  Are the troggs you mention the same as the ones in the world today?','Troggs?!  Are the troggs you mention the same as the ones in the world today?',26124),
(3198,'enUS','You mentioned two results when the Earthen destabilize.  What is the second?','You mentioned two results when the Earthen destabilize.  What is the second?',26124),
(3199,'enUS','Dwarves!!!  Now you\'re telling me that dwarves originally came from the Earthen?!','Dwarves!!!  Now you\'re telling me that dwarves originally came from the Earthen?!',26124),
(3200,'enUS','These dwarves are the same ones today, yes?  Do dwarves maintain any other links to the Earthen?','These dwarves are the same ones today, yes?  Do dwarves maintain any other links to the Earthen?',26124),
(3201,'enUS','Who are the Creators?','Who are the Creators?',26124),
(3202,'enUS','This is a lot to think about.','This is a lot to think about.',26124),
(3203,'enUS','%s points you to the Gizmotronic Apparatus.','',26124),
(3204,'enUS','%s explodes, lighting the sky up in a brilliant fireworks display! It seems to be beckoning to you, rogue.','',26124),
(3205,'enUS','%s opens. The contents assault your senses with a very foul odor. Inside you see what appear to be enormous bird droppings and a lot of blood.','',26124),
(3206,'enUS','%s is full of dead black rats. Hmmmm....','',26124),
(3207,'enUS','%s is empty.','',26124),
(3221,'enUS','I will access the discs now.','I will access the discs now.',26124),
(3222,'enUS','SI:7 lockbox opens, sounding an audible alarm.','',26124),
(3223,'enUS','SI:7 lockbox begins to vibrate and hum. A loud, rustling sound, can be heard coming from the north.','',26124),
(3224,'enUS','SI:7 lockbox crashes open. Grunts and voices can be heard in the distance.','',26124),
(3225,'enUS','SI:7 lockbox creaks open. A loud booming voice can be heard. You can make out the words: \'Go... search... shadows...\'','',26124),
(3241,'enUS','Hi this is my text.','Hi this is my text.',26124),
(3261,'enUS','','None may steal the secrets of the Makers!',26124),
(3262,'enUS','','How dare you defile this ancient place!',26124),
(3263,'enUS','%s chips and splinters!','%s chips and splinters!',26124),
(3264,'enUS','','Be sure to read over the notes in my journal, $n. You will find them to be invaluable in overcoming the tower\'s defenses.',26124),
(3265,'enUS','So ye want to be a Blacksmith eh? Grab an apron and a hammer $g lad : lass;, let\'s see what ye\'ve got.','',26124),
(3266,'enUS','Train me.','Train me.',26124),
(3267,'enUS','Tell me more about Forging Armor.','Tell me more about Forging Armor.',26124),
(3268,'enUS','I\'ve not seen finer armor made in many years $n. Not since I trained under Grumnus Steelshaper in the Great Forge. I bet he could teach ye things about makin armor that would spark yer interest.','',26124),
(3269,'enUS','Can you give me directions?','Can you give me directions?',26124),
(3270,'enUS','If ye want to find Grumnus, the first thing ye should do is head to Ironforge. Go to the very center of the city and look for the Great Forge, ye should find him there.','',26124),
(3271,'enUS','Tell me more about Forging Weapons.','Tell me more about Forging Weapons.',26124),
(3272,'enUS','That\'s some impressive skill ye have there $n. The blades and hammers ye make surpass even my own, hard as that is to admit. Only person I ever met with skill even greater is Borgus Steelhand, I bet he could teach ye a thing or three.','',26124),
(3273,'enUS','Want to train with Borgus? Aye, I can tell ye where to find him. Head through the Square northwest of me forge, then take the western road. Ye\'ll find him in the second building on yer right.','',26124),
(3274,'enUS','Ye have some skill at weapon crafting $g lad : lass;,very impressive indeed. Now grab a hammer and let\'s see if ye can forge a real weapon.','',26124),
(3275,'enUS','The Shattered Hand\'s influence dominates these lands. We are the veil which covers Kalimdor: The protectorates, the police, the judges, the jury, and ultimately, the executioners. We see all, we know all.$B$BYou have grown much in the time which you have spent in service of the Hand, $n. The time has come to send you into the field.$B$BAre you prepared to undertake your next mission?\n','',26124),
(3276,'enUS','Can\'t ye see I\'m busy? This had better be good.','',26124),
(3277,'enUS','What are ye daft? That\'s not a weapon, that\'s a dinner knife. I don\'t train amateurs.','',26124),
(3278,'enUS','$n, pay very close attention to what I do and follow my instructions precisely. To not heed my words is to sign your own death warrant, as Taskmaster Fizzule is VERY well versed in the ways of the warrior and the assassin.','',26124),
(3279,'enUS','After you get his attention - and you can be certain that if he sees you near the tower, you\'ll have his undue attention - face him and perform the Shattered /Salute. Let me demonstrate....','',26124),
(3280,'enUS','%s prepares the Shattered Salute! *PAY ATTENTION!*','',26124),
(3281,'enUS','Did you see what I did? If you are unsure of the technique used in presenting the /salute, practice on me. If you correctly execute the Shattered /Salute, I will give you the proper response.','',26124),
(3282,'enUS','Welcome to the Great Forge $g lad : lass;. It may be cold outside but we keep it nice and hot down \'ere. Grab a hammer, strike that anvil and show me ye\'ve got what it takes to be a Blacksmith of the Great Forge!','',26124),
(3283,'enUS','Nice form $n, I bet a full mug at Bruuk\'s Corner that the function is just as solid. Ye know, ye might want to talk to Myolor Sunderfury. He\'ll set ya straight.','',26124),
(3284,'enUS','Course I can show ye where Myolor is. Right over there near the anvil of the Great Forge, that\'s where he does his work. Listen to his words well $g lad:lass;, Myolor is as skilled as they come.','',26124),
(3285,'enUS','Ye have my approval $n, ye can forge blades better than any I\'ve trained in years. If ye want to make a real weapon though, ye need to talk with Myolor Sunderfury. That Dwarf will set ya on the right path.','',26124),
(3286,'enUS','So, off to see Myolor, eh? He\'s right o\'er there... behind ye! Er, maybe in front of ye! Near the Great Anvil!','',26124),
(3287,'enUS','Well done!','',26124),
(3288,'enUS','Something plagues this tower. I\'ve fallen ill and the other Venture Co. employees that work near or in the tower have also become sick.$B$BJust last week, two of our patrollers died, only to instantly come back to life as mindless drones!$B$BThe lifeforce is draining from my body. I can feel myself losing control. Urges taking over... Bad urges... *Fizzule slaps himself in the face* Not yet... Listen... Mine is a position of power. This position privies me to some sensitive information. ','',26124),
(3289,'enUS','What can I do for ye?','',26124),
(3290,'enUS','Ye bothered me for that? Ye\'d be better off strapping a dead rabbit to yer back and running through a Troll\'s den than wearing that piece of garbage.','',26124),
(3291,'enUS','$n, was it? That is a mighty fine piece of work ye have there. I\'ll take ye on, train ye how to make armor fit fer King Magni himself.','',26124),
(3292,'enUS','Something plagues this tower. I\'ve fallen ill and the other Venture Co. employees that work near or in the tower have also become sick. Just last week, two of our patrollers died, only to come back to life immediately as mindless drones! The lifeforce is draining from my body. I can feel myself losing control. Urges taking over... Bad urges... Not yet... Listen... Mine is a position of power. This position privies me to some sensitive information. \n','',26124),
(3293,'enUS','Tell me more.','Tell me more.',26124),
(3294,'enUS','About five months ago, the Venture Co.\'s Stranglethorn division got their hands on a special poison from a shady merchant in Booty Bay named Crank Fizzlebub. Fizzlebub had apparently stolen the poison from Zanzil!$B$BYes, Zanzil the Outcast - the troll that was exiled from his own tribe due to the nature of his \'experiments\' in necromancy.$B$BNaturally, once they had the poison, they proceeded to test it on each other. The results were disastrous.','',26124),
(3296,'enUS','Continue please, this story is intriguing.','Continue please, this story is intriguing.',26124),
(3301,'enUS','Grand Foreman Puzik Gallywix finally intervened, taking the surplus of poisons to his tower, here at the Sludge Fen, in order to study and research the unstable nature of the toxins. A decision was finally reached to share the secret of the poison with the Defias Brotherhood in exchange for a very large supply of a stable, usable poison.$B$BKlaven Mortwake of the Defias Brotherhood was tasked with the job of altering the chemical properties of Zanzil\'s mixture.','',26124),
(3302,'enUS','Fast forward to the present: The resultant formula works, allowing for the creation of a more controlled drone, however, the drawback is that the inactive compound is extremely volatile.$B$BGallywix, everyone in this tower and everyone outside are infected with the poison. It\'s affecting our minds and our bodies. Our internal organs have become soft and extremely fragile. This is your chance, $n. I don\'t have the strength to carry on and I sense that soon I will become one of \'them.\'','',26124),
(3303,'enUS','Defias? This is not good. Not good at all. Please continue.','Defias? This is not good. Not good at all. Please continue.',26124),
(3304,'enUS','Be strong, Fizzule!','Be strong, Fizzule!',26124),
(3305,'enUS','The tower\'s defenses are at their weakest right now. The patrollers, sentries, lookouts, and even Gallywix himself are all infected and highly vulnerable to your special abilities and attacks.$B$BI want to see you enter that tower and when you exit, I want to see you covered in the blood of your enemies, the head of Grand Foreman Puzik Gallywix in your hands, and the last of that poison in your pack. Take what you recover to Shenthul. He\'ll know what to do... I hope.\n','',26124),
(3306,'enUS','I won\'t let you down!','I won\'t let you down!',26124),
(3307,'enUS','You have jostled the cluster, and have been sickened by the spores!','You have jostled the cluster, and have been sickened by the spores!',26124),
(3308,'enUS','Greetings, mortals!  I have been activated by the Discs of Norgannon to assist you!','',26124),
(3321,'enUS','*cough* who goes there? *cough*','',26124),
(3322,'enUS','Who would be foolish enough to enter the tower of the Grand Foreman?','',26124),
(3324,'enUS','I can\'t stand all of the cackling and diabolical laughter. One more \'muhahaha\' from Lydon and I\'m blowing us all up.\n','',26124),
(3325,'enUS','I wish to learn alchemy, Serge.','I wish to learn alchemy, Serge.',26124),
(3326,'enUS','Whoops!','',26124),
(3329,'enUS','He he!  This will be a great hiding spot.','',26124),
(3330,'enUS','What was that noise?','',26124),
(3331,'enUS','Did you hear that?','',26124),
(3332,'enUS','I smell rogue.','',26124),
(3333,'enUS','What can I help you with $g sir : ma\'am;?','What can I help you with $g sir : ma\'am;?',26124),
(3334,'enUS','Welcome to my shop, it\'s good to see another Enchanter here in Stormwind. Are you here for a lesson perhaps?','Welcome to my shop, it\'s good to see another Enchanter here in Stormwind. Are you here for a lesson perhaps?',26124),
(3335,'enUS','Another Alchemist, hmm. I doubt your skill is as great as my own so perhaps I can train you in a few proper techniques.','Another Alchemist, hmm. I doubt your skill is as great as my own so perhaps I can train you in a few proper techniques.',26124),
(3336,'enUS','I hope that your interruption is for a good cause, I was in the middle of some important work.','I hope that your interruption is for a good cause, I was in the middle of some important work.',26124),
(3337,'enUS','Another Herbalist, hmm. I doubt your skill is as great as my own so perhaps I can train you in a few proper techniques.','Another Herbalist, hmm. I doubt your skill is as great as my own so perhaps I can train you in a few proper techniques.',26124),
(3338,'enUS','Welcome to my shop, it\'s good to see another Tailor here in Stormwind. Are you here for a lesson perhaps?','Welcome to my shop, it\'s good to see another Tailor here in Stormwind. Are you here for a lesson perhaps?',26124),
(3339,'enUS','Ah, a fellow Fisherman. Are you perhaps in need of a little training? Maybe I can show you a thing or two?','Ah, a fellow Fisherman. Are you perhaps in need of a little training? Maybe I can show you a thing or two?',26124),
(3340,'enUS','Welcome to Stormwind. Took a long time to rebuild her but it was well worth it. So are you visiting, or are you here on business?','Welcome to Stormwind. Took a long time to rebuild her but it was well worth it. So are you visiting, or are you here on business?',26124),
(3341,'enUS','I don\'t get too many cooks in here looking for training, but I guess I could teach you something if you\'re ready.','I don\'t get too many cooks in here looking for training, but I guess I could teach you something if you\'re ready.',26124),
(3342,'enUS','Do I look like I have the time or energy to coddle every tourist that wanders through my door? Tell me what you need, and make it quick.','Do I look like I have the time or energy to coddle every tourist that wanders through my door? Tell me what you need, and make it quick.',26124),
(3343,'enUS','I don\'t get too many Leatherworkers in here looking for training, but I guess I could teach you something if you\'re ready.','I don\'t get too many Leatherworkers in here looking for training, but I guess I could teach you something if you\'re ready.',26124),
(3344,'enUS','I don\'t get too many Skinners in here looking for training, but I guess I could teach you something if you\'re ready.','I don\'t get too many Skinners in here looking for training, but I guess I could teach you something if you\'re ready.',26124),
(3345,'enUS','Most people around these parts frown on lockpicking. As a little professional courtesy, let me show you a few tricks I\'ve learned.','Most people around these parts frown on lockpicking. As a little professional courtesy, let me show you a few tricks I\'ve learned.',26124),
(3346,'enUS','Tell me what you need, and make it quick.','Tell me what you need, and make it quick.',26124),
(3347,'enUS','','You have need of my skills as an alchemist, yes?',26124),
(3349,'enUS','I am interested in alchemy training.','I am interested in alchemy training.',26124),
(3350,'enUS','You have need of my skills as an alchemist, yes?','',26124),
(3351,'enUS','The big wars might be over, for now, but we still have to keep our skills sharp!','The big wars might be over, for now, but we still have to keep our skills sharp!',26124),
(3352,'enUS','Stormwind is the pillar of the human race, maintained through strength of will and the edge of a sturdy blade.','Stormwind is the pillar of the human race, maintained through strength of will and the edge of a sturdy blade.',26124),
(3353,'enUS','Greetings.  You seek instruction in the art of war?','Greetings.  Do you seek instruction in art of war?',26124),
(3354,'enUS','No matter how much one learns, there is always more to know.','No matter how much one learns, there is always more to know.',26124),
(3355,'enUS','The warrior\'s role is one of protection.  Just as we protect our compatriots in battle, we must also protect the interests of the Forsaken.','The warrior\'s role is one of protection.  Just as we protect our compatriots in battle, we must also protect the interests of the Forsaken.',26124),
(3356,'enUS','Oh, a fellow Physician. I would be glad to teach you anything that would aid your journeys.','Oh, a fellow Physician. I would be glad to teach you anything that would aid your journeys.',26124),
(3357,'enUS','Yes my $g son : daughter;? What can I assist you with?','Yes my $g son : daughter;? What can I assist you with?',26124),
(3358,'enUS','Another Survivalist, hmm. I doubt your skill is as great as my own so perhaps I can train you in a few proper techniques.','Another Survivalist, hmm. I doubt your skill is as great as my own so perhaps I can train you in a few proper techniques.',26124),
(3359,'enUS','Another Tracker, hmm. I doubt your skill is as great as my own so perhaps I can train you in a few proper techniques.','Another Tracker, hmm. I doubt your skill is as great as my own so perhaps I can train you in a few proper techniques.',26124),
(3360,'enUS','I do not like these human cities of stone and steel. I would prefer the forests of Ashenvale, tracking great beasts. But my dear brother, Kaerbrus, felt it would be beneficial to train the humans in our ways. So while I honor him and offer my services, I do not have to like it.','I do not like these human cities of stone and steel. I would prefer the forests of Ashenvale, tracking great beasts. But my dear brother, Kaerbrus, felt it would be beneficial to train the humans in our ways. So while I honor him and offer my services, I do not have to like it.',26124),
(3361,'enUS','I came from Ironforge to help out with the rebuilding effort here. If I can teach enough of ye my skills then maybe I can leave it to ye and take myself back home.','I came from Ironforge to help out with the rebuilding effort here. If I can teach enough of ye my skills then maybe I can leave it to ye and take myself back home.',26124),
(3362,'enUS','Yeah? Ye interrupted me, so ye better have a blasted good reason to do so.','Yeah? Ye interrupted me, so ye better have a blasted good reason to do so.',26124),
(3363,'enUS','Many would tell you that the Tallstrider is a laughable pet. But it\'s intelligence and loyalty make it a hard creature to match in many situations. If you are interested in the breed, then perhaps I can introduce you and your pet to a few talents I have learned over the years.','Many would tell you that the Tallstrider is a laughable pet. But it\'s intelligence and loyalty make it a hard creature to match in many situations. If you are interested in the breed, then perhaps I can introduce you and your pet to a few talents I have learned over the years.',26124),
(3364,'enUS','He is not a chicken, and no you may not pet him. Now be on your way before I give you a closer look at his beak.','He is not a chicken, and no you may not pet him. Now be on your way before I give you a closer look at his beak.',26124),
(3365,'enUS','Sharp teeth, muscles like cables, and a mind like a steel trap. This fella is one of the finest pets I have ever seen. Now if ye are interested, I could show ye a few things to make even the weakest of Raptors into a force to be reckoned with.','Sharp teeth, muscles like cables, and a mind like a steel trap. This fella is one of the finest pets I have ever seen. Now if ye are interested, I could show ye a few things to make even the weakest of Raptors into a force to be reckoned with.',26124),
(3366,'enUS','Ye should be on yer way $g lad : lass;. My pet here is hungry and he likes the smell of ye.','Ye should be on yer way $g lad : lass;. My pet here is hungry and he likes the smell of ye.',26124),
(3367,'enUS','%s is splashed by the blood and becomes irradiated!','%s is splashed by the blood and becomes irradiated!',26124),
(3368,'enUS','Since the fall of Dalaran and the destruction of Quel\'Thalas, wares of this sort have been hard to come by. But Lucan Cordell and some of our other Tradesman have been doing a fine job of filling our orders with quality merchandise.','Since the fall of Dalaran and the destruction of Quel\'Thalas, wares of this sort have been hard to come by. But Lucan Cordell and some of our other Tradesman have been doing a fine job of filling our orders with quality merchandise.',26124),
(3369,'enUS','I sell only the finest arcane gear, made by the crafters and mages here in the city of Stormwind.','I sell only the finest arcane gear, made by the crafters and mages here in the city of Stormwind.',26124),
(3370,'enUS','I want to browse your goods.','I want to browse your goods.',26124),
(3371,'enUS','Since the fall of Dalaran and the destruction of Quel\'Thalas, wares of this sort have been hard to come by. But Lucan Cordell and some of our other Tradesman have been doing a fine job of filling our orders with quality merchandise.','Since the fall of Dalaran and the destruction of Quel\'Thalas, wares of this sort have been hard to come by. But Lucan Cordell and some of our other Tradesman have been doing a fine job of filling our orders with quality merchandise.',26124),
(3372,'enUS','I sell only the finest arcane gear, made by the crafters and mages here in the city of Stormwind.','I sell only the finest arcane gear, made by the crafters and mages here in the city of Stormwind.',26124),
(3373,'enUS','Made by the finest craftsmen in all of Teldrassil, carried by hand from Kalimdor to Azeroth as a sign of the growing alliance between the people of the Great Tree and the humans of this land. If there is anything you require, you have but to ask.','Made by the finest craftsmen in all of Teldrassil, carried by hand from Kalimdor to Azeroth as a sign of the growing alliance between the people of the Great Tree and the humans of this land. If there is anything you require, you have but to ask.',26124),
(3374,'enUS','Since the fall of Dalaran and the destruction of Quel\'Thalas, wares of this sort have been hard to come by. But Lucan Cordell and some of our other Tradesman have been doing a fine job of filling our orders with quality merchandise.','Since the fall of Dalaran and the destruction of Quel\'Thalas, wares of this sort have been hard to come by. But Lucan Cordell and some of our other Tradesman have been doing a fine job of filling our orders with quality merchandise.',26124),
(3375,'enUS','I sell only the finest arcane gear, made by the crafters and mages here in the city of Stormwind.','I sell only the finest arcane gear, made by the crafters and mages here in the city of Stormwind.',26124),
(3376,'enUS','Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?','Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?',26124),
(3377,'enUS','Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?','Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?',26124),
(3378,'enUS','Just browsing my wares or is there something specific I can help you find today?','Just browsing my wares or is there something specific I can help you find today?',26124),
(3379,'enUS','Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?','Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?',26124),
(3380,'enUS','Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?','Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?',26124),
(3381,'enUS','Just browsing my wares or is there something specific I can help you find today?','Just browsing my wares or is there something specific I can help you find today?',26124),
(3382,'enUS','Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?','Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?',26124),
(3383,'enUS','Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?','Best deals in all of Stormwind my friend, won\'t find any better. Now, what can I help you with?',26124),
(3384,'enUS','Just browsing my wares or is there something specific I can help you find today?','Just browsing my wares or is there something specific I can help you find today?',26124),
(3385,'enUS','I sell only the best gear, tested and true. And the prices are set, so if you want to haggle then go find a Goblin.','I sell only the best gear, tested and true. And the prices are set, so if you want to haggle then go find a Goblin.',26124),
(3386,'enUS','I sell only the best gear, tested and true. And the prices are set, so if you want to haggle then go find a Goblin.','I sell only the best gear, tested and true. And the prices are set, so if you want to haggle then go find a Goblin.',26124),
(3387,'enUS','I sell only the best gear, tested and true. And the prices are set, so if you want to haggle then go find a Goblin.','I sell only the best gear, tested and true. And the prices are set, so if you want to haggle then go find a Goblin.',26124),
(3388,'enUS','May the light guide your path and aid you in your journeys. If you need any assistance browsing, I will be right over here.','May the light guide your path and aid you in your journeys. If you need any assistance browsing, I will be right over here.',26124),
(3389,'enUS','May the light guide your path and aid you in your journies. If you need any assistance browsing, I will be right over here.','May the light guide your path and aid you in your journies. If you need any assistance browsing, I will be right over here.',26124),
(3390,'enUS','Don\'t let the humans in the Bazaar fool ye $g lad : lass;, with the subway those gnomes built it\'s easier than ye might think to transport goods from Ironforge. If they try to tack on import fees just tell them yer gonna buy yer gear from me.','Don\'t let the humans in the Bazaar fool ye $g lad : lass;, with the subway those gnomes built it\'s easier than ye might think to transport goods from Ironforge. If they try to tack on import fees just tell them yer gonna buy yer gear from me.',26124),
(3391,'enUS','We support mystical tradesmen by carrying a limited selection of arcane trade supplies. Are you looking for something in particular?','We support mystical tradesmen by carrying a limited selection of arcane trade supplies. Are you looking for something in particular?',26124),
(3392,'enUS','Many of the supplies that tradesmen need can be found in the world. For those that cannot, I provide a limited selection for fair price.','Many of the supplies that tradesmen need can be found in the world. For those that cannot, I provide a limited selection for fair price.',26124),
(3393,'enUS','We support mystical tradesmen by carrying a limited selection of arcane trade supplies. Are you looking for something in particular?','We support mystical tradesmen by carrying a limited selection of arcane trade supplies. Are you looking for something in particular?',26124),
(3394,'enUS','Hidey ho $g sir : miss;. I would watch your step around here, I lost a bomb disguised as a mouse and I can\'t seem to find it.','Hidey ho $g sir : miss;. I would watch your step around here, I lost a bomb disguised as a mouse and I can\'t seem to find it.',26124),
(3395,'enUS','Another Engineer! Hey, this is a great chance for me to show off some new gadgets I\'ve been building!','Another Engineer! Hey, this is a great chance for me to show off some new gadgets I\'ve been building!',26124),
(3396,'enUS','If you insert tab A into slot B then of course it\'s going to go BOOM! Here, let me show you what I have and then you can ask Lilliam about how to put it together so it doesn\'t blow up.','If you insert tab A into slot B then of course it\'s going to go BOOM! Here, let me show you what I have and then you can ask Lilliam about how to put it together so it doesn\'t blow up.',26124),
(3397,'enUS','No one\'s ever stolen anything out of here. Not in the whole history of... the whole history!','No one\'s ever stolen anything out of here. Not in the whole history of... the whole history!',26124),
(3398,'enUS','I would like to check my deposit box.','I would like to check my deposit box.',26124),
(3399,'enUS','%s breaks free from his stone slumber!','',26124),
(3400,'enUS','Who dares awaken Archaedas? Who dares the wrath of the Makers?','',26124),
(3401,'enUS','What can I help you with $g sir : ma\'am;?','What can I help you with $g sir : ma\'am;?',26124),
(3402,'enUS','Welcome to the Blue Recluse, where the magically inclined gather to blow off steam. Though not literally of course. What can I get for you $g sir : ma\'am;?','Welcome to the Blue Recluse, where the magically inclined gather to blow off steam. Though not literally of course. What can I get for you $g sir : ma\'am;?',26124),
(3403,'enUS','Take my advice, don\'t sit close to the shadows.','Take my advice, don\'t sit close to the shadows.',26124),
(3404,'enUS','Welcome to the Pig and Whistle! Grab a drink my friend and pull up a seat, the more the merrier!','Welcome to the Pig and Whistle! Grab a drink my friend and pull up a seat, the more the merrier!',26124),
(3405,'enUS','Welcome to the Bank of Stormwind. We offer financial accounts and safety deposit boxes for valuable items. Do you already have an account with us $g sir : ma\'am;?','Welcome to the Bank of Stormwind. We offer financial accounts and safety deposit boxes for valuable items. Do you already have an account with us $g sir : ma\'am;?',26124),
(3406,'enUS','We are the only supplier of healthy flowers in all of Stormwind. We provide beautiful blooms for any occasion.','We are the only supplier of healthy flowers in all of Stormwind. We provide beautiful blooms for any occasion.',26124),
(3407,'enUS','Where is it ye would like to go $g lad : lass;? For just a few coin my Gryphons can get ye there faster than even the swiftest horse.','Where is it ye would like to go $g lad : lass;? For just a few coin my Gryphons can get ye there faster than even the swiftest horse.',26124),
(3408,'enUS','These great beasts know paths that ye can\'t find on foot, they\'ll get ye there fast and maybe show ye something new at the same time.','These great beasts know paths that ye can\'t find on foot, they\'ll get ye there fast and maybe show ye something new at the same time.',26124),
(3409,'enUS','I need a ride.','I need a ride.',26124),
(3410,'enUS','Speak quietly and with great care, the wrong word in these parts could get your throat cut. Now, what is it you need from me?','Speak quietly and with great care, the wrong word in these parts could get your throat cut. Now, what is it you need from me?',26124),
(3411,'enUS','Speak quietly and with great care, the wrong word in these parts could get your throat cut. Now, what is it you need from me?','Speak quietly and with great care, the wrong word in these parts could get your throat cut. Now, what is it you need from me?',26124),
(3412,'enUS','Welcome to the Stormwind Guild Registry offices. What can I help you with today?','Welcome to the Stormwind Guild Registry offices. What can I help you with today?',26124),
(3413,'enUS','How do I form a guild?','How do I form a guild?',26124),
(3414,'enUS','Welcome to the Stormwind Guild Registry offices. What can I help you with today?','Welcome to the Stormwind Guild Registry offices. What can I help you with today?',26124),
(3415,'enUS','I want to create a guild crest.','I want to create a guild crest.',26124),
(3416,'enUS','I hope ye didn\'t come all the way to the Great Forge just to stay warm. Speak up $g lad : lass;, tell me what it is I can do for ye?','',26124),
(3417,'enUS','Ye have the look of a Blacksmith to ye. Soot under the nails, steel in yer bones. Aye, very much the blood of a Blacksmith in yer veins. Which means ye\'ve come to me looking to learn a thing or two, well $g lad : lass; grab a hammer. Let\'s see what I can teach ye.','',26124),
(3421,'enUS','You look as if you need some assistance, how can I help you?','You look as if you need some assistance, how can I help you?',26124),
(3422,'enUS','What wisdom can I impart?','What wisdom can I impart?',26124),
(3423,'enUS','The spirits guide our steps as we follow our paths though life, how may I guide yours?','The spirits guide our steps as we follow our paths though life, how may I guide yours?',26124),
(3424,'enUS','Can you help me with some directions?','Can you help me with some directions?',26124),
(3425,'enUS','What are you looking for?','What are you looking for?',26124),
(3426,'enUS','Bank','Bank',26124),
(3427,'enUS','Wind Rider Master','Wind Rider Master',26124),
(3428,'enUS','Guild Master & Vendor','Guild Master & Vendor',26124),
(3429,'enUS','Class Trainer','Class Trainer',26124),
(3430,'enUS','Profession Trainer','Profession Trainer',26124),
(3441,'enUS','%s releases the flawless draenethyst sphere, allowing it to hover before him.','',26124),
(3442,'enUS','%s chants in an unknown tongue.','',26124),
(3443,'enUS','Krumn is the bull you are looking for. He can be found on the lower rise at Thunder Bluff Civic Information.','Krumn is the bull you are looking for. He can be found on the lower rise at Thunder Bluff Civic Information.',26124),
(3444,'enUS','The Thunder Bluff Bank can be found on the lower rise.','The Thunder Bluff Bank can be found on the lower rise.',26124),
(3445,'enUS','The Wind Rider Roost is atop the totem stairway in the center of town.','The Wind Rider Roost is atop the totem stairway in the center of town.',26124),
(3446,'enUS','Druid','Druid',26124),
(3447,'enUS','Hunter','Hunter',26124),
(3448,'enUS','Mage','Mage',26124),
(3449,'enUS','Priest','Priest',26124),
(3450,'enUS','Shaman','Shaman',26124),
(3451,'enUS','Warrior','Warrior',26124),
(3452,'enUS','Seek out Turak Runetotem in the Hall of Elders on the Elder Rise.','Seek out Turak Runetotem in the Hall of Elders on the Elder Rise.',26124),
(3453,'enUS','Ahh, you will need to make your way over to the Hunter\'s Hall then. Several great hunters like Holt Thunderhorn can be found there on the Hunter Rise.','Ahh, you will need to make your way over to the Hunter\'s Hall then. Several great hunters like Holt Thunderhorn can be found there on the Hunter Rise.',26124),
(3454,'enUS','A follower of the arcane are you?  Hmph!  Very well then... you can find them around the Pools of Vision underneath the Spirit Rise.','A follower of the arcane are you?  Hmph!  Very well then... you can find them around the Pools of Vision underneath the Spirit Rise.',26124),
(3455,'enUS','Father Cobb will be the one you want to talk to. He can be found under the Spirit Rise in the Pools of Vision cave.','Father Cobb will be the one you want to talk to. He can be found under the Spirit Rise in the Pools of Vision cave.',26124),
(3456,'enUS','The Hall of Spirits is where our shamans call home.  You can find it on the Spirit Rise.  May your ancestors watch over you.','The Hall of Spirits is where our shamans call home.  You can find it on the Spirit Rise.  May your ancestors watch over you.',26124),
(3457,'enUS','Aspiring to join our ranks one day?  Sark Ragetotem can help you on your way.  He\'s in the Hunter\'s Hall.','Aspiring to join our ranks one day?  Sark Ragetotem can help you on your way.  He\'s in the Hunter\'s Hall.',26124),
(3458,'enUS','Which trainer do you seek?','Which trainer do you seek?',26124),
(3459,'enUS','Which profession?','Which profession?',26124),
(3460,'enUS','Alchemy','Alchemy',26124),
(3461,'enUS','Blacksmithing','Blacksmithing',26124),
(3462,'enUS','Cooking','Cooking',26124),
(3463,'enUS','Enchanting','Enchanting',26124),
(3464,'enUS','First Aid','First Aid',26124),
(3465,'enUS','Fishing','Fishing',26124),
(3466,'enUS','Herbalism','Herbalism',26124),
(3467,'enUS','Leatherworking','Leatherworking',26124),
(3468,'enUS','Mining','Mining',26124),
(3469,'enUS','Tailoring','Tailoring',26124),
(3470,'enUS','Tracking','Tracking',26124),
(3471,'enUS','Skinning','Skinning',26124),
(3472,'enUS','Survival','Survival',26124),
(3473,'enUS','It\'s fascinating... I have heard orcs proclaim the odor of humans to be sickening and I have heard humans proclaim the odor of orcs to be wretched; yet, to me, all of the races of these lands give off the same odor: The foul, dizzying scent of greed.$B$BDo you doubt the validity of my claim? Do you not see these things that run your life as merely runoff from the greed which dictates your every decision?$B$BSo be it. As it was greed that displaced me from my home, it shall be greed that takes me back.','',26124),
(3474,'enUS','So you have returned to help Kum\'isha, $r? Do not worry, the pang that you feel in the pit of your stomach is merely your willpower collapsing.$B$BThankfully, you will not need willpower for this collection. I am certain that you will enjoy the trinkets I will have waiting for you upon your return with the item.\n','',26124),
(3475,'enUS','Success, the rift is open!! My brethren, rise and return home! The Outland awaits!','',26124),
(3476,'enUS','Hurry brothers! You must go now! I do not know how much longer the rift will remain open!','',26124),
(3477,'enUS','And now you know why I live in a crater.','',26124),
(3478,'enUS','War is a bloody, messy ordeal full of pain, suffering and death. But those that survive come back with a new respect for life. Not to mention a collection of stories to tell around the bar, full of bravery and courage. So tell me $g lad : lass;, are you here to make some stories? or just to hear some of mine?','War is a bloody, messy ordeal full of pain, suffering and death. But those that survive come back with a new respect for life. Not to mention a collection of stories to tell around the bar, full of bravery and courage. So tell me $g lad : lass;, are you here to make some stories? or just to hear some of mine?',26124),
(3479,'enUS','I wish to fight!','I wish to fight!',26124),
(3481,'enUS','Then head over to Bena\'s Alchemy on the middle rise and talk to Bena herself.  She will be able to help you master the art of potion brewing.','Then head over to Bena\'s Alchemy on the middle rise and talk to Bena herself.  She will be able to help you master the art of potion brewing.',26124),
(3482,'enUS','Looking to learn how to work an anvil and hammer, eh?  Karn Stonehoof can teach you how.  He has a smithy set up on the lower rise by the pond.','Looking to learn how to work an anvil and hammer, eh?  Karn Stonehoof can teach you how.  He has a smithy set up on the lower rise by the pond.',26124),
(3483,'enUS','There is no finer cook in Thunder Bluff than Aska Mistrunner.  Mmmmm, I can smell what she is cooking from here.  Head over to her kitchen located on the high rise.\n\nDrat... now I am hungry.','There is no finer cook in Thunder Bluff than Aska Mistrunner.  Mmmmm, I can smell what she is cooking from here.  Head over to her kitchen located on the high rise.\n\nDrat... now I am hungry.',26124),
(3484,'enUS','Check out Dawnstrider Enchanters on the middle rise then.  Teg will be more than happy to help you in whatever way he can.','Check out Dawnstrider Enchanters on the middle rise then.  Teg will be more than happy to help you in whatever way he can.',26124),
(3485,'enUS','First Aid is always a nice skill to have.  Many a time during battle has it saved my hide.  Visit Spiritual Healing on the Spirit Rise.  Pand Stonebinder can teach you all you need to know to save your hide as well.','First Aid is always a nice skill to have.  Many a time during battle has it saved my hide.  Visit Spiritual Healing on the Spirit Rise.  Pand Stonebinder can teach you all you need to know to save your hide as well.',26124),
(3486,'enUS','Don\'t blame you for taking up fishing.  Mulgore has some the best fishing spots in Southern Kalimdor and Mountaintop Bait & Tackle on the high rise has all of the gear you\'ll need to take advantage of it.\n\nTell Kah Mistrunner that I sent ya!','Don\'t blame you for taking up fishing.  Mulgore has some the best fishing spots in Southern Kalimdor and Mountaintop Bait & Tackle on the high rise has all of the gear you\'ll need to take advantage of it.\n\nTell Kah Mistrunner that I sent ya!',26124),
(3487,'enUS','Komin Winterhoof at Holistic Herbalism is the one you want to talk to then.  He can be found on the middle rise.','Komin Winterhoof at Holistic Herbalism is the one you want to talk to then.  He can be found on the middle rise.',26124),
(3488,'enUS','Go see Una at Thunder Bluff Armorers then.  It can be found on the middle rise.','Go see Una at Thunder Bluff Armorers then.  It can be found on the middle rise.',26124),
(3489,'enUS','Brek Stonehoof can be found at Stonehoof Geology on the lower rise and can teach you the proper way to harvest precious ores and gems.','Brek Stonehoof can be found at Stonehoof Geology on the lower rise and can teach you the proper way to harvest precious ores and gems.',26124),
(3490,'enUS','Tepa is renown for her clothwork.  She can be found at Thunder Bluff Armorers on the middle rise.','Tepa is renown for her clothwork.  She can be found at Thunder Bluff Armorers on the middle rise.',26124),
(3491,'enUS','There is not a better tracker in these lands than Drayl.  He can be found on the Hunter Rise.','There is not a better tracker in these lands than Drayl.  He can be found on the Hunter Rise.',26124),
(3492,'enUS','Mooranta can help you learn skinning.  She can be found just outside the Thunder Bluff Armorers on the middle rise.','Mooranta can help you learn skinning.  She can be found just outside the Thunder Bluff Armorers on the middle rise.',26124),
(3493,'enUS','Bale can teach you the ways of survival.  Look for him on the Hunter Rise.','Bale can teach you the ways of survival.  Look for him on the Hunter Rise.',26124),
(3494,'enUS','','%s is once again at peace.',26124),
(3501,'enUS','I\'ll get to work right away, $n!','',26124),
(3502,'enUS','There you have it! The King should be quite pleased, if I do say so myself.','',26124),
(3503,'enUS','The King\'s guards should be along shortly to pick up the Memorial. In the meantime, come join me upstairs and let\'s finish our little chat, $n.','',26124),
(3521,'enUS','The beasts of these blasted lands exhibit preternatural attributes, heretofore unseen in nature.$B$BWe have theorized that the energy which was released upon the opening of the Dark Portal, infused into their physical being and forced the creatures to evolve into their current forms.$B$BFearsome beasts they are, no doubt, but we also believe that they could prove to be quite useful in our studies.$B$BPerhaps you would be interested in assisting us in the study of these beasts, $n?\n','',26124),
(3541,'enUS','%s will be armed in 10 seconds!','',26124),
(3542,'enUS','%s will be armed in 5 seconds!','',26124),
(3543,'enUS','%s is now armed!','',26124),
(3561,'enUS','','While my brother, Drazial, focuses his analysis on the more physical nature of the beasts of the blasted lands, I tend to focus on the more cerebral and spiritual aspects of the wildlife.$B$BIt is true that the beasts exhibit extremely unusual strength, agility, and stamina, but some of them also possess great intelligence and regenerative abilities, untied to their physical being.$B$BPerhaps you would be interested in helping advance my research, $r?\n',26124),
(3562,'enUS','Oh! I almost forgot! I slipped you a set of thieven\' tools. You\'ll need those where you\'re going.','',26124),
(3563,'enUS','%s prepares his syringe.','',26124),
(3564,'enUS','%s examines the blood in the bottle.','',26124),
(3565,'enUS','Very interesting!','',26124),
(3566,'enUS','%s seems to be talking to the squirrel and the statue. He periodically points in your direction.','',26124),
(3567,'enUS','Just /lay down anywhere, $n. I promise, this won\'t hurt a bit!','',26124),
(3568,'enUS','This doesn\'t look good!','',26124),
(3581,'enUS','It\'s hard to imagine that so much death and despair could be confined to such a small area; yet beyond the swamp is a land plagued by chaos and destruction.$B$BWatch your step, adventurer. The Blasted Lands are the final resting place to far greater beings than you.','',26124),
(3582,'enUS','Why are you here?','Why are you here?',26124),
(3583,'enUS','Thrall\'s Grasp they called us: Twenty of Thrall\'s most accomplished and honored soldiers.$B$BI had ordered the regiment to build an encampment here, on the border of the Blasted Lands, while we waited for our orders to arrive from Orgrimmar. Weeks passed without word from the warchief; the men grew restless.$B$BIt was a judgment call, $n. I was young and ambitious, afraid of nothing. The battalion would set forth into the Blasted Lands under my command.$B$BA decision I would later regret.','',26124),
(3601,'enUS','Continue with your story.','Continue with your story.',26124),
(3602,'enUS','Regret. It is all I have now. One bad decision resulting in several horrible outcomes. If only I had waited for those orders. Maybe they would have detailed the horrors that awaited us in those cursed lands! Maybe they were to redirect us to another detail? Ultimately, it was my fault. All of it was my fault.','',26124),
(3621,'enUS','Come to me, my children!','',26124),
(3622,'enUS','How dare you enter my sanctum!','',26124),
(3641,'enUS','FREEEEEEEEEEDDOOOOMM!','',26124),
(3642,'enUS','%s\'s physical form is weakened. You notice the Stone of Binding near the creature is glowing! Strike now!','',26124),
(3643,'enUS','%s shatters, releasing the soul which it held.','',26124),
(3661,'enUS','','Just sit tight while I get this prepared for you!',26124),
(3662,'enUS','Seen any strange things in the desert lately?','Seen any strange things in the desert lately?',26124),
(3681,'enUS','Finally, the agony ceases....','',26124),
(3682,'enUS','Give my regards to Commander Trebor.','',26124),
(3683,'enUS','The Defiler... must warn Thrall... ','',26124),
(3684,'enUS','It was not his fault. Tell him that...','',26124),
(3685,'enUS','Finally, released from his cursed grasp. Father, I come... ','',26124),
(3686,'enUS','Get them my prettys...and their little dogs too!','',26124),
(3687,'enUS','Bah! Now pet eat you!','',26124),
(3688,'enUS','Now me crush you myself!','',26124),
(3689,'enUS','Let the flames of chaos engulf you!','',26124),
(3690,'enUS','Yes, sir!','Yes, sir!',26124),
(3691,'enUS','Ilifar, your master calls!','',26124),
(3692,'enUS','Face my champion, mortals!','',26124),
(3693,'enUS','Prepare yourselves for an eternity of anguish and torture - vengeance shall be mine...','',26124),
(3701,'enUS','Would you believe that in my darkest hour, at the apex of my being, I failed.$B$BAs I fled from the wanton destruction of the forces that overwhelmed us, the only sounds I could hear were the screams of my soldiers and the rapid beat of my own heart.$B$BA short while later, I returned to the Blasted Lands in hopes of rescuing my men and restoring my honor. Instead I was captured and beaten until dead.$B$BWhat I found out during my inquisition and subsequent torture was horrifying.','',26124),
(3702,'enUS','Please continue, Hero...','Please continue, Hero...',26124),
(3703,'enUS','My captors were cruel beyond measure, $n. They would alternate between Lieutenant Kirith and I, torturing one while the other watched. During a lull in the activity of an especially brutal day, Kirith told me what had happened to my men and a plan he had been formulating to free them from their masters.$B$BThey suffered a fate far worse than death, or even the pain Kirith and I  endured.','',26124),
(3704,'enUS','What could be worse than death?','What could be worse than death?',26124),
(3705,'enUS','Neither you nor I could possibly imagine the pain an individual suffers when their soul is ripped from their body. They are not dead and by no means are they alive. Instead, they walk the land, servants of those that bind them to this world.$B$BLord Razelikh, demonic overlord of these lands, enslaved them all. Nine he took for his own, placing stones of binding near the Dark Portal. The remaining nine were divided up between his subordinates.','',26124),
(3706,'enUS','Subordinates?','Subordinates?',26124),
(3707,'enUS','The archmage Allistarj of the Shadowsworn was granted three. Lady Sevine, warlock of the Shadowsworn was also granted three. The remaining three were given to Grol the Destroyer, lord of the Dreadmaul ogres of these blasted lands.$B$BYou see, $n, without a soul, the body cannot be killed. The remnants of my men are now indestructible fighting units. Thankfully, they are bound in how far they can travel by the stones of binding.','',26124),
(3708,'enUS','What are the stones of binding?','What are the stones of binding?',26124),
(3709,'enUS','They are exactly what you need to destroy in order to free the regiment! As I had told you earlier, Kirith had a plan.$B$BEach of the servants does have a weakness. Punish their physical form in proximity of their stones until they are near the state of disintegration. It is at that point, and that point alone, that the stones of binding are vulnerable to attack. You must hurry to destroy the stones, however, as once the enslaved regain their composure, they will be invulnerable to harm once more.','',26124),
(3710,'enUS','You can count on me, Hero.','You can count on me, Hero.',26124),
(3711,'enUS','I wish it were true, $n, but it will take more than you alone to overcome the forces of Razelikh and his subordinates.$B$BGather a suitable group of adventurers and would-be heroes and free my men of their eternal torture! Eighteen stones you must shatter.$B$BFight hard and die with honor, $n.','',26124),
(3712,'enUS','You must hear my story before we may continue, $n. It will be of great use to you in the future.','',26124),
(3713,'enUS','%s prepares to sting its victim as a last desperate move!','',26124),
(3721,'enUS','%s waits for the guards to be out of sight.','',26124),
(3741,'enUS','%s points to the west.','',26124),
(3742,'enUS','In need of some alchemy supplies, are we?  Or do you have other business with me?','',26124),
(3743,'enUS','Your discs are now ready!  Engage the Discs of Norgannon once again to retrieve them!','',26124),
(3744,'enUS','Oh no!  Here they come!','',26124),
(3745,'enUS','Let\'s move forward!','',26124),
(3761,'enUS','Wait here, $n. Spybot will make Lescovar come out as soon as possible. Be ready! Attack only after you\'ve overheard their conversation.','Wait here, $n. Spybot will make Lescovar come out as soon as possible. Be ready! Attack only after you\'ve overheard their conversation.',26124),
(3762,'enUS','Milord, your guest has arrived. He awaits your presence.','Milord, your guest has arrived. He awaits your presence.',26124),
(3763,'enUS','Hero, I have urgent business with Corporal Splithoof.','Hero, I have urgent business with Corporal Splithoof.',26124),
(3764,'enUS','Per your request, Corporal Splithoof has come, $n.','',26124),
(3781,'enUS','Good day to you both. I would speak to Lord Lescovar.','Good day to you both. I would speak to Lord Lescovar.',26124),
(3782,'enUS','Thank you. The Light be with you both.','Thank you. The Light be with you both.',26124),
(3783,'enUS','Of course. He awaits you in the library.','Of course. He awaits you in the library.',26124),
(3784,'enUS','Ah, thank you kindly. I will leave you to the library while I tend to this small matter.','',26124),
(3785,'enUS','Ok, here I go!','',26124),
(3786,'enUS','Get out of my sight, mortal. Your presence alone is enough to drive me to violence.','',26124),
(3787,'enUS','Rin\'ji is free!','',26124),
(3788,'enUS','Under the cover of darkness.','Under the cover of darkness.',26124),
(3789,'enUS','On the wings of death, I ride.','',26124),
(3790,'enUS','Rin\'ji can see the road now, $n. Rin\'ji knows the way home.','',26124),
(3791,'enUS','I shall use the time wisely, milord. Thank you.','I shall use the time wisely, milord. Thank you.',26124),
(3792,'enUS','Living out here in the desert is rough! I get so thirsty standing outside in this heat.','',26124),
(3793,'enUS','Yes! I want more of that fabulous Noggenfogger Elixir!','Yes! I want more of that fabulous Noggenfogger Elixir!',26124),
(3794,'enUS','Emergency power activated!  Initializing ambulatory motor!  CLUCK!','',26124),
(3795,'enUS','Physical threat detected!  Evasive action!  CLUCK!','',26124),
(3796,'enUS','Threat analyzed!  Activating combat plan beta!  CLUCK!','',26124),
(3797,'enUS','CLUCK!  Sensors detect spatial anomaly -- danger imminent!  CLUCK!','',26124),
(3798,'enUS','Stop! Omosh time!','',26124),
(3799,'enUS','Don\'t listen to that old fool, kid. He\'s like that with everyone. I\'ve been watching you, though; you got real talent. Come have a talk with me.','',26124),
(3801,'enUS','Help!$B$BIf you get me out of here, I can blow up the door that leads to the chief of Zul\'Farrak!','',26124),
(3802,'enUS','Zul\'Farrak - Weegli Blastfuse - Greeting default.','',26124),
(3803,'enUS','We have to kill more trolls!  Kill enough and I\'ll blow the door to the troll chief!','',26124),
(3804,'enUS','Thanks, $n.  If you hadn\'t shown up I\'m sure we would have been dead meat!  Now the only thing between us and the chief troll is that door yonder...','',26124),
(3805,'enUS','Will you blow up that door now?','Will you blow up that door now?',26124),
(3806,'enUS','Help!  My band and I have been captured by trolls, and they\'re going to sacrifice us!$B$BGet us out of here and I\'ll give you anything you want.','',26124),
(3807,'enUS','We don\'t have time to talk!  We have to think about those trolls!','',26124),
(3808,'enUS','Thanks a lot, $n.  We couldn\'t have made it without you.  Oh, and if I had mentioned before something about repaying you for saving us, well... you can forget it!','',26124),
(3809,'enUS','Hey Bly!  Bilgewizzle wants his divino-matic rod back!','Hey Bly!  Bilgewizzle wants his divino-matic rod back!',26124),
(3810,'enUS','Zul\'Farrak - Sergeant Bly - Greeting default.','',26124),
(3811,'enUS','I\'m out of here!','',26124),
(3812,'enUS','No one challenges the Wastewander nomads -- not even robotic chickens!  ATTACK!','No one challenges the Wastewander nomads -- not even robotic chickens!  ATTACK!',26124),
(3813,'enUS','','Hi there! I have a proposition for an adventure-seeker such as you, if you are up to the challenge!$B$BAlong with my invention, the Super Egg-O-Matic, I am hard at work aiding the druids with their campaign to save the hippogryphs. The birds are being affected by the evil effects of the Gordunni ogres inhabiting the ruins of Feralas, and their numbers are dwindling.$B$BI collect many different types of eggs.  Will you help and find some for me?',26124),
(3814,'enUS','Please tell me more about the hippogryphs.','Please tell me more about the hippogryphs.',26124),
(3815,'enUS','','In a place called Feralas to the west of here, the hippogryphs, long-time companions of the night elves, are in danger.$B$BI need you to rescue an egg from the ruins of Isildien, to the south, there. The Super Egg-O-Matic can analyze any egg brought to it and judge if it is likely to hatch. I then send the eggs along to the druids, safe from the Gordunni ogres\' dark magics.$B$BPlease know, $n, some of the rescued eggs are bad eggs, and will never hatch.',26124),
(3816,'enUS','Flight systems online!  CLUCK!  Engaging rockets for transport to Booty Bay!','',26124),
(3817,'enUS','Rin\'ji will tell you secret now... $n should go to the Overlook Cliffs. Rin\'ji hid something on island there.','',26124),
(3818,'enUS','You find it, you keep it! Don\'t tell no one that Rin\'ji talked to you!','',26124),
(3819,'enUS','Emergency power activated!  Initializing ambulatory motor!  CLUCK!','',26124),
(3820,'enUS','Flight systems online!  CLUCK!  Engaging rockets for transport to Booty Bay!','',26124),
(3821,'enUS','CLUCK!  Sensors detect spatial anomaly -- danger imminent!  CLUCK!','',26124),
(3822,'enUS','CLUCK!  Sensors detect spatial anomaly -- danger imminent!  CLUCK!','',26124),
(3823,'enUS','Flight systems online!  CLUCK!  Engaging rockets for transport to Booty Bay!','',26124),
(3824,'enUS','Emergency power activated!  Initializing ambulatory motor!  CLUCK!','',26124),
(3825,'enUS','I am almost done, $n. Just a few more adjustments!','',26124),
(3826,'enUS','DONE!','',26124),
(3827,'enUS','','Attack, my sisters! The troll must not escape!',26124),
(3828,'enUS','Stand by, $n! To craft a reward of such exquisite quality takes time.','',26124),
(3829,'enUS','Aaaaahhh! So close to escaping.','Aaaaahhh! So close to escaping.',26124),
(3830,'enUS','Tragic...','Tragic...',26124),
(3841,'enUS','I shall.','I shall.',26124),
(3861,'enUS','Rin\'ji is being attacked!','',26124),
(3862,'enUS','Rin\'ji needs help!','',26124),
(3881,'enUS','Get me out of here!','',26124),
(3882,'enUS','What?  How dare you say that to me?!?','',26124),
(3883,'enUS','Greetings, $n. Are you ready to train?','',26124),
(3884,'enUS','After all we\'ve been through?  Well, I didn\'t like you anyway!!','',26124),
(3885,'enUS','Good day to you Nogg! I require training.','Good day to you Nogg! I require training.',26124),
(3901,'enUS','Hello, $n! If you don\'t see it in my shop, chances are good I can get it!','',26124),
(3902,'enUS','Hello Sovik, I wish to browse your goods.','Hello Sovik, I wish to browse your goods.',26124),
(3903,'enUS','Come and have a talk with me if you\'re going to go to Gnomeregan, $n!','',26124),
(3904,'enUS','Give me a moment while I calibrate the transponder to your height and weight specifications, $n.','',26124),
(3905,'enUS','Alright, $n, your transponder is ready!','',26124),
(3906,'enUS','','Oh, there you are!',26124),
(3907,'enUS','','Oh, what a beautiful flower over there...',26124),
(3908,'enUS','','These trees are quite glorious, aren\'t they? ',26124),
(3909,'enUS','','Are you sure this is the right way? Maybe we should go this way instead...',26124),
(3911,'enUS','','Hmmm, I wonder what\'s over this way?',26124),
(3912,'enUS','','Are we taking the scenic route?',26124),
(3913,'enUS','','Oh, I wandered off again.  I\'m sorry.',26124),
(3914,'enUS','','This is quite an adventure!',26124),
(3915,'enUS','','I can\'t help it, really. This is just such a beautiful place.',26124),
(3916,'enUS','','The bell again, such a sweet sound.',26124),
(3917,'enUS','','Oh, here you are, Rockbiter! I\'m sorry, I know I\'m not supposed to wander off.',26124),
(3918,'enUS','','%s begins to wander off.',26124),
(3919,'enUS','Greetings $c, I am the leatherworking trainer for Darnassus.  What may I assist you with?','',26124),
(3920,'enUS','','Greetings $c, I am the leatherworking trainer for Thunder Bluff.  What may I assist you with?',26124),
(3921,'enUS','','Don\'t forget to get my bell out of the chest here. And remember, if do happen to wander off, just ring it and I\'ll find you again.',26124),
(3922,'enUS','I\'m so glad yer back, Shay. Please, don\'t ever run off like that again! What would I tell yer parents if I lost ya?','',26124),
(3923,'enUS','Please tell me more about the Gordunni ogres.','Please tell me more about the Gordunni ogres.',26124),
(3924,'enUS','','The Gordunni are a large ogre tribe that has control over considerable portions of forests in Feralas. Their dark magic seeps into the elements around them, damaging both the environment and the creatures that inhabit it.$B$BIf you do decide to travel to Feralas, please be mindful of these ogres -- they are quite nasty and many are able to wield powerful dark magic. ',26124),
(3925,'enUS','Get to work, you lubbers!','',26124),
(3926,'enUS','%s activates!','',26124),
(3927,'enUS','Self-destruct sequence activated.','',26124),
(3928,'enUS','%s cheers!','',26124),
(3929,'enUS','Thank you for rescuing me! Word of your deed will not go unnoticed.','',26124),
(3930,'enUS','%s waves goodbye to everyone.','',26124),
(3931,'enUS','Hey!  Get away from our treasure!','Hey!  Get away from our treasure!',26124),
(3932,'enUS','That\'s our treasure, you lubber!','That\'s our treasure, you lubber!',26124),
(3933,'enUS','We didn\'t hide this stuff just you could steal it!','We didn\'t hide this stuff just you could steal it!',26124),
(3934,'enUS','What?! How dare you!','',26124),
(3935,'enUS','Don\'t see many Blacksmiths this far from Ironforge. What can I do for ye?','',26124),
(3936,'enUS','The Defias shall succeed! No meek adventurer will stop us!','',26124),
(3937,'enUS','I just can\'t seem to get comfortable without a sturdy ceiling of granite over my head. All these stars up there, enough to give ye the shivers.','',26124),
(3938,'enUS','Now that\'s a piece of steel worth wearing. Form and function lad/lass, I am impressed. Only ever seen it\'s match once, a Master in the Great Forge named Grumnus Steelshaper. I bet he has learned a few things since then, could probably teach some to ye.','',26124),
(3939,'enUS','Go to the Great Forge at the very center of Ironforge. He works there, alongside the other Masters of our kind.','',26124),
(3940,'enUS','Well now, I haven\'t seen blades this fine since I left Lordaron with Proudmore and her people. I can\'t teach ye much more it seems, but if ye were to find Borgus Steelhand I bet he could show ye some things. Finest weaponsmith I ever met.','',26124),
(3941,'enUS','Borgus used to work at the Great Forge but I hear he moved down to Stormwind when they finished rebuilding. Rumor holds that he started a shop in the Dwarven District with a man named Kathrum Axehand.','',26124),
(3942,'enUS','Are you blind youngling? Shayis is standing right outside.','',26124),
(3943,'enUS','Your steel is strong, your skill stronger. Take your steel and your strength to my mate Shayis Steelfury, her skill with armor crafting is unmatched even by me.','',26124),
(3944,'enUS','Welcome to my forge, Blacksmith. Let me share with you a little secret. No one, no one in the world can you trust. Not men, not women, not beasts ... this you can trust, Steel.','',26124),
(3945,'enUS','What is it you seek at my forge? Is it training? Do you perhaps seek the secrets of steel? The mysteries of the forge? Speak up Grunt!','',26124),
(3946,'enUS','Where is he? Go next door, to the Arms of Legend. He forges special weapons for great heroes there. Honor him and he may show you how to make the stuff of legends.','',26124),
(3947,'enUS','Good blades, solid axes. I have nothing left to teach you in the making of weapons $n. Take your pride and courage before Kelgruk Bloodaxe, he will forge them into the skills you will need.','',26124),
(3948,'enUS','I see the exit! Hurry, hurry!','',26124),
(3949,'enUS','Anti-escape countermeasures activated. Self-destruct in t-minus 20 seconds....','',26124),
(3950,'enUS','Alarm-a-bomb unit 2600 has failed. Self-destruct override [ACTIVE]. Cooldown [ACTIVE].','',26124),
(3951,'enUS','Travel to Orgrimmar, to the Valley of Honor. There she lives with her husband and two daughters. All of them are smiths of great skill, but the spirits tell me that she will best guide your learning.','',26124),
(3952,'enUS','You guide the spirits in the steel to protect and defend with far more skill than I ever could. The student has surpassed the teacher and now I must send you to where your education may continue. $n, you must seek out Shayis Steelfury in Orgrimmar. She is the finest Armorsmith I have ever known, and she can teach you much.','',26124),
(3953,'enUS','Uh oh....','',26124),
(3954,'enUS','Everything has a spirit, if you learn to listen to it you can get it to take any shape you want. Blacksmithing isn\'t about beating metal, forcing it to do your will. It\'s about listening to the spirit within the steel and guiding it to the shape you know it wants to take.','',26124),
(3955,'enUS','You have the look of a $g man : woman; who seeks knowledge. Perhaps you seek the teachings of the forge, and the hammer. Perhaps I can guide you down that path. But only once you have accepted the spirits, and listened to their calling.','',26124),
(3956,'enUS','Make the journey to Orgrimmar and seek him out in the Valley of Honor. He works in a shop called the Arms of Legend.','',26124),
(3957,'enUS','That is a fine weapon indeed $n. You guide the spirits like few I have ever known. Listen to them and they will guide you as you have guided them. Go, seek out the Orc known as Kelgruk Bloodaxe. He does not speak with the spirits but he does listen, and his weapons are the finest I have ever laid my eyes upon.','',26124),
(3958,'enUS','Go to Orgrimmar, you will find her and her brood in the Valley of Honor.','',26124),
(3959,'enUS','Armor like the kind you make could stop even the sharpest axe. I\'m impressed $n, that doesn\'t happen often. Seek out an Orc named Shayis Steelfury, she makes the best armor outside of that cursed Dwarven stronghold.','',26124),
(3960,'enUS','How is the edge of your steel? Good enough to cut through the belly of your enemy? Let me show you some things to make it even sharper.','',26124),
(3961,'enUS','Want to be a smith? Want to forge blades to gut your foe? Hammers to crush his skull? Aye I can help, and gladly too if there is blood to be shed from it.','',26124),
(3962,'enUS','Go to the Orc city of Orgrimmar, find him in the Valley of Honor at a shop called the Arms of Legend.','',26124),
(3963,'enUS','These are good blades you make, $n. Cut a stone and still sharp enough to slit a throat. I have seen better though, an orc named Kelgrum Bloodaxe makes them, go and learn all he can teach you.','',26124),
(3964,'enUS','$n! How have ye been $g lad : lass;? Show me what ye\'ve learned since I saw ye last, we\'ll see if there\'s anything new I can teach ye.','',26124),
(3979,'enUS','Welcome back to the Great Forge, $n. Ye come to visit an old Dwarf or do ye think yer ready for the next step in yer training?','',26124),
(3980,'enUS','Good steel $n. Grab a hammer and come over here, let me show you the secret to forging a legendary weapon.','',26124),
(3981,'enUS','Back to learn more, $n? Come over here and show me you are ready.','',26124),
(3982,'enUS','What is it? Can\'t you see I\'m busy?','',26124),
(3983,'enUS','What is it? Can\'t you see I\'m busy?','',26124),
(3984,'enUS','','How are your travels, $n? $g Sumi and Tumi missed you, you should say hi after your lesson : I have heard tales of your adventures, sounds like you have been busy;. Now let\'s see what you\'ve learned while you were away.',26124),
(3985,'enUS','','Yes? I have a breastplate to finish so this had better be good.',26124),
(3986,'enUS','','I see potential in you $n. Now grab a hammer and some of those scraps, you need a lot of practice.',26124),
(3987,'enUS','','I don\'t train smiths with no skill, come back when you have something decent to show me.',26124),
(3988,'enUS','Greetings, $c!  Welcome to the Cathedral of Light!','',26124),
(3989,'enUS','Brzzzzt!$B$BWelcome to Matrix Punchograph 3005 stroke A, a security level alpha terminal.$B$BYou must possess a white punch card to access terminal functions.\n\n01000100 01101111 01110111 01101110 00100000 01110111 01101001 01110100 01101000 00100000 01110100 01101000 01100101 00100000 01101000 01101111 01110010 01100100 01100101 00100001','',26124),
(3991,'enUS','White security card insertion successful...$B$BDispensing security level beta unit.\n\n01010000 01101100 01100001 01111001 00100000 01110100 01101000 01100101 00100000 01010111 01100001 01110010 01100011 01100001 01110010 01100110 01110100 00100000 01110010 01101111 01101100 01100101 01110000 01101100 01100001 01111001 01101001 01101110 01100111 00100000 01100111 01100001 01101101 01100101','',26124),
(3992,'enUS','Brzzzzt!$B$BWelcome to Matrix Punchograph 3005 stroke B, a security level beta terminal.$B$BYou must possess a yellow punch card to access terminal functions.\n\n01000111 01101110 01101111 01101101 01100101 01110010 01100011 01111001 00100001','',26124),
(3993,'enUS','Yellow security card insertion successful.  Dispensing security level chi unit.\n\n01010100 01101000 01100101 00100000 01001100 01101001 01100011 01101000 00100000 01001011 01101001 01101110 01100111 00100000 01101100 01101001 01110110 01100101 01110011 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001 00100001','',26124),
(3994,'enUS','Brzzzzt!$B$BWelcome to Matrix Punchograph 3005 stroke C, a security level chi terminal.$B$BYou must possess a blue punch card to access terminal functions.\n\n01010010 01100101 01100011 01101001 01110000 01100101 00111010 00100000 01001101 01100101 01100011 01101000 01100001 01101110 01101001 01100011 01100001 01101100 00100000 01000011 01101000 01101001 01100011 01101011 01100101 01101110 00100000 01010011 01101111 01110101 01110000','',26124),
(3996,'enUS','Blue security card insertion successful.  Dispensing security level delta unit.\n\n01010000 01101100 01100001 01111001 00100000 01001101 01101111 01110010 01100101 00100000 01010111 01101111 01010111','',26124),
(3997,'enUS','Here goes nothing!','',26124),
(3998,'enUS','Not one word....','',26124),
(3999,'enUS','%s laughs hysterically.','',26124),
(4000,'enUS','Hah! Serves you right, you filthy trogg!!','',26124),
(4001,'enUS','Acquire Higher Level Access Card','Acquire Higher Level Access Card',26124),
(4002,'enUS','Brzzzzt!$B$BWelcome to Matrix Punchograph 3005 stroke D, a security level delta terminal.$B$BYou must possess a red punch card to access terminal functions.\n\n01010011 01101000 01101111 01110010 01110100 00100000 01100001 01101110 01100100 00100000 01110011 01110111 01100101 01100101 01110100','',26124),
(4003,'enUS','Acquire high level data card.','Acquire high level data card.',26124),
(4004,'enUS','Red security card insertion successful.  Dispensing security level delta data card.\n\n00111100 01101001 01101110 01110011 01100101 01110010 01110100 00100000 01100110 01110101 01101110 01101110 01111001 00100000 01101101 01100101 01110011 01110011 01100001 01100111 01100101 00100000 01101000 01100101 01110010 01100101 00111110','',26124),
(4005,'enUS','Eraka no Kimbul$BGod of Tigers, Lord of Beasts, King of Cats, the Prey\'s Doom$B$BUeetay no Mueh\'zala$BGod of Death, Father of Sleep, Son of Time, the Night\'s Friend.','',26124),
(4006,'enUS','Continue reading...','Continue reading...',26124),
(4007,'enUS','Elortha no Shadra$BGod of Spiders, Mother of Venom, Silk Dancer, Death\'s Love.','',26124),
(4008,'enUS','Use engineering to access hidden schematics!','Use engineering to access hidden schematics!',26124),
(4009,'enUS','The Matrix Punchograph Technologic Huerist-o-meter has detected your aptitude in engineering.  You may now choose from the following option(s):\n\n01000111 01101111 00100000 01100111 01101111 00100000 01100111 01101111 00100001 00100001','',26124),
(4010,'enUS','Access: Minor Recombobulator','Access: Minor Recombobulator',26124),
(4011,'enUS','Accessing...\n\nVoid -- engineer <#skill_level == n3wb>\n \n01000111 01100001 01101101 01100101 00100000 01001111 01110110 01100101 01110010\n\nACCESS DENIED!','',26124),
(4012,'enUS','Data access granted.  Have a nice day!\n\n01001110 01100001 01110100 01100001 01101100 01101001 01100101 00100000 01010000 01101111 01110010 01110100 01101101 01100001 01101110 00100000 01010010 01101111 01100011 01101011 01110011','',26124),
(4013,'enUS','','Fresh bread for sale!',26124),
(4014,'enUS','','Fresh bread, baked this very morning.',26124),
(4015,'enUS','','Come get yer fresh bread!',26124),
(4018,'enUS','Klaven doesn\'t pay me enough to deal with zombies, drones, or whatever he calls \'em.','Klaven doesn\'t pay me enough to deal with zombies, drones, or whatever he calls \'em.',26124),
(4019,'enUS','','Juicy fruits for sale!',26124),
(4020,'enUS','','Sink your teeth into a fresh, ripe apple.',26124),
(4021,'enUS','','Straight from the lush forests of Elwynn, get your fresh fruit right here.',26124),
(4039,'enUS','Feralas: A History... Hmmmm... Let me examine this for a moment.','',26124),
(4040,'enUS','%s skims the pages of the book.','',26124),
(4041,'enUS','Amazing! I think I have found it, $n!','',26124),
(4042,'enUS','','Take a look around, $n. Perhaps you will find something that I have missed.',26124),
(4043,'enUS','','%s gestures at the piles of books.',26124),
(4045,'enUS','','Please, a moment, $n. Kindal is down below in the Grimtotem camp trying to free the faerie dragons from captivity. We were just lucky that help came along when it did. Who knows what those foul tauren would have done to them.',26124),
(4046,'enUS','','Aw! The captured sprite darters didn\'t make it. What will we do?',26124),
(4047,'enUS','','Yeah! They made it! The captured sprite darters made it!',26124),
(4048,'enUS','Primary interaction complete.  Image dissipation in ten minutes.','',26124),
(4049,'enUS','Salutations!  I am a guardian of entry.  Please use the proper discs for access to Uldum.','',26124),
(4050,'enUS','','With your help, I can evaluate these tunnels.',26124),
(4051,'enUS','','Let\'s see if we can find out where these Troggs are coming from.... and put a stop to the invasion!',26124),
(4052,'enUS','','Such devastation... what a horrible mess...',26124),
(4053,'enUS','Salutations.  I am a guardian of entry.  Unless you have the Plates of Uldum already integrated with your disc set, I will not allow for entry into the Uldum compound.','',26124),
(4054,'enUS','What function do you serve?','What function do you serve?',26124),
(4055,'enUS','My purpose is to regulate access to the Uldum complex for the Creators.  I allow entry into the compound only when the solicitor exhibits for access the proper sequencing discs.$B$BYour disc set currently does not contain the Plates of Uldum, the primary prerequisite for entry.  Access is not granted unless the Plates of Uldum are present.','',26124),
(4056,'enUS','What are the Plates of Uldum?','What are the Plates of Uldum?',26124),
(4057,'enUS','Where are the Plates of Uldum?','Where are the Plates of Uldum?',26124),
(4058,'enUS','Excuse me?  We\'ve been \"rescheduled for visitation\"?  What does that mean?!','Excuse me?  We\'ve been \"rescheduled for visitation\"?  What does that mean?!',26124),
(4059,'enUS','So... what\'s inside Uldum?','So... what\'s inside Uldum?',26124),
(4060,'enUS','I will return when I have the Plates of Uldum.','I will return when I have the Plates of Uldum.',26124),
(4061,'enUS','The Plates of Uldum are discs synthesized by the Creators that allow access into the Uldum compound.  These discs house and store specific data related to the Creators\' activities here.$B$BPhysically, they are nearly identical in circumference to the disc set you currently possess.  Their markings, however, are directly related to information on Uldum as opposed to the Uldaman complex.','',26124),
(4062,'enUS','Several sets of the Plates of Uldum have been synthesized by the Creators for their expressed use.  The Creators control the distribution of said discs for all complexes on this world.  As such, Azeroth has been rescheduled for visitation, and therefore future discs may enter circulation at that time.$B$BExisting discs have been fully distributed to those parties with appropriate security clearance.','',26124),
(4063,'enUS','The Creators use visitation as a means to reestablish control over seeded worlds when forces, both external and internal, upset the matrix dynamics associated with it.  Such tactics are not to be taken lightly when executed by the Creators.$B$BFor additional information on this world\'s scheduled visitation, please consult the appropriate data repository that fields all Creator-related scheduling considerations.','',26124),
(4064,'enUS','Uldum is a research facility for the Creators in their continuing efforts to enhance the biosphere of Azeroth.  Specific information regarding their work as it relates to Uldum is restricted to those individuals who possess the Plates of Uldum in their disc sets.$B$BData repositories inside the Uldum complex have been programmed to address specific experiments and data compilations; please refer to them for detailed information.','',26124),
(4065,'enUS','Your discs will be returned to you once you access the pedestal.','',26124),
(4079,'enUS','','I\'m ready when you are, $n. Lead the way!',26124),
(4080,'enUS','','We\'ve done it! Meet me back by Jer\'kai above the Grim Totem camp.',26124),
(4081,'enUS','','No! The faerie dragons aren\'t making it, $n! I must return to Jer\'kai to make sure she hasn\'t been found. Elune be with you.',26124),
(4083,'enUS','','Thank the light you are here! I\'d accept help from a two-headed ogre at this point.\n\nThe city has been overrun by troggs! The attempts to wipe them out resulted in mass contamination. But there is still hope.\n\nOur scientists who evacuated to Ironforge are working on a cure for the fallout sickness. Meanwhile, if you can help me stop the trogg invasion, perhaps the city can be retaken. ',26124),
(4084,'enUS','I am ready to begin.','I am ready to begin.',26124),
(4102,'enUS','Give me a couple minutes, $n. There was some excitement in here a moment ago, and I just want to make sure things have died back down. I\'ll talk to you soon enough.','',26124),
(4122,'enUS','','Quickly! $n attacks!',26124),
(4123,'enUS','','Die, $n. Elune will not have you harm her creatures any longer!',26124),
(4124,'enUS','','Death to you, $n. How dare you come within a bow\'s shot of me!',26124),
(4125,'enUS','','You dare touch me?!',26124),
(4126,'enUS','Make no sound during the ritual.  One misstep could spell our doom...','',26124),
(4127,'enUS','Now, watch...','',26124),
(4128,'enUS','There.  It is done.','',26124),
(4129,'enUS','','It\'s quiet here....',26124),
(4130,'enUS','','...too quiet.',26124),
(4131,'enUS','','Look! Over there at the tunnel wall!',26124),
(4132,'enUS','','Trogg incursion! Defend me while I blast the hole closed!',26124),
(4133,'enUS','','I don\'t think one charge is going to cut it. Keep fending them off!',26124),
(4134,'enUS','','The charges are set. Get back before they blow!',26124),
(4135,'enUS','','Incoming blast in 10 seconds!',26124),
(4136,'enUS','','Incoming blast in 5 seconds. Clear the tunnel! Stay back!',26124),
(4137,'enUS','','FIRE IN THE HOLE!',26124),
(4138,'enUS','','%s chirps a goodbye to $n.',26124),
(4139,'enUS','Welcome to Blue Moon Odds and Ends, $c.  If you have any questions, please let me know.','',26124),
(4142,'enUS','Warning! Warning! Intruder alert! Intruder alert!','',26124),
(4162,'enUS','Sir?','Sir?',26124),
(4163,'enUS','Stand guard -- intruders are near.','Stand guard -- intruders are near.',26124),
(4165,'enUS','That\'s it!  I\'m tired of helping you out.  It\'s time we settled things on the battlefield!','That\'s it!  I\'m tired of helping you out.  It\'s time we settled things on the battlefield!',26124),
(4166,'enUS','Lunch has arrived, my beautiful children. Tear them to pieces!','',26124),
(4167,'enUS','Access: Discombobulator Ray','Access: Discombobulator Ray',26124),
(4169,'enUS','I\'m glad the commotions died down some around here. The last thing this place needs is another brawl.','',26124),
(4170,'enUS','Brzzzzt!$B$BWelcome to Matrix Punchograph 3005 stroke A, a security level alpha terminal.$B$BWhite punch card detected.  Access Granted.\n\n01010100 01100101 01101100 01101100 00100000 01111001 01101111 01110101 01110010 00100000 01100110 01110010 01101001 01100101 01101110 01100100 01110011 00100000 01110100 01101111 00100000 01110000 01101100 01100001 01111001 00100000 01010111 01101111 01010111','',26124),
(4171,'enUS','Brzzzzt!$B$BWelcome to Matrix Punchograph 3005 stroke B, a security level beta terminal.$B$BYellow punch card detected.  Access Granted.\n\n01001011 01101001 01110011 01110011 00100000 01101101 01100101 00101100 00100000 01001001 00100111 01101101 00100000 01100111 01101110 01101111 01101101 01101001 01110011 01101000 00100001','',26124),
(4172,'enUS','Brzzzzt!$B$BWelcome to Matrix Punchograph 3005 stroke C, a security level chi terminal.$B$BBlue punch card detected.  Access Granted.\n\n01000111 01101110 01101111 01101101 01100101 01110010 01100101 01100111 01100001 01101110 00100000 01100110 01101111 01110010 01100101 01110110 01100101 01110010 00100001','',26124),
(4173,'enUS','Brzzzzt!$B$BWelcome to Matrix Punchograph 3005 stroke D, a security level delta terminal.$B$BRed punch card detected.  Access Granted.\n\n01001000 01101111 01110111 00100000 01100001 01101101 00100000 01001001 00100000 01100100 01110010 01101001 01110110 01101001 01101110 01100111 00111111','',26124),
(4175,'enUS','%s gathers the materials together and begins to work.','',26124),
(4176,'enUS','I have completed the weapons, $n.','',26124),
(4177,'enUS','Rise and defend your master!','',26124),
(4178,'enUS','The children of Sul will protect their master. Rise once more Sul\'lithuz!','',26124),
(4179,'enUS','Incredible power can be found in the spirits or \"muisek\" of the creatures that we battle against.$B$BLook inside yourself; learn to harness the power of your own spirit, and you will be more powerful than you ever imagined.','',26124),
(4180,'enUS','The muisek vessels are now ready, $n.','',26124),
(4181,'enUS','%s begins the ritual.','',26124),
(4182,'enUS','Sul\'thraze... the first time I heard the word uttered I was around your age. It meant nothing to me then, as it means nothing to you now. It was not until a warband of trolls coming from Zul\'Farrak laid waste to the land that I understood... and feared.$B$BMany will tell you that the Splitblade of Suffering does not exist. That it\'s a myth; a rumor started to scare children. But believe me, $r, it exists.$B$B<Trenton loses focus as he runs his hand across the jagged scar on his face.>','',26124),
(4183,'enUS','Tell me more, Trenton.','Tell me more, Trenton.',26124),
(4184,'enUS','Split in two to form the one. The twin blades are bound to Zul\'Farrak.$B$BSul\'thraze will be reborn when the twins are found.','',26124),
(4185,'enUS','Skulls you will give and skulls I will take.','',26124),
(4186,'enUS','Be healed, my pets!','',26124),
(4206,'enUS','','Well done! Without your help I would have never been able to thwart that wave of troggs.',26124),
(4207,'enUS','','Did you hear something?',26124),
(4208,'enUS','','I heard something over there.',26124),
(4209,'enUS','','More troggs! Ward them off as I prepare the explosives!',26124),
(4210,'enUS','Never shall you find the twin blades of Sul.','',26124),
(4211,'enUS','There is no escape!','',26124),
(4212,'enUS','Succumb to the gaze, mortals!','',26124),
(4213,'enUS','You will pay for that...','',26124),
(4214,'enUS','The servants of sul will feast on your remains.','',26124),
(4215,'enUS','Death is merely a doorway to rebirth. The brood shall rise again.','',26124),
(4216,'enUS','','',26124),
(4225,'enUS','The guards of Theramore are the finest group of Alliance soldiers based in Kalimdor. It is our duty to uphold the laws of the Alliance even so far away from our homes.','',26124),
(4226,'enUS','We don\'t know much about the burning of the Shady Rest Inn, except that James Hyal\'s wife and child were unable to escape.$b$bWe managed to drag James out, but he hasn\'t been the same since.$b$bWe have many leads but not much evidence. It is our hope that through the efforts of the guard and the vigilant help of the people of Theramore, we will unravel this terrible crime.$b$bIf you would like to lend assistance to the investigation, what remains of the inn can be found at the border to the Barrens.','',26124),
(4227,'enUS','What have you heard of the Shady Rest Inn?','What have you heard of the Shady Rest Inn?',26124),
(4228,'enUS','You freed Kirith from his suffering? Inconceivable -- and now Trebor has sent you here to learn of demons and their minions?$B$B<Loramus laughs.>$B$BBe thankful the arcane pangs have finally dissipated, $r.','',26124),
(4229,'enUS','Can you see them, mortal? No... I did not think you could. Sighted but sightless - it is your gift and your curse.','',26124),
(4230,'enUS','Hail, Loramus. I bring word from the Blasted Lands.','Hail, Loramus. I bring word from the Blasted Lands.',26124),
(4245,'enUS','Will you help?','Will you help?',26124),
(4246,'enUS','In the age of war, Razelikh the Defiler served as the most fearsome of Lord Kazzak\'s lieutenants. When the Legion was defeated and Kazzak forced back into the Tainted Scar, Razelikh was tasked by his master to secure the Blasted Lands.$B$BWhile the Alliance fought petty battles with the Horde over territory outside of the Blasted Lands, Razelikh was uniting the differing Shadow Council sects and the brutish Dreadmaul ogres of the land.','',26124),
(4247,'enUS','Please continue.','Please continue.',26124),
(4248,'enUS','Tragically, it was Thrall\'s wisdom that finally sealed the bond between the demon lord and his minions. It was Trebor\'s regiment that served as the catalyst to unite the demon lord, the shadowsworn sects and the ogres. The lure of nearly unlimited power and the granting of immortal shock troops to each respective leader sealed the deal in blood.\n','',26124),
(4249,'enUS','I do not understand.','I do not understand.',26124),
(4250,'enUS','What Sevine, Allistarj, and Grol did not realize was that just as their servants were bound to the land, so would they be... You see, the price for their own immortality was also imprisonment and eternal servitude under the command of Razelikh. The cruel cunning of Razelikh had emerged the victor once again.\n','',26124),
(4251,'enUS','Indeed.\n','Indeed.\n',26124),
(4252,'enUS','Their minds are now tainted, $r. Yes, even more so than before. They live only to serve and protect Razelikh. The amulet fragments they each hold are the key to summoning the demon lord. What you do not understand is that none of them can be harmed through any conventional means','',26124),
(4253,'enUS','Their minds are now tainted, $r. Yes, even more so than before. They live only to serve and protect Razelikh. The amulet fragments they each hold are the key to summoning the demon lord. What you do not understand is that none of them can be harmed through any conventional means.','',26124),
(4254,'enUS','I will do this with or without your help, Loramus.\n','I will do this with or without your help, Loramus.\n',26124),
(4255,'enUS','Then let us pretend that you undergo the long and arduous task of creating the bane necessary to break through the demonic wards placed upon the triad. What would be your next course of action? To face the Defiler in his lair?$B$B<Loramus laughs.>\n','',26124),
(4256,'enUS','Yes.\n','Yes.\n',26124),
(4257,'enUS','I wish to hear your story.','I wish to hear your story.',26124),
(4258,'enUS','The humans claimed much of the Dustwallow Marsh for themselves, but the Stonemaul clan, with our help, has been able to push them back.','',26124),
(4259,'enUS','The Burning Inn.','The Burning Inn.',26124),
(4260,'enUS','The humans built an inn on the edge of the Barrens. The Shady Rest, they called it. Weeks ago, it was burned down.$b$bWhy do I care? I don\'t-not about the humans anyway-but I had a spy placed in that inn and I will not let his death go unanswered. I need to know who did this.$B$BIf you wish to provide assistance, go to the remains of the Shady Rest Inn and return any clues you find to me.','',26124),
(4261,'enUS','Finding Reethe.','Finding Reethe.',26124),
(4262,'enUS','If Reethe is somehow involved with the burning of the Shady Rest Inn, you\'ll have to find him and get some answers out of him.$b$bI sent Ogron to track him down. He was headed off to the southeast, toward the main road through the marsh. Meet up with Ogron and then go find Reethe.','',26124),
(4265,'enUS','','I don\'t care to hear it, $n. Nope, no way are you going to be let into the Searing Gorge. Impossible. Not going to happen. How many times do I have to tell you - I can\'t let you in! Do you not speak common? Are you an orc in disguise? N-O. NO!$B$BIf I let you in, then I have to let everybody in. Pretty soon your close friends will want in, then their distant relatives, then their friends, and so on and so forth. The last time that happened... well, we won\'t talk about the last time it happened. ',26124),
(4266,'enUS','What\'s the worst that could happen?','What\'s the worst that could happen?',26124),
(4267,'enUS','','Are you mad? Do you know what manner of beast inhabit that place? The worst that can happen is that we\'ll have to scoop up your remains with a shovel. We\'ve lost some good dwarves to those awful monsters.$B$BSo the answer is no. If you\'re bent on getting to the Searing Gorge, you\'ll have to find another way.',26124),
(4268,'enUS','Another way? Do tell...','Another way? Do tell...',26124),
(4269,'enUS','','I shouldn\'t even be telling you this but if you can make it past all the critters and beasties in Badlands, you might be able to make it to Searing Gorge.$B$BYes, the Badlands. There\'s some type of back road the orcs paved near Kargath. Just goes to show you what kind of fools we\'re dealing with here! A backdoor to hell? What were they thinking?',26124),
(4270,'enUS','Orcs? Badlands? I\'m invulnerable!','Orcs? Badlands? I\'m invulnerable!',26124),
(4271,'enUS','','Invulnerable?',26124),
(4272,'enUS','Absolutely!','Absolutely!',26124),
(4273,'enUS','','You\'re a fool that should heed my warnings. No one is invulnerable. You would be wise to remember that bit of advice.',26124),
(4274,'enUS','My apologies, Pebblebitty.','My apologies, Pebblebitty.',26124),
(4275,'enUS','','I\'ll tell you what. Since you fancy yourself the hero type, if you can make your way through the Badlands to the Searing Gorge and bring me back something to prove your heroics, I\'ll see what I can do about getting you a key.$B$BIn the southeasternmost corner of Searing Gorge is a lady almost as tough as me, Margol the Rager. Maybe you should investigate.',26124),
(4276,'enUS','Done, done, and done.','Done, done, and done.',26124),
(4285,'enUS','%s dusts the base of the artifact.','',26124),
(4286,'enUS','%s meticulously examines the large vase.','',26124),
(4287,'enUS','Poor Dorius. If I ever get my hands on those Dark Irons, so help me...','',26124),
(4305,'enUS','I have just the spot for this horn!','',26124),
(4306,'enUS','I\'ve been saving this spot for something special. I don\'t think it gets any more special than this, $n.','',26124),
(4307,'enUS','There we go. All done!','',26124),
(4308,'enUS','What can I do at an inn?','What can I do at an inn?',26124),
(4309,'enUS','When you stay at an inn, you rest very comfortably.  Because of this, you will become \"well rested\" much more quickly than you would in the wilderness.  When you are well rested, you learn more from experience.$B$BYou may also speak with any innkeeper to get a hearthstone, and can later use the hearthstone in order to quickly return to that inn.','When you stay at an inn, you rest very comfortably.  Because of this, you will become \"well rested\" much more quickly than you would in the wilderness.  When you are well rested, you learn more from experience.$B$BYou may also speak with any innkeeper to get a hearthstone, and can later use the hearthstone in order to quickly return to that inn.',26124),
(4325,'enUS','','The final charge is set. Stand back!',26124),
(4326,'enUS','','10 seconds to blast! Stand back!!!',26124),
(4327,'enUS','','5 seconds until detonation!!!!!',26124),
(4328,'enUS','We come from below! You can never stop us!','',26124),
(4329,'enUS','','Nice work! I\'ll set off the charges to prevent any more troggs from making it to the surface.',26124),
(4345,'enUS','Stop... need to catch.... my breath.','',26124),
(4346,'enUS','The secrets of Suntara will not leave these lands.','',26124),
(4347,'enUS','Ragnaros sees all, mortal.','',26124),
(4348,'enUS','Where does my path now lead, Jorn?','Where does my path now lead, Jorn?',26124),
(4349,'enUS','You are well on your way, $n.  But you still have much to learn.  The southern Barrens may be where your next lesson is found.','',26124),
(4350,'enUS','Although we call this land the Barrens, to one who knows where to look this place teems with life.','',26124),
(4351,'enUS','I\'m about to open a can on this $n.','',26124),
(4352,'enUS','Are you going to let an injured dwarf do all the work for you?','',26124),
(4353,'enUS','It\'s on! $n, meet my fists. Fists, say hello to $n.','',26124),
(4354,'enUS','This is the place, $r: The Cauldron! Mark it on a map or do something so that you don\'t forget. If anything ever happened to me, my team would be stuck in that mine forever.','',26124),
(4355,'enUS','Onward! And be on guard this time! I\'m not going to carry anymore fights.','',26124),
(4356,'enUS','I\'ve got to quit smoking! Give me a minute to catch my breath.','',26124),
(4357,'enUS','We\'re almost to safety. From here, we run. Try not to get too far behind! GO!','',26124),
(4358,'enUS','He\'s mine...','',26124),
(4359,'enUS','ARRRRRGH! He got me!','',26124),
(4360,'enUS','%s sniffs the air...','',26124),
(4361,'enUS','%s feasts!','',26124),
(4362,'enUS','%s disappears in a cloud of dust.','',26124),
(4363,'enUS','The gate is in sight! We\'re going to make it! But first, I need to take a breather.','',26124),
(4364,'enUS','You know not what you do!  We must destroy you for your own good.','',26124),
(4365,'enUS','Hear ye, denizens of Tanaris! Let it be known that $n is an exalted member of the Mithril Order. A blacksmith of honor, dedication, and infinite patience. Three cheers for $n!','',26124),
(4366,'enUS','It\'s in the hole!  It\'s in the hole!','',26124),
(4367,'enUS','He shoots, he scores!','',26124),
(4368,'enUS','From way downtown!','',26124),
(4370,'enUS','It\'s up and....it\'s good!','',26124),
(4371,'enUS','He puts the rock into the hole!','',26124),
(4372,'enUS','Swish!  We are on fire today boys.','',26124),
(4373,'enUS','GOOOOOOOAAAAAAAALLLLLLLLLLL!','',26124),
(4374,'enUS','In the pipe, 5 by 5!','',26124),
(4375,'enUS','Aye, it\'s a cold one today, but ne\'er too cold to offer you my fine wares!','',26124),
(4376,'enUS','I sell the finest cloth and leather garb this side of the valley!','',26124),
(4377,'enUS','There\'s nothing like some scalding mornbrew on a chilly Dun Morogh day to get things started right!','',26124),
(4378,'enUS','Oooooo hot hot hot!  If that won\'t put spring in your step, I don\'t know what will!','',26124),
(4379,'enUS','I\'ve been here long enough, $n. I\'m sure we\'ll meet again. Good luck!','',26124),
(4380,'enUS','','Infidels!',26124),
(4381,'enUS','','You dare interrupt our prayer? Execute them!',26124),
(4382,'enUS','','You will make a fitting sacrifice to Ragnaros.',26124),
(4383,'enUS','','Excellent, fresh blood has arrived.',26124),
(4384,'enUS','Tell me about the Glowing Shard.','Tell me about the Glowing Shard.',26124),
(4385,'enUS','','You\'ve come further than many, $n. Respect the elements around you and you shall fare far greater than most.',26124),
(4390,'enUS','You have returned to finish the job? <Lathoric laughs.> Obsidion rise and annihilate them!','',26124),
(4391,'enUS','Your task is complete. Prepare to meet your doom.','',26124),
(4392,'enUS','Obsidion rise and serve your master!','',26124),
(4393,'enUS','Bravo! Bravo! Good show. What? You thought I was dead?','',26124),
(4394,'enUS','Fools, I knew that if I played upon my brother\'s feeble emotions, he would send \'rescuers.\'','',26124),
(4395,'enUS','How easy it was to manipulate you into recovering the last Suntara stone from those imbeciles of the Twilight\'s Hammer.','',26124),
(4396,'enUS','When I stumbled upon the Suntara stones at the Grimesilt Digsite, the power of Ragnaros surged through my being. It was Ragnaros that gave me a purpose.','',26124),
(4397,'enUS','It was the will of Ragnaros that Obsidion be built. Obsidion will destroy the Blackrock orcs of Blackrock Spire, uniting us with our brethren in the fiery depths.','',26124),
(4398,'enUS','And ultimately, it was Ragnaros that named me when I was reborn as an acolyte of fire: Lathoric... Lathoric the Black.','',26124),
(4399,'enUS','%s\'s laughter trails off...','',26124),
(4400,'enUS','The altar seems to beckon to you as if it were alive.','',26124),
(4401,'enUS','Touch the Suntara stone and call forth Lathoric the Black and his guardian, Obsidion.','Touch the Suntara stone and call forth Lathoric the Black and his guardian, Obsidion.',26124),
(4402,'enUS','','I know of a druid that lives atop the hill above the Wailing Caverns,$n. She might be able to tell you more about this shard you have found.',26124),
(4403,'enUS','Guards! Help me!','Guards! Help me!',26124),
(4404,'enUS','','Greetings, $n. May Elune\'s wisdom guide your hand and heart. How may I help you today?',26124),
(4405,'enUS','Salutations, Astarii. I require training.','Salutations, Astarii. I require training.',26124),
(4406,'enUS','Been waitin\' for ya, $n. Glad to see you\'ve come through. Do you have the shipment?','',26124),
(4407,'enUS','Praise Elune! It has been many years since I have had visitors.','',26124),
(4408,'enUS','I wish to hear your tale.','I wish to hear your tale.',26124),
(4409,'enUS','As a young night elf in Darkshore, I crossed paths with a group of unsavory individuals known as the Twilight\'s Hammer. A group of them befriended me and shamefully, I ended up eschewing my faith in Elune and embracing the vitriol of the Twilight\'s Hammer.$B$BIt was not until a vision came to me from Elune, that I woke up from the malaise that I had fallen into as a follower of the old gods.$B$BIn repentance, I began work on my prayer to Elune. ','',26124),
(4410,'enUS','Please continue, Zamael.','Please continue, Zamael.',26124),
(4411,'enUS','Etched into a tablet of pure gold was the embodiment of my remorse, shame, regret, and sorrow. Unfortunately, the Twilight\'s Hammer found the tablet and branded me a blasphemer. I was summarily executed, my prayer to Elune incomplete. I am now bound to this world as a spirit, unable to transcend to the Nether; held in this cage as a warning to all that would betray the faith of the Twilight\'s Hammer.\n','',26124),
(4412,'enUS','Let me think about it, Zamael.','Let me think about it, Zamael.',26124),
(4413,'enUS','Raze need go home now. Bye, bye, $r.','',26124),
(4414,'enUS','','Use this Staff of Command on Raze when you are near Shadowsilk Poachers and he will make them rue the day they decided to poach in these lands.',26124),
(4415,'enUS','Bye, bye, tiny little $r. Raze go now.','',26124),
(4416,'enUS','The ancient Altar of Hakkar stands silently near the entrance to the room.$B$BLooking to the balconies above it, you notice a large serpent-like statue rests on each. The statues look very much like the ones on the altar before you. They must be related in some way...','The ancient Altar of Hakkar stands silently near the entrance to the room.$B$BLooking to the balconies above it, you notice a large serpent-like statue rests on each. The statues look very much like the ones on the altar before you. They must be related in some way...',26124),
(4417,'enUS','How could the altar and the statues be related?','How could the altar and the statues be related?',26124),
(4418,'enUS','I want to begin the statue puzzle.','I want to begin the statue puzzle.',26124),
(4419,'enUS','Tell me more about muisek.','Tell me more about muisek.',26124),
(4420,'enUS','Existing in this area are many creatures considered allies of the night elves. The elves have had access to the power within each of these creatures; it is time that the horde be allowed this same satisfaction. I have devised a way that this power can be captured and used for our benefit.$B$BDo not doubt what I tell you, $n. Help me, and you shall see that I speak truth.','',26124),
(4421,'enUS','There\'ll be a new trade risin\' up round your carcass, $n. We\'ll call it \'flesh-craftin.\'','',26124),
(4422,'enUS','All they be doin\' is a little huntin\' and gatherin\'. Where\'s the harm in that??','',26124),
(4423,'enUS','If tailoring is your thing, Vizzklick will most definitely have your supplies. Take a look around, $n, and let me know if you wish to purchase something!','',26124),
(4424,'enUS','I wish to browse your wares.','I wish to browse your wares.',26124),
(4425,'enUS','Grab your things, $n! I\'ve just gotten word from Nilith Lokrav in the Searing Gorge that the Undermarket has set up operations in the heart of the Cauldron. Find Nilith Lokrav in the Searing Gorge and get the low down!','',26124),
(4426,'enUS','One bright light appears accross the room, then disppears. Then you notice another beam... and then another.$B$BThey seem to be showing you a pattern.','One bright light appears accross the room, then disppears. Then you notice another beam... and then another.$B$BThey seem to be showing you a pattern.',26124),
(4427,'enUS','The statues are all in place, and you may begin the puzzle.','The statues are all in place, and you may begin the puzzle.',26124),
(4428,'enUS','%s goes into a berserker rage!','%s goes into a berserker rage!',26124),
(4429,'enUS','Vengeance shall be mine.','',26124),
(4430,'enUS','Tell me what drives this vengeance?','Tell me what drives this vengeance?',26124),
(4431,'enUS','My father was slain by the filth that inhabits the cauldron. My pleas for assistance to the Stormwind magistrate fell on deaf ears. Nay, they want not to admit that this part of the world even exists, let alone send their precious military in to administer justice.$B$BI seek vengeance, $r, plain and simple. Is there a more passionate cause in this world?','',26124),
(4432,'enUS','Continue please.','Continue please.',26124),
(4433,'enUS','As you can see, I am but one man with a lumbering oaf of a squire. The might of the Dark Iron dwarves and the beasts held in the grip of Ragnaros would surely overwhelm me alone, but I have the utmost confidence that such a brave and ambitious adventurer such as you would have no problem handling the denizens of the cauldron. Should you choose to assist me, I shall reward you with riches and wealth beyond your wildest dreams.','',26124),
(4434,'enUS','Let me confer with my colleagues.','Let me confer with my colleagues.',26124),
(4435,'enUS','We will enslave the quilboar!','',26124),
(4436,'enUS','We will spread across this barren land!','',26124),
(4437,'enUS','Soon, the Scourge will rule the world!','',26124),
(4438,'enUS','My eyes!  It burns... it burns...','',26124),
(4439,'enUS','Torture me no more!  Release me, mortal!  The Swamp of Sorrows... mortal... please...','',26124),
(4440,'enUS','Foolish mortal, I will rend your soul in two once I am released!','',26124),
(4441,'enUS','You are an agent of their wicked god, fool.  I will see you destroyed!','',26124),
(4442,'enUS','My soul is not a trinket!  Mortal, you must release me from these chains!','',26124),
(4443,'enUS','It hurts so much... Itharius, my old friend... please help me...','',26124),
(4444,'enUS','Will the nightmare ever end?!  I cannot force myself awake!','',26124),
(4445,'enUS','My charge to watch the temple has failed... my corrupted soul knows no peace...','',26124),
(4446,'enUS','','Superb! Because of your help, my people stand a chance of re-taking our beloved city. Three cheers to you!',26124),
(4447,'enUS','%s chants in an unknown tongue.','',26124),
(4448,'enUS','Be patient, $n. The torch is almost complete.','',26124),
(4449,'enUS','%s falls to one knee. He looks exhausted.','',26124),
(4450,'enUS','It is done...','',26124),
(4451,'enUS','Oh, $n, wait a minute! There\'s one more thing! Come back!','',26124),
(4452,'enUS','Conjure the Torch of Retribution, Kalaran.','Conjure the Torch of Retribution, Kalaran.',26124),
(4453,'enUS','%s is released and now bound to you, $n.','',26124),
(4454,'enUS','%s engulfs the sentry tower. The tower is ablaze!','',26124),
(4455,'enUS','I give unto you cordial salutations, $r.  You\'ve come far off the beaten path merely to speak to someone dwelling inside a cave.  I trust there is a reason for your strange, yet not unforeseen visit here.  Yes?','',26124),
(4456,'enUS','Glorious, indeed, Maltrake. It looks as if my plan worked perfectly. Wouldn\'t you say so, mortal?','',26124),
(4457,'enUS','You would not have helped the legion of Blackrock had we just asked for your assistance, now would you?','',26124),
(4458,'enUS','%s lets loose a reptilian laugh... at least you think it\'s a laugh.','',26124),
(4459,'enUS','What will we do with them, master? They are of no use to us anymore.','',26124),
(4460,'enUS','SILENCE FOOL!','',26124),
(4461,'enUS','They will live, if only to see the fruits of their labor: the destruction and chaos that will surely ensue as the legion of Blackrock invade the gorge.','',26124),
(4462,'enUS','I leave you now, mortals. Alive and with these trinkets. Maltrake! Present them with the trinkets!','',26124),
(4463,'enUS','Oh yes, the molt - do not lose it. There are those of my kin in the Burning Steppes that would craft items that only the molt of the black Dragonflight could fortify.','',26124),
(4464,'enUS','%s begins to flap his massive wings faster. He is preparing for flight.','',26124),
(4465,'enUS','The legion of Blackrock comes, dwarflings! We shall scorch the earth and set fire to the heavens. None shall survive...','',26124),
(4466,'enUS','Reset all of the statues in this room.','Reset all of the statues in this room.',26124),
(4467,'enUS','The statues all move back into their original positions.$B$BThe sequence must be started again now, from the beginning.\n','The statues all move back into their original positions.$B$BThe sequence must be started again now, from the beginning.\n',26124),
(4468,'enUS','Right away, master!','',26124),
(4469,'enUS','Greetings, $Gsir:miss;. I am Master Xylem\'s apprentice Nyrill. If you have any concerns, please feel free to bring them up with the master.$B$BI will be here to serve you when you\'re ready to return down to the base of the mountain.','',26124),
(4470,'enUS','I know who you are, $n.  Fate and forces beyond that have brought you to me for a reason, and it is one I take no pleasure in being a part of.  There are many decisions you will make in the coming times, and I hope you are wise enough to make the correct ones.$B$BBelieve me, $r, when I tell you this - there are correct choices.','',26124),
(4471,'enUS','What\'s an elf like you doing inside a cave like this?','What\'s an elf like you doing inside a cave like this?',26124),
(4472,'enUS','You are quite inquisitive, though such inquisitiveness belies a general lack of understanding.  I say this because were you to have a definite purpose in being here, the question you ask would seem pointless. $B$BWith that, I bid you good day.','',26124),
(4473,'enUS','','',26124),
(4474,'enUS','Do you know someone... or something, rather, by the name of Eranikus?','Do you know someone... or something, rather, by the name of Eranikus?',26124),
(4475,'enUS','You know I do, mortal; I am abandoning a fair number of pretenses here, and I recommend you do the same.$B$BYou have come here clearly because you know that what you possess, garnered from your actions within the Sunken Temple of the Atal\'al, has brought you to me for a purpose.  This purpose is to put my associate... my brother, to rest.  He is trapped within a nightmare within the Dream itself.  He cannot break free alone.','',26124),
(4476,'enUS','What happened to him in the first place?  When I... encountered him, he was rather malicious.','What happened to him in the first place?  When I... encountered him, he was rather malicious.',26124),
(4477,'enUS','The god that the Atal\'ai trolls had brought forth is to blame for this.  We destroyed the god\'s physical manifestation and sunk the temple, but the god was much stronger than even we had anticipated.  Its seed of corruption ran deep, twisting everything in its path.$B$BEranikus was charged to watch over the sunken temple to ensure that neither the simple Atal\'ai nor their god would rise again.  He was an unwitting victim of this corruption, and we in underestimating its potency.','',26124),
(4478,'enUS','I possess part of Eranikus\' essence.  What do you want with it... or with me?','I possess part of Eranikus\' essence.  What do you want with it... or with me?',26124),
(4479,'enUS','The fact that you are here is a first step... a correct choice if you will, in aiding Ysera\'s Dragonflight.$B$BYou may be here for purely the lure of personal gain, or you may be here because you are morally compelled.  Neither reason is important on its own, but both are in fact critical to this end: The agony that Eranikus endures is what rousted me from my Dream, and it is now my charge to see his torment ended.  I now ask you to aid me in this quest.\n','',26124),
(4480,'enUS','I will consider what you have told me.','I will consider what you have told me.',26124),
(4481,'enUS','I have given you an oathstone of Ysera\'s Dragonflight, $n.  When you are ready and able to aid us, use it, and then we may begin.','',26124),
(4482,'enUS','Good luck. Sorry I can\'t take you with me!','',26124),
(4483,'enUS','%s begins to summon wraiths out of the freezing cold air!','',26124),
(4484,'enUS','Intruders! Attack the intruders!','Intruders! Attack the intruders!',26124),
(4485,'enUS','My banishment is ended! Let the blood flow!','',26124),
(4486,'enUS','Interesting, interesting... I know of a druid that lives atop the hill above the Wailing Caverns, $n. She might be able to tell you more about this shard you have found.$B$BNow, I must get back to work!','',26124),
(4489,'enUS','%s staggers.','',26124),
(4490,'enUS','The shield be down! Rise up Atal\'ai! Rise up!','',26124),
(4491,'enUS','Mistress!! They seek to destroy your work!!','Mistress!! They seek to destroy your work!!',26124),
(4492,'enUS','Ha! Now your death is ensured!','Ha! Now your death is ensured!',26124),
(4493,'enUS','All right, stay close.  These fiends will jump right out of the shadows at you if you let your guard down.','',26124),
(4495,'enUS','','You dare! Now feel my wrath!',26124),
(4496,'enUS','The days we\'ve spent here in Azshara are not among our best and most glorious, but we are still young and blood still courses through our veins--we shall find victory here. It is only a matter of time.','',26124),
(4497,'enUS','Belgrom sent us here from Orgrimmar to aid him in an unwise Alliance, but if his gamble pays off, then it will be to the great benefit of all the Horde.$B$BToo many orcs have already perished because of his desire to please women, but he still commands us, and our honor dictates we make the best of this situation.','',26124),
(4498,'enUS','','I am not here because of honor, $n. I am here because of one orc\'s pride.$B$BIf I had not rejected Belgrom\'s offers, then I\'m sure I\'d still be in Orgrimmar taking care of real business.$B$BHis desire for women is not unknown to many of the female warriors in Durotar, but that doesn\'t stop him from being his charming self.$B$BHe\'s lucky he didn\'t pursue his desire for me much longer though--he\'d be short more than just the digits on his hands.',26124),
(4499,'enUS','','Greetings, $n. I see you\'ve come from Orgrimmar to aid us. I\'m glad. I want to be out of this forsaken forest as quickly as possible. I\'d much rather be spending my time in Orgrimmar with a good ale.$B$BAlthough I cannot wait to hear how Belgrom talked you into coming out here.',26124),
(4500,'enUS','You\'ve done it, $n! <The strangely familiar voice seems to be coming from the phial!> Hurry back! The fallout will only remain stable for thirty minutes.','',26124),
(4501,'enUS','Okay, here we go.  It\'s going to take about five minutes to shut this thing down through the ritual.  Once I start, keep the vermin off of me or it will be the end of us all!','',26124),
(4502,'enUS','Who dares?! I will destroy you!','Who dares?! I will destroy you!',26124),
(4503,'enUS','DUMMY SPELL TEST MESSAGE','DUMMY SPELL TEST MESSAGE',26124),
(4504,'enUS','Three minutes left -- I can feel the energy starting to build!  Keep up the solid defense!','',26124),
(4505,'enUS','Just two minutes to go!  We\'re half way there, but don\'t let your guard down!','',26124),
(4506,'enUS','One more minute!  Hold on now, the ritual is about to take hold!','',26124),
(4507,'enUS','That\'s it -- we made it!  The ritual is set in motion, and idol fires are about to go out for good!  You truly are the heroes I thought you would be!','',26124),
(4508,'enUS','%s lashes at your collection phial. The green glow encases you. You don\'t look so hot, pal.','',26124),
(4509,'enUS','What brings you to the Cenarion Circle, $n?','What brings you to the Cenarion Circle, $n?',26124),
(4510,'enUS','I am here for training.','I am here for training.',26124),
(4511,'enUS','I know, I know, I\'m out here in the middle of nowhere!$B$BMy home is actually in Ratchet, but after crashing my zeppelin here, I thought I might as well start the research I came here to do!','',26124),
(4512,'enUS','This spirit hovers over its fallen body.  Its ghostly eyes pierce through you as it gazes beyond...','',26124),
(4514,'enUS','Feralas - Screecher Spirit - On Quest Default Greeting','',26124),
(4515,'enUS','%s is getting really hungry!','',26124),
(4516,'enUS','%s is VERY HUNGRY!','',26124),
(4517,'enUS','','The land of Feralas has been through much, $r. The earth, the trees, the creatures; they are all changing what Feralas is and will be.$B$BThe Twin Colossals above us remain as a constant, though, throughout all that has happened here...',26124),
(4518,'enUS','To get down safely, I provide wings to those in need. ','',26124),
(4519,'enUS','Can you help me get down?','Can you help me get down?',26124),
(4520,'enUS','Well, now that you mention it, yeah, I did see something I thought was a little strange yesterday afternoon!$B$BI was running past some old troll ruins southeast of here; well, I wasn\'t really running, more like hopping... The sand\'s so hot!$B$BAnyway, so I was hopping past the ruins, when I noticed a camp set up there. Seems like a funny place to set up camp, if you ask me... I would have poked around a little more but one of those crazy big vultures chased me off.','',26124),
(4521,'enUS','Raze follow $n! Raze SMASH poachers! SMASH SMASH SMASH! Tell Raze to SMASH by playing with stick! SMASH! ','',26124),
(4522,'enUS','There! Job\'s done.','',26124),
(4523,'enUS','Don\'t worry, I\'ll find a good home for ya.','',26124),
(4524,'enUS','Can anyone give my adorable, extra little kitty a home?','',26124),
(4525,'enUS','I can\'t believe dad won\'t let me keep your sister.','',26124),
(4526,'enUS','Kitten for sale, looking for a good home.','',26124),
(4527,'enUS','What does allergic mean anyway? And what does it have to do with either of my kitties?','',26124),
(4528,'enUS','Will someone please give my little kitten a good home?','',26124),
(4529,'enUS','','No!  We cannot allow you to summon Hakkar!',26124),
(4530,'enUS','','You must not summon our god!',26124),
(4531,'enUS','','No!  You must not do this!',26124),
(4532,'enUS','','Stop!  Infidels!',26124),
(4533,'enUS','','Wha... what\'s happening?',26124),
(4534,'enUS','Thank you for saving me!$B$BI\'m a cook and an alchemist from Stormwind.  I was here looking for local herbs and recipes for my uncle Angus when these quilboar captured me.  If you hadn\'t come around, I\'m sure I\'d have ended up in their stew pot!','',26124),
(4535,'enUS','You can cook?  So can I!  Is there a recipe you can teach me?','You can cook?  So can I!  Is there a recipe you can teach me?',26124),
(4536,'enUS','Hm... yes, I do have a recipe you might find useful.  Let me teach you!','',26124),
(4537,'enUS','You\'re an alchemist?  So am I.  Perhaps you can teach me what you know...','You\'re an alchemist?  So am I.  Perhaps you can teach me what you know...',26124),
(4538,'enUS','Well yes, I do know a rare alchemical recipe.  Let me teach you!','',26124),
(4539,'enUS','%s is noticeably weakened. The Felcurse is working!','',26124),
(4540,'enUS','','%s is substantially more susceptible to your attacks. The Felcurse is working!',26124),
(4541,'enUS','%s seems to no longer be able to cast spells. The Felcurse is working!','',26124),
(4542,'enUS','Your fel weapon is ready, $n.','',26124),
(4543,'enUS','I DRAW CLOSER TO THIS WORLD!','',26124),
(4544,'enUS','NOOOO!!','',26124),
(4545,'enUS','I AM HERE!','',26124),
(4546,'enUS','DIE, MORTALS!','',26124),
(4547,'enUS','','%s begins casting a counterspell...',26124),
(4548,'enUS','I\'m going to carefully mix this - oops! ...Well, I spilled a little, but it\'s ready!','',26124),
(4549,'enUS','Who dares summon me?','',26124),
(4550,'enUS','Greetings!  If you are here to access goblin engineering schemata, please know we only interface with certified goblin engineers.','',26124),
(4551,'enUS','Access secret goblin engineering schemata!','Access secret goblin engineering schemata!',26124),
(4552,'enUS','Greetings!  If you are here to access gnome engineering schemata, then you are welcome to do so.  Our scanners report you are a certified gnomish engineer!','',26124),
(4553,'enUS','Access secret gnome engineering schemata!','Access secret gnome engineering schemata!',26124),
(4554,'enUS','Hello there $glad:lass;... the name\'s Oglethorpe and I may be responsible for one of the amazing gnomish devices you might possess!  If it blew up, then it wasn\'t me; if it made you rich though, we can discuss royalties!$B$BOh, and if you\'re from Gnomeregan, you can just take two ninety degree angles, smash them together, and start marching.  I have nothing to say to you.','',26124),
(4555,'enUS','Well, if it isn\'t $n!  It\'s good to see you again; I cannot express my gratitude enough at the help that you\'ve given me and my invention work to date.$B$BWhat can I do for you today?','',26124),
(4556,'enUS','I am Tinkmaster Overspark, and I am the chief architect for modern gnomish engineering principles in the world today.  It is my job to ensure that the power of invention continues to shine brightest from our arclight spanners than anywhere else!$B$BAlso, if you happen to know a good schematic for radiation elimination, we just so happen to be in the market for one right about now...','',26124),
(4557,'enUS','Let me break down a little math for you: \"goblin\" plus \"engineering\" equals KNOW HOW, baby.  Anyone who tells you otherwise simply doesn\'t know how to add.','',26124),
(4558,'enUS','Grunts! Attack!','Grunts! Attack!',26124),
(4559,'enUS','Guardians! Defend Sen\'jin!','Guardians! Defend Sen\'jin!',26124),
(4560,'enUS','You will not defile our sacred land!','You will not defile our sacred land!',26124),
(4561,'enUS','Guards!','Guards!',26124),
(4562,'enUS','Sentinels, come to my defense!','Sentinels, come to my defense!',26124),
(4563,'enUS','Through my studies, I see that defeating the god Hakkar\'s avatar has weakened him.  But the bulk of his strength remains, lurking at the far end of the Nether.$B$BYou have defeated his avatar once, $n.  Perhaps if you defeat it again you can further weaken the god so that, one day, we might face his true self.$B$BI have prepared a spell that you may use to again summon an avatar of Hakkar within the Sanctum of the Fallen God.  Do you want to confront it once again?','',26124),
(4564,'enUS','Sentinels, come to my defense!','Sentinels, come to my defense!',26124),
(4565,'enUS','Greetings, $c.  Though time and drink have dulled my outer senses, my inner eyes remain strong.','',26124),
(4566,'enUS','Guards! Help me!','Guards! Help me!',26124),
(4567,'enUS','Yes.  Give me the spell to summon the avatar.','Yes.  Give me the spell to summon the avatar.',26124),
(4568,'enUS','Guards!','Guards!',26124),
(4569,'enUS','Intruders! Attack the intruders!','Intruders! Attack the intruders!',26124),
(4570,'enUS','%s searches for a source of arcane energy.','',26124),
(4571,'enUS','%s growls.','',26124),
(4572,'enUS','Hello, $n. I train and care for young hippogryphs here; feel free to have a look around.','',26124),
(4573,'enUS','Tell me more about these hippogryphs.','Tell me more about these hippogryphs.',26124),
(4574,'enUS','Druids are very sensitive to the plight of all creatures of the world. When it was found that these birds were in danger, we set up a system of rescuing them from the corruption of Feralas.$B$BA gnome named Curgle Cranklehop leads the affair; she collects the eggs and has them sent here, where I care for them.$B$BWe could always use more help for our cause, $n. Maybe you should head over to Gadgetzan and look for Curgle.','',26124),
(4575,'enUS','Thank again, $n.  Now I\'ll just wait here until it\'s safe to leave.','',26124),
(4576,'enUS','You will need to open the Felhound Tracker Kit and read the instruction manual. Summon the beast when you are near the peninsula of cliff giants, south of here.','',26124),
(4577,'enUS','Thank you, little $r!','',26124),
(4578,'enUS','Your talents in cooking are a little too low.  Maybe with some practice I can teach you what I know.','',26124),
(4579,'enUS','Your skills in alchemy aren\'t yet high enough to benefit from my teachings.  Perhaps if you speak with me later...','',26124),
(4580,'enUS','Captain, here they come! The naga are coming!','Captain, here they come! The naga are coming!',26124),
(4581,'enUS','The arcane only corrupts those who are weak. Even if you do not follow the path of the warlock, you would do well to remember that.','The arcane only corrupts those who are weak. Even if you do not follow the path of the warlock, you would do well to remember that.',26124),
(4582,'enUS','A pleasure, $n. What can I do for you?','',26124),
(4583,'enUS','Guards!','Guards!',26124),
(4584,'enUS','The arcane only corrupts those who are weak. Keep up on your training, or you may find a similar fate.','The arcane only corrupts those who are weak. Keep up on your training, or you may find a similar fate.',26124),
(4590,'enUS','Thank you.','Thank you.',26124),
(4591,'enUS','I am bound eternally to this cursed world. What is it you desire, mortal?','',26124),
(4592,'enUS','I wish to face the Defiler.','I wish to face the Defiler.',26124),
(4593,'enUS','By your command!','By your command!',26124),
(4594,'enUS','Leave this place. <The relic emits a white hot arc of flame. A memory has been gained: A lone Dark Iron dwarf is surrounded by seven corpses, kneeling before a monolith of flame.>','',26124),
(4595,'enUS','You will perish here. <Your mind fills with visions of chaos and destruction.>','',26124),
(4596,'enUS','Do not taint these ruins, mortal. <You are engulfed in a blinding flash of light. A creature composed entirely of flame is the only thing you can remember seeing.>','',26124),
(4597,'enUS','Help us, outsider. <The relic crumbles to dust. A vision of eight Dark Iron dwarves performing some sort of ritual fills your head.>','',26124),
(4598,'enUS','He cannot be defeated. <The relic burns to nothing. The memories it held are now your own. This city was destroyed by a being not of this world.>','',26124),
(4599,'enUS','Your existence is acknowledged. <The relic turns to dust. Your head throbs with newfound wisdom. Something evil lurks in the heart of the mountain.>','',26124),
(4600,'enUS','Defiler... you will be punished for this incursion. <A symbol of flame radiates from the relic before it crumbles to the earth.>','',26124),
(4601,'enUS','','Greetings, $n. Have you come to learn of the history of Ironforge?',26124),
(4602,'enUS','','Notify me when you are ready to listen to the story.',26124),
(4603,'enUS','I am ready, Historian Archesonus.','I am ready, Historian Archesonus.',26124),
(4604,'enUS','','Hundreds of years ago, the great city of Thaurissan stood proudly in a lush expanse of land that is now the dilapidated Burning Steppes.$B$BThaurissan was home to the nation of Dark Iron dwarves and at the time, in the midst of a civil war among the dwarven nation at large.$B$BYou see, that area of the world was at one point in time part of the Redridge Mountains - until the day that Thaurissan was consumed by a gigantic explosion. The city lay in ruin, the surrounding areas reduced to an ashy wasteland.\n',26124),
(4605,'enUS','That is tragic. How did this happen?','That is tragic. How did this happen?',26124),
(4606,'enUS','','We do not know.$B$BThe Dark Irons that did survive made their way into the mountain and began rebuilding their city.$B$BFrom the ashes of Thaurissan then rose Blackrock Spire and the new Dark Iron nation. Additional fortifications were made within the Searing Gorge, in the area known as the Cauldron.$B$BStories of an ancient evil that controlled the kingdom of Dark Irons began to circulate. ',26124),
(4607,'enUS','Interesting, continue please.','Interesting, continue please.',26124),
(4608,'enUS','','Recently, the Dark Irons have been seen on the surface world with greater regularity. Fortresses have been built in the Badlands. Massive exploratory forces have been sent into the depths of Uldaman in search of ancient lore. They have even invaded our own homeland, striking at our dam near the loch.',26124),
(4609,'enUS','Unbelievable! How dare they??','Unbelievable! How dare they??',26124),
(4610,'enUS','','We need adventurers to assist us, $n. Will you help?',26124),
(4611,'enUS','Of course I will help!','Of course I will help!',26124),
(4612,'enUS','You did a great job, Spybot! Glad to have you back here with me!','You did a great job, Spybot! Glad to have you back here with me!',26124),
(4613,'enUS','That\'s it! That\'s what you were waiting for! KILL THEM!','That\'s it! That\'s what you were waiting for! KILL THEM!',26124),
(4614,'enUS','Um, hello!  If you are here about fee collection and/or a summons, then you must have me mistaken for someone else.  Terribly sorry!','',26124),
(4615,'enUS','','I think my necklace fell in the lake.  My daddy got it for me, and he\'s gonna be mad now.',26124),
(4616,'enUS','','Thank you $g mister : miss; for finding my necklace!  You\'re the best!',26124),
(4617,'enUS','Besides the Grunts outside, my brothers and I fought at the battle of Hyjal. Any who seek to steal from the bank must face us first.','Besides the Grunts outside, my brothers and I fought at the battle of Hyjal. Any who seek to steal from the bank must face us first.',26124),
(4618,'enUS','Hello there $g mister : ma\'am;... do you have a little time that you could help us out?  Please?','',26124),
(4619,'enUS','I guarantee this bank\'s security with my own blood, is that good enough for you?','I guarantee this bank\'s security with my own blood, is that good enough for you?',26124),
(4620,'enUS','Thank you again for helping Nida, $g mister : miss;!  When I grow up, I wanna be a hero just like you!','',26124),
(4621,'enUS','Would you rather trust your goods with a goblin?','Would you rather trust your goods with a goblin?',26124),
(4622,'enUS','So many years of battle and slavery, it feels good to have a home again. ','So many years of battle and slavery, it feels good to have a home again. ',26124),
(4623,'enUS','Tell me what you want, and make it quick.','Tell me what you want, and make it quick.',26124),
(4624,'enUS','I live only to serve the master.','',26124),
(4625,'enUS','Present the trinkets, Maltrake.','Present the trinkets, Maltrake.',26124),
(4626,'enUS','Tell me what you want, and make it quick.','Tell me what you want, and make it quick.',26124),
(4627,'enUS','Meow!','',26124),
(4628,'enUS','','I know how to speak kitty, and Effsee said thank you.',26124),
(4629,'enUS','Even in peace there is still war, and many clans still fight beneath the banner of the Warchief. Are you here to add your clan to those that fight for Orgrimmar?','Even in peace there is still war, and many clans still fight beneath the banner of the Warchief. Are you here to add your clan to those that fight for Orgrimmar?',26124),
(4630,'enUS','Even in peace there is still war, and many clans still fight beneath the banner of the Warchief. Are you here to add your clan to those that fight for Orgrimmar?','Even in peace there is still war, and many clans still fight beneath the banner of the Warchief. Are you here to add your clan to those that fight for Orgrimmar?',26124),
(4631,'enUS','Yes, I offer training. But it\'s not cheap.','Yes, I offer training. But it\'s not cheap.',26124),
(4632,'enUS','Hello, $n! I am master engineer, Scooty.','',26124),
(4633,'enUS','Of course I offer lessons to other Enchanters, provided you are ready.','Of course I offer lessons to other Enchanters, provided you are ready.',26124),
(4634,'enUS','I lost my transponder and need another one, Scooty.','I lost my transponder and need another one, Scooty.',26124),
(4635,'enUS','The earth keeps many secrets, $c; it is our duty to ensure that those that must remain a secret for the good of all stays as such.','',26124),
(4636,'enUS','If you are here to waste my time, then you are wasting the time of the Cenarion Circle as a whole.  For your sake, let us hope that you are not foolish enough to be doing just that.','',26124),
(4637,'enUS','I can\'t believe the officials in Stormwind, sending the bulk of our army abroad... when our home front is under so much pressure!$B$BWith thieves coming from Westfall and gnolls encroaching from the east and west, it\'s a wonder Stormwind itself isn\'t besieged.','',26124),
(4638,'enUS','Hello, $c.  I hope you\'ve come to bolster our ranks.  Beasts and thieves are spilling into our beloved Elwynn, and we barely have enough men to keep the roads safe!$B$BAnd if you haven\'t done so, read that notice about Hogger.  He\'s a beast in yonder woods that must be dealt with.','',26124),
(4639,'enUS','Hello, $n.  Welcome to Thelsamar, and while you\'re here don\'t forget to visit our local brewery!','',26124),
(4640,'enUS','Welcome to Thelsamar, your home away from home in Loch Modan!$B$BThelsamar is a nice place, but it\'s not all beer and salted meat for those who answer the call to duty!  If you\'re willing to face danger in the name of the Alliance, then read the poster outside the Thelsamar branch of the Explorers\' League.','',26124),
(4641,'enUS','','Ahoy, $n! Not a pretty picture, is it?$B$BThe Horizon Scout at the bottom of the sea, my crew in shambles, and our cargo and passengers strewn about like so much debris that you\'d think this was one of Stormwind\'s canals after a festival.$B$BAnd that\'s not where the trouble ends...',26124),
(4642,'enUS','%s bellows a challenging roar!','',26124),
(4643,'enUS','Conspiracies abound, I say.  There are those who lack vision in understanding what I do, and would seek to keep me shackled to obscurity!$B$BDon\'t step in the dirt.','',26124),
(4644,'enUS','What are you doing out here?','What are you doing out here?',26124),
(4645,'enUS','What am I doing?  Do you lack vision?  I am a dreamer, good $g sir : lady;, and I dream of a better future for us all.  Clearly, I am a visionary.$B$BThere are those, however, who seek to keep us mired in banality.  I told him that I was a dreamer, and Archdruid Staghelm replied, \"Well, the world needs ditch diggers too.\"$B$BUntil such time as the shackles of banality are ripped from us, I will help the Cenarion Circle by shuffling these piles of dirt around.','',26124),
(4646,'enUS','Greetings, $r. I am Franclorn Forgewright. Are you here to learn of the Spire and of Dark Iron?','',26124),
(4647,'enUS','','',26124),
(4648,'enUS','Amazing! I\'ve never spoken to a ghost. I wish to learn!','Amazing! I\'ve never spoken to a ghost. I wish to learn!',26124),
(4649,'enUS','I had no choice, or so I thought. I would endure the destruction of Thaurissan and stand by the side of my king and his people.$B$BUnder the control of Ragnaros, King Dagran Thaurissan tore out the heart of this mountain and erected Blackrock Spire. We worked tirelessly to build a dwarven city mightier than any city or fortress that came before... or would come after.','',26124),
(4650,'enUS','Continue please.','Continue please.',26124),
(4651,'enUS','I stood by and watched the corruption of Ragnaros seep through the hearts and minds of the Dark Iron nation. This once honorable race, driven to madness... to evil.$B$BWhen the construction of the Spire was complete, my will to live amongst my people gave way. I passed as a hero of the new nation of Dark Iron. This tomb was placed here - at the entrance to the city I planned and built - in honor of my efforts.','',26124),
(4652,'enUS','Fascinating. Please, tell me more.','Fascinating. Please, tell me more.',26124),
(4653,'enUS','My great hammer, Ironfel, was handed down to the new chief architect, Fineous Darkvire: A man of despicable motive and little talent.$B$BThis is where you come in, $n. I want him stopped. He is too inept to harness the true power of Ironfel, but should one come after him with the aptitude to use Ironfel to its full potential, the destruction they could cause with their creations would be disastrous to this world.\n','',26124),
(4654,'enUS','Just show me the way, Franclorn.','Just show me the way, Franclorn.',26124),
(4655,'enUS','You will find Fineous Darkvire beyond the Ring of Law, in the Hall of Crafting. Kill the miserable cur and recover Ironfel.$B$BTake Ironfel to the Shrine of Thaurissan and place the hammer in its rightful place: In the hands of the statue erected in my honor.$B$BWhen this is done, the compartment in which I stored the master key will open. More importantly, Ironfel will remain forever in my grasp. Should they make an attempt to remove the hammer; both the statue and hammer will shatter, lost forever.\n','',26124),
(4656,'enUS','Yes, but you\'ll find it more rewarding if you have skill in herbalism!  You will be required to nurture and cultivate special seeds -- not to swing an axe blindly or gesticulate wildly at passing shadows.  While the Evergreen Pouch you\'ll receive allows even the simplest brute to grow something, those who show some aptitude will have more bountiful results.','',26124),
(4657,'enUS','I\'m not a journeyman herbalist -- am I able to still assist you in your work?','I\'m not a journeyman herbalist -- am I able to still assist you in your work?',26124),
(4658,'enUS','','Stand prepared! The naga won\'t wait long to press their advantage once they know we\'re alive.',26124),
(4659,'enUS','Be advised, $g Jackson : Princess;, I am in no mood for any comment that you think is cute or funny. I am here to make sure that the Archdruid\'s research proceeds as planned, and my orders are to weed out all non-hackers who do not pack the gear to serve in my beloved Cenarion Circle.','',26124),
(4660,'enUS','','Greetings, noble $c.  This humble servant of the Cenarion Circle wishes blessings and bounties be given unto you and yours.',26124),
(4661,'enUS','Amakkar, where do you think Warlord Goretooth is going to send us? I don\'t think I can handle another tour in the Steppes.','',26124),
(4662,'enUS','Hrmmm...','',26124),
(4663,'enUS','Quit being such a baby, Razal\'blade. It\'s time to start acting like you\'re part of one of the Warchief\'s elite forces. You don\'t want to end up like Gargal, do you?','',26124),
(4664,'enUS','%s seems oblivious to the nearby commentary.','',26124),
(4665,'enUS','Proudtusk!','',26124),
(4666,'enUS','No, Gargal. Just no.','',26124),
(4667,'enUS','But...','',26124),
(4668,'enUS','NO! Shhhh! Just shut up. Goretooth is coming!','',26124),
(4669,'enUS','%s laughs.','',26124),
(4670,'enUS','Watch where you\'re stepping, $c, because I have a polymorph spell with your name on it...','',26124),
(4672,'enUS','All present and accounted for, SIR!','',26124),
(4673,'enUS','FALL IN, MAGGOTS!','',26124),
(4674,'enUS','I love pie.','I love pie.',26124),
(4675,'enUS','Nana always said there was no greater thing in the whole world than a warm, toasty slice of fresh, homemeade cherry pie.','Nana always said there was no greater thing in the whole world than a warm, toasty slice of fresh, homemeade cherry pie.',26124),
(4676,'enUS','','So what\'s this new plague all about?',26124),
(4677,'enUS','This pie is so good, would you like some?','This pie is so good, would you like some?',26124),
(4678,'enUS','Having a bad day? Try some cherry pie.','Having a bad day? Try some cherry pie.',26124),
(4679,'enUS','','Oh, it\'s just terribly, terribly, awful! You will just DIE when you see it, Vivian.',26124),
(4680,'enUS','This cherry pie tastes so good, it could make a grown gnome cry.','This cherry pie tastes so good, it could make a grown gnome cry.',26124),
(4681,'enUS','Try some of this cherry pie, it will put a smile on your face, ten miles wide.','Try some of this cherry pie, it will put a smile on your face, ten miles wide.',26124),
(4682,'enUS','Fresh cherry pie for sale, looks so good it will bring a tear to your eye.','Fresh cherry pie for sale, looks so good it will bring a tear to your eye.',26124),
(4683,'enUS','','Oh, do tell! The suspense alone is enough to make a girl scream!',26124),
(4684,'enUS','Cherry pie is my favoritist food in all of Azeroth.','Cherry pie is my favoritist food in all of Azeroth.',26124),
(4685,'enUS','','Well, from what I hear, the new plague has ALL of the old plague flavor but none of the old plague calories or carbohydrates!',26124),
(4686,'enUS','','Oh, how positively delightful!',26124),
(4687,'enUS','','%s claps excitedly.',26124),
(4688,'enUS','Very well, Proudtusk, you may begin your march. Carry on!','',26124),
(4689,'enUS','Well hello there ladies. Heard about the new plague?','',26124),
(4690,'enUS','SIR, YES SIR!','',26124),
(4691,'enUS','You heard the Warlord, maggots! MARCH!','',26124),
(4692,'enUS','Well done, soldiers! At ease!','',26124),
(4693,'enUS','','%s blushes.',26124),
(4694,'enUS','','Ewwwww... not if you were the last orc on Kalimdor, Lunk.',26124),
(4695,'enUS','%s laughs.','',26124),
(4696,'enUS','Ah, look at the time! I must return to my post... up over there.','',26124),
(4697,'enUS','If you\'ll excuse me, I must take my leave. Good day, ladies.','',26124),
(4698,'enUS','Great dangers lie beyond those walls, $n. turn back until you are more seasoned in the ways of combat.\n','',26124),
(4699,'enUS','Your reign of terror ends now!  Face your doom mortals!','',26124),
(4700,'enUS','You must be hard up to be wandering these Badlands, $c.  Hard up like me.$B$BOr maybe you\'re here because you\'re crazy.  Crazy, like me.','',26124),
(4701,'enUS','%s runs for their life!','',26124),
(4702,'enUS','%s reaches out towards Captain Beltis as he falls.','%s reaches out towards Captain Beltis as she falls.',26124),
(4703,'enUS','This evil cannot be allowed to enter this world!  Come my children!','',26124),
(4704,'enUS','Get away from there!','Get away from there!',26124),
(4705,'enUS','Oh, if I only had a tree branch to hold up in front of me. The guards would never see me then.','',26124),
(4706,'enUS','You\'ll have to be patient with me, $n. I\'ve got my Spybot inside working on a very delicate matter. I\'ll be with ya in a second.$B$BOh, and do me a favor, try not to let Lescovar see you... we\'re about to ambush him.','',26124),
(4707,'enUS','GOR\'TESH DEAD?!?!','',26124),
(4708,'enUS','RUN! RUN FOR HILLS!','',26124),
(4709,'enUS','WHO KILL GOR\'TESH!?!? WHO DO THIS?!','',26124),
(4710,'enUS','Rough times, huh, $n? No matter where you turn someone needs help, and my wife and I are no exception.','',26124),
(4711,'enUS','$n KILL! $G He:She; kill you now! RUN! RUN!','',26124),
(4712,'enUS','Run for hills! Wait! We already in hills!','',26124),
(4713,'enUS','I\'d like to see what you have to sell.','I\'d like to see what you have to sell.',26124),
(4714,'enUS','%s looks up at you quizzically. Maybe you should inspect it?','',26124),
(4715,'enUS','Launch me!','Launch me!',26124),
(4716,'enUS','Greetings!','',26124),
(4717,'enUS','','You are indeed powerful, $n. Come to me if it is more work that you seek.',26124),
(4718,'enUS','My eyes never deceive me, $r. I see great power in you - enough power, perhaps, to further our cause. Find me at the top of the tower.','',26124),
(4719,'enUS','I saw it with me own two eyes!  The biggest Makura ye ever seen, bigger\'n a mountain giant\'s fist it was, clawed its way right up the side of one o\' them twin colossals.  I dunno how yeh plan on gettin\' up there, but the beast\'s sure to have a load of treasure if yeh do.','',26124),
(4720,'enUS','Buy somethin\', will ya?','Buy somethin\', will ya?',26124),
(4721,'enUS','Can you tell me how I can get a Videre Elixir?','Can you tell me how I can get a Videre Elixir?',26124),
(4722,'enUS','Sure thing, $n. You look like you can be trusted... Trustworthy! I can spot that a mile away...$B$BAnyway, back to what I was sayin\'. Takes one Evoroot plant to make the Videre Elixir. The rest \'a the ingredients are trivial really, but the Evoroot, well, that can be a bit tricky to get.','',26124),
(4723,'enUS','Key... get the key... Gerstahn has... key.','',26124),
(4724,'enUS','Try and make yourself useful, $r. GET ME OUT OF HERE! The High Interrogator has the key.','',26124),
(4725,'enUS','HEY! HEY YOU! $R! Get me out of here!','',26124),
(4726,'enUS','%s groans.','',26124),
(4727,'enUS','Ok, let\'s take a look at this thing...','',26124),
(4728,'enUS','Oh, darn...','',26124),
(4729,'enUS','','Ok!  Let\'s get started!',26124),
(4730,'enUS','','... oops.',26124),
(4731,'enUS','Get it over with you filthy $r.$B$B<Kharan lowers his head, exposing his stubby neck.>','',26124),
(4732,'enUS','I am not here to harm you, Kharan. Gor\'shak sent me. He told me that you would speak to me about the Princess.','I am not here to harm you, Kharan. Gor\'shak sent me. He told me that you would speak to me about the Princess.',26124),
(4733,'enUS','All is lost...','',26124),
(4734,'enUS','All is not lost, Kharan!','All is not lost, Kharan!',26124),
(4735,'enUS','Do I look stupid to you, $r? I may as well sign her death warrant myself! Why should I trust you?\n','',26124),
(4736,'enUS','Because you are still alive and my hands aren\'t gripped firmly around your stubby little neck.','Because you are still alive and my hands aren\'t gripped firmly around your stubby little neck.',26124),
(4737,'enUS','<Kharan sighs.>$B$BI suppose... I suppose you are right.$B$BGor\'shak told me that your Warchief has big plans. Plans that may change the way the Alliance and Horde interact. What do you know about this?','',26124),
(4738,'enUS','Nothing. My orders were to speak with you and then speak with Thrall. All I know is that Thrall is interested in saving your princess.\n','Nothing. My orders were to speak with you and then speak with Thrall. All I know is that Thrall is interested in saving your princess.\n',26124),
(4739,'enUS','Then listen well, $r.$B$BSeveral months ago, the Magistrate of Lakeshire sent envoys to Ironforge, pleading with the King for assistance with the Blackrock incursions coming from Redridge and the Burning Steppes.$B$BPrincess Moira volunteered to help, against my pleadings. I was assigned twenty elite guardsmen to protect the Princess through the perilous journey from the Loch to Lakeshire.','',26124),
(4740,'enUS','Which would explain why you\'re sitting in a jail cell at the bottom of a mountain, right, dwarf?','Which would explain why you\'re sitting in a jail cell at the bottom of a mountain, right, dwarf?',26124),
(4741,'enUS','<Kharan clears his throat.>$B$BWe made our way through the Searing Gorge tunnel and into the ravaged wasteland comprising the gorge. In retrospect, things were eerily quiet. The only dangers we ran across were the wildlife of the region: Creatures that my men easily dispatched.$B$BWe reached Blackrock Mountain with relative ease and made our way through the stonewrought construction without so much as a hiccup.','',26124),
(4742,'enUS','So what happened?','So what happened?',26124),
(4743,'enUS','As we were making our way across the Burning Steppes, we were ambushed. It must have been a hundred of them... Dark Iron dwarves! They were shifting out of the walls, from the rocks in the Steppes; out of every crevice, nook, and cranny in sight. They swarmed us, overwhelming the guards and the few brave heroes that had agreed to assist us on this mission.$B$BOne thing was clear: This was a highly orchestrated ambush. It was as if they knew every move we would make before we made them...','',26124),
(4744,'enUS','So you suspect that someone on the inside was involved? They were tipped off?','So you suspect that someone on the inside was involved? They were tipped off?',26124),
(4745,'enUS','How else could this have happened? Someone must have tipped the Dark Irons off.$B$B<Kharan shakes his fist at you.>$B$BSo help me, if I ever get out of here, I will spend the rest of my days finding the traitor.','',26124),
(4746,'enUS','Continue with your story please.','Continue with your story please.',26124),
(4747,'enUS','Where was I? Oh yes, so we were captured. My elite guardsmen were executed on the spot. They spared me and took the princess away by way of ram. I was taken to the detention halls of the Slag Pit and then transferred to this prison.$B$BI can only assume I am still alive because they wish to extract a ransom for my pitiful life. Or maybe out of cruelty, as a way to let me forever play back the events that transpired in my mind. Regret is the cruelest jailor of all, $r.','',26124),
(4748,'enUS','Indeed.','Indeed.',26124),
(4749,'enUS','She now resides at the side of Emperor Thaurissan. He has her under some sort of powerful thought altering spell... and here I sit, completely helpless.\n','',26124),
(4750,'enUS','If it\'s any consolation, I\'ll be leaving the cell door open. How you get out is your problem. Good bye, Kharan. \n','If it\'s any consolation, I\'ll be leaving the cell door open. How you get out is your problem. Good bye, Kharan. \n',26124),
(4751,'enUS','','%s holds the Rune of Escape in front of her.',26124),
(4752,'enUS','I am here!','',26124),
(4753,'enUS','Only a fool would dare disturb me in my lair.','',26124),
(4754,'enUS','I present you with proof of my deeds, Cyrus.','I present you with proof of my deeds, Cyrus.',26124),
(4755,'enUS','I do not possess any proof, Cyrus.','I do not possess any proof, Cyrus.',26124),
(4756,'enUS','<Cyrus\'s eyes glow brightly>$B$BDo I devour you whole or do I allow you to live?$B$BPerhaps you could still be of some use...$B$BChallenge my minion, $r. Survive and return proof of your victory to me.','',26124),
(4757,'enUS','A defender has fallen!','',26124),
(4758,'enUS','Be alert, you lazy mules!','',26124),
(4759,'enUS','I am ready!','I am ready!',26124),
(4760,'enUS','Grumble, grumble...','',26124),
(4761,'enUS','Look for Yelmak\'s Alchemy and Potions.  Find it in the middle of The Drag, west of the huge tree.','Look for Yelmak\'s Alchemy and Potions.  Find it in the middle of The Drag, west of the huge tree.',26124),
(4762,'enUS','Potions and oils, these are things that Yelmak will teach you of if you are worthy.  Look for his shop in the middle of The Drag.','Potions and oils, these are things that Yelmak will teach you of if you are worthy.  Look for his shop in the middle of The Drag.',26124),
(4763,'enUS','Talk to Saru Steelfury at The Burning Anvil.  Go to the Valley of Honor.  It\'s at the end of the path to the right of Red Canyon Mining.','Talk to Saru Steelfury at The Burning Anvil.  Go to the Valley of Honor.  It\'s at the end of the path to the right of Red Canyon Mining.',26124),
(4764,'enUS','Maybe Saru Steelfury will teach you to make an axe as good as mine some day.  Find him at The Burning Anvil in the Valley of Honor down the path to the right past Red Canyon Mining.','Maybe Saru Steelfury will teach you to make an axe as good as mine some day.  Find him at The Burning Anvil in the Valley of Honor down the path to the right past Red Canyon Mining.',26124),
(4765,'enUS','You want Zamja at Borstan\'s Firepit on the upper level of The Drag.  Go up the stairs on the left as you enter The Drag from the Valley of Strength.','You want Zamja at Borstan\'s Firepit on the upper level of The Drag.  Go up the stairs on the left as you enter The Drag from the Valley of Strength.',26124),
(4766,'enUS','Grumble...','',26124),
(4767,'enUS','You\'ll want to learn from Zamja.  Head to Borstan\'s Firepit on the upper level of The Drag by taking the stairs on the left as you enter from the Valley of Strength.','You\'ll want to learn from Zamja.  Head to Borstan\'s Firepit on the upper level of The Drag by taking the stairs on the left as you enter from the Valley of Strength.',26124),
(4768,'enUS','%s sniffs the bait.','',26124),
(4769,'enUS','Godan\'s Runeworks is where you\'ll go.  Look for it on the west end of The Drag, right next to the Valley of Wisdom.','Godan\'s Runeworks is where you\'ll go.  Look for it on the west end of The Drag, right next to the Valley of Wisdom.',26124),
(4770,'enUS','Can you enchant my axe?  I\'ll want a permanent.  Maybe later then.  Find Godan\'s Runeworks on the west end of The Drag near the Valley of Wisdom.','Can you enchant my axe?  I\'ll want a permanent.  Maybe later then.  Find Godan\'s Runeworks on the west end of The Drag near the Valley of Wisdom.',26124),
(4771,'enUS','%s gnaws at the bait ravenously.','',26124),
(4772,'enUS','Arnok makes good bandages.  Find him at the Survival of the Fittest hut on the shore of the lake next to Spirit Lodge in the Valley of Spirits.  It\'s above and to the west of the Valley of Strength.','Arnok makes good bandages.  Find him at the Survival of the Fittest hut on the shore of the lake next to Spirit Lodge in the Valley of Spirits.  It\'s above and to the west of the Valley of Strength.',26124),
(4773,'enUS','I guess someone needs to bandage us warriors up after the fighting.  Seek out Arnok at the Survival of the Fittest hut next to the Spirit Lodge in the Valley of Spirits.  Look up above and to the west of the Valley of Strength for a lake.  That\'s where he\'s at.','I guess someone needs to bandage us warriors up after the fighting.  Seek out Arnok at the Survival of the Fittest hut next to the Spirit Lodge in the Valley of Spirits.  Look up above and to the west of the Valley of Strength for a lake.  That\'s where he\'s at.',26124),
(4774,'enUS','That Lumak... always fishing instead of fighting.  You\'ll find him out on his dock on the lake in the Valley of Honor.  While you\'re there say hi to Shankys for me.','That Lumak... always fishing instead of fighting.  You\'ll find him out on his dock on the lake in the Valley of Honor.  While you\'re there say hi to Shankys for me.',26124),
(4775,'enUS','Fishing is a sport for the old who have not died in battle!  Go find Lumak on the lake in the Valley of Honor.','Fishing is a sport for the old who have not died in battle!  Go find Lumak on the lake in the Valley of Honor.',26124),
(4776,'enUS','Herbs... you need to speak to Jandi at her arboretum in The Drag.  There are some wooden steps behind Asoran\'s Market in the Valley of Wisdom.  Follow them to the upper level of The Drag and you\'ll find her.','Herbs... you need to speak to Jandi at her arboretum in The Drag.  There are some wooden steps behind Asoran\'s Market in the Valley of Wisdom.  Follow them to the upper level of The Drag and you\'ll find her.',26124),
(4777,'enUS','Ya man, you be wantin Jandi\'s Arboretum.  Did I just say that?  Glok\'tar I must be tired!  Follow the wooden steps behind Asoran\'s Market in the Valley of Wisdom up into The Drag and you\'ll find Jandi\'s there on the upper level.','Ya man, you be wantin Jandi\'s Arboretum.  Did I just say that?  Glok\'tar I must be tired!  Follow the wooden steps behind Asoran\'s Market in the Valley of Wisdom up into The Drag and you\'ll find Jandi\'s there on the upper level.',26124),
(4778,'enUS','Go to Kodohide Leatherworkers in The Drag. Ask for Karolek.','Go to Kodohide Leatherworkers in The Drag. Ask for Karolek.',26124),
(4779,'enUS','Kodohide Leatherworkers is what you want.  Find it in the middle of The Drag.','Kodohide Leatherworkers is what you want.  Find it in the middle of The Drag.',26124),
(4780,'enUS','Go find Zando\'zan in the Cleft of Shadow.  There are a couple of tunnels leading down into that cavern, one just south of the Valley of Wisdom and the other in The Drag.','Go find Zando\'zan in the Cleft of Shadow.  There are a couple of tunnels leading down into that cavern, one just south of the Valley of Wisdom and the other in The Drag.',26124),
(4781,'enUS','You have a treasure chest?  Let me see!  Alright, find Zando\'zan in the Cleft of Shadow.  Look for the tunnel going down in The Drag to find it.','You have a treasure chest?  Let me see!  Alright, find Zando\'zan in the Cleft of Shadow.  Look for the tunnel going down in The Drag to find it.',26124),
(4782,'enUS','Find Red Canyon Mining northeast of the lake in the Valley of Honor.  Speak to Makaru there.','Find Red Canyon Mining northeast of the lake in the Valley of Honor.  Speak to Makaru there.',26124),
(4783,'enUS','Makaru can be found day and night at Red Canyon Mining in the Valley of Honor, just off the lake.','Makaru can be found day and night at Red Canyon Mining in the Valley of Honor, just off the lake.',26124),
(4784,'enUS','Thuwd will show you how to skin your kills.  Look for him at Kodohide Leatherworkers in The Drag.','Thuwd will show you how to skin your kills.  Look for him at Kodohide Leatherworkers in The Drag.',26124),
(4785,'enUS','It is good that you wish to honor your kills by putting their bodies to use.  Find Thuwd inside the Kodohide Leatherworks in the middle of The Drag.','It is good that you wish to honor your kills by putting their bodies to use.  Find Thuwd inside the Kodohide Leatherworks in the middle of The Drag.',26124),
(4786,'enUS','I prefer my food raw, but if you like yours cooked Denni\'ka can show you how to light a fire.  Find her at Survival of the Fittest, a hut on the shore of the lake next to the Spirit Lodge.  Look for it up above and to the west of the Valley of Strength.','I prefer my food raw, but if you like yours cooked Denni\'ka can show you how to light a fire.  Find her at Survival of the Fittest, a hut on the shore of the lake next to the Spirit Lodge.  Look for it up above and to the west of the Valley of Strength.',26124),
(4787,'enUS','Denni\'ka can show you how to keep warm.  Look for her at Survival of the Fittest, a hut on the shore of the lake next to the Spirit Lodge.  Head up above and west of the Valley of Strength.','Denni\'ka can show you how to keep warm.  Look for her at Survival of the Fittest, a hut on the shore of the lake next to the Spirit Lodge.  Head up above and west of the Valley of Strength.',26124),
(4788,'enUS','Magar\'s Cloth Goods is in The Drag.  Find him south of the huge tree next to the Kodohide Leatherworks.','Magar\'s Cloth Goods is in The Drag.  Find him south of the huge tree next to the Kodohide Leatherworks.',26124),
(4789,'enUS','Clothing!?  That won\'t help you against good steel!  Bah, if you\'re sure you want to be a tailor go find Magar\'s Cloth Goods in The Drag.','Clothing!?  That won\'t help you against good steel!  Bah, if you\'re sure you want to be a tailor go find Magar\'s Cloth Goods in The Drag.',26124),
(4790,'enUS','Track down Shim\'la at the south entrance to the Hunter\'s Hall in the Valley of Honor.','Track down Shim\'la at the south entrance to the Hunter\'s Hall in the Valley of Honor.',26124),
(4791,'enUS','Good thing someone here has tracking!  Look for Shim\'la in the Hunter\'s Hall in the Valley of Honor.','Good thing someone here has tracking!  Look for Shim\'la in the Hunter\'s Hall in the Valley of Honor.',26124),
(4792,'enUS','We have our duties, $c.  Duties to the Horde.','',26124),
(4793,'enUS','Where is Warlord Krom\'zar?','Where is Warlord Krom\'zar?',26124),
(4794,'enUS','I think I hear him coming!  Look to the west!','',26124),
(4795,'enUS','The Bank of Orgrimmar is in the Valley of Strength. Look for it north of the main entrance to the city.','The Bank of Orgrimmar is in the Valley of Strength. Look for it north of the main entrance to the city.',26124),
(4796,'enUS','Go to the Valley of Strength and look for the Bank of Orgrimmar to the south of the Sky Tower.','Go to the Valley of Strength and look for the Bank of Orgrimmar to the south of the Sky Tower.',26124),
(4797,'enUS','Find the Wind Rider Master at the top of The Sky Tower in the Valley of Strength.  Doras will make sure you find your way to the battle you seek.','Find the Wind Rider Master at the top of The Sky Tower in the Valley of Strength.  Doras will make sure you find your way to the battle you seek.',26124),
(4798,'enUS','Where did you think the Wind Rider Master would be?  Head to the top of The Sky Tower in the Valley of Strength!','Where did you think the Wind Rider Master would be?  Head to the top of The Sky Tower in the Valley of Strength!',26124),
(4799,'enUS','You\'re looking for Urtrun Clanbringer in the Horde Embassy.  Find it on the west side of the Valley of Strength.','You\'re looking for Urtrun Clanbringer in the Horde Embassy.  Find it on the west side of the Valley of Strength.',26124),
(4800,'enUS','The Horde Embassy is in the Valley of Strength on the west side.','The Horde Embassy is in the Valley of Strength on the west side.',26124),
(4801,'enUS','That\'s the second building on the right in the Valley of Strength north of the main city entrance.  Speak to Innkeeper Gryshka.','That\'s the second building on the right in the Valley of Strength north of the main city entrance.  Speak to Innkeeper Gryshka.',26124),
(4802,'enUS','Look for Innkeeper Grishka in the Valley of Strength.  Her inn is on the east side, north of the main city gates.','Look for Innkeeper Grishka in the Valley of Strength.  Her inn is on the east side, north of the main city gates.',26124),
(4803,'enUS','You\'ll find one of those outside the Bank of Orgrimmar in the middle of the Valley of Strength.','You\'ll find one of those outside the Bank of Orgrimmar in the middle of the Valley of Strength.',26124),
(4804,'enUS','You can pick up your love letters outside the bank in the middle of the Valley of Strength.','You can pick up your love letters outside the bank in the middle of the Valley of Strength.',26124),
(4805,'enUS','Go to the Hunter\'s Hall in the Valley of Honor, west of the Coliseum.  Talk to Ormak Grimshot there.','Go to the Hunter\'s Hall in the Valley of Honor, west of the Coliseum.  Talk to Ormak Grimshot there.',26124),
(4806,'enUS','Shoot straight to the northwest section of the Valley of Honor.  There you will find the Hunter\'s Hall.','Shoot straight to the northwest section of the Valley of Honor.  There you will find the Hunter\'s Hall.',26124),
(4807,'enUS','Speak to Pephredo at the Darkbriar Lodge in the Valley of Spirits, up above and to the west of the Valley of Strength.','Speak to Pephredo at the Darkbriar Lodge in the Valley of Spirits, up above and to the west of the Valley of Strength.',26124),
(4808,'enUS','What, you can\'t port there?  Go to the Darkbriar Lodge next to the lake in the Valley of Spirits, up above and to the west of the Valley of Strength.','What, you can\'t port there?  Go to the Darkbriar Lodge next to the lake in the Valley of Spirits, up above and to the west of the Valley of Strength.',26124),
(4809,'enUS','Zayus and his priests are in the Spirit Lodge, which is in the Valley of Spirits.  Look for it on the lake up above and to west of the Valley of Strength.','Zayus and his priests are in the Spirit Lodge, which is in the Valley of Spirits.  Look for it on the lake up above and to west of the Valley of Strength.',26124),
(4810,'enUS','Healing is for those who cannot endure pain.  However if you must, seek out the Spirit Lodge on the lake in the Valley of Spirits, up and above the Valley of Strength to the west.','Healing is for those who cannot endure pain.  However if you must, seek out the Spirit Lodge on the lake in the Valley of Spirits, up and above the Valley of Strength to the west.',26124),
(4811,'enUS','You seek Kardris Dreamseeker.  She and the other shaman are in the entrance room to Thrall\'s Fortress in the Valley of Wisdom.','You seek Kardris Dreamseeker.  She and the other shaman are in the entrance room to Thrall\'s Fortress in the Valley of Wisdom.',26124),
(4812,'enUS','Your search is almost completed.  Seek your truth in the entrance room of Thrall\'s Fortress in the Valley of Wisdom.','Your search is almost completed.  Seek your truth in the entrance room of Thrall\'s Fortress in the Valley of Wisdom.',26124),
(4813,'enUS','Looking for Shenthul of the Shadowswift Brotherhood, huh?  In The Drag across from Droffers and Son Salvage look for a tunnel leading down into the Cleft of Shadow.','Looking for Shenthul of the Shadowswift Brotherhood, huh?  In The Drag across from Droffers and Son Salvage look for a tunnel leading down into the Cleft of Shadow.',26124),
(4814,'enUS','Don\'t let me catch you stealing anything!  Look for Shenthul and his Shadowswift Brotherhood in the underground Cleft of Shadow.  Find the tunnel leading down into it south of the Valley of Wisdom.','Don\'t let me catch you stealing anything!  Look for Shenthul and his Shadowswift Brotherhood in the underground Cleft of Shadow.  Find the tunnel leading down into it south of the Valley of Wisdom.',26124),
(4815,'enUS','You seek Grol\'dar and the Darkfire Enclave?  Find them in the underground cavern called the Cleft of Shadow.  There are two tunnels leading down into that cave, one just south of the Valley of Wisdom and the other from The Drag.','You seek Grol\'dar and the Darkfire Enclave?  Find them in the underground cavern called the Cleft of Shadow.  There are two tunnels leading down into that cave, one just south of the Valley of Wisdom and the other from The Drag.',26124),
(4816,'enUS','Didn\'t we just break free of the Burning Legion, and here you are messing with demons again?  Seek out the Darkfire Enclave in the underground cavern known as the Cleft of Shadow.  You\'ll find a tunnel down into it from The Drag.','Didn\'t we just break free of the Burning Legion, and here you are messing with demons again?  Seek out the Darkfire Enclave in the underground cavern known as the Cleft of Shadow.  You\'ll find a tunnel down into it from The Drag.',26124),
(4817,'enUS','Speak to Grezz Ragefist in the Hall of the Brave, which is in the Valley of Honor.  Put in a good word for me!','Speak to Grezz Ragefist in the Hall of the Brave, which is in the Valley of Honor.  Put in a good word for me!',26124),
(4818,'enUS','Find the Hall of the Brave in the Valley of Honor and speak to Grezz Ragefist.  Let them know that I\'ll be reporting back in after my shift here.','Find the Hall of the Brave in the Valley of Honor and speak to Grezz Ragefist.  Let them know that I\'ll be reporting back in after my shift here.',26124),
(4819,'enUS','You lost?','You lost?',26124),
(4820,'enUS','What do you want?','What do you want?',26124),
(4821,'enUS','What!?','What!?',26124),
(4822,'enUS','Lok\'tar Ogar!','Lok\'tar Ogar!',26124),
(4823,'enUS','Can you help me with some directions?','Can you help me with some directions?',26124),
(4824,'enUS','Please, leave an old spirit in peace.','',26124),
(4825,'enUS','Very few seek me out... What may I do for you?','',26124),
(4826,'enUS','I have given you all the knowledge I have, $n. May luck be with you.','',26124),
(4827,'enUS','How can I get Evoroot?','How can I get Evoroot?',26124),
(4828,'enUS','Heh, heh... Quite the inquisitive one, aren\'t ya, $n? Well, here\'s what you need to do.$B$BNorth of here, in the old ruins, lives a very disagreeable gnoll by the name of Miblon Snarltooth. He guards the only Evoroot I know of, but he watches it night and day! Seems like he never even sleeps!$B$BWhat you can do, is bribe him. I can sell you some bait that he\'ll find tasty -- just put it down near him and that will distract him long enough for you to grab the Evoroot. Good luck!','',26124),
(4829,'enUS','Face me, if you dare!','',26124),
(4830,'enUS','Vorfalk','',26124),
(4831,'enUS','Bethek','',26124),
(4832,'enUS','Uggel','',26124),
(4833,'enUS','Zimrel','',26124),
(4834,'enUS','Ofgut','',26124),
(4835,'enUS','Pelver','',26124),
(4836,'enUS','%s abandons the block he was holding up in the doorway, and looks towards the bait.','',26124),
(4837,'enUS','%s pounds his chest, calling for help!','',26124),
(4838,'enUS','%s explodes into chunks of acidic slime!','',26124),
(4839,'enUS','','I know it\'ll work this time...',26124),
(4840,'enUS','','This will be my best experiment yet!',26124),
(4841,'enUS','','Now, if I add the yellow ones...',26124),
(4842,'enUS','','I know it\'ll work this time... My last 13 tries were just practice!',26124),
(4843,'enUS','','Ahh... My experiments never seem to work out right. Maybe I should go back downstream.',26124),
(4844,'enUS','I\'d like to purchase more Tharlendris seeds.','I\'d like to purchase more Tharlendris seeds.',26124),
(4845,'enUS','I\'d like to purchase more Tharlendris seeds.','I\'d like to purchase more Tharlendris seeds.',26124),
(4846,'enUS','','%s begins to combine different colored crystals together.',26124),
(4847,'enUS','','I think... I think it\'s working!',26124),
(4848,'enUS','I\'m not a journeyman herbalist -- am I able to still assist you in your work?','I\'m not a journeyman herbalist -- am I able to still assist you in your work?',26124),
(4849,'enUS','Yes, but you\'ll find it more rewarding if you have skill in herbalism!  You\'ll be nurturing and cultivating special seeds.  While the Evergreen Pouch you\'ll receive allows even a novice to grow something, those who show some aptitude in herbalism will have more bountiful results.','',26124),
(4850,'enUS','Greetings, $c.  What may this humble servant of the Feathermoon Stronghold do for you today?','',26124),
(4851,'enUS','I\'d like to purchase more Tharlendris seeds.','I\'d like to purchase more Tharlendris seeds.',26124),
(4852,'enUS','','OW! That\'s not right!',26124),
(4853,'enUS','','Oh well... Maybe next time.',26124),
(4854,'enUS','Stand straight!  Your weakness sickens me!','',26124),
(4855,'enUS','Be alert!  The orcs and their allies are close!','',26124),
(4856,'enUS','Look fierce!  You are Kolkar, so act like one!','',26124),
(4857,'enUS','What are you looking for?','What are you looking for?',26124),
(4858,'enUS','Which profession?','Which profession?',26124),
(4859,'enUS','Alchemy','Alchemy',26124),
(4860,'enUS','Blacksmithing','Blacksmithing',26124),
(4861,'enUS','Cooking','Cooking',26124),
(4862,'enUS','Enchanting','Enchanting',26124),
(4863,'enUS','First Aid','First Aid',26124),
(4864,'enUS','Fishing','Fishing',26124),
(4865,'enUS','Herbalism','Herbalism',26124),
(4866,'enUS','Leatherworking','Leatherworking',26124),
(4867,'enUS','Lockpicking','Lockpicking',26124),
(4868,'enUS','Mining','Mining',26124),
(4869,'enUS','Skinning','Skinning',26124),
(4870,'enUS','Survival','Survival',26124),
(4871,'enUS','Tailoring','Tailoring',26124),
(4872,'enUS','Tracking','Tracking',26124),
(4873,'enUS','','The death of our flesh marked the birth of our spirit and our sacred task.',26124),
(4874,'enUS','I am one of the Seven, and it is our doom to stand sentry.  Forever.','',26124),
(4875,'enUS','Our leader, Doom\'rel, has ears for the challenge.','',26124),
(4876,'enUS','I am forever denied the touch of stone.  I will never again know the glory of shaped iron...','',26124),
(4877,'enUS','','You may not pass.  You are not our kin, nor have you issued the challenge.',26124),
(4878,'enUS','Which trainer do you seek?','Which trainer do you seek?',26124),
(4879,'enUS','Our fate is the doom of all who face the Great Fire.','',26124),
(4880,'enUS','Hunter','Hunter',26124),
(4881,'enUS','Our punishment is also our blessing.','',26124),
(4882,'enUS','Mage','Mage',26124),
(4883,'enUS','Priest','Priest',26124),
(4884,'enUS','Shaman','Shaman',26124),
(4885,'enUS','Rogue','Rogue',26124),
(4886,'enUS','Warlock','Warlock',26124),
(4887,'enUS','Warrior','Warrior',26124),
(4888,'enUS','The bank','The bank',26124),
(4889,'enUS','Flight Master','Flight Master',26124),
(4890,'enUS','Guild Master & Vendor','Guild Master & Vendor',26124),
(4891,'enUS','Class Trainer','Class Trainer',26124),
(4892,'enUS','Your bondage is at an end, Doom\'rel.  I challenge you!','Your bondage is at an end, Doom\'rel.  I challenge you!',26124),
(4893,'enUS','The inn','The inn',26124),
(4894,'enUS','You have challenged the Seven, and now you will die!','',26124),
(4895,'enUS','Mailbox','Mailbox',26124),
(4896,'enUS','Profession Trainer','Profession Trainer',26124),
(4897,'enUS','Gloom\'rel, tell me your secrets!','Gloom\'rel, tell me your secrets!',26124),
(4898,'enUS','You wish to learn the old craft?  You wish to smelt dark iron?$B$BAppease me, $r.  Show me a sacrifice and I will consider it!','',26124),
(4899,'enUS','Your will is strong, and your intent is clear.$B$BPerhaps you are worthy...','',26124),
(4900,'enUS','I have paid your price, Gloom\'rel.  Now, teach me your secrets!','I have paid your price, Gloom\'rel.  Now, teach me your secrets!',26124),
(4901,'enUS','You have shown me your desire, and have paid with precious stone.  I will teach you...','',26124),
(4902,'enUS','Intruders! Attack the intruders!','Intruders! Attack the intruders!',26124),
(4903,'enUS','I know the way, insect. There is no need to prod me as if I were cattle.','',26124),
(4904,'enUS','Surely you do not think that you will get away with this incursion. They will come for me and you shall pay for your insolence.','',26124),
(4905,'enUS','RUN THEM THROUGH BROTHERS!','',26124),
(4906,'enUS','I doubt you will be so lucky the next time you encounter my brethren.','',26124),
(4907,'enUS','They come for you, fool!','',26124),
(4908,'enUS','What do you think you accomplish from this, fool? Even now, the Blackrock armies make preparations to destroy your world.','',26124),
(4909,'enUS','On darkest wing they fly. Prepare to meet your end!','',26124),
(4910,'enUS','You will not defile our sacred land!','You will not defile our sacred land!',26124),
(4911,'enUS','The worst is yet to come!','',26124),
(4912,'enUS','%s laughs.','',26124),
(4913,'enUS','Time to make your final stand, insect.','',26124),
(4914,'enUS','The Kolkar will rule!','',26124),
(4915,'enUS','Your Horde is nothing to the Kolkar!','',26124),
(4916,'enUS','Shake in fear, dogs!  I am here!','',26124),
(4917,'enUS','The Kolkar are the strongest!','',26124),
(4918,'enUS','%s submits.','',26124),
(4919,'enUS','You two-legs are nothing!  My children could beat you!','',26124),
(4920,'enUS','I am here!  Your rule of this land is over!','',26124),
(4921,'enUS','For the Horde!','For the Horde!',26124),
(4922,'enUS','Defend the bunkers!','Defend the bunkers!',26124),
(4923,'enUS','The invaders are here!','The invaders are here!',26124),
(4924,'enUS','Beware!  The Kolkar attack!','Beware!  The Kolkar attack!',26124),
(4925,'enUS','Our foes will fall!','Our foes will fall!',26124),
(4926,'enUS','Beware, $n!  Look to the west!','',26124),
(4927,'enUS','You have come to play? Then let us play!','',26124),
(4928,'enUS','Kneel, Grark.','',26124),
(4929,'enUS','Grark Lorkrub, you have been charged and found guilty of treason against the Horde. How you plead is unimportant. High Executioner Nuzrak, step forward.','',26124),
(4930,'enUS','%s raises his massive axe over Grark.','',26124),
(4931,'enUS','End him...','',26124),
(4932,'enUS','%s raises his hand and then lowers it.','',26124),
(4933,'enUS','You, soldier, report back to Kargath at once!','',26124),
(4934,'enUS','Get away from those kegs!','',26124),
(4935,'enUS','I... I\'m not really sure how I got here...$B$BI seem to remember traveling... a raft...$B$B','',26124),
(4936,'enUS','You\'ll pay for that!','',26124),
(4937,'enUS','Pay me and I\'ll talk...$B$BOh hey, it\'s you, $n! Nevermind about that...','',26124),
(4938,'enUS','Does my name sound familiar to you? Maybe we knew each other a long time ago...$B$BI think I\'m named after someone important...','',26124),
(4939,'enUS','Hi there! I\'m glad you came back, $n. Tell me, have you completed the first quest I gave you? If you have, I might have a second quest for you...','',26124),
(4940,'enUS','When I was wandering the crater after I crashed here, I remembered something that I once was told... \"Go up, up the mountain ahead,\" said the voice in my head.$B$BListening to it is how I ended up here, $n!','',26124),
(4941,'enUS','A long time ago, during my travels, I met a man that told me, \"Master using it and you can have this.\"$B$BWhat do you suppose that means? I didn\'t know then, and I still don\'t now, really...','',26124),
(4942,'enUS','It\'s a secret to everybody... including me!$B$BI\'m glad you found me -- it\'s a good thing I\'m not hiding in a bush or underneath a rock, isn\'t it?','',26124),
(4943,'enUS','Thanks, $n! You\'re the hero of Un\'Goro Crater!','',26124),
(4944,'enUS','Ragnaros will reign supreme!','Ragnaros will reign supreme!',26124),
(4945,'enUS','Have a drink, $c.  It might be your last!','Have a drink, $c.  It might be your last!',26124),
(4946,'enUS','If it weren\'t for the Grim Guzzler, I\'d spend my free time pulling the wings off dragon whelps.','If it weren\'t for the Grim Guzzler, I\'d spend my free time pulling the wings off dragon whelps.',26124),
(4947,'enUS','If it weren\'t for the Grim Guzzler, I\'d probably spend my free time pulling the wings off dragon whelps.','If it weren\'t for the Grim Guzzler, I\'d probably spend my free time pulling the wings off dragon whelps.',26124),
(4948,'enUS','The water elementals are at war with the fire elementals, which sort of means they\'re at war with us.  One of their leaders, Hydraxis, is mustering agents for his cause...','The water elementals are at war with the fire elementals, which sort of means they\'re at war with us.  One of their leaders, Hydraxis, is mustering agents for his cause...',26124),
(4949,'enUS','Oh man, I thought I was dead for sure.  Ugh... still dizzy...','',26124),
(4950,'enUS','I heard that a noble among the water elementals, Hydraxis, wages war with the servants of fire.  Let\'s hope he loses!','I heard that a noble among the water elementals, Hydraxis, wages war with the servants of fire.  Let\'s hope he loses!',26124),
(4951,'enUS','The Waterlord Hydraxis hides off in Azshara, on an island in the Bay of Storms.  What kind of threat can the fool muster from there?','The Waterlord Hydraxis hides off in Azshara, on an island in the Bay of Storms.  What kind of threat can the fool muster from there?',26124),
(4952,'enUS','I like the way you think!  Let\'s get outta here!','',26124),
(4953,'enUS','If Hydraxis recruits more in his war, then it might shift the balance of power...','If Hydraxis recruits more in his war, then it might shift the balance of power...',26124),
(4954,'enUS','It\'s all guns and flames until someone loses and dies.','It\'s all guns and flames until someone loses and dies.',26124),
(4955,'enUS','All right, I think I can make it on my own from here.  I don\'t know who you are... but I owe you one.  Thank you!','',26124),
(4956,'enUS','My father told me there\'d be days like this, where a stranger would talk to me and I\'d have to restrain myself from killing $ghim:her;.','My father told me there\'d be days like this, where a stranger would talk to me and I\'d have to restrain myself from killing $ghim:her;.',26124),
(4957,'enUS','Welcome to Stonemaul Hold, brave $c.  How may I assist you this day?','',26124),
(4958,'enUS','Greetings $c -- if you\'re looking for leather goods and leatherworking supplies, you\'ve come to the right semi-retired Paladin.','',26124),
(4959,'enUS','You look like you might be needing passage across the Great Sea. Well you have come to the right place, this here is the berth of the Maiden\'s Fancy, finest passenger ship to travel these waters. When she arrives, just climb aboard and the next thing you know you will find yourself basking on the sandy beaches of Stranglethorn.','You look like you might be needing passage across the Great Sea. Well you have come to the right place, this here is the berth of the Maiden\'s Fancy, finest passenger ship to travel these waters. When she arrives, just climb aboard and the next thing you know you will find yourself basking on the sandy beaches of Stranglethorn.',26124),
(4960,'enUS','I must say, Booty Bay has the best Clam Chowder to be had anywhere in the South Seas. Oh, not interested in cuisine eh? Well then let me be the first to welcome you to the berth of the Maiden\'s Fancy, the finest passenger ship to travel between the Eastern Kingdoms and Kalimdor. She\'s due back for another trip to Ratchet soon, so make yourself comfortable till she arrives.','I must say, Booty Bay has the best Clam Chowder to be had anywhere in the South Seas. Oh, not interested in cuisine eh? Well then let me be the first to welcome you to the berth of the Maiden\'s Fancy, the finest passenger ship to travel between the Eastern Kingdoms and Kalimdor. She\'s due back for another trip to Ratchet soon, so make yourself comfortable till she arrives.',26124),
(4961,'enUS','Intruders!!','',26124),
(4962,'enUS','What are you doing?  Intruders!!','',26124),
(4963,'enUS','Of course there\'s no danger in everything catching flames and exploding like a huge helium bomb. This baby will get you to Undercity faster and safer than any boat, and the view is truly breathtaking. Speaking of breath, smoking is not allowed while on board the zeppelin, and fire spells are banned from being cast during the trip.','Of course there\'s no danger in everything catching flames and exploding like a huge helium bomb. This baby will get you to Undercity faster and safer than any boat, and the view is truly breathtaking. Speaking of breath, smoking is not allowed while on board the zeppelin',26124),
(4964,'enUS','Hello!  You\'re just the person I was looking for.  Take a seat and listen, because I have a plan that will make us both rich!','',26124),
(4965,'enUS','My brother said we could make great money with this trade route, but he didn\'t tell me I would be the one living on this side. If you come back this way on the Zeppelin, could you bring me something to eat? They sell some of the finest meat in Orgrimmar, and I sure could use something that didn\'t die weeks before it stopped moving.','My brother said we could make great money with this trade route, but he didn\'t tell me I would be the one living on this side. If you come back this way on the Zeppelin, could you bring me something to eat? They sell some of the finest meat in Orgrimmar, and I sure could use something that didn\'t die weeks before it stopped moving.',26124),
(4966,'enUS','I hope this works!','',26124),
(4967,'enUS','%s adds the haze to the Bloodpetal sprouts.','',26124),
(4968,'enUS','Look at them go!','',26124),
(4969,'enUS','%s laughs as he watches the pests run off.','',26124),
(4970,'enUS','It\'s GO TIME! Come get sum! <replace this>','',26124),
(4971,'enUS','Your family says hello, Ribbly.  And they want your head!','Your family says hello, Ribbly.  And they want your head!',26124),
(4972,'enUS','You\'re good for nothing, Ribbly.  It\'s time to pay for your wickedness!','You\'re good for nothing, Ribbly.  It\'s time to pay for your wickedness!',26124),
(4973,'enUS','No!  Get away from me!  Help!!','',26124),
(4974,'enUS','Look for Nogg\'s Machine Shop in the Valley of Honor northeast of Red Canyon Mining.','Look for Nogg\'s Machine Shop in the Valley of Honor northeast of Red Canyon Mining.',26124),
(4975,'enUS','You\'ll find that goblin and his toy shop in the Valley of Honor.','You\'ll find that goblin and his toy shop in the Valley of Honor.',26124),
(4976,'enUS','Engineering','Engineering',26124),
(4977,'enUS','Help me choose wisely.','Help me choose wisely.',26124),
(4978,'enUS','I am a mage of great power, I have spent my days studying the mind and the memory as it pertains to learning and the retention of learned abilities. I would even now be perfecting my studies if not for the great voices that came to me in the night, informing me that my services were required. I will be here for only a short time offering my ability to wipe your talents for free. Soon I will leave again, and you will once more be stuck with whatever choices you make.','I am a mage of great power, I have spent my days studying the mind and the memory as it pertains to learning and the retention of learned abilities. I would even now be perfecting my studies if not for the great voices that came to me in the night, informing me that my services were required. I will be here for only a short time offering my ability to wipe your talents for free. Soon I will leave again, and you will once more be stuck with whatever choices you make.',26124),
(4979,'enUS','','You got it!',26124),
(4980,'enUS','','Coming right up!',26124),
(4981,'enUS','','I\'ll bring it right over, baby...',26124),
(4983,'enUS','','Yes $gsir:madam;.',26124),
(4984,'enUS','Hey Nagmara!  How about a mug of Dark Iron Ale?','Hey Nagmara!  How about a mug of Dark Iron Ale?',26124),
(4985,'enUS','Nagmara!  Have any mutton left?','Nagmara!  Have any mutton left?',26124),
(4986,'enUS','Mistress, you tell Plugger that I want more of his ale.  I can\'t get enough!','Mistress, you tell Plugger that I want more of his ale.  I can\'t get enough!',26124),
(4987,'enUS','Hey Nag, how about you slice me off a piece of that...','Hey Nag, how about you slice me off a piece of that...',26124),
(4988,'enUS','I\'d like to train in cooking.','I\'d like to train in cooking.',26124),
(4989,'enUS','Hello, $n. If you\'d like to learn a thing or two about cooking, please visit me at any time.','',26124),
(4990,'enUS','','<Lady Prestor glares at you.>',26124),
(4991,'enUS','Pardon the intrusion, Lady Prestor, but Highlord Bolvar suggested that I seek your advice.','Pardon the intrusion, Lady Prestor, but Highlord Bolvar suggested that I seek your advice.',26124),
(4992,'enUS','','I was standing right next to you, imbecile. I know what you seek.',26124),
(4993,'enUS','My apologies, Lady Prestor.\n','My apologies, Lady Prestor.\n',26124),
(4994,'enUS','','You seek to lower our global defenses in order to appease a paranoid magistrate and an encampment of riff-raff that are most probably suffering from heat stroke.',26124),
(4995,'enUS','Begging your pardon, Lady Prestor. That was not my intent.\n','Begging your pardon, Lady Prestor. That was not my intent.\n',26124),
(4996,'enUS','','Of course not, dear $g boy:girl;. You \'adventurer\' types are often victims of circumstance; subject to the political drama which tends to unfold between citizenry and royalty.$B$BMy advice to you, then, is to seek out something else, more specifically: A new career.$B$BThis world has enough heroes.',26124),
(4997,'enUS','Thank you for your time, Lady Prestor.','Thank you for your time, Lady Prestor.',26124),
(4998,'enUS','%s gets really dizzy!','%s gets really dizzy!',26124),
(4999,'enUS','%s drunkenly miscasts a shadow bolt!','%s drunkenly miscasts a shadow bolt!',26124),
(5000,'enUS','','Hey, Rocknot!',26124),
(5001,'enUS','','Let\'s go, honey.',26124),
(5002,'enUS','','%s kisses her lover.',26124),
(5003,'enUS','%s kisses Mistress Nagmara','',26124),
(5004,'enUS','Please, help me to get through this cursed forest, $r.','',26124),
(5005,'enUS','The corruption of the fel has not left any of the creatures of Felwood untouched, $n. Please, be on your guard.','',26124),
(5006,'enUS','What you be wanting? *hic*','',26124),
(5007,'enUS','Official business, John. I need some information about Marshal Windsor. Tell me about the last time you saw him.','Official business, John. I need some information about Marshal Windsor. Tell me about the last time you saw him.',26124),
(5008,'enUS','That I must fight against my own kind deeply saddens me.','',26124),
(5009,'enUS','Windsor was particularly ornery that day - and believe me, for Windsor, that\'s a monumental accomplishment. He kept telling me that \'something feels off.\' Well he wasn\'t kidding!$B$BWe were in the middle of Blackrock Mountain when the filthy animals attacked. I\'m talking about the orcs, of course. Pay attention, will ya? All you could hear were grunts and the clanging of steel as they rushed us. ','',26124),
(5010,'enUS','So what did you do?','So what did you do?',26124),
(5012,'enUS','Me versus fifty orcs? I\'m no fool, $n. My pappy always told me, \'Discreditin is the better part of a cracker,\' or something, and I knew what that meant.','',26124),
(5013,'enUS','Start making sense, dwarf. I don\'t want to have anything to do with your cracker, your pappy, or any sort of \'discreditin.\'\n','Start making sense, dwarf. I don\'t want to have anything to do with your cracker, your pappy, or any sort of \'discreditin.\'\n',26124),
(5014,'enUS','Alright, alright. Anyhow, so I sorta slipped into the shadows.$B$BThat didn\'t sit too well with Windsor, seeing as how he was already extra cranky. Well he started spinnin\' old Ironfoe around and screaming like a mad man at the orcs. ','',26124),
(5015,'enUS','Ironfoe?\n','Ironfoe?\n',26124),
(5016,'enUS','Yep. You never heard of Ironfoe? The legendary orc slaying hammer? Yep, yep, that was ol\' Windsor\'s hammer. He told me that Franclorn Forgewright himself made that hammer for his great, great, grand pappy. THE Franclorn Forgewright: The Dark Iron responsible for stonewrought archimetenc... building stuff. He also said the hammer had a twin that Franclorn kept for himself. Think he called it Ironfel or something.','',26124),
(5017,'enUS','Interesting... continue, John.','Interesting... continue, John.',26124),
(5018,'enUS','So where was I? Oh yea, so the orcs rushed Windsor and Windsor, well, he didn\'t move an inch. He stood tall as they charged him, ten at a time. All I could see was the glow from Ironfoe and a lot of blood. This went on for hours, maybe days. I don\'t remember. Anyhow, FINALLY, it stopped.','',26124),
(5019,'enUS','So that\'s how Windsor died...','So that\'s how Windsor died...',26124),
(5020,'enUS','Died? Are you cracked, $n? Excuse me, $g Mister:Miss; $n! Windsor wouldn\'t have died from no fifty orcs. As sure as Thelsamar blood sausage is the tastiest food the world may ever know, there he stood: He was covered in orc chunks from head to toe, drenched in about eighteen layers of their blood, but he was definitely alive... and really, really angry.','',26124),
(5021,'enUS','So how did he die?','So how did he die?',26124),
(5022,'enUS','Why do you keep saying he died? Who told you he died? I never said he died.$B$BHe went missing is all.$B$BYou see, apparently we had gotten into the middle of some big orc versus Dark Iron dwarf battle. The orcs, being the filthy, miserable curs that they are, were out early, setting up some traps and other diabolical things you probably wouldn\'t understand.','',26124),
(5023,'enUS','I can sense it now, $n. Ashenvale lies down this path.','',26124),
(5024,'enUS','Ok, so where the hell is he? Wait a minute! Are you drunk?','Ok, so where the hell is he? Wait a minute! Are you drunk?',26124),
(5025,'enUS','Dwarves don\'t get drunk, $g mister:missy;. I\'m just a little sloppy.$B$BAnyhow, Windsor? I figure he\'s somewhere in Blackrock Depths. That\'s the Dark Iron city for you unedumecated peoples.','',26124),
(5026,'enUS','I feel... something strange...','',26124),
(5027,'enUS','WHY is he in Blackrock Depths?','WHY is he in Blackrock Depths?',26124),
(5028,'enUS','Slow down! I was getting to that!$B$BSo there he was, standing tall with all the blood and guts dripping off him when who shows up?$B$BThe Dark Irons! Didn\'t you hear a word I said??$B$BWell, the Dark Irons are a little craftier than those Blackrock orcs. They came prepared. By prepared I mean there were about 300 of em... *hic* \'scuse me.','',26124),
(5029,'enUS','$n, my form has now changed! The true strength of my spirit is returning to me now... The cursed grasp of the forest is leaving me.','',26124),
(5030,'enUS','300? So the Dark Irons killed him and dragged him into the Depths?','300? So the Dark Irons killed him and dragged him into the Depths?',26124),
(5031,'enUS','$G Mister:Missy;, if I didn\'t know better, I\'d think you were one of them \'special\' peoples. We call em Troggs.$B$BWindsor didn\'t have no beef with the Dark Irons, after all, his great, great, grand pappy\'s best friend was a Dark Iron. Which is also probably why that army of Dark Irons didn\'t kill him on sight.','',26124),
(5032,'enUS','Your knowledge is lacking.  Return to me when your skills in smelting have grown!','',26124),
(5033,'enUS','You may leave me here -- I wish to be alone in my final moments.','',26124),
(5034,'enUS','Ahhh... Ironfoe.\n','Ahhh... Ironfoe.\n',26124),
(5035,'enUS','Finally! Put some fingers in your ears, your brain mighta just grown five sizes and I\'m worried it might leak out.$B$BSo, the Dark Irons spared his life and took him prisoner. Their leader, some self-important, uppity fella named Thauris-something, took Ironfoe for himself. And that was the last I saw of ol\' Windsor... *hic* \'scuse me.\n','',26124),
(5036,'enUS','Thank you, $n. Now my spirit will finally be at peace.','',26124),
(5037,'enUS','The corruption of Felwood has trapped my spirit here... I may never rest...','',26124),
(5038,'enUS','Thanks, Ragged John. Your story was very uplifting and informative. ','Thanks, Ragged John. Your story was very uplifting and informative. ',26124),
(5039,'enUS','','Welcome to the Grim Guzzler!',26124),
(5040,'enUS','Why don\'t you and Rocknot go find somewhere private...','Why don\'t you and Rocknot go find somewhere private...',26124),
(5041,'enUS','','Good idea!',26124),
(5042,'enUS','','Thanks again, $n.  Rocknot and I are really hitting it off!',26124),
(5043,'enUS','Another Engineer! Hey, this is a great chance for me to show off some new gadgets I\'ve been building!','Another Engineer! Hey, this is a great chance for me to show off some new gadgets I\'ve been building!',26124),
(5044,'enUS','','If you\'re going to venture into Blackrock Depths, come speak with me. I may have some work for you.',26124),
(5045,'enUS','%s looks tired. He then yawns and lies down next to A-Me 01','',26124),
(5046,'enUS','%s snores loudly and cuddles up next to A-Me 01.','',26124),
(5047,'enUS','','Have you seen all the wonderful things here in Ungoro Crater, $n? It\'s simply amazing. Not as amazing as some of the things I can make with my skill at engineering, but for it being all natural here... it\'s not too bad.$B$BMy uncle Remtravel loves old stuff like this place. I\'m following in his footsteps kinda--I want to discover new things from lost cultures too!',26124),
(5048,'enUS','','Hmm, I don\'t have any mithril casings. I\'m all out. Is that all you need to get to fix A-Me? Oh, that would be fantastic!$B$BMithril casings aren\'t too hard to find back in civilization. Just ask any skilled engineer to make one for you. I think it takes a few bars of mithril, but if you could help me out, I\'ll make sure you\'re well rewarded!',26124),
(5049,'enUS','Do you have any mithril casings?','Do you have any mithril casings?',26124),
(5050,'enUS','','Be sure to try our Dark Iron Ale.  I hear the dwarves around here can\'t get enough of it.',26124),
(5051,'enUS','','My master, Plugger Spazzring, is a good boss.  And he makes a lot of money.  His pockets are bursting!',26124),
(5052,'enUS','This here is the finest, most state of the art mode of transportation money can build. What? Deeprun Tram? Gnomes? Listen pal, If you believe that garbage then I\'ve got a statue down in Stranglethorn to sell ya. Now, are you walking to Grom\'Gol or are you gonna ride in style in this fine flying machine? Your choice.','',26124),
(5053,'enUS','Hey!  Get away from that!','',26124),
(5054,'enUS','What are you doing over there?','',26124),
(5055,'enUS','No stealing the goods!','',26124),
(5056,'enUS','Hey!  Stop that!','',26124),
(5057,'enUS','Phalanx, I think you need to teach thos person a lesson.','',26124),
(5058,'enUS','You are deemed a threat!','',26124),
(5059,'enUS','I will be reborn, mortals! Incendius shall raise me from these ashes!','',26124),
(5060,'enUS','That\'s it!  You\'re going down!','',26124),
(5061,'enUS','I cannot be destroyed! By the will of Ragnaros, I shall be reborn!','',26124),
(5062,'enUS','A-Me operational.  A-Me go home.  You speak to A-Me to change locomotion settings.','',26124),
(5063,'enUS','Good... good, A-Me. A-Me good. Home. Find home.','',26124),
(5064,'enUS','Aid me! $n draws near!','',26124),
(5065,'enUS','Help me with this $n!','',26124),
(5066,'enUS','Have you tried that Thunderbrew Lager?  It\'s good stuff!','Have you tried that Thunderbrew Lager?  It\'s good stuff!',26124),
(5067,'enUS','I have duty in an hour, but until then... bottom\'s up!','I have duty in an hour, but until then... bottom\'s up!',26124),
(5068,'enUS','You looking at me, $gladdy:lassy;?','You looking at me, $gladdy:lassy;?',26124),
(5069,'enUS','I\'ll take a pint of Dark Iron ale.  Oh, you\'re not the $gwaiter:waitress;?','I\'ll take a pint of Dark Iron ale.  Oh, you\'re not the $gwaiter:waitress;?',26124),
(5070,'enUS','I think Plugger filled one of his kegs too much.  It looks like it\'s about to blow!','I think Plugger filled one of his kegs too much.  It looks like it\'s about to blow!',26124),
(5071,'enUS','Don\'t bother me while I\'m partying...','Don\'t bother me while I\'m partying...',26124),
(5072,'enUS','Ye be needing directions $glad : lass;?','Ye be needing directions $glad : lass;?',26124),
(5073,'enUS','I love the smell of Ironforge in the morning!  Eh? And what would you be needing $c?','I love the smell of Ironforge in the morning!  Eh? And what would you be needing $c?',26124),
(5074,'enUS','Whatcha need?','Whatcha need?',26124),
(5075,'enUS','IF they say... IF!  There are no if\'s about Ironforge!  Eh?  What now?','IF they say... IF!  There are no if\'s about Ironforge!  Eh?  What now?',26124),
(5076,'enUS','Can you help me with some directions?','Can you help me with some directions?',26124),
(5077,'enUS','What do ye need directions to?','What do ye need directions to?',26124),
(5078,'enUS','Bank of Ironforge','Bank of Ironforge',26124),
(5079,'enUS','Do ye have some new treasures that ye want to keep safe n\' sound?  Then ye\'ll be wanting to store them at The Vault with the Stonemantles.  \n\nYe\'ll find The Vault just a hammer\'s throw northeast from the entrance to Ironforge.','Do ye have some new treasures that ye want to keep safe n\' sound?  Ye\'ll be wanting to store them at The Vault with the Stonemantles.  Ye\'ll find The Vault just a hammer\'s throw northeast from the entrance to Ironforge.',26124),
(5080,'enUS','The bank?  Oh, ye mean The Vault!  No safer place to store yer valuables than The Vault. Ye\'ll find it just northeast of the entrance to Ironforge. ','The bank?  Oh, ye mean The Vault!  No safer place to store yer valuables than The Vault. Ye\'ll find it just northeast of the entrance to Ironforge. ',26124),
(5081,'enUS','Gryphon Master','Gryphon Master',26124),
(5083,'enUS','Looking to take a ride on a gryphon, now are ye?  Gryth Thurden is the one ye\'ll want to be seeing about that.  \n\nYe can find him on the eastern side of The Great Forge in the middle of Ironforge.','Looking to take a ride on a gryphon, now are ye?  Gryth Thurden is the one ye\'ll want to be seeing about that.  \n\nYe can find him on the eastern side of The Great Forge in the middle of Ironforge.',26124),
(5085,'enUS','Ah, nothing quite like a ride on a gryphon, is there?  The night elves can keep those hippo\'s of theirs, just give me a gryphon and the wind in me hair!  \n\nWell now, I won\'t keep ye any longer, just head over to Gryth Thurden on the east side of The Great Forge and he\'ll get ye on yer way.','Ah, nothing quite like a ride on a gryphon, is there?  The night elves can keep those hippo\'s of theirs, just give me a gryphon and the wind in me hair!  \n\nWell now, I won\'t keep ye any longer, just head over to Gryth Thurden on the east side of The Great Forge and he\'ll get ye on yer way.',26124),
(5086,'enUS','Guild Master & Vendor','Guild Master & Vendor',26124),
(5087,'enUS','If yer thinking about forming a guild, then ye\'ll need to put it past Jondor Steelbrow o\'er in the Ironforge Visitor\'s Center.  Just head southeast from the gates of Ironforge to see him.','If yer thinking about forming a guild, then ye\'ll need to put it past Jondor Steelbrow o\'er in the Ironforge Visitor\'s Center.  Just head southeast from the gates of Ironforge to see him.',26124),
(5088,'enUS','Class Trainer','Class Trainer',26124),
(5089,'enUS','Which class trainer might ye be looking for?','Which class trainer might ye be looking for?',26124),
(5090,'enUS','The Inn','The Inn',26124),
(5091,'enUS','The Inn?  Ah, ye looking to toss back some of the best ales Ironforge has to offer?  The Stonefire Tavern is where ye\'ll want to go.  $B$BYe\'ll find it just to the left of the entrance to Ironforge if ye be coming, or to the right if ye be going.','The Inn?  Ah, ye looking to toss back some of the best ales Ironforge has to offer?  The Stonefire Tavern is where ye\'ll want to go. $B$BYe\'ll find it just to the left of the entrance to Ironforge if ye be coming, or to the right if ye be going.',26124),
(5092,'enUS','If yer of need of an Inn, The Stonefire Inn is where ye should be.  Ye\'ll find it just to the left of the entrance to Ironforge if ye be coming, or to the right if ye be going.  $B$BOh, and if yer going that way, then tell them to have a tankard ready for me.','If yer of need of an Inn, The Stonefire Inn is where ye should be.  Ye\'ll find it just to the left of the entrance to Ironforge if ye be coming, or to the right if ye be going.  $B$BOh, and if yer going that way, then tell them to have a tankard ready for me.',26124),
(5093,'enUS','Mailbox','Mailbox',26124),
(5094,'enUS','You can find a mailbox right o\'er by The Stonefire Tavern.  It\'s just north of the gates of Ironforge.','You can find a mailbox right o\'er by The Stonefire Tavern.  It\'s just north of the gates of Ironforge.',26124),
(5095,'enUS','Hunter','Hunter',26124),
(5096,'enUS','I overheard Regnus Thundergranite in the Hall of Arms bragging about a new trophy for his den the other day.  If yer looking for training from a skilled hunter, Regnus is the one to see.','I overheard Regnus Thundergranite in the Hall of Arms bragging about a new trophy for his den the other day.  If yer looking for training from a skilled hunter, Regnus is the one to see.',26124),
(5097,'enUS','Mage','Mage',26124),
(5098,'enUS','That wee wizardly lass, Bink, over in the Hall of Mysteries would probably be able to help ye out with any magical needs you have.  \n\nThe Hall of Mysteries is just north of the gates of Ironforge.','That wee wizardly lass, Bink, over in the Hall of Mysteries would probably be able to help ye out with any magical needs you have.\n\nThe Hall of Mysteries is just north of the gates of Ironforge.',26124),
(5099,'enUS','Well ye\'d be sure to find some training in the magical arts over in the Hall of Mysteries, north of the gates of Ironforge.  Juli Stormkettle can always be found there with her nose in a book.','Well ye\'d be sure to find some training in the magical arts over in the Hall of Mysteries, north of the gates of Ironforge.  Juli Stormkettle can always be found there with her nose in a book.',26124),
(5100,'enUS','Priest','Priest',26124),
(5101,'enUS','Ah, Braenna Flintcrag.  She has magic hands, that one.  Braenna is the one to see about Priestly matters.  \n\nYe\'ll want to travel north from the gates of Ironforge to the Hall of Mysteries.  That\'s where ye\'ll find her.','Ah, Braenna Flintcrag.  She has magic hands, that one.  Braenna is the one to see about Priestly matters.  \n\nYe\'ll want to travel north from the gates of Ironforge to the Hall of Mysteries.  That\'s where ye\'ll find her.',26124),
(5102,'enUS','Paladin','Paladin',26124),
(5103,'enUS','Brandur Ironhammer would be the one ye\'d want to see.  Ye can find him in the Hall of Mysteries north of the gates of Ironforge.','Brandur Ironhammer would be the one ye\'d want to see.  Ye can find him in the Hall of Mysteries north of the gates of Ironforge.',26124),
(5104,'enUS','Ah, good ol\' Brandur Ironhammer.  There\'s no doubt he\'ll provide ye with the guidance ye seek, $glad : lass;.  Ye\'ll find him in the Hall of Mysteries north of the gates of Ironforge.','Ah, good ol\' Brandur Ironhammer.  There\'s no doubt he\'ll provide ye with the guidance ye seek, $glad : lass;.  Ye\'ll find him in the Hall of Mysteries north of the gates of Ironforge.',26124),
(5105,'enUS','Rogue','Rogue',26124),
(5106,'enUS','Now why would ye be needing the services of one of those types?  We get enough trouble out of that rogue, Hulfdan Blackbeard, over in The Forlorn Cavern, do I need to be turning my eye to you as well?','Now why would ye be needing the services of one of those types?  We get enough trouble out of that rogue, Hulfdan Blackbeard, over in The Forlorn Cavern, do I need to be turning my eye to you as well?',26124),
(5107,'enUS','All the roguish types hang out in The Forlorn Cavern, north of the gates of Ironforge.  I\'d wager ye\'ll find Fenthwick there, no doubt counting the coin of another cut purse.  I\'ll catch him one of these days!  \n\nIn the meantime I\'ll have my eye on you as well, $glad : lass;.','All the roguish types hang out in The Forlorn Cavern, north of the gates of Ironforge.  I\'d wager ye\'ll find Fenthwick there, no doubt counting the coin of another cut purse.  I\'ll catch him one of these days!  \n\nIn the meantime I\'ll have my eye on you as well, $glad : lass;.',26124),
(5108,'enUS','Warlock','Warlock',26124),
(5109,'enUS','Where better to look for a dark and brooding lot, than the dark section of Ironforge, aptly named The Forlorn Cavern.  Thistleheart is sure to be found there, likely summoning some manner of vile creature to do his bidding.','Where better to look for a dark and brooding lot, than the dark section of Ironforge, aptly named The Forlorn Cavern.  Thistleheart is sure to be found there, likely summoning some manner of vile creature to do his bidding.',26124),
(5110,'enUS','Warrior','Warrior',26124),
(5111,'enUS','Och! Ye seek training in the way of the warrior, do ye?  Kelstrum Stonebreaker will put ye through yer paces!  Just march yerself over to the Hall of Arms east of the gates of Ironforge. ','Och! Ye seek training in the way of the warrior, do ye?  Kelstrum Stonebreaker will put ye through yer paces!  Just march yerself over to the Hall of Arms east of the gates of Ironforge. ',26124),
(5112,'enUS','Profession Trainer','Profession Trainer',26124),
(5113,'enUS','Which profession trainer would ye be looking for?','Which profession trainer would ye be looking for?',26124),
(5114,'enUS','Alchemy','Alchemy',26124),
(5115,'enUS','An Alchemy trainer is what you need?  Well, I just came from there, I did.  Ye\'ll find Ms. Berryfizz over in Tinker Town where the gnomes gather.','An Alchemy trainer is what you need?  Well, I just came from there, I did.  Ye\'ll find Ms. Berryfizz over in Tinker Town where the gnomes gather.',26124),
(5116,'enUS','Yer looking for an Alchemy trainer are ye?  Just came from there, I did.  Ye\'ll find Ms. Berryfizz over in Tinker Town where the gnomes gather.  \n\n::sigh:: ...why o\' why didn\'t I take the blue potion.','Yer looking for an Alchemy trainer are ye?  Just came from there, I did.  Ye\'ll find Ms. Berryfizz over in Tinker Town where the gnomes gather.  \n\n::sigh:: ...why o\' why didn\'t I take the blue potion.',26124),
(5117,'enUS','Blacksmithing','Blacksmithing',26124),
(5118,'enUS','Ye\'ve come to the right place $glad : lass;!  People come here from all o\'er the world to train to be a blacksmith.  Ye\'ll find Bengus Deepforge hammering away at an anvil in the middle of our fine city by The Great Forge itself.','Ye\'ve come to the right place $glad : lass;!  People come here from all o\'er the world to train to be a blacksmith.  Ye\'ll find Bengus Deepforge hammering away at an anvil in the middle of our fine city by The Great Forge itself.',26124),
(5119,'enUS','Cooking','Cooking',26124),
(5120,'enUS','A Cooking trainer is it?  Well then, get yerself over to the Bronze Kettle on the northeastern side of The Great Forge.  Daryl Riknussun will teach ye to make a mighty fine dish that\'s sure to put the life back in ye!','A Cooking trainer is it?  Well then, get yerself over to the Bronze Kettle on the northeastern side of The Great Forge.  Daryl Riknussun will teach ye to make a mighty fine dish that\'s sure to put the life back in ye!',26124),
(5121,'enUS','Enchanting','Enchanting',26124),
(5122,'enUS','Ah, I believe Gimble Thistlefuzz is who ye\'ll be needing if yer looking to learn the Enchanter\'s profession.  Ye\'ll find Gimble in his shop, Thistlefuzz Arcanery, right by the Gryphon Master at The Great Forge.','Ah, I believe Gimble Thistlefuzz is who ye\'ll be needing if yer looking to learn the Enchanter\'s profession.  Ye\'ll find Gimble in his shop, Thistlefuzz Arcanery, right by the Gryphon Master at The Great Forge.',26124),
(5123,'enUS','Engineering','Engineering',26124),
(5124,'enUS','The tinkerer\'s craft for you is it?  No doubt ye\'ll want to go see Springspindle Fizzlegear in Tinker Town.  \n\nJust head east from the gates of Ironforge, or follow the sound of the explosions.','The tinkerer\'s craft for you is it?  No doubt ye\'ll want to go see Springspindle Fizzlegear in Tinker Town.  \n\nJust head east from the gates of Ironforge, or follow the sound of the explosions.',26124),
(5125,'enUS','First Aid','First Aid',26124),
(5126,'enUS','A valuable skill First Aid is.  Our resident trainer, Nissa Firestone, can show ye how it\'s done.  Look for her on the southern side of The Great Forge at the Ironforge Physician.','A valuable skill First Aid is.  Our resident trainer, Nissa Firestone, can show ye how it\'s done.  Look for her on the southern side of The Great Forge at the Ironforge Physician.',26124),
(5127,'enUS','Fishing','Fishing',26124),
(5128,'enUS','Grimnur Stonebrand will tell ye some whoppers about the one that got away, but he\'s still one o\' the best fishermen around.  He\'s got a shop set up in The Forlorn Cavern called the Traveling Fisherman.','Grimnur Stonebrand will tell ye some whoppers about the one that got away, but he\'s still one o\' the best fishermen around.  He\'s got a shop set up in The Forlorn Cavern called the Traveling Fisherman.',26124),
(5129,'enUS','Herbalism','Herbalism',26124),
(5130,'enUS','Herbalism','Herbalism',26124),
(5131,'enUS','Flowers and seeds and such?  That would be Reyna Stonebranch\'s area of expertise.  Ye can find her tending to her plants over at the Ironforge Physician on the southern side of The Great Forge.','Flowers and seeds and such?  That would be Reyna Stonebranch\'s area of expertise.  Ye can find her tending to her plants over at the Ironforge Physician on the southern side of The Great Forge.',26124),
(5132,'enUS','Oh, ye want to learn to pick some daisies do ye?  Ha!  I\'m just teasing ye $gladdie : lass;.  \n\nA fine profession it is, and Reyna Stonebranch can show ye how it\'s done.  She works at the Ironforge Physician on the southern side of The Great Forge.','Oh, ye want to learn to pick some daisies do ye?  Ha!  I\'m just teasing ye $gladdie : lass;.  \n\nA fine profession it is, and Reyna Stonebranch can show ye how it\'s done.  She works at the Ironforge Physician on the southern side of The Great Forge.',26124),
(5133,'enUS','Leatherworking','Leatherworking',26124),
(5135,'enUS','Fimble Finespindle has a shop set up on the northwest side of The Great Forge.  I wager he could show ye how to make some fine armor.','Fimble Finespindle has a shop set up on the northwest side of The Great Forge.  I wager he could show ye how to make some fine armor.',26124),
(5136,'enUS','Lockpicking','Lockpicking',26124),
(5137,'enUS','Durtham Greldon over in The Forlorn Cavern can teach ye the in\'s and out\'s of lockpicking.  Just don\'t be practicing any of those in\'s or out\'s here in Ironforge, if ye understand my meaning.','Durtham Greldon over in The Forlorn Cavern can teach ye the in\'s and out\'s of lockpicking.  Just don\'t be practicing any of those in\'s or out\'s here in Ironforge, if ye understand my meaning.',26124),
(5138,'enUS','Mining','Mining',26124),
(5139,'enUS','Do we have Mining trainers here?  Where do ye think ye are!?  \n\nWhy you\'ll find one o\' the best miners in all Dun Morogh at Deepmountain Mining and Jewelcrafting on the northern side of The Great Forge.  There, Geofram Bouldertoe will show ye the true art of mining.','Do we have Mining trainers here?  Where do ye think ye are!?  \n\nWhy you\'ll find one o\' the best miners in all Dun Morogh at Deepmountain Mining and Jewelcrafting on the northern side of The Great Forge.  There, Geofram Bouldertoe will show ye the true art of mining.',26124),
(5140,'enUS','Skinning','Skinning',26124),
(5141,'enUS','Balthus Stoneflayer is the one to see about Skinning.  If it can be skinned, he can teach ye how.  Just walk yerself over to Finespindle\'s Leather Goods on the northern side of The Great Forge.','Balthus Stoneflayer is the one to see about Skinning.  If it can be skinned, he can teach ye how.  Just walk yerself over to Finespindle\'s Leather Goods on the northern side of The Great Forge.',26124),
(5142,'enUS','Survival','Survival',26124),
(5143,'enUS','Tresa Farmountain has seen her share of bad weather, but with her knowledge of Survival skills she\'s come through with her spirits high.  \n\nShe\'s over in The Military Ward south of the gates of Ironforge if you wish to speak with her.','Tresa Farmountain has seen her share of bad weather, but with her knowledge of Survival skills she\'s come through with her spirits high.  \n\nShe\'s over in The Military Ward south of the gates of Ironforge if you wish to speak with her.',26124),
(5144,'enUS','Tailoring','Tailoring',26124),
(5145,'enUS','That Jormund Stonebrow has a knack for the needle, he does.  Should you be needing some training, then you\'ll find him at Stonebrow\'s Clothier on the northern side of The Great Forge.','That Jormund Stonebrow has a knack for the needle, he does.  Should you be needing some training, then you\'ll find him at Stonebrow\'s Clothier on the northern side of The Great Forge.',26124),
(5146,'enUS','Tracking','Tracking',26124),
(5147,'enUS','Tracking is it?  Then Denmul Farmountain is the one you should pay a visit to.  He\'ll teach ye the tricks of the trade like no other.  \n\nJust head south from the gates of Ironforge to The Military District to find him.','Tracking is it?  Then Denmul Farmountain is the one you should pay a visit to.  He\'ll teach ye the tricks of the trade like no other.  \n\nJust head south from the gates of Ironforge to The Military District to find him.',26124),
(5148,'enUS','I will need to focus my energies onto this knife.  By doing so, I should catch some of the stronger psychic impressions associated with it.','',26124),
(5149,'enUS','I... I\'ve seen enough I think... so very draining...','',26124),
(5150,'enUS','I have suffered, but now I can feel it slowly fading from me. I feel... free.','',26124),
(5151,'enUS','The Crystal Pylons of Un\'Goro are a mystery to all. To the few inhabitants here, they are a source of legend, with much speculation as to their purpose.','',26124),
(5152,'enUS','Examine the pylon.','Examine the pylon.',26124),
(5153,'enUS','The pylon seems to be transmitting data somewhere.$b$bA closer inspection of the pylon leads you to find a small table containing yellow, red, and green crystals arranged in what seems like a specific formation.$B$BA large blue circle of crystals is flanked on either side by a smaller circle of yellow crystals and another of green crystals.$B$BYou carefully take note of what you see, knowing that someone may be very interested in hearing about what you have found.','',26124),
(5154,'enUS','The pylon seems to be transmitting data somewhere.$b$bA closer inspection of the pylon leads you to find a small table containing yellow, red, and green crystals arranged in what seems like a specific formation.$B$BA large yellow circle of crystals is flanked on either side by a smaller circle of red crystals and another of green crystals.$B$BYou carefully take note of what you see, knowing that someone may be very interested in hearing about what you have found.\n','',26124),
(5155,'enUS','The pylon seems to be transmitting data somewhere.$b$bA closer inspection of the pylon leads you to find a small table containing red, blue, and green crystals arranged in what seems like a specific formation.$B$BA large red circle of crystals is flanked on either side by a smaller circle of blue crystals and another of green crystals.$B$BYou carefully take note of what you see, knowing that someone may be very interested in hearing about what you have found.','',26124),
(5156,'enUS','A-Me home! A-Me, good! Good A-Me. Home. Home. Home.','',26124),
(5157,'enUS','Bad, $n. $n, bad!','',26124),
(5158,'enUS','$n, no hurt A-Me. A-Me, good.','',26124),
(5159,'enUS','Danger. Danger! $n try hurt A-Me.','',26124),
(5160,'enUS','A-Me, home. A-Me go home! $n, no stop A-Me.','',26124),
(5161,'enUS','','Get this, $n off of me!',26124),
(5162,'enUS','','Help!',26124),
(5163,'enUS','','I need help!',26124),
(5164,'enUS','','$n attacking! Help!',26124),
(5166,'enUS','I want more ale!  Give me more ale!','',26124),
(5167,'enUS','That one\'s empty!!','',26124),
(5168,'enUS','Ah, empty again!','',26124),
(5169,'enUS','ALE!','',26124),
(5170,'enUS','%s looks at you expectantly.','',26124),
(5171,'enUS','','My name\'s J.D., and I really can\'t tell you much about how I got here, but what I can tell you is that this camp is my home now!$B$BI spend my time studying the strange crystals that can be found all over the crater.  You must have seen some on your way over here.  Say, did you happen to pick any up?',26124),
(5172,'enUS','Ah, hits the spot!','',26124),
(5173,'enUS','Sweet Elune, thanks for getting me out of that... thing!','',26124),
(5175,'enUS','Come with me if you want to live.','Come with me if you want to live.',26124),
(5176,'enUS','Burning Steppes - Tablet of the Seven','',26124),
(5177,'enUS','Transcribe the tablet.','Transcribe the tablet.',26124),
(5178,'enUS','The symbols on the tablet are carefully transcribed...','',26124),
(5179,'enUS','Greetings, $c. For some, the hunter is a way of life, a chosen profession. For others, it is something of a pastime, a badge of courage, or a rite of passage depending on your tribe.$B$BFor me, race and profession mean nothing - it is the testing of your spirit and mind that I respect. For one to stand against the forces of nature and test all of their skills is the true mark of honor.$B$BIf you wish to test yourself and earn my respect, then speak to me more.','',26124),
(5181,'enUS','You\'ve started down an honorable path, $n. My ancestors respect your willingness, but you will not have my approval until you have followed through with my tasks.$B$BYou know what you must do if you wish to prove yourself a hunter in spirit.','',26124),
(5182,'enUS','I give you warm greetin\'s, $c, as does the Shattered Hand.$B$BDo not look so surprised, $n. There be shadows even on the highest perches of Orgrimmar--somethin\' must hide there. The Shattered Hand take that role willingly. Thrall, even in his good heart, acknowledge that the Hand be necessary to ensure orc and troll safety.$B$BBut you not here to talk \'bout my business, you here for somethin\' else.','',26124),
(5183,'enUS','Un\'Goro Crater be far to the south of Kalimdor. Beyond the Thousand Needles in Tanaris. Look for the large floating stones... they mark the entrance to the Crater. But be careful... it is no easy path. The raptors are not far from the entrance.','',26124),
(5184,'enUS','Where is Un\'Goro Crater?','Where is Un\'Goro Crater?',26124),
(5185,'enUS','','Thanks to you, we can now unlock the secrets of the crystals and the mysterious pylons, $n. If you need more information at any time, please come back and visit me again!',26124),
(5186,'enUS','Tell me more about the Eastern Crystal Pylon.','Tell me more about the Eastern Crystal Pylon.',26124),
(5187,'enUS','Who is this Lar\'korwi you spoke of?','Who is this Lar\'korwi you spoke of?',26124),
(5188,'enUS','Tell me more about the Northern Crystal Pylon.','Tell me more about the Northern Crystal Pylon.',26124),
(5189,'enUS','The ravasaur here in Un\'Goro seem to be related to the raptors of the barrens - highly intelligent, volatile, and with a sense or code of conduct. The greatest of these that I have encountered is  Lar\'korwi. He is one of the most dangerous beasts I\'ve ever seen. In taurahe, Lar\'korwi means \"sharp claw,\" but that does not do him justice.$B$BDo not underestimate Lar\'korwi if you ever plan on hunting him, but I will help you in any way I can if you do.','',26124),
(5190,'enUS','Tell me more about the Western Crystal Pylon.','Tell me more about the Western Crystal Pylon.',26124),
(5191,'enUS','I lost my Crystal Pylon User\'s Manual and need another one.','I lost my Crystal Pylon User\'s Manual and need another one.',26124),
(5192,'enUS','','The Eastern Pylon accepts blue, yellow, and green crystals.$B$BIt focuses on the energy that can be created using blue crystals as the main source of power. There are two possible effects: one provides bonus to spirit, and one that creates a damaging shield.$B$BCrystal Force requires blue and green crystals. This will provide you with an increase in spirit.$B$BCrystal Spire requires blue and yellow crystals. This will create a shield that does damage to attackers.\n\n',26124),
(5193,'enUS','','The Northern Pylon accepts yellow, red, and green crystals.$B$BThe focus is the energy that can be created using yellow crystals as the main source of power. There are two possible effects: one that will produce damage, and one that will negate damage. $B$BCrystal Charge requires red and yellow crystals. This will produce a large explosion, stunning your enemies.$B$BCrystal Restore requires yellow and green crystals. This will provide you with a healing aura.',26124),
(5194,'enUS','','The Western Pylon accepts red, green, and blue crystals.$B$BThe Pylon focuses on the energy that can be created using red crystals as the main source of power. There are two possible effects: one that increases your protection from damage, and one that weakens an enemy\'s defenses.$B$BCrystal Ward requires red and green crystals. This will provide you with an increase to armor.$B$BCrystal Yield requires blue and red crystals. This can lower the armor of a specific target.',26124),
(5195,'enUS','','Sure thing, $n. Here\'s another for you.',26124),
(5196,'enUS','You see the faint outline of a humanoid figure inside the pod; you now know that this is indeed the location you need to be at.  While you think you will eventually be able to open the pod, it remains tighly shut even to your most forceful attempts to open it.','',26124),
(5197,'enUS','%s attacks a new target!','',26124),
(5198,'enUS','You make perfect little hat, $r!','',26124),
(5199,'enUS','Ograbisi needs new hat!','',26124),
(5200,'enUS','What manner of filth dares enter my chambers!?','',26124),
(5201,'enUS','Ah, just in time for your cleansing, $r. I shall wax the impurities from your soul.','',26124),
(5202,'enUS','Is that you, my dear Tobias???','',26124),
(5203,'enUS','Perhaps Ograbisi will use your head as a tiny little hat when I\'m through with you.','',26124),
(5204,'enUS','','These once beautiful woods suffer under a terrible curse!  Corrupting forces twist the life here into shadows of their former selves.  If you are not an agent of this corruption, then perhaps you can aid me in reclaiming Felwood!',26124),
(5205,'enUS','Let\'s get a move on. My gear should be in the storage area up this way...','',26124),
(5206,'enUS','','\"Taurahe?\"$B$BThe tauren druid looks at you expectantly, but it is clear you cannot verbally communicate with her.  Undaunted, she points to herself and smiles.  She points at you and smiles once more.  She finally motions several times down the path to the south.$B$BPerhaps she is indicating that there is a druid you can speak to further down the road?\n',26124),
(5207,'enUS','Check that cell, $n. If someone is alive in there, we need to get them out.','',26124),
(5208,'enUS','','These once beautiful woods suffer under a terrible curse!  Corrupting forces twist the life here into shadows of their former selves.  If you are not an agent of this corruption, then perhaps you can aid me in reclaiming Felwood!',26124),
(5209,'enUS','','\"Darnassae?\"$B$BThe night elf druid looks at you expectantly, but it is clear you cannot verbally communicate with her.  Undaunted, she points to herself and smiles.  She points at you and smiles once more.  She finally motions several times down the path to the north.$B$BPerhaps she is indicating that there is a druid you can speak to further up the road?',26124),
(5210,'enUS','Thank you, $n! I\'m free!!!','',26124),
(5211,'enUS','HELP!!!!','',26124),
(5212,'enUS','You\'re free, Dughal! Get out of here!','You\'re free, Dughal! Get out of here!',26124),
(5213,'enUS','Good work! We\'re almost there! This way.','',26124),
(5214,'enUS','This is it, $n. My stuff should be in that room. Cover me, I\'m going in!','',26124),
(5215,'enUS','Ah, there it is!','',26124),
(5216,'enUS','Can you feel the power, $n??? It\'s time to ROCK!','',26124),
(5217,'enUS','Now we just have to free Tobias and we can get out of here. This way!','',26124),
(5218,'enUS','Finally!! I can leave this dump.','',26124),
(5219,'enUS','Did Crest send you?','',26124),
(5220,'enUS','Get out of here, Tobias, you\'re free!','Get out of here, Tobias, you\'re free!',26124),
(5221,'enUS','Excellent work, $n. Let\'s find the exit. I think I know the way. Follow me!','',26124),
(5222,'enUS','Open it.','',26124),
(5223,'enUS','I never did like those two. Let\'s get moving.','',26124),
(5224,'enUS','Open it and be careful this time!','',26124),
(5225,'enUS','That intolerant dirtbag finally got what was coming to him. Good riddance!','',26124),
(5226,'enUS','%s spits on the ground.','',26124),
(5227,'enUS','Alright, let\'s go.','',26124),
(5228,'enUS','Open it. We need to hurry up. I can smell those Dark Irons coming a mile away and I can tell you one thing, they\'re COMING!','',26124),
(5229,'enUS','He has to be in the last cell. Unless... they killed him.','',26124),
(5230,'enUS','Get him out of there!','',26124),
(5231,'enUS','We made it!','',26124),
(5232,'enUS','Meet me at Maxwell\'s encampment. We\'ll go over the next stages of the plan there and figure out a way to decode my tablets without the decryption ring.','',26124),
(5233,'enUS','Grurk open soon. Then we split treasure.','',26124),
(5234,'enUS','Stupid box! Stupid, stupid box! OPEN! GRURK SAY YOU OPEN!','',26124),
(5236,'enUS','Let me try! You too stupid!','',26124),
(5237,'enUS','Grurk stupid? You try open box! Maybe you smart as gnome???','',26124),
(5238,'enUS','Lumurk open this box easy!','',26124),
(5239,'enUS','Box stupid. Lumurk sleepy.','',26124),
(5240,'enUS','','There are plants in Felwood that may be saved from corruption when Cenarion plant salve is applied to them.  I know how to make the salve from several different kinds of items; based on your skill set, you may find that you have multiple options to assist me.$B$BYou will also need a Cenarion beacon for your work here; it is a device that allows you to see the taint and corruption of nature that the naked eye will miss.',26124),
(5241,'enUS','','There are plants in Felwood that may be saved from corruption when Cenarion plant salve is applied to them.  I know how to make the salve from several different kinds of items; based on your skill set, you may find that you have multiple options to assist me.$B$BYou will also need a Cenarion beacon for your work here; it is a device that allows you to see the taint and corruption of nature that the naked eye will miss.',26124),
(5243,'enUS','I need a Cenarion beacon.','I need a Cenarion beacon.',26124),
(5244,'enUS','','Here is a beacon for you, $n.  You must keep it in your possession if you are to find the corrupted items we will need.',26124),
(5245,'enUS','','Here is a beacon for you, $n.  You must keep it in your possession if you are to find the corrupted items we will need.',26124),
(5246,'enUS','The remains are covered in flies and maggots.','',26124),
(5247,'enUS','I summon you, Sha\'ni Proudtusk! ','I summon you, Sha\'ni Proudtusk! ',26124),
(5248,'enUS','%s looks as though he\'s been stymied. He takes a few moments to recover from his wounds.','',26124),
(5249,'enUS','Administering fists of fury on $n!','',26124),
(5250,'enUS','You better hold me back or $n is going to feel some prison house beatings.','',26124),
(5251,'enUS','This is gonna leave a mark!','',26124),
(5252,'enUS','I bet you\'re sorry now, aren\'t you $n!?!','',26124),
(5253,'enUS','You locked up the wrong Marshal, $n. Prepare to be destroyed!','',26124),
(5254,'enUS','The large shrine was built many years ago by the night elves that once inhabited this land.$B$BWhat secrets could it hold?','',26124),
(5255,'enUS','I need another sparkling stone.','I need another sparkling stone.',26124),
(5256,'enUS','Continue...','Continue...',26124),
(5257,'enUS','The door is open, Kharan. You are a free man.','The door is open, Kharan. You are a free man.',26124),
(5258,'enUS','Where I come from, you get shanked for opening another inmate\'s cell door!','',26124),
(5259,'enUS','Doesn\'t anybody KNOCK anymore???!','',26124),
(5260,'enUS','I have destroyed my Azsharite weaponry! I need your assistance in defeating the triad of power.','I have destroyed my Azsharite weaponry! I need your assistance in defeating the triad of power.',26124),
(5261,'enUS','I regret that I must fight this $n.','',26124),
(5262,'enUS','Hey!  What\'s gives?','Hey!  What\'s gives?',26124),
(5263,'enUS','You\'ll pay for that!','You\'ll pay for that!',26124),
(5264,'enUS','Oh, now I\'m pissed!','Oh, now I\'m pissed!',26124),
(5265,'enUS','No!','No!',26124),
(5266,'enUS','Hey, my pockets were picked!','',26124),
(5267,'enUS','That\'s it!  No more beer until this mess is sorted out!','',26124),
(5268,'enUS','Ha! Ha! Ha! Thank you for freeing me, fools. Now let me repay you by charring the flesh from your bones.','',26124),
(5269,'enUS','','We showed that one!',26124),
(5270,'enUS','The secrets hidden within the Pylons of Un\'Goro Crater are now yours. Visit the Pylons at any time to access their power and gain useful resources.','',26124),
(5271,'enUS','You can\'t hide from us.  Prepare to burn!','',26124),
(5274,'enUS','Welcome to Tanaris, $n. How can I be of service to you today? You don\'t look like a blacksmith to me, but I know how looks can be deceiving.','',26124),
(5275,'enUS','','Uh oh!  I\'m out of here!',26124),
(5281,'enUS','I\'m getting out of here!','',26124),
(5283,'enUS','%s begins to summon a lava spawn!','',26124),
(5284,'enUS','I do not enjoy conversation.','',26124),
(5285,'enUS','','Oh, no! We\'ve run out of time. ',26124),
(5286,'enUS','%s cries out an alarm!','',26124),
(5287,'enUS','','Now, let\'s see... If I am correct, then... Hmmm...',26124),
(5288,'enUS','','Blue plus red... I predict...',26124),
(5289,'enUS','','$n, that\'s it! I have finally figured it out!',26124),
(5290,'enUS','They are lost, $r. Librams written by the elven masters. Scattered across the world when the Scourge was unleashed upon Quel\'Thalas.$B$BNow we search for these librams. Search to find the secrets they hold - to restore power once had.$B$BI search for the ten written by Master Kariel Winthalus. Should you find a libram, allow me to absorb its magical properties and for you I shall craft an amalgamation of power... of course, all things come at some cost. You will find my cost to be high; but pay you shall.','',26124),
(5291,'enUS','I present to you the Libram of Rumination.','I present to you the Libram of Rumination.',26124),
(5292,'enUS','Ah, so... you have found it.$B$B<Mathredis points to the book in your possession.>$B$BHave you collected the necessary components?$B$BThe manifestations listed in the libram, imbecile!','',26124),
(5293,'enUS','<Mathredis gazes intently at the libram.>$B$BYou come for an amalgamation? Have you done as the libram instructed?','',26124),
(5294,'enUS','Give me the arcana and I shall craft the amalgamation, mortal.','',26124),
(5295,'enUS','A rare find, indeed.$B$B<Mathredis nods.>$B$B If you wish to continue, I will need the components.','',26124),
(5296,'enUS','Greed has led you back to me.$B$B<Mathredis laughs.>$B$BA wise Draenei once told me that it - greed - is the single quality that all of the races on this world share. I would have to agree.$B$BHave you collected the components listed within the libram?','',26124),
(5297,'enUS','Intruders in the Manufactory? My constructs will destroy you!','',26124),
(5298,'enUS','May the Light protect you this day.','May the Light protect you this day.',26124),
(5299,'enUS','I would like to train further in the ways of the Light.','I would like to train further in the ways of the Light.',26124),
(5300,'enUS','Violence!  Property damage!  None shall pass!!','',26124),
(5301,'enUS','You must leave the bar!','',26124),
(5302,'enUS','You have outworn your welcome!','',26124),
(5303,'enUS','NO SERVICE!!','',26124),
(5304,'enUS','What want from Raze??','',26124),
(5305,'enUS','','Hello, $n. Should you require assistance in completing your mission, you have only to ask. My guardian, Raze, can assist you in defeating the shadowsilk poachers. Use this Staff of Command to command Raze in battle. He is trained to ONLY attack shadowsilk poachers.',26124),
(5306,'enUS','I need help in defeating the shadowsilk poachers.','I need help in defeating the shadowsilk poachers.',26124),
(5307,'enUS','Drink up!  There\'s more where that came from!','',26124),
(5308,'enUS','Enjoy!  You won\'t find better ale anywhere!','',26124),
(5309,'enUS','Have you tried the Dark Iron Ale?  It\'s the best!','',26124),
(5310,'enUS','Try the boar!  It\'s my new recipe!','',26124),
(5311,'enUS','Thank you for clearing out those foolish senators.  Now prepare to meet your doom at the hands of Ragnaros\' most powerful servant.','',26124),
(5312,'enUS','Your efforts are utterly pointless, fools!  You will never be able to defeat me!','',26124),
(5313,'enUS','They were just getting in the way anyways.','',26124),
(5314,'enUS','Ha! You can\'t even begin to imagine the futility of your efforts.','',26124),
(5315,'enUS','Is that the best you can do?  Do you really expect that you could defeat someone as awe inspiring as me?','',26124),
(5316,'enUS','Auction House','Auction House',26124),
(5317,'enUS','Where is the Auction House?  Why it\'s right by the gates of Ironforge as you enter our fine city.  Ye\'ll find it just across from The Vault.','Where is the Auction House?  Why it\'s right by the gates of Ironforge as you enter our fine city.  Ye\'ll find it just across from The Vault.',26124),
(5318,'enUS','Anu therador mali $c.  Where can I guide you to?','Anu therador mali $c.  Where can I guide you to?',26124),
(5319,'enUS','How may I aid you in your journey?','How may I aid you in your journey?',26124),
(5320,'enUS','Do you require guidance to your destination?','Do you require guidance to your destination?',26124),
(5321,'enUS','What direction can I point you in?','What direction can I point you in?',26124),
(5324,'enUS','Can you help me with some directions?','Can you help me with some directions?',26124),
(5325,'enUS','Of all the wondrous places within Darnassus, which would you have me direct you to?','Of all the wondrous places within Darnassus, which would you have me direct you to?',26124),
(5326,'enUS','The Bank','The Bank',26124),
(5328,'enUS','','',26124),
(5329,'enUS','You may find storage for your worldly goods at the bank of Darnassus, which lies in the center of our wondrous city.','You may find storage for your worldly goods at the bank of Darnassus, which lies in the center of our wondrous city.',26124),
(5330,'enUS','Hippogryph Master','Hippogryph Master',26124),
(5331,'enUS','Vesprystus\' hippogryphs will bear you swiftly to your destination.  Seek him out in Rut\'theran Village, through the portal which lies in the western section of Darnassus.','Vesprystus\' hippogryphs will bear you swiftly to your destination.  Seek him out in Rut\'theran Village, through the portal which lies in the western section of Darnassus.',26124),
(5332,'enUS','Guild Master & Vendor','Guild Master & Vendor',26124),
(5333,'enUS','If you desire to form a fellowship then it is the guild master, Lysheana, that you must see.  You will find her in the Craftsmen\'s Terrace in the northeastern section of Darnassus.','If you desire to form a fellowship then it is the guild master, Lysheana, that you must see.  You will find her in the Craftsmen\'s Terrace in the northeastern section of Darnassus.',26124),
(5334,'enUS','The Inn','The Inn',26124),
(5335,'enUS','Though I find the cool grass which covers Teldrassil as good a bed as any, the beds which Saelienne keeps at the Inn in Craftsman\'s Terrace are quite suitable for those with a taste for luxury.','Though I find the cool grass which covers Teldrassil as good a bed as any, the beds which Saelienne keeps at the Inn in Craftsman\'s Terrace are quite suitable for those with a taste for luxury.',26124),
(5336,'enUS','Mailbox','Mailbox',26124),
(5337,'enUS','There is a mailbox outside of the Bank which you\'ll find in the center of Darnassus.','There is a mailbox outside of the Bank which you\'ll find in the center of Darnassus.',26124),
(5338,'enUS','A class trainer','A class trainer',26124),
(5339,'enUS','Here in Darnassus you will find skilled trainers who have perfected the skills of their chosen class through ages of training and dedication.  I will guide you to one who can become your mentor, you have but to name your chosen path.','Here in Darnassus you will find skilled trainers who have perfected the skills of their chosen class through ages of training and dedication.  I will guide you to one who can become your mentor, you have but to name your chosen path.',26124),
(5340,'enUS','Hunter','Hunter',26124),
(5341,'enUS','You are fortunate to have come to Darnassus where you can find such an accomplished Hunter as Jocaste among our trainers.  I encourage you to visit her over in the Cenarion Enclave and seek her tutelage.','You are fortunate to have come to Darnassus where you can find such an accomplished Hunter as Jocaste among our trainers.  I encourage you to visit her over in the Cenarion Enclave and seek her tutelage.',26124),
(5342,'enUS','Druid','Druid',26124),
(5343,'enUS','In grizzly times a druid can be a dear friend to those around them.  Ask any of the druids in the Cenarion Enclave and they will tell you the same.','In grizzly times a druid can be a dear friend to those around them.  Ask any of the druids in the Cenarion Enclave and they will tell you the same.',26124),
(5344,'enUS','Priest','Priest',26124),
(5345,'enUS','The Temple of the Moon is home to the priests of Elune.  There you will find Jandria and Lariia, who will provide you with further guidance in the path of priesthood.','The Temple of the Moon is home to the priests of Elune.  There you will find Jandria and Lariia, who will provide you with further guidance in the path of priesthood.',26124),
(5346,'enUS','The power of Elune compels you!  The power of Elune compels you!  \n\nGo now!  Seek out Jandria in the central hall of the Temple of the Moon in the southern section of Darnassus!','The power of Elune compels you!  The power of Elune compels you!  \n\nGo now!  Seek out Jandria in the central hall of the Temple of the Moon in the southern section of Darnassus!',26124),
(5347,'enUS','Rogue','Rogue',26124),
(5348,'enUS','It is Syurna that you seek if you are to follow the rogue\'s path.  She dwells in the Cenarion Enclave down the spiraling path within the western most tree.','It is Syurna that you seek if you are to follow the rogue\'s path.  She dwells in the Cenarion Enclave down the spiraling path within the western most tree.',26124),
(5349,'enUS','There are those that attempt to follow the path of the Rogue, but only the night elves are truly embraced by the night.  If you seek to walk the shaded path then find Syurna in the Cenarion Enclave.','There are those that attempt to follow the path of the Rogue, but only the night elves are truly embraced by the night.  If you seek to walk the shaded path then find Syurna in the Cenarion Enclave.',26124),
(5350,'enUS','Warrior','Warrior',26124),
(5351,'enUS','You will find Sildinair at the Warrior\'s Terrace among the guards, her keen eyes scanning the forest for enemies that might dare to enter our fair city.  ','You will find Sildinair at the Warrior\'s Terrace among the guards, her keen eyes scanning the forest for enemies that might dare to enter our fair city.  ',26124),
(5352,'enUS','Profession Trainer','Profession Trainer',26124),
(5353,'enUS','Here among the craftsmen of Darnassus, there is a millennium of knowledge for the benefit of your chosen craft.  Now tell me, which craft do you find the most intriguing?','Here among the craftsmen of Darnassus, there is a millennium of knowledge for the benefit of your chosen craft.  Now tell me, which craft do you find the most intriguing?',26124),
(5354,'enUS','Alchemy','Alchemy',26124),
(5355,'enUS','If you truly have the desire to learn this profession, then I would point you in the direction of Ainethil, a skilled alchemist at the Craftsmen\'s Terrace in northern Darnassus.','If you truly have the desire to learn this profession, then I would point you in the direction of Ainethil, a skilled alchemist at the Craftsmen\'s Terrace in northern Darnassus.',26124),
(5356,'enUS','Cooking','Cooking',26124),
(5357,'enUS','Alegorn is a masterful chef who has had centuries with which to perfect his cooking.  You should consider yourself blessed should he decide to teach you.  If you believe you are worthy, you can find him in the Craftsmen\'s Terrace.','Alegorn is a masterful chef who has had centuries with which to perfect his cooking.  You should consider yourself blessed should he decide to teach you.  If you believe you are worthy, you can find him in the Craftsmen\'s Terrace.',26124),
(5358,'enUS','The dishes that Alegorn whips up are to die for.  He\'s always busy preparing new delicacies over in the Craftsman\'s Terrace.  Be sure to try his Cenarion Green recipe if he has any left.  \n\nNow, if you don\'t mind, I must investigate this rash of missing deer. ','The dishes that Alegorn whips up are to die for.  He\'s always busy preparing new delicacies over in the Craftsman\'s Terrace.  Be sure to try his Cenarion Green recipe if he has any left.  \n\nNow, if you don\'t mind, I must investigate this rash of missing deer. ',26124),
(5360,'enUS','Class Trainer','Class Trainer',26124),
(5362,'enUS','Alchemy','Alchemy',26124),
(5363,'enUS','Enchanting','Enchanting',26124),
(5364,'enUS','Because the blade can never be too sharp nor the armor too tough a talented enchanter will always be needed.  Such an enchanter is Taladan, who can show you how to properly weave enchantments to improve your weapons and armor.  Seek him out in the Craftsmen\'s Terrace.','Because the blade can never be too sharp nor the armor too tough a talented enchanter will always be needed.  Such an enchanter is Taladan, who can show you how to properly weave enchantments to improve your weapons and armor.  Seek him out in the Craftsmen\'s Terrace.',26124),
(5365,'enUS','Och!  Ye should be careful what ye get enchanted $glad : lass;.  I had me mug enchanted so it wouldn\'t spill a drop, but now I can\'t drink from it!  Such a tragedy.  \n\nYou be sure to heed me advice when ye see Gimble.  He\'ll be in his shop right by the Gryphon Master at The Great Forge.','Och!  Ye should be careful what ye get enchanted $glad : lass;.  I had me mug enchanted so it wouldn\'t spill a drop, but now I can\'t drink from it!  Such a tragedy.  \n\nYou be sure to heed me advice when ye see Gimble.  He\'ll be in his shop right by the Gryphon Master at The Great Forge.',26124),
(5366,'enUS','First Aid','First Aid',26124),
(5367,'enUS','When you have not a healer to tend to your wounds, the knowledge of First Aid can be a lifesaver.  I would consult Dannelor over at the Craftsmen\'s Terrace for instruction on this skill.','When you have not a healer to tend to your wounds, the knowledge of First Aid can be a lifesaver.  I would consult Dannelor over at the Craftsmen\'s Terrace for instruction on this skill.',26124),
(5368,'enUS','Fishing','Fishing',26124),
(5369,'enUS','A time consuming, yet rewarding skill.  Speak with Astaia in the Tradesman\'s Terrace and maybe you\'ll learn something useful.','A time consuming, yet rewarding skill.  Speak with Astaia in the Tradesman\'s Terrace and maybe you\'ll learn something useful.',26124),
(5370,'enUS','Herbalism','Herbalism',26124),
(5371,'enUS','Leatherworking','Leatherworking',26124),
(5372,'enUS','The skill with which Telonis crafts armor is beyond compare.  You should be grateful that he does not charge more for the knowledge he passes to others.  Go now and seek him out in the Craftsmen\'s Terrace in the northeast section of Darnassus.','The skill with which Telonis crafts armor is beyond compare.  You should be grateful that he does not charge more for the knowledge he passes to others.  Go now and seek him out in the Craftsmen\'s Terrace in the northeast section of Darnassus.',26124),
(5373,'enUS','We plant the vegetables.  Our vegetables are eaten by the rabbit.  The rabbit is devoured by the wolf.  The wolf is slain by us.  We take the meat and hide from the wolf\'s corpse.  It\'s that Magic Circle of life, or whatever you call it.  \n\nNow go see Telonis in the Cenarion Enclave to get started and let me return to my duties.','We plant the vegetables.  Our vegetables are eaten by the rabbit.  The rabbit is devoured by the wolf.  The wolf is slain by us.  We take the meat and hide from the wolf\'s corpse.  It\'s that Magic Circle of life, or whatever you call it.  \n\nNow go see Telonis in the Cenarion Enclave to get started and let me return to my duties.',26124),
(5374,'enUS','Lockpicking','Lockpicking',26124),
(5375,'enUS','\"A skill for those who wish to overcome obstacles.\"  I believe that is how Faelyssa describes her skill set.  \n\nIf you believe as she does then find your way to the Cenarion Enclave in the northern section of Darnassus where she conducts her class.','\"A skill for those who wish to overcome obstacles.\"  I believe that is how Faelyssa describes her skill set. \n\nIf you believe as she does then find your way to the Cenarion Enclave in the northern section of Darnassus where she conducts her class.',26124),
(5376,'enUS','Skinning','Skinning',26124),
(5377,'enUS','In death, the animals of the world bestow both life and protection unto us.  If you feel that you can offer the appropriate respect for their sacrifice, then the skinner\'s profession may suit you.  Speak with Eladriel in the Craftsmen\'s Terrace in northern Darnassus to learn more.','In death, the animals of the world bestow both life and protection unto us.  If you feel that you can offer the appropriate respect for their sacrifice, then the skinner\'s profession may suit you.  Speak with Eladriel in the Craftsman\'s Terrace in northern Darnassus to learn more.',26124),
(5378,'enUS','Survival','Survival',26124),
(5379,'enUS','If you need help surviving in the woods, you had best not stray far from the city walls.  However if you do plan to stray, then you had better have a talk with Malygen in the Cenarion Enclave so that you might learn to set a proper campfire.','If you need help surviving in the woods, you had best not stray far from the city walls.  However if you do plan to stray, then you had better have a talk with Malygen in the Cenarion Enclave so that you might learn to set a proper campfire.',26124),
(5380,'enUS','Tailoring','Tailoring',26124),
(5381,'enUS','You would certainly be looking for Me\'Lynn if you have any hope of learning to be a tailor.  She resides at the Craftsmen\'s Terrace in northeastern Darnassus.','You would certainly be looking for Me\'Lynn if you have any hope of learning to be a tailor.  She resides at the Craftsmen\'s Terrace in northeastern Darnassus.',26124),
(5382,'enUS','Tracking','Tracking',26124),
(5383,'enUS','Not a creature in the forest can elude Corand, such is his skill at tracking.  You would do well to listen to his teachings if you wish to be even half as successful.  \n\nI will relieve you of the burden of tracking him and mark his location on your map, there in the Cenarion Enclave.','Not a creature in the forest can elude Corand, such is his skill at tracking.  You would do well to listen to his teachings if you wish to be even half as successful.  \n\nI will relieve you of the burden of tracking him and mark his location on your map, there in the Cenarion Enclave.',26124),
(5384,'enUS','What plants are in Felwood that might be corrupted?','What plants are in Felwood that might be corrupted?',26124),
(5385,'enUS','','I have observed four different kinds of plants that have been affected by the corruption: the songflower, the windblossom, the whipper root, and the night dragon plant.  The songflower and windblossom are common plants in Felwood, while the whipper root and night dragon are seen less frequently.  All are a vital part of Felwood\'s ecosystem.',26124),
(5386,'enUS','','I have observed four different kinds of plants that have been affected by the corruption: the songflower, the windblossom, the whipper root, and the night dragon plant.  The songflower and windblossom are common plants in Felwood, while the whipper root and night dragon are seen less frequently.  All are a vital part of Felwood\'s ecosystem.',26124),
(5387,'enUS','This was the site of a great battle.  Many great battles.','',26124),
(5388,'enUS','Speak with Regthar.  He is wise and can help you find what you seek.','',26124),
(5389,'enUS','HALT!  There were...reports...of a...disturbance.','',26124),
(5390,'enUS','We...are...investigating.','',26124),
(5391,'enUS','Well, I\'m not sure how far I\'ll make it in this state... I\'m feeling kind of faint...','',26124),
(5392,'enUS','If I look woozy, slap me.  If I pass out, use the canteen.  Now let\'s go!','',26124),
(5393,'enUS','%s faints and falls onto the ground.','',26124),
(5394,'enUS','Uuuuuuggggghhhhh....','',26124),
(5395,'enUS','I\'m not feeling so well...','',26124),
(5396,'enUS','The heat... I can\'t take it...','',26124),
(5397,'enUS','Maybe... you could carry me?','',26124),
(5398,'enUS','Yes, I must go on.','',26124),
(5399,'enUS','I am feeling a little better now, thank you.','',26124),
(5400,'enUS','Where... Where am I?','',26124),
(5401,'enUS','How am I feeling? Quite soaked, thank you.','',26124),
(5402,'enUS','Spraggle! I didn\'t think I\'d make it back!','',26124),
(5403,'enUS','Oh... I\'m feeling faint...','',26124),
(5404,'enUS','Ugh.','',26124),
(5405,'enUS','','Ringo! You\'re okay!',26124),
(5406,'enUS','','Ringo? Wake up! Don\'t worry, I\'ll take care of you.',26124),
(5407,'enUS','Ach! Thank you so much, $n! I\'m free! Finally!','',26124),
(5408,'enUS','You take care of yourself! I\'m gettin\' out o\' here.','',26124),
(5409,'enUS','Hello? ','',26124),
(5410,'enUS','Um... sorry to bother you, but could I see Goodsteel\'s ledger again... if you\'re not using it.','Um... sorry to bother you, but could I see Goodsteel\'s ledger again... if you\'re not using it.',26124),
(5411,'enUS','Yeah, no problem, $n! Sorry... thought you were done with it already.','',26124),
(5412,'enUS','','You\'ll have to give me a moment, $c, the naga are attacking us right now. I\'ll speak to you as soon as the attack is done!',26124),
(5413,'enUS','Tell me a story, John.','Tell me a story, John.',26124),
(5414,'enUS','Aright *hic*... Say, you look familiar *hic*. Have I ever told you about the time me and Windsor fought off thir, er... a thous... a million orcs?$B$BOh settle down friend, this is a good one!','',26124),
(5415,'enUS','Let me grab the popped corn kernels, sire.','Let me grab the popped corn kernels, sire.',26124),
(5416,'enUS','I present to you the Libram of Constitution.','I present to you the Libram of Constitution.',26124),
(5417,'enUS','I present to you the Libram of Tenacity.','I present to you the Libram of Tenacity.',26124),
(5418,'enUS','I present to you the Libram of Resilience.','I present to you the Libram of Resilience.',26124),
(5419,'enUS','I present to you the Libram of Voracity.','I present to you the Libram of Voracity.',26124),
(5420,'enUS','%s bursts into the hatchery once you apply the lure to the crystal!','',26124),
(5421,'enUS','The Orgrimmar Auction House is in the Valley of Strength.  Look for it on the east side next to Boomstick Imports.','The Orgrimmar Auction House is in the Valley of Strength.  Look for it on the east side next to Boomstick Imports.',26124),
(5422,'enUS','Your voice is hoarse from yelling huh?  Find the Orgrimmar Auction House in the Valley of Strength.','Your voice is hoarse from yelling huh?  Find the Orgrimmar Auction House in the Valley of Strength.',26124),
(5423,'enUS','Auction House','Auction House',26124),
(5424,'enUS','Welcome to the Bank of Darnassus. We offer financial accounts and safety deposit boxes for valuable items. Do you already have an account with us $g sir : ma\'am;?','Welcome to the Bank of Darnassus. We offer financial accounts and safety deposit boxes for valuable items. Do you already have an account with us $g sir : ma\'am;?',26124),
(5425,'enUS','Amazing, aren\'t they? All these artifacts and remains.$B$BI\'m not sure what I\'m more impressed by, their size, or the stories that go along with them. There\'s so much to study and learn. And the connections we can make...$B$BDid you know rumor has it that many races have the same heritage as Night elves?','',26124),
(5426,'enUS','Image dissipation in sixty seconds.','',26124),
(5427,'enUS','%s begins to cast a powerful spell.','',26124),
(5428,'enUS','%s transforms the items into a totem.','',26124),
(5429,'enUS','','%s is visibly shaken by the death of Emperor Thaurissan.',26124),
(5430,'enUS','Emperor Thaurissan does not wish to be disturbed! Turn back now or face your doom, weak mortals!','',26124),
(5431,'enUS','Hail to the king, baby!','',26124),
(5432,'enUS','','Hello there, my name is Petra.  To my right is my kodo, Dadanga.  We\'re with Marshal Expeditions - been so for a few years now, ever since Dadanga was a babe.$B$BIf you have any lit torches or any open sources of flame, I\'d like to ask you to keep them stashed if you could.  Dadanga dislikes smoke.',26124),
(5433,'enUS','For the love of all that is holy and dear, please tell me that you\'ve come to deliver us from this forsaken land.  Though I\'m with Marshal Expeditions, I would give you the gold teeth from my mouth to climb inside your backpack and leave this place.','',26124),
(5434,'enUS','','Oh, hello there!  I\'m Hol\'anyee, the chief scientist and biologist of Marshal Expeditions.  My brother and I, along with our companions, travel Azeroth exploring the wild and untamed majesty.  It is exciting... but, um... I think we got ourselves into a little too much excitement this time!',26124),
(5435,'enUS','Hello stranger, and welcome to the untamed majesty of Un\'Goro Crater!$B$BMy name is Williden Marshal.  My sister, our companions, and I make up Marshal Expeditions - scientists and explorers of Azeroth\'s wild and great unknown.','',26124),
(5436,'enUS','','This is where things get interesting.  My plan is to follow the mountail wall, keeping it to our left.  That way, we won\'t get lost in the jungle and we\'ll cut down on the hostiles.  You ready?',26124),
(5437,'enUS','','Here\'s the eastern mountain wall!  I\'m cutting towards the south now; try and keep up.  We\'re not out of the thick of it yet!',26124),
(5439,'enUS','','Here\'s the path out of Un\'Goro!  We made it!  All we have to worry about is the Tanaris desert now.',26124),
(5440,'enUS','','Here it is -- the Tanaris desert.  Funny how an inhospitable place like this looks better than a lush jungle once you\'ve been trapped in it forever.',26124),
(5441,'enUS','You have been sentenced to death for crimes against the Dark Iron nation!','',26124),
(5442,'enUS','The Sons of Thaurissan shall watch you perish in the Ring of the Law!','',26124),
(5443,'enUS','Unleash the fury and let it be done!','',26124),
(5444,'enUS','Haha! I bet you thought you were done!','',26124),
(5445,'enUS','But your real punishment lies ahead.','',26124),
(5446,'enUS','Good riddance!','',26124),
(5447,'enUS','Incredible! Amazing! I don\'t even know what this means!','',26124),
(5448,'enUS','Look at these samples! What does it mean? What does it mean? I\'m going to need time, time to look at all this information. And I\'ll need more information. Information I can\'t get... damn! Think, Laris, think!$B$BWhat are you going to do? What?!$B$BThere has to be a solution!','',26124),
(5449,'enUS','There must be someplace on Azeroth that we can find oozes uncorrupted by the Scourge or anything else. But where?!','',26124),
(5450,'enUS','Is there a difference between ooze and slime?','Is there a difference between ooze and slime?',26124),
(5451,'enUS','No, not that I can tell. It seems to be mostly based on region. Some races have labled them slimes, some oozes. It seems to be preference mostly.$B$BEvery time I\'ve encountered ooze, sludge, or slime they have basically been the same creatures. The differences seem to be based on their environment, which is why we need a pure sample.','',26124),
(5452,'enUS','What do you mean by \"pure?\"','What do you mean by \"pure?\"',26124),
(5453,'enUS','A pure sample would be one that\'s uncorrupted by unintentional influences. We need to find the creatures in the most basic, normal environment we can.$B$BThat means somewhere devoid of civilization or the effects of the dominant races of Azeroth. Someplace... untouched.','',26124),
(5454,'enUS','Are there any areas you can think of that would be so untouched?','Are there any areas you can think of that would be so untouched?',26124),
(5455,'enUS','It\'ll definitely not be anywhere in the Eastern Kingdoms, that\'s for sure.$B$BIt\'ll have to be somwhere on Kalimdor, but still far enough away from the Horde and other races. Someplace unaffected by the Sundering--that means no where near the Night elves\' civilization either.$B$BI would guess it\'d be someplace protected also... like a valley, or a crater. I don\'t know. I\'m just guessing now. I\'m sorry I couldn\'t help you more.','',26124),
(5456,'enUS','I bid you welcome, $c. Rare do we have visitors down to these levels of the Apothecarium... unless of course there\'s something someone wants... or needs.$B$B<Chemist Coely laughs.>$B$BHow can I help you today, hmm?','',26124),
(5457,'enUS','I will crush you into little tiny pieces!','',26124),
(5458,'enUS','%s groans.','%s groans.',26124),
(5459,'enUS','%s weeps pitifully.','%s weeps pitifully.',26124),
(5460,'enUS','%s begs to be put out of his misery.','%s begs to be put out of her misery.',26124),
(5461,'enUS','','Well, we\'re not getting any closer just standing here.  Come on Dadanga!  Yah!',26124),
(5462,'enUS','','Step lively Dadanga!  Come on, girl!  The quicker we get through here, the happier we\'ll both be.',26124),
(5463,'enUS','$n, you have disturbed me from my rest!','',26124),
(5464,'enUS','Leave me now in peace. I must rest.','',26124),
(5465,'enUS','Who dares awaken Aquementas?','',26124),
(5466,'enUS','','Get away from my kodo, you freak of nature!',26124),
(5467,'enUS','','Dadanga!  Attack!',26124),
(5468,'enUS','','That has to be the biggest $n I have ever seen... and it\'s coming right for us!',26124),
(5469,'enUS','','Watch out for the $n!',26124),
(5470,'enUS','The gathering and knowledge of herbs is a specialty of Firodren Mooncaller.  Seek him out in the Temple Gardens in the southwestern area of Darnassus.','The gathering and knowledge of herbs is a specialty of Firodren Mooncaller.  Seek him out in the Temple Gardens in the southwestern area of Darnassus.',26124),
(5471,'enUS','A budding herbalist are we?  Then you should visit with Firodren Mooncaller over in the Temple Gardens.  He may have some tricks of the trade to impart with you.','A budding herbalist are we?  Then you should visit with Firodren Mooncaller over in the Temple Gardens.  He may have some tricks of the trade to impart with you.',26124),
(5472,'enUS','Why you would want to leave these sunny shores and crystal blue waters I have no idea. It\'s like paradise down here. But don\'t tell my brother Zapetta that, he\'s bitter enough already about getting stuck up there in Tirisfal all day long. This Zeppelin here drops off at Orgrimmar so you shouldn\'t have to worry about having to listen to him whine. But if you are in Tirisfal anytime soon, heed my warning and don\'t get him started.','Why you would want to leave these sunny shores and crystal blue waters I have no idea. It\'s like paradise down here. But don\'t tell my brother Zapetta that, he\'s bitter enough already about getting stuck up there in Tirisfal all day long. This Zeppelin here drops off at Orgrimmar so you shouldn\'t have to worry about having to listen to him whine. But if you are in Tirisfal anytime soon, heed my warning and don\'t get him started.',26124),
(5473,'enUS','I sense the taint of corruption upon this $n. Help me destroy it!','',26124),
(5474,'enUS','This creature suffers from the effects of the fel... We must end its misery.','',26124),
(5475,'enUS','This $n has been driven mad from the corruption! ','',26124),
(5476,'enUS','The herbs found in nature can be a powerful ally when combined with respect.  You will want to seek out Bena at her alchemy shop on the middle rise to further your training.','The herbs found in nature can be a powerful ally when combined with respect.  You will want to seek out Bena at her alchemy shop on the middle rise to further your training.',26124),
(5477,'enUS','You may shed yourself of your worldly possessions at the Thunder Bluff Bank on the lower rise.','You may shed yourself of your worldly possessions at the Thunder Bluff Bank on the lower rise.',26124),
(5478,'enUS','Metal, as with all things, should be used in balance with nature.  Karn Stonehoof has a smithy setup near the pond on the lower rise.  Seek out his wisdom.','Metal, as with all things, should be used in balance with nature.  Karn Stonehoof has a smithy setup near the pond on the lower rise.  Seek out his wisdom.',26124),
(5479,'enUS','You honor the spirits of the animals you must slay by not letting them go to waste.  Aska Mistrunner will show you how.  She has a kitchen on the high rise.','You honor the spirits of the animals you must slay by not letting them go to waste.  Aska Mistrunner will show you how.  She has a kitchen on the high rise.',26124),
(5480,'enUS','Greetings honored one.  Turak Runetotem and the other druids have been expecting you at the Hall of Elders on Elder Rise.','Greetings honored one.  Turak Runetotem and the other druids have been expecting you at the Hall of Elders on Elder Rise.',26124),
(5481,'enUS','The profession of Enchanting displays the cycle of destruction and creation that is at the heart of nature.  Teg at the Dawnstrider Enchanters on the middle rise will show you how.','The profession of Enchanting displays the cycle of destruction and creation that is at the heart of nature.  Teg at the Dawnstrider Enchanters on the middle rise will show you how.',26124),
(5482,'enUS','Life is a struggle, and the saying that which does not kill you makes you stronger is not always true.  Sometimes wounds act slowly, which is why we have bandages.  Pand Stonebinder of the Spirit Rise can teach you the art of First Aid.','Life is a struggle, and the saying that which does not kill you makes you stronger is not always true.  Sometimes wounds act slowly, which is why we have bandages.  Pand Stonebinder of the Spirit Rise can teach you the art of First Aid.',26124),
(5483,'enUS','Kah Mistrunner at Mountaintop Bait & Tackle on the high rise will show you the way to find inner peace and serenity while fishing for your next meal.','Kah Mistrunner at Mountaintop Bait & Tackle on the high rise will show you the way to find inner peace and serenity while fishing for your next meal.',26124),
(5484,'enUS','A fellowship of kindred spirits can be a powerful force.  Krumn will help you to achieve this.  You will find him at the Thunder Bluff Civic Information center on the lower rise next to the lifts.','A fellowship of kindred spirits can be a powerful force.  Krumn will help you to achieve this.  You will find him at the Thunder Bluff Civic Information center on the lower rise next to the lifts.',26124),
(5485,'enUS','Nature provides all that we need.  Speak to Komin Winterhoof at Holistic Herbalism on the middle rise.','Nature provides all that we need.  Speak to Komin Winterhoof at Holistic Herbalism on the middle rise.',26124),
(5486,'enUS','Any friend of the animals is a friend of mine.  The Hunter\'s Hall is what you seek.  It sits atop the Hunter Rise.','Any friend of the animals is a friend of mine.  The Hunter\'s Hall is what you seek.  It sits atop the Hunter Rise.',26124),
(5487,'enUS','There is a symmetry in the idea of the hide of your enemy providing you with protection.  To further your leatherworking skills look for Una inside the Thunder Bluff Armorers on the middle rise.','There is a symmetry in the idea of the hide of your enemy providing you with protection.  To further your leatherworking skills look for Una inside the Thunder Bluff Armorers on the middle rise.',26124),
(5488,'enUS','Very sad to think what has befallen those poor undead souls.  You can find Archmage Shymm reflecting near the Pools of Vision under the Spirit Rise.','Very sad to think what has befallen those poor undead souls.  You can find Archmage Shymm reflecting near the Pools of Vision under the Spirit Rise.',26124),
(5489,'enUS','The Earth Mother holds many secrets and Brek Stonehoof can help you to discover some of them.  You will find him on the lower rise at Stonehoof Geology.','The Earth Mother holds many secrets and Brek Stonehoof can help you to discover some of them.  You will find him on the lower rise at Stonehoof Geology.',26124),
(5490,'enUS','Despite their tragedy the Undead have come all this way to aid us.  I only hope that we can be as helpful to them.  Seek out Father Cobb near the Pools of Vision under the Spirit Rise.','Despite their tragedy the Undead have come all this way to aid us.  I only hope that we can be as helpful to them.  Seek out Father Cobb near the Pools of Vision under the Spirit Rise.',26124),
(5491,'enUS','The Earth Mother calls and you answer.  You will find the Hall of Spirits on the Spirit Rise.','The Earth Mother calls and you answer.  You will find the Hall of Spirits on the Spirit Rise.',26124),
(5492,'enUS','Every scrap used makes us less wasteful and brings us closer to the Earth Mother.  Mooranta can show you the way.  Seek her just outside the Thunder Bluff Armorers on the middle rise.','Every scrap used makes us less wasteful and brings us closer to the Earth Mother.  Mooranta can show you the way.  Seek her just outside the Thunder Bluff Armorers on the middle rise.',26124),
(5493,'enUS','You, in harmony with nature, and only your skills to survive.  This is the way that the Earth Mother intended it to be.  You will want to find Bale on the Hunter Rise.','You, in harmony with nature, and only your skills to survive.  This is the way that the Earth Mother intended it to be.  You will want to find Bale on the Hunter Rise.',26124),
(5494,'enUS','Clothing the tribe is as important a job as any other.  You should look for Tepa inside Thunder Bluff Armorers.  She has a natural way with the needle.','Clothing the tribe is as important a job as any other.  You should look for Tepa inside Thunder Bluff Armorers.  She has a natural way with the needle.',26124),
(5495,'enUS','Ah, the true sign of the hunter!  To stalk one\'s prey in the never-ending game of life.  Look to Drayl on the Hunter Rise for your answers.','Ah, the true sign of the hunter!  To stalk one\'s prey in the never-ending game of life.  Look to Drayl on the Hunter Rise for your answers.',26124),
(5496,'enUS','Strong of body and spirit.  There can be no stronger combination!  Find your destiny with Sark Ragetotem in the Hunter\'s Hall.','Strong of body and spirit.  There can be no stronger combination!  Find your destiny with Sark Ragetotem in the Hunter\'s Hall.',26124),
(5497,'enUS','Ah, to soar with the great birds of the sky.  Seek out Tal at the top of the Winder Rider Roost.  He will steer you toward where you\'re going.','Ah, to soar with the great birds of the sky.  Seek out Tal at the top of the Winder Rider Roost.  He will steer you toward where you\'re going.',26124),
(5498,'enUS','Look for Innkeeper Pala in the building just south of the Thunder Bluff Bank on the lower rise.','Look for Innkeeper Pala in the building just south of the Thunder Bluff Bank on the lower rise.',26124),
(5499,'enUS','Innkeeper Pala will help you rest your body and spirit.  You can find her in the building just south of the bank on the lower rise.','Innkeeper Pala will help you rest your body and spirit.  You can find her in the building just south of the bank on the lower rise.',26124),
(5500,'enUS','You can find a mailbox just outside the Thunder Bluff Bank on the lower rise.','You can find a mailbox just outside the Thunder Bluff Bank on the lower rise.',26124),
(5501,'enUS','I believe I noticed a new shipment of mail being delivered not too long ago.  You\'ll find the mailbox just outside the Thunder Bluff Bank on the lower rise.','I believe I noticed a new shipment of mail being delivered not too long ago.  You\'ll find the mailbox just outside the Thunder Bluff Bank on the lower rise.',26124),
(5502,'enUS','It is found on the lowest section of Thunder Bluff.  Search near the bank.  It is not far from there.','It is found on the lowest section of Thunder Bluff.  Search near the bank.  It is not far from there.',26124),
(5503,'enUS','The auction house can be found on the central spire of Thunder Bluff.  Search near the bottom of the Windrider\'s Tower. May your ancestors watch over you.','The auction house can be found on the central spire of Thunder Bluff.  Search near the bottom of the Windrider\'s Tower. May your ancestors watch over you.',26124),
(5504,'enUS','This may come as a shock to you, but business hasn\'t been all that good as of late...','',26124),
(5505,'enUS','','I welcome you to Theramore, $n.$B$BI apologize for being abrupt and not having a lot of time to exchange pleasantries, but my city must come first. Too many things threaten our way of life and the sanctity of the Alliance. I must stay ever vigilant against forces outside of our control if I\'m to ensure my people remain safe and happy.$B$BPerhaps we\'ll have more time to speak later.',26124),
(5506,'enUS','','Hendel is in our custody now, $n, thanks to you.$B$BAlthough the questioning goes slowly, I assure you, he will tell us everything he knows.$B$BFor now, please be patient. I will contact you immediately if we have need of your assistance.$B$BUntil then, please, enjoy Theramore and I invite you to stay for as long as you like within our city\'s walls as a friend of the Alliance.',26124),
(5508,'enUS','','If you\'re ready, then Dadanga and I are ready.  Let\'s go!',26124),
(5509,'enUS','Yes $gbrother : sister;, how may I assist you?','Yes $gbrother : sister;, how may I assist you?',26124),
(5511,'enUS','','All right then... I know the way to and from Gadgetzan.  What I need for you to do is to keep the beasts off of us.  I\'ve trained Dadanga how to defend herself pretty well, but we can\'t handle the overgrown madness out there for long.  Let me know when you\'re ready to go, $n.',26124),
(5512,'enUS','What do you think of Dadanga?\n','What do you think of Dadanga?',26124),
(5513,'enUS','Inn','Inn',26124),
(5514,'enUS','Mailbox','Mailbox',26124),
(5515,'enUS','Auction House','Auction House',26124),
(5516,'enUS','Just outside the city\'s main gate is a signpost.  It will point you toward the western zeppelin tower.','Just outside the city\'s main gate is a signpost.  It will point you toward the western zeppelin tower.',26124),
(5517,'enUS','Look for the eastern Zeppelin Landing Tower outside of the city to the southeast.','Look for the eastern Zeppelin Landing Tower outside of the city to the southeast.',26124),
(5518,'enUS','Zeppelin Master','Zeppelin Master',26124),
(5519,'enUS','My brother and I have dedicated ourselves to Sylvanas. She is our beacon of light when times were darkest. We sacrifice ourselves day in and day out to ensure our kind overcome the destiny that\'s chosen us.$B$BWe will not remain weak. We will take that which is owed to us. We will return tenfold, the pain that was done to us. And we shall do so with smiles on our faces.','',26124),
(5520,'enUS','Lady Sylvanas has ordered the investigation of some of the natural phenomena of Azeroth. She feels there is something great to be learned from its secretive past.$B$BI know not how she learned such things, but I trust her completely, so I will do my best.$B$BI am currently investigating slimes, oozes and such. The creatures all seem to be similar in make up, but greatly affected by their environment.$B$BI could use your help in gathering samples of the creatures..','',26124),
(5521,'enUS','','%s becomes enraged from seeing a cub die!',26124),
(5522,'enUS','Three cheers for $n -- Admiral o\' the Bloodsail Bucaneer Navy!','',26124),
(5523,'enUS','Hip hip... arrrrr...','',26124),
(5524,'enUS','<Volcor doesn\'t look at you at all as you get close to him. He seems to be concentrating on keeping his bandages from falling off. After a moment, he looks up at you, a little startled.>$B$BOh, sorry, $c. Now\'s not a good time. I hope you understand.','',26124),
(5525,'enUS','Well, the way I see it, $n, we have two options to consider for leaving this cave.$B$BWe can make our way stealthfully--I use the cloak you\'ve given me, and you\'d be left to your own devices, or, and this may be a harder option considering my wounds, we fight our way out back to back.$B$BI\'ll let you decide since you know your strengths better than I.','',26124),
(5526,'enUS','Greetings $g lad : lass;, if you\'re looking for the best deals you\'ll find outside of Ironforge itself, then you\'ve come to the right place.','',26124),
(5527,'enUS','','Have you seen the befouled water elementals in our lake, $n? It is a sorry sight, but I do not know where they are coming from.$B$BYour name has been mentioned in conversations past, perhaps you could help me with this problem.$B$BThe first thing we must learn is who is in control of these elementals.',26124),
(5528,'enUS','Hi there.  I\'m Gubber Blump.','',26124),
(5529,'enUS','Gubber, I don\'t know how to fish.\n','Gubber, I don\'t know how to fish.',26124),
(5530,'enUS','Gubber, I don\'t have a fishing pole.','Gubber, I don\'t have a fishing pole.',26124),
(5531,'enUS','Fishing is real easy.  Just take a pole with a line on it, maybe put some bait on it, and cast it out in the water.  Sure enough, them fish will start biting.','',26124),
(5532,'enUS','I got some extras with me; if you pay me back what I paid for them, you can have one.  I got some bait too.','',26124),
(5533,'enUS','...pan fried, deep fried, and stir fried...','',26124),
(5534,'enUS','Do you need assistance?','Do you need assistance?',26124),
(5535,'enUS','','Watch my back, this could get real messy.',26124),
(5536,'enUS','The liquids and mixtures all bubble and spasm as you approach. Next to the equipment lies a large pair of tongs that look as though they would be adequate for dropping in samples of ooze.$B$BThere is safety gear present, but it appears to be dusty and well-ignored.$B$BYou don\'t think touching anything would be wise.','',26124),
(5537,'enUS','','The plans are in there!',26124),
(5538,'enUS','Intruders are destroying our eggs!  Stop!!','Intruders are destroying our eggs!  Stop!!',26124),
(5539,'enUS','SQUAWK!! *cough* *cough* I need to quit smoking!','',26124),
(5540,'enUS','Ask Kibler about the treasure! SQUAWK!','',26124),
(5541,'enUS','Bijou lost! SQUAWK! *cough*','',26124),
(5542,'enUS','Bijou knows where treasures are hidden.','',26124),
(5543,'enUS','Opus wants some Cuergo\'s Gold... with worm.','',26124),
(5544,'enUS','They all go to the Spire but none ever come back... just like Bijou.','',26124),
(5545,'enUS','Kibler is being investigated by G.E.T.A.','',26124),
(5546,'enUS','Dragons controlling orcs!? SQUAWK!','',26124),
(5547,'enUS','I am here!  Now, puny little worms, you will pay for your intrusion!','',26124),
(5548,'enUS','%s lets loose a guttural growl as her body collapses. A horrifying howl can be heard echoing through the halls of Blackrock Spire. Something is very, very angry.','',26124),
(5549,'enUS','Hello, $n.','',26124),
(5550,'enUS','Don\'t mind Skuerto, $n. He doesn\'t mean to be rude, he\'s just terribly busy. While we wait for him to finish scouting, why don\'t we work on something more productive?','',26124),
(5551,'enUS','','Hi $n!$B$BI have to work on my devices, but eventually... I\'m going to need someone to get me dragon eggs!',26124),
(5552,'enUS','','The Burning Steppes is a dangerous place, but scholars like me will do almost anything to advance our knowledge.',26124),
(5553,'enUS','I\'m going back to the Rookery, Tinkee.  I need an Eggscilliscope!','I\'m going back to the Rookery, Tinkee.  I need an Eggscilliscope!',26124),
(5554,'enUS','May your skills in smelting dark iron serve you well, $n.  But do not let your knowledge corrupt you... as it corrupted us.','',26124),
(5555,'enUS','At last - one among you is worthy of my knowledge. Worry not - I have probed your thoughts, no harm will come to you.','',26124),
(5556,'enUS','Listen carefully, for the lord of Blackrock will surely destroy you, should you not be prepared.','',26124),
(5557,'enUS','','Kar Aman, $n. You look to be a strong $c--you would do well to mind yourself in this area. Touching things you know nothing about, or showing disrespect to your elders is just cause for punishment.$B$BYou may not respect me or my companions, but you will learn to respect our power if you prove foolish enough.$B$BNow, enough with the pleasantries, was there something I can do for you?',26124),
(5558,'enUS','','Ah, a fellow warlock who has proven $ghis:her; worth to some degree.$B$BI am pleased to meet your acquaintance. My name is Menara Voidrender... and not without just cause.$B$BYou seem powerful and well-learned enough that other tools... more powerful tools... would be welcome and not foolishly imparted. If this is true, then speak to me further. If not, well then, you know your way  back to the docks and off into the ocean.',26124),
(5559,'enUS','Humans are usually vunerable on their left side between the 4th and 5th rib. Let\'s practice striking at this area like so...','Humans are usually vunerable on their left side between the 4th and 5th rib. Let\'s practice striking at this area like so...',26124),
(5560,'enUS','Now, you try.','Now, you try.',26124),
(5561,'enUS','Night Elves like to stand off on one leg while casting. Strike at that leg like so...','Night Elves like to stand off on one leg while casting. Strike at that leg like so...',26124),
(5562,'enUS','Dwarves will spin around leaving their backs open for attack at times. Take this opportunity to strike like this...','Dwarves will spin around leaving their backs open for attack at times. Take this opportunity to strike like this...',26124),
(5563,'enUS','Gnomes can be hard to hit due to their size. However, they have a pinchant for dancing around and thrusting their hips. When they do this, strike at them like so...','Gnomes can be hard to hit due to their size. However, they have a pinchant for dancing around and thrusting their hips. When they do this, strike at them like so...',26124),
(5564,'enUS','Good. You are showing promise to join the elite ranks. Now, more practice.','Good. You are showing promise to join the elite ranks. Now, more practice.',26124),
(5565,'enUS','%s begins to regain its strength!','',26124),
(5566,'enUS','%s is nearly at full strength!','',26124),
(5567,'enUS','%s regains its power and breaks free of its bonds!','',26124),
(5568,'enUS','In decades past - of now ancient wars and conflicts - our kind was driven to the brink of extinction. Much we have endured, $r.$B$BThe onslaught of the Burning Legion. The Demon Soul. The Aspects divided. The ascension of Deathwing. The enslavement of our Queen, Alexstrasza, by the Dragonmaw.$B$BThrough it all, we have been the unshakable will of the dragons - the undaunted force that has fought to represent our waning existence in this world.','',26124),
(5569,'enUS','Your kind?','Your kind?',26124),
(5570,'enUS','Indeed. I stand before you in a form that you can comprehend, mortal. Surely, you could not bear to stand in the presence of the dragon known as Vaelastrasz.$B$B<Vaelan laughs.>$B$BShall I continue?','',26124),
(5571,'enUS','Please.','Please.',26124),
(5572,'enUS','Perhaps I should tell you why I am here.$B$BDo you know of the Aspect, Deathwing? Or of his progeny, Nefarian and Onyxia?','',26124),
(5573,'enUS','No, Vaelan, I do not.\n','No, Vaelan, I do not.\n',26124),
(5574,'enUS','Deathwing, or Neltharion as he was once known, was the Aspect that embodied the strength of the world - granted almost limitless power over this mortal realm by the Titan shaper known as Khaz\'goroth: Forger of the world.$B$BThrough treachery and deceit, the foul one convinced the four other Aspects to imbue an item, known as the Demon Soul, with their powers - greatly weakening them, forcing a division among the once great Aspects. \n','',26124),
(5575,'enUS','Demon Soul?','Demon Soul?',26124),
(5576,'enUS','Indeed. The item was ultimately destroyed and Deathwing nearly slain by the combined and renewed power of the four remaining Aspects. Where Deathwing is now is unknown. What we do know, however, is that one of his progeny, Nefarian, rules this citadel and wishes to continue where his father left off.','',26124),
(5577,'enUS','Where he left off?','Where he left off?',26124),
(5578,'enUS','Before his banishment, Deathwing was attempting to create impure offspring. Half breeds that would not only be immune to the innate natural powers and abilities of their Aspects but also under the complete control of Deathwing.$B$BIt seems that where his father failed, Nefarian may have succeeded - at least partially.$B$BIt was Ysera, Aspect of Dreams, who saw the abominations and forced us to act. If these \'Chromatic\' dragonkin exist, they must be destroyed.','',26124),
(5579,'enUS','Why not destroy them with the combined might of the Aspects?','Why not destroy them with the combined might of the Aspects?',26124),
(5580,'enUS','It is not our way, nor would it be possible. Nefarian is guarded by ancient wards, as old as the Aspects themselves. It is what prevents me from entering the inner sanctum of this citadel. The dark magic prevents any of the other flight to enter without being ordained... unless.','',26124),
(5581,'enUS','Unless?','Unless?',26124),
(5582,'enUS','It is possible for one, not of dragon kind, to obtain the Adorned Seal of Ascension and pass through the protected barrier. While possession of such an item would surely destroy me, perhaps you could utilize it and lower the barrier.\n','',26124),
(5583,'enUS','I am willing to try but I will require instruction.','I am willing to try but I will require instruction.',26124),
(5584,'enUS','You must find one amongst the wretch in the lower portion of this citadel that has attained an Unadorned Seal of Ascension. It is a great honor for one of the lesser beings to obtain this item, as it is the first step in gaining access to the upper citadel and becoming one of Nefarian\'s elite guardsmen - the Blackhand legion. Find such an item and return it to me so that I may examine its properties. I will know how to proceed once my inspection of the seal is complete.','',26124),
(5585,'enUS','I will do my best, Vaelan.','I will do my best, Vaelan.',26124),
(5586,'enUS','Be warned, mortal, it is exceptionally rare that one of the lesser clans in this citadel would hold such an item. Your search could take decades. I recommend you destroy these beasts without impunity.','',26124),
(5587,'enUS','It will be done.','It will be done.',26124),
(5588,'enUS','Do not bring it any closer, mortal. I can sense the evil coursing through the seal from where I stand.$B$BGive me a moment to inspect the item - hold it firmly.','',26124),
(5589,'enUS','As you wish, Vaelan.','As you wish, Vaelan.',26124),
(5590,'enUS','%s is surrounded by a barrier of anti-magic.','',26124),
(5591,'enUS','I have discerned the path that you must take. Are you prepared?','',26124),
(5592,'enUS','Begone, mortal. You are not worthy of my knowledge.','',26124),
(5593,'enUS','Ah, $r, you have returned!','',26124),
(5594,'enUS','%s\'s will falters.','',26124),
(5595,'enUS','At last, I have caught up with you, Nefarian. Surely you did not think you would escape the might of the other Aspects?','',26124),
(5596,'enUS','Enough! Playtime is over!','',26124),
(5597,'enUS','I would like to train.','I would like to train.',26124),
(5598,'enUS','What do you mean you don\'t know how to use an axe? ','',26124),
(5599,'enUS','It\'s small but it does it\'s job if you know what you are doing. Let me show you just the right places to hit.','',26124),
(5600,'enUS','Take tha blade like dis, den throw. Just flip joo wrist mon, one twirl and joo got jooself lunch.','',26124),
(5601,'enUS','','We have used bows since before even my father\'s time. They are solid and sure and take down our foes swiftly. I see no reason to use the guns that the goblins and tauren seem so fond of.',26124),
(5602,'enUS','','Come to learn have ya, mon?',26124),
(5603,'enUS','','The fists of an Orc are already a powerful weapon, so why not add blades or studs of solid steel. Now the fists I use to tame the wolves of the plains I can also use to shatter the armor of my foes.',26124),
(5604,'enUS','Joo may tink this ma walkin stick mon. Dat\'s jus wat I want joo to tink.','',26124),
(5605,'enUS','A bow is a great ting ma friend. Joo jus have to take care of it, and it will take care of joo.','',26124),
(5606,'enUS','Dis ain\'t no game mon. Joo want to use da axe, joo got to say da line. Say it wif me... \"Say hello, to ma little friend.\"','',26124),
(5607,'enUS','Never had much use for a bow, but these rifles the goblins make are very handy when hunting. Still can\'t get used to the smell though.','',26124),
(5608,'enUS','$n, I\'ve come to find out how rampant the effects of Fel Moss are throughout Darkshore. The remainaing corruption in Teldrassil and our surrounding lands really concerns the druids of the Cenarian Circle, and all Night elves.$B$BIt is my goal to find out why this is still happening and put it to an end.','',26124),
(5609,'enUS','It may look simple, a large stick with a huge weight on the end. But when swung with the might of a tauren behind it, this stick can break stone walls.','',26124),
(5610,'enUS','Just a stick? Want me to show you what \'just a stick\' can do?','',26124),
(5611,'enUS','','%s begins to summon in a Black Iron Dreadweaver!',26124),
(5612,'enUS','','%s summons a Black Iron Dreadweaver to his aid!',26124),
(5613,'enUS','','%s begins to summon in a Black Iron Veteran!',26124),
(5614,'enUS','','%s summons a Black Iron Veteran to his aid!',26124),
(5615,'enUS','I\'m flattered, but really I\'m not interested... What?  You want to know where to learn enchanting?  Oh, how embarrassing!  Well, you should...  I\'m sure you could... go see, um...  Taladan!  Yes, see Taladan over in the Craftsmen\'s Terrace!','I\'m flattered, but really I\'m not interested... What?  You want to know where to learn enchanting?  Oh, how embarrassing!  Well, you should...  I\'m sure you could... go see, um...  Taladan!  Yes, see Taladan over in the Craftsmen\'s Terrace!',26124),
(5616,'enUS','What the... nobody cleanses a furbolg in MY camp!  Face the wrath of Xabraxxis!','',26124),
(5617,'enUS','%s is lured out by the sweet scent of the purified food.','',26124),
(5618,'enUS','%s begins to greedily devour the food.','',26124),
(5619,'enUS','VanCleef pay big for you heads!','',26124),
(5621,'enUS','Nuttin\' be \'fraid of. Come.','Nuttin\' be \'fraid of. Come.',26124),
(5622,'enUS','We\'re doomed!','We\'re doomed!',26124),
(5623,'enUS','The only weapon I know of that has no use other than killing someone. Not something, but someone. These blades were invented to end the lives of men. Beautiful aren\'t they?','',26124),
(5624,'enUS','','Keep your foes at bay and carve them into cutlets at the same time. The only problem is that the long shaft keeps me from getting blood on my hands.',26124),
(5625,'enUS','','Swift and sure. Cut a tendon here, slit an artery there. I can show you how to turn any knife into a perfect killing machine.',26124),
(5626,'enUS','The long reload takes some getting used to, but nothing else is better for starting off a fight. ','',26124),
(5627,'enUS','Welcome to my shop, $c. What is it the Goodstitch brothers can do for you?','',26124),
(5628,'enUS','Ah, one of my favorite customers. You look to be of a warlock of some power, $n. I am pleased to meet you. If there is anything I can do for you, please, just ask.$B$BMy brother and I feel that it will be your kind who lead us into the next great era. One with such power... such control... it\'s only a matter of time before the Legion itself bends to your will.$B$BI am but a little envious.','',26124),
(5629,'enUS','What of the Alliance, Rend?','',26124),
(5630,'enUS','They have freed the human, Windsor, sire. It will not be long until Onyxia is uncovered.','',26124),
(5631,'enUS','Then we must not waste anymore time. Are the chromatic dragonflight ready?','',26124),
(5632,'enUS','The next clutch is due to hatch soon, sire. We will be ready to launch the attacks by week\'s end.','',26124),
(5633,'enUS','','I can teach you both the finesse of a short blade and the bone shattering cleaving power of a two handed behemoth. Or we can get crazy and I can teach you both, could come in handy for when the situation changes on ya.',26124),
(5634,'enUS','','Sure I can teach you the fine art of wielding a polearm, but it\'s gonna cost you.',26124),
(5635,'enUS','Excellent... it would appear as if the meddlesome insects have arrived just in time to feed my legion. Welcome, mortals!','',26124),
(5636,'enUS','Sure it takes longer to reload but this baby will punch a hole the size of my fist through any set of armor.','',26124),
(5637,'enUS','','I\'ve seen farmers with staves hold off trained soldiers. Do not ever underestimate the power and skill it takes to wield one of these properly.',26124),
(5638,'enUS','','If you think I\'m good, you should see my husband fight.',26124),
(5639,'enUS','%s turns to face you.','',26124),
(5640,'enUS','Let not even a drop of their blood remain upon the arena floor, my children. Feast on their souls!','',26124),
(5641,'enUS','A good hammer in yer hands makes the world feel safer. Like ye can face even the mightiest of foes with a large hunk of solid metal gripped in yer fists.','',26124),
(5642,'enUS','I\'ll teach ye to chop down yer foes like saplings in the forest.','',26124),
(5643,'enUS','','Hound on the horizon moving at thirty feet per second. The only question is, right or left eye. That\'s right $g lad : lass;, I\'m that good.',26124),
(5644,'enUS','','See this? This is my boom stick! Dwarven top of the line. That\'s right, this sweet baby was made in Ironforge, Khaz Modan. Retails for about one hundred and nine gold, ninety five copper. It\'s got a walnut stock, thorium steel, and a hair trigger.',26124),
(5645,'enUS','Och I love a good brawl, but sometimes yer foe has a skull thicker than a Thorium heat shield. Times like that ye need a wee bit o assistance. ','',26124),
(5646,'enUS','The chromatic flight shall deal with these intruders. Let us talk of more pressing matters.','',26124),
(5647,'enUS','Modernization is the key. With a crank and a lever you can fire this baby with the power of an ogre pulling a normal bow.','',26124),
(5648,'enUS','Lets go, $n. I am ready to reach Whitereach Post.','',26124),
(5649,'enUS','','Zoom, zing, and BAM! He may have had a huge two handed cleaver made from a boat anchor but after a few well placed slices from my dinner knife, he was the one going crash!',26124),
(5650,'enUS','','A hidden blade up the sleeve can mean the difference between you laying dead in the alley, and your opponent laying face down in his own blood.',26124),
(5651,'enUS','The slow blade penetrates the shield.','',26124),
(5652,'enUS','The secret to the knife is to keep it hidden until the moment you strike.','',26124),
(5653,'enUS','','So, you wish to learn more about our elven weaponry? Let your first lesson begin.',26124),
(5654,'enUS','Now this looks familiar. If we keep heading east, I think we can... Ahh! Wyvern on the attack!','',26124),
(5655,'enUS','You want a weapon that acts as an extension of your very fist? Yes, I believe I can show you something.','',26124),
(5656,'enUS','I do not know this Eye of the Tiger some speak of, but I can show you how to use the claws of the tiger.','',26124),
(5657,'enUS','','Many think the staff an inferior weapon. I challenge any who think so to prove their strength against my staff. ',26124),
(5658,'enUS','The skill of the bow is a great asset to anyone, not just the hunter. You can strike swiftly, silently, and before your prey can blink... they are dead.','',26124),
(5659,'enUS','','Ah, $r... I possess great knowledge a\' da world and how ta create charms a\' great power. ',26124),
(5660,'enUS','Many times my blades have felled my target before they even drew near. The secret is in the flick of your wrist.','',26124),
(5661,'enUS','','Mau\'ari know why you seek her out...$B$BBring me da E\'ko you find in the world, an\' I can transform it for you.',26124),
(5662,'enUS','How do I use the Cache of Mau\'ari?','How do I use the Cache of Mau\'ari?',26124),
(5663,'enUS','Sssplendid... Then let us watch as my children tear these mortals to pieces.','',26124),
(5664,'enUS','Use the freezing breath, imbecile!','',26124),
(5665,'enUS','Foolsss... Kill the one in the dress!','',26124),
(5666,'enUS','Inconceivable!','',26124),
(5667,'enUS','Do not force my hand, children! I shall use your hides to line my boots.','',26124),
(5668,'enUS','Your efforts will prove fruitless. None shall stand in our way!','',26124),
(5669,'enUS','I promise you an eternity of dung clean up duty for that failure!','',26124),
(5670,'enUS','Curse you, mortal.','',26124),
(5671,'enUS','Concentrate your attacks upon the healer!','',26124),
(5672,'enUS','Sire, let me join the fray! I shall tear their spines out with my bare hands!','',26124),
(5673,'enUS','Impossible!','',26124),
(5674,'enUS','Flee while you still have a chance, mortals. You will pray for a swift death should I enter the arena.','',26124),
(5675,'enUS','You will learn of the sanctuary only death can offer...','',26124),
(5676,'enUS','It appears as if I will have to step in and take care of you myself.','',26124),
(5677,'enUS','I will tear off your limbs and use them to beat you into submission!','',26124),
(5678,'enUS','Defilers!','',26124),
(5679,'enUS','I can stand no more of this!','',26124),
(5680,'enUS','Vincent!  You and your pathetic ilk will find no more success in routing my sons and I than those beggardly remnants of the Kirin Tor.','',26124),
(5681,'enUS','If you will not serve my Master with your sword and knowledge of his enemies...','',26124),
(5682,'enUS','Your moldering remains will serve ME as a testament to what happens when one is foolish enough to trespass in my domain!\n','',26124),
(5683,'enUS','Thanks a bunch... I can find my way back to Whitereach Post from here. Be sure to talk with Motega Firemane; perhaps you can keep him from sending me home.','',26124),
(5684,'enUS','%s spies you tampering with the camp\'s fruit stores and attacks you!','',26124),
(5685,'enUS','%s emerges from the log hovel and catches you tampering with the grain stores!','',26124),
(5686,'enUS','','More and more of Kalimdor is turning into the twisted landscape to our left, and the critters who dwell within are NOT friendly.  Watch your step.',26124),
(5687,'enUS','','Blast... ogres.  I forgot about these buffoons.  There\'s no easy way around them, so expect plenty of fighting.  Look sharp!',26124),
(5688,'enUS','','Come on Dadanga!  March girl, march!',26124),
(5689,'enUS','','There it is -- Gadgetzan!  We\'re in the home stretch now!',26124),
(5690,'enUS','','We\'re finally here, thanks to you $n!  Without your help, we would have been some over-grown lizard\'s lunch!',26124),
(5691,'enUS','','It was quite a haul, but now I can load up on supplies for the trip back into the Crater.  I should be able to unload some of this exotic cargo as well.',26124),
(5692,'enUS','','Look out, incoming!',26124),
(5693,'enUS','','I\'m gonna need some help with this $n!',26124),
(5694,'enUS','Yeah yeah, I know Dadanga dislikes smoke.  From the smell of it though, seems like Dadanga also dislikes bathing.','',26124),
(5695,'enUS','Have you seen Petra or Dadanga around?\n','Have you seen Petra or Dadanga around?',26124),
(5696,'enUS','They took off for Gadgetzan a while ago to bring us back some supplies.  Frankly, I would have given at least four of my fingers to have had the chance to crawl inside one of Dadanga\'s packs in order to leave this forsaken place.','',26124),
(5698,'enUS','What is E\'ko?','What is E\'ko?',26124),
(5699,'enUS','','Da Cache of Mau\'ari holds great secrets... The shards used ta make it are reflective, and you can use its shiny surface ta siphon power from other tings and den reflect it onto yourself.$B$BKeeping da charm in your inventory lets you collect e\'ko, da spiritual power from the beasts you fight. Once you find e\'ko, you bring it ta Mau\'ari.',26124),
(5700,'enUS','','E\'ko is da power dat each creatures possesses. Da charm I made for ya allows you ta capture it in a physical manifestation.$B$BI know an incantation dat can transform da e\'ko you find, and turn it into juju.$B$BYou can den take the Cache of Mau\'ari, an\' use it ta reflect da power of da juju onto yourself.$B$BC\'mon, give it a try. Bring da e\'ko ta Mau\'ari an\' we have some fun.',26124),
(5701,'enUS','','As nice as Gadgetzan is compared to Un\'Goro, I have some good folks counting on us to bring them some supplies.  If you\'re ready to go, then so are Dadanga and I.  Let\'s mount up!',26124),
(5702,'enUS','','The Tanaris desert is littered with gigantic bones just like this one to my right.  I\'d hate to have ever ran across that thing.',26124),
(5703,'enUS','','Whoa, whoa, hold up Dadanga girl.',26124),
(5704,'enUS','%s snorts deeply as she comes to a halt.','',26124),
(5705,'enUS','','This doesn\'t look... right.  Look at how alien the desert is!  Going through here might be a terrible mistake.',26124),
(5706,'enUS','','What the... what are those things crawling at us?  We... we have incoming!',26124),
(5707,'enUS','','That was not what I would call \'escort friendly\'.  I will find a way to go around these things.  Let\'s move to the south, toward that rock.  Maybe we can wedge through it and still avoid the ogres.',26124),
(5708,'enUS','','This will work -- keep heading through this gap.  The path to Un\'Goro is due west of here once we round these infernal bugs.',26124),
(5709,'enUS','THIS CANNOT BE!!! Rend, deal with these insects.','',26124),
(5710,'enUS','The mortals have fallen! The new age of the Blackrock legion is at hand!','',26124),
(5711,'enUS','%s is knocked off his drake!','',26124),
(5712,'enUS','WOOT!','',26124),
(5713,'enUS','That will surely save me some work.','',26124),
(5714,'enUS','I want those boots! Nobody touch that corpse!','',26124),
(5715,'enUS','Consider yourself lucky, mortal. At least your corpse is still somewhat presentable.','',26124),
(5716,'enUS','Do not consume the entire corpse just yet, children! Save room for dessert!','',26124),
(5717,'enUS','Served!','',26124),
(5718,'enUS','You actually believed that you stood a chance?','',26124),
(5719,'enUS','The Blackhand legion shall wear your skin as fashion accessories!','',26124),
(5720,'enUS','The Warchief shall make quick work of you, mortals. Prepare yourselves!','',26124),
(5721,'enUS','%s paces back and forth in anticipation of the battle.','',26124),
(5722,'enUS','With pleasure...','',26124),
(5723,'enUS','Good day to ye $g lad : lass;. Can I be of service?','',26124),
(5724,'enUS','Here for training eh? Just began my training meself, but I would be glad ta teach ye what I can.','',26124),
(5725,'enUS','Ye learn fast $g lad : lass;, much faster than I can keep up with. If ye want ta continue yer training, I suggest ye see my teacher. His name\'s Rotgath, Rotgath Stonebeard and ye\'ll find him in Ironforge at The Great Forge.','',26124),
(5726,'enUS','Taste in my power!','',26124),
(5727,'enUS','Eh? I don\'t have time ta chat, my da\' wants me ta finish this order fer him.','',26124),
(5728,'enUS','Ye\'ve got a little skill on ye. Enough to learn ye a few things I wager. Let\'s see what I can teach ye, shall we?','',26124),
(5729,'enUS','Ye know more than I do, that\'s a certainty. Tell ye what though, go talk with me da\'. He\'ll want ye ta prove yerself, but he is a fine teacher indeed. His name\'s Rotgath, and ye\'ll find him near the anvils workin steel for ol\' Bengus.','',26124),
(5730,'enUS','Well my friend, ye have more skill than I do. Why don\'t ye go find me old friend Rotgath Stonebeard. He stayed in Ironforge when I left to join Jaina\'s army. I\'m sure he\'ll be able ta teach ye somethin, or at least know someone who can. If he\'s still around, I\'m sure he\'ll be at The Great Forge.','',26124),
(5731,'enUS','Where should I look for E\'ko?','Where should I look for E\'ko?',26124),
(5732,'enUS','','The creatures in Winterspring are a good place ta start.$B$BHoweva\', der may also be other places you can look...',26124),
(5733,'enUS','Of course I can help you with training. I\'m just a journeyman myself, but I\'m sure there\'s something I can show you.','',26124),
(5734,'enUS','I don\'t admit this lightly, but you are a far better smith than I am. If you want to learn more than my meager teachings then I suggest you seek out a Dwarf named Therum Deepforge in Stormwind. You will find him in the Dwarven District.','',26124),
(5735,'enUS','I\'m sorry, I\'m a bit busy right now making horseshoes for Verner Osgood in Lakeshire. ','',26124),
(5736,'enUS','Do I look like I have the time to spend jawin?','',26124),
(5737,'enUS','You\'re not bad, but let me show you a few tricks you might find handy. ','',26124),
(5738,'enUS','A far better blacksmith than I am, that\'s for sure. Though I\'ll deny it if you tell anyone I said that. You should go speak with Therum Deepforge. If anyone can teach you more, it\'s him.','',26124),
(5739,'enUS','I hear one comment about waterfowl, and you will be eating through a tube.','',26124),
(5740,'enUS','Just swinging a hammer at an anvil doesn\'t make you a smith. Give me that and let me teach you something before you embarrass us all.','',26124),
(5741,'enUS','Not bad. Go talk with Snarl, he just moved to Orgrimmar to study under Saru. Look for him in the Warrior district near Saru\'s smithy. Oh and he\'ll test you, so you better be as ready as you think you are.','',26124),
(5742,'enUS','Snarl calls me simple because I am too slow. I just want to do the job right, and that takes time.','',26124),
(5743,'enUS','I can show you what you wish to know, but you must be patient. Take your time to work the steel and feel the way it shapes beneath your hammer. When you become one with the steel, then you will understand.','',26124),
(5744,'enUS','You learn quickly, that is not a bad thing. Just be sure to do the job right, as long as it takes to do so. Now, I fear I must send you to Snarl to learn more. Learn what he can teach, but do not listen to his angry words. He gets that way when Saru\'s daughters laugh at him.','',26124),
(5745,'enUS','I listen and I listen but I don\'t hear these spirits that Karn speaks of. ','',26124),
(5746,'enUS','Karn says we need to listen to the spirits of the forge and of the steel, that they will guide us. I hear nothing but a ringing in my ears. Here, take a hammer and let us try to hear the spirits together.','',26124),
(5747,'enUS','I guess the spirits like you better than me, I still have not heard their call but you seem to have gathered their lessons well. Go speak to Karn, he will be excited to see one who hears them as he does.','',26124),
(5748,'enUS','All is not lost! Battle these beasts without fear. Your wounds I shall heal, bones I shall mend. Be renewed, heroes!','',26124),
(5749,'enUS','','Your interruption is costing me valuable time, this had better be good.',26124),
(5750,'enUS','','Ah yes, another who will stoke the fires and forge the weapons of war. Of course I will teach you how.',26124),
(5751,'enUS','','You have learned well my child. Go to the Undercity, find a smith named James Van Brunt. He will be able to teach you much that I cannot. I understand he spends his time near the Warriors training hall, forging their weapons and armor.',26124),
(5752,'enUS','I hope to one day forge weapons and armor from the bones of my enemies.','',26124),
(5753,'enUS','You are not trying to kill the anvil with your hammer, you are trying to create a weapon to kill your foes with. Let me show you what you are doing wrong.','',26124),
(5754,'enUS','You have learned much, more than I can teach. Go to James Van Brunt, he will teach you what I cannot.','',26124),
(5755,'enUS','You must continue! Their resolve is weakening. Drink from my power and be renewed once again!','',26124),
(5756,'enUS','What is Juju?','What is Juju?',26124),
(5757,'enUS','','E\'ko is da unfocused form of the supernatural power, and Juju is da concentrated essence. By using a stong incantation, I can transform da E\'ko into Juju.  Once it becomes Juju, you can den use the Cache of Mau\'ari ta reflect da powers onto yourself.',26124),
(5758,'enUS','I lost the Cache of Mau\'ari. What can I do?','I lost the Cache of Mau\'ari. What can I do?',26124),
(5759,'enUS','','Ah am very surprised that one wit such a careless nature has gotten dis far...$B$BYah, you may have another charm, but Mau\'ari is very displeased wit your actions!$B$BGo, now. ',26124),
(5760,'enUS','You have come too far to fail. Stand back, mortals.','',26124),
(5761,'enUS','You will suffer in this defeat, Nefarian!','',26124),
(5762,'enUS','This should do it! At least it better do it!','',26124),
(5763,'enUS','Holy Krakle! The temperature is 428,000 degrees Kraklenheit! ','',26124),
(5764,'enUS','The temperature is 9280 degrees Kraklenheit! That\'s HOT!','',26124),
(5765,'enUS','The temperature is 564 degrees Kraklenheit.','',26124),
(5766,'enUS','The temperature is 122 degrees Kraklenheit.','',26124),
(5767,'enUS','The temperature is 12 degrees Kraklenheit. How exciting.','',26124),
(5768,'enUS','Um, Ozzie... that doesn\'t look very safe.','',26124),
(5769,'enUS','OZZIE!!!! OH NO!','',26124),
(5770,'enUS','Didn\'t even leave his boots behind...','',26124),
(5771,'enUS','%s shrugs.','',26124),
(5772,'enUS','%s collapses but the broken body rises again!','',26124),
(5773,'enUS','The living are here!','',26124),
(5774,'enUS','Ow!  OK, I\'ll get back to work, $n!','',26124),
(5775,'enUS','When I get all shaken up, hear me shout...','',26124),
(5776,'enUS','Vaelastrasz, when this world belongs to the black flight, your flight shall know its end.','',26124),
(5777,'enUS','But for now, your death will have to suffice...','',26124),
(5778,'enUS','You merely destroy an image, fool. I shall hunt you until the end of days.','',26124),
(5779,'enUS','Aye, it appears as if ye have learned quite a bit, I\'m impressed. But do ye know how many I have that seek to be my apprentice? Tell ye what, do a small task fer me and I\'ll take ye on.','',26124),
(5780,'enUS','Ye have some skill about ye with hammer and anvil, but not enough. Go speak to Dane Lindgren, he\'ll get ye ready to learn what I have to teach ye.','',26124),
(5781,'enUS','I said ye had the blood of a blacksmith in ye, and I was right. Go to Ironforge, to The Great Forge, and find yerself a Dwarven smith by the name of Bengus Deepforge. My teacher, and one of the greatest smiths I\'ve ever known.','',26124),
(5783,'enUS','The life of a smith is not an easy one, but it puts steel in yer bones and fire in yer heart. My da\' was a smith, my grandfather before him in the forges beneath Grim Batol. And now my son follows in our footsteps, that boy makes me proud.','',26124),
(5784,'enUS','Sorry $g lad : lass;, ye aren\'t quite up to the challenge of learning from me. Go see my son Groum, it would make his day to get a new apprentice.','',26124),
(5785,'enUS','Yer skill is not without merit, but I need to put one last test to ye before I take ye on.','',26124),
(5786,'enUS','Aye, I would love ta teach ye a thing or two about smithing. Grab an apron and a hammer and let\'s see what we can accomplish shall we?','',26124),
(5787,'enUS','A fast learner is what ye are, and a good smith to boot. I would sign off on yer work any day of the week. But I sense ye still have some learnin in ye. Go talk to Bengus Deepforge, he\'s a hard taskmaster but he\'s also one of the best.','',26124),
(5788,'enUS','%s lets out a shrill cry.','',26124),
(5789,'enUS','','Don\'t come out of the shadows like that. Next time give a girl some warning. ',26124),
(5790,'enUS','','Ever since the shadows claimed Duskwood I haven\'t been able to sleep. I am kept awake by the ghostly sounds of screaming on the breeze. It sounds almost like lambs screaming, and they won\'t stop.',26124),
(5791,'enUS','','Hmm, your work is allright but it\'s nowhere near the quality I look for in a student. Go talk with Smith Argus in Goldshire, I\'m sure he can teach you some basics. Then when you\'re done, come on back to me and I\'ll give you a little test to make sure you are ready.',26124),
(5792,'enUS','','Yeah, I\'ve heard through the grapevine that I might be seeing you sooner or later. But I don\'t just take on anyone, I need to make sure you have what it takes first. You willing to take my little test and find out?',26124),
(5793,'enUS','','You do fine work, but it\'s a bit rough around the edges. Don\'t worry about it, it will come with practice. Speaking of which, how about we see what you\'ve been working on?',26124),
(5794,'enUS','','Now I\'m the one who feels rough around the edges, I honestly don\'t think there\'s anything left I can teach you. But you know who can? Bengus Deepforge in Ironforge, now there\'s a dwarf that knows his steel. Go look him up in The Great Forge of Ironforge, see if he\'s up to having a new trainee under him.',26124),
(5795,'enUS','If I prove myself to Saru he will have no choice but to let me fight for one of his daughters. Then we will see who is sneering.','',26124),
(5796,'enUS','Stay away from Sumi and Tumi. They are....spoken for.','',26124),
(5797,'enUS','Come to me again with such pathetic work and I will send you home in a small iron box that I tempered in goat urine. Now go see that idiot Ug\'thok, he is better suited to your needs.','',26124),
(5798,'enUS','So you think you are good enough to learn from me? The great Snarl? You are no more than a lowly worm beneath my boot. However, taking on an underling might make me seem more appealing to Sumi and Tumi. Let\'s see what meager skills you possess.','',26124),
(5799,'enUS','Hmm? Oh yes, I can teach you something if you desire. But stay away from Sumi and Tumi, they are not for the likes of you. Saru only let\'s those of great skill approach his daughters.','',26124),
(5800,'enUS','There is nothing more that I can teach - now get out! And don\'t even think of approaching Saru, for one as unworthy as you he will use your blood to temper his steel.','',26124),
(5801,'enUS','The spirits have brought you to me, and so I feel blessed by them. ','',26124),
(5803,'enUS','You need to heed the guidance of the spirits a little better young one. Your path lies with another, Thrag Stonehoof in Thunder Bluff. Perhaps you can learn something from one another.','',26124),
(5805,'enUS','Tell me, do your feel prepared to face the challenge I have laid out for you? The spirits tell me that you will pass, but do you have faith in them or in yourself?','',26124),
(5806,'enUS','Join me, together we will weave the spirits of the forge and find the true shape that the metal seeks.','',26124),
(5807,'enUS','Our paths through life intersect only briefly and now is the time for ours to part ways. I consider myself blessed to have spent this time teaching you and now send you along to join paths with your next mentor. Seek out Saru Steelfury of Orgrimmar, he will teach what you need to learn.','',26124),
(5808,'enUS','You have great potential, but you must achieve understanding first, you must accept the spirits and listen to their calling. Only then will you be prepared for the path you must follow. Go speak with Thrag, I think perhaps you can learn a lot from one another.','',26124),
(5809,'enUS','You are now ready to follow the path that joins your life with my own, if only for a short time. However we must make sure that you understand the things of which the spirits speak.','',26124),
(5810,'enUS','You have learned much, but I sense that there is more left for the spirits to teach you. I can place your foot on the path but cannot guide your steps. Go and find Saru Steelfury in Orgrimmar, the next stretch of your journey begins there.','',26124),
(5811,'enUS','You waste my time, go talk with my student Basil.','',26124),
(5812,'enUS','Perhaps you have what it takes, perhaps not. If you do then I will take you on and teach you what you wish to know. If you do not... well, I\'ll just leave it at that.','',26124),
(5813,'enUS','Very fine equipment you make, very fine indeed. Go to the Orc\'s home of Orgrimmar and seek out a smith named Saru Steelfury. One thing you must give the Orcs, they make beautiful instruments of death.','',26124),
(5814,'enUS','I\'m sorry $g lad : lass; but ye just don\'t have the foundation to learn what I have to teach. But don\'t fret, go speak with my student Rotgath, he\'ll help ye out.','',26124),
(5815,'enUS','Looks like ye may have the makings of a great smith. But before I teach ye anything I need to know that ye\'ve got what it takes. ','',26124),
(5816,'enUS','I can\'t say enough about yer work, truly amazing things that ye can do with a hammer and an anvil. Now, don\'t be tellin anyone that I suggested ye go find a goblin to teach ye but that\'s exactly what I\'m gonna do. Brikk Keencraft is his name, and last I heard he was operating a shop down in Booty Bay.','',26124),
(5817,'enUS','This isn\'t a game you toy with youngling! Go, speak with Snarl outside. He may be a serpent in my lair but he does know his way around an anvil.','',26124),
(5818,'enUS','Still a bit weak, unbalanced, unsure. Not your work youngling, I am speaking of you! Now, are you ready to be shaped into a real smith or not?','',26124),
(5819,'enUS','I see you know more of the secret of steel than I do. That is good, for it is meant to be taken. Now you must travel to the jungle south of the human lands, to the goblin city of Booty Bay. There you will find a Goblin named Brikk Keencraft. I do not like Goblins but his knowledge of the secret of steel is unmatched by any I know of.','',26124),
(5820,'enUS','Yeah? Of course I\'m a smith. What, you think Dwarves are the only ones worth their weight in anvils? Fine, be that way. Go get a dwarf to help you!','',26124),
(5821,'enUS','Are you kidding me? You must be kidding me! Either that or you think I\'m a clown here to amuse you. Is that what you think? That I\'m a clown? Huh, is it! You think I\'m a clown don\'t you!','',26124),
(5822,'enUS','You act like this is the best junk I\'ve ever seen. Sure it\'s ok, but I see stuff this \'OK\' every day. Tell you what, you find a way to wow me, and I\'ll teach you things that make dwarves smile in their sleep.','',26124),
(5823,'enUS','Imagination is the limit my friend, if you can figure out how to smith it then you can make it, box it, and ship it to retailers all over the world. Of course, then you have to deal with marketing. Tell you what, let\'s just stick with the smithing part for now, ok?','',26124),
(5824,'enUS','Your victory shall be short lived. The days of both the Alliance and Horde are coming to an end! The next time we meet shall be the last.','',26124),
(5825,'enUS','What did Gryphe tell boss?? Gryphe wasn\'t lying! There she is, trying to steal battle plans!','',26124),
(5826,'enUS','Gryfe do his job! Gryfe go now!!!','',26124),
(5827,'enUS','Oh, it\'s on now! Bet you thought I\'d be alone too, huh?!','',26124),
(5828,'enUS','Whoa! This is way more than what I bargained for, you\'re on your own, Slim!','',26124),
(5829,'enUS','Though I hate to admit it, the bear did get the better of me. My oh my, that\'s one big ol\' bear!$b$bNonetheless, if you can take that bear down, it\'d be a feat to be proud of! It gave more than a few of our best hunters some trouble.$b$b<He claps you on the back.>$b$bBest the bear and we\'ll accept you as a regular member of the Farstrider Lodge.','',26124),
(5830,'enUS','Here at the Farstrider lodge, we prize hunting skills above all else. Wish to gain my approval? You\'ll have to earn it.$B$BYou look up to the challenge, $Glad:lass;!','',26124),
(5831,'enUS','You\'ve become quite the hunter, $n! Not only have you proven your skills, you also bested Daryl, which gets you extra points in my book!$B$BYou\'re welcome here any time.','',26124),
(5832,'enUS','You have summoned me, fool!  Now DIE!','',26124),
(5833,'enUS','Milk me, John.','Milk me, John.',26124),
(5834,'enUS','With pleasure... just let me savor this moment for a minute longer.','',26124),
(5835,'enUS','Do it... Do it now.','Do it... Do it now.',26124),
(5836,'enUS','They\'s in Magic Quarter.  Look for them in scary skull building.','They\'s in Magic Quarter.  Look for them in scary skull building.',26124),
(5837,'enUS','Us know where they are!  Skull building in Magic Quarter on outer ring of city.','Us know where they are!  Skull building in Magic Quarter on outer ring of city.',26124),
(5838,'enUS','Bank in Trade Quarter central tower.  You not miss it.','Bank in Trade Quarter central tower.  You not miss it.',26124),
(5839,'enUS','We have one eye and see better than you!  Bank in center of Undercity!','We have one eye and see better than you!  Bank in center of Undercity!',26124),
(5840,'enUS','Michael Garrett on upper ring in Trade Quarter.','Michael Garrett on upper ring in Trade Quarter.',26124),
(5841,'enUS','Bat man on upper level of Trade Quarter.','Bat man on upper level of Trade Quarter.',26124),
(5842,'enUS','Yep, you looking for Christopher Drakul in Trade Quarter.  He on eastern platform.','Yep, you looking for Christopher Drakul in Trade Quarter.  He on eastern platform.',26124),
(5843,'enUS','We join guild?  No?  Ok, you find Guild Master on east platform in Trade Quarter.','We join guild?  No?  Ok, you find Guild Master on east platform in Trade Quarter.',26124),
(5844,'enUS','Innkeeper Norman on upper ring of Trade Quarter is one to talk to.','Innkeeper Norman on upper ring of Trade Quarter is one to talk to.',26124),
(5845,'enUS','No rest for wicked, but us guess you ok.  You find Innkeeper Norman on upper ring of Trade Quarter.','No rest for wicked, but us guess you ok.  You find Innkeeper Norman on upper ring of Trade Quarter.',26124),
(5846,'enUS','Mailbox in middle of city, Trade Quarter, upper ring... next to inn.','Mailbox in middle of city, Trade Quarter, upper ring... next to inn.',26124),
(5847,'enUS','Us need check to see if our Brain... Brain... Brain Hacker sold at auction.  You find mailbox next to inn on upper ring of Trade Quarter.','Us need check to see if our Brain... Brain... Brain Hacker sold at auction.  You find mailbox next to inn on upper ring of Trade Quarter.',26124),
(5848,'enUS','We have auction house in central ring.','We have auction house in central ring.',26124),
(5849,'enUS','Central ring.  You go!','Central ring.  You go!',26124),
(5850,'enUS','Little goblin Zapetta on top of right zep building north of Ruins of Lordaeron.  Leave Undercity and you go there, to go Orgrimmar.','Little goblin Zapetta on top of right zep building north of Ruins of Lordaeron.  Leave Undercity and you go there, to go Orgrimmar.',26124),
(5851,'enUS','Us see balloon run by Hin Denburg north of ruins up above in right tower.  It take you to far off places, like jungle of Grom\'gol in Stranglethorn Vale.','Us see balloon run by Hin Denburg north of ruins up above in right tower.  It take you to far off places, like jungle of Grom\'gol in Stranglethorn Vale.',26124),
(5852,'enUS','Priest trainer?  You go to outer ring of War Quarter and look for them there.','Priest trainer?  You go to outer ring of War Quarter and look for them there.',26124),
(5853,'enUS','Uh huh.  Unholies in War Quarter standing around main building on outer ring of city.','Uh huh.  Unholies in War Quarter standing around main building on outer ring of city.',26124),
(5854,'enUS','','Get that head and it\'s sure to give Daryl a fright. Not that he doesn\'t deserve it, the bloody arrogant fool. But ha! I can\'t wait to see the look on his face when you show it to him.',26124),
(5855,'enUS','','Welcome to the Farstrider Lodge, $n!',26124),
(5856,'enUS','Rogues in building on outer ring of Rogues\' Quarter.','Rogues in building on outer ring of Rogues\' Quarter.',26124),
(5857,'enUS','They teach me to sneak good.  You find them in Rogues\' Quarter on outer ring of Undercity.','They teach me to sneak good.  You find them in Rogues\' Quarter on outer ring of Undercity.',26124),
(5858,'enUS','','You\'re always welcome here, $n. Thanks for the laugh -- and don\'t worry about Daryl, he had one coming!',26124),
(5859,'enUS','Warlock trainers in Magic Quarter in building on outer ring with Mages.','Warlock trainers in Magic Quarter in building on outer ring with Mages.',26124),
(5860,'enUS','Us want felhound for pet.  We feed it and treat it good and teach it play fetch.  You find Warlocks in Magic Quarter on outer ring of city.','Us want felhound for pet.  We feed it and treat it good and teach it play fetch.  You find Warlocks in Magic Quarter on outer ring of city.',26124),
(5861,'enUS','In building of War Quarter on outer ring of city.','In building of War Quarter on outer ring of city.',26124),
(5862,'enUS','Warrior trainers fight good.  You find them in War Quarter on outer ring of Undercity.','Warrior trainers fight good.  You find them in War Quarter on outer ring of Undercity.',26124),
(5863,'enUS','You look in The Apothecarium.  That where Doctor Herbert Halsey and Doctor Marsh practice.','You look in The Apothecarium.  That where Doctor Herbert Halsey and Doctor Marsh practice.',26124),
(5864,'enUS','Doctor Herbert Halsey in The Apothecarium where us was born.  Him could sew you back together better like us.','Doctor Herbert Halsey in The Apothecarium where us was born.  Him could sew you back together better like us.',26124),
(5865,'enUS','James Van Brunt in War Quarter on inner ring.','James Van Brunt in War Quarter on inner ring.',26124),
(5866,'enUS','Inner ring of War Quarter where James Van Brunt work.  Him make us good chain.','Inner ring of War Quarter where James Van Brunt work.  Him make us good chain.',26124),
(5867,'enUS','That Eunice Burch in Trade Quarter.','That Eunice Burch in Trade Quarter.',26124),
(5868,'enUS','Eunice Burch sell leftover parts.  You find her in Trade Quarter.','Eunice Burch sell leftover parts.  You find her in Trade Quarter.',26124),
(5869,'enUS','You go to inner ring of The Apothecarium.  Lavinia Crowe is there.','You go to inner ring of The Apothecarium.  Lavinia Crowe is there.',26124),
(5870,'enUS','Lady teach you make magic items.  She at inner ring of The Apothecarium.','Lady teach you make magic items.  She at inner ring of The Apothecarium.',26124),
(5871,'enUS','Franklin Lloyd in Rogues\' Quarter on outer ring of Undercity.','Franklin Lloyd in Rogues\' Quarter on outer ring of Undercity.',26124),
(5872,'enUS','Heh, bombs, us like bombs.  Graham Van Talen show you how to make.  He in outer ring of Rogues\' Quarter.','Heh, bombs, us like bombs.  Graham Van Talen show you how to make.  He in outer ring of Rogues\' Quarter.',26124),
(5873,'enUS','Us know her good.  She Mary Edras at inner ring of Rogues\' Quarter.','Us know her good.  She Mary Edras at inner ring of Rogues\' Quarter.',26124),
(5874,'enUS','Lady stitch us up and bandage when we get hit.  You find her in inner ring of Rogues\' Quarter.','Lady stitch us up and bandage when we get hit.  You find her in inner ring of Rogues\' Quarter.',26124),
(5875,'enUS','You not miss Armand Cromwell in Magic Quarter.  He stand on dock.','You not miss Armand Cromwell in Magic Quarter.  He stand on dock.',26124),
(5876,'enUS','Armand Cromwell always on dock in Magic Quarter.  Fish in green goo taste extra good.  You try.','Armand Cromwell always on dock in Magic Quarter.  Fish in green goo taste extra good.  You try.',26124),
(5877,'enUS','You look for Martha Alliestar.  She on inner ring of The Apothecarium.','You look for Martha Alliestar.  She on inner ring of The Apothecarium.',26124),
(5878,'enUS','You need go to The Apothecarium on inner ring.  That where Martha Alliestar teach you how to pick flowers.','You need go to The Apothecarium on inner ring.  That where Martha Alliestar teach you how to pick flowers.',26124),
(5879,'enUS','Him\'s at inner ring of Rogues\' Quarter.','Him\'s at inner ring of Rogues\' Quarter.',26124),
(5880,'enUS','Arthur Moore in Rogues\' Quarter inner ring is one who teach leatherworking.','Arthur Moore in Rogues\' Quarter inner ring is one who teach leatherworking.',26124),
(5881,'enUS','Go to inner ring of War Quarter.  Brom Killian there.','Go to inner ring of War Quarter.  Brom Killian there.',26124),
(5882,'enUS','Brom Killian teach you how dig up shiny for me.  Him on inner ring of War Quarter.','Brom Killian teach you how dig up shiny for me.  Him on inner ring of War Quarter.',26124),
(5883,'enUS','Killian Hagey teach skinning in Rogues\' Quarter on inner ring.','Killian Hagey teach skinning in Rogues\' Quarter on inner ring.',26124),
(5884,'enUS','Us have skinning hook.  We get it from Killian Hagey who teach us how to skin kills.  You have nice skin.  You find him on inner ring of Rogues\' Quarter.','Us have skinning hook.  We get it from Killian Hagey who teach us how to skin kills.  You have nice skin.  You find him on inner ring of Rogues\' Quarter.',26124),
(5885,'enUS','You look for Josef Gregorian.  He in Magic Quarter on inner ring side of green canal.','You look for Josef Gregorian.  He in Magic Quarter on inner ring side of green canal.',26124),
(5886,'enUS','Hmmm, that good idea.  Maybe we head there to get some stitches replaced?  Him sew good.  You find Josef Gregorian on inner circle of Magic Quarter.','Hmmm, that good idea.  Maybe we head there to get some stitches replaced?  Him sew good.  You find Josef Gregorian on inner circle of Magic Quarter.',26124),
(5887,'enUS','','Oh, ok!  Here you are, $n.  It\'s the least I can do for all the help you\'ve given me.',26124),
(5888,'enUS','Which profession?','Which profession?',26124),
(5889,'enUS','Alchemy','Alchemy',26124),
(5890,'enUS','Blacksmithing','Blacksmithing',26124),
(5891,'enUS','Cooking','Cooking',26124),
(5892,'enUS','Enchanting','Enchanting',26124),
(5893,'enUS','Engineering','Engineering',26124),
(5894,'enUS','First Aid','First Aid',26124),
(5895,'enUS','Fishing','Fishing',26124),
(5896,'enUS','Herbalism','Herbalism',26124),
(5897,'enUS','Leatherworking','Leatherworking',26124),
(5898,'enUS','Mining','Mining',26124),
(5899,'enUS','Skinning','Skinning',26124),
(5900,'enUS','Tailoring','Tailoring',26124),
(5901,'enUS','Which trainer do you seek?','Which trainer do you seek?',26124),
(5902,'enUS','Mage','Mage',26124),
(5903,'enUS','Priest','Priest',26124),
(5904,'enUS','Rogue','Rogue',26124),
(5905,'enUS','Warlock','Warlock',26124),
(5906,'enUS','Warrior','Warrior',26124),
(5907,'enUS','What are you looking for?','What are you looking for?',26124),
(5908,'enUS','Bank','Bank',26124),
(5909,'enUS','Bat Handler','Bat Handler',26124),
(5910,'enUS','Guild Master & Vendor','Guild Master & Vendor',26124),
(5911,'enUS','Inn','Inn',26124),
(5912,'enUS','Mailbox','Mailbox',26124),
(5913,'enUS','Auction House','Auction House',26124),
(5914,'enUS','Other Continents','Other Continents',26124),
(5915,'enUS','Class Trainer','Class Trainer',26124),
(5916,'enUS','Profession Trainer','Profession Trainer',26124),
(5917,'enUS','Us think you need help.','Us think you need help.',26124),
(5918,'enUS','We help you find them.','We help you find them.',26124),
(5919,'enUS','Our eye say you look lost.','Our eye say you look lost.',26124),
(5920,'enUS','Us hear and obey.','Us hear and obey.',26124),
(5921,'enUS','Can you help me with some directions?','Can you help me with some directions?',26124),
(5922,'enUS','Listen to the stories of an elder. $n. I have many to speak of...','',26124),
(5923,'enUS','','Welcome to the refuge, $n. Some come here with a purpose, others found their way here by accident... But everyone here seems to have a unique story to tell.',26124),
(5926,'enUS','','Be on guard... Arnak has some strange power over the Grimtotem... they will not be happy to see me escape.',26124),
(5927,'enUS','','Look out, the Grimtotem are upon us!',26124),
(5928,'enUS','','Here they come.',26124),
(5929,'enUS','','More Grimtotems are coming this way!',26124),
(5930,'enUS','','Finally, free at last... I must be going now, thanks for helping me escape. I can get back to Freewind Post by myself.',26124),
(5931,'enUS','','$n!  You\'re back!  And not a moment too soon!',26124),
(5932,'enUS','','',26124),
(5933,'enUS','','Hi, $n.  No hard feelings, ok?',26124),
(5934,'enUS','I present to you the rabid thistle bear, Tharnariun.','I present to you the rabid thistle bear, Tharnariun.',26124),
(5935,'enUS','Grrr...','',26124),
(5936,'enUS','I want to release the corrupted saber to Winna.','I want to release the corrupted saber to Winna.',26124),
(5937,'enUS','Be cleansed!','',26124),
(5938,'enUS','%s recasts the cleansing spell.','',26124),
(5939,'enUS','%s jumps into the moonwell, and goes underwater...','',26124),
(5940,'enUS','%s follows $n obediently.','',26124),
(5941,'enUS','%s snarls ferociously.','',26124),
(5942,'enUS','What kind of a Horde are we if we refuse to deliver justice? The cowards all turned their backs on me in my time of need, $c. At the Crossroads they claimed I was blinded by my own rage, that I was acting rash and reckless.$B$B<Mankrik spits on the ground.>$B$BThey did not see what I have seen, have never lost what I have lost. I will not rest until I have my vengeance.','',26124),
(5943,'enUS','I thank you, $n. Your dedication to my plea gives rest to my lost wife\'s spirit, and for that I could never repay you enough.$B$BI cannot say that my hatred will ever cease for the quilboar, but it is satiated for now.$B$BNow I must begin to rebuild my life.','',26124),
(5944,'enUS','%s points to the parchment on the ground.','',26124),
(5945,'enUS','','I\'m very curious to see what this sample of water will do!',26124),
(5946,'enUS','','%s pours the corrupted water onto the cat.',26124),
(5947,'enUS','','Haha! Perfect!',26124),
(5948,'enUS','%s has been encaged.','',26124),
(5949,'enUS','Use staff, tell Raze what do! Show Raze poacher! Raze smash!','',26124),
(5950,'enUS','Now this is an example of what not to summon. Look, it\'s frail and brittle. One good whack from a mace will send bone shards flying.','Now this is an example of what not to summon. Look, it\'s frail and brittle. One good whack from a mace will send bone shards flying.',26124),
(5951,'enUS','Note the weak binding structure of this one. Be sure to finish your incantations or this is what you will end up with.','Note the weak binding structure of this one. Be sure to finish your incantations or this is what you will end up with.',26124),
(5952,'enUS','This one is slightly better than the last. However, it still suffers from the same flimsy bone structure as the others. When you summon one of these, you are on the right path.','This one is slightly better than the last. However, it still suffers from the same flimsy bone structure as the others. When you summon one of these, you are on the right path.',26124),
(5953,'enUS','Wow, this one is just plain useless. Let me try again.','Wow, this one is just plain useless. Let me try again.',26124),
(5954,'enUS','Hmmm, this one looks like something that would be better off as a windchime. Take notes class... This is NOT what you want to summon in the heat of battle.','Hmmm, this one looks like something that would be better off as a windchime. Take notes class... This is NOT what you want to summon in the heat of battle.',26124),
(5955,'enUS','What could be taking so long?','',26124),
(5956,'enUS','How long can it take to pick a handful of weeds?','',26124),
(5957,'enUS','At this rate I could have gathered them myself!','',26124),
(5958,'enUS','If you want something done right, do it yourself!','',26124),
(5959,'enUS','As if I had all eternity.','',26124),
(5960,'enUS','Ah, this must be him now... no?  Bah!','',26124),
(5961,'enUS','Maybe I should have just bought some off of Faruza?','',26124),
(5962,'enUS','I had to go and requisition an Abomination... an Abomination!','',26124),
(5963,'enUS','','The body is that of a female orc warrior.$B$BIt is clear that she died in battle, probably against the quilboar in the area.',26124),
(5964,'enUS','I inspect the body further.','I inspect the body further.',26124),
(5965,'enUS','','You turn the body over and see the marks from blades and spells upon the deceased orc--her armor all but destroyed, her hair matted to her face.$B$BBased on Mankrik\'s description of her, there is no doubt in your mind that this was his wife.$B$BHe will be upset by the news, but you are sure he should know the truth.',26124),
(5966,'enUS','Start running!','Start running!',26124),
(5967,'enUS','Bring it on!','Bring it on!',26124),
(5968,'enUS','Do not push me, or I will impale you on my horns!','Do not push me, or I will impale you on my horns!',26124),
(5969,'enUS','Welcome to the Crossroads, $c. My name is Thork--I lead the defenses here in the name of the Warchief.$B$BPlease, feel free to make yourself at home. As long as you mind your business, no one should have any problem with you taking up some space.$B$BThere are many threats to our safety here. If you\'ve already become familiar with the lay of the land, speak to the others here--perhaps they have tasks for you to do.','',26124),
(5970,'enUS','<Goretooth spits.>$B$BI am a warrior of the Horde, $n. It fills me with rage to know that our enemies sit in a fortress, less than a day\'s ride from Kargath, plotting against us.$B$BHow I long to break free from the bonds of duty and destroy them all in the name of the Warchief.$B$BAlas, we all have roles we must fulfill.\n','',26124),
(5971,'enUS','What roles?','What roles?',26124),
(5972,'enUS','Truly, I envy you: To battle in the name of the Horde, at the forefront of conflict. Mine is a job of command.$B$BCertainly, in my youth, I lived out the dreams that make my old age bearable. I now revel in the glory of victory, the bitter taste of defeat - all through the soldiers I command.\n','',26124),
(5973,'enUS','Dreams?','Dreams?',26124),
(5974,'enUS','I dream, $n... oh yes, I dream. In my dreams I die a thousand times in a thousand different ways. Some would call dreams such as mine nightmares. NOT I! In dreams I die in the thick of battle. For each single death of my own, ten thousand enemies of the Horde fall before me. It is glorious!','',26124),
(5975,'enUS','I pray for such things.','I pray for such things.',26124),
(5976,'enUS','Aye, I could tell just by looking at you, $n. You remind me very much of myself as a young warrior of the Horde.$B$BYou will undoubtedly go far in life and even further in death.$B$B<Goretooth salutes.>','',26124),
(5977,'enUS','I do not deserve such praise, Warlord Goretooth.','I do not deserve such praise, Warlord Goretooth.',26124),
(5978,'enUS','And modest too... Perhaps it is your time, then, $n.$B$BAre you prepared to enter the fortress of the Blackrock orcs? To wreak havoc? To tear asunder the foundation of the mountain citadel?','',26124),
(5979,'enUS','Sir! Until my body ceases to function!','Sir! Until my body ceases to function!',26124),
(5980,'enUS','I did not doubt you for even one second, $n.$B$BHere are your orders, $n. I know that you will not let me down.\n','',26124),
(5981,'enUS','Yes, sir. Thank you, sir!','Yes, sir. Thank you, sir!',26124),
(5982,'enUS','%s bows before Krang Stonehoof','%s bows before Krang Stonehoof',26124),
(5983,'enUS','Ah a visitor! Must be an adventurer, we don\'t get many tourists down this way. Grab a chair and a drink, make yourself comfortable. Say, you look like you have some meat on your bones. You thinkin about competing in the cage matches?','Ah a visitor! Must be an adventurer, we don\'t get many tourists down this way. Grab a chair and a drink, make yourself comfortable. Say, you look like you have some meat on your bones. You thinkin about competing in the cage matches?',26124),
(5984,'enUS','%s attacks the pike!','',26124),
(5985,'enUS','%s destroys the pike!','',26124),
(5986,'enUS','%s and Raider Kerr let their wolves rest a bit and drink...','',26124),
(5987,'enUS','%s and Raider Kerr charge into battle...','',26124),
(5988,'enUS','%s takes aim...','',26124),
(5989,'enUS','Greetings, young $c.','',26124),
(5990,'enUS','Hello, Eitrigg. I bring news from Blackrock Spire.','Hello, Eitrigg. I bring news from Blackrock Spire.',26124),
(5991,'enUS','Rend, son of Blackhand: Impotent chieftain of the Blackrock clan. A more stubborn fool does not exist.$B$BAt the end of the second War, Rend and his brother, Maim, fled to find sanctuary within the mountainous stronghold of Blackrock Spire. It was there that Rend declared himself Warchief of the weakened Blackrock clan.','',26124),
(5992,'enUS','There is only one Warchief, Eitrigg!','There is only one Warchief, Eitrigg!',26124),
(5993,'enUS','Yes, young one, you need not convince me of such things, the Warchief and I have much history. Your dedication, however, is noted.$B$BAs I was saying, Rend had found a new home for his people, and I was among those who would wearily follow.$B$BFrom one conflict arose others... countless others. It was in those battles for Blackrock Spire between the Blackrock clan and the Dark Iron dwarves that my sons were both slain. It was then that I realized my time among the Blackrock clan had come to an end.','',26124),
(5994,'enUS','What do you mean?','What do you mean?',26124),
(5995,'enUS','I left. I would not remain with the Blackrock. No, the deaths of my children would not be in vain. I would not serve under an inept, power hungry maniac such as Rend.$B$BI took shelter in the woods of Lordaeron, living as a hermit near Hearthglen.','',26124),
(5996,'enUS','Hearthglen?? But...\n','Hearthglen?? But...\n',26124),
(5997,'enUS','<Eitrigg laughs.>$B$BYoung one, the world has not always been in such disarray. It was a time before the Scourge had sacked the land. Before those parts of Lordaeron were known as the Plaguelands.$B$BIt was there that Thrall rescued me from death and it was then that I joined the new Horde... but I digress. This is a story for another time. Yes, another time... Perhaps...','',26124),
(5998,'enUS','I will take you up on that offer, Eitrigg.','I will take you up on that offer, Eitrigg.',26124),
(5999,'enUS','I\'m certain you will. Perhaps one day you could deliver a message to an old friend of mine. I hear he still wanders those woods.$B$B<Eitrigg bows his head for a moment, as if in prayer.>$B$BSo Rend, yes... Rend and his brother Maim ruled the Spire, in constant conflict with the Dark Iron dwarves. They managed to displace the dwarves in the upper portion of the city, but only after the dragons came and only after the death of Maim.','',26124),
(6000,'enUS','Ah, so that is how they pushed the Dark Iron to the lower parts of the Spire.','Ah, so that is how they pushed the Dark Iron to the lower parts of the Spire.',26124),
(6001,'enUS','Indeed. Nefarian, brood of Deathwing, rules the Spire now. Rend is under the command of the dragon.$B$BIf only you could somehow manage to pass through the Halls of Ascension.$B$B<Eitrigg sighs.>$B$BAlas, only those deemed worthy by the black flight earn privilege to ascend.\n','',26124),
(6002,'enUS','Perhaps there exists a way?','Perhaps there exists a way?',26124),
(6003,'enUS','Perhaps. Go now, young one. Seek council with the Warchief. He will surely wish to know of your discovery.','',26124),
(6004,'enUS','As you wish, Eitrigg.','As you wish, Eitrigg.',26124),
(6005,'enUS','Hulfnar!  Thontek!  Stand and address me.','Hulfnar!  Thontek!  Stand and address me.',26124),
(6006,'enUS','It\'s 428,000 degrees Kraklenheit... What\'s happening, hot stuff!?','',26124),
(6007,'enUS','DING! 428,000 degrees Kraklenheit, exactly! Well, approximately. Almost. Somewhere around there...','',26124),
(6008,'enUS','Measuring by Kraklenheit, it is 428,000 degrees! That\'s Krakley!','',26124),
(6009,'enUS','18 degrees Kraklenheit. It\'s kind of cold, actually...','',26124),
(6010,'enUS','It\'s 40 degrees Kraklenheit. Can you feel the heat? No? I really couldn\'t either.','',26124),
(6011,'enUS','Wow, it\'s 3 degrees Kraklenheit. Keep looking.','',26124),
(6012,'enUS','The stake is covered with the remnants of those foolish enough to anger the Warchief.','',26124),
(6013,'enUS','Honor your heroes! On this day, they have dealt a great blow against one of our most hated enemies! The false Warchief, Rend Blackhand, has fallen!','',26124),
(6014,'enUS','Be bathed in my power! Drink in my might! Battle for the glory of the Horde!','',26124),
(6015,'enUS','Be bathed in the power of the Warchief! Drink in his might! Battle for the glory of the Horde!','',26124),
(6016,'enUS','The Valley of Trials will temper even the weakest into a warrior worthy to join the Horde. Those who cannot rise to its tests will be left to bake in the scorching desert sun.','',26124),
(6017,'enUS','Place Rend\'s head on the stake.','Place Rend\'s head on the stake.',26124),
(6018,'enUS','','Hello there, $n.  I am known as Chronormu, but you may call me Chromie.  I am comfortable with such familiarity.$B$BNow - how did I know your name, you ask?  I am one of the bronze dragonflight, forever attuned to the ebb and flow of time.  You could say that we have met before.  To that end, we shall also meet again.',26124),
(6019,'enUS','','Hello once again, $n.  I sense that the flow of time remains threatened by forces that are quite powerful indeed.  Your continued assistance is always welcomed by the bronze dragonflight.$B$BWhile the past is set in its ways, the future is always changing.  The decisions you make in the here and now help guide that change.',26124),
(6020,'enUS','I want you both to demonstrate the techniques I have taught you for the benefit of the younger students here.  Ready...  begin!','I want you both to demonstrate the techniques I have taught you for the benefit of the younger students here.  Ready...  begin!',26124),
(6021,'enUS','','This is where I get off, suckers!',26124),
(6022,'enUS','','Tell Lexlort if he wants the information, all he has to do is pay! Unfortunately, that means he can\'t kill me if he wants the information - since I burned the battle plans and all...',26124),
(6023,'enUS','','Listen to your elders, $n. If you are strong of will and dedicated, there is no power you cannot control.',26124),
(6024,'enUS','','Not all Forsaken are driven by Sylvanas\' will, $n. Some of us are driven by true power--power we earn for ourselves.',26124),
(6025,'enUS','Enough talk you two!  Commence fighting!','Enough talk you two!  Commence fighting!',26124),
(6026,'enUS','','Now\'s not a good time, $n.$B$BAre you insane?!',26124),
(6027,'enUS','','It... is... not... the best... time, $n. I must concen... trate.',26124),
(6028,'enUS','','Your errand must mean much, $c, to draw you so deep into the marsh...',26124),
(6029,'enUS','','The infernal is one of the most powerful demons a warlock could hope to have at $Ghis:her; side in battle. The creature is stong, well-armored, and delivers devastating blows upon any foe. If you were to choose to put the spirit of an infernal into your weapon, you would gain some of those benefits--greater health and regeneration and the like.$B$BIf you wish to know more about felhounds, then you should speak to Wytula across from me.',26124),
(6030,'enUS','','The felhound... a vicious creature indeed. It is not as physically strong as an infernal, but a wise warlock knows that brute force is not always the answer--if it was, you would have chosen the path of a warrior instead, wouldn\'t you?$B$BThe felhound draws upon the mana of its foes, using that and its quickness to overcome enemies. Its strength comes from the arcane and using that arcane power for its own ends.$B$BIf you wish to know more about infernals, then you should speak to Magaz across from me.',26124),
(6031,'enUS','ROOKERY MINION SPAWN DEBUG','ROOKERY MINION SPAWN DEBUG',26124),
(6032,'enUS','ROOKERY MINION death DEBUG','ROOKERY MINION death DEBUG',26124),
(6033,'enUS','%s is summoned through a temporal rift!','',26124),
(6034,'enUS','','Have you spoken to either of my acolytes inside the tower yet, $n? We cannot complete your orb until you\'ve done one of their tasks. Speak to them now, if you\'re ready.',26124),
(6035,'enUS','Help me kill $n!','',26124),
(6036,'enUS','Protect me from this $n! I must return to my brood.','',26124),
(6037,'enUS','Don\'t let me die!','',26124),
(6038,'enUS','Well Done!','Well Done!',26124),
(6039,'enUS','','%s roars out for her mate!',26124),
(6040,'enUS','%s answers the call of Shy-Rotam.','',26124),
(6043,'enUS','Please, help me $g brother : sister;...$B$BI will soon pass from this world, and though I suffer I know I shall not any more once I pass.  The wildlife though, my $g brother : sister;... the wildlife suffers too, and it knows no release.  I ask for your aid with my last breaths of life.','',26124),
(6045,'enUS','Yes, I speak a language you understand $r.  We are not animals, yet most of your kind continues to treat us as such!  Our differences though pale to the tragedy that has befallen this land.  Please, put aside your differences with my kind and hear my dying plea.$B$BI came to this land to mend what I could, and now that will be for naught unless you can aid me.  I ask for such aid with my last breaths of life.','',26124),
(6046,'enUS','\"...\"$B$BThe body of the tauren druid lies still and unmoving.  It would seem as though he has finally passed from this world to his promised great beyond.','',26124),
(6061,'enUS','None may challenge the Brotherhood!','',26124),
(6062,'enUS','And stay down!','',26124),
(6063,'enUS','Lapdogs, all of you!','',26124),
(6064,'enUS','Fools! Our cause is righteous!','',26124),
(6065,'enUS','The Brotherhood shall prevail!','',26124),
(6066,'enUS','Leaping leper gnomes! I\'ve been stuck in there for months. Thanks, gang.','',26124),
(6067,'enUS','Who dares step into my domain!  Come!  Come, and be consumed!','',26124),
(6068,'enUS','Ever vigilant in their protection of the natural world, the druids are guided by Archdruid Fandral Staghelm, who resides in the Cenarion Enclave. You will find him and the other druid trainers in the northern section of Darnassus.','Ever vigilant in their protection of the natural world, the druids are guided by Archdruid Fandral Staghelm, who resides in the Cenarion Enclave. You will find him and the other druid trainers in the northern section of Darnassus.',26124),
(6069,'enUS','I am an officer of the city, working in the capacity of the Undercity\'s census.  Since our liberation from the Scourge, we have tried to keep an accurate track of our city\'s populace.  Through arcane methods and sharpened mental discipline, I am able to access these records.  If you have business with me accordingly, please proceed.  You should know if you do, at any rate.','',26124),
(6070,'enUS','The Warchief has instructed me to study all kinds of weapons and armor. He has sent me here to the hub of both the tauren and orc cultures in the Barrens to meet as many travelers as possible, and to learn about the cultures of the Barrens.$B$BHe feels there\'s something to be learned from even the most pathetic of cultures... like the quilboar or centaur.','',26124),
(6071,'enUS','You surrendered.  I win.','You surrendered.  I win.',26124),
(6072,'enUS','Now that\'s a War Stomp!  Good job!','Now that\'s a War Stomp!  Good job!',26124),
(6073,'enUS','That\'s how it\'s done class!  You better be paying attention!','That\'s how it\'s done class!  You better be paying attention!',26124),
(6074,'enUS','Now that\'s putting your hoof down!','Now that\'s putting your hoof down!',26124),
(6075,'enUS','You! $R! Come here. <snort>$B$BTime is short, and my end <snort> is near. Mangletooth shall win; you will see. <snort>$B$BMy capture can still aid <snort> my people. The Razormane tribe is more powerful than the Bristlebacks!$B$BThe Horde looks to find out who leads the raids on their people. You <snort> shall aid Mangletooth in return for the information only I know. Mangletooth can help you! <snort> But you must help Mangletooth.','',26124),
(6076,'enUS','Welcome to Stormwind!  I am one of the city\'s officers, aiding the citizenry of the city through our census bureau.  If you are in need of locating someone specific, then I might be able to assist you.  Through arcane methods and sharpened mental discipline, I am able to access these records.$B$BIf you have business with me, then please proceed!','',26124),
(6077,'enUS','My hatred is strong <snort>, but the time is right to tell you a tale, $r.$B$BLong ago a battle took place between gods. Agamaggan, our great boar god, fell to the earth after being defeated in the War of the Ancients, his blood raining down and his bones torn asunder. <snort>$B$BGreat thorns reached up out of the earth where his blood touched the ground, and his skull adorns one of the caverns to the south.','',26124),
(6078,'enUS','Whew... I need a smoke and the touch of a fine gnomish woman - not particularly in that order!$B$BI\'ve been stuck inside the belly of that thing for months! What day is it anyway? Ah, nevermind. All that matters is that I\'m finally out.$B$BWOOO HOOO!','',26124),
(6079,'enUS','How the hell did you get in there to begin with?\n','How the hell did you get in there to begin with?\n',26124),
(6080,'enUS','How?? Well, it\'s a long story.','',26124),
(6081,'enUS','I\'m all ears.','I\'m all ears.',26124),
(6082,'enUS','Alrighty then! So I was down at the lava pits of the Molten Span, testing out my lava suit. Everything was going great. I was even able to swim around in that stuff without suffering a single injury!$B$BSo there I am, minding my own business, doing a few backstrokes, when out of nowhere this thing swallows me up whole! Had it not been for my lava suit and built in food pellet dispenser, I would have been done for!','',26124),
(6083,'enUS','So let me get this straight. You were swimming, nay, doing backstrokes in molten lava with this... this lava suit of yours? Yes? And out of nowhere, this here beast swallowed you whole? ','So let me get this straight. You were swimming, nay, doing backstrokes in molten lava with this... this lava suit of yours? Yes? And out of nowhere, this here beast swallowed you whole? ',26124),
(6084,'enUS','Say, I sense a measure of disbelief in your voice - but yes, that\'s how it happened.','',26124),
(6085,'enUS','I must know something: How did you go to the bathroom with that thing on?','I must know something: How did you go to the bathroom with that thing on? ',26124),
(6086,'enUS','I\'m not out of the belly of this beast for more than two minutes and someone is already asking me about my bathroom behavior??? $G Mister:Missy;, I\'d have smacked you silly for that question had you not been the one to rescue me!$B$BAnyhow! I\'m grateful for the assistance. Maybe I can pay you back?','',26124),
(6087,'enUS','Oh?','Oh?',26124),
(6088,'enUS','Well, maybe \'pay\' isn\'t the best word to use. See, when I was stuck in the belly of that thing, I got to thinking:$B$BThis creature lives in hot, flaming magma and yet it doesn\'t take a lick of damage from the fire!$B$BIf only I could find a pristine hide from one of these beasts. I could take it back to my dear friend, Malyfous Darkhammer, in Everlook. If anyone could do anything with the hide of a beast like this, it would be him. \n','',26124),
(6089,'enUS','I\'ll consider that the next time I run into one of these things.','I\'ll consider that the next time I run into one of these things.',26124),
(6090,'enUS','So how about you deliver a message for me?','',26124),
(6091,'enUS','Ish nu!  That\'s enough!','Ish nu!  That\'s enough!',26124),
(6092,'enUS','To Malyfous, I assume.','To Malyfous, I assume.',26124),
(6093,'enUS','Wanna buy a cockroach?','',26124),
(6094,'enUS','You will never wake the dreamer!','',26124),
(6095,'enUS','The coils of death will crush you!','',26124),
(6096,'enUS','I am the serpent king! I can do anything! ','',26124),
(6097,'enUS','','None can stand against the Serpent Lords!',26124),
(6098,'enUS','Good, good.  Now bow to each other.','Good, good.  Now bow to each other.',26124),
(6099,'enUS','Now bow to me.','Now bow to me.',26124),
(6100,'enUS','Good job you two.  Now go have a seat.','Good job you two.  Now go have a seat.',26124),
(6101,'enUS','%s whimpers.','',26124),
(6102,'enUS','%s grumbles.','',26124),
(6103,'enUS','%s snorts.','',26124),
(6104,'enUS','%s cries.','',26124),
(6105,'enUS','Hahah!  Revenge is mine!','',26124),
(6106,'enUS','%s takes a more careful aim...','',26124),
(6107,'enUS','%s picks the orc target...','',26124),
(6108,'enUS','%s takes aim again...','',26124),
(6109,'enUS','%s takes aim one last time...','',26124),
(6110,'enUS','','Time is running out for me... for us all...',26124),
(6111,'enUS','','I have so much to do... so much before the plague comes...\n',26124),
(6112,'enUS','','John, honey, where are you?',26124),
(6113,'enUS','','What is happening to everyone?  I feel... cold...',26124),
(6114,'enUS','','The spirit looks upon you with a sense of completeness and cognizance that had not been present before.$B$B\"I feel as though a great burden has been lifted from my soul.  Soon I will rest forever in peace.  I now know this, and I await this time patiently.$B$BThank you, stranger.\"',26124),
(6115,'enUS','You, too, shall serve!','',26124),
(6116,'enUS','Another falls!','',26124),
(6117,'enUS','You have <snort> aided Mangletooth more than I would have dreamed, $r.$B$BThank you.$B$BAs long as I remain a captive here, you may bring me blood shards from the Bristleback quilboar and I will bless you with Agamaggan\'s power.','',26124),
(6118,'enUS','%s casually points at the orc target...','',26124),
(6119,'enUS','%s blows the smoke off his rifle\'s barrel..','',26124),
(6120,'enUS','%s takes aim at the bottles...','',26124),
(6121,'enUS','%s takes aim at the bottles again...','',26124),
(6122,'enUS','%s then takes aim at the bottles...','',26124),
(6123,'enUS','%s only hits the side of the box!','',26124),
(6124,'enUS','%s quickly shoots the middle target dead center...','',26124),
(6126,'enUS','Rawww!  Urok is dead!!  Hahah!!','',26124),
(6127,'enUS','Revenge is mine!','',26124),
(6128,'enUS','The Thorium Brotherhood does not waste time on ants. Be gone!','',26124),
(6129,'enUS','Tell me about the hide.','Tell me about the hide.',26124),
(6130,'enUS','It\'s a simple process for a craftsman of my caliber.$B$BThe most difficult aspect of crafting items out of beast hides and carapace is the actual acquisition of said parts. Now, if you could bring me a pristine hide from this beast, I could make several different powerful items from the flesh.','',26124),
(6131,'enUS','What are the chances of obtaining such a hide?','What are the chances of obtaining such a hide?',26124),
(6132,'enUS','I reckon that the odds of obtaining such a piece would be a one in a million! A once in a lifetime skin! Even the most disciplined artisans of the craft would no doubt fail several hundred times in the process of skinning the beast before a pristine sample was recovered.\n','',26124),
(6133,'enUS','So let us pretend I get this hide, what else would you need and what could you actually make?','So let us pretend I get this hide, what else would you need and what could you actually make?',26124),
(6134,'enUS','If you actually brought me the hide of the beast? Well... Let me show you...','',26124),
(6135,'enUS','Ok!','Ok!',26124),
(6136,'enUS','%s turns to the paper target...','',26124),
(6137,'enUS','%s quickly shoots the orc dummy...','',26124),
(6138,'enUS','%s shoots from the hip at the bottles...','',26124),
(6139,'enUS','Read through my catalogue, $n.','',26124),
(6140,'enUS','%s misses...','',26124),
(6141,'enUS','%s misses again...','',26124),
(6142,'enUS','%s hits!','',26124),
(6143,'enUS','Left Combat','Left Combat',26124),
(6144,'enUS','The Thorium Brotherhood Fall Catalogue:$B$BInside you will find the hottest deals on all of your adventuring needs! We\'ll even show you where to pick up those difficult to find components and supplies.','',26124),
(6145,'enUS','Chapter on Frayed Abomination Stitchings.','Chapter on Frayed Abomination Stitchings.',26124),
(6146,'enUS','Chapter on Enchanted Scarlet Thread.','Chapter on Enchanted Scarlet Thread.',26124),
(6147,'enUS','Chapter on Frostwhisper\'s Embalming Fluid.','Chapter on Frostwhisper\'s Embalming Fluid.',26124),
(6149,'enUS','Here they come! Defend yourselves!','',26124),
(6150,'enUS','TIMMY!','',26124),
(6151,'enUS','Chapter on Arcane Crystals and Arcanite.','Chapter on Arcane Crystals and Arcanite.',26124),
(6152,'enUS','You\'ve accepted my surrender.','You\'ve accepted my surrender.',26124),
(6153,'enUS','','Please, follow me.',26124),
(6154,'enUS','','I haven\'t really figured out what it is, but there\'s something strange about the hot springs...',26124),
(6155,'enUS','','%s tosses the sword into the shallow pool.',26124),
(6156,'enUS','','I\'ve found that when I throw something into this water, it has improved incredibly when I retrieve it.',26124),
(6157,'enUS','','Well, whatever it is, it works quite well!',26124),
(6158,'enUS','','And I am determined to find out more... So if you need my help again, you know where I\'ll be.',26124),
(6159,'enUS','The title of this book reads with a handwritten flourish: Maureen Dalson\'s Diary.','',26124),
(6160,'enUS','A diary with yellowing pages lies open to the last entry:$B$B\"I don\'t know what\'s going to happen now that Harold\'s turned.  It took everything out of me to drag him into the only place I could find that\'d lock him up tight and hold him.  I hid the key on me, and I pray it works...$B$BI hope I can get out of here, but I need money to do that.  Our stuff\'s all in the cabinet I think... and now that I think about it, doesn\'t Harold keep the key on him?$B$BI\'ll rest on it, I\'m dead tired now.\"','',26124),
(6161,'enUS','Chapter on Skin of Shadow.','Chapter on Skin of Shadow.',26124),
(6162,'enUS','Intruders at the Service Gate! Lord Rivendare must be warned!','',26124),
(6163,'enUS','If it\'s frayed abomination stitchings you be wanting, to Stratholme you\'ll be jaunting.$B$BFormerly the hometown of the Lightbringer hisself, now overrun by the minions of Kel\'Thuzad.$B$BBrave the perils of the burning city and strike down the meaty abominations! Take from them your prize: Frayed abomination stitchings!','',26124),
(6164,'enUS','The final sanctum of crazed zealots. \'Tis where they create their scarlet uniforms, magically imbued by the enchanted scarlet thread!$B$BTo Stratholme, adventurer!','',26124),
(6165,'enUS','The finest preservative of flesh known to man and Scourge alike - Frostwhisper\'s embalming fluid.  Only one place an adventurer could find this and one would think that the lich the fluid is named after would not take too kindly to anyone going to said place.$B$BBut... if it\'s the fluid you want, the Scholomance you\'ll haunt...','',26124),
(6166,'enUS','The ground upon which the Scholomance was built was given to Kel\'Thuzad by the Barov family. In exchange for this land - a place where the Cult of the Damned could learn the foul magics of the Scourge - Kel\'Thuzad granted the Barov\'s immortality through undeath.$B$BIt is in Shadow Vault that you will find both the skin of shadow and its owner, Lady Illucia Barov.$B$BA finer mirror for the vain and dead never existed.','',26124),
(6167,'enUS','A staple of the Thorium Brotherhood.$B$BArcanite crystals are harvested from rich thorium lodes. Through the alchemical prowess of powerful alchemists, arcanite bars are born.$B$BSeek out a miner, if you aren\'t one... and find a good alchemist! You\'ll need both.','',26124),
(6168,'enUS','%s paces back and forth nervously.','',26124),
(6169,'enUS','','You should not be here! Slay them!',26124),
(6170,'enUS','','Paltry kill.',26124),
(6171,'enUS','Who dares disturb my meditation?','',26124),
(6172,'enUS','Dust to dust.','',26124),
(6173,'enUS','Usurpers! Gnomeregan is mine!','',26124),
(6174,'enUS','My machines are the future! They\'ll destroy you all!','',26124),
(6175,'enUS','And STAY dead!','',26124),
(6176,'enUS','Explosions! MORE explosions! I got to have more explosions!','',26124),
(6177,'enUS','Electric justice!','',26124),
(6178,'enUS','Victory! For Agamaggan!','',26124),
(6179,'enUS','','Troublesome whelps. I\'ll teach you to interfere!',26124),
(6180,'enUS','','Who\'s next?',26124),
(6181,'enUS','','You outsiders will pay for encroaching on our land!',26124),
(6182,'enUS','','Bah! My power rules here!',26124),
(6183,'enUS','','Our new allies will avenge us!',26124),
(6184,'enUS','Slay them, my brethren! For the Scourge!','',26124),
(6185,'enUS','Me smell stench of the living!','',26124),
(6186,'enUS','Me feast on you all!','',26124),
(6187,'enUS','You\'ll never leave this place alive.','',26124),
(6188,'enUS','Too easy.','',26124),
(6189,'enUS','To me, my servants!','',26124),
(6190,'enUS','Come, spirits - attend your master!','',26124),
(6191,'enUS','Your skulls I shall crack with all the might of Blackrock.','',26124),
(6192,'enUS','I am the hand of the Lich King!','',26124),
(6193,'enUS','%s wipes his brow.','',26124),
(6194,'enUS','Ah - I\'ve been waiting for a real challenge!','',26124),
(6195,'enUS','Light, give me strength!','',26124),
(6196,'enUS','Is that all?','',26124),
(6197,'enUS','Unworthy.','',26124),
(6198,'enUS','','The Light has spoken!',26124),
(6199,'enUS','You will not defile these mysteries!','',26124),
(6200,'enUS','Burn in righteous fire!','',26124),
(6201,'enUS','We hunger for vengeance.','',26124),
(6202,'enUS','No rest... for the angry dead!','',26124),
(6203,'enUS','More... More souls!','',26124),
(6204,'enUS','Tell me... tell me everything!','',26124),
(6205,'enUS','Purged by pain!','',26124),
(6206,'enUS','Naughty secrets!','',26124),
(6207,'enUS','I\'ll rip the secrets from your flesh!','',26124),
(6208,'enUS','Take a look at this, Malyfous.','Take a look at this, Malyfous.',26124),
(6209,'enUS','What have you got there, $n?$B$B<Malyfous points to the unfired plate gauntlets hanging out of your pack.>','',26124),
(6210,'enUS','','',26124),
(6211,'enUS','Don\'t forget to get some Flame in a Bottle from the box here.  You\'re going to need it to destroy their command tent.','',26124),
(6212,'enUS','By Thaurissan\'s beard! Slay them!','',26124),
(6213,'enUS','Me Grimlok, king!','',26124),
(6214,'enUS','Die! Die!','',26124),
(6215,'enUS','Reckless mortal!','',26124),
(6216,'enUS','I\'ll feast on your bones!','',26124),
(6217,'enUS','The Soulflayer comes!','',26124),
(6219,'enUS','Hakkar shall live again!','',26124),
(6220,'enUS','Turn back! Do not wake the dreamer!','',26124),
(6221,'enUS','Sands consume you!','',26124),
(6222,'enUS','Fall!','',26124),
(6223,'enUS','Let the executions begin!','',26124),
(6224,'enUS','Justice is done!','',26124),
(6225,'enUS','This desert be mine!','',26124),
(6226,'enUS','Die, outlander!','',26124),
(6227,'enUS','Feel the fury of the sands!','',26124),
(6228,'enUS','The Sandfury reign supreme!','',26124),
(6229,'enUS','Welcome to the front lines, $c.  While politicians may connive and scheme amongst themselves, they\'ll find no such luxury afforded to them here.  This is the Bulwark, and we fight for our continued survival on a daily basis here.$B$BIf you\'ve come here looking for a chance to prove yourself as a hero, then you\'ll find plenty of opportunities to do so.','',26124),
(6230,'enUS','Welcome to the front lines, $c.  The Kingdom of Stormwind, with the aid of its allies, has sent me here to counter the growing threat of the Scourge.  Here at Chillwind Camp, we fight for our continued survival on a daily basis.$B$BIf you\'ve come here looking for a chance to prove yourself as a hero, then you\'ll find plenty of opportunities to do so... especially as we push towards Andorhal and whatever malign force that controls the Scourge there.','',26124),
(6231,'enUS','','%s looks around nervously.',26124),
(6232,'enUS','','Are you sure you weren\'t followed here? I have a very bad feeling all of a sudden...',26124),
(6233,'enUS','','Be on your guard!',26124),
(6234,'enUS','We are betrayed!','',26124),
(6235,'enUS','It is good to see others who fight the Scourge in Stratholme, for it is here they are strongest.$B$BGreetings.  I am Aurius.  I was once a paladin of the Silver Hand, but like others whose faith wavered... I fell from grace.  The Scourge seduced me and nearly transformed me into a death knight!$B$BFinally sensing my peril, I fled to this chapel.  It is a sacred place, where the first paladin, Uther the Lightbringer, was ordained into the order of the Silver Hand.','',26124),
(6236,'enUS','Rivendare!  I come for you!','',26124),
(6237,'enUS','Argh!','',26124),
(6238,'enUS','I do not have much time in this world, but Light willing, it is time enough to fulfill my destiny.  When you face Baron Rivendare, I will be with you.','',26124),
(6239,'enUS','Leave me.  My wounds are great and I fear they will overtake me.  Thank you, $n.  I will die here, but because of you... I\'ll die in peace.','',26124),
(6240,'enUS','Test not my patience, mortal.','',26124),
(6241,'enUS','You will have to excuse me, Lorax, I do not speak \'crazy.\'','You will have to excuse me, Lorax, I do not speak \'crazy.\'',26124),
(6242,'enUS','Bite your tongue, $r, lest I rip it from your skull case and use it as a horn warmer.','',26124),
(6243,'enUS','My apologies, I did not realize that you could understand what I was saying. What is it you are doing out here?','My apologies, I did not realize that you could understand what I was saying. What is it you are doing out here?',26124),
(6244,'enUS','What it is that I do, of course. I brood. I lament. I hate. I plot. When that cycle is complete, I brood again. What is it you want from me? I have much on my mind.','',26124),
(6245,'enUS','Do you? Perhaps you should tell me what it is that is bothering you.','Do you? Perhaps you should tell me what it is that is bothering you.',26124),
(6246,'enUS','You?$B$B<Lorax laughs.>$B$BThat is doubtful.$B$BI stand in these ruins and dream. Dream of the day that I catch that miserable thief, Goraluk Anvilcrack.$B$BWe had a deal, him and I. A deal that he broke. Betrayed.','',26124),
(6247,'enUS','What deal?','What deal?',26124),
(6248,'enUS','I would teach him how to demon forge in exchange for his soul. The soul of a Blackrock orc is worth very little but in these trying times, a soul, any soul, is better than none at all.','',26124),
(6249,'enUS','So how did he break the deal?','So how did he break the deal?',26124),
(6250,'enUS','He took the unforged rune covered breastplate, used in the making of the demon forged breastplate and ran away without making payment. A fool, I am not, however... the unforged chest piece is useless without knowledge or the recipe to apply said knowledge.$B$BI wonder... does he sit safely in his city of Blackrock Spire and attempt to create the item from the raw material? I know he dare not leave!\n','',26124),
(6251,'enUS','Perhaps I can be of some assistance. I will make a deal with you, Satyr. I shall recover this unforged breastplate and slay the beast, Goraluk Anvilcrack. In exchange for this task, you will teach me how to create the breastplate.','Perhaps I can be of some assistance. I will make a deal with you, Satyr. I shall recover this unforged breastplate and slay the beast, Goraluk Anvilcrack. In exchange for this task, you will teach me how to create the breastplate.',26124),
(6252,'enUS','I TASTE THE BLOOD OF LIFE!','',26124),
(6253,'enUS','I AM NEAR!','',26124),
(6254,'enUS','HAKKAR LIVES!','',26124),
(6255,'enUS','%s breaks apart and loses strength!','',26124),
(6256,'enUS','The liquids and mixtures all bubble and spasm as you approach. Next to the equipment lies a large pair of tongs that look as though they would be adequate for dropping in samples of ooze.$B$BThere is safety gear present, but it appears to be dusty and well-ignored.$B$BDo you place some of your samples into the beakers?','',26124),
(6257,'enUS','%s explodes and releases several Bile Slimes!','',26124),
(6258,'enUS','%s belches out a disgusting Bile Slime!','',26124),
(6259,'enUS','','Ha ha, $n! I won\'t ever forget the look on Daryl\'s face when you showed him that head!',26124),
(6260,'enUS','Leave this place!','',26124),
(6261,'enUS','My turn, meathead! I get to throw now.','My turn, meathead! I get to throw now.',26124),
(6262,'enUS','You threw last one, idiot. It\'s my turn.','You threw last one, idiot. It\'s my turn.',26124),
(6263,'enUS','%s start pushing each other back and forth.','%s start pushing each other back and forth.',26124),
(6264,'enUS','What does Dadanga like to eat?\n','What does Dadanga like to eat?\n',26124),
(6265,'enUS','','Since we\'ve begun our stay in the crater, Dadanga\'s taken a liking to the large bloodpetal sprouts that grow all over the place here.$B$BI\'m sure she\'d enjoy a snack, if you feel like bringing her some...',26124),
(6266,'enUS','OK, OK! It\'s your turn!','OK, OK! It\'s your turn!',26124),
(6267,'enUS','Heya mon.  Once I get my hands on a few more supplies, I fix ya right up!','',26124),
(6268,'enUS','Dis here volunteer work be my way of gettin through Witch Doctor School.  Since you help me, I help ya for free.  Whatcha need fixin?','',26124),
(6269,'enUS','Low spirits','Low spirits',26124),
(6270,'enUS','%s whimpers.','',26124),
(6271,'enUS','%s breathes erratically. ','',26124),
(6272,'enUS','%s cries for help.','',26124),
(6273,'enUS','I... I am badly injured... ','',26124),
(6274,'enUS','Save me...','',26124),
(6275,'enUS','You will be ok, Awbee. Your assailants have been terminated.','You will be ok, Awbee. Your assailants have been terminated.',26124),
(6276,'enUS','Listen, $r. Listen well...$B$BThe dragon riders came in the night, mounted atop the black flight. They struck fast and with deadly precision, taking young whelps - such as me - and escaping under the veil of darkness.$B$BI watched in horror as they used my brothers and sisters in their experiments. From our essence would be created the chromatic flight.','',26124),
(6277,'enUS','Continue please...','Continue please...',26124),
(6278,'enUS','Nefarian had ordered that unsuitable subjects be destroyed immediately, but these retched beasts would not do so without first inflicting an \'ample\' amount of torture.$B$BWhen we were thoroughly \'broken,\' they would round up what remained and throw us to these thugs. Our bodies used as instruments in their sick game: thrown into the lava or worse; to the open and waiting arms of the bloodthirsty legion below.','',26124),
(6279,'enUS','Horrifying.','Horrifying.',26124),
(6280,'enUS','You came along just as they were about to throw me to the fiends below - for that, I thank you. Perhaps, I - rather - we, of the blue flight, can assist you further?$B$BYou have come this far, $r, risked much. Will you go a ways further to battle Nefarian and his legion of Blackrock? ','',26124),
(6281,'enUS','Absolutely.','Absolutely.',26124),
(6282,'enUS','You cannot save him!','',26124),
(6283,'enUS','Bad hang nail','Bad hang nail',26124),
(6284,'enUS','Feeling underpowered','Feeling underpowered',26124),
(6285,'enUS','Jungle Fever','Jungle Fever',26124),
(6286,'enUS','Uni-brow','Uni-brow',26124),
(6287,'enUS','Whiplash','Whiplash',26124),
(6288,'enUS','I don\'t want to go back to work','I don\'t want to go back to work',26124),
(6289,'enUS','The Ash\'ari Crystals have been destroyed! The Slaughterhouse is vulnerable!','',26124),
(6290,'enUS','If you are here to hunt dragons, be my guest.  Where should I send my condolences?','',26124),
(6291,'enUS','Your stench will attract every dragon for miles.  Tell me what you want, and quickly.','',26124),
(6292,'enUS','The spirits told me you would come, that you would seek me for some reason, but that even you may not know that reason. So, do you know why you are here?','',26124),
(6293,'enUS','','Oh hi! My name\'s Sarah. What can I do for you?',26124),
(6294,'enUS','','The forest told me of your presence, but not why you were here. So, speak and enlighten me.',26124),
(6295,'enUS','How you doin\' mon!','',26124),
(6296,'enUS','','The Emerald Circle welcomes you, $n.$B$BHopefully together we can help rejuvenate and protect this once-mighty forest. Many forces seek to destroy it from without... and within.$B$BDo not be persuaded by the power here--it will only corrupt you, like it has this entire land.',26124),
(6297,'enUS','While Greta focuses her energy on the recovery of Jaedenar and those who she thinks is mostly responsible for the corruption here in Felwood. I spend my time looking into the effects the corruption has had on the land.$B$BHow has it affected the creatures of the land? What must be done to end the pain of their suffering?$B$BUnfortunately, the corruption runs so deep that eternal sleep is too often the answer.','',26124),
(6298,'enUS','Tucked away in the Mage Quarter, there is a little shop called Alchemy Needs.  You\'re bound to see all sort of strange shops on your way through the Mage Quarter, but if you stick to the outer rim you\'ll be sure to find it.','Tucked away in the Mage Quarter, there is a little shop called Alchemy Needs.  You\'re bound to see all sort of strange shops on your way through the Mage Quarter, but if you stick to the outer rim you\'ll be sure to find it.',26124),
(6299,'enUS','Stormwind Counting House is located by the front gates in the Trade District of Stormwind. And when you get tired of counting your money, be sure to stop by the Gilded Rose for a drink.','Stormwind Counting House is located by the front gates in the trade district of Stormwind. And when you get tired of counting your money, be sure to stop by the Gilded Rose for a drink.',26124),
(6300,'enUS','You mean you can\'t smell the smoke of the Dwarven forges from here?  Well, you will be looking for Therum Deepforge if you want to learn blacksmithing.  He\'s over in the Dwarven District which is just north of the Cathedral Square.','You mean you can\'t smell the smoke of the Dwarven forges from here?  Well, you will be looking for Therum Deepforge if you want to learn blacksmithing.  He\'s over in the Dwarven District which is just north of the Cathedral Square.',26124),
(6301,'enUS','','%s jumps in fright!',26124),
(6302,'enUS','','Ahhhhh!!!',26124),
(6303,'enUS','','You big meanie! Who put you up to this?',26124),
(6304,'enUS','','It was Umi, wasn\'t it?! She\'s always playing jokes on me, and now she\'s got you in on it too!',26124),
(6305,'enUS','','%s sighs.',26124),
(6306,'enUS','','%s jumps in fright!',26124),
(6307,'enUS','','Ahhhh!!! What is that thing?!',26124),
(6308,'enUS','','Umi sent you, didn\'t she?! She told me to expect a surprise, but I never thought that this is what she meant!',26124),
(6309,'enUS','There\'s a great cook who works at the Pig and Whistle Tavern in Old Town.  I\'ve watched him use a knife when he cooks and just between you and me, I don\'t think he\'s always been a cook.  Don\'t get me wrong... if you still want to learn, he\'s the best we have.','There\'s a great cook who works at the Pig and Whistle Tavern in Old Town.  I\'ve watched him use a knife when he cooks and just between you and me, I don\'t think he\'s always been a cook.  Don\'t get me wrong... if you still want to learn, he\'s the best we have.',26124),
(6310,'enUS','Ah, you\'re looking for Lucan Cordell.  He runs a shop on the outside of the Magic Quarter on your way to the Stockade.  ','Ah, you\'re looking for Lucan Cordell.  He runs a shop on the outside of the Magic Quarter on your way to the Stockade.  ',26124),
(6311,'enUS','%s attempts to get help!','%s attempts to get help!',26124),
(6312,'enUS','Hey, that reminds me, I need to have my rocket boots repaired.  Word to the wise my friend, rocket boots and gryphons don\'t mix.  \n\nOh, but you need directions...  just head on over to the Dwarven District, you\'ll find Lilliam Sparkspindle towards the back.','Hey, that reminds me, I need to have my rocket boots repaired.  Word to the wise my friend, rocket boots and gryphons don\'t mix.  \n\nOh, but you need directions...  just head on over to the Dwarven District, you\'ll find Lilliam Sparkspindle towards the back.',26124),
(6313,'enUS','No better place to learn First Aid than under the watchful eye of Angela Leifeld at the Cathedral of Light.  \n\nTo get there, just look for the yellow rooftops, or the towering spire of the Cathedral itself which you can see from almost anywhere in the city.','No better place to learn First Aid than under the watchful eye of Angela Leifeld at the Cathedral of Light.  \n\nTo get there, just look for the yellow rooftops, or the towering spire of the Cathedral itself which you can see from almost anywhere in the city.',26124),
(6314,'enUS','Oh!!! Get that thing away from me!','',26124),
(6315,'enUS','That bum Leland... all he does is sit out on the dock outside the Trade District and fish all day.  I sure hope he\'s good at it for all the time he spends fishing.  If you want to learn, why don\'t you go talk to him?','That bum Leland... all he does is sit out on the dock outside the Trade District and fish all day.  I sure hope he\'s good at it for all the time he spends fishing.  If you want to learn, why don\'t you go talk to him?',26124),
(6316,'enUS','There\'s nothing quite like communing with nature... or at least that\'s what the night elves tell me.  I\'m not much for talking to flowers and trees, but I\'m sure Tannysa could help you out.  She\'s over in the Mage Quarter outside of Alchemy Needs.','There\'s nothing quite like communing with nature... or at least that\'s what the night elves tell me.  I\'m not much for talking to flowers and trees, but I\'m sure Tannysa could help you out.  She\'s over in the Mage Quarter outside of Alchemy Needs.',26124),
(6317,'enUS','Why do you chase me, Mechanical Yeti?! WHY?!','',26124),
(6318,'enUS','%s runs quickly away from Umi\'s Mechanical Yeti.','',26124),
(6319,'enUS','A Hunter is it?  Well, then you will want to speak with Thorfin Stoneshield over in the Dwarven District.  \n\nOh, and you be sure to tell him that if I step in his pet\'s business one more time, he\'s going to be training other hunters from behind bars in the Stockade!','A Hunter is it?  Well, then you will want to speak with Thorfin Stoneshield over in the Dwarven District.  \n\nOh, and you be sure to tell him that if I step in his pet\'s business one more time, he\'s going to be training other hunters from behind bars in the Stockade!',26124),
(6320,'enUS','I\'m jumpy as it is... and people insist on scaring me... Next time, though, I\'ll be ready!','',26124),
(6321,'enUS','You\'re into leather, eh?  Sounds like you should talk to Simon Tanner over in Old Town.  He runs a shop there called the Protective Hide.','You\'re into leather, eh?  Sounds like you should talk to Simon Tanner over in Old Town.  He runs a shop there called the Protective Hide.',26124),
(6322,'enUS','%s looks relieved.','',26124),
(6323,'enUS','Leave it to the dwarves to send a mining specialist from Ironforge to tell us how to mine.  How hard is it to take a pick and chip away at some rock?  Well, since he\'s here, he\'s probably the one you should see anyhow.  His name is Gelman and he resides over in the Dwarven District.','Leave it to the dwarves to send a mining specialist from Ironforge to tell us how to mine.  How hard is it to take a pick and chip away at some rock?  Well, since he\'s here, he\'s probably the one you should see anyhow.  His name is Gelman and he resides over in the Dwarven District.',26124),
(6324,'enUS','You know, I could run an orc through or slice up a troll.  I could even carve my initials in an ogre\'s flank, but I just can\'t stand to skin an animal.  Go figure, eh.  \n\nWell, if you have the stomach for it, then go see Maris Granger at the Protective Hide in Old Town.','You know, I could run an orc through or slice up a troll.  I could even carve my initials in an ogre\'s flank, but I just can\'t stand to skin an animal.  Go figure, eh.  \n\nWell, if you have the stomach for it, then go see Maris Granger at the Protective Hide in Old Town.',26124),
(6325,'enUS','A tailor is it?  Well, if you hang out here long enough you\'ll eventually hear word of mouth about Georgio Bolero.  He\'s been setting the trends for some months now.  If you wish to learn from him, you can find him over in the Mage Quarter in the outer rim.','A tailor is it?  Well, if you hang out here long enough you\'ll eventually hear word of mouth about Georgio Bolero.  He\'s been setting the trends for some months now.  If you wish to learn from him, you can find him over in the Mage Quarter in the outer rim.',26124),
(6326,'enUS','Warlocks, eh.  Well, you didn\'t hear it from me, but I\'ve heard rumors that those types gather at a bar called the Slaughtered Lamb in the Mage Quarter.  ','Warlocks, eh.  Well, you didn\'t hear it from me, but I\'ve heard rumors that those types gather at a bar called the Slaughtered Lamb in the Mage Quarter.  ',26124),
(6327,'enUS','%s marches around, roaring and making a ruckus.','',26124),
(6328,'enUS','Deeprun Tram','Deeprun Tram',26124),
(6329,'enUS','RAAAAAAAR!','',26124),
(6330,'enUS','You don\'t have the stomach for the gryphon ride, huh.  Well lucky for you, we have an alternative where you can keep your feet on the ground... more or less.  It\'s the gnomish mover of people, the Deeprun Tram.  Conveniently located in the back of the Dwarven District.','You don\'t have the stomach for the gryphon ride, huh.  Well lucky for you, we have an alternative where you can keep your feet on the ground... more or less.  It\'s the gnomish mover of people, the Deeprun Tram.  Conveniently located in the back of the Dwarven District.',26124),
(6331,'enUS','You\'ve heard about the Tram have you?  What a ride that thing is!  You\'ll find it in the Dwarven District towards the back.  Oh, and be sure to keep your arms and legs inside the tram while the tram is in motion.','You\'ve heard about the Tram have you?  What a ride that thing is!  You\'ll find it in the Dwarven District towards the back.  Oh, and be sure to keep your arms and legs inside the tram while the tram is in motion.',26124),
(6332,'enUS','Study it, $n: The Catalogue of the Wayward.','',26124),
(6333,'enUS','Aye, everyone wants to ride the tram to Stormwind, it\'s a real hoot and a half.  Well, if ye want to find the tram, it\'s located over in Tinker Town just east of the gates of Ironforge.','Aye, everyone wants to ride the tram to Stormwind, it\'s a real hoot and a half.  Well, if ye want to find the tram, it\'s located over in Tinker Town just east of the gates of Ironforge.',26124),
(6334,'enUS','Oh, the tram, the tram...  everyone wants to ride the tram to Stormwind.  What happened to the good ol\' days of flying on the back of a gryphon, gripping the saddle for dear life as you flew up high in the sky above?  \n\nBah!  You go take the tram then... it\'s over in Tinker Town with the rest of the gnomish contraptions.','Oh, the tram, the tram...  everyone wants to ride the tram to Stormwind.  What happened to the good ol\' days of flying on the back of a gryphon, gripping the saddle for dear life as you flew up high in the sky above?  \n\nBah!  You go take the tram then... it\'s over in Tinker Town with the rest of the gnomish contraptions.',26124),
(6335,'enUS','Are ye really askin\' me where the Blacksmith is?  Have ye not heard of The Great Forge!?  All our best blacksmiths gather there to craft their weapons and armor!  \n\nIt\'s dead smack in the middle of Ironforge, and that\'s where you\'ll find one of our most brilliant blacksmiths, Bengus Deepforge.  ','Are ye really askin\' me where the Blacksmith is?  Have ye not heard of The Great Forge!?  All our best blacksmiths gather there to craft their weapons and armor!  \n\nIt\'s dead smack in the middle of Ironforge, and that\'s where you\'ll find one of our most brilliant blacksmiths, Bengus Deepforge.  ',26124),
(6336,'enUS','Och!  That Daryl Riknussun is a brilliant cook!  He makes a chilli so hot ye could temper steel with it!  I don\'t think he\'ll teach ye the recipe, but he\'ll certainly help ye to become a good cook.  Ye\'ll find him at the Bronze Kettle o\'er on the northeastern side of The Great Forge.','Och!  That Daryl Riknussun is a brilliant cook!  He makes a chilli so hot ye could temper steel with it!  I don\'t think he\'ll teach ye the recipe, but he\'ll certainly help ye to become a good cook.  Ye\'ll find him at the Bronze Kettle o\'er on the northeastern side of The Great Forge.',26124),
(6337,'enUS','Oh, you\'re looking for Springspindle Fizzlegear then.  Why that little gnome and his gadgets...  Let me tell you, if you\'re going to his shop in Tinker Town, keep your hands to yourself and don\'t pet any of his mechanical sheep!  \n\nExploding sheep... now why would you even make such a thing!?','Oh, you\'re looking for Springspindle Fizzlegear then.  Why that little gnome and his gadgets...  Let me tell you, if you\'re going to his shop in Tinker Town, keep your hands to yourself and don\'t pet any of his mechanical sheep!  \n\nExploding sheep... now why would you even make such a thing!?',26124),
(6338,'enUS','First Aid?  Well ye don\'t look hurt to me.  If yer really interested in learning First Aid, then Nissa Firestone is the one to learn from.  Go see her over by The Great Forge in her shop, The Ironforge Physician.','First Aid?  Well ye don\'t look hurt to me.  If yer really interested in learning First Aid, then Nissa Firestone is the one to learn from.  Go see her over by The Great Forge in her shop, The Ironforge Physician.',26124),
(6339,'enUS','I once heard ol\' Grimnur say he fished up a sword.  Or was it a swordfish?  Damn that Grimnur, he\'s told so many fish tales I can\'t remember which is which.  Well, why don\'t you go see him over in The Forlorn Cavern and have him tell you what it was.','I once heard ol\' Grimnur say he fished up a sword.  Or was it a swordfish?  Damn that Grimnur, he\'s told so many fish tales I can\'t remember which is which.  Well, why don\'t you go see him over in The Forlorn Cavern and have him tell you what it was.',26124),
(6340,'enUS','Well now, ye\'ll need papers to form a guild, and Jondor Steelbrow can help you get started with the process.  He can be found over at the Ironforge Visitor\'s Center when yer ready to get started.','Well now, ye\'ll need papers to form a guild, and Jondor Steelbrow can help you get started with the process.  He can be found over at the Ironforge Visitor\'s Center when yer ready to get started.',26124),
(6341,'enUS','Do ye have the potential to be a skilled hunter?  Well $gladdie : lassie;, only time will tell.  Just don\'t ye go shooting at apples atop peoples\' heads till ye\'ve spoken with Regnus o\'er in the Hall of Arms.','Do ye have the potential to be a skilled hunter?  Well $gladdie : lassie;, only time will tell.  Just don\'t ye go shooting at apples atop peoples\' heads till ye\'ve spoken with Regnus o\'er in the Hall of Arms.',26124),
(6342,'enUS','Sure ye don\'t want to be a Blacksmith?  Well, if yer heart is set on Leatherworking, then you best talk to Fimble Finespindle over at his shop on the northwest side of The Great Forge.','Sure ye don\'t want to be a Blacksmith?  Well, if yer heart is set on Leatherworking, then you best talk to Fimble Finespindle over at his shop on the northwest side of The Great Forge.',26124),
(6343,'enUS','Bah!  Mailboxes...  all I get is junk mail lately!  \n\nIncrease the size of this... decrease the size of that... act now for your free Sword of Dragonslaying.  I have to change my mailbox number every other month!  \n\nWell, ye can\'t say I didn\'t warn ye.  If you\'re looking for the mailbox it\'s just outside the Stonefire Tavern.','Bah!  Mailboxes...  all I get is junk mail lately!  \n\nIncrease the size of this... decrease the size of that... act now for your free Sword of Dragonslaying.  I have to change my mailbox number every other month!  \n\nWell, ye can\'t say I didn\'t warn ye.  If you\'re looking for the mailbox it\'s just outside the Stonefire Tavern.',26124),
(6344,'enUS','Well well!  You\'ve come to the right place to learn Mining, $gboyo : girlie;!  Geofram Bouldertoe himself resides at Deepmountain Mining and Jewelcrafting.  Ye couldn\'t ask for a better instructor than him.','Well well!  You\'ve come to the right place to learn Mining, $gboyo : girlie;!  Geofram Bouldertoe himself resides at Deepmountain Mining and Jewelcrafting.  Ye couldn\'t ask for a better instructor than him.',26124),
(6345,'enUS','The book tells of dragons uniting against another, more powerful dragon, named Deathwing. From what you can make out, the chromatic dragonflight had almost been unleashed upon the world. The Aspects were prepared.\n','',26124),
(6346,'enUS','Ah, nothing better than a priest to cure what ails ye.  Of course a nice tall pint cures a lot of what ails ye too, but I don\'t think Braenna Flintcrag teaches brewing.  I guess ye\'ll have to settle for some priest training over in the Hall of Mysteries instead.','Ah, nothing better than a priest to cure what ails ye.  Of course a nice tall pint cures a lot of what ails ye too, but I don\'t think Braenna Flintcrag teaches brewing.  I guess ye\'ll have to settle for some priest training over in the Hall of Mysteries instead.',26124),
(6347,'enUS','Ye might not know it, but in addition to being a skilled tailor, Jormund is also a slayer of giants!  Why he must have overheard a few of us sharing stories when he shouted that he\'d killed seven with one blow!  \n\nYe should pay him a visit at his store on the north side of The Great Forge an\' see if he\'ll tell ye the tale!','Ye might not know it, but in addition to being a skilled tailor, Jormund is also a slayer of giants!  Why he must have overheard a few of us sharing stories when he shouted that he\'d killed seven with one blow!  \n\nYe should pay him a visit at his store on the north side of The Great Forge an\' see if he\'ll tell ye the tale!',26124),
(6348,'enUS','Skinning?  The only thing ye look like ye could skin is yer own knee!  Ha!  Now why don\'t you go see Balthus Stoneflayer so he can teach you how to properly skin some animals.  You\'ll find him in Finespindle\'s Leather Goods on the northern side of The Great Forge.','Skinning?  The only thing ye look like ye could skin is yer own knee!  Ha!  Now why don\'t you go see Balthus Stoneflayer so he can teach you how to properly skin some animals.  You\'ll find him in Finespindle\'s Leather Goods on the northern side of The Great Forge.',26124),
(6349,'enUS','A warlock, eh...  Well, if you\'ve got a mind to be doing that sort of thing around here then ye best keep yer demons on a leash $gboyo : girlie;.  I don\'t like demons, but I love putting mah axe to them.  Ye get me?  \n\nNow you just leave me be and go get lost in The Forlorn Cavern.  That\'s where you\'ll find that warlock, Thistleheart.','A warlock, eh...  Well, if you\'ve got a mind to be doing that sort of thing around here then ye best keep yer demons on a leash $gboyo : girlie;.  I don\'t like demons, but I love putting mah axe to them.  Ye get me?  \n\nNow you just leave me be and go get lost in The Forlorn Cavern.  That\'s where you\'ll find that warlock, Thistleheart.',26124),
(6350,'enUS','Kelstrum is a loudmouth and a braggart... and if that weren\'t enough he\'s also one of the most skilled warriors ye\'ll ever meet!  \n\nI tell ye, if ye\'re looking to be trained in the ways of a warrior, that\'s who ye should be talking to.  I\'m sure he can be found over in the Hall of Arms east of the Gates of Ironforge.','Kelstrum is a loudmouth and a braggart... and if that weren\'t enough he\'s also one of the most skilled warriors ye\'ll ever meet!  \n\nI tell ye, if ye\'re looking to be trained in the ways of a warrior, that\'s who ye should be talking to.  I\'m sure he can be found over in the Hall of Arms east of the Gates of Ironforge.',26124),
(6351,'enUS','Deeprun Tram','Deeprun Tram',26124),
(6352,'enUS','NO!','',26124),
(6353,'enUS','An alchemist?  No trouble at all $c.  Ainethil, in all her labor and toil, has become the most accomplished alchemist in the Craftsmen\'s Terrace.  I would head over there on the double if I were you. On the double!  Now off with you!','An alchemist?  No trouble at all $c.  Ainethil, in all her labor and toil, has become the most accomplished alchemist in the Craftsmen\'s Terrace.  I would head over there on the double if I were you. On the double!  Now off with you!',26124),
(6354,'enUS','Another material $gboy : girl; are we?  Well, if you are obsessed with your precious items then you will probably want to store them at the Darnassus Bank in the center of our city.','Another material $gboy : girl; are we?  Well, if you are obsessed with your precious items then you will probably want to store them at the Darnassus Bank in the center of our city.',26124),
(6355,'enUS','Astaia has fished up some curious treasures over the ages she has spent fishing.  Why don\'t you go see her over in the Tradesman\'s terrace and have her show you some of them.','Astaia has fished up some curious treasures over the ages she has spent fishing.  Why don\'t you go see her over in the Tradesman\'s terrace and have her show you some of them.',26124),
(6356,'enUS','Lysheana can offer you the proper documents, she resides in the Craftsmen\'s Terrace in northeasten Darnassus.  May your fellowship bring glory to the Night Elves!','Lysheana can offer you the proper documents, she resides in the Craftsmen\'s Terrace in northeasten Darnassus.  May your fellowship bring glory to the Night Elves!',26124),
(6357,'enUS','It is Vesprystus that you seek.  He watches over the hippogryphs that come and go from the base of Teldrassil.  You will find him through the portal in western Darnassus that will take you to Rut\'theran Village.','It is Vesprystus that you seek.  He watches over the hippogryphs that come and go from the base of Teldrassil.  You will find him through the portal in western Darnassus that will take you to Rut\'theran Village.',26124),
(6358,'enUS','Jocaste was the greatest of Hunters of her time.  These days you can find her over in the Cenarion Enclave where she teaches those who are just starting down the Hunter\'s path.','Jocaste was the greatest of Hunters of her time.  These days you can find her over in the Cenarion Enclave where she teaches those who are just starting down the Hunter\'s path.',26124),
(6359,'enUS','Has the sun risen already?  There are just never enough hours in the night!  Well, Saelienne will take good care of you.  You can find her tending to her guests over in the Craftsmen\'s Terrace in northeastern Darnassus.','Has the sun risen already?  There are just never enough hours in the night!  Well, Saelienne will take good care of you.  You can find her tending to her guests over in the Craftsmen\'s Terrace in northeastern Darnassus.',26124),
(6360,'enUS','A mailbox?  You have a letter to send, or perhaps have received one?  I hope it\'s something good!  There\'s a mailbox right outside of the Bank in the center of Darnassus.','A mailbox?  You have a letter to send, or perhaps have received one?  I hope it\'s something good!  There\'s a mailbox right outside of the Bank in the center of Darnassus.',26124),
(6361,'enUS','As a culture we believe in letting nothing go to waste.  When we are forced to slay a creature we take what we can to make sure its sacrifice was not in vain.  \n\nIf you wish to learn the proper way to take the skin of a slain beast, then seek out Eladriel in the Craftsmen\'s Terrace.','As a culture we believe in letting nothing go to waste.  When we are forced to slay a creature we take what we can to make sure its sacrifice was not in vain.  \n\nIf you wish to learn the proper way to take the skin of a slain beast, then seek out Eladriel in the Craftsmen\'s Terrace.',26124),
(6362,'enUS','With the garments that Me\'Lynn tailors, one might think that her needle was blessed by Elune herself.  Unless your needle is so blessed, you best pay her a visit and listen to her teachings.  You can find her in The Craftsmen\'s Terrace in northeastern Darnassus.','With the garments that Me\'Lynn tailors, one might think that her needle was blessed by Elune herself.  Unless your needle is so blessed, you best pay her a visit and listen to her teachings.  You can find her in The Craftsmen\'s Terrace in northeastern Darnassus.',26124),
(6363,'enUS','Sildinair has trained many of the Sentinels who guard our beloved city.  I am certain she can make a warrior out of the likes of you.  Seek her out at the Warrior\'s Terrace near the entrance to our city.','Sildinair has trained many of the Sentinels who guard our beloved city.  I am certain she can make a warrior out of the likes of you.  Seek her out at the Warrior\'s Terrace near the entrance to our city.',26124),
(6364,'enUS','You want to learn how to make a campfire?  Well then you had best see Malygen in the Cenarion Enclave before you set fire to Teldrassil itself.  ','You want to learn how to make a campfire?  Well then you had best see Malygen in the Cenarion Enclave before you set fire to Teldrassil itself.  ',26124),
(6365,'enUS','One has opened up on the Tradesman\'s Terrace.  If you take the path leading Southeast from the bank, it should be easy to find.','One has opened up on the Tradesman\'s Terrace.  If you take the path leading Southeast from the bank, it should be easy to find.',26124),
(6366,'enUS','Oh, the ever-present obsession with material wealth.  Well, fortune smiles on you, as you can find the auction house in the Tradesman\'s Terrace.','Oh, the ever-present obsession with material wealth.  Well, fortune smiles on you, as you can find the auction house in the Tradesman\'s Terrace.',26124),
(6367,'enUS','It is in the western portion Trade District, just north of the fountain.','It is in the western portion Trade District, just north of the fountain.',26124),
(6368,'enUS','Another entrepreneur, eh? Well, the Auction House can be found in the Trade District.  Not far from the bank.\n','Another entrepreneur, eh? Well, the Auction House can be found in the Trade District.  Not far from the bank.',26124),
(6369,'enUS','Auction House','Auction House',26124),
(6370,'enUS','Trade District Auction House','Trade District Auction House',26124),
(6371,'enUS','THIS CANNOT BE!!','',26124),
(6372,'enUS','All hands to battle stations! Naga incoming!','',26124),
(6373,'enUS','%s explodes into poisonous goo!','',26124),
(6374,'enUS','You dare defile this holy ground?','You dare defile this holy ground?',26124),
(6375,'enUS','Be cleansed by blade, filth!','Be cleansed by blade, filth!',26124),
(6376,'enUS','Enemies have reached the door!  Move in!  We must hold!','Enemies have reached the door!  Move in!  We must hold!',26124),
(6377,'enUS','Move back and hold the line!  We cannot fail or all will be lost!','Move back and hold the line!  We cannot fail or all will be lost!',26124),
(6378,'enUS','Move to the stairs and defend!','Move to the stairs and defend!',26124),
(6379,'enUS','They have broken into the Hall of Lights!  We must stop the intruders!','They have broken into the Hall of Lights!  We must stop the intruders!\n',26124),
(6380,'enUS','This will not be the end of the Scarlet Crusade!  You will not break our line!','This will not be the end of the Scarlet Crusade!  You will not break our line!\n',26124),
(6381,'enUS','Hello, traveler. Not many find me out this way.$B$BMy name is Rivern, and I train the Winterspring Frostsabers to become mounts.$B$BThese cats are the most feral and difficult to subdue of all the sabers. Only the most trusted and exalted may attempt to ride one.$B$BI will not sell such a mount to just anyone; no, you must work for it and earn your acceptance not only with me, but with the sabers themselves.','',26124),
(6382,'enUS','Information on the Chromatic Carapace.','Information on the Chromatic Carapace.',26124),
(6383,'enUS','Information on Brilliant Chromatic Scales.','Information on Brilliant Chromatic Scales.',26124),
(6384,'enUS','Information on the Blood of Heroes.','Information on the Blood of Heroes.',26124),
(6385,'enUS','Information on Frayed Abomination Stitchings.','Information on Frayed Abomination Stitchings.',26124),
(6386,'enUS','Information on the Skin of Shadow.','Information on the Skin of Shadow.',26124),
(6387,'enUS','Presumed to exist. Only a greater chromatic dragonkin or dragon could possess such a carapace.','',26124),
(6388,'enUS','Commonly found on the lesser chromatic flight: Whelps, broodlings, lesser wyrmkin.','',26124),
(6389,'enUS','Legend claims that in places of extreme conflict, across what is now known as the Plaguelands; clean and holy springs may erupt from the ground. The water from those springs has been named \'Blood of Heroes,\' by artisans and commonfolk alike - in honor of those that fell in the war against the Scourge.','',26124),
(6390,'enUS','The threads that holds together the abominations of Stratholme are highly sought after by artisan craftsmen: Extremely resilient - nearly unbreakable.','',26124),
(6391,'enUS','Used by the Barov family of the Scholomance as a mirror into the souls that they no longer possess. A valuable keepsake.','',26124),
(6392,'enUS','There are many establishments where you can get a drink in Stormwind, but only one will let you spend the night. Head over to the Gilded Rose in the Trade District. I\'ve heard the cost of a room is reasonable and the sheets are clean. ','There are many establishments where you can get a drink in Stormwind, but only one will let you spend the night. Head over to the Gilded Rose in the Trade District. I\'ve heard the cost of a room is reasonable and the sheets are clean. ',26124),
(6393,'enUS','Ah, The Gilded Rose... with its soft down beds and warm baths... just thinking about that Inn makes me want to... ::yawn:: Lucky you if you\'re heading over there...  you will find it in the west side of the Trade District.   ...nice soft pillows, warm blankets.  ::yawn::','Ah, The Gilded Rose... with its soft down beds and warm baths... just thinking about that Inn makes me want to... ::yawn:: Lucky you if you\'re heading over there...  you will find it in the west side of the Trade District.   ...nice soft pillows, warm blankets.  ::yawn::',26124),
(6394,'enUS','There is a mailbox located conveniently right between the Stormwind Bank and The Gilded Rose Inn in the Trade District.','There is a mailbox located conveniently right between the Stormwind Bank and The Gilded Rose Inn in the Trade District.',26124),
(6395,'enUS','I don\'t know how they do it...  those mailboxes must be magic portals or something.  Why I see people gathered around the mailbox next to the bank all day pulling swords and shields and various armor all from that small box!','I don\'t know how they do it...  those mailboxes must be magic portals or something.  Why I see people gathered around the mailbox next to the bank all day pulling swords and shields and various armor all from that small box!',26124),
(6396,'enUS','Inn','Inn',26124),
(6397,'enUS','Mailbox','Mailbox',26124),
(6398,'enUS','So you see fit to toy with the Lich King\'s creations? Ramstein, be sure to give the intruders a proper greeting.','',26124),
(6399,'enUS','I would like to buy from you.','I would like to buy from you.',26124),
(6400,'enUS','','Hi! I just got back from exploring the Ruins of Kel\'Theril, to the southwest. Now I\'m intent on investigating the Wildkin that lie just up the ridge here, in Owl Wing Thicket.$B$BHave you spoken to Erelas Ambersky in Rut\'theran Village? He requested that I come here, and perhaps he has a task for you as well.',26124),
(6401,'enUS','Time to take matters into my own hands. Come. Enter my domain and challenge the might of the Scourge!','',26124),
(6402,'enUS','I don\'t get paid enough for this bull excrement!','',26124),
(6403,'enUS','I can\'t take these taxes! F.I.C.A. me? F.I.C.A. YOU!','',26124),
(6404,'enUS','Hey! Do you like the sauce? The sauce is good, no?','',26124),
(6405,'enUS','And then the Tauren said, \'13 INCHES!\'','',26124),
(6406,'enUS','I come from the land down under... where women plague and men sunder.','',26124),
(6407,'enUS','The what-bringer? Oh, ASHbringer? Never heard of it... What? Stop bothering me!','',26124),
(6408,'enUS','I should have taken the translucent pill.','',26124),
(6409,'enUS','Just sit right back and you\'ll hear a ta... *hic* a tai... *hic* a taiiii *hic* Damnit!','',26124),
(6410,'enUS','','Have you seen Watcher Backus? So brave...$B$BI think he\'s the toughest of all the Night Watch. I wonder if he even notices I\'m around....',26124),
(6411,'enUS','The temperature is... not hot enough!','',26124),
(6412,'enUS','*sigh* ...113 degrees Kraklenheit. Can\'t you do any better?','',26124),
(6413,'enUS','You\'re getting warmer... 7039 degrees Kraklenheit!','',26124),
(6414,'enUS','8536 degrees Kraklenheit is the reading... Tired of me yet?','',26124),
(6415,'enUS','Who dares disturb our master?','',26124),
(6416,'enUS','','Hurray!  My doll!',26124),
(6417,'enUS','','You\'ll keep the bad people away, won\'t you?',26124),
(6418,'enUS','','Let\'s find out the whole story.  That\'s going to take some magic...',26124),
(6419,'enUS','','There, it is done.  The book has been enhanced...',26124),
(6420,'enUS','Looking for these???? You\'ll never have em!','',26124),
(6421,'enUS','The bastion is falling! Burn the evidence!','',26124),
(6422,'enUS','I\'m going to wear your skin as a smoking jacket! The stogies? You\'ll have to pry them from my cold dead... er... RAWR!!!!','',26124),
(6423,'enUS','Leave nothing behind!','',26124),
(6424,'enUS','Destroy the records before the bastion falls!','',26124),
(6425,'enUS','Ramstein hunger for flesh!','',26124),
(6426,'enUS','Welcome to flavor country!','',26124),
(6427,'enUS','Thank you!  You freed me!','Thank you!  You freed me!',26124),
(6428,'enUS','Oh, thank you!  I have been trapped in this nightmare for so long...','Oh, thank you!  I have been trapped in this nightmare for so long...',26124),
(6429,'enUS','At last, my soul is free!','At last, my soul is free!',26124),
(6430,'enUS','Thank you!  The battle for Darrowshire doomed me, but you have set me free!','Thank you!  The battle for Darrowshire doomed me, but you have set me free!',26124),
(6431,'enUS','Ah!  Please, if you see a survivor of Darrowshire, tell them I am free!','Ah!  Please, if you see a survivor of Darrowshire, tell them I am free!',26124),
(6432,'enUS','','The Emerald Circle strives to heal the wounded land of Felwood. Although the land is named for the very thing that has corrupted it, we hope that one day we will be able to eradicate the corruption from this land.',26124),
(6433,'enUS','','I\'m ready, $n. Let\'s find my equipment and get out of here. I think I know where it is.',26124),
(6434,'enUS','','We\'ve failed, $n!!',26124),
(6435,'enUS','','Hello, $c. I am Jessir Moonbow. I have come from Darnassus seeking two friends who came looking for signs of the Shadow Council in Felwood.$B$BIt seems those vile creatures who claim responsibility for much of the orcish race\'s suffering seeks to regain some of its power.$B$BMy two friends went looking in Jaedenar to prove one way or the other what was happening.$B$BI expected them to be here when I arrived, but now they are days late.',26124),
(6436,'enUS','The Scourge have broken into the Bastion!  Redouble your efforts!  We must not fail!','The Scourge have broken into the Bastion!  Redouble your efforts!  We must not fail!',26124),
(6437,'enUS','Skeletons have advanced past the Hall of Lights!  Destroy them!','Skeletons have advanced past the Hall of Lights!  Destroy them!',26124),
(6438,'enUS','Our defenses are failing!  By the light we must prevail!','Our defenses are failing!  By the light we must prevail!',26124),
(6439,'enUS','The Scourge have broken through in all wings!  May the light defeat these foul creatures!  We shall fight to the last!','The Scourge have broken through in all wings!  May the light defeat these foul creatures!  We shall fight to the last!',26124),
(6440,'enUS','Zug zug, brave $c!  I have the finest bred wolf mounts for you to peruse.  You\'ll not find another animal with the level of endurance and survival instincts that the wolf has anywhere!  Please, inspect them for yourself.','Zug zug, brave $c!  I have the finest bred wolf mounts for you to peruse.  You\'ll not find another animal with the level of endurance and survival instincts that the wolf has anywhere!  Please, inspect them for yourself.',26124),
(6441,'enUS','Today you have unmade what took me years to create! For this you shall all die by my hand!','',26124),
(6442,'enUS','Damn you mortals! All my plans of revenge, all my hate...I will be avenged...','',26124),
(6443,'enUS','','',26124),
(6444,'enUS','I only make my mounts available to those who are considered friendly to Orgrimmar and the Orcish race.  Go prove yourself to us, and I\'ll make my mighty wolves available for your inspection.','I only make my mounts available to those who are considered friendly to Orgrimmar and the Orcish race.  Go prove yourself to us, and I\'ll make my mighty wolves available for your inspection.',26124),
(6445,'enUS','And a good day to ya, brave $c.  I know ya be lookin\' for a fine steed.  There\'s no finer steed than a raptor under your reigns, lemme tell you $g mon : sis;!  Take a look at the ones I got to offer - bred from the fiercest stock anywhere.','And a good day to ya, brave $c.  I know ya be lookin\' for a fine steed.  There\'s no finer steed than a raptor under your reigns, lemme tell you $g mon : sis;!  Take a look at the ones I got to offer - bred from the fiercest stock anywhere.',26124),
(6446,'enUS','I\'m sorry $g mon : sis;, but I won\'t be sellin\' my raptors to someone who hasn\'t proven themselves to be a friendly to the Darkspear tribe.  When ya make a stand and show yourself to be at least friendly to us, then I\'ll make my raptors available to ya.','I\'m sorry $g mon : sis;, but I won\'t be sellin\' my raptors to someone who hasn\'t proven themselves to be a friendly to the Darkspear tribe.  When ya make a stand and show yourself to be at least friendly to us, then I\'ll make my raptors available to ya.',26124),
(6447,'enUS','You fools think you can defeat me so easily? Face the true might of the Nathrezim!','',26124),
(6448,'enUS','Thieves! I shall smelt your remains!','Thieves! I shall smelt your remains!',26124),
(6449,'enUS','Payment for those plans comes in bones - YOUR BONES!','',26124),
(6450,'enUS','Thank you, $n. My torment is now at an end.','',26124),
(6451,'enUS','FREE!!!','',26124),
(6452,'enUS','The curse ends!','',26124),
(6453,'enUS','Praise be to Egan!','',26124),
(6454,'enUS','May Kel\'Thuzad one day feel our vengeance.','',26124),
(6455,'enUS','Rivendare must be destroyed!','',26124),
(6456,'enUS','','Oh my! Look at this... all these candles. I\'m sure they\'re used for some terrible ritual or dark summoning. We best make haste!',26124),
(6457,'enUS','','There! Over there!',26124),
(6458,'enUS','','All I need now is a golden lasso.',26124),
(6459,'enUS','','Let\'s get out of here, $n. I\'m ready now!',26124),
(6460,'enUS','','DIE, DEMON DOGS!',26124),
(6461,'enUS','','Ah! Fresh air at last! I never thought I\'d see the day...',26124),
(6463,'enUS','','What was that?! Trey? TREY!?',26124),
(6464,'enUS','They hand the corpses to me, I toss them in the pit.','',26124),
(6465,'enUS','I wish to make a purchase.','I wish to make a purchase.',26124),
(6466,'enUS','BETRAYER!','',26124),
(6467,'enUS','','NO! What have they done to you!?',26124),
(6468,'enUS','','No! My friend... what\'s happened? This is all my fault...',26124),
(6469,'enUS','','I can travel faster on my own from here, $n. Meet Jessir Moonbow near Ashenvale. She should be with the druids of the Emerald Circle. She\'ll tell you what to do next. Thank you so much for your help!',26124),
(6470,'enUS','No tampering with the mail!','No tampering with the mail!',26124),
(6471,'enUS','Try again!','',26124),
(6472,'enUS','Certainly!','',26124),
(6473,'enUS','No chance!','',26124),
(6474,'enUS','Here comes the postmaster!','Here comes the postmaster!',26124),
(6475,'enUS','Greetings, $n. I am Myolor Sunderfury, keeper of the Great Forge.','',26124),
(6476,'enUS','I wish to become an armorsmith.','I wish to become an armorsmith.',26124),
(6477,'enUS','I wish to become a weaponsmith.','I wish to become a weaponsmith.',26124),
(6478,'enUS','Your skill in blacksmithing is exceptional, $n. The time has come to make a decision. There are two paths you may choose: The way of the weaponsmith or the art of the armorsmith.$B$BBe warned, when you have chosen to dedicate yourself to a path, there is no going back. The discipline each path requires leaves no room for hybrids.','',26124),
(6479,'enUS','','The time has come, my $g brother : sister; in arms, to take back the night from the Scourge!',26124),
(6480,'enUS','','The time has come, my $g brother : sister; in arms, to take back the night from the Scourge!',26124),
(6481,'enUS','Alas $c, you are not considered to be a true friend of Darnassus and the night elves of Teldrassil.  Only when you prove yourself to be friendly to us through deeds - not just mere words - will I then make available my selection of mounts for your perusal.','Alas $c, you are not considered to be a true friend of Darnassus and the night elves of Teldrassil.  Only when you prove yourself to be friendly to us through deeds - not just mere words - will I then make available my selection of mounts for your perusal.',26124),
(6482,'enUS','By the grace of Elune, I am pleased to offer you the finest steed found anywhere in Teldrassil, and perhaps the world - the nightsaber.  For years, the Sentinel Army has relied on the value of these companions.$B$BTake your time friend and examine each one to your satisfaction.  I am sure you will not be disappointed.','By the grace of Elune, I am pleased to offer you the finest steed found anywhere in Teldrassil, and perhaps the world - the nightsaber.  For years, the Sentinel Army has relied on the value of these companions.$B$BTake your time friend and examine each one to your satisfaction.  I am sure you will not be disappointed.',26124),
(6483,'enUS','Erm... I really don\'t know you that well, sorry.  I mean, as an authorized Mechano-strider dealer, I really only can sell my mounts to those people who are considered a friend of the gnomes.  If you ever are recognized as friendly to Gnomeregan, I\'d be happy to show you what I have to offer.','Erm... I really don\'t know you that well, sorry.  I mean, as an authorized Mechano-strider dealer, I really only can sell my mounts to those people who are considered a friend of the gnomes.  If you ever are recognized as friendly to Gnomeregan, I\'d be happy to show you what I have to offer.',26124),
(6484,'enUS','Um... I think you\'re a little too big to ride a Mechano-strider there, $g mister : ma\'am;.  You\'d likely crush the finely tuned servo-balancers!','Um... I think you\'re a little too big to ride a Mechano-strider there, $g mister : ma\'am;.  You\'d likely crush the finely tuned servo-balancers!',26124),
(6485,'enUS','If you have come looking for the gift of fast and safe mobility, then you have arrived at your destination!  This year\'s model of the new Mechano-striders have recently arrived, and I am ready to show you all they have to offer!','If you have come looking for the gift of fast and safe mobility, then you have arrived at your destination!  This year\'s model of the new Mechano-striders have recently arrived, and I am ready to show you all they have to offer!',26124),
(6486,'enUS','Speak with Ironus, $n. He\'ll be the one training you in the way of the weaponsmith.','',26124),
(6487,'enUS','Grumnus be your man, $n. He\'ll school you in the art of the armorsmith.','',26124),
(6488,'enUS','When the work of a blacksmith reaches your level of expert craftsmanship, I present them with a choice.$B$BWhile you are not required to make a choice, it is recommended that you do - after all, do you want to be a neophyte forever? It is the artisan armorsmiths and weaponsmiths that supply our armies, win our wars and garner acclaim!$B$BBe warned, $n. Once a choice is made and the tasks required completed - there is no going back. One can only walk down one path.','',26124),
(6489,'enUS','I am Krathok, overseer of these craftsmen.','',26124),
(6490,'enUS','Borgosh! $n is ready to be trained.','',26124),
(6491,'enUS','Okothos will train you, $n.','',26124),
(6492,'enUS','One of the Ash\'ari Crystals has been destroyed!  Slay the intruders!','One of the Ash\'ari Crystals has been destroyed!  Slay the intruders!',26124),
(6493,'enUS','An Ash\'ari Crystal has been restored!','An Ash\'ari Crystal has been restored!',26124),
(6494,'enUS','$R flesh... must feed!','',26124),
(6495,'enUS','Who dares to approach this cauldron?  Taste my dark blade!','',26124),
(6496,'enUS','The Scourge beckons you, foolish $r.','',26124),
(6497,'enUS','$C - I will consume your light!','',26124),
(6498,'enUS','Greetings, $r.','',26124),
(6499,'enUS','I require training.','I require training.',26124),
(6500,'enUS','Hail, $c!','',26124),
(6501,'enUS','I require training.','I require training.',26124),
(6502,'enUS','What do you want?','',26124),
(6503,'enUS','I require training.','I require training.',26124),
(6504,'enUS','Prepare to be Malowned!','',26124),
(6505,'enUS','','Highborne spirits! Be at peace! The Crystal of Zin-Malor is whole once again!',26124),
(6506,'enUS','','Cursed spirits! Let go of the past! The Crystal of Zin-Malor no longer binds you!',26124),
(6507,'enUS','','Spirits of the Highborne! You may now rest! The curse of the crystal releases you!',26124),
(6509,'enUS','Ya may not follow the ways of the Light like a Knight of the Silver Hand, but ya can always ask us for aid.','Ya may not follow the ways of the Light like a Knight of the Silver Hand, but ya can always ask us for aid.',26124),
(6510,'enUS','The Light be with ya, $c. How can I help ya?','The Light be with ya, $c. How can I help ya?',26124),
(6511,'enUS','%s raises an undead servant back to life!','',26124),
(6512,'enUS','%s attempts to cast Death Pact on his servants!','',26124),
(6513,'enUS','I wish to purchase arcane quickener from you.','I wish to purchase arcane quickener from you.',26124),
(6514,'enUS','A fierce wind is coming - I can tell by the ache in my exposed knee.  I just hope we don\'t get caught up in it.','',26124),
(6515,'enUS','Well now $n, let\'s get to work on those cauldrons!  If you\'re going to collect the components we need, then get a vitreous focuser from me.  You\'ll need to have it on you to identify the necessary resources found on the Scourge that will turn those cauldrons.$B$BYou\'ll also need a dose of arcane quickener for the cauldrons.  It\'s not cheap, nor is it stable.  Once you have it, you\'ll only have thirty minutes to use it before it expires on you; be smart about buying it.','',26124),
(6516,'enUS','What\'s needed for the cauldron at Felstone Field?','What\'s needed for the cauldron at Felstone Field?',26124),
(6517,'enUS','What\'s needed for the cauldron at Dalson\'s Tears?','What\'s needed for the cauldron at Dalson\'s Tears?',26124),
(6518,'enUS','What\'s needed for the cauldron at the Writhing Haunt?','What\'s needed for the cauldron at the Writhing Haunt?',26124),
(6519,'enUS','What\'s needed for the cauldron at Gahrron\'s Withering?','What\'s needed for the cauldron at Gahrron\'s Withering?',26124),
(6520,'enUS','Based on the sample of the toxin you provided for us, we think you will need the following: an arcane quickener, six osseous agitators, and four pieces of runecloth.  With the vitreous focuser in tow, acquire the agitators from skeletal undead here in the Plaguelands!$B$BOnce you have these items, you should be able to load the counter agent into that cauldron.','',26124),
(6521,'enUS','Based on the sample of the toxin you provided for us, we think you will need the following: an arcane quickener, five somatic intensifiers, and and four pieces of runecloth.  With the vitreous focuser in tow, acquire the intensifiers from zombie or ghoul undead here in the Plaguelands!$B$BOnce you have these items, you should be able to load the counter agent into that cauldron.','',26124),
(6522,'enUS','Based on the sample of the toxin you provided for us, we think you will need the following: an arcane quickener, five somatic intensifiers, and and four pieces of runecloth.  With the vitreous focuser in tow, acquire the intensifiers from zombie or ghoul undead here in the Plaguelands!$B$BOnce you have these items, you should be able to load the counter agent into that cauldron.','',26124),
(6523,'enUS','Based on the sample of the toxin you provided for us, we think you will need the following: an arcane quickener, four ectoplasmic resonators, and four pieces of runecloth.  With the vitreous focuser in tow, acquire the resonators from wraith and ghostly undead here in the Plaguelands!$B$BOnce you have these items, you should be able to load the counter agent into that cauldron.','',26124),
(6524,'enUS','This job is definitely not worth sixteen-five a year.','',26124),
(6525,'enUS','Well now $n, let\'s get to work on those cauldrons!  If you\'re going to collect the components we need, then get a vitreous focuser from me.  You\'ll need to have it on you to identify the necessary resources found on the Scourge that will turn those cauldrons.$B$BYou\'ll also need a dose of arcane quickener for the cauldrons.  It\'s not cheap, nor is it stable.  Once you have it, you\'ll only have thirty minutes to use it before it expires on you; be smart about buying it.','',26124),
(6526,'enUS','An Ash\'ari Crystal has fallen! Stay true to the Lich King, my brethren, and attempt to resummon it.','An Ash\'ari Crystal has fallen! Stay true to the Lich King, my brethren, and attempt to resummon it.',26124),
(6527,'enUS','An Ash\'ari Crystal has been toppled! Restore the ziggurat before the Slaughterhouse is vulnerable!','An Ash\'ari Crystal has been toppled! Restore the ziggurat before the Slaughterhouse is vulnerable!',26124),
(6528,'enUS','Our summoning is complete! The Ash\'ari crystal has been restored!','Our summoning is complete! The Ash\'ari crystal has been restored!',26124),
(6529,'enUS','Success is ours! The Ash\'ari Crystal has been restored!','Success is ours! The Ash\'ari Crystal has been restored!',26124),
(6530,'enUS','You\'ve been MALOWNED!','',26124),
(6531,'enUS','I need a vitreous focuser.','I need a vitreous focuser.',26124),
(6532,'enUS','','Arise, my champion!',26124),
(6533,'enUS','At your side, milady!','',26124),
(6534,'enUS','Blades of light!','',26124),
(6535,'enUS','Release your rage!','',26124),
(6536,'enUS','Awake, ye servants! Defend the Disks!','',26124),
(6537,'enUS','To my side, brothers! For the Makers!','',26124),
(6538,'enUS','Join us!','',26124),
(6539,'enUS','','Shhh... do you smell something?',26124),
(6540,'enUS','Liladris has been waiting for me at Maestra\'s Post, so we should make haste, $n.','',26124),
(6541,'enUS','%s begins to drift off...','',26124),
(6542,'enUS','%s suddenly falls asleep.','',26124),
(6543,'enUS','Yaaaaawwwwwnnnn...','',26124),
(6544,'enUS','Oh, I am so tired...','',26124),
(6545,'enUS','You don\'t mind if I stop here for a moment, do you?','',26124),
(6546,'enUS','%s emerges from the shadows to defend the cauldron!','',26124),
(6547,'enUS','The Scourge\'s plague still dominates the zone, and we have a long way to go before the plague will be altered enough to affect them.  Collect the necessary resources and help out the war effort!','The Scourge\'s plague still dominates the zone, and we have a long way to go before the plague will be altered enough to affect them.  Collect the necessary resources and help out the war effort!',26124),
(6548,'enUS','We are having difficulty determining the status of the plague within the area; check back shortly and we may have a better idea.','We are having difficulty determining the status of the plague within the area; check back shortly and we may have a better idea.',26124),
(6549,'enUS','The Scourge\'s plague is almost to the turning point; a handful more cauldron subversions will push us over the top!  Be sure to do your part to help out!','The Scourge\'s plague is almost to the turning point; a handful more cauldron subversions will push us over the top!  Be sure to do your part to help out!',26124),
(6550,'enUS','We have begun to turn the Scourge\'s plague against them, but our hold is tenuous at best!  Be sure to aid the cause by subverting their cauldrons!','We have begun to turn the Scourge\'s plague against them, but our hold is tenuous at best!  Be sure to aid the cause by subverting their cauldrons!',26124),
(6551,'enUS','We are dominating the Scourge - the effects of the altered plague will affect them for at least another full day!  We need to stay on top of it though, so be sure to sabotage a cauldron when you can.','We are dominating the Scourge - the effects of the altered plague will affect them for at least another full day!  We need to stay on top of it though, so be sure to sabotage a cauldron when you can.',26124),
(6552,'enUS','How are we doing in the battle to subvert the cauldrons?','How are we doing in the battle to subvert the cauldrons?',26124),
(6553,'enUS','%s comes to rest as it begins to release the counter agent into the air.','',26124),
(6554,'enUS','The deeds are mine, brother! Soon you shall be out of my way for good!','',26124),
(6555,'enUS','The fortune is mine, Alexi! Your end comes soon!','',26124),
(6556,'enUS','The Hunter Trainer\'s name is Thotar.  Seek him out inside the burrow on the southwest corner of Razor Hill.','The Hunter Trainer\'s name is Thotar.  Seek him out inside the burrow on the southwest corner of Razor Hill.',26124),
(6557,'enUS','You\'re a hunter?  Well anyway, you\'ll find Thotar hiding from the sun inside the burrow at the southwest corner of town.','You\'re a hunter?  Well anyway, you\'ll find Thotar hiding from the sun inside the burrow at the southwest corner of town.',26124),
(6558,'enUS','Speak with Un\'Thuwa to the south in Sen\'jin Village.','Speak with Un\'Thuwa to the south in Sen\'jin Village.',26124),
(6559,'enUS','That\'s troll business.  Look for Un\'Thuwa in Sen\'jin Village down south.','That\'s troll business.  Look for Un\'Thuwa in Sen\'jin Village down south.',26124),
(6560,'enUS','You\'re looking for Tai\'jin.  Find her in the barracks on the east side of town.','You\'re looking for Tai\'jin.  Find her in the barracks on the east side of town.',26124),
(6561,'enUS','Tai\'jin is her name and you\'ll find her inside the barracks on the east side of Razor Hill.  She\'ll teach you to respect the gods.  Make certain that you show her the proper respect in return!','Tai\'jin is her name and you\'ll find her inside the barracks on the east side of Razor Hill.  She\'ll teach you to respect the gods.  Make certain that you show her the proper respect in return!',26124),
(6562,'enUS','Find Kaplak on top of the burrow in the southwest section of town.','Find Kaplak on top of the burrow in the southwest section of town.',26124),
(6563,'enUS','Why would you want to talk to Kaplak?  Nevermind.  Look for him on top of the burrow in the southwest corner of Razor Hill.  Just make sure that you keep your hands in your own pockets!','Why would you want to talk to Kaplak?  Nevermind.  Look for him on top of the burrow in the southwest corner of Razor Hill.  Just make sure that you keep your hands in your own pockets!',26124),
(6564,'enUS','You need to find Swart.  Look for him inside the barracks on the east side of Razor Hill.','You need to find Swart.  Look for him inside the barracks on the east side of Razor Hill.',26124),
(6565,'enUS','The Warchief brings change that will bring the Horde victory!  Look for Swart inside the barracks on the east side of town.','The Warchief brings change that will bring the Horde victory!  Look for Swart inside the barracks on the east side of town.',26124),
(6566,'enUS','On the east side of Razor Hill, behind the barracks is where you will find Dhugru Gorelust.','On the east side of Razor Hill, behind the barracks is where you will find Dhugru Gorelust.',26124),
(6567,'enUS','Dhugru Gorelust is hiding behind the barracks on the east side of town.  Don\'t let me find out that you\'re in league with the Burning Legion!','Dhugru Gorelust is hiding behind the barracks on the east side of town.  Don\'t let me find out that you\'re in league with the Burning Legion!',26124),
(6568,'enUS','Look for Tarshaw Jaggedscar in the barracks on the east side of town.','Look for Tarshaw Jaggedscar in the barracks on the east side of town.',26124),
(6569,'enUS','Find Tarshaw Jaggedscar inside the barracks on the east side of Razor Hill.  Bring pride and honor to the Horde youngling!','Find Tarshaw Jaggedscar inside the barracks on the east side of Razor Hill.  Bring pride and honor to the Horde youngling!',26124),
(6570,'enUS','Seek out Miao\'zan in Sen\'jin Village to the south.','Seek out Miao\'zan in Sen\'jin Village to the south.',26124),
(6571,'enUS','I hear that the trolls in Sen\'jin Village have a potion maker named Miao\'zan.  Look there.','I hear that the trolls in Sen\'jin Village have a potion maker named Miao\'zan.  Look there.',26124),
(6572,'enUS','That would be Dwukk.  Find him next to the heated forge at the northwest corner of town.','That would be Dwukk.  Find him next to the heated forge at the northwest corner of town.',26124),
(6573,'enUS','If you think you have the strength to pound good metal into weapons and armor for the Horde look for Dwukk next to the heated forge in the northwest corner of Razor Hill.','If you think you have the strength to pound good metal into weapons and armor for the Horde look for Dwukk next to the heated forge in the northwest corner of Razor Hill.',26124),
(6574,'enUS','Head north up the road to Orgrimmar.  You can ask one of the grunts there for directions to the Cooking Trainer.','Head north up the road to Orgrimmar.  You can ask one of the grunts there for directions to the Cooking Trainer.',26124),
(6575,'enUS','Mmmmm food.  It\'s not too long of a run, but you need to head north to Orgrimmar and ask one of the grunts there.','Mmmmm food.  It\'s not too long of a run, but you need to head north to Orgrimmar and ask one of the grunts there.',26124),
(6576,'enUS','There\'s one in Orgrimmar.  A grunt up there will know what directions to give you.  Just head north up the road here, you can\'t miss it.','There\'s one in Orgrimmar.  A grunt up there will know what directions to give you.  Just head north up the road here, you can\'t miss it.',26124),
(6577,'enUS','I don\'t know of one of those around here.  Your best bet is to go to Orgrimmar to the north and speak to one of their grunts.','I don\'t know of one of those around here.  Your best bet is to go to Orgrimmar to the north and speak to one of their grunts.',26124),
(6578,'enUS','There is an Engineering Trainer in Razor Hill.  He is called Mukdrak and can usually be found standing over near the forge.','There is an Engineering Trainer in Razor Hill.  He is called Mukdrak and can usually be found standing over near the forge.',26124),
(6579,'enUS','Bah, that\'s goblin work!  Still, we have an orc here in Razor Hill that will teach you of such things.  Look for Mukdrak over near the forge.','Bah, that\'s goblin work!  Still, we have an orc here in Razor Hill that will teach you of such things.  Look for Mukdrak over near the forge.',26124),
(6580,'enUS','There\'s one of those inside the barracks on the east side of Razor Hill.  Look for Rawrk.','There\'s one of those inside the barracks on the east side of Razor Hill.  Look for Rawrk.',26124),
(6581,'enUS','With all of the fighting we do of course we have a First Aid Trainer in Razor Hill.  Find Rawrk inside the barracks on the east side of town.','With all of the fighting we do of course we have a First Aid Trainer in Razor Hill.  Find Rawrk inside the barracks on the east side of town.',26124),
(6582,'enUS','I\'ve seen a troll named Lau\'Tiki fishing down south at the Darkspear Strand.  That\'s just on the outskirts of Sen\'jin Village.','I\'ve seen a troll named Lau\'Tiki fishing down south at the Darkspear Strand.  That\'s just on the outskirts of Sen\'jin Village.',26124),
(6583,'enUS','You\'re looking for Lau\'Tiki.  You\'ll find him on Darkspear Strand out beyond Sen\'jin Village to the south.','You\'re looking for Lau\'Tiki.  You\'ll find him on Darkspear Strand out beyond Sen\'jin Village to the south.',26124),
(6584,'enUS','You\'re looking for Mishiki.  She has a hut to the south in Sen\'jin Village.','You\'re looking for Mishiki.  She has a hut to the south in Sen\'jin Village.',26124),
(6585,'enUS','Flowers?  In this wasteland?  If anyone can teach you how to find them it will be Mishiki down in Sen\'jin Village to the south.','Flowers?  In this wasteland?  If anyone can teach you how to find them it will be Mishiki down in Sen\'jin Village to the south.',26124),
(6586,'enUS','','Spirits of Water, I give you praise, and I beg of you a favor. You have heard $n\'s pleas, and I trust $ghis:her; intent is noble. Please, will you aid us?',26124),
(6587,'enUS','You\'ll need to head to Orgrimmar for that.  Just follow the road heading out of Razor Hill to the north through the canyon and you\'ll come to it.  When you get there ask one of their grunts for further directions.','You\'ll need to head to Orgrimmar for that.  Just follow the road heading out of Razor Hill to the north through the canyon and you\'ll come to it.  When you get there ask one of their grunts for further directions.',26124),
(6588,'enUS','To learn to cure leather and work with hides go to Orgrimmar to the north.  One of the Orgrimmar Grunts will be able to tell you the way to the Leatherworking Trainer.','To learn to cure leather and work with hides go to Orgrimmar to the north.  One of the Orgrimmar Grunts will be able to tell you the way to the Leatherworking Trainer.',26124),
(6589,'enUS','Sure, sure.  We have a Mining Trainer right here in town.  Look for Krunn over in the northwest corner alongside the inn.','Sure, sure.  We have a Mining Trainer right here in town.  Look for Krunn over in the northwest corner alongside the inn.',26124),
(6590,'enUS','Plenty of good mining to be had in Durotar, or so I hear.  So good in fact that we have a Mining Trainer right here in Razor Hill.  You\'ll find Krunn next to the heated forge in the northwest corner of town.','Plenty of good mining to be had in Durotar, or so I hear.  So good in fact that we have a Mining Trainer right here in Razor Hill.  You\'ll find Krunn next to the heated forge in the northwest corner of town.',26124),
(6591,'enUS','There\'s a Skinning Trainer in Orgrimmar.  To get there head north up the road out of Razor Hill.  Ask an Orgrimmar Grunt for directions when you arrive.','There\'s a Skinning Trainer in Orgrimmar.  To get there head north up the road out of Razor Hill.  Ask an Orgrimmar Grunt for directions when you arrive.',26124),
(6592,'enUS','There\'s one in Orgrimmar.  Go north and talk to one of their grunts.','There\'s one in Orgrimmar.  Go north and talk to one of their grunts.',26124),
(6593,'enUS','Then Orgrimmar is where you need to go.  The north road out of Razor Hill leads directly there.  Just talk to one of the grunts there and they can give you further directions.','Then Orgrimmar is where you need to go.  The north road out of Razor Hill leads directly there.  Just talk to one of the grunts there and they can give you further directions.',26124),
(6594,'enUS','You can learn to sew up in Orgrimmar.  That\'s to the north.  Maybe one of the Orgrimmar Grunts can help you.','You can learn to sew up in Orgrimmar.  That\'s to the north.  Maybe one of the Orgrimmar Grunts can help you.',26124),
(6595,'enUS','Huh?  You\'ll find the bank in Orgrimmar.  Head north up the road to get there and then talk to one of their grunts.','Huh?  You\'ll find the bank in Orgrimmar.  Head north up the road to get there and then talk to one of their grunts.',26124),
(6596,'enUS','Yeah, I need to drop off some things myself.  Find it by heading north up the road to Orgrimmar and then ask one of the grunts there.','Yeah, I need to drop off some things myself.  Find it by heading north up the road to Orgrimmar and then ask one of the grunts there.',26124),
(6597,'enUS','You\'ll find the Wind Rider Master in Orgrimmar.  Go north up the road to get there and ask an Orgrimmar Grunt for further directions.','You\'ll find the Wind Rider Master in Orgrimmar.  Go north up the road to get there and ask an Orgrimmar Grunt for further directions.',26124),
(6598,'enUS','Can\'t you see I\'m busy here?  Go north up the road to Orgrimmar and ask one of the grunts there.  You can\'t miss it.','Can\'t you see I\'m busy here?  Go north up the road to Orgrimmar and ask one of the grunts there.  You can\'t miss it.',26124),
(6599,'enUS','','Thank you, great spirit. Thank you!',26124),
(6600,'enUS','I could use a drink and some rest myself.  You\'ll find it right in the northwest corner of Razor Hill.  Say hi to Innkeeper Grosk for me.','I could use a drink and some rest myself.  You\'ll find it right in the northwest corner of Razor Hill.  Say hi to Innkeeper Grosk for me.',26124),
(6601,'enUS','It\'s the big building in Razor Hill that\'s not the barracks.  Just talk to Innkeeper Grosk inside.  Got that?','It\'s the big building in Razor Hill that\'s not the barracks.  Just talk to Innkeeper Grosk inside.  Got that?',26124),
(6602,'enUS','Which trainer do you seek?','Which trainer do you seek?',26124),
(6603,'enUS','Hunter','Hunter',26124),
(6604,'enUS','Mage','Mage',26124),
(6605,'enUS','Priest','Priest',26124),
(6606,'enUS','Shaman','Shaman',26124),
(6607,'enUS','We have heard your requests, and we agree... it is noble in intent. We will purify your waters. Go with our blessing, shaman.','',26124),
(6608,'enUS','Rogue','Rogue',26124),
(6612,'enUS','%s wakes up!','',26124),
(6615,'enUS','Warlock','Warlock',26124),
(6616,'enUS','Warrior','Warrior',26124),
(6617,'enUS','Which profession?','Which profession?',26124),
(6618,'enUS','Alchemy','Alchemy',26124),
(6619,'enUS','Blacksmithing','Blacksmithing',26124),
(6620,'enUS','Cooking','Cooking',26124),
(6621,'enUS','Enchanting','Enchanting',26124),
(6622,'enUS','Engineering','Engineering',26124),
(6623,'enUS','First Aid','First Aid',26124),
(6624,'enUS','Fishing','Fishing',26124),
(6625,'enUS','Herbalism','Herbalism',26124),
(6626,'enUS','Leatherworking','Leatherworking',26124),
(6627,'enUS','Mining','Mining',26124),
(6628,'enUS','Skinning','Skinning',26124),
(6629,'enUS','Tailoring','Tailoring',26124),
(6630,'enUS','What are you looking for?','What are you looking for?',26124),
(6631,'enUS','Bank','Bank',26124),
(6632,'enUS','Flight Master','Flight Master',26124),
(6633,'enUS','Inn','Inn',26124),
(6634,'enUS','Class Trainer','Class Trainer',26124),
(6635,'enUS','Profession Trainer','Profession Trainer',26124),
(6636,'enUS','Lok\'tar!  You look like you need help.','Lok\'tar!  You look like you need help.',26124),
(6637,'enUS','What do you need?','What do you need?',26124),
(6638,'enUS','Make it fast.','Make it fast.',26124),
(6639,'enUS','Yes!?','Yes!?',26124),
(6640,'enUS','Can you help me with some directions?','Can you help me with some directions?',26124),
(6641,'enUS','','With the cauldrons breeched, we are now able to introduce the counter agent into the environment.  This should give the scourge a taste of their own medicine, as it were!$B$BCheck with Alchemist Arbington on information regarding the reagents needed to use in the cauldrons.  I will be handling all information reports on how we are doing overall in turning the plague against the Scourge!',26124),
(6642,'enUS','','With the cauldrons breeched, we are now able to introduce the counter agent into the environment.  This should give the scourge a taste of their own medicine, as it were!$B$BCheck with Apothecary Dithers on information regarding the reagents needed to use in the cauldrons.  I will be handling all information reports on how we are doing overall in turning the plague against the Scourge!',26124),
(6643,'enUS','Oh, I can see Liladris from here... Tell her I\'m here, won\'t you?','',26124),
(6644,'enUS','','Hello young $g Master:Mistress;. I am Eva Sarkhoff and this is my husband, Lucien. It is a pleasure to make your acquaintance.',26124),
(6645,'enUS','The pleasure is mine, madam. Might I ask what it is that you are doing here?','The pleasure is mine, madam. Might I ask what it is that you are doing here?',26124),
(6646,'enUS','','Certainly, $g sir:miss;. We were once servants of the house Barov: What is now known as the Scholomance.$B$BI was the head maid and Lucien was Master Barov\'s butler.$B$BWe had worked for the Barovs for decades, until...$B$B<Eva weeps.>',26124),
(6647,'enUS','Until what, Eva? I must know.','Until what, Eva? I must know.',26124),
(6648,'enUS','','Oh it\'s just so horrible, $g sir:miss;. The house Barov was once full of life... full of splendor. The manor was the Barov\'s primary residence amidst their far reaching empire.$B$BLucien and I noticed that as the days progressed, the Barovs became depressed. Despondent. Paranoia and rage often overcame the master and missus. At night, we could hear the Barovs arguing in their chambers. From what we understood, their greed had \'broken the dam,\' so to speak. ',26124),
(6649,'enUS','What do you mean?','What do you mean?',26124),
(6650,'enUS','','We suspect that in order to preserve their fortune and hold of the land - well past their lifespan - the Barovs made a deal with a powerful human mage named Kel\'Thuzad.$B$B<Eva shudders.>$B$BFrom this deal sprang the school of necromancy: A place which bore the Cult of the Damned and would become their capital.$B$BAs each week passed, the house Barov became more and more decrepit...$B$BDark beings began to take residence in the various wings of the house. Upkeep became impossible... and disgusting.',26124),
(6651,'enUS','Why didn\'t you just leave?','Why didn\'t you just leave?',26124),
(6652,'enUS','','And go where? It was all that we knew; all that we had known and all that we would ever know.$B$BEventually, we lost contact with the Barovs and ultimately, were separated from the household. We knew not what happened to the other servants, only that there were screams. Tortured screams.$B$BKnowing that we had nowhere to go, Lucien and I were forced to hide in our quarters. During the day, when the school was relatively quiet, Lucien would sneak out to scrounge up food and drink.',26124),
(6653,'enUS','So what happened?','So what happened?',26124),
(6654,'enUS','','We did this for about six months and watched as the house went through horrifying changes. Foul monsters roamed through the manor at will. Dark cultists populated every inch with various paraphernalia relating to rituals and sacrifices. We knew that we could not hide much longer.$B$BAs expected, we were found and captured. They stripped us of all our clothes and laid us out inside a circle of blood. We sat there for days, naked and terrified.',26124),
(6655,'enUS','No restraints? Just in a circle?','No restraints? Just in a circle?',26124),
(6656,'enUS','','Restraints? There are things in this world far more restraining than bars and shackles, young $g master:mistress;. The undead surrounded us, constantly tormenting us with horrifying acts of depravity.$B$BFinally, he came. He introduced himself as Doctor Theolen Krastinov. We came to know him as \'The Butcher.\'\n',26124),
(6657,'enUS','Tell me more.','Tell me more.',26124),
(6658,'enUS','','We finally understood what the screams were from. The Butcher exposed us to pain that we did not know existed. He used us in countless experiments, attempting to devise a plague.$B$BThe days turned to weeks. We would have died on the first day had it not been for that cruel monster keeping us alive through magical means.',26124),
(6659,'enUS','This is an atrocity.','This is an atrocity.',26124),
(6660,'enUS','','The Butcher would speak of \'the blood of innocents,\' and his dark master, \'Kirtonos.\' Of how he must appease his master.$B$BFinally, the beast was done with his experiments. We had been drained of all life. Our spirits shattered. The sweet embrace of death was upon us and we welcomed it with open arms. But in his infinite cruelty, the Butcher revived us from death\'s door.$B$BWe were to be kept alive and thrown to his ravenous ghouls. He laughed as he watched the fiends devour our flesh.',26124),
(6661,'enUS','I feel sick.','I feel sick.',26124),
(6662,'enUS','','We feel nothing. Our souls remain here, in limbo. We are unable to leave until our remains are found and spirits laid to rest.',26124),
(6663,'enUS','Ah, you must go to the great heights of Thunder Bluff to visit one of those.  Follow the path north out of Bloodhoof Village.  At the base of the bluffs is an elevator that will take you to the top.  When you get there ask for further directions from one of the Bluffwatchers.','Ah, you must go to the great heights of Thunder Bluff to visit one of those.  Follow the path north out of Bloodhoof Village.  At the base of the bluffs is an elevator that will take you to the top.  When you get there ask for further directions from one of the Bluffwatchers.',26124),
(6664,'enUS','How can I help?','How can I help?',26124),
(6665,'enUS','We have no such place in the village.  The soaring heights of Thunder Bluff does though.  Head north up the road out of Bloodhoof Village until you come to the base of the bluffs.  There ride the elevator to the top and speak with a Bluffwatcher.  May your ancestors watch over you.','We have no such place in the village.  The soaring heights of Thunder Bluff does though.  Head north up the road out of Bloodhoof Village until you come to the base of the bluffs.  There ride the elevator to the top and speak with a Bluffwatcher.  May your ancestors watch over you.',26124),
(6666,'enUS','There is a Wind Rider Master in the great city of Thunder Bluff to the north.  Ride the elevator from the base of Thunder Bluff to the top and ask one of the Bluffwatchers there for further instructions.','There is a Wind Rider Master in the great city of Thunder Bluff to the north.  Ride the elevator from the base of Thunder Bluff to the top and ask one of the Bluffwatchers there for further instructions.',26124),
(6667,'enUS','Nothing frees the spirit like soaring through the sky.  There is such a place in our great tribal center Thunder Bluff.  The road north out of Bloodhoof Village will guide you there.  Once you ride the elevator to the top speak with one of the Bluffwatchers who can give you further directions.','Nothing frees the spirit like soaring through the sky.  There is such a place in our great tribal center Thunder Bluff.  The road north out of Bloodhoof Village will guide you there.  Once you ride the elevator to the top speak with one of the Bluffwatchers who can give you further directions.',26124),
(6668,'enUS','Innkeeper Kauth can see to your needs.  He can be found on the west side of the village in one of the long houses.','Innkeeper Kauth can see to your needs.  He can be found on the west side of the village in one of the long houses.',26124),
(6669,'enUS','There is a time and a place for all things, including relaxation.  On the west side of Bloodhoof Village Innkeeper Kauth maintains a long house for those who seek to rest.  You will find him there.','There is a time and a place for all things, including relaxation.  On the west side of Bloodhoof Village Innkeeper Kauth maintains a long house for those who seek to rest.  You will find him there.',26124),
(6670,'enUS','It is Gennia Runetotem\'s counsel that you seek.  You will find her in the large tent on the east side of the village.','It is Gennia Runetotem\'s counsel that you seek.  You will find her in the large tent on the east side of the village.',26124),
(6671,'enUS','The way of the Druid is sibling to the Shaman.  Gennia Runetotem is steeped in such knowledge.  Seek her out in the large tent on the east side of Bloodhoof Village.','The way of the Druid is sibling to the Shaman.  Gennia Runetotem is steeped in such knowledge.  Seek her out in the large tent on the east side of Bloodhoof Village.',26124),
(6672,'enUS','Yaw Sharpmane awaits you on the north edge of the village.  He can teach you the ways of the Hunter.','Yaw Sharpmane awaits you on the north edge of the village.  He can teach you the ways of the Hunter.',26124),
(6673,'enUS','To learn to be one with Nature in the eyes of the Earth Mother, this is a matter of pride.  If your will is to learn the ways of the Hunter you must seek out Yaw Sharpmane at the north end of Bloodhoof Village.','To learn to be one with Nature in the eyes of the Earth Mother, this is a matter of pride.  If your will is to learn the ways of the Hunter you must seek out Yaw Sharpmane at the north end of Bloodhoof Village.',26124),
(6674,'enUS','There is a large tent on the east side of Bloodhoof Village.  You will find Narm Skychaser awaiting you there.','There is a large tent on the east side of Bloodhoof Village.  You will find Narm Skychaser awaiting you there.',26124),
(6675,'enUS','There is a wise one in the village who goes by the name Narm Skychaser.  He can continue your learning along the path of the Shaman.','There is a wise one in the village who goes by the name Narm Skychaser.  He can continue your learning along the path of the Shaman.',26124),
(6676,'enUS','Krang Stonehoof stands astride his training circle at the southeast corner of the village.','Krang Stonehoof stands astride his training circle at the southeast corner of the village.',26124),
(6677,'enUS','If it is the way of the Warrior that you crave then you must seek out Krang Stonehoof.  You will find him in the southeast corner of the village at his training circle, often instructing his other students.','If it is the way of the Warrior that you crave then you must seek out Krang Stonehoof.  You will find him in the southeast corner of the village at his training circle, often instructing his other students.',26124),
(6678,'enUS','While we have no Alchemy Trainer here in Bloodhoof Village, there is one in Thunder Bluff to the north.  Follow the road there and ask one of the Bluffwatchers for directions when you get to the top.','While we have no Alchemy Trainer here in Bloodhoof Village, there is one in Thunder Bluff to the north.  Follow the road there and ask one of the Bluffwatchers for directions when you get to the top.',26124),
(6679,'enUS','Using the fruits of the Earth Mother to create potions to aid us in our eternal struggle is an honorable endeavor.  To learn of this you must travel north to our great home of Thunder Bluff.  When you arrive at the top seek out the assistance of one of the Bluffwatchers for more specific directions.','Using the fruits of the Earth Mother to create potions to aid us in our eternal struggle is an honorable endeavor.  To learn of this you must travel north to our great home of Thunder Bluff.  When you arrive at the top seek out the assistance of one of the Bluffwatchers for more specific directions.',26124),
(6680,'enUS','There is a Blacksmithing Trainer in our great home Thunder Bluff to the north.  If you seek such knowledge then head there and ask one of the Bluffwatchers for directions.','There is a Blacksmithing Trainer in our great home Thunder Bluff to the north.  If you seek such knowledge then head there and ask one of the Bluffwatchers for directions.',26124),
(6681,'enUS','You desire to shape the bones of the Earth Mother into tools that will aid the Horde.  Good, good.  Follow the path north out of Bloodhoof Village until you come to the elevator leading to the top of Thunder Bluff.  A Bluffwatcher there can give you further assistance.','You desire to shape the bones of the Earth Mother into tools that will aid the Horde.  Good, good.  Follow the path north out of Bloodhoof Village until you come to the elevator leading to the top of Thunder Bluff.  A Bluffwatcher there can give you further assistance.',26124),
(6682,'enUS','You will find Pyall Silentstride inside the great tent in the northwest corner of the village.  He can teach you what you crave.','You will find Pyall Silentstride inside the great tent in the northwest corner of the village.  He can teach you what you crave.',26124),
(6683,'enUS','My mouth waters just to think on it.  Pyall Silentstride is the finest cook in Bloodhoof Village.  You will find him in the great tent at the northwest corner of the village.','My mouth waters just to think on it.  Pyall Silentstride is the finest cook in Bloodhoof Village.  You will find him in the great tent at the northwest corner of the village.',26124),
(6684,'enUS','Away to Thunder Bluff to the north is where your journey takes you then friend.  Once there seek out the wisdom of one of the Bluffwatchers who can tell you directly where to find whom you seek.','Away to Thunder Bluff to the north is where your journey takes you then friend.  Once there seek out the wisdom of one of the Bluffwatchers who can tell you directly where to find whom you seek.',26124),
(6685,'enUS','Such wisdom is steeped in a mystery that can only be found in great Thunder Bluff.  Follow the path north out of Bloodhoof Village until you come to an elevator at the base of the bluffs.  Ride it to the top and ask one of the Bluffwatchers for further assistance.','Such wisdom is steeped in a mystery that can only be found in great Thunder Bluff.  Follow the path north out of Bloodhoof Village until you come to an elevator at the base of the bluffs.  Ride it to the top and ask one of the Bluffwatchers for further assistance.',26124),
(6686,'enUS','Vira Younghoof keeps her practice inside the long house on the west side of the village.','Vira Younghoof keeps her practice inside the long house on the west side of the village.',26124),
(6687,'enUS','Bandages, anti-venoms and such things, these are the inevitable necessities of life on the plains.  Vira Younghoof can teach you this knowledge.  You can find her in the long house on the west side of Bloodhoof Village.','Bandages, anti-venoms and such things, these are the inevitable necessities of life on the plains.  Vira Younghoof can teach you this knowledge.  You can find her in the long house on the west side of Bloodhoof Village.',26124),
(6688,'enUS','You are looking for Uthan Stillwater.  You will find him west of the village, fishing at Stonebull Lake.','You are looking for Uthan Stillwater.  You will find him west of the village, fishing at Stonebull Lake.',26124),
(6689,'enUS','Give a bull a fish and feed him for a day.  Teach a bull to fish and feed him for life.  Uthan Stillwater can teach you how to fish.  Seek his wisdom west of Bloodhoof Village along the banks of Stonebull Lake.','Give a bull a fish and feed him for a day.  Teach a bull to fish and feed him for life.  Uthan Stillwater can teach you how to fish.  Seek his wisdom west of Bloodhoof Village along the banks of Stonebull Lake.',26124),
(6690,'enUS','If you desire to learn the ways of Herbalism then it is to Thunder Bluff that you must go.  Follow the road north out of Bloodhoof Village and take the elevator to the top of the rise.  You can ask a Bluffwatcher there for further assistance.','If you desire to learn the ways of Herbalism then it is to Thunder Bluff that you must go.  Follow the road north out of Bloodhoof Village and take the elevator to the top of the rise.  You can ask a Bluffwatcher there for further assistance.',26124),
(6691,'enUS','There are those that would teach you of Herbalism in the great home of Thunder Bluff away to the north.  Follow the road out of the village to get there and at the base of the bluff ride the elevator to the top of the rise.  There are many Bluffwatchers there who can direct you further.','There are those that would teach you of Herbalism in the great home of Thunder Bluff away to the north.  Follow the road out of the village to get there and at the base of the bluff ride the elevator to the top of the rise.  There are many Bluffwatchers there who can direct you further.',26124),
(6692,'enUS','Inside the great tent at the northwest corner of the village is where Chaw Stronghide resides.  He will teach you what you must know of Leatherworking for now.','Inside the great tent at the northwest corner of the village is where Chaw Stronghide resides.  He will teach you what you must know of Leatherworking for now.',26124),
(6693,'enUS','When we use the hides of the animals we must fell for food or protection we give honor to the Earth Mother and respect to the animal.  Chaw Stronghide can teach you of such things.  You will find him in the great tent at the northwest corner of Bloodhoof Village.','When we use the hides of the animals we must fell for food or protection we give honor to the Earth Mother and respect to the animal.  Chaw Stronghide can teach you of such things.  You will find him in the great tent at the northwest corner of Bloodhoof Village.',26124),
(6694,'enUS','Hmmm, I think you will need to go up to Thunder Bluff to learn that.  Head north on the road out of Bloodhoof Village.  It will take you to the base of Thunder Bluff.  Ride the elevator to the top and you should be able to ask any of the Bluffwatchers there for further assistance.','Hmmm, I think you will need to go up to Thunder Bluff to learn that.  Head north on the road out of Bloodhoof Village.  It will take you to the base of Thunder Bluff.  Ride the elevator to the top and you should be able to ask any of the Bluffwatchers there for further assistance.',26124),
(6695,'enUS','I hear that they have a Mining Trainer in Thunder Bluff to the north.  Take the road out of the village and when you get there ride the elevator to the top of the rise.  Any of the Bluffwatchers should be able to help you from there.','I hear that they have a Mining Trainer in Thunder Bluff to the north.  Take the road out of the village and when you get there ride the elevator to the top of the rise.  Any of the Bluffwatchers should be able to help you from there.',26124),
(6696,'enUS','Yonn Deepcut can be found inside the great tent at the northwest corner of Bloodhoof Village.','Yonn Deepcut can be found inside the great tent at the northwest corner of Bloodhoof Village.',26124),
(6697,'enUS','Ah yes, Skinning.  There is no one finer in wielding a skinning knife than Yonn Deepcut.  You can find him in the great tent at the northwest corner of the village.','Ah yes, Skinning.  There is no one finer in wielding a skinning knife than Yonn Deepcut.  You can find him in the great tent at the northwest corner of the village.',26124),
(6698,'enUS','Unfortunately we do not have one who teaches Tailoring here in Bloodhoof Village, but you can find a trainer in Thunder Bluff.  Follow the path north out of the village until you come to a set of elevators.  Take one up to the top of the rise and ask one of the Bluffwatchers there for directions.','Unfortunately we do not have one who teaches Tailoring here in Bloodhoof Village, but you can find a trainer in Thunder Bluff.  Follow the path north out of the village until you come to a set of elevators.  Take one up to the top of the rise and ask one of the Bluffwatchers there for directions.',26124),
(6699,'enUS','Tailoring you say?  Hmmm.  Ah yes, of course.  You\'ll need to head to Thunder Bluff, up north.  Take the path out of the village to get there.  When you arrive at the base of the bluffs ride the elevator to the top of the rise and speak with one of the Bluffwatchers.','Tailoring you say?  Hmmm.  Ah yes, of course.  You\'ll need to head to Thunder Bluff, up north.  Take the path out of the village to get there.  When you arrive at the base of the bluffs ride the elevator to the top of the rise and speak with one of the Bluffwatchers.',26124),
(6700,'enUS','Which trainer do you seek?','Which trainer do you seek?',26124),
(6701,'enUS','Druid','Druid',26124),
(6702,'enUS','Hunter','Hunter',26124),
(6703,'enUS','Shaman','Shaman',26124),
(6704,'enUS','Warrior','Warrior',26124),
(6705,'enUS','Which profession?','Which profession?',26124),
(6706,'enUS','Alchemy','Alchemy',26124),
(6707,'enUS','Blacksmithing','Blacksmithing',26124),
(6708,'enUS','Cooking','Cooking',26124),
(6709,'enUS','Enchanting','Enchanting',26124),
(6710,'enUS','First Aid','First Aid',26124),
(6711,'enUS','Fishing','Fishing',26124),
(6712,'enUS','Herbalism','Herbalism',26124),
(6713,'enUS','Leatherworking','Leatherworking',26124),
(6714,'enUS','Mining','Mining',26124),
(6715,'enUS','The doctor is in!','',26124),
(6716,'enUS','Skinning','Skinning',26124),
(6717,'enUS','Tailoring','Tailoring',26124),
(6718,'enUS','What are you looking for?','What are you looking for?',26124),
(6719,'enUS','The bank','The bank',26124),
(6720,'enUS','The wind rider master','The wind rider master',26124),
(6721,'enUS','The inn','The inn',26124),
(6722,'enUS','A class trainer','A class trainer',26124),
(6723,'enUS','A profession trainer','A profession trainer',26124),
(6724,'enUS','Blessings of the Earth Mother upon you.','Blessings of the Earth Mother upon you.',26124),
(6725,'enUS','You look lost.  I can help.','You look lost.  I can help.',26124),
(6726,'enUS','Do you need something?','Do you need something?',26124),
(6727,'enUS','Yes?','Yes?',26124),
(6728,'enUS','Can you help me with some directions?','Can you help me with some directions?',26124),
(6729,'enUS','We don\'t have a bank here in Brill, you\'ll have to go to the Undercity for that.  At the back of the Ruins of Lordaeron to the south are elevators that will take you down into the Undercity.  Once there, ask one of the Undercity Guardians for more precise directions.','We don\'t have a bank here in Brill, you\'ll have to go to the Undercity for that.  At the back of the Ruins of Lordaeron to the south are elevators that will take you down into the Undercity.  Once there, ask one of the Undercity Guardians for more precise directions.',26124),
(6730,'enUS','What could you possibly need a bank for?  Very well, you\'ll need to go through the Ruins of Lordaeron to the south of Brill.  In the back are a set of elevators leading down into the Undercity.  When you get there stop any of those lumbering Abominations they like to call an Undercity Guardian and ask it for better directions.','What could you possibly need a bank for?  Very well, you\'ll need to go through the Ruins of Lordaeron to the south of Brill.  In the back are a set of elevators leading down into the Undercity.  When you get there stop any of those lumbering Abominations they like to call an Undercity Guardian and ask it for better directions.',26124),
(6731,'enUS','There\'s a Bat Handler inside the Undercity.  Head south down the road out of Brill, then west at the T-intersection.  The Ruins of Lordaeron will be on your left.  Go into them and then down into the Undercity.  You can ask an Undercity Guardian there for further assistance.','There\'s a Bat Handler inside the Undercity.  Head south down the road out of Brill, then west at the T-intersection.  The Ruins of Lordaeron will be on your left.  Go into them and then down into the Undercity.  You can ask an Undercity Guardian there for further assistance.',26124),
(6732,'enUS','Somewhere to fly to?  You\'ll need to go to the Undercity for that!  Go south on the road out of town, then southwest to the Ruins of Lordaeron.  You can catch the elevator down to the Undercity from the back of the ruins and once there ask an Undercity Guardian for more specific directions.','Somewhere to fly to?  You\'ll need to go to the Undercity for that!  Go south on the road out of town, then southwest to the Ruins of Lordaeron.  You can catch the elevator down to the Undercity from the back of the ruins and once there ask an Undercity Guardian for more specific directions.',26124),
(6733,'enUS','You\'ll find Innkeeper Renee inside the Gallows\' End Tavern at the southeast end of the street running through town.','You\'ll find Innkeeper Renee inside the Gallows\' End Tavern at the southeast end of the street running through town.',26124),
(6734,'enUS','Now if I were Innkeeper Renee where might I be?  Hmmm?  Oh, perhaps inside the Gallows\' End Tavern.  Yes, that\'s it, I\'m sure of it.  Try the southeast end of Brill... think you can find that?','Now if I were Innkeeper Renee where might I be?  Hmmm?  Oh, perhaps inside the Gallows\' End Tavern.  Yes, that\'s it, I\'m sure of it.  Try the southeast end of Brill... think you can find that?',26124),
(6735,'enUS','You\'ll find the Mage Trainer, Cain Firesong, upstairs on the landing at the Gallows\' End Tavern, which is on the southeast end of Brill.  I guess he checked in too late to get a room.','You\'ll find the Mage Trainer, Cain Firesong, upstairs on the landing at the Gallows\' End Tavern, which is on the southeast end of Brill.  I guess he checked in too late to get a room.',26124),
(6736,'enUS','Do I look to you like I cast spells?  Well, I did hear that Cain Firesong was hanging out on the upstairs landing of the Gallows\' End Tavern at the southeast end of town.  Odd how he just stands there outside of Gretchen\'s room like that.','Do I look to you like I cast spells?  Well, I did hear that Cain Firesong was hanging out on the upstairs landing of the Gallows\' End Tavern at the southeast end of town.  Odd how he just stands there outside of Gretchen\'s room like that.',26124),
(6737,'enUS','At the southeast edge of town is the Gallows\' End Tavern.  Go there and head upstairs, and you\'ll find Dark Cleric Beryl inside the reading room.','At the southeast edge of town is the Gallows\' End Tavern.  Go there and head upstairs, and you\'ll find Dark Cleric Beryl inside the reading room.',26124),
(6738,'enUS','Ah, you seek Dark Cleric Beryl.  He\'s upstairs in the reading room at the Gallows\' End Tavern.  Reading, praying, who knows what he\'s up to, and who would dare to ask?','Ah, you seek Dark Cleric Beryl.  He\'s upstairs in the reading room at the Gallows\' End Tavern.  Reading, praying, who knows what he\'s up to, and who would dare to ask?',26124),
(6739,'enUS','The Rogue Trainer\'s name is Marion Call.  You can find her upstairs in the reading room at the Gallows\' End Tavern at the town\'s southeast edge.','The Rogue Trainer\'s name is Marion Call.  You can find her upstairs in the reading room at the Gallows\' End Tavern at the town\'s southeast edge.',26124),
(6740,'enUS','Marion Call is keeping Dark Cleric Beryl company in the reading room upstairs at the Gallows\' End Tavern on the southeast edge of Brill.  I\'m just dying to see who wins that staring contest.','Marion Call is keeping Dark Cleric Beryl company in the reading room upstairs at the Gallows\' End Tavern on the southeast edge of Brill.  I\'m just dying to see who wins that staring contest.',26124),
(6741,'enUS','Rupert Boch is his name.  I hear that he\'s upstairs in one of the rooms at the Gallows\' End Tavern on the southeast end of town.','Rupert Boch is his name.  I hear that he\'s upstairs in one of the rooms at the Gallows\' End Tavern on the southeast end of town.',26124),
(6742,'enUS','That\'s Rupert Boch you\'re looking for.  He and his entourage have a room upstairs at the Gallows\' End Tavern on the southeast end of Brill.','That\'s Rupert Boch you\'re looking for.  He and his entourage have a room upstairs at the Gallows\' End Tavern on the southeast end of Brill.',26124),
(6743,'enUS','Look inside the Gallows\' End Tavern\'s main dining room for Austil de Mon.  The tavern is on the southeast edge of Brill.','Look inside the Gallows\' End Tavern\'s main dining room for Austil de Mon.  The tavern is on the southeast edge of Brill.',26124),
(6744,'enUS','Yeah, that would be Austil de Mon.  He\'s always hanging out in the tavern at the southeast end of town.  It\'s called the Gallows\' End Tavern, you can\'t miss it.','Yeah, that would be Austil de Mon.  He\'s always hanging out in the tavern at the southeast end of town.  It\'s called the Gallows\' End Tavern, you can\'t miss it.',26124),
(6745,'enUS','Our Alchemist\'s name is Carolai Anise.  You\'ll find her in a house at the northwest end of Brill.','Our Alchemist\'s name is Carolai Anise.  You\'ll find her in a house at the northwest end of Brill.',26124),
(6746,'enUS','You\'ll find Carolai Anise trying to blow up her house at the northwest end of town.  Why don\'t you go see if you can help her?','You\'ll find Carolai Anise trying to blow up her house at the northwest end of town.  Why don\'t you go see if you can help her?',26124),
(6747,'enUS','Sorry friend, we don\'t have one of those here in Brill.  You\'ll have to head to the Undercity for that.  The Undercity is underneath the Ruins of Lordaeron to the south of Brill.  From the back of the ruins take the elevator down and then speak to one of the Undercity Guardians to find your way further.','Sorry friend, we don\'t have one of those here in Brill.  You\'ll have to head to the Undercity for that.  The Undercity is underneath the Ruins of Lordaeron to the south of Brill.  From the back of the ruins take the elevator down and then speak to one of the Undercity Guardians to find your way further.',26124),
(6748,'enUS','Blacksmith?  Nope, our last one turned back into one of those mindless Scourge.  There\'s one in the Undercity though to the south of town though.  Undercity is underneath the Ruins of Lordaeron, clever name, huh?  Just take the elevators down at the back of the ruins and then you can talk to one of the Undercity Guardians.  They should be able to point you in the right direction.','Blacksmith?  Nope, our last one turned back into one of those mindless Scourge.  There\'s one in the Undercity though to the south of town though.  Undercity is underneath the Ruins of Lordaeron, clever name, huh?  Just take the elevators down at the back of the ruins and then you can talk to one of the Undercity Guardians.  They should be able to point you in the right direction.',26124),
(6749,'enUS','Fancy yourself a chef?  Head to the Undercity south of town for your training.  You can catch the elevators heading down at the back of the Ruins of Lordaeron.  Talk to one of those lumbering Undercity Guardians for further assistance once you arrive.','Fancy yourself a chef?  Head to the Undercity south of town for your training.  You can catch the elevators heading down at the back of the Ruins of Lordaeron.  Talk to one of those lumbering Undercity Guardians for further assistance once you arrive.',26124),
(6750,'enUS','Why cook when everything tastes like ashes in your mouth?  If you have one still that is.  Very well, head to the Undercity south of Brill and ask an Undercity Guardian there for further directions to their Cooking Trainer.  To get there you can take the elevators down from the rear of the Ruins of Lordaeron.','Why cook when everything tastes like ashes in your mouth?  If you have one still that is.  Very well, head to the Undercity south of Brill and ask an Undercity Guardian there for further directions to their Cooking Trainer.  To get there you can take the elevators down from the rear of the Ruins of Lordaeron.',26124),
(6751,'enUS','You can find Vance Undergloom upstairs in a room at the Gallows\' End Tavern on the southeast side of Brill.','You can find Vance Undergloom upstairs in a room at the Gallows\' End Tavern on the southeast side of Brill.',26124),
(6752,'enUS','Word is that Vance Undergloom has taken a permanent room upstairs at the Gallows\' End Tavern at the southeast end of town.  I think he\'s just off the reading room.','Word is that Vance Undergloom has taken a permanent room upstairs at the Gallows\' End Tavern at the southeast end of town.  I think he\'s just off the reading room.',26124),
(6753,'enUS','While there\'s no Engineering Trainer in Brill, there is one down in the Undercity.  To get there head to the back of the Ruins of Lordaeron to the south of town and take the elevator down.  Once you get there ask an Undercity Guardian for more specific directions.','While there\'s no Engineering Trainer in Brill, there is one down in the Undercity.  To get there head to the back of the Ruins of Lordaeron to the south of town and take the elevator down.  Once you get there ask an Undercity Guardian for more specific directions.',26124),
(6754,'enUS','Rifles, dynamite, bombs, exploding sheep... what\'s not to love?  To learn how to make these and many other exciting tools of the trade head to the Undercity, under the Ruins of Lordaeron to the south of Brill.  Take the elevators down at the back of the ruins.  Once you arrive speak to one of the Undercity Guardians about where the trainer is exactly.','Rifles, dynamite, bombs, exploding sheep... what\'s not to love?  To learn how to make these and many other exciting tools of the trade head to the Undercity, under the Ruins of Lordaeron to the south of Brill.  Take the elevators down at the back of the ruins.  Once you arrive speak to one of the Undercity Guardians about where the trainer is exactly.',26124),
(6755,'enUS','Nurse Neela greets all of her future customers as they enter the Gallows\' End Tavern at the southeast end of town.','Nurse Neela greets all of her future customers as they enter the Gallows\' End Tavern at the southeast end of town.',26124),
(6756,'enUS','Butcher you say?  Oh, First Aid Trainer!  Same thing.  When you see Nurse Neela standing just inside the Gallows\' End Tavern on the southeast side of town you\'ll know why.','Butcher you say?  Oh, First Aid Trainer!  Same thing.  When you see Nurse Neela standing just inside the Gallows\' End Tavern on the southeast side of town you\'ll know why.',26124),
(6757,'enUS','Clyde Kellen, the local bass master, has his favorite fishing spot just east of Brill at Brightwater Lake.','Clyde Kellen, the local bass master, has his favorite fishing spot just east of Brill at Brightwater Lake.',26124),
(6758,'enUS','Yeah, you\'ll always find Clyde Kellen fishing on the bank of Brightwater Lake just east of Brill.  Just watch out for psychos wearing masks while you\'re out there.  We had to shut down the kids\' summer camp last year.','Yeah, you\'ll always find Clyde Kellen fishing on the bank of Brightwater Lake just east of Brill.  Just watch out for psychos wearing masks while you\'re out there.  We had to shut down the kids\' summer camp last year.',26124),
(6759,'enUS','Look for Faruza.  Last I saw she was standing out front between the stables and the house on the northwest end of town.','Look for Faruza.  Last I saw she was standing out front between the stables and the house on the northwest end of town.',26124),
(6760,'enUS','Actually I prefer traditional medicines... leeches, maggots, bonesaws... that sort of thing.  Well to each their own.  You can find the our local Herbalism Trainer, Faruza, standing out front near the stables in Brill.','Actually I prefer traditional medicines... leeches, maggots, bonesaws... that sort of thing.  Well to each their own.  You can find the our local Herbalism Trainer, Faruza, standing out front near the stables in Brill.',26124),
(6761,'enUS','That would be Shelene Rhobart.  Take the road southeast out of Brill then head east at the intersection.  She\'s at a camp along the side of the road.','That would be Shelene Rhobart.  Take the road southeast out of Brill then head east at the intersection.  She\'s at a camp along the side of the road.',26124),
(6762,'enUS','Nothing quite like the feel of something dead rubbing up against you.  You can find Shelene Rhobart by heading southeast on the road out of town, and then going east at the intersection.  She\'s at a small camp there not too far along the road.','Nothing quite like the feel of something dead rubbing up against you.  You can find Shelene Rhobart by heading southeast on the road out of town, and then going east at the intersection.  She\'s at a small camp there not too far along the road.',26124),
(6763,'enUS','I hear that they have a Mining Trainer in the Undercity.  All you have to do to get there is head south out of town and go to the back of the Ruins of Lordaeron.  Then take the elevator down into the Undercity itself and ask an Undercity Guardian for further directions.','I hear that they have a Mining Trainer in the Undercity.  All you have to do to get there is head south out of town and go to the back of the Ruins of Lordaeron.  Then take the elevator down into the Undercity itself and ask an Undercity Guardian for further directions.',26124),
(6764,'enUS','I guess your first exercise is going to be to mine your way down to the Undercity.  Heh, get it?  Mine... nevermind.  To get to the Undercity go to the rear of the Ruins of Lordaeron south of Brill, and take the elevator down.  Ask one of the Undercity Guardians there for further assistance.','I guess your first exercise is going to be to mine your way down to the Undercity.  Heh, get it?  Mine... nevermind.  To get to the Undercity go to the rear of the Ruins of Lordaeron south of Brill, and take the elevator down.  Ask one of the Undercity Guardians there for further assistance.',26124),
(6765,'enUS','Rand Rhobart is fairly good at skinning felbats and the like.  You can find him at a camp along the road to the southeast of Brill.  Take the road southeast out of town and then head east at the intersection.','Rand Rhobart is fairly good at skinning felbats and the like.  You can find him at a camp along the road to the southeast of Brill.  Take the road southeast out of town and then head east at the intersection.',26124),
(6766,'enUS','You aiming to be a taxidermist?  I don\'t like people who think they can stuff and mount me because they think I\'m dead.  No?  Good!  Look for Rand Rhobart at a camp to the southeast of town.  To get to him take the road southeast out of Brill and hang a left at the intersection.','You aiming to be a taxidermist?  I don\'t like people who think they can stuff and mount me because they think I\'m dead.  No?  Good!  Look for Rand Rhobart at a camp to the southeast of town.  To get to him take the road southeast out of Brill and hang a left at the intersection.',26124),
(6767,'enUS','It is Bowen Brisboise that you seek then.  You\'ll find him inside his house southwest of Brill just on the other side of the bridge at Cold Hearth Manor.','It is Bowen Brisboise that you seek then.  You\'ll find him inside his house southwest of Brill just on the other side of the bridge at Cold Hearth Manor.',26124),
(6768,'enUS','Black, grey and dark purple are the prescribed colors.  See to it that you don\'t stray onto the wrong side of fashion street friend.  Bowen Brisboise can help to see that you don\'t.  You\'ll find him inside Cold Hearth Manor on the other side of the bridge to the southwest of town.','Black, grey and dark purple are the prescribed colors.  See to it that you don\'t stray onto the wrong side of fashion street friend.  Bowen Brisboise can help to see that you don\'t.  You\'ll find him inside Cold Hearth Manor on the other side of the bridge to the southwest of town.',26124),
(6769,'enUS','Which trainer do you seek?','Which trainer do you seek?',26124),
(6770,'enUS','Mage','Mage',26124),
(6771,'enUS','Priest','Priest',26124),
(6772,'enUS','Rogue','Rogue',26124),
(6773,'enUS','Warlock','Warlock',26124),
(6774,'enUS','Warrior','Warrior',26124),
(6775,'enUS','Which profession?','Which profession?',26124),
(6776,'enUS','Alchemy','Alchemy',26124),
(6777,'enUS','Blacksmithing','Blacksmithing',26124),
(6778,'enUS','Cooking','Cooking',26124),
(6779,'enUS','Enchanting','Enchanting',26124),
(6780,'enUS','Engineering','Engineering',26124),
(6781,'enUS','First Aid','First Aid',26124),
(6782,'enUS','Fishing','Fishing',26124),
(6783,'enUS','Herbalism','Herbalism',26124),
(6784,'enUS','Leatherworking','Leatherworking',26124),
(6785,'enUS','Mining','Mining',26124),
(6786,'enUS','Skinning','Skinning',26124),
(6787,'enUS','Tailoring','Tailoring',26124),
(6788,'enUS','What are you looking for?','What are you looking for?',26124),
(6789,'enUS','The bank','The bank',26124),
(6790,'enUS','The bat handler','The bat handler',26124),
(6791,'enUS','The inn','The inn',26124),
(6792,'enUS','A class trainer','A class trainer',26124),
(6793,'enUS','A profession trainer','A profession trainer',26124),
(6794,'enUS','You look like you\'re lost.','You look like you\'re lost.',26124),
(6795,'enUS','Yes?','Yes?',26124),
(6796,'enUS','What is it?','What is it?',26124),
(6797,'enUS','Do I look like a guide to you?  Fine, what do you need?','Do I look like a guide to you?  Fine, what do you need?',26124),
(6798,'enUS','Can you help me with some directions?','Can you help me with some directions?',26124),
(6799,'enUS','Eva, I have lost the Spectral Essence. I need another.','Eva, I have lost the Spectral Essence. I need another.',26124),
(6800,'enUS','','So cold... and hungry.$B$BMy poor friend, I hope you\'ve found peace. I can\'t stand to think about what they could have done to you.$B$BYou! You there! Please, you have to help me escape. One of them has a key, can you find it? I know they have it. If you get it, you can help me get out of here. Trey is probably already dead, but there\'s still time! Please, can you help me?',26124),
(6801,'enUS','','You will not stop me from escaping here, $r!',26124),
(6802,'enUS','','You kept me in that cell for too long, monster!',26124),
(6803,'enUS','','You will pay for what you\'ve done to Trey!',26124),
(6804,'enUS','','You\'ve already done me a great service, $n. For that I thank you.$B$BThe least I can do now is tell you what brought me here: My long time friend Trey Lightforge and I came to Jaedenar to investigate the Shadow Council when they caught us unprepared. They took Trey deeper into Shadow Hold and put me in here after taking all of our equipment... I can still hear his screams from below, $n. They were... inhuman. I don\'t know what they\'ve done to him, but they will pay for it. ',26124),
(6805,'enUS','','As you inspect the cage and the Night elf inside, you get an odd sense of deja vu. For some reason she does not make eye contact with you--it is almost as if you are not there to her.',26124),
(6806,'enUS','','Ready. Set. GO!',26124),
(6807,'enUS','','HEY! No fair!',26124),
(6808,'enUS','','I win!!',26124),
(6809,'enUS','','Wanna race again? Best two out of three!',26124),
(6810,'enUS','','You cheated!',26124),
(6811,'enUS','%s looks very sleepy...','',26124),
(6812,'enUS','looks very sleepy...','',26124),
(6813,'enUS','This looks like the perfect place for a nap...','',26124),
(6814,'enUS','','',26124),
(6815,'enUS','','',26124),
(6816,'enUS','They don\'t realize that they\'re dead, $r. They are cursed to relive the last memory they had before the town was eaten alive from the inside out. Most of them, anyway. Some were less fortunate.$B$BYou thought the Scourge did this? The Scourge did not yet exist and if they had, we would have at least put up a damned fight.$B$BNo, this was the result of a plague that came out of Scholomance and ravaged the town. It was horrifying and devastating. None survived.$B$BNow leave me to my sorrows.','',26124),
(6817,'enUS','Can\'t you see we\'re trying to prepare for Uther\'s visit? Now get out of my way, I have much work to do!','Can\'t you see we\'re trying to prepare for Uther\'s visit? Now get out of my way, I have much work to do!',26124),
(6818,'enUS','Have you tried our bread? Baker Masterson must be the most gifted chef to have ever lived!','Have you tried our bread? Baker Masterson must be the most gifted chef to have ever lived!',26124),
(6819,'enUS','Welcome to Caer Darrow, stranger.','Welcome to Caer Darrow, stranger.',26124),
(6820,'enUS','We\'re not really rude people, stranger, it\'s just that everyone is in a rush, trying to make sure that everything is perfect for Uther\'s arrival. It\'s not often that the Lightbringer comes to town.','We\'re not really rude people, stranger, it\'s just that everyone is in a rush, trying to make sure that everything is perfect for Uther\'s arrival. It\'s not often that the Lightbringer comes to town.',26124),
(6821,'enUS','Another lovely day on our beautiful island.','Another lovely day on our beautiful island.',26124),
(6822,'enUS','Watch your step, stranger. We do not allow miscreants in our town.','Watch your step, stranger. We do not allow miscreants in our town.',26124),
(6823,'enUS','I\'ve got my eye on you, $r.','I\'ve got my eye on you, $r.',26124),
(6824,'enUS','I have a lot of pent up anger and hostility. Just give me a reason, guttersnipe.','I have a lot of pent up anger and hostility. Just give me a reason, guttersnipe.',26124),
(6825,'enUS','Why, you look like a common street urchin!','Why, you look like a common street urchin!',26124),
(6826,'enUS','There\'s no loitering, pan handling, cursing, fighting, or anything else you\'re thinking about doing, allowed in Caer Darrow.','There\'s no loitering, pan handling, cursing, fighting, or anything else you\'re thinking about doing, allowed in Caer Darrow.',26124),
(6827,'enUS','Hail the Lich King!','',26124),
(6828,'enUS','Your soul is doomed!','',26124),
(6829,'enUS','Join us, or fall forever!','',26124),
(6830,'enUS','There is no hope!','',26124),
(6831,'enUS','Our master wants you!','',26124),
(6832,'enUS','Darrowshire will fall!','',26124),
(6833,'enUS','Scourge will prevail!','',26124),
(6834,'enUS','All hope is lost!','',26124),
(6835,'enUS','We must not give up!','We must not give up!',26124),
(6836,'enUS','Fight!  Fight for Darrowshire!','Fight!  Fight for Darrowshire!',26124),
(6837,'enUS','Our captain has fallen!','Our captain has fallen!',26124),
(6838,'enUS','The Alliance has abandoned us!','The Alliance has abandoned us!',26124),
(6839,'enUS','Where is the Silver Hand?  We need their help!','Where is the Silver Hand?  We need their help!',26124),
(6840,'enUS','Fight for your families!  Don\'t give up!','Fight for your families!  Don\'t give up!',26124),
(6841,'enUS','If we fall, then Darrowshire is doomed!','If we fall, then Darrowshire is doomed!',26124),
(6842,'enUS','We must stop these villains!','We must stop these villains!',26124),
(6843,'enUS','The Cult of the Damned has grown large in scope. Nearly every city, from the capitals to the small hamlets and hovels of both the Horde and Alliance, have Cult members hidden amongst their citizenry.$B$BDo not look so surprised. The Cult only wears a uniform for ritual and ceremony. It is quite possible that you have interacted with one during your adventures and not even known.','',26124),
(6844,'enUS','Impossible.','Impossible.',26124),
(6845,'enUS','Is it? This has always been their method of operation. What is of greater value to Kel\'Thuzad and the ever growing Scourge army? A zealous, living, follower that can work their way into a society and then unleash a plague, destroying thousands; or a single undead trooper? Certainly you cannot be that dense$B$BYes, $r, they live, work, and plot among you.','',26124),
(6846,'enUS','This is disheartening. Is there anything I can do to stop this?','This is disheartening. Is there anything I can do to stop this?',26124),
(6847,'enUS','Stop - no. Slow down - maybe.$B$BThe Scholomance is their primary source of training and education. It is from there that the Cult members fan out and ultimately, make their way into our societies.$B$BThat is why we must strike at the source. The very heart of the Cult of the Damned!','',26124),
(6848,'enUS','Who do I need to kill?','Who do I need to kill?',26124),
(6849,'enUS','Slow down, $r. The one you need to kill is already dead. Killing him again will serve no purpose. There are very few ways in which a lich can actually be destroyed and none of those means are available to you or I. That is why I have a plan. A plan that will have a very noticeable and real impact upon the Cult.','',26124),
(6850,'enUS','What is this plan?','What is this plan?',26124),
(6851,'enUS','It\'s simple, really. Rob the lich, Ras Frostwhisper, of his powers. Return him to his mortal form and then slay him, once and for all.','',26124),
(6852,'enUS','Ras Frostwhat? Who is that?','Ras Frostwhat? Who is that?',26124),
(6853,'enUS','Ah, I suppose that I am getting ahead of myself. Ras Frostwhisper is the overseer of this school. The being responsible for training all of its Dark Masters. A lieutenant and favored pupil of Kel\'Thuzad. He was once a hedge mage of Stromgarde: A rogue wizard that never received his formal training from Dalaran.$B$BWhen Kel\'Thuzad opened the Cult, Ras was among the first to join his ranks. Ras knew that through dark magic, he would find immortality.','',26124),
(6854,'enUS','Continue, please.\n','Continue, please.\n',26124),
(6855,'enUS','And find it he did. After quickly advancing through the ranks of the Cult, the Lich King himself granted Ras immortality. Thus was born Ras Frostwhisper, the lich.$B$BNow do you understand?','',26124),
(6856,'enUS','Yes I do.','Yes I do.',26124),
(6857,'enUS','Good. In order to carry out my plan, we must first create a lifestone. Are you prepared to act?','',26124),
(6858,'enUS','Yes I am.','Yes I am.',26124),
(6859,'enUS','Some were spared the anguish that memories provide.','',26124),
(6860,'enUS','Tell me about the Cult of the Damned.','Tell me about the Cult of the Damned.',26124),
(6861,'enUS','You must save us!','You must save us!',26124),
(6862,'enUS','','I am sorry. I am unable to help you at this time.',26124),
(6863,'enUS','The Barov house sure does keep me busy. Always some sort of refuse coming out of there.','',26124),
(6864,'enUS','My job title is Waste Management Specialist.','',26124),
(6865,'enUS','Perhaps you should speak into these sound enhancing devices attached to my FISTS OF FURY.','',26124),
(6866,'enUS','Ah, my sweet Brandy, I miss her so!','',26124),
(6867,'enUS','Be on the alert! The Blackwood furbolgs are numerous in this area...','',26124),
(6868,'enUS','It\'s quiet... Too quiet...','',26124),
(6869,'enUS','Well met, friend.  I am Officer Garush, and I am a proud member of a world-wide organization known as the Argent Crusade.  Our cause is to fight swiftly and mercilessly against any element of evil that surfaces in Azeroth.  We are not a political body, nor do we ever wish to become one.  Our cause is singular, and to that end we call both the Horde and Alliance as friends - friends in the cause of stamping out evil!$B$BFor the Crusade, my $g brother : sister;!','',26124),
(6870,'enUS','','Well met, friend.  I am Officer Pureheart, and I am a proud member of a world-wide organization known as the Argent Crusade.  Our cause is simple - fight swiftly and mercilessly against any element of evil that surfaces in Azeroth.  We are not a political body, nor do we ever wish to become one.  To that end we call both the Alliance and the Horde both as friends - friends in the cause of stamping out evil!$B$BFor the Light, my $g brother : sister;!',26124),
(6871,'enUS','%s bursts forth from the ground!','',26124),
(6872,'enUS','ZZzzzz....','',26124),
(6873,'enUS','Huh?  What do you want?','',26124),
(6874,'enUS','%s is lured out into the open!','',26124),
(6875,'enUS','Wake up!','Wake up!',26124),
(6876,'enUS','','The Argent Dawn salutes you, $c.  I am Hasana - one of but a few authorized equipment and materiel quartermasters for the Dawn.$B$BAs you fight evil under our commission - all the while earning our respect and trust - you\'ll earn valor tokens from Officer Garush.  Tokens serve two purposes: use them to gain increased standing within our ranks, or use them as tender in acquiring special items.$B$BAs you improve your standing with the Dawn, you\'ll discover that more items will be made available to you.',26124),
(6877,'enUS','','Join the fight against evil!  Accept a commission within the Argent Dawn today!',26124),
(6878,'enUS','I need another Argent Dawn Commission.','I need another Argent Dawn Commission.',26124),
(6879,'enUS','The Argent Crusade salutes you, $c!  The name\'s Lightspark, and I\'m an authorized equipment and materiel quartermaster for the Crusade.$B$BAs you fight evil under our commission - all the while earning our respect and trust - you\'ll earn valor tokens from Officer Pureheart.  Tokens serve two purposes: use them to gain increased standing within our ranks, or use them as tender in acquiring special items.$B$BAs you improve your standing with the Crusade, you\'ll discover that more items will be made available to you.','',26124),
(6880,'enUS','Onward, Crusaders! We must retake Corin\'s Crossing!','Onward, Crusaders! We must retake Corin\'s Crossing!',26124),
(6881,'enUS','Join the fight against evil!  Accept a commission within the Argent Crusade today!','',26124),
(6882,'enUS','','Greetings, $c.  I am Miranda Breechlock - one of but a few authorized equipment and materiel quartermasters for the Dawn.$B$BAs you fight evil under our commission - all the while earning our respect and trust - you\'ll earn valor tokens from Duke Zverenhoff.  Tokens serve two purposes: use them to gain increased standing within our ranks, or use them as tender in acquiring special items.$B$BAs you improve your standing with the Dawn, you\'ll discover that more items will be made available to you.',26124),
(6883,'enUS','What is this?!  How dare you!','',26124),
(6884,'enUS','Greetings, $c.$B$BThose Sentinels over there have allowed me to share their camp as long as I promise no trouble will follow--I am sure you can appreciate the need for diplomacy while here, yes?$B$BI am here investigating disturbances to the land, and since it aids their cause also, they have agreed that my presence here could only aid the tenuous alliance between all of Azeroth\'s races. If you wish to aid me, then I would appreciate it, but regardless, please try not to cause any trouble.','',26124),
(6885,'enUS','Ah, so my minions from the Burning Steppes have brought the dragons...','',26124),
(6886,'enUS','Marduk, gather the box and place it before me!','',26124),
(6887,'enUS','Master Vectus, I sense something strange within this container...','',26124),
(6888,'enUS','Welcome to Steelgrill\'s Depot!','',26124),
(6889,'enUS','Race does not dictate honor, $r. While you remain on my farmstead, I ask that you remember and respect this credo.$B$BI have known orcs who have been as honorable as the most noble of knights and humans who have been as vile as the most ruthless of Scourge.$B$BBut I shall not bore you with tales of my youth! There is much work to be done - if that is what you desire. ','',26124),
(6890,'enUS','We have yet to meet our quota for the wood demand.  Now back to work with you.','We have yet to meet our quota for the wood demand.  Now back to work with you.',26124),
(6891,'enUS','Daylight is still upon us so let\'s see that axe of yours chopping some more wood.','Daylight is still upon us so let\'s see that axe of yours chopping some more wood.',26124),
(6892,'enUS','We need to get this wagon filled by the end of the day.  So back to work with you.  Chop, chop!','We need to get this wagon filled by the end of the day.  So back to work with you.  Chop, chop!',26124),
(6893,'enUS','%s reaps the Gloom Weed violently from the ground.','',26124),
(6894,'enUS','TEST - death before attack $n','',26124),
(6895,'enUS','TEST - death after attack $n','',26124),
(6896,'enUS','','Your blood spills for the betterment of humanity, infidel!',26124),
(6897,'enUS','Fordring shall never see his son.','Fordring shall never see his son.',26124),
(6898,'enUS','Say hello to my little friend.','',26124),
(6901,'enUS','Hail citizen.  Do you need directions?','Hail citizen.  Do you need directions?',26124),
(6902,'enUS','Is there something I can help you find?','Is there something I can help you find?',26124),
(6903,'enUS','You look a little lost.  Who are you looking for?','You look a little lost.  Who are you looking for?',26124),
(6904,'enUS','Are you new here?  Well, tell me what you\'re looking for then.','Are you new here?  Well, tell me what you\'re looking for then.',26124),
(6905,'enUS','I need directions.','I need directions.',26124),
(6906,'enUS','What are you looking for?','What are you looking for?',26124),
(6907,'enUS','Bank','Bank',26124),
(6908,'enUS','Gryphon Master','Gryphon Master',26124),
(6909,'enUS','Guild Master & Vendor','Guild Master & Vendor',26124),
(6910,'enUS','Inn','Inn',26124),
(6911,'enUS','Class Trainer','Class Trainer',26124),
(6912,'enUS','Profession Trainer','Profession Trainer',26124),
(6913,'enUS','A bank?  Well, the closest bank around here is The Stormwind Counting House.  It\'s just up the road in Stormwind not far from the gates.','A bank?  Well, the closest bank around here is The Stormwind Counting House.  It\'s just up the road in Stormwind not far from the gates.',26124),
(6914,'enUS','Oh, you must mean the Stormwind Counting House.  It\'s not far from the gates after you enter Stormwind.','Oh, you must mean the Stormwind Counting House.  It\'s not far from the gates after you enter Stormwind.',26124),
(6915,'enUS','Well there\'s a gryphon master up in Stormwind if you need to fly somewhere.  You should be able to see the gryphons landing on your right as you walk through the Valley of Heroes.','Well there\'s a gryphon master up in Stormwind if you need to fly somewhere.  You should be able to see the gryphons landing on your right as you walk through the Valley of Heroes.',26124),
(6916,'enUS','The gryphon master oversees the gryphon flights from within Stormwind.  If you\'re looking to take a ride, then that\'s where you should be headed.','The gryphon master oversees the gryphon flights from within Stormwind.  If you\'re looking to take a ride, then that\'s where you should be headed.',26124),
(6917,'enUS','I believe Aldwin Laughlin is still the resident Guild Master of Stormwind.  Look for his residence on your left as you pass the inner gate of Stormwind.','I believe Aldwin Laughlin is still the resident Guild Master of Stormwind.  Look for his residence on your left as you pass the inner gate of Stormwind.',26124),
(6918,'enUS','All that official business is handled up in Stormwind these days.  You could stop by the Stormwind Visitor\'s Center if you want to start a guild.','All that official business is handled up in Stormwind these days.  You could stop by the Stormwind Visitor\'s Center if you want to start a guild.',26124),
(6919,'enUS','Look no further than the Lion\'s Pride Inn in Goldshire.  With a wide selection of ales and soft down beds you, couldn\'t ask for a better place to rest.','Look no further than the Lion\'s Pride Inn in Goldshire.  With a wide selection of ales and soft down beds you, couldn\'t ask for a better place to rest.',26124),
(6920,'enUS','The Lion\'s Pride Inn in Goldshire is as good as any inn you will find around these parts.  Drop in and let Innkeeper Farley make you feel at home.','The Lion\'s Pride Inn in Goldshire is as good as any inn you will find around these parts.  Drop in and let Innkeeper Farley make you feel at home.',26124),
(6921,'enUS','There are quite a few trainers available in Elwynn.  Which one are you looking for?','There are quite a few trainers available in Elwynn.  Which one are you looking for?',26124),
(6922,'enUS','Druid','Druid',26124),
(6923,'enUS','Druids?  I haven\'t seen any druids around here.  Although there is a district in Stormwind that the night elves have made their own.','Druids?  I haven\'t seen any druids around here.  Although there is a district in Stormwind that the night elves have made their own.',26124),
(6924,'enUS','Hunter','Hunter',26124),
(6925,'enUS','I\'ve heard that there\'s a dwarf in Stormwind who has achieved some fame for his hunting skill.  Maybe you should go see if he could help you.','I\'ve heard that there\'s a dwarf in Stormwind who has achieved some fame for his hunting skill.  Maybe you should go see if he could help you.',26124),
(6926,'enUS','Priest','Priest',26124),
(6927,'enUS','Josetta has been a blessing to this town with her aid of the local guards.  If you seek her for training in the ways of a priest, you can find her in the Lion\'s Pride Inn.','Josetta has been a blessing to this town with her aid of the local guards.  If you seek her for training in the ways of a priest, you can find her in the Lion\'s Pride Inn.',26124),
(6928,'enUS','I bet Josetta would be more than happy to teach you some new spells.  She is probably up in her room at the Lion\'s Pride Inn.','I bet Josetta would be more than happy to teach you some new spells.  She is probably up in her room at the Lion\'s Pride Inn.',26124),
(6929,'enUS','Mage','Mage',26124),
(6930,'enUS','Zaldimar could probably teach you some new spells.  He has recently taken a liking to staying at the Lion\'s Pride Inn, you might want to check one of the rooms and see if he\'s in.','Zaldimar could probably teach you some new spells.  He has recently taken a liking to staying at the Lion\'s Pride Inn, you might want to check one of the rooms and see if he\'s in.',26124),
(6931,'enUS','I don\'t know much about magic, but there\'s a mage named Zaldimar who is staying at the Lion\'s Pride Inn that could probably assist you.','I don\'t know much about magic, but there\'s a mage named Zaldimar who is staying at the Lion\'s Pride Inn that could probably assist you.',26124),
(6932,'enUS','Paladin','Paladin',26124),
(6933,'enUS','You can usually find Brother Wilhelm in back of the smithy trading stories with Lyria.  He\'s always up for teaching fellow paladins new skills.','You can usually find Brother Wilhelm in back of the smithy trading stories with Lyria.  He\'s always up for teaching fellow paladins new skills.',26124),
(6934,'enUS','Brother Wilhelm often trains with Lyria Du Lac out in back of the smithy in Goldshire.  You could probably learn a thing or two about being a paladin from him.','Brother Wilhelm often trains with Lyria Du Lac out in back of the smithy in Goldshire.  You could probably learn a thing or two about being a paladin from him.',26124),
(6935,'enUS','Rogue','Rogue',26124),
(6936,'enUS','A rogue?  Hmmm... well, I\'ve heard that Keryn Sylvius hangs around those shady types.  You might want to talk to her and see what you can learn.','A rogue?  Hmmm... well, I\'ve heard that Keryn Sylvius hangs around those shady types.  You might want to talk to her and see what you can learn.',26124),
(6937,'enUS','I\'d wager Keryn Sylvius knows the type you\'re looking for. The company Keryn keeps is less than honorable. She usually hangs out in the Lion\'s Pride Inn.','I\'d wager Keryn Sylvius knows the type you\'re looking for. The company Keryn keeps is less than honorable. She usually hangs out in the Lion\'s Pride Inn.',26124),
(6938,'enUS','Warrior','Warrior',26124),
(6939,'enUS','Few around here are as skilled with a blade as Lyria Du Lac.  Check for her out behind the smithy and see if she\'s in the mood to teach you something new.','Few around here are as skilled with a blade as Lyria Du Lac.  Check for her out behind the smithy and see if she\'s in the mood to teach you something new.',26124),
(6940,'enUS','Lyria\'s the one you should talk to if you need some training.  She can usually be found out behind the smithy waiting for some armor or weapon to be finished.','Lyria\'s the one you should talk to if you need some training.  She can usually be found out behind the smithy waiting for some armor or weapon to be finished.',26124),
(6941,'enUS','Warlock','Warlock',26124),
(6942,'enUS','Oh... one of those types.  Well, Maximillian is the only one around here that knows about the dark arts.  You can probably find him in the dark of the Lion\'s Pride Inn basement.','Oh... one of those types.  Well, Maximillian is the only one around here that knows about the dark arts.  You can probably find him in the dark of the Lion\'s Pride Inn basement.',26124),
(6943,'enUS','A warlock?  Well, if I was a warlock, I would probably be in the darkest place around here... which would be the Lion\'s Pride Inn basement.  That\'s where you should look first.','A warlock?  Well, if I was a warlock, I would probably be in the darkest place around here... which would be the Lion\'s Pride Inn basement.  That\'s where you should look first.',26124),
(6944,'enUS','I know of a few people around here that practice a profession or two.  What profession do you have in mind?','I know of a few people around here that practice a profession or two.  What profession do you have in mind?',26124),
(6945,'enUS','Alchemy','Alchemy',26124),
(6946,'enUS','Blacksmithing','Blacksmithing',26124),
(6947,'enUS','Cooking','Cooking',26124),
(6948,'enUS','Enchanting','Enchanting',26124),
(6949,'enUS','Engineering','Engineering',26124),
(6950,'enUS','First Aid','First Aid',26124),
(6951,'enUS','Fishing','Fishing',26124),
(6952,'enUS','Herbalism','Herbalism',26124),
(6953,'enUS','Leatherworking','Leatherworking',26124),
(6954,'enUS','Mining','Mining',26124),
(6955,'enUS','Skinning','Skinning',26124),
(6956,'enUS','Tailoring','Tailoring',26124),
(6957,'enUS','That hermit Mallory is known to concoct some potions for the local townsfolk on occasion.  He has a cottage in the hills between Stormwind and Northshire.','That hermit Mallory is known to concoct some potions for the local townsfolk on occasion.  He has a cottage in the hills between Stormwind and Northshire.',26124),
(6958,'enUS','There is an alchemist that lives up in the hills between Northshire and Stormwind that might be of some help.  Why don\'t you go pay him a visit?','There is an alchemist that lives up in the hills between Northshire and Stormwind that might be of some help.  Why don\'t you go pay him a visit?',26124),
(6959,'enUS','Argus is the resident blacksmith of Goldshire.  I\'m sure he could teach you the Blacksmith\'s profession.','Argus is the resident blacksmith of Goldshire.  I\'m sure he could teach you the Blacksmith\'s profession.',26124),
(6960,'enUS','You must be looking for Smith Argus.  He\'s usually overseeing the forge in Goldshire if you need some training.','You must be looking for Smith Argus.  He\'s usually overseeing the forge in Goldshire if you need some training.',26124),
(6961,'enUS','Tomas may not be the best cook around, but he has a few dishes that hit the spot.  He\'s currently working in the Lion\'s Pride Inn if you\'d like to learn the profession.','Tomas may not be the best cook around, but he has a few dishes that hit the spot.  He\'s currently working in the Lion\'s Pride Inn if you\'d like to learn the profession.',26124),
(6962,'enUS','Why don\'t you try looking in the Lion\'s Pride Inn?  The cook there might be able to teach you a few good recipes.','Why don\'t you try looking in the Lion\'s Pride Inn?  The cook there might be able to teach you a few good recipes.',26124),
(6963,'enUS','Nope, don\'t think there are any Enchanters here in Elwynn Forest.  There\'s a guy named Lucan who runs a shop up in Stormwind though.  You could check with him and see if he will train you.','Nope, don\'t think there are any Enchanters here in Elwynn Forest.  There\'s a guy named Lucan who runs a shop up in Stormwind though.  You could check with him and see if he will train you.',26124),
(6964,'enUS','Hmmm... only enchanters I know of around here work out of Stormwind.  Why don\'t you ask one of the guards up in Stormwind?','Hmmm... only enchanters I know of around here work out of Stormwind.  Why don\'t you ask one of the guards up in Stormwind?',26124),
(6965,'enUS','I usually leave that sort of thing to the gnomes.  If you want to take up the profession, I\'m sure you could find some gnomes hanging out in Stormwind that would train you.','I usually leave that sort of thing to the gnomes.  If you want to take up the profession, I\'m sure you could find some gnomes hanging out in Stormwind that would train you.',26124),
(6966,'enUS','There is bound to be a gnome in Stormwind that can teach you the profession.  I\'m sure one of the Stormwind Guards could point you in the right direction.','There is bound to be a gnome in Stormwind that can teach you the profession.  I\'m sure one of the Stormwind Guards could point you in the right direction.',26124),
(6967,'enUS','I had a bad encounter with some of the Defias around here recently, but Michelle Belle fixed me up pretty well.  Check with her in the Lion\'s Pride Inn and see if she\'ll teach you.','I had a bad encounter with some of the Defias around here recently, but Michelle Belle fixed me up pretty well.  Check with her in the Lion\'s Pride Inn and see if she\'ll teach you.',26124),
(6968,'enUS','Michelle Belle\'s bedside manner is remarkable!  While she might not be able to teach you that, she surely could teach you some proper First Aid.  She currently resides in the Lion\'s Pride Inn.','Michelle Belle\'s bedside manner is remarkable!  While she might not be able to teach you that, she surely could teach you some proper First Aid.  She currently resides in the Lion\'s Pride Inn.',26124),
(6969,'enUS','Lee Brown spends the whole day fishing up by Crystal Lake.  He\'s probably got some stories to tell and some tips he could teach you.','Lee Brown spends the whole day fishing up by Crystal Lake.  He\'s probably got some stories to tell and some tips he could teach you.',26124),
(6970,'enUS','Lee\'s caught some pretty odd things up at Crystal Lake.  He told me a story about this weird mask he fished up some months ago.  If you ask me, I think he just had one too many at the Lion\'s Pride that night.','Lee\'s caught some pretty odd things up at Crystal Lake.  He told me a story about this weird mask he fished up some months ago.  If you ask me, I think he just had one too many at the Lion\'s Pride that night.',26124),
(6971,'enUS','Ms. Pomeroy gathers herbs for an Alchemist who lives up in the hills between Northshire and Stormwind.  Check for her at his cottage and see if she\'ll show you the profession.','Ms. Pomeroy gathers herbs for an Alchemist who lives up in the hills between Northshire and Stormwind.  Check for her at his cottage and see if she\'ll show you the profession.',26124),
(6972,'enUS','There\'s an herbalist that lives in the hills east of Stormwind with our alchemist. Quite the handy pairing don\'t you think?','There\'s an herbalist that lives in the hills east of Stormwind with our alchemist. Quite the handy pairing don\'t you think?',26124),
(6973,'enUS','Over by Crystal Lake there lives a lady named Adele Fielder.  She makes patches for the local guards with the extra leather she gets from the local skinner, Helene.  She would probably be the one to see if you\'re interested in learning the profession.','Over by Crystal Lake there lives a lady named Adele Fielder.  She makes patches for the local guards with the extra leather she gets from the local skinner, Helene.  She would probably be the one to see if you\'re interested in learning the profession.',26124),
(6974,'enUS','Adele Fielder has made a name for herself as a leatherworker around Elwynn.  You can find her working out of her home up by Crystal Lake.','Adele Fielder has made a name for herself as a leatherworker around Elwynn.  You can find her working out of her home up by Crystal Lake.',26124),
(6975,'enUS','You best head up to Stormwind in the Dwarven District if you want to learn to mine.  Surely one of the dwarves there can teach you the profession.','You best head up to Stormwind in the Dwarven District if you want to learn to mine.  Surely one of the dwarves there can teach you the profession.',26124),
(6976,'enUS','I think you\'ll have better luck looking in Stormwind.  Ask a guard up there and they\'ll point you in the right direction.','I think you\'ll have better luck looking in Stormwind.  Ask a guard up there and they\'ll point you in the right direction.',26124),
(6977,'enUS','Helene Peltskinner has had years of experience skinning animals for Adele Fielder to make leather items.  You can find Helene in her house by Crystal Lake.','Helene Peltskinner has had years of experience skinning animals for Adele Fielder to make leather items.  You can find Helene in her house by Crystal Lake.',26124),
(6978,'enUS','There\'s an excellent skinner that lives up in the house by Crystal Lake.  She\'s bound to be able to show you how to get started in the skinner\'s profession.','There\'s an excellent skinner that lives up in the house by Crystal Lake.  She\'s bound to be able to show you how to get started in the skinner\'s profession.',26124),
(6979,'enUS','Eldrin is the only one in Elwynn Forest that I would call a tailor.  You can find him at the Eastvale Lumber Camp if you\'re interested in learning the profession.','Eldrin is the only one in Elwynn Forest that I would call a tailor.  You can find him at the Eastvale Lumber Camp if you\'re interested in learning the profession.',26124),
(6980,'enUS','You want to learn to be a tailor?  Hmmm... I believe there\'s a tailor over in the Eastvale Logging Camp that may be able to get you started.  ','You want to learn to be a tailor?  Hmmm... I believe there\'s a tailor over in the Eastvale Logging Camp that may be able to get you started.  ',26124),
(6981,'enUS','Ye be needing directions $glad : lass;?','Ye be needing directions $glad : lass;?',26124),
(6982,'enUS','Ye look a bit lost there.  Can I help ye find something?','Ye look a bit lost there.  Can I help ye find something?',26124),
(6983,'enUS','Do ye need some help finding something?','Do ye need some help finding something?',26124),
(6984,'enUS','Whatcha need?','Whatcha need?',26124),
(6985,'enUS','I need directions.','I need directions.',26124),
(6986,'enUS','What do ye need directions to?','What do ye need directions to?',26124),
(6987,'enUS','Bank','Bank',26124),
(6988,'enUS','The nearest bank ye\'ll find is The Vault in Ironforge, $glad : lass;. ','The nearest bank ye\'ll find is The Vault in Ironforge, $glad : lass;. ',26124),
(6989,'enUS','The Vault in Ironforge is the closest bank ye\'ll find in these parts.','The Vault in Ironforge is the closest bank ye\'ll find in these parts.',26124),
(6990,'enUS','Gryphon Master','Gryphon Master',26124),
(6991,'enUS','Ye won\'t find a gryphon master just anywhere around Dun Morogh, $glad : lass;.  Ye\'re going to have to go to Ironforge if ye want to take a gryphon somewhere.','Ye won\'t find a gryphon master just anywhere around Dun Morogh, $glad : lass;.  Ye\'re going to have to go to Ironforge if ye want to take a gryphon somewhere.',26124),
(6992,'enUS','The closest gryphon master is located up in Ironforge near The Great Forge itself.  Ye\'ll need to head to Ironforge if ye want to travel by gryphon.','The closest gryphon master is located up in Ironforge near The Great Forge itself.  Ye\'ll need to head to Ironforge if ye want to travel by gryphon.',26124),
(6993,'enUS','Guild Master & Vendor','Guild Master & Vendor',26124),
(6994,'enUS','All those official types reside in Ironforge.  Ye\'ll be wanting to check out the Ironforge Visitor\'s Center for guild creation papers.','All those official types reside in Ironforge.  Ye\'ll be wanting to check out the Ironforge Visitor\'s Center for guild creation papers.',26124),
(6995,'enUS','If ye need to get yer hands on some guild creation papers ye\'ll have to head up to Ironforge and visit the Ironforge Visitor\'s Center.','If ye need to get yer hands on some guild creation papers ye\'ll have to head up to Ironforge and visit the Ironforge Visitor\'s Center.',26124),
(6996,'enUS','The Inn','The Inn',26124),
(6997,'enUS','The Thunderbrews run a fine Inn in Kharanos which bears their name.  Stop in for a pint and a bit of rest.','The Thunderbrews run a fine Inn in Kharanos which bears their name.  Stop in for a pint and a bit of rest.',26124),
(6998,'enUS','Oooh, an Inn is it?  Well, ye just can\'t beat the Thunderbrew Distillery.  Rest if ye must, but be sure to have an ale or two while ye\'re there.','Oooh, an Inn is it?  Well, ye just can\'t beat the Thunderbrew Distillery.  Rest if ye must, but be sure to have an ale or two while ye\'re there.',26124),
(6999,'enUS','Class Trainer','Class Trainer',26124),
(7000,'enUS','Which class trainer might ye be looking for?','Which class trainer might ye be looking for?',26124),
(7001,'enUS','Hunter','Hunter',26124),
(7002,'enUS','There\'s only one hunter around here I would have ye talk to, and that would be Grif Wildheart.  Ye\'ll find him standing just outside the smithy in Kharanos.','There\'s only one hunter around here I would have ye talk to, and that would be Grif Wildheart.  Ye\'ll find him standing just outside the smithy in Kharanos.',26124),
(7003,'enUS','If ye ask me, I think Grif spends a little too much time with the animals.  Still, nobody else knows the hunter\'s path quite like he does.  Look for him outside the smithy in Kharanos.','If ye ask me, I think Grif spends a little too much time with the animals.  Still, nobody else knows the hunter\'s path quite like he does.  Look for him outside the smithy in Kharanos.',26124),
(7004,'enUS','Mage','Mage',26124),
(7005,'enUS','There\'s a mage at the Thunderbrew Distillery who might be able to teach you some new spells.  I believe his name is Magis Sparkmantle.','There\'s a mage at the Thunderbrew Distillery who might be able to teach you some new spells.  I believe his name is Magis Sparkmantle.',26124),
(7006,'enUS','Ye sure ye don\'t want to learn to be a warrior?  Well, it\'s yer hide on the battlefield.  If ye really want to learn to waggle yer finger, ye best talk to Magis Sparkmantle in the Thunderbrew Distillery.','Ye sure ye don\'t want to learn to be a warrior?  Well, it\'s yer hide on the battlefield.  If ye really want to learn to waggle yer finger, ye best talk to Magis Sparkmantle in the Thunderbrew Distillery.',26124),
(7007,'enUS','Paladin','Paladin',26124),
(7008,'enUS','Och... a paladin?  Well $glad : lass;, ye\'re in luck!  Azar Stronghammer is back from training and is currently staying at the Thunderbrew Distillery in Kharanos.','Och... a paladin?  Well $glad : lass;, ye\'re in luck!  Azar Stronghammer is back from training and is currently staying at the Thunderbrew Distillery in Kharanos.',26124),
(7009,'enUS','Ye need some training?  Well, Azar Stronghammer is always up for showing the younger paladins a thing or two.  Why don\'t ye go see him in the Thunderbrew Distillery.','Ye need some training?  Well, Azar Stronghammer is always up for showing the younger paladins a thing or two.  Why don\'t ye go see him in the Thunderbrew Distillery.',26124),
(7010,'enUS','Priest','Priest',26124),
(7011,'enUS','Oh, a priest is it?  Well good ol\' Maxan is sure to be found having a drink in the Thunderbrew Distillery if ye need a bit of training.','Oh, a priest is it?  Well good ol\' Maxan is sure to be found having a drink in the Thunderbrew Distillery if ye need a bit of training.',26124),
(7012,'enUS','Ye\'ll surely find Maxan Anvol tossin\' back a few in the Thunderbrew Distillery.  Why don\'t ye go have yerself a pint and see if he\'ll teach ye something new.','Ye\'ll surely find Maxan Anvol tossin\' back a few in the Thunderbrew Distillery.  Why don\'t ye go have yerself a pint and see if he\'ll teach ye something new.',26124),
(7013,'enUS','Rogue','Rogue',26124),
(7014,'enUS','Well then, it seems we\'re both looking for Hogral Bakkan.  He\'s a dwarf to be sure, so sooner or later he\'ll be heading for the Thunderbrew Distillery for an ale -- he might even be there now.','Well then, it seems we\'re both looking for Hogral Bakkan.  He\'s a dwarf to be sure, so sooner or later he\'ll be heading for the Thunderbrew Distillery for an ale -- he might even be there now.',26124),
(7015,'enUS','Ye looking for Hogral?  Well did ye check the tavern?  Och!  If yer looking for a rogue, and a dwarf one at that, ye should start in the Inn!  Go have a look already.','Ye looking for Hogral?  Well did ye check the tavern?  Och!  If yer looking for a rogue, and a dwarf one at that, ye should start in the Inn!  Go have a look already.',26124),
(7016,'enUS','Warlock','Warlock',26124),
(7017,'enUS','Warlocks... I don\'t care for their lot.  Like that Grimrizz who\'s set up shop outside the Thunderbrew Distillery. The ale will probably go flat there because of him!  Warlocks... bah!','Warlocks... I don\'t care for their lot.  Like that Grimrizz who\'s set up shop outside the Thunderbrew Distillery. The ale will probably go flat there because of him!  Warlocks... bah!',26124),
(7018,'enUS','That kind of magic is just bad news, I tell ye.  I don\'t know why that Grimrizz has been allowed to set up outside the Thunderbrew Distillery of all places!  You stay away from him, you here!','That kind of magic is just bad news, I tell ye.  I don\'t know why that Grimrizz has been allowed to set up outside the Thunderbrew Distillery of all places!  You stay away from him, you here!',26124),
(7019,'enUS','Warrior','Warrior',26124),
(7020,'enUS','Och!  Now ye\'re talkin\'!  I bet Granis Swiftaxe could show ye a thing or two about swinging steel.  He\'s over in the Thunderbrew Distillery in Kharanos at the moment.','Och!  Now ye\'re talkin\'!  I bet Granis Swiftaxe could show ye a thing or two about swinging steel.  He\'s over in the Thunderbrew Distillery in Kharanos at the moment.',26124),
(7021,'enUS','That Granis Swiftaxe could drink a fish under the table and yet his axe still swings true.  However, if yer looking for training, ye best catch him while ye can understand him.','That Granis Swiftaxe could drink a fish under the table and yet his axe still swings true.  However, if yer looking for training, ye best catch him while ye can understand him.',26124),
(7022,'enUS','Profession Trainer','Profession Trainer',26124),
(7023,'enUS','Which profession trainer would ye be looking for?','Which profession trainer would ye be looking for?',26124),
(7024,'enUS','Alchemy','Alchemy',26124),
(7025,'enUS','Blacksmithing','Blacksmithing',26124),
(7026,'enUS','Cooking','Cooking',26124),
(7027,'enUS','Enchanting','Enchanting',26124),
(7028,'enUS','Engineering','Engineering',26124),
(7029,'enUS','First Aid','First Aid',26124),
(7030,'enUS','Fishing','Fishing',26124),
(7031,'enUS','Herbalism','Herbalism',26124),
(7032,'enUS','Leatherworking','Leatherworking',26124),
(7033,'enUS','Mining','Mining',26124),
(7034,'enUS','Skinning','Skinning\n',26124),
(7035,'enUS','Tailoring','Tailoring',26124),
(7036,'enUS','Nope, no alchemists out here in Dun Morogh.  Ye best take a look in Ironforge for them... try the gnomes in Tinker Town.','Nope, no alchemists out here in Dun Morogh.  Ye best take a look in Ironforge for them... try the gnomes in Tinker Town.',26124),
(7037,'enUS','I hear there\'s a shop up in Ironforge run by the gnomes that specializes in alchemy.  You should go have a look.','I hear there\'s a shop up in Ironforge run by the gnomes that specializes in alchemy.  You should go have a look.',26124),
(7038,'enUS','Och!  Now that\'s a skill worth knowing.  Tognus beats the anvil with a fury ye don\'t see often.  Why don\'t ye go talk him up and see what he can teach ye?','Och!  Now that\'s a skill worth knowing.  Tognus beats the anvil with a fury ye don\'t see often.  Why don\'t ye go talk him up and see what he can teach ye?',26124),
(7039,'enUS','Ye can probably hear Tognus beating away on the anvil when yer in Kharanos.  Although, if ye haven\'t cleared the wax out of yer ears recently, then why don\'t ye just have a look in the smithy.','Ye can probably hear Tognus beating away on the anvil when yer in Kharanos.  Although, if ye haven\'t cleared the wax out of yer ears recently, then why don\'t ye just have a look in the smithy.',26124),
(7040,'enUS','A Thunderbrew ale and a bit of Gremlock\'s cooking makes for a nice meal indeed.  Ye really should hit him up for some training if ye want to be a cook.','A Thunderbrew ale and a bit of Gremlock\'s cooking makes for a nice meal indeed.  Ye really should hit him up for some training if ye want to be a cook.',26124),
(7041,'enUS','Gremlock doesn\'t always have the best of luck with cooking, but he does have some tasty recipies worth learning.  Go chat him up in the Thunderbrew Distillery and see what he\'ll teach ye.','Gremlock doesn\'t always have the best of luck with cooking, but he does have some tasty recipies worth learning.  Go chat him up in the Thunderbrew Distillery and see what he\'ll teach ye.',26124),
(7042,'enUS','There aren\'t any enchanters out here in Dun Morogh that I know of.  Ye\'re going to have to visit Ironforge if ye want to learn the enchanter\'s profession.','There aren\'t any enchanters out here in Dun Morogh that I know of.  Ye\'re going to have to visit Ironforge if ye want to learn the enchanter\'s profession.',26124),
(7043,'enUS','Ye should take a look in Ironforge if ye have yer mind set on enchanting.  I think I saw a shop over by the gryphon master last time I was up there.','Ye should take a look in Ironforge if ye have yer mind set on enchanting.  I think I saw a shop over by the gryphon master last time I was up there.',26124),
(7044,'enUS','Ye should check over at Steelgrill\'s Depot for Bronk.  When he\'s not tinkering with some odd device, he\'s usually chatting up the pilots about their steam tanks.','Ye should check over at Steelgrill\'s Depot for Bronk.  When he\'s not tinkering with some odd device, he\'s usually chatting up the pilots about their steam tanks.',26124),
(7045,'enUS','With all the screws that Bronk has been tightening, I think he\'s let a few of his own go if ye get me.  All the same he\'s still got a good head for engineering the darndest devices.  Ye should go pay him a visit over at Steelgrill\'s Depot.','With all the screws that Bronk has been tightening, I think he\'s let a few of his own go if ye get me.  All the same he\'s still got a good head for engineering the darndest devices.  Ye should go pay him a visit over at Steelgrill\'s Depot.',26124),
(7046,'enUS','First Aid may not make up for a priest\'s healing, but it\'s handy in a pinch.  I recommend ye go talk to Thamner in the Thunderbrew Distillery and learn what ye can.','First Aid may not make up for a priest\'s healing, but it\'s handy in a pinch.  I recommend ye go talk to Thamner in the Thunderbrew Distillery and learn what ye can.',26124),
(7047,'enUS','Good ol\' Thamner bandaged me up just the other day when I had a run in with a nasty trogg.  I\'m good as new I tell ye!  I\'m sure Thamner would be happy to show ye how to make a good bandage.','Good ol\' Thamner bandaged me up just the other day when I had a run in with a nasty trogg.  I\'m good as new I tell ye!  I\'m sure Thamner would be happy to show ye how to make a good bandage.',26124),
(7048,'enUS','Not much fishing to be had around here, but what little there is to be had is Paxton\'s ye can be sure.  Ye can find him fishing out on Iceflow Lake.','Not much fishing to be had around here, but what little there is to be had is Paxton\'s ye can be sure.  Ye can find him fishing out on Iceflow Lake.',26124),
(7049,'enUS','Only a few spots to get any fishing done around here.  Paxton knows them all and probably a few he won\'t tell ya about.  Why don\'t ye go over to Iceflow Lake and see what he will tell ya.','Only a few spots to get any fishing done around here.  Paxton knows them all and probably a few he won\'t tell ya about.  Why don\'t ye go over to Iceflow Lake and see what he will tell ya.',26124),
(7050,'enUS','Amazing to see little flowers persist in the cold of Dun Morogh...  but ye won\'t find any herbalists out here.  Ye\'ll have to go to Ironforge to get some training in that profession.','Amazing to see little flowers persist in the cold of Dun Morogh...  but ye won\'t find any herbalists out here.  Ye\'ll have to go to Ironforge to get some training in that profession.',26124),
(7051,'enUS','Nope, nobody who can teach ye herbalism out here.  I think ye\'ll have better luck in Ironforge though.','Nope, nobody who can teach ye herbalism out here.  I think ye\'ll have better luck in Ironforge though.',26124),
(7052,'enUS','If ye\'re looking to learn the profession of leatherworking, ye\'re gonna need to travel to Ironforge.  I hear there\'s a nice shop near the Great Forge where ye can learn the profession.','If ye\'re looking to learn the profession of leatherworking, ye\'re gonna need to travel to Ironforge.  I hear there\'s a nice shop near the Great Forge where ye can learn the profession.',26124),
(7053,'enUS','Ironforge is going to be your best bet for leatherworkers.  If memory serves, there\'s a shop by The Great Forge that should meet yer needs.','Ironforge is going to be your best bet for leatherworkers.  If memory serves, there\'s a shop by The Great Forge that should meet yer needs.',26124),
(7054,'enUS','Surely ye didn\'t think ye would find a town without a resident miner about, did ye?  Yarr can usually be found over at Steelgrill\'s Depot just outside of Kharanos.','Surely ye didn\'t think ye would find a town without a resident miner about, did ye?  Yarr can usually be found over at Steelgrill\'s Depot just outside of Kharanos.',26124),
(7055,'enUS','A miner?  Ye don\'t need to ask if $glad : lass;, only where!  Yarr is who yer looking for, and I think ye can find him hiding out over in Steelgrill\'s Depot.','A miner?  Ye don\'t need to ask if $glad : lass;, only where!  Yarr is who yer looking for, and I think ye can find him hiding out over in Steelgrill\'s Depot.',26124),
(7056,'enUS','Ye won\'t find any skinners out in here Dun Morogh $glad : lass;, they\'re mostly to be found in Ironforge if ye\'re looking to be trained.','Ye won\'t find any skinners out in here Dun Morogh $glad : lass;, they\'re mostly to be found in Ironforge if ye\'re looking to be trained.',26124),
(7057,'enUS','The skinners usually take all their hides into Ironforge to dry out.  Why don\'t you head there and see if you can find one to train ye?','The skinners usually take all their hides into Ironforge to dry out.  Why don\'t you head there and see if you can find one to train ye?',26124),
(7058,'enUS','Ah, Stonebrow doesn\'t leave Ironforge much these days so if ye\'re looking to learn the tailor\'s profession ye\'ll have to go to see him up in Ironforge.','Ah, Stonebrow doesn\'t leave Ironforge much these days so if ye\'re looking to learn the tailor\'s profession ye\'ll have to go to see him up in Ironforge.',26124),
(7059,'enUS','Well, ye won\'t have much luck with finding a tailor out here.  Ironforge is home to a quite a few talented tailors though.  Why don\'t ye go ask a guard there.','Well, ye won\'t have much luck with finding a tailor out here.  Ironforge is home to a quite a few talented tailors though.  Why don\'t ye go ask a guard there.',26124),
(7060,'enUS','Anu therador mali $c.  Where can I guide you to?','Anu therador mali $c.  Where can I guide you to?',26124),
(7061,'enUS','How may I aid you in your journey?','How may I aid you in your journey?',26124),
(7062,'enUS','Do you require guidance to your destination?','Do you require guidance to your destination?',26124),
(7063,'enUS','What direction can I point you in?','What direction can I point you in?',26124),
(7064,'enUS','I need directions.','I need directions.',26124),
(7065,'enUS','There are many places that you might visit in Teldrassil.  Tell me what you seek.','There are many places that you might visit in Teldrassil.  Tell me what you seek.',26124),
(7066,'enUS','The Bank','The Bank',26124),
(7067,'enUS','The bank is located in the serene city of Darnassus.  You must go there if you wish to store your possessions.','The bank is located in the serene city of Darnassus.  You must go there if you wish to store your possessions.',26124),
(7068,'enUS','If a bank is what you desire, then your travels take you to the heart of Darnassus.  There you will find storage for your treasures.','If a bank is what you desire, then your travels take you to the heart of Darnassus.  There you will find storage for your treasures.',26124),
(7069,'enUS','Rut\'theran Ferry','Rut\'theran Ferry',26124),
(7070,'enUS','To reach the Rut\'theran Ferry, you will need to travel to Darnassus and take the portal to Rut\'theran Village at the base of Teldrassil.','To reach the Rut\'theran Ferry, you will need to travel to Darnassus and take the portal to Rut\'theran Village at the base of Teldrassil.',26124),
(7071,'enUS','Gryphons leave for Lor\'danel from Rut\'theran Village at the base of Teldrassil.  The portal in Darnassus will allow you to reach Rut\'theran safely.','Gryphons leave for Lor\'danel from Rut\'theran Village at the base of Teldrassil.  The portal in Darnassus will allow you to reach Rut\'theran safely.',26124),
(7072,'enUS','The Guild Master & Vendor.','The Guild Master & Vendor.',26124),
(7073,'enUS','Matters of such an official nature are only handled in Darnassus.  You must travel there to begin the process of your guild\'s creation.','Matters of such an official nature are only handled in Darnassus.  You must travel there to begin the process of your guild\'s creation.',26124),
(7074,'enUS','Documents such as guild creation papers can be acquired from the Guild Master in the city of Darnassus.  ','Documents such as guild creation papers can be acquired from the Guild Master in the city of Darnassus.  ',26124),
(7075,'enUS','The Inn','The Inn',26124),
(7076,'enUS','A restful sleep is sure to be had in the beds which Innkeeper Keldamyr keeps at the Inn in Dolanaar.  ','A restful sleep is sure to be had in the beds which Innkeeper Keldamyr keeps at the Inn in Dolanaar.  ',26124),
(7077,'enUS','If you require time to rest and regain your strength, you will find the best at the Inn in Dolanaar.  Innkeeper Keldamyr will see to it that you are taken care of.','If you require time to rest and regain your strength, you will find the best at the Inn in Dolanaar.  Innkeeper Keldamyr will see to it that you are taken care of.',26124),
(7078,'enUS','Class Trainer','Class Trainer',26124),
(7079,'enUS','You will find numerous trainers around Dolanaar with ages of experience with which to tutor you.  Which would you have me point you to?','You will find numerous trainers around Dolanaar with ages of experience with which to tutor you.  Which would you have me point you to?',26124),
(7080,'enUS','Druid','Druid',26124),
(7081,'enUS','You seek the aid of a Druid?  Then you should go see Kal at the Moonwell just south of the Inn in Dolanaar.','You seek the aid of a Druid?  Then you should go see Kal at the Moonwell just south of the Inn in Dolanaar.',26124),
(7082,'enUS','The druid, Kal, often spends his time at the moonwell in Dolanaar.  I am certain he would be able to provide you with the training you require.','The druid, Kal, often spends his time at the moonwell in Dolanaar.  I am certain he would be able to provide you with the training you require.',26124),
(7083,'enUS','Hunter','Hunter',26124),
(7084,'enUS','If a hunter is whom you seek, then it is Dazalar that you should visit.  He can usually be found just outside the Inn in Dolanaar.','If a hunter is whom you seek, then it is Dazalar that you should visit.  He can usually be found just outside the Inn in Dolanaar.',26124),
(7085,'enUS','Dazalar is well known around Dolanaar for his hunting skill.  Why don\'t you talk to him and see what he can teach you?','Dazalar is well known around Dolanaar for his hunting skill.  Why don\'t you talk to him and see what he can teach you?',26124),
(7086,'enUS','Priest','Priest',26124),
(7087,'enUS','A priestess by the name of Laurna Morninglight calls Dolanaar home.  I believe she can be found just north of the Inn.','A priestess by the name of Laurna Morninglight calls Dolanaar home.  I believe she can be found just north of the Inn.',26124),
(7088,'enUS','Laurna Morninglight offers healing to those that live around Dolanaar.  Perhaps she would be able to teach you in the ways of a priest.','Laurna Morninglight offers healing to those that live around Dolanaar.  Perhaps she would be able to teach you in the ways of a priest.',26124),
(7089,'enUS','Rogue','Rogue',26124),
(7090,'enUS','A rogue?  I\'m not in the habit of referring people to those types, but I believe Jannok would be the one you\'re looking for.  You will find him at the Inn in Dolanaar.','A rogue?  I\'m not in the habit of referring people to those types, but I believe Jannok would be the one you\'re looking for.  You will find him at the Inn in Dolanaar.',26124),
(7091,'enUS','You seek a rogue?  I believe Jannok would fit that description.  Why don\'t you go talk to him over at the Inn in Dolanaar.','You seek a rogue?  I believe Jannok would fit that description.  Why don\'t you go talk to him over at the Inn in Dolanaar.',26124),
(7092,'enUS','Warrior','Warrior',26124),
(7093,'enUS','Kyra Windblade wields her blade with great skill.  She should be able to provide you with some training.  You\'ll find her at the Inn in Dolanaar.','Kyra Windblade wields her blade with great skill.  She should be able to provide you with some training.  You\'ll find her at the Inn in Dolanaar.',26124),
(7094,'enUS','I had the pleasure of seeing Kyra Windblade in combat once.  Considering what I witnessed, I am confident she will train you well.  Look for her at the Inn in Dolanaar.','I had the pleasure of seeing Kyra Windblade in combat once.  Considering what I witnessed, I am confident she will train you well.  Look for her at the Inn in Dolanaar.',26124),
(7095,'enUS','Profession Trainer','Profession Trainer',26124),
(7096,'enUS','The path of those who undertake a profession is long and rewarding.  Which path do you choose to walk?','The path of those who undertake a profession is long and rewarding.  Which path do you choose to walk?',26124),
(7097,'enUS','Alchemy','Alchemy',26124),
(7098,'enUS','While Cyndra is not bubbly like her potions, her kind manner is suitable for teaching her trade.  You can find her just east of the Inn in Dolanaar.','While Cyndra is not bubbly like her potions, her kind manner is suitable for teaching her trade.  You can find her just east of the Inn in Dolanaar.',26124),
(7099,'enUS','Cyndra\'s knowledge in alchemy is somewhat limited, but I\'m sure it would be sufficient to get you started.  She practices her craft just east of the Inn in Dolanaar.','Cyndra\'s knowledge in alchemy is somewhat limited, but I\'m sure it would be sufficient to get you started.  She practices her craft just east of the Inn in Dolanaar.',26124),
(7100,'enUS','Cooking','Cooking',26124),
(7101,'enUS','Zarrin seems to have a good knowledge of the cooking trade.  Why don\'t you go see if he will show you some recipes?  He is usually cooking over by the Inn in Dolanaar.','Zarrin seems to have a good knowledge of the cooking trade.  Why don\'t you go see if he will show you some recipes?  He is usually cooking over by the Inn in Dolanaar.',26124),
(7102,'enUS','We could certainly use another cook around Dolanaar, not that Zarrin\'s cooking is lacking mind you.  Why don\'t you go see what he can teach you?','We could certainly use another cook around Dolanaar, not that Zarrin\'s cooking is lacking mind you.  Why don\'t you go see what he can teach you?',26124),
(7103,'enUS','Enchanting','Enchanting',26124),
(7104,'enUS','Alanna Raveneye attributes part of her talent in enchanting to her communion with the spirits at the Oracle Glade.  You should be able to find her there now.','Alanna Raveneye attributes part of her talent in enchanting to her communion with the spirits at the Oracle Glade.  You should be able to find her there now.',26124),
(7105,'enUS','Alanna spends most of her day at the Oracle Glade where she practices her profession.  Should you wish to learn the Enchanter\'s profession you will need to go there to find her.','Alanna spends most of her day at the Oracle Glade where she practices her profession.  Should you wish to learn the Enchanter\'s profession you will need to go there to find her.',26124),
(7106,'enUS','First Aid','First Aid',26124),
(7107,'enUS','Byancie has often lent her services to the sentinels who patrol the local wilds.  You should talk to her if you desire to learn First Aid.','Byancie has often lent her services to the sentinels who patrol the local wilds.  You should talk to her if you desire to learn First Aid.',26124),
(7108,'enUS','Byancie\'s skill in First Aid has proven useful on numerous occasions.  You can find her just north of the Inn in Dolanaar if you wish to learn from her.','Byancie\'s skill in First Aid has proven useful on numerous occasions.  You can find her just north of the Inn in Dolanaar if you wish to learn from her.',26124),
(7109,'enUS','Fishing','Fishing',26124),
(7110,'enUS','All the fisherman have moved to Darnassus with the recent attacks around Lake Al\'Ameth.  You should try looking for someone to train you there.','All the fisherman have moved to Darnassus with the recent attacks around Lake Al\'Ameth.  You should try looking for someone to train you there.',26124),
(7111,'enUS','The Timberlings have made it too difficult for the fishermen to catch anything around Dolanaar.  You best look for someone to train you in Darnassus.','The Timberlings have made it too difficult for the fishermen to catch anything around Dolanaar.  You best look for someone to train you in Darnassus.',26124),
(7112,'enUS','Herbalism','Herbalism',26124),
(7113,'enUS','Malorne somehow manages to pick the most delicate herbs without damaging them.  Certainly he is the one you should learn from.  He lives just east of the Inn in Dolanaar.','Malorne somehow manages to pick the most delicate herbs without damaging them.  Certainly he is the one you should learn from.  He lives just east of the Inn in Dolanaar.',26124),
(7114,'enUS','Herbalism requires a gentle touch that few such as Malorne can teach.  Seek him out east of the Inn in Dolanaar.','Herbalism requires a gentle touch that few such as Malorne can teach.  Seek him out east of the Inn in Dolanaar.',26124),
(7115,'enUS','Leatherworking','Leatherworking',26124),
(7116,'enUS','The Maneweavers practice their professions out of their home on the road to Darnassus.  Nadyia is an excellent teacher when it comes to Leatherworking.  You should see what she can teach you.','The Maneweavers practice their professions out of their home on the road to Darnassus.  Nadyia is an excellent teacher when it comes to Leatherworking.  You should see what she can teach you.',26124),
(7117,'enUS','Nadyia has made quite the leatherworker in her years of practice.  Travel west on the road to Darnassus to pay her a visit and maybe she can bestow some of her knowledge upon you.','Nadyia has made quite the leatherworker in her years of practice.  Travel west on the road to Darnassus to pay her a visit and maybe she can bestow some of her knowledge upon you.',26124),
(7118,'enUS','Skinning','Skinning',26124),
(7119,'enUS','Radnaal provides Nadyia with a good supply of leather from the animals he skins.  I recommend you speak with him if you wish to learn the profession.','Radnaal provides Nadyia with a good supply of leather from the animals he skins.  I recommend you speak with him if you wish to learn the profession.',26124),
(7120,'enUS','You can find Radnaal practicing his craft outside his home on the road to Darnassus.  You should stop by and see what he can teach you.','You can find Radnaal practicing his craft outside his home on the road to Darnassus.  You should stop by and see what he can teach you.',26124),
(7121,'enUS','Tailoring','Tailoring',26124),
(7122,'enUS','I am certain there is a Tailor that could provide you training in Darnassus.  When you arrive, ask one of the Sentinels in Darnassus about seeing a Tailor.','I am certain there is a Tailor that could provide you training in Darnassus.  When you arrive, ask one of the Sentinels in Darnassus about seeing a Tailor.',26124),
(7123,'enUS','Many of the supplies the tailors need come by way of Darnassus.  It is not surprising that they all moved there to work.  If you wish to be a tailor then you best head to Darnassus.','Many of the supplies the tailors need come by way of Darnassus.  It is not surprising that they all moved there to work.  If you wish to be a tailor then you best head to Darnassus.',26124),
(7124,'enUS','Help!  Please, you must help me!','',26124),
(7125,'enUS','Hello, $c. I\'ve set up camp here at the Bulwark to make my preparations for my journey into the Plaguelands. I\'ve heard rumor that a great human wizard took up residency in Hearthglen not terribly long ago. He was commissioned by the Scarlet Crusade to fashion their warriors and hunters new bows and guns. It\'s said that he was working on a remarkable weapon before the Crusade killed him.$B$BI guess their mistrust of the arcane has grown.','',26124),
(7126,'enUS','','Greetings, $c. Don\'t have too much time to talk--I\'m just using Chillwind as a camp to get some rest before heading to Hearthglen. I\'ve heard word that before they went crazy, the Scarlet Crusade had a mage working for them who was trying to create powerful bows and guns for their soldiers. I\'m not sure if he succeeded or not... the Crusade killed him before any of his finished product made it out. Maybe they killed him to keep it a secret... or maybe they distrust the arcane that much.',26124),
(7127,'enUS','','He... hello, $n. Sorry, I\'m recovering from my wounds.$B$BThose Scarlet Crusaders are tougher than I had given them credit for. They almost did me in.$B$BYou should be careful too. I\'d hate to see them get the jump on you.',26124),
(7128,'enUS','','My family worked  the Northridge Lumber Mill in what\'s now Western Plaguelands. They were dedicated to the Dumah family, and now the Scarlet Crusade have taken it over along with all of Hearthglen!$B$BI will not rest until those zealots are wiped from Azeroth.',26124),
(7129,'enUS','Long ago, before the last great war, my father ran the Northridge Lumber Mill. It was his life, and he was committed to it. Then the war came, and as much as it pained him, we had to flee to Stormwind.$B$BWe lost a number of friends and family in those days, and it pains me to know that the Scarlet Crusade has taken the mill for their own ends.$B$BThat\'s why I\'ve returned.','',26124),
(7130,'enUS','Greetings, $c.','',26124),
(7131,'enUS','Greetings, $c.','',26124),
(7132,'enUS','Greetings, $c.','',26124),
(7133,'enUS','I see those fools at the Abbey sent some fresh meat for us.','I see those fools at the Abbey sent some fresh meat for us.',26124),
(7134,'enUS','This land belongs to the Defias Brotherhood now!','This land belongs to the Defias Brotherhood now!',26124),
(7135,'enUS','We are the last of the furbolg race... The Timbermaw tribe remains uncorrupted, yet we face the same hostility from outsiders; most believe that it is not possible... that there could actually be furbolg that escaped the corruption...$B$BAngry at those that strive to make enemies too quickly, my brethren now attack any that draw near; they trust no one.$B$BBut perhaps, if you strive to make your presence peaceful with them, they might look upon you as an ally.','',26124),
(7136,'enUS','How can I prove myself to the Timbermaw furbolg?','How can I prove myself to the Timbermaw furbolg?',26124),
(7137,'enUS','You must find a way to show that you both are fighting for the same side. Although the Timbermaw may attack you now, if you are diligent, you will find a way.$B$BYou must remember that any attacks on the Timbermaw furbolg directly will greatly hinder your chances of gaining them as an ally.$B$BA good place to start would be the Deadwood furbolg found in many parts of Felwood. These furbolg are the enemy of the Timbermaw tribe, and slaying them would greatly improve your standing with the Timbermaw.','',26124),
(7138,'enUS','We Timbermaw can grant you safe passage through the hold, however, you must prove yourself worthy of our aid.','',26124),
(7139,'enUS','What about the Winterfall furbolg?','What about the Winterfall furbolg?',26124),
(7140,'enUS','The Winterfall furbolg that reside here in Winterspring were once our allies... But one day, that all changed.$B$BDriven by the strange demands of their high chief, they began to attack all others that they came in contact with, including our tribe. They keep to themselves now...','',26124),
(7141,'enUS','Please, do not bother me... Your kind is all the same...','',26124),
(7142,'enUS','I would like to buy from you.','I would like to buy from you.',26124),
(7143,'enUS','I trust very few of your kind, $n. But I can tell that you are a friend.','',26124),
(7144,'enUS','Yes, yes. I see you.$B$BBe on your way. You may have earned the trust of a few, but it will take more than that to prove it to me!','',26124),
(7145,'enUS','School is in session!','',26124),
(7146,'enUS','I have no time for you, $r. Continue on your way.','',26124),
(7147,'enUS','If you prove that you are a true ally, I might consider training you...','',26124),
(7148,'enUS','Welcome, $n! Are you interested in training in tailoring?','',26124),
(7149,'enUS','I\'d like to train.','I\'d like to train.',26124),
(7150,'enUS','I don\'t get paid enough for this!','I don\'t get paid enough for this!',26124),
(7151,'enUS','Time to take out the trash!','Time to take out the trash!',26124),
(7152,'enUS','I\'m going to dust you into oblivion!','I\'m going to dust you into oblivion!',26124),
(7153,'enUS','How dare you?!','How dare you?!',26124),
(7154,'enUS','Spot of tea, gov\'na?','Spot of tea, gov\'na?',26124),
(7155,'enUS','Do not turn your back on the Light, $c, it may be the one thing that saves you some day.','Do not turn your back on the Light, $c, it may be the one thing that saves you some day.',26124),
(7156,'enUS','I trust the Light is with you, $n. Is there something that I can I help you with?','I trust the Light is with you, $n. Is there something that I can I help you with?',26124),
(7157,'enUS','I seek more training in the priestly ways.','I seek more training in the priestly ways.',26124),
(7158,'enUS','The Light protect you, $c.','The Light protect you, $c.',26124),
(7159,'enUS','I hope the Light is with you, $n. Is there anything I can do for you today?','I hope the Light is with you, $n. Is there anything I can do for you today?',26124),
(7160,'enUS','I seek more training in the priestly ways.','I seek more training in the priestly ways.',26124),
(7161,'enUS','You be watchin\' yerself, $c. Respect our ways, or a curse be on you and yours.','You be watchin\' yerself, $c. Respect our ways, or a curse be on you and yours.',26124),
(7162,'enUS','I do what me can to train you in the priestly ways, if that what you be here for.','I do what me can to train you in the priestly ways, if that what you be here for.',26124),
(7163,'enUS','Yes, $c?','Yes, $c?',26124),
(7164,'enUS','What can this insignificant servant do for you, $n? Training perhaps?','What can this insignificant servant do for you, $n? Training perhaps?',26124),
(7165,'enUS','Elune be with you, $c.','Elune be with you, $c.',26124),
(7166,'enUS','My wisdom is yours, as is my knowledge. What can I do for you, $n?','My wisdom is yours, as is my knowledge. What can I do for you, $n?',26124),
(7167,'enUS','I seek more training in the priestly ways.','I seek more training in the priestly ways.',26124),
(7168,'enUS','I seek more training in the priestly ways.','I seek more training in the priestly ways.',26124),
(7169,'enUS','I seek more training in the priestly ways.','I seek more training in the priestly ways.',26124),
(7170,'enUS','I be seeking someone, $c. Please, leave me be... it is important I find them.','',26124),
(7171,'enUS','I be a messenger from the Eastern Kingdoms, $n. I be sent here to make sure da priests who travel here be given proper direction.','',26124),
(7172,'enUS','Be quiet!  Can\'t you see the master is speaking?','Be quiet!  Can\'t you see the master is speaking?',26124),
(7173,'enUS','Spend less time rattling and more time listening.','Spend less time rattling and more time listening.',26124),
(7174,'enUS','We must focus if we are to spawn our dragonflight!','We must focus if we are to spawn our dragonflight!',26124),
(7175,'enUS','Be silent!  I cannot afford to miss even a moment of this lecture!','Be silent!  I cannot afford to miss even a moment of this lecture!',26124),
(7176,'enUS','Did you forget your student\'s attire?  Do you think fashion is more vital than the Scourge\'s domination?','Did you forget your student\'s attire?  Do you think fashion is more vital than the Scourge\'s domination?',26124),
(7177,'enUS','Did you finish yesterday\'s assignment?  If so, then sit by me!','Did you finish yesterday\'s assignment?  If so, then sit by me!',26124),
(7178,'enUS','Watch your step in here, $gboy:girl;.  The master sees all...','Watch your step in here, $gboy:girl;.  The master sees all...',26124),
(7179,'enUS','Did you bring your text books?  Can I look on with you?','Did you bring your text books?  Can I look on with you?',26124),
(7180,'enUS','What, may I ask, are you doing here?  Put on your student\'s attire, and study!','',26124),
(7181,'enUS','Be silent!  Do you think our plagued dragons will hatch and train themselves?','',26124),
(7182,'enUS','Have you come from the Burning Steppes?  Do you have my black dragon eggs?','',26124),
(7183,'enUS','Your mind is unfocused.  Are you hiding something from me?','',26124),
(7185,'enUS','I sense a disturbance, lurking around you...','',26124),
(7186,'enUS','Your future is clouded.  Concentrate, and ask again.','',26124),
(7187,'enUS','You don\'t look like a student...','',26124),
(7188,'enUS','Now if you turn to page 34 in your text, you see an illustration of a dwarf undergoing dissection...','',26124),
(7189,'enUS','Take note of the delicacy of the plagued dragon\'s diet.  Only terrified flesh will suffice.','',26124),
(7190,'enUS','We await a batch of black dragon eggs from the Burning Steppes.  We believe that, through their study, we will advance our knowledge dramatically.','',26124),
(7191,'enUS','Our oldest clutch of dragons are still far from maturity, but with patience and study, we are confident the dragonflight will soon be ready.','',26124),
(7192,'enUS','From yesterday\'s field trip, Marduk showed us that the dragons will tolerate the meat of recently killed humanoids, but only if they died slowly and painfully.','',26124),
(7193,'enUS','Tomorrow we will begin training of our promising dragons, so don\'t forget your chew toys.','',26124),
(7194,'enUS','The Lich King\'s forces are building.  It is imperative that our timetable supports his plans.','',26124),
(7195,'enUS','When preparing the dragon\'s meal, be sure to torture the prisoner in view of the dragon.  It responds well to pre-meal entertainment.','',26124),
(7196,'enUS','This kodo sure looks nothing like the beast I originally lured!  I wonder if the kombobulator can be used on me.','This kodo sure looks nothing like the beast I originally lured!  I wonder if the kombobulator can be used on me.',26124),
(7197,'enUS','','The Plaguelands are an excellent place to strike against the Scourge!',26124),
(7198,'enUS','May I have another Dawn\'s Gambit, Betina?  I want to test it again...','May I have another Dawn\'s Gambit, Betina?  I want to test it again...',26124),
(7199,'enUS','','I\'ve run out of arrows! I\'m afraid if any more come you will need to take them on by yourself my friend.',26124),
(7200,'enUS','','Wait... did you hear that? Something approaches from the west!',26124),
(7201,'enUS','','Praise Elune! I don\'t know if I could have survived the day without you, friend.',26124),
(7202,'enUS','','My leg feels much better now, the remedy must be working. If you will excuse me, I must go report to my superiors about what has transpired here.\n',26124),
(7203,'enUS','Who dares to challenge me in my domain?!','',26124),
(7204,'enUS','','I just fired an arrow.',26124),
(7205,'enUS','End our suffering!','End our suffering!',26124),
(7206,'enUS','You must save him!','You must save him!',26124),
(7207,'enUS','Oh, Darrowshire!  I would give a thousand lives for you!','Oh, Darrowshire!  I would give a thousand lives for you!',26124),
(7208,'enUS','Do not fail us!','Do not fail us!',26124),
(7209,'enUS','The Light must prevail!','The Light must prevail!',26124),
(7210,'enUS','Beware Marduk!  Beware, or your strength will wither.','Beware Marduk!  Beware, or your strength will wither.',26124),
(7211,'enUS','I was devoured by Horgus!  I can still feel his teeth upon me!','I was devoured by Horgus!  I can still feel his teeth upon me!',26124),
(7212,'enUS','Captain Redpath!  How could you forsake us!','Captain Redpath!  How could you forsake us!',26124),
(7213,'enUS','%s takes in a deep breath...','%s takes in a deep breath...',26124),
(7214,'enUS','Well met, $c. You may speak to me unless you have direct business with my mistress Magatha.$B$BI deal with most of her tasks for her so she can concentrate on more important matters. Perhaps there are some things we could discuss before you seek audience with her?','',26124),
(7215,'enUS','Hello, $n.','',26124),
(7216,'enUS','Please, feel free to speak to me anytime, $n. You have served Magatha well. I am sure she will call upon you in the future.','',26124),
(7217,'enUS','Do not presume to speak to me as though you are my equal, $c. Sylvanas is my queen, and I will do as she bids.$B$BIf you do not show the proper respect, I assure you, we can find a more than suitable place for you in the Nether.$B$BBut there is no reason we cannot have words if you wish to aid the Dark Lady...','',26124),
(7218,'enUS','All members of the Horde are equal in my eyes, $n. We have all suffered many burdens, and if it were not for wisdom and honor, then we would be no better than the Scourge or my people while our blood was tainted by the demon Mannoroth.$B$BIt is your duty to aid the Horde and to defend our way of life. But it is also your duty to know when quarter and compassion should be given to friend and foe alike.$B$BUnderstand this well. This is the new Horde, not some demon-spawned army who lack freewill.','',26124),
(7219,'enUS','I am ready to hear your tale, Tirion.','I am ready to hear your tale, Tirion.',26124),
(7220,'enUS','I must apologize for not being entirely truthful with you in regards to my identity. I had to be certain that you could be trusted - few people would have selflessly lent assistance to an old and forgotten hermit.$B$BYou have proven yourself as one of those people: A person of integrity and honor.','',26124),
(7221,'enUS','Thank you, Tirion. What of your identity?','Thank you, Tirion. What of your identity?',26124),
(7222,'enUS','My son, Taelan, was only a child when I was found guilty of treason and banished from the Alliance to live a life in exile. I chose to remain here so that I could watch over him; to somehow insure that he would grow up an honorable man.$B$BAs I had hoped, he took my place as lord of Mardenholde; but in a cruel twist of fate, joined the ranks of the Scarlet Crusade. He is now their Highlord, $r.','',26124),
(7223,'enUS','That is terrible.','That is terrible.',26124),
(7224,'enUS','Indeed. The Scarlet Crusade are an aberration of the Order of the Silver Hand.$B$BYou must believe me, $r; Taelan is a good man. He needs guidance. He needs to remember... remember what it is to be noble and honorable. I know that in his heart, he knows what he does is wrong. Will you help him? Will you help him remember?','',26124),
(7225,'enUS','I will, Tirion.','I will, Tirion.',26124),
(7226,'enUS','Why is it that small creatures such as goblins are always fascinated with larger creatures?','Why is it that small creatures such as goblins are always fascinated with larger creatures?',26124),
(7227,'enUS','Ah!  My wounds are too severe.  Defenders, fight on without me!','',26124),
(7228,'enUS','Listen closely to what you are told and do not quickly trust, or distrust.  For even friends serve their own ends, $c.$B$BOur great Warchief knows this, and to prove that there are warlocks within the Horde who do not wish to destroy it from within or gain control over it, I have volunteered to aid our young leader in anyway I can.','',26124),
(7229,'enUS','Prepare for a severe beating.','',26124),
(7230,'enUS','I shall wear your entrails as a necklace.','',26124),
(7231,'enUS','I can smell your fear, $r.','',26124),
(7232,'enUS','If you run now, you may live.','',26124),
(7233,'enUS','How dare you!','',26124),
(7234,'enUS','Pathetic.','',26124),
(7235,'enUS','The reckoning is upon you, weakling!','',26124),
(7236,'enUS','Disappointing.','',26124),
(7237,'enUS','Is that the best you can do?','',26124),
(7238,'enUS','You weren\'t worth the energy expenditure. <Nathanos spits.>','',26124),
(7239,'enUS','Next time, bring friends.','',26124),
(7240,'enUS','I am now corrupting you...','',26124),
(7241,'enUS','Weapons Trainer','Weapons Trainer',26124),
(7242,'enUS','Woo Ping\'s stamina is simply astounding.  Watching him practice his weapon techniques for hours on end, I felt sorry for the practice dummy afterward.  I can\'t think of anyone better suited to train you in armed combat.','Woo Ping\'s stamina is simply astounding.  Watching him practice his weapon techniques for hours on end, I felt sorry for the practice dummy afterward.  I can\'t think of anyone better suited to train you in armed combat.',26124),
(7243,'enUS','Master Woo Ping has mastered nearly every weapon known to man.  He is especially deadly with his sword techniques.  He spends a good deal of time over in the Weller\'s Arsenal waiting on new shipments of weapons to arrive if you need some training.','Master Woo Ping has mastered nearly every weapon known to man.  He is especially deadly with his sword techniques.  He spends a good deal of time over in the Weller\'s Arsenal waiting on new shipments of weapons to arrive if you need some training.',26124),
(7244,'enUS','Weapons Trainer','Weapons Trainer',26124),
(7245,'enUS','Through the millennia, Ilyenia Moonfire has mastered numerous weapons and now offers to train others in their use.  You can find her at the Warrior\'s Terrace if you desire training.','Through the millennia, Ilyenia Moonfire has mastered numerous weapons and now offers to train others in their use.  You can find her at the Warrior\'s Terrace if you desire training.',26124),
(7246,'enUS','I received the majority of my weapons training from Ilyenia Moonfire in the Warrior\'s Terrace.  You would do well to seek her out if you desire to learn the use of a new weapon.  ','I received the majority of my weapons training from Ilyenia Moonfire in the Warrior\'s Terrace.  You would do well to seek her out if you desire to learn the use of a new weapon.  ',26124),
(7247,'enUS','Weapons Trainer','Weapons Trainer',26124),
(7248,'enUS','Between Bixi and Buliwyf, there ain\'t many weapons they haven\'t had the pleasure of slashing or smashing an orc with.  You can find them hanging out at the Timberline Arms weapon shop if ye need some training.','Between Bixi and Buliwyf, there ain\'t many weapons they haven\'t had the pleasure of slashing or smashing an orc with.  You can find them hanging out at the Timberline Arms weapon shop if ye need some training.',26124),
(7249,'enUS','Yer looking to learn how to use a new weapon are ye?  Well, ye should be talking to Bixi or Buliwyf over at the Timberline Arms weapon shop then $glad : lass;.  They know their weapons from axes to... uh... zweihanders.','Yer looking to learn how to use a new weapon are ye?  Well, ye should be talking to Bixi or Buliwyf over at the Timberline Arms weapon shop then $glad : lass;.  They know their weapons from axes to... uh... zweihanders.',26124),
(7251,'enUS','Looking to learn how to use a new weapon?  Find Sayoc and Hanashi inside Arms of Legend in the Valley of Honor.','Looking to learn how to use a new weapon?  Find Sayoc and Hanashi inside Arms of Legend in the Valley of Honor.',26124),
(7252,'enUS','Look for Sayoc and Hanashi at the Valley of Honor inside Arms of Legend.  Watch your tongue around them or Sayoc may decide to give a piece of you as a snack to Grinning Dog.','Look for Sayoc and Hanashi at the Valley of Honor inside Arms of Legend.  Watch your tongue around them or Sayoc may decide to give a piece of you as a snack to Grinning Dog.',26124),
(7253,'enUS','Weapon Master','Weapon Master',26124),
(7254,'enUS','Ah, you seek the wisdom of Ansekhwa.  Look for him on the lower rise at Thunder Bluff Weapons.','Ah, you seek the wisdom of Ansekhwa.  Look for him on the lower rise at Thunder Bluff Weapons.',26124),
(7255,'enUS','None are as skilled in the use of weapons as Ansekhwa.  It is said that he is guided by the spirits of the finest warriors of our honored ancestors.  Seek him out on the lower rise and he will teach you what you want to know.','None are as skilled in the use of weapons as Ansekhwa.  It is said that he is guided by the spirits of the finest warriors of our honored ancestors.  Seek him out on the lower rise and he will teach you what you want to know.',26124),
(7256,'enUS','Weapon Master','Weapon Master',26124),
(7257,'enUS','Archibald who you look for.  He outside weapon merchant shop on inner ring of War Quarter.','Archibald who you look for.  He outside weapon merchant shop on inner ring of War Quarter.',26124),
(7258,'enUS','Little forsaken know all weapons.  Him Archibald.  You find on inner ring of War Quarter.','Little forsaken know all weapons.  Him Archibald.  You find on inner ring of War Quarter.',26124),
(7259,'enUS','Weapon Master','Weapon Master',26124),
(7260,'enUS','It would be wise to explain to you the depths at which our enemies will go to to hide themselves under our noses.$B$BKnow this first and foremost: our enemy is the Shadow Council. No matter what task I give you, or who I ask you to act against, know that one simple fact.$B$BMany cults exist within the Council, but only to hide its actions against the foolish.$B$BGroups like the Burning Blade, the Argus Wake, and the Searing Blade are all tools of the Council. Consider them one and the same.','',26124),
(7261,'enUS','Well, well. Looks like we got ourselves some competition. Get \'em boys!','',26124),
(7262,'enUS','Ah, one of our own. It is good to see our numbers are growing so rapidly that I can no longer keep track of the faces of our members.$B$BThat fool Vol\'jin thinks I am working hard to cleanse the image of warlocks and prove we are his servants. Idiot! The Burning Legion will make ash of this entire world after it drains it completely.','',26124),
(7263,'enUS','Naive fool. The Burning Blade IS the Shadow Council! There are many cults and organizations under the Council\'s rule, but all of them are just extensions of their will. I may lead the Burning Blade, but I am still just as much a pawn to the Council as you are to me!$B$BLook at the Searing Blade--most of them think they are becoming the next rising group of powerful warlocks that they will replace the Shadow Council.','',26124),
(7264,'enUS','Haha! Save for their leaders--the satyr, Bazzalan, and the warlock Jergosh--yes, all of them. That is why I constantly send Vol\'jin\'s worshippers at them. It gives Vol\'jin the impression that I am weeding out the evil in the bowels of his great city. The victory is in reality two-fold: kill Thrall\'s faithful and test the strength of those in the Searing Blade to see if they are truly worthy of joining me.','',26124),
(7265,'enUS','I will make it known to you. You are obviously already proving yourself in our ranks to become a lieutenant so quickly. Perhaps you can return to me later and I will have tasks for you. The council adores those skilled in the arcane, but servants of all kinds are always welcome, no matter their profession.','',26124),
(7266,'enUS','You may speak frankly...','You may speak frankly...',26124),
(7267,'enUS','It is good to see the Burning Blade is taking over where the Shadow Council once failed.','It is good to see the Burning Blade is taking over where the Shadow Council once failed.',26124),
(7268,'enUS','So the Searing Blade is expendable?','So the Searing Blade is expendable?',26124),
(7269,'enUS','If there is anything you would have of me...','If there is anything you would have of me...',26124),
(7270,'enUS','I am now corrupted.','',26124),
(7271,'enUS','I\'m saved.','',26124),
(7272,'enUS','','So dark...',26124),
(7273,'enUS','','Is someone there? Tirion my old friend, is that you? Have you come to save us?',26124),
(7274,'enUS','','Are they all... dead?',26124),
(7275,'enUS','','The Sarkhoff\'s... sometimes the Sarkhoff\'s visit. They are good people.',26124),
(7276,'enUS','Being part of the Explorers\' League, I\'ve been hunting for artifacts in the area. Winterspring is said to contain very magical items... Most are highly guarded.','',26124),
(7277,'enUS','%s searches for a soul to swallow!','',26124),
(7278,'enUS','The solution is ready in my cauldron.  It\'s just the matter of treating both the unfinished key and the scarab.','',26124),
(7279,'enUS','It\'s done $n, and I think you\'ll be satisfied with the results.','',26124),
(7280,'enUS','The solution is ready in my cauldron.  It\'s just the matter of treating both the unfinished key and the scarab.','',26124),
(7281,'enUS','It\'s done $n, and I think you\'ll be satisfied with the results.','',26124),
(7282,'enUS','Captain Ballinda Stonehearth will soon arrive at her garrison.  A new battle will soon be joined!','',26124),
(7283,'enUS','Fresh troops flood to Iceblood Garrison!  Captain Galvangar will soon arrive, and a new battle will soon begin!','',26124),
(7284,'enUS','This is the Alterac Valley battlefield.  Both sides are still fighting.','',26124),
(7285,'enUS','Let\'s start a new battle, and beat the Horde this time!','Let\'s start a new battle, and beat the Horde this time!',26124),
(7286,'enUS','This is the Alterac Valley battlefield.  Currently both sides are at odds.','',26124),
(7287,'enUS','Let\'s start a new battle, and beat the Alliance this time!','Let\'s start a new battle, and beat the Alliance this time!',26124),
(7288,'enUS','Our forces are ready and eager.  Soon, Balinda Stonehearth will enter her outpost and the battle will begin anew!','',26124),
(7289,'enUS','Our general, Vanndar Stormpike, has fallen in battle!  The battle is lost!$B$BSpeak with our quartermaster and help rebuild our forces.','',26124),
(7290,'enUS','The horde general is defeated!$B$BThe Alliance is the victor, and the Horde now scrambles to rebuild its weakened forces.','',26124),
(7291,'enUS','Neither generals is spawned.','',26124),
(7293,'enUS','Drek\'Thar is defeated!  The Alliance is victorious... for now.$B$BSpeak with our quartermaster and aid in our reconstruction.','',26124),
(7294,'enUS','I\'m here!  Come and get me you alliance pansies!','',26124),
(7295,'enUS','Vanndar is here.  Come on, hordelings!  Show me what you got!','',26124),
(7296,'enUS','The Frostwolf General is dead!','',26124),
(7297,'enUS','The Stormpike General is dead!','',26124),
(7301,'enUS','Hey, look out with that kodo! You had better inspect that beast before I give you credit!','',26124),
(7302,'enUS','That kodo sure is a beauty.  Wait a minute, where are my bifocals?  Perhaps you should inspect the beast for me.','',26124),
(7303,'enUS','Ah...the wondrous sound of kodos.  I love the way they make the ground shake... inspect the beast for me.','',26124),
(7304,'enUS','How do the goblins ever manage to secure packs to these beasts?  Kodos are ten times the size!','How do the goblins ever manage to secure packs to these beasts?  Kodos are ten times the size!',26124),
(7305,'enUS','','These are dangerous times, adventurer. Walk lightly.',26124),
(7306,'enUS','I am ready for the illusion, Myranda.','I am ready for the illusion, Myranda.',26124),
(7307,'enUS','','Hello! What brings you to Winterspring? These cold and vast lands may seem dismal, but this is a place of many secrets...',26124),
(7308,'enUS','','Such sssorrow... The passst cannot be undone...',26124),
(7309,'enUS','','I will not forrrget what you have done...$B$BPleassse, leave meee...',26124),
(7310,'enUS','Hey, you call yourself a body guard? Get to work and protect us...','',26124),
(7311,'enUS','Mister body guard, are you going to earn your money or what?','',26124),
(7312,'enUS','You\'re fired! <Cough...Cork clears throat.> I mean, help!','',26124),
(7313,'enUS','I will lead us through Hearthglen to the forest\'s edge. From there, you will take me to my father.','',26124),
(7314,'enUS','Remove your disguise, lest you feel the bite of my blade when the fury has taken control.','',26124),
(7315,'enUS','Halt.','',26124),
(7316,'enUS','%s calls for his mount.','',26124),
(7317,'enUS','%s whinnies.','',26124),
(7318,'enUS','NOOOOOOOOOOOO!','',26124),
(7319,'enUS','Sir?','Sir?',26124),
(7320,'enUS','Something is wrong with the Highlord. Do something!','Something is wrong with the Highlord. Do something!',26124),
(7321,'enUS','What the...','What the...',26124),
(7322,'enUS','Hey, what\'s going on over there? Sir, are you alright? Sir??','Hey, what\'s going on over there? Sir, are you alright? Sir??',26124),
(7323,'enUS','Highlord Fordring, are you alright?','Highlord Fordring, are you alright?',26124),
(7324,'enUS','Run!','Run!',26124),
(7325,'enUS','It\'s Proudmoore! Get out of here!','It\'s Proudmoore! Get out of here!',26124),
(7326,'enUS','Here I am, alliance!  Take me down... if you can!','',26124),
(7327,'enUS','','For the Alliance!',26124),
(7328,'enUS','','Please speak with Sentinel Onaeya at Maestra\'s Post in Ashenvale, she will see to it that you are properly rewarded for your bravery this day.',26124),
(7329,'enUS','It\'s not much further. The main road is just up ahead.','',26124),
(7330,'enUS','Eeck! Demons appear hungry for the kodos!','',26124),
(7331,'enUS','What am I paying you for? The kodos are nearly dead!','',26124),
(7332,'enUS','Only if I were about five feet taller, then I would show these blasphemous demons a thing or two! Help!','',26124),
(7333,'enUS','Wow! We did it... not sure why we thought we needed the likes of you. Nevertheless, speak with Smeed Scrabblescrew; he will give you your earnings!\n','',26124),
(7334,'enUS','Blast those stupid centaurs! Sigh - well, it seems you kept your bargain. Up the road you shall find Smeed Scrabblescrew, he has your money.','',26124),
(7335,'enUS','The Alliance wins!','',26124),
(7336,'enUS','The Horde wins!','',26124),
(7337,'enUS','You disappoint me, Taelan. I had plans for you... grand plans. Alas, it was only a matter of time before your filthy bloodline would catch up with you.','',26124),
(7338,'enUS','It is as they say: Like father, like son. You are as weak of will as Tirion... perhaps more so. I can only hope my assassins finally succeeded in ending his pitiful life.','',26124),
(7339,'enUS','TEST - restart battlefield.','TEST - restart battlefield.',26124),
(7340,'enUS','Get out of here!','Get out of here!',26124),
(7341,'enUS','Don\'t let them catch you!','Don\'t let them catch you!',26124),
(7342,'enUS','She\'ll have our heads if we\'re caught!','She\'ll have our heads if we\'re caught!',26124),
(7343,'enUS','Do not lose hope, Darrowshire!  We will not fall!','',26124),
(7344,'enUS','The Light burns bright in you, Davil.  I will enjoy snuffing it out!','',26124),
(7345,'enUS','Now is the time, Davil.  Now is the time of your death!','',26124),
(7346,'enUS','Horgus, your nightmare ends!  Now!','',26124),
(7347,'enUS','For Darrowshire!','For Darrowshire!',26124),
(7348,'enUS','Our captain will save us!','Our captain will save us!',26124),
(7349,'enUS','Fight!  Fight for your families!','Fight!  Fight for your families!',26124),
(7350,'enUS','The Scourge will not prevail!','The Scourge will not prevail!',26124),
(7351,'enUS','Do not give up!  Shed your blood for Darrowshire!','Do not give up!  Shed your blood for Darrowshire!',26124),
(7352,'enUS','Fight, and we will win this day!','Fight, and we will win this day!',26124),
(7353,'enUS','Fight to your last breath, brothers and sisters!','Fight to your last breath, brothers and sisters!',26124),
(7354,'enUS','Go back to your Lich King, foul creatures!','Go back to your Lich King, foul creatures!',26124),
(7355,'enUS','Defenders of Darrowshire!  Rally!  We must prevail!','',26124),
(7356,'enUS','Darrowshire!  You are doomed!','',26124),
(7357,'enUS','Darrowshire is defeated!  Soon, all of Lordaeron will fall!','',26124),
(7358,'enUS','Darrowshire, to arms!  The Scourge approach!','Darrowshire, to arms!  The Scourge approach!',26124),
(7359,'enUS','The Grand Crusader has charged me with destroying you and your newfound friends, Taelan, but know this: I do this for pleasure, not of obligation or duty.','',26124),
(7360,'enUS','%s calls for his guardsmen.','',26124),
(7361,'enUS','The end is now, Fordring.','',26124),
(7362,'enUS','Sit and listen to my story, $r.','',26124),
(7363,'enUS','','Too much time has passed. We must try again later.',26124),
(7364,'enUS','','Ok, let\'s get going!',26124),
(7365,'enUS','','Remember, I need your help to properly channel. I will ask you to aid me several times on our path, so please be ready.',26124),
(7366,'enUS','Davil Lightfire is defeated!  Darrowshire is lost!','Davil Lightfire is defeated!  Darrowshire is lost!',26124),
(7367,'enUS','Davil Lightfire has succumbed to his wounds!','Davil Lightfire has succumbed to his wounds!',26124),
(7368,'enUS','Horgus is slain!  Take heart, defenders of Darrowshire!','Horgus is slain!  Take heart, defenders of Darrowshire!',26124),
(7369,'enUS','Captain Redpath is slain!','Captain Redpath is slain!',26124),
(7370,'enUS','Isillien!','',26124),
(7371,'enUS','This is not your fight, stranger. Protect yourself from the attacks of the Crimson Elite. I shall battle the Grand Inquisitor.','',26124),
(7372,'enUS','What have you done,  Isillien? You once fought with honor, for the good of our people... and now... you have murdered my boy... ','',26124),
(7373,'enUS','May your soul burn in anguish, Isillien! Light give me strength to battle this fiend.','',26124),
(7374,'enUS','Face me, coward. Face the faith and strength that you once embodied.','',26124),
(7375,'enUS','','This blue light... It\'s strange. What do you think it means?',26124),
(7376,'enUS','$g Hey there cutie, you looking for a ride to Grom\'gol? I hear it gets mighty steamy down in those jungles, maybe I could join you for a short vacation, show you a real jungle cat. : Come, take a trip to the wonderful, gorgeous, tropical jungles of Stranglethorn. That\'s right, you too can be spending your time sunbathing by the crystal blue waters while I stand here in this unbearable heat with nothing to look at but my brother Frezza all day! Enjoy your trip!;','$g Hey there cutie, you looking for a ride to Grom\'gol? I hear it gets mighty steamy down in those jungles, maybe I could join you for a short vacation, show you a real jungle cat. : Come, take a trip to the wonderful, gorgeous, tropical jungles of Stranglethorn. That\'s right, you too can be spending your time sunbathing by the crystal blue waters while I stand here in this unbearable heat with nothing to look at but my brother Frezza all day! Enjoy your trip!;',26124),
(7377,'enUS','Slip a little coin into the boss\'s hand and look what it gets ya. I love my job. Though, if I could find a way to get that little firecracker Snurk reassigned to this port....well, I can\'t imagine it any better. But I\'m betting that you aren\'t here about my business practices. You\'re looking for the Zeppelin to Undercity, am I right? Well that\'s great, because it docks right here behind me. Oh and hey, if you see Snurk, put a good word in for me, would ya?','Slip a little coin into the boss\'s hand and look what it gets ya. I love my job. Though, if I could find a way to get that little firecracker Snurk reassigned to this port....well, I can\'t imagine it any better. But I\'m betting that you aren\'t here about my business practices. You\'re looking for the Zeppelin to Undercity, am I right? Well that\'s great, because it docks right here behind me. Oh and hey, if you see Snurk, put a good word in for me, would ya?',26124),
(7378,'enUS','','Please, light this while I am channeling.',26124),
(7379,'enUS','','This is the place. Let\'s light it.',26124),
(7380,'enUS','','We\'ve found it!',26124),
(7381,'enUS','Enough!','',26124),
(7382,'enUS','%s laughs.','',26124),
(7383,'enUS','Did you really believe that you could defeat me? Your friends are soon to join you, Taelan.','',26124),
(7384,'enUS','%s turns his attention towards you.','',26124),
(7385,'enUS','','It is time for the final step; we must activate the altar.',26124),
(7386,'enUS','','I will read the words carved into the stone, and you must find a way to light it.',26124),
(7387,'enUS','','It... it is working!',26124),
(7388,'enUS','','What is happening? Look!',26124),
(7389,'enUS','','It has been many years...',26124),
(7390,'enUS','','Who has disturbed the altar of the goddess?',26124),
(7391,'enUS','','Please, priestesses, forgive us for our intrusion. We do not wish any harm here.',26124),
(7392,'enUS','','We only wish to know why the wildkin guard this area...',26124),
(7393,'enUS','','Enu thora\'serador. This is a sacred place.\n',26124),
(7394,'enUS','','We will show you...\n',26124),
(7395,'enUS','You will not make it to the forest\'s edge, Fordring.','',26124),
(7396,'enUS','The Nightmare is finally over!  Darrowshire, forgive me!','',26124),
(7397,'enUS','Pamela?  Are you there, honey?','',26124),
(7398,'enUS','Hahah!','',26124),
(7399,'enUS','','Daddy!',26124),
(7400,'enUS','','Daddy!  You\'re back!',26124),
(7401,'enUS','','Let\'s go play!  No, tell me a story, Daddy!  No... let\'s go pick flowers!  And play tea time!  I found my dollie, did I tell you?',26124),
(7402,'enUS','','I missed you so much, Daddy!',26124),
(7403,'enUS','I missed you too, honey.  And I\'m finally home...','',26124),
(7404,'enUS','The slain spirit of Lunaclaw stares at you intently, as though wanting something from you.','',26124),
(7405,'enUS','You have fought well, spirit.  I ask you to grant me the strength of your body and the strength of your heart.','You have fought well, spirit.  I ask you to grant me the strength of your body and the strength of your heart.',26124),
(7406,'enUS','The spirit looks intently into your eyes and grasps your hand.  You feel a warmth shoot through your body, almost knocking you to your knees.$B$BAs the warmth passes, you feel the slight presence of an ursine spirit within your being... bolstering your resolve.','',26124),
(7407,'enUS','The Scourge are defeated!  Darrowshire is saved!','The Scourge are defeated!  Darrowshire is saved!',26124),
(7408,'enUS','We have all been witness to terrible tragedies, but we must not let them drag us to despair.$B$BInstead, hold those memories close so that one day, we might find a reckoning.','',26124),
(7409,'enUS','I need another Relic Bundle!','I need another Relic Bundle!',26124),
(7410,'enUS','','Let\'s find the next one.',26124),
(7411,'enUS','','We must continue on now.',26124),
(7412,'enUS','','The altar is glowing! We have done it!',26124),
(7413,'enUS','','Look above you; thara dormil dorah... ',26124),
(7414,'enUS','','This gem once allowed direct communication with Elune, herself.',26124),
(7415,'enUS','','Through the gem, Elune channeled her infinite wisdom...',26124),
(7416,'enUS','','Anu\'dorini Talah. Ru shallora enudoril.\n',26124),
(7417,'enUS','','Realizing that the gem needed to be protected, we turned to the goddess herself.',26124),
(7418,'enUS','','Soon after, we began to have visions of a creature... A creature with the feathers of an owl, but the will and might of a bear...',26124),
(7419,'enUS','','It was on that day that the wildkin were given to us. Fierce guardians, the goddess assigned the wildkin to protect all of her sacred places.\n',26124),
(7420,'enUS','A thousand more like him exist. Ten thousand. Should one fall, another will rise to take the seat of power.','',26124),
(7421,'enUS','%s falls to one knee.','',26124),
(7422,'enUS','','But now, many years later, the wildkin have grown more feral, and without the guidance of the goddess, they are confused...\n',26124),
(7423,'enUS','Look what they did to my boy.','',26124),
(7424,'enUS','','Without a purpose, they wander... But many find their way back to the sacred areas that they once were sworn to protect.\n',26124),
(7425,'enUS','%s holds the limp body of Taelan Fordring and softly sobs.','',26124),
(7426,'enUS','Your death will not have been in vain, Taelan. A new Order is born on this day... an Order which will dedicate itself to extinguishing the evil that plagues this world. An evil that cannot hide behind politics and pleasantries.','',26124),
(7427,'enUS','','Wildkin are inherently magical; this power was bestowed upon them by the goddess.',26124),
(7428,'enUS','','Know that wherever you might find them in the world, they are protecting something of importance, as they were entrusted to do so long ago.',26124),
(7429,'enUS','Too long have I sat idle, gripped in this haze... this malaise, lamenting what could have been... what should have been.','',26124),
(7430,'enUS','This I promise... This I vow...','',26124),
(7431,'enUS','','Please, remember what we have shown you...',26124),
(7432,'enUS','','Farewell.\n',26124),
(7433,'enUS','Tragic. The elder Fordring lives on... You are too late, old man. Retreat back to your cave, hermit, unless you wish to join your son in the Twisting Nether.','',26124),
(7434,'enUS','','Thank you for your help, $n. I wish you well in your adventures. ',26124),
(7435,'enUS','','I want to stay here and reflect on what we have seen. Please see Erelas and tell him what we have learned.',26124),
(7436,'enUS','Then come, hermit!','',26124),
(7437,'enUS','The bear looks at you calmy and patiently, but says nothing.','',26124),
(7438,'enUS','The bear spirit looks upon you with a calm and peaceful gaze.  You hear a voice speak to you as though it was coming from the bear, but the creature makes no indication that it is speaking.$B$B\"Greetings, my young friend.  If you have come to me seeking guidance, then perhaps I can help you find what you seek.\"','',26124),
(7439,'enUS','What do you represent, spirit?','What do you represent, spirit?',26124),
(7440,'enUS','I represent the strength which bolsters you as a young druid.  I am the strength of the body, and the strength of the heart.  You have already come to know this in your training, and you draw upon this when you take on the aspect of the bear.$B$BContinue to keep the balance in all things, young one, and keep your perspective clear and true.  When you need me... I will be there for you.','',26124),
(7441,'enUS','I represent the strength which bolsters you as a young druid.  You have come to me to learn this strength, young one, and I will teach this to you.  I will teach you all that is the spirit bear, provided you will listen and understand.$B$BIn order to know what it means to draw upon my spirit, you need to understand the importance of the strength of the body, as well as the strength of the heart.','',26124),
(7442,'enUS','I seek to understand the importance of strength of the body.','I seek to understand the importance of strength of the body.',26124),
(7443,'enUS','Strength of the body is the power and swiftness of action.  You must keep yourself fit at all times, both physically and mentally.  The bear\'s girth highlights its strength, as it is a ferocious foe in combat.  The bear\'s girth, however, belies its lithe agility and sharp mind.  These are surprises you will use to your advantage.$B$BYou must rely on the strength of the bear\'s body in order to master the way of the Claw.','',26124),
(7444,'enUS','I seek to understand the importance of strength of the heart.','I seek to understand the importance of strength of the heart.',26124),
(7445,'enUS','Strength of the heart is what gives you the resolve to take action... action that is rooted in intents that are pure and forthright.  To keep the balance is not to be complacent or banal.$B$BYou must show resolve for that which you believe in, and you must be willing to fight for it.  The mother bear shows endless conviction in protecting her young, as does an elder bear protecting his den.  It is this resolve, this strength of heart, which you must come to know if you are to master the way of the Claw.','',26124),
(7446,'enUS','I have heard your words, Great Bear Spirit, and I understand.  I now seek your blessings to fully learn the way of the Claw.','I have heard your words, Great Bear Spirit, and I understand.  I now seek your blessings to fully learn the way of the Claw.',26124),
(7447,'enUS','It remains to be seen if you are ready, young one.  Even the wisest and oldest of druids are never truly ready when their ultimate time of testing comes.$B$BYou have heard my words, and now you must move on.  Heed what I have taught you.  There will be a time when you will have your strength tested.  You must face your foe as the bear would - with strength of body and with strength of heart.  Learn from the fight, young one.  Go... with my blessings.','',26124),
(7448,'enUS','Greetings, $c.  You are welcome in Nighthaven, as well as all of Moonglade.  The Cenarion Circle welcomes all beings who respect the authority and command of nature.$B$BWhile you are here, please be sure to preserve the balance in all things.  Disturbances are not welcome here, and our wardens are trained to cease all hostilities without question.','',26124),
(7449,'enUS','','Do you require an illusion?$B$BShould your illusion falter in the midst of your quest, return to me and I shall reapply the guise.$B$BShould you fail in your endeavors, do not give up! Return to me. I shall assist you until you have completed your objectives.',26124),
(7450,'enUS','Strive to keep the balance in all things, $c.  This is where true harmony lies.','Strive to keep the balance in all things, $c.  This is where true harmony lies.',26124),
(7451,'enUS','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to teach you.$B$BIt never hurts to reaffirm one\'s place within what I like to call the Great Balance.  As preservers of this balance, we must strive to continually keep our minds clear and our hearts strong.  Training helps us in this regard.','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to teach you.$B$BIt never hurts to reaffirm one\'s place within what I like to call the Great Balance.  As preservers of this balance, we must strive to continually keep our minds clear and our hearts strong.  Training helps us in this regard.',26124),
(7452,'enUS','I seek training as a druid.','I seek training as a druid.',26124),
(7453,'enUS','The battle is over, and the people of Darrowshire are saved.','',26124),
(7454,'enUS','The battle is over, and the people of Darrowshire are saved.$B$BThey are saved, $n, because of you.  You are truly a hero of Darrowshire.','',26124),
(7455,'enUS','A darkness had fallen over my eyes, but you tore me from my unholy reverie.  You saved me, $n.$B$BAnd now I beg you... to forgive me.','',26124),
(7456,'enUS','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BWe are the preservers of the balance, now and forever, with Malfurion watching over us.  Never forget this.','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BWe are the preservers of the balance, now and forever, with Malfurion watching over us.  Never forget this.',26124),
(7457,'enUS','Our master Malfurion has returned from the Dreaming, $c.  His is the light of a beacon that shows the way for us, and we must do everything in our power to preserve that light.','Our master Malfurion has returned from the Dreaming, $c.  His is the light of a beacon that shows the way for us, and we must do everything in our power to preserve that light.',26124),
(7458,'enUS','The blessings of Cenarius be yours, $c.','The blessings of Cenarius be yours, $c.',26124),
(7459,'enUS','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you!','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you!',26124),
(7460,'enUS','Even within cold, stone walls such as the ones that shelter this town, one may find tranquility and peace.  In fact, you may find them everywhere you are... simply look inside yourself for such balance.','Even within cold, stone walls such as the ones that shelter this town, one may find tranquility and peace.  In fact, you may find them everywhere you are... simply look inside yourself for such balance.',26124),
(7461,'enUS','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BThere will be a time soon where the call of the Emerald Dream will take hold in you.  You will hibernate for many years and walk amongst the purest of forms.  It is there and then that your ultimate training will take place.','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BThere will be a time soon where the call of the Emerald Dream will take hold in you.  You will hibernate for many years and walk amongst the purest of forms.  It is there and then that your ultimate training will take place.',26124),
(7462,'enUS','You merely prolong the inevitable. Succumb. She will free your misguided soul.','',26124),
(7463,'enUS','We work to preserve the balance as Cenarius teaches, $c.  His is the light of a beacon that shows the way for us, and we must do everything in our power to preserve that light.','We work to preserve the balance as Cenarius teaches, $c.  His is the light of a beacon that shows the way for us, and we must do everything in our power to preserve that light.',26124),
(7464,'enUS','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BWe are the preservers of the balance, now and forever, as Cenarius has taught us.  Never forget this.','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BWe are the preservers of the balance, now and forever, as Cenarius has taught us.  Never forget this.',26124),
(7465,'enUS','','Thanks again, $n! I\'m very pleased with what we found.$B$BGood luck to you!',26124),
(7466,'enUS','','I\'m getting ready to travel up the ridge, $n. I could use some help -- would you like to come with me?',26124),
(7467,'enUS','','%s begins chanting a strange spell...',26124),
(7468,'enUS','Are you ready to fetch, boy?','',26124),
(7469,'enUS','%s barks in anticipation.','',26124),
(7470,'enUS','Go get it!!','',26124),
(7471,'enUS','Redpath!  Your life ends, here and now!','',26124),
(7472,'enUS','I am unable to train you.','I am unable to train you.',26124),
(7473,'enUS','Good boy! Now put it back on the bone pile.','',26124),
(7474,'enUS','I am looking for some bodyguards that would like to protect the Gizelton Caravan. We are stopped on the road east of Kormek\'s Hut, north of Kolkar Centaur Village.','',26124),
(7475,'enUS','This is Rigger Gizelton asking for assistance escorting my caravan past Mannoroc Coven. I\'m on the road east of Shadowprey village.','',26124),
(7476,'enUS','I don\'t train your kind $c.','I don\'t train your kind $c.',26124),
(7477,'enUS','We are but darkness and shadows. Eternal. Invisible.','We are but darkness and shadows. Eternal. Invisible.',26124),
(7478,'enUS','I seek training.','I seek training.',26124),
(7479,'enUS','Greetings young rogue. What do you seek?','Greetings young rogue. What do you seek?',26124),
(7480,'enUS','I can not train you. You need to talk to your class trainer.','I can not train you. You need to talk to your class trainer.',26124),
(7481,'enUS','Can\'t help ya, $n. I only train rogues.','Can\'t help ya, $n. I only train rogues.',26124),
(7482,'enUS','Can\'t help ya, $n. I only train rogues.','Can\'t help ya, $n. I only train rogues.',26124),
(7483,'enUS','Sorry, but I only train rogues.','Sorry, but I only train rogues.',26124),
(7484,'enUS','Ah... a customer! Talk to my greatest invention, the Vendor-Tron 1000. He has all your needs... some of the rarest items you will ever find on the market anywhere in Kalimdor... not to mention that his programming will not allow any bargaining, so the price you see is the price you pay.','',26124),
(7486,'enUS','No doubt you are another inept simpleton sent from the Dark Lady to train under her champion.$B$B<Nathanos sighs.>$B$BI\'ve sent every one of you back to her in pieces, I don\'t see why it will be any different this time.$B$BMine, however, is not to question why, but instead to do as the Dark Lady bids.','',26124),
(7487,'enUS','Let me take a look at what you have to offer.','Let me take a look at what you have to offer.',26124),
(7488,'enUS','This just happens to be your lucky day; I just completed Super-Seller 680\'s maintenance. There are tons of items for sell at great low-low prices. Go ahead and see for yourself... my brother Cork thinks his Vendor-Tron 1000 will out sell my bot.','',26124),
(7489,'enUS','What kin I do for ye, $n?','What kin I do for ye, $n?',26124),
(7490,'enUS','I\'m lookin\' for rogue trainin\'.','I\'m lookin\' for rogue trainin\'.',26124),
(7491,'enUS','Can you train me how to use rogue skills?','Can you train me how to use rogue skills?',26124),
(7492,'enUS','You look like the type I should watch my coin purse around. Something I can help you with?','You look like the type I should watch my coin purse around. Something I can help you with?',26124),
(7493,'enUS','I don\'t think you want to learn anything I can teach. Might want to find a $c trainer to help you out.','I don\'t think you want to learn anything I can teach. Might want to find a $c trainer to help you out.',26124),
(7494,'enUS','Come to learn from the master eh?','Come to learn from the master eh?',26124),
(7495,'enUS','Yes, I have. Teach me.','Yes, I have. Teach me.',26124),
(7496,'enUS','Do I look like a $c to you? Now run along before I feel the need to oil my blade... in your blood.','Do I look like a $c to you? Now run along before I feel the need to oil my blade... in your blood.',26124),
(7497,'enUS','Elune be with you, $c.','',26124),
(7498,'enUS','Greetings, my friend.  May the Dawn keep you well in these troubled times.','',26124),
(7499,'enUS','Not so fast, $g guy : lady;... I\'ll not be handing out the reigns of a mighty ram steed to someone that\'s not a proven ally of the dwarves of Ironforge.  Once you\'ve been recognized as friendly to Ironforge, I\'ll gladly show you what varieties of rams I have for sale.','Not so fast, $g guy : lady;... I\'ll not be handing out the reigns of a mighty ram steed to someone that\'s not a proven ally of the dwarves of Ironforge.  Once you\'ve been recognized as friendly to Ironforge, I\'ll gladly show you what varieties of rams I have for sale.',26124),
(7500,'enUS','My programming will not allow me to lower the cost of any items.','',26124),
(7501,'enUS','I am curious to see what a bucket of bolts has to offer.','I am curious to see what a bucket of bolts has to offer.',26124),
(7503,'enUS','You\'ve not had a steed until you\'ve taken the reigns of a finely bred Barak Tor\'ol mountain ram, my friend.  Please, feel free to inspect these fine companions to any adventurer.  They\'ll serve you well, believe me.','You\'ve not had a steed until you\'ve taken the reigns of a finely bred Barak Tor\'ol mountain ram, my friend.  Please, feel free to inspect these fine companions to any adventurer.  They\'ll serve you well, believe me.',26124),
(7504,'enUS','I am the latest incarnation of automated vendors... we will rule the world one day... don\'t tell my boss that I am skimming money off his merchandise...','',26124),
(7505,'enUS','So sorry to leave a customer but we have places to go and people to swindle. We will be back sometime later today. Good-bye!','',26124),
(7506,'enUS','Time for the Gizleton Caravan to head on out! We\'ll be back soon but if you cannot wait, head north to Kormek\'s Hut. We open shop in about an hour.','',26124),
(7507,'enUS','Sorry, but I am not disposed to sell horses to any individual who is not considered to be at least friendly to the Kingdom of Stormwind.  These steeds are the finest you\'ll find anywhere, and we certainly wouldn\'t want them in the hands of our enemies.$B$BNot saying you\'re an enemy, of course... just earn the trust of Stormwind and then we can do business.','Sorry, but I am not disposed to sell horses to any individual who is not considered to be at least friendly to the Kingdom of Stormwind.  These steeds are the finest you\'ll find anywhere, and we certainly wouldn\'t want them in the hands of our enemies.$B$BNot saying you\'re an enemy, of course... just earn the trust of Stormwind and then we can do business.',26124),
(7508,'enUS','Years of quality breeding techniques and plenty of care allow me the privilege of showing you these horses!  Please, take your time as you consider them for your mount.  A horse is a companion for the ages, friend.  Don\'t sell yourself short - get your steed here today!','Years of quality breeding techniques and plenty of care allow me the privilege of showing you these horses!  Please, take your time as you consider them for your mount.  A horse is a companion for the ages, friend.  Don\'t sell yourself short - get your steed here today!',26124),
(7509,'enUS','Let me browse your goods.','Let me browse your goods.',26124),
(7510,'enUS','You are not known to my people.  A kodo is a mighty steed, and it is the product of love and care by my people; such is not given onto strangers.  Until the elders of Thunder Bluff consider you to be a friend, I cannot offer you the sale of a kodo.','You are not known to my people.  A kodo is a mighty steed, and it is the product of love and care by my people; such is not given onto strangers.  Until the elders of Thunder Bluff consider you to be a friend, I cannot offer you the sale of a kodo.',26124),
(7511,'enUS','Before beginning a hunt, it is wise to ask someone what you are looking for before you begin looking for it.','Before beginning a hunt, it is wise to ask someone what you are looking for before you begin looking for it.',26124),
(7512,'enUS','Kodo beasts, my friend!  Trained from a young age and raised on the Golden Plains of Mulgore, these fine animals will make even finer steeds!  Please, browse my selection, and see for yourself why we taurens have come to rely on these magnificant creatures!','Kodo beasts, my friend!  Trained from a young age and raised on the Golden Plains of Mulgore, these fine animals will make even finer steeds!  Please, browse my selection, and see for yourself why we taurens have come to rely on these magnificant creatures!',26124),
(7513,'enUS','Welcome to the Cenarion Circle, $c.','Welcome to the Cenarion Circle, $c.',26124),
(7514,'enUS','I\'d like to train.','I\'d like to train.',26124),
(7515,'enUS','I am here for training.','I am here for training.',26124),
(7516,'enUS','Let me train you in the ways of the hunter.','Let me train you in the ways of the hunter.',26124),
(7517,'enUS','I am in need of training.','I am in need of training.',26124),
(7518,'enUS','I have much knowledge to impress upon you, $c. You must learn to hunt with honor.','I have much knowledge to impress upon you, $c. You must learn to hunt with honor.',26124),
(7519,'enUS','I have come for training.','I have come for training.',26124),
(7520,'enUS','I train hunters in the ways and traditions of our ancestors.','I train hunters in the ways and traditions of our ancestors.',26124),
(7521,'enUS','I am in need of training.','I am in need of training.',26124),
(7522,'enUS','Tauren have a passion for hunting; it is something that runs deep with our kind.','Tauren have a passion for hunting; it is something that runs deep with our kind.',26124),
(7523,'enUS','I am a hunter and wish to train.','I am a hunter and wish to train.',26124),
(7524,'enUS','The Royal Apothecary Society has little patience for fools, as do I.  Perhaps the next time you and I speak of my steeds, you will be considered a friend of the Undercity.  Until then...','The Royal Apothecary Society has little patience for fools, as do I.  Perhaps the next time you and I speak of my steeds, you will be considered a friend of the Undercity.  Until then...',26124),
(7525,'enUS','On behalf of the Royal Apothecary Society, I am pleased to offer you the finest steeds available for the Forsaken.  These beasts have endured trials and tribulations as we all have, and now they too have emerged stronger and more resilient than mere mortal flesh would have had them destined to be!  Please, inspect them for yourself and see.','On behalf of the Royal Apothecary Society, I am pleased to offer you the finest steeds available for the Forsaken.  These beasts have endured trials and tribulations as we all have, and now they too have emerged stronger and more resilient than mere mortal flesh would have had them destined to be!  Please, inspect them for yourself and see.',26124),
(7526,'enUS','Come learn the ways of the hunter. Pride, honor, and tradition.','Come learn the ways of the hunter. Pride, honor, and tradition.',26124),
(7527,'enUS','I can teach you the finer points of Ram Riding, provided you have enough gold to cover the lesson!','I can teach you the finer points of Ram Riding, provided you have enough gold to cover the lesson!',26124),
(7528,'enUS','I\'d like to train.','I\'d like to train.',26124),
(7529,'enUS','I train and guide young hunters in the traditions passed down many generations.','I train and guide young hunters in the traditions passed down many generations.',26124),
(7530,'enUS','I can teach you the finer points of Mechanostrider Piloting, provided you have enough gold to cover the lesson!','I can teach you the finer points of Mechanostrider Piloting, provided you have enough gold to cover the lesson!',26124),
(7531,'enUS','I can teach you the finer points of Horse Riding, provided you have enough gold to cover the lesson!','I can teach you the finer points of Horse Riding, provided you have enough gold to cover the lesson!',26124),
(7532,'enUS','I can teach you the finer points of Tiger Riding, provided you have enough gold to cover the lesson!','I can teach you the finer points of Tiger Riding, provided you have enough gold to cover the lesson!',26124),
(7533,'enUS','I can teach you the finer points of Kodo Riding, provided you have enough gold to cover the lesson!','I can teach you the finer points of Kodo Riding, provided you have enough gold to cover the lesson!',26124),
(7534,'enUS','I can teach you the finer points of Raptor Riding, provided you have enough gold to cover the lesson!','I can teach you the finer points of Raptor Riding, provided you have enough gold to cover the lesson!',26124),
(7535,'enUS','I can teach you the finer points of Skeletal Horse Riding, provided you have enough gold to cover the lesson!','I can teach you the finer points of Skeletal Horse Riding, provided you have enough gold to cover the lesson!',26124),
(7536,'enUS','I can teach you the finer points of Wolf Riding, provided you have enough gold to cover the lesson!','I can teach you the finer points of Wolf Riding, provided you have enough gold to cover the lesson!',26124),
(7537,'enUS','You need to be friendly with the dwarves of Ironforge before I will teach you a riding skill, $c.','You need to be friendly with the dwarves of Ironforge before I will teach you a riding skill, $c.',26124),
(7538,'enUS','You need to be friendly with the orcs of Orgrimmar before I will teach you a riding skill, $c.','You need to be friendly with the orcs of Orgrimmar before I will teach you a riding skill, $c.',26124),
(7539,'enUS','You need to be friendly with the trolls of the Darkspear tribe before I will teach you a riding skill, $c.','You need to be friendly with the trolls of the Darkspear tribe before I will teach you a riding skill, $c.',26124),
(7540,'enUS','','Thanks $n.  Now let\'s get out of here!',26124),
(7541,'enUS','You need to be friendly with the tauren of Thunder Bluff before I will teach you a riding skill, $c.','You need to be friendly with the tauren of Thunder Bluff before I will teach you a riding skill, $c.',26124),
(7542,'enUS','You need to be friendly with the humans of Stormwind before I will teach you a riding skill, $c.','You need to be friendly with the humans of Stormwind before I will teach you a riding skill, $c.',26124),
(7543,'enUS','You need to be friendly with the night elves of Darnassus before I will teach you a riding skill, $c.','You need to be friendly with the night elves of Darnassus before I will teach you a riding skill, $c.',26124),
(7544,'enUS','','We made it!  Thanks again!  I\'m going to run ahead!',26124),
(7545,'enUS','You need to be friendly with the gnomes of the Gnomeregan Exiles before I will teach you how to pilot a Mechanostrider, $c.','You need to be friendly with the gnomes of the Gnomeregan Exiles before I will teach you how to pilot a Mechanostrider, $c.',26124),
(7546,'enUS','You need to be friendly with the Forsaken of the Undercity before I will teach you a riding skill, $c.','You need to be friendly with the Forsaken of the Undercity before I will teach you a riding skill, $c.',26124),
(7547,'enUS','I\'d be wasting both your gold and my time if I were to teach you how to pilot a Mechanostrider, $c.  You\'re just too large!','I\'d be wasting both your gold and my time if I were to teach you how to pilot a Mechanostrider, $c.  You\'re just too large!',26124),
(7548,'enUS','I seek training to ride a steed.','I seek training to ride a steed.',26124),
(7549,'enUS','Please train me.','Please train me.',26124),
(7550,'enUS','','Hey Hornizz!  I\'m back!  And there are some people behind me who helped me out of a jam.',26124),
(7551,'enUS','','We\'re going to have to scratch the Maraudines off our list.  Too hard to work with...',26124),
(7552,'enUS','','Well, I\'m off to the Gelkis.  They\'re not as dumb as the Maraudines, but they\'re more reasonable.',26124),
(7553,'enUS','Bye!  Better luck next time!','',26124),
(7554,'enUS','Always on the go, that girl.','',26124),
(7555,'enUS','Remember, all things are connected. If the beasts were gone from the land, our kind would die from a great loneliness of spirit, for whatever happens to the beasts also happens to the Tauren. Whatever befalls Azeroth befalls all those that inhabit it.','Remember, all things are connected. If the beasts were gone from the land, our kind would die from a great loneliness of spirit, for whatever happens to the beasts also happens to the Tauren. Whatever befalls Azeroth befalls all those that inhabit it.',26124),
(7556,'enUS','I wish to train.\n','I wish to train.\n',26124),
(7557,'enUS','If you\'re here to be trained in the tactics and strategy of hunting, you\'ve come to the right place!','If you\'re here to be trained in the tactics and strategy of hunting, you\'ve come to the right place!',26124),
(7558,'enUS','I am here for training.','I am here for training.',26124),
(7559,'enUS','Hey mon! You\'ve ever been diving deep in the ocean? I\'ll let you in on a little secret, eh. Deep in the ocean you can find bubbly fissures; they\'ll allow you to breathe air while underwater.  Let\'s keep this secret between you and me though, eh. I don\'t need no competition for me shellfish traps elsewhere... if you get my drift!\n','',26124),
(7561,'enUS','Impossible! Stay your attack, mortals... I submit! I submit!','',26124),
(7562,'enUS','','The flutter of the wings of a hawk, the breath of a ram in the snow, the pace of a bear through the forest... Such is life for the hunter.',26124),
(7563,'enUS','I would like to train.','I would like to train.',26124),
(7564,'enUS','','Look at the wisdom and knowledge of the beast, and you will see yourself. Observe as the owl does, learn cleverness from the sabercat, embody the mighty spirit of the wolf.',26124),
(7565,'enUS','Please train me.','Please train me.',26124),
(7566,'enUS','The runes of warding have been destroyed! Hunt down the infidels, my brethren!','',26124),
(7567,'enUS','Brashly, you have come to wrest the secrets of the Living Flame! You will soon regret the recklessness of your quest.','',26124),
(7568,'enUS','I go now to summon the lord whose house this is. Should you seek an audience with him, your paltry lives will surely be forfeit! Nevertheless, seek out his lair, if you dare!','',26124),
(7569,'enUS','[PH] Ok, I\'m outta here... see you in Ragnaros\' Lair... l8','',26124),
(7570,'enUS','%s splits into two new Lava Spawns!','',26124),
(7571,'enUS','I just finished wandering.','',26124),
(7572,'enUS','','You\'re not a druid!',26124),
(7573,'enUS','I\'d like to fly to Rut\'theran Village.','I\'d like to fly to Rut\'theran Village.',26124),
(7574,'enUS','','Would you like a flight to Rut\'theran Village, courtesy of the Cenarion Circle?',26124),
(7575,'enUS','','If you\'re looking for a flight back to Thunder Bluff, then you should talk to my tauren counterpart, Bunthen Plainswind.',26124),
(7576,'enUS','You\'re not a druid!','',26124),
(7577,'enUS','Would you like a flight to Thunder Bluff, courtesy of the Cenarion Circle?','',26124),
(7578,'enUS','If you\'re looking for a flight back to Rut\'theran Village, then you should talk to my night elven counterpart, Silva Fil\'naveth.','',26124),
(7579,'enUS','You\'ve interfered with our plans for the last time, foolish $c!','You\'ve interfered with our plans for the last time, foolish $c!',26124),
(7580,'enUS','%s begins countdown.','',26124),
(7581,'enUS','%s disabled ghost region.','',26124),
(7582,'enUS','','You\'ve interfered with our plans for the last time, foolish $c!',26124),
(7583,'enUS','%s is angered!','',26124),
(7584,'enUS','The times we live in are as fickle as the shifting winds, $c. The ground itself quakes and cries out in anguish. We must remain resolute or we ourselves will be engulfed by the turmoil.','',26124),
(7585,'enUS','%s is drawn to the ghost magnet...','',26124),
(7586,'enUS','No other race on Azeroth has suffered as much as our people, $c. To laugh in the face of death has become second nature for all of us.','',26124),
(7587,'enUS','Be prepared. Today, we will teach the quilboar much regret, sorrow, and fear, in the name of our Greatmother.','',26124),
(7588,'enUS','Ah, the beauty of Shadowglen never ceases to delight my senses!','',26124),
(7589,'enUS','Once ye\'ve seen one trogg, ye\'ve seen \'em all.','',26124),
(7590,'enUS','Hey, citizen!  You look like a stout one.  We guards are spread a little thin out here, and I could use your help...','',26124),
(7591,'enUS','The land of Azshara.','The land of Azshara.',26124),
(7592,'enUS','My knowledge of night elf lore is limited, but it is said long ago--back when the night elves still held sacred the art of arcane spell casting--that Azshara was the greatest of their kind. A beautiful woman they named queen. Sadly, it was her addiction to the arcane that would one day be the catalyst for the most devastating events in this world\'s history.','',26124),
(7593,'enUS','The Ruins of Eldarath.','The Ruins of Eldarath.',26124),
(7594,'enUS','The mage tower to the north.','The mage tower to the north.',26124),
(7595,'enUS','','Assassins! Guards! Guards!',26124),
(7596,'enUS','','I sense danger up ahead.',26124),
(7597,'enUS','','My back is killing me.',26124),
(7598,'enUS','','These orders must get to High General Abbendis!',26124),
(7599,'enUS','','If I should fall, take my pouch. Make certain that it gets to the High General.',26124),
(7600,'enUS','The Timbermaw furbolgs.','The Timbermaw furbolgs.',26124),
(7601,'enUS','The presence of blue dragons.','The presence of blue dragons.',26124),
(7602,'enUS','Because you have aided me, I will tell you what I know of this land and of the things there are to see. My knowledge is not vast, but perhaps I can point out some things that might interest one such as yourself.','',26124),
(7603,'enUS','Once a great city of the night elves, the Highborne once ruled there, practicing great and powerful arcane magics. They are cursed now, haunting the lands, and their ruined city has been victimized by the Spitelash naga. I understand that the naga search the ruins for powerful Highborne artifacts.','',26124),
(7604,'enUS','A powerful human mage is rumored to live to the north; he keeps watch over the land for some unknown reason. I have not traveled there myself, but it is said that visitors are welcome and can even earn favor with him if they are willing to do errands for him.','',26124),
(7605,'enUS','I\'ve seen terrible things happen to the furbolg over the last few years--they were victims on many fronts. But it\'s unclear to me what\'s become of this tribe. Are they corrupted by the same plague that\'s touched Felwood? Or perhaps they are simply angry at what\'s happened to their once peaceful people and now seek to defend themselves. Either way, most of them appear hostile to those who come into the area.','',26124),
(7606,'enUS','The blue dragons themselves aren\'t here, but followers of Malygos are. I do not know why, but I can tell you this: wherever the blue dragons are, expect to find arcane magic. I wouldn\'t be surprised if the dragonspawn are here protecting something... perhaps something the Highborne left behind.','',26124),
(7607,'enUS','','I should find some hired help; I don\'t like sitting here all day selling fish supplies. I\'d much rather go fishing, and then sell supplies.',26124),
(7608,'enUS','Let\'s take a look at your fishing supplies.','Let\'s take a look at your fishing supplies.',26124),
(7610,'enUS','','Throm-Ka, $c. My mood is poor this day, so please, unless you can help me, I would prefer to be alone.',26124),
(7611,'enUS','','Good work, $n!  Complete your trial by speaking with me.  Time continues to slip away until you do so!',26124),
(7612,'enUS','Reckless mortals! None may challenge the Sons of the Living flame!','',26124),
(7613,'enUS','I can not train you, $c.','I can not train you, $c.',26124),
(7614,'enUS','I am Ulysses Rackmore, captain of the Gallant.  And this is the log of the last few days of my doomed ship.$B$BWe were sailing to Feathermoon Stronghold with a shipment of supplies when naga stormed the sides of the Gallant.  We drove them back but we knew they\'d return.  Fearing the loss of my most precious belongings, I steered the Gallant to an island off the coast of Desolace, one with old, night elf ruins.  And there I left my treasure chest.','',26124),
(7615,'enUS','Continue reading...','Continue reading...',26124),
(7616,'enUS','My chest is one of ingenious design, and requires two keys to unlock, one gold and one silver.  The first key, the silver key, I gave to my first mate, and I kept the gold.$B$BBut we were doomed to lose them.  My key was lost during the next naga attack, and my first mate\'s was lost a day later when drysnap makrura assailed us and pulled him into the deep.$B$BI am sure the naga and makrura have the keys.  I am glad the two are enemies and will not share them.','',26124),
(7617,'enUS','After the makrura attack, we could see that the Gallant would not survive another.  So I and the few surviving sailors abandoned my ship.$B$BWe are now ashore and will soon strike out for the town of Nijel\'s Point, but much danger lies between us and sanctuary, and I fear Desolace will consume us.$B$BI write this now in hopes that someone will know our plight, and some day avenge us against the watery fiends who were our ruin.','',26124),
(7618,'enUS','','The Shrine of Remulos is a sacred place for us in the Cenarion Circle here in Moonglade... so please conduct yourself in a manner befitting a visitor.$B$BA visitor who doesn\'t want my scimitar buried in them, that is.',26124),
(7619,'enUS','','May Cenarius watch over you, $g brother : sister;.$B$BI am Tajarri, and I am a sworn protector of this shrine.  It is my honor to serve Keeper Remulos as a warden of this sacred land.',26124),
(7620,'enUS','Before the Scourge came, I had a great business.  I bought and sold everything.  Everything!$B$BAnd my prices were INSANE!$B$BJust ask anyone.  Anyone who\'s not dead.','',26124),
(7621,'enUS','Hi $n!  Are you here to buy something?  Or maybe sell something?$B$BYou won\'t find better prices anywhere, or my name isn\'t Augustus the Touched!','',26124),
(7622,'enUS','Commerce!  I crave it!','',26124),
(7623,'enUS','Yes, Augustus.  I would like to do business.','Yes, Augustus.  I would like to do business.',26124),
(7624,'enUS','This is a dangerous place, $n. Be careful around here.','',26124),
(7625,'enUS','Greetings, $c. Please be brief in how the Kirin Tor may be of service to you.','',26124),
(7626,'enUS','DIE, INSECT!','',26124),
(7627,'enUS','You won\'t find better prices anywhere!','',26124),
(7628,'enUS','I\'m Augustus, and my prices are INSANE!','',26124),
(7629,'enUS','I\'m Augustus!  You want it, I got it!  You wanna sell it, then I want it!','',26124),
(7630,'enUS','Do not waste my time, $c.','Do not waste my time, $c.',26124),
(7631,'enUS','I don\'t train your kind, $c.  Find your own trainer before you anger me.','I don\'t train your kind, $c.  Find your own trainer before you anger me.',26124),
(7632,'enUS','Take it easy, mon. I only train da warriors.','Take it easy, mon. I only train da warriors.',26124),
(7633,'enUS','What kin I do for ya, mon?','What kin I do for ya, mon?',26124),
(7634,'enUS','Due to incompatibility on your class specification, I am unable to help you rectify any situation you have with lack of ability.','Due to incompatibility on your class specification, I am unable to help you rectify any situation you have with lack of ability.',26124),
(7635,'enUS','Excellent! You meet the required parameters and specifications. What can I do for you?','Excellent! You meet the required parameters and specifications. What can I do for you?',26124),
(7636,'enUS','TOO SOON! YOU HAVE AWAKENED ME TOO SOON, EXECUTUS! WHAT IS THE MEANING OF THIS INTRUSION???','',26124),
(7637,'enUS','Hegnar Rumbleshot, at your service!','',26124),
(7638,'enUS','While Theramore is reknown for it\'s exceptional training of warriors, I am afraid that I can not help you.','While Theramore is reknown for it\'s exceptional training of warriors, I am afraid that I can not help you.',26124),
(7639,'enUS','Come to train with the Theramore guard have you?','Come to train with the Theramore guard have you?',26124),
(7640,'enUS','Yes. I have.','Yes. I have.',26124),
(7641,'enUS','What can I do for you my child?','What can I do for you my child?',26124),
(7642,'enUS','I cannot train a $c such as yourself.','I cannot train a $c such as yourself.',26124),
(7643,'enUS','I seek training in the ways of the Hunter.','I seek training in the ways of the Hunter.',26124),
(7644,'enUS','I can not train you, young one.','I can not train you, young one.',26124),
(7645,'enUS','The Firelord and his brethren once held sway over this entire world, mortal. As a servant of the Old Gods, he fought against the Titans for domination of this planet. The victorious Titans banished my master and his brethren to the Elemental Plane - there to remain imprisoned until the end of time.','',26124),
(7646,'enUS','Tell me more.','Tell me more.',26124),
(7647,'enUS','Do you prefer guns or bows?','Do you prefer guns or bows?',26124),
(7648,'enUS','I do not have the knowledge you seek.','I do not have the knowledge you seek.',26124),
(7649,'enUS','Very well, $n.','',26124),
(7650,'enUS','Wot kin I do fer ye?','Wot kin I do fer ye?',26124),
(7651,'enUS','I kinnae help ye with trainin\'. Ye should look fer a $c trainer.','I kinnae help ye with trainin\'. Ye should look fer a $c trainer.',26124),
(7652,'enUS','What?','What?',26124),
(7653,'enUS','Don\'t waste my time.','Don\'t waste my time.',26124),
(7654,'enUS','I can not train you.','I can not train you.',26124),
(7655,'enUS','Impudent whelps! You\'ve rushed headlong to your own deaths! See now, the master stirs!\n','',26124),
(7656,'enUS','Hey mon, you be needin\' to head on over to da $c trainer.','Hey mon, you be needin\' to head on over to da $c trainer.',26124),
(7657,'enUS','Behold Ragnaros - the Firelord! He who was ancient when this world was young! Bow before him, mortals! Bow before your ending!','',26124),
(7658,'enUS','Teach me the ways of the spirits.','Teach me the ways of the spirits.',26124),
(7659,'enUS','The spirits have guided you to me. How may I be of service?','The spirits have guided you to me. How may I be of service?',26124),
(7660,'enUS','May the spirits be with you.','May the spirits be with you.',26124),
(7661,'enUS','These mortal infidels, my lord! They have invaded your sanctum and seek to steal your secrets!','',26124),
(7662,'enUS','FOOL! YOU ALLOWED THESE INSECTS TO RUN RAMPANT THROUGH THE HALLOWED CORE? AND NOW YOU LEAD THEM TO MY VERY LAIR? YOU HAVE FAILED ME, EXECUTUS! JUSTICE SHALL BE MET, INDEED!','',26124),
(7663,'enUS','Da spirits be strong wit you, mon. What kin dis troll do for ya?','Da spirits be strong wit you, mon. What kin dis troll do for ya?',26124),
(7664,'enUS','May da spirits protect you mon.','May da spirits protect you mon.',26124),
(7665,'enUS','Where are you going?  Well if you\'re looking to get there quickly, then look no further!','',26124),
(7666,'enUS','I try to keep Sentinel Hill stocked, and that\'s not easy with all the action we see.','',26124),
(7667,'enUS','I need a ride, fast!  I have an important message to deliver!','I need a ride, fast!  I have an important message to deliver!',26124),
(7668,'enUS','Ah, $gpriest:priestess;, you came along just in time. I appreciate it.','',26124),
(7669,'enUS','Argh, the pain. Will it ever leave me?','',26124),
(7670,'enUS','Thank you! Thank you, $gpriest:priestess;. Now I can take on those murlocs with the Light on my side!','',26124),
(7671,'enUS','Farewell to you, and may the Light be with you always.','',26124),
(7672,'enUS','A mere three hundred years ago, a reckless dwarf named Thaurissan summoned the master from his fiery realm. His return to this paltry world devastated the surrounding lands and created this volcanic Core. Mighty Ragnaros has slept under this mountain ever since. \n','',26124),
(7673,'enUS','What else do you have to say?','What else do you have to say?',26124),
(7674,'enUS','We, his sworn servants, do his bidding and enforce his iron-rule. Cut off from the energies of his fiery realm, Ragnaros is but a shadow of his true self. However, he has more than enough strength to be your end.      \n','',26124),
(7675,'enUS','You challenged us and we have come. Where is this master you speak of?\n','You challenged us and we have come. Where is this master you speak of?\n',26124),
(7676,'enUS','Good day, $gsir:ma\'am;. I\'d shake your hand, but as you see, I\'m in the middle of something. May I be of assistance?','',26124),
(7677,'enUS','You\'ve made a good start, but you still have a great deal to learn, $n.','',26124),
(7678,'enUS','You\'ve already learned everything I can teach you, $n. Talk to the night elf Lilyssia Nightbreeze in the Mage Quarter of Stormwind if you want to continue your studies. I hear she\'s a good teacher.','',26124),
(7679,'enUS','','Shut inside this little house, I dream of joining the battles that rage outside the city walls. Still, duty compels me to share my knowledge with others who fight in my stead... for now.',26124),
(7682,'enUS','Ishnu-alah, $gbrother:sister;. Have you any tidings from abroad? My heart yearns for news of Teldrassil.','',26124),
(7683,'enUS','I am honored to share my knowledge with you, $n. See that you use it well.','',26124),
(7684,'enUS','You must choose a more experienced teacher, for you have surpassed my abilities. I advise you to speak with Lilyssia Nightbreeze here: she has much knowledge to offer.','',26124),
(7685,'enUS','NOW FOR YOU, INSECTS! BOLDLY, YOU SOUGHT THE POWER OF RAGNAROS. NOW YOU SHALL SEE IT FIRSTHAND!\n','',26124),
(7686,'enUS','','The druids say that it is only a matter of time until nature itself drives the Horde from Kalimdor. Yet corruption continues to spread throughout our lands, even here on Teldrassil.',26124),
(7687,'enUS','','Well done! Your understanding of potions is coming along nicely.',26124),
(7688,'enUS','','Unfortunately, there is little I can teach someone with your experience, my friend. Seek out the night elf Sylvanna Forestmoon, who resides in the Craftsmen\'s Terrace of Darnassus.',26124),
(7689,'enUS','','Elune-adore, my $gbrother:sister;. You are welcome here.',26124),
(7690,'enUS','','Is it not astonishing what one can create from the plants of the forest? Truly, Elune has blessed us with her bounty.',26124),
(7691,'enUS','','You are kind to seek me out, but your skills are beyond my own. Have a word with Sylvanna Forestmoon, just over there. She\'s been looking for another student.',26124),
(7692,'enUS','Did my sweet lass Kali send you down to me? The apple of my eye, she is.','',26124),
(7693,'enUS','I don\'t suppose you\'re here to talk about my lovely Kali. Fine, then. Potions it is. Anyone ever tell ye you\'ve got a one-track mind?','',26124),
(7694,'enUS','Ye\'re beyond my skill to teach, $n. Go pester Tally Berryfizz; she\'s a gnome living in Tinker Town of Ironforge. Oh, and since you\'re headed up anyway, give Kali my love.','',26124),
(7695,'enUS','Don\'t let those big, innocent eyes fool ye. Tally\'s an expert, all right: I learn something new every day. Why d\'you think I\'m here in Tinker Town? Do I look like an engineer to you? Aye, I didn\'t think so.','',26124),
(7696,'enUS','Put your back into it, $glad:lass;. Hard work and determination--that\'s the way! Don\'t let anyone tell you book learnin\' is all ye need.','',26124),
(7697,'enUS','Och, there\'s nothing I can teach ye, $n. Have a word with Tally Berryfizz over there. She can hardly reach the tables, but when she starts brewing a potion, watch out!','',26124),
(7698,'enUS','You got the look of someone wantin\' adventure. Me, I had enough of that by the time we trolls came here. Now I take each day as it comes, an\' I train other folks to handle adventures for me.','',26124),
(7699,'enUS','Ready for another lesson? All right, then. First, relax. You gotta stay loose to stir a potion just right.','',26124),
(7700,'enUS','You got questions, but they be too big for me to answer, $n. You be needin\' to have words with the orc Yelmak in the Drag of Orgrimmar. He\'ll help you out.','',26124),
(7701,'enUS','All the bottles on this table are potions I brewed today. And they say a watched pot never boils. Ha!','',26124),
(7702,'enUS','They called me stupid, but I\'ll show them. I\'m going to watch every pot I have and prove that they can all boil stuff anyway. Yeah, I\'m on a roll! Who\'s stupid now, huh? Huh!?','',26124),
(7703,'enUS','Can\'t help you. You know more about potions than I do. Besides, I have pots to watch. Talk to Yelmak over there. He knows a lot about potions.','',26124),
(7704,'enUS','Bena works like one possessed. Day and night I have seen her bent over these potions, often going without sleep or food. I know our undead allies need help, but I begin to fear she will do herself an injury.','',26124),
(7705,'enUS','I must have broken hundreds of vials when I first began brewing potions. The glass was so fragile in my clumsy hands. I hope you are more cautious than I was.','',26124),
(7706,'enUS','Your capacity for learning has outstripped mine. You will need to talk to Bena Winterhoof over there for further instruction. Please don\'t take too much of her time, though. She needs her rest.','',26124),
(7707,'enUS','','Nice to see a friendly face. I don\'t get much chitchat from Apothecary Johaan unless he wants something. He\'s been out of the grave too long. Someday I\'ll be like that, I hear. Creepy. Maybe by then I won\'t care.',26124),
(7708,'enUS','','Here to learn about potions? I\'ve got plenty to teach you. I might be dead, but I haven\'t lost my brains. Yet.',26124),
(7709,'enUS','','I appreciate the company, but let\'s face it: you have more experience with potions than I do. Talk to Doctor Marsh instead if you want training. He\'s a Forsaken in the Apothecarium of the Undercity.',26124),
(7710,'enUS','Once, it is true, I was human. What might otherwise be a shortcoming works to our advantage, $n, for I know human weaknesses intimately.','',26124),
(7711,'enUS','Very well. Cut another lump of flesh from one of these specimens. Let us test what you\'ve learned so far, and we can progress from there.','',26124),
(7712,'enUS','Your knowledge of potions has exceeded mine, but you still have much to learn. Go up the stairs to the southeast and see Doctor Marsh. He will teach you true sufferi--ahem. He is a Forsaken who will train you further.','',26124),
(7713,'enUS','Stop giving me that look. I may not be an adventurer like you, but that doesn\'t mean I can\'t have a few muscles. All that stirring makes your arms strong.','',26124),
(7714,'enUS','There\'s nothing more I can teach you. I\'ve heard of a night elf who might be able to, though. Her name is Ainethil, and she lives in the Craftsmen\'s Terrace of Darnassus.','',26124),
(7715,'enUS','I\'m sorry, $n, but I have no time to spend on novices. You want someone closer to your own skill level. Try the night elf Milla Fairancora, in the Craftsmen\'s Terrace of Darnassus.','',26124),
(7716,'enUS','You\'ve put in your time studying the basics. Now it\'s time to up the ante.','',26124),
(7717,'enUS','You want my help? You got it. What do you need?','',26124),
(7718,'enUS','','Don\'t let the beady eyes and bushy beard fool you. Vosur\'s a talented apprentice and a good friend, even if I do get a crick in my neck when I talk to him.',26124),
(7719,'enUS','','Um, you already know everything I could teach you. Maybe it\'s time for you to talk to someone else. Try the night elf Ainethil in the Craftsmen\'s Terrace of Darnassus. She\'s got some real talent!',26124),
(7720,'enUS','','Hey, that\'s actually not so bad. Alrighty, then. How\'d you like to run an errand for me?',26124),
(7721,'enUS','','That\'s nice, $n. Go show whatever it is to Vosur over there. He\'ll answer any questions you have.',26124),
(7722,'enUS','','Who are you and why are you bothering me? Oh, right--potions student. Right. What can I do for you?',26124),
(7723,'enUS','','Ishnu-dal-dieb, $n. Have you come here in search of knowledge?',26124),
(7724,'enUS','','Teaching is not a one-sided trade, $n. As I teach you, I learn more myself, and my understanding grows.',26124),
(7725,'enUS','','My apologies, $n, but I do not offer instruction to novices. Instead, talk to Milla Fairancora in the Craftsmen\'s Terrace of Darnassus. She can help you make up for lost time.',26124),
(7726,'enUS','','You have learned the fundamentals of making potions, but further study requires greater commitment. Prove your dedication by carrying out a task for me.',26124),
(7727,'enUS','','Although I am flattered by your confidence in my abilities, teaching you is beyond my skill. You must go to the Craftsmen\'s Terrace in Darnassus, and speak with the night elf Ainethil. She can help you.',26124),
(7728,'enUS','','Even slight alterations to a potion\'s ingredients can change it fundamentally. Patience and precision, young one: they will serve you well in all walks of life.',26124),
(7729,'enUS','','My skill at creating potions is inferior to yours. You are ready to speak with Ainethil, just over there. She will understand that you are ready for further instruction.',26124),
(7730,'enUS','','Your skill is not inconsiderable. Since you appear to have sufficient experience, there is a matter in which I require your aid.',26124),
(7731,'enUS','','Ah, to be young again, and to have discovered potions for the first time. Thank you for refreshing my memory, $n. Now go share that youthful enthusiasm with Milla Fairancora over there.',26124),
(7732,'enUS','','I have learned much of potions over the long years, $n, and that knowledge is at your disposal. You have only to ask.',26124),
(7733,'enUS','I\'m busy, $n. Tell Whuut to handle whatever it is. That young pup has been stewing all day long. He spends much more time like that, and he\'s going to hurt something.','',26124),
(7734,'enUS','I\'m honored to meet you, $n, but your skill at potions is greater than my own. Go see Doctor Herbert Halsey, an undead in the Apothecarium of the Undercity. He can help you from now on.','',26124),
(7735,'enUS','I\'ve been looking for a little help. Since you\'ve got the skill, I guess you\'ll do, provided you\'ve also got the guts.','',26124),
(7736,'enUS','You\'re talking to the wrong orc. I don\'t train novices. Talk to young Whuut over there... and use small words.','',26124),
(7737,'enUS','Another student, eh? All right. I\'ll see what I can do to help you out.','',26124),
(7738,'enUS','Glyx and I have an understanding: he keeps me supplied, and I keep him rich. Seriously! What that pirate charges me for a measly pouch of crumpled kingsblood... it\'s enough to make a grown goblin cry.','',26124),
(7739,'enUS','I\'ve got plenty of great recipes for you to take a look at, and at discounted prices, too!','',26124),
(7740,'enUS','What is this? You trying to ruin my reputation? I don\'t teach novices, $gbuddy:lady;. Try talking to the orc Whuut in the Drag of Orgrimmar. He\'s a lot closer to your level of skill. And brains.','',26124),
(7741,'enUS','Herbs are so pricey! I could always use a little something extra, if you know what I mean. Help a goblin out?','',26124),
(7742,'enUS','You\'re better at this gig than I am! You want someone with even more experience than I\'ve got. That\'d be Ainethil, a night elf lady who lives in the Craftsmen\'s Terrace of Darnassus.','',26124),
(7743,'enUS','','When I first saw the undead, I wept, for I could not imagine their horror and loneliness. The Earth Mother spoke to me then; she sang in my blood. And she told me, \"Save them.\"',26124),
(7744,'enUS','','Can you not sense the anguish of the Earth Mother for her lost children, the undead? Speak quickly, $n. Every second costs me dearly. We must help them find their way back to her!',26124),
(7745,'enUS','','I cannot in good conscience spend time training novices while our allies, the undead, are suffering so terribly. Please speak with Kray over there instead; he can help you for now.',26124),
(7746,'enUS','','You have some skill, it is true, but every moment I spend teaching you is one more moment the undead will spend in torment. Prove to me that you are worth my time.',26124),
(7747,'enUS','','Your potion-making skills are beyond mine. Seek out the undead Doctor Herbert Halsey in the Apothecarium of the Undercity. He has the skill to train you further, and you can witness firsthand his people\'s plight.',26124),
(7748,'enUS','Another interruption. How am I supposed to get any work done like this? Don\'t answer that; do I look as if I care what you have to say? If we are to ever get this place cleaned up and expand our empire I will need absolute silence!','',26124),
(7749,'enUS','Me, train you? Come on--we both know I can\'t. It\'s this teaching, you see. My own skills suffer. You want training, go to Doctor Herbert Halsey, a Forsaken in the Apothecarium of the Undercity.','',26124),
(7750,'enUS','If you\'re going to be taking up my time, you\'d better prove you\'re worth it. I ought to get something out of this arrangement, after all.','',26124),
(7751,'enUS','Don\'t waste my time. I have research projects older than you. Go talk to Doctor Martin Felben in the Apothecarium of the Undercity. He\'s a Forsaken who can probably manage to teach you the basics.','',26124),
(7752,'enUS','Another student. Wonderful. This is why Lydon gets to supervise and I\'m stuck being an instructor. If I win another teaching award, I\'ll never live it down!','',26124),
(7753,'enUS','My powers have returned and you have squandered your chance, foolish mortals. Till we meet again.','',26124),
(7754,'enUS','With Algernon to keep me supplied, I can do all my work here without hunting for a single herb. If I never have to see the wonders of nature again, it won\'t be too soon.','',26124),
(7755,'enUS','I have no more knowledge to bestow upon you. Go through the archway and down the ramp to the southeast, and talk to Doctor Herbert Halsey. He is a Forsaken who can teach you more advanced techniques.','',26124),
(7756,'enUS','If you seek to become my student, you\'ll need to complete an assignment for me. Prove yourself worthy, and I might even consider rewarding you.','',26124),
(7757,'enUS','I\'m not amused by your audacity in coming to me for training. Go through the archway and down the ramp to the southeast, and talk to Doctor Martin Felben. He is a Forsaken who can teach you the basics.','',26124),
(7758,'enUS','Here to learn? Very well. I suppose you can\'t cause our allies much harm if I teach you. Just as long as you actually do manage to harm our enemies.','',26124),
(7759,'enUS','','This potion seems to heal less damage every time I brew it, though I use the same ingredients. There can be only one conclusion: the plants are changing. I cannot say why or into what.',26124),
(7760,'enUS','','It is time you moved on to a more advanced teacher. In the Feathermoon Stronghold of Feralas dwells the night elf Kylanna Windwhisper. She has a brilliant mind; doubtless she can train you further.',26124),
(7761,'enUS','','This is excellent work. Are you ready to undertake a mission on my behalf? I know of no one more qualified.',26124),
(7762,'enUS','','Your skill at brewing potions needs to be greater before you can become one of my students. In the meantime, perhaps Sylvanna Forestmoon or Milla Fairancora can help you, just over there.',26124),
(7763,'enUS','','Your education is progressing well. You should be proud of your accomplishments.',26124),
(7764,'enUS','My colleagues and I are gathering the deadliest substances we know and testing their effects on our enemies. Once I have everything I need, I shall brew such plagues as this world has never seen.','',26124),
(7765,'enUS','Incredible. Your potions display a knowledge that rivals my own. I cannot train you further, but talk to the orc Rogvar of Stonard in the Swamp of Sorrows. He\'s known for his cutting-edge experiments.','',26124),
(7766,'enUS','You\'ve got real talent and a passion for making potions. There is one little matter I\'d like you to take care of, though.','',26124),
(7767,'enUS','You don\'t yet have the skill to study with me. Go talk to Doctor Martin Felben over there, or go up the ramp to the southeast and see Doctor Marsh. They are Forsaken who can give you the training you need.','',26124),
(7768,'enUS','Ready for training? Then try to keep up, $n. We\'ve got a lot of ground to cover.','',26124),
(7769,'enUS','','Once I welcomed darkness, for it was the sister of night. Now it is dark all the time, even during the day, and the forests cry out for sustenance. Unless we act soon, this spreading blight will cover the world.',26124),
(7770,'enUS','','Have you come here for instruction in the art of making potions? You were mistaken if you thought that I would offer such a privilege to you, unearned. Go, and do not return to me until you have greater skill.',26124),
(7771,'enUS','','Your skill displays an enduring affection for our art, but I would see further evidence of your commitment. I shall charge you with a task. Fulfill it, and I will be content.',26124),
(7772,'enUS','','Elune has seen fit to gift me with skill and experience. Now I shall pass them on to you.',26124),
(7773,'enUS','Kalaran, I have misplaced my torch. I require another.','Kalaran, I have misplaced my torch. I require another.',26124),
(7774,'enUS','Warchief Thrall himself asked me to come out here. I was honored to obey, and it\'s no hardship. I couldn\'t have asked for a better posting than Stonard. Just about any herb I might need grows in the muck here.','',26124),
(7775,'enUS','Don\'t stir the potion like that, you ham-handed farmer! No, don\'t stop stirring it, either! Forget it--just give me that ladle before you start a fire. I\'ll salvage what I can. Now, pay attention.','',26124),
(7776,'enUS','Hmm, well, I can see that you have a little skill at making potions. Whether you\'re worthy to be my student remains to be seen, however. I have a job for you. Impress me.','',26124),
(7777,'enUS','How dare you ask me for training, maggot? What were you hoping for, you slack-jawed yokel, a lecture on the proper uses of silverleaf? Out! You\'re lucky I don\'t thrash you senseless for wasting my time.','',26124),
(7778,'enUS','','Ah, $gpriest:priestess;, you came along just in time. I appreciate it.',26124),
(7779,'enUS','','Argh, the pain. Will it ever leave me?',26124),
(7780,'enUS','','Thank you! Thank you, $gpriest:priestess;. Now I can take on those corrupt timberlings with Elune\'s power behind me!',26124),
(7781,'enUS','','Farewell to you, and may Elune be with you always.',26124),
(7782,'enUS','','Ah, $gpriest:priestess;, you came along just in time. I appreciate it.',26124),
(7783,'enUS','','Argh, the pain. Will it ever leave me?',26124),
(7784,'enUS','','Thank you! Thank you, $gpriest:priestess;. Now I can take on those humans with your power to back me!',26124),
(7785,'enUS','','Farewell to you, and may our ancestors be with you always!',26124),
(7786,'enUS','Ah, $gpriest:priestess;, you came along just in time. I appreciate it.','',26124),
(7787,'enUS','Argh, the pain. Will it ever leave me?','',26124),
(7788,'enUS','Thank you! Thank you, $gpriest:priestess;. Now I can take on those wendigo with the Light on my side!','',26124),
(7789,'enUS','Farewell to you, and may the Light be with you always.','',26124),
(7790,'enUS','Ah, $gpriest:priestess;, you came along just in time. I appreciate it.','',26124),
(7791,'enUS','Argh, the pain. Will it ever leave me?','',26124),
(7792,'enUS','Thank you! Thank you, $gpriest:priestess;. Now I can take on those gnolls with your power to back me!','',26124),
(7793,'enUS','Farewell to you, and may shadow always protect you!','',26124),
(7794,'enUS','Just a minor adjustment here... ah there we go!','',26124),
(7795,'enUS','I would train ye if I could, but ye need the services of someone a bit more... what\'s the word? Brainy! Look for Trixie Quickswitch in Ironforge. Tell \'er Bronk sent ye!','',26124),
(7796,'enUS','Lookin\' to be an engineer, eh? Well, by Muradin, ye\'ve come to the right place!','',26124),
(7797,'enUS','%s goes into a killing frenzy!','',26124),
(7798,'enUS','%s becomes enraged!','',26124),
(7799,'enUS','Where\'s my spinner? I just had it here somewhere...','',26124),
(7800,'enUS','Your current aptitude exceeds my instructional capabilities. You should enquire further with my fellow Gnome Trixie Quickswitch in Ironforge!','',26124),
(7801,'enUS','I would be delighted to aid you in the commencement of your pursuit! Let me grab my spinner and we\'ll get started...','',26124),
(7802,'enUS','','I heard the new Henweigh 6000 will be rolling off the assembly line soon. I can barely contain my excitement!',26124),
(7803,'enUS','','Well... I hate to admit it, but my sister\'s the one you\'ll have to talk to if you want to continue training. I don\'t know as much as she does... yet! She\'s standing over by the rocket car.',26124),
(7804,'enUS','','I\'d love to teach you! Show my sister she\'s not the only one who knows a thing or two about engineering...',26124),
(7805,'enUS','','Hello there! My name\'s Jenna! And you? ',26124),
(7806,'enUS','','Oh, you\'ve got oodles of things to learn still. I would teach you everything if I could, but I\'m still learning too! Why don\'t you talk to Trixie Quickswitch in Ironforge, she\'ll help you further your education!',26124),
(7807,'enUS','','You want to train? With me? Fantastic! The only thing better than assembling bullets and explosive devices is to share that knowledge with someone else! Let\'s get started!',26124),
(7808,'enUS','','Ah, what a beautiful day to blow something up!',26124),
(7809,'enUS','','You need to start learning things that are beyond my expertise! Talk to Lilliam Sparkspindle in front of the tent there. He\'ll set you on the right course!',26124),
(7810,'enUS','','This kind of work isn\'t for the faint of heart. I have an uncle who lost a hand! Poor old Stumpy... anyway, if you\'re still interested I might be able to show you a few things.',26124),
(7811,'enUS','What? You want something?','',26124),
(7812,'enUS','I can\'t help ya\'! You\'re ready to see someone who\'s been at it longer than I have! Let\'s see... you\'re an Alliance type, so you need to talk to Lilliam Sparkspindle in Stormwind.','',26124),
(7813,'enUS','Yeah, I\'ll show you a few things. We\'ll see how you do, maybe you\'ll surprise me!','',26124),
(7814,'enUS','(Sniff, sniff) You smell that? Don\'t you just LOVE the smell of grease?','',26124),
(7815,'enUS','I\'m afraid you\'re out of my league, friend! You should go see Nogg in Orgrimmar, he\'ll take you to the next level!','',26124),
(7816,'enUS','A fellow enthusiast, huh? Well, you just wait, we\'ll make a gearhead out of you in no time!','',26124),
(7817,'enUS','I like to build stuff. Of course, I like to blow stuff up even more!','',26124),
(7818,'enUS','You know who can really show you some things? Nogg! You go find him in Orgrimmar.','',26124),
(7819,'enUS','I know a few things. You want me to show you?','',26124),
(7820,'enUS','Who says orcs aren\'t smart? It takes a lot of brains to be an engineer!','',26124),
(7821,'enUS','You know who\'s really smart? Nogg! Smarter than me, even. You go tell Nogg Thund sent you! You can find him by the control panel over there.','',26124),
(7822,'enUS','You think you\'re smart enough? You think you got what it takes? Let\'s find out!','',26124),
(7823,'enUS','The Dark Lady has said that knowledge will be our greatest weapon in this war.','',26124),
(7824,'enUS','You are ready for greater things! See Franklin Lloyd, to my right. He will guide you from now on.','',26124),
(7825,'enUS','Engineering will provide you with the skills and knowledge to dismantle your opponents! Let me show you how...','',26124),
(7826,'enUS','I\'m never too busy to speak to a stranger! Almost never, anyway...','',26124),
(7827,'enUS','You\'re working your way up... higher than me, at this point! You should talk to Springspindle Fizzlegear in Ironforge! (He\'ll? She\'ll?) show you more than I ever could!','',26124),
(7828,'enUS','I can show you a few tricks... if you don\'t mind doing a little something first, that is.','',26124),
(7829,'enUS','Hmm... well, I can\'t help you quite yet! You have to learn the basics first. Why don\'t you go see Sprite Jumpsprocket in Stormwind!','',26124),
(7830,'enUS','Fantastic! Aren\'t you the industrious one? Well, let\'s get started, shall we?','',26124),
(7831,'enUS','Let\'s see... fourteen plus seven, carry the two... oh, yes?','',26124),
(7832,'enUS','Well, you\'re just zooming right along! I can\'t teach you anything you don\'t already know, but Springspindle Fizzlegear sure can! You can find Springspindle in Ironforge. Good luck!','',26124),
(7833,'enUS','Quid pro quo! I\'ll teach you what I know, but first I want you to perform a small task...','',26124),
(7834,'enUS','You can learn from me in time... but not yet! Why don\'t you start out by talking to Sprite Jumpsprocket to my right here. You can check in with me after you\'ve gotten your feet wet!','',26124),
(7835,'enUS','You certainly did not disappoint! Now that we\'ve gotten that out of the way, your instruction may begin!','',26124),
(7836,'enUS','','The plans for my twenty-foot tall turkey baster are nearly complete! Now all I need is a twenty-foot tall turkey...',26124),
(7837,'enUS','','Don\'t tell anyone else I said this, but even I don\'t know everything! If you want to keep learning, you should talk to the owner of the shop, Springspindle Fizzlegear.',26124),
(7838,'enUS','','You\'ll need to prove your worthiness before I go giving away my secrets! I\'ve got just the test for you...',26124),
(7839,'enUS','','Close, but no cigar! I\'m afraid you\'ll have to talk to my sis, Jemma first. After she\'s gone over the basics with you, come see me and I\'ll show you the juicy stuff!',26124),
(7840,'enUS','','Not bad, for a beginner! I guess it couldn\'t hurt for me to show you a few things...',26124),
(7841,'enUS','If there were just a few more hours in a day...','',26124),
(7842,'enUS','You have earned the privilege of training with a higher instructor. Go see my pal Roxxik there.','',26124),
(7843,'enUS','Every day is a test, and this day is no different. If you pass this test, I will share some of my knowledge...','',26124),
(7844,'enUS','You have not yet earned the right to train with me. See Thund first, over by the table. Come back when he says you\'re ready!','',26124),
(7845,'enUS','You have passed your test, well done! Your training may now continue.','',26124),
(7846,'enUS','I don\'t have time for idle gossip, I\'m a professional!','',26124),
(7847,'enUS','What do you think I could teach you? Roxxik would do a much better job. You can find him in Orgrimmar. Now be off!','',26124),
(7848,'enUS','Let\'s see how competent you are, shall we? If you perform this task to my liking, I\'ll spend the time to teach you!','',26124),
(7849,'enUS','This is a waste of time, mine and yours! Go see Graham Van Talen if you want to begin your instruction! He\'s standing to my left over there.','',26124),
(7850,'enUS','Well... you almost impressed me. I suppose I could spare the time for a few lessons...','',26124),
(7851,'enUS','If my calculations are correct, the wheel will soon be obsolete!','',26124),
(7852,'enUS','You have certainly come a long way in your training. If you want to learn more, you have to travel to the desert. Find Buzzek Bracketswing in Gadgetzan! ','',26124),
(7853,'enUS','Not that I doubt your abilites, but I would like you to perform a task for me. Call it a demonstration of good faith...','',26124),
(7854,'enUS','The things I would teach you would turn your brain to jelly! Come back when you\'ve learned sufficiently!','',26124),
(7855,'enUS','Excellent, you have proven yourself worthy! Now for the next phase of your instruction...','',26124),
(7856,'enUS','Sometimes I surprise even myself!','',26124),
(7857,'enUS','I can\'t teach what I don\'t know! If only there was someone else who knew more than I do... wait, there is! Go see Buzzek Bracketswing in Gadgetzan!','',26124),
(7858,'enUS','I think you\'re more than qualified for this little assignment... let\'s see if I\'m right!','',26124),
(7859,'enUS','Nice try, but you\'ll need some more experience before training with me! Back to the trenches! ','',26124),
(7860,'enUS','Nice going! I knew I was right about you, no matter what those other people said. Ha! I\'m kidding! Okay, on with your lessons...','',26124),
(7861,'enUS','I\'ve been working on a way to transport oil underground between major cities, but everyone tells me it\'s a pipe dream.','',26124),
(7862,'enUS','Well my friend, you\'ve reached heights some people only dream of. Congrats! And now, without further ceremony, it is time for your final lesson!','',26124),
(7863,'enUS','Show me what you got! You won\'t be sorry, I promise!','',26124),
(7864,'enUS','I would never turn away someone who\'s ready to train with me. Unfortunately, you\'re not! You\'ve still got a ways to go kid!','',26124),
(7865,'enUS','%s refuses to die while its master is endangered!','',26124),
(7866,'enUS','%s collapses and begins to smolder.','',26124),
(7867,'enUS','%s reignites from the heat of another Core Hound!','',26124),
(7868,'enUS','','Hail, traveler! What brings you to my doorstep?',26124),
(7869,'enUS','','I\'m afraid I have nothing to teach to someone with your experience. But you haven\'t reached the end of the road yet. Speak to Lucan Cordell, behind the counter there. He\'ll guide you through the next phase of your journey.',26124),
(7870,'enUS','','Hmm... well you seem capable enough. If you truly desire to learn, then nothing will stand in your way! I will guide you through your first steps on what I hope will be a long and fulfilling path.',26124),
(7871,'enUS','There are ways to strengthen steel beyond the hammer and forge, young wanderer.','',26124),
(7872,'enUS','Ye\'re a fine enchanter indeed! Now it\'s time fer ye to move on. I want ye to talk to Gimble Thistlefuzz, upstairs. He\'s a bit of a character, but he\'ll steer ye in the right direction from here on out!','',26124),
(7873,'enUS','Ah, ye\'re an inquisitive one, are ye\'? Excellent! Pay close attention, this just might save yer skin when the goin\' gets rough!','',26124),
(7874,'enUS','','The Goddess has granted me wisdom, stranger. If it is her will, I shall pass it on to you.',26124),
(7875,'enUS','','Your skills are beyond my reach. It is time for you to face new challenges. Taladan will help you prepare. He is standing by the table there.',26124),
(7876,'enUS','','I will teach you what I can. Each lesson is a gift from the Goddess herself. Use her gifts wisely, and you shall not falter.',26124),
(7877,'enUS','','Elune\'s secrets are many, but they are not to be shared with just anyone. ',26124),
(7878,'enUS','','You have truly excelled in your knowledge of enchanting. There is much more to learn, if you are willing. Speak to Taladan, in the Craftsmen\'s Terrace in Darnassus.',26124),
(7879,'enUS','','Open your mind, wanderer, and we shall begin.',26124),
(7880,'enUS','I do not have time to waste, stranger. State your business or be off!','',26124),
(7881,'enUS','Eh, well you\'ve made it this far... go see Lavinia Crowe by the other bookshelf there. If you don\'t mess things up with her, maybe you can learn some more.','',26124),
(7882,'enUS','You don\'t look like much to me, but who knows, maybe there\'s an enchanter hidden in there somewhere!','',26124),
(7883,'enUS','What I wouldn\'t give to be out on the open plains on a day like this... but my duty binds me.','',26124),
(7884,'enUS','I cannot teach you anything you don\'t already know. However, the knowledge of my father far surpasses my own. Go inside and speak to him. Good luck!','',26124),
(7885,'enUS','There are many secrets that may be unlocked with patience and determination. Now, let us begin...','',26124),
(7886,'enUS','Throm-ka! What you looking for, stranger?','',26124),
(7887,'enUS','You come to wrong place. Talk to the expert Godan over there. You learn more from him.','',26124),
(7888,'enUS','To die in battle is glorious! But, with what I teach you, maybe you not die so quickly, hm?  ','',26124),
(7889,'enUS','Who are you? What do you want from me?','',26124),
(7890,'enUS','What do I look like, the Grand Poobah of enchanters? Your skills require the guidance of an Artisan! Go find Kitta Firewind at the Tower of Azora.','',26124),
(7891,'enUS','Great, let\'s get started... ha! Fooled you! Surely you didn\'t think it would be that simple. You\'ll need to prove your mettle just like everyone else!','',26124),
(7892,'enUS','You\'re joking, right? I believe you\'re looking for the OTHER short fellow, Thonys Pillarstone. He\'s downstairs. Now skedaddle!','',26124),
(7893,'enUS','Okay, well... don\'t get cocky! Since you have demonstrated  your competence though, we may now begin!','',26124),
(7894,'enUS','If you have what it takes, I will be happy to show you the way.','',26124),
(7895,'enUS','A true professional know his limitations, and I\'m not ashamed to admit that your skills exceed mine. I want you to pay a visit to Kitta Firewind at the Tower of Azora. She is well-renowned, and with good reason.','',26124),
(7896,'enUS','You seem confident. Surely you wouldn\'t mind a test of your skills?','',26124),
(7897,'enUS','You are not ready. Speak to Betty Quinn, she\'s standing by the stairs over there. Return to me when you have achieved a higher enlightenment.','',26124),
(7898,'enUS','Your confidence is well-founded, traveler. Now your true education may begin!','',26124),
(7899,'enUS','If you seek to hunt naga, then you will need all the help you can get. Deep in the water you can find bubbly fissures that produce enough air bubbles that will allow you to breath underwater. Swim up close so that you can use the bubbles.','',26124),
(7900,'enUS','','That one, Malagan. I know $g him:her;. Dependable, brave, and trustworthy. $n is $g his:her; name.',26124),
(7901,'enUS','$n, eh? Oy! Citizen $n, come \'ere. Highlord Bolvar Fordragon has requested that all able bodied heroes o\' the Alliance meet with him at Stormwind Keep. You just been recruited, mate! Get a move on!','',26124),
(7902,'enUS','It is true I have skills to teach to those who are worthy. Would that be you?','',26124),
(7903,'enUS','You are an exceptional enchanter. Beyond my talents as a teacher, I fear. Seek out Kitta Firewind at the Tower of Azora. Only she can qualify as your instructor now.','',26124),
(7904,'enUS','I believe you are up to this task... will you accept the challenge?','',26124),
(7905,'enUS','You have not yet learned the basics, wanderer. Have you spoken to my assistant, Lalina Summermoon? Perhaps you should.','',26124),
(7906,'enUS','Fine work! You are truly deserving of the knowledge I shall bestow upon you!','',26124),
(7907,'enUS','','If you are seeking a truly rewarding pursuit, then a life of enchanting is for you!',26124),
(7908,'enUS','','I know many things, stranger, but your knowledge rivals my own. Enchanters who wish to hone their skills further are known to travel to the Tower of Azora, where an artisan named Kitta Firewind resides.',26124),
(7909,'enUS','','Why don\'t we see just what you\'re capable of? If you complete the task I shall be happy to further your training! ',26124),
(7910,'enUS','','I would be happy to teach you when you are ready, but that time has not yet come! I\'m sure Lalina Summermoon will guide you until then. You may find her in the Craftsmen\'s Terrace in Darnassus.',26124),
(7911,'enUS','','You have gone to great lengths, stranger, and you have my appreciation. I promised to further your training, and now I shall keep that promise.',26124),
(7912,'enUS','Enchanting has run in our family for generations. I learned at an early age, just as my son is doing now.','',26124),
(7913,'enUS','There is one whose knowledge exceeds my own. You are ready to seek her out. Go to Sun Rock Retreat in Stonetalon Mountains. Find Hgarth, and continue your training.','',26124),
(7914,'enUS','I will teach you... soon. I require a demonstration of your loyalty, first.','',26124),
(7915,'enUS','Surely Mot didn\'t send you to me? He knows better. You are not yet capable of understanding what I would teach you. See my son Mot, just outside there, and finish training with him. ','',26124),
(7916,'enUS','Ah, very good. I am satisfied that you are a worthy student. Now, your training with me may begin...','',26124),
(7917,'enUS','','I don\'t get many visitors.  You\'re looking for something specific, yes?',26124),
(7918,'enUS','','If I wasn\'t stuck here day in and day out, I would have attained the mastery required to train the likes of you! Unfortunately that\'s not the case. Go talk to Hgarth at the Sun Rock Retreat in the Stonetalon Mountains.',26124),
(7919,'enUS','','Hmm, you scratch my back, I\'ll scratch yours. If you do what I ask, and do it well, maybe we can discuss your training.',26124),
(7920,'enUS','','No, no, you\'ll need FAR more training before you\'re ready to learn from me! Go talk to that uptight dabbler Malcomb Wynn. He\'s the one buried in books over there.',26124),
(7921,'enUS','','Well, I\'ve seen better. But, you have potential, I won\'t deny it. Pay attention and you just might learn something!',26124),
(7922,'enUS','Greetings, traveler! Care to delve into the mysteries of the arcane? Hm?','',26124),
(7927,'enUS','Some adventurers think enchanting doesn\'t work. I find that when I challenge them to battle they change their tune!','',26124),
(7928,'enUS','Your skills are out of my league, stranger.Talk to Hgarth at the Sun Rock Retreat in the Stonetalon Mountains. He will provide you with more knowledge than I can. ','',26124),
(7929,'enUS','You may have what it takes. Let\'s find out! ','',26124),
(7930,'enUS','You are unfit to train with me, stranger. Spend some time with my assistant Jhag over there. ','',26124),
(7931,'enUS','Well done! You have that spark in your eye... I know it well, it\'s the same spark I had when I was but a pup! Now, let\'s see if I can\'t teach you something.','',26124),
(7932,'enUS','','What brings you to the Tower?',26124),
(7933,'enUS','','You are growing ever closer to the pinnacle of your training. To become a greater enchanter, you have yet another instructor to seek out. Her name is Annora, and you may find her in Uldaman.',26124),
(7934,'enUS','','To come this far has not been easy, I know. But how boring life would be without challenges, don\'t you think? Good, because I have a challenge for you...',26124),
(7935,'enUS','','You are eager, that is good. However, you are not yet ready to train with the likes of me. ',26124),
(7936,'enUS','','Your skills are truly becoming extraordinary. Now, let us continue your training...',26124),
(7937,'enUS','Have you come to seek the knowledge of Hgarth?','',26124),
(7938,'enUS','There is one even greater than I in this art. You are ready to receive her knowledge. She is Annora, and you may find her... in Uldaman.','',26124),
(7939,'enUS','True mastery must be earned! It is up to you to earn it now...','',26124),
(7940,'enUS','Train hard, train every day. And when you have perfected your skills, return to me.','',26124),
(7941,'enUS','You have reached new heights in your path to mastery. Let us see if we can take you even further...','',26124),
(7942,'enUS','','Greetings traveler, you have my undying gratitude for dispensing with those dreadful creatures! I was beginning to think I might have to hide out forever!',26124),
(7943,'enUS','','I am proud. You are truly a gifted student. Now, for your final lesson...',26124),
(7944,'enUS','','Your education is nearly complete. One final task is all that stands between you and the culmination of all your efforts...',26124),
(7945,'enUS','','There are still lessons you must learn from others before my knowledge may be shared with you. Be diligent, and do not give up hope.',26124),
(7946,'enUS','','Since my husband left for the front, Helene here has been my strength. Her kind heart and sharp sword have helped me through a lot of tough times. I don\'t know what I would\'ve done without her.',26124),
(7947,'enUS','','Gosh, I\'m sorry. I don\'t have anything new to teach you. How about you go talk to Simon Tanner in the Old Town section of Stormwind? He\'s a human with big muscles and dreamy red hair.',26124),
(7948,'enUS','','How\'s it going? I love the smell of leather; don\'t you?',26124),
(7949,'enUS','I already know a lot about style. Now it\'s just a matter of mastering the techniques for working with leather. Good thing Simon\'s a real sport about helping me learn them.','',26124),
(7950,'enUS','There\'s nothing I can teach you, other than maybe a better eye for color and detail. Talk to Simon Tanner over there; he knows a lot of advanced techniques for working with leather.','',26124),
(7951,'enUS','This outfit really brings out the blue in my eyes, don\'t you think? It should be obvious I have plenty of skill to go around, so I can afford to share a few of my tricks of the trade. Listen up, okay?','',26124),
(7952,'enUS','','Welcome to our home, $n. Radnaal and I have little to offer, but you are welcome to what hospitality we can provide.',26124),
(7953,'enUS','','My apologies, but you have already learned everything I know. The night elf Faldron could offer you further training, however. Look for him in the Craftsmen\'s Terrace of Darnassus.',26124),
(7954,'enUS','','You need to make your stitches smaller, $n. Fewer items will slip out of your quivers and ammo pouches. Besides, no one likes a lumpy tunic.',26124),
(7955,'enUS','','If you\'re interested in sewing with leather, you\'ve certainly come to the right place. Faldron and Telonis are true artists, and I hope to learn much from them.',26124),
(7956,'enUS','','Oh, I\'m sorry, but you know more about leather than I do at this point. Talk to Faldron over there if you wish to learn more.',26124),
(7957,'enUS','','It\'s so exciting to be here in Darnassus, surrounded by talented people! I just know I\'m going to make my family proud. Maybe if I\'m really lucky, the Sentinels will ask me to join their forces on the front!',26124),
(7958,'enUS','','This hide isn\'t ready to work with yet. I wish it didn\'t take so long to make leather. There has to be some way to cut down on all this waiting. It can\'t be good for my health, you know?',26124),
(7959,'enUS','','Aww, what rotten luck! My skills aren\'t good enough to be of any use to you. Oh well. Talk to Fimble Finespindle over there by the loom. He\'s been working with leather for longer than I have.',26124),
(7960,'enUS','','Oh, goody, something else to do while I wait! You\'re a real life-saver, $n!',26124),
(7961,'enUS','','You like the rug? I killed and skinned the beast myself. May all the centaur fall as easily.',26124),
(7962,'enUS','','I have nothing more to teach you. Talk to Karolek if you wish to further your leatherworking skills.',26124),
(7963,'enUS','','Too bad we can\'t skin the humans and their allies. All that skin is just going to waste. Still, who\'d want to wear the flimsy leather you could make out of it?',26124),
(7964,'enUS','','Skin, glorious skin. It holds your insides... in. You might\'ve noticed my skin\'s not doing so well. To think I used to worry about my pores. Hardly any skin left to worry about these days. In a way, it\'s very freeing.',26124),
(7965,'enUS','','You\'ve got the hang of it. I can\'t teach you any more, but talk to Arthur Moore, a Forsaken who works in the Rogues\' Quarter of the Undercity. Tell him I sent you.',26124),
(7966,'enUS','','Before the plague came, I knew nothing about leather. Now I know enough to teach others. Death\'s left me with a lot of time on my hands.',26124),
(7967,'enUS','Meat, skin, bones... a good hunter lets nothing go to waste. Every scrap of leather can be salvaged, perhaps to reinforce an ally\'s armor. Thus, each of us is strong alone, but together we become invincible.','',26124),
(7968,'enUS','You have outgrown any teachings I could offer. Go with the blessing of the Earth Mother. Seek out the tauren Tarn in the northwestern shops of Thunder Bluff\'s central plateau. Be guided by his wisdom.','',26124),
(7969,'enUS','We live and die, and the land remains, eternal, unmoved by our passage. Thus, land cannot belong to us, $n. Instead, we belong to it. Therefore we protect the land, for without it we cannot hope to survive.','',26124),
(7970,'enUS','The caverns below us are a source of strange and wondrous hides, but you must take care if you venture into their depths, $n. Remember that your own skin is far more valuable.','',26124),
(7971,'enUS','Your understanding of leather is deeper than my own. Perhaps you should visit the tauren Krulmoo Fullmoon in Camp Taurajo of the Barrens. He has much knowledge to offer a student of your talents.','',26124),
(7972,'enUS','Even here in the wilds, you seek out learning. Your drive for knowledge is an admirable trait.','',26124),
(7973,'enUS','Cairne himself lives here, they say. Once I have finished crafting a fitting gift, I will seek him out. Perhaps he will have words of wisdom for me.','',26124),
(7974,'enUS','Your talent is beyond my own, friend. Speak with Tarn here; his knowledge of leather is much greater than mine. I\'m sure he would welcome another student.','',26124),
(7975,'enUS','Cleanse your hands before you begin any project. Staining the leather with blood or dirt would take away from its natural beauty.','',26124),
(7976,'enUS','When I clawed my way out of the grave, I thought my family would welcome me with open arms. Instead, they drove me from the village, screaming in a language I could no longer understand.','',26124),
(7977,'enUS','I can\'t help you; your work is beyond my own. Talk to Arthur Moore, over there by the coffins. He\'ll be able to train you further.','',26124),
(7978,'enUS','Take every word I say and commit it to memory. Until our enemies have been eradicated, we must never shirk a chance to further our knowledge. Reinforce your armor, and never relax your guard.','',26124),
(7979,'enUS','HELP! ASSASSINS HAVE COME TO KILL ME!','',26124),
(7980,'enUS','I\'m free!  That device shall never torment me again!','',26124),
(7983,'enUS','','You are beyond my limited abilities. Seek out the night elf Ainethil in the Craftsmen\'s Terrace of Darnassus. She can teach you more. I only wish that I could go with you.',26124),
(7984,'enUS','','You were wise to seek me out. I would ask a small favor. In return, there is much I can teach you.',26124),
(7985,'enUS','','My teachings would be too advanced for you at this stage. If you wish to learn more of potions, speak with Tel\'Athir here instead.',26124),
(7986,'enUS','','Listen carefully, $n, for I have much knowledge to impart.',26124),
(7987,'enUS','Even I have my limitations! Go talk to Lavinia Crowe in Undercity if you wish to further your training.','',26124),
(7988,'enUS','Not bad... I suppose training you is not out of the question. Very well! Let\'s begin...','',26124),
(7989,'enUS','Randal\'s a bit of a dandy, but he\'s dependable, which is more than I can say for a lot of the students I take on. Still, I guess I can\'t blame them for wanting a bit of adventure.','',26124),
(7990,'enUS','Sorry, but you\'ve reached the limit of what I can teach. If you want to learn more, go see Telonis in the Craftsmen\'s Terrace of Darnassus. He\'s pretty talented, so I hear.','',26124),
(7991,'enUS','Okay, I\'ll teach you, but I want you to do something for me. This is important, so pay close attention.','',26124),
(7992,'enUS','Come back to me when you\'ve had more training. Randal Worth over there can help you with that.','',26124),
(7993,'enUS','Hmm, I guess I can take on another student. Well, don\'t just stand there. Tell me what you\'re looking to learn.','',26124),
(7994,'enUS','Darianna shows promise, but she is so full of energy that it is hard for her to stay still and listen. With her strength and agility, I fear it won\'t be long before she is called to fight. We must teach her quickly.','',26124),
(7995,'enUS','If you are here for further training, you have overestimated my abilities. Have a word with Telonis over there; he can help you.','',26124),
(7996,'enUS','This war has been an enormous drain upon our people and resources. Even here on Teldrassil, we cannot escape its repercussions. Forgive me for asking it of you, but would you perform a task for me?','',26124),
(7997,'enUS','In time you will be ready for what I have to teach, $n. Until then, please ask Darianna over there to help you with your training.','',26124),
(7998,'enUS','Many animals lost their lives so that we could gain these materials. Do not take their sacrifice lightly, $n. Handle the leather with the respect it deserves.','',26124),
(7999,'enUS','Lots to do! Haven\'t been this busy since my cousin accidentally vaporized all the cloth and leather in Gnomeregan. My, it was drafty for a while! Ah, $n, those were the days....','',26124),
(8000,'enUS','Nope, can\'t help you, I\'m afraid. Your skills have mine beat! If you want to learn more, talk to the night elf Telonis in the Craftsmen\'s Terrace of Darnassus. He\'s amazing!','',26124),
(8001,'enUS','I can see that you\'ll be a quick learner. That\'s good for me, because I\'m always busy these days. In fact, that reminds me: could you run a quick errand for me?','',26124),
(8002,'enUS','Well, I declare! It\'s a new student! I\'ll gladly teach you everything I know once you have a little more skill. Go talk to Gretta Finespindle over there, would you? She\'ll have you up to speed in no time.','',26124),
(8003,'enUS','Your skills are coming along nicely. Soon you\'ll be running a leather shop of your own. I\'ll be glad for the help, $n. My hands are only so fast, you know? There\'s so much work to do!','',26124),
(8004,'enUS','This blue leather does draw the eye, I know. You see, we have a great many eager recruits running around here, hunting and slaying with more enthusiasm than wisdom. One must take precautions.','',26124),
(8005,'enUS','I cannot aid you with further lessons: your skills have surpassed mine. Go and see the tauren Una in the northwestern shops of Thunder Bluff\'s central plateau. She offers more advanced training.','',26124),
(8006,'enUS','A task presses upon me, but I do not have the time to take care of it myself. Can I entrust you with it?','',26124),
(8007,'enUS','I do not offer apprentice training. Look for the tauren Waldor in the Wailing Caverns, here in the Barrens. He can assist you with whatever you need.','',26124),
(8008,'enUS','Have you come for further training? Shake the dust of the road from your garments, then, and let us get to work.','',26124),
(8009,'enUS','My axe has seen many battles, and I like to keep it handy. Enemy forces have fought their way into our capital several times now, but have no fear: we have always driven them back.','',26124),
(8010,'enUS','I cannot help you with further training: your skill at working with leather rivals my own. You should speak with Una, over there. I will vouch for your skill if need be.','',26124),
(8011,'enUS','You have come to me for instruction, and in return I have a favor to ask of you. See it done, and you will be rewarded.','',26124),
(8012,'enUS','Your skills are insufficient to learn what I teach. Try talking to Mak over there instead. He can help you out until you\'re ready for more advanced lessons.','',26124),
(8013,'enUS','I am pleased with your progress so far. Surely the Earth Mother has inspired your hands.','',26124),
(8014,'enUS','We have only a small foothold on this continent for now, but the humans can\'t fight us off forever. Then they\'ll pay for enslaving us. We\'ll cut their lying tongues out for their treachery.','',26124),
(8015,'enUS','I\'d train you if I could, but you\'re too much for me. Tell you what: go talk to the tauren Una in the northwestern shops of Thunder Bluff\'s central plateau. She\'s got some real talent.','',26124),
(8016,'enUS','There\'s enough work here for an army of orcs, and most of it, only I can do. Still, there is a job I could use a hand with.','',26124),
(8017,'enUS','You\'ve got more guts than brains, coming to me without the proper training. Go talk to somebody closer to your skill level, like the orc Kamari, who lives in the Drag of Orgrimmar.','',26124),
(8018,'enUS','We\'re pretty far from anything I\'d call civilization here, at least until the Horde can send us more reinforcements. You must really like working with leather.','',26124),
(8019,'enUS','Am I busy? What\'s that supposed to mean? Do you think I just stand here all day, twiddling my thumbs? If you\'re here to buy something, talk to Handor.','',26124),
(8020,'enUS','You won\'t learn anything new from me; you know too much already. If you want more training, talk to the tauren Una in the northwestern shops of Thunder Bluff\'s central plateau. Send her my regards, eh?','',26124),
(8021,'enUS','That\'s decent work, I admit. But I\'d be more impressed if you\'d handle something for me.','',26124),
(8022,'enUS','You can\'t study my techniques until you\'ve learned the basics. Speak with Kamari if you are interested in training.','',26124),
(8023,'enUS','The twists and turns of Orgrimmar are designed to thwart invaders. Can you imagine how quickly one of those puny gnomes would get lost in here? Ha! If it was lucky, I\'d track it down and keep it as a pet.','',26124),
(8024,'enUS','Before my death, I was a librarian; I had nothing to do with wars and plagues. I never asked to become this. On the other hand, now that my mind is my own again, I\'m not about to surrender without a fight.','',26124),
(8025,'enUS','I\'m pleased to say that your talents have outpaced my own. Go away now. Err, try the tauren Una in the northwestern shops of Thunder Bluff\'s central plateau. She\'s very skilled, I assure you.','',26124),
(8026,'enUS','Yes, yes, I\'ll train you. There\'s no need to raise your voice.','',26124),
(8027,'enUS','If I taught novices, there\'d be a lot more students visiting me, and things would get noisy. Go talk to Dan Golthas over there. He\'s a little intense, but he means well, and he\'s a decent teacher.','',26124),
(8028,'enUS','I first set up shop in the Magic Quarter, but it was pretty noisy there. This is a definite improvement, barring a few persistent students who still track me down, despite the fact that I\'ve relocated.','',26124),
(8029,'enUS','','Elune has granted the night elves many gifts. In return, it is our responsibility to safeguard these forests from the demonic taint that the Horde always brings with it.',26124),
(8030,'enUS','','Training you further is beyond my abilities. Speak to Telonis in the Craftsmen\'s Terrace of Darnassus. He is always glad to help talented students.',26124),
(8031,'enUS','','I cannot leave my post here, $n, but there is a task that must be taken care of. Can I trust you to see it done?',26124),
(8032,'enUS','','I only teach students who have already mastered the basics. You must seek out the night elf Darianna in the Craftsmen\'s Terrace of Darnassus. Her skills will be a perfect complement to yours.',26124),
(8033,'enUS','','Always double-check your measurements before you begin to cut the leather. We cannot afford to waste materials.',26124),
(8034,'enUS','I need a ride, Dungar!  I have important supplies to deliver!','I need a ride, Dungar!  I have important supplies to deliver!',26124),
(8035,'enUS','Do you know where I may find the Half Pendant of Aquatic Agility?','Do you know where I may find the Half Pendant of Aquatic Agility?',26124),
(8036,'enUS','Do you know where I may find the Half Pendant of Aquatic Endurance?','Do you know where I may find the Half Pendant of Aquatic Endurance?',26124),
(8037,'enUS','The waters of Westfall are where you must search, due west-northwest of where the Gold Coast Quarry meets with the shore.  An anchor shows where a boat has sunk beyond it, deep within the water.  The underwater pressure is fierce here; swimming too far will crush even the mightiest swimmer from fatigue.  $B$BLook for a natural formation to aid you, $n - a bubbly fissure is near here, offering deep-water swimmers a chance for renewed breath.\n','',26124),
(8038,'enUS','In the Silverpine Forest along the edges of the North Tide\'s Run, a derelict boat rests on the shore.  Out to the west of this lies what you seek; swim too far and the ocean will crush you from fatigue.  It resides on the ocean floor in a lockbox, waiting for you to claim it.$B$BYou\'ll be hard pressed to survive a dive to such depths without aid, so take heart; a bubbly fissure offers renewed breath to divers seeking this half of the pendant.  Use it wisely.','',26124),
(8039,'enUS','','In the northern part of Darkshore runs the Cliffspring River, flowing down from the lands now known as Felwood.  As the river flows out and empties out into the Mist\'s Edge, travel north to where the deepest parts of the ocean begin.  A stone formation that some call the Stone Claw due to its shape is where you may find what you seek.$B$BBe warned - threshers gather by the Stone Claw, and will attack those who trespass on their territory.',26124),
(8040,'enUS','','In the northeastern Barrens lies a pool of water sickened by pollution.  The locals call it the Sludge Fen; the Venture Company has turned the once crystal-blue waters into a mire of industrial byproducts and waste.  In the heart of this fen lies what you seek, $n.$B$BBe warned - the Venture Company does not tolerate trespassers, and they consider anyone who does not work for them as such.  You\'ll especially be a target as a protector of nature, something they vehemently oppose.',26124),
(8041,'enUS','The grass is soft and lush. The air is fresh, full of light and song. Everything I\'ve seen suggests that Teldrassil is a dream come true. Why, then, is my heart full of foreboding?','',26124),
(8042,'enUS','You have advanced beyond my skill to teach you. Journey now to Aerie Peak in the Hinterlands and speak with the dwarf Drakk Stonehand. His work is magnificent, far better than my own.','',26124),
(8043,'enUS','You have demonstrated skill in learning our craft. Do you also possess the resolve to complete a mission on my behalf?','',26124),
(8044,'enUS','I regret to say that I cannot aid you, $gnoble sir:gentle lady;, until you learn more of working with leather. Speak with Faldron or Darianna here instead. They can teach you the skill you require.','',26124),
(8045,'enUS','Do not try to force your will upon the leather. Rather, let its natural tendencies dictate what form and function it will take. This is not a battle to be won. Work with the leather, not against it.','',26124),
(8046,'enUS','','The needle is small, but the thread is strong, and the stitches are fine. Our pact with Thrall and the others will hold. The Horde will not be driven from these lands.',26124),
(8047,'enUS','','Even my talents have a limit, and you have reached it. Congratulations, $n. Your next stop should be Camp Mojache in Feralas. The tauren Hahrana Ironhide lives there; she is renowned for her skill.',26124),
(8048,'enUS','','As members of the Horde, we must contribute to our community to ensure that it continues to thrive. Thus, I am certain you will gladly aid us by undertaking a small task I have for you.',26124),
(8049,'enUS','','It\'s been so long since I was a novice myself that I don\'t think I\'d be the best teacher for you. Try talking to Tarn or Mak, right over there. One of them should be able to answer your questions.',26124),
(8050,'enUS','','Cairne has brought us to a land rich with possibilities for the future. We have been fortunate, and so in turn we pass on our good fortune to others. That is why I began teaching, $n.',26124),
(8051,'enUS','I can make amazing things with the materials I find out here. By Muradin\'s beard, there are fantastic creatures in these hills! Go have a whack at them, $n, and bring me back some tall tales.','',26124),
(8052,'enUS','Och, \'twas a sad day when I realized my obsession. I woke up and found myself tannin\' before I had my first tankard of ale. Hardly even a respectable hangover! I knew then--aye, I knew!--how it was goin\' to be.','',26124),
(8053,'enUS','I love a good challenge; don\'t you? Aye, of course ye do. An\' that\'s why you\'re about to do exactly what I say.','',26124),
(8054,'enUS','I\'m not here to teach babes fresh out of the cradle. Ye\'ve nowhere near the amount of skill I require in my students. In fact, ye\'re a sad figure of a $glad:lass;, an\' I\'ll thank ye not to stand there jibber-jabberin\' at me.','',26124),
(8055,'enUS','','All requests for my work must be made in person by the buyer. Orwin often asks me to reconsider, but my priorities lie here. Look around you: many of these fighters rely upon me for their armor.',26124),
(8056,'enUS','','I only wish I had more students like you. Not many will venture so far into enemy territory. I salute your courage.',26124),
(8057,'enUS','','We cannot afford to give an inch in this war. Day and night, I create new armor, and I patch whatever can be salvaged from the old. I have no time for other tasks. Would you take care of something for me?',26124),
(8058,'enUS','','You have wasted your time and mine by coming to me for training, $n. I have no time to teach basic skills. We\'re fighting a war here, and this is one of the front lines. Don\'t return to me until you are more prepared.',26124),
(8059,'enUS','I can tell that your wardrobe is in dire need of care.','',26124),
(8060,'enUS','I\'m a simple man who knows a few things about tailoring, but you need more assistance than I can provide. I have heard of a Night Elf who is quite an accomplished tailor. He resides in Stormwind, in the Magic District. ','',26124),
(8061,'enUS','So you would like to learn a few things? I would be happy to get you started!','',26124),
(8062,'enUS','Life is like a carefully woven tapestry.','',26124),
(8063,'enUS','Hmm... the things you need to learn are a little above my head. Have a talk with Sellandus over at Larson\'s Clothiers just up the path to the right. He taught me everything I know!','',26124),
(8064,'enUS','Very well, let your journey of tailoring begin.','',26124),
(8065,'enUS','Needlework requires a steady hand. And patience... above all, patience.','',26124),
(8066,'enUS','It is time for you to journey to Darnassus and speak to Me\'lynn. She will guide you from now on.','',26124),
(8067,'enUS','I would be happy to take you under my wing. Let us begin.','',26124),
(8068,'enUS','Welcome to me shop. What can I do for ye\'?','',26124),
(8069,'enUS','Hold on there, I\'m just an assistant. If ye want to start learnin\' the fancy stuff, talk to old Stonebrew over there.','',26124),
(8070,'enUS','Excellent! I\'ve been hopin\' for a new student. Well, let\'s get started right away then!','',26124),
(8071,'enUS','We use many animal pelts and skins in our creations. ','',26124),
(8072,'enUS','I know a few things, but I\'m no expert. Lucky for you, Magar is. He\'s standing near the back of the shop. See if he can help you, but be careful not to rile him. He can be irritable.','',26124),
(8073,'enUS','I will teach you what I can.','',26124),
(8074,'enUS','No part of the animals we hunt is wasted. ','',26124),
(8075,'enUS','You seek a higher knowledge. Tepa is blessed with such knowledge. She should be standing somewhere nearby...','',26124),
(8076,'enUS','With the Earth Mother\'s blessing, we shall begin.','',26124),
(8077,'enUS','Pleased to make you acquaintance. May I help you?','',26124),
(8078,'enUS','I am knowledgable, but I am not an expert. You know who you should talk to? Rhiannon! She\'s not far. Ask around for her in Undercity','',26124),
(8079,'enUS','So... you want to be a tailor? Very well, we\'ll see if you have what it takes.','',26124),
(8080,'enUS','We don\'t get many visitors out here. May I interest you in something?','',26124),
(8081,'enUS','I\'m just a student myself, really. Rhiannon\'s the expert. She\'s standing by the crates over there. You can learn a lot from her.','',26124),
(8082,'enUS','Yes, I think you have potential. Maybe I can show you a thing or two.','',26124),
(8083,'enUS','','There is no greater way to clear the mind than to weave.',26124),
(8084,'enUS','','My education is ongoing, and your knowledge surpasses mine. If you wish to learn more you must speak to Me\'lynn. She will guide you.',26124),
(8085,'enUS','','You will not be disappointed, traveler. Tailoring is a joyous endeavor.',26124),
(8086,'enUS','Hey mon, what can I be doin\' for you?','',26124),
(8087,'enUS','At dis point you know as much as I do, mon. Maybe you go see Magar in Orgrimmar. He not be da happiest tailor around, but he help you anyway.','',26124),
(8088,'enUS','Dat\'s da attitude! Grab a needle and thread and let\'s get jammin\'!','',26124),
(8089,'enUS','I am afraid that I am no longer gentle or humble. Age and countless battles have hardened my skin and soul. Perhaps that is why Cairne assigned me to Sun Rock Retreat... the gentle winds and warm sun does ease the pain.','',26124),
(8090,'enUS','I knew you would come, $n. It is good to see you again, friend.','',26124),
(8091,'enUS','Yawww!','',26124),
(8092,'enUS','%s loses power and shuts off!','',26124),
(8093,'enUS','%s nearly shatters!','',26124),
(8094,'enUS','Greetings.  Our bats are well trained and fed.  You\'ll not find faster.','',26124),
(8095,'enUS','How may I be of service?','',26124),
(8096,'enUS','Greetings, and welcome.  I am not very good at smiling, but trust me; I am happy to serve you.','',26124),
(8097,'enUS','Let me browse your goods.','Let me browse your goods.',26124),
(8098,'enUS','','The Hippogryph is a noble beast, proud and swift.  They are an honor to train, and can quickly take their rider a great distance.',26124),
(8099,'enUS','To maintain our link to the mainland, we have hippogryphs constantly flying between Rut\'theran Village and Darkshore.','',26124),
(8100,'enUS','','The fish off the coast of Teldrassil are quite large and robust.  Rumors say it is the speedy growth of our new world tree that is the cause.',26124),
(8101,'enUS','Although the coast of Darkshore is more dangerous than that of Teldrassil, many fishers find profit here.','',26124),
(8102,'enUS','It is my honor to provide for adventurers, for they are heroes in the making.','',26124),
(8103,'enUS','I\'m sorry but I can not let you ride my gryphons. You should go talk to Gringer if you need a ride somewhere.','',26124),
(8104,'enUS','Fastest gryphons this side of Aerie Peak. Want to take a ride?','',26124),
(8105,'enUS','Sure! Let\'s go for a ride.','Sure! Let\'s go for a ride.',26124),
(8106,'enUS','On the northern dock, you can board a ship that will carry you to Rut\'theran Village and Darnassus.  From the southern dock, you can find passage across the Great Sea to Stormwind Harbor.  The dock to the west, at the end of the pier, leads to Azuremyst Isle, near the Exodar. Safe journeys to you!','',26124),
(8107,'enUS','On guard, friend. The lady dragon will not give in without a fight.','',26124),
(8108,'enUS','This dock here?  Well you can catch the ship that goes to that Night Elf place.  What\'s it\'s name?  Uhh Auberdine I think.  I don\'t really know for sure, I just load and unload stuff.','',26124),
(8109,'enUS','As was fated a lifetime ago in Karazhan, monster - I come - and with me I bring justice.','',26124),
(8110,'enUS','Are you here to help with the delivery? Miran\'s just about ready.','',26124),
(8111,'enUS','My wind riders are trained to fly quickly through the hot Barrens air.','',26124),
(8112,'enUS','The Barrens, with its hot sun and hostile denizens, is the perfect place to test your strength and fortitude.','',26124),
(8113,'enUS','Delivering these barrels to the excavation site is hard work, but there are so many depending on us to get the blast powder there.$B$BWe must do what we can against the Dark Irons!','',26124),
(8114,'enUS','Greetings.  If you are here for leather goods, then you will find my wares well crafted.','',26124),
(8115,'enUS','Thanks for your help, $n. Because of you, another shipment arrived safely at the excavation.','',26124),
(8116,'enUS','When mounted on the back of a wind rider, one sees that its reputation for strength and speed is well earned.','',26124),
(8117,'enUS','You\'re better at this gig than I am! You want someone with even more experience than I\'ve got. That\'d be Doctor Herbert Halsey, an undead who works in the Apothecarium of the Undercity.','',26124),
(8118,'enUS','What is this? You trying to ruin my reputation? I don\'t teach novices, $gbuddy:lady;. Go talk to Milla Fairancora in the Craftsmen\'s Terrace of Darnassus.','',26124),
(8119,'enUS','','Seize him! Seize the worthless criminal and his allies!',26124),
(8120,'enUS','Have a look at my meats, friend.  You won\'t want to go out into the Barrens without a good stock of provisions.','',26124),
(8121,'enUS','Reginald, you know that I cannot let you pass.','',26124),
(8122,'enUS','You haven\'t lived until you\'ve looked down on the world from the back of a wind rider.','',26124),
(8123,'enUS','You must do what you think is right, Marcus. We served together under Turalyon. He made us both the men that we are today. Did he err with me? Do you truly believe my intent is to cause harm to our alliance? Would I shame our heroes?','',26124),
(8124,'enUS','%s appears lost in contemplation.','',26124),
(8125,'enUS','I am ashamed, old friend. I know not what I do anymore. It is not you that would dare bring shame to the heroes of legend - it is I. It is I and the rest of these corrupt politicians. They fill our lives with empty promises, unending lies.','',26124),
(8126,'enUS','Dear friend, you honor them with your vigilant watch. You are steadfast in your allegiance. I do not doubt for a moment that you would not give as great a sacrifice for your people as any of the heroes you stand under.','',26124),
(8127,'enUS','Stand down! Can you not see that heroes walk among us?','',26124),
(8128,'enUS','Move aside! Let them pass!','',26124),
(8129,'enUS','Reginald Windsor is not to be harmed! He shall pass through untouched!','',26124),
(8130,'enUS','Go, Reginald. May the light guide your hand.','',26124),
(8131,'enUS','You can find passage to Theramore from this dock.  Heed my words, those lands are rarely safe to travel for people of the Alliance.  Watch your step and your back.','',26124),
(8132,'enUS','We shame our ancestors. We shame those lost to us... forgive me, Reginald.','',26124),
(8133,'enUS','Holding me here is not the right decision, Marcus.','',26124),
(8134,'enUS','Now, it is time to bring her reign to an end, Marcus. Stand down, friend.','',26124),
(8135,'enUS','Your understanding of leather is deeper than my own. Perhaps you should visit Aayndia Floralwind in the town of Astranaar in Ashenvale Forest. She has much knowledge to offer a student of your talents.','',26124),
(8136,'enUS','Good day to you.','',26124),
(8137,'enUS','You are beyond my level of expertise. Georgio Bolero, the master of Duncan\'s Textiles around the corner could help you advance your skills.','',26124),
(8138,'enUS','I will teach you, but first you must prove your worth...','',26124),
(8139,'enUS','Speak with Lawrence Shneider at Duncan\'s Textiles around the corner to the left. He is adept at dealing with beginners.','',26124),
(8140,'enUS','A fine display of worthiness. Your instruction may now continue.','',26124),
(8141,'enUS','Ah, this Darnassian fabric is the finest!','',26124),
(8142,'enUS','Well, aren\'t you the smarty-pants? Ye know more than I do, I can tell ye that! Don\'t go getting\' a big head, but if ye want to keep learnin\', have a chat with Georgio Bolero in Stormwind. They say he knows his tailorin\'!','',26124),
(8143,'enUS','I don\'t train just anyone! You\'ll need to perform a task first!','',26124),
(8144,'enUS','I don\'t have time to babysit! Go talk to me assistant, Uthrar! ','',26124),
(8145,'enUS','Hmm... you show a little promise, I\'ll give you that. Okay then, where were we?','',26124),
(8146,'enUS','','Look around you, $r. Appreciate what you see today.$b$bMuch has changed since I first stepped foot into this forest. Wonderful and unexpected changes....',26124),
(8147,'enUS','I made a lot of the things you see in the store. What do you think? Answer carefully, your life may depend on it.','',26124),
(8148,'enUS','You need to learn from someone who knows more than I do. Go talk to Josef Gregorian in Undercity. Well, what are you still doing here?','',26124),
(8149,'enUS','You think you just walk up to me and I start teaching you? Ha! You need to pay your dues like everyone else!','',26124),
(8150,'enUS','What? Why are you bothering me? Why, I bet you can\'t even create a high quality robe! Go talk to Snang and come back when you\'re worthy of my talents!','',26124),
(8151,'enUS','About time you showed me some results! Now I\'ll show you results!','',26124),
(8152,'enUS','They say a stitch in time saves... what, eleven? Ah, I can\'t remember. Stupid saying anyway.','',26124),
(8153,'enUS','Not bad... for an amateur! Still, you know about as much as I do. If you wanna\' learn more you\'re gonna\' have to talk to Josef Gregorian in Undercity.','',26124),
(8154,'enUS','Maybe you got it, maybe you don\'t. I think I got a way to find out...','',26124),
(8155,'enUS','Ha! You ain\'t got what it takes... yet! Come back to me after you\'ve learned a few things!','',26124),
(8156,'enUS','Well well, not too bad. Maybe I CAN show you a few things...','',26124),
(8157,'enUS','','What a fine day! It inspires me to create a new design.',26124),
(8158,'enUS','','Your talents excel! You are truly inspired. To continue your pursuit of knowledge, speak with Georgio Bolero in Stormwind. He is held in high regard, and will be able to further your instruction.',26124),
(8159,'enUS','','There are many obstacles one must overcome on the path to excellence. Your path is no exception...',26124),
(8160,'enUS','','There are basics that must be learned. Trianna is standing nearby, speak with her and return to me later.',26124),
(8161,'enUS','','You have done well, traveler. I am proud to call you my student!',26124),
(8162,'enUS','','Welcome to our tent. May I assist you?',26124),
(8163,'enUS','','Your knowledge is great, traveler. You must learn from one who is wiser than I. Many tales have been told of the wisdom of Josef Gregorian. You may find him in Undercity.',26124),
(8164,'enUS','','There is a task I would like you to perform before we go any further...',26124),
(8165,'enUS','','You still have lessons to learn before I may begin your training. In the meantime, perhaps Vhan, in Thunder Bluff can help you.',26124),
(8166,'enUS','','Expertly accomplished! Now, let us continue your education...',26124),
(8167,'enUS','Light be with you, sir.','Light be with you, sir.',26124),
(8168,'enUS','','Aren\'t the patterns beautiful? Each one speaks with its own voice.',26124),
(8169,'enUS','','My knowledge is limited, though I am still learning. It is time for you to move on, traveler. Find Josef Gregorian in Undercity and tell him you are ready.',26124),
(8170,'enUS','You are an inspiration to us all, sir.','You are an inspiration to us all, sir.',26124),
(8171,'enUS','','I will require a demonstration of your determination before I share my gifts with you...',26124),
(8172,'enUS','There walks a hero.','There walks a hero.',26124),
(8173,'enUS','','There are fundamental things you must learn before I can aid you. Speak to my apprentice, Vhan. He is kind and patient and will teach you what you need to know.',26124),
(8174,'enUS','','You are truly a determined student. I will be happy to provide you with instruction!',26124),
(8175,'enUS','Make way!','Make way!',26124),
(8176,'enUS','','Tailoring can come in very handy. I once had to sew my arm back on.',26124),
(8177,'enUS','We are but dirt beneath your feet, sir.','We are but dirt beneath your feet, sir.',26124),
(8178,'enUS','','You have worked your way up... time to see the boss. Go to Josef and tell him you are ready.',26124),
(8179,'enUS','','Okay... so you wanna\' be a tailor. How about you prove it?',26124),
(8180,'enUS','A moment I shall remember for always.','A moment I shall remember for always.',26124),
(8181,'enUS','','How can I share my secrets with a beginner? Try speaking with Victor Ward first.',26124),
(8182,'enUS','','Good, you\'ve got some grit! I like that. Well then, let\'s get going!',26124),
(8183,'enUS','...nerves of thorium.','...nerves of thorium.',26124),
(8184,'enUS','A living legend... ','A living legend... ',26124),
(8185,'enUS','Yes, I\'ve been running this shop for some time now. Business has been pretty good lately. A lot of new adventurers coming through...','',26124),
(8186,'enUS','There\'s only one person I know of who is more learned in the art of tailoring than myself. Last I heard he could be found in Theramore Isle. He is the person you should seek.','',26124),
(8187,'enUS','I require all my students to prove their dedication. Now it\'s your turn...','',26124),
(8188,'enUS','You\'ll need more training before I can share my knowledge with you, I\'m afraid. ','',26124),
(8189,'enUS','Good! I can tell that my efforts will not be wasted!','',26124),
(8190,'enUS','Cloth is okay. Personally I prefer to work with human skin.','',26124),
(8191,'enUS','You require the instruction of a true master! Go to Daryl Stack in Tarren Mill and embrace your destiny!','',26124),
(8192,'enUS','Before your learning may begin, I must ask of you a favor...','',26124),
(8193,'enUS','I will instruct you when the time is right... that time is not now. You have much more to learn first!','',26124),
(8194,'enUS','Good! I can tell that my efforts will not be wasted!','',26124),
(8195,'enUS','I have outfitted kings. With the proper training, you can too.','',26124),
(8196,'enUS','You have truly become one of the finest tailors in the business! Congratulations, I am proud to have been your instructor!','',26124),
(8197,'enUS','You have come a long way, traveler. There is one more task for you to perform...','',26124),
(8198,'enUS','I cannot help you until you have learned more of the essentials. Come back to me when you are ready.','',26124),
(8199,'enUS','I am not worthy, sir.','',26124),
(8200,'enUS','The place is a bit drafty... but what do I care? I\'m dead.','',26124),
(8201,'enUS','Well done. You have now earned tailoring\'s highest honor. Go forth, and do terrible things with this knowledge!','',26124),
(8202,'enUS','You\'re doing very well in the art of tailoring, I must admit. Now, let\'s see how good you REALLY are...','',26124),
(8203,'enUS','Who sent you here? You\'re not ready for my instruction yet! You\'ll be told when you\'re ready.','',26124),
(8204,'enUS','','I do so enjoy sitting out here, listening to the sounds of the Great Sea.  Oh, what?  Yes, there is a ship that will take you to Menethil Harbor.  It docks here from time to time.',26124),
(8205,'enUS','Thank you, old friend. You have done the right thing.','',26124),
(8206,'enUS','Follow me, friends. To Stormwind Keep!','',26124),
(8207,'enUS','Be brave, friends. The reptile will thrash wildly. It is an act of desperation. When you are ready, give me the word.','',26124),
(8208,'enUS','Onward!','',26124),
(8209,'enUS','Mark my words!  You won\'t find faster gryphons anywhere in the Eastern Kingdoms than the ones right here in Thelsamar!','',26124),
(8210,'enUS','Majesty, run while you still can. She is not what you think her to be...','',26124),
(8211,'enUS','The masquerade is over, Lady Prestor. Or should I call you by your true name... Onyxia...','',26124),
(8212,'enUS','To the safe hall, your majesty.','',26124),
(8213,'enUS','If you ask me, there\'s no greater profession than a miner.  And if you ask me, there\'s no greater miner than a dwarf!','',26124),
(8214,'enUS','','%s laughs.',26124),
(8215,'enUS','','You will be incarcerated and tried for treason, Windsor. I shall watch with glee as they hand down a guilty verdict and sentence you to death by hanging...',26124),
(8216,'enUS','','And as your limp body dangles from the rafters, I shall take pleasure in knowing that a mad man has been put to death. After all, what proof do you have? Did you expect to come in here and point your fingers at royalty and leave unscathed? ',26124),
(8217,'enUS','The Wildhammer dwarves might have fast steeds, but can those Aerie Peak gryphons stand the heat of The Great Forge?  I think not!','',26124),
(8218,'enUS','You will not escape your fate, Onyxia. It has been prophesied - a vision resonating from the great halls of Karazhan. It ends now...','',26124),
(8219,'enUS','Listen, dragon. Let the truth resonate throughout these halls.','',26124),
(8220,'enUS','The best miner has a firm grip on $ghis:her; pick, a stout heart in $ghis:her; chest, and thick, black dust in $ghis:her; hair.','',26124),
(8221,'enUS','I would like to train.','I would like to train.',26124),
(8222,'enUS','The sturdy crate sits in the middle of the lumber mill surrounded by debris and very zealous followers of the Scarlet Crusade.','',26124),
(8223,'enUS','Place Termite Barrel on the crate.','Place Termite Barrel on the crate.',26124),
(8224,'enUS','%s, too injured, gives up the chase.','',26124),
(8225,'enUS','%s obviously beaten, tries to run.','',26124),
(8226,'enUS','%s reaches into his pack and pulls out the encoded tablets.','',26124),
(8227,'enUS','The Dark Irons thought these tablets to be encoded. This is not any form of coding, it is the tongue of ancient dragon.','',26124),
(8228,'enUS','%s reads from the tablets. Unknown, unheard sounds flow through your consciousness.','',26124),
(8229,'enUS','What can you tell me about the bear - Ursangous?\n','What can you tell me about the bear - Ursangous?',26124),
(8230,'enUS','What can you tell me about the nightsaber cat - Shadumbra?\n','What can you tell me about the nightsaber cat - Shadumbra?',26124),
(8231,'enUS','What can you tell me about the hippogryph - Sharptalon?\n','What can you tell me about the hippogryph - Sharptalon?',26124),
(8232,'enUS','','This bear wanders a path close to where the Talondeep Path lies, due west of Mystral Lake and the Alliance outpost of Silverwind Refuge.  While he is the easiest of the three creatures you will face on the Ashenvale Hunt, he should not be trifled with.  His presence is a constant threat to travelers who sojourn between Ashenvale and the Stonetalon Mountains.',26124),
(8233,'enUS','','This nightsaber is rumored to be docile in the presence of night elves and their allies, which makes her an even more worthy opponent.  Shadumbra\'s hunting path takes her from the Raynewood Retreat to our west, ultimately to lands due west of there.  Her fur is the color of pitch, and her speed is not to be underestimated.',26124),
(8234,'enUS','','The mightiest of all the beasts that make up the Ashenvale Hunt, Sharptalon is let to wander freely by the self-proclaimed guardians of this land, the night elves.  Sharptalon patrols for prey to the south of here, taking delight in rending the unsuspecting and unaware traveler limb from limb.$B$BTo bring down such a beast would be the mightiest of hauls, $n.  I wish you luck in the hunt for this creature!',26124),
(8235,'enUS','','Curious... Windsor, in this vision, did you survive? I only ask because one thing that I can and will assure is your death. Here and now.',26124),
(8236,'enUS','%s gasps.','',26124),
(8237,'enUS','Dragon filth! Guards! Guards! Seize this monster!','',26124),
(8238,'enUS','','%s laughs.',26124),
(8239,'enUS','','Yesss... Guards, come to your lord\'s aid!',26124),
(8240,'enUS','Get your seats, folks!  The race is starting in 2 minutes!','',26124),
(8241,'enUS','The Drag race will start in 1 minute!','',26124),
(8242,'enUS','Look at what $n brought us!  Let\'s drink up!','',26124),
(8243,'enUS','Greetings $c - welcome to the front lines in our conquest of Ashenvale!  If you are looking for something to do, then you\'ve come to the right place.  I\'m always looking for able-bodied individuals to help bring glory to the Horde!','',26124),
(8244,'enUS','$n brought us booze!  Let\'s party!','',26124),
(8245,'enUS','%s hisses.','',26124),
(8246,'enUS','','Was this fated, Windsor? If it was death that you came for, then the prophecy has been fulfilled. May your consciousness rot in the Twisting Nether. Finish the rest of these meddlesome insects, children. Bolvar, you have been a pleasurable puppet.',26124),
(8247,'enUS','DO NOT LET HER ESCAPE!','',26124),
(8248,'enUS','','You have failed him, mortalsss... Farewell!',26124),
(8249,'enUS','Reginald... I... I am sorry.','',26124),
(8250,'enUS','Bol... Bolvar... the medallion... use...','',26124),
(8251,'enUS','%s dies.','',26124),
(8252,'enUS','%s becomes exhausted!','',26124),
(8253,'enUS','%s performs one last service for Ragnaros...','',26124),
(8254,'enUS','%s forces one of his Firesworn minions to erupt!','',26124),
(8255,'enUS','The dragon hides behind a royal facade. The tablets will reveal her for what she is... If what I have seen holds true, I will not survive this battle, friend. It is you that must finish what I have started. Are your forces ready? Are you ready? We will begin on your command.','',26124),
(8256,'enUS','I am ready, as are my forces. Let us end this masquerade!','I am ready, as are my forces. Let us end this masquerade!',26124),
(8257,'enUS','If you want to know about the comings and goings of caravans and merchants here in Splintertree Post, then I am fortunately the orc you are looking for.  Unfortunately for you though, I don\'t like people.$B$BIf you want something, make it quick.','',26124),
(8258,'enUS','The elements speak to us, $c.  They share knowledge that we must learn, and they share secrets that must be kept.','',26124),
(8259,'enUS','','',26124),
(8260,'enUS','Through rigorous retraining I have had to break many students of all they had previously learned so that I might teach them anew.  The service I offer becomes increasingly difficult to perform each time it is done.  It is for that reason that it becomes increasingly expensive with each retraining.  Do you desire that I break you of the talents you have learned?','Through rigorous retraining I have had to break many students of all they had previously learned so that I might teach them anew.  The service I offer becomes increasingly difficult to perform each time it is done.  It is for that reason that it becomes increasingly expensive with each retraining.  Do you desire that I break you of the talents you have learned?',26124),
(8261,'enUS','How do I reset my Talents?','How do I reset my Talents?',26124),
(8262,'enUS','Yes. I do.','Yes. I do.',26124),
(8263,'enUS','If you desire, in addition to training, I have it within my power to erase the knowledge of your talents from your mind.  Be warned that every time you undergo this procedure the more difficult it is to perform, and therefore the more expensive it becomes.','If you desire, in addition to training, I have it within my power to erase the knowledge of your talents from your mind.  Be warned that every time you undergo this procedure the more difficult it is to perform, and therefore the more expensive it becomes.',26124),
(8264,'enUS','Look at the wisdom and knowledge of the beast, and you will see yourself. Observe as the owl does, learn cleverness from the sabercat, embody the mighty spirit of the wolf.','Look at the wisdom and knowledge of the beast, and you will see yourself. Observe as the owl does, learn cleverness from the sabercat, embody the mighty spirit of the wolf.',26124),
(8265,'enUS','Thank you for freeing me.  Speak with my sister in Splintertree.  I... I must find a place to rest...','',26124),
(8266,'enUS','%s\'s medallion shatters.','',26124),
(8267,'enUS','The arcane only corrupts those who are weak. Keep up on your training, or you may find a similar fate.','The arcane only corrupts those who are weak. Keep up on your training, or you may find a similar fate.',26124),
(8268,'enUS','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BThere will be a time soon where the call of the Emerald Dream will take hold in you.  You will hibernate for many years and walk amongst the purest of forms.  It is there and then that your ultimate training will take place.','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BThere will be a time soon where the call of the Emerald Dream will take hold in you.  You will hibernate for many years and walk amongst the purest of forms.  It is there and then that your ultimate training will take place.',26124),
(8269,'enUS','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BThere will be a time soon where the call of the Emerald Dream will take hold in you.  You will hibernate for many years and walk amongst the purest of forms.  It is there and then that your ultimate training will take place.','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BThere will be a time soon where the call of the Emerald Dream will take hold in you.  You will hibernate for many years and walk amongst the purest of forms.  It is there and then that your ultimate training will take place.',26124),
(8270,'enUS','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BThere will be a time soon where the call of the Emerald Dream will take hold in you.  You will hibernate for many years and walk amongst the purest of forms.  It is there and then that your ultimate training will take place.','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BThere will be a time soon where the call of the Emerald Dream will take hold in you.  You will hibernate for many years and walk amongst the purest of forms.  It is there and then that your ultimate training will take place.',26124),
(8271,'enUS','I wish to unlearn my talents.','I wish to unlearn my talents.',26124),
(8272,'enUS','Yes. I do.','Yes. I do.',26124),
(8273,'enUS','I wish to unlearn my talents.','',26124),
(8274,'enUS','','I wish to unlearn my talents.',26124),
(8275,'enUS','What can I do for ya?','What can I do for ya?',26124),
(8276,'enUS','I got nothin\' more to teach! Not for somebody who knows as much as you do, anyway! You Horde types need to talk to Nogg in Orgrimmar!','',26124),
(8277,'enUS','Ragers, Fetch!','',26124),
(8278,'enUS','Ok, let\'s move out!','',26124),
(8279,'enUS','','Who dares attack the Silverwing Outpost?!?',26124),
(8280,'enUS','Silverwing is ours!','',26124),
(8281,'enUS','Go report that the outpost is taken.  We will remain here.','',26124),
(8282,'enUS','Prepare yourselves.  Silverwing is just around the bend.','',26124),
(8283,'enUS','For the Horde!','',26124),
(8284,'enUS','Everyone ready?','',26124),
(8285,'enUS','','I mean you no harm. I am scouting the quilboar and taking notes of their activities. My people have noticed something odd--an emanation or darkness--coming from this area. I\'ve come to investigate, and what I\'ve found is very disturbing.$B$BThere seems to be an undead diplomat who is powerful in the ways of the arcane. I don\'t believe he\'s one of the Forsaken... I think it\'s worse.',26124),
(8286,'enUS','','How fortuitous. Usually, I must leave my lair in order to feed.',26124),
(8287,'enUS','','Learn your place, mortal!',26124),
(8288,'enUS','','This meaningless exertion bores me. I\'ll incinerate you all from above!',26124),
(8289,'enUS','You know enough to be dangerous, but you still look like you need training to me $n.','You know enough to be dangerous, but you still look like you need training to me $n.',26124),
(8290,'enUS','','It seems you\'ll need another lesson, mortals!',26124),
(8291,'enUS','Your will is not strong enough to manipulate the forces we control $c.','Your will is not strong enough to manipulate the forces we control $c.',26124),
(8292,'enUS','It is a greater knowledge of the ways of the warlock that I crave.','It is a greater knowledge of the ways of the warlock that I crave.',26124),
(8293,'enUS','$n, how may I further your training in the eyes of the Earth Mother?','$n, how may I further your training in the eyes of the Earth Mother?',26124),
(8294,'enUS','Many are the paths of the Earth Mother.  May your ancestors watch over you $c.','Many are the paths of the Earth Mother.  May your ancestors watch over you $c.',26124),
(8295,'enUS','I seek further druidic training to have a closer understanding of the Earth Mother\'s will.','I seek further druidic training to have a closer understanding of the Earth Mother\'s will.',26124),
(8296,'enUS','It is wise that you humble yourself before me, $n, in your desire for more warlock knowledge.','It is wise that you humble yourself before me, $n, in your desire for more warlock knowledge.',26124),
(8297,'enUS','I have no time to waste on the likes of you $c.','I have no time to waste on the likes of you $c.',26124),
(8298,'enUS','I submit myself for further training, my master.','I submit myself for further training, my master.',26124),
(8299,'enUS','I can tell just by the way you\'re standing that you\'re no warrior.  $B$BWhy don\'t you go do something safe, like read a book.','I can tell just by the way you\'re standing that you\'re no warrior.  $B$BWhy don\'t you go do something safe, like read a book.',26124),
(8300,'enUS','The darkness does not embrace you, $c.  Cease your prattle and remove yourself from my sight!  Be gone!','The darkness does not embrace you, $c.  Cease your prattle and remove yourself from my sight!  Be gone!',26124),
(8301,'enUS','I\'m afraid your darkness quotient isn\'t sufficient enough for me to bother talking to you any further.  Move along please.','I\'m afraid your darkness quotient isn\'t sufficient enough for me to bother talking to you any further.  Move along please.',26124),
(8302,'enUS','Yer no warrior... Why ye wouldn\'t even last a day under my training regimen!  $B$BA $c who thinks $ghe\'s : she\'s; a warrior.  Ha!','Yer no warrior... Why ye wouldn\'t even last a day under my training regimen!  $B$BA $c who thinks $ghe\'s : she\'s; a warrior.  Ha!',26124),
(8303,'enUS','I do not see the warrior\'s spirit within you, child.  I have no teachings which would benefit a $c such as yourself.','I do not see the warrior\'s spirit within you, child.  I have no teachings which would benefit a $c such as yourself.',26124),
(8304,'enUS','%s emerges to protect the Fathom Stone!','',26124),
(8305,'enUS','Pathetic. You two do not deserve the training you are getting here if that was the best you can do.','',26124),
(8306,'enUS','Lysta, summon in undead captives.','',26124),
(8307,'enUS','Lysta, summon forth... the abomination!','',26124),
(8308,'enUS','Please share your wisdom with me, Warchief.','Please share your wisdom with me, Warchief.',26124),
(8309,'enUS','The Shattered Hand has been able to place spies throughout the upper citadel of Blackrock. Though the information gathering process has been slow, we have made discoveries that cannot be ignored.','',26124),
(8310,'enUS','What discoveries?','What discoveries?',26124),
(8311,'enUS','It would appear as if the influence of the Black Dragonflight had extended beyond the borders of the Burning Steppes and into the kingdom of Stormwind itself! The usurper has since been unmasked and ousted.','',26124),
(8312,'enUS','Usurper?','Usurper?',26124),
(8313,'enUS','Indeed. The brood mother of the Black Dragonflight had used illusion and trickery to disguise herself as a member of the royal court. Worse yet, she had assumed control of the current Highlord of Stormwind, Bolvar Fordragon.$B$BIt is no wonder that such foolish military decisions had been made. The movement of the Alliance forces as of late had left us scratching our heads. We now understand that the Black Flight was attempting to divide the empire - destroy it from within.','',26124),
(8314,'enUS','With all due respect, Warchief - why not allow them to be destroyed? Does this not strengthen our position?\n','With all due respect, Warchief - why not allow them to be destroyed? Does this not strengthen our position?\n',26124),
(8315,'enUS','<Thrall laughs.>$B$BSo much to learn still, $r.$B$BYou are too young to remember the wars and bloodshed of ages past. Too young to remember the burden of the curse carried by our people.$B$BOur position with the Alliance right now is a tenuous one. Skirmishes and smaller battles do take place, but there is peace - something our people have not known for millennia. Would you give this up and plunge us into the maw of chaos again but against a new foe? One that will not rest until we are all destroyed?','',26124),
(8316,'enUS','I... I did not think of it that way, Warchief.','I... I did not think of it that way, Warchief.',26124),
(8317,'enUS','No, $n, you did not. I do not fault you, however, as yours is a mind much like mine was as a youth: Impetuous, rebellious, and often without a single coherent thought! Traits I can no longer afford to express.$B$BEnough lamenting. $R, I have a task for you; one that you may not survive. ','',26124),
(8318,'enUS','I live only to serve, Warchief! My life is empty and meaningless without your guidance.','I live only to serve, Warchief! My life is empty and meaningless without your guidance.',26124),
(8319,'enUS','<Thrall laughs.>$B$BNoted... Now pay attention, $n. The Black Dragonflight brood mother, Onyxia, has been flushed out from her position of power in Stormwind. She has escaped, fleeing to her lair in Dustwallow Marsh.$B$BShe cannot be allowed to live in such close proximity to our capital cities. We must strike before being struck!$B$BI want her destroyed, $n. ','',26124),
(8320,'enUS','Of course, Warchief!','Of course, Warchief!',26124),
(8321,'enUS','%s collapses upon seeing his master die!','',26124),
(8322,'enUS','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BWe are the preservers of the balance, now and forever, as Malfurion lies in the Dreaming.  Never forget this.','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BWe are the preservers of the balance, now and forever, as Malfurion lies in the Dreaming.  Never forget this.',26124),
(8323,'enUS','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BWe are the preservers of the balance, now and forever, as Malfurion lies in the Dreaming.  Never forget this.','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BWe are the preservers of the balance, now and forever, as Malfurion lies in the Dreaming.  Never forget this.',26124),
(8324,'enUS','Myranda, do you have enough eyeballs to make another amulet? I have lost the old one.','Myranda, do you have enough eyeballs to make another amulet? I have lost the old one.',26124),
(8325,'enUS','I see some interesting characters come and go here at the port. Watch yourself, $n. It\'s never clear who to trust, what with all of the shady activity that goes on here...','',26124),
(8326,'enUS','So you\'re here for the Warsong axes. Well, it\'s about time, $n. That crate has been sitting out there for days, now.$B$BFeel free to haul it away whenever you are ready.','',26124),
(8327,'enUS','','Let\'s go before they find out I\'m free!',26124),
(8328,'enUS','','Look out! We\'re under attack!',26124),
(8329,'enUS','','Thank you for helping me. I know my way back from here.',26124),
(8330,'enUS','Stonetalon Mountain has many perilous caves through out this region.  Exploring these caves can hold many adventures for those willing to risk life for glory.$B$B$C, perhaps you seek riches that only following your heart and soul can garnish.','',26124),
(8331,'enUS','%s goes into a rage after seeing Misha fall in battle!','%s goes into a rage after seeing Misha fall in battle!',26124),
(8332,'enUS','','Please wait while I attempt to bind the shards together so that they will be whole once again.',26124),
(8333,'enUS','','Ishnu... Oshalan thara dormil... Anu\'dorin...',26124),
(8334,'enUS','Fish so delicious. You come learn fish? Eat fish? Mmmmm...','',26124),
(8335,'enUS','I require training, Lumak.','I require training, Lumak.',26124),
(8336,'enUS','Yap, I can teach ye to fish.','',26124),
(8337,'enUS','I require training, Grimnur.','I require training, Grimnur.',26124),
(8338,'enUS','','Yes, I was able to reseal the relic, $n.',26124),
(8339,'enUS','','Please, leave this place, $n. You know nothing of what troubles us...',26124),
(8340,'enUS','Where can I get Enchanted Thorium?','Where can I get Enchanted Thorium?',26124),
(8341,'enUS','Where can I find Crystal Restore?','Where can I find Crystal Restore?',26124),
(8342,'enUS','','Enchanted thorium is a highly sought-after metal. You best chance of finding some of it is to speak with an artisan blacksmith or miner.',26124),
(8343,'enUS','','Crystal Restore is a difficult item to acquire.$B$BI believe that it comes from Un\'Goro Crater, so you\'d best head there.',26124),
(8344,'enUS','We may have been suffering a drought but there\'s no shortage of meat! Care to browse my goods?','',26124),
(8345,'enUS','I wish to browse your goods, Dirge.','I wish to browse your goods, Dirge.',26124),
(8346,'enUS','','Can Zamja help you, $r?',26124),
(8347,'enUS','I require training, Zamja.','I require training, Zamja.',26124),
(8348,'enUS','I keep \'em fed, kid. Yep, Daryl Riknussun, at yer service.','',26124),
(8349,'enUS','I require training, Daryl.','I require training, Daryl.',26124),
(8350,'enUS','You are a little gnat to the Foulweald!  Die!','',26124),
(8351,'enUS','No!  You cannot be stronger than the Foulweald!  No!!','',26124),
(8352,'enUS','Heeellp meee... ri... ribss... bro... broken.','',26124),
(8353,'enUS','Dying... See the light... gloriouss...','',26124),
(8354,'enUS','I... I think I see Blue...','',26124),
(8355,'enUS','I\'m saved! Thank you, doctor!','',26124),
(8356,'enUS','My entrails are leaking out! HELP!','',26124),
(8357,'enUS','I\'m not gonna make it... death comes... ','',26124),
(8358,'enUS','Goodbye, cruel world... I\'m leavin\' you today... goodbye... goodbye... goodbye...','',26124),
(8359,'enUS','HOORAY! I AM SAVED!','',26124),
(8360,'enUS','Brain encaved... mortar... bas... hed... leaking... dyin... g...','',26124),
(8361,'enUS','Sweet, sweet embrace... take me... ','',26124),
(8362,'enUS','The good doctor saves the day! HOORAY!','',26124),
(8363,'enUS','I regret to inform you that you have failed your examination, doctor.','',26124),
(8364,'enUS','I am an orc of medicine, $r. If you have come here to learn, I shall do my best to teach.','',26124),
(8365,'enUS','I require training, Arnok.','I require training, Arnok.',26124),
(8366,'enUS','','May this evil aura be banished from this artifact!',26124),
(8367,'enUS','','I can feel the presence of evil leaving...',26124),
(8368,'enUS','','Are you a student of the medical sciences?',26124),
(8369,'enUS','I require training, Nissa.','I require training, Nissa.',26124),
(8370,'enUS','','Why have you come here, $c?',26124),
(8371,'enUS','','My people, they are as shattered as the relic you seek to repair.',26124),
(8372,'enUS','','While nothing can change the past, time can heal all wounds. Thank you for showing me that it is possible, $n. I wish you well.',26124),
(8373,'enUS','Kel\'Thuzad? If you know that name at all, then perhaps you did read the book I sent you to get.$B$BUnfortunately, you\'re answer is incorrect.','',26124),
(8374,'enUS','Gul\'dan. Not a name many have heard on Azeroth.$B$BUnfortunately, not the correct answer.','',26124),
(8375,'enUS','An interesting response to my question... and the wrong one.','',26124),
(8376,'enUS','Ah, Ner\'zhul. Not a name that should be uttered lightly, but I did ask you for an answer.$B$BAnd Ner\'zhul is the correct one.','',26124),
(8377,'enUS','Kel\'Thuzad is my answer.','Kel\'Thuzad is my answer.',26124),
(8378,'enUS','Gul\'dan is my answer.','Gul\'dan is my answer.',26124),
(8379,'enUS','Kil\'jaeden is my answer.','Kil\'jaeden is my answer.',26124),
(8380,'enUS','Ner\'zhul is my answer.','Ner\'zhul is my answer.',26124),
(8381,'enUS','Ysera is my answer.','Ysera is my answer.',26124),
(8382,'enUS','Ah, Ysera the Dreamer.','',26124),
(8383,'enUS','Neltharion is  my answer.','Neltharion is  my answer.',26124),
(8384,'enUS','Alexstrasza is  my answer.','Alexstrasza is  my answer.',26124),
(8385,'enUS','Malygos is my answer.','Malygos is my answer.',26124),
(8386,'enUS','Neltharion, hmm? As good an answer as any, yes?','',26124),
(8387,'enUS','Alexstrazsa, the Life-Binder. A magnificent creature.','',26124),
(8388,'enUS','Malygos, is it?','',26124),
(8389,'enUS','Greetings, $c. Is there something I can help you with?','',26124),
(8390,'enUS','My question to you is this, $c:$BWhich of the Aspects created by the titans became the nefarious creature known as Deathwing?','',26124),
(8391,'enUS','It\'s always nice when someone wishes to speak to me. How are things with you, $c?','',26124),
(8392,'enUS','Now, answer me this, $n:$BWhich creature became the Lich King before spreading the plague across Lordaeron?','',26124),
(8393,'enUS','That is the wrong answer, $n. Be off with you.','',26124),
(8394,'enUS','I\'m afraid not, $n. Now, feel the shame you have brought upon yourself.','',26124),
(8395,'enUS','','In position!',26124),
(8396,'enUS','','For the Great Mother!',26124),
(8397,'enUS','','Warriors of the night... Assemble!',26124),
(8398,'enUS','%s attacks the banner!','',26124),
(8399,'enUS','Yeah, you know a few things! If you wanna\' learn more you\'re gonna\' have to talk to Georgio Bolero in Stormwind.','',26124),
(8400,'enUS','The Thorium Brotherhood possesses the knowledge required to make the sacred arms and armaments of the Fire Lord, but we lack the manpower to obtain the materials required for the crafting.$B$BI, Lokhtos Darkbargainer, have been empowered by the Brotherhood to exchange the exalted recipes for materials gathered from the Molten Core.$B$BPresent your offer, $r.','',26124),
(8401,'enUS','Show me what I have access to, Lokhtos.','Show me what I have access to, Lokhtos.',26124),
(8402,'enUS','Want to make your demons more powerful?  It\'ll cost you, but you\'ve come to the right place.','Want to make your demons more powerful?  It\'ll cost you, but you\'ve come to the right place.',26124),
(8403,'enUS','You\'re no warlock and I\'ve no time for you.  Begone!','You\'re no warlock and I\'ve no time for you.  Begone!',26124),
(8404,'enUS','Show me your selection of grimoires.','Show me your selection of grimoires.',26124),
(8405,'enUS','','',26124),
(8406,'enUS','You\'ve come for training in order to pass it on to your pets?','You\'ve come for training in order to pass it on to your pets?',26124),
(8407,'enUS','Ah friend, I only help hunters and their pets.','Ah friend, I only help hunters and their pets.',26124),
(8408,'enUS','Train me in the ways of the beast.','Train me in the ways of the beast.',26124),
(8409,'enUS','Fear lies in your heart. When you truly are ready to face Vorsha the Lasher, come speak with me.','',26124),
(8410,'enUS','Now we must wait. It won\'t be long before the naga realize what we have done.','',26124),
(8411,'enUS','The Royal Apothecary Society has little patience for fools, as do I.  Perhaps the next time you and I speak of my steeds, you will be considered exalted by the Undercity.  Until then...','The Royal Apothecary Society has little patience for fools, as do I.  Perhaps the next time you and I speak of my steeds, you will be considered exalted by the Undercity.  Until then...',26124),
(8412,'enUS','Be on your guard, $n!','',26124),
(8413,'enUS','Perhaps we will get a moment to rest. But I will not give up until we have faced off against Vorsha!','',26124),
(8414,'enUS','I only make my mounts available to those who are considered exalted to Orgrimmar and the Orcish race.  Go prove yourself to us, and I\'ll make my mighty wolves available for your inspection.','I only make my mounts available to those who are considered exalted to Orgrimmar and the Orcish race.  Go prove yourself to us, and I\'ll make my mighty wolves available for your inspection.',26124),
(8415,'enUS','I\'m sorry $g mon : sis;, but I won\'t be sellin\' my raptors to someone who hasn\'t proven themselves to be exalted to the Darkspear tribe.  When ya make a stand and show yourself to be no less than exalted to us, then I\'ll make my raptors available to ya.','I\'m sorry $g mon : sis;, but I won\'t be sellin\' my raptors to someone who hasn\'t proven themselves to be exalted to the Darkspear tribe.  When ya make a stand and show yourself to be no less than exalted to us, then I\'ll make my raptors available to ya.',26124),
(8416,'enUS','You are not known to my people.  A kodo is a mighty steed, and it is the product of love and care by my people; such is not given onto strangers.  Until the elders of Thunder Bluff consider you to be exalted, I cannot offer you the sale of a kodo.','You are not known to my people.  A kodo is a mighty steed, and it is the product of love and care by my people; such is not given onto strangers.  Until the elders of Thunder Bluff consider you to be exalted, I cannot offer you the sale of a kodo.',26124),
(8417,'enUS','Alas $c, you are not considered to be exalted to Darnassus and the night elves of Teldrassil.  Only when you prove yourself to us through deeds - not just mere words - will I then make available my selection of mounts for your perusal.','Alas $c, you are not considered to be exalted to Darnassus and the night elves of Teldrassil.  Only when you prove yourself to us through deeds - not just mere words - will I then make available my selection of mounts for your perusal.',26124),
(8418,'enUS','Stay back! Children should not be here! Be gone, child!','',26124),
(8419,'enUS','Intruders! Attack the intruders!','Intruders! Attack the intruders!',26124),
(8420,'enUS','Steady, people.  We\'ll raid soon enough.','',26124),
(8421,'enUS','With luck, we\'ll gain some good scars today.','',26124),
(8422,'enUS','These woods make my tusks itch...','',26124),
(8423,'enUS','They say Duriel is a fierce night elf.  It\'ll be a good fight!','',26124),
(8424,'enUS','We\'ll be notching our axes after this.','',26124),
(8425,'enUS','Stay calm, people.  We don\'t want to give away our position.','',26124),
(8426,'enUS','Plucky?  I heard race master Kronkrider up on the the tower knows where he is.','Plucky?  I heard race master Kronkrider up on the the tower knows where he is.',26124),
(8427,'enUS','You looking for plucky?  Well, you didn\'t hear me say this, but... maybe if you ask Kronkrider up in the tower, he\'ll tell you...','You looking for plucky?  Well, you didn\'t hear me say this, but... maybe if you ask Kronkrider up in the tower, he\'ll tell you...',26124),
(8428,'enUS','Sorry, but I am not disposed to sell horses to any individual who is not considered to be at least exalted to the Kingdom of Stormwind.  These steeds are the finest you\'ll find anywhere, and we certainly wouldn\'t want them in the hands of our enemies.$B$BNot saying you\'re an enemy, of course... just earn the trust of Stormwind and then we can do business.','Sorry, but I am not disposed to sell horses to any individual who is not considered to be at least exalted to the Kingdom of Stormwind.  These steeds are the finest you\'ll find anywhere, and we certainly wouldn\'t want them in the hands of our enemies.$B$BNot saying you\'re an enemy, of course... just earn the trust of Stormwind and then we can do business.',26124),
(8429,'enUS','Not so fast, $g guy : lady;... I\'ll not be handing out the reigns of a mighty ram steed to someone that\'s not a proven ally of the dwarves of Ironforge.  Once you\'ve been recognized as exalted to Ironforge, I\'ll gladly show you what varieties of rams I have for sale.','Not so fast, $g guy : lady;... I\'ll not be handing out the reigns of a mighty ram steed to someone that\'s not a proven ally of the dwarves of Ironforge.  Once you\'ve been recognized as exalted to Ironforge, I\'ll gladly show you what varieties of rams I have for sale.',26124),
(8430,'enUS','Erm... I really don\'t know you that well, sorry.  I mean, as an authorized Mechano-strider dealer, I really only can sell my mounts to those people who are considered exalted amongst the gnomes.  If you ever are recognized as exalted to Gnomeregan, I\'d be happy to show you what I have to offer.','Erm... I really don\'t know you that well, sorry.  I mean, as an authorized Mechano-strider dealer, I really only can sell my mounts to those people who are considered exalted amongst the gnomes.  If you ever are recognized as exalted to Gnomeregan, I\'d be happy to show you what I have to offer.',26124),
(8431,'enUS','You need to be exalted with the dwarves of Ironforge before I will teach you a riding skill, $c.','You need to be exalted with the dwarves of Ironforge before I will teach you a riding skill, $c.',26124),
(8432,'enUS','You need to be exalted with the Forsaken of the Undercity before I will teach you a riding skill, $c.','You need to be exalted with the Forsaken of the Undercity before I will teach you a riding skill, $c.',26124),
(8433,'enUS','You need to be exalted with the gnomes of the Gnomeregan Exiles before I will teach you how to pilot a Mechanostrider, $c.','You need to be exalted with the gnomes of the Gnomeregan Exiles before I will teach you how to pilot a Mechanostrider, $c.',26124),
(8434,'enUS','You need to be exalted with the humans of Stormwind before I will teach you a riding skill, $c.','You need to be exalted with the humans of Stormwind before I will teach you a riding skill, $c.',26124),
(8435,'enUS','You need to be exalted with the night elves of Darnassus before I will teach you a riding skill, $c.','You need to be exalted with the night elves of Darnassus before I will teach you a riding skill, $c.',26124),
(8436,'enUS','You need to be exalted with the orcs of Orgrimmar before I will teach you a riding skill, $c.','You need to be exalted with the orcs of Orgrimmar before I will teach you a riding skill, $c.',26124),
(8437,'enUS','You need to be exalted with the tauren of Thunder Bluff before I will teach you a riding skill, $c.','You need to be exalted with the tauren of Thunder Bluff before I will teach you a riding skill, $c.',26124),
(8438,'enUS','You need to be exalted with the trolls of the Darkspear tribe before I will teach you a riding skill, $c.','You need to be exalted with the trolls of the Darkspear tribe before I will teach you a riding skill, $c.',26124),
(8439,'enUS','Half way there...','',26124),
(8440,'enUS','','I do not believe you possess the mental acuity to grasp the nature of portal magic.',26124),
(8441,'enUS','','As a mage, you are one of a select group that can conjure a portal to transport you back to this very place.  I can teach you if you are ready.',26124),
(8442,'enUS','Please teach me.','Please teach me.',26124),
(8443,'enUS','','I do not believe you possess the mental acuity to grasp the nature of portal magic.',26124),
(8444,'enUS','','As a mage, you are one of a select group that can conjure a portal to transport you back to this very place.  I can teach you if you are ready.',26124),
(8445,'enUS','I do not believe you possess the mental acuity to grasp the nature of portal magic.','',26124),
(8446,'enUS','As a mage, you are one of a select group that can conjure a portal to transport you back to this very place.  I can teach you if you are ready.','',26124),
(8447,'enUS','I do not believe you possess the mental acuity to grasp the nature of portal magic.','I do not believe you possess the mental acuity to grasp the nature of portal magic.',26124),
(8448,'enUS','As a mage, you are one of a select group that can conjure a portal to transport you back to this very place.  I can teach you if you are ready.','As a mage, you are one of a select group that can conjure a portal to transport you back to this very place.  I can teach you if you are ready.',26124),
(8449,'enUS','','I do not believe you possess the mental acuity to grasp the nature of portal magic.',26124),
(8453,'enUS','','As a mage, you are one of a select group that can conjure a portal to transport you back to this very place.  I can teach you if you are ready.',26124),
(8454,'enUS','I do not believe you possess the mental acuity to grasp the nature of portal magic.','',26124),
(8455,'enUS','As a mage, you are one of a select group that can conjure a portal to transport you back to this very place.  I can teach you if you are ready.','',26124),
(8456,'enUS','I do not believe you possess the mental acuity to grasp the nature of portal magic.','',26124),
(8457,'enUS','As a mage, you are one of a select group that can conjure a portal to transport you back to this very place.  I can teach you if you are ready.','',26124),
(8458,'enUS','Overflowin\' with rats! Help a pirate out, matey!','',26124),
(8459,'enUS','Do yer part in keepin\' the Deeprun Tram clean!','',26124),
(8460,'enUS','Don\'t crowd me, people!','',26124),
(8461,'enUS','Your own strength feeds me, $n!','',26124),
(8462,'enUS','The little feller be hidin\' in one o\' them boxes, matey. G\'luck!','',26124),
(8463,'enUS','Monty be me name an\' rats be me game.','',26124),
(8464,'enUS','I\'m ready to find the squirrel, Monty.','I\'m ready to find the squirrel, Monty.',26124),
(8465,'enUS','Into the box me pretties! Thas it. One by one ye go.','',26124),
(8466,'enUS','Winner! We be havin\' a winner here!','',26124),
(8467,'enUS','The strongest hides come from those kodo that have laid themselves to rest in this wasteland.','',26124),
(8468,'enUS','Your skills have surpassed mine, young one. Go see Una who has a shop in Thunder Bluff\'s central plateau. She can give you the guidance you seek.','',26124),
(8470,'enUS','I am sorry but I can not train any more apprentices. Seek out Mak in Thunder Bluff. He will be able to teach you the basics.','',26124),
(8471,'enUS','First you must prove yourself to me, then I will train you.','',26124),
(8472,'enUS','Now you are ready to learn the finer points of kodo hide tanning. Let us begin...','',26124),
(8473,'enUS','','Between the light and the dark, there is shadow... and those shadows have powers you have yet to see.',26124),
(8474,'enUS','','Between the light and the dark, there is shadow... and those shadows have powers you have yet to see.',26124),
(8475,'enUS','You\'ll find no finer rat kabob this side of Khaz Modan!','',26124),
(8476,'enUS','I wish to make a purchase, Nipsy.','I wish to make a purchase, Nipsy.',26124),
(8477,'enUS','You look like you could use some work, $g fella:lady;. You should board the tram and visit my brother, Monty, at the Ironforge Deeprun Tram depot. I\'m sure he has something you could do.','',26124),
(8478,'enUS','Watch your back, stranger.','',26124),
(8479,'enUS','Ravenholdt Manor does not recognize you, $c.','',26124),
(8480,'enUS','Brash. Master Ravenholdt does not like brash.','',26124),
(8481,'enUS','It is good to see you again, $n.','',26124),
(8482,'enUS','Greetings, $c. Have you spoken with Fahrad yet?','',26124),
(8483,'enUS','The Syndicate is made up of a bunch of hacks - disorganized, unskilled, and lazy... ','',26124),
(8484,'enUS','You have truly grown more cunning, $n.','',26124),
(8485,'enUS','An honor to see you again, $n.','',26124),
(8486,'enUS','I believe Simone was looking for you earlier, $n. Have you spoken with her yet?','',26124),
(8487,'enUS','$G Master:Mistress; $n! Master Kang has been asking about you! Perhaps it is your time!','',26124),
(8488,'enUS','Your presence steels our nerves, $G Master:Mistress; $n.','',26124),
(8489,'enUS','Tales of your heroics are heard throughout Ravenholdt Manor, $G Master:Mistress; $n.','',26124),
(8490,'enUS','I am unworthy of this conversation, $G Master:Mistress;.','',26124),
(8491,'enUS','It is my dream to one day serve under your command, $G Master:Mistress; $n. That is, should you ever deem me worthy of such things...','',26124),
(8492,'enUS','The Manor has been abuzz with talk of your arrival, $G Master:Mistress; $n. We are all honored and graced by your presence.','',26124),
(8493,'enUS','You dare set foot inside Ravenholdt Manor, worm?','You dare set foot inside Ravenholdt Manor, worm?',26124),
(8494,'enUS','Making it out of here without a blade in your back or poison in your veins would be an accomplishment.','Making it out of here without a blade in your back or poison in your veins would be an accomplishment.',26124),
(8495,'enUS','You\'re shaping up nicely, $n. I\'ve heard good things...','You\'re shaping up nicely, $n. I\'ve heard good things...',26124),
(8496,'enUS','You should talk to Winstone. I hear he\'s looking for thieves with your skill.','You should talk to Winstone. I hear he\'s looking for thieves with your skill.',26124),
(8497,'enUS','Marvelous. Simply marvelous. You are an inspiration to us all, $n.','Marvelous. Simply marvelous. You are an inspiration to us all, $n.',26124),
(8498,'enUS','I really envy you, $n. You do amazing work.','I really envy you, $n. You do amazing work.',26124),
(8499,'enUS','Your time has come, $n. Master Kang awaits...','Your time has come, $n. Master Kang awaits...',26124),
(8500,'enUS','And to think, one day you might be the one that the stories of legend are about!','And to think, one day you might be the one that the stories of legend are about!',26124),
(8501,'enUS','I wept like a babe when I heard of your heroics. Master Ravenholdt would do well to have an apprentice like you.','I wept like a babe when I heard of your heroics. Master Ravenholdt would do well to have an apprentice like you.',26124),
(8502,'enUS','If I was not bound by duty to Master Ravenholdt, I would follow you to the ends of the world, $G Master:Mistress; $n. You are grace and cunning personified.','If I was not bound by duty to Master Ravenholdt, I would follow you to the ends of the world, $G Master:Mistress; $n. You are grace and cunning personified.',26124),
(8503,'enUS','','May Elune walk with you, $c.  The Temple of the Moon has come to help the troubled citizens of Auberdine.',26124),
(8504,'enUS','I\'m a test spirit healer.','',26124),
(8505,'enUS','Why did you kill me, $n?','',26124),
(8506,'enUS','Shoja\'my is over in front of the inn.  Now move along, I\'m busy.','Shoja\'my is over in front of the inn.  Now move along, I\'m busy.',26124),
(8507,'enUS','Pets to take care of?  Just make sure you clean up after it!  Look for Shoja\'my in front of the inn.','Pets to take care of?  Just make sure you clean up after it!  Look for Shoja\'my in front of the inn.',26124),
(8508,'enUS','Stable Master','Stable Master',26124),
(8509,'enUS','Go to the Valley of Honor and seek out Xon\'cha near the stables.','Go to the Valley of Honor and seek out Xon\'cha near the stables.',26124),
(8510,'enUS','Xon\'cha will stable your extra pets.  Find him in the Valley of Honor at the stables between the arena and the Hunter\'s Hall.  Now begone!','Xon\'cha will stable your extra pets.  Find him in the Valley of Honor at the stables between the arena and the Hunter\'s Hall.  Now begone!',26124),
(8511,'enUS','Stable Master','Stable Master',26124),
(8512,'enUS','Only a fool walks into a den of thieves unaware. That fool rarely walks out...','',26124),
(8513,'enUS','Ah yes, it is Seikwa that you must find.  I believe I saw her last standing out in front of the inn.','Ah yes, it is Seikwa that you must find.  I believe I saw her last standing out in front of the inn.',26124),
(8514,'enUS','Seikwa can take care of your animal friends when you have the need.  Seek her out in front of the inn.','Seikwa can take care of your animal friends when you have the need.  Seek her out in front of the inn.',26124),
(8515,'enUS','The stable master','The stable master',26124),
(8516,'enUS','It is the assistance of Bulrug that you need.  You will find him outside on the lower rise standing between the inn and the Thunder Bluff Bank.','It is the assistance of Bulrug that you need.  You will find him outside on the lower rise standing between the inn and the Thunder Bluff Bank.',26124),
(8517,'enUS','The concern that you show for the welfare of your animal companions is commendable.  Bulrug, on the lower rise, can help you with that.  Seek him out between the bank and the inn.','The concern that you show for the welfare of your animal companions is commendable.  Bulrug, on the lower rise, can help you with that.  Seek him out between the bank and the inn.',26124),
(8518,'enUS','Stable Master','Stable Master',26124),
(8519,'enUS','Morganus the stable master can be found out in front of the stables strangely enough.','Morganus the stable master can be found out in front of the stables strangely enough.',26124),
(8520,'enUS','Not too clever are you?  Hmm, if I were a stable master perhaps I might be in the vicinity of say, the stable?  Look for Morganus over there.','Not too clever are you?  Hmm, if I were a stable master perhaps I might be in the vicinity of say, the stable?  Look for Morganus over there.',26124),
(8521,'enUS','The stable master','The stable master',26124),
(8522,'enUS','Anya Maulray at inn on upper ring of Trade Quarter.','Anya Maulray at inn on upper ring of Trade Quarter.',26124),
(8523,'enUS','Us want lots of pets.  Anya Maulray help you take care of them.  You find her at inn, upper ring of Trade Quarter.','Us want lots of pets.  Anya Maulray help you take care of them.  You find her at inn, upper ring of Trade Quarter.',26124),
(8524,'enUS','Stable Master','Stable Master',26124),
(8525,'enUS','Stable Master','Stable Master',26124),
(8526,'enUS','You can trust any pets you have to be well taken care of by Alassin.  He resides in the Cenarion Enclave where the hunters gather.','You can trust any pets you have to be well taken care of by Alassin.  He resides in the Cenarion Enclave where the hunters gather.',26124),
(8527,'enUS','For many hundreds of years Alassin has cared for the animals that our hunters befriend.  His care of animals is highly sought for by the hunters around here.  If you seek him as well, then look for him in the Cenarion Enclave.','For many hundreds of years Alassin has cared for the animals that our hunters befriend.  His care of animals is highly sought for by the hunters around here.  If you seek him as well, then look for him in the Cenarion Enclave.',26124),
(8528,'enUS','We are all pieces of a much larger puzzle, $n. Just as you guide the piece of a puzzle to its destination, so too are we guided by another.$B$BAnd perhaps they who guide us are themselves guided by an even greater force.','',26124),
(8529,'enUS','Stable Master','Stable Master',26124),
(8530,'enUS','Ah, gentle Seriadne.  All animals are safe while in her care.  You can find her just outside the Inn in Dolanaar.','Ah, gentle Seriadne.  All animals are safe while in her care.  You can find her just outside the Inn in Dolanaar.',26124),
(8531,'enUS','You seek someone who cares for animals?  Then you should look for Seriadne outside the Inn in Dolanaar.  She is the one that you seek.','You seek someone who cares for animals?  Then you should look for Seriadne outside the Inn in Dolanaar.  She is the one that you seek.',26124),
(8532,'enUS','Good ol\' Erma, she\'s been taking care of the local animals for years now.  I\'m sure she\'d be happy to take care of any you\'d like to put up.  She can be found right outside of the Lion\'s Pride Inn.','Good ol\' Erma, she\'s been taking care of the local animals for years now.  I\'m sure she\'d be happy to take care of any you\'d like to put up.  She can be found right outside of the Lion\'s Pride Inn.',26124),
(8533,'enUS','Erma does all the caring for animals around here.  She\'s right outside the Lion\'s Pride Inn if you need to speak with her.','Erma does all the caring for animals around here.  She\'s right outside the Lion\'s Pride Inn if you need to speak with her.',26124),
(8534,'enUS','Stable Master','Stable Master',26124),
(8535,'enUS','Why did you kill me, $n?','',26124),
(8536,'enUS','Stable Master','Stable Master',26124),
(8537,'enUS','Jenova Stoneshield over in the Dwarven District is the one you\'re looking for.  She tends to hunters\' pets while they seek training from her father.','Jenova Stoneshield over in the Dwarven District is the one you\'re looking for.  She tends to hunters\' pets while they seek training from her father.',26124),
(8538,'enUS','If you need to house your pet while you\'re training another, then you should talk to Jenova Stoneshield over in the Dwarven District.','If you need to house your pet while you\'re training another, then you should talk to Jenova Stoneshield over in the Dwarven District.',26124),
(8539,'enUS','Stable Master','Stable Master',26124),
(8540,'enUS','Well $glad : lass;, ye can find Shelby Stoneflint right outside the Thunderbrew Distillery in Kharanos.  She\'ll take good care of any pets ye might have.','Well $glad : lass;, ye can find Shelby Stoneflint right outside the Thunderbrew Distillery in Kharanos.  She\'ll take good care of any pets ye might have.',26124),
(8541,'enUS','Shelby Stoneflint houses a good deal of pets for the local hunters.  She can be found over by the Thunderbrew Distillery if ye need her to look after a pet.','Shelby Stoneflint houses a good deal of pets for the local hunters.  She can be found over by the Thunderbrew Distillery if ye need her to look after a pet.',26124),
(8542,'enUS','Stable Master','Stable Master',26124),
(8543,'enUS','Taking care of animals is something that Ulbrek Firehand takes quite seriously.  He usually hangs out with the hunters at the Hall of Arms if ye want him to look after a pet or two.','Taking care of animals is something that Ulbrek Firehand takes quite seriously.  He usually hangs out with the hunters at the Hall of Arms if ye want him to look after a pet or two.',26124),
(8544,'enUS','Over in the Hall of Arms you can find our resident stable master, Ulbrek Firehand.  He\'ll make sure any pets ye have are well fed and rightly cared for.','Over in the Hall of Arms you can find our resident stable master, Ulbrek Firehand.  He\'ll make sure any pets ye have are well fed and rightly cared for.',26124),
(8545,'enUS','You think you\'ve won already? Perhaps you\'ll need another lesson in pain!','',26124),
(8546,'enUS','Help! Guards! It\'s going to step on me!','Help! Guards! It\'s going to step on me!',26124),
(8547,'enUS','I got something for you, $n. Looks important.','I got something for you, $n. Looks important.',26124),
(8548,'enUS','May I have it, please.','May I have it, please.',26124),
(8549,'enUS','Welcome to SI:7 headquarters, $n.','',26124),
(8550,'enUS','$n, this came for you this morning.','',26124),
(8551,'enUS','Messengers from Ravenholdt delivered this letter to me this morning. It is addressed to you, $n.','Messengers from Ravenholdt delivered this letter to me this morning. It is addressed to you, $n.',26124),
(8552,'enUS','Take heart!  Pain goes away and $gladies love men with scars:men love women with scars;!','Take heart!  Pain goes away and $gladies love men with scars:men love women with scars;!',26124),
(8553,'enUS','I require aid.','I require aid.',26124),
(8554,'enUS','Show strength to your enemy, and we will prevail!','Show strength to your enemy, and we will prevail!',26124),
(8555,'enUS','This will be a tough fight, $n. Follow me closely!','',26124),
(8556,'enUS','This is the brazier, $n. Put it out. Vorsha is a beast, worthy of praise from no one!','',26124),
(8557,'enUS','Bah, it\'s not here.  I wonder where I left it last...','',26124),
(8558,'enUS','You have my deepest gratitude. I thank you.','',26124),
(8559,'enUS','Now where did I put that companion document?','',26124),
(8560,'enUS','Quite the riveting tale.  Now I know why there was so much dust on that book.','',26124),
(8561,'enUS','So many bookshelves, so little time...','',26124),
(8562,'enUS','I should talk to Dewey about some sort of notation system to keep these books better organized.','',26124),
(8563,'enUS','A book by a goblin on gnomish military victories... and all the pages are blank.  Figures.','',26124),
(8564,'enUS','I am going to patrol the area for a while longer and ensure that things are truly safe.','',26124),
(8565,'enUS','Please return to Zoram\'gar and report our success to the Warsong Runner.','',26124),
(8566,'enUS','Are you sure that you are ready? If we do not have a group of your allies to aid us, we will surely fail.','',26124),
(8567,'enUS','I sense that the great beast draws near...','',26124),
(8568,'enUS','Look, just at the water\'s surface!','',26124),
(8569,'enUS','We have done it!','',26124),
(8570,'enUS','','You seek to lure me from my clutch? You shall pay for your insolence!',26124),
(8571,'enUS','Yes, $c? Are you reporting in?','',26124),
(8572,'enUS','COME FORTH, MY SERVANTS! DEFEND YOUR MASTER!','',26124),
(8573,'enUS','YOU CANNOT DEFEAT THE LIVING FLAME! COME YOU MINIONS OF FIRE! COME FORTH, YOU CREATURES OF HATE! YOUR MASTER CALLS!','',26124),
(8574,'enUS','Crush them!!!','',26124),
(8575,'enUS','RUN THEM THROUGH, SOLDIERS!','',26124),
(8576,'enUS','Push them back to their base! Let not a single Alliance soldier remain living on this battlefield!','',26124),
(8577,'enUS','Rally around your Lieutenants and Commanders! Protect our bases!','',26124),
(8578,'enUS','Major Domo Enabled.','',26124),
(8579,'enUS','Who controls the Coldtooth Mine?','Who controls the Coldtooth Mine?',26124),
(8580,'enUS','The Coldtooth Mine is owned by the Kobolds.','',26124),
(8581,'enUS','The Coldtooth Mine is owned by the Alliance.','',26124),
(8582,'enUS','The Coldtooth Mine is owned by the Horde.','',26124),
(8583,'enUS','The Coldtooth Mine lies in Horde territory, in the mountains north of the Frostwolf Graveyard.$B$BIt is controlled by the Alliance.','',26124),
(8584,'enUS','The Coldtooth Mine lies in Horde territory, in the mountains north of the Frostwolf Graveyard.$B$BIt is controlled by the Horde.','',26124),
(8585,'enUS','The Coldtooth Mine lies in Horde territory, in the mountains north of the Frostwolf Graveyard.$B$BIt is controlled by the Kobolds.','',26124),
(8586,'enUS','Who controls the Irondeep Mine?','Who controls the Irondeep Mine?',26124),
(8587,'enUS','The Irondeep Mine is in Alliance territory, north of the Stormpike Graveyard.$B$BIt is controlled by the Alliance.','',26124),
(8588,'enUS','The Irondeep Mine is in Alliance territory, north of the Stormpike Graveyard.$B$BIt is controlled by the Horde.','',26124),
(8589,'enUS','The Irondeep Mine is in Alliance territory, north of the Stormpike Graveyard.$B$BIt is controlled by the Troggs.','',26124),
(8590,'enUS','This monument is dedicated to all those who have fallen in the protection of Stormwind. Our people have weathered unbelievable hardships to retain their freedoms and to control their own destinies. It is here we remember every sacrifice our citizens have made during the first war that riddled our people.','',26124),
(8591,'enUS','The Irondeep Mine is owned by the Alliance.','',26124),
(8592,'enUS','The Irondeep Mine is owned by the Horde.','',26124),
(8593,'enUS','The Irondeep Mine is owned by the Troggs.','',26124),
(8594,'enUS','The Alliance has taken Coldtooth Mine!  Its supplies will now be used for reinforcements!','',26124),
(8595,'enUS','The Alliance has taken the Irondeep Mine!  Its supplies will now be used for reinforcements!','',26124),
(8596,'enUS','The Horde has taken the Coldtooth Mine!  Its supplies will now be used for reinforcements!','',26124),
(8597,'enUS','The Horde has taken the Irondeep Mine!  Its supplies will now be used for reinforcements!','',26124),
(8599,'enUS','The troggs are retaking the Irondeep Mine!','',26124),
(8600,'enUS','The kobolds are retaking the Coldtooth Mine!','',26124),
(8601,'enUS','In Alterac Valley, battles rage and equipment is in short supply.','',26124),
(8602,'enUS','I\'ve reached my supply needs for now.','',26124),
(8603,'enUS','Hook me up!','Hook me up!',26124),
(8604,'enUS','','Cover me, soldier! I have to make it back to our base and get the fleet prepped for an aerial assault!',26124),
(8605,'enUS','','WOOT! Made it!',26124),
(8606,'enUS','','There\'s no time to waste, trooper. I must get back to base immediately! Cover me!',26124),
(8607,'enUS','','Let\'s get down to business!',26124),
(8608,'enUS','Guse? Jeztor? Are they... flat spin?? Seas of Southshore??','',26124),
(8609,'enUS','I need to get back to my ride. Search and destroy imminent! Cover me! On my six! GO GO GO!','',26124),
(8610,'enUS','I come for you, puny Alliance!','',26124),
(8611,'enUS','Good work, soldier. Now we light the fires and spite their ire!','',26124),
(8612,'enUS','%s let\'s loose a menacing hoot.','',26124),
(8613,'enUS','','Soldiers of Frostwolf, come to my aid! The time has come to unleash the fury of the elements upon them!',26124),
(8614,'enUS','I\'ve reached my supply needs for now.','',26124),
(8615,'enUS','This expedition is a terrible drain on military supplies.','',26124),
(8616,'enUS','WHO DARES SUMMON LOKHOLAR?','',26124),
(8617,'enUS','The blood of a thousand Alliance soldiers I shall spill... None shall stand against the might of the Ice Lord!','',26124),
(8618,'enUS','I drink in your suffering, mortal. Let your essence congeal with Lokholar!','',26124),
(8619,'enUS','%s\'s death wail has stirred the nearby silithid hive!','',26124),
(8620,'enUS','','%s\'s death wail has stirred the nearby silithid hive!',26124),
(8621,'enUS','','The blood of our enemies shall be spilt upon the battlefield. The great elementals shall answer our call and crush all that stand in our way.',26124),
(8622,'enUS','','%s cackles.',26124),
(8623,'enUS','','The Ice Lord will consume the entire Stormpike army!',26124),
(8624,'enUS','Answer cannot be seen through the twisting nether.','',26124),
(8625,'enUS','','Watch as the blood seeps into the snow, children. The elemental will be bound to us!',26124),
(8626,'enUS','','It is done! The Ice Lord has arrived! Bow to the might of the Horde, fools!',26124),
(8627,'enUS','Forget about it!','',26124),
(8628,'enUS','It is not worth answering.','',26124),
(8629,'enUS','Is that some kind of a joke?','',26124),
(8630,'enUS','Do not summon me again unless you have a real question to ask, ok?','',26124),
(8631,'enUS','%s is enraged!','',26124),
(8632,'enUS','','Channel your energies into the Altar!',26124),
(8633,'enUS','It\'s just so horrible. Our three top guns were shot down over Alliance territory during an air assault Nobody knows if they\'re dead or alive!$B$BThis is a terrible blow to our air strike capabilities.','',26124),
(8634,'enUS','I need a ride out of here, Martin.','I need a ride out of here, Martin.',26124),
(8635,'enUS','','Good work, soldier. I need to get back to base camp! Will you cover me?',26124),
(8636,'enUS','I got your back, Guse.','I got your back, Guse.',26124),
(8637,'enUS','','About damn time someone came. What took you so long? Ah, nevermind. Cover me, soldier. I gotta make it back to base!',26124),
(8638,'enUS','You can count on me, Jeztor.','You can count on me, Jeztor.',26124),
(8639,'enUS','','You do not belong in these gardens.  Your body shall nourish our lovely creations!',26124),
(8640,'enUS','','Nothing must befoul the gardens! You must be destroyed!',26124),
(8641,'enUS','How much more blood is needed, Commander?','How much more blood is needed, Commander?',26124),
(8642,'enUS','','There is much work left to be done, $n! Continue to strike down our enemies!',26124),
(8643,'enUS','We must be close, Commander. I can feel the elements stirring.','We must be close, Commander. I can feel the elements stirring.',26124),
(8644,'enUS','','Yes, $n. The elements are stirring. Soon, we will unleash their might upon our enemies. They shall reel from the blows!',26124),
(8645,'enUS','I sense a great power among us, Commander. Is the spell ready?','I sense a great power among us, Commander. Is the spell ready?',26124),
(8646,'enUS','','I have made contact, $n. It is Lokholar the Ice Lord. He has deemed our cause worthy - our earth bound sacrifice sufficient. He comes soon... prepare yourself.',26124),
(8647,'enUS','I need a few good wing men to get me out of here safely and back to base.','',26124),
(8648,'enUS','I will be your wingman!','I will be your wingman!',26124),
(8649,'enUS','Leave this sacred place or perish!','',26124),
(8650,'enUS','For the Legion! For Kil\'Jaeden!','',26124),
(8651,'enUS','Kazzak is supreme!','',26124),
(8652,'enUS','Holds mistletoe over $g his : her; head','Holds mistletoe over $g his : her; head',26124),
(8653,'enUS','The pages of the journal seem to be filled with information about trades, buyers  and other miscellaneous business related events.','',26124),
(8654,'enUS','','Never look the Commander directly in the eyes.',26124),
(8655,'enUS','','We are under direct orders from Cairne, $r. Do not interfere with the Commander\'s task.',26124),
(8656,'enUS','','The Shaman Commander is not to be trifled with, $r.',26124),
(8657,'enUS','','Soon, Lokholar shall rise... Soon... Very, very soon...',26124),
(8658,'enUS','You continue to thumb through the journal looking for any information that might help in your search for the stolen chest.$B$BTowards the final pages of the book, in red pencil, you see a notation from James along the side of the page. It says, \"Old home near Stone Cairn Lake... gnolls will work perfectly as bodyguards.\"$B$BThere is no reason to suggest this is where the chest is, but there doesn\'t seem to be any other clues.','',26124),
(8659,'enUS','','The fleet is ready, $n. You must take this beacon and place it at the eastern crater of the central battlezone. Defend the beacon from attackers until the fleet is able to lock on to its coordinates!',26124),
(8660,'enUS','** CONFIRMS TARGET LOCK. WAR RIDER UNIT INCOMING.  AERIAL ASSAULT IMMINENT. **','',26124),
(8661,'enUS','** PLANTED. CONFIRMING WAR RIDER LOCK. STAND BY. T-MINUS 60 SECONDS. **','',26124),
(8662,'enUS','** SERVOS DESTROYED. UNIT TARGETTING CORRUPT. SHUT DOWN IMMINENT. **','',26124),
(8663,'enUS','%s lets loose a shrill cry.','',26124),
(8664,'enUS','I am Hydraxis, Duke of the Waterlords.  You are not an elemental and so cannot understand our struggle, but perhaps we can strike a deal that will benefit us both...','',26124),
(8665,'enUS','$n, it is good to see you.  Our war with the other elemental lords yet rages, but your efforts help ensure our victory.','',26124),
(8666,'enUS','I require a vial of aqual quintessence, Hydraxis, for I go to the Molten Core to extinguish a rune of the Firelords.','I require a vial of aqual quintessence, Hydraxis, for I go to the Molten Core to extinguish a rune of the Firelords.',26124),
(8667,'enUS','I\'ll get that beacon to the crater safely, Guse. You can count on me!','I\'ll get that beacon to the crater safely, Guse. You can count on me!',26124),
(8668,'enUS','','The fleet is ready, $n. You must take this beacon and place it at the western crater of the central battlezone. Defend the beacon from attackers until the fleet is able to lock on to its coordinates!',26124),
(8669,'enUS','Consider it done, Jeztor. Give me a beacon.','Consider it done, Jeztor. Give me a beacon.',26124),
(8670,'enUS','The time has come to prove your worth as a wing man, $n. Take this beacon and plant it dead center of the Snowfall graveyard. Defend it until my fleet arrives.$B$B<Mulverick salutes.>','',26124),
(8671,'enUS','I\'m ready to plant the beacon, Mulv. Give me a beacon.','I\'m ready to plant the beacon, Mulv. Give me a beacon.',26124),
(8672,'enUS','Yeee hawww! Mulverick\'s fleet is ready to rock. All able bodied Horde soldiers need request a beacon and try their damndest to plant it so that my War Riders can home in for the aerial assault.','',26124),
(8673,'enUS','','War Riders are now ready! Soldiers of the Horde, I need your assistance.',26124),
(8674,'enUS','','Jeztor\'s Riders are ready! Soldiers of the Horde, report for duty!',26124),
(8675,'enUS','%s springs forth to defend its hive!','',26124),
(8676,'enUS','%s springs forth to defend its hive!','',26124),
(8677,'enUS','The Earth Mother watch over us; under cover of the night as in the day. Let this fire illuminate both our bodies and spirits and remind us of our honored ancestors, who are ever present and guiding our way.\n','',26124),
(8678,'enUS','I wish to learn my leatherworking focus.','I wish to learn my leatherworking focus.',26124),
(8679,'enUS','Show these savages no mercy, soldiers! They\'ll give none to you!','',26124),
(8680,'enUS','Withdraw your troops, brother, and I promise you a swift second death!','',26124),
(8681,'enUS','Rally around your Lieutenants and Commanders, soldiers! Keep the savages at bay!','',26124),
(8682,'enUS','Show our enemies your resolve, soldiers! Crush them underfoot! Under steel!','',26124),
(8683,'enUS','FER THE KING! Push \'em back, soldiers!','',26124),
(8684,'enUS','Surrender an\' we\'ll let ye live, heathens! Jus\' put down yer arms an\' march!','',26124),
(8685,'enUS','Sending ground assaults takes huge amounts of supplies!','',26124),
(8686,'enUS','$n, what are you waiting for?  Find Field Marshal Teravaine in the Field of Strife and give him the assault orders.  Once he gets the orders, he and his troops will charge into the Horde and take no prisoners!','$n, what are you waiting for?  Find Field Marshal in the Field of Strife and give him the assault orders.  Once he gets the orders, he and his troops will charge into the Horde and take no prisoners!',26124),
(8687,'enUS','Give me the orders!  I will deliver them to Teravaine in the Field of Strife!','Give me the orders!  I will deliver them to Teravaine in the Field of Strife!',26124),
(8688,'enUS','The Eye sees all within its sphere of influence, $c. What is it that you wish to see?','',26124),
(8689,'enUS','The orders are given!  Move out, and show them what we\'re made of!','The orders are given!  Move out, and show them what we\'re made of!',26124),
(8691,'enUS','Thank you, $n.  I\'ll mobilize my people right now!','Thank you, $n.  I\'ll mobilize my people right now!',26124),
(8692,'enUS','I wish to see my enemies, Ryson. Show them to me.','I wish to see my enemies, Ryson. Show them to me.',26124),
(8693,'enUS','Take it! Return to me should the Eye\'s power falter.','',26124),
(8694,'enUS','If you\'re looking for information that the Cenarion Circle might have archived somewhere, then I\'m the one to talk to.  Then again, you need to know what information you\'re looking for first before I can really help you.$B$BSee how that works?  Brilliant!','',26124),
(8695,'enUS','Don\'t listen to the hearts of the world - the answer lies within.  You know the truth.','',26124),
(8696,'enUS','The past lives in these wastes, $c.  We must be careful to not awaken it.','',26124),
(8697,'enUS','The power of the Eye is unquestionable, Ryson, but what else can it do?','The power of the Eye is unquestionable, Ryson, but what else can it do?',26124),
(8698,'enUS','The power of the Eye is unquestionable, Ryson, but what else can it do?','The power of the Eye is unquestionable, Ryson, but what else can it do?',26124),
(8699,'enUS','You have only just begun to see the Eye\'s power, $c. If you wish to facilitate the abilities of the Eye, then there is a task that you must complete.','',26124),
(8700,'enUS','What is this task?','What is this task?',26124),
(8701,'enUS','Take this beacon and advance upon the enemy\'s base. Make your way to the outside of their main stronghold and place the beacon in the center of the courtyard. Defend the beacon from attackers until the Eye has locked on the beacon\'s coordinates.$B$BOnce this is done, all activity outside the enemy\'s base will be viewable from here.$B$BWill you take on this task?','',26124),
(8702,'enUS','Absolutely. Give me a beacon, Ryson.','Absolutely. Give me a beacon, Ryson.',26124),
(8703,'enUS','$n, you are ready for the ultimate task.  The fiery runes etched on the floor of the molten core are conduits to the realm of fire, and their presence is both an affront to us and a source of power for the Firelords.  They must be extinguished!$B$BTo extinguish a rune, take a vial of aqual quintessence.  Pour it on the rune and its flame will go out, rendering it useless and weakening our enemy!','',26124),
(8704,'enUS','Welcome to the Undercity Guild Registry. What do you want?','',26124),
(8705,'enUS','Welcome to the Cenarion Circle, $c.  How may I assist you?','Welcome to the Cenarion Circle, $c.  How may I assist you?',26124),
(8706,'enUS','I need a Scrying Scope to view the Globe of Scrying, Ryson.','I need a Scrying Scope to view the Globe of Scrying, Ryson.',26124),
(8707,'enUS','Speak with Hydraxis.','',26124),
(8708,'enUS','You have no business with me, little one.','',26124),
(8709,'enUS','Speak not your vulgar language to me!  Only Hydraxis can stand it.','',26124),
(8710,'enUS','Greetings, little one.  You have business with the Waterlords?','',26124),
(8711,'enUS','Tales of your exploits spread.  Your name is not unknown to us, $n.','',26124),
(8712,'enUS','You have made our enemies your own.  I will gladly share waters with you.','',26124),
(8713,'enUS','Perhaps you will tell me of your deeds, $n.  I would be honored to know them.','',26124),
(8714,'enUS','Our lord Hydraxis speaks highly of you.  My water is your water, friend.','',26124),
(8715,'enUS','When you next go to the Molten Core, kill a Firelord for me, will you?','',26124),
(8716,'enUS','I don\'t think you want to learn anything I can teach. Might want to find a $c trainer to help you out.','I don\'t think you want to learn anything I can teach. Might want to find a $c trainer to help you out.',26124),
(8717,'enUS','You look like the type I should watch my coin purse around. Something I can help you with?','You look like the type I should watch my coin purse around. Something I can help you with?',26124),
(8718,'enUS','Upgrade to seasoned units!','Upgrade to seasoned units!',26124),
(8719,'enUS','Upgrade to veteran units!','Upgrade to veteran units!',26124),
(8720,'enUS','I see that you have found the eye.$B$B<Master Ryson grins.>$B$BWell, give it to me!','',26124),
(8721,'enUS','Take it! This thing is probably more trouble than its worth.','Take it! This thing is probably more trouble than its worth.',26124),
(8722,'enUS','The All Seeing Eye must be recovered!','',26124),
(8723,'enUS','Upgrade to champion units!','Upgrade to champion units!',26124),
(8724,'enUS','Lets get back to your base!','',26124),
(8725,'enUS','I am greatly indebted to you, $c. Perhaps I can help your cause.','',26124),
(8726,'enUS','I was searching for materials to build my latest and greatest invention, the portable remote control shredder unit, when these trolls clubbed me and dragged me into the depths of their cave.$B$BReturn me to safety and I will lend my aid to your cause, $r.','',26124),
(8727,'enUS','Let\'s go, goblin!','Let\'s go, goblin!',26124),
(8728,'enUS','Upgrade to seasoned units!','Upgrade to seasoned units!',26124),
(8729,'enUS','Upgrade to veteran units!','Upgrade to veteran units!',26124),
(8730,'enUS','Upgrade to champion units!','Upgrade to champion units!',26124),
(8731,'enUS','','This land is tainted. Ivus must be called!',26124),
(8732,'enUS','','Stormpike soldiers, aid and protect us! The Forest Lord has granted us his protection. The gateway must now be opened!',26124),
(8733,'enUS','','Come, brothers.',26124),
(8734,'enUS','','Onward!',26124),
(8735,'enUS','','We must focus our thoughts upon the Circle of Calling if the Forest Lord is to come! We must hurry! Concentrate your energies!',26124),
(8736,'enUS','Wicked, wicked, mortals! The forest weeps. The elements recoil at the destruction. Ivus must purge you from this world!','',26124),
(8737,'enUS','I come to raze your bases, Frost Wolf clan. Ivus punishes you for your treachery!','',26124),
(8738,'enUS','Ancients, rise!','',26124),
(8739,'enUS','Your base is forfeit, mortals! From its ashes shall rise life!','',26124),
(8740,'enUS','Your base is forfeit, puny mortals!','',26124),
(8741,'enUS','Our seasoned units are leaving the field.  We need more supplies!','',26124),
(8742,'enUS','Our veteran units are leaving the field.  We need more supplies!','',26124),
(8743,'enUS','Our champion units are leaving the field.  We need more supplies!','',26124),
(8744,'enUS','Seasoned units are entering the battle!','',26124),
(8745,'enUS','Veteran units are entering the battle!','',26124),
(8746,'enUS','Champion units are entering the battle!','',26124),
(8747,'enUS','We have been sent here from Darnassus to aid the Stormpike in their time of need.','',26124),
(8748,'enUS','The Archdruid believes that Ivus the Forest Lord will come once he is made aware of the destructive forces within this valley.','',26124),
(8749,'enUS','It is not for us to judge these atrocities. Ivus will pass judgment once he arrives.','',26124),
(8750,'enUS','','My faith guides my actions, $r. I know that Ivus will come.',26124),
(8751,'enUS','Our seasoned units are leaving the field.  We need more supplies!','',26124),
(8752,'enUS','Our veterans are leaving the field.  We need more supplies!','',26124),
(8753,'enUS','Our champion units are leaving the field.  We need more supplies!','',26124),
(8754,'enUS','Seasoned units are taking to the field!','',26124),
(8755,'enUS','Our veterans are entering the field!','',26124),
(8756,'enUS','Our champion units are equipped!  Beware, alliance!','',26124),
(8757,'enUS','Have you made contact with Ivus, Archdruid?','Have you made contact with Ivus, Archdruid?',26124),
(8758,'enUS','','I have been lost in the Dream. I sense his lifeforce but my powers have not yet grown strong enough to make contact.',26124),
(8759,'enUS','The air is abuzz with energy, Archdruid. What is the status of the Forest Lord?','The air is abuzz with energy, Archdruid. What is the status of the Forest Lord?',26124),
(8760,'enUS','','Yes. $n. I have located the Forest Lord. We must redouble our efforts! More crystals are needed!',26124),
(8761,'enUS','The forest shakes and shudders! The winds howl! Does the Forest Lord approach?','The forest shakes and shudders! The winds howl! Does the Forest Lord approach?',26124),
(8762,'enUS','','The Forest Lord is aware of the destruction in this valley, $n. Soon we must make our way to the Circle of Calling. Prepare yourself!',26124),
(8763,'enUS','I was shot down by that reckless fool, Mulverick. I fear that if I do not make it back to base, all will be lost! Mulverick and his squad of War Riders must be stopped!','',26124),
(8764,'enUS','I got your back, Ichman. GO GO GO!','I got your back, Ichman. GO GO GO!',26124),
(8765,'enUS','I can\'t believe it... I was doing a routine recon mission over the central DMZ when all hell broke loose. I saw the Horde Wing Commander, Mulverick, take out both Ichman and Slidore! Anger took hold of me and I broke from my wing man and drove that show-off, Mulverick, down. Unfortunately, he clipped my gryphon before he crashed, forcing me down as well. I ended up captured by these savages.$B$BI have to get back to base! Help!','',26124),
(8766,'enUS','I got you covered, Vipore. Move out!','I got you covered, Vipore. Move out!',26124),
(8767,'enUS','I heard their mocking laughter as my gryphon crashed and burned, $c.$B$B\"Slidore, you stink!\" They shouted.$B$BNobody talks to Slidore that way! Help me get out of here so that I can show them who the real stinker is!','',26124),
(8768,'enUS','I got your back, Slidore, but to be honest, you do stink. Take a shower, man.','I got your back, Slidore, but to be honest, you do stink. Take a shower, man.',26124),
(8769,'enUS','Cover me, I\'m making a break for it!','',26124),
(8770,'enUS','We\'ve got no time to waste. This is a really long run! Cover me!','',26124),
(8771,'enUS','Just get me close enough to our base and I can channel a teleport!','',26124),
(8772,'enUS','This is far enough! Meet me back at base!','',26124),
(8773,'enUS','You\'re going down, Mulv!','',26124),
(8774,'enUS','','I have orders here for an attack on alliance forces in the middle fields.  I need someone to get them to the assault leader.',26124),
(8775,'enUS','','It\'s a cold, bloody battle we wage in Alterac Valley.  It\'s perfect.',26124),
(8776,'enUS','Yes, I will deliver the orders to Warmaster Garrick!','Yes, I will deliver the orders to Warmaster Garrick!',26124),
(8777,'enUS','','This forest can be confusing! Be careful out there.',26124),
(8778,'enUS','Season\'s savings to you and yours!','Season\'s savings to you and yours!',26124),
(8779,'enUS','Fresh from our farm to your plate - it\'s Smokywood Pastures wholesome goodness!','Fresh from our farm to your plate - it\'s Smokywood Pastures wholesome goodness!',26124),
(8780,'enUS','\'Tis the season for great bargains!  Fah la la la la!','\'Tis the season for great bargains!  Fah la la la la!',26124),
(8781,'enUS','Have a wondrous Feast of Winter Veil!  Start it off right with treats from Smokywood Pastures!','Have a wondrous Feast of Winter Veil!  Start it off right with treats from Smokywood Pastures!',26124),
(8782,'enUS','Be sure to tell Greatfather Winter what secret surprise you\'d like to get this Winter Veil!','Be sure to tell Greatfather Winter what secret surprise you\'d like to get this Winter Veil!',26124),
(8783,'enUS','Don\'t let the jingle of the bells take away from the jingle in your pocket!  Buy Smokywood Pastures treats for your Winter Veil festivities!','Don\'t let the jingle of the bells take away from the jingle in your pocket!  Buy Smokywood Pastures treats for your Winter Veil festivities!',26124),
(8784,'enUS','If I had some chestnuts, you\'d better believe I\'d have them roasting over an open fire.  Mmmm!','If I had some chestnuts, you\'d better believe I\'d have them roasting over an open fire.  Mmmm!',26124),
(8785,'enUS','Don\'t forget to stock up on wrapping paper this holiday season!  Nothing says \"Wondrous Winter Veil\" like wrapped armors and weapons for your friends and family.','Don\'t forget to stock up on wrapping paper this holiday season!  Nothing says \"Wondrous Winter Veil\" like wrapped armors and weapons for your friends and family.',26124),
(8786,'enUS','Let me browse your seasonal fare.','Let me browse your seasonal fare.',26124),
(8787,'enUS','Double time!','',26124),
(8788,'enUS','%s arming. T-minus 60 seconds.','',26124),
(8789,'enUS','%s armed. Aerie Gryphon en route.','',26124),
(8790,'enUS','%s is destroyed. Aerial assault unable to confirm strike point. Mission aborted.','',26124),
(8791,'enUS','Soldiers of Stormpike, come to my aid! The beacon must be planted.','',26124),
(8792,'enUS','Pay attention, soldier! You need to take this beacon to the Snowfall graveyard and plant it! Protect it long enough so that my gryphon can lock on.$B$BIf my gryphon gets a solid strike location, Mulv and his crew will be humiliated!','',26124),
(8793,'enUS','I\'m your man, Ich. Give me a beacon!','I\'m your man, Ich. Give me a beacon!',26124),
(8794,'enUS','My flight is ready! Soldiers come to my aid!','',26124),
(8795,'enUS','$n! Finally!$B$BYou must take this beacon and plant it in the eastern crater of the central battle grounds. My flight will attack when the beacon beams its coordinates!','',26124),
(8796,'enUS','Give me the beacon, Slidore! Also, you still stink!','Give me the beacon, Slidore! Also, you still stink!',26124),
(8797,'enUS','Their spirits are restored! The gryphons are ready to strike! Come, soldiers! Come to my side!','',26124),
(8798,'enUS','The gryphons are ready to strike, $n! You must take this beacon and plant it in the western crater of the central battlegrounds.$B$BDo this and the battle is ours!','',26124),
(8799,'enUS','I am ready to rock, Vipore! Give me a beacon.','I am ready to rock, Vipore! Give me a beacon.',26124),
(8800,'enUS','We now hold the wisdom of the Winterax, $n. This power can be yours for a short time should you so desire.','',26124),
(8801,'enUS','Grant me the wisdom of Winterax!','Grant me the wisdom of Winterax!',26124),
(8802,'enUS','Our units are not upgraded, and I don\'t have enough supplies to upgrade them.','',26124),
(8803,'enUS','Our units are upgraded to Seasoned, but I don\'t have enough supplies to upgrade them to Veteran.','',26124),
(8804,'enUS','Our units are upgraded to Veteran, but I don\'t have enough supplies to upgrade them to Champion.','',26124),
(8805,'enUS','I have enough supplies to upgrade  our troops to seasoned.','',26124),
(8806,'enUS','I have enough supplies to upgrade our troops to veterans.','',26124),
(8807,'enUS','I have enough supplies to upgrade our troops to champions.','',26124),
(8808,'enUS','Our units are upgraded to Champions, but I can still collect more supplies.','',26124),
(8809,'enUS','I cannot store any more supplies.  I have all I can handle!','',26124),
(8810,'enUS','Here to learn how to wield a new weapon, or just to waste my time?','',26124),
(8811,'enUS','I\'d like some weapon training','I\'d like some weapon training',26124),
(8812,'enUS','What can other weapon masters teach?','What can other weapon masters teach?',26124),
(8813,'enUS','Tell me what weapon you want to learn or go away.','',26124),
(8814,'enUS','Who controls the Stormpike Graveyard?','Who controls the Stormpike Graveyard?',26124),
(8817,'enUS','The Stormpike Graveyard is cut into the mountains, across the bridge east of Dun Baldar.$B$BThe Alliance currently controls it.','',26124),
(8818,'enUS','The Stormpike Graveyard is cut into the mountains, across the bridge east of Dun Baldar.$B$BThe Horde currently controls it.','',26124),
(8820,'enUS','Who controls the Snowfall Graveyard?','Who controls the Snowfall Graveyard?',26124),
(8821,'enUS','The Snowfall Graveyard lies high atop a hill in the Field of Strife, east of Winterax Hold.$B$BThe Alliance currently controls it.','',26124),
(8823,'enUS','The Snowfall Graveyard lies high atop a hill in the Field of Strife, east of Winterax Hold.$B$BThe Horde currently controls it.','',26124),
(8824,'enUS','Who controls the Frostwolf Graveyard?','Who controls the Frostwolf Graveyard?',26124),
(8825,'enUS','The Frostwolf Graveyard is along the side of the road, not far north of Frostwolf Village.$B$BThe Alliance currently controls it.','',26124),
(8826,'enUS','The Frostwolf Graveyard is along the side of the road, not far north of Frostwolf Village.$B$BThe Horde currently controls it.','',26124),
(8830,'enUS','The Fostwolf Graveyard is owned by the Alliance.','',26124),
(8831,'enUS','The Fostwolf Graveyard is owned by the Horde.','',26124),
(8832,'enUS','The Snowfall Graveyard is owned by the Alliance.','',26124),
(8833,'enUS','The Snowfall Graveyard is owned by the Horde.','',26124),
(8834,'enUS','A wondrous Winter Veil to you... uh... little $G boy : girl;.  Good children get special, um, discounts at any local Smokywood Pastures vendor.  Yum.','',26124),
(8835,'enUS','I have a pretty good idea what ol\' Greatfather Winter\'s gonna be doing when this shift is over.  I got a bottle of Winter Veil cheer right here in my bag, and I intend to get to the bottom of it.','',26124),
(8836,'enUS','No... you can\'t sit on my lap.','',26124),
(8837,'enUS','Yeah, sure, go ahead and tell ol\' Greatfather Winter what you\'d like for this Winter Veil.$B$BHo ho hurry up.','',26124),
(8838,'enUS','The Stormpike clan bows to no one, especially the horde!','',26124),
(8839,'enUS','Your attacks are weak!  Go practice on some rabbits and come back when you\'re stronger.','',26124),
(8840,'enUS','Is that the best you can do?','',26124),
(8841,'enUS','It\'ll take more than you rabble to bring me down!','',26124),
(8842,'enUS','We will not be swayed from our mission!','',26124),
(8843,'enUS','We, the Alliance, will prevail!','',26124),
(8844,'enUS','You cannot defeat the Frostwolf clan!','',26124),
(8845,'enUS','Your spirits are weak, and your blows are weaker!','',26124),
(8846,'enUS','Your attacks are slowed by the cold, I think!','',26124),
(8847,'enUS','If you will not leave Alterac Valley on your own, then the Frostwolves will force you out!','',26124),
(8848,'enUS','You are no match for the strength of the Horde!','',26124),
(8849,'enUS','Today, you will meet your ancestors!','',26124),
(8850,'enUS','%s\'s wings thunder in the distance.','',26124),
(8851,'enUS','Tell me about the Glowing Shard.','Tell me about the Glowing Shard.',26124),
(8852,'enUS','Mine! Mine! Mine!  Gizlock is the ruler of this domain!  You shall never reveal my presence!','',26124),
(8853,'enUS','Dun Baldar took a real beating in the last Horde attack!  We need more supplies in order to rebuild and make repairs!','',26124),
(8854,'enUS','They say an army travels on its stomach, and that\'s the truth.  For any offensive to succeed, your troops have to be well-fed and well supplied.','',26124),
(8855,'enUS','Some say that strength and bravery are most needed for an army\'s success.  And it\'s true!  But an army also needs supplies to keep itself in good shape, and it\'s my job to make sure they have what they need.','',26124),
(8857,'enUS','Frostwolf Keep is razed!  We must have supplies in order to repair and rebuild!','',26124),
(8858,'enUS','%s whimpers obediently.','',26124),
(8859,'enUS','','Greetings, soldier. Are you here to help the cause?',26124),
(8860,'enUS','','Well done, soldier. A few more and our stables will be overflowing with mounts for the cavalry to ride into combat!',26124),
(8861,'enUS','Thank you, Stable Master. Please take the animal.','Thank you, Stable Master. Please take the animal.',26124),
(8862,'enUS','Heya mon.  You come right place learn how ta wield a new weapon.','',26124),
(8863,'enUS','Ah, $n!  You\'re just the person I was hoping to see!  We have enough supplies to send a ground assault against the Horde!  Field Marshal Teravaine is waiting in the Field of Strife for orders...$B$BYou\'re a brave veteran who\'s proven himself time and again.  Do you want to deliver Teravaine the orders?','',26124),
(8864,'enUS','What you want to learn, mon?','',26124),
(8865,'enUS','$n!  What are you doing talking to me?  You should be out fighting the Horde!$B$BI have assault orders for one of our field marshals in the Field of Strife, but I need someone I can count on.$B$BPerhaps if your standing with the Stormpike militia were higher, I could count on you...','',26124),
(8866,'enUS','I would be honored to train you in the use of the weapons that I have mastered should you have the ability to learn within you.','',26124),
(8867,'enUS','$n!  Our supplies are dwindling and until we get more we can\'t launch large ground assaults into the Field of Strife!$B$BSpeak with the Stormpike Quartermaster.  He\'ll tell you what you can do to resupply our assault forces.','',26124),
(8868,'enUS','If you require more training, I would be happy to tell you who can aid you. What weapon has caught your eye?','',26124),
(8869,'enUS','Death to Stormpike!','',26124),
(8870,'enUS','Unleash the cavalry!','Unleash the cavalry!',26124),
(8871,'enUS','You have done an exceptional job, soldier! The cavalry is ready to ride on your command.','',26124),
(8872,'enUS','Awaiting orders from my superiors.','',26124),
(8873,'enUS','I suppose you are here to be trained in the use of a new weapon?  Make it fast, I\'m very busy!','',26124),
(8874,'enUS','I\'ll tell you where to go, provided you tell me what interests you.','',26124),
(8875,'enUS','I wish to stable my pet, Stable Master.','I wish to stable my pet, Stable Master.',26124),
(8876,'enUS','$n, it\'s good to see veterans like you in the field!  I\'m sorry to report that our supplies are currently too low to launch any large ground assaults against the Horde.$B$BSpeak with our quartermaster; he has supply missions available.','',26124),
(8877,'enUS','Have you come seeking training in the ways of armed combat?','',26124),
(8878,'enUS','What weapon in particular interests you?','',26124),
(8879,'enUS','','The grace with which I fight is not something I can teach you, but I can teach you the use of various weapons.',26124),
(8880,'enUS','','I can direct you to other weapon masters if you prefer. What interests you?',26124),
(8881,'enUS','Ye want to be trained in the use of a weapon, do ye?  Well don\'t stand there slack-jawed, speak up $gladdie : lassie;!','',26124),
(8882,'enUS','What weapon were ye lookin\' to learn?','',26124),
(8883,'enUS','','Well hi there!  Are you here to learn the proper technique of a new weapon?',26124),
(8884,'enUS','','Aw, don\'t want to train with me? What other weapon catches your eye?',26124),
(8885,'enUS','','We need more wolves! Come to the stables and help!',26124),
(8886,'enUS','','Well done, Horde! We have enough Frostwolves in our stables to provide mounts to all of our wolf riders!',26124),
(8887,'enUS','Wolf riders, to Frost Dagger Pass!','',26124),
(8888,'enUS','RARRRRRR!','',26124),
(8889,'enUS','Let me know when it is best to ride. You must be our eyes and ears on the battlefront.','',26124),
(8890,'enUS','The time has come, brothers. We must not let the enemy advance through Frost Dagger Pass. Some of us will surely perish, but would any of you shy away from this duty? This honor? Onward! For the Horde!','',26124),
(8891,'enUS','For the Warchief!','For the Warchief!',26124),
(8892,'enUS','Myolor, I was once an armorsmith and wish to retake the hammer once more! Teach me the way of the armorsmith.','Myolor, I was once an armorsmith and wish to retake the hammer once more! Teach me the way of the armorsmith.',26124),
(8893,'enUS','Myolor, I was once a weaponsmith and wish to retake the hammer once more! Teach me the way of the weaponsmith!','Myolor, I was once a weaponsmith and wish to retake the hammer once more! Teach me the way of the weaponsmith!',26124),
(8894,'enUS','Krathok, I was once an armorsmith and wish to retake the hammer once more! Teach me the way of the armorsmith.','Krathok, I was once an armorsmith and wish to retake the hammer once more! Teach me the way of the armorsmith.',26124),
(8895,'enUS','Krathok, I was once a weaponsmith and wish to retake the hammer once more! Teach me the way of the weaponsmith.','Krathok, I was once a weaponsmith and wish to retake the hammer once more! Teach me the way of the weaponsmith.',26124),
(8896,'enUS','Patrol Frost Dagger Pass. Let none through! Die with honor...','',26124),
(8897,'enUS','The Kolkar invaders are retreating!','',26124),
(8898,'enUS','We have gathered enough hides from the wolves. Soon, the cavalry will be ready to ride! Speak to me again when we have stabled enough rams.','',26124),
(8899,'enUS','','The stables are full again! Our cavalry is soon to ride!',26124),
(8900,'enUS','','The stable is empty! We must provide our cavalry with suitable mounts. Stormpike Stables requests your assistance!',26124),
(8901,'enUS','Death to Frostwolf!','',26124),
(8902,'enUS','We ride on your command!','',26124),
(8903,'enUS','YAW! Er, to the front lines with you!','YAW! Er, to the front lines with you!',26124),
(8904,'enUS','Awaiting orders from my superiors!','',26124),
(8905,'enUS','Ram Riders, REGULATE!','',26124),
(8906,'enUS','Lads and ladies. Today can be your greatest day, for today, you fight for the glory of Stormpike! Ride unto the field and grant your enemies no mercy! Strike the savages down and let their Warchief sort em out!','',26124),
(8907,'enUS','Patrol the front line, soldiers!','',26124),
(8908,'enUS','For the King!','For the King!',26124),
(8909,'enUS','','The indigenous rams of Alterac are vital to the functionality of our cavalry!',26124),
(8910,'enUS','','Just a few more and our stables will be overflowing with mounts. Release it into my custody, soldier. I\'ll take it from here.',26124),
(8911,'enUS','With pleasure. These things stink!','With pleasure. These things stink!',26124),
(8912,'enUS','I wish to stable my pet.','I wish to stable my pet.',26124),
(8913,'enUS','All right, Reavers!  The orders are here!  To battle!','',26124),
(8914,'enUS','I\'ll perform these with pleasure, $n!','',26124),
(8915,'enUS','%s emerges from the plant, allowing it to heal.','',26124),
(8916,'enUS','%s attacks!','',26124),
(8917,'enUS','Well met, $n. We must be brief because there is much to do.','',26124),
(8918,'enUS','May Cenarius guide you, $c.$B$BI am here in this corrupt land with my sisters on a mission of great importance to the Cenarion Circle. But only those who are powerful enough I ask speak to me about such matters--to send a lesser being would be folly.','',26124),
(8919,'enUS','','My sisters and I have come down from the Stonetalon Mountains to put to rest a tragedy from ages past. Unfortunately, we are not powerful enough to accomplish our goals on our own and now seek mortals such as yourself to aid us.$B$BIf you are powerful enough, then we have much to discuss, $c. If you are not, then, for your safety, I will leave the details of my mission out of our conversation.',26124),
(8920,'enUS','','$n, please take a look at the sample of the Vylestem vine that I took from the caverns, so that you know what to look for...',26124),
(8921,'enUS','I greet you, $r.','',26124),
(8922,'enUS','Free! Free from my bonds at last!','',26124),
(8923,'enUS','$n, please take a look at the sample of the Vylestem vine that I took from the caverns, so that you know what to look for...','',26124),
(8924,'enUS','I need no home to know I still have a place in this world, $c. The tribes will see... all of them. They fight amongst one another, and for what? Scraps left over by vultures... lands infested by the Legion... bah!$B$BThe centaur should be proud of their heritage--it is just as noble as any Night elf\'s or orc\'s--it is time we started acting like it!','',26124),
(8925,'enUS','At last, I am free of the corruption that once bound me to this place...','',26124),
(8926,'enUS','Thank you for what you have done, $n.$B$BKeep the scepter safe; may it aid you in your toil against the evils that have invaded this place...','',26124),
(8927,'enUS','How has this come to be, $n? Do you think that an item such as the Scepter of Celebras is trivial?$B$BI can help you this time, but do not be careless with this valuable item again...','',26124),
(8928,'enUS','Celebras, I lost my Scepter...','Celebras, I lost my Scepter...',26124),
(8929,'enUS','I carry both parts of the scepter.','I carry both parts of the scepter.',26124),
(8930,'enUS','My scepter... After so many years... You have recovered it! You shall truly be the savior of this place...$B$BPlease listen to me carefully, $n. The head and the rod of the scepter may only be reunited into one at the Stone of Maraudon.','',26124),
(8931,'enUS','Please show me the Stone of Maraudon.','Please show me the Stone of Maraudon.',26124),
(8932,'enUS','Please explain how the scepter works.','Please explain how the scepter works.',26124),
(8933,'enUS','Between the colors, a path.$B$BBlink across in light.$B$BFrom the water, you emerge.','',26124),
(8934,'enUS','I don\'t quite understand...','I don\'t quite understand...',26124),
(8935,'enUS','Between the orange and the purple passageways near the doors to Maraudon, you will find a third path.$B$BThe scepter you hold in your hands is the key.','',26124),
(8936,'enUS','No, really, I still don\'t understand...','No, really, I still don\'t understand...',26124),
(8937,'enUS','I grow weary...$B$BFrom here, you can see the waterfalls, $n...The scepter grants you the power to travel to this very place, should you ever desire to enter through the front gates of Maraudon again.$B$BNear the entrance to Maraudon, you will find a passage that goes down beneath the caverns. Use the scepter at the ancient ritual site to create a portal, and you will find yourself here once more.','',26124),
(8938,'enUS','Please tell me more about Maraudon.','Please tell me more about Maraudon.',26124),
(8939,'enUS','Long ago, my dryad sisters and I entered these caves to free the tortured spirit of my uncle, Zaetar. However, the corruption that had already spread through these caverns soon overcame us, and we too fell.$B$BWe were destined to wander these passages; the toxins poisoning our minds...$B$BAlthough my spirit may now be at rest, I know that I have failed in my mission. It is a great sadness I must bear...','',26124),
(8940,'enUS','Please tell me more about Zaetar.','Please tell me more about Zaetar.',26124),
(8941,'enUS','Ah, Zaetar... <Celebras looks away.>$B$BMy father, Remulos, tried to stop him...$B$BZaetar was headstrong, and when he fell for an earthen elemental princess, my father knew that their union was cursed, but Zaetar refused to listen.$B$BThe centaur are the result of his mistake. They were born misshapen and hateful; my uncle Zaetar was killed by his own kin...$B$BThe evil princess, Theradras, still guards his remains here in the crystal caverns.','',26124),
(8942,'enUS','Those goblins should be ashamed of themselves.  Bah!','',26124),
(8943,'enUS','Spending coin is NOT the reason for the Feast of Winter Veil!','',26124),
(8944,'enUS','I cannot believe those greedy goblins are allowed to hawk their wares while spoiling the spirit of this season.','',26124),
(8945,'enUS','Vile goblins... anything for a gold coin.','',26124),
(8946,'enUS','Could I have a copy of \"The Feast of Winter Veil\" to read?','Could I have a copy of \"The Feast of Winter Veil\" to read?',26124),
(8947,'enUS','Perhaps we can attempt this later. Please speak to me again if you wish to do so.','',26124),
(8948,'enUS','Together, the two parts shall become one, once again.','',26124),
(8949,'enUS','Shal myrinan ishnu daldorah...','',26124),
(8950,'enUS','Read this tome I have placed before you, and speak the words aloud.','',26124),
(8951,'enUS','%s begins to channel his energy, focusing on the stone.','',26124),
(8952,'enUS','You wish to learn of the stone? Follow me.','',26124),
(8953,'enUS','For so long I have drifted in my cursed form. You have freed me... Your hard work shall be repaid.','',26124),
(8954,'enUS','Please do as I instruct you, $n.','',26124),
(8955,'enUS','My scepter will once again become whole!','',26124),
(8956,'enUS','Welcome to the Explorers\' League.  If you need information, and it is in book form, then I might be able to help you out.','',26124),
(8957,'enUS','How can I find the two parts of your scepter?','How can I find the two parts of your scepter?',26124),
(8958,'enUS','As the toxins lurking within Maraudon seeped into my mind, I began to lose my grip on reality. Worried that it would be used for evil, my dryad sisters secretly took the scepter from me, breaking it into two parts and hiding it within the caverns.$B$BSoon they fell victim to the madness as well, and the two parts of the scepter, left unguarded, came to be in the possession of Vyletongue, himself. The satyr entrusted one part to Noxxion, an evil elemental, and the other he still has to this day.','',26124),
(8959,'enUS','Why didn\'t Lord Vyletongue unite both parts of the scepter into one?','Why didn\'t Lord Vyletongue unite both parts of the scepter into one?',26124),
(8960,'enUS','Without knowledge of the incantations required to unite the two parts, Lord Vyletongue was unable to use the scepter. However, now that I am free of the curse of Vyletongue\'s corruption, I will be able to assist you, if you\'d like to bring me the two parts -- both the head and the rod of the scepter.','',26124),
(8961,'enUS','Tell me more about the history of Remulos and Zaetar.','Tell me more about the history of Remulos and Zaetar.',26124),
(8962,'enUS','You ask of the Sons of Cenarius, Remulos and Zaetar.$B$BMy father, Remulos, was strong and beautiful, and my uncle, Zaetar, very cunning and slight of build. While they were respected quite equally, Zaetar always felt as if he could never quite compare to the glory and attention he thought Remulos had.$B$BAfter my sisters and I were born, Zaetar, blinded by jealousy, set out to outdo his brother... He was the creator of his own end. The sadness it brings me has never lessened, even as time passes...','',26124),
(8963,'enUS','Long have my spirit and remains been kept captive here within Maraudon, young $c. The time has given me nothing but ample opportunities to reflect on my mistakes and realize that my jealousy of Remulos was foolish. He attempted to warn and persuade me that my relations with Theradras would bear nothing pure--that only destruction would come from chaos. My brother was right.$B$BBut that does not mean since you have freed me, I am free of penance.','',26124),
(8964,'enUS','Please, go on.','Please, go on.',26124),
(8965,'enUS','Though exiled as a heretic, my beliefs still ring true--that alone drives me onward. But for my destiny to be complete, I need the aid of an outsider... one not of any centaur tribe.$B$BThe task requires someone to enter the holy halls of Maraudon--a temple my people protect, and only the most devout are ever allowed to enter.$B$BIf you agree to aid me, then you need only nod. I will pass you a parchment with my instructions on it. Read it over and consider my words.','',26124),
(8966,'enUS','I will aid you. Give me the instructions.','I will aid you. Give me the instructions.',26124),
(8967,'enUS','%s bows low before you.','',26124),
(8968,'enUS','Thank you, good $c.','',26124),
(8969,'enUS','Greetings, $n. I am Doctor Gregory Victor, head trauma surgeon of Horde Trauma.','',26124),
(8970,'enUS','It is good to see you again, Doctor $n. I have been following your progress and I dare say that it is time you learned some of the more advanced bandaging techniques.$B$BReturn to me from time to time, as your skill advances, and I shall teach you all that I know.','',26124),
(8971,'enUS','Teach me how to create and apply a Heavy Mageweave Bandage, Doctor.','Teach me how to create and apply a Heavy Mageweave Bandage, Doctor.',26124),
(8972,'enUS','Teach me how to create and apply a Runecloth Bandage, Doctor.\n','Teach me how to create and apply a Runecloth Bandage, Doctor.\n',26124),
(8973,'enUS','Teach me how to create and apply a Heavy Runecloth Bandage, Doctor.\n','Teach me how to create and apply a Heavy Runecloth Bandage, Doctor.\n',26124),
(8974,'enUS','Greetings, $n. I am Doctor Gustaf VanHowzen, head trauma surgeon of Alliance Trauma.','',26124),
(8975,'enUS','Great!  Let\'s keep those supplies coming, people!','',26124),
(8976,'enUS','Thanks for the supplies, $n!','',26124),
(8977,'enUS','Thanks a lot, $n!','',26124),
(8978,'enUS','We\'re making progress!  Bring more supplies to repair Dun Baldar!','',26124),
(8979,'enUS','We have enough supplies!  Our captain has retaken position in the Field of Strife!','',26124),
(8980,'enUS','Now we\'re making progress!','',26124),
(8981,'enUS','Thank you for the armor scraps, $n!','',26124),
(8982,'enUS','Our cache of equipment grows!','',26124),
(8983,'enUS','Thank you for the supplies, $n.','',26124),
(8984,'enUS','Very good.  Our supply cache grows...','',26124),
(8985,'enUS','Keep them coming!  We need more supplies in order to rebuild...','',26124),
(8986,'enUS','We can now rebuild!  For the Horde!','',26124),
(8987,'enUS','','Hail, $n!  It is good you came to see me.  We are prepared to launch a ground assuault through the Field of Strife!  Once Warmaster Garrick gets his orders, he and his reavers will cut a swath through the Alliance!$B$BDo you want to deliver those orders, $n?  Garrick is waiting in the Field of Strife...',26124),
(8988,'enUS','','Why are you here, $n?  Is there lead in your boots?$B$BYou have the assault orders - Warmaster Garrick needs them in the Field of Strife before he can make his assault!  Go!',26124),
(8989,'enUS','','It\'s good to have veterans like you in Alterac Valley, $n.  Our supplies are too low to launch a ground assault through Alterac Valley... speak with our quartermaster - he\'ll tell you how to increase our supply base.',26124),
(8990,'enUS','','Hail, $c!  Our supply level is high, and we are ready to launch a ground assault through the Field of Strife.  Perhaps if your renown was greater, I would trust you to deliver the assault orders.$B$BSo get out there and fight the Alliance!  Show me you\'re a trusted and capable member of the Horde!',26124),
(8991,'enUS','','You!  $n!  What are you doing wandering around the village like this?  There are Alliance foes in Alterac!  We must drive them out!$B$BOur supplies are too low to launch a large ground assault, so speak with our quatermaster.  He\'ll tell you how you can increase our supply base.',26124),
(8993,'enUS','','Even the bravest warrior must be well supplied if he is to face his foes with strength!',26124),
(8994,'enUS','I just gave kill credit to $n.','',26124),
(8995,'enUS','Click here to remove res effects and repair all gear','Click here to remove res effects and repair all gear',26124),
(8996,'enUS','Hi! Clear your res effects here!','',26124),
(8997,'enUS','Click here to repair your gear','Click here to repair your gear',26124),
(8998,'enUS','We have enough supplies to launch a ground assault.  If you want to send the order, and you think you qualify, then speak Sergeant Yazra Bloodsnarl.','',26124),
(8999,'enUS','We have enough supplies to launch a ground assault.  If you want to deliver those orders, and you think you qualify, then speak with Corporal Noreg Stormpike.','',26124),
(9000,'enUS','I am in charge of recruitment for the Frostwolf Clan. As a soldier of Frostwolf, it is your responsibility to check in with me as your rank among the clan rises.$B$BHonor and respect are earned on this frigid field.','',26124),
(9001,'enUS','Warmaster, I have lost my insignia. Could you supply me with a replacement?','Warmaster, I have lost my insignia. Could you supply me with a replacement?',26124),
(9002,'enUS','Hail, $r! I am Lieutenant Haggerdin, officer in charge of recruitment for the Stormpike Guard.$B$BAs you gain prestige and notoriety among the Stormpike, return to me and I shall see about upgrading your insignia. Also, should you ever lose your insignia, I am able to supply a replacement.','',26124),
(9003,'enUS','Lieutenant, I have lost my insignia. Could you please supply me with a replacement?','Lieutenant, I have lost my insignia. Could you please supply me with a replacement?',26124),
(9004,'enUS','I have found both parts of your scepter.','I have found both parts of your scepter.',26124),
(9005,'enUS','Argh, I need help here!','',26124),
(9006,'enUS','Watch out for the $n!','',26124),
(9007,'enUS','Incoming $n - look sharp, friends!','',26124),
(9008,'enUS','You\'ll rue the day you crossed me, $n.','',26124),
(9009,'enUS','Our ancestors teach us that while the individual must be strong, there is safety in numbers.  Do you wish to defend the honor of Thunder Bluff by organizing a guild?','',26124),
(9010,'enUS','Aye, you look the type to be a leader.  Here to organize a guild to fight for the Alliance?','',26124),
(9011,'enUS','I will not be lured away!','',26124),
(9012,'enUS','Shenthul, I have lost my whistle and I have no more flares. Please help!','Shenthul, I have lost my whistle and I have no more flares. Please help!',26124),
(9013,'enUS','Well met, $c. I am Rokaro.','',26124),
(9014,'enUS','Rokaro, I have lost the Drakefire Amulet. Could another be created?','Rokaro, I have lost the Drakefire Amulet. Could another be created?',26124),
(9015,'enUS','','What is it you ask of the Blue Flight?',26124),
(9016,'enUS','Haleh, I have lost the Drakefire Amulet. Could you fashion another?','Haleh, I have lost the Drakefire Amulet. Could you fashion another?',26124),
(9017,'enUS','Master Nesingwary has a big hunt ahead of him.  I find helping him prepare for a day in the jungle is much more relaxing than helping him ready for combat.  Although I do miss some of those glorious moments on the battlefield.','',26124),
(9018,'enUS','Barnil, I seem to have misplaced Chapter I.','Barnil, I seem to have misplaced Chapter I.',26124),
(9019,'enUS','Barnil, I seem to have misplaced Chapter II.','Barnil, I seem to have misplaced Chapter II.',26124),
(9020,'enUS','Barnil, I seem to have misplaced Chapter III.','Barnil, I seem to have misplaced Chapter III.',26124),
(9021,'enUS','Barnil, I seem to have misplaced Chapter IV.','Barnil, I seem to have misplaced Chapter IV.',26124),
(9022,'enUS','I see you misplaced that chapter you worked so hard to put together, $n. Well, you left it right here!','',26124),
(9023,'enUS','Kalaran, please enchant the torch.','Kalaran, please enchant the torch.',26124),
(9024,'enUS','','I know these forests as if they were a part of me... but know that there is still much to be learned from them, and much danger still hidden.',26124),
(9025,'enUS','Raene, I lost Dartol\'s Rod of Transformation.','Raene, I lost Dartol\'s Rod of Transformation.',26124),
(9026,'enUS','','Yes, I expected that you would be back. I sent Korra out earlier and she came across Dartol\'s Rod, abandoned in the forest.$B$BWe worked so hard to recover it, $n. Please take care to see that you do not handle it so carelessly in the future.',26124),
(9027,'enUS','','You have completed Teronis\' mission, and I appreciate all you have done, $n.',26124),
(9028,'enUS','','Hiya! This workshop isn\'t mine, no! But one day after I finish training I am going to be an inventor, just like my hero, Marvon Rivetseeker.$B$BYou\'ve never heard of him? Well it just so happens that he left quite some time ago to study some ancient troll ruins he kept talking about. He left in a zeppelin... not quite sure about where exactly he went...$B$BTanarasin? Tenkeris? Taneranisany?$B$B<Liv shakes her head.>$B$BNo, that\'s not it...',26124),
(9029,'enUS','','Hi there. No, Marvon sure isn\'t here, and he won\'t be back for quite some time. Actually, I am getting a little worried about him...$B$BI hope he gets back soon. A large chest arrived for him and it\'s too heavy for me to lug it inside here! I had to leave it out by the door...',26124),
(9030,'enUS','You have learned all that I am able to teach you at this time, Doctor $n. Return to me when your practice has expanded and I shall train you in the ways of the more advanced medicinal arts.','',26124),
(9031,'enUS','Run! They are coming!','Run! They are coming!',26124),
(9032,'enUS','','This place... it\'s cursed.$B$BI barely managed to escape, and I cannot bear to go down through the tunnels again.$B$BMy brother, and sisters though... They were not as fortunate. Trapped inside, they are feverish with the corrupted haze that flows from the evil garden growing there.$B$BPlease, you must help.',26124),
(9033,'enUS','','Oh, I am so glad you have returned, $n.$B$BMy brother\'s spirit has now be freed from the corruption, but I choose to remain here, in my mourning.$B$BThank you so much for your help, $n.',26124),
(9034,'enUS','Interlopers! Invaders! The All Seeing Eye has been stolen! The miserable dog, $n, has it in $g his:her; possession!','',26124),
(9036,'enUS','','Need some supplies?',26124),
(9037,'enUS','Show me what\'s for sale.','Show me what\'s for sale.',26124),
(9038,'enUS','Korrak has come, weaklings! Snowfall belongs to Winterax!','',26124),
(9039,'enUS','How many more supplies do we need?','How many more supplies do we need?',26124),
(9040,'enUS','Alterac Valley - Alliance Quatmaster Greeting Option Default','',26124),
(9041,'enUS','The Commander has been slain! Charge their lines! Die with honor!','The Commander has been slain! Charge their lines! Die with honor!',26124),
(9042,'enUS','Our Commander has fallen! The time for vengeance is now! Ram riders charge!!!!!!','Our Commander has fallen! The time for vengeance is now! Ram riders charge!!!!!!',26124),
(9044,'enUS','Commander, the time has come for the wolf riders to charge the enemy lines. Send the order.','Commander, the time has come for the wolf riders to charge the enemy lines. Send the order.',26124),
(9045,'enUS','Awaiting orders, sir. On your command, I shall unleash hell upon them!','',26124),
(9046,'enUS','The orders have been given! Death to Stormpike! Charge the enemy!','The orders have been given! Death to Stormpike! Charge the enemy!',26124),
(9047,'enUS','Commander, the time has come to charge the Frostwolf filth! Run them through!','Commander, the time has come to charge the Frostwolf filth! Run them through!',26124),
(9048,'enUS','Truffles!','',26124),
(9049,'enUS','I shall unleash the cavalry upon your command, sir!','',26124),
(9050,'enUS','Charge!!! Run \'em through!','Charge!!! Run \'em through!',26124),
(9051,'enUS','It\'s our turn to pickle your feet!','',26124),
(9052,'enUS','Time to gore...','',26124),
(9053,'enUS','Intruder!','Intruder!',26124),
(9054,'enUS','Kill it!','Kill it!',26124),
(9055,'enUS','Raaaaaaaaaaaaarrrr!','Raaaaaaaaaaaaarrrr!',26124),
(9056,'enUS','','',26124),
(9057,'enUS','The Stormpike Graveyard was taken by the Alliance!','',26124),
(9058,'enUS','The Stormpike Graveyard is under attack!  If left unchecked, the Alliance will capture it!','',26124),
(9059,'enUS','The Stormpike Graveyard was taken by the Horde!','',26124),
(9060,'enUS','The Stormpike Graveyard is under attack!  If left unchecked, the Horde will capture it!','',26124),
(9061,'enUS','The Snowfall Graveyard was taken by the Alliance!','',26124),
(9062,'enUS','The Snowfall Graveyard is under attack!  If left unchecked, the Alliance will capture it!','',26124),
(9063,'enUS','The Snowfall Graveyard was taken by the Horde!','',26124),
(9064,'enUS','The Snowfall Graveyard is under attack!  If left unchecked, the Horde will capture it!','',26124),
(9065,'enUS','The Frostwolf Graveyard was taken by the Alliance!','',26124),
(9066,'enUS','The Frostwolf Graveyard is under attack!  If left unchecked, the Alliance will capture it!','',26124),
(9067,'enUS','The Frostwolf Graveyard was taken by the Horde!','',26124),
(9068,'enUS','The Frostwolf Graveyard is under attack!  If left unchecked, the Horde will capture it!','',26124),
(9069,'enUS','You have come to learn in the art of warfare, $r? You have come to the wrong place.','',26124),
(9070,'enUS','You have come to learn of battles won and lost on this field? There are no winners here...','',26124),
(9071,'enUS','Come, little ones. Face me!','',26124),
(9072,'enUS','This place is under my protection. The mysteries of the arcane shall remain inviolate.','',26124),
(9073,'enUS','Such is the price of curiosity.','',26124),
(9074,'enUS','Greetings, soldier. Intelligence has reported that the Winterax trolls to the west have taken a master goblin engineer prisoner. Perhaps you should investigate?','',26124),
(9075,'enUS','My scouts report that the Syndicate has taken up residence in a hidden cave on the eastern plateau. Be cautious when adventuring in that area.','',26124),
(9076,'enUS','Watch your step, soldier. The Stormpike have littered the ground around their bases with landmines. Speak with our explosives expert in the watch tower to the east if you want information on how to diffuse their mine fields.','',26124),
(9077,'enUS','Look alive, soldier! Stormpike Intelligence has reported that a master goblin engineer has been taken prisoner by the Winterax trolls. The Frostwolf dogs are actively trying to rescue him so that they may use his engineered gadgets to destroy us! Do not let that happen.','',26124),
(9078,'enUS','The Syndicate have been reported to be nosing around in a cave on the eastern plateau. Find out what they\'re up to, soldier! Beware of Frostwolf activity!','',26124),
(9079,'enUS','Beware of entering Frostwolf territory, soldier. The whole damn place is booby trapped! Landmines galore! Speak with our explosives expert in the first tower on the front lines for more information. I am certain that he could teach you how to diffuse the situation.','',26124),
(9080,'enUS','Yes I have, Commander.','Yes I have, Commander.',26124),
(9081,'enUS','Then listen well, $c.$B$BCan you feel the power radiating from me? Does your morale not swell? Aye, it is the same for the other side. To disrupt their defenses and thin out their troops will be no easy task, but it must be done! Victory will be ours!','',26124),
(9082,'enUS','Who do I kill? Just point me in their direction, Commander.','Who do I kill? Just point me in their direction, Commander.',26124),
(9083,'enUS','Six Lieutenants control the front line\'s defenses. They must be destroyed first and fast! We cannot risk one of their priests returning the fallen Lieutenants to life.$B$BShould all of the Lieutenants be killed in quick succession, the morale of the front lines will falter! It will be shattered! Their troops will run in fear, leaving the remaining soldiers without backup.','',26124),
(9084,'enUS','Is that all? I thought you were going to challenge me.','Is that all? I thought you were going to challenge me.',26124),
(9085,'enUS','No, $c, that is not all. The elite fighting forces of the opposition are commanded by the four Commanders of the base. Should you be able to strike a fatal and rapid blow to their Commanders, the elite line will falter. Their numbers dwindling to nothing!$B$BBut be warned, soldier; Commanders and Lieutenants are not to be trifled with or taken lightly. They earned those ranks...','',26124),
(9086,'enUS','Clap your hands everybody, and everybody clap your hands!','',26124),
(9087,'enUS','Thank you, you\'re a great audience!  I\'ll be here all week!','',26124),
(9088,'enUS','Spare some change?','',26124),
(9089,'enUS','I had it all!  I had it all and then I lost it.  Lost... all gone... like... my mind.  My mind is like... cheese.  I like cheese.  ','',26124),
(9090,'enUS','Show your appreciation for the arts and drop some coins in my hat!','',26124),
(9091,'enUS','Scanning life forms....target not found','',26124),
(9092,'enUS','Unknown life forms detected....assessing...','',26124),
(9093,'enUS','Target lost....resuming search patterns Delta','',26124),
(9094,'enUS','Explorer reporting!....Excellent!','',26124),
(9095,'enUS','%s stares hungrily at a Deeprun Rat.','',26124),
(9096,'enUS','Mmmm... don\'t you look good enough to eat.','',26124),
(9097,'enUS','On second thought... I think I\'ll pass.','',26124),
(9098,'enUS','Forty-two... forty-two... forty-two what?  It could be anything!  Forty-two... hmmm...','',26124),
(9099,'enUS','As you wish...','',26124),
(9100,'enUS','My strength wanes, mortal. I have done as promised, the way is clear. I now return to whence I came.','',26124),
(9101,'enUS','Helpless... powerless... restore... must restore... Zevrim controls... end this torment...','',26124),
(9102,'enUS','Thank you, mortal. There is but one service that I may offer to you before I return to the Dream.$B$BThe door to Zevrim\'s master, Alzzin, blocks your path. I shall act as your instrument of destruction. The door will be opened, I merely await your command.','',26124),
(9103,'enUS','Thank you, Ironbark. We are ready for you to open the door.','Thank you, Ironbark. We are ready for you to open the door.',26124),
(9104,'enUS','At last... Freed from his cursed grasp!','',26124),
(9105,'enUS','Who controls the Stonehearth Graveyard?','Who controls the Stonehearth Graveyard?',26124),
(9106,'enUS','The Stonehearth Graveyard lies east of the Stonehearth Outpost in the Field of Strife.$B$BThe Alliance currently controls it.','',26124),
(9107,'enUS','The Stonehearth Graveyard lies east of the Stonehearth Outpost in the Field of Strife.$B$BThe Horde currently controls it.','',26124),
(9110,'enUS','How many more supplies are needed to send a ground assault?','How many more supplies are needed to send a ground assault?',26124),
(9111,'enUS','How many more supplies are needed to rebuild our base?','How many more supplies are needed to rebuild our base?',26124),
(9112,'enUS','We have a lot of supplies, but we still need a lot more in order to send a ground assault into the Field of Strife.','',26124),
(9113,'enUS','We have some supplies, but not many.  We\'ll need a lot more in order to send a ground assault into the Field of Strife.','',26124),
(9114,'enUS','We have barely any supplies.  If we want to send a ground assault into the Field of Strife, then we\'ll need a lot more!','',26124),
(9115,'enUS','We have a large store of supplies to rebuild Frostwolf Keep.  Just a little bit more and we\'ll have enough to repair and reenter the battle!','',26124),
(9116,'enUS','We have a medium store of supplies for rebuilding, but we still need a lot more before Frostwolf Keep can be fully repaired.','',26124),
(9117,'enUS','We have a very small store of supplies to rebuild Frostwolf Keep.  It\'s going to take a lot more before we can repair and reenter the battle.','',26124),
(9118,'enUS','We barely have any supplies to build Frostwolf Keep.  We\'ll need many, many more before we can repair our base and reenter the battle.','',26124),
(9119,'enUS','$n, we have enough supplies to launch ground assaults into the Field of Strife.  If you want to send the orders, and your rank is high enough, then speak with Sergeant Yazra Bloodsnarl in Frostwolf Village.','',26124),
(9120,'enUS','We have lots of supplies for rebuilding.  Just a little bit more and we\'ll have enough to repair Dun Baldar and reenter the battle!','',26124),
(9121,'enUS','We have gathered a lot of supplies for rebuilding, but we still need a lot more in order to repair Dun Baldar.  Keep bringing me supplies!','',26124),
(9122,'enUS','We don\'t have many supplies for rebuilding.  It will take a lot more before Dun Baldar will be repaired.','',26124),
(9123,'enUS','Dun Baldar is in very bad shape, and we\'re very low on supplies to rebuild it.  The Alliance needs your help gathering supplies!','',26124),
(9124,'enUS','$n, we have enough supplies to launch ground assaults.  If your standing with the Stormpike Guard is high enough, then speak with Corporal Noreg Stormpike.','',26124),
(9125,'enUS','We have a lot of excess supplies, but we still need more before we can send an assualt into the Field of Strife.','',26124),
(9126,'enUS','We have excess supplies, but not many.  We\'ll need a lot more before we can send a ground assault into the Field of Strife.','',26124),
(9127,'enUS','We barely have any excess supplies.  It\'ll take a lot more work before we\'re ready to send another ground assault into the Field of Strife.','',26124),
(9128,'enUS','How many more supplies are needed to send ground assaults?','How many more supplies are needed to send ground assaults?',26124),
(9129,'enUS','How many more supplies are needed to rebuild our base?','How many more supplies are needed to rebuild our base?',26124),
(9130,'enUS','How many more supplies are needed for the next upgrade?','How many more supplies are needed for the next upgrade?',26124),
(9131,'enUS','I almost have enough supplies to upgrade to veteran units.','',26124),
(9132,'enUS','I need many more supplies in order to upgrade our units.','',26124),
(9133,'enUS','I almost have enough supplies to upgrade our troops.','',26124),
(9134,'enUS','I have about half the supplies needed to upgrade to veteran units.','',26124),
(9135,'enUS','I have less than one-third of the supplies needed to upgrade to veteran units.','',26124),
(9136,'enUS','I barely have any supplies for upgrades.','',26124),
(9137,'enUS','Ugh... these pests keep me busy night and day! Haven\'t you seen them?$B$BI wish I could just jump down a pipe to get away from them...','',26124),
(9138,'enUS','Larion, I want to help you fight these pests!','Larion, I want to help you fight these pests!',26124),
(9139,'enUS','This is some specialized equipment! Don\'t be handling it carelessly, and of course don\'t try and operate the thing if you\'ve had too much of that volatile rum I hear you like so much...$B$BSpeaking of which... you don\'t happen to have any of that nasty stuff, do you?','',26124),
(9140,'enUS','Which way should you go? Well, the only advice I can offer is for you to take any road you want!$B$BI can\'t remember anything!','',26124),
(9141,'enUS','%s sifts through the trash.','',26124),
(9142,'enUS','','This is my test gossip.\n',26124),
(9143,'enUS','','This is my test gossip.',26124),
(9144,'enUS','%s puts his club away and begins swinging wildly!','',26124),
(9145,'enUS','How dare you attempt to zerg me, wimp!','',26124),
(9147,'enUS','%s yawns.','',26124),
(9148,'enUS','Yes, $c?','',26124),
(9149,'enUS','Rats everywhere.  Everywhere I see rats.  Always looking at me with their beady little eyes.  I\'ll show them.  I\'ll show them all!','',26124),
(9150,'enUS','Rat-kabobs!  Get your tasty Rat-kabobs here!  Get them while they last!','',26124),
(9151,'enUS','How many more supplies are needed for the next upgrade?','How many more supplies are needed for the next upgrade?',26124),
(9152,'enUS','I almost have enough supplies to upgrade to champion units.','',26124),
(9153,'enUS','I have about half the supplies needed to upgrade to champion units.','',26124),
(9154,'enUS','I barely have any supplies for upgrades.','',26124),
(9155,'enUS','I almost have enough supplies to upgrade our troops.','',26124),
(9156,'enUS','I need many more supplies in order to upgrade our units.','',26124),
(9158,'enUS','I almost have enough supplies to upgrade to veteran units.','',26124),
(9159,'enUS','I need many more supplies in order to upgrade our units.','',26124),
(9160,'enUS','I have about half the supplies needed to upgrade to veteran units.','',26124),
(9161,'enUS','I almost have enough supplies to upgrade to champion units.','',26124),
(9162,'enUS','I have about half the supplies needed to upgrade to champion units.','',26124),
(9163,'enUS','I barely have any supplies for upgrades.','',26124),
(9164,'enUS','Our units are not upgraded, and I don\'t have enough supplies to upgrade them.','',26124),
(9165,'enUS','Our units are upgraded to Seasoned, but I don\'t have enough supplies to upgrade them to Veteran.','',26124),
(9166,'enUS','Our units are upgraded to Veteran, but I don\'t have enough supplies to upgrade them to Champion.','',26124),
(9167,'enUS','I have enough supplies to upgrade  our troops to seasoned.','',26124),
(9168,'enUS','I have enough supplies to upgrade our troops to veterans.','',26124),
(9169,'enUS','I have enough supplies to upgrade our troops to champions.','',26124),
(9170,'enUS','I cannot store any more supplies.  I have all I can handle!','',26124),
(9171,'enUS','My altar will siphon the life from you!','',26124),
(9172,'enUS','Your pain will end soon!','',26124),
(9173,'enUS','OH NOES!! BRB AS DRAGON! <PH>','',26124),
(9174,'enUS','The Dun Baldar South Bunker is under attack!  If left unchecked, the Horde will destroy it!','',26124),
(9175,'enUS','The Dun Baldar South Bunker was destroyed by the Horde!','',26124),
(9176,'enUS','The Dun Baldar South Bunker is under attack!  If left unchecked, the Alliance will destroy it!\n','',26124),
(9177,'enUS','The Dun Baldar South Bunker was taken by the Alliance!','',26124),
(9178,'enUS','The Dun Baldar North Bunker is under attack!  If left unchecked, the Horde will destroy it!','',26124),
(9179,'enUS','The Dun Baldar North Bunker was destroyed by the Horde!','',26124),
(9180,'enUS','The Dun Baldar North Bunker is under attack!  If left unchecked, the Alliance will destroy it!','',26124),
(9181,'enUS','The Dun Baldar North Bunker was taken by the Alliance!','',26124),
(9182,'enUS','The Icewing Bunker is under attack!  If left unchecked, the Horde will destroy it!','',26124),
(9183,'enUS','The Icewing Bunker was destroyed by the Horde!','',26124),
(9184,'enUS','The Icewing Bunker is under attack!  If left unchecked, the Alliance will destroy it!','',26124),
(9185,'enUS','The Icewing Bunker was taken by the Alliance!','',26124),
(9186,'enUS','The Stonehearth Bunker is under attack!  If left unchecked, the Horde will destroy it!','',26124),
(9187,'enUS','The Stonehearth Bunker was destroyed by the Horde!','',26124),
(9188,'enUS','The Stonehearth Bunker is under attack!  If left unchecked, the Alliance will destroy it!','',26124),
(9189,'enUS','The Stonehearth Bunker was taken by the Alliance!','',26124),
(9190,'enUS','The West Frostwolf Tower is under attack!  If left unchecked, the Horde will destroy it!','',26124),
(9191,'enUS','The West Frostwolf Tower was taken by the Horde!','',26124),
(9192,'enUS','The West Frostwolf Tower is under attack!  If left unchecked, the Alliance will destroy it!','',26124),
(9193,'enUS','The West Frostwolf Tower was destroyed by the Alliance!','',26124),
(9194,'enUS','The East Frostwolf Tower is under attack!  If left unchecked, the Horde will destroy it!','',26124),
(9195,'enUS','The East Frostwolf Tower was taken by the Horde!','',26124),
(9196,'enUS','The East Frostwolf Tower is under attack!  If left unchecked, the Alliance will destroy it!','',26124),
(9197,'enUS','The East Frostwolf Tower was destroyed by the Alliance!','',26124),
(9198,'enUS','Tower Point is under attack!  If left unchecked, the Horde will destroy it!','',26124),
(9199,'enUS','Tower Point was taken by the Horde!','',26124),
(9200,'enUS','Tower Point is under attack!  If left unchecked, the Alliance will destroy it!','',26124),
(9201,'enUS','Tower Point was destroyed by the Alliance!','',26124),
(9202,'enUS','Iceblood Bunker is under attack!  If left unchecked, the Horde will destroy it!','',26124),
(9203,'enUS','Iceblood Tower was taken by the Horde!','',26124),
(9204,'enUS','Iceblood Tower is under attack!  If left unchecked, the Alliance will destroy it!','',26124),
(9205,'enUS','Iceblood Tower was destroyed by the Alliance!','',26124),
(9206,'enUS','The West Frostwolf Tower is under attack!  If left unchecked, the Horde will destroy it!','',26124),
(9207,'enUS','The West Frostwolf Tower was taken by the Horde!','',26124),
(9208,'enUS','The West Frostwolf Tower is under attack!  If left unchecked, the Alliance will destroy it!','',26124),
(9209,'enUS','The West Frostwolf Tower was destroyed by the Alliance!','',26124),
(9210,'enUS','Your skill exceeds mine, though  I\'ve heard that Old Man Heming in Booty Bay has copies of \"The Bass and You\".  That is sure to help you increase your skill.','Your skill exceeds mine, though  I\'ve heard that Old Man Heming in Booty Bay has copies of \"The Bass and You\".  That is sure to help you increase your skill.',26124),
(9211,'enUS','The Stormpike Aid Station was taken by the Horde!','',26124),
(9212,'enUS','The Stormpike Aid Station is under attack!  If left unchecked, the Horde will capture it!','',26124),
(9213,'enUS','The Stormpike Aid Station was taken by the Alliance!','',26124),
(9214,'enUS','The Stormpike Aid Station is under attack!  If left unchecked, the Alliance will capture it!','',26124),
(9215,'enUS','The Frostwolf Relief Hut was taken by the Horde!','',26124),
(9216,'enUS','The Frostwolf Relief Hut is under attack!  If left unchecked, the Horde will capture it!','',26124),
(9217,'enUS','The Frostwolf Relief Hut was taken by the Alliance!','',26124),
(9218,'enUS','The Frostwolf Relief Hut is under attack!  If left unchecked, the Alliance will capture it!','',26124),
(9219,'enUS','Your skill exceeds mine, though  I\'ve heard that Old Man Heming in Booty Bay has copies of \"The Bass and You\".  That is sure to help you increase your skill.','Your skill exceeds mine, though  I\'ve heard that Old Man Heming in Booty Bay has copies of \"The Bass and You\".  That is sure to help you increase your skill.',26124),
(9220,'enUS','See that broken trap over yonder?  The ogres are too stupid to figure out how to fix it.  Clearly, it needs a little tinkering!  If you fix it, I bet you could lure Slip\'kik into it, and BLAMMO - trapped ogre guard!','',26124),
(9221,'enUS','The Stonehearth Graveyard was taken by the Horde!','',26124),
(9222,'enUS','The Stonehearth Graveyard is under attack!  If left unchecked, the Horde will capture it!','',26124),
(9223,'enUS','The Stonehearth Graveyard was taken by the Alliance!','',26124),
(9224,'enUS','The Stonehearth Graveyard is under attack!  If left unchecked, the Alliance will capture it!','',26124),
(9225,'enUS','The Iceblood Graveyard was taken by the Horde!','',26124),
(9226,'enUS','The Iceblood Graveyard is under attack!  If left unchecked, the Horde will capture it!','',26124),
(9227,'enUS','The Iceblood Graveyard was taken by the Alliance!','',26124),
(9228,'enUS','The Iceblood Graveyard is under attack!  If left unchecked, the Alliance will capture it!','',26124),
(9229,'enUS','Tell me about mines.','Tell me about mines.',26124),
(9230,'enUS','Tell me about graveyards.','Tell me about graveyards.',26124),
(9231,'enUS','Tell me about towers.','Tell me about towers.',26124),
(9232,'enUS','There are two mines in Alterac: the Irondeep in Alliance territory and the Coldtooth mine in Horde territory.  Both mines are a rich source of minerals, and in the past were used to store excess supplies.$B$BNow, these mines are constantly fought over by the Horde, the Alliance and local denizens.','',26124),
(9233,'enUS','The towers and bunkers in Alterac Valley are vital strategic locales.  If we control a tower, then our troops can fire great distances from it.','',26124),
(9234,'enUS','The graveyards in Alterac Valley are where the souls of the deceased find rest and succor.  If you die, then your spirit will drift to the closest graveyard that our side controls.','',26124),
(9235,'enUS','Who controls the Stormpike Aid Station?','Who controls the Stormpike Aid Station?',26124),
(9236,'enUS','Who controls the Frostwolf Relief Hut?','Who controls the Frostwolf Relief Hut?',26124),
(9237,'enUS','Who controls the Iceblood Graveyard?','Who controls the Iceblood Graveyard?',26124),
(9238,'enUS','The Stormpike Aid Station is in Dun Baldar, right outside the Dun Baldar barracks.$B$BThe Alliance currently controls it.','',26124),
(9239,'enUS','The Stormpike Aid Station is in Dun Baldar, right outside the Dun Baldar barracks.$B$BThe Horde currently controls it.','',26124),
(9240,'enUS','The Stormpike Aid Station is in Dun Baldar, right outside the Dun Baldar barracks.$B$BNeither side currently controls it.','',26124),
(9241,'enUS','The Stonehearth Graveyard lies east of the Stonehearth Outpost in the Field of Strife.$B$BNeither side currently controls it.','',26124),
(9242,'enUS','The Stormpike Graveyard is cut into the mountains, across the bridge east of Dun Baldar.$B$BNeither side currently controls it.','',26124),
(9243,'enUS','The Frostwolf Graveyard is along the side of the road, not far north of Frostwolf Village.$B$BNeither side controls it.','',26124),
(9244,'enUS','The Snowfall Graveyard lies high atop a hill in the Field of Strife, east of Winterax Hold.$B$BNeither side controls it.','',26124),
(9245,'enUS','The Frostwolf Relief Hut lies in Frostwolf Keep, south of the Frostwolf Towers.$B$BThe Alliance currently controls it.','',26124),
(9246,'enUS','The Frostwolf Relief Hut lies in Frostwolf Keep, south of the Frostwolf Towers.$B$BThe Horde controls it.','',26124),
(9247,'enUS','The Frostwolf Relief Hut lies in Frostwolf Keep, south of the Frostwolf Towers.$B$BNeither side currently controls it.','',26124),
(9248,'enUS','The Iceblood Graveyard is on the south side of the Field of Strife, east of the Iceblood Tower.$B$BThe Alliance currently controls it.','',26124),
(9249,'enUS','The Iceblood Graveyard is on the south side of the Field of Strife, east of the Iceblood Tower.$B$BThe Horde currently controls it.','',26124),
(9250,'enUS','The Iceblood Graveyard is on the south side of the Field of Strife, east of the Iceblood Tower.$B$BNeither side currently controls it.','',26124),
(9251,'enUS','Who controls the Frostwolf Graveyard?','Who controls the Frostwolf Graveyard?',26124),
(9252,'enUS','Who controls the Snowfall Graveyard?','Who controls the Snowfall Graveyard?',26124),
(9253,'enUS','Look to this ravaged field and know the power that the elements hold, $r.','',26124),
(9254,'enUS','Who controls the Dun Baldar South Bunker?','Who controls the Dun Baldar South Bunker?',26124),
(9255,'enUS','Who controls the Dun Baldar North Bunker?','Who controls the Dun Baldar North Bunker?',26124),
(9256,'enUS','Who controls the Icewing Bunker?','Who controls the Icewing Bunker?',26124),
(9257,'enUS','Who controls the Stonehearth Bunker?','Who controls the Stonehearth Bunker?',26124),
(9258,'enUS','Who controls the West Frostwolf Tower?','Who controls the West Frostwolf Tower?',26124),
(9259,'enUS','Who controls East Frostwolf Tower?','Who controls East Frostwolf Tower?',26124),
(9260,'enUS','Who controls Tower Point?','Who controls Tower Point?',26124),
(9261,'enUS','Who controls the Iceblood Tower?','Who controls the Iceblood Tower?',26124),
(9262,'enUS','Who controls the West Frostwolf Tower?','Who controls the West Frostwolf Tower?',26124),
(9263,'enUS','The Dun Baldar South Bunker protects the south and east flanks of Dun Baldar.$B$BIt is controlled by the Alliance.','',26124),
(9264,'enUS','The Dun Baldar South Bunker protects the south and east flanks of Dun Baldar.$B$BIt is controlled by the Horde.','',26124),
(9265,'enUS','The Dun Baldar South Bunker protects the south and east flanks of Dun Baldar.$B$BIt is controlled by neither side.','',26124),
(9266,'enUS','The Dun Baldar North Bunker protects the eastern entrance to Dun Baldar.$B$BIt is controlled by the Alliance.','',26124),
(9267,'enUS','The Dun Baldar North Bunker protects the eastern entrance to Dun Baldar.$B$BIt is controlled by the Horde.','',26124),
(9268,'enUS','The Dun Baldar North Bunker protects the eastern entrance to Dun Baldar.$B$BIt is controlled by neither side.','',26124),
(9269,'enUS','The Icewing Bunker holds the pass between Alliance territory and the Field of Strife.$B$BIt is controlled by the Alliance.','',26124),
(9270,'enUS','The Icewing Bunker holds the pass between Alliance territory and the Field of Strife.$B$BIt is controlled by the Horde.','',26124),
(9271,'enUS','The Icewing Bunker holds the pass between Alliance territory and the Field of Strife.$B$BIt is controlled by neither side.','',26124),
(9272,'enUS','The Stonehearth Bunker protects the eastern flank of the Field of Strife.$B$BIt is controlled by the Alliance.','',26124),
(9273,'enUS','The Stonehearth Bunker protects the eastern flank of the Field of Strife.$B$BIt is controlled by the Horde.','',26124),
(9274,'enUS','The Stonehearth Bunker protects the eastern flank of the Field of Strife.$B$BIt is controlled by neither side.','',26124),
(9275,'enUS','The West Frostwolf Tower protects the gate between Frostwolf Village and Frostwolf Keep.$B$BIt is controlled by the Alliance.','',26124),
(9276,'enUS','The West Frostwolf Tower protects the gate between Frostwolf Village and Frostwolf Keep.$B$BIt is controlled by the Horde.','',26124),
(9277,'enUS','The West Frostwolf Tower protects the gate between Frostwolf Village and Frostwolf Keep.$B$BIt is controlled by neither side.','',26124),
(9278,'enUS','Tower Point East holds the pass between the Field of Strife and Horde territories to the south.$B$BIt is controlled by the Alliance.The East Frostwolf Tower protects the gate between Frostwolf Village and Frostwolf Keep.$B$BIt is controlled by the Alliance.','',26124),
(9279,'enUS','Tower Point East holds the pass between the Field of Strife and Horde territories to the south.$B$BIt is controlled by the Horde.The East Frostwolf Tower protects the gate between Frostwolf Village and Frostwolf Keep.$B$BIt is controlled by the Horde.','',26124),
(9280,'enUS','Tower Point East holds the pass between the Field of Strife and Horde territories to the south.$B$BIt is controlled by neither side.The East Frostwolf Tower protects the gate between Frostwolf Village and Frostwolf Keep.$B$BIt is controlled by neither side.','',26124),
(9281,'enUS','Tower Point holds the pass between the Field of Strife and the Horde territories to the south.$B$BIt is controlled by the Alliance.','',26124),
(9282,'enUS','Tower Point holds the pass between the Field of Strife and the Horde territories to the south.$B$BIt is controlled by the Horde.','',26124),
(9283,'enUS','Tower Point holds the pass between the Field of Strife and the Horde territories to the south.$B$BIt is controlled by neither side.','',26124),
(9284,'enUS','The Iceblood Tower protects the Iceblood Garrison from the southeast.$B$BIt is controlled by the Alliance.','',26124),
(9285,'enUS','The Iceblood Tower protects the Iceblood Garrison from the southeast.$B$BIt is controlled by the Horde.','',26124),
(9286,'enUS','The Iceblood Tower protects the Iceblood Garrison from the southeast.$B$Bis controlled by neither side.','',26124),
(9287,'enUS','The West Frostwolf Tower protects the gate between Frostwolf Village and Frostwolf Keep.$B$BIt is controlled by the Alliance.','',26124),
(9288,'enUS','The West Frostwolf Tower protects the gate between Frostwolf Village and Frostwolf Keep.$B$BIt is controlled by the Horde.','',26124),
(9289,'enUS','The West Frostwolf Tower protects the gate between Frostwolf Village and Frostwolf Keep.$B$BIt is controlled by neither side.','',26124),
(9290,'enUS','Tell me again about towers...','Tell me again about towers...',26124),
(9291,'enUS','Tell me again about graveyards...','Tell me again about graveyards...',26124),
(9292,'enUS','Tell me again about the mines...','Tell me again about the mines...',26124),
(9293,'enUS','Tell me about something else...','Tell me about something else...',26124),
(9294,'enUS','Captain Balinda Stonehearth has fallen!$B$BAttack the Horde!  Claim vengeance for Captain Stonehearth!','',26124),
(9295,'enUS','The Horde Captain Galvangar is slain.  Defeat Drek\'Thar and victory will be ours!','',26124),
(9296,'enUS','What do you know of it?','What do you know of it?',26124),
(9297,'enUS','I know much, listen and be educated, $r.','',26124),
(9298,'enUS','I am listening, Demitrian.','I am listening, Demitrian.',26124),
(9299,'enUS','In the time before time, what the usurpers would later call the First Age of Creation, my master and his siblings ruled over this world. It was they, the Old Gods, who created all.$B$BAnd it was they who would ultimately be cast down by those that would call themselves Shapers.\n','',26124),
(9300,'enUS','Continue, please.','Continue, please.',26124),
(9301,'enUS','Their manifest forms weak from eons of battle, imprisoned beneath the world - the world that they themselves created - the corruption of the Titan Shapers would permeate through the surface and befoul the Old Gods.$B$BIt was then and there that the brothers did turn. For five millennia a battle was fought at the core of this world.\n','',26124),
(9302,'enUS','Both the Horde and Alliance captains have fallen!  Defeat Drek\'Thar before it\'s too late!','',26124),
(9303,'enUS','Both the Horde and Alliance captains have taken to the field.  Our Captain Balinda Stonehearth directs the Stormpike forces from the Stonehearth Outpost, and the enemy Captain Galvangar barks orders from within Iceblood Garrison.$B$BTo battle!','',26124),
(9304,'enUS','NO!!!  It puts the tannin in the basket, or it gets the mallet again!','',26124),
(9305,'enUS','Both the Horde and Alliance captains have taken to the field.  Our Captain Galvangar directs the Frostwolves from Iceblood Garrison, and his rival, Captain Balinda Stonehearth, hides in her Stonehearth Outpost.$B$BThe battle has begun!','',26124),
(9306,'enUS','The Stormpike general has fallen!  The battle is won!$B$BNow laugh as the Alliance scurries to recover its lost holdings.','',26124),
(9307,'enUS','The battle rages, and both our captain and the captain of our enemy are slain!$B$BDrek\'Thar now leads us from Frostwolf Keep, and the dwarf Vanndar Stormpike hides deep in Dun Baldar.  Defeat Vanndar and claim victory for the Horde!','',26124),
(9308,'enUS','Captain Balinda Stonehearth is dead!  Defeat Vanndar and the battle will be ours!','',26124),
(9309,'enUS','Captain Galvangar has been slain!  Honor our fallen captain, and unleash yourself again the Alliance!','',26124),
(9310,'enUS','Tell me about Alterac Valley.','Tell me about Alterac Valley.',26124),
(9311,'enUS','Alterac Valley has been home to the Frostwolf Clan for years; we will not let the dwarves and their Alliance trespass!  And so we battle!$B$BTo win back Alterac, defeat their general Vanndar Stormpike, in Dun Baldar.$B$BFor the Horde!','',26124),
(9312,'enUS','The Stormpikes uncovered ancient artifacts within Alterac Valley, but the Frostwolf orcs don\'t take kindly to explorers.  If the dwarves have to fight for knowledge of their ancestors, then so be it!$B$BTo win this battle, defeat the orc, Drek\'Thar, in Frostwolf Keep.  Fortune be with you, $c!','',26124),
(9313,'enUS','Captain Balinda Stonehearth leads the front line Alliance forces.  She is based in the Stonehearth Outpost, in the northern section of the Field of Strife.$B$BBalinda has not yet reentered the battle.','',26124),
(9314,'enUS','Captain Galvangar is the trusted aid to Drek\'Thar.  He leads the Horde forces from the Iceblood Garrison, in the southern section of the the Field of Strife.$B$BCaptain Galvangar has not yet entered the battle.','',26124),
(9315,'enUS','Vanndar Stormpike is the general of the Alliance military in Alterac, and directs his forces from Dun Baldar.$B$BIf he is defeated then the Alliance will surely lose the battle for Alterac.$B$BVanndar is not currently in Alterac Valley.','',26124),
(9316,'enUS','Drek\'Thar is the military and spiritual leader of the Frostwolf Clan in Alterac, leading his brethren from Frostwolf Keep.$B$BIf he is defeated then the Horde forces in Alterac will crumble.$B$BDrek\'Thar is not currently in Alterac Valley.','',26124),
(9317,'enUS','Tell me of Captain Balinda Stonehearth.','Tell me of Captain Balinda Stonehearth.',26124),
(9318,'enUS','Tell me of Captain Galvangar.','Tell me of Captain Galvangar.',26124),
(9319,'enUS','Tell me of Vanndar Stormpike.','Tell me of Vanndar Stormpike.',26124),
(9320,'enUS','Tell me of Drek\'Thar.','Tell me of Drek\'Thar.',26124),
(9321,'enUS','Tell me again about Alterac Valley...','Tell me again about Alterac Valley...',26124),
(9322,'enUS','Captain Balinda Stonehearth leads the front line Alliance forces.  She is based in the Stonehearth Outpost, in the northern section of the Field of Strife.$B$BBalinda is currently in Stonehearth Outpost.','',26124),
(9323,'enUS','Captain Balinda Stonehearth leads the front line Alliance forces.  She is based in the Stonehearth Outpost, in the northern section of the Field of Strife.$B$BBalinda has been slain.','',26124),
(9324,'enUS','Drek\'Thar is the military and spiritual leader of the Frostwolf Clan in Alterac, leading his brethren from Frostwolf Keep.$B$BIf he is defeated then the Horde forces in Alterac will crumble.','',26124),
(9325,'enUS','Drek\'Thar is the military and spiritual leader of the Frostwolf Clan in Alterac, leading his brethren from Frostwolf Keep.$B$BIf he is defeated then the Horde forces in Alterac will crumble.$B$BDrek\'Thar has been slain.','',26124),
(9326,'enUS','Captain Galvangar is the trusted aid to Drek\'Thar.  He leads the Horde forces from the Iceblood Garrison, in the southern section of the the Field of Strife.$B$BCaptain Galvangar is currently in the Iceblood Garrison.','',26124),
(9327,'enUS','Captain Galvangar is the trusted aid to Drek\'Thar.  He leads the Horde forces from the Iceblood Garrison, in the southern section of the the Field of Strife.$B$BCaptain Galvangar has been slain.','',26124),
(9328,'enUS','Vanndar Stormpike is the general of the Alliance military in Alterac, and directs his forces from Dun Baldar.$B$BIf he is defeated then the Alliance will surely lose the battle for Alterac.','',26124),
(9329,'enUS','Vanndar Stormpike is the general of the Alliance military in Alterac, and directs his forces from Dun Baldar.$B$BIf he is defeated then the Alliance will surely lose the battle for Alterac.','',26124),
(9330,'enUS','A battle?','A battle?',26124),
(9331,'enUS','It was during the Elemental Sundering that the Firelord, Ragnaros, would seek to consume my Lord, Thunderaan, Prince of Air.$B$B<Demitrian bows his head, his face contorted in rage.>$B$BSpeak his name and I shall decorate this ravaged camp with your entrails. Be silent and listen.\n','',26124),
(9332,'enUS','<Nod>.','<Nod>.',26124),
(9333,'enUS','It was the Lieutenants of Ragnaros, Geddon and Garr, who would perpetrate the betrayal against my Lord. Thunderaan was caught unaware.','',26124),
(9334,'enUS','Caught unaware? How?','Caught unaware? How?',26124),
(9335,'enUS','The Firelord\'s advances were wholly unknown to Thunderaan. Before my Lord could react, Sulfuras, legendary hammer of Ragnaros, would strike an unmerciful blow. Thunderaan fell, utterly defeated.$B$BThe Firelord feasted upon the essence of my Lord, but was unable to consume him entirely.','',26124),
(9336,'enUS','So what did Ragnaros do next?','So what did Ragnaros do next?',26124),
(9337,'enUS','What little remained of Thunderaan\'s essence was stored within a talisman of elemental binding. Ragnaros then shattered the talisman in two flawless pieces. The pieces assigned to his Lieutenants...\n','',26124),
(9338,'enUS','Dun Baldar is the strongest point of Alliance power in Alterac Valley.  Nestled in the northern reaches of the valley, Dun Baldar is the staging ground for all advances to the south.$B$BDun Baldar is intact.','',26124),
(9339,'enUS','Dun Baldar is the strongest point of Alliance power in Alterac Valley.  Nestled in the northern reaches of the valley, Dun Baldar is the staging ground  for all advances to the south.$B$BDun Baldar was razed and is under reconstruction.','',26124),
(9340,'enUS','Frostwolf Keep lies in the south corner of Alterac Valley and protects Frostwolf Village, home of orc clan of the same name.  All Horde territories in Alterac Valley stem from this one place of power.$B$BFrostwolf Keep is intact.','',26124),
(9341,'enUS','Frostwolf Keep lies in the south corner of Alterac Valley and protects Frostwolf Village, home of orc clan of the same name.  All Horde territories in Alterac Valley stem from this one place of power.$B$BFrostwolf Keep was razed and is under reconstruction.','',26124),
(9342,'enUS','Tell me of Dun Baldar.','Tell me of Dun Baldar.',26124),
(9343,'enUS','Tell me of Frostwolf Keep.','Tell me of Frostwolf Keep.',26124),
(9344,'enUS','So, I found this shackle key...','So, I found this shackle key...',26124),
(9345,'enUS','You found a key?  Well, is it THE key?  I mean, is it the key to unlock these shackles?  Well $G sir : ma\'am;, there is only one way to find out!','',26124),
(9346,'enUS','$n, I\'ll make sure all my friends in the Cartel know that you\'ve saved my life today.  Here - I\'m going to need to be able to travel light, so please help yourself to my cache of tailoring and leatherworking supplies!  Thanks again - see ya!','',26124),
(9347,'enUS','You big boss now!  You king!  All hail King $n, King of Gordok!$B$BNow that you da boss, all henchmen will give you tribute!  You left some alive, yeah boss?','',26124),
(9348,'enUS','OH NOES!  Da king is dead!  Uh... hail to da new king!  Yeah!','',26124),
(9349,'enUS','If you want the key, you\'ll have to catch me!','',26124),
(9350,'enUS','Do you want to play a game, stinky?','',26124),
(9351,'enUS','I hold the key to lands of free! Chase me and you\'ll see!','',26124),
(9352,'enUS','Game? Are you crazy?','Game? Are you crazy?',26124),
(9353,'enUS','Chase me if you dare! I run without a care!','',26124),
(9354,'enUS','Still alive? You do surprise. Watch me as I flee!','',26124),
(9355,'enUS','Why you little...','Why you little...',26124),
(9356,'enUS','Mark my words, I will catch you, imp. And when I do!','Mark my words, I will catch you, imp. And when I do!',26124),
(9357,'enUS','Why would you ever want to harm me!? Come. Friends we can be!','',26124),
(9358,'enUS','Turn that frown upside down!','',26124),
(9359,'enUS','DIE!','DIE!',26124),
(9360,'enUS','DIE?! You make Pusillin cry!','',26124),
(9361,'enUS','This is the end of the line, no friend of mine!','',26124),
(9362,'enUS','Prepare to meet your maker.','Prepare to meet your maker.',26124),
(9363,'enUS','Say hello to my little friends!','',26124),
(9364,'enUS','The demon is loose!  Quickly we must restrain him!','The demon is loose!  Quickly we must restrain him!',26124),
(9365,'enUS','I\'m the new king?  What are you talking about?','I\'m the new king?  What are you talking about?',26124),
(9366,'enUS','All henchmen of da boss - Stomper Kreeg, all three of da Guards, Captain Kromcrush, and da Observer - give tribute to da new boss.  If you kill a henchman, then that henchman can\'t give tribute!  Each one you keep alive will give you more tribute.  Keep all of them alive and you get da BIG tribute!$B$BYeah!','',26124),
(9367,'enUS','Well then... show me the tribute!','Well then... show me the tribute!',26124),
(9368,'enUS','Why should I bother fixing the trap?  Why not just eliminate the guard the old fashioned way?','Why should I bother fixing the trap?  Why not just eliminate the guard the old fashioned way?',26124),
(9369,'enUS','Well, from what I\'ve gathered while waiting to be eaten by these yokels... it might not be necessary to kill every ogre you find here.$B$BThe ogres were going on and on the other day about how King Gordok came to power; specifically, he killed the previous king and took his place.  Well, the king\'s henchmen - those that Gordok spared - immediately swore fealty to the new king.$B$BWho knows - the ogre you save could very well be your own... figuratively speaking, of course!','',26124),
(9370,'enUS','','THIS EVENT IS WORKING.',26124),
(9371,'enUS','You da boss now, yeah?  Long live da new king!$B$BKreeg let you look at Gordok hooch.  Ogre hooch best of all hooch, and Gordok hooch best of all ogre hooch!  Maybe you buy some from me, ya boss?!','',26124),
(9372,'enUS','Show me what hooch you\'ve got to sell, Kreeg.','Show me what hooch you\'ve got to sell, Kreeg.',26124),
(9373,'enUS','What do you mean, buy?!  I\'m the king now... and it\'s good to be the king!','What do you mean, buy?!  I\'m the king now... and it\'s good to be the king!',26124),
(9374,'enUS','%s begins to grow!','',26124),
(9375,'enUS','%s continues to grow!','',26124),
(9376,'enUS','%s has grown to full size!','',26124),
(9377,'enUS','OK boss, when you ready for da tribue from your henchmen, you let me know!','',26124),
(9378,'enUS','Apply the Gordok war paint!','Apply the Gordok war paint!',26124),
(9379,'enUS','','Leave this place, stranger, lest it consume you as it has all that it has touched.',26124),
(9380,'enUS','What happened here, spirit?','What happened here, spirit?',26124),
(9381,'enUS','','Do you know of the Highborne? The Shen\'dralar?',26124),
(9382,'enUS','I know very little of the Highborne and nothing of the Shen\'dralar.','I know very little of the Highborne and nothing of the Shen\'dralar.',26124),
(9383,'enUS','','The Shen\'dralar were Queen Azshara\'s most revered arcanists. It was within these very walls that the Queen\'s most important demands were processed - often in secret.$B$BAfter the destruction of the Well and the subsequent lethargy that overcame the Highborne and lesser night elf sects, the Prince of Eldre\'Thalas, Tortheldrin, began construction of the pylons that you see littering the halls of the west wing.\n',26124),
(9384,'enUS','','The Prince plotted to imprison a demon of immense power behind a grand force field. The pylons would channel latent energies into the field, keeping it operational.$B$BWhile imprisoned, Immol\'thar would serve as a battery to the populace of Eldre\'Thalas.',26124),
(9385,'enUS','Continue, please.','Continue, please.',26124),
(9386,'enUS','Fascinating. Continue, please.','Fascinating. Continue, please.',26124),
(9387,'enUS','','The siphoned energies would sustain the Highborne\'s magic, allowing those within the walls of Eldre\'Thalas to feed their endless and growing magical pangs.$B$BThousands of years passed and the power required to keep Immol\'thar imprisoned while sustaining life within Eldre\'Thalas, began to shift. The cost to keep Immol\'thar bound grew to overshadow the rate at which energy could be siphoned and distributed. The once net gain turned to loss.',26124),
(9388,'enUS','I\'m going to have to kill something, aren\'t I?','I\'m going to have to kill something, aren\'t I?',26124),
(9389,'enUS','','The Highborne ghosts that you see wandering through the courtyard and halls of Eldre\'Thalas were slain, not by invading Gordok ogres or satyrs, but by the Prince himself!',26124),
(9390,'enUS','We live in a world of endless tragedy.','We live in a world of endless tragedy.',26124),
(9391,'enUS','','The people were destroyed in order to preserve the Prince\'s immortal life and near limitless powers. The power once divided among thousands now funnels into the Prince and the Shen\'dralar zealots. Those few remaining survivors are directly feeding power into the pylons in order to keep Immol\'thar imprisoned.$B$BShould the demon break free of its bonds, it would surely destroy what little is left of this once great bastion of arcana.',26124),
(9392,'enUS','A very sad tale. Thank you, spirit.','A very sad tale. Thank you, spirit.',26124),
(9393,'enUS','You da man now, dog!','',26124),
(9394,'enUS','I am, am I?  Well what have you got for the new big dog of Gordok, Fengus?','I am, am I?  Well what have you got for the new big dog of Gordok, Fengus?',26124),
(9396,'enUS','Fengus make you fierce!  Crazed!  RAR!','',26124),
(9397,'enUS','You got me good boss!  How you get by Slip\'kik??  I smart though, I watch next time!  Har har!$B$BNobody get by Slip\'kik no more. Slip\'kik promise!','',26124),
(9398,'enUS','Yeah, you\'re a real brainiac.  Just how smart do you think you are, Slip\'kik?','Yeah, you\'re a real brainiac.  Just how smart do you think you are, Slip\'kik?',26124),
(9399,'enUS','I show you how smart I am, boss!  You be extra smart with mighty magic mojo now!$B$BUm... maybe Slip\'kik use magic on self. Dat would be good idea...','',26124),
(9400,'enUS','You are da king of the Gordok!  You\'re A-number-one!','',26124),
(9401,'enUS','Call me \"Boss\".  What have you got for me!','Call me \"Boss\".  What have you got for me!',26124),
(9402,'enUS','I heard you was dead... well, you won\'t be easy to make dead after this!','',26124),
(9403,'enUS','Hey Knot - I\'m a Leatherworker.  Think you could teach me how to make the ogre suit?','Hey Knot - I\'m a Leatherworker.  Think you could teach me how to make the ogre suit?',26124),
(9404,'enUS','Hey Knot - I\'m a Tailor.  Think you could teach me how to make the ogre suit?','Hey Knot - I\'m a Tailor.  Think you could teach me how to make the ogre suit?',26124),
(9405,'enUS','I suppose I can teach that to you.  You\'ll probably only be able to find ogre tannin here, but the other things you can find most anywhere!','',26124),
(9406,'enUS','For 10,000 years I have ruled this kingdom. In that time, I have heard many fascinating tales from those that would walk the hallowed grounds of the House of Shen\'dralar.$B$BAs I am bound to this place, I often exchange stories with visitors. Do you have a story for me or perhaps you would like to hear a story?','',26124),
(9407,'enUS','Who dares disrupt the sanctity of Eldre\'Thalas? Face me, cowards!','',26124),
(9408,'enUS','We mustn\'t anger the Master. His is a wrath that is cruel beyond measure.','We mustn\'t anger the Master. His is a wrath that is cruel beyond measure.',26124),
(9409,'enUS','Keep your voice down, stranger. You do not want to disrupt the Master\'s meditations.','Keep your voice down, stranger. You do not want to disrupt the Master\'s meditations.',26124),
(9410,'enUS','Many have come to this sanctuary, few have left. ','Many have come to this sanctuary, few have left. ',26124),
(9411,'enUS','Yar, he\'s dead all right.  That makes you da new king... well, all of you!  Gordok is yours now, boss!  You should talk to me so you can learn everything there is about being da king!  I was... is his assistant!  Yeah, that\'s why I\'m called da crafty one!','',26124),
(9412,'enUS','The Lorekeeper is an ancient. He has served under our glorious Queen!','The Lorekeeper is an ancient. He has served under our glorious Queen!',26124),
(9413,'enUS','%s lets out a deep roar, alerting nearby allies and becoming enraged!','',26124),
(9414,'enUS','%s goes into a drunken rage!','',26124),
(9416,'enUS','Hey, who Fengus callin\' a gnoll lover?!  Take da prisoners to da king; you smart to bring them with their weapons and show da king that they a threat.  I\'ll go see if Fengus talk smack when I give him da beatdown!  HAR!','',26124),
(9418,'enUS','No one get past me and threaten da king!  Ungh, take it!!','',26124),
(9419,'enUS','What you doin\' wanderin\' around here?  Why them small fries not in da shackles?!','',26124),
(9420,'enUS','You da strong one now!  All hail to da new king of da Gordok!','',26124),
(9421,'enUS','Um, I\'m taking some prisoners we found outside before the king for punishment.','Um, I\'m taking some prisoners we found outside before the king for punishment.',26124),
(9422,'enUS','Do I see them with weapons still?  Why you let them keep their weapons?!','',26124),
(9423,'enUS','Er... that\'s how I found them.  I wanted to show the king that they were a threat!  Say Captain... I overheard Guard Fengus calling you a fat, useless gnoll lover!','Er... that\'s how I found them.  I wanted to show the king that they were a threat!  Say Captain... I overheard Guard Fengus calling you a fat, useless gnoll lover!',26124),
(9424,'enUS','OK Fengus, where you at?!  You come call me a gnoll lover while I give you da hammer upside da head!','',26124),
(9425,'enUS','Ashes to ashes!','',26124),
(9426,'enUS','BY FIRE BE PURGED!','',26124),
(9427,'enUS','TASTE THE FLAMES OF SULFURON!','',26124),
(9428,'enUS','','Here are the orders, $n.  Take them quickly to Warmaster Garrick!',26124),
(9429,'enUS','Here are the orders, $n.  Now, take them quickly to Field Marshal Teravaine!','',26124),
(9431,'enUS','Tharnariun, I have lost the trap. Could you please give me another?','Tharnariun, I have lost the trap. Could you please give me another?',26124),
(9432,'enUS','Where is Field Marshal Teravaine?','Where is Field Marshal Teravaine?',26124),
(9433,'enUS','Where is Warmaster Garrick?','Where is Warmaster Garrick?',26124),
(9434,'enUS','When our supplies are high, Field Marshal Teravaine is stationed in the Field of Strife, at our southernmost ballista emplacement.','',26124),
(9435,'enUS','','When our supplies are high, Warmaster Garrick is stationed in the Field of Strife at a catapult, north of Iceblood Garrison.',26124),
(9436,'enUS','Where is the Frostwolf Quartermaster?','Where is the Frostwolf Quartermaster?',26124),
(9437,'enUS','Where is the Stormpike Quartermaster?','Where is the Stormpike Quartermaster?',26124),
(9438,'enUS','The Stormpike Quatermaster keeps his supplies under an awning, just west of here.','',26124),
(9439,'enUS','','The Frostwolf Quartermaster is southwest of this bunker.  Enter the bunker and then exit on the right, you\'ll see the quartermaster a short way down the path.',26124),
(9440,'enUS','Henchmen?  Tribute?','Henchmen?  Tribute?',26124),
(9441,'enUS','It\'s good to be the king!  Now, let\'s get back to what you were talking about before...','It\'s good to be the king!  Now, let\'s get back to what you were talking about before...',26124),
(9442,'enUS','Um, you kill king, yeah?  That means you take his place.  That make you da new boss!  Hail to da king!','',26124),
(9443,'enUS','','Oh the horror! The tragedy! We are on the verge of a breakthrough, yet all could be lost.',26124),
(9444,'enUS','Uh... I sorry I attack you boss.  You no kill me, please OK!?  You da king now, and I help make your tribute better!','',26124),
(9445,'enUS','A cursory examination of the skeletal remains indicates that the flesh was seared off. Quite a grisly sight.','',26124),
(9446,'enUS','I very much doubt that he will have anything to say, stranger...','',26124),
(9447,'enUS','I personally didn\'t mind him. It was the Prince who took exception to a high elf in his domain. Alas, I am not one to question the Prince. In his defense, he did not incinerate Master Winthalus immediately.','',26124),
(9448,'enUS','We most definitely do not need anymore attention drawn to us, stranger. Return to those that sent you in search of the lost master and tell them that nothing could be found. When this is done - and I will know when it is so - return and I shall reveal the secrets of the deceased.','',26124),
(9449,'enUS','Mourn the great loss.','Mourn the great loss.',26124),
(9450,'enUS','Our forces are poised for battle, and eager to spill the blood of the Alliance.  Soon our captain will enter Iceblood Garrison and the war will begin anew!','',26124),
(9451,'enUS','So, now that I\'m the king... what have you got for me?!','So, now that I\'m the king... what have you got for me?!',26124),
(9452,'enUS','Maybe you do better at getting back prized Gordok relic from creepy Highborne prince than da old boss did!','',26124),
(9453,'enUS','So... you wouldn\'t happen to have a chest around here that has, let\'s say, a gauntlet that the Gordok ogres consider to be a priceless artifact?','So... you wouldn\'t happen to have a chest around here that has, let\'s say, a gauntlet that the Gordok ogres consider to be a priceless artifact?',26124),
(9454,'enUS','Even if I did, fool, do you think I\'d just let you take it from me?  The only way you\'d ever get it - if I did possess it - is to pry it from my cold, dead fingers.$B$BThat, my little friend, will not be happening any time soon.','',26124),
(9455,'enUS','Hail to da new king!','',26124),
(9456,'enUS','When I scowled at you before you became da new king... um... I was just joking.$B$BYeah!','',26124),
(9457,'enUS','Dem other ogres was dumb to attack you, boss!  Dat\'s why I\'m still alive - I\'m smart and stuff!','',26124),
(9458,'enUS','We a lot cleaner than da ogres in Tanaris.  All over da desert as far as da eye can see - ogre poo.  Not here, no $g sir : ma\'am;!','',26124),
(9459,'enUS','So long as you stay here with us, you da king.  You take off, and some other ogre will take your place.  That\'s da way of da Gordok!','',26124),
(9460,'enUS','I am so smart!  S-M-R-T!','',26124),
(9461,'enUS','Old king got dead?  That\'s unpossible!','',26124),
(9462,'enUS','I cause you no trouble, boss.','',26124),
(9463,'enUS','Oh dear, where is the \"Codex of Defense?\" Lydros will be most assuredly displeased.','',26124),
(9464,'enUS','%s sighs.','',26124),
(9465,'enUS','\"The Arcanist\'s Cookbook\" is also gone! This is a disaster!','',26124),
(9466,'enUS','Books have been disappearing as of late. The Lorekeeper and his assistants are in a frenzy. They suspect foul play within Eldre\'Thalas.','Books have been disappearing as of late. The Lorekeeper and his assistants are in a frenzy. They suspect foul play within Eldre\'Thalas.',26124),
(9467,'enUS','Has the Prince recanted the tale of the Ashbringer? It is our most favorite of his stories. His favorite is the followup to the Ashbringer. Of course, nobody has ever been able to get that story out of him.','Has the Prince recanted the tale of the Ashbringer? It is our most favorite of his stories. His favorite is the followup to the Ashbringer. Of course, nobody has ever been able to get that story out of him.',26124),
(9468,'enUS','I suspect that the imps are stealing knowledge.','I suspect that the imps are stealing knowledge.',26124),
(9469,'enUS','The Master holds great interest in the lair of Nefarian. If only someone would defeat the dragon and his minions and retell the tale to the Prince. I bet that would loosen the Prince\'s lips. The Ashbringer could be found!','The Master holds great interest in the lair of Nefarian. If only someone would defeat the dragon and his minions and retell the tale to the Prince. I bet that would loosen the Prince\'s lips. The Ashbringer could be found!',26124),
(9470,'enUS','If you not talk to Mizzle, you not become da king!  Talk to Mizzle da Crafty!','',26124),
(9471,'enUS','So... you took out the King eh?  I knew that these bozos would make you the new king, I just knew it!  That\'s all these bozos understand - power.$B$BIt would seem that the more henchmen you keep alive, the higher your tribute will be.  Not to shabby - makes for an interesting challenge I\'d say.  If you leave, I wouldn\'t expect to remain king.  One of these yokels will no doubt step up and take your place.$B$BOne more thing... you didn\'t happen to find my key, did you?','',26124),
(9472,'enUS','The king is dead - OH NOES!  Summon Mizzle da Crafty!  He knows what to do next!','',26124),
(9473,'enUS','What you must understand is that being able to index 10,000 years of existence has given me a rather unique perspective on life. Your present day trials and tribulations are meaningless.','',26124),
(9474,'enUS','Oh the drama and fuss the young Master exerted. You would think the fate of the world rested squarely on his shoulders. Only mortals could have such a skewed perspective on our world.$B$BAlas, he left me with his meager magical secrets... Librams or some such nonsense. I have no use for these paultry magics but perhaps you might be interested in their enchantments.','',26124),
(9475,'enUS','Where is \"Garona: A Study in Stealth and Treachery!\" These texts must be returned! ','',26124),
(9476,'enUS','They\'ve been stolen, $r! Three of our most prized volumes. Should you return the tomes, a reward will most certainly be yours.','',26124),
(9477,'enUS','%s begins to retaliate all attacks against him!','',26124),
(9478,'enUS','Help me crush these punys!','',26124),
(9479,'enUS','I guess so!','I guess so!',26124),
(9480,'enUS','This sounds like a task worthy of the new king!','This sounds like a task worthy of the new king!',26124),
(9481,'enUS','You no challenge me, scrubs!  I\'m da king now, and I stay king FOREVER!!!','',26124),
(9482,'enUS','Doh!','',26124),
(9483,'enUS','<You cannot comprehend any of the technical mumbo jumbo on this scroll.>','',26124),
(9484,'enUS','<Drawn out on this parchment is the schematic for a field repair robot.>','',26124),
(9485,'enUS','<Copy the schematic into your engineering notebook.>','<Copy the schematic into your engineering notebook.>',26124),
(9486,'enUS','<The complicated schematics are too much for your meager engineering talents to discern.>','',26124),
(9487,'enUS','<You are well versed in the creation and function of this robot.>','',26124),
(9488,'enUS','The fabric of which our world is woven is most delicate. It merely takes some knowledge and the application of said knowledge to tear the fabric. It is thusly that rifts are born. ','',26124),
(9489,'enUS','%s senses your presence and opens a nether portal!','',26124),
(9490,'enUS','Cho\'Rush die! NOW YOU DIE!','',26124),
(9491,'enUS','People of da Horde, citizens of Orgrimmar, come an\' gather round an\' celebrate a hero of da  Horde. On dis day, $n laid a mortal blow against da Black Dragonflight. Da brood mother, Onyxia, been slain!','',26124),
(9492,'enUS','Bear witness to da undeniable power of ya Warchief! Be lifted by da rallying cry of da dragon slayers!','',26124),
(9493,'enUS','Gaze upon the enemy, $r. See what the might of the Horde reduces even the most powerful of dragons to! All that oppose us shall meet a similar fate!','',26124),
(9494,'enUS','We be horde, all of us. Tauren, orc, troll, an\' all da rest. Never forget dat we in dis together.','',26124),
(9495,'enUS','Citizens and allies of Stormwind, on this day, history has been made. $n has laid waste to that which had attempted to usurp the rule of the kingdom. Gather round and join me in honoring our heroes.','',26124),
(9496,'enUS','Behold the might of the Alliance! The dread lady, Onyxia, hangs from the arches! Let the rallying cry of the dragon slayer lift your spirits!','',26124),
(9497,'enUS','I live only to serve our King.','',26124),
(9498,'enUS','Perhaps one day, your contributions to the Alliance will be as great as the heroes you have seen this day. Honor them, $n.','',26124),
(9499,'enUS','You honor us with your presence, my $glord:lady;.','',26124),
(9500,'enUS','That will teach you to lay off the herb, $r.','',26124),
(9501,'enUS','Holy Cow!  That is Mushgog down there in The Maul.','Holy Cow!  That is Mushgog down there in The Maul.',26124),
(9502,'enUS','Look at that!  Someone is fighting Mushgog!','Look at that!  Someone is fighting Mushgog!',26124),
(9503,'enUS','Can that be The Razza down there in the Maul?  This is going to be exciting!','Can that be The Razza down there in the Maul?  This is going to be exciting!',26124),
(9504,'enUS','Woohoo! They are into it now!','Woohoo! They are into it now!',26124),
(9505,'enUS','The Razza just made more fertilizer for Mushgog!','The Razza just made more fertilizer for Mushgog!',26124),
(9506,'enUS','It\'s time for the main event!  Skarr the Unbreakable is in the Maul!','It\'s time for the main event!  Skarr the Unbreakable is in the Maul!',26124),
(9507,'enUS','Looks like Skarr has found his next challenger!  Wouldn\'t want to be in that poor fool\'s shoes!','Looks like Skarr has found his next challenger!  Wouldn\'t want to be in that poor fool\'s shoes!',26124),
(9508,'enUS','Down goes Frazier!  Down goes Frazier! Down goes...huh?  That wasn\'t Frazier?','Down goes Frazier!  Down goes Frazier! Down goes...huh?  That Wasn\'t Frazier?',26124),
(9509,'enUS','10,000 years of recorded knowledge tends to draw the wrong element to the Athenaeum. Books are stolen, recovered and stolen again on a daily basis.','',26124),
(9510,'enUS','','Kildrath tends to overdramatize the situation. For example, \"Garona: A Study on Stealth and Treachery,\" has been stolen over 400 times.$B$BThe mark of the Athenaeum protects the tomes, preventing any unauthorized viewings.',26124),
(9511,'enUS','','%s sighs.',26124),
(9512,'enUS','','When will they learn?',26124),
(9513,'enUS','','Imbecile! Have you not learned the Dewey Decimal System? It has been 3,000 years since you began working for us! Incompetent buffoon.',26124),
(9514,'enUS','%s grumbles.','',26124),
(9515,'enUS','I will not be lured from this place.','',26124),
(9516,'enUS','<Lydros reaches into his robe and presents you with a dull, flat elven blade.>$B$BIn ages past, well before even the War of the Ancients, there existed this blade.','',26124),
(9517,'enUS','Fascinating, Lorekeeper. Continue please.','Fascinating, Lorekeeper. Continue please.',26124),
(9518,'enUS','The blade itself had to be crafted in ceremony with the children of the Aspects. A rare occurrence indeed... For not only would a dragon have to willingly heat and mold the enchanted metal with their breath, they would also need to contain the fury of their own enchantment by using their blood as temper.\n','',26124),
(9519,'enUS','(Continue.)','(Continue.)',26124),
(9520,'enUS','Over the course of 8,000 years, only a handful of these blades were created - each blade unique in both power and appearance. The blades of Quel\'Serrar would take on the characteristics of their creator.','',26124),
(9521,'enUS','(Continue.)','(Continue.)',26124),
(9522,'enUS','Rumors exist of a single, legendary blade of Quel\'Serrar crafted for an unknown entity by the combined might of the five Aspects. Before the abominations of Nefarian and Deathwing were thrust into our world, such meetings of the Aspect were represented by the term \'Prismatic.\' I could only assume that the Prismatic Blade of Quel\'Serrar was a most glorious creation.\n','',26124),
(9523,'enUS','(Continue.)','(Continue.)',26124),
(9524,'enUS','What I offer to you now is one such blade, unfired, unheated, untreated - the most raw and basic form.$B$BNow you merely need to find a dragon that will willingly enchant the blade.$B$BIf you had an eternity to live, this might be a possibility; but since you are mortal and could very likely cease to exist at any moment, might I recommend trying to persuade one of the lesser dragons to do your bidding. ','',26124),
(9525,'enUS','Eh?','Eh?',26124),
(9526,'enUS','Have you heard of the brood mother of the Black Flight? I believe she is called Onyxia...','',26124),
(9527,'enUS','Maybe... What do I do now?','Maybe... What do I do now?',26124),
(9528,'enUS','I have no time for interruptions.','',26124),
(9529,'enUS','Lexlort, I lost the thorium shackles.','Lexlort, I lost the thorium shackles.',26124),
(9530,'enUS','Nathanos, I have lost the rotten apple. I require another.','Nathanos, I have lost the rotten apple. I require another.',26124),
(9531,'enUS','Can I help you?','',26124),
(9532,'enUS','I\'ve lost the cure, Doc! Tell me you got more!!!','I\'ve lost the cure, Doc! Tell me you got more!!!',26124),
(9533,'enUS','Serge I have lost the cure to the Touch of Zanzil! HELP!','Serge I have lost the cure to the Touch of Zanzil! HELP!',26124),
(9534,'enUS','Have you ever heard of a place called Dire Maul?','Have you ever heard of a place called Dire Maul?',26124),
(9535,'enUS','Aye, but I know it by its true name - Eldre\'Thalas.  It was a bastion of magical power for the night elves many, many years ago.$B$BYou know of Eldre\'Thalas, young one?  One might say that is coincidental to my current plight... but I am one not to believe in coincidence.','',26124),
(9536,'enUS','Why do you say that this is a coincidence, Rabine?','Why do you say that this is a coincidence, Rabine?',26124),
(9537,'enUS','Agents of the Cenarion Circle have uncovered disturbing information pertaining to the current situation in Eldre\'Thalas.  I am at an impasse as to what to do about it, and I will no doubt soon seek the aid of able bodied beings capable of handling themselves in a fight.$B$BTo properly take action in Eldre\'Thalas, however, is to understand the lore of an object known as the Fruit of Fertility.','',26124),
(9538,'enUS','The Fruit of Fertility?','The Fruit of Fertility?',26124),
(9539,'enUS','In ages past, Eldre\'Thalas was a nexus of magical power, and those who dwelt within its hallowed halls wielded immense power.  One such night elf was Millicent Serene - a naturalist who willed the power of nature itself into potent artifacts she forged.$B$BThe Fruit of Fertility was her crowning achievement... she used a specially prepared moonwell to grow an exotic and vibrant vine that was imbued with an aura of protection and growth.  All of Eldre\'Thalas flourished from its existence.','',26124),
(9540,'enUS','But something went wrong, didn\'t it?','But something went wrong, didn\'t it?',26124),
(9541,'enUS','Alas, it always seems like it does.  I - as did the rest of the Cenarion Circle - had assumed that Milli\'s creation was destroyed during the War of the Ancients.  This, as I have come to learn, is far from correct.$B$BThe Fruit of Fertility survived... though now it is known as the Felvine.  It is being corrupted by the demonic lord of that section of Eldre\'Thalas, Alzzin the Wildshaper.','',26124),
(9542,'enUS','What would happen if the Fruit of Fertility - or the Felvine - was allowed to be fully corrupted?','What would happen if the Fruit of Fertility - or the Felvine - was allowed to be fully corrupted?',26124),
(9543,'enUS','I... cannot begin to imagine, $n.  All I know is that I am not going to allow it to happen.  It will be destroyed - if not for our continued safety from demonic taint, then for the memory of Millicent Serene... Milli...$B$BThis, my friend, this is where I hope you will come in.','',26124),
(9544,'enUS','What would you have me do, Rabine?','What would you have me do, Rabine?',26124),
(9545,'enUS','Speak with me, $n - if you are willing, the Cenarion Circle would eagerly accept your generous offer of aid.  The threat posed by the Felvine of Eldre\'Thalas is indeed dire.','',26124),
(9546,'enUS','<Demitrian falls to his knees.>$B$BYou have recovered my Master\'s eternal prison!$B$BOh long have I waited for this day and finally, it is realized.$B$BHe must be released!','',26124),
(9547,'enUS','What must be done?','What must be done?',26124),
(9548,'enUS','I hold the vessel of his rebirth. Should you be prepared to take on this task, you will be required to fortify the vessel and ultimately, break the hold of Ragnaros himself!','',26124),
(9549,'enUS','The Firelord and all who dare stand in my way shall reel from my wrath.','The Firelord and all who dare stand in my way shall reel from my wrath.',26124),
(9550,'enUS','The vessel of rebirth must be fortified with elementium. I know of only one source of the mineral: the elemental planes, at the core of our world.$B$BThere is one, an Earthshaper, who may know more than I about the acquisition of such things. You must find this Earthshaper!','',26124),
(9551,'enUS','Greetings and salutations, hero!  I have the latest news from both continents and points beyond for your consideration.','Greetings and salutations, hero!  I have the latest news from both continents and points beyond for your consideration.',26124),
(9552,'enUS','I shall scour the earth for this Earthshaper. What of the essence?','I shall scour the earth for this Earthshaper. What of the essence?',26124),
(9553,'enUS','The corporeal form of Ragnaros must be destroyed. From the remnants, his essence shall emerge. In this weakened state, Ragnaros\' grip on the prison of Thunderaan is loosed. The essence itself acting as a key...','',26124),
(9554,'enUS','Give me the vessel, Highlord.','Give me the vessel, Highlord.',26124),
(9555,'enUS','You will need to find Nat Pagle in Dustwallow Marsh to get any better than you are currently.','You will need to find Nat Pagle in Dustwallow Marsh to get any better than you are currently.',26124),
(9556,'enUS','You will need to find Nat Pagle in Dustwallow Marsh to get any better than you are currently.','You will need to find Nat Pagle in Dustwallow Marsh to get any better than you are currently.',26124),
(9557,'enUS','I can teach you fishing skills.','I can teach you fishing skills.',26124),
(9558,'enUS','Your challenge has failed!','',26124),
(9559,'enUS','Where can I go to improve my lockpicking?','Where can I go to improve my lockpicking?',26124),
(9560,'enUS','Bluegill Marsh north of Menethil Harbor in the Wetlands holds many locked boxes from the wrecks offshore that have washed ashore.','Bluegill Marsh north of Menethil Harbor in the Wetlands holds many locked boxes from the wrecks offshore that have washed ashore.',26124),
(9561,'enUS','The waters of northern Sar\'theris Strand in Desolace or the Angor Fortress in Badlands have locked boxes that can be picked open.','The waters of northern Sar\'theris Strand in Desolace or the Angor Fortress in Badlands have locked boxes that can be picked open.',26124),
(9562,'enUS','The Pool of Tears in the Swamp of Sorrows holds ancient locked boxes that were lost in another age.','The Pool of Tears in the Swamp of Sorrows holds ancient locked boxes that were lost in another age.',26124),
(9563,'enUS','The Dark Iron dwarves of the Slag Pit in Searing Gorge have a great number of locked boxes.','The Dark Iron dwarves of the Slag Pit in Searing Gorge have a great number of locked boxes.',26124),
(9564,'enUS','Both Lost Rigger Cove in Tanaris and the Bay of Storms in Azshara have boxes that can be picked to improve your skill.','Both Lost Rigger Cove in Tanaris and the Bay of Storms in Azshara have boxes that can be picked to improve your skill.',26124),
(9565,'enUS','The Scarlet Crusade of Tyr\'s Hand in the Eastern Plaguelands have many lockboxes that will challenge your skill.','The Scarlet Crusade of Tyr\'s Hand in the Eastern Plaguelands have many lockboxes that will challenge your skill.',26124),
(9566,'enUS','Many locked boxes of supplies were sunk by the orcs in Lake Everstill in Redridge.','Many locked boxes of supplies were sunk by the orcs in Lake Everstill in Redridge.',26124),
(9567,'enUS','Many locked supply boxes were lost when the Naga overran the Zoram Strand in Ashenvale.','Many locked supply boxes were lost when the Naga overran the Zoram Strand in Ashenvale.',26124),
(9568,'enUS','The Venture Company based around Windshear Crag in Stonetalon keeps their supplies in locked boxes.','The Venture Company based around Windshear Crag in Stonetalon keeps their supplies in locked boxes.',26124),
(9569,'enUS','The Syndicate keeps many locked boxes of supplies in Durnholde Keep in Hillsbrad.   ','The Syndicate keeps many locked boxes of supplies in Durnholde Keep in Hillsbrad.   ',26124),
(9570,'enUS','Well done, servant. For so long I have been held captive within the prison of the Firelord. I am once more free to feast upon the out world! The land shall once more be ravaged by the force of the Wind Seeker!','',26124),
(9571,'enUS','Ah, and the fool who freed me shall be among the first to quell my immense hunger.','',26124),
(9572,'enUS','My power is discombobulatingly devastating! It is ludicrous that these mortals even attempt to enter my realm!\n','',26124),
(9573,'enUS','<Demitrian laughs.>$B$BYour reward is a quick and painful death, fool!','',26124),
(9574,'enUS','Summon forth your cowardly master, fool! Let him face me!','Summon forth your cowardly master, fool! Let him face me!',26124),
(9575,'enUS','I study the known and unknown elements of our world.','',26124),
(9576,'enUS','Are you the Earthshaper capable of creating Elementium?','Are you the Earthshaper capable of creating Elementium?',26124),
(9577,'enUS','Elementium? I have not heard that word uttered from the mouth of a mortal in decades.','',26124),
(9578,'enUS','What do you know of it, Franzahl?','What do you know of it, Franzahl?',26124),
(9579,'enUS','A former student of mine by the name of Krixix spent a lifetime attempting to make contact with the chained Gods of the underworld. He pursued that which would spring up from the ravaged earth... That which would form only as a result of the elements clashing in titanic conflict.$B$BElementium as it would be known to mortals.$B$BOne day, nearly a decade ago, Krixix\'s pursuit lead to a fissure forming in this very gorge.','',26124),
(9580,'enUS','A fissure?','A fissure?',26124),
(9581,'enUS','Aye, he had done what was thought to be impossible. Out from the fissure sprung an agent of Therazane!$B$BFrom my vantage point, I could see the goblin holding conversation with the agent of the Old God. What happened after that was terrible...','',26124),
(9582,'enUS','So what happened?','So what happened?',26124),
(9583,'enUS','The fissure closed and Krixix was gone! Swallowed whole!$B$BBe warned, $r, what you wish for could very well become that which you do not want. You play with beings and arcana that are older than time itself!$B$BShould Krixix be alive and should he have the information which you seek, you can be certain that he will not give up said information. He has faced terrors far worse than you could ever dream to perpetrate.','',26124),
(9584,'enUS','There comes a time when the life we know falls short.  We are trapped and look for answers, and we find hope burning in dark places.$B$BOnly then, $n, do we take our first steps to freedom.','',26124),
(9585,'enUS','Do you have any spiders or beetles, $c?  They scurry fast, but if you\'re faster then you\'ll find them quite a treat!','',26124),
(9586,'enUS','Gorzeeki, I wish to make a purchase.','Gorzeeki, I wish to make a purchase.',26124),
(9587,'enUS','Did you just come out of a dungeon?  Did you get me anything?','',26124),
(9588,'enUS','Your armor looks scary.  Are you scary too?','',26124),
(9589,'enUS','I cannot permit you to enter the Temple!  I must destroy you for your own good!','',26124),
(9590,'enUS','A sacrifice will be due if I am ever called upon, mortal...','',26124),
(9591,'enUS','If I fall into the abyss, I\'ll take all of you mortals with me!','',26124),
(9592,'enUS','%s flee as the controlling power of the orb is drained.','',26124),
(9593,'enUS','When I grow up, I wanna be the king of Stormwind!','',26124),
(9594,'enUS','I\'ve been to Ironforge before.  It smells funny there.','',26124),
(9595,'enUS','Mushrooms always grow in damp places and so they look like umbrellas.','',26124),
(9596,'enUS','If overalls are held up by the snaps at the top, then why do they have belt loops?','',26124),
(9597,'enUS','What happens if your snot freezes in your nose?','',26124),
(9598,'enUS','Do fish ever get thirsty?','',26124),
(9599,'enUS','If you try to fail and succeed, what did you just do?','',26124),
(9600,'enUS','If you\'re a real hero of the Horde, then I wanna see you fight a dragon!  Yeah!','',26124),
(9601,'enUS','When lightning strikes the ocean why don\'t all the fish die?','',26124),
(9602,'enUS','Would a fly without wings be called a walk?','',26124),
(9603,'enUS','I have a rock in my nose.','',26124),
(9604,'enUS','If a turtle doesn\'t have a shell, is he homeless or naked?','',26124),
(9605,'enUS','What does \"zug zug\" mean?','',26124),
(9606,'enUS','If your glove is too big, does it still fit like a glove?','',26124),
(9607,'enUS','You are certainly a long way from home, $r.','',26124),
(9608,'enUS','I have come to learn, Daio.','I have come to learn, Daio.',26124),
(9609,'enUS','So, you have found me. I suppose that you have come to learn of suppression and control.$B$BI will teach you much more than that... you will also learn of sacrifice.$B$B<Daio grins.>','',26124),
(9610,'enUS','What would I sacrifice?','What would I sacrifice?',26124),
(9611,'enUS','That will be the choice of the demon you wish to conjure and enslave. We wield dark powers and we pay grossly for the use of said powers.','',26124),
(9612,'enUS','How can I conjure a demon?','How can I conjure a demon?',26124),
(9613,'enUS','We must first craft a prison to confine the beast, if you wish to progress further.','',26124),
(9614,'enUS','I have regained control! Everyone - back to your posts!','',26124),
(9615,'enUS','This is it, Impsy. I can feel it! This is the big one!','',26124),
(9616,'enUS','Brace yourself for the glorious impact, Impsy!','',26124),
(9617,'enUS','Kick me out, will they!? I\'ll show those uptight cone heads in Stormwind the true power of Niby! BEHOLD!','',26124),
(9618,'enUS','%s shakes his fist in frustration.','',26124),
(9619,'enUS','Niby, you are stupid.','',26124),
(9620,'enUS','Oh my, what a surprise! Another failure!? But how, oh great one??','',26124),
(9621,'enUS','Awe inspiring, master. Your ineptitude is awe inspiring.','',26124),
(9622,'enUS','Why you little!','',26124),
(9623,'enUS','Ack! Help! Crazed gnome trying to kill me!','',26124),
(9624,'enUS','Bow in my presence, insect! Surely you can feel the power I hold over you.','',26124),
(9625,'enUS','I am in search of a great and powerful Warlock.','I am in search of a great and powerful Warlock.',26124),
(9626,'enUS','So you have come to Niby to learn the secrets of calling down an infernal servant from the Nether.$B$BSilence! Niby knows all!$B$BNiby is not so quick to part with such knowledge. First, you must assist Niby with a very important task.','',26124),
(9627,'enUS','What task?','What task?',26124),
(9628,'enUS','There is a powerful infernal named Kroshius northeast of this camp. It is why Niby is here. Kroshius is a greater infernal - an infernal that has lasted longer than expected. You see, nub, an infernal crashes down into the earth with great intensity to serve its master but this intensity fades fast. Once the blazing flames have died down, the infernal crumbles.','',26124),
(9629,'enUS','This is all very interesting but what is it that you want?','This is all very interesting but what is it that you want?',26124),
(9630,'enUS','Do not interrupt Niby, fool! I shall rend the flesh from your bones and use your skeletal remains as a coat rack. Now where was I? Oh yes, so, Kroshius lasted nearly ten times longer than any ordinary infernal. I am not sure why but I am confident that with enough study, I could find out.$B$BI need you to recover Kroshius\' Infernal Core.','',26124),
(9631,'enUS','How do I do that?','How do I do that?',26124),
(9632,'enUS','If I am to teach you the secrets of summoning an infernal servant, you must destroy Kroshius and bring me the infernal core from his burning remains. This, however, is not as easy as it sounds. Kroshius has all but burned out completely. You must reignite his corpse and raise him from the rubble. To do this, however, you must gather some components from other demonic entities.$B$BMy imp, Impsy, shall set you on your way.','',26124),
(9633,'enUS','Kroshius live? Kroshius crush!','',26124),
(9634,'enUS','Stand back! Stand clear! The infernal will need to be given a wide berth!','',26124),
(9635,'enUS','BOW DOWN TO THE ALMIGHTY! BOW DOWN BEFORE MY INFERNAL DESTRO... chicken?','',26124),
(9636,'enUS','%s rolls on the floor laughing.','',26124),
(9637,'enUS','Niby, you\'re an idiot.','',26124),
(9638,'enUS','Silence, servant! Vengeance will be mine! Death to Stormwind! Death by chicken!','',26124),
(9639,'enUS','A Sulfuron ingot?!??! Impossible! I must have it! I must! I must!$B$B$R, I am authorized to make you a grand deal for that ingot. Perhaps you would be interested to know the secrets of the Hand of Ragnaros? Sulfuras, idiot! The legendary hammer of the Firelord.','',26124),
(9640,'enUS','Hrm, I\'m listening. What is this offer?','Hrm, I\'m listening. What is this offer?',26124),
(9641,'enUS','In exchange for one Sulfuron Ingot, I am authorized to grant you one copy of the plans to forge a Sulfuron hammer.$B$BNow an adventurer like yourself is probably thinking to $g himself:herself;, \"What would I ever need a hammer like that for when what I already own is far superior?\"$B$BWell let me tell you something, $g mister:missy;, there ain\'t nothing more superior than what the Sulfuron hammer can become!','',26124),
(9642,'enUS','You\'ve got my attention.','You\'ve got my attention.',26124),
(9643,'enUS','You see, all you gotta do is forge the Sulfuron hammer and find yourself the Eye of Sulfuras. Combine the Eye of Sulfuras with the Sulfuron hammer and it will become Sulfuras! Now I\'m not going to bog you down with any technical information as to where or how or when you can get an Eye of Sulfuras. I\'m sure you\'ll figure that stuff out. Just sign this here contract so that our agreement is binding and our business will be done.','',26124),
(9644,'enUS','Give me the contract.','Give me the contract.',26124),
(9645,'enUS','PEASANT CROSSES LINE.','PEASANT CROSSES LINE.',26124),
(9646,'enUS','YOU ARE THE WINNER!','YOU ARE THE WINNER!',26124),
(9647,'enUS','YOU ARE THE LOSE!','YOU ARE THE LOSER. BOO.',26124),
(9648,'enUS','','I have failed once more...',26124),
(9649,'enUS','','I now return to whence I came, only to find myself here once more to relive the same epic tragedy.',26124),
(9650,'enUS','At last, it ends....','At last, it ends....',26124),
(9651,'enUS','Thank you, kind stranger. May your heroism never be forgotten.','Thank you, kind stranger. May your heroism never be forgotten.',26124),
(9652,'enUS','We shall be reunited once more, my love...','We shall be reunited once more, my love...',26124),
(9653,'enUS','Stranger, find the fallen Prince Menethil and end his reign of terror.','Stranger, find the fallen Prince Menethil and end his reign of terror.',26124),
(9654,'enUS','The power of the light is truly great and merciful.','The power of the light is truly great and merciful.',26124),
(9655,'enUS','','Be healed!',26124),
(9656,'enUS','','There are costs with war, $c... ones often overlooked.  Those costs are the orphans - children who have lost their parents to the far-too-numerous conflicts that rage across Azeroth.  Those children who have no one else to turn to often come here to live until they are old enough to fend for themselves.$B$BOne week out of the year during the Spring, the Horde takes time to give something back to these innocents.  This time is called Children\'s Week.\n',26124),
(9658,'enUS','Tiny mortals - me HERE! Doom you meet!','',26124),
(9659,'enUS','','There are costs with war, $c... ones often overlooked.  Those costs are the orphans - children who have lost their parents to the far-too-numerous conflicts that rage across Azeroth.  Those children who have no one else to turn to often come here to live until they are old enough to fend for themselves.$B$BOne week out of the year during the Spring, the Alliance takes time to give something back to these innocents.  This time is called Children\'s Week.\n',26124),
(9660,'enUS','What?!  You no can beat me!  Me will return!','',26124),
(9661,'enUS','You have not seen the last of me fools!  All shall be consumed in the end!','',26124),
(9662,'enUS','Hear me, denizens of the Crater!  I come to burn this land of its impurity!','',26124),
(9663,'enUS','Lady Jaina, this may sound like an odd request... but I have a young ward who is quite shy.  You are a hero to him, and he asked me to get your autograph.','Lady Jaina, this may sound like an odd request... but I have a young ward who is quite shy.  You are a hero to him, and he asked me to get your autograph.',26124),
(9664,'enUS','You will all pay dearly when I return from the depths!','',26124),
(9665,'enUS','','Why... that is very sweet of you.  I gather that you are volunteering time for Children\'s Week, yes $c?  Well, you are to be commended.  It is imperative that we remember those less fortunate - especially the children.$B$BI\'d be happy to sign an autograph.  Here you go.',26124),
(9666,'enUS','This frozen land shall suffice for a start.  Come to me, mortals - and I shall give you a quick and painful death.','',26124),
(9667,'enUS','Greetings young one, and welcome to Thunder Bluff.  You\'ll find safe refuge from the burdens of the world here.  All denizens of the Horde are welcome here.$B$BThe spirits of the present and past come alive here in this sacred place, my friend.  Honor them, and in doing so honor yourself.','',26124),
(9668,'enUS','%s dissipates into the ether, his howling winds still ringing in your ears.','',26124),
(9669,'enUS','%s and his invading forces appear amidst a tumultuous conflagration in the northwest of Silithus.','',26124),
(9670,'enUS','Chief Bloodhoof, this may sound like an odd request... but I have a young ward who is quite shy.  You are a hero to him, and he asked me to get your hoofprint.','Chief Bloodhoof, this may sound like an odd request... but I have a young ward who is quite shy.  You are a hero to him, and he asked me to get your hoofprint.',26124),
(9671,'enUS','Ah, a young warrior to be no doubt!  I take it you are participating in Children\'s Week, yes?  It warms these weary bones to hear that you are setting the example by which others will be sure to follow.$B$BI\'d be delighted to oblige you and the young lad.  Hrmm... what advice should I give to him?  Listen to the spirits, yes... maybe something about eating all of his vegetables too...','',26124),
(9672,'enUS','Children\'s Week is not yet over... may I have another Orphan Whistle?','Children\'s Week is not yet over... may I have another Orphan Whistle?',26124),
(9673,'enUS','You be too scared!  Me find you!','',26124),
(9674,'enUS','If you mortals are all so craven, this will be easier than I thought!','',26124),
(9675,'enUS','Well what do you know, this is Children\'s Week!  What can I do to help?','Well what do you know, this is Children\'s Week!  What can I do to help?',26124),
(9676,'enUS','Where are the so-called heroes of this world?  Too frightened to come out and play?','',26124),
(9677,'enUS','','Become a mentor for one of our orphans during the Week of the Wardens!  Huzzah!\n',26124),
(9678,'enUS','','Become a mentor for one of our orphans during the Week of the Wardens!  For the Horde!',26124),
(9679,'enUS','%s causes a gale to sweep across the land, the sound of his mindless fury coming from the northwest.','',26124),
(9680,'enUS','I won\'t make it... go... go on without me...','I won\'t make it... go... go on without me...',26124),
(9681,'enUS','The pain is unbearable!','The pain is unbearable!',26124),
(9682,'enUS','Should I live through this, I shall make it my life\'s sole ambition to destroy Arthas...','Should I live through this, I shall make it my life\'s sole ambition to destroy Arthas...',26124),
(9683,'enUS','Death take me! I cannot go on! I have nothing left...','Death take me! I cannot go on! I have nothing left...',26124),
(9684,'enUS','Seek out Shandrina in Silverwind Refuge.  She can sell you the \"Expert Cookbook\".','Seek out Shandrina in Silverwind Refuge.  She can sell you the \"Expert Cookbook\".',26124),
(9685,'enUS','Cooking is a lifelong pursuit and I see we share the same passion!','Cooking is a lifelong pursuit and I see we share the same passion!',26124),
(9686,'enUS','Dirge Quikcleave of Gadgetzan is a master of the culinary arts.  To better yourself you will need to seek him out.','Dirge Quikcleave of Gadgetzan is a master of the culinary arts.  To better yourself you will need to seek him out.',26124),
(9687,'enUS','Wulan in Shadowprey Village can sell you the \"Expert Cookbook\".  You will need that if you are to better yourself.','Wulan in Shadowprey Village can sell you the \"Expert Cookbook\".  You will need that if you are to better yourself.',26124),
(9688,'enUS','I can teach you how to cook!','I can teach you how to cook!',26124),
(9689,'enUS','','It\'s so sad for you poor children.',26124),
(9690,'enUS','','Now children stop that!  I mean it!',26124),
(9691,'enUS','','All will be well children.  The Light shall see to that!',26124),
(9692,'enUS','','I believe you children are our future...',26124),
(9693,'enUS','','You are mine now, children.  You will grow up to be a strong part of the Horde!',26124),
(9694,'enUS','','Stop whining!',26124),
(9695,'enUS','','Clean this place up! We will not live in such squalor.',26124),
(9696,'enUS','','It\'s my way or the Gold Road.  Is that understood?',26124),
(9697,'enUS','Only the renowned Doctor Gregory Victor can improve your skill now.  He can be found in Arathi Highlands at Hammerfall.','Only the renowned Doctor Gregory Victor can improve your skill now.  He can be found in Arathi Highlands at Hammerfall.',26124),
(9698,'enUS','Balai Lok\'Wein of Brackenwall Village in Dustwallow Marsh sells a manual that you will need to study in order to improve your skills!','Balai Lok\'Wein of Brackenwall Village in Dustwallow Marsh sells a manual that you will need to study in order to improve your skills!',26124),
(9699,'enUS','The esteemed Doctor Gustaf VanHowzen can train you further.  He can be found in Theramore treating the wounded at the barracks.','The esteemed Doctor Gustaf VanHowzen can train you further.  He can be found in Theramore treating the wounded at the barracks.',26124),
(9700,'enUS','I\'ve heard it said that Deneb Walker, holed up in Stromgarde, has a book that is sure to help improve your First Aid techniques.','I\'ve heard it said that Deneb Walker, holed up in Stromgarde, has a book that is sure to help improve your First Aid techniques.',26124),
(9701,'enUS','I can train you in First Aid techniques.','I can train you in First Aid techniques.',26124),
(9702,'enUS','Well duties call, yes?  First, the bell... to give you vigor!','',26124),
(9703,'enUS','Next, I\'ll place the wheel... to protect you from harm.','',26124),
(9704,'enUS','And finally the candle... to burn those who would thwart you!','',26124),
(9705,'enUS','Ah, freedom!  Although brief, so sweet it is...','',26124),
(9706,'enUS','$n, my duties are complete and I shall now take my leave.  Luck to you my $gfellow:lady;, and remember to keep the Bell, Wheel and Candle working!','',26124),
(9707,'enUS','','Praise the Light, one has finally answered the calling.',26124),
(9708,'enUS','But wait...','',26124),
(9709,'enUS','$n, summon me again when you need to perform the ritual again.','',26124),
(9710,'enUS','Until then, I shall take my leave...','',26124),
(9711,'enUS','','Too many have fallen, $g priest:priestess;. You must focus!',26124),
(9712,'enUS','The Scourge are upon us! Run! Run for your lives!','The Scourge are upon us! Run! Run for your lives!',26124),
(9713,'enUS','Please help us! The Prince has gone mad!','Please help us! The Prince has gone mad!',26124),
(9714,'enUS','Seek sanctuary in the Hearthglen! It is our only hope!','Seek sanctuary in the Hearthglen! It is our only hope!',26124),
(9715,'enUS','Stratholme is no more! The city lies in ruins. The Prince consumed by hatred... madness...','Stratholme is no more! The city lies in ruins. The Prince consumed by hatred... madness...',26124),
(9716,'enUS','The Eye led me here, Eris.','The Eye led me here, Eris.',26124),
(9717,'enUS','','<Eris nods.>$B$BThe Eye has seen so many horrors and so many wonders.$B$BIt displays what it feels the one looking into it is most suited to see.',26124),
(9718,'enUS','And I was suited to see this?','And I was suited to see this?',26124),
(9719,'enUS','','You were. The Eye is never wrong.$B$BYou are a $g priest:priestess;, after all. A powerful $g priest:priestess;, if the Eye showed you this horrible memory.$B$BYou have come for redemption, yet you yourself do not even realize this... Do you?',26124),
(9720,'enUS','I really did not know what to expect, Eris. I will use my powers to assist you if that is what is asked of me.','I really did not know what to expect, Eris. I will use my powers to assist you if that is what is asked of me.',26124),
(9721,'enUS','','I know you will, $n.$B$BI myself am a priestess, though, unlike you I am long since gone from this world. My spirit, however, remains here, as do the spirits of the thousands who were brutally slain by the mad Prince, Arthas Menethil and his legion of undeath.',26124),
(9722,'enUS','Those days are over, Eris.','Those days are over, Eris.',26124),
(9723,'enUS','','I never stated that you were here to redeem yourself, $g priest:priestess;. You are here to redeem me and the innocents murdered while trying to escape Stratholme.$B$BMy spirit and the spirit of those lost are bound here, cursed to endlessly relive our own tragic deaths.',26124),
(9724,'enUS','So what can I do to help?','So what can I do to help?',26124),
(9725,'enUS','','You must do what I could not: Save the peasants that were cut down while fleeing from Stratholme.$B$BThey will walk towards the light, you must ensure their survival. Should too many fall, our cursed existence shall continue - you will have failed.$B$BEvery ability, prayer, and spell that you have learned will be tested. May the Light protect you, $n.',26124),
(9726,'enUS','You dare interfere with this being\'s test? The battle must be fought alone! You shall all suffer for this indiscretion.','',26124),
(9727,'enUS','Who dares steal my precious mount?  You will pay for your insolence, mortal!','',26124),
(9728,'enUS','','We are saved! The peasants have escaped the Scourge!',26124),
(9729,'enUS','The spirit of the Dreadsteed pulses with rage.','',26124),
(9730,'enUS','Arrr, Me Hearties!   I be havin\' some extra Treasure that I be givin\' away at the Gurubashi Arena!  All ye need do to collect it is open the chest I leave on the arena floor!','',26124),
(9731,'enUS','Let the Bloodletting Begin!','',26124),
(9732,'enUS','%s recoils in pain as the Judgment of Wisdom washes over it!','',26124),
(9733,'enUS','The ways of Jaedenar are dark and treacherous.  Watch your moves in this place, $C, or you will find your soul entralled by your rivals...','',26124),
(9734,'enUS','I wish to purchase from you.','I wish to purchase from you.',26124),
(9735,'enUS','You dog!  Now I\'ll trap your soul into a shard and give you to my imp as a plaything!','',26124),
(9736,'enUS','Be gone!  I hold counsel with Dreadlords, and the matters we discuss are not your concern!','',26124),
(9737,'enUS','Dreadlords?  Perhaps you mean Lord Banehollow.  He sends his regards, and has a message for you...','Dreadlords?  Perhaps you mean Lord Banehollow.  He sends his regards, and has a message for you...',26124),
(9738,'enUS','... A message from Banehollow?  What message is that?  Does he have need of his great advisor and servant, Ulathek?  Does he require my presence?','',26124),
(9739,'enUS','No, Ulathek.  He knows your secret.  He knows you plot with Lord Hel\'nurath of Xoroth.','No, Ulathek.  He knows your secret.  He knows you plot with Lord Hel\'nurath of Xoroth.',26124),
(9740,'enUS','What?  But how?  No!  This is not possible!  I have been so careful... he could not know!$B$BYou lie!  You lie, and now you\'ll die for your deceit!','',26124),
(9741,'enUS','It\'s no lie, traitor.  Banehollow wants your heart, and I\'m going to get it for him.','It\'s no lie, traitor.  Banehollow wants your heart, and I\'m going to get it for him.',26124),
(9742,'enUS','I\'m finished.  The parchment is made.  Now, return to Gorzeeki...','',26124),
(9743,'enUS','You are mine, dreadsteed!  Your spirit is now bound to me!','You are mine, dreadsteed!  Your spirit is now bound to me!',26124),
(9744,'enUS','','What a wonderful day to be alive! Look at the beauty that surrounds you, friend. Enjoy what life has to give!',26124),
(9745,'enUS','*GRRRR* *RUFF* *RUFF*','',26124),
(9746,'enUS','Lava? Pay no mind to all of that, friend. Look around you. Take in the joys that nature has to offer.','',26124),
(9747,'enUS','I come to Silithus every year around this time. The weather is phenomenal for my bunions.$B$BYou should take a stroll with me, friend. Enjoy the sights and what not.','',26124),
(9748,'enUS','How wonderful to see another person in this remote region of the world. Come, walk with me. Let our bodies keep each other warm.','',26124),
(9749,'enUS','Officer\'s Lounge','Officer\'s Lounge',26124),
(9750,'enUS','Look for it high up on the west side of the Valley of Strength.','Look for it high up on the west side of the Valley of Strength.',26124),
(9751,'enUS','I know you as Artorius the Doombringer. Show yourself, demon! Face me!','I know you as Artorius the Doombringer. Show yourself, demon! Face me!',26124),
(9752,'enUS','You want the Hall of Legends. It\'s high above the Valley of Strength on the west side.','You want the Hall of Legends. It\'s high above the Valley of Strength on the west side.',26124),
(9753,'enUS','A gnome? How pathetic. Face me, demon!','A gnome? How pathetic. Face me, demon!',26124),
(9754,'enUS','So you are Klinfran the Crazed? Sad, I was expecting an actual challenge. Do you dare face me in your true form?','So you are Klinfran the Crazed? Sad, I was expecting an actual challenge. Do you dare face me in your true form?',26124),
(9755,'enUS','I am not fooled by your disguise, temptress. Your time to die has come.','I am not fooled by your disguise, temptress. Your time to die has come.',26124),
(9756,'enUS','Officers\' Lounge','Officers\' Lounge',26124),
(9757,'enUS','All of a sudden you\'re a \'Defender of the Alliance\' are you?! Well, I suppose you\'ll be wanting to head to the Champions\' Hall now. It\'s over in Old Town.','All of a sudden you\'re a \'Defender of the Alliance\' are you?! Well, I suppose you\'ll be wanting to head to the Champions\' Hall now. It\'s over in Old Town.',26124),
(9758,'enUS','Well, well, moving up in the world are we? You\'re looking for the Champions\' Hall, and you\'ll find it on the southeast end of Old Town. Good luck!','Well, well, moving up in the world are we? You\'re looking for the Champions\' Hall, and you\'ll find it on the southeast end of Old Town. Good luck!',26124),
(9759,'enUS','','%s laughs at your foolish request.',26124),
(9760,'enUS','','As you wish, $c.',26124),
(9761,'enUS','','Do I look like a fool, mortal? Because only a fool would remain here and do battle with you and all of your allies. Perhaps another time... Should you ever find the courage to back up your banter.',26124),
(9762,'enUS','','%s is silenced by the venomous sting.',26124),
(9763,'enUS','%s breaks free of its spectral bonds with a tremendous crash of thunder!','',26124),
(9764,'enUS','%s goes into a killing frenzy!','',26124),
(9765,'enUS','The ritual is already underway!','',26124),
(9766,'enUS','$n, I shall leave before one of these beasts takes a liking to me!','',26124),
(9768,'enUS','%s is pulled back to Xoroth!','',26124),
(9769,'enUS','Ah, here we are!  Well let\'s get to work, shall we...?','',26124),
(9770,'enUS','Oh, right!  Over here now...','',26124),
(9771,'enUS','And now... the final step!','',26124),
(9772,'enUS','I shall enjoy this, $c.','',26124),
(9773,'enUS','%s recoils in pain as the Judgment of Light washes over it!','',26124),
(9774,'enUS','%s recoils in pain as the Judgment of Justice washes over it!','',26124),
(9775,'enUS','%s recoils in pain as the Judgment of Righteousness washes over it!','',26124),
(9776,'enUS','Follow me, good Paladin.  I\'ll have your barding done faster than I could down a Dwarven stout.  Mmmm... stout.','',26124),
(9777,'enUS','%s assembles the runecloth, herbs, and holy water to the barding.','',26124),
(9778,'enUS','%s smiths the arcanite into place on the barding.','',26124),
(9779,'enUS','Well, that should do it.  Come now, back to the shop to finish our business!','',26124),
(9780,'enUS','If you\'ve come looking for the finest craftsmanship on this or any other continent in the world, then you\'ve come to the right place!$B$BGrimand Elmore, at your service!','',26124),
(9781,'enUS','%s emerges from the darkness, drawn out by the divination scryer!','',26124),
(9782,'enUS','You dare challenge me? Prepare for an eternity of dread.','',26124),
(9783,'enUS','%s notes your cowardly battle tactics and flees from battle.','',26124),
(9784,'enUS','ENOUGH - this ends now!  You fools will be added to my bone collection!','',26124),
(9785,'enUS','%s is immobilized.','',26124),
(9786,'enUS','%s is stricken by a virulent poison.','',26124),
(9787,'enUS','Your soul is mine, weakling.','',26124),
(9788,'enUS','To summon a Dreadsteed, you must first create a Circle of Greater Summoning.  A portal to Xoroth may only be created from within such a circle.$B$BThe Circle of Greater Summoning requires three powerful implements: a Bell of Dethmoora, a Wheel of the Black March and a Doomsday Candle.','',26124),
(9789,'enUS','Your preparations are complete.  All that now stands before you and your dreadsteed is the ritual for the Circle of Greater Summoning, and the binding of the dreadsteed\'s spirit...','',26124),
(9790,'enUS','Gorzeeki tells me that you have brought him all that he needs for the Bell of Dethmoora, the Wheel of the Black March and the Doomsday Candle.$B$BWell done, $n!  You are almost ready to perform your ritual and bind a dreadsteed!','',26124),
(9791,'enUS','Greetings, $n.  How goes your delvings into the demonic and arcane?  Have you uncovered any dark secrets of late?','',26124),
(9792,'enUS','Merideth, could I have some more manna-enriched horse feed please?','Merideth, could I have some more manna-enriched horse feed please?',26124),
(9793,'enUS','%s flinches as its skin shimmers.','',26124),
(9794,'enUS','Ah...the heroes. You are persistent, aren\'t you? Your ally here attempted to match his power against mine - and paid the price. Now he shall serve me...by slaughtering you. ','',26124),
(9795,'enUS','Arr!   There be nothin I like to see better than folks fightin to the death in the arena.   If you be here at the right time maybe you can be one of them!','',26124),
(9796,'enUS','Don\'t interrupt me.','',26124),
(9797,'enUS','A slippery tile causes you to lose your footing.','',26124),
(9798,'enUS','Yesh, it\'sh true, I\'m blind as a bat! An\' drunk as a ... err, drunk as shomething that getsh drunk.$B$BI\'ll tell you what, $r. It\'sh the drink that keeps me shenses sharp. It\'sh common knowledge that when you lose a shense, yer other shenses become more alert. My drunk shense is incredible these days.','',26124),
(9799,'enUS','Our pillas! Someone has stolen our pillas!','Our pillas! Someone has stolen our pillas!',26124),
(9800,'enUS','We\'ll not let this act of madness go unpunished!','We\'ll not let this act of madness go unpunished!',26124),
(9801,'enUS','$n captured the Horde Flag!','',26124),
(9802,'enUS','$n captured the Alliance Flag!','',26124),
(9803,'enUS','The flags are now placed at their bases.','',26124),
(9804,'enUS','The Alliance Flag was picked up by $n!','',26124),
(9805,'enUS','The Alliance Flag was dropped by $n!','',26124),
(9806,'enUS','The Horde Flag was dropped by $n!','',26124),
(9807,'enUS','The Horde Flag was picked up by $n!','',26124),
(9808,'enUS','The Alliance Flag was returned to its base by $n!','',26124),
(9809,'enUS','The Horde Flag was returned to its base by $n!','',26124),
(9810,'enUS','','Thieves! Scallywags! Rapscallions! Come face me gigantic pillas!',26124),
(9811,'enUS','','We chose to leave the protection and comfort of the Depths to exploit... er, I mean... hrm, yes that\'s right, EXPLORE the world.',26124),
(9812,'enUS','Run if you like fools!  Your fate is sealed anyways!','',26124),
(9813,'enUS','Flee while you can mortal!','',26124),
(9814,'enUS','Generic Text','Generic Text!',26124),
(9815,'enUS','Only a fool would remain in this battle. Farewell, coward.','Only a fool would remain in this battle. Farewell, coward.',26124),
(9816,'enUS','Hey, you! Random traveler! C\'mere and make some coin!','',26124),
(9817,'enUS','Got anything interesting for sale, Zorbin?','Got anything interesting for sale, Zorbin?',26124),
(9818,'enUS','I wish to browse your wares.','I wish to browse your wares.',26124),
(9819,'enUS','Burninate\'s the name, smithin\'s my game... and, erm... I sell a little food and water on the side. Care for some meat?','',26124),
(9820,'enUS','Well hello again, $n!  I don\'t know how much longer I\'m going to keep on trying to set up a shop out in the middle of nowhere.  Still, since you\'ve helped me out in the past, I\'ll show you some stuff you may find interesting!','',26124),
(9821,'enUS','When Lolo doesn\'t wanna spill any o\' his precious ale or get his lil\' dress dirty, I\'m called in. Yep. Ol\' Hansel is the dwarf they use to mete out a lil\' bit o\' justice an\' a whole lotta pain.','',26124),
(9822,'enUS','Now that the Stormpike general is defeated, we can spare a few troops to guard Winterax Hold.  But we must be ever vigilant, $c, for the Alliance will return.$B$BWhen you find them skulking about, teach them another lesson!','Now that the Stormpike general is defeated, we can spare a few troops to guard Winterax Hold.  But we must be ever vigilant, $c, for the Alliance will return.$B$BWhen you find them skulking about, teach them another lesson!',26124),
(9823,'enUS','','Now that the Frostwolf general is defeated, we can spare some troops to guard the entrance to Winterax Hold.$B$BBut stay vigilant!  We must always be on the lookout for Horde interlopers..',26124),
(9824,'enUS','As acting Taskmaster of this here compound, it is my duty to make sure that there is a certain level of tedium involved with all forms of business, work, rest, and relaxation that may take place here.$B$BIf you find anything that you are asked to do to be too easy and hassle free, report to me immediately.','',26124),
(9825,'enUS','You\'ve done all that I\'ve asked you to do, $n. There\'s really nothing more here for you. If you are interested in continuing your career as an agent of the Thorium Brotherhood, speak with Lokhtos Darkbargainer at the Grim Guzzler in Blackrock Depths.$B$BFarewell!','',26124),
(9826,'enUS','I swear... if Quint tries to plant one more fishing grub on me, I\'m going to hack down his tree with my not-so-rusty sword.','',26124),
(9827,'enUS','','Beware!  The $r $n attacks us at Winterax Hold!',26124),
(9828,'enUS','','Thorium Brotherhood or not, if one of them Dark Iron gets near to me they\'ll taste my mattock up the side of their head!  Now, where can I send ya $G lad : lass;?',26124),
(9829,'enUS','Hey Pratt - can you teach me how to make Wild Leather Boots again?','Hey Pratt - can you teach me how to make Wild Leather Boots again?',26124),
(9830,'enUS','Hey Pratt - can you teach me how to make a Wild Leather Cloak?','Hey Pratt - can you teach me how to make a Wild Leather Cloak?',26124),
(9831,'enUS','Hey Pratt - can you teach me how to make a Wild Leather Vest again?','Hey Pratt - can you teach me how to make a Wild Leather Vest again?',26124),
(9832,'enUS','Hey Pratt - can you teach me how to make Wild Leather Shoulders again?','Hey Pratt - can you teach me how to make Wild Leather Shoulders again?',26124),
(9833,'enUS','Hey Pratt - can you teach me how to make Wild Leather Leggings again?','Hey Pratt - can you teach me how to make Wild Leather Leggings again?',26124),
(9834,'enUS','Hey Pratt - can you teach me how to make a Wild Leather Helmet again?','Hey Pratt - can you teach me how to make a Wild Leather Helmet again?',26124),
(9835,'enUS','Hey Jangdor - can you teach me how to make Wild Leather Boots again?','Hey Jangdor - can you teach me how to make Wild Leather Boots again?',26124),
(9836,'enUS','Hey Jangdor - can you teach me how to make a Wild Leather Cloak?','Hey Jangdor - can you teach me how to make a Wild Leather Cloak?',26124),
(9837,'enUS','Hey Jangdor - can you teach me how to make a Wild Leather Helmet again?','Hey Jangdor - can you teach me how to make a Wild Leather Helmet again?',26124),
(9838,'enUS','Hey Jangdor - can you teach me how to make Wild Leather Leggings again?','Hey Jangdor - can you teach me how to make Wild Leather Leggings again?',26124),
(9839,'enUS','Hey Jangdor - can you teach me how to make Wild Leather Shoulders again?','Hey Jangdor - can you teach me how to make Wild Leather Shoulders again?',26124),
(9840,'enUS','Hey Jangdor - can you teach me how to make a Wild Leather Vest again?','Hey Jangdor - can you teach me how to make a Wild Leather Vest again?',26124),
(9841,'enUS','','As long as those dwarves stay over there we\'ll have no trouble.  Where are you heading $n?',26124),
(9842,'enUS','The Horde wins!','',26124),
(9843,'enUS','The Alliance wins!','',26124),
(9844,'enUS','Get up, little red wyrm...and destroy them!\n','',26124),
(9845,'enUS','Let the games begin!','',26124),
(9846,'enUS','Do you expect me to cower before the mighty legion of $n?$B$BYou are nothing to me. Less than nothing. Had I desired your head, it would have been presented to me on a pike.$B$BYou have made the mistake that all mortals make.$B$B<Lord Victor Nefarius sighs.>$B$BTime does strange things to those that use it as a form of currency.\n','',26124),
(9847,'enUS','I cannot, Vaelastrasz! Surely something can be done to heal you!','I cannot, Vaelastrasz! Surely something can be done to heal you!',26124),
(9848,'enUS','Priests! If you\'re going to keep healing like that, we might as well make it a little more interesting!','',26124),
(9849,'enUS','Hunters and your annoying pea-shooters!','',26124),
(9850,'enUS','Mages too? You should be more careful when you play with magic...','',26124),
(9851,'enUS','Druids and your silly shapeshifting. Lets see it in action!','',26124),
(9852,'enUS','Warlocks, you shouldn\'t be playing with magic you don\'t understand. See what happens?','',26124),
(9853,'enUS','Paladins... I\'ve heard you have many lives. Show me.','',26124),
(9854,'enUS','Shamans, show me what your totems can do!','',26124),
(9855,'enUS','Warriors, I know you can hit harder than that! Let\'s see it!','',26124),
(9856,'enUS','Rogues? Stop hiding and face me!','',26124),
(9857,'enUS','A large humanoid hand print is embedded on the surface of the orb. Despite what appears to be constant manipulation and handling, the orb remains unmarred.','',26124),
(9858,'enUS','The orb\'s markings match the brand on your hand.','',26124),
(9859,'enUS','<Place my hand on the orb.>','<Place my hand on the orb.>',26124),
(9860,'enUS','At last, the agony ends. I have failed you my Queen. I have failed us all...','',26124),
(9861,'enUS','I... I have failed, $n. The Lord of Bla... The Lord of Blackrock is too powerful. He consumed my energy with... with ease. I turn... I... kill me... you must... you must kill me.','',26124),
(9862,'enUS','I am he that watches they. I am the fist of retribution. That which does quell the recalcitrant. Dare you defy the Warchief? Dare you face my merciless judgment?','',26124),
(9863,'enUS','Can\'t you see I\'m fishing here!','',26124),
(9864,'enUS','You scared the fish away!  What do you want?','',26124),
(9865,'enUS','What can I do for you $c?','',26124),
(9866,'enUS','I\'m going to stay here until I catch a 68 Pound Grouper!  You on the other hand want to fly off somewhere, am I right?','',26124),
(9867,'enUS','NEFARIAN BE SLAIN! People of Orgrimmar, bow down before da might of $n and $g his:her; allies for dey have laid a mighty blow against da Black Dragonflight !','',26124),
(9868,'enUS','Be lifted by $n\'s accomplishment! Revel in $g his:her; rallying cry!','',26124),
(9869,'enUS','Look to this fallen dragon, $r. The might of the Horde is unquestionable!','',26124),
(9870,'enUS','Citizens of the Alliance, the Lord of Blackrock is slain! Nefarian has been subdued by the combined might of $n and $g his:her; allies!','',26124),
(9871,'enUS','Ragefire Chasm consists of a network of volcanic caverns below the orcs\' new capital city of Orgrimmar. Recently, rumors have spread that a cult loyal to the demonic Shadow Council has taken up residence within the Chasm\'s fiery depths. This cult, known as the Burning Blade, threatens the very sovereignty of Durotar. Many believe that the orc Warchief Thrall is aware of the Blade\'s existence and has chosen not to destroy it in the hopes that its members might lead him straight to the Shadow Council. \n','Ragefire Chasm consists of a network of volcanic caverns below the orcs\' new capital city of Orgrimmar. Recently, rumors have spread that a cult loyal to the demonic Shadow Council has taken up residence within the Chasm\'s fiery depths. This cult, known as the Burning Blade, threatens the very sovereignty of Durotar. Many believe that the orc Warchief Thrall is aware of the Blade\'s existence and has chosen not to destroy it in the hopes that its members might lead him straight to the Shadow Council. \n',26124),
(9872,'enUS','Let your spirits rise! Rally around your champion, bask in $g his:her; glory! Revel in the rallying cry of the dragon slayer!','',26124),
(9873,'enUS','Join a group going to this dungeon.    <This choice will place you in a meetingstone queue>                              ','Join a group going to this dungeon.    <This choice will place you in a meetingstone queue>    \n',26124),
(9874,'enUS','The Lord of Blackrock hangs from the arches!','',26124),
(9875,'enUS','Move along, citizen. There is nothing to see here.','',26124),
(9876,'enUS','Ragefire','Ragefire',26124),
(9877,'enUS','Are you interested in exploring one of these dungeons?','Are you interested in exploring one of these dungeons?',26124),
(9878,'enUS','Wailing Caverns','Wailing Caverns',26124),
(9879,'enUS','A stack of papers and schematics are strewn here.','',26124),
(9880,'enUS','These papers are guarded.  Speak with Zamek to create a distraction!','',26124),
(9881,'enUS','Recently, a night elf druid named Naralex discovered a network of underground caverns within the heart of the Barrens. Believing he could use the caverns\' springs to restore lushness to the Barrens, the druid began siphoning the energies of the fabled Emerald Dream. His vision somehow became a nightmare, however, and soon the Wailing Caverns changed into a den of vicious, deadly predators. It is said that Naralex still resides somewhere inside the labyrinth, trapped beyond the edges of the Emerald Dream. \r','Recently, a night elf druid named Naralex discovered a network of underground caverns within the heart of the Barrens. Believing he could use the caverns\' springs to restore lushness to the Barrens, the druid began siphoning the energies of the fabled Emerald Dream. His vision somehow became a nightmare, however, and soon the Wailing Caverns changed into a den of vicious, deadly predators. It is said that Naralex still resides somewhere inside the labyrinth, trapped beyond the edges of the Emerald Dream. \r',26124),
(9882,'enUS','Tell me about dungeons I could explore.','Tell me about dungeons I could explore.',26124),
(9883,'enUS','Impossible! Rise my minions!  Serve your master once more!','',26124),
(9884,'enUS','Frustrated by the Dalaran wizards\' lack of progress against the undead during the Third War, the Archmage Arugal elected to summon the extra-dimensional worgen to bolster his side\'s diminishing ranks. The wolf-men slaughtered the Scourge, then quickly turned on the wizards themselves and laid siege to the keep of the noble, Baron Silverlaine. The fort quickly fell into shadow and ruin. Driven mad with guilt, Arugal adopted the worgen as his children and retreated to the newly dubbed \'Shadowfang Keep\'. \n','Frustrated by the Dalaran wizards\' lack of progress against the undead during the Third War, the Archmage Arugal elected to summon the extra-dimensional worgen to bolster his side\'s diminishing ranks. The wolf-men slaughtered the Scourge, then quickly turned on the wizards themselves and laid siege to the keep of the noble, Baron Silverlaine. The fort quickly fell into shadow and ruin. Driven mad with guilt, Arugal adopted the worgen as his children and retreated to the newly dubbed \'Shadowfang Keep\'. \n',26124),
(9885,'enUS','Shadowfang Keep','Shadowfang Keep',26124),
(9886,'enUS','Too late, friends! Nefarius\' corruption has taken hold...I cannot...control myself.\n','',26124),
(9887,'enUS','I beg you, mortals - FLEE! Flee before I lose all sense of control! The black fire rages within my heart! I MUST- release it! ','',26124),
(9888,'enUS','FLAME! DEATH! DESTRUCTION! Cower, mortals before the wrath of Lord...NO - I MUST fight this! Alexstrasza help me, I MUST fight it! ','',26124),
(9889,'enUS','','Aye, you there!  If you want to earn the respect of the Darkspear, then you can start by donating valuable resources for those in need!  Textiles and bandages don\'t grow on trees, ya know.$B$BRather than cash in various cloth pieces you find adventuring, donate them!  Doing so will earn you the recognition of the Darkspear!',26124),
(9890,'enUS','','In these trying times, a simple donation of cloth can go a long way to help those less fortunate than ourselves.  Cloth goes a long way to making garments and bandages - both important for the war effort!$B$BIf you are interested in donating cloth pieces to the orcs of Orgrimmar, I will gladly accept them and make sure you receive the proper recognition for doing so.$B$BFor the Horde!',26124),
(9891,'enUS','Hail $g brother : sister;... I\'d like a moment of your time, if I may.$B$BWe tauren have endured much in our trials and tribulations in establishing our homeland.  We now find ourselves in a dire shortage of cloth.  If you have the materials to spare, I ask that you please donate them.  You certainly would earn the gratitude of tauren everywhere in helping us out!','',26124),
(9892,'enUS','Once the greatest gold production center in the human lands, the Dead Mines are now inhabited by the Defias Brotherhood, who have turned the dark tunnels into their private sanctum. It is rumored that the thieves have conscripted the clever goblins to help them build something terrible at the bottom of the mines - but what that may be is still uncertain. Rumor has it that the way into the Deadmines lies through the quiet, unassuming village of Moonbrook.\n','Once the greatest gold production center in the human lands, the Dead Mines are now inhabited by the Defias Brotherhood, who have turned the dark tunnels into their private sanctum. It is rumored that the thieves have conscripted the clever goblins to help them build something terrible at the bottom of the mines - but what that may be is still uncertain. Rumor has it that the way into the Deadmines lies through the quiet, unassuming village of Moonbrook.\n',26124),
(9893,'enUS','You there... it is in your best interest to aid the Forsaken during these dire times.  Listen closely, as I dislike repeating myself.$B$BWe currently find ourselves in a dire shortage of cloth.  Bandages and simple textiles are running low, and donations are being accepted to bolster sagging inventories.  While you\'ll not receive financial compensation - hence what donation means - your aid will not go unnoticed.','',26124),
(9894,'enUS','Friend - Stormwind needs your assistance and your generosity!$B$BOur once large stockpile of textiles has run critically low.  Stormwind is now engaged in a multi-pronged effort to rebuild those stocks for the manufacture of textiles and bandages!  Your donation of cloth would help Stormwind immensely, as well as earn the respect of the citizenry!','',26124),
(9895,'enUS','','Aye, you there!  If you want to earn the respect of the dwarves of Ironforge, then you can start by donating valuable resources!  Ironforge finds itself running low on cloth piece; textiles and bandages don\'t grow on trees, ya know!$B$BRather than cash in various cloth pieces you find adventuring, donate them!  Doing so will earn you the recognition of the dwarven people of Ironforge!',26124),
(9896,'enUS','Ragefire Chasm can be found beneath the Shadow Cleft in the center of Orgrimmar.','Ragefire Chasm can be found beneath the Shadow Cleft in the center of Orgrimmar.',26124),
(9897,'enUS','The exiles of Gnomeregan find ourselves in even more dire straits by running low on cloth reserves!  Perhaps you can help us, eh?!$B$BBring me extra cloth pieces you might have to help us replenish our stocks.  By donating them, you\'ll be earning the respect and trust of gnomes everywhere.  That\'s something that money can\'t buy!  Well, I guess cloth does, but that\'s beside the point...','',26124),
(9898,'enUS','Can you tell me more about this place?','Can you tell me more about this place?',26124),
(9899,'enUS','The Wailing Caverns has its entrance at the Lushwater Oasis southwest of Crossroads in the Barrens.   ','The Wailing Caverns has its entrance at the Lushwater Oasis southwest of Crossroads in the Barrens.   ',26124),
(9900,'enUS','Hail friend - a moment of your time, if I may...$B$BWe have endured much in our trials and tribulations in establishing Teldrassil.  Were the constant strife of the times not enough, we now find ourselves in a dire shortage of cloth.  If you have the materials to spare, I ask that you please donate them.  You certainly would earn the gratitude of night elves everywhere in helping us out!','',26124),
(9901,'enUS','Shadowfang Keep is in southern Silverpine just north of Pyrewood Village.','Shadowfang Keep is in southern Silverpine just north of Pyrewood Village.',26124),
(9902,'enUS','I\'ve made no mistakes.','I\'ve made no mistakes.',26124),
(9903,'enUS','In your rush to glory, you assumed that the pace of the game revolved around your actions. Can you even fathom how preposterous that sounds to a being like me? A being that if so inclined could cause your own insignificant thoughts to crush the peanut sized mass of grey matter floating within your skull.\n','',26124),
(9904,'enUS','You have lost your mind, Nefarius. You speak in riddles.','You have lost your mind, Nefarius. You speak in riddles.',26124),
(9905,'enUS','It\'s simple really. Allow me to summarize...\n','',26124),
(9906,'enUS','Please do.','Please do.',26124),
(9907,'enUS','In this world where time is your enemy, it is my greatest ally. This grand game of life that you think you play in fact plays you. To that I say...','',26124),
(9908,'enUS','Gnomeregan','Gnomeregan',26124),
(9909,'enUS','Blackfathom Deeps','Blackfathom Deeps',26124),
(9910,'enUS','Blackfathom Deeps can be found at the north end of Zoram Strand along the coast of Ashenvale.','Blackfathom Deeps can be found at the north end of Zoram Strand along the coast of Ashenvale.',26124),
(9911,'enUS','Situated along the Zoram Strand of Ashenvale, Blackfathom Deeps was once a glorious temple dedicated to the night elves\' moon-goddess Elune. However, the great Sundering shattered the temple - sinking it beneath the waves of the Veiled Sea. There it remained untouched - until, drawn by its ancient power - the naga and satyr emerged to plumb its secrets. Legends hold that the ancient beast, Aku\'mai, has taken up residence within the temple\'s ruins. \n','Situated along the Zoram Strand of Ashenvale, Blackfathom Deeps was once a glorious temple dedicated to the night elves\' moon-goddess Elune. However, the great Sundering shattered the temple - sinking it beneath the waves of the Veiled Sea. There it remained untouched - until, drawn by its ancient power - the naga and satyr emerged to plumb its secrets. Legends hold that the ancient beast, Aku\'mai, has taken up residence within the temple\'s ruins. \n',26124),
(9913,'enUS','Gnomeregan can be found in western Dun Morogh.','Gnomeregan can be found in western Dun Morogh.',26124),
(9914,'enUS','Located in Dun Morogh, Gnomeregan has been the gnomes\' capital city for generations, though it was recently infested by mutant troggs. In a desperate attempt to retaliate, High Tinker Mekkatorque ordered the emergency venting of the city\'s radioactive waste tanks. Though the troggs became irradiated, their siege continued unabated and the gnomes were forced to seek refuge in the dwarven city of Ironforge, where the High Tinker now enlists brave souls to help his people reclaim their beloved city. \n','Located in Dun Morogh, Gnomeregan has been the gnomes\' capital city for generations, though it was recently infested by mutant troggs. In a desperate attempt to retaliate, High Tinker Mekkatorque ordered the emergency venting of the city\'s radioactive waste tanks. Though the troggs became irradiated, their siege continued unabated and the gnomes were forced to seek refuge in the dwarven city of Ironforge, where the High Tinker now enlists brave souls to help his people reclaim their beloved city. \n',26124),
(9915,'enUS','Razorfen Kraul','Razorfen Kraul',26124),
(9916,'enUS','Razorfen Kraul can be found on the very southern tip of the Barrens on the west side of the road.','Razorfen Kraul can be found on the very southern tip of the Barrens on the west side of the road.',26124),
(9917,'enUS','During the War of the Ancients, the demigod Agamaggan came forth to battle the Burning Legion. The colossal boar was defeated, and over time in the areas where his blood fell, massive thorn-ridden vines sprouted to life. The quilboar came to occupy these regions and hold them sacred. The heart of these massive thorn-colonies is the Razorfen. Razorfen Kraul was conquered by the crone, Charlga Razorflank, a Geomancer with experimental and powerful practices, whose rise to power and the rapidly increasing violence between quilboar tribesmen can only lead to one thing: war.','During the War of the Ancients, the demigod Agamaggan came forth to battle the Burning Legion. The colossal boar was defeated, and over time in the areas where his blood fell, massive thorn-ridden vines sprouted to life. The quilboar came to occupy these regions and hold them sacred. The heart of these massive thorn-colonies is the Razorfen. Razorfen Kraul was conquered by the crone, Charlga Razorflank, a Geomancer with experimental and powerful practices, whose rise to power and the rapidly increasing violence between quilboar tribesmen can only lead to one thing: war.',26124),
(9918,'enUS','Scarlet Monastery','Scarlet Monastery',26124),
(9919,'enUS','Scarlet Monastery lies in the hills northeast of Tirisfal Glades.','Scarlet Monastery lies in the hills northeast of Tirisfal Glades.',26124),
(9920,'enUS','The monastery was once a center for learning and enlightenment. With the rise of the undead Scourge during the Third War, the peaceful Monastery was converted into a stronghold of the fanatical Scarlet Crusade. The Crusaders are intolerant of all non-human races, regardless of alliance or affiliation. They believe that any and all outsiders are potential carriers of the undead plague - and must be destroyed. \n','The monastery was once a center for learning and enlightenment. With the rise of the undead Scourge during the Third War, the peaceful Monastery was converted into a stronghold of the fanatical Scarlet Crusade. The Crusaders are intolerant of all non-human races, regardless of alliance or affiliation. They believe that any and all outsiders are potential carriers of the undead plague - and must be destroyed. \n',26124),
(9921,'enUS','Razorfen Downs','Razorfen Downs',26124),
(9922,'enUS','Razorfen Downs can be found on the very southern tip of the Barrens on the east side of the road.','Razorfen Downs can be found on the very southern tip of the Barrens on the east side of the road.',26124),
(9923,'enUS','Crafted from the same vines as Razorfen Kraul, Razorfen Downs is the traditional capital city of the quilboar race. The sprawling, thorn-ridden labyrinth houses a veritable army of loyal quilboar as well as their high priests - the Death\'s Head tribe. Recently, however, a looming shadow has fallen over the crude den. Agents of the undead Scourge - led by the lich, Amnennar the Coldbringer - have taken control over the quilboar race and turned the maze of thorns into a bastion of undead might. \n\n','Crafted from the same vines as Razorfen Kraul, Razorfen Downs is the traditional capital city of the quilboar race. The sprawling, thorn-ridden labyrinth houses a veritable army of loyal quilboar as well as their high priests - the Death\'s Head tribe. Recently, however, a looming shadow has fallen over the crude den. Agents of the undead Scourge - led by the lich, Amnennar the Coldbringer - have taken control over the quilboar race and turned the maze of thorns into a bastion of undead might. \n\n',26124),
(9924,'enUS','Uldaman','Uldaman',26124),
(9925,'enUS','Uldaman can be found at the very northern end of the Badlands.','Uldaman can be found at the very northern end of the Badlands.',26124),
(9926,'enUS','Lard keep peace here. Lard also sell fish. Want fish?','Lard keep peace here. Lard also sell fish. Want fish?',26124),
(9927,'enUS','Uldaman is an ancient Titan vault that has laid buried within the earth since the world\'s creation. Dwarven excavations of the city have recently released the Titans\' first failed creations: the troggs. Legends say that when the Titans deemed the trogg experiment a failure they tried again, resulting in the creation of the dwarven race. These secrets are recorded on the fabled Discs of Norgannon - massive artifacts that lie at the bottom of the ancient city, protected by giant constructs of living stone. \r','Uldaman is an ancient Titan vault that has laid buried within the earth since the world\'s creation. Dwarven excavations of the city have recently released the Titans\' first failed creations: the troggs. Legends say that when the Titans deemed the trogg experiment a failure they tried again, resulting in the creation of the dwarven race. These secrets are recorded on the fabled Discs of Norgannon - massive artifacts that lie at the bottom of the ancient city, protected by giant constructs of living stone. \r',26124),
(9928,'enUS','Zul\'Farrak','Zul\'Farrak',26124),
(9929,'enUS','The ruins of Zul\'Farrak are located in the northwestern corner of the Tanaris Desert.','The ruins of Zul\'Farrak are located in the northwestern corner of the Tanaris Desert.',26124),
(9930,'enUS','This sun-blasted city is home to the Sandfury trolls, known for their particular ruthlessness and dark mysticism. Troll legends tell of a powerful sword called Sul\'thraze the Lasher, a weapon capable of instilling fear and weakness in even the most formidable of foes. Long ago, the weapon was split in half. However, rumors have circulated that the two halves may be found somewhere within Zul\'Farrak\'s walls.\n','This sun-blasted city is home to the Sandfury trolls, known for their particular ruthlessness and dark mysticism. Troll legends tell of a powerful sword called Sul\'thraze the Lasher, a weapon capable of instilling fear and weakness in even the most formidable of foes. Long ago, the weapon was split in half. However, rumors have circulated that the two halves may be found somewhere within Zul\'Farrak\'s walls.\n',26124),
(9931,'enUS','Maraudon','Maraudon',26124),
(9932,'enUS','Maraudon is located in the middle of the western coast of Desolace, in the Valley of Spears.','Maraudon is located in the middle of the western coast of Desolace, in the Valley of Spears.',26124),
(9933,'enUS','Maraudon is one of the most sacred sites within Desolace. The great temple/cavern is the burial place of Zaetar, one of two immortal sons born to the demigod, Cenarius. Legend holds that Zaetar and the earth elemental princess, Theradras, sired the misbegotten centaur race. It is said that upon their emergence, the barbaric centaur turned on their father and killed him. Some believe that Theradras, in her grief, trapped Zaetar\'s spirit within the winding cavern - used its energies for some malign purpose. ','Maraudon is one of the most sacred sites within Desolace. The great temple/cavern is the burial place of Zaetar, one of two immortal sons born to the demigod, Cenarius. Legend holds that Zaetar and the earth elemental princess, Theradras, sired the misbegotten centaur race. It is said that upon their emergence, the barbaric centaur turned on their father and killed him. Some believe that Theradras, in her grief, trapped Zaetar\'s spirit within the winding cavern - used its energies for some malign purpose. ',26124),
(9934,'enUS','Sunken Temple','Sunken Temple',26124),
(9935,'enUS','The Sunken Temple can be found in the center of a great lake in eastern Swamp of Sorrows.','The Sunken Temple can be found in the center of a great lake in eastern Swamp of Sorrows.',26124),
(9936,'enUS','Over a thousand years ago a group of troll priests known as the Atal\'ai attempted to bring back an ancient blood god named Hakkar the Soulflayer. After the resulting civil war the priests were defeated and exiled to the Swamp of Sorrows. There they erected a temple to Hakkar to prepare for his arrival into the physical world. The dragon Aspect Ysera soon learned of the Atal\'ai\'s plans and smashed the temple beneath the marshes. To this day, the temple\'s ruins are guarded by the mighty green dragons.\n','Over a thousand years ago a group of troll priests known as the Atal\'ai attempted to bring back an ancient blood god named Hakkar the Soulflayer. After the resulting civil war the priests were defeated and exiled to the Swamp of Sorrows. There they erected a temple to Hakkar to prepare for his arrival into the physical world. The dragon Aspect Ysera soon learned of the Atal\'ai\'s plans and smashed the temple beneath the marshes. To this day, the temple\'s ruins are guarded by the mighty green dragons.\n',26124),
(9937,'enUS','Blackrock Depths','Blackrock Depths',26124),
(9938,'enUS','Blackrock Mountain lies between Searing Gorge in the north and Burning Steppes in the south.','Blackrock Mountain lies between Searing Gorge in the north and Burning Steppes in the south.',26124),
(9939,'enUS','Once the capital city of the Dark Iron dwarves, this volcanic labyrinth now serves as the seat of power for Ragnaros the Firelord. Ragnaros has uncovered the secret to creating life from stone and plans to build an army of unstoppable golems to aid him in conquering the whole of Blackrock Mountain. Obsessed with defeating Nefarian and his draconic minions, Ragnaros will go to any extreme to achieve final victory.  \n','Once the capital city of the Dark Iron dwarves, this volcanic labyrinth now serves as the seat of power for Ragnaros the Firelord. Ragnaros has uncovered the secret to creating life from stone and plans to build an army of unstoppable golems to aid him in conquering the whole of Blackrock Mountain. Obsessed with defeating Nefarian and his draconic minions, Ragnaros will go to any extreme to achieve final victory.  \n',26124),
(9940,'enUS','Blackrock Spire','Blackrock Spire',26124),
(9941,'enUS','The mighty fortress carved within the fiery bowels of Blackrock Mountain was held by the sinister Dark Iron dwarves for centuries until Nefarian - the cunning son of the dragon, Deathwing - took control of the upper Spire and made war on the dwarves\' holdings in the mountain\'s volcanic depths. Realizing that the dwarves were led by the mighty fire elemental, Ragnaros - Nefarian vowed to crush his enemies and claim the whole of Blackrock mountain for himself. \n','The mighty fortress carved within the fiery bowels of Blackrock Mountain was held by the sinister Dark Iron dwarves for centuries until Nefarian - the cunning son of the dragon, Deathwing - took control of the upper Spire and made war on the dwarves\' holdings in the mountain\'s volcanic depths. Realizing that the dwarves were led by the mighty fire elemental, Ragnaros - Nefarian vowed to crush his enemies and claim the whole of Blackrock mountain for himself. \n',26124),
(9942,'enUS','Dire Maul','Dire Maul',26124),
(9943,'enUS','The ruins of Dire Maul stand in central Ferelas.','The ruins of Dire Maul stand in central Ferelas.',26124),
(9944,'enUS','Built twelve thousand years ago by a covert sect of night elf sorcerers, the ancient city of Eldre\'Thalas was used to protect Queen Azshara\'s most prized arcane secrets. Though it was ravaged by the Great Sundering of the world, much of the wondrous city still stands as the imposing Dire Maul. The ruins\' three distinct districts have been overrun by all manner of creatures - especially the spectral highborne, foul satyr and brutish ogres. \n','Built twelve thousand years ago by a covert sect of night elf sorcerers, the ancient city of Eldre\'Thalas was used to protect Queen Azshara\'s most prized arcane secrets. Though it was ravaged by the Great Sundering of the world, much of the wondrous city still stands as the imposing Dire Maul. The ruins\' three distinct districts have been overrun by all manner of creatures - especially the spectral highborne, foul satyr and brutish ogres. \n',26124),
(9945,'enUS','Scholomance','Scholomance',26124),
(9946,'enUS','The School for Necromancy known as Scholomance is on the ruined island of Caer Darrow in the Western Plaguelands.','The School for Necromancy known as Scholomance is on the ruined island of Caer Darrow in the Western Plaguelands.',26124),
(9947,'enUS','The Scholomance is housed in crypts beneath the Caer Darrow keep. Once owned by the noble Barov family, the keep fell to ruin after the Second War. As the wizard Kel\'Thuzad enlisted followers for his Cult of the Damned, he often promised immortality for those who served his Lich King. The Barovs fell to his influence and donated their keep, but the cultists killed the family and turned the crypts into a school of necromancy. Though Kel\'Thuzad no longer resides there, cultists and instructors still remain. ','The Scholomance is housed in crypts beneath the Caer Darrow keep. Once owned by the noble Barov family, the keep fell to ruin after the Second War. As the wizard Kel\'Thuzad enlisted followers for his Cult of the Damned, he often promised immortality for those who served his Lich King. The Barovs fell to his influence and donated their keep, but the cultists killed the family and turned the crypts into a school of necromancy. Though Kel\'Thuzad no longer resides there, cultists and instructors still remain. ',26124),
(9948,'enUS','Stratholme','Stratholme',26124),
(9949,'enUS','The ruined city of Stratholme lies in the Eastern Plaguelands to the north of the Plaguewood.','The ruined city of Stratholme lies in the Eastern Plaguelands to the north of the Plaguewood.',26124),
(9950,'enUS','Once the jewel of northern Lordaeron, the city of Stratholme is where Prince Arthas turned against his mentor, Uther Lightbringer, and slaughtered hundreds of his own subjects who were believed to have contracted the plague of undeath. Arthas\' surrender to the Lich King soon followed. The broken city is now inhabited by the undead Scourge - led by the powerful lich, Kel\'Thuzad, and a contingent of Scarlet Crusaders, led by Grand Crusader Dathrohan. The two sides are locked in constant, violent combat. \n','Once the jewel of northern Lordaeron, the city of Stratholme is where Prince Arthas turned against his mentor, Uther Lightbringer, and slaughtered hundreds of his own subjects who were believed to have contracted the plague of undeath. Arthas\' surrender to the Lich King soon followed. The broken city is now inhabited by the undead Scourge - led by the powerful lich, Kel\'Thuzad, and a contingent of Scarlet Crusaders, led by Grand Crusader Dathrohan. The two sides are locked in constant, violent combat. \n',26124),
(9951,'enUS','Deadmines','Deadmines',26124),
(9952,'enUS','The Deadmines can be found beneath Moonbrook in the south of Westfall.','The Deadmines can be found beneath Moonbrook in the south of Westfall.',26124),
(9953,'enUS','Stormwind Stockade','Stormwind Stockade',26124),
(9954,'enUS','The Stormwind Stockades are found near the mage quarter in Stormwind.','The Stormwind Stockades are found near the mage quarter in Stormwind.',26124),
(9955,'enUS','The Stockades are a high-security prison complex, hidden beneath the canal district of Stormwind city. Presided over by Warden Thelwater, the Stockades are home to petty crooks, political insurgents, murderers and a score of the most dangerous criminals in the land. Recently, a prisoner-led revolt has resulted in a state of pandemonium within the Stockades - where the guards have been driven out and the convicts roam free. \n','The Stockades are a high-security prison complex, hidden beneath the canal district of Stormwind city. Presided over by Warden Thelwater, the Stockades are home to petty crooks, political insurgents, murderers and a score of the most dangerous criminals in the land. Recently, a prisoner-led revolt has resulted in a state of pandemonium within the Stockades - where the guards have been driven out and the convicts roam free. \n',26124),
(9956,'enUS','%s shot a buff!','',26124),
(9958,'enUS','Intruders have breached the hatchery! Sound the alarm! Protect the eggs at all costs!\n','',26124),
(9959,'enUS','Don\'t fight in broken weapons and armor! Expert armor and weapon repairing done here - while you wait!','',26124),
(9960,'enUS','Foolish $n, you serve me now! ','',26124),
(9961,'enUS','You\'ll pay for forcing me to do this!','',26124),
(9962,'enUS','Fools! These eggs are more precious than you know!','',26124),
(9963,'enUS','No - not another one! I\'ll have your heads for this atrocity!','',26124),
(9964,'enUS','Forgive me, $n! Your death only adds to my failure! ','',26124),
(9965,'enUS','Nefarius\' hate has made me stronger than ever before! You should have fled while you could, mortals! The fury of Blackrock courses through my veins! \n','',26124),
(9966,'enUS','Protect the flight!  These intruders die now!','',26124),
(9967,'enUS','None of your kind should be here!  You\'ve doomed only yourselves!','',26124),
(9968,'enUS','Clever, mortals - but I am not so easily lured away from my sanctum!','',26124),
(9969,'enUS','The blood samples must be protected!  Destroy the intruders!','',26124),
(9971,'enUS','This cannot be!  I am the master here!  You mortals are nothing to my kind!  Do you hear me? Nothing!','',26124),
(9972,'enUS','Worthless $n!  Your friends will join you soon enough!','',26124),
(9973,'enUS','Well done, my minions. The mortals\' courage begins to wane! Now, let\'s see how they contend with the true Lord of Blackrock Spire!!!','',26124),
(9974,'enUS','BURN! You wretches! BURN!','',26124),
(9975,'enUS','I\'ve got all the cooking supplies you\'ll ever need, mon!','',26124),
(9976,'enUS','','Welcome to Revantusk Village, stranger. I am Primal Torntusk, leader of the Revantusk trolls.',26124),
(9977,'enUS','If it\'s broke, Slagtree can fix it!','',26124),
(9978,'enUS','','Don\'t be steppin\' on my goods, there.',26124),
(9979,'enUS','Fishing is just so pleasant, mon. You know? I owe my state of bliss to my mentor, the greatest angler in the whole world - Nat Pagle. Have you heard of him, mon?$B$BIf you be looking for enlightenment, Nat Pagle be the one who gonna show you the way. ','',26124),
(9980,'enUS','What can you teach me?','What can you teach me?',26124),
(9981,'enUS','Zul\'jin shall return one day, $r. Mark my words. Until then, we all hold our positions and do what we can to keep the forest troll population intact.$B$BWith that said, as master huntsman of Revantusk Village, it is my responsibility to ensure that the world around us is safe for habitation.$B$BThe beasts of this area must be kept in check.$B$BAre you looking for work?\n','',26124),
(9982,'enUS','Markhor, I wish to stable my pet.','Markhor, I wish to stable my pet.',26124),
(9983,'enUS','I am Kilram, master of the axe.','',26124),
(9984,'enUS','Ah, a seasoned veteran you once were. Kilram can make you this again. I know you are capable, you merely need to ask and I shall teach you the way of the axesmith.','',26124),
(9985,'enUS','Please teach me how to become an axesmith, Kilram.','Please teach me how to become an axesmith, Kilram.',26124),
(9986,'enUS','','Don\'t get too close, $n. I\'m liable to fumble and bash your brains open with the face of my hammer.',26124),
(9987,'enUS','','I will teach you the way of the hammersmith. Just ask nicely.',26124),
(9988,'enUS','Please teach me how to become a hammersmith, Lilith.','Please teach me how to become a hammersmith, Lilith.',26124),
(9989,'enUS','Back off or I\'ll cut you in half.','',26124),
(9990,'enUS','If you wish to become a swordsmith, just ask.','',26124),
(9991,'enUS','Please teach me how to become a swordsmith, Seril.','Please teach me how to become a swordsmith, Seril.',26124),
(9992,'enUS','I would like to buy from you.','I would like to buy from you.',26124),
(9993,'enUS','I have just completed a new dimensional imploder that will make me rich beyond my wildest goblin dreams!   All I need to do is get a skilled Goblin Engineer to build a dimensional ripper that connects to it and try it! \n','',26124),
(9994,'enUS','This Dimensional Imploder sounds dangerous!  How can I make one?','This Dimensional Imploder sounds dangerous!  How can I make one?',26124),
(9995,'enUS','The theory behind it is that we completely destroy you with a massive explosion wherever you are and send those particles through a dimensional rip and then re-implode you at the machine here.   Instant Transport!    It might not work ALL the time, but what kind of goblin engineer are you!   If survival was your first priority you could never be a real Goblin Engineer!\nHere is the recipe you will need to make the Dimensional Ripper and try it out!\n\n','',26124),
(9996,'enUS','With some of the technology that was recovered by bold gnomes venturing into Gnomeregan, I have managed to construct my greatest invention:  The Matter Transporter!    All I need now is a skilled Gnomish Engineer to build a powerful beacon attuned to the transporter.','',26124),
(9997,'enUS','I must build a beacon for this marvelous device!','I must build a beacon for this marvelous device!',26124),
(9998,'enUS','Once you have built the device, you simply activate the device to be whisked away to lovely Gadgetzan!    Nearly everyone who has used the device has arrived on the pad here looking just the way they did when they began!\n\nThere have been some reported problems with transportees being replaced by their evil selves from an alternate universe, but I\'m sure we will have that worked out soon...','',26124),
(9999,'enUS','If you figure out any way to improve the device let me know!','',26124),
(10000,'enUS','It\'s good to see an engineer brave enough to make the device.   We goblin engineers laugh at danger!','',26124),
(10001,'enUS','Reporting for duty!','Reporting for duty!',26124),
(10002,'enUS','For the Horde!','For the Horde!',26124),
(10003,'enUS','Another fool falls for the trap!','Another fool falls for the trap!',26124),
(10004,'enUS','Dinner has arrived!','Dinner has arrived!',26124),
(10005,'enUS','The High Priestess will feast on your bones!','The High Priestess will feast on your bones!',26124),
(10006,'enUS','%s is weakened by the orb!','',26124),
(10007,'enUS','Supplies from our enemies!  Well done, $n!','',26124),
(10008,'enUS','You brought supplies from the enemy!  Hah! Well done $n!','',26124),
(10009,'enUS','Invaders! Invaders! We\'re under attack, boys! Get \'em!','',26124),
(10010,'enUS','I perform one final service. I pray it is sufficient...','',26124),
(10011,'enUS','Vaelastrasz, no!!!','Vaelastrasz, no!!!',26124),
(10012,'enUS','Get the key and unlock these chains! Hitah\'ya the Keeper holds it... back of cave... ','',26124),
(10013,'enUS','Finally, I am free! I come home soon, my dear!','',26124),
(10014,'enUS','Let the battle begin!','',26124),
(10015,'enUS','The battle for Warsong Gulch begins in 1 minute.','',26124),
(10016,'enUS','The battle for Warsong Gulch begins in 30 seconds.  Prepare yourselves!','',26124),
(10017,'enUS','Jobs/Lost & Found/Wanted:','',26124),
(10018,'enUS','Zug zug, my friend!  I am Kelm Hargunth, the main supplier for the Warsong Outriders.  As you improve your standing with the Outriders, I will make available to you a fine selection of goods that you can use inside Warsong Gulch.  Should you find yourself in need of item repair, I also provide those services.','',26124),
(10019,'enUS','What goods have I earned the right to purchase for use in Warsong Gulch?','What goods have I earned the right to purchase for use in Warsong Gulch?',26124),
(10020,'enUS','','May the blessings of the night be yours, friend!  I am Illiyana Moonblaze, and I am the main supplier for the Silverwing Sentinels here in Ashenvale.  As you improve your standing with the Sentinels, I will make available to you a fine selection of goods that you can use inside Warsong Gulch.  Should you find yourself in need of item repair, I also provide those services.',26124),
(10021,'enUS','What goods have I earned the right to purchase for use in Warsong Gulch?','What goods have I earned the right to purchase for use in Warsong Gulch?',26124),
(10022,'enUS','The Alliance Flag has returned to its base!','',26124),
(10023,'enUS','The Horde Flag has returned to its base!','',26124),
(10024,'enUS','I am here!  And the Irondeep Mine is... MINE!','',26124),
(10025,'enUS','Snivvle is here!  Snivvle claims the Coldtooth mine!','',26124),
(10026,'enUS','Let the coils of hate unfurl!','',26124),
(10027,'enUS','','Lord Hir\'eek, grant me wings of vengeance!',26124),
(10028,'enUS','Welcome!  Welcome to Yebb Neblegear\'s Darkmoon Zoo Bizarre - a Trove of Living Legends and Mythical Oddities!  Enjoy your visit, friend!$B$BBut be mindful of what you touch!  These exhibits hold artifacts and beasts both dire and divine!  They might burn the wayward hand of an over-curious onlooker...','',26124),
(10029,'enUS','Where can I send you today $c?','',26124),
(10030,'enUS','Though the Crossroads seems to be the center of activity in The Barrens, I prefer the quietude of Camp Taurajo.  Where shall I send you?','',26124),
(10031,'enUS','Many are the paths of the Earth Mother.  Wherever you decide to travel, may she watch over you.','',26124),
(10032,'enUS','Treat the wind rider well as it takes you to your destination.  May your ancestors watch over you $n.','',26124),
(10033,'enUS','Greetings my friend, and welcome to the greatest show on Azeroth!$B$BPlease, step right up and take in all we have to offer.  Amaze at the wonders that the Darkmoon Faire has uncovered in this vast and mysterious world!  We have spared no expense in bringing you excitement that children of all ages will delight in!','',26124),
(10034,'enUS','Welcome back to the greatest show on Azeroth, my friend!  It is truly a delight to see you once again.$B$BPlease, step right up and once more take in all we have to offer.  Be sure to check around, as we are always adding new and exciting things to the Darkmoon Faire!  Amaze at wonders old and new that we have uncovered!  We continue to spare no expense in bringing you excitement that children of all ages will delight in!','',26124),
(10035,'enUS','Silas, why is most everything at the faire free?  How do you make a profit?','Silas, why is most everything at the faire free?  How do you make a profit?',26124),
(10036,'enUS','It\'s not always about money, clem!  While we receive generous donations - some extremely substantial - our traveling troupe of performers is fueled creatively by a need to brighten this war-torn world.  Don\'t worry about us, but instead let us worry about how to best entertain you.','',26124),
(10037,'enUS','Ticket redemption here!  Get your tickets turned into prizes!  Step right up!','',26124),
(10038,'enUS','Move along, rube.','',26124),
(10039,'enUS','This ain\'t a ride, clem.  Beat it.','',26124),
(10040,'enUS','If you\'re trying to be friendly, save your breath.  Better yet, just stop breathing all together.','',26124),
(10041,'enUS','In case it wasn\'t obvious, I\'m not here for customer relations.','',26124),
(10042,'enUS','You mess with Silas, you mess with me.  Have a nice day.','',26124),
(10043,'enUS','I need a second head like I need to lose my first one.','',26124),
(10044,'enUS','I lived in Dire Maul for a little bit.  That was fun.  Really.','',26124),
(10045,'enUS','Unlike most ogres, I do know what an outhouse is for - giving you a swirlie.  Now beat it.','',26124),
(10046,'enUS','I have long known you\'d seek me out, $n.$B$BEvery sentient being in this world is driven by the choices they make.  Choices beget further choices, and these in turn make someone who they are.  This is where your fortune is drawn from - who you are, and the choices you make.$B$BAre you ready to discover where your fortune lies?','',26124),
(10047,'enUS','I am ready to discover where my fortune lies!','I am ready to discover where my fortune lies!',26124),
(10048,'enUS','Very well then...$B$BYou have been tasked by your liege to guard his fields of corn from poachers and thieves.  One night on patrol, you stumble across a haggard man in thread-bare clothing stealing corn from the field.  You quickly confront him, and he immediately begs for his life.  He claims he is stealing the corn to feed his family since the lord of the land - your liege - demands too much in taxes.  Your liege is indeed known for his harsh taxes throughout the land.$B$BMake your choice.','',26124),
(10049,'enUS','I slay the man on the spot as my liege would expect me to do, as he is nothing more than a thief and a liar.','I slay the man on the spot as my liege would expect me to do, as he is nothing more than a thief and a liar.',26124),
(10050,'enUS','I turn over the man to my liege for punishment, as he has broken the law of the land and it is my sworn duty to enforce it.','I turn over the man to my liege for punishment, as he has broken the law of the land and it is my sworn duty to enforce it.',26124),
(10051,'enUS','I confiscate the corn he has stolen, warn him that stealing is a path towards doom and destruction, but I let him go to return to his family.','I confiscate the corn he has stolen, warn him that stealing is a path towards doom and destruction, but I let him go to return to his family.',26124),
(10052,'enUS','I allow the man to take enough corn to feed his family for a couple of days, encouraging him to leave the land.','I allow the man to take enough corn to feed his family for a couple of days, encouraging him to leave the land.',26124),
(10053,'enUS','Your next choice awaits.$B$BYou are the sworn executioner for your liege.  A man has been sent to you for execution as a traitor of the liege and your people.  You know this individual as a close, virtuous friend who mysteriously vanished one day.  You also know that the man\'s crimes for which he was convicted supposedly caused the deaths of many innocent civilians.  Upon seeing you he begs for his life, claiming he was framed by a higher authority.$B$BMake your choice.','',26124),
(10054,'enUS','','Begone, uncouth scum!  The Alliance shall prevail in Alterac Valley!',26124),
(10055,'enUS','Die!  Your kind has no place in Alterac Valley!','',26124),
(10056,'enUS','','Take heart, Alliance!  Throw these villains from Alterac Valley!',26124),
(10057,'enUS','Now is the time to attack!  For the Horde!','',26124),
(10058,'enUS','Can\'t you see I\'ve got work to do here?','Can\'t you see I\'ve got work to do here?',26124),
(10059,'enUS','Faire\'s a coming!','Faire\'s a coming!',26124),
(10060,'enUS','That\'s right friend!  The Darkmoon Faire is going to be right here.  Just as soon as I unload those huge wagons, put up all the tents, erect the zoo and pour the drinks.  Make sure you come back!','That\'s right friend!  The Darkmoon Faire is going to be right here.  Just as soon as I unload those huge wagons, put up all the tents, erect the zoo and pour the drinks.  Make sure you come back!',26124),
(10061,'enUS','Won\'t be long now until the Darkmoon Faire opens.  Come back later and check to see if we\'re done.','Won\'t be long now until the Darkmoon Faire opens.  Come back later and check to see if we\'re done.',26124),
(10062,'enUS','Welcome to the faire young one!   We have collected wonders from all over the world for your perusal.   Oh and please let me know if you manage to collect a set of the lesser darkmoon cards, as the master... I mean I would be keenly interested in them.','',26124),
(10064,'enUS','Tell me more about these Darkmoon Cards.','Tell me more about these Darkmoon Cards.',26124),
(10065,'enUS','We have seeded darkmoon cards around the world to see if any worthy individuals could complete a set of any of the eight suits.  If you manage to collect all eight cards of one of the suits we will reward you with one of the greater darkmoon cards that functions as a powerful trinket as well as a link to the Darkmoon Faire.','',26124),
(10066,'enUS','Would you like something more to eat sir?','',26124),
(10067,'enUS','Tell me about the Beasts Deck.','Tell me about the Beasts Deck.',26124),
(10068,'enUS','If you manage to complete a deck of beasts cards you will be rewarded with a greater darkmoon card of the blue dragon.   This is very useful in restoring of magical energies.','',26124),
(10069,'enUS','Tell me about the Portals Deck.','Tell me about the Portals Deck.',26124),
(10070,'enUS','If you manage to complete a deck of portals cards you will be rewarded with a greater darkmoon card of the twisting nether.   This card will occasionally pull your spirit back into your body after death and restore you.','',26124),
(10071,'enUS','Tell me about the Elementals Deck.','Tell me about the Elementals Deck.',26124),
(10072,'enUS','If you manage to complete a deck of elementals cards you will be rewarded with a greater darkmoon card of the maelstrom.   This card will occasionally impact an enemy you are fighting with for heavy damage.','',26124),
(10073,'enUS','Tell me about the Warlords Deck.','Tell me about the Warlords Deck.',26124),
(10074,'enUS','If you manage to complete a deck of warlords cards you will be rewarded with a greater darkmoon card of heroism.   This card will occasionally heal you while you are engaged in melee combat.','',26124),
(10075,'enUS','I execute him as per my liege\'s instructions, and do it in such a manner that he suffers painfully before he dies as retribution for his crimes against my people.','I execute him as per my liege\'s instructions, and do it in such a manner that he suffers painfully before he dies as retribution for his crimes against my people.',26124),
(10076,'enUS','I execute him as per my liege\'s instructions, but doing so in as painless of a way as possible.  Justice must be served, but I can show some compassion.','I execute him as per my liege\'s instructions, but doing so in as painless of a way as possible.  Justice must be served, but I can show some compassion.',26124),
(10077,'enUS','I risk my own life and free him so that he may prove his innocence.  If I can, I\'ll help him in any way.','I risk my own life and free him so that he may prove his innocence.  If I can, I\'ll help him in any way.',26124),
(10078,'enUS','Your next choice awaits.$B$BYou are on a diplomatic mission for your liege to a cruel country that is currently at war with yours.  The war has been costly on both sides.  Your mission is to secure a peace that is honorable to both peoples.$B$BAt a diplomatic dinner, you overhear the ruler of the opposing land viciously insult your benevolent liege.  You are fairly certain the ruler meant to say it out of your earshot, but nonetheless he has besmirched your liege\'s honor.$B$BMake your choice.','',26124),
(10079,'enUS','I confront the ruler on his malicious behavior, upholding my liege\'s honor at the risk of any future diplomacy.','I confront the ruler on his malicious behavior, upholding my liege\'s honor at the risk of any future diplomacy.',26124),
(10080,'enUS','I not-so-quietly ignore the insult, hoping to instill a fear in the ruler that he may have gaffed.  I then inform my liege of the insult when I return.','I not-so-quietly ignore the insult, hoping to instill a fear in the ruler that he may have gaffed.  I then inform my liege of the insult when I return.',26124),
(10081,'enUS','I quietly ignore the insult.  I will not tell my liege, as I am to secure peace at all costs.  It\'s only an insult - not a declaration of war.','I quietly ignore the insult.  I will not tell my liege, as I am to secure peace at all costs.  It\'s only an insult - not a declaration of war.',26124),
(10082,'enUS','Your next choice awaits.$B$BYour brother seeks to join the ranks of the prestigious military order you are already a part of.  While you are sure of his commitment and loyalty, his talent and ability to perform the arduous tasks of the order is what you question.  While you are not certain he will be able to rise to the challenge of the order - putting you and others in danger - you are certain that your word alone would allow him in or keep him out.$B$BMake your choice.','',26124),
(10083,'enUS','I would speak against my brother joining the order, rushing a permanent breach in our relationship.  He would be a danger to himself and those around him, and that is too great a risk hoping he would improve over time.','I would speak against my brother joining the order, rushing a permanent breach in our relationship.  He would be a danger to himself and those around him, and that is too great a risk hoping he would improve over time.',26124),
(10084,'enUS','I would speak for my brother joining the order, potentially risking the safety of the order.  I could help him with the order\'s regimens, and I\'d have faith in his ability to adapt and learn.','I would speak for my brother joining the order, potentially risking the safety of the order.  I could help him with the order\'s regimens, and I\'d have faith in his ability to adapt and learn.',26124),
(10085,'enUS','I would create some surreptitious means to keep my brother out of the order.  I can keep him out without him being any bit wiser, thereby saving our familial bonds.','I would create some surreptitious means to keep my brother out of the order.  I can keep him out without him being any bit wiser, thereby saving our familial bonds.',26124),
(10086,'enUS','Your next choice awaits.$B$BYou alone have defeated a terrible beast that has been ravaging the countryside, taking its ear as a trophy.  You later learn that your liege had offered a reward for the beast\'s death, and that a kind but destitute knight who you know is trying to support a family by meager means claims the beast\'s kill as his own.  You have no real need for money yourself, but you know that the destitute knight is lying for his own personal gain.$B$BMake your choice.','',26124),
(10087,'enUS','I would show my liege the beast\'s ear and claim the beast\'s death as my own, taking the reward for my own use.  It is wrong to claim a deed as your own that someone else in fact did.','I would show my liege the beast\'s ear and claim the beast\'s death as my own, taking the reward for my own use.  It is wrong to claim a deed as your own that someone else in fact did.',26124),
(10088,'enUS','I would show my liege the beast\'s ear and claim the beast\'s death as my own - after all, I did slay it.  I would then offer some of the reward to the destitute knight to help his family.','I would show my liege the beast\'s ear and claim the beast\'s death as my own - after all, I did slay it.  I would then offer some of the reward to the destitute knight to help his family.',26124),
(10089,'enUS','I would remain silent about the kill and allow the knight to claim the reward to aid his family.','I would remain silent about the kill and allow the knight to claim the reward to aid his family.',26124),
(10090,'enUS','Your fortune is cast, $c.  For the next few hours, you will find your spirit in tune with your true nature.  Be careful, as your fortune - and your fate - are never as clear as you might think them to be.$B$BIf you would like a small glimpse of something to ponder in your future, by all means let me know.  I\'d be happy to give you a written fortune, provided you have room in your inventory.  It is one drawn from the insight you have shown in answering my questions.','',26124),
(10091,'enUS','I\'d love to get one of those written fortunes you mentioned!  I\'ve got the space in my inventory for it.','I\'d love to get one of those written fortunes you mentioned!  I\'ve got the space in my inventory for it.',26124),
(10092,'enUS','Here is your fortune, $n.  May it serve you well.','',26124),
(10093,'enUS','The Darkmoon Faire is coming to town!  Don\'t miss it!','',26124),
(10094,'enUS','Be sure to catch all the amazing sights and wonders of the Darkmoon Faire when it comes to town!','',26124),
(10095,'enUS','The Darkmoon Faire is coming!  There is fun for children of ALL ages!  Come one, come all!','',26124),
(10096,'enUS','Step right up and hear about the most amazing spectacle in all of Azeroth - the Darkmoon Faire!  Huzzah!','',26124),
(10097,'enUS','The Darkmoon Faire is coming to town!  Don\'t miss it!','',26124),
(10098,'enUS','The Darkmoon Faire is coming!  There is fun for children of ALL ages!  Come one, come all!','',26124),
(10099,'enUS','Step right up and hear about the most amazing spectacle in all of Azeroth - the Darkmoon Faire!  Huzzah!','',26124),
(10100,'enUS','Be sure to catch all the amazing sights and wonders of the Darkmoon Faire when it comes to town!','',26124),
(10101,'enUS','It\'s here!  The Darkmoon Faire is now open for business!  Be sure to see the most exciting show on all of Azeroth!','',26124),
(10102,'enUS','The Darkmoon Faire has come to town!  Be sure to experience the most thrilling show you\'ll ever see!','',26124),
(10103,'enUS','The Darkmoon Faire will only be live for a short time before the curtains are drawn closed.  Be sure to visit it today!','',26124),
(10104,'enUS','Boys and girls - children of all ages - the Darkmoon Faire has arrived!  Huzzah!','',26124),
(10105,'enUS','It\'s here!  The Darkmoon Faire is now open for business!  Be sure to see the most exciting show on all of Azeroth!','',26124),
(10106,'enUS','The Darkmoon Faire has come to town!  Be sure to experience the most thrilling show you\'ll ever see!','',26124),
(10107,'enUS','The Darkmoon Faire will only be live for a short time before the curtains are drawn closed.  Be sure to visit it today!','',26124),
(10108,'enUS','Boys and girls - children of all ages - the Darkmoon Faire has arrived!  Huzzah!','',26124),
(10109,'enUS','When the Darkmoon Faire arrives, where will it be located?','When the Darkmoon Faire arrives, where will it be located?',26124),
(10110,'enUS','The Darkmoon Faire has already arrived, you say?  Where is it located?','The Darkmoon Faire has already arrived, you say?  Where is it located?',26124),
(10111,'enUS','The next location of the Darkmoon Faire has not been finalized yet, but when it is you and I will be the first to know!','',26124),
(10112,'enUS','The Darkmoon Faire is right now located in Elwynn Forest, just south of Goldshire.  Don\'t miss it!','',26124),
(10113,'enUS','When the Darkmoon Faire is open, it will be located in Elwynn Forest.  We\'ll be pitching our tents just south of Goldshire!','',26124),
(10114,'enUS','The Darkmoon Faire is right now located in the golden plains of Mulgore, just southwest of Thunder Bluff.  Don\'t miss it!','',26124),
(10115,'enUS','When the Darkmoon Faire opens, it will be located in Mulgore.  We\'ll be pitching our tents just southwest of Thunder Bluff!','',26124),
(10116,'enUS','asdasd','',26124),
(10117,'enUS','Hello friend.','Hello friend.',26124),
(10118,'enUS','Sure are a lot of litter bugs around here.','Sure are a lot of litter bugs around here.',26124),
(10119,'enUS','Having a good time?','Having a good time?',26124),
(10120,'enUS','Don\'t forget to buy refreshments and souvenirs!','Don\'t forget to buy refreshments and souvenirs!',26124),
(10121,'enUS','The Darkmoon Faire is the greatest event on all of Azeroth!','The Darkmoon Faire is the greatest event on all of Azeroth!',26124),
(10122,'enUS','%s fixates on $n.','%s fixates on $n.',26124),
(10123,'enUS','','Welcome to the Darkmoon Faire, $c!$B$BMy name is Kerri Hicks and I\'d shake your hand but I\'m afraid I\'d break it, because I\'m the strongest woman alive!',26124),
(10124,'enUS','','Hi $n!  Thanks for all the help you\'ve given me!  Right now I don\'t need anything, but who knows what the future will bring?$B$BEnjoy yourself, and remember to tell your friends about the Darkmoon Faire!',26124),
(10125,'enUS','Come to me and see what the future holds for you!','',26124),
(10126,'enUS','Come speak with me, and what once was cloudy shall become crystal clear.','',26124),
(10127,'enUS','Fear not!  All fortunes can be discerned for those who know the way.','',26124),
(10128,'enUS','The longer you wait, the less future you have for me to foretell.','',26124),
(10129,'enUS','','Cheap beer!  Get your cheap beer right here!',26124),
(10130,'enUS','','Huzzah for the tipper!  Step right up and get your delicious, cold drinks right here!',26124),
(10131,'enUS','','Just in... another batch of Darkmoon Special Reserve.  Come get yours before they\'re all gone!',26124),
(10132,'enUS','','You there!  Yes you!  You look thirsty.  Get over here, I have just what you need!',26124),
(10133,'enUS','Step right up!  Get your red hot wings right here!','',26124),
(10134,'enUS','Darkmoon Dogs fresh off the grill.  Come and get \'em while they\'re hot!','',26124),
(10135,'enUS','You\'ve got money and we\'ve got food.  What are you waiting for?!','',26124),
(10136,'enUS','For a limited time only, crunchy frog available exclusively here at the Darkmoon Faire.','',26124),
(10137,'enUS','Have a completed Darkmoon deck? Turn it in here!','',26124),
(10138,'enUS','Come speak with me if you have any Darkmoon Faire Cards.','',26124),
(10139,'enUS','Darkmoon decks! Turn them in here!','',26124),
(10140,'enUS','Have you any Darkmoon Faire cards?  Come speak with me to learn more about them if you dare!','',26124),
(10141,'enUS','','Every item that I have for sale I acquired myself.  You have my personal guarantee of authenticity.',26124),
(10142,'enUS','','Darkmoon Faire Cards?  See the Professor here for those.',26124),
(10143,'enUS','','Come and take a look at my wares while you still can.  We\'re here all week, and then we\'re off to some far off land.',26124),
(10144,'enUS','','Have you any idea what I go through to bring these incomparable valuables to sell?  Come see them all for yourself!',26124),
(10145,'enUS','Hey, someone help me catch this thing!','',26124),
(10146,'enUS','It\'s getting away!','',26124),
(10147,'enUS','Get back here!','',26124),
(10148,'enUS','Frogs and leather balls for sale!','',26124),
(10149,'enUS','Tickets! Redeem your Darkmoon Prize Tickets here!  Wondrous and exotic prizes are waiting for you!','',26124),
(10150,'enUS','Mysterious prizes await the adventurous.  Step right up, step right up!','',26124),
(10151,'enUS','Five tickets or five hundred, it doesn\'t matter friend, everybody is a winner!','',26124),
(10152,'enUS','Prizes!  Get your prizes right here!  Get over here and turn in your Darkmoon Prize Tickets for valuable prizes!','',26124),
(10153,'enUS','Everyone enjoying themselves so far?  That\'s great!  Welcome to the Darkmoon Faire, the greatest show on all of Azeroth!  Make sure that you speak with Yebb and his friends here while you\'re taking in Neblegear\'s Darkmoon Zoo Bizarre.','',26124),
(10154,'enUS','Come one, come all.  Welcome to the Darkmoon Faire!  Don\'t be shy.  Step right up to Lhara and buy yourself an exotic artifact from far off lands.  If you\'re one of the lucky few who have found Darkmoon Cards, have a word with Professor Paleo.  Hungry?  Thirsty?  You\'re in luck!  Refreshments are available right here from Sylannia and Stamp.  I recommend the Darkmoon Special Reserve to wash down some Red Hot Wings.  And if the future is what you seek, then run, don\'t walk, to speak with Sayge.','',26124),
(10155,'enUS','Welcome one and all to the Darkmoon Faire, the greatest event in all the world!  We have it all... delicious food, strong drink, exotic artifacts, fortunes read, amazing prizes and excitement without end!  Don\'t forget to turn in your Darkmoon Faire Prize Tickets to Gelvas Grimegate!  All it takes is five or more and you\'re on your way to the most wondrous prizes on all of Azeroth.  Everybody is a winner!','',26124),
(10156,'enUS','Welcome one and all to the greatest show on all of Azeroth... the Darkmoon Faire!  Adventure and excitement await, don\'t be shy!  Mysteries and prizes for both the young and the old are here for the taking.  And be sure to speak with the professor about any Darkmoon Cards that you have come across during your travels!','',26124),
(10157,'enUS','Greetings friends, and welcome to the greatest show on Azeroth!$B$BPlease, step right up and take in all we have to offer.  Ride the rides and see the sights!  Amaze at the wonders that the Darkmoon Faire has uncovered in this vast and mysterious world!  We have spared no expense in bringing you excitement that children of all ages will delight in!','',26124),
(10158,'enUS','Come one, come all!  Welcome to the Darkmoon Faire!  Do you crave adventure?  Do you seek exotic and mysterious treasures?  Then look no further!  You, my friend, have come to the right place!  Dive right in and take part in all that the Faire has to offer!  We\'ll be at this location all week, so be sure to tell your friends and loved ones!','',26124),
(10159,'enUS','Alas... I am sorry to say I cannot currently give you your fortune, as you have recently received a fortune reading from me.$B$BReturn to me several hours from when you first received your fortune.  The forces of Fate will have properly recalibrated themselves, and I will be able to see into your future.','',26124),
(10160,'enUS','We\'re back and better than ever!  It\'s the Darkmoon Faire friend, and it\'s your lucky day!  Sparing no expense, we\'ve gathered wonders and treats from around the world for your delight.  Whether you\'re young or old, rich or poor, the Darkmoon Faire has it all!  Be sure to turn in your Darkmoon Faire Prize Tickets to Gelvas Grimegate, and choose from several exotic and wondrous prizes!','',26124),
(10161,'enUS','','$n, it\'s good to see you again!  Are you having fun at the Faire?$B$BWant to arm wrestle?  No, of course not... you want to keep your arm!',26124),
(10162,'enUS','Greetings.  I am Chronos - He Who Never Forgets.  My memory is without flaw, and exact to the most minor detail.$B$BTrust me.','',26124),
(10163,'enUS','Hello again, $n.  Did you think I would forget you?$B$BI knew you would not.  You are a clever $c who knows a person with perfect memory when $ghe:she; sees him.','',26124),
(10164,'enUS','Hello!  And welcome!  I\'m afraid my booth is not open... many repairs are needed...$B$BBut I am still bound by blood oath to put a smile on your face.  So please, smile, or I must cut off my hand and consume no living flesh until it regenerates...','',26124),
(10165,'enUS','$n, you return!  The spirits of my last meal said you would come see me and that we would discuss business.$B$BWere they correct?','',26124),
(10166,'enUS','Hello again, $n!  It\'s good to see you!  Our Darkmoon Faire is quite a show, don\'t you think?$B$BThere is quite a lot to see!  So look!  Look, and perhaps, one day, even more will be revealed to you...','',26124),
(10167,'enUS','%s guzzles down the ale!','',26124),
(10168,'enUS','','I can\'t find my pet frog, Jubjub.  She loves Dark Iron Ale, it\'s all she ever drinks, but can be so hard to get!  Now I\'m out... and Jubjub must have run away to find more!$B$BI wish she would come back...',26124),
(10169,'enUS','','I\'m so happy that Jubjub returned!  I only hope that I don\'t run out of Dark Iron ale soon, or I fear my pet frog might once again escape!',26124),
(10170,'enUS','','Hi Jubjub.  I missed you!',26124),
(10171,'enUS','','Jubjub?  Where are you, Jubjub?  Oh no!  Where did you go this time!',26124),
(10172,'enUS','%s hears her owner\'s voice!','',26124),
(10173,'enUS','We must ensure the survival of this camp at all costs, $c!  Our enemies must not be given any quarter, for they would surely give us none were we to need it.','',26124),
(10174,'enUS','These are dangerous times, $r.  An ancient evil is rising, and it cares not if you\'re Horde or Alliance.','',26124),
(10175,'enUS','','Tasty drinks for sale!  Quench your thirst on some of the Darkmoon Faire\'s finest brews!',26124),
(10176,'enUS','','Don\'t be shy, buy a round for everyone!',26124),
(10177,'enUS','','Tips are always graciously accepted, friend.',26124),
(10178,'enUS','','Just in... another batch of Darkmoon Special Reserve.  Come get yours before they\'re all gone!',26124),
(10179,'enUS','Show me the drinks!','Show me the drinks!',26124),
(10180,'enUS','Ribbit.','',26124),
(10181,'enUS','Kiss me.','',26124),
(10182,'enUS','What do you have for sale?','What do you have for sale?',26124),
(10183,'enUS','More bread boy!','',26124),
(10184,'enUS','Here is your bread sir.','',26124),
(10185,'enUS','Mmm... food.','Mmm... food.',26124),
(10186,'enUS','You mean to tell me you sell frogs?','You mean to tell me you sell frogs?',26124),
(10187,'enUS','Molthor sees all, $r.','',26124),
(10188,'enUS','Greetings young $c. It is here that your Warchief challenged Orgrim Doomhammer! Although it happened so many years ago, it is an image still fresh in my mind.','',26124),
(10189,'enUS','How many of our Commanders are still alive, Drek\'Thar?','How many of our Commanders are still alive, Drek\'Thar?',26124),
(10190,'enUS','$966w, young $c.','',26124),
(10191,'enUS','','Come to learn, eh? Well I just might have some work for you, scrub.',26124),
(10192,'enUS','<Sergeant Stormpike salutes.>$B$BName, rank, and serial number, soldier! That\'s the only bit of information you\'ll ever give those dirty Frostwolf dogs!','',26124),
(10195,'enUS','Hmmm... I think I need better bait. I\'ll check my father\'s wagon.','',26124),
(10196,'enUS','Quillboar scraps! These should do the trick. Fish love Quillboar.','',26124),
(10197,'enUS','Let\'s give this a try...','',26124),
(10198,'enUS','I caught a fish if you are hungry...','',26124),
(10199,'enUS','$n has assaulted the Stables!','',26124),
(10200,'enUS','$n has assaulted the Stables!','',26124),
(10201,'enUS','$n has defended the Stables!','',26124),
(10202,'enUS','$n has defended the Stables!','',26124),
(10203,'enUS','The Alliance has taken the Stables!','',26124),
(10204,'enUS','The Horde has taken the Stables!','',26124),
(10205,'enUS','Caught one! I\'ll see if any of the guards are hungry. Come on Fang!','',26124),
(10206,'enUS','Zug zug! Happy to help!','',26124),
(10207,'enUS','How many of our Lieutenants are alive, Drek\'Thar?','How many of our Lieutenants are alive, Drek\'Thar?',26124),
(10208,'enUS','$964w, young $c.','',26124),
(10209,'enUS','How many of the Stormpike\'s Officers are still alive, Drek\'Thar?','How many of the Stormpike\'s Officers are still alive, Drek\'Thar?',26124),
(10210,'enUS','$962w Stormpike Commander(s) and $950w Stormpike Lieutenant(s).\n','',26124),
(10211,'enUS','$n has assaulted the Blacksmith!','',26124),
(10212,'enUS','$n has assaulted the Blacksmith!','',26124),
(10213,'enUS','The Alliance has taken the Blacksmith!','',26124),
(10214,'enUS','The Horde has taken the Blacksmith!','',26124),
(10215,'enUS','$n has defended the Blacksmith!','',26124),
(10216,'enUS','$n has defended the Blacksmith!','',26124),
(10217,'enUS','$n has assaulted the Farm!','',26124),
(10218,'enUS','$n has assaulted the Farm!','',26124),
(10219,'enUS','The Alliance has taken the Farm!','',26124),
(10220,'enUS','The Horde has taken the Farm!','',26124),
(10221,'enUS','$n has defended the Farm!','',26124),
(10222,'enUS','$n has defended the Farm!','',26124),
(10223,'enUS','A nice catch it is at that! You bring honor to the Horde boy, we thank you!','',26124),
(10224,'enUS','$n has assaulted the Lumber Mill!','',26124),
(10225,'enUS','$n has assaulted the Lumber Mill!','',26124),
(10226,'enUS','The Alliance has taken the Lumber Mill!','',26124),
(10227,'enUS','The Horde has taken the Lumber Mill!','',26124),
(10228,'enUS','$n has defended the Lumber Mill!','',26124),
(10229,'enUS','$n has defended the Lumber Mill!','',26124),
(10230,'enUS','$n has assaulted the mine!','',26124),
(10231,'enUS','$n has assaulted the mine!','',26124),
(10232,'enUS','The Alliance has taken the mine!','',26124),
(10233,'enUS','The Horde has taken the mine!','',26124),
(10234,'enUS','$n has defended the mine!','',26124),
(10235,'enUS','$n has defended the mine!','',26124),
(10236,'enUS','I promise you this much: The Valley will be ours.','',26124),
(10237,'enUS','How many of our Commanders are alive, Vanndar?','How many of our Commanders are alive, Vanndar?',26124),
(10238,'enUS','$962w, soldier.','',26124),
(10239,'enUS','How many of our Lieutenants are alive, Vanndar?','How many of our Lieutenants are alive, Vanndar?',26124),
(10240,'enUS','$950w, soldier.','',26124),
(10241,'enUS','How many Frostwolf Officers are alive, Vanndar?','How many Frostwolf Officers are alive, Vanndar?',26124),
(10242,'enUS','$966w Frostwolf Commander(s) and $964w Frostwolf Lieutenant(s), soldier.','',26124),
(10243,'enUS','Soldiers of Stormpike, your General is under attack! I require aid! Come! Come! Slay these mangy Frostwolf dogs.','',26124),
(10245,'enUS','Stormpike filth! In my keep?! Slay them all!','',26124),
(10249,'enUS','Hmmm... Where is my fishing hook? Oh, there it is.','',26124),
(10250,'enUS','Let\'s see if the fish are biting.','',26124),
(10251,'enUS','','Trok are you hungry? I\'m making some food for us to eat! ',26124),
(10252,'enUS','','Trok? Why are you running around like fearful human?',26124),
(10253,'enUS','','You\'re supposed to be doing your chores!',26124),
(10255,'enUS','','I wonder if the pigs are hungry...',26124),
(10256,'enUS','','Are you piggies hungry? I have some food for you...',26124),
(10257,'enUS','','I guess you were hungry! Trok was supposed to have fed you earlier... What has he been doing all this time?',26124),
(10259,'enUS','Help! I\'m being chased by a swarm of bees!','',26124),
(10260,'enUS','I\'m so tired of running, but these bees won\'t leave me alone!','',26124),
(10261,'enUS','I didn\'t know bees didn\'t like fire!','',26124),
(10262,'enUS','Karu will you please help get these bees off of me? They sting!','',26124),
(10265,'enUS','Aaahh... Very good. Now scat!','',26124),
(10266,'enUS','As you wish sir.','',26124),
(10267,'enUS','Right away sir.','',26124),
(10268,'enUS','If you have come to save the world then you have come to the right place. The faceless one - the Blood God, Hakkar - has been brought back into our world!','',26124),
(10269,'enUS','The strength of your resolve shines, $n. You continue to prove that you are an asset to our people. Someday the world will realize the extent of your great deeds.','',26124),
(10270,'enUS','The burgeoning hero returns! It is good to see you again, $n. You are always welcome at our village.','',26124),
(10271,'enUS','I knew of another like you once... His name was Vol\'jin. You are a rare breed, my friend.','',26124),
(10272,'enUS','Long is the way, and hard, the road you have traveled. Few reach such status amongst our ranks. You are a great friend of the Zandalar empire, $n.$B$BLegendary perhaps... Yes... Perhaps.','',26124),
(10273,'enUS','Right away sir.','',26124),
(10274,'enUS','','Can I go collect more rocks for my necklace, Papa?',26124),
(10275,'enUS','Yes you may, Okla. But do not stray too far from home. ','',26124),
(10276,'enUS','','Dabu! I will be careful Papa!',26124),
(10277,'enUS','','Ooohh... This rock is nice and colorful. Let\'s see if I can find more like it...',26124),
(10278,'enUS','','Hmm... That rock is nice, but too small.',26124),
(10279,'enUS','','This is a shiney rock, I\'ll put it in my bucket. Ok, I just need a few more...',26124),
(10280,'enUS','','I bet my friend Gruk would like this rock for the spear he is making! It\'s very sharp... I hope he likes it.',26124),
(10281,'enUS','','There... That should be enough rocks to make a necklace. I should probably get home now anyway.',26124),
(10282,'enUS','$n claims the mine!  If left unchallenged, the Alliance will control it in 1 minute!','',26124),
(10283,'enUS','$n claims the mine!  If left unchallenged, the Horde will control it in 1 minute!','',26124),
(10284,'enUS','$n claims the lumber mill!  If left unchallenged, the Alliance will control it in 1 minute!','',26124),
(10285,'enUS','$n claims the lumber mill!  If left unchallenged, the Horde will control it in 1 minute!','',26124),
(10286,'enUS','$n claims the stables!  If left unchallenged, the Alliance will control it in 1 minute!','',26124),
(10287,'enUS','$n claims the stables!  If left unchallenged, the Horde will control it in 1 minute!','',26124),
(10288,'enUS','$n claims the farm!  If left unchallenged, the Alliance will control it in 1 minute!','',26124),
(10289,'enUS','$n claims the farm!  If left unchallenged, the Horde will control it in 1 minute!','',26124),
(10290,'enUS','$n claims the blacksmith!  If left unchallenged, the Alliance will control it in 1 minute!','',26124),
(10291,'enUS','$n claims the blacksmith!  If left unchallenged, the Horde will control it in 1 minute!','',26124),
(10292,'enUS','','Yummy. I love roasted Plainstrider.',26124),
(10293,'enUS',' I am going to practice and become a warrior like my father!','',26124),
(10294,'enUS','Now to find an unsuspecting Harpy!','',26124),
(10295,'enUS','There\'s one! For the Horde!','',26124),
(10296,'enUS','Take that you mangy Harpy! Hyaa!','',26124),
(10297,'enUS','You can\'t get away from a warrior of The Horde! Take that! And that!','',26124),
(10298,'enUS','Now go back home where you belong! ','',26124),
(10299,'enUS','Aaahhh... Another glorious victory for The Horde! ','',26124),
(10300,'enUS','','Mogg, get inside. It is not safe out there while your father is gone.',26124),
(10301,'enUS','Yes right away momma! ','',26124),
(10303,'enUS','When is pappa coming back from the fights in Warsong? It has been so long... ','',26124),
(10304,'enUS','','Soon child... very soon.',26124),
(10305,'enUS','','What happened to our pigs?',26124),
(10306,'enUS','Guard, Bring forth the prisoner. Place him in the Circle of Binding.','',26124),
(10307,'enUS','Right away, Servitor.','',26124),
(10308,'enUS','Move!','',26124),
(10309,'enUS','Kneel, heathen.','',26124),
(10310,'enUS','Curious. A Servitor of Rastakhan that does not know the Hakkari do not converse in the old tongue?','',26124),
(10311,'enUS','I said KNEEL!','',26124),
(10312,'enUS','Do you know who I am, zealot?','',26124),
(10313,'enUS','You are a fool, soon to forfeit his life. No?','',26124),
(10314,'enUS','I could crush you with but a single motion. Do not anger me.','',26124),
(10315,'enUS','%s laughs.','',26124),
(10316,'enUS','How pathetic. I am infused with the power of the Soulflayer. I fear nothing but the wrath of the almighty Hakkar. I serve no one but my master, Jin.','',26124),
(10317,'enUS','So Hakkar has returned?','',26124),
(10318,'enUS','Do you really need to ask? Can you not feel him? Has the almighty King Rastakhan sent his Servitor and Hand here on a mission of diplomacy?','',26124),
(10319,'enUS','Oh yes, old one, Hakkar has returned. Soon the world shall crumble beneath his might. Consumed. Left in ruin...','Oh yes, old one, Hakkar has returned. Soon the world shall crumble beneath his might. Consumed. Left in ruin...',26124),
(10320,'enUS','We will never allow it... We have banished him from our world before and we will banish him again.\n','',26124),
(10321,'enUS','%s laughs maniacally.','',26124),
(10322,'enUS','FOOL! Do you purport to have even one-tenth of the power you held during the Uprising? The nations were united and still were nearly consumed by a shadow of Hakkar. You stand no chance.','',26124),
(10323,'enUS','And now, even those nations that you would have called allies have recoiled and joined forces with us... Yes, old one, do not look so surprised.','',26124),
(10324,'enUS','Bloodscalp, Sandfury, Skullsplitter, Vilebranch and Witherbark. They all pledge their allegiance to Jin - their souls to Hakkar. You have lost.','',26124),
(10325,'enUS','Times have changed. The young races will join us. You will never succeed.','',26124),
(10326,'enUS','The young races? The infants? Humans? Orcs? Dwarves? You expect to defeat the Hakkari? To destroy a GOD?','',26124),
(10327,'enUS','It shall NEVER happen. We are legion. We are united. Where are your heroes? Vol\'jin sits in sanctuary at the side of the young Warchief, unaware. Zul\'jin missing, probably dead.','',26124),
(10328,'enUS','And... do you expect to defeat the Primal Gods?','',26124),
(10329,'enUS','%s smirks.','',26124),
(10330,'enUS','The Primal Gods? Impossible!','',26124),
(10331,'enUS','Is it? Call out to them, Servitor.','',26124),
(10332,'enUS','%s uses his index finger to make a cutting motion across his neck.','',26124),
(10333,'enUS','Where are your Gods now? WHERE, SERVITOR?','',26124),
(10334,'enUS','Strike me down. I shall be reborn... Even more powerful...','',26124),
(10335,'enUS','%s drops his shoulders and exposes his neck.','',26124),
(10336,'enUS','%s spits on the corpse of the fallen zealot.','',26124),
(10337,'enUS','I would like to enter my e-coupon code to win the virtual item.','I would like to enter my e-coupon code to win the virtual item.',26124),
(10338,'enUS','Welcome to the iCoke-WOW summer promotion.$B$BDear $n, the halo of fortune goddess is shining on you.  Obey to the order of god; you\'ll get a special and mystery present.  Now, the gate of Azeroth is open for you.  A great adventure will begin soon.  Are you ready?$B$BMay the honor be with you!','Welcome to the iCoke-WOW summer promotion.$B$BDear $n, the halo of fortune goddess is shining on you.  Obey to the order of god; you\'ll get a special and mystery present.  Now, the gate of Azeroth is open for you.  A great adventure will begin soon.  Are you ready?$B$BMay the honor be with you!',26124),
(10339,'enUS','','Guse is joining the battle! Time to take out the Stormpike filth!',26124),
(10340,'enUS','','Awaiting orders!',26124),
(10341,'enUS','The time has come, Guse. You fly again!','The time has come, Guse. You fly again!',26124),
(10342,'enUS','','Jeztor\'s coming for you, Stormpike!',26124),
(10343,'enUS','Jeztor lives! Time to light up the Valley sky, Commander.','Jeztor lives! Time to light up the Valley sky, Commander.',26124),
(10344,'enUS','','Let me at \'em, $n! Just give the word and I\'ll mount up and attack their bridge!',26124),
(10345,'enUS','I\'m ready, sir! Just give the word and I will rain down hellfire upon their base!','',26124),
(10346,'enUS','Do you feel it, Mulv? The need? You have to want it before I can give you the command. Who am I kidding. Get out there!','Do you feel it, Mulv? The need? You have to want it before I can give you the command. Who am I kidding. Get out there!',26124),
(10347,'enUS','Incoming aerial support to Dun Baldar! Stormpike bow down!','',26124),
(10348,'enUS','I\'m ready to fly, Commander. Just give the word and I\'ll be on their base like trogg on rock.','',26124),
(10349,'enUS','Take the base. We\'ll be sieging it from the ground.','Take the base. We\'ll be sieging it from the ground.',26124),
(10350,'enUS','I\'ll patrol the pass leading up to Frostwolf Keep. Just give me the word and I\'ll take flight, Commander.','',26124),
(10351,'enUS','I want a surgical strike, Slidore. Carpet the road with fire!','I want a surgical strike, Slidore. Carpet the road with fire!',26124),
(10352,'enUS','Make the call, Commander. I\'ll tear the bottom half of their base apart.','',26124),
(10353,'enUS','Tactical suppression fire, Vipore. Lay it on thick.','Tactical suppression fire, Vipore. Lay it on thick.',26124),
(10354,'enUS','','Greetings $c.  Do you wish to aid the Silverwing Sentinels in their fight at Warsong Gulch?',26124),
(10355,'enUS','I would like to go to the battleground.','I would like to go to the battleground.',26124),
(10356,'enUS','I\'m coming Frostwolf, and this time you\'re gonna feel the flames!','',26124),
(10357,'enUS','Senior Wing Commander Vipore, launching. Pray for a swift death, Frostwolf.','',26124),
(10358,'enUS','Drek\'Thar, I\'m coming for you!','',26124),
(10359,'enUS','Battlemaster','Battlemaster',26124),
(10360,'enUS','','Elune be praised!  You seek out our Warsong Gulch Battlemaster?  Her name is Aethalas, and she stands ready to greet you near the warrior trainers.',26124),
(10361,'enUS','','It is no light endeavor upon which you embark $n.  To get to Warsong Gulch you will want to speak to Aethalas, the Battlemaster of the Silverwing Sentinels.  She will guide your way.  Blessings of the Goddess be with you!',26124),
(10362,'enUS','Battlemaster','Battlemaster',26124),
(10363,'enUS','So $g lad : lass;, you think you have what it takes to defend the Alliance against the Horde in Alterac Valley?  Very well then, you will want to speak with our very own Glordrum Steelbeard here in Ironforge.  You\'ll find him strategizing over the war table in the Hall of Arms.','So $g lad : lass;, you think you have what it takes to defend the Alliance against the Horde in Alterac Valley?  Very well then, you will want to speak with our very own Glordrum Steelbeard here in Ironforge.  You\'ll find him strategizing over the war table in the Hall of Arms.',26124),
(10364,'enUS','Ah, Alterac Valley, I have fine memories I tell ya.  <sigh>  Well, I cannot join ya, but do me proud just the same!  To get there you\'ll be wanting to speak with Glordrum Steelbeard at the Hall of Arms here in Ironforge.','Ah, Alterac Valley, I have fine memories I tell ya.  <sigh>  Well, I cannot join ya, but do me proud just the same!  To get there you\'ll be wanting to speak with Glordrum Steelbeard at the Hall of Arms here in Ironforge.',26124),
(10365,'enUS','Battlemaster','Battlemaster',26124),
(10366,'enUS','If you are going to Alterac Valley then go speak to Kartra Bloodsnarl. You will find her inside the Hall of the Brave in the Valley of Honor.','If you are going to Alterac Valley then go speak to Kartra Bloodsnarl. You will find her inside the Hall of the Brave in the Valley of Honor.',26124),
(10367,'enUS','How I yearn to join you in glorious battle, but instead I am stuck here on duty. Go to the Hall of the Brave in Orgrimmar\'s Valley of Honor and speak to Kartra Bloodsnarl. She will help you get to Alterac Valley. Make us proud $n!','How I yearn to join you in glorious battle, but instead I am stuck here on duty. Go to the Hall of the Brave in Orgrimmar\'s Valley of Honor and speak to Kartra Bloodsnarl. She will help you get to Alterac Valley. Make us proud $n!',26124),
(10368,'enUS','','',26124),
(10369,'enUS','','I command you to rain fire down upon these invaders!',26124),
(10370,'enUS','','%s emits a deafening shriek!',26124),
(10371,'enUS','Tell me about the iCoke promotion.','Tell me about the iCoke promotion.',26124),
(10372,'enUS','World of Warcraft and Coca-Cola (R) have teamed up to bring you the iCoke-World of Warcraft Summer Promotion.  Look for codes under the caps of specially marked bottles of Coca-Cola.  Then return here and enter the code to win a virtual item.','World of Warcraft and Coca-Cola (R) have teamed up to bring you the iCoke-World of Warcraft Summer Promotion.  Look for codes under the caps of specially marked bottles of Coca-Cola.  Then return here and enter the code to win a virtual item.',26124),
(10373,'enUS','You\'ll never get me out of me bunker, heathens!','',26124),
(10374,'enUS','Why don\'t ya try again without yer cheap tactics, pansies! Or are you too chicken???','',26124),
(10375,'enUS','','Filthy Frostwolf cowards! If you want a fight, you\'ll have to come to me!',26124),
(10376,'enUS','Stormpike weaklings, face me in my fortress - if you dare!','',26124),
(10377,'enUS','You seek to draw the General of the Frostwolf legion out from his fortress? PREPOSTEROUS!','',26124),
(10378,'enUS','I\'ll never fall for that, fool! If you want a battle, it will be on my terms and in my lair.','',26124),
(10379,'enUS','I am Jin\'rokh the Breaker, envoy of Mugamba: Fist of Rastakhan!$B$BMy dealings are with warriors and heathens.','',26124),
(10380,'enUS','I have lost my talisman and require a new one, Jin\'rokh.','I have lost my talisman and require a new one, Jin\'rokh.',26124),
(10381,'enUS','I am Al\'tabim the All-Seeing - an envoy of King Rastakhan.$B$BMy dealings are with priests, mages, and warlocks.','',26124),
(10382,'enUS','The League of Arathor has sworn to retake Arathi for humans of Stromgarde and the Alliance.  It is a battle hard fought, but a battle worth fighting.','',26124),
(10383,'enUS','','To win this war, we can\'t sit idle and let the tides sweep us over.  We must strike, hard and fast, or Arathi will never again be ours.',26124),
(10384,'enUS','I have lost the talisman and require a new one, Al\'tabim.','I have lost the talisman and require a new one, Al\'tabim.',26124),
(10385,'enUS','','I know just the one that you speak of $c. You must seek out Brogun Stoneshield on the Warrior\'s Terrace.',26124),
(10386,'enUS','','The Stormpike Guard is in need of your assistance in the fight against the Frostwolf Clan, $n. Speak to Brogun Stoneshield on the Warrior\'s Terrace and he will help you find your way to Alterac Valley. Elune be praised!',26124),
(10387,'enUS','','There are several battlegrounds from which to choose.  To which battlemaster shall I send you?',26124),
(10388,'enUS','Alterac Valley','Alterac Valley',26124),
(10389,'enUS','Warsong Gulch','Warsong Gulch',26124),
(10390,'enUS','We must eliminate the elves and their cowardly Alliance from Warsong Gulch. Go to the Hall of the Brave in the Valley of Honor and speak with Brakgul Deathbringer if you have what it takes to aid the Horde.','We must eliminate the elves and their cowardly Alliance from Warsong Gulch. Go to the Hall of the Brave in the Valley of Honor and speak with Brakgul Deathbringer if you have what it takes to aid the Horde.',26124),
(10391,'enUS','The Silverwing Sentinels are hardly what I would call honorable opponents. But if you are intent upon their slaughter $c, then seek out Brakgul Deathbringer in the Hall of the Brave.','The Silverwing Sentinels are hardly what I would call honorable opponents. But if you are intent upon their slaughter $c, then seek out Brakgul Deathbringer in the Hall of the Brave.',26124),
(10392,'enUS','Which battleground do you seek your glory in?','Which battleground do you seek your glory in?',26124),
(10393,'enUS','Alterac Valley','Alterac Valley',26124),
(10394,'enUS','Warsong Gulch','Warsong Gulch',26124),
(10395,'enUS','Then it is to Taim Ragetotem that you must speak. Seek him out on the Hunter Rise.','Then it is to Taim Ragetotem that you must speak. Seek him out on the Hunter Rise.',26124),
(10396,'enUS','There is one that I know of here in Thunder Bluff that can aid you in your journey to Alterac Valley. On the Hunter Rise look for Taim Ragetotem. May you find what you are looking for $n.','There is one that I know of here in Thunder Bluff that can aid you in your journey to Alterac Valley. On the Hunter Rise look for Taim Ragetotem. May you find what you are looking for $n.',26124),
(10398,'enUS','Kergul Bloodaxe on the Hunter Rise stands ready to help you get to Warsong Gulch.','Kergul Bloodaxe on the Hunter Rise stands ready to help you get to Warsong Gulch.',26124),
(10399,'enUS','Such needless strife, but if the elves of Silverwing Hold will not speak to us in peace, then what alternative do they leave us? Seek out the aid of Kergul Bloodaxe on the Hunter Rise to get to Warsong Gulch.','Such needless strife, but if the elves of Silverwing Hold will not speak to us in peace, then what alternative do they leave us? Seek out the aid of Kergul Bloodaxe on the Hunter Rise to get to Warsong Gulch.',26124),
(10400,'enUS','And to which battleground do you wish to journey?','And to which battleground do you wish to journey?',26124),
(10401,'enUS','Alterac Valley','Alterac Valley',26124),
(10402,'enUS','Warsong Gulch','Warsong Gulch',26124),
(10403,'enUS','Battlemaster','Battlemaster',26124),
(10404,'enUS','It cold there! You go in Royal Quarter, talk to Grizzle Halfmane.','It cold there! You go in Royal Quarter, talk to Grizzle Halfmane.',26124),
(10405,'enUS','Him name is Grizzle Halfmane. He in Royal Quarter with Banshee Queen and Dread Lord.','Him name is Grizzle Halfmane. He in Royal Quarter with Banshee Queen and Dread Lord.',26124),
(10406,'enUS','Think him in Royal Quarter. Kurden Bloodclaw is little orc.','Think him in Royal Quarter. Kurden Bloodclaw is little orc.',26124),
(10407,'enUS','Elves in Warsong Gulch make crunchy sound. You crunch them good. Talk to Kurden Bloodclaw in Royal Quarter.','Elves in Warsong Gulch make crunchy sound. You crunch them good. Talk to Kurden Bloodclaw in Royal Quarter.',26124),
(10408,'enUS','What battleground you want?','What battleground you want?',26124),
(10409,'enUS','Alterac Valley','Alterac Valley',26124),
(10410,'enUS','Warsong Gulch','Warsong Gulch',26124),
(10411,'enUS','Battlemaster','Battlemaster',26124),
(10412,'enUS','Warsong Gulch you say? Well then, you\'ll be wanting to speak with fair Lylandris over in the Hall of Arms.','Warsong Gulch you say? Well then, you\'ll be wanting to speak with fair Lylandris over in the Hall of Arms.',26124),
(10413,'enUS','Any chance to fight against the Horde, especially orcs, is a good time if you ask me. You\'ll find plenty of battle in Warsong Gulch, that you will. Head on over to the Hall of Arms and speak with Lylandris. She\'ll set you on your way.','Any chance to fight against the Horde, especially orcs, is a good time if you ask me. You\'ll find plenty of battle in Warsong Gulch, that you will. Head on over to the Hall of Arms and speak with Lylandris. She\'ll set you on your way.',26124),
(10414,'enUS','Aye, and which battleground be ye looking for?','Aye, and which battleground be ye looking for?',26124),
(10415,'enUS','Alterac Valley','Alterac Valley',26124),
(10416,'enUS','Warsong Gulch','Warsong Gulch',26124),
(10417,'enUS','Then it is Thelman Slatefist that you wish to speak to. You can find him in the presence of the King at Stormwind Keep.','Then it is Thelman Slatefist that you wish to speak to. You can find him in the presence of the King at Stormwind Keep.',26124),
(10418,'enUS','And I wish I could join you $n. Head over to Stormwind Keep. You\'ll find Thelman Slatefist in the King\'s audience chamber. He will aid you in getting to Alterac Valley.','And I wish I could join you $n. Head over to Stormwind Keep. You\'ll find Thelman Slatefist in the King\'s audience chamber. He will aid you in getting to Alterac Valley.',26124),
(10419,'enUS','Indeed, Silverwing Hold is in need of your assistance. Speak with Elfarran in the audience chamber at Stormwind Keep.','Indeed, Silverwing Hold is in need of your assistance. Speak with Elfarran in the audience chamber at Stormwind Keep.',26124),
(10420,'enUS','The Silverwing Sentinels can use all the help they can get in their fight against the Warsong Outriders. $n, go to Stormwind Keep and speak with Elfarran if you wish to assist them.','The Silverwing Sentinels can use all the help they can get in their fight against the Warsong Outriders. $n, go to Stormwind Keep and speak with Elfarran if you wish to assist them.',26124),
(10421,'enUS','Which battleground are you interested in?','Which battleground are you interested in?',26124),
(10422,'enUS','Alterac Valley','Alterac Valley',26124),
(10423,'enUS','Warsong Gulch','Warsong Gulch',26124),
(10424,'enUS','Battlemaster','Battlemaster',26124),
(10425,'enUS','%s fully engulfs in flame and a maddened look appears in his eyes!','',26124),
(10426,'enUS','','What you be expectin\', mon?$B$BMaywiki only be dealin\' with the druids and shaman.',26124),
(10427,'enUS','Maywiki, I\'ve lost my talisman and require a replacement.','Maywiki, I\'ve lost my talisman and require a replacement.',26124),
(10428,'enUS','Greetings, $c.  It is the time of the Harvest Festival - a time of great bounties and a time of remembrance.  We partake of feasts to celebrate all we have to be thankful of, and we remember our ancestors and past heroes to give thanks to the legacy they gave us.$B$BPlease feel free to partake of the feast being offered here.  Also, I am offering some fireworks to help celebrate this joyous time of year.','',26124),
(10429,'enUS','Let me browse your selection of fireworks.','Let me browse your selection of fireworks.',26124),
(10430,'enUS','Greetings, $c.  It is the time of the Harvest Festival - a time of great bounties and a time of remembrance.  We partake of feasts to celebrate all we have to be thankful of, and we remember our ancestors and past heroes to give thanks to the legacy they gave us.$B$BPlease feel free to partake of the feast being offered here.  Also, I am offering some fireworks to help celebrate this joyous time of year.','',26124),
(10431,'enUS','','We must not allow the Alliance to expand their power base in Arathi!  Even their miniscule Refuge Pointe may one day grow to threaten us.',26124),
(10432,'enUS','The battle for Arathi Basin is a battle for resources.  Lumber, ore, food... all these are needed in order to wage a good war.$B$BDenying our enemies of their supplies is as good as killing them on the battlefield.','',26124),
(10433,'enUS','Sightless I may be, but vision I have.$B$BMy primary dealings are with hunters and rogues, $r.','',26124),
(10434,'enUS','You be dead soon!','You be dead soon!',26124),
(10435,'enUS','I gonna make you into mojo!','I gonna make you into mojo!',26124),
(10436,'enUS','Your skull gonna decorate our ritual altars!','Your skull gonna decorate our ritual altars!',26124),
(10437,'enUS','Troll mojo da strongest mojo!','Troll mojo da strongest mojo!',26124),
(10438,'enUS','Feel da big bad voodoo!','Feel da big bad voodoo!',26124),
(10439,'enUS','I have lost the talisman, Falthir. I require a replacement.','I have lost the talisman, Falthir. I require a replacement.',26124),
(10440,'enUS','Hail, adventurer. I am Rin\'wosho, trader of Zuldazar. I come from the South Seas and bring many exotic goods and items from my homeland.$B$BPerhaps if you prove your worth to my tribe, I shall barter.  If you have any of my tribe\'s Honor Tokens, then perhaps we shall barter even more.','',26124),
(10441,'enUS','Let us barter, Rin\'wosho. Show me what goods are available!','Let us barter, Rin\'wosho. Show me what goods are available!',26124),
(10442,'enUS','Rin\'wosho, I require repairs.','Rin\'wosho, I require repairs.',26124),
(10443,'enUS','','Shadra, make of me your avatar!',26124),
(10444,'enUS','','The brood shall not fall!',26124),
(10445,'enUS','%s is fully grown!','',26124),
(10446,'enUS','Make peace, worms.  I be deliverin\' you to Hakkar myself!','',26124),
(10447,'enUS','PRIDE HERALDS THE END OF YOUR WORLD.  COME, MORTALS!  FACE THE WRATH OF THE SOULFLAYER!','',26124),
(10448,'enUS','','Aid me my brood!',26124),
(10449,'enUS','Welcome to the great show, friends.  Step right up to die!','',26124),
(10450,'enUS','','At last, I am free of the Soulflayer!',26124),
(10451,'enUS','Hakkar binds me no more!  Peace at last!','',26124),
(10452,'enUS','','Finally...death!  Curse you, Hakkar!  Curse you!',26124),
(10453,'enUS','%s dies.','%s dies.',26124),
(10454,'enUS','%s is resurrected by a nearby ally!','%s is resurrected by a nearby ally!',26124),
(10455,'enUS','Shirvallah, fill me with your RAGE!','',26124),
(10456,'enUS','It is true, $n.  The wheels of doom now turn, inevitably, toward the true return of Hakkar!','',26124),
(10457,'enUS','Blood and souls for Hakkar!  HAHAHAH!','',26124),
(10458,'enUS','Betina, I\'d like a replacement Seal of the Dawn please!','Betina, I\'d like a replacement Seal of the Dawn please!',26124),
(10459,'enUS','','Bless you, mortals, for this release...Hakkar controls me no longer!',26124),
(10460,'enUS','Ssserenity...at lassst!','',26124),
(10461,'enUS','','Bethekk, your priestess calls upon your might!',26124),
(10462,'enUS','Betina, I\'d like a replacement Rune of the Dawn please!','Betina, I\'d like a replacement Rune of the Dawn please!',26124),
(10463,'enUS','I am Zanza, a Loa of Zandalar. I have come in this ethereal form from Zandalar to help my people. Hakkar has no dominion over my soul.$B$BI help those that have helped the Zandalarian people.','',26124),
(10464,'enUS','A friend of the Zandalrian! You have ventured deep into the lair of the Blood God, $c. You will do well to listen to what I have to say.$B$BMany thousands of years ago, while the indigenous trolls of the Zul\'Aman empire were battling the invading high elf heathens, great magic was stolen from Zanza. This magic was used by the high elves to enchant their weapons and armor to assist in conquering the trolls of the region.','',26124),
(10465,'enUS','I think I have heard of this magic.','I think I have heard of this magic.',26124),
(10466,'enUS','Have you? Then you know how weak and pathetic the high elf version of troll magic was?$B$BThe high elves could not understand why a people with their magical affinity could not contend with the powers of troll voodoo. This was an inconceivable notion for the pale skins to understand. They were resigned to using the bastardized version of troll enchantments. I believe they called them \'Arcanum.\'\n','',26124),
(10467,'enUS','Arcanum? That sounds very familiar.','Arcanum? That sounds very familiar.',26124),
(10468,'enUS','Zanza can create the ancient troll enchantments with the right components. This magic will help you in defeating Hakkar and his minions.$B$BI only ask that you bring me two items.','',26124),
(10469,'enUS','What are the components?','What are the components?',26124),
(10470,'enUS','The first is a primal token that must be taken from the most powerful of the Hakkari lieutenants: Jin\'do and the Bloodlord.$B$BThe second is a punctured voodoo doll. These can be found in the piles of refuse that litter this foul place. Look inside the jinxed Hoodoo piles.$B$BBring me these things and I will create a powerful enchantment for you!','',26124),
(10471,'enUS','I am sorry $c, but you are not seasoned enough yet to enter Warsong Gulch.','I am sorry $c, but you are not seasoned enough yet to enter Warsong Gulch.',26124),
(10472,'enUS','','Feast on $n, my pretties!',26124),
(10473,'enUS','Now, only one step remains to rid us of the Soulflayer\'s threat...','',26124),
(10474,'enUS','Begin the ritual, my servants.  We must banish the heart of Hakkar back into the void!','',26124),
(10475,'enUS','Welcome to the Booty Bay fishing contest where each week we reward the finest fishermen in all of Azeroth.\n\nWhen the fishing tournament begins, you will be able to catch tastyfish from any fishing node in Stranglethorn.','',26124),
(10476,'enUS','Greetings, $c.  I am Exzhal, Servitor of Rastakhan.','',26124),
(10477,'enUS','The battle will begin in 1 minute.','The battle will begin in 1 minute.',26124),
(10478,'enUS','The battle will begin in 30 seconds.','The battle will begin in 30 seconds.',26124),
(10479,'enUS','The battle has begun!','The battle has begun!',26124),
(10480,'enUS','Do not be lured into the mortals\' trap.  Bathe in my power!  Be renewed and destroy the heretics!','',26124),
(10481,'enUS','I am sorry $c, but you need to be more experienced before you can survive in Alterac Valley.','I am sorry $c, but you need to be more experienced before you can survive in Alterac Valley.',26124),
(10482,'enUS','What are the Paragons of Power?','What are the Paragons of Power?',26124),
(10483,'enUS','The Paragons of Power are remnants from the ancient Gurubashi Empire.  We Zandalar seek them - not only are they of tremendous collectible value to us, but we believe that they also hold latent signatures of magic used by the old Empire.$B$BYou\'ll more than likely discover three kinds of Paragons in Zul\'Gurub: coins, bijous, and primal items.  Bring them to us in the quantities that we seek, and you\'ll be rewarded with some of the finest items we Zandalar have ever crafted.\n','The Paragons of Power are remnants from the ancient Gurubashi Empire.  We Zandalar seek them - not only are they of tremendous collectible value to us, but we believe that they also hold latent signatures of magic used by the old Empire.$B$BYou\'ll more than likely discover three kinds of Paragons in Zul\'Gurub: coins, bijous, and primal items.  Bring them to us in the quantities that we seek, and you\'ll be rewarded with some of the finest items we Zandalar have ever crafted.',26124),
(10484,'enUS','The markings of this tablet show ancient diagrams and hold dire words of power, but their meaning is inscrutable to you.','',26124),
(10485,'enUS','The markings on this tablet show ancient diagrams and dire words of power, used to create  Gurubashi Mojo Madness...','',26124),
(10486,'enUS','Learn the recipe.','Learn the recipe.',26124),
(10487,'enUS','The markings of this tablet show ancient diagrams and hold dire words of power.$B$BYou believe it is an alchemical recipe, but it is beyond your skill...','',26124),
(10488,'enUS','If you ask me, the best part about fishing is its slow pace.  It gives one time to think, to reflect on past events and to plan for future ones.$B$BOh, and it\'s also a great excuse to drink.  Heavily.','',26124),
(10489,'enUS','Thanks again for returning my lucky measuring tape, $n.  I swear it helps me catch bigger fish!','',26124),
(10490,'enUS','I want to catch Gahz\'ranka!  Tell me how!','I want to catch Gahz\'ranka!  Tell me how!',26124),
(10491,'enUS','To catch Gahz\'ranka, you\'ll need a special Mudskunk lure.  I make \'em myself!$B$BBut you need more than just the lure; you need some mudskunks too... you need to place them in the lure to give it a rank old smell!$B$BWhen you have the mudskunks, throw the lure off Pagle\'s Point in Zul\'Gurub... and then grab a drink and wait... but not too long, because Gahz\'ranka is sure to come a\'stomping!','',26124),
(10492,'enUS','Nat, I want to buy your mudskunk lures!','Nat, I want to buy your mudskunk lures!',26124),
(10493,'enUS','*Whirr* *CLANK*\n\nI have been instructed to accept high quality rare fish and return valuable Nat Pagle fishing accessories.   Fish Requested.\n\n*THUMP* *Buzz*\n','',26124),
(10494,'enUS','','%s begins to cast a Great Heal!',26124),
(10495,'enUS','I am sorry $c, but you need to be more powerful before I can allow you to enter Arathi Basin.','I am sorry $c, but you need to be more powerful before I can allow you to enter Arathi Basin.',26124),
(10496,'enUS','Gri\'lek, of the Iron Blood$B$BThe wanderer.  May his strength and lust for battle pierce the ages.  $B$BGri\'lek now dwells far from here.  One day, he may return...','',26124),
(10497,'enUS','Arathi Basin','Arathi Basin',26124),
(10498,'enUS','Go to the Hall of the Brave.  You will find The Defiler, Deze Snowbane there to assist you in getting to Arathi Basin.','Go to the Hall of the Brave.  You will find The Defiler, Deze Snowbane there to assist you in getting to Arathi Basin.',26124),
(10499,'enUS','You wish to help the Forsaken with their fight against the humans in Arathi Basin?  Then go to the Hall of the Brave and speak with Deze Snowbane.','You wish to help the Forsaken with their fight against the humans in Arathi Basin?  Then go to the Hall of the Brave and speak with Deze Snowbane.',26124),
(10500,'enUS','How do I catch the mudskunks for your lure?','How do I catch the mudskunks for your lure?',26124),
(10501,'enUS','Arathi Basin','Arathi Basin',26124),
(10502,'enUS','Mudskunks are a particularly smelly breed of fish that likes tropical waters.  The Zulian Mudskunk - the smelliest of them all, can only be found in the steamy waters of Zul\'Gurub.$B$BThe Zulian Mudskunks are what I believe attracted Gahz\'ranka to the place, though trolls will probably tell you he\'s one of their gods...$B$BBelieve what you like, but mark me - fill one of my lures with Zulian Mudskunks and that old boy will come, for sure!','',26124),
(10503,'enUS','You go Royal Quarter.  See Sir Malory Wheeler.  Him scary.','You go Royal Quarter.  See Sir Malory Wheeler.  Him scary.',26124),
(10504,'enUS','Arathi Basin place to take from soft humans.  Sir Malory Wheeler send you there.','Arathi Basin place to take from soft humans.  Sir Malory Wheeler send you there.',26124),
(10505,'enUS','DING!','',26124),
(10507,'enUS','Your deaths feed my strength!','',26124),
(10508,'enUS','Arathi Basin','Arathi Basin',26124),
(10509,'enUS','You may seek out Martin Lindsey inside the Pools of Vision, underneath the Spirit Rise.  He will assist you on your way to Arathi Basin.','You may seek out Martin Lindsey inside the Pools of Vision, underneath the Spirit Rise.  He will assist you on your way to Arathi Basin.',26124),
(10510,'enUS','You wish to aid The Defilers in their fight against The League of Arathor in Arathi Basin?  Very well, you should ask Martin Lindsey for his assistance then.  Look for him in the Pools of Vision.','You wish to aid The Defilers in their fight against The League of Arathor in Arathi Basin?  Very well, you should ask Martin Lindsey for his assistance then.  Look for him in the Pools of Vision.',26124),
(10511,'enUS','Arathi Basin','Arathi Basin',26124),
(10512,'enUS','The humans are in need of your assistance in their fight against The Forsaken at Arathi Basin.  Go to the Hall of Arms and speak with their representative, Donal Osgood.','The humans are in need of your assistance in their fight against The Forsaken at Arathi Basin.  Go to the Hall of Arms and speak with their representative, Donal Osgood.',26124),
(10513,'enUS','The League of Arathor is trying to reclaim their ancestral holdings in Arathi Basin from the Forsaken.  If you would aid them $n speak to Donal Osgood in the Hall of Arms.','The League of Arathor is trying to reclaim their ancestral holdings in Arathi Basin from the Forsaken.  If you would aid them $n speak to Donal Osgood in the Hall of Arms.',26124),
(10514,'enUS','Arathi Basin','Arathi Basin',26124),
(10515,'enUS','In the King\'s audience chamber you will find the Lady Hoteshem.  She can assist you in getting to Arathi Basin where The League of Arathor is in need of assistance against The Defilers.','In the King\'s audience chamber you will find the Lady Hoteshem.  She can assist you in getting to Arathi Basin where The League of Arathor is in need of assistance against The Defilers.',26124),
(10516,'enUS','It\'s admirable what The League of Arathor is attempting to do in Arathi Basin.  Too bad those undead abominations and their Horde friends are standing in the way.  Head over to Stormwind Keep.  Lady Hoteshem awaits you in the King\'s audience chamber.  She can help you to get to Arathi Basin.','It\'s admirable what The League of Arathor is attempting to do in Arathi Basin.  Too bad those undead abominations and their Horde friends are standing in the way.  Head over to Stormwind Keep.  Lady Hoteshem awaits you in the King\'s audience chamber.  She can help you to get to Arathi Basin.',26124),
(10517,'enUS','Arathi Basin','Arathi Basin',26124),
(10518,'enUS','','The humans definitely need all of our help in Arathi Basin.  The one that you wish to speak to is named Keras Wolfheart.  He stands ready to assist you on the Warrior\'s Terrace.',26124),
(10519,'enUS','','If that is your wish $c, then you will need to speak to Keras Wolfheart on the Warrior\'s Terrace.  He is a representative of The League of Arathor and can help you to get to Arathi Basin.',26124),
(10520,'enUS','Throm\'ka $c!  Are you ready to fight for the Horde at Warsong Gulch?','',26124),
(10521,'enUS','','Hail to thee $n.  Do you wish me to aid you in your journey to Warsong Gulch?',26124),
(10522,'enUS','$n, the Silverwing Sentinels must be crushed!  Are you ready for Warsong Gulch?','',26124),
(10523,'enUS','Are you here to fight for us at Warsong Gulch?  Lok\'tar Ogar $c!','',26124),
(10524,'enUS','','$C, we need your assistance at Warsong Gulch.  Will you aid us in our fight against the Warsong Outriders?',26124),
(10525,'enUS','Aye $g lad : lass; are ye ready to head to Alterac Valley and give the Horde a taste o\' what they been asking for?','',26124),
(10526,'enUS','$n, have ye any idea o\' what we\'re up against in Alterac Valley?  Are ye ready to fight the Frostwolf Clan?','',26124),
(10527,'enUS','The Stormpike Guard must be destroyed!  Ready for Alterac Valley $c?','',26124),
(10528,'enUS','','Lok\'tar $c!  We have need of your services in Alterac Valley.  Shall I add you to the lists?',26124),
(10529,'enUS','Our forces in Alterac Valley need wisdom to achieve victory $c.  You look like the one to lead them.','',26124),
(10530,'enUS','I hope that you are here to go to Alterac Valley $n.  We can use all o\' the help that we can get.','',26124),
(10531,'enUS','','The humans and their so-called League of Arathor think to push us out of Arathi Basin.  I think not $c!  Are you ready to be sent there and demonstrate that it is they, and not The Defilers, that will be leaving soon?',26124),
(10532,'enUS','Arathi Basin was once our home, and will be again with your aid!  Will you help us $c?','',26124),
(10533,'enUS','I hope that you\'re here to help us take back Arathi Basin from The Defilers.  What do you say $n?','',26124),
(10534,'enUS','','I\'ve been expecting you $n.  Are you ready to assist us in Arathi Basin?',26124),
(10535,'enUS','You think you have what it takes to destroy The League of Arathor, $c?  I hope so.  What is it that you want, or are you simply here to waste my time?','',26124),
(10536,'enUS','Look around you $c.  You are in rare company to be certain, yet still I think you need to prove yourself.  Hmm, perhaps I shall allow you to aid us in our cause at Arathi Basin.  Would you like that?','',26124),
(10537,'enUS','All Hail $n, slayer of Hakkar, and hero of Azeroth!','',26124),
(10538,'enUS','Gri\'lek, of the Iron Blood$B$BThe wanderer.  May his strength and lust for battle pierce the ages.$B$BGri\'lek now lingers near the edge of madness...','',26124),
(10539,'enUS','Hazza\'rah, the Dreamweaver.$B$BHis is the power of nightmares, and may his foes ever sleep.  $B$BHazza\'rah now dwells far from here.  One day, he may return...','',26124),
(10540,'enUS','Hazza\'rah, the Dreamweaver.$B$BHis is the power of nightmares, and may his foes ever sleep.$B$BHazza\'rah now dreams near the edge of madness.','',26124),
(10541,'enUS','Renataki, of the Thousand Blades.$B$BPain is his lifeblood.  Fear, his ally.  May he one day return and bring joyous bloodshed with him.  $B$BRenataki now dwells far from here.  One day, he may return...','',26124),
(10542,'enUS','Renataki, of the Thousand Blades.$B$BPain is his lifeblood.  Fear, his ally.  May he one day return and bring joyous bloodshed with him.$B$BRenataki now dwells near the edge of madness.','',26124),
(10543,'enUS','Wushoolay, the Storm Witch.$B$BHis power is the power of the sky, the rain, and the shattered earth.  May he once again reign father to the Gurubashi.  $B$BWushoolay now dwells far from here.  One day, he may return...','',26124),
(10544,'enUS','Wushoolay, the Storm Witch.$B$BHis power is the power of the sky, the rain, and the shattered earth.  May he once again reign father to the Gurubashi.$B$BWushoolay now rages near the edge of madness.','',26124),
(10545,'enUS','%s goes into a rage after seeing his raptor fall in battle!','%s goes into a rage after seeing his raptor fall in battle!',26124),
(10546,'enUS','Minions of Hakkar, hear your God. The sanctity of this temple has been compromised. Invaders encroach upon holy ground! The Altar of Blood must be protected. Kill them all!','',26124),
(10547,'enUS','Hey Hey Hey!  I am here to promote a fabulous fishing tournament in Stranglethorn but you need to be tough enough to survive there and have enough skill in fishing to fish those waters.$B$BCome back later when you are more qualified!\n\n','',26124),
(10548,'enUS','Heya Heya Heya!   If you want to test your fishing skills then I have just the place for you!   This Sunday we have a fishing tournament in Stranglethorn!\n\n','',26124),
(10549,'enUS','%s flees toward the safety of another tiger.','',26124),
(10550,'enUS','Your callous disregard for the sovereign might of the Gurubashi Empire has been noted. The inhabitants of Zul\'Gurub have been alerted to your presence.','',26124),
(10551,'enUS','You are not yet powerful enough, $c.  Move along.','You are not yet powerful enough, $c.  Move along.',26124),
(10552,'enUS','Our need for assistance in Arathi Basin is greater than one might imagine, $n.  So too is the honor and reputation one might acquire there in this time of need, however.  I implore you to seek out the Arathi Basin battlemaster in this city.','Our need for assistance in Arathi Basin is greater than one might imagine, $n.  So too is the honor and reputation one might acquire there in this time of need, however.  I implore you to seek out the Arathi Basin battlemaster in this city.',26124),
(10553,'enUS','I wish to join the battle!','I wish to join the battle!',26124),
(10554,'enUS','I am so glad that you asked.  You will find Sir Malory Wheeler at the Royal Quarter in the presence of our Dark Lady.','I am so glad that you asked.  You will find Sir Malory Wheeler at the Royal Quarter in the presence of our Dark Lady.',26124),
(10555,'enUS','Of course, of course.  Please speak with Deze Snowbane at the Hall of the Brave in the Valley of Honor of this city, $c.','Of course, of course.  Please speak with Deze Snowbane at the Hall of the Brave in the Valley of Honor of this city, $c.',26124),
(10556,'enUS','And a great deal of honor you shall have, I am sure.  Speak with Martin Lindsey at the Pools of Vision.  It is a cave located in the side of the Spirit Rise.','And a great deal of honor you shall have, I am sure.  Speak with Martin Lindsey at the Pools of Vision.  It is a cave located in the side of the Spirit Rise.',26124),
(10557,'enUS','You need to be a stronger $c before you can help us in Alterac Valley.','You need to be a stronger $c before you can help us in Alterac Valley.',26124),
(10558,'enUS','Hail, $c.  There is a great need and even greater honor and renown to be had in Alterac Valley at this time. Will you join our fight against the Stormpike Guard?','Hail, $c.  There is a great need and even greater honor and renown to be had in Alterac Valley at this time. Will you join our fight against the Stormpike Guard?',26124),
(10559,'enUS','Honor to your house and ancestors, $c!  You will find Kartra Bloodsnarl inside the Hall of the Brave in the Valley of Honor.','Honor to your house and ancestors, $c!  You will find Kartra Bloodsnarl inside the Hall of the Brave in the Valley of Honor.',26124),
(10560,'enUS','','',26124),
(10561,'enUS','Your name will be remembered down through the ages, $n.  Seek out Taim Ragetotem on the Hunter Rise and he will assist you on your way to Alterac Valley.','Your name will be remembered down through the ages, $n.  Seek out Taim Ragetotem on the Hunter Rise and he will assist you on your way to Alterac Valley.',26124),
(10562,'enUS','Very good, $n.  You will find Grizzle Halfmane in the Royal Quarter of the Undercity.  May you find great honor in Alterac Valley.','Very good, $n.  You will find Grizzle Halfmane in the Royal Quarter of the Undercity.  May you find great honor in Alterac Valley.',26124),
(10563,'enUS','Unfortunately you are not yet strong enough to survive in Warsong Gulch, $c.','Unfortunately you are not yet strong enough to survive in Warsong Gulch, $c.',26124),
(10564,'enUS','$C, we have a great need for your help in Warsong Gulch against the Silverwing Sentinels.  And there is even greater honor and reputation with the Warsong Outriders to be gained as well!  Do you have the courage to enter battle?','$C, we have a great need for your help in Warsong Gulch against the Silverwing Sentinels.  And there is even greater honor and reputation with the Warsong Outriders to be gained as well!  Do you have the courage to enter battle?',26124),
(10565,'enUS','Then it is with great pride that I tell you that Brakgul Deathbringer stands ready in the Hall of Arms to aid you on your way to Warsong Gulch. Seek him out in the Valley of Honor.','Then it is with great pride that I tell you that Brakgul Deathbringer stands ready in the Hall of Arms to aid you on your way to Warsong Gulch. Seek him out in the Valley of Honor.',26124),
(10566,'enUS','You have chosen wisely, $n.  Seek out Kergul Bloodaxe on the Hunter Rise.  He will assist you on your journey to Warsong Gulch.','You have chosen wisely, $n.  Seek out Kergul Bloodaxe on the Hunter Rise.  He will assist you on your journey to Warsong Gulch.',26124),
(10567,'enUS','Honor and praise will be yours for the taking, $c!  Look for Kurden Bloodclaw in this city\'s Royal Quarter.','Honor and praise will be yours for the taking, $c!  Look for Kurden Bloodclaw in this city\'s Royal Quarter.',26124),
(10568,'enUS','I\'m afraid ye would not survive long in Alterac Valley, $c.  Come back and see us when you have a few more seasons under your belt.','I\'m afraid ye would not survive long in Alterac Valley, $c.  Come back and see us when you have a few more seasons under your belt.',26124),
(10569,'enUS','$n, the Stormpike Guard is in need of your aid in the battle against the Frostwolf Clan in Alterac Valley, now more than ever.  The opportunities for honor and repute are greater than ever as well! Will you join the battle?','$n, the Stormpike Guard is in need of your aid in the battle against the Frostwolf Clan in Alterac Valley, now more than ever.  The opportunities for honor and repute are greater than ever as well! Will you join the battle?',26124),
(10570,'enUS','Excellent, $n!  You shall find Brogun Stoneshield on the Warrior\'s Terrace.  He can help you to get to Alterac Valley.','Excellent, $n!  You shall find Brogun Stoneshield on the Warrior\'s Terrace.  He can help you to get to Alterac Valley.',26124),
(10571,'enUS','','Fishmaster Bassbait has had the waters here seeded with high quality Tastyfish so he can have his tournament.\n\nOnce he gets his winners, I will give you silver for each five Tastyfish you bring me!',26124),
(10572,'enUS','You\'ve made the right decision, $c.  You\'ll find our battlemaster, Glordrum Steelbeard, in the Hall of Arms.  Good luck, $n!','You\'ve made the right decision, $c.  You\'ll find our battlemaster, Glordrum Steelbeard, in the Hall of Arms.  Good luck, $n!',26124),
(10573,'enUS','Good for you, $c!  Our battlemaster, Thelman Slatefist, can be found in the war room inside Stormwind Keep.  He will help you get to Alterac Valley.','Good for you, $c!  Our battlemaster, Thelman Slatefist, can be found in the war room inside Stormwind Keep.  He will help you get to Alterac Valley.',26124),
(10574,'enUS','Thank you for the offer, $c.  Unfortunately you are not yet experienced enough to weather the hazards of Arathi Basin.','Thank you for the offer, $c.  Unfortunately you are not yet experienced enough to weather the hazards of Arathi Basin.',26124),
(10575,'enUS','Will you help us in our time of great need at Arathi Basin, $c?  The chance for increased honor and standing is greater than ever, and your assistance is sure to help to turn the tide against The Defilers.  Can we count on you?','Will you help us in our time of great need at Arathi Basin, $c?  The chance for increased honor and standing is greater than ever, and your assistance is sure to help to turn the tide against The Defilers.  Can we count on you?',26124),
(10576,'enUS','Thank you, $n!  You will find Keras Wolfheart on the Warrior\'s Terrace near the trainers there.  He will guide your way to Arathi Basin.  Good luck and great honor upon thee.','Thank you, $n!  You will find Keras Wolfheart on the Warrior\'s Terrace near the trainers there.  He will guide your way to Arathi Basin.  Good luck and great honor upon thee.',26124),
(10577,'enUS','We shall be in your debt, $c.  Look for Donal Osgood in the Hall of Arms.  He will be more than happy to aid you in your journey to Arathi Basin.','We shall be in your debt, $c.  Look for Donal Osgood in the Hall of Arms.  He will be more than happy to aid you in your journey to Arathi Basin.',26124),
(10578,'enUS','Excellent!  You shall be doing the League of Arathor a great service in ridding Arathi Basin of The Defilers and their Horde thugs.  Seek out the Lady Hoteshem in the royal audience chamber of Stormwind Keep.  She has been expecting you, $n.','Excellent!  You shall be doing the League of Arathor a great service in ridding Arathi Basin of The Defilers and their Horde thugs.  Seek out the Lady Hoteshem in the royal audience chamber of Stormwind Keep.  She has been expecting you, $n.',26124),
(10579,'enUS','I am released through you! Avenge me!','',26124),
(10580,'enUS','The seasons turn for all in due time, but you are still in the springtime of your life.  Please return to us later, $c, when you have experienced more.','The seasons turn for all in due time, but you are still in the springtime of your life.  Please return to us later, $c, when you have experienced more.',26124),
(10581,'enUS','$C, we are not ashamed to say that we are in need of all of the assistance that we can get in our fight at Warsong Gulch.  But there is greater honor to be had now than at any time in the past if you so choose to lend us your skills.  As well, the Silverwing Sentinels are sure to look more favorably upon your efforts on our behalf.  Will you join the battle?','$C, we are not ashamed to say that we are in need of all of the assistance that we can get in our fight at Warsong Gulch.  But there is greater honor to be had now than at any time in the past if you so choose to lend us your skills.  As well, the Silverwing Sentinels are sure to look more favorably upon your efforts on our behalf.  Will you join the battle?',26124),
(10582,'enUS','The Light of Elune shine upon thee, $n!  You will find Aethalas, our battlemaster, on the Warrior\'s Terrace.  She will aid you on your way to Warsong Gulch.','The Light of Elune shine upon thee, $n!  You will find Aethalas, our battlemaster, on the Warrior\'s Terrace.  She will aid you on your way to Warsong Gulch.',26124),
(10583,'enUS','You show wisdom beyond your years, $c.  Thank you. You can find our battlemaster, Lylandris, standing at the war table in the Hall of Arms. She can assist you in traveling to Warsong Gulch.','You show wisdom beyond your years, $c. Thank you. You can find our battlemaster, Lylandris, standing at the war table in the Hall of Arms. She can assist you in traveling to Warsong Gulch.',26124),
(10584,'enUS','','The Paragons of Power are remnants from the ancient Gurubashi Empire.  We Zandalar seek them - not only are they of tremendous collectible value to us, but we believe that they also hold the strongest of mojo used by the old Empire.$B$BYa can expect to be findin\' three kinds of Paragons in Zul\'Gurub: coins, bijous, and primal items.  Bring them to us in the quantities that we seek, and you\'ll be rewarded with the some of the finest items we Zandalar have ever crafted.$B$BCount on it, mon!\n\n',26124),
(10585,'enUS','The Silverwing Sentinels shall be in your debt, $c.  You will find Elfarran, our battlemaster, inside Stormwind Keep, attending the boy-king\'s audience.  Goddess watch over you!','The Silverwing Sentinels shall be in your debt, $c.  You will find Elfarran, our battlemaster, inside Stormwind Keep, attending the boy-king\'s audience.  Goddess watch over you!',26124),
(10586,'enUS','You will suffer eternally, $r.','',26124),
(10587,'enUS','Hakkar will rule the world!','',26124),
(10588,'enUS','You will make a fitting sacrifice.','',26124),
(10589,'enUS','Surrender your soul, mortal.','',26124),
(10590,'enUS','The world will suffer immeasurable cruelties under my reign.','',26124),
(10591,'enUS','Your gods can\'t save you now, $c.','',26124),
(10592,'enUS','The Primal Gods serve Hakkar. Turn back now, you stand no chance.','',26124),
(10593,'enUS','Pledge your allegiance to Hakkar and the pain you suffer shall be minimal.','',26124),
(10594,'enUS','You dare set foot upon Hakkari holy ground? Minions of Hakkar, destroy the infidels!\n','',26124),
(10595,'enUS','Well met master of Rod and Reel!   If you be willing to test your skills against the best fisher-folk in the lands then listen up!   On this very Sunday there be a contest in Stranglethorn where the master angler will be chosen!\n\n','',26124),
(10596,'enUS','Greetings!  I am here to promote a tournament to test your fishing skill in Stranglethorn.  To participate you need enough might to survive there and have enough skill in fishing to coax the fish from the water.$B$B Come back later when you are more qualified!\n\n','',26124),
(10597,'enUS','Paragons of Power are powerful mojo.  They are Gurubashi Empire mojo.  We Zandalar must get mojo.  The tribe will take mojo for our own.  The Blood God will not destroy us.$B$BThere are three kinds of Paragons in Zul\'Gurub.  Seek coins.  Seek bijous.  Seek primal items.  These are the Paragons.$B$BGo to Zul\'Gurub now.  Kill.  Take the Paragons of Power.  Bring them to the tribe.  Earn our respect.  Earn our battle gear.  Earn real power.','',26124),
(10598,'enUS','The Alliance has gathered over 1200 resources and is near victory!','',26124),
(10599,'enUS','The Horde has gathered over 1200 resources and is near victory!','',26124),
(10600,'enUS','We already have all our winners for today\'s contest, but Jang is willing to purchase any Tastyfish that you have fished up!\n\nThere\'s always next Sunday for you to show your angling skill!','',26124),
(10601,'enUS','Hey! Grats, mon!','',26124),
(10602,'enUS','Wow!','',26124),
(10603,'enUS','Yay!','',26124),
(10604,'enUS','$n! I\'m watching you!','',26124),
(10605,'enUS','You\'ve angered me for the last time $n!','',26124),
(10606,'enUS','Listen, young $c.  You hear the call of water?','',26124),
(10607,'enUS','I wish to speak to the spirits, Tiev.','I wish to speak to the spirits, Tiev.',26124),
(10608,'enUS','Let the Fishing Tournament BEGIN!','',26124),
(10609,'enUS','And the Tastyfish have gone for the week!   I will remain for another hour to allow you to turn in your fish!','',26124),
(10610,'enUS','We have a winner!  $n has won FIRST PLACE in the tournament!','',26124),
(10611,'enUS','Behind me is the Altar of Zanza, a sacred place for us Zandalar.  We pray here to bolster our resolve in preparation for war against the Blood God, Hakkar.$B$BProve yourself to the tribe by using the altar to destroy any of the Hakkari Bijous you might find inside Zul\'Gurub.  Also, I will trade you Honor Tokens our tribe uses for sets of coins you may find in Zul\'Gurub.  Bring me the coins that I seek, and you will be rewarded!','',26124),
(10612,'enUS','The Blood God, the Soulflayer, has been defeated!  We are imperiled no longer!','',26124),
(10613,'enUS','The Zandalarian trolls have traveled far and suffered much to reach this place, but to do nothing... is to invite our doom...','The Zandalarian trolls have traveled far and suffered much to reach this place, but to do nothing... is to invite our doom...',26124),
(10614,'enUS','Take heart!$B$BThe Soulflayer has been defeated and his wretched heart has been cast into the nether!','Take heart!$B$BThe Soulflayer has been defeated and his wretched heart has been cast into the nether!',26124),
(10615,'enUS','The Soulflayer is defeated!  Our leader, Molthor, now calls more of his servants...','The Soulflayer is defeated!  Our leader, Molthor, now calls more of his servants...',26124),
(10616,'enUS','We, the Zandalarian trolls, traveled here from distant islands, for we cannot ignore the threat that now faces our world.$B$BThe leader of our expedition, Molthor, brought us to the Yojamba Isle, along the northern coasts of Stranglethorn, and even now recruits brave heroes to venture into the ancient troll city... Zul\'Gurub.','',26124),
(10618,'enUS','We, the Zandalarian trolls, traveled here from distant islands, for we cannot ignore the threat that now faces our world.','',26124),
(10619,'enUS','Not now.  Have you any tasks for me?','Not now.  Have you any tasks for me?',26124),
(10620,'enUS','I can get back to the Stronghold on my own, I think.  Now that you bought me some time, I should be able to stealth out of here.  Who ever you are... thank you.  May Elune bless you always!','',26124),
(10621,'enUS','I wish to untrain my pet.','I wish to untrain my pet.',26124),
(10622,'enUS','You can\'t teach an old dog new tricks.  At least that\'s what someone once told me.  Lucky for you, I\'ve discovered it to be untrue.$b$bNow then, would you like your pet to unlearn talents?','You can\'t teach an old dog new tricks.  At least that\'s what someone once told me.  Lucky for you, I\'ve discovered it to be untrue.$b$bNow then, would you like your pet to unlearn talents?',26124),
(10623,'enUS','What goods have I earned the right to purchase from the Defilers?','What goods have I earned the right to purchase from the Defilers?',26124),
(10624,'enUS','I am Rutherford Twing, the main supplier for the Defilers posted here at Arathi Basin.  As you improve your standing with us, I will make available to you a fine selection of goods that you might find useful.  Should you find yourself in need of item repair, I also provide those services.','',26124),
(10625,'enUS','What goods have I earned the right to purchase from the League of Arathor?','What goods have I earned the right to purchase from the League of Arathor?',26124),
(10626,'enUS','I am Samuel Hawke, the main supplier for the League of Arathor posted here at Arathi Basin.  As you improve your standing with us, I will make available to you a fine selection of goods that you might find useful.  Should you find yourself in need of item repair, I also provide those services.','',26124),
(10627,'enUS','Yes, please do.','Yes, please do.',26124),
(10628,'enUS','Don\'t make me angry! You wouldn\'t like me when I\'m angry!','',26124),
(10629,'enUS','','The battle for Warsong Gulch is a battle that we cannot lose.  We fight for our honor and we fight for our land, and no orc or misguided ally will take them from us!',26124),
(10630,'enUS','It is no easy task to protect the Horde\'s lumber gathering efforts here in Ashenvale, but we have never shied from battle!  The night elves and their allies will fall!','',26124),
(10631,'enUS','Game start timer disabled.','Game start timer disabled.',26124),
(10632,'enUS','The attackers have fled!  Strength and honor to the Horde!','',26124),
(10633,'enUS','The Alliance wins!','',26124),
(10634,'enUS','The Horde wins!','',26124),
(10635,'enUS','Fleeing will do you no good, mortals!','',26124),
(10636,'enUS','$n claims the Snowfall graveyard!  If left unchallenged, the Alliance will control it!','',26124),
(10637,'enUS','$n claims the Snowfall graveyard!  If left unchallenged, the Horde will control it!','',26124),
(10638,'enUS','1 minute until the battle for Alterac Valley begins.','',26124),
(10639,'enUS','30 seconds until the battle for Alterac Valley begins.','',26124),
(10640,'enUS','The battle for Alterac Valley has begun!','',26124),
(10641,'enUS','Hi!  I\'m Luis!  What do you think of me so far...?','',26124),
(10644,'enUS','Something different!!!','',26124),
(10645,'enUS','%s goes into a frenzy!','',26124),
(10646,'enUS','','Greetings, traveler. As long as you remain within the walls of the Cenarion Hold, you will be safe from harm.$B$BBe wary when leaving the protection of the Hold as the silithid have been swarming as of late.',26124),
(10647,'enUS','I wish to browse your wares, Calandrath.','I wish to browse your wares, Calandrath.',26124),
(10648,'enUS','I supply the Hold with various relics required for spellcasting as well as other alchemical reagents.','',26124),
(10649,'enUS','A great evil stirs, $r. Can you feel it?$B$BBah! Of course you cannot. Hand me your armor and weapons and I shall renew their vigor.','',26124),
(10650,'enUS','','Oh dear, I am running dangerously low on supplies! What is taking that blasted goblin so long?',26124),
(10651,'enUS','Look behind you, $r. The hive stirs as the land that surrounds us shudders and shakes.$B$BThe time has come for me to fulfill a promise I made a thousand years past. The sands shift once more as the Qiraji plan for war.','',26124),
(10652,'enUS','I wish to stable my pet.','I wish to stable my pet.',26124),
(10653,'enUS','Why now, $r? I just do not understand it. So much work to be done...','',26124),
(10654,'enUS','The Commander has not been himself as of late. His mistress disappeared while on an archaeological dig in the southern desert - vanished without a trace! Very strange, indeed.$B$BI suppose you\'re looking for work? Do I need to bash you in the head with a clue?','',26124),
(10655,'enUS','','Can ye hear it, stranger? The humming is gettin\' louder with each passing day. These crystals must be what\'s driving these bugs crazy.',26124),
(10656,'enUS','Look up to the heavens, $c. The Dragonflights have not been seen in this area for a thousand years! Those Qiraji are up to something, I just know it!','',26124),
(10657,'enUS','Bronzebeard\'s gone missing again! That dwarf sure didn\'t get any of his brother\'s good senses.','',26124),
(10658,'enUS','A terrible and costly mistake you have made. It is not my time, mortals.','',26124),
(10659,'enUS','The ashes from the burning wickerman radiate magical power.','',26124),
(10660,'enUS','Smear the ash on my face like war paint!','Smear the ash on my face like war paint!',26124),
(10661,'enUS','The ashes from the burning wickerman radiate magical power.  You have already applied the ashes to your face.','',26124),
(10662,'enUS','','Children of the grave, heed my call!',26124),
(10663,'enUS','','In life, we suffered unspeakable tragedies.',26124),
(10664,'enUS','','Finally, in the face of such atrocities, we were denied even the release of death.',26124),
(10665,'enUS','','We are the chill in a coward\'s spine...',26124),
(10666,'enUS','','We are NOT monsters! We are NOT the mindless wretches of a ghoul army!',26124),
(10667,'enUS','','WE ARE THE FORSAKEN!! ',26124),
(10668,'enUS','Happy Hallow\'s End, $c!','',26124),
(10669,'enUS','You like candy?  I like candy.','',26124),
(10670,'enUS','Go Forsaken!  Yay us!','',26124),
(10671,'enUS','','Welcome to the Wickerman Festival, $c!$B$BOn the observance of Hallow\'s End, the Forsaken burn a Wickerman in honor of this, the most revered of occasions.  It was on this day that the Banshee Queen herself delivered us from the clutches of the Lich King and the Scourge.  We have remained free ever since.  Those who would have seen us fall are repaid in full... with vengeance!$B$BWhen the Wickerman is burning, paint your face with the ashes scattered below if you want to celebrate in style!',26124),
(10672,'enUS','Wha... where am I?  So... weak..','',26124),
(10673,'enUS','You there!  You look able bodied... we need your aid in defending Southshore!$B$BThe blasted Forsaken are all riled up because it\'s Hallow\'s End.  Their \"celebration\" will no doubt be leading them right to our doorstep.  If you\'ve got the time, we really could use your help!','',26124),
(10674,'enUS','So... cold...','',26124),
(10675,'enUS','Yes!  I\'m cured!  I\'m cure... whoa, got up too fast!','',26124),
(10676,'enUS','Thanks for finding my reagents!  *yawn*  That poison\'s made me... a bit tired...','',26124),
(10677,'enUS','%s becomes enraged!','%s becomes enraged!',26124),
(10678,'enUS','%s roars, high atop Blackrock Spire...','',26124),
(10679,'enUS','Baristolth, I have lost my badge and require a replacement.','Baristolth, I have lost my badge and require a replacement.',26124),
(10680,'enUS','It is we who must make the first strike. We cannot be allowed to repeat the mistakes of the past...','',26124),
(10681,'enUS','I am ready to hear your tale, Baristolth.','I am ready to hear your tale, Baristolth.',26124),
(10682,'enUS','','',26124),
(10683,'enUS','Be gone, infidel!  May the power of the Abyss smite you down!','Be gone, infidel!  May the power of the Abyss smite you down!',26124),
(10684,'enUS','I am no cultist, you monster!  Come to me and face your destruction!','I am no cultist, you monster!  Come to me and face your destruction!',26124),
(10685,'enUS','Crimson Templar!  I hold your crest of beckoning.  Heed my summons!','Crimson Templar!  I hold your crest of beckoning.  Heed my summons!',26124),
(10686,'enUS','The Abyssal Council does not tolerate deceit!  Feel our wrath, little $r!','',26124),
(10687,'enUS','','Greetings, $c.  Welcome to Cenarion Hold.  From here we will strike against the silithid where they\'re at their strongest.  I hope you\'ve come to lend a hand.',26124),
(10688,'enUS','','It\'s a pleasure to see you again, $n.  Your aid has provided us with a considerable boost in the security of our supply lines.  I hope you understand the importance of the logistics involved in large battle efforts such as this.',26124),
(10689,'enUS','','No luck with the Twilight\'s Hammer deserter?  Check the mountains to the southeast thoroughly.  There are numerous rumors of a mysterious hermit living there.',26124),
(10690,'enUS','Hoary Templar!  I hold your crest of beckoning.  Heed my summons!','Hoary Templar!  I hold your crest of beckoning.  Heed my summons!',26124),
(10691,'enUS','Earthen Templar!  I hold your crest of beckoning.  Heed my summons!','Earthen Templar!  I hold your crest of beckoning.  Heed my summons!',26124),
(10692,'enUS','Azure Templar!  I hold your crest of beckoning.  Heed my summons!','Azure Templar!  I hold your crest of beckoning.  Heed my summons!',26124),
(10693,'enUS','Trick or Treat!','Trick or Treat!',26124),
(10694,'enUS','My lord will be outraged to learn of this ambush.  Let us hope your death will appease him.','',26124),
(10695,'enUS','It is my duty and honor to die for the Abyssal Council!','',26124),
(10696,'enUS','Your life is a fitting sacrifice for my master, $c.','',26124),
(10697,'enUS','How dare you commune with a Duke of the Council, worm!','How dare you commune with a Duke of the Council, worm!',26124),
(10698,'enUS','You will listen to this, vile duke!  I am not your Twilight\'s Hammer lapdog!  I am here to challenge you!  Come!  Come, and meet your death...','You will listen to this, vile duke!  I am not your Twilight\'s Hammer lapdog!  I am here to challenge you!  Come!  Come, and meet your death...',26124),
(10699,'enUS','Duke of Cynders! I hold your signet!  Heed my call!','Duke of Cynders! I hold your signet!  Heed my call!',26124),
(10700,'enUS','Duke of Zephyrs! I hold your signet!  Heed my call!','Duke of Zephyrs! I hold your signet!  Heed my call!',26124),
(10701,'enUS','Duke of Shards! I hold your signet!  Heed my call!','Duke of Shards! I hold your signet!  Heed my call!',26124),
(10702,'enUS','Duke of Fathoms! I hold your signet!  Heed my call!','Duke of Fathoms! I hold your signet!  Heed my call!',26124),
(10703,'enUS','You\'re hunting Deathclasp, $n?  Color me impressed.  I lost two of my men to her this week alone.  Let\'s hope your luck is better than theirs.','',26124),
(10704,'enUS','Hey!  Thanks for saving my hide!  I think I\'ll be lying down for a while until I recover my strength.','',26124),
(10705,'enUS','Who are you?  Where am I?  I feel... so weak...','',26124),
(10706,'enUS','A thunderous voice bellows from the stone...$B$BGreetings, commander.  What news of Silithus do you bring the Lords of the Council?','A thunderous voice bellows from the stone...$B$BGreetings, commander.  What news of Silithus do you bring the Lords of the Council?',26124),
(10707,'enUS','The day of judgment has come, fiend!  I challenge you to battle!','The day of judgment has come, fiend!  I challenge you to battle!',26124),
(10708,'enUS','Skaldrenox!  I hold your scepter, and charge you to enter this world!','Skaldrenox!  I hold your scepter, and charge you to enter this world!',26124),
(10709,'enUS','Whirlaxis!  I hold your scepter!  I command you to enter this world!','Whirlaxis!  I hold your scepter!  I command you to enter this world!',26124),
(10710,'enUS','Kazum!  I hold your scepter!  I command you to enter this world!','Kazum!  I hold your scepter!  I command you to enter this world!',26124),
(10711,'enUS','Skwol!  I hold your scepter!  I command you to enter this world!','Skwol!  I hold your scepter!  I command you to enter this world!',26124),
(10712,'enUS','Hello, Rutgar. The Commander has sent me here to gather some information about his missing wife.','Hello, Rutgar. The Commander has sent me here to gather some information about his missing wife.',26124),
(10713,'enUS','You best have a seat then, this is gonna be a long one.$B$BWhen we initially arrived in Silithus, Mistress Mar\'alith was the first of the night elves from Cenarion Hold to join the expedition. Our routine was nothing out of the ordinary: Form a party to venture into the various hives and search for lost artifacts. ','',26124),
(10714,'enUS','That sounds dangerous.','That sounds dangerous.',26124),
(10715,'enUS','It sure is! Those hives were abuzz with various silithid that were none too happy to see us.$B$BEverything was going fine until we came across a glyphed crystal in Hive\'Regal. She was drawn to it like a moth to a flame! She put her pretty little cheek up against the crystal and instantly entered a trance-like state. Naturally, this worried my crew. We picked her up and carried her out of there with a quickness!','',26124),
(10716,'enUS','What happened to her after that?','What happened to her after that?',26124),
(10717,'enUS','We took her to the Commander with hopes that the druids of the Circle could fix her up. Sure enough, they were able to wake her up. We figured our business with the Circle was done and we could get back to work.$B$BA few weeks passed and everything was going fine. Brann was still around back then so we had a bit of order in our work structure. Then one day, out of the blue, she appeared back at our camp.\n','',26124),
(10718,'enUS','Natalia?','Natalia?',26124),
(10719,'enUS','Are you daft? Who else would I be talking about? Yes, the girl - Mistress Mar\'alith. Anyhow, she was back and not in too good of a mood. That\'s when the demands started flowing.\n','',26124),
(10720,'enUS','What demands?','What demands?',26124),
(10721,'enUS','She demanded that we immediately head back to Hive\'Regal! Brann would have none of that sass. He told her that there\'s no way we would go back into those hives without an army backing us up. It had gotten far too dangerous. The number of those stinking insects seemed to have tripled from when we first ventured into \'em.$B$BThat\'s when Natalia lost it!','',26124),
(10722,'enUS','Lost it? What do you mean?','Lost it? What do you mean?',26124),
(10723,'enUS','What do you mean what do I mean? She went nutso! The girl went straight crazy on us. Now ordinarily I don\'t hit girls but after I recovered from the blackout, I was pretty damned angry. Brann, Rutgar, me and the monkey went positively orc on her! It\'s a miracle we were able to fend her off. She seemed almost possessed!','',26124),
(10724,'enUS','Possessed by what?','Possessed by what?',26124),
(10725,'enUS','Who knows? Anyhow, that was the last I saw of her. Maybe Frankal can give you better information.$B$BNot to steer off topic here as I\'m sure the work you\'re doing for the Commander is important, but we\'re onto something huge here. HUGE! Our requests to Ironforge for an army have so far fallen on deaf ears. Apparently we\'re stretched too thin in protecting the realm or some such nonsense. Once you take your report back to the Commander, come back down here with some friends. We need your help!','',26124),
(10726,'enUS','I\'ll be back once I straighten this mess out.','I\'ll be back once I straighten this mess out.',26124),
(10727,'enUS','Hello, Frankal. I\'ve heard that you might have some information as to the whereabouts of Mistress Natalia Mar\'alith.','Hello, Frankal. I\'ve heard that you might have some information as to the whereabouts of Mistress Natalia Mar\'alith.',26124),
(10728,'enUS','Oh brother, not this again... Have a seat $g sonny:missy;.$B$BI\'m sure Rutgar has told you some of this story already so I\'ll spare you the boring details and get right down to the nitty gritty.','',26124),
(10729,'enUS','That\'s what I like to hear.','That\'s what I like to hear.',26124),
(10730,'enUS','Right then! So the Mistress had come back for a second go at the hives but Brann was having none of that nonsense! Before the melee began, she started talking to something or someone. Crazier still, she started chanting in a language none of us had ever heard.','',26124),
(10731,'enUS','That\'s odd.','That\'s odd.',26124),
(10732,'enUS','You\'re telling me! It\'s even stranger considering between Brann, Rutgar, me and the monkey, we know 38 different languages including a touch of Titan - both Vanir and Aesir.$B$BSo anyway, whatever she was click clacking about, it definitely wasn\'t with anyone \"present.\" She then nodded and went on the offensive! Attacked us outright!','',26124),
(10733,'enUS','You couldn\'t handle a lone night elf priestess?','You couldn\'t handle a lone night elf priestess?',26124),
(10734,'enUS','Listen $g sonny:missy;, I\'ll have you know that whatever attacked us was no priestess of nothin\'! Her eyes were aglow with something evil and she was genuinely frothing at the mouth! She came in, did some kind of crazy scream that sent us all runnin\' in separate directions then started flayin\' our minds one by one. I\'d be hearin\' shadowy words in my head, watchin\' the other\'s periodically black out here and there. It was madness! We would have been done for if not for the damned monkey.','',26124),
(10735,'enUS','I\'ve been meaning to ask you about that monkey.','I\'ve been meaning to ask you about that monkey.',26124),
(10736,'enUS','What\'s there to ask? He\'s a monkey you crazy fool. Anyhow, so yea, the monkey went into a frenzy after seein\' ol\' Brann flop into the sand face first. Nothin\' the night elf could do was stopping Glibb here from poundin\' on her noggin.','',26124),
(10737,'enUS','Then what?','Then what?',26124),
(10738,'enUS','I\'ll tell you \'then what.\' She went runnin\' straight for the hive. And you know what\'s crazier? Not a single damned bug got in her way or tried to stop her. She ran through them all as if she\'d been best friends with \'em for centuries.','',26124),
(10739,'enUS','What a story! So she went into Hive\'Regal and that was the last you saw of her?','What a story! So she went into Hive\'Regal and that was the last you saw of her?',26124),
(10740,'enUS','Yep.','',26124),
(10741,'enUS','Thanks for the information, Frankal.','Thanks for the information, Frankal.',26124),
(10742,'enUS','','You will make a fitting sacrifice!',26124),
(10743,'enUS','','C\'Thun will retake this world!',26124),
(10744,'enUS','The crystal is covered in intricate glyphs and runes. You can\'t make sense of any of it.','',26124),
(10745,'enUS','A faint whisper is heard from within the stone...$B$BGreetings, little one.  Do you have news for the Templar?','A whisper may be heart from within the stone...$B$BGreetings, little one.  Do you have news for the Templar?',26124),
(10746,'enUS','A clear voice rises from within the stone...$B$BWhere is your Medallion of Station, little one?  You may not speak with a Duke without proof of title...','A clear voice rises from within the stone...$B$BWhere is your Medallion of Station, little one?  You may not speak with a Duke without proof of title...',26124),
(10747,'enUS','A clear voice rises from within the stone...$B$BYou come to us with title and so we will listen, but do not try our patience, $c.  The council has no time for idle gossip from one such as you.','You come to us with title and so we will listen, but do not try our patience, $c.  The council has no time for idle gossip from one such as you.',26124),
(10748,'enUS','What bug comes before the lords of the Council?  A bug, no doubt, wishing to be squashed!','What bug comes before the lords of the Council?  A bug, no doubt, wishing to be squashed!',26124),
(10749,'enUS','A thunderous voice bellows from the stone...$B$BI sense your Medallion of Station, cultist, but you have no Ring of Lordship?  Are you truly a commander of the Twilight\'s Hammer, or do you merely run errands for your betters?','A thunderous voice bellows from the stone...$B$BI sense your Medallion of Station, cultist, but you have no Ring of Lordship?  Are you truly a commander of the Twilight\'s Hammer, or do you merely run errands for your betters?',26124),
(10750,'enUS','A thunderous voice bellows from the stone...$B$BWhat is this?  I sense a little cultist scurrying about!  Run along, vermin, or face the wrath of the lords of the Council!','A thunderous voice bellows from the stone...$B$BWhat is this?  I sense a little cultist scurrying about!  Run along, vermin, or face the wrath of the lords of the Council!',26124),
(10751,'enUS','','You were always the troublemaker in the family, Noggle.  Always!',26124),
(10752,'enUS','<Use the transcription device to gather a rubbing.>','<Use the transcription device to gather a rubbing.>',26124),
(10753,'enUS','Where would you like to fly to?','Where would you like to fly to?',26124),
(10754,'enUS','The spirits of Silithus call out to us, $n.  The land weeps, for it has a woeful story to tell...','',26124),
(10755,'enUS','%s emits a strange noise.','',26124),
(10756,'enUS','Hail $c. Didn\'t I see you recently at an exclusive gathering? You look familiar, but then again this city is a busy place.$B$BIf you attended that convention, then surely you were given a secret code. Tell me your code and I will give you a special prize in return.','Hail $c. Didn\'t I see you recently at an exclusive gathering? You look familiar, but then again this city is a busy place.$B$BIf you attended that convention, then surely you were given a secret code. Tell me your code and I will give you a special prize in return.',26124),
(10757,'enUS','I would like to enter the secret code to receive my Murloc pet.','I would like to enter the secret code to receive my Murloc pet.',26124),
(10758,'enUS','','$n!  I hope you\'re ready to get to work, because there is much for you to do here on Sunstrider Isle.$B$BEver since the destruction of the Sunwell by Arthas and the Scourge, we have been a race adrift on a sea of uncertainty.  We teeter on the edge of oblivion.  This will change, $c, and you will learn and aid our recovery at the same time.$B$BThe Outland awaits us!',26124),
(10759,'enUS','','The Cenarion Circle is wise, and has delved into many of earth\'s secrets.  Craftsmen would do well to heed the words of these druids.',26124),
(10760,'enUS','','The ghostly figure looks at you with mistrust in her eyes and remains silent.',26124),
(10761,'enUS','Show me what I can learn.','Show me what I can learn.',26124),
(10762,'enUS','','I will do my best to translate and describe what I see.',26124),
(10763,'enUS','The Sunspire held a beautiful vantage of the Sunwell... once.  Our lives have been turned upside down, $n, but we nonetheless carry on.  It is our way; we are survivors.$B$BIf you are to survive this upheaval... to carry on in your own right, then you MUST learn how to survive.  All blood elves must do this.  You must master your insatiable hungering for magic before it masters you.','',26124),
(10764,'enUS','Your continued service to the Blood Elves is paramount to our survival!  We must all pitch in and pull ourselves out of the mire we all find ourselves in.$B$BIf you\'re ready to work, then let\'s get started.','',26124),
(10765,'enUS','Knowledge is power - TRUE power, my young friend.  You\'ll be wise to acquire as much of it as you can, and pay proper heed to those who have already done so.$B$BBefore the razing of the Sunwell, we fooled ourselves into thinking we had neared the apex of our civilization.  It took the Scourge to bring us to our knees... and in a way, back to reality.','',26124),
(10766,'enUS','You\'ve caught me at a critical time in my research!  No worries, you\'re welcome to join me in quiet contemplation... emphasis on \"quiet\", if you don\'t mind though.','',26124),
(10767,'enUS','','If you\'re heading toward the city, then I have something important for you to do!',26124),
(10768,'enUS','','Welcome! Step right up, don\'t be shy.$b$bThis here is my pride and joy... the Blastenheimer 5000 Ultra Cannon! Ain\'t she pretty?',26124),
(10769,'enUS','How do I use the cannon?','How do I use the cannon?',26124),
(10770,'enUS','','It\'s simple! You give me a Darkmoon Game Token, and I toss you in and light the fuse.$B$BYou\'ll \"float\" for a little while after you\'re shot, but you can descend quickly by dropping the \"wings\" I\'ll give you.$B$BYou\'re aiming for a big floating target in the water right off the boardwalk.$B$BJust don\'t drop your wings while you\'re still over ground, or... well... I don\'t sell life insurance!',26124),
(10771,'enUS','','I\'ve come back to my old home so my knowledge may be passed on.  Unlike the mindless undead around me, I\'ve chosen this unlife for my own reasons.$B$BThe silithid are formidable opponents, $n.  I\'ve learned to respect them as much as I despise them.$B$BMuch of their deadliness comes from the strength and lightness of their chitin, which I\'ve learned to work into armor.  As we seem to have a common enemy I shall teach you my trade. ',26124),
(10772,'enUS','','Hello $c, and welcome to the Darkmoon Faire. There is so much to do here at the faire that it can be a little overwhelming for our first time visitors. That\'s why I\'m here to help. Do you have any questions?',26124),
(10773,'enUS','What can I purchase?','What can I purchase?',26124),
(10774,'enUS','An excellent question! We have many things for sale here at the faire. If you are interested in food or drink, then visit Stamp or Sylannia\'s booths.\n\nIf you\'d rather purchase something more exotic, then Lhara may have just the thing for you. She specializes in rarities from all over the world.\n\nAnd then there is Flik running around here somewhere. If you can grab him he sells balls for throwing and frogs to keep as pets.','An excellent question! We have many things for sale here at the faire. If you are interested in food or drink, then visit Stamp or Sylannia\'s booths.\n\nIf you\'d rather purchase something more exotic, then Lhara may have just the thing for you. She specializes in rarities from all over the world.\n\nAnd then there is Flik running around here somewhere. If you can grab him he sells balls for throwing and frogs to keep as pets.',26124),
(10775,'enUS','Darkmoon Faire Prize Tickets?','Darkmoon Faire Prize Tickets?',26124),
(10776,'enUS','Glad you asked. Darkmoon Faire Prize Tickets are your currency to purchase some amazing prizes.$b$bPrize Tickets are rewarded for doing monthly quests and playing the games around the faire.$b$bCompleting the monthly quests will earn you the most Prize Tickets, but playing the games daily, is a great way to get ahead.$b$bOnce you have enough tickets, you can spend them at the different vendors on the faire grounds.','Glad you asked. Darkmoon Faire Prize Tickets are your currency to purchase some amazing prizes.$b$bPrize Tickets are rewarded for doing monthly quests and playing the games around the faire.$b$bCompleting the monthly quests will earn you the most Prize Tickets, but playing the games daily, is a great way to get ahead.$b$bOnce you have enough tickets, you can spend them at the different vendors on the faire grounds.',26124),
(10777,'enUS','Darkmoon Cards?','Darkmoon Cards?',26124),
(10778,'enUS','','No one really knows who made the Darkmoon Cards or what their true purpose is, but I can tell you that they have been found all over Azeroth, usually in the hands of a villain attempting to unlock their mysteries.',26124),
(10779,'enUS','Attractions?','Attractions?',26124),
(10780,'enUS','','I highly recommend that you visit Sayge to get your fortune told. I know, I know... he\'s a gnoll.  But he\'s a very special gnoll with the power to divine your future!$B$BAnd we are constantly expanding the faire with all manner of new attractions!',26124),
(10781,'enUS','We have more than one enemy in Silithus, $n.$B$BWhile everyone\'s attention is focused on the silithid, my big brother and I have been keeping a close eye on the Twilight\'s Hammer crazies.\n\n','',26124),
(10782,'enUS','','I highly recommend that you visit Sayge to get your fortune told. I know, I know... he\'s a gnoll.  But he\'s a very special gnoll with the power to divine your future!$B$BAnd we are constantly expanding the faire with all manner of new attractions!',26124),
(10783,'enUS','Greetings, $n.','',26124),
(10784,'enUS','Greetings, ancient one. I have done all that has been asked of me. I now ask that you grant me Rhok\'delar.','Greetings, ancient one. I have done all that has been asked of me. I now ask that you grant me Rhok\'delar.',26124),
(10785,'enUS','Greetings, ancient one. I have done all that has been asked of me. I now ask that you grant me Lok\'delar.','Greetings, ancient one. I have done all that has been asked of me. I now ask that you grant me Lok\'delar.',26124),
(10786,'enUS','Bawk, bawk, bawk!  Happy Hallow\'s End, $n!','',26124),
(10787,'enUS','','I may have ninety-nine problems, but dancin\' ain\'t one of them!  Happy Hallow\'s End, $n!',26124),
(10788,'enUS','','Chugga-chugga, woo-woo!  Happy Hallow\'s End, $n!',26124),
(10789,'enUS','','Ooo, so strong!  Happy Hallow\'s End, $n!',26124),
(10790,'enUS','','Greetings, traveler. It was here, nearly 1,000 years past, that the Qiraji began their march of destruction across Kalimdor.$B$BThousands of lives were lost during the war, most in this cursed desert during the initial invasion.$B$BI am one of only a few that remain, chained to both the past and the present. I know not why I am to remain stationed here but I know that I must.',26124),
(10791,'enUS','How do you know?','How do you know?',26124),
(10792,'enUS','','I have been slain a hundred times. I always wake here, alive. Some say I am cursed and others...',26124),
(10793,'enUS','What do they say?','What do they say?',26124),
(10794,'enUS','','They say that I am blessed: A herald to harken in a new age.',26124),
(10795,'enUS','And what do you say?','And what do you say?',26124),
(10796,'enUS','','Ancient forces stir - forces that have not been seen or felt for thousands of years. The world weeps, $r. Perhaps a new sundering comes. A sickness born from within...$B$BThe foulness has begun to seep into our lands. From the Dream come nightmares. Nightmares to befoul us in our waking hours...\n',26124),
(10797,'enUS','','Ooo, so strong!  Happy Hallow\'s End, $n!',26124),
(10798,'enUS','Bawk, bawk, bawk!  Happy Hallow\'s End, $n!','',26124),
(10799,'enUS','Chugga-chugga, woo-woo!  Happy Hallow\'s End, $n!','',26124),
(10800,'enUS','','I may have ninety-nine problems, but dancin\' ain\'t one of them!  Happy Hallow\'s End, $n!',26124),
(10801,'enUS','You will pay the ultimate price for this insolence, little vermin.  Your soul is mine!','',26124),
(10802,'enUS','This act of defiance will not go unpunished.  You, and your world, will die!','',26124),
(10803,'enUS','What?  Such a small, frail thing beckons me?  This will not go unpunished!','',26124),
(10804,'enUS','Imposter!  It is a dishonor without equal to be summoned by a whelp such as you!  DIE!','',26124),
(10805,'enUS','Your treachery only speeds your doom.  This world will fall to darkness!','',26124),
(10806,'enUS','You dare!  Outrageous!  I curse you, $c.  I curse you with... death!','',26124),
(10807,'enUS','What?  Such a small, frail thing beckons me?  I shall add your bones to my throne, $r!!','',26124),
(10808,'enUS','','Happy Hallow\'s End!  Do you like my mask?  Very scary!',26124),
(10809,'enUS','','Happy Hallow\'s End!  How do you like my mask?  Very scary!',26124),
(10810,'enUS','Killing you and your cohorts, $c, will amuse me.  I shall make it quick.','',26124),
(10811,'enUS','','I\'m going to miss out on a lot of the trick-or-treating!',26124),
(10812,'enUS','I\'m going to miss out on trick-or-treating because I can\'t go out!','',26124),
(10813,'enUS','','You\'re the best, $n - thanks for going trick-or-treating for me!',26124),
(10814,'enUS','You\'re the best, $n - thanks for going trick-or-treating for me!','',26124),
(10815,'enUS','What Hallow\'s End candy do you have for sale?','What Hallow\'s End candy do you have for sale?',26124),
(10816,'enUS','What is there to do on Hallow\'s End?','What is there to do on Hallow\'s End?',26124),
(10817,'enUS','','What ISN\'T there to do, you mean!$B$BEach of the innkeepers throughout the world are handing out trick-or-treat goodies, and many of the towns are decorated for the season!  Also, there is the Wickerman Festival just outside the Undercity during the evenings.',26124),
(10818,'enUS','','What ISN\'T there to do, you mean!$B$BEach of the innkeepers throughout the world are handing out trick-or-treat goodies, and many of the towns are decorated for the season!  Also, Sergeant Hartman in Southshore needs help against the Forsaken and their Wickerman Festival.$B$BOne more thing - I\'ve heard that a sick little boy at the orphanage in Stormwind is looking for someone to help him gather treats for the holiday.',26124),
(10819,'enUS','I am despawning from $n.','I am despawning from $n.',26124),
(10820,'enUS','Sergeant Hartman!  I need to buy another stink bomb cleaner!','Sergeant Hartman!  I need to buy another stink bomb cleaner!',26124),
(10821,'enUS','I want to buy another stink bomb!','I want to buy another stink bomb!',26124),
(10822,'enUS','%s laughs maniacally.','',26124),
(10823,'enUS','No!  It can\'t be...','',26124),
(10824,'enUS','Pathetic fool!  Now I will teach you the meaning of pain!','',26124),
(10826,'enUS','%s begs Impsy for forgiveness.','',26124),
(10827,'enUS','Prepare to meet your doom!','',26124),
(10828,'enUS','Uh oh...','',26124),
(10829,'enUS','','It is history... A history of Silithus... of Ahn\'Qiraj... of Titans and Old Gods... I read from the prophecy of C\'Thun as written by the Qiraji Prophet Skeram. A prophecy that portends a cataclysm...\n',26124),
(10830,'enUS','','In the time before time, when the world was still in its infancy, a battle between a Titan and a being of unimaginable evil and power raged on this very soil. The prophecy is unclear about whether or not the Titan was vanquished in this battle but it illustrates that a Titan fell. An Old God had also fallen - or so it was thought.\n',26124),
(10831,'enUS','','For millennia this being lay dormant beneath the world - biding its time. From its prison it waited for the exact moment at which to strike back at those that would see it harmed.\n',26124),
(10832,'enUS','','The land of eternal starlight, Kalimdor, was a nurturing mother to all of its creatures. The magic of the Well of Eternity permeated the land and empowered the multitude of flora and fauna that would make the world their home. From this magical ether were born the silithid. It was through the silithid that the brooding Old God would reach and attempt to sunder the world that it once held in its unmerciful grasp. \n',26124),
(10833,'enUS','','The Old God would create avatars from the silithid in its own image. These avatars were to be known as Qiraji. Sentient and with purpose, the Qiraji would name their creator: C\'Thun was born... For many thousands of years the Qiraji worked feverishly to build a force capable of laying waste to the world that would betray their god. The great fortress city of Ahn\'Qiraj was created to house their growing armies and prepare for the coming of C\'Thun.\n',26124),
(10834,'enUS','%s examines the Scourgestone closely.','',26124),
(10835,'enUS','The evil in these stones is strong, but it has been dispelled.','',26124),
(10836,'enUS','','This can\'t be right. An Old God could never be allowed to enter this world. The results would be... Oh dear!',26124),
(10837,'enUS','','%s regains her composure.',26124),
(10838,'enUS','','There is more.',26124),
(10839,'enUS','','The moment that C\'Thun had so patiently waited for had finally arrived. His children had spent thousands of years building an army capable of exacting revenge upon the whole of Kalimdor and now the prize was within their grasp.\n',26124),
(10840,'enUS','','The Titans had long since vacated this world. Only the night elves that once inhabited this area were here to defend. Oh my! The next passage is fascinating!\n',26124),
(10841,'enUS','','A mighty Qiraji known as General Rajaxx would command the initial incursion into Silithus. Only one would stand in his way: A night elf known as Staghelm. They refer to him as Khar\'sis or \'hand of the earth\' in the native Qiraji tongue.\n',26124),
(10842,'enUS','','Staghelm and his armies were clearly overwhelmed as the endless flow of Rajaxx\'s troops poured into Silithus. It would seem as if Staghelm, however, was more than just a nuisance to the Qiraji. Under Staghelm, the whole of the night elf armies had come together to defend Kalimdor, greatly slowing the Qiraji forces.\n',26124),
(10843,'enUS','','Unfortunately, the night elf defense was untenable and Rajaxx knew that they could not hold out much longer. Their tenacity, however, was causing great frustration to Rajaxx and causing even more frustration to his king. Wait, kings? Incredible...\n',26124),
(10844,'enUS','','Vek\'nilash and Vek\'lor, known as the Twin Emperors of Ahn\'Qiraj, watched the war from the sanctuary of their temple. The clever brothers devised a plan to demoralize and divide Staghelm\'s forces. ',26124),
(10845,'enUS','','Valstann Staghelm served as the right hand of Fandral. A proud and noble warrior, his dedication and adoration for his father unyielding... and the Twin Emperors sensed this as weakness. A weakness that could be exploited.\n',26124),
(10846,'enUS','','The Qiraji forces were commanded to fall back and hide the bulk of their numbers beneath the sands of the desert. A small attack was ordered upon Southwind Village while the front lines of Staghelm\'s army were kept occupied.',26124),
(10847,'enUS','','Valstann, eager to please his father, convinced Fandral to allow him to take a small battalion to the defense of Southwind. Surely with the tide of battle turning their way, no harm could come to his beloved child. The trap was missed. Valstann was captured by the hiding Qiraji and Southwind Village obliterated. Rajaxx himself would take the captive Valstann to the front lines of the battle where - in front of Staghelm and the night elf forces - he would brutally execute the young night elf.\n',26124),
(10848,'enUS','','The war continued but the will of the great leader was sapped. The whole of Silithus was soon engulfed by the silithid and their Qiraji hosts.',26124),
(10849,'enUS','','Poor man, this explains so much.',26124),
(10850,'enUS','','The night elf army was pushed back through Un\'Goro, to the borders of the Tanaris desert. Something in Un\'Goro prevented the Qiraji from being able to take the land. I do not quite understand this word but I believe it to mean \'God Lands.\' It is stated that they could not \'take the God Lands.\' \n',26124),
(10851,'enUS','Fascinating, this coincides with theories of Un\'Goro being the home of the Titans when they inhabited Kalimdor. Perhaps Aman\'thul himself watched over \'The God Lands.\'\n','Fascinating, this coincides with theories of Un\'Goro being the home of the Titans when they inhabited Kalimdor. Perhaps Aman\'thul himself watched over \'The God Lands.\'\n',26124),
(10852,'enUS','','Hrm, curious... This ends abruptly. In Tanaris the Qiraji document facing a bronze dragon. There is much missing from this... More information must be found! Surely they are planning to invade Kalimdor once more!\n',26124),
(10853,'enUS','%s shifts uncomfortably.','',26124),
(10854,'enUS','When the time is right, my lady. All will be clear when the time is right. The master stirs even now. Look to the skies for the Brood of Nozdormu have returned.','',26124),
(10855,'enUS','Some call me... Impsy?','',26124),
(10856,'enUS','','The Wickerman festivities will begin in ten minutes!  Join us in the Ruins of Lordaeron courtyard to celebrate Hallow\'s End and our liberation from the Scourge!',26124),
(10857,'enUS','Leave at once, stranger!  I have no business with you.','',26124),
(10858,'enUS','You\'re back already!  What can I do for you now?','',26124),
(10859,'enUS','','The burning of the Wickerman will begin in fifteen minutes!  Come to the festival - located just west of the Undercity - and celebrate Hallow\'s End and our liberation from the Scourge!',26124),
(10860,'enUS','','The burning of the Wickerman will begin in five minutes!  Come to the festival - located just west of the Undercity - and celebrate Hallow\'s End and our liberation from the Scourge!',26124),
(10861,'enUS','','The Wickerman Festival now begins!  Power to the Forsaken!',26124),
(10862,'enUS','The war against the Horde has reached full tilt, $n.  This is a time of great need for the Alliance and it\'s necessary that all of us do our part to help.','',26124),
(10863,'enUS','War is upon us, $n.  It\'s time for every member of the Horde to answer the call and join the fight against the cowardly Alliance.','',26124),
(10864,'enUS','%s surveys the ground and nods approvingly.','',26124),
(10865,'enUS','I don\'t think it\'s strong enough.','',26124),
(10866,'enUS','Come, $n. The lake is just around the bend.','',26124),
(10867,'enUS','Stand near me, $n. I will protect you should anything go wrong.','',26124),
(10868,'enUS','Malfurion!','',26124),
(10869,'enUS','Remulos, old friend. It is good to see you once more. I knew that the message would find its way to you - one way or another.','',26124),
(10870,'enUS','It was shrouded in nightmares, Malfurion. What is happening in the Dream? What could cause such atrocities?','',26124),
(10871,'enUS','I fear for the worst, old friend. Within the Dream we fight a new foe, born of an ancient evil. Ysera\'s noble brood has fallen victim to the old whisperings. It seems as if the Nightmare has broken through the realm and seeks a new host on Azeroth.','',26124),
(10872,'enUS','I sensed as much, Malfurion. Dark days loom ahead.','',26124),
(10873,'enUS','Aye, Remulos. Prepare the mortal races.','',26124),
(10874,'enUS','You have been gone too long, Malfurion. Peace between the children of Azeroth is tenuous at best. What of my father? Of your brother? Have you any news?\n','',26124),
(10875,'enUS','','You\'re a leatherworker by trade, aren\'t you?  It\'s that faint smell of cured hides, I\'d recognize it anywhere.$B$BMy father used to talk about a famous artisan who lived in Southwind Village centuries ago.  It\'s a shame the place is in ruins now.',26124),
(10876,'enUS','Cenarius fights at my side. Illidan sits atop his throne in the Outland - brooding. I am afraid that the loss to Arthas proved to be his breaking point. Madness has embraced him, Remulos. He replays the events in his mind a thousand times per day, but in his mind, he is the victor and Arthas is utterly defeated. He is too far gone, old friend. I fear that the time may soon come that our bond is tested and it will not be as it was at the Well in Zin-Azshari. ','',26124),
(10877,'enUS','Farewell, old friend... Farewell...','',26124),
(10878,'enUS','Remulos, I am being drawn back... Tyrande... send her my love... Tell her I am safe. Tell her... Tell her I will return... Farewell...','',26124),
(10879,'enUS','Let us return to the grove, mortal.','',26124),
(10880,'enUS','The strands of LIFE have been severed! The Dreamers must be avenged!','',26124),
(10881,'enUS','Come forth, ye Dreamers - and claim your vengeance!','',26124),
(10882,'enUS','Your wicked souls shall feed my power!','',26124),
(10883,'enUS','I can sense the SHADOW on your hearts. There can be no rest for the wicked!','',26124),
(10884,'enUS','Taste your world\'s corruption!','',26124),
(10885,'enUS','Hope is a DISEASE of the soul! This land shall wither and die!','',26124),
(10886,'enUS','Peace is but a fleeting dream! Let the NIGHTMARE reign!','',26124),
(10887,'enUS','Children of Madness - I release you upon this world!','',26124),
(10888,'enUS','Come, puny mortals. Come and face your end. The secrets of Ahn\'Qiraj will die with Roman\'khan!','',26124),
(10889,'enUS','','Ah, $n - it is good to see you again.  I trust your affairs go well.',26124),
(10890,'enUS','All the resources have been gathered.  Yippee!','',26124),
(10891,'enUS','We have all the copper bars that we need. Thank you for your assistance, $c. You might wanna help out with the other materials being collected here.','',26124),
(10892,'enUS','$C, I need more copper bars! There\'s a war brewing at the Gates of Ahn\'Qiraj and we need supplies! The Alliance has collected $1997w and we need $1998w copper bars in total. If I don\'t get those copper bars, it\'s going to be my head on a platter!','',26124),
(10893,'enUS','My fury is released!','',26124),
(10894,'enUS','%s will be armed in 3 seconds!','',26124),
(10895,'enUS','Myolor, I was once an armorsmith and wish to instead learn the way of the weaponsmith. Will you teach me?','Myolor, I was once an armorsmith and wish to instead learn the way of the weaponsmith. Will you teach me?',26124),
(10896,'enUS','Myolor, I was once a weaponsmith and wish to instead learn the way of the armorsmith. Will you teach me?','Myolor, I was once a weaponsmith and wish to instead learn the way of the armorsmith. Will you teach me?',26124),
(10897,'enUS','Krathok, I was once an armorsmith and wish to instead learn the ways of the weaponsmith. Will you train me?','Krathok, I was once an armorsmith and wish to instead learn the ways of the weaponsmith. Will you train me?',26124),
(10898,'enUS','Krathok, I was once a weaponsmith and wish to instead learn the ways of the armorsmith. Will you train me?','Krathok, I was once a weaponsmith and wish to instead learn the ways of the armorsmith. Will you train me?',26124),
(10899,'enUS','You see large cavernous tunnels and corridors reflected inside the crystal. You recognize the area as the Molten Core.','',26124),
(10900,'enUS','<Touch the unstable rift crystal.>','<Touch the unstable rift crystal.>',26124),
(10901,'enUS','Let them feel the wrath of the Blue Flight! May Malygos protect me!','',26124),
(10902,'enUS','Alexstrasza grant me the resolve to drive our enemies back!','',26124),
(10903,'enUS','','Succumb to the endless dream, little ones. Let it consume you!',26124),
(10904,'enUS','Anachronos, this diversion will give you and the young druid time enough to seal the gate. Do not falter. Now, let us see how they deal with chaotic magic.','',26124),
(10905,'enUS','Up!','',26124),
(10906,'enUS','The translocator hums, awaiting your command.','',26124),
(10907,'enUS','Do not forget the sacrifices made on this day, night elf. We have all suffered immensely at the hands of these beasts.','',26124),
(10908,'enUS','','We will push them back, Anachronos. This I vow. Uphold your end of this task. Let not your hands falter as you seal our fates behind the barrier.',26124),
(10909,'enUS','We must act quickly or all shall be lost!','',26124),
(10910,'enUS','My forces cannot overcome the Qiraji defenses. We will not be able to get close enough to place your precious barrier, dragon.','',26124),
(10911,'enUS','','There is a way...',26124),
(10912,'enUS','','%s glances at her compatriots.',26124),
(10913,'enUS','%s nods knowingly.','',26124),
(10914,'enUS','Aye, Fandral, remember these words: Let not your grief guide your faith. These thoughts you hold... dark places you go, night elf. Absolution cannot be had through misguided vengeance.','',26124),
(10915,'enUS','NOW, STAGHELM! WE GO NOW! Prepare your magic!','',26124),
(10916,'enUS','It is done, dragon. Lead the way.','',26124),
(10917,'enUS','Stay close...','',26124),
(10918,'enUS','Greetings, $r. Wonderful day to be alive, is it not?','Greetings, $r. Wonderful day to be alive, is it not?',26124),
(10919,'enUS','Not all Tauren despise your kind, $r. Alas, I am forbidden to offer you my services.','Not all Tauren despise your kind, $r. Alas, I am forbidden to offer you my services.',26124),
(10920,'enUS','FINISH THE SPELL, STAGHELM! I CANNOT HOLD THE GLYPHS OF WARDING IN PLACE MUCH LONGER! CALL FORTH THE ROOTS!','',26124),
(10921,'enUS','Ancient ones guide my hand... Wake from your slumber! WAKE AND SEAL THIS CURSED PLACE!','',26124),
(10922,'enUS','%s falls to one knee - exhausted.','',26124),
(10923,'enUS','It... It is over, Lord Staghelm. We are victorious. Albeit the cost for this victory was great.','',26124),
(10924,'enUS','There is but one duty that remains...','',26124),
(10925,'enUS','Before I leave this place, I make one final offering to you, Lord Staghelm. Should a time arise in which you must gain entry to this accursed fortress, use the Scepter of the Shifting Sands on the sacred gong. The magic holding the barrier together will dissipate and the horrors of Ahn\'Qiraj will be unleashed upon the world once more.','',26124),
(10926,'enUS','%s hands the Scepter of the Shifting Sands to Fandral Staghelm.','',26124),
(10927,'enUS','After the savagery that my people have witnessed and felt, you expect me to accept another burden, dragon? Surely you are mad.','',26124),
(10928,'enUS','I want nothing to do with Silithus, the Qiraji and least of all, any damned dragons!','',26124),
(10929,'enUS','%s hurls the Scepter of the Shifting Sands into the barrier, shattering it.','',26124),
(10930,'enUS','The sands of time will halt, but only for a moment! I will now conjure the barrier.','',26124),
(10931,'enUS','Lord Staghelm, where are you going? You would shatter our bond for the sake of pride?\n','',26124),
(10932,'enUS','My son\'s soul will find no comfort in this hollow victory, dragon. I will have him back. Though it takes a millennia, I WILL have my son back!  ','',26124),
(10933,'enUS','%s shakes his head in disappointment.','',26124),
(10934,'enUS','%s kneels down to pick up the fragments of the shattered scepter.','',26124),
(10935,'enUS','And now you know all that there is to know, mortal... ','',26124),
(10936,'enUS','Listen up, flapjack, we\'re in for the fight of our lives with the bugs in Ahn\'Qiraj and we need to get prepared for it. I\'m collecting iron bars here.  Currently, the Alliance only has $2002w iron bars, but we\'re projected to need a total of $2003w for the war effort.','',26124),
(10937,'enUS','Thanks to everyone\'s efforts we now have all the iron bars that we need. Check with one of the others to see if there\'s something else you should be out there collecting for the war effort. Me, I\'m going to see if I can get out of here a little early to play some cards.','',26124),
(10938,'enUS','','$C, please listen to what I have to say. The Alliance and Horde are preparing for a war with the Silithid and their masters in Ahn\'Qiraj. Any assistance that you can lend will be greatly appreciated. As you can see, I am collecting thorium bars here for the war effort. We need to gather $2012w in total, and currently we have $2011w.',26124),
(10939,'enUS','','Thank you for checking in with me, $c. We now have all of the thorium bars that we\'ll need, but you may want to ask some of the others here that are in charge of different collection efforts.',26124),
(10940,'enUS','It\'s true, even stranglekelp can be quite useful in building up what we need for the upcoming war at Ahn\'Qiraj! It has so many uses, like making ice cream for hot days under the Silithus sun, as a salve for the effects of some icky plants, breathing underwater, hardening the skin, making you quick, regaining magic power; so many things I can\'t think of them all! Did I mention making ice cream?$B$BAnywhoodles, I\'ve got about $2047w here, and I need a total of $2048w!','',26124),
(10941,'enUS','Not that I\'m quite sure that you could ever possibly in a gazillion years have enough stranglekelp, what with all the ice cream one needs, but we seem to have enough. Or that\'s what I\'m told anyway. It looks like some of the others here might need help with whatever it is that they\'re collecting. Understandable really when you consider that theirs just couldn\'t possibly be as fun as collecting stranglekelp.','',26124),
(10942,'enUS','Greetings, young $c. In preparation for the war at Ahn\'Qiraj against the Silithid, the Alliance has asked me to head up their collection of purple lotus. This flower has many uses that I am aware of, and thus, I have agreed to help them attain $2055w. To date we have collected $2053w.','',26124),
(10943,'enUS','It is with satisfaction that I relay to you we have collected all of the purple lotus that we feel we need. Thank you for your contribution to the effort, $c. If you are so inclined, there are most likely several still here that are collecting other resources for the struggle.','',26124),
(10944,'enUS','','We\'re preparing for war, $c. We\'ve taken all that we\'re going to from the Silithid and their masters in Ahn\'Qiraj. To get ready for it we\'re collecting all sorts of material. I\'m in charge of gathering Arthas\' Tears. Not sure what we need them for though. If you ask me I don\'t want anything to do with that madman, even if it is just a flower named after him.$B$BStill, I\'m my father\'s daughter, and a soldier, so I do what I\'m told. Currently we have $2057w and need to collect a grand total of $2058w.',26124),
(10945,'enUS','','I guess that\'s that. We have all of the Arthas\' Tears necessary. You might try asking around. One of these others is sure to have something that they still need collected for the war effort.',26124),
(10946,'enUS','I get reports of your exploits against the Abyssal Council all the time, $n.  You\'re doing great things out there!$B$BKeep it up, and we\'ll make it worth the effort!','',26124),
(10947,'enUS','','The Ahn\'Qiraj War is on the horizon, $c, and in preparation the Alliance has asked my family to gather up a good deal of light leather for the war effort. Out of $2061w needed, we currently have $2060w. You look the type that might be able to help out.',26124),
(10948,'enUS','You dare spill blood on neutral ground? OUT! OUT, I SAY!','You dare spill blood on neutral ground? OUT! OUT, I SAY!',26124),
(10949,'enUS','We don\'t take kindly to miscreants, $r.','We don\'t take kindly to miscreants, $r.',26124),
(10950,'enUS','Taste blade, mongrel!','Taste blade, mongrel!',26124),
(10951,'enUS','Please tell me that you didn\'t just do what I think you just did. Please tell me that I\'m not going to have to hurt you... ','Please tell me that you didn\'t just do what I think you just did. Please tell me that I\'m not going to have to hurt you... ',26124),
(10952,'enUS','Get a rope!','Get a rope!',26124),
(10953,'enUS','As if we don\'t have enough problems, you go and create more!','As if we don\'t have enough problems, you go and create more!',26124),
(10954,'enUS','Believe me when I tell you this: You\'re gonna wish you weren\'t born, sissy!','Believe me when I tell you this: You\'re gonna wish you weren\'t born, sissy!',26124),
(10955,'enUS','Your actions shame us all, $c. I hurt inside as I beat you senseless.','Your actions shame us all, $c. It pains me to beat you senseless!',26124),
(10956,'enUS','','You\'re sweet for asking, $c, but we have all of the light leather that we need. May be that one of the others in charge of collecting around here is in need of your assistance though?',26124),
(10957,'enUS','$G Sir : Ma\'am;, yes $g sir : ma\'am;! Private Porter reporting for duty and ready to assist you with your medium leather collection needs. The Ahn\'Qiraj War is coming and we need to be as prepared as we can be.$B$BAs you can see we have collected exactly $2063w pieces of medium leather, and I have been tasked with gathering a total of $2064w.','',26124),
(10958,'enUS','Ah, um, yes $g sir : ma\'am;. It would appear that we have collected all of the medium leather that the Alliance feels is necessary for the war. I\'m told that there may be others here though that still need your assistance with their collection efforts.','',26124),
(10959,'enUS','','Hi there, $c! With the Ahn\'Qiraj War drawing near, our preparations here are in full swing. I\'m in charge of thick leather collections. It\'s a fine day for gathering thick leather, don\'t ya think? I got my stacks here and it looks like we\'ve got $2069w right now. Our magic number is $2071w. Want to help out?',26124),
(10960,'enUS','','Wow! Looks like we already gathered all of the thick leather they think we\'ll need. That sure went by fast. You know, there are probably others around here that could use your help though if ya want to give \'em a hand.',26124),
(10961,'enUS','Open fire!','',26124),
(10962,'enUS','','Hello, $c. I am collecting linen bandages here for the Ahn\'Qiraj war effort; an effort that will put us all to the test, but strengthen us for the war to come. I can assure you that any bandages that you choose to donate will be put to good use in helping to save the lives of our soldiers when the time comes. I am in need of $2077w, and to this point have managed to collect $2076w. Will you assist us?',26124),
(10963,'enUS','','Thank you for the inquiry, $c, but as you can see, I already have all of the linen bandages that the Alliance feels is necessary in preparation for the war at Ahn\'Qiraj. Don\'t let that stop you from helping out with the other collections going on here though.',26124),
(10964,'enUS','This better be important!','',26124),
(10967,'enUS','Aye, lads!  Things are about to get quite ugly.','',26124),
(10968,'enUS','Looks like it\'s going to be one of those days.','',26124),
(10969,'enUS','I should\'ve grabbed a bigger sword.','',26124),
(10970,'enUS','Footmen, make a line!','',26124),
(10971,'enUS','Great sorrow eminates from this crystal.','',26124),
(10972,'enUS','<Gaze into the crystalline tear.>','<Gaze into the crystalline tear.>',26124),
(10973,'enUS','Something big\'s coming out from the hive, ma\'am.  Headed straight for us.','',26124),
(10974,'enUS','','Soldier, call Captain Blackanvil at once!',26124),
(10975,'enUS','Yes, Ma\'am!','',26124),
(10976,'enUS','Captain!  Lieutenant Stouthammer requests your presence!  The enemy is approaching, sir!','',26124),
(10977,'enUS','','Hello, how are you feeling today, $c? Well, I hope. You may be wondering what is going on here. There\'s a war at Ahn\'Qiraj that is being planned and prepared for. We and the Horde are preparing as best we can for it.$B$BTo that end, the Alliance has asked me to supervise the collection of silk bandages here. To date we\'ve managed to put together $2082w out of $2083w needed. Are you thinking about helping out?',26124),
(10978,'enUS','','That\'s very kind of you to ask, but it would appear that we\'ve collected all of the silk bandages that we\'ll need. You could ask around though and see if anyone else needs help with their collections.',26124),
(10979,'enUS','$C, even our hardiest warriors and scouts will need use of the healing arts in the war to come at Ahn\'Qiraj. And when there is no magical healing available, they must rely upon our efforts here.$B$BTo date I have collected $2088w runecloth bandages, out of $2090w needed. If you are willing, we should speak further on how you can do your part.','',26124),
(10980,'enUS','$C, through the efforts of many we have managed to gather up all of the runecloth bandages that the Alliance feels it needs for the upcoming conflict. Were I you, I would ask some of the others here to see if they still have collection tasks that need fulfilling.','',26124),
(10981,'enUS','Alas $n, I am much too busy to talk.  As I mentioned, I need time to think on the situation at hand.$B$BI wish you luck in your travels.  Good day.','',26124),
(10982,'enUS','Stand ready!','',26124),
(10983,'enUS','Mmm, mmm, mmm. Can you smell that?! That\'s good eatin\' right there, $c. Rainbow Fin Albacore hits the spot every time. Slicky Gastronome here, ace connoisseur of all things edible, especially fish. With the Ahn\'Qiraj War looming, the Alliance thought it wise to bring in an expert for the war effort, so here I am, large and in charge.$B$BLooks like we\'re going to need $2093w of the fish, and we\'ve got a pile that currently comes to $2092w.','',26124),
(10984,'enUS','Well, looks like we have all of the cooked albacore that we can properly salt and store for the upcoming war at Ahn\'Qiraj. Thanks for asking though, $c. If you have a mind to, check around with the other collectors. I\'d bet there\'s someone else here that could use your help with gathering up whatever it is that they need.','',26124),
(10985,'enUS','Foolish whelp! I will consume your energies - and then your SOUL!','',26124),
(10986,'enUS','Take heart! Your friends will not long mourn your passing! ','',26124),
(10987,'enUS','I must feed... prepare to die!','',26124),
(10988,'enUS','','Oh, hi, $c. I guess the Alliance asked me to come here and keep track of all of this cooked meat that people are gathering because of the impending doom at Ahn\'Qiraj. Doesn\'t that sound like fun?$B$BAnyway, I suppose you\'d like to know how much we have. Last time I counted it we were at $2098w out of a total $2099w roast raptor needed.',26124),
(10989,'enUS','','Looks like you\'re too late, $c. We have all of the roast raptor that we need; killed, cooked and salted. Anyway, it looks like some of the others around here could use some help. You should go check with them. I\'m going to see if they\'ll let me go home now.',26124),
(10990,'enUS','','Proper sustenance will keep a soldier alive long after the wounds of the battlefield should have finished $g him : her; off, $c. If we\'re to persevere in the Ahn\'Qiraj War to come, we\'ll need all of the provisions that we can carry. I\'m gathering up spotted yellowtail fish at this location before it is to be shipped out.$B$BAs of now we have $2101w, but we need to collect a total of $2103w if we\'re going to be able to feed everyone.',26124),
(10991,'enUS','','Thank you for your inquiry, $c, but we have all of the spotted yellowtail necessary. There are others here though that may still be gathering materiel for the upcoming war. Seek them out, and may the goddess shine upon you.',26124),
(10992,'enUS','Move along, $C!','',26124),
(10993,'enUS','Off with you, $n!','',26124),
(10994,'enUS','Do not push it citizen!','',26124),
(10995,'enUS','Hello, $c. I\'m sure that I don\'t need to inform you of the gravity of our situation here. We need to gather many goods, and in most cases assemble them into materiel, to be transported to Cenarion Hold in Silithus. This is no small effort.$B$BRecently in the Molten Core we discovered something called a singed corestone. Our blacksmiths and engineers tell us that they can put them to good use, so I\'m supervising their accumulation here. As of now, out of $2110w needed, we\'ve managed to collect $2108w.','',26124),
(10996,'enUS','Thanks to the combined efforts of the Alliance\'s adventuring guilds, we have been able to gather all of the singed corestones we think that we\'ll need. However, you might want to check around with the other collectors here to see if they still need help in gathering up vital resources.','',26124),
(10997,'enUS','We need a great number of copper bars, $c. The upcoming war at Ahn\'Qiraj is going to use up a lot of metal for weapons, armor and whatnot. I\'m told that the Horde alone needs to collect $1998w copper bars. As of now we have $2018w.','',26124),
(10998,'enUS','According to the latest count we have all of the copper bars we\'re going to need for the war. If I were you I\'d check with some of the other collectors here to see if they need your help.','',26124),
(10999,'enUS','If you have not spoken to Magistrix Erona at the Sunspire, I recommend you do so immediately.  There are pressing matters to attend to, and she - as do we all - need your help!','',26124),
(11000,'enUS','$n, it is good to see you again.$B$BRemember to stay focused on your learning.  You represent our future, and should you falter our future will be dark indeed.','',26124),
(11001,'enUS','Throm\'ka, $c. You are here to help me with tin bars? They tell me that I will need $2006w so that they can make weapons and armor for the upcoming Ahn\'Qiraj War, but I only have $2005w right now. You are going to bring me more!','',26124),
(11002,'enUS','No more tin bars! Even my arms hurt from stacking them. We have all that we need, so go ask one of the others if they need you to collect anything.','',26124),
(11003,'enUS','','Welcome to the Falconwing Square Inn. May I prepare a meal for you, or ready a room?',26124),
(11004,'enUS','A golden placard along the side of the shrine reads:$B$B\"Here stands the Shrine of Dath\'Remar, a fitting tribute to the most noble of elves.  Let all who gaze on this monument remember his sacrifices to bring us to this land.  All who prosper in Quel\'Thalas do so thanks to him.\"','',26124),
(11005,'enUS','','Hail, $c.  The Ironforge Brigade is stationed here to keep an eye on Hive\'Zora.  The Cenarion Circle druids have been monitoring silithid movement and they\'re anticipating something major in this area.',26124),
(11006,'enUS','I\'m here to aid the Captain.','I\'m here to aid the Captain.',26124),
(11007,'enUS','','The Captain is busy at the moment.  He\'s studying maps we recently acquired of the underground silithid hives.  Stay with us if you\'d like to help, he\'ll come out any moment now.',26124),
(11008,'enUS','%s is stunned by Elune\'s Candle!','',26124),
(11009,'enUS','Kill $n!','',26124),
(11010,'enUS','','Hey mon, you be here ta bring me mithril bars no doubt. There be big trouble brewin\' in the Silithus desert at Ahn\'Qiraj. We and the Alliance goin\' all out this time to stop them bugs, and that be why you seein\' everyone here.$B$BThe Horde be askin\' me to collect $2009w for the war effort, but I only have $2008w. So ya gonna help me out, or what?',26124),
(11011,'enUS','','Yah, I know, it be lookin\' like we already have all of the mithril bars we be needin\' for the war. But ya know, there still be plenty of folk \'round here that can probably be usin\' your help right about now.  Thanks mon.',26124),
(11012,'enUS','They come now. Try not to get yourself killed, young blood.','',26124),
(11013,'enUS','','Hello, young $c. Are you here to bring me a batch of peacebloom? We are collecting them to make potions and elixirs for the Ahn\'Qiraj war effort. Though tragic that we are forced into this war, the results will be even more terrible if we do not prepare properly.$B$BThe Horde has tasked me with the collection of $2020w peacebloom, and so far we\'ve managed to put together $2021w. If you have it within your ability, please gather up all that you can and return them to me here.',26124),
(11014,'enUS','','It is good that you wish to help, $c. Unfortunately I have collected up all of the peacebloom that we feel we\'ll need for the war effort. Maybe you could ask around; I\'m sure that there are likely to be others here that still need your aid in gathering other things.',26124),
(11015,'enUS','You seek to harm me, $r?','',26124),
(11016,'enUS','I am a treasure hunter in search of powerful artifacts. Give them to me and you will not be harmed.','I am a treasure hunter in search of powerful artifacts. Give them to me and you will not be harmed.',26124),
(11017,'enUS','You challenge the charge of the Blue Dragonflight? DIE, vermin.','',26124),
(11018,'enUS','%s counterattacks with retaliation.','',26124),
(11022,'enUS','My watch is eternal, mortal.','',26124),
(11023,'enUS','There is more to magic than just arcane gesticulations... but I am speaking to someone who already knows this, yes?$B$BYou\'ve come to me to learn, and learn you will... just so long as you pay attention and do as I say.  The secrets of the demons do not cater to fools, and neither do I.','There is more to magic than just arcane gesticulations... but I am speaking to someone who already knows this, yes?$B$BYou\'ve come to me to learn, and learn you will... just so long as you pay attention and do as I say.  The secrets of the demons do not cater to fools, and neither do I.',26124),
(11025,'enUS','<Andorov looks at you grimly.>$B$BIf it bleeds, we can kill it.','',26124),
(11026,'enUS','Let\'s find out.','Let\'s find out.',26124),
(11027,'enUS','Your world shall suffer an unmerciful end. The Nightmare comes for you!','',26124),
(11028,'enUS','Remember, Rajaxx, when I said I\'d kill you last?','',26124),
(11029,'enUS','The end rapidly approaches! Surrender yourselves to Eranikus and be spared eternal suffering!','',26124),
(11030,'enUS','Pitiful, predictable mortals... You know not what you have done! The Master\'s will fulfilled. The Moonglade shall be destroyed and Malfurion along with it!','',26124),
(11031,'enUS','Run, little ones. Run and tell your masters that Eranikus has come to raze their world.','',26124),
(11032,'enUS','Kill first, ask questions later... Incoming!','',26124),
(11033,'enUS','You seek the scepter shard charged to the protection of the Blue Flight?$B$B<Azuregos appears to be smiling.>','',26124),
(11034,'enUS','How did you know? I mean, yes... Yes I am looking for that shard. Do you have it?','How did you know? I mean, yes... Yes I am looking for that shard. Do you have it?',26124),
(11035,'enUS','Of course I do not have the shard. That would be asinine. I walk amongst savages in this cursed land! I cannot take five steps without some crazed orc or human trying to thrust a sharp stick into my hide. At any given time you could very well be speaking to my ghostly spirit.$B$BAnyhow... I hid it.$B$BGo on... ask me where.','',26124),
(11036,'enUS','Alright. Where?','Alright. Where?',26124),
(11037,'enUS','You are going to love this story, $r. See, here is the thing. As soon as Malygos charged me with protecting the scepter shard, I knew I was in for an eternity of headache and pain.$B$BAll I want to do is study these magic rich shorelines and take in what artifacts might remain from the Sundering. You know, there was once a thriving Highborne civilization here! You don\'t have to tell me that there is going to be some solid magical items around here, $r. I can smell it!','',26124),
(11038,'enUS','By Bronzbeard\'s... um, beard! What are you talking about?','By Bronzbeard\'s... um, beard! What are you talking about?',26124),
(11039,'enUS','As I was saying, I held onto that scepter shard for a good five-hundred years and it was nothing but trouble. It attracted all kinds of attention - the wrong kind of attention. I want to be left alone to my studies not babysit some would be hero\'s ticket to glory. So... I gave it to the fish.','',26124),
(11040,'enUS','Fish? You gave a piece of what could be the key to saving all life on Kalimdor to a fish?','Fish? You gave a piece of what could be the key to saving all life on Kalimdor to a fish?',26124),
(11041,'enUS','Not just any fish, mortal. This fish was a minnow. A very special minnow.','',26124),
(11042,'enUS','A minnow? The oceans are filled with minnows! There could be a hundred million minnows out there!','A minnow? The oceans are filled with minnows! There could be a hundred million minnows out there!',26124),
(11043,'enUS','Exactly!','',26124),
(11044,'enUS','...','...',26124),
(11045,'enUS','Genius, I know... It will never be found; but, in case it is found, I gave the minnow some special powers.','',26124),
(11046,'enUS','You put the piece on a minnow and placed the minnow somewhere in the waters of the sea between here and the Eastern Kingdoms? And this minnow has special powers?','You put the piece on a minnow and placed the minnow somewhere in the waters of the sea between here and the Eastern Kingdoms? And this minnow has special powers?',26124),
(11047,'enUS','Correct. You\'ve been listening! This minnow is really quite a terrible creature of my own creation. When I am relaxing I like to think of the unlucky fishermen who have run into this minnow and been devoured whole. I bet they were quite surprised!$B$B<Azuregos laughs.>','',26124),
(11048,'enUS','You\'re insane.','You\'re insane.',26124),
(11049,'enUS','Genius is often misunderstood, $r. Now, about the scepter shard... If you want that shard and do not wish to spend the next ten thousand years searching for it, you are going to have to listen very carefully.','',26124),
(11050,'enUS','I\'m all ears.','I\'m all ears.',26124),
(11051,'enUS','Two words: Arcanite buoy.','',26124),
(11052,'enUS','Come again.','Come again.',26124),
(11053,'enUS','Right then... You have to build an arcanite buoy and place it in the ocean. My minnow will be attracted to the magical emanations. When he gets near the buoy - BLAMO! It will explode in a glorious pulse of arcane energy, revealing the minnow\'s true form. Also, you may or may not incur the wrath of Neptulon. A 50/50 chance I would say.','',26124),
(11054,'enUS','Ok, let me get this straight. You put the scepter shard entrusted to your Flight by Anachronos on a minnow of your own making and now you expect me to build an... an arcanite buoy or something... to force your minnow out of hiding? AND potentially incur the wrath of an Elemental Lord? Did I miss anything? Perhaps I am to do this without any clothes on, during a solar eclipse, on a leap year?\n','Ok, let me get this straight. You put the scepter shard entrusted to your Flight by Anachronos on a minnow of your own making and now you expect me to build an... an arcanite buoy or something... to force your minnow out of hiding? AND potentially incur the wrath of an Elemental Lord? Did I miss anything? Perhaps I am to do this without any clothes on, during a solar eclipse, on a leap year?\n',26124),
(11055,'enUS','General Rajaxx has been owned. Chalk up another victory for Andorov.','',26124),
(11056,'enUS','If I did not know better I would think that you were mocking me, mortal; but yes, that is mostly correct. You may remain fully clothed.','',26124),
(11057,'enUS','FINE! And how, dare I ask, am I supposed to acquire an arcanite buoy?','FINE! And how, dare I ask, am I supposed to acquire an arcanite buoy?',26124),
(11058,'enUS','Take this ledger to an old acquaintance of mine in Tanaris. His name is Narain Soothfancy - terrible, terrible, psychic but an amazing engineer! He should be able to make sense of it all.$B$BNo need to thank me, $n. It\'s the least I could do.$B$BGood day!','',26124),
(11059,'enUS','But...','But...',26124),
(11060,'enUS','I SAID GOOD DAY!','',26124),
(11061,'enUS','','Step carefully mortal.  You tread where mightier beings have met their fate.',26124),
(11062,'enUS','A thousand years ago, when the War of the Shifting Sands ended, three of our kin sacrificed themselves and held the Qiraji inside these halls while Anachronos and Staghelm sealed Ahn\'Qiraj shut.$B$BEach of us vowed to look for Merithra, Arygos and Caelestrasz should the Scarab Wall ever fall.$B$BAnd fall it did... and so we came.','',26124),
(11063,'enUS','Shouldn\'t you be saving the world?','',26124),
(11064,'enUS','<Narain holds an unopened envelope to his forehead.>$B$BWhat is... Mmmm... Velvet!$B$BAm I right?$B$BIf you\'re here to try and relearn a tradeskill, use the book over there...$B$B<Narain points to \"Soothsaying for Dummies.\">','',26124),
(11065,'enUS','Don\'t tell me! Shhh! You are here about the Ashbringer?!? Yes... Yes... No! My bad.$B$BWhat can I help you with, $r?$B$BIf you\'re here to try and relearn a tradeskill, use the book over there...$B$B<Narain points to \"Soothsaying for Dummies.\">','',26124),
(11066,'enUS','Narain Soothfancy, at your service! Retired engineer and master soothsayer! I can tell your future before it even happens!$B$BIf you\'re here to try and relearn a tradeskill, use the book over there...$B$B<Narain points to \"Soothsaying for Dummies.\">','',26124),
(11067,'enUS','You are not worth my time, $n!','',26124),
(11068,'enUS','Your path does not match mine.  You must seek training elsewhere, $c.','Your path does not match mine.  You must seek training elsewhere, $c.',26124),
(11069,'enUS','Do you seek training?','Do you seek training?',26124),
(11071,'enUS','I do what me can to train you in the priestly ways, if that what you be here for.','I do what me can to train you in the priestly ways, if that what you be here for.',26124),
(11072,'enUS','I require priest training.','I require priest training.',26124),
(11073,'enUS','I require rogue training.','I require rogue training.',26124),
(11074,'enUS','%s sets eyes on $n!','',26124),
(11075,'enUS','Hehehe, how you doin\' mon. You gonna help Pele\'keiki great deal he be thinkin\'. We be needin\' a bombastic amount of the firebloom herb to be preparin\' right for the Ahn\'Qiraj War. The Horde, they say, \'Pele\'keiki, you get us $2051w of the fire petals right quick\'.$B$BPele\'keiki tell you now, he only have $2050w firebloom, but you gonna add to that real soon, right mon?','',26124),
(11076,'enUS','Pele\'keiki know, it seem impossible even to him, but we be havin\' all that firebloom the Horde be wantin\' for the war. If you not be feelin\' too lazy, Pele\'keiki think you be helpin\' out the others here. They sure to have many things they be wantin\' you to get for them.','',26124),
(11077,'enUS','','Ah, there you are. I was told to expect help, so please listen closely. The situation is this: I\'ve been tasked with gathering $2055w purple lotus in preparation for the coming war in Ahn\'Qiraj. To date we have $2054w.$B$BActually going into the field and collecting the flowers will be up to you and those like you. I am needed here to see that they are properly maintained and to find new, creative applications for their use against the silithid and whatever else awaits us there.',26124),
(11078,'enUS','','We\'re filled to capacity on purple lotus, $c. Go ask one of the others if they need your help, and leave me to my studies. There is no time to waste!',26124),
(11079,'enUS','','You\'re here to help with the heavy leather for the Ahn\'Qiraj war effort, are you, $c? Good, good. As you can see I\'ve collected $2066w, but we\'re going to need $2067w in total. That\'s a lot of skinning my friend, so I hope that your knife is sharp. The leather will go to all sorts of uses for making our war materiel and ensuring our success.',26124),
(11080,'enUS','','Ah, that\'s sweet of you mon, but we already got all the heavy leather that we need. And here I\'m sure that your knife is still sharp. Maybe you can put it to use helping the others with their collections, no?  Have a good one!',26124),
(11081,'enUS','','An unspeakable horror dwells here, mortal.  C\'Thun and his worshippers are not just an affront to nature, their existence presages destruction for Azeroth as we know it.$B$BMerithra sacrificed herself a thousand years ago along with Caelestrasz and Arygos because they knew this as well.  We\'re here because of our oath to return for them, but we\'re also here because C\'Thun must be stopped!',26124),
(11082,'enUS','','Lok\'tar, $c, I have important information! There\'s a war coming at Ahn\'Qiraj and we need to get ready for it. I\'m here collecting all of the thick leather that I can get my hands on. Right now we have $2070w, but the Warchief has tasked me with the gathering of $2071w. As you can see, I\'m a little short.',26124),
(11083,'enUS','','If you have more thick leather, I\'m sorry but you\'ve come too late. We have all that we need, but before you go would you check with the others here? There\'s likely someone that still needs your help with their own collecting.',26124),
(11084,'enUS','Hello, $c. I trust that you bring good tidings concerning the Ahn\'Qiraj War preparations. I myself have been placed in charge of all accumulation of rugged leather for the Horde; a task to which I feel uniquely qualified. Never underestimate the utility of a sharpened knife.$B$BAs to the rugged leather, we currently have $2073w out of $2074w needed.','',26124),
(11085,'enUS','Such a pity, and here I\'ll wager that you sharpened your knife special in anticipation of slicing a few skins for me. Alas, we\'ve already gathered all of the rugged leather necessary, $c. Do make yourself useful though, and check with the others here to see if they have any other collection tasks to send you on.','',26124),
(11086,'enUS','','I find the ocean floor to be very peaceful.',26124),
(11087,'enUS','','It\'s so lovely to see you again, $n! I really can\'t thank you enough for delivering that message to my dear little gnome.$B$BWould you like to hear a song? It will make traveling in the rough seas much easier!',26124),
(11088,'enUS','That would be wonderful! Thank you, Meridith.','That would be wonderful! Thank you, Meridith.',26124),
(11089,'enUS','','Lovely song, isn\'t it?',26124),
(11090,'enUS','Ah, $c, good to see you. We need assistance here with gathering supplies in preparation for the impending war at Ahn\'Qiraj. I\'ve been asked to put together a great many first aid field kits, and the primary component I need is wool bandages. I already have some, $2079w to be exact, but I need to collect $2080w.','',26124),
(11091,'enUS','I thank you for your inquiry, but I already have all of the wool bandages necessary for the war effort. I suggest that you ask around though; there are many here that could probably still use your aid.','',26124),
(11092,'enUS','','Hello, $c, good of you to show up. Allow me to be succinct; we are gathering supplies for the Ahn\'Qiraj war effort. We wouldn\'t want to have more casualties than necessary, now would we? I have the responsibility of coordinating the collection of $2086w mageweave bandages. To date we have garnered $2085w. Care to assist?',26124),
(11093,'enUS','','How unfortunate; it would appear that we have collected all of the mageweave bandages necessary. Perhaps you can go sell them on the auction house? But before you go, be a good $g boy : girl; and check with the other collectors present. They may have an errand to send you off on.',26124),
(11094,'enUS','I shall take my secrets to the grave with me!','',26124),
(11095,'enUS','','The Earth Mother provides, but at times, a $c needs a little extra help to survive. Thus, I am collecting all of the runecloth bandages that we can in preparation for the looming war at Ahn\'Qiraj. As of now we have gathered $2089w on our way to collecting a total of $2090w.',26124),
(11096,'enUS','','It is very kind of you to ask after our needs, $c. It would appear though that we have collected all of the runecloth bandages we feel we\'ll need of the war. May I ask that you inquire around with some of the other collectors and lend them your aid if needed? Ancestors watch over you.',26124),
(11097,'enUS','','Grrr, what do you want, $r? Oh, you must be here about the lean wolf steaks for the impending Ahn\'Qiraj War. Yes, you heard right, I\'m collecting them, what about it? Do you have a fresh stack for me? I only need $2096w, and it looks like we have $2095w right now.',26124),
(11098,'enUS','','Looks like we have as many lean wolf steaks as the Horde wants. They told me to pack up what we have here and ready it to be shipped it out to Cenarion Hold in Silithus. But it looks like some of the others here might still be collecting whatever it is that they\'re in charge of. Go bug one of them.',26124),
(11099,'enUS','Ja mon, I be collectin\' up the fishy-fishy for the Horde. They gettin\' ready for big war in the desert at Ahn\'Qiraj, and askin\' me to get them $2103w of the spotted yellowtail. But right now we only be havin\' $2102w. You here to help?','',26124),
(11100,'enUS','Heya, $c! Lookin\' like we got all the spotted yellowtail that we be needin\' for that war. Maybe you going to some of the other collectors \'round here and askin\' them if they be needin\' your help?','',26124),
(11101,'enUS','Greetings, $c. It is good to see you interested in helping with the war effort. The collectors here are organizing the gathering of various stockpiles of goods so that we will be prepared when the time comes.$B$BI am in charge of obtaining $2106w baked salmon to store away for those involved in the fighting at Ahn\'Qiraj. The last time that I counted, we had collected $2105w.','',26124),
(11102,'enUS','It is good of you to ask, $c, but we already have all of the baked salmon that we\'ll need for the war. Perhaps you would be kind enough to check with the other collectors here; they are sure to have something that they could use your help with.','',26124),
(11103,'enUS','I do not have time to waste, $c; there is a war at Ahn\'Qiraj to prepare for. If you are going to help, we are collecting singed corestones from the Molten Core. I need to gather a total of $2110w, and currently have $2109w.','',26124),
(11104,'enUS','The guilds of the Horde have pulled together and accomplished this task already $c. We have all of the singed corestones necessary for our war materiel. Make yourself useful by asking the other collectors here if they need your aid.','',26124),
(11105,'enUS','Now is the time when the year is new and the moon shines bright.$B$BIt is our time... when the ancients awake.','',26124),
(11106,'enUS','No hello for your old friend, Narain? Who were you expecting???','',26124),
(11107,'enUS','%s eyes you suspiciously.','',26124),
(11108,'enUS','So... You thought you could fool me, did you? The greatest criminal mastermind Azeroth has ever known???','',26124),
(11109,'enUS','I see right through your disguise, $r. Number Two! Number Two kill!','',26124),
(11110,'enUS','KILL!','',26124),
(11111,'enUS','In days long past, we lived for the hunt.  We hunted for glory, for honor...$B$BIs it so different now?','In days long past, we lived for the hunt.  We hunted for glory, for honor...$B$BIs it so different now?',26124),
(11112,'enUS','','Dogs of the Cenarion Circle.  Slay them all!',26124),
(11113,'enUS','Your quest to learn Draconic is futile, mortal. And why would you ever want to learn to speak in the ancient tongue? Baffling really...','',26124),
(11114,'enUS','<Take this book for the good of Azeroth!>','<Take this book for the good of Azeroth!>',26124),
(11115,'enUS','%s is devoured!','%s is devoured!',26124),
(11116,'enUS','It... It\'s foggy, $n. I can\'t see anything! Wait... Wait a minute. I see... I see Doctor Weavil\'s hideout. It... YES! I believe he is holding a chapter of the book!$B$BLet me see if I can zoom this thing out to get a better vantage point.$B$B<Narain appears to be going cross-eyed.>$B$BAlcaz Island! That devious son-of-a-goblin is on Alcaz Island!','',26124),
(11117,'enUS','Evil makes me so sleepy...','',26124),
(11118,'enUS','%s yawns.','',26124),
(11119,'enUS','Lok\'tar, $r. I am General Zog, ambassador of the Horde. I am here to keep you apprised of the progress that the mighty Horde is making in their efforts toward the Ahn\'Qiraj War. What is it that you want to know?','',26124),
(11120,'enUS','What is the Ahn\'Qiraj war effort?','What is the Ahn\'Qiraj war effort?',26124),
(11121,'enUS','This line is mostly filler...','',26124),
(11122,'enUS','How many metal bars have the Horde collected so far?','How many metal bars have the Horde collected so far?',26124),
(11123,'enUS','How many metal bars you say? As of my last update on the situation, here is what I know. The Horde has collected $2018w copper bars out of $1998w needed, $2005w tin bars out of $2006w and of $2009w mithril bars sought, $2008w have been gathered.','',26124),
(11124,'enUS','How many herbs have the Horde collected so far?','How many herbs have the Horde collected so far?',26124),
(11125,'enUS','Last I heard the Horde had accumulated $2021w of $2020w peacebloom, $2050w of $2051w firebloom and $2054w out of $2055w purple lotuses.','',26124),
(11126,'enUS','How many leather skins have the Horde collected so far?','How many leather skins have the Horde collected so far?',26124),
(11127,'enUS','Leather skins? Yes, I just received some information on that. It would appear that of $2067w heavy leather needed, the Horde has collected $2066w. Also, $2070w out of $2071w thick leather and $2073w out of $2074w rugged leather have been gathered.','',26124),
(11128,'enUS','How many bandages have the Horde collected so far?','How many bandages have the Horde collected so far?',26124),
(11129,'enUS','The Horde is stockpiling a great many bandages. So far $2079w out of $2080w wool bandages have been collected. $2085w out of $2086w mageweave bandages have been created. And $2089w out of $2090w runecloth bandages have been gathered.','',26124),
(11130,'enUS','How many cooked goods have the Horde collected so far?','How many cooked goods have the Horde collected so far?',26124),
(11131,'enUS','You want to know about ration collections? Very well. Last I was told, the Horde had prepared $2095w out of $2096w lean wolf steaks. We\'ve also packed away $2102w of $2103w spotted yellowtail and $2105w out of $2106w baked salmon needed.','',26124),
(11132,'enUS','I want to ask you about something else.','I want to ask you about something else.',26124),
(11133,'enUS','Greetings, $r $c. I am Commander Stronghammer, the ambassador representing the Alliance here. If you have any questions concerning the status of Alliance collections for the Ahn\'Qiraj war effort, $g lad : lass;, don\'t hesitate to ask.','',26124),
(11134,'enUS','This line is mostly filler...','',26124),
(11135,'enUS','How many metal bars have the Alliance collected so far?','How many metal bars have the Alliance collected so far?',26124),
(11136,'enUS','A very good question, $c. When last I had heard, the Alliance had managed to smelt $1997w out of $1998w copper bars, $2002w out of $2003w iron bars and $2011w out of $2012w thorium bars needed for the war effort.','',26124),
(11137,'enUS','How many herbs have the Alliance collected so far?','How many herbs have the Alliance collected so far?',26124),
(11138,'enUS','Let me see, let me see. I had those numbers here somewhere. Ah yes, here they are! To date, the Alliance has collected $2047w stranglekelp, out of $2048w needed. It also says here that we have $2053w of $2055w purple lotus and $2057w out of $2058w arthas\' tears needed.','',26124),
(11139,'enUS','How many leather skins have the Alliance collected so far?','How many leather skins have the Alliance collected so far?',26124),
(11140,'enUS','Funny you should ask... I just received an update on that. Thus far, the Alliance has gathered $2060w of $2061w light leather, $2063w out of $2064w medium leather and $2069w of $2071w thick leather skins.','',26124),
(11141,'enUS','How many bandages have the Alliance collected so far?','How many bandages have the Alliance collected so far?',26124),
(11142,'enUS','Bandages you say? Yes, well, if memory serves from the last time I was told, it would appear that the Alliance has created $2076w of $2077w linen bandages, $2082w of $2083w silk bandages and $2088w of $2090w runecloth bandages.','',26124),
(11143,'enUS','How many cooked goods have the Alliance collected so far?','How many cooked goods have the Alliance collected so far?',26124),
(11144,'enUS','That reminds me, I\'m going to need to find something to eat soon. As to what the Alliance has been cooking up, I\'m told that $2092w out of $2093w rainbow fin albacore have been packed away. As well, $2098w of $2099w roast raptor and $2101w out of $2103w spotted yellowtail have been prepared and are currently in cold storage awaiting transport to Cenarion Hold in Silithus.','',26124),
(11145,'enUS','The stars of this time are bent on new paths, beacons of hope and strength for the coming ages.','The stars of this time are bent on new paths, beacons of hope and strength for the coming ages.',26124),
(11146,'enUS','Haha, $g boyo : girlie;! The Alliance has gathered everything that we\'re needin\' to get this here war started! Maybe the Horde will catch up soon?','',26124),
(11147,'enUS','It\'s all over \'cept for the crying now. All of the war materiel is being transported to Cenarion Hold in Silithus, and will be there in less than $2113w days. Shouldn\'t be much longer until the scepter is assembled and the war finally begins.','',26124),
(11148,'enUS','Well, well, what do you know, sparky, we did it. Everything\'s collected and ready to go. We\'re just waiting on those Horde yahoos now, and once they get their act together it\'s off to the races at Ahn\'Qiraj!','',26124),
(11149,'enUS','Woo hoo, here we go! Everyone\'s collected everything, and it\'s all being airlifted via zeppelin to Silithus as we speak. The last of it should be there in less than $2113w days. Once it\'s all over there, and the scepter has been assembled, the war against those dirty insects can begin. As they say, \'Ship It!\'	','',26124),
(11150,'enUS','','It would appear dear that the Alliance has managed to collect everything needed for the war effort. Now all that we\'re waiting on are those poor Horde creatures to finish with theirs.',26124),
(11151,'enUS','','Hello, $c. From what I\'ve been told, everything\'s been collected, and all of the materiel for the war is being shipped over to Silithus as we speak. It should all be there in less than $2113w days. Once that\'s done, and the gong has been rung with the Scepter of the Shifting Sands, the war will really begin.',26124),
(11152,'enUS','Well, looks like we\'ve gathered up everything that the Alliance is going to need; now we\'re just waiting on the Horde. I think soon I\'m going to see if there\'s any Tigule & Foror\'s ice cream nearby.','',26124),
(11153,'enUS','That\'s it, everything\'s been collected by both sides. Now it\'s all being transported over to Silithus and should be there in less than $2113w days. Once that\'s done and someone rings the gong on the Scarab Dais with the Scepter of the Shifting Sands, the war is on!','',26124),
(11154,'enUS','Welcome to Booty Bay, partner.  I hope your stay in my town is enjoyable and uneventful - emphasis on the latter.  We\'ve got plenty of drink if you\'re thirsty, and plenty of bouncers if you\'re antsy.$B$BNow then... what can this humble servant of the Steamwheedle Cartel do for you?  Better still - what can you do for me, eh?','',26124),
(11155,'enUS','All of the material necessary for the Alliance\'s contribution to the war effort has been satisfied, $c. We await the Horde\'s labors to be finalized and then shall move on to transporting the war materiel to Silithus.','',26124),
(11156,'enUS','All is completed, young $c. Even as we speak, both the Horde and the Alliance are in the process of transporting all final goods for the war into Silithus near Cenarion Hold, which should be complete in less than $2113w days. After that, the gong near the gates of Ahn\'Qiraj can be rung, and the war will begin.','',26124),
(11157,'enUS','','Hail, $c. As you may know, we\'ve completed all collections necessary for the Alliance\'s role in the upcoming war. Now it\'s up to the Horde to finish with theirs and we\'ll ship out to Silithus.',26124),
(11158,'enUS','','Are you reporting for duty, $c? All of the war materiel for both the Horde and the Alliance is completed and being shipped to Silithus as we speak. It should all arrive in less than $2113w days. I hope that someone has found the different pieces of the Scepter of the Shifting Sands and put them all together.',26124),
(11159,'enUS','A being of great power has awoken.','',26124),
(11160,'enUS','The beast returns from whence it came. The wrath of Neptulon has subsided.','',26124),
(11161,'enUS','','Well now, $g lad : lass;, it looks like the Alliance has already gathered up all that we need for our part of the war. I know that the blacksmiths, engineers and everyone else is busy with the final preparations, and as soon as the Horde assembles all of their goods, it will all be sent to Silithus for the war.',26124),
(11162,'enUS','','As I understand it dear, everything has been gathered and the final materiel is being assembled and shipped off to Cenarion Hold. The last of it should arrive in less than $2113w days. Once our equipment and forces are all there, the bearer of the Scepter of the Shifting Sands can ring the gong near Ahn\'Qiraj to open the gates. Then the war will begin.',26124),
(11163,'enUS','It\'s all over \'cept for the crying now. All of the war materiel is being transported to Cenarion Hold in Silithus, and the last of it will be there in less than a day. Shouldn\'t be much longer until the scepter is assembled and the war finally begins.','',26124),
(11164,'enUS','Woo hoo, here we go! Everyone\'s collected everything, and it\'s all being airlifted via zeppelin to Silithus as we speak. The last of it should be there in less than a day. Once it\'s all over there, and the scepter has been assembled, the war against those dirty insects can begin. As they say, \'Ship It!\'','',26124),
(11165,'enUS','','Hello, $c. From what I\'ve been told, everything\'s been collected, and all of the materiel for the war is being shipped over to Silithus as we speak. It should all be there in less than a day. Once that\'s done, and the gong has been rung with the Scepter of the Shifting Sands, the war will really begin.',26124),
(11166,'enUS','That\'s it, everything\'s been collected by both sides. Now it\'s all being transported over to Silithus and should be there in less than a day. Once that\'s done and someone rings the gong on the Scarab Dais with the Scepter of the Shifting Sands, the war is on!','',26124),
(11167,'enUS','All is completed, young $c. Even as we speak, both the Horde and the Alliance are in the process of transporting all final goods for the war into Silithus near Cenarion Hold, which should be complete in less than a day. After that, the gong near the gates of Ahn\'Qiraj can be rung, and the war will begin.','',26124),
(11168,'enUS','','Are you reporting for duty, $c? All of the war materiel for both the Horde and the Alliance is completed and being shipped to Silithus as we speak. It should all arrive in less than a day. I hope that someone has found the different pieces of the Scepter of the Shifting Sands and put them all together.',26124),
(11169,'enUS','','As I understand it dear, everything has been gathered and the final materiel is being assembled and shipped off to Cenarion Hold. The last of it should arrive in less than a day. Once our equipment and forces are all there, the bearer of the Scepter of the Shifting Sands can ring the gong near Ahn\'Qiraj to open the gates. Then the war will begin.',26124),
(11170,'enUS','Yes $g sir : ma\'am;! I\'ve been ordered to report that the Alliance has collected all war materiel necessary. It has been relayed to me that we are simply waiting on the Horde to finish their part and then everything will be shipped to Silithus. Thank you $g sir : ma\'am;!','',26124),
(11171,'enUS','A-ten-hut! All Ahn\'Qiraj war materiel accounted for and in the process of being transported to Cenarion Hold $g sir : ma\'am;! I am told that the last of it should arrive in less than $2113w days. Once that is done, and someone rings that gong over there to open the gates, I guarantee that we\'ll give those bugs one heck of a fight!','',26124),
(11172,'enUS','A-ten-hut! All Ahn\'Qiraj war materiel accounted for and in the process of being transported to Cenarion Hold $g sir : ma\'am;! I am told that the last of it should arrive in less than a day. Once that is done, and someone rings that gong over there to open the gates, I guarantee that we\'ll give those bugs one heck of a fight!','',26124),
(11173,'enUS','','Hey there, $c! Looks like the Horde collected the last of their stuff, and now theirs and ours is being shipped over to Silithus as we speak. I\'m told it\'ll be there in less than a day, and then someone can ring that big gong near the Ahn\'Qiraj gates to start the war.',26124),
(11174,'enUS','','Hey there, $c! Looks like the Horde collected the last of their stuff, and now theirs and ours is being shipped over to Silithus as we speak. I\'m told it\'ll be there in less than $2113w days, and then someone can ring that big gong near the Ahn\'Qiraj gates to start the war.',26124),
(11175,'enUS','','Hello, $c! I\'ve went around and asked, and it looks like all of us here have collected everything that the Alliance needs to prepare for the Ahn\'Qiraj War. Now we just need to encourage the Horde to do the same and then we\'ll be able to ship it all over to Cenarion Hold in Silithus.',26124),
(11176,'enUS','','',26124),
(11177,'enUS','Narain, I need another special kit.','Narain, I need another special kit.',26124),
(11178,'enUS','Narain, if you have enough materials, I could use another arcanite buoy.','Narain, if you have enough materials, I could use another arcanite buoy.',26124),
(11179,'enUS','','Even as we speak, $c, all of the war materiel is being transported over to Silithus. By the looks of things, the last of it should arrive in less than a day. After that, a $g hero : heroine; will need to come along and ring the gong at the Scarab Dais. Then the war will begin in earnest.',26124),
(11180,'enUS','','Even as we speak, $c, all of the war materiel is being transported over to Silithus. By the looks of things, all of it should arrive in less than $2113w days. After that, a $g hero : heroine; will need to come along and ring the gong at the Scarab Dais. Then the war will begin in earnest.',26124),
(11181,'enUS','','Take pride, $c, in the fact that the Alliance has completed all of the gathering tasks set before it. The finished products are stored and preserved, and our tradeskill professionals are hard at work molding those raw materials into war materiel that will be shipped to Silithus as soon as the Horde finishes their collections.',26124),
(11182,'enUS','','Looks like the last of the goods we\'ve collected is going to be shipped out to Silithus sometime in the next day. And once that\'s done, someone will have to come along and ring the gong on the Scarab Dais, outside of Ahn\'Qiraj, to open the gates. That\'s when our bandages will come in handy.',26124),
(11183,'enUS','','Looks like the last of the goods we\'ve collected are shipping out to Silithus over the next $2113w days. And once that\'s done, someone will have to come along and ring the gong on the Scarab Dais, outside of Ahn\'Qiraj, to open the gates. That\'s when our bandages will come in handy.',26124),
(11184,'enUS','','The generals tell us that we\'ve collected everything that we need for the upcoming Ahn\'Qiraj War. Now we\'re just waiting for the Horde to finish their stockpiling and the transport of the war materiel can begin.',26124),
(11185,'enUS','All is gathered, $c. All is being transported for final preparation to Silithus and should arrive within a day. All of our combined forces await the $g hero : heroine; that will complete the reunification of the Scepter of the Shifting Sands, ring the gong and begin the Ahn\'Qiraj War.','',26124),
(11186,'enUS','All is gathered, $c. All is being transported for final preparation to Silithus and should arrive within $2113w days. All of our combined forces await the $g hero : heroine; that will complete the reunification of the Scepter of the Shifting Sands, ring the gong and begin the Ahn\'Qiraj War.','',26124),
(11187,'enUS','The Alliance has completed its gathering tasks, $c. Now, while we pack and prepare everything, we await the Horde\'s collections to be completed. Then we shall all transport our war materiel to Silithus.','',26124),
(11188,'enUS','All of the fish and everything else is on its way to Silithus, and should be there in less than a day. After that someone\'s going to have to ring that gong with the Scepter of the Shifting Sands to start the war.','',26124),
(11189,'enUS','All of the fish and everything else is on its way to Silithus, and should be there in less than $2113w days. After that someone\'s going to have to ring that gong with the Scepter of the Shifting Sands to start the war.','',26124),
(11190,'enUS','The buzz around here is that we\'ve collected everything that we need. Now it all comes down to the Horde gathering up their stuff. Once they have we can all ship our goods over to Silithus and the war can begin.','',26124),
(11191,'enUS','The walls of the chamber tremble. Something is happening...','The walls of the chamber tremble. Something is happening...',26124),
(11192,'enUS','%s bows.','',26124),
(11193,'enUS','Be steadfast, champion. I know why it is that you are here and I know what it is that you seek. Eranikus will not give up the shard freely. He has been twisted... twisted by the same force that you seek to destroy.','',26124),
(11194,'enUS','Are you really surprised? Is it hard to believe that the power of an Old God could reach even inside the Dream? It is true - Eranikus, Tyrant of the Dream, wages a battle against us all. The Nightmare follows in his wake of destruction.','',26124),
(11195,'enUS','Understand this, Eranikus wants nothing more than to be brought to Azeroth from the Dream. Once he is out, he will stop at nothing to destroy my physical manifestation. This, however, is the only way in which you could recover the scepter shard.','',26124),
(11196,'enUS','You will bring him back into this world, champion. ','',26124),
(11197,'enUS','','All of the food and war materiel we gathered is on its way to Silithus. It should be there in less than a day. Someone told me that once it\'s all assembled over near Cenarion Hold, someone\'s going to have to go ring the gong at the Scarab Dais to open the gates to Ahn\'Qiraj and start the war.',26124),
(11198,'enUS','','All of the food and war materiel we gathered is on its way to Silithus. It should be there in less than $2113w days. Someone told me that once it\'s all assembled over near Cenarion Hold, someone\'s going to have to go ring the gong at the Scarab Dais to open the gates to Ahn\'Qiraj and start the war.',26124),
(11199,'enUS','','Hey there, $c. I\'ve talked with everyone around here, and it seems like we have all of the stuff that the Alliance wants for the war. That mean orc ambassador said that the Horde is still gathering though, which means we have some time before we need to ship all of this stuff over to Silithus.',26124),
(11200,'enUS','','Greetings, $r. The war materiel is on its way and should be at Cenarion Hold within a day\'s time. We can only hope that once it is there that someone, having assembled the Scepter of the Shifting Sands, will step forward to ring the gong and open the gates.',26124),
(11201,'enUS','','Greetings, $r. The war materiel is gradually being sent on its way and should be at Cenarion Hold within $2113w day\'s time. We can only hope that once it is there that someone, having assembled the Scepter of the Shifting Sands, will step forward to ring the gong and open the gates.',26124),
(11202,'enUS','','All of us, working collectively, have accomplished a great task. Now an even greater one confronts us. We only await the completion of the Horde\'s gathering efforts and then we shall all confront the Silithid and their masters together.',26124),
(11203,'enUS','Unexpected that you are all capable of such organization. Both the Alliance and the Horde have completed their preparations for the Ahn\'Qiraj War. Even as we speak the materiel is being shipped over to Silithus and should all arrive within a day. Then it is up to the one who is going to reassemble the Scepter of the Shifting Sands to beat on the gong at the Scarab Dais and open the gates of Ahn\'Qiraj. That is when the war will truly begin!','',26124),
(11204,'enUS','Unexpected that you are all capable of such organization. Both the Alliance and the Horde have completed their preparations for the Ahn\'Qiraj War. Even as we speak the materiel is being shipped over to Silithus and should all arrive within $2113w days. Then it is up to the one who is going to reassemble the Scepter of the Shifting Sands to beat on the gong at the Scarab Dais and open the gates of Ahn\'Qiraj. That is when the war will truly begin!','',26124),
(11205,'enUS','As expected, the Horde has completed all of their preparations well in advance of you and your so-called Alliance. You are all holding us up as we cannot take final measures to begin the war until you finish your promised responsibilities.$B$BNow go and pull your weight, $r.','',26124),
(11206,'enUS','%s acknowledges your obeisance and then waves dismissively at you.','',26124),
(11207,'enUS','Attack!  For the Horde!','',26124),
(11208,'enUS','I\'ve heard that the last of the preparations are being shipped over to Silithus and should arrive in under a day. I don\'t want to see one of those bugs burrowing through into my mine, so I hope that someone is taking the time to assemble that Scepter of the Shifting Sands so the gong can be rung, the gates opened and the war finally begun.','',26124),
(11209,'enUS','I\'ve heard that the preparations are being shipped over to Silithus and should all arrive in under $2113w days. I don\'t want to see one of those bugs burrowing through into my mine, so I hope that someone is taking the time to assemble that Scepter of the Shifting Sands so the gong can be rung, the gates opened and the war finally begun.','',26124),
(11210,'enUS','Our work is done. Now we wait on the Alliance to finish theirs before shipping everything over to Silithus.','',26124),
(11211,'enUS','If someone has put together the magic scepter of the sands then the war with the bugs will be soon. I relish it, $c! The last of our war goods are on their way to Silithus and should be there within a day. Go and bring honor to the Horde!','',26124),
(11212,'enUS','If someone has put together the magic scepter of the sands then the war with the bugs will be soon. I relish it, $c! The last of our war goods are on their way to Silithus and should be there within $2113w days. Go and bring honor to the Horde!','',26124),
(11213,'enUS','Ours is the path of glory, $r! The puny Alliance is still trying to scrape together their war supplies, while we have gathered all of ours and stand ready to send them to Silithus.','',26124),
(11214,'enUS','I wonder, heroes, what will you do when I manage to destroy this shard? Will the world be beyond salvation?','',26124),
(11215,'enUS','What\'s this? A chip in the shard? Finally, a weakness exposed... It won\'t be long now.','',26124),
(11216,'enUS','Would it not be glorious if you somehow managed to defeat me but not before I could destroy the only hope Kalimdor may have? I am giddy with anticipation. Soon... Soon it will be dust.','',26124),
(11217,'enUS','Not even my father could have planned such tragedy... such chaos. You will never make it! Time is running out!\n','',26124),
(11218,'enUS','Ah, the protective layer is nearly gone. Do you hear that, heroes? That... That is the sound of inevitability. Of your hopes and dreams being crushed under the weight of my being.','',26124),
(11219,'enUS','The scepter shard is no more! Your beloved Kalimdor shall soon be a desolate wasteland. I will, of course, turn the Eastern Kingdoms into an ashen, lifeless void...','',26124),
(11220,'enUS','','And now the war, it be comin\' soon. All that be left is the sendin\' of all these goods and weapons to the Cenarion Hold in Silithus, and that is gonna be done within a day. Then some brave soul is gonna have to be ringin\' the gong near those Ahn\'Qiraj gates to open \'em and start the war.',26124),
(11221,'enUS','','And now the war, it be comin\' soon. All that be left is the sendin\' of all these goods and weapons to the Cenarion Hold in Silithus, and that is gonna be done within $2113w days. Then some brave soul is gonna have to be ringin\' the gong near those Ahn\'Qiraj gates to open \'em and start the war.',26124),
(11222,'enUS','','Not only am I havin\' all the mithril bars I be needin\', but all the Horde collections are done now mon. It\'s lookin\' like we just waitin\' on the Alliance and then we be goin\' to war!',26124),
(11223,'enUS','','It is true, young $r, we and the Alliance have gathered and prepared all that we will need for this upcoming conflict at Ahn\'Qiraj. Even now these things are being sent to Cenarion Hold, and the last of them should arrive within a day. After all is in place, some person will need to ring the gong on the Scarab Dais to open the gates and start the war.',26124),
(11224,'enUS','','It is true, young $r, we and the Alliance have gathered and prepared all that we will need for this upcoming conflict at Ahn\'Qiraj. Even now these things are being sent to Cenarion Hold, and they should all arrive within $2113w days. After all is in place, some person will need to ring the gong on the Scarab Dais to open the gates and start the war.',26124),
(11225,'enUS','','The Horde\'s gathering efforts are completed, $c. Now we bide our time with extra preparations while the Alliance finishes their war collections.',26124),
(11226,'enUS','Whoa now, $c, Pele\'keiki thinkin\' that you not knowin\' all that stuff be on its way to Silithus. Pele\'keiki told the last of it be getting\' there in less than a day, and after that some misguided fool gonna ring the gong outside the Ahn\'Qiraj gates to open \'em up and be startin\' the war.','',26124),
(11227,'enUS','Whoa now, $c, Pele\'keiki thinkin\' that you not knowin\' all that stuff be on its way to Silithus. Pele\'keiki told the last of it be getting\' there in less than $2113w days, and after that some misguided fool gonna ring the gong outside the Ahn\'Qiraj gates to open \'em up and be startin\' the war.','',26124),
(11228,'enUS','Haha, you be pullin\' me leg mon. Pele\'keiki know that you know we Horde already be havin\' all the war stuff we be needin\'. Now we just waitin\' on that Alliance to get all theirs and we startin\' up the war.','',26124),
(11229,'enUS','If it is my fate to fall, then my dying breath shall take you with me!','',26124),
(11230,'enUS','%s\'s laughter echoes through the halls of Blackwing.','',26124),
(11231,'enUS','%s\'s laughter can once more be heard through the halls of Blackwing.','',26124),
(11232,'enUS','','The end draws nigh! Even as we speak the last of our supplies are being shipped to Silithus and should arrive within a day. Once there I am sure that all we be assembled in quick order, and then we\'ll be awaiting the ringing of the gong at the gates to Ahn\'Qiraj to start the war. I look forward to analyzing whether our preparatory efforts will make a difference.',26124),
(11233,'enUS','','The end draws nigh! Even as we speak our supplies are being shipped to Silithus and should arrive within $2113w days. Once there I am sure that all we be assembled in quick order, and then we\'ll be awaiting the ringing of the gong at the gates to Ahn\'Qiraj to start the war. I look forward to analyzing whether our preparatory efforts will make a difference.',26124),
(11234,'enUS','','You are dutiful to inquire, $c, but all Horde collections have been completed. We now wait for the Alliance hegemony to finish theirs, and then all will be transported to Silithus in the vicinity of Cenarion Hold.',26124),
(11235,'enUS','','All of the collecting is done and the finished goods are being shipped over to Silithus as they\'re being completed. Looks like less than a day until all of it is over there. After that we just need to get someone to ring that gong and open the gates to Ahn\'Qiraj. Then the real fun begins.',26124),
(11236,'enUS','','All of the collecting is done and the finished goods are being shipped over to Silithus as they\'re being completed. Looks like less than $2113w days until all of it is over there. After that we just need to get someone to ring that gong and open the gates to Ahn\'Qiraj. Then the real fun begins.',26124),
(11237,'enUS','','Heya, $c, don\'t you know? The Horde is done with all of its collecting. We\'re just finishing up final preparations while we wait for the Alliance to finish their gathering. Then it will be time to ship everything over to Silithus for the war.',26124),
(11238,'enUS','','Throm\'ka, $c. All of the war materiel is in final preparation and being sent to Silithus. The last of it should arrive in less than a day. With the equipment readied, and our forces arrayed, all we will be waiting for is someone to ring the gong on the Scarab Dais, which should open the gates of Ahn\'Qiraj and start the war.$B$BLok\'tar Ogar!',26124),
(11239,'enUS','','Throm\'ka, $c. All of the war materiel is in final preparation and being sent to Silithus. It should arrive over the course of the next $2113w days. With the equipment readied, and our forces arrayed, all we will be waiting for is someone to ring the gong on the Scarab Dais, which should open the gates of Ahn\'Qiraj and start the war.$B$BLok\'tar Ogar!',26124),
(11240,'enUS','','The Horde stands ready now that we have finished with all of our resource gathering. We only wait for the sluggish Alliance to finish with theirs, and then on to glorious battle!',26124),
(11241,'enUS','All of our collections are completed, $c. That which we have assembled is in the process of being transported to Cenarion Hold in Silithus, and the last of it should take no more than a day to arrive. The Ahn\'Qiraj War can then start once that is done and someone brave and foolish rings the gong right outside of the gates down there.','',26124),
(11242,'enUS','All of our collections are completed, $c. That which we have assembled is in the process of being transported to Cenarion Hold in Silithus, and the rest of it should take no more than $2113w days to arrive. The Ahn\'Qiraj War can then start once that is done and someone brave and foolish rings the gong right outside of the gates down there.','',26124),
(11243,'enUS','Well now, it would appear that we have some time on our hands. The Horde has completed its gathering tasks, and all is being prepared for final shipment to Silithus. We\'re only waiting on the Alliance to finish with theirs. You should go ask that silly, little ambassador of theirs how far along they are.','',26124),
(11244,'enUS','All has been gathered and is being sent to Silithus, $c. The last of it should get there within a day. I can only hope that after the gong is rung, and the gates opened, that our efforts here will make an impact and save many lives.','',26124),
(11245,'enUS','All has been gathered and is being sent to Silithus, $c. It should get there within $2113w days. I can only hope that after the gong is rung, and the gates opened, that our efforts here will make an impact and save many lives.','',26124),
(11246,'enUS','We of the Horde have done all that we can to prepare for the upcoming war at Ahn\'Qiraj. Now we wait, $c, for the Alliance to do the same. Once they are done we will all transport our war materiel to Cenarion Hold in Silithus.','',26124),
(11247,'enUS','','Yes, you heard true, $c, all of our collections are complete and the last of the war materiel should arrive in Silithus within a day. I am told that once all is assembled there, and our troops readied, someone from within the ranks of you heroes is going to ring the gong outside of Ahn\'Qiraj, already having assembled the Scepter of the Shifting Sands to do so with. I hope that we don\'t have to wait too long for that to happen.',26124),
(11248,'enUS','','Yes, you heard true, $c, all of our collections are complete and the last of the war materiel should arrive in Silithus within $2113w days. I am told that once all is assembled there, and our troops readied, someone from within the ranks of you heroes is going to ring the gong outside of Ahn\'Qiraj, already having assembled the Scepter of the Shifting Sands to do so with. I hope that we don\'t have to wait too long for that to happen.',26124),
(11249,'enUS','','What is it now, $c, I haven\'t got all day? The Horde has completed its collections and now waits only on the Alliance to organize themselves and do the same. Perhaps you should be out there looking for the pieces to the Scepter of the Shifting Sands so that you can ring the gong at the Scarab Dais, opening the gates to Ahn\'Qiraj and thereby starting the war?',26124),
(11250,'enUS','','All of the preparations are complete now, $c. We await the last of the materiel to be sent to Silithus, which should be in less than a day\'s time. Then once the organization there is done with, someone will have to come forward and ring the gong on the Scarab Dais with the Scepter of the Shifting Sands. That is when the Ahn\'Qiraj War will begin. May the Earth Mother watch over all of us then.',26124),
(11251,'enUS','','All of the preparations are complete now, $c. We await the last of the materiel to be sent to Silithus, which should be in less than $2113w day\'s time. Then once the organization there is done with, someone will have to come forward and ring the gong on the Scarab Dais with the Scepter of the Shifting Sands. That is when the Ahn\'Qiraj War will begin. May the Earth Mother watch over all of us then.',26124),
(11252,'enUS','','While I live to serve the Earth Mother and the Horde, I cannot help but feel a little nervous now that we\'ve collected everything that we need. At least we have a little time until the Alliance finishes their gathering efforts. After that it will all be shipped to Cenarion Hold in Silithus, and the war will likely follow not long after.',26124),
(11253,'enUS','','Yes, yes, all of the Horde\'s and Alliance\'s war materiel is being shipped over to Silithus and should be there within a day. Do you know what happens then, $c? We hurry up and wait. Hopefully someone is gathering the pieces of the Scepter of the Shifting Sands, because in order to open the gates of Ahn\'Qiraj it needs to be rung against the gong on the Scarab Dais.',26124),
(11254,'enUS','','Yes, yes, all of the Horde\'s and Alliance\'s war materiel is being shipped over to Silithus and should be there within $2113w days. Do you know what happens then, $c? We hurry up and wait. Hopefully someone is gathering the pieces of the Scepter of the Shifting Sands, because in order to open the gates of Ahn\'Qiraj it needs to be rung against the gong on the Scarab Dais.',26124),
(11255,'enUS','','What is it, $c? The Horde is done with all collections, and final preparations are being made while the Alliance tries to catch up in their efforts. Is there anything else that you need?',26124),
(11256,'enUS','Looks like there be only one more day left to fish until all this here war materiel is shipped over to the Silithus desert mon. Then they\'s gonna be getting\' it all ready, and someone is gonna have to ring that gong down south of Cenarion Hold there to open them gates and be startin\' the war.','',26124),
(11257,'enUS','Looks like there be only $2113w more days left to fish until all this here war materiel is shipped over to the Silithus desert mon. Then they\'s gonna be getting\' it all ready, and someone is gonna have to ring that gong down south of Cenarion Hold there to open them gates and be startin\' the war.','',26124),
(11258,'enUS','Time to relax, the Alliance be way behind us mon. We all done with our collectin\' here, and the final polishes be goin\' on things as we speak. When they get done over in their Ironforge, then we be thinkin\' \'bout movin\' all this stuff to Silithus. \'Til then, sit tight and maybe do some fishin\'.','',26124),
(11259,'enUS','If you heard that all of the Horde and Alliance collections have been completed, then you heard right, $c. All of the goods for the war that we gathered and prepared are in the process of being sent to Cenarion Hold in Silithus, with less than a day until the last of it arrives there. After that I suppose we\'ll just have to wait and see who assembles that scepter to ring the gong with, which will open the gates to Ahn\'Qiraj and herald the war.','',26124),
(11260,'enUS','If you heard that all of the Horde and Alliance collections have been completed, then you heard right, $c. All of the goods for the war that we gathered and prepared are in the process of being sent to Cenarion Hold in Silithus, with less than $2113w days until the last of it arrives there. After that I suppose we\'ll just have to wait and see who assembles that scepter to ring the gong with, which will open the gates to Ahn\'Qiraj and herald the war.','',26124),
(11261,'enUS','All of the Horde\'s war effort tasks are completed, young $c. Now we need but wait for the Alliance to also finish theirs and all will be ready for the Ahn\'Qiraj War. Except perhaps for the gathering and reunification of the pieces to the Scepter of the Shifting Sands?','',26124),
(11262,'enUS','That\'s right, um, $g lad : lass;, all of the war materiel is being transported to Silithus and the last of it should get there within a day. After that, we\'ll all just have to wait and see who puts forth a $g hero : heroine; to reconstitute the Scepter of the Shifting Sands and ring the gong on the Scarab Dais. Only when that occurs will the war begin to open the gates of Ahn\'Qiraj.','',26124),
(11263,'enUS','That\'s right, um, $g lad : lass;, all of the war materiel is being transported to Silithus and the last of it should get there within $2113w days. After that, we\'ll all just have to wait and see who puts forth a $g hero : heroine; to reconstitute the Scepter of the Shifting Sands and ring the gong on the Scarab Dais. Only when that occurs will the war begin to open the gates of Ahn\'Qiraj.','',26124),
(11264,'enUS','While it is true that the Alliance has completed all of their war effort tasks, don\'t let that discourage you, $r. Time is of the essence, but we would much rather that you help in the Horde\'s collections carefully and thoroughly. That seems better to me than making a mistake that could cost someone their life once this war truly begins. Wouldn\'t you agree, $c?','',26124),
(11265,'enUS','Recover the scepter shard, $n. Nefarius must not be allowed to destr... destroy the shard.','',26124),
(11266,'enUS','I will pull the shard from his sundered corpse.','I will pull the shard from his sundered corpse.',26124),
(11267,'enUS','Looking for this: [Red Scepter Shard]? Come and get it...','',26124),
(11268,'enUS','Your meddling in demonic affairs ends NOW, mortal!  Face the great corruptor - Xandivious!','',26124),
(11269,'enUS','The Nightmare cannot be stopped!','',26124),
(11270,'enUS','%s squeezes the last bit of life out of $n and swallows their soul.','',26124),
(11271,'enUS','Come, $n. See what the Nightmare brings...','',26124),
(11272,'enUS','A chill is in the air.','A chill is in the air.',26124),
(11273,'enUS','We serve Thrall with great pride.  We\'ll travel as far as is needed to vanquish the enemy.','',26124),
(11274,'enUS','Reporting for duty, sir.','Reporting for duty, sir.',26124),
(11275,'enUS','You\'re just in time, $c.  Do you feel the ground shaking beneath you?$B$BSomething approaches from the hive.  Take a place near the grunts, $n.  I\'m counting on you!','',26124),
(11276,'enUS','The silithid are no match for the sons and daughters of Orgrimmar.  Soon all that will be left of them are their crushed limbs and wings under our feet, $n.','',26124),
(11277,'enUS','Eranikus, Tyrant of the Dream, has entered our world.','Eranikus, Tyrant of the Dream, has entered our world.',26124),
(11278,'enUS','','Very well, $n. I will use the Nightmare object to conjure forth Eranikus.',26124),
(11279,'enUS','','Follow me.',26124),
(11280,'enUS','','Steel yourselves! Summoning a being this powerful is seldom done with positive results.',26124),
(11281,'enUS','','Eranikus is here! Seek shelter! Safety!',26124),
(11282,'enUS','We will locate the origin of the Nightmare through the fragments you collected, $n. From there we will pull Eranikus through a rift in the Dream. Steel yourself, $c. We are inviting the embodiment of the Nightmare into our world.','',26124),
(11283,'enUS','To Nighthaven! Keep your army close, champion.','',26124),
(11284,'enUS','I will call forth Eranikus when I am given the word.','',26124),
(11285,'enUS','I am ready, Remulos.','I am ready, Remulos.',26124),
(11286,'enUS','The enemy is upon us, stand ready!','',26124),
(11287,'enUS','Merok!  Shai!  To my side!','',26124),
(11288,'enUS','For the Horde!','',26124),
(11289,'enUS','%s drinks in the suffering of the fallen.','',26124),
(11290,'enUS','The rift will be opened there, above Lake Elun\'ara. Prepare yourself, $n. Eranikus\'s entry into our world will be wrought with chaos and strife.\n','',26124),
(11291,'enUS','He will stop at nothing to get to Malfurion\'s physical manifestation. That must not happen... We must keep the beast occupied long enough for Tyrande to arrive.','',26124),
(11292,'enUS','Defend Nighthaven, hero...','',26124),
(11293,'enUS','Fiend! Face the might of Cenarius!','',26124),
(11294,'enUS','You are certainly not your father, insect. Should it interest me, I would crush you with but a swipe of my claws. Turn Shan\'do Stormrage over to me and your pitiful life will be spared along with the lives of your people.','',26124),
(11295,'enUS','Who is the predictable one, beast? Surely you did not think that we would summon you on top of Malfurion? Your redemption comes, Eranikus. You will be cleansed of this madness - this corruption.\n','',26124),
(11296,'enUS','%s lets loose a sinister laugh.','',26124),
(11297,'enUS','My redemption? You are bold, little one. My redemption comes by the will of my god.','',26124),
(11298,'enUS','%s roars furiously.','',26124),
(11299,'enUS','Rise, servants of the Nightmare! Rise and destroy this world! Let there be no survivors...','',26124),
(11300,'enUS','Hurry, $n! We must find protective cover!','',26124),
(11301,'enUS','Please, champion, protect our people.','',26124),
(11302,'enUS','We will battle these fiends, together! Nighthaven\'s Defenders are also among us. They will fight to the death if asked. Now, quickly, we must drive these aberrations back to the Nightmare. Destroy them all!','',26124),
(11303,'enUS','It will be done, Eranikus. Be well, ancient one.','',26124),
(11304,'enUS','Where is your savior? How long can you hold out against my attacks? ','',26124),
(11305,'enUS','Defeated my minions? Then face me, mortals!','',26124),
(11306,'enUS','Remulos, look how easy they fall before me? You can stop this, fool. Turn the druid over to me and it will all be over...','',26124),
(11307,'enUS','Let it be known that $n - Horde $C - has earned the undying respect of the Warchief.   $GHe : She; has engaged in great diplomacy with Timbermaw Hold and performed valiant actions for them on our behalf.   $GHe : She; has gone above and beyond the call of duty.  Three cheers for $n - a true hero of the Horde!','',26124),
(11308,'enUS','Let it be known that $n - Alliance $C - has earned the undying respect of Ironforge and the Alliance as a whole.  $GHe : She; has engaged in great diplomacy with Timbermaw Hold and performed valiant actions for them on our behalf.   $GHe : She; has gone above and beyond the call of duty.  Three cheers for $n - a true hero of the Alliance!','',26124),
(11309,'enUS','','Elune, hear my prayers. Grant us serenity! Watch over our fallen...',26124),
(11310,'enUS','','Seek absolution, Eranikus. All will be forgiven...\n',26124),
(11311,'enUS','','You will be forgiven, Eranikus. Elune will always love you. Break free of the bonds that command you!',26124),
(11312,'enUS','','The grasp of the Old Gods is unmoving. He is consumed by their dark thoughts... I... I cannot... cannot channel much longer... Elune aid me...',26124),
(11313,'enUS','Eranikus, Tyrant of the Dream, is wholly consumed by the Light of Elune. Tranquility sets in over the Moonglade.','Eranikus, Tyrant of the Dream, is wholly consumed by the Light of Elune. Tranquility sets in over the Moonglade.',26124),
(11314,'enUS','IT BURNS! THE PAIN... SEARING...','',26124),
(11315,'enUS','WHY? Why did this happen to ... to me? Where were you Tyrande? Where were you when I fell from the grace of Elune?','',26124),
(11316,'enUS','I... I feel... I feel the touch of Elune upon my being once more... She smiles upon me... Yes... I...','',26124),
(11317,'enUS','','Tend to the injuries of the wounded, sisters!',26124),
(11318,'enUS','It takes a bit of practice to be this close to the silithid and go unnoticed.  I don\'t recommend trying it if you can avoid it.  ','',26124),
(11319,'enUS','','%s falls to one knee.',26124),
(11320,'enUS','','Praise be to Elune... Eranikus is redeemed.',26124),
(11321,'enUS','Don\'t get me wrong, I\'d rather not be in a tunnel filled with silithid day in and day out, but if hiding here and watching these creatures\' movements is going to help us win the war then I\'ll do it for as long as it takes.','',26124),
(11322,'enUS','Soon we shall rid Azeroth of the silithids\' abominable presence.  Their potential for destruction is much greater than what you\'ve seen firsthand, $n.  Greater, darker powers are behind their activities.','',26124),
(11323,'enUS','For so long, I was lost... The Nightmare\'s corruption had consumed me... And now, you... all of you... you have saved me. Released me from its grasp.','',26124),
(11324,'enUS','But... Malfurion, Cenarius, Ysera... they still fight. They need me. I must return to the Dream at once.','',26124),
(11325,'enUS','I\'m here to retrieve your report.','I\'m here to retrieve your report.',26124),
(11326,'enUS','My lady, I am unworthy of your prayer. Truly, you are an angel of light. Please, assist me in returning to the barrow den so that I may return to the Dream. I, like Malfurion, also have a love awaiting me... I must return to her... to protect her...','',26124),
(11327,'enUS','And heroes... I hold that which you seek. May it once more see the evil dissolved. Remulos, see to it that our champion receives the shard of the Green Flight.','',26124),
(11328,'enUS','','%s nods.',26124),
(11329,'enUS','Let us leave Nighthaven, hero. Seek me out at the grove.','',26124),
(11330,'enUS','The Scepter of the Shifting Sands is whole once more, $n.$B$BIt must be you who uses the scepter. It must be you who heralds in the next age of your people.$B$BWhen you are prepared to ring the Scarab Gong and once more open the gates of Ahn\'Qiraj, I will grant you the Scepter. You have only to ask.\n','',26124),
(11331,'enUS','I am ready, Anachronos. Please grant me the Scepter of the Shifting Sands.','I am ready, Anachronos. Please grant me the Scepter of the Shifting Sands.',26124),
(11332,'enUS','The Scepter of the Shifting Sands is whole once more, $n.$B$BIt must be you who uses the scepter. It must be you who heralds in the next age of your people. $B$BYou must wait for the armies of the Horde and the Alliance to arrive in Silithus before you may ring the Scarab Gong. The time for war is close at hand.\n','',26124),
(11333,'enUS','The Scepter of the Shifting Sands is whole once more, $n.$B$BIt is you who must lead your armies into the cursed fortress city of Ahn\'Qiraj and mete justice to its inhabitants.$B$BVenture to Silithus and present the Scepter of the Shifting Sands to Jonathan the Revelator.\n','',26124),
(11334,'enUS','I\'m ready!','I\'m ready!',26124),
(11335,'enUS','','This line is mostly filler...',26124),
(11336,'enUS','What is an Alliance Commendation Signet?','What is an Alliance Commendation Signet?',26124),
(11337,'enUS','','An Alliance Commendation Signet is awarded to a $g hero : heroine; who goes above and beyond the call of duty to the Alliance.  Various Commendation Officers for the factions of the Alliance are located in all of the major cities; speak with the one with whom you\'d like to raise your reputation, and give them the number of signets they ask for!$B$BBy the way, during the war effort here, if you\'d rather receive a material reward for your signets in lieu of reputation, seek out Field Marshal Snowfall.',26124),
(11338,'enUS','We are united in cause, $r. An ancient evil threatens to extinguish all life on Kalimdor and consume the world with its depravity... Its hatred of all things born of the great Shapers: The eternal Titans.$B$BWe are the first and the last lines of defense against the armies of C\'Thun. If we do not rise up and strike at our enemy, our enemy will surely destroy us.$B$BThe war effort needs you!','',26124),
(11339,'enUS','An Alliance Commendation Signet is awarded to a $g hero : heroine; who goes above and beyond the call of duty to the Alliance.  Various Commendation Officers for the factions of the Alliance are located in all of the major cities; speak with the one with whom you\'d like to raise your reputation, and give them the number of signets they ask for!$B$BBy the way, during the war effort here, if you\'d rather receive a material reward for your signets in lieu of reputation, seek out Field Marshal Snowfall.','',26124),
(11340,'enUS','What is a Horde Commendation Signet?','What is a Horde Commendation Signet?',26124),
(11341,'enUS','A Horde Commendation Signet is awarded to a $g hero : heroine; who goes above and beyond the call of duty to the Horde.  Various Commendation Officers for the factions of the Horde are located in all of the major cities; speak with the one with whom you\'d like to raise your reputation, and give them the number of signets they ask for!$B$BBy the way, during the war effort here, if you\'d rather receive a material reward for your signets instead of reputation, seek out Warlord Gorchuk.','',26124),
(11342,'enUS','','A Horde Commendation Signet is awarded to a $g hero : heroine; who goes above and beyond the call of duty to the Horde.  Various Commendation Officers for the factions of the Horde are located in all of the major cities; speak with the one with whom you\'d like to raise your reputation, and give them the number of signets they ask for!$B$BBy the way, during the war effort here, if you\'d rather receive a material reward for your signets instead of reputation, seek out Warlord Gorchuk.',26124),
(11343,'enUS','%s begins to slow!','',26124),
(11345,'enUS','%s is freezing up!','',26124),
(11346,'enUS','%s begins to crack!','',26124),
(11347,'enUS','%s looks ready to shatter!','',26124),
(11348,'enUS','Anachronos, I have lost the signet ring. Could you supply me with a replacement?','Anachronos, I have lost the signet ring. Could you supply me with a replacement?',26124),
(11349,'enUS','Around this reindeer\'s neck is a tag with the Smokywood Pastures logo on it and a name - \"Metzen\".$B$BMetzen looks at you with sad, forlorn eyes.  It is almost as if the reindeer has been immobilized by some unseen force.','',26124),
(11350,'enUS','You\'re free, Metzen. The bad greench can\'t hurt you anymore.','You\'re free, Metzen. The bad greench can\'t hurt you anymore.',26124),
(11351,'enUS','Metzen\'s eyes light up with reindeer joy.','',26124),
(11352,'enUS','Even if you somehow managed to free us without defeating C\'Thun, we would focus all of our powers to see the beast banished back to the hell from whence it came - AT ANY COST.','',26124),
(11353,'enUS','','Heroes of the Brood? C\'Thun must be banished! We can assist you, mortal!',26124),
(11354,'enUS','I bear witness to a miracle that stands before me! In one thousand years of captivity, I have not seen a single LIVING specimen - other than those foul Qiraji and silithid - enter these chambers.','',26124),
(11355,'enUS','Soldiers of Kalimdor! Heroes of Silithus! One among you has dealt a vicious blow to our mortal enemies! $n and $g his:her; allies have relieved the Ruins of Ahn\'Qiraj of its merciless leader! Ossirian the Unscarred, scourge of Silithus, has finally been destroyed and his armies wholly dismantled!','',26124),
(11356,'enUS','','Look alive, lads!  The enemy has been sighted!  Form ranks immediately!',26124),
(11357,'enUS','Be sure to stick around for the next firework show!  Starting at 6PM, they\'re every hour on the hour!','Be sure to stick around for the next firework show!  Starting at 6PM, they\'re every hour on the hour!',26124),
(11358,'enUS','I don\'t know what they put in those kegs, but it goes down like honey!','I don\'t know what they put in those kegs, but it goes down like honey!',26124),
(11359,'enUS','After the firework show, they\'ll put out goblets so we can raise a toast!','After the firework show, they\'ll put out goblets so we can raise a toast!',26124),
(11360,'enUS','Well met, friend!','Well met, friend!',26124),
(11361,'enUS','Greetings, $c. I am Field Marshal Snowfall, commander of the war effort here. We\'ve a hard road to plow ahead of us, $g lad : lass;, so if you can help out, please do so. And feel free to ask questions.','',26124),
(11362,'enUS','We\'ve done it, $g lad : lass;! The Alliance and the Horde have completed gathering everything that we think we\'ll need for the Ahn\'Qiraj War. Right now the final goods are being taken over to Cenarion Hold in Silithus and the last of it will arrive within a day. After that, some brave $g hero : heroine; is going to need to ring the Scarab Gong with the Scepter of the Shifting Sands to open the gates to Ahn\'Qiraj. When those gates open, the war begins!','',26124),
(11363,'enUS','We\'ve done it, $g lad : lass;! The Alliance and the Horde have completed gathering everything that we think we\'ll need for the Ahn\'Qiraj War. Right now the final goods are being taken over to Cenarion Hold in Silithus and all of it will arrive within $2113w days. After that, some brave $g hero : heroine; is going to need to ring the Scarab Gong with the Scepter of the Shifting Sands to open the gates to Ahn\'Qiraj. When those gates open, the war begins!','',26124),
(11364,'enUS','Have you heard the good news, $c? The Alliance has completed all of its war effort collections! Now we simply await the Horde to finish theirs. When they do, we\'ll begin shipping all of the war materiel over to Silithus, and it shouldn\'t be long after that until the Ahn\'Qiraj War begins.','',26124),
(11365,'enUS','Good question, $c. Last I was informed; we have managed to collect $1997w copper bars out of $1998w needed. Additionally, I am told that we have $2002w iron bars out of $2003w, and $2011w out of $2012w thorium bars requested.','',26124),
(11366,'enUS','Herbs, herbs, hmmm, let me see here. Ah yes, here it is. To date we have accumulated $2047w out of $2048w stranglekelp, $2053w out of $2055w purple lotuses, and $2057w out of $2058w arthas\' tears needed.','',26124),
(11367,'enUS','I received an update on that just a moment ago. It looks like out of $2061w light leather needed, we have $2060w. As for the others, the report indicated that we\'ve gathered $2063w of $2064w medium leather, and $2069w out of our $2071w thick leather quota.','',26124),
(11368,'enUS','Collection of bandages is proceeding according to schedule. As far as linen bandages are concerned, we\'ve gathered $2076w of $2077w. Silk bandages have been tallied at $2082w out of $2083w, and we have $2088w out of $2090w runecloth bandages needed.','',26124),
(11369,'enUS','On the cooked goods front it would appear that we\'ve managed to collect and store away $2092w rainbow fin albacore, out of $2093w requested. Additionally, right now we have in $2098w of $2099w roast raptor and $2101w out of $2103w spotted yellowtail in cold storage.','',26124),
(11370,'enUS','Throm\'ka, Horde $C, stand proud! I am Warlord Gorchuk, commander of the Horde\'s war effort. There are trying times ahead of us, but we shall prevail, as always.$B$BIf you have questions, you should ask them.','',26124),
(11371,'enUS','The time for war is almost upon us, $c! Both the Horde and the Alliance have finished with their preparations. All of our war materiel is being shipped to Silithus as we speak. I\'d expect the last of it to arrive within a day. When all is assembled there, the one who has completed the arduous task of reassembling the Scepter of the Shifting Sands will bang it against the Scarab Gong and open the gates to Ahn\'Qiraj. Then battle shall be joined as has not been seen in ages!$B$BLok\'tar Ogar!','',26124),
(11372,'enUS','The time for war is almost upon us, $c! Both the Horde and the Alliance have finished with their preparations. All of our war materiel is being shipped to Silithus as we speak. I\'d expect it all to arrive within $2113w days. When all is assembled there, the one who has completed the arduous task of reassembling the Scepter of the Shifting Sands will bang it against the Scarab Gong and open the gates to Ahn\'Qiraj. Then battle shall be joined as has not been seen in ages!$B$BLok\'tar Ogar!','',26124),
(11373,'enUS','$C, the Horde has gathered all that it needs for the Ahn\'Qiraj War! Now we wait for the puny Alliance to catch up. When they do, we\'ll begin transporting everything to Silithus. It should not be long after the buildup there is completed that the war will begin!','',26124),
(11374,'enUS','Of the $1998w copper bars that we\'ll need, we have $2018w. The number for tin bar collections sits at $2005w out of $2006w needed. And, there have been $2008w of $2009w mithril bars smelted for the cause.','',26124),
(11375,'enUS','I just received word on that. We currently have $2021w out of $2020w peacebloom, $2050w of $2051w firebloom, and $2054w out of $2055w purple lotus herbs requested.','',26124),
(11376,'enUS','Give me a moment; there are a lot of numbers to remember here. It looks like we have $2066w of $2067w heavy leather skins collected. As well, we have $2070w out of $2071w thick leather, and $2073w of $2074w rugged leather stockpiled.','',26124),
(11377,'enUS','Bandages? Why, do you intend to survive long enough to need them? Har! Very well, $r, I will tell you. Of the $2080w wool bandaged needed, we have collected $2079w. Also to date, we have taken in $2085w out of $2086w mageweave bandages, and $2089w of $2090w runecloth bandages asked for.','',26124),
(11378,'enUS','Food, now there\'s a subject that I can sink my fangs into! I am told that we have $2095w of $2096w lean wolf steaks, $2102w out of $2103w spotted yellowtail, and $2105w of $2106w baked salmon on ice and stored away.','',26124),
(11379,'enUS','Well met, $c. I hope you are here to inquire on the Ahn\'Qiraj war effort. We are going to need a great deal of assistance.$B$BThe war effort is a united effort between the Alliance and Horde to prepare for the upcoming war against the Silithid and their masters in Ahn\'Qiraj. In the Military Ward of Ironforge, we are collecting all manner of goods to create our war materiel from, and these gathering tasks are what we need your help with.$B$BCan I convince you to speak with our commander about pitching in?','',26124),
(11380,'enUS','','Well met, $c. I hope you are here to inquire on the Ahn\'Qiraj war effort. We are going to need a great deal of assistance.$B$BThe war effort is a united effort between the Alliance and Horde to prepare for the upcoming war against the Silithid and their masters in Ahn\'Qiraj. In the Military Ward of Ironforge, we are collecting all manner of goods to create our war materiel from, and these gathering tasks are what we need your help with.$B$BCan I convince you to speak with our commander about pitching in?',26124),
(11381,'enUS','','Well met, $c. I hope you are here to inquire on the Ahn\'Qiraj war effort. We are going to need a great deal of assistance.$B$BThe war effort is a united effort between the Alliance and Horde to prepare for the upcoming war against the Silithid and their masters in Ahn\'Qiraj. In the Military Ward of Ironforge, we are collecting all manner of goods to create our war materiel from, and these gathering tasks are what we need your help with.$B$BCan I convince you to speak with our commander about pitching in?',26124),
(11382,'enUS','Hail, $c. I trust you are here to inquire on the Ahn\'Qiraj war effort. We are going to need a great deal of assistance.$B$BThe war effort is a united effort between the Horde and Alliance to prepare for the impending war against the Silithid and their masters in Ahn\'Qiraj. In Orgrimmar\'s Valley of Spirits, we are collecting a vast number of goods to create war materiel, and these gathering tasks are what we need your help with.$B$BCan I convince you to speak with our commander about helping out?','',26124),
(11383,'enUS','','Hail, $c. I trust you are here to inquire on the Ahn\'Qiraj war effort. We are going to need a great deal of assistance.$B$BThe war effort is a united effort between the Horde and Alliance to prepare for the impending war against the Silithid and their masters in Ahn\'Qiraj. In Orgrimmar\'s Valley of Spirits, we are collecting a vast number of goods to create war materiel, and these gathering tasks are what we need your help with.$B$BCan I convince you to speak with our commander about helping out?',26124),
(11384,'enUS','','Hail, $c. I trust you are here to inquire on the Ahn\'Qiraj war effort. We are going to need a great deal of assistance.$B$BThe war effort is a united effort between the Horde and Alliance to prepare for the impending war against the Silithid and their masters in Ahn\'Qiraj. In Orgrimmar\'s Valley of Spirits, we are collecting a vast number of goods to create war materiel, and these gathering tasks are what we need your help with.$B$BCan I convince you to speak with our commander about helping out?',26124),
(11385,'enUS','Greetings, $c. I am Leoren, stable master of Cenarion Hold.','',26124),
(11386,'enUS','There is a pile of wrapped gifts here.','',26124),
(11387,'enUS','The tag on this present reads: \"For ages 40 and up.\"','',26124),
(11388,'enUS','Get your present from the pile.','Get your present from the pile.',26124),
(11389,'enUS','Greetings, citizen.','',26124),
(11390,'enUS','The world is indebted to you and your allies, $n.','',26124),
(11391,'enUS','Our freedom would have meant nothing if C\'Thun had survived. You are truly a champion of prophecy.','',26124),
(11392,'enUS','','All will know of what has transpired here in this accursed temple, hero. It will be written about in history books - the tales told as legend from Azeroth to the far reaches of the Nether itself!',26124),
(11393,'enUS','Now that the war is in full swing, we\'ve had no shortage of able-bodied combatants from the Horde and Alliance.$B$BIf only we could keep them off of each other\'s throats...','',26124),
(11394,'enUS','','Wait!  It appears our lookout has spotted something.',26124),
(11395,'enUS','The tag on this present reads: \"For ages 20 and up.\"','',26124),
(11396,'enUS','The tag on this present reads: \"For ages 10 and up.\"','',26124),
(11397,'enUS','Ye\'ll be feasting on me blade this Winter Veil!  Yeargh!','Ye\'ll be feasting on me blade this Winter Veil!  Yeargh!',26124),
(11398,'enUS','No scallywag $c is taking our Winter Veil plunder!  Get \'em!','No scallywag $c is taking our Winter Veil plunder!  Get \'em!\n',26124),
(11399,'enUS','These land lubbers are here for the reindeer!  Give \'em the shank!','These land lubbers are here for the reindeer!  Give \'em the shank!\n',26124),
(11400,'enUS','It\'s a rescue attempt!  Let no one escape!','It\'s a rescue attempt!  Let no one escape!\n',26124),
(11401,'enUS','Let me give you my regards for Greatfather Winter, scum...','Let me give you my regards for Greatfather Winter, scum...\n',26124),
(11402,'enUS','Humbug!  Die!','Humbug!  Die!\n',26124),
(11403,'enUS','It\'s a rescue attempt!  Slay them all!','It\'s a rescue attempt!  Slay them all!\n',26124),
(11404,'enUS','The only thing Metzen is going to be doing this Winter Veil is roasting on a spit!','The only thing Metzen is going to be doing this Winter Veil is roasting on a spit!\n',26124),
(11405,'enUS','','The journal of Jandice Barov is filled with rantings and ravings about the undead. Towards the end of the book is what appears to be a tailoring pattern for the creation of a bag of some sort. Your understanding of tailoring is insufficient to decipher the pattern.',26124),
(11406,'enUS','','The journal of Jandice Barov is filled with rantings and ravings about the undead. Towards the end of the book is what appears to be a tailoring pattern for the creation of a felcloth bag. This bag is used by warlocks to store soul shards. Do you wish to copy the pattern into your own journal?',26124),
(11407,'enUS','<Copy the pattern into my journal.>','<Copy the pattern into my journal.>',26124),
(11408,'enUS','','%s loosens her grasp on the journal she had been clutching.',26124),
(11409,'enUS','%s lets out a battlecry!','',26124),
(11410,'enUS','','The journal of Jandice Barov is filled with rantings and ravings about the undead. Towards the end of the book is what appears to be a tailoring pattern for the creation of a felcloth bag. This bag is used by warlocks to store soul shards. You already know how to create this bag.',26124),
(11411,'enUS','Only those who have proven themselves to not be hostile toward the Timbermaw may pass through the Hold without fear of being attacked.  Have you made an effort to earn our trust, outsider?','',26124),
(11412,'enUS','What do you seek, $c?','',26124),
(11413,'enUS','I\'ll wait.','I\'ll wait.',26124),
(11414,'enUS','New this year: the PX-238 Winter Wondervolt.  Step on up and don\'t be shy!$B$BAnd sign these forms before you try it, we\'re still working a few bugs out of this thing...','',26124),
(11415,'enUS','Greetings, $c - I\'m a Commendation Officer acting on behalf of Darnassus.  It is my duty to assist adventurers who have received Alliance Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Darnassus for your duty and service.\n','Greetings, $c - I\'m a Commendation Officer acting on behalf of Darnassus.  It is my duty to assist adventurers who have received Alliance Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Darnassus for your duty and service.\n\n',26124),
(11416,'enUS','Greetings, $c - I\'m a Commendation Officer acting on behalf of the Gnomeregan Exiles.  It is my duty to assist adventurers who have received Alliance Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from the Gnomeregan Exiles for your duty and service.\n','Greetings, $c - I\'m a Commendation Officer acting on behalf of the Gnomeregan Exiles.  It is my duty to assist adventurers who have received Alliance Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from the Gnomeregan Exiles for your duty and service.\n',26124),
(11417,'enUS','Greetings, $c - I\'m a Commendation Officer acting on behalf of Ironforge.  It is my duty to assist adventurers who have received Alliance Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Ironforge for your duty and service.\n','Greetings, $c - I\'m a Commendation Officer acting on behalf of Ironforge.  It is my duty to assist adventurers who have received Alliance Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Ironforge for your duty and service.',26124),
(11418,'enUS','Greetings, $c - I\'m a Commendation Officer acting on behalf of Stormwind.  It is my duty to assist adventurers who have received Alliance Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Stormwind for your duty and service.\n','Greetings, $c - I\'m a Commendation Officer acting on behalf of Stormwind.  It is my duty to assist adventurers who have received Alliance Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Stormwind for your duty and service.\n\n',26124),
(11419,'enUS','Greetings, $c - I\'m a Commendation Officer acting on behalf of Orgrimmar.  It is my duty to assist adventurers who have received Horde Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Orgrimmar for your duty and service.\n','Greetings, $c - I\'m a Commendation Officer acting on behalf of Orgrimmar.  It is my duty to assist adventurers who have received Horde Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Orgrimmar for your duty and service.\n\n',26124),
(11420,'enUS','Greetings, $c - I\'m a Commendation Officer acting on behalf of the Darkspear tribe.  It is my duty to assist adventurers who have received Horde Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from the Darkspear tribe for your duty and service.\n','Greetings, $c - I\'m a Commendation Officer acting on behalf of the Darkspear tribe.  It is my duty to assist adventurers who have received Horde Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from the Darkspear tribe for your duty and service.\n',26124),
(11421,'enUS','Greetings, $c - I\'m a Commendation Officer acting on behalf of Thunder Bluff.  It is my duty to assist adventurers who have received Horde Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Thunder Bluff for your duty and service.\n','Greetings, $c - I\'m a Commendation Officer acting on behalf of Thunder Bluff.  It is my duty to assist adventurers who have received Horde Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Thunder Bluff for your duty and service.\n\n',26124),
(11422,'enUS','Greetings, $c - I\'m a Commendation Officer acting on behalf of the Undercity.  It is my duty to assist adventurers who have received Horde Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from the Undercity for your duty and service.\n','Greetings, $c - I\'m a Commendation Officer acting on behalf of the Undercity.  It is my duty to assist adventurers who have received Horde Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from the Undercity for your duty and service.\n',26124),
(11423,'enUS','%s lets loose a massive attack.','',26124),
(11424,'enUS','%s hears the call to battle and rises to serve its master.','',26124),
(11425,'enUS','%s casts its massive shadow upon the whole of Silithus.','',26124),
(11426,'enUS','%s breaks free of its cocoon beneath Hive\'Ashi.','',26124),
(11427,'enUS','$n, Champion of the Bronze Dragonflight, has rung the Scarab Gong. The ancient gates of Ahn\'Qiraj open, revealing the horrors of a forgotten war...','$n, Champion of the Bronze Dragonflight, has rung the Scarab Gong. The ancient gates of Ahn\'Qiraj open, revealing the horrors of a forgotten war...',26124),
(11428,'enUS','Slay them all. Leave their husks for the master to consume...','',26124),
(11429,'enUS','Soon you will know the price of your meddling, mortals... The master is nearly whole... And when he rises, your world will cease.','',26124),
(11430,'enUS','Presents for everyone! Father Winter\'s put gifts under the tree for all.','',26124),
(11431,'enUS','Do you think you\'ve won? So easily? The legion has only just begun its march. The armies of C\'Thun will raze this world.','',26124),
(11432,'enUS','Massive Qiraji resonating crystals break through the earthen crust of Kalimdor. Colossal creatures made of obsidian stone breach the freshly broken land.','Massive Qiraji resonating crystals break through the earthen crust of Kalimdor. Colossal creatures made of obsidian stone breach the freshly broken land.',26124),
(11433,'enUS','Breathe your last!','',26124),
(11434,'enUS','Warriors, Captains, continue the fight! ','',26124),
(11435,'enUS','Impudent fool! I will kill you myself!','',26124),
(11436,'enUS','Fandral! Your time has come! Go and hide in the Emerald Dream and pray we never find you!\n','',26124),
(11437,'enUS','Staghelm will whimper and beg for his life, just as his whelp of a son did! One thousand years of injustice will end this day!\n','',26124),
(11438,'enUS','Fear is for the enemy! Fear and death!','',26124),
(11439,'enUS','No longer will we wait behind barred doors and walls of stone! No longer will our vengeance be denied! The dragons themselves will tremble before our wrath!\n','',26124),
(11440,'enUS','The time of our retribution is at hand! Let darkness reign in the hearts of our enemies!','',26124),
(11441,'enUS','%s senses your fear.','',26124),
(11442,'enUS','You will be judged for defiling these sacred grounds!  The laws of the Ancients will not be challenged!  Trespassers will be annihilated!\n','',26124),
(11443,'enUS','I sentence you to death!','',26124),
(11444,'enUS','I serve to the last!','',26124),
(11445,'enUS','Are you so eager to die? I will be happy to accommodate you...','',26124),
(11446,'enUS','Let your death serve as an example!','',26124),
(11447,'enUS','You only delay the inevitable!','',26124),
(11448,'enUS','senses your fear.','',26124),
(11449,'enUS','Sands of the desert, rise and block out the sun!','',26124),
(11450,'enUS','You are terminated.','',26124),
(11451,'enUS','I...have...failed. ','',26124),
(11452,'enUS','My brother, no!','',26124),
(11453,'enUS','You will not escape death!','',26124),
(11454,'enUS','Vek\'lor, I feel your pain!','',26124),
(11455,'enUS','Your fate is sealed!','',26124),
(11456,'enUS','Starting at 6PM, they will show fireworks from the highest bluff!','Starting at 6PM, they will show fireworks from the highest bluff!',26124),
(11457,'enUS','The kegs are filled with strong brew!  Drink, friend, and celebrate!','The kegs are filled with strong brew!  Drink, friend, and celebrate!',26124),
(11458,'enUS','I heard that, after the fireworks show, goblets will be brought to the tables.  Fine toasts we shall raise!','I heard that, after the fireworks show, goblets will be brought to the tables.  Fine toasts we shall raise!',26124),
(11459,'enUS','Hail, $c!  Welcome to the celebration!','Hail, $c!  Welcome to the celebration!',26124),
(11460,'enUS','They\'re going to show fireworks all night long.  From 6PM until dawn, the sky will blaze over Booty Bay!','They\'re going to show fireworks all night long.  From 6PM until dawn, the sky will blaze over Booty Bay!',26124),
(11461,'enUS','Wow!  These kegs are filled with powerful stuff!  They lift me right out of my boots!','Wow!  These kegs are filled with powerful stuff!  They lift me right out of my boots!',26124),
(11462,'enUS','Stick around after the firework show is over.  Find a goblet and raise it to toast your hardy friends!','Stick around after the firework show is over.  Find a goblet and raise it to toast your hardy friends!',26124),
(11463,'enUS','All right!  Party time!','All right!  Party time!',26124),
(11464,'enUS','Times like these get me all sentimental...','Times like these get me all sentimental...',26124),
(11465,'enUS','I sure could use a kiss about now.  Know where I can find one?','I sure could use a kiss about now.  Know where I can find one?',26124),
(11466,'enUS','Hah!  This tauren wants a kiss!','Hah!  This tauren wants a kiss!',26124),
(11467,'enUS','A happy Winter Veil to you, friend!','A happy Winter Veil to you, friend!',26124),
(11468,'enUS','Season\'s greetings, and peace to you!','Season\'s greetings, and peace to you!',26124),
(11469,'enUS','I wish you a happy holiday, friend!','I wish you a happy holiday, friend!',26124),
(11470,'enUS','Ah, mistletoe...','Ah, mistletoe...',26124),
(11471,'enUS','Kneel before me, mortal! Kneel before Zod!','',26124),
(11472,'enUS','Why ... won\'t you ... just dieeeee?','',26124),
(11473,'enUS','%s bristles with energy.','',26124),
(11474,'enUS','%s drains your mana and turns to stone.','',26124),
(11475,'enUS','Burn in hate, $r.','',26124),
(11476,'enUS','%s is weakened!','',26124),
(11477,'enUS','I lied...','',26124),
(11478,'enUS','Come get some!','',26124),
(11479,'enUS','','Mighty fine weather we\'re having here, wouldn\'t you say?',26124),
(11480,'enUS','Oh Umi, please teach me again how to create a Tranquil Yeti. I miss it so.','Oh Umi, please teach me again how to create a Tranquil Yeti. I miss it so.',26124),
(11481,'enUS','','Well, alright then $n. I can tell that you\'ve seen the error of your ways and rejoined the engineering fold.$B$BHave fun with your yeti!!!',26124),
(11482,'enUS','','Why is it that there\'s never a gyrochronatom lying around when you need one?',26124),
(11483,'enUS','','I\'ll get the last laugh... they\'ll see! Oh, hi $c, I didn\'t see you there.',26124),
(11484,'enUS','','Invention, my dear $c, is two percent bottled inspiration, four percent solar exposure, six percent chance of thunderstorms clearing by mid-afternoon, and ninety-three percent Rumplesnicker.$B$BWait, did that add to one hundred? I\'ve got my notes around here somewhere.',26124),
(11485,'enUS','We\'ve gotta find out what the Qiraji are feeding those monsters! Look at the size of \'em!','',26124),
(11486,'enUS','Studying and understanding the Colossus will give us a needed advantage over the Qiraji.','',26124),
(11487,'enUS','','The secrets behind the power of the Colossus could lead to all sorts of innovations in science!',26124),
(11488,'enUS','Where is Elder Graveborn?','Where is Elder Graveborn?',26124),
(11489,'enUS','The inner gates of Ahn\'Qiraj crash open.','The inner gates of Ahn\'Qiraj crash open.',26124),
(11490,'enUS','Elder Graveborn spends time near Brill in Tirisfal Glades.','Elder Graveborn spends time near Brill in Tirisfal Glades.',26124),
(11491,'enUS','Where is Elder Moonstrike?','Where is Elder Moonstrike?',26124),
(11492,'enUS','Elder Moonstrike can be found in the Scholomance in the Western Plaguelands.','Elder Moonstrike can be found in the Scholomance in the Western Plaguelands.',26124),
(11493,'enUS','Where is Elder Darkcore?','Where is Elder Darkcore?',26124),
(11494,'enUS','Elder Darkcore can be found in the Undercity.','Elder Darkcore can be found in the Undercity.',26124),
(11495,'enUS','','',26124),
(11496,'enUS','Show them what you\'re made of!  Attack!','',26124),
(11497,'enUS','Where is Elder Obsidian?','Where is Elder Obsidian?',26124),
(11498,'enUS','Elder Obsidian wanders near the Sepulcher in Silverpine Forest.','Elder Obsidian wanders near the Sepulcher in Silverpine Forest.',26124),
(11499,'enUS','Where is Elder Snowcrown?','Where is Elder Snowcrown?',26124),
(11500,'enUS','Elder Snowcrown can be found in Light\'s Hope Chapel in the Eastern Plaguelands.','Elder Snowcrown can be found in Light\'s Hope Chapel in the Eastern Plaguelands.',26124),
(11501,'enUS','Where is Elder Highpeak?','Where is Elder Highpeak?',26124),
(11502,'enUS','Elder Highpeak watches over the Hinterlands from a hill near its center.','Elder Highpeak watches over the Hinterlands from a hill near its center.',26124),
(11503,'enUS','Where is Elder Windrun?','Where is Elder Windrun?',26124),
(11504,'enUS','Elder Windrun resides in the Crown Guard Tower in the Eastern Plaguelands.','Elder Windrun resides in the Crown Guard Tower in the Eastern Plaguelands.',26124),
(11505,'enUS','Where is Elder Farwhisper?','Where is Elder Farwhisper?',26124),
(11506,'enUS','Elder Farwhisper can be found wandering the streets of Stratholme.','Elder Farwhisper can be found wandering the streets of Stratholme.',26124),
(11507,'enUS','Where is Elder Ironband?','Where is Elder Ironband?',26124),
(11508,'enUS','Elder Ironband lives in Blackchar Cave in Searing Gorge.','Elder Ironband lives in Blackchar Cave in Searing Gorge.',26124),
(11509,'enUS','Where is Elder Goldwell?','Where is Elder Goldwell?',26124),
(11510,'enUS','Elder Goldwell spends his time in the village of Kharanos in Dun Morogh.','Elder Goldwell spends his time in the village of Kharanos in Dun Morogh.',26124),
(11511,'enUS','','Begone foul creatures!  Your kind has no place in this world.',26124),
(11512,'enUS','Where is Elder Bronzebeard?','Where is Elder Bronzebeard?',26124),
(11513,'enUS','Show your courage, men and women of Azeroth!  Drive back the Qiraji invaders!','',26124),
(11514,'enUS','Elder Bronzebeard can be found in the ancestral home of the Bronzebeards, Ironforge.','Elder Bronzebeard can be found in the ancestral home of the Bronzebeards, Ironforge.',26124),
(11515,'enUS','','Show no weakness!  Crush these foul creatures!',26124),
(11516,'enUS','Where is Elder Silvervein?','Where is Elder Silvervein?',26124),
(11517,'enUS','','Elune be with you, $c.',26124),
(11518,'enUS','','The High Priestess could not leave Darnassus. Fandral is in a very foul mood.',26124),
(11519,'enUS','','Tyrande sends her prayers. The Mother Moon blesses us all.',26124),
(11520,'enUS','It is settled. I command the Might of Kalimdor. Be certain that your soldiers understand and accept this as fact. Bloodshed is already plentiful. Let there be none between our factions.','',26124),
(11521,'enUS','Soon, young ones. Soon the armies of the Horde will arrive. We march. March to the cursed gates and crush all in our way. Let them feel the might of Kalimdor!','',26124),
(11522,'enUS','','You have a way with words, Overlord Saurfang. ',26124),
(11523,'enUS','','As to your warning - worry not. Our troops are all aware of the chain of command. We fight united. Let us hope your own troops remember that...',26124),
(11524,'enUS','Elder Silvervein can be found near Thelsamar in Loch Modan.','Elder Silvervein can be found near Thelsamar in Loch Modan.',26124),
(11525,'enUS','%s goes into a frenzy at the sight of his fallen troops.','',26124),
(11526,'enUS','You will pay for that...','',26124),
(11527,'enUS','FOR THE MIGHT OF KALIMDOR!','',26124),
(11528,'enUS','DOOMHAMMER GUIDE MY HAND!','',26124),
(11529,'enUS','I will destroy you...','',26124),
(11530,'enUS','Where is Elder Morndeep?','Where is Elder Morndeep?',26124),
(11531,'enUS','Elder Morndeep spends time at the Ring of Law in Blackrock Depths.','Elder Morndeep spends time at the Ring of Law in Blackrock Depths.',26124),
(11532,'enUS','Where is Elder Stonefort?','Where is Elder Stonefort?',26124),
(11533,'enUS','Elder Stonefort has taken to the dungeons of Blackrock Spire.','Elder Stonefort has taken to the dungeons of Blackrock Spire.',26124),
(11534,'enUS','Where is Elder Rumblerock?','Where is Elder Rumblerock?',26124),
(11535,'enUS','Elder Rumblerock passes the years in a cave atop Dreadmaul Rock in the Burning Steppes.','Elder Rumblerock passes the years in a cave atop Dreadmaul Rock in the Burning Steppes.',26124),
(11536,'enUS','Colossals on the rise! At least 10 units strong! INCOMING FROM THE SOUTH!','Colossals on the rise! At least 10 units strong! INCOMING FROM THE SOUTH!',26124),
(11537,'enUS','Where is Elder Starsong?','Where is Elder Starsong?',26124),
(11538,'enUS','HOLD THE LINE! LET NOTHING THROUGH!','',26124),
(11539,'enUS','Last I knew, Elder Starsong was in the Sunken Temple of the Swamp of Sorrows.','Last I knew, Elder Starsong was in the Sunken Temple of the Swamp of Sorrows.',26124),
(11540,'enUS','FOR KALIMDOR!','',26124),
(11541,'enUS','KNOW NO FEAR, SOLDIERS! WE DIE FOR KALIMDOR TODAY!','',26124),
(11542,'enUS','Where is Elder Stormbrow?','Where is Elder Stormbrow?',26124),
(11543,'enUS','Elder Stormbrow is most likely at the village of Goldshire in Elwynn Forest.','Elder Stormbrow is most likely at the village of Goldshire in Elwynn Forest.',26124),
(11544,'enUS','Where is Elder Winterhoof?','Where is Elder Winterhoof?',26124),
(11545,'enUS','Winterhoof? I hear he\'s living it up in Booty Bay.','Winterhoof? I hear he\'s living it up in Booty Bay.',26124),
(11546,'enUS','Where is Elder Skychaser?','Where is Elder Skychaser?',26124),
(11547,'enUS','Elder Skychaser looks out over Westfall from atop Sentinel Hill.','Elder Skychaser looks out over Westfall from atop Sentinel Hill.',26124),
(11548,'enUS','Where is Elder Dawnstrider?','Where is Elder Dawnstrider?',26124),
(11549,'enUS','Elder Dawnstrider can be found at Flame Crest on the Burning Steppes.','Elder Dawnstrider can be found at Flame Crest on the Burning Steppes.',26124),
(11550,'enUS','Where is Elder Hammershout?','Where is Elder Hammershout?',26124),
(11551,'enUS','Elder Hammershout can be found outside the walls of Stormwind.','Elder Hammershout can be found outside the walls of Stormwind.',26124),
(11552,'enUS','Where is Elder Bellowrage?','Where is Elder Bellowrage?',26124),
(11553,'enUS','Elder Bellowrage watches over the Dark Portal from a ridge in the Blasted Lands.','Elder Bellowrage watches over the Dark Portal from a ridge in the Blasted Lands.',26124),
(11554,'enUS','Where is Elder Bladeswift?','Where is Elder Bladeswift?',26124),
(11555,'enUS','Elder Bladeswift wanders the paths of Darnassus atop Teldrassil.','Elder Bladeswift wanders the paths of Darnassus atop Teldrassil.',26124),
(11556,'enUS','Where is Elder Skygleam?','Where is Elder Skygleam?',26124),
(11557,'enUS','Elder Skygleam can be found near the Ravencrest Monument in Azshara.','Elder Skygleam can be found near the Ravencrest Monument in Azshara.',26124),
(11558,'enUS','Where is Elder Bladeleaf?','Where is Elder Bladeleaf?',26124),
(11559,'enUS','The village of Dolanaar atop Teldrassil is home to Elder Bladeleaf.','The village of Dolanaar atop Teldrassil is home to Elder Bladeleaf.',26124),
(11560,'enUS','My work here is done. I\'ll be sure to let Mar\'alith and the others at Cenarion Hold know that you helped me out a little. Be careful in here, you don\'t have me holdin\' your hand past this point.','',26124),
(11561,'enUS','Where is Elder Starweave?','Where is Elder Starweave?',26124),
(11562,'enUS','Elder Starweave can be found on the beach near Lor\'danel in Darkshore.','Elder Starweave can be found on the beach near Lor\'danel in Darkshore.',26124),
(11563,'enUS','%s\'s eyes glow red for a brief moment.','',26124),
(11564,'enUS','Is that the best you can do?','',26124),
(11565,'enUS','Where is Elder Nightwind?','Where is Elder Nightwind?',26124),
(11566,'enUS','Elder Nightwind passes the days at the shrine in Jaedenar in Felwood.','Elder Nightwind passes the days at the shrine in Jaedenar in Felwood.',26124),
(11567,'enUS','Where is Elder Riversong?','Where is Elder Riversong?',26124),
(11568,'enUS','The village of Astranaar in Ashenvale is Elder Riversong\'s current home.','The village of Astranaar in Ashenvale is Elder Riversong\'s current home.',26124),
(11570,'enUS','Where is Elder Stonespire?','Where is Elder Stonespire?',26124),
(11571,'enUS','Last I knew, Elder Stonespire was at Everlook in Winterspring.','Last I knew, Elder Stonespire was at Everlook in Winterspring.',26124),
(11572,'enUS','Where is Elder Brightspear?','Where is Elder Brightspear?',26124),
(11573,'enUS','Elder Brightspear can be found wandering amongst the ruins of Kel\'Theril in Winterspring.','Elder Brightspear can be found wandering amongst the ruins of Kel\'Theril in Winterspring.',26124),
(11574,'enUS','Where is Elder Bloodhoof?','Where is Elder Bloodhoof?',26124),
(11575,'enUS','Elder Bloodhoof can be found at Bloodhoof Village in Mulgore.','Elder Bloodhoof can be found at Bloodhoof Village in Mulgore.',26124),
(11576,'enUS','Where is Elder Windtotem?','Where is Elder Windtotem?',26124),
(11577,'enUS','Elder Windtotem is keeping company with the goblins of Ratchet on the coast of the Barrens.','Elder Windtotem is keeping company with the goblins of Ratchet on the coast of the Barrens.',26124),
(11578,'enUS','Where is Elder High Mountain?','Where is Elder High Mountain?',26124),
(11579,'enUS','Elder High Mountain is at Vendetta Point in Southern Barrens.','Elder High Mountain is at Vendetta Point in Southern Barrens.',26124),
(11580,'enUS','Where is Elder Moonwarden?','Where is Elder Moonwarden?',26124),
(11581,'enUS','Elder Moonwarden is observing the Crossroads in Northern Barrens.','Elder Moonwarden is observing the Crossroads in Northern Barrens.',26124),
(11582,'enUS','Where is Elder Wheathoof?','Where is Elder Wheathoof?',26124),
(11583,'enUS','Elder Wheathoof is enjoying the vistas above Mulgore at Thunder Bluff.','Elder Wheathoof is enjoying the vistas above Mulgore at Thunder Bluff.',26124),
(11584,'enUS','Where is Elder Darkhorn?','Where is Elder Darkhorn?',26124),
(11585,'enUS','Elder Darkhorn can be found among the red rocks of Orgrimmar.','Elder Darkhorn can be found among the red rocks of Orgrimmar.',26124),
(11586,'enUS','Where is Elder Morningdew?','Where is Elder Morningdew?',26124),
(11587,'enUS','Elder Morningdew has taken to watching the commotion aboard Fizzle & Pozzik\'s Speedbarge in Thousand Needles.','Elder Morningdew has taken to watching the commotion aboard Fizzle & Pozzik\'s Speedbarge in Thousand Needles.',26124),
(11588,'enUS','Where is Elder Runetotem?','Where is Elder Runetotem?',26124),
(11589,'enUS','Last I heard, Elder Runetotem was traveling to Razor Hill in Durotar.','Last I heard, Elder Runetotem was traveling to Razor Hill in Durotar.',26124),
(11590,'enUS','Where is Elder Grimtotem?','Where is Elder Grimtotem?',26124),
(11591,'enUS','You\'ll find Elder Grimtotem at the Lariss Pavilion in Feralas.','You\'ll find Elder Grimtotem at the Lariss Pavilion in Feralas.',26124),
(11592,'enUS','Where is Elder Mistwalker?','Where is Elder Mistwalker?',26124),
(11593,'enUS','Elder Mistwalker enjoys watching the struggles at the Maul in Feralas.','Elder Mistwalker enjoys watching the struggles at the Maul in Feralas.',26124),
(11594,'enUS','Where is Elder Skyseer?','Where is Elder Skyseer?',26124),
(11595,'enUS','Go to the Freewind Post in Thousand Needles and you will find Elder Skyseer.','Go to the Freewind Post in Thousand Needles and you will find Elder Skyseer.',26124),
(11596,'enUS','Where is Elder Splitrock?','Where is Elder Splitrock?',26124),
(11597,'enUS','I think Elder Splitrock has traveled to Maraudon in Desolace.','I think Elder Splitrock has traveled to Maraudon in Desolace.',26124),
(11598,'enUS','Where is Elder Dreamseer?','Where is Elder Dreamseer?',26124),
(11599,'enUS','Elder Dreamseer resides in Gadgetzan in Tanaris Desert.','Elder Dreamseer resides in Gadgetzan in Tanaris Desert.',26124),
(11600,'enUS','Where is Elder Ragetotem?','Where is Elder Ragetotem?',26124),
(11601,'enUS','Elder Ragetotem spends her days at the Valley of the Watchers in Tanaris Desert.','Elder Ragetotem spends her days at the Valley of the Watchers in Tanaris Desert.',26124),
(11602,'enUS','Where is Elder Wildmane?','Where is Elder Wildmane?',26124),
(11603,'enUS','Zul\'Farrak in Tanaris Desert is Elder Wildmane\'s home.','Zul\'Farrak in Tanaris Desert is Elder Wildmane\'s home.',26124),
(11604,'enUS','Where is Elder Thunderhorn?','Where is Elder Thunderhorn?',26124),
(11605,'enUS','For reasons I cannot understand, Elder Thunderhorn has gone to the Slithering Scar in Un\'Goro Crater.','For reasons I cannot understand, Elder Thunderhorn has gone to the Slithering Scar in Un\'Goro Crater.',26124),
(11606,'enUS','Where is Elder Bladesing?','Where is Elder Bladesing?',26124),
(11607,'enUS','If you travel to Cenarion Hold in Silithus, you will find Elder Bladesing.','If you travel to Cenarion Hold in Silithus, you will find Elder Bladesing.',26124),
(11608,'enUS','Where is Elder Primestone?','Where is Elder Primestone?',26124),
(11609,'enUS','Elder Primestone has spent many years in the Crystal Vale in Silithus.','Elder Primestone has spent many years in the Crystal Vale in Silithus.',26124),
(11610,'enUS','To honor your elders is to honor your culture and your people, $c.  For this, the coins of ancestry serve as a tangible means to recognize those who choose to follow a venerable path of respect.$B$BDuring this Lunar Festival, you may have the opportunity to honor many elders.  As you do so, you will acquire the coins of ancestry.  Bring me these coins, and I will reward your diligence with a selection of unique items.','',26124),
(11611,'enUS','Qiraji War Party spotted!','Qiraji War Party spotted!',26124),
(11612,'enUS','Sandstorm coming from the south, take co...That\'s no sandstorm! INCOMING QIRAJI ARMY!','Sandstorm coming from the south, take co...That\'s no sandstorm! INCOMING QIRAJI ARMY!',26124),
(11613,'enUS','Invaders approaching from the south!','Invaders approaching from the south!',26124),
(11614,'enUS','Crush them all!','',26124),
(11615,'enUS','The Might of Kalimdor will halt their advances!','',26124),
(11616,'enUS','Soldiers of Kalimdor, defend the base!','Soldiers of Kalimdor, defend the base!',26124),
(11617,'enUS','I\'d like a new invitation to the Lunar Festival.','I\'d like a new invitation to the Lunar Festival.',26124),
(11618,'enUS','','Greetings, $n.  We\'ve travelled from Moonglade to spread the spirit of the Lunar Festival far and wide.$B$BWon\'t you join us in our celebration?',26124),
(11619,'enUS','The final battle for Kalimdor is upon us. The supreme commander of the Might of Kalimdor orders his troops to march upon Ahn\'Qiraj and destroy all in their path.','The final battle for Kalimdor is upon us. The supreme commander of the Might of Kalimdor orders his troops to march upon Ahn\'Qiraj and destroy all in their path.',26124),
(11620,'enUS','%s stands before the Might of Kalimdor.','',26124),
(11621,'enUS','I am Saurfang. Brother of Broxigar. \n','',26124),
(11622,'enUS','You know me to be the Supreme Commander of the Might of Kalimdor.\n','',26124),
(11623,'enUS','%s pauses and looks across the sea of soldiers that stand nervously before him.','',26124),
(11624,'enUS','An orc - a true orc warrior - wishes for one thing: To die in the glory of battle against a hated enemy.\n','',26124),
(11625,'enUS','Some of you have not fought in battles. Peace has been with us for many years. Many years we sat idle but many years we battled.\n','',26124),
(11626,'enUS','In those years - where strife filled the land as Legion and Scourge sacked our homes, killed our families - these insects dwelled beneath us. Beneath our homes - waiting.\n','',26124),
(11627,'enUS','Waiting to crush the life from our little ones. To slay all in their path. This they do for their god.\n','',26124),
(11628,'enUS','And for our gods?\n','',26124),
(11629,'enUS','We defend. We stand. We show that as one. United. We destroy. Their god will fall.\n','',26124),
(11630,'enUS','To die today, on this field of battle, is to die an orcish death. To die today is to die for our little ones. Our old ones. Our ... loved ones.\n','',26124),
(11631,'enUS','Would any of you deny yourselves such a death? Such an honor?\n','',26124),
(11632,'enUS','FOR KALIMDOR!','FOR KALIMDOR!',26124),
(11633,'enUS','FOR HONOR!\n','FOR HONOR!\n',26124),
(11634,'enUS','FER THE KING!','FER THE KING!',26124),
(11635,'enUS','FER MAGNI!','FER MAGNI!',26124),
(11636,'enUS','FER KHAZ\'MODAN!','FER KHAZ\'MODAN!',26124),
(11637,'enUS','FER IRONFORGE!','FER IRONFORGE!',26124),
(11638,'enUS','I am with you until I gasp my last dying breath.','',26124),
(11639,'enUS','','%s says a prayer.',26124),
(11640,'enUS','','',26124),
(11641,'enUS','For the Warchief!','For the Warchief!',26124),
(11642,'enUS','FOR THE HORDE!','FOR THE HORDE!',26124),
(11643,'enUS','For Broxigar!','For Broxigar!',26124),
(11644,'enUS','For Kalimdor!','For Kalimdor!',26124),
(11645,'enUS','FOR THE HORDE! FOR CAIRNE! FOR THUNDER BLUFF!','FOR THE HORDE! FOR CAIRNE! FOR THUNDER BLUFF!',26124),
(11646,'enUS','ONWARD! TO AHN\'QIRAJ!\n','',26124),
(11647,'enUS','Our fates lie ahead...','',26124),
(11648,'enUS','Face the Might of Kalimdor!','',26124),
(11649,'enUS','The Might of Kalimdor is victorious! The last of the Qiraji forces are defeated, retreating back to the ancient city-fortress of Ahn\'Qiraj. The Qiraji Resonating Crystals littering Kalimdor vanish as quickly as they appeared, leaving behind nothing but sundered earth.','The Might of Kalimdor is victorious! The last of the Qiraji forces are defeated, retreating back to the ancient city-fortress of Ahn\'Qiraj. The Qiraji Resonating Crystals littering Kalimdor vanish as quickly as they appeared, leaving behind nothing but sundered earth.',26124),
(11650,'enUS','We\'re on orders from on high to destroy Rajaxx. Terminate with extreme prejudice if you want to get technical.','',26124),
(11651,'enUS','The battle is won! Watch as they flee to the safety of their precious temple. Soon all will be razed... Their leaders destroyed!','',26124),
(11652,'enUS','We stand together with the Alliance, $r. An evil, so old that the world has forgotten it, seeks to engulf us all; first on Kalimdor and then the rest of Azeroth. It is driven by a hatred of all things born of the great Shapers: The eternal Titans.$B$BWe are all that stand in the way of C\'Thun\'s armies. We will strike first and bring down the forces of Ahn\'Qiraj. Let all of Azeroth quake at the combined might of the Horde and Alliance.$B$BThe war effort needs you!','',26124),
(11653,'enUS','Where is Elder Meadowrun?','Where is Elder Meadowrun?',26124),
(11654,'enUS','I last saw Elder Meadowrun at the Weeping Cave in the Western Plaguelands.','I last saw Elder Meadowrun at the Weeping Cave in the Western Plaguelands.',26124),
(11656,'enUS','Where is Elder Starglade?','Where is Elder Starglade?',26124),
(11657,'enUS','You\'ll find Elder Starglade outside the gates to Zul\'Gurub in Stranglethorn Vale.','You\'ll find Elder Starglade outside the gates to Zul\'Gurub in Stranglethorn Vale.',26124),
(11658,'enUS','\"Great job collecting resources for the war,\" they said, \"Have a promotion,\" they said.  What they really meant is \"You\'re stationed outside a bughive in Silithus with a bunch of sweaty dwarves, Carnes!\"$B$BThanks for the promotion, Captain!','',26124),
(11659,'enUS','','I, like my brother, honor those who honor their ancestors.  It brings me great joy to share my crafting secrets to disciples of the Lunar Festival!',26124),
(11660,'enUS','Run if you want cowards!  It will do you no good!','',26124),
(11661,'enUS','I, like many others, came to aid my fellow druids when the war started.$B$BNow that the Gates of Ahn\'Qiraj are open, I\'ve realized that much work still remains to be done.  I\'ve decided to stay in Silithus and do my best to help the cause, $n.  ','',26124),
(11662,'enUS','As deadly as the silithid seem, they are but tame creatures compared to their Qiraji overlords.','',26124),
(11663,'enUS','This war\'s not over, it\'s only just begun!  We have brave men and women fighting our enemy inside Ahn\'Qiraj day and night, $n.  It won\'t be long before the Qiraji city falls.','',26124),
(11664,'enUS','','Our steady progress in our fight against the Qiraji can be attributed to the diverse help we received from nearly every corner of Kalimdor.$B$BYou need more than just soldiers to fight a war, $n.  Many of the war\'s unsung heroes are the traders and craftsmen that keep our forces supplied with the resources they need.',26124),
(11665,'enUS','They know how to throw a party here in Moonglade.  Who would have thought so?','They know how to throw a party here in Moonglade.  Who would have thought so?',26124),
(11666,'enUS','Try these fireworks launchers.  They\'re a blast!','Try these fireworks launchers.  They\'re a blast!',26124),
(11667,'enUS','This beam of moonlight leads to Stormwind.  Use your invitation when you\'re ready.','This beam of moonlight leads to Stormwind.  Use your invitation when you\'re ready.',26124),
(11668,'enUS','Don\'t try to teleport to one of your enemies\' cities.  It won\'t work - we may all be friendly here, but back home old grudges remain...','Don\'t try to teleport to one of your enemies\' cities.  It won\'t work - we may all be friendly here, but back home old grudges remain...',26124),
(11669,'enUS','The people in Nighthaven sure know how to party!','The people in Nighthaven sure know how to party!',26124),
(11670,'enUS','These fireworks sure make a nice BOOM, don\'t you think?','These fireworks sure make a nice BOOM, don\'t you think?',26124),
(11672,'enUS','This moonlight will send you to Ironforge.  But who\'d want to leave this party?','This moonlight will send you to Ironforge.  But who\'d want to leave this party?',26124),
(11673,'enUS','The lunar celebration this year is quite magnificent!','The lunar celebration this year is quite magnificent!',26124),
(11674,'enUS','They say these fireworks use the power of the moon!','They say these fireworks use the power of the moon!',26124),
(11675,'enUS','This beam of greater moonlight will send you to Darnassus.','This beam of greater moonlight will send you to Darnassus.',26124),
(11676,'enUS','If I didnt know better, I\'d say this party was organized by orcs!','If I didnt know better, I\'d say this party was organized by orcs!',26124),
(11677,'enUS','Did you see?  That last firework almost caught that dwarf\'s shirt on fire!  Hah!','Did you see?  That last firework almost caught that dwarf\'s shirt on fire!  Hah!',26124),
(11678,'enUS','This moon beam will send you to Orgrimmar.  Use your invitation when you want to go.','This moon beam will send you to Orgrimmar.  Use your invitation when you want to go.',26124),
(11679,'enUS','There\'s nothing like a little Lunar celebration to warm your bones!','There\'s nothing like a little Lunar celebration to warm your bones!',26124),
(11680,'enUS','You have to be careful lighting fireworks when you can\'t feel your fingers...','You have to be careful lighting fireworks when you can\'t feel your fingers...',26124),
(11681,'enUS','This beam of moonlight leads to the Undercity.  Retire when ready.','This beam of moonlight leads to the Undercity.  Retire when ready.',26124),
(11682,'enUS','I love the Lunar Festival!  It\'s a great place to let your hooves kick up dust!','I love the Lunar Festival!  It\'s a great place to let your hooves kick up dust!',26124),
(11683,'enUS','I don\'t know how these fireworks work, but they sure are pretty!','I don\'t know how these fireworks work, but they sure are pretty!',26124),
(11684,'enUS','This moonlight will take you to Thunder Bluff.  Use it when you want to leave the festival.','This moonlight will take you to Thunder Bluff.  Use it when you want to leave the festival.',26124),
(11685,'enUS','They\'re going to show fireworks all night long.  From 6PM until dawn, the sky will blaze over Elune\'ara!','They\'re going to show fireworks all night long.  From 6PM until dawn, the sky will blaze over Elune\'ara!',26124),
(11686,'enUS','They put these lanterns out to commemorate the closing of the Lunar Festival.','They put these lanterns out to commemorate the closing of the Lunar Festival.',26124),
(11687,'enUS','It is the last night of the Lunar Festival.  May fortune be with you!','It is the last night of the Lunar Festival.  May fortune be with you!',26124),
(11688,'enUS','May your elders bless you, $n, and bring you luck in the coming year.','May your elders bless you, $n, and bring you luck in the coming year.',26124),
(11689,'enUS','How can I summon Omen?','How can I summon Omen?',26124),
(11690,'enUS','Omen sleeps in the depths of Lake Elune\'ara, but may be summoned at the southeast banks near the Stormrage Barrow Dens.  There, you will find special cluster launchers...$B$BUse your rockets in the launchers and Omen\'s minions will come.  Fire more rockets, nearly three dozen, or fire Elune\'s candles at his minions, and soon he will awaken.','',26124),
(11691,'enUS','I wish to purchase another Elune\'s Candle.','I wish to purchase another Elune\'s Candle.',26124),
(11692,'enUS','%s shares his powers with his brethren.','%s shares his powers with his brethren.',26124),
(11693,'enUS','%s goes into a rage!','%s goes into a rage!',26124),
(11694,'enUS','%s goes into a berserker rage!','',26124),
(11695,'enUS','%s is frozen solid!','',26124),
(11696,'enUS','Long have we toiled to see our land returned to its former glory, $c. Ever shall we remain vigilant against those who have invaded and defiled Quel\'thalas. We will not rest until they are driven from our sight.$B$BLet none exist who stand in the way of the sin\'dorei!','',26124),
(11697,'enUS','','It\'s all a mess, $c, and it\'s all my fault! I was warned to get out of dock while there was still time, but did I listen? No.$B$BWhat am I going to do now? Those sickly blood elves, the Wretched, have made off with my magical goods, and ate them I think. I\'m pretty sure that means they can\'t be retrieved. And the Grimscale murlocs pirated away the rest of my goods in the dead of night! Furthermore, to kick an honest merchant when she\'s down, my crew abandoned ship!$B$BI think I\'m going to cry.',26124),
(11698,'enUS','','Hello, $c. These are troubling times indeed if this is what is to become of our beloved Quel\'Thalas.',26124),
(11700,'enUS','The massive floating eyeball in the center of the chamber turns its gaze upon you. You stand before a god.','',26124),
(11701,'enUS','The Wretched are a constant thorn in my side, $n.  When they\'re not being a danger to themselves by tapping unstable arcane sources to satisfy their cravings, they\'re cooking up half-brained schemes against our respectable society.','',26124),
(11702,'enUS','Only flesh and bone. Mortals are such easy prey...','',26124),
(11703,'enUS','and Bone.','',26124),
(11704,'enUS','Mortals are...','',26124),
(11705,'enUS','such easy pray.','',26124),
(11706,'enUS','Where are your manners, brother. Let us properly welcome our guests.','',26124),
(11707,'enUS','There will be pain...','',26124),
(11708,'enUS','Oh so much pain...','',26124),
(11709,'enUS','Come, little ones.\n','',26124),
(11710,'enUS','The feast of souls begins now...','',26124),
(11711,'enUS','','',26124),
(11713,'enUS','Good riddance... now none shall be able to repeat my mistakes!','',26124),
(11714,'enUS','I hope that Loralthalis is alright, $c. Maybe I should go up to Duskwither Spire myself? Maybe I should have done that in the first place?','',26124),
(11715,'enUS','A man can only live with himself and his shame for so long, $c, before he must take action to undo the mistakes he\'s made.','',26124),
(11716,'enUS','A mess, that\'s what this is!  All of these creatures sprung up out of nowhere, and are running around out of control!  And where\'ve the Magister, and his apprentices, run off to?  Leaving me here all alone without as much as a, \"Hello there Wyllithen, would you like to come with?\"$B$BThe nerve!','',26124),
(11717,'enUS','These arcane sanctums of yours are quite... interesting Mr. Caidanis.  I appreciate the information you have given me today.','',26124),
(11718,'enUS','It\'s been a pleasure, Mr. Anvilward.  I must say your enthusiastic interest in our operations is most... unexpected.','',26124),
(11720,'enUS','The walls have been breached!','',26124),
(11721,'enUS','','Attack!  Don\'t let them reach the gates!',26124),
(11722,'enUS','Generic Text2!','Generic Text2',26124),
(11723,'enUS','Here, I\'d like to give you this token of my love.','Here, I\'d like to give you this token of my love.',26124),
(11724,'enUS','We\'ve been so wrapped up in this war, some of us forgot to make time for love.','We\'ve been so wrapped up in this war, some of us forgot to make time for love.',26124),
(11725,'enUS','What are those crates for?','What are those crates for?',26124),
(11726,'enUS','I ordered a few shipments of new perfumes and colognes from the city. After I get them unpacked, check back and I\'ll have them for sale.','I ordered a few shipments of new perfumes and colognes from the city. After I get them unpacked, check back and I\'ll have them for sale.',26124),
(11727,'enUS','You do not belong here!  Ancients, rise against these intruders!','',26124),
(11728,'enUS','','That was quite a fight.  Let us catch our breath for a bit.',26124),
(11729,'enUS','Hey, $gmister:miss;.  You look like a $C with discerning tastes in wine.  I have a favor to ask, and I think I can make you an offer you can\'t refuse...forget about it!','',26124),
(11730,'enUS','What are you looking at, $glad : lass;?  Never seen a dwarf before, then?$B$BYou\'d best be on yer way if you don\'t want any trouble.','',26124),
(11731,'enUS','I need a moment of your time, sir.','I need a moment of your time, sir.',26124),
(11732,'enUS','Ah, you must be the $glad : lass; assigned to show me around the Eversong Woods.  Took your sweet time getting here, didn\'t you?$B$BVery well, off we go.  Let us not waste one more minute.','',26124),
(11733,'enUS','Why... yes, of course.  I\'ve something to show you right inside this building, Mr. Anvilward.','Why... yes, of course.  I\'ve something to show you right inside this building, Mr. Anvilward.',26124),
(11734,'enUS','Very well.  Let\'s see what you have to show me, $n.','',26124),
(11735,'enUS','What manner of trick is this, $r?  If you seek to ambush me, I warn you I will not go down quietly!  ','',26124),
(11736,'enUS','We\'ve been so wrapped up in this war, some of us forgot to make time for love.','',26124),
(11737,'enUS','','We\'ve been so wrapped up in this war, some of us forgot to make time for love.',26124),
(11738,'enUS','It looks like you\'ve already found love. You can give me a love token, but I\'m not giving you anything nice. I\'m waiting for someone special.','It looks like you\'ve already found love. You can give me a love token, but I\'m not giving you anything nice. I\'m waiting for someone special.',26124),
(11739,'enUS','','It looks like you\'ve already found love. You can give me a love token, but I\'m not giving you anything nice. I\'m waiting for someone special.',26124),
(11740,'enUS','It looks like you\'ve already found love. You can give me a love token, but I\'m not giving you anything nice. I\'m waiting for someone special.','',26124),
(11741,'enUS','Greetings, $c. I trust that you bring me good news concerning the Worldwide Invitational event? If you are, then surely that means you were given a secret code to tell me. In return for your code I will give you a gift of one of the panda cubs that I take care of.$B$BJust whisper it in my ear when you are ready.','Greetings, $c. I trust that you bring me good news concerning the Worldwide Invitational event? If you are, then surely that means you were given a secret code to tell me. In return for your code I will give you a gift of one of the panda cubs that I take care of.$B$BJust whisper it in my ear when you are ready.',26124),
(11742,'enUS','I would like to whisper my secret code to you to receive my Panda Cub pet.','I would like to whisper my secret code to you to receive my Panda Cub pet.',26124),
(11743,'enUS','It looks like you\'ve already found love. You can give me a love token, but I\'m not giving you anything nice. I\'m waiting for someone special.','It looks like you\'ve already found love. You can give me a love token, but I\'m not giving you anything nice. I\'m waiting for someone special.',26124),
(11744,'enUS','It looks like you\'ve already found love. You can give me a love token, but I\'m not giving you anything nice. I\'m waiting for someone special.','',26124),
(11745,'enUS','We\'ve been so wrapped up in this war, some of us forgot to make time for love.','',26124),
(11746,'enUS','','I don\'t know what\'s come over me. My heart feels as hot as new steel.',26124),
(11747,'enUS','I don\'t know what\'s come over me. My heart feels as hot as new steel.','',26124),
(11748,'enUS','','You work with machines for so long, sometimes you forget about real hearts.',26124),
(11749,'enUS','You work with machines for so long, sometimes you forget about real hearts.','You work with machines for so long, sometimes you forget about real hearts.',26124),
(11750,'enUS','You work with machines for so long, sometimes you forget about real hearts.','',26124),
(11751,'enUS','','When you have lived as long as I, it becomes easy to forget about love for years. It is always good to be reminded.',26124),
(11752,'enUS','When you have lived as long as I, it becomes easy to forget about love for years. It is always good to be reminded.','When you have lived as long as I, it becomes easy to forget about love for years. It is always good to be reminded.',26124),
(11753,'enUS','When you have lived as long as I, it becomes easy to forget about love for years. It is always good to be reminded.','',26124),
(11754,'enUS','It seems like love is drifting on the wind. I hope that I won\'t be left out.','',26124),
(11755,'enUS','It seems like love is drifting on the wind. I hope that I won\'t be left out.','It seems like love is drifting on the wind. I hope that I won\'t be left out.',26124),
(11756,'enUS','It has been years since I have thought with my heart, but it\'s all flooding back.','It has been years since I have thought with my heart, but it\'s all flooding back.',26124),
(11757,'enUS','','It has been years since I have thought with my heart, but it\'s all flooding back.',26124),
(11758,'enUS','It has been years since I have thought with my heart, but it\'s all flooding back.','',26124),
(11759,'enUS','We orcs are usually a private people, but lately, no one\'s been hiding their feelings.','We orcs are usually a private people, but lately, no one\'s been hiding their feelings.',26124),
(11760,'enUS','','It seems like love is drifting on the wind. I hope that I won\'t be left out.',26124),
(11761,'enUS','','We orcs are usually a private people, but lately, no one\'s been hiding their feelings.',26124),
(11762,'enUS','We orcs are usually a private people, but lately, no one\'s been hiding their feelings.','',26124),
(11763,'enUS','After all these years of fighting, now everyone\'s falling in love!','',26124),
(11764,'enUS','After all these years of fighting, now everyone\'s falling in love!','After all these years of fighting, now everyone\'s falling in love!',26124),
(11765,'enUS','I would like to enter the secret code to receive my Murloc pet.','I would like to enter the secret code to receive my Murloc pet.',26124),
(11767,'enUS','Hail!  You look familiar... have we met before?$B$BWell if we have met, then... surely you were given a secret code. Tell me your code and I will give you a gift!','Hail, $c. You look familiar... have we met before?$B$BWell if we have met, then... surely you were given a secret code. Tell me your code and I will give you a gift!',26124),
(11768,'enUS','Just because it\'s not my heart doesn\'t mean it can\'t be broken.','Just because it\'s not my heart doesn\'t mean it can\'t be broken.',26124),
(11769,'enUS','I\'ve gone easy on you thus far, but now you bore me. Witness the magnificence of my power, and despair!','',26124),
(11770,'enUS','I will not die again! Not to the likes of you!!','',26124),
(11771,'enUS','Debug message, Thelrin has been summoned.','',26124),
(11772,'enUS','You can see me? Do you know how much I\'m ignored up here just because no one can see me? How refreshing to finally have someone to talk to!$B$BSo, you must have been sent by some living member of my former mercenary company, am I right? Of course I am!$B$BBut enough idle chit-chat, there\'s a great deal of work for you and I if you\'re going to put things right and return Lord Valthalak\'s spirit to him!','',26124),
(11773,'enUS','I lost Lord Valthalak\'s Amulet!','I lost Lord Valthalak\'s Amulet!',26124),
(11774,'enUS','Ah, $n, don\'t cry. Lucky for you, when last you gave me the amulet, I attuned myself to it. I\'ll just summon it back from wherever you dropped it.$B$BTry looking in your bags now.','',26124),
(11775,'enUS','You\'ve convinced me of your intentions, $n, and you have my thanks for being willing to help out the members of my former mercenary company, The Veiled Blade.$B$BNow let\'s see, what\'s next on our list of things to do?','',26124),
(11776,'enUS','I lost a piece of Lord Valthalak\'s Amulet!','I lost a piece of Lord Valthalak\'s Amulet!',26124),
(11777,'enUS','There, there, $n, worry not! Which piece of the amulet have you misplaced?$B$BDid you check all of your bags and the bank?','',26124),
(11778,'enUS','Yes I checked, I\'m missing the top piece!','Yes I checked, I\'m missing the top piece!',26124),
(11779,'enUS','Never fear, Bodley is on the job! Let\'s see here, ah yes... there it is. Let me just summon it... and, presto!$B$BTry not to lose it again, $n.','',26124),
(11780,'enUS','Yes I checked, I\'m missing the left piece!','Yes I checked, I\'m missing the left piece!',26124),
(11781,'enUS','Yes, yes, calm down, $c, there\'s nothing to worry about. As luck would have it, when you first gave the left piece to me, I attuned myself to it, so summoning it back from wherever you \'misplaced\' it is really not a problem.$B$BHere, and this time try to take better care of it.','',26124),
(11784,'enUS','I\'ve misplaced the Brazier of Beckoning!','I\'ve misplaced the Brazier of Beckoning!',26124),
(11785,'enUS','You\'re kidding, right? Ok, ok, don\'t panic. Luckily when I was imbueing it with the component that you retrieved, I attuned myself to it as well. I should be able to locate and summon it from wherever it is that you left it.$B$BAre you sure that you\'ve lost it? You looked in all of your bags and the bank?','',26124),
(11786,'enUS','Yes, please summon it back!','Yes, please summon it back!',26124),
(11787,'enUS','There you go, $n. Good thing my powers of divination and summoning still work in this ghostly state, huh?','',26124),
(11788,'enUS','Greetings and salutations from the manor Ravenholdt, adventurer.','',26124),
(11789,'enUS','Time to learn ya about manners, $g sonny:lass;.','',26124),
(11790,'enUS','','You look like you\'ve had your heart broken. Come back when you\'re not so sad.',26124),
(11791,'enUS','You look like you\'ve had your heart broken. Come back when you\'re not so sad.','You look like you\'ve had your heart broken. Come back when you\'re not so sad.',26124),
(11792,'enUS','You look like you\'ve had your heart broken. Come back when you\'re not so sad.','',26124),
(11793,'enUS','','I\'d talk to you if you smelled better. Cologne would be nice.',26124),
(11794,'enUS','','What, you don\'t have a token to give me? Don\'t you love me?',26124),
(11795,'enUS','I\'d talk to you if you smelled better. Cologne would be nice.','I\'d talk to you if you smelled better. Cologne would be nice.',26124),
(11796,'enUS','What, you don\'t have a token to give me? Don\'t you love me?','What, you don\'t have a token to give me? Don\'t you love me?',26124),
(11797,'enUS','I\'d like you better if you would apply some perfume.','I\'d like you better if you would apply some perfume.',26124),
(11798,'enUS','I\'d like you better if you would apply some perfume.','',26124),
(11799,'enUS','What, you don\'t have a token to give me? Don\'t you love me?','',26124),
(11800,'enUS','What?! How did you sneak past my jail...er, minion out there? Well, I suppose it\'s for the best. Sales have been a little slow lately.$B$BHow may I fulfill your infernal needs, $c?','',26124),
(11801,'enUS','You look like you\'ve had your heart broken. Come back when you\'re not so sad.','You look like you\'ve had your heart broken. Come back when you\'re not so sad.',26124),
(11802,'enUS','I\'d like you better if you would apply some perfume.','I\'d like you better if you would apply some perfume.',26124),
(11803,'enUS','What, you don\'t have a token to give me? Don\'t you love me?','What, you don\'t have a token to give me? Don\'t you love me?',26124),
(11804,'enUS','It looks like you\'ve already found love. You can give me a love token, but I\'m not giving you anything nice. I\'m waiting for someone special.','It looks like you\'ve already found love. You can give me a love token, but I\'m not giving you anything nice. I\'m waiting for someone special.',26124),
(11805,'enUS','You look like you\'ve had your heart broken. Come back when you\'re not so sad.','You look like you\'ve had your heart broken. Come back when you\'re not so sad.',26124),
(11806,'enUS','I\'d like you better if you would apply some perfume.','I\'d like you better if you would apply some perfume.',26124),
(11807,'enUS','What, you don\'t have a token to give me? Don\'t you love me?','What, you don\'t have a token to give me? Don\'t you love me?',26124),
(11808,'enUS','You look like you\'ve had your heart broken. Come back when you\'re not so sad.','',26124),
(11809,'enUS','I\'d like you better if you would apply some perfume.','',26124),
(11810,'enUS','What, you don\'t have a token to give me? Don\'t you love me?','',26124),
(11811,'enUS','I\'d talk to you if you smelled better. How about cologne? Maybe perfume?','I\'d talk to you if you smelled better. How about cologne? Maybe perfume?',26124),
(11812,'enUS','Intruders!  More pawns of the Argent Dawn, no doubt.  I already count one of their number among my prisoners.  Withdraw from my domain before she is executed!','',26124),
(11813,'enUS','You\'re still here?  Your foolishness is amusing!  The Argent Dawn wench needn\'t suffer in vain.  Leave at once and she shall be spared!','',26124),
(11814,'enUS','May this prisoner\'s death serve as a warning.  None shall defy the scourge and live!','',26124),
(11815,'enUS','I shall take great pleasure in taking this poor wretch\'s life!  It\'s not too late, she needn\'t suffer in vain.  Turn back and her death shall be merciful!','',26124),
(11816,'enUS','','Don\'t worry about me!  Slay this dreadful beast and cleanse this world of his foul taint!',26124),
(11817,'enUS','','My death means nothing.... light... will... prevail!',26124),
(11818,'enUS','','I am free! Let\'s work together now to save my brother, Sothos!',26124),
(11819,'enUS','','Thank you for freeing me, my brother, and all of you! We can finally rest in peace now.',26124),
(11820,'enUS','Let\'s see what you have.','Let\'s see what you have.',26124),
(11821,'enUS','My mission is compete. I may have some spare supplies if you need any.','',26124),
(11822,'enUS','No, I\'m not, but lots of others are looking for love.  You should buy my love tokens, put on some cologne or perfume, and then pass them around!','No, I\'m not, but lots of others are looking for love.  You should buy my love tokens, put on some cologne or perfume, and then pass them around!',26124),
(11823,'enUS','Does that heart mean you\'re looking for love?','Does that heart mean you\'re looking for love?',26124),
(11824,'enUS','What are love tokens?','What are love tokens?',26124),
(11825,'enUS','You\'re selling cologne and perfume?','You\'re selling cologne and perfume?',26124),
(11826,'enUS','Love tokens are small messages of affection you can give to amorous town and city folk.  Such people will reward you with a gift of adoration.$B$BOr, if you are already adored by another, then at the least they\'ll give you a gift of friendship.','Love tokens are small messages of affection you can give to amorous town and city folk.  Such people will reward you with a gift of adoration.$B$BOr, if you are already adored by another, then at the least they\'ll give you a gift of friendship.',26124),
(11827,'enUS','If you put on cologne or perfume, then you\'ll see who is amorous.  Those are the ones who accept love tokens... and offer a gift in return.$B$BBut remember: to give someone a love token, you have to smell just right!  Men like the scent of perfume, while women prefer cologne.','If you put on cologne or perfume, then you\'ll see who is amorous.  Those are the ones who accept love tokens... and offer a gift in return.$B$BBut remember: to give someone a love token, you have to smell just right!  Men like the scent of perfume, while women prefer cologne.',26124),
(11828,'enUS','What can I do with these gifts?','What can I do with these gifts?',26124),
(11829,'enUS','When you give love tokens to townsfolk, you\'ll receive different gifts in return.  Some of those you\'ll want to keep and use, but others can be bundled together and given to your favorite hero!  Visit Kwee Q. Peddlefeet to turn them in.$B$BKwee can be found near Bolvar, Magni, or Tyrande.','When you give love tokens to townsfolk, you\'ll receive different gifts in return.  Some of those you\'ll want to keep and use, but others can be bundled together and given to your favorite hero!  Visit Kwee Q. Peddlefeet to turn them in.$B$BKwee can be found near Bolvar, Magni, or Tyrande.',26124),
(11830,'enUS','$n! You\'ve returned just to talk to me? That\'s very thoughtful of you, and you look pretty sweet in that outfit, too!$B$BYou don\'t know how good it makes me feel to see you. It can get pretty lonely up here, what with most of these yahoos not being able to see me, and all. It\'s a great thing that you did for all of us, and I\'ll never forget it!$B$BThanks for dropping in and saying hi, and don\'t be such a stranger.','',26124),
(11831,'enUS','Welcome back, $n. Have I mentioned how good it is to have someone to talk to?$B$BAlright then, let\'s get down to business. What\'s next that we have to do?','',26124),
(11832,'enUS','Hey, $n. Over here, I want to talk to you.','',26124),
(11833,'enUS','Who\'s the most popular hero of the realm, you ask?  Well here are the current standings!$B$BThrall: $2200w$BCairne: $2201w$BSylvanas: $2202w$BTotal Horde: $2207w$B$BVarian: $2203w$BMagni: $2204w$BTyrande: $2205w$BTotal Alliance: $2206w$B$BIf you want to cast your vote, be sure to turn in your gift collections!','Who\'s the most popular hero of the realm, you ask?  Well here are the current standings!$B$BThrall: $2200w$BCairne: $2201w$BSylvanas: $2202w$BTotal Horde: $2207w$B$BVarian: $2203w$BMagni: $2204w$BTyrande: $2205w$BTotal Alliance: $2206w$B$BIf you want to cast your vote, be sure to turn in your gift collections!',26124),
(11834,'enUS','Hi!  I\'m Kwee Q. Peddlefeet!  I\'m here to find out who is the most popular of all the heroes in Azeroth!$B$BIt sure warms my heart to see so many adoring fans greet their leaders, but... do you know what would warm me even more?$B$BA kiss!','',26124),
(11835,'enUS','How are the gift standings?  Who\'s the most popular?','How are the gift standings?  Who\'s the most popular?',26124),
(11836,'enUS','Annalise? Is that you?','',26124),
(11837,'enUS','','My dear Staffron, have you forgotten what it is to love? The love that we once shared?',26124),
(11838,'enUS','','Staffron...',26124),
(11839,'enUS','Have I forgotten? Of course I have... I have forgotten about love, happiness... of life itself.','',26124),
(11840,'enUS','But I do know this - love makes the heart and body weak. It can be exploited. Without your love, I have only my work, Annalise.','',26124),
(11841,'enUS','','But of course I love you, Staffron. And it pains me to see you suffer so.',26124),
(11842,'enUS','','I pledge my love to you forever. Death cannot erase that, even as I am sure that you still remember your love for me.',26124),
(11843,'enUS','','And if you do not, then I am truly lost.',26124),
(11844,'enUS','How could you love me, Annalise? Look at me. I am not the man you once knew.','',26124),
(11845,'enUS','Annalise? Annalise! No, don\'t leave me!','',26124),
(11846,'enUS','Annalise... You\'re right. I-I can\'t do this. I must find another way.','',26124),
(11847,'enUS','You there. You\'re welcome to take the contents of my cauldron. It was to be the second stage of my plan - amorous clothing.','',26124),
(11848,'enUS','You two are surely star-crossed lovers who have found each other. There is much happiness in your future.','',26124),
(11850,'enUS','Yikes! Two fiery personalities. You\'ll have many arguments, but your love will burn just as hot!','',26124),
(11851,'enUS','While you may try to make it work, in the end, you will go your separate ways.','',26124),
(11852,'enUS','You two will have many ups and downs, but if you can hold on, the ride will be worth it.','',26124),
(11853,'enUS','I hear wedding bells in your future.','',26124),
(11854,'enUS','The future is cloudy for you two. If you work at your relationship, I\'m sure you can find some measure of happiness.','',26124),
(11856,'enUS','Here are the final standings!$B$BThrall: $2200w$BCairne: $2201w$BSylvanas: $2202w$BTotal Horde: $2207w$B$BBolvar: $2203w$BMagni: $2204w$BTyrande: $2205w$BTotal Alliance: $2206w$B$BThe Alliance has the most popular hero!','Here are the final standings!$B$BThrall: $2200w$BCairne: $2201w$BSylvanas: $2202w$BTotal Horde: $2207w$B$BBolvar: $2203w$BMagni: $2204w$BTyrande: $2205w$BTotal Alliance: $2206w$B$BThe Alliance has the most popular hero!',26124),
(11857,'enUS','Here are the final standings!$B$BThrall: $2200w$BCairne: $2201w$BSylvanas: $2202w$BTotal Horde: $2207w$B$BBolvar: $2203w$BMagni: $2204w$BTyrande: $2205w$BTotal Alliance: $2206w$B$BThe Horde has the most popular hero!','Here are the final standings!$B$BThrall: $2200w$BCairne: $2201w$BSylvanas: $2202w$BTotal Horde: $2207w$B$BBolvar: $2203w$BMagni: $2204w$BTyrande: $2205w$BTotal Alliance: $2206w$B$BThe Horde has the most popular hero!',26124),
(11858,'enUS','I am free! Let\'s work together now to save my sister, Jarien!','',26124),
(11859,'enUS','Thank you for freeing me, my sister, and all of you! We can finally rest in peace now.','',26124),
(11860,'enUS','','My torture is ended and now I can join the Goddess. Thank you so very much!',26124),
(11861,'enUS','Though I move on in peace, you all have my undying gratitude. Thank you for freeing me from the curse of my folly and greed.','',26124),
(11862,'enUS','Very clever how you got in here like that, $n.$B$BWhat? Surprised that I know your name? I\'m a demon, that\'s what we do. I also know your true name, so you\'d better buy something expensive.','',26124),
(11863,'enUS','Here for the rod? Or, maybe you\'re simply stocking up on runes?$B$BWait a minute! Are you just trying to offload a whole bunch of junk on me?! Curse my never-ending compulsion to buy, buy, buy!','',26124),
(11864,'enUS','What? No, I don\'t do armor repairs. Everlook is about a mile to the north, $g brother : sister;.$B$BNow buy something, or move along before I summon my warlock to deal with you!','',26124),
(11865,'enUS','Can I show you what I have for sale?\n\n','',26124),
(11866,'enUS','If I make a gift collection, what do I do with it?','If I make a gift collection, what do I do with it?',26124),
(11868,'enUS','If it is your desire to visit the rise of the Defiler, you have only to ask. I am able to transport you and your comrades.','',26124),
(11869,'enUS','We wish to face the Defiler.','We wish to face the Defiler.',26124),
(11870,'enUS','When you give love tokens to townsfolk, you\'ll receive different gifts in return.  Some of those you\'ll want to keep and use, but others can be bundled together and given to your favorite hero!  Visit Kwee Q. Peddlefeet to turn them in.$B$BKwee can be found near Cairne, Sylvanas and Thrall.','When you give love tokens to townsfolk, you\'ll receive different gifts in return.  Some of those you\'ll want to keep and use, but others can be bundled together and given to your favorite hero!  Visit Kwee Q. Peddlefeet to turn them in.$B$BKwee can be found near Cairne, Sylvanas and Thrall.',26124),
(11871,'enUS','<PH> Incoming Mages <PH>','',26124),
(11872,'enUS','Here are the final standings!$B$BThrall: $2200w$B$BCairne: $2201w$B$BSylvanas: $2202w$B$BTotal Horde: $2207w$B$B$BBolvar: $2203w$B$BMagni: $2204w$B$BTyrande: $2205w$B$BTotal Alliance: $2206w$B$BThe Horde and the Alliance tied in total votes!','',26124),
(11873,'enUS','We am free! Thank you little, puny ones.','',26124),
(11874,'enUS','The pages of this book have been destroyed.','',26124),
(11875,'enUS','Hundreds of various diagrams and schematics begin to take shape on the pages of the book. You recognize some of the diagrams while others remain foreign but familiar.','',26124),
(11876,'enUS','I am 100% confident that I wish to learn in the ways of goblin engineering.','I am 100% confident that I wish to learn in the ways of goblin engineering.',26124),
(11877,'enUS','','',26124),
(11878,'enUS','I am 100% confident that I wish to learn in the ways of gnomish engineering.','I am 100% confident that I wish to learn in the ways of gnomish engineering.',26124),
(11879,'enUS','Your fate is sealed, Deliana!  You will pay for your trespasses against Lord Valthalak!','Your fate is sealed, Deliana!  You will pay for your trespasses against Lord Valthalak!',26124),
(11880,'enUS','So you\'re looking to relearn what you forgot, eh? Or maybe learn what you were never taught? I know just the thing, $n. Over by Steamwheedle port, to the east, you\'ll find a magical book in Narain\'s hut called \"Soothsaying for Dummies.\" Give it a read.$B$B<Nixx winks.>$B$BYou\'ll find all that you need to know and then some...','',26124),
(11881,'enUS','','You\'re never going to stop coming after me, are you?  Fine, but you won\'t take me down without a fight!',26124),
(11882,'enUS','Teach you the ways of gnomish engineering? Not going to happen! Not this gnome, anyway. You have a stink on you, $n. Maybe this is the pity talking but I will offer some advice.$B$BIn the Tanaris desert you\'ll find a hut that belongs to Narain Soothfancy. In that hut is a magical book that has been known to do wonderous things. Find that book and you may yet learn the gnomish way.','',26124),
(11883,'enUS','','I didn\'t mean to drag you into this, $n.  Ever since we took on a job to steal Lord Valthalak\'s spellbook, everyone involved has wound up dead or missing.',26124),
(11884,'enUS','Teach you gnomish engineering? I don\'t have time for this nonsense. You only get one chance with Oglethorpe and you blew that, didn\'t you?$B$BYou\'ll have to head to Tanaris and find Narain Soothfancy\'s hut. In that hut is a magical book that might be able to jostle whatever is left of your brain and reconnect you with what you\'ve lost.$B$BNow get lost!','',26124),
(11885,'enUS','','Trying to find out more about my predicament has been nearly impossible.  The smuggler that hired us has vanished and Anthion Harmon, our mercenary company\'s leader, is dead.',26124),
(11888,'enUS','','Come to think about it, most everyone involved is dead.  I\'ll understand if you don\'t want to be involved in any of this, $n.',26124),
(11889,'enUS','I am absolutely certain that I want to learn dragonscale leatherworking.','I am absolutely certain that I want to learn dragonscale leatherworking.',26124),
(11890,'enUS','I am absolutely certain that I want to learn elemental leatherworking.','I am absolutely certain that I want to learn elemental leatherworking.',26124),
(11891,'enUS','I am absolutely certain that I want to learn tribal leatherworking.','I am absolutely certain that I want to learn tribal leatherworking.',26124),
(11892,'enUS','The assortment of images, shapes, and markings come together before your eyes. The book seems to know your skill with leatherworking and offers you a choice - but be warned - you may only select one and once you have done so, may not change your mind!:','',26124),
(11893,'enUS','Your fate is sealed, Mokvar!  You will pay for your trespasses against Lord Valthalak!','Your fate is sealed, Mokvar!  You will pay for your trespasses against Lord Valthalak!',26124),
(11894,'enUS','I cannot teach you dragonscale leatherworking, $n. You must go to Tanaris and find the home of Narain Soothfancy. Once there, consult the book \"Soothsaying for Dummies.\"','',26124),
(11895,'enUS','Begone foul creatures!  Go back to the void your master shaped you from!','',26124),
(11896,'enUS','It was not my intention to get you involved in this, $n.  I\'ve spent every waking hour looking over my shoulder ever since I helped an old friend in a daring raid on Blackrock Spire.','',26124),
(11897,'enUS','Trying to find out more about these creatures hasn\'t been easy.  My friend and the person who hired his mercenaries to steal Lord Valthalak\'s spellbook have both been feared dead for a while.','',26124),
(11898,'enUS','One by one, nearly everyone involved in this matter has fallen prey to these spectres.  I\'ll understand if you decide to walk away from this, $n.','',26124),
(11899,'enUS','','I cannot teach you elemental leatherworking, $n. You must go to Tanaris and find the home of Narain Soothfancy. Once there, consult the book \"Soothsaying for Dummies.\"',26124),
(11900,'enUS','I cannot teach you elemental leatherworking, $n. You must go to Tanaris and find the home of Narain Soothfancy. Once there, consult the book \"Soothsaying for Dummies.\"','',26124),
(11901,'enUS','','I cannot teach you tribal leatherworking, $n. You must go to Tanaris and find the home of Narain Soothfancy. Once there, consult the book \"Soothsaying for Dummies.\"',26124),
(11902,'enUS','I cannot teach you tribal leatherworking, $n. You must go to Tanaris and find the home of Narain Soothfancy. Once there, consult the book \"Soothsaying for Dummies.\"','',26124),
(11903,'enUS','It is good that I have been allowed to continue my pursuits here.  I do not wish to overstay my welcome, at any rate.  It would be a great dishonor if I brought any trouble to our capital.','',26124),
(11904,'enUS','','Try not to draw too much attention, I\'m waiting for the Council to grant me audience.  Not that I mind waiting, I feel pretty safe around all these burly guards.',26124),
(11905,'enUS','Losing my life was a danger I had come to terms with.  Losing Ysida is something I cannot endure, even after my own death.','',26124),
(11906,'enUS','Greetings, friend!  Can I interest you in some ectoplasmic capacitors?  Or perhaps a nice omni-directional spectral assimilator? ','',26124),
(11907,'enUS','What now?  Can\'t you see I\'m rather busy?','',26124),
(11908,'enUS','I seem to have misplaced the distiller, Mux.  Did I happen to leave it here?','I seem to have misplaced the distiller, Mux.  Did I happen to leave it here?',26124),
(11909,'enUS','About that ghost revealer.  Did I happen to leave it here?  I seem to be missing it.','About that ghost revealer.  Did I happen to leave it here?  I seem to be missing it.',26124),
(11910,'enUS','I believe I misplaced that banner you enchanted for me, Falrin.','I believe I misplaced that banner you enchanted for me, Falrin.',26124),
(11911,'enUS','Anthion, I seem  to have misplaced the banner you created for me. ','Anthion, I seem to have misplaced the banner you created for me. ',26124),
(11912,'enUS','I guess it\'s all just about over, right $n? I\'m going to miss you... it\'ll be pretty lonely up here without someone to talk to.$B$BBut that doesn\'t mean that you can\'t come back to see me in the future!','',26124),
(11913,'enUS','Hey Vi\'el, show me your wares!','Hey Vi\'el, show me your wares!',26124),
(11914,'enUS','Return the amulet! Return to me what was stolen!!','',26124),
(11915,'enUS','Bodley, tell me what\'s going on.','Bodley, tell me what\'s going on.',26124),
(11916,'enUS','It\'s quite simple, really, $n. My old merc company, The Veiled Blade, took the wrong mission at the wrong time.$B$BWe were hired by a goblin smuggler out of Booty Bay, one Gremnik Rizzlesprang, who was covetous of Lord Valthalak\'s spellbook. Or, maybe there was some old rivalry there? I suppose we\'ll never know now, because Gremnik was killed not too long ago by a group of Valthalak\'s spectral assassins. They really can be very deadly when a large number of them gather.$B$BWhere was I?','',26124),
(11917,'enUS','You were telling me about The Veiled Blade and how you took the wrong mission.','You were telling me about The Veiled Blade and how you took the wrong mission.',26124),
(11918,'enUS','Oh yes, that\'s right.$B$BSo, here we are invading deep into the upper reaches of Blackrock Spire, against their lord and leader; this was before Drakkisath. Not too smart if you ask me, but our leader, Anthion Harmon, you met him, was always one who loved a challenge.$B$BSurprisingly, everything went according to plan, right up to the point where we were prying Valthalak\'s spellbook out of his stiff fingers. That\'s when it all went south.$B$BShould I continue? You look like your eyes are glazing over.','',26124),
(11919,'enUS','No, no, please continue... it\'s just that the air up here is so, um, smoky.','No, no, please continue... it\'s just that the air up here is so, um, smoky.',26124),
(11920,'enUS','<Bodley looks at you dubiously, but continues...>$B$BThere we are, spellbook in hand, and Kormok, our two-headed ogre necromancer, gets this strange look in all four of his eyes. It was really creepy, because that second set of eyes always kind of looked dead, like a cow\'s eyes, you know? So, all of a sudden he just reaches out and rips this amulet off that Valthalak was wearing.$B$BThe rest of the company went crazy; some of us telling them to leave it alone, and others who wanted it for themselves.','',26124),
(11921,'enUS','Please continue, Bodley.','Please continue, Bodley.',26124),
(11922,'enUS','Sheesh, you don\'t have to beg! Anyways, I\'m almost done with the story.$B$BSo, the whole company is in the middle of that massive chamber fighting over this amulet, and you know how it echoes in there! In the end it was broken into three pieces, and we rolled the dice, with it going to various people or groups.$B$BThe rest is a bit of a blur, though, because it was at about that time that old Valthalak\'s spirit decided to make an entrance and start summoning forth all of these spectral assassins.','',26124),
(11923,'enUS','I thought you were almost done?','I thought you were almost done?',26124),
(11924,'enUS','Cool your heels!$B$B<Bodley grumbles something under his breath about the impatience of the living>$B$BAs I was saying, Lord Valthalak\'s spirit and spectral assassins, summoned forth through his necromantic dabbling, started to assail us. Let me tell you, at that point we weren\'t in any condition to fight back, so we ran. I can still remember Mor Grayhoof, one of our druids, slip and fall at one point into the lower reaches of the spire.$B$BThe rest as they say, is history.','',26124),
(11925,'enUS','What happened to your mercenary company, The Veiled Blade?','What happened to your mercenary company, The Veiled Blade?',26124),
(11926,'enUS','We broke up afterward, that\'s what happened. Too much bad blood, I guess...it had been building for a while. And the thing with the amulet was the straw that broke the kodo\'s back.$B$BEver since then Valthalak\'s servants have been picking us off one by one. Most of the amulet piece holders are dead, their souls corrupted by the portion of Valthalak\'s spirit contained within it.$B$BThat\'s why I\'m glad that you\'re here, $n. With your help we\'ll be able to recombine the amulet and return it to Lord Valthalak!','',26124),
(11927,'enUS','Your meddling ends here, $n!  Lord Valthalak shall have his revenge!','Your meddling ends here, $n!  Lord Valthalak shall have his revenge!',26124),
(11928,'enUS','Friends of yours?','',26124),
(11929,'enUS','Use your tonk action bar above your standard action bar to attack other tonks.','',26124),
(11930,'enUS','','I\'ll be fine for now, don\'t worry about me.  I\'ll find a way out of here once I\'ve performed some cleansing rituals in this room.  Foul magic taints this place, $n.',26124),
(11931,'enUS','','You did it... you\'ve slain Baron Rivendare!  The Argent Dawn shall hear of your valiant deeds!',26124),
(11932,'enUS','Talk about making the wrong investment!$B$BLord Valthalak\'s dark book of spells fetched a pretty penny in the black market.  It\'s too bad he didn\'t take too kindly to getting his possessions stolen.  That stinker got us even after he\'d been dead for months!','',26124),
(11933,'enUS','Ysida lives thanks to your courage, $n.  I am deeply in your debt and shall assist you as much as it is in my power.','',26124),
(11934,'enUS','Tonks?','Tonks?',26124),
(11935,'enUS','','Our newest attraction, and at no cost to you I might add, these miniature tanks, or Tonks as we\'ve cleverly named them, can be controlled from any of the Tonk Control Consoles spread throughout the faire.$B$BAll that you have to do is activate an available control console. Each tonk will come equipped with a stock set of devices, and a random special power to unleash upon your enemy!$B$BHold epic battles with your friends, cruise around, or just cause wild mayhem... the choice is yours!',26124),
(11936,'enUS','Cannon?','Cannon?',26124),
(11937,'enUS','','The Blastenheimer 5000 Ultra Cannon is a state-of-the-art single person projectile device. Delivering its payload at near the speed of a dragon, the cannon is the pride and joy of the Blastenheimer family, world renown for their aeronautical and combustible feats!$B$BIf you\'d like to be launched through the skies to fly free as a bird, seek out Maxima Blastenheimer on the east end of the faire. I hear that she\'s placed a target ring way over on Crystal Lake for you to aim for as you sail through the air!',26124),
(11938,'enUS','','The Blastenheimer 5000 Ultra Cannon is a state-of-the-art single person projectile device. Delivering its payload at near the speed of a dragon, the cannon is the pride and joy of the Blastenheimer family, world renown for their aeronautical and combustible feats!$B$BIf you\'d like to be launched through the skies to fly free as a bird, seek out Maxima Blastenheimer on the south edge of Thunder Bluff\'s central rise. She\'ll aim you at the target far to south on Stonebull Lake!',26124),
(11939,'enUS','%s goes into a rage after seeing $n fall in battle!','%s goes into a rage after seeing $n fall in battle!',26124),
(11940,'enUS','','It is said that Kel\'Thuzad seeks the legendary Atiesh, greatstaff of the Guardian.$B$BYes, the very staff once held by Medivh.',26124),
(11941,'enUS','We of the Brotherhood of the Light are not as lenient as our brethren when it comes to meting justice to those that would do this world wrong.','',26124),
(11942,'enUS','The Lich King is attempting to make his presence known in our world. This must not be allowed to occur.\n','',26124),
(11943,'enUS','What is the Brotherhood of the Light?  Well... We are all members of the Argent Crusade at the core - members of the Argent Crusade that aren\'t held in check by morals, guilt and useless human emotion.','',26124),
(11944,'enUS','','The Argent Dawn might be impotent idealists but their delusional leader knows that they are outmatched. I have been sent here as an emissary of the Scarlet Crusade. An ambassador, if you will... It is doubtful that we could even dent the armies of Kel\'Thuzad - united or not - but we might be able to contain them long enough for some sort of miracle to happen.$B$BAs for me? I\'ll die in battle...$B$B<Marjhan shrugs.>\n',26124),
(11945,'enUS','','That is wonderous, Rimblat! Even this foul, sundered earth is not beyond healing.',26124),
(11946,'enUS','Watch, druid. The earth still breathes. It yearns to be cleansed.','',26124),
(11947,'enUS','The title is misleading. I\'m really a very nice person once you get to know me.','',26124),
(11948,'enUS','They almost sent my brother, Loksey, to this gathering. He cannot even take care of his hounds, let alone represent the Scarlet Crusade in a competent manner.','',26124),
(11949,'enUS','I\'ve been expec...$B$B<Rimblat coughs.>$B$BExcuse me, old habit. I am Rimblat of the Earthen Ring. ','',26124),
(11950,'enUS','','Hello, $c. Please try not to draw too much attention.',26124),
(11951,'enUS','What is it that you want, lemming? Get out of my sight before you find out why I am known as the Wrathcaster.','',26124),
(11952,'enUS','You want a fight?  A fight you\'ll get!','',26124),
(11953,'enUS','I\'m going to kick yer ugly head in!','',26124),
(11954,'enUS','I crush weaklings like you every day!  Bring it on!','',26124),
(11955,'enUS','Your insolence is appalling, fool!  I shall feast on your soul!','',26124),
(11956,'enUS','Who dares to disturb my eternal rest?  Your deaths will be slow and painful!','',26124),
(11957,'enUS','You\'re but worms beneath my feet.  You dare challenge me?','',26124),
(11958,'enUS','First Kormok crush your bones!  Then Kormok burn your soul!','',26124),
(11959,'enUS','You so little and puny... you no make good servants for Kormok!','',26124),
(11960,'enUS','What is Dreadnaught armor?','What is Dreadnaught armor?',26124),
(11961,'enUS','The first suit of Dreadnaught armor was made exclusively for the Scarlet Highlord Mograine.  Whilst donning the full suit, the Highlord looked himself to be a demon from the depths of the Nether.$B$BAye, \'twas quite a sight to behold as Mograine would wade into a hundred Scourge, Ashbringer held high, and come out on the other side in a cloud of dust and flames - enemies left in ashes beneath his feet.','',26124),
(11962,'enUS','Continue please.','Continue please.',26124),
(11963,'enUS','It was not until after his controversial death that the knights and warriors of Lordaeron would wear similarly fashioned suits in honor of their fallen hero. While the death of Mograine was a great victory for Kel\'Thuzad, the resulting martyrdom would be felt until the end of the war.$B$BWhere one did fall, many would rise...','',26124),
(11964,'enUS','Anything else?','Anything else?',26124),
(11965,'enUS','During your battles with the Scourge in Naxxramas, should you come across desecrated battlements and wartorn plate scraps, return them to me and I shall craft for you a piece of this armor worn by heroes.','',26124),
(11966,'enUS','All of Nature\'s might is at my disposal, puny mortals. Let us see which of my many forms it will be that ends your suffering!','',26124),
(11967,'enUS','Muahahahaha! What is this pathetic spectacle I see before me? Well, what are you waiting for? I hunger, and you look as if you may make for a passable appetizer!','',26124),
(11968,'enUS','You think you can summon us? We are the ones that summon, not you! We bash you good for this and suck the marrow from your bones!','',26124),
(11969,'enUS','I\'m what you call a capitalist, $r.','',26124),
(11970,'enUS','','In life, I focused my energies on healing others. Let us see in death how much pain I can cause!',26124),
(11971,'enUS','','Hello, brother.',26124),
(11972,'enUS','Hello, sister. What have we here?','',26124),
(11973,'enUS','','Would-be interlopers, I\'m afraid.',26124),
(11974,'enUS','Shall we slay them for the impertinence of disturbing our sleep?','',26124),
(11975,'enUS','','Yes, we shall!',26124),
(11976,'enUS','What is Redemption armor?','What is Redemption armor?',26124),
(11977,'enUS','The armor of Redemption was worn by our most pious knights - armor worthy of the Lightbringer himself!$B$BThousands fell in the last war; their vestments stripped from their corpses and taken to the dread citadel of Naxxramas.$B$BIt is said that the death knights of Naxxramas corrupt the Redemption plate mail for their own use.$B$BSuch tragedy... ','',26124),
(11978,'enUS','What is Cryptstalker armor?','What is Cryptstalker armor?',26124),
(11979,'enUS','The preternatural ability of the crypt fiend to hunt and kill its foe is one studied and vaunted by men in my profession. I, myself, have slain thousands of the beasts in my crusade to rid this world of Scourge.$B$BWhile I loathe the crypt fiend for its merciless nature, its abilities must be admired. It has a job and it does it - very well.','',26124),
(11980,'enUS','Continue please.','Continue please.',26124),
(11981,'enUS','I have discovered a use for the carapace of the crypt fiend and its various body parts. I am able to fashion an extremely light and very deadly set of armor by combining the fragments with some of the desecrated magical armors lost in Naxxramas.','',26124),
(11982,'enUS','I am unable to teach a Tauren to ride a Skeletal Mount.  I am sorry but there is nothing I can do for you.','I am unable to teach a Tauren to ride a Skeletal Mount.  I am sorry but there is nothing I can do for you.',26124),
(11983,'enUS','What brings a tauren to the Plaguelands?','What brings a tauren to the Plaguelands?',26124),
(11984,'enUS','In the last war, tauren fought. Shaman were sent in defense of this world against the Scourge invasion. Most lost their lives. Many were otherwise ripped asunder, their body parts used for foul experiments in that cursed citadel. I mourn their passing but my heart swells with pride at their courage.','',26124),
(11985,'enUS','Continue please.','Continue please.',26124),
(11986,'enUS','I was a young tauren, barely having reached adolescence at the time, but I knew that those that would brave the battles for our freedom were well protected in my namesake\'s vestments.','',26124),
(11987,'enUS','The name of Earthshatter has been one held by my family for hundreds of years. And like my father and his father before him, I too have inherited the right to create the vestments of my namesake. ','',26124),
(11988,'enUS','Oh, hello there.. um, what\'s your name?$B$BNo matter, what brings you to my home-away-from-home here out in the beautiful countryside?','',26124),
(11989,'enUS','Hello, $c. I trust that you are enjoying youself? What do you think of the party? I do so hope that we aren\'t running out of anything. Nothing kills a fete faster than running out of drinks and hors d\'oeuvres, wouldn\'t you say?$B$BYes, well, I must be about attending to my other guests. Do enjoy your stay.','',26124),
(11990,'enUS','Ah, excellent! Let the festivities begin. Let us retire to the terrace. Now, where did I put my drink?','',26124),
(11991,'enUS','<Yawn> Is it dawn already? Ah well, all good things... as they say. I don\'t know about the rest of you, but I\'m going inside.','',26124),
(11992,'enUS','','Milord, do you think that we can join the party soon? I\'m so bored in here.',26124),
(11993,'enUS','','Oh, my lordship, I do so hope that you\'ve arranged for more of that excellent wine from Silvermoon City. I dare say drinking it makes me feel almost as forward as a common woman!',26124),
(11994,'enUS','','I\'m so tired. We really shouldn\'t have stayed up so late last night,,, well this morning. But it was fun! You do throw the best soirees milord.',26124),
(11995,'enUS','','Lord Saltheril, my dear, did you notice that supplies for the party are a little low? We really should send for one of those couriers from Fairbreeze Village to deliver more of whatever is needed. I especially like those little hors d\'oeuvres wrapped in the smoked bacon. What are those called?',26124),
(11996,'enUS','As you say, my dear, as you say.','',26124),
(11997,'enUS','Hmm, what was that? I\'m sorry my dear, I must have been daydreaming.','',26124),
(11998,'enUS','Oh, most definitely, Elisara. But please, can you show the least bit of patience?','',26124),
(11999,'enUS','Is that so? How very interesting. My dear, why don\'t you run along and powder your nose? I have much to think about.','',26124),
(12000,'enUS','','Oh goody! The party\'s about to start!',26124),
(12001,'enUS','','Greetings, my $g lord : lady;. I trust that you are having a pleasant time?',26124),
(12002,'enUS','','Isn\'t this just so much fun? I\'m so glad that Lord Saltheril throws these parties every night, especially with all of that nastiness occurring to the south. Kind of just makes all of that go away, don\'t you think?',26124),
(12003,'enUS','What is it that you do exactly, Rohan?','What is it that you do exactly, Rohan?',26124),
(12004,'enUS','Ah, as the title states I am an assassin for the Scarlet Crusade. I spend my days exterminating high priority targets and nights at the Gadgetzan discotheque. Dancing is my true calling. Assassination just pays the bills.','',26124),
(12005,'enUS','So what brings you to Light\'s Hope?','So what brings you to Light\'s Hope?',26124),
(12006,'enUS','Good question, $r. In my younger days I was footloose and fancy free without a care in the world. In those days I would sing in a barber shop quartet out of Stormwind known as the Four Dons. That\'s where I learned how to craft the Bonescythe digs.','',26124),
(12007,'enUS','What? Bonescythe?','What? Bonescythe?',26124),
(12008,'enUS','Yes, Bonescythe. You see, it was our tenor, an ornery fellow known as Don Julio, who got me started on the whole thing. In his travels throughout Lordaeron, Don Julio picked up many interesting skills, one of them being the ability to take the bones of fallen Scourge and fashion them into a lethal set of leather armor - perfectly suited for an assassin.','',26124),
(12009,'enUS','Wow, you\'re insane, aren\'t you?','Wow, you\'re insane, aren\'t you?',26124),
(12010,'enUS','I\'m as sane as the next guy, $g fella:lady;. Believe what you will, but I AM capable of fashioning this armor. If you\'re interested, maybe we can make a deal. The sooner I can get out of the assassination business, the better.','',26124),
(12011,'enUS','Hey wait, Gadgetzan has a disco?','Hey wait, Gadgetzan has a disco?',26124),
(12012,'enUS','Members only, scrub!\n','',26124),
(12013,'enUS','What?  Oh, not this again!','',26124),
(12014,'enUS','You can\'t do this to me!  We had a deal!','',26124),
(12015,'enUS','Hello, Rayne. What brings the Cenarion Circle to the Plaguelands?','Hello, Rayne. What brings the Cenarion Circle to the Plaguelands?',26124),
(12016,'enUS','','We are all drawn here for different reasons, $c.$B$B<Rayne smiles.>$B$BI am here to meet with Rimblat of the Earthen Ring. He has some interesting theories on cleansing these lands.',26124),
(12017,'enUS','Are these lands not beyond healing? They look pretty beat up.','Are these lands not beyond healing? They look pretty beat up.',26124),
(12018,'enUS','','I think not. Rimblat has already proven that new life can grow from the sundered earth. Now we must find a way to reproduce and, more importantly, sustain the growth.$B$BWhile I am here, I am also offering my services to adventurers entering Naxxramas.',26124),
(12019,'enUS','What kind of services?','What kind of services?',26124),
(12020,'enUS','','I am a crafter of some renown, $c. With the proper materials, I am able to craft an armor known as Dreamwalker. Druids - and even some shaman - are drawn to this armor due to its magical properties. Are you interested?',26124),
(12021,'enUS','What is Atiesh?\n','What is Atiesh?\n',26124),
(12022,'enUS','','Like Kel\'Thuzad, I too was once a mage of the Kirin Tor. And like Kel\'Thuzad, I seek the legendary Atiesh, greatstaff of the Guardian. Our fates are intertwined as such, $c.',26124),
(12023,'enUS','What Guardian? I don\'t understand any of this.','What Guardian? I don\'t understand any of this.',26124),
(12024,'enUS','','Progeny of Aegwynn, he that would be the last Guardian of Tirisfal... Medivh.',26124),
(12025,'enUS','Please continue.','Please continue.',26124),
(12026,'enUS','','It is a story of legend and one that I do not have the time nor the inclination to retell. Just know that Medivh was the last of the Guardians. The greatstaff of Atiesh was a focal point of his power and a focal point of corruption.',26124),
(12027,'enUS','What corruption?','What corruption?',26124),
(12028,'enUS','','The corruption of a fallen titan. The corruption of the Destroyer. After all, the staff was forged from the seed of hate. That is, of course, what has brought me here...',26124),
(12029,'enUS','Please continue.','Please continue.',26124),
(12030,'enUS','','After the fall of Karazhan, the Kirin Tor dispatched an assembly of mages to search the tower and seize all items of import... for the purposes of \"research.\" It was then that the fabled staff was discovered and brought back to Dalaran.',26124),
(12031,'enUS','Please continue.','Please continue.',26124),
(12032,'enUS','','What followed were a series of tragic events, leading to the death of every Kirin Tor mage that came into contact with Atiesh.$B$BYou see, it was an artifact with sentience. A sentience granted to it by Sargeras...',26124),
(12033,'enUS','What?','What?',26124),
(12034,'enUS','','<Angela nods.>$B$BAfter the deaths, the Six decided that the best course of action was to seal the staff behind impenetrable barriers of magic and appoint a watcher: A guardian of the staff... I would be that watcher.',26124),
(12035,'enUS','This is disturbing. Please continue.','This is disturbing. Please continue.',26124),
(12036,'enUS','','There is not much more to tell. Dalaran was nearly wholly destroyed by Archimonde, the staff lost, presumably shattered by the barrier\'s fail-safe mechanisms.$B$BThere are those that believe the staff to be the cause of Archimonde\'s reprisal.',26124),
(12037,'enUS','Please, tell me more.','Please, tell me more.',26124),
(12038,'enUS','','After the fall of Dalaran, I took my leave from the Kirin Tor. I spent years watching over Atiesh, only to have my purpose amongst the Kirin Tor taken from me in one fell swoop. I would find the staff, though it might take a lifetime. That is how I came to join the Argent Dawn and why I am here now.',26124),
(12039,'enUS','Is there anything else?','Is there anything else?',26124),
(12040,'enUS','','I have tracked the various fragments of the staff across this world and in doing so, discovered Kel\'Thuzad\'s plans to reform the staff. He has already collected several of the staff\'s fragments - which are being held by his most trusted lieutenants.$B$BI cannot emphasize enough the importance of keeping the greatstaff of the Guardian out of Kel\'Thuzad\'s grasp. Frankly, I do not know what the result would be, other than a catastrophe of epic proportion.',26124),
(12041,'enUS','What is Plagueheart armor?','What is Plagueheart armor?',26124),
(12042,'enUS','It is power, imbecile.$B$B<Mataus\'s eyes darken.>$B$BThese fools send idiots like you into Naxxramas to retrieve desecrated armor so that they may purify it and restore the pieces to their former glory.$B$B<Mataus spits.>$B$BJust the thought of such utter stupidity brings the bile up to my throat.$B$BI too seek that armor, but in its most foul and desecrated form.','',26124),
(12043,'enUS','I also seek such power.','I also seek such power.',26124),
(12044,'enUS','I make no pretenses, maggot. The darkness such items hold could very well destroy the both of us. That is why the price is so high. If I\'m going to die, it\'s going to be as a rich man.$B$BAnd I don\'t give an ounce of gnoll spit how you die, only that you do as I ask. Bring me what I require and we will both benefit - or die, but I\'ve already explained this...','',26124),
(12045,'enUS','Tell me about faith, Father.','Tell me about faith, Father.',26124),
(12046,'enUS','Faith... Some have lost it, others have found it. It cannot be destroyed and it cannot be created.$B$BOr perhaps you speak of the vestments of Faith? Armor worn by our priests and most devout warriors into battle against the Scourge during the last war.$B$BAye, much of it is lost... Stolen by the fiends of Naxxramas.','',26124),
(12047,'enUS','','Your message did reach us, Commander, but by no means is our involvement here sanctioned by the Grand Crusader.',26124),
(12048,'enUS','Your leader takes residence at the doorstep to Naxxramas. Do you think he does not feel the pressure?\n','',26124),
(12049,'enUS','%s lowers the sound of his voice to a whisper.','',26124),
(12050,'enUS','Even demons are capable of fear...','',26124),
(12051,'enUS','Scourge activity in the Plaguelands has increased ten-fold. We are receiving reports of Scourge attacks from as far away as Kalimdor! Now how do you suppose this has happened? How have the wretched undead done that which was previously thought impossible? Is nowhere safe?','',26124),
(12052,'enUS','','The heathens will be forced to react. Orcs, bull-men...',26124),
(12053,'enUS','Tauren.','',26124),
(12054,'enUS','','Whatever. The revolting, unkempt Horde filth...',26124),
(12055,'enUS','You lack tact, Commander. This is not surprising. However, you are right in that the Horde will be forced to act. But not just the Horde. They already come - heroes from across the world.','',26124),
(12056,'enUS','','Too little, too late. The dam has broken. We are a bump in the road at best.',26124),
(12057,'enUS','So why are you here? What are we to do if there is no hope?','',26124),
(12058,'enUS','There is always... Ashbringer.','There is always... Ashbringer.',26124),
(12059,'enUS','Greetings, travelers. I have been instructed to treat any bearer of a key to Karazhan as an honored guest of the Master. Feel free to ask any questions you wish of me. How may I assist you?','',26124),
(12060,'enUS','We\'re too merciful with the Wretched.  We ought to drive a sword through each of them.$B$BTheir boldness in Sunsail Anchorage is unpardonable.','',26124),
(12061,'enUS','','It\'s been a long day of cutting down the mindless Scourge that endlessly parade down the Dead Scar.  I hope you\'re here to lend a hand and not to waste my time with idle chatter.',26124),
(12062,'enUS','So this is what you have come for? To try and claim that which is the reason for the Dawn\'s existence and the Crusade\'s downfall? You open old wounds with your words, Commander!','',26124),
(12063,'enUS','The Ashbringer is dead and there will never be another like him. The lesser Mograine is a far cry from the man his father was. You know this, Commander! It was, after all, your own leadership that was responsible for the death of the Scarlet Highlord Mograine. ','',26124),
(12064,'enUS','Ah, guests of the Master. I hope you\'ve been watching your step in here.','',26124),
(12065,'enUS','It was your leadership that manipulated a grieving child to try and recover the sword. A child that has grown into a man with nothing but vengeance and hatred in his heart! And for what? You are no closer to the sword now than you were five years ago.\n','',26124),
(12066,'enUS','Yet you think that recovering Ashbringer will somehow turn the tide of battle? Let me let you in on a little secret, Commander: The power of the Ashbringer came from the man who would wield it... I was there, Commander. I watched him burn legions of undead in righteous fire before he would even unsheathe the blade. Alas, your grasp on history is ... lacking.','',26124),
(12067,'enUS','Now be silent and note where you are, lest I inform Lord Fordring and his knights that you are no longer here on amicable terms. I am certain he would take great pleasure in seeing to your \'atonement.\'','',26124),
(12070,'enUS','','I was just thinking... we really ought to take a trip south one of these nights, maybe have an evening picnic overlooking the fighting at the border? What do you think, milord? Wouldn\'t that just be so exciting?',26124),
(12071,'enUS','','Milord, with much of the sin\'dorei nobility regrettably crushed, does that mean that you are likely to receive an elevation soon?  I\'m so excited for you!',26124),
(12072,'enUS','','How wonderful. Time for the party to start.',26124),
(12073,'enUS','Damn all these vermin! I don\'t suppose you could help me with this situation?','',26124),
(12074,'enUS','I cannot be teachin\' a Tauren to ride a Raptor.','I cannot be teachin\' a Tauren to ride a Raptor.',26124),
(12075,'enUS','Where can I find crypt fiend parts, Leopold?','Where can I find crypt fiend parts, Leopold?',26124),
(12076,'enUS','Those filthy beasts are all over the place.$B$BIf you prefer hunting outdoors, you\'ll find most of them around Plaguewood and Terrordale, with a good concentration of them in the Terrorweb tunnel. They are also likely to appear at almost any Scourge encampment in the Eastern Plaguelands.$B$BIf you\'re a hearty dungeon crawler, you\'ll find a good lot of them in Stratholme and a few of the necrofiend variety in Scholomance.','',26124),
(12077,'enUS','Where can I find bone fragments?','Where can I find bone fragments?',26124),
(12078,'enUS','Are you daft? Did you miss the BONY SKELETAL CREATURES littering the landscape on your way over here?$B$B<Rohan sighs.>$B$BIf you\'re the outdoor type, you\'ll find skeletal creatures all over both the Western and Eastern Plaguelands. Trust me, you can\'t miss \'em - they certainly won\'t miss you if they get the chance.$B$BIf you\'re a dungeon type, Stratholme and Scholomance are definitely the place to be for bone fragments.','',26124),
(12079,'enUS','','Another lovely, gloomy day here in Tranquillien, wouldn\'t you say, $c?$B$BWhat can I do for you?',26124),
(12081,'enUS','No greater freedom than to soar through the skies, $c. What can I do for you today?','',26124),
(12082,'enUS','I\'d like to fly back to Silvermoon City.','I\'d like to fly back to Silvermoon City.',26124),
(12083,'enUS','Hello, friend. How may I be of service to you today?','',26124),
(12084,'enUS','','Heading down to Tranquillien today, $c, or is there something else that I can do for you?',26124),
(12085,'enUS','Yes, I\'d like to purchase a ride down to the Ghostlands.','Yes, I\'d like to purchase a ride down to the Ghostlands.',26124),
(12086,'enUS','Where can I find core of elements?','Where can I find core of elements?',26124),
(12087,'enUS','','Ah, a good question.$B$BIf you prefer hunting in the great outdoors, there are elementals here in the Plaguelands, Azshara, Burning Steppes, Felwood, Silithus, Winterspring, and even Un\'Goro Crater.$B$BIf you are the type that laughs in the face of danger, then perhaps you should visit Dire Maul. I have heard that a great many elemental abberations exist within its walls. You would also do well in seeking out the elementals employed by the Dark Iron dwarves of Blackrock Depths.',26124),
(12088,'enUS','Korfax, where can I find Dark Iron scraps?','Korfax, where can I find Dark Iron scraps?',26124),
(12089,'enUS','Is this a serious question? You really don\'t know?$B$BIf you are the cowardly sort, afraid to get their hands too dirty, you will find Dark Iron scraps on the creatures in the Burning Steppes and Searing Gorge.$B$BIf you\'re the bloodthirsty adventuring type, the dungeons of Blackrock Spire and Blackrock Depths hold quite a large supply of the scraps.','',26124),
(12090,'enUS','Rayne, where should I look for savage fronds?','Rayne, where should I look for savage fronds?',26124),
(12091,'enUS','','If you are one that prefers to hunt in the outdoor world, both Felwood\'s treants and Un\'Goro\'s lashers are an excellent source of fronds.$B$BIf you are more of a risk-taker, the eastern and western wings of Dire Maul will provide you with a nearly limitless supply of savage fronds.',26124),
(12092,'enUS','$C, look what they\'ve done to our beloved land. The Scourge must be destroyed!','',26124),
(12093,'enUS','','It\'s going to take a bit of work, but I think we can save this blood elf\'s life.',26124),
(12094,'enUS','Who are you?  I feel... so... cold.','',26124),
(12095,'enUS','','It is shameful that we sin\'dorei have lost so much of what we used to call home.  It shall not be long before we regain our strength and retake our southern lands back from the Scourge!',26124),
(12096,'enUS','I\'m far too busy to be playing \'guess the smell\' with you, $r. State your business or get out of my sight!','',26124),
(12097,'enUS','The high executor and Dame Auriferous are making me wait, but I don\'t have time for this! My friends are out there dying, $c!','',26124),
(12098,'enUS','','I sent Ranger Salissa south to the enclave and Ranger Lethvalin west to Tranquillien more than a day ago! Have you seen either of them? Are you the aid that\'s been sent back?',26124),
(12099,'enUS','Sometimes it feels like I\'ll never go back to being a simple functionary in service to Dame Auriferous. I\'m not cut out for war.$B$BThankfully there are those like you who burn to see Quel\'Thalas restored to its former beauty. Crush the Scourge, $c! Crush them wherever you can!','',26124),
(12100,'enUS','Ah, here\'s the $g hero : heroine; of the hour now! Good to see you again, $n! I trust that you\'re still destroying the Scourge wherever you find them?','',26124),
(12101,'enUS','','I\'m sure that help from Farstrider Enclave will be here soon to help me and this useless lieutenant get to safety. You might not want to stick around; I\'ve heard all sorts of strange sounds coming from the lake and that village over yonder.',26124),
(12102,'enUS','I received word that you were able to help Ranger Valanna and the lieutenant at Zeb\'Sora.$B$BThank you, $c. I suppose I should make my way back to Farstrider Enclave now.','',26124),
(12103,'enUS','What business brings you here, $c?','',26124),
(12104,'enUS','What can I help you find?','What can I help you find?',26124),
(12105,'enUS','Alright, everything looks in order. Let\'s get this show on the road.','',26124),
(12106,'enUS','Ah, hello there, $r. As you can see, I\'m not open for business quite yet. Now, if you\'ll excuse me, I\'m very busy.','',26124),
(12107,'enUS','Such a delight to see you again, $c. No, really. You\'re the reason that I\'m making money here, hand over fist.$B$BNow, what can I sell to you today?','',26124),
(12108,'enUS','','Welcome to Tranquillien, $c. I apologize for the state that you find it in. As you can see, we\'ve been having some trouble, but the Forsaken, and their Lady Sylvanas Windrunner, have been gracious enough to lend us a great deal of assistance in our time of need.$B$BIf you can lend a hand please do not hesitate to do so. We can use all of the help that we can get in our struggle against the myriad forces arrayed against us.',26124),
(12109,'enUS','The time has come for Horde and Alliance to look towards Northrend and the invasion of the Lich King. In recent days, territories across Kalimdor and the Eastern Kingdoms have come under attack. Will you take up arms to save your land from destruction at their hands?','',26124),
(12110,'enUS','Don\'t be afraid of the sword, nubling. It\'s the mutton that gets ya!','',26124),
(12111,'enUS','This cultist is in a deep trance...','',26124),
(12112,'enUS','Use 8 necrotic runes and disrupt his ritual.','Use 8 necrotic runes and disrupt his ritual.',26124),
(12113,'enUS','Onward! The front lines await!','',26124),
(12114,'enUS','Whew! That was some hard work, $r. I haven\'t seen the Scourge this aggressive since...$B$B<Guard Didier swallows hard.>$B$BSince the last war...','',26124),
(12115,'enUS','Look out... the night elves are back!','',26124),
(12116,'enUS','Terrible thing, what happened to them mules... Metz is gonna have my hide for this failure.','',26124),
(12117,'enUS','','You won\'t get away this time!',26124),
(12118,'enUS','Poor little donkey. It was only a wee lad.','',26124),
(12119,'enUS','','It is very important that we find out what the the night elves are up to, $c! Please concentrate all of your efforts toward that end.',26124),
(12120,'enUS','','We are most pleased with your actions against the night elves. When you uncovered their plot to use the ley-line nexi and their so-called moon crystals to spy upon us, you strengthened our position here by an order of magnitude.$B$BYou have our gratitude, $n.',26124),
(12121,'enUS','Are you the reinforcements? The night elves have been routed!','',26124),
(12122,'enUS','Good thing that you deactivated the moon crystal at An\'owyn when you did, $c! Come around any time you feel like pitching in with my research here.','',26124),
(12123,'enUS','Name, rank and serial number, soldier.\n','',26124),
(12124,'enUS','Yes, sir! Thank you, sir!','Yes, sir! Thank you, sir!',26124),
(12125,'enUS','<Field Marshal Chambers growls.>$B$BSo you\'re the riff-raff that assisted Didier in getting the supplies here in one piece? Where are the rest of you? I know there\'s gotta be more. Chickens like you generally roam in huge packs.$B$BBah, just give me the damned writ so I can sign off on it.\n','',26124),
(12126,'enUS','Job well done, soldier. Dismissed!','',26124),
(12127,'enUS','Alright, I\'ll sign writs now. Bring \'em to the front, maggots.','',26124),
(12128,'enUS','I think I hear something! Chambers must be coming. Make way! Make way!','',26124),
(12129,'enUS','How can I work under these conditions?! And all of these disgusting Forsaken around here! I weep for Tranquillien and Quel\'Thalas!','',26124),
(12130,'enUS','Yes... what do you want, $r? Can\'t you see I am busy here?','',26124),
(12131,'enUS','$R, report! What news of significance do you bring? Be quick about your business... Dame Auriferous and I are in the middle of a strategic discussion.','',26124),
(12132,'enUS','','Ok, you had the fish platter, Commander. Enjoy!',26124),
(12133,'enUS','','Father, you had the bowl of fruit? Right?',26124),
(12134,'enUS','','And for the ladies, roast baby boar. Enjoy!',26124),
(12135,'enUS','','Please let me know if you need anything else!',26124),
(12136,'enUS','','Welcome to Light\'s Hope Chapel, stranger.',26124),
(12137,'enUS','My compliments to the chef!','',26124),
(12138,'enUS','The fish is exquisite, Jessica.','',26124),
(12139,'enUS','Delicious!','',26124),
(12140,'enUS','Thank you, Mrs. Chambers.','',26124),
(12141,'enUS','Is this a mango? Stupendous!','',26124),
(12142,'enUS','You\'ve really outdone yourself this time, Mrs. Chambers. Not a spot of mold to be found!','',26124),
(12143,'enUS','','Thank you, Jessica.',26124),
(12144,'enUS','','And might I add, that dress is lovely! You must tell me where you got it from.',26124),
(12145,'enUS','','Indeed... lovely dress, Jessica.',26124),
(12146,'enUS','','The boar is superb!',26124),
(12147,'enUS','','Oh, quite succulent. Many thanks, Mrs. Chambers.',26124),
(12148,'enUS','Our caravans go out \'bout twice a day, but I\'ll be damned if the Scourge haven\'t gone out of their way to stop Didier and his mules from getting shipments to the front lines. Craziest thing I\'ve ever seen. If only we had the heroic adventurin\' types to help protect the shipments...','',26124),
(12149,'enUS','The pain...the need...I hunger for more...','The pain...the need...I hunger for more...',26124),
(12150,'enUS','More, more, more!  I must feed soon.','More, more, more!  I must feed soon.',26124),
(12151,'enUS','I cannot stand the pain.  I must find a new source.','I cannot stand the pain.  I must find a new source.',26124),
(12152,'enUS','I\'ve got too much to do and not enough time to do it in, $r! Please, get out of my way.','I\'ve got too much to do and not enough time to do it in, $r! Please, get out of my way.',26124),
(12153,'enUS','I\'ve got too much to do and not enough time to do it in, $r! Please, get out of my way.$B$BIf you\'re infected with the maggot slime or ghoul rot, I might be able to help you.','I\'ve got too much to do and not enough time to do it in, $r! Please, get out of my way.$B$BIf you\'re infected with the maggot slime or ghoul rot, I might be able to help you.',26124),
(12154,'enUS','I am diseased. Please cure me, medic.','I am diseased. Please cure me, medic.',26124),
(12155,'enUS','%s is jolted back to life!','',26124),
(12156,'enUS','%s loses its link!','',26124),
(12157,'enUS','That could have gone better. $n, come here, please. I have something I need you to take care of for me.','',26124),
(12158,'enUS','<The blood elf quickly regains consciousness as you pour the draught into his mouth.>$B$BI owe you my life, $c.  Without your help I would\'ve succumbed to the Scourge\'s painful torture.','',26124),
(12159,'enUS','<Administer the restorative draught.>','<Administer the restorative draught.>',26124),
(12160,'enUS','<The blood elf lies on the floor in some manner of induced torpor.>','',26124),
(12161,'enUS','Greetings, $r.  I am Ambassador Sunsorrow of the sin\'dorei, or blood elves as we are commonly known.  I have high hopes that this new bond between us and the Horde will be mutually beneficial.','',26124),
(12162,'enUS','You\'re free to go now.  The way out is safe.','You\'re free to go now.  The way out is safe.',26124),
(12163,'enUS','','<The Forsaken female is curled up on the floor, her face in a grimace.  She does not appear capable of getting up on her own at the moment.>',26124),
(12164,'enUS','','Ahhhhggg... this pain in my head is killing me.$B$BThey must\'ve sent you to rescue me.  Took them long enough!  Do you have any idea of the things they do to prisoners here?',26124),
(12165,'enUS','A bit ungrateful, aren\'t we?  The way out is clear, flee quickly!','A bit ungrateful, aren\'t we?  The way out is clear, flee quickly!',26124),
(12166,'enUS','<The blood elf lies limp on the table.  While he\'s still breathing, he appears to have been the victim of potent sedative toxins.>','',26124),
(12167,'enUS','Well met, $r. I am here as a resource of advice for the High Executor to make use of as he will. I am confident that together we can forge the Horde into something that is even stronger than before and turn back the Scourge menace once and for all!','',26124),
(12168,'enUS','<Varnis coughs violently as the restorative draught takes effect.>$B$BThank you for rescuing me.  I must go back to Tranquillien at once!','',26124),
(12169,'enUS','The drafts of fresh air that blow from Eversong from time to time really upset my stomach, if you know what I mean.','',26124),
(12170,'enUS','I seek a sample of your restorative draught, apothecary.','I seek a sample of your restorative draught, apothecary.',26124),
(12171,'enUS','','If it is a matter of import that you wish to speak on, $c, it may be more appropriate to seek an audience with Dame Auriferous. I warn you though, she is very busy and you may be in for quite a wait.',26124),
(12172,'enUS','','Normally it would not be my place to speak with you directly; rather, you would seek an audience with milady. However, I did give you a task directly, so what is it that we need to discuss?',26124),
(12173,'enUS','','$C, Dame Auriferous has conveyed to me her great pleasure in the service that you have done us in the past. She wishes to extend to you her hope that you will continue to be a champion of sin\'dorei interests here in the Ghostlands.',26124),
(12174,'enUS','%s rushes to the aid of Feugen!','',26124),
(12176,'enUS','What\'s happening?','What\'s happening?',26124),
(12177,'enUS','This sign contains various announcements and notices of rewards.','',26124),
(12178,'enUS','%s overloads!','',26124),
(12179,'enUS','','We\'ve important work to do, $n.  Let us attack our enemies while their guard is down.  Let us show them that sin\'dorei vengeance never forgets nor forgives.',26124),
(12180,'enUS','The tides of war have come again. From the cold north, the Lich King\'s necropolises have laid siege to our lands.  He sends flying necropolises to invade across the world.','',26124),
(12181,'enUS','','Well this is troublesome! How am I supposed to collect the ore samples for the magisters if the mines have been overrun with gnoll vermin?',26124),
(12182,'enUS','','Thanks for getting that ore and taking it to Magister Quallestis, $c. I suppose that I should head back, but I\'m afraid of the punishment I\'m going to receive because I couldn\'t get the ore myself.$B$BDon\'t tell the magister, ok?',26124),
(12183,'enUS','Where could she possibly be? I sent my apprentice, Shatharia, to the Underlight Mines to the west quite some time ago. We need those ore samples back, and fast or our experiment is going to fail!','',26124),
(12184,'enUS','Without delivery of the Underlight ore in such a timely fashion, our research would have failed.$B$BJust wait until Shatharia shows her head here again. I\'ve got some interesting tasks for her, you can be sure of it!','',26124),
(12185,'enUS','','Sin\'dorei have lost far too much in the past years.  Our land, our homes, even our identities...$B$BIt\'s about time we started taking it all back.',26124),
(12186,'enUS','Before we can overcome external obstacles like the Scourge and the Amani trolls, we must overcome obstacles from within.  The Wretched have been a nuisance for long enough; it is time we vanquished them.','',26124),
(12187,'enUS','','$n, let\'s use the antechamber to the right.',26124),
(12188,'enUS','','I can see the light at the end of the tunnel!',26124),
(12189,'enUS','','There\'s Farstrider Enclave now, $c. Not far to go... look out!  Troll ambush!!',26124),
(12190,'enUS','','Captain Helios, I\'ve been rescued from the Amani Catacombs. Reporting for duty, sir!',26124),
(12191,'enUS','','Thank you for saving my life and bringing me back to safety, $n!',26124),
(12192,'enUS','%s nods in relief to Ranger Lilatha and her escort.','',26124),
(12193,'enUS','Lilatha, get someone to look at those injuries. Thank you for bringing her back safely.','',26124),
(12194,'enUS','','Think you could help me to get out of here?',26124),
(12195,'enUS','%s dies.','',26124),
(12196,'enUS','Amongst the various pieces of parchment containing checklists and other information from the Farstriders, one stands out. It is a drawing of a hideous troll, perhaps the most fearsome creature that you have ever seen!','',26124),
(12197,'enUS','OH NO YOU DIDN\'! ITS ON NOW! <PH>','',26124),
(12198,'enUS','Is Winterspring currently under attack?','Is Winterspring currently under attack?',26124),
(12199,'enUS','Indeed, the hills of Winterspring are currently attempting to withstand a renewed Scourge assault. Your assistance would help them greatly.$B$BNumber of Necropolises remaining: $2284W','',26124),
(12200,'enUS','For the time being, that area is free of Scourge influence. I fear it will only be a matter of time before they return.','',26124),
(12201,'enUS','Is Tanaris currently under attack?','Is Tanaris currently under attack?',26124),
(12202,'enUS','It seems the army of the Scourge has come to Tanaris. A significant number of their necropolises and other forces have been dispatched there.$B$BNumber of Necropolises remaining: $2283W','',26124),
(12203,'enUS','Are the Blasted Lands currently under attack?','Are the Blasted Lands currently under attack?',26124),
(12204,'enUS','The Scourge infestation grows in the Blasted Lands. Every able bodied warrior is needed to stem the tide of their invasion.$B$BNumber of Necropolises remaining: $2280W','',26124),
(12205,'enUS','Are the Burning Steppes currently under attack?','Are the Burning Steppes currently under attack?',26124),
(12206,'enUS','If additional support is not soon sent to the Burning Steppes, I fear the Scourge will establish a base of operations there. If you can, you should go there to aid the defenders.$B$BNumber of Necropolises remaining: $2281W','',26124),
(12207,'enUS','What can I do?','What can I do?',26124),
(12208,'enUS','','Many an advantage can be gained from getting to know your enemy.  Take that lesson to heart, $n.$B$BThe more we learn about the Scourge the better prepared we are to defeat them.',26124),
(12209,'enUS','The Scourge are establishing small staging points in the places under attack, receiving communications and other assistance from the necropolises that fly overhead. From what we can tell, the only way to root them out is by killing the ground forces that surround the points.','',26124),
(12210,'enUS','','You\'re welcome to stay at the Farstrider Enclave for as long as you\'d like, $c.  We welcome any who would aid us in our endeavors in the Ghostlands.',26124),
(12211,'enUS','Stray arcane forces can do strange things to the land, the elements and even the spirits of the dead.','',26124),
(12212,'enUS','The High Executor is a very busy man, $c.  Maybe I can help you with whatever you need?','',26124),
(12213,'enUS','You\'ve done us exemplary service, $n. Between dealing with the gnolls at the Underlight Mines, and the mummified trolls in the Amani Catacombs, you\'ve dealt a mighty blow to our enemies!$B$B$G Good job! : We should get together for drinks sometime, what do you say?;','',26124),
(12214,'enUS','Good to see you again, $g man! : gorgeous!; I think we would work well together; $g see you around. : I hope we get to do so.;','',26124),
(12215,'enUS','Word got back to me through channels concerning Lady Sylvanas\'s reaction to you and the recovery of her necklace. I still think you did the right thing; don\'t worry too much about how the lady reacted.$B$BNow, state your business.','',26124),
(12216,'enUS','What can I say, $c? You\'re a true $g hero : heroine;! Not only have you personally saved many of my rangers, but you\'ve dealt a decisive blow against the Shadowpine trolls. Are you sure that you don\'t want to stay here and be one of my Farstriders?$B$BFare well, $n.','',26124),
(12217,'enUS','You\'re a one-$g man : woman; rescue machine. That\'s three of my Farstriders that you\'ve saved now!','',26124),
(12218,'enUS','Your help with the Shadowpine trolls is proving invaluable, $c. Keep this up and maybe we\'ll be able to turn our attention back to dealing with the Scourge.','',26124),
(12219,'enUS','You\'ve dealt the decisive blow against the Shadowpine trolls, $n. I only hope that we can muster our forces quickly enough to finish them off before they receive reinforcements from Zul\'Aman.$B$BIt would be nice if Tranquillien were to reinforce us.','',26124),
(12220,'enUS','','Thanks, I should\'ve never left Silverpine Forest.',26124),
(12221,'enUS','You have my thanks!','',26124),
(12222,'enUS','Th... thank you.  I thought I was going to die.','',26124),
(12223,'enUS','Death is the price you shall pay for this insolence!','',26124),
(12224,'enUS','Mortal fools!  The ghouls of Deatholme will feast on your remains!','',26124),
(12225,'enUS','Your deaths shall be slow and painful!','',26124),
(12226,'enUS','Miranda, could you please tell me the insignia cost of items that you are offering for adventurers with other reputations?','Miranda, could you please tell me the insignia cost of items that you are offering for adventurers with other reputations?',26124),
(12227,'enUS','','Certainly, $n. You only need to tell me what reputation you would like to know about.\n',26124),
(12228,'enUS','Miranda, could you please tell me the insignia cost of items that you are offering for adventurers of honored reputation?','Miranda, could you please tell me the insignia cost of items that you are offering for adventurers of honored reputation?',26124),
(12229,'enUS','','Certainly, $n.$B$BAdventurers that the Dawn views as honored must submit a combined total of 40 insignias to access superior items. To access items of even greater power, they would be required to submit a total of 150 insignias.$B$BI must admit, the price is high even for those honored amongst the Dawn.\n',26124),
(12230,'enUS','Arcanist Vandril, what are the Forsaken doing here?','Arcanist Vandril, what are the Forsaken doing here?',26124),
(12231,'enUS','Miranda, could you please tell me the insignia cost of items that you are offering for adventurers of revered reputation?','Miranda, could you please tell me the insignia cost of items that you are offering for adventurers of revered reputation?',26124),
(12232,'enUS','','Certainly, $n.$B$BAdventurers that the Dawn views as revered must submit a combined total of 14 insignias to access superior items. To access items of even greater power, they would be required to submit a total of 90 insignias.$B$BThose that are revered by the Dawn will find the cost of superior items quite reasonable! The cost for the more powerful items is still high.\n',26124),
(12233,'enUS','The situation is more grim than many have been led to believe. The Forsaken are here as allies in the fight against our common enemy, the Scourge.$B$BTrust me when I say this, without them the Ghostlands would be lost and the Scourge would already have overrun all of Eversong Woods!$B$BBut more than anything else, we need your help in reclaiming our once proud lands!','',26124),
(12234,'enUS','Miranda, could you please tell me the insignia cost of items that you are offering for adventurers of exalted reputation?','Miranda, could you please tell me the insignia cost of items that you are offering for adventurers of exalted reputation?',26124),
(12235,'enUS','','Certainly, $n.$B$BAdventurers that the Dawn views as exalted must submit a combined total of 12 insignias to access superior items. To access items of even greater power, they would be required to submit a total of 54 insignias.$B$BThose exalted in the eyes of the Dawn receive the greatest discounts.\n',26124),
(12236,'enUS','','Certainly, $n.$B$BAdventurers that the Dawn views as friendly must submit a combined total of 60 insignias to access superior items. To access items of even greater power, they would be required to submit a total of 220 insignias.$B$BI must admit, the price is quite high for adventurers not favored by the Dawn.\n',26124),
(12237,'enUS','Friendly.','Friendly.',26124),
(12238,'enUS','Honored.','Honored.',26124),
(12239,'enUS','Revered.','Revered.',26124),
(12240,'enUS','Exalted.','Exalted.',26124),
(12241,'enUS','I have another question.','I have another question.',26124),
(12242,'enUS','%s spots a zombie to devour!','',26124),
(12243,'enUS','You will not stop our deepening shadow, $c.  Now... join us!  Join the ranks of the Chosen!','',26124),
(12244,'enUS','These Runestones protect the lands in Eversong from becoming tainted by the Scourge.  The Western Runestone failed long ago, forcing us to burn the ground around it.$B$BAs long as I live I won\'t allow the remaining Runestones to fail us.  That is my oath.','',26124),
(12245,'enUS','','Well, you didn\'t come all this way out here to jaw over a cup of tea. Let\'s see how you might be able to help get us out of this situation.',26124),
(12246,'enUS','There are those who would say that the Argent Crusade is a thing of the past.  I am one of them, but not because the Scourge have fallen.$b$bNo... it is because of their stubborn ways.  They\'ve become too much like the church that they seceded from: too rigid, too governed by honor and order.  This is what I\'m trying to tell Barthalomew, anyhow.$b$bSure, it may sound a bit jingoistic, but it makes for a good debate.','',26124),
(12247,'enUS','Is this the best they could do?$B$B<Omarion musters the strength to laugh.>$B$BYou do not possess the resolve to face a monster like Kel\'Thuzad. You will crumble before his minions - just like those that have come before you...$B$BLeave me here to die. I refuse to return to a world that champions the likes of you.\n','',26124),
(12248,'enUS','Could it be? One that passes through these halls with a purpose? Aye, a righteous fire burns in your belly, $r.$B$BMy life may soon end, but the knowledge I hold must be shared with the world. It is, after all, why I am here now.$B$BAre you a master of a trade?\n','',26124),
(12249,'enUS','You honor me with your presence, $r. Alas, it is too late for me. I pass from this world soon, but... I know so much. So much is in this head of mine. So much that could help this world fend off the beasts of this citadel of depravity.$B$BPerhaps if you are a master of a trade... Yes, perhaps you would take the knowledge I hold and use it to save this world.\n','',26124),
(12251,'enUS','I am a master tailor, Omarion.','I am a master tailor, Omarion.',26124),
(12252,'enUS','A tailor, eh? Very well. What would you like to learn about, tailor?','',26124),
(12253,'enUS','Glacial Vest.','Glacial Vest.',26124),
(12254,'enUS','Glacial Cloak.','Glacial Cloak.',26124),
(12255,'enUS','Glacial Gloves.','Glacial Gloves.',26124),
(12256,'enUS','Glacial Wrists.','Glacial Wrists.',26124),
(12257,'enUS','I am a master leatherworker, Omarion.','I am a master leatherworker, Omarion.',26124),
(12258,'enUS','Perhaps I can teach you something...','',26124),
(12259,'enUS','Icy Scale Breastplate.','Icy Scale Breastplate.',26124),
(12260,'enUS','Icy Scale Gauntlets.','Icy Scale Gauntlets.',26124),
(12261,'enUS','Icy Scale Bracers.','Icy Scale Bracers.',26124),
(12262,'enUS','Polar Tunic.','Polar Tunic.',26124),
(12263,'enUS','Polar Gloves.','Polar Gloves.',26124),
(12264,'enUS','Polar Bracers.','Polar Bracers.',26124),
(12265,'enUS','I have what you need, $c.','',26124),
(12266,'enUS','Icebane Breastplate.','Icebane Breastplate.',26124),
(12267,'enUS','Icebane Gauntlets.','Icebane Gauntlets.',26124),
(12268,'enUS','Icebane Bracers.','Icebane Bracers.',26124),
(12269,'enUS','I am a master blacksmith, Omarion.','I am a master blacksmith, Omarion.',26124),
(12270,'enUS','I need to go. Evil stirs. Die well, Omarion.','I need to go. Evil stirs. Die well, Omarion.',26124),
(12271,'enUS','Show me where I can fly.','Show me where I can fly.',26124),
(12272,'enUS','%s releases the last of its energies into the nearby runestone, successfully reactivating it.','',26124),
(12273,'enUS','Master craftsman Omarion just vanished one night. Like a toot in the wind... Poof! Gone! Bah, now I\'m the only one left to craft the goods for the boys on the front lines. ','',26124),
(12274,'enUS','Show me your wares, Wilhelm.','Show me your wares, Wilhelm.',26124),
(12275,'enUS','Your actions will not be tolerated!','Your actions will not be tolerated!',26124),
(12276,'enUS','You will abide by our rules around here, miscreant!','You will abide by our rules around here, miscreant!',26124),
(12277,'enUS','Lay down your weapons, your feuds have no place here!','Lay down your weapons, your feuds have no place here!',26124),
(12278,'enUS','Sin\'dorei and Forsaken share a common goal in the Ghostlands, $n.  Together we shall defeat the Scourge and who knows... perhaps the Forsaken will be valuable allies in our quest to reach Outland.','',26124),
(12279,'enUS','Omarion, I am not a craftsman. Can you still help me?','Omarion, I am not a craftsman. Can you still help me?',26124),
(12280,'enUS','<Omarion grumbles something under his breath.>$B$BBut of course I can help you, dear $g boy:girl;. It is my dying wish... my final desire. Please, take this handbook. The information on its pages are a compilation of all that I know and have learned in the past 30 some-odd years of my miserable life. Give the handbook to that good for nothing apprentice of mine that\'s probably sitting on his fat duff at Light\'s Hope Chapel.','',26124),
(12281,'enUS','Thank you, Omarion. You have taken a fatal blow for the team on this day.','Thank you, Omarion. You have taken a fatal blow for the team on this day.',26124),
(12282,'enUS','<Tarsis groans.>$B$BThere may still be time... Listen closely, mortal.$B$BThrough time and across the Nether I have searched. Deals made with a host of evil and villainy so wretched...$B$B<Tarsis coughs blood into his hands.>$B$BWould you... would you believe that even Elune has turned her back on me, $r? To die here, in this manner now...','',26124),
(12283,'enUS','What are you talking about, mage?','What are you talking about, mage?',26124),
(12284,'enUS','The things I have done... such horrible things...$B$B<Tarsis begins to sob.>\n','',26124),
(12285,'enUS','Why have you done such horrible things?\n','Why have you done such horrible things?\n',26124),
(12286,'enUS','I am Highborne, $r. It has no meaning now. There was a time, though, when this world was ruled by Highborne. Ten thousand years past...','',26124),
(12287,'enUS','I still do not understand.','I still do not understand.',26124),
(12288,'enUS','I would have it back, mortal. Atiesh... From it I would create the Highborne anew. I would have it all back. Even the Queen...','',26124),
(12289,'enUS','You are talking nonsense, mage. ','You are talking nonsense, mage. ',26124),
(12290,'enUS','<Tarsis grabs you weakly by the collar. Even in death you see power unimaginable in his eyes.>$B$BAm I? Then listen closely, for more nonsense is about to escape my lips. Within this citadel you will find my life\'s work: The exact location of every fragment of the splintered staff.','',26124),
(12291,'enUS','What staff?','What staff?',26124),
(12292,'enUS','Atiesh, Greatstaff of the Guardian. The staff handed down through the ages to each of the Guardians of Tirisfal. The staff corrupted by Sargeras. The staff of the last Guardian. The staff of Medivh.\n','',26124),
(12293,'enUS','You said you would have it back. What does that mean?','You said you would have it back. What does that mean?',26124),
(12294,'enUS','<Tarsis\'s eyes light up.>$B$BI held it once... I held it despite the warnings of the Kirin Tor. I held it, mortal... Power unending. Power to do what I desired, as I desired. And just as quickly, it was taken from me. But I had tasted... And that taste was all that it took.  ','',26124),
(12295,'enUS','%s gets to one knee.','%s gets to one knee.',26124),
(12296,'enUS','%s sits down.','',26124),
(12297,'enUS','<Tarsis is badly injured.>','',26124),
(12298,'enUS','<Wake Tarsis up.>','<Wake Tarsis up.>',26124),
(12299,'enUS','The battle is won. For the time being, the Scourge threat has been pushed back. Our resources can be channeled into aiding you, in thanks and preparation for the future.','The battle is won. For the time being, the Scourge threat has been pushed back. Our resources can be channeled into aiding you, in thanks and preparation for the future.',26124),
(12300,'enUS','The battle goes well. The Scourge forces seem weakened. I believe it will only be a matter of time before we drive them from our shores. I will turn my magics to you, to aid in this struggle.','The battle goes well. The Scourge forces seem weakened. I believe it will only be a matter of time before we drive them from our shores. I will turn my magics to you, to aid in this struggle.',26124),
(12301,'enUS','The first steps of our fight against the Scourge go well. We have had some successes, and hopefully my assistance can aid you in bringing future success to the battle.','The first steps of our fight against the Scourge go well. We have had some successes, and hopefully my assistance can aid you in bringing future success to the battle.',26124),
(12302,'enUS','Give me one of your magic items.','Give me one of your magic items.',26124),
(12303,'enUS','I put at your disposal whatever assistance I can offer.','I put at your disposal whatever assistance I can offer.',26124),
(12304,'enUS','What happened to the staff?','What happened to the staff?',26124),
(12305,'enUS','It was lost when the Violet Citadel fell... splintered into forty-two pieces.','',26124),
(12306,'enUS','So what has led you to Naxxramas?','So what has led you to Naxxramas?',26124),
(12307,'enUS','Kel\'Thuzad has put forth considerable effort in attempting to reform the staff. The pieces were once scattered across this world, from Kalimdor to the South Seas. I myself held twenty of the pieces at one point in time - until they were stolen from me by Kel\'Thuzad\'s minions. It is why I am here.','',26124),
(12308,'enUS','So Kel\'Thuzad holds all of the pieces?','So Kel\'Thuzad holds all of the pieces?',26124),
(12309,'enUS','Haven\'t you been listening? No, I very much doubt we would be having this conversation had Kel\'Thuzad formed the staff. Kel\'Thuzad holds the head. His underlings hold forty splinters of Atiesh. The last piece - the base - was uncovered by Brann Bronzebeard. He was last seen in the Silithus desert; undoubtedly doing his best to stay as far away as possible from the relentless seekers Kel\'Thuzad has dispatched into the world.','',26124),
(12310,'enUS','To arms!  Scourge spotted in the Cathedral of Light!','To arms!  Scourge spotted in the Cathedral of Light!',26124),
(12311,'enUS','Scourge in the Trade District!  Have at them!','Scourge in the Trade District!  Have at them!',26124),
(12312,'enUS','You... The frame! How? You must not... It... the Destroyer...','',26124),
(12313,'enUS','What is it Tarsis? I don\'t know what to do!','What is it Tarsis? I don\'t know what to do!',26124),
(12314,'enUS','%s scratches at his throat.','',26124),
(12315,'enUS','Light help us... the Scourge are in the Park!','Light help us... the Scourge are in the Park!',26124),
(12316,'enUS','The Scourge are at the castle entrance!  For Stormwind!  For King Anduin!','The Scourge are at the castle entrance!  For Stormwind!  For King Anduin!',26124),
(12317,'enUS','Hold the line!  Protect the King at all costs!','',26124),
(12318,'enUS','Good work, one and all!  The Scourge at the castle have been defeated.','',26124),
(12320,'enUS','','%s scratches at her throat.',26124),
(12321,'enUS','','What have you done? FOOL! You brought it... NO!',26124),
(12322,'enUS','%s flaps down from the ceiling...','',26124),
(12323,'enUS','%s howls through the halls...','',26124),
(12324,'enUS','%s skitters out from the shadows...','',26124),
(12325,'enUS','We come destroy puny ones!','',26124),
(12326,'enUS','The Lich King say to tell you... DIE!','',26124),
(12327,'enUS','Raaarrrrggghhh!  We come for you!','',26124),
(12328,'enUS','Hahaha, your guards no match for Scourge!','',26124),
(12329,'enUS','What?  This not Naxxramas!  We not like this place... destroy!','',26124),
(12330,'enUS','You spare parts!  We make more Scourge in necropolis.','',26124),
(12331,'enUS','','The Scourge attack against my court has been eliminated.  You may go about your business.',26124),
(12332,'enUS','','My Royal Dreadguard, you will deal with this matter as befits your station.  That, or you will wish that you had.',26124),
(12333,'enUS','Dreadguard, hold your line.  Halt the advance of those Scourge!','',26124),
(12334,'enUS','Scourge in sewers!  We need help!','',26124),
(12335,'enUS','Scourge attack Magic Quarter!','',26124),
(12336,'enUS','Rogues\' Quarter attacked by Scourge!  Help!','',26124),
(12337,'enUS','The Scourge are at the entrance to the Royal Quarter!  Kill them!!','The Scourge are at the entrance to the Royal Quarter!  Kill them!!',26124),
(12338,'enUS','%s drops its weapon.','',26124),
(12339,'enUS','Our Sanctums syphon arcane power from ley-line currents that traverse our lands invisible to the naked eye.$B$BWith the Sunwell gone, they provide us with a steady and reliable source of energy.','',26124),
(12340,'enUS','It\'s a testament to our race\'s tenacity that Fairbreeze Village still stands.  We shall never concede defeat to the Scourge ever again.','',26124),
(12341,'enUS','Gangway, ye scurvy dog!  Revilgaz has spared me from the gallows but my punishment might be nearly as bad.','Gangway, ye scurvy dog!  Revilgaz has spared me from the gallows but my punishment might be nearly as bad.',26124),
(12342,'enUS','Why you run away? We make your corpse into Scourge.','',26124),
(12343,'enUS','No worry, we find you.','',26124),
(12344,'enUS','','You\'d better not be causing trouble, $n!',26124),
(12345,'enUS','What can I do for you, $n?  Make it quick, I don\'t have all day!','',26124),
(12346,'enUS','What can I do for you?  No, wait!  What can you do for me?','',26124),
(12347,'enUS','%s belches out a disgusting Bile Sludge!','',26124),
(12348,'enUS','%s devours all nearby zombies!','',26124),
(12349,'enUS','The Stormpike forces gain the General\'s Warcry.','',26124),
(12350,'enUS','The Frostwolf forces gain the General\'s Warcry.','',26124),
(12351,'enUS','Take no prisoners! Drive these heathens from our lands!','',26124),
(12352,'enUS','Leave no survivors!','',26124),
(12353,'enUS','There Scourge outside Trade Quarter!','',26124),
(12354,'enUS','Scourge inside Trade Quarter!  Destroy!','',26124),
(12355,'enUS','Scourge spotted nearby!','Scourge spotted nearby!',26124),
(12356,'enUS','I just saw a Scourge!  Kill it!','I just saw a Scourge!  Kill it!',26124),
(12357,'enUS','Did you see that?  There\'s a Scourge over there!','Did you see that?  There\'s a Scourge over there!',26124),
(12358,'enUS','How can I get anything done with the Scourge running amok in here?!','How can I get anything done with the Scourge running amok in here?!',26124),
(12359,'enUS','There\'s one of the Scourge, right over there!','There\'s one of the Scourge, right over there!',26124),
(12360,'enUS','This has gone too far.  How dare the Scourge attack Undercity!  Destroy it before more come!','This has gone too far.  How dare the Scourge attack Undercity!  Destroy it before more come!',26124),
(12361,'enUS','Will these unrelenting Scourge attacks never end?','Will these unrelenting Scourge attacks never end?',26124),
(12362,'enUS','Destroy the Scourge invader now, before it\'s too late!','Destroy the Scourge invader now, before it\'s too late!',26124),
(12363,'enUS','I desire this eternal quintessence, Duke Hydraxis.','I desire this eternal quintessence, Duke Hydraxis.',26124),
(12364,'enUS','You\'ve served our cause with great loyalty, $n.  Allow me to present you with an unending source of our elemental quintessence.','',26124),
(12365,'enUS','Welcome back, $n.  You\'ve proven a worthy ally against Ragnaros and your presence is always welcome among us.','',26124),
(12366,'enUS','Scourge spotted nearby!','Scourge spotted nearby!',26124),
(12367,'enUS','I just saw a Scourge!  Kill it!','I just saw a Scourge!  Kill it!',26124),
(12368,'enUS','Did you see that?  There\'s a Scourge over there!','Did you see that?  There\'s a Scourge over there!',26124),
(12369,'enUS','How can I get anything done with the Scourge running amok around here?!','How can I get anything done with the Scourge running amok around here?!',26124),
(12370,'enUS','There\'s one of the Scourge, right over there!','There\'s one of the Scourge, right over there!',26124),
(12371,'enUS','This has gone too far.  How dare the Scourge attack Stormwind!  Destroy it before more come!','This has gone too far.  How dare the Scourge attack Stormwind!  Destroy it before more come!',26124),
(12372,'enUS','Will these unrelenting Scourge attacks never end?','Will these unrelenting Scourge attacks never end?',26124),
(12373,'enUS','Destroy the Scourge invader now, before it\'s too late!','Destroy the Scourge invader now, before it\'s too late!',26124),
(12374,'enUS','The dead walk among us!','The dead walk among us!',26124),
(12375,'enUS','You hold evil in your hands, fool! REPENT!','You hold evil in your hands, fool! REPENT!',26124),
(12376,'enUS','You risk destroying us all, $r! You must be terminated!','You risk destroying us all, $r! You must be terminated!',26124),
(12377,'enUS','This is holy ground, heathen.','This is holy ground, heathen.',26124),
(12378,'enUS','Ashbringer...','Ashbringer...',26124),
(12379,'enUS','Kneel! Kneel before the Ashbringer!','Kneel! Kneel before the Ashbringer!',26124),
(12380,'enUS','I am unworthy, $g sir:ma\'am;.','I am unworthy, $g sir:ma\'am;.',26124),
(12381,'enUS','Have you come to save this world? To cleanse it?','Have you come to save this world? To cleanse it?',26124),
(12382,'enUS','My $g Lord:Lady;, please allow me to live long enough to see you purge this world of the infidels.','My $g Lord:Lady;, please allow me to live long enough to see you purge this world of the infidels.',26124),
(12383,'enUS','And so it begins...','And so it begins...',26124),
(12384,'enUS','Take me with you, $g sir:ma\'am;.','Take me with you, $g sir:ma\'am;.',26124),
(12385,'enUS','Port back to center','',26124),
(12386,'enUS','I look into the eye...','I look into the eye...',26124),
(12387,'enUS','Oh Rly? <PH>','',26124),
(12388,'enUS','Ya Rly! <PH>','Ya Rly! <PH>',26124),
(12389,'enUS','Bow down! Kneel before the Ashbringer! A new dawn approaches, brothers and sisters! Our message will be delivered to the filth of this world through the chosen one!','',26124),
(12390,'enUS','You hold my father\'s blade, $n. My soldiers are yours to control, my $g Lord:Lady;. Take them... Lead them... The impure must be purged. They must be cleansed of their taint.','',26124),
(12391,'enUS','%s flees after seeing Kel\'Thuzad fall!','',26124),
(12392,'enUS','Phase 3! <PH>','',26124),
(12393,'enUS','','Let\'s go.',26124),
(12394,'enUS','Dar\'Khan thinks we\'ll roll over for the Scourge without putting up a fight.  We shall prove him wrong, $n.','',26124),
(12395,'enUS','Can\'t you see that I\'m trying to have a conversation with the lady?  Oh, very well, she seems preoccupied anyway.$B$BI deal in only the finest drinks, both local and exotic in vintage.  Care to have a look?','',26124),
(12397,'enUS','Is that a list from Saltheril\'s Haven?  No doubt, his lordship will require a bottle of my finest.  And, of course, any friend of Lord Saltheril deserves a special price on such a fine vintage.','',26124),
(12398,'enUS','How many battles have we won?','How many battles have we won?',26124),
(12399,'enUS','We have won $2219W battles against the Scourge.  Gird yourself, $n, for this war is far from over.','',26124),
(12400,'enUS','','If you have the coin, I have the food and drink to keep that appetite of yours satisfied.  Every copper goes to keeping the Retreat in tip-top shape.',26124),
(12401,'enUS','','Is that a list from Lord Saltheril that you have there? Yes, I can sell you a batch of appetizers, fresh off the fire.',26124),
(12402,'enUS','We have won $2219W battles against the Scourge.  Take heart, $n.  While many battles lie ahead, heroes, heroes from every realm have risen to fight them.','',26124),
(12403,'enUS','We have won $2219W battles against the Scourge.  Stand firm, $n!  We must persevere!','',26124),
(12404,'enUS','I have all manner of goods for sale, $c.  Browse at your leisure.','',26124),
(12405,'enUS','A list... how intriguing.  Ah yes, the shipment of fireworks for Lord Saltheril.  He hasn\'t paid for them; are you here to purchase them on his behalf, $c?','',26124),
(12406,'enUS','','Is there no end to these undead?  It seems that for every ghoul or skeleton we kill, two take its place.',26124),
(12407,'enUS','','Marketing - iCoke Redemption Greeting (S.H.E.)',26124),
(12408,'enUS','Where\'s that courier?','',26124),
(12409,'enUS','What word from Silvermoon?  The courier is late!','',26124),
(12410,'enUS','Where is the messenger from the regent lord?','',26124),
(12411,'enUS','I don\'t have all day to wait out here for that message. There are things that Dame Auriferous has tasked me with seeing to!','',26124),
(12412,'enUS','The hour runs late. The message from Silvermoon City is delayed for some reason.','',26124),
(12413,'enUS','The courier from Silvermoon City is delayed. Perhaps I should send a scout to look for him?','',26124),
(12414,'enUS','At this rate I\'m going to pace a rut into the road. I hope the messenger from Kalecgos arrives soon.','',26124),
(12415,'enUS','Whatever the courier delivers, I hope that it\'s good news.','',26124),
(12416,'enUS','$C, you didn\'t happen to see a courier on your way here? We are awaiting word from Silvermoon City and their messenger is late!','',26124),
(12417,'enUS','','Open fire!',26124),
(12418,'enUS','','Enemy sighted!  Ready your weapons!',26124),
(12419,'enUS','','Hold your positions!',26124),
(12420,'enUS','Our dark master has noticed your trifling, and sends me to bring a message... of doom!','',26124),
(12421,'enUS','These heroics mean nothing, $c.  Your future is sealed and your soul is doomed to servitude!','',26124),
(12422,'enUS','Your battle here is but the smallest mote of a world wide invasion, whelp!  It is time you learned of the powers you face!','',26124),
(12423,'enUS','Sometimes I stand here, looking into the forest beyond the lake, and I see the land as it once was... green and full of life.','',26124),
(12424,'enUS','We really must perfect a way to deal with those smelly Shadowpine trolls!','',26124),
(12425,'enUS','I must say, you delivered my poison and dealt with those trolls most ruthlessly, $c. You\'ve got the makings of quite a talented young $g man : lady;!','',26124),
(12426,'enUS','','Marketing - iCoke Redemption Greeting (S.H.E. non-Quest)',26124),
(12427,'enUS','World of Warcraft and Coca-Cola (R) have teamed up to bring you the iCoke-World of Warcraft Summer Promotion.  Look for codes under the caps of specially marked bottles of Coca-Cola.  Then return here and enter the code to win a virtual item.','World of Warcraft and Coca-Cola (R) have teamed up to bring you the iCoke-World of Warcraft Summer Promotion.  Look for codes under the caps of specially marked bottles of Coca-Cola.  Then return here and enter the code to win a virtual item.',26124),
(12428,'enUS','I shall find you mortals!  You shall pay for destroying the Ash\'ari Crystals!','',26124),
(12429,'enUS','Thank you for becoming my next victim!','',26124),
(12430,'enUS','','We must maintain a state of vigilance, $c! Between Dar\'Khan the Betrayer and his Scourge, and the Shadowpine trolls backed by the might of Zul\'Aman, we\'re barely keeping our heads above water here. We really shouldn\'t have to be dividing our attentions!$B$BI hope you\'re here to help.',26124),
(12431,'enUS','','I\'m glad that you\'re here to help, $c. The faster we can deal with these trolls, the faster we\'ll get to send the scourge back to where they came from.',26124),
(12432,'enUS','','One set of trolls dealt with, one yet to go. You have no idea how much I appreciate what you\'re doing, $n! Before you came along I didn\'t think we\'d ever get the Shadowpine problem under control.',26124),
(12433,'enUS','','You wouldn\'t believe some of the rabble that we\'ve had come through here lately. Most are more trouble than the supposed help that they provide. Nothing at all like you.$B$BYou sure you don\'t want to sign up with the Farstriders?',26124),
(12434,'enUS','Where are we battling the Scourge?','Where are we battling the Scourge?',26124),
(12435,'enUS','The Lich King brought only small forces to bear against each of Azeroth\'s capital cities, while their main forces periodically attack the following lands:$B$BAzshara, the Blasted Lands, the Burning Steppes, the Tanaris Desert, the Eastern Plaguelands and Winterspring.','',26124),
(12436,'enUS','Haha... I gonna kill puny $r and make trophy of your skull!','',26124),
(12437,'enUS','','What brings you here, $n?  We don\'t see too many people around these parts.  With good reason, I suppose.',26124),
(12438,'enUS','','Do you wish to learn the blacksmithing profession or is there something else you wish to tell me?',26124),
(12439,'enUS','Nevermind my injuries, $g brother : sister;. It\'s a miracle that any of us are alive!','',26124),
(12440,'enUS','DISCOVERY!   $n has discovered the Super Rejuvenation Potion recipe!','DISCOVERY!   $n has discovered the Super Rejuvenation Potion recipe!',26124),
(12441,'enUS','DISCOVERY!   $n has discovered the Flask of Fortification recipe!','DISCOVERY!   $n has discovered the Flask of Fortification recipe!',26124),
(12442,'enUS','DISCOVERY!   $n has discovered the Flask of Mighty Versatility recipe!','DISCOVERY!   $n has discovered the Flask of Mighty Versatility recipe!',26124),
(12443,'enUS','DISCOVERY!   $n has discovered the Flask of Relentless Assault recipe!','DISCOVERY!   $n has discovered the Flask of Relentless Assault recipe!',26124),
(12444,'enUS','DISCOVERY!   $n has discovered the Flask of Blinding Light recipe!','DISCOVERY!   $n has discovered the Flask of Blinding Light recipe!',26124),
(12445,'enUS','DISCOVERY!   $n has discovered the Flask of Pure Death recipe!','DISCOVERY!   $n has discovered the Flask of Pure Death recipe!',26124),
(12446,'enUS','','We are very fortunate to be alive, you and I!',26124),
(12447,'enUS','You don\'t see too many apprentices around these parts, do you?  I\'m beginning to think it\'s because the magisters give us all the dangerous work they\'d rather not do themselves.','',26124),
(12448,'enUS','The Light be praised!  I would have died out here if it weren\'t for you, $c!  I must get to the ship.','The Light be praised!  I would have died out here if it weren\'t for you, $c!  I must get to the ship.',26124),
(12449,'enUS','Huh?  What happened?  Oh... my head feels like it\'s going to explode!  I\'d best get back to the crash site.','Huh?  What happened?  Oh... my head feels like it\'s going to explode!  I\'d best get to the crash site.',26124),
(12450,'enUS','Many thanks to you, $c.  I\'d best get to the crash site and see how I can help out.  Until we meet again.','Many thanks to you, $c.  I\'d best get to the crash site and see how I can help out.  Until we meet again.',26124),
(12451,'enUS','$C, you saved me!  I owe you a debt that I can never repay.  I\'ll go see if I can help the others.','$C, you saved me!  I owe you a debt that I can never repay.  I\'ll go see if I can help the others.',26124),
(12452,'enUS','DISCOVERY!   $n has discovered how to transmute primal shadow into water.','DISCOVERY!   $n has discovered how to transmute primal shadow into water.',26124),
(12453,'enUS','DISCOVERY!   $n has discovered how to transmute primal water into shadow.','DISCOVERY!   $n has discovered how to transmute primal water into shadow.',26124),
(12454,'enUS','DISCOVERY!   $n has discovered how to transmute primal mana into fire.','DISCOVERY!   $n has discovered how to transmute primal mana into fire.',26124),
(12455,'enUS','DISCOVERY!   $n has discovered how to transmute primal fire into mana.','DISCOVERY!   $n has discovered how to transmute primal fire into mana.',26124),
(12456,'enUS','DISCOVERY!   $n has discovered how to transmute primal life into earth.','DISCOVERY!   $n has discovered how to transmute primal life into earth.',26124),
(12457,'enUS','DISCOVERY!   $n has discovered how to transmute primal earth into life.','DISCOVERY!   $n has discovered how to transmute primal earth into life.',26124),
(12458,'enUS','Ours is the path of purity and righteousness in the Light.','Ours is the path of purity and righteousness in the Light.',26124),
(12459,'enUS','We are one in the Light, $g brother : sister;, but I cannot train you.','We are one in the Light, $g brother : sister;, but I cannot train you.',26124),
(12460,'enUS','You come in search of training, hunter?','You come in search of training, hunter?',26124),
(12461,'enUS','I\'m a hunter trainer. You\'ll want to find the $c trainer.','I\'m a hunter trainer. You\'ll want to find the $c trainer.',26124),
(12462,'enUS','Do you seek further training in the ways of the warrior?','Do you seek further training in the ways of the warrior?',26124),
(12463,'enUS','I would train you, but you are no warrior.','I would train you, but you are no warrior.',26124),
(12464,'enUS','We practitioners of the arcane and elemental ways follow a never ending path of discovery. Is that why you seek my counsel? You wish further training?','We practitioners of the arcane and elemental ways follow a never ending path of discovery. Is that why you seek my counsel? You wish further training?',26124),
(12465,'enUS','By the Naaru, you are no mage! If you are looking for training, you must seek out a $c trainer.','By the Naaru, you are no mage! If you are looking for training, you must seek out a $c trainer.',26124),
(12466,'enUS','In the Light we all cast shadows, my $g brother : sister;.  Do you seek further guidance today?','In the Light we all cast shadows, my $g brother : sister;.  Do you seek further guidance today?',26124),
(12467,'enUS','Though I cannot offer you training, young $c, I can give you my blessing. Walk boldly in the Light!','Though I cannot offer you training, young $c, I can give you my blessing. Walk boldly in the Light!',26124),
(12468,'enUS','Who dares invade the Shattered Halls? Prepare to meet the might of the Fel Horde!','',26124),
(12469,'enUS','Renault...','',26124),
(12470,'enUS','Father... But... How?','',26124),
(12471,'enUS','Did you think that your betrayal would be forgotten? Lost in the carefully planned cover up of my death? Blood of my blood, the blade felt your cruelty long after my heart had stopped beating. And in death, I knew what you had done. But now, the chains of Kel\'Thuzad hold me no more. I come to serve justice. I AM ASHBRINGER.\n','',26124),
(12472,'enUS','Forgive me, father! Please...','',26124),
(12473,'enUS','You are forgiven...','',26124),
(12474,'enUS','The Scourge infestation grows in Azshara. Every able bodied warrior is needed to stem the tide of their invasion.$B$BNumber of Necropolises remaining: $2279W','',26124),
(12475,'enUS','The Scourge infestation grows in the Eastern Plaguelands. Every able bodied warrior is needed to stem the tide of their invasion.$B$BNumber of Necropolises remaining: $2282W','',26124),
(12476,'enUS','Is Azshara currently under attack?','Is Azshara currently under attack?',26124),
(12477,'enUS','Are the Eastern Plaguelands currently under attack?','Are the Eastern Plaguelands currently under attack?',26124),
(12478,'enUS','I have another question.','I have another question.',26124),
(12479,'enUS','Where else are we battling the Scourge?','Where else are we battling the Scourge?',26124),
(12480,'enUS','At last, the curse is lifted. Thank you, hero.','',26124),
(12481,'enUS','Curse? What\'s going on here, Fairbanks?','Curse? What\'s going on here, Fairbanks?',26124),
(12482,'enUS','You mean, you don\'t know? The sword that you carry on your back - it is known as Ashbringer; named after its original owner.','',26124),
(12483,'enUS','Mograine?','Mograine?',26124),
(12484,'enUS','Aye, the Highlord Mograine: A founder of the original order of the Scarlet Crusade. A knight of unwavering faith and purity; Mograine would be betrayed by his own son and slain by Kel\'Thuzad\'s forces inside Stratholme. It is how I ended up here...','',26124),
(12485,'enUS','What do you mean?','What do you mean?',26124),
(12486,'enUS','It was High General Abbendis, High Inquisitor Isillien, and Highlord Mograine that formed the Crusade. In its infancy, the Crusade was a noble order. The madness and insane zealotry that you see now did not exist. It was not until the one known as the Grand Crusader appeared that the wheels of corruption were set in motion.','',26124),
(12487,'enUS','I still do not fully understand.','I still do not fully understand.',26124),
(12488,'enUS','The Highlord was the lynchpin of the Crusade. Aye, Mograine was called the Ashbringer because of his exploits versus the armies of the Lich King. With only blade and faith, Mograine would walk into whole battalions of undead and emerge unscathed - the ashes of his foes being the only indication that he had been there at all. Do you not understand? The very face of death feared him! It trembled in his presence!','',26124),
(12489,'enUS','Incredible story. So how did he die?','Incredible story. So how did he die?',26124),
(12490,'enUS','The only way a hero can die, $r: Through tragedy. The Grand Crusader struck a deal with Kel\'Thuzad himself! An ambush would be staged that would result in the death of Mograine. The type of betrayal that could only be a result of the actions of one\'s most trusted and loved companions.','',26124),
(12491,'enUS','You mean...','You mean...',26124),
(12492,'enUS','<High Inquisitor Fairbanks nods.>$B$BAye, the lesser Mograine, the one known as the Scarlet Commander, through - what I suspect - the dealings of the Grand Crusader. He led his father to the ambush like a lamb to the slaughter.','',26124),
(12493,'enUS','How do you know all of this?','How do you know all of this?',26124),
(12494,'enUS','<High Inquisitor Fairbanks lifts up his tabard revealing several gruesome scars.>$B$BBecause I was there... I was the Highlord\'s most trusted advisor. I should have known... I felt that something was amiss yet I allowed it to happen. Would you believe that there were a thousand or more Scourge?','',26124),
(12495,'enUS','A thousand? For one man?','A thousand? For one man?',26124),
(12496,'enUS','This was the Ashbringer, fool! As the Scourge began to materialize around us, Mograine\'s blade began to glow... to hum... the younger Mograine would take that as a sign to make his escape. They descended upon us with a hunger the likes of which I had never seen. Yet...','',26124),
(12497,'enUS','Yet? Yet what??','Yet? Yet what??',26124),
(12498,'enUS','It was not enough.$B$B<Fairbanks smirks briefly, lost in a memory.>$B$BA thousand came and a thousand died. By the Light! By the might of Mograine! He would smite them down as fast as they could come. Through the chaos, I noticed that the lesser Mograine was still there, off in the distance. I called to him, \"Help us, Renault! Help your father, boy!\"','',26124),
(12499,'enUS','And did he?','And did he?',26124),
(12500,'enUS','<High Inquisitor Fairbanks shakes his head.>$B$BNo... He stood in the background, watching as the legion of undead descended upon us. Soon after, my powers were exhausted. I was the first to fall... Surely they would tear me limb from limb as I lay there unconscious; but they ignored me completely, focusing all of their attention on the Highlord. ','',26124),
(12501,'enUS','Continue please, Fairbanks.','Continue please, Fairbanks.',26124),
(12502,'enUS','It was all I could do to feign death as the corpses of the Scourge piled upon me. There was darkness and only the muffled sounds of the battle above me. The clashing of iron, the gnashing and grinding... gruesome, terrible sounds. And then there was silence. He called to me! \"Fairbanks! Fairbanks where are you? Talk to me Fairbanks!\" And then came the sound of incredulousness. The bite of betrayal, $r...','',26124),
(12503,'enUS','You mean...','You mean...',26124),
(12504,'enUS','The boy had picked up the Ashbringer and driven it through his father\'s heart as his back was turned. His last words will haunt me forever: \"What have you done, Renault? Why would you do this?\"','',26124),
(12505,'enUS','You were right, Fairbanks. That is tragic.','You were right, Fairbanks. That is tragic.',26124),
(12506,'enUS','The blade and Mograine were a singular entity. Do you understand? This act corrupted the blade and lead to Mograine\'s own corruption as a death knight of Kel\'Thuzad. I swore that if I lived, I would expose the perpetrators of this heinous crime. For two days I remained under the rot and contagion of Scourge - gathering as much strength as possible to escape the razed city.\n','',26124),
(12507,'enUS','And you did...','And you did...',26124),
(12508,'enUS','Aye, I did. Much to the dismay of the lesser Mograine, I made my way back to the Scarlet Monastery. I shouted and screamed. I told the tale to any that would listen. And I would be murdered in cold blood for my actions, dragged to this chamber - the dark secret of the order. But some did listen... some heard my words. Thus was born the Argent Dawn...','',26124),
(12509,'enUS','You tell an incredible tale, Fairbanks. What of the blade? Is it beyond redemption?','You tell an incredible tale, Fairbanks. What of the blade? Is it beyond redemption?',26124),
(12510,'enUS','I\'m afraid that the blade which you hold in your hands is beyond saving. The hatred runs too deep. But do not lose hope, $c. Where one chapter has ended, a new one begins.$B$BFind his son - a more devout and pious man you may never meet. It is rumored that he is able to build the Ashbringer anew, without requiring the old, tainted blade.','',26124),
(12511,'enUS','But his son is dead.','But his son is dead.',26124),
(12512,'enUS','<High Inquisitor Fairbanks shakes his head.>$B$BNo, $r; only one of his sons is dead. The other lives...$B$B<High Inquisitor Fairbanks points to the sky.>$B$BThe Outland... Find him there... ','',26124),
(12513,'enUS','','',26124),
(12514,'enUS','The %s nods appreciatively.','',26124),
(12516,'enUS','The %s seems overjoyed.','',26124),
(12517,'enUS','The %s looks confused.','',26124),
(12518,'enUS','The %s seems disoriented.','',26124),
(12519,'enUS','The %s wanders aimlessly.','',26124),
(12520,'enUS','The %s doesn\'t look like it minds the crystal\'s effects.','',26124),
(12521,'enUS','The %s didn\'t like what just happened.','',26124),
(12522,'enUS','The %s is agitated by the inoculation.','',26124),
(12523,'enUS','saved world state is: $2285W','',26124),
(12524,'enUS','$C, I\'m going to need a little time to look into this possible business concerning the blood elves. Perhaps you have other tasks that need doing in the meantime?','',26124),
(12525,'enUS','Many are the paths of the Light, $c.  You must decide which to follow on this world, or any other.','',26124),
(12526,'enUS','As you gain renown with our town, I can make more goods available to you, $n.  With equipment in such short supply we can only afford to provide it to those we trust.','',26124),
(12527,'enUS','Show me what I have access to, Vredigar.','Show me what I have access to, Vredigar.',26124),
(12528,'enUS','I offer what shelter I can in our shattered lands.','I offer what shelter I can in our shattered lands.',26124),
(12529,'enUS','It is so good to see you, $g brother : sister;!  This place gives me the creeps.  While you\'re here, be sure to avail yourself of the many opportunities that these so-called Forsaken are providing.','',26124),
(12530,'enUS','It\'s not my fault... IT\'S NOT MY FAULT!!!$B$BIf they\'d just done what I told them to do everything would have been fine. But no! They wouldn\'t listen.$B$BNow they\'re all dead.$B$BI just want to go home. Home to Silvermoon. I\'m so tired.','',26124),
(12531,'enUS','Yer slop is ready. Come n\' get it...','',26124),
(12532,'enUS','And if I hear that you palookas complained to Nazgrel again, it\'ll be one of ya\'s that I serve up next time...','And if I hear that you palookas complained to Nazgrel again, it\'ll be one of ya\'s that I serve up next time...',26124),
(12533,'enUS','This ain\'t your vacation getaway, $r. If you want to rest, take a bedroll and shut yer yap.$B$BAnd don\'t tell me that you wanna make Hellfire yer home. You ain\'t gonna last two minutes out in the wilds. We\'ll be shipping you back home in five small boxes.','',26124),
(12534,'enUS','As a matter of fact, I do want to make Hellfire Peninsula my home.','As a matter of fact, I do want to make Hellfire Peninsula my home.',26124),
(12535,'enUS','I\'m looking for some specialty goods. Let me browse your wares, Floyd.','I\'m looking for some specialty goods. Let me browse your wares, Floyd.',26124),
(12536,'enUS','This ain\'t daycare, peon. Double time!','',26124),
(12537,'enUS','Don\'t say I didn\'t warn ya when I thrust my fist into the back of yer head. It\'ll feel just like home, back in the Valley of Trials.','',26124),
(12538,'enUS','Yer gonna learn why they call this place Hellfire, maggot.','',26124),
(12539,'enUS','We really must perfect a way to deal with those smelly Shadowpine trolls.$B$BOh, no offense, $c.$B$B<The apothecary grins innocently and shrugs.>','',26124),
(12540,'enUS','They should have listened to me.  Then I\'d receive all of the accolades that are my due!','',26124),
(12541,'enUS','Did I not yell at them? Pull back! Pull back and regroup with suppressing fire!!','',26124),
(12542,'enUS','This isn\'t Silvermoon City! Where are we? Oh, I was confused there for a moment.','',26124),
(12543,'enUS','I tell you now, when we get back to Farstrider Enclave there will be a full accounting of your actions, Ranger Valanna! You alone were responsible for our losses and I\'m certain that the captain will see it my way.','',26124),
(12544,'enUS','Take that!','',26124),
(12545,'enUS','I\'m sure to receive a commendation upon our return. We may have suffered a few losses, but overall I think we did quite nicely, don\'t you, Valanna?','',26124),
(12546,'enUS','Delicious, Cookie... You\'ve really outdone yourself this time, old-timer. I\'ve never tasted horse this good.','Delicious, Cookie... You\'ve really outdone yourself this time, old-timer. I\'ve never tasted horse this good.',26124),
(12547,'enUS','Do I detect a hint of cinnamon? Or is that nutmeg? Whatever it is, one thing\'s for sure - nobody cooks a donkey like you, Cookie.','Do I detect a hint of cinnamon? Or is that nutmeg? Whatever it is, one thing\'s for sure - nobody cooks a donkey like you, Cookie.',26124),
(12548,'enUS','It tastes like I died and went to the Nether; where slop that tastes like rotting threshadon carcass is then shoved down my throat by an obese tauren that\'s never washed their hands - or bathed...','It tastes like I died and went to the Nether; where slop that tastes like rotting threshadon carcass is then shoved down my throat by an obese tauren that\'s never washed their hands - or bathed...',26124),
(12549,'enUS','Is this what it\'s come down to, Cookie? Are we so low on supplies that you\'ve resorted to feeding us dung flavored wood chips?','Is this what it\'s come down to, Cookie? Are we so low on supplies that you\'ve resorted to feeding us dung flavored wood chips?',26124),
(12550,'enUS','If my stomach wasn\'t threatening to dislodge itself from my body and leave me for the refuse that we give to the prisoners, I might be insulted by this... this food.','If my stomach wasn\'t threatening to dislodge itself from my body and leave me for the refuse that we give to the prisoners, I might be insulted by this... this food.',26124),
(12551,'enUS','I\'ve seen gnomes work harder than you, peon! Little girl gnomes - with pig tails! MOVE IT, MOVE IT, MOVE IT!','',26124),
(12552,'enUS','','Executor, your direct assault approach will cost us more lives than I am comfortable with. A more nuanced strategy is called for; one that involves us reclaiming the surrounding territory, starting with the villages so as to cut off all points of reinforcement to Deatholme.',26124),
(12553,'enUS','With all due respect, milady, you have not fought the Scourge as I have. The Lady appointed me to assist you in defeating Dar\'khan because of that, and you would do well to consider what I have to say.','',26124),
(12554,'enUS','I strongly disagree. Dar\'khan is not going to get reinforcements because he\'ll be bottlenecked. Deatholme has only one way in and out. Your traitor was a fool to corner himself there, and I intend to exploit that weakness!','',26124),
(12555,'enUS','This is war, Dame Auriferous, and in any war lives will be lost! The only areas that we need to secure are the two ziggurats. We will turtle in and take the Tower of the Damned and its master by brute force. Then you will have your Quel\'Thalas.','',26124),
(12556,'enUS','And if your Farstriders were here to reinforce us, I might agree. But, they are busying themselves instead with the Shadowpine trolls on your eastern border. The longer we wait for them, the stronger the Scourge will become.','',26124),
(12557,'enUS','','How long until Forsaken reinforcements arrive? Our position here is tenuous. Your Lady promised us more soldiers. We must be able to concentrate solely on Deatholme and the Scourge!',26124),
(12558,'enUS','I believe that you\'re making my argument for me, but yes it would be nice if we had more reinforcements. I would counter that it would be faster to pull the Farstriders from their senseless skirmishing with the trolls.','',26124),
(12559,'enUS','Dame Auriferous, we are the reinforcements. It may come to pass that The Lady will send more men in time. Better that you convince Silvermoon City to muster all of its forces and put them at our disposal here.','',26124),
(12560,'enUS','You are correct; we must concentrate on the Scourge. Ignore the trolls and the villages, and focus our attentions on Deatholme! With Dar\'khan defeated you will find that the rest of the Scourge \'body\' will fall quickly, lacking their \'head\'.','',26124),
(12561,'enUS','Forsaken reinforcements? Undercity is stretched thin with the Scourge on all sides. No, this will be a matter largely dealt with by the blood elves. We Forsaken are here as backup and advisors.','',26124),
(12562,'enUS','','No, I was right to begin with. Deatholme must come last. We must secure all of the Ghostlands first. I will not commit the forces here to a battle against Dar\'khan with enemies to our flank and rear!',26124),
(12563,'enUS','Watch your back, mon!','Watch your back, mon!',26124),
(12564,'enUS','Check your tracks!','Check your tracks!',26124),
(12565,'enUS','Make sure you weren\'t followed, mon!','Make sure you weren\'t followed, mon!',26124),
(12566,'enUS','Didn\'t drag anything in with ya, did ya?','Didn\'t drag anything in with ya, did ya?',26124),
(12567,'enUS','Again I strongly disagree with your view of the strategic situation. Your plan will spread our forces too thin. It will leave us with only a small force to assault Deatholme. I cannot in good conscience execute such a strategy.','',26124),
(12568,'enUS','Spread throughout the Ghostlands, our forces will be of little use in an assault on Deatholme. No, milady, I am here to kill Dar\'khan and that is what I intend to do!','',26124),
(12569,'enUS','We\'ve been over this before. Only a focused assault upon Deatholme will meet with success. These other targets are distractions that we can ill afford. I suggest that you inform your Captain Helios that he is to leave off his campaign against the Shadowpine trolls and focus solely on the Scourge.','',26124),
(12570,'enUS','Perhaps we should let the matter rest for the time being until your chef has prepared your meal? You look a bit piqued if you don\'t mind my saying. We can resume our discussion when you are feeling more yourself.','',26124),
(12571,'enUS','','I hear what you are saying, Mavren. Nevertheless, the final decision is mine. I appreciate your assistance, but the majority of the lives on the line are blood elf. I will not have those lives carelessly thrown away!',26124),
(12572,'enUS','','Mavren, I don\'t want excuses, I want results! The Farstriders aren\'t available and we\'ve received all that we\'re going to get from Silvermoon for now. I cannot ignore the Shadowpine trolls and Zul\'Aman... they\'re arrayed across our eastern border!',26124),
(12573,'enUS','','Disagree with me all you like, High Executor. I will weigh your counsel, and then we will take the steps to free all of Quel\'Thalas as I deem necessary. We shall continue this discussion anon.',26124),
(12574,'enUS','','%s looks appalled at the Executor\'s tone!',26124),
(12575,'enUS','','%s tries to busy herself with other matters.',26124),
(12576,'enUS','','%s glares daggers in the direction of High Executor Mavren and Deathstalker Maltendis.',26124),
(12577,'enUS','','%s lifts her nose and sniffs in response to the High Executor\'s reply.',26124),
(12578,'enUS','','%s shakes her head in disbelief at what she is hearing out of the Forsaken\'s mouth.',26124),
(12579,'enUS','','%s blanches as much of the blood drains from her face.',26124),
(12580,'enUS','','%s reddens furiously at what she is hearing in response to her lady\'s question.',26124),
(12581,'enUS','','%s concentrates on the wall opposite her, clearly ignoring the looks of the Executor and his assistant.',26124),
(12582,'enUS','%s nods in agreement.','',26124),
(12583,'enUS','%s opens his mouth as if to add something, and then apparently thinks the better of it.','',26124),
(12584,'enUS','%s looks over at Advisor Valwyn with a smirk on his face.','',26124),
(12585,'enUS','%s grins at the High Executor\'s words.','',26124),
(12586,'enUS','%s appears bored with the whole discussion.','',26124),
(12587,'enUS','%s winks slyly at Advisor Valwyn.','',26124),
(12588,'enUS','%s fidgets with his armor, clearly uncomfortable at the tone of the discussion.','',26124),
(12589,'enUS','%s looks like he\'d rather be anywhere else but here.','',26124),
(12590,'enUS','%s taps his foot impatiently.','',26124),
(12591,'enUS','%s glares at the guards.','',26124),
(12592,'enUS','%s sighs in apparent frustration.','',26124),
(12593,'enUS','%s peers inside the tower and then clenches his jaw.','',26124),
(12594,'enUS','Why doesn\'t Kaendris move against Dar\'Khan yet?  What is it we\'re waiting for?','',26124),
(12595,'enUS','','Calm yourself, Idonis.  Brash actions will get us nowhere!  Take a break, tap into some mana crystals.  You\'ll feel better.',26124),
(12596,'enUS','','He\'s got his reasons, Idonis.  He thinks the Farstriders have uncovered something.',26124),
(12597,'enUS','','We must remain focused on our work.  Once the sanctum starts producing at full capacity, Silvermoon will be forced to send help.  Functioning arcane sanctums are in short supply.',26124),
(12598,'enUS','I deal in comfort... Soothe your savage impulse, $r. My inn is your home... ','',26124),
(12599,'enUS','A fine offer, Floyd. I wish to make Hellfire Peninsula my home.','A fine offer, Floyd. I wish to make Hellfire Peninsula my home.',26124),
(12601,'enUS','Farstrider Dusking, what business have you to report?','',26124),
(12602,'enUS','Anything new, Dusking?','',26124),
(12603,'enUS','At ease, Farstrider Dusking. What news do you have for me?','',26124),
(12604,'enUS','Out with it, Farstrider! What news do you bring?','',26124),
(12605,'enUS','','Sir, Farstrider Solanna informs me that attacks on Zeb\'Tela and Zeb\'Nowa are underway. She was able to recruit a promising, young candidate to help with the situation. Also, the apothecary upstairs has made mention of a solution he believes he has to also help with the trolls.',26124),
(12606,'enUS','','%s fidgets and looks away from Captain Helios.',26124),
(12607,'enUS','Is that all, Farstrider?','',26124),
(12608,'enUS','','%s looks down at her feet.',26124),
(12609,'enUS','','No, sir. A signed letter from the High Executor has come in from Tranquillien. He\'s requesting that we pull all Farstrider forces from the eastern border and the trolls. He wants us to prepare to deploy to Andilien Estate as a staging area for an assault on Deatholme, sir.',26124),
(12610,'enUS','','No, Captain. Another signed letter has arrived by messenger from Tranquillien. It\'s signed again by High Executor Mavren. He wants to know why we haven\'t begun pulling the Farstriders from their missions against the Shadowpine trolls as he previously ordered, sir.',26124),
(12611,'enUS','','Sir, no, sir! Another dispatch has arrived from Tranquillien. It\'s High Executor Mavren again, captain. This time the language in the letter was very \'colorful\'. He reiterates his request that we marshal the Farstriders in support of the efforts against Deatholme, and suggests that you should send a runner north to Farstrider Retreat in Eversong Woods and muster their forces as well.',26124),
(12612,'enUS','What! If I\'ve told him once, I\'ve told him a thousand times! I do not take orders from him, or any of the forsaken! Send a letter to Dame Auriferous letting her know of the situation. Perhaps she will let him know how things work around here. Thank you for letting me know, Dusking. Dismissed.','',26124),
(12613,'enUS','I am growing tired of this High Executor Mavren! We dare not pull the Farstriders off of the eastern border and he knows it! He also knows that Dame Auriferous is in full agreement with me on this matter. Until she says otherwise, we stay put. That\'s all, farstrider, dismissed.','',26124),
(12614,'enUS','I\'m not pulling anyone from anything! He can send all of the letters that he wants. I\'m fully aware of his \'strategic\' plan, and he knows that the Dame and I are in full agreement with what the Farstriders need to be doing. Once the Shadowpine trolls have been dealt with then, and only then, will we divert our attentions to Deatholme. I know that the scourge are the greater threat, but Tranquillien is going to have to hold them off for now. It would be suicide to ignore the trolls! Dismissed, Dusking.','',26124),
(12615,'enUS','','As you say, sir!',26124),
(12616,'enUS','','Hello, $c. If you haven\'t already, you really should speak with Farstrider Solanna.',26124),
(12617,'enUS','So there we were - me and the battalion, doing a routine recon down the bone road. We\'d sent the scout up ahead to look around in case anything dangerous come up.','',26124),
(12618,'enUS','Sure enough, scout came runnin\' back, talkin\' bout some orcs down the path. They hadn\'t seen us yet so we figured we\'d go get acquainted.','',26124),
(12619,'enUS','What kinda orcs, chief?','',26124),
(12620,'enUS','','Greetings, $n. ',26124),
(12621,'enUS','','Hi, I\'m a newb.',26124),
(12622,'enUS','','I see you did it with your pants down and your hammer in your hand.',26124),
(12623,'enUS','What further information do you have?','What further information do you have?',26124),
(12624,'enUS','','You look like just the Warlock I need! The evil goblin chieftain Snarl must be defeated.',26124),
(12625,'enUS','Big red suckers! Bigger than any orc I\'d ever seen. Muscles out to here, tusks out to here... ','',26124),
(12626,'enUS','You mean...','',26124),
(12627,'enUS','%s nods.','',26124),
(12628,'enUS','Fel orcs...','',26124),
(12629,'enUS','Show me the lobsters!','Show me the lobsters!',26124),
(12630,'enUS','I desire training.','I desire training.',26124),
(12631,'enUS','I wish to browse your wares.','I wish to browse your wares.',26124),
(12632,'enUS','I wish to make Designer Island my home.','I wish to make Designer Island my home.',26124),
(12633,'enUS','I wish to stable my pet.','I wish to stable my pet.',26124),
(12634,'enUS','','Die, Warlock scum!',26124),
(12635,'enUS','But how, chief? I thought the curse was lifted...\n','',26124),
(12636,'enUS','I dunno, grunt. I just - don\'t - know...','',26124),
(12637,'enUS','But that\'s not the worst of it. Before I could pull us back, a group of \'em spotted us and attacked.','',26124),
(12638,'enUS','Lost some of my best soldiers that day...','Lost some of my best soldiers that day...',26124),
(12639,'enUS','If you have lost a piece of your Zandalarian armor, I may be able to help.','',26124),
(12640,'enUS','Jin\'rokh, I fear I\'ve lost my Zandalar Vindicator\'s Breastplate. Can you supply me with a replacement?','Jin\'rokh, I fear I\'ve lost my Zandalar Vindicator\'s Breastplate. Can you supply me with a replacement?',26124),
(12641,'enUS','Jin\'rokh, I need assistance in recovering a piece of my Vindicator\'s Battlegear.','Jin\'rokh, I need assistance in recovering a piece of my Vindicator\'s Battlegear.',26124),
(12642,'enUS','I think I\'ve lost my  Zandalar Vindicator\'s Belt. Can you help?','I think I\'ve lost my  Zandalar Vindicator\'s Belt. Can you help?',26124),
(12643,'enUS','Jin\'rokh, my Zandalar Vindicator\'s Armguards have gone missing. Do you have a spare set?','Jin\'rokh, my Zandalar Vindicator\'s Armguards have gone missing. Do you have a spare set?',26124),
(12644,'enUS','Jin\'rokh, I fear I\'ve lost my Zandalar Freethinker\'s Breastplate. Can you supply me with a replacement?','Jin\'rokh, I fear I\'ve lost my Zandalar Freethinker\'s Breastplate. Can you supply me with a replacement?',26124),
(12645,'enUS','Jin\'rokh, I have lost my Zandalar Freethinker\'s Belt. Can you help?','Jin\'rokh, I have lost my Zandalar Freethinker\'s Belt. Can you help?',26124),
(12646,'enUS','Jin\'rokh, I am missing my Zandalar Freethinker\'s Armguards. Can you replace them?','Jin\'rokh, I am missing my Zandalar Freethinker\'s Armguards. Can you replace them?',26124),
(12647,'enUS','Jin\'rokh, I need assistance in recovering a piece of my Freethinker\'s Armor.','Jin\'rokh, I need assistance in recovering a piece of my Freethinker\'s Armor.',26124),
(12648,'enUS','','',26124),
(12649,'enUS','Falthir, I need assistance in recovering a piece of my Madcap\'s Outfit.','Falthir, I need assistance in recovering a piece of my Madcap\'s Outfit.',26124),
(12652,'enUS','If you have lost a piece of your Zandalarian armor, I may be able to help.','',26124),
(12653,'enUS','Falthir, I need assistance in replacing a piece of my Predator\'s Armor.','Falthir, I need assistance in replacing a piece of my Predator\'s Armor.',26124),
(12654,'enUS','Get in there and help those worthless fools out.','',26124),
(12655,'enUS','I\'ve lost my Zandalar Madcap\'s Tunic and require a new one, Falthir.','I\'ve lost my Zandalar Madcap\'s Tunic and require a new one, Falthir.',26124),
(12656,'enUS','Falthir, I have lost my Zandalar Madcap\'s Mantle. Do you have a replacement?','Falthir, I have lost my Zandalar Madcap\'s Mantle. Do you have a replacement?',26124),
(12657,'enUS','I seem to have misplaced my Zandalar Madap\'s Bracers. Can you help?','I seem to have misplaced my Zandalar Madap\'s Bracers. Can you help?',26124),
(12658,'enUS','Falthir, I have lost my Zandalar Predator\'s Mantle and need a replacement.','Falthir, I have lost my Zandalar Predator\'s Mantle and need a replacement.',26124),
(12659,'enUS','My Zandalar Predator\'s Belt has gone missing. Can you help, Falthir?','My Zandalar Predator\'s Belt has gone missing. Can you help, Falthir?',26124),
(12660,'enUS','Falthir, I no longer have my Zandalar Predator\'s Bracers. Can you provide a new pair?','Falthir, I no longer have my Zandalar Predator\'s Bracers. Can you provide a new pair?',26124),
(12661,'enUS','I need help recovering a missing piece of my Haruspex\'s Garb, Maywiki.','I need help recovering a missing piece of my Haruspex\'s Garb, Maywiki.',26124),
(12662,'enUS','','If you have lost a piece of your Zandalarian armor, I may be able to help.',26124),
(12663,'enUS','I am missing a piece of my Augur\'s Regalia and I need a replacement.','I am missing a piece of my Augur\'s Regalia and I need a replacement.',26124),
(12664,'enUS','Maywiki, I\'ve lost my Zandalar Augur\'s Hauberk and need a new one.','Maywiki, I\'ve lost my Zandalar Augur\'s Hauberk and need a new one.',26124),
(12665,'enUS','Maywiki, a dastardly little gnome made off with my Zandalar Augur\'s Belt. Can you provide a replacement?','Maywiki, a dastardly little gnome made off with my Zandalar Augur\'s Belt. Can you provide a replacement?',26124),
(12666,'enUS','I have misplaced my Zandalar Augur\'s Bracers and require another pair.','I have misplaced my Zandalar Augur\'s Bracers and require another pair.',26124),
(12667,'enUS','I have lost my Zandalar Haruspex\'s Tunic, Maywiki. Do you have a replacement?','I have lost my Zandalar Haruspex\'s Tunic, Maywiki. Do you have a replacement?',26124),
(12668,'enUS','Maywiki, I no longer have my Zandalar Haruspex\'s Belt. Can you help?','Maywiki, I no longer have my Zandalar Haruspex\'s Belt. Can you help?',26124),
(12669,'enUS','I\'ve misplaced my Zandalar Haruspex\'s Bracers and require another pair.','I\'ve misplaced my Zandalar Haruspex\'s Bracers and require another pair.',26124),
(12670,'enUS','I need assistance in recovering a piece of my Confessor\'s Raiment, Al\'tabim.','I need assistance in recovering a piece of my Confessor\'s Raiment, Al\'tabim.',26124),
(12671,'enUS','If you have lost a piece of your Zandalarian armor, I may be able to help you.','',26124),
(12672,'enUS','I require assistance in recovering a piece of my Illusionist\'s Attire, Al\'tabim.','I require assistance in recovering a piece of my Illusionist\'s Attire, Al\'tabim.',26124),
(12673,'enUS','I require assistance in recovering a piece of my Demoniac\'s Threads, Al\'tabim.','I require assistance in recovering a piece of my Demoniac\'s Threads, Al\'tabim.',26124),
(12674,'enUS','I have lost my Confessor\'s Mantle and require a replacement, Al\'tabim.','I have lost my Confessor\'s Mantle and require a replacement, Al\'tabim.',26124),
(12675,'enUS','I no longer possess my Zandalar Confessor\'s Bindings. Can you provide a replacement?','I no longer possess my Zandalar Confessor\'s Bindings. Can you provide a replacement?',26124),
(12676,'enUS','Al\'tabim, my Zandalar Confessor\'s Wraps have gone missing. Can you replace them?','Al\'tabim, my Zandalar Confessor\'s Wraps have gone missing. Can you replace them?',26124),
(12677,'enUS','I have lost my Zandalar Illusionist\'s Robe and need a new one, Al\'tabim.','I have lost my Zandalar Illusionist\'s Robe and need a new one, Al\'tabim.',26124),
(12678,'enUS','Al\'tabim, I seem to have misplaced my Zandalar Illusionist\'s Mantle. Can you supply me with a replacement?','Al\'tabim, I seem to have misplaced my Zandalar Illusionist\'s Mantle. Can you supply me with a replacement?',26124),
(12679,'enUS','I no longer have my Zandalar Illusionist\'s Wraps and require a new pair.','I no longer have my Zandalar Illusionist\'s Wraps and require a new pair.',26124),
(12680,'enUS','I no longer have my Zandalar Demoniac\'s Robe. Can you provide a replacement?','I no longer have my Zandalar Demoniac\'s Robe. Can you provide a replacement?',26124),
(12681,'enUS','Al\'tabim, I have lost my Zandalar Demoniac\'s Mantle. Can you help?','Al\'tabim, I have lost my Zandalar Demoniac\'s Mantle. Can you help?',26124),
(12682,'enUS','My Zandalar Demoniac\'s Wraps have gone missing. Can you provide me with another set?','My Zandalar Demoniac\'s Wraps have gone missing. Can you provide me with another set?',26124),
(12683,'enUS','We\'ll drink their blood and feast on their bones!','',26124),
(12684,'enUS','Serve the Fel Horde!','',26124),
(12685,'enUS','Power to the Fel Horde!','',26124),
(12686,'enUS','Break their bones!','',26124),
(12687,'enUS','Know your master, you worthless mutts!','',26124),
(12688,'enUS','We shall crush these feeble beings!','',26124),
(12689,'enUS','Who wants to be the first to spill their blood?','',26124),
(12690,'enUS','','%s shimmers and becomes intangible!',26124),
(12691,'enUS','As if you weaklings pose any threat to us. We will devour you.','',26124),
(12692,'enUS','We will destroy you.','',26124),
(12693,'enUS','I have lost my Mace of Unending Life. Are you able to replace it for me?','I have lost my Mace of Unending Life. Are you able to replace it for me?',26124),
(12694,'enUS','I have lost my Scythe of the Unseen Path. Are you able to replace it for me?','I have lost my Scythe of the Unseen Path. Are you able to replace it for me?',26124),
(12695,'enUS','I have lost my Blade of Vaulted Secrets. Are you able to replace it for me?','I have lost my Blade of Vaulted Secrets. Are you able to replace it for me?',26124),
(12696,'enUS','I have lost my Blade of Eternal Justice. Are you able to replace it for me?','I have lost my Blade of Eternal Justice. Are you able to replace it for me?',26124),
(12697,'enUS','I have lost my Gavel of Infinite Wisdom. Are you able to replace it for me?','I have lost my Gavel of Infinite Wisdom. Are you able to replace it for me?',26124),
(12698,'enUS','Brothers and sisters, I have been to the promised land. I have tasted in the sublime energy. I have felt bliss - bliss so engrossing and all encompassing that I was left wondering if I had stumbled upon the dreams of gods.','',26124),
(12699,'enUS','I have lost my Dagger of Veiled Shadows. Are you able to replace it for me?','I have lost my Dagger of Veiled Shadows. Are you able to replace it for me?',26124),
(12700,'enUS','Tell us more, Martik. What is it? What does it feel like?','Tell us more, Martik. What is it? What does it feel like?',26124),
(12701,'enUS','I have lost my Hammer of the Gathering Storm. Are you able to replace it for me?','I have lost my Hammer of the Gathering Storm. Are you able to replace it for me?',26124),
(12702,'enUS','I have lost my Kris of Unspoken Names. Are you able to replace it for me?','I have lost my Kris of Unspoken Names. Are you able to replace it for me?',26124),
(12703,'enUS','In paradise, you merely reach out and take from the Nether.','',26124),
(12704,'enUS','But how?','But how?',26124),
(12705,'enUS','I have lost my Sickle of Unyielding Strength. Are you able to replace it for me?','I have lost my Sickle of Unyielding Strength. Are you able to replace it for me?',26124),
(12706,'enUS','From the very air! Tendrils of arcane energy light up the obsidian sky as plumes of raw magic rise up from fissures in the land. Kneel and drink from the fissure as you do from a stream or well. Pluck a tendril from the heavens as if it were an apple hanging from a branch.','From the very air! Tendrils of arcane energy light up the obsidian sky as plumes of raw magic rise up from fissures in the land. Kneel and drink from the fissure as you do from a stream or well. Pluck a tendril from the heavens as if it were an apple hanging from a branch.',26124),
(12707,'enUS','%s gasps.','%s gasps.',26124),
(12708,'enUS','I have lost my Cloak of Unending Life. Are you able to replace it for me?','I have lost my Cloak of Unending Life. Are you able to replace it for me?',26124),
(12709,'enUS','%s smiles.','%s smiles.',26124),
(12710,'enUS','I have lost my Cloak of the Unseen Path. Are you able to replace it for me?','I have lost my Cloak of the Unseen Path. Are you able to replace it for me?',26124),
(12711,'enUS','I have lost my Drape of Vaulted Secrets. Are you able to replace it for me?','I have lost my Drape of Vaulted Secrets. Are you able to replace it for me?',26124),
(12712,'enUS','I have lost my Cape of Eternal Justice. Are you able to replace it for me?','I have lost my Cape of Eternal Justice. Are you able to replace it for me?',26124),
(12713,'enUS','I have lost my Shroud of Infinite Wisdom. Are you able to replace it for me?','I have lost my Shroud of Infinite Wisdom. Are you able to replace it for me?',26124),
(12714,'enUS','I have lost my Cloak of Veiled Shadows. Are you able to replace it for me?','I have lost my Cloak of Veiled Shadows. Are you able to replace it for me?',26124),
(12715,'enUS','I have lost my Cloak of the Gathering Storm. Are you able to replace it for me?','I have lost my Cloak of the Gathering Storm. Are you able to replace it for me?',26124),
(12716,'enUS','I have lost my Shroud of Unspoken Names. Are you able to replace it for me?','I have lost my Shroud of Unspoken Names. Are you able to replace it for me?',26124),
(12717,'enUS','I have lost my Drape of Unyielding Strength. Are you able to replace it for me?','I have lost my Drape of Unyielding Strength. Are you able to replace it for me?',26124),
(12718,'enUS','I have lost my Band of Unending Life. Are you able to replace it for me?','I have lost my Band of Unending Life. Are you able to replace it for me?',26124),
(12719,'enUS','I have lost my Signet of the Unseen Path. Are you able to replace it for me?','I have lost my Signet of the Unseen Path. Are you able to replace it for me?',26124),
(12720,'enUS','I have lost my Band of Vaulted Secrets. Are you able to replace it for me?','I have lost my Band of Vaulted Secrets. Are you able to replace it for me?',26124),
(12721,'enUS','I have lost my Ring of Eternal Justice. Are you able to replace it for me?','I have lost my Ring of Eternal Justice. Are you able to replace it for me?',26124),
(12722,'enUS','I have lost my Ring of Infinite Wisdom. Are you able to replace it for me?','I have lost my Ring of Infinite Wisdom. Are you able to replace it for me?',26124),
(12723,'enUS','I have lost my Band of Veiled Shadows. Are you able to replace it for me?','I have lost my Band of Veiled Shadows. Are you able to replace it for me?',26124),
(12724,'enUS','I have lost my Ring of the Gathering Storm. Are you able to replace it for me?','I have lost my Ring of the Gathering Storm. Are you able to replace it for me?',26124),
(12725,'enUS','I have lost my Ring of Unspoken Names. Are you able to replace it for me?','I have lost my Ring of Unspoken Names. Are you able to replace it for me?',26124),
(12726,'enUS','Where... where am I?','',26124),
(12727,'enUS','I have lost my Signet of Unyielding Strength. Are you able to replace it for me?','I have lost my Signet of Unyielding Strength. Are you able to replace it for me?',26124),
(12728,'enUS','','You\'re not going anywhere just yet, handsome.  Not until you regain your strength.',26124),
(12729,'enUS','Wake up you lazy sod and help out.','',26124),
(12730,'enUS','Thank you very much! I don\'t know what I would have done if you weren\'t here!','',26124),
(12731,'enUS','I am most grateful for your help, $c!','',26124),
(12732,'enUS','','',26124),
(12733,'enUS','So cold!  There is no heat left in this world.','So cold!  There is no heat left in this world.',26124),
(12734,'enUS','The barrier did not protect us.  How could this have happened?','The barrier did not protect us.  How could this have happened?',26124),
(12736,'enUS','Why do I remain?  This torment must end.','Why do I remain?  This torment must end.',26124),
(12737,'enUS','Here they come again!  Stand ready!','',26124),
(12738,'enUS','Ah, you\'re the one who found the letter. Thank you for the... news, I suppose, about my family. You\'re welcome to what food and drink I can offer.','Ah, you\'re the one who found the letter. Thank you for the... news, I suppose, about my family. You\'re welcome to what food and drink I can offer.',26124),
(12739,'enUS','','Ah, you\'re the one who found the letter. Thank you for the... news, I suppose, about my family. You\'re welcome to what food and drink I can offer.',26124),
(12740,'enUS','I suppose you want something for what you did, is that it? Reminding me of my life? Pfagh. Take what I have and leave me alone.','I suppose you want something for what you did, is that it? Reminding me of my life? Pfagh. Take what I have and leave me alone.',26124),
(12741,'enUS','Another batch of Scourge has been destroyed!','',26124),
(12742,'enUS','That\'s done it!  Hopefully Rommath will send reinforcements soon.','',26124),
(12743,'enUS','%s skin hardens!','',26124),
(12744,'enUS','OY! Wait in line, would ya? Outland food doesn\'t agree with me at all.','OY! Wait in line, would ya? Outland food doesn\'t agree with me at all.',26124),
(12745,'enUS','What\'s goin\' on in there?? For the love of the LIGHT, hurry it up!','What\'s goin\' on in there?? For the love of the LIGHT, hurry it up!',26124),
(12746,'enUS','Do ya want me to call a medic? Maybe a priest? It\'s been over an hour, mate!','Do ya want me to call a medic? Maybe a priest? It\'s been over an hour, mate!',26124),
(12747,'enUS','OY! You in there, this is official Honor Hold business yer holdin\' up!','OY! You in there, this is official Honor Hold business yer holdin\' up!',26124),
(12748,'enUS','So help me, I\'m gonna count to ten and if yer not outta there by the time I reach 10, I\'m comin\' in!','So help me, I\'m gonna count to ten and if yer not outta there by the time I reach 10, I\'m comin\' in!',26124),
(12749,'enUS','Sid\'s the name. It\'s nice to see some new faces around here. What can I do you for?','',26124),
(12750,'enUS','I would like to take a look at your wares, Sid.','I would like to take a look at your wares, Sid.',26124),
(12751,'enUS','I wish to make Honor Hold my home, Sid.','I wish to make Honor Hold my home, Sid.',26124),
(12752,'enUS','And who do we have here?  No doubt th... crzzzk ...ade this communication possible?  I give you greetings fro... psshzzzk... Azure Watch.','',26124),
(12753,'enUS','Judging by your signal, we put you... ust southeast of the larger part of the island we crashed onto.  Cross the Crystalbrook River to ge... kshhhhk zzzt. Sorry, there\'s a lot of stat...','',26124),
(12754,'enUS','What now, Danath? Can you not see that I am inundated with work as is?','',26124),
(12755,'enUS','That is precisely why I have called for you old friend. We have much to discuss.','',26124),
(12756,'enUS','Though we\'ve arrived at the promised land, $n, much work remains to be done.  Our people won\'t reach Kael\'thas if we lunge desperately across Outland.$B$BSafe routes must be found, resources must be secured and our enemies must be avoided or destroyed.','',26124),
(12757,'enUS','What manner of fool opens the very thing we were sent to close?','',26124),
(12758,'enUS','I have a good mind to tear that portal down myself! This is outrageous!','',26124),
(12759,'enUS','And have you heard? Have you heard the preposterous claims? Alliance and Horde supporting peace? Why the very thought of such things makes my blood boil!','And have you heard? Have you heard the preposterous claims? Alliance and Horde supporting peace? Why the very thought of such things makes my blood boil!',26124),
(12760,'enUS','Twenty years lost! Twenty! I won\'t stand for this! No, no, no... ','Twenty years lost! Twenty! I won\'t stand for this! No, no, no... ',26124),
(12761,'enUS','To trust an orc? Even if it is the progeny of Durotan himself! This is madness!','',26124),
(12762,'enUS','Never! I\'ll never abide by their will! I\'d sooner be dead.','',26124),
(12763,'enUS','I take my leave now, Commander. Good day!','',26124),
(12764,'enUS','A mailbox? Well is that not the salt on the wounds! Twenty years cut-off from the world and now a mailbox! WONDERFUL!','',26124),
(12765,'enUS','Sid! Ale, NOW!','',26124),
(12766,'enUS','Comin\' right up, yer highness! Is there anythin\' else you\'ll be needin\'? Perhaps yer hat cleaned or yer nails trimmed?','',26124),
(12767,'enUS','','You\'ll not take me alive, scum!',26124),
(12768,'enUS','Don\'t you start with me, Sid! Have it sent to my quarters in the tower instead! Your inn has become a zoo!','',26124),
(12769,'enUS','What I wouldn\'t give for a healing crystal right about now!','',26124),
(12770,'enUS','Thank you for delivering that list!  My leg is almost recovered enough that I\'ll be able to walk back to the crash site.','',26124),
(12771,'enUS','','How are we ever going to get out of here?',26124),
(12772,'enUS','','Thank you for taking care of the lake, the lashers and the owlkin, $c.',26124),
(12773,'enUS','','None will question your actions, $c.  You did what had to be done.',26124),
(12774,'enUS','It is good to see you alive and well, $n!','',26124),
(12775,'enUS','Thank you again for replenishing our healing crystals.  I hear that you\'re helping out all over the place.  Keep up the good work!','',26124),
(12776,'enUS','I appreciate the company, $n.','',26124),
(12777,'enUS','$n, what are you still doing here?  Have you spoken with Proenitus down at the crash site yet?','',26124),
(12778,'enUS','Mirren and I are two of the very best hunters on either side of the Dark Portal.  Stick around, you might learn a thing or two.','',26124),
(12779,'enUS','I hope yer not here for our ale.  We\'re not sharing and that\'s final!$B$BIt\'s not our fault no one had the good sense to bring beer to Outland but us.','',26124),
(12780,'enUS','%s bursts, showering the area with arcane residue!','',26124),
(12781,'enUS','%s bristles with energy!','',26124),
(12782,'enUS','','Here\'s to hoping not all of Outland is as barren as this region.  This is quite a change from the green grasslands and forests of Eversong.',26124),
(12783,'enUS','There exist in Outland demonic presences much more powerful than anything we\'d ever seen in the old world.$B$BGreat power shall come to those who do not shy away from it, but learn to harness and master its strength.','',26124),
(12784,'enUS','I was born here, $r. This is my world - all that I know... As a boy, my mother and father would regale me with tales of your world and the splendor it held. How I longed to leave this place.$B$BAlas, fate is a cruel mistress. My mother and father have long since passed, buried in this very graveyard. I remain to uphold their honor and the honor of my family - the Sons of Lothar.','',26124),
(12785,'enUS','I do not think enough attention is being paid to those trolls.  They could swarm in here anytime.','',26124),
(12786,'enUS','Does anyone need supplies to hunt down the trolls?  Any troll will do.','',26124),
(12787,'enUS','Why do we ally with filthy stinking trolls?  The only good troll is a dead troll.','',26124),
(12788,'enUS','How may I serve?','How may I serve?',26124),
(12789,'enUS','Be gone filthy creature!  Why anyone would tolerate your filth is beyond me.','',26124),
(12790,'enUS','May I see your wares?','May I see your wares?',26124),
(12791,'enUS','Outland just oozes with magical energy, it\'s in the very air.  Can you feel it, $n?  I can\'t think of a place better suited to our race.  Soon the sin\'dorei shall have a new land to call our own!','',26124),
(12792,'enUS','','My husband\'s been missing for days.  We went on this pilgrimage together; we were supposed to finish it together.$B$BAll this worry has gotten me tapping into mana crystals more often than I really should.',26124),
(12793,'enUS','','Dragonhawks, if raised properly, are really quite tame.  Don\'t you think that is fascinating?  To be so friendly and companionable if raised right and so vicious and deadly in the wild...I just love them so much.',26124),
(12794,'enUS','Don\'t... worry... about me...','',26124),
(12795,'enUS','%s grunts in pain as he applies a splint to his injured leg.','',26124),
(12796,'enUS','','I really don\'t think our situation is so bad.  I am certain it will all be rectified soon and the Sunwell\'s power will be restored.  It just can\'t possibly be as bad as everyone is making it out to be.',26124),
(12797,'enUS','Befriending the Sunstriders has paid off; I get to conduct research with subjects I can only find in Outland and they get... my charming personality and rugged good looks.','',26124),
(12798,'enUS','Where do you want these bottles?','Where do you want these bottles?',26124),
(12799,'enUS','Got another shipment for you, Sid.','Got another shipment for you, Sid.',26124),
(12800,'enUS','Craziest thing - No matter how many bottles I take from the stockpile, the quantity on hand never decreases. It\'s like I\'m stuck in some endless loop of actions...','Craziest thing - No matter how many bottles I take from the stockpile, the quantity on hand never decreases. It\'s like I\'m stuck in some endless loop of actions...',26124),
(12801,'enUS','Bless yer heart, soldier! Just put \'em in the back room.','',26124),
(12802,'enUS','Just leave \'em in the cellar.','',26124),
(12803,'enUS','%s nods.','%s nods.',26124),
(12804,'enUS','I\'d like to fly to Thunder Bluff.','I\'d like to fly to Thunder Bluff.',26124),
(12805,'enUS','I was only an infant when my father was deployed to this wasteland. All that I have ever known of him is what others have told me.$B$BDo your dreams change, $n? Mine do not. I have one dream: A crimson skyline envelops me as Legion, numbering beyond comprehension, battle in the distance. I kneel before the body of a man, presumably my father, and weep. As he is gasping for air, his body wholly crushed, he whispers something. Despite every effort, I am unable to hear what he is trying to tell me.','',26124),
(12806,'enUS','A gloom shrouds our lands, young $c.  Will you take up arms to face this flying death?','',26124),
(12807,'enUS','How long will the invasion last?','How long will the invasion last?',26124),
(12808,'enUS','Holiday - Scourge Invasion, mystic - how long, Tier 0','',26124),
(12809,'enUS','Holiday - Scourge Invasion, mystic - how long, Tier 1','',26124),
(12810,'enUS','Holiday - Scourge Invasion, mystic - how long, Tier 2','',26124),
(12811,'enUS','As I live and breathe! \"Little\" Arator? Is that you?','',26124),
(12812,'enUS','Aye, Commander; but I am little no more. I have come to find my father. Have you any news as to his whereabouts? I know that he still lives. I have seen it in my dreams...','',26124),
(12813,'enUS','%s looks at Arator grimly.','',26124),
(12814,'enUS','I am afraid that I do not, Arator. I have not seen or heard from your father in 15 years. We had long since presumed him dead. But know this: I did all that was in my power to try and find him. From the bounds of Hellfire to the ravages of Nagrand, we searched... All for naught. If I could give my own life to bring Turalyon back, I would do so a thousand times over. I... I am sorry.','',26124),
(12815,'enUS','As long as he remains unfound, I will search. I know that he lives. And I know that I must find him. I am thankful for what you have done, Commander. As my father called upon you, a brother in arms, know that you may call upon me. I am at your service, my Lord.','',26124),
(12816,'enUS','Soldier! Front and center!','',26124),
(12817,'enUS','SIR! YES, SIR! Reporting for duty, sir!','SIR! YES, SIR! Reporting for duty, sir!',26124),
(12818,'enUS','At ease, Private. I have a mission for you. The last messenger I sent to Nethergarde didn\'t make it. We found his entrails scattered about the bone road a few hours ago. We suspect it may have been Legion or fel orc, maybe even Horde...','',26124),
(12819,'enUS','Sir, yes sir! Private will do their best to not die, sir!','Sir, yes sir! Private will do their best to not die, sir!',26124),
(12820,'enUS','I need this message delivered to Watch Commander Netherwane at Nethergarde Keep. There\'s a commendation in it for you if you make it... Your horse is waiting at the stables. Dismissed!','',26124),
(12821,'enUS','ONWARD!','ONWARD!',26124),
(12822,'enUS','Protect the innocent!','',26124),
(12823,'enUS','Uphold the law!','',26124),
(12824,'enUS','Serve the public trust!','',26124),
(12825,'enUS','Dead!  They are all dead! At least I don\'t have to pay wages.','',26124),
(12826,'enUS','Wait \'til Nazgrel hears about this! It\'ll be my head! My head I say!','',26124),
(12827,'enUS','What am I to do?  My precious mine...','',26124),
(12828,'enUS','You will rue the day that you killed my crew! Rue it, I say!','',26124),
(12829,'enUS','','Marketing - iCoke Redemption Greeting (S.H.E. giftbox)',26124),
(12830,'enUS','Tell me about the iCoke gift box promotion.','Tell me about the iCoke gift box promotion.',26124),
(12831,'enUS','','iCoke - Description (S.H.E. giftbox)',26124),
(12832,'enUS','I might just have to go hunting for that Wretched beast now that there\'s a bounty on his head.','',26124),
(12833,'enUS','Tell us!  Where does your leader hide?','',26124),
(12834,'enUS','You\'re not getting anything until you speak, scum!','',26124),
(12835,'enUS','Please!  I must feed on something soon... A mana crystal.... a shard... anything!  The pain is unbearable!','',26124),
(12836,'enUS','Protect the Warchief at all costs!','Protect the Warchief at all costs!',26124),
(12837,'enUS','Death to the interlopers!','Death to the interlopers!',26124),
(12838,'enUS','For Spinebreaker!','For Spinebreaker!',26124),
(12839,'enUS','Your bones will be devoured!','Your bones will be devoured!',26124),
(12840,'enUS','You think I\'m being cruel to this worm?$B$BThey\'ve killed two of my men this month!  We\'re too kind to this Wretched scum.','',26124),
(12842,'enUS','','Welcome to Fairbreeze Village.  Silvermoon\'s all but given up on us, but we refuse to leave.  This is our home.',26124),
(12844,'enUS','Kill them all!','',26124),
(12845,'enUS','By the seven Ata\'mal crystals!  Others have survived the crash!  Zhanaa, is that you?  It is so good to see you again!','',26124),
(12846,'enUS','','This is great news!  Your efforts have indeed saved us, $n!',26124),
(12847,'enUS','','My job consists of one task and one task only: ensuring that the West Sanctum runs smoothly.$B$BYou\'ll have to excuse my temper but, as you can see, the situation here is a bit out of hand.',26124),
(12848,'enUS','','With the Emperors slain, the magical protection blocking teleportation within the temple has been greatly weakened. If you desire, I am able to translocate you to the Emperors\' lair.',26124),
(12849,'enUS','Teleport me to the lair of the Twin Emperors, please.','Teleport me to the lair of the Twin Emperors, please.',26124),
(12850,'enUS','','With Ouro slain the way is clear to the final chamber. I am able to transport you there, if you desire.',26124),
(12851,'enUS','Please teleport me to the final chamber.','Please teleport me to the final chamber.',26124),
(12852,'enUS','','Your old lives, your mortal desires mean nothing... you are acolytes of the master now, and you will serve the cause without question! The greatest glory is to die in the master\'s service!',26124),
(12853,'enUS','','The master will avenge me!!',26124),
(12854,'enUS','','You have failed!',26124),
(12855,'enUS','','Pathetic wretch!',26124),
(12856,'enUS','','Slay them in the master\'s name!',26124),
(12857,'enUS','','You cannot hide from me!',26124),
(12858,'enUS','','Kneel before me, worm!',26124),
(12859,'enUS','','Run while you still can!',26124),
(12860,'enUS','Enjoying the festival, $c?$b$bWhile the Flame Wardens tend to the fires of the present, I am more of a historian, keeping close the festivals past. I\'m also, of course, documenting this year\'s festivities. Things are going well thus far, don\'t you think?$b$bYou know, $n, there is power inherent in all festival fires burning throughout the holiday. We\'re taking care of ours, but I\'m certain there are sacred flames burning deep within our enemy\'s cities...','Enjoying the festival, $c?$b$bWhile the Flame Wardens tend to the fires of the present, I am more of a historian, keeping close the festivals past. I\'m also, of course, documenting this year\'s festivities. Things are going well thus far, don\'t you think?$b$bYou know, $n, there is power inherent in all festival fires burning throughout the holiday. We\'re taking care of ours, but I\'m certain there are sacred flames burning deep within our enemy\'s cities...',26124),
(12861,'enUS','','Slay them!  Don\'t let the Scourge scum defile our city!',26124),
(12862,'enUS','','The enemy approaches from the south.  Ready your weapons!',26124),
(12863,'enUS','','The undead are approaching.  Attack!',26124),
(12983,'enUS','','There, $n, I think I\'ve figured it out!',26124),
(12984,'enUS','Who dares violate the sanctity of my domain? Be warned: all who trespass here are doomed!','',26124),
(12985,'enUS','Fools! You think yourselves triumphant? You have only taken one step closer to the abyss!','',26124),
(12986,'enUS','I grow tired of these games. Proceed, and I will banish your souls to oblivion!','',26124),
(12987,'enUS','You have no idea what horrors lie ahead. You have seen nothing! The frozen heart of Naxxramas awaits you!','',26124),
(12988,'enUS','Soon we will eradicate the Alliance and Horde. Then the rest of Azeroth will fall before the might of my army.','',26124),
(12989,'enUS','Invaders... here?! DESTROY them, Kel\'Thuzad! Naxxramas must not fall!','',26124),
(12990,'enUS','Your forces are nearly marshaled to strike back against your enemies, my liege.','',26124),
(12991,'enUS','Yes, master. The time of their ultimate demise draws close.... What is this?','',26124),
(12992,'enUS','As you command, master!','',26124),
(12993,'enUS','Come, heroes... By the will of the Lich King, you shall be destroyed.','',26124),
(12994,'enUS','Very well. Warriors of the frozen wastes, rise up! I command you to fight, kill and die for your master! Let none survive!','',26124),
(12995,'enUS','Pray for mercy!','',26124),
(12996,'enUS','Scream your dying breath!','',26124),
(12997,'enUS','The end is upon you!','',26124),
(12998,'enUS','Master, I require aid!','',26124),
(12999,'enUS','Minions, servants, soldiers of the cold dark! Obey the call of Kel\'Thuzad!','',26124),
(13000,'enUS','Just a little taste...','',26124),
(13001,'enUS','%s rushes to the aid of Stalagg!','',26124),
(13002,'enUS','There is no way out.','',26124),
(13003,'enUS','Yes, run! It makes the blood pump faster!','',26124),
(13004,'enUS','Ahh... welcome to my parlor.','',26124),
(13005,'enUS','Shhh... it will all be over soon.','',26124),
(13006,'enUS','I hear little hearts beating. Yes... beating faster now... soon the beating will stop.','',26124),
(13007,'enUS','Where to go? What to do? So many choices that all end in pain, end in death.','',26124),
(13008,'enUS','Which one shall I eat first? So difficult to choose. They all smell so delicious...','',26124),
(13009,'enUS','Closer now. Tasty morsels. I\'ve been too long without food, without blood to drink.','',26124),
(13010,'enUS','','Defend yourself!',26124),
(13011,'enUS','','Touche...',26124),
(13012,'enUS','','Who\'s next?',26124),
(13013,'enUS','','Your life is mine!',26124),
(13014,'enUS','','Come, Zeliek, do not drive them out. Not before we\'ve had our fun!',26124),
(13015,'enUS','','I do hope they stay alive long enough for me to... introduce myself.',26124),
(13016,'enUS','','The first kill goes to me! Anyone care to wager?',26124),
(13017,'enUS','Your soul is bound to me, now!','',26124),
(13018,'enUS','There will be no escape!','',26124),
(13019,'enUS','Agghhhh! Do... not... rejoice! Your victory is a hollow one, for I shall return with powers beyond your imagining!','',26124),
(13020,'enUS','I will freeze the blood in your veins!','',26124),
(13021,'enUS','The dark void awaits you!','',26124),
(13022,'enUS','%s cackles maniacally.\n','',26124),
(13023,'enUS','Feed you to master!','',26124),
(13024,'enUS','No... more... Feugen.','',26124),
(13025,'enUS','Feugen make master happy.','',26124),
(13026,'enUS','I... am... undone.','',26124),
(13027,'enUS','Death is the only escape!','',26124),
(13028,'enUS','I have waited long enough. Now you face the harvester of souls.','',26124),
(13029,'enUS','Foolishly you have sought your own demise. Brazenly you have disregarded powers beyond your understanding. You have fought hard to invade the realm of the harvester. Now there is only one way out- to walk the lonely path of the damned.','',26124),
(13030,'enUS','Foolishly you have sought your own demise.','',26124),
(13031,'enUS','Brazenly you have disregarded powers beyond your understanding.','',26124),
(13032,'enUS','You have fought hard to invade the realm of the harvester.','',26124),
(13033,'enUS','Now there is only one way out- to walk the lonely path of the damned.','',26124),
(13034,'enUS','C\'mon an\' fight ye wee ninny!','',26124),
(13035,'enUS','What a bloody waste this is!','',26124),
(13036,'enUS','Next time, bring more friends!','',26124),
(13037,'enUS','I like my meat extra crispy!','',26124),
(13038,'enUS','To arms, ye roustabouts! We\'ve got company!','',26124),
(13039,'enUS','I\'ve heard about enough a\' yer snivelin\'! Shut yer flytrap before I shut it for ye\'!','',26124),
(13040,'enUS','I\'m gonna\' enjoy killin\' these slack-jawed daffodils!','',26124),
(13041,'enUS','You are mine now.','',26124),
(13042,'enUS','I see you...','',26124),
(13043,'enUS','You... are next.','',26124),
(13044,'enUS','%s takes his last breath.','',26124),
(13045,'enUS','Close your eyes. Sleep.','',26124),
(13046,'enUS','The races of the world will perish. It is only a matter of time.','',26124),
(13047,'enUS','I see endless suffering. I see torment. I see rage. I see everything...','',26124),
(13048,'enUS','Soon the world will tremble.','',26124),
(13049,'enUS','The end is upon you.','',26124),
(13050,'enUS','Hungry worms will feast on your rotting flesh.','',26124),
(13051,'enUS','You seek death?','',26124),
(13052,'enUS','None shall pass!','',26124),
(13053,'enUS','Be still!','',26124),
(13054,'enUS','I... am... released... perhaps it\'s not too late to- No! I need... more... time...','',26124),
(13055,'enUS','You will find no peace in death.','',26124),
(13056,'enUS','The master\'s will is done.','',26124),
(13057,'enUS','Bow to the might of the Scourge!','',26124),
(13058,'enUS','Enough prattling. Let them come. We shall grind their bones to dust.','',26124),
(13059,'enUS','Conserve your anger. Harness your rage. You will all have outlets for your frustrations soon enough.','',26124),
(13060,'enUS','Life is meaningless. It is in death that we are truly tested.','',26124),
(13061,'enUS','Glory to the master!','',26124),
(13062,'enUS','Your life is forfeit!','',26124),
(13063,'enUS','Die, trespasser!','',26124),
(13064,'enUS','I will serve the master... in death!','',26124),
(13065,'enUS','My task is done!','',26124),
(13066,'enUS','Breathe no more!','',26124),
(13067,'enUS','Rise, my soldiers! Rise and fight once more!','',26124),
(13068,'enUS','Patchwerk want to play!','',26124),
(13069,'enUS','Kel\'thuzad make Patchwerk his avatar of war!','',26124),
(13070,'enUS','What... happen to-','',26124),
(13071,'enUS','No more play?','',26124),
(13072,'enUS','I\'m just getting warmed up!','',26124),
(13073,'enUS','Stand and fight!','',26124),
(13074,'enUS','Show me what you\'ve got!','',26124),
(13075,'enUS','Do as I taught you!','',26124),
(13076,'enUS','Show them no mercy!','',26124),
(13077,'enUS','You disappoint me, students!','',26124),
(13078,'enUS','The time for practice is over! Show me what you have learned!','',26124),
(13079,'enUS','An honorable... death.','',26124),
(13080,'enUS','Sweep the leg... Do you have a problem with that?','',26124),
(13081,'enUS','You should have stayed home.','',26124),
(13082,'enUS','%s lets loose a triumphant shout.','',26124),
(13083,'enUS','Stalagg crush you!','',26124),
(13084,'enUS','Master, save me!!','',26124),
(13085,'enUS','Stalagg kill!','',26124),
(13086,'enUS','Kill...','',26124),
(13087,'enUS','Eat... your... bones...','',26124),
(13088,'enUS','Break... you!!','',26124),
(13089,'enUS','Thank... you...','',26124),
(13090,'enUS','Now you feel pain...','',26124),
(13091,'enUS','You are too late!! I... must... obey!!','',26124),
(13092,'enUS','Hurry! Ple-e-ase hurry!!','',26124),
(13093,'enUS','Sto-o-op! Make it stop!!','',26124),
(13094,'enUS','Help me! Save me!','',26124),
(13095,'enUS','No-o-o-o!!','',26124),
(13096,'enUS','You... die now!!','',26124),
(13097,'enUS','Flee, before it\'s too late!','',26124),
(13098,'enUS','It is... as it should be. ','',26124),
(13099,'enUS','Forgive me.','',26124),
(13100,'enUS','I have no choice but to obey!','',26124),
(13101,'enUS','Invaders, cease this foolish venture at once! Turn away while you still can!','',26124),
(13102,'enUS','Perhaps they will come to their senses... and run away as fast as they can.','',26124),
(13103,'enUS','Do not continue! Turn back while there\'s still time!','',26124),
(13104,'enUS','Aurelon, some assistance please.','',26124),
(13105,'enUS','I could use some help over here if you please.','',26124),
(13106,'enUS','Paladin, perhaps you would lend a hand?  I just need another heal on that one.  Thank you.','',26124),
(13107,'enUS','Paladin Aurelon, if you have the mana to spare, could you help with that one, please?  Thank you.','',26124),
(13109,'enUS','Of course, Zalduun.','',26124),
(13110,'enUS','As you wish.','',26124),
(13111,'enUS','My meager healing powers are at your disposal, Zalduun.','',26124),
(13112,'enUS','As the Light wills.','',26124),
(13113,'enUS','Oh no!  I\'m losing this one!','',26124),
(13114,'enUS','NO!!!','',26124),
(13116,'enUS','%s bows his head in prayer.','',26124),
(13118,'enUS','','No...',26124),
(13119,'enUS','Enjoying the festival, $c? My wares can give an extra kick to your day. Nothing like warm food and drink!$b$bAnd if you haven\'t tried it yet, get a friend or two and celebrate around the ribbon pole; it\'s sure to lift your spirits!','Enjoying the festival, $c? My wares can give an extra kick to your day. Nothing like warm food and drink!$b$bAnd if you haven\'t tried it yet, get a friend or two and celebrate around the ribbon pole; it\'s sure to lift your spirits!',26124),
(13120,'enUS','Let me see your festival fare.','Let me see your festival fare.',26124),
(13121,'enUS','Can you feel it, pathetic creatures? The pall over this land is but a precursor. Soon your precious holdings will be in our grasp! You will fall before the might of the Lich King!','',26124),
(13122,'enUS','Despair, mortals! Your doom has come!','',26124),
(13123,'enUS','Let this gloom serve to remind you: the shadow of the Scourge is all-encompassing! There is no escape!','',26124),
(13124,'enUS','As you fall in battle, we grow in strength. There is only one inevitable outcome. Prepare for your end!','',26124),
(13125,'enUS','Forward, my minions! Forward! Let none stand in our way!','',26124),
(13126,'enUS','Cower before our might! Flee! There will be no victory for the living!','',26124),
(13127,'enUS','What manner of trap have we walked into?  Vindicators, ready your weapons!','',26124),
(13128,'enUS','You won\'t get away with this!','',26124),
(13129,'enUS','Show me what you\'ve got, rookie!','',26124),
(13130,'enUS','Is that the best you can do?','',26124),
(13131,'enUS','You\'re not only wasting the time of your fellow students, you\'re wasting my time too.','',26124),
(13132,'enUS','Pathetic...','',26124),
(13133,'enUS','My granny, livin\' down in Redridge, hits dummies harder than you, rookie!','',26124),
(13134,'enUS','I think you signed up for the wrong job, initiate. Kel\'Thuzad don\'t need any flower girls...','',26124),
(13135,'enUS','Is this some kind of joke?','',26124),
(13136,'enUS','Start doing something before I replace that target dummy with you and begin a warm up session of my own!','',26124),
(13137,'enUS','Student is worthless, master! Student apologizes for his deficiency!','',26124),
(13138,'enUS','I am unworthy, master!','',26124),
(13139,'enUS','Student will work harder, master!','',26124),
(13140,'enUS','Sir, student requests that you beat him for his lack of understanding!','',26124),
(13141,'enUS','%s marks $n for an airstrike.','',26124),
(13142,'enUS','If you\'re looking for work, $c, grab yourself a pick and get to digging. There\'re ruins out there as far as the eye can see!','',26124),
(13143,'enUS','','Greetings, $n. My fellow Sons of Lothar and I have been stuck on this miserable world for close to twenty years now. We held on as best we could, but it still amazes me that the threats we face today are just the shadows of our past failures.$B$BPerhaps you will help us atone for them?  \n',26124),
(13144,'enUS','I don\'t suppose you\'ve come bearing news about the mines, have you?','',26124),
(13145,'enUS','','The extent of the corruption in Outland is truly astonishing, $c. The Cenarion Circle hopes to understand how these creatures have managed to survive. Studying this broken, tortured land and its inhabitants may yet teach us how to heal ailing parts of our own world.',26124),
(13146,'enUS','It is sad to see what has happened to this land.  The Cenarion Expedition will do what it can to understand and heal the damage that has been done.','',26124),
(13147,'enUS','You look lost, $c. Don\'t make me put you to work on the walls with the other peons.','',26124),
(13148,'enUS','','Well met, $c. Your arrival in Thrallmar could not have occurred at a better time. The warchief is depending on us, since he cannot be here himself.',26124),
(13149,'enUS','Thrallmar needs you, $c. The warchief needs you. Stand ready to do your duty.','',26124),
(13150,'enUS','No!!! A curse upon you, interlopers! The armies of the Lich King will hunt you down. You will not escape your fate...','',26124),
(13151,'enUS','Greetings, $n. I am Johnny McWeaksauce. I am used as a tool by developers to carry out specific functions for the purpose of testing. For this test period, I am set to do two specific things:$B$B(1) Flag you as having done the Naxxramas attunement quest so that you are able to accept the next quest, \"Echoes of War\" from Commander Eligor Dawnbringer. You must first complete that quest to be able to access the quests for your Tier 3 armor set.$B$B(2) Teleport you to Naxxramas.$B$BWhat is it that you require?','',26124),
(13152,'enUS','%s shakes his head in dismay.','',26124),
(13153,'enUS','I require flagging.','I require flagging.',26124),
(13154,'enUS','I require a teleport to Naxxramas.','I require a teleport to Naxxramas.',26124),
(13155,'enUS','%s sighs in regret.','',26124),
(13156,'enUS','Greetings, $n. I see that you are already flagged as having completed the quest to gain entry to Naxxramas. Be sure to speak with Commander Eligor Dawnbringer at Light\'s Hope Chapel in the Eastern Plaguelands to acquire the quest, \"Echoes of War.\" You must first complete that quest to be able to access the quests for your Tier 3 armor set.$B$BI am able to teleport you directly to Naxxramas or you may use the portal found in Plaguewood, to the west.','',26124),
(13157,'enUS','Fools!  You seek to abjure my father\'s presence?  Death awaits you, mortals!','',26124),
(13158,'enUS','','Could night elf saboteurs be behind this?  I doubt it.  With the load we\'ve been putting on the West Sanctum it was only a matter of time until something went wrong.',26124),
(13159,'enUS','So you\'ve conquered a small spot of land. A minor setback! I will reign here!','',26124),
(13160,'enUS','Enjoy your small victory while you can, mortals. It will not stop my eventual triumph over this land!','',26124),
(13161,'enUS','There is no victory for you here! What little ground you\'ve gained will be swallowed by my army in due course!','',26124),
(13162,'enUS','The shadow of the Scourge yet remains on this land, fools! You will never prevail!','',26124),
(13163,'enUS','So, the frail members of the living have some teeth after all. Take this place, then, for the time being. I will return, twice as strong, and your paltry forces will fall!','',26124),
(13164,'enUS','You dare disrupt my works here?! Take this time to prepare yourselves... when I return, there will be nothing but death and destruction in my wake!','',26124),
(13165,'enUS','You may think you have won, worms, but against the might of the Lich King there is no victory for the living! You have not seen the last of me!','',26124),
(13166,'enUS','%s shimmers and disappears!','',26124),
(13167,'enUS','Few bouts are won by sheer strength.  It is cunning, reflexes and knowledge of your weapon that wins the day in the end.','Few bouts are won by sheer strength.  It is cunning, reflexes and knowledge of your weapon that wins the day in the end.',26124),
(13168,'enUS','Show me what you know, Larenis.','Show me what you know, Larenis.',26124),
(13169,'enUS','Do you truly believe you are doing well? Hah! My forces are limitless!','',26124),
(13170,'enUS','You may succeed on the field of battle briefly... but you cannot hope to win against my Scourge!','',26124),
(13171,'enUS','','Open wide, Jir\'see.',26124),
(13172,'enUS','You\'ve reclaimed a few paltry territories. Pathetic. In short order they will again be mine!','',26124),
(13173,'enUS','Do you truly believe you\'re making progress? You can never defeat my Scourge!','',26124),
(13174,'enUS','Think you the master is daunted by your games? We will never fall to you!','',26124),
(13175,'enUS','You fools! Keep fighting, if that is your wish! With every battle, more of you fall, and the ranks of my undead swell!','',26124),
(13176,'enUS','The toils of the living never cease to amaze. Your numbers are limited, and with every battle they dwindle further. You will not live to see the end!','',26124),
(13177,'enUS','Do you truly believe you can win against the armies of the Lich King? No army of the living, no power you could possibly bring to bear can destroy my ranks!','',26124),
(13178,'enUS','This constant, annoying resistance is futile, you maggots! There will be nothing in the end but death!','',26124),
(13179,'enUS','','That\'s my little Jir\'see! We\'ll make you into one of those netherhounds yet!',26124),
(13180,'enUS','My strength.... is... returning!','',26124),
(13181,'enUS','You\'ve found a cure!  We will crush our enemies!','',26124),
(13182,'enUS','You\'ve restored my health!  I\'m in your debt, $n.','',26124),
(13183,'enUS','%s whispers something unintelligible.','%s whispers something unintelligible.',26124),
(13184,'enUS','Everybody settle down! We\'re doing our best to get the situation under control. Them bleedin\' orcs are unrelenting!','',26124),
(13185,'enUS','Go with the Light.','',26124),
(13186,'enUS','%s sobs.','%s sobs.',26124),
(13187,'enUS','%s clenches $g his:her; fists in anger.','%s clenches $g his:her; fists in anger.',26124),
(13188,'enUS','We can\'t even leave our houses anymore! The attacks are never ending!','We can\'t even leave our houses anymore! The attacks are never ending!',26124),
(13189,'enUS','The graveyard on the hill is filling up faster than we can dig the holes on some days.','The graveyard on the hill is filling up faster than we can dig the holes on some days.',26124),
(13190,'enUS','Will we ever be able to go back home?','Will we ever be able to go back home?',26124),
(13191,'enUS','I buried my son today, Thalvos... And my spouse last week.','I buried my son today, Thalvos... And my spouse last week.',26124),
(13192,'enUS','They say that there\'s gonna be another attack... None are to be left alive...','They say that there\'s gonna be another attack... None are to be left alive...',26124),
(13193,'enUS','Nerzhul will never give up. Where are our heroes?','Nerzhul will never give up. Where are our heroes?',26124),
(13194,'enUS','Trollbane alone cannot fight back the combined might of the orcish Horde. We are done for...','Trollbane alone cannot fight back the combined might of the orcish Horde. We are done for...',26124),
(13195,'enUS','We want answers, Lieutenant! We\'re entitled to know the truth!','We want answers, Lieutenant! We\'re entitled to know the truth!',26124),
(13196,'enUS','Even as my health fails me... it\'s my duty to serve... the Clans!','',26124),
(13197,'enUS','<Administer the Healing Salve.>','<Administer the Healing Salve.>',26124),
(13198,'enUS','Where is the master?','Where is the master?',26124),
(13199,'enUS','Where has the master gone?','Where has the master gone?',26124),
(13200,'enUS','I must see the master at once!','I must see the master at once!',26124),
(13201,'enUS','Why can we not talk to the master?','Why can we not talk to the master?',26124),
(13202,'enUS','The Master is deep in study.','',26124),
(13203,'enUS','The Master is resting after his labors.','',26124),
(13204,'enUS','The Master will return from Stormwind soon....','',26124),
(13205,'enUS','The master has business in the rooms above.','',26124),
(13206,'enUS','The master is meeting with his apprentice.','',26124),
(13207,'enUS','Another hero? The fates smile upon us on this day, $n. ','',26124),
(13208,'enUS','Your meal is ready, sir.','',26124),
(13209,'enUS','As you requested.','',26124),
(13210,'enUS','At your service, sir, as always.','',26124),
(13211,'enUS','Such a shame for this food to go to waste. Oh, well.','',26124),
(13212,'enUS','Where has he gone?','',26124),
(13214,'enUS','Thank you.','',26124),
(13215,'enUS','All this fuss just for me?\n','',26124),
(13216,'enUS','Appreciated.','',26124),
(13217,'enUS','Another meal, another triumph!','Another meal, another triumph!',26124),
(13218,'enUS','It is Gul\'dan!','It is Gul\'dan!',26124),
(13219,'enUS','What exactly is going on upstairs, anyway?','What exactly is going on upstairs, anyway?',26124),
(13220,'enUS','%s gasps.','%s gasps.',26124),
(13221,'enUS','He appeared from thin air!','He appeared from thin air!',26124),
(13222,'enUS','That joke... I swear I laugh every time!','That joke... I swear I laugh every time!',26124),
(13223,'enUS','%s whispers something unintelligible.','%s whispers something unintelligible.',26124),
(13224,'enUS','Kneel! Kneel fools!','Kneel! Kneel fools!',26124),
(13225,'enUS','What are we doing here?','What are we doing here?',26124),
(13226,'enUS','Why has this gathering been called?','Why has this gathering been called?',26124),
(13227,'enUS','%s whispers something to their compatriot.','%s whispers something to their compatriot.',26124),
(13228,'enUS','I\'ve heard something of your exploits, $n.  I know that while you\'re here in Forsaken lands that you\'ll comport yourself with dignity and as a true hero of the sin\'dorei!','',26124),
(13229,'enUS','I\'m positively stuffed; I can\'t eat another bite! Well, perhaps just one more...','I\'m positively stuffed; I can\'t eat another bite! Well, perhaps just one more...\n',26124),
(13230,'enUS','I fear the worst.','',26124),
(13231,'enUS','','What are they going to do with it?',26124),
(13232,'enUS','','%s points to the draenei captive.',26124),
(13233,'enUS','Every dish is more delicious than the last!','Every dish is more delicious than the last!',26124),
(13234,'enUS','A feast fit for royalty!','A feast fit for royalty!',26124),
(13235,'enUS','And so then he says \"I was talking to the chicken!\"','And so then he says \"I was talking to the chicken!\"',26124),
(13236,'enUS','That joke kills me!','That joke kills me!',26124),
(13237,'enUS','Does anyone else remember how we got here? Is it just me...?','Does anyone else remember how we got here? Is it just me...?',26124),
(13238,'enUS','Where did I live before this? I used to know. At least I thought I did....','Where did I live before this? I used to know. At least I thought I did....',26124),
(13239,'enUS','Ahh, life is good.','Ahh, life is good.',26124),
(13240,'enUS','I\'ve never been so happy! I wish this night would never end!','I\'ve never been so happy! I wish this night would never end!',26124),
(13241,'enUS','Waiter, another ale!','Waiter, another ale!',26124),
(13242,'enUS','Waiter, more wine!','Waiter, more wine!',26124),
(13243,'enUS','Waiter, where is my hasenpfeffer?','Waiter, where is my hasenpfeffer?',26124),
(13244,'enUS','Gladly.','',26124),
(13245,'enUS','No sooner said than done, sir.','',26124),
(13246,'enUS','I\'ll check on that right away.','',26124),
(13247,'enUS','','I saw some killing children in battle. The bloodlust was upon them - I could not condone it but I could see how it could happen, but surely they will not make a ritual sacrifice out of this defenseless captive.',26124),
(13248,'enUS','I hope you are right.','',26124),
(13249,'enUS','Today is a glorious day for the Horde!','',26124),
(13250,'enUS','All quiet.','',26124),
(13251,'enUS','Who goes there?','',26124),
(13252,'enUS','Am I hearing things?','',26124),
(13253,'enUS','I would like to enter the secret code to receive my Zergling pet.','I would like to enter the secret code to receive my Zergling pet.',26124),
(13254,'enUS','Hail!  You look familiar... have we met before?$B$BWell if we have met, then... surely you were given a secret code. Tell me your code and I will give you a gift!','Hail!  You look familiar... have we met before?$B$BWell if we have met, then... surely you were given a secret code. Tell me your code and I will give you a gift!',26124),
(13255,'enUS','','Over there! They\'re following us!',26124),
(13256,'enUS','You have all seen this portal being built, admired the craftsmanship and how it stands as a monument to the glory of the Horde.','',26124),
(13257,'enUS','Now, I will reveal to you the visions I have had.','',26124),
(13258,'enUS','%s points to the monolothic structure known as the Dark Portal.','',26124),
(13259,'enUS','Far, far away, in a land called Azeroth, I have an ally. He offers us his land. It is green and lush, filled with pure water and fat creatures to hunt.','',26124),
(13260,'enUS','Best of all, we will continue to exalt in the glory of bloodshed. A race called \'humans\', the enemy of our ally, will try to stop us from taking their lands.','',26124),
(13261,'enUS','We will destroy them. Their blood-red blood-will flow freely upon our swords. As we have destroyed the Draenei, so now we will destroy the humans!\n','',26124),
(13262,'enUS','%s gestures for silence.','',26124),
(13263,'enUS','','%s shakes her head in disbelief.',26124),
(13264,'enUS','','How can they still feel this way? Can they not see this new land will suffer as ours has if we continue on this path?',26124),
(13265,'enUS','%s nods in agreement.','',26124),
(13266,'enUS','But at the same time, there is no choice. We need food, water. We must go through this portal.','',26124),
(13267,'enUS','Even now, our ally is working to open the portal on his side. And now, we will begin.','',26124),
(13268,'enUS','%s gestures to the draenei captive.','',26124),
(13269,'enUS','Blood is a pure offering to those who give us these vast powers.  And the blood of an innocent is purer still.  With the life fluid of our enemies, we will open the portal and step into a glorious new world - a new page in the history of the Horde!','',26124),
(13270,'enUS','NO!!!','',26124),
(13271,'enUS','Gul\'dan, what have you done to us!','',26124),
(13272,'enUS','These are our scouts! They have already gone through the Dark Portal. They return to you with news of the new world.','',26124),
(13273,'enUS','It is true! All is as you promised us!','',26124),
(13274,'enUS','This is the moment of destiny! On the other side, a new beginning awaits. A new enemy to slaughter. You can feel it, can you not? The bloodlust rising? Follow Blackhand! Listen to his orders and you will rule this new world as is your right! It is your world on the other side of the portal. Take it!','',26124),
(13275,'enUS','FOR THE HORDE!','FOR THE HORDE!',26124),
(13276,'enUS','FOR THE HORDE!','',26124),
(13277,'enUS','FOR THE HORDE!','',26124),
(13278,'enUS','Waiter, another bottle, and be quick!','Waiter, another bottle, and be quick!',26124),
(13279,'enUS','Of course, sir.','',26124),
(13280,'enUS','%s begins to weaken as its energy bleeds away.','',26124),
(13281,'enUS','This music never gets old, does it?','This music never gets old, does it?',26124),
(13282,'enUS','It\'s so strange: I can\'t remember how I came to be here.','It\'s so strange: I can\'t remember how I came to be here.',26124),
(13283,'enUS','I feel as though there\'s a task I have yet to complete....','I feel as though there\'s a task I have yet to complete....',26124),
(13284,'enUS','For the life of me I don\'t know why I\'m here, but I\'m having the best time!','For the life of me I don\'t know why I\'m here, but I\'m having the best time!',26124),
(13286,'enUS','This all seems so strange.','This all seems so strange.',26124),
(13287,'enUS','Perhaps just one more dance. Then I really must be leaving! I have to get back to... to...','Perhaps just one more dance. Then I really must be leaving! I have to get back to... to...',26124),
(13289,'enUS','','Thank you for agreeing to help. Now, let\'s get out of here, $n!',26124),
(13290,'enUS','','Allow me a moment to rest. The journey taxes what little strength I have.',26124),
(13291,'enUS','Another drink!','Another drink!',26124),
(13292,'enUS','','Falcon Watch, at last! Now, where\'s my... Oh no! My pack, it\'s missing! Where has - ',26124),
(13293,'enUS','More food! More wine!','More food! More wine!',26124),
(13294,'enUS','I believe I\'ll try the merlot this time.','I believe I\'ll try the merlot this time.',26124),
(13295,'enUS','As you wish.','As you wish.',26124),
(13296,'enUS','Without delay!','Without delay!',26124),
(13297,'enUS','Right away!','Right away!',26124),
(13298,'enUS','Keep the drinks coming; it\'s going to be a long night!','Keep the drinks coming; it\'s going to be a long night!',26124),
(13299,'enUS','Practice as if your life depends on it, because it does!','',26124),
(13300,'enUS','What kind of pathetic strike was that? Shape up at once!','',26124),
(13301,'enUS','You block like a little girl! Put your shoulder into it!','',26124),
(13302,'enUS','You had better straighten up, or you\'ll answer to me!','',26124),
(13303,'enUS','','I bid you welcome, $c.',26124),
(13304,'enUS','I haven\'t time for idle chatter, $c. I must see to the pilgrims and ensure they are prepared for the long journey ahead.','',26124),
(13305,'enUS','Welcome to Falcon Watch, $c. I see to the needs of the pilgrims and help them in continuing their long journey. If you haven\'t yet undertaken the pilgrimage, I can provide you with the information you will need.','',26124),
(13306,'enUS','Greetings, $c.','',26124),
(13307,'enUS','Yes, sir!','Yes, sir!',26124),
(13308,'enUS','','Walk always in the Light, $n.',26124),
(13309,'enUS','','Welcome to the Farstrider Retreat.  We are rangers sworn to defend our people from enemies both near and far.',26124),
(13310,'enUS','Shay, what\'sh your deal anwaysh? Are you shome kind of elf or shomethin? You looksh shorta familiar.','',26124),
(13311,'enUS','I am Arator, son of Turalyon and Alleria. So yes, Father, I am \"shome\" kind of elf: half-elf to be precise.','',26124),
(13312,'enUS','%s\'s face turns white. Sobriety seems to have set in rather quickly.','',26124),
(13313,'enUS','By the Light! So this is why you look familiar. Is this fate? Destiny perhaps? Arator, your father and I were the best of friends. It is I who kept him in good health... Oh the battles we fought... And...','',26124),
(13314,'enUS','%s clears his throat.','',26124),
(13315,'enUS','And... the battle we lost. I... I\'m sorry, Arator. It was my fault...','',26124),
(13316,'enUS','%s begins to sob.','%s begins to sob.',26124),
(13317,'enUS','Quickly, Sid. Fill my tankard. Make the memories fade...','',26124),
(13318,'enUS','Oh brother... Listen, he\'s gonna be here crying like a baby for another five hours. If you\'re really the son of Turalyon, go speak with Trollbane. He\'s in the keep - top floor.','',26124),
(13319,'enUS','%s nods.','',26124),
(13320,'enUS','Take care of him, Sid. He may be the only link I have to my father and mother. He needs to sober up...','',26124),
(13321,'enUS','','I think I\'m beginning to regret undertaking this pilgrimage. I anticipated that the road would be rough and I\'m no stranger to travel, but I wasn\'t prepared for the rigors of Outland.$B$BOn top of everything else, that Taleris seems to want to push me out of here before I\'ve regained my strength completely.',26124),
(13322,'enUS','Farewell, Commander. I will be staying at the inn, should you require my services.','',26124),
(13323,'enUS','Yes... this will do nicely.','',26124),
(13324,'enUS','An unstable source.... but its warmth beckons me!','',26124),
(13325,'enUS','Wake up, Gal\'ressa.','',26124),
(13326,'enUS','','%s rubs the sleep from her eyes.',26124),
(13327,'enUS','','What do you want, Taleris?',26124),
(13328,'enUS','You\'ve had enough time to recover from your wounds, Gal\'ressa. The time has come for you to return to the road.','',26124),
(13329,'enUS','','I\'m not going on alone, Taleris, and that\'s final. I\'m going to wait here for the next group of pilgrims and set out with them when they depart.',26124),
(13330,'enUS','You\'ll do no such thing. We simply haven\'t the room to keep you here. Now, kindly be on your way.','',26124),
(13331,'enUS','','By the Sunwell, you\'ve a thick skull! You\'ll not bully me into leaving, Taleris. Now, begone from my sight!',26124),
(13332,'enUS','Very well then, have it your way. When we turn others away, you will be responsible for their suffering. Think about that.','',26124),
(13333,'enUS','I wish I had tickets for tonight\'s show!','I wish I had tickets for tonight\'s show!',26124),
(13334,'enUS','I heard last night\'s performance was spectacular!','I heard last night\'s performance was spectacular!',26124),
(13335,'enUS','It\'s much easier to talk up here without all that music.','It\'s much easier to talk up here without all that music.',26124),
(13336,'enUS','This all seems so familiar, like I\'ve been here before.','This all seems so familiar, like I\'ve been here before.',26124),
(13337,'enUS','Perhaps later we should join the dance.','Perhaps later we should join the dance.',26124),
(13338,'enUS','I\'m quite sure there was a reason I came here....','I\'m quite sure there was a reason I came here....',26124),
(13339,'enUS','Oh... do I know you?','Oh... do I know you?',26124),
(13340,'enUS','Hi, $n!  Enjoying the party?','Hi, $n!  Enjoying the party?',26124),
(13341,'enUS','Hey everyone, it\'s $n!','Hey everyone, it\'s $n!',26124),
(13342,'enUS','Word travels fast in this circle.  Thanks for restocking the supplies!','Word travels fast in this circle.  Thanks for restocking the supplies!',26124),
(13343,'enUS','This party is just the best!  Don\'t you agree?','This party is just the best!  Don\'t you agree?',26124),
(13344,'enUS','You should try the springpaw appetizers, they\'re to die for!','You should try the springpaw appetizers, they\'re to die for!',26124),
(13345,'enUS','Hmm... I think this year\'s Suntouched Special isn\'t so special after all.  Wouldn\'t you agree, $n?','Hmm... I think this year\'s Suntouched Special isn\'t so special after all.  Wouldn\'t you agree, $n?',26124),
(13346,'enUS','I heard a rumor that we\'re all going to go watch the battle with the Scourge at the border tonight.  How delightfully wicked!','I heard a rumor that we\'re all going to go watch the battle with the Scourge at the border tonight.  How delightfully wicked!',26124),
(13347,'enUS','Can you believe the nerve of that Elisara Sunstriker?  Thinking that she can catch the eye of Lord Saltheril?  And did you see what she\'s wearing?  So last season.  It\'s sad, really.','Can you believe the nerve of that Elisara Sunstriker?  Thinking that she can catch the eye of Lord Saltheril?  And did you see what she\'s wearing?  So last season.  It\'s sad, really.',26124),
(13348,'enUS','Sorry, I don\'t speak with the help.','Sorry, I don\'t speak with the help.',26124),
(13349,'enUS','And you would be?','And you would be?',26124),
(13350,'enUS','I\'m afraid you have me confused with someone who wants to talk to you.','I\'m afraid you have me confused with someone who wants to talk to you.',26124),
(13351,'enUS','Ugh... go away!','Ugh... go away!',26124),
(13352,'enUS','Huh, what?  What happened?','Huh, what?  What happened?',26124),
(13353,'enUS','Go away.. I\'m tryin\' to shleep here.','Go away.. I\'m tryin\' to shleep here.',26124),
(13354,'enUS','Ack, I don\'t feel so good.','Ack, I don\'t feel so good.',26124),
(13355,'enUS','','Salthy, do you think we\'re letting too many \'undesirables\' into the party?  I do worry about what our friends might think of all of this.',26124),
(13356,'enUS','','You promised to take me out for a night on the town!  Are we just going to stand around here again tonight?',26124),
(13357,'enUS','I hate having to do that.','I hate having to do that.',26124),
(13358,'enUS','They just keep attacking.  There\'s nothing else that I can do but put them down.','They just keep attacking.  There\'s nothing else that I can do but put them down.',26124),
(13359,'enUS','I hope this ends soon.  Having to kill these owlkin, mutated or not, is making me sick.','I hope this ends soon.  Having to kill these owlkin, mutated or not, is making me sick.',26124),
(13360,'enUS','Light take these creature\'s spirits into your arms!','Light take these creature\'s spirits into your arms!',26124),
(13361,'enUS','','%s whispers something in the Dame\'s ear.',26124),
(13362,'enUS','','%s nods her head yes at what her advisor has to say.',26124),
(13363,'enUS','','%s disagrees with whatever it is that Valwyn has whispered to her.',26124),
(13365,'enUS','','%s seems nonplussed by whatever it is that her advisor has whispered in her ear.',26124),
(13366,'enUS','%s turns to Advisor Valwyn and winks lasciviously in her direction.','',26124),
(13367,'enUS','','%s looks disgusted at the deathstalker\'s flirtations.',26124),
(13368,'enUS','%s cackles maniacally as he combines the two mixtures in his hands.','',26124),
(13369,'enUS','Drat!  This bloodthistle extract doesn\'t seem to want to combine properly with my poison.  I\'ll not be deterred - those trolls will be dealt with!  Perhaps a different mixture?','',26124),
(13370,'enUS','While the soldiers of our army put their steel to our enemies, the actual efficacy of such attacks is questionable - a diversion at best. It is through the arcane that our enemies will crumble and fall before us.','',26124),
(13371,'enUS','Watch and learn, students. Only through discipline and practice will you achieve such results.','',26124),
(13372,'enUS','The taskmaster\'s dead!  Quick, Dreghoods!  Run!','',26124),
(13373,'enUS','Flee!  Flee!','',26124),
(13374,'enUS','This is our chance!  Run for it!','',26124),
(13375,'enUS','This is your standard fireball.','',26124),
(13376,'enUS','We use frost to chill their bones and bring their movement to a halt.','',26124),
(13377,'enUS','For multiple targets, bring a blizzard down upon their heads.','',26124),
(13378,'enUS','Last, but certainly not least, we have the pyroblast. This is for when you absolutely, positively want to make a lasting first impression.','',26124),
(13379,'enUS','You\'ll go nowhere worms!','',26124),
(13380,'enUS','Return at once or suffer the master\'s wrath!','',26124),
(13381,'enUS','You\'ll soon beg for death if you don\'t return at once, wretches!','',26124),
(13382,'enUS','','Hey!  Could you come over and get me out of this cage?',26124),
(13383,'enUS','','HELP!!!',26124),
(13384,'enUS','','Get me out of here and I guarantee there\'ll be a reward in it for you!',26124),
(13385,'enUS','','Quick, kill all of these trolls and then let me out of this thing!',26124),
(13386,'enUS','','If you let me out I promise that you won\'t regret it!',26124),
(13387,'enUS','','If you don\'t mind hurrying it up?  I think they\'re getting ready to sacrifice me!',26124),
(13388,'enUS','Another pilgrim has arrived! Bring water quickly, or we may lose her!','',26124),
(13389,'enUS','','Do you hear something?',26124),
(13390,'enUS','I\'ve managed to work myself into quite a spot here. Far Seer Regulkut tried to warn me, but my carelessness has finally caught up with me.$B$BI came down here to study the ruins of Zeth\'Gor, but ran afoul of the Legion on my way. Now, all I have to show for it is a nasty gash on my leg.','',26124),
(13391,'enUS','Though I cannot offer you training, young $c, I can give you my blessing.  Walk boldly in the Light!$B$BIs there anything else?','Though I cannot offer you training, young $c, I can give you my blessing.  Walk boldly in the Light!$B$BIs there anything else?',26124),
(13392,'enUS','','It is very important that we find out what the the night elves are up to, $c! Please concentrate all of your efforts toward that end.',26124),
(13393,'enUS','Not long ago, this place was the site of a terrible battle.  We of Nethergarde and the Argent Dawn held at bay a wave of demons, surging relentlessly from the Dark Portal.$B$BThose were dark days, full of bloodshed and despair...$B$BBut the Kingdoms of Azeroth soon joined us and pushed the monsters back!  The fighting continues on the far side of the Portal...$B$BThis camp is now calm, but I fear the quiet here belies the madness found through that hellish gate.','',26124),
(13394,'enUS','The heroics of the Trollbane bloodline are legendary. I idolize the man.$B$BAnd to find him alive, in the Outland...$B$B<Romus gazes past you.>$B$BWhen I first saw him, I nearly fainted. The shock was overwhelming. As I knelt before him, I had to fight back tears.$B$BYou can bet your sweet behind that I\'m going to do everything in my power to make sure the Sons of Lothar are kept safe.','',26124),
(13395,'enUS','Romus informed me of the tragedies that beset my beautiful city. There are no fitting words for the sorrow I felt upon hearing of Lordaeron\'s fate - and the fate of my own, beloved Stromgarde.$B$BTwenty years ago, no one had heard of the \'Burning Legion\'... Damn those cursed devils!$BRest assured, $n; should I ever return to Azeroth, Stromgarde will once more rise as a force of reckoning. This I swear...','',26124),
(13396,'enUS','','Your impurity must be cleansed.',26124),
(13397,'enUS','','Such... dark... energy!  How can this be possible?',26124),
(13398,'enUS','Hey! Where do you think you are going, sneaking around like that?','Hey! Where do you think you are going, sneaking around like that?',26124),
(13399,'enUS','Excuse me, are you trying to sneak by without an invitation?','Excuse me, are you trying to sneak by without an invitation?',26124),
(13400,'enUS','$n, you too shall serve the Master!','$n, you too shall serve the Master!',26124),
(13401,'enUS','Pledge your loyalty to the Master, $gSir:Madam;, and your life shall be spared!','Pledge your loyalty to the Master, $gSir:Madam;, and your life shall be spared!',26124),
(13402,'enUS','','This emitter is driving me nuts!  I\'m missing all sorts of parts that I need to fix it.',26124),
(13403,'enUS','','$n!  Thanks again for all the help.',26124),
(13404,'enUS','','Nope, still not done with these repairs.  Shouldn\'t be long though.',26124),
(13405,'enUS','%s siphons the energy from the totem and redirects it in the form of an anti-magic pulse.','',26124),
(13406,'enUS','%s siphons the blessing of wisdom\'s energy and redirects it in the form of an anti-magic pulse.','',26124),
(13407,'enUS','Oh no!  Where are we?  What happened?  Look, there\'s part of the ship!','Oh no!  Where are we?  What happened?  Look, there\'s part of the ship!',26124),
(13408,'enUS','The last thing I remember is the ship falling and us getting into the pods.  I\'ll go see how I can help.  Thank you!','The last thing I remember is the ship falling and us getting into the pods.  I\'ll go see how I can help.  Thank you!',26124),
(13409,'enUS','Where am I?  Who are you?  Oh no!  What happened to the ship?','Where am I?  Who are you?  Oh no!  What happened to the ship?',26124),
(13410,'enUS','Ugh... what is this place?  Is that all that\'s left of the ship over there?','Ugh... what is this place?  Is that all that\'s left of the ship over there?',26124),
(13411,'enUS','Ughhh... I hurt.  Can you help me?','Ughhh... I hurt.  Can you help me?',26124),
(13412,'enUS','Oh, I hurt all over. Can you help me?','Oh, I hurt all over. Can you help me?',26124),
(13413,'enUS','<Sobbing> I hate graveyards.  So many dead.  And my sweet Luhanaa....','',26124),
(13414,'enUS','%s weeps softly.','',26124),
(13415,'enUS','%s stares in silence at the grave marker before him.','',26124),
(13416,'enUS','%s breaks down into huge, wracking sobs.','',26124),
(13417,'enUS','%s bows his head and sighs, clearly exhausted.','',26124),
(13418,'enUS','Why, Luhanaa?  Why?!','',26124),
(13419,'enUS','It should have been me!','',26124),
(13420,'enUS','I\'ll never forget you, my love.','',26124),
(13421,'enUS','We should never have come along.','',26124),
(13422,'enUS','I miss you so much!','',26124),
(13423,'enUS','If I ever find the ones responsible for the crash...!','',26124),
(13424,'enUS','You\'ll always be here, with me.','',26124),
(13425,'enUS','Be at peace, my sweet, sweet, Luhanaa.','',26124),
(13426,'enUS','We won\'t allow you to leave this valley!','We won\'t allow you to leave this valley!',26124),
(13427,'enUS','What a pity you survived the crash just to die here.','What a pity you survived the crash just to die here.',26124),
(13428,'enUS','I hope you\'ve made your peace.','I hope you\'ve made your peace.',26124),
(13429,'enUS','None of you are to leave this valley alive.','None of you are to leave this valley alive.',26124),
(13430,'enUS','%s lifts its head into the air, as if listening for something.','',26124),
(13431,'enUS','A giant worm-like creature just erupted from the earth near Hive\'Ashi!','',26124),
(13432,'enUS','Look, there! By Hive\'Regal! Is that... a sandworm?!','',26124),
(13433,'enUS','Be on your guard! There are reports of a humungous worm close to Hive\'Zora!','',26124),
(13434,'enUS','Something stirs near Southwind Village! It... it\'s one of those sandworm creatures! Look out!','',26124),
(13435,'enUS','How dare you spill the master\'s wine!','How dare you spill the master\'s wine!',26124),
(13436,'enUS','That was a 200 year old Pupellyverbos Port!','That was a 200 year old Pupellyverbos Port!',26124),
(13437,'enUS','That was wasted on the likes of you!','That was wasted on the likes of you!',26124),
(13438,'enUS','How dare you disturb the master\'s dinner!','How dare you disturb the master\'s dinner!',26124),
(13439,'enUS','%s calls for her master!','%s calls for her master!',26124),
(13440,'enUS','Oh, the pain...','Oh, the pain...',26124),
(13441,'enUS','Everything hurts. Please, make it stop...','Everything hurts. Please, make it stop...',26124),
(13442,'enUS','I don\'t know if I can make it. Please help me...','I don\'t know if I can make it. Please help me...',26124),
(13443,'enUS','Anub\'Rekhan begins to unleash an insect swarm!','',26124),
(13445,'enUS','%s mounts his steed.','',26124),
(13446,'enUS','%s lets out a howl that rings across the mountains to the north and motions for you to follow.','',26124),
(13447,'enUS','Avruu\'s magic is broken!  I\'m free once again!','',26124),
(13448,'enUS','Avruu\'s magic... it still controls me.  You must fight me, mortal.  It\'s the only way to break the spell!','',26124),
(13449,'enUS','Activating defense mode EL-7M.','',26124),
(13450,'enUS','Activating defense mode EL-5R.','',26124),
(13451,'enUS','Activating defense mode EL-2S.','',26124),
(13452,'enUS','Remember to always show your respect for the elements of the world.','Remember to always show your respect for the elements of the world.',26124),
(13453,'enUS','We must strive to understand the balance maintained by this world\'s elemental spirits.','We must strive to understand the balance maintained by this world\'s elemental spirits.',26124),
(13454,'enUS','%s attacks with renewed vigor!','',26124),
(13455,'enUS','%s rushes to her master\'s aid.','%s rushes to her master\'s aid.',26124),
(13456,'enUS','Come Midnight, let\'s disperse this petty rabble!','',26124),
(13457,'enUS','Come Midnight, let\'s disperse this petty rabble!','',26124),
(13458,'enUS','%s cries out in pain!','%s cries out in pain!',26124),
(13459,'enUS','Cowards! Wretches!','',26124),
(13460,'enUS','It was... inevitable.','',26124),
(13461,'enUS','One more for dinner this evening.','',26124),
(13462,'enUS','Always knew... someday I would become... the hunted.','',26124),
(13463,'enUS','','Hello!  So good to meet you!',26124),
(13464,'enUS','','Greetings.  You are here to help?',26124),
(13465,'enUS','','Just remember, $n, it\'s in our best interests that you do as much as possible for these... these people.',26124),
(13466,'enUS','','Greetings, $r!  I trust this day finds you well?',26124),
(13467,'enUS','','Any news from home, $c?',26124),
(13468,'enUS','Come closer, friend.  Do not let my eyes startle you.$B$BI might have lost my sight many years ago but I never needed it to see the things that really matter.','',26124),
(13469,'enUS','','Victory for the Horde!',26124),
(13470,'enUS','We\'ve done it!  Victory to the Alliance!','',26124),
(13471,'enUS','','Grab a net, young $c. Our people need sustenance!',26124),
(13472,'enUS','Hello.  I trust that this day finds you well?','',26124),
(13473,'enUS','Please teach me how to fish, Diktynna.','Please teach me how to fish, Diktynna.',26124),
(13474,'enUS','I wish to browse your wares, Diktynna.','I wish to browse your wares, Diktynna.',26124),
(13475,'enUS','It\'s so good to see another sin\'dorei $g brother : sister;!  As you can imagine, there\'s not much in the way of conversation around here.','',26124),
(13476,'enUS','','We have one quarter of our needed silithyst! Keep it up!',26124),
(13477,'enUS','','We have half our needed silithyst.  Don\'t stop now!',26124),
(13478,'enUS','','We have almost all the silithyst we need!  For the Horde!',26124),
(13479,'enUS','We have one quarter of the needed silithyst! Keep it up!','',26124),
(13480,'enUS','We have half of our needed silithyst.  We can do it!','',26124),
(13481,'enUS','We have almost all the silithyst we need!  Don\'t stop now!','',26124),
(13482,'enUS','I am honored to make your acquaintance.','',26124),
(13483,'enUS','So good of you to speak with me.  Please, help the Alliance in any way that you can.','',26124),
(13484,'enUS','Greetings.  I am Anchorite Delan - one of the draenei.  I am a teacher of sorts.  And who might you be?','',26124),
(13485,'enUS','While we have much to teach the other races of the Alliance, we have as much to learn from them.  Keep your eyes, ears and mind open, $c.','',26124),
(13486,'enUS','','Hail to thee, $c.',26124),
(13487,'enUS','','Is this city not beautiful, $c?  It warms my heart that we have found such good friends in these night elves.',26124),
(13488,'enUS','','Greetings,  I am Vindicator Palanaar, a traveling paladin of the Light.  I am here to be of assistance to the night elves.',26124),
(13489,'enUS','','It is my fervent hope that we will be able to bring the Light to those places in Ashenvale where it has been forsaken.',26124),
(13490,'enUS','Weapons are merely a convenience for a warrior of my skill!','',26124),
(13491,'enUS','Transport me to the Molten Core, Lothos.','Transport me to the Molten Core, Lothos.',26124),
(13492,'enUS','Your petty magics are no challenge to the might of the Scourge!','',26124),
(13493,'enUS','I am far too busy to be wasting time on idle chatter. If you are looking for work as a huntsman, speak with Diktynna at the river\'s edge -- to the east. No doubt she\'s behind on her duties...','',26124),
(13494,'enUS','I am a hunter in need of training, Acteon.','I am a hunter in need of training, Acteon.',26124),
(13495,'enUS','','This is going to be such fun!  Don\'t you think, my dear?',26124),
(13496,'enUS','Gaze upon the Exodar, young $r. It is hard to imagine that we survived such a catastrophe.$B$B<Menelaous sighs.>$B$BThe Prophet states that it is here that our fate will finally be known. Ten lifetimes spent fleeing from the madness of the Burning Legion... here we finally make a stand.$B$BNo more running... I am ready to die.','',26124),
(13497,'enUS','','Get word to Balandar Brightstar. He\'ll know what to do.',26124),
(13498,'enUS','','Did Balandar Brightstar send you to rescue me?',26124),
(13499,'enUS','Balandar sent me to get you out of here and reclaim his cargo. He\'s waiting for you in Brackenwall Village.','Balandar sent me to get you out of here and reclaim his cargo. He\'s waiting for you in Brackenwall Village.',26124),
(13500,'enUS','','I think I can make it to Brackenwall on my own. They\'ve got the cargo at the top of the tower. Be careful!',26124),
(13501,'enUS','','Oh, most excellent!  That was great fun, was it not?  Little by little I\'ve been cursing more of those disgusting Lost Ones.  Soon enough I\'ll be ready to try it on the draenei!',26124),
(13502,'enUS','','May the spirits guide you, $r.',26124),
(13503,'enUS','Strength to the Clans, $c!  What brings you here?','',26124),
(13504,'enUS','Greetings.  I am Anchorite Avuun of the draenei.  I am here studying the Lost Ones of the Fallow Sanctuary in the hope of being able to find a cure for their condition.','',26124),
(13505,'enUS','You are welcome among us, $c.  At least for the time being.','',26124),
(13506,'enUS','Once more, thank you for your assistance with the cursed Lost Ones.  Without your help I would never have been able to continue my research.','',26124),
(13507,'enUS','','',26124),
(13508,'enUS','','%s removes the reagents from the crate and mixes portions of each in a flask.',26124),
(13509,'enUS','','I\'ve endured much hardship to complete my research and with your help, $n, I\'ve finally done it. Here\'s to a brighter future!',26124),
(13510,'enUS','','I feel... lightheaded... What\'s... happening to me?',26124),
(13511,'enUS','','No, this can\'t be! This tonic... it was supposed to reverse my addiction, not hasten my descent into the ranks of the Wretched!',26124),
(13512,'enUS','','Welcome, kind spirit.  What has brought you to us?',26124),
(13513,'enUS','I\'m not finished yet! No, I have a few more tricks up my sleeve...','',26124),
(13514,'enUS','Surely you wouldn\'t deny an old man a replenishing drink? No, no, I thought not.','',26124),
(13515,'enUS','%s begins channelling his mana into a powerful arcane spell.','',26124),
(13516,'enUS','Ah, nothing like a good drink!','',26124),
(13517,'enUS','Yes, yes my son is quite powerful... but I have powers of my own!','',26124),
(13518,'enUS','I am not some simple jester! I am Nielas Aran!','',26124),
(13519,'enUS','I\'ll show you: this beaten dog still has some teeth!','',26124),
(13520,'enUS','Burn, you hellish fiends!','',26124),
(13521,'enUS','I was among the greatest of the Kirin Tor. You shall not defeat me idling about!','',26124),
(13522,'enUS','I\'ll freeze you all!','',26124),
(13523,'enUS','Back to the cold dark with you!','',26124),
(13525,'enUS','Even death won\'t prevent me from uncovering the secrets of my son!','',26124),
(13526,'enUS','I want this nightmare to be over!','',26124),
(13527,'enUS','Torment me no more!','',26124),
(13529,'enUS','Please, no more! My son... he\'s gone mad!','',26124),
(13530,'enUS','Who are you? What do you want? Stay away from me!','',26124),
(13532,'enUS','Where did you get that? Did HE send you?','',26124),
(13536,'enUS','Come down from there!','',26124),
(13537,'enUS','My people have survived in Outland...','',26124),
(13538,'enUS','Unnoticed for years...','',26124),
(13539,'enUS','...uncorrupted!','',26124),
(13540,'enUS','I\'ll be fine, Eitrigg.  We must begin preparations... I need to go to Outland at once!','',26124),
(13541,'enUS','You are right, Eitrigg.  The timing is unfavorable.  Make sure our best ambassadors are sent as envoys to Hellscream.','',26124),
(13542,'enUS','Thrall!  My lord... are you all right?','',26124),
(13543,'enUS','With all due respect, Warchief.  Our enemies would take advantage of your sudden absence if we don\'t prepare properly.','',26124),
(13544,'enUS','At once, sir!  For the Horde!','',26124),
(13545,'enUS','','Isn\'t that adorable! How did you make it out of the Vale? Maybe you should get back there before someone sends a search party after you.',26124),
(13546,'enUS','','I haven\'t got anymore work for you, $n. I do want you to know that the red snapper we shared was something special that I\'ll never forget...',26124),
(13547,'enUS','Of course I\'ve got a job for you! We\'re always looking for $cs. Hopefully you\'ll fare better than the draenei we had to send back to the Exodar -- for burial.$B$B<Acteon laughs.>$B$BI\'m joking! You should have seen the look on your face. They got sent back to the Exodar for treatment of minor wounds. Nothin\' that they won\'t recover from...','',26124),
(13548,'enUS','Quit running around, $n!','',26124),
(13549,'enUS','Return to your people and tell them to send one of your shaman to me.','',26124),
(13550,'enUS','Return to the draenei and tell them to send me one of their shaman.','',26124),
(13551,'enUS','Your work here is complete, shaman.  Return to your people.','',26124),
(13552,'enUS','Do you have the understanding to continue, shaman?  Do you know why you are here?','',26124),
(13553,'enUS','If he\'s anything like his father, allying with the Mag\'har will mark the dawn of a new age for the Horde.','',26124),
(13554,'enUS','Greetings, $r.','',26124),
(13555,'enUS','It is a good day to be alive and one with the elements.','',26124),
(13556,'enUS','And why would I speak with you, $r?','',26124),
(13557,'enUS','Your presence here can only mean trouble, $g son : daughter; of the Horde.  Go in peace.','',26124),
(13558,'enUS','Look around you, shaman.  Can you see the balance of the elements in the earth, the air, the water and the fire that has touched them all?','',26124),
(13559,'enUS','You dare summon me?!','',26124),
(13560,'enUS','Who challenges Naias? Puny $r, you are little better than those mindless trolls I have played against each other like so many pieces on a game board!','',26124),
(13561,'enUS','Don\'t be alarmed... while my gryphons may not be entirely alive, they will still carry you faithfully to your destination. Tell me... which tower do you seek?','Don\'t be alarmed... while my gryphons may not be entirely alive, they will still carry you faithfully to your destination. Tell me... which tower do you seek?',26124),
(13562,'enUS','Take me to Northpass Tower.','Take me to Northpass Tower.',26124),
(13563,'enUS','Take me to Eastwall Tower.','Take me to Eastwall Tower.',26124),
(13564,'enUS','Take me to Crown Guard Tower.','Take me to Crown Guard Tower.',26124),
(13565,'enUS','','If you have not yet learned how to make use of bandages, I will be happy to show you the basics of creation and application. The difference between life and death can often come down to properly bandaging wounds.',26124),
(13566,'enUS','I wish to learn all that you have to teach me about first aid, Fateema.','I wish to learn all that you have to teach me about first aid, Fateema.',26124),
(13567,'enUS','I WILL have my revenge!','',26124),
(13568,'enUS','I\'m very busy right now, young $c. Please excuse me.','I\'m very busy right now, young $c. Please excuse me.',26124),
(13569,'enUS','You\'ve wasted enough of my time... let these games be finished!','',26124),
(13570,'enUS','Bah, useless! There must be another way...','',26124),
(13571,'enUS','This won\'t work at all! The buildings will surely collapse if we do not shore up the support beams.','',26124),
(13572,'enUS','This won\'t do at all! We have to secure the foundation or the entire structure will crumble!','',26124),
(13573,'enUS','This structure violates at least 8 different ordinances!','',26124),
(13574,'enUS','I won\'t be held responsible for the catastrophe that will surely result from the haphazard maintenance of this building.\n','',26124),
(13575,'enUS','Hrm, this looks much better. Let\'s have a look on the inside.','',26124),
(13576,'enUS','By the foul teat of Kil\'Jaeden\'s rotted torso, the entire backside is blown out! How can someone be expected to live in here? I\'ve seen enough!','',26124),
(13577,'enUS','Greetings, $c. I have been sent here from the Exodar to oversee the construction of Azure Watch.','',26124),
(13578,'enUS','I wish to learn about engineering, Daelo.','I wish to learn about engineering, Daelo.',26124),
(13579,'enUS','I wish to browse your wares, Daelo.','I wish to browse your wares, Daelo.',26124),
(13580,'enUS','I have much to do! Why can they not leave me to my work?','',26124),
(13582,'enUS','%s shrieks in pain and points at his master.','',26124),
(13584,'enUS','You cannot ride a mount in that form.','You cannot ride a mount in that form.',26124),
(13585,'enUS','','',26124),
(13586,'enUS','','You\'re such a good friend, Twinkle.  You\'d never leave me, would you?',26124),
(13587,'enUS','','It\'s just you and me, Twinkle.  Daddy\'s not going to be coming home.',26124),
(13588,'enUS','','Did you find something fun to chase around, Twinkle?  I bet you did!',26124),
(13589,'enUS','','Ok, let\'s go.  I know just the perfect spot!',26124),
(13590,'enUS','','I can\'t wait to try this wine!',26124),
(13591,'enUS','','What... is happening... to me?  Get this cat away from me!',26124),
(13592,'enUS','An alchemist is able to work miracles with ordinary herbs, converting them into stable potions that range in effect from healing to breathing underwater and everything in between.','',26124),
(13593,'enUS','I wish to train as an alchemist, Daedal.','I wish to train as an alchemist, Daedal.',26124),
(13594,'enUS','Please allow me to browse your wares, Daedal.','Please allow me to browse your wares, Daedal.',26124),
(13595,'enUS','Twinkle looks at Viera Sunwhisper with very hungry eyes.','',26124),
(13596,'enUS','','Now to apply the ointment to her wounds.',26124),
(13597,'enUS','','It appears that the ointment is ineffective. Such a pity...',26124),
(13598,'enUS','There may still be a solution. Come here, $n. I will explain what I need.','',26124),
(13599,'enUS','This should do it...','',26124),
(13600,'enUS','Wake up little creature. Wake up from your slumber... You are safe now.','',26124),
(13601,'enUS','','%s groans.',26124),
(13602,'enUS','','%s sits up.',26124),
(13603,'enUS','','Whe... Where am I? What... What is this place?',26124),
(13604,'enUS','','BY THE LIGHT OF ELUNE! Eredar! Cursed demons, what have you done to me? I have not come alone, we will fight you as we have in the past! I...',26124),
(13605,'enUS','','%s falls back into a coma.',26124),
(13606,'enUS','','%s gasps.',26124),
(13607,'enUS','','Oh dear...',26124),
(13608,'enUS','','Man\'ari... But how... We are not eredar! She must know! If there are others like her, we must find them and explain...',26124),
(13609,'enUS','%s sighs.','',26124),
(13610,'enUS','','Viera Sunwhisper scurries away, attempting to flee from Twinkle.',26124),
(13611,'enUS','By the Light you will leave this tomb!','',26124),
(13612,'enUS','Hello.  What brings you to Chillwind Camp today?','',26124),
(13613,'enUS','Shall we begin, my friend?','',26124),
(13614,'enUS','This area is known to be full of foul Scourge.  You may want to take a moment to prepare any defenses at your disposal.','',26124),
(13615,'enUS','Very well, let us continue.','',26124),
(13616,'enUS','Beware!  We are attacked!','',26124),
(13617,'enUS','It must be the purity of the Mark of the Lightbringer that is drawing forth the Scourge to us.  We must proceed with caution lest we be overwhelmed!','',26124),
(13618,'enUS','We are beset upon again!  Defend yourself!','',26124),
(13619,'enUS','This land truly needs to be cleansed by the Light!  Let us continue on to the tomb.  It isn\'t far now.','',26124),
(13620,'enUS','','Hello there!  Oh my, a draenei!',26124),
(13621,'enUS','Be welcome, friends!','',26124),
(13622,'enUS','Thank you for coming here in remembrance of me.  Your efforts in recovering that symbol, while unnecessary, are certainly touching to an old man\'s heart.','',26124),
(13623,'enUS','Please, rise my friend.  Keep the Blessing as a symbol of the strength of the Light and how heroes long gone might once again rise in each of us to inspire.','',26124),
(13624,'enUS','Thank you my friend for making this possible.  This is a day that I shall never forget!  I think I will stay a while.  Please return to High Priestess MacDonnell at the camp.  I know that she\'ll be keenly interested to know of what has transpired here.','',26124),
(13625,'enUS','Why do you do this?  Did I somehow wrong you in life?','',26124),
(13626,'enUS','Ah, I see it now in your mind.  This is the work of one of my former students... Mehlar Dawnblade.  It is sad to know that his heart has turned so dark.','',26124),
(13627,'enUS','Return to him.  Return to Mehlar and tell him that I forgive him and that I understand why he believes what he does.','',26124),
(13628,'enUS','Good day to you, $c.$B$BI\'m waiting to hear from one of the High Thane\'s advisors about an audience. It was a struggle just to get the opportunity to present my credentials.$B$BI\'ve heard the Wildhammer described as \'wary of outsiders,\' but that\'s proven to be quite an understatement.  Hopefully, things will improve once I\'ve had the opportunity to meet with Featherbeard, whom I\'m told favors closer ties with the Alliance.','',26124),
(13629,'enUS','|cffffff00The Plaguewood Tower has been taken by the Alliance!|r','',26124),
(13630,'enUS','|cffffff00Northpass Tower has been taken by the Alliance!|r','',26124),
(13631,'enUS','|cffffff00Eastwall Tower has been taken by the Alliance!|r','',26124),
(13632,'enUS','|cffffff00Crown Guard Tower has been taken by the Alliance!|r','',26124),
(13633,'enUS','|cffffff00Crown Guard Tower has been taken by the Horde!|r','',26124),
(13634,'enUS','|cffffff00The Plaguewood Tower has been taken by the Horde!|r','',26124),
(13635,'enUS','|cffffff00Northpass Tower has been taken by the Horde!|r','',26124),
(13636,'enUS','|cffffff00Eastwall Tower has been taken by the Horde!|r','',26124),
(13637,'enUS','|cffff0000All four towers are now in control of the Horde!|r','',26124),
(13638,'enUS','|cff33ccffAll four towers are now in control of the Alliance!|r','',26124),
(13639,'enUS','','What do you want?$B$BIt\'s a bit rude to walk up to strangers for no reason, don\'t you think?',26124),
(13640,'enUS','I can only hope that he will see the Light and instead turn his energies to restoring once-beautiful Quel\'Thalas.','',26124),
(13641,'enUS','Avast ye, matey. Cookie is me name, cooking is me game. The McWeaksauce bloodline be a long line of cooks and tradesmen that work to please the more delicate senses o\' man and woman.','',26124),
(13642,'enUS','Teach me how to cook, Cookie.','Teach me how to cook, Cookie.',26124),
(13643,'enUS','Let me browse your wares, Cookie.','Let me browse your wares, Cookie.',26124),
(13644,'enUS','','Need something?',26124),
(13645,'enUS','I want to become a blacksmith.','I want to become a blacksmith.',26124),
(13646,'enUS','Let me browse your wares, Calypso.','Let me browse your wares, Calypso.',26124),
(13647,'enUS','An ancient being awakens in the distance...','',26124),
(13648,'enUS','More mortals have come seeking the mysteries of Karazhan?','',26124),
(13649,'enUS','What fools! I shall bring a quick end to your suffering!','',26124),
(13650,'enUS','Light be with you, $c.','',26124),
(13651,'enUS','','It looks like help has finally arrived!  The Omenai welcome you to our remnant camp, $n.',26124),
(13652,'enUS','Ikan tries and tries.  I think these Dreghood are much like the Lost Ones, you know... lost.','',26124),
(13653,'enUS','It will take a while, but these Broken Ones will learn the ways of the Light!','',26124),
(13654,'enUS','Welcome, $n. I am Landro Longshot - manager of the Black Flame. Perhaps you\'ve not heard of the Black Flame until now. That doesn\'t surprise me; we work to keep things that way. We prefer to avoid... factional entanglements.$B$BThe Black Flame specializes in providing the finest services and entertainment money can buy, whether they happen to be hard to find items, gladiatorial combat, or lucrative games of chance.$B$BAre you here seeking something specific?','',26124),
(13655,'enUS','What promotions do you have?','What promotions do you have?',26124),
(13656,'enUS','Ah - oddities and rarities. We specialize in Azeroth\'s more unique items for the discerning adventurer.$B$BSince you\'re speaking with me, you must already have an idea of what you\'re looking for. So, $n, which item are you interested in?','',26124),
(13657,'enUS','Red Tabard','Red Tabard',26124),
(13658,'enUS','Thank you, brother.','',26124),
(13659,'enUS','','You won\'t keep me from getting to Falcon Watch!',26124),
(13660,'enUS','Thank you for the blessing, $n.','',26124),
(13661,'enUS','Nothing can stop me now!','',26124),
(13662,'enUS','Your blessing is always welcome, $n.','',26124),
(13663,'enUS','','Do you need something, $c?  Perhaps I can assist you.',26124),
(13664,'enUS','You cannot hide from me, mortal!','',26124),
(13665,'enUS','%s coughs and begins to wheeze.','',26124),
(13666,'enUS','','Thank you, $n.  It looks like they\'re going to get along just fine.',26124),
(13668,'enUS','%s\'s cries awaken the undead. ','',26124),
(13669,'enUS','Blue Tabard','Blue Tabard',26124),
(13670,'enUS','Tabard #3','Tabard #3',26124),
(13671,'enUS','Ogre Disguise','Ogre Disguise',26124),
(13672,'enUS','Hippogryph Hatchling','Hippogryph Hatchling',26124),
(13673,'enUS','Perpetual Purple Firework','Perpetual Purple Firework',26124),
(13674,'enUS','Ogre Costume','Ogre Costume',26124),
(13675,'enUS','Riding Turtle','Riding Turtle',26124),
(13676,'enUS','Enough! I shall land and crush you myself!','',26124),
(13677,'enUS','Insects! Let me show you my strength up close!','',26124),
(13678,'enUS','...a potent concoction!','',26124),
(13682,'enUS','But where could I ever find a suitable test subject?','',26124),
(13683,'enUS','Drink this, you blue brute!  Disobey me and I promise you a slow, painful death!','',26124),
(13684,'enUS','Hmmm... looks like I\'m going to need a new test subject.','',26124),
(13685,'enUS','I pity you, Forsaken.  Your soul is devoid of light.','',26124),
(13686,'enUS','','Dyvuun, is that you?',26124),
(13687,'enUS','Yes, Zhanaa, it\'s me!  Your signal is weak.','',26124),
(13688,'enUS','','I can barely hear you... <static> aking up!',26124),
(13689,'enUS','%s\'s bonds begin to weaken!','',26124),
(13690,'enUS','%s is nearly free of his bonds!','',26124),
(13691,'enUS','%s breaks free!','',26124),
(13692,'enUS','Zhanaa!  Gah, I have to get this thing fixed!','',26124),
(13693,'enUS','Thank you, shaman.  I am reborn and will burn brighter than ever before!','',26124),
(13694,'enUS','%s looks over at Temper as if reluctant to speak.','',26124),
(13695,'enUS','You there!  Keep a close watch on these ramparts, intruders could approach at any time!','',26124),
(13697,'enUS','The Ghostlands will not be won back by military force alone, $n.  That\'s where we magisters come in.$B$BOur guile and knowledge of the arcane are unmatched.','',26124),
(13698,'enUS','Hey, Cookie! What\'s for dinner tonight? And don\'t say chicken!','',26124),
(13699,'enUS','Yarr, Admiral. Let me think about it... Arrr... It be comin\' into focus.','',26124),
(13700,'enUS','It looks like it be succulent pork ribs basted with its own delectable juices and a side o\' Captain Sander\'s Secret Sauce - fer dippin\'.\n','',26124),
(13701,'enUS','And fer dessert we be havin\' cheesecake, flown in fresh from Stormwind on the wings o\' angels...','',26124),
(13702,'enUS','Wow! Really?','',26124),
(13703,'enUS','No. Not really...','',26124),
(13704,'enUS','It be chicken...','',26124),
(13705,'enUS','I hate you so much, Cookie.','',26124),
(13706,'enUS','','<Priestess Il\'dinare eyes you suspiciously.>',26124),
(13707,'enUS','','I am a night elf, stranger. While you may know nothing of my kind, we know much of you and your progenitors. You may not call yourself eredar but, in appearance, you share many similarities.$B$BYou have helped my allies, and for that I am thankful; but for the time being, you walk a tenuous path. Perhaps in time, you will be able to dissolve the doubts and fears that I hold in my heart.',26124),
(13708,'enUS','','Greetings, $r. Your noble actions are acknowledged. May Elune protect you.',26124),
(13709,'enUS','Watch your step around here, stranger.','',26124),
(13710,'enUS','You\'ve been a great help thus far, $n. You would do well to help out the others at the encampment.$B$BAnd don\'t worry about those goblins, I\'m taking care of everything.','',26124),
(13711,'enUS','','Adamant, could you please take a look at this tablet and try to decipher the runes?',26124),
(13712,'enUS','Of course! Anything for you, darling!','',26124),
(13713,'enUS','Alright, let me take a look at that tablet.','',26124),
(13714,'enUS','%s slowly reads the tablet, mouthing the words in their native tongue.','',26124),
(13715,'enUS','Naga warlord! Oh dear...','',26124),
(13716,'enUS','Well, you aren\'t going to like what I have to tell you, young missy. This tablet is a naga communication. Their leader, Warlord Sriss\'tiz, has ordered his naga to take the rest of the island by force.','',26124),
(13717,'enUS','And it looks like he\'s got reinforcements comin\' from Nazjatar!','',26124),
(13718,'enUS','We\'ve got to do something about this!','',26124),
(13719,'enUS','','Thank you, Adamant. I think I know just the person for the job.',26124),
(13720,'enUS','','It is good to see you again, $n. Perhaps once things have settled down, I can talk to you about the priceless treasure that we have lost...',26124),
(13721,'enUS','The Alliance dares to intrude this far into my fortress?  Bring out the Honor Hold prisoners and call for the executioner!  They\'ll pay with their lives for this trespass!','',26124),
(13722,'enUS','Thrall\'s false Horde dares to intrude this far into my fortress?  Bring out the Thrallmar prisoners and call for the executioner!  They\'ll pay with their lives for this trespass!','',26124),
(13723,'enUS','The excecutioner has arrived!  Ready the prisoners!','',26124),
(13724,'enUS','Execute one of the prisoners at once!  Slay the dwarf first... he talks far too much for his own good.','',26124),
(13725,'enUS','Execute one of the prisoners at once!  Slay the tauren first... keep his head as a trophy.','',26124),
(13726,'enUS','It looks like we have a ranking officer among our captives... how amusing.  Execute the Alliance wench!','',26124),
(13727,'enUS','It looks like we have a ranking officer among our captives... how amusing.  Execute this green-skinned dog at once!','',26124),
(13728,'enUS','Slay the last prisoner.  Maybe our intruders will reconsider their foolish actions now!','',26124),
(13729,'enUS','What are you lookin\' at?','',26124),
(13730,'enUS','I am Adamant Ironheart of the great city of Ironforge. As you could probably guess by looking at my uniform, I was once part of the Ironforge elite guard. Yep, I was Magni\'s right hand man! At least until I retired. Now I dabble in archaeology. It\'s a hobby really; plus I figured it would be a great way to see the world!','',26124),
(13731,'enUS','Bring it on, you son of a mangy ogre!','',26124),
(13732,'enUS','','Do your worst, demonspawn!',26124),
(13733,'enUS','Let\'s finish this... I\'ve waited long enough.','',26124),
(13734,'enUS','I spit on you, Kargath.  The true Horde will crush you!','',26124),
(13735,'enUS','You can\'t stop the inevitable, fel orc.  Hellfire Citadel will soon fall.','',26124),
(13736,'enUS','Take a look at me, scum!  This is what a real orc looks like!','',26124),
(13737,'enUS','<Cowlen sobs.>','',26124),
(13738,'enUS','What could I have done to give the gods cause to lash out at me with such ferocity? All that I cherished is gone - dead or destroyed. My family taken from me by the brutes of the forest. My home razed. My ship sunk.$B$BI am a broken man, stranded on a broken island.$B$BPerhaps you are you here to finish the job? Make it quick, I will not resist. Take my life, stranger; I am too cowardly to do it myself. My hand shivers... the blade will not strike true.\n','',26124),
(13739,'enUS','I have not come to kill you, night elf. And the gods did not do this...','I have not come to kill you, night elf. And the gods did not do this...',26124),
(13740,'enUS','If not the gods, who? How? What could cause such strife?','',26124),
(13741,'enUS','I fear that my people are somewhat responsible for this destruction. We are refugees, displaced from our homes by the Burning Legion. This tragedy is a result of our latest evacuation. Our vessel crashed - this debris is a part of that vessel.','I fear that my people are somewhat responsible for this destruction. We are refugees, displaced from our homes by the Burning Legion. This tragedy is a result of our latest evacuation. Our vessel crashed - this debris is a part of that vessel.',26124),
(13742,'enUS','Legion? Demons? They hunt you? My people have also been hunted by Legion: Targeted by their dark masters for damnation.$B$B<Cowlen wipes the tears away.>$B$BIt is the reason that I moved my family here oh-so-many years ago.','',26124),
(13743,'enUS','We have much in common, night elf. I can\'t help but feel that perhaps it was fate that brought us together. Let me help you, Cowlen. Let my people help. We will right the wrongs. This I vow.','We have much in common, night elf. I can\'t help but feel that perhaps it was fate that brought us together. Let me help you, Cowlen. Let my people help. We will right the wrongs. This I vow.',26124),
(13744,'enUS','','Our house is this way, through the thicket.',26124),
(13745,'enUS','','My poor family. Everything has been destroyed.',26124),
(13746,'enUS','','Father! Father! You\'re alive!',26124),
(13747,'enUS','','%s hugs her father.',26124),
(13748,'enUS','','You can thank $n for getting me back here safely, father.',26124),
(13749,'enUS','Daughter!','',26124),
(13750,'enUS','Greetings, $c. Before the night elves invited the draenei to join them here, this glade was all but forgotten.$B$BThe kaldorei are deeply tied to these lands, and we draenei are honored that they have asked us to share in the task of revitalizing Forest Song.','',26124),
(13757,'enUS','','It\'s good to see a new face out here. We\'re barely hanging on and our enemies are plentiful.$B$BWe\'re surrounded by those who seek to destroy us: the satyr to the north, the orcs in the lumber camp here to the east, and the demons of Felfire Hill.$B$BWe\'re going to retake this place if it kills us. It looks like it just might!',26124),
(13758,'enUS','%s Takes a Deep Beath','',26124),
(13759,'enUS','It\'s good to hear the voices of others here in Forest Song again. I\'d begun to feel as though I might be the last of the kaldorei ever to set eyes on these lands before their descent into corruption.','',26124),
(13760,'enUS','capture point Contested1','',26124),
(13761,'enUS','capture point Contested2','',26124),
(13762,'enUS','capture point Win1','',26124),
(13763,'enUS','capture point Win2','',26124),
(13764,'enUS','capture point Progress1','',26124),
(13765,'enUS','capture point Progress2','',26124),
(13766,'enUS','Can you feel the evil all around us, $c? By the Hand, it must be cleansed!$B$BThe demons destroyed our homeworld, Argus. I will NOT countenance their presence here on our new home, Azeroth!','',26124),
(13767,'enUS','Now that the demons have been dealt with, we can proceed with the establishment of a new base here. ','',26124),
(13768,'enUS','%s devours the fabric and hisses angrily!','',26124),
(13769,'enUS','While you\'ve dealt the demonic evil from the south a serious blow, I still sense trouble from that region.','',26124),
(13770,'enUS','','Help me!',26124),
(13771,'enUS','With you and your people as allies, we have decided to stay on this island and rebuild. Elune bless you, hero.$B$BWhile the sadness still comes and goes, I think we will survive.\n','',26124),
(13772,'enUS','You\'re a $r, right?  I am heartened to see you here!  We can use all of the help that we can get.','',26124),
(13773,'enUS','Intruder!','Intruder!',26124),
(13774,'enUS','You are not welcome here!','You are not welcome here!',26124),
(13775,'enUS','%s picks up the naga flag.','',26124),
(13776,'enUS','What\'s the big idea, Spark? Why\'d you call for this meeting?','',26124),
(13777,'enUS','What\'s the big idea? You nearly blew my cover, idiot! I told you to put the compass and navigation maps somewhere safe - not out in the open for any fool to discover.','',26124),
(13778,'enUS','The Master has gone to great lengths to secure information about the whereabouts of the Exodar. You could have blown the entire operation, including the cover of our spy on the inside.','',26124),
(13779,'enUS','Relax, Spark! I have it all under control. We\'ll strip mine the Exodar right out from under \'em - making both you and I very, very rich in the process.','',26124),
(13780,'enUS','Relax? Do you know what Kael\'thas does to those that fail him, Geezle? Eternal suffering and pain... Do NOT screw this up, fool.','',26124),
(13781,'enUS','Our Bloodmyst scouts have located our contact. The fool, Velen, will soon leave himself open and defenseless -- long enough for us to strike! Now get out of my sight before I vaporize you...','',26124),
(13782,'enUS','Yes, sir. It won\'t happen again...','',26124),
(13783,'enUS','So it was you, Spark! How could you? You were a trusted envoy of Mekkatorque!','',26124),
(13784,'enUS','','There are demons to kill, $c.  Do you have the backbone to do what needs to be done?',26124),
(13785,'enUS','%s laughs.','',26124),
(13786,'enUS','You and your kind mean nothing to me, fool. The Master\'s will is all that matters. These ... These draenei will be hunted down and slain -- as will all things on this world. You will cease.','',26124),
(13787,'enUS','Does it frighten you to know that there are those that would serve the Legion with such devotion as to remain unwavering citizens of your pointless civilizations until called upon?','',26124),
(13789,'enUS','Is this the end?','Is this the end?',26124),
(13790,'enUS','What will become of--','What will become of--',26124),
(13791,'enUS','Live in fear, die by the will of Kael\'thas... It\'s all the same.','',26124),
(13792,'enUS','Admiral, I need another tree disguise kit.','Admiral, I need another tree disguise kit.',26124),
(13793,'enUS','What have you done to my life\'s work?!  DIE!!!','',26124),
(13794,'enUS','','Sentinels be on the alert!  I heard something over there...',26124),
(13795,'enUS','','What was that?',26124),
(13796,'enUS','','You won\'t sneak up on me, $c!',26124),
(13797,'enUS','','With a good portion of their demons slain, the Legion will think twice about attacking our lumber camp again.  However, I still sense demonic evil stirring.',26124),
(13798,'enUS','You, hold there!','You, hold there!',26124),
(13800,'enUS','We\'re under attack!','We\'re under attack!',26124),
(13801,'enUS','I am lost...','I am lost...',26124),
(13802,'enUS','Why...?','Why...?',26124),
(13803,'enUS','','You honor us with your presence, $n.',26124),
(13804,'enUS','Another day, another stable to muck out.','Another day, another stable to muck out.',26124),
(13805,'enUS','I grow tired of this routine.','I grow tired of this routine.',26124),
(13806,'enUS','<sigh> Seems like I\'ve been at this forever...','<sigh> Seems like I\'ve been at this forever...',26124),
(13807,'enUS','There was a demon amongs us after all... Just not where we had expected.','',26124),
(13808,'enUS','All hail the exalted hero!','',26124),
(13809,'enUS','The story of your journey will be told for years to come!','',26124),
(13810,'enUS','I finally have a story to tell my grandchildren about... A traitor to the kingdom was living among us!','',26124),
(13811,'enUS','Truth be told, I never liked that gnome...','',26124),
(13812,'enUS','We are lucky to have survived this ordeal. If it wasn\'t for you, everyone on this island could have been killed!','',26124),
(13813,'enUS','I wonder how many more of them live among us. I knew Spark for years - never could I have imagined that he was a traitor.','',26124),
(13814,'enUS','','All hail the exalted hero!',26124),
(13815,'enUS','','The story of your journey will be told for years to come!',26124),
(13816,'enUS','','I finally have a story to tell my grandchildren about... A traitor to the kingdom was living among us!\n',26124),
(13817,'enUS','','Truth be told, I never liked that gnome...',26124),
(13818,'enUS','','We are lucky to have survived this ordeal. If it wasn\'t for you, everyone on this island could have been killed!',26124),
(13819,'enUS','','I wonder how many more of them live among us. I knew Spark for years - never could I have imagined that he was a traitor.',26124),
(13820,'enUS','What is this?','What is this?',26124),
(13821,'enUS','Invaders in the tower!','Invaders in the tower!',26124),
(13822,'enUS','Stop them!','Stop them!',26124),
(13823,'enUS','I am finished!','I am finished!',26124),
(13824,'enUS','No!','No!',26124),
(13825,'enUS','The master... will be angry....','The master... will be angry....',26124),
(13826,'enUS','If we dawdle much longer, there\'ll be hell to pay!\n','If we dawdle much longer, there\'ll be hell to pay!',26124),
(13827,'enUS','The rest are fine without us.','The rest are fine without us.',26124),
(13828,'enUS','They\'ll never know we\'re missing.','They\'ll never know we\'re missing.',26124),
(13829,'enUS','To arms!','To arms!',26124),
(13830,'enUS','Protect the tower!','Protect the tower!',26124),
(13831,'enUS','Have at them!','Have at them!',26124),
(13832,'enUS','Let your death be an example!','Let your death be an example!',26124),
(13833,'enUS','Death to all invaders!','Death to all invaders!',26124),
(13834,'enUS','I have failed....','I have failed....',26124),
(13835,'enUS','You will be punished!','You will be punished!',26124),
(13836,'enUS','You... will... pay.','You... will... pay.',26124),
(13837,'enUS','[Furbolg] Thank you, $n!','',26124),
(13838,'enUS','How dare you interfere?!','How dare you interfere?!',26124),
(13839,'enUS','You do not belong here!','You do not belong here!',26124),
(13840,'enUS','Leave us alone! Let us be!','Leave us alone! Let us be!',26124),
(13841,'enUS','Not... fair...','Not... fair...',26124),
(13842,'enUS','It\'s not my time, not yet!','It\'s not my time, not yet!',26124),
(13843,'enUS','All good things must come to an end.','All good things must come to an end.',26124),
(13844,'enUS','You\'ll ruin everything!','You\'ll ruin everything!',26124),
(13845,'enUS','Off with you!','Off with you!',26124),
(13846,'enUS','We do not wish to be disturbed!','We do not wish to be disturbed!',26124),
(13847,'enUS','Where am I? What--','Where am I? What--',26124),
(13848,'enUS','What is happening?','What is happening?',26124),
(13849,'enUS','I mustn\'t be afraid....','I mustn\'t be afraid....',26124),
(13850,'enUS','%s whimpers.','',26124),
(13851,'enUS','Begone, outsider!','Begone, outsider!',26124),
(13852,'enUS','You\'ll not ruin the celebration!','You\'ll not ruin the celebration!',26124),
(13853,'enUS','We are besieged!','We are besieged!',26124),
(13854,'enUS','You should never have come here!','You should never have come here!',26124),
(13855,'enUS','Now you will pay the ultimate price!','Now you will pay the ultimate price!',26124),
(13856,'enUS','The fates have turned against me!','The fates have turned against me!',26124),
(13857,'enUS','My time is done.','My time is done.',26124),
(13858,'enUS','No, not now! Not like this!','No, not now! Not like this!',26124),
(13859,'enUS','Open your senses, little one. Can you not feel it - the pain, the suffering this tree endured when it was ripped from the nourishing earth? We will heal it and give it peace, though the tree will never grow again.','',26124),
(13860,'enUS','It is done, little one. Now, we must focus our efforts on preventing such destruction from claiming any more victims.','',26124),
(13861,'enUS','I\'ll chop you into minced meat!','I\'ll chop you into minced meat!',26124),
(13862,'enUS','I\'ll gut you like a fish!','I\'ll gut you like a fish!',26124),
(13863,'enUS','I\'ll carve the meat from your bones!','I\'ll carve the meat from your bones!',26124),
(13864,'enUS','I have served to the last....','I have served to the last....',26124),
(13865,'enUS','This isn\'t the end; it can\'t be!','This isn\'t the end; it can\'t be!',26124),
(13866,'enUS','I tried, master. I tried.','I tried, master. I tried.',26124),
(13867,'enUS','%s urges you to follow him.','',26124),
(13868,'enUS','%s points to the totem of Coo.','',26124),
(13869,'enUS','%s motions for you to follow him.','',26124),
(13870,'enUS','[Furbolg] Ritk kin\'chikx azul azure summit...','',26124),
(13871,'enUS','[Furbolg] Coo xip fly... Jump ilos river. Find Tikti.','',26124),
(13872,'enUS','%s points across the river.','',26124),
(13873,'enUS','[Furbolg] Far you mixik tak come. Gaze upon the kitch\'kal river. Follow. Ilog to Yor.','',26124),
(13874,'enUS','%s asks that you follow him.','',26124),
(13875,'enUS','[Furbolg] Go... Search yitix\'kil bottom river. South!','',26124),
(13876,'enUS','Impudent outsiders!','Impudent outsiders!',26124),
(13877,'enUS','Meddling fools! You will pay with your lives!','Meddling fools! You will pay with your lives!',26124),
(13878,'enUS','Wait--no! No!','Wait--no! No!',26124),
(13879,'enUS','You\'ll never make it out alive....','You\'ll never make it out alive....',26124),
(13880,'enUS','','Come play with me!',26124),
(13881,'enUS','','You WILL be mine.',26124),
(13882,'enUS','','Come here, pretty. You have what I need!',26124),
(13883,'enUS','','So I said, \"Yeah, but that\'ll cost you extra.\"',26124),
(13884,'enUS','','Five seconds. I\'m not kidding!',26124),
(13885,'enUS','','He asked if the imp could join in--can you believe it? Actually, it wasn\'t half bad....',26124),
(13886,'enUS','','They fall asleep after. Me, I fall asleep during....',26124),
(13887,'enUS','','Come any closer, and I\'ll scream.',26124),
(13888,'enUS','','I want to show you a different side of me....',26124),
(13889,'enUS','','It was fun while it lasted....',26124),
(13890,'enUS','','<sigh> It\'s always over too soon.',26124),
(13891,'enUS','','I want you to be with me... forever and ever.',26124),
(13892,'enUS','','Shhh... I have a little secret I\'ve been keeping.\n',26124),
(13893,'enUS','','Come play with me!',26124),
(13894,'enUS','','Come play with me!',26124),
(13895,'enUS','','I\'ve been very, very naughty....',26124),
(13896,'enUS','','Enough foreplay. Let\'s get down to business.',26124),
(13897,'enUS','','Just when things were getting interesting.',26124),
(13898,'enUS','','We could have had so much fun!',26124),
(13899,'enUS','','Hmm... it\'s not in this stack. Maybe I left it on the shelf.',26124),
(13900,'enUS','','%s leafs through the pages of a journal.',26124),
(13901,'enUS','[Furbolg] Come, $n. Let us leave the water together, purified.','',26124),
(13902,'enUS','','Aha! Here\'s the sketch I was looking for...',26124),
(13903,'enUS','[Furbolg] We go now, together. We will seek Vark.','',26124),
(13904,'enUS','','Here, Master Nemos, this is the drawing I was talking about.',26124),
(13905,'enUS','','%s offers the journal to Architect Nemos.',26124),
(13906,'enUS','%s accepts the book from Apprentice Boulian and glances at the indicated page.','',26124),
(13907,'enUS','[Furbolg] Follow me to Vark.','',26124),
(13908,'enUS','Ah, yes, I see what you were talking about now. Thank you, Boulian.','',26124),
(13909,'enUS','It\'s a great assignment, yeah, but \"all looking and no touching\" gets old after a while.','It\'s a great assignment, yeah, but \"all looking and no touching\" gets old after a while.',26124),
(13910,'enUS','I think she winked at me.','I think she winked at me.',26124),
(13911,'enUS','This beats patrolling the Opera Hall. Theater people scare me.','This beats patrolling the Opera Hall. Theater people scare me.',26124),
(13912,'enUS','Another sold-out crowd.','Another sold-out crowd.',26124),
(13913,'enUS','Haven\'t I seen tonight\'s show before? I could have sworn...','Haven\'t I seen tonight\'s show before? I could have sworn...',26124),
(13914,'enUS','Urgent business! Yes, but what? And how did I end up here...?','Urgent business! Yes, but what? And how did I end up here...?',26124),
(13915,'enUS','Tickets aren\'t easy to come by, I hear.','Tickets aren\'t easy to come by, I hear.',26124),
(13916,'enUS','You must not interfere!','You must not interfere!',26124),
(13917,'enUS','What are you doing? Be off!','What are you doing? Be off!',26124),
(13918,'enUS','I\'ll miss the show!','I\'ll miss the show!',26124),
(13919,'enUS','Yes, I think I remember now....','Yes, I think I remember now....',26124),
(13920,'enUS','Clear the area!','',26124),
(13921,'enUS','Where\'s your ticket?','',26124),
(13922,'enUS','The show is for guests only!','',26124),
(13923,'enUS','You should not have come here!','',26124),
(13924,'enUS','You\'ll be joining the other guests now....','',26124),
(13925,'enUS','You cannot stop us all!','',26124),
(13926,'enUS','Your death will soon follow....','',26124),
(13927,'enUS','[Furbolg] Hurry, $n. Vark awaits you.','',26124),
(13928,'enUS','You\'re not allowed here!','You\'re not allowed here!',26124),
(13929,'enUS','You\'re not a guest!','You\'re not a guest!',26124),
(13930,'enUS','Am I released from my duties?','Am I released from my duties?',26124),
(13931,'enUS','At last, my work is done.','At last, my work is done.',26124),
(13932,'enUS','Step lively; the master is counting on us!','Step lively; the master is counting on us!',26124),
(13933,'enUS','More paint for the Oz set--yes, I\'ll have to remember....','More paint for the Oz set--yes, I\'ll have to remember....',26124),
(13934,'enUS','How many set changes? Same as last time, I suppose.','How many set changes? Same as last time, I suppose.',26124),
(13935,'enUS','And I MUST have a carafe of sweet nectar in my dressing room. It\'s right there in my contract!','And I MUST have a carafe of sweet nectar in my dressing room. It\'s right there in my contract!',26124),
(13936,'enUS','I told him he would simply have to contact my agent.','I told him he would simply have to contact my agent.',26124),
(13937,'enUS','No, no, that was under the OLD guild rules....','No, no, that was under the OLD guild rules....',26124),
(13938,'enUS','I will not be upstaged by amateurs!','I will not be upstaged by amateurs!',26124),
(13939,'enUS','The show must go on!','The show must go on!',26124),
(13940,'enUS','It\'s so cold, so dark.... I\'m not overacting, am I?','It\'s so cold, so dark.... I\'m not overacting, am I?',26124),
(13941,'enUS','Make sure my name is spelled correctly on the tombst--','Make sure my name is spelled correctly on the tombst--',26124),
(13942,'enUS','Your insolence will not be tolerated!','Your insolence will not be tolerated!',26124),
(13943,'enUS','You were not invited!','You were not invited!',26124),
(13944,'enUS','It\'s all... coming back to me....','It\'s all... coming back to me....',26124),
(13945,'enUS','Is it really over?','Is it really over?',26124),
(13946,'enUS','You will find no reward here, only death!','',26124),
(13947,'enUS','Visitors are forbidden!','',26124),
(13948,'enUS','Free... at last.','Free... at last.',26124),
(13949,'enUS','Time to move on.','Time to move on.',26124),
(13950,'enUS','[Furbolg] Bear witness to the savage acts of our adversaries, $n. They steal our young... our weak... Imprisoned here, they are left to the devices of the Bristlelimb. Set them free, Promised One!','',26124),
(13951,'enUS','Thieves! Stop them!','',26124),
(13952,'enUS','Halt at once!','',26124),
(13953,'enUS','Pillagers! Desecrators!','',26124),
(13954,'enUS','The same fate awaits all who would steal from the master.','',26124),
(13955,'enUS','Death is far too merciful for your kind.','',26124),
(13956,'enUS','You will not make it out alive!','',26124),
(13957,'enUS','Others will take my place!','',26124),
(13958,'enUS','This... changes nothing. Eternal damnation awaits you!\n','',26124),
(13959,'enUS','','Welcome to Forest Song, $c. If there is anything I can do for you, please let me know.',26124),
(13960,'enUS','No! We were here first!','No! We were here first!',26124),
(13961,'enUS','The secrets of the library are ours and ours alone!','The secrets of the library are ours and ours alone!',26124),
(13962,'enUS','A treasure trove of knowledge, ripe for the taking!','A treasure trove of knowledge, ripe for the taking!',26124),
(13963,'enUS','Powers beyond comprehension, all at our fingertips...','Powers beyond comprehension, all at our fingertips...',26124),
(13964,'enUS','Beware... the upper reaches.','Beware... the upper reaches.',26124),
(13965,'enUS','Turn back while you can.','Turn back while you can.',26124),
(13966,'enUS','I wish to browse your wares.','I wish to browse your wares.',26124),
(13967,'enUS','The secrets of this place are not intended for the likes of you!','',26124),
(13968,'enUS','Amateurs! You are far beyond your depth!','',26124),
(13969,'enUS','The tower is no place for the uninitiated!','',26124),
(13970,'enUS','You never should have stepped foot in this place.','',26124),
(13971,'enUS','Your bravado will be rewarded... with death.\n','',26124),
(13972,'enUS','You will succeed only in damning yourselves!','',26124),
(13973,'enUS','Turn back while you can.','',26124),
(13974,'enUS','%s gnaws at the bars of its cage.','',26124),
(13975,'enUS','%s rattles its cage.','',26124),
(13976,'enUS','%s calls for help.','',26124),
(13977,'enUS','%s growls at its captors.','',26124),
(13978,'enUS','[Furbolg] The Stillpine furbolgs will not soon forget your bravery!','',26124),
(13979,'enUS','[Furbolg] Those remaining at Stillpine Hold will welcome you as a hero!','',26124),
(13980,'enUS','[Furbolg] The prophecy is true!','',26124),
(13981,'enUS','You have faced many challenges.... Pity they were all in vain! Soon your people will kneel to MY lord!','',26124),
(13982,'enUS','I\'ve failed... peace is impossible.','',26124),
(13983,'enUS','What in the Light\'s name...?','',26124),
(13984,'enUS','Fel orcs!','',26124),
(13985,'enUS','The cycle of bloodshed is unending... Is there nothing I can do?','',26124),
(13986,'enUS','Do not return, draenei scum.  Next time we won\'t spare your life, unarmed or not!','',26124),
(13987,'enUS','','',26124),
(13988,'enUS','You can die!','',26124),
(13989,'enUS','Yes sir!  I will not fail the Fel Horde!','',26124),
(13990,'enUS','%s signals a charge.','',26124),
(13991,'enUS','What have you done, Makuru?!  These are not our ways!','',26124),
(13992,'enUS','I understand how you feel Makuru.  Sedai was my brother after all.  Yet we can\'t disgrace his memory by going against his very ideals.','',26124),
(13993,'enUS','Don\'t be afraid; we\'re here to aid you. We\'re grateful for the defense you\'ve granted us within our former home, and as a measure of thanks, we\'ve come to help you return quickly to the Plaguelands should you need it. My compatriot can explain the process further; you\'ll find him where the arcane energies are strongest within this city.','Don\'t be afraid; we\'re here to aid you. We\'re grateful for the defense you\'ve granted us within our former home, and as a measure of thanks, we\'ve come to help you return quickly to the Plaguelands should you need it. My compatriot can explain the process further; you\'ll find him where the arcane energies are strongest within this city.',26124),
(13994,'enUS','I am truly sorry, $c, but as your spirit has never before experienced the horrors that lie in wait within the burning wreck of Stratholme, our magic cannot carry you to the city.','I am truly sorry, $c, but as your spirit has never before experienced the horrors that lie in wait within the burning wreck of Stratholme, our magic cannot carry you to the city.',26124),
(13995,'enUS','I can see in your eyes you\'re no stranger to the tragedy within Stratholme. If you wish to end the miserable existence of the poor souls trapped therein, step into the circle. It leads directly to the gates of the burning city itself.','I can see in your eyes you\'re no stranger to the tragedy within Stratholme. If you wish to end the miserable existence of the poor souls trapped therein, step into the circle. It leads directly to the gates of the burning city itself.',26124),
(13996,'enUS','The orcs hate us, Obadei!  They\'ve killed many of us before!  They deserve death and worse.','',26124),
(13997,'enUS','No!  Not... Sedai!  The orcs must pay!','',26124),
(13998,'enUS','[Furbolg] Behold the prophecy!','',26124),
(13999,'enUS','Do you smell that?  Fresh meat has somehow breached our citadel.  Be wary of any intruders.','',26124),
(14000,'enUS','Intruders!  Hold them off until I can release the warhounds!','',26124),
(14001,'enUS','You\'re too late, now feel the wrath of my warhounds!','',26124),
(14002,'enUS','<The footman stand resolute, muscles tense.>','',26124),
(14003,'enUS','Stop it with this Light nonsense.  The swamp is where we need to go!  We belong there!','',26124),
(14004,'enUS','Bah!  Suit yourselves.  We\'re leaving!','',26124),
(14005,'enUS','I... I want to hear about the Light.  I think... I remember...','',26124),
(14006,'enUS','Welcome, my brethren!  You\'ve been freed from demons.  Embrace the teachings of Velen!  Embrace the light!','',26124),
(14007,'enUS','As we attempt to gain the help of the peoples of this world against the Burning Legion, we must also learn to live peaceably amongst them.$B$BPlease keep this in mind as your journey takes you throughout Azeroth.  May the Light guide you.','',26124),
(14008,'enUS','Control Human Footman','Control Human Footman',26124),
(14009,'enUS','[Furbolg] Spirits grant us vision!','',26124),
(14010,'enUS','I am ready to be flown down to the Exodar.','I am ready to be flown down to the Exodar.',26124),
(14011,'enUS','What brings you all the way up here, little $r?','',26124),
(14012,'enUS','Are you ready, $n?','',26124),
(14013,'enUS','','Greetings, $c.  I get so few visitors up here.  To what do I owe the pleasure?',26124),
(14014,'enUS','','Susurrus is expecting you, $n.',26124),
(14015,'enUS','You are brave to swim down to my realm, land-walker.','',26124),
(14016,'enUS','','I have been expecting you.',26124),
(14017,'enUS','I wish to learn more about blacksmithing.','I wish to learn more about blacksmithing.',26124),
(14018,'enUS','Be careful out in the desert, $c.','',26124),
(14019,'enUS','The sound of footsteps shuffling echo throughout the cave.','',26124),
(14020,'enUS','What\'s that $T scrub : girlie;?  You want your mommy?  Well too bad.  Maybe you should pay a visit to the Thrallmar officer\'s club to get her back?','',26124),
(14021,'enUS','Do you know where you are?  This is Honor Hold, sweetheart!  Love it or get out!','',26124),
(14022,'enUS','You stay away from crystals! Die now!','',26124),
(14023,'enUS','This isn\'t a field trip, maggot!  You\'re in the Outland now!  Shape up or take a stroll back through the portal.','',26124),
(14024,'enUS','I have neither the time, nor the inclination, to explain things to you, scumbag!  Now do you have something important to say, or are you just here to ask me out for a drink, princess?','',26124),
(14025,'enUS','What is your major malfunction?!','',26124),
(14026,'enUS','I\'ve seen you prancing around.  Why don\'t you do us all a favor and just drop your gear off at the armory?','',26124),
(14027,'enUS','Who in name of Kurdran let you through the Dark Portal?','',26124),
(14028,'enUS','Well, well, well, what have we here?  A $T civilian : civilian;?  Isn\'t that precious?  You\'ll get no special treatment from me!','',26124),
(14029,'enUS','%s roars!','',26124),
(14030,'enUS','','These pictographs tell a story. This figure at the beginning, almost looks like one of the creatures we encountered at Azure Watch...',26124),
(14031,'enUS','','No, this can\'t be... It says this creature willingly became a servant of the Legion. He transforms into a satyr and receives the Legion\'s \"blessing.\"',26124),
(14032,'enUS','','We must defeat these satyr, $n. We will not suffer the Legion\'s presence in these lands.',26124),
(14033,'enUS','Keep your voice down, $c!','',26124),
(14034,'enUS','If you have something to say, say it!','',26124),
(14035,'enUS','You\'re a $T civilian : civilian;?','',26124),
(14036,'enUS','I\'m busy, make it fast!','',26124),
(14037,'enUS','[Furbolg] There is currently an assault in progress. We must wait before unleashing another!','',26124),
(14038,'enUS','Stillpine raiders, the time to strike is at hand! Charge!','',26124),
(14039,'enUS','Have you spoken with the high priestess yet?  She\'s very eager to hear the tale of the pilgrimage from your point of view.','',26124),
(14040,'enUS','How fares your search for the Mark?','',26124),
(14041,'enUS','This is a great day, $c!','',26124),
(14042,'enUS','I cannot thank you enough for making my pilgrimage possible!','',26124),
(14043,'enUS','Me not like this one...','',26124),
(14044,'enUS','Hey, you numbskull!','',26124),
(14045,'enUS','We kill his friend!','',26124),
(14046,'enUS','Smash!','',26124),
(14047,'enUS','Why don\'t you let me do the talking?','',26124),
(14048,'enUS','If you nice me let you live.','',26124),
(14049,'enUS','[Furbolg] What could it mean?','',26124),
(14050,'enUS','About time the guild sent some new blood our way! Too bad you came all this way for nothing. We\'re not allowed to put on a show for our guests, can you believe it? Moroes has forbidden us from starting a new show, and my backers are going nuts! Something needs to be done about Moroes.','',26124),
(14051,'enUS','Finally, everything is in place. Are you ready for your big stage debut?','',26124),
(14052,'enUS','I\'m not an actor.','I\'m not an actor.',26124),
(14053,'enUS','Don\'t worry, you\'ll be fine. You look like a natural!','',26124),
(14054,'enUS','Ok, I\'ll give it a try, then.','Ok, I\'ll give it a try, then.',26124),
(14055,'enUS','Intruders are upon us!  Help me, brothers!','',26124),
(14056,'enUS','Splendid. I\'m going to get the audience ready. Break a leg!','',26124),
(14057,'enUS','Good evening ladies and gentlemen, welcome to this evening\'s presentation!','',26124),
(14058,'enUS','Acteon, where is the best area to hunt for moongraze stags?','Acteon, where is the best area to hunt for moongraze stags?',26124),
(14059,'enUS','Moongraze stags can be found grazing south and east of Azure Watch.','',26124),
(14060,'enUS','Acteon, where is the best place to hunt moongraze bucks?','Acteon, where is the best place to hunt moongraze bucks?',26124),
(14061,'enUS','Just north of Azure Watch is where you will have the best luck finding moongraze bucks.$B$BHappy hunting, $n!','',26124),
(14062,'enUS','Where can I find more infected nightstalker runts, Exarch?','Where can I find more infected nightstalker runts, Exarch?',26124),
(14063,'enUS','The infected nightstalker runts seem to be coming from the north. If I were you, that\'s where I would start my hunt.','',26124),
(14064,'enUS','%s roars in pain! ','',26124),
(14065,'enUS','Magtoor, thank you for allowing me to stay here with you.  I\'m sure that there is much that we can learn from each other.  And I\'m eager to learn all that I can of the Lost Ones to the east.','',26124),
(14066,'enUS','Great Tzerak, in the name of Zevrax, we summon you forth!','',26124),
(14067,'enUS','Cast down the enemies of the Burning Legion, rain down destruction upon those who would oppose us!','',26124),
(14068,'enUS','Of course, my friend.  You are welcome to stay with us for as long as you like.','',26124),
(14069,'enUS','Long have we craved your return! Command us in the destruction of the Legion\'s greatest foes!','',26124),
(14070,'enUS','Fools! Weaklings! Tzerak has no need of your assistance!','',26124),
(14071,'enUS','Wow, you totally bombed out there. Let\'s think of that as a rehearsal, shall we? Ready to go out again?','',26124),
(14072,'enUS','%s throws his head back and laughs.','',26124),
(14073,'enUS','Entering Phase 3 <PH>','',26124),
(14074,'enUS','The wolf\'s going down.','The wolf\'s going down.',26124),
(14075,'enUS','Why do you traffic with the Horde?  Their foul ways are beneath you.','',26124),
(14076,'enUS','A-ha! Found one!','',26124),
(14077,'enUS','Another one!','',26124),
(14078,'enUS','Oh that\'s a big one!','',26124),
(14079,'enUS','I wonder if you can really hear the ocean in these things.','',26124),
(14080,'enUS','It\'s ironic, I hate the ocean but I love the beach.','',26124),
(14081,'enUS','We have no choice.  If we fail to honor the presence of the Horde, then surely they will crush us from nearby Stonard!  I\'m afraid that not even you and your friends would be able to stop them.','',26124),
(14082,'enUS','Yes Master, all goes along as planned.','',26124),
(14083,'enUS','%s places the shell in his pack.','',26124),
(14084,'enUS','%s holds the shell up to his ear.','',26124),
(14085,'enUS','I must find a way to put an end to the evil that Cersei Dusksinger is committing against our lost brothers and sisters!','',26124),
(14086,'enUS','%s examines the shell.','',26124),
(14087,'enUS','Be careful, Avuun.  One of the merchants that I trade with in Stonard has heard her raving about some horrible disease she\'s trying to perfect.  They say it\'s for use against the draenei!','',26124),
(14088,'enUS','Anchorite, we are honored that you are here, but I am curious as to what you truly believe you can accomplish?','',26124),
(14089,'enUS','Magtoor, I have faith that there is a way to bring the Lost Ones back from the brink.  By studying them, I will find a way to cure the fel energies that have consumed them.  And in so doing, I will be able to reverse the damage to the Broken as well.','',26124),
(14090,'enUS','And now, I cut you!','',26124),
(14091,'enUS','DIE!','',26124),
(14092,'enUS','Can\'t you see that I\'m busy?','',26124),
(14093,'enUS','It\'s over, Spark. The admiral knows it was you who betrayed the Alliance. Now you\'re either going to cooperate with me and tell me everything that you know or we\'re going to engage in some fisticuff.','It\'s over, Spark. The admiral knows it was you who betrayed the Alliance. Now you\'re either going to cooperate with me and tell me everything that you know or we\'re going to engage in some fisticuff.',26124),
(14094,'enUS','','Hahaha!  That fool will never find out what I\'m up to!  Or, if he does, it\'ll be too late for the draenei!',26124),
(14095,'enUS','','These orcs are fools!  So much power nearby just waiting to be taken, and all they do is sit on their hands and watch while others plunder the riches!',26124),
(14096,'enUS','','I cannot wait to see the results of this latest batch!',26124),
(14097,'enUS','','Avuun dares to oppose me?!  I will crush him!  When I am done with the draenei, they\'ll wish that they were Lost Ones!',26124),
(14098,'enUS','','Oh, would you please stop checking your nails and spanking yourself, for one moment?  Really, no one cares!',26124),
(14099,'enUS','','Are you hungry?  I\'m hungry.  I just can\'t stand the thought of cured ham steak from Thultash again.  If only we could get some of that succulent roasted quail!',26124),
(14101,'enUS','','I need some fresh air, not that there\'s any to be had in this swamp!  I\'m going out for a bit.  Tidy up a bit while I\'m gone, would you?',26124),
(14102,'enUS','','Must you follow me everywhere? <sigh>',26124),
(14103,'enUS','','Look at her down there!  Just who does she think she is?',26124),
(14104,'enUS','Hmph, no doubt she believes herself to be the new mistress of Stonard.  Perhaps we should offer to help her succubi tidy up her messes?','',26124),
(14105,'enUS','Her methods are cowardly.  She reminds me of the Forsaken apothecaries.','',26124),
(14106,'enUS','','You have something to say to my face?',26124),
(14107,'enUS','','I thought not!',26124),
(14108,'enUS','Putting the bottles away, %s sighs.','',26124),
(14109,'enUS','%s stares at you in sheer wonderment.','',26124),
(14110,'enUS','I run now!','',26124),
(14111,'enUS','How did I let myself get stationed here?','',26124),
(14112,'enUS','Uther Lightbringer brought only darkness to Quel\'Thalas.  Let us see if we can bring some darkness to his tomb!','',26124),
(14113,'enUS','','%s inspects the contents of the crates.',26124),
(14114,'enUS','What is taking so long?','',26124),
(14115,'enUS','At last I will have my revenge!','',26124),
(14116,'enUS','The brazier fires upon the helpless orc! [PH]','',26124),
(14117,'enUS','Rough audience, but you\'ll win them over. Ready for another shot?','',26124),
(14118,'enUS','Welcome ladies and gentlemen, to this evening\'s presentation!','',26124),
(14119,'enUS','The romantic plays are really tough, but you\'ll do better this time. You have TALENT. Ready?','',26124),
(14120,'enUS','I\'ll nail it!','I\'ll nail it!',26124),
(14121,'enUS','I\'ve never been more ready.','I\'ve never been more ready.',26124),
(14122,'enUS','Welcome ladies and gentlemen, to this evening\'s presentation!','',26124),
(14123,'enUS','[Furbolg] Mil\'ork kix ilfin o oomtor...','',26124),
(14124,'enUS','[Furbolg] Poorov\'tarkh!','',26124),
(14125,'enUS','[Furbolg] Yar vartslaf?','',26124),
(14126,'enUS','[Furbolg] Boro gomsho!','',26124),
(14127,'enUS','You feeble dogs are still weak!','',26124),
(14128,'enUS','Beg and tremble before my power!','',26124),
(14129,'enUS','They call you the Fel Horde\'s elite? Yet, you still tremble in my presence!','',26124),
(14130,'enUS','Beg for your pitiful life!','',26124),
(14131,'enUS','You are nothing to me. ','',26124),
(14132,'enUS','Run, coward, run!   ','',26124),
(14133,'enUS','Flee, peon!','',26124),
(14134,'enUS','Fight!','',26124),
(14135,'enUS','That\'s enough. Now back off!','',26124),
(14136,'enUS','It hurt!','',26124),
(14137,'enUS','Augh! No more hurt!','',26124),
(14138,'enUS','This not good tickle!','',26124),
(14139,'enUS','Skin on fire!','',26124),
(14140,'enUS','It hurt!','',26124),
(14141,'enUS','Aahhh!','',26124),
(14142,'enUS','No more scary!','',26124),
(14143,'enUS','Mommy!','',26124),
(14144,'enUS','No more!','',26124),
(14145,'enUS','Until you can endure the shadow fires, you remain at my mercy!','',26124),
(14146,'enUS','Be seared with the shadow!','',26124),
(14147,'enUS','A few burns are nothing to the Fel Horde!','',26124),
(14148,'enUS','Your pain amuses me!','',26124),
(14149,'enUS','Pain!','',26124),
(14150,'enUS','It hurts!','',26124),
(14151,'enUS','Graaagggh!!','',26124),
(14152,'enUS','No more!!','',26124),
(14153,'enUS','Yes! Run while you still can!','',26124),
(14154,'enUS','How can I help you, stranger?','',26124),
(14155,'enUS','I wish to browse your wares, Ergh.','I wish to browse your wares, Ergh.',26124),
(14156,'enUS','Gurf is my name, stranger. Gurf the Brave!','',26124),
(14157,'enUS','Please teach me how to skin, Gurf.','Please teach me how to skin, Gurf.',26124),
(14158,'enUS','I am Moordo, elder hunter of Stillpine.','',26124),
(14159,'enUS','I wish to become a leatherworker, Moordo. Please train me.','I wish to become a leatherworker, Moordo. Please train me.',26124),
(14160,'enUS','Welcome to my shop!','',26124),
(14161,'enUS','Hello, Parkat. I wish to purchase something.','Hello, Parkat. I wish to purchase something.',26124),
(14162,'enUS','Ah, the Promised One has arrived. Welcome to Stillpine Hold.','',26124),
(14163,'enUS','Good tidings, $c. I am Stillpine the Younger, heir to the throne of Stillpine.','',26124),
(14164,'enUS','It is you who will defend my people and usher in a new era of prosperity for Stillpine!','',26124),
(14165,'enUS','Kill as many infected nightstalkers as I can find... This should be easy.','Kill as many infected nightstalkers as I can find... This should be easy.',26124),
(14166,'enUS','Thanks for the heal, $n!','Thanks for the heal, $n!',26124),
(14167,'enUS','Help! I think this creature might be too tough for me to handle alone.','Help! I think this creature might be too tough for me to handle alone.',26124),
(14168,'enUS','Can anyone hear me? I need help! This creature is going to kill me!','Can anyone hear me? I need help! This creature is going to kill me!',26124),
(14169,'enUS','I can\'t hold it off any longer! Tell the exarch that I gave it my best.','I can\'t hold it off any longer! Tell the exarch that I gave it my best.',26124),
(14170,'enUS','Thanks again!','Thanks again!',26124),
(14171,'enUS','Another victory for the draenei!','Another victory for the draenei!',26124),
(14172,'enUS','Another infected beast destroyed!','Another infected beast destroyed!',26124),
(14173,'enUS','How could you think yourself a match for the draenei champion!','How could you think yourself a match for the draenei champion!',26124),
(14174,'enUS','Hah! This is easy.','Hah! This is easy.',26124),
(14175,'enUS','I\'m supposed to be hunting infected nightstalkers... This should be easy.','I\'m supposed to be hunting infected nightstalkers... This should be easy.',26124),
(14176,'enUS','Where in the nether are these damnable lashers??','Where in the nether are these damnable lashers??',26124),
(14177,'enUS','Hrm, azure snapdragons? Where do they come up with these names? Daedal has gone mad!','Hrm, azure snapdragons? Where do they come up with these names? Daedal has gone mad!',26124),
(14178,'enUS','These stags are nothing like talbuks.','These stags are nothing like talbuks.',26124),
(14179,'enUS','I wonder what that little purple creature at the village is... It\'s certainly beautiful.','I wonder what that little purple creature at the village is... It\'s certainly beautiful.',26124),
(14180,'enUS','Time to meet your maker, $n!','Time to meet your maker, $n!',26124),
(14181,'enUS','Your money or your life! Actually, just your life will do...','Your money or your life! Actually, just your life will do...',26124),
(14182,'enUS','Your death will make a fitting tribute to the King!','Your death will make a fitting tribute to the King!',26124),
(14183,'enUS','For Silvermoon! For Sunstrider!','For Silvermoon! For Sunstrider!',26124),
(14184,'enUS','I\'m afraid I\'m rather busy fixing horseshoes at the moment.  Would you mind coming back at another time?','',26124),
(14185,'enUS','I once served Medivh... or pretended to.  I helped the Violet Eye keep a close eye on the Master.$B$BBut now all I can think of is... making horseshoes.  Over and over.','',26124),
(14186,'enUS','Look at the size of your head! That should fetch me twice as much of a bounty!','Look at the size of your head! That should fetch me twice as much of a bounty!',26124),
(14187,'enUS','You know about the Violet Eye then?  Maybe I\'ll have time for you later.$B$BI have to get back to my work.','',26124),
(14188,'enUS','I\'m in need of your skill as a blacksmith, Koren.','I\'m in need of your skill as a blacksmith, Koren.',26124),
(14189,'enUS','','<Eralan appears to be chewing on some deathweed.>$b$bIf you\'re looking to make a love potion, you\'ve got the wrong place.  Blinding, crippling, and killing is my business and hopefully yours.',26124),
(14190,'enUS','I can sense your desire for power, $c.','I can sense your desire for power, $c.',26124),
(14191,'enUS','Your faith guides me to victory.','',26124),
(14192,'enUS','The Light gives us the strength and magic to triumph.','The Light gives us the strength and magic to triumph.',26124),
(14193,'enUS','Lok-Narash! Prepare to strike down the outsiders! Warriors, rally!\n','',26124),
(14194,'enUS','Drive them out! We take none alive! ','',26124),
(14195,'enUS','Two enemy factions. Both deserve to drown in blood. Who will taste death this day?\n','',26124),
(14196,'enUS','We ride! For the Fel Horde! For Victory! \n','',26124),
(14197,'enUS','FOR THE FEL HORDE!\n','',26124),
(14199,'enUS','Lok\'tar! For victory!','',26124),
(14200,'enUS','Raiders, join ranks! On Korfang\'s signal, charge forth and crush these cowardly dogs! Forward!\n','',26124),
(14201,'enUS','The Alliance has stood against us for decades! Even now they \n mock us with the towers they have built on our land! \n','',26124),
(14202,'enUS','Thrall\'s traitors have abandoned the path to true power! They should die for their insolence and stupidity!\n','',26124),
(14203,'enUS','Hear my words, Korfang!','',26124),
(14204,'enUS','Then let those towers be their tombs! Lay waste to them!\n','',26124),
(14205,'enUS','So be it! They will curse Thrall for a fool once they have tasted our strength! To the towers!\n','',26124),
(14206,'enUS','The Fel Horde is on the move!','',26124),
(14207,'enUS','A Fel Horde scout! What\'s he looking for?','',26124),
(14208,'enUS','We\'re under attack! Take your positions!\n','',26124),
(14209,'enUS','They are assaulting Thrallmar!','',26124),
(14210,'enUS','Kill them all!','',26124),
(14211,'enUS','Where is your precious earth magic now?','',26124),
(14212,'enUS','The better to own you with!','',26124),
(14213,'enUS','Run away little girl, run away!','',26124),
(14214,'enUS','%s bellows its approval.','',26124),
(14215,'enUS','','Welcome to the Registrar of Guilds.  How can I be of service to you?',26124),
(14216,'enUS','','Hello, my child.',26124),
(14217,'enUS','Oh, grandmother, what big ears you have.','Oh, grandmother, what big ears you have.',26124),
(14218,'enUS','','The better to hear you with, my child.',26124),
(14219,'enUS','Oh, grandmother, what big eyes you have.','Oh, grandmother, what big eyes you have.',26124),
(14220,'enUS','','The better to see you with, my child.',26124),
(14221,'enUS','Oh, grandmother, what phat lewts you have.','Oh, grandmother, what phat lewts you have.',26124),
(14223,'enUS','','Thank the Light, $n, my leg is completely healed!',26124),
(14224,'enUS','','Please tell Guvan that I\'ll be fine, thanks to you.',26124),
(14225,'enUS','Wonderful! You made it!','',26124),
(14226,'enUS','Did it give you much trouble? My poor little baby, $r are such nasty company.','',26124),
(14227,'enUS','Well it\'s about time. Kessel isn\'t gonna be too happy about any of this...','',26124),
(14229,'enUS','Who dares wield magic in my presence?','Who dares wield magic in my presence?',26124),
(14230,'enUS','What...','',26124),
(14231,'enUS','%s is consumed by its own magic!','',26124),
(14232,'enUS','Greetings, young shaman.  Make yourself at home within my reef.','',26124),
(14233,'enUS','Together we will deal with this corruption of the water.','',26124),
(14234,'enUS','You have done a great thing, $n.  You are welcome here at any time.','',26124),
(14235,'enUS','%s bursts forth from the ground and attacks!','',26124),
(14236,'enUS','You Kessel?','You Kessel?',26124),
(14237,'enUS','I am. What is it that I can do for you?','I am. What is it that I can do for you?',26124),
(14238,'enUS','We\'ve got orders from the harbinger to pick up some elekk for the base.','We\'ve got orders from the harbinger to pick up some elekk for the base.',26124),
(14239,'enUS','Nonsense. These are not the elekk you\'re looking for.','',26124),
(14240,'enUS','These are not the elekk we\'re looking for.','These are not the elekk we\'re looking for.',26124),
(14241,'enUS','You can go about your business.','',26124),
(14242,'enUS','The %ss nod their heads in unison.','The %ss nod their heads in unison.',26124),
(14243,'enUS','We will go about our business now. Good day.','We will go about our business now. Good day.',26124),
(14244,'enUS','Weren\'t we supposed to do something?','Weren\'t we supposed to do something?',26124),
(14245,'enUS','Hrm. Nothing comes to mind.','Hrm. Nothing comes to mind.',26124),
(14246,'enUS','%s shrugs.','%s shrugs.',26124),
(14247,'enUS','Wrong!  It is YOU that will die, Tel\'athion the Impure!','',26124),
(14248,'enUS','It is YOU who are wrong!  I will deal with you two after I have slain this meddlesome shaman!','',26124),
(14249,'enUS','Entering Phase 2 <PH>','',26124),
(14250,'enUS','Master chef, can you train me in the culinary arts?','Master chef, can you train me in the culinary arts?',26124),
(14251,'enUS','<Sigh> I suppose, if I must.','',26124),
(14252,'enUS','Have you any cooking supplies?','Have you any cooking supplies?',26124),
(14253,'enUS','Yes, but be quick with your browsing.','',26124),
(14254,'enUS','%s roars in pain and attacks its assailant.','',26124),
(14255,'enUS','','Come for some blacksmithing supplies, have ya?',26124),
(14256,'enUS','I\'ve got fresh meat, fish and mushrooms.  And plenty to drink!','',26124),
(14257,'enUS','','Greetings, $n.  As you rise in rank among the forces of Honor Hold, I will give you access to some of the different goods we keep in stock.',26124),
(14258,'enUS','Show me what I\'ve earned the right to purchase.','Show me what I\'ve earned the right to purchase.',26124),
(14259,'enUS','Come intruders....','',26124),
(14260,'enUS','I am Admetius, leader of Blood Watch.','',26124),
(14261,'enUS','Welcome to Thrallmar, $n!  As you continue to aid us in our cause, I will grant you access to more of our supplies.','',26124),
(14262,'enUS','Morae... Is that you?','',26124),
(14263,'enUS','No... you\'re not Morae, but I sense that you have met. When you see her, tell her that I survived the crash, only to be done in by the infiltrators.','',26124),
(14264,'enUS','Let her know... my last thought was of her...','',26124),
(14265,'enUS','%s calls for assistance.','',26124),
(14266,'enUS','Need me to take care of your animal companions?','',26124),
(14267,'enUS','I wish to make use of the stables.','I wish to make use of the stables.',26124),
(14268,'enUS','On Argus, Mac\'Aree was the most sacred of our cities.$B$BWould you believe me if I told you that the walkways were lined with precious minerals? That the rivers glittered even in complete darkness?$B$BI long for those days... How long has it been? A thousand years? Ten-thousand?','',26124),
(14269,'enUS','If only I could get back to the mushroom thicket. I have not seen such a mature cluster in my lifetime!','',26124),
(14270,'enUS','It will be done, my lady.','',26124),
(14271,'enUS','You have new orders, maggots.','',26124),
(14272,'enUS','It is none of your concern, maggot.','',26124),
(14273,'enUS','Out of my way!','',26124),
(14274,'enUS','You dare impede official Sunhawk communications?','You dare impede official Sunhawk communications?',26124),
(14275,'enUS','Touch not the horse, filth!','',26124),
(14276,'enUS','Sire, any news from the king?','Sire, any news from the king?',26124),
(14277,'enUS','Sironas stirs, master? Does she toil?','Sironas stirs, master? Does she toil?',26124),
(14278,'enUS','I will smite them all in the name of Sunstrider!','I will smite them all in the name of Sunstrider!',26124),
(14279,'enUS','Draenei filth will not last on this world...','Draenei filth will not last on this world...',26124),
(14280,'enUS','What does gotcher mean?','What does gotcher mean?',26124),
(14281,'enUS','Now, let\'s see...','',26124),
(14282,'enUS','In the process of translating this, I believe I\'ve learned more about the drunken exploits of a certain \'Andrew Clementine\' than about the journal\'s author.','',26124),
(14283,'enUS','But, no matter. Mister Clementine\'s... err, \'contribution\' notwithstanding, this seems to be the journal of a man named Nolkai. The entries toward the end describe a brutal battle.','',26124),
(14284,'enUS','Jessera, could you direct me towards the aquatic stinkhorn?','Jessera, could you direct me towards the aquatic stinkhorn?',26124),
(14285,'enUS','Take a look at this passage...','',26124),
(14286,'enUS','Look in the waters that divide this island, but be warned: the stinkhorn striker makes its home in the waters of the river.','',26124),
(14287,'enUS','Jessera, could you direct me towards the ruinous polyspore?','Jessera, could you direct me towards the ruinous polyspore?',26124),
(14288,'enUS','Welcome to Blood Watch, $c. In my travels, I have amassed a wide variety of tools, artifacts, and knowledge from the various peoples we\'ve encountered.$B$BShould you find yourself in need of this knowledge, you have only to ask.','',26124),
(14289,'enUS','As the name suggests, it can be found near ruins. Loreth\'Aran holds the answer.$B$BActually, the name doesn\'t really suggest that -- I was just trying to be clever in naming the fungi.','',26124),
(14290,'enUS','Jessera, could you direct me towards the fel cone fungus?','Jessera, could you direct me towards the fel cone fungus?',26124),
(14291,'enUS','Fel cone derives its name from fel magic corruption. Seek the fel cone fungus at the Nazzivian satyr camp - to the west.','',26124),
(14292,'enUS','Jessera, could you direct me towards the blood mushrooms?','Jessera, could you direct me towards the blood mushrooms?',26124),
(14293,'enUS','Blood mushrooms are more common than the other fungi varieties and can be found mostly anywhere in the woods around Bloodmyst. Keep your search south of the road dividing Bloodmyst if you value your life.','',26124),
(14294,'enUS','What have you done, wizard?  This cannot be!  I\'m burning from... within!','',26124),
(14295,'enUS','You\'ve got my attention, dragon.  You\'ll find I\'m not as easily scared as the villagers below.','',26124),
(14296,'enUS','Your dabbling in the arcane has gone too far, Medivh.  You\'ve attracted the attention of powers beyond your understanding.  You must leave Karazhan at once!','',26124),
(14297,'enUS','You dare challenge me at my own dwelling?  Your arrogance is astounding, even for a dragon!','',26124),
(14298,'enUS','A dark power seeks to use you, Medivh!  If you stay, dire days will follow.  You must hurry, we don\'t have much time!','',26124),
(14299,'enUS','I do not know what you speak of, dragon... but  I will not be bullied by this display of insolence.  I\'ll leave Karazhan when it suits me!','',26124),
(14300,'enUS','You leave me no alternative.  I will stop you by force if you won\'t listen to reason!','',26124),
(14301,'enUS','If you only learn one thing during your time in Bloodmyst, $c, I hope that it is vigilance. This island claims the unwary first, then begins to wear down even the most guarded of warriors.$B$BEverywhere you turn, a foe stands ready to take your life. ','',26124),
(14302,'enUS','','Everything that has happened since the crash is little more than a blur. It seems like a lifetime ago that I was aboard the Exodar.$B$BNow, my reality is restricted to this island with its mutant creatures and endless sea of blood elf agents. Soon, it will be as if I\'ve never known anything different...',26124),
(14303,'enUS','The others look at this landscape and see only death, corruption, and adversity. None of those things are in short supply, true, but that view ignores the opportunities presented by our environment.$B$BI will not stand by and watch these opportunities go ignored, $c. With your help, we can demonstrate to the others here at Blood Watch just how to make use of the environment and its creatures.','',26124),
(14304,'enUS','Hello, $c.$B$BOld man Kessel over there, he\'s a clever one. I\'d be real careful in my dealings with him if I were you.$B$BHe offered me work \'caring for the elekk\' and being the fool I was, I took it to mean feeding, training, and the like. Things became real clear when he handed me the shovel...','',26124),
(14305,'enUS','I should res right now.','I should res right now.',26124),
(14306,'enUS','To arms! The prisoner is escaping!','To arms! The prisoner is escaping!',26124),
(14308,'enUS','%s begins to cast a spell of great power, weaving his own essence into the magic.','',26124),
(14309,'enUS','Invaders have breached the defenses!','',26124),
(14310,'enUS','Archers, form ranks! On my mark!','',26124),
(14311,'enUS','Ready!','',26124),
(14312,'enUS','Thanks for the warning, $n! We shall prepare!','',26124),
(14313,'enUS','Promised One, we thank you for the warning. The Stillpine tribe will be prepared.','',26124),
(14314,'enUS','Thank you for the warning, $n. We will prepare our defenses.','',26124),
(14315,'enUS','','I\'m going back inside.  Let me know if anything else comes up.',26124),
(14316,'enUS','He should not have angered me.  I must go... recover my strength now...','',26124),
(14317,'enUS','I am Kessel, lord of the elekk, disciple of the Hand of Argus. Are you the new recruit?','',26124),
(14318,'enUS','','All those years of research... and for nothing! Perhaps they were right, perhaps this is something we must learn to live with.',26124),
(14319,'enUS','Holding his nose, %s scoops up the dung and places it in his bucket.','',26124),
(14320,'enUS','I\'ll do what I can.  No promises, though.  This weapon has been completely shattered.','',26124),
(14321,'enUS','The metal was salvageable.  I should be able to reforge the weapon as a sword or a dagger.','',26124),
(14322,'enUS','Face the wrath of Bristlelimb!','',26124),
(14323,'enUS','Thank you for saving me, $n! My father will be delighted!','',26124),
(14324,'enUS','I am Achelus, chief expeditionary officer of Blood Watch.','',26124),
(14325,'enUS','I deliver the mail to and from Azuremyst, $c. If you need a message delivered, it\'ll more than likely be routed through me first.','',26124),
(14326,'enUS','What it means to be a Hand of Argus... We are agents of the Light. We serve without question. We die without question.','',26124),
(14327,'enUS','Did they send you to find me? Well I\'m not going back without my men.','',26124),
(14328,'enUS','Don\'t you people ever check the mail?','',26124),
(14329,'enUS','How am I expected to deliver all of these messages?','',26124),
(14330,'enUS','I need to be re-assigned. This job is pushing me over the edge...','',26124),
(14331,'enUS','One of these days I\'m going to bust out the crystalline doomhammer and go positively orc on this town. Then they\'ll be sorry...','',26124),
(14332,'enUS','He thinks he\'s so damned important. Always pushing me around... I\'ll show him. I\'ll show all of them!','',26124),
(14333,'enUS','Hey Hermesius, do I have any new mail?','',26124),
(14334,'enUS','Hermesius, has my package from the Exodar arrived yet? It\'s been over a week.','',26124),
(14335,'enUS','Hermesius come quick! I have an urgent delivery that must be taken to the human admiral of the Alliance expedition.','',26124),
(14336,'enUS','What\'s going on over there at your delivery service? How are we expected to function when our mail is never here on time?','',26124),
(14337,'enUS','IF YOU THINK THIS IS SO EASY, GRAB A BAG AND GET TO WORK!','',26124),
(14338,'enUS','Otherwise, get off my back! One of these days you won\'t have old Hermesius to push around anymore. That much I can promise...','',26124),
(14339,'enUS','','Hey Hermesius, do I have any new mail?',26124),
(14340,'enUS','','Hermesius, has my package from the Exodar arrived yet? It\'s been over a week.',26124),
(14341,'enUS','','Hermesius come quick! I have an urgent delivery that must be taken to the human admiral of the Alliance expedition.',26124),
(14342,'enUS','','What\'s going on over there at your delivery service? How are we expected to function when our mail is never here on time?',26124),
(14343,'enUS','','You must be the laziest messenger known to draenei.',26124),
(14344,'enUS','You must be the laziest messenger known to draenei.','',26124),
(14345,'enUS','You dare strike an agent of the Hand?','',26124),
(14346,'enUS','We\'re free! We\'re free!','We\'re free! We\'re free!',26124),
(14347,'enUS','Woot! Thanks!','Woot! Thanks!',26124),
(14348,'enUS','By the forehead signet of Velen, I am saved!','By the forehead signet of Velen, I am saved!',26124),
(14349,'enUS','I knew Cornelius wouldn\'t leave us behind!','I knew Cornelius wouldn\'t leave us behind!',26124),
(14350,'enUS','Your death will satisfy our master.','Your death will satisfy our master.',26124),
(14351,'enUS','Yes, I am one of the \'Broken\'.  I trust that this does not bother you?  Broken or draenei, we must endure the ridicule that some in our society may throw at us.  A better understanding and communication with the elements of this world is all that matters.','Yes, I am one of the \'Broken\'.  I trust that this does not bother you?  Broken or draenei, we must endure the ridicule that some in our society may throw at us.  A better understanding and communication with the elements of this world is all that matters.',26124),
(14352,'enUS','Please, sit and make yourself comfortable.','Please, sit and make yourself comfortable.',26124),
(14353,'enUS','Ahhh.... Yes, the blood of the exiles fills me with power! Beware, Bloodmyst!','',26124),
(14354,'enUS','Come, followers of Kael, let us destroy our enemies! Let us show them that there is no escape from the Eredun!','',26124),
(14355,'enUS','This siege has gone dormant for far too long, let us destroy the Draenei and their pitiful city!','',26124),
(14356,'enUS','Now, kill them all!','',26124),
(14357,'enUS','Good day, $c. Are you in need of a reliable hippogryph?','',26124),
(14358,'enUS','I desire to travel by hippogryph.','I desire to travel by hippogryph.',26124),
(14359,'enUS','If you need to travel to the Exodar, I have just the hippogryph for you!','',26124),
(14360,'enUS','I wish to travel by hippogryph.','I wish to travel by hippogryph.',26124),
(14361,'enUS','%s begins to rust!','',26124),
(14362,'enUS','Shh! Be very quiet; I\'m observing murlocs.$B$BLiving in an oversized turtle shell is a sacrifice I\'m willing to make for science. After all, if the murlocs see me here, they\'ll react to my presence and contaminate my data!$B$BAs the first gnomish member of the Explorers\' League, I\'m boldly going places no dwarf has gone before!','',26124),
(14363,'enUS','Now I\'m coming for you, Exarch!','',26124),
(14364,'enUS','','The spirits of this place are focused against your kind, $r. Perhaps if you win this tower in the flesh, I will be able to aid you.',26124),
(14365,'enUS','Defend yourself, youngling! We\'ll see if there\'s a Blood Knight in you, yet.','',26124),
(14366,'enUS','Who dares defile the statue of our beloved?','',26124),
(14367,'enUS','This is... Silvermoon? My head... Next time Bloodvalor needs a volunteer, I\'ll point him in a different direction. Paragon of Blood Knight virtue, indeed!','',26124),
(14368,'enUS','Don\'t get me wrong, $n. I very much appreciate the resurrection, but I think this is the last time I\'ll perform this particular duty. Maybe a goblet or two of wine will help with this headache.','',26124),
(14369,'enUS','Are you mad? Look around you, mortal. Do you not see that you stand upon sundered earth? Leave this place lest you suffer as my people and I have...','',26124),
(14370,'enUS','Why do you suffer?','Why do you suffer?',26124),
(14371,'enUS','Are you blind as well as insane?$B$BI am a ghost - a cruel reminder of a civilization that has long since ceased to exist - anchored to a land that I failed to protect.$B$BLong ago - ten-thousand years past - I was flesh and bone, just like you. I was prince of this land and a dragon rider, blessed by Ysera of the Dream.','',26124),
(14372,'enUS','What is Ysera and how were you blessed?','What is Ysera and how were you blessed?',26124),
(14373,'enUS','Have you not heard of Ysera? Guardian of nature? Aspect of the Dream? She is the matron of all green dragons! Aye, it was Ysera herself that gifted my kingdom with her brood. We stood shoulder to shoulder with the noble creatures and they allowed us to ride them into battle against our enemies. All was well for many centuries... until...','',26124),
(14374,'enUS','Until what?','Until what?',26124),
(14375,'enUS','Deathwing\'s brood... Ysera\'s benevolence raised the ire of Deathwing - patron of the black dragonflight. They attacked us in our sleep! Many died on the initial surge but the greens rose to protect us.$B$B<Prince Toreth points around the island.>$B$BThe bones are all that remain of the once great dragons. None were spared.','',26124),
(14376,'enUS','So why are you still here?','So why are you still here?',26124),
(14377,'enUS','I was the last to die. As I felt my spirit leaving my mortal shell, I swore a blood oath.$B$B<Prince Toreth shakes his head.>$B$BA pact was made between this land and I: My blood for this world. I became the sole keeper of the history of my people.$B$BI cannot rest until I am secure in knowing that the story of the dragon riders of Loreth\'Aran is not lost in the passages of time.\n','',26124),
(14378,'enUS','Students are a bit like sheep.  They\'re useful and even likeable when you guide and pay close attention to them.$B$BYou leave them alone for a minute and they end up falling down a cliff or drowning in a shallow river.','',26124),
(14379,'enUS','This sign contains various announcements and notices of rewards for performing dangerous sounding tasks.  Nothing particularly catches your eye; perhaps you should check again at a later time.','',26124),
(14380,'enUS','Wiping his brow, the %s sighs.','Wiping her brow, the %s sighs.',26124),
(14381,'enUS','Turning to face Tuluun, the %s sneers contemptuously.','Turning to face Tuluun, the %s sneers contemptuously.',26124),
(14382,'enUS','We do not need your kind here.','We do not need your kind here.',26124),
(14383,'enUS','How can I be expected to get any work done with that thing spreading its heresy?','How can I be expected to get any work done with that thing spreading its heresy?',26124),
(14384,'enUS','The %s sighs disgustedly as he turns back to his work.','The %s sighs disgustedly as he turns back to his work.',26124),
(14385,'enUS','Greetings, citizen. I ask that you move along if you have nothing to ask of me.','',26124),
(14386,'enUS','Marshal Windsor has been expecting you, $n. Unfortunately, he is currently indisposed. He should be returning shortly.','',26124),
(14387,'enUS','You made it! Outstanding! Marshal Windsor has been expecting you. Would you like me to signal him now?','',26124),
(14388,'enUS','Let Marshal Windsor know that I am ready.','Let Marshal Windsor know that I am ready.',26124),
(14389,'enUS','The signal has been sent. He should be arriving shortly.','',26124),
(14390,'enUS','Hail, champion. The tale of your deeds will be told throughout the ages. Perhaps one day, a statue of you will stand amongst the heroes of Stormwind.','',26124),
(14391,'enUS','Stay away from me, $r! There\'s no telling when the sickness will take me again.$B$BJust leave me alone before it happens again.','',26124),
(14392,'enUS','Listen to me, human. I care nothing for your plight, but you have something I require. Tell me where to find the bloodforged ingots.','Listen to me, human. I care nothing for your plight, but you have something I require. Tell me where to find the bloodforged ingots.',26124),
(14393,'enUS','How did you learn about the ore? Not even the Baron knew...$B$BTake the cursed things. They\'ve brought me nothing but misfortune anyway. I hid them in the stables just off the courtyard.$B$B<A low growl begins to emanate from the back of Landen\'s throat.>','',26124),
(14394,'enUS','','',26124),
(14395,'enUS','%s howls in rage.','',26124),
(14396,'enUS','','You will tell me everything I need to know, scum.',26124),
(14397,'enUS','','Where are our men, scoundrel? I want answers!',26124),
(14398,'enUS','','Aren\'t you hungry? Thirsty? I can arrange for food and drink -- all you need to do is tell me what I want to know.',26124),
(14399,'enUS','','If these two don\'t start talking soon, I\'m going to get violent with my words.',26124),
(14400,'enUS','You dare speak to me, blue skinned mongrel? I would sooner die than tell you anything.','You dare speak to me, blue skinned mongrel? I would sooner die than tell you anything.',26124),
(14401,'enUS','%s spits on Interrogator Elysia.','%s spits on Interrogator Elysia.',26124),
(14402,'enUS','%s laughs.','%s laughs.',26124),
(14403,'enUS','We happily drink in your blue blood, draenei. Nothing gives us more pleasure than to wound you just to see the blood flow.','We happily drink in your blue blood, draenei. Nothing gives us more pleasure than to wound you just to see the blood flow.',26124),
(14404,'enUS','Get back to work you!','',26124),
(14405,'enUS','Wake up! Now get up and back to work!','',26124),
(14406,'enUS','Insolent fool! You thought to steal Zelemar\'s blood? You shall pay with your own!','',26124),
(14407,'enUS','Examining the corpse, you conclude that this must be Blood Knight Dawnstar, the leader of the failed assault on Deatholme.','',26124),
(14408,'enUS','Search the corpse for an insignia.','Search the corpse for an insignia.',26124),
(14409,'enUS','I can help you establish a guild.','',26124),
(14410,'enUS','A search of the corpse\'s clothing and equipment reveals the insignia you need, undamaged by the battle and foul environment.','',26124),
(14411,'enUS','','Elune\'s grace upon you.  How can I serve?',26124),
(14412,'enUS','Hurry up with it already! The longer you take, the more of a hurtin\' I\'m putting on you!','',26124),
(14413,'enUS','What is this?! Didn\'t mommy and daddy teach you anything?!','',26124),
(14414,'enUS','This is terrible..... my arms grow tired from beating on you lazy peons!','',26124),
(14415,'enUS','Too soon! You are slacking off too soon!','',26124),
(14416,'enUS','Yes master, anything you say.','',26124),
(14417,'enUS','','Greetings, $c.  It is good you\'ve decided to visit us.',26124),
(14418,'enUS','You have served one of three with honor, $n. Our time is at an end. Kuros will call for you when he is ready.','',26124),
(14419,'enUS','A %s spots medical supplies.','A %s spots medical supplies.',26124),
(14420,'enUS','%s picks up medical supplies.','%s picks up medical supplies.',26124),
(14421,'enUS','Sorry, you lose! <PH>','Sorry, you lose! <PH>',26124),
(14422,'enUS','Greetings, $c. I am Kuros, second of the Triumvirate of the Hand.','',26124),
(14428,'enUS','I watched as they beat him without mercy. Their ruthless lieutenant acted as if such cruelty was an act of normalcy. Through the savage beatings, I could feel myself breaking.$B$BAs I watched Vindicator Saruan take their blows, I began to weep. Not out of fear... I wept out of sadness. To see a draenei of the Triumvirate treated in such a manner. If only I could have broken free of my bonds. If only...\n','',26124),
(14429,'enUS','<Turn to the next page.>','<Turn to the next page.>',26124),
(14430,'enUS','After what seemed an eternity, the Vindicator lost consciousness. The torture was too much, even for him. The cruel one - Matis as I found out he was called - attempted to wake Saruan by splashing contagion laced water across his ravaged body. But Saruan did not wake.\n','',26124),
(14431,'enUS','I wanted to scream but only a low gasp escaped my lips. I was promptly beaten for this act of rebellion. As I lay on the ground, I could see Matis pacing in front of Saruan\'s body. He seemed visibly concerned. He stated that Sironas or Sirona or some such entity would have his flesh flayed from his bones if Saruan had perished in the beatings. \n','',26124),
(14432,'enUS','That the Sironas entity had plans for Saruan... $B$B<The writing stops abruptly and a long line scrolls off the page. This draenei died while making the entry.>\n','',26124),
(14433,'enUS','','Remember, $n!  Remain within Dawning Street and you will reach the Inner Elf Gate!',26124),
(14434,'enUS','sqwaks in the innkeeper\'s direction and makes its way back towards Sunstrider Isle.','',26124),
(14435,'enUS','Good day, $c. If you wish to learn the smith\'s art, you\'ve come to the right place.','',26124),
(14436,'enUS','I seek training as a Blacksmith.','I seek training as a Blacksmith.',26124),
(14437,'enUS','','Oh, pay no mind to Buddy.  He won\'t hurt you, he just likes to scratch now and then.$B$BHe\'s just a big, loveable kitty.$B$BAren\'t you Buddy?  Yes, you are, you cute, little thing.  You\'re mommy\'s little baby, that\'s what you are!',26124),
(14438,'enUS','%s arranges the materials on the anvil.','',26124),
(14439,'enUS','%s\'s face twists in revulsion as he realizes what Bemarrin is doing. He turns his back and walks away.','',26124),
(14440,'enUS','Pay no attention to their kind, $n. The sacrifices made by your order are lost on them. They will never understand the price you pay for the power you wield in their defense.','',26124),
(14441,'enUS','There, $n. It is done.','',26124),
(14442,'enUS','We Cenarion druids are the protectors of the balance of nature.  The main point being the balance.  When called for, we shouldn\'t wait too long before taking decisive action.  Don\'t let anyone tell you otherwise, especially those of us who only want to observe!','',26124),
(14443,'enUS','Stand back, $n. There are going to be a lot of sparks.','',26124),
(14444,'enUS','%s falls unconscious.','',26124),
(14445,'enUS','Return to Kuros. I will bring him to Blood Watch.','Return to Kuros. I will bring him to Blood Watch.',26124),
(14446,'enUS','We\'ve got you now, $n!','We\'ve got you now, $n!',26124),
(14447,'enUS','You will never take me alive!','',26124),
(14448,'enUS','To the death!','',26124),
(14449,'enUS','You will regret this, maggot.','',26124),
(14450,'enUS','Hi, $n. Click the option below to complete quest 9711 -- Matis the Cruel.$B$BNote that nothing happens even though I am attempting to cast a spell.','',26124),
(14451,'enUS','You complete me.','You complete me.',26124),
(14452,'enUS','Cast another spell on me that uses the exact same implicit target but has a different effect -- like death touch.','Cast another spell on me that uses the exact same implicit target but has a different effect -- like death touch.',26124),
(14453,'enUS','I am at your service, my lord.','I am at your service, my lord.',26124),
(14454,'enUS','I want all of your trackers out in search of the criminal, Matis the Cruel. I have given trusted agents of the Hand flare guns. Should you or one of your trackers see the flare, it means that an agent has found Matis and needs assistance. And remember, tracker, Matis is to be brought back to me alive.','',26124),
(14455,'enUS','It will be done, my lord.','It will be done, my lord.',26124),
(14456,'enUS','%s calls forth their brethren.','%s calls forth their brethren.',26124),
(14457,'enUS','Brothers and sisters, tonight we hunt! A blood elf known as Matis must be brought to justice! The first to find him gets one week\'s vacation aboard the Exodar!','Brothers and sisters, tonight we hunt! A blood elf known as Matis must be brought to justice! The first to find him gets one week\'s vacation aboard the Exodar!',26124),
(14458,'enUS','Onward! The wilds of Bloodmyst await!','Onward! The wilds of Bloodmyst await!',26124),
(14459,'enUS','Let the trial begin! Bloodwrath, attack!','',26124),
(14460,'enUS','Champion Lightrend, make me proud!','',26124),
(14461,'enUS','Thrall has escaped!  Don\'t let him get away!','Thrall has escaped!  Don\'t let him get away!',26124),
(14462,'enUS','Show this upstart how a real Blood Knight fights, Swiftblade!','',26124),
(14463,'enUS','Show $n the meaning of pain, Sunstriker!','',26124),
(14464,'enUS','Well done, $n! You have passed the second trial!','',26124),
(14465,'enUS','There he is, stop him!','There he is, stop him!',26124),
(14466,'enUS','Don\'t let him get away!','Don\'t let him get away!',26124),
(14467,'enUS','Who are you?  Just leave me be.','',26124),
(14468,'enUS','We are ready to get you out of here, Thrall. Let\'s go!','We are ready to get you out of here, Thrall. Let\'s go!',26124),
(14470,'enUS','Your beloved leader has failed you! Let your blood be on his hands! Attack!\n','',26124),
(14471,'enUS','Victory is a stone\'s throw away!  Lok\'tar Ogar!','',26124),
(14472,'enUS','What\'s the status on the primary tank?','',26124),
(14473,'enUS','What is that thing doing inside the tank?\n','',26124),
(14475,'enUS','Any word from Mennu on the relief we requested? ','',26124),
(14477,'enUS','Sir, we\'re doing everything we can to address the leak!','',26124),
(14478,'enUS','Still leaking, sir. ','Still leaking, sir. ',26124),
(14479,'enUS','We\'re doing everything we can to stop the water.','We\'re doing everything we can to stop the water.',26124),
(14480,'enUS','We can\'t seem to stop the pumps. ','We can\'t seem to stop the pumps. ',26124),
(14481,'enUS','No idea. ','No idea. ',26124),
(14482,'enUS','This is the first time I\'ve ever seen anything like it. ','This is the first time I\'ve ever seen anything like it. ',26124),
(14483,'enUS','It probably caused the leak!','It probably caused the leak!',26124),
(14484,'enUS','No word since the disturbance earlier, sir. ','No word since the disturbance earlier, sir. ',26124),
(14485,'enUS','There\'s been trouble contacting Mennu, sir!','There\'s been trouble contacting Mennu, sir! ',26124),
(14486,'enUS','Our messenger to the slave pens never returned, sir.','Our messenger to the slave pens never returned, sir.',26124),
(14488,'enUS','Well, hurry up! Lord Illidan has no patience for mistakes!','',26124),
(14489,'enUS','Keep trying, we need to get this water out of here. ','',26124),
(14490,'enUS','Bah! Incompetent!','',26124),
(14491,'enUS','Perhaps if he spent less time playing with his pet Goblin and more time training we\'d have enough power to fix this thing!','',26124),
(14492,'enUS','Ugh, what a bunch of slackers.','',26124),
(14493,'enUS','I don\'t remember saying they could take a break!','',26124),
(14494,'enUS','Remind me to dock them for leaving without permission!','',26124),
(14495,'enUS','Hurry up, Lady Vashj expects results! ','',26124),
(14496,'enUS','%s sniggers.','',26124),
(14498,'enUS','%s nods in agreement.','',26124),
(14499,'enUS','%s giggles.','',26124),
(14500,'enUS','%s smirks.','',26124),
(14501,'enUS','%s sneers.','',26124),
(14502,'enUS','%s snorts.','',26124),
(14503,'enUS','Where should I begin my search for the portal?','Where should I begin my search for the portal?',26124),
(14504,'enUS','Begin your search to the north, $n. Our scouts have spotted the Warp Piston near the shoreline.','',26124),
(14505,'enUS','Tell me of your past, Farseer.','Tell me of your past, Farseer.',26124),
(14506,'enUS','My story? It is kind of you to ask. Very well.$B$BLong ago on the planet Draenor - the remains of which are now known as the Outland - all of the draenei lived in peace. But then the Burning Legion came, and they corrupted the orcs with their fel magics.$B$BWith no other option we fought to survive, but exposure to these fel energies had horrible effects upon some of us, over time transforming us into the Broken like me, or worse, the seemingly mindless Lost Ones.$B$BShall I go on?','',26124),
(14507,'enUS','Yes, please continue.','Yes, please continue.',26124),
(14508,'enUS','The fel energies also had the side-effect on the Broken and the Lost Ones of cutting us off from the Light. At the time I did not know exactly why, but as a vindicator I insisted on finding out. I decided to make a pilgrimage to do just that.$B$BAnd so it was that after the war came to its fateful end, I journeyed into the desert of the fragmented planet, beseeching the Light to return to us. But decades passed, and the Light never answered my prayers.$B$BIs this something that you wish to hear more of?','',26124),
(14509,'enUS','Yes, please, if you do not mind.','Yes, please, if you do not mind.',26124),
(14510,'enUS','I had been fortunate to find an oasis and made the decision to stay there until I received an answer. So there I sat, moving only when absolutely necessary, living off of the creatures that would come near the pool. Such was my pride.$B$BAs I said, decades passed without an answer. But I can remember a particularly beautiful sunset one evening. A warm zephyr blew across the land and I was sure that I heard a voice, but no one was around.$B$BAs you can imagine, I thought that I was finally losing my mind.','',26124),
(14511,'enUS','Nobundo, please continue.','Nobundo, please continue.',26124),
(14512,'enUS','There was something strange about that wind; it didn\'t stop. For weeks it blew across the land, waxing and waning, but never ceasing. And all the time the voice continued, though I could not understand it, nor did I know where it was coming from.$B$BMy time in solitude had taught me how to calm myself and look inward. This I did in order to keep my sanity. And that is when I began to understand the voice. It was coming from the wind itself and it had much to say!','',26124),
(14513,'enUS','What did it say to you?','What did it say to you?',26124),
(14514,'enUS','It spoke to me of secrets and power, and also of truths. The Light had not forsaken the Broken! The fel energies that the orcs had wielded long ago against the draenei had infused us, causing a break in our ability to be heard by, or perhaps to hear, the Light. The same that had been responsible for the degradation of our bodies.$B$BBut our spirits were not broken, and the air offered to me another path, through which I might deliver my people.\n','',26124),
(14515,'enUS','What was that?','What was that?',26124),
(14516,'enUS','It taught me the path of shamanism, which in a way is just another facet of the Light. Joining the wind was the water of the oasis, the fire from my camp and the earth upon which I sat. All had something to say.$B$BOver the next few years they taught me what it was to call upon and be one with the elements of the world. And they told me that the worlds of all of the stars in the sky, even this one, are made up of these elements.$B$BBut the day came when I felt that I had learned enough to leave.','',26124),
(14517,'enUS','What did you do then?','What did you do then?',26124),
(14518,'enUS','I returned to my people and was greeted with smiling faces and outstretched arms, mostly from the Broken. The prejudices against us from many draenei had continued in my absence. But it was as if they knew that I was coming, and I soon found out why.$B$BVelen, the prophet and leader of all of the draenei, had seen my return in one of his visions and was there to greet me as well. He asked to speak with me in private and as I related my story to him, he nodded and smiled, for this too he had foreseen.','',26124),
(14519,'enUS','Bring forth the blood elf.','',26124),
(14520,'enUS','Sorry, you win! <PH>','Sorry, you win! <PH>',26124),
(14521,'enUS','Please, go on.','Please, go on.',26124),
(14522,'enUS','You heard the Prophet. Move, filth.','You heard the Prophet. Move, filth.',26124),
(14523,'enUS','Velen urged me to take a leadership role amongst the Broken. But more importantly, he asked me to teach shamanism to all; Broken and draenei alike. I accepted.$B$BWe knew then that given the prejudices of some that this would be a difficult proposition at best. There are those that despise the Broken because we are a frightening reminder of the past. And there are others who believe the way of the shaman to be a blasphemy against the Light.$B$BIn any case, that is my tale.','',26124),
(14524,'enUS','Matis, blood elf lieutenant of the Sunhawks, you have been found guilty of genocide against the draenei people.','',26124),
(14525,'enUS','You are to be executed at light\'s dawning. Have you anything to say for yourself?','',26124),
(14526,'enUS','%s spits at the image of Velen.','',26124),
(14527,'enUS','May the Light have mercy on your soul. Take him back to his cell.','',26124),
(14528,'enUS','%s glares at Velen.','',26124),
(14529,'enUS','The Light?','',26124),
(14530,'enUS','%s laughs.','',26124),
(14531,'enUS','I am Blood Knight, mongrel. I do not serve the Light, the Light serves me. If mercy is to be granted, it will be by me.','',26124),
(14532,'enUS','You seek to martyr me before my order - so be it. Strike me down, another will rise in my place and the suffering of the Light - of the conquered - will continue uninterrupted.','',26124),
(14533,'enUS','You blaspheme! The Light would never allow such an aberration!','',26124),
(14534,'enUS','The Light has no choice. It does as it is commanded. Just as the naaru you hold at the core of your vessel will do when we capture and enslave it... Do my words surprise you, blue blood? Yes, we know... We know everything.','',26124),
(14535,'enUS','Take him away.','',26124),
(14536,'enUS','Move!','Move!',26124),
(14537,'enUS','Draenei dog! Did you know that the one you call Saruan wept like a babe as I beat him? A feeling of euphoria coursed through me, knowing that I had a member of high rank in my grasp. Were it not for Sironas\' plans for him, I would have tortured him to death... As I do to all draenei that I capture. Alas, I am certain that you will see him again soon...\n','',26124),
(14538,'enUS','%s grins wickedly.','',26124),
(14539,'enUS','Breathe your last breath, heathen.','',26124),
(14540,'enUS','%s spits on the corpse of Matis.','',26124),
(14541,'enUS','Find their source of power and tear it down. Tear all of it down.','',26124),
(14542,'enUS','If our enemies would see that we only wish to live in harmony with them, maybe we wouldn\'t have to attack them for our own survival?','',26124),
(14543,'enUS','Their day will come, $n.$B$BAnd when it does, I will be there.','',26124),
(14544,'enUS','With new enemies on our doorsteps, we must not allow our ancient enemies to take advantage of our situation!','',26124),
(14545,'enUS','','Can you believe this place?  \'Course, it\'s a mite stuffy up here if you ask me.',26124),
(14546,'enUS','Say, you happen to see that arch in the lake to the west?  I wonder where that goes?  I should go divin\' over there.','',26124),
(14547,'enUS','Filthy fungal giants!  What did we ever do to them?','',26124),
(14548,'enUS','','If only I hadn\'t twisted my ankle coming into this place, I\'d be in there with my friends.  Hmmm, now that I think about it, maybe it\'s better that I\'m out here?',26124),
(14549,'enUS','Fhwoor like little sporelings.  They save Fhwoor.  Not eat them.$B$BFhwoor hate naga.  Fhwoor smash!','',26124),
(14550,'enUS','I must concentrate! Guards! Guards! Aid me!','I must concentrate! Guards! Guards! Aid me!',26124),
(14551,'enUS','Count yourself blessed that I fear the wrath of Kael\'thas more than death, else I would break from this channel and disintigrate you.','Count yourself blessed that I fear the wrath of Kael\'thas more than death, else I would break from this channel and disintigrate you.',26124),
(14552,'enUS','Protect the portal!','Protect the portal!',26124),
(14553,'enUS','You will never know such discipline.','You will never know such discipline.',26124),
(14554,'enUS','You hit like a child.','You hit like a child.',26124),
(14555,'enUS','Pathetic, really. Is that the best you can do?','Pathetic, really. Is that the best you can do?',26124),
(14556,'enUS','Like the phoenix, I shall be reborn.','Like the phoenix, I shall be reborn.',26124),
(14557,'enUS','I... have... failed...','I... have... failed...',26124),
(14558,'enUS','Forgive me, master.','Forgive me, master.',26124),
(14559,'enUS','My comrades will... will... arrrrgghhh...','My comrades will... will... arrrrgghhh...',26124),
(14560,'enUS','Sunstrider shall be victorious!','Sunstrider shall be victorious!',26124),
(14561,'enUS','You only delay the inevitable...','You only delay the inevitable...',26124),
(14562,'enUS','I lost my Weathered Treasure Map. Do you have a spare copy of it?','I lost my Weathered Treasure Map. Do you have a spare copy of it?',26124),
(14563,'enUS','I am Aesom, third of the Triumvirate.','',26124),
(14564,'enUS','As a matter of fact, I did. I was going to frame it and show it to the guys in Ironforge for a laugh, but you\'re welcome to it.','',26124),
(14565,'enUS','The wind speaks of our enemies\' movements, Ashyen.  The naga will attack again.','',26124),
(14566,'enUS','Prudence should not mean granting our enemy unnecessary advantages.','',26124),
(14567,'enUS','Very well.  When that decision is made, I will be ready.  Let us hope it won\'t be too late.','',26124),
(14568,'enUS','We\'d do well not to be reckless.  There\'s still much to learn about this land and about the enemy.','',26124),
(14569,'enUS','We will act when we know what we need, old friend.  The druids have proven wise and capable of making their own decisions.','',26124),
(14570,'enUS','Here lie the remains of Weeder Greenthumb, one of Watcher Jhang\'s druid companions.  By all appearances he was killed quick and clean while trying to make his escape from the Slave Pens.','',26124),
(14571,'enUS','I almost made it!$B$BI came in here to prove the existence of Quagmirran, that most mythical of fungal giants.  I got my wish, sort of.$B$BYou must let me free!  In return I will grant you a boon to help you to deal with Quagmirran.','',26124),
(14572,'enUS','The protective tendrils of arcane energy have been lifted. The sun gate is vulnerable!','',26124),
(14573,'enUS','The sun gate must be stabilized. Focus your energies!','The sun gate must be stabilized. Focus your energies!',26124),
(14574,'enUS','Alright, Bite, I\'ll let you out.','Alright, Bite, I\'ll let you out.',26124),
(14575,'enUS','Uh oh!  It would appear that all of the noise you\'ve been making has attracted some unwanted attention!','',26124),
(14576,'enUS','Very well.  Onward to fame and glory!','',26124),
(14577,'enUS','Who dares disturb the sanctity of the Alonsus Chapel?','',26124),
(14578,'enUS','Oh mighty Quagmirran, we beseech thee to welcome us into your presence!','',26124),
(14580,'enUS','What you have done is abominable! Atone for your crimes against the Light!','',26124),
(14581,'enUS','False paladin, show yourself! Prepare to taste the wrath of the Light\'s true servants!','',26124),
(14582,'enUS','Filthy animals!  Cage me will you?!','',26124),
(14583,'enUS','<Naturalist Bite growls.> You took my worldly possessions, but you will NEVER take my soul!','',26124),
(14584,'enUS','I... HAVE HAD ENOUGH... OF... YOU!','',26124),
(14585,'enUS','I like to think myself a reasonable fellow in an unreasonable situation.','',26124),
(14586,'enUS','Nothing will stop me from fulfilling my destiny!','',26124),
(14587,'enUS','There is no other way, blasphemer. Prepare to meet your fate.','',26124),
(14588,'enUS','I can go around you, or through you.  Your choice!','',26124),
(14589,'enUS','Not the face... Not the face!!!','',26124),
(14590,'enUS','Is it really wrong of me to seek my petty revenge?','',26124),
(14591,'enUS','Thank goodness for you!  Claw and I were investigating this place when we were jumped by Swamplord Musel\'ek.$B$BUnfortunately, Claw was caught in bear form at the time, and is now the swamplord\'s pet.$B$BI\'m afraid you\'ll have to fight Claw in order to save him.','',26124),
(14592,'enUS','As the only apparent surviving \'Broken\', it is both my duty and honor to carry on the shamanistic teachings of Farseer Nobundo.','As the only apparent surviving \'Broken\', it is both my duty and honor to carry on the shamanistic teachings of Farseer Nobundo.',26124),
(14593,'enUS','','Damn those blood elves and their reckless magic!',26124),
(14594,'enUS','Do not waste my time.  What is it you want?','Do not waste my time.  What is it you want?',26124),
(14595,'enUS','Fool! Do you know what you\'ve done? This is sacred ground!','',26124),
(14596,'enUS','[PH] Encounter Complete!','',26124),
(14597,'enUS','How embarrassing to be taken as a pet by a hunter!$B$BI owe you my life.  Now that you\'ve freed me from Musel\'ek, I\'ll be able to find my way out.','',26124),
(14598,'enUS','Kill them before they grow!','Kill them before they grow!',26124),
(14599,'enUS','Filthy void beast! DIE!','Filthy void beast! DIE!',26124),
(14600,'enUS','Destroy the vermin!','Destroy the vermin!',26124),
(14601,'enUS','Sironas will have our skulls if these are allowed to grow!','Sironas will have our skulls if these are allowed to grow!',26124),
(14602,'enUS','Tune \'em up good, boys!','',26124),
(14603,'enUS','Watcher Leesa\'oh, why are you out here?','Watcher Leesa\'oh, why are you out here?',26124),
(14604,'enUS','','May the Light bend to your will in all endeavors.',26124),
(14605,'enUS','','All things in nature exists in an interconnected web; an ecology.  If we\'re careful not to disturb it, and simply observe, we may be fortunate to piece together the complex relationship between the diverse organisms around us.$B$BOnce we have that understanding, we can take the appropriate actions to ensure the wellbeing of all creatures.  Interfere without that knowledge, and we\'ll surely cause destruction.$B$BI am here to observe the complex interactions between the sporelings and the bog lords.',26124),
(14606,'enUS','I have run out of extinguishing mixture. May I have another vial?','I have run out of extinguishing mixture. May I have another vial?',26124),
(14607,'enUS','','Of course, $n.',26124),
(14608,'enUS','','$n, let\'s go see if this plan will work.  Come along, Buddy!',26124),
(14609,'enUS','','Ok, let\'s see about using those mushrooms you brought back to grow the bog lords a new food supply.',26124),
(14610,'enUS','','Oh Buddy, you big baby!  Look, it\'s working.  It\'s really working!!  Now all I need to do is grow more of these mushrooms here and the bog lords will likely leave the sporelings alone!',26124),
(14611,'enUS','','Oh, thank you, $n!  You\'ve made it possible to save both the sporelings from the bog lords, and the bog lords from our wrath.',26124),
(14612,'enUS','The %s takes a piece of the mushroom tree and holds it to its \'nose\'.  Seemingly satisfied, it eats it!','',26124),
(14613,'enUS','The %s uproots the rest of the mushroom tree and makes off with it.','',26124),
(14614,'enUS','Starting Event <PH>','',26124),
(14615,'enUS','','Wait and see what happens!',26124),
(14616,'enUS','Banish <PH>','',26124),
(14617,'enUS','<Vindicator Aesom salutes you.>$B$BHave you spoken with Admetius? I believe he was inquiring as to your whereabouts.','',26124),
(14618,'enUS','Psst!  Hey, $c, over here to your left.  Come here!','',26124),
(14619,'enUS','The druids protect me from the naga and evil Lost Ones.  In exchange, I teach them about the plants and animals of the marsh.','',26124),
(14620,'enUS','Unpleasant place, this \"Undercity\". Not at all like the Lordaeron of old. How I miss it...$b$bIf you\'re looking to go to Stratholme, I\'m afraid I\'m unable to assist at the moment. The towers nearby the burning city are still in contention, and as such my powers are far too weak to aid you. Return to me once you\'re victorious there.','',26124),
(14621,'enUS','Ah, I can sense it - you\'ve won the day! I believe I can safely transport you to Stratholme now, provided you\'ve paid my colleague there a visit first. Just step into the circle and be patient...','',26124),
(14622,'enUS','Be thankful that I am locked inside this cage, $r.','Be thankful that I am locked inside this cage, $r.',26124),
(14623,'enUS','Hope this day finds you well.  Can I offer you something?','Hope this day finds you well.  Can I offer you something?',26124),
(14624,'enUS','I need the illusion cast upon me again, Admetius.','I need the illusion cast upon me again, Admetius.',26124),
(14625,'enUS','<The captured Sunhawk agent eyes you suspiciously.>$B$BI\'ve never seen you before. Who are you?','<The captured Sunhawk agent eyes you suspiciously.>$B$BI\'ve never seen you before. Who are you?',26124),
(14626,'enUS','I\'m a prisoner, what does it look like? The draenei filth captured me as I exited the sun gate. They killed our portal controllers and destroyed the gate. The Sun King will be most displeased with this turn of events.','I\'m a prisoner, what does it look like? The draenei filth captured me as I exited the sun gate. They killed our portal controllers and destroyed the gate. The Sun King will be most displeased with this turn of events.',26124),
(14627,'enUS','<The captured Sunhawk agent smirks.>$B$BDon\'t worry, new blood, there are many more portal controllers and many more suitable locations for portals. I am certain that Sironas will have a new gate up very soon. These blue skinned dogs are not long for this world. Sironas and the abomination will clean up whatever the Sunhawk forces leave behind.','<The captured Sunhawk agent smirks.>$B$BDon\'t worry, new blood, there are many more portal controllers and many more suitable locations for portals. I am certain that Sironas will have a new gate up very soon. These blue skinned dogs are not long for this world. Sironas and the abomination will clean up whatever the Sunhawk forces leave behind.',26124),
(14628,'enUS','Ah yes, Sironas. I had nearly forgotten that Sironas was here. I served under Sironas back on Outland. I hadn\'t heard of this abomination, though; those damnable draenei captured me before I even fully materialized on this world.','Ah yes, Sironas. I had nearly forgotten that Sironas was here. I served under Sironas back on Outland. I hadn\'t heard of this abomination, though; those damnable draenei captured me before I even fully materialized on this world.',26124),
(14629,'enUS','It was Sironas\' idea... The abomination is actually one of their own. He is a high ranking member of the draenei military order: Triumvirate or some such nonsense.$B$BWhatever that thing is, it\'s massive, powerful, and full of rage. Any attacks against the Vector Coil will most certainly result in failure as long as that abomination is around.','It was Sironas\' idea... The abomination is actually one of their own. He is a high ranking member of the draenei military order: Triumvirate or some such nonsense.$B$BWhatever that thing is, it\'s massive, powerful, and full of rage. Any attacks against the Vector Coil will most certainly result in failure as long as that abomination is around.',26124),
(14630,'enUS','Incredible. How did Sironas accomplish such a thing?','Incredible. How did Sironas accomplish such a thing?',26124),
(14631,'enUS','Sironas claims that certain eredar possess the ability to transform others of their race into man\'ari. Draenei were supposedly once eredar and Sironas is a powerful eredar.$B$B<The agent laughs.>$B$BCan you believe it? These pathetic creatures were once all-powerful demons. What kind of fool rejects such power?\n','Sironas claims that certain eredar possess the ability to transform others of their race into man\'ari: Savage demonic beings. Draenei were supposedly once eredar and Sironas is a powerful eredar.$B$B<The agent laughs.>$B$BCan you believe it? These pathetic creatures were once all-powerful demons. What kind of fool rejects such power?\n',26124),
(14632,'enUS','Sironas is an eredar... I mean, yes, obviously.','Sironas is an eredar... I mean, yes, obviously.',26124),
(14633,'enUS','Obviously. How else could she infiltrate their ranks and pass as a draenei? She had been living among them for a very long time. ','Obviously. How else could she infiltrate their ranks and pass as a draenei? She had been living among them for a very long time. ',26124),
(14634,'enUS','The Vector Coil is massive. I hope we have more than one abomination guarding the numerous weak points.','The Vector Coil is massive. I hope we have more than one abomination guarding the numerous weak points.',26124),
(14635,'enUS','Numerous? It has two weak points: The base of the structure on the west side and the base of the structure on the east side. Hey, wait a minute. How would you know anything about the Vector Coil? Didn\'t you say that you were captured before you even materialized?','Numerous? It has two weak points: The base of the structure on the west side and the base of the structure on the east side. Hey, wait a minute. How would you know anything about the Vector Coil? Didn\'t you say that you were captured before you even materialized?',26124),
(14636,'enUS','I did and you believed me. Thank you for the information, blood elf. You have helped us more than you could know.','I did and you believed me. Thank you for the information, blood elf. You have helped us more than you could know.',26124),
(14637,'enUS','Treacherous whelp! Sironas will destroy you and your people!','Treacherous whelp! Sironas will destroy you and your people!',26124),
(14638,'enUS','Test','',26124),
(14639,'enUS','Fhwoor go now, $n.  Get ark, come back.','',26124),
(14640,'enUS','Take moment... get ready.','',26124),
(14641,'enUS','We go!','',26124),
(14642,'enUS','%s lifts the Ark of Ssslith with ease.','',26124),
(14643,'enUS','Uh oh...','',26124),
(14644,'enUS','Ha ha, squishy naga!','',26124),
(14645,'enUS','%s places the Ark of Ssslith on the ground.','',26124),
(14646,'enUS','Fhwoor do good!','',26124),
(14647,'enUS','The time has come to destroy the Vector Coil!','',26124),
(14648,'enUS','There\'s no turning back now, $n. Stay close and watch my back.','',26124),
(14649,'enUS','There it is! Do you see where the large red crystal is jutting out from the Vector Coil? That\'s where I need to plant the first set of explosives.','',26124),
(14650,'enUS','Cover me!','',26124),
(14651,'enUS','It won\'t be much longer, $n. Just keep them off me while I work.','',26124),
(14652,'enUS','That\'ll do it! Quickly, take cover!','',26124),
(14653,'enUS','3...','',26124),
(14654,'enUS','2...','',26124),
(14655,'enUS','1...','',26124),
(14656,'enUS','Don\'t get too excited, hero, that was the easy part. The challenge lies ahead! Let\'s go.','',26124),
(14657,'enUS','What in the Nether is that?!?!','',26124),
(14658,'enUS','Be ready for anything, $n.','',26124),
(14659,'enUS','Blessed Light! She\'s siphoning energy right out of the Vector Coil!','',26124),
(14660,'enUS','Cover me, we have to do this quickly. Once I blow the support on this side, it will disrupt the energy beams and she\'ll break out! I doubt very much that she\'ll be happy to see us.','',26124),
(14661,'enUS','I\'ve almost got it! Just a little more time...','',26124),
(14662,'enUS','Take cover and be ready for the fight of your life, $n!','',26124),
(14663,'enUS','Holy mother of O\'ros!','',26124),
(14664,'enUS','I... I can\'t believe it\'s over. You did it! You\'ve destroyed the blood elves and their leader!','',26124),
(14665,'enUS','Get back to Blood Watch. I\'ll see you there...','',26124),
(14666,'enUS','','Petulant children, pray to your gods for you are about to meet them!',26124),
(14667,'enUS','','I am patiently awaiting orders, $c.',26124),
(14668,'enUS','Hey!  Over here!  Yeah, over here... I\'m in this cage!!!','',26124),
(14669,'enUS','Now that the rude interruption is over, as I was saying, Quagmirran is nearby!$B$BAs promised, I can fortify you with a magical boon that should aid you in your fight with him.','',26124),
(14670,'enUS','Naturalist, please grant me your boon.','Naturalist, please grant me your boon.',26124),
(14671,'enUS','[In broken Common] It is time celebrate we do.','',26124),
(14672,'enUS','Promised One, do you remember us? Do you recall the prophecy of Kurz? This moment was pre-ordained. You have done what you were put on this world to do.$B$B<High Chief Stillpine bows before you.>$B$BDraenei will always be welcome among my people.','',26124),
(14673,'enUS','[In broken Common] Stillpine thank hero. Many thank!','',26124),
(14674,'enUS','A glorious victory!','',26124),
(14675,'enUS','You\'ve come a long way, $n. A long way indeed... But I knew you were destined for great things.  We all knew. All hail $n!$B$BAnd thanks again for taking care of our gnome problem...','',26124),
(14676,'enUS','We are here to celebrate your victory and to welcome our newfound allies!','',26124),
(14677,'enUS','','I am here to give thanks to the one that saved my life.',26124),
(14678,'enUS','','You probably don\'t remember me, but you saved my life. I have only recently become healthy enough to walk on my own.$B$BI wanted to thank you for what you did for me and apologize for what I may have said... Thank you, $n. May Elune always watch over you.',26124),
(14679,'enUS','','%s hugs you.',26124),
(14680,'enUS','We are here to support our hero!','',26124),
(14681,'enUS','I wouldn\'t have missed this for the world, $n.$B$B<Exarch Menelaous hugs you.>$B$BWe are proud of you.','',26124),
(14682,'enUS','I have come to support the draenei champion!','',26124),
(14683,'enUS','Good to see you again, $n. I brought a friend with me. She really wanted to see you.$B$B<Kessel laughs.>','',26124),
(14684,'enUS','This is a glorious day for the draenei! Thank you for all that you have done, $n.','',26124),
(14685,'enUS','We have traveled far to celebrate the hero of the draenei people.','',26124),
(14686,'enUS','I would have traveled across the Great Sea to see you, friend. We will never forget what you did for us.','',26124),
(14687,'enUS','I wanted to thank you once more for what you did for me. You gave me the courage to take back my home from the beasts of the forest. In doing so, I found Magwin!','',26124),
(14688,'enUS','You saved my daughter, $n, and for that, I am forever indebted to you, $n. Thank you so much.','',26124),
(14689,'enUS','The draenei champion walks among us. This is a celebration for the savior of Azuremyst and Bloodmyst!','',26124),
(14690,'enUS','This is all for you, $n. You did this. You saved all of these people and thousands more.$B$BYou have risen above the strife and tragedy of this world and in doing so, elevated all of us with you.$B$BYou have done so much - more than many could do in ten lifetimes - yet your life has just begun. If only we had a thousand heroes like you.$B$BBut listen well, $n. Your destiny lies in the Outland. I have seen it in visions, a prophecy yet untold.$B$BFind our people, $n. Find them and bring them home...','',26124),
(14691,'enUS','All hail $n, savior of Azuremyst and Bloodmyst. Hero of the Hand of Argus, champion of the draenei people!','',26124),
(14692,'enUS','It does my soul good to see the walls of Stormwind standing strong and tall.$b$bIf you\'re looking to go to Stratholme, I\'m afraid I\'m unable to assist at the moment. The towers nearby the burning city are still in contention, and as such my powers are far too weak to aid you. Return to me once you\'re victorious there.','',26124),
(14693,'enUS','Ah, I can sense it - you\'ve won the day! I believe I can safely transport you to Stratholme now, provided you\'ve paid my colleague there a visit first. Just step into the circle and be patient...','',26124),
(14694,'enUS','Bah! Cowards and fools! Return to my platform if you dare to face me!','',26124),
(14695,'enUS','','We cannot afford to let our guard down, $c. This world is crawling with agents and allies of the Burning Legion. If you come across anything strange, don\'t hestitate to show me.',26124),
(14696,'enUS','Ysiel expected some enemy opposition to her foray into Outland.  That\'s why us wardens were brought along.$B$BWe never expected our opposition to come in the strength or numbers that the naga have shown.','',26124),
(14697,'enUS','','I have no idea who you are, but your presence is most welcome. Archimonde and his Scourge army could attack at any time, $C. Will you stand with us against this evil?',26124),
(14698,'enUS','My companions and I are with you, Lady Proudmoore.','My companions and I are with you, Lady Proudmoore.',26124),
(14699,'enUS','','Thank you, $R. Now prepare yourselves. Archimonde is on the march, and we must hold off the inevitable for as long as we can.',26124),
(14700,'enUS','','I don\'t like the idea of asking Azeroth for help, but we have little choice.',26124),
(14701,'enUS','','I told myself I wouldn\'t burden the Cenarion Circle with our expedition\'s problems, $n.  Our military strength is minimal, however.  We\'re scholars and explorers, first and foremost.',26124),
(14702,'enUS','','This is too big, though.  If the naga aren\'t stopped, our expedition won\'t even matter.  Word must be sent back to the Archdruids of the Circle.',26124),
(14703,'enUS','[PH] The British are coming! Clear the roads!','[PH] The British are coming! Clear the roads!',26124),
(14704,'enUS','','We must continue to hold on for as long as we can! Fight on!',26124),
(14705,'enUS','%s roars in pain. ','%s roars in pain. ',26124),
(14706,'enUS','','It\'s just like the structure you described at Umbrafen Lake.  Does this mean the naga are pumping water out of all the lakes in Zangarmarsh?',26124),
(14707,'enUS','By your order, master!','By your order, master!',26124),
(14708,'enUS','As you wish!','As you wish!',26124),
(14709,'enUS','For the Sunhawks!','For the Sunhawks!',26124),
(14710,'enUS','Let us slay them!','Let us slay them!',26124),
(14711,'enUS','For Kael!','For Kael!',26124),
(14712,'enUS','','The naga are even pumping the water out of their own lake!  What purpose could that possibly serve?',26124),
(14713,'enUS','','There!  Those pipes all appear to be connected to that structure.  It can\'t possibly fit all the water they\'ve been stealing.  Where are they keeping it?',26124),
(14714,'enUS','','What we saw explains what happened in the Dead Mire.  There was a lake here once.  If we don\'t stop the naga, all of the marsh will soon look like this!',26124),
(14715,'enUS','What a pitiful defense. Is this the best you can do?','',26124),
(14716,'enUS','More of you stand in my way? Kill them, Sunhawks!','',26124),
(14717,'enUS','I will not be stopped by such pitiful defenses. ','',26124),
(14718,'enUS','','I am the leader of the Blood Watch defenses. What can I help you with?',26124),
(14719,'enUS','[In broken Common] Stillpine be ready! Many thanks!','',26124),
(14720,'enUS','','Hello, are you here to learn about the conflict in Bloodmyst?',26124),
(14721,'enUS','','Can I help you? ',26124),
(14722,'enUS','','We serve the light unquestioningly. Perhaps you might be a bit more curious about our purpose?',26124),
(14723,'enUS','Tell me about the Defenders.','Tell me about the Defenders.',26124),
(14724,'enUS','','Is the way clear?  Let\'s get out while we can, $n.',26124),
(14725,'enUS','','Looks like we won\'t get away so easily.  Get ready!',26124),
(14726,'enUS','','Let\'s keep moving.  We\'re not safe here!',26124),
(14727,'enUS','','Look out, $n!  Enemies ahead!',26124),
(14728,'enUS','','We\'re almost to the refuge!  Let\'s go.',26124),
(14729,'enUS','','I can see my fellow druids from here.  Thank you, $n.  I\'m sure Ysiel will reward you for your actions!',26124),
(14730,'enUS','Welcome to the headquarters of the Blood Knights, the defenders of Quel\'Thalas, the faithful servants of Silvermoon, and the true masters of the Light.','',26124),
(14731,'enUS','You won\'t escape us, druid!','',26124),
(14732,'enUS','Yes.. spill more of their blood! It draws me nearer to this place!','',26124),
(14733,'enUS','More! Spill more of their blood! I am near!','',26124),
(14734,'enUS','Yes! more! I shall soon be unleashed!','',26124),
(14735,'enUS','You have thwarted us for now, but we shall return...','',26124),
(14736,'enUS','Welcome back, $n!','Welcome back, $n!',26124),
(14737,'enUS','You honor us with your presence, $n.','You honor us with your presence, $n.',26124),
(14738,'enUS','Nature favors those willing to learn its secrets, $n.','',26124),
(14739,'enUS','Grant me your mark, wise ancient.','Grant me your mark, wise ancient.',26124),
(14740,'enUS','Nature is a powerful force, $r.  Those who seek to subdue never succeed in doing so permanently.','',26124),
(14741,'enUS','Grant me your mark, mighty ancient.','Grant me your mark, mighty ancient.',26124),
(14742,'enUS','','Sir! We have reports of a Man\'ari abomination being summoned to the west. I am deploying the Defenders to intercept along the path to Blood Watch. ',26124),
(14743,'enUS','May the light protect you. Now, go!','',26124),
(14744,'enUS','Please cast a high priority DEBUFF spell on all nearby targets.','Please cast a high priority DEBUFF spell on all nearby targets.',26124),
(14745,'enUS','Please cast a high priority BUFF spell on all nearby targets.','Please cast a high priority BUFF spell on all nearby targets.',26124),
(14746,'enUS','The Northpass tower needs our aid!  Once again, let us charge and do proud our liege!','',26124),
(14747,'enUS','Having successfully defended the Alonsus Chapel, %s\'s spirit returns to its rest.','Having successfully defended the Alonsus Chapel, %s\'s spirit returns to its rest.',26124),
(14748,'enUS','The waters calm as Watoosun materializes.','',26124),
(14749,'enUS','Ancient spirit, you honor the Earthen Ring. What troubles you so?','',26124),
(14750,'enUS','Your brethren seek to harm my children. Those that call themselves Windyreed subvert the land. A marsh this will not become...','',26124),
(14751,'enUS','Our might will be focused. We will not allow the desecration to continue.','',26124),
(14752,'enUS','Your death comes, Boros!','',26124),
(14753,'enUS','We\'re not the younglings we once were, Man\'ari! By the light, we shall end your suffering!','',26124),
(14754,'enUS','By the light! What have they done to you?','',26124),
(14755,'enUS','We end this now!','',26124),
(14756,'enUS','%s grins malevolently.','',26124),
(14757,'enUS','','Greetings, $n.',26124),
(14758,'enUS','The spirits are restless, $r. Be mindful of your surroundings while in Nagrand lest you be consumed by their fury.','',26124),
(14759,'enUS','The Earthen Ring seeks to preserve the strength and majesty of the elements.','',26124),
(14760,'enUS','','How can my people fight when the elements are in such turmoil? Do they not see that without the support of the elements, the world simply cannot be.',26124),
(14761,'enUS','I am Untrag of the Earthen Ring. Try not to upset the elements while you remain at the Throne of the Elements.','',26124),
(14762,'enUS','The creature approachessss! Arm yourssselvesss!','',26124),
(14763,'enUS','I apologize, $c. I mistook you for someone with a spine. Begone; our secrets are not for untrained ears.','I apologize, $c. I mistook you for someone with a spine. Begone; our secrets are not for untrained ears.',26124),
(14764,'enUS','Prepare to perisssh at my handsss!','',26124),
(14765,'enUS','I have no time for a sermon now, $c. Seek your knowledge elsewhere.','I have no time for a sermon now, $c. Seek your knowledge elsewhere.',26124),
(14766,'enUS','It appears you took a wrong turn, $c.','It appears you took a wrong turn, $c.',26124),
(14767,'enUS','Greetings, $n. You were not followed here, I trust?','Greetings, $n. You were not followed here, I trust?',26124),
(14768,'enUS','We have little to discuss, $c. Perhaps you should seek other, more like-minded individuals.','We have little to discuss, $c. Perhaps you should seek other, more like-minded individuals.',26124),
(14769,'enUS','It\'s a pleasure to see someone sane around here. How can I help you?','It\'s a pleasure to see someone sane around here. How can I help you?',26124),
(14770,'enUS','Ah, a fellow ranger. What do you need?','Ah, a fellow ranger. What do you need?',26124),
(14771,'enUS','You clearly lack the capacity to grasp the intricacies of the arcane, $c. Off with you.','You clearly lack the capacity to grasp the intricacies of the arcane, $c. Off with you.',26124),
(14772,'enUS','What assistance can I offer in your studies?','What assistance can I offer in your studies?',26124),
(14773,'enUS','Ours is a path for those with an iron will and unfaltering resolve. You seem to possess none of these traits, $c.','Ours is a path for those with an iron will and unfaltering resolve. You seem to possess none of these traits, $c.',26124),
(14774,'enUS','You seek further instruction, $n?','You seek further instruction, $n?',26124),
(14775,'enUS','This land has been ravaged by the crash. While you may not follow our philosophies, $c, I urge you to do whatever you can to aid in the healing process.','This land has been ravaged by the crash. While you may not follow our philosophies, $c, I urge you to do whatever you can to aid in the healing process.',26124),
(14776,'enUS','Greetings, my $g brother : sister;. How can I guide you today?','Greetings, my $g brother : sister;. How can I guide you today?',26124),
(14777,'enUS','','May the winds guide you, $n.',26124),
(14778,'enUS','Burn! Burn! Burn!','',26124),
(14779,'enUS','This book contains information on the plant species of Outland.  Most of the plants detailed are native to Zangarmarsh.$B$BThe charts and diagrams are a bit beyond your understanding.  Perhaps the author could give you some pointers.','',26124),
(14780,'enUS','This book contains information on the plant species of Outland.  Most of the plants detailed are native to Zangarmarsh.$B$BYou feel confident that you can use the charts and diagrams in the book to identify various plant species.','',26124),
(14781,'enUS','','I\'ve always liked sorting and organizing things.  I guess I take after my mother.',26124),
(14782,'enUS','Happiness is mandatory, citizen.','',26124),
(14783,'enUS','Obey the laws of Silvermoon. Failure to do so will result in termination.','',26124),
(14784,'enUS','Remain strong. Kael\'thas will - error - Lor\'themar will lead you to power and glory!','',26124),
(14785,'enUS','Do not disturb the serenity of the city. Peace must be upheld.','',26124),
(14786,'enUS','I don\'t know what to think of your kind yet, $r.  Some of you can be violent and kill sporelings on sight.$B$BYou seem friendly... though maybe a little bit funny looking, I suppose.','',26124),
(14787,'enUS','Maintain order within these walls.','',26124),
(14788,'enUS','I welcome you to Sporeggar, $r.  We don\'t normally see many of your kind around here, but you\'ve proven your worth to us.  Make yourself at home.','',26124),
(14789,'enUS','The bog lords are devouring the spore sacs!  They\'ve got to be stopped!','',26124),
(14790,'enUS','Thanks to you our young ones will be safe, $n.  Go to Sporeggar and meet my people.  They\'ve all heard great things about you.','',26124),
(14791,'enUS','Our lives are yours, Blood Knight.','Our lives are yours, Blood Knight.',26124),
(14792,'enUS','Your power strengthens us all.','Your power strengthens us all.',26124),
(14793,'enUS','Even the Light is no match for the indomitable will of our people.','Even the Light is no match for the indomitable will of our people.',26124),
(14794,'enUS','','The Defenders of Blood Watch protect this outpost from any threat. ',26124),
(14795,'enUS','','The Defenders are here to protect Blood Watch from the Sunhawk threat. ',26124),
(14796,'enUS','','We\'ve recently heard word of a creature of immense power being summoned near the Vector Coil. Fear not, should anything threaten the town, we will give our lives to protect it.',26124),
(14797,'enUS','Agh... a chill ran up my spine.','Agh... a chill ran up my spine.',26124),
(14798,'enUS','Is there no sanctity left in this world?','Is there no sanctity left in this world?',26124),
(14799,'enUS','They\'ll see the light, I hope.','They\'ll see the light, I hope.',26124),
(14800,'enUS','With M\'uru gone, perhaps those haughty Blood Knights will see sense.','With M\'uru gone, perhaps those haughty Blood Knights will see sense.',26124),
(14801,'enUS','If I had my way, I\'d show those puffed-up paladins a thing or two.','If I had my way, I\'d show those puffed-up paladins a thing or two.',26124),
(14802,'enUS','<The earth rumbles as Gordawg\'s movements come to a halt.>$B$BSpeak.','',26124),
(14803,'enUS','Ha!  You have failed!  Now I will pry my ark from your dead hands!','',26124),
(14804,'enUS','Hah! Bullseye!','Hah! Bullseye!',26124),
(14805,'enUS','What a beautiful shot!','What a beautiful shot!',26124),
(14806,'enUS','Straight and true, that\'s the way.','Straight and true, that\'s the way.',26124),
(14807,'enUS','Glory to the Sun K-- ah... Silvermoon!','Glory to the Sun K-- ah... Silvermoon!',26124),
(14808,'enUS','%s arches a sculpted brow at the guards, a disapproving scowl on his face.','%s arches a sculpted brow at the guards, a disapproving scowl on her face.',26124),
(14809,'enUS','%s glances from guard to guard.','%s glances from guard to guard.',26124),
(14810,'enUS','%s surveys the small ranger practice ground with a condescending smirk.','%s surveys the small ranger practice ground with a condescending smirk.',26124),
(14811,'enUS','%s inclines his head slightly to the pair of guardians in greeting.','%s inclines her head slightly to the pair of guardians in greeting.',26124),
(14812,'enUS','By the seas... look at the sssize of that thing!','',26124),
(14813,'enUS','How did sssuch a thing grow in this wasteland?','',26124),
(14814,'enUS','Lady Vashj will not be pleasssed to hear of thisss...','',26124),
(14815,'enUS','Our neighbors are positively laughable. Have you seen the way they turn up their noses at us?','Our neighbors are positively laughable. Have you seen the way they turn up their noses at us?',26124),
(14816,'enUS','It ssspoilss our water!','',26124),
(14817,'enUS','Overseer Tidewrath, watch out!','',26124),
(14818,'enUS','The rangers certainly have a high opinion of themselves.','The rangers certainly have a high opinion of themselves.',26124),
(14819,'enUS','I\'m quickly tiring of the haughty attitude I receive from those grubby bowslingers outside.','I\'m quickly tiring of the haughty attitude I receive from those grubby bowslingers outside.',26124),
(14820,'enUS','Who do they think they are?','Who do they think they are?',26124),
(14821,'enUS','I know what you mean... they whisper about us when they think we can\'t hear them. They\'ll get theirs.','I know what you mean... they whisper about us when they think we can\'t hear them. They\'ll get theirs.',26124),
(14822,'enUS','Jealous, that\'s what they are. They\'re afraid to dedicate themselves to true power.','Jealous, that\'s what they are. They\'re afraid to dedicate themselves to true power.',26124),
(14823,'enUS','They simply fear what they cannot begin to understand.','They simply fear what they cannot begin to understand.',26124),
(14824,'enUS','Look how big that thing is!','Look how big that thing is!',26124),
(14825,'enUS','He\'s monstrous!','He\'s monstrous!',26124),
(14826,'enUS','It must have broken the walls of the tank!','It must have broken the walls of the tank!',26124),
(14827,'enUS','What does that thing eat?','What does that thing eat?',26124),
(14828,'enUS','Watch out!','Watch out!',26124),
(14829,'enUS','Go! Go! You can take him!','Go! Go! You can take him!',26124),
(14830,'enUS','Watch out for the acid spray, Overseer Tidewrath!','Watch out for the acid spray, Overseer Tidewrath!',26124),
(14831,'enUS','Matters are so uncertain now that the chamber below is empty...','Matters are so uncertain now that the chamber below is empty...',26124),
(14832,'enUS','Those things eat fish! Watch out!','Those things eat fish! Watch out!',26124),
(14833,'enUS','It\'s gone. I can\'t believe it\'s gone. Who would have thought we\'d be betrayed like this?','It\'s gone. I can\'t believe it\'s gone. Who would have thought we\'d be betrayed like this?',26124),
(14834,'enUS','Yessss! Defeat him, Overseer!','',26124),
(14835,'enUS','Yes! Use the mana shield!','',26124),
(14836,'enUS','Defeat him in the name of Lady Vashj!','',26124),
(14837,'enUS','Ssssurely the overseer can stop him!','',26124),
(14838,'enUS','Lady Liadrin is bound to find a way. She must.','Lady Liadrin is bound to find a way. She must.',26124),
(14839,'enUS','Is... it true, what I\'ve heard?  That it was the Sun King himself?','Is... it true, what I\'ve heard?  That it was the Sun King himself?',26124),
(14840,'enUS','Still, the Blood Knights will endure through this loss. We have no other choice... we must find another source.','Still, the Blood Knights will endure through this loss. We have no other choice... we must find another source.',26124),
(14841,'enUS','|cffffff00The Overlook has been taken by the Alliance!|r','',26124),
(14842,'enUS','|cffffff00The Overlook has been taken by the Horde!|r','',26124),
(14843,'enUS','|cffffff00The Stadium has been taken by the Alliance!|r','',26124),
(14844,'enUS','|cffffff00The Stadium has been taken by the Horde!|r','',26124),
(14845,'enUS','|cffffff00Broken Hill has been taken by the Alliance!|r','',26124),
(14846,'enUS','|cffffff00Broken Hill has been taken by the Horde!|r','',26124),
(14847,'enUS','','Foolsss, you will not ssssuccceed in ssstealing the ark!',26124),
(14848,'enUS','My father\'s off to more exotic locations in search of bigger prey.  Don\'t worry though, we\'re still on the hunt here!','',26124),
(14849,'enUS','Keep a sharp eye, $c.  You never know when some beastie is stalking you instead of the other way around.','',26124),
(14850,'enUS','Hemet Nesingwary, what are you doing here in the Outland?','Hemet Nesingwary, what are you doing here in the Outland?',26124),
(14851,'enUS','Listen $g lad : lass;. I left the expedition in the capable hands of me son, Junior. When you\'ve stalked the finest game in all of Azeroth you start to itch for something more.$B$BAnd have you seen the size of the beasties here?!$B$BI\'m here hunting the most dangerous prey you\'ll ever lay your eyes on. I mean to bag myself Tusker and take her heart as my trophy!','',26124),
(14852,'enUS','$n!  I remember your hunting prowess all too well.  You might have gotten off to a shaky start in Stranglethorn, but you stuck in there and became one o\' the finest when you bagged old Bangalash.$B$BBut listen, $g lad : lass;, the prey out here in the Outland is the real deal.  And I\'ve the scars to prove it!','',26124),
(14853,'enUS','The %s hisses loudly and prepares to attack.','',26124),
(14854,'enUS','','Remind me, ambassador... what precisely will your people be contributing to our efforts?',26124),
(14855,'enUS','Take me to the place<PH>','',26124),
(14856,'enUS','Follow me!','Follow me!',26124),
(14857,'enUS','Our people are strong. We bring you a mastery over arcane magics that you have previously lacked - ah, no offense intended, of course.','',26124),
(14858,'enUS','Surely you see the advantage in our relationship. The powers we command are immense. With our aid, your enemies could well be decimated.','',26124),
(14859,'enUS','I realize we have had somewhat differing loyalties in the past, but put your suspicions aside. Our considerable power has been pledged to your leaders in good faith.','',26124),
(14860,'enUS','','I suppose we\'ll see the measure of your dedication in due time.',26124),
(14861,'enUS','T\'ink ja be contributin\' less glarin\' in dis troll\'s direction?','',26124),
(14862,'enUS','','Tatai!',26124),
(14863,'enUS','%s sighs in resignation and falls silent.','',26124),
(14864,'enUS','','Truly an advantageous alliance.',26124),
(14865,'enUS','WHO DARES CALL GUROK FROM THE UNDERNEATH?','',26124),
(14866,'enUS','','Dela Runetotem\'s brow furrows, but she remains silent.',26124),
(14867,'enUS','Stranger, make haste and contact Lady Jaina Proudmoore. Her small Alliance force is bravely attempting to blunt the Burning Legion\'s initial assault and delay the approach of Archimonde.','',26124),
(14868,'enUS','What help be ja givin\' de Horde, anyway?','',26124),
(14869,'enUS','Lady Proudmoore\'s forces have bled to delay Archimonde and his Burning Legion, and now this grim task falls to us. Are you ready to stand with me against the onslaught?','',26124),
(14870,'enUS','','Tell us, Ambassador Kelemar... how do the blood elves plan to aid us, exactly?',26124),
(14871,'enUS','I humbly welcome you to our temple, spirit.','',26124),
(14872,'enUS','Greetings, elder. It is time for your people to end their hostility toward the draenei and their allies.','Greetings, elder. It is time for your people to end their hostility toward the draenei and their allies.',26124),
(14873,'enUS','Treat with the draenei, the people who turned their backs on us while we suffered? I think not.$B$BA true spirit does not speak thus! Reveal yourself, impostor. Who sent you?','',26124),
(14874,'enUS','I did not mean to deceive you, elder. The draenei of Telredor thought to approach you in a way that would be familiar to you.','I did not mean to deceive you, elder. The draenei of Telredor thought to approach you in a way that would be familiar to you.',26124),
(14875,'enUS','I am with you, Thrall.','I am with you, Thrall.',26124),
(14876,'enUS','So we\'re to trust people who would insult us with this deception? Do the draenei think so little of us that they must resort to trickery to get our attention?$B$BWe\'re aware of their desire to \'redeem\' us, but my people want none of their redemption. We are capable of standing on our own and we will pursue our destiny as a proud and separate people. Carry this message to your allies.','',26124),
(14877,'enUS','Then let the Legion do their worst!','',26124),
(14878,'enUS','The Burning Legion presses us hard, but our defenses hold. Every moment we keep Archimonde away from the World Tree brings us closer to victory.','',26124),
(14879,'enUS','I will tell them. Farewell, elder.','I will tell them. Farewell, elder.',26124),
(14880,'enUS','Good. Be sure they understand.$B$BNow, I would appreciate it if you would leave my temple in peace.','',26124),
(14881,'enUS','My work here is done.','',26124),
(14882,'enUS','Dis place be huge. Why ja be needin\' all dis space?','',26124),
(14883,'enUS','This is merely part of what Silvermoon once was. Much of the city was lost after Arthas swept through our lands.','',26124),
(14884,'enUS','We lost many of our kin in the war... so yes, the city is not perhaps as lively as it once was. We will endure, however.','',26124),
(14885,'enUS','','If your people are as strong as you purport, I\'m sure you\'ll find your stride again.',26124),
(14886,'enUS','Dis be a big waste, if ja be askin\' me.','',26124),
(14887,'enUS','','Well, no one asked you, Tatai.',26124),
(14888,'enUS','%s grumbles under his breath.','',26124),
(14889,'enUS','','You\'re not the only victims of the Scourge. Our lady Sylvanas sympathizes with your plight.',26124),
(14890,'enUS','','My condolences. These past years have been hard on us all.',26124),
(14891,'enUS','','This city is very... expansive, but it seems to be lacking something. I can\'t put my finger on what...',26124),
(14892,'enUS','','It seems that a great deal of your power is used for... and I hope you\'ll pardon the term... frivolous things. Isn\'t that, well, wasteful?',26124),
(14893,'enUS','This must be somewhat different from the environment to which you\'re accustomed. It is a visible demonstration of the power we hold, nothing more. We\'re mindful of our resources.','',26124),
(14894,'enUS','Think about it carefully, my friends. If we can afford to spend our magic on simple aesthetic enhancements, clearly we hold a vast reservoir of power at our beck and call.','',26124),
(14895,'enUS','It is not simply a beautification measure, but also a morale booster. It demonstrates to our people that we have a great deal of power at our fingertips, and with it... we can do nearly anything.','',26124),
(14896,'enUS','','%s taps a finger on her chin, lost in thought.',26124),
(14897,'enUS','Bah! If I ever be in charge\'a dis place, da first t\'ing I be doin\' is stoppin\' alla dat. Ja be markin\' my words.','',26124),
(14898,'enUS','','Tatai, please. We\'re guests here.',26124),
(14899,'enUS','Yes, well... luckily for us all, the troll will not be in a position of power within our fair city anytime soon.','',26124),
(14900,'enUS','','An understandable expenditure, as I see it. Show everyone, enemies and allies alike, that you\'re not afraid to use your power.',26124),
(14901,'enUS','%s begins to perform an arcane scrying.','',26124),
(14902,'enUS','Blasted scrying crystal!  I\'m not getting anything over here.','',26124),
(14903,'enUS','','I don\'t know. It still seems like such a waste.',26124),
(14904,'enUS','Why be all dese t\'ings floatin\' an\' movin\' by demselves?','',26124),
(14905,'enUS','','Your choice of decor is intriguing, Kelemar. Tell me - why the arcane frippery?',26124),
(14906,'enUS','','I don\'t suppose Lor\'themar Theron is available for an audience yet?',26124),
(14907,'enUS','The regent lord is a very busy man. I\'m sure you understand.','',26124),
(14908,'enUS','He is unable to see you just yet, but do not trouble yourselves over it. I\'m certain he will find a way to fit you into his busy schedule.','',26124),
(14909,'enUS','In due course. There is no rush, after all - our hospitality is extended to you indefinitely. Even the troll.','',26124),
(14910,'enUS','','I\'ll accept that answer for the time being, Kelemar, but my patience is not exactly boundless.',26124),
(14911,'enUS','Just what I be t\'inkin\'. More delays.','',26124),
(14912,'enUS','','Troll, if you can\'t keep a civil tongue in your head, I\'ll be happy to remove it for you.',26124),
(14913,'enUS','Ja be keepin\' away from me.','',26124),
(14914,'enUS','','%s smirks triumphantly.',26124),
(14915,'enUS','','This is becoming tiresome.',26124),
(14916,'enUS','','As you say, ambassador. We can wait.',26124),
(14917,'enUS','','I thought we were going to speak with the regent lord. I\'m beginning to question whether or not he exists at all at this point.',26124),
(14918,'enUS','','There\'s an ethereal beauty about this place... but for all the trees and plant life, it\'s still so... unnatural.',26124),
(14919,'enUS','I be gettin\' tired\'a dis. Dese elves, dey be treatin\' me like I stole somet\'in\'.','',26124),
(14920,'enUS','Welcome to the Orebor Harborage, friend. You have nothing to fear here. We are Broken, but we are not your enemies.$B$BI am Ikuti of the Kurenai, a group of Broken who desire to reestablish ties with our draenei brothers and their newfound allies.','',26124),
(14921,'enUS','Maktu doesn\'t recognize you, $r, but he is pleased to meet you. If ever you need to buy or repair armor, look no further than Maktu.','',26124),
(14922,'enUS','I\'m afraid your ancestry is the cause, troll. Decades of fighting with your green-skinned brethren have hardened their hearts against your kind.','',26124),
(14923,'enUS','Show me your wares, Maktu.','Show me your wares, Maktu.',26124),
(14924,'enUS','Memories of this temple shroud my mind like a thick haze, yet I cannot assemble them into a coherent story. This place meant something to me once. Until I can restore that memory, I will feel as though a part of me is missing.$B$BPerhaps the draenei can help me recover what I\'ve lost.','',26124),
(14925,'enUS','I wish to browse your wares.','I wish to browse your wares.',26124),
(14926,'enUS','Keep your chin up. Perhaps with time, our people will see you as the ally you are, rather than the enemy you appear to be.','',26124),
(14927,'enUS','','You should be used to those looks, Tatai. Do you remember the reason you were drafted into this job?',26124),
(14928,'enUS','Don\'t ja start...','',26124),
(14929,'enUS','','I\'m no happier about being your babysitter than you are about being watched. Just remember... it could have been worse.',26124),
(14930,'enUS','Let me browse your reagents and poison supplies.','Let me browse your reagents and poison supplies.',26124),
(14931,'enUS','There are some who call me \'Tim,\' but to my friends, I am \'the specialist.\'','',26124),
(14932,'enUS','Specialist, eh? Just what kind of specialist are you, anyway?','Specialist, eh? Just what kind of specialist are you, anyway?',26124),
(14933,'enUS','If you have to ask, you don\'t know me anywhere near well enough to be using that appellation.','',26124),
(14934,'enUS','Greetings, $c.  You seek to push yourself to the limits of your hunting prowess?  Look no further.$B$BHemet Nesingwary has assembled the finest expedition the remnant of this world has ever known.  Join us on safari if you dare.','',26124),
(14935,'enUS','Do not be fooled by the ruins surrounding us, $c.  Dalaran is as powerful as ever.','',26124),
(14936,'enUS','Karazhan is more than a mere building, $n.  If you traced the ley-lines traversing Azeroth you would find that they all converge right about there.$B$B<Alturus points at an invisible spot below the tower.>$B$BFascinating, isn\'t it?','',26124),
(14937,'enUS','Archmage Alvareux once wrote a treatise exploring a fascinating theory.  He proposed the existence of an exact copy of Karazhan in a world other than our own and that both somehow shared the same space.$B$BHe went mad soon after.  A real pity.','',26124),
(14938,'enUS','Bounties for notorious criminals and vicious animals are posted here. It would be much too dangerous for you to pursue the bounty posted here right now, but check the board again as you gain strength.','',26124),
(14939,'enUS','The naaru are wise beyond our understanding.  I\'ve learned more from A\'dal in the last five months than all the years I spent in the libraries of Dalaran.','',26124),
(14940,'enUS','A thick red slash has been drawn across the words WANTED: Deathclaw.  \"This bounty has been claimed by the heroic $n, who has overcome the fearsome beast,\" declares more writing in the same red ink.','',26124),
(14941,'enUS','This sign contains various announcements and notices of rewards.','',26124),
(14942,'enUS','GLHF! <PH>','',26124),
(14943,'enUS','Let me fly!','Let me fly!',26124),
(14944,'enUS','This spot is perfect! Let me set up...','',26124),
(14945,'enUS','Welcome to Zabra\'jin, $c. I am Shadow Hunter Denjai, overseer of this outpost and commander of the Darkspear forces in Zangarmarsh.','',26124),
(14946,'enUS','Now don\'t you be thinkin\' about tryin\' to make off with me baby murlocs! I got the eyes of a hawk and ears like... ears like... like somethin\' with mighty powerful ears!','',26124),
(14947,'enUS','','Tor\'gash believes he can see the future in the entrails of birds, or by tossing the knucklebones of his ancestors. Really, all you need to do is ask the spirits. But don\'t try telling him that, $n. He\'s very stubborn.',26124),
(14948,'enUS','','TugofWar Buffbot, Alliance',26124),
(14949,'enUS','','TugofWar Buffbot, Alliance Winner',26124),
(14950,'enUS','TugofWar Buffbot, Give me a Reward','TugofWar Buffbot, Give me a Reward',26124),
(14951,'enUS','','TugofWar Buffbot, Horde Winner',26124),
(14952,'enUS','','TugofWar Buffbot, Horde Greeting',26124),
(14953,'enUS','There are no more available rides! There should be one available very soon... <PH>','',26124),
(14954,'enUS','You\'ve proven yourself a very capable game hunter, $n.  But there\'s still one beastie that haunts your dreams... Tusker!','',26124),
(14955,'enUS','You\'ve bagged them all: Bach\'lor, Banthar, Gutripper, and even the mighty Tusker!  You\'re truly the finest big game hunter that I know!','',26124),
(14956,'enUS','There I was tumbling in a patch of prickly undergrowth with a talbuk stag, hand-to-hand, only my sharp knife...<cough>... and keen hunter\'s intellect to save me.$B$BAll of a sudden I\'m jumped by a pair of fierce windroc hunters that came at me from the skies!  Their cowardly attack...<cough>... didn\'t help them any though.$B$BAnd while I have their beaks as trophies, I received an infected scratch out of the ordeal.  Kind of nasty, and I\'m in a lot of pain, but I\'m sure it\'ll heal up in a day or two.','',26124),
(14957,'enUS','The first time I saw mushrooms taller than trees, I wasn\'t so sure I could call this place home. After a while you just stop noticing.','',26124),
(14958,'enUS','I wish to purchase tradeskill supplies.','I wish to purchase tradeskill supplies.',26124),
(14959,'enUS','','Don\'t forget to take some time out to fish while you\'re in Zangarmarsh. You never know when you\'ll see water again.',26124),
(14960,'enUS','I wish to purchase fishing supplies.','I wish to purchase fishing supplies.',26124),
(14961,'enUS','Give me some pointers on my fishing technique.','Give me some pointers on my fishing technique.',26124),
(14962,'enUS','Telredor was once a secluded retreat for draenei priests and pilgrims. The resident priests seldom received visitors.$B$BWhen the orcs started to attack draenei settlements, refugees began to arrive in larger numbers. Anchorite Ahuurn and the others transformed Telredor from a shrine into a safe haven. Many draenei, myself included, owe our survival to his efforts.','',26124),
(14963,'enUS','','Such marvelous sights. I regret being unable to see it when I was younger.',26124),
(14964,'enUS','Thank you for making the journey here. I hope you will find Silvermoon to your liking.','',26124),
(14965,'enUS','Behold the wonders of our fair city.','',26124),
(14966,'enUS','','The view from the top of Telredor is magnificent, isn\'t it?',26124),
(14967,'enUS','I would like to buy from you.','I would like to buy from you.',26124),
(14968,'enUS','Welcome to Telredor, $c. If you need anything, don\'t hesitate to ask.','',26124),
(14969,'enUS','Dis place be too bright fa my tastes.','',26124),
(14970,'enUS','Exercise caution during your stay. Some close-minded individuals may still cling to old alliances long since dissolved...','',26124),
(14971,'enUS','I wish to buy from you.','I wish to buy from you.',26124),
(14972,'enUS','I\'ve never seen so many different kinds of mushrooms in one place. Given enough time, I\'m sure I could find a use for all of them.','',26124),
(14973,'enUS','Telredor has seen more change in the last 20 years than it did in prior centuries. I cannot complain, $n, for the world has changed far more in that time.$B$BThe Light has brought me friends and companions I could not have met as a cloistered priest. Learn what you can of the past in your time here. It will help you to understand where your journey is leading you.','',26124),
(14974,'enUS','Treacherous whelp! I will beat you within an inch of your miserable life!','',26124),
(14975,'enUS','Tell me where the totem of Kar\'dash is hidden and the beatings will stop.','',26124),
(14976,'enUS','Shadow Hunter Denjai sent me here with a small contingent of builders and warriors to establish this outpost. We\'ve barely finished building it and he\'s already asking for reports!$B$BIf you need supplies, I can offer a few things, but we\'re still waiting for our first shipment.','',26124),
(14977,'enUS','Once you die from the torture, we will go out and kidnap another of your kind. One of you is bound to crack under the pain and give us the information we need.','',26124),
(14978,'enUS','Once the totem of Kar\'dash is ours, we will raze your cities and rebuild them as our own.','Once the totem of Kar\'dash is ours, we will raze your cities and rebuild them as our own.',26124),
(14979,'enUS','I wish to buy from you.','I wish to buy from you.',26124),
(14980,'enUS','If you ever meet Witch Doctor Tor\'gash, tell him his concoctions and charms don\'t work! I did exactly as he told me to and still Magasha has eyes only for Zurai.$B$BDon\'t believe a thing that sham witch doctor tells you!','',26124),
(14981,'enUS','','Reavij has all the subtlety of a kodo! What\'s funny is that he doesn\'t think he\'s being obvious. I see the way he stares at me when he thinks no one\'s looking.$B$BHe creeps me out. I really wish Shadow Hunter Denjai hadn\'t sent him with us. Setting up Swamprat Post was the perfect opportunity to get away from him.',26124),
(14982,'enUS','Hello, $c.  I am what is referred to as one of the Broken.  Like the Lost Ones, though not as badly as they, we were afflicted with fel energies that transformed us from our original draenei forms.','',26124),
(14983,'enUS','Garadar is in shambles, stranger. Since the Greatmother took ill, Garrosh has gone into a deep depression. He is most certainly not his father\'s boy.$B$B<Kurkush sighs.>\n','',26124),
(14984,'enUS','Put your backs into it!','',26124),
(14985,'enUS','Chop faster!','',26124),
(14986,'enUS','Faster or Boss Grog\'ak will have your head!','',26124),
(14987,'enUS','Do I need to come over there and show you how it\'s done?','',26124),
(14988,'enUS','Maybe a lightning bolt will give you the incentive to work faster?','',26124),
(14989,'enUS','No breaks until it\'s all chopped down!','',26124),
(14990,'enUS','At last it is here! Mourn and lament the passing of all you have ever known, and all that would have been! Hach min corai!','',26124),
(14991,'enUS','No, it cannot be! Nooo!','',26124),
(14992,'enUS','Back to work, dog!','',26124),
(14993,'enUS','Notices of reward for the naga leaders of the Darkcrest and Bloodscale tribes are listed here.  They both sound extremely dangerous, perhaps you should check again later.','',26124),
(14994,'enUS','Notices of reward for the naga leaders of the Darkcrest and Bloodscale tribes are listed here.','',26124),
(14995,'enUS','They died. All of them...$B$BAs the Murkbloods cut through us, something took hold of me that I cannot understand. Tell me, have you ever felt a rage so great that the whole of your being burns? A heat that wilts the living? A heat that incinerates the blood in your veins? That is what I felt.$B$B<Saurfang\'s eyes glow red for a brief moment.>$B$BI was the last one left alive. 30 of them surrounded me... Murkbloods... I remember nothing beyond that vision. I blacked out and awoke some time later.','',26124),
(14996,'enUS','Dark times loom ahead, stranger...','',26124),
(14997,'enUS','The spirits are greatly agitated. We must find the cause of this disturbance.','',26124),
(14998,'enUS','%s places the Murkblood idols atop the Lightning stone and invokes the spirits.','',26124),
(14999,'enUS','Look out!','',26124),
(15000,'enUS','More of them coming! Watch out!','',26124),
(15001,'enUS','It is best that we split up now, in case they send more after us. Hopefully one of us will make it back to Garrosh. Farewell, stranger.','',26124),
(15002,'enUS','Don\'t let them escape! Kill the strong one first!','',26124),
(15003,'enUS','Where do you think you\'re going? Kill them all!','',26124),
(15004,'enUS','Spirits grant me the strength to heal!','',26124),
(15005,'enUS','Wounds be gone!','',26124),
(15006,'enUS','Ride the lightning, filth!','',26124),
(15007,'enUS','The Sons of Lightning will have their vengeance!','',26124),
(15008,'enUS','Totem of the earth, halt their advances!','',26124),
(15009,'enUS','FROST SHOCK!','',26124),
(15010,'enUS','','No, no, no! Come back here!',26124),
(15011,'enUS','','The magister\'s going to kill me...',26124),
(15012,'enUS','','Get back here, you little...',26124),
(15013,'enUS','','Argh. They told me those crystals would work properly!',26124),
(15014,'enUS','','You stay out of the regent lord\'s way! I mean it!',26124),
(15015,'enUS','','When I catch you, I\'m going to disenchant your components, so help me...',26124),
(15016,'enUS','Everything that we have, we have fought for tooth and tentacle... Retaking Telaar from the orcs and then the ogres was no easy task.','',26124),
(15017,'enUS','|cffffff00All the guards have been defeated!|r','',26124),
(15018,'enUS','|cffffff00The Alliance has taken control of Halaa!|r','',26124),
(15019,'enUS','|cffffff00The Horde has taken control of Halaa!|r','',26124),
(15020,'enUS','|cffffff00Halaa is defenseless!|r','',26124),
(15021,'enUS','Hm, unannounced visitors. Preparations must be made...','',26124),
(15022,'enUS','How terribly clumsy of me.','',26124),
(15023,'enUS','Hemet is the greatest hunter that I know.  We chanced upon each other in the hills of Winterspring back on Azeroth many moons ago.  He and I were stalking the same quarry: the great cat known as Rak\'shiri.$B$BRather than fight each other over our prey, we made a wager out of it; whoever collected the frostsaber\'s skin would get to demand something of the other.  To my eternal shame, this is how I earned the nickname, Fitz.$B$BDo I look like a Fitz?','',26124),
(15024,'enUS','Your new name is Sayena.','',26124),
(15025,'enUS','','My name is Nimrida, boy.',26124),
(15026,'enUS','It\'s Sayena.','',26124),
(15027,'enUS','','Nimrida.',26124),
(15028,'enUS','I\'m your master... you\'re supposed to do what I say!','',26124),
(15029,'enUS','','You may have summoned me, my little warlock, but that does not give you leave to rename me like some child\'s pet.',26124),
(15030,'enUS','Come on... please?','',26124),
(15031,'enUS','','You know I love it when you beg... but no.',26124),
(15032,'enUS','%s hangs his head and sighs.','',26124),
(15033,'enUS','I told you to wait for me elsewhere, not follow me like a puppy...','',26124),
(15034,'enUS','The mighty hunter, $n returns.  Tell me the tale of stalking your latest prey.','',26124),
(15035,'enUS','','Tch. One might think you\'re ashamed to be seen with me, master.',26124),
(15036,'enUS','No, no... it\'s just that... well... we\'re attracting looks.','',26124),
(15037,'enUS','','And what\'s wrong with that? A woman enjoys turning heads now and again.',26124),
(15038,'enUS','Will you please go back inside?','',26124),
(15039,'enUS','','%s arches a brow at Keyanomir, a wry smirk playing about her lips.',26124),
(15040,'enUS','','\"Please?\" You have so much to learn... master.',26124),
(15041,'enUS','Enjoy the taste of fel iron?','',26124),
(15042,'enUS','Die!','',26124),
(15043,'enUS','None shall defeat the Fel Horde!','',26124),
(15044,'enUS','It\'s an ambush! Defend yourself!','',26124),
(15045,'enUS','Yeah, yeah, I\'m feeling better, but I kind of like it down here.','',26124),
(15046,'enUS','We must leave before more are alerted.','',26124),
(15047,'enUS','We are surrounded!','',26124),
(15048,'enUS','Up ahead is the road to Telaar. We will split up when we reach the fork as they will surely send more Murkblood after us. Hopefully one of us makes it back to Telaar alive.','',26124),
(15049,'enUS','Farewell, stranger. Your heroics will be remembered by my people. Now, hurry to Telaar!','',26124),
(15050,'enUS','','Woe to each and every one of you, my pretties!',26124),
(15051,'enUS','','Fixed you, didn\'t I?',26124),
(15052,'enUS','','How could you? What a cruel, cruel world...',26124),
(15053,'enUS','S-sir... have you tried giving the crystal a good shake?  It\'s possible that the ley-lines are clouding up the reading.','',26124),
(15054,'enUS','I ought to give your head a good shake!  I\'ve a feeling the ley-lines are clouding up your brain.  No, Darius, what we need is a large depository of mineral-heavy water.  Even faint arcane signals will accumulate in sulphur and lime.','',26124),
(15055,'enUS','The Menagerie is for guests only.','',26124),
(15056,'enUS','S-sorry, sir.','',26124),
(15057,'enUS','Curator is no longer operation-a-l.','',26124),
(15058,'enUS','','Do not be so harsh on the child, Alturus.  Remember that Cedric himself assigned him to you.',26124),
(15059,'enUS','Your request cannot be processed.','',26124),
(15060,'enUS','Failure to comply will result in offensive action.','',26124),
(15061,'enUS','I grow tired of waiting. Dance for me, imbecile.','',26124),
(15062,'enUS','Not you, moron! The other imbecile.','Not you, moron! The other imbecile.',26124),
(15063,'enUS','Oops. Grondo sorry.','',26124),
(15064,'enUS','You hear Unkor, dummy? Dance!','',26124),
(15065,'enUS','Ok, ok. Me dance now.','',26124),
(15066,'enUS','','Don\'t let them hurt us Tito! Oh, you won\'t, will you?',26124),
(15067,'enUS','','Oh Tito, we simply must find a way home! The old wizard could be our only hope! Strawman, Roar, Tinhead, will you - wait... oh golly, look we have visitors!',26124),
(15068,'enUS','','Oh at last, at last I can go home!',26124),
(15069,'enUS','','Tito! Oh Tito, no!',26124),
(15070,'enUS','','What devil art thou, that dost torment me thus?',26124),
(15071,'enUS','','Parting is such sweet sorrow.',26124),
(15072,'enUS','','Romulo, I come! Oh... this do I drink to thee!',26124),
(15073,'enUS','','Come, gentle night; and give me back my Romulo!',26124),
(15074,'enUS','','O happy dagger! This is thy sheath; there rust, and let me die!',26124),
(15075,'enUS','Wilt thou provoke me? Then have at thee, boy!','',26124),
(15076,'enUS','How well my comfort is revived by this!','',26124),
(15077,'enUS','Thou detestable maw, thou womb of death; I enforce thy rotten jaws to open!','',26124),
(15078,'enUS','Thou smilest... upon the stroke that... murders me.','',26124),
(15079,'enUS','','Your behavior will not be tolerated.',26124),
(15080,'enUS','','Cast out your corrupt thoughts.',26124),
(15081,'enUS','','Death comes. Will your conscience be clear?',26124),
(15082,'enUS','','Ah ah ah...',26124),
(15083,'enUS','','Impure thoughts lead to profane actions.',26124),
(15084,'enUS','','This is for the best.',26124),
(15085,'enUS','Time... never enough time.','',26124),
(15086,'enUS','Oh, I\'ve gone and made a mess...','',26124),
(15087,'enUS','The Consortium has been planning this operation for months!  We were to dig Oshu\'gun, the largest known diamond in the universe.$B$BMinutes before we were to begin, Nexus-Prince Haramaad sends word that we\'re to hold off until a political matter is resolved in Netherstorm.  I\'ve transformed our operation into a clearing house for smuggled gems in the meantime, but this is slowly eating into our profits.','',26124),
(15088,'enUS','Uh oh, those stags don\'t look pleased with us!','',26124),
(15089,'enUS','Look out, Fitz, they\'re coming right for us!','',26124),
(15090,'enUS','What\'s going on?!','',26124),
(15091,'enUS','%s smiles and sheathes his rifle.','',26124),
(15092,'enUS','Gezhe is here to get a job done.  I\'m here to make sure no one bothers him while he does it.','',26124),
(15093,'enUS','Um... guys?','',26124),
(15094,'enUS','Hemet?  Fitz?','',26124),
(15095,'enUS','Oh good, I was beginning to worry.','',26124),
(15096,'enUS','Do you know who we are, stranger? We are Mag\'har - brown orcs, as I have heard your kind call us. The Mag\'har are survivors: Survivors of a fallen dynasty; Survivors of the Red Pox; Survivors of a shattered world...$B$BI am Jorin, son of Kilrogg; last of the lineage of Deadeye: Warchief of the Bleeding Hollow Clan.','',26124),
(15097,'enUS','I give up! Please don\'t kill me!','',26124),
(15098,'enUS','And now, I run!','',26124),
(15099,'enUS','','We wouldn\'t have crashed if Hemet could learn how to avoid shooting through the ailerons when he\'s trying to bag game on the ground!$B$BNo worries though, I\'ll have her fixed up quick enough.',26124),
(15100,'enUS','Surely you\'ve got something to spare, Zalle. You know I\'m good for it. Something, anything!','',26124),
(15101,'enUS','','I\'ve nothing for the likes of you, Cailan. For the last time, get out of this shop.',26124),
(15102,'enUS','','Hi, Harold.  I have your skins!',26124),
(15103,'enUS','Help me!  Please help me!','',26124),
(15104,'enUS','','Ack!  Somebody help me!',26124),
(15106,'enUS','How can you just leave me here?','',26124),
(15107,'enUS','You over there!  Help me find a way out of this wretched cage!','',26124),
(15108,'enUS','Will the pain ever end?','',26124),
(15109,'enUS','%s rifles through Kristen\'s stuff and grabs her bundle of skins.','',26124),
(15110,'enUS','Here are my skins, Harold.  Now give me the reward!','',26124),
(15111,'enUS','I\'ll be taking those skins, tiny.','',26124),
(15112,'enUS','Uh... sure thing, Gankly.  Just...<cough>... wait right there.  <Cough>  Guys?','',26124),
(15113,'enUS','','I am SO glad that evil Gankly Rottenfist got his just desserts!  I have lots of skins if you want some to give to Harold.',26124),
(15114,'enUS','Tag! You\'re it!','Tag! You\'re it!',26124),
(15115,'enUS','Kill them!','',26124),
(15116,'enUS','Get out of the way!','Get out of the way!',26124),
(15117,'enUS','Duck!','Duck!',26124),
(15118,'enUS','OGRE! You\'re the ogre! HA-HA!','OGRE! You\'re the ogre! HA-HA!',26124),
(15119,'enUS','Don\'t go close to the lake! It\'s haunted!','Don\'t go close to the lake! It\'s haunted!',26124),
(15120,'enUS','Can we stop running now?','Can we stop running now?',26124),
(15121,'enUS','I miss my mommy.','I miss my mommy.',26124),
(15122,'enUS','I don\'t wanna play anymore!','I don\'t wanna play anymore!',26124),
(15123,'enUS','I refuse to concede defeat! I am a prince of the Eredar! I... am...','',26124),
(15124,'enUS','Surely you did not think you could win.','',26124),
(15125,'enUS','Your greed, your foolishness has brought you to this end.','',26124),
(15126,'enUS','You are but a plaything. Unfit even to amuse.','',26124),
(15127,'enUS','Madness has brought you here to me. I shall be your undoing!','',26124),
(15129,'enUS','%s begins to arm the Proximity Bomb!','',26124),
(15130,'enUS','Who dares interrupt--What is this; what have you done? You\'ll ruin everything!','',26124),
(15131,'enUS','Go ahead and take forty winks.','',26124),
(15132,'enUS','Closer! Come closer... and burn!','',26124),
(15133,'enUS','You didn\'t have to go and do that!','',26124),
(15134,'enUS','%s spawns a poison cloud!','',26124),
(15135,'enUS','Don\'t let them make... a mattress outta\' me.','',26124),
(15136,'enUS','I guess I\'m not a failure after all!','',26124),
(15137,'enUS','My life is yours, oh great one...','',26124),
(15138,'enUS','','I am SO glad that evil Gankly Rottenfist got his just desserts!',26124),
(15139,'enUS','','Greatmother, please drink this water.',26124),
(15140,'enUS','','Hey!  Didn\'t I give you a bundle of skins before?$B$BEither way, I\'m glad to be saved from the ruthless clutches of that evil Gankly Rottenfist!',26124),
(15141,'enUS','Ah, you\'re just in time. The rituals are about to begin!','',26124),
(15142,'enUS','','Greatmother, is there anything I can do?',26124),
(15143,'enUS','','Greatmother, Garrosh has lost his heart. We are lost without you.',26124),
(15144,'enUS','','I will do my best to take care of the children, Greatmother.',26124),
(15145,'enUS','Your blood will anoint my circle!','',26124),
(15146,'enUS','The great one will be pleased.','',26124),
(15147,'enUS','Please accept this humble offering, oh great one...','',26124),
(15148,'enUS','Let this sacrifice serve as testament to my fealty.','',26124),
(15149,'enUS','','The Greatmother raised all of us. Any Mag\'hari that you see has had their life touched in some special way by the Greatmother. We will miss her greatly when she passes.',26124),
(15150,'enUS','Come, you dwellers in the dark! Rally to my call!','',26124),
(15151,'enUS','Gather, my pets... there is plenty for all!','',26124),
(15152,'enUS','','Greatmother tells me that I was named after a great orcish hero.',26124),
(15153,'enUS','Mmmm... delicious.','',26124),
(15155,'enUS','Back to being an old rust bucket.','',26124),
(15156,'enUS','Guess I\'m not so rusty after all.','',26124),
(15157,'enUS','Shifting, %s moans from the pain of his thorn scratch.','',26124),
(15158,'enUS','%s groans in pain.','',26124),
(15159,'enUS','%s looks at his friends and then grunts painfully.','',26124),
(15160,'enUS','%s wakes himself up snoring.','',26124),
(15161,'enUS','%s winces when he touches the tender area around his scratch.','',26124),
(15162,'enUS','%s begins to whistle a tune, but then stops abruptly and moans.','',26124),
(15163,'enUS','Our time has come!','',26124),
(15164,'enUS','The wizard will fall!','',26124),
(15165,'enUS','Enforcers! Kill them all!','',26124),
(15166,'enUS','We will not be stopped!','',26124),
(15167,'enUS','More will take my place.','',26124),
(15168,'enUS','Your efforts... are in vain.','',26124),
(15169,'enUS','You will not save him!','',26124),
(15170,'enUS','We control the timeways now!','',26124),
(15171,'enUS','','Death to the Last Guardian!',26124),
(15172,'enUS','','You will not stand in our way!',26124),
(15173,'enUS','','Magna Medivh dies today!',26124),
(15174,'enUS','','We are not finished!',26124),
(15175,'enUS','','A minor victory...',26124),
(15176,'enUS','','We will not fail!',26124),
(15177,'enUS','','The end is at hand!',26124),
(15178,'enUS','','One step closer...',26124),
(15179,'enUS','The sands of time shall be scattered to the winds!','The sands of time shall be scattered to the winds!',26124),
(15180,'enUS','History is about to be rewritten!','History is about to be rewritten!',26124),
(15181,'enUS','Let the siege begin!','Let the siege begin!',26124),
(15182,'enUS','The rift must be protected!','The rift must be protected!',26124),
(15183,'enUS','You are running out of time!','You are running out of time!',26124),
(15184,'enUS','Victory or death!','Victory or death!',26124),
(15185,'enUS','You will never defeat us all!','You will never defeat us all!',26124),
(15186,'enUS','You will accomplish nothing!','You will accomplish nothing!',26124),
(15187,'enUS','No! The rift...','No! The rift...',26124),
(15188,'enUS','The end is at hand!','The end is at hand!',26124),
(15189,'enUS','One step closer...','One step closer...',26124),
(15190,'enUS','There is no time to waste!','',26124),
(15191,'enUS','We must hurry!','',26124),
(15192,'enUS','We must use this time wisely!','',26124),
(15193,'enUS','One less threat to the timeways!','',26124),
(15194,'enUS','Victory will be ours!','',26124),
(15195,'enUS','Carry on! Victory at all costs!','',26124),
(15196,'enUS','Continue the fight! Do not falter!','',26124),
(15197,'enUS','You look like a reasonable $r.  Perhaps we could be of mutual assistance.','',26124),
(15198,'enUS','You no take mushroom!','',26124),
(15199,'enUS','I\'ll make you pay for that!','',26124),
(15200,'enUS','Ladies, please. I\'m desperate. Certainly you can spare something... the smallest reagent, your cheapest wares. Help a soul in need!','',26124),
(15201,'enUS','Warlord Kalithresh will hear of this insolence!','',26124),
(15202,'enUS','I will show you not to cross us again!','',26124),
(15203,'enUS','%s\'s lip quivers, and he shuffles out of the shop forlornly.','',26124),
(15204,'enUS','','No handouts, Cailan.',26124),
(15205,'enUS','','I\'m not about to perpetuate your addiction. It certainly isn\'t my fault. Out.',26124),
(15206,'enUS','Be strong. Kael\'thas has betrayed us and what we know is in flux, but do not lose heart. We will endure, as we always have. Arthas did not crush our spirit when he swept through our land, and neither will Kael\'thas. Let it serve as a lesson to us all as we move forward to our prosperous future.','',26124),
(15207,'enUS','Where in our fair city do you wish to go?','Where in our fair city do you wish to go?',26124),
(15208,'enUS','Auction House','Auction House',26124),
(15209,'enUS','We have two auction houses within Silvermoon. Which would you prefer?','We have two auction houses within Silvermoon. Which would you prefer?',26124),
(15210,'enUS','To the west.','To the west.',26124),
(15211,'enUS','The western auction house can be found in the middle of the Bazaar, just west of the Walk of Elders.','The western auction house can be found in the middle of the Bazaar, just west of the Walk of Elders.',26124),
(15212,'enUS','To the east.','To the east.',26124),
(15213,'enUS','The Royal Exchange auction house can be found in the eastern part of the city, just south of the training area for the blood knights and rangers.','The Royal Exchange auction house can be found in the eastern part of the city, just south of the training area for the blood knights and rangers.',26124),
(15214,'enUS','Bank','Bank',26124),
(15215,'enUS','Which of our two banks would you like to visit?','Which of our two banks would you like to visit?',26124),
(15216,'enUS','The west.','The west.',26124),
(15217,'enUS','The Bank of Silvermoon can be found within the Bazaar. Seek it out in the southeast corner.','The Bank of Silvermoon can be found within the Bazaar. Seek it out in the southeast corner.',26124),
(15218,'enUS','The east.','The east.',26124),
(15219,'enUS','If you\'re seeking a bank in the eastern part of the city, look no further than the Royal Exchange. It lies along the north wall therein.','If you\'re seeking a bank in the eastern part of the city, look no further than the Royal Exchange. It lies along the north wall therein.',26124),
(15220,'enUS','Dragonhawk Master','Dragonhawk Master',26124),
(15221,'enUS','Skymistress Gloaming and her dragonhawks are just outside and to the west of the Shepherd\'s Gate.','Skymistress Gloaming and her dragonhawks are just outside and to the west of the Shepherd\'s Gate.',26124),
(15222,'enUS','Guild Master & Vendor','Guild Master & Vendor',26124),
(15223,'enUS','Tandrine is the guild master of Silvermoon. Her residence is along the Walk of Elders, close to the Magister\'s Gate.','Tandrine is the guild master of Silvermoon. Her residence is along the Walk of Elders, close to the Magister\'s Gate.',26124),
(15224,'enUS','Inn','Inn',26124),
(15225,'enUS','The Silvermoon City Inn, located in the Royal Exchange, is run by a talented woman named Velandra. I\'m told that the renowned vinemaster can sometimes be found there, as well.','The Silvermoon City Inn, located in the Royal Exchange, is run by a talented woman named Velandra. I\'m told that the renowned vinemaster can sometimes be found there, as well.',26124),
(15226,'enUS','Mailbox','Mailbox',26124),
(15227,'enUS','We have an abundance of mailboxes in our fair city. The one by the Royal Exchange Bank should certainly fit your needs.','We have an abundance of mailboxes in our fair city. The one by the Royal Exchange Bank should certainly fit your needs.',26124),
(15228,'enUS','Stable Master','Stable Master',26124),
(15229,'enUS','Shalenn tends the animals within the city and prevents them from running amok while their masters continue to fritter their lives away. She stands in Farstriders\' Square, just outside the rangers\' hall.','Shalenn tends the animals within the city and prevents them from running amok while their masters continue to fritter their lives away. She stands in Farstriders\' Square, just outside the rangers\' hall.',26124),
(15230,'enUS','Weapon Master','Weapon Master',26124),
(15231,'enUS','The Blood Knights in Farstriders\' Square graciously allow space within their halls for Ileda, the weapon master of Silvermoon. While her training is not cheap, you\'ll appreciate her expertise.','The Blood Knights in Farstriders\' Square graciously allow space within their halls for Ileda, the weapon master of Silvermoon. While her training is not cheap, you\'ll appreciate her expertise.',26124),
(15232,'enUS','Battlemasters','Battlemasters',26124),
(15233,'enUS','The battlemasters take their ease deep within the halls of the Blood Knight enclave in Farstriders\' Square. While somewhat... crude, they have their redeemable traits.','The battlemasters take their ease deep within the halls of the Blood Knight enclave in Farstriders\' Square. While somewhat... crude, they have their redeemable traits.',26124),
(15234,'enUS','Class Trainer','Class Trainer',26124),
(15235,'enUS','What path do you wish to pursue?','What path do you wish to pursue?',26124),
(15236,'enUS','Druid','Druid',26124),
(15237,'enUS','One of the druids? Our people don\'t walk that path... but you are in luck. A tauren woman - at least, I believe it\'s a woman - has set up a modest residence on the north end of the Walk of Elders. Harene Plainwalker is her name.\n','One of the druids? Our people don\'t walk that path... but you are in luck. A tauren woman - at least, I believe it\'s a woman - has set up a modest residence on the north end of the Walk of Elders. Harene Plainwalker is her name.',26124),
(15238,'enUS','Hunter','Hunter',26124),
(15239,'enUS','Oh. You\'re seeking one of... them. Well, if you truly want to waste your time speaking with those backward individuals, you\'ll find the rangers in Farstriders\' Square. Zandine can take care of you.','Oh. You\'re seeking one of... them. Well, if you truly want to waste your time speaking with those backward individuals, you\'ll find the rangers in Farstriders\' Square. Zandine can take care of you.',26124),
(15240,'enUS','Mage','Mage',26124),
(15241,'enUS','Priest','Priest',26124),
(15242,'enUS','Paladin','Paladin',26124),
(15243,'enUS','Rogue','Rogue',26124),
(15244,'enUS','Warlock','Warlock',26124),
(15245,'enUS','Ah, seeking the masters of the arcane? You can find Quithas and the other magisters within the Sunfury Spire.','Ah, seeking the masters of the arcane? You can find Quithas and the other magisters within the Sunfury Spire.',26124),
(15246,'enUS','Lady Liadrin, matriarch of the Blood Knights, has the Knights\' headquarters in an enclave in Farstriders\' Square. You\'ll need to speak to Champion Bachi there if you are looking for instruction. Be respectful while there if you value your head.','Lady Liadrin, matriarch of the Blood Knights, has the Knights\' headquarters in an enclave in Farstriders\' Square. You\'ll need to speak to Champion Bachi there if you are looking for instruction. Be respectful while there if you value your head.',26124),
(15247,'enUS','The priests of our fair city can be found within the Sunfury Spire.  Seek out the lady Belestra.','The priests of our fair city can be found within the Sunfury Spire.  Seek out the lady Belestra.',26124),
(15248,'enUS','The more agile among us can sometimes be difficult to spot, but nonetheless, you\'ll probably run across the rogue Zelanis and his cohorts deep within Murder Row.','The more agile among us can sometimes be difficult to spot, but nonetheless, you\'ll probably run across the rogue Zelanis and his cohorts deep within Murder Row.',26124),
(15249,'enUS','The summoning of demons is a dangerous practice, but the resulting power can be immense. Our resident expert is Alamma, who watches over the warlocks within Murder Row.','The summoning of demons is a dangerous practice, but the resulting power can be immense. Our resident expert is Alamma, who watches over the warlocks within Murder Row.',26124),
(15250,'enUS','Profession Trainer','Profession Trainer',26124),
(15251,'enUS','Which profession do you seek to learn?','Which profession do you seek to learn?',26124),
(15252,'enUS','Alchemy','Alchemy',26124),
(15254,'enUS','The alchemists are located in the Court of the Sun; you\'ll find Camberon eager to teach you anything you might want to know about the art of brewing potions.','The alchemists are located in the Court of the Sun; you\'ll find Camberon eager to teach you anything you might want to know about the art of brewing potions.',26124),
(15255,'enUS','Blacksmithing','Blacksmithing',26124),
(15256,'enUS','Bemarrin teaches the trade of blacksmithing in Farstriders\' Square. While a somewhat... dirty trade, I suppose it has its merits.','Bemarrin teaches the trade of blacksmithing in Farstriders\' Square. While a somewhat... dirty trade, I suppose it has its merits.',26124),
(15257,'enUS','Enchanting','Enchanting',26124),
(15258,'enUS','The enchanter Sedana is currently accepting apprentices, I believe. You\'ll find her in one of the alcoves within the Court of the Sun.','The enchanter Sedana is currently accepting apprentices, I believe. You\'ll find her in one of the alcoves within the Court of the Sun.',26124),
(15259,'enUS','Engineering','Engineering',26124),
(15260,'enUS','An odd choice... but I suppose I\'m not one to judge. Danwe is the one you\'re after; her engineering stand lies near the Court of the Sun, on the path to Farstriders\' Square.','An odd choice... but I suppose I\'m not one to judge. Danwe is the one you\'re after; her engineering stand lies near the Court of the Sun, on the path to Farstriders\' Square.',26124),
(15261,'enUS','First Aid','First Aid',26124),
(15262,'enUS','Alestus is a master at the... messier way of mending wounds.  If learning first aid is your aim, seek him out on the Walk of Elders, near the entrance to the Royal Exchange.','Alestus is a master at the... messier way of mending wounds.  If learning first aid is your aim, seek him out on the Walk of Elders, near the entrance to the Royal Exchange.',26124),
(15263,'enUS','Fishing','Fishing',26124),
(15264,'enUS','The waters of Quel\'thalas are teeming with fish; I take it they caught your eye? Drathen is quite experienced with the tricks of the fishing trade, and can be found on the Walk of Elders near the Royal Exchange.','The waters of Quel\'thalas are teeming with fish; I take it they caught your eye? Drathen is quite experienced with the tricks of the fishing trade, and can be found on the Walk of Elders near the Royal Exchange.',26124),
(15265,'enUS','Herbalism','Herbalism',26124),
(15266,'enUS','Botanist Nathera has a keen eye for finding herbs, and I imagine she might impart her wisdom to the likes of you. You\'ll find her with the alchemists in an alcove of the Court of the Sun.','Botanist Nathera has a keen eye for finding herbs, and I imagine she might impart her wisdom to the likes of you. You\'ll find her with the alchemists in an alcove of the Court of the Sun.',26124),
(15267,'enUS','Jewelcrafting','Jewelcrafting',26124),
(15268,'enUS','If jewelcrafting is what you seek, you\'ll find Kalinda\'s shop on the south end of the Royal Exchange.','If jewelcrafting is what you seek, you\'ll find Kalinda\'s shop on the south end of the Royal Exchange.',26124),
(15269,'enUS','Leatherworking','Leatherworking',26124),
(15270,'enUS','Along the southeast end of the Walk of Elders, Lynalis has set up a fine leatherworking stand. She\'ll train you... for a fee.','Along the southeast end of the Walk of Elders, Lynalis has set up a fine leatherworking stand. She\'ll train you... for a fee.',26124),
(15271,'enUS','Mining','Mining',26124),
(15272,'enUS','If digging in the dirt is the sort of pastime you find enjoyable, go share your insanity with Belil in Farstriders\' Square. I\'m certain he\'d be happy to see he\'s not the only crazy one.','If digging in the dirt is the sort of pastime you find enjoyable, go share your insanity with Belil in Farstriders\' Square. I\'m certain he\'d be happy to see he\'s not the only crazy one.',26124),
(15273,'enUS','Skinning','Skinning',26124),
(15274,'enUS','Tyn is quite the talented skinner; she produces the finest lynx hides I\'ve yet seen. If you wish to learn from her, you\'ll find her on the southeast end of the Walk of Elders.','Tyn is quite the talented skinner; she produces the finest lynx hides I\'ve yet seen. If you wish to learn from her, you\'ll find her on the southeast end of the Walk of Elders.',26124),
(15275,'enUS','Tailoring','Tailoring',26124),
(15276,'enUS','The tailor Keelen is always seeking more curious students to teach his delicate craft. His shop is somewhat difficult to uncover at first, but it\'s just north of the auction house in the Bazaar. You\'ll find him on the lower level of the building.','The tailor Keelen is always seeking more curious students to teach his delicate craft. His shop is somewhat difficult to uncover at first, but it\'s just north of the auction house in the Bazaar. You\'ll find him on the lower level of the building.',26124),
(15277,'enUS','TESTING. IS THIS THING WORKING????','TESTING. IS THIS THING WORKING????',26124),
(15278,'enUS','In Nagrand, food hunt ogre!','',26124),
(15279,'enUS','You taste good with maybe a little salt and pepper.','',26124),
(15280,'enUS','%s drops a conspicuous document.','',26124),
(15281,'enUS','Why you mean to Lump? Lump hungry, dat\'s all.','',26124),
(15282,'enUS','OK, OK! Lump give up!','',26124),
(15283,'enUS','I need answers, ogre!','I need answers, ogre!',26124),
(15284,'enUS','OK! Lump tell you anything you want!','',26124),
(15285,'enUS','Why are Boulderfist out this far? You know that this is Kurenai territory.','Why are Boulderfist out this far? You know that this is Kurenai territory.',26124),
(15286,'enUS','Boulderfist hungry! Need food! Warmaul ogre tribe kick Boulderfist out of mound to north. Many more Boulderfist to feed now.','',26124),
(15287,'enUS','And you think you can just eat anything you want? You\'re obviously trying to eat the Broken of Telaar.','And you think you can just eat anything you want? You\'re obviously trying to eat the Broken of Telaar.',26124),
(15288,'enUS','Dat not true. Me just want to nibble. I don\'t eat all. Ok, maybe I eat da little ones.$B$BDey so delicious!\n','',26124),
(15289,'enUS','This means war, Lump! War I say!','This means war, Lump! War I say!',26124),
(15290,'enUS','<Lump shrugs.>$B$BYou bring da war to da Boulderfist. We put it in da stew.\n','',26124),
(15291,'enUS','Get me out of here, $r!','',26124),
(15292,'enUS','Hey fathead, how about some food!?','',26124),
(15293,'enUS','Hey fatso, how do you go to the bathroom with all that fat!?','',26124),
(15294,'enUS','Eat me already! I can\'t take being locked up in this cage around you stinky, fat slobs.','',26124),
(15295,'enUS','I want my daddy!','',26124),
(15296,'enUS','You fatheads are in trouble if I ever get out of here!','',26124),
(15297,'enUS','Thanks, $r! I\'m sure my dad will reward you greatly! Bye!','',26124),
(15298,'enUS','You shut up!','',26124),
(15299,'enUS','Me don\'t even want to eat him no more.','',26124),
(15300,'enUS','Me lose appetite. Corki is poop.','',26124),
(15301,'enUS','Me no can take it no more!','',26124),
(15302,'enUS','','Learning about new plant species is extremely important for our expedition.  Not just the medicinal or edible ones either.$B$BPlants provide the foundation for many other forms of life to exist.  Understanding them allows us to better understand nature as a whole.',26124),
(15303,'enUS','','',26124),
(15304,'enUS','Congratulations. It smells worse in here than in the ruins.','',26124),
(15305,'enUS','Hey fatso, is there any reason why you insist on living in a dung filled hole in the wall?','',26124),
(15306,'enUS','Can I get some food, please??? This is outrageous!','',26124),
(15307,'enUS','I don\'t know what smells worse: Your feet or a dung-filled cheese and fish fillet.','',26124),
(15308,'enUS','This is the last time I get caught! I promise! Bye!','',26124),
(15309,'enUS','','We have won valuable time. Now we must pull back.',26124),
(15310,'enUS','','%s begins channelling a massive teleport spell. ',26124),
(15311,'enUS','Lord Thrall, it is time to go!','',26124),
(15312,'enUS','We have played our part, and done well at that. It is up to the others now.','',26124),
(15313,'enUS','%s nods at Lady Jaina Proudmoore.','',26124),
(15314,'enUS','Who so boldly stands before Lantresor of the Blade? Do you not know death by sight, $g boy:girl;?','',26124),
(15315,'enUS','I have killed many of your ogres, Lantresor. I have no fear.\n','I have killed many of your ogres, Lantresor. I have no fear.\n',26124),
(15316,'enUS','Then you are a fool. Do you not know what I am?','',26124),
(15317,'enUS','Should I know? You look like an orc to me.','Should I know? You look like an orc to me.',26124),
(15318,'enUS','An orc...$B$B<Lantresor scoffs.>$B$BI am a blademaster of half-orc descent. ','',26124),
(15319,'enUS','And the other half?','And the other half?',26124),
(15320,'enUS','Draenei... And because of this, I am neither. Not orc, not draenei. My own kind are a rare breed. Most having been killed decades ago... I live because of my strength of will.','',26124),
(15321,'enUS','I have heard of your kind, but I never thought to see the day when I would meet a half-breed.','I have heard of your kind, but I never thought to see the day when I would meet a half-breed.',26124),
(15322,'enUS','Bite your tongue, $r. I have seen things in my lifetime that you have only heard about in legends. I have killed man, woman, and child without remorse. Under the banner of two Warchiefs of the Horde I have served... And now, I rule Boulderfist.','',26124),
(15323,'enUS','My apologies. I did not mean to offend. I am here on behalf of my people.\n','My apologies. I did not mean to offend. I am here on behalf of my people.\n',26124),
(15324,'enUS','And what do your people want of Lantresor, $r?','',26124),
(15325,'enUS','My people ask that you pull back your Boulderfist ogres and cease all attacks on our territories. In return, we will also pull back our forces.','My people ask that you pull back your Boulderfist ogres and cease all attacks on our territories. In return, we will also pull back our forces.',26124),
(15326,'enUS','<Lantresor laughs heartily.>$B$BDo you know where you are, fool? This is ogre land. Before orc, before draenei, there was ogre. Yet, you wish to start a war that you will inevitably lose? Boulderfist will crush you. And if Boulderfist does not destroy you, Warmaul will...$B$BBut I think your leaders already know this...','',26124),
(15327,'enUS','We will fight you until the end, then, Lantresor. We will not stand idly by as you pillage our towns and kill our people.','We will fight you until the end, then, Lantresor. We will not stand idly by as you pillage our towns and kill our people.',26124),
(15328,'enUS','<Lantresor glares at you as if he were looking through you.>$B$BPerhaps there is another way... I will agree to your leader\'s demands, only if you do exactly as I ask.$B$BWith your assistance, we may be able to help each other out greatly.\n','',26124),
(15329,'enUS','What do I need to do?','What do I need to do?',26124),
(15330,'enUS','You will stage a series of events that will lead the Kil\'sorrow orcs of Kil\'sorrow Fortress to believe that the Warmaul ogres have attacked their base and then another series of events to make the Warmaul ogres believe the Kil\'sorrow orcs are attacking their base.$B$BDo this and you solve both of our problems.$B$BThe Boulderfist will have their territory back and your people will be free from attack from Boulderfist, Warmaul and Shadow Council.','',26124),
(15331,'enUS','No overgrown bug\'s gonna chase me out of Zangarmarsh! I\'ll show \'em what the Explorers\' League is made of...','',26124),
(15332,'enUS','','It will all be over soon!',26124),
(15333,'enUS','Another trophy to add to my collection!','',26124),
(15334,'enUS','Well done, Midnight!','',26124),
(15335,'enUS','Do not touch the displays.','',26124),
(15336,'enUS','You are not a guest.','',26124),
(15337,'enUS','Gallery rules will be strictly enforced.','',26124),
(15338,'enUS','This Curator is equipped for gallery protection.','',26124),
(15339,'enUS','Now, where was I? Oh, yes...','',26124),
(15340,'enUS','You rang?','',26124),
(15341,'enUS','Simple fools! Time is the fire in which you\'ll burn!','',26124),
(15342,'enUS','How can you hope to stand against such overwhelming power?','',26124),
(15343,'enUS','All realities, all dimensions are open to me!','',26124),
(15344,'enUS','You face not Malchezaar alone, but the legions I command!','',26124),
(15345,'enUS','At last the nightmare is over...','',26124),
(15346,'enUS','Rawr! Me is Shadow Council magishun! Me come for Warmaul terri... tettritor... Me come for Warmaul land!','',26124),
(15347,'enUS','Shadow Council come for you Warmaul! We is mad at you!','',26124),
(15348,'enUS','I killeded anoder Warmaul ogre! I am Shadow Council! Come get me!','',26124),
(15349,'enUS','Shut up, stupid! Why you yell?','',26124),
(15350,'enUS','Me wanted to make it belive... Me wanted to make it real. Dey tink for shure it Shadow Council now!','',26124),
(15351,'enUS','You so smart. Let\'s do dis now before more come.','',26124),
(15352,'enUS','Dat\'s all of dem! Dese Warmaul be so mad! Hooray!','',26124),
(15353,'enUS','I\'ll not be tortured again!','',26124),
(15354,'enUS','You make dat sound pretty good. Sound like da orc dieded.','',26124),
(15355,'enUS','My dead orc sound is da best!','',26124),
(15356,'enUS','Your dead orc sound ok. Mine better.','',26124),
(15357,'enUS','For shure it be good.','',26124),
(15358,'enUS','Last mont, me won da dead orc sound champi... champichi... me won da dead orc sound contest.','',26124),
(15359,'enUS','Tonight, things are not what they seem... for tonight your eyes may not be trusted!','',26124),
(15360,'enUS','Take for instance this quiet elderly woman waiting for a visit from her granddaughter... surely there is nothing to fear from this sweet, gray-haired old lady!','',26124),
(15361,'enUS','But don\'t let me pull the wool over your eyes! See for yourself what lies beneath those covers! And now... on with the show!','',26124),
(15362,'enUS','Tonight we plumb the depths of the human soul as we join a lost, lonely girl trying desperately--with the help of her loyal companions--to find her way home!','',26124),
(15363,'enUS','But she is pursued... by a wicked, malevolent crone!','',26124),
(15364,'enUS','Will she survive? Will she prevail? Only time will tell. And now... on with the show!','',26124),
(15365,'enUS','Tonight... we explore a tale of forbidden love!','',26124),
(15366,'enUS','But beware, for not all love stories end happily, as you may find out. Sometimes, love pricks like a thorn!','',26124),
(15367,'enUS','But don\'t take it from me; see for yourself what tragedy lies ahead when the paths of star crossed lovers meet! And now... on with the show!','',26124),
(15368,'enUS','[PH] This is a test boss emote to see how the text is displayed.','',26124),
(15369,'enUS','Registrants are required to speak with Warden Bullrok before posting any task.$B$BThose found making unapproved postings will be prosecuted.$B$BPost no bills.','',26124),
(15370,'enUS','Registrants are required to speak with Warden Moi\'bff Jill before posting any task.$B$BThose found making unapproved postings will be prosecuted.$B$BPost no bills.','',26124),
(15371,'enUS','Damn those ogres. Damn them to the Nether. Won\'t someone save us from these savages! This is the fifth kidnapping in as many days.','',26124),
(15372,'enUS','That\'s the best reward we\'re going to be able to offer. Hopefully someone accepts the mission.','',26124),
(15373,'enUS','New posting going up! Adventurers and heroes, gather round the bulletin board!','',26124),
(15374,'enUS','That should get Telaar the assistance it needs!','',26124),
(15375,'enUS','Check the bulletin board if you\'re looking for work, $r.','',26124),
(15376,'enUS','You treat my hat well now, $n.  You won\'t find a finer one anywhere in this world or another.','',26124),
(15377,'enUS','','[PH] Players! Go Stop Archimonde at the tree, we will hold the Undead off here!',26124),
(15378,'enUS','Who dares attack the steed of the Huntsman?','',26124),
(15379,'enUS','Perhaps you would rather test yourselves against a more formidable opponent?!','',26124),
(15380,'enUS','They have no respect for the dead, $r. The ogres must be taught a lesson.','',26124),
(15381,'enUS','We must search for survivors. If anyone is still alive, we must at least try and get them back...','',26124),
(15382,'enUS','Help! Help! They\'re going to eat me!','Help! Help! They\'re going to eat me!',26124),
(15383,'enUS','I\'m done for!','I\'m done for!',26124),
(15384,'enUS','One day, a hero will rise and lift the orcs up to their former glory.','One day, a hero will rise and lift the orcs up to their former glory.',26124),
(15385,'enUS','The ogres have the keys! Kill the ogres and get me out of here!','The ogres have the keys! Kill the ogres and get me out of here!',26124),
(15386,'enUS','My children will be made orphans!','My children will be made orphans!',26124),
(15387,'enUS','Thank you, $r! Your service to the Mag\'har will not be forgotten.','Thank you, $r! Your service to the Mag\'har will not be forgotten.',26124),
(15388,'enUS','Death to the ogres!','Death to the ogres!',26124),
(15389,'enUS','Many thanks, hero!','Many thanks, hero!',26124),
(15390,'enUS','Spirits watch over you, $r!','Spirits watch over you, $r!',26124),
(15391,'enUS','Go on, get out of here!  Save yourself!','',26124),
(15392,'enUS','','Well done, adventurer. Rage Winterchill\'s death has earned us all a small pause in the enemy\'s advance. Use this short time wisely. Tend to your wounded and prepare your defenses, as soon Archimonde will send even deadlier forces at us. My meager force of reserve units will reinforce you when battle is joined again.',26124),
(15393,'enUS','We are ready for whatever Archimonde might send our way, Lady Proudmoore.','We are ready for whatever Archimonde might send our way, Lady Proudmoore.',26124),
(15394,'enUS','','Then let Archimonde do his worst.',26124),
(15395,'enUS','BOOM!','',26124),
(15397,'enUS','Stop looking at me!','',26124),
(15398,'enUS','They broke us all.','',26124),
(15399,'enUS','Can\'t... control... form.','',26124),
(15400,'enUS','Meow.','',26124),
(15401,'enUS','Roar!','',26124),
(15402,'enUS','Blinding white light, and then silence!','',26124),
(15403,'enUS','Too close to the truth, too close to the truth!','',26124),
(15404,'enUS','Who are you?  What do you want here?','',26124),
(15405,'enUS','Why did you do this to us?','',26124),
(15406,'enUS','There are FOUR lights!','',26124),
(15407,'enUS','My vicious teromoths will avenge me!','',26124),
(15408,'enUS','Where did everyone go?','',26124),
(15409,'enUS','Dinner guests should show more respect!','',26124),
(15410,'enUS','Oh, what a sacred place is here overthrown!','',26124),
(15411,'enUS','I can instruct you in mining.  Interested?','I can instruct you in mining.  Interested?',26124),
(15412,'enUS','Anoint my head with a healing balm.  Do you like my crown of thorns?','',26124),
(15413,'enUS','I can instruct you in herbalism.  Interested?','I can instruct you in herbalism.  Interested?',26124),
(15414,'enUS','I can instruct you in alchemy.  Interested?','I can instruct you in alchemy.  Interested?',26124),
(15415,'enUS','','Amazing! Anatheron\'s defeat at your hands has delayed Archimonde from his objective, and brought us that much closer to victory. My forces cannot stay here, however. My troops and I are exhausted, and now is the time for retreat. If your strength has not waned, head east to Thrall\'s encampment. That is where we make another stand. Be well.',26124),
(15416,'enUS','Until we meet again, Lady Proudmoore.','Until we meet again, Lady Proudmoore.',26124),
(15418,'enUS','You won\'t get my clothes!  Die!','',26124),
(15419,'enUS','IT DUZ WUT IT\'S TOLD!','',26124),
(15420,'enUS','GET IN DA STEW!','',26124),
(15421,'enUS','YOU GUD IN DA BELLY!','',26124),
(15422,'enUS','','We\'ve got to get those supply crates back!',26124),
(15423,'enUS','Why do you want to eat me when you have all of these orcs to eat?','',26124),
(15424,'enUS','Thanks, $n! How many times have you saved my life now? Three? That makes us blood in my book!','',26124),
(15425,'enUS','Be careful going into the thicket, $c.  There is a harmful aura lingering about the place.  It must be the residue from whatever destroyed my fellow druids.','',26124),
(15426,'enUS','Your daddy pay Warmaul and maybe we no eat you.','',26124),
(15427,'enUS','Ha-ha! Just kidding. We eat you for shure anyway!','',26124),
(15428,'enUS','This forest be a spooky place.  It\'s full of more bad juju than just the Alliance, so you watch out for yourself.','',26124),
(15429,'enUS','','The Horde isn\'t the only danger in this forest.  Don\'t let its seeming tranquility fool you.',26124),
(15430,'enUS','BAM! Look at dat gristle sizzle!','',26124),
(15431,'enUS','And dis is da recipe for da bestest Broken chowder!','',26124),
(15432,'enUS','First you need da spices.','',26124),
(15433,'enUS','Da salt goes into da pot...','',26124),
(15434,'enUS','Den you put da pepper in da pot...','',26124),
(15435,'enUS','Now we gonna kick it up a notch wit da secret ingra... ingor... inrag... da secret sauce!','',26124),
(15436,'enUS','And last, we put in da Corki!','',26124),
(15437,'enUS','You\'re definitely strong, $r, but do you have what it takes to become the Warmaul champion?','',26124),
(15438,'enUS','Brokentoe prepares to charge.','',26124),
(15439,'enUS','The battle is about to begin! $n versus the ferocious clefthoof, Brokentoe!','',26124),
(15440,'enUS','Get out of my way, $r. Can\'t you see that we\'re in the middle of a battle!','',26124),
(15441,'enUS','Get in the Ring of Blood, $n. The fight is about to start!','',26124),
(15442,'enUS','$n has defeated Brokentoe!','',26124),
(15443,'enUS','$n has been defeated!','',26124),
(15444,'enUS','Outstanding! Kaz\'rogal\'s death cry should strike fear into the core of the Burning Legion. They now know the power your forces possess, so expect the worst the Legion can offer.','',26124),
(15445,'enUS','We have nothing to fear.','We have nothing to fear.',26124),
(15446,'enUS','May the spirits be with you.','',26124),
(15447,'enUS','A loud chime sounds as the defense wards detect intruders, alerting the sentries.','',26124),
(15448,'enUS','Outstanding! Killing a Pit Lord such as Azgalor is no small feat, my friend. If we had more time, I would love to hear the story of you and your companions. Archimonde will not give us that pause, however. My scouts have already reported that the Legion is amassing an immense force outside our camp, and Archimonde is very close to the World Tree. We are evacuating with the help of Lady Proudmoore. You should head to the World Tree at once. The fate of our world is still undecided.','',26124),
(15449,'enUS','Until we meet again, Thrall.','Until we meet again, Thrall.',26124),
(15450,'enUS','Filthy vermin.  Submit or perish!','',26124),
(15451,'enUS','You as well, Flutter?  We used to be such good friends.  I will miss you.','',26124),
(15452,'enUS','Oops, my bad.  Sometimes I can\'t control my moonfire.','',26124),
(15453,'enUS','Who are you to stare at me and pass judgment?!','',26124),
(15454,'enUS','Do I know you?  If you\'re interested in joining the Cenarion Expedition step right in.','',26124),
(15455,'enUS','Careful who you talk to.  The teromoths have ears.','',26124),
(15456,'enUS','Not all dinner guests are gracious.  Mind your manners!','',26124),
(15457,'enUS','It knows all, it sees all!','',26124),
(15458,'enUS','No need to wait outside in the rain.  Come in... you\'re welcome with us in here.','',26124),
(15459,'enUS','The vicious teromoths and I are just fine in here on our own, thank you.','',26124),
(15460,'enUS','Blue brothers reign supreme!','',26124),
(15461,'enUS','The battle is about to begin! The unmerciful Murkblood twins versus $n!','',26124),
(15462,'enUS','Unbelievable! $n has defeated the Murkblood twins!','',26124),
(15463,'enUS','Come out, little birdies! Mug\'gok want to play!','',26124),
(15464,'enUS','No hurt Mug\'gok\'s feelings, bird-men!','',26124),
(15465,'enUS','Fine! Birdies be dat way! Mug\'gok find new friends!','',26124),
(15466,'enUS','Rise, my fallen brothers! Take form and fight!','',26124),
(15467,'enUS','Hailing from the mountains of Blade\'s Edge comes Rokdar the Sundered Lord! $n is in for the fight of $g his:her; life.','',26124),
(15468,'enUS','ROKDAR SMASH PUNY $n!','',26124),
(15469,'enUS','$n is victorious once more!','',26124),
(15470,'enUS','Dat was poop! Mogor could put up much better fight den dat!','',26124),
(15471,'enUS','The corpse of one of the Broken lies here.  Mysteriously, the cause of its death does not appear to be from one of the mutated moths.$B$BPerhaps it has something to do with the strange object resting right next to its outstretched hand?','',26124),
(15472,'enUS','Closer... Come closer... See what the void brings!','',26124),
(15473,'enUS','From parts unknown: Skra\'gath! Can $n possibly survive the onslaught of void energies?','',26124),
(15474,'enUS','Mogor not impressed! Skra\'gath wuz made of da air and shadow! Soft like da squishy orcies!','',26124),
(15475,'enUS','This is the moment we\'ve all been waiting for! The Warmaul champion is about to make his first showing at the Ring of Blood in weeks! Will $n go down in defeat as easily as the champion\'s other opponents? We shall see...','',26124),
(15476,'enUS','Piece by piece I will tear this challenger apart... PIECE BY PIECE!','',26124),
(15477,'enUS','WUT!? UNPOSSIBLE!! You fight Mogor now! Mogor destroy!','',26124),
(15478,'enUS','Now you face da true champion! I give you chance to run away little one. Run away now before Mogor decim... destyor... Run away before Mogor KILL!','',26124),
(15479,'enUS','No more chances! Now you pay da ogre!','',26124),
(15480,'enUS','Mogor has challenged you. You have to accept! Get in the ring if you are ready to fight.','',26124),
(15481,'enUS','For the first time in the Ring of Blood\'s history, Mogor has chosen to exercise his right of battle! On this wartorn ground, $n will face Mogor, hero of the Warmaul!','',26124),
(15482,'enUS','$n has defeated the hero of the Warmaul, Mogor! All hail $n!','',26124),
(15483,'enUS','No more nice ogre! You hurt Mogor!!','',26124),
(15484,'enUS','$n went down like a sack of orc skulls!','',26124),
(15485,'enUS','All that\'s left of $n is a red stain on the floor!','',26124),
(15486,'enUS','Hail, champion! Have you ever thought about going into the gladiator business full time? You and I could make a mountain of gold.','',26124),
(15487,'enUS','What is the meaning of this?!','',26124),
(15488,'enUS','Very busy... very busy!  What?','',26124),
(15489,'enUS','Empoor, you\'re going to tell me what I want to know, or else!','Empoor, you\'re going to tell me what I want to know, or else!',26124),
(15490,'enUS','Now that I\'ve been beaten to within an inch of my life what do you want?','',26124),
(15491,'enUS','I\'m leaving now!','',26124),
(15492,'enUS','We\'ll get to the bottom of this massacre if it\'s the last thing we do!','',26124),
(15493,'enUS','|cffffff00The Horde is gaining control of Halaa!|r','',26124),
(15494,'enUS','|cffffff00The Alliance is gaining control of Halaa!|r','',26124),
(15495,'enUS','Thank you, $n! I\'d given up any hope of being rescued from these crazy bird-brains!','',26124),
(15496,'enUS','I am in your debt, $n. I had begun to think I would die in this overgrown nest!','',26124),
(15497,'enUS','','Your assistance fighting the Burning Legion would be most appreciated. Lady Jaina Proudmoore could use your help on the front lines.',26124),
(15498,'enUS','','Your continued help against the Burning Legion would still be appreciated. Thrall could use your assistance in his encampment to the west of here.',26124),
(15499,'enUS','','The moment we\'ve been dreading is now at hand, $C. Archimonde has made his way to Nordrassil, and is beginning to devour the World Tree\'s energies. Malfurion needs more time for his plan to work, so we must do the unthinkable. You must attack Archimonde directly, while my own troops hold off the streams of Burning Legion forces approaching the top of the mount.',26124),
(15500,'enUS','Have you come to rescue me? Quick, get me out of these chains!','',26124),
(15501,'enUS','I\'ll have you out of them in just a moment.','I\'ll have you out of them in just a moment.',26124),
(15502,'enUS','Hurry and free me from these chains before the bird-men return!','',26124),
(15503,'enUS','I\'ll have you out of those chains in a moment.','I\'ll have you out of those chains in a moment.',26124),
(15504,'enUS','Faster! Faster you worthless runts!','',26124),
(15505,'enUS','FOR THE GLORY OF THE LEGION!','',26124),
(15506,'enUS','Demos will flense the flesh from your bones!','',26124),
(15507,'enUS','This forge will usher in the new age! Demos commands it!','',26124),
(15508,'enUS','This forge will usher in the new age! Demos commands it!','',26124),
(15509,'enUS','Welcome to the Taverns of Time!','',26124),
(15510,'enUS','Rest your weary feet, we have all the time in the world...','',26124),
(15511,'enUS','Can I offer you a drink? I promise you its aged like none other!','',26124),
(15512,'enUS','','Congratulations! A great victory has been won today.',26124),
(15514,'enUS','The World\'s End Tavern has nothing to offer those of my kind.  However, I find that it attracts the type of clientele that are interested in what I have for sale.$B$BI specialize in exotic engineering goods acquired from far and wide.  From time to time I might even have a rare thing or two for purchase.$B$BWhat might I interest you in?','',26124),
(15515,'enUS','Any luck tracking down that box in Tuurem?','',26124),
(15516,'enUS','What do you see when you look to the west, mortal?','',26124),
(15517,'enUS','I see twisted steel and smell sundered earth.','I see twisted steel and smell sundered earth.',26124),
(15518,'enUS','Do you know what I see? A precursor to invasion.$B$BAye, the master was wise in sealing the portals but has since lost his... how shall I put this? The master has lost his focus. Yes... Focus.$B$BWith this loss, the Legion has seized opportunity. They seep out now, growing in number day by day.','',26124),
(15519,'enUS','Legion?','Legion?',26124),
(15520,'enUS','The Burning Legion. Demons. I see them as clearly as you can see your own hand in front of your face. That is, I used to be able to see them clearly.$B$BWith the Legion\'s return come new machinations. Under normal circumstances, I am able to sense the presence of a demon from a thousand paces.$B$B<Altruis grimaces.>','',26124),
(15521,'enUS','And now?','And now?',26124),
(15522,'enUS','They elude me. I cannot see past their defenses. They have put in place wards to prevent detection.$B$B<Altruis points westward.>$B$BThey fear us because they know that we fear nothing. The cost for such power is great, the sacrifices many. ','',26124),
(15523,'enUS','How do you see them now?','How do you see them now?',26124),
(15524,'enUS','<Altruis turns to face you and smiles.>$B$BI do not.$B$B<Altruis points to his steed, Nethrandamus.>$B$BWe must stop them before these forge camps are able to complete whatever it is that they are building.','',26124),
(15525,'enUS','Forge camps?','Forge camps?',26124),
(15526,'enUS','That is what these structures that litter the landscape are called. The Legion have employed the mo\'arg and gan\'arg to build weapons of mass destruction at these mobile forge camps. Let us not find out what it is that they intend to build here in Nagrand!$B$BYou will be my eyes. Your weapons will be my fury.','',26124),
(15527,'enUS','Oh no, not you again!  Go away!','',26124),
(15528,'enUS','This belongs to Firewing Point.  You\'ll not be putting your grubby hands on it!','This belongs to Firewing Point.  You\'ll not be putting your grubby hands on it!',26124),
(15529,'enUS','Clearly annoyed, %s swats Naturalist Bite with deadly force.','',26124),
(15530,'enUS','What\'s this?  You\'ve already killed him!  Oh well, I suppose I can study the corpse.','',26124),
(15531,'enUS','Here lies the broken form of poor Naturalist Bite.  His zeal for knowledge was only matched in ferocity by the manner of his death.','',26124),
(15532,'enUS','This is what I have gathered from the information that you collected from the survey.$B$BThere are two primary forge camps: Forge Camp: Hate, directly west of where we stand and Forge Camp: Fear, directly southwest. Each camp has a Legion transporter, one forge, and several spell warding towers. Additionally, the camps are guarded by wrathguards manning fel cannons. Lastly, each camp has a pit lord overseer.$B$BRight then, this should be no problem at all...$B$B<Altruis laughs.>','',26124),
(15534,'enUS','I think I\'ll make my own money on the side while the others try to decide whether it\'s okay to go into Oshu\'gun.$B$BTime is profit!','',26124),
(15535,'enUS','The beacons are lit, now is the time to strike! Take one of these battle standards and plant it at the graveyard for the Horde!','',26124),
(15536,'enUS','Twin Spire Ruins is not yet secure! My orders are to only give out battle standards when the two beacons are lit and the area is secure. Get out there and gain control of those beacons!','',26124),
(15537,'enUS','Give me a battle standard. I will take control of Twin Spire Ruins.','Give me a battle standard. I will take control of Twin Spire Ruins.',26124),
(15538,'enUS','The beacons are lit, now is the time to strike! Take one of these battle standards and plant it at the graveyard for the Alliance!','',26124),
(15539,'enUS','Give me a battle standard. I will take control of Twin Spire Ruins.','Give me a battle standard. I will take control of Twin Spire Ruins.',26124),
(15540,'enUS','Twin Spire Ruins is not yet secure! My orders are to only give out battle standards when the two beacons are lit and the area is secure. Get out there and gain control of those beacons!','',26124),
(15541,'enUS','|cffffff00The Alliance has taken control of the West Beacon!|r','',26124),
(15542,'enUS','You come into my house and threaten ME?  I think not!','',26124),
(15543,'enUS','|cffffff00The Horde has taken control of the West Beacon!|r','',26124),
(15544,'enUS','<Sal\'salabim growls at you, then goes back to drinking his frothy beverage.>','',26124),
(15545,'enUS','|cffffff00The Horde has taken control of the East Beacon!|r','',26124),
(15546,'enUS','|cffffff00The Alliance has taken control of the East Beacon!|r','',26124),
(15551,'enUS','[Demonic] Ka kalix!','',26124),
(15552,'enUS','Altruis sent me. He said that you could help me.','Altruis sent me. He said that you could help me.',26124),
(15553,'enUS','Treelos, I know that the truth is somewhere inside you.  Tell me what it is.','Treelos, I know that the truth is somewhere inside you.  Tell me what it is.',26124),
(15554,'enUS','<Warden Treelos looks at you funny and then pauses a moment, clearly struggling.>$B$BZangarmarsh... too close to truth.$B$B<His face goes crazy again.>$B$BIs he still watching!?','',26124),
(15555,'enUS','Keep it together man!  What about Zangarmarsh?','Keep it together man!  What about Zangarmarsh?',26124),
(15556,'enUS','What\'s that?  Zangarmarsh?  Why would I want to go there?$B$B<Treelos looks thoughtful.>$B$BYes, Zangarmarsh... we... the druids there are getting close to figuring out why the water level is dropping.  It\'s destroying everything!$B$B<You can see the insanity creep back in behind the warden\'s eyes.>$B$BDestroyed us all!  Bright light!  BOOM!!','',26124),
(15557,'enUS','I don\'t have time for this!  Warden, what happened?!','I don\'t have time for this!  Warden, what happened?!',26124),
(15558,'enUS','The Firewing blood elves... for some reason they want to stop us.$B$B<Warden Treelos visibly struggles to keep his wits about him for a few more seconds.>$B$BThey... they sent one of the Broken as ... as an emissary....  But he had a bomb!$B$BThey died, they all died!  They tried to run away!  The lucky ones didn\'t even know.$B$BI must have been at the edge of the blast.  It was horr...IT\'S WATCHING US AGAIN!$B$B<Treelos becomes despondent and looks straight through you as if you\'re not there.>','',26124),
(15559,'enUS','WUT YOU WANT!?','',26124),
(15560,'enUS','I have been sent by Sal\'salabim to collect a debt that you owe. Pay up or I\'m going to have to hurt you.','I have been sent by Sal\'salabim to collect a debt that you owe. Pay up or I\'m going to have to hurt you.',26124),
(15561,'enUS','Fshhhhhhsssfhhhhh?','',26124),
(15562,'enUS','<Floon makes a series of strange clicking and clucking sounds.>','',26124),
(15563,'enUS','Are you serious? He already killed me! What more could he want?','',26124),
(15564,'enUS','He wants his \"golds.\" Pay up or die... again...','He wants his \"golds.\" Pay up or die... again...',26124),
(15565,'enUS','F\'woooroonn! Coosh\'coosh pay nothing! Die!','',26124),
(15566,'enUS','I choose the third option: KILLING YOU!','',26124),
(15567,'enUS','Raliq teach you lesson now!','',26124),
(15568,'enUS','Thank you again, $n, for helping me to uncover what happened here at the thicket.','',26124),
(15569,'enUS','You can have that one, I no longer need him!','',26124),
(15570,'enUS','Intruders? Go ahead, kill that one, it saves me the effort!','',26124),
(15572,'enUS','You want him? Very well, take him!','',26124),
(15573,'enUS','Don\'t waste your time on that one, he\'s weak!','',26124),
(15574,'enUS','Careful! That one might call for his mommy when you hit him. Hahaha!','',26124),
(15575,'enUS','Yes, beat him mercilessly! His skull is as thick as an ogre\'s!\n','',26124),
(15576,'enUS','That one\'s skin may be red, but his belly is yellow!','',26124),
(15577,'enUS','You want another? Go ahead! His blood will look better on the floor than in his face. ','',26124),
(15578,'enUS','Ahh yes, the first kill of the morning. Continue!','',26124),
(15579,'enUS','One pitiful wretch down. Go on, take another one! ','',26124),
(15580,'enUS','That one died so quickly! Perhaps his brothers can put up more of a fight!','',26124),
(15581,'enUS','Even the brown skinned orcs take longer to die. What a waste... next!','',26124),
(15582,'enUS','I was going to kill him anyway!','',26124),
(15583,'enUS','His death was even more miserable than the first!','',26124),
(15584,'enUS','Ah, what a waste... next!','',26124),
(15585,'enUS','He cried when his worg died. Well, no one cries for him now!','',26124),
(15586,'enUS','Took you long enough to finish them off!','',26124),
(15587,'enUS','Now that I\'m free of training those miserable wretches, I\'ll entertain myself with you!','',26124),
(15588,'enUS','How nice of you to decorate my floor with blood.','',26124),
(15589,'enUS','Thank you for saving me the trouble. Now it\'s my turn to have some fun!\n','',26124),
(15590,'enUS','|cffffff00The Horde has taken control of Twin Spire Ruins!|r','',26124),
(15591,'enUS','|cffffff00The Alliance has taken control of Twin Spire Ruins!|r','',26124),
(15593,'enUS','Outsiders? Maybe you can beat some sense into that dolt!','',26124),
(15594,'enUS','You wish to fight us all at once? This should be amusing!\n','',26124),
(15595,'enUS','Come on, show me a real fight!','',26124),
(15596,'enUS','I feel so funky...','',26124),
(15597,'enUS','Ugh... I\'m so not ready to leave...','',26124),
(15598,'enUS','The things I\'ve seen... so beautiful...  if only I were a poet...','',26124),
(15599,'enUS','My head is clear and cloudy at the same time... Crystal Lining...Silver Clouds...','',26124),
(15600,'enUS','','My job is to care for these poor souls.  I accept the help of any willing to lend a hand, be they Aldor or Scryer.$B$BWe are so understaffed, I wouldn\'t turn an ogre away if they knew how to apply a tourniquet.  The politics of the city are of little matter to me. ',26124),
(15601,'enUS','','Can you believe it?  This ethereal does not have a single basilisk eye on him!$B$BAnd his leader has the gall to call himself \"the Smuggler Prince!\"',26124),
(15602,'enUS','The cat watches the broom intently.','',26124),
(15603,'enUS','Why hullo there, Bessy. Its your turn for a walk today, isn\'t it?','',26124),
(15604,'enUS','Poor Bessy, cooped up in this barn on such a hot day. Let me get a snack for you!','',26124),
(15605,'enUS','Bessy is a hungry girl today, isn\'t she? Let me go get you an apple.','',26124),
(15606,'enUS','Good day, Benjamin! Would you mind if I took an apple for Bessy?','',26124),
(15608,'enUS','Hullo there, Benjamin! Mind if I snack an apple for Old Bessy?','',26124),
(15609,'enUS','Benjamin, my old friend, think you could spare an apple for Bessy today?','',26124),
(15610,'enUS','%s grabs an apple from the tree.','',26124),
(15611,'enUS','Thanks, Benjamin!','',26124),
(15612,'enUS','Samuel, is that old wagon still breaking down on you? ','',26124),
(15613,'enUS','That wagon break down on you again, Samuel?','',26124),
(15614,'enUS','Such an old wagon, no wonder it broke down on you, Samuel. ','',26124),
(15615,'enUS','Well, I\'m sorry to hear that. I\'ll be by again later if you want a hand.','',26124),
(15616,'enUS','Well, Bessy will enjoy this little snack.','',26124),
(15617,'enUS','Here, Bessy, enjoy this apple while I get you ready. ','',26124),
(15618,'enUS','%s feeds Bessy the bright red apple.','',26124),
(15619,'enUS','Now, now, Blanchy. Don\'t be jealous, you\'ll be going on a big adventure of your own, soon.','',26124),
(15620,'enUS','Whoa, there, Blanchy, you can\'t be having any apples today. Tomorrow, we\'ll be taking you down to Southshore, where you\'ll take a boat way across the seas.','',26124),
(15621,'enUS','Aww, Blanchy, don\'t worry, my brother in Westfall will take good care of you. I hear he\'s got a beautiful farm with lots of space for you to roam.','',26124),
(15622,'enUS','Young Blanchy stomps her foot jealously.','',26124),
(15623,'enUS','Alright Bessy, let\'s get \'cha out for a walk here. Hut, hut!','',26124),
(15624,'enUS','Good girl, Bessy!','',26124),
(15625,'enUS','Any luck, Samuel?','',26124),
(15626,'enUS','Bessy whinneys happily.','',26124),
(15627,'enUS','Sure, go ahead and take one, there\'s plenty for all!','',26124),
(15628,'enUS','%s grumbles to himself while he works.','',26124),
(15629,'enUS','Aye, its still broken. Can\'t afford to buy a new one though.','',26124),
(15630,'enUS','Nay, its still broken. No luck at all, I suppose.','',26124),
(15631,'enUS','','%s shakes her head at all of the commotion.',26124),
(15632,'enUS','I\'ll keep you safe, mommy!','',26124),
(15633,'enUS','When is daddy coming back, mom?','',26124),
(15634,'enUS','','Don\'t go too far away Seth.  You know mommy doesn\'t like it when she can\'t hear you.',26124),
(15635,'enUS','Coming, momma!','',26124),
(15636,'enUS','','I... I can see...',26124),
(15637,'enUS','','I thought I\'d never see my son\'s face again.  Come here, Seth!  Let mom take a look at you!',26124),
(15638,'enUS','Don\'t cry mommy.  I\'m right here, see?','',26124),
(15639,'enUS','','Drink this, Zahlia.  It is not as potent as I\'d hoped, but perhaps it will help.',26124),
(15640,'enUS','You are going the wrong way, $n. My elekk will not go into hostile territory.','',26124),
(15641,'enUS','','Welcome, $n.  We are the Aldor, priests of the Light and servants of the Sha\'tar.$B$BYou are welcome to stay with us for as long as you need.',26124),
(15642,'enUS','Who are the Sha\'tar?','Who are the Sha\'tar?',26124),
(15643,'enUS','','\"Born from light\" would be a close translation for Sha\'tar.  It is the name we gave to the naaru who reclaimed Shattrath City from the agents of Illidan.',26124),
(15644,'enUS','Isn\'t Shattrath a draenei city?  Why do you allow others here?','Isn\'t Shattrath a draenei city?  Why do you allow others here?',26124),
(15645,'enUS','','Shattrath is more than a staging ground for war against the Burning Legion and Illidan.  It serves as a sanctuary to those seeking to escape the violence surrounding us.$B$BWe would be hypocrites if we turned the refugees away.$B$BIf your question refers to the Scryers, then I will respond that while I may not like them or their leader\'s wild claims of visions of redemption, it is not for us to question the wisdom of the naaru.$B$BThese are difficult times, $n.  We need allies where we can find them.',26124),
(15646,'enUS','Back in my day, we fought demons! Real ones!','',26124),
(15647,'enUS','Fine fishing weather!','',26124),
(15648,'enUS','Couldn\'t ask for a nicer day!','',26124),
(15649,'enUS','Nothing like a good evening to fish!','',26124),
(15650,'enUS','Indeed! Nothing like the warm air and a cool pond...','',26124),
(15651,'enUS','I just wish the fish would bite more than the bugs...','',26124),
(15652,'enUS','Aye, if only every day was just like today....','',26124),
(15653,'enUS','Hush up, your yapping will scare the fish away!','',26124),
(15654,'enUS','Bah, real fishermen take on the fiercest rains!','',26124),
(15655,'enUS','What did you say?','',26124),
(15656,'enUS','Think we\'ll see ol\' sooty today?','',26124),
(15657,'enUS','I bet I\'ll catch a big one this time...','',26124),
(15658,'enUS','I better not pull up another of Reggy\'s boots again...','',26124),
(15659,'enUS','Maybe...','',26124),
(15660,'enUS','Anything could happen...','',26124),
(15661,'enUS','Hahah, don\'t get your hope up too high...','',26124),
(15662,'enUS','Got one!','',26124),
(15663,'enUS','You guys have any extra bait?','',26124),
(15664,'enUS','Remember that time we caught the red-finned murloc down in Elwynn?','',26124),
(15665,'enUS','Thank the light that Bertha\'s not here...','',26124),
(15666,'enUS','Nothing like a warm day and no ol\' lady to yell at ya...','',26124),
(15667,'enUS','Nothing like peace an quiet... unlike home!','',26124),
(15668,'enUS','I hear you! I can\'t get a moments peace without Sarah complaining about the chores!','',26124),
(15669,'enUS','Aye, an no squealing youngster to upset the peace of a man and his fish...','',26124),
(15670,'enUS','So you say now, but at least you\'ve got a warm dinner waiting for ya...','',26124),
(15671,'enUS','Could be worse, your wife coulda ran off to Stormwind with some cheese merchant!','',26124),
(15672,'enUS','Better not say that too loudly!','',26124),
(15673,'enUS','','My brothers and sisters. Listen to me. We must speak of the survival of our people. We have narrowly survived one calamity, but I fear the next shall destroy us.',26124),
(15674,'enUS','','Can you not see what is happening? Open your eyes. It is laid bare for all to see. What is this new alliance? Why have we betrayed our allies of old, only to take up with the enemies of all that live?',26124),
(15675,'enUS','No, you\'re wrong! We were the ones betrayed!','',26124),
(15676,'enUS','When have the dwarves ever been our friends?','',26124),
(15677,'enUS','','The humans abandoned us in our darkest hour! Their prince himself led the assault on our lands.',26124),
(15678,'enUS','You fool! The prince\'s minions were the very Forsaken we have now allied ourselves with, and now he has betrayed us!','',26124),
(15679,'enUS','The Ranger-General of Silvermoon will be a loyal ally!','',26124),
(15680,'enUS','','You speak of her as friend? You are a fool. This \"Dark Lady\" is not Sylvanas.',26124),
(15681,'enUS','Now, let\'s see what we can find out...','',26124),
(15682,'enUS','I see... something. It\'s very faint, though.','',26124),
(15683,'enUS','Deirom is alive! I can make out an arakkoa pacing back and forth in front of him, asking him the same questions over and over. There is another, too, an orc...','',26124),
(15684,'enUS','They\'ve got him in one of their tree-settlements. Veil... Veil Shalas! Thander must know about this immediately! Go speak with him.','',26124),
(15685,'enUS','Welcome to the Allerian Stronghold, $c.','',26124),
(15686,'enUS','Now, let\'s see what we can find out...','',26124),
(15687,'enUS','Dugar is alive! I can make out an arakkoa pacing back and forth in front of him, asking him the same questions over and over. There is another, too, a human...','',26124),
(15688,'enUS','They\'ve got him in one of their tree-settlements. Veil... Veil Shalas! Rokag must know about this immediately! Go speak with him.','',26124),
(15689,'enUS','Be wary, $c. The forest is full of hidden dangers and potential enemies.','',26124),
(15690,'enUS','Southshore is such a peaceful town.... I\'d like to live here someday.','',26124),
(15691,'enUS','The bog lords are attacking!  Help us!','',26124),
(15692,'enUS','Somebody help!  Our young are in peril!','',26124),
(15693,'enUS','Get ready! The brawl is about to begin!\n','Get ready! The brawl is about to begin!\n',26124),
(15694,'enUS','Wow, what a fight!','Wow, what a fight!',26124),
(15695,'enUS','Off with his head!','Off with his head!',26124),
(15696,'enUS','I want blood!','I want blood!',26124),
(15697,'enUS','Yes, yes! I want more!','Yes, yes! I want more!',26124),
(15698,'enUS','Finish it, but not too quickly! I want to see a slow death!','Finish it, but not too quickly! I want to see a slow death!',26124),
(15699,'enUS','[PH] I have a dream... a dream of a day when horses run faster, men grow stronger and time itself stands still.','',26124),
(15700,'enUS','[PH] If only there was a leather soft enough to appeal to Marshal Zyx.','',26124),
(15701,'enUS','I remember everything...','I remember everything...',26124),
(15702,'enUS','This is just horrible.$B$BI care not for our own discomforts here, but we must do something to ease the pain of the dead in the Bone Wastes!','',26124),
(15703,'enUS','What is happening to me?','What is happening to me?',26124),
(15704,'enUS','The spirits call... I am consumed.','The spirits call... I am consumed.',26124),
(15705,'enUS','The pain is unbearable.','The pain is unbearable.',26124),
(15706,'enUS','Cease your crying! STOP!','Cease your crying! STOP!',26124),
(15707,'enUS','It is dying. It is dying. It is dying.','It is dying. It is dying. It is dying.',26124),
(15708,'enUS','','Come on. This way.',26124),
(15709,'enUS','What will become of us when it falls?','What will become of us when it falls?',26124),
(15710,'enUS','Cannot control... It draws me in... The void grows...','Cannot control... It draws me in... The void grows...',26124),
(15711,'enUS','','I am grateful for your assistance and sacrifice in this matter, $n.',26124),
(15712,'enUS','','I am forever indebted to you for putting to rest the spirits of my ancestors.',26124),
(15713,'enUS','Anchorite, I need another Extract of the Afterlife.','Anchorite, I need another Extract of the Afterlife.',26124),
(15714,'enUS','If you\'re expecting some kind of official welcome, you\'re going to be disappointed, $c. We don\'t stand on tradition, here. What works is what goes.','',26124),
(15715,'enUS','One note stands out from the other various pieces of parchment that are tacked onto this wanted poster.  It\'s a call to slay the bonelashers of the Bone Wastes.','',26124),
(15716,'enUS','This wanted poster is adorned with an assortment of notices and rewards for all manner of dangerous activities.  However, you see nothing in particular that you feel you\'re cut out for yet.$B$BPerhaps you should check again at a later time?','',26124),
(15717,'enUS','','No, don\'t feel bad.  I get that a lot.$B$B<Taela looks both amused and annoyed.>$B$BI\'m a HIGH elf, not a blood elf.  Don\'t worry, I\'m not going to suck all of the magic out of you.',26124),
(15718,'enUS','Bonelashers, I hate them all!$B$BIf it weren\'t for the loss of my eye, and the fainting spells that I get sometimes, I\'d be out there shooting them down all the time!','',26124),
(15719,'enUS','%s faints.','',26124),
(15720,'enUS','I\'ve been watching the Aldor working on the walls. They\'re gonna rebuild the whole city, you know.$B$BThey work much faster than old Foreman Oslow did back home in Lakeshire. He kept losing his tools in the lake, or the gnolls would take his supplies.$B$BI should ask the Aldor to send him some help. They\'d have that bridge fixed faster\'n anything.','',26124),
(15721,'enUS','','There\'s a whole vast forest out there, $c. Let the shaman play with the spirits and the warriors toy with their swords. Terokkar is where I\'ll make my fortune.',26124),
(15722,'enUS','Malukaz chatters incessantly about the historical importance of this forest, but I don\'t have the luxury of indulging in history until our present problems are settled.$B$BI\'m not saying his work here isn\'t important, but someone has to see to the defenses and logistics of running the hold.','',26124),
(15723,'enUS','Until I traveled through Nagrand and came to the forest, I feared that too much of our original culture was lost. I\'m thankful to see that I was wrong.$B$BThere is so much to be done here!','',26124),
(15724,'enUS','','The opening of the Dark Portal brought news of my people\'s fate. In a way, my exile shielded me from sharing in their downfall, but to see the Farstriders throw their lot in with Kael\'thas...$B$BI never imagined my one-time brethren capable of such a thing.$B$BThe homecoming I once dreamt of will never happen. This forest is the only home I have left.',26124),
(15725,'enUS','','When I first arrived, I\'d hoped to meet the town\'s namesake.$B$B<Ros\'eleth glances around.>$B$BMost young high elves outgrow the \'I wanna be a Farstrider\' phase by the time they come of age for their first apprenticeship. Then, it\'s onto the \'I\'m going to be a magister\' stage.$B$BNo one dreams of growing up to be a seamstress, but we can\'t have the Farstriders going around naked, as my mother used to say.',26124),
(15726,'enUS','','When I first arrived, I\'d hoped to meet the town\'s namesake.$B$B<Ros\'eleth glances around.>$B$BMost young high elves outgrow the \'I wanna be a Farstrider\' phase by the time they\'re taken as apprentices. Then, it\'s onto the \'I\'m going to be a magister\' stage.$B$BI don\'t think I ever quite outgrew the Farstrider phase, to be honest. No one dreams of growing up to be a seamstress, but we can\'t have the Farstriders running around naked, as my mother used to say.',26124),
(15727,'enUS','Have you seen the way Ros\'eleth winks at me whenever I go to pick up a garment or hat? When things settle down around here, I\'m going to take her for a nice walk in the woods.$B$BFor once, I miss all those fancy taverns in Stormwind.','',26124),
(15728,'enUS','<Kaide hisses at you.>$B$BBe quiet, or you\'ll bring the orcs and the Alliance down on us, you clumsy oaf!$B$BThat\'s right, nod your head, and when we\'re done speaking, you\'ll walk away and forget you found me here.','',26124),
(15729,'enUS','We may be working together, but that only increases the need for discretion. Once again, be mindful of your words and actions.$B$BI can guarantee we\'re far from the only ones out here.','',26124),
(15730,'enUS','%s glances around somewhat nervously.','',26124),
(15731,'enUS','Good day, Ros\'eleth. Is my, err, um... uh, my \'headgear\' finished?','',26124),
(15732,'enUS','','Why, yes, Bertelm, I\'ve finished your hat. I used the largest, puffiest, most magnificent feather I could find. Perhaps you\'d like me to measure you for a new pair of hose while you\'re -',26124),
(15733,'enUS','%s begins to turn red.','',26124),
(15734,'enUS','Uh, no... no, that won\'t be necessary. I\'ll, uh, send a soldier by to collect the, uh, headgear later on. I really must be going now...','',26124),
(15735,'enUS','','Poor Bertelm...',26124),
(15736,'enUS','','Poor Bertelm...',26124),
(15737,'enUS','You there, fetch water quickly! Get these flames out before they spread to the rest of the keep! Hurry, damn you!','',26124),
(15738,'enUS','Blood will be true. We can trust in none but our own!','',26124),
(15739,'enUS','Fifteen seconds until the Arena battle begins!','',26124),
(15740,'enUS','One minute until the Arena battle begins!','',26124),
(15741,'enUS','Thirty seconds until the Arena battle begins!','',26124),
(15742,'enUS','The Arena battle has begun!','',26124),
(15743,'enUS','','Blood? And these orcs, these fair weather friends? They will aid us?',26124),
(15744,'enUS','A great blight lies across our land! It grows every day. Our need for magic weakens us, and will bring us to destruction, just as it has before!','',26124),
(15745,'enUS','How are we to live without magic?','',26124),
(15747,'enUS','','Look at the wonders of this city! This is magic.',26124),
(15748,'enUS','But at what cost? You\'ve all been blinded. We have all been blinded. ','',26124),
(15749,'enUS','You call us traitors?','',26124),
(15750,'enUS','','The magisters are the traitors! They have sealed our doom.',26124),
(15751,'enUS','Idealistic blather. Go back to your forests!','',26124),
(15752,'enUS','','You would have us live like the savages!',26124),
(15753,'enUS','No, not savagery! Conscience. The excesses of our people will destroy us, and all that we have struggled to build.','',26124),
(15754,'enUS','','We have not struggled so hard to survive, only to bring about the true destruction.',26124),
(15755,'enUS','Yeah, what do you want?  Can\'t you see I\'m busy here?  The Shadow Council isn\'t paying me by the hour!','Yeah, what do you want?  Can\'t you see I\'m busy here?  The Shadow Council isn\'t paying me by the hour!',26124),
(15756,'enUS','We stand on the brink of destruction. We must reconsider this rash course of action.','',26124),
(15757,'enUS','Why are you fixing all of this up?','Why are you fixing all of this up?',26124),
(15758,'enUS','What\'s it look like I\'m doing?  I\'m fixing the place up - all on my own I might add - so that we can move in!$B$BWith a base of operations out here in the forest, it\'ll be easier to keep track of what Shattrath, Allerian, Stonebreaker and the Cenarion druids are all up to.  Our base in Auchindoun is just too inconvenient for that.$B$BWait a minute, do I know you?','What\'s it look like I\'m doing?  I\'m fixing the place up - all on my own I might add - so that we can move in!$B$BWith a base of operations out here in the forest, it\'ll be easier to keep track of what Shattrath, Allerian, Stonebreaker and the Cenarion druids are all up to.  Our base in Auchindoun is just too inconvenient for that.$B$BWait a minute, do I know you?',26124),
(15759,'enUS','What\'s it look like I\'m doing?  I\'m fixing the place up - all on my own I might add - so that we can move in!$B$BDo I know you?','What\'s it look like I\'m doing?  I\'m fixing the place up - all on my own I might add - so that we can move in!$B$BDo I know you?',26124),
(15760,'enUS','Do I know you?  Look, I don\'t want any trouble.  I just fix things around here.','Do I know you?  Look, I don\'t want any trouble.  I just fix things around here.',26124),
(15761,'enUS','What?  Who are you?$B$B<The initiate holds his hands up.>$B$BLook, how about I just go back to my practice and you ignore me?','What?  Who are you?$B$B<The initiate holds her hands up.>$B$BLook, how about I just go back to my practice and you ignore me?',26124),
(15762,'enUS','Yes?  Darn it all, now I\'ll have to start over from scratch!','Yes?  Darn it all, now I\'ll have to start over from scratch!',26124),
(15763,'enUS','What are you doing there?','What are you doing there?',26124),
(15764,'enUS','Practicing!  Soon I\'ll be good enough to join the other summoners and take my turn inside the Shadow Labyrinth at Auchindoun.$B$BI hope that I\'ll get the chance to summon something big!  Maybe something as big as Murmur, though I wouldn\'t lose control of him!','Practicing!  Soon I\'ll be good enough to join the other summoners and take my turn inside the Shadow Labyrinth at Auchindoun.$B$BI hope that I\'ll get the chance to summon something big!  Maybe something as big as Murmur, though I wouldn\'t lose control of him!',26124),
(15765,'enUS','You\'re not one of us!  Guards!$B$BOh please, don\'t hurt me!  Not the face!  Not the face!','You\'re not one of us!  Guards!$B$BOh please, don\'t hurt me!  Not the face!  Not the face!',26124),
(15766,'enUS','And what is it exactly that you think I can do for you?  Can\'t you see that I\'m very busy here discussing matters of import with our illustrious leader?$B$BBe quick about your business or I\'ll have you beaten, dog!','And what is it exactly that you think I can do for you?  Can\'t you see that I\'m very busy here discussing matters of import with our illustrious leader?$B$BBe quick about your business or I\'ll have you beaten, dog!',26124),
(15767,'enUS','Advisor, what\'s the latest news?','Advisor, what\'s the latest news?',26124),
(15768,'enUS','Well, I was just giving our leader here a progress report on how everything is proceeding according to plan.  It should only be a few more weeks and we\'ll have this place back in shape.$B$BWe may want the Shadow Council to only staff the village with orcs, however.  That way we can make an ancestral claim and work undercover.$B$BWait a minute.  Do I know you?  What\'s your name?','Well, I was just giving our leader here a progress report on how everything is proceeding according to plan.  It should only be a few more weeks and we\'ll have this place back in shape.$B$BWe may want the Shadow Council to only staff the village with orcs, however.  That way we can make an ancestral claim and work undercover.$B$BWait a minute.  Do I know you?  What\'s your name?',26124),
(15769,'enUS','','Hello, young $r.',26124),
(15770,'enUS','Hello, Greatmother. Garrosh told me that you wanted to speak with me.','Hello, Greatmother. Garrosh told me that you wanted to speak with me.',26124),
(15771,'enUS','','Hello, dear. I am Geyah, matron of the Mag\'har.$B$B<Greatmother Geyah coughs.>$B$BIf you are here, it would be safe to assume that the portal has opened. Most of the orcs here were too young or too sick to remember the Dark Portal.$B$B<Greatmother Geyah points to the orcs around her.>$B$BMany of them were orphans or would soon become orphans. Aye, Blackhand would have it no other way. Keep the sick from the healthy. Only the strong would survive... Or so they say.',26124),
(15772,'enUS','You raised all of the orcs here, Greatmother?','You raised all of the orcs here, Greatmother?',26124),
(15773,'enUS','','They have grown up here. We kept them safe from harm. We did the best that we could in nursing them back to health. Many perished but many, many more grew strong. Like Garrosh...$B$B<Greatmother Geyah sighs.>$B$BHe has lost his heart, you know. He tells me that I am his balance. That without me, the blood lust that consumed his father and ultimately cursed our people would take him over.',26124),
(15774,'enUS','Do you believe that?','Do you believe that?',26124),
(15775,'enUS','','<Greatmother Geyah laughs weakly.>$B$BOf course not, dear. But it\'s not me that has to believe...$B$BGarrosh can lead the Mag\'har. He is strong and wise. All of the spirits approve of him. He just needs to believe in himself. He fears so much... He fears so deeply that if he lets himself go, his rage will consume him and all that would be near him.',26124),
(15776,'enUS','What can be done? I have tried many different things. I have done my best to help the people of Nagrand. Each time I have approached Garrosh, he has dismissed me.','What can be done? I have tried many different things. I have done my best to help the people of Nagrand. Each time I have approached Garrosh, he has dismissed me.',26124),
(15777,'enUS','','I wish I knew, dear. He will not listen to you nor will he listen to me. In truth, it is why I am still here. It is why I have not left with Mother Kashur. He must find his heart. Our people will not survive through the winter without leadership.',26124),
(15778,'enUS','Left? How can you choose to leave?','Left? How can you choose to leave?',26124),
(15779,'enUS','','<Greatmother Geyah smiles.>$B$BI am old. It is my time. When I pass, my spirit will move on to the spirit realm. It is there that I will stand with my ancestors. It is there that we will watch over our people.$B$BWhen Garad was alive Mother Kashur\'s duty was the same as my duty now.',26124),
(15780,'enUS','What is this duty?','What is this duty?',26124),
(15781,'enUS','','The duty of a clan mother is to listen. To listen to the wind and the water and the fire and the earth. To gather information for her clan in the way others gather furs to stay warm. It is the spirits that I commune with... In my dreams, Mother Kashur speaks to me like the spirits that spoke to her once... When I pass, I will speak to Drakia and Celestine in this manner.$B$B<Greatmother Geyah smiles.>',26124),
(15782,'enUS','Is there anything I can do for you, Greatmother?','Is there anything I can do for you, Greatmother?',26124),
(15783,'enUS','Time is precious, never waste it.','',26124),
(15784,'enUS','I need a pack of incendiary bombs.','I need a pack of incendiary bombs.',26124),
(15785,'enUS','Here are more of the incendiary devices, $n. Be careful with these, they can cause a great deal of disruption to time if used improperly.','',26124),
(15786,'enUS','You!  You don\'t belong here!','',26124),
(15787,'enUS','I\'m going to figure out what this shadowy group is up to no matter what!','',26124),
(15788,'enUS','Private Weeks, I need another disguise.','Private Weeks, I need another disguise.',26124),
(15789,'enUS','$n, thank you for dealing with the mystery of the Shadow Council at Grangol\'var Village.','',26124),
(15790,'enUS','','Again, I thank you, $n.  Without your aid we would never have been able to deal with the Shadow Council here at Grangol\'var Village.',26124),
(15791,'enUS','','We need to figure out what this shadowy group is doing here at Grangol\'var Village!',26124),
(15792,'enUS','Scout Neftis, I need another disguise.','Scout Neftis, I need another disguise.',26124),
(15793,'enUS','We\'ve a duty out here, $g boy : girl;, to see to it that we don\'t let anyone surprise us.$B$BThat means proactive action!','',26124),
(15794,'enUS','','I must have made a misstep somewhere to be assigned here.',26124),
(15795,'enUS','Did you hear that they lost total control of Murmur in the Shadow Labyrinth?!','Did you hear that they lost total control of Murmur in the Shadow Labyrinth?!',26124),
(15796,'enUS','They don\'t pay us enough for this.  But this ruined village sure beats skulking around inside of Auchindoun.','They don\'t pay us enough for this.  But this ruined village sure beats skulking around inside of Auchindoun.',26124),
(15797,'enUS','I joined up because they said they\'d pay my way into the academy.  My uncle says that I can go next season!','I joined up because they said they\'d pay my way into the academy.  My uncle says that I can go next season!',26124),
(15798,'enUS','Hey there, you must be the new recruit!  Good to meet you!$B$BAny word from the Shadow Labyrinth in Auchindoun on whether we\'ve regained control of Murmur yet?','Hey there, you must be the new recruit!  Good to meet you!$B$BAny word from the Shadow Labyrinth in Auchindoun on whether we\'ve regained control of Murmur yet?',26124),
(15799,'enUS','If you\'re interested, a couple of us are going into Shattrath for drinks later.','If you\'re interested, a couple of us are going into Shattrath for drinks later.',26124),
(15800,'enUS','Interested in joining up for the leather ball league?  We play Monday through Wednesday, mostly. $B$BYou\'re welcome to join us after this shift.  We\'re going to toss it around.','Interested in joining up for the leather ball league?  We play Monday through Wednesday, mostly. $B$BYou\'re welcome to join us after this shift.  We\'re going to toss it around.',26124),
(15801,'enUS','I hope this place pans out as a forward base for Shadow Council operations.  I know it sounds weird, but I kind of miss the Shadow Labyrinth.','I hope this place pans out as a forward base for Shadow Council operations.  I know it sounds weird, but I kind of miss the Shadow Labyrinth.',26124),
(15802,'enUS','<He leans in closer.>$B$BJust between you and me, I\'m thinking about \'mustering\' out one of these nights.  You know what I mean?','<She leans in closer.>$B$BJust between you and me, I\'m thinking about \'mustering\' out one of these nights.  You know what I mean?',26124),
(15803,'enUS','Who do you think you are that you can walk in here and address me?  I\'m the leader of the Shadow Council in this village.  Get out of my sight!$B$BIf I see you again, I\'ll be the last person that you ever see.  Understand?$B$BPerhaps you\'d like to be buried in the labyrinth of Auchindoun, or sacrificed to Murmur?','',26124),
(15804,'enUS','How could you do this?  I confided in you!','How could you do this?  I confided in you!',26124),
(15805,'enUS','You\'re off the leather ball team!','You\'re off the leather ball team!',26124),
(15806,'enUS','You can forget about those drinks later!','You can forget about those drinks later!',26124),
(15807,'enUS','Special lunch?  How about a special death!','Special lunch?  How about a special death!',26124),
(15808,'enUS','Um, yeah... get \'em!','Um, yeah... get \'em!',26124),
(15809,'enUS','I thought we were going to be best friends!','I thought we were going to be best friends!',26124),
(15810,'enUS','What?  Isn\'t that the new guy?','What?  Isn\'t that the new guy?',26124),
(15811,'enUS','Darn, and I kind of liked you.','Darn, and I kind of liked you.',26124),
(15812,'enUS','','I hear Bertelm\'s been collecting fur for his latest creation. He told you it\'s going to be a cloak, right?$B$BIt isn\'t. That\'s just the cover he\'s using to keep his wolf fur hatband a secret. He wouldn\'t put all that work into collecting the fur just to soil it in battle!',26124),
(15813,'enUS','You will find our alchemist trainers in the Vault of Lights. Go with the Light.','You will find our alchemist trainers in the Vault of Lights. Go with the Light.',26124),
(15814,'enUS','Though the acquisition of wealth is no longer a driving force in our lives, we understand that money makes the world go \'round. You will find our auction house in the Seat of the Naaru.','Though the acquisition of wealth is no longer a driving force in our lives, we understand that money makes the world go \'round. You will find our auction house in the Seat of the Naaru.',26124),
(15815,'enUS','You will find our bank in the Exodar\'s central hub.  Go with the Light.','You will find our bank in the Exodar\'s central hub.  Go with the Light.',26124),
(15816,'enUS','Stephanos is our Hippogryph master.  He resides in the Exodar\'s central hub.  May the Light bless you on your travels.','Stephanos is our Hippogryph master.  He resides in the Exodar\'s central hub.  May the Light bless you on your travels.',26124),
(15817,'enUS','You will find our battlemasters in the Vault of the Lights.  There is also one \"Miglik Blotstrom\" staying with Caregiver Breel, who claims to represent an arena fighting circuit on this world.','You will find our battlemasters in the Vault of the Lights.  There is also one \"Miglik Blotstrom\" staying with Caregiver Breel, who claims to represent an arena fighting circuit on this world.',26124),
(15818,'enUS','Miall is our chief blacksmith on the Exodar. She can be found on the lower level of the Trader\'s Tier.  Go with the Light.','Miall is our chief blacksmith on the Exodar. She can be found on the lower level of the Trader\'s Tier.  Go with the Light.',26124),
(15819,'enUS','What trainer do you seek?','What trainer do you seek?',26124),
(15820,'enUS','Druid?  Ah... Shalannius, you seek Shalannius.  You shall find this night elf outside of the Exodar, near Valaar\'s Berth.','Druid?  Ah... Shalannius, you seek Shalannius.  You shall find this night elf outside of the Exodar, near Valaar\'s Berth.',26124),
(15821,'enUS','Our enchanters are located in the Crystal Hall opposite the jewel crafters.  Light be with you.','Our enchanters are located in the Crystal Hall opposite the jewel crafters.  Light be with you.',26124),
(15822,'enUS','So, you are willing to help repair the mighty Exodar?  I heard it will take years before the Exodar is fully functional once more.  You have two hours.  Just kidding.  Our engineers are located on the lower levels of the Trader\'s Tier.  Go with the Light.','So, you are willing to help repair the mighty Exodar?  I heard it will take years before the Exodar is fully functional once more.  You have two hours.  Just kidding.  Our engineers are located on the lower levels of the Trader\'s Tier.  Go with the Light.',26124),
(15823,'enUS','By the Light! It is a blessing to have one who cares about the well-being of others. At a time like this we need all the help we can get. Nus can train you in the ways of first aid. She is near the crystal cave in the Crystal Hall. Light be with you.','By the Light! It is a blessing to have one who cares about the well-being of others. At a time like this we need all the help we can get. Nus can train you in the ways of first aid. She is near the crystal cave in the Crystal Hall. Light be with you.',26124),
(15824,'enUS','Stop!','Stop!',26124),
(15825,'enUS','Will you stop--','Will you stop--',26124),
(15826,'enUS','You can find Erett the fishing trainer in the Crystal Hall near the Light Blessed Waters.','You can find Erett the fishing trainer in the Crystal Hall near the Light Blessed Waters.',26124),
(15827,'enUS','Rifling through the stacks of books and scrolls on the table, %s begins to examine one in particular with interest.','',26124),
(15828,'enUS','You will find Funaam, the guild master, near the Trader\'s Tier entrance.','You will find Funaam, the guild master, near the Trader\'s Tier entrance.',26124),
(15829,'enUS','What?  What\'s this?!','',26124),
(15830,'enUS','That is not even remotely imaginable!','',26124),
(15831,'enUS','Looks like I picked a bad day to stop drinking.','',26124),
(15832,'enUS','How did this get missed?!','',26124),
(15833,'enUS','Cap\'n, sir, we have a slight problem.','',26124),
(15834,'enUS','At ease, lieutenant.  Go on.','',26124),
(15835,'enUS','What is it now, Gravel?','',26124),
(15836,'enUS','What else could possibly go wrong?','',26124),
(15837,'enUS','Yes, lieutenant?  Report.','',26124),
(15838,'enUS','As you say, sir.  It would appear that someone failed to mention to me that the druids at the Cenarion Thicket have been wiped out!','',26124),
(15839,'enUS','Bad news.  We\'ve been hit again.  They\'re gone, but the front sentry tower is on fire.','',26124),
(15840,'enUS','One of our merchants has gone missing!','',26124),
(15841,'enUS','You will find our herbalist, Cemmorhan, against the back wall of the Vault of Lights.','You will find our herbalist, Cemmorhan, against the back wall of the Vault of Lights.',26124),
(15842,'enUS','That group that recently arrived from Honor Hold -- they\'re mercs!  They\'re starting to stir up trouble.  Maybe I should have a talk with them?','',26124),
(15843,'enUS','One of our scouts is reporting that a shadowy group has moved into the ruins of Grangol\'var Village.  Oops, this report is over a week old.','',26124),
(15844,'enUS','We have reports from a scout in the field that one of the Cenarion druids has been taken captive up at Firewing Point.','',26124),
(15845,'enUS','You seek the hunters?  You will find them on the second level of the Trader\'s Tier, in the Hunters\' Sanctum.','You seek the hunters?  You will find them on the second level of the Trader\'s Tier, in the Hunters\' Sanctum.',26124),
(15846,'enUS','Our Caregiver Center is located above the central Vault of Light, near the Exodar\'s main entrance.','Our Caregiver Center is located above the central Vault of Light, near the Exodar\'s main entrance.',26124),
(15847,'enUS','Have you honed your skills enough to learn what I have to teach?','Have you honed your skills enough to learn what I have to teach?',26124),
(15848,'enUS','Farii trains those interested in jewel crafting. You can find her in the Crystal Hall near the cavern there.','Farii trains those interested in jewel crafting. You can find her in the Crystal Hall near the cavern there.',26124),
(15849,'enUS','That\'s troubling news indeed.  See to it that it\'s taken care of immediately!','',26124),
(15850,'enUS','I don\'t have time for this, lieutenant.  Make sure that you handle it.','',26124),
(15851,'enUS','If we\'re to help with that in any way we\'ll need more people.  Call some of the scouts in to help with that.','',26124),
(15852,'enUS','Lieutenant, I want you to make that your top priority.  Notify anyone that you think can help.','',26124),
(15853,'enUS','Aye, aye, sir.  Right away!','',26124),
(15854,'enUS','You will find the Exodar\'s leatherworkers in the Trader\'s Tier.  May the Light bless you.','You will find the Exodar\'s leatherworkers in the Trader\'s Tier.  May the Light bless you.',26124),
(15855,'enUS','You will find our mages in the Vault of Lights.  Go with the Light.','You will find our mages in the Vault of Lights.  Go with the Light.',26124),
(15856,'enUS','Blessings of the Naaru. What can I help you find?','Blessings of the Naaru. What can I help you find?',26124),
(15857,'enUS','You will find our mining trainers towards the back of the Trader\'s Tier.','You will find our mining trainers towards the back of the Trader\'s Tier.',26124),
(15858,'enUS','The Exodar\'s paladin trainers are found in the luminous Chapel of Light in the Seat of the Naaru.','The Exodar\'s paladin trainers are found in the luminous Chapel of Light in the Seat of the Naaru.',26124),
(15859,'enUS','Our priest trainers can be found within the Order of Light\'s chamber, at the entrance to the Seat of the Naaru. Light be with you.','Our priest trainers can be found within the Order of Light\'s chamber, at the entrance to the Seat of the Naaru. Light be with you.',26124),
(15860,'enUS','Which profession trainer are you looking for?','Which profession trainer are you looking for?',26124),
(15861,'enUS','You will find a number of shaman trainers in the Crystal Hall. Perhaps you should visit Farseer Nobundo there, and show the Broken some pity. Light be with you.','You will find a number of shaman trainers in the Crystal Hall. Perhaps you should visit Farseer Nobundo there, and show the Broken some pity. Light be with you.',26124),
(15862,'enUS','You will find the Exodar\'s skinning trainers in the Trader\'s Tier with the leatherworkers.  May the Light bless you.','You will find the Exodar\'s skinning trainers in the Trader\'s Tier with the leatherworkers.  May the Light bless you.',26124),
(15863,'enUS','You can find Arthaid, our stable master, outside of the Caregiver Center. He is located on the upper level of the central hub, near the Exodar\'s main entrance.','You can find Arthaid, our stable master, outside of the Caregiver Center. He is located on the upper level of the central hub, near the Exodar\'s main entrance.',26124),
(15864,'enUS','Long ago, we wore one piece jumpsuits. Thanks to our innovative tailors, we no longer wear such impractical outfits. You can find these fashion lifesavers in the Trader\'s Tier.','Long ago, we wore one piece jumpsuits. Thanks to our innovative tailors, we no longer wear such impractical outfits. You can find these fashion lifesavers in the Trader\'s Tier.',26124),
(15865,'enUS','The information on this wanted poster indicates that you don\'t yet qualify for the task at hand.$B$BYou should definitely check back later, though.','',26124),
(15866,'enUS','Interesting.  The wanted poster calls for the extermination of the local moth population.  Something about royal teromoths.','',26124),
(15867,'enUS','Looking to be a great warrior?  War does not make one great.  Still, you will find our great warrior trainers on the Warriors\' Terrace, overlooking the rest of the Trader\'s Tier.','Looking to be a great warrior?  War does not make one great.  Still, you will find our great warrior trainers on the Warriors\' Terrace, overlooking the rest of the Trader\'s Tier.',26124),
(15868,'enUS','Welcome to the Royal Exchange Bank, $g sir : ma\'am;. How may I help you?','Welcome to the Royal Exchange Bank, $g sir : ma\'am;. How may I help you?',26124),
(15869,'enUS','Thank you for choosing the Bank of Silvermoon. What may I do for you today?','Thank you for choosing the Bank of Silvermoon. What may I do for you today?',26124),
(15870,'enUS','You wish to improve your weapon skills?  Our weapon master is located on the highest level of the Trader\'s Tier, on the Warriors\' Terrace.','You wish to improve your weapon skills?  Our weapon master is located on the highest level of the Trader\'s Tier, on the Warriors\' Terrace.',26124),
(15871,'enUS','Yes, $t citizen : citizen;, what matter of import do you have to bring to my attention?','',26124),
(15872,'enUS','Greetings. How may we of the Royal Exchange Bank assist you today?','Greetings. How may we of the Royal Exchange Bank assist you today?',26124),
(15873,'enUS','Welcome to the Bank of Silvermoon, $g sir : ma\'am;. Would you care to access the depository?','Welcome to the Bank of Silvermoon, $g sir : ma\'am;. Would you care to access the depository?',26124),
(15874,'enUS','The Exodar\'s vaults are vast and well-protected. Your goods will come to no harm here.','The Exodar\'s vaults are vast and well-protected. Your goods will come to no harm here.',26124),
(15875,'enUS','We control access to the Exodar\'s storage facilities. Are there goods you wish to store or remove?','We control access to the Exodar\'s storage facilities. Are there goods you wish to store or remove?',26124),
(15876,'enUS','','Hi!  Do you think you might help me to get out of here?',26124),
(15877,'enUS','','Hi!  I know that you\'re with the Horde, and I\'m with the Alliance, but do you think we could put that behind us this once?  I\'d really like some help getting out of here.',26124),
(15878,'enUS','','Hello?  Help?',26124),
(15879,'enUS','','<cough> <cough> Damsel in distress over here!',26124),
(15880,'enUS','','When you get a chance do you think you could let me out of here?',26124),
(15881,'enUS','','Don\'t leave me in here!  Cause if you do, I will find you...',26124),
(15882,'enUS','','Ok, let\'s get out of here!',26124),
(15883,'enUS','','You sure you\'re ready?  Take a moment.',26124),
(15884,'enUS','','Alright, let\'s do this!',26124),
(15885,'enUS','','Uh oh, bad elves!',26124),
(15886,'enUS','','Don\'t these guys ever give up?',26124),
(15887,'enUS','','Ok, I think I can make it on my own from here.  Thank you so much for breaking me out of there!',26124),
(15888,'enUS','The high elf spy is escaping.  Get her!','The high elf spy is escaping.  Get her!',26124),
(15889,'enUS','Notices of bounties and job openings are posted here.','',26124),
(15890,'enUS','Do NOT let the spy escape!','Do NOT let the spy escape!',26124),
(15891,'enUS','What\'s the meaning of this? GUARDS!','',26124),
(15892,'enUS','That\'s enough out of him.','',26124),
(15893,'enUS','As long as we\'re going with a new plan, I may as well pick up a weapon and some armor.','',26124),
(15894,'enUS','Let\'s go.','',26124),
(15895,'enUS','Invaders, you dangle upon the precipice of oblivion! The Burning Legion comes and with it comes your end.\n','',26124),
(15896,'enUS','Intrudersss with the prisssoner!  Kill them!!!','',26124),
(15897,'enUS','What?  You already killed him!$B$BI was hoping to study Quagmirran, perhaps interact with him.  But now all that I\'ll be studying is his corpse.$B$B<sigh>$B$BPlease let me out of this cage.  I\'ll take a look at him and then make my own way out of here.','',26124),
(15898,'enUS','The gruesome visage of a leering orc stares back at you from this poster.  His raiments are obviously of a warlock nature.','',26124),
(15899,'enUS','Yes?  What is it?','',26124),
(15900,'enUS','Zzz...','Zzz...',26124),
(15901,'enUS','Zzz... wine... so good... zzz...','Zzz... wine... so good... zzz...',26124),
(15902,'enUS','Zzz... all lies... doomed, all of us... zzz...','Zzz... all lies... doomed, all of us... zzz...',26124),
(15903,'enUS','Zzz... I\'m so... beautiful... zzz...','Zzz... I\'m so... beautiful... zzz...\n',26124),
(15904,'enUS','There is nothing to see here. Move along.','There is nothing to see here. Move along.',26124),
(15905,'enUS','This does not concern you. Be on your way.','This does not concern you. Be on your way.',26124),
(15906,'enUS','Ssslay them!','',26124),
(15907,'enUS','You will all sssuffer!','',26124),
(15908,'enUS','A rider approaches.','',26124),
(15909,'enUS','Thrall! You didn\'t really think you would escape, did you?  You and your allies shall answer to Blackmoore... after I\'ve had my fun.','',26124),
(15910,'enUS','Thank you friends, I owe my freedom to you. Where is Taretha? I hoped to see her one last time and thank her before leaving into the mountains.','',26124),
(15911,'enUS','Taretha cannot see you, Thrall.','Taretha cannot see you, Thrall.',26124),
(15912,'enUS','What do you mean by this? Is Taretha in danger?','',26124),
(15913,'enUS','The situation is rather complicated, Thrall. It would be best for you to head into the mountains now, before more of Blackmoore\'s men show up. We\'ll make sure Taretha is safe.','The situation is rather complicated, Thrall. It would be best for you to head into the mountains now, before more of Blackmoore\'s men show up. We\'ll make sure Taretha is safe.',26124),
(15914,'enUS','I will do no such thing. I simply cannot leave Taretha in danger while I run off into the mountains. I am no coward. Now, where is she?','',26124),
(15915,'enUS','Tarren Mill.','Tarren Mill.',26124),
(15916,'enUS','Very well. Tarren Mill lies just west of here. Since time is of the essence...','',26124),
(15917,'enUS','','If we speak as one, we cannot be ignored!',26124),
(15918,'enUS','Lend us your voices! Now is the time we must act to save our people.','',26124),
(15919,'enUS','Lor\'themar must hear us! We will not be silenced!','',26124),
(15920,'enUS','','The magisters will guide us back to glory.',26124),
(15921,'enUS','Our new allies will bring us back to our former glory. These bonds will be true, and we will not be betrayed again!','',26124),
(15922,'enUS','That should take care of that. Summon me if you have further need of my services.','',26124),
(15923,'enUS','Do you not see how magic has made our city great?','',26124),
(15924,'enUS','Lor\'themar has remade Silvermoon into something we may truly be proud of.','',26124),
(15925,'enUS','How can you say our lives are not better now? How can you deny the betterment of our lives?','',26124),
(15926,'enUS','The magisters are wise and will plot a prosperous course for our future.','',26124),
(15927,'enUS','','We will pay back the Alliance for their betrayal a thousandfold. We will never forgive and never forget.',26124),
(15928,'enUS','','Those who would speak out against magic are enemies of progress. ',26124),
(15929,'enUS','','Nature lives at peace with magic. With both, there is no limit to our future.',26124),
(15930,'enUS','','We will repay the betrayal of the Alliance! We shall never forget, and never forgive!',26124),
(15931,'enUS','I wish to browse your goods.','I wish to browse your goods.',26124),
(15932,'enUS','Don\'t look so surprised to see me here, $r. The coming of the draenei and their alliance with my people was foretold by Kurz the Revelator.','',26124),
(15933,'enUS','<As you greet Ambassador Frasaboo in the furbolg language, he smiles.>$B$BYou must be the one spoken of in the prophecy. It is a great honor to meet you.$B$BI am Ambassador Frasaboo, High Chief Stillpine\'s representative in Blood Watch.','',26124),
(15934,'enUS','It\'s good to see you again, $n. You have High Chief Stillpine\'s deepest gratitude for rescuing his daughter from the clutches of the Bristlelimb.','',26124),
(15935,'enUS','In my years as a member of Explorers\' League, I\'ve been all over Azeroth, but I\'ve never seen anythin\' quite like Bloodmyst. ','',26124),
(15936,'enUS','Train me in the trade of mining.','Train me in the trade of mining.',26124),
(15937,'enUS','Please, don\'t say anything to me. I don\'t want to get into any more trouble with them.','Please, don\'t say anything to me. I don\'t want to get into any more trouble with them.',26124),
(15938,'enUS','','We\'ve just arrived here and already we\'ve buried too many of our friends and comrades.',26124),
(15939,'enUS','What is it that you want, $r?','',26124),
(15940,'enUS','I wish to browse your wares, Otonambusi.','I wish to browse your wares, Otonambusi.',26124),
(15941,'enUS','How can you have any pudding if you don\'t eat your fish?','',26124),
(15942,'enUS','If you don\'t eat your fish, you can\'t have any pudding!','',26124),
(15943,'enUS','I wish to train, Aesom.','I wish to train, Aesom.',26124),
(15944,'enUS','Train me in the ways of herbalism.','Train me in the ways of herbalism.',26124),
(15945,'enUS','I wish to learn more about first aid.','I wish to learn more about first aid.',26124),
(15946,'enUS','Days is $3930e.','',26124),
(15947,'enUS','Tell me how many until Christmas','Tell me how many until Christmas',26124),
(15948,'enUS','Let\'s ride!','',26124),
(15949,'enUS','','If you are not here to help the cause, get out.',26124),
(15950,'enUS','With your help, we might be able to win this thing!','',26124),
(15952,'enUS','%s roars in anger!','',26124),
(15953,'enUS','Tarren Mill lies beyond these trees. The commotion at Durnholde should give us a little time to find Taretha before the entire countryside is flooded with human soldiers. Let\'s check the nearby barn, then head into town.','',26124),
(15954,'enUS','You may make purchases from me by using Halaa tokens of battle and research.','',26124),
(15955,'enUS','I wish to browse your wares.','I wish to browse your wares.',26124),
(15956,'enUS','We\'re ready, Thrall.','We\'re ready, Thrall.',26124),
(15957,'enUS','I can instruct you in skinning.  Interested?','I can instruct you in skinning.  Interested?',26124),
(15958,'enUS','I thought I saw something go into the barn.','I thought I saw something go into the barn.',26124),
(15959,'enUS','%s attempts to get Landra\'s attention.','',26124),
(15960,'enUS','%s sighs.','',26124),
(15962,'enUS','Hmm? Yes?  What\'s that, $n?$B$BPlease, I\'m trying to study Quagmirran.  What\'s left of him anyway.','',26124),
(15963,'enUS','','I can teach you a bit about Tailoring.',26124),
(15964,'enUS','Do you mean the Silvermoon City Inn, or the Wayfarer\'s Rest tavern?','Do you mean the Silvermoon City Inn, or the Wayfarer\'s Rest tavern?',26124),
(15965,'enUS','The Wayfarer\'s Rest tavern.','The Wayfarer\'s Rest tavern.',26124),
(15966,'enUS','The Silvermoon City Inn.','The Silvermoon City Inn.',26124),
(15967,'enUS','The Wayfarer\'s Rest Tavern is located between the Walk of Elders and the Bazaar. You can reach it from either location.','The Wayfarer\'s Rest Tavern is located between the Walk of Elders and the Bazaar. You can reach it from either location.',26124),
(15968,'enUS','I didn\'t see anything.','I didn\'t see anything.',26124),
(15969,'enUS','Something riled that horse. Let\'s go!','Something riled that horse. Let\'s go!',26124),
(15970,'enUS','Thrall tries to calm the horse down.','',26124),
(15971,'enUS','Seems the elevator is out.  I could give you a lift.','',26124),
(15972,'enUS','Please transport me to the top.','Please transport me to the top.',26124),
(15973,'enUS','Please transport me to the bottom.','Please transport me to the bottom.',26124),
(15974,'enUS','Taretha isn\'t here. Let\'s head into town.','',26124),
(15975,'enUS','She\'s not here.','',26124),
(15976,'enUS','Thrall\'s trapped himself in the chapel. He can\'t escape now.','Thrall\'s trapped himself in the chapel. He can\'t escape now.',26124),
(15977,'enUS','Taretha must be in the inn. Let\'s go.','',26124),
(15978,'enUS','Taretha! What foul magic is this?','',26124),
(15979,'enUS','','Thrall, you escaped!',26124),
(15980,'enUS','I, Peoreth Il\'danube, greatest mage within earshot, will teleport you, a peon, to the Undercity.$B$BIt should be noted that my greatness will only be felt during this period of reformation, as the regal House of Blizzard prepares a teleportation device the likes of which has never before been seen, heard, or felt.$B$BOh yes, it will be grand. So grand in fact that the fabric of time and space will itself shift, propelling the denizens of this world into a new age of prosperity...','',26124),
(15981,'enUS','Just shut up and teleport me to the Undercity.','Just shut up and teleport me to the Undercity.',26124),
(15982,'enUS','Bask in the opulence of my people! Let yourself taste the fineries of living, if only this one time. Perhaps then may you die with finality, knowing that you have been touched by the hands of a god!$B$BMay you drink in the spittle that is sure to fly in your direction from disapproving blood elf - man, woman and child alike. Drink it down! Drink. It. DOWN!$B$BTo Silvermoon with you, barbarian!\n','',26124),
(15983,'enUS','Um, just teleport me to Silvermoon.','Um, just teleport me to Silvermoon.',26124),
(15984,'enUS','Ah, many apologies young master. You must be at least this high to utilize a teleportation spell.$B$B<Peoreth makes an approximation of height with his right hand, hovering it at about knee length.>$B$BCome back when you\'ve grown up.','',26124),
(15985,'enUS','Ah, many apologies young master. You must be at least this high to utilize a teleportation spell.$B$B<Maltrake makes an approximation of height with his right hand, hovering it at about knee length.>$B$BCome back when you\'ve grown up.','',26124),
(15986,'enUS','He\'s here, stop him!','He\'s here, stop him!',26124),
(15987,'enUS','','Thank you for helping Thrall escape, friends. Now I only hope you can help me as well. I awoke this morning to find myself trapped in this magical prison. A strange wizard told me that I would have to stay here for a while.',26124),
(15988,'enUS','','Who are you? Are you with the wizard? [PH]',26124),
(15989,'enUS','','',26124),
(15990,'enUS','We\'re here to rescue you, Taretha.','We\'re here to rescue you, Taretha.',26124),
(15991,'enUS','','No, I\'m not important right now. You have to go help Thrall escape. I was going to set a fire as a diversion, but with me in this magical prison you\'ll have to do it instead. [PH]',26124),
(15992,'enUS','Strange wizard?','Strange wizard?',26124),
(15993,'enUS','','Yes, friends. This man was no wizard of Dalaran. His clothes looked quite foreign, and his accent was unfamiliar. All he could mumble about was time this, time that. You\'ll have to find that wizard and convince him to release me.',26124),
(15994,'enUS','We\'ll get you out, Taretha. Don\'t worry. I doubt the wizard would wander too far away.','We\'ll get you out, Taretha. Don\'t worry. I doubt the wizard would wander too far away.',26124),
(15995,'enUS','I\'m glad Taretha is alive. We now must find a way to free her from her magical bindings.','',26124),
(15996,'enUS','','As a representative of the Lower City, I\'m here to put forward our case that Auchindoun must be cleared of its Shadow Council infestation.  That is, if we\'re to have any hope for a future and stave off the possibility of a cataclysm greater than the creation of the Bone Wastes!$B$BAll of our peoples have suffered too much already.  I am here to see to it that the suffering stops!',26124),
(15997,'enUS','Doomguard','Doomguard',26124),
(15998,'enUS','Wrathguard\n','Wrathguard\n',26124),
(15999,'enUS','Succubus','Succubus',26124),
(16000,'enUS','Shivarra','Shivarra',26124),
(16001,'enUS','Dreadlord','Dreadlord',26124),
(16002,'enUS','Eredar','Eredar',26124),
(16003,'enUS','Pit Lord','Pit Lord',26124),
(16004,'enUS','Gan\'arg','Gan\'arg',26124),
(16005,'enUS','Mo\'arg','Mo\'arg',26124),
(16006,'enUS','Felguard','Felguard',26124),
(16007,'enUS','Turn back, mortal... This is not your battle.','',26124),
(16008,'enUS','You cannot stop them...','',26124),
(16009,'enUS','We are infinite... eternal.','',26124),
(16010,'enUS','They lack control... Oshu\'gun calls to them...','',26124),
(16011,'enUS','It is a beacon. A remnant of a forgotten era.','',26124),
(16012,'enUS','Have a seat, $g brother:sister;. The ravages of Zangarmarsh can take a lot out of a $g man:woman;.','',26124),
(16013,'enUS','If you be wantin\' ta rest here, ya just need to ask!','',26124),
(16014,'enUS','Graaaa!','',26124),
(16015,'enUS','Thank you for your help in making the salve, $n. Once it\'s had a chance to dull the pain, I\'m going to see how far I can get on this leg.','',26124),
(16016,'enUS','Thrall! Come outside and face your fate!','',26124),
(16017,'enUS','Who or what was that?','',26124),
(16018,'enUS','Thrall, come outside and face your fate. [PH]','',26124),
(16019,'enUS','Taretha\'s life hangs in the balance. Surely you care for her. Surely you wish to save her... ','',26124),
(16020,'enUS','No!','',26124),
(16021,'enUS','Ah, there you are. I had hoped to accomplish this with a bit of subtlety, but I suppose direct confrontation was inevitable. Your future, Thrall, must not come to pass and so... you and your troublesome friends must die!','',26124),
(16022,'enUS','','Welcome to Garadar, stranger. Are you looking for a place to rest?',26124),
(16023,'enUS','Enough, I will erase your very existence!','',26124),
(16024,'enUS','Ah... another shaman seeks enlightenment, perhaps? Are the spirits speaking unclearly? Do you wish my help in seeing what lies before you?','',26124),
(16025,'enUS','I am Skaltesh, guide to the shaman seeking enlightenment here... but even those who follow different paths can be shown a thing or two. Do you wish to see?','',26124),
(16026,'enUS','Show me, Seer.','Show me, Seer.',26124),
(16027,'enUS','Drink from this vial, and the fog will be cleared for a short time. Go with the spirits, my friend.','',26124),
(16028,'enUS','Sylann, one of the finest cooks in the city, can be found upstairs in the Wayfarer\'s Rest tavern. You can purchase cooking supplies from her assistant there, too.','Sylann, one of the finest cooks in the city, can be found upstairs in the Wayfarer\'s Rest tavern. You can purchase cooking supplies from her assistant there, too.',26124),
(16029,'enUS','Cooking','Cooking',26124),
(16031,'enUS','Greatfather Winter leaves toys for everyone under the tree in Ironforge during the feast of Winter Veil!','Greatfather Winter leaves toys for everyone under the tree in Ironforge during the feast of Winter Veil!',26124),
(16032,'enUS','I should take the tram to Ironforge and visit Greatfather Winter.','I should take the tram to Ironforge and visit Greatfather Winter.',26124),
(16033,'enUS','They say the elves have stirred themselves from their forest for the first time in years. But to join the Horde? It can\'t be true, can it?','They say the elves have stirred themselves from their forest for the first time in years. But to join the Horde? It can\'t be true, can it?',26124),
(16034,'enUS','Human Gossip NPC - Periodic Talk (Expansion Prologue) 01','Human Gossip NPC - Periodic Talk (Expansion Prologue) 01',26124),
(16035,'enUS','Can you not see that I am busy here?','Can you not see that I am busy here?',26124),
(16036,'enUS','Yes?  What do you want?','Yes?  What do you want?',26124),
(16037,'enUS','And you are?','And you are?',26124),
(16039,'enUS','My sister Silanna is naive to the growing danger in these woods. But like it or not, as soon as I get this wagon loaded we\'re moving within the city walls. $b$bIt appears that I\'ve got more bags here than I need. Perhaps you could make use of them.\n','',26124),
(16040,'enUS','Haven\'t got much time to talk, $r. That is, unless you\'re willin\' to help with this mine trouble.','',26124),
(16041,'enUS','Stop here a moment, my children, and close your eyes. Can you feel the air currents?','',26124),
(16042,'enUS','Can\'t thank ya enough fer helpin\' with the mines. Now, it\'s just a matter of convincing the miners to get back to work.','',26124),
(16043,'enUS','The two students close their eyes and bow their heads.','The two students close their eyes and bow their heads.',26124),
(16044,'enUS','Your world will die, mortals!  Your doom is now at hand!','',26124),
(16045,'enUS','Cower, little worms!  Your feeble heroes are nothing!  Your saviors will be our first feast!','',26124),
(16046,'enUS','Azeroth has cowered too long under our shadow!  Now, feel the power of the Burning Crusade and despair!','',26124),
(16047,'enUS','Your fate is sealed, Azeroth!  I will find the Aspect Shards, and then you will not stand against our might!','',26124),
(16048,'enUS','Hah!  This place is not yet worthy of my infliction!','',26124),
(16049,'enUS','Thank you for freeing me, $n! I\'m going to make my way to Shattrath!','',26124),
(16050,'enUS','Yes, teacher.','',26124),
(16051,'enUS','<Isfar sighs.>$B$BA couple of treehouses don\'t make a home, but it was vast improvement over the Sethekk Halls.$B$BComfortable as it was in Shattrath, I can\'t bring myself to return to my true home in Skettis without my sister. She\'s still trapped in the Sethekk Halls, held prisoner by our older brother.','',26124),
(16052,'enUS','Please, $r, get me out of here! Unlocking the cage will surely attract my brother\'s attention. Kill Darkweaver Syth!','',26124),
(16053,'enUS','Now\'s our chance! Let me out of this cage!','',26124),
(16054,'enUS','I\'ll have you out of there in just a moment.','I\'ll have you out of there in just a moment.',26124),
(16055,'enUS','The spirits of the air can be found even here, underground. They dislike being surrounded, constricted by the earth... their precious freedom is limited here.','',26124),
(16056,'enUS','Well done! Hurry, though, we don\'t want to be caught!','',26124),
(16057,'enUS','They are flighty, these spirits, and easily distracted... but they will share their secrets with those who know how to listen.','',26124),
(16058,'enUS','Having trouble dealing with the Wretched? I\'ve got just what you need.\n','Having trouble dealing with the Wretched? I\'ve got just what you need.\n',26124),
(16059,'enUS','Just don\'t ask me where I got it...\n','Just don\'t ask me where I got it...\n',26124),
(16060,'enUS','%s smiles to himself as he watches the students fidget in their concentration.','%s smiles to himself as he watches the students fidget in their concentration.',26124),
(16061,'enUS','Come. There is more to study than the secrets on the wind.','',26124),
(16062,'enUS','','Your blood will coat the walls of Kil\'sorrow!',26124),
(16063,'enUS','The Ring of Trials was once of place of great glory and honor. But then, the Steamwheedle Cartel came, with their wagons of gold and quill pens sharper than any orc axe...','',26124),
(16064,'enUS','The Sethekk believe themselves to be the true and most loyal followers of the master of all arakkoa. Do not ask about the master, $r, for his mysteries are for the feathered people alone.$B$BThe Sethekk interpreted the destruction of Auchindoun to be the arrival of our master on this planet. They set out for the ruins, taking with them the relics of our greatest hero, Terokk.$B$BThey still seek the master in the temple\'s ruins, but I came to see through their lies. I am no longer one of them.','',26124),
(16065,'enUS','When I was last in the halls, Talon King Ikiss carried Terokk\'s Quill with him, as a sign of his authority.$B$BMy brother, Darkweaver Syth, wore Terokk\'s Mask during our rituals.$B$BAs for the Saga of Terokk, there\'s no way of knowing exactly where it is, but they usually kept it at the center of one of their rune circles in the great vaulted halls.','',26124),
(16066,'enUS','\'Talon King\' Ikiss is one of the leaders of the Sethekk, along with my brother, Darkweaver Syth.$B$BIt was they who led the exodus of the Sethekk from Skettis to the ruins of Auchindoun. In the beginning, Ikiss was a charismatic leader, but he has descended into madness.$B$BNow, he openly proclaims that he is Terokk reborn! He truly expects the arakkoa to bend knee to him as their ruler. Can you believe his arrogance?','',26124),
(16067,'enUS','Who is Talon King Ikiss?','Who is Talon King Ikiss?',26124),
(16068,'enUS','Who are the Sethekk?','Who are the Sethekk?',26124),
(16069,'enUS','Where can I find the relics of Terokk?','Where can I find the relics of Terokk?',26124),
(16070,'enUS','Who is this Terokk you keep mentioning?','Who is this Terokk you keep mentioning?',26124),
(16071,'enUS','He is the greatest hero the arakkoa have ever known.$B$BIt is said that in ancient times, he built the city of Skettis with his own claws. He was our greatest champion and defender, but he left us when we turned away from the veneration of Rukhmar.$B$BWe came to worship a new master, one who promised us untold power and status in the cosmos.$B$BThere are some who say that Terokk and Rukhmar are one, and he withdrew his presence from us when we turned away from him.','',26124),
(16072,'enUS','Welcome, welcome, to the recently appropriated and callously renamed Steamwheedle Stadium!','',26124),
(16073,'enUS','Can you feel the warmth here, my children?','',26124),
(16074,'enUS','The students nod slowly, eyes rapt on their teacher.','The students nod slowly, eyes rapt on their teacher.',26124),
(16075,'enUS','Focus upon that warmth as I speak...','',26124),
(16076,'enUS','The strength of fire lies in change. Its strength is considerable, but ever-shifting... unpredictable.','',26124),
(16077,'enUS','This is extended to the spirits themselves. They are often quick to anger; it is important that you learn to listen without falling prey to their tempers.','',26124),
(16078,'enUS','That is enough for now. Come.','',26124),
(16079,'enUS','The water here is peaceful, is it not? Listening to the trickle from the ceiling can aid you in finding its true voice...','',26124),
(16080,'enUS','The water spirits are perhaps the most outspoken. They are generous and understanding. Indeed, if you are having trouble hearing the voices, it is with water that you should begin.','',26124),
(16081,'enUS','Close your eyes, my children, and listen to the water within these halls.','',26124),
(16082,'enUS','','I\'m free! Thank you all!',26124),
(16083,'enUS','I\'m glad you\'re safe, Taretha. None of this would have been possible without your friends. They made all of this happen.','',26124),
(16084,'enUS','Then who are these people?','',26124),
(16085,'enUS','','Thrall, I\'ve never met these people before in my life.',26124),
(16086,'enUS','I believe I can explain everything to you two if you give me a moment of your time.','',26124),
(16087,'enUS','That spell should wipe their memories of us and what just happened. All they should remember now is what reality would be like without the attempted temporal interference. Well done. Thrall will journey on to find his destiny, and Taretha...','',26124),
(16088,'enUS','Her fate is regrettably unavoidable.','',26124),
(16089,'enUS','Goodbye, Taretha. I will never forget your kindness.','',26124),
(16090,'enUS','','They call you a monster. But they\'re the monsters, not you. Farewell, Thrall.',26124),
(16091,'enUS','Something must be done about these Wretched...\n','Something must be done about these Wretched...\n',26124),
(16092,'enUS','Once they\'re dealt with we can dedicate more resources to the war effort.\n','Once they\'re dealt with we can dedicate more resources to the war effort.\n',26124),
(16093,'enUS','If only I had some wine to go with my cheese...\n','If only I had some wine to go with my cheese...\n',26124),
(16094,'enUS','Ooh what a dreadful job!\n','Ooh what a dreadful job!\n',26124),
(16095,'enUS','All day, surrounded by the stench of bad feet.\n','All day, surrounded by the stench of bad feet.\n',26124),
(16096,'enUS','The hours would pass so much more sweetly.\n','The hours would pass so much more sweetly.\n',26124),
(16097,'enUS','Why couldn\'t mother have chosen something else to dedicate herself to?\n','Why couldn\'t mother have chosen something else to dedicate herself to?',26124),
(16098,'enUS','Cakes, pastries, even bread - anything but cheese!\n','Cakes, pastries, even bread - anything but cheese!',26124),
(16099,'enUS','Gah! Every time I load something into the wagon, it reappears here within moments!\n','Gah! Every time I load something into the wagon, it reappears here within moments!\n',26124),
(16100,'enUS','I should have known better than to have given Silanna that tome of cantrips.\n','I should have known better than to have given Silanna that tome of cantrips.\n',26124),
(16101,'enUS','All muscle and no brain, that\'s what peons are! They\'re great when you can motivate them, but they have to be \'kick\' started, if you know what I mean.','',26124),
(16102,'enUS','Foul deeds, these.\n','Foul deeds, these.\n',26124),
(16103,'enUS','Luckily, I managed to salvage a few bottles.\n','Luckily, I managed to salvage a few bottles.\n',26124),
(16104,'enUS','Both students close their eyes, straining to hear the voices.','Both students close their eyes, straining to hear the voices.',26124),
(16105,'enUS','Hic... What a calim... a culamu... uhh calamit... Err, what a disaster!\n\n','Hic... What a calim... a culamu... uhh calamit... Err, what a disaster!\n\n',26124),
(16106,'enUS','It\'s enough to drive a man to drink.\n\n','It\'s enough to drive a man to drink.\n\n',26124),
(16107,'enUS','%s nods to himself and clears his throat.','%s nods to himself and clears his throat.',26124),
(16108,'enUS','Stand, my children... that\'s enough for now.','',26124),
(16109,'enUS','','Like anything that you see, $c?',26124),
(16110,'enUS','What about the earth spirits?','What about the earth spirits?',26124),
(16111,'enUS','%s chuckles softly.','%s chuckles softly.',26124),
(16112,'enUS','The earth spirits are very much present in this chamber, my child. After all, we are underground, are we not?','',26124),
(16113,'enUS','They are stoic, the spirits of the earth. Through them, the shaman learns to endure the hardships of life.','',26124),
(16114,'enUS','If you have the money, I have what you need.','',26124),
(16115,'enUS','The rocks are here when we first enter this world, and they will remain long after we pass.','',26124),
(16116,'enUS','','Take a look around and let me know if there\'s anything that you\'re interested in.',26124),
(16118,'enUS','Stand... there is more to discuss.','',26124),
(16119,'enUS','|cffffff00The Horde has taken control of The Bone Wastes!|r','',26124),
(16120,'enUS','|cffffff00The Alliance has taken control of The Bone Wastes!|r','',26124),
(16121,'enUS','','Take your time, look the weapons over.  I also repair weapons and armor if you need such services.',26124),
(16122,'enUS','I have just the thing you need to cast your spell.','',26124),
(16123,'enUS','Tell me again what you know!','Tell me again what you know!',26124),
(16124,'enUS','It will take a sharp blade and reinforced armor to bring tranquility back to Nagrand. Shall I repair your equipment so that you may mete justice?','',26124),
(16125,'enUS','I wish to browse your wares.','I wish to browse your wares.',26124),
(16126,'enUS','Are you looking for reagents or poison supplies? If so, you\'ve come to the right place!','',26124),
(16127,'enUS','I wish to browse your wares.','I wish to browse your wares.',26124),
(16128,'enUS','I sell wares that crafters need. Just the basics, nothing fancy.','',26124),
(16129,'enUS','What do you have for sale?','What do you have for sale?',26124),
(16130,'enUS','','Do you need to stable your pet?',26124),
(16131,'enUS','I wish to stable my pet.','I wish to stable my pet.',26124),
(16132,'enUS','','Are you lost? Most of the town\'s vendors are situated near the center of town.',26124),
(16133,'enUS','','I carry odds and ends, but mostly just odds.',26124),
(16134,'enUS','What do you have for sale?','What do you have for sale?',26124),
(16135,'enUS','What do you have for sale?','What do you have for sale?',26124),
(16136,'enUS','It\'s driving me crazy. I cannot reach those damned eggs!','',26124),
(16137,'enUS','They look so delicious...','',26124),
(16138,'enUS','If only I could get this blasted machine working!','',26124),
(16139,'enUS','Oh sweet, delicious, spotted eggs - you will be mine... ','',26124),
(16140,'enUS','','For years, Honor Hold has stood against the horrors of Hellfire Peninsula.  Now, now that the portal has reopened and aid streams in from Azeroth, perhaps this bloody stalemate will end.',26124),
(16141,'enUS','','It is regrettable that, among our many enemies in Hellfire Peninsula, the orcs of Hellfire Citadel stand among them.$B$BBut... who better to challenge and hone the Horde... than orcs?',26124),
(16142,'enUS','','I am the quartermaster, here. Did you need provisions?',26124),
(16143,'enUS','Good to see you again, $n! Just a few more adjustments and the trajectory of the jump will be perfect!','',26124),
(16144,'enUS','Wazat, I have done something foolish and have lost my key as a result of this action. Could I trouble you for a spare?','Wazat, I have done something foolish and have lost my key as a result of this action. Could I trouble you for a spare?',26124),
(16145,'enUS','Anything for you, $n!','',26124),
(16146,'enUS','I have marks to redeem!','I have marks to redeem!',26124),
(16147,'enUS','Psst, $n, get over here.','',26124),
(16148,'enUS','$n, get over here.','',26124),
(16149,'enUS','%s lets loose a terrifying shriek.','',26124),
(16150,'enUS','%s cracks open, filling the nest with yolk.','',26124),
(16151,'enUS','The Lunar Festival celebration being held by the druids is taking place in Moonglade. If that\'s too far for you to travel, they are offering transportation just outside Stormwind.','The Lunar Festival celebration being held by the druids is taking place in Moonglade. If that\'s too far for you to travel, they are offering transportation just outside Stormwind.',26124),
(16153,'enUS','The Lunar Festival is a special time for us. We seek out our ancient elders, the Earthen, and pay homage to them.','The Lunar Festival is a special time for us. We seek out our ancient elders, the Earthen, and pay homage to them.',26124),
(16154,'enUS','Dwarf Gossip NPC - Periodic Talk (Expansion Prologue) 01','Dwarf Gossip NPC - Periodic Talk (Expansion Prologue) 01',26124),
(16155,'enUS','Ironforge rarely looks as splendid as it does during the feast of Winter Veil.','Ironforge rarely looks as splendid as it does during the feast of Winter Veil.',26124),
(16156,'enUS','The Lunar Festival holds special meaning for the night elves. We seek out the wisdom of our elders across the world.','The Lunar Festival holds special meaning for the night elves. We seek out the wisdom of our elders across the world.',26124),
(16157,'enUS','Night Elf Gossip NPC - Periodic Talk (Expansion Prologue) 01','Night Elf Gossip NPC - Periodic Talk (Expansion Prologue) 01',26124),
(16158,'enUS','It feels like everyone wants to kiss me under the mistletoe.','It feels like everyone wants to kiss me under the mistletoe.',26124),
(16161,'enUS','It is my understanding that the people of the Alliance celebrate this Winter Veil in Ironforge.','It is my understanding that the people of the Alliance celebrate this Winter Veil in Ironforge.',26124),
(16163,'enUS','If the Dark Portal opens again, we could go home to Draenor.','If the Dark Portal opens again, we could go home to Draenor.',26124),
(16164,'enUS','Though we do not truly understand the traditions of Winter Veil, we have taken to them.','Though we do not truly understand the traditions of Winter Veil, we have taken to them.',26124),
(16165,'enUS','Undead Gossip NPC - Periodic Talk (Lunar Festival) 01','Undead Gossip NPC - Periodic Talk (Lunar Festival) 01',26124),
(16166,'enUS','Undead Gossip NPC - Periodic Talk (Expansion Prologue) 01','Undead Gossip NPC - Periodic Talk (Expansion Prologue) 01',26124),
(16167,'enUS','Winter Veil just isn\'t the same now, but going through the motions still makes me feel something.','Winter Veil just isn\'t the same now, but going through the motions still makes me feel something.',26124),
(16168,'enUS','The Lunar Festival holds special meaning for the tauren. We seek out the wisdom of our elders across the world.','The Lunar Festival holds special meaning for the tauren. We seek out the wisdom of our elders across the world.',26124),
(16169,'enUS','Tauren Gossip NPC - Periodic Talk (Expansion Prologue) 01','Tauren Gossip NPC - Periodic Talk (Expansion Prologue) 01',26124),
(16170,'enUS','Greatfather Winter is only a wyvern\'s ride away to Orgrimmar.','Greatfather Winter is only a wyvern\'s ride away to Orgrimmar.',26124),
(16171,'enUS','The festival of the moon was ever more important to the kaldorei. The great festival of the druids is surely in full swing.','The festival of the moon was ever more important to the kaldorei. The great festival of the druids is surely in full swing.',26124),
(16173,'enUS','Winter Veil has always been a human thing. To see the goblins and orcs take it up is rather strange.','Winter Veil has always been a human thing. To see the goblins and orcs take it up is rather strange.',26124),
(16174,'enUS','Go to Ironforge\'s Mystic Ward and speak with the night elf druids there. They can transport you to Moonglade to join in the Lunar Festival celebration.','Go to Ironforge\'s Mystic Ward and speak with the night elf druids there. They can transport you to Moonglade to join in the Lunar Festival celebration.',26124),
(16175,'enUS','I have heard rumors that our old friends, the elves, have allied themselves with the Horde. I always said our trust in them was foolish.','I have heard rumors that our old friends, the elves, have allied themselves with the Horde. I always said our trust in them was foolish.',26124),
(16176,'enUS','Greatfather Winter can be found in front of the Ironforge bank. The tree near him is where presents are given out.','Greatfather Winter can be found in front of the Ironforge bank. The tree near him is where presents are given out.',26124),
(16179,'enUS','The younger races make a big fuss over Winter Veil. Ironforge\'s bank is the center of the festivities.','The younger races make a big fuss over Winter Veil. Ironforge\'s bank is the center of the festivities.',26124),
(16180,'enUS','If only our brothers, the blood elves, could change their ways. They will bring the Legion upon us again, mark my words.','If only our brothers, the blood elves, could change their ways. They will bring the Legion upon us again, mark my words.',26124),
(16181,'enUS','The celebration of the Lunar Festival is in full swing in Moonglade. You can make the trek, or the druids in the Cenarion Enclave are offering transport.','The celebration of the Lunar Festival is in full swing in Moonglade. You can make the trek, or the druids in the Cenarion Enclave are offering transport.',26124),
(16183,'enUS','I have traveled countless worlds, but I have never seen as enjoyable a celebration as this feast of Winter Veil. You should travel to Ironforge, the dwarves\' great city, to see it for yourself.','I have traveled countless worlds, but I have never seen as enjoyable a celebration as this feast of Winter Veil. You should travel to Ironforge, the dwarves\' great city, to see it for yourself.',26124),
(16184,'enUS','This new world fascinates us. A world that has fought the Legion to a standstill... amazing.','This new world fascinates us. A world that has fought the Legion to a standstill... amazing.',26124),
(16185,'enUS','The druids of Azeroth hold a great celebration in the Moonglade. If you find the lunar festival revelers in the city, they can transport you there.','The druids of Azeroth hold a great celebration in the Moonglade. If you find the lunar festival revelers in the city, they can transport you there.',26124),
(16187,'enUS','If you wish to truly experience the feast of Winter Veil, you should go to Orgrimmar.','If you wish to truly experience the feast of Winter Veil, you should go to Orgrimmar.',26124),
(16188,'enUS','They say that the Alliance has found new allies. They will be hard pressed to recover from losing us.','They say that the Alliance has found new allies. They will be hard pressed to recover from losing us.',26124),
(16189,'enUS','If you find the lunar festival revelers in Silvermoon, they can transport you to Moonglade to partake in the celebration.','If you find the lunar festival revelers in Silvermoon, they can transport you to Moonglade to partake in the celebration.',26124),
(16191,'enUS','You\'ll find Greatfather Winter in the center of the Valley of Strength. Just look for the tree.','You\'ll find Greatfather Winter in the center of the Valley of Strength. Just look for the tree.',26124),
(16192,'enUS','Have you heard about the great explosion in the north?','Have you heard about the great explosion in the north?',26124),
(16193,'enUS','The largest celebration of the Lunar Festival is taking place in Moonglade. If that\'s too far to travel to, there are druids offering transport from the Valley of Wisdom.','The largest celebration of the Lunar Festival is taking place in Moonglade. If that\'s too far to travel to, there are druids offering transport from the Valley of Wisdom.',26124),
(16195,'enUS','We still go through the motions, but the feast of Winter Veil feels empty now. In Orgrimmar they have the true celebration.','We still go through the motions, but the feast of Winter Veil feels empty now. In Orgrimmar they have the true celebration.',26124),
(16196,'enUS','I hear our new allies will be joining us here. Fighting alongside elves... Just like old times.','I hear our new allies will be joining us here. Fighting alongside elves... Just like old times.',26124),
(16197,'enUS','To many of the Forsaken, the moon now holds the place in our hearts where sun once resided. However, if you choose to join the celebration, go to Moonglade in Kalimdor. You\'ll find druids in the throne room above Undercity that will transport you there.','To many of the Forsaken, the moon now holds the place in our hearts where sun once resided. However, if you choose to join the celebration, go to Moonglade in Kalimdor. You\'ll find druids in the throne room above Undercity that will transport you there.',26124),
(16199,'enUS','The celebration of the feast of Winter Veil is a source of great warmth during the cold seasons, and its heart is in Orgrimmar.','The celebration of the feast of Winter Veil is a source of great warmth during the cold seasons, and its heart is in Orgrimmar.',26124),
(16200,'enUS','I do not know what to make of these elves from across the sea. The tauren and elves of this continent have always warred.','I do not know what to make of these elves from across the sea. The tauren and elves of this continent have always warred.',26124),
(16201,'enUS','The largest celebration of the Lunar Festival takes place in Moonglade. Druids will transport you there from the Elder Rise of Thunder Bluff.','The largest celebration of the Lunar Festival takes place in Moonglade. Druids will transport you there from the Elder Rise of Thunder Bluff.',26124),
(16202,'enUS','You - come here. Are these blades not the finest quality? Surely you wish to purchase from me. You will not find such workmanship and care wrought into such weapons anywhere else, $r.','',26124),
(16203,'enUS','What are you staring at, $r?','',26124),
(16204,'enUS','How embarrassing! Someone mistook me for one of Greatfather Winter\'s helpers.','How embarrassing! Someone mistook me for one of Greatfather Winter\'s helpers.',26124),
(16205,'enUS','Gnome Gossip NPC - Periodic Talk (Expansion Prologue) 01','Gnome Gossip NPC - Periodic Talk (Expansion Prologue) 01',26124),
(16206,'enUS','Lunar Festival is the best time of year for fireworks!','Lunar Festival is the best time of year for fireworks!',26124),
(16209,'enUS','Orgrimmar has truly become the heart of Winter Veil.','Orgrimmar has truly become the heart of Winter Veil.',26124),
(16210,'enUS','Troll Gossip NPC - Periodic Talk (Expansion Prologue) 01','Troll Gossip NPC - Periodic Talk (Expansion Prologue) 01',26124),
(16211,'enUS','We should go to Moonglade to see the druids\' great festival of the moon.','We should go to Moonglade to see the druids\' great festival of the moon.',26124),
(16212,'enUS','Greatfather Winter can be found in front of the Ironforge bank. The tree near him is where presents are given out.','Greatfather Winter can be found in front of the Ironforge bank. The tree near him is where presents are given out.',26124),
(16213,'enUS','Have you heard the rumors? There was a great explosion in the northern lands of Kalimdor and the elves are finally stirring in Quel\'thalas!','Have you heard the rumors? There was a great explosion in the northern lands of Kalimdor and the elves are finally stirring in Quel\'thalas!',26124),
(16214,'enUS','Go to Ironforge\'s Mystic Ward and speak with the night elf druids there. They can transport you to Moonglade to join in the Lunar Festival celebration.','Go to Ironforge\'s Mystic Ward and speak with the night elf druids there. They can transport you to Moonglade to join in the Lunar Festival celebration.',26124),
(16215,'enUS','You\'ll find Greatfather Winter in the center of the Valley of Strength. Just look for the tree.','You\'ll find Greatfather Winter in the center of the Valley of Strength. Just look for the tree.',26124),
(16216,'enUS','Rumors of blue skinned people in the north? Perhaps it\'s just more trolls.','Rumors of blue skinned people in the north? Perhaps it\'s just more trolls.',26124),
(16217,'enUS','The most amazing of the Lunar Festival parties is in Moonglade. Don\'t walk there, though, the druids in the Valley of Wisdom can transport you.','The most amazing of the Lunar Festival parties is in Moonglade. Don\'t walk there, though, the druids in the Valley of Wisdom can transport you.',26124),
(16218,'enUS','The untamed plains of Nagrand offer some of the best hunting I\'ve ever experienced. ','',26124),
(16219,'enUS','Do you like fish, $r? I have fish here. If you like fresh fish, the freshest, come and sample my wares.','',26124),
(16220,'enUS','I cannot help you, please speak with the Gryphon Master on the South side of the Dark Portal.','I cannot help you, please speak with the Gryphon Master on the South side of the Dark Portal.',26124),
(16222,'enUS','I cannot help you, please speak with the Wind Rider Master on the North side of the Dark Portal.','I cannot help you, please speak with the Wind Rider Master on the North side of the Dark Portal.',26124),
(16223,'enUS','Never look these Broken directly in the eyes. I think they can suck the soul right out of you if they\'re so inclined!','',26124),
(16224,'enUS','Get out of my face, kid! Can\'t you see that I\'m training? That\'s right, yours truly is going to be the next Warmaul champion.$B$BYep, I\'m almost ready for the Ring of Blood up north in the old Laughing Skull Ruins. But don\'t even think about it, kid. You\'re way too weak. Gurgthock, the ring announcer, wouldn\'t even let you peek inside that ring let alone fight in it.$B$BNow beat it before it beats you.','',26124),
(16225,'enUS','Well look at you. Aren\'t you big and tough... Maybe you think you\'re tough enough to step into the Ring of Blood and face the Warmaul champion?$B$B<The pitfighter laughs.>$B$BNot very likely but if you ever wanna test your strength, the Ring of Blood is far to the north against the mountains dividing Nagrand and Zangarmarsh. Gurgthock runs the show at the old Laughing Skull Ruins and he also dispenses the prizes. Speaking of prizes, I hear the prizes this season are incredible!','',26124),
(16226,'enUS','Wow! Look at his muscles!','Wow! Look at his muscles!',26124),
(16227,'enUS','I wanna be just like the pitfighter!','I wanna be just like the pitfighter!',26124),
(16228,'enUS','Will he win? Can he win?','Will he win? Can he win?',26124),
(16229,'enUS','The pitfighter will be victorious! Just look at him!','The pitfighter will be victorious! Just look at him!',26124),
(16230,'enUS','He\'s so well disciplined!','He\'s so well disciplined!',26124),
(16231,'enUS','How does he do it?','How does he do it?',26124),
(16232,'enUS','The attackers shall not succeed!  Strength and honor to the Horde!','',26124),
(16233,'enUS','Wow! Look at his muscles!','Wow! Look at his muscles!',26124),
(16234,'enUS','I wanna be just like the pitfighter!','I wanna be just like the pitfighter!',26124),
(16235,'enUS','Will he win? Can he win?','Will he win? Can he win?',26124),
(16236,'enUS','The pitfighter will be victorious! Just look at him!','The pitfighter will be victorious! Just look at him!',26124),
(16237,'enUS','He\'s so well disciplined!','He\'s so well disciplined!',26124),
(16238,'enUS','How does he do it?','How does he do it?',26124),
(16239,'enUS','What are you doing in Nagrand, filth? Answer me!','',26124),
(16240,'enUS','What are you after, Bloodknight? Speak or the brutes will punish you.','',26124),
(16241,'enUS','%s raises an eyebrow at Khan.','%s raises an eyebrow at Khan.',26124),
(16242,'enUS','%s kneels down as if to get closer to the Bloodknight.','',26124),
(16243,'enUS','Surprised? You thought what? That draenei do not beat their prisoners?','',26124),
(16244,'enUS','You are correct. We do not beat our prisoners. Broken, on the other hand, have no issues with violence. You see, they are brutes, after all...','',26124),
(16245,'enUS','Beat this filth until it speaks...','',26124),
(16246,'enUS','%s nods.','',26124),
(16247,'enUS','The interrogator is trying to find out what these blood elves are doing here in Nagrand. From what I hear, they\'re after crystal powder residue from Oshu\'gun, the diamond mountain to the west.$B$BNo doubt to use in some insidious scheme or concoction...$B$BIf you are looking to help our cause and stop these blood elves, the conflict is happening right now to the northwest at Halaa. Blood elves and those Hand of Argus soldiers are battling! Join in and show them what\'s right!','The interrogator is trying to find out what these blood elves are doing here in Nagrand. From what I hear, they\'re after crystal powder residue from Oshu\'gun, the diamond mountain to the west.$B$BNo doubt to use in some insidious scheme or concoction...$B$BIf you are looking to help our cause and stop these blood elves, the conflict is happening right now to the northwest at Halaa. Blood elves and those Hand of Argus soldiers are battling! Join in and show them what\'s right!',26124),
(16248,'enUS','Draenei have come back! This group jumped two of my best wolf riders as they were out patrolling the western roads. Needless to say, we were victorious in that skirmish.$B$BNow I\'m not sure what\'s going on but from what my scouts tell me, there are blood elves and draenei all over Halaa. I\'m no blood elf lover but if it\'s one thing I hate it\'s a draenei. If you see draenei or any of their allies at Halaa, be sure to put a boot in their backsides for me.$B$BHalaa\'s to the west... In case you want to go now.','Draenei have come back! This group jumped two of my best wolf riders as they were out patrolling the western roads. Needless to say, we were victorious in that skirmish.$B$BNow I\'m not sure what\'s going on but from what my scouts tell me, there are blood elves and draenei all over Halaa. I\'m no blood elf lover but if it\'s one thing I hate it\'s a draenei. If you see draenei or any of their allies at Halaa, be sure to put a boot in their backsides for me.$B$BHalaa\'s to the west... In case you want to go now.',26124),
(16249,'enUS','You won\'t escape alive!','You won\'t escape alive!',26124),
(16250,'enUS','Kill them before they get away!','Kill them before they get away!',26124),
(16251,'enUS','You know too much!','You know too much!',26124),
(16252,'enUS','For Kael\'thas!','For Kael\'thas!',26124),
(16253,'enUS','They mustn\'t escape!','They mustn\'t escape!',26124),
(16254,'enUS','I will have your energy and then your life!','I will have your energy and then your life!',26124),
(16255,'enUS','What can I do for you?','What can I do for you?',26124),
(16256,'enUS','What\'s your poison, $G boy:girl;?','What\'s your poison, $G boy:girl;?',26124),
(16257,'enUS','What can I get you today, $r?','What can I get you today, $r?',26124),
(16258,'enUS','Rough day? You need a drink,$G soldier:hon;.','Rough day? You need a drink,$G soldier:hon;.',26124),
(16259,'enUS','','%s makes some strange gestures.',26124),
(16260,'enUS','I wonder if they can fly?','I wonder if they can fly?',26124),
(16261,'enUS','Why do they like rats anyways?','Why do they like rats anyways?',26124),
(16262,'enUS','I wish I could live in a tree house.','I wish I could live in a tree house.',26124),
(16263,'enUS','That bridge looks pretty scary.','That bridge looks pretty scary.',26124),
(16264,'enUS','This is a good hiding spot.','This is a good hiding spot.',26124),
(16265,'enUS','If I lived in a tree I would never come down to the ground.','If I lived in a tree I would never come down to the ground.',26124),
(16266,'enUS','Why do they need bridges, can\'t they fly?','Why do they need bridges, can\'t they fly?',26124),
(16267,'enUS','White rats are my favorite','White rats are my favorite',26124),
(16268,'enUS','That rat over there looks mean.  I wonder if it has rabies.','That rat over there looks mean.  I wonder if it has rabies.',26124),
(16269,'enUS','I had a rat once, but then my mom made me put it back outside.','I had a rat once, but then my mom made me put it back outside.',26124),
(16270,'enUS','I like that brown rat over there.  HEY!  I think he waved at me!!','I like that brown rat over there.  HEY!  I think he waved at me!!',26124),
(16271,'enUS','','%s begins to summon in a Cabal Deathsworn!',26124),
(16272,'enUS','Let\'s get outta here!','Let\'s get outta here!',26124),
(16273,'enUS','Ha ha ha!  Those rats must be real scared now!','Ha ha ha!  Those rats must be real scared now!',26124),
(16274,'enUS','I think the rats are after us!  Run!!','I think the rats are after us!  Run!!',26124),
(16275,'enUS','','%s begins to summon in a Cabal Acolyte!',26124),
(16278,'enUS','','%s summons a Cabal Acolyte to his aid!',26124),
(16279,'enUS','We\'re safe.  Let\'s rest a bit before we go back.','We\'re safe.  Let\'s rest a bit before we go back.',26124),
(16280,'enUS','','%s summons a Cabal Deathsworn to his aid!',26124),
(16281,'enUS','We made it!!','We made it!!',26124),
(16282,'enUS','Gross!  I think i might have stepped on a rat!','Gross!  I think i might have stepped on a rat!',26124),
(16283,'enUS','I hope they don\'t tell on us.','I hope they don\'t tell on us.',26124),
(16284,'enUS','|cffffff00The Alliance has taken control of both beacons!|r','',26124),
(16285,'enUS','|cffffff00The Horde has taken control of both beacons!|r','',26124),
(16286,'enUS','Behold the power of the Light! Grace and glory to the Alliance!','',26124),
(16287,'enUS','|cffffff00The Alliance Field Scout is now issuing battle standards.|r','',26124),
(16288,'enUS','|cffffff00The Horde Field Scout is now issuing battle standards.|r','',26124),
(16289,'enUS','We already have control of Twin Spire Ruins! Get out there and defend it!','',26124),
(16290,'enUS','We already have control of Twin Spire Ruins! Get out there and defend it!','',26124),
(16291,'enUS','This old draenei board has been refurbished by the Kurenai and is now used to post announcements and bounties.','',26124),
(16292,'enUS','Troops! Fall in!','',26124),
(16293,'enUS','Shadow Hunter Denjai uses this board to post important announcements and news of bounties on the foes of Zabra\'jin.','',26124),
(16294,'enUS','We are graced to hear from our revered Grand Anchorite Almonen. Take a knee men.','',26124),
(16295,'enUS','Troops! Fall out!','',26124),
(16296,'enUS','FRUIT VENDOR!!! Your cart is still in our way!  We will give you one more hour to move it from our area.  Do not test our patience anymore!','FRUIT VENDOR!!! Your cart is still in our way!  We will give you one more hour to move it from our area.  Do not test our patience anymore!',26124),
(16297,'enUS','Does this fruit vendor not value his life? YOU ARE RUNNING OUT OF TIME FRUIT VENDOR!!','Does this fruit vendor not value his life? YOU ARE RUNNING OUT OF TIME FRUIT VENDOR!!',26124),
(16298,'enUS','HA!  I CRUSHED AN APPLE, FRUIT VENDOR!  THIS WILL NOT BE THE LAST!!','HA!  I CRUSHED AN APPLE, FRUIT VENDOR!  THIS WILL NOT BE THE LAST!!',26124),
(16299,'enUS','I have been observing your training, my young brothers and sisters.','',26124),
(16300,'enUS','I\'ve not seen a more well-trained group of soldiers in all my years.','',26124),
(16301,'enUS','The time has now come for you to face our enemies on the field of battle. As I speak our brothers and sisters fight to fend off the forces of Kil\'jaeden on the isle of Quel\'Danas.','',26124),
(16302,'enUS','The darkness in your souls draws you ever closer...','',26124),
(16303,'enUS','As you all well know, the path of our people has not been an enviable one. Blood elf and draenei alike have been tested.','',26124),
(16305,'enUS','Conflict and strife have been our constant companions for as long as any of us can remember.','',26124),
(16306,'enUS','For countless years, and across the faces of many worlds, draenei have yearned to better embrace the Light and put an end to the darkness. So too have our Scryer brethren held such ambition.','',26124),
(16307,'enUS','','I could have sworn I had more apples.  Grok!',26124),
(16308,'enUS','At last my noble brothers and sisters, our time is at hand!','',26124),
(16309,'enUS','A moment ago, you knelt as recruits...','',26124),
(16310,'enUS','Now, with my blessing, you arise as true sons of the Light!','',26124),
(16311,'enUS','Go forth my brothers, and may your light pierce the darkness! The Deceiver must be brought to justice!','',26124),
(16312,'enUS','','Huh? Did someone say something?',26124),
(16313,'enUS','','Fruit?  Did somebody say they wanted fruit?',26124),
(16314,'enUS','','What is that poor orc yelling about? Someone should see what is going on.',26124),
(16315,'enUS','','Is someone calling for me?',26124),
(16316,'enUS','Ahh, ya couldn\'t resist, could ya? Want to be better, stronger, faster? Each one of these amulets be guaranteed to do just what I say they be doin\'. Step up and buy one of these miraculous baubles! Cheap at twice the price!','',26124),
(16317,'enUS','I\'ll... take a look.','I\'ll... take a look.',26124),
(16318,'enUS','Hey! Hey, $r! I be havin\' just the thing for ya. Ya ever see a tikbalang? Frightenin\' creatures. Prone to stealin\' ya away. What ya need is one of my tikbalang wards. Guaranteed to ward away all tikbalangs!','',26124),
(16319,'enUS','Look over here, $c! I got somethin\' for ya. Just what ya need. It\'s soap, right... and it\'s on a rope! No offense, $G man:honey;, but yer a little ripe, know what I\'m sayin\'?','',26124),
(16320,'enUS','Ya look lovesick. Special someone be gettin\' ya down, eh? No worries, no worries. Ya get this medallion from me, ya wear it when ya see \'em, and they be all over ya, $G man:sweetheart;!','',26124),
(16321,'enUS','Dangerous out there, innit? Know what ya need? Protection. I can help ya defy death itself! Ya wear this madstone \'round yer neck, see, and then ya be able to come back if ya find yerself in the spirit world! Just a quick jaunt to yer corpse and up ya come, fresh and new!','',26124),
(16322,'enUS','Amazing amulets! Incredible curios! The newfangled jewelcrafters be havin\' nothin\' on the tried and true mystical methods of ol\' Griftah! Improve yerself through these magical talismans for a bargain price!','',26124),
(16323,'enUS','C\'mere, $r. Ya don\'t want to be riskin\' yerself in a dungeon, do ya? Filthy work, and for what? Some worthless trinket? Nah, what ya need be one of my amulets. Guaranteed to work!','',26124),
(16324,'enUS','Ya look tired, $c. I be havin\' somethin\' for ya. These amulets, they can help ya leap obstacles and swim through the rivers like ya be born to it. They energize the food ya be eatin\', makin\' yer wounds close before yer eyes!','',26124),
(16325,'enUS','Thank you! Thank you! Thanks for that warm welcome.','',26124),
(16326,'enUS','Whoa!  Is all that applause for me?  Thanks for coming out!','',26124),
(16327,'enUS','Thanks for coming out to see me!  I hope you are ready for a good time, because I am.','',26124),
(16328,'enUS','Hey folks, go easy on me... it\'s my first time.','',26124),
(16329,'enUS','Are you ready to laugh!','',26124),
(16330,'enUS','Fools.','',26124),
(16331,'enUS','Have you ever noticed that all those cute, orc kids look the same?','',26124),
(16332,'enUS','So this gnome tells a tauren that he\'s been to Molten Core.','',26124),
(16333,'enUS','Here\'s a good one, why do watermelons have water in them? ','',26124),
(16334,'enUS','It\'s too bad they don\'t stay cute.  There must be some rite of passage in the Barrens called, \"Climb ugly tree and fall out.\"','',26124),
(16335,'enUS','The tauren says, \"That\'s a load of bull.\"','',26124),
(16336,'enUS','Because they are planted in the spring!','',26124),
(16337,'enUS','Impersonation time!!  I call this, \"The Silly Tauren.\"','',26124),
(16338,'enUS','The comedian clears his throat.','',26124),
(16339,'enUS','What\'s the deal with women?  I mean they are always like...','',26124),
(16340,'enUS','And then gnomes are even worse!  They are always saying stuff like...','',26124),
(16341,'enUS','Thank you! Don\'t forget to tip your waiters! Good night folks.','',26124),
(16343,'enUS','Is it over already?  You\'ve been great folks.  Walk safely and have a good night.','',26124),
(16344,'enUS','You guys have been a great audience!  Have a good night!','',26124),
(16345,'enUS','Thank you everyone!  And keep clapping, there is a fly in here and one of you are bound to get it!  Good night!','',26124),
(16346,'enUS','Line up and crush these fools!','',26124),
(16347,'enUS','Form up! Let\'s make quick work of them!','',26124),
(16348,'enUS','Well, it\'s time to take these comedic muscles elsewhere. Have a good night all!','',26124),
(16349,'enUS','Get ready! This shouldn\'t take long...','',26124),
(16350,'enUS','Show them no quarter! Form up!','',26124),
(16351,'enUS','One last impersonation.  It\'s tough, but let\'s see if you can guess who it is...','',26124),
(16352,'enUS','Lok-Narash! Defensive positions!','',26124),
(16353,'enUS','Hold the line! They must not get through!','',26124),
(16354,'enUS','Gakarah ma!','',26124),
(16355,'enUS','We must halt their advance! Take your positions!','',26124),
(16356,'enUS','Fighter down!','',26124),
(16357,'enUS','Replacement, quickly!','',26124),
(16358,'enUS','Next warrior, now!','',26124),
(16359,'enUS','Fall in! Mok-thora ka!','',26124),
(16360,'enUS','Where\'s my support?','',26124),
(16361,'enUS','Next warrior, step up! ','',26124),
(16362,'enUS','Join the fight! Agrama-ka!','',26124),
(16363,'enUS','Wake up, we\'re under attack!','',26124),
(16364,'enUS','Sleep on your own time!','',26124),
(16365,'enUS','Get up!','',26124),
(16366,'enUS','On your feet!','',26124),
(16367,'enUS','No time for slumber! Join the fight!','',26124),
(16368,'enUS','What time is it when an elekk sits on your fence?','',26124),
(16369,'enUS','Time to get a new fence!!','',26124),
(16370,'enUS','My wife and I were happy for 23 years...','',26124),
(16371,'enUS','And then we met!','',26124),
(16372,'enUS','What do you call a broken boomerang?','',26124),
(16373,'enUS','A stick!','',26124),
(16374,'enUS','I love blood elf women.  Especially when they say stuff like this...','',26124),
(16375,'enUS','I\'ve heard that gnomes can grant wishes...','',26124),
(16376,'enUS','Well I wish they\'d go away!','',26124),
(16377,'enUS','Check out the comedy stylings of Perry Gatner in just a few minutes!','Check out the comedy stylings of Perry Gatner in just a few minutes!',26124),
(16378,'enUS','I never met a tauren I didn\'t like...','',26124),
(16379,'enUS','To eat!!','',26124),
(16380,'enUS','If you are ready to laugh, head over to the World\'s End Tavern!','If you are ready to laugh, head over to the World\'s End Tavern!',26124),
(16381,'enUS','Now that the show\'s done, can someone run me through Scarlet Monastery?','',26124),
(16382,'enUS','Hey all!  So how long until the jokes spawn?','',26124),
(16383,'enUS','Thank you all for coming tonight.  Now put your hands together to welcome Shattrath\'s best, Perry Gatner!','',26124),
(16384,'enUS','Perry Gatner! What an act!  The cantina is open all night long, so please, stay and enjoy yourselves!','',26124),
(16385,'enUS','Apparently my reputation with you people is hostile.','',26124),
(16386,'enUS','Can I get a buff? I\'m dying up here.','',26124),
(16387,'enUS','Come on!  These jokes are epic!','',26124),
(16388,'enUS','If I knew it was going to be like this, I\'d have worn my Greater Boots of Laughter.','',26124),
(16389,'enUS','Wow!  The laughs don\'t drop very often here, do they?','',26124),
(16390,'enUS','I\'m not gonna lie to you, soldiers. We\'re getting our butts kicked out there! Now which one of you is orc enough to do something about it?','',26124),
(16391,'enUS','The warchief\'s put a price on Arazzius\'s head! As of right now, that no-good piece of demon refuse is enemy number one.','',26124),
(16392,'enUS','Yea, we got problems. I think that\'s crystal clear. The question is, what are we gonna do about it?','',26124),
(16393,'enUS','How many more of you grunts do I need to send back to mommy and daddy in a body bag before you grow a brain and realize that runnin\' head first into a Legion kill squad is suicide? And don\'t nod your thick skulls at me as if you know what I\'m talkin\' about!','',26124),
(16394,'enUS','Get used to it, girls. We\'re out here for the rest of our miserable lives as far as I\'m concerned. Welcome to Hellfire Peninsula, your new home.','',26124),
(16395,'enUS','INCOMING! Do not let them through! Focus fire! NOW, NOW, NOW!','',26124),
(16396,'enUS','Bow to the might of the Doom Lord! You stand no chance!','',26124),
(16397,'enUS','Arzule will have this land in the name of our master!','',26124),
(16398,'enUS','Warbringers hear my call! Strike down at our enemies!','',26124),
(16399,'enUS','','Find a way to get me out of here, $c.',26124),
(16400,'enUS','Find a way to get me out of here, $c!','',26124),
(16401,'enUS','Training complete, sir. Our next batch of recruits are due shortly.','',26124),
(16402,'enUS','%s roars!','',26124),
(16403,'enUS','Thank you sir, though I cannot accept your praise without acknowledging the assistance of our guest, Emissary Mordin.','',26124),
(16404,'enUS','The techniques he has suggested have been most effective in preparing the troops.','',26124),
(16405,'enUS','By your leave, Lord Torvos. I must prepare the next troops for your review.','',26124),
(16406,'enUS','You\'re doing a fine job, Harbinger.','',26124),
(16407,'enUS','Word from the front lines is that your recruits outperform all others in battle.','',26124),
(16408,'enUS','On the contrary, my friend.','',26124),
(16409,'enUS','With the intelligence you\'ve provided on the enemy and their tactics we\'ve gained a significant edge in the field.','',26124),
(16410,'enUS','The fighting remains fierce and costly, but your assistance has proven invaluable.','',26124),
(16411,'enUS','Dismissed.','',26124),
(16412,'enUS','You give me too much credit, good sir. I regret we cannot be of more assistance in such perilous times.','',26124),
(16413,'enUS','This is welcome news indeed. I shall pass along your gratitude to our commanders back on Azeroth.','',26124),
(16414,'enUS','','Welcome. Will you take your rest here, or perhaps a meal?',26124),
(16416,'enUS','Look upon what you have accomplished, soldiers! Even the Legion\'s most fearsome machines are no match for the Horde!','',26124),
(16417,'enUS','Let them see what we have done to their fel reaver!','',26124),
(16418,'enUS','We war so that our little ones may live to see a better tomorrow! And for them, we destroy the Burning Legion!','',26124),
(16419,'enUS','Send more, demons! We will destroy them as we have this one!','',26124),
(16420,'enUS','For the Warchief! For the Horde!','',26124),
(16421,'enUS','Faster, scum!  The Master won\'t be pleased if we don\'t find the Ata\'mal crystal he\'s after.','',26124),
(16422,'enUS','Greatfather Winter will leave presents for everyone under the tree in Ironforge. I can\'t wait to get mine!','Greatfather Winter will leave presents for everyone under the tree in Ironforge. I can\'t wait to get mine!',26124),
(16423,'enUS','I hope I have a chance to visit with Greatfather Winter before Winter Veil is over.','I hope I have a chance to visit with Greatfather Winter before Winter Veil is over.',26124),
(16424,'enUS','Dig faster, wretch!  Do not force me to show you the true meaning of pain!','',26124),
(16425,'enUS','Do not stop!  I promise you a thousand deaths if you even think about putting down that pick!','',26124),
(16426,'enUS','What was THAT?','',26124),
(16427,'enUS','','We must discover what\'s behind the mystery of the giant crystal that fell from the heavens on Fallen Sky Ridge.',26124),
(16428,'enUS','Sometimes the straightforward approach to a problem is the best.','',26124),
(16429,'enUS','Master, I have failed...','',26124),
(16430,'enUS','If you\'re ever captured by the Legion, tell them \"Xar il romath da tidesbi.\" They will kill you instantly for insulting their god, saving you intolerable torture or worse...','',26124),
(16431,'enUS','I\'m on a bombing mission for Forward Commander To\'arch.  I need a wyvern destroyer!','I\'m on a bombing mission for Forward Commander To\'arch.  I need a wyvern destroyer!',26124),
(16432,'enUS','Impudent whelps, you only delay the inevitable. Where one has fallen, ten shall rise. Such is the will of Kazzak...','',26124),
(16433,'enUS','Time for fun!','',26124),
(16434,'enUS','To arms!  The colossi attack!','To arms!  The colossi attack!',26124),
(16435,'enUS','Wardens, defend the east entrance!','',26124),
(16436,'enUS','All clear.  Looks like the colossi attack has been repelled.','',26124),
(16437,'enUS','Quake, mortals!  Quake and kneel before your destroyer!','',26124),
(16438,'enUS','You dare interfere with the Master\'s endeavors?  You will pay, foolish mortal!','',26124),
(16439,'enUS','Slay these intruders, filthy Dreghood!  I promise you neverending pain if you disobey me!','',26124),
(16440,'enUS','Go, you little wretches!  Show these fools that our Master is not to be trifled with!','',26124),
(16441,'enUS','Do not even think of fleeing, Broken wretches!  I promise you a fate worse than death if you don\'t slay these intruders!','',26124),
(16442,'enUS','Thank you for freeing me, $n. Now let\'s get out of here!','',26124),
(16443,'enUS','','That\'s more like it! Let\'s get out of here!',26124),
(16444,'enUS','Smokywood Pastures has set up shop in Orgrimmar and Ironforge. I wonder what they\'ll dream up this year?','Smokywood Pastures has set up shop in Orgrimmar and Ironforge. I wonder what they\'ll dream up this year?',26124),
(16445,'enUS','Blonde hair, green skin, horn head, blue skin - all it means to us are new markets for our excellent goblin engineering! Even the prospect of another war against the Legion means more sales for us!','Blonde hair, green skin, horn head, blue skin - all it means to us are new markets for our excellent goblin engineering! Even the prospect of another war against the Legion means more sales for us!',26124),
(16446,'enUS','Troops! Fall out!','',26124),
(16447,'enUS','The druids are holding a great celebration of Lunar Festival in Moonglade. If that\'s too far to walk, they\'re transporting people from the big cities.','The druids are holding a great celebration of Lunar Festival in Moonglade. If that\'s too far to walk, they\'re transporting people from the big cities.',26124),
(16448,'enUS','Listen up Men!','',26124),
(16449,'enUS','Your training is now complete. You each have your assignments. May the Light guide you.','',26124),
(16450,'enUS','We\'re here to protect Gadgetzan interests in Un\'Goro and that\'s none of your business.','',26124),
(16451,'enUS','','Hellfire Peninsula is a shattered realm - ruthless and unforgiving to its inhabitants. Be sure to repair and stock up on supplies before venturing out.',26124),
(16452,'enUS','What do you have for sale?','What do you have for sale?',26124),
(16453,'enUS','How many more soldiers need to die before we start paying attention out there?','',26124),
(16454,'enUS','Do you think that demons will play fair? These beasts are more savage than orcs and more cunning than the undead. Do not attempt to engage Legion by normal standards of war.','',26124),
(16455,'enUS','I regret to inform you all that we sent home another ten soldiers today - in body bags.','',26124),
(16456,'enUS','This war - and don\'t mistake this for anything but a war - is not going to win itself. If we do not fight, scratch, claw, and kick for every speck of land on this shattered world, all will be lost.','This war - and don\'t mistake this for anything but a war - is not going to win itself. If we do not fight, scratch, claw, and kick for every speck of land on this shattered world, all will be lost.',26124),
(16457,'enUS','Keep your voice low and your eyes open, $n. We\'re surrounded by enemies out here.','',26124),
(16458,'enUS','You must use the incendiary bombs at the barrels inside the internment lodges of Durnholde Keep. Once five bombs have been ignited and the diversion has been set, find Thrall in the basement prison of Durnholde and set him free. Follow him and make sure that he does not die!$B$BBrazen will fly you to Durnholde when you are ready.','',26124),
(16459,'enUS','I can take you to Durnholde directly, if that is your wish.','',26124),
(16460,'enUS','You should receive a pack of incendiary bombs from Erozion before I fly you to Durnholde. You wouldn\'t want to waste time, after all.','',26124),
(16461,'enUS','I\'m ready to go to Durnholde Keep.','I\'m ready to go to Durnholde Keep.',26124),
(16462,'enUS','Horrible... just horrible!$B$BWe were minding our own business on our way from Area 52 in Netherstorm and they shot us down!  I knew we shouldn\'t have taken that shortcut to get to Terokkar Forest!','',26124),
(16463,'enUS','The goblins of Smokywood Pastures always have such wonderful treats for sale this time of year.','The goblins of Smokywood Pastures always have such wonderful treats for sale this time of year.',26124),
(16464,'enUS','Greatfather Winter will leave presents for everyone under the tree in Orgrimmar. I wonder what he\'ll bring me this year.','Greatfather Winter will leave presents for everyone under the tree in Orgrimmar. I wonder what he\'ll bring me this year.',26124),
(16465,'enUS','Legend says that the great beast Omen sleeps in the waters of Lake Elune\'ara in Moonglade, only to appear once a year. But that\'s just a legend.','Legend says that the great beast Omen sleeps in the waters of Lake Elune\'ara in Moonglade, only to appear once a year. But that\'s just a legend.',26124),
(16466,'enUS','During the Lunar Festival, we should take time to seek out our elders and consider their wisdom.','During the Lunar Festival, we should take time to seek out our elders and consider their wisdom.',26124),
(16467,'enUS','Have you seen the fireworks? This is the best time of year to buy them.','Have you seen the fireworks? This is the best time of year to buy them.',26124),
(16468,'enUS','The druids of Nighthaven are holding a great celebration in Moonglade for the Lunar Festival.','The druids of Nighthaven are holding a great celebration in Moonglade for the Lunar Festival.',26124),
(16469,'enUS','Forgive me... I have no choice.','',26124),
(16470,'enUS','I will do as you ask, demon.  At least for now.','',26124),
(16471,'enUS','Put me out of this misery!','',26124),
(16472,'enUS','Work these Broken wretches to the bones, Illidari!  If there\'s anything of value in this forsaken place we shall find it!','',26124),
(16473,'enUS','Expedition Point is the Alliance\'s closest point of contact with the Legion Front. North of here is nothin\' but demon, demon and more demon. Travel with a buddy.','',26124),
(16474,'enUS','Keep a close eye on this Broken scum!  Far too many have escaped from us!','',26124),
(16475,'enUS','We will find what the Master is looking for!  Failure is not an option!','',26124),
(16476,'enUS','Do not allow these wretches a moment of rest!  If there\'s an Ata\'mal crystal here then we shall find it!','',26124),
(16477,'enUS','Two sets of orders seem to have been hastily scribbled on this dispatch.','',26124),
(16478,'enUS','The Dark Portal opens once again! What does it portend?','The Dark Portal opens once again! What does it portend?',26124),
(16479,'enUS','The Burning Legion has returned! What can we do to stop them?','The Burning Legion has returned! What can we do to stop them?',26124),
(16481,'enUS','The Illidari demons keep me here because of my knowledge of ancient draenei crystals and relics.$B$BThey\'ve enslaved many of my people and use us to look for a powerful crystal... one that in all likelihood is not even here.','',26124),
(16482,'enUS','The draenei... it\'s almost too much to believe. But if they follow the Light, they can\'t be that bad.','The draenei... it\'s almost too much to believe. But if they follow the Light, they can\'t be that bad.',26124),
(16483,'enUS','How could the elves betray us? We were never the greatest of friends, but joining the Horde?','How could the elves betray us? We were never the greatest of friends, but joining the Horde?',26124),
(16484,'enUS','The Dark Portal coming alive? This can\'t be good.','The Dark Portal coming alive? This can\'t be good.',26124),
(16485,'enUS','Why don\'t you escape?','Why don\'t you escape?',26124),
(16486,'enUS','The Apothecary Society researches to find a cure against the plague of the Lich King..','The Apothecary Society researches to find a cure against the plague of the Lich King..',26124),
(16487,'enUS','What for?  If Illidan\'s demons don\'t catch me and enslave me again, then the naga of Zangarmarsh will.$B$BJoining Illidan and his allies has turned out to mean nothing but slavery to most of the Broken tribes.  There is no hope for my people.','',26124),
(16488,'enUS','With the Lich King on the offensive, the Horde must respond in kind!  To Northrend!','With the Lich King on the offensive, the Horde must respond in kind!  To Northrend!',26124),
(16489,'enUS','Sir, it appears that another of our special units have arrived.','',26124),
(16490,'enUS','Excellent. We must focus our efforts on the cleansing of Nagrand!','',26124),
(16491,'enUS','Understood, sir.','',26124),
(16492,'enUS','Listen up, soldiers!','',26124),
(16493,'enUS','You are here because you displayed exceptional aptitude and ability throughout your training period.','',26124),
(16494,'enUS','You are now to be dispatched directly into a hostile environment on a treacherous mission.','',26124),
(16495,'enUS','Nagrand, the land to the west, has recently become littered with enemy forge camps that threaten our security.','',26124),
(16496,'enUS','With the bulk of our forces focused on Illidan, the task of cleansing these lands falls to you.','',26124),
(16497,'enUS','You are to return in a week\'s time with a detailed report of your actions.','',26124),
(16498,'enUS','May the Light be with you... Dismissed!','',26124),
(16499,'enUS','Thrall startles the horse with a fierce yell!','',26124),
(16500,'enUS','I can\'t wait to see the newest goods from Smokywood Pastures.','I can\'t wait to see the newest goods from Smokywood Pastures.',26124),
(16501,'enUS','Ah, the Winter Wondervolt. What will we think of next?','Ah, the Winter Wondervolt. What will we think of next?',26124),
(16502,'enUS','Elves or draenei, just means more money for our engineers.','Elves or draenei, just means more money for our engineers.',26124),
(16503,'enUS','Where are all those wonderful winter hats coming from?','Where are all those wonderful winter hats coming from?',26124),
(16504,'enUS','I\'ll never take another shortcut again, I swear! How was I supposed to know the skies over Hellfire Peninsula were that dangerous?','',26124),
(16505,'enUS','By your leave, sir, I have pressing matters to attend to.','',26124),
(16506,'enUS','Anchorite Nindumen, I have a request to make of you.','',26124),
(16507,'enUS','We\'ve just sent another inexperienced squad into Nagrand. Might you offer a prayer for them?','',26124),
(16508,'enUS','Of course, Harbinger. Dismissed.','',26124),
(16509,'enUS','I wonder why the sporelings live under the bridge?','I wonder why the sporelings live under the bridge?',26124),
(16510,'enUS','Sporelings have pretty colors.','Sporelings have pretty colors.',26124),
(16511,'enUS','My mom said that if I don\'t get enough exercise, I could end up looking like a sporeling.','My mom said that if I don\'t get enough exercise, I could end up looking like a sporeling.',26124),
(16512,'enUS','Mom says not to feed the sporelings after midnight.','Mom says not to feed the sporelings after midnight.',26124),
(16513,'enUS','I wonder how Seth\'s mom is doing?','I wonder how Seth\'s mom is doing?',26124),
(16514,'enUS','Nurse Mildred is real nice, she took care of my dad when he was hurt.','Nurse Mildred is real nice, she took care of my dad when he was hurt.',26124),
(16515,'enUS','Sha\'nir said that I can help her when I get older.','Sha\'nir said that I can help her when I get older.',26124),
(16516,'enUS','The dumb boys think this is a good hiding place.','The dumb boys think this is a good hiding place.',26124),
(16517,'enUS','The boys like to hide here. I think they are afraid to actually climb the bridge.','The boys like to hide here. I think they are afraid to actually climb the bridge.',26124),
(16518,'enUS','I heard one of the boys say he wished he could live in a tree. I want to live in a tree too!','I heard one of the boys say he wished he could live in a tree. I want to live in a tree too!',26124),
(16519,'enUS','There are so many cute, little rats!','There are so many cute, little rats!',26124),
(16520,'enUS','I love their little whiskers!','I love their little whiskers!',26124),
(16521,'enUS','Of course, my friend. How can I be of service to you?','',26124),
(16522,'enUS','Those smelly boys love scaring the poor, cute, little rats.','Those smelly boys love scaring the poor, cute, little rats.',26124),
(16523,'enUS','Those boys always come over here and cause trouble and scare the poor, little rats.','Those boys always come over here and cause trouble and scare the poor, little rats.',26124),
(16524,'enUS','A noble request. It would be an honor, Erothem.','',26124),
(16525,'enUS','I taught one of the rats to wave.','I taught one of the rats to wave.',26124),
(16526,'enUS','My friends, please join me in humble supplication to the Light.','',26124),
(16527,'enUS','I wonder where the baby is?','I wonder where the baby is?',26124),
(16528,'enUS','Look, one of the eggs hatched!','Look, one of the eggs hatched!',26124),
(16529,'enUS','I want to see the baby!','I want to see the baby!',26124),
(16530,'enUS','A baby arakkoa must be the cutest thing ever!','A baby arakkoa must be the cutest thing ever!',26124),
(16531,'enUS','Light that we embrace, we beseech thee...','',26124),
(16532,'enUS','','Hurry up with that axe, you! I want it sharp enough to cut the wind!',26124),
(16533,'enUS','Into our struggle against the darkness we have sent our children.','',26124),
(16534,'enUS','Please bless and protect them, and grant them success over those who seek to do us harm...','',26124),
(16535,'enUS','Continue to bless this, our ancient home, we beg.','',26124),
(16536,'enUS','Bless us with tolerance for our elven visitors.','',26124),
(16537,'enUS','By the Naaru, may it be so.','',26124),
(16538,'enUS','','If you\'re no good at fixing, we\'ll see if you\'re good for eating. Now WORK!',26124),
(16539,'enUS','','He\'s sort of a cute little thing, really. I think I\'ll keep him.',26124),
(16540,'enUS','I don\'t understand you!','',26124),
(16541,'enUS','Please don\'t beat me!','',26124),
(16542,'enUS','You know, this is really sort of exciting me.','',26124),
(16543,'enUS','Show me where the Winter Veil celebration is happening.','Show me where the Winter Veil celebration is happening.',26124),
(16544,'enUS','May it be so.','May it be so.',26124),
(16545,'enUS','Marshals... brothers and sisters of the sword.  I\'d rather fight alongside you than any army of thousands.  We are lions!  You know what\'s waiting through these demons and beyond that Dark Portal?  Immortality!  Take it!','',26124),
(16546,'enUS','Let us therefore brace ourselves to our duty, and so bear ourselves, that if the Humans of Azeroth last for a thousand years, men will still say, \'This was their finest hour.','',26124),
(16547,'enUS','It is time for us as kingdoms and as individuals to set aside our long-standing feuds and unite. The tides of an unwinnable war are upon us, and we must seek refuge on higher ground, lest we be swept away by the flood of darkness.','',26124),
(16548,'enUS','Yes. Fight and you may die. Run and you will live, but for how long?  The devils are upon us!  And those not here, dying in their villages weeks from now, would they be willing to trade all the days from this day to that, for one chance to come here and stop these horrors from invading our world?\n','',26124),
(16549,'enUS','Everyone fights.  No one quits.','',26124),
(16550,'enUS','Hold your ground! Hold your ground! Sons of the Alliance!  Of the Horde! My brothers and sisters!  I see in your eyes the same fear that would wither my own heart. A day may come when our courage fails, when we forsake our friends and break our fellowships... but it is not this day.','',26124),
(16551,'enUS','This day we fight!! By all that you hold dear in these good lands, I bid you stand, heroes of Azeroth!','',26124),
(16552,'enUS','We few, we happy few, we band of brothers and sisters.  For those today that shed their blood with me, Shall be my kin; be they never so vile, This day shall gentle their conditions.','',26124),
(16553,'enUS','And those in Azeroth now a-bed shall think themselves accursed they were not here,  And hold their valor cheap whiles any speaks that fought with us upon this dark day.','',26124),
(16554,'enUS','Work faster! We need these catapults ready for an attack!','Work faster! We need these catapults ready for an attack!',26124),
(16555,'enUS','Salvage what you need from the broken catapults!','Salvage what you need from the broken catapults!',26124),
(16556,'enUS','The next one of you peons that messes up will spend a night patrolling the cursed perimeter!','The next one of you peons that messes up will spend a night patrolling the cursed perimeter!',26124),
(16557,'enUS','If I see any lazy peons here, I\'ll load them into a catapult and launch them off to the Black Temple!','If I see any lazy peons here, I\'ll load them into a catapult and launch them off to the Black Temple!',26124),
(16558,'enUS','Keep up the pace!','Keep up the pace!',26124),
(16559,'enUS','Any time any of you peons want to take a break, the graveyard is right over there.','Any time any of you peons want to take a break, the graveyard is right over there.',26124),
(16560,'enUS','Sir, I am here to deliver my report from the Scryer\'s Tier.','',26124),
(16561,'enUS','Sir, it\'s impossible to read anything into their actions.','',26124),
(16562,'enUS','Their movements are totally chaotic, as if they themselves know not what they are about.','',26124),
(16563,'enUS','My apologies, sir. I wish I had more to report.','',26124),
(16564,'enUS','As you command, sir.','',26124),
(16565,'enUS','Well, out with it, neophyte...','',26124),
(16566,'enUS','It is exactly as I expected, soldier. They know we watch them closely.','',26124),
(16567,'enUS','They mask their intentions with meaningless movements to confuse us.','',26124),
(16568,'enUS','In time, you may learn to see through their deceptions.','',26124),
(16569,'enUS','Until then, your presence at your post will keep them on their toes.','',26124),
(16570,'enUS','Harder! Faster! Stronger!','',26124),
(16571,'enUS','At this rate you will not survive.','',26124),
(16572,'enUS','Worthless!  You are completely worthless!','',26124),
(16573,'enUS','INFERNAL RAIN ON THE RISE! TAKE COVER!','',26124),
(16574,'enUS','INFERNALS! CLEAR THE COURTYARD!','',26124),
(16575,'enUS','WE\'RE UNDER ATTACK! RUN FOR COVER!','',26124),
(16576,'enUS','Tear it down, soldiers! We\'re shippin\' this thing back to Stormwind!','',26124),
(16577,'enUS','We\'re gonna melt this hunk of junk down and make weapons with the ingots! Let\'s see how the Legion likes a taste of fel reaver served up Alliance style!','',26124),
(16578,'enUS','Well done, soldiers! We weren\'t about to let the filthy animals of the Horde show us up!','',26124),
(16579,'enUS','Let them throw another one of these overgrown tin cans at us! We\'ll show them what the Alliance is made of!','',26124),
(16580,'enUS','The comedian impersonates a tauren.','',26124),
(16581,'enUS','The comedian impersonates a gnome.','',26124),
(16582,'enUS','The comedian impersonates a blood elf.','',26124),
(16583,'enUS','The comedian impersonates a human female.','',26124),
(16584,'enUS','The comedian impersonates an orc.','',26124),
(16586,'enUS','Bron! \'Ey, Bron! Hit me!','',26124),
(16587,'enUS','%s blinks, a perplexed expression crossing his face.','',26124),
(16588,'enUS','What, with me fists?','',26124),
(16589,'enUS','Nae, that\'s fer wimps. Hit me with yer hammer!','',26124),
(16590,'enUS','I\'m... not sure that\'s a good idea, \'Moke. Ye might get hurt...','',26124),
(16591,'enUS','DO IT, YE PANSY!','',26124),
(16592,'enUS','Er... \'Moke?','',26124),
(16593,'enUS','...THAT WAS GREAT!','',26124),
(16594,'enUS','Hungarfen roars in pain. ','Hungarfen roars in pain. ',26124),
(16595,'enUS','<A soothing light fills you as you approach the naaru.  Slow musical chimes echo within your mind and, though a word is not uttered, you feel an assurance of safety.  You are welcome in Shattrath City.>','',26124),
(16596,'enUS','Alright now, let\'s get those rifles sighted in...','',26124),
(16597,'enUS','Move along unless you\'ve got business with the fleet.','',26124),
(16598,'enUS','Tell me about light bombs and carpet bombing.','Tell me about light bombs and carpet bombing.',26124),
(16599,'enUS','Carpet bombing refers to dropping a very large number of bombs on an area, essentially carpetting the region with bombs.$B$BBombers often use several light bombs on a region and then use heavy bombs to clean up whatever might still be standing.','',26124),
(16600,'enUS','Carpet bombing is for me. I\'m ready to fly!','Carpet bombing is for me. I\'m ready to fly!',26124),
(16601,'enUS','Tell me about something else.','Tell me about something else.',26124),
(16602,'enUS','Tell me about heavy bombs.','Tell me about heavy bombs.',26124),
(16603,'enUS','When you absolutely, positively must kill NOW, the heavy bomb is the way to go. Heavy bombs have a much larger radius and cause much more damage. The downside is that you can carry far fewer heavy bombs than you can light bombs and you must wait longer between uses.\n','',26124),
(16604,'enUS','I\'m the heavy bomb master. Send me up!','I\'m the heavy bomb master. Send me up!',26124),
(16605,'enUS','Uhh, whoops...','',26124),
(16606,'enUS','...at least we know my rifle is sighted properly.','',26124),
(16607,'enUS','Soldier...','',26124),
(16608,'enUS','You DO know that marksmen are issued blanks for practice drills, right?','',26124),
(16609,'enUS','Clearly, this group is not ready for weapons exercises.','',26124),
(16610,'enUS','Fall in for some marching practice! Let\'s see if we can manage to walk without suffering any casualties...','',26124),
(16611,'enUS','Spare a copper, $G sir:madam;?','Spare a copper, $G sir:madam;?',26124),
(16612,'enUS','Hey, $G man:lady;? Got some money?  I got five kids to feed!','Hey, $G man:lady;? Got some money?  I got five kids to feed!',26124),
(16613,'enUS','Please don\'t ignore us...','Please don\'t ignore us...',26124),
(16614,'enUS','Any spare copper?','Any spare copper?',26124),
(16615,'enUS','Send me to the Abyssal Shelf!','Send me to the Abyssal Shelf!',26124),
(16616,'enUS','Hunters, to me! Let us show these demons what it is to fight and die in Azeroth!','',26124),
(16617,'enUS','The spirits sing to us!  They sing the song of battle!','',26124),
(16618,'enUS','Strike true, brothers and sisters!  Today our quarry is demons!','',26124),
(16619,'enUS','Defenders of the Argent Dawn!  We are with you!','',26124),
(16620,'enUS','Once again, we will show this Burning Legion that our world is not for the taking!','',26124),
(16621,'enUS','These fiends will fail!  For Azeroth!','',26124),
(16622,'enUS','If it is our fate to die this day, then we will not go easy!  Mark me, these demons will fall like wheat!','',26124),
(16623,'enUS','Fight on, and let our ancestors see the bravery and strength we hold!  Today our hunt is for them, and for our world!','',26124),
(16624,'enUS','Though your sinews tire and your blood flows from cuts and wounds to this sodden ground, you fight for the spirits of your world.  No evil force can stand against us!','',26124),
(16625,'enUS','Soldiers of Azeroth, you now fight against the vile Burning Crusade.  And the hopes and prayers of all Light-loving people march with you.  In the company of our brave allies and brothers-in-arms you will hold your ground and break this demonic charge.  You will stem the destructive tyranny that rages across so many worlds.','',26124),
(16626,'enUS','We shall take up this grim task in high spirits, and be sure that our cause will not be suffered to fail.  Welcome the aid of your brethren, and of your once heated foes - let us all go forward together with our united strength, and know victory this day!','',26124),
(16627,'enUS','The demons should be in no doubt that we are their nemesis and, though they wish our destruction, it is we who will bring about their ruin.  Kazzak and his forces will be diminished and defeated by this coalition.  And to do this, we must throw at them our bodies and hearts, for they seek no less than the obliteration of this world.','',26124),
(16628,'enUS','The strength, the wisdom, the unending endurance of the peoples of Azeroth inspires those beyond your reckoning.  On this day, this day of blood and terror, I see that yours is a world of heroes!','',26124),
(16629,'enUS','The demons, our old foes from eons passed, once again show their beastly visage.  But do not falter, for fear is one of their many weapons.  And a weapon most deadly it is.','',26124),
(16630,'enUS','Strength!  My new brothers and sisters!  Beat back these devils for the sake of your world.  Hold here, and your friends and allies will come and weigh their swords with you!','',26124),
(16631,'enUS','Yes!  Hold your feet firm!  Lend aid to your cohorts and together our banded strength will overcome these demons!  Cling fiercely to hope and grip tightly your weapons, and trust that the Light will pierce this darkness and shine through to morrow\'s dawn!','',26124),
(16632,'enUS','Fight on!  Fight on!  And know that blood shed this day mingles with the blood of heroes.  Even in death, our spirits will know the victory of saving your kin and your world.  Do not succumb to despair, friends, for the demons against whom we face will surely take pleasure in it.','',26124),
(16633,'enUS','With each passing moment, I see the people of Azeroth prove again the reasons we have come.  It is with solemn pride that I fight with you, and if I die this day, then I die among friends.','',26124),
(16634,'enUS','That was some pretty fancy prancin\' ladies!','',26124),
(16635,'enUS','Now let\'s give shootin\' another try...','',26124),
(16636,'enUS','Get into formation and get those guns sighted in!','',26124),
(16637,'enUS','Carefully now, we don\'t need any more mista-','',26124),
(16638,'enUS','Oh, that was cute...','',26124),
(16639,'enUS','We\'ll be marching all day if I see any more of that!','',26124),
(16640,'enUS','In fact, let\'s see some more of that fancy walkin\'... Move it!','',26124),
(16641,'enUS','Again, very nice strutting ladies.','',26124),
(16642,'enUS','If we can\'t teach you to shoot, you\'ll have a career in the cantina to fall back on.','',26124),
(16643,'enUS','What\'s this? You\'ve shifted into an incorrect formation!','',26124),
(16644,'enUS','You are only to use the staggered formation just before atta-','',26124),
(16645,'enUS','Enough messing around! There\'s a war going on here!','',26124),
(16646,'enUS','%s begins to grow stronger.','',26124),
(16647,'enUS','The surface of the %s begins to bubble.','',26124),
(16648,'enUS','What a good looking crowd. The dwarven women even shaved.','',26124),
(16649,'enUS','I just flew in from Ironforge and, Boy!, are my mount\'s wings tired!','',26124),
(16650,'enUS','I know what you\'re up to, and I mean to put an end to it, permanently!','',26124),
(16651,'enUS','Last week I was in Goldshire. Have you been there?','',26124),
(16652,'enUS','That town\'s so small, I asked a kid to draw me a map. He drew it on the back of a Defias wanted poster...','',26124),
(16653,'enUS','to scale!!','',26124),
(16654,'enUS','She\'s a beaut\', isn\'t she? Sky\'ree... the faithful gryphon of our commander. Kurdran himself, he holds his audiences in th\' stronghold. I care fer our Sky\'ree here when he\'s busy. Gorgeous creature, she is; as strong and fierce as they come. She\'d die fer Kurdran, she would. A more loyal soul ye\'ve ne\'er seen.\n\n\'Tis an honor to care fer her, it is.','',26124),
(16655,'enUS','Goldshire\'s inn advertises a lakeside view...','',26124),
(16656,'enUS','I saw a murloc swim by my window.','',26124),
(16657,'enUS','How many kobolds does it take to change a lantern wick?','',26124),
(16658,'enUS','You no take candle!','',26124),
(16659,'enUS','Time to bleed!','',26124),
(16660,'enUS','Run, you blasted cowards!','',26124),
(16661,'enUS','Hey, it\'s Raliq the drunk... His momma\'s so fat, when she flies to Blade\'s Edge they charge her by the pound!','',26124),
(16662,'enUS','No more meddling for you!','',26124),
(16663,'enUS','You will not interfere!','',26124),
(16664,'enUS','Thrall... must not... go free.','',26124),
(16665,'enUS','Look who\'s here, it\'s Raliq the drunk... His momma\'s so fat dragons won\'t eat her...','',26124),
(16666,'enUS','They don\'t know where to store the leftovers!','',26124),
(16667,'enUS','Hey! Hey! Hey! It\'s Raliq the drunk... His momma\'s so fat she didn\'t just make the front cover of Ogre Today...','',26124),
(16668,'enUS','She made the back cover too!','',26124),
(16669,'enUS','The gnomes used to be a nice respectful people...','',26124),
(16670,'enUS','The other day I saw one walking down the street shouting, \"Once you go gnome, you never go home!\"','',26124),
(16671,'enUS','Used to be you couldn\'t trust a goblin...','',26124),
(16672,'enUS','Who am I kiddin\'? If you trade with goblins you\'d better have iron plating in your coinpurse.','',26124),
(16673,'enUS','You\'re a slave! That\'s all you\'ll ever be!','',26124),
(16674,'enUS','I don\'t know what Blackmoore sees in you. For my money you\'re just another ignorant savage!','',26124),
(16675,'enUS','Thrall will never be free!','',26124),
(16676,'enUS','Did you really think you would leave here alive?','',26124),
(16677,'enUS','Guards... guards!','',26124),
(16678,'enUS','Is it just me, or is the Horde about the ugliest enemy we could find?','',26124),
(16679,'enUS','Just so you guys don\'t feel left out, all I said was how attractive the blood elves are.  It loses something in the translation.','',26124),
(16680,'enUS','How desperate do you have to be for allies that you recruit your livestock?','',26124),
(16681,'enUS','I own a dog, but I\'m not giving him a sword.','',26124),
(16682,'enUS','So the blood elves think they\'re just one step away from ruling the world...','',26124),
(16683,'enUS','Twelve steps is more like it!','',26124),
(16684,'enUS','WORK FASTER!','',26124),
(16685,'enUS','Work, you filthy swine!','',26124),
(16686,'enUS','Put your backs into it, you lazy peons!','',26124),
(16687,'enUS','I want those catapults built YESTERDAY!','',26124),
(16688,'enUS','Hurry it up! Work, WORK!','',26124),
(16689,'enUS','What we fire from this thing, anyway?','',26124),
(16690,'enUS','Me not know. The overseer, me hope!','',26124),
(16691,'enUS','Not so fast!','',26124),
(16692,'enUS','Struggle as much as you like...','',26124),
(16693,'enUS','You cannot fight fate!','',26124),
(16694,'enUS','You are... irrelevant.','',26124),
(16695,'enUS','Thrall will remain a slave. Taretha will die. You have failed.','',26124),
(16696,'enUS','No! The master will... not be... pleased.','',26124),
(16697,'enUS','We are the true Horde!','We are the true Horde!',26124),
(16698,'enUS','For Kargath!  For Victory!','For Kargath!  For Victory!',26124),
(16699,'enUS','Gakarah ma!','Gakarah ma!',26124),
(16700,'enUS','The blood is our power! ','The blood is our power! ',26124),
(16701,'enUS','Lok\'tar Illadari!\n','Lok\'tar Illadari!\n',26124),
(16702,'enUS','This world is OURS!','This world is OURS!',26124),
(16703,'enUS','Lok narash!','Lok narash!',26124),
(16704,'enUS','Move those crates, peon!','',26124),
(16705,'enUS','Heft those barrels!','',26124),
(16706,'enUS','Get the arms and armor shipments unpacked!','',26124),
(16707,'enUS','Peon! Unpack the food and medical supplies!','',26124),
(16708,'enUS','For the Master!','For the Master!',26124),
(16709,'enUS','Illidan reigns! ','Illidan reigns! ',26124),
(16710,'enUS','Die, warmblood!','Die, warmblood!',26124),
(16711,'enUS','By Nazjatar\'s Depths! ','By Nazjatar\'s Depths! ',26124),
(16712,'enUS','My blood is like venom!','My blood is like venom!',26124),
(16713,'enUS','Ugh...That hurt... Where are my friends?  I need to get back into the fight...','Ugh...That hurt... Where are my friends?  I need to get back into the fight...',26124),
(16714,'enUS','Where do you think you are you going soldier?  Those are fatal wounds you\'ve got there.  Now, get back in that tent and let the nurse treat you!','Where do you think you are you going soldier?  Those are fatal wounds you\'ve got there.  Now, get back in that tent and let the nurse treat you!',26124),
(16715,'enUS','Sir!  If I don\'t get out there and fight for Azeroth, then why am I in this army? I enlisted to do a job, and I intend to see it through.','Sir!  If I don\'t get out there and fight for Azeroth, then why am I in this army? I enlisted to do a job, and I intend to see it through.\n',26124),
(16716,'enUS','In Terokk\'s name!','In Terokk\'s name!',26124),
(16717,'enUS','Protect the Veil!','Protect the Veil!',26124),
(16718,'enUS','Darkfire -- avenge us!','Darkfire -- avenge us!',26124),
(16719,'enUS','Ssssekk-sara Rith-nealaak!','Ssssekk-sara Rith-nealaak!',26124),
(16720,'enUS','Arak-ha!','Arak-ha!',26124),
(16721,'enUS','What have the netherwinds brought us?','',26124),
(16722,'enUS','You\'re far from home, stranger.','',26124),
(16723,'enUS','Welcome to the Void...','',26124),
(16724,'enUS','If you hear the whisper, you\'re dying...','',26124),
(16725,'enUS','Thank you for speaking to the men, Almonen. They\'ll be better for it.','',26124),
(16726,'enUS','It would be an honor, Grand Anchorite.','',26124),
(16727,'enUS','Lieutenant General. The peons are working day and night to organize and ready the supplies from Orgrimmar. There is still much to be done, but we are an hour ahead of schedule.','',26124),
(16728,'enUS','Excellent. Continue your good work, Supply Master. Dismissed.','',26124),
(16729,'enUS','My magical power can turn back time to before Thrall\'s death, but be careful. My power to manipulate time is limited.','',26124),
(16730,'enUS','Now get out of my way, it\'s time to send the Burning Legion back to the nether!!','Now get out of my way, it\'s time to send the Burning Legion back to the nether!!',26124),
(16731,'enUS','I have set back the flow of time just once more.  If you fail to prevent Thrall\'s death, then all is lost.','',26124),
(16732,'enUS','Friends... I\'ve failed you...','Friends... I\'ve failed you...',26124),
(16733,'enUS','Your thanks are unnecessary, my friend. I consider it a privilege to speak to your recruits.','',26124),
(16734,'enUS','A\'dal has opened my mind to truths that I am to impart to our patrons today.','',26124),
(16735,'enUS','Friends, it is my great pleasure to welcome you to the temple today.','',26124),
(16736,'enUS','Sniff... That\'s the spirit soldier... I only wish we had more soldiers like you in this army.  Now go out there and give \'em hell!!','Sniff... That\'s the spirit soldier... I only wish we had more soldiers like you in this army.  Now go out there and give \'em hell!!',26124),
(16737,'enUS','NOOOOOOOOOO!!','NOOOOOOOOOO!!',26124),
(16738,'enUS','No my friend... we failed you... we failed you.','No my friend... we failed you... we failed you.',26124),
(16739,'enUS','NEVER AGAIN!! Next time some wounded soldier wants to return to the front line, I am putting my foot down.  I mean it this time.','NEVER AGAIN!! Next time some wounded soldier wants to return to the front line, I am putting my foot down.  I mean it this time.\n',26124),
(16740,'enUS','A\'dal has been most generous in his revelations to me, a humble servant of the Light.','',26124),
(16741,'enUS','In accordance with my divine calling, I must share these revealed truths to all who would hear.','',26124),
(16742,'enUS','It has been made known to me that inside each of us, the Light resides...','',26124),
(16743,'enUS','...that it is a gift, given freely to all naturally born beings.','',26124),
(16744,'enUS','%s defends himself in desperation.','',26124),
(16745,'enUS','You are welcome to remain in attendance.','',26124),
(16746,'enUS','%s smells a fresh corpse nearby.','',26124),
(16747,'enUS','Oh! So sorry. How terribly embarrassing! I didn\'t realize... ah... please, lie down, get some more rest.','',26124),
(16748,'enUS','Ah, Lieutenant General Orion. I\'ve come to report that casualties are well within acceptable levels for this operation. In fact, the wounded are quite... ah... lively.','',26124),
(16749,'enUS','Oh dear, Lieutenant General, how ghastly! I would most certainly never. I shall return to my charges, now.','',26124),
(16750,'enUS','This is good news. Return to them, priest. But heed this: do not eat ANYONE.','',26124),
(16751,'enUS','AIEEE! What are you doing?! I\'m still ALIVE, damn you!','',26124),
(16752,'enUS','It manifests itself as a feeling, small at first and easily ignored, that confirms truths and subtly prods one to do good.','',26124),
(16753,'enUS','Simple kindnesses, charitable deeds, service to those in need. These are all fruits of the Light.','',26124),
(16754,'enUS','It rewards those who heed its promptings with blessings, both seen and unseen.','',26124),
(16755,'enUS','Personal reservoirs of hope and faith are strengthened, and one\'s capacity for greater light increases.','',26124),
(16756,'enUS','Over the course of time, through obedience to the Light\'s guidance, one becomes more sensitive to its voice, and its power.','',26124),
(16757,'enUS','Great is the healing and blessing power of the Light\'s most diligent followers.','',26124),
(16758,'enUS','Come on!  Our boys are out there and they need these supplies ready!','Come on!  Our boys are out there and they need these supplies ready!',26124),
(16759,'enUS','Keep up the pace boys!  We need these supplies moved and weapons fixed!','Keep up the pace boys!  We need these supplies moved and weapons fixed!',26124),
(16760,'enUS','Let\'s pick up the pace!  These ballistas aren\'t going to fix themselves!','Let\'s pick up the pace!  These ballistas aren\'t going to fix themselves!',26124),
(16761,'enUS','Sadly, there are those who wander through mortality in defiance of the Light.','',26124),
(16762,'enUS','From these the Light withdraws, until only darkness remains.','',26124),
(16763,'enUS','Where there is no light, despair, loathing and rage thrive.','',26124),
(16764,'enUS','We are born into a perilous age, where the forces of darkness are determined to bring about our destruction.','',26124),
(16765,'enUS','These are the times to find yourselves in unison with the Light.','',26124),
(16766,'enUS','Hear my words, and let the Light inside of you confirm the truth of them.','',26124),
(16767,'enUS','Light, give me strength.','Light, give me strength.',26124),
(16768,'enUS','We humbly entrust our fallen brothers and sisters into the Light.  In this life you embraced them with your tender love; deliver them now from every evil and bid them enter eternal rest.','We humbly entrust our fallen brothers and sisters into the Light.  In this life you embraced them with your tender love; deliver them now from every evil and bid them enter eternal rest.',26124),
(16769,'enUS','Light, lead the fallen from untruth to truth, from darkness to Light and from death to immortality.','Light, lead the fallen from untruth to truth, from darkness to Light and from death to immortality.',26124),
(16770,'enUS','Light be with you now and forever.','Light be with you now and forever.',26124),
(16771,'enUS','%s\'s eyes glow red as he begins to cackle madly!','',26124),
(16772,'enUS','The priest kneels in silent prayer.','The priest kneels in silent prayer.',26124),
(16773,'enUS','Haven\'t you done enough harm?  Must you also disturb my slumber?','',26124),
(16774,'enUS','What good does this violence serve?  What is done is done.  I have failed my people.','',26124),
(16775,'enUS','Embrace the light that is in you, my friends! Deny yourself all darkness...','',26124),
(16776,'enUS','We must endure these trying times faithfully, and one day we will find ourselves victorious.','',26124),
(16777,'enUS','It falls upon us to usher in an age of peace, where the Light will reign.','',26124),
(16778,'enUS','By the naaru, may it be so.','',26124),
(16779,'enUS','May it be as you say, Grand Anchorite.','',26124),
(16780,'enUS','May it be so.','May it be so.',26124),
(16781,'enUS','You are spotted by the %s!','',26124),
(16782,'enUS','%s attempts to bind the spirit of his fallen comrade.','',26124),
(16783,'enUS','Do as I say, Fly!','Do as I say, Fly!',26124),
(16784,'enUS','Protect the Botanica at all costs!','',26124),
(16785,'enUS','Any intruders must be eliminated!','',26124),
(16786,'enUS','Kael\'thas will save us.','',26124),
(16787,'enUS','The time has come! Gul\'dan, order your warlocks to double their efforts! Moments from now the gateway will open and your Horde will be released upon this ripe, unsuspecting world!','',26124),
(16788,'enUS','You will rest with the honored dead.','You will rest with the honored dead.',26124),
(16789,'enUS','What is this? Champions... I sense the hand of the Dark One. Truly this sacred event bears his blessing.','',26124),
(16790,'enUS','No! Damn this feeble, mortal coil!','',26124),
(16791,'enUS','You have chosen death.','You have chosen death.',26124),
(16792,'enUS','Champions! My shield grows weak!','',26124),
(16793,'enUS','You will pay for this violation.','You will pay for this violation.',26124),
(16794,'enUS','My powers must be concentrated on the portal! I do not have time to hold the shield!','',26124),
(16795,'enUS','The shield is nearly gone! All that I have worked for is in danger!','',26124),
(16796,'enUS','I am grateful for your aid, champions. Now, Gul\'dan\'s Horde will sweep across this world like a locust swarm, and all my designs, all my carefully-laid plans will at last fall into place.','',26124),
(16797,'enUS','Shhh! The spirits are sleeping!','Shhh! The spirits are sleeping!',26124),
(16798,'enUS','Ruin finds us all!','Ruin finds us all!',26124),
(16799,'enUS','In Sargeras\' name!','In Sargeras\' name!',26124),
(16800,'enUS','The end comes for you!','The end comes for you!',26124),
(16801,'enUS','I do as I must!','I do as I must!',26124),
(16802,'enUS','The Legion reigns!','The Legion reigns!',26124),
(16803,'enUS','I shall be rewarded!','I shall be rewarded!',26124),
(16804,'enUS','A cool breeze caresses your face. Gentle, melodic humming resonates throughout the chamber.\n','',26124),
(16805,'enUS','This world shall burn!','This world shall burn!',26124),
(16806,'enUS','Greetings, traveler, I wish to thank you for lifting the exarch\'s hold. Ah, A\'dal has sent you?','',26124),
(16807,'enUS','The end is come!','The end is come!',26124),
(16808,'enUS','Embrace the Nothing!','Embrace the Nothing!',26124),
(16809,'enUS','Pathetic worm!','Pathetic worm!',26124),
(16810,'enUS','None can stand against the Legion!','None can stand against the Legion!',26124),
(16811,'enUS','I\'ll feast on your soul!','I\'ll feast on your soul!',26124),
(16812,'enUS','You shall not escape.','You shall not escape.',26124),
(16813,'enUS','The only justice is death!','The only justice is death!',26124),
(16814,'enUS','Why do you aid the Magus? Just think of how many lives could be saved if the portal is never opened, if the resulting wars could be erased....','',26124),
(16815,'enUS','If you will not cease this foolish quest, then you will die!','',26124),
(16816,'enUS','Time... is on our side.','',26124),
(16817,'enUS','You have outstayed your welcome, Keeper. Be gone!','',26124),
(16818,'enUS','I told you it was a fool\'s quest!','',26124),
(16819,'enUS','Leaving so soon?','',26124),
(16820,'enUS','Group one, load up and take your positions!','',26124),
(16821,'enUS','Why do you persist? Surely you can see the futility of it all. It is not too late! You may still leave with your lives...','',26124),
(16822,'enUS','So be it... you have been warned.','',26124),
(16823,'enUS','My death means... little.','',26124),
(16824,'enUS','Keeper! The sands of time have run out for you.','',26124),
(16825,'enUS','You should have left when you had the chance.','',26124),
(16826,'enUS','Your days are done.','',26124),
(16827,'enUS','The time has come to shatter this clockwork universe forever! Let us no longer be slaves of the hourglass! I warn you: those who do not embrace this greater path shall become victims of its passing!','',26124),
(16828,'enUS','Let us see what fate has in store....','',26124),
(16829,'enUS','Your time is up, slave of the past.','',26124),
(16830,'enUS','We will triumph. It is only a matter... of time.','',26124),
(16831,'enUS','One less obstacle in our way!','',26124),
(16832,'enUS','No one will stop us!','',26124),
(16833,'enUS','Fire at will!','',26124),
(16834,'enUS','Units, cease fire! Group two, lets see if you can do any better...','',26124),
(16835,'enUS','What... What have I become? Arrrgghhh...','What... What have I become? Arrrgghhh...',26124),
(16836,'enUS','Thank you...','Thank you...',26124),
(16837,'enUS','The cold embrace awaits...','The cold embrace awaits...',26124),
(16838,'enUS','It comes for you...','It comes for you...',26124),
(16839,'enUS','It cannot be...','It cannot be...',26124),
(16840,'enUS','What is this trickery? I... ARGH...','What is this trickery? I... ARGH...',26124),
(16841,'enUS','Ancestors watch over you, kind one...','Ancestors watch over you, kind one...',26124),
(16842,'enUS','I\'ve seen enough. If I were you, I\'d get to the temple and pray that you shoot straighter when it counts!','',26124),
(16843,'enUS','%s attempts to flee to a nearby ravager.','%s attempts to flee to a nearby ravager.',26124),
(16844,'enUS','','What did Garrosh tell you, $n?',26124),
(16845,'enUS','Garrosh is beyond redemption, Greatmother. I fear that in helping the Mag\'har, I have convinced Garrosh that he is unfit to lead.\n','Garrosh is beyond redemption, Greatmother. I fear that in helping the Mag\'har, I have convinced Garrosh that he is unfit to lead.\n',26124),
(16846,'enUS','','This can\'t be. He can\'t just give up like this. Why has he asked that you take his place as warchief?',26124),
(16847,'enUS','Greatmother, he tells me that the Mag\'har all love, honor, and trust me. He states that with me as warchief, he will be free to die when you pass, erasing his bloodline from existence.','Greatmother, he tells me that the Mag\'har all love, honor, and trust me. He states that with me as warchief, he will be free to die when you pass, erasing his bloodline from existence.',26124),
(16848,'enUS','','<Greatmother Geyah nods, accepting your answer.>$B$BI can no longer fight the spirits, $n. My time has long since passed. Once again, I must thank you for all that you have done. While Garrosh may be unmovable, many of my people have been lifted by your accomplishments. They are now willing to fight for our rights as a united clan.',26124),
(16849,'enUS','I have done all that I could, Greatmother. I thank you for your kind words.','I have done all that I could, Greatmother. I thank you for your kind words.',26124),
(16850,'enUS','','<Greatmother Geyah smiles at you.>$B$BYou remind me of my son, $n.$B$BHe was an immovable mountain: A pillar of strength and honor.$B$B<Geyah\'s eyes well up with tears.>$B$BHe sacrificed himself so that we could survive. So that generations of orcs after him could be born into a world without the blood curse... Without Gul\'dan and his dark Horde...$B$B<Geyah stares into the distance, lost in thought.>$B$BOh Durotan, how I wish you could be here. Your people so desperately need you...',26124),
(16851,'enUS','Greatmother, you are the mother of Durotan?','Greatmother, you are the mother of Durotan?',26124),
(16852,'enUS','','<Greatmother Geyah nods.>$B$BDid you know my son?',26124),
(16853,'enUS','Greatmother, I never had the honor. Durotan died long before my time, but his heroics are known to all on my world. The orcs of Azeroth reside in a place known as Durotar, named after your son. And... <You take a moment to breathe and think through what you are about to tell the Greatmother.>\n','Greatmother, I never had the honor. Durotan died long before my time, but his heroics are known to all on my world. The orcs of Azeroth reside in a place known as Durotar, named after your son. And... <You take a moment to breathe and think through what you are about to tell the Greatmother.>\n',26124),
(16854,'enUS','','<Greatmother Geyah\'s violet eyes lock onto yours.>$B$BYes...',26124),
(16855,'enUS','It is my warchief, Greatmother. The leader of my people. From my world. He... He is the son of Durotan. He is your grandchild.','It is my warchief, Greatmother. The leader of my people. From my world. He... He is the son of Durotan. He is your grandchild.',26124),
(16856,'enUS','','<Tears stream down Greatmother Geyah\'s face.>$B$BI... I... Durotan survived to have a child? The child Draka told me of before they left... It was their greatest fear... To raise a child in this world. On the other side of that gate was their only hope. I dared not tell Durotan, but secretly, I begged the spirits to watch over them - to protect their child and to give them strength.$B$BI... I must see my grandchild. I must see him. Please, I am too weak. You must tell him. Before I leave this world...\n',26124),
(16857,'enUS','I will return to Azeroth at once, Greatmother.','I will return to Azeroth at once, Greatmother.',26124),
(16858,'enUS','Fool! You are a child playing in a world beyond your comprehension. Speak no more!','',26124),
(16859,'enUS','Your weapons are nothing to me! Relent!','',26124),
(16860,'enUS','You have confidence in your skills? Think carefully as the answer may surprise you.','',26124),
(16861,'enUS','','We must not fail our leader!  Kael\'thas will redeem us!',26124),
(16862,'enUS','What... a shame.','',26124),
(16863,'enUS','I had more fun torturing the peons!','',26124),
(16864,'enUS','I\'m already bored!','',26124),
(16865,'enUS','You lose.','',26124),
(16866,'enUS','Oh, just die!','',26124),
(16867,'enUS','\'Netherstorm\' was not always as you see it now.$B$BThere was a time when this crumbling land was known as the Plains of Farahlon. Little of those days has survived the evil that has taken hold here.','',26124),
(16868,'enUS','','$C, hold your attack, this is just a disguise!  I\'m a spy working for the Lower City coalition out of Shattrath City.$B$BI hope you\'re here to help!',26124),
(16869,'enUS','Archmage Vargoth enstrusted me with his staff when he told me to flee from the blood elf attack on Violet Tower. I did as he told me, hoping to take refuge in the old draenei settlement of Arklon.$B$BThere was to be no respite. I had walked right into the leading edge of a Burning Legion force. The demons wrested the staff from me, but I managed to escape with my life.$B$BThough my master knows nothing of my failure, it still shames me.','',26124),
(16870,'enUS','','With all due respect, A\'dal sent us here to investigate Kael\'s activities, not mount a full-scaled attack.',26124),
(16871,'enUS','%s is unstable!','%s is unstable!',26124),
(16872,'enUS','Look, sweetheart.  No one\'s talking about storming Tempest Keep ourselves, but when we see a target of opportunity we have to take it.','',26124),
(16873,'enUS','Hold your tongue, knave!  Do not dare use that tone with a priestess of the Light!','',26124),
(16874,'enUS','','I\'m surrounded by idiots!',26124),
(16875,'enUS','','The magistrix will be happy to know  I\'m  fluent in Thalassian.  Your courtesy is not lost on me.',26124),
(16876,'enUS','','Back to the topic...  we should focus our attention on these manaforges.  We need to learn what the enemy is doing with them and why.',26124),
(16877,'enUS','Need a heal over here!','Need a heal over here!',26124),
(16878,'enUS','Um, healer?!','Um, healer?!',26124),
(16879,'enUS','Need some help!','Need some help!',26124),
(16881,'enUS','','That\'s hot.',26124),
(16882,'enUS','','Psshh... whatever.',26124),
(16883,'enUS','','We\'ve told you all there is to know!  Do you forget that many of us used to be trusted followers of Kael\'thas?',26124),
(16884,'enUS','I\'m on it!','I\'m on it!',26124),
(16885,'enUS','Incoming.','Incoming.',26124),
(16886,'enUS','Hold on just a second.','Hold on just a second.',26124),
(16887,'enUS','','That joke\'s hot.',26124),
(16888,'enUS','','I, like, so don\'t get it...',26124),
(16889,'enUS','...and just look at where that got us!','',26124),
(16890,'enUS','Even you must admit that your information from defectors is outdated and unreliable.  Let us make calculated attacks on these manaforges and gather what information we can.','',26124),
(16891,'enUS','Finally some talk of action from the big guy!','',26124),
(16892,'enUS','Less watching, more healing!','Less watching, more healing!',26124),
(16893,'enUS','Here it comes!','Here it comes!',26124),
(16894,'enUS','Well. Look what the netherwinds swept in. Come in, sit down, and rest yourself a spell. The fee is modest; you can surely afford it.','Well. Look what the netherwinds swept in. Come in, sit down, and rest yourself a spell. The fee is modest; you can surely afford it.',26124),
(16895,'enUS','We kill someone else!','',26124),
(16896,'enUS','I\'m not done yet, idiot!','',26124),
(16898,'enUS','You stay here.  Me go kill someone else!','',26124),
(16899,'enUS','That\'s not funny!','',26124),
(16900,'enUS','Ha ha ha.','',26124),
(16901,'enUS','What are you doing?','',26124),
(16902,'enUS','Me get bored.','',26124),
(16903,'enUS','Bored? He was almost dead!','',26124),
(16914,'enUS','Do they never rest?!$B$BIf we\'re to secure a future for the people of the Lower City, we must deal with the Shadow Council before they cause an even greater cataclysm than the Bone Wastes!$B$BBecause the leadership of Shattrath City will not move quickly, we the free people of the Lower City have taken matters into our own hands.$B$BBut our spies have been discovered.  We will hold off the Shadow Council\'s agents while you slip into the labyrinth and see what you can uncover.','',26124),
(16915,'enUS','Long ago, in a dimension of the cosmos unfathomable to mortal minds, there was born - if such a term can be used for it - a being of such unbelievable power that its very entrance into existence shattered all reality around it.$B$BKnown only as Murmur, it was the essence of sound, and to hear it speak was to know death eternal!','',26124),
(16916,'enUS','No, we will NOT let you live.','',26124),
(16917,'enUS','Hey!','',26124),
(16918,'enUS','Me hungry.','',26124),
(16919,'enUS','You\'re always hungry.  That\'s why we so fat!','',26124),
(16920,'enUS','You kill next one!','',26124),
(16921,'enUS','I\'m tired.  You kill next one!','',26124),
(16922,'enUS','This one die easy!','',26124),
(16923,'enUS','That\'s because I do all the hard work!','',26124),
(16924,'enUS','This all... your fault!','',26124),
(16925,'enUS','I... hate... you.','',26124),
(16926,'enUS','Phew! There\'s my lucky hat. I\'ve been looking for it everywhere.','',26124),
(16927,'enUS','I can\'t possibly go out without my cloak. I hope it\'s in here...','',26124),
(16928,'enUS','<Read on, if you dare...>','<Read on, if you dare...>',26124),
(16929,'enUS','There it is! I could\'ve sworn it wasn\'t here last time I checked...','',26124),
(16930,'enUS','Existing only for chaos, its slightest whisper meant the destruction of whole worlds!$B$BYet still, there were those that would try to worship this mindless being.  There were even those more insane who dared to think to control it.','',26124),
(16931,'enUS','I don\'t know what I was thinking, going out without my sword. I would\'ve put it on if I\'d seen it here...','',26124),
(16932,'enUS','','I can\'t sleep without a good bedtime story. Now I\'m certain to rest well.',26124),
(16933,'enUS','Fight on, good people of Azeroth.  And take heart!  Your brethren rush to this hellish portal and will soon throw themselves at these demons as you have so bravely done.  May the Light keep you!','Fight on, good people of Azeroth.  And take heart!  Your brethren rush to this hellish portal and will soon throw themselves at these demons as you have so bravely done.  May the Light keep you!',26124),
(16934,'enUS','Argent Dawn! We go to gather more aid!  Fight on, brothers and sisters.  And know that you will not long fight alone!','',26124),
(16935,'enUS','My brethren, my comrades-in-arms!  I must go to seek the forces of the Horde and direct them here!  Keep your spirits strong, brave hunters!  Do not fall to the portal-spawned fiends!','',26124),
(16936,'enUS','The musty pages of the codex seem to magically turn themselves, guiding your attention to a specific chapter past horrors no mortal eyes should ever perceive.$B$BThe book opens to a page that somehow feels \'right,\' yet so very wrong.','',26124),
(16937,'enUS','And lo, how the mighty fell trembling at its feet, fearful that it might direct its words upon them.$B$BBut still did these charlatans, these worshipping pretenders to a non-existent religion, rail against the inevitable in a vain attempt to control their \'god.\'  Uncaring, and likely not even noticing them, Murmur yawned and they knew oblivion.$B$BYet one somehow managed to survive, and in his insanity found a way to bring Murmur into the world.','',26124),
(16938,'enUS','A mortal possessed of arcane and dark knowledge that none could surpass, he devised a method to enhance his summoning through the capture and use of souls untold.$B$BWhole civilizations were brought to extinction through his soul devices to fuel the ritual through which he and his conspirators would bring Murmur into their world.','',26124),
(16939,'enUS','And summon forth Murmur they did.$B$BPowerful magics of containment and silencing were employed, held together by the constant supply of souls being fed into them.  Yet still they could not control the beast, could not bend it to their will.$B$BThese mortals began to devise different strategies, and one after the other they all failed.  And in so doing, they weakened the rituals, accidentally giving Murmur the slightest modicum of freedom.$B$BIt was all that was needed.','',26124),
(16940,'enUS','Only this book survived the cataclysm that destroyed their world.  Those proud and foolish men who thought to control a cosmic being of untold power.$B$BWould you, the possessor of the codex, do the same?$B$BHave you devised a foolproof method to summon forth Murmur, or any of the other entities cautiously whispered of in these unhallowed pages?$B$BWe shall see.','',26124),
(16941,'enUS','Hey there!  Good to see a new face - I don\'t get many visitors and the technicians aren\'t very good conversationalists.$B$BI bet you\'re on your way to Area 52.  Am I right?','',26124),
(16942,'enUS','High Botanist?','High Botanist?',26124),
(16944,'enUS','%s sighs.','%s sighs.',26124),
(16945,'enUS','...mumble...Petals of Fire...mumble...','',26124),
(16946,'enUS','...mumble mumble...','',26124),
(16947,'enUS','...thorny vines...mumble...ouch!','',26124),
(16948,'enUS','...with the right mixture, perhaps...','',26124),
(16949,'enUS','What\'s this?  That can\'t be right!  Who built this bridge anyway?  Oh, we did.','',26124),
(16950,'enUS','Oh no!  Does this thing need ANOTHER recalibration?','',26124),
(16951,'enUS','This is the last time that I buy second-hand equipment from an ethereal!','',26124),
(16952,'enUS','I hope those blood elves across the way don\'t think that I\'m spying on them!','',26124),
(16953,'enUS','If this is right, we don\'t have long!  Oh well.','',26124),
(16954,'enUS','The planets are aligned!  The second moon is in the house of ... now what was that house called again?','',26124),
(16955,'enUS','If I were smart, I\'d be selling this research for a seat on the rocket ship.  I have a feeling we\'re going to need to get out of here soon!','',26124),
(16956,'enUS','Unbelievable!  I think I\'ve just discovered that everything does not orbit around the Outland.  No, that can\'t be right!','',26124),
(16957,'enUS','Rocket-Chief Fuselage, commander of B.O.O.M - the Braintrust of Orbital Operations and Mechanics - at your service.$B$BAre all systems go?!  It looks like the X-52 Nether-Rocket still needs a lot of work!$B$BCome on people... we\'re T-minus NEVER here!','',26124),
(16958,'enUS','','Welcome to the Allerian Stronghold, $n.',26124),
(16959,'enUS','','This is delicate work out here, you know?  It can\'t just be rushed, or something\'s likely to get broken.$B$BLike Fuselage\'s head!$B$BYou might be wondering about my bots?  I\'m always working on the Mk. I, and the Mk. II gained sentience for a split-second before his brain capacitor blew out and he went insane!$B$BI decided to skip III and IV, and went straight to the Mk. V - my pride and joy!',26124),
(16960,'enUS','Try to keep appraisal errors to a minimum.  I\'d hate to tell Gezhe we\'ve overpaid on another gem shipment this month.','',26124),
(16961,'enUS','Welcome my brothers! Bask in the glory of my power!','',26124),
(16962,'enUS','Be careful among the ruins, $c. The Kirin Tor spirits you find there will not recognize you as a friend.$B$BThe custodian and I are the only ones whose spirits retained a strong enough tie to this place to preserve our full identities in death.','',26124),
(16963,'enUS','Kirin\'Var survived 20 long years and countless orc assaults, but it could not withstand the forces of Kael\'thas. A man who once called himself a member of the Kirin Tor murdered all of us, save one.$B$BArchmage Vargoth survived the attack, so Kael\'thas imprisoned him within the Violet Tower, warding it with a magic that forbids the passage of any of the Kirin Tor.','',26124),
(16964,'enUS','','Alright, Mk. I, that should just about do it.  Let\'s just flip your switch here...',26124),
(16965,'enUS','','Oh no!  Will I ever get you working?!',26124),
(16966,'enUS','Please, sit and make yourself comfortable.','Please, sit and make yourself comfortable.',26124),
(16967,'enUS','Welcome to my inn, weary traveler. What can I do for you?','Welcome to my inn, weary traveler. What can I do for you?',26124),
(16968,'enUS','%s begins to collapse!','',26124),
(16969,'enUS','Hey, did you read the bounty on this wanted poster?','Hey, did you read the bounty on this wanted poster?',26124),
(16970,'enUS','This wanted poster says that they\'re offering gold to these so-called adventurers to go kill things.  Isn\'t that what we do?  I don\'t think I\'m being paid enough!','This wanted poster says that they\'re offering gold to these so-called adventurers to go kill things.  Isn\'t that what we do?  I don\'t think I\'m being paid enough!',26124),
(16971,'enUS','This wanted poster has a bounty on bonelashers.  You think I should do that?','This wanted poster has a bounty on bonelashers.  You think I should do that?',26124),
(16972,'enUS','The Bone Wastes!  I don\'t care what\'s being offered as a reward, I\'m not going into the Bone Wastes!','The Bone Wastes!  I don\'t care what\'s being offered as a reward, I\'m not going into the Bone Wastes!',26124),
(16973,'enUS','%s summons his servants from the nether!','',26124),
(16974,'enUS','You want to go do the bounty off of this wanted poster after the shift is over?','You want to go do the bounty off of this wanted poster after the shift is over?',26124),
(16975,'enUS','I don\'t know and I don\'t care.','I don\'t know and I don\'t care.',26124),
(16976,'enUS','Is that wanted poster all that you\'re going to talk about today?','Is that wanted poster all that you\'re going to talk about today?',26124),
(16977,'enUS','I\'m up to looking into that bounty after this shift.','I\'m up to looking into that bounty after this shift.',26124),
(16978,'enUS','The bonelashers of the wastes are no laughing matter.  I hear they carry diseases!','The bonelashers of the wastes are no laughing matter.  I hear they carry diseases!',26124),
(16979,'enUS','I could use the extra money.','I could use the extra money.',26124),
(16980,'enUS','War drums echo in the distance.','',26124),
(16981,'enUS','I say we fire it. Cut the rope.','I say we fire it. Cut the rope.',26124),
(16982,'enUS','Harumph! Coward.','Harumph! Coward.',26124),
(16983,'enUS','You cut the rope. You have the knife.','You cut the rope. You have the knife.',26124),
(16984,'enUS','You read wanted poster to Grek?$B$BGrek want to help!','',26124),
(16985,'enUS','Someone come read this wanted poster to Grek.  Grek can\'t read!','',26124),
(16986,'enUS','You know, I think we can hit Honor Hold from here.','You know, I think we can hit Honor Hold from here.',26124),
(16987,'enUS','Ah! We can tell him Hagash stumbled into it and fired it accidentally!','Ah! We can tell him Hagash stumbled into it and fired it accidentally!',26124),
(16988,'enUS','If General Krakork found out, he\'d eat us alive. Don\'t.','If General Krakork found out, he\'d eat us alive. Don\'t.',26124),
(16989,'enUS','%s sighs.','%s sighs.',26124),
(16990,'enUS','I\'m blind, you stupid sow-spawn, not deaf. Don\'t even think about it.','',26124),
(16991,'enUS','Ten silver says I can hit Honor Hold with this boulder!','Ten silver says I can hit Honor Hold with this boulder!',26124),
(16992,'enUS','Try it, and I\'ll fire you AND your ten silver over that wall.','Try it, and I\'ll fire you AND your ten silver over that wall.',26124),
(16993,'enUS','Get out of here, there are too many of them! Escape while you can!','Get out of here, there are too many of them! Escape while you can!',26124),
(16994,'enUS','Help! Someone help us!','Help! Someone help us!',26124),
(16995,'enUS','','Hello, what business brings you here?$B$BThis is an orphanage for the children of Outland who have lost their parents and have no one else to look after them.$B$BPerhaps you are here because you are considering adoption?',26124),
(16996,'enUS','At long last, I am home...','',26124),
(16997,'enUS','Forward! We march to Garadar!','',26124),
(16998,'enUS','','Mark II, get your metallic behind back here this instant!',26124),
(16999,'enUS','','Yes. That did the trick.',26124),
(17000,'enUS','','Hmm...',26124),
(17001,'enUS','Ahh, another powerful traveler. The nether can be dangerous; you\'ll want the most potent spells at your disposal. I carry the finest reagents, common and exotic. Come, buy - you won\'t be sorry!','',26124),
(17002,'enUS','The creatures of this place are strong, wayfarer. You\'ll need ample ammunition if you hope to survive. You\'re in luck - I am well-stocked with fine arrows, bullets, and throwing weapons. The price is reasonable, considering circumstances.','',26124),
(17003,'enUS','','Be careful in there and come back in one piece!',26124),
(17004,'enUS','A tradesman, perhaps? You need look no further than I for supplies. My prices are quite fair, friend. These items were difficult to acquire, but what does the source matter, eh? You\'ll have what you need.','',26124),
(17005,'enUS','Who is he? He looks so familiar.','Who is he? He looks so familiar.',26124),
(17006,'enUS','Are the rumors true? Does he truly carry the Greatmother\'s bloodline?','Are the rumors true? Does he truly carry the Greatmother\'s bloodline?',26124),
(17007,'enUS','Could it really be? The son of Durotan?','Could it really be? The son of Durotan?',26124),
(17008,'enUS','Has he come to lead us?','Has he come to lead us?',26124),
(17009,'enUS','I have never felt such strength radiate from an orc. Is he... mortal...','I have never felt such strength radiate from an orc. Is he... mortal...',26124),
(17010,'enUS','He carries the Doomhammer!','He carries the Doomhammer!',26124),
(17011,'enUS','For the first time, I feel safe. I do not know you, stranger, but I know that I would lay down my life for you if only you asked.','For the first time, I feel safe. I do not know you, stranger, but I know that I would lay down my life for you if only you asked.',26124),
(17012,'enUS','Son of Durotan... Grandson of Garad and Geyah... Bow your heads for a Warchief is among us...','Son of Durotan... Grandson of Garad and Geyah... Bow your heads for a Warchief is among us...\n',26124),
(17013,'enUS','I am unworthy, son of Durotan. We are all unworthy...','I am unworthy, son of Durotan. We are all unworthy...',26124),
(17014,'enUS','','You\'re back!  Were you able to get all of the machines?',26124),
(17015,'enUS','Stand proud, $g brother:sister;!','',26124),
(17016,'enUS','You honor me, $g brother:sister;.','',26124),
(17017,'enUS','It is I who is unworthy.','',26124),
(17018,'enUS','I stand before you only a boy in search of lost memories.','',26124),
(17019,'enUS','Hippogryph Master','Hippogryph Master',26124),
(17020,'enUS','Hmm... the readings on the gravimeteric distortions seem to have stabalized.  We did it!','',26124),
(17021,'enUS','I\'m picking up trace amounts of chroniton particles.  Hmm, if we use a reverse phase inducer, while inverting our own chronosphere, we might be able to eliminate the particles. Of course, that means we need to build a chronosphere...','',26124),
(17022,'enUS','Interesting... it seems the nethertron emissions are on the rise using the gobo-sin curve scale.  Yet the energon particles are cubed...  ','',26124),
(17023,'enUS','My gadget can\'t get an accurate reading with all the quatum nether fluctuations.','',26124),
(17024,'enUS','Hmm... It seems that the syncotron unit we\'ve been using has had no noticeable effect on the gravimetric or gravitronic distortions in this sector.','',26124),
(17025,'enUS','Look around you, younglings. This is Draenor!','',26124),
(17026,'enUS','It is amazing. How could it have remained in this state, untouched by the world\'s destruction?','',26124),
(17027,'enUS','I wonder, does Oshu\'gun still stand... Oh the stories I could tell of the time before the darkness... So many wonderous memories...','',26124),
(17028,'enUS','I believe it was on this very land that a young Durotan, barely into adolescence, killed his first talbuk. Ah, I can still remember him recanting that tale for us at the springtime festival.','',26124),
(17029,'enUS','And on this very soil that we now touch, our greatest heroes once hunted.','',26124),
(17030,'enUS','They were best friends, you know. Durotan and Orgrim once ventured into the Terokkar forest, where they were almost killed by an ogre. If it were not for the draenei that saved them... It makes me sad to look back upon those days. Such terrible things we did to the draenei...','',26124),
(17031,'enUS','The old memories stir. They rush back to me as if propelled by the noble spirits of the air...','',26124),
(17032,'enUS','I am ready to die. Finally home, my spirit can be freed from this mortal shell.','',26124),
(17033,'enUS','We\'ve taken some strange readings from nether ribbons.','',26124),
(17034,'enUS','I\'ve got a preliminary report about the gravimetric disruptions.','',26124),
(17035,'enUS','I have another reading from the nether.','',26124),
(17036,'enUS','My quad-corder has detected some anomolous readings from the nether anomolies.','',26124),
(17037,'enUS','I think my gadget is broken, it did manage to pick up some unusual readings.','',26124),
(17038,'enUS','You should take a look at these readings, they are unlike anything we\'ve seen before.','',26124),
(17039,'enUS','%s dons his wolf-fur vestments.','',26124),
(17040,'enUS','Let me see what you\'ve found.','',26124),
(17041,'enUS','Let\'s see what you\'ve got.','',26124),
(17042,'enUS','Give me a moment to look over these findings.','',26124),
(17043,'enUS','I\'ll be the judge of that.','',26124),
(17044,'enUS','Wolf spirit of the forest, hear me!','',26124),
(17045,'enUS','Well hand it over and let\'s see what you\'ve got!','',26124),
(17046,'enUS','Long ago, you were a companion to my people. We gave ourselves to evil and you were forgotten.','',26124),
(17047,'enUS','But we have returned, spirit! We have returned to honor you again. Favor us with your presence once more.','',26124),
(17048,'enUS','What\'s your pleasure?  Pull up a seat and knock one back.$B$BI\'m Boots, lead mixologist for B.O.O.M. and bartender extraordinaire!$B$BIf it\'s got kick, Ol\' Boots can give it to ya.','',26124),
(17049,'enUS','Oh my...','',26124),
(17050,'enUS','Fascinating.','',26124),
(17051,'enUS','%s howls in response to Malukaz\'s call.','',26124),
(17052,'enUS','Incredible!','',26124),
(17053,'enUS','Impressive... Most impressive.','',26124),
(17054,'enUS','Boots, what do you have back there that goes down smooth?','Boots, what do you have back there that goes down smooth?',26124),
(17055,'enUS','May our bond with you never be broken again, spirit.','',26124),
(17056,'enUS','Great Gazlowe!','',26124),
(17057,'enUS','We\'ll need to collect more data to substantiate these readings.  Get back in there and collect that data.','',26124),
(17058,'enUS','We need to confirm this data, we don\'t want to rip apart any more of our facility.','',26124),
(17059,'enUS','According to these readings, we have nothing to fear.  At least nothing in the near future.  We\'ll need more data to be sure.','',26124),
(17060,'enUS','This data will be quite useful for Project Blue Book. Er, I mean, this will be great for my new look.  See if you can gather any more data.','',26124),
(17061,'enUS','Hmmm... this nether radiation could prove to be quite deadly.  But it could be even deadlier to  just ignore it.  I\'ll need some more readings to confirm this.','',26124),
(17062,'enUS','Woot!  Here we go!','',26124),
(17063,'enUS','Uh oh!','',26124),
(17064,'enUS','I\'m ok, I\'m ok!  Ah well, back to the drawing board on that rocket fuel!','',26124),
(17066,'enUS','We have done it! Thrall would be proud.','',26124),
(17067,'enUS','Yikes!  Someone call the fire marshal!  Medic!!!  Is there a doctor in the house?','',26124),
(17068,'enUS','Grek, will you try out this new weapon oil Rakoria made?','Grek, will you try out this new weapon oil Rakoria made?',26124),
(17069,'enUS','Grek try!','',26124),
(17070,'enUS','This oil no good for Grek! What Grek look like to you, some weakling in robes?','',26124),
(17071,'enUS','I\'m a doctor!  What seems to be the problem?','',26124),
(17072,'enUS','Oh!  Someone needs to get those fires out so I can get in there and save that goblin!','',26124),
(17073,'enUS','','I never thought it would turn out to be mana oil! There\'s going to be plenty of demand for that, minus Grek, of course!',26124),
(17074,'enUS','Right... let me in there!','',26124),
(17075,'enUS','','Ship it!',26124),
(17076,'enUS','Everyone clear!','',26124),
(17077,'enUS','Come on!  Clear!','',26124),
(17078,'enUS','Dammit, Boots, I\'m a doctor not a priest!  Clear!!!','',26124),
(17079,'enUS','I\'ve got a pulse!','',26124),
(17080,'enUS','Hellscream! Blessed ancestors! He is the mirrored reflection of Grom, Drek\'Thar.','',26124),
(17081,'enUS','A pleasure!','',26124),
(17082,'enUS','Thanks...','',26124),
(17083,'enUS','','Are you the correspondent from the Gadgetzan Times? If you just follow me, I\'ll show you my experimental apparatus...$B$B<You tell the magus that you\'re not the reporter she\'s expecting.>$B$BOh, you\'re not? Well then, if you need reagents, find what you need and don\'t tarry. I\'m expecting someone.',26124),
(17084,'enUS','Someone called?','',26124),
(17085,'enUS','I wish to browse your wares.','I wish to browse your wares.',26124),
(17086,'enUS','%s expresses its approval.','',26124),
(17087,'enUS','Impertinent fool! You are no match for the servants of Prince Kael\'thas!','',26124),
(17088,'enUS','Radiation?!$B$BNo, you don\'t need to worry about that!  Sheesh, the things that people believe these days.$B$BSo, what do you think of our operations down here?  State of the art, baby!  You better believe it.','',26124),
(17089,'enUS','I have some left over.','I have some left over.',26124),
(17090,'enUS','I lost my Crude Explosives. Do you have any left?','I lost my Crude Explosives. Do you have any left?',26124),
(17091,'enUS','%s nods.','',26124),
(17092,'enUS','The memories rush back, Thrall.','',26124),
(17093,'enUS','For years I was convinced we were doing the right thing in Silvermoon - working to reach Outland so we could be reunited with Kael.$B$BHad I known what Kael\'thas had in store for us, I would\'ve stayed right in Falconwing Square.','',26124),
(17094,'enUS','There are two prominent bills tacked up on the board here; one from Papa Wheeler and one from Rocket-Chief Fuselage.$B$BPapa\'s looks like it\'s a wanted ad for a machine part.  The rocket-chief\'s has something to do with a bounty on the head of an immense mountain giant!$B$BThe details for both are provided in very small goblin handwriting, which is, of course, barely legible.','',26124),
(17095,'enUS','There are several prominent bills tacked up on the board here.$B$BHowever, the fine-print indicates that you\'re not quite ready for either of the tasks at hand.  You should definitely check back later!','',26124),
(17096,'enUS','I am sorry that I did not come sooner, young Hellscream. There is so much that I have to tell you about your father, but first you must tell me where I may find the Greatmother.','',26124),
(17097,'enUS','Where?  Where are the Shards!  You cannot hide them from us!','',26124),
(17098,'enUS','We are honored by your presence, son of Durotan. The Greatmother awaits you at the hospice.','',26124),
(17099,'enUS','%s points towards the hospice.','',26124),
(17100,'enUS','I thank you, Garrosh. We have much to discuss when I return from my visit with the Greatmother.','',26124),
(17101,'enUS','','I have been expecting you, young one. Come closer - my eyes are not as sharp as they once were.\n',26124),
(17102,'enUS','Greatmother...','',26124),
(17103,'enUS','','Come closer, grandson. Sit by your Greatmother.',26124),
(17104,'enUS','','Drek\'Thar, forever loyal to our people. Spirits bless you, old friend. This is your home too, please make yourself comfortable.',26124),
(17105,'enUS','%s absorbs the fire energy of the attack.','',26124),
(17106,'enUS','%s absorbs the frost energy of the attack.','',26124),
(17107,'enUS','%s absorbs the nature energy of the attack.','',26124),
(17108,'enUS','%s absorbs the shadow energy of the attack.','',26124),
(17109,'enUS','%s absorbs the arcane energy of the attack.','',26124),
(17110,'enUS','%s absorbs the holy energy of the attack.','',26124),
(17111,'enUS','Thrall, you should go alone. Perhaps this old shaman can teach those farseers a thing or two.','',26124),
(17112,'enUS','I will be with the Lightning Sons should you require my services.','',26124),
(17113,'enUS','Greatmother...Am I...\n','',26124),
(17114,'enUS','I can\'t believe that Papa Wheeler thinks he\'s going to dupe anyone into going out to Manaforge B\'naar!','I can\'t believe that Papa Wheeler thinks he\'s going to dupe anyone into going out to Manaforge B\'naar!',26124),
(17115,'enUS','Maybe I should gather up some other agents and head out there after this shift?','Maybe I should gather up some other agents and head out there after this shift?',26124),
(17116,'enUS','Hmm, arcane annihilators are pretty tough.  I wonder if Papa Wheeler knows what he\'s asking for?','Hmm, arcane annihilators are pretty tough.  I wonder if Papa Wheeler knows what he\'s asking for?',26124),
(17117,'enUS','We can\'t let a failing servo slow down the construction of the X-52 Nether-Rocket!','We can\'t let a failing servo slow down the construction of the X-52 Nether-Rocket!',26124),
(17118,'enUS','Hey!  Come over here and take a look at this wanted poster.  You\'re not going to believe this!','Hey!  Come over here and take a look at this wanted poster.  You\'re not going to believe this!',26124),
(17119,'enUS','Good thing that we\'re surrounded by neighbors with excess machine parts.','Good thing that we\'re surrounded by neighbors with excess machine parts.',26124),
(17120,'enUS','','Yes, you move like my son. You have his broad shoulders - ahh, and your mother\'s fierce eyes.\n',26124),
(17121,'enUS','','Are they...',26124),
(17122,'enUS','They... did not, Greatmother. They were killed shortly after I was born. I never knew them. I was raised as a slave. To this day, I carry the name of Thrall.\n','',26124),
(17123,'enUS','','There is no doubt - you are the heir of Durotan... my grandson. Draka told me she was with child before she and your father left our world, but I never dared dream that they would survive...\n',26124),
(17124,'enUS','They died honorably, Greatmother.','',26124),
(17125,'enUS','I never knew my father or mother. Orgrim told me many stories about them and their adventures on Draenor. He was my greatest teacher and dearest friend, Greatmother. He died a hero... They all died as heroes and for all of them, a song of honor remains.','',26124),
(17126,'enUS','','Thrall? You\'ve been a slave only to the past, grandson! But no more! When last I saw him, Durotan told me the name he would give his unborn son... He was... so proud...',26124),
(17127,'enUS','But surely you heard, Greatmother.','',26124),
(17128,'enUS','He died our greatest hero. It was Grom who freed us all... I was by his side when he struck down Mannoroth and ended the curse forever.','',26124),
(17129,'enUS','','Blessed spirits! For twenty years, all we knew was that Grom was the first to drink from the cursed chalice and bring damnation down upon our people... It is the only truth his son, Garrosh has ever known.\n',26124),
(17130,'enUS','Shredders?!  They just won\'t cut it anymore.  They\'re so yesterday!$B$BIf we\'re going to build rockets - if we\'re going to get the X-52 off the ground - we need better tech!','',26124),
(17131,'enUS','','Grandson, will you... Will you tell Garrosh what you have told me about his father?',26124),
(17132,'enUS','Tell him? Greatmother, that boy\'s father died so that all of us could live free of the blood curse. I will tell him nothing. I will show him! Show him and any that would doubt Hellscream\'s resolve exactly what Grom Hellscream did for all orcs!','',26124),
(17133,'enUS','Please excuse me, Greatmother. I will return soon.','',26124),
(17134,'enUS','Garrosh, son of Hellscream, your father lived and died as our greatest hero. Honor me by allowing me to show you what your father sacrificed so that we could live free of the demon\'s grasp.','',26124),
(17135,'enUS','As you wish, Thrall, son of Durotan.','',26124),
(17136,'enUS','Spirits give me strength! Take from my soul these old wounds and expose them for all to see! Let this child know his father! Let these people know their savior!','',26124),
(17137,'enUS','%s laughs.','',26124),
(17138,'enUS','So predictable. I knew you would come. And I see you\'ve brought the mighty Hellscream.','',26124),
(17139,'enUS','His blood is mine, as is your whole misbegotten race.','',26124),
(17140,'enUS','%s roars in defiance.','',26124),
(17141,'enUS','A worthy effort, but futile.','',26124),
(17142,'enUS','The boy believed you could be saved, but he didn\'t know what burns within your soul when in your heart, you know we are the same.\n','',26124),
(17143,'enUS','%s breaks free of the blood elf\'s control!','',26124),
(17144,'enUS','NOOOO!','',26124),
(17145,'enUS','Soup\'s on, men! Eat up. We\'ve got a long day ahead.','',26124),
(17146,'enUS','Alright, let\'s see what makes this tech tick!','',26124),
(17147,'enUS','The Long Tube Gadget Analyzer should tell me what I need to know.','',26124),
(17148,'enUS','Fall in men! It\'s time to drill!','',26124),
(17149,'enUS','Ack, disintegrated!  I guess I had the power setting too high?  And it almost hit the Wheeler Mobile!  Yikes, don\'t tell him!','',26124),
(17150,'enUS','Thrall... The blood haze has lifted.','',26124),
(17151,'enUS','Grom\'s eyes go dim as the blood curse is lifted.','',26124),
(17152,'enUS','The demon\'s fire has burnt out in my veins. I have... freed myself.\n','',26124),
(17153,'enUS','No, old friend. You\'ve freed us all...','',26124),
(17154,'enUS','I\'ve heard your name spoken only in whispers, mage.  Who are you?','I\'ve heard your name spoken only in whispers, mage.  Who are you?',26124),
(17155,'enUS','I am Khadgar, former apprentice to the fallen Guardian, Medivh. I\'m sure you\'ve heard his name before.$B$BIt was I who discovered that Medivh had been possessed by the Evil One, Sargeras - and that he had opened the Dark Portal between this world and Azeroth. Though I honored my Master, I was forced to slay him and put his tortured soul to rest.','',26124),
(17156,'enUS','I see.','I see.',26124),
(17157,'enUS','I fought alongside Lord Anduin Lothar as we drove the Horde from our lands on Azeroth. As the heir of Medivh\'s legacy, I could do no less.$B$BWhen the call finally came to invade this grim world - and put an end to the orcs\' evil forever - I stepped forward along with my friends Turalyon, Alleria, Danath and Kurdran.','',26124),
(17158,'enUS','My comrades and I called ourselves the Sons of Lothar - in honor of the greatest, most selfless man we ever knew.  We gave our all to defeat Ner\'zhul and end his madness.$B$BAs this doomed world fell apart around us, we shattered the Dark Portal to prevent any further harm befalling our beloved Azeroth.','',26124),
(17159,'enUS','Trapped in this broken wasteland, we did our best to survive. Over time we sensed that a new evil was closing in around us from the Twisting Nether.  More foul than the dark orcs - it was the Burning Legion itself that sought to take hold of this... Outland.','',26124),
(17160,'enUS','While my comrades held the line against the encroaching darkness, I used my magic to reach out into the Great Dark Beyond.  There, I sensed beings of immense Light - of unfathomable purity.$B$BIt was A\'dal and his naaru I had found. It was nothing short of a... miracle.','',26124),
(17161,'enUS','<Khadgar grins to himself>$B$BI convinced A\'dal and his brethren to return here with me. I believe that only their power can drive the Legion from this universe. But as you will no doubt find - their power must first live in our hearts.$B$BTo combat the darkness, we must become beacons of their eternal Light.','',26124),
(17162,'enUS','Fierce retaliation for the defections were to follow.  Shattrath City came under unrelenting attack from Illidan and Kael\'thas.$B$BArmies of blood elves, naga and Broken, would pour into the city; only to be repelled by the might of the Sha\'tar.$B$BOne thing became clear to the naaru.  If they were to pursue the Legion, they would have to defeat Illidan first.','',26124),
(17163,'enUS','%s collapses.','',26124),
(17164,'enUS','For my entire life I have thought my bloodline cursed. I have lived beneath the shadow of my father\'s greatest failure.','',26124),
(17165,'enUS','Shattrath did not fall, as you can see.  To the contrary, the naaru known as Xi\'ri, led a successful incursion into Shadowmoon Valley - Illidan\'s doorstep.$B$BThere he continues to wage war on Illidan\'s armies with the assitance of the Aldor and the Scryers.$B$BThe two factions have not given up on their old feuds, however. Such is their animosity that they vie for the honor of being the ones sent to assist the naaru there.  Each day, that decision is made by A\'dal right here in Shattrath.','',26124),
(17166,'enUS','I hated him for what he had done. I hated him for the burden he left me. But now...','',26124),
(17167,'enUS','You have shown me truths that I would have never known. You and your allies have gifted me with something that cannot bear a price: Redemption. Thrall, redeemer of the Mag\'har, you honor me as none ever have...','',26124),
(17168,'enUS','On this day, a great burden has been lifted from my chest. My heart swells with pride. And for the first time, I can proudly proclaim who I am. I can finally unleash the fury in my heart.','',26124),
(17169,'enUS','I am Garrosh Hellscream, son of Grom, chieftain of the Mag\'har! Let the battle call of Hellscream give you courage and strength! Be lifted by my rallying cry.','',26124),
(17170,'enUS','News spread quickly of Shattrath City\'s victories.  Refugees from all previous wars and from the one that had begun anew begun to pour into the city.$B$BThe entire lower third of the city is inhabited by them now.  No one who seeks respite from Illidan is turned away, so you might run into an unsavory character or two there.  But for the most part, they\'re just ordinary people who had lost all hope and have now been given a new lease on life.','',26124),
(17171,'enUS','Thank you, son of Durotan.','',26124),
(17172,'enUS','%s places a hand on Garrosh\'s shoulder.','',26124),
(17173,'enUS','You need not thank me, Garrosh. Your father was a brother to me. I would do anything for you and the Mag\'har. I must now return to the Greatmother.','',26124),
(17174,'enUS','It is for them, or rather for what they represent, that we fight.$B$BOutside these walls, these people\'s lives are forfeit.  The world as they know it... as we all know it, is threatened by Kael\'thas, Illidan and the Burning Legion.$B$BWithin these walls you will find the few that are willing to fight for that world.','',26124),
(17175,'enUS','I have returned, Greatmother. Garrosh has found his heart and his fury.','',26124),
(17178,'enUS','Hmm...Frost, Fire, and Arcane defenses respond faster than Batch 7, but Nature defenses remain passive.','Hmm...Frost, Fire, and Arcane defenses respond faster than Batch 7, but Nature defenses remain passive.',26124),
(17179,'enUS','I love the smell of nether in the morning.','I love the smell of nether in the morning.',26124),
(17180,'enUS','It smells like...','It smells like...',26124),
(17181,'enUS','...victory.','...victory.',26124),
(17182,'enUS','This thing kind of reminds me of a Zed Power Nodule I once took half of Papa Wheeler\'s old garage out with.','',26124),
(17183,'enUS','What is it that you want, $r?','',26124),
(17184,'enUS','Hail, Gezhe!  Seventeen more orders have been placed in the Hara\'samid Sector.  The markets of heavy veldarite have all but collapsed, as you predicted.','',26124),
(17185,'enUS','By your leave, sir.','',26124),
(17186,'enUS','Heraazi exports are on the rise, sir.  We\'ve already bribed the appropriate taxation officers and contraband will begin to arrive within days.','',26124),
(17187,'enUS','No word from the nexus-prince as of yet.  Rumors of a dispute with our clients in Netherstorm have begun to circulate.  Our Sodaraami backers speak of divesting.  We\'ve dispatched our top negotiators to dissuade them, sir.','',26124),
(17188,'enUS','Xarodi sector markets have reopened, sir.  Sapphires of all sort are up.  Silver is down.  Gold is up.  Diamonds remain stable.$B$BOh, and your brother asks that you return the holocubes you borrowed last week.','',26124),
(17189,'enUS','Word from Netherstorm, sir.  Stop all bloodgem imports; client has reneged payments.$B$BThe nexus-prince will buy out our stock at full price as compensation.','',26124),
(17190,'enUS','As expected.  Very well, dismissed.','',26124),
(17191,'enUS','Nothing surprising there.  Come back with some real news, will you?','',26124),
(17192,'enUS','Bribe who you must, but I need some inside information this week if I\'m to make a profit and keep your lot employed.  Off with you!','',26124),
(17193,'enUS','Not really.','',26124),
(17194,'enUS','It is if I\'m not the one that\'s going to be sent in to test it... Otherwise, no.','',26124),
(17195,'enUS','What does that mean anyway? Ready? Can it ever be ready?','',26124),
(17196,'enUS','I\'m giving her all that I\'ve got, captain. I don\'t think she can take much more of this!','',26124),
(17197,'enUS','I can\'t bang on this device any faster, captain! My wrapping is already beginning to unravel!','',26124),
(17198,'enUS','Will you stop asking that?','',26124),
(17199,'enUS','Why don\'t you pick up a hammer and start banging on these structures instead of asking us if it\'s done every 5 minutes?','',26124),
(17200,'enUS','I\'ve had just about enough of your incessant whining, captain. What are you even a captain of? I mean, the nerve!','',26124),
(17201,'enUS','Is that damned thing safe to go through yet?','',26124),
(17202,'enUS','Is it done yet? What is taking so damned long?','',26124),
(17203,'enUS','You know, we could easily replace you with goblins. Is that what you want???','',26124),
(17204,'enUS','I can\'t believe you imbeciles went to school for this! Does anybody here know what they\'re doing?','',26124),
(17205,'enUS','I don\'t get paid enough for this nonsense.','',26124),
(17206,'enUS','Here goes nothing!','',26124),
(17207,'enUS','This is gonna leave a mark...','',26124),
(17208,'enUS','If I make it through, I expect a pay raise.','',26124),
(17209,'enUS','I made it! I made it!','',26124),
(17210,'enUS','Alright, it looks safe. Get in there, engineer!','',26124),
(17211,'enUS','%s runs his hands across his body to make sure everything is intact.','',26124),
(17212,'enUS','%s shrugs.','',26124),
(17213,'enUS','%s shakes his head in disapproval.','',26124),
(17214,'enUS','Oh well, back to the drawing board.','',26124),
(17215,'enUS','I didn\'t like him much anyway. Too much talk, not enough \"do.\"','',26124),
(17216,'enUS','Damnit. How are we ever going to get through their security measures?','',26124),
(17217,'enUS','Nice going you incompetent morons! Another one of our engineers vaporized!','',26124),
(17218,'enUS','Thankfully, there\'s a steady stream of these fools chomping at the bit to get in here.','',26124),
(17219,'enUS','What\'s an \"Ologist?\" A better question might be what isn\'t an \"Ologist.\" It means I study everything! In fact, I\'m so well versed in \"everything\" that I\'m guaranteed to be the most intelligent ethereal you\'ll ever meet - or your money back.$B$BApologies. That\'s the dealer in me talking...','',26124),
(17220,'enUS','I\'m neither slim nor shady. As a matter of fact, I find both references insulting.$B$BNow, get out of my sight before I plant my staff up your backside.','',26124),
(17221,'enUS','Ah, I see you are a friend to the Consortium. Perhaps you would be interested in making a purchase?','',26124),
(17222,'enUS','Show me what you have for sale, \"Slim.\"','Show me what you have for sale, \"Slim.\"',26124),
(17223,'enUS','That Shaffar is a clever one. He\'s rigged the entrance with some sort of ward to prevent other ethereal groups from entering. We\'re working on breaking through his defenses so we can get in there and take what\'s ours. I\'ve got top ethereals working on this around the clock. We\'ll have it open any minute now. I can feel it...','',26124),
(17224,'enUS','I don\'t give a damn what Shaffar\'s ethereals have placed over the entrance to the Mana-Tombs. You will work until those wards are removed and the Consortium can move in safely and take what\'s rightfully ours!','',26124),
(17225,'enUS','I don\'t pay you engineers exorbitant amounts of gold so that I can hear the words \"no\" or \"can\'t\" exit your wrappings. Bring that barrier down or you\'ll find yourselves working the energy reclamation line on X-17.','',26124),
(17226,'enUS','I\'m close to the edge, Morphalius. Another screw up and it\'ll be you running through that portal for Kaftiz\'s tests.','',26124),
(17227,'enUS','At ease, men.','',26124),
(17228,'enUS','%s checks to make sure his body is intact.','',26124),
(17229,'enUS','You made it! Well done, $r. Now if you\'ll excuse me, I have to get the rest of our crew inside.','',26124),
(17230,'enUS','%s expertly manipulates the control panel.','',26124),
(17231,'enUS','Let\'s not waste any time! Take anything that isn\'t nailed down to the floor and teleport directly to Stormspire! Chop chop!','',26124),
(17232,'enUS','The control panel shifts and rotates on its axis.','',26124),
(17233,'enUS','<Push a random button.>','<Push a random button.>',26124),
(17234,'enUS','','',26124),
(17235,'enUS','The market sure looks busy today.','',26124),
(17236,'enUS','Look at those crazy kids running around.  Not a care in the world.','',26124),
(17237,'enUS','What manner of creature is that?  Looks like a purple goblin.','',26124),
(17238,'enUS','Do not burden A\'dal with mundane questions, $r.  This being\'s will is all that keeps our enemies from crushing this city.','',26124),
(17239,'enUS','Follow me, stranger.  This won\'t take long.','',26124),
(17240,'enUS','Shattrath was once the draenei capital of this world. Its name means \"dwelling of light.\"','',26124),
(17241,'enUS','Bravo! Bravo! Good show... I couldn\'t convince you to work for me, could I? No, I suppose the needless slaughter of my employees might negatively impact your employment application.','',26124),
(17242,'enUS','The Sha\'tar, or \"born from light\" are the naaru that came to Outland to fight the demons of the Burning Legion.','',26124),
(17243,'enUS','Your plan was a good one, Sha\'heen, and you would have gotten away with it if not for one thing...','',26124),
(17244,'enUS','Never underestimate the other ethereal\'s greed!','',26124),
(17245,'enUS','It wouldn\'t be long, however, before the city came under attack once again.  This time, the attack came from Illidan\'s armies. A large regiment of blood elves had been sent by Illidan\'s ally, Kael\'thas Sunstrider, to lay waste to the city.','',26124),
(17246,'enUS','This should\'t take very long. Just watch my back as I empty these nether collectors.','',26124),
(17247,'enUS','The blood elves laid down their weapons in front of the city\'s defenders; their leader, a blood elf elder known as Voren\'thal, stormed into the Terrace of Light and demanded to speak to A\'dal.','',26124),
(17248,'enUS','Fantastic! Let\'s move on, shall we?','',26124),
(17249,'enUS','Looking at these energy levels, Shaffar was set to make a killing!','',26124),
(17250,'enUS','The defection of Voren\'thal and his followers was the largest loss ever incurred by Kael\'s forces. And these weren\'t just any blood elves.  Many of the best and brightest amongst Kael\'s scholars and magisters had been swayed by Voren\'thal\'s influence.\n','',26124),
(17251,'enUS','That should do it...','',26124),
(17252,'enUS','Hrm, now where is the next collector?','',26124),
(17253,'enUS','The Aldor are followers of the Light and forgiveness and redemption are values they understand. However, they found hard to forget the deeds of the blood elves while under Kael\'s command.','',26124),
(17254,'enUS','Ah, there it is. Follow me, fleshling.','',26124),
(17255,'enUS','There can\'t be too many more of these collectors. Just keep me safe as I do my job.','',26124),
(17256,'enUS','What do we have here? I thought you said the area was secure? This is now the third attack? If we make it out of here, I will definitely be deducting this from your reward. Now don\'t just stand there, destroy them so I can get to that collector.','',26124),
(17257,'enUS','The attacks against Shattrath continued, but the city did not fall, as you can see. On the contrary, the naaru known as Xi\'ri led a successful incursion into Shadowmoon Valley - Illidan\'s doorstep.','',26124),
(17258,'enUS','We\'re close to the exit. I\'ll let you rest for about thirty seconds, but then we\'re out of here.','',26124),
(17260,'enUS','Are you ready to go?','',26124),
(17261,'enUS','Ok break time is OVER. Let\'s go!','',26124),
(17262,'enUS','Khadgar should be ready to see you again.  Just remember that to serve the Sha\'tar you will most likely have to ally with the Aldor or the Scryers. And seeking the favor of one group will cause the others\' dislike.\n','',26124),
(17263,'enUS','Oh really? And what might that be?','',26124),
(17264,'enUS','He was right, you know. I\'ll have to take that tag-line for my own... It\'s not like he\'ll have a use for it anymore!','',26124),
(17265,'enUS','Thanks and good luck!','',26124),
(17266,'enUS','Show our guest around Shattrath, will you?  Keep an eye out for pickpockets in the Lower City.','',26124),
(17268,'enUS','When the Burning Legion turned the orcs against the draenei, the fiercest battle was fought here. The draenei fought tooth and nail, but in the end the city fell.','',26124),
(17269,'enUS','The city was left in ruins and darkness... until the Sha\'tar arrived.','',26124),
(17270,'enUS','Let us go into the Lower City.  I will warn you that as one of the only safe havens in Outland, Shattrath has attracted droves of refugees from all wars, current and past.','',26124),
(17271,'enUS','They were drawn to the ruins of Shattrath City where a small remnant of the draenei priesthood conducted its rites inside a ruined temple on this very spot.\n','',26124),
(17272,'enUS','The priesthood, known as the Aldor, quickly regained its strength as word spread that the naaru had returned and reconstruction soon began.  The ruined temple is now used as an infirmary for injured refugees.','',26124),
(17274,'enUS','As the regiment of blood elves crossed this very bridge, the Aldor\'s exarchs and vindicators lined up to defend the Terrace of Light.  But then the unexpected happened.\n','',26124),
(17275,'enUS','As the naaru approached him, Voren\'thal kneeled before him and uttered the following words: \"I\'ve seen you in a vision, naaru. My race\'s only hope for survival lies with you. My followers and I are here to serve you.\"','',26124),
(17276,'enUS','The naaru accepted the defectors, who would be known as the Scryers; their dwelling lies in the platform above.  Only those initiated with the Scryers are allowed there.','',26124),
(17277,'enUS','Many of the priesthood had been slain by the same magisters who now vowed to serve the naaru.  They were not happy to share the city with their former enemies.','',26124),
(17278,'enUS','The Aldor\'s most holy temple and its surrounding dwellings lie on the terrace above.  As a holy site, only the initiated are welcome inside.\n','',26124),
(17279,'enUS','There he continues to wage war on Illidan with the assistance of the Aldor and the Scryers.  The two factions have not given up on their old feuds, though.','',26124),
(17280,'enUS','Such is their animosity that they vie for the honor of being sent to assist the naaru there. Each day, that decision is made here by A\'dal.  The armies gather here to receive A\'dal\'s blessing before heading to Shadowmoon.','',26124),
(17281,'enUS','Good luck stranger, and welcome to Shattrath City.','',26124),
(17282,'enUS','','A newcomer to Shattrath!  Make sure to drop by later.  We can always use a hand with the injured.',26124),
(17283,'enUS','Khadgar himself is showing you around?  You must have made a good impression, $n.','',26124),
(17284,'enUS','Be mindful of what you say, this one\'s being shown around by Khadgar\'s pet.','',26124),
(17285,'enUS','','Are you joking?  I\'m a Scryer, I always watch what I say.  More enemies than allies in this city, it seems.',26124),
(17286,'enUS','Light be with you, $n.  And welcome to Shattrath.','Light be with you, $n.  And welcome to Shattrath.',26124),
(17287,'enUS','We\'re rather selective of who we befriend, $n.  You think you have what it takes?','We\'re rather selective of who we befriend, $n.  You think you have what it takes?',26124),
(17288,'enUS','<The image\'s head blurs as it turns to take in its surroundings.>$B$BIf you had seen the Plains of Farahlon, you wouldn\'t believe this is the same place. Mere months ago, these fields would not have looked out of place in Westfall.$B$BAll that is gone now, but how and why?','',26124),
(17289,'enUS','The land is in worse shape than I could\'ve imagined. If the damage continues at this rate, Farahlon -- err, Netherstorm will be nothing but cosmic gravel very soon.$B$BWhere will it stop, I wonder? Perhaps the better question is, \'will it stop?\'','',26124),
(17290,'enUS','<The archmage\'s image seems to look through you, rather than at you.>$B$BRibbons and currents of arcane energy ebb and flow here as if the area is awash in a sea of magical power. Not even the first cataclysm caused this kind of damage.','',26124),
(17291,'enUS','I will have my revenge on Kael\'thas for this outrage against the Kirin Tor! He once walked among us as a brother, but we are brothers no more.$B$BThere will be a reckoning.$B$B<The archmage nods grimly, not relishing the prospect.>$B$BKael\'thas is more than a mere rogue mage. Once I am free from my tower, Ravandwyr and I will assist anyone who opposes him.','',26124),
(17292,'enUS','The orb behind me was once capable of glimpsing into the happenings on Azeroth.$B$BKael\'thas\'s curse changed all that, of course, but during our years of isolation many of the mages found solace in its images.$B$BSome scried to remember; some scried to forget. ','',26124),
(17293,'enUS','If you\'ve been sent to kill me, please take a number and wait your turn.','',26124),
(17294,'enUS','<Archmage Vargoth favors you with a wry smile.>$B$BPlenty of room at the cursed Violet Tower.$B$BAny time of year, you can find me here.','',26124),
(17295,'enUS','The night Kael\'thas leveled the village, I could do nothing to help. His magic had already sealed me in the tower, exacerbating my torment by forcing me to witness the deaths of my fellows.$B$BAnd still their voices are calling from far away, waking me up in the middle of the night. ','',26124),
(17296,'enUS','Keep it down!  I don\'t want them to see me over here.$B$BOoh, this really burns me up!  Who do these ethereals think they are?$B$BThis is MY claim!','',26124),
(17297,'enUS','','Please leave me to my sadness.',26124),
(17298,'enUS','Welcome back, $n.','Welcome back, $n.',26124),
(17299,'enUS','I wouldn\'t venture into the Scryer\'s Terrace if I were you, $n.  You are not welcome there.','I wouldn\'t venture into the Scryer\'s Terrace if I were you, $n.  You are not welcome there.',26124),
(17300,'enUS','','Father, give me strength to go on.',26124),
(17301,'enUS','','Give me a sign... anything...',26124),
(17302,'enUS','','Please, father, I do not have your strength. I cannot do this on my own. Please help me...',26124),
(17303,'enUS','%s giggles.','',26124),
(17304,'enUS','%s nods.','',26124),
(17305,'enUS','%s smiles.','',26124),
(17306,'enUS','%s laughs.','',26124),
(17307,'enUS','I\'ll tell her, Greatfather.','',26124),
(17308,'enUS','You promise?','',26124),
(17309,'enUS','Ok!','',26124),
(17310,'enUS','I will, Greatfather.','',26124),
(17311,'enUS','%s tugs on Clarissa\'s robe.','',26124),
(17312,'enUS','Mommy, Greatfather says everything will be ok.','',26124),
(17313,'enUS','Don\'t cry, Mommy. Greatfather says not to worry.','',26124),
(17314,'enUS','Mommy, Greatfather told me that he will watch over us and make sure we\'re ok.','',26124),
(17315,'enUS','','%s wipes the tears away.',26124),
(17316,'enUS','','Oh sweetheart, grandpoppy has passed. It will be ok.',26124),
(17317,'enUS','','I know it will be ok, baby.',26124),
(17318,'enUS','','In the end, we will all be together, sweetheart.',26124),
(17319,'enUS','','Mommy is going to make sure you\'re ok, baby.',26124),
(17320,'enUS','','Mommy won\'t let anyone harm you, sweetheart.',26124),
(17321,'enUS','Be silent! Damn you, spirits!','',26124),
(17322,'enUS','Throw me out of the priory, will they?','',26124),
(17323,'enUS','I\'ll show them... I\'ll show them all!','',26124),
(17324,'enUS','No, spirit, I am afraid that they are all trapped inside - FOREVER! Now leave me be...','',26124),
(17325,'enUS','I broke a covenant? I BROKE A COVENANT? What about that fool exarch and his avatar?','',26124),
(17326,'enUS','The dead are not supposed to speak. Now be silent!','',26124),
(17327,'enUS','Why? WHY! Why was I \"gifted\" such a burden?','',26124),
(17328,'enUS','%s rummages through the bones.','',26124),
(17329,'enUS','It is good to see you again, $n.','It is good to see you again, $n.',26124),
(17330,'enUS','The Aldor welcome you, $n.','The Aldor welcome you, $n.',26124),
(17331,'enUS','May the Light guide you, $n.','May the Light guide you, $n.',26124),
(17332,'enUS','I would not venture further if I were you, $n.  You are not permitted above.','I would not venture further if I were you, $n.  You are not permitted above.',26124),
(17333,'enUS','It would be to your benefit for you to stay away from our holy grounds, $n.','It would be to your benefit for you to stay away from our holy grounds, $n.',26124),
(17334,'enUS','You\'ll have to prove yourself to us before you\'re welcome here, $n.','You\'ll have to prove yourself to us before you\'re welcome here, $n.',26124),
(17335,'enUS','Psst, hey, $n.  Up here on the platform.  Hurry!','',26124),
(17336,'enUS','I will not be taken so easily! Let the walls of this prison tremble... and fall!','',26124),
(17337,'enUS','Lambs! Lemmings! All of them!','',26124),
(17338,'enUS','%s becomes unstable and begins to disintegrate!','%s becomes unstable and begins to disintegrate!',26124),
(17339,'enUS','Wretched, meddling insects! Release me, and perhaps I will grant you a merciful death!','',26124),
(17340,'enUS','Vermin! Leeches! Take my blood and choke on it!','',26124),
(17341,'enUS','Illidan is an arrogant fool! I will crush him and reclaim Outland as my own!','',26124),
(17342,'enUS','Away, you mindless parasites! My blood is my own!','',26124),
(17343,'enUS','How long do you believe your pathetic sorcery can hold me?','',26124),
(17344,'enUS','My blood will be the end of you!','',26124),
(17345,'enUS','When Rocket-Chief Fuselage was asking for volunteers to help out with building the X-52 Nether-Rocket, I submitted my resume for the security division.$B$BUnfortunately, the only position that was left was chief engineer.  Lucky for me, I have Xyrol here to look over my shoulder.','',26124),
(17346,'enUS','I... am... unleashed!','',26124),
(17347,'enUS','The Legion will consume you all!','',26124),
(17348,'enUS','Not again! Not again...','',26124),
(17349,'enUS','Did you think me weak? Soft? Who is the weak one now?','',26124),
(17350,'enUS','Help!  A mana wraith!  It\'s come to avenge its brethren and steal back their essences!','',26124),
(17351,'enUS','Welcome, friend of the free people of the Lower City, but do not tarry long.$B$BThere are sounds of battle coming from within.  My compatriots could use your assistance!','',26124),
(17352,'enUS','If you become a friend of the Lower City, perhaps we can do business?','',26124),
(17353,'enUS','Time to teach you a lesson in manners, little $g boy:girl;!','',26124),
(17354,'enUS','Now I\'m gonna give you to the count of \'3\' to get out of here before I sick the dogs on you.','',26124),
(17355,'enUS','1...','',26124),
(17356,'enUS','2...','',26124),
(17357,'enUS','Time to meet your maker!','',26124),
(17358,'enUS','%s cracks his knuckles.','',26124),
(17359,'enUS','','Can you believe this ethereal technology?!$B$BI\'m sure glad they let me stay out here with them.  I\'m gonna learn a lot... and maybe get some of it for myself, too!',26124),
(17360,'enUS','Oh, come on!  First the mana wraith and now revenge from a stalker?!  No, you\'re not getting your mojo back!','',26124),
(17361,'enUS','Alright, we give up! Don\'t hurt us!','',26124),
(17362,'enUS','Unbelievable!  Anyone else want to attack?','',26124),
(17363,'enUS','%s falls unconscious.','',26124),
(17364,'enUS','Beat it, kid. I got business to attend to...','',26124),
(17365,'enUS','Ezekiel said that you might have a certain book...','Ezekiel said that you might have a certain book...',26124),
(17366,'enUS','Intruders have breached the factory!  Engage emergency defense protocol immediately!','Intruders have breached the factory!  Engage emergency defense protocol immediately!',26124),
(17367,'enUS','Species: Ered\'ruin','Species: Ered\'ruin',26124),
(17368,'enUS','Affiliation: Burning Legion','Affiliation: Burning Legion',26124),
(17369,'enUS','Function: Shock Troops, Enforcers','Function: Shock Troops, Enforcers',26124),
(17370,'enUS','Powerful and deliberate, these winged aberrations are renowned across the cosmos for their brutality.','Powerful and deliberate, these winged aberrations are renowned across the cosmos for their brutality.',26124),
(17371,'enUS','Species: Eredar','Species: Eredar',26124),
(17372,'enUS','Species: Sayaad','Species: Sayaad',26124),
(17373,'enUS','Species: Shivarra','Species: Shivarra',26124),
(17374,'enUS','Species: Nathrezim','Species: Nathrezim',26124),
(17375,'enUS','Species: Eredar','Species: Eredar',26124),
(17376,'enUS','Species: Annihilan','Species: Annihilan',26124),
(17377,'enUS','Species: Mo\'arg','Species: Mo\'arg',26124),
(17378,'enUS','Species: Mo\'arg','Species: Mo\'arg',26124),
(17379,'enUS','Species: Mo\'arg','Species: Mo\'arg',26124),
(17380,'enUS','Affiliation: Burning Legion','Affiliation: Burning Legion',26124),
(17381,'enUS','Affiliation: Burning Legion','Affiliation: Burning Legion',26124),
(17382,'enUS','Affiliation: Burning Legion','Affiliation: Burning Legion',26124),
(17383,'enUS','Affiliation: Burning Legion','Affiliation: Burning Legion',26124),
(17384,'enUS','Affiliation: Burning Legion','Affiliation: Burning Legion',26124),
(17385,'enUS','Affiliation: Burning Legion','Affiliation: Burning Legion',26124),
(17386,'enUS','Affiliation: Burning Legion','Affiliation: Burning Legion',26124),
(17387,'enUS','Affiliation: Burning Legion','Affiliation: Burning Legion',26124),
(17388,'enUS','Affiliation: Burning Legion','Affiliation: Burning Legion',26124),
(17389,'enUS','Function: Honor Guard','Function: Honor Guard',26124),
(17390,'enUS','Function: Intelligence Agents, Torturers','Function: Intelligence Agents, Torturers',26124),
(17391,'enUS','Function: Priestesses, Military Chaplains','Function: Priestesses, Military Chaplains',26124),
(17392,'enUS','Function: Secret Police, Interrogator','Function: Secret Police, Interrogators',26124),
(17393,'enUS','Function: Overlords, Strategists','Function: Overlords, Strategists',26124),
(17394,'enUS','Function: Generals, Ground Commanders','Function: Generals, Ground Commanders',26124),
(17395,'enUS','Function: Tinkerers, Machine-smiths','Function: Tinkerers, Machine-smiths',26124),
(17396,'enUS','Function: Engineers, Scientists','Function: Engineers, Scientists',26124),
(17397,'enUS','Function: Standard Soldiers','Function: Standard Soldiers',26124),
(17398,'enUS','Cunning and precise, the Wrathguard often protect the Legion\'s eredar masters.','Cunning and precise, the Wrathguard often protect the Legion\'s eredar masters.',26124),
(17399,'enUS','The cruel sayaadi temptresses exemplify the subtler side of the Legion\'s nihilistic Crusade.','The cruel sayaadi temptresses exemplify the subtler side of the Legion\'s nihilistic Crusade.',26124),
(17400,'enUS','Devout and exceedingly charismatic, these priestesses live only to evangelize the power of Sargeras\' dread vision.','Devout and exceedingly charismatic, these priestesses live only to evangelize the power of Sargeras\' dread vision.',26124),
(17401,'enUS','The Nathrezim are merciless villains who feed upon the energies of mortal creatures.','The Nathrezim are merciless villains who feed upon the energies of mortal creatures.',26124),
(17402,'enUS','The cunning, powerful eredar warlocks were once our noble kinsmen.','The cunning, powerful eredar warlocks were once our noble kinsmen.',26124),
(17403,'enUS','These colossal destroyers serve as the Legion\'s military commanders.','These colossal destroyers serve as the Legion\'s military commanders.',26124),
(17404,'enUS','These stunted mo\'arg are very clever, and are often employed as helpers for their larger brethren.','These stunted mo\'arg are very clever, and are often employed as helpers for their larger brethren.',26124),
(17405,'enUS','Brutish though they seem, these iron-stitched horrors are exceedingly brilliant engineers and forge-smiths.','Brutish though they seem, these iron-stitched horrors are exceedingly brilliant engineers and forge-smiths.',26124),
(17406,'enUS','Conscripted from the mo\'arg race, these warriors serve as the Legion\'s rank and file soldiers.','Conscripted from the mo\'arg race, these warriors serve as the Legion\'s rank and file soldiers.',26124),
(17407,'enUS','Thank goodness you got here, it was almost dinner time!','',26124),
(17408,'enUS','Hahaha!  We\'re coming for you, little goblins!','',26124),
(17409,'enUS','I thought I was a goner for sure.','',26124),
(17410,'enUS','I don\'t know which is worse, getting eaten by fel orcs or working for that slave master Razelcraz! Oh well, thanks anyways!','',26124),
(17411,'enUS','Let\'s see what you have.','Let\'s see what you have.',26124),
(17412,'enUS','It is said that those who are blessed by the spirits of Auchindoun possess the ability to capture powerful souls in the form of Spirit Shards. I have come across a few of these Spirit Shards throughout my travels but have yet to unlock their secrets. \n\nThe only thing I have been able to discern is that they seem to originate from the depths of Auchindoun itself. If you happen to come across any of these Spirit Shards I\'m sure I could make it worth your while to allow me to take them off your hands...','',26124),
(17413,'enUS','All my bags are packed, I\'m ready to go.','',26124),
(17414,'enUS','The ship\'s not ready yet.  We still need to calibrate the fuse length to make sure that it doesn\'t burn out and leave you up there alone.','',26124),
(17415,'enUS','The armies of the Burning Legion are attacking all across Azeroth. We need heroes to throw them back!','The armies of the Burning Legion are attacking all across Azeroth. We need heroes to throw them back!',26124),
(17416,'enUS','You need to do what? All this science, I don\'t understand... Look, this is just my job, five days a week.','',26124),
(17417,'enUS','Essentially, it\'s going to be a long, long time till we are ready to launch.  Maybe you should just head back home to your family.','',26124),
(17418,'enUS','Lend me a Windrider.  I\'m going to Spinebreaker Post!','Lend me a Windrider.  I\'m going to Spinebreaker Post!',26124),
(17419,'enUS','I can\'t. I\'m not the man they think I am at home.  Besides, I didn\'t bring them out here.','',26124),
(17420,'enUS','Why not? A family can give you strength.','',26124),
(17421,'enUS','This isn\'t the kind of place to raise your kids. It\'s cold, and there\'d be no one to raise them.','',26124),
(17422,'enUS','Couldn\'t you raise them?','',26124),
(17423,'enUS','Oh no, no, no... I\'m a rocket man.','',26124),
(17424,'enUS','Well, it\'s like I said; it\'s going to be a while before we get this ship ready for flight.  We\'ll keep you informed.','',26124),
(17425,'enUS','This crystal-based construct hums with energy.  Strange glyphs are projected in front of you and scroll in rapid succession.','',26124),
(17426,'enUS','During the full moon of the Lunar Festival, we celebrate the light of Elune.','During the full moon of the Lunar Festival, we celebrate the light of Elune.',26124),
(17427,'enUS','Busy, busy!  So much to do, so little time!$B$BNow where did I put that pyrospanner?  I know it\'s around here somewhere... I burned my fingers on it just a moment ago!','',26124),
(17428,'enUS','It is no surprise that the people of this land hold a great festival of the moon. I should very much like to go to Moonglade to attend it.','It is no surprise that the people of this land hold a great festival of the moon. I should very much like to go to Moonglade to attend it.',26124),
(17429,'enUS','Make them work faster!','',26124),
(17430,'enUS','We must get all of this fel reaver tech out of here before the Stormspire comes down on us!','',26124),
(17431,'enUS','Go tell them to hurry!','',26124),
(17432,'enUS','This operation is moving too slowly.  Go motivate them!','',26124),
(17433,'enUS','I want all of this fel reaver technology packed up and ready to ship out within the next turning of Outland!','',26124),
(17434,'enUS','You there!  Go check to make sure they\'re doing their jobs!','',26124),
(17435,'enUS','There\'s nothing like running your own enterprise.  But do I have to do everything myself?  Tell them to speed it up!','',26124),
(17436,'enUS','If we catch that turncoat, Khay\'ji, I\'m going to unravel him personally!  Go look for him!','',26124),
(17437,'enUS','Do you think we can pull off a passable disguise?','',26124),
(17438,'enUS','Not sure if this is going to be good enough.  These aren\'t troggs we\'re trying to fool.','',26124),
(17439,'enUS','','I think you\'ve got the shoulders wrong.  Looks close, though.',26124),
(17440,'enUS','Knowing a little magic comes in handy in this line of work.  Illusions can\'t always fool everyone, but they\'re usually good enough to get the job done.','',26124),
(17441,'enUS','Three cheers for $n!  $G He\'s : She\'s; saved the town from the Burning Legion!','',26124),
(17442,'enUS','Hooray!','',26124),
(17443,'enUS','What are you doing here?  Shouldn\'t you be working on the energy pipeline?$B$BWe\'ve more than doubled the amount of energy we\'re sending to Tempest Keep and can\'t afford anyone loafing.  We don\'t want another Ultris to happen here.','',26124),
(17444,'enUS','Ultris?','Ultris?',26124),
(17445,'enUS','Manaforge Ultris, of course!  Where have you been?$B$BThe manaforge was overloaded and created a huge explosion.  It left a tear in reality and now void creatures have been pouring in through it.  You can see them all over the place towards the northeast.','',26124),
(17446,'enUS','%s reads from the book of the dead.','',26124),
(17447,'enUS','Jeffrey Kaplan! Tom Chilton! Rob Pardo!','',26124),
(17448,'enUS','Justin Thavirat! Roman Kenney! Our entire awesome art and animation team!','',26124),
(17449,'enUS','CHRIS METZEN!','',26124),
(17450,'enUS','Pat Nagle! World design team! Cory Stockton, Paul C., Jim Chadwick, Staats, Ed Hanes, Morris, Gotcher, Jesse!, Sarah B., Victor C., Dave A.! All of our amazing exterior artists!','',26124),
(17451,'enUS','Scott Mercer! Geoff, Wyatt, Joe, Travis, Kris, Steven! Brazie!','',26124),
(17452,'enUS','Luis, Brianna and Eric! Blizzard QA team! Of course our fans!','',26124),
(17453,'enUS','Kevin Jordan and Jonathan LeCraft!','',26124),
(17454,'enUS','Shane Dabiri, Lee, Alex T., Rob F., J. A. B.,  A. Mayberry!','',26124),
(17455,'enUS','I AM DEATH!  PREPARE YOUR TOWN FOR ANNIHILATION!','',26124),
(17456,'enUS','Oh no!  What\'s that?  Quickly, defend us with the Scrap Reaver X6000!!!','',26124),
(17457,'enUS','Urtrak kill you!','',26124),
(17458,'enUS','Vengeance is ours!  Attack my brothers!','Vengeance is ours!  Attack my brothers!',26124),
(17459,'enUS','And now to do what I should have done a hundred years ago.','',26124),
(17460,'enUS','Never again...','',26124),
(17461,'enUS','Form ranks and make the intruders pay!','',26124),
(17462,'enUS','Hold them back at all costs!','',26124),
(17463,'enUS','You ought to feel safe here; we\'ve stepped up security at this facility after the attacks on Manaforge Duro.','',26124),
(17464,'enUS','Who attacked Manaforge Duro?','Who attacked Manaforge Duro?',26124),
(17465,'enUS','Manaforge Duro is the closest facility to Tempest Keep, so it handles most of the load.$B$BAs you should know, overloading these manaforges causes leaks in the pipelines.  The emanating energy attracts unwanted mana creatures.  We\'ve had mana creature infestations at many leak locations; Manaforge Duro is being hit the hardest at the moment.','',26124),
(17466,'enUS','HAHAHA!  YOUR FEEBLE ROCKET IS DESTROYED!  I\'LL RETURN LATER TO FINISH OFF THE REST OF YOUR PUNY TOWN!','',26124),
(17467,'enUS','Tell me of the Sons of Lothar.','Tell me of the Sons of Lothar.',26124),
(17468,'enUS','YOUR SAD ATTEMPT AT CREATING A FEL REAVER TO STOP ME HAS FAILED!  NOW, ON TO AREA 52!','',26124),
(17469,'enUS','','Working with this technology is a huge headache.  Everything is constructed in such an alien way.',26124),
(17470,'enUS','Many years ago, my men and I followed the wizard Khadgar and the paladin Turalyon to this world. Our sole aim was to annihilate the orcs and their vile kin. Yet something went terribly wrong in the final hours of our war.$B$BUltimately, this dark world was ripped asunder - and my dear friends were lost to the void.','',26124),
(17471,'enUS','<more>','<more>',26124),
(17472,'enUS','We, the Sons of Lothar, have remained here ever since - fighting... dying... praying that a day like today would come - a day when the Portal would open and our brothers would come to deliver us home.$B$BOverjoyed as we are, duty still calls. There is much to be done before we can depart this world and take our rest.\n','',26124),
(17474,'enUS','Oh no!  The X-52 Nether-Rocket is being attacked!  Guards!  Guards!','',26124),
(17475,'enUS','Where did this technology come from?','Where did this technology come from?',26124),
(17476,'enUS','','Don\'t they teach you new recruits anything?  These manaforges were built from parts of Tempest Keep designed to siphon energy from the nether.$B$BThe naaru used this technology to power their vessel during its travels.  Some said the technology might not be safe to use on land.  They were promptly silenced.',26124),
(17477,'enUS','Another soldier on $ghis:her; way to Honor Hold... by Kurdran\'s beard, they can use the help!','Another soldier on $ghis:her; way to Honor Hold... by Kurdran\'s beard, they can use the help!',26124),
(17478,'enUS','Send me to Honor Hold!','Send me to Honor Hold!',26124),
(17479,'enUS','Ack!  My beautiful X-52 Nether-Rocket.  We\'ll have to quadruple our efforts to get this damage repaired!','',26124),
(17480,'enUS','It\'s my passion, you know. In life and in death, armorcrafting is what I love. Please, treat me as if I were a living draenei, stranger. Let me know what it is to feel again... Allow me the honor of repairing your items.','',26124),
(17481,'enUS','Please repair my items.','Please repair my items.',26124),
(17482,'enUS','The Consortium will exact its revenge upon the Zaxxis betrayers!','',26124),
(17483,'enUS','Ah, a new champion to aid our cause? What say you, $n? \n','',26124),
(17484,'enUS','$n, the Sons of Lothar have fought here, on the Hellfire Peninsula, for two decades.  We are beset on all sides by indigenous orcs and hellish demons of the Burning Crusade, and though our hearts still beat fiercely, years of war have reduced our numbers.$B$BYou, and the influx of Azeroth\'s new generation of heroes, are a welcome sight indeed!','',26124),
(17485,'enUS','Bip!','',26124),
(17486,'enUS','Hey, you there.  Want some candy?','',26124),
(17487,'enUS','Spare some change for a starving artist?','',26124),
(17488,'enUS','What up son!  Wait....is anyone there?','',26124),
(17489,'enUS','Tell me of the Hellfire orcs.','Tell me of the Hellfire orcs.',26124),
(17490,'enUS','Orcs. It seems I\'ve been fighting them all my life.$B$BTwenty years ago we shattered the Horde and tore down the walls of their Hellfire Citadel. We drove the vile greenskins to the very brink! After that, other than a few skirmishes the broken orcs never again posed a threat to us.$B$BUntil now. \n','',26124),
(17491,'enUS','Is there no one left to test me? ','',26124),
(17492,'enUS','Your time is running out!','',26124),
(17493,'enUS','You are nothing! I answer a higher call....','',26124),
(17494,'enUS','The dark lord laughs at you!','',26124),
(17495,'enUS','It is over! Finished!','',26124),
(17496,'enUS','Your days are done!','',26124),
(17497,'enUS','My lord will be... the end of you all!','',26124),
(17498,'enUS','Heal me, quickly!','',26124),
(17499,'enUS','Back off, pup!','',26124),
(17500,'enUS','Say farewell!','',26124),
(17501,'enUS','Much too easy.','',26124),
(17502,'enUS','What have we here?','',26124),
(17503,'enUS','This may hurt a little....','',26124),
(17504,'enUS','I\'m going to enjoy this...','',26124),
(17505,'enUS','We fight to the death!','',26124),
(17506,'enUS','I will end this quickly....','',26124),
(17507,'enUS','Acalah pek ecta!','',26124),
(17508,'enUS','Krypta!\n','',26124),
(17509,'enUS','It is finished.\n','',26124),
(17510,'enUS','Well... done...','',26124),
(17511,'enUS','Beast! Obey me! Kill them at once!','',26124),
(17512,'enUS','Jero\'me falls into a drunken sleep.','',26124),
(17513,'enUS','Jero\'me wakes up and slowly rises to his feet.','',26124),
(17514,'enUS','Welcome to Honor Hold, $n.  It\'s good to have you.','',26124),
(17515,'enUS','The dark ones had taken a hold of me, master. You were merciful in seeking my death. Forgive me...','',26124),
(17516,'enUS','','',26124),
(17517,'enUS','In death, all is forgiven...','',26124),
(17518,'enUS','','Father? Father is that you?',26124),
(17519,'enUS','It will be alright, darling. Grieve no more...','',26124),
(17520,'enUS','%s nods.','',26124),
(17521,'enUS','About twenty years ago, the Alliance launched the first Expedition to this world in hopes of eradicating the orcs forever. It was a... terrible conflict. Many brave souls perished to assure Azeroth\'s safety.$B$BYet some souls remain...locked in eternal combat.','',26124),
(17522,'enUS','About twenty years ago, the Alliance launched the first Expedition to this world in hopes of eradicating the orcs forever. It was a... terrible conflict. Many brave souls perished to assure Azeroth\'s safety.$B$BThank you, $n, for helping those souls find peace.','',26124),
(17523,'enUS','The men and women of Honor Hold have shed such blood and have lost their youth in this monstrous land... and yet they still hold their spirits high!$B$BNow, you and your cohorts from Azeroth can help us turn the tide.  You give us hope that we may one day return to our homelands.','',26124),
(17524,'enUS','I can\'t thank you enough for your help, $n. At long last, I will be free of this tower and Kael\'s damnable magic!','',26124),
(17525,'enUS','Tell me of your homeland.','Tell me of your homeland.',26124),
(17526,'enUS','No! How could the ritual fail?','',26124),
(17527,'enUS','The Lunar Festival is in full swing in Moonglade. A delegation of druids can be found in the throne room of Undercity, transporting people there.','The Lunar Festival is in full swing in Moonglade. A delegation of druids can be found in the throne room of Undercity, transporting people there.',26124),
(17528,'enUS','It seems the heart of the Lunar Festival celebration is in Moonglade. The druids in the Cenarion Enclave in Darnassus can transport you there if you don\'t want to walk.','It seems the heart of the Lunar Festival celebration is in Moonglade. The druids in the Cenarion Enclave in Darnassus can transport you there if you don\'t want to walk.',26124),
(17529,'enUS','','A flickering image of a female blood elf commander appears. From the surroundings, you can tell she must be inside Tempest Keep.',26124),
(17530,'enUS','','The blood elf doesn\'t appear to be a magister, but perhaps she holds something that is the key to the tower\'s curse.',26124),
(17531,'enUS','There was little time before the watchers of Nethergarde sensed a disturbance in the portal... and the demons screamed into our world!$B$BAlthough reinforcements from the kingdoms of Azeroth are on the march, we of the Argent Dawn were first to rally behind Nethergarde\'s call.$B$BOur mission: hold these monsters at bay until help from the Alliance and Horde arrives...','',26124),
(17532,'enUS','%s calls for a nearby slave to assist him!','',26124),
(17533,'enUS','Great!  This servo should do the trick!','',26124),
(17534,'enUS','That\'ll do it.  Thanks again for getting us that part!','',26124),
(17535,'enUS','The curse remains intact. We\'ll have to find another way.','',26124),
(17536,'enUS','','Oh dear! What happened here?',26124),
(17537,'enUS','','The timeway collapsed with five of our agents inside.',26124),
(17538,'enUS','','And the kaldorei vessel?',26124),
(17539,'enUS','','It came crashing through shortly after the collapse. We\'re examining it now.',26124),
(17540,'enUS','','%s nods.',26124),
(17541,'enUS','','Fascinating. What is it, Andormu?',26124),
(17542,'enUS','Something very, very disturbing. We\'re starting to see more of them across the timeways.','',26124),
(17543,'enUS','','Hrm, are they tampering with timeways?',26124),
(17544,'enUS','Nozari, I\'m not talking about a greedy wizard looking to improve his station in life by making a small adjustment to the past.','',26124),
(17545,'enUS','These beings aren\'t giving themselves the winning numbers for the Stormwind lottery, dear.','',26124),
(17546,'enUS','','I hate it when you speak to me in that manner. I am your equal in every way, brother. Remember that the next time you are trapped amidst a temporal vortex, crying for help.',26124),
(17547,'enUS','My apologies, Nozari. I have been a bit \'on edge\' as of late. These creatures are attempting to alter the timeways.','',26124),
(17548,'enUS','You do recall the last time that this occurred, yes? Let us hope that the master need not be involved.','',26124),
(17549,'enUS','','Shall we?',26124),
(17550,'enUS','Absolutely not. We must not place ourselves at risk. With the master away, we are all that is in place to keep the stream intact. Others are due to arrive any moment now. Heroes and adventurers from Azeroth...','',26124),
(17551,'enUS','','%s nods.',26124),
(17552,'enUS','Nethergarde, for years, has stood watch over the Dark Portal.  Ever vigilant, it was we who first sensed fel energies leaking through the long closed gateway.$B$BWe raised a global alarm, and the world answered...$B$BNow, the Argent Dawn holds this line as the kingdoms and clans of the Horde and Alliance marshal their forces and rush to aid us!','',26124),
(17553,'enUS','As a representative of the Consortium, I am always mindful of the ramifications that my interactions have upon our business dealings.$B$BIt is unfortunate that the blood elves do not treat their partnerships with such respect.','',26124),
(17554,'enUS','My younger brother here is quite the rising star in the Consortium. Of course, he\'s too modest to acknowledge it.','',26124),
(17555,'enUS','When he says, \'younger brother,\' he fails to mention that we\'re twins. He\'s really only older by a couple of minutes.$B$BDon\'t let that \'rising star\' bit of his fool you. I\'ll never be a trader of the same magnitude that he is.','',26124),
(17556,'enUS','','%s examines the specimen.',26124),
(17557,'enUS','','This specimen is fading from existence. Something or someone is altering the timeway.',26124),
(17558,'enUS','','I can\'t get a reading... Something is interfering...',26124),
(17559,'enUS','','Have the Scale of Sands been made aware?',26124),
(17560,'enUS','','We must dispatch another watcher. Balance must be maintained...',26124),
(17562,'enUS','','%s calls for reinforcements!',26124),
(17563,'enUS','You\'ll be sorry!','',26124),
(17564,'enUS','Hail to you, $r. What I am doing here is a story for another time. Oof, that was a bad one.$B$BMy brother and I are stuck here, between our time and the present. We dare not leave for fear of causing a temporal paradox. Patiently we wait until the dragons restore us to our proper timeline.$B$BHow long has it been you ask? I\'m not sure really. Ask my brother.$B$BCare for some cheese?','',26124),
(17565,'enUS','Time to kill!','',26124),
(17566,'enUS','Cheese, eh? Is it perhaps... aged cheese?','Cheese, eh? Is it perhaps... aged cheese?',26124),
(17567,'enUS','','Hold the line!',26124),
(17568,'enUS','','...steady...',26124),
(17569,'enUS','This... no... good...','',26124),
(17570,'enUS','','Prevent the advance!',26124),
(17571,'enUS','','Looks like I picked the wrong day to quit mana tapping...',26124),
(17572,'enUS','No, you aren\'t hearing things. I actually do have the voice of a young orc woman. But you listen here, $g boy:girl;, time travel does strange things to a body.$B$BBy the way, it\'s 250 years.','',26124),
(17573,'enUS','No coming back for you!','',26124),
(17574,'enUS','I need some reagents and poisons, lady.','I need some reagents and poisons, lady.',26124),
(17575,'enUS','Nice try.','',26124),
(17576,'enUS','Now you gone for good!','',26124),
(17577,'enUS','You fail!','',26124),
(17578,'enUS','','Thank you, kind $gsir:lady;!',26124),
(17579,'enUS','Yep, I\'ve been stuck here for as long as I can remember.$B$BIn my former life, I was an armorer. Perhaps I can fix something for you?','',26124),
(17580,'enUS','I need to repair.','I need to repair.',26124),
(17581,'enUS','Finally, someone came down to talk to me!  Want to hear some of my rhymes?','',26124),
(17582,'enUS','YES!','YES!',26124),
(17583,'enUS','NO!','NO!',26124),
(17584,'enUS','Walking down the street!  Looking at my feet!  Watching the leaves, fall off of the trees!','',26124),
(17585,'enUS','When will this city be done?  Everytime I think im done they tell me I need to work for one more day...','',26124),
(17586,'enUS','I feel like I have been working on this city forever!','',26124),
(17587,'enUS','Sometimes I dream of this amazing city being complete.  Alas, all this work has turned my dreams into nightmares!','',26124),
(17588,'enUS','We only have to work crunch time for a few more weeks.  At least thats what they tell us...','',26124),
(17590,'enUS','This ethereal teleport pad is covered in brightly colored buttons and switches, but seems to have fallen into disuse.','',26124),
(17591,'enUS','All things for sale, my friend!  Large and small, whatever you need, Hazzin will provide.$B$BIf you value your life, do not approach Manaforge Ultris without a resupply.  Hazzin is the last chance that you have.','',26124),
(17592,'enUS','Dealer Hazzin, what do you have to offer?','Dealer Hazzin, what do you have to offer?',26124),
(17593,'enUS','%s calls for his worgs.','',26124),
(17594,'enUS','I have every confidence that we will recover that which Nexus-Prince Haramad desires.','',26124),
(17595,'enUS','%s wakes up, startled.','',26124),
(17596,'enUS','Was... Was it all a dream? Azuremyst, Bloodmyst, Zangarmarsh, Shadowmoon... even Zul\'Aman... Jane! Jane where are you!','',26124),
(17597,'enUS','Ah, wonderful. It was all just a dream...','',26124),
(17598,'enUS','','I\'m right here, daddy. You\'ve been asleep all day long. You sure must be tired!',26124),
(17599,'enUS','','%s resumes playing on the beach.',26124),
(17600,'enUS','I have earned my freedom!','',26124),
(17601,'enUS','This day is long overdue! Out of my way!','',26124),
(17602,'enUS','I am a slave no longer!','',26124),
(17603,'enUS','Blackmoore has much to answer for!','',26124),
(17604,'enUS','You have forced my hand!','',26124),
(17605,'enUS','It should not have come to this!','',26124),
(17606,'enUS','I did not ask for this!','',26124),
(17607,'enUS','I am truly in your debt, strangers.','',26124),
(17608,'enUS','Thank you, strangers. You have given me hope.','',26124),
(17609,'enUS','I will not waste this chance. I will seek out my destiny.','',26124),
(17610,'enUS','Things are looking grim....','',26124),
(17611,'enUS','I\'ll fight... to the last!','',26124),
(17612,'enUS','Taretha....','',26124),
(17613,'enUS','A good day... to die.','',26124),
(17614,'enUS','Ours is the TRUE Horde! The only Horde!','',26124),
(17615,'enUS','Let us hold our discussion in a more... private place. Follow me, $n.','',26124),
(17616,'enUS','I\'ll carve the meat from your bones!','',26124),
(17617,'enUS','I am called Bladefist for a reason. As you will see.','',26124),
(17618,'enUS','You didn\'t really think I\'d do business with you again, did you? Sometimes, the best way to return to profitability is to know when to cut your losses.','',26124),
(17619,'enUS','For the real Horde!','',26124),
(17620,'enUS','I am the ONLY warchief!','',26124),
(17621,'enUS','The true Horde... will prevail.','',26124),
(17622,'enUS','Very well then. Let\'s go!','',26124),
(17623,'enUS','I\'ll never be chained again!','',26124),
(17624,'enUS','Kill $n!','Kill $n!',26124),
(17625,'enUS','','I\'ve never seen anything like these nether dragons. They seem to have inherited their sire\'s temperment, but they have become something entirely different.',26124),
(17626,'enUS','The ground of this place is still warm from freshly shed blood.  Ah, I would have given my own eye to be here when the demons tore through that portal and clashed with Azeroth\'s heroes!  What a battle it was!$B$BBut now, even more fierce fighting rages on the other side!','',26124),
(17627,'enUS','If you have come all the way out here, then it must be that you dare to venture near Manaforge Ara.$B$BCare to buy or sell before you head over?','',26124),
(17628,'enUS','What do you have to sell, Tuluman?','What do you have to sell, Tuluman?',26124),
(17629,'enUS','There are only 3 kinds of people in this world: competitors, customers, and employees. Competitors are to be crushed ruthlessly, customers indulged, and employees strictly supervised.$B$BIndependent contractors are a myth.They want to be paid better than employees, but treated like customers. Never trust one who calls himself by that title.','',26124),
(17630,'enUS','It is... not over.','',26124),
(17631,'enUS','Die, weakling!','',26124),
(17632,'enUS','I am victorious!','',26124),
(17633,'enUS','I will not be defeated!','',26124),
(17634,'enUS','You dare stand against ME?','',26124),
(17635,'enUS','Your insolence will be your death!','',26124),
(17636,'enUS','A-kreesh!','',26124),
(17637,'enUS','Achor she-ki!  Feast, my pet!  Eat your fill!','',26124),
(17638,'enUS','Attempt to contact Wind Trader Marid.','Attempt to contact Wind Trader Marid.',26124),
(17639,'enUS','%s takes a long look into the forest of Terokkar.','',26124),
(17640,'enUS','$n, you have done a great service for us, restoring some of our honor.  Look for us again in your darkest hour when our enemies are near. ','',26124),
(17641,'enUS','This is sacred ground!','This is sacred ground!',26124),
(17642,'enUS','How dare you come here?','How dare you come here?',26124),
(17643,'enUS','Outsiders are forbidden!','Outsiders are forbidden!',26124),
(17644,'enUS','Let your mind be clouded.','',26124),
(17645,'enUS','Stare into the darkness of your soul.','',26124),
(17646,'enUS','This is... where I belong.','',26124),
(17647,'enUS','You will pay with your life!','',26124),
(17648,'enUS','There is no turning back now!','',26124),
(17649,'enUS','Serve your penitence!','',26124),
(17650,'enUS','These walls will be your tomb!','',26124),
(17651,'enUS','Now you\'ll stay... for eternity.','',26124),
(17652,'enUS','%s begins a massive heal!','',26124),
(17653,'enUS','What insolence! What arrogance! To believe you could defeat me on my own doorstep!','',26124),
(17654,'enUS','This exercise bores me.','',26124),
(17655,'enUS','You wish to test me? You are hardly up to the task.','',26124),
(17656,'enUS','','Greetings, $n. I will guide you through the cavern. Please try and keep up.',26124),
(17657,'enUS','','We do not know if the Caverns of Time have always been accessible to mortals. Truly, it is impossible to tell as the Timeless One is in perpetual motion, changing our timeways as he sees fit. What you see now may very well not exist tomorrow. You may wake up yesterday and have no memory of this place.\n',26124),
(17658,'enUS','','It is strange, I know... Most mortals cannot actually comprehend what they see here, as often, what they see is not anchored within their own perception of reality.\n',26124),
(17659,'enUS','','As custodians of time, we watch over and care for Nozdormu\'s realm. The master is away at the moment, which means that attempts are being made to dramatically alter time. The master never meddles in the affairs of mortals but instead corrects the alterations made to time by others. He is reactionary in this regard.\n',26124),
(17660,'enUS','','For normal maintenance of time, the Keepers of Time are sufficient caretakers. We are able to deal with most ordinary disturbances. I speak of little things, such as rogue mages changing something in the past to elevate their status or wealth in the present.\n',26124),
(17661,'enUS','','These tunnels that you see are called timeways. They are infinite in number. The ones that currently exist in your reality are what the master has deemed as \'trouble spots.\'  These trouble spots may differ completely in theme but they always share a cause. That is, their existence is a result of the same temporal disturbance. Remember that should you venture inside one...\n',26124),
(17662,'enUS','','The timeways are currently ranked in order from least catastrophic to most catastrophic. Note that they are all classified as catastrophic, meaning that any single one of these timeways collapsing would mean that your world would end. We only classify them in such a way so that the heroes and adventurers that are sent here know which timeway best suits their abilities.\n',26124),
(17663,'enUS','','This timeway is in great disarray! We have agents inside right now attempting to restore order. What little information I have indicates that Thrall\'s freedom is in jeopardy. A malevolent organization known as the Infinite Dragonflight is trying to prevent his escape. I fear without outside assistance, all will be lost.\n',26124),
(17664,'enUS','','We have very little information on this timeway. Sa\'at has been dispatched and is currently inside. The data we have gathered from his correspondence is that the Infinite Dragonflight are once again attempting to alter time. Could it be that the opening of the Dark Portal is being targeted for sabotage? Let us hope not...\n',26124),
(17665,'enUS','','All we know of this timeway is that it leads to Mount Hyjal. The Infinite Dragonflight have gone to great lengths to prevent our involvement. We know next to nothing, mortal. Soridormi is currently attempting to break through the timeway\'s defenses but has thus far been unsuccessful. You might be our only hope of breaking through and resolving the conflict.\n',26124),
(17666,'enUS','','Our time is at an end, $n. I would wish you luck, if such a thing existed.\n',26124),
(17667,'enUS','','There are only two truths to be found here: First, that time is chaotic, always in flux, and completely malleable and second, perception does not dictate reality.',26124),
(17668,'enUS','','Follow me, please.',26124),
(17669,'enUS','','This timeway collapsed and reformed. The result was Stratholme of yore. What could possibly be happening inside?',26124),
(17670,'enUS','Just as you deserve!','',26124),
(17671,'enUS','Your friends will soon be joining you!','',26124),
(17672,'enUS','Good...luck. You\'ll need it.','',26124),
(17673,'enUS','You mustn\'t let him loose!','',26124),
(17674,'enUS','Ignorant whelps!','',26124),
(17675,'enUS','You fools! He\'ll kill us all!','',26124),
(17676,'enUS','Culuthas, you will return the crystal to me at once!','',26124),
(17677,'enUS','You have no idea how to control the ata\'mal crystal.  It will consume you!','',26124),
(17678,'enUS','Return the crystal to me or face annihilation!','',26124),
(17679,'enUS','My work must not be interrupted!','',26124),
(17680,'enUS','Perhaps I can find a use for you...','',26124),
(17681,'enUS','Anger...hate... These are tools I can use.','',26124),
(17682,'enUS','Do not make me come there and destroy you!','',26124),
(17683,'enUS','Let\'s see what I can make of you!','',26124),
(17684,'enUS','It is pointless to resist.','',26124),
(17685,'enUS','Stay away from... Me!','',26124),
(17686,'enUS','How dare you destroy my demons!','',26124),
(17687,'enUS','What are these things that you have summoned to serve you?!  Just who do you think you are!','',26124),
(17688,'enUS','Culuthas, deliver the crystal to me now!','',26124),
(17689,'enUS','What\'s that?  Did you hear something?  Culuthas, there are servants of the Consortium nearby.  Bring me the crystal immediately!','',26124),
(17690,'enUS','Culuthas where have you gone?!','',26124),
(17691,'enUS','You cannot hide from me, Culuthas!  I will hunt you down no matter where you go!','',26124),
(17692,'enUS','I can sense you, \'adventurer\', even through this magical image.  You think you will retrieve the ata\'mal crystal when Culuthas shows himself, but you are mistaken!','',26124),
(17693,'enUS','Show yourself, Culuthas.  All may be forgiven if you just bring the crystal to me.','',26124),
(17694,'enUS','Are you using the crystal to hide?  Is that it?  You should know that you cannot possibly mask such power!','',26124),
(17695,'enUS','I don\'t know where you\'ve gone to.  But I can assure you that wherever that is, I will find you and the crystal, Culuthas!','',26124),
(17696,'enUS','','The depths will consume you!',26124),
(17697,'enUS','','Meet your doom, surface dwellers!',26124),
(17698,'enUS','','You will drown in blood!',26124),
(17699,'enUS','Culuthas, when I find you, I am going to make certain that you suffer for all eternity!','',26124),
(17701,'enUS','','To the depths of oblivion with you!',26124),
(17702,'enUS','','For my lady and master!',26124),
(17703,'enUS','I will not give it to you, Socrethar!','',26124),
(17704,'enUS','','Our matron will be... the end of you.',26124),
(17705,'enUS','Nothing that you say will convince me to give up such power!','',26124),
(17706,'enUS','WITH THE CRYSTAL, I AM A GOD!','',26124),
(17707,'enUS','You can talk until you\'re blue in the face, I\'m not delivering the ata\'mal crystal to you.','',26124),
(17708,'enUS','I think not, Socrethar.  With the power of the crystal, you will be serving me soon.  If I allow you to live, that is.','',26124),
(17709,'enUS','They all wanted it for themselves, but I slew them as easily as I will slay you when I pay you a visit later.','',26124),
(17710,'enUS','No.','',26124),
(17711,'enUS','Stay alert!','Stay alert!',26124),
(17712,'enUS','Beg all you want, I am keeping the crystal for myself.  All of Outland will soon fall beneath my step!','',26124),
(17713,'enUS','Be wary of intruders.','Be wary of intruders.',26124),
(17714,'enUS','Don\'t you wish there was some water around here?','Don\'t you wish there was some water around here?',26124),
(17715,'enUS','We must not fail the master.','We must not fail the master.',26124),
(17716,'enUS','You\'re in for a world o\' hurt!','',26124),
(17717,'enUS','Eat hot metal, scumbag!','',26124),
(17718,'enUS','I\'ll come over there!','',26124),
(17719,'enUS','I\'m bringin\' the pain!','',26124),
(17720,'enUS','You just got served, punk!','',26124),
(17721,'enUS','I own you!','',26124),
(17722,'enUS','Have fun dyin\', cupcake!','',26124),
(17723,'enUS','Mommy.','',26124),
(17724,'enUS','You deem yourselves worthy simply because you bested my guards? Our work here will not be compromised!','',26124),
(17725,'enUS','This is not nearly over...','',26124),
(17726,'enUS','Your head will roll!','',26124),
(17727,'enUS','I despise all of your kind!','',26124),
(17728,'enUS','Ba\'anthalso-dorei!','',26124),
(17729,'enUS','Squirm, surface filth!','',26124),
(17730,'enUS','For her Excellency... for... Vashj!','',26124),
(17733,'enUS','I have pets -- ca-caw! -- of my own!','',26124),
(17734,'enUS','Mmm... time to make my move!','',26124),
(17735,'enUS','Nice pets, yes... raa-a-ak!','',26124),
(17736,'enUS','Nice pets have weapons. No so -- ra-ak -- nice.','',26124),
(17737,'enUS','Yes, fleeting life is, rak-a-kak!','',26124),
(17738,'enUS','Mmmm... be free. Caw!','',26124),
(17739,'enUS','Mmm... no more life. No more pain. A-ak!','',26124),
(17740,'enUS','Beware, mortal, beyond this hall lies dangers unheard of in your world. Tread carefully...','',26124),
(17741,'enUS','It is good to see you again, $n. Would you like me to take you to the master\'s lair?','',26124),
(17742,'enUS','Please take me to the master\'s lair.','Please take me to the master\'s lair.',26124),
(17743,'enUS','Arathi Basin has been overrun by The Defilers.  Will you help us, $n?','',26124),
(17744,'enUS','It is good to see a friend of the Aldor around these remote parts.  I fear I cannot stand for much more of these elves\' insolent chatter.','',26124),
(17745,'enUS','','Go, $n, into Arathi Basin! Slay, SLAY, as you\'ve never slain before!',26124),
(17746,'enUS','The entrance to Warsong Gulch stands before you. Will you fight the wretched Alliance there?','',26124),
(17747,'enUS','','Well met, $c. Even now, the Horde attacks Warsong Gulch. Will you fight alongside the Alliance there?',26124),
(17748,'enUS','What are ye doin\' here?! Get yer chatty self ta Alterac Vallery, where ye\'re needed!','',26124),
(17749,'enUS','','BOAR\'S DUNG! Why must I stay here to guide others to Alterac Valley, when I could be fighting there myself? You! Have you come to fight the Alliance?',26124),
(17750,'enUS','The forest sings with the seeds of change, but it also cries out in pain.$B$BOur new friends, the draenei, are here to help us, like you. We must put an end to the destruction of my brother and sister trees before all is lost and Ashenvale is no more.','',26124),
(17751,'enUS','Attempt to contact Tyri and Jorad.','Attempt to contact Tyri and Jorad.',26124),
(17752,'enUS','','There\'s no need to contact that conniving ethereal. Come, we have much to discuss.',26124),
(17753,'enUS','When you are ready to fly to Durnholde, let me know and I shall take you.','',26124),
(17754,'enUS','Wind Trader Marid, I\'ve returned with more information on the nether drakes. I\'m prepared to be your business partner, and for an extra sum, I\'ll take care of that troublesome elf and her human friend.','Wind Trader Marid, I\'ve returned with more information on the nether drakes. I\'m prepared to be your business partner, and for an extra sum, I\'ll take care of that troublesome elf and her human friend.',26124),
(17755,'enUS','Spare my life!  I will tell you about Arelion\'s secret.','',26124),
(17756,'enUS','What is it you want?  I\'m not one for small talk.','',26124),
(17757,'enUS','Magistrix Carinda has sent me to ask you about Arelion\'s secret.  Who was he seeing?','Magistrix Carinda has sent me to ask you about Arelion\'s secret.  Who was he seeing?',26124),
(17758,'enUS','If you think I\'ll betray my friend that easily, think again!  Face me, you scoundrel!','',26124),
(17759,'enUS','','I\'m a little busy negotiating a bribe right now.  You might want to come back later.',26124),
(17760,'enUS','','I\'ve arranged for your flight to Manaforge Coruu.  Are you ready, $n?  You will be dropped off behind enemy lines so make sure you bring everything you need.',26124),
(17761,'enUS','I\'m as ready as I\'ll ever be.','I\'m as ready as I\'ll ever be.',26124),
(17762,'enUS','Ikiss will not -- rak, rak -- die...','',26124),
(17763,'enUS','You die -- ka! Stay away from trinkets!','',26124),
(17764,'enUS','Mmmmmm...','',26124),
(17765,'enUS','Mmm, you make war on Ikiss? Aa-ak!','',26124),
(17766,'enUS','Don\'t let those fiends breath through!  Our wounded are here behind me!','Don\'t let those fiends breath through!  Our wounded are here behind me!',26124),
(17767,'enUS','Ikiss cut you, pretty -- ak-a-ak -- slice you, yes!','',26124),
(17768,'enUS','Ak-a-ra-k! No escape for -- caw -- you!','',26124),
(17769,'enUS','Ra-ak! Trinkets, yes. Pretty trinkets! Ak! Power, great power. Ra-kaw! Power in trinkets! Ak-caw!','',26124),
(17771,'enUS','I will feed... on your soul.','',26124),
(17772,'enUS','So... full of life.','',26124),
(17773,'enUS','Do not... resist.','',26124),
(17774,'enUS','Yes... I am... empowered.','',26124),
(17775,'enUS','More... I must have more.','',26124),
(17776,'enUS','To the Void... once more.','',26124),
(17777,'enUS','I must bid you... farewell.','',26124),
(17778,'enUS','And now we part company.','',26124),
(17779,'enUS','It has been... entertaining.','',26124),
(17780,'enUS','We have not been properly introduced.','',26124),
(17781,'enUS','An epic battle, how exciting!','',26124),
(17782,'enUS','I\'ve longed for a good adventure!','',26124),
(17783,'enUS','I have such fascinating things to show you.','',26124),
(17784,'enUS','What is this? You must forgive me, but I was not expecting company. As you can see, we are somewhat preoccupied right now. But no matter. As I am a gracious host, I will tend to you... personally.','',26124),
(17785,'enUS','%s grows in size upon seeing $n!','',26124),
(17786,'enUS','%s\'s strength fades.','',26124),
(17787,'enUS','Indeed, Nexus-Prince Haramad, you do have much to think on.  Such as turning over that ata\'mal crystal to my master, Prince Kael\'thas.','',26124),
(17788,'enUS','I will use the power of the ata\'mal crystal to crush you!','',26124),
(17790,'enUS','You\'ll never get the ata\'mal crystal from me!','',26124),
(17791,'enUS','The ata\'mal crystal is mine!','',26124),
(17793,'enUS','No, I think not.  The selflessness that I have just been witness to has cleared my mind.  My dealings with your master are at an end.  You may return and let him know that I have decided to turn the ata\'mal crystal over to the naaru.','',26124),
(17794,'enUS','WHAT!  This is outrageous!  You will pay for this Haramad!  You and your assistant here!','',26124),
(17795,'enUS','Welcome to the Stormspire, $c.$B$BPlease do not be put off by my being present through this imaging device.  I have many enemies that would like to see me dead, so it is only a precaution.$B$BI assure you that you are perfectly safe here.','',26124),
(17796,'enUS','Guards!  Hold on, I will be right there!','',26124),
(17797,'enUS','That definitely ended our business relationship with Kael\'thas.  Please stay here.  I will return shortly and there is something that I want you to do.','',26124),
(17798,'enUS','I\'ll get you working yet, you bucket of junk.','',26124),
(17799,'enUS','There is something that you wish to buy?  There is something that you wish to sell?$B$BThis is why we are here, my friend.$B$BPlease, tell me your pleasure.','',26124),
(17800,'enUS','Dealer Dunar, I wish to browse your wares.','Dealer Dunar, I wish to browse your wares.',26124),
(17801,'enUS','Don\'t you start with me!','',26124),
(17802,'enUS','What?!  You don\'t think I can do it?  I\'ll show you...once I get my parts, that is.','',26124),
(17803,'enUS','Oh yeah, it\'s real funny isn\'t it?','',26124),
(17804,'enUS','It moved!  I swear, I saw it move!','',26124),
(17805,'enUS','Ouch!  That\'s not right.','',26124),
(17806,'enUS','So you\'ve recently arrived from Azeroth, eh? You\'d best steel yourself, $c - there are perils in this land unlike anything the Horde has faced before. I am Nazgrel - right hand to our mighty warchief, Thrall. He honored me with the task of safeguarding this brave expedition and - by all the spirits - I shall!','',26124),
(17807,'enUS','Send me to Thrallmar!','Send me to Thrallmar!',26124),
(17808,'enUS','Throm\'ka, $gbrother:sister;! Welcome to Outland. The Horde needs all the strength it can muster in this broken world. I promise you, if it\'s glorious battle you\'ve come seeking, you\'ll have your fill of it here.','',26124),
(17809,'enUS','Make it quick, $c - we\'ve got a war to fight here, or hadn\'t you noticed?','',26124),
(17810,'enUS','Their skill in battle should never be underestimated.','Their skill in battle should never be underestimated.',26124),
(17811,'enUS','They revel in causing anguish and pain - and their murderous interrogations are the stuff of nightmares.','They revel in causing anguish and pain - and their murderous interrogations are the stuff of nightmares.',26124),
(17812,'enUS','They are the driving heart of the Burning Crusade.','They are the driving heart of the Burning Crusade.',26124),
(17813,'enUS','They utilize terror and subterfuge - often turning brother against brother as whole worlds fall before their dark influence.','They utilize terror and subterfuge - often turning brother against brother as whole worlds fall before their dark influence.',26124),
(17814,'enUS','Stop! Do not go any further, mortal. You are ill-prepared to face the forces of the Infinite Dragonflight. Come, let me help you.','',26124),
(17815,'enUS','Mischievous by nature, they are fond of employing their own hastily-constructed technologies.','Mischievous by nature, they are fond of employing their own hastily-constructed technologies.',26124),
(17816,'enUS','Muttering under his breath, %s goes back to work.','',26124),
(17817,'enUS','Their black iron constructs have sown death across a thousand worlds.','Their black iron constructs have sown death across a thousand worlds.',26124),
(17818,'enUS','Golem. Command. Operational status report.','Golem. Command. Operational status report.',26124),
(17819,'enUS','The Alliance has taken control of the Blood Elf Tower!','',26124),
(17820,'enUS','This unit is currently at ninety five percent operational efficiency.','',26124),
(17821,'enUS','This unit is currently performing within normal parameters.','',26124),
(17822,'enUS','This unit is ready to serve.','',26124),
(17823,'enUS','The Horde has taken control of the Blood Elf Tower!','',26124),
(17824,'enUS','The Alliance has taken control of the Mage Tower!','',26124),
(17825,'enUS','The Horde has taken control of the Mage Tower!','',26124),
(17826,'enUS','$n has defended the Draenei Ruins!','',26124),
(17827,'enUS','The Alliance has taken control of the Draenei Ruins!','',26124),
(17828,'enUS','The Alliance has taken control of the Fel Reaver Ruins!','',26124),
(17829,'enUS','The Horde has taken control of the Fel Reaver Ruins!','',26124),
(17830,'enUS','You recovered an ata\'mal crystal?  Impressive, $n!','',26124),
(17831,'enUS','$n has assaulted the Blood Elf Tower!','',26124),
(17832,'enUS','$n has assaulted the Blood Elf Tower!','',26124),
(17833,'enUS','$n has assaulted the Draenei Ruins!','',26124),
(17834,'enUS','$n has assaulted the Draenei Ruins!','',26124),
(17835,'enUS','$n has assaulted the Fel Reaver Ruins!','',26124),
(17836,'enUS','$n has assaulted the Fel Reaver Ruins!','',26124),
(17837,'enUS','$n has assaulted the Mage Tower!','',26124),
(17838,'enUS','$n has assaulted the Mage Tower!','',26124),
(17839,'enUS','Golem movement appears to be within the specifications.','Golem movement appears to be within the specifications.',26124),
(17840,'enUS','I\'ll be glad when final testing of this unit is complete.','I\'ll be glad when final testing of this unit is complete.',26124),
(17841,'enUS','After this mobility test, we\'ll only have the final weapons check to complete.','After this mobility test, we\'ll only have the final weapons check to complete.',26124),
(17842,'enUS','Ahhh, dat feel guud!','',26124),
(17843,'enUS','Raaaah!','',26124),
(17844,'enUS','Mmmm, Bloodmaul Brew!','',26124),
(17845,'enUS','Buuuurrp...','',26124),
(17846,'enUS','Ahhh, guud stuff!','',26124),
(17847,'enUS','Mmm, me wanna bash!','',26124),
(17848,'enUS','Oh, another show already? Very well then...','',26124),
(17849,'enUS','%s sighs audibly and glances at Sagan.','',26124),
(17850,'enUS','And, for my next trick...','',26124),
(17851,'enUS','Another long day in the trenches over with at last! Maybe the magic show will take away some of the afterglow...','',26124),
(17852,'enUS','Show us a trick, Ravandwyr!','',26124),
(17853,'enUS','That was the best trick ever! Ok, boys, let\'s go get a drink.','',26124),
(17854,'enUS','I shall breathe fire!','',26124),
(17855,'enUS','I shall transform my familiar, Sagan, into something truly wondrous!','',26124),
(17856,'enUS','Thank you for watching, everyone! If you\'d be so kind as to bring your non-irradiated currency to tomorrow\'s performance, I\'d appreciate it.','',26124),
(17857,'enUS','A skunk! Eeeeeeeeeeeeeeeeeew! Don\'t touch me!','',26124),
(17858,'enUS','Get it away from me!','',26124),
(17859,'enUS','Aid me, you fools, before it\'s too late!','',26124),
(17860,'enUS','Pathetic mortals! You will pay dearly.','',26124),
(17861,'enUS','I will break you!','',26124),
(17863,'enUS','Finally, something to relieve the tedium!','',26124),
(17864,'enUS','Do you fear death?','',26124),
(17865,'enUS','This is the part I enjoy most...','',26124),
(17866,'enUS','Do not... grow... overconfident, mortal.','',26124),
(17867,'enUS','Come to my aid! Heed your master now!','',26124),
(17868,'enUS','I\'ll make an offering of your blood!','',26124),
(17869,'enUS','You\'ll be a fine example for the others!','',26124),
(17870,'enUS','Good, a worthy sacrifice!','',26124),
(17871,'enUS','I serve with pride.','',26124),
(17872,'enUS','Your death is for the greater cause...','',26124),
(17873,'enUS','I give my life... gladly.','',26124),
(17874,'enUS','Let me outta here! Guys... guys?','',26124),
(17875,'enUS','Oh man, he got you good!','',26124),
(17876,'enUS','Remember how you\'re always telling us to chill?','',26124),
(17877,'enUS','A simple practical joke.','',26124),
(17878,'enUS','Hail, adventurer. Heed my warnings before venturing into the Black Morass.','',26124),
(17879,'enUS','Sa\'at, I have lost the chrono-beacon and require another!','Sa\'at, I have lost the chrono-beacon and require another!',26124),
(17880,'enUS','Ah, welcome back, hero. You have returned to protect the Guardian once more? Do not forget to take a chrono-beacon with you!','',26124),
(17881,'enUS','I require a chrono-beacon, Sa\'at.','I require a chrono-beacon, Sa\'at.',26124),
(17882,'enUS','Greetings, $n. Proceed with caution...','',26124),
(17883,'enUS','Warning!  %s emergency shutdown process has begun.  Shutdown will complete in one minute.','',26124),
(17884,'enUS','Emergency shutdown will complete in thirty seconds.','',26124),
(17885,'enUS','Emergency shutdown will complete in ten seconds.','',26124),
(17886,'enUS','Manaforge shutdown aborted.  Resuming manaforge activity.','',26124),
(17887,'enUS','','I told you only to summon me if that stupid elf returned! What\'s this? No matter, you won\'t detain me long.',26124),
(17888,'enUS','The work must continue!','',26124),
(17889,'enUS','You brought this on yourselves!','',26124),
(17890,'enUS','Don\'t make me kill you!','',26124),
(17891,'enUS','Throm\'ka, $c. Is this shattered land what you expected to see? It\'s nothing like the stories I\'ve been told. It\'s hard to believe my people ever thrived in this desolate place.','Throm\'ka, $c. Is this shattered land what you expected to see? It\'s nothing like the stories I\'ve been told. It\'s hard to believe my people ever thrived in this desolate place.',26124),
(17892,'enUS','It had to be done....','',26124),
(17893,'enUS','You should not have come....','',26124),
(17894,'enUS','I... deserve this....','',26124),
(17895,'enUS','Tell me more of our mission here, Nazgrel.','Tell me more of our mission here, Nazgrel.',26124),
(17896,'enUS','Once our warchief heard that the Dark Portal had been reopened, he immediately gathered his advisors to plan this daring expedition. Though a few of his councilors have their doubts, Thrall holds out the hope that we might discover new insights into the history of our people. He believes that somewhere amidst the wreckage of this world, the true tale of the orcish people lies hidden.$B$BI must admit that in my darkest moments... I fear that that tale should remain untold.','',26124),
(17897,'enUS','<Keep Listening>','<Keep Listening>',26124),
(17898,'enUS','The Horde has risked much to venture into Outland - resources, manpower - even the tactical defense of our lands is at stake. Despite all else, Thrall believes in the promise of this ravaged land. There is a strange light in his eyes these days - as if he senses some stirring revelation the rest of us do not.$B$BStill, he is my warchief and my blood-brother. I would follow him through the gates of the abyss itself.','',26124),
(17899,'enUS','Throm\'ka, $c. You must be new. You look fresh and unspoiled by the horrors of this land.$B$B<Sergeant Shatterskull spits into the dust.>$B$BThat\'ll change.','',26124),
(17900,'enUS','Emergency shutdown complete.','',26124),
(17901,'enUS','Our Expedition made it safely through the Portal and set up a new base called Thrallmar. Yet as you can see, the Burning Legion moved in and cut us off from our brothers. Clearly, the demons hope to retake the Dark Portal and prevent us from gathering reinforcements from Azeroth.','',26124),
(17902,'enUS','Aided by the Alliance, my forces will hold the line here, but I need you to deliver my report to General Krakork in Thrallmar. With his help, we\'ll be able to drive these demons back into the abyss that spawned them! Speak to Vlagga Freyfeather who stands on the platform behind us. She\'ll speed you on your way.','',26124),
(17903,'enUS','more','more',26124),
(17904,'enUS','With some help, I believe Taerix may be close to a breakthrough.','',26124),
(17905,'enUS','My brothers in Stormwind told me not to join the military... I\'m glad I didn\'t listen to them!','',26124),
(17906,'enUS','Shatter Point is a great place for a Wildhammer dwarf.  I\'ve never had so much time in the air!','Shatter Point is a great place for a Wildhammer dwarf.  I\'ve never had so much time in the air!',26124),
(17907,'enUS','','Hawkstriders are noble creatures.  Make sure to always treat yours well; there are fewer things more dangerous than an angry hawkstrider.',26124),
(17908,'enUS','','I am sure that, with our help, Botanist Taerix will be able to find solutions to our problems.',26124),
(17909,'enUS','I wish to purchase one of these creatures.','I wish to purchase one of these creatures.',26124),
(17910,'enUS','Aim!','',26124),
(17911,'enUS','Fire!','',26124),
(17912,'enUS','As the neutralizing agent mixes into the waters of the lake, the water that was irradiated by the crystal seems to clear.','',26124),
(17913,'enUS','Protect the Mechanar at all costs!','',26124),
(17914,'enUS','Of course none of my goods are stolen.  But if someone asks, you didn\'t get them from me!','',26124),
(17915,'enUS','The latest blueprints, patterns and schematics are available right here.  These instructions are so simple to follow they practically craft themselves!','',26124),
(17916,'enUS','The best selection of smuggled goods is available right here, $n.  Great for the whole family!  Avoid goblin taxation and naaru prohibition - the Consortium is here to fill your every shopping need!','',26124),
(17917,'enUS','Pssst!  I have something that might interest you, $n.  It fell off a pack mule in Nagrand!','',26124),
(17918,'enUS','','I think I can see the Sunwell from here!',26124),
(17919,'enUS','','Can you really hear the ocean from one of these shells?',26124),
(17920,'enUS','','Oooh! Look, a shiny one!',26124),
(17921,'enUS','','Jane will love this one!',26124),
(17922,'enUS','','%s picks up a sea shell.',26124),
(17923,'enUS','','%s holds a sea shell up to her ear.',26124),
(17924,'enUS','','%s shakes the dirt loose from the shell.',26124),
(17925,'enUS','Looks like it\'s time to let you out of this cage.','',26124),
(17926,'enUS','','%s wipes a tear away.',26124),
(17927,'enUS','','Go\'el. You are Go\'el, son of Durotan - rightful chieftain of the Frostwolves. This day, grandson - you are the great joy of my heart.\n',26124),
(17928,'enUS','I have dreamed of this moment all my life, Greatmother. \'Till now, all I\'ve had were Orgrim\'s stories about my parents and their adventures on Draenor. He was my greatest teacher and dearest friend. He died a hero... They all died as heroes - and for all of them, a song of honor remains.\n','',26124),
(17929,'enUS','','I see that you hold the Doomhammer. Have all of our greatest heroes fallen, grandson?\n',26124),
(17930,'enUS','','What of Grommash? What of Hellscream?\n',26124),
(17931,'enUS','Stop the emergency shutdown!  Kael will have our heads if he hears about this!','Stop the emergency shutdown!  Kael will have our heads if he hears about this!',26124),
(17932,'enUS','The naaru\'s emergency shutdown will disable the manaforge permanently!  It must be aborted!','The naaru\'s emergency shutdown will disable the manaforge permanently!  It must be aborted!',26124),
(17933,'enUS','','Heading to Outland? Visit Vixton Pinchwhistle in Netherstorm\'s Area 52. As the Steamwheedle Fighting Circuit\'s official Arena Vendor, he has all sorts of incredible items for sale to those with enough Arena Points.',26124),
(17934,'enUS','Now, to put the neutralizing agent on it...','',26124),
(17935,'enUS','Send me to Shatter Point!','Send me to Shatter Point!',26124),
(17936,'enUS','Send me to Honor Point!','Send me to Honor Point!',26124),
(17937,'enUS','Send me to Shatter Point!','Send me to Shatter Point!',26124),
(17938,'enUS','','Tedon, go ahead and try the neutralizing agent on the mutated creature.',26124),
(17939,'enUS','Success!','',26124),
(17940,'enUS','Very well.  Before we head down there, take a moment to prepare yourself.','',26124),
(17941,'enUS','Let\'s proceed at a brisk pace.','',26124),
(17942,'enUS','We\'ll start at that first energy pylon, straight ahead.  Remember, try to keep them off of me.','',26124),
(17943,'enUS','I\'m done with this pylon.  On to the next.','',26124),
(17944,'enUS','Alright, pylon two down.  Now for the heat manifold.','',26124),
(17945,'enUS','That should do it.  The teleporter should blow any second now!','',26124),
(17946,'enUS','Ok, let\'s get out of here!','',26124),
(17947,'enUS','Feel like helping me to take down the warp-gate in that Burning Legion camp to the south?','',26124),
(17948,'enUS','We work well together, $n.  I couldn\'t have taken that warp-gate down without you!','',26124),
(17949,'enUS','Thank you, $n!  I couldn\'t have done it without you.  You\'ll let Gahruj know?','',26124),
(17950,'enUS','Keep them off me!','',26124),
(17951,'enUS','','These people arrived from Shattrath a few nights ago and they haven\'t stopped arguing since then.$B$BI\'m glad to see that hasn\'t turned you away, I was beginning to think they were scaring off potential customers.',26124),
(17952,'enUS','','I hope these Shattrath folks stop fighting soon.  They\'re beginning to get on my nerves.$B$B How can I help you?',26124),
(17953,'enUS','Work harder, dogs!','',26124),
(17954,'enUS','Faster, or you will taste The Claw!','',26124),
(17955,'enUS','Lord Doomclaw.  Yes, I like the sound of that!','',26124),
(17956,'enUS','Who\'s your master?!','',26124),
(17957,'enUS','Faster, faster!  Get those fel reaver parts gathered!','',26124),
(17958,'enUS','You think I should have gone with the buzzsaw instead?','',26124),
(17959,'enUS','Gather up those fel reaver parts.  We\'re going to make a surprise for the goblins!','',26124),
(17960,'enUS','This is hard work.  I feel like I need a vacation.  You there, put your back into it!','',26124),
(17961,'enUS','You are not yet strong enough to do battle in the Eye of the Storm. Return when you have gained more experience.','You are not yet strong enough to do battle in the Eye of the Storm. Return when you have gained more experience.',26124),
(17962,'enUS','Draenei forces and their Alliance allies are engaged with the Horde in the Eye of the Storm in Outland. Will you join them in an effort to turn the tide of battle in our favor?','Draenei forces and their Alliance allies are engaged with the Horde in the Eye of the Storm in Outland. Will you join them in an effort to turn the tide of battle in our favor?',26124),
(17963,'enUS','The Horde must not allow the draenei and their meddling Alliance to control all the mana cells in Outland. Will you join the blood elves in their assault on the Eye of the Storm?','The Horde must not allow the draenei and their meddling Alliance to control all the mana cells in Outland. Will you join the blood elves in their assault on the Eye of the Storm?',26124),
(17964,'enUS','Speak with Wing Commander Brack, $n.  He\'ll outfit you with one of our armored wyvern destroyers.  And, good luck!','',26124),
(17965,'enUS','Hello, $c!  Are you reporting for a flight mission?','',26124),
(17966,'enUS','Hal...','',26124),
(17967,'enUS','Yea, Nat?','',26124),
(17968,'enUS','Had that dream again last night...','',26124),
(17969,'enUS','Which one?','',26124),
(17970,'enUS','That one dream... The crazy one. Remember?','',26124),
(17971,'enUS','Tarren Mill is destroyed by some crazy force of undead and forever more becomes an enemy to Southshore.','',26124),
(17972,'enUS','Could ya imagine such a thing, Hal? Could ya?','',26124),
(17973,'enUS','That one where I\'m in Durnholde and that one orc that Blackmoore keeps as his personal slave breaks out...','',26124),
(17974,'enUS','He ends up destroying the whole keep, freeing all the orcs we\'re keeping in the camps, and rising to power as the king of orcs... Warchief or somethin\'.','',26124),
(17975,'enUS','Crazy, isn\'t it?','',26124),
(17976,'enUS','So I\'m on some mountain with some big ol\' tree. Bunch of elves runnin\' around all over...','',26124),
(17977,'enUS','Out of nowhere, some 300 foot tall demon or somethin\' walks up and starts climbin\' the tree...','',26124),
(17978,'enUS','And if that weren\'t crazy enough, that big demon gets killed by a bunch of little floating light things... Oh, I was also a female elf in that one... Yep...','',26124),
(17979,'enUS','In this dream, I was fishin\' master of the world. I moved to some place called Kalimdor...','',26124),
(17980,'enUS','And people from all over the world come to me to pay homage... and learn to fish.','',26124),
(17981,'enUS','I\'m like some kind of fishing god...','',26124),
(17982,'enUS','I can\'t even believe this one... You know those two loud-mouthed ruffians, Foror and Tigule?','',26124),
(17983,'enUS','Well in this dream, they somehow end up inventing something called ice-cream and flavoring it with strawberries... Well, long story short, they end up striking it rich!','',26124),
(17984,'enUS','If that weren\'t crazy enough, they decide to quit the ice-cream business and become adventurers... They travel all over the place and finally disappear into some portal. I woke up in a cold sweat after that one...','',26124),
(17985,'enUS','This one\'s real grim... So the king\'s kid, Arthas... Well he goes out to battle evil, along with Uther... *Nat pats his brow dry*','',26124),
(17986,'enUS','But tragically, Arthas is consumed by the evil and becomes evil himself...','',26124),
(17987,'enUS','Well, he comes back to the king all pretendin\' to be nice, draws his sword, and runs the king through, elbow to ... well you know... kills him on the spot.','',26124),
(17988,'enUS','It\'ll never happen, Nat.\n','',26124),
(17989,'enUS','Impossible!\n','',26124),
(17990,'enUS','I worry about you sometimes, Nat.','',26124),
(17991,'enUS','No way.\n','',26124),
(17992,'enUS','Nat, I\'ve heard a whopper or two in my day but that one takes the cake.\n','',26124),
(17993,'enUS','What you got in that pipe, Nat?\n','',26124),
(17994,'enUS','*Hal shakes his head* Nat, Nat, Nat...\n','',26124),
(17995,'enUS','Shut up and fish, Nat.\n','',26124),
(17996,'enUS','I hate this place and everyone in it! Smithers do this! Smithers do that! Oh so I\'m a farmer now, eh? So I\'m gonna have to harvest stuff, eh? I hope one day this whole place becomes one big graveyard and all the loud-mouths are buried right damned here!','',26124),
(17997,'enUS','%s collects some vegetables.','',26124),
(17998,'enUS','%s digs into the dirt.','',26124),
(17999,'enUS','%s moves a rock.','',26124),
(18000,'enUS','I didn\'t come all this way from Silvermoon City to toil my life away in a mine!','',26124),
(18001,'enUS','We should just leave.  Is this what we came to Outland for?','',26124),
(18002,'enUS','We were duped.  This is definitely not the promised land!','',26124),
(18003,'enUS','I am a blood elf.  I do not do physical labor.','',26124),
(18004,'enUS','Kael\'thas lied to us.  The Outland is no paradise.','',26124),
(18005,'enUS','I was once a great magister in Silvermoon City.  Now I\'m a demoted, former-foreman and little more than a slave!','',26124),
(18006,'enUS','They had no right to demote me to these menial tasks!','',26124),
(18007,'enUS','Come.  Let\'s put down these crude instruments and walk away from all of this.  It isn\'t why we came to Outland.','',26124),
(18008,'enUS','If you\'ve been to Zangarmarsh, you might\'ve run into a fellow named Daniels. You know -- wears a strange helmet, only answers to \"the Specialist.\"$B$BOf course, I taught him everything he knows.$B$BDon\'t let the fine clothing fool you. I\'m still a rogue at heart. Daniels and I spent a lot of time in the trenches together, but that was before I retired. As far as I know, he\'s still out there, giving \'em hell.','',26124),
(18009,'enUS','Time for old Smithers to take a break...','',26124),
(18010,'enUS','Day in, day out, all we do is toil in this mine.  The blood elf male was not built for such manual labor.','',26124),
(18011,'enUS','%s yawns.','',26124),
(18012,'enUS','Welp, back to the grind.','',26124),
(18013,'enUS','','STOP! Intruders are in the castle!',26124),
(18014,'enUS','','So you thought you could break into this palace of the Light and run away with our secrets! Vishas, interrogate this criminal at once!',26124),
(18015,'enUS','My pleasure, milady!','',26124),
(18016,'enUS','Tell me everything, scum! Tell me or I\'ll rip the secrets from your flesh!','',26124),
(18017,'enUS','It isn\'t talking, milady. I know it holds secrets! Naughty secrets!','',26124),
(18018,'enUS','I must conserve my energy... there\'s no telling when my portal magic will be needed!','',26124),
(18019,'enUS','','My champion, destroy this monster!',26124),
(18020,'enUS','The infidel shall be purified, milady!','',26124),
(18021,'enUS','ARGH! It has struck a fatal blow! I have failed you...','',26124),
(18022,'enUS','%s staggers about as if he were mortally wounded.','',26124),
(18023,'enUS','','Mograine has fallen! You shall pay for this treachery! Arise, my champion! Arise!',26124),
(18024,'enUS','','%s pretends to cast a healing spell on Renault.',26124),
(18025,'enUS','','I do so hope these... Argent Dawn manage things here.  I would hate to sully my robe on demon rabble!',26124),
(18026,'enUS','At your side, milady!','',26124),
(18027,'enUS','','We will attack as one!',26124),
(18028,'enUS','','The children cheer.',26124),
(18029,'enUS','','We are victorious!',26124),
(18030,'enUS','First squad is ready for battle!','First squad is ready for battle!',26124),
(18031,'enUS','All clear!','All clear!',26124),
(18032,'enUS','We stand ready to defend the Eye!','We stand ready to defend the Eye!',26124),
(18033,'enUS','Keep your voice down, Helcular. Strangers abound...','',26124),
(18034,'enUS','%s nods.','',26124),
(18035,'enUS','Second squad is ready to fight!','Second squad is ready to fight!',26124),
(18036,'enUS','The enemy will not get past us!','The enemy will not get past us!',26124),
(18037,'enUS','Our blades and spells are at the ready!','Our blades and spells are at the ready!',26124),
(18038,'enUS','Third squad reporting in!','Third squad reporting in!',26124),
(18039,'enUS','We will show our enemies no quarter!','We will show our enemies no quarter!',26124),
(18040,'enUS','Our defenses stand ready!','Our defenses stand ready!',26124),
(18041,'enUS','So you can teach me this... this...','',26124),
(18042,'enUS','Necromancy. It is called necromancy. And yes, I have it within my power to bless you with this gift.','',26124),
(18043,'enUS','And the Kirin Tor? What have they to say of necromancy?','',26124),
(18044,'enUS','That is none of your concern, Helcular, as you are neither Kirin Tor nor a necromancer.','',26124),
(18045,'enUS','As you were!','As you were!',26124),
(18046,'enUS','Stand vigilant.','Stand vigilant.',26124),
(18047,'enUS','Very well.','Very well.',26124),
(18048,'enUS','Excellent work.','Excellent work.',26124),
(18049,'enUS','Your conduct makes me proud.','Your conduct makes me proud.',26124),
(18050,'enUS','But to be perfectly frank, I do not give a damn what the Kirin Tor think! They are fools, set in their archaic ways.','',26124),
(18051,'enUS','Then teach me, Kel\'Thuzad. Teach me everything you know...','',26124),
(18052,'enUS','In due time, Helcular... All in due time...','',26124),
(18053,'enUS','%s looks to the left and then the right.','',26124),
(18054,'enUS','Come, Helcular, let me give you a small taste...','',26124),
(18055,'enUS','%s utters some unintelligible words.','',26124),
(18056,'enUS','Now do you see, Helcular? Do you doubt the power? I control life!','',26124),
(18057,'enUS','And death...','',26124),
(18058,'enUS','I\'m still working out some minor details...','',26124),
(18059,'enUS','$n, please make sure that you tell Gahruj of our success.','',26124),
(18060,'enUS','That one where thousands of people are all watching us from up in the sky...','',26124),
(18061,'enUS','We\'re like their puppets - we dance and cry and fight and say silly things for their amusement.\n','',26124),
(18062,'enUS','Sometimes, even when I\'m awake, I think they\'re watching us. Maybe they\'re watching us right now...','',26124),
(18063,'enUS','Good thing you brought us nine others.  I think I\'ll finish this later.','',26124),
(18064,'enUS','Avast, Ed! Lemme show ye me ship! *hic*','',26124),
(18065,'enUS','Lead the way, Sanders!','',26124),
(18066,'enUS','What are you doing, Sanders?','',26124),
(18067,'enUS','I just be makin\' sure we wasn\'t followed! *hic*','',26124),
(18068,'enUS','It be clear...','',26124),
(18069,'enUS','Thar she be! Ain\'t she a beaut?','',26124),
(18070,'enUS','Aye, she\'s a beaut alright. And you parked her right next to my frigate! *hic*','',26124),
(18071,'enUS','That thar monster be yers, Ed? Arrr... She\'s a big\'un!','',26124),
(18072,'enUS','Ayep! She\'s all mine... I\'m gonna sail her around the world. Across the sea!','',26124),
(18073,'enUS','Arrr, Ed! She definitely be seaworthy!','',26124),
(18074,'enUS','Sanders, what have you got in that chest?','',26124),
(18075,'enUS','Can ye keep a secret, Ed? Arr, dead men tell no tales!','',26124),
(18076,'enUS','%s nods.','',26124),
(18077,'enUS','It be me treasure, Ed. Me life\'s work! Arrr... One white shirt fit fer a pirate king to be wearin\'!','',26124),
(18078,'enUS','One red sash that ye can put on yer head or your britches. Pride o\' the fleet, that sash is...','',26124),
(18079,'enUS','An\' last but certainly not least, one enormous bag! Big enough to fit eight whole apples! Eight, Ed! Can ye believe it!?','',26124),
(18080,'enUS','%s gasps.','',26124),
(18081,'enUS','Yarrr! Keep it down, Ed! Thar be scallywags about! Their scallywag ears be listenin\' for gasps like the one that just escaped yer lips!','',26124),
(18082,'enUS','I\'m sorry, Sanders. I\'ve just never seen such a bounty. It took me by surprise.','',26124),
(18083,'enUS','It be alright, Ed. Me booty be locked away good in that thar chest. No fool will ever have Cap\'n Sanders\'s treasure! Let\'s go get another drink. The spirits be runnin\' low.','',26124),
(18084,'enUS','Keep your voices down. There are strangers about...','',26124),
(18085,'enUS','Brothers and sisters, I have called you here today to discuss the fate of Lordaeron.','',26124),
(18086,'enUS','%s lowers his voice to a whisper.','',26124),
(18087,'enUS','I hear things... Things that should not be.','',26124),
(18088,'enUS','The dead rise... Undead, from the frozen northlands. Whole cities have gone missing. I...','',26124),
(18089,'enUS','I have heard that Northrend is lost...','',26124),
(18090,'enUS','Gasps can be heard throughout the room.','',26124),
(18091,'enUS','We must stand at the ready. I have faced undead before. They are ruthless killing machines, devoid of any emotion or compassion.','',26124),
(18092,'enUS','%s nods.','',26124),
(18093,'enUS','Aye, I\'ve battled them as well. We are ill-prepared as a kingdom to withstand such an assault.','',26124),
(18094,'enUS','What do you propose, Mograine?','',26124),
(18095,'enUS','Propose? I propose that we prepare. That we prepare our loved ones, family and friends for the possibility of an undead holocaust.','',26124),
(18096,'enUS','And there is this...','',26124),
(18097,'enUS','%s unlocks the chest.','',26124),
(18098,'enUS','','By the Light! What is it?',26124),
(18099,'enUS','I have had this object in my possession for 10 years. Since Blackrock Spire...','',26124),
(18100,'enUS','I wrested it free from the remains of an orc lieutenant - a dark caster... It is from their homeworld.','',26124),
(18101,'enUS','Do not get too close. I laid a hand upon it once... Only once and never again. The memories of that day still linger.','',26124),
(18102,'enUS','%s removes the gauntlet from his right arm and shows everyone his mangled hand.','',26124),
(18103,'enUS','I surmise that this object is the living embodiment of shadows... darkness... It is a manifestation. It is a void.','',26124),
(18104,'enUS','I do not see how this evil artifact is relevant to the undead. We must destroy it!','',26124),
(18105,'enUS','Emissary Taluun brought me with him hoping I could teach our new allies about the elements of this world... but no one will listen.','Emissary Taluun brought me with him hoping I could teach our new allies about the elements of this world... but no one will listen.',26124),
(18106,'enUS','%s shakes his head.','',26124),
(18107,'enUS','No, old friend, it is very relevant.','',26124),
(18108,'enUS','Let me ask you this, brothers and sisters: Can good exist without evil? Can there be light without dark?','',26124),
(18109,'enUS','And if that answer is no, then could it be possible that because this artifact exists, its polar opposite must also exist?','',26124),
(18110,'enUS','Could you imagine what the material manifestation of the Light could do against the undead?','',26124),
(18111,'enUS','Emissary Taluun brought me with him hoping I could teach our new allies about the elements of this world. So far they refuse to listen, but perhaps you would be willing?','Emissary Taluun brought me with him hoping I could teach our new allies about the elements of this world. So far they refuse to listen, but perhaps you would be willing?',26124),
(18112,'enUS','Nonsense, Mograine! It must be destroyed!','',26124),
(18113,'enUS','Shock then silence overtakes the crowd.','',26124),
(18114,'enUS','Leave me, $c. I must attend to my duties with Ambassador Sunsorrow, dull as they are.','Leave me, $c. I must attend to my duties with Ambassador Sunsorrow, dull as they are.',26124),
(18115,'enUS','','While the focus of the Sha\'tar remains on Shadowmoon Valley and Illidan, we cannot ignore the threat that Kael\'thas Sunstrider presents.',26124),
(18116,'enUS','I grow bored of guarding Ambassador Sunsorrow, $n. Care to spar a bit? Perhaps one of us will learn something.','I grow bored of guarding Ambassador Sunsorrow, $n. Care to spar a bit? Perhaps one of us will learn something.',26124),
(18117,'enUS','It consumed the Light!','',26124),
(18118,'enUS','Impossible!','',26124),
(18119,'enUS','<Begin emergency shutdown.>','<Begin emergency shutdown.>',26124),
(18120,'enUS','As you approach the console the access crystal you have with you begins to hum softly and pulse with light.$B$BA rush of information flows into your mind and all of a sudden you\'re aware of the manaforge\'s energy production levels, its stability and its output to different pipelines.  The console awaits your command.','',26124),
(18121,'enUS','Is... Is it getting lighter? Its coloration... It is changing.','',26124),
(18122,'enUS','BY THE LIGHT! Could it be? Could this be it?','',26124),
(18123,'enUS','I must know... I will know...','',26124),
(18124,'enUS','%s reaches out to touch the light crystal.','',26124),
(18125,'enUS','I... It... It is beautiful. What I felt when I touched it... The Light coursed through me and I through it... It healed my spirit.','',26124),
(18126,'enUS','Your hand! It is healed!','',26124),
(18127,'enUS','%s puts the crystal back inside the chest.','',26124),
(18128,'enUS','Let us never again speak of this day. Our enemies are many. They need not know we hold such artifacts.','',26124),
(18129,'enUS','I have seen it... From this blessed crystal we will forge a weapon. This weapon will hold inside it a piece of each of us... And when it is used against undead, it shall cast them down. And in its wake, it will leave only ashes...','',26124),
(18130,'enUS','The Ashbringer...','The Ashbringer...',26124),
(18131,'enUS','Stop this immediately!','Stop this immediately!',26124),
(18132,'enUS','When I get this hunk of junk up and running, I\'ll be able to walk the roads without fear of being jumped by bandits!','',26124),
(18133,'enUS','Just a few more swings and it\'ll be ready...','',26124),
(18134,'enUS','Maybe I can sell these things to other goblins? I\'ll be rich! Rich I say!','',26124),
(18135,'enUS','Yes, Zixil will be a household name! I\'ll corner the market!','',26124),
(18136,'enUS','Hands off the cloak! Yes, yes, I know that you want one too. Everybody wants one of my cloaks. Believe me, person of low moral and social standing, one day I will make my fortune from the sale of my cloaks. Everyone from here to Ironforge will know the name of Bartolo Ginsetti. The Ginsetti label will be coveted by all!','',26124),
(18137,'enUS','You there! Yes, you, peasant $g boy:girl;. Come quickly, I must tell you something... I must tell you about my greatness, lest such things are lost in the void!','',26124),
(18138,'enUS','Ooooh, YAH! Gaze upon my rippling musculature. Bask in the glow of my physique.','',26124),
(18139,'enUS','Show us truth! Show us the one who shall betray!','',26124),
(18140,'enUS','This is madness! I\'ve had enough! ENOUGH!','',26124),
(18141,'enUS','EVERYBODY LISTEN UP!','',26124),
(18142,'enUS','I\'m speakin\' to you too, mister fancy britches Mograine! SHUT YER YAP!','',26124),
(18143,'enUS','NOW, everybody in this bar is gonna keep the noise to a minimum or ol\' Jessen is gonna bust out his rollin\' pin and cleaver and go orc on all of ya! IS EVERYONE CLEAR?!!!','',26124),
(18144,'enUS','AAAAAAaaaarrrrgh!!!!! SHUT IT!','',26124),
(18145,'enUS','We must not fail the master.','We must not fail the master.',26124),
(18146,'enUS','Understood.','Understood.',26124),
(18147,'enUS','Yes sir!','Yes sir!',26124),
(18148,'enUS','Spare a silver, friend?','',26124),
(18149,'enUS','Spare a copper? You won\'t need it soon. The end of days nears...','',26124),
(18150,'enUS','Got any food?','',26124),
(18151,'enUS','Please, $g sir:madam;, I have three hungry children! Did I say three? TEN HUNGRY CHILDREN!','',26124),
(18152,'enUS','Psst... Spare a copper for some grog?','',26124),
(18153,'enUS','Will work for food...','',26124),
(18154,'enUS','Allow me to shine your shoes! Only one copper for the service!','',26124),
(18155,'enUS','Warning!  %s emergency shutdown process initiated by $n.  Shutdown will complete in two minutes.','',26124),
(18156,'enUS','Emergency shutdown will complete in one minute.','',26124),
(18157,'enUS','','What\'ll it be?',26124),
(18158,'enUS','','I\'ll come back later.',26124),
(18159,'enUS','','More grog?',26124),
(18160,'enUS','Look at it, Jon. It\'s glorious!','',26124),
(18161,'enUS','Indeed. What better way to symbolize the bond of friendship and brotherhood between Tarren Mill and Southshore by erecting this tower at the halfway point between both towns. Brilliant!','',26124),
(18162,'enUS','You will not shut my manaforge down, scum!','',26124),
(18163,'enUS','%s crushes a vial of green gas.','',26124),
(18164,'enUS','The Lightwarden\'s job is twofold.  Protect the priesthood at all costs first and foremost.  Destroy the enemies of the Light wherever they may hide second.','',26124),
(18165,'enUS','We need you to send reinforcements to Manaforge Duro, Ardonis.  This is not a request, it\'s an order.','',26124),
(18166,'enUS','You cannot be serious!  We are severely understaffed and can barely keep this manaforge functional!','',26124),
(18167,'enUS','You will do as ordered.  Manaforge Duro has come under heavy attack by mana creatures and the situation is out of control.  Failure to comply will not be tolerated!','',26124),
(18168,'enUS','By Muradin\'s beard, $c. This land is on the brink of annihilation. I cannot imagine anyone survived here since the end of the second war.','By Muradin\'s beard, $c. This land is on the brink of annihilation. I cannot imagine anyone survived here since the end of the second war.',26124),
(18169,'enUS','Area trigger works.','',26124),
(18170,'enUS','Ohh, look! Bloodmaul Brew! Mmmm...','',26124),
(18171,'enUS','Bloodmaul Brew? Me favorite!','',26124),
(18172,'enUS','Mmm. Me thirsty!','',26124),
(18173,'enUS','Wut\'s dis?','',26124),
(18174,'enUS','I\'m looking for someone to help me with a task that is long overdue.$B$BYou look capable.','',26124),
(18175,'enUS','The work that you did for me at the Ruins of Farahlon has got me back on schedule.  I\'m assembling my team to head out there now.$B$BThank you, $n.','',26124),
(18176,'enUS','Legion everywhere... they must be dealt with!','',26124),
(18177,'enUS','Thanks to you, we\'ll be able to proceed with our plans for the Ruins of Farahlon.','',26124),
(18178,'enUS','What do you know about ethereals, fleshling?$B$BYou undoubtedly view us all in the same light, oblivious to the conflicts and struggles between the differing factions.$B$BPerhaps it is time for an introduction. I am Commander Ameer of the Protectorate - also your only hope of resolving the infestation of both void creature and Ethereum in this area.\n','',26124),
(18179,'enUS','Mooooo...','',26124),
(18180,'enUS','Moooooooooo!','',26124),
(18181,'enUS','Bessy, you\'re home. Thank the Light!','',26124),
(18182,'enUS','Uh oh...','',26124),
(18183,'enUS','What are Ethereum?','What are Ethereum?',26124),
(18184,'enUS','The Ethereum were the ruling class of ethereal on my homeworld of K\'aresh. Tragically, we were forced to evacuate K\'aresh shortly before the void lord, Dimensius, unleashed his void armies upon the world and utterly decimated all that stood in his way. For this act, the Ethereum vowed vengeance. They have been tracking Dimensius ever since...$B$BThe Protectorate, however, were not a reaction to Dimensius. We were a reaction to Ethereum.','',26124),
(18185,'enUS','I don\'t understand. What do you mean, Ameer?','I don\'t understand. What do you mean, Ameer?',26124),
(18186,'enUS','The Ethereum have grown dark... twisted. Vengeance has become their only recourse and any that would stand in their way or not join their cause are considered enemies. Many saw that the Ethereum were plummeting into madness and left. Several of the Nexus-Princes of the Ethereum council abandoned the Ethereum to form other groups and factions with different goals. The Consortium are one such example of an off-shoot group. The Protectorate another... ','',26124),
(18187,'enUS','So what is your purpose?','So what is your purpose?',26124),
(18188,'enUS','We feel that the Ethereum are as great a threat to our existence as Dimensius. Both must be stopped...','',26124),
(18189,'enUS','I think I understand now. Can I help with any of this? The Ethereum and void creatures are a threat to our survival as well.','I think I understand now. Can I help with any of this? The Ethereum and void creatures are a threat to our survival as well.',26124),
(18190,'enUS','Hostiles detected. Ending transmission.','',26124),
(18191,'enUS','Protectorate transmission complete.','',26124),
(18192,'enUS','Yo. I\'m Vixton Pinchwhistle, official Arena Vendor for the Steamwheedle Fighting Circuit. If you\'ve got the rep, I\'ve got the goods that\'ll make your mouth water.','',26124),
(18193,'enUS','The battle begins in 2 minutes!','',26124),
(18194,'enUS','The battle begins in 1 minute!','',26124),
(18195,'enUS','The battle begins in 30 seconds!','',26124),
(18196,'enUS','The battle has begun!','',26124),
(18197,'enUS','Ugh... Me not feel so guud.','',26124),
(18198,'enUS','I\'m on a bombing mission for Forward Commander Kingston.  I need a gryphon destroyer!','I\'m on a bombing mission for Forward Commander Kingston.  I need a gryphon destroyer!',26124),
(18199,'enUS','If you\'re feeling queasy, speak with Pestle.  He might have something for motion sickness.','',26124),
(18200,'enUS','Send me to the Abyssal Shelf!','Send me to the Abyssal Shelf!',26124),
(18201,'enUS','These damned taxes are breaking my back. King Terenas must be losing his grip if he thinks all this reconstruction will boost the economy.','These damned taxes are breaking my back. King Terenas must be losing his grip if he thinks all this reconstruction will boost the economy.',26124),
(18202,'enUS','He hasn\'t been the same since the War. It\'s like he aged and became an old man overnight. That son of his, though - he\'ll make a fine king one day. \n','He hasn\'t been the same since the War. It\'s like he aged and became an old man overnight. That son of his, though - he\'ll make a fine king one day. \n',26124),
(18203,'enUS','Prince Arthas? Please. Spends all his time chasing after Proudmoore\'s daughter, from what I hear. Boy\'s got more on his mind than affairs of state, I tell ya.\n','Prince Arthas? Please. Spends all his time chasing after Proudmoore\'s daughter, from what I hear. Boy\'s got more on his mind than affairs of state, I tell ya.\n',26124),
(18204,'enUS','I\'m not so sure. I\'ve heard that he\'s being trained as a paladin. Terenas hopes the Silver Hand can teach him some discipline. If anyone can set Arthas straight, it\'d be old Uther.','I\'m not so sure. I\'ve heard that he\'s being trained as a paladin. Terenas hopes the Silver Hand can teach him some discipline. If anyone can set Arthas straight, it\'d be old Uther.',26124),
(18205,'enUS','Aye, that\'s true. Uther - now there\'s a real hero for the people.','Aye, that\'s true. Uther - now there\'s a real hero for the people.',26124),
(18206,'enUS','So have you heard about Lieutenant Blackmoore\'s new gladiator? Some say he\'s unbeatable.','So have you heard about Lieutenant Blackmoore\'s new gladiator? Some say he\'s unbeatable.',26124),
(18207,'enUS','Aye, I seen \'im fight. He\'s an orc - big as they come. Lost a week\'s wages bettin\' against that one. Won\'t make that mistake again!','Aye, I seen \'im fight. He\'s an orc - big as they come. Lost a week\'s wages bettin\' against that one. Won\'t make that mistake again!',26124),
(18208,'enUS','Win or lose, the Lieutenant must be crazy to keep a pet orc like that. Those ones can\'t be trusted. Animals, they are.\n','Win or lose, the Lieutenant must be crazy to keep a pet orc like that. Those ones can\'t be trusted. Animals, they are.\n',26124),
(18209,'enUS','True. True. Light help him if that monster ever gets free!','True. True. Light help him if that monster ever gets free!',26124),
(18210,'enUS','Twenty years we\'ve been stranded in this hell-hole. It\'s all I can do not to run screaming through that blasted Portal. I want to see my loved ones again! I want them to know I\'m still alive.\n','',26124),
(18211,'enUS','I feel the same. But there\'s still a job to do out here. It\'ll all be for naught if this evil finds its way back to Azeroth - back to our homes. We just have to hold on a while longer. Trust Danath - he\'s never let us down before.','',26124),
(18212,'enUS','It\'s not him I\'m worried about. It\'s these new rookies around here - and those creepy purple elves they brought with \'em. They ain\'t even proved themselves yet.\n','',26124),
(18213,'enUS','C\'mon - you sound like a grumpy old man.','',26124),
(18214,'enUS','I am a grumpy old man!','',26124),
(18215,'enUS','Muahahahaha!  Go my minions... destroy the rocket-chief and his nether-rocket!  Annihilate Area 52!  Kneel!  Kneel before Dr. Boom!!!','',26124),
(18216,'enUS','<The apprentice occasionally looks over his shoulder, apparently responding to sounds that you can\'t hear.>$B$BGood day, $n. Pardon me if I seem distracted, but I\'m in the middle of a job for Farmer Natin. I want to have all of his horses shoed by the time he returns from the town hall. What can I help you with?','',26124),
(18217,'enUS','I wish to browse your wares.','I wish to browse your wares.',26124),
(18218,'enUS','Dr. Boom\'s Bots are attacking!  Stop them!','',26124),
(18219,'enUS','Yikes.  That was close!  And they\'re getting closer to me and the nether-rocket every time!  Someone needs to deal with Dr. Boom!','',26124),
(18220,'enUS','You have won this battle, but not... the... war.','',26124),
(18221,'enUS','The Legion\'s final conquest has begun! Once again the subjugation of this world is within our grasp. Let none survive!','',26124),
(18222,'enUS','Crumble and rot!','',26124),
(18223,'enUS','Ashes to ashes, dust to dust!','',26124),
(18224,'enUS','Succumb to the icy chill... of death.','',26124),
(18225,'enUS','It will be much colder in your grave.','',26124),
(18226,'enUS','All life must perish!','',26124),
(18227,'enUS','Your world is ours now!','',26124),
(18228,'enUS','Victory to the Legion!','',26124),
(18229,'enUS','The clock... is still... ticking.','',26124),
(18230,'enUS','You are defenders of a doomed world! Flee here, and perhaps you will prolong your pathetic lives!','',26124),
(18231,'enUS','You look tired....','',26124),
(18232,'enUS','Sweet dreams.','',26124),
(18233,'enUS','The swarm is eager to feed.','',26124),
(18234,'enUS','Pestilence upon you!','',26124),
(18235,'enUS','Let fire rain from above!','',26124),
(18236,'enUS','Earth and sky shall burn!','',26124),
(18237,'enUS','Your hopes are lost!','',26124),
(18238,'enUS','Scream for me.','',26124),
(18239,'enUS','Pity, no time for a slow death!','',26124),
(18240,'enUS','Cry for mercy! Your meaningless lives will soon be forfeit!','',26124),
(18241,'enUS','Your death will be a painful one.','',26124),
(18242,'enUS','You... are marked.','',26124),
(18243,'enUS','Shaza-kiel!','',26124),
(18244,'enUS','You are nothing!','',26124),
(18245,'enUS','Miserable nuisance!','',26124),
(18246,'enUS','Agent Ya-six and I were given a high priority mission from Protectorate command to eradicate all signs of void creature infestation at Ultris. These were to be tactical strikes. Our last hit before returning to the Protectorate Watch Post was to be on a void lord named Arconus who had been getting fat off the fleshlings of the area.$B$BUnfortunately, we arrived a bit late. Ya-six and I got separated in the firefight with the flesh beasts. Now he\'s trapped inside, pinned down behind enemy lines.\n','',26124),
(18247,'enUS','Abandon all hope! The Legion has returned to finish what was begun so many years ago. This time, there will be no escape!','',26124),
(18248,'enUS','Your time is almost... up.','',26124),
(18249,'enUS','Araxes, come in... Are you there Araxes? Visibility is nil. Warp storms blocking us.','',26124),
(18250,'enUS','Copy. Status report, soldier.','',26124),
(18251,'enUS','Suffer, you despicable insect!','',26124),
(18252,'enUS','Just a taste... of what awaits you.','',26124),
(18253,'enUS','Reesh, hokta!','',26124),
(18254,'enUS','No one is going to save you.','',26124),
(18255,'enUS','Don\'t fight it.','',26124),
(18256,'enUS','I hope this damned thing works. *Araxes pounds on the portable transponder.*','',26124),
(18257,'enUS','Your resistance is insignificant.','',26124),
(18258,'enUS','You are mine now.','',26124),
(18259,'enUS','Bow to my will.','',26124),
(18260,'enUS','A-kreesh!','',26124),
(18261,'enUS','Away, vermin!','',26124),
(18262,'enUS','This world will burn!','',26124),
(18263,'enUS','Manach sheek-thrish!','',26124),
(18264,'enUS','Your soul will languish for eternity.','',26124),
(18265,'enUS','All creation will be devoured.','',26124),
(18266,'enUS','I am the coming of the end!','',26124),
(18267,'enUS','I\'m here, commander.','',26124),
(18268,'enUS','We\'ve located the mark, commander. Ya-six and I have been separated. Requesting backup.','',26124),
(18269,'enUS','Copy that, Araxes. Backup is on the way. Hold your position. I repeat, hold your position.','',26124),
(18270,'enUS','Ameer, over and out.','',26124),
(18271,'enUS','The %s\'s mechanical heart begins to beat softly.','',26124),
(18272,'enUS','Welcome to Shatter Point, $n!  I hope you survive the experience!','',26124),
(18273,'enUS','If the Light cannot guide you, my friend, perhaps I can be of assistance. What is it you need?','If the Light cannot guide you, my friend, perhaps I can be of assistance. What is it you need?',26124),
(18274,'enUS','This isle can be strange, can it not? Is there something I can do for you?','This isle can be strange, can it not? Is there something I can do for you?',26124),
(18275,'enUS','Seeking storage? You\'ll want to head to the safety of the Exodar, then... the bankers will be more than happy to help you.','Seeking storage? You\'ll want to head to the safety of the Exodar, then... the bankers will be more than happy to help you.',26124),
(18276,'enUS','','Odd city, ain\'t it?',26124),
(18277,'enUS','','Don\'t say much, do yeh?',26124),
(18278,'enUS','','I miss me home, sometimes. Or maybe I just miss fightin\' for it.',26124),
(18279,'enUS','','I haven\'t seen me brothers in ages.',26124),
(18280,'enUS','Mmm.','',26124),
(18281,'enUS','Araxes! Send help! I\'m pinned down in the mines. I... I\'m not sure where I am exactly but I had the presence of mind to drop tracers on the ground behind me.','',26124),
(18282,'enUS','I can\'t follow the tracers back out, too many flesh beasts in the way. Send someone in... Follow the tracers... Ya-six, out.','',26124),
(18283,'enUS','Hey! Hey you! $R! Over here!','',26124),
(18284,'enUS','I have misplaced Archmage Vargoth\'s Staff.','I have misplaced Archmage Vargoth\'s Staff.',26124),
(18285,'enUS','|cffffff00The Alliance has taken control of a Spirit Tower!|r','',26124),
(18286,'enUS','|cffffff00The Horde has taken control of a Spirit Tower!|r','',26124),
(18287,'enUS','|cffffff00The Horde has lost control of a Spirit Tower!|r','',26124),
(18288,'enUS','|cffffff00The Alliance has lost control of a Spirit Tower!|r','',26124),
(18289,'enUS','','I have an idea.  Let\'s plant this shard in the ground and see what happens.',26124),
(18290,'enUS','','Be sure to visit Vixton Pinchwhistle in Netherstorm\'s Area 52. As the Steamwheedle Fighting Circuit\'s official Arena Vendor, he has all sorts of incredible items for sale to those with enough Arena Points.',26124),
(18291,'enUS','','The evil emanating from the crystal shard has lured one of the colossi.  Put it down quick!',26124),
(18292,'enUS','Hippogryph Master','Hippogryph Master',26124),
(18293,'enUS','','Up here on the hill, $n.',26124),
(18294,'enUS','','$n, there\'s something that I need you to do.',26124),
(18295,'enUS','The hippogryphs are well-tended near the Exodar proper. You should journey there if you wish to fly to Blood Watch.','The hippogryphs are well-tended near the Exodar proper. You should journey there if you wish to fly to Blood Watch.',26124),
(18296,'enUS','The Exodar\'s once-vast supply of textiles has dwindled dangerously low. Your reputation with the draenei here would increase were you to assist us by donating cloth.','',26124),
(18297,'enUS','Funaam is our guild registrar. His office has been set up within the Exodar. Just follow the road; you\'ll find it in no time.','Funaam is our guild registrar. His office has been set up within the Exodar. Just follow the road; you\'ll find it in no time.',26124),
(18298,'enUS','Our humble inn is located in the north of Azure Watch; Chellan will take good care of you.','Our humble inn is located in the north of Azure Watch; Chellan will take good care of you.',26124),
(18299,'enUS','Look at that handsome grouping of chaotic energies!','',26124),
(18300,'enUS','Esbina will be happy to take care of your animal companion, my friend. She waits outside the inn within Azure Watch.','Esbina will be happy to take care of your animal companion, my friend. She waits outside the inn within Azure Watch.',26124),
(18301,'enUS','Oh stop! You\'re going to make me turn red and then someone is going to mistake me for Ethereum and kill me.','',26124),
(18302,'enUS','Ah, seeking training, are you? There are several instructors who are camped in Azure Watch... what are you after?','Ah, seeking training, are you? There are several instructors who are camped in Azure Watch... what are you after?',26124),
(18303,'enUS','Yet they fell to the lure of Sargeras\' evil - and now they have become our most stalwart enemies.','Yet they fell to the lure of Sargeras\' evil - and now they have become our most stalwart enemies.',26124),
(18304,'enUS','This is the wrong way. Arconus is at the other end of the mine. You\'re not chickening out, are you, fleshling? I won\'t follow a coward.','',26124),
(18305,'enUS','They are as cruel as they are powerful - and revel in the destruction of all that exists.','They are as cruel as they are powerful - and revel in the destruction of all that exists.',26124),
(18306,'enUS','Druid? No one here follows that path... but I believe I heard of someone matching that description near the Exodar. Shalannius, I think?','Druid? No one here follows that path... but I believe I heard of someone matching that description near the Exodar. Shalannius, I think?',26124),
(18307,'enUS','What? You wish to donate cloth to Silvermoon?$B$BYou\'re merely after a Hawkstrider, aren\'t you? Very well, very well... do the city this service, and I will see to it that your reputation here rises.','',26124),
(18308,'enUS','They are fearless and unwaveringly loyal to their master\'s godlike will.','They are fearless and unwaveringly loyal to their master\'s godlike will.',26124),
(18309,'enUS','Acteon is our resident tracker, and a good one he is, too - the skins he wears are testament to his skill. His camp is in the southeast of Azure Watch.','Acteon is our resident tracker, and a good one he is, too - the skins he wears are testament to his skill. His camp is in the southeast of Azure Watch.',26124),
(18310,'enUS','Arconus is close. I can feel him. Take the northwest passage. He should be just up and around the corner. Be ready to battle!','',26124),
(18311,'enUS','The Doomguard are utterly devoted to their Pit Lord masters and revel in the destruction of worlds.','The Doomguard are utterly devoted to their Pit Lord masters and revel in the destruction of worlds.',26124),
(18312,'enUS','Turn its back to me! I need a clean shot!','',26124),
(18313,'enUS','This is a waste of my time. Where\'s the action?','',26124),
(18314,'enUS','Did I forget to mention that I\'m injured?','',26124),
(18315,'enUS','Not a bad shot. For a fleshling...','',26124),
(18316,'enUS','I hate flesh beasts...','',26124),
(18317,'enUS','For mastery over the arcane, you need look no further than Semid. He teaches on the eastern side of Azure Watch along with Ruada.','For mastery over the arcane, you need look no further than Semid. He teaches on the eastern side of Azure Watch along with Ruada.',26124),
(18318,'enUS','This reflection of me is exceptionally weak. Don\'t let these brutes lay a finger on my precious image.','',26124),
(18319,'enUS','The good Tullas is a noble woman, and a stalwart defender of the Light. Her lessons are taught in the inn proper.','The good Tullas is a noble woman, and a stalwart defender of the Light. Her lessons are taught in the inn proper.',26124),
(18320,'enUS','In Chellan\'s small but serviceable inn, you can find the priest Guvan.','In Chellan\'s small but serviceable inn, you can find the priest Guvan.',26124),
(18321,'enUS','Shaman','Shaman',26124),
(18322,'enUS','You\'re one of the shaman? Hm. I suppose you are free to choose your own path... whatever that path may be. Tuluun has an isolated, small camp in the northwest of Azure Watch.','You\'re one of the shaman? Hm. I suppose you are free to choose your own path... whatever that path may be. Tuluun has an isolated, small camp in the northwest of Azure Watch.',26124),
(18323,'enUS','Ruada trains young fighters in the eastern portion of Azure Watch. If training in the practical art of warfare is what you\'re looking for, she will help you.','Ruada trains young fighters in the eastern portion of Azure Watch. If training in the practical art of warfare is what you\'re looking for, she will help you.',26124),
(18324,'enUS','There are a number of skilled tradesmen scattered around Azuremyst. Which one are you looking for?','There are a number of skilled tradesmen scattered around Azuremyst. Which one are you looking for?',26124),
(18325,'enUS','%s stops playing dead and charges forward!','',26124),
(18326,'enUS','Daedal knows his way around the art of brewing potions. He works closely with Fateema in western Azure Watch.','Daedal knows his way around the art of brewing potions. He works closely with Fateema in western Azure Watch.',26124),
(18327,'enUS','We have no smithy set up in Azure Watch. However, I\'ve seen a few young blacksmiths coming from that odd encampment on the south coast. Perhaps you should investigate.','We have no smithy set up in Azure Watch. However, I\'ve seen a few young blacksmiths coming from that odd encampment on the south coast. Perhaps you should investigate.',26124),
(18328,'enUS','We had no cooks to spare, but it is a bit odd... there are some delectable scents on the south wind. Follow your nose, eh?','We had no cooks to spare, but it is a bit odd... there are some delectable scents on the south wind. Follow your nose, eh?',26124),
(18329,'enUS','Our enchanters spend their days in the Exodar, working away at any number of projects. Nahogg will start your training.','Our enchanters spend their days in the Exodar, working away at any number of projects. Nahogg will start your training.',26124),
(18330,'enUS','The local artificer, Daelo, can teach you the basics of engineering. Perhaps you can help our technician fix that malfunctioning communications device!','The local artificer, Daelo, can teach you the basics of engineering. Perhaps you can help our technician fix that malfunctioning communications device!',26124),
(18331,'enUS','Fateema is our anchorite, and she has been invaluable in tending crash victims. She practices her trade on the western side of the Watch.','Fateema is our anchorite, and she has been invaluable in tending crash victims. She practices her trade on the western side of the Watch.',26124),
(18332,'enUS','An aspiring angler... well, Diktynna lives on the shore of Ammen Ford, using her net and pole to keep us all supplied. I am certain she could use the help.','An aspiring angler... well, Diktynna lives on the shore of Ammen Ford, using her net and pole to keep us all supplied. I am certain she could use the help.',26124),
(18333,'enUS','Heur has studied the local flora since our landing. He will be able to guide you. You can find him working with Daedal on the western edge of Azure Watch.','Heur has studied the local flora since our landing. He will be able to guide you. You can find him working with Daedal on the western edge of Azure Watch.',26124),
(18334,'enUS','Our new allies, the Stillpine furbolgs, have expressed interest in taking what hides we find. They live to the north; I would seek knowledge from them.','Our new allies, the Stillpine furbolgs, have expressed interest in taking what hides we find. They live to the north; I would seek knowledge from them.',26124),
(18335,'enUS','Dulvi is the woman you want. She trains new prospects in the middle of the Watch.','Dulvi is the woman you want. She trains new prospects in the middle of the Watch.',26124),
(18336,'enUS','Travel to Stillpine Hold, my friend. The furbolgs there have been very helpful, and they might have just the expertise you need.','Travel to Stillpine Hold, my friend. The furbolgs there have been very helpful, and they might have just the expertise you need.',26124),
(18337,'enUS','We have no tailors here in Azure Watch. You might try the encampment on the beach, however - they seem to have a number of tradesmen from across the sea.','We have no tailors here in Azure Watch. You might try the encampment on the beach, however - they seem to have a number of tradesmen from across the sea.',26124),
(18338,'enUS','Jewelcrafting','Jewelcrafting',26124),
(18339,'enUS','Looking for a lapidary? Our jewelcrafters are in the Exodar, using the materials they have uncovered to work wonders. Speak with Farii when you arrive.','Looking for a lapidary? Our jewelcrafters are in the Exodar, using the materials they have uncovered to work wonders. Speak with Farii when you arrive.',26124),
(18340,'enUS','You want what?! I\'ve heard something about one of those odd draenei creatures in the Valley of Heroes. Maybe she knows; I don\'t.','You want what?! I\'ve heard something about one of those odd draenei creatures in the Valley of Heroes. Maybe she knows; I don\'t.',26124),
(18341,'enUS','You\'re weak! COME ON!','',26124),
(18342,'enUS','Now you will know fear!','',26124),
(18343,'enUS','For Salhadaar! For the Nexus-King!','',26124),
(18344,'enUS','Taste pure energy!','',26124),
(18345,'enUS','Your battle prowess is nothing compared to mine!','',26124),
(18346,'enUS','Your death will serve as a message to all that would dare set foot upon Ethereum territory!','',26124),
(18347,'enUS','Pathetic. Is that the best you can do?','',26124),
(18348,'enUS','Run away while you still can!','',26124),
(18349,'enUS','That Broken worm gave you that staff, didn\'t he?  Did he also tell you he\'s the one that sold out his tribe?  No matter, you will both pay for this!','',26124),
(18350,'enUS','','',26124),
(18351,'enUS','That Broken worm!  Did he come clean to you!?  Did he tell you he\'s the one that sold out his tribe to my master?','',26124),
(18352,'enUS','The spirit of water has left us.  Our tribe is doomed.','',26124),
(18353,'enUS','Walk free, elder.  Bring the spirits back to your tribe.','Walk free, elder.  Bring the spirits back to your tribe.',26124),
(18354,'enUS','The winds do not speak to our tribe anymore, $n.  My people are lost without elders to bring the spirits to them.','',26124),
(18355,'enUS','These chains that bind me prevent me from bringing the spirit of fire to my people, $n.  Souls without fire are souls that cannot rebel against their masters.','',26124),
(18356,'enUS','I am free!  I will ask the spirit of fire to return to us so that my people may have the courage to fight their masters!  I thank you, $r.','',26124),
(18357,'enUS','I\'m free!  The spirit of water returns to my people.  It will bring us the wisdom we need to survive in this harsh land.  I am in your debt, $n.','',26124),
(18358,'enUS','You\'ve freed me!  The winds speak to my people once again and grant us their strength.  I thank you, stranger.','',26124),
(18359,'enUS','$n has taken the flag!','',26124),
(18360,'enUS','I\'ve heard there\'s a pair of Wildhammer shamans visiting the Dwarven District, so you might try your luck there.$B$BThe draenei Farseer who used to lounge about the Valley of Heroes went off to meet them, too.','I\'ve heard there\'s a pair of Wildhammer shamans visiting the Dwarven District, so you might try your luck there.$B$BThe draenei Farseer who used to lounge about the Valley of Heroes went off to meet them, too.',26124),
(18361,'enUS','The flag has been dropped!','',26124),
(18362,'enUS','Paladin','Paladin',26124),
(18363,'enUS','Us no like paladins. Elf lady come to city, stay in Royal Quarter. Her paladin. You talk, learn paladin things.','Us no like paladins. Elf lady come to city, stay in Royal Quarter. Her paladin. You talk, learn paladin things.',26124),
(18364,'enUS','The flag has been reset.','',26124),
(18365,'enUS','Paladin? Have you been partaking of the Apothecary\'s concoctions or some such thing? I have heard a rumor that some elven contingent is visiting the Dark Lady within the Undercity. Perhaps one of them might know.','Paladin? Have you been partaking of the Apothecary\'s concoctions or some such thing? I have heard a rumor that some elven contingent is visiting the Dark Lady within the Undercity. Perhaps one of them might know.',26124),
(18366,'enUS','%s discards his weapons and reaches for a polearm!','',26124),
(18367,'enUS','Cowards! You\'ll never draw me into the shadows!','',26124),
(18368,'enUS','%s is exhausted.','',26124),
(18369,'enUS','And just what do you think you are doing?  You dare to interfere with my master\'s experiment?','',26124),
(18370,'enUS','Do you like what we\'ve done here?  Perhaps we will drop these crystals from the sky all over Outland.','',26124),
(18371,'enUS','I grow bored with your attempt to heal the land and quell the energies summoning and driving the colossi mad.  Goliathon, King of the Colossi, Prince Kael\'thas and I demand that you defend the crystal!','',26124),
(18372,'enUS','We will meet again soon.','',26124),
(18373,'enUS','','Your help was invaluable, my friend.$B$BI can assure you that the Cenarion Expedition will do everything in its power to counter any future tainted crystals dropped from the heavens by Illidan.',26124),
(18374,'enUS','HIT ME!','',26124),
(18375,'enUS','$n has captured the flag!','',26124),
(18376,'enUS','Children, come to me!','Children, come to me!',26124),
(18377,'enUS','Hah!  Your ritual has failed, fool!','',26124),
(18378,'enUS','Bring out the gladiator!','',26124),
(18379,'enUS','My money\'s on the fleshfiend. That creature is terrifying!','',26124),
(18380,'enUS','There\'s no way some Protectorate prisoner is going to defeat our gladiator!','',26124),
(18381,'enUS','The netherlisk will be a challenge but the gladiator will pull through!','',26124),
(18382,'enUS','How do you defeat that which has no life?','',26124),
(18383,'enUS','I hear the rock flayer has been sucking down unstable energy since its capture.','',26124),
(18384,'enUS','$n has captured the flag!','',26124),
(18385,'enUS','Light!  Do not fail me!','',26124),
(18386,'enUS','Do not die on me, vindicator!','',26124),
(18387,'enUS','Kael\'thas and the Legion... just what we needed!','',26124),
(18388,'enUS','You\'ve saved me, fleshling! Ameer will hear of this noble act.','',26124),
(18389,'enUS','We\'re here for you, lost brother.  It is custom to offer you a chance to repent before you are destroyed.  We offer you this chance, as the naaru\'s law commands.','',26124),
(18390,'enUS','Do not make me laugh.  Is this the mighty Aldor army that\'s come to defeat me?','',26124),
(18391,'enUS','We may be few, Socrethar, but our faith is strong.  Something you will never understand.  Now that custom has been served, prepare to meet your end.','',26124),
(18392,'enUS','Yes, let us settle this.  Before we begin, however, there\'s somebody I\'d like you to meet.','',26124),
(18393,'enUS','How... how could you?!','',26124),
(18394,'enUS','My heart has been filled with hate since our sworn enemies were allowed into our city.  I knew the one known as Voren\'thal before he was called a Seer.  It was by his hand that my brother was slain.','',26124),
(18395,'enUS','I turned that hate on the Illidari and the Burning Legion... but they weren\'t the ones who betrayed us.  We were the naaru\'s chosen!  We lived and died for them!','',26124),
(18396,'enUS','Once the hatred in my heart became focused, everything became clear to me.  Shattrath must be destroyed and the naaru with it.','',26124),
(18397,'enUS','Socrethar is clouding your mind, Kaylaan!  You do not mean these words!  I remember training you when you were but a youngling.  Your will was strong even then!','',26124),
(18398,'enUS','You are wrong, Adyen.  My mind has never been clearer.','',26124),
(18399,'enUS','Teacher...','',26124),
(18400,'enUS','','The Light wants its lost son back, Socrethar.',26124),
(18401,'enUS','','I offer myself in exchange.  You will have Ishanah, the High Priestess of the Aldor, as your prisoner if you release Kaylaan from your dark grasp.',26124),
(18402,'enUS','You foolish old hag... Why would I do that when I can have you both?','',26124),
(18403,'enUS','','',26124),
(18404,'enUS','No!  What have I done?','',26124),
(18405,'enUS','Light grant me strength!','',26124),
(18406,'enUS','Oh, please!  This is sickening; I\'m going to have to kill you all myself.','',26124),
(18407,'enUS','Slay these dogs, Kaylaan!  Earn your place in the Burning Legion!','',26124),
(18408,'enUS','What are you waiting for?  Finish them, young one.  Let your hatred burn!','',26124),
(18409,'enUS','Yes... master.','',26124),
(18410,'enUS','We will not fail.','We will not fail.',26124),
(18411,'enUS','What is this place?','What is this place?',26124),
(18412,'enUS','Where is Medivh?','Where is Medivh?',26124),
(18413,'enUS','How do you navigate the tower?','How do you navigate the tower?',26124),
(18414,'enUS','This is the tower of Karazhan and residence of my master, Medivh. As a humble doorman, there is little else I can explain to you.','',26124),
(18415,'enUS','All inquiries regarding Medivh should be directed to Moroes, the Tower Steward. I myself know very little about the Master\'s business. I believe several nobles are currently having an audience with Moroes in the Banquet Hall, if you wish to inquire further.','',26124),
(18416,'enUS','From here in the Gatehouse, you may travel in one of three directions. The stairs behind me lead to the Grand Ball Room, where guests are currently being entertained. I\'m sure you can smell the nearby Stables, and the entrance to Servant\'s Quarters lies next to the Gatehouse door.','',26124),
(18417,'enUS','Who is Midnight?','Who is Midnight?',26124),
(18418,'enUS','Midnight is Attumen the Huntsman\'s personal mount. I\'ve never seen a faster, stronger, or more mean spirited horse. And her rider is even more temperamental! Everyone keeps their distance from her, lest they get a hoof upside the head from Midnight or a beating from Attumen.','',26124),
(18419,'enUS','The damn spiders, the endlessly screeching bats, and those blasted demon beasts have all taken residence in the Servant\'s Quarters. It\'s not safe to walk around anymore, especially when the big ones come out of hiding.','',26124),
(18420,'enUS','Help you with what situation?','Help you with what situation?',26124),
(18421,'enUS','Big ones?','Big ones?',26124),
(18422,'enUS','Oh yeah, I\'ve never seen them personally, but sometimes I hear them in the distance. Keep a watchful eye out for them if you venture inside.','',26124),
(18423,'enUS','I don\'t have time for idle chitchat. I have men and women to train, and a tower to watch.','',26124),
(18424,'enUS','Greetings! Behold one of the finest musical instruments in all of Lordaeron. It\'s a true honor to perform for the Master and all his guests. Take a seat in the audience, I hear a show is starting soon.','',26124),
(18425,'enUS','Splendid! Wonderful! Such an excellent performance from a relative unknown! Do you have an agent, perhaps?','',26124),
(18426,'enUS','This party is pointless. Those foolish nobles will never get to see Medivh. Can\'t they see this? I should have just stayed in Darkshire with my family instead of wasting my time here.','',26124),
(18427,'enUS','It\'s here... somewhere... I know it. Somewhere in this library is the knowledge I\'m looking for...','',26124),
(18428,'enUS','','This tower is complete and utter madness. This isn\'t a library, it\'s a huge haystack of books and I don\'t think the needle even exists! Now, what was I doing?',26124),
(18429,'enUS','Your presence here is interfering with very important work. Please leave at once. Where was I, again?','',26124),
(18430,'enUS','Ah, such an odd place to find potential customers!','',26124),
(18431,'enUS','What could you be selling?','What could you be selling?',26124),
(18432,'enUS','Let\'s do this... Just keep me covered and I\'ll deliver the package.','',26124),
(18433,'enUS','By the second sun of K\'aresh, look at this place! I can only imagine what Salhadaar is planning. Come on, let\'s keep going.','',26124),
(18434,'enUS','With this much void waste and run-off, a toxic void horror can\'t be too far behind.','',26124),
(18435,'enUS','Look there, fleshling! Salhadaar\'s conduits! He\'s keeping well fed....','',26124),
(18436,'enUS','Alright, keep me protected while I plant this disruptor. This shouldn\'t take very long.','',26124),
(18437,'enUS','Done! Back up! Back up!','',26124),
(18438,'enUS','Keep these things off me!','',26124),
(18439,'enUS','I\'m under attack! I repeat, I am under attack!','',26124),
(18440,'enUS','I need to find a new line of work.','',26124),
(18441,'enUS','Protect the conduit! Stop the intruders!','',26124),
(18442,'enUS','Looks like my work here is done. Report back to the holo-image of Ameer over at the transponder.','',26124),
(18443,'enUS','Prepare to enter oblivion, meddlers. You have unleashed a god!','',26124),
(18444,'enUS','Elen-ak shaktha!','',26124),
(18445,'enUS','Rise, my soldiers, and march for me!','',26124),
(18446,'enUS','You will... ultimately fail.','',26124),
(18447,'enUS','My life... to the master.','',26124),
(18448,'enUS','A pleasure... to serve the master.','',26124),
(18449,'enUS','One less enemy of the master!','',26124),
(18450,'enUS','Lambs for the slaughter!','',26124),
(18451,'enUS','Let this torment end!!','Let this torment end!!',26124),
(18452,'enUS','I am... released?','I am... released?',26124),
(18453,'enUS','Is it really... over?','Is it really... over?',26124),
(18454,'enUS','I obey.','I obey.',26124),
(18455,'enUS','You\'re the lucky one.','You\'re the lucky one.',26124),
(18456,'enUS','Let these monsters taste cold steel!','',26124),
(18457,'enUS','Back, hold them back!','',26124),
(18458,'enUS','Agghh!','',26124),
(18459,'enUS','I... can\'t....','',26124),
(18460,'enUS','Back to the void with you!','',26124),
(18461,'enUS','One less demon to contend with!','',26124),
(18462,'enUS','For Lordaeron! For victory!','',26124),
(18463,'enUS','Rout these demons!','',26124),
(18464,'enUS','Good will... prevail.','',26124),
(18465,'enUS','Light receive me!','',26124),
(18466,'enUS','For the Light!','',26124),
(18467,'enUS','Justice is served!','',26124),
(18468,'enUS','I\'m itchin\' to shoot somethin\'!','',26124),
(18469,'enUS','Blow \'em away!','',26124),
(18470,'enUS','Carry on the fight!','',26124),
(18471,'enUS','For... Khaz... Modan!','',26124),
(18472,'enUS','Take that, ya freakish git!','',26124),
(18473,'enUS','That\'s what I\'m talkin\' about!','',26124),
(18474,'enUS','','I think a change is in order....',26124),
(18475,'enUS','','You could use a makeover.',26124),
(18476,'enUS','','Not... my best... day.',26124),
(18477,'enUS','','Res...?',26124),
(18478,'enUS','','Next!',26124),
(18479,'enUS','%s breaks down into globules!','',26124),
(18480,'enUS','For... Quel\'Thalas.','',26124),
(18481,'enUS','Stay... the course.','',26124),
(18482,'enUS','Vengeance is ours!','',26124),
(18483,'enUS','We\'re doomed!','',26124),
(18484,'enUS','It\'s the end of the world!','',26124),
(18485,'enUS','Have at them! Lok\'tar!','',26124),
(18486,'enUS','Destroy them all!','',26124),
(18487,'enUS','Keep... fighting!','',26124),
(18488,'enUS','Spill their... blood!','',26124),
(18489,'enUS','Demon filth!','',26124),
(18490,'enUS','Another one down!','',26124),
(18491,'enUS','Greetings, fleshling. I am Navuud, chief researcher here at the Protectorate Watch Post.','',26124),
(18492,'enUS','','Leaving Kael\'thas was the best thing any of us ever did.  His followers are too blind or too scared to realize where he\'s leading them.$B$BWe, however, are not.',26124),
(18493,'enUS','For the Earth Mother!','',26124),
(18494,'enUS','Crush them!','',26124),
(18495,'enUS','I return... to the earth.','',26124),
(18496,'enUS','My spirit... goes on.','',26124),
(18497,'enUS','Balance must be restored!','',26124),
(18498,'enUS','This world is not for you!','',26124),
(18499,'enUS','Take their heads!','',26124),
(18500,'enUS','We kill \'em good, mon.','',26124),
(18501,'enUS','Dis no good....','',26124),
(18502,'enUS','It all over... now.','',26124),
(18503,'enUS','You stay dead.','',26124),
(18504,'enUS','Da Legion gonna pay.','',26124),
(18505,'enUS','It all over for you, mon.','',26124),
(18506,'enUS','Bad mojo.','',26124),
(18507,'enUS','I no gonna make it....','',26124),
(18508,'enUS','The spirits condemn you!','',26124),
(18509,'enUS','My spirit will fight on.','',26124),
(18510,'enUS','I am one... with all.','',26124),
(18511,'enUS','Kagh!','',26124),
(18512,'enUS','Help!','',26124),
(18513,'enUS','','Press the attack!',26124),
(18514,'enUS','','Andu-falah-dor!',26124),
(18515,'enUS','','Don\'t give... up!',26124),
(18516,'enUS','','Elune help us!',26124),
(18517,'enUS','','I make this look easy.',26124),
(18518,'enUS','','One shot, one kill!',26124),
(18519,'enUS','','Ahhh!!',26124),
(18520,'enUS','','I tried.',26124),
(18521,'enUS','','Yes!',26124),
(18522,'enUS','','Take that!',26124),
(18523,'enUS','','Ehrin\'delumina shorinel!',26124),
(18524,'enUS','','Begone forever!',26124),
(18525,'enUS','','Take the fight to them!',26124),
(18526,'enUS','','Tor ilisar\'thera\'nal!',26124),
(18527,'enUS','','If it is Elune\'s... will.',26124),
(18528,'enUS','','Keep at them!',26124),
(18529,'enUS','We will drive you from our lands!','',26124),
(18530,'enUS','Death is too good for you!','',26124),
(18531,'enUS','Remain... strong.','',26124),
(18532,'enUS','The land... cries out.','',26124),
(18533,'enUS','You deserve worse than death!','',26124),
(18534,'enUS','Another falls!','',26124),
(18535,'enUS','Winds... carry me.','',26124),
(18536,'enUS','Do not... despair.','',26124),
(18537,'enUS','','I\'m in jeopardy! Help me if you can!',26124),
(18538,'enUS','','They\'ve broken through!',26124),
(18539,'enUS','','I did... my best.',26124),
(18540,'enUS','','Don\'t give up! We must prevail!',26124),
(18541,'enUS','','Hold them back as long as possible!',26124),
(18542,'enUS','','We must hold strong!',26124),
(18543,'enUS','','We are lost! Fall back!',26124),
(18544,'enUS','I will lay down for no one!','',26124),
(18545,'enUS','Bring the fight to me and pay with your lives!','',26124),
(18546,'enUS','I\'ve lost Archmage Vargoth\'s Staff. Can you replace it?','I\'ve lost Archmage Vargoth\'s Staff. Can you replace it?',26124),
(18547,'enUS','There are those who seek to lie and twist the truth.  Seers, on the other hand, bring the truth to light.$B$BThe purpose of this library, $n, is to make a seer out of everyone.','',26124),
(18548,'enUS','Among ethereals, certain members deal specifically with flesh and beings of flesh. Those individuals are known as flesh handlers.','',26124),
(18549,'enUS','You seek something in our fair land?','You seek something in our fair land?',26124),
(18550,'enUS','Skymistress Gloaming stands just outside the Magister\'s Gate near Silvermoon proper, tending to the dragonhawks.','Skymistress Gloaming stands just outside the Magister\'s Gate near Silvermoon proper, tending to the dragonhawks.',26124),
(18551,'enUS','If you\'re looking to register a guild, I would suggest inquiring within the walls of Silvermoon City itself.','If you\'re looking to register a guild, I would suggest inquiring within the walls of Silvermoon City itself.',26124),
(18552,'enUS','Delaniel keeps her inn well in the southeastern corner of Falconwing Square. Good food, fine wine, soft beds... what more could one ask for?','Delaniel keeps her inn well in the southeastern corner of Falconwing Square. Good food, fine wine, soft beds... what more could one ask for?',26124),
(18553,'enUS','Some rangers seem to be unable to look after their beastly charges themselves. If you simply must stow such a thing somewhere in town, Anathos will take it off your hands. She waits and works in Falconwing Square, outside the inn.','Some rangers seem to be unable to look after their beastly charges themselves. If you simply must stow such a thing somewhere in town, Anathos will take it off your hands. She waits and works in Falconwing Square, outside the inn.',26124),
(18554,'enUS','A cow woman who claims to be a druid has set up camp within Silvermoon. She\'s no doubt grazing on our planters as we speak.','A cow woman who claims to be a druid has set up camp within Silvermoon. She\'s no doubt grazing on our planters as we speak.',26124),
(18555,'enUS','The rangers take their lessons from Hannovia, a farstrider who stays in the northeast building of Falconwing Square.','The rangers take their lessons from Hannovia, a farstrider who stays in the northeast building of Falconwing Square.',26124),
(18556,'enUS','Garridel teaches the arcane arts within Falconwing Square; you can find her on the second floor of the inn.','Garridel teaches the arcane arts within Falconwing Square; you can find her on the second floor of the inn.',26124),
(18557,'enUS','Is this the best you can throw at me, Salhadaar??','',26124),
(18558,'enUS','Time for the pain!','',26124),
(18559,'enUS','Another pitiful contender...','',26124),
(18560,'enUS','Send it out!','',26124),
(18561,'enUS','For the Protectorate! DIE ETHEREUM FILTH!','',26124),
(18562,'enUS','Thanks, friend. Will you help me get out of here?','',26124),
(18563,'enUS','Blood Knight Noellene awaits young trainees within the northeast building of the square.','Blood Knight Noellene awaits young trainees within the northeast building of the square.',26124),
(18564,'enUS','If priestly knowledge is what you seek, Ponaris is your man. He works with the others on the second floor of Delaniel\'s inn.','If priestly knowledge is what you seek, Ponaris is your man. He works with the others on the second floor of Delaniel\'s inn.',26124),
(18565,'enUS','There\'s a building in the northeast of Falconwing Square... within, you\'ll most likely find Tannaria, a woman well skilled in remaining out of sight.','There\'s a building in the northeast of Falconwing Square... within, you\'ll most likely find Tannaria, a woman well skilled in remaining out of sight.',26124),
(18566,'enUS','We\'re not too far from the Protectorate Watch Post, $n. This way!','',26124),
(18567,'enUS','Commander! This fleshling rescued me!','',26124),
(18568,'enUS','%s salutes Commander Ameer.','',26124),
(18569,'enUS','Celoenus is our resident expert on the summoning of demons. He resides in the Falconwing Square Inn, no doubt on the second floor.','Celoenus is our resident expert on the summoning of demons. He resides in the Falconwing Square Inn, no doubt on the second floor.',26124),
(18570,'enUS','I know of a local alchemist. Sheynathren, I believe his name is. When last I saw him, he was heading off to Saltheril\'s Haven, no doubt to engage in one of his ridiculous parties.','I know of a local alchemist. Sheynathren, I believe his name is. When last I saw him, he was heading off to Sartheril\'s Haven, no doubt to engage in one of his ridiculous parties.',26124),
(18571,'enUS','The farstriders keep a smith at their retreat in the eastern portion of Eversong. Arathel might be able to help you.','The farstriders keep a smith at their retreat in the eastern portion of Eversong. Arathel might be able to help you.',26124),
(18572,'enUS','Delaniel keeps a delightful cook named Quarelestra on staff. You\'ll do well to learn from her. Naturally, you\'ll find her in the Falconwing Square inn.','Delaniel keeps a delightful cook named Quarelestra on staff. You\'ll do well to learn from her. Naturally, you\'ll find her in the Falconwing Square inn.',26124),
(18573,'enUS','Look no further than Saltheril\'s little celebration if you\'re after the enchanter Eredania. She received her invitation a few days ago.','Look no further than Saltheril\'s little celebration if you\'re after the enchanter Eredania. She received her invitation a few days ago.',26124),
(18574,'enUS','Such a dangerous and unpredictable profession cannot reliably be practiced among our pristine woods without calamitous consequences. You might try Silvermoon City itself, however; the walls are strong enough to weather the blasts.','Such a dangerous and unpredictable profession cannot reliably be practiced among our pristine woods without calamitous consequences. You might try Silvermoon City itself, however; the walls are strong enough to weather the blasts.',26124),
(18575,'enUS','For those who prefer to rely on mundane methods of mending the flesh, Kanaria keeps a tidy station within the Falconwing Square inn.','For those who prefer to rely on mundane methods of mending the flesh, Kanaria keeps a tidy station within the Falconwing Square inn.',26124),
(18576,'enUS','There is a fisherman within our grand city... if spending time with pungent, wet, flopping abominations is your idea of a pleasant day.','There is a fisherman within our grand city... if spending time with pungent, wet, flopping abominations is your idea of a pleasant day.',26124),
(18577,'enUS','Who better to have tending one\'s floral arrangements for a party than the botanist Tyniarrel? I\'m sure Saltheril pays him in wine.','Who better to have tending one\'s floral arrangements for a party than the botanist Tyniarrel? I\'m sure Saltheril pays him in wine.',26124),
(18578,'enUS','...they told us not to go... but we went anyway... they told us not to go... but we went anyway...','...they told us not to go... but we went anyway... they told us not to go... but we went anyway...',26124),
(18579,'enUS','Ameer might be worried about what the Ethereum are doing but I\'m squarely focused on the real danger here: Dimensius.','',26124),
(18580,'enUS','Our resident jewelcrafter, Aleinia, can be found within Delaniel\'s establishment in Falconwing Square. She might be looking for an apprentice.','Our resident jewelcrafter, Aleinia, can be found within Delaniel\'s establishment in Falconwing Square. She might be looking for an apprentice.',26124),
(18581,'enUS','Sathein finds the lynx hides in Eversong perfect for his creations. You should speak to him - he stands with Mathreyn just southwest of the Magister\'s Gate.','Sathein finds the lynx hides in Eversong perfect for his creations. You should speak to him - he stands with Mathreyn just southwest of the Magister\'s Gate.',26124),
(18582,'enUS','The miners can be found within Silvermoon City, no doubt close to the odiferous forges where they smelt their gains.','The miners can be found within Silvermoon City, no doubt close to the odiferous forges where they smelt their gains.',26124),
(18583,'enUS','Mathreyn is skilled in the barbaric practice of skinning, if that is truly your wont. He supplies Sathein with hides; you can find them both just southwest of the Magister\'s Gate.','Mathreyn is skilled in the barbaric practice of skinning, if that is truly your wont. He supplies Sathein with hides; you can find them both just southwest of the Magister\'s Gate.',26124),
(18584,'enUS','The good sempstress is of late occupied at Saltheril\'s Haven; her prowess with a needle and thread is assuredly appreciated there.','The good sempstress is of late occupied at Saltheril\'s Haven; her prowess with a needle and thread is assuredly appreciated there.',26124),
(18585,'enUS','What are you after? Speak up.','What are you after? Speak up.',26124),
(18586,'enUS','What elekks are for sale?','What elekks are for sale?',26124),
(18587,'enUS','The %s, having fought the good fight, falls to pieces.','',26124),
(18588,'enUS','In a different time and place I would\'ve been considered but a youngling.  Here I am a seasoned combatant ready to live and die for the glory of the naaru.$B$BTen of us went into Manaforge Ara.  All the others fell to the Legion.','',26124),
(18589,'enUS','%s begins to metamorphose...','',26124),
(18590,'enUS','It is time to face Socrethar, $n.  Are you ready?','',26124),
(18591,'enUS','I\'m ready, Adyen.','I\'m ready, Adyen.',26124),
(18592,'enUS','Did the Scryers send you to contact me?  You do not look like a Scryer at all.','',26124),
(18593,'enUS','','Speak quickly; I don\'t have time to waste on idle chatter. The Forsaken have become a force to be reckoned with, but there is still much to do in a given day. This city doesn\'t run itself.$b$bWhat do you want?',26124),
(18594,'enUS','It is hopeless... I\'ve done all I can.','',26124),
(18595,'enUS','I\'ve failed.  The Light has abandoned me.','',26124),
(18596,'enUS','You don\'t have what it takes to fight in the Steamwheedle Fighting Circuit, $c. Stop wasting my time.','You don\'t have what it takes to fight in the Steamwheedle Fighting Circuit, $c. Stop wasting my time.',26124),
(18597,'enUS','All right, $c. You think you have what it takes to make it in the Steamwheedle Fighting Circuit\'s arena battlegrounds?','All right, $c. You think you have what it takes to make it in the Steamwheedle Fighting Circuit\'s arena battlegrounds?',26124),
(18598,'enUS','I would like to fight in an arena.','I would like to fight in an arena.',26124),
(18599,'enUS','You hear a faint echo....','',26124),
(18600,'enUS','You hear a loud rumble of metal grinding on stone...','',26124),
(18601,'enUS','The naga\'s water boiler activates and the sound of dying frenzies can be heard below.','',26124),
(18602,'enUS','You only hasten the inevitable. In time, all will be devoured!','',26124),
(18603,'enUS','Ye\'ll find the battlemasters around the war table in the Hall of Arms.','Ye\'ll find the battlemasters around the war table in the Hall of Arms.',26124),
(18604,'enUS','','You will find the the battlemasters gathered at the Warrior\'s Terrace.',26124),
(18605,'enUS','You\'ll find the battlemasters in the war room of Stormwind Keep.','You\'ll find the battlemasters in the war room of Stormwind Keep.',26124),
(18606,'enUS','%s seems to have weakened.','',26124),
(18607,'enUS','Go to the Hunter Rise. You will find the battlemasters there.','Go to the Hunter Rise. You will find the battlemasters there.',26124),
(18608,'enUS','You will find the battlemasters inside the Hall of the Brave in the Valley of Honor.','You will find the battlemasters inside the Hall of the Brave in the Valley of Honor.',26124),
(18609,'enUS','You go to Royal Quarter. They all there, in circle around room.','You go to Royal Quarter. They all there, in circle around room.',26124),
(18610,'enUS','Arena Battlemaster','Arena Battlemaster',26124),
(18611,'enUS','You will find him in the Caregiver Center in the Seat of the Naaru. Light be with you.','You will find him in the Caregiver Center in the Seat of the Naaru. Light be with you.',26124),
(18612,'enUS','Oh yeah, I got muffins!','',26124),
(18613,'enUS','Alright, muffin man, show me your muffins!','Alright, muffin man, show me your muffins!',26124),
(18614,'enUS','Fresh muffins!  Get your fresh muffins right here!','',26124),
(18615,'enUS','What\'s up?  I hope you\'re having a fabulous day.  Come buy one of my muffins!','',26124),
(18616,'enUS','I\'ve got muffins right over here.  Come on over!','',26124),
(18617,'enUS','Yea, yea, I\'m the muffin man.  You know why?  Because I sell muffins, that\'s why!','',26124),
(18618,'enUS','Nothing compares to my magnificent muffins!','',26124),
(18619,'enUS','Get \'em hot and fresh while you can.  You won\'t find a better price on muffins anywhere else in Shattrath.','',26124),
(18620,'enUS','Nothing like a tankard full to wash down one of my magnificent muffins.','',26124),
(18621,'enUS','Yea, that hit the spot.  Muffins for sale!  Get your fresh muffins right here!','',26124),
(18622,'enUS','','The Legion requires you work faster!  Faster, worms!',26124),
(18623,'enUS','','The full might of the Burning Legion shall arrive soon.',26124),
(18624,'enUS','','Do not stop!  The hour of our glory draws near!',26124),
(18625,'enUS','','You shall suffer eternally if you fail!',26124),
(18626,'enUS','As you say!','',26124),
(18627,'enUS','Hey you!  Get over here and check out my hot muffins!','',26124),
(18628,'enUS','I live to serve!','',26124),
(18629,'enUS','Always with the speeches.','',26124),
(18630,'enUS','Get me the parts for another Fel Reaver, now!','',26124),
(18631,'enUS','There are enough parts to rebuild it. Stronger, faster, better!','',26124),
(18632,'enUS','I don\'t care about the shell, just get the internal parts!','',26124),
(18633,'enUS','Fleshling, I am Captain Saeed of the Protectorate and these soldiers that stand by me are my avengers. We await orders from the fleshling who destroyed the void conduit. On that fleshling\'s word, we will make our way up to Dimensius\'s lair and wait for the word to make a final strike!$B$BToo long it has been... The void lord will soon face our combined might!','',26124),
(18634,'enUS','Saeed is currently engaged or awaiting orders to engage. You may check directly east of me and see if Saeed is ready for you. If he is not present then he is off fighting another battle. I recommend that you wait for him to return before attacking Dimensius.','',26124),
(18635,'enUS','I need a new phase disruptor, Professor.','I need a new phase disruptor, Professor.',26124),
(18636,'enUS','The nether drake looks upon you approvingly.','',26124),
(18637,'enUS','I\'m ready to fly! Take me up, dragon!','I\'m ready to fly! Take me up, dragon!',26124),
(18638,'enUS','The nether drake refuses to let you mount it. Be sure to get a phase disruptor from Professor Dabiri. It will not take you up without one.','',26124),
(18639,'enUS','I am that fleshling, Saeed. Let\'s go!','I am that fleshling, Saeed. Let\'s go!',26124),
(18640,'enUS','This is it, $n. We charge on your orders! Just say the word and my men and I will engage!','',26124),
(18641,'enUS','I am ready. Let\'s make history!','I am ready. Let\'s make history!',26124),
(18642,'enUS','You heard the fleshling! MOVE OUT!','',26124),
(18643,'enUS','Tell me when you are ready, $n. We will attack on your command.','',26124),
(18644,'enUS','It\'s now or never, soldiers! Let\'s do this! For K\'aresh! For the Protectorate!','',26124),
(18645,'enUS','The time for your destruction has finally come, Dimensius!','',26124),
(18646,'enUS','%s laughs.','',26124),
(18647,'enUS','Time only has meaning to mortals, insect. Dimensius is infinite!','',26124),
(18648,'enUS','I need Saeed\'s help, Professor! Where is he?','I need Saeed\'s help, Professor! Where is he?',26124),
(18649,'enUS','We are victorious! Dimensius is no more! Report back to the Professor, hero.','',26124),
(18650,'enUS','Welcome to Eco-Dome Midrealm, traveler. I would warn you to be wary of dealing with that goblin, Shauly. I don\'t believe I\'ve ever heard anyone use the word \"buddy\" as punctuation before.','',26124),
(18651,'enUS','Now to begin the repairs.','',26124),
(18652,'enUS','It\'s working! Ghabar will be pleased to hear the news.','',26124),
(18653,'enUS','','We\'ve finally got what we came here for. I just wish we\'d hired $n right away and saved you the embarassment, Jaxon.',26124),
(18654,'enUS','What\'s that supposed to mean?','',26124),
(18655,'enUS','Well at least we can leave this place and start working on the dome at Area --','',26124),
(18656,'enUS','','Jaxon! Are you trying to blow our cover? So help me, I\'ll take the needle right out of this blouse I\'m working on...',26124),
(18657,'enUS','No, not the needle! Anything but the needle!','',26124),
(18658,'enUS','%s laughs at your clumsiness.','',26124),
(18659,'enUS','With the Allerian Stronghold surrounded by enemies on all sides it\'s time for us to take the fight to them.','',26124),
(18661,'enUS','','If you\'re going to come out here, make yourself useful because the shadowstalker over there isn\'t doing much.',26124),
(18662,'enUS','With the precise angle and velocity...','',26124),
(18663,'enUS','','The Battle of Mount Hyjal is one of the most well-guarded events of this timeline.  Should an intruder alter its outcome, the impact would extend to all subsequent moments in history.$B$BAs the Aspect\'s prime mate I\'m far more in tune with the flow of time than other bronze dragons.  I recently sensed a minute ripple in time emanating from the events surrounding the Battle of Mount Hyjal.  Someone or something is attempting to change this timeline and they must be stopped.',26124),
(18664,'enUS','Thank you, earthmender.','',26124),
(18665,'enUS','','Thank you, kind soul. You have freed me from the watery prison of Coilskar but many more are being held prisoner nearby. Will you assist me in freeing them as well?',26124),
(18666,'enUS','Just one moment. You cannot purchase a fine elekk without proving yourself a friend to the Exodar. Return once we know you can be trusted.','Just one moment. You cannot purchase a fine elekk without proving yourself a friend to the Exodar. Return once we know you can be trusted.',26124),
(18667,'enUS','What are you after? Speak up. I\'m not about to trust you with one of my Elekks until you prove your dedication and friendship to our people.','What are you after? Speak up. I\'m not about to trust you with one of my Elekks until you prove your dedication and friendship to our people.',26124),
(18668,'enUS','','I sense the tortured spirits, $n. They are this way. Come quickly!',26124),
(18669,'enUS','','Grant me protection, $n. I must break through their foul magic!',26124),
(18670,'enUS','','Now we must find the exit.',26124),
(18671,'enUS','','It shouldn\'t be much further, $n. The exit is just up ahead.',26124),
(18672,'enUS','','Thank you, $n. Please return to my brethren at the Altar of Damnation, near the Hand of Gul\'dan, and tell them that Wilda is safe. May the Earthmother watch over you...',26124),
(18673,'enUS','','The naga do not respect nature. They twist and corrupt it to meet their needs. They live to agitate the spirits.',26124),
(18674,'enUS','','The naga torture the spirits of water. They invoke chaos and destruction!',26124),
(18675,'enUS','','The tumultuous nature of the great waterways of Azeroth and Draenor are a direct result of tormented water spirits.',26124),
(18676,'enUS','5...','',26124),
(18677,'enUS','4...','',26124),
(18678,'enUS','3...','',26124),
(18680,'enUS','2...','',26124),
(18681,'enUS','1...','',26124),
(18682,'enUS','','You just going to kneel there all day?',26124),
(18683,'enUS','','Fine, ignore me.  I don\'t care!',26124),
(18684,'enUS','','Lady Vashj must answer for these atrocities. She must be brought to justice!',26124),
(18685,'enUS','','The naga of Coilskar are exceptionally cruel to their prisoners. It is a miracle that I survived inside that watery prison for as long as I did. Earthmother be praised.',26124),
(18686,'enUS','Sighing, %s returns to the campfire.','',26124),
(18687,'enUS','','Watch out!',26124),
(18688,'enUS','','Naga attackers! Defend yourself!',26124),
(18689,'enUS','It\'s too quiet today, Theloria.  The blood elves are up to no good.  I can feel it.','',26124),
(18690,'enUS','%s grunts at her silence.','',26124),
(18691,'enUS','It\'s too quiet tonight, Theloria.  The blood elves are up to no good.  I can feel it.','',26124),
(18692,'enUS','Kill them all!','',26124),
(18693,'enUS','You will never essscape Coilssskarrr...','',26124),
(18694,'enUS','Tear the land asunder, Gul\'dan! Sever the tie!','Tear the land asunder, Gul\'dan! Sever the tie!',26124),
(18695,'enUS','They have abandoned us! Do not forget!','They have abandoned us! Do not forget!',26124),
(18696,'enUS','We will take from the land if it refuses to give!','We will take from the land if it refuses to give!',26124),
(18697,'enUS','Do not do this, Gul\'dan! The elements will never forgive us!','Do not do this, Gul\'dan! The elements will never forgive us!',26124),
(18698,'enUS','Stop! You must stop!','Stop! You must stop!',26124),
(18699,'enUS','Think of our younglings, Gul\'dan! You will destroy us all!','Think of our younglings, Gul\'dan! You will destroy us all!',26124),
(18700,'enUS','You have damned us all... We are lost.','You have damned us all... We are lost.',26124),
(18701,'enUS','Be silent! The shattering is soon to come!','',26124),
(18702,'enUS','Bear witness to the undeniable power of our dark master!','',26124),
(18703,'enUS','With his gift, I shall raze this land and reform it!','',26124),
(18704,'enUS','Watch! See the ground shatter before us! Watch as the energy flows! It will feed our armies...','',26124),
(18705,'enUS','We will never be without power! I have secured our future! Bask in my glory!','',26124),
(18706,'enUS','It... is... done...','',26124),
(18707,'enUS','Free at last!','',26124),
(18708,'enUS','Thank you!','',26124),
(18709,'enUS','Thank you!','',26124),
(18710,'enUS','How can we ever repay you for this?','',26124),
(18711,'enUS','We have waited forever for this day to come!','',26124),
(18712,'enUS','The pain is finally over.','',26124),
(18713,'enUS','I spit on the corpse of these filthy naga.','',26124),
(18714,'enUS','Who dares to interrupt my operation?','',26124),
(18715,'enUS','','%s whispers softly in reverent tones under her breath.',26124),
(18716,'enUS','I\'m looking for a team player...','',26124),
(18717,'enUS','Time to supplement my work force.','',26124),
(18718,'enUS','','Our work in the Living Grove must not be endangered.  Our very lives hinge upon its continued health and growth.',26124),
(18719,'enUS','%s examines the information on the wanted poster.','',26124),
(18720,'enUS','If you haven\'t already, make sure that you offer your assistance to Rina Moonspring.','',26124),
(18721,'enUS','If I heard correctly, you\'re already doing good work for Sylvanaar.$B$BKeep it up and maybe we\'ll be able to keep our home here.','',26124),
(18722,'enUS','The time for vengeance draws near.','',26124),
(18723,'enUS','You will do our bidding, mortal.','',26124),
(18724,'enUS','It will all end soon...','',26124),
(18725,'enUS','I prefer to be hands-on...','',26124),
(18726,'enUS','Let me see what hatchlings you have for sale.','Let me see what hatchlings you have for sale.',26124),
(18727,'enUS','Go and rest, wanderer. Our fires are yours.','Go and rest, wanderer. Our fires are yours.',26124),
(18728,'enUS','You\'re in range! Drop the phase disruptor now!!!','You\'re in range! Drop the phase disruptor now!!!',26124),
(18729,'enUS','I will do as you wish!','',26124),
(18730,'enUS','%s departs from the world and summons shades to do his bidding.','',26124),
(18731,'enUS','Hold them back! Do not falter!','',26124),
(18732,'enUS','Victory or death!','',26124),
(18733,'enUS','Do not give an inch of ground!','',26124),
(18734,'enUS','It is over! Withdraw! We have failed....','',26124),
(18735,'enUS','%s makes a dash for the forge.','',26124),
(18736,'enUS','It is here that Gul\'dan severed the tie between orcs and the elemental spirits. His unquenchable thirst for power could not be satiated with the complete annihilation of the draenei. He had to also destroy Draenor, razing the land and siphoning all of its energies for use in his war.$B$BNow all that is left are remnants of his madness.$B$BLook to the altar, $r - the land is forever haunted...','',26124),
(18737,'enUS','The dirge of Karabor howls to the heavens.','',26124),
(18738,'enUS','The dirge of Karabor returns to the elements.','',26124),
(18739,'enUS','%s begins to cast Blast Nova!','',26124),
(18740,'enUS','Go on, please.','Go on, please.',26124),
(18741,'enUS','I honor my ancestors in the time-honored shamanistic tradition.  We must never forget the sacrifices that they have made so that we can be here.$B$BAnd we, in turn, must make the necessary sacrifices so that our descendants will have a future.$B$BWhat brings you to me, $c?','',26124),
(18742,'enUS','What did you do then?','What did you do then?',26124),
(18743,'enUS','What happened next?','What happened next?',26124),
(18744,'enUS','I see.','I see.',26124),
(18745,'enUS','There was something else I wanted to ask you.','There was something else I wanted to ask you.',26124),
(18746,'enUS','It was not so long ago that we had to wrest control of Thunderlord Stronghold from the nearby ogres.$B$BYou are here to help us maintain our defenses?  I know that Gor\'drek is looking for assistance.','',26124),
(18747,'enUS','%s gets an evil look in his eye as he reaches into his backpack.','',26124),
(18748,'enUS','%s calls out to its father.','%s calls out to its father.',26124),
(18749,'enUS','Stand back, $n. The spirits may lash out.','',26124),
(18750,'enUS','Why have you captured us?','',26124),
(18751,'enUS','What is it that you hope to gain from this?','',26124),
(18752,'enUS','%s bows.','',26124),
(18753,'enUS','We wish to help you, spirit. We seek your wisdom.','',26124),
(18754,'enUS','Wisdom? It was your people that caused the insufferable wrath of Cyrukh.','',26124),
(18755,'enUS','Why should we help you? The world is ruined. Destroyed.','',26124),
(18756,'enUS','%s nods.','',26124),
(18757,'enUS','You are right, spirit. It was my people that did this to you. Allow us to make it right.','',26124),
(18758,'enUS','Please tell us this: Who or what is Cyrukh?','',26124),
(18759,'enUS','Fool! Cyrukh the fire lord! When the tie was severed, Cyrukh awoke. It is the tears of Cyrukh that fill this land with molten rock.','',26124),
(18760,'enUS','The... The fire lord? An elemental lord was unearthed? Of course... Gul\'dan you were a damned fool!','',26124),
(18761,'enUS','He is insane now. Driven mad during the shattering. There is no rest for the elements.','',26124),
(18762,'enUS','There must be a way.','',26124),
(18763,'enUS','Yes, a way. Destroy Cyrukh. Destroy an elemental lord.','',26124),
(18764,'enUS','Do not doubt my comrades and I, spirit. Tell us how to conjure the fire lord. My allies will destroy him.','',26124),
(18765,'enUS','You must utter the words...','',26124),
(18766,'enUS','Yes... Yes... the words. The words of damnation. The words spoken by the dark one. Your master.','',26124),
(18767,'enUS','Yes... Gul\'dan...','',26124),
(18768,'enUS','We will find these words. We will summon your master and we will destroy him.','',26124),
(18769,'enUS','Talk. More talk... Now release us, mortal.','',26124),
(18770,'enUS','There are two mailboxes in the Seat of the Naaru: one by the bank, and another outside the auction house.','There are two mailboxes in the Seat of the Naaru: one by the bank, and another outside the auction house.',26124),
(18771,'enUS','How do you like the war, $n?  Just remember why we\'re here...that makes the fighting, and the dying, a lot easier.','',26124),
(18772,'enUS','Expedition Point is a tough place to be stationed, but it\'s critical to the defense of Honor Hold.  The information gathered here, and the engagements our soldiers make against the Legion and the orcs of Zeth\'Gor, are invaluable to the Alliance\'s Hellfire campaign.','',26124),
(18773,'enUS','I hear that you\'ve already begun to pull your weight around here.$B$BGood.  I was worried that we were going to have to \'convince\' you to help out.','',26124),
(18774,'enUS','A deep, bone chilling voice echoes from the %s...','',26124),
(18775,'enUS','How dare you trifle with my playthings, $n!','',26124),
(18776,'enUS','The orcs in my citadel will drink your blood and devour you!','',26124),
(18777,'enUS','Hahahahah!','',26124),
(18778,'enUS','Now to recover the lost words!','',26124),
(18779,'enUS','The skin stretched taut between the bones is a call to arms against the main defender of the Alliance\'s Sylvanaar and the Living Grove to the west.','',26124),
(18780,'enUS','','Well met, I\'m Azimi! I often make the walk out here to sell the men fresh fruit and water. Are you hungry, or perhaps thirsty?',26124),
(18781,'enUS','%s begins to read the wanted poster.','',26124),
(18782,'enUS','Grunting, %s turns away from the wanted poster, returning to his warm spot by the fire.','',26124),
(18783,'enUS','Bah!  Do I look like I have time for idle chit-chat?$B$BDo I?$B$BBe quick about your business.  There are ogres to be killed!','',26124),
(18784,'enUS','The words painted on the stretched skin here call for something that you don\'t think you\'re quite ready for.$B$BYou should check back later.','',26124),
(18785,'enUS','','Hail, $c. I trust you are here to inquire on the Ahn\'Qiraj war effort. We are going to need a great deal of assistance.$B$BThe war effort is a united effort between the Horde and Alliance to prepare for the impending war against the Silithid and their masters in Ahn\'Qiraj. In Orgrimmar\'s Valley of Spirits, we are collecting a vast number of goods to create war materiel, and these gathering tasks are what we need your help with.$B$BCan I convince you to speak with our commander about helping out?',26124),
(18786,'enUS','','Well met, $c. I hope you are here to inquire on the Ahn\'Qiraj war effort. We are going to need a great deal of assistance.$B$BThe war effort is a united effort between the Alliance and Horde to prepare for the upcoming war against the Silithid and their masters in Ahn\'Qiraj. In the Military Ward of Ironforge, we are collecting all manner of goods to create our war materiel from, and these gathering tasks are what we need your help with.$B$BCan I convince you to speak with our commander about pitching in?',26124),
(18787,'enUS','Heroes of your stature should not waste their talents in Alterac Valley, $n.','Heroes of your stature should not waste their talents in Alterac Valley, $n.',26124),
(18788,'enUS','It\'s good to see a $r, such as yourself, contributing to the well-being of Sylvanaar.  We\'ve done a lot here in a very short time, but the forces that surround us threaten our way of life.$B$BI would hear what you have to say.  Speak your mind, $c.','',26124),
(18789,'enUS','','Are you seeking ammunition or other supplies? I\'ve also some extra food I gathered for Beibei, here, should you require any.',26124),
(18790,'enUS','%s grows in size!','',26124),
(18791,'enUS','','Welcome to the Cenarion Refuge, $n. I\'ve been instructed to offer you basic supplies for purchase, should you need them.',26124),
(18792,'enUS','I\'M ON FIRE!!!','I\'M ON FIRE!!!',26124),
(18793,'enUS','I\'M ON FIRE!!!  AGAIN!!','I\'M ON FIRE!!!  AGAIN!!',26124),
(18794,'enUS','IT BURNS!!','IT BURNS!!',26124),
(18795,'enUS','Not again...','Not again...',26124),
(18796,'enUS','WHY ME!?!','WHY ME!?!',26124),
(18797,'enUS','This is going to hurt in the morning.','This is going to hurt in the morning.',26124),
(18798,'enUS','YEOW!!','YEOW!!',26124),
(18799,'enUS','%s draws energy from the air...','',26124),
(18800,'enUS','It looks like there\'s a skirmish up ahead, $n.  Let us wait til the situation clears up.','',26124),
(18801,'enUS','Are you ready to fight the Stormpike Guard in Alterac Valley, $n?','',26124),
(18802,'enUS','As representatives of the Explorers\' League, Bronwyn and I are here at the Alliance\'s behest to study these mountains.$B$BBut between you and me, after an extended stay in Silithus, we just needed a vacation.  This seems like a nice enough spot.','',26124),
(18803,'enUS','','Borgrim might be correct.  Maybe we do need to take a break.$B$BBut now that we\'re here, I\'m eager to get my hands dirty and study what this land has to offer.',26124),
(18804,'enUS','Mmmmrrrrrgggggglllll!!!!!! [PH]','',26124),
(18805,'enUS','Excellent news, Tooki! We\'re saved!','',26124),
(18806,'enUS','$n, I am pleased to see you. Our dwarven allies require our assistance in Alterac Valley. Will you help them?','',26124),
(18807,'enUS','It\'s time to celebrate, I think...','',26124),
(18808,'enUS','%s places a keg on the ground.','',26124),
(18809,'enUS','Listen up, you lot! Our worries are over! FREE BOOZE FOR EVERYONE!','',26124),
(18810,'enUS','','Borgrim!  Get over here right this instant and help me with this unpacking!',26124),
(18811,'enUS','','I know that you want your vacation, but we still have work to do.',26124),
(18812,'enUS','','Tell you what, hon.  If you help me get all of this unpacked, we can both take a breather.  Deal?',26124),
(18813,'enUS','','Borgrim, this is no time for drinking.  We just got here.  We need to get settled in.',26124),
(18814,'enUS','Uh, yeah... I\'ll be right there, dear.','',26124),
(18815,'enUS','Yup, just as soon as I finish this pint.  You betcha.','',26124),
(18816,'enUS','Right.  We just busted our tails to haul all of this stuff up here, and you want to work more?','',26124),
(18817,'enUS','I thought this was going to be our chance to get away from it all?  Our vacation?','',26124),
(18818,'enUS','Women!','',26124),
(18819,'enUS','','Men!',26124),
(18820,'enUS','The threat be over! $n be savin\' us all!','',26124),
(18821,'enUS','%s calls to its hatchlings.','',26124),
(18822,'enUS','%s feasts on the rotting carcass.','',26124),
(18823,'enUS','The Sons of Lothar have been fighting a war without end.  I\'m amazed we\'ve kept our equipment in as good a shape as it is!','',26124),
(18825,'enUS','','Even now, free-willed undead battle the League of Arathor in Arathi Basin.  Will you aid the Defilers in defeating the humans and their Alliance allies?',26124),
(18826,'enUS','Throm\'ka, $n.  Warsong Gulch is in need of heroes such as you.','',26124),
(18827,'enUS','Our Alliance allies are assisting the Leage of Arathor in their defense of Arathi Basin.  They could use your aid against the undead Defilers, $c.','',26124),
(18828,'enUS','','Our friends in the Alliance gather to fight alongside the Silverwing Sentinels in Warsong Gulch. Will you travel there to help them?',26124),
(18829,'enUS','%s breaks free from the egg and attacks!','',26124),
(18830,'enUS','ACK!  That\'s the worst thing I\'ve ever tasted!  I wouldn\'t let my ram drink that!','',26124),
(18831,'enUS','Watch me go! [PH]','Watch me go! [PH]',26124),
(18832,'enUS','%s senses the egg in your possession and attacks!','',26124),
(18833,'enUS','Greetings, traveler. I am Oronok. Please, sit by my fire and warm yourself.$B$BBeware the ravenous beasts of the shattered shelf below us!','',26124),
(18834,'enUS','What do you have for sale, Oronok?','What do you have for sale, Oronok?',26124),
(18835,'enUS','%s counts his sheep.','',26124),
(18836,'enUS','1, 2, 3, 4, 5, 6, 7, 8, 9, 10... DAMNIT!','1, 2, 3, 4, 5, 6, 7, 8, 9, 10... DAMNIT!',26124),
(18837,'enUS','Must have snuck in through the back when I wasn\'t lookin\'... I\'ll get those ravagers if it\'s the last thing I do.','',26124),
(18838,'enUS','You\'re not getting my sheep, scoundrel!','',26124),
(18839,'enUS','Over my dead body!','',26124),
(18840,'enUS','You\'ll pay for that!','',26124),
(18841,'enUS','','Do not forget, $c, battles still rage in Azeroth. Will you return to help the Horde in Alterac Valley?',26124),
(18842,'enUS','Throm\'ka, $c. Did you know our fight with the Silverwing Sentinels in Warsong Gulch continues still? Your presence would be welcome there...','',26124),
(18843,'enUS','%s attacks from the hillside.','',26124),
(18844,'enUS','I have traveled far in search of a way to ultimately defeat the League of Arathor in Arathi Basin, but that loin-clothed lummox Adam Eternum hounds my every move.\n$b\nStill, if slayers such as you were to return to Azeroth, perhaps we could defeat the Alliance once and for all!','',26124),
(18845,'enUS','Be on your guard! The enemy is on the prowl.','',26124),
(18846,'enUS','There they are!','',26124),
(18847,'enUS','','How are ye? Had yer fill o\' Outland, and ready ta head back ta Alterac Valley and give the Horde what for?',26124),
(18848,'enUS','The Silverwing Sentinels still fight the Horde in Warsong Gulch, $c. What remains to be seen is if you will return there to help them.','',26124),
(18849,'enUS','I came to Outland hoping to discover powerful artifacts to assist the League of Arathor against the Defilers in Arathi Basin... but all I\'ve found is this smashing magical loincloth, a ridiculous gnome sidekick, and an egomaniacal undead stalker who insists I\'ve stolen his grey skull, or some such.\n$b\nIn any case, would you care to join the League in their fight while I continue my search?','',26124),
(18850,'enUS','<One gets the sense that Oric is here only in a sorry attempt at comic relief and shouldn\'t be paid attention to, as it will only encourage him.>','',26124),
(18851,'enUS','Me sorry little birdy!','',26124),
(18852,'enUS','Bird, you hurting me!','',26124),
(18853,'enUS','ARGH!!','',26124),
(18854,'enUS','Why you keep hurting me? Me said me sorry...','',26124),
(18855,'enUS','Me do whatever birdy want. Just stop the hurting.','',26124),
(18856,'enUS','<It\'s a giant, armored, saddle-bearing attack cat. Isn\'t that already silly enough without it talking, too?>','',26124),
(18857,'enUS','Me no can think right anymore!','',26124),
(18858,'enUS','At LAST! I\'m parched!','',26124),
(18859,'enUS','Oh no you don\'t! You\'ll stop practicing when I\'m damn well ready for you to stop practicing! KEEP GOING!','',26124),
(18861,'enUS','Did I win? [PH]','Did I win? [PH]',26124),
(18862,'enUS','Nobody can beat that! [PH]','Nobody can beat that! [PH]',26124),
(18863,'enUS','Don\'t mind if I do. Maybe it\'ll get rid of this headache.','',26124),
(18864,'enUS','','Only a mage can learn portal magic, $c.',26124),
(18865,'enUS','','A mage... you seek to learn the magic of portals, yes?',26124),
(18866,'enUS','This pumpkin sure looks succulent! Nobody will notice if I take a small bite... [PH]','',26124),
(18867,'enUS','','The Royal Apothecary Society of the Undercity is eager to aid our orc allies here, in Outland.  It is an opportunity to strengthen our bonds, and to find new specimens and compounds for study.$B$BCompounds...such as poisons.',26124),
(18868,'enUS','Who\'s stealing my pumpkins?! You won\'t get away with this, you rascal! [PH]','',26124),
(18869,'enUS','The %s is very weak.','',26124),
(18870,'enUS','Ack!  Everyone run... the last asset is materializing!!!','',26124),
(18871,'enUS','Crash, get out of there!!!  Oh no!!!  Not another of my proteges!!!','',26124),
(18872,'enUS','Uh oh.  The wagon looks unstable... it\'s going to blow!!!','',26124),
(18873,'enUS','I\'m ok!  It\'s just a flesh wound...  That was fun!!!','',26124),
(18874,'enUS','Fun?!!  You nearly gave me a heart attack!  Yeah, I guess you\'re right.  That was fun!!!','',26124),
(18875,'enUS','%s sniffs at the air. A tuber is near!','',26124),
(18876,'enUS','%s starts to dig.','',26124),
(18877,'enUS','%s squeals with glee at its discovery.','',26124),
(18878,'enUS','We must work faster.','',26124),
(18879,'enUS','Our work is not yet complete.','',26124),
(18880,'enUS','You should be honored to be doing Lady Vashj\'s bidding.','',26124),
(18881,'enUS','Lady Vashj expects our work to be done soon.','',26124),
(18882,'enUS','Maintain focus.','',26124),
(18883,'enUS','Steady the pumps.','',26124),
(18884,'enUS','Keep those pumps working.','',26124),
(18885,'enUS','We\'re in the home stretch now.','',26124),
(18886,'enUS','Things are proceeding as planned.','',26124),
(18887,'enUS','The pumps are working magnificently.','',26124),
(18888,'enUS','Soon all of Draenor\'s water will be ours.','',26124),
(18889,'enUS','The reservoir fills nicely.','',26124),
(18890,'enUS','Purification seems to be ahead of schedule.','',26124),
(18891,'enUS','We appear to be on target.','',26124),
(18892,'enUS','If we can keep working at this rate, the Lady will be pleased.','',26124),
(18893,'enUS','We will be at capacity soon enough.','',26124),
(18894,'enUS','Keep everyone working efficiently.','',26124),
(18895,'enUS','Don\'t let the levels get too low.','',26124),
(18896,'enUS','Keep ample pressure on the southern pump.','',26124),
(18897,'enUS','Direct the flow from from the western bog.','',26124),
(18898,'enUS','Open the purification valves and continue work.','',26124),
(18899,'enUS','Make sure these Broken are thoroughly cleaned before touching the water.','',26124),
(18900,'enUS','Keep regulating the main valve to ensure steady flow.','',26124),
(18901,'enUS','Don\'t take your eyes off of these filthy Broken. I don\'t trust them.','',26124),
(18902,'enUS','My thoughts exactly.','My thoughts exactly.',26124),
(18903,'enUS','I couldn\'t agree more.','I couldn\'t agree more.',26124),
(18904,'enUS','It\'s as if you were reading my mind.','It\'s as if you were reading my mind.',26124),
(18905,'enUS','You speak the truth.','You speak the truth.',26124),
(18906,'enUS','Yessir.','Yessir.',26124),
(18907,'enUS','Right away, sir.','Right away, sir.',26124),
(18908,'enUS','I shall see to it, sir.','I shall see to it, sir.',26124),
(18909,'enUS','What\'s on your mind, sir?','What\'s on your mind, sir?',26124),
(18910,'enUS','You filthy little beings need to work faster!','',26124),
(18911,'enUS','FASTER!!!!','',26124),
(18912,'enUS','%s attempts to split in two.','',26124),
(18913,'enUS','%s throws a mushroom spore at $n.','',26124),
(18914,'enUS','Whitereach Post is something of an unintended stop for me, to put it mildly. My clients are counting on me to deliver my wares and I\'m starting to wonder if I\'m going to make it in time with all the delays involved.','',26124),
(18915,'enUS','','Hey, don\'t open the cage!  Okay?$B$BThese ogres have got me right where I want them.',26124),
(18916,'enUS','I am told that the dust and heat of Hellfire Peninsula is quite irritating... I would not know, but I will trust my esteemed, and still living, allies.','',26124),
(18917,'enUS','I wish to unlearn elemental leatherworking!','I wish to unlearn elemental leatherworking!',26124),
(18918,'enUS','','Hi.  Thanks for the help.  But please don\'t open the cage.',26124),
(18919,'enUS','','Yes, the ogres are so stupid that they forgot to lock my cage.  But that\'s exactly how I like it, so please don\'t open it again.',26124),
(18920,'enUS','','No.  Don\'t open the cage.  One of them might notice!',26124),
(18921,'enUS','','Please leave the cage door closed.  Thanks.',26124),
(18922,'enUS','','Psst, $r, up here near the entrance.  I\'m in the cage.  Hurry!',26124),
(18923,'enUS','Forgetting elemental leatherworking is not something to do lightly.  If you choose to abandon it you will forget all recipes that require elemental leatherworking as well!','Forgetting elemental leatherworking is not something to do lightly.  If you choose to abandon it you will forget all recipes that require elemental leatherworking as well!',26124),
(18924,'enUS','','You\'ll be purchasing no hawkstrider here until you\'ve proven yourself at least friendly to our people.',26124),
(18925,'enUS','','You\'ll be purchasing no hawkstrider here until you\'ve proven your worth and dedication to our people.$b\n\nDo not return until you are considered exalted among the blood elves. Away with you!',26124),
(18926,'enUS','These orcs must really be eager to stake their claim in Outland! If I told you how much they were paying for my allegiance, you\'d kill me out of jealousy!','',26124),
(18927,'enUS','','No, $r. Your bulk would only crush one of these noble creatures.\n$b\nNow, away with you!',26124),
(18928,'enUS','Do you really want to unlearn your leatherworking specialty and lose all associated recipes?','Do you really want to unlearn your leatherworking specialty and lose all associated recipes?',26124),
(18929,'enUS','%s begins to release his power in desperation!','',26124),
(18930,'enUS','If you\'ve the gold, I can teach you how to ride a hawkstrider.','',26124),
(18931,'enUS','You must be friendly with the blood elves before I will teach you a riding skill, $c.','',26124),
(18932,'enUS','You must be exalted with the blood elves before I will teach you a riding skill, $c.','',26124),
(18933,'enUS','Oh, please.\n$b\nI cannot teach a $r to ride a hawkstrider.','',26124),
(18934,'enUS','Are you ready to hear the story of the Cipher of Damnation, $n?','',26124),
(18935,'enUS','I am ready to hear your story, Oronok.\n','I am ready to hear your story, Oronok.\n',26124),
(18936,'enUS','Very well. The words you seek have a name, $n. They are known as the Cipher of Damnation: The words uttered by Gul\'dan himself to shatter this land. The very spell that severed the last remaining tie the orcs had with the elements of Draenor.$B$B<Oronok nods.>$B$BAye, it is the cipher that you must reconstruct and ultimately the words of the cipher that you must call.','',26124),
(18937,'enUS','How do I find the cipher?','How do I find the cipher?',26124),
(18938,'enUS','The Cipher of Damnation was kept in Gul\'dan\'s private quarters inside Karabor for twenty years. Ah, that\'s right, you have no idea what Karabor is, do you?$B$BThe Black Temple...$B$BAye, now home to Illidan Stormrage.$B$BWhen Illidan took control of the Black Temple, he discovered the cipher. He recognized that the damage to this world had already been done but thought it wise to keep the cipher secure for later use.','',26124),
(18939,'enUS','How do you know all of this?','How do you know all of this?',26124),
(18940,'enUS','When you stand at the Altar of Damnation and see the spirits of the damned, kneeling in prayer, what you do not see is me, standing next to Gul\'dan.$B$B<Oronok nods.>$B$BI told you that I was a lot of things, did I not? One of those \'things\' was a lieutenant of Gul\'dan.$B$BI have done many terrible things in my life. I have slaughtered man, woman, and child alike. Danced in the blood of innocent draenei... yet...$B$B<Oronok chokes on his words.>','',26124),
(18941,'enUS','Yet what? What is it, Oronok?','Yet what? What is it, Oronok?',26124),
(18942,'enUS','I will never forget that day, $r. Never. Even though I had long since abandoned shamanism in favor of shadow magic, I felt the cut. A sense of loss so profound... I could not explain it to you with mere words.$B$BWhen the tie to the elements was severed, all orcs on Draenor changed. If there was ever any doubt in the power of the shadows, it was washed away with the cresting of the molten lava over the shattered earth.\n','',26124),
(18943,'enUS','Continue, please.','Continue, please.',26124),
(18944,'enUS','A wave of sickness rushed through me. After the ritual was over, I ran home to my children. I gathered what belongings I could carry in my arms and left with my boys. We ran to the hills and hid. There really was no other option...$B$BNot a day goes by that I don\'t think of the cut. It has taken 20 years to reconnect with the elements. It has taken 20 years for the elements to even begin to heal.','',26124),
(18945,'enUS','So what of the cipher now? And your boys?','So what of the cipher now? And your boys?',26124),
(18946,'enUS','As I said, the cipher was found by Illidan when he took over the Black Temple. He divided the tome into three parts and charged their care to his minions.$B$BMy boys... My boys are grown now. When I got word of what Illidan had done with the cipher, I sent my boys to recover the pieces.$B$BYou must find my boys, $n. You must find them and recover the Cipher of Damnation.','',26124),
(18947,'enUS','I will find your boys and the cipher, Oronok.','I will find your boys and the cipher, Oronok.',26124),
(18948,'enUS','Don\'t let any of them escape, you dogs!','',26124),
(18949,'enUS','I want these Alliance and Horde pigs dead!','',26124),
(18950,'enUS','We will crush the Bladespire clan.  Then we will have Gruul the Dragonkiller\'s favor!','',26124),
(18951,'enUS','Get up there.  March on Bladespire Hold.  I want to adorn my tower with Gorr\'Dim\'s head!','',26124),
(18952,'enUS','You!  I see you!  One of you, kill them!','',26124),
(18953,'enUS','Gah!  Your meat will taste sweet slow roasting over my fire!!','',26124),
(18954,'enUS','I\'m through asking nicely, fish-man.','',26124),
(18955,'enUS','Where is the Cipher of Damnation? I know a third of it is in this village.','',26124),
(18956,'enUS','Whhaaat... are you sssspeaking of, ssssoft-sskin?','',26124),
(18957,'enUS','The naga do nottt... have thissss... cipherrr...','',26124),
(18958,'enUS','No... Of course not. What was I thinking? Why would you have a third of the Cipher of Damnation?','',26124),
(18959,'enUS','I feel so stupid. Maybe I should unchain you and set you free?','',26124),
(18960,'enUS','DO I HONESTLY LOOK THAT STUPID TO YOU, NAGA? NOW YOU FEEL PAIN!','',26124),
(18961,'enUS','Yesss... Yesss... Ssset me freee...','',26124),
(18962,'enUS','%s spits on the Coilskar naga.','',26124),
(18963,'enUS','GET UP YOU ROTTEN PIECE OF TRASH! GET UP BEFORE I END YOU!','',26124),
(18964,'enUS','%s regains consciousness.','',26124),
(18965,'enUS','Do not beat the Coilsssskaarrr commander anymore, orc! I will tell you! The cipherrr... It is hidden in one of the chests at Coilssskarrr Point... The naga there hold the keysss...','',26124),
(18966,'enUS','I\'m listening...','',26124),
(18967,'enUS','COILSSSKARRR!','',26124),
(18968,'enUS','Welcome to Shattrath City, seat of the Sha\'tar in Outland. You seek guidance?','Welcome to Shattrath City, seat of the Sha\'tar in Outland. You seek guidance?',26124),
(18969,'enUS','Do you really want to unlearn your leatherworking specialty and lose all associated recipes?','Do you really want to unlearn your leatherworking specialty and lose all associated recipes?',26124),
(18970,'enUS','','I came to this place because of my study into the backward culture that used to be the Thunderlord clan.$B$BThey were weak and succumbed to the lure of power that came with being transformed into fel orcs through Mannoroth\'s blood.$B$BI have read all of their texts.  I am particularly interested in the recovery of an artifact, a drum, an arrow and a tablet that were lost when we crushed the Bladespire ogres and pushed them back down into their hold.',26124),
(18971,'enUS','Ar\'tor\'s lifeless body remains suspended in mid-air by demonic magic. They take from him, even in death...','',26124),
(18972,'enUS','Assist me slaves!','',26124),
(18973,'enUS','','I am pleased that you\'ve decided to take up our cause.  As a reward I will infuse a ring with the remnants of the Well of Eternity you brought me.$B$BI offer you four different paths in which to unlock their power.  Choose wisely, $n.  The sands of time flow easily in one direction and not the other.',26124),
(18974,'enUS','Forgetting tribal leatherworking is not something to do lightly.  If you choose to abandon it you will forget all recipes that require tribal leatherworking as well!','Forgetting tribal leatherworking is not something to do lightly.  If you choose to abandon it you will forget all recipes that require tribal leatherworking as well!',26124),
(18975,'enUS','I wish to unlearn tribal leatherworking!','I wish to unlearn tribal leatherworking!',26124),
(18976,'enUS','Forgetting dragonscale leatherworking is not something to do lightly.  If you choose to abandon it you will forget all recipes that require dragonscale leatherworking as well!','Forgetting dragonscale leatherworking is not something to do lightly.  If you choose to abandon it you will forget all recipes that require dragonscale leatherworking as well!',26124),
(18977,'enUS','I wish to unlearn dragonscale leatherworking!','I wish to unlearn dragonscale leatherworking!',26124),
(18978,'enUS','I... died.$B$BWhy am I still here? Is there no great hunting ground that I ascend to?$B$BNo... I must first complete my task. Before I can leave this world, the second part of the Cipher of Damnation must be recovered.','I... died.$B$BWhy am I still here? Is there no great hunting ground that I ascend to?$B$BNo... I must first complete my task. Before I can leave this world, the second part of the Cipher of Damnation must be recovered.',26124),
(18979,'enUS','Hah!  The Thunderspike is mine.  Die!','',26124),
(18980,'enUS','Puny $r cannot lift spear.  Gor lift spear!','',26124),
(18981,'enUS','%s\'s skin partially deflects the spell.','',26124),
(18982,'enUS','I wish to unlearn Swordsmithing!','I wish to unlearn Swordsmithing!',26124),
(18983,'enUS','Forgetting your swordsmithing skill is not something to do lightly.  If you choose to abandon it you will forget all recipes that require swordsmithing to create!','Forgetting your swordsmithing skill is not something to do lightly.  If you choose to abandon it you will forget all recipes that require swordsmithing to create!',26124),
(18984,'enUS','Do you really want to unlearn your blacksmithing specialty and lose all associated recipes?','Do you really want to unlearn your blacksmithing specialty and lose all associated recipes?',26124),
(18985,'enUS','These Infernals are almost ready for the next assualt on The Betrayers Black Citadel!','',26124),
(18986,'enUS','I wish to unlearn Axesmithing!','I wish to unlearn Axesmithing!',26124),
(18987,'enUS','Forgetting your Axesmithing skill is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Axesmithing to create!','Forgetting your Axesmithing skill is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Axesmithing to create!',26124),
(18989,'enUS','Hi, $n.  I\'m here!','',26124),
(18990,'enUS','I wish to unlearn Hammersmithing!','I wish to unlearn Hammersmithing!',26124),
(18991,'enUS','Forgetting your Hammersmithing skill is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Hammersmithing to create!','Forgetting your Hammersmithing skill is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Hammersmithing to create!',26124),
(18992,'enUS','%s strikes out in desperate fury.','',26124),
(18993,'enUS','I... I have died... I was in so much pain... engulfed in darkness... Can you see me, $r?','',26124),
(18994,'enUS','Things are proceeding well!  Soon we grind The Betrayers bones beneath our feet!','',26124),
(18995,'enUS','Prepare to launch the next wave of Infernals!','',26124),
(18996,'enUS','The sky shall fall with the Legions glory!','',26124),
(18997,'enUS','We must be prepared for the next assualt!  The Betrayer will be destroyed!','',26124),
(18998,'enUS','%s rushes to the aid of a nearby doe!','',26124),
(18999,'enUS','We will conquer all, for we are the Burning Legion!  Our enemies shall be consumed in flame and crushed beneath our might!','',26124),
(19001,'enUS','None can stand against the Burning Legion!  This world is ours!','',26124),
(19002,'enUS','You are meaningless!  Only absolute victory for the Legion matters!','',26124),
(19003,'enUS','You have persevered against some of my best advisors... but none can withstand the might of the Blood Hammer. Behold, Lord Sanguinar!','',26124),
(19004,'enUS','Capernian will see to it that your stay here is a short one.','',26124),
(19005,'enUS','Well done, you have proven worthy to test your skills against my master engineer, Telonicus.','',26124),
(19006,'enUS','Let us see how your nerves hold up against the Darkener, Thaladred! ','',26124),
(19007,'enUS','I wish to unlearn Weaponsmithing!','I wish to unlearn Weaponsmithing!',26124),
(19008,'enUS','Forgetting your Weaponsmithing skill is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Weaponsmithing to create!','Forgetting your Weaponsmithing skill is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Weaponsmithing to create!',26124),
(19009,'enUS','You must forget your weapon type specialty before i can help you.   Go to Everlook in Winterspring and seek help there!','You must forget your weapon type specialty before i can help you.   Go to Everlook in Winterspring and seek help there!',26124),
(19010,'enUS','I wish to unlearn Armorsmithing!','I wish to unlearn Armorsmithing!',26124),
(19011,'enUS','Forgetting your Armorsmithing skill is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Armorsmithing to create!','Forgetting your Armorsmithing skill is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Armorsmithing to create!',26124),
(19012,'enUS','There! Destroy him! The Cipher must be recovered!','',26124),
(19013,'enUS','Petulent fool! You will never have the Cipher!','',26124),
(19014,'enUS','The Cipher of Damnation belongs to us now!','',26124),
(19015,'enUS','You will be destroyed!','',26124),
(19016,'enUS','The master will know of this incursion. You will be hunted for all eternity!','',26124),
(19017,'enUS','I require the aid of another spirit hunter, Ar\'tor.','I require the aid of another spirit hunter, Ar\'tor.',26124),
(19018,'enUS','As you wish, $n. The spirit hunter is ready.','',26124),
(19019,'enUS','I\'ve done my time in the trenches, and spent many years training the pups. It\'s good to be home. No matter what has become of it, this is my home.','',26124),
(19020,'enUS','To care for these fearless beasts, who stand between my clanmates and death, is an honor.','',26124),
(19021,'enUS','I wish to stable my pet, Gedrah.','I wish to stable my pet, Gedrah.',26124),
(19022,'enUS','','Thank you, $n.  Now, to perform the test...',26124),
(19023,'enUS','','Ah, I see...',26124),
(19024,'enUS','','Yes, this is unfortunate.',26124),
(19025,'enUS','','$n, I have confirmed that this blood is from the Bonechewer clan of orcs, tainted with demonic power.  I\'m afraid, however, that my current equipment can delve no deeper into this mystery...',26124),
(19026,'enUS','These are holy grounds!  You are not welcome here.','These are holy grounds!  You are not welcome here.',26124),
(19027,'enUS','Friends of the Scryers are not allowed here!','Friends of the Scryers are not allowed here!',26124),
(19028,'enUS','Take your time away from here to reflect upon your actions.','Take your time away from here to reflect upon your actions.',26124),
(19029,'enUS','The ogres, they bury me here up to my neck and then forget to come back.$B$BYah, mon, funny.  Laugh it up.  Disembodied ghost head here.$B$BOf course, if you want to help me out, I might be able to make it worth your while.$B$BBut no, keep laughing.','',26124),
(19030,'enUS','Bird spell not working. Me is free!','',26124),
(19031,'enUS','%s lays an egg.','',26124),
(19032,'enUS','Stupid ogre.  You all need to be taught a lesson.','',26124),
(19033,'enUS','If freedom is what you seek, freedom is what you shall find.','',26124),
(19034,'enUS','You ogres are disposable.  That being said, it is time to take out the garbage.','',26124),
(19035,'enUS','I tire of these ogres. We should wipe them out, all of them.','',26124),
(19036,'enUS','Do any of you other ogres want to join your friend?','',26124),
(19037,'enUS','Me promise be good...','',26124),
(19038,'enUS','Me no want to die.','',26124),
(19039,'enUS','Me sorry...','',26124),
(19040,'enUS','It is dying! The second part of the Cipher of Damnation is ours. I...','',26124),
(19041,'enUS','I am fading... Return to Ar\'tor... Ret... rn... to...','',26124),
(19042,'enUS','Oh no!','Oh no!',26124),
(19043,'enUS','NO!','NO!',26124),
(19044,'enUS','The mana bomb!','The mana bomb!',26124),
(19045,'enUS','They set it off!','They set it off!',26124),
(19046,'enUS','It\'s going to blow!','It\'s going to blow!',26124),
(19047,'enUS','The %s gasps.','The %s gasps.',26124),
(19048,'enUS','The %s is transfixed in fear.','The %s is transfixed in fear.',26124),
(19049,'enUS','Sighing quietly, the %s awaits the inevitable.','Sighing quietly, the %s awaits the inevitable.',26124),
(19050,'enUS','The %s turns to face his impending doom.','The %s turns to face her impending doom.',26124),
(19051,'enUS','Knowing there isn\'t enough time, the %s doesn\'t even try to run.','Knowing there isn\'t enough time, the %s doesn\'t even try to run.',26124),
(19052,'enUS','<Nuainn Stormwing shakes his head.>$B$BWith the Legion on one side and Illidan\'s minions on the other, it\'s going to take everything we\'ve got to defend the stronghold, and defend it we will! Every true Wildhammer would sooner die than surrender our home.','',26124),
(19053,'enUS','As you see, I have many weapons in my arsenal....','',26124),
(19054,'enUS','Stand up straight, grunt! You\'re under the command of the Kor\'kron Guard now.','',26124),
(19055,'enUS','You hear a faint unlocking sound...','',26124),
(19056,'enUS','The %s looks on in disbelief.','The %s looks on in disbelief.',26124),
(19057,'enUS','Attention stance!  Ready Begin.','Attention stance!  Ready Begin.',26124),
(19058,'enUS','Attention!  Now do what I do.','Attention!  Now do what I do.',26124),
(19059,'enUS','I have been waiting for you!','',26124),
(19060,'enUS','Perhaps I underestimated you. It would be unfair to make you fight all four advisors at once, but... fair treatment was never shown to my people. I\'m just returning the favor.','',26124),
(19061,'enUS','','Hah! It\'s about time! No more fearing that each day would be our last...',26124),
(19062,'enUS','','I think everyone deserves a drink. If Thadok\'s sharing...',26124),
(19063,'enUS','','Learning to read is a thirsty business. A toast, eh?',26124),
(19064,'enUS','','Drink up, boys!',26124),
(19065,'enUS','Please excuse me while I begin my tests...','',26124),
(19066,'enUS','Interesting...','',26124),
(19067,'enUS','But what is this?','',26124),
(19068,'enUS','Oh, my!','',26124),
(19069,'enUS','If my blood hadn\'t clotted long ago, it would be boiling with rage right now...','',26124),
(19070,'enUS','This land still bears the scars of the past. I wonder if they will ever heal.','',26124),
(19071,'enUS','Can you cast the spell to help me breathe and move underwater?','Can you cast the spell to help me breathe and move underwater?',26124),
(19072,'enUS','I am too far... The link... is lost...','',26124),
(19073,'enUS','Grek get drink!','',26124),
(19074,'enUS','At last! I\'ll light the lamps.','',26124),
(19075,'enUS','','Rejoice, my friends! $n has saved us from the looming shadow that threatened our very lives!',26124),
(19076,'enUS','We\'re saved? We\'re really saved?! YAHOO!','',26124),
(19077,'enUS','It\'s time to PARTY!','',26124),
(19078,'enUS','%s applauds lightly, smiling.','',26124),
(19079,'enUS','How fortuitous. I believe this calls for some wine.','',26124),
(19080,'enUS','A fine vintage in celebration of our salvation!','',26124),
(19081,'enUS','The smell of these land walkers disgusts me.','The smell of these land walkers disgusts me.',26124),
(19082,'enUS','Our work is almost complete.','Our work is almost complete.',26124),
(19083,'enUS','Our time draws near.','Our time draws near.',26124),
(19084,'enUS','The feralfen that dwell in Zangarmarsh have wicker baskets with clever locks on them.  Surely they would challenge even your skill.','The feralfen that dwell in Zangarmarsh have wicker baskets with clever locks on them.  Surely they would challenge even your skill.',26124),
(19085,'enUS','I\'ll light the lamps.','',26124),
(19086,'enUS','They can take away our land, but they can\'t take away our freedom!  Attack! [PH]','',26124),
(19087,'enUS','The footlockers of Kil\'sorrow Fortress in Nagrand would provide a considerable challenge to even a rogue of your notable skill.','The footlockers of Kil\'sorrow Fortress in Nagrand would provide a considerable challenge to even a rogue of your notable skill.',26124),
(19088,'enUS','AAAAAAAAHHHHHHHHHHHHH!  Get them!  Kill them all! [PH]','AAAAAAAAHHHHHHHHHHHHH!  Get them!  Kill them all! [PH]',26124),
(19089,'enUS','Bring me the skulls of our enemies!  Go now and kill them all! [PH]','',26124),
(19090,'enUS','Zug Zug! [PH]','Zug Zug [PH]',26124),
(19091,'enUS','Tread lightly, $r. Beyond this bridge lies hell.','',26124),
(19092,'enUS','Ahh... not so fast my friend.  The freedom you seek is behind you.','',26124),
(19093,'enUS','I only have one rule. Everyone fights. No one quits.','',26124),
(19094,'enUS','You don\'t do your job, I\'ll shoot you myself.','',26124),
(19095,'enUS','Come on you apes. You want to live forever?','',26124),
(19096,'enUS','Warm it up and give \'em everything you\'ve got.','',26124),
(19097,'enUS','Test.','Test.',26124),
(19098,'enUS','%s cracks the rotten egg open and - to the horror and dismay of all around him - begins to drink from its putrid core.','',26124),
(19099,'enUS','That was life-changing... Excuse me for one minute.','',26124),
(19100,'enUS','%s lets loose the most foul belch ever heard or smelled.','',26124),
(19101,'enUS','Ok then, back to business.','',26124),
(19102,'enUS','It\'s a complete and total barf-o-rama! RUN FOR YOUR LIVES!','',26124),
(19103,'enUS','I knew the prince would be angry, but I... I have not been myself. I had to let them out! The great one speaks to me, you see. Wait--outsiders. Kael\'thas did not send you! Good... I\'ll just tell the prince you released the prisoners!','',26124),
(19104,'enUS','The naaru kept some of the most dangerous beings in existence here in these cells. Let me introduce you to another....','',26124),
(19105,'enUS','%s\'s weapons glow with unnatural fire.','',26124),
(19106,'enUS','Yes, yes... another! Your will is mine!','',26124),
(19107,'enUS','Behold, yet another terrifying creature of incomprehensible power!','',26124),
(19108,'enUS','Where in Bonzo\'s Brass Buttons am I? And who are-- yaaghh, that\'s one mother of a headache!','',26124),
(19109,'enUS','What is this? A lowly gnome? I will do better, oh great one.','',26124),
(19110,'enUS','Anarchy! Bedlam! Oh, you are so wise! Yes, I see it now, of course!','',26124),
(19111,'enUS','One final cell remains. Yes, O great one, right away!','',26124),
(19112,'enUS','It is a small matter to control the mind of the weak... for I bear allegiance to powers untouched by time, unmoved by fate. No force on this world or beyond harbors the strength to bend our knee... not even the mighty Legion! ','',26124),
(19113,'enUS','Bear witness to the agent of your demise!','',26124),
(19114,'enUS','Welcome, O great one. I am your humble servant.','',26124),
(19115,'enUS','%s shatters into shards.','',26124),
(19116,'enUS','\"Lowly\"? I don\'t care who you are, friend: no one refers to the mighty Millhouse Manastorm as \"lowly\"!','',26124),
(19117,'enUS','I just need to get some things ready first. You guys go ahead and get started. I need to summon up some water....','',26124),
(19118,'enUS','Mana gem...','',26124),
(19119,'enUS','Fantastic! Next, some protective spells. Yeah, now we\'re cookin\'!','',26124),
(19120,'enUS','And of course I\'ll need some mana. You guys are gonna love this; just wait....','',26124),
(19121,'enUS','Aaalllriiiight!! Who ordered up an extra large can of whoop-ass?','',26124),
(19122,'enUS','','Default.',26124),
(19123,'enUS','I have the spell. You can analyze it.','I have the spell. You can analyze it.',26124),
(19124,'enUS','Toshley\'s Station is the best!  The solitude and supply of strange, Outland power sources is an ideal setting for extreme experiments!','',26124),
(19125,'enUS','Have you talked to my clone--I mean... my twin?','',26124),
(19126,'enUS','You haven\'t signed your waiver!  Come back after you\'ve signed away all claims of liability toward me or Tally.','',26124),
(19127,'enUS','','Default.',26124),
(19128,'enUS','My work here is complete!','',26124),
(19129,'enUS','My portal creation spells do not appear to work here. The damned naaru constructed this place well.','',26124),
(19130,'enUS','Our time is finally at hand. The naaru and their allies will learn the true meaning of suffering.','',26124),
(19131,'enUS','Our imprisonment was intolerable. The sooner we can leave this accursed place, the better.','',26124),
(19132,'enUS','I cannot believe they made me move my transporter out of town!   Most of the gnomes affected by the accident regained some sort of humanoid form within a few weeks and it should have been an honor to be a participant in such a grand gnomish experiment!\n\nBesides, we needed the eggs!\n','',26124),
(19133,'enUS','Once you have built the device, you simply activate the device to be transported to Toshley\'s Station!    A few people have reported being transformed into chickens, but I am sure they were exaggerating!\n\nIf possible I would try and not use the device on a day when someone else has, but it will probably work out alright even if you do!','',26124),
(19134,'enUS','With the help of my brother Zap in Everlook I have constructed a Dimensional Imploder right here in Area 52.   Who needs a rocket when you have instant transportation via Goblin Engineering!   Are you a skilled enough Goblin Engineer to learn how to build your own Imploder beacon?\n','',26124),
(19135,'enUS','I am happy to talk with another qualified Goblin Engineer!   So many Goblin Engineers learn how to make the Dimension Ripper and then we never hear from them again.  Puzzling.','',26124),
(19136,'enUS','I hope the Ultrasafe Transporter never lets you down!   I just know it won\'t but I would recommend carrying a parachute cloak just in case!','',26124),
(19137,'enUS','Stay frosty boys!','',26124),
(19138,'enUS','Keep an eye out boys.  It\'s too quiet out there.','',26124),
(19139,'enUS','Back up is on the way.  Keep up the fight!','',26124),
(19140,'enUS','Where\'s our back up?  I want them here now!','',26124),
(19141,'enUS','INCOMING!!','',26124),
(19142,'enUS','Hostile\'s on the move!','',26124),
(19143,'enUS','LET\'S ROCK!!','',26124),
(19144,'enUS','','Bring me another plaything to launch!',26124),
(19145,'enUS','','I\'m feeling playful.  Bring me another Infernal!',26124),
(19146,'enUS','Who\'s bad? Who\'s bad? That\'s right: we bad!','',26124),
(19147,'enUS','Thanks for getting me out of there. I owe you one!','',26124),
(19148,'enUS','I should be able to get out here now. Thanks!','',26124),
(19149,'enUS','This place is crazy! I could spend years here investigating all this technology!','',26124),
(19150,'enUS','Doom Lord Kazzak will be pleased. You are to increase the pace of your attacks. Destroy the orcish and dwarven strongholds with all haste.','',26124),
(19151,'enUS','Don\'t worry about that. I\'ve increased production at the Deathforge. You\'ll have all the infernals you need to carry out your orders. Don\'t fail, Jovaan.','',26124),
(19152,'enUS','Yes?','',26124),
(19153,'enUS','Keep up the good work.  Do well and you will be rewarded by the master.','',26124),
(19154,'enUS','Dig! Dig for the glory of the master!','',26124),
(19155,'enUS','Let me know right away if you find something important.','',26124),
(19156,'enUS','My master, we are honored by your presence.  How may I serve thee?','',26124),
(19157,'enUS','Rise, young Voldoun.  Do not worry yourself with pleasantries.  I come at the behest of our master, Prince Kael\'thas.  He bids me to check on the progress of the mana bomb.','',26124),
(19158,'enUS','','Good, $n, you are under the spell\'s influence. I must analyze it quickly, then we can talk.',26124),
(19159,'enUS','All goes exceedingly well, my lord.  Testing of the smaller prototype at the Cenarion Thicket was a complete success.  The second bomb is being ritually fueled in the courtyard below even as we speak.  And, I\'ve sent a courier to Tuurem to bring the rest of the parts to us here.','',26124),
(19160,'enUS','You are satisfied?','',26124),
(19162,'enUS','For the time being, yes.  However, allow my presence to be a motivator.  Prince Kael\'thas was displeased with the failure of the crystal experiment on Fallen Sky Ridge.  This is one of the reasons for why we chose the Cenarion druids as the testing grounds for the bomb.','',26124),
(19163,'enUS','I need not tell you what will happen should the mana bomb down in the courtyard fail to be used on its target soon?  Since moving into the forest, they\'ve become increasingly annoying to our operations: here, at Tuurem and to the south at the Bonechewer Ruins.','',26124),
(19164,'enUS','I can assure you that we will not fail, my master.  I am personally overseeing every aspect of the construction, and I hold the final codes, myself.  Within a day\'s time, I will have the bomb detonated on those nearby pests.','',26124),
(19165,'enUS','See to it that you do, Sharth, or I will personally see to your slow torture and death.','',26124),
(19166,'enUS','%s begins to channel from the nearby distiller...','',26124),
(19167,'enUS','%s reflects the spell back at its caster. ','',26124),
(19168,'enUS','THREE!','',26124),
(19169,'enUS','See? That\'s all it takes. It \'twasn\'t so bad.','',26124),
(19170,'enUS','I believe I may recognize them.  Deal with this quickly, Sharth.  Then take the mana bomb and destroy their town!','',26124),
(19171,'enUS','Halt!','',26124),
(19172,'enUS','What is it, my lord?','',26124),
(19173,'enUS','Zarath you must return to the Black Temple at once! I... I seem to have misplaced Lord Illidan\'s orders. Quickly!','',26124),
(19174,'enUS','My lord, surely you do not expect me to leave you unattended. Lord Illidan would have my head if anything were to happen to you.','',26124),
(19175,'enUS','Zarath, I am perfectly capable of making it up this road to Eclipse Point. If we do not deliver the missive, Lord Illidan will have both of our heads! You are dismissed!','',26124),
(19176,'enUS','As you wish, my lord.','',26124),
(19177,'enUS','Ah, sweet, sweet bloodthistle... Probably left behind by one of those filthy addicts at Eclipse Point.','',26124),
(19178,'enUS','Their loss is most definitely my gain...','',26124),
(19179,'enUS','%s puts the bundle of bloodthistle in his robe.','',26124),
(19180,'enUS','Hide! Hide before they see you! Back up!','',26124),
(19181,'enUS','The time to strike is at hand. Terminate Icarius.','',26124),
(19182,'enUS','Borak, I need another bundle of bloodthistle.','Borak, I need another bundle of bloodthistle.',26124),
(19183,'enUS','You have it. Do not lose it again!','',26124),
(19184,'enUS','Ah, damn it all! Clever trap. Too bad you\'ll never live to tell the tale...','',26124),
(19185,'enUS','Indeed, it is not a request.','',26124),
(19186,'enUS','My lord!','',26124),
(19187,'enUS','Duro will be reinforced!  Ultris was a complete disaster.  I will NOT have that mistake repeated!','',26124),
(19188,'enUS','We\'ve had too many setbacks along the way: Hellfire Citadel, Fallen Sky Ridge, Firewing Point...  Prince Kael\'thas will tolerate no further delays.  I will tolerate nothing other than complete success!','',26124),
(19189,'enUS','Yes, my lord.','',26124),
(19190,'enUS','See to it, Ardonis!','',26124),
(19191,'enUS','I am returning to Tempest Keep.  See to it that I do not have reason to return!','',26124),
(19192,'enUS','Get your house in order!  I will return to finish this conversation later.','',26124),
(19193,'enUS','%s pulls a throwing knife from his boot!','%s pulls a throwing knife from his boot!',26124),
(19194,'enUS',' I think that we should teach a lesson to both the Horde and the Alliance.  One that they will not soon forget!','',26124),
(19195,'enUS','Alas, sometimes one must take matters into one\'s own hands. Balamore shanal!','',26124),
(19197,'enUS','','%s looks down at the discarded necklace.  In her sadness, the lady incants a glamour, which beckons forth Highborne spirits.  The chamber resonates with their ancient song about the Sin\'dorei...',26124),
(19200,'enUS','That could have gone better, $n.  Come, I have something for you.','',26124),
(19201,'enUS','Bank','Bank',26124),
(19202,'enUS','Inn','Inn',26124),
(19203,'enUS','Flight Master','Flight Master',26124),
(19204,'enUS','Mailbox','Mailbox',26124),
(19205,'enUS','What is it that you have for me, ambassador?','What is it that you have for me, ambassador?',26124),
(19206,'enUS','Just a small songbook that I thought you might like to have.  It contains the lyrics to a song known as the Lament of the Highborne; the one that Lady Sylvanas glamoured from the air.','',26124),
(19207,'enUS','%s calls for the aid of a nearby male!','',26124),
(19208,'enUS','Stable Master','Stable Master',26124),
(19209,'enUS','Battlemaster','Battlemaster',26124),
(19210,'enUS','Profession Trainer','Profession Trainer',26124),
(19211,'enUS','There are two banks in Shattrath, both along the rim of the central city hub. One is run by the draenei Aldor, the other by the blood elf Scryers.','There are two banks in Shattrath, both along the rim of the central city hub. One is run by the draenei Aldor, the other by the blood elf Scryers.',26124),
(19212,'enUS','Aldor Bank','Aldor Bank',26124),
(19213,'enUS','Scryers Bank','Scryers Bank',26124),
(19214,'enUS','The Aldor bank is located northwest of the the city\'s center.','The Aldor bank is located northwest of the the city\'s center.',26124),
(19215,'enUS','The Scryers bank is located southeast of the city\'s center.','The Scryers bank is located southeast of the city\'s center.',26124),
(19216,'enUS','Shattrath\'s inns are full of wounded refugees. Still, there is room among the draenei Aldor and blood elf Scryers on Aldor Rise and Scryer\'s Tier.','Shattrath\'s inns are full of wounded refugees. Still, there is room among the draenei Aldor and blood elf Scryers on Aldor Rise and Scryer\'s Tier.',26124),
(19217,'enUS','Aldor Inn','Aldor Inn',26124),
(19218,'enUS','Scryers Inn','Scryers Inn',26124),
(19219,'enUS','The Aldor inn is located high above Shattrath city, on Aldor Rise. The lift to there is northwest of the city center.','The Aldor inn is located high above Shattrath city, on Aldor Rise. The lift to there is northwest of the city center.',26124),
(19220,'enUS','The Scryers inn is located above Shattrath city, on Scryer\'s Tier. The lift to there is southwest of the city center.','The Scryers inn is located above Shattrath city, on Scryer\'s Tier. The lift to there is southwest of the city center.',26124),
(19221,'enUS','Shattrath\'s flight master is Nutral. You will find him east of the city\'s center.','Shattrath\'s flight master is Nutral. You will find him east of the city\'s center.',26124),
(19222,'enUS','You will find mailboxes within or just outside the Aldor and Scryers banks and inns.','You will find mailboxes within or just outside the Aldor and Scryers banks and inns.',26124),
(19223,'enUS','There are stable masters just outside both the draenei and blood elf inns on Aldor Rise and Scryer\'s Tier.','There are stable masters just outside both the draenei and blood elf inns on Aldor Rise and Scryer\'s Tier.',26124),
(19224,'enUS','Aldor Stable','Aldor Stable',26124),
(19225,'enUS','Scryers Stable','Scryers Stable',26124),
(19226,'enUS','Shattrath\'s battlemasters often congregate on the stairwells between the upper and lower city. The Alliance battlemasters gather in one place, the Horde in another, with the arena battlemasters between and across from them.','Shattrath\'s battlemasters often congregate on the stairwells between the upper and lower city. The Alliance battlemasters gather in one place, the Horde in another, with the arena battlemasters between and across from them.',26124),
(19227,'enUS','Alliance Battlemasters','Alliance Battlemasters',26124),
(19228,'enUS','Horde Battlemasters','Horde Battlemasters',26124),
(19229,'enUS','The Alliance battlemasters can usually be found on a stairwell northeast of the city\'s center.','The Alliance battlemasters can usually be found on a stairwell northeast of the city\'s center.',26124),
(19230,'enUS','The Horde battlemasters can usually be found on a stairwell southeast of the city\'s center.','The Horde battlemasters can usually be found on a stairwell southeast of the city\'s center.',26124),
(19231,'enUS','What sort of trainer were you looking for?','What sort of trainer were you looking for?',26124),
(19232,'enUS','Alchemy','Alchemy',26124),
(19233,'enUS','Cooking','Cooking',26124),
(19234,'enUS','Enchanting','Enchanting',26124),
(19235,'enUS','Jewelcrafting','Jewelcrafting',26124),
(19236,'enUS','Leatherworking','Leatherworking',26124),
(19237,'enUS','Skinning','Skinning',26124),
(19238,'enUS','First Aid','First Aid',26124),
(19239,'enUS','Lorokeem, grand master alchemist and Skettis outcast, lives among the other arakkoa in the northwest portion of the lower city.','Lorokeem, grand master alchemist and Skettis outcast, lives among the other arakkoa in the northwest portion of the lower city.',26124),
(19240,'enUS','Jack Trapper can be found cooking in the lower city\'s open market, in the southeast.','Jack Trapper can be found cooking in the lower city\'s open market, in the southeast.',26124),
(19241,'enUS','World\'s End Tavern','World\'s End Tavern',26124),
(19242,'enUS','The World\'s End Tavern may be found in the easternmost portion of the lower city.','The World\'s End Tavern may be found in the easternmost portion of the lower city.',26124),
(19243,'enUS','High Enchanter Bardolan may be found in the Seer\'s Library on Scryer\'s Tier. A grand master of the art, he is surrounded by his students: masters, artisans, experts, and journeymen.','High Enchanter Bardolan may be found in the Seer\'s Library on Scryer\'s Tier. A grand master of the art, he is surrounded by his students: masters, artisans, experts, and journeymen.',26124),
(19244,'enUS','','Sighing, %s kneels down and picks up the amulet.',26124),
(19245,'enUS','Mildred Fletcher may be found within the infirmary in the northeastern section of the lower city.','Mildred Fletcher may be found within the infirmary in the northeastern section of the lower city.',26124),
(19246,'enUS','The draenei grand master jewelcrafter, Hamanar, may be found among his people on the Aldor Rise.','The draenei grand master jewelcrafter, Hamanar, may be found among his people on the Aldor Rise.',26124),
(19247,'enUS','Seymour, the principal skinner in Shattrath and grand master of the trade, may be found in the lower city\'s open marketplace.','Seymour, the principal skinner in Shattrath and grand master of the trade, may be found in the lower city\'s open marketplace.',26124),
(19248,'enUS','The grand master leatherworker Darmari may be found in the lower city\'s open marketplace.','The grand master leatherworker Darmari may be found in the lower city\'s open marketplace.',26124),
(19249,'enUS','Blacksmithing','Blacksmithing',26124),
(19250,'enUS','The armor and weapons crafters Kradu Grimblade and Zula Slagfury may be found working at a great forge in the lower city.','The armor and weapons crafters Kradu Grimblade and Zula Slagfury may be found working at a great forge in the lower city.',26124),
(19251,'enUS','Who dares interrupt the Grand Commander?','',26124),
(19252,'enUS','I need another disguise, Borak. I lost the last one.','I need another disguise, Borak. I lost the last one.',26124),
(19253,'enUS','Do try and be more careful, $n.','',26124),
(19254,'enUS','Look alive, we\'ve got company!','',26124),
(19255,'enUS','Somebody call for an exterminator?','Somebody call for an exterminator?',26124),
(19256,'enUS','I\'m all over it.','I\'m all over it.',26124),
(19257,'enUS','Finally.','Finally.',26124),
(19258,'enUS','Need something destroyed?','Need something destroyed?',26124),
(19259,'enUS','You boys need some help?','You boys need some help?',26124),
(19260,'enUS','I bring word from Lord Illidan.','I bring word from Lord Illidan.',26124),
(19261,'enUS','I\'m listening.','',26124),
(19262,'enUS','The cipher fragment is to be moved. Have it delivered to Zuluhed.','The cipher fragment is to be moved. Have it delivered to Zuluhed.',26124),
(19263,'enUS','','Belore...',26124),
(19264,'enUS','%s\'s hand begins to glow with Arcane energy!','',26124),
(19265,'enUS','Oh? Of course you have papers documenting this request.','',26124),
(19266,'enUS','Perhaps you did not hear me, Ruusk. I am giving you an order from Illidan himself!','Perhaps you did not hear me, Ruusk. I am giving you an order from Illidan himself!',26124),
(19267,'enUS','Listen to me, peon. We have a process for the delivery and safekeeping of the cipher fragment. The envoy delivers the missive, which is sealed by Lord Illidan. No missive, no transfer.','',26124),
(19268,'enUS','Very well. I will return to the Black Temple and notify Lord Illidan of your unwillingness to carry out his wishes. I suggest you make arrangements with your subordinates and let them know that you will be leaving this world soon.','Very well. I will return to the Black Temple and notify Lord Illidan of your unwillingness to carry out his wishes. I suggest you make arrangements with your subordinates and let them know that you will be leaving this world soon.',26124),
(19269,'enUS','<Ruusk swallows hard.>$B$BI... What do you mean?','',26124),
(19270,'enUS','Do I need to go into all the gory details? I think we are both well aware of what Lord Illidan does with those that would oppose his word. Now, I must be going! Farewell, Ruusk! Forever...\n','Do I need to go into all the gory details? I think we are both well aware of what Lord Illidan does with those that would oppose his word. Now, I must be going! Farewell, Ruusk! Forever...\n',26124),
(19271,'enUS','Wait. Where are you going? You needed a transfer, correct? Let\'s just get it done and over with, ok? Zuluhed at Dragonmaw? It will be done. Please let Lord Illidan know that his orders were carried out with the full cooperation of the Eclipsion.$B$BI will dispatch Ruul the Darkener to personally deliver the fragment!$B$BYou heard me right - Ruul...\n','',26124),
(19272,'enUS','Ah, good of you to come around, Ruusk. Thank you and farewell.','Ah, good of you to come around, Ruusk. Thank you and farewell.',26124),
(19273,'enUS','%s moves in behind you with his axe at the ready.','',26124),
(19274,'enUS','Everything is in readiness, warbringer.','',26124),
(19275,'enUS','Warbringer, that will require the use of all the hold\'s infernals. It may leave us vulnerable to a counterattack.','',26124),
(19276,'enUS','I\'m not afraid a\' you! Do you wanna\' fight? Huh, do ya\'? C\'mon! I\'ll fight ya\' with both paws behind my back!','',26124),
(19277,'enUS','Now what should I do with you? I simply can\'t make up my mind.','',26124),
(19278,'enUS','I could really use a heart. Say, can I have yours?','',26124),
(19279,'enUS','It shall be as you say, warbringer. One last question, if I may...','',26124),
(19280,'enUS','What\'s in the crate?','',26124),
(19281,'enUS','Crate? I didn\'t send you a crate, Jovaan. Don\'t you have more important things to worry about? Go see to them!','',26124),
(19282,'enUS','With the help of Engineer Lapforge from Gadgetzan i have built a powerful gnomish transporter here at Toshley\'s Station!  I would be happy to help any gnomish engineer with enough skill to build their own personal transport beacon.','',26124),
(19283,'enUS','Why are you so far from Toshley\'s Station?\n','Why are you so far from Toshley\'s Station?\n',26124),
(19284,'enUS','When you are ready to seek a new specialization, seek Narain Soothfancy.   He can be found in Steamwheedle Port in Tanaris.','When you are ready to seek a new specialization, seek Narain Soothfancy.   He can be found in Steamwheedle Port in Tanaris.',26124),
(19285,'enUS','Control Conjured Water Elemental.','Control Conjured Water Elemental.',26124),
(19286,'enUS','<The water elemental is ready to surge.>','',26124),
(19287,'enUS','<The charger stands proud, eager for battle.>','',26124),
(19288,'enUS','Control Human Charger.','Control Human Charger.',26124),
(19289,'enUS','Forced to land like a dog. No matter. Soon, all of these wonderous beasts will be under the control of the master.','',26124),
(19290,'enUS','Your world is at an end.','',26124),
(19291,'enUS','The skies will darken and all will go quiet. Only then will you know the sweet serenity of death...','',26124),
(19292,'enUS','<The cleric stares at you through the corner of its eye.>','',26124),
(19293,'enUS','Control Human Cleric','Control Human Cleric',26124),
(19294,'enUS','<The conjurer stands fierce, its gaze distant.>','',26124),
(19295,'enUS','Control Human Conjurer','Control Human Conjurer',26124),
(19296,'enUS','<Llane\'s true wisdom and strength burn bright, even in this likeness of the king.>','',26124),
(19297,'enUS','Control King Llane','Control King Llane',26124),
(19298,'enUS','Cyrukh has awoken!','',26124),
(19299,'enUS','You will suffer eternally!','',26124),
(19300,'enUS','Come, mortals, face the lord of fire!','',26124),
(19301,'enUS','Cyrukh comes for you!','',26124),
(19302,'enUS','Those that dare play with fire will be incinerated!','',26124),
(19303,'enUS','A flaming vortex takes shape.','',26124),
(19304,'enUS','You do not fight alone, $n! Together, we will banish this spawn of hellfire!','',26124),
(19305,'enUS','We have come to help battle the dirge of Karabor!','',26124),
(19306,'enUS','We will fight when you are ready, $n.','',26124),
(19307,'enUS','I am ready, Oronok. Let us destroy Cyrukh and free the elements!','I am ready, Oronok. Let us destroy Cyrukh and free the elements!',26124),
(19308,'enUS','Little creature made of flesh, your wish is granted! Death comes for you!','',26124),
(19309,'enUS','We will set the elements free of your grasp by force!','',26124),
(19310,'enUS','We will fight when you are ready.','',26124),
(19311,'enUS','WARNING!  WARNING!  AWAY HOSTILE BEINGS!  DO NOT HEAD UP THE RIDGE TO TOSHLEY\'S STATION!','',26124),
(19312,'enUS','I AM FLUENT IN OVER TWO LANGUAGES: DWARVISH, GNOMISH AND THE VERY COMMON TONGUE OF HUMANS.  BUT I HAVE NO IDEA WHAT YOU ARE SAYING!$B$BSPEAK UP; I CANNOT HEAR YOU OVER THE GRINDING OF MY GEARS!','',26124),
(19313,'enUS','Yeah, yeah... welcome to my station.$B$BSo, what do you think?  Pretty nifty what we\'ve done here, wouldn\'t you say?$B$BMakes me glad to be rid of those stuffy elves at Sylvanaar anyway.$B$BMake yourself useful around here; there\'re plenty of experiments and whatnot to help out with.','',26124),
(19314,'enUS','','Glory to the naaru, $n.  The Light will soon triumph over its enemies.',26124),
(19315,'enUS','Cansis, hold still. I\'m going to try to use this crystal.','',26124),
(19316,'enUS','%s partially phases himself out of reality.','',26124),
(19317,'enUS','Interesting... Let me try something.','',26124),
(19318,'enUS','Cansis. You are a chicken.','',26124),
(19319,'enUS','<The grunt\'s mouth waters, anticipating bloodshed.>','',26124),
(19320,'enUS','Control Orc Grunt','Control Orc Grunt',26124),
(19321,'enUS','%s focuses on $n!','%s focuses on $n!',26124),
(19322,'enUS','<The summoned daemon twitches, fighting against Medivh\'s rules of play.  He wants your soul!>','',26124),
(19323,'enUS','Control Summoned Daemon','Control Summoned Daemon',26124),
(19324,'enUS','All of the nearby arokkoa face east and whistle a long, low note of devotion. [PH]','',26124),
(19325,'enUS','The dwarf appears to have been discovered and slain in the midst of a spy mission. The Deathforge\'s attendants have left the corpse in the open, perhaps as a warning to other would-be interlopers.','',26124),
(19326,'enUS','Reclaim Flanis\'s pack.','Reclaim Flanis\'s pack.',26124),
(19327,'enUS','Keep working!  You must be ready to join the front lines!','',26124),
(19328,'enUS','You are not worthy to be called Burning Legion!  Try harder worm!','',26124),
(19329,'enUS','You are nearly ready!  You will soon be called to destroy our enemies and conquer this land!','',26124),
(19331,'enUS','You are nearly ready!  You will soon be called to destroy our enemies and conquer this land!','',26124),
(19332,'enUS','Could... Could it be over? Is he destroyed?','',26124),
(19333,'enUS','We must speak with the shaman of the Earthen Ring. Come...','',26124),
(19334,'enUS','What say the elements, Torlok? I hear only silence.','',26124),
(19335,'enUS','%s falls unconscious.','',26124),
(19336,'enUS','I hear what you hear, brother. Look behind you...','',26124),
(19337,'enUS','They are redeemed! Then we have won?','',26124),
(19338,'enUS','It is now as it should be, shaman. You have done well.','',26124),
(19339,'enUS','Yes... Well enough for the elements that are here, but the cipher is known to another... The spirits of fire are in turmoil... If this force is not stopped, the world where these mortals came from will cease.','',26124),
(19340,'enUS','Farewell, mortals... The earthmender knows what fire feels...','',26124),
(19341,'enUS','We leave, then, Torlok. I have only one request...','',26124),
(19342,'enUS','The Torn-heart men give their weapons to Earthmender Torlok.','',26124),
(19343,'enUS','Give these to the heroes that made this possible.','',26124),
(19344,'enUS','Things are proceeding as planned.','',26124),
(19345,'enUS','There have been reports of intruders. You are to notify me at once if you see anything unusual!','',26124),
(19346,'enUS','We\'re never going to fire one of these, are we?','We\'re never going to fire one of these, are we?',26124),
(19347,'enUS','Do we even have ammunition for these?','Do we even have ammunition for these?',26124),
(19348,'enUS','What, exactly, are we ever going to fire these at?','What, exactly, are we ever going to fire these at?',26124),
(19349,'enUS','I wonder how far this would launch that white cat...','I wonder how far this would launch that white cat...',26124),
(19350,'enUS','As you say, sir.','As you say, sir.',26124),
(19351,'enUS','Understood, sir.','Understood, sir.',26124),
(19352,'enUS','By your command!','By your command!',26124),
(19353,'enUS','As you wish.','As you wish.',26124),
(19354,'enUS','It shall be so, sir.','It shall be so, sir.',26124),
(19355,'enUS','Consider it done, sir.','Consider it done, sir.',26124),
(19356,'enUS','Be diligent! One word from me and  you\'ll be fed to the warlocks\' demons.','',26124),
(19357,'enUS','You see those bones at your feet? Those are guards who tried to desert their post.','',26124),
(19358,'enUS','Okay, okay! Me dancing!','',26124),
(19359,'enUS','What\'s that? Oh you try and use birdy magic? I crush you!','',26124),
(19360,'enUS','I hurt you for that.','',26124),
(19361,'enUS','<The Arcane Guardian seems to face you, but says nothing.>','',26124),
(19362,'enUS','<The Arcane Guardian gestures towards the easternmost portion of the lower city.>','',26124),
(19363,'enUS','<The Arcane Guardian gestures to a place southeast of the city\'s center.>','',26124),
(19364,'enUS','<The Arcane Guardian gestures across the Tier, towards the inn.>','',26124),
(19365,'enUS','Don\'t get any ideas or I\'ll see that you join them!','',26124),
(19366,'enUS','<Dark magic ripples from the necrolyte.>','',26124),
(19367,'enUS','Control Orc Necrolyte','Control Orc Necrolyte',26124),
(19368,'enUS','<The Arcane Guardian gestures to a place east of the city\'s center.>','',26124),
(19369,'enUS','Look sharp troops! Varedis is known for conducting surprise inspections.','',26124),
(19370,'enUS','<The Arcane Guardian gestures to a place across the Tier, towards the inn and nearby mailbox.>','',26124),
(19371,'enUS','<The Arcane Guardian gestures across the Tier, towards the inn and the stablemaster outside it.>','',26124),
(19372,'enUS','<The Arcane Guardian stands motionless, waiting for you to elaborate on which Battlemasters you mean.>','',26124),
(19373,'enUS','They most often turn deadly, and we\'re understaffed as it is.','',26124),
(19374,'enUS','<The orc wolf\'s frozen, snarling mouth shivers your bones.>','',26124),
(19375,'enUS','Control Orc Wolf','Control Orc Wolf',26124),
(19376,'enUS','<Behind the warlock\'s eyes smolders a deep malevolence.>','',26124),
(19377,'enUS','Control Orc Warlock','Control Orc Warlock',26124),
(19378,'enUS','Chubis Chubisimo!  Get those things fixed... we haven\'t got all day!','',26124),
(19379,'enUS','When I was your age I could have had all of those shredders fixed before breakfast and still had time for all of my other chores.  In the Winterspring snow, no less.  And it\'s uphill both ways there!','',26124),
(19380,'enUS','Chubis, after you\'re done there, make sure that you put another coat of wax on the Wheeler mobile.  I want to take mama out for a spin tonight.','',26124),
(19381,'enUS','How much am I paying you?  You call that working?','',26124),
(19382,'enUS','I just knew that I shouldn\'t have fired Beebo!','',26124),
(19383,'enUS','<Warchief Blackhand towers over the field.>','',26124),
(19384,'enUS','Control Warchief Blackhand','Control Warchief Blackhand',26124),
(19385,'enUS','Okay, if you can manage to get even one of those fixed, I\'ll let you take a ten minute break.  How\'s that sound?  Pretty good, huh?','',26124),
(19386,'enUS','You want me to get into trouble?  I have a lot of work to do here, and old man Wheeler there isn\'t cutting me any slack.','',26124),
(19387,'enUS','Guardians! To me!','',26124),
(19388,'enUS','If you ever do that again, I will break your neck.','',26124),
(19389,'enUS','Fascinating.','',26124),
(19390,'enUS','I\'m a scientist who studies both time and sound, so I\'m not quite certain how I\'m supposed to think, or find the time to get any work done around here, with all of this racket?!$B$BWhy can\'t these fools go blow themselves up somewhere else?$B$BAh well, at least I look good.  Say, $g boy : lovely;, have I seen you around here before?','',26124),
(19391,'enUS','Spirits of fire grant us wisdom!','',26124),
(19392,'enUS','Void energy gathers at the base of the %s!','Void energy gathers at the base of the %s!',26124),
(19393,'enUS','Be ready to advance on the enemy.  We will soon launch an all out assault on the Betrayer.','',26124),
(19394,'enUS','','This cell won\'t hold me for long.  I will have Illidan\'s head one way or another.',26124),
(19395,'enUS','','Release me immediately or face my wrath!',26124),
(19396,'enUS','','I do not know what manner of ruse you\'re attempting, Broken wretch, but I want no part in this!',26124),
(19397,'enUS','You cannot stop us!','',26124),
(19398,'enUS','What $r dare harm those of my flock?','',26124),
(19399,'enUS','The orc\'s corpse has been casually tossed aside so as not to litter the walkway.','',26124),
(19400,'enUS','Search the corpse for Kagrosh\'s pack.','Search the corpse for Kagrosh\'s pack.',26124),
(19401,'enUS','Mortals, here?  What is the meaning of this, pathetic Broken!','',26124),
(19402,'enUS','Have no fear, $r.  Just play along.','',26124),
(19403,'enUS','A mere nuisance, I assure you!  Tell the Master his prisoner will not escape while Akama and his Deathsworn watch over her.','',26124),
(19404,'enUS','You\'d do well not to toy with me, Akama.  Illidan has given me specific orders to keep a close watch on the Warden.  If I find out you\'re hiding anything from me, I will crush you with my own hands!','',26124),
(19405,'enUS','Forgive my harsh methods, but the Betrayer cannot learn of the truth.  My secret must be kept at all costs!','',26124),
(19406,'enUS','To many of my people I am known as a traitor... as Illidan\'s lapdog.  It is best that they continue to think that for now.','',26124),
(19407,'enUS','','If we truly desire the same thing, Akama, then release me!  If Illidan is to die, it shall be by my hand!',26124),
(19408,'enUS','In due time, Maiev.  I\'ve spent years preparing to make my move - I can\'t afford to put my plans in peril by tipping my hand too soon.','',26124),
(19409,'enUS','','Curse you, Akama!  I am not a pawn in your game... my will is my own.  When I unleash my wrath upon Illidan it will have nothing to do with your foolish scheme!',26124),
(19410,'enUS','All rewards for services rendered to be dispensed by Warcaller Sardon Truslice.$B$BPost no bills.','',26124),
(19411,'enUS','All rewards for services rendered to be dispensed by Warcaller Beersnout.$B$BPost no bills.','',26124),
(19412,'enUS','Aye, that\'ll do it! They\'ll come runnin\' once they see the reward we\'ve put up!','',26124),
(19413,'enUS','Wit a reward like dis, how could they refuse, mon?','',26124),
(19414,'enUS','%s detonates in a rage upon seeing its master die.','',26124),
(19415,'enUS','%s goes into a furious rage.','',26124),
(19416,'enUS','Make ready the chambers, another ally will soon join our ranks!','',26124),
(19417,'enUS','Our ally has arrived!  Clear the way to the materialization chamber!','',26124),
(19418,'enUS','Now, proceed to the translocator.  Forge Camp Wrath awaits your arrival!','',26124),
(19419,'enUS','Squawk!  Who dare slay my Worshippers and summon me , High Priest A, forth! [PH]','',26124),
(19420,'enUS','I hunger! Feed me the power of this forge, my children!','',26124),
(19421,'enUS','Fools! Assemble yourselves!','',26124),
(19422,'enUS','We have some uninvited guests.... [PH]','',26124),
(19423,'enUS','','Ooh, this shall be fun! [PH]',26124),
(19424,'enUS','Welcome to the Toshley\'s Station inn.  What can I do for you?','',26124),
(19425,'enUS','','Are you interested in learning the intricacies of Jewelcrafting?',26124),
(19426,'enUS','How do I use Prospecting?','How do I use Prospecting?',26124),
(19427,'enUS','Prospecting is the primary method of finding gems!   You simply use the prospecting ability (which is found in the professions tab of your spellbook) on a stack of five ore to extract the gems from it.   Any type of non-precious ore will do!    \n\nBetter quality ores will provide more valuable gems so you will find higher quality gems in iron ore than in copper ore.','Prospecting is the primary method of finding gems!   You simply use the prospecting ability (which is found in the professions tab of your spellbook) on a stack of five ore to extract the gems from it.   Any type of non-precious ore will do!    \n\nBetter quality ores will provide more valuable gems so you will find higher quality gems in iron ore than in copper ore.',26124),
(19428,'enUS','Where can I continue my Jewelcrafting Training?','Where can I continue my Jewelcrafting Training?',26124),
(19429,'enUS','','If you wish to further your skills, seek Telia\'s shop in Silvermoon.  It is on the south end of the Royal Exchange.',26124),
(19430,'enUS','Testing...','',26124),
(19431,'enUS','What do you wish to know of Jewelcrafting?','',26124),
(19432,'enUS','','Until you have mastered the Apprentice level of Jewelcrafting we shall not speak again.',26124),
(19433,'enUS','','My knowledge of Jewelcrafting I will share with you.',26124),
(19434,'enUS','Creation of Jewelry and Gems is what I live for. Can I share my passion with you?','Creation of Jewelry and Gems is what I live for. Can I share my passion with you?',26124),
(19435,'enUS','','I wish I had more time to teach all who came before me, but alas that is not the way of things. Until you have learned all that Padaar has to teach, I cannot help you.',26124),
(19436,'enUS','','I am blessed to be able to help someone of your skills to learn more of Jewelcrafting. What do you wish to know?',26124),
(19437,'enUS','%s goes into a rage after seeing its master fall in battle!','%s goes into a rage after seeing its master fall in battle!',26124),
(19438,'enUS','%s sends its pet into a bestial rage!','',26124),
(19439,'enUS','%s\'s thick scales begin to crack.','',26124),
(19440,'enUS','%s\'s scales shatter, revealing its soft flesh below.','',26124),
(19441,'enUS','Retesting','',26124),
(19442,'enUS','','I\'m extremely busy, $r.$B$BWe have a terrible problem on our hands that must be dealt with at once!',26124),
(19443,'enUS','Hildagard, I need a new pair of goggles.','Hildagard, I need a new pair of goggles.',26124),
(19444,'enUS','We will never dissipate, mortal... Our fate is tied to Gorefiend...','We will never dissipate, mortal... Our fate is tied to Gorefiend...',26124),
(19445,'enUS','Pray that the chilling embrace of Teron Gorefiend does not reach out for you...','Pray that the chilling embrace of Teron Gorefiend does not reach out for you...',26124),
(19446,'enUS','It is you who have invaded our home. Gorefiend will avenge us!','It is you who have invaded our home. Gorefiend will avenge us!',26124),
(19447,'enUS','Gorefiend will have your head, interloper!','Gorefiend will have your head, interloper!',26124),
(19448,'enUS','We are bound here... eternally. It is the will of Gorefiend.','We are bound here... eternally. It is the will of Gorefiend.',26124),
(19449,'enUS','Test02','',26124),
(19450,'enUS','%s begins to force toxic waste out of its broken tubes.','',26124),
(19451,'enUS','Pour it on \'em boys!','',26124),
(19452,'enUS','Show no mercy!','',26124),
(19453,'enUS','Last push boys!  Let \'em have it!','',26124),
(19454,'enUS','This is the last of them.  Don\'t get sloppy!','',26124),
(19455,'enUS','Nice work soldiers!  This is the last of them!','',26124),
(19456,'enUS','','Enjoy the storm warm bloods!',26124),
(19457,'enUS','Mount up!  We are outta here!','Mount up!  We are outta here!',26124),
(19458,'enUS','Cavalry, let\'s roll out!','Cavalry, let\'s roll out!',26124),
(19459,'enUS','Illidan\'s grasp on this land is slipping.  Can you feel it, $n?','',26124),
(19460,'enUS','','When you run with Razak\'s Roughriders, you learn a thing or two about following orders.$B$BThe first thing is that you fight until you die.  The second thing is, see the first thing.',26124),
(19461,'enUS','%s cries out for the blessing of the flight.','%s cries out for the blessing of the flight.',26124),
(19462,'enUS','%s is reborn anew!','%s is reborn anew!',26124),
(19463,'enUS','Need your blade sharpened, or perhaps a new weapon? Better safe than sorry...','',26124),
(19464,'enUS','Let me see your wares.','Let me see your wares.',26124),
(19465,'enUS','If it\'s a hammer you\'re looking for,  you\'ve come to the right place.','',26124),
(19466,'enUS','I wish to browse your wares.','I wish to browse your wares.',26124),
(19467,'enUS','%s rushes forward, carefully watching its enemy.','%s rushes forward, carefully watching its enemy.',26124),
(19468,'enUS','Muahahahaha!  You fool!  You\'ve released me from my banishment in the interstices between space and time!','',26124),
(19469,'enUS','All of Draenor shall quake beneath my feet!  I will destroy this world and reshape it in my image!','',26124),
(19470,'enUS','Where shall I begin?  I cannot bother myself with a worm such as yourself.  There is a world to be conquered!','',26124),
(19471,'enUS','No doubt the fools that banished me are long dead.  I shall take wing and survey my new demesne.  Pray to whatever gods you hold dear that we do not meet again.','',26124),
(19472,'enUS','NOOOOooooooo......','',26124),
(19473,'enUS','%s makes a break for the nearest rune circle.','%s makes a break for the nearest rune circle.',26124),
(19474,'enUS','$G Son : Young lady;, I\'m not going to lie to you; things aren\'t pretty around here.  We\'re under constant assault by the bugs and our very way of life, our freedom, is at stake!$B$BAre you going to be a responsible citizen and help out?','',26124),
(19475,'enUS','From the darkest night shall rise again the raven, shall take flight in the shadows, shall reveal the nature of its kind. Prepare yourself for its coming, for the faithful shall be elevated to take flight with the raven, the rest be forgotten to walk upon the ground, clipped wings and shame.','',26124),
(19476,'enUS','Steel your minds and guard your thoughts. The dark wings will cloud and consume the minds of the weak, a flock of thralls whose feet may never leave the ground.','',26124),
(19477,'enUS','The old blood will flow once again with the coming of the raven, the return of the darkness in the skies. Scarlet night, and the rise of the old.','',26124),
(19478,'enUS','The raven was struck down once for flying too high, unready. The eons have prepared the Dark Watcher for its ascent, to draw the dark cloak across the horizon.','',26124),
(19479,'enUS','This is a flavor whisper.','',26124),
(19480,'enUS','Teron Gorefiend? Yes... I know of him.','',26124),
(19481,'enUS','All systems on-line.  Prepare yourself, we leave shortly.','',26124),
(19482,'enUS','The Skettis Windwalker throws a bundle of fragrant herbs into the fire. [PH]','',26124),
(19483,'enUS','Splendid! Marvelous! An excellent performance!','',26124),
(19484,'enUS','Proceed.','',26124),
(19485,'enUS','Wut dat?','',26124),
(19486,'enUS','Perty light!','',26124),
(19487,'enUS','Me not see dat before.','',26124),
(19488,'enUS','Me catch firefly!','',26124),
(19489,'enUS','Whoa!','',26124),
(19490,'enUS','Look out... ball of light!','',26124),
(19491,'enUS','Duck!','',26124),
(19492,'enUS','Me want light!','',26124),
(19493,'enUS','','When I was young I trained hard to become an anchorite in the priesthood.  Female exarchs were practically unheard of.$B$BNowadays gender matters little - it is courage and conviction that make all the difference.',26124),
(19494,'enUS','Your body is mine! Our fates are forever intertwined.','',26124),
(19495,'enUS','','Bring me another toy!',26124),
(19496,'enUS','','Another one!  Bring me another one!',26124),
(19497,'enUS','You no cast spells!','',26124),
(19498,'enUS','If you are ready and wish to quickly return to the normal time stream, I can transport you.','',26124),
(19499,'enUS','Take me back to my time.','Take me back to my time.',26124),
(19500,'enUS','Shaping the flow of time is a very difficult and quite delicate task, but you have performed admirably today.','',26124),
(19501,'enUS','No... no! What have you done? I am the master! Do you hear me? I am... aaggh! Can\'t... contain him.','',26124),
(19502,'enUS','At last I am liberated. It has been too long since I have tasted true freedom!','',26124),
(19503,'enUS','Waste no time, fool! Use our power to kill those that stand in our way! Destroy Karsius before you are subdued!','',26124),
(19504,'enUS','Your pathetic attempt to escape will be short lived, Gorefiend. Let the $g boy:girl; go and submit! Even with your armor and weapons, you cannot defeat the ancients!','',26124),
(19505,'enUS','Let this be a lesson to those that would do evil to our lands!','',26124),
(19506,'enUS','What ... have you done...','',26124),
(19507,'enUS','Well done, pawn. You are free to go as I no longer have a use for your body.','',26124),
(19508,'enUS','We will meet again... Someday.','',26124),
(19509,'enUS','Death incarnate has been released upon the world once more! Teron Gorefiend has returned...','',26124),
(19510,'enUS','Stupid, squishy $r. That weapon mine now! Give!','',26124),
(19511,'enUS','Halt!','Halt!',26124),
(19512,'enUS','Surrender immediately!','Surrender immediately!',26124),
(19513,'enUS','This area is restricted!','This area is restricted!',26124),
(19514,'enUS','Stop them!','Stop them!',26124),
(19515,'enUS','I was just... following orders.','I was just... following orders.',26124),
(19516,'enUS','Why...?','Why...?',26124),
(19517,'enUS','Blackmoore will have... your head!','Blackmoore will have... your head!',26124),
(19518,'enUS','Cursed scum!','Cursed scum!',26124),
(19519,'enUS','Hm, hungry.','',26124),
(19520,'enUS','Don\'t feel... so good.','',26124),
(19521,'enUS','When can we eat again?','',26124),
(19522,'enUS','So-ngh-thirsty.','',26124),
(19523,'enUS','What do you think you\'re doing?','What do you think you\'re doing?',26124),
(19524,'enUS','Stop right there!','Stop right there!',26124),
(19525,'enUS','I\'ll...','I\'ll...',26124),
(19526,'enUS','Agh!','Agh!',26124),
(19527,'enUS','Oh no, you don\'t....','Oh no, you don\'t....',26124),
(19528,'enUS','Nice try.','Nice try.',26124),
(19529,'enUS','Give up or die!','Give up or die!',26124),
(19530,'enUS','You won\'t get far....','You won\'t get far....',26124),
(19531,'enUS','You think you\'ve won?','You think you\'ve won?',26124),
(19532,'enUS','You have achieved nothing!','You have achieved nothing!',26124),
(19533,'enUS','You are too late!','You are too late!',26124),
(19534,'enUS','Do not think you can win!','Do not think you can win!',26124),
(19535,'enUS','You don\'t stand a chance!','You don\'t stand a chance!',26124),
(19536,'enUS','We have all the time in the world....','We have all the time in the world....',26124),
(19537,'enUS','All that you know... will be undone.','All that you know... will be undone.',26124),
(19538,'enUS','You cannot escape us!','You cannot escape us!',26124),
(19539,'enUS','Of course, my mind isn\'t what it used to be. The only spells I\'m familiar with now are dizzy spells.','',26124),
(19540,'enUS','You know, if I was a bit younger, I\'d show you how a real man courts a young lady.','',26124),
(19542,'enUS','Have all the ingredients. Just can\'t remember the order they go in....','',26124),
(19543,'enUS','Now what was the name of that book? Oh yes, it was-- No, no, that wasn\'t it....','',26124),
(19544,'enUS','What good are words of power if you can\'t remember them?','',26124),
(19545,'enUS','Antonidas has some interesting notions about these orcs and their \"lethargy\".','',26124),
(19546,'enUS','That Kel\'Thuzad is nothing but a troublemaker. If he keeps it up he\'ll get himself in hot water again.','',26124),
(19547,'enUS','','You must have been very brave.',26124),
(19548,'enUS','','That\'s not true. You\'re still a great wizard.',26124),
(19549,'enUS','','That\'s not true. You\'re still a great wizard.',26124),
(19550,'enUS','','Do you have a spell that can take me as far away from here as possible?',26124),
(19551,'enUS','Mommy, mommy!','Mommy, mommy!',26124),
(19552,'enUS','Heeeelllpp!!','Heeeelllpp!!',26124),
(19553,'enUS','Tag! You\'re it!','',26124),
(19554,'enUS','I wanna play soldier!','',26124),
(19555,'enUS','','Can I play?',26124),
(19556,'enUS','','Ew, boys are gross!',26124),
(19557,'enUS','If I don\'t have it, you don\'t need it!','',26124),
(19558,'enUS','Guaranteed to satisfy, or your money back!','',26124),
(19559,'enUS','Don\'t take it from me what a bargain this is. Come see for yourself!','',26124),
(19560,'enUS','I hear that Blackmoore has been acting strange.','I hear that Blackmoore has been acting strange.',26124),
(19561,'enUS','I\'m thinking of a vacation. I hear Hearthglen is nice.','I\'m thinking of a vacation. I hear Hearthglen is nice.',26124),
(19562,'enUS','Quitting time can\'t come too soon.','Quitting time can\'t come too soon.',26124),
(19563,'enUS','Here to help with the disturbances?','',26124),
(19564,'enUS','Zorus, I need a new pair of goggles.','Zorus, I need a new pair of goggles.',26124),
(19565,'enUS','Tell me about the demon hunter training grounds at the Ruins of Karabor.','Tell me about the demon hunter training grounds at the Ruins of Karabor.',26124),
(19566,'enUS','As a reward for his years of service, Illidan allowed Kael\'thas to send him five warriors to train under him.  It would be the first time blood elves would be allowed to train as demon hunters.$B$BThe training was brutal.  Illidan put Kael\'s warriors through trials that would defeat most fully capable demon hunters.$B$BThree of Kael\'s elves died in training - another went mad.$B$BOne succeeded.','',26124),
(19567,'enUS','Varedis was his name.  To Illidan\'s surprise, not only did he succeed in the excruciating rites of passage that are part of the training; Varedis was already displaying better command over his powers than many veteran demon hunters.$B$BIllidan sensed the potential in Varedis and assigned three master demon hunters to train him further in their ways.','',26124),
(19568,'enUS','Within a year of training under Illidan\'s best three demon hunters, Varedis had surpassed them.$B$BNo longer content with the training they had to offer, Varedis infiltrated the Shadow Council where he learned of a powerful relic known as the Book of Fel Names.  He secretly read from this book, committing each passage to memory.','',26124),
(19569,'enUS','Knowledge of a demon\'s true name is rumored to give a certain amount of power over that demon.$B$BThe Book of Fel names is said to contain the true name of every demon ever to have existed.  By memorizing the passages in the book, Varedis had found a source of power to rival Illidan\'s own drinking from the Skull of Gul\'dan.$B$BAt Illidan\'s request, Varedis now runs the training grounds at the Ruins of Karabor - along with the three masters that mentored Varedis.','',26124),
(19570,'enUS','Be gone, mortal! Your kind is unwelcome here...','',26124),
(19571,'enUS','It is not surprising that a blood elf\'s potential for power as a demon hunter is so high.  After all, the sin\'dorei do not have the natural aversion to demonic magic that night elves do.$B$BHowever, I do not expect many to succeed.  Most of them, Varedis included, pursue power for its own sake.  That power will consume them, for they are not driven by the pure fire that burns inside a true demon hunter\'s heart.','',26124),
(19572,'enUS','That\'s quite a story.','That\'s quite a story.',26124),
(19573,'enUS','There was something else I wanted to ask you, Altruis.','There was something else I wanted to ask you, Altruis.',26124),
(19574,'enUS','Go on, please.','Go on, please.',26124),
(19575,'enUS','I\'m listening.','I\'m listening.',26124),
(19576,'enUS','Interesting.','Interesting.',26124),
(19577,'enUS','Illidan\'s lapdogs!  You will pay for my imprisonment with your lives!','',26124),
(19578,'enUS','','You dare fight me?  I was trained by Illidan himself!',26124),
(19579,'enUS','You will witness true power!','',26124),
(19580,'enUS','You will soon pray for a switft death!','',26124),
(19581,'enUS','This doesn\'t look right...','',26124),
(19582,'enUS','The metal\'s magical properties are gone! It can still be worked, but not by conventional smithing methods.','',26124),
(19583,'enUS','You dare intrude in my sanctum?  I promise you a world of pain!','',26124),
(19584,'enUS','No, this isn\'t right. What\'s happened here?','',26124),
(19585,'enUS','The metal has lost its magic. I could make a weapon from it, but it would be no different from a mundane blade.','',26124),
(19586,'enUS','You can take a man away from the Sons of Lothar, but you can\'t take the Sons out of him.$B$B<The smith shrugs.>$B$BIt\'s hard to explain, but I don\'t feel like I\'m meant to be at Honor Hold right now, is all.$B$BPerhaps I\'m meant to be part of something larger.','',26124),
(19587,'enUS','','I will tear you to pieces, demon!',26124),
(19588,'enUS','Mumman has set up her humble shop near the main entrance of the city, just past the inn. A fine cook, that one.','Mumman has set up her humble shop near the main entrance of the city, just past the inn. A fine cook, that one.',26124),
(19589,'enUS','Mana Loom','Mana Loom',26124),
(19590,'enUS','Keelen\'s tailoring shop in the northwest corner of the Bazaar has a loom like you describe.','Keelen\'s tailoring shop in the northwest corner of the Bazaar has a loom like you describe.',26124),
(19591,'enUS','You can find our mana loom in the merchant\'s bazaar within the Lower City.','You can find our mana loom in the merchant\'s bazaar within the Lower City.',26124),
(19592,'enUS','Work harder!','',26124),
(19593,'enUS','Mine rock!  Crack stone!  Faster!  Faster!','',26124),
(19594,'enUS','','',26124),
(19595,'enUS','Be gone, trifling elf.  I am in control now!','',26124),
(19596,'enUS','Finally, my banishment ends!','',26124),
(19597,'enUS','We all have our demons....','',26124),
(19598,'enUS','','Feel my wrath, $r scum!  You will not get away with this!',26124),
(19599,'enUS','Who disturbs my slumber?  That spear... I still carry the scar!','',26124),
(19600,'enUS','<The Arcane Guardian silently waits for you to further elaborate.>','',26124),
(19602,'enUS','%s reads several pages of the Lexicon Demonica before beginning his work.','',26124),
(19603,'enUS','Into this blade, I imbue the power to strike down the strongest of demons! No demon shall stand before the wielder of this weapon!','',26124),
(19604,'enUS','Anti-demon magics flare to life and imbue the weapon.','',26124),
(19605,'enUS','Thank you, $n, for saving us from a fate worse than death.  You have our eternal gratitude.','Thank you, $n, for saving us from a fate worse than death.  You have our eternal gratitude.',26124),
(19606,'enUS','Aaghh, the poison...','',26124),
(19607,'enUS','Better, much better.','',26124),
(19608,'enUS','What is it that you want from me, shaman?','',26124),
(19609,'enUS','Do you not have eyes? Did you not see the demons on our very doorstep? I do not have the soldiers to spare!','',26124),
(19610,'enUS','Pray to your gods, shaman. Perhaps they will come to your aid. The Horde, however, cannot...','',26124),
(19611,'enUS','Look, if I\'ve told ya once, I\'ve told ya a hundred times: WE CANNOT HELP YOU!','',26124),
(19612,'enUS','I don\'t get it! Are ya blind? Can ya not see the demons bangin\' on our door? Who am I gonna send out to talk to your shaman friends? Point \'em out!','',26124),
(19613,'enUS','I really wish I could help ya, but I can\'t! Kurdran\'s given me direct orders. Now move along!','',26124),
(19614,'enUS','This book would give me unlimited power over my enemies... I would become... unstoppable!','',26124),
(19615,'enUS','No... you must take this from me, $n!  I feel its dark power swaying my will already!  Use it to destroy Varedis.','',26124),
(19616,'enUS','\"It is too soon for you to control me, for you have recently left the game.\"','',26124),
(19617,'enUS','To pass beyond my Hall, you must defeat me in a game of skill!  Control your king when you are ready to begin...','',26124),
(19618,'enUS','Chief, I\'ve somehow misplaced my X-52 Rocket Helmet!!!!','Chief, I\'ve somehow misplaced my X-52 Rocket Helmet!!!!',26124),
(19619,'enUS','Well, alright then, there you go, First Officer $n.  Just try to be more careful with your helmet in the future.$B$BThose things don\'t grow on trees, you know!','',26124),
(19620,'enUS','Whatever advice I can give to aid in your fight against the ogres, you shall have it!','',26124),
(19621,'enUS','%s begins intensely dodging incoming attacks!','%s begins intensely dodging incoming attacks!',26124),
(19622,'enUS','Facing $n.','',26124),
(19623,'enUS','$n, you above all have earned the right for the Horde to inhabit our ancestral home.','',26124),
(19624,'enUS','By recovering the artifacts of our clan, by taking up the fight against our ancient enemy, the Bladespire ogres, and their gronn masters, by returning the Thunderspike to my hand, you have secured the blessing of the Thunderlord clan.','',26124),
(19625,'enUS','I have been watching you and Rexxar.  You must aid him to secure the future of the Horde here in these mountains.  Only when you have forced the ogres into submission and slain their master, Gruul the Dragonkiller, will your people be safe.','',26124),
(19626,'enUS','You honor our memory.','',26124),
(19627,'enUS','The details of the posting call for the execution of an enormous wolf.  She apparently keeps her den to the south of the Jagged Ridge, near the Horde stronghold.','',26124),
(19628,'enUS','What you read is something that you don\'t think you\'re quite ready for.$B$BYou should check back later.','',26124),
(19629,'enUS','Excellent!  You are almost ready my pet.','Excellent!  You are almost ready my pet.',26124),
(19630,'enUS','You are coming along nicely.','You are coming along nicely.',26124),
(19631,'enUS','Good!  Soon you will be ready for a rider.','Good!  Soon you will be ready for a rider.',26124),
(19632,'enUS','Stupid drake!  When will you learn to follow directions?','Stupid drake!  When will you learn to follow directions?',26124),
(19633,'enUS','If you keep failing these simple tasks, you will be put down.','If you keep failing these simple tasks, you will be put down.',26124),
(19634,'enUS','Your failures are tiring me.  If you cannot do as instructed we will have no use for you.','Your failures are tiring me.  If you cannot do as instructed we will have no use for you.',26124),
(19635,'enUS','Now, execute the instructions!','Now, execute the instructions!',26124),
(19636,'enUS','Prepare to die!','',26124),
(19637,'enUS','<The Arcane Guardian gestures towards a place below the Tier, a stairwell northeast of the city\'s center.>','',26124),
(19638,'enUS','<The Arcane Guardian gestures to a place below the Tier, a stairwell southeast of the city\'s center.>','',26124),
(19640,'enUS','<The Arcane Guardian gestures to the northwest portion of the lower city, where Shattrath\'s arakkoa dwell.>','',26124),
(19641,'enUS','<The Arcane Guardian gestures down towards the lower city, where a great forge may be found.>','',26124),
(19642,'enUS','<The Arcane Guardian gestures down towards the lower city\'s open market, in the southeast.>','',26124),
(19643,'enUS','Go on, kill them! I\'ll be the better for it!','',26124),
(19644,'enUS','More knowledge, more power!','',26124),
(19645,'enUS','I am more powerful than ever!','',26124),
(19646,'enUS','<The Arcane Guardian gestures towards the Seer\'s Library.>','',26124),
(19647,'enUS','<The Arcane Guardian gestures towards the northeastern section of the lower city.>','',26124),
(19648,'enUS','<The Arcane Guardian gestures towards Aldor Rise.>','',26124),
(19650,'enUS','<The Arcane Guardian gestures towards the lower city\'s open marketplace.>','',26124),
(19651,'enUS','Welcome to Aldor Rise. You seek guidance?','Welcome to Aldor Rise. You seek guidance?',26124),
(19652,'enUS','You will find a caregiver center in the southern portion of Aldor Rise.','You will find a caregiver center in the southern portion of Aldor Rise.',26124),
(19653,'enUS','You will find a mailbox near the caregiver center.','You will find a mailbox near the caregiver center.',26124),
(19654,'enUS','You will find the Stable Master near the caregiver center.','You will find the Stable Master near the caregiver center.',26124),
(19655,'enUS','You will find the enchanting trainer, Zurii, in southern Aldor Rise.','You will find the enchanting trainer, Zurii, in southern Aldor Rise.',26124),
(19656,'enUS','A grand master jewelcrafter, Hamanar, may be found in northern Aldor Rise.','A grand master jewelcrafter, Hamanar, may be found in northern Aldor Rise.',26124),
(19657,'enUS','Greetings, $c - I\'m a Commendation Officer acting on behalf of Silvermoon City.  It is my duty to assist adventurers who have received Horde Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Silvermoon City for your duty and service.','Greetings, $c - I\'m a Commendation Officer acting on behalf of Silvermoon City.  It is my duty to assist adventurers who have received Horde Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from Silvermoon City for your duty and service.\n',26124),
(19658,'enUS','Greetings, $c - I\'m a Commendation Officer acting on behalf of the Exodar.  It is my duty to assist adventurers who have received Alliance Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from the Exodar for your duty and service.\n','Greetings, $c - I\'m a Commendation Officer acting on behalf of the Exodar.  It is my duty to assist adventurers who have received Alliance Commendation Signets.$B$BI accept signets in different quantities, but the most beneficial exchange for you is to hand in a set of ten at once.  I will enter your deeds into our records when you hand in your signets.  As a result, you will earn recognition from the Exodar for your duty and service.',26124),
(19659,'enUS','Netherock?!  That thing\'ll squish you flat with one step of its massive foot!  No thanks!','Netherock?!  That thing\'ll squish you flat with one step of its massive foot!  No thanks!',26124),
(19660,'enUS','Last time someone went out to try to collect the bounty on Netherock, all we got back was a compressed layer of foolhardy adventurer!','Last time someone went out to try to collect the bounty on Netherock, all we got back was a compressed layer of foolhardy adventurer!',26124),
(19661,'enUS','The Blade\'s Edge Mountains are a place of great opportunity.  How unfortunate that some deem themselves above all others on matters that pertain to taking advantage of such opportunities.$B$BWho do the Cenarion Expedition think they are to tell us what we can and cannot do here?','',26124),
(19662,'enUS','Overseer, I am here to negotiate on behalf of the Cenarion Expedition.','Overseer, I am here to negotiate on behalf of the Cenarion Expedition.',26124),
(19663,'enUS','Negotiations?  NEGOTIATIONS!$B$BAllow me to make our stance perfectly clear.  We are a free people, able to do whatever we want and come and go as we please.  The Cenarion Expedition does not own this mountain range.$B$BThere will be no negotiations!  Now, go back to the druids and tell them that we will continue to do as we please.','',26124),
(19664,'enUS','We\'ve come to the Ruuan Weald to see if we can reestablish the balance of nature to these mountains.$B$BThe interference of the arakkoa and the wyrmcult is making this a difficult task, however.$B$BLuckily, there are those like you and Samia that are willing to lend us a hand.','',26124),
(19665,'enUS','Haha, you\'re back?  You don\'t seriously expect me to change my mind do you?$B$BGet lost.','',26124),
(19666,'enUS','I\'ve rigged a few control consoles down the slope. Get to one quickly and take control of the fel reaver! You\'ll only have a limited amount of time.','',26124),
(19667,'enUS','I\'m ready for my test flight!','I\'m ready for my test flight!',26124),
(19668,'enUS','Send me to Razaan\'s Landing!','Send me to Razaan\'s Landing!',26124),
(19669,'enUS','Take me to Ruuan.','Take me to Ruuan.',26124),
(19670,'enUS','Take me to Raven\'s Wood.','Take me to Raven\'s Wood.',26124),
(19671,'enUS','Take me to Singing Ridge.','Take me to Singing Ridge.',26124),
(19672,'enUS','GET THOSE GUNS ONLINE!!','',26124),
(19673,'enUS','FIRE UP THE DEF GUNS!','',26124),
(19674,'enUS','We can handle it from here.  Roughriders you are dismissed.','',26124),
(19675,'enUS','Speak quickly, $n. We haven\'t much time!','Speak quickly, $n. We haven\'t much time!',26124),
(19676,'enUS','Collecting','Collecting',26124),
(19677,'enUS','I detect a charge in your paranarbulatric region!  You must have used the Zephyrium Capacitorium lately -- you can\'t use it again until the charge wears off...','',26124),
(19678,'enUS','','I am here at the behest of my master, Baron Sablemane, to help the Cenarion Expedition with its wyrmcult problems.$B$BI\'m something of an expert on these things.',26124),
(19679,'enUS','','I did not wish to lower myself by engaging your kind, but you leave me little choice...',26124),
(19680,'enUS','Searching','Searching',26124),
(19681,'enUS','Nuaar, are you feeling well?  You don\'t look like yourself today.','',26124),
(19682,'enUS','Begone, overseer!  We\'ve already spoken.$B$BStop dragging your feet and execute your orders at Ruuan Weald!','',26124),
(19683,'enUS','I\'m fine, thank you.  You asked for me?','I\'m fine, thank you.  You asked for me?',26124),
(19684,'enUS','Right, the meeting.  Let\'s get down to it then.$B$BThe fact is that the lumber and livestock being gathered from the Ruuan Weald, which you\'re responsible for, has slowed to a trickle.$B$BWe need those resources, but you\'ve allowed the druids of the Cenarion Expedition to get in the way!','',26124),
(19685,'enUS','Oh, it\'s not my fault, I can assure you.','Oh, it\'s not my fault, I can assure you.',26124),
(19686,'enUS','I don\'t want excuses, I demand results!$B$BYou think what we\'re doing here is a joke?  If we don\'t do this right, then not only will the so-called do-gooders come calling, but we\'ll be found unworthy for elevation within the ranks of the Blackwing.$B$BIs that what you want?','',26124),
(19687,'enUS','Um, no... no, I don\'t want that at all.','Um, no... no, I don\'t want that at all.',26124),
(19688,'enUS','You could at least try to sound a little bit convincing.$B$BLook, Nuaar, I wasn\'t going to tell you this, but I might as well because it\'s going to involve you, too.  Maxnar is planning an all-out attack on the druids at Ruuan Weald.  And he intends to wipe them out.$B$BIt\'s bad enough that we\'ve been fighting with the Boulder\'mok ogres, so we can\'t afford another front to deal with.  I\'ve arranged for a temporary truce with the arakkoa.$B$BWell, what do you think?','',26124),
(19689,'enUS','Impressive.  When do we attack?','Impressive.  When do we attack?',26124),
(19690,'enUS','We\'re putting the final preparations together even as we speak.  The rest will depend upon how quickly you can organize your forces at Ruuan Weald.$B$BDo you think that you can handle that and get it done quickly?','',26124),
(19691,'enUS','Absolutely!','Absolutely!',26124),
(19692,'enUS','That\'s the spirit!$B$BI\'m glad that we had this little meeting.  I feel much better about the attack now.  With leaders like you on the front, how can we lose?$B$BAlright, you have your marching orders.  Now get back to the Ruuan Weald and make it happen!','',26124),
(19693,'enUS','','Lend us the strength of the giants of Shadowmoon, Corok. The master is a just ruler. He will be sure to take care of those that assisted in subduing the dissidents of this world.',26124),
(19694,'enUS','%s begins channelling power into Dimensius.','',26124),
(19695,'enUS','And... if we do not?','',26124),
(19696,'enUS','','Then you become enemies of my lord, Illidan. Enemies of Illidan are destroyed. Are your giants able to withstand an attack from the forces of Eclipse Point?',26124),
(19697,'enUS','','No... I did not think so...',26124),
(19698,'enUS','Enemies approach! Call for me when you are at a safe location.','Enemies approach! Call for me when you are at a safe location.',26124),
(19699,'enUS','','Karazhan wasn\'t always quite as... ominous.  The darkening of Karazhan only came with Medivh\'s death.  Or what we believe was Medivh\'s death.',26124),
(19700,'enUS','Using','Using',26124),
(19701,'enUS','Straighten up!  I will not have soldiers in my unit looking so undisciplined before Val\'zareq.','Straighten up!  I will not have soldiers in my unit looking so undisciplined before Val\'zareq.',26124),
(19702,'enUS','You will do nothing to dishonor me before Val\'zareq.  Is that clear?','You will do nothing to dishonor me before Val\'zareq.  Is that clear?',26124),
(19703,'enUS','You are doing well.  Keep it up!','You are doing well.  Keep it up!',26124),
(19704,'enUS','Sir, yes Sir!','Sir, yes Sir!',26124),
(19705,'enUS','As you command, Sir!','As you command, Sir!',26124),
(19706,'enUS','We shall not fail you Sir!','We shall not fail you Sir!',26124),
(19707,'enUS','You made it this far, grunt. There is no turning back now.','',26124),
(19708,'enUS','I\'ve lost my Kor\'kron Flare Gun, sir. May I have another?','I\'ve lost my Kor\'kron Flare Gun, sir. May I have another?',26124),
(19709,'enUS','You\'re wearing my patience thin, grunt. I\'ve put the new flare gun in your pack. Try not to lose this one!','',26124),
(19710,'enUS','The wyrmcult blackwhelp lies here netted and helpless.','',26124),
(19711,'enUS','Collect the wyrmcult blackwhelp.','Collect the wyrmcult blackwhelp.',26124),
(19712,'enUS','You quickly place the subdued whelp into your pack.','',26124),
(19713,'enUS','Hello, overseer.  Ready for the attack?','Hello, overseer.  Ready for the attack?',26124),
(19714,'enUS','Something you need, sir?','Something you need, sir?',26124),
(19715,'enUS','You don\'t look well, overseer.','You don\'t look well, overseer.',26124),
(19716,'enUS','I heard that Kolphis Darkscale has been looking for you.','I heard that Kolphis Darkscale has been looking for you.',26124),
(19717,'enUS','Samia, do you know who Kolphis Darkscale is?','',26124),
(19718,'enUS','','Yes, he\'s the second-in-command of the wyrmcult at the Blackwing Coven to the west.',26124),
(19719,'enUS','These druids have tapped a tremendous source of power!  They can turn into animals... project  lightning and intense moonlight... I must discover how they do it!$B$BPerhaps they\'re wearing batteries underneath those robes...','',26124),
(19720,'enUS','Until Tally works out the kinks in this flight, the Capicitorium will need some extra fuel.  5 units ought to do it!','',26124),
(19721,'enUS','I have the fuel!  Take me to Raven\'s Wood.','I have the fuel!  Take me to Raven\'s Wood.',26124),
(19722,'enUS','<The arakkoa favors you with a haunted gaze and alternates between looking at you and looking through you.>$B$BWhat have our efforts wrought, but a greater abomination than we sought to prevent?','',26124),
(19723,'enUS','Countdown to February 16th, 2007: $4262d$BRaw number: $4262e','',26124),
(19724,'enUS','In Outland, our forces fight against the Horde to control the Eye of the Storm. It is dangerous, fighting amidst the raging energies of the Nether. Do you have what it takes to join us?','In Outland, our forces fight against the Horde to control the Eye of the Storm. It is dangerous, fighting amidst the raging energies of the Nether. Do you have what it takes to join us?',26124),
(19725,'enUS','The mana cells within the Eye of the Storm are a precious thing; we cannot afford to lose them to the draenei! You there! Make yourself useful and aid us in the fight!','The mana cells within the Eye of the Storm are a precious thing; we cannot afford to lose them to the draenei! You there! Make yourself useful and aid us in the fight!',26124),
(19726,'enUS','$n! Come here! Surely you know of the battle that rages within Alterac Valley back on Azeroth. We need every able-bodied fighter we can muster. Fight with the Stormpike Guard and defeat the Frostwolves!','$n! Come here! Surely you know of the battle that rages within Alterac Valley back on Azeroth. We need every able-bodied fighter we can muster. Fight with the Stormpike Guard and defeat the Frostwolves!',26124),
(19727,'enUS','This flight takes you to the far point of the Singing Ridge.  Very dangerous!$B$BFor this one, I\'m going to need a signed waiver...','',26124),
(19728,'enUS','I have the signed waiver!  Fire me into the Singing Ridge!','I have the signed waiver!  Fire me into the Singing Ridge!',26124),
(19729,'enUS','Send me back to the Jagged Ridge.','Send me back to the Jagged Ridge.',26124),
(19730,'enUS','Send me back to the Singing Ridge.','Send me back to the Singing Ridge.',26124),
(19731,'enUS','Send me back to Razaan\'s Landing.','Send me back to Razaan\'s Landing.',26124),
(19732,'enUS','Send me back to Ruann Weald.','Send me back to Ruann Weald.',26124),
(19733,'enUS','Send me back to Raven\'s Wood.','Send me back to Raven\'s Wood.',26124),
(19734,'enUS','We\'re always eager for more flight data!  Where do you want to go?','',26124),
(19735,'enUS','I want to fly to an old location!','I want to fly to an old location!',26124),
(19736,'enUS','%s raises his shield in a vigorous defense!','%s raises her shield in a vigorous defense!',26124),
(19737,'enUS','Brashly you have attacked my children, Illidan! The pact is broken. Giant will never side with elf! NEVER!','',26124),
(19738,'enUS','%s begins to channel arcane energy....','',26124),
(19739,'enUS','%s roars in defiance.','',26124),
(19740,'enUS','You hear the sound of giant gears churning to life below the depths...','',26124),
(19741,'enUS','You hear the faint sound of a gate unlocking in the cavern.','',26124),
(19742,'enUS','What is it, $r? Have you gathered some new information?','What is it, $r? Have you gathered some new information?',26124),
(19743,'enUS','We\'re under attack! Defend yourself! I\'m taking the high road. Call me back when the coast is clear!','We\'re under attack! Defend yourself! I\'m taking the high road. Call me back when the coast is clear!',26124),
(19744,'enUS','You will never get the Heart of Fury!  Its power belongs to Illidan!','',26124),
(19745,'enUS','I need another waiver!','I need another waiver!',26124),
(19746,'enUS','What is it then? Can\'t you see I\'m a busy dwarf?','',26124),
(19747,'enUS','I need another Wildhammer Flare Gun, Thane.','I need another Wildhammer Flare Gun, Thane.',26124),
(19748,'enUS','It\'s a done deal, soldier. The replacement flare gun is in your pack. Don\'t lose this one!','',26124),
(19749,'enUS','Die, worms!','',26124),
(19750,'enUS','While exploration in these new lands is no doubt important, you mustn\'t forsake Azeroth! We need you now more than ever in the fight against the Defilers. Those resources must be secured!','While exploration in these new lands is no doubt important, you mustn\'t forsake Azeroth! We need you now more than ever in the fight against the Defilers. Those resources must be secured!',26124),
(19751,'enUS','You, $c! We require your aid! The brutish Warsong orcs are destroying the wonder and beauty of Ashenvale, and we need your strength to meet them on the field of battle. Return with us to Azeroth and fight for the honor of the Silverwing Sentinels! Will you join us?','You, $c! We require your aid! The brutish Warsong orcs are destroying the wonder and beauty of Ashenvale, and we need your strength to meet them on the field of battle. Return with us to Azeroth and fight for the honor of the Silverwing Sentinels! Will you join us?',26124),
(19752,'enUS','Yes... what do you want, $r? Can\'t you see I am busy here?','',26124),
(19753,'enUS','There\'s an old saying, \"Give a man a fish; you have fed him for a day.  Teach a man to fish; and you have fed him for a lifetime.\"  Of course, you might want to cook that fish and that is where I come in.','',26124),
(19754,'enUS','Hello, $n!  How goes your adventures? My experiments are progressing nicely...$B$BBe sure to check back with me later!   I might have more test flight opportunities for you!','',26124),
(19755,'enUS','Tell me more about this thing you call \"cooking?\"','Tell me more about this thing you call \"cooking?\"',26124),
(19756,'enUS','Strength and honor, $c. We need eager soldiers like you in Alterac Valley; the territory of the Frostwolves must be defended! Will you return to Azeroth and lend your aid?','Strength and honor, $c. We need eager soldiers like you in Alterac Valley; the territory of the Frostwolves must be defended! Will you return to Azeroth and lend your aid?',26124),
(19757,'enUS','$R! Yes, you! Why do you waste time dawdling in this wreck of a city when your rightful place is in Arathi Basin? The League of Arathor is ruthless in its assault; your contribution is needed, and you will be rewarded!','$R! Yes, you! Why do you waste time dawdling in this wreck of a city when your rightful place is in Arathi Basin? The League of Arathor is ruthless in its assault; your contribution is needed, and you will be rewarded!',26124),
(19758,'enUS','$C, back on Azeroth, the Silverwing Sentinels hamper our progress in the woods. We need you there on the battlefront to push them back! You will earn great honor and reputation with the Warsong Outriders for helping us - join us now!','$C, back on Azeroth, the Silverwing Sentinels hamper our progress in the woods. We need you there on the battlefront to push them back! You will earn great honor and reputation with the Warsong Outriders for helping us - join us now!',26124),
(19759,'enUS','Save yourself, $r. Flee from this place! The Crimson Sigil will execute you on sight if you are discovered.','Save yourself, $r. Flee from this place! The Crimson Sigil will execute you on sight if you are discovered.',26124),
(19760,'enUS','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.',26124),
(19761,'enUS','In the name of Illidan!','',26124),
(19762,'enUS','For our patron!','',26124),
(19763,'enUS','Die, interloper!','',26124),
(19764,'enUS','There will be no escape...','',26124),
(19765,'enUS','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.',26124),
(19766,'enUS','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.',26124),
(19767,'enUS','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',26124),
(19768,'enUS','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',26124),
(19769,'enUS','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',26124),
(19770,'enUS','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',26124),
(19771,'enUS','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.',26124),
(19772,'enUS','The Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','The Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',26124),
(19773,'enUS','The Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.','The Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.',26124),
(19774,'enUS','At your command, my liege...\n','',26124),
(19775,'enUS','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',26124),
(19776,'enUS','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.',26124),
(19777,'enUS','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',26124),
(19778,'enUS','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.',26124),
(19779,'enUS','Destroy them, Torloth. Let loose their blood like a river upon this hallowed ground.','',26124),
(19780,'enUS','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',26124),
(19781,'enUS','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.',26124),
(19782,'enUS','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',26124),
(19783,'enUS','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.',26124),
(19784,'enUS','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',26124),
(19785,'enUS','As you desire, Lord Illidan.','',26124),
(19786,'enUS','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.',26124),
(19787,'enUS','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','The goblin Steamwheedle Fighting Circuit has begun. You can find Arena Organizers selling arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',26124),
(19788,'enUS','For Lord Illidan, I would sacrifice even this magnificent physique. On this day, you will fall - another victim of Torloth...','',26124),
(19789,'enUS','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.','The goblin Steamwheedle Fighting Circuit is beginning soon. They\'re holding practice matches in their arenas now, but ranking fights begin in $4262d.',26124),
(19790,'enUS','<The grizzled gladiator speaks in halting Common.> What? You have a problem with me? Take it to the arena. I don\'t waste my time with your little \"hordes\" and \"alliances.\"','',26124),
(19791,'enUS','Gladiators earn the right to wear equipment like mine by winning ranked arena matches.','',26124),
(19792,'enUS','<The veteran gladiator speaks in halting Orcish.> What? You have a problem with me? Take it to the arena. I don\'t waste my time with your little \"hordes\" and \"alliances.\"','',26124),
(19793,'enUS','Gladiators earn the right to wear equipment like mine by winning ranked arena matches.','',26124),
(19794,'enUS','Return to Shattrath, hero. Seek out the wisdom of A\'dal.','',26124),
(19795,'enUS','Dark days are upon us, $n. What are we to do when even our greatest heroes fall before the might of Illidan?','',26124),
(19796,'enUS','Quickly, get to the middle of the platform! Illidan\'s fury is soon to be unleashed!','',26124),
(19797,'enUS','What manner of fool dares stand before Illidan Stormrage? Soldiers, destroy these insects!','',26124),
(19798,'enUS','You are no challenge for the Crimson Sigil. Mind breakers, end this nonsense!','',26124),
(19799,'enUS','Run while you still can. The highlords come soon...','',26124),
(19800,'enUS','Torloth, your master calls!','',26124),
(19801,'enUS','So you have defeated the Crimson Sigil. You now seek to challenge my rule? Not even Arthas could defeat me, yet you dare to even harbor such thoughts? Then I say to you, come! Come $n! The Black Temple awaits...','',26124),
(19802,'enUS','Yo! Have you heard about the Steamwheedle Fighting Circuit?\n\nYou can find Arena Organizers selling the arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.','Yo! Have you heard about the Steamwheedle Fighting Circuit?\n\nYou can find Arena Organizers selling the arena team charters in Gadgetzan and outside the arenas in Nagrand and the Blade\'s Edge Mountains.',26124),
(19803,'enUS','Hey there.  Taking a break, overseer?  We don\'t get to see you around here much anymore since you were reassigned to Ruuan Weald.$B$BTake a look at what I have to offer.  It may not have changed much since last we spoke, but I\'ve got plenty.$B$BAnd don\'t be such a stranger!','',26124),
(19804,'enUS','Very well, let me see what you\'ve got.','Very well, let me see what you\'ve got.',26124),
(19805,'enUS','My loathing of interruptions is overshadowed only by my hatred of Gruul the Dragonkiller and his seven sons!','',26124),
(19806,'enUS','Ranked arena matches start in $4262d. Would-be champions are already busy honing their skills and acquiring the best gear they can. Are you going to be ready?','Ranked arena matches start in $4262d. Would-be champions are already busy honing their skills and acquiring the best gear they can. Are you going to be ready?',26124),
(19807,'enUS','','You must... free... my children...',26124),
(19808,'enUS','There, it is completed.','',26124),
(19809,'enUS','They can\'t keep this up! Their wings will eventually give...','',26124),
(19810,'enUS','Just one good shot...','',26124),
(19811,'enUS','','Read the tome of divinity I have given you, $n.  When you have learned from the book, speak with me again.',26124),
(19812,'enUS','%s picks up the flayer carcass.','',26124),
(19813,'enUS','Your fate is written.','',26124),
(19814,'enUS','The chaos I have sown here is but a taste....','',26124),
(19815,'enUS','I am merely one of... infinite multitudes.','',26124),
(19816,'enUS','You will do my bidding, weakling.','',26124),
(19817,'enUS','Your will is no longer your own.','',26124),
(19818,'enUS','Flee in terror.','',26124),
(19819,'enUS','I will show you horrors undreamed of.','',26124),
(19820,'enUS','Master... I\'ve failed you...','',26124),
(19821,'enUS','We span the universe, as countless as the stars!','',26124),
(19822,'enUS','I have no idea what goes on here, but I will gladly join your fight against this impudent imbecile!','',26124),
(19823,'enUS','Prepare to defend yourself, cretin!','',26124),
(19824,'enUS','I didn\'t even break a sweat on that one!','',26124),
(19825,'enUS','You guys feel free to jump in anytime.','',26124),
(19826,'enUS','I\'m gonna light you up, sweet cheeks!','',26124),
(19827,'enUS','Ice, ice baby.','',26124),
(19828,'enUS','Heal me! For the love of all that\'s holy, heal me! I\'m dying!!','',26124),
(19829,'enUS','You\'ll be hearing from my lawyer!','',26124),
(19830,'enUS','%s retrieves the Heart of Fury.','',26124),
(19831,'enUS','You dare imprison me? You will die!','',26124),
(19832,'enUS','You are... nothing!','',26124),
(19833,'enUS','You shall be consumed by flame!','',26124),
(19834,'enUS','S-s-o-o... cold.','',26124),
(19835,'enUS','Pathetic, inferior mortals!','',26124),
(19836,'enUS','The dragonflight will... devour you.','',26124),
(19837,'enUS','The black dragonflight will conquer all!','',26124),
(19838,'enUS','Doom upon you... wretched mortals!','',26124),
(19839,'enUS','I\'m gonna cook ya, an\' then I\'m gonna eat ya!','',26124),
(19840,'enUS','I hope you all... die in pain!','',26124),
(19841,'enUS','Grulloc having lots of fun!','',26124),
(19842,'enUS','Me hungry!','',26124),
(19843,'enUS','You be Grulloc\'s friend!','',26124),
(19844,'enUS','Mmm, other white meat!','',26124),
(19845,'enUS','Piggy stop!','',26124),
(19846,'enUS','Where piggy go?!','',26124),
(19847,'enUS','Sound the alarm!','Sound the alarm!',26124),
(19848,'enUS','%s hungrily eats the flayer carcass.\n','',26124),
(19849,'enUS','Thank you, mortal.','',26124),
(19850,'enUS','Ah, another $c looking to be a gladiator, eh? Good!\n\nI sell the arena team charters you\'ll need to participate in ranking Steamwheedle Fighting Circuit matches.','Ah, another $c looking to be a gladiator, eh? Good!\n\nI sell the arena team charters you\'ll need to participate in ranking Steamwheedle Fighting Circuit matches.',26124),
(19852,'enUS','How do I form an arena team?','How do I form an arena team?',26124),
(19853,'enUS','The Steamwheedle Fighting Circuit isn\'t selling the arena team charters you\'ll need to participate in ranking matches yet.\n\nStill, you can find an Arena Battlemaster and get in some practice rounds. It\'s never too soon to start training.','The Steamwheedle Fighting Circuit isn\'t selling the arena team charters you\'ll need to participate in ranking matches yet.\n\nStill, you can find an Arena Battlemaster and get in some practice rounds. It\'s never too soon to start training.',26124),
(19854,'enUS','Your overconfidence will be your undoing! Guards, lend me your strength!','',26124),
(19855,'enUS','','Spinebreaker Post is a great place to be stationed!  The Bleeding Hollow aberrations are so close you can smell their foul blood!  What better place to gather vengeance from a clan that has forsaken its brethren and made a pact with demons?',26124),
(19856,'enUS','Piggy!!!','',26124),
(19857,'enUS','Porkchops!','',26124),
(19858,'enUS','The Heart of Fury... I witnessed its power long ago, when Velen wielded it.  I feel the same power coursing through it right now!','',26124),
(19859,'enUS','With this crystal\'s powers, my Deathsworn and I... we\'d be unstoppable!  We could destroy Illidan!  We could... replace him as lords of Outland!','',26124),
(19860,'enUS','But that is not part of the vision I was granted... that is not... how my people will be freed.','',26124),
(19861,'enUS','Fairweather and I are up here representing Sylvanaar\'s interests.$B$BThe druids have been more than accommodating, but allowing the Horde to travel through here gives me the willies.','',26124),
(19862,'enUS','Greetings, mortal.','',26124),
(19863,'enUS','I am listening, dragon.','I am listening, dragon.',26124),
(19864,'enUS','In the eastern reaches of the Netherwing Fields lies Dragonmaw Fortress. It is there that the cruel Dragonmaw orc clan tortures the drakes that they capture in an attempt to bend them to their will. Many have given up hope, choosing instead to do the bidding of Dragonmaw. The others... They refuse to land for fear of Dragonmaw war parties capturing them and taking them back to the fortress.','',26124),
(19865,'enUS','But you are dragons! How could orcs do this to you?','But you are dragons! How could orcs do this to you?',26124),
(19866,'enUS','I... We are powerless. Illidan found and delivered unto the Dragonmaw their leader - Zuluhed. This orc was the one responsible for the capture and incarceration of Alexstrasza. How could we fight against such power? He captured an Aspect!$B$BAnd just as easily, he took my mate.','',26124),
(19867,'enUS','Your mate?','Your mate?',26124),
(19868,'enUS','<Neltharaku nods.>$B$BKarynaku... She is held prisoner atop Dragonmaw Fortress. I have made many attempts to free her. All have failed... You have battled these beasts before, have you not?\n','',26124),
(19869,'enUS','I have battled many beasts, dragon. I will help you.','I have battled many beasts, dragon. I will help you.',26124),
(19870,'enUS','Please, $n.  You must take the Heart of Fury somewhere safe... you must take it to A\'dal!','',26124),
(19871,'enUS','','You\'re willing to give up an Ata\'mal crystal... just to see your plan against Illidan through?  You intrigue me, Broken.  Perhaps I\'ll play along... for now, at least.',26124),
(19872,'enUS','','Hellfire Peninsula - Mordiba default',26124),
(19873,'enUS','Intruder detected!  Neutralizing threat immediately!','',26124),
(19874,'enUS','Perimeter breached!  Destroy $R!','',26124),
(19875,'enUS','Unauthorized personnel identified!  Punishment protocol activated.','',26124),
(19876,'enUS','Power levels seem adequate.  No sign of the anomlies like we saw at Manaforge Ultris.','',26124),
(19877,'enUS','%s goes into a nether-fed rage!','',26124),
(19878,'enUS','Everything is going according to schedule.  Prince Kael\'thas should be pleased.','',26124),
(19879,'enUS','Why must I be surrounded by incompetence?  Oh well, perhaps some of my underling may eventually grow a brain.','',26124),
(19880,'enUS','%s cries out in withdrawal, opening gates to the nether.','',26124),
(19881,'enUS','We should be uniting the Ogre clans, not fighting each other.','',26124),
(19882,'enUS','Will we never learn to work together?  Or will we simply kill each other off and be forgotten in time.','',26124),
(19883,'enUS','If only the leaders of the clans would listen.  Unity is the only answer.  All other paths lead to our destruction.','',26124),
(19884,'enUS','My message of unity is meant for the Ogre clans, not for you, $R!','',26124),
(19885,'enUS','I will not allow you to kill anymore of my kind!  Prepare to die!','',26124),
(19886,'enUS','I decree that you are an enemy of the Ogre clans.  Punishment is death!','',26124),
(19887,'enUS','Excellent!  Fresh parts!','',26124),
(19888,'enUS','It is very kind of you to donate your organs!','',26124),
(19889,'enUS','Be proud, your brain will be put to good use in one of my abominations.','',26124),
(19890,'enUS','The information you seek... I cannot give you that freely.  You will have to prove that your enemies are the same as mine.','',26124),
(19891,'enUS','Enough! I have had enough of you filthy warm bloods!','',26124),
(19892,'enUS','Stupid puny thing.  Me smash!','',26124),
(19893,'enUS','Me mad. You get smash in face!','',26124),
(19894,'enUS','Me angered. Raaah!','',26124),
(19895,'enUS','Doom Lord Kazzak will soon unleash our full might on these pitiful Orcs and Humans!','',26124),
(19896,'enUS','Be ready my brothers!  We shall make our way thru the Dark Portal and all of Azeroth shall fall!','',26124),
(19898,'enUS','We are but extensions of Doom Lord Kazzak\'s will!  Be strong!  Be vigilant!  Let nothing stand in the way of the Burning Legion!','',26124),
(19899,'enUS','Obey his commands and be honored among the Burning Legion.  Falter and you will be consumed!','',26124),
(19900,'enUS','I love to bathe in the blood of my enemies!','',26124),
(19901,'enUS','','The fight against Kael\'thas and Illidan continues on all fronts.  Defeat is not an option.',26124),
(19902,'enUS','Once I\'ve hacked off your limbs, I may hang your body from our battlements.','',26124),
(19903,'enUS','I crave your death!','',26124),
(19904,'enUS','Hail, $n.  All friends of the Light are welcome at the Altar of Sha\'tar.','',26124),
(19905,'enUS','The Wyrmcult must be using another path. We are still finding them in Ruuan Weald.','The Wyrmcult must be using another path. We are still finding them in Ruuan Weald.',26124),
(19906,'enUS','I shall send your soul into the infinite void!','',26124),
(19907,'enUS','Let my darkness engulf you!','',26124),
(19908,'enUS','In the void, no one can hear you scream!','',26124),
(19909,'enUS','Orcs of the Horde! This portal is the gateway to your new destiny! Azeroth lies before you, ripe for the taking!','',26124),
(19910,'enUS','','',26124),
(19911,'enUS','Gul\'dan speaks the truth! We should return at once to tell our brothers of the news! Retreat back through the portal!','',26124),
(19912,'enUS','We are to wait here. They sent others ahead to check the tunnel interior.','We are to wait here. They sent others ahead to check the tunnel interior.',26124),
(19913,'enUS','How dare you take my eye!  I will crush your soul and feed it to my blind and whimpering imps!','',26124),
(19914,'enUS','Come to my lair, whelp!  Come to me and pay for your insolence!','',26124),
(19915,'enUS','','Light be with you, Harbinger.',26124),
(19916,'enUS','','Why hasn\'t Illidan made his move?  All this waiting is making our forces uneasy.',26124),
(19917,'enUS','What manner of thing would ever serve those sinister Wyrmcult wretches?','What manner of thing would ever serve those sinister Wyrmcult wretches?',26124),
(19918,'enUS','The Betrayer hasn\'t been the most predictable of foes, Exarch.  I have no fear however, with the Light on our side we shall defeat his forces today, tomorrow, or whenever he chooses to attack.','',26124),
(19919,'enUS','Never forget whom you serve.  Illidan will rule this land and beyond.','',26124),
(19920,'enUS','How has the Wyrmcult gained so many followers? Where are they coming from?!','How has the Wyrmcult gained so many followers? Where are they coming from?!',26124),
(19921,'enUS','The master desires your full obedience and you will comply!','',26124),
(19922,'enUS','Soon all our enemies will beg for mercy or be shatterd bones under our feet!','',26124),
(19923,'enUS','I realize you have only recently joined us, and thus may be unaware of our traditions. In Moonglade, a tremendous celebration is taking place. This is a time of year when we honor our elders, and you are certainly invited! Travel to one of our cities if you wish to join in!','I realize you have only recently joined us, and thus may be unaware of our traditions. In Moonglade, a tremendous celebration is taking place. This is a time of year when we honor our elders, and you are certainly invited! Travel to one of our cities if you wish to join in!',26124),
(19924,'enUS','%s emits a low, quiet growl, looking back over its shoulder.','%s emits a low, quiet growl, looking back over its shoulder.',26124),
(19925,'enUS','What do you see? Anything?','What do you see? Anything?',26124),
(19926,'enUS','Are there Wyrmcult ahead?','Are there Wyrmcult ahead?',26124),
(19927,'enUS','Have you found them?','Have you found them?',26124),
(19928,'enUS','Are there very many of them, up there?','Are there very many of them, up there?',26124),
(19929,'enUS','Die, Scryer scum!','',26124),
(19930,'enUS','Destroy these Aldor dogs!','',26124),
(19931,'enUS','The Lunar Festival is in full swing on Azeroth! Return there and honor your elders in this wonderful celebration! The main festivities can be found in Moonglade, but we\'ve provided easy transportation from Stormwind, Ironforge, Darnassus, Thunder Bluff, Orgrimmar, and the Undercity. We hope to see you there!','The Lunar Festival is in full swing on Azeroth! Return there and honor your elders in this wonderful celebration! The main festivities can be found in Moonglade, but we\'ve provided easy transportation from Stormwind, Ironforge, Darnassus, Thunder Bluff, Orgrimmar, and the Undercity. We hope to see you there!',26124),
(19932,'enUS','What? Where am I? This isn\'t right at all! Look at you! Look at this place! It isn\'t on my list! There\'s going to be so much paperwork...$b$b<The goblin writes frantically in a small notebook.>$b$bLook, if you\'ve got nothing better to do than stand there and stare, why don\'t you go visit my cousin, Kwee Q. Peddlefeet, in one of the major cities? Says here he\'s taking care of Orgrimmar, Stormwind, Thunder Bluff, Ironforge, the Undercity, and Darnassus. Go on, get outta here!','What? Where am I? This isn\'t right at all! Look at you! Look at this place! It isn\'t on my list! There\'s going to be so much paperwork...$b$b<The goblin writes frantically in a small notebook.>$b$bLook, if you\'ve got nothing better to do than stand there and stare, why don\'t you go visit my cousin, Kwee Q. Peddlefeet, in one of the major cities? Says here he\'s taking care of Orgrimmar, Stormwind, Thunder Bluff, Ironforge, the Undercity, and Darnassus. Go on, get outta here!',26124),
(19933,'enUS','There are mysteries in this place that we, the orcs, are desperate to uncover.  Mysteries of our past, mysteries of our future, and mysteries that offer glimpses inside us.$B$BIt is my hope to pierce these mysteries... will you walk that path with me?','',26124),
(19934,'enUS','Oh no!','',26124),
(19935,'enUS','I can watch no longer.  We MUST undo this evil that the arakkoa are perpetrating upon the protectors of the Raven\'s Wood!','',26124),
(19936,'enUS','','Step forward.  I will see that you are properly welcomed!',26124),
(19937,'enUS','','Oh, stop your whimpering!',26124),
(19938,'enUS','','Mission accomplished!',26124),
(19939,'enUS','','You are no longer dealing with some underling!',26124),
(19940,'enUS','','Band\'or shorel\'aran!',26124),
(19941,'enUS','','Guards, rally!  Cut these invaders down!',26124),
(19942,'enUS','','I have not yet... begun to...',26124),
(19943,'enUS','The %s appears very grateful to be free of the koi-koi spirit\'s influence.','',26124),
(19944,'enUS','What are you doing?  These specimens are very delicate!','',26124),
(19945,'enUS','Your life cycle is now concluded.','',26124),
(19946,'enUS','You will feed the worms.','',26124),
(19947,'enUS','Endorel anuminor!','',26124),
(19948,'enUS','Nature bends to my will....','',26124),
(19949,'enUS','The specimens... must be preserved.','',26124),
(19950,'enUS','There\'s trouble in the woods.  We must uncover its source before it is too late!','',26124),
(19951,'enUS','You are always welcome with us here in the Raven\'s Wood, $n.','',26124),
(19952,'enUS','You should split while you can.','',26124),
(19953,'enUS','Can\'t say I didn\'t warn you....','',26124),
(19954,'enUS','Damn, I\'m good!','',26124),
(19955,'enUS','Think you can hurt me, huh?  Think I\'m afraid a\' you?','',26124),
(19956,'enUS','Go ahead, gimme your best shot.  I can take it!','',26124),
(19957,'enUS','Bully!','',26124),
(19958,'enUS','The %s creaks in pain as it is possessed by the koi-koi.','',26124),
(19959,'enUS','','Don\'t value your life very much, do you?',26124),
(19960,'enUS','','Welcome to cokeplay.com, drink CocaCola and raise a cute polar bear!',26124),
(19961,'enUS','','And don\'t come back!',26124),
(19962,'enUS','','Endala finel endal!',26124),
(19963,'enUS','','Think you can take the heat?',26124),
(19964,'enUS','','Anar\'endal dracon!',26124),
(19965,'enUS','','I am not alone.',26124),
(19966,'enUS','','Anu... bala belore...alon.',26124),
(19967,'enUS','At last, a target for my frustrations!','',26124),
(19968,'enUS','Have you come to kill Dalliah?  Can I watch?','',26124),
(19969,'enUS','Yes, that was quite satisfying.','',26124),
(19970,'enUS','Ahh... much better.','',26124),
(19971,'enUS','On guard!','',26124),
(19972,'enUS','Defend yourself, for all the good it will do....','',26124),
(19973,'enUS','Knew this was... the only way out.','',26124),
(19974,'enUS','Having problems, Dalliah?  How nice.','',26124),
(19975,'enUS','This may be the end for you, Dalliah.  What a shame that would be.','',26124),
(19976,'enUS','I suggest a new strategy: you draw their attacks while I gather reinforcements.','',26124),
(19977,'enUS','Finally!  Well done!','',26124),
(19978,'enUS','','It is unwise to anger me!',26124),
(19979,'enUS','','Don\'t worry about me; kill that worthless dullard instead!',26124),
(19980,'enUS','','Completely ineffective.  Just like someone else I know.',26124),
(19981,'enUS','','You chose the wrong opponent.',26124),
(19982,'enUS','','Reap the whirlwind!',26124),
(19983,'enUS','','I\'ll cut you to pieces!',26124),
(19984,'enUS','','That is much better.',26124),
(19985,'enUS','','Ahh... just what I needed.',26124),
(19986,'enUS','','Now I\'m really angry.',26124),
(19987,'enUS','','More than you can handle, scryer?',26124),
(19988,'enUS','','I suppose I\'ll end up fighting them all myself.',26124),
(19989,'enUS','','I\'ve grown used to cleaning up your messes.',26124),
(19990,'enUS','','Congratulations.  I\'ve wanted to do that for years.',26124),
(19991,'enUS','Soon I will plant roots and sleep.   Before I rest there are things that must yet be done.','',26124),
(19992,'enUS','You brought the green to my land for a short time.  It is enough.  I am at peace.  I am ready for my long sleep.','',26124),
(19993,'enUS','I have no equal!','',26124),
(19994,'enUS','Perish, mortal!','',26124),
(19995,'enUS','Yes... yes!','',26124),
(19996,'enUS','Kill, kill!','',26124),
(19997,'enUS','That\'s right, yes!','',26124),
(19998,'enUS','Who\'s the master now?','',26124),
(19999,'enUS','You cannot kill me, fools! I\'ll be back, I\'ll....','',26124),
(20000,'enUS','Guards, attention! We have visitors....','',26124),
(20001,'enUS','Land-dwelling scum!','',26124),
(20002,'enUS','Alana be\'lendor!','',26124),
(20003,'enUS','I am rid of you.','',26124),
(20004,'enUS','Her... excellency... awaits.','',26124),
(20005,'enUS','%s begins to radiate massive amounts of energy!','',26124),
(20006,'enUS','Consider this a warm up!  Your real training will be far harsher!','',26124),
(20007,'enUS','Success!  I have attuned myself to Hellfire Citadel and the magic within.  Ah, such power!$B$BThere are countless fel orcs in that place... but that is not all!  I sense demonic power within those walls as well...$B$BIf you open yourself, then I shall grasp your mind -- briefly, mind you -- and take quill to parchment and record my findings for you...','',26124),
(20008,'enUS','Yes, Scryer.  You may possess me.','Yes, Scryer.  You may possess me.',26124),
(20009,'enUS','I think I hear him coming now.','',26124),
(20010,'enUS','Thank you, my friend.  This drake from Dragons\' End is just what we need to lure Goc out from hiding!','',26124),
(20011,'enUS','Must you leave so soon?  Very well, may your journey bring you honor.','',26124),
(20012,'enUS','What aggravation is this? You will die!','',26124),
(20013,'enUS','You seek a prize, eh? How about death?','',26124),
(20014,'enUS','I hate to say I told you so...','',26124),
(20015,'enUS','Your life will be mine!','',26124),
(20016,'enUS','I revel in your pain!','',26124),
(20017,'enUS','I\'ll incinerate you!','',26124),
(20018,'enUS','Scream while you burn!','',26124),
(20019,'enUS','You won\'t... get far.','',26124),
(20020,'enUS','Die, interloper!  Your puny device cannot pierce the dark magics of Hellfire Citadel!','',26124),
(20021,'enUS','%s takes a deep breath.','',26124),
(20022,'enUS','Maybe this is not-- No, we fight! Come to my aid!','Maybe this is not-- No, we fight! Come to my aid!',26124),
(20023,'enUS','Miserable vermin. I shall exterminate you from the air!','',26124),
(20024,'enUS','Who disturbs this sanctuary?','Who disturbs this sanctuary?',26124),
(20025,'enUS','You must die! But wait: this does not-- No, no... you must die!','You must die! But wait: this does not-- No, no... you must die!',26124),
(20026,'enUS','What am I doing? Why do I...','What am I doing? Why do I...',26124),
(20027,'enUS','An intruder!  Begone!','',26124),
(20028,'enUS','So... confused. Do not... belong here.','So... confused. Do not... belong here.',26124),
(20029,'enUS','Low-tech, yet quite effective.','',26124),
(20030,'enUS','My calculations did not...','',26124),
(20031,'enUS','A foregone conclusion.','',26124),
(20032,'enUS','The processing will continue as scheduled!','',26124),
(20033,'enUS','You have approximately five seconds to live.','',26124),
(20034,'enUS','I predict a painful death.','',26124),
(20035,'enUS','Your strategy was flawed.','',26124),
(20036,'enUS','Yes, the only logical outcome.','',26124),
(20037,'enUS','Measure twice; cut once.','',26124),
(20038,'enUS','If my division is correct... you should be quite dead.','',26124),
(20039,'enUS','An unforeseen... contingency.','',26124),
(20040,'enUS','You work for me now!','',26124),
(20041,'enUS','We are on a strict timetable. You will not interfere!','',26124),
(20042,'enUS','A minor inconvenience.','',26124),
(20043,'enUS','Looks like you lose.','',26124),
(20044,'enUS','The project will... continue.','',26124),
(20045,'enUS','Life energy to... consume.','',26124),
(20046,'enUS','This vessel is empty.','',26124),
(20047,'enUS','No... more... life.','',26124),
(20048,'enUS','The shadow... will engulf you.','',26124),
(20049,'enUS','Darkness... consumes all.','',26124),
(20050,'enUS','The Void... beckons.','',26124),
(20051,'enUS','Did you call on me?','',26124),
(20052,'enUS','To do your heavy lifting, most likely.','',26124),
(20053,'enUS','Then I\'ll commit myself to ignoring you.','',26124),
(20054,'enUS','You\'re the one who should be-- Wait, we have company...','',26124),
(20055,'enUS','','Why would I call on you?',26124),
(20056,'enUS','','When I need someone to prance around like an overstuffed peacock, I\'ll call on you.',26124),
(20057,'enUS','','What would you know about commitment, sheet-sah?',26124),
(20058,'enUS','I will come back for you all!','',26124),
(20060,'enUS','Free at last!','',26124),
(20061,'enUS','The Legion will prevail!','',26124),
(20062,'enUS','','Daddy!',26124),
(20063,'enUS','Dad!','',26124),
(20064,'enUS','Yay, fireworks!','Yay, fireworks!',26124),
(20065,'enUS','Our enemies surround us.  I would have a better life for the Mok\'Nathal, but the forces we are at battle with have chosen otherwise for us.$B$BIf you would prove yourself worthy to the Mok\'Nathal, aid us in their elimination.','',26124),
(20066,'enUS','Gronn are the real power in Outland!','',26124),
(20067,'enUS','You will not defeat the hand of Gruul!','',26124),
(20068,'enUS','You won\'t kill next one so easy.','',26124),
(20069,'enUS','Pah! Does not prove anything!','',26124),
(20070,'enUS','I\'m not afraid of you!','',26124),
(20071,'enUS','Good, now you fight me!','',26124),
(20072,'enUS','You not so tough after all!','',26124),
(20073,'enUS','%s laughs.','',26124),
(20074,'enUS','Maulgar is king!','',26124),
(20075,'enUS','Gruul... will crush you.','',26124),
(20076,'enUS','I remember well the sting of defeat at the conclusion of the Third War. I have waited far too long for my revenge. Now the shadow of the Legion falls over this world. It is only a matter of time until all of your failed creation... is undone. ','',26124),
(20077,'enUS','The Legion will conquer all!','',26124),
(20078,'enUS','All mortals will perish!','',26124),
(20079,'enUS','All life must be eradicated! ','',26124),
(20080,'enUS','I\'ll rip the flesh from your bones!','',26124),
(20081,'enUS','Kirel narak!','',26124),
(20082,'enUS','Contemptible wretch!','',26124),
(20083,'enUS','The universe will be remade.','',26124),
(20084,'enUS','The Legion... will never... fall.','',26124),
(20085,'enUS','','Water... is life. It has become a rare commodity here in Outland; a commodity that we alone shall control. We are the Highborne, and the time has come at last for us to retake our rightful place in the world!',26124),
(20086,'enUS','','Straight to the heart!',26124),
(20087,'enUS','','Seek your mark!',26124),
(20088,'enUS','','I\'ll split you from stem to stern!',26124),
(20089,'enUS','','Victory to Lord Illidan! ',26124),
(20090,'enUS','','Death to the outsiders!',26124),
(20091,'enUS','','I spit on you, surface filth!',26124),
(20092,'enUS','','The time is now! Leave none standing! ',26124),
(20093,'enUS','','Your time ends now!',26124),
(20094,'enUS','','You have failed!',26124),
(20095,'enUS','','Be\'lemer an-delei!',26124),
(20096,'enUS','','Lord Illidan, I... I am... sorry.',26124),
(20097,'enUS','This fel reaver appears to not be quite operation just yet.','',26124),
(20098,'enUS','<Administer the condensed nether gas.>','<Administer the condensed nether gas.>',26124),
(20099,'enUS','Puzzled by what you see, stranger?$B$BWe give praise to the spirits of our ancestors by keeping the flame of their memory alive and paying it tribute.','',26124),
(20100,'enUS','%s lets loose a low, guttural growl.\n','',26124),
(20101,'enUS','%s grows massively powerful!','',26124),
(20102,'enUS','%s orders a nearby ogre to assist him!','',26124),
(20103,'enUS','%s begins to sputter as its engine malfunctions.','',26124),
(20104,'enUS','%s will detonate in 5 seconds!','',26124),
(20105,'enUS','4...','',26124),
(20106,'enUS','Deathforge Mine will detonate in 3 seconds!','',26124),
(20107,'enUS','2...','',26124),
(20108,'enUS','Deathforge Mine: Detonating!','',26124),
(20109,'enUS','Yay!  We\'re free!','Yay!  We\'re free!',26124),
(20110,'enUS','Woot!','Woot!',26124),
(20111,'enUS','Yay!  We love you!  You saved us!','Yay!  We love you!  You saved us!',26124),
(20112,'enUS','Spiritcaller, I need more totems to save the spirits of the nether drakes.','Spiritcaller, I need more totems to save the spirits of the nether drakes.',26124),
(20113,'enUS','Well, alright, but you know these things don\'t grow on trees.$B$B<The spiritcaller thinks about that a moment.>$B$BOh, wait a minute....','',26124),
(20114,'enUS','I think those weird bird guys were going to eat us.  Gross!','I think those weird bird guys were going to eat us.  Gross!',26124),
(20115,'enUS','Gross!','Gross!',26124),
(20116,'enUS','Come.... and die.','',26124),
(20117,'enUS','Scurry.','',26124),
(20118,'enUS','No escape.','',26124),
(20119,'enUS','Stay.','',26124),
(20120,'enUS','Beg for life.','',26124),
(20121,'enUS','No more.','',26124),
(20122,'enUS','Unworthy.','',26124),
(20123,'enUS','Die.','',26124),
(20124,'enUS','Me am so thirsty!','',26124),
(20125,'enUS','No taste good. Bad.','',26124),
(20126,'enUS','Lord Illidan, bless me with the power of the flight!','',26124),
(20127,'enUS','Foolish mortals. Did you think that I would not strike you down for your transgressions?','',26124),
(20128,'enUS','Indeed, the time has come to end this charade.','',26124),
(20129,'enUS','Destroy them! Destroy them all!','',26124),
(20130,'enUS','I can instruct you in alchemy.  Interested?','I can instruct you in alchemy.  Interested?',26124),
(20131,'enUS','I can instruct you in engineering.  Interested?','I can instruct you in engineering.  Interested?',26124),
(20132,'enUS','I can instruct you in enchanting.  Interested?','I can instruct you in enchanting.  Interested?',26124),
(20133,'enUS','I can instruct you in tailoring.  Interested?','I can instruct you in tailoring.  Interested?',26124),
(20134,'enUS','I can instruct you in leatherworking.  Interested?','I can instruct you in leatherworking.  Interested?',26124),
(20135,'enUS','I can instruct you in blacksmithing.  Interested?','I can instruct you in blacksmithing.  Interested?',26124),
(20136,'enUS','The %s flies up through the trees, free of Terokk\'s corruption.','',26124),
(20137,'enUS','ATTACK WITH THE FULL FORCE OF NETHERWING, MY CHILDREN! ATTACK!','',26124),
(20138,'enUS','Breaking','Breaking',26124),
(20139,'enUS','It is good to see you again, friend.','',26124),
(20140,'enUS','%s casts a spell to draw magical attacks away from his allies.','',26124),
(20141,'enUS','You are spotted by the %s!','',26124),
(20142,'enUS','Mother!','',26124),
(20143,'enUS','Praise the naaru, I\'m saved.  I will try to make it clear on my own.','Praise the naaru, I\'m saved.  I will try to make it clear on my own.',26124),
(20144,'enUS','I\'m hurt, but I can still run.  Thank you, stranger.','I\'m hurt, but I can still run.  Thank you, stranger.',26124),
(20145,'enUS','My thanks, stranger.','My thanks, stranger.',26124),
(20146,'enUS','I\'m too weak to fight with you.  Please find my friends.','I\'m too weak to fight with you.  Please find my friends.',26124),
(20147,'enUS','Extinguishing','Extinguishing',26124),
(20148,'enUS','It feels good to walk about and stretch all four limbs. Is there something I can help you with, $c?','',26124),
(20149,'enUS','The Felsworn Gas Mask was destroyed, do you have another one?','The Felsworn Gas Mask was destroyed, do you have another one?',26124),
(20150,'enUS','Greetings, $c.  If I might be so bold, may I remind you that -- while I attune myself to the magics of Hellfire Citadel -- there will undoubtedly be Hellfire wardens biting at my proverbial heels!$B$BSo, do be an upstanding member of your Horde and play the part of the hero... and protect me!','',26124),
(20151,'enUS','','Mordenaku... Your allies have saved us and destroyed the wretch, Zuluhed. Forever they will be a friend to the Netherwing.',26124),
(20152,'enUS','','In time, we will again require the assistance of the mortals. Across this world our birthright is shattered. It will be the mortal races that help us regain our rightful place on Draenor. Watch over them, Mordenaku...',26124),
(20153,'enUS','','Farewell, mortal. We are forever indebted to you.\n',26124),
(20154,'enUS','Thank you for allowing me to visit, $n.  You have a very colorful soul, but it\'s a little brighter than I prefer... or I might have stayed longer!','',26124),
(20155,'enUS','You have saved us from a fate far worse than death, $n.  You have the eternal gratitude of the Mok\'Nathal ancestors.','You have saved us from a fate far worse than death, $n.  You have the eternal gratitude of the Mok\'Nathal ancestors.',26124),
(20156,'enUS','Who dares slay one of my Kargath\'s commanders?  You will pay for this... in flesh!','',26124),
(20157,'enUS','%s points to the sky above.','',26124),
(20158,'enUS','You\'re free, Millhouse. Get out of here!','You\'re free, Millhouse. Get out of here!',26124),
(20159,'enUS','You are not powerful enough to undergo the trial of the naaru. Return to me when you are stronger.','',26124),
(20160,'enUS','Speak, filthy refugee!  What was your caravan doing in the Bone Wastes?','Speak, filthy refugee!  What was your caravan doing in the Bone Wastes?',26124),
(20161,'enUS','Let us leave this place.  I\'ve had enough of these madmen!','',26124),
(20162,'enUS','Beware!  More cultists come!','',26124),
(20163,'enUS','I can find my way from here.  My friend Mekeda will reward you for your kind actions.','',26124),
(20164,'enUS','You\'ll go nowhere, fool!','You\'ll go nowhere, fool!',26124),
(20165,'enUS','You will not escape us so easily!','You will not escape us so easily!',26124),
(20166,'enUS','','Incompetent fools!  Auchindoun should\'ve been ours... look at yourselves scrambling like rats!',26124),
(20167,'enUS','The search for my people.  Our struggle against the Alliance.  The war with the ogres and their gronn masters.$B$BAll of these things weigh heavy upon my shoulders, $c.$B$BEven I can use some help from time to time.','',26124),
(20168,'enUS','The wyvern drops a black drake corpse on the ground.','',26124),
(20169,'enUS','Auchindoun is home to my ancestor\'s spirits.  We might not look it, but all Broken were once draenei... our spirits are all the same.','',26124),
(20170,'enUS','Tell her to use the druids for that!','',26124),
(20171,'enUS','If they will not bend the knee, then she is to see to it that they are destroyed!','',26124),
(20172,'enUS','I did not sanction their actions.  Tell her to deal with it.','',26124),
(20173,'enUS','Very well, but make certain she knows that the blackwhelps are to be captured first.','',26124),
(20174,'enUS','Must I tell her every little thing to do?  I have larger issues of my own to deal with here.','',26124),
(20175,'enUS','Hello, little one.  What news do you bring?','',26124),
(20176,'enUS','Tell her that I don\'t want to be connected with it at this time.  The Cenarion Expedition should be more than happy to rid themselves of them.','',26124),
(20177,'enUS','No.  Inform her that I\'m still searching for the prophesied one that is to assist me in the battle.  There are very few promising candidates.','',26124),
(20178,'enUS','%s inspects the talisman $n gave him...','',26124),
(20179,'enUS','Ah, this was from Private Denning.  I remember when he fell...','',26124),
(20180,'enUS','This one was from Corporal Stonewell... he died protecting a field hospital...','',26124),
(20181,'enUS','Ah, yes... Private Guarding.  He always was quick to laugh... until a Bleeding Hollow Raid tore out his throat!','',26124),
(20182,'enUS','This insignia is from Sergeant Rantack, once my superior.  You\'d never find a tougher soldier than old Rantack...','',26124),
(20183,'enUS','%s faces the Bleeding Hollow fort of Zeth\'Gor...','',26124),
(20184,'enUS','Damn you!  Damn all of you bleeding fel orcs!  May your souls rot in the belly of whatever Dark Power that fuels you!','',26124),
(20185,'enUS','The Deathforge is run by the Shadow Council, under the watchful eye of the Legion.','',26124),
(20186,'enUS','','Hi there, cutey!  Do me a favor... ask the Baron what he wants me to do about you know what.',26124),
(20187,'enUS','Below is the aptly named Deathforge. If left to their own devices, the Shadow Council would supply the Legion with an endless stream of infernals.','',26124),
(20188,'enUS','','Tell him that they have refused his \'offer\'.',26124),
(20189,'enUS','','Deal with them?  How am I supposed to deal with them?',26124),
(20190,'enUS','','Right.  We, uh, need to... examine... those blackwhelps.',26124),
(20191,'enUS','','Ask him how he wants to proceed, then come right back!',26124),
(20192,'enUS','','What does the baron want?',26124),
(20193,'enUS','','Tell him that our Cenarion friends have been most helpful.',26124),
(20194,'enUS','','Has he found the one, yet?',26124),
(20195,'enUS','Energy. Power. My people are addicted to it... a dependence made manifest after the Sunwell was destroyed. Welcome to the future. A pity you are too late to stop it. No one can stop me now! Selama ashal\'anore!','',26124),
(20198,'enUS','Let us see how you fare when your world is turned upside down.','',26124),
(20199,'enUS','Having trouble staying grounded?','',26124),
(20200,'enUS','By the power of the sun!','',26124),
(20201,'enUS','Anar\'anel belore!','',26124),
(20202,'enUS','Obey me!','',26124),
(20203,'enUS','Bow to my will!','',26124),
(20204,'enUS','You will not prevail!','',26124),
(20205,'enUS','You gambled. And lost.','',26124),
(20206,'enUS','This was child\'s play.','',26124),
(20207,'enUS','For... Quel\'...Thalas!','',26124),
(20208,'enUS','I have not come this far to be stopped! The future I have planned will not be jeopardized! Now you will taste true power!!','',26124),
(20209,'enUS','We know that the wyrmcultists are massing on the other side of the tunnel.  We\'ll make our stand here.','',26124),
(20210,'enUS','','You may want to take cover. ',26124),
(20211,'enUS','%s\'s eyes glaze over as the effects of the wand take over his mind.','',26124),
(20212,'enUS','The magic of the wand appears to take hold on %s, but then it fades.','',26124),
(20213,'enUS','Not work so good for not birdies!','',26124),
(20214,'enUS','','What a bunch of rabble!',26124),
(20215,'enUS','It\'s a good thing I was able to make duplicates of the Felsworn Gas Mask.','',26124),
(20216,'enUS','','Don\'t let them through!  Look, over there!',26124),
(20217,'enUS','','Maxnar is going to have my hide if we don\'t get this assault underway soon!',26124),
(20218,'enUS','','Has anyone seen the overseer?',26124),
(20219,'enUS','','You there!  What do you think you\'re doing?!',26124),
(20220,'enUS','','Well, are we going to attack, or are we just going to mill about all day?',26124),
(20221,'enUS','','Someone tell those fools to stay back.  They\'re getting slaughtered when they go over there alone!',26124),
(20222,'enUS','','There\'s a druid stealthing around in his cat-form.  I thought that we had hunters in here.  Deal with it!',26124),
(20223,'enUS','','Welcome, $n. My expertise is in the art of working with primal mooncloth. Tailors interested in becoming mooncloth specialists often ask me to teach them our ways.',26124),
(20224,'enUS','','I\'m afraid there is little I can teach you, $c. You\'re free to browse my wares, of course, but you will not find them of use to you.',26124),
(20225,'enUS','Show me what you have for sale.','Show me what you have for sale.',26124),
(20226,'enUS','','Pleased to meet you! I\'m Gidge, the resident spellfire tailoring expert here in Shattrath. Not that there\'s any competition, but if you\'re interested in learning to be a spellfire tailor and haven\'t settled on a specialization, I can help.',26124),
(20227,'enUS','','If you\'re not a tailor, I don\'t think any of my patterns will interest you, but you\'re welcome to browse!',26124),
(20228,'enUS','If you\'re seeking patterns or knowledge about shadoweave tailoring, I\'d be happy to help you.','',26124),
(20229,'enUS','I\'m sorry, $c, but my wares are best suited to those who know which end of the needle the thread goes through.$B$BI can assure you, tailoring is about far more than monogramming handkerchiefs.','',26124),
(20230,'enUS','A\'dal, I have lost the key to Tempest Keep and require a replacement.','A\'dal, I have lost the key to Tempest Keep and require a replacement.',26124),
(20231,'enUS','I cannot allow you to interfere!','',26124),
(20232,'enUS','Show me what you have for sale.','Show me what you have for sale.',26124),
(20233,'enUS','I will purge you from this place!','',26124),
(20234,'enUS','You are no better than they!','',26124),
(20235,'enUS','They have forced me to this....','',26124),
(20236,'enUS','I had no choice.','',26124),
(20237,'enUS','I wish to become a shadoweave tailoring expert. Can you teach me?','I wish to become a shadoweave tailoring expert. Can you teach me?',26124),
(20238,'enUS','I am... released.','',26124),
(20239,'enUS','You... are the disease... not I...','',26124),
(20240,'enUS','I wish to be a mooncloth tailoring specialist. Can you teach me?','I wish to be a mooncloth tailoring specialist. Can you teach me?',26124),
(20241,'enUS','I wish to become a spellfire tailoring specialist. Can you teach me?','I wish to become a spellfire tailoring specialist. Can you teach me?',26124),
(20242,'enUS','I would be grateful for any aid you can provide, Priestess.','I would be grateful for any aid you can provide, Priestess.',26124),
(20243,'enUS','','These Tears of the Goddess have been blessed by Elune, and their power will help you combat Archimonde\'s vile magics. Use their power well.',26124),
(20244,'enUS','They fear my words. They make an example out of me. A mockery of the one true god, Neptulon.$B$B<Skar\'this spits.>$B$BRetribution comesss, mortal. The glorious hand of the Tidehunter will one day sweep through the non-believers like a scythe against a new harvest.','',26124),
(20245,'enUS','These wastes are scarred by terrible magic.  We must do what we can to heal this great wound.','',26124),
(20246,'enUS','*WARNING!* You can only select one tailoring specialization.','*WARNING!* You can only select one tailoring specialization.',26124),
(20247,'enUS','*WARNING!* You can only select one tailoring specialization.\n','*WARNING!* You can only select one tailoring specialization.',26124),
(20248,'enUS','*WARNING!* You can only select one tailoring specialization.','*WARNING!* You can only select one tailoring specialization.',26124),
(20249,'enUS','These refugees have suffered greatly and they will no doubt suffer more.  You have already helped them and for that I thank you.  If you have done all you can for now then I would beg a small favor.  ','',26124),
(20251,'enUS','Death\'s Door is a portal that opens upon the world that the Burning Legion uses to breed their fel hounds and other canine-like terrors.  Any time that you see one of those creatures, that is where it came from, and it passes through here, first.$B$BLately, we became aware that the Burning Legion have ramped up their summoning of these creatures through the portal.$B$BYou must shut down Death\'s Door before it becomes an inexorable tide, and all is lost!','Death\'s Door is a portal that opens upon the world that the Burning Legion uses to breed their fel hounds and other canine-like terrors.  Any time that you see one of those creatures, that is where it came from, and it passes through here, first.$B$BLately, we became aware that the Burning Legion have ramped up their summoning of these creatures through the portal.$B$BYou must shut down Death\'s Door before it becomes an inexorable tide, and all is lost!',26124),
(20252,'enUS','I came to this land to cleanse troubled spirits, but after the attack I fear that my mission has failed.  So many have been taken by the wastes.  Please, you must help them.','',26124),
(20253,'enUS','','Long ago the Shadow Council tried to perform a dark ritual inside Auchindoun.  Their failure created the waste you see around you.  The bones and the spirits of the fallen Draenei now haunt this land.  I was sent to cleanse the tombs of my ancestors, but with so many dangers I must remain here to protect the refugees.',26124),
(20254,'enUS','%s squawks and heads toward Veil Shalas. Hurry and follow!','',26124),
(20255,'enUS','%s pauses briefly before the tree and then heads inside.','',26124),
(20256,'enUS','%s seems to be looking for something. He wants you to follow.','',26124),
(20257,'enUS','%s flies to the platform below! You\'d better jump if you want to keep up. Hurry!','',26124),
(20258,'enUS','Me like soft bacon!','',26124),
(20259,'enUS','Me keep piggy as pet!','',26124),
(20260,'enUS','May the Light guide you, $n.','',26124),
(20261,'enUS','Misha lets out a loud roar as she rakes her claws against the gronn\'s altar.','',26124),
(20262,'enUS','Who dares defile the altar of Gorgrom the Dragon-Eater?','',26124),
(20263,'enUS','It is with solemn pride that I perform my services in Honor Hold.','',26124),
(20264,'enUS','I will crush it and flay it and eat its meat and crack its bones one by one when I am done.','',26124),
(20265,'enUS','How may I assist you, $n?','How may I assist you, $n?',26124),
(20266,'enUS','More Minions of Terokk are coming!','',26124),
(20267,'enUS','The invaders persist! Hold them off!','',26124),
(20268,'enUS','An Avatar of Terokk!! To arms!','',26124),
(20269,'enUS','We have taken too long. Terokk reigns victorious.','',26124),
(20270,'enUS','The Avatar of Terokk has been defeated! Death to Terokk! Death to Skettis!','',26124),
(20271,'enUS','Yes! Feel the might of the booterang!','',26124),
(20272,'enUS','Farewell, $n.','Farewell, $n.',26124),
(20273,'enUS','I must leave.  Proceed with caution.','I must leave.  Proceed with caution.',26124),
(20274,'enUS','Until we meet again.','Until we meet again.',26124),
(20275,'enUS','I must go now.  Good luck.','I must go now.  Good luck.',26124),
(20276,'enUS','The wind calls to me.','The wind calls to me.',26124),
(20277,'enUS','There is something that I must attend to.','There is something that I must attend to.',26124),
(20278,'enUS','Luckily, I was nearby.  How can I help?','Luckily, I was nearby.  How can I help?',26124),
(20279,'enUS','You called?','You called?',26124),
(20280,'enUS','Let us see if together we can figure out what next to do.','Let us see if together we can figure out what next to do.',26124),
(20281,'enUS','Hello.','Hello.',26124),
(20282,'enUS','I\'ve been circling nearby in case you needed to speak.','I\'ve been circling nearby in case you needed to speak.',26124),
(20283,'enUS','Skywing, I will free you from your curse over my dead body!','',26124),
(20284,'enUS','%s bellows a loud squawk!','',26124),
(20285,'enUS','My eyebrows! You singed my eyebrows!','',26124),
(20286,'enUS','Don\'t worry. It\'s an improvement!','',26124),
(20287,'enUS','I\'ve trained as an alchemist once again.  I wish to specialize in potions.','I\'ve trained as an alchemist once again.  I wish to specialize in potions.',26124),
(20288,'enUS','','When I first set up my rogue academy in Shattrath, it wasn\'t nearly this crowded. Then, the refugees started flooding in and the naaru needed every available building to house them.$B$BI\'ve closed the doors to my academy for now, but it\'s not permanent. I\'ll find a new place to set up.$B$BThen, a new generation of rogues will learn such staples as the gouge\'n grin, combat looting, and blaming someone else for breaking polymorph. And who can forget the central rule of roguery --- real rogues don\'t feint.',26124),
(20289,'enUS','I\'ve trained as an alchemist once again.  I wish to specialize in elixirs.','I\'ve trained as an alchemist once again.  I wish to specialize in elixirs.',26124),
(20290,'enUS','I am Zarevhi of the Consortium.  My skills as a transmuter are known in a thousand worlds.','',26124),
(20291,'enUS','','The trick to using evasion is realizing that the best fifteen seconds of your life are often the last.',26124),
(20292,'enUS','I\'ve trained as an alchemist once again.  I wish to specialize in transmutations.','I\'ve trained as an alchemist once again.  I wish to specialize in transmutations.',26124),
(20293,'enUS','','Swords, claws, daggers, of course -- I\'ve trained rogues in the use of them all. Now maces, I won\'t touch maces and I won\'t instruct any rogue who gets it in his head to wield one.$B$BThere\'s nothing stealthy about a mace. You\'re in for a noisy kill and a long cleanup if you go that route.',26124),
(20294,'enUS','','My early classes are always filled with bright-eyed young lads. Few make it past the first test, though.$B$BI\'ve given up on shouting, \'when I yell vanish, you need to vanish.\' They never listen. Now, the test simply kills the inept.',26124),
(20295,'enUS','Free at last from that horrible curse! Thank you! Please send word to Rilak the Redeemed that I am okay. My mission lies in Skettis. Terokk must be defeated!','',26124),
(20296,'enUS','','Never leave home without ample supplies of flash powder, especially when working with others. I guarantee someone will run out every time.$B$BWhen the choice comes down to handing out materials or letting the poor sap die, I help... most of the time.',26124),
(20297,'enUS','%s wanders off into the distance.','',26124),
(20298,'enUS','You have brought me back too soon! I am weak yet... What is this! Who... It matters not! DIE!','You have brought me back too soon! I am weak yet... What is this! Who... It matters not! DIE!',26124),
(20299,'enUS','Wildlord, I seem to have lost my druid signal.','Wildlord, I seem to have lost my druid signal.',26124),
(20300,'enUS','Very well, here is your replacement.','',26124),
(20301,'enUS','Vengeance will not be yours, $n!','',26124),
(20302,'enUS','I heard that your dog Fei Fei took Klatu\'s prayer beads...','I heard that your dog Fei Fei took Klatu\'s prayer beads...',26124),
(20303,'enUS','','Oh, no!  My Fei Fei would never take someone else\'s things!  He\'s a good dog... he just needs attention sometimes.  If you give him a treat, then you see!',26124),
(20304,'enUS','%s begins to moan.','',26124),
(20306,'enUS','<back>','<back>',26124),
(20307,'enUS','%s uses the key to open the cage.','',26124),
(20308,'enUS','AAAAEEEEEEIIIIIIII!!!!','',26124),
(20309,'enUS','AHHHH-YAAA-YAAA-YAAA!!!','',26124),
(20310,'enUS','AWOOOOGAAAA!','',26124),
(20311,'enUS','AYYAYAAYAA!','',26124),
(20312,'enUS','%s digs in the dirt...','',26124),
(20313,'enUS','%s buries his treat!','',26124),
(20314,'enUS','Aright, listen up! Form a circle around me and move out!','',26124),
(20315,'enUS','%s sniffs around, unsatisfied with this hiding spot.','',26124),
(20316,'enUS','%s looks for a hiding spot...','',26124),
(20317,'enUS','Who dares rouse Goc from his restful slumber?','',26124),
(20318,'enUS','I am Rexxar, son of the Mok\'Nathal, champion of the Horde.','',26124),
(20319,'enUS','And their torment at your hands is at an end. By my name, I shall put an end to your life.','',26124),
(20320,'enUS','Prepare yourself for the end.','',26124),
(20321,'enUS','Your name is as insignificant to me as the names of the thousands who have died under the might of Goc.  I will crush you and $n!','',26124),
(20323,'enUS','It\'s only right that you know the name of the one who will take your life.','',26124),
(20324,'enUS','Baron Sablemane. It will be on your lips as you gasp your dying breath.','',26124),
(20325,'enUS','Let us begin.','',26124),
(20326,'enUS','I could not have achieved this victory without you. We will speak back at Thunderlord Stronghold.','',26124),
(20327,'enUS','We will speak again, but away from here.','',26124),
(20328,'enUS','Aright, $r, just keep us safe from harm while we work. We\'ll pay you when we return.','',26124),
(20329,'enUS','The dig site is just north of here.','',26124),
(20330,'enUS','We\'re here! Start diggin\'!','',26124),
(20331,'enUS','I think there\'s somethin\' buried here, beneath the sand!','',26124),
(20332,'enUS','Almost got it!','',26124),
(20333,'enUS','By Brann\'s brittle bananas! What is it!? It... It looks like a drum.','',26124),
(20334,'enUS','Wow... a drum.','Wow... a drum.',26124),
(20335,'enUS','This discovery will surely rock the foundation of modern archaeology.','This discovery will surely rock the foundation of modern archaeology.',26124),
(20336,'enUS','Yea, great. Can we leave now? This desert is giving me hives.','Yea, great. Can we leave now? This desert is giving me hives.',26124),
(20337,'enUS','Have ye gone mad? You expect me to leave behind a drum without first beatin\' on it? Not this son of Ironforge! No sir!','',26124),
(20338,'enUS','Here goes!','',26124),
(20339,'enUS','This reminds me of that one time where you made us search Silithus for evidence of sand gnomes.','This reminds me of that one time where you made us search Silithus for evidence of sand gnomes.',26124),
(20340,'enUS','Or that time when you told us that you\'d discovered the cure for the plague of the 20th century. What is that even? 20th century?','Or that time when you told us that you\'d discovered the cure for the plague of the 20th century. What is that even? 20th century?',26124),
(20341,'enUS','I used to amuse myself by accepting challenges from anyone who would offer them, but I\'ve long since grown tired of such easy victories.$B$BFor now, I\'m taking some time to get my reagent business off the ground and write a book about my experiences in Twilight\'s Hammer.','',26124),
(20342,'enUS','I don\'t think it can top the one time where he told us that he\'d heard that Arthas\'s \"cousin\'s\" skeleton was frozen beneath a glacier in Winterspring. I\'ll never forgive you for that one, Letoll. I mean honestly... Arthas\'s cousin?','I don\'t think it can top the one time where he told us that he\'d heard that Arthas\'s \"cousin\'s\" skeleton was frozen beneath a glacier in Winterspring. I\'ll never forgive you for that one, Letoll. I mean honestly... Arthas\'s cousin?',26124),
(20343,'enUS','I dunno. It can\'t possibly beat the time he tried to convince us that we\'re all actually a figment of some being\'s imagination and that they only use us for their own personal amusement. That went over well during dinner with the family.','I dunno. It can\'t possibly beat the time he tried to convince us that we\'re all actually a figment of some being\'s imagination and that they only use us for their own personal amusement. That went over well during dinner with the family.',26124),
(20344,'enUS','Shut yer yaps! I\'m gonna bang on this drum and that\'s that!','',26124),
(20345,'enUS','I won\'t challenge you, but I\'d like to see your wares.','I won\'t challenge you, but I\'d like to see your wares.',26124),
(20346,'enUS','Say, do you guys hear that?','Say, do you guys hear that?',26124),
(20347,'enUS','Seems like we\'ve been working on this roof forever.','',26124),
(20348,'enUS','IN YOUR FACE! I told you there was somethin\' here!','',26124),
(20349,'enUS','You would think we would be finished mending this roof by now.','',26124),
(20350,'enUS','It\'s like the more I hammer, the bigger this hole gets.','',26124),
(20351,'enUS','Pick up the pace, boys. We\'re not making any progress here.','',26124),
(20352,'enUS','I think we\'re running out of nails.','',26124),
(20353,'enUS','','I\'m only 4 years old.',26124),
(20354,'enUS','All work and no play makes... I\'ll just shut up and keep hammering.','',26124),
(20355,'enUS','','Have you seen my mommy and daddy?',26124),
(20356,'enUS','I hear there are great wars being fought in Outland. I wonder if there\'s any rooftops up there that need fixing...','',26124),
(20357,'enUS','','Antelarion, is it safe to play in the forest yet?',26124),
(20358,'enUS','','I think I came from Eng-land, do you know where that is?',26124),
(20359,'enUS','I wonder what made a hole in the roof of the Inn in the first place. See what happens when you drop a copper piece off of the edge of Outland?','',26124),
(20360,'enUS','','Antelarion says I fell off a big bird, as I fell he caught me... He is so pretty!',26124),
(20361,'enUS','Don\'t just stand there! Help $g him:her; out!','',26124),
(20362,'enUS','%s picks up the drum.','',26124),
(20363,'enUS','You\'ve been a tremendous help, $r! Let\'s get out of here before more of those things show up! I\'ll let Dwarfowitz know you did the job asked of ya\' admirably.','',26124),
(20364,'enUS','I have enough strength left to stand and fight.  Prepare yourself.','',26124),
(20365,'enUS','WHAT?!  Who dares to disturb the Burning Legion?','',26124),
(20366,'enUS','Prepare yourself for eternal torture, mortal!','',26124),
(20367,'enUS','Nothing will prevent your doom!','',26124),
(20368,'enUS','I shall enjoy the smell of the grease from your marrow crackling over the fire!','',26124),
(20369,'enUS','You DARE to attack me?!','',26124),
(20370,'enUS','You will suffer slowly until the end of time for this affront!','',26124),
(20371,'enUS','%s gathers the warp chaser\'s blood.','',26124),
(20372,'enUS','Enough of this!  Now I call upon the fury of the cosmos itself.','Enough of this!  Now I call upon the fury of the cosmos itself.',26124),
(20373,'enUS','I become ONE... with the VOID!','I become ONE... with the VOID!',26124),
(20374,'enUS','This one seems a little weak still.','',26124),
(20375,'enUS','This one should make a fine mount someday.','',26124),
(20376,'enUS','Bring this whelp more food!','',26124),
(20377,'enUS','Grow big and strong my precious.','',26124),
(20378,'enUS','You will help restore the Dragonmaw Clan to their former glory.','',26124),
(20379,'enUS','Your father destroyed my children and left their bodies impaled upon the rocky blades at Dragons\' End.  For this, you will die!  Enough of this farce.  Prepare to face my full wrath!','',26124),
(20380,'enUS','%s begins emanating immense power.','',26124),
(20381,'enUS','Who dares place this affront upon the altar of Goc?','',26124),
(20382,'enUS','You hear the sound of beating wings from high up in the canyon as Rexxar approaches.','You hear the sound of beating wings from high up in the canyon as Rexxar approaches.',26124),
(20383,'enUS','Alchemy Lab','Alchemy Lab',26124),
(20384,'enUS','Our resident alchemist Lorokeem brought his equipment with him, in fact. It may be slightly different from what you\'re used to - he is an arakkoa, after all - but it should serve your needs. He roosts in the northwest portion of the lower city.','Our resident alchemist Lorokeem brought his equipment with him, in fact. It may be slightly different from what you\'re used to - he is an arakkoa, after all - but it should serve your needs. He roosts in the northwest portion of the lower city.',26124),
(20385,'enUS','Gem Merchant','Gem Merchant',26124),
(20386,'enUS','There are two gem merchants in residence: one works closely with the Scryers, and the other is loyal to the Aldor. Whom do you seek?','There are two gem merchants in residence: one works closely with the Scryers, and the other is loyal to the Aldor. Whom do you seek?',26124),
(20388,'enUS','Aldor Gem Merchant','Aldor Gem Merchant',26124),
(20389,'enUS','Inessera is a sharp woman who carries various gems as well as jewelcrafting supplies. You can find her shop in the northern part of Aldor Rise.','Inessera is a sharp woman who carries various gems as well as jewelcrafting supplies. You can find her shop in the northern part of Aldor Rise.',26124),
(20390,'enUS','Scryer Gem Merchant','Scryer Gem Merchant',26124),
(20391,'enUS','Lisrythe may be a bit... intimidating at first, but she stocks what you\'re looking for. She sells her wares in the eastern portion of Scryer\'s Tier.','Lisrythe may be a bit... intimidating at first, but she stocks what you\'re looking for. She sells her wares outside the large library on Scryer\'s Tier.',26124),
(20392,'enUS','<The construct gestures to the eastern portion of the Tier.>','',26124),
(20393,'enUS','I\'m not about to train you until you prove yourself a friend to the draenei of the Exodar.','I\'m not about to train you until you prove yourself a friend to the draenei of the Exodar.',26124),
(20394,'enUS','I\'m not about to train you until you\'re exalted in the eyes of the draenei.','I\'m not about to train you until you\'re exalted in the eyes of the draenei.',26124),
(20395,'enUS','Release the hounds!','',26124),
(20396,'enUS','I am ready, Anchorite.  Let us begin the exorcism.','I am ready, Anchorite.  Let us begin the exorcism.',26124),
(20397,'enUS','Oh, thank you!  The pit of blackness inside of me has been lifted!  I can see again... and I see the face of my savior!','',26124),
(20398,'enUS','Be gone, $c!  Leave us be, or we will enter you next and show you true despair!','',26124),
(20400,'enUS','It is time.  The rite of exorcism will now commence...','',26124),
(20401,'enUS','Prepare yourself.  Do not allow the ritual to be interrupted or we may lose our patient...','',26124),
(20402,'enUS','Keep away. The fool is mine.','',26124),
(20403,'enUS','Be cleansed with Light, human!  Let not the demonic corruption overwhelm you.','',26124),
(20404,'enUS','Back, foul beings of darkness!  You have no power here!','',26124),
(20405,'enUS','The power of Light compels you!  Back to your pit!','',26124),
(20406,'enUS','In the name of the Light! It is Light that commands you! It is Light that flung you to the depths of darkness! ','',26124),
(20407,'enUS','I... must not...falter!','',26124),
(20408,'enUS','The Light is my guide... it is my sustenance!','',26124),
(20409,'enUS','You cannot deceive me, demon!  Your strength wanes just as my faith bolsters!','',26124),
(20410,'enUS','You... will... leave... this... man!','',26124),
(20411,'enUS','Give us time... Let the man die... I am no one... I am no one... Fear the anchorite... Fear the anchorite... Barada... Barada.','',26124),
(20412,'enUS','No!  Not yet!  This soul is ours!','',26124),
(20413,'enUS','You will not succeed, mortal!  This shell will lie decrepit, blistered and bleeding before I am done with it.  And its spirit will be long cast into darkness.','',26124),
(20414,'enUS','Ah!  Cease the incantations, Anchorite!  Cease, or I will show you such pain that your pathetic people have never imagined!','',26124),
(20415,'enUS','I see your ancestors, Anchorite!  They writhe and scream in the darkness... they are with us!','',26124),
(20416,'enUS','This is fruitless, draenei!  You and your little helper cannot wrest control of this pathetic human.  He is mine!','',26124),
(20417,'enUS','I will tear your soul into morsels and slow roast them over demon fire!','',26124),
(20418,'enUS','All is lost, Anchorite!  Abandon what hope remains.','',26124),
(20419,'enUS','Back!  I cast you back... corrupter of faith!  Author of pain!  Do not return, or suffer the same fate as you did here today!','',26124),
(20420,'enUS','Debug Error: Couldn\'t find a target!','',26124),
(20421,'enUS','I cast you out! Unclean Spirit!','',26124),
(20422,'enUS','Be gone... from this creature of Light! \n','',26124),
(20423,'enUS','Be gone! In the Name of the Light, the Goodness, and the All that is Just!','',26124),
(20424,'enUS','Don\'t worry.  Shatter Point is as sturdy as they come!  But just in case, be ready to jump on a gryphon if the base starts to break apart...','',26124),
(20425,'enUS','Now that you have bested me, test your skills against each other!  Take control of either king to begin play.','',26124),
(20426,'enUS','facing $n.','',26124),
(20427,'enUS','A\'dal, I am ashamed to say that I have somehow misplaced the key to the Arcatraz.','A\'dal, I am ashamed to say that I have somehow misplaced the key to the Arcatraz.',26124),
(20428,'enUS','<The chime of A\'dal\'s voice echoes reassuringly through your mind.>$B$BWorry not, child.  Look in your pack and you will find it once more.','',26124),
(20429,'enUS','You wish to speak to me, $r?','',26124),
(20430,'enUS','The halls of Karazhan shake, as the curse binding the doors of the Gamesman\'s Hall is lifted.','',26124),
(20431,'enUS','I have seen many dangers in these wastes.  Who knows what creatures yet lurk in the dust to ambush the unwary?','',26124),
(20432,'enUS','All of your efforts have been in vain, for the draining of the World Tree has already begun!  Soon the heart of your world will beat no more!','',26124),
(20433,'enUS','You do not have enough reputation with or have not pledged allegiance to The Aldor.','You do not have enough reputation with or have not pledged allegiance to The Aldor.',26124),
(20434,'enUS','You do not have enough reputation with or have not pledged allegiance to The Scryers.','You do not have enough reputation with or have not pledged allegiance to The Scryers.',26124),
(20435,'enUS','At last I am released! Thank you, gentle $r. I must return to the expedition at once! They will know of your deeds. This I vow.','At last I am released! Thank you, gentle $r. I must return to the expedition at once! They will know of your deeds. This I vow.',26124),
(20436,'enUS','I will tell the tale of your heroics to Haramad myself! All Consortium will know your name, $n. Thank you, my friend.','',26124),
(20437,'enUS','','The Keepers of Time thank you for your assistance. The Timeless One shall be pleased with this outcome...',26124),
(20438,'enUS','What is this? Where am I? How... How did I... Cursed ethereals! I was on an escort mission out of Shattrath when we were ambushed! I must return to the city at once! Your name will be recorded as a friend of the Lower City, $n.','',26124),
(20439,'enUS','Blessed Light! Free of my confines at last... Thank you, hero. A\'dal will be told of your heroics.','Blessed Light! Free of my confines at last... Thank you, hero. A\'dal will be told of your heroics.',26124),
(20440,'enUS','$R save me! Thank you! My people thank you too!','',26124),
(20441,'enUS','Look into my eyes... Find your death within...','',26124),
(20442,'enUS','FREE! FREE TO DEVOUR ALL THAT STAND IN THE WAY OF LORD ILLIDAN!','',26124),
(20443,'enUS','The gateway of your oblivion has been opened! The blood tide rises.','',26124),
(20444,'enUS','A thousand and one ways that all spell out your demise!','',26124),
(20445,'enUS','WUT! DA KING IS BACK, BABY!','',26124),
(20446,'enUS','In Outland, lunch open prison for you! What a world! Time to eat!','',26124),
(20447,'enUS','Only flesh and blood...','',26124),
(20448,'enUS','For the Deceiver! For Kil\'jaeden!','',26124),
(20449,'enUS','','Death! Only death awaits!',26124),
(20450,'enUS','','Give us a kissss...',26124),
(20451,'enUS','','The conflicts in Outland are deadlier than any I have seen.  And their most tragic victims are the children that are left behind.$B$BNow, with the threat against Shattrath from the arakkoa of Skettis, there will be even more orphans to take care of.  These children often live without the hope of a bright future.$B$BBut you have the power to do something about that.  It\'s Children\'s Week, $c, and I implore you to volunteer to bring joy and wonder into a child\'s life.',26124),
(20452,'enUS','Children\'s Week is not yet over... may I have another Blood Elf Orphan Whistle?','Children\'s Week is not yet over... may I have another Blood Elf Orphan Whistle?',26124),
(20453,'enUS','Children\'s Week is not yet over... may I have another Draenei Orphan Whistle?','Children\'s Week is not yet over... may I have another Draenei Orphan Whistle?',26124),
(20454,'enUS','I\'m lonely.  I wish that there were more kids my age around here.  Sometimes I miss being at the orphanage in Shattrath City.','',26124),
(20455,'enUS','Thank you, $g sir : ma\'am;!  It was so great to get to speak with Salandria again!','',26124),
(20456,'enUS','','Are we there yet?',26124),
(20457,'enUS','','Hch\'uu!!!',26124),
(20458,'enUS','','Dornaa begins to examine the stone edifice, and then touches it.',26124),
(20459,'enUS','I am free!  But the secret... is now in peril.  Akama must be warned!','',26124),
(20460,'enUS','The naga came close to breaking my will... but the secret is still safe, thanks to you.','',26124),
(20461,'enUS','','Thank you for bringing me here to see my friend, Hch\'uu!',26124),
(20462,'enUS','','Why isn\'t the Outland called Draenor anymore?',26124),
(20463,'enUS','','Oh wow!',26124),
(20464,'enUS','','Is this where all of the adventurers come from?  Help me.',26124),
(20465,'enUS','','If the demons fell, where did they fall from?',26124),
(20466,'enUS','','Whoa, no way!',26124),
(20467,'enUS','','Salandria stands and gapes in awe at the immense Dark Portal.',26124),
(20469,'enUS','','By the Light!',26124),
(20470,'enUS','','Is the Twisting Nether shaped like a pretzel?  And just what is a Nether?  The orphan matron said I shouldn\'t ask people about their nethers.',26124),
(20471,'enUS','<Morthis glances skyward.>$B$BIn a way, I envy the freedom Rook and Corvax enjoy. To be free of earthbound responsibilities is a great blessing indeed.$B$BThe future will see me on wing once more, but first there\'s a task I must complete.','',26124),
(20472,'enUS','Nazan descends from the sky.','',26124),
(20473,'enUS','Gezhe has been really nice letting me come here to apprentice and learn all of this fun stuff, $g mister : ma\'am;.$B$B<Jheel hangs his head.>$B$BBut, I hate being away from my sister.','',26124),
(20474,'enUS','Thanks again for bringing my sister to visit me, $G Mr. : Miss; $n!','',26124),
(20475,'enUS','','Jheel!!!',26124),
(20476,'enUS','','Dornaa gives her brother a big hug, and the two children begin to talk.',26124),
(20477,'enUS','','I hope that Jheel will be able to come back to the orphanage soon.',26124),
(20478,'enUS','','Salandria and Hch\'uu begin to catch up on all that has happened to them this past year.',26124),
(20479,'enUS','Dornaa!!!','',26124),
(20480,'enUS','The Horde Flag was returned to its base by $n!','',26124),
(20481,'enUS','Salandria?  Salandria!!!','',26124),
(20482,'enUS','Back to your studies, boy!','',26124),
(20483,'enUS','Yes, sir.','',26124),
(20484,'enUS','','See you soon, big brother!',26124),
(20485,'enUS','','Hah, it\'s true!  I\'m gonna go have a closer look at the fire one!',26124),
(20486,'enUS','','Ow!  Hot!!',26124),
(20487,'enUS','','Dornaa walks slowly and turns in reverence as a blessing is bestowed upon her by O\'ros.',26124),
(20489,'enUS','','Tee hee, your mind-talk tickles.  Thank you, O\'ros!  I promise to be good!!',26124),
(20490,'enUS','Olum... old friend.  It is good to see that you are safe.','',26124),
(20491,'enUS','Illidan will become suspicious... that much is for certain.  We will deal with it as we always do.','',26124),
(20492,'enUS','You cannot... be serious, Olum.  Your sacrifice has already been too great.','',26124),
(20493,'enUS','It appears your mind is set then.  We will guide you to the spirit world with as much kindness as we can.','',26124),
(20494,'enUS','Farewell, dear friend. We shall meet you in the next world when our duties in this one are fulfilled.','',26124),
(20495,'enUS','Master!  We\'ve found the traitor who escaped Vashj!  His body lies in front of me... lifeless!','',26124),
(20496,'enUS','But, sire!  You have misjudged my actions... I do have knowledge of someone close to you who plans to betray you.  It is that dog, Kael\'thas!  He has allied with Kil\'jaeden and intends to replace you as Lord of Outland!','',26124),
(20497,'enUS','It will be done, my lord!','',26124),
(20498,'enUS','Akama, my friend!  Have you been informed?  I was found out by Vashj\'s followers.  Our secret is in peril!','',26124),
(20499,'enUS','Illidan will find me and when he does... he will pry the Ashtongue secret from me - such is the power of the Betrayer!  No... there is only one way.  My usefulness to the cause has come to an end. I must venture into the spirit world!','',26124),
(20500,'enUS','My decision is final.  I will not be dissuaded.  I have devoted my life to our plan.  To jeopardize it now would betray all who have died for the cause long before me.','',26124),
(20501,'enUS','I thank you, Akama.  You honor me by allowing me this moment, surrounded by my brothers.  Farewell, friend.  Guide our people well.','',26124),
(20502,'enUS','Illidan is looking for me.  I am not safe here... none of us are.','',26124),
(20503,'enUS','','Do you feel that?',26124),
(20504,'enUS','','Come on, let\'s go check it out!',26124),
(20505,'enUS','','It\'s just ahead!',26124),
(20506,'enUS','','Oh, wow, is that a naaru they\'re channeling from?  I feel funny....',26124),
(20507,'enUS','When you\'re done visiting this exotic city, perhaps you would be interested in celebrating with us. The Lunar Festival is underway in Moonglade; the other cities have transport to the festivities. Come and join the other revelers!','When you\'re done visiting this exotic city, perhaps you would be interested in celebrating with us. The Lunar Festival is underway in Moonglade; the other cities have transport to the festivities. Come and join the other revelers!',26124),
(20508,'enUS','','Wow, what a rush!',26124),
(20509,'enUS','','As if in a daze, Salandria moves toward whatever it is she is sensing.',26124),
(20510,'enUS','','Dornaa stands and gapes in awe at the immense Dark Portal.',26124),
(20511,'enUS','What are you doing here, $r?','',26124),
(20512,'enUS','%s kneels, filling the vial with water from the moonwell.','',26124),
(20513,'enUS','The potion is finished. I can only hope Clintar forgives us for interrupting his sojourn in the Emerald Dream.','',26124),
(20514,'enUS','','Salandria\'s jaw nearly hits the ground at the sight of Zaladormu.',26124),
(20515,'enUS','','Okay, I like!  Um... what\'s going on?  Save me!',26124),
(20516,'enUS','There are few left in the world who can prepare the Ward of Waking, $n. We are fortunate that I am among them.','',26124),
(20517,'enUS','%s combines the herbs with the moonwell water to create the Ward of Waking.','',26124),
(20518,'enUS','Aran has been defeated? Yes... I can sense his grip has loosened - if only just a little. But just enough to allow me to do my job as the doorman! Would you like me transport you to the Guardian\'s Library, $n?','',26124),
(20519,'enUS','Please transport me to the Guardian\'s Library.','Please transport me to the Guardian\'s Library.',26124),
(20520,'enUS','WAIT!','',26124),
(20521,'enUS','This girl has done nothing, and will not be held accountable for what she might do, or fail to do, in the future.','',26124),
(20522,'enUS','Go in peace, child.','',26124),
(20523,'enUS','%s snaps up to a kneeling position, but seems as though he\'s somewhere else.','',26124),
(20524,'enUS','What are you doing in Ysera\'s realm, interloper? Leave us, I say! Your kind are not welcome here!','',26124),
(20525,'enUS','%s gets to his feet, beginning to recognize his surroundings.','',26124),
(20526,'enUS','%s links with it\'s master, creating a spirit bond.','%s links with it\'s master, creating a spirit bond.',26124),
(20527,'enUS','','Dornaa\'s jaw nearly hits the ground at the sight of Zaladormu.',26124),
(20528,'enUS','','Wow, he\'s a big one!  Um... what\'s going on?  Save me!',26124),
(20529,'enUS','','It is good to see you again, $C $n.  Dornaa has been asking about you.',26124),
(20530,'enUS','','It is good to see you again, $C $n.  Salandria has been asking about you.',26124),
(20531,'enUS','','The conflicts in Outland are deadlier than any I have seen.  And their most tragic victims are the children that are left behind.$B$BNow, with the threat against Shattrath from the arakkoa of Skettis, there will be even more orphans to take care of.  These children often live without the hope of a bright future.',26124),
(20532,'enUS','They\'re following me, $r! Quickly, tell me why you\'re here before we\'re discovered! If they catch up to me, it will mean my death and yours!','',26124),
(20533,'enUS','%s grows sleepy.','',26124),
(20534,'enUS','I must return to my rest... they must not find me here... the Emerald Dream...','',26124),
(20535,'enUS','<The druid appears to be deep in sleep, oblivious to his surroundings.>','',26124),
(20536,'enUS','Attempt to wake Clintar.','Attempt to wake Clintar.',26124),
(20537,'enUS','I beg you, $r, be swift. They will not stop pursuing me! I cannot escape from them, even here!','',26124),
(20538,'enUS','You -- you\'re not one of them! Let\'s get out of sight before they find us! Hurry!','',26124),
(20539,'enUS','Stand back, $n. This may be an Ethereum trap.','',26124),
(20540,'enUS','%s uses the Ethereum prison key on the salvaged Ethereum prison.','',26124),
(20541,'enUS','The crossbow can be learned from Woo Ping, the human weapon master at Weller\'s Arsenal in Stormwind, Handiir, the draenei weapon master found in the Trader\'s Tier within the Exodar, or Bixi Wobblebonk, the gnome weapon master within the Timberline Arms in Ironforge.','The crossbow can be learned from Woo Ping, the human weapon master at Weller\'s Arsenal in Stormwind, Handiir, the draenei weapon master found in the Trader\'s Tier within the Exodar, or Bixi Wobblebonk, the gnome weapon master within the Timberline Arms in Ironforge.',26124),
(20542,'enUS','Commander... I am not long for this world... Taken to a holding pen... hundreds... thousands... beings from other worlds... Imprisoned... Imprisoned by Ethereum. Many of them our allies. Must... Must save the others... It... It\'s not too late...','',26124),
(20543,'enUS','','You\'re the man from my dream!',26124),
(20544,'enUS','Those fools! What have they done! What horrors do they hold? And for what purpose? I will need your help again, hero. Help us. Help your people.','',26124),
(20545,'enUS','Indeed I am, child.  And do you remember what you showed me in those dreams?','',26124),
(20546,'enUS','Ilyenia Moonfire, the night elf weapon master who resides at the Warrior\'s Terrace in Darnassus, can train you in the use of bows.','Ilyenia Moonfire, the night elf weapon master who resides at the Warrior\'s Terrace in Darnassus, can train you in the use of bows.',26124),
(20547,'enUS','','You mean, I can do it here, too?',26124),
(20548,'enUS','Try.','',26124),
(20549,'enUS','Amazing, Dornaa.  Truly amazing!','',26124),
(20550,'enUS','','I did it, I did it!!!',26124),
(20551,'enUS','Bixi Wobblebonk in this very shop can train ye in daggers. If ye\'re still looking abroad, anyone else - Woo Ping in Stormwind, Handiir in the Exodar, and Ilyenia Moonfire in Darnassus - can show ye a thing or two. Me, I was never one fer knife fights.','Bixi Wobblebonk in this very shop can train ye in daggers. If ye\'re still looking abroad, anyone else - Woo Ping in Stormwind, Handiir in the Exodar, and Ilyenia Moonfire in Darnassus - can show ye a thing or two. Me, I was never one fer knife fights.',26124),
(20552,'enUS','Ilyenia Moonfire, the night elf weapon master on the Warrior\'s Terrace in Darnassus, or Buliwyf, the dwarf weapon master within the Timberline Arms in Ironforge, can train you in the use of fist weapons.','Ilyenia Moonfire, the night elf weapon master on the Warrior\'s Terrace in Darnassus, or Buliwyf, the dwarf weapon master within the Timberline Arms in Ironforge, can train you in the use of fist weapons.',26124),
(20553,'enUS','','Concentrating a moment, Dornaa summons forth the elemental forces.',26124),
(20554,'enUS','The man to talk to about gunnery is Buliwyf, found in the Timberline Arms within Ironforge.','The man to talk to about gunnery is Buliwyf, found in the Timberline Arms within Ironforge.',26124),
(20555,'enUS','Buliwyf here will happily teach you everything there is to know about guns!','Buliwyf here will happily teach you everything there is to know about guns!',26124),
(20556,'enUS','I am here at the behest of Nexus-Prince Haramad. Strange things are afoot at the Stormspire.','',26124),
(20557,'enUS','','I\'m going to miss you so much, $n!  Promise that you\'ll come to see me.',26124),
(20558,'enUS','Please reset the chess board, we would like to play again.','Please reset the chess board, we would like to play again.',26124),
(20559,'enUS','A shadowy, sinister presence has invaded the Emerald Dream. Its power is poised to spill over into our world, $n. We must oppose it! That\'s why I cannot accompany you in person.','',26124),
(20560,'enUS','I will guide you to the location of the relics, but you must guard my spirit well. As the guardian of the relics, only I can break the seals on the reliquaries.','',26124),
(20561,'enUS','','I\'m going to miss you so much, $n!  Promise that you\'ll come to see me.',26124),
(20562,'enUS','A %s erupts into the waking world from the Emerald Dream!','',26124),
(20563,'enUS','That\'s the first relic, but there are still two more. Follow me, $n.','',26124),
(20564,'enUS','I\'ve recovered the second relic. Take a moment to rest, and then we\'ll continue to the last reliquary.','',26124),
(20565,'enUS','Foolish druid! Dividing your essence has weakened you, opening the door for my master to dominate the Emerald Dream. Your spirit and your body will die here!','',26124),
(20566,'enUS','%s hands the Relics of Aviana to Dreamwarden Lurosa.','',26124),
(20567,'enUS','Begone from this place!','',26124),
(20568,'enUS','The Emerald Dream will never be yours!','',26124),
(20569,'enUS','The dwarven weapon master Buliwyf can train you in both one and two-handed axes. He\'s found in the Timberline Arms in Ironforge.','The dwarven weapon master Buliwyf can train you in both one and two-handed axes. He\'s found in the Timberline Arms in Ironforge.',26124),
(20570,'enUS','There\'s no finer expert I know on axes than Buliwyf here! One hand, two hands... he\'s a master of it all!','There\'s no finer expert I know on axes than Buliwyf here! One hand, two hands... he\'s a master of it all!',26124),
(20571,'enUS','My pal Buliwyf here can show you how to use fist weapons... or, if you prefer, Ilyenia Moonfire - she\'s the night elf weapon master on the Warrior\'s Terrace in Darnassus - can show you, too!','My pal Buliwyf here can show you how to use fist weapons... or, if you prefer, Ilyenia Moonfire - she\'s the night elf weapon master on the Warrior\'s Terrace in Darnassus - can show you, too!',26124),
(20572,'enUS','My plucky companion Bixi Wobblebonk here can train ye in crossbows. If ye\'re looking for other trainers, though, ye might want to try Ilyenia Moonfire on the Warrior\'s Terrace in Darnassus, or maybe the draenei weapon master, Handiir, in the Trader\'s Tier within the Exodar.','',26124),
(20573,'enUS','Ilyenia Moonfire, the night elf weapon master who resides at the Warrior\'s Terrace in Darnassus, can show ye how to use a bow.','Ilyenia Moonfire, the night elf weapon master who resides at the Warrior\'s Terrace in Darnassus, can show ye how to use a bow.',26124),
(20574,'enUS','Both Handiir and Buliwyf can show you how to swing a mace properly, no matter the size. You can find Buliwyf within the Timberline Arms in Ironforge. Handiir spends his days in the Exodar, training draenei on the Trader\'s Tier.','Both Handiir and Buliwyf can show you how to swing a mace properly, no matter the size. You can find Buliwyf within the Timberline Arms in Ironforge. Handiir spends his days in the Exodar, training draenei on the Trader\'s Tier.',26124),
(20575,'enUS','Maces are a specialty of Buliwyf\'s! He\'s around this shop somewhere, grousing. If his training techniques aren\'t your style, I hear the draenei weapon master in the Exodar, Handiir, knows his way around the weapon too! He\'s up on the Trader\'s Tier there.','Maces are a specialty of Buliwyf\'s! He\'s around this shop somewhere, grousing. If his training techniques aren\'t your style, I hear the draenei weapon master in the Exodar, Handiir, knows his way around the weapon too! He\'s up on the Trader\'s Tier there.',26124),
(20576,'enUS','Woo Ping is the master of polearms. He trains his students at Weller\'s Arsenal in Stormwind.','Woo Ping is the master of polearms. He trains his students at Weller\'s Arsenal in Stormwind.',26124),
(20577,'enUS','Staves are taught by both Woo Ping, the master found at Weller\'s Arsenal in Stormwind, and Ilyenia Moonfire, who trains the night elves on the Warrior\'s Terrace in Darnassus.','Staves are taught by both Woo Ping, the master found at Weller\'s Arsenal in Stormwind, and Ilyenia Moonfire, who trains the night elves on the Warrior\'s Terrace in Darnassus.',26124),
(20578,'enUS','There are two masters of the sword: Handiir and Woo Ping. The former can be found in the Trader\'s Tier of the Exodar, and the latter in Weller\'s Arsenal within Stormwind.','There are two masters of the sword: Handiir and Woo Ping. The former can be found in the Trader\'s Tier of the Exodar, and the latter in Weller\'s Arsenal within Stormwind.',26124),
(20579,'enUS','Both Ilyenia Moonfire on the Warrior\'s Terrace of Darnassus and Bixi Wobblebonk of the Timberline Arms in Ironforge can show you how to use throwing weapons properly.','Both Ilyenia Moonfire on the Warrior\'s Terrace of Darnassus and Bixi Wobblebonk of the Timberline Arms in Ironforge can show you how to use throwing weapons properly.',26124),
(20580,'enUS','Axe','Axe',26124),
(20581,'enUS','Bow','Bow',26124),
(20582,'enUS','Crossbow','Crossbow',26124),
(20583,'enUS','Dagger','Dagger',26124),
(20584,'enUS','Fist Weapon','Fist Weapon',26124),
(20585,'enUS','Gun','Gun',26124),
(20586,'enUS','Mace','Mace',26124),
(20587,'enUS','Polearm','Polearm',26124),
(20588,'enUS','Staff','Staff',26124),
(20589,'enUS','Sword','Sword',26124),
(20590,'enUS','Thrown','Thrown',26124),
(20592,'enUS','Bixi here can teach ye how to lob throwin\' weapons.  If Darnassus is more yer speed, talk to Ilyenia Moonfire on the Warrior\'s Terrace there.','Bixi here can teach ye how to lob throwin\' weapons.  If Darnassus is more yer speed, talk to Ilyenia Moonfire on the Warrior\'s Terrace there.',26124),
(20593,'enUS','Are you with me, $n?','',26124),
(20594,'enUS','If you seek training in weapons, I can provide.','',26124),
(20595,'enUS','Ah, you wish to train abroad? I will direct you. Tell me which weapon has sparked your interest.','',26124),
(20596,'enUS','We have all three of the relics, but my energy is rapidly fading. We must make our way back to Dreamwarden Lurosa! He will let you know what to do next.','',26124),
(20597,'enUS','','Sooooo cute!!!',26124),
(20598,'enUS','','Awww.... Hello little baby!',26124),
(20599,'enUS','','They are so tiny.',26124),
(20600,'enUS','','Aww...',26124),
(20601,'enUS','Lurosa, I am entrusting the Relics of Aviana to $n, who will take them to Morthis Whisperwing. I must return completely to the Emerald Dream now. Do not let $n fail!','',26124),
(20602,'enUS','','Hmm... this one smells kinda funny.',26124),
(20603,'enUS','','What big eyes you have!',26124),
(20604,'enUS','','I don\'t remember ever being this small.',26124),
(20605,'enUS','','How adorable!',26124),
(20606,'enUS','Both Hanashi and Sayoc can train you in the use of one and two-handed axes. They can be found in the Valley of Honor in Orgrimmar.','Both Hanashi and Sayoc can train you in the use of one and two-handed axes. They can be found in the Valley of Honor in Orgrimmar.',26124),
(20608,'enUS','The weapon masters in the Valley of Honor within Orgrimmar, Sayoc and Hanashi, can teach you how to shoot a bow. Ileda, the weapon master of Silvermoon found in Farstrider Square, is also an expert.','The weapon masters in the Valley of Honor within Orgrimmar, Sayoc and Hanashi, can teach you how to shoot a bow. Ileda, the weapon master of Silvermoon found in Farstrider Square, is also an expert.',26124),
(20609,'enUS','Archibald is the master of the crossbow. He\'s the weapon master of the Undercity, located in the War Quarter.','Archibald is the master of the crossbow. He\'s the weapon master of the Undercity, located in the War Quarter.',26124),
(20610,'enUS','Dagger instruction can be sought from three weapon masters: Archibald in the War Quarter of the Undercity, Sayoc within the Valley of Honor in Orgrimmar, and Ileda in Silvermoon\'s Farstrider Square.','Dagger instruction can be sought from three weapon masters: Archibald in the War Quarter of the Undercity, Sayoc within the Valley of Honor in Orgrimmar, and Ileda in Silvermoon\'s Farstrider Square.',26124),
(20611,'enUS','Sayoc, da ugly orc here, teach you daggers. You want teaching in other places, you talk to Ileda in da Farstrider Square of Silvermoon or Archibald in the War Quarter of Undercity, hokay?','Sayoc, da ugly orc here, teach you daggers. You want teaching in other places, you talk to Ileda in da Farstrider Square of Silvermoon or Archibald in the War Quarter of Undercity, hokay?',26124),
(20612,'enUS','Fist weapons are taught by Sayoc, the orc weapon master in Orgrimmar. He spends his days in the Valley of Honor.','Fist weapons are taught by Sayoc, the orc weapon master in Orgrimmar. He spends his days in the Valley of Honor.',26124),
(20613,'enUS','You want to punch things, yah? Talk to Sayoc right here. He teach you.','You want to punch things, yah? Talk to Sayoc right here. He teach you.',26124),
(20614,'enUS','Our gunnery instructor is Ansekhwa, the tauren weapon master on the lower central rise of Thunder Bluff.','Our gunnery instructor is Ansekhwa, the tauren weapon master on the lower central rise of Thunder Bluff.',26124),
(20615,'enUS','Maces are taught by Ansekhwa, found on the lower central rise of Thunder Bluff.','Maces are taught by Ansekhwa, found on the lower central rise of Thunder Bluff.',26124),
(20616,'enUS','The Forsaken weapon master Archibald knows his way around the polearm. He trains others in the War Quarter of the Undercity. Ileda, the blood elf weapon master within Farstrider Square in Silvermoon, can show you the proper techniques also.','The Forsaken weapon master Archibald knows his way around the polearm. He trains others in the War Quarter of the Undercity. Ileda, the blood elf weapon master within Farstrider Square in Silvermoon, can show you the proper techniques also.',26124),
(20617,'enUS','Staves are taught by Hanashi, the troll weapon master in Orgrimmar\'s Valley of Honor, and Ansekhwa, the tauren weapon master who trains on the lower central rise of Thunder Bluff.','Staves are taught by Hanashi, the troll weapon master in Orgrimmar\'s Valley of Honor, and Ansekhwa, the tauren weapon master who trains on the lower central rise of Thunder Bluff.',26124),
(20618,'enUS','Hanashi here knows staves. If you want a sturdier instructor, go to Thunder Bluff. Ansekhwa will teach you on the lower central rise there.','',26124),
(20619,'enUS','Ileda of the blood elves, found within Farstrider Square of Silvermoon, trains her students in both one and two-handed swords. Archibald, Undercity\'s weapon master, can also train you; he is in the War Quarter.','Ileda of the blood elves, found within Farstrider Square of Silvermoon, trains her students in both one and two-handed swords. Archibald, Undercity\'s weapon master, can also train you; he is in the War Quarter.',26124),
(20620,'enUS','Sayoc and Hanashi, Orgrimmar\'s weapon masters, are true artisans of the thrown weapon. They train willing students in the Valley of Honor. For pure finesse in the art, however, Ileda of Silvermoon\'s Farstrider Square cannot be beaten.','Sayoc and Hanashi, Orgrimmar\'s weapon masters, are true artisans of the thrown weapon. They train willing students in the Valley of Honor. For pure finesse in the art, however, Ileda of Silvermoon\'s Farstrider Square cannot be beaten.',26124),
(20621,'enUS','Archibald da master of da crossbow. He da weapon master of da Undercity, located in da War Quarter.','Archibald is da master of da crossbow. He da weapon master of da Undercity, located in da War Quarter.',26124),
(20622,'enUS','Our gunnery instructor, he Ansekhwa, da tauren weapon master on da lower central rise of Thunder Bluff.','Our gunnery instructor, he Ansekhwa, da tauren weapon master on da lower central rise of Thunder Bluff.',26124),
(20623,'enUS','Maces, they taught by Ansekhwa, found on da lower central rise of Thunder Bluff.','Maces, they taught by Ansekhwa, found on da lower central rise of Thunder Bluff.',26124),
(20624,'enUS','Da Forsaken weapon master Archibald know his way \'round da polearm. He train others in da War Quarter of da Undercity. Ileda, da blood elf weapon master in Farstrider Square in Silvermoon, show you da right techniques too, mon.','Da Forsaken weapon master Archibald know his way \'round da polearm. He train others in da War Quarter of da Undercity. Ileda, da blood elf weapon master in Farstrider Square in Silvermoon, show you da right techniques too, mon.',26124),
(20625,'enUS','Ileda of da blood elves, in Farstrider Square of Silvermoon, train her students in both one and two-handed swords. Archibald, da Undercity\'s weapon master, also train you, mon. He in da War Quarter.','Ileda of da blood elves, in Farstrider Square of Silvermoon, train her students in both one and two-handed swords. Archibald, da Undercity\'s weapon master, also train you, mon. He in da War Quarter.',26124),
(20626,'enUS','','I can\'t see why you want to learn something else... but I suppose I can point you in the right direction. What training are you after, specifically?',26124),
(20627,'enUS','','If you haven\'t come to train, step back and leave me to my work.',26124),
(20628,'enUS','You disappoint me, Akama.  I wanted to question the treacherous worm myself!  I\'m beginning to question your allegiance, Broken.','',26124),
(20629,'enUS','I do not sense lies in your voice, Akama.  That Kael\'thas would betray me does not come as a big surprise - I\'m not as oblivious as some would think. That one of your own was involved with him puts your loyalties into question.','',26124),
(20630,'enUS','Send your Ashtongue into Tempest Keep and slay his most prized possession, the phoenix known as Al\'ar.  I must know that you\'re not on his side.  Do not think of betraying me, Broken.  We both know who owns your soul!','',26124),
(20631,'enUS','Be wary of the Ethereum that surround us on all sides.','',26124),
(20632,'enUS','I\'ve lost my Violet Signet and seek a replacement.','I\'ve lost my Violet Signet and seek a replacement.',26124),
(20633,'enUS','I... I am free! Ethereum were planning on torturing me until I gave in to their requests. I fear that, had you not come along, I would have surely given in to their torment.','',26124),
(20634,'enUS','Know this, $r. Within Shaffar\'s chambers at the end of these tombs rests a creature of unimaginable power. It is held in check by the power of the stasis chamber. You must return to Ameer before you venture further if you wish to destroy it!','',26124),
(20635,'enUS','Come and I will show you how to ride the finest beasts you have ever seen. You... do have enough gold to cover the cost, I trust?','Come and I will show you how to ride the finest beasts you have ever seen. You... do have enough gold to cover the cost, I trust?',26124),
(20636,'enUS','','Welcome to the Evergrove, $c. Timeon and I have been studying the arakkoa of Blade\'s Edge for some time now, and we\'ve found some alarming differences between them and their cousins in Terokkar.',26124),
(20637,'enUS','<The arakkoa ghost reaches out toward you as though to try to identify you. You get the impression that it cannot see you clearly.>$B$BRokkaram, is that you?','',26124),
(20638,'enUS','Yes... yes, it\'s me...','Yes... yes, it\'s me...',26124),
(20639,'enUS','Forgive me for questioning you, my son. My sight isn\'t what it once was, but the raven has blessed me with a long life.$B$BSoon, it will be time for you to take my place. I have taught you all I know. My only regret is that I didn\'t prove worthy enough to recover our sacred Book of the Raven.','',26124),
(20640,'enUS','Yes, elder. Tell me more of the book.','Yes, elder. Tell me more of the book.',26124),
(20641,'enUS','The true believers have lived in shame since the day our treacherous cousins in Skettis stole the book from us, shattered its tablet, and buried the fragments in their wretched city!$B$BPray that the raven will choose you to restore it, my son. Be faithful and remember always the prophecy, \"From the dreams of his enemies shall the raven spring forth into the world.\"','',26124),
(20642,'enUS','Grok look for help.  Little $r go to the mountains and help the Bloodmaul!','',26124),
(20643,'enUS','You go see Mog\'dorg?','',26124),
(20644,'enUS','I seek a $g hero : heroine; of the utmost skill.  $G He : She; will gather others to save the Bloodmaul clan, and all of the ogres of these mountains from the tyranny of our gronn oppressors.$B$BReturn to me when you have learned all that you can.  But, $c, keep quiet about this until that time lest the gronn get wind of our underground movement.','',26124),
(20645,'enUS','The Sons of Gruul must be defeated if we are to shake off our shackles and live as free ogres once more!$B$BWe must work quietly, yet quickly, if our underground resistance is to have a chance of success.','',26124),
(20646,'enUS','I fear that Colonel Jules may only be saved through a dangerous ritual... an exorcism.','',26124),
(20647,'enUS','Speak with me, $n, for we have much to prepare...','',26124),
(20648,'enUS','Grok need help!  Why no one help?','',26124),
(20649,'enUS','Looking around for help, %s sighs.','',26124),
(20650,'enUS','We must not fail The Betrayer.','',26124),
(20651,'enUS','Soon, our time will come!','',26124),
(20652,'enUS','Has there been contact from the Citadel?','',26124),
(20653,'enUS','The smell of these mutant orcs disgusts me.','',26124),
(20654,'enUS','Ogre, please leave.  You are disturbing our clientele!','',26124),
(20655,'enUS','Not again, Grok.  You\'ve been told before to stay away!','',26124),
(20656,'enUS','Grok, take it outside.','',26124),
(20657,'enUS','Has no one helped you yet, ogre?','',26124),
(20658,'enUS','Ogre, leave!','',26124),
(20659,'enUS','Grok, you\'ve been told before, stay out!','',26124),
(20660,'enUS','Guards, if the ogre doesn\'t leave, escort him out.','',26124),
(20661,'enUS','Will somebody please help this ogre so that he won\'t come back?','',26124),
(20662,'enUS','Move along, Grok, you can\'t go up.','Aw, sweety, you know that I can\'t let you go up there.  Rules are rules.',26124),
(20663,'enUS','The answer is still no, Grok.  You can\'t go up.','I thought that I told you not to come around here.  Move on!',26124),
(20664,'enUS','Grok get angry if puny ones not go to Blade\'s Edge and talk to Mog\'dorg!','',26124),
(20665,'enUS','The enemy is upon us!  Stand your ground!','The enemy is upon us!  Stand your ground!',26124),
(20666,'enUS','The enemies of the Light must be defeated!','The enemies of the Light must be defeated!',26124),
(20667,'enUS','For Xi\'ri!  For the Sha\'tar!','For Xi\'ri!  For the Sha\'tar!',26124),
(20668,'enUS','Your end is at hand, Illidari!','Your end is at hand, Illidari!',26124),
(20669,'enUS','Illidan\'s lapdogs!  Destroy them all!','Illidan\'s lapdogs!  Destroy them all!',26124),
(20670,'enUS','Come closer, demon!  Death awaits!','Come closer, demon!  Death awaits!',26124),
(20671,'enUS','Pathetic worm... your master\'s days are over!','Pathetic worm... your master\'s days are over!',26124),
(20672,'enUS','I\'ve a message for your master, scum!','I\'ve a message for your master, scum!',26124),
(20673,'enUS','Do my eyes deceive me? Is that really you, Brother Rokkaram, after all this time?$B$BIf you are looking for Sai\'kkal, he walks among the crystals in the western part of the Vortex Pinnacle. He seems preoccupied with what he calls a brutish, primitive presence there, although nothing seems amiss.','',26124),
(20674,'enUS','%s begins to break apart!','',26124),
(20675,'enUS','%s surveys the ground for buried raven stones.','',26124),
(20676,'enUS','%s locates a buried raven stone.','',26124),
(20677,'enUS','','I think I need a bath.  *sniff*  I think you need one, too!',26124),
(20678,'enUS','','Would a tauren paladin be a holy cow?',26124),
(20679,'enUS','','Does this dress make me look fat?',26124),
(20680,'enUS','','I bet Illidan is a nice guy underneath.  He just needs a mama, too.',26124),
(20681,'enUS','','I bet ice cream would taste better if it were socketed!',26124),
(20682,'enUS','','Boys have cooties and girls have beauty!',26124),
(20683,'enUS','','Are we there yet?',26124),
(20684,'enUS','','If I hold my breath, what color would I turn?',26124),
(20685,'enUS','','If a horse gets horseshoes, will I get draenei shoes?',26124),
(20686,'enUS','','If the Burning Legion is such a problem, why not just throw water on them?  Then they\'ll just be a Legion.',26124),
(20687,'enUS','','How do you drink and eat so much, and not get fat?',26124),
(20688,'enUS','','Does a naaru turn off the Light when it wants to sleep?',26124),
(20689,'enUS','%s looks at you for a moment, then motions for you to follow.','',26124),
(20690,'enUS','','Heh, I got a little too close.  Don\'t worry, I\'m fine.',26124),
(20691,'enUS','','O\'ros says that he wants to talk with you.',26124),
(20692,'enUS','%s senses danger and flees.','',26124),
(20693,'enUS','%s begins channelling the powers of the Light.','',26124),
(20694,'enUS','I have lost the Eye of Haramad and require a replacement, Ameer.','I have lost the Eye of Haramad and require a replacement, Ameer.',26124),
(20695,'enUS','%s begins to channel a spell of immense purity.','',26124),
(20696,'enUS','','Onward, Scryers!  Show Illidan\'s lackeys the temper of our steel!',26124),
(20697,'enUS','','Ya may know a thing or two about handlin\' animals, but have ya ever taken ta the skies? We Wildhammers know how ta ride the wind with the best of \'em. Fer a small fee, if ya\'ve got the mettle, I\'ll train ya good and proper.',26124),
(20698,'enUS','What do you think when you think Wildhammer, eh? Gryphon riders, if you\'ve any sense! Shadowmoon is no Aerie Peak, but we\'ve still got fine stock for you, aye, fine stock. Take a look at my beauties and see if one of \'em catches your eye!','',26124),
(20699,'enUS','Show me your gryphons, Brunn.','Show me your gryphons, Brunn.',26124),
(20700,'enUS','The violent earthquake has alerted nearby Murlocs!','',26124),
(20701,'enUS','%s sends his enemies to their watery graves!','',26124),
(20702,'enUS','%s sees a bug!','',26124),
(20703,'enUS','%s summons watery globules!','',26124),
(20704,'enUS','Attention!','',26124),
(20705,'enUS','Yes Sir!','',26124),
(20706,'enUS','At ease soldiers!','',26124),
(20708,'enUS','','%s takes the Southfury moonstone and escapes into the river. Follow her!',26124),
(20710,'enUS','%s raises his hammer menacingly...','',26124),
(20711,'enUS','Weapons ready!','',26124),
(20712,'enUS','Attack one!','',26124),
(20713,'enUS','Attack two!','',26124),
(20714,'enUS','Attack three!','',26124),
(20715,'enUS','','You, there! Hand over that moonstone and nobody gets hurt!',26124),
(20716,'enUS','Hut!','',26124),
(20717,'enUS','Hoo-rah!','',26124),
(20718,'enUS','Ahhhhhhhhhhhhhhhhhhh!','',26124),
(20719,'enUS','Pitiful wretches. You dared to assault Illidan\'s temple? Very well, I shall make it your death bed!','',26124),
(20720,'enUS','','All right, you win! I surrender! Just don\'t hurt me!',26124),
(20721,'enUS','','See? I\'ve got the Southfury moonstone and there\'s not a thing you can do about it. So long!',26124),
(20722,'enUS','','Don\'t hurt me!',26124),
(20723,'enUS','Hand over the Southfury moonstone and I\'ll let you go.','Hand over the Southfury moonstone and I\'ll let you go.',26124),
(20724,'enUS','Cast the frost trap.','Cast the frost trap.',26124),
(20725,'enUS','A kiss would be most appreciated.','A kiss would be most appreciated.',26124),
(20726,'enUS','Argh!  I will shred your soul and grind it to dust!','',26124),
(20727,'enUS','Weak, little bugs!  Your souls aren\'t worth eating...','',26124),
(20728,'enUS','You can kiss me if you like, just be quick about it.','You can kiss me if you like, just be quick about it.',26124),
(20729,'enUS','Make sure you stick around for the next firework show!  Starting at 6PM, they\'re every hour on the hour!','Make sure you stick around for the next firework show!  Starting at 6PM, they\'re every hour on the hour!',26124),
(20730,'enUS','Help yourself to a drink friend.  Just make sure to stay away from the ledge while you drink.','Help yourself to a drink friend.  Just make sure to stay away from the ledge while you drink.',26124),
(20731,'enUS','After the fireworks, goblets will be put out. We will then toast our comrades!','After the fireworks, goblets will be put out. We will then toast our comrades!',26124),
(20732,'enUS','Enjoy the festivities!','Enjoy the festivities!',26124),
(20733,'enUS','Starting at 6PM, the city will have a fireworks extravaganza every hour on the hour.','Starting at 6PM, the city will have a fireworks extravaganza every hour on the hour.',26124),
(20734,'enUS','The drink in the kegs is divine.  Drink up, $c!','The drink in the kegs is divine.  Drink up, $c!',26124),
(20735,'enUS','After the firework show, they\'ll put out goblets so we can raise a toast!','After the firework show, they\'ll put out goblets so we can raise a toast!',26124),
(20736,'enUS','Excellent, it\'s party time!','Excellent, it\'s party time!',26124),
(20737,'enUS','%s falls silent and a quiet tension falls over the nearby Sha\'tar forces as Xi\'ri makes his decision.','',26124),
(20738,'enUS','','Come closer, young one. There\'s nothing to fear from me or $n.',26124),
(20739,'enUS','%s cautiously approaches Watcher Elaira.','',26124),
(20740,'enUS','','I\'m going to train you to help $n with a very important task. After that, I promise you\'ll be free to return home.',26124),
(20741,'enUS','A miserable defense from Light-swollen fools. Xi\'ri, I will consume you myself!','',26124),
(20742,'enUS','Now is the time, Maiev!  Unleash your wrath!','',26124),
(20743,'enUS','','I\'ve waited for this moment for years.  Illidan and his lapdogs will be destroyed!',26124),
(20744,'enUS','Slay all who see us!  Word must not get back to Illidan.','',26124),
(20745,'enUS','You\'ve sealed your fate, Akama.  The Master will learn of your betrayal!','',26124),
(20746,'enUS','Akama has no master.  Not anymore.','',26124),
(20747,'enUS','','%s slips into the shadows discreetly as Akama\'s attention shifts towards Vagath\'s last words.',26124),
(20748,'enUS','Our plans are in danger already.  It appears Maiev\'s decided to do things her own way.','',26124),
(20749,'enUS','%s\'s attention shifts to a crack along the temple\'s southern wall.','',26124),
(20750,'enUS','We must carry on with or without Maiev.  Inside!  Quickly!','',26124),
(20751,'enUS','','You will hear the call when you are needed. Fly east, to Skettis, and wait there for $n\'s signal.',26124),
(20752,'enUS','','It would\'ve taken years to find the Book of the Raven without you, young sparrowhawk. Return to your home in Nagrand with our gratitude.',26124),
(20753,'enUS','','This is it! This is really it -- the Book of the Raven!',26124),
(20754,'enUS','The feast of corruption is no more! Magtheridon has fallen to the battle prowess of $n and $g his:her; allies! Witness the might of the Alliance! A pit lord commander is destroyed!\n','',26124),
(20755,'enUS','Hear me brothers and sisters-in-arms! The time of our enemies is at an end! We must strike at the fel orcs that remain! Exterminate them like the vermin that they are! Carry with you the favor of the Sons of Lothar!\n','',26124),
(20756,'enUS','','It\'s all here... how the raven\'s followers captured and subdued the spirits of rivals, trapping them forever within stone statues! The tablet even mentions the raven god\'s name -- Anzu. I\'d thought it was lost to history!',26124),
(20757,'enUS','','There\'s something else here, too. After a description of a bloody battle and the downfall of the raven, there\'s a prophecy. Anzu will haunt the dreams of his enemies, twisting them to effect a return to this world...',26124),
(20758,'enUS','','The tablet has the confirmation we need, just as I thought. Now, we have to use this information to draw out and defeat this Anzu before he can do any more damage to the Emerald Dream!',26124),
(20759,'enUS','','%s greets the sparrowhawk that helped locate the raven stones.',26124),
(20761,'enUS','Forward, vindicators!  Drive these demons from our sacred temple!','',26124),
(20762,'enUS','You look like you may know your way around a beast that runs on land, but if you want to soar, it\'ll take training and dedication. And gold. You have gold, right?','',26124),
(20763,'enUS','','Fine beasts, aren\'t they? The wyverns we raise here are trained to handle the fiercest and strangest weather conditions Draenor has to offer. You\'ll find them dependable and hardy.',26124),
(20764,'enUS','Let me see the wyverns, Dama.','Let me see the wyverns, Dama.',26124),
(20765,'enUS','Hellfire Citadel is ours! The source of Illidan\'s fel orc army is no more! Magtheridon has fallen to the might of $n and $g his:her; allies!','',26124),
(20766,'enUS','The time for us to rise and strike at the fel orcs that remain is now! Do this for your Warchief! Do this for the Horde!\n','',26124),
(20767,'enUS','Fool! The essence of the hawk will never be yours!','',26124),
(20768,'enUS','The time of the Raven is nigh, but yours will end here!','',26124),
(20769,'enUS','You dare to disturb the loyal followers of the Raven?','',26124),
(20770,'enUS','You will die for your hubris, $c!','',26124),
(20771,'enUS','The falcon is vanquished, doomed never to rise again! Your quest is futile!','',26124),
(20772,'enUS','The raven will return to us as foretold in the prophecy and you are powerless to stop it!','',26124),
(20773,'enUS','You dare summon me?','',26124),
(20774,'enUS','%s takes a deep breath!','',26124),
(20775,'enUS','%s begins to cast Pyroblast!','',26124),
(20776,'enUS','Silence descends upon Shattrath.','',26124),
(20777,'enUS','%s\'s thoughts invade your mind.','',26124),
(20778,'enUS','Kael\'thas Sunstrider has been defeated by $n and $g his:her; allies.\n','',26124),
(20779,'enUS','The time to strike at the remaining blood elves of Tempest Keep is now. Take arms and let A\'dal\'s song of battle empower you!\n','',26124),
(20780,'enUS','I don\'t care who you are or what you do outside of the Skyguard, but while you\'re here you will do as you\'re told.','',26124),
(20781,'enUS','Me hungry.  Fruit look tasty.','',26124),
(20782,'enUS','Mog\'dorg the Wizened tell Grok go to city, get help for Bloodmaul.  Grok go.','',26124),
(20783,'enUS','If no one help, Grok smash!','',26124),
(20784,'enUS','Bladespire clan not fight fair.  Have gronn to help dem.  You go to Blade\'s Edge Mountains.  Talk to Mog\'dorg the Wizened.  Kill gronn.','',26124),
(20785,'enUS','Hey, troll!  Why dis charm no work?!','',26124),
(20786,'enUS','When I grow up I wanna be a tanner!','',26124),
(20787,'enUS','Huh?','',26124),
(20788,'enUS','What?','',26124),
(20789,'enUS','Grok not eat all of the apples.  See, der one basket left!','',26124),
(20790,'enUS','It was dat angry orc.  He smushed dem!  Want Grok to smush him?','',26124),
(20791,'enUS','All hail, $n, the new $G King : Queen; of the ogres!!!','',26124),
(20792,'enUS','Your monkeys failed to finish the job, naaru. Beaten but alive... The same mistake was not made when we took command of your vessel.','',26124),
(20793,'enUS','All for what? Trinkets? You are too late. The preparations have already begun. Soon the master will make his return.','',26124),
(20794,'enUS','And there is nothing you or that fool, Illidan, can do to stop me! You have both served me in your own right - unwittingly.','',26124),
(20795,'enUS','And who will save Azeroth from his hungering gaze? You? Your monkeys?','',26124),
(20796,'enUS','Lay down your arms and succumb to the might of Kil\'jaeden!','',26124),
(20797,'enUS','No! How can this be?','',26124),
(20798,'enUS','The lesser spirits were imprisoned ages ago, never to return! I chose the guardians myself! What have you done?','',26124),
(20799,'enUS','Pain will be the price for your insolence! You cannot stop me from claiming the Emerald Dream as my own!','',26124),
(20800,'enUS','A kiss would be most appreciated.','A kiss would be most appreciated.',26124),
(20801,'enUS','Make sure you stick around for the next firework show!  Starting at 6PM, they\'re every hour on the hour!','Make sure you stick around for the next firework show!  Starting at 6PM, they\'re every hour on the hour!',26124),
(20802,'enUS','Help yourself to a drink friend.  Just make sure to stay away from the ledge while you drink.','Help yourself to a drink friend.  Just make sure to stay away from the ledge while you drink.',26124),
(20803,'enUS','After the fireworks, goblets will be put out. We will then toast our comrades!','After the fireworks, goblets will be put out. We will then toast our comrades!',26124),
(20804,'enUS','Enjoy the festivities!','Enjoy the festivities!',26124),
(20805,'enUS','You can kiss me if you like, just be quick about it.','You can kiss me if you like, just be quick about it.',26124),
(20806,'enUS','Starting at 6PM, the city will have a fireworks extravaganza every hour on the hour.','Starting at 6PM, the city will have a fireworks extravaganza every hour on the hour.',26124),
(20807,'enUS','The drink in the kegs is divine.  Drink up, $c!','The drink in the kegs is divine.  Drink up, $c!',26124),
(20808,'enUS','After the firework show, they\'ll put out goblets so we can raise a toast!','After the firework show, they\'ll put out goblets so we can raise a toast!',26124),
(20809,'enUS','Party on, $c!\n','Party on, $c!',26124),
(20810,'enUS','Protect the precioussss!','',26124),
(20811,'enUS','For Blackscale!','',26124),
(20812,'enUS','Leave no survivors!','',26124),
(20813,'enUS','Dinner is served!','',26124),
(20814,'enUS','Scout the area and report anything you see!','Scout the area and report anything you see!',26124),
(20815,'enUS','By the Light! What is that thing?','By the Light! What is that thing?',26124),
(20816,'enUS','The Legion\'s machinations are truly intimidating! ','The Legion\'s machinations are truly intimidating! ',26124),
(20817,'enUS','Hurry past this foul contraption!','Hurry past this foul contraption!',26124),
(20818,'enUS','That machine is too powerful for us alone, quickly, before we are spotted!','That machine is too powerful for us alone, quickly, before we are spotted!',26124),
(20819,'enUS','What is that thing?','What is that thing?',26124),
(20820,'enUS','The Legion\'s creations truly grow more foul by the day.','The Legion\'s creations truly grow more foul by the day.',26124),
(20821,'enUS','Let\'s see how you enjoy that mechanical abomination knocking on your door, Illidan!','Let\'s see how you enjoy that mechanical abomination knocking on your door, Illidan!',26124),
(20822,'enUS','Inside, quickly! Let\'s use the Legion\'s attack as a distraction!','Inside, quickly! Let\'s use the Legion\'s attack as a distraction!',26124),
(20823,'enUS','Dragonriders mount up!','Dragonriders mount up!',26124),
(20824,'enUS','Back to your patrol, worm! That shield is more valuable to me than a hundred of you...','',26124),
(20825,'enUS','This is an outrage! Your disobedience shall not go unpunished!','',26124),
(20826,'enUS','Permission to buzz the tower!','Permission to buzz the tower!',26124),
(20827,'enUS','','No words could do justice to those who would so unselfishly lay down their lives for the good of all. Suffice it to say that I am honored to have fought beside each and every one of you. Now go forth and celebrate. Victory is ours!',26124),
(20828,'enUS','I\'ve never heard of a tikbalang in my life. In fact, the Scryers tell me they can\'t find a single mention of one in their libraries...','',26124),
(20829,'enUS','Look, man, they didn\'t live to be writin\' about it, okay?!','',26124),
(20830,'enUS','%s quirks a skeptical brow.','',26124),
(20831,'enUS','Are you insulting our citizens?','',26124),
(20832,'enUS','It\'s the truth, man. Can\'t ya smell that?','',26124),
(20833,'enUS','Be afraid no more, $n!','Be afraid no more, $n!',26124),
(20834,'enUS','Awaken from your slumber, $n!','Awaken from your slumber, $n!',26124),
(20835,'enUS','Remember where your loyalties lie, $n!','Remember where your loyalties lie, $n!',26124),
(20836,'enUS','Return to this realm, $n!','Return to this realm, $n!',26124),
(20837,'enUS','Return to your original form, $n!','Return to your original form, $n!',26124),
(20838,'enUS','Do not be so easily taken, $n! It is a trick!','Do not be so easily taken, $n! It is a trick!',26124),
(20839,'enUS','Free yourself and chase them, $n!','Free yourself and chase them, $n!',26124),
(20840,'enUS','Break free of your shackles, $n!','Break free of your shackles, $n!',26124),
(20841,'enUS','%s shells up defensively.','',26124),
(20842,'enUS','%s sniffs the air and frowns. He glances over his shoulder.','',26124),
(20843,'enUS','That... odor is from Tobias, I believe.','',26124),
(20844,'enUS','%s\'s frustrated frown disappears into a sly look.','',26124),
(20845,'enUS','...do ya think he be buyin\' soap on a rope, mebbe?','',26124),
(20846,'enUS','%s rolls his eyes.','',26124),
(20847,'enUS','','The sin\'dorei reign supreme!',26124),
(20848,'enUS','','This is not over!',26124),
(20849,'enUS','','Tal anu\'men no sin\'dorei!',26124),
(20850,'enUS','','The warmth of the sun... awaits.',26124),
(20851,'enUS','','Your soul belongs to the abyss!',26124),
(20852,'enUS','','By the blood of the Highborne!',26124),
(20853,'enUS','','For the Sunwell!',26124),
(20854,'enUS','','You are hopelessly outmatched!',26124),
(20855,'enUS','','I will crush your delusions of grandeur!',26124),
(20856,'enUS','Prepare to march!','',26124),
(20857,'enUS','Excellent!','',26124),
(20858,'enUS','NO! I... will... not...','',26124),
(20859,'enUS','Blood for blood!','',26124),
(20860,'enUS','Anar\'alah belore!','',26124),
(20861,'enUS','More perils... await...','',26124),
(20862,'enUS','Are you insinuating that you sell devices which hold sway over others\' minds? That is a very dangerous claim...','',26124),
(20863,'enUS','%s turns to Jadaar with an exasperated expression.','',26124),
(20864,'enUS','Ya be crampin\' my style, man. Seriously.','',26124),
(20865,'enUS','Provided your \"style\" does not include swindling the inhabitants of the city, my words should not \"cramp\" it whatsoever.','',26124),
(20866,'enUS','Yeah, yeah.','',26124),
(20867,'enUS','Akama. Your duplicity is hardly surprising. I should have slaughtered you and your malformed brethren long ago.','',26124),
(20868,'enUS','Boldly said. But I remain... unconvinced.','',26124),
(20869,'enUS','You cannot possibly be suggesting that these baubles of yours hold sway over the very fabric of life itself!','',26124),
(20870,'enUS','%s growls angrily.','',26124),
(20871,'enUS','Ya wanna find out?!','',26124),
(20872,'enUS','%s gives Griftah a chilly stare.','',26124),
(20873,'enUS','...was that a THREAT?!','',26124),
(20874,'enUS','Ah... uh... nah.','',26124),
(20875,'enUS','%s frowns sternly at the back of Griftah\'s head, but remains silent.','',26124),
(20876,'enUS','Truly? \"Guaranteed?\" We\'ll have to sit down and talk at length about this \"guarantee\" of yours, merchant.','',26124),
(20877,'enUS','%s slumps his shoulders, muttering imprecations under his breath.','',26124),
(20878,'enUS','I don\'t suppose you\'d be amenable to demonstrating the amulet\'s healing power here and now...?','',26124),
(20879,'enUS','Ah... nah, man. Don\'t wanna get the merchandise all messy, ya know?','',26124),
(20880,'enUS','%s smiles nervously.','',26124),
(20881,'enUS','Very well. Later, however, I wish to see proof of your claims.','',26124),
(20882,'enUS','Yeah! Yeah. Later, man. Much later.','',26124),
(20883,'enUS','There have been some complaints filed about this... individual. I\'m told he\'s something of a shady character. I am here to determine whether or not this business of his is legitimate... and take action if it proves otherwise.','',26124),
(20884,'enUS','You are not prepared!','',26124),
(20885,'enUS','If you manage to complete a deck of furies cards you will be rewarded with a greater darkmoon card of vengeance.   While wielding this card anyone who strikes you has a chance of suffering holy vengeance.','',26124),
(20886,'enUS','If you manage to complete a deck of storms cards you will be rewarded with a greater darkmoon card of wrath.   This will increase your chance to get a critical hit with spells or physical attacks until you achieve one.','',26124),
(20887,'enUS','If you manage to complete a deck of blessings cards you will be rewarded with a greater darkmoon card of crusade.   This will increase the damage you do with your spells and attacks as you continue to fight.','',26124),
(20888,'enUS','If you manage to complete a deck of lunacy cards you will be rewarded with a greater darkmoon card of madness.   The power of madness will fill you each time you slay an enemy.','',26124),
(20889,'enUS','Tell me about the Furies Deck.','Tell me about the Furies Deck.',26124),
(20890,'enUS','Tell me about the Lunacy Deck.','Tell me about the Lunacy Deck.',26124),
(20891,'enUS','Tell me about the Blessings Deck.','Tell me about the Blessings Deck.',26124),
(20892,'enUS','Tell me about the Storms Deck.','Tell me about the Storms Deck.',26124),
(20893,'enUS','We\'ve come to end your reign, Illidan. My people, and all of Outland, shall be free!','',26124),
(20894,'enUS','The time has come! The moment is at hand!','',26124),
(20895,'enUS','We ogres were once lost...','We ogres were once lost...',26124),
(20896,'enUS','Though mighty, we only knew of violence...','Though mighty, we only knew of violence...',26124),
(20897,'enUS','We fought long and hard.  We had proven again and again that we ogres were a force to be reckoned with.','We fought long and hard.  We had proven again and again that we ogres were a force to be reckoned with.',26124),
(20898,'enUS','Yet soon we turned on each other.  Brother fought brother to decide who was the mightiest.','Yet soon we turned on each other.  Brother fought brother to decide who was the mightiest.',26124),
(20899,'enUS','It was clear that our paths were set.  We were our own greatest enemies, and we were determined to destroy ourselves.','It was clear that our paths were set.  We were our own greatest enemies, and we were determined to destroy ourselves.',26124),
(20900,'enUS','Among these crystals we have seen a new path, a path of peace.','Among these crystals we have seen a new path, a path of peace.',26124),
(20901,'enUS','Morthis! Thank Elune! I was worried I\'d never see you again.','',26124),
(20902,'enUS','Be wary, friends. The Betrayer meditates in the court just beyond.','',26124),
(20903,'enUS','We\'re ready to face Illidan.','We\'re ready to face Illidan.',26124),
(20904,'enUS','Forgive me, my prince! I have... failed.','',26124),
(20905,'enUS','Prepare yourselves!','',26124),
(20906,'enUS','Alert! You are marked for extermination.','',26124),
(20907,'enUS','Systems... shutting... d-o-w-n...','',26124),
(20908,'enUS','Extermination successful.','',26124),
(20909,'enUS','Invasive lifeform no longer functional.','',26124),
(20910,'enUS','Threat neutralized.','',26124),
(20911,'enUS','Alternative measure commencing...','',26124),
(20912,'enUS','Calculating force parameters...','',26124),
(20913,'enUS','So my blood was not a sufficient payment, eh? Fine, let us recover your arcane essence. After this, I owe Balthas nothing.','',26124),
(20914,'enUS','%s places a fetish at the ritual pile.','',26124),
(20915,'enUS','The process is arduous. We must first summon forth acolytes of the elements. You must then destroy these acolytes so that my minions can make preparations.','',26124),
(20916,'enUS','Well done!  Let\'s continue.','',26124),
(20917,'enUS','Prepare yourself! The acolyte of water is soon to come...','',26124),
(20918,'enUS','Come forth, acolyte of earth!','',26124),
(20919,'enUS','Fire, show yourself!','',26124),
(20920,'enUS','Now we call forth the arcane acolyte.','',26124),
(20921,'enUS','You try my patience, shore-dwellers!','',26124),
(20922,'enUS','Enough! Taste the full fury of High Warlord Naj\'entus!','',26124),
(20923,'enUS','','Shh! Keep your voice down. The babes are sleeping.',26124),
(20925,'enUS','The %s cowers at the sight of his angered $g king : queen;.','',26124),
(20926,'enUS','%s brushes up against $n and farts like only an ogre can.','',26124),
(20927,'enUS','Me like to fart, too!','',26124),
(20928,'enUS','Aw, me not think it work out between us.','',26124),
(20929,'enUS','What me do wrong, my $g king : queen;?','',26124),
(20930,'enUS','No hurt!!','',26124),
(20931,'enUS','Flood of the deep, take you!','',26124),
(20932,'enUS','The bogblossom explodes, spraying pollen wildly.','',26124),
(20933,'enUS','By the tides!','',26124),
(20934,'enUS','Destroy them, my subjects!','',26124),
(20935,'enUS','There is nowhere to hide!','',26124),
(20936,'enUS','Soon it will be finished!','',26124),
(20937,'enUS','It is done!','',26124),
(20938,'enUS','Struggling only makes it worse.','',26124),
(20939,'enUS','Only the strong will survive.','',26124),
(20940,'enUS','Great currents of... Ageon...','',26124),
(20941,'enUS','Do not proceed. You will be eliminated.','',26124),
(20942,'enUS','Tectonic disruption commencing.','',26124),
(20943,'enUS','Magnitude set. Release.','',26124),
(20944,'enUS','Trajectory locked.','',26124),
(20945,'enUS','Engage maximum speed.','',26124),
(20946,'enUS','Threat level zero.','',26124),
(20947,'enUS','Directive accomplished.','',26124),
(20948,'enUS','Target exterminated.','',26124),
(20949,'enUS','System failure in five, f-o-u-r...','',26124),
(20950,'enUS','Yes, $g king : queen;?','',26124),
(20951,'enUS','You kill gronn!  Now you fight things from sky?','',26124),
(20952,'enUS','Me life for $n!','',26124),
(20953,'enUS','Dis drink good!','',26124),
(20954,'enUS','If $G King : Queen; $n dance, me dance!','',26124),
(20955,'enUS','$G King : Queen; not angry with me?','',26124),
(20956,'enUS','Why you look at me like dat?  You not gonna kiss me, right!?','',26124),
(20957,'enUS','Now all Sons of Gruul dead!  Now new $g king : queen; lead all ogres to Ogri\'la!','',26124),
(20958,'enUS','crystal man','',26124),
(20959,'enUS','Da $g king : queen;!','',26124),
(20960,'enUS','$G King : Queen; $n.','',26124),
(20961,'enUS','Kneel dogs!','',26124),
(20962,'enUS','$G Him : Her; look too pretty to be da ruler.','',26124),
(20963,'enUS','Mercy!','',26124),
(20964,'enUS','Shh... quiet, it da new $g king : queen;.','',26124),
(20965,'enUS','$G Him : Her; so tiny!  How $g him : her; rule?','',26124),
(20966,'enUS','Me live to serve.','',26124),
(20967,'enUS','','You better wake up real quick, rookie.  This isn\'t our cushy backyard outside of Skettis; this is the Blade\'s Edge Mountains!  One false move and it\'s crash and burn!',26124),
(20968,'enUS','Return to me when you are better prepared.','',26124),
(20969,'enUS','I\'ve lost my Essence-Infused Moonstone. Can you replace it?','I\'ve lost my Essence-Infused Moonstone. Can you replace it?',26124),
(20970,'enUS','I require your life essence to maintain my existence in this realm.','',26124),
(20971,'enUS','It is yours my Lord!','',26124),
(20972,'enUS','Well now, you can find Farseer Javad in the area of The Great Forge, just a bit to the North on the East side.','Well now, you can find Farseer Javad in the area of The Great Forge, just a bit to the North on the East side.',26124),
(20973,'enUS','Shaman','Shaman',26124),
(20974,'enUS','Paladin','Paladin',26124),
(20975,'enUS','Master Pyreanor can be found among Thrall\'s advisors in his fortress, Grommash Hold, in the Valley of Wisdom.','Master Pyreanor can be found among Thrall\'s advisors in his fortress, Grommash Hold, in the Valley of Wisdom.',26124),
(20976,'enUS','','Scary!',26124),
(20977,'enUS','','Scary!',26124),
(20978,'enUS','Ambassador Dawnsinger and I represent the Court of the Sun here in Orgrimmar.$B$BThe ambassador handles civil matters, while I advise Thrall on military campaigns and the unique, err... advantages conferred by the Blood Knights.','',26124),
(20979,'enUS','Instruct me further in the use of the naaru\'s power.','Instruct me further in the use of the naaru\'s power.',26124),
(20980,'enUS','%s returns to stone.','',26124),
(20981,'enUS','Symbols of Divinity? Check. Candles? Check. Arcane powder, uh... arcane powder? Oh, no! This is the last time I offer to pick up reagents for anyone. Is there a vendor around here?','Symbols of Divinity? Check. Candles? Check. Arcane powder, uh... arcane powder? Oh, no! This is the last time I offer to pick up reagents for anyone. Is there a vendor around here?',26124),
(20982,'enUS','Is there a mage around here? I\'m supposed to be bringing the food and water...','Is there a mage around here? I\'m supposed to be bringing the food and water...',26124),
(20983,'enUS','The next person who asks me for a potion is getting a knuckle sandwich. I quit alchemy!','The next person who asks me for a potion is getting a knuckle sandwich. I quit alchemy!',26124),
(20984,'enUS','Boy, I could really use one of those gryphons right about now...','Boy, I could really use one of those gryphons right about now...',26124),
(20985,'enUS','I can instruct you in jewelcrafting.  Interested?','I can instruct you in jewelcrafting.  Interested?',26124),
(20986,'enUS','Why dis wall no stay up? Me keep banging but no good!','',26124),
(20987,'enUS','Thank you for the summon, little one. My group left for the dungeon without me!','Thank you for the summon, little one. My group left for the dungeon without me!',26124),
(20988,'enUS','Why dis wall no go down? Wut doing?','',26124),
(20989,'enUS','Hey stupid! Why you banging wall? Wall go up not down! Stupid orc! Up! Up!','',26124),
(20990,'enUS','','That was neat!',26124),
(20991,'enUS','Awaken, my children and assist your master!','',26124),
(20992,'enUS','Wut you want? Smell funny for fel orc...','',26124),
(20993,'enUS','You no make dis your home. Maybe you want eat someting?','',26124),
(20994,'enUS','What do you have for sale?','What do you have for sale?',26124),
(20995,'enUS','Me want Gug fix armor. Maybe me buy someting.','Me want Gug fix armor. Maybe me buy someting.',26124),
(20996,'enUS','Sometimes those damnable blood elves stop by and require some inane reagent or poison. I must keep my stock of such items full at all times lest Lord Illidan get word of the Dragonmaw not cooperating...$B$B<Rumpus swallows hard.>$B$BWe don\'t want that...','Sometimes those damnable blood elves stop by and require some inane reagent or poison. I must keep my stock of such items full at all times lest Lord Illidan get word of the Dragonmaw not cooperating...$B$B<Rumpus swallows hard.>$B$BWe don\'t want that...',26124),
(20997,'enUS','What do you have for sale, Rumpus?','What do you have for sale, Rumpus?',26124),
(20998,'enUS','OH YEA! You want a taste of these guns, maggot? Step on in!','',26124),
(20999,'enUS','How do you compete with these pythons? Ooooooh yaaaaa, brother!','',26124),
(21000,'enUS','You hear that? You hear that chantin\', brother? They\'re cheerin\' for the Rulkster!','',26124),
(21001,'enUS','What are you gonna do when Rulk-a-mania runs wild on you, brother????!','',26124),
(21002,'enUS','<The light surrounding Xi\'ri pulses blue.  The naaru welcomes you as an ally in the field of battle.>','',26124),
(21003,'enUS','I am ready to join your forces in battle, Xi\'ri.','I am ready to join your forces in battle, Xi\'ri.',26124),
(21004,'enUS','Check those crystals over there!','',26124),
(21005,'enUS','You\'ve found nothing?  Very well.  Over there next.','',26124),
(21006,'enUS','That grouping looks promising.','',26124),
(21007,'enUS','Find what I am looking for and you may have a treat.','',26124),
(21008,'enUS','I am beginning to suspect you are worthless.  Do not disappoint me further.','',26124),
(21009,'enUS','Yes, that\'s it.  These will do nicely.','',26124),
(21010,'enUS','$G Brother:Sister;, you are now considered bound by blood to the Netherwing. All of Netherwing will be behind you now! The time to strike at the heart of our enemies is now, friend! We must reclaim our lost heritage.','',26124),
(21011,'enUS','You have done much for our cause, $n, but you may go no further until you have mastered flight. Only the most stalwart riders are able to assist the Netherwing.','',26124),
(21012,'enUS','Yes... cast your precious little spells, ak-a-ak!','',26124),
(21013,'enUS','I would like to enter the secret code to receive my Golden Pig pet.','I would like to enter the secret code to receive my Golden Pig pet.',26124),
(21014,'enUS','Hail, $r. Were you lucky enough to have attended that recent special event?$B$BIf so, you may have learned a secret code. Tell me your code and I will give you a special prize in return.','Hail, $r. Were you lucky enough to have attended that recent special event?$B$BIf so, you may have learned a secret code. Tell me your code and I will give you a special prize in return.',26124),
(21015,'enUS','Your magics shall be your undoing... ak-a-ak...','',26124),
(21016,'enUS','Your powers... ak-ak... turn against you...','',26124),
(21017,'enUS','Your spells... ke-kaw... are weak magics... easy to turn against you...','',26124),
(21018,'enUS','The ground begins to crack open!','',26124),
(21019,'enUS','Supremus punches the ground in anger!','',26124),
(21020,'enUS','INVADERS! Let the mark of the Dragonmaw guide your anger! Slay $n!','',26124),
(21021,'enUS','','Are you gonna help?',26124),
(21022,'enUS','You fool no one, $r. Even the magic of the Netherwing cannot hide you from the all-seeing gaze of the Skybreakers!','',26124),
(21023,'enUS','Beware the Dragonmaw Skybreakers and ascendants as they are not fooled by our magic! Always keep your distance from those entities!\n','',26124),
(21024,'enUS','The Ogre clans will not be subjugated.  Not by the gronn, and not by a puny $r like you!','',26124),
(21025,'enUS','Mog\'dorg is a fool to think that one of the smaller races will be our savior.','',26124),
(21026,'enUS','These mountains are for ogres.  Not for gronn, not for humans or orcs!','',26124),
(21027,'enUS','Do not bow to Mog\'dorg\'s puppet!  He would replace our gronn overlords with a liege of lesser stock.  Why should we replace one master with another?','',26124),
(21028,'enUS','The time has come.  Strike down every creature that stands in the way of the clans!','',26124),
(21029,'enUS','Do not listen to Mog\'dorg\'s lies!  Ogri\'la is a myth!  We make our own heaven here with the blood of any that would divide and subjugate us!','',26124),
(21030,'enUS','You must have wondered how it is that I can speak so clearly for an ogre.  It\'s a side effect of the crystals that grow on the terrace surrounding Ogri\'la.  The ogres there gifted me with this staff, and its crystal has in turn gifted me mentally.$B$BIt is through your continued actions, at Ogri\'la above, that I hope to one day be able to bring this boon to all of my ogre brethren.  You have my thanks, my $g king : queen;, for all that you have done and will do.','',26124),
(21031,'enUS','We are brothers.  And we will stand united against those who oppose our peace.','We are brothers.  And we will stand united against those who oppose our peace.',26124),
(21032,'enUS','Agh... me am...dead.','',26124),
(21033,'enUS','Me go to... Ogri\'la.','',26124),
(21034,'enUS','Me honored... $g king : queen; kill me.','',26124),
(21035,'enUS','$G King : Queen; $n, me die now.','',26124),
(21036,'enUS','You are no stranger to the Legion, scum. Surely, you know what torment awaits you...','',26124),
(21037,'enUS','We are in Ogri\'la.','We are in Ogri\'la.',26124),
(21038,'enUS','We are in heaven.','We are in heaven.',26124),
(21039,'enUS','We\'ve moved from bloodstained roads to roads illuminated by crystals.','We\'ve moved from bloodstained roads to roads illuminated by crystals.',26124),
(21040,'enUS','Though the sounds of battle are still near, we also hear the song of these crystals.','Though the sounds of battle are still near, we also hear the song of these crystals.',26124),
(21041,'enUS','Even with enemies at our door step, the light and song of the crystals have sustained us.','Even with enemies at our door step, the light and song of the crystals have sustained us.',26124),
(21042,'enUS','Here in Ogri\'la, we have reached a higher existence.  And we will keep it that way.','Here in Ogri\'la, we have reached a higher existence.  And we will keep it that way.',26124),
(21043,'enUS','Do you hear that brothers?','Do you hear that brothers?',26124),
(21044,'enUS','Over the song of the crystals, do you hear the battle that is approaching?','Over the song of the crystals, do you hear the battle that is approaching?',26124),
(21045,'enUS','Do you see our enemies?','Do you see our enemies?',26124),
(21046,'enUS','They lurk nearby ready to strike.','They lurk nearby ready to strike.',26124),
(21047,'enUS','Are we ready?','Are we ready?',26124),
(21048,'enUS','The crystals have enlightened us brothers.  But we must still be on guard.','The crystals have enlightened us brothers.  But we must still be on guard.',26124),
(21049,'enUS','$G King : Queen; think... there really is... an Ogri\'la?','',26124),
(21050,'enUS','Puny $r... you were a... horrible $g king : queen;.','',26124),
(21051,'enUS','For honor, for mercy, for Gorefiend.  Forever.','',26124),
(21052,'enUS','Another one, eh? You\'ll never make it...','',26124),
(21053,'enUS','Just remember that you can only pick one gathering job to do per day. Aside from that, we\'re always looking for more crystals. Any worthless peon can bring those back to the base camp.','',26124),
(21054,'enUS','My hounds shall feast on your corpse!','',26124),
(21055,'enUS','Your moment of defiance is nearly over!','',26124),
(21056,'enUS','Your soul is doomed! Our defenses are nearly armed...','',26124),
(21057,'enUS','Shield defense arming. Executing in 30 seconds','',26124),
(21058,'enUS','Shield defense arming. Executing in 20 seconds.','',26124),
(21059,'enUS','Shield defense arming. Executing in 10 seconds.','',26124),
(21060,'enUS','A fitting end for a traitor...','',26124),
(21061,'enUS','I got nothing new for you, kid. You\'ve outgrown manual labor...','',26124),
(21062,'enUS','Summoning','Summoning',26124),
(21063,'enUS','For the younglings! For the Horde!','For the younglings! For the Horde!',26124),
(21064,'enUS','For our children and the future of the Alliance! The Legion shall not prevail!','For our children and the future of the Alliance! The Legion shall not prevail!',26124),
(21065,'enUS','%s doesn\'t seem to have had any luck finding raven stones nearby.','',26124),
(21066,'enUS','Behold the power... of the demon within!','',26124),
(21067,'enUS','%s shifts into the void...','',26124),
(21068,'enUS','Is this it, mortals? Is this all the fury you can muster?','',26124),
(21069,'enUS','Maiev... How is it even possible?','',26124),
(21070,'enUS','','Their fury pales before mine, Illidan. We have some unsettled business between us.',26124),
(21071,'enUS','','My long hunt is finally over. Today, Justice will be done!',26124),
(21072,'enUS','Greetings, $c. I trust that you bring me good news concerning the Worldwide Invitational event? If you are, then surely that means you were given a secret code to tell me. In return for your code I will give you a gift of one of the golden pigs that I take care of.$B$BJust whisper it in my ear when you are ready.','Greetings, $c. I trust that you bring me good news concerning the Worldwide Invitational event? If you are, then surely that means you were given a secret code to tell me. In return for your code I will give you a gift of one of the golden pigs that I take care of.$B$BJust whisper it in my ear when you are ready.',26124),
(21073,'enUS','I would like to whisper my secret code to you to receive my Golden Pig pet.','I would like to whisper my secret code to you to receive my Golden Pig pet.',26124),
(21074,'enUS','%s fixates on $n.','',26124),
(21075,'enUS','%s\'s flesh shatters in an unearthly rage!','',26124),
(21076,'enUS','Consume $n, my children!','',26124),
(21077,'enUS','%s focuses on $n.','',26124),
(21078,'enUS','Illidan\'s grasp over my tribe is strong, $n. It shall all be over soon, one way or another.$B$BAre you ready, $n?  My people\'s future depends on us.','',26124),
(21079,'enUS','I\'m with you, Akama.','I\'m with you, Akama.',26124),
(21080,'enUS','SKYGUARD SCOUT!!','SKYGUARD SCOUT!!',26124),
(21081,'enUS','%s spills his beverage.','%s spills her beverage.',26124),
(21082,'enUS','%s cleans up the mess while muttering curses about the Skyguard hotshot pilots.','%s cleans up the mess while muttering curses about the Skyguard hotshot pilots.',26124),
(21083,'enUS','The elixir... give it to me, Severin!','',26124),
(21084,'enUS','I see them now... assassins from Skettis!','',26124),
(21085,'enUS','You will die in the name of Lady Vashj!','',26124),
(21086,'enUS','The arakkoa can send all the assassins they have... they will meet the same fate as these!','',26124),
(21087,'enUS','Blood... will... flow!','',26124),
(21088,'enUS','Be\'lanen dalorai!','',26124),
(21089,'enUS','Stick around...','',26124),
(21090,'enUS','I\'ll deal with you later.','',26124),
(21091,'enUS','Your success was short-lived!','',26124),
(21092,'enUS','Time for you to go.','',26124),
(21093,'enUS','Lord Illidan will... crush you!','',26124),
(21094,'enUS','Is this... blood in my lungs?  If I don\'t die to an assassin\'s blade, it\'ll be my old injuries that get me.','',26124),
(21095,'enUS','Bal, lamer zhita!','',26124),
(21096,'enUS','My patience has run out! Die! Die!','',26124),
(21097,'enUS','Vengeance is mine!','',26124),
(21098,'enUS','I was the first you know. For me the wheel of death has spun many times. So much time has passed... I have a lot of catching up to do. ','',26124),
(21099,'enUS','I have use for you...','',26124),
(21100,'enUS','It gets worse.','',26124),
(21101,'enUS','Death really isn\'t so bad.','',26124),
(21102,'enUS','What are you afraid of?','',26124),
(21103,'enUS','Give in.','',26124),
(21104,'enUS','I have something for you...','',26124),
(21105,'enUS','You will show the proper respect!','',26124),
(21106,'enUS','The wheel... spins... again.','',26124),
(21107,'enUS','<TXT>','',26124),
(21108,'enUS','%s cheers!','%s cheers!',26124),
(21109,'enUS','%s is disgusted!','%s is disgusted!',26124),
(21110,'enUS','%s roars!','%s roars!',26124),
(21111,'enUS','What manner of deception is this!? Who turns my underlings against me?','',26124),
(21112,'enUS','Get to work on those crystals!','',26124),
(21113,'enUS','These crystals will work.  Get them!','',26124),
(21114,'enUS','Move it!  These crystals aren\'t going to collect themselves.','',26124),
(21115,'enUS','You\'ve ruined this batch!  Why must I work with you worthless Gan\'arg.','',26124),
(21116,'enUS','At least you didn\'t screw this batch up.','',26124),
(21117,'enUS','I can\'t believe you\'ve actually done something right for once.','',26124),
(21118,'enUS','Time for eating!?','',26124),
(21119,'enUS','Mmmm! FOOD!','',26124),
(21120,'enUS','Me so hungry! YUM!','',26124),
(21121,'enUS','It put the mutton in the stomach!','',26124),
(21122,'enUS','Hey... me not feel so good.','',26124),
(21123,'enUS','You is bad orc... baaad... or... argh!','',26124),
(21124,'enUS','Test.','',26124),
(21125,'enUS','I am a Conqueror.','I am a Conqueror.',26124),
(21126,'enUS','I am a Justicar.','I am a Justicar.',26124),
(21127,'enUS','','You\'re not yet advanced enough to properly follow anything I might have to show you. I highly suggest you hone your crude skills with the sluggish stylings of Gloresse here before speaking with me.',26124),
(21128,'enUS','','Let\'s get to business, $n. I\'ll show you what I know, but keep up.',26124),
(21129,'enUS','You cannot withstand the power of my forces!','',26124),
(21130,'enUS','Peer inside the warp-gate if you dare. I\'ve prepared something special for you...','',26124),
(21131,'enUS','Skettis prevails!','',26124),
(21132,'enUS','Adaris!','',26124),
(21133,'enUS','Rest now, friend.  You need your strength.','',26124),
(21137,'enUS','You cannot escape your fate, traitor!','',26124),
(21138,'enUS','You\'re not going anywhere!','',26124),
(21139,'enUS','Get back here!','',26124),
(21140,'enUS','Traitor! You\'ve struck the shield! Your fate is sealed...','',26124),
(21141,'enUS','Mog\'dorg, me know stuff you want to know.','',26124),
(21142,'enUS','Me back, boss.  Me tell you wut me know.','',26124),
(21143,'enUS','Da gronn not know nothing, Mog\'dorg.  Me sure them not know \'bout da plan.','',26124),
(21144,'enUS','Me hear lots of stuff goin\' on.  We kill gronn soon?','',26124),
(21145,'enUS','Mog\'dorg, me not tell no one \'bout cov... cov... cov... secret plan against da gronn.','',26124),
(21146,'enUS','Me check with other ogres.  Them\'s ready.','',26124),
(21147,'enUS','Okay, me go now.','',26124),
(21148,'enUS','Your pathetic efforts shall yield you nothing but pain.','',26124),
(21149,'enUS','You have done well.  The information you are providing is critical to our success.','',26124),
(21150,'enUS','Thank you, friend.  Soon, we will be free of our slavery to the gronn.','',26124),
(21151,'enUS','Excellent.  The work that you do now will allow us to join our brethren in Ogri\'la, above, one day.','',26124),
(21152,'enUS','Those that speak to me from on high in Ogri\'la will be most pleased with the information that you bring.','',26124),
(21153,'enUS','This is good news; our covert operation against the gronn proceeds as planned.  And, there is someone on the outside helping us now, too.','',26124),
(21154,'enUS','Our underground movement against the gronn must not falter!  Return and gather more information.','',26124),
(21155,'enUS','Good.  If all goes as planned, we will soon be free of the gronn.  Then all of the ogres of the mountains will be able to enjoy the enlightened blessings of the ogres from Ogri\'la.','',26124),
(21156,'enUS','One day soon, my friend, you will carry an Ogri\'la crystal, as I do.  Then you will come to a greater understanding of the world around you.','',26124),
(21157,'enUS','Yes, unless I have anything to do with it.','',26124),
(21158,'enUS','I see that happening sometime between tomorrow and the next decade. Definitely.','',26124),
(21159,'enUS','Indeeeeed!','',26124),
(21160,'enUS','Looks good for you...and bad for me.','',26124),
(21161,'enUS','I\'ve consulted my fellow imps, and we think YES, except for that one imp.','',26124),
(21162,'enUS','The outlook is positive, but I\'m still negative.','',26124),
(21163,'enUS','It pains me to say this, but \"Yes\".','',26124),
(21164,'enUS','When dwarves fly! They do? Then yes!','',26124),
(21165,'enUS','Sure, but you\'re not going to like it.','',26124),
(21166,'enUS','Be quiet \'bout what you hear and see around here, $r.','',26124),
(21167,'enUS','Da $g king : queen;!  Chort ready to serve.','',26124),
(21168,'enUS','Grok hear dat yous da new $g king : queen; of all da ogres.  Congrat... congratu... gratz, little $r.','',26124),
(21169,'enUS','Unfortunately... yes.','',26124),
(21170,'enUS','I can\'t see why not, although, I can\'t see a lot of things right now.','',26124),
(21171,'enUS','I would bet your soul on it.','',26124),
(21172,'enUS','Yes, but if anyone asks... It wasn\'t me who told you.','',26124),
(21173,'enUS','Didn\'t you already ask that once? Yes already!','',26124),
(21174,'enUS','Ruk!','',26124),
(21175,'enUS','Please... Is Kil\'jaeden red?','',26124),
(21176,'enUS','Yeah, sure. You just keep thinking that.','',26124),
(21177,'enUS','I suppose.','',26124),
(21178,'enUS','Definitely.','',26124),
(21179,'enUS','Jump three times and dance for ten minutes and it will definitely happen!','',26124),
(21180,'enUS','Word on the peninsula is YES!','',26124),
(21181,'enUS','Oh, that one\'s for sure.','',26124),
(21182,'enUS','Yes, but not in the way you imagine.','',26124),
(21183,'enUS','Yes, yes, a thousand times, yes already!','',26124),
(21184,'enUS','Yes, now stop pestering me!','',26124),
(21185,'enUS','The answer will be a yes if you let me out of here.','',26124),
(21186,'enUS','It\'s as sure as the warts on my backside!','',26124),
(21187,'enUS','The answer is yes in here, I don\'t see why it would be any different out there.','',26124),
(21188,'enUS','Three words - \"ab - so - lutely\"!','',26124),
(21189,'enUS','Yes, but I hoped I would never have to answer that.','',26124),
(21190,'enUS','Ask me again later - I\'m trying to scratch my nose and it\'s hard to concentrate.','',26124),
(21191,'enUS','Why should I answer that?  Do you tell fortunes when people shake YOU?','',26124),
(21192,'enUS','Yes, it will rain.  That\'s not what you asked?  Too bad!','',26124),
(21193,'enUS','I\'m sorry, I can only speak Demonic.','',26124),
(21194,'enUS','Yes!  I mean no!  I mean... which answer gets me out of here?','',26124),
(21195,'enUS','Yes, No, Maybe so.','',26124),
(21196,'enUS','It won\'t matter, you\'ll be dead by tomorrow.','',26124),
(21197,'enUS','You should be asking \"Is that rogue behind me going to kill me?\"','',26124),
(21198,'enUS','It\'s times like these that I wish I had a longer cooldown.','',26124),
(21199,'enUS','%s shrugs. Who knows?','',26124),
(21200,'enUS','I ask myself that question everyday...','',26124),
(21201,'enUS','Thank you, friend.','',26124),
(21202,'enUS','You honor us, friend.','',26124),
(21203,'enUS','These things that you do for Netherwing do not go unnoticed.','',26124),
(21204,'enUS','An ally always!','',26124),
(21205,'enUS','It\'s like my mother always said: [Demonic] \"Razxx khaj jhashxx xashjx.\"','',26124),
(21206,'enUS','%s is ignoring you.','',26124),
(21207,'enUS','Why me?  Why not a goblin, or a gnome...','',26124),
(21208,'enUS','What happens in the twisting nether, stays in the twisting nether.','',26124),
(21209,'enUS','Avoid taking unnecessary gambles. Your lucky numbers are two, two and half, and eleven-teen.','',26124),
(21210,'enUS','Wouldn\'t you like to know?','',26124),
(21211,'enUS','Oh, oh, oh!  I can see this one clearly...  Nah, lost it.','',26124),
(21212,'enUS','This was NOT in my contract!','',26124),
(21213,'enUS','XRA RAHKI MAZIZRA!','',26124),
(21214,'enUS','4 8 15 16 23 42','',26124),
(21215,'enUS','Are you making fun of me?','',26124),
(21216,'enUS','What kind of imp do you think I am?','',26124),
(21217,'enUS','Say please.','',26124),
(21218,'enUS','Want to trade places?','',26124),
(21219,'enUS','Do you ask this question to everything that\'s trapped in a ball?','',26124),
(21220,'enUS','Hey! You try arranging furniture with some jerk shaking your house!','',26124),
(21221,'enUS','I can make that happen. Just sign below the dotted line...','',26124),
(21222,'enUS','Reply hazy and slightly damp. Dry thoroughly and try again.','',26124),
(21223,'enUS','Concentrate (on releasing me from this infernal prison) and try again later.','',26124),
(21224,'enUS','Please insert 25 silver pieces and try again.','',26124),
(21225,'enUS','Are you my pal, Danny?','',26124),
(21226,'enUS','You remember the time you tried to drill that hole in your head?','',26124),
(21227,'enUS','Oh that\'s right, don\'t make any effort to make your own fortune!','',26124),
(21228,'enUS','Two words - imp-possible!','',26124),
(21229,'enUS','You need Arcane Intellect, because that answer is obvious!  NO!','',26124),
(21230,'enUS','Not on your life!','',26124),
(21231,'enUS','I don\'t have to be a fortune-telling imp to know the answer to that one - NO!','',26124),
(21232,'enUS','The odds are 32.33 (repeating of course) percent chance of success.','',26124),
(21233,'enUS','When Blackrock freezes over!','',26124),
(21234,'enUS','Hahahaha, you\'re kidding right?','',26124),
(21235,'enUS','Inconceivable!','',26124),
(21236,'enUS','My sources say \"no\". Before the torture, that is.','',26124),
(21237,'enUS','That\'s about as likely as me getting out of this ball.','',26124),
(21238,'enUS','You picked the wrong time to shake me today, buddy!  Prepare for disappointment.','',26124),
(21239,'enUS','Not unless you\'re some kind of super-person.  And don\'t kid yourself, you\'re not.','',26124),
(21240,'enUS','That\'s about as likely as me getting a date with a succubus.','',26124),
(21241,'enUS','My fortune telling powers are immeasurable - your chances are though: NO CHANCE','',26124),
(21242,'enUS','NO - and don\'t try shaking me again for a better answer!','',26124),
(21243,'enUS','Yes is my answer...','',26124),
(21244,'enUS','...NOT!','',26124),
(21245,'enUS','I\'m gonna have to give this one the big N-O.','',26124),
(21246,'enUS','The outlook is very bad - for YOU that is!  Haha, take it!','',26124),
(21247,'enUS','Survey says: BZZZT!','',26124),
(21248,'enUS','Very well, intruder. You have earned my undivided attention...','',26124),
(21249,'enUS','Behold! I\'ve reserved my favorite pets for just such an occasion.','',26124),
(21250,'enUS','I will deal with these mongrels! Strike now, friends! Strike at the Betrayer!','',26124),
(21251,'enUS','Come, my minions. Deal with this traitor as he deserves!','',26124),
(21252,'enUS','I will not be touched by rabble such as you!','',26124),
(21253,'enUS','I submit! You win this time...','',26124),
(21254,'enUS','Good fight!','',26124),
(21255,'enUS','You see that final blow! Awesome!','',26124),
(21256,'enUS','Kill him!','',26124),
(21257,'enUS','Weak!','',26124),
(21258,'enUS','Finish him off!','',26124),
(21259,'enUS','Filthy animals!','',26124),
(21260,'enUS','%s lets out a shrill shriek, calling for help from a nearby kaliri.','',26124),
(21261,'enUS','%s appears to be speaking with an unseen entity.','',26124),
(21262,'enUS','Throwing grenade!','',26124),
(21263,'enUS','Baby Gorilla Pet','Baby Gorilla Pet',26124),
(21264,'enUS','Now me grow bigger and crush you!','',26124),
(21265,'enUS','Imp in a Ball','Imp in a Ball',26124),
(21266,'enUS','Picnic Basket','Picnic Basket',26124),
(21267,'enUS','How long must we wait?','',26124),
(21268,'enUS','One day, we will rule this dark temple.','',26124),
(21269,'enUS','I must feed!','',26124),
(21270,'enUS','OH, IT\'S ON NOW $n!','',26124),
(21271,'enUS','','Stupid grenade picked a fine time to backfire! So much for high quality goblin engineering!',26124),
(21272,'enUS','Fortune be with us!  To the skies!','',26124),
(21273,'enUS','','I have a proposal for you, $r.  Please consider your choices carefully - your decision cannot be easily reversed.$B$BIt is time we formalized your allegiance to our organization.  I must know in what capacity you wish to serve us so that we may reward you appropriately.',26124),
(21274,'enUS','Foolish Akama, your mortal time has expired....','',26124),
(21275,'enUS','Behold the Flames of Azzinoth!','',26124),
(21276,'enUS','Our studies are complete!  Well fought!  Headquarters will pour over our gained measurements and, with luck, uncover the Bash\'ir\'s intentions.  Now, to the skies!','Our studies are complete!  Well fought!  Headquarters will pour over our gained measurements and, with luck, uncover the Bash\'ir\'s intentions.  Now, to the skies!',26124),
(21277,'enUS','I hired Galana specifically to deal with rudimentary training. Go speak with her. This shop is meant to be run efficiently and effectively, and I expect everyone - including the patrons - to respect it.','',26124),
(21278,'enUS','Welcome to Keelen\'s Trustworthy Tailoring. I think you\'ll find my shop will suit your needs. If you wish to train with me, you need only ask; I\'ll be more than happy to teach you.','',26124),
(21279,'enUS','How can I help you, $c?','',26124),
(21280,'enUS','Show me what you have for sale.','Show me what you have for sale.',26124),
(21281,'enUS','The pile of skulls reeks of foulness.  You fear the arakkoa have made an addition to the pile fairly recently.','',26124),
(21282,'enUS','<Call forth Gezzarak the Huntress.>','<Call forth Gezzarak the Huntress.>',26124),
(21283,'enUS','Now you shall witness the meaning of true power!','',26124),
(21284,'enUS','','If you\'re looking for gadgets, doodads, thingamajigs, widgets, whatsis, dohickeys, or gizmos, you\'ve come to the right place!',26124),
(21285,'enUS','Show me your assortment of, err... things.','Show me your assortment of, err... things.',26124),
(21286,'enUS','The forge needs additonal tuning.  Look into it, slave!','',26124),
(21287,'enUS','<Call forth Vakkiz the Windrager.>','<Call forth Vakkiz the Windrager.>',26124),
(21288,'enUS','<Call forth Karrog.>','<Call forth Karrog.>',26124),
(21289,'enUS','<Call forth Darkscreecher Akkarai.>','<Call forth Darkscreecher Akkarai.>',26124),
(21290,'enUS','You look familiar...','',26124),
(21291,'enUS','Your bones shall make ideal playthings for my hound.','',26124),
(21292,'enUS','My sight is filled with visions of events taking place throughout the world and ones that may yet happen. Many of them are grim, but we needn\'t believe they are incapable of changing.','',26124),
(21293,'enUS','If you need reagents, you\'ve come to the right place. You won\'t find a finer selection in all of Shattrath.','',26124),
(21294,'enUS','Show me what you have for sale.','Show me what you have for sale.',26124),
(21295,'enUS','Drinking','Drinking',26124),
(21296,'enUS','I gotcha boss!','',26124),
(21297,'enUS','I\'m coming, boss!','',26124),
(21298,'enUS','Looks like that hurt!','',26124),
(21299,'enUS','Repair module activated!','',26124),
(21300,'enUS','Who... Who is you?? What you want?','',26124),
(21301,'enUS','','Step aside lest I add you as another adornment to my armor. Your leader and I have matters to attend...',26124),
(21302,'enUS','Yes... Yes we move now... Please no hurt us...','',26124),
(21303,'enUS','','%s smiles.',26124),
(21304,'enUS','','I thought you would see it my way...',26124),
(21305,'enUS','','Overlord Mor\'ghor, I presume... A pleasure to finally make your acquaintance. ',26124),
(21306,'enUS','','I am Lady Sinestra.',26124),
(21307,'enUS','I will not drag this out any further than it needs, Lady Sinestra. You have bent my ear, now tell me what it is that you want from Dragonmaw.','',26124),
(21308,'enUS','','You have no doubt heard about Nefarian\'s failures on Azeroth... While he has fallen, the experiments continue. My master... He continues the work that his progeny began.',26124),
(21309,'enUS','','%s nods.',26124),
(21310,'enUS','The... The master? He lives?','',26124),
(21311,'enUS','','You were once a chief lieutenant, Mor\'ghor. Your work in Grim Batol is not easily forgotten.',26124),
(21312,'enUS','','Now... We need the eggs that you recover. The Netherwing eggs. They are, after all, a product of the master. We will pay whatever price that you ask.',26124),
(21313,'enUS','%s stammers.','',26124),
(21314,'enUS','Ye... Yes, yes... Of course. We need only the crystals and ore from this place. There is... We will need mounts.','',26124),
(21315,'enUS','','The master will be most pleased with this news. The Black Dragonflight will provide you all that you ask. You will be allowed to ride upon the backs of our drakes as needed.',26124),
(21316,'enUS','','I thank you for your graciousness, Mor\'ghor. I must now take my leave.',26124),
(21317,'enUS','','%s falls to the floor.',26124),
(21318,'enUS','I\'m not finished with you!','',26124),
(21319,'enUS','You\'ll never leave here alive!','',26124),
(21320,'enUS','Just chill!','Just chill!',26124),
(21321,'enUS','<Mudlump is polishing his boots.>','',26124),
(21322,'enUS','Your skill is notable, $c, and I believe the time has come for you to vacate the premises. If you wish to expand your horizons, visit Josef Gregorian in the Undercity.','',26124),
(21323,'enUS','','You\'ve sufficiently advanced in the field to be beyond my ability to teach. I hear there\'s a skilled engineer named Roxxik in the stinking pit of a city they call Orgrimmar who might be able to train you.',26124),
(21324,'enUS','Me no work no more!','',26124),
(21325,'enUS','Work is da poop! NO MORE!','',26124),
(21326,'enUS','I am da powerful! Nobody tell me what to do!','',26124),
(21327,'enUS','Show me what you\'re made of, $n!','',26124),
(21328,'enUS','%s becomes enraged as his shield shatters.','',26124),
(21329,'enUS','Hah! You\'ve unleashed my pet! Your soul shall be its next meal.','',26124),
(21330,'enUS','Stand at attention, grunt!','',26124),
(21331,'enUS','OWWWW! Ok, ok, me go back to work!','',26124),
(21332,'enUS','HEY! No more booterang! Me sorry! Me work!','',26124),
(21333,'enUS','OOF! Booterang hurted me! Me tink work better den booterang!','',26124),
(21334,'enUS','WHY IT PUT DA BOOTERANG ON DA SKIN?? WHY??','',26124),
(21335,'enUS','ARGH! BOOTERANG!','',26124),
(21336,'enUS','AYAYA! One day me have dat booterang...','',26124),
(21337,'enUS','Whoever you are, trespasser, I shall make an example of you!','',26124),
(21338,'enUS','Such arrogance!','',26124),
(21339,'enUS','You over there!  I must speak with you!','',26124),
(21340,'enUS','A thousand curses upon you, $r!  This prison will not hold me for long!','',26124),
(21341,'enUS','You have nowhere to run, coward!','',26124),
(21342,'enUS','Broken of the Ashtongue tribe, your leader speaks!','',26124),
(21343,'enUS','The Betrayer no longer holds sway over us.  His dark magic over the Ashtongue soul has been destroyed!','',26124),
(21344,'enUS','Come out from the shadows!  I\'ve returned to lead you against our true enemy!  Shed your chains and raise your weapons against your Illidari masters!','',26124),
(21345,'enUS','I lost my booterang, Mudlump. I think it may have malfunctioned and is now stuck up the backside of a worthless peon.','I lost my booterang, Mudlump. I think it may have malfunctioned and is now stuck up the backside of a worthless peon.',26124),
(21346,'enUS','Get lost before I beat you with my booterang.','',26124),
(21347,'enUS','[DEBUG] Cast spell on me [DEBUG]','[DEBUG] Cast spell on me [DEBUG]',26124),
(21348,'enUS','Hail Akama!','',26124),
(21349,'enUS','Try and keep up, grunt.','',26124),
(21350,'enUS','Hail our leader!  Hail Akama!','',26124),
(21351,'enUS','Take of my life\'s essence, master!','',26124),
(21352,'enUS','%s becomes increasingly enraged as he sees his allies fall in battle!','%s becomes increasingly enraged as he sees his allies fall in battle!',26124),
(21353,'enUS','Stop your slacking and fight like a true fel orc!','Stop your slacking and fight like a true fel orc!',26124),
(21354,'enUS','I\'ve seen female Gnomes hit harder than you!','I\'ve seen female Gnomes hit harder than you!',26124),
(21355,'enUS','You call that an offense? I\'ve seen more offensive tallstriders!','You call that an offense? I\'ve seen more offensive tallstriders!',26124),
(21356,'enUS','If you don\'t start throwing some real punches, you\'ll be cleaning the drake stalls for a year!','If you don\'t start throwing some real punches, you\'ll be cleaning the drake stalls for a year!',26124),
(21357,'enUS','','Stop toying with my emotions!',26124),
(21358,'enUS','Oh, ye like me eyepatch now do ya?  Well, just make sure that ya don\'t have ta be wearing one yerself now $g boyo : girly;.','',26124),
(21359,'enUS','','Huh?  What?  I\'m a little busy here, friend!$B$BOf course, if you\'re here to help, I\'ve got all the time in the world.',26124),
(21360,'enUS','Debug Error: Out of Range','',26124),
(21361,'enUS','%s approaches and waits quietly.','',26124),
(21362,'enUS','I may be old but I can still take on a young whippersnapper like you, $n. Try not to fall behind...','',26124),
(21363,'enUS','Well, you won... I guess.','',26124),
(21364,'enUS','%s calls for an ally to assist him!','%s calls for an ally to assist her!',26124),
(21365,'enUS','%s rushes away to attack $n!','%s rushes away to attack $n!',26124),
(21366,'enUS','The %s appears ready to be wrangled.','',26124),
(21367,'enUS','The crystal prison begins to shatter!','',26124),
(21368,'enUS','The Skyguard are here! The Skyguard are here!','The Skyguard are here! The Skyguard are here!',26124),
(21369,'enUS','Woo hoo! Go Skyguard!','Woo hoo! Go Skyguard!',26124),
(21370,'enUS','','Wow!  Thanks for bringing it all the way back here.  You didn\'t have to do that.',26124),
(21371,'enUS','','You\'re a peach!  I\'ll make sure that the ray is properly cared for.',26124),
(21372,'enUS','','Thank you soooooo much for bringing it back.  I think you\'re going to be my best wrangler ever!',26124),
(21373,'enUS','','Oh, isn\'t she a beauty!  Can\'t wait to get her properly trained and back up in the air!',26124),
(21374,'enUS','','Isn\'t he so cute?!  Thanks for bringing him right to me!!!',26124),
(21375,'enUS','','We never have enough of these rays for the Skyguard.  You\'re keeping us afloat... literally!',26124),
(21376,'enUS','','Nice job!  She looks like she\'s in fine condition.  Thank you!',26124),
(21377,'enUS','','Woo hoo!  More rays for training!',26124),
(21378,'enUS','How dare you summon me, $n?','',26124),
(21379,'enUS','Burning eyes within the prism fill your mind with a sense of dread...','',26124),
(21380,'enUS','Place 35 Apexis Shards into the prism.','Place 35 Apexis Shards into the prism.',26124),
(21381,'enUS','The fel crystalforge can be used to transform your apexis shards into unstable flasks of the beast.  These flasks make the imbiber more agile, stronger and heartier.$B$BMake your choice, below.','',26124),
(21382,'enUS','Purchase 1 Unstable Flask of the Beast for the cost of 10 Apexis Shards','Purchase 1 Unstable Flask of the Beast for the cost of 10 Apexis Shards',26124),
(21383,'enUS','<As you place your apexis shards into the fel crystalforge and pull the lever, the device makes an unworldly sound as it grinds them into dust.  A few moments later your flask pops out of its \'mouth\'.>','',26124),
(21384,'enUS','Use the fel crystalforge to make another purchase.','Use the fel crystalforge to make another purchase.',26124),
(21385,'enUS','Purchase 5 Unstable Flasks of the Beast for the cost of 50 Apexis Shards','Purchase 5 Unstable Flasks of the Beast for the cost of 50 Apexis Shards',26124),
(21386,'enUS','<As you place your apexis shards into the fel crystalforge and pull the lever, the device makes an unworldly sound as it grinds them into dust.  A few moments later your flasks pop out of its \'mouth\'.>','',26124),
(21387,'enUS','The Bash\'ir crystalforge can be used to transform your apexis shards into unstable flasks of the sorcerer.  These flasks make the imbiber more intelligent, heartier, and increase the effectiveness of their damaging and healing magics.$B$BMake your choice, below.','',26124),
(21388,'enUS','Purchase 1 Unstable Flask of the Sorcerer for the cost of 10 Apexis Shards','Purchase 1 Unstable Flask of the Sorcerer for the cost of 10 Apexis Shards',26124),
(21389,'enUS','Use the Bash\'ir crystalforge to make another purchase.','Use the Bash\'ir crystalforge to make another purchase.',26124),
(21390,'enUS','<As you place your apexis shards within the hollow of the Bash\'ir crystalforge and pull the lever, the device literally disintegrates them.  A few moments later your flask appears at your feet.>','',26124),
(21391,'enUS','Purchase 5 Unstable Flasks of the Sorcerer for the cost of 50 Apexis Shards','Purchase 5 Unstable Flasks of the Sorcerer for the cost of 50 Apexis Shards',26124),
(21392,'enUS','<As you place your apexis shards within the hollow of the Bash\'ir crystalforge and pull the lever, the device literally disintegrates them.  A few moments later your flasks appear at your feet.>','',26124),
(21393,'enUS','We hope you\'ll be able to ease our headaches.  You try having ten sons, all of them wanting to do something they weren\'t meant for!$B$BStill, as a father, we do what we must.','',26124),
(21394,'enUS','Do you have any sons, $c?$B$BLet us tell you something, we think we were much happier before we came to Ogri\'la and the crystals made us more aware.  Before, we would have just bashed them over the head to get them to shut up.  Now all they do is bother us about the Sha\'tari Skyguard.$B$BIgnorance is bliss!','',26124),
(21395,'enUS','The boy\'s too stupid still to say it -- not enough crystal exposure yet -- but, he\'s thankful for what you did in getting him those flasks.$B$BNow, only nine more sons to go.  Gah!$B$B<Both of Torkus\'s heads sigh.>$B$BWant to take one of them off of our hands?  We\'ll sell him to you cheap.','',26124),
(21396,'enUS','As a relative newcomer to Ogri\'la, you don\'t have enough exposure to the crystals here to reap their full benefits.  Besides, you only have one head.$B$BWe, on the other hand, have been here a very long time.  So, as you can imagine, we\'re fairly well-versed in a great many things.$B$BOf late, we\'ve taken a keen interest in the demons of the forge camps.  More specifically, we\'ve devised a way to rid us of them for good.$B$BAt least, that\'s the theory.','',26124),
(21397,'enUS','We wish that we could create more than one darkrune in a day, but that would be a waste of time.  It\'s simply not physically possible.  Besides, we can\'t even reliably create them at that rate.$B$BAnd trust us, if there were anyone else here smart enough to help, they\'d be conscripted and we\'d have as many darkrunes as needed.','',26124),
(21398,'enUS','The Bash\'ir crystalforge can be used to transform your apexis shards into unstable flasks of the sorcerer.  These flasks make the imbiber more intelligent, heartier, and increase the effectiveness of their damaging and healing magics.$B$BIt appears, however, that you do not have the requisite ten shards to purchase even a single flask.','',26124),
(21399,'enUS','The fel crystalforge can be used to transform your apexis shards into unstable flasks of the beast.  These flasks make the imbiber more agile, stronger and heartier.$B$BIt appears, however, that you do not have the ten shards necessary to purchase even a single flask.','',26124),
(21400,'enUS','Opening','Opening',26124),
(21401,'enUS','Gahk new at Ogri\'la like little $r.  It like heaven da other ogres below always talk about.  But, Gahk\'s heads hurt from crystal making Gahk smarter.$B$B<Both of Gahk\'s heads nod to each other.>$B$BUs learning ta make da crystalforged darkrune.  When us learn dat, we smash da demon\'s warp-gate!','',26124),
(21402,'enUS','Gahk now smart!  Us know how ta make da darkrune into da crystalforged darkrune!','',26124),
(21403,'enUS','$n smash warp-gate good, but da demons make it strong again.$B$B$n bring Gahk another darkrune and Gahk make special crystalforged darkrune for $n!','',26124),
(21404,'enUS','Welcome to Ogri\'la, $c.$B$BThe ogres here have managed to gain a great mental acuity through the magical emanations of the surrounding crystals.  Though we do not fully understand how they work, we have come to appreciate our new home and only want to live in peace.$B$BUnfortunate then that the demons and ethereals, and especially the Black Dragonflight, will not leave us to that peace.','',26124),
(21405,'enUS','On behalf of all of Ogri\'la, we give you thanks for your efforts, $n.$B$B<Chu\'a\'lor\'s left head nods while his right head smiles at you.>$B$BAnd do not forget that by helping us here you are also helping to protect our brethren down below whom you have become like a $g king : queen; to.','',26124),
(21406,'enUS','When are we going to get some more magical flasks?','When are we going to get some more magical flasks?',26124),
(21407,'enUS','Have we taken enough magical flasks to join the Skyguard yet?','Have we taken enough magical flasks to join the Skyguard yet?',26124),
(21408,'enUS','The Skyguard need our help! We need to get more magical flasks.','The Skyguard need our help! We need to get more magical flasks.',26124),
(21409,'enUS','We can\'t wait to join the Skyguard. We just need to take a few more magical flasks, right?','We can\'t wait to join the Skyguard. We just need to take a few more magical flasks, right?',26124),
(21410,'enUS','You don\'t. You\'re not strong enough to participate in ranking matches yet. Still, you can find an Arena Battlemaster and get in some practice rounds. It\'s never too soon to start training.','You don\'t. You\'re not strong enough to participate in ranking matches yet. Still, you can find an Arena Battlemaster and get in some practice rounds. It\'s never too soon to start training.',26124),
(21411,'enUS','Look it\'s the Skyguard!!','Look it\'s the Skyguard!!',26124),
(21412,'enUS','Have you come to hurt me?  I have nothing to do with the war, $r.$B$BI\'m just a sickly scholar, please leave me alone!','',26124),
(21413,'enUS','The egg appears resilient as an egg of the Black Dragonflight rightfully should.  Perhaps if you were to place a great many apexis shards next to it, their vibrations would cause it to crack open?','',26124),
(21414,'enUS','The egg appears resilient as an egg of the Black Dragonflight rightfully should.  Perhaps if you were to place a great many apexis shards next to it, their vibrations would cause it to crack open?$B$BToo bad that you don\'t appear to have the thirty-five apexis shards necessary to do the job.','',26124),
(21415,'enUS','Place 35 Apexis Shards near the dragon egg to crack it open.','Place 35 Apexis Shards near the dragon egg to crack it open.',26124),
(21416,'enUS','<As you place the apexis shards into the nest surrounding the dragon egg, they begin to hum.  A few moments later a crack appears in the rugged shell, and a black dragon whelpling emerges, squalling for its mother.>','',26124),
(21417,'enUS','','<Angela coos to the felhunter again before turning her attention to you.>$B$BJir\'see\'s always been smaller than all the other felhunters, but that\'s never bothered him. And Outland\'s going to change all that, right Jir\'see?$B$BMomma\'s little angel is going to grow up to be a big, fierce felhunter, yes he is!',26124),
(21418,'enUS','Trope will show you how to fly like a Dragonmaw... You will show Trope how to die like a scrub.','',26124),
(21419,'enUS','You did well. Certainly a surprise to Trope... Report back to Ja\'y.','',26124),
(21420,'enUS','The %s screams out for its mother.','',26124),
(21421,'enUS','Let\'s get this over with...','',26124),
(21422,'enUS','You put up a hell of a fight, newbie. Hell of a fight...','',26124),
(21423,'enUS','I\'m taking this back to the old school. I\'ll be the Alliance and you be Frostwolf Village. BOMBS AWAY!','',26124),
(21424,'enUS','Thank you for that... It was humbling to be served in such a manner.','',26124),
(21425,'enUS','You\'re in for a rough ride, $n. I hope you\'ve already made funeral arrangements.','',26124),
(21426,'enUS','You\'re the best I\'ve ever seen. I can\'t believe I\'m saying this but you might have a chance against Skyshatter. And hey, if that doesn\'t go so well you can be my wing man...','',26124),
(21427,'enUS','The %s screams out for its father.','',26124),
(21428,'enUS','<As you place the apexis shards into the nest surrounding the dragon egg, they begin to hum.  A few moments later a crack appears in the rugged shell, and a black dragon whelpling emerges, squalling for its father.>','',26124),
(21429,'enUS','MULVERICK!','',26124),
(21430,'enUS','Prepare a funeral pyre! $n has challenged Skyshatter!','',26124),
(21431,'enUS','I... I am undone... The new top orc is $n!','',26124),
(21432,'enUS','I weep for you, $n. You really have no idea what you\'ve gotten yourself into...','',26124),
(21433,'enUS','The Cenarion Expedition rescued me from certain death inside the mines. I owe them my life! I offer up my services of repair and reagent sales to those that are allies of the Cenarion Expedition.','',26124),
(21434,'enUS','I am an ally of the Cenarion Expedition, Mortog. Show me your wares.','I am an ally of the Cenarion Expedition, Mortog. Show me your wares.',26124),
(21435,'enUS','It has been a long while since I fought a worthy adversary...','',26124),
(21436,'enUS','Now you shall witness the meaning of true power!','',26124),
(21437,'enUS','They did it!  Enemy down!  Return to base!','They did it!  Enemy down!  Return to base!',26124),
(21438,'enUS','Abort mission!  Our ground forces have been defeated.','Abort mission!  Our ground forces have been defeated.',26124),
(21439,'enUS','Enemy sighted!  Fall into formation and prepare for bombing maneuvers!','Enemy sighted!  Fall into formation and prepare for bombing maneuvers!',26124),
(21440,'enUS','You\'ll find plenty to do here, $n.','',26124),
(21441,'enUS','Battle Stance! Prepare for an offensive rush!','',26124),
(21442,'enUS','Ack, ye\'ve been busy now haven\'t ye?!  I canna thank ye enough for bombing them demons and resupplying us with mounts.$B$BYer making our job all the more easier.  Keep up the good work, $g laddy : lassie;!','',26124),
(21443,'enUS','Berserker Stance! Attack them recklessly!','',26124),
(21444,'enUS','Defensive Stance! Shield yourself against their blows and strike back!','',26124),
(21445,'enUS','Now that the flasks are ready, we can show the Skyguard our moves!','',26124),
(21446,'enUS','Watch out, Skyguard. Here comes Torkus Jr.!','',26124),
(21447,'enUS','Commander, sir! Cadet Torkus Jr. reporting for duty, sir!','',26124),
(21448,'enUS','Look here, lad. I admire your dedication, but I\'m not sure how to tell you this... You\'re an ogre, son.','',26124),
(21449,'enUS','Yes, sir. An ogre, sir. But give us a chance, sir! We\'ve been preparing for this since the first time the Skyguard flew over Ogri\'la, sir!','',26124),
(21450,'enUS','%s makes a gesture of dismissal and heads for the launch pad.','',26124),
(21451,'enUS','%s cowers in fear as it realizies what the ogre has in mind.','',26124),
(21452,'enUS','','We must re-establish our stranglehold on these mines!',26124),
(21453,'enUS','<The Murkblood overseer grunts.>','',26124),
(21454,'enUS','They sent you to kill me, eh? So predictable... Creatures ruled by terror are all the same.$B$BBut you... You are not one of them...','',26124),
(21455,'enUS','I am here for you, overseer.','I am here for you, overseer.',26124),
(21456,'enUS','How dare you question an overseer of the Dragonmaw!','How dare you question an overseer of the Dragonmaw!',26124),
(21457,'enUS','Overseer?$B$BYou are no more an overseer than I am the king of Stormwind. Yes... You are the one they speak of.','',26124),
(21458,'enUS','The Netherwing. They speak to us. They offered us peace and protection. Something the broken have never truly felt. We accepted their offer and assisted Toranaku in rousing the creatures of this mine - at great personal cost to us. Many of my brothers gave their lives for this offensive. We were attempting to make the mine uninhabitable, forcing the Dragonmaw to relocate and ultimately move off of this island.','',26124),
(21459,'enUS','Who speaks of me? What are you talking about, broken?','Who speaks of me? What are you talking about, broken?',26124),
(21460,'enUS','Continue please.','Continue please.',26124),
(21461,'enUS','The Dragonmaw are corrupt. They are strip-mining this island of all natural resources and using those resources to supply Illidan\'s armies out of the Black Temple. They take much for themselves, however, and sell whatever they have hidden away to the highest bidder.','',26124),
(21462,'enUS','Who are these bidders?','Who are these bidders?',26124),
(21463,'enUS','We do not know. We believe that the Black Dragonflight is involved as are some independent third parties. That is why you are here, $r. You will unravel this mystery from the inside and bring redemption to Netherwing.$B$BAnd now... I can only assume she asked you to bring back my hand.','',26124),
(21464,'enUS','Well... yes.','Well... yes.',26124),
(21465,'enUS','I gladly make such a sacrifice if it means the downfall of the Dragonmaw.','',26124),
(21466,'enUS','Aargh! If I must fall, I\'m taking you with me!','',26124),
(21467,'enUS','No, lad, not Bronco! He\'s not been broken yet! You\'ll get yerself killed up there!','',26124),
(21468,'enUS','Bronco bucks %s from its back and escapes into the wild!','',26124),
(21469,'enUS','Dreadmaw! You shall pay dearly, trespasser...','',26124),
(21470,'enUS','I must leave this place at once!','',26124),
(21471,'enUS','[DEBUG] THEN LET\'S GO!','[DEBUG] THEN LET\'S GO!',26124),
(21472,'enUS','Bronco? That sounds like a good one!','',26124),
(21473,'enUS','I don\'t think yer hearin\' me. Nether rays just aren\'t made for --','',26124),
(21474,'enUS','The Apexis Relic shimmers, betraying a hidden intelligence within.','',26124),
(21475,'enUS','Insert an Apexis Shard, and begin!','Insert an Apexis Shard, and begin!',26124),
(21476,'enUS','Come back, Mr. Bronco! We\'re gonna be in the Skyguard together!','',26124),
(21477,'enUS','The Apexis Monument looms above you.','',26124),
(21478,'enUS','Insert 35 Apexis Shards, and begin!','Insert 35 Apexis Shards, and begin!',26124),
(21479,'enUS','Thank you for helping us with the flasks.','',26124),
(21480,'enUS','No disturbances!  Zero tolerance!','',26124),
(21481,'enUS','Thanks for your help.  Let\'s get out of here!','',26124),
(21482,'enUS','%s hisses loudly at Torkus Jr.','',26124),
(21483,'enUS','Stand at attention, captain!','',26124),
(21484,'enUS','Let\'s keep moving.  I don\'t like this place.','',26124),
(21485,'enUS','Thanks again.  Sergeant Doryn will be glad to hear he has one less scout to replace this week.','',26124),
(21486,'enUS','Burning eyes within the prism fill your mind with a sense of dread... especially knowing that you don\'t have the thirty-five apexis shards needed to summon forth its demon.','',26124),
(21487,'enUS','I am ready to take on my challenger! Call him out!','I am ready to take on my challenger! Call him out!',26124),
(21488,'enUS','Nonsense!','',26124),
(21489,'enUS','','That is for Naisha!',26124),
(21490,'enUS','You\'ll go nowhere, Skyguard scum!','',26124),
(21491,'enUS','Skettis prevails!','',26124),
(21492,'enUS','No one escapes Skettis!','',26124),
(21493,'enUS','Death to our enemies!','',26124),
(21494,'enUS','The door to The Den of Mortal Delights has opened.','',26124),
(21495,'enUS','Skwak!','Skwak!',26124),
(21496,'enUS','You\'re a young hatchling aren\'t you?  My eyes fail me.$B$BI assume you\'re here to purchase one of my exotic texts?','',26124),
(21497,'enUS','Stare into the eyes of the Betrayer!','',26124),
(21498,'enUS','This is too easy!','',26124),
(21499,'enUS','Who shall be next to taste my blades?','',26124),
(21500,'enUS','You know nothing of power!','',26124),
(21501,'enUS','Feel the hatred of ten thousand years!','',26124),
(21502,'enUS','The controller can be used to activate the linked proton accelerator.  This will call forth one of Bash\'ir\'s harbingers, or perhaps Bash\'ir himself.$B$BAssuming, of course, that you have an accelerator module to activate the device.','',26124),
(21503,'enUS','The controller can be used to activate the linked proton accelerator.  This will call forth one of Bash\'ir\'s harbingers, or perhaps Bash\'ir himself.$B$BUnfortunate that you do not possess an accelerator module to activate the device.','',26124),
(21504,'enUS','Power the proton accelerator with an Accelerator Module to summon Bash\'ir, or one of his harbingers.','Power the proton accelerator with an Accelerator Module to summon Bash\'ir, or one of his harbingers.',26124),
(21505,'enUS','<Placing the requisite accelerator module within the space on the controller, you give it a final pull.  The module glows for a moment and its power is consumed as the device hums to life.>','',26124),
(21506,'enUS','You have won... Maiev. But the huntress... is nothing without the hunt. You... are nothing... without me.','',26124),
(21507,'enUS','','It is finished. You are beaten.',26124),
(21508,'enUS','','He\'s right. I feel nothing... I am... nothing.',26124),
(21509,'enUS','','Farewell, champions.',26124),
(21510,'enUS','Next time, show me the respect of at least being prepared!','',26124),
(21511,'enUS','Pitiful!  I will rend the flesh from your bones and wrack your soul for my pleasure!','',26124),
(21512,'enUS','Did you really think that you could fool my master into falling for your sad, little trap, $n?','',26124),
(21513,'enUS','Fools!','',26124),
(21514,'enUS','The Light will bless these dismal halls once again.... I swear it.','',26124),
(21515,'enUS','Forget Vixton\'s spread. You want the good stuff? You talk to Krixel here. I got just what you need, provided you got the right rep. You know, in the arena. This stuff isn\'t for sissies, kid.','',26124),
(21516,'enUS','I wish to queue for the Coliseum, Rulkster.','I wish to queue for the Coliseum, Rulkster.',26124),
(21517,'enUS','<Flaskataur flaps his majestic wings.>','',26124),
(21518,'enUS','Those who\'ve defiled this temple have all been defeated.  All but one!','',26124),
(21519,'enUS','Oh great Flaskataur, allow me to purchase your goods.','Oh great Flaskataur, allow me to purchase your goods.',26124),
(21520,'enUS','Let us finish what we\'ve started.  I will lead you to Illidan\'s abode once you\'ve recovered your strength.','',26124),
(21521,'enUS','The time has come to face Illidan, $n.  Are you ready?','',26124),
(21522,'enUS','I\'m ready, Akama.','I\'m ready, Akama.',26124),
(21523,'enUS','We\'re currently focus testing the Battle of Mount Hyjal. You must have at least HONORED reputation with the Violet Eye to participate.$B$BThat\'s the reputation you gain while doing Karazhan.','',26124),
(21524,'enUS','%s becomes increasingly enraged!','%s becomes increasingly enraged!',26124),
(21525,'enUS','Jimmy, can you please flag me for Mount Hyjal access?','Jimmy, can you please flag me for Mount Hyjal access?',26124),
(21526,'enUS','Jimmy, I want to buy something.','Jimmy, I want to buy something.',26124),
(21527,'enUS','Now that you\'re attuned to Mount Hyjal, I can teleport you to the Caverns of Time. Just let me know when you are ready.','',26124),
(21528,'enUS','I\'m ready for Mount Hyjal, Jimmy. Teleport me!','I\'m ready for Mount Hyjal, Jimmy. Teleport me!',26124),
(21529,'enUS','We\'re currently focus testing The Black Temple. You must have at least HONORED reputation with the Violet Eye to participate.$B$BThat\'s the reputation you gain while doing Karazhan.','',26124),
(21530,'enUS','I wish to purchase the key to the Black Temple and some phat lewtz.','I wish to purchase the key to the Black Temple and some phat lewtz.',26124),
(21531,'enUS','Now that you have your Black Temple key (Medallion of Karabor), I can teleport you directly to the Black Temple. Just tell me when you are ready.','',26124),
(21532,'enUS','I\'m ready to go to the Black Temple, Johnny.','I\'m ready to go to the Black Temple, Johnny.',26124),
(21533,'enUS','Welcome friend! What would you like to see?','',26124),
(21534,'enUS','Greetings $G brother:sister;. How can we be of service?','',26124),
(21535,'enUS','How can we help you?','',26124),
(21536,'enUS','Mighty one! How can we serve you?','',26124),
(21537,'enUS','We are honored by your presence, friend.  How can we serve you today?','',26124),
(21538,'enUS','Mighty one! We hope that you find our food to your satisfaction.','',26124),
(21539,'enUS','Our food should satisfy even the mightiest of hungers.','',26124),
(21540,'enUS','Still hungry $G brother:sister;? How can we help?','',26124),
(21541,'enUS','We have quite the feast for you friend.','',26124),
(21542,'enUS','What tasty treats can we offer you?','',26124),
(21543,'enUS','%s expires from battle.','',26124),
(21544,'enUS','%s arises to fight once more!','',26124),
(21545,'enUS','You are not alone, Akama.','',26124),
(21546,'enUS','Your people will always be with you!','',26124),
(21547,'enUS','','Hey, comrade.  If you get yourself in good with the Skyguard, I can offer you a direct flight to our base, Blackwind Landing, in the Skethyl Mountains.$B$BDo you like my beautiful nether ray?  It is lovely.',26124),
(21548,'enUS','I cannot do this alone...','',26124),
(21549,'enUS','','Hello, $n.  Need to quickly get to Blackwind Landing, our base in the Skethyl Mountains?  I\'ve got a pretty little nether ray ready.$B$BYou want to go now?  You just say the word, $g big guy : bunny;!',26124),
(21550,'enUS','Yes, I\'d love a ride to Blackwind Landing.','Yes, I\'d love a ride to Blackwind Landing.',26124),
(21551,'enUS','Hello, $g sir : ma\'am;!  If you want, I have a nether ray waiting to take you to the Skyguard Outpost atop the Blade\'s Edge Mountains.$B$BJust let me know.','',26124),
(21552,'enUS','Good day to you.  When you\'ve risen a bit more in the ranks of the Sha\'tari Skyguard, I will be able offer you a direct flight to the Skyguard Outpost, our base atop the Blade\'s Edge Mountains.','',26124),
(21553,'enUS','Absolutely!  Send me to the Skyguard Outpost.','Absolutely!  Send me to the Skyguard Outpost.',26124),
(21554,'enUS','I thank you for your aid, brothers.  Our people will be redeemed!','',26124),
(21555,'enUS','Be wary, friends. The Betrayer meditates in the court just beyond.','',26124),
(21556,'enUS','What do you hope to accomplish from this, insect?','',26124),
(21557,'enUS','I WILL CRUSH YOU LIKE A GNAT!','',26124),
(21558,'enUS','You cannot stop us!','',26124),
(21559,'enUS','You are making me angry, mortal!','',26124),
(21560,'enUS','I will break you in two! Relent, fool!','',26124),
(21561,'enUS','Flee now while you still have your life!','',26124),
(21562,'enUS','Be reasonable! You cannot hope to stop the Burning Legion! Let us discuss this in a civilized manner. I can offer you power beyond your wildest dreams!','',26124),
(21563,'enUS','This door is all that stands between us and the Betrayer.  Stand aside, friends.','',26124),
(21564,'enUS','Forgetting your skill in Spellfire Tailoring is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Spellfire Tailoring to create!','Forgetting your skill in Spellfire Tailoring is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Spellfire Tailoring to create!',26124),
(21565,'enUS','We\'ll let you in on our secret diet: Cocktails and dreams. We can help you with one.','',26124),
(21566,'enUS','I wish to unlearn Spellfire Tailoring.','I wish to unlearn Spellfire Tailoring.',26124),
(21568,'enUS','Everyone\'s gotta drink. What can we get for you?','',26124),
(21569,'enUS','Forgetting your knowledge is an expensive endeavor.  Are you willing to pay the cost?','Forgetting your knowledge is an expensive endeavor.  Are you willing to pay the cost?',26124),
(21570,'enUS','Greetings $G brother:sister;, how can we help?','',26124),
(21571,'enUS','Our drinks should quench even the mightiest of thirsts.','',26124),
(21572,'enUS','Don\'t ya have something better ta do, $g lad : lass; than jaw with me?$B$BNow get out there and prove yer mettle!','',26124),
(21573,'enUS','That\'s the spirit, $g laddy : lassie;!  Yer making all of us proud with all o\' the work ye be doing!$B$BAnd ya know, if ya want a quick trip ta our other base in the Skethyl Mountains, go down an talk ta Skyguard Handler Irena.  She\'ll set ya up nicely.','',26124),
(21574,'enUS','Yer gettin\' ta be something of a revered figure \'round here, $g boy : girl;!  If\'n I didn\'t know better, I\'d say ye were gunnin\' fer me job!!!$B$BAll the same, if ye keep up the way ye have been, ye\'ll deserve it!','',26124),
(21575,'enUS','Drink or be gone!','',26124),
(21576,'enUS','What can I say, $n?  Yer the finest o\' the Sha\'tari Skyguard!$B$BJust don\'t be lettin\' that go ta yer head.  I can still teach ya a thing or two, $g lad : lass;!$B$B<Sky Commander Keller grins at you and winks.>','',26124),
(21577,'enUS','','I see that you\'ve been putting in your time around here, $c.$B$BPut in more; the demons aren\'t gone yet, rookie.',26124),
(21578,'enUS','','Your name seems to be on everyone\'s lips around the outpost.  Don\'t let it get to your head; I know that you can do better!$B$BI\'ll be watching you, rookie.',26124),
(21579,'enUS','How can we be of service, exalted one?','',26124),
(21580,'enUS','','Alright, I admit it, you\'ve proven yourself and then some, $n.$B$BIf I was hard on you before it was because I saw the spark of a true Skyguard within you.  I dare say that you\'re the finest ace that we have!$B$BAnytime that you want to help out, I\'ll be more than proud to hand you another set of bombs.',26124),
(21581,'enUS','We are happy to provide you with supplies.','',26124),
(21582,'enUS','Honored $G brother:sister;, how can we help?','',26124),
(21583,'enUS','','Hey there, $c!$B$B<Khatie looks at you slyly.>$B$BAnytime you want to wrangle us up some more aether rays, you make sure to come and see me!',26124),
(21584,'enUS','Friend! It\'s been too long.  What can we get for you?','',26124),
(21585,'enUS','What are you looking for?','',26124),
(21586,'enUS','','You know, $n, it\'s such an honor to work with you!$B$BWhen you\'re not busy wrangling, maybe we could $g go out some place for dinner? : get together for a girl\'s night?;$B$BOh, did I mention that we can now get you to our base in the Skethyl Mountains real quick?  If you want, speak with Skyguard Handler Irena about that.',26124),
(21587,'enUS','','So, you\'ve been around a lot, but we seem to keep missing each other for getting together after work.$B$BIs it me?$B$B<Khatie purposely cheers up.>$B$BAnyway, I just wanted to say that I... we really appreciate everything that you\'ve been doing for the Skyguard!',26124),
(21588,'enUS','','I hope you don\'t think I\'m a stalker, or anything like that, $n.$B$BI mean, I know that you\'re real famous within the Skyguard now, and well... I\'m sure that you wouldn\'t want to hang out with a lowly peon like me.$B$BBut, if you ever want to get together to just hang out, or even wrangle some more rays, drop by anytime!  I\'ll be here.$B$BI miss you...',26124),
(21589,'enUS','The relics are truly a great mystery.  Perhaps by studying them regularly, you will gain a finer appreciation of their capabilities.','',26124),
(21590,'enUS','<Chu\'a\'lor\'s left head says,>$B$BWe find your zeal to help us most appealing...$B$B<His right head concludes,>$B$B... and we want you to know that we greatly appreciate your efforts!','',26124),
(21591,'enUS','Steel isn\'t strong, exalted one, flesh is stronger. Steel gains its strength from the one who wields it. But enough of that... How can we help you exalted one?','',26124),
(21592,'enUS','Your name is beginning to be revered around here.$B$B<Chu\'a\'lor\'s left eye pierces you with its stony gaze.>$B$BKeep up the good work, $n!','',26124),
(21593,'enUS','First you became $g king : queen; of the ogres below, and now you have exalted yourself amongst us of Ogri\'la.$B$BThis is unheard of for a $r, and yet, there you stand as living proof.  I thank you, $n, and we all owe you a debt that we will never truly be able to repay!','',26124),
(21594,'enUS','There are few things you can trust in life. Steel, you can trust.','',26124),
(21595,'enUS','It\'s an honor to have a $r such as yourself aiding us ogres.  You\'re keeping our hope of a better future alive.$B$BNow if we could just get rid of these headaches.  Are you sure you don\'t want one of our sons?','',26124),
(21596,'enUS','What is steel compared to the hand that shapes it?','',26124),
(21597,'enUS','It\'s amazing how much you\'ve helped us out.  We dare say that if it weren\'t for you, we\'d already have been overrun by the demons, or fried to a crisp by the Black Dragonflight!$B$BOn a side note, we did mention that we\'d sell you one of our sons, cheap, right?  No, not interested?','',26124),
(21598,'enUS','Here in Ogri\'la we have time to contemplate the riddle of steel. But enough of that, how can we help?','',26124),
(21599,'enUS','Do you have steel that needs shaping?','',26124),
(21600,'enUS','We cannot thank you enough for everything you\'ve done to protect our family, $n.$B$BAnd, you do realize that we were joking before when we offered to sell you one of our sons?  No, really... although we do feel a couple more headaches coming on.$B$BJunior, be still, will you?!','',26124),
(21601,'enUS','Us starting ta like little $n!  Yous bashem da demons real good!','',26124),
(21602,'enUS','Gahk like little, $r $n.  Yous kill da big demon; make all da little demons scared!$B$B<Gahk\'s heads both grin at you.>','',26124),
(21603,'enUS','Us sure see yous here all da time!$B$BChu\'a\'lor say little $r our $g hero : heroine;!$B$B$n like one of us ogres now.  Only, Gahk confused because $n need to be bigger for dat!','',26124),
(21604,'enUS','What can we get for you, our exalted $G brother:sister;?','',26124),
(21605,'enUS','How might we be of assistance?','',26124),
(21606,'enUS','You will regret this, mortal! Reth\'hedron will return... I will have my vengeance!','',26124),
(21607,'enUS','','Since the sparrowhawks have proven such a success in hunting down the raven stones, Watcher Elaira has trained another one to relay my voice at a great distance. He can help us communicate as you investigate the bird spirits revealed in the tablet!',26124),
(21608,'enUS','Honored $G brother:sister;, how may we help?','',26124),
(21609,'enUS','Hello friend! What can we do for you?','',26124),
(21610,'enUS','We are here to help.','',26124),
(21611,'enUS','You\'ve been making quite a name for yourself around here, $r.  Good for you.$B$BWe trust that you won\'t let that go to your single head, and that you\'ll still help out by banishing demons?','',26124),
(21612,'enUS','We are humbled by your selflessness, $n.  If in the past we\'ve seemed a bit conceited, realize that it is by your example that we were able to change our attitudes.$B$BWe thank you, and hope that you\'ll continue to assist us in our struggle against the forge camps.','',26124),
(21613,'enUS','Get over there and realign The Crystal Forge.','',26124),
(21614,'enUS','About time you showed up!  That forge has been busted for almost an hour!','',26124),
(21615,'enUS','What have you done you fools?','',26124),
(21616,'enUS','Incompetent fools!  Why must we suffer your stupidity?','',26124),
(21617,'enUS','I shall add another year to your enslavement for your failure!','',26124),
(21618,'enUS','You having a good time here with us in Ogri\'la?$B$BWe have a lot of stuff that our ogres are making, day and night.  We save the best to sell to our coolest guests like you!$B$BSo, as you\'re out there doing your thing, and making the mountains a safer place, stop by from time to time to see what we have.$B$BGood luck out there, $g man : chicky;.','',26124),
(21619,'enUS','Rangers, listen up! We stand ready to take the pain directly to the heathen Bash\'ir devils.  Our mission is simple. Hold the area long enough to get accurate readings on their new technology.  ','',26124),
(21620,'enUS','But don\'t underestimate our enemies.  We are invading them.  We are taking the fight to them.  We have them backed into a corner and they will strike back.','',26124),
(21621,'enUS','We are Skyguard!  This is what we are trained to do.  We do not retreat, we do not surrender.  We will see our mission through even if it means death! We will secure that information or we will die on the field of battle.','',26124),
(21622,'enUS','Anyone have any questions?','',26124),
(21623,'enUS','You are about to find out!','',26124),
(21624,'enUS','Skyguard Rangers, MOUNT UP!!','',26124),
(21625,'enUS','Look man, I only need to know one thing, where they are.','Look man, I only need to know one thing, where they are.',26124),
(21626,'enUS','What is it that you want?','',26124),
(21627,'enUS','I am an envoy of Balthas. He has sent me to collect a flawless arcane essence.','I am an envoy of Balthas. He has sent me to collect a flawless arcane essence.',26124),
(21628,'enUS','Jho\'nass, let me see what you have to offer.','Jho\'nass, let me see what you have to offer.',26124),
(21629,'enUS','Sky Commander Keller, I don\'t like my Deathwing Brood Cloak.','Sky Commander Keller, I don\'t like my Deathwing Brood Cloak.',26124),
(21630,'enUS','Ye don\'t?  But ya worked so hard ta get it!  Well, $g lad : lass;, if ya want, I\'ll take it off o\' yer hands fer a fair price.$B$BHow does an exchange of yer cloak fer an apexis crystal sound ta ye?','',26124),
(21631,'enUS','<Overlord Mor\'ghor salutes.>','',26124),
(21632,'enUS','Defenders, show these mongrels the fury of a Scryer!','',26124),
(21633,'enUS','Stand tall, soldiers. Show them no quarter!','',26124),
(21634,'enUS','<Call forth Terokk.>','<Call forth Terokk.>',26124),
(21635,'enUS','That sounds fine to me.','That sounds fine to me.',26124),
(21636,'enUS','Are ya sure, $g laddy : lassie;?  Once I trade ya, I ain\'t gonna trade it back.','',26124),
(21637,'enUS','Yes, I\'m sure.  I want to exchange my Deathwing Brood Cloak for an Apexis Crystal.','Yes, I\'m sure.  I want to exchange my Deathwing Brood Cloak for an Apexis Crystal.',26124),
(21638,'enUS','Very well, I\'m sure that I can find a Skyguard out there that can make use o\' the cloak.$B$BThere\'s yer apexis crystal.  I hope it makes ya happier than that cloak did.','',26124),
(21639,'enUS','Who calls me to this world?  The stars are not yet aligned... my powers fail me!  You will pay for this!','',26124),
(21640,'enUS','Peace, child, your time has not yet come. Remain here and witness that which is to unfold.','',26124),
(21641,'enUS','Hey, remember, $n, we\'ll make this stuff available for you to buy as you do good deeds.  It\'s like a karma thing, or something.$B$BSo, help out where you can, including with our Skyguard friends just to the north.$B$BAwesome... thanks!','',26124),
(21642,'enUS','Chu\'a\'lor\'s been saying good things about you, $n.  If you want, we have a couple of special ogre brews for sale.$B$BThey\'re really tasty!','',26124),
(21643,'enUS','You\'re like something of a revered figure around here, $g man : kitten;.  Seems like everyone\'s talking about you.  That\'s cool.$B$BLet\'s see if there\'s something in stock that you\'re interested in.  We have a lot of nice stuff.','',26124),
(21644,'enUS','What can we say, $n?  $G Dude : Dudette;, anything that we have in the store is yours to purchase!$B$BRight on!','',26124),
(21645,'enUS','That is a dangerous train of thought.  If something was truly amiss, Soridormi would be the first to know.','',26124),
(21646,'enUS','','Do you think the rumors about the Infinite Dragonflight are true?  I\'ve sensed it... the familiarity.',26124),
(21647,'enUS','I love when they do that.','I love when they do that.',26124),
(21648,'enUS','Heads up!','Heads up!',26124),
(21649,'enUS','Let\'s go!','Let\'s go!',26124),
(21650,'enUS','Come on!','Come on!',26124),
(21651,'enUS','Come and get it!','Come and get it!',26124),
(21652,'enUS','Oh, you want some of this?','Oh, you want some of this?',26124),
(21653,'enUS','LET\'S ROCK!','LET\'S ROCK!',26124),
(21654,'enUS','Who\'s next?','Who\'s next?',26124),
(21655,'enUS','KILL THEM ALL!','',26124),
(21656,'enUS','BURN IT DOWN!','',26124),
(21657,'enUS','%s feeds on the freshly-killed warp chaser.','',26124),
(21658,'enUS','I wish to unlearn Shadoweave Tailoring.','I wish to unlearn Shadoweave Tailoring.',26124),
(21659,'enUS','I wish to unlearn Mooncloth Tailoring.','I wish to unlearn Mooncloth Tailoring.',26124),
(21660,'enUS','Forgetting your skill in Spellfire Tailoring is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Spellfire Tailoring to create!$b$bAre you absolutely sure?','Forgetting your skill in Spellfire Tailoring is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Spellfire Tailoring to create!$b$bAre you absolutely sure?\n',26124),
(21661,'enUS','Forgetting your skill in Shadoweave Tailoring is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Shadoweave Tailoring to create!$b$bAre you absolutely sure?\n','Forgetting your skill in Shadoweave Tailoring is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Shadoweave Tailoring to create!$b$bAre you absolutely sure?\n',26124),
(21662,'enUS','Forgetting your skill in Mooncloth Tailoring is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Mooncloth Tailoring to create!$b$bAre you absolutely sure?\n','Forgetting your skill in Mooncloth Tailoring is not something to do lightly.  If you choose to abandon it you will forget all recipes that require Mooncloth Tailoring to create!$b$bAre you absolutely sure?\n',26124),
(21663,'enUS','Victory to the Scryers! The Dragonmaw have been defeated!','',26124),
(21664,'enUS','We... are... lost.','',26124),
(21665,'enUS','Be judged by the Light!','',26124),
(21666,'enUS','Prepare to face the wrath of the light!','',26124),
(21667,'enUS','The hammer of justice shall now find you guilty!','',26124),
(21668,'enUS','Leave off. I don\'t have anything for the likes of you.','Leave off. I don\'t have anything for the likes of you.',26124),
(21669,'enUS','I look forward to teaching you the error of your ways.','',26124),
(21670,'enUS','You were expecting one of my harbingers?','',26124),
(21671,'enUS','Perhaps I\'ll be able to sell your hide on the market.  Then again, it\'s likely worthless.','',26124),
(21672,'enUS','And wheresoever did you find the module to activate that controller?  No matter, you won\'t be doing that again.','',26124),
(21673,'enUS','The master is busy, but I have time to come out and play!','',26124),
(21674,'enUS','Bash\'ir sends his regrets that he could not make it, but he sent me along to salve your disappointment.','',26124),
(21675,'enUS','Do you know what you\'re playing with, $n?  Here, allow me to educate you and your friends.','',26124),
(21676,'enUS','I have other matters to attend to for the master.  Let\'s make this quick so that I can get back to them.','',26124),
(21677,'enUS','You activated the accelerator with only this motley assemblage to back you up?','',26124),
(21678,'enUS','$n, allow me to give you some advice: tuck tail now and fly back down to the safety of the valleys below.','',26124),
(21679,'enUS','You think that you\'re $g man : woman; enough to take the depleted item from me?','',26124),
(21680,'enUS','So many fools, so little time!','',26124),
(21681,'enUS','A $c and $g his : her; friends... how quaint.  This shouldn\'t take long.','',26124),
(21682,'enUS','','You haven\'t yet mastered the simplest of enchantments. Please, trouble Dolothos instead.',26124),
(21683,'enUS','Don\'t cry, $n.  It will all soon be over.  I promise not to spit upon your corpse.','',26124),
(21684,'enUS','','If you seek to advance your training beyond what I have to show you, you\'ll need to sully those fine clothes. Hgarth has unlocked a number of mysteries in our profession, and lurks in the hills behind Sun Rock Retreat in Stonetalon Mountains.',26124),
(21685,'enUS','The Dragonmaw must be stopped...','',26124),
(21686,'enUS','','What mysteries of the trade can I help you uncover today?',26124),
(21687,'enUS','Your laughable stitching is best observed by Talmar there; come back when you understand how to properly cure a hide, perhaps. Your work smells foul.','Your laughable stitching is best observed by Talmar there; come back when you understand how to properly cure a hide, perhaps. Your work smells foul.',26124),
(21688,'enUS','I am older than you can fathom.  Show some respect!','',26124),
(21689,'enUS','As I shall consume your flesh, so too shall the Burning Legion consume your people!','',26124),
(21690,'enUS','What better teacher for working leather than one who lives encased in it daily and could make a fine pelt herself if she were to meet an unfortunate end? Una in Thunder Bluff can show you more than I, if you can stand the stench.','What better teacher for working leather than one who lives encased in it daily and could make a fine pelt herself if she were to meet an unfortunate end? Una in Thunder Bluff can show you more than I, if you can stand the stench.',26124),
(21691,'enUS','Come, come. If you\'ve properly prepared your leather for once, I\'ll show you how to fashion serviceable items.','Come, come. If you\'ve properly prepared your leather for once, I\'ll show you how to fashion serviceable items.',26124),
(21692,'enUS','I will make your death a quick one, $n.','',26124),
(21693,'enUS','Why don\'t you go hone your skills with Mirvedon first? He\'ll gladly show you the basics.','',26124),
(21694,'enUS','May whatever god you believe in have mercy on you.  For I will show you none.','',26124),
(21695,'enUS','I\'ve heard tell of a truly skilled smith across the sea named Saru Steelfury. The smithy in Orgrimmar is where you should head if you wish to ply your trade, $c. Best of luck.','',26124),
(21696,'enUS','Get away from my clutch!!!','',26124),
(21697,'enUS','Eager to die, are we?','',26124),
(21698,'enUS','You wish to test me?','',26124),
(21699,'enUS','Valiant effort.','',26124),
(21700,'enUS','Please. Show Razia your weak little concoctions if you must. Return to me when you can handle more... potent fare.','Please. Show Razia your weak little concoctions if you must. Return to me when you can handle more... potent fare.',26124),
(21701,'enUS','A glorious kill!','',26124),
(21702,'enUS','Your death is at hand, $n.  Savor these last moments.','',26124),
(21703,'enUS','You got... lucky.','',26124),
(21704,'enUS','You\'re not cut out for this.','',26124),
(21705,'enUS','Anar\'alah belore!','',26124),
(21706,'enUS','I know you by your stench, little $n.  Here, in my perch, is where your bones shall finally rest.','',26124),
(21707,'enUS','You wish to kill me? You first!','',26124),
(21709,'enUS','The Forsaken brew such intriguing and strong concoctions, don\'t you think? It comes from an inability to poison oneself with failures, I believe. Luckily for you, Doctor Herbert Halsey in the Undercity has already done the necessary research; all that remains is for you to visit him.','The Forsaken brew such intriguing and strong concoctions, don\'t you think? It comes from an inability to poison oneself with failures, I believe. Luckily for you, Doctor Herbert Halsey in the Undercity has already done the necessary research; all that remains is for you to visit him.',26124),
(21710,'enUS','I tire of interruptions from the insignificant.  Your time has come, $n!','',26124),
(21711,'enUS','','Flee or die!',26124),
(21712,'enUS','','My work is done.',26124),
(21713,'enUS','','As it should be.',26124),
(21714,'enUS','The Skyguard shall pay for your temerity, $n!','',26124),
(21715,'enUS','','Destiny... awaits.',26124),
(21716,'enUS','','No second chances!',26124),
(21717,'enUS','','For Quel\'Thalas! For the Sunwell!',26124),
(21718,'enUS','I believe that I shall feast upon both $r and ogre flesh tonight.','',26124),
(21719,'enUS','','I\'m full of surprises!',26124),
(21720,'enUS','Little $r, you will now come to appreciate my wrath!','',26124),
(21721,'enUS','You dare summon me?  Your insolence will be punished.','',26124),
(21722,'enUS','Come, $r. What formula interests you today?','Come, $r. What formula interests you today?',26124),
(21723,'enUS','The Aldor shall be victorious!','',26124),
(21724,'enUS','Common... such a crude language. Bandal!','',26124),
(21725,'enUS','Shorel\'aran.','',26124),
(21726,'enUS','You have dared to defile my perch and must now be cleansed in fire!','',26124),
(21727,'enUS','Belesa menoor!','',26124),
(21728,'enUS','Victory to the Aldor! The Dragonmaw have been defeated!','',26124),
(21729,'enUS','Diel ma\'ahn... orindel\'o.','',26124),
(21730,'enUS','Diel fin\'al.','',26124),
(21731,'enUS','Sha\'amoor ara mashal?','',26124),
(21732,'enUS','Shal\'mor sinabanal!','',26124),
(21733,'enUS','What\'s this?!  $n and $g his : her; friends come to play?','',26124),
(21734,'enUS','I have better things to do...','',26124),
(21735,'enUS','Selama am\'oronor!','',26124),
(21736,'enUS','Well done!','',26124),
(21737,'enUS','Lord Illidan, I...','',26124),
(21738,'enUS','Enjoy your final moments.','',26124),
(21739,'enUS','You are mine!','',26124),
(21740,'enUS','Horde will... crush you.','',26124),
(21741,'enUS','Time to feast.','',26124),
(21742,'enUS','More! I want more!','',26124),
(21743,'enUS','Drink your blood. Eat your flesh.','',26124),
(21744,'enUS','I hunger.','',26124),
(21745,'enUS','I\'ll rip the meat from your bones!','',26124),
(21746,'enUS','Beware: I live!','',26124),
(21747,'enUS','So... foolish.','',26124),
(21748,'enUS','Enough! No more!','',26124),
(21749,'enUS','On your knees!','',26124),
(21750,'enUS','I won\'t... be... ignored!','',26124),
(21751,'enUS','Beware, coward!','',26124),
(21752,'enUS','','You can have anything you desire... for a price.',26124),
(21753,'enUS','','Fulfillment is at hand.',26124),
(21754,'enUS','','Yes, you\'ll stay with us now...',26124),
(21755,'enUS','','Be careful what you wish for.',26124),
(21756,'enUS','','Your reach exceeds your grasp.',26124),
(21757,'enUS','','I\'ll be waiting.',26124),
(21758,'enUS','','I won\'t be far!',26124),
(21759,'enUS','Pain and suffering are all that await you!','',26124),
(21760,'enUS','Don\'t leave me alone!','',26124),
(21761,'enUS','Look at what you made me do!','',26124),
(21762,'enUS','I didn\'t ask for this!','',26124),
(21763,'enUS','The pain is only beginning...','',26124),
(21764,'enUS','I don\'t want to go back!','',26124),
(21765,'enUS','Now what do I do?','',26124),
(21766,'enUS','','You play, you pay.',26124),
(21767,'enUS','','I\'m not impressed.',26124),
(21768,'enUS','','Enjoying yourselves?',26124),
(21769,'enUS','','So... business or pleasure?',26124),
(21770,'enUS','','You seem a little tense...',26124),
(21771,'enUS','','Don\'t be shy.',26124),
(21772,'enUS','','I\'m all... yours.',26124),
(21773,'enUS','We are launching an assault on Bash\'ir Landing, to study their Crystalforge.  Help us if you can!  Our Skyguard Aether-tech will leave in about $4581d.','',26124),
(21774,'enUS','','Easy come, easy go.',26124),
(21775,'enUS','Ignore their blows, $n! They cannot harm you!','',26124),
(21776,'enUS','','So much for a happy ending.',26124),
(21777,'enUS','','I wasn\'t finished.',26124),
(21778,'enUS','Their magics are meaningless to you, $n!','',26124),
(21779,'enUS','Akama has no master. Not anymore.','',26124),
(21780,'enUS','Illidan will pay.','',26124),
(21781,'enUS','One step closer.','',26124),
(21782,'enUS','Uninvited guests!','',26124),
(21783,'enUS','There are more of them!','',26124),
(21784,'enUS','I will not last much longer!','',26124),
(21785,'enUS','No! Not yet!','',26124),
(21786,'enUS','The Light will bless these dismal halls once again... I swear it.','',26124),
(21787,'enUS','Fight on, friends! Kill him - and end the curse on my people!','',26124),
(21788,'enUS','Beware his gaze! Do not look into his eyes!','',26124),
(21789,'enUS','Slay all who see us... word must not get back to Illidan.','',26124),
(21790,'enUS','Now is the time, Maiev! Unleash your wrath!','',26124),
(21791,'enUS','Akama has no master. Not anymore.','',26124),
(21792,'enUS','','A discovery!  I need aid with these measurements... I\'ll send a signal to my colleague!',26124),
(21793,'enUS','','The disruptor towers over charged the crystalforge, and uncovered more secrets!  Hold them!  Hold them while we gather new data!',26124),
(21794,'enUS','','At last!  The information we seek!  Gather quickly, skyguard.  We must soon return to headquarters with our findings!',26124),
(21795,'enUS','This forge can make unstable concoctions... to study them, I need Apexis Shards!','',26124),
(21796,'enUS','I am growing amazing crystals from these waters.  For catalysts, I must have more Apexis shards!','',26124),
(21797,'enUS','Its properties are amazing!  Provide me with Apexis crystals, and I\'ll form weapons and armor within crystal geodes.','',26124),
(21798,'enUS','Come, $n. Lord Stormrage awaits.','',26124),
(21799,'enUS','Warriors of Dragonmaw, gather \'round! One among you has attained the rank of highlord! Bow your heads in reverence! Show your respect and allegiance to Highlord $n!','',26124),
(21800,'enUS','Lord Illidan will be here shortly.','',26124),
(21801,'enUS','The pile of skulls reeks of foulness.  You fear the arakkoa have made an addition to the pile fairly recently.\n\nYou will need 10 Time-Lost Scrolls to call forth the descendants of Terokk\'s adversaries.','',26124),
(21802,'enUS','All hail Lord Illidan!','',26124),
(21803,'enUS','Lord Illidan, this is the Dragonmaw that I, and others, have told you about. He will lead us to victory!','',26124),
(21804,'enUS','What is the meaning of this, Mor\'ghor?','',26124),
(21805,'enUS','But... My lord, I do not understand. $n... He is the orc that has...','',26124),
(21806,'enUS','A terrible, dark energy emanates from this pile of skulls.','',26124),
(21807,'enUS','SILENCE!','',26124),
(21808,'enUS','Blathering idiot. You incomprehensibly incompetent buffoon...\n','',26124),
(21809,'enUS','THIS is your hero?','',26124),
(21810,'enUS','You have been deceived, imbecile.','',26124),
(21811,'enUS','This... whole... operation... HAS BEEN COMPROMISED!','',26124),
(21812,'enUS','I expect to see this insect\'s carcass in pieces in my lair within the hour. Fail and you will suffer a fate so much worse than death.','',26124),
(21813,'enUS','I seem to have misplaced my ring.','I seem to have misplaced my ring.',26124),
(21814,'enUS','Need supplies for the field?','',26124),
(21815,'enUS','How can I outfit you today, sir?','',26124),
(21816,'enUS','Need to requisition some supplies?','',26124),
(21817,'enUS','My $g lord : lady;.','My $g lord : lady;.',26124),
(21818,'enUS','I am honored by your presence, $t lord : lady; $n.','I am honored by your presence, $t lord : lady; $n.',26124),
(21819,'enUS','Look, there\'s $n!','Look, there\'s $n!',26124),
(21820,'enUS','With you here, we\'re saved, $n.','With you here, we\'re saved, $n.',26124),
(21821,'enUS','If only there were more $g heroes : heroines; such as yourself, $n.','If only there were more $g heroes : heroines; such as yourself, $n.',26124),
(21822,'enUS','$n, I hope that you\'re staying for a while.  Stop by later if you have the time.','$n, I hope that you\'re staying for a while.  Stop by later if you have the time.',26124),
(21823,'enUS','It will be done, my lord.','',26124),
(21824,'enUS','So you thought to make a fool of Mor\'ghor, eh? Before you are delivered to Lord Illidan, you will feel pain that you could not know to exist. I will take pleasure in exacting my own vengeance.','',26124),
(21825,'enUS','You will not harm the $g boy:girl;, Mor\'ghor! Quickly, $n, climb on my back!','',26124),
(21826,'enUS','I seem to have misplaced my key.','I seem to have misplaced my key.',26124),
(21827,'enUS','You can never be too prepared.','',26124),
(21828,'enUS','You have arrived!','',26124),
(21829,'enUS','Greetings, traveler.','Greetings, traveler.',26124),
(21830,'enUS','I have lost my reins. Could you provide me with another?','I have lost my reins. Could you provide me with another?',26124),
(21831,'enUS','Our Aether-tech and his escort are heading to Bash\'ir Landing.  Meet them there and help with their mission!','',26124),
(21832,'enUS','Our Skyguard Aether-tech and her escort is studying the Bash\'ir crystal forge.  She needs help!  Go to Bash\'ir Landing, find the aether-tech and keep her safe!','',26124),
(21833,'enUS','I\'ve made up my mind.  Make me forget my tailoring specialty!','I\'ve made up my mind.  Make me forget my tailoring specialty!',26124),
(21834,'enUS','Hey look, it\'s $n!','',26124),
(21835,'enUS','$n, slay any dragons today?','',26124),
(21836,'enUS','We are honored by your presence, little $g brother : sister; $n.','',26124),
(21837,'enUS','We heard that $n single-handedly took out a forge camp!','',26124),
(21838,'enUS','Now that $n is here, we won\'t need to worry about the Burning Legion any longer.','',26124),
(21839,'enUS','$n, $g king : queen; of the ogres, is here!','',26124),
(21840,'enUS','Thank you for helping us, $n.','',26124),
(21841,'enUS','$n is our $g hero : heroine;!','',26124),
(21842,'enUS','$n, how are you today?','',26124),
(21843,'enUS','Three cheers for $n!','',26124),
(21844,'enUS','$n, how are you?','',26124),
(21845,'enUS','We hope you\'re staying for a while, $n.  Stop by later and we\'ll catch up on old times.','',26124),
(21846,'enUS','If it weren\'t for $n, where would we be now?','',26124),
(21847,'enUS','$n, how many hundreds of demons have you banished?','',26124),
(21848,'enUS','We heard that $n figured out how to use the apexis relics and monuments!','',26124),
(21849,'enUS','You could all learn a lot from $n!','',26124),
(21850,'enUS','No violence in Ogri\'la!','',26124),
(21851,'enUS','Keep your fight away from Ogri\'la!','',26124),
(21852,'enUS','Not in here!','',26124),
(21853,'enUS','You bring violence to Ogri\'la?','',26124),
(21854,'enUS','Look, it $n!','',26124),
(21855,'enUS','$n, slay dragon?','',26124),
(21856,'enUS','We glad, little $g brother : sister; $n here.','',26124),
(21857,'enUS','$n take out forge camp all by $g himself : herself;!','',26124),
(21858,'enUS','$n here... we not worry \'bout Burning Legion any more.','',26124),
(21859,'enUS','$n, $g king : queen; of da ogres here!','',26124),
(21860,'enUS','Thanks, $n.','',26124),
(21861,'enUS','$n is Gahk\'s $g hero : heroine;!','',26124),
(21862,'enUS','How $n today?','',26124),
(21863,'enUS','Gahk like $n!','',26124),
(21864,'enUS','$n, Gahk\'s friend.','',26124),
(21865,'enUS','Gahk hope $n stay a while.  $n visit Gahk later.','',26124),
(21866,'enUS','$n smash da demons.  Save Ogri\'la!','',26124),
(21867,'enUS','Little $n crush all da demons.','',26124),
(21868,'enUS','Gahk hear dat $n know how use da apexis relics!','',26124),
(21869,'enUS','Yous all listen ta $n!','',26124),
(21870,'enUS','Forgetting your skill in Potion Mastery is not something to do lightly.\n\nAre you absolutely sure?','Forgetting your skill in Potion Mastery is not something to do lightly.\n\nAre you absolutely sure?',26124),
(21871,'enUS','Forgetting your skill in Elixir Mastery is not something to do lightly.\n\nAre you absolutely sure?','Forgetting your skill in Elixir Mastery is not something to do lightly.\n\nAre you absolutely sure?',26124),
(21872,'enUS','Forgetting your skill in Transmutation Mastery is not something to do lightly.\n\nAre you absolutely sure?','Forgetting your skill in Transmutation Mastery is not something to do lightly.\n\nAre you absolutely sure?',26124),
(21873,'enUS','I\'ve made up my mind.  Make me forget my alchemy mastery!','I\'ve made up my mind.  Make me forget my alchemy mastery!',26124),
(21874,'enUS','I wish to unlearn Potion Mastery.','I wish to unlearn Potion Mastery.\n',26124),
(21875,'enUS','I wish to unlearn Elixir Mastery.','I wish to unlearn Elixir Mastery.\n',26124),
(21876,'enUS','I wish to unlearn Transmutation Mastery.','I wish to unlearn Transmutation Mastery.\n\n',26124),
(21877,'enUS','All of Illidan\'s lieutenants have fallen, $n.  The way forward is open, if you\'re ready.','',26124),
(21878,'enUS','%s seethes in anger!','',26124),
(21879,'enUS','I\'m ready.  Take me to the Chamber of Command.','I\'m ready.  Take me to the Chamber of Command.',26124),
(21880,'enUS','Illidan\'s lackeys still guard these halls, $n.  Once they are defeated, my powers will allow me to take you deeper inside the temple.','',26124),
(21881,'enUS','They called me down from K\'aresh to deal with this band of misfits?  Unbelievable!  Prepare to be collected!','',26124),
(21882,'enUS','Rider $n, good to see you.','Rider $n, good to see you.',26124),
(21883,'enUS','Hey, it\'s our ace flyer, $n!','Hey, it\'s our ace flyer, $n!',26124),
(21884,'enUS','I heard that $n is gunning to be the captain of the air group.','I heard that $n is gunning to be the captain of the air group.',26124),
(21885,'enUS','Look who\'s here.  It\'s $n, our top gun.','Look who\'s here.  It\'s $n, our top gun.',26124),
(21886,'enUS','$n, do you feel the need -- the need for speed?','$n, do you feel the need -- the need for speed?',26124),
(21887,'enUS','Enough!  I will take care of these fools myself!','',26124),
(21888,'enUS','Good hunting up there, $n!','Good hunting up there, $n!',26124),
(21889,'enUS','Buzz the landing pad lately, $n?','Buzz the landing pad lately, $n?',26124),
(21890,'enUS','$G Mister : Lady; $n, what an unexpected pleasure, $g sir : ma\'am;.','$G Mister : Lady; $n, what an unexpected pleasure, $g sir : ma\'am;.',26124),
(21891,'enUS','A-TEN-HUT, officer $n on the deck!','A-TEN-HUT, officer $n on the deck!',26124),
(21892,'enUS','With $n on the job, we have nothing to worry about.','With $n on the job, we have nothing to worry about.',26124),
(21893,'enUS','$n, terror of the skies, how are you doing?','$n, terror of the skies, how are you doing?',26124),
(21894,'enUS','They say that $n has never been shot down.','They say that $n has never been shot down.',26124),
(21895,'enUS','Heh, the skies aren\'t so friendly with $n flying them!','Heh, the skies aren\'t so friendly with $n flying them!',26124),
(21896,'enUS','Well one thing\'s for sure, $n\'s not a nugget any more!','Well one thing\'s for sure, $n\'s not a nugget any more!',26124),
(21897,'enUS','$n, how\'s your mount holding up?  Pretty rough up there these days?','$n, how\'s your mount holding up?  Pretty rough up there these days?',26124),
(21898,'enUS','Well, if it isn\'t our resident $g flyboy : flygirl;, $n.  How\'s it going, ace?','Well, if it isn\'t our resident $g flyboy : flygirl;, $n.  How\'s it going, ace?',26124),
(21899,'enUS','I sense you\'ve cleared the path to my brethren.  My connection to them and to the temple is still strong.  Do you wish to delve deeper inside?','',26124),
(21900,'enUS','My brethren were here not long ago.  My connection to them has grown tenuous.  A powerful presence in the courtyard guards the way forward.','',26124),
(21901,'enUS','Take me to the other Deathsworn, Olum.','Take me to the other Deathsworn, Olum.',26124),
(21902,'enUS','%s bares her fangs and hisses menacingly at those around her.','',26124),
(21903,'enUS','You capture Karrog!  Karrog smash you!','',26124),
(21904,'enUS','Hear the voices below the earth!  They call for your blood!','',26124),
(21905,'enUS','Furious winds envelop Vakkiz as he writhes menacingly towards you.','',26124),
(21906,'enUS','You\'re one of our bravest, $n.  All of the Skyguard is in your debt.','',26124),
(21907,'enUS','Do not... bring Terokk into our world, $n...  That would be... madness...','',26124),
(21908,'enUS','','',26124),
(21909,'enUS','I seem to have lost my Blackened Urn.','I seem to have lost my Blackened Urn.',26124),
(21910,'enUS','Echo of Medivh cheats!','',26124),
(21911,'enUS','Trying to cast on $n.','',26124),
(21912,'enUS','Only the most seasoned hunters of Illidan\'s minions gain access to my wares.$B$BYou will be considered worthy when your status with the Sha\'tar, Cenarion Expedition and the Aldor is exalted.','',26124),
(21913,'enUS','Only the most seasoned hunters of Illidan\'s minions gain access to my wares.$B$BYou will be considered worthy when your status with the Sha\'tar, Cenarion Expedition and the Scryers is exalted.','',26124),
(21914,'enUS','Welcome, $n. Bring me the marks that Illidan bestows upon his most powerful minions and I shall grant you access to my alchemical goods.','',26124),
(21915,'enUS','I have marks to redeem.','I have marks to redeem.',26124),
(21916,'enUS','I seem to have misplaced my Ashtongue Cowl.','I seem to have misplaced my Ashtongue Cowl.',26124),
(21917,'enUS','The arakkoa are hidden... everywhere!','',26124),
(21918,'enUS','Rest now, Adaris.  You need to recover your strength.','',26124),
(21919,'enUS','ONE!','ONE!',26124),
(21920,'enUS','TWO!','TWO!',26124),
(21921,'enUS','THREE!','THREE!',26124),
(21922,'enUS','FOUR!','FOUR!',26124),
(21923,'enUS','FIVE!','FIVE!',26124),
(21924,'enUS','The keg is tapped!  Now I would like to propose a toast.  Don\'t worry, I\'ll keep it short and sweet.','The keg is tapped!  Now I would like to propose a toast.  Don\'t worry, I\'ll keep it short and sweet.',26124),
(21925,'enUS','The gronn... the Legion... is there nothing you can\'t handle, $n?','',26124),
(21926,'enUS','The crystals sing a sweeter song when $n is around.','',26124),
(21927,'enUS','We hear that the dragons tremble in fear at the mere mention of $n.','',26124),
(21928,'enUS','Truly $n has been enlightened by the crystals.','',26124),
(21929,'enUS','$n! The crystals sing your praises!','',26124),
(21930,'enUS','We owe you a debt of gratitude $n.','',26124),
(21931,'enUS','Da Gronn... da Legion... $n beat dem all!','',26124),
(21932,'enUS','Da crystals sing da perdy song when little $n here.','',26124),
(21933,'enUS','Da dragons get scared when yous say $n\'s name.','',26124),
(21934,'enUS','Da crystals make $n smarter.','',26124),
(21935,'enUS','$n!  Da crystals sing about you!','',26124),
(21936,'enUS','Gahk owe little $n much thanks.','',26124),
(21937,'enUS','$n, you and I should race sometime.','$n, you and I should race sometime.',26124),
(21938,'enUS','I hear you fly without a parachute cloak, $n.','I hear you fly without a parachute cloak, $n.',26124),
(21939,'enUS','The list of Skyguard members is long and distinguished.  $n tops that list.','The list of Skyguard members is long and distinguished.  $n tops that list.',26124),
(21940,'enUS','$n is an officer and a $g gentleman : gentlewoman;.','$n is an officer and a $g gentleman : gentlewoman;.',26124),
(21941,'enUS','Ace pilot $n, 12 o\'clock!','Ace pilot $n, 12 o\'clock!',26124),
(21942,'enUS','Maybe one day $n will teach us a few of $g his : her; tricks?','Maybe one day $n will teach us a few of $g his : her; tricks?',26124),
(21943,'enUS','I\'d be honored to have you on my wing anytime, $n.','I\'d be honored to have you on my wing anytime, $n.',26124),
(21944,'enUS','$n, you are the Skyguard\'s best; make us proud!','$n, you are the Skyguard\'s best; make us proud!',26124),
(21945,'enUS','We still stand here only because of $n\'s help.','',26124),
(21946,'enUS','It\'s $n, mighty $c and $g brother : sister; to ogres everywhere!','',26124),
(21947,'enUS','We still here cuz $n help Ogri\'la!','',26124),
(21948,'enUS','$n da mighty $c is my little $g brother : sister;!','',26124),
(21949,'enUS','I\'ve lost the sparrowhawk whistle you gave me. Can you replace it?','I\'ve lost the sparrowhawk whistle you gave me. Can you replace it?',26124),
(21950,'enUS','Unseen arakkoa... they\'re all around us... watching us... waiting!','',26124),
(21951,'enUS','Drakes is my business, $n. I\'m authorized to sell them to our highest ranking officers.','',26124),
(21952,'enUS','I\'m interested in purchasing a new drake.','I\'m interested in purchasing a new drake.',26124),
(21953,'enUS','I\'ve lost my medallion, Xi\'ri.','I\'ve lost my medallion, Xi\'ri.',26124),
(21954,'enUS','This is madness!','This is madness!',26124),
(21955,'enUS','What do you need, $c?','',26124),
(21956,'enUS','I need a new Enchanted Illidari Tabard.','I need a new Enchanted Illidari Tabard.',26124),
(21957,'enUS','It\'s so good seeing so many of you here to celebrate this time honored festivity.  A celebration of this magnitude is long overdue.','It\'s so good seeing so many of you here to celebrate this time honored festivity.  A celebration of this magnitude is long overdue.',26124),
(21958,'enUS','Start the countdown!','Start the countdown!',26124),
(21959,'enUS','Supremus acquires a new target!','',26124),
(21960,'enUS','Enough games!','',26124),
(21961,'enUS','Level 1: Completed!','',26124),
(21962,'enUS','Game Over','',26124),
(21963,'enUS','Level 2: Completed!','',26124),
(21964,'enUS','Final Level: Completed!','',26124),
(21965,'enUS','Prepare to be incinerated!','',26124),
(21966,'enUS','Brewfest is almost here!','Brewfest is almost here!',26124),
(21967,'enUS','Can\'t you see I\'ve got work to do here?','Can\'t you see I\'ve got work to do here?',26124),
(21968,'enUS','Won\'t be long now until the Brewfest starts!  Come back later and check to see if we\'re done.','Won\'t be long now until the Brewfest starts!  Come back later and check to see if we\'re done.',26124),
(21969,'enUS','I can\'t wait until we\'re done setting up.  Then I can kick back and enjoy the festivities.','I can\'t wait until we\'re done setting up.  Then I can kick back and enjoy the festivities.',26124),
(21970,'enUS','Brewfest is a non-stop party.  Setting up for it, though, is non-stop work!','Brewfest is a non-stop party.  Setting up for it, though, is non-stop work!',26124),
(21971,'enUS','Let\'s get out of here!','',26124),
(21972,'enUS','Let\'s go!','Let\'s go!',26124),
(21973,'enUS','Kronk, tell me about the charged crystal foci.','Kronk, tell me about the charged crystal foci.',26124),
(21974,'enUS','The crystal foci?  Of course we\'ll explain it seeing as you only have half the brain power to figure it out.$B$BA depleted crystal focus can be combined with ten apexis shards in a simple process, which creates a charged crystal focus.  These charged foci have some healing properties, but more important is their use with a possessed demon.$B$BYou see, the charged focus can be used to enable a possessed demon to exhibit special powers.  After a time, Gahk will have a mission for you to do just that.','',26124),
(21975,'enUS','The crystal foci?  Of course we\'ll explain it seeing as you only have half the brain power to figure it out.$B$BA depleted crystal focus can be combined with ten apexis shards in a simple process, which creates a charged crystal focus.  These charged foci have some healing properties, but more important is their use with a possessed demon.$B$BYou see, the charged focus can be used to enable a possessed demon to exhibit special powers.  If you have a darkrune, Gahk will speak to you about that.','',26124),
(21976,'enUS','Hey! Lishten up!  I\'ve got... I have something important to talk about!  Shee... Wait... What wash I shaying?  Something aboutsh boats and floating... Yeah! Sho don\'t float on a boat... Thank you...','Hey! Lishten up!  I\'ve got... I have something important to talk about!  Shee... Wait... What wash I shaying?  Something aboutsh boats and floating... Yeah! Sho don\'t float on a boat... Thank you...',26124),
(21977,'enUS','Now you\'ll shee shome real fancy riding!','Now you\'ll shee shome real fancy riding!',26124),
(21978,'enUS','That\'ll leave a mark...  I\'ll just rest here for a bit.','That\'ll leave a mark...  I\'ll just rest here for a bit.',26124),
(21979,'enUS','Hey fellas!  How\'s it going?','Hey fellas!  How\'s it going?',26124),
(21980,'enUS','You guys have gotta try thish...','You guys have gotta try thish...',26124),
(21981,'enUS','What\'s all the fuss about here?','What\'s all the fuss about here?',26124),
(21982,'enUS','The besht part about drinking is pretending to be drunk... I\'m jusht pretending guys.','The besht part about drinking is pretending to be drunk... I\'m jusht pretending guys.',26124),
(21983,'enUS','Hey! Anyone shee that cute blond dwarf?  I shwear they were jusht here...','Hey! Anyone shee that cute blond dwarf?  I shwear they were jusht here...',26124),
(21984,'enUS','It\'sh great to finally drink with friendsh... Normally I\'d jusht sit at home and drink alone.','It\'sh great to finally drink with friendsh... Normally I\'d jusht sit at home and drink alone.',26124),
(21985,'enUS','Good times! <hic!>','Good times! <hic!>',26124),
(21986,'enUS','Uh oh...','Uh oh...',26124),
(21987,'enUS','%s lashes out, opening a large gash on $n!\n','',26124),
(21988,'enUS','When King Magni approached me about these festivities I was excited.  I began explaining how with a little help from the gnomes, we could really make this a blast to remember.  Sadly, King Magni wanted to keep it simple.  He wanted to honor the past.','When King Magni approached me about these festivities I was excited.  I began explaining how with a little help from the gnomes, we could really make this a blast to remember.  Sadly, King Magni wanted to keep it simple.  He wanted to honor the past.',26124),
(21989,'enUS','I can understand that. But the King did allow for a change, letting a gnome tap the keg.  So I got a chance to work on a new type of problem; How to efficiently and quickly open the keg and distribute its contents such that all participants will receive equal parts quickly and efficiently.','I can understand that. But the King did allow for a change, letting a gnome tap the keg.  So I got a chance to work on a new type of problem; How to efficiently and quickly open the keg and distribute its contents such that all participants will receive equal parts quickly and efficiently.',26124),
(21990,'enUS','So I had my top men and women start working on a machine to do this exact task!  We\'ve calculated down to the second how best to dist-','So I had my top men and women start working on a machine to do this exact task!  We\'ve calculated down to the second how best to dist-',26124),
(21991,'enUS','Well... uh...  I guess the Keg Tapper 74205 will have to wait... but that\'s okay, I\'ve got some designs for the Keg Tapper 75633...','Well... uh...  I guess the Keg Tapper 74205 will have to wait... but that\'s okay, I\'ve got some designs for the Keg Tapper 75633...',26124),
(21992,'enUS','Right, right... So let\'s start the countdown from ten, ready?  TEN!','Right, right... So let\'s start the countdown from ten, ready?  TEN!',26124),
(21993,'enUS','Oh... okay, I\'ll just wait for zero then...','Oh... okay, I\'ll just wait for zero then...',26124),
(21994,'enUS','Speed it up, Tinker!','Speed it up, Tinker!',26124),
(21995,'enUS','MORE POUR, LESS BORE!','MORE POUR, LESS BORE!',26124),
(21996,'enUS','Yak, yak! Let\'s get to the drinking!','Yak, yak! Let\'s get to the drinking!',26124),
(21997,'enUS','BOOORING!!','BOOORING!!',26124),
(21998,'enUS','Drink, Tink! Drink, Tink! Drink, Tink!','Drink, Tink! Drink, Tink! Drink, Tink!',26124),
(21999,'enUS','Just tap the keg already!','Just tap the keg already!',26124),
(22000,'enUS','%s focuses intensely!','',26124),
(22001,'enUS','Drink and be merry!','Drink and be merry!',26124),
(22002,'enUS','Interested in a canoe ride to Dragonblight?','',26124),
(22003,'enUS','I would like to ride in one of your canoes, Jimmy.','I would like to ride in one of your canoes, Jimmy.',26124),
(22004,'enUS','Watch out for Big Shirl!','',26124),
(22005,'enUS','Thanksh everybody for sheeing me... Todaysh a day that we should all... fall.. shmall... No... CALL! That\'s it... We should all call Thrall small... That way he\'ll know we love the Horde.  FOR THE SHWORD!','Thanksh everybody for sheeing me... Todaysh a day that we should all... fall.. shmall... No... CALL! That\'s it... We should all call Thrall small... That way he\'ll know we love the Horde.  FOR THE SHWORD!',26124),
(22006,'enUS','Now you\'ll shee shome real fancy riding!','Now you\'ll shee shome real fancy riding!',26124),
(22007,'enUS','That\'ll leave a mark...  I\'ll just rest here for a bit.','That\'ll leave a mark...  I\'ll just rest here for a bit.',26124),
(22008,'enUS','Hey! You for the Horde? <hic> I\'m for the Horde!','Hey! You for the Horde? <hic> I\'m for the Horde!',26124),
(22009,'enUS','You guys have gotta try thish...','You guys have gotta try thish...',26124),
(22010,'enUS','What\'s all the fuss about here?','What\'s all the fuss about here?',26124),
(22011,'enUS','The besht part about drinking is pretending to be drunk... I\'m jusht pretending guys.','The besht part about drinking is pretending to be drunk... I\'m jusht pretending guys.',26124),
(22012,'enUS','Hey! Anyone shee that cute goblin?  I shwear they were jusht here...','Hey! Anyone shee that cute goblin?  I shwear they were jusht here...',26124),
(22013,'enUS','It\'sh great to finally drink with friendsh... Normally I\'d jusht sit at home and drink alone.','It\'sh great to finally drink with friendsh... Normally I\'d jusht sit at home and drink alone.',26124),
(22014,'enUS','Good times! <hic!>','Good times! <hic!>',26124),
(22015,'enUS','Today, we honor the ones that bring us good food and good drink.','Today, we honor the ones that bring us good food and good drink.',26124),
(22016,'enUS','We honor them by putting them to war against one another.','We honor them by putting them to war against one another.',26124),
(22017,'enUS','We will learn who the greatest brewmaster is.  We know the breweries are up for the challenge.  We would not have invited them otherwise.','We will learn who the greatest brewmaster is.  We know the breweries are up for the challenge.  We would not have invited them otherwise.',26124),
(22018,'enUS','So now, let us celebrate with our fine warrior brothers!','So now, let us celebrate with our fine warrior brothers!',26124),
(22019,'enUS','Let us count down from five. Then I will tap this keg and we can all decide who is the greatest of brewmasters.','Let us count down from five. Then old Vol\'jin will tap this keg and we can all decide who is the greatest of brewmasters.',26124),
(22020,'enUS','The keg has been tapped!  The battle begins!  Now raise your glasses with me, as I toast our combatants...','The keg has been tapped!  The battle begins!  Now raise your glasses with me, as I toast our combatants...',26124),
(22021,'enUS','Brew for the Horde! Drink for the Horde!','Brew for the Horde! Drink for the Horde!',26124),
(22022,'enUS','Prepare yourselves, the bells have tolled! Shelter your weak, your young and your old! Each of you shall pay the final sum. Cry for mercy, the reckoning has come!','',26124),
(22023,'enUS','FOR THE POUR!','FOR THE POUR!',26124),
(22024,'enUS','Today is a good day to drink!','Today is a good day to drink!',26124),
(22025,'enUS','Drink for the Horde!','Drink for the Horde!',26124),
(22026,'enUS','Fire consumes! You\'ve tried and failed.  Let there be no doubt, justice prevailed!','',26124),
(22027,'enUS','My flames have died, left not a spark. I shall send you myself, to the lifeless dark.','',26124),
(22028,'enUS','Headless Horseman - Attack, Go to new loc.','',26124),
(22029,'enUS','I\'ve lost the key to the Shattered Halls.','I\'ve lost the key to the Shattered Halls.',26124),
(22030,'enUS','Fire a warning shot!','',26124),
(22031,'enUS','That\'ll teach \'em...','',26124),
(22032,'enUS','Aye aye, sir!','',26124),
(22033,'enUS','FIRE!','',26124),
(22034,'enUS','The sky is dark.  The fire burns.  You strive in vain as Fate\'s wheel turns.','',26124),
(22035,'enUS','The town still burns, a cleansing fire!  Time is short, I\'ll soon retire!','',26124),
(22036,'enUS','You\'ve wasted too much time, mortals. Now you shall fall.','',26124),
(22037,'enUS','Let there be no doubt, justice prevailed!','',26124),
(22038,'enUS','Mysterious hoofprints, scorched shields, stray badges... how do we make sense of all this?','',26124),
(22039,'enUS','This crime cannot be allowed to go unsolved. The location of the inn and the violence of its destruction make this a very delicate matter. Inspect the site with the utmost respect, friend.','',26124),
(22040,'enUS','What are you doing here? Do you wish to defile the ashes of this slain family further? Leave this place. You are not welcome.','',26124),
(22041,'enUS','Can you spread the reflective dust again?','Can you spread the reflective dust again?',26124),
(22042,'enUS','Hmm... I wonder...','',26124),
(22043,'enUS','Stupid mages... always using the last of a reagent and never replacing it.','',26124),
(22044,'enUS','Is he complaining about the reagents again? Does he even remember how he left the summoning tomes last time?','',26124),
(22045,'enUS','Now, where is it?','',26124),
(22046,'enUS','If you think you can stop us, you\'re mistaken, \'friend.\'','',26124),
(22047,'enUS','You can\'t stop us from exposing the truth about Jaina\'s cowardice!','',26124),
(22048,'enUS','These people will know Admiral Proudmoore for the true hero he was!','',26124),
(22049,'enUS','It\'s people like you who weaken the Alliance and invite the Horde to take away all we\'ve fought for!','',26124),
(22050,'enUS','It\'s good to see you defending Theramore with pride, friend.','',26124),
(22051,'enUS','When you\'re off duty, let\'s go to the inn. I\'ll buy a round and we can reminisce about the good old days.','',26124),
(22052,'enUS','Wouldn\'t you like to bring those days back? I have some friends who know just the way to do that...','',26124),
(22053,'enUS','You seem like a sensible $c, friend. Do you remember the glory days of Theramore, back before Jaina made us give up the fight against the Horde? Are you sick of being told to stay your blade while the orcs continue to provoke us?','',26124),
(22054,'enUS','Your propaganda won\'t work on me. Spout your treasonous filth elsewhere, traitor!','Your propaganda won\'t work on me. Spout your treasonous filth elsewhere, traitor!',26124),
(22055,'enUS','Look at that!  Near the fruit carts, an ogre.  The fruit vendor is preparing for war...','Look at that!  Near the fruit carts, an ogre.  The fruit vendor is preparing for war...',26124),
(22056,'enUS','That ogre is just the first sign that war is upon us.  The fruit vendor has gone too far.','That ogre is just the first sign that war is upon us.  The fruit vendor has gone too far.',26124),
(22057,'enUS','Who is this fruit vendor to make such a bold move? He\'s brought in an ogre for support.','Who is this fruit vendor to make such a bold move? He\'s brought in an ogre for support.',26124),
(22058,'enUS','HA! The fruit vendor must be scared for his life.  He\'s enlisted support.  Well two can play that game.','HA! The fruit vendor must be scared for his life.  He\'s enlisted support.  Well two can play that game.',26124),
(22059,'enUS','Does the fruit vendor think that I am blind?  Do they think I wouldn\'t see his ogre reinforcement?','Does the fruit vendor think that I am blind?  Do they think I wouldn\'t see his ogre reinforcement?',26124),
(22060,'enUS','I feel that war is fast approaching.  The fruit vendor has enlisted the help of an ogre.  I shall have to enlist help as well.','I feel that war is fast approaching.  The fruit vendor has enlisted the help of an ogre.  I shall have to enlist help as well.',26124),
(22061,'enUS','','The Headless Horseman\'s undead mind is obsessed!  During Hallow\'s End, his attacks on this village are frequent, and terrible.',26124),
(22062,'enUS','','The Headless Horseman attacks the village!  Someone must save the children and stop him!',26124),
(22063,'enUS','','We are free of the Headless Horseman\'s terror, for now.  We may breathe easy again, but until he can be defeated while joined with his head, he may return.',26124),
(22064,'enUS','IF WAR IS WHAT YOU WANT, WAR IS WHAT YOU SHALL GET, FRUIT VENDOR!','IF WAR IS WHAT YOU WANT, WAR IS WHAT YOU SHALL GET, FRUIT VENDOR!',26124),
(22065,'enUS','YOUR OGRE DOESN\'T SCARE ME, FRUIT VENDOR! MY ARMY IS ON ITS WAY!','YOUR OGRE DOESN\'T SCARE ME, FRUIT VENDOR! MY ARMY IS ON ITS WAY!',26124),
(22066,'enUS','YOUR DAYS ARE NUMBERED FRUIT VENDOR! I KNOW ABOUT YOUR OGRE ARMY!','YOUR DAYS ARE NUMBERED FRUIT VENDOR! I KNOW ABOUT YOUR OGRE ARMY!',26124),
(22067,'enUS','$n, I sure hope somebody finds my dog!','',26124),
(22068,'enUS','%s howls in delight at the sight of his lunch!','',26124),
(22069,'enUS','%s eats his lunch.','',26124),
(22070,'enUS','%s thanks you with a special dance.','',26124),
(22071,'enUS','The zeppelin should have just arrived at Grom\'gol... ','The zeppelin should have just arrived at Grom\'gol... ',26124),
(22072,'enUS','Why does my cousin get to enjoy the balmy beaches of Stranglethorn, anyway?','Why does my cousin get to enjoy the balmy beaches of Stranglethorn, anyway?',26124),
(22073,'enUS','The zeppelin should have just left from Grom\'gol... ','The zeppelin should have just left from Grom\'gol... ',26124),
(22074,'enUS','The zeppelin to Grom\'gol should be arriving here any time now.','The zeppelin to Grom\'gol should be arriving here any time now.',26124),
(22075,'enUS','The zeppelin to Grom\'gol has just arrived! All aboard for Stranglethorn!','The zeppelin to Grom\'gol has just arrived! All aboard for Stranglethorn!',26124),
(22076,'enUS','Hey! Did I remember to refill the tank before the zeppelin left? Oh, well!','Hey! Did I remember to refill the tank before the zeppelin left? Oh, well!',26124),
(22077,'enUS','The zeppelin to Orgrimmar has just arrived! All aboard for Durotar!','The zeppelin to Orgrimmar has just arrived! All aboard for Durotar!',26124),
(22078,'enUS','The zeppelin should have just reached Orgrimmar. Should be back in a few minutes...','The zeppelin should have just reached Orgrimmar. Should be back in a few minutes...',26124),
(22079,'enUS','I hope that my brother\'s doing okay in Durotar. There\'s an awful lot of smelly Orcs out there.... Then again, this isn\'t exactly the greatest gig, either...','I hope that my brother\'s doing okay in Durotar. There\'s an awful lot of smelly Orcs out there.... Then again, this isn\'t exactly the greatest gig, either...',26124),
(22080,'enUS','There goes the zeppelin to Orgrimmar. I hope there\'s no explosions this time.','There goes the zeppelin to Orgrimmar. I hope there\'s no explosions this time.',26124),
(22081,'enUS','I\'m not sure where the zeppelin is right now, actually...','I\'m not sure where the zeppelin is right now, actually...',26124),
(22082,'enUS','The zeppelin should have just arrived at Grom\'gol... ','The zeppelin should have just arrived at Grom\'gol... ',26124),
(22083,'enUS','The zeppelin should have just arrived at Orgrimmar... ','The zeppelin should have just arrived at Orgrimmar... ',26124),
(22084,'enUS','The zeppelin should have just departed from Orgrimmar... ','The zeppelin should have just departed from Orgrimmar... ',26124),
(22085,'enUS','The zeppelin should have just departed from Grom\'gol... ','The zeppelin should have just departed from Grom\'gol... ',26124),
(22086,'enUS','Where is the zeppelin now?','Where is the zeppelin now?',26124),
(22087,'enUS','The zeppelin should just have arrived at Undercity.','The zeppelin should just have arrived at Undercity.',26124),
(22088,'enUS','The zeppelin should have just reached Orgrimmar.','The zeppelin should have just reached Orgrimmar.',26124),
(22089,'enUS','The zeppelin should have just departed from Orgrimmar.','The zeppelin should have just departed from Orgrimmar.',26124),
(22090,'enUS','The zeppelin should have just departed from Undercity.','The zeppelin should have just departed from Undercity.',26124),
(22091,'enUS','','The Headless Horseman attacks!  The fires threaten to consume the whole village!  What will we do?',26124),
(22092,'enUS','The zeppelin should just have arrived at Undercity.','The zeppelin should just have arrived at Undercity.',26124),
(22093,'enUS','The zeppelin should just have arrived at Grom\'gol.','The zeppelin should just have arrived at Grom\'gol.',26124),
(22094,'enUS','The zeppelin should just have departed from Grom\'gol.','The zeppelin should just have departed from Grom\'gol.',26124),
(22095,'enUS','The zeppelin should just have departed from Undercity.','The zeppelin should just have departed from Undercity.',26124),
(22096,'enUS','I never get to ride to Grom\'gol. Its just so unfair. Warm, steamy beaches... Crocolisks, Raptors... hmmm... maybe I don\'t really want to go there after all.','I never get to ride to Grom\'gol. Its just so unfair. Warm, steamy beaches... Crocolisks, Raptors... hmmm... maybe I don\'t really want to go there after all.',26124),
(22097,'enUS','The zeppelin to Grom\'gol has just arrived! All aboard for Stranglethorn!','The zeppelin to Grom\'gol has just arrived! All aboard for Stranglethorn!',26124),
(22098,'enUS','Don\'t be late, the next ship to Stranglethorn departs in only a minute!','Don\'t be late, the next ship to Stranglethorn departs in only a minute!',26124),
(22099,'enUS','The zeppelin to Undercity has just arrived! All aboard for Tirisfal Glades!','The zeppelin to Undercity has just arrived! All aboard for Tirisfal Glades!',26124),
(22100,'enUS','The zeppelin to historic Tirisfal Glades has just arrived! Don\'t be caught dead without the latest in Forsaken fashion!','The zeppelin to historic Tirisfal Glades has just arrived! Don\'t be caught dead without the latest in Forsaken fashion!',26124),
(22101,'enUS','The zeppelin should have just arrived at Grom\'gol... ','The zeppelin should have just arrived at Grom\'gol... ',26124),
(22102,'enUS','The zeppelin should have just arrived at Orgrimmar...','The zeppelin should have just arrived at Orgrimmar...',26124),
(22103,'enUS','The zeppelin should have just departed from Grom\'gol...','The zeppelin should have just departed from Grom\'gol...',26124),
(22104,'enUS','The zeppelin should have just departed from Orgrimmar...','The zeppelin should have just departed from Orgrimmar...',26124),
(22105,'enUS','','It would be a shame to let these leaflets go to waste, wouldn\'t it?',26124),
(22106,'enUS','I spend all day retrieving parts for the zeppelin and Frezza doesn\'t even have the decency to pay me an hourly wage. But you\'re not here about that, are you? I bet you want to know where the zeppelin is located. Well, you\'re in luck - I have my zeppelin tracking device right here!','I spend all day retrieving parts for the zeppelin and Frezza doesn\'t even have the decency to pay me an hourly wage. But you\'re not here about that, are you? I bet you want to know where the zeppelin is located. Well, you\'re in luck - I have my zeppelin tracking device right here!',26124),
(22107,'enUS','','With just a little creative editing, these are much more useful...',26124),
(22108,'enUS','Where is the zeppelin to Undercity right now?','Where is the zeppelin to Undercity right now?',26124),
(22109,'enUS','Where is the zeppelin to Grom\'gol right now?','Where is the zeppelin to Grom\'gol right now?',26124),
(22110,'enUS','Please consider joining our cause!','Please take one of these leaflets and consider joining our cause!',26124),
(22111,'enUS','Hey, thanks.','Hey, thanks.',26124),
(22112,'enUS','%s reads the leaflet.','%s reads the leaflet.',26124),
(22113,'enUS','This... this is a joke, right?','This... this is a joke, right?',26124),
(22114,'enUS','That\'s the funniest thing I\'ve read in a long time. You\'ve just made my day!','That\'s the funniest thing I\'ve read in a long time. You\'ve just made my day!',26124),
(22115,'enUS','What a bunch of lunatics! You actually believe this stuff?','What a bunch of lunatics! You actually believe this stuff?',26124),
(22116,'enUS','I\'d never join anything like this. Better keep this, though. It\'ll come in handy in the privy...','I\'d never join anything like this. Better keep this, though. It\'ll come in handy in the privy...',26124),
(22117,'enUS','Heh... heh... hey! You! I may be down, but I be gettin\' back on my feet! Come over here and look at what I got. The rarest and most marvelous amulets, right here! I even picked up some extra bits! Come on, come on, ya know ya wanna look.','',26124),
(22118,'enUS','Check this out, $r! Ya know what $G ya:yer sweetheart; be needin\'? One of these flowers. Lilacs, right outta the mystical forest of Terokkar! Rare! So rare! Ya don\'t see any of \'em around me, do ya? A pretty flower for a pretty lady, right? Right?','',26124),
(22119,'enUS','Amazing amulets! Incredible curios! The newfangled jewelcrafters be havin\' nothin\' on the tried and true mystical methods of... the... uh... the newly relocated Griftah! Improve yerself through these magical talismans for a bargain price!','',26124),
(22120,'enUS','Okay, okay, I know what ya be thinkin\'. This be a stick. But it be no ORDINARY stick, no! What ya be seein\' here, $c, be a stick of incredible rarity and extraordinary value, shaped by the very powers that wrought the world! Ya wanna own this fantastic piece of Draenor, touched by magnificent power, I know ya do. I be practically givin\' em away!','',26124),
(22121,'enUS','Hey, wait, $c! Ya been by the market lately? My stall\'s okay, yeah? Still there?','',26124),
(22122,'enUS','I can\'t believe they be chasin\' me outta the city. Innit supposed to be a refuge? Ol\' Griftah be a refugee! Not my fault I be an ENTERPRISIN\' refugee...','',26124),
(22123,'enUS','Now, I know what ya be thinkin\'. Ol\' Griftah\'s in a spot of trouble. This be nothin\'. I still got a lotta my stock on me, so c\'mere and check out what I got.','',26124),
(22124,'enUS','The merchant known as Griftah has been exiled from this city for his fraudulent activities. We plan to go over these little knick-knacks he sells extremely carefully. Please, leave his stall undisturbed and let us do our work.','',26124),
(22125,'enUS','Nothing to see here. Move along.','',26124),
(22126,'enUS','This stall is under official investigation. Please keep your distance.','',26124),
(22127,'enUS','You have no need to worry - the swindler who peddled his \"wares\" here has been exiled from our fair city.','',26124),
(22128,'enUS','Keep back from this stall, please; there is a delicate investigation underway.','',26124),
(22129,'enUS','Let it never be said that we do not listen to the concerns of the people. This \"Griftah\" individual has made false claims, and we mean to set things right.','',26124),
(22130,'enUS','Keep a wary eye out, $r; there are unsavory characters afoot.','',26124),
(22131,'enUS','Should you venture outside the gates, $c, be alert; a garishly-dressed troll may attempt to approach you. Leave him to his exile where he rightly belongs.','',26124),
(22132,'enUS','Barleybrew, finest brewery in Azeroth!','Barleybrew, finest brewery in Azeroth!',26124),
(22133,'enUS','Come try our Barleybrew Dark!','Come try our Barleybrew Dark!',26124),
(22134,'enUS','The Barleybrews have always been leaders in brewery innovation.  Check out our newest creation, Barleybrew Clear!','The Barleybrews have always been leaders in brewery innovation.  Check out our newest creation, Barleybrew Clear!',26124),
(22135,'enUS','Thunderbrew, finest brewery in all the realms.','Thunderbrew, finest brewery in all the realms.',26124),
(22136,'enUS','THUNDER!  THUNDER!  THUNDER!  THUNDERBREW, HO!','THUNDER!  THUNDER!  THUNDER!  THUNDERBREW, HO!',26124),
(22137,'enUS','You look like you could use a cold one.  Thunderbrew\'s got ya covered!','You look like you could use a cold one.  Thunderbrew\'s got ya covered!',26124),
(22138,'enUS','YOU WANT DRINK?!  WE GOT DRINK!','',26124),
(22139,'enUS','HEY YOU!  DRINK OGRE BREWS!  MAKE YOU BIG AND STRONG!','',26124),
(22140,'enUS','YOU TRY DA\' BEST, NOW TRY DA\' REST!  OGRE BREW!!','',26124),
(22141,'enUS','You won\'t find a better brew in Azeroth.','',26124),
(22142,'enUS','We Thunderbrews take pride knowing that we are the best brewhouse in all the realms.','',26124),
(22143,'enUS','Whoah! You really want buy from us?','',26124),
(22144,'enUS','Get da move on, guards! It be killin\' time!','',26124),
(22145,'enUS','Mua-ha-ha!','',26124),
(22146,'enUS','Guards, go already! Who you more afraid of, dem... or me?','',26124),
(22147,'enUS','Mmm? Uhg... gah, rhmmrugh...','',26124),
(22148,'enUS','Wake up, orc, I\'m parched! Sell me something to drink....','Wake up, orc, I\'m parched! Sell me something to drink....',26124),
(22149,'enUS','Can\'t you see that I\'ve got places to go and people to see! Step aside, peasant!','',26124),
(22150,'enUS','Wait! I want some coffee!','Wait! I want some coffee!',26124),
(22151,'enUS','Ride now! Ride out dere and bring me back some heads!','',26124),
(22152,'enUS','I can only assume that you know who I am. And yet you insist on disturbing me?$b$bWhat could you possibly want that requires my attention?','',26124),
(22153,'enUS','Uhh, who are you?','Uhh, who are you?',26124),
(22154,'enUS','Oh come now, don\'t be ridiculous! I\'m the one and only Budd Nedreck!$b$bI\'ve been all over this land, from the top of Mount Hyjal to the depths of the Sunken Temple. In fact, I was the first to call it the Sunken Temple!$b$bYes, that was me. Don\'t give it a second thought.\n\n','',26124),
(22155,'enUS','I be losin\' me patience! Go on: make dem wish dey was never born!','',26124),
(22156,'enUS','','I highly recommend that you visit Sayge to get your fortune told. I know, I know... he\'s a gnoll.  But he\'s a very special gnoll with the power to divine your future!$B$BAnd we are constantly expanding the faire with all manner of new attractions!',26124),
(22157,'enUS','Nope, can\'t say I\'ve heard of you.','Nope, can\'t say I\'ve heard of you.',26124),
(22158,'enUS','Really? That\'s quite a claim....','Really? That\'s quite a claim....',26124),
(22159,'enUS','Yes, well, listen here, $c. I\'m older than I look and wise beyond my years. You\'d do well not to question me so much.\n\nLook, you don\'t need to take my word for it. Read the postings on any local bulletin board for yourself. I\'m everywhere!$b$bJust do yourself a favor and ignore the ones with \'WANTED\' in the title. Simple misunderstandings, I assure you.','',26124),
(22160,'enUS','Hmm... old coins... ugly jewelry...','',26124),
(22161,'enUS','More ugly jewelry... letters home... I\'m beginning to give up hope!','',26124),
(22162,'enUS','Hey... what\'s this? A pair of manacles and not just any. These are enchanted. This cargo, it wasn\'t a thing... it was a person!','',26124),
(22163,'enUS','No one expects the Dark Iron dwarves!','',26124),
(22164,'enUS','','Well met, $c. I\'m learning the art of gryphon handling from Baldruc over there. One day, I hope to run my own stable of gryphons.',26124),
(22165,'enUS','WOOP! WOOP! Unauthorized retrieval of valuables detected. Activating security system.','',26124),
(22166,'enUS','Where is that dog?','',26124),
(22167,'enUS','Will you help me find my dog?','',26124),
(22168,'enUS','I miss my dog so much!','',26124),
(22169,'enUS','I understand that many individuals seek romance in taverns and festivals like this one, but alcohol dulls the senses and makes calculating the difficulties of daily life all fuzzy!$b$bBut I\'ve found a solution! Through many trials and tribulations, I\'ve engineered an extraordinary device! With these goggles on, ANYONE looks attractive!$b$bMmm... including you, cutie! Tell you what. I\'ll give you a discount!','I understand that many individuals seek romance in taverns and festivals like this one, but alcohol dulls the senses and makes calculating the difficulties of daily life all fuzzy!$b$bBut I\'ve found a solution! Through many trials and tribulations, I\'ve engineered an extraordinary device! With these goggles on, ANYONE looks attractive!$b$bMmm... including you, cutie! Tell you what. I\'ll give you a discount!',26124),
(22170,'enUS','','Ooo, walk by again, cutie! Your posterior muscles are very finely toned!',26124),
(22171,'enUS','','Yoohoo! Over here, sweet stuff!',26124),
(22172,'enUS','','You! The cute one! Would you like to go over to my place and look over my tool collection?',26124),
(22173,'enUS','','Sweetie! Are you interested in a woman able to hold intelligent discourse and look attractive while doing so?',26124),
(22174,'enUS','','Yoooohoo, you well-proportioned charmer, you!',26124),
(22175,'enUS','','What an impressive display of alluring prospects!',26124),
(22176,'enUS','Lady Jaina told me to speak to you about using a gryphon to survey Alcaz Island.','Lady Jaina told me to speak to you about using a gryphon to survey Alcaz Island.',26124),
(22177,'enUS','What\'s happening?','What\'s happening?',26124),
(22178,'enUS','','What\'ll it be, sweety?',26124),
(22179,'enUS','I\'d like a drink.','I\'d like a drink.',26124),
(22180,'enUS','I hear you\'re quite the cook.','I hear you\'re quite the cook.',26124),
(22181,'enUS','','Oh, me a cook?  I suppose that\'s true.  A barmaid\'s got to work in the kitchens from time to time, and I\'ve learned a few recipes over the years.  Nothing too special, but they\'re hearty enough to fill Grok\'s substantial belly.',26124),
(22182,'enUS','I\'d love to learn more.','I\'d love to learn more.',26124),
(22183,'enUS','','I\'m sorry $n, but you\'ve already learned all I know about cooking.  Of course, you never know when our cooks will whip up something new, so don\'t be shy and be sure to visit again some time.',26124),
(22184,'enUS','My brother Krixx thinks he has it bad working in Orgrimmar. Nothing compares to the stench of this place. At least the boss had the decency to give me hazard pay!\n\nWhat? Do you want to see where the zeppelin is? Good thing I\'ve got my zeppelin tracker right here!','My brother Krixx thinks he has it bad working in Orgrimmar. Nothing compares to the stench of this place. At least the boss had the decency to give me hazard pay!\n\nWhat? Do you want to see where the zeppelin is? Good thing I\'ve got my zeppelin tracker right here!',26124),
(22185,'enUS','Where is the zeppelin to Orgrimmar right now?','Where is the zeppelin to Orgrimmar right now?',26124),
(22186,'enUS','This troll was positively filthy.','',26124),
(22187,'enUS','Who in the world would believe these little bits of rock and string possessed any power whatsoever? No energy worth drawing at all.','',26124),
(22188,'enUS','I told A\'dal that playing host to a mass of flea-bitten refugees would only end in trouble, but would he listen? No, no, what would a Scryer know about such things? Bah.','',26124),
(22189,'enUS','When I get home, I\'m going to have a hot bath to scour away the grime. Perhaps two. Or five.','',26124),
(22190,'enUS','If they think I\'m about to root around in a troll\'s wardrobe, they are SORELY mistaken.','',26124),
(22191,'enUS','What in all the worlds did I do to deserve this job?','',26124),
(22192,'enUS','Ugh. Tell me that wasn\'t a cockroach...','',26124),
(22193,'enUS','People of Azeroth and Outland... ARE YOU READY TO ROCK?!','',26124),
(22194,'enUS','This is a little something I like to call...','',26124),
(22195,'enUS','THE POWER OF THE HORDE!','',26124),
(22196,'enUS','Thank you, and good night!','',26124),
(22197,'enUS','Alright... I give up... sniff...','',26124),
(22198,'enUS','Be on your guard. We are Theramore\'s first line of defense against its many enemies in the marsh.','',26124),
(22199,'enUS','Where is the zeppelin to Grom\'gol right now?','Where is the zeppelin to Grom\'gol right now?',26124),
(22200,'enUS','That hit the shpot! Gimmie anudder one, Coot! *hic*','',26124),
(22201,'enUS','You\'re shayin\' you wan... you wan... *hic* you wan\' me to dansh on dis bar? *hic*','',26124),
(22202,'enUS','Maeshtro! Cue da mushic!','',26124),
(22203,'enUS','Now that the deserters have taken over Lost Point, North Point Tower is the most distant of Theramore\'s outposts.','',26124),
(22204,'enUS','Well, helllooo there, pretty thing...','',26124),
(22205,'enUS','Playing hard to get today, I see.... Very well, perhaps I\'ll find you in a better mood later.','',26124),
(22206,'enUS','Hmm, don\'t mind if I do!','',26124),
(22207,'enUS','','Not now, Mack. I be in no mood for your drunken pawing. Off with ya!',26124),
(22208,'enUS','','There shall be no prison for you this time!',26124),
(22209,'enUS','Whatever you say, princess. But yer simply postponing the inevitable....','',26124),
(22210,'enUS','Now why would ya wanna go an\' break poor Mack\'s heart? When I return, I\'ll pray ye\'ve changed yer way of thinkin\'....','',26124),
(22211,'enUS','Yer wearin down, princess. I can sense it!','',26124),
(22212,'enUS','','Beat it, Mack! Else I\'ll have Budd cook ya fer my hounds....',26124),
(22213,'enUS','','There be nuthin\' here to drink, Mack. Away with ya!',26124),
(22214,'enUS','','Go jump in the lake, won\'t ya Mack? I smelled ya before I saw ya....',26124),
(22215,'enUS','Well now, what vision of loveliness is this?','',26124),
(22216,'enUS','Ahh, my precious Ameenah! How wonderful to see you again.','',26124),
(22217,'enUS','Hrmph. I never liked her anyway....','',26124),
(22218,'enUS','Mmm, nuthin a little lubrication won\'t fix!','',26124),
(22219,'enUS','Never drink before 5 o\'clock, momma used to say. Well, momma, it\'s bound to be 5 o\'clock somewhere!','',26124),
(22220,'enUS','<cough> Ugh...','',26124),
(22221,'enUS','Whooo! Like daddy used to say, just makin room fer more! Heh.','',26124),
(22222,'enUS','Ooohh. Somethin\'s not agreein\' with the tummy today...','',26124),
(22223,'enUS','Hmmm, p\'rhaps I\'ll rest these old bones for a bit.','',26124),
(22224,'enUS','Budd\'s crew, ye mean?$b$bAye, he be no respecter of persons. He\'ll take on anyone who can work a shovel$b$b...\'cept them undead. Budd hates \'em. Personally, I think he\'s scared of \'em.\n','',26124),
(22225,'enUS','Who is this Budd fellow?','Who is this Budd fellow?',26124),
(22226,'enUS','What can a guy like me be doin\' for a $r like you at a time like this?\n','',26124),
(22227,'enUS','Sumthin\' I can do fer ya, $c?\n','',26124),
(22228,'enUS','If yer here to partake in the big spoils, ya best be gettin\' in line!$b$bMy share be long overdue....\n','',26124),
(22229,'enUS','Beats me, kid. I\'m new to the crew.$b$bI\'ve had my fill of troll-killin\' and grog drinkin, I can tell ya that. Only thing left to see is the treasure Budd keeps promisin\'....\n','',26124),
(22230,'enUS','Interesting crew you\'ve got here....','Interesting crew you\'ve got here....',26124),
(22231,'enUS','Budd\'s crew, ye mean? Aye, he be no respecter of persons. He\'ll take on anyone who can work a shovel.$b$b\'cept them undead. Budd hates \'em. Scared of \'em, likely as not.\n','',26124),
(22232,'enUS','Aye, ya never know who\'s gunna join next, or who be dyin\' next for that matter.$b$bMy advice? Don\'t be gettin\' too attached to anyone.','',26124),
(22233,'enUS','Agreed. Budd\'s scraped together rif-raf from all over creation.$b$bSeems when there\'s free booze to be had, there be plenty of folk willin\' to set aside their differences.','',26124),
(22234,'enUS','Whew! What\'s that smell?','Whew! What\'s that smell?',26124),
(22235,'enUS','<sniff\'s himself, and winces>$b$bThat there be the smell of adventure, $c!','',26124),
(22236,'enUS','<hic>Lissen here, $r. Spend a day or two wrestlin\' with wild trolls and then tell me how you smell!','',26124),
(22237,'enUS','Ohh, that. See, there\'s been nuthin\' but orc grog around camp lately.$b$bOrc grog doesn\'t seem to agree with me, if ya know what I mean....','',26124),
(22238,'enUS','','Uh huh.  Whatever you say.',26124),
(22239,'enUS','','Idiot.',26124),
(22240,'enUS','','Would you please shut up?!',26124),
(22241,'enUS','','Remind me once again why it is that I don\'t just leave?',26124),
(22242,'enUS','','You have got to be the most incompetent officer I have ever met!',26124),
(22243,'enUS','','With all due respect, sir, stick it!',26124),
(22244,'enUS','','James? James... No, you\'re not James, but I know who you are...',26124),
(22245,'enUS','','You\'re the one who tracked down the brutes who did this to us.',26124),
(22246,'enUS','','I tried so hard to tell Jim... to tell anyone... who was behind this, but I couldn\'t find a way...',26124),
(22247,'enUS','','Thank you for helping us and for helping Jim. If you see him, tell him little Jimmy and I love him and that we\'re waiting for him.',26124),
(22248,'enUS','Mommy, when will we see Daddy again?','',26124),
(22249,'enUS','','I don\'t know when we\'ll see Daddy again, Jimmy, but I know he loves you and he misses you very much.',26124),
(22250,'enUS','','Oh my, let me change those bandages!',26124),
(22251,'enUS','','That should slow the infection down a little.',26124),
(22252,'enUS','','Turgore! Get up and help me unload, you lazy peon!',26124),
(22253,'enUS','','Useless orc! Just you wait, one day I\'ll drop somethin in yer grog that you\'ll NEVER wake up from....',26124),
(22254,'enUS','','Say, Brend, why is it that you never make eyes at me?',26124),
(22255,'enUS','Well, Marge, I\'ve actually been looking for a way to tell you this....','',26124),
(22256,'enUS','Try as I might, I can\'t seem to drink you pretty!','',26124),
(22257,'enUS','Welcome to Sentry Point, $c.','',26124),
(22258,'enUS','','Oohhhh. How dare you!',26124),
(22259,'enUS','','Let that be a lesson to ya....',26124),
(22260,'enUS','Hahahahahahahah!','',26124),
(22261,'enUS','It is over, your search is done. Let fate choose now, the righteous one.','',26124),
(22262,'enUS','I\'m sorry... sniff...','',26124),
(22263,'enUS','Okay... you got us... sniff...','',26124),
(22264,'enUS','Please, no more... I hurt all over... sniff...','',26124),
(22265,'enUS','','Say, Brend, whisper me somethin\' sweet, will ya?',26124),
(22266,'enUS','','But Brend, yer always drinkin\'!',26124),
(22267,'enUS','','Filthy orc!',26124),
(22268,'enUS','Lissen Marge, I thought I told ya never to bother me when I be drinkin\'....','',26124),
(22269,'enUS','Hey Morgom, looks like Margie here be needin\' some attention. What\'dya say?','',26124),
(22270,'enUS','Zug Zug!','',26124),
(22271,'enUS','Here\'s my body, fit and pure!  Now, your blackened souls I\'ll cure!','',26124),
(22272,'enUS','Time to make some room!','',26124),
(22273,'enUS','Outta my way!','',26124),
(22274,'enUS','Watch out boys!','',26124),
(22275,'enUS','I need room to operate!','',26124),
(22276,'enUS','','I could use a hand here, $c.$b$bHow \'bout you make yourself useful?',26124),
(22277,'enUS','What can you tell me about this Budd fellow?','What can you tell me about this Budd fellow?',26124),
(22278,'enUS','','Nuthin\' good!$b$bI\'m on to that one. He lures fools in with promises of wealth, keeps \'em drunk, an\' then uses \'em to do his dirty work - which ends up gettin\' em killed often as not.\n',26124),
(22279,'enUS','Then what are you doing here?','Then what are you doing here?',26124),
(22280,'enUS','','Good question. You\'d hafta ask my brother Turgore that one.$b$bMaybe you can get an answer out of that lazy, no good... oohh. Don\'t get me started.\n\n',26124),
(22281,'enUS','Sniff... We\'re all out... The Dark Iron dwarves... sniff... Come back later...  sniff...','Sniff... We\'re all out... The Dark Iron dwarves... sniff... Come back later...  sniff...',26124),
(22282,'enUS','Looks like I\'ll have to get my drink elsewhere.','Looks like I\'ll have to get my drink elsewhere.',26124),
(22283,'enUS','','Hey there. I\'m watching these whelps until their owners come along with the proper secret passwords.',26124),
(22284,'enUS','Enter code to receive Netherwhelp pet.','Enter code to receive Netherwhelp pet.',26124),
(22285,'enUS','Pitiful mortal, Onyxia answers to no one!','',26124),
(22286,'enUS','Your pathetic challenge has not gone unnoticed. I shall enjoy toying with you before you die.','',26124),
(22287,'enUS','Hurry, mon! I be doomed!$b$bI see what they be doin\' to prisoners, an\' I be too young to die!$b$bYa gotta do somethin\', and soon!','',26124),
(22288,'enUS','What can you tell me about this place?','What can you tell me about this place?',26124),
(22289,'enUS','Listen, mon!$b$bI tell ya all I be knowin\', but first ya gotta be savin\' me from these savages and their killer bears.$b$bDeal?','',26124),
(22290,'enUS','Brogg is glad Mudsprocket goblins have let him stay here, but sometimes thinks he hears them laughing at him.','',26124),
(22291,'enUS','I would like to enter the secret code to receive my Murloc costume.','I would like to enter the secret code to receive my Murloc costume.',26124),
(22292,'enUS','Hooray! Tanzar be free, mon!$b$bWhat luck! All that an\' not even a chipped tusk.$b$bCharmed, mon. That\'s what I be. No sense denyin\' it.','',26124),
(22293,'enUS','You\'re welcome.... Now tell us what\'s going on in here!','You\'re welcome.... Now tell us what\'s going on in here!',26124),
(22294,'enUS','What can you tell us about Budd?','What can you tell us about Budd?',26124),
(22295,'enUS','','I\'ve never experienced cold like this, $r. Even in the absence of ice and snow, the frozen wastes of Northrend are extremely taxing.',26124),
(22296,'enUS','I wish to purchase reagents, Yazmina.','I wish to purchase reagents, Yazmina.',26124),
(22297,'enUS','Say, you look familiar. Have we met?','',26124),
(22298,'enUS','Do I know you?','',26124),
(22299,'enUS','Lemme give you some advice: Never trust a gnome.','',26124),
(22300,'enUS','I need some booze, Coot.','I need some booze, Coot.',26124),
(22301,'enUS','Ok mon, a deal be a deal....$b$bIt was night when we all snuck in to Zul\'Aman fer a look around.$b$bAll was quiet, til we be hearin\' a rustlin\' sound, like the wind through the trees. Before we know it, we be surrounded by these savages and their pets! Next day, I be wakin\' up here, stuck in a cage.$b$bDay an\' night, one by one, prisoners be gettin\' killed. Every time one be dyin\', that bear-troll be lookin\' stronger.$b$bThat be all I know \'bout this place, mon. And I don\'t wanna be knowin\' any more!','',26124),
(22302,'enUS','When I grow up I want to be a stable man!','',26124),
(22303,'enUS','Cut the chatter, kid. I need to stable my pet.','Cut the chatter, kid. I need to stable my pet.',26124),
(22304,'enUS','','This inn was built before the savages from the north awoke. Thank the Light for that, at least!$B$BWill you be staying long?',26124),
(22305,'enUS','I wish to browse your wares, Hazel.','I wish to browse your wares, Hazel.',26124),
(22306,'enUS','That man be nuthin\' but a fool!$b$bFame, fortune? Phooey! This place be nuthin\' but a deathtrap, mon!$b$bI seen all kinds a\' trolls in my day, but these, they be different - sneaky, strong, tricky.$b$bSeemed to me like they knew we was comin\'....\n','',26124),
(22307,'enUS','Dealin\' wit\' *hic* poison and alco... *hic* booze ish dangeroush...','',26124),
(22308,'enUS','I require some components, Sorely.','I require some components, Sorely.',26124),
(22309,'enUS','<Budd rolls his eyes as he sees you draw near>$b$bAhh, yes, the soon-to-be-famous $n!$b$bTo what do I owe the pleasure of your company?','',26124),
(22310,'enUS','The party you sent to Zul\'Aman is being slaughtered! You must do something!','The party you sent to Zul\'Aman is being slaughtered! You must do something!',26124),
(22311,'enUS','Now, now, $n, just relax and take a deep breath. You really need to learn to trust me.$b$bYour lack of experience in these situations is causing you to panic, and panic always exaggerates the truth. So you see, there really is no crisis.$b$bNow that we\'ve settled that, I must ask that you stop being so negative. It\'s not good for the crew\'s morale....','',26124),
(22312,'enUS','If you\'re as accomplished as you claim, why don\'t you investigate Zul\'Aman yourself?','If you\'re as accomplished as you claim, why don\'t you investigate Zul\'Aman yourself?',26124),
(22313,'enUS','What a silly question! Clearly, $n, I\'ve overestimated you.$b$bIt should be apparent to you that someone needs to stay focused on the big picture here. Being the only one remotely qualified, alas, that burden falls to me.$b$bIn truth, I envy you, $c. I would much rather be the one to enter Zul\'Aman and cleanse it of those savages. You should consider yourself lucky....\n\n','',26124),
(22314,'enUS','Fire!','',26124),
(22315,'enUS','Burn, mutants, BURN!','',26124),
(22316,'enUS','Drink it all boys!','',26124),
(22317,'enUS','It\'s not a party without some crashers!','',26124),
(22318,'enUS','Did someone say, \"Free Brew\"?','',26124),
(22319,'enUS','If you need to speak with Apprentice Garion, you\'ll find him inside the cottage with Tabetha. At least there, he can\'t steal all the reagents.','',26124),
(22320,'enUS','I wish we had a priest or a druid out here. I can\'t continue my studies until I\'ve recovered from my injuries.','',26124),
(22321,'enUS','Wait, don\'t tell me... $n, right?$b$bWhat can I do for you?\n','',26124),
(22322,'enUS','What became of your previous \'partners\'?','What became of your previous \'partners\'?',26124),
(22323,'enUS','Oh, well, that all depends on which partners you mean. Many have come and gone over the years - always someone eager to ride the coat-tails of the legend that is Budd Nedreck!$b$bYou can rest assured that most of them have become wealthy and retired. That\'s simply not the path I\'ve chosen. You see, I\'ve always felt that I\'ve been called to reveal the world\'s great mysteries. Alas, if I don\'t do it, who could?\n','',26124),
(22324,'enUS','How about this latest crew - what became of them?','How about this latest crew - what became of them?',26124),
(22325,'enUS','Ahh, them - a sad tale, that one.$b$bThey have disappeared behind the walls of Zul\'Aman. I haven\'t heard from them in days.$b$bI\'ve seen it a hundred times; that overeager itch for fame and fortune. I tried to hold them back, told them they weren\'t prepared, but in the end they chose to face their peril....','',26124),
(22326,'enUS','Gee, Budd, is there anyone alive who can back up these claims of yours?','Gee, Budd, is there anyone alive who can back up these claims of yours?',26124),
(22327,'enUS','Listen, $n, you should know by now that when fortune comes knocking, you open the door and ask questions later. Chances like this don\'t come along every day!$b$bNow, are you in or not, $c?$b$b<Budd doesn\'t wait for a reply>$b$bOf course you are! Now, there\'s work to be done, and so far I\'ve seen a lot of talking and no action. I suggest you show me something before I find a replacement.$b$bThere are thousands who would kill for an opportunity like this, I assure you!','',26124),
(22328,'enUS','Hi there! We\'re being blockaded by those good-for-nothing pirates out in the bay!$B$BDo you think you can help us out?','',26124),
(22329,'enUS','Hi there! We\'re being blockaded by those good-for-nothing pirates out in the bay! Do you think you can help us out by dropping a few bombs on them?!$B$BOur stolen zeppelin\'s here; hop on board before she sets sail!','',26124),
(22330,'enUS','Hi there! We\'re being blockaded by those good-for-nothing pirates out in the bay! Do you think you can help us out by dropping a few bombs on them?!$B$BOur stolen zeppelin\'s less than $3078w minutes away.  Make sure you\'re onboard when she leaves!','',26124),
(22331,'enUS','Hi there! We\'re being blockaded by those good-for-nothing pirates out in the bay! Do you think you can help us out by dropping a few bombs on them?!$B$BOur stolen zeppelin\'s almost here... I think I hear her now.  Make sure you\'re onboard when she leaves!','',26124),
(22332,'enUS','I\'m a prisoner!$B$BThey shot me and my beautiful zeppelin out of the sky. And what for? Because I was ferrying men and materiel for the Horde? That\'s nothing new!$B$BNow they have me running her in circles around the bay so that they can bomb the pirates. I just don\'t have the parts to keep her going like this! I\'m barely keeping her together on spit and bailing wire!$B$BIt\'s a crime I tell you!','',26124),
(22333,'enUS','I\'m a prisoner!$B$BThey shot me and my beautiful zeppelin out of the sky. And what for? Because I was ferrying men and materiel for the Horde? That\'s nothing new!$B$BNow they have me running her in circles around the bay so that they can bomb the pirates. I just don\'t have the parts to keep her going like this! I\'m barely keeping her together on spit and bailing wire!$B$BI won\'t be held responsible for what happens to you, but you might as well get on board before she leaves.$B$BIt\'s a crime I tell you!','',26124),
(22334,'enUS','I\'m a prisoner!$B$BThey shot me and my beautiful zeppelin out of the sky. And what for? Because I was ferrying men and materiel for the Horde? That\'s nothing new!$B$BNow they have me running her in circles around the bay so that they can bomb the pirates. I just don\'t have the parts to keep her going like this! I\'m barely keeping her together on spit and bailing wire!$B$BIf you\'re determined to help them out, she\'s due to arrive back in port in less than a minute.$B$BIt\'s a crime I tell you!','',26124),
(22335,'enUS','I\'m a prisoner!$B$BThey shot me and my beautiful zeppelin out of the sky. And what for? Because I was ferrying men and materiel for the Horde? That\'s nothing new!$B$BNow they have me running her in circles around the bay so that they can bomb the pirates. I just don\'t have the parts to keep her going like this! I\'m barely keeping her together on spit and bailing wire!$B$BIf you\'re determined to help them out, she\'s due to arrive back in port in less than $3078w minutes.$B$BIt\'s a crime I tell you!','',26124),
(22336,'enUS','My zeppelin has docked. Despite my being held captive, and the sorry state that she\'s in, she\'ll be departing the dock again in two minutes.','',26124),
(22337,'enUS','The zeppelin\'s leaving for a tour around the bay in less than one minute!  Oh, and if anyone feels like setting me free, I\'m on the dock.','',26124),
(22338,'enUS','The blazing flames are safely extinguished.','',26124),
(22339,'enUS','Disturbing','Disturbing',26124),
(22340,'enUS','RETREAT!!!!','',26124),
(22341,'enUS','So, when does this excavation of Zul\'Aman begin?','So, when does this excavation of Zul\'Aman begin?',26124),
(22342,'enUS','Listen, $n, you should know by now that when fortune comes knocking, you open the door and ask questions later. Chances like this don\'t come around every day! Are you in or not?$b$b<Budd doesn\'t wait for a reply.>$b$bOf course you are! Now, there\'s work to be done, and so far I\'ve seen a lot of talking and no action. I suggest you show me something before I find a replacement.$b$bThere are thousands who would kill for an opportunity like this, I assure you!','',26124),
(22343,'enUS','Patience, $n. I didn\'t become the renowned Budd Nedreck by being hasty.$b$bFinal preparations are being made and soon the treasures and secrets of Zul\'Aman shall be mine! $b$b<Budd pauses and looks at you for a moment, then chuckles.>$b$b...ours I mean, of course.','',26124),
(22344,'enUS','I want to go back to the orphanage!','I want to go back to the orphanage!',26124),
(22345,'enUS','Matron!  Is that bad man going to eat us?','Matron!  Is that bad man going to eat us?',26124),
(22346,'enUS','If my dad were alive, he would put out the fires!','If my dad were alive, he would put out the fires!',26124),
(22347,'enUS','If my mom were alive, she would put out the fires!','If my mom were alive, she would put out the fires!',26124),
(22348,'enUS','I brought you a housewarming gift, Jarl.','',26124),
(22349,'enUS','Go on, open it. I think you\'ll like it.','',26124),
(22350,'enUS','Jarl?','',26124),
(22351,'enUS','Unless it\'s something I can eat, I don\'t want it.','',26124),
(22352,'enUS','Jarl, you haven\'t been yourself ever since I arrived. What\'s going on?','',26124),
(22353,'enUS','Nothing. Wanna help me whip up some frog leg stew?','',26124),
(22354,'enUS','I came out here to visit you, Jarl! And I find you living in an empty cabin in the middle of nowhere, babbling about frogs? You\'re hopeless!','',26124),
(22355,'enUS','','%s hums a melody over the well.',26124),
(22356,'enUS','','%s sighs.',26124),
(22357,'enUS','','%s smiles as she continues to draw water from the well.',26124),
(22358,'enUS','','Dropping a coin down the well, Lissan looks around to see if anyone noticed.',26124),
(22359,'enUS','Go away, whoever you are! Witch Hill is mine... mine!','Go away, whoever you are! Witch Hill is mine... mine!',26124),
(22360,'enUS','It was... terrible... the demon...','It was... terrible... the demon...',26124),
(22361,'enUS','The manor... someone else... will soon be consumed...','The manor... someone else... will soon be consumed...',26124),
(22362,'enUS','The darkness... the corruption... they came too quickly for anyone to know...','The darkness... the corruption... they came too quickly for anyone to know...',26124),
(22363,'enUS','Why have you come here, outsider? You will only find pain! Our fate will be yours...','Why have you come here, outsider? You will only find pain! Our fate will be yours...',26124),
(22364,'enUS','The darkness will consume all... all the living...','The darkness will consume all... all the living...',26124),
(22365,'enUS','It is too late for us, living one. Take yourself and your friend away from here before you both are... claimed...','It is too late for us, living one. Take yourself and your friend away from here before you both are... claimed...',26124),
(22366,'enUS','It is too late for Jarl... its hold is too strong...','It is too late for Jarl... its hold is too strong...',26124),
(22367,'enUS','Day and night all I do is sit here and make ammo and restring crossbows.$B$BI suppose you want me to do something for you too?','',26124),
(22368,'enUS','Finlay, let me see what you have for sale.','Finlay, let me see what you have for sale.',26124),
(22369,'enUS','Listen, $c, it\'s clear that you and your friends know your way around Azeroth. Surely you\'ve come across certain folks who hunger for fame and fortune. $b$bSend me anyone who might be willing to enter Zul\'Aman and I\'ll make it worth your while.','',26124),
(22370,'enUS','This land was mine long before your wretched kind set foot here.','',26124),
(22371,'enUS','All who venture here belong to me, including you!','',26124),
(22373,'enUS','He\'s gone?  Hooray!','He\'s gone?  Hooray!',26124),
(22374,'enUS','Hallow\'s End is a scary holiday, but I like it!','Hallow\'s End is a scary holiday, but I like it!',26124),
(22375,'enUS','For years beyond counting these woods have burned. They are fueled by an ancient magic and are the mating grounds for the brood mother and her proto-drake consorts.$B$BBut now a long-forgotten evil has reawakened and seeks once again to enslave the offspring of the brood mother for their own purposes.$B$BThese vrykul have caused a disturbance that is extending the boundary of the clutch, and threatens your people.','',26124),
(22376,'enUS','This is an insult! An affront! They deny us participation in time-honored dwarven traditions!','',26124),
(22377,'enUS','They\'ve sent muscle to get revenge! Scatter!','',26124),
(22378,'enUS','This board is used by the Steamwheedle representatives at Mudsprocket to post bounties and job notices.','',26124),
(22379,'enUS','','I don\'t think Drazzit\'s going to have any luck finding anyone to kill this raptor. I mean, he\'s already raised the reward twice...',26124),
(22380,'enUS','','Keep firing!  Cut off their reinforcements!',26124),
(22381,'enUS','','Cover fire, now!',26124),
(22382,'enUS','','Keep them split from their main force!',26124),
(22383,'enUS','You supplied the crew with disguises?','You supplied the crew with disguises?',26124),
(22384,'enUS','Indeed! They were given every advantage I could muster. I simply can\'t imagine what went wrong.$b$bHere, $c, take one. I\'ve made a couple of modifications - little refinements really. Now there\'s no excuse for failure!','',26124),
(22385,'enUS','Down the free brew and pelt the Guzzlers with your mug!','Down the free brew and pelt the Guzzlers with your mug!',26124),
(22386,'enUS','Are you suggesting I provide you with people for Zul\'jin\'s sacrifices?','Are you suggesting I provide you with people for Zul\'jin\'s sacrifices?',26124),
(22387,'enUS','Perish the thought!$b$bI\'m simply trying to rid the world of a horrible menace, and that type of thing rarely comes without a price, as I\'m sure you know.$b$bThink of it like this, $n. You\'ll be offering ordinary folks the chance to become heroes! A rare opportunity indeed!$b$bYou just send them my way and I\'ll handle the rest....','',26124),
(22388,'enUS','Are we going to hide in our mountain and let those swill-peddlers have their little shindig without us?!','',26124),
(22389,'enUS','DAMN RIGHT! We\'ll show \'em why you don\'t cross the Dark Iron dwarves!','',26124),
(22390,'enUS','Everybody try to keep de Amani Empire down. Now we got friends. We wit de Zandalari now. We part of something bigger. You can\'t stop us all. De whole world gonna drown in blood!!','',26124),
(22391,'enUS','Smash their kegs! DRAIN BREWFEST DRY!','',26124),
(22392,'enUS','You might wanna stand back. Fish guttin\' is a dirty job.','',26124),
(22393,'enUS','Yeah!','Yeah!',26124),
(22394,'enUS','Right!','Right!',26124),
(22395,'enUS','You said it!','You said it!',26124),
(22396,'enUS','Damn straight!','Damn straight!',26124),
(22397,'enUS','No way!','No way!',26124),
(22398,'enUS','Not on your life!','Not on your life!',26124),
(22399,'enUS','NO!','NO!',26124),
(22400,'enUS','As my most recent gift to the lowly inhabitants of Azeroth, the evil Zul\'jin is no more!','',26124),
(22403,'enUS','The last ten strains from Undercity... all of them worthless!','',26124),
(22404,'enUS','I cannot work under these conditions!  We need a viable strain!','',26124),
(22405,'enUS','The plague samples they\'ve sent us would not even hurt a rat!','',26124),
(22406,'enUS','We were making progress with our plague in Undercity.  All of a sudden our strains keep failing!','',26124),
(22407,'enUS','The Royal Apothecary Society welcomes you to Northrend, $c.  Now, what is it that you will do to aid us in Sylvanas\' service?','',26124),
(22410,'enUS','%s absorbs the essence of the bear spirit!','',26124),
(22411,'enUS','Quick! Run!','Quick! Run!',26124),
(22412,'enUS','I\'m out of here!','I\'m out of here!',26124),
(22413,'enUS','You\'ll never catch me!','You\'ll never catch me!',26124),
(22414,'enUS','Go go go!','Go go go!',26124),
(22415,'enUS','Get over here, you idiot!','',26124),
(22416,'enUS','Me crush puny friend of dragons!','',26124),
(22417,'enUS','You leave Stonemaul lands now!','',26124),
(22418,'enUS','Why you wake ghost? Where other Stonemauls?!','',26124),
(22419,'enUS','%s looks weak enough to capture!','',26124),
(22420,'enUS','Break time.','Break time.',26124),
(22421,'enUS','Watch it there.','Watch it there.',26124),
(22422,'enUS','Let\'s work smarter, people. The captain wants this done by the end of the week!','Let\'s work smarter, people. The captain wants this done by the end of the week!',26124),
(22423,'enUS','Break time\'s over, ladies.','Break time\'s over, ladies.',26124),
(22424,'enUS','Do you even know what you\'re doing?','Do you even know what you\'re doing?',26124),
(22425,'enUS','Faster!','Faster!',26124),
(22426,'enUS','No! A little to the left... there, you have it.','No! A little to the left... there, you have it.',26124),
(22427,'enUS','Look out for that beam!','Look out for that beam!',26124),
(22428,'enUS','At the rate this is going, we\'re not going to finish on time.','At the rate this is going, we\'re not going to finish on time.',26124),
(22429,'enUS','There is little else I can teach you, $c. Please, speak with my colleague Kalinda if you wish to know more of the craft.','',26124),
(22430,'enUS','You\'ve reached the limits of my enchantments. Sedana can instruct you further.','',26124),
(22431,'enUS','','If you wish to advance further in the fine art of tailoring, please speak with my employer, Keelen. He can show you more than I ever will.',26124),
(22432,'enUS','%s absorbs the essence of the eagle spirit!','',26124),
(22433,'enUS','%s absorbs the essence of the lynx spirit!','',26124),
(22435,'enUS','%s absorbs the essence of the dragonhawk spirit!','',26124),
(22436,'enUS','','The situation out here is worse than I thought! The zeppelin is little better than a heap of twisted metal and burning fuel!',26124),
(22437,'enUS','A Lion Seal has become alerted to your presence and begins bellowing a warning!','',26124),
(22438,'enUS','Thank you! There\'s no telling what those brutes would\'ve done to me.','Thank you! There\'s no telling what those brutes would\'ve done to me.',26124),
(22439,'enUS','A %s senses a potential meal!','',26124),
(22440,'enUS','','Welcome to Theramore, $c.',26124),
(22441,'enUS','Oh, we\'re from Blackrock Mountain,\nWe\'ve come ta drink yer brew!\nDark Iron dwarves, they do not lie,\nAnd so yeh know it\'s true!','Oh, we\'re from Blackrock Mountain,\nWe\'ve come ta drink yer brew!\nDark Iron dwarves, they do not lie,\nAnd so yeh know it\'s true!',26124),
(22442,'enUS','Yeh will not try our bitter, \nYeh will not serve our ale!\nBut have Brewfest without our lot?\nJust try it, and ye\'ll fail!\n','Yeh will not try our bitter, \nYeh will not serve our ale!\nBut have Brewfest without our lot?\nJust try it, and ye\'ll fail!\n',26124),
(22443,'enUS','So lift a mug to Coren,\nAnd Hurley Blackbreath too!\nThis drink is weak, without much kick,\nBut oi!  At least it\'s brew!','So lift a mug to Coren,\nAnd Hurley Blackbreath too!\nThis drink is weak, without much kick,\nBut oi!  At least it\'s brew!',26124),
(22444,'enUS','We\'ll drink yer stout and lager,\nDrain all the pints and kegs!\nWe\'ll drink and brawl and brawl and drink,\n\'til we can\'t feel our legs!','We\'ll drink yer stout and lager,\nDrain all the pints and kegs!\nWe\'ll drink and brawl and brawl and drink,\n\'til we can\'t feel our legs!',26124),
(22445,'enUS','And when the brew\'s all missin\'\nTa Shadowforge we\'ll hop,\nA bitter toast ta Ragnaros...\n... but bring him not a drop!','And when the brew\'s all missin\'\nTa Shadowforge we\'ll hop,\nA bitter toast ta Ragnaros...\n... but bring him not a drop!',26124),
(22446,'enUS','[DNT] Verse 6','[DNT] Verse 6',26124),
(22447,'enUS','Marksmen, form up and take your positions!','',26124),
(22448,'enUS','Prepare to fire upon my command! Ready, aim...','',26124),
(22449,'enUS','FIRE AT WILL!','',26124),
(22450,'enUS','There\'s the flare. Left cannon, ready!','There\'s the flare. Left cannon, ready!',26124),
(22451,'enUS','Range.','Range.',26124),
(22452,'enUS','Fire!','Fire!',26124),
(22453,'enUS','Center cannon, ready.','Center cannon, ready.',26124),
(22454,'enUS','Right cannon, ready.','Right cannon, ready.',26124),
(22455,'enUS','Mr. Ely!','Mr. Ely!',26124),
(22456,'enUS','Where are my recovered cannonballs?','Where are my recovered cannonballs?',26124),
(22457,'enUS','Very well.  Carry on Mr. Ely.','Very well.  Carry on Mr. Ely.',26124),
(22458,'enUS','Sir!','',26124),
(22459,'enUS','I have top men and women on it even as we speak, sir!','',26124),
(22460,'enUS','Aye, aye, sir!','',26124),
(22461,'enUS','All cannons, ready.','All cannons, ready.',26124),
(22463,'enUS','All o\' this shootin\' at Skorn and other places o\'er the horizon, and what do ya think it\'s gotten me?$B$BCannonball recovery duty!$B$BNot exactly what I signed up fer, ya know?','',26124),
(22464,'enUS','','Time for some rest, sweety, or just something to eat and some relaxation?$B$BWell, if anyone deserves it, it\'s you!',26124),
(22465,'enUS','What do you have to eat, Celeste?','What do you have to eat, Celeste?',26124),
(22466,'enUS','Get him, Fiend!','',26124),
(22467,'enUS','That\'s it!  Bite the sword arm!','',26124),
(22468,'enUS','Easy, boy!  Don\'t ruin the dummy now!','',26124),
(22469,'enUS','I surrender! Stay your blade!','',26124),
(22470,'enUS','I will go with you. Just spare my men. They\'re good lads who\'ve only made a mistake...','',26124),
(22471,'enUS','What\'s this? No, no, there must be some misunderstanding. I can explaaaiiin....','',26124),
(22472,'enUS','So, dis be Budd?','',26124),
(22473,'enUS','You be the worm my captives be cursin\'? I expected more!','',26124),
(22474,'enUS','So long as yer fools be fillin\' my cages with sacrifices I\'d be a fool to kill ya.','',26124),
(22475,'enUS','But be knowin\' this, little man - no matter where ya be hidin\', when me pyres grow dim, I\'ll be feedin\' them with yer bones!','',26124),
(22476,'enUS','And then, forever on, yer soul be my plaything....','',26124),
(22477,'enUS','I\'ll be seein\' ya, little man Budd. Sooner than later I\'ll be bettin\'.','',26124),
(22478,'enUS','I haven\'t much time to talk unless it\'s urgent, citizen. The gates of Theramore are my greatest responsibility.','',26124),
(22479,'enUS','Lieutenant Aden always volunteers for gate duty. That\'s fine by me.$B$BI\'ve got a post that allows me a good view of my guards AND the daughters of the tradesmen at the same time.','',26124),
(22480,'enUS','Are you here to relieve me? I\'m certain it\'s almost time. Well, if you want to relieve me anyway, let me know. I could use a drink or three.','',26124),
(22481,'enUS','Thank the Light the Defias don\'t know the first thing about diving!','',26124),
(22482,'enUS','I don\'t have the Repaired Diving Gear anymore. Do you have a spare?','I don\'t have the Repaired Diving Gear anymore. Do you have a spare?',26124),
(22483,'enUS','Fire!','',26124),
(22484,'enUS','','What you need are schematics far beyond my own meager offerings. Danwe here can show you some true technological delights!',26124),
(22485,'enUS','You couldn\'t have come at a better time!  Let\'s get out of here.','',26124),
(22486,'enUS','Yes, let us leave... but not before we leave our Alliance hosts something to remember us by!','',26124),
(22487,'enUS','They have limited supplies in this camp.  It would be a real shame if something were to happen to them.','',26124),
(22488,'enUS','Captain Adams sent me out here to investigate what\'s happening at Halgrind. This is as close as I\'ve been able to get, however; the abandoned Vrykul tower affords me some amount of cover from prying eyes.$B$BThe Forsaken are up to no good over there. I can feel it!','',26124),
(22489,'enUS','Ah, yes... watch it burn!','',26124),
(22490,'enUS','We\'re almost done!','',26124),
(22491,'enUS','That\'ll teach you to mess with an apothecary, you motherless Alliance dogs!','',26124),
(22492,'enUS','Let\'s high-tail it out of here.','',26124),
(22493,'enUS','Don\'t shoot!  Apothecary coming through!','',26124),
(22494,'enUS','We\'re in your debt, friend.  Speak to Lysander at Vengeance Landing; he will arrange a suitable reward for you.','',26124),
(22495,'enUS','Ahahaha! I must find the secrets!','Ahahaha! I must find the secrets!',26124),
(22496,'enUS','I don\'t want to know anymore. Make me forget!','AI don\'t want to know anymore. Make me forget!',26124),
(22497,'enUS','When one studies and digs, one reveals the truth.','When one studies and digs, one reveals the truth.',26124),
(22498,'enUS','We\'re safe; IT will never reach us here!','We\'re safe; IT will never reach us here!',26124),
(22499,'enUS','The end is nigh! That Which Must Not Be Named is almost free!','The end is nigh! That Which Must Not Be Named is almost free!',26124),
(22500,'enUS','IT\'s coming! HIDE!','IT\'s coming! HIDE!',26124),
(22501,'enUS','If only there were more time!','If only there were more time!',26124),
(22502,'enUS','Forgive me oh great one. I did not mean to learn the truth!','Forgive me oh great one. I did not mean to learn the truth!',26124),
(22503,'enUS','The truth shall set you free. Like us, you will be with IT forever!','The truth shall set you free. Like us, you will be with IT forever!',26124),
(22504,'enUS','Now that you know the truth, I can\'t let you leave!','Now that you know the truth, I can\'t let you leave!',26124),
(22505,'enUS','It\'ll all be over soon. Soon you will be in the embrace of That Which Must Not Be Named!','It\'ll all be over soon. Soon you will be in the embrace of That Which Must Not Be Named!',26124),
(22506,'enUS','Intruder! You were sent to destroy us!','Intruder! You were sent to destroy us!',26124),
(22507,'enUS','You cannot leave... IT mustn\'t find us!','You cannot leave... IT mustn\'t find us!',26124),
(22508,'enUS','If you\'re here, then IT might be close behind!','If you\'re here, then IT might be close behind!',26124),
(22509,'enUS','I will put an end to your life before you realize the horrible truth!','I will put an end to your life before you realize the horrible truth!',26124),
(22510,'enUS','Now you\'ll have to join us... permanently!','Now you\'ll have to join us... permanently!',26124),
(22511,'enUS','Welcome to Theramore.','',26124),
(22512,'enUS','What enchantments interest you today, $c?','',26124),
(22513,'enUS','','Is there a pattern or two I can show you today?',26124),
(22514,'enUS','You\'ve surpassed my own knowledge, but Bemarrin over there can teach you far more.','',26124),
(22515,'enUS','','I\'m afraid you\'re at the limits of my knowledge. Camberon is more skilled in alchemy than I. Please speak with him if you\'re interested in advancing.',26124),
(22516,'enUS','Lady Jaina would not send a messenger with such haste if she did not believe her information reliable.','',26124),
(22517,'enUS','With their newfound patronage and apparent role in the king\'s disappearance, I see no choice but to plan a renewed offensive against the Defias.','',26124),
(22518,'enUS','Convey my thanks to Lady Jaina and let her know that we will pursue the Defias and their backers until our liege is safely returned!','',26124),
(22519,'enUS','Lynalis can help you more than I, $c. Speak with her to learn more.','',26124),
(22520,'enUS','','Don\'t be such a fool, Bolvar!',26124),
(22521,'enUS','','The Defias are little more than a band of thugs. We should be busy combatting Stormwind\'s real enemies instead of chasing baseless speculation!',26124),
(22522,'enUS','I\'m ready to travel to Stormwind.','I\'m ready to travel to Stormwind.',26124),
(22523,'enUS','Pleased to meet you, $c.','',26124),
(22524,'enUS','Can you send me to Theramore? I have an urgent message for Lady Jaina from King Wrynn.','Can you send me to Theramore? I have an urgent message for Lady Jaina from King Wrynn.',26124),
(22525,'enUS','The peace of Ogri\'la shall be restored!','',26124),
(22526,'enUS','Lucc is the one to speak to now, $n, to further your skill.','',26124),
(22527,'enUS','','There are eight types of Darkmoon Cards; Beasts, Blessings, Elementals, Furies, Lunacy, Portals, Storms and Warlords, with eight cards, Ace to Eight in each suit. If you collect all eight of one suit then you can turn them into a deck that you can give to our Professor Thaddeus Paleo in exchange for a powerful trinket.',26124),
(22528,'enUS','','The Headless Horseman\'s mind is plagued with dementia!  During Hallow\'s End, he might attack this village at any moment.',26124),
(22529,'enUS','','The Headless Horseman has set fire to the village!  We must protect the children!',26124),
(22530,'enUS','','The Headless Horseman is attacking!  Quickly, aid your Horde brethren in the village\'s defense!',26124),
(22531,'enUS','','The Headless Horseman had been driven away, for now.  We may breath easy for a time, but must remain ever vigilant.',26124),
(22532,'enUS','Hallow\'s End is a scary holiday, but I like it!','Hallow\'s End is a scary holiday, but I like it!',26124),
(22533,'enUS','What\'s happening?','What\'s happening?',26124),
(22534,'enUS','I want to go back to the orphanage!','I want to go back to the orphanage!',26124),
(22535,'enUS','Matron!  Is the Headless Horseman going to eat us?','Matron!  Is the Headless Horseman going to eat us?',26124),
(22536,'enUS','If my dad was alive, he would put out the fires!','If my dad was alive, he would put out the fires!',26124),
(22537,'enUS','If my mom was alive, she would put out the fires!','If my mom was alive, she would put out the fires!',26124),
(22538,'enUS','Is he gone?  Hooray!','Is he gone?  Hooray!',26124),
(22539,'enUS','Welcome back to the greatest show in Outland, my friend!  It is truly a delight to see you once again.$B$BPlease, step right up and once more take in all we have to offer.  Be sure to check around, as we are always adding new and exciting things to the Darkmoon Faire!  Amaze at wonders old and new that we have uncovered!  We continue to spare no expense in bringing you excitement that children of all ages will delight in!','',26124),
(22540,'enUS','Greetings my friend, and welcome to the greatest show in Outland!$B$BPlease, step right up and take in all we have to offer.  Amaze at the wonders that the Darkmoon Faire has uncovered in this vast and mysterious world!  We have spared no expense in bringing you excitement that children of all ages will delight in!','',26124),
(22541,'enUS','Welcome one and all to the greatest show on all of Azeroth... the Darkmoon Faire!  Adventure and excitement await, don\'t be shy!  Mysteries and prizes for both the young and the old are here for the taking.  And be sure to speak with the professor about any Darkmoon Cards that you have come across during your travels!','',26124),
(22542,'enUS','Greetings friends, and welcome to the greatest show on Azeroth!$B$BPlease, step right up and take in all we have to offer.  Ride the rides and see the sights!  Amaze at the wonders that the Darkmoon Faire has uncovered in this vast and mysterious world!  We have spared no expense in bringing you excitement that children of all ages will delight in!','',26124),
(22543,'enUS','Everyone enjoying themselves so far?  That\'s great!  Welcome to the Darkmoon Faire, the greatest show in all of Outland!  Make sure that you speak with Yebb and his friends here while you\'re taking in Neblegear\'s Darkmoon Zoo Bizarre.','',26124),
(22544,'enUS','Welcome one and all to the Darkmoon Faire, the greatest event in all the worlds!  We have it all... delicious food, strong drink, exotic artifacts, fortunes read, amazing prizes and excitement without end!  Don\'t forget to turn in your Darkmoon Faire Prize Tickets to Gelvas Grimegate!  All it takes is five or more and you\'re on your way to the most wondrous prizes in all of Outland.  Everybody is a winner!','',26124),
(22545,'enUS','','I\'ll take good care of your pets, don\'t you worry!',26124),
(22546,'enUS','The Darkmoon Faire is the greatest event in all of Outland!','The Darkmoon Faire is the greatest event in all of Outland!',26124),
(22547,'enUS','SOMEONE TRY THIS SUPER BREW!!','SOMEONE TRY THIS SUPER BREW!!',26124),
(22548,'enUS','Welcome to Theramore, $c. Looking for something?','Welcome to Theramore, $c. Looking for something?',26124),
(22549,'enUS','You look like an intelligent person. Why don\'t you read one of these leaflets and give it some thought?','You look like an intelligent person. Why don\'t you read one of these leaflets and give it some thought?',26124),
(22550,'enUS','It wasn\'t me! $n did it, I swear!','',26124),
(22551,'enUS','WAAAHH! This was all $n\'s idea! Some of my best friends are forest trolls....','',26124),
(22552,'enUS','We shouldn\'t have left so many behind at Valgarde. Admiral Keller, that insufferable egomaniac!$B$BHow am I to fulfill my orders with so few? I need enough men to stay here at the keep and still properly garrison Fort Wildervar when it\'s ready!$B$BAt least we have a hope of dealing with our problems now that you\'re here.','',26124),
(22553,'enUS','I advise the captain on matters that he chooses to share with me, but I have a feeling that he\'d rather hear from you.','',26124),
(22554,'enUS','','All of these mouths to feed, and who has to do it? Me!$B$BAll the cooking, and the cleaning, and everything else!',26124),
(22555,'enUS','...receive 50 percent off deserter undergarments? What is this garbage?','...receive 50 percent off deserter undergarments? What is this garbage?',26124),
(22556,'enUS','...as a deserter, you\'ll enjoy activities like tethered swimming and dog grooming? How ridiculous!','...as a deserter, you\'ll enjoy activities like tethered swimming and dog grooming? How ridiculous!',26124),
(22557,'enUS','In all of my days I never thought to see such a magnificent new frontier.$B$BIf only it weren\'t tainted by evil and knowledge which is best left hidden.','',26124),
(22558,'enUS','I\'ve seen a lot of things in my time, but the change that came over the Explorers\' League in the Whisper Gulch takes the cake.$B$BI\'m just glad that I got out of there with my skin intact!','',26124),
(22559,'enUS','...the deserters seek a Theramore where citizens will be free to juggle at all hours of the day? What is this nonsense?','...the deserters seek a Theramore where citizens will be free to juggle at all hours of the day? What is this nonsense?',26124),
(22560,'enUS','You\'ve reached the limits of my skill. Farii was my instructor, and I\'m sure she\'ll instruct you as well.','',26124),
(22561,'enUS','...to establish the chicken as the official symbol of Theramore?! These guys are nuts!','...to establish the chicken as the official symbol of Theramore?! These guys are nuts!',26124),
(22562,'enUS','...to create a fund for the purchase of hair gel? I like my hair the way it is, thanks!','...to establish a fund for the purchase of hair gel? I like my hair the way it is, thanks!',26124),
(22563,'enUS','Miall is the next step in your training, friend $c. You\'ve grown beyond what I can teach you.','',26124),
(22564,'enUS','Your time learning at my side draws to a close, friend. Akham will gladly instruct you further.','',26124),
(22565,'enUS','','It is time for you to expand your knowledge with another teacher; Ockil has unlocked many fascinating wonders of the engineer, and will lead you on your path to discovery, yes?',26124),
(22566,'enUS','','You flatter me, but it is my colleague Refik who deserves your attention now, not I.',26124),
(22567,'enUS','','You seek to uncover mysteries I myself have yet to unlock, $c. Please, discuss these matters with Nahogg instead.',26124),
(22568,'enUS','You must walk before you can run. Speak with Feruul for training, and attend well to his lessons.','',26124),
(22569,'enUS','It is time for you to move on. Telonis, a night elf located within the Craftsmen\'s Terrace in Darnassus, is the next step in your training.','',26124),
(22570,'enUS','Deriz is the one you should speak with if you wish to learn the basics of alchemy.','',26124),
(22571,'enUS','Have you ever wished to see the boughs of Teldrassil, $n? You should, for there is an elf there who can teach you more. Seek out Ainethil in Darnassus on the Craftsmen\'s Terrace.','',26124),
(22572,'enUS','','Please, not now. Speak with Edrem. He can show you what you need to know.',26124),
(22573,'enUS','','You may ask yourself, \"What is next?\" I have the answer. To learn more of our art, you must travel across the sea to an awe-inspiring place known as Ironforge. The forge there is one of the largest in the land! Bengus Deepforge, found in the Great Forge, can instruct you further.',26124),
(22574,'enUS','The Tauren Chieftains play on this stage at the top of every hour. Show some energy: Cheer the minstrels on to capture some of the event\'s intensity!','',26124),
(22575,'enUS','I am busy, $c. Your time would be better spent discussing matters with Kudrii.','',26124),
(22576,'enUS','The Tauren Chieftains concert will begin in thirty minutes!  Come celebrate the opening of the Darkmoon Faire in Terokkar, just south of Shattrath City!','',26124),
(22577,'enUS','The Tauren Chieftains concert will begin in fifteen minutes!  Come celebrate the opening of the Darkmoon Faire in Terokkar, just south of Shattrath City!','',26124),
(22578,'enUS','The Tauren Chieftains concert will begin in five minutes!  Come celebrate the opening of the Darkmoon Faire in Terokkar, just south of Shattrath City!','',26124),
(22579,'enUS','The more powerful enchantments are beyond even me, $n. Your path should lead you through Elwynn Forest to the Tower of Azora, where your next tutor spends her days. Her name is Kitta Firewind.','',26124),
(22580,'enUS','People of Outland, are you ready to rock?! The Tauren Chieftain concert now begins!','',26124),
(22581,'enUS','For simple schematics of your skill level, speak with Ghermas, if you would.','',26124),
(22582,'enUS','Gnomes! Gnomes are marvelous people. Wonderful! And they hold such knowledge of the engineering arts! You must travel to Ironforge, to Tinkertown, and speak with Springspindle Fizzlegear.','',26124),
(22583,'enUS','Tsk. Respect your elders. It is Kayaart who should train you.','',26124),
(22584,'enUS','You have reached the limits of my knowledge, but there is more yet to learn. Across the sea, in the Mage Quarter of Stormwind City, a great tailor dwells. His name is Georgio Bolero, and he will train you now, I think. Go and speak with him.','',26124),
(22585,'enUS','','Your skill impresses me greatly, $n! It is time for you to head to Outland to learn more. If you head to Hellfire Peninsula, Tatiana will take you on as a student in Honor Hold. Or, if you prefer working with the Aldor, Hamanar can instruct you in Shattrath City, on Aldor Rise.',26124),
(22586,'enUS','','Your skill has grown immense, $c. In order to further your instruction, you must journey to Outland itself. Kalaen will train you in Thrallmar, within Hellfire Peninsula. If you prefer, you can speak to the rather prudish Hamanar on Aldor Rise within Shattrath City, though I wouldn\'t advise it.',26124),
(22587,'enUS','Harken, cur!  Tis you I spurn!  Now feel... the burn!','',26124),
(22588,'enUS','I thought we talked about this, Brogg. You can\'t stay in this building. Sure, it can house you, but there\'s no room for anyone else!','',26124),
(22589,'enUS','You said Brogg could stay here! You promised Brogg you\'d help regain Stonemaul clan mound!','',26124),
(22590,'enUS','Yes, we said you can stay here, but this building is our headquarters! All of our manuals and blueprints are stored here!','',26124),
(22591,'enUS','But this the only building that fit Brogg! Goblins make buildings too small!','',26124),
(22592,'enUS','I\'m inclined to say they made ogres too big! I can see I\'m not going to convince you to move now, but don\'t think this is permanent!','',26124),
(22593,'enUS','The ground... is frozen.  We\'re sitting ducks here; these meatwagons aren\'t going anywhere.','',26124),
(22594,'enUS','High Executor Anselm wants a report on the situation.','High Executor Anselm wants a report on the situation.',26124),
(22595,'enUS','What does it look like?  The ground is frozen like a rock!$B$BThe wheels on these meatwagons were built to go over mud at best.  We\'re going to need an abomination and some chains to salvage them.','',26124),
(22596,'enUS','I will never call Brackenwall Village my home. To do so is to give up hope of reclaiming our rightful lands.','',26124),
(22597,'enUS','','Hi $c, I\'m Ashli, and I need you to help me \'cause I\'m trapped in this cage \'cause Budd sent me in here with some yucky trolls and stinky orcs and silly humans and a drunk dwarf and we got caught by super-bad trolls and they dragged us off and they put me in here with the big troll-cat who\'s really really mean and kills all the people in the cages and I think he\'s gunna kill me too really soon but I can\'t get out by myself so...$b$b<Ashli takes a deep breath.>$b$bCan you kill that thing?\n',26124),
(22598,'enUS','Goblin Gumbo Kettle','Goblin Gumbo Kettle',26124),
(22599,'enUS','Fishing Chair','Fishing Chair',26124),
(22600,'enUS','Spectral Tiger Mount','Spectral Tiger Mount',26124),
(22601,'enUS','We did it boys!  Now back to the Grim Guzzler and we\'ll drink to the $3096W that were injuredl!','',26124),
(22602,'enUS','RETREAT!!  We\'ve already lost $3096W and we can\'t afford to lose any more!!','',26124),
(22603,'enUS','There are $3094W activated dwarves!','',26124),
(22604,'enUS','Curse this frozen land!  We\'ll never move these meatwagons to the front!','',26124),
(22605,'enUS','Curses!  We might as well dismantle these for parts!  They\'re useless to us.','',26124),
(22606,'enUS','Dig the wheels out, we don\'t have much time!','',26124),
(22607,'enUS','Listen, stranger, I\'d love to sit and chat, but me head\'s poundin\' somethin\' fierce.$b$bHow \'bout ye git these good fer nothin\' trolls to stop makin\' such a racket. Then we\'ll get to talkin\', eh?','',26124),
(22608,'enUS','Well then, I spose I be owin\' ya my thanks, $r.$b$bTruth is, I thought I\'d swallowed me last tankard \'til ye showed up.','',26124),
(22609,'enUS','So, how does a dwarf like you end up in a place like this?','So, how does a dwarf like you end up in a place like this?',26124),
(22610,'enUS','A sad tale, that one - a wee bit embarrassin\' too.$b$bMy people be know fer havin\' a taste fer the ale, ya know. And I be no exception. Seems I been given more than me share of the thirst.$b$bSo I run inta ol\' Budd ya see, an\' he offers me all the grog I can swallow fer joinin\' his crew - a move I\'ve come to regret.$b$bOne night, after drinkin\' enough grog to drop a Kodo, I was lured into followin\' Budd\'s band o\' misfits into Zul\'Aman.$b$bThat be the last I recall before findin\' meself in that cage.','',26124),
(22611,'enUS','','Ohh, thank you soo much for getting me out of that cage because I was in there for soo long and it smelled like minced mutton that had been sitting out in the sun for a week and I don\'t like mutton to begin with because when I was little, well littler, I was actually turned into a sheep for a minute and so I know what it feels like to be a sheep and I don\'t want someone eating me, especially an overgrown troll dressed up like a kitty....$b$b<Ashli takes a deep breath.>$b$bHow\'s my hair?\n',26124),
(22612,'enUS','How\'d a perky little gnome like you get caught up in a mess like this?','How\'d a perky little gnome like you get caught up in a mess like this?',26124),
(22613,'enUS','','I wanted to practice my spells on the bunnies outside my home to make my magic stronger so I could go and kill all the bad guys in Gnomeregan and let all the gnomes go back home but momma said I was too young to go on adventures but then I met Mister Budd and he told me that you\'re only as young as you feel and that I could come here with his friends and I would get all the practice I needed but then we got caught and put in the cages...$b$b<Ashli takes a deep breath.>$b$bAre you a real $r?\n',26124),
(22614,'enUS','','The stranded Alliance sailors know they\'re going to die, yet they fight us tooth and nail.$B$BImpressive and pathetic at the same time.',26124),
(22615,'enUS','','It will be a matter of hours before the Alliance in the Derelict Strand are crushed.  They are surrounded and outnumbered.',26124),
(22616,'enUS','','By the will of Sylvanas, our enemies will fall.',26124),
(22617,'enUS','High Executor Anselm requests your report.','High Executor Anselm requests your report.',26124),
(22618,'enUS','','It is those two cannons along the wall that are slowing us down.  Without their protection our forces would be able to rush their fortification without taking any losses.$B$BIt\'s either take out those cannons or wait until they run out of ammunition.  Anselm\'s choice, I suppose.',26124),
(22619,'enUS','','The Headless Horseman, once a knight of the Silver Hand and a hero among his fellow paladins, is cursed.  Driven insane within the Scarlet Monastery, he believes that he is alive and we are dead.$B$BNow, his fervor no longer serves the Light.  With the coming of Hallow\'s End, he spreads gloom and fire across the villages of Azeroth.',26124),
(22620,'enUS','Who is the Headless Horseman?','Who is the Headless Horseman?',26124),
(22621,'enUS','Nevermind me, $r. $b$bKraz as good as dead. Leave now, $r, before bad trolls get you too.','',26124),
(22622,'enUS','','Give me your souls that I might slay the enemy!',26124),
(22623,'enUS','Crush them!  Crush their faces!','',26124),
(22624,'enUS','Hold positions!  Keep vrykul men back!','',26124),
(22625,'enUS','Kill vrykul scum!  For Sylvanas!','',26124),
(22626,'enUS','Don\'t let vrykul come through!  Kill all!','',26124),
(22627,'enUS','Some things Gorth has to do himself!','',26124),
(22628,'enUS','You no match for Gorth!','',26124),
(22629,'enUS','Gorth no care if he die!  Gorth get put back together!','',26124),
(22630,'enUS','Freedom! Kraz life was over.$b$bI thank you, $c.','',26124),
(22631,'enUS','What happened to you, orc?','What happened to you, orc?',26124),
(22632,'enUS','Kraz should never have come to this cursed place... should have known not to trust the human. A blind fool I was, $c, as are you if you follow his counsel.$b$bMy son, lost for two moons, was last seen with the human, Budd. He told me I could find him behind the walls of Zul\'Aman....$b$bI followed his people here, and was captured with the rest. Without your help, I was doomed to die.$b$bThank you, stranger.','',26124),
(22633,'enUS','We did it! We\'ve defeated Tethyr!','',26124),
(22634,'enUS','We defeated the sea monster!','',26124),
(22635,'enUS','Come in out of the cold and rest your weary bones a while. Our hospitality is yours.','Come in out of the cold and rest your weary bones a while. Our hospitality is yours.',26124),
(22636,'enUS','','You will not stop my work here!  My husband-king will awaken!',26124),
(22637,'enUS','Please, let me out of here!','Please, let me out of here!',26124),
(22638,'enUS','The key... you have to find the key!','The key... you have to find the key!',26124),
(22639,'enUS','I think I saw a key on one of those vrykul.','I think I saw a key on one of those vrykul.',26124),
(22640,'enUS','I don\'t want to be taken down into the catacombs!','I don\'t want to be taken down into the catacombs!',26124),
(22641,'enUS','I don\'t want to be sacrificed!','I don\'t want to be sacrificed!',26124),
(22642,'enUS','They\'re performing unholy rites down in the catacombs, and I\'m about to be the sacrifice!','They\'re performing unholy rites down in the catacombs, and I\'m about to be the sacrifice!',26124),
(22643,'enUS','Is there no hero to rescue me?','Is there no hero to rescue me?',26124),
(22644,'enUS','This is the end.','This is the end.',26124),
(22645,'enUS','Oh, thank you, thank you!','Oh, thank you, thank you!',26124),
(22646,'enUS','Thank you.  I will not forget this!','Thank you.  I will not forget this!',26124),
(22647,'enUS','Avenge my friends who have already been sacrificed!','Avenge my friends who have already been sacrificed!',26124),
(22648,'enUS','You have to put a stop to this madness before it\'s too late!','You have to put a stop to this madness before it\'s too late!',26124),
(22649,'enUS','My thanks to you, hero!','My thanks to you, hero!',26124),
(22650,'enUS','The vrykul are evil and must be destroyed!','The vrykul are evil and must be destroyed!',26124),
(22651,'enUS','You saved my life!','You saved my life!',26124),
(22652,'enUS','Thank goodness for you!','Thank goodness for you!',26124),
(22653,'enUS','','Don\'t let them take the Windrunner you worthless mutts!  Stand your ground!',26124),
(22654,'enUS','','I\'m going to gut the lookouts that scouted these reefs!  We walked right into their blasted trap!',26124),
(22655,'enUS','','Kick these Alliance mongrels off our ships!',26124),
(22656,'enUS','','Defend our cannons at all costs!',26124),
(22657,'enUS','Walk in the Light, my child.','',26124),
(22658,'enUS','[DEBUG] SPLIT','',26124),
(22659,'enUS','[DEBUG] GROW AND EXPLODE','',26124),
(22660,'enUS','[DEBUG] SHRINK AND EXTINGUISH','',26124),
(22661,'enUS','Fire grant me vision...','',26124),
(22662,'enUS','Archers at the ready!  Hold your fire!','',26124),
(22663,'enUS','What fool dares to enter her majesty\'s dominion unannounced?','',26124),
(22664,'enUS','Water grant me serenity...','',26124),
(22665,'enUS','Ah, but it is you who intrudes on our master\'s territory.  He could wipe you out in an instant for that transgression alone!  Arthas does not have much love or patience for his escaped slaves.','',26124),
(22666,'enUS','%s inhales the wispy smoke tendrils emanating from the burner.','',26124),
(22668,'enUS','%s falls into a trance.','',26124),
(22669,'enUS','But... he has learned of your victory over Stormwind\'s North Fleet and thinks you have potential.  Potential to see reason and abandon Sylvanas\' childish rebellion.','',26124),
(22670,'enUS','Thank you, spirits.','',26124),
(22671,'enUS','Arthas is prepared to offer you power beyond your imagination.  The puny army you lead here would pale in comparison to the phalanxes at your command if you returned to the Scourge\'s embrace.','',26124),
(22672,'enUS','Dark Iron dwarves!!!','Dark Iron dwarves!!!',26124),
(22673,'enUS','They\'re after the beer!','They\'re after the beer!',26124),
(22674,'enUS','Someone has to save the beer!','Someone has to save the beer!',26124),
(22675,'enUS','If you value your beer, run for it!','If you value your beer, run for it!',26124),
(22676,'enUS','Run!  It\'s the Dark Iron dwarves!','Run!  It\'s the Dark Iron dwarves!',26124),
(22677,'enUS','Work faster, people!','',26124),
(22678,'enUS','We know some of the truth. Now we must uncover the rest!','',26124),
(22679,'enUS','Kill anyone who tries to interfere!','',26124),
(22680,'enUS','Their coming will herald the end of the world!','',26124),
(22681,'enUS','You there, stop slacking!','',26124),
(22682,'enUS','We\'re safe here, my brothers and sisters, while the rest of the world will perish.','',26124),
(22683,'enUS','Sometimes even I wish that I didn\'t know. But then I realize it\'s for the best.','',26124),
(22684,'enUS','Quiet, did you hear that?!','',26124),
(22685,'enUS','$n, my child, come here, I have something to ask of you.','',26124),
(22686,'enUS','Is that all you\'ve come to say?','',26124),
(22687,'enUS','Send these scumbags back to hell!  Fire at will!','',26124),
(22688,'enUS','It\'s coming right for us!','It\'s coming right for us!',26124),
(22689,'enUS','FIRE! FIRE!','FIRE! FIRE!',26124),
(22690,'enUS','Shoot it between the eyes! Those beasts are vulnerable there!','Shoot it between the eyes! Those beasts are vulnerable there!',26124),
(22691,'enUS','Invader incoming!','Invader incoming!',26124),
(22692,'enUS','Don\'t let those monsters through the gate! Stand firm, soldiers!','Don\'t let those monsters through the gate! Stand firm, soldiers!',26124),
(22693,'enUS','$G Sir : Ma\'am;! I\'m here to assist and defend you.$B$BYour orders?','',26124),
(22694,'enUS','For ages, I was lost.  Now, finally, I see how dark my soul had become...','',26124),
(22695,'enUS','Horseman rise...','Horseman rise...',26124),
(22696,'enUS','Your time is nigh...','Your time is nigh...',26124),
(22697,'enUS','For Ymiron!','For Ymiron!',26124),
(22698,'enUS','Beg for your life...','Beg for your life...',26124),
(22699,'enUS','Your end draws closer!','Your end draws closer!',26124),
(22700,'enUS','YAAARRRGH!','YAAARRRGH!',26124),
(22701,'enUS','Suffer, insect!','Suffer, insect!',26124),
(22702,'enUS','My life for Ymiron!','My life for Ymiron!',26124),
(22703,'enUS','What are these things?!','What are these things?!',26124),
(22704,'enUS','Where are they coming from?!','Where are they coming from?!',26124),
(22705,'enUS','What do they want?!','What do they want?!',26124),
(22706,'enUS','This is madness!','This is madness!',26124),
(22707,'enUS','I don\'t know, but they\'re big and they\'re pissed!','I don\'t know, but they\'re big and they\'re pissed!',26124),
(22708,'enUS','They\'re definitely not gnomes.','They\'re definitely not gnomes.',26124),
(22709,'enUS','Let me stop fighting for my life and ask them - oh wait... Who cares! Just kill!','Let me stop fighting for my life and ask them - oh wait... Who cares! Just kill!',26124),
(22710,'enUS','Does it really matter?','Does it really matter?',26124),
(22711,'enUS','Total shot in the dark here but I\'d guess they\'re coming from that gigantic evil castle. I could be wrong.','Total shot in the dark here but I\'d guess they\'re coming from that gigantic evil castle. I could be wrong.',26124),
(22712,'enUS','Idiot...','Idiot...',26124),
(22713,'enUS','Us dead? I dunno... Just a guess.','Us dead? I dunno... Just a guess.',26124),
(22714,'enUS','That\'s the 64,000 gold piece question, isn\'t it? ','That\'s the 64,000 gold piece question, isn\'t it? ',26124),
(22715,'enUS','They want you to stop asking questions! Shut up and fight!','They want you to stop asking questions! Shut up and fight!',26124),
(22716,'enUS','Reminds me of the time I was stationed at Cenarion Hold during the second war of the shifting sands... Remember that orc? Saurfang? Damndest thing I ever did see.','Reminds me of the time I was stationed at Cenarion Hold during the second war of the shifting sands... Remember that orc? Saurfang? Damndest thing I ever did see.',26124),
(22717,'enUS','I\'m no orc lover but yea, wish he were here right now. He\'d dismantle these things!','I\'m no orc lover but yea, wish he were here right now. He\'d dismantle these things!',26124),
(22718,'enUS','Heard he\'s Thrall\'s right hand orc. Hangs up dragon heads in his spare time.','Heard he\'s Thrall\'s right hand orc. Hangs up dragon heads in his spare time.',26124),
(22719,'enUS','Heard he sent Ragnaros back to the elemental planes by himself...','Heard he sent Ragnaros back to the elemental planes by himself...',26124),
(22720,'enUS','You felt death once...','You felt death once...',26124),
(22721,'enUS','Now, know demise!','Now, know demise!',26124),
(22722,'enUS','Behold the Vrykul!   A race that has perfected war and destruction to the point of an art form.  Already they\'ve cast their lot with the Lich King!  Their dwellings surround you and their numbers are easily five times yours.','',26124),
(22723,'enUS','The choice is yours, Anselm.  Return to the Lich King\'s army and fight alongside them or remain loyal to your so-called queen and suffer their wrath as they drive you from their homelands!','',26124),
(22724,'enUS','Here, kitty kitty.....','',26124),
(22725,'enUS','Where ya be mon? Ya dang kitty\'s are sneaky!','',26124),
(22726,'enUS','Coo Yah! There ya be!','',26124),
(22727,'enUS','Look at ya mon! You be out here all day tryin\' to find em!','',26124),
(22728,'enUS','There be one mon!','',26124),
(22729,'enUS','Aranal, ledel! Their fate shall be yours!','',26124),
(22730,'enUS','Our gryphons are still learning the lay of the land, $c, so I can only offer you short flights to other places in the fjord. Where do you want to go?','Our gryphons are still learning the lay of the land, $c, so I can only offer you short flights to other places in the fjord. Where do you want to go?',26124),
(22731,'enUS','Take me to Valgarde Port.','Take me to Valgarde Port.',26124),
(22732,'enUS','Take me to Westguard Keep.','Take me to Westguard Keep.',26124),
(22733,'enUS','Take me to Fort Wildervar.','Take me to Fort Wildervar.',26124),
(22734,'enUS','Not so fast.','',26124),
(22736,'enUS','Your blood is mine!','',26124),
(22737,'enUS','%s clears his throat.','',26124),
(22738,'enUS','I look across this base and all I see is fear... Are you gonna be scared when the Lich King\'s armies are sittin\' pretty in Stormwind? Ironforge? NO! You\'re not. And do you know why? Because you\'ll be dead, that\'s why.','',26124),
(22739,'enUS','So when you\'re feeling that tinglin\' sensation at the base of your spine and you\'re \'bout ready to wet your pants, embrace it. Let it enrage you. That fear is the only thing that\'s gonna keep you breathin\'.','',26124),
(22740,'enUS','Am I clear? Do you understand what I\'m sayin\'? I don\'t wanna have to send any more coffins or letters home.','',26124),
(22741,'enUS','Removing','Removing',26124),
(22742,'enUS','The pumpkin head smolders forebodingly...','',26124),
(22743,'enUS','%s groans.','%s groans.',26124),
(22744,'enUS','%s screams in agony as the harpoon is removed.','%s screams in agony as the harpoon is removed.',26124),
(22745,'enUS','%s whimpers.','%s whimpers.',26124),
(22746,'enUS','Call the Headless Horseman.','Call the Headless Horseman.',26124),
(22747,'enUS','Not... no... Our people... Wyrmskull... some live...','Not... no... Our people... Wyrmskull... some live...',26124),
(22748,'enUS','My injuries are too great. I won\'t make it... Our citizenry held in cages... ritual...','My injuries are too great. I won\'t make it... Our citizenry held in cages... ritual...',26124),
(22749,'enUS','I\'m done for... too much blood lost... Forget about me, tell Keller... People still alive inside...','I\'m done for... too much blood lost... Forget about me, tell Keller... People still alive inside...',26124),
(22750,'enUS','My family must know... I... for them... always for them...','My family must know... I... for them... always for them...',26124),
(22751,'enUS','They left us here impaled as a warning to the others... Several still alive... prisoners of...','They left us here impaled as a warning to the others... Several still alive... prisoners of...',26124),
(22752,'enUS','Don\'t let my death go unavenged, stranger... give... them... hell...','Don\'t let my death go unavenged, stranger... give... them... hell...',26124),
(22753,'enUS','You have my thanks, hero. If you don\'t mind, I\'d like to stay by your side and exact a little vengeance upon my captors!','You have my thanks, hero. If you don\'t mind, I\'d like to stay by your side and exact a little vengeance upon my captors!',26124),
(22754,'enUS','Best pray I don\'t get out of here, scum.','Best pray I don\'t get out of here, scum.',26124),
(22755,'enUS','So help me... If I get out of this cage there will be hell to pay.','So help me... If I get out of this cage there will be hell to pay.',26124),
(22756,'enUS','Thanks for the opportunity to dole out some payback. I\'m going to head back to Valgarde now, friend.','Thanks for the opportunity to dole out some payback. I\'m going to head back to Valgarde now, friend.',26124),
(22757,'enUS','So eager you are, for my blood to spill. Yet to vanquish me, \'tis my head you must kill!','',26124),
(22758,'enUS','Such a futile gesture.','',26124),
(22759,'enUS','','Make haste, $c!$b$bThis crisis is nowhere near being under control.',26124),
(22760,'enUS','Many thanks! Allow me to repay you by killing a few dozen of these beasts!','Many thanks! Allow me to repay you by killing a few dozen of these beasts!',26124),
(22761,'enUS','Thanks, friend. Looking for another to join your group?','Thanks, friend. Looking for another to join your group?',26124),
(22762,'enUS','I will help you out before I head back to Valgarde. It\'s the least I could do.','I will help you out before I head back to Valgarde. It\'s the least I could do.',26124),
(22763,'enUS','I hear they\'re sacrificing prisoners up at their ritual grounds. I think the place is called Gjalerbron...','I hear they\'re sacrificing prisoners up at their ritual grounds. I think the place is called Gjalerbron...',26124),
(22764,'enUS','This will not be the last you hear of me.  I will return to spit on your corpse after Utgarde\'s armies have descended upon you!','',26124),
(22766,'enUS','Listen to your men\'s dying breaths as I drink in their souls!','',26124),
(22767,'enUS','You seek passage somewhere, $n?  My bats will get you there in no time.','',26124),
(22768,'enUS','I need to fly to the Windrunner.  Official business!','I need to fly to the Windrunner.  Official business!',26124),
(22769,'enUS','','%s focuses her energies upon the corpse of the fallen.',26124),
(22770,'enUS','','Unworthy...',26124),
(22771,'enUS','','A worthless offering...',26124),
(22772,'enUS','','An unfavorable verdict...',26124),
(22773,'enUS','','You have failed...',26124),
(22774,'enUS','Sergeant, loan me your spyglass.','Sergeant, loan me your spyglass.',26124),
(22775,'enUS','%s dangles a key in front of the prisoner.','',26124),
(22776,'enUS','Tread carefully, $r.$b$bYou wouldn\'t be the first to die here.','',26124),
(22777,'enUS','Do ya want it, monkey? Do ya??','',26124),
(22778,'enUS','Your stench sickens me. I\'d kill you myself if it were not for Angerboda.','',26124),
(22779,'enUS','The day of reckoning draws near. Aberrations like you will be destroyed...','',26124),
(22780,'enUS','How much longer do you think your town can hold out? It will be crushed soon... Soon, little one.','',26124),
(22781,'enUS','How will you stop that which you fear so much, little one?','',26124),
(22782,'enUS','My heart grows darker... Soon I will be judged... Worthy of the Val\'kyr! Worthy of the Lich King!','',26124),
(22783,'enUS','A creature emerges from the shadows!','',26124),
(22784,'enUS','Cannonfire rings off in the distance, followed by the sound of a whistling cannonball coming from above.','',26124),
(22785,'enUS','','These Alliance pondsuckers sure are gutsy!  Boarding fully-manned Forsaken destroyers... now that\'s suicidal behavior if I ever heard of it.',26124),
(22786,'enUS','Hah! You thought to interfere with my ascension? Nothing can stop me now!','',26124),
(22787,'enUS','You think I do not know what you are trying to do? You think I haven\'t been watching you?','',26124),
(22788,'enUS','You will not stop my ascension, tiny $r. Time to die!','',26124),
(22789,'enUS','No! You will not defeat me!','',26124),
(22790,'enUS','','My sisters and I welcome you, $r.',26124),
(22791,'enUS','','How unfortunate, Halfdan.',26124),
(22792,'enUS','','We find you unworthy of ascension, Halfdan. Let your soul know oblivion!',26124),
(22793,'enUS','Reports from the test on the enemy fleet have come in, sir!','',26124),
(22794,'enUS','Well... the good news is we forced the reinforcements to turn back.','',26124),
(22795,'enUS','The plague was not quite... fatal.  However, reports of harmful effects include nausea, loss of equilibrium and severe stomach pain.','',26124),
(22796,'enUS','Yes, sir!','',26124),
(22797,'enUS','Excellent.  What\'s the lowdown?  Do we have a bodycount?','',26124),
(22798,'enUS','Well, spit it out!  What\'s the bad news?','',26124),
(22799,'enUS','Stay sharp, $n.$b$bWe\'re not out of the woods yet....','',26124),
(22800,'enUS','Severe stomach pain?','',26124),
(22801,'enUS','SEVERE STOMACH PAIN?','',26124),
(22802,'enUS','We are the Royal Apothecary Society!  Inducing belly aches is not part of our job description!','',26124),
(22803,'enUS','Am I surrounded by amateurs?  I want a full analysis of the new strain by tomorrow morning!  Get on it, Ravien!','',26124),
(22804,'enUS','Hail, stranger. If you are looking for a place in need of your help, you have found it.$B$BThe dead reawaken, walk the land, and arrive on ships from across the great ocean. The fjord grows too dangerous even for us, and soon we must leave for safer lands to the north.','',26124),
(22805,'enUS','I am here to assist and defend you.$B$BHow next shall we strike at the enemy?','',26124),
(22806,'enUS','Please loan me that spyglass.','Please loan me that spyglass.',26124),
(22807,'enUS','','Come closer, young one; my ears aren\'t what they once were, and I care not for raising my voice.',26124),
(22808,'enUS','I am over here, you fool of a body!','',26124),
(22809,'enUS','Captain, I\'ve somehow lost my command insignia.','Captain, I\'ve somehow lost my command insignia.',26124),
(22810,'enUS','Alright, here\'s another. Try not to lose this one!','',26124),
(22811,'enUS','Chief Ashtotem, I have misplaced the token that you gave me.','Chief Ashtotem, I have misplaced the token that you gave me.',26124),
(22812,'enUS','Very well, here is another. Please be more careful with this one.','',26124),
(22813,'enUS','For Ymiron!','For Ymiron!',26124),
(22814,'enUS','YAAARRRGH!','YAAARRRGH!',26124),
(22815,'enUS','My life for Ymiron!','My life for Ymiron!',26124),
(22816,'enUS','You tiny creatures disgust me!','You tiny creatures disgust me!',26124),
(22817,'enUS','Damn you, Pulroy! Where\'d you put those ciphers!','',26124),
(22818,'enUS','Just like the League to leave a dwarf stranded with no help and no ale!','',26124),
(22819,'enUS','How do ya lose an entire group of people?','',26124),
(22820,'enUS','Look what\'s come to play.','Look what\'s come to play.',26124),
(22821,'enUS','Keller\'s soldiers ain\'t brought me nothin\' in days... No news is good news I \'spose.','',26124),
(22822,'enUS','There will be no everlasting life for you!','There will be no everlasting life for you!',26124),
(22823,'enUS','I will break you!','I will break you!',26124),
(22824,'enUS','Your race is a disease upon the world!','Your race is a disease upon the world!',26124),
(22825,'enUS','Oy! Keller! Any word from the ruins? Anything at all??','',26124),
(22826,'enUS','%s grumbles something under his breath.','',26124),
(22827,'enUS','I\'ve already told you, McSorf. I\'ve sent no less than three rescue teams into the ruins and none have returned. I am working tirelessly to keep this port afloat and in one piece! GET OFF MY BACK!','',26124),
(22828,'enUS','','I can only hope the treatment will work.',26124),
(22829,'enUS','','I just don\'t have the medical supplies I need to properly treat all of you.',26124),
(22830,'enUS','','Don\'t worry, soldier. Yazmina is going to take care of you.',26124),
(22831,'enUS','','%s shakes her head.',26124),
(22832,'enUS','I need a riding bat to intercept the Alliance reinforcements.','I need a riding bat to intercept the Alliance reinforcements.',26124),
(22833,'enUS','DRINK! BRAWL! DRINK! BRAWL! ','DRINK! BRAWL! DRINK! BRAWL! ',26124),
(22834,'enUS','Help!  My eyes!','Help!  My eyes!',26124),
(22835,'enUS','Someone shoot that bat down!','Someone shoot that bat down!',26124),
(22836,'enUS','I don\'t feel so good...','I don\'t feel so good...',26124),
(22837,'enUS','That liquid... it reeks!','That liquid... it reeks!',26124),
(22838,'enUS','I show you strength... in numbers.','',26124),
(22839,'enUS','When the Darkmoon Faire is open, it will be located in Terokkar Forest in Outland.  We\'ll be pitching our tents just south of Shattrath City!','',26124),
(22840,'enUS','The Darkmoon Faire is right now located in Terokkar Forest in Outland, just south of Shattrath City.  Don\'t miss it!','',26124),
(22841,'enUS','It\'s been a pleasure serving with you.','',26124),
(22842,'enUS','It has been an honor to fight at your side.','',26124),
(22843,'enUS','The hound appears to pick up a scent from the north and prepares to sprint to its source.','',26124),
(22844,'enUS','Upon reaching its destination the hound becomes startled by noise up ahead and appears ready to flee.','',26124),
(22845,'enUS','So many uses for the plague, so little time!','',26124),
(22846,'enUS','Are you nearly recovered from the last time? Let\'s try again...','',26124),
(22847,'enUS','Hm, the pressure must be alleviated somewhat...','',26124),
(22848,'enUS','The subject is still breathing. Time for another dosage...','',26124),
(22849,'enUS','It is a marvel how we were able to set this up in so short a time. Let\'s try again...','',26124),
(22850,'enUS','Tell me how this makes you feel.','',26124),
(22851,'enUS','What a robust subject we have. Once more, then...','',26124),
(22852,'enUS','%s turns a nearby valve and directs his attention to the cage, quill in hand.','',26124),
(22853,'enUS','The Dread King sends his regards! Pray that today is the day that we die in battle! Pray that the judgment is favorable!','',26124),
(22854,'enUS','','These are all excellent. It\'s going to be hard to choose just one.',26124),
(22855,'enUS','','I think I\'ve found the one I\'ll use. Now I have to begin the task of carving it. I don\'t think it\'s going to be easy. I don\'t even know what a female yeti\'s mating call sounds like!',26124),
(22856,'enUS','','I\'ve got most of the basic carving done, but it needs to be tested before I can continue. Are you willing to help me with that, $n?',26124),
(22857,'enUS','My life for the Dread King!','My life for the Dread King!',26124),
(22858,'enUS','I am ready to die, my lord!','I am ready to die, my lord!',26124),
(22859,'enUS','The interlopers will be stopped, my lord.','The interlopers will be stopped, my lord.',26124),
(22860,'enUS','One among us will ascend on this day.','One among us will ascend on this day.',26124),
(22861,'enUS','One among us will ascend on this day.','One among us will ascend on this day.',26124),
(22862,'enUS','The val\'kyr surround us, brothers and sisters! Glory comes to those who sacrifice all for the Lich King!','',26124),
(22863,'enUS','Gunnar, son of Thorvard, has arrived!  Prepare to meet your demise!','',26124),
(22864,'enUS','Ingvar sends his dragon riders to descend upon these insects! Soon they will face the awakened force of the Vrykul!','',26124),
(22865,'enUS','Battle hard, brothers! Rouse our sleeping kin with the echoes of war!','',26124),
(22866,'enUS','Sacrifice event triggered - beginning countdown...','',26124),
(22867,'enUS','Enemies of the Winterskorn, you will be torn limb from limb!','',26124),
(22868,'enUS','Drive this scum from the Vrykul homeland!','',26124),
(22869,'enUS','AGH! Not again with the sprayin\'!','',26124),
(22870,'enUS','What\'s that n- AGH!','',26124),
(22871,'enUS','Brann\'s beard, just STOP!','',26124),
(22872,'enUS','The dwarf coughs, sputters, and shivers in the cage.','',26124),
(22873,'enUS','A low, despairing moan escapes the caged dwarf.','',26124),
(22874,'enUS','%s shakes the bars of the cage weakly.','',26124),
(22875,'enUS','%s slumps against the cage bars dejectedly.','',26124),
(22876,'enUS','Are YOU the one who interrupted my dinner? Well, are you?','',26124),
(22877,'enUS','You\'re too ugly and scrawny to be a female yeti! And now you\'re making me mad...','',26124),
(22878,'enUS','','Aren\'t you a sight for sore eyes!$B$BThere\'s work to be done and not much time.',26124),
(22879,'enUS','I\'ve got Keg Protector marks to redeem...','I\'ve got Keg Protector marks to redeem...',26124),
(22880,'enUS','What do you want with me?','',26124),
(22881,'enUS','Release me, cowards! I\'ll show you what a dwarf is made of!','',26124),
(22882,'enUS','What did you do with the people of this village!?','',26124),
(22883,'enUS','Gorth not afraid of getting killed.  Them Forsaken just put me back together again.','',26124),
(22884,'enUS','Gorth is confused sometimes.  Gorth is good at killing people so Gorth is made sergeant.  But now Gorth never gets to kill nothing!','',26124),
(22885,'enUS','Vrykuls is bigger and stronger than us.  But we is better looking!','',26124),
(22886,'enUS','','The Blastenheimer 5000 Ultra Cannon is a state-of-the-art single person projectile device. Delivering its payload at near the speed of a dragon, the cannon is the pride and joy of the Blastenheimer family, world renown for their aeronautical and combustible feats!$B$BIf you\'d like to be launched through the skies to fly free as a bird, seek out Maxima Blastenheimer in the Terrace of Light in Shattrath City. She\'ll aim you at a target in a small pond outside the city walls!',26124),
(22887,'enUS','What\'s a guy gotta do to get some help around here?','',26124),
(22888,'enUS','You do know about the giant YETI in the mine, don\'t you?','',26124),
(22889,'enUS','That\'s Y-E-T-I. Yeti! You know, the giant, shaggy things with the bloody horns?','',26124),
(22890,'enUS','It\'s keeping my boys from expanding the mine. The Alliance needs that ore!','',26124),
(22891,'enUS','Are you deaf?! I\'ll be there when Captain Adams is flogging you for holding up the Alliance\'s advance!','',26124),
(22892,'enUS','BRAINNNS!','',26124),
(22893,'enUS','So... Hungry...','',26124),
(22894,'enUS','FEED ME...','',26124),
(22895,'enUS','FOOD! EAT YOU!','',26124),
(22896,'enUS','Closer... come closer...','',26124),
(22897,'enUS','You hear something, Jones? I almost thought I heard something, right there...','You hear something, Jones? I almost thought I heard something, right there...',26124),
(22898,'enUS','BURNS! IT BURNS!','',26124),
(22899,'enUS','ARGHHHH...','',26124),
(22900,'enUS','Light... light so bright...','',26124),
(22901,'enUS','Bad light... hurt...','',26124),
(22902,'enUS','Away... go...','',26124),
(22903,'enUS','Nope. Didn\'t hear a thing...','Nope. Didn\'t hear a thing...',26124),
(22904,'enUS','$C, are you certain you are ready to leave? Take a moment.','',26124),
(22905,'enUS','Let\'s go then.','',26124),
(22906,'enUS','She\'s just as beautiful as ever! Please, $n, tell her for me!','',26124),
(22907,'enUS','I love you, my precious Irena.','',26124),
(22908,'enUS','','Irena sobs gently.',26124),
(22909,'enUS','Time is up! You have failed.... Any remaining prisoners are now SMOKED.','',26124),
(22910,'enUS','Perhaps it was a mistake to travel so close to the Rivenwood and Gjalerbron to get here.','',26124),
(22911,'enUS','All four prisoners saved! You are teh uber!','',26124),
(22912,'enUS','Come, hero. The Light will guide and protect us.','',26124),
(22913,'enUS','Face the blinding judgment of the Light, fiend!','',26124),
(22914,'enUS','Back to the cold dark with you!','',26124),
(22915,'enUS','I will return you to the hell that bore you!','',26124),
(22916,'enUS','%s places the sacred artifact next to Lord Irulon Trueblade.','',26124),
(22917,'enUS','My charge ends as your charge begins, Irulon. Farewell and may the Light guide you.','',26124),
(22918,'enUS','%s smells the meat, awakens from his slumber, and roars in anger!','',26124),
(22919,'enUS','Our magic... useless against this sickness!','',26124),
(22920,'enUS','The gods have abandoned us!','',26124),
(22921,'enUS','The end is near, brothers!  This plague eats us from within!','',26124),
(22922,'enUS','For your safety, I can only allow you short flights to other places in the fjord. What is your desired destination?','For your safety, I can only allow you short flights to other places in the fjord. What is your desired destination?',26124),
(22923,'enUS','Take me to Vengeance Landing.','Take me to Vengeance Landing.',26124),
(22924,'enUS','Take me to New Agamand.','Take me to New Agamand.',26124),
(22925,'enUS','I can\'t offer you anything outside Howling Fjord. The bats still don\'t know their way abroad. Where do you want to go?','I can\'t offer you anything outside Howling Fjord. The bats still don\'t know their way abroad. Where do you want to go?',26124),
(22926,'enUS','Take me to Camp Winterhoof.','Take me to Camp Winterhoof.',26124),
(22927,'enUS','You spar like a girl!','You spar like a girl!',26124),
(22928,'enUS','I train better against a target dummy.','I train better against a target dummy.',26124),
(22929,'enUS','You practice as if you\'re still asleep.','You practice as if you\'re still asleep.',26124),
(22930,'enUS','When the little ones come, I won\'t hold back like I am with you.','When the little ones come, I won\'t hold back like I am with you.',26124),
(22931,'enUS','Sure you don\'t need a break, old woman?','Sure you don\'t need a break, old woman?',26124),
(22932,'enUS','Your sparring is feeble!','Your sparring is feeble!',26124),
(22933,'enUS','Practice or not, you\'re going to spit teeth!','Practice or not, you\'re going to spit teeth!',26124),
(22934,'enUS','Come on, stop trying to hit me and hit me already!','Come on, stop trying to hit me and hit me already!',26124),
(22935,'enUS','A %s appears to defend its dinner.','',26124),
(22936,'enUS','I\'ve been in the military my whole life.  I\'ve fought in many wars, under many banners - but they\'ve always been other people\'s battles.$B$BNot this time.  Every Forsaken soldier you see here has come for one reason alone.  Arthas must be killed.','',26124),
(22937,'enUS','Hey, Gil, you give my offer any more thought? I\'ll have plenty of skins and preserved meat to trade for those heavy yeti furs or down your men are working with.','',26124),
(22938,'enUS','Much as I\'d like to do business with you, Jethan, all this stuff is the property of the Alliance expeditionary forces.','',26124),
(22939,'enUS','Maybe after everything dies down, you and I can make a deal with some of the surplus. I\'m sure the troops will give your people plenty of business as they head into the Grizzly Hills.','',26124),
(22940,'enUS','I\'ll be lookin\' forward to it. Guess I\'ll get to preserving this meat, then. A good quartermaster won\'t turn down a reliable supply of rations.','',26124),
(22941,'enUS','Barleybrew, finest brewery in Azeroth!  Check them out at Brewfest!','Barleybrew, finest brewery in Azeroth!  Check them out at Brewfest!',26124),
(22942,'enUS','Thunderbrew, finest brewery in all the realms.  Check them out at Brewfest!','Thunderbrew, finest brewery in all the realms.  Check them out at Brewfest!',26124),
(22943,'enUS','Hungry? Can sleep here, too.','',26124),
(22944,'enUS','Keep your wits about you, $r, we\'re surrounded by the walking dead here.','',26124),
(22945,'enUS','Thank you, stranger.','Thank you, stranger.',26124),
(22946,'enUS','I must return. Good hunting to you.','I must return. Good hunting to you.',26124),
(22947,'enUS','Blessings of the spirits of the land and air upon you.','Blessings of the spirits of the land and air upon you.',26124),
(22948,'enUS','You saved me from certain death. I owe you.','You saved me from certain death. I owe you.',26124),
(22949,'enUS','We should never have traveled through the Rivenwood. Everyone knows this!','We should never have traveled through the Rivenwood. Everyone knows this!',26124),
(22950,'enUS','Strange ghosts walk the land. Be careful!','Strange ghosts walk the land. Be careful!',26124),
(22951,'enUS','They took us one by one. I\'m sure there are other survivors.','They took us one by one. I\'m sure there are other survivors.',26124),
(22952,'enUS','I owe you a life debt, stranger.','I owe you a life debt, stranger.',26124),
(22953,'enUS','Take me! I am ready to die!','',26124),
(22954,'enUS','Drink in their misery, brother!','',26124),
(22955,'enUS','Stand and be judged!','',26124),
(22956,'enUS','May you die in the Lich King\'s favor!','',26124),
(22957,'enUS','We battle for the glory of Ymiron! We die in the name of the Lich King!','',26124),
(22958,'enUS','Wait a minute...','',26124),
(22959,'enUS','It\'s just...','',26124),
(22960,'enUS','Beer! Mere beer!','',26124),
(22961,'enUS','There\'s absolutely nothing out of the ordinary about it.','',26124),
(22962,'enUS','You! Not a word to Grick about this! Do you hear me?','',26124),
(22963,'enUS','I fight wit\' untamed spirit....','',26124),
(22964,'enUS','Spirit, come back to me!','',26124),
(22965,'enUS','The coast is clear. You\'re free!','The coast is clear. You\'re free!',26124),
(22966,'enUS','Pssst! Up \'ere, in the cage. Come and lemme get a look at yeh.','',26124),
(22967,'enUS','Hallooo.... You just gunna sit down there an\' pat yerselves on the back? What kinda rescuers are ya?','',26124),
(22968,'enUS','So.... How\'s about one \'a ya stroll on up \'ere an\' help me out, eh?','',26124),
(22969,'enUS','Yoohoo. Over here... the trapped dwarf. Come on, lemme have a word with yeh.','',26124),
(22970,'enUS','Don\'t go leavin\' the job half done, now. Come an\' tell me if it be safe to make my escape!','',26124),
(22971,'enUS','Akil\'zon, the invaders approach!','',26124),
(22972,'enUS','The ring will overflow with the blood of the interlopers! Oluf has come!','',26124),
(22973,'enUS','Release the prisoners! Firjus will destroy them all!','',26124),
(22974,'enUS','Firjus was unworthy! Test your battle prowess against a true soldier of the Lich King!','',26124),
(22975,'enUS','Good... More flesh for the harvest...','',26124),
(22976,'enUS','How\'d I ever let Petrov talk me into coming out here with these incompetent dwarves?!','',26124),
(22977,'enUS','Where\'s the help that I was promised?','',26124),
(22978,'enUS','That guano\'s not going to collect itself!','',26124),
(22979,'enUS','There\'s no way I\'m going into the Rivenwood; the place is haunted!','',26124),
(22980,'enUS','When we get back, I\'m gonna kill Petrov!','',26124),
(22981,'enUS','This is as far north as I go! Those spiders are huge!','',26124),
(22982,'enUS','Petrov promised me more help would be coming. What\'s taking so long?!','',26124),
(22983,'enUS','I should be down there working on the flying machines, not in charge of guano collection!','',26124),
(22984,'enUS','This place was supposed to be safe! Instead we\'re in the middle of hungry worgs and the High Tinker only knows what!','',26124),
(22985,'enUS','','Oh Feknut, hush!',26124),
(22986,'enUS','','Everything\'s going to be fine, Feknut. You\'ll see.',26124),
(22987,'enUS','','Feknut, please stop. I\'m worried about Jaren and you\'re not helping.',26124),
(22988,'enUS','','Yes, and we all wish that you\'d stayed back at the keep.',26124),
(22989,'enUS','','Feknut! Enough!',26124),
(22990,'enUS','','You know, you could think about doing the work yourself. That way you could get back to the keep more quickly.',26124),
(22991,'enUS','','Feknut please quiet down. You\'re giving me a headache.',26124),
(22992,'enUS','','Feknut, please! I\'m sure that Petrov will be sending you more help soon.',26124),
(22993,'enUS','Their defenses are down!  Attack!','Their defenses are down!  Attack!',26124),
(22994,'enUS','Ahh, freedom!','',26124),
(22995,'enUS','A\'course it only be fair that I reward yeh fer me rescue. Now where\'d them savages put me satchel?','',26124),
(22996,'enUS','Don\'t be shy, now. Help yerselves. If it weren\'t fer yer help, them basterds\'d be shrinkin\' me head right about now.','',26124),
(22997,'enUS','That will be enough, Irulon.','',26124),
(22998,'enUS','Lord Fordring, you mustn\'t reveal yourself!','',26124),
(22999,'enUS','%s removes his disguise.','',26124),
(23000,'enUS','The boy\'s death and, in fact, the deaths of all of the knights involved in the redemption of the blade could have been avoided.','',26124),
(23001,'enUS','Their passing weighs heavily upon my soul.','',26124),
(23002,'enUS','The path of freedom has always been beset with tragedy, sire. We could not risk losing you. The Crusade could not have survived such a blow.','',26124),
(23003,'enUS','%s grimaces.','',26124),
(23004,'enUS','It should have been me that carried the blade to Northrend. The burden was mine to bear.\n','',26124),
(23005,'enUS','But you are right, Irulon. The price of our freedom will undoubtedly cost thousands more of their lives.','',26124),
(23006,'enUS','%s picks up the Ashbringer.','',26124),
(23007,'enUS','Do you hear me, Arthas? The Argent Crusade comes for you! Your kingdom shall crumble beneath the weight of justice! By the Light!','',26124),
(23008,'enUS','[Crude Vrykul] Bjorns mottar haelgond sygar!','[Crude Vrykul] Bjorns mottar haelgond sygar!',26124),
(23009,'enUS','No one speaks of my mother in that manner!','',26124),
(23010,'enUS','Hey mon! Don\'t ya be forgettin\' about Tanzar over here.','',26124),
(23011,'enUS','You kill the trollbear, mon? It be safe for Tanzar to come out now?','',26124),
(23012,'enUS','Hello out there. Anybody be hearin\' Tanzar?','',26124),
(23013,'enUS','I could be pickin\' this lock in my sleep, mon. Just come an\' say when it be safe to get away.','',26124),
(23014,'enUS','Pleaase! Someone save poor ol\' Tanzar.','',26124),
(23015,'enUS','Nalorakk is dead, you\'re free to go.','Nalorakk is dead, you\'re free to go.',26124),
(23016,'enUS','The ancient cipher falls to the ground.','',26124),
(23017,'enUS','We plaguebringers tend to be slightly more practical than the average apothecary.  After all, we deal with the logistics of deploying the plague.$B$BThat doesn\'t mean our theoretical background isn\'t rock solid.  We just prefer... hands on tasks.','',26124),
(23018,'enUS','Firjus fears nothing! Release the combatants!','',26124),
(23019,'enUS','More souls for the Lich King! Come, little ones! Come!','',26124),
(23020,'enUS','Have you seen the Headless Horseman?  If he comes here then I\'ll fight him and steal his pumpkin!','Have you seen the Headless Horseman?  If he comes here then I\'ll fight him and steal his pumpkin!',26124),
(23021,'enUS','I like to play in the water barrel but I\'m told it\'s not for children.','I like to play in the water barrel, but I\'m told it\'s not for children.',26124),
(23022,'enUS','They say the barrel and buckets are for fighting fires.  Are you a fire fighter?','They say the barrel and buckets are for fighting fires.  Are you a fire fighter?',26124),
(23023,'enUS','The Headless Horseman lives in the Scarlet Monastery with all the other creepy ghosts and humans.','The Headless Horseman lives in the Scarlet Monastery with all the other creepy ghosts and humans.',26124),
(23024,'enUS','They\'re giving candies and treats at the inn!  Guardian Grimwatch says if they don\'t give us a treat... then we get to play a trick on them!','They\'re giving candies and treats at the inn!  Guardian Grimwatch says if they don\'t give us a treat... then we get to play a trick on them!',26124),
(23025,'enUS','Have you seen the Headless Horseman?  The matron says if I look at him, then he\'ll turn me into a pumpkin!','Have you seen the Headless Horseman?  The matron says if I look at him, then he\'ll turn me into a pumpkin!',26124),
(23026,'enUS','You can fill a bucket at the water barrel.  It\'s fun to splash!','You can fill a bucket at the water barrel.  It\'s fun to splash!',26124),
(23027,'enUS','Wahoo! Tanzar be free!','',26124),
(23028,'enUS','I saw soldiers from Stormwind fighting a fire before.  They were heroes!','I saw soldiers from Stormwind fighting a fire before.  They were heroes!',26124),
(23029,'enUS','The Headless Horseman lives in the Scarlet Monastery.  Sometimes he comes out and scares the grown ups, but not me!','The Headless Horseman lives in the Scarlet Monastery.  Sometimes he comes out and scares the grown ups, but not me!',26124),
(23030,'enUS','I got some candy at the inn before.  I can\'t wait to get some more!','I got some candy at the inn before.  I can\'t wait to get some more!',26124),
(23031,'enUS','What luck! Here be one of Tanzar\'s things....','',26124),
(23032,'enUS','There now. It be a gift to you, to celebrate Tanzar\'s great escape!','',26124),
(23033,'enUS','A little left now - no, no, right....','',26124),
(23034,'enUS','Hrmm... left, right, wiggle, press....','',26124),
(23035,'enUS','A little deeper now - almost got it....','',26124),
(23036,'enUS','To the den of suffering...','',26124),
(23037,'enUS','Let\'s see now, press, shake, turn, turn....','',26124),
(23038,'enUS','Another soul for the scourge!','',26124),
(23039,'enUS','Flesh for the miserable slaves below...','',26124),
(23040,'enUS','Weakness... Fit for only the lowliest of undeath. To the pit!','',26124),
(23041,'enUS','','%s appears weak!',26124),
(23042,'enUS','','Thank you. I thought I would die without seeing my sisters again!',26124),
(23043,'enUS','','Where am I? What happened to me? You... you freed me?',26124),
(23044,'enUS','','I knew Lurielle would send help! Thank you, friend, and give Lurielle my thanks as well!',26124),
(23045,'enUS','Let\'s see now, press, shake, turn, turn....','',26124),
(23046,'enUS','Ya be havin\' me gratitude, $c.$b$bIf there be anythin\' I can be doin\' fer yeh, just say so.','',26124),
(23047,'enUS','Is it safe? Who has slain the trollbeast?\n','',26124),
(23048,'enUS','Kraz lives!\n','',26124),
(23049,'enUS','Come to Kraz. Accept my thanks.\n','',26124),
(23050,'enUS','Kraz must meet the slayers of the great troll-beast!\n','',26124),
(23051,'enUS','My liberators! Come down and speak with Kraz.','',26124),
(23052,'enUS','','It was kind of the Explorers\' League to allow me to tag along. However, with the dangers in the Rivenwood and surrounding area, it looks like it may have been foolish of me to come without help.',26124),
(23053,'enUS','I wanted to help fight the Headless Horseman, but old Grimwatch wouldn\'t let me!','I wanted to help fight the Headless Horseman, but old Grimwatch wouldn\'t let me!',26124),
(23054,'enUS','The next time the Headless Horseman comes, we\'ll beat him again!','The next time the Headless Horseman comes, we\'ll beat him again!',26124),
(23055,'enUS','My friend was afraid, but not me!','My friend was afraid, but not me!',26124),
(23056,'enUS','You\'re a hero!','You\'re a hero!',26124),
(23057,'enUS','The Headless Horseman was scary, but I wasn\'t scared!  Not me!','The Headless Horseman was scary, but I wasn\'t scared!  Not me!',26124),
(23058,'enUS','The Headless Horseman was scared away!','The Headless Horseman was scared away!',26124),
(23059,'enUS','If he comes back, are you going to fight him again?','If he comes back, are you going to fight him again?',26124),
(23060,'enUS','I wish I had a $gfather:mother; like you!','I wish I had a $gfather:mother; like you!',26124),
(23061,'enUS','The Winterskorn tribe will prevail!','',26124),
(23062,'enUS','Drive the invaders out!  For Queen Angerboda!','',26124),
(23063,'enUS','Fight without fear and the Val\'kyr will reward you!','',26124),
(23064,'enUS','Enough of this charade!','',26124),
(23065,'enUS','','It\'s hard work putting these things together!',26124),
(23066,'enUS','','The foot bone\'s connected to the... hip bone!  The hip bone\'s connected to this... other bone!  Hmmmhmmmmhmmm...',26124),
(23067,'enUS','','Gotta cut up the rotten bits - only the best components go into my creations!',26124),
(23068,'enUS','I have misplaced my worg disguise.','I have misplaced my worg disguise.',26124),
(23069,'enUS','','Very well, but try not to lose this one, okay?',26124),
(23070,'enUS','How could you lose it? Very well, but try not to \'lose\' this one as well.','',26124),
(23071,'enUS','The failed concoction spills on the floor and appears to come to life!','',26124),
(23072,'enUS','Fool.','',26124),
(23073,'enUS','','I\'m going to miss Camp Winterhoof, but I understand why Chieftain Ashtotem made his decision. Home is a comfort we cannot always afford.',26124),
(23074,'enUS','<The mangled body of one of the New Agamand apothecaries lies here.>','',26124),
(23075,'enUS','Take the apothecary\'s pack.','Take the apothecary\'s pack.',26124),
(23076,'enUS','I should be in Utgarde Keep, battling at Ingvar\'s side! Instead I am charged to guard little maggots like you.','',26124),
(23077,'enUS','Why we don\'t just kill you is beyond my understanding.','',26124),
(23078,'enUS','Ingvar has plans for you, little one.','',26124),
(23079,'enUS','Your time in the Ring of Judgment comes soon, maggot.','',26124),
(23080,'enUS','%s rattles the cage.','',26124),
(23081,'enUS','%s loses all self control and begins to attack friend and foe alike!','',26124),
(23082,'enUS','I sacrifice this human in the name of our dark master!','',26124),
(23083,'enUS','Take me, val\'kyr! I am ready to be judged!','',26124),
(23084,'enUS','I am ready to die!','',26124),
(23085,'enUS','','Hey, can\'t you shee I\'m trying to drink here?',26124),
(23086,'enUS','','Right, that should do it. I think ...hic.',26124),
(23087,'enUS','The vrykul clutches at his throat as he begins to gag and thrash about.','',26124),
(23088,'enUS','This place reeks of death, stranger.$b$bYou must leave before you fill a cage like Kraz.\n','',26124),
(23089,'enUS','','Bones... flesh... muscles... tendons... cartilage... it all comes together here under my hacksaw.',26124),
(23090,'enUS','We\'ve killed your captors. You\'re free to go.\n','We\'ve killed your captors. You\'re free to go.\n',26124),
(23091,'enUS','Oh, sick!','Oh, sick!',26124),
(23092,'enUS','That did NOT just happen!','That did NOT just happen!',26124),
(23093,'enUS','I feel ill.','I feel ill.',26124),
(23094,'enUS','Heh, cool!','Heh, cool!',26124),
(23095,'enUS','What kind of sicko are you?','What kind of sicko are you?',26124),
(23096,'enUS','I didn\'t know they could do that.','I didn\'t know they could do that.',26124),
(23097,'enUS','That\'s... special.','That\'s... special.',26124),
(23098,'enUS','That\'s the new Forsaken plague?!','That\'s the new Forsaken plague?!',26124),
(23099,'enUS','It\'s alive!','',26124),
(23100,'enUS','Steady your hand, you fool!  Those are rare components you\'re spilling on the floor!','',26124),
(23101,'enUS','The mixture!  It moves!','',26124),
(23102,'enUS','%s turns to face you.','',26124),
(23103,'enUS','Uh...?','Uh...?',26124),
(23104,'enUS','Yikes.','Yikes.',26124),
(23105,'enUS','Is he okay?','Is he okay?',26124),
(23106,'enUS','Captain\'s not gonna like this.','Captain\'s not gonna like this.',26124),
(23107,'enUS','Interesting.','Interesting.',26124),
(23108,'enUS','Whoa.','Whoa.',26124),
(23109,'enUS','Invaders! Sound the alarm!','Invaders! Sound the alarm!',26124),
(23110,'enUS','Stand clear....','',26124),
(23111,'enUS','Please, friends, accept this offering with Kraz\'s thanks.','',26124),
(23112,'enUS','Greer, I need a gryphon to ride and some bombs to drop on New Agamand!','Greer, I need a gryphon to ride and some bombs to drop on New Agamand!',26124),
(23113,'enUS','Here you go, $g lad : lass;. Make \'em count!','',26124),
(23114,'enUS','','',26124),
(23115,'enUS','Now, where have they put Kraz\'s things?','',26124),
(23116,'enUS','So then we too are cursed?','',26124),
(23117,'enUS','%s points to the infant.','',26124),
(23118,'enUS','','%s sobs.',26124),
(23119,'enUS','The gods have forsaken us! We must dispose of it before Ymiron is notified!','',26124),
(23120,'enUS','','NO! You cannot! I beg of you! It is our child!',26124),
(23121,'enUS','Then what are we to do, wife? The others cannot find out. Should they learn of this aberration, we will all be executed.','',26124),
(23122,'enUS','','I... I will hide it. I will hide it until I find it a home, far away from here...',26124),
(23123,'enUS','All hail our glorious king, Ymiron!','All hail our glorious king, Ymiron!',26124),
(23124,'enUS','Let him speak! Be silent!','Let him speak! Be silent!',26124),
(23125,'enUS','Show the abberations no mercy, Ymiron!','Show the abberations no mercy, Ymiron!',26124),
(23126,'enUS','Fire upon Skorn!','Fire upon Skorn!',26124),
(23127,'enUS','Vrykul must remain pure!','Vrykul must remain pure!',26124),
(23128,'enUS','Show them mercy, my king! They are of our flesh and blood!','Show them mercy, my king! They are of our flesh and blood!',26124),
(23129,'enUS','They weaken us! Our strength is dilluted by their very existence! Destroy them all!','They weaken us! Our strength is dilluted by their very existence! Destroy them all!',26124),
(23130,'enUS','%s motions for silence.','',26124),
(23131,'enUS','Shhh!','Shhh!',26124),
(23132,'enUS','The king is going to speak!','The king is going to speak!',26124),
(23133,'enUS','Silence!','Silence!',26124),
(23134,'enUS','Vrykul, your king implores you to listen!','',26124),
(23135,'enUS','The gods have abandoned us!','',26124),
(23136,'enUS','The crowd gasps in horror.','',26124),
(23137,'enUS','Even now, in our darkest hour, they mock us!','',26124),
(23138,'enUS','Where are the titans in our time of greatest need? Our women birth abberations - disfigured runts unable to even stand on their own! Weak and ugly... Useless...','',26124),
(23139,'enUS','Ymiron has toiled. Long have I sat upon my throne and thought hard of our plight. There is only one answer... one reason...','',26124),
(23140,'enUS','For who but the titans themselves could bestow such a curse? What could have such power?','',26124),
(23141,'enUS','And the answer is nothing... For it is the titans that have cursed us!','',26124),
(23142,'enUS','The crowd clamours.','',26124),
(23143,'enUS','On this day all Vrykul will shed their old beliefs! We denounce our old gods! All Vrykul will pledge their allegiance to Ymiron! Ymiron will protect our noble race!','',26124),
(23144,'enUS','The crowd cheers.','',26124),
(23145,'enUS','And now my first decree upon the Vrykul! All malformed infants born of Vrykul mother and father are to be destroyed upon birth! Our blood must remain pure always! Those found in violation of Ymiron\'s decree will be taken to Gjalerbron for execution!','',26124),
(23146,'enUS','%s grins.','',26124),
(23147,'enUS','Shamanism has brought you here... Its scent permeates the air. *The Lich King laughs* I was once a shaman.','',26124),
(23148,'enUS','No, minion. This one is not ready.','',26124),
(23149,'enUS','Do you feel it, mortal? Death seeps through me, enveloping all that I touch. With just a snap of my finger your soul will languish in damnation for all eternity.','',26124),
(23150,'enUS','But... It is not yet your time to serve the Lich King. Yes, a greater destiny awaits you. Power... You must become more powerful before you are to serve me.','',26124),
(23151,'enUS','Now watch, val\'kyr. Observe as I apply pressure. Can you see that it is not yet ripe? Watch as it pops and falls lifeless to the floor.','',26124),
(23152,'enUS','','Shall we prepare it for you, my lord?',26124),
(23153,'enUS','','Oh hooray - you killed the bad troll just in time to save me from being helplessly slaughtered and having my innocent little soul enslaved and used to add power to their wicked scheme to take over Azeroth and seeing how you have risked your lives to free me from certain death I must repay your kindness regardless of who you are or where you may have come from so help me out of here and I will do my best to find some way to reward you....$b$b<Ashli takes a deep breath.>$b$bI hope you like candy....',26124),
(23154,'enUS','It\'s safe, little gnome. You can come out now.','It\'s safe, little gnome. You can come out now.',26124),
(23155,'enUS','Of course. I found it on the corpse of a dwarf nearby.','',26124),
(23156,'enUS','','Wowee! It was amazing how you beat that big bad troll into the ground like that and it\'s too bad I can\'t reach the handle of this cage or I would have jumped in and blown him to bits to get him back for killing all of the other poor prisoners and scaring me so badly and I feel bad for asking you for any more help but could you maybe come over and let me out of here?',26124),
(23157,'enUS','Of course.','',26124),
(23158,'enUS','','Ahem... so, I most certainly don\'t blame you for taking your time and catching your breath and congratulating yourselves for such heroism after such a long and hard-fought battle with that horrible monster just so long as when you\'re finished you don\'t forget about me over here because even though I\'m small I think I can still find some way to repay you for your amazing bravery....',26124),
(23159,'enUS','','So... as much as I hate to complain after being saved from a horrible death I just thought you should know that I\'m still over here stuck in one of these messy cages and it would really be great if you could come on over and let me out so I could help you celebrate your amazing victory over that big crazy scary troll-cat... thing.',26124),
(23160,'enUS','','I\'m sure you all must be in a big hurry and probably have some more big dangerous monsters to kill but if you would just take a moment and come help me out of this cage before rushing off it would make me so happy and excited that I would barely be able to contain myself so if you get a moment I\'ll just be over here... waiting... patiently....',26124),
(23161,'enUS','I can get you started on your journey to Northrend. Let me know when you are ready and I will teleport you to your starting point.','',26124),
(23162,'enUS','I\'m ready to go!','I\'m ready to go!',26124),
(23163,'enUS','Go now! Do the bidding of your masters!','',26124),
(23164,'enUS','You wanna go to Zul\'Aman, mon? I be takin\' you der.','',26124),
(23165,'enUS','Take me to Zul\'Aman!','Take me to Zul\'Aman!',26124),
(23166,'enUS','You be dead soon enough!','',26124),
(23167,'enUS','I bring da pain!','',26124),
(23168,'enUS','You call on da beast, you gonna get more dan you bargain for!','',26124),
(23169,'enUS','Make way for da Nalorakk!','',26124),
(23170,'enUS','You had your chance; now it be too late!','',26124),
(23171,'enUS','Now whatchoo got to say?','',26124),
(23172,'enUS','Da Amani gonna rule again!','',26124),
(23173,'enUS','I... be waitin\' on da udda side....','',26124),
(23174,'enUS','De Zandalari give us strength. Nobody push around de Amani no more!','',26124),
(23175,'enUS','Got me some new tricks... like me brudda bear....','',26124),
(23176,'enUS','Dere be no hidin\' from da eagle!','',26124),
(23177,'enUS','Let me introduce you to me new bruddas: fang and claw!','',26124),
(23178,'enUS','Ya don\' have to look to da sky to see da dragonhawk!','',26124),
(23179,'enUS','Fire kill you just as quick!','',26124),
(23180,'enUS','Dis is why dey call me INVINCIBLE!','',26124),
(23181,'enUS','Da Amani di chuka!','',26124),
(23182,'enUS','Lot more going to fall like you.','',26124),
(23183,'enUS','Mebbe me fall... but da Amani empire... never going to die.','',26124),
(23184,'enUS','','Weeee! I\'m alive, I\'m alive, I\'m alive! Oh, I hope it\'s not too forward of me to tell you that I think I love you all and I hope I can find my bag because you certainly deserve a little something extra, you know, for the effort and all that you must have went through to save me...',26124),
(23185,'enUS','','Hmm, maybe it\'s this one - oh by the way, did I ever tell you about the time Fudgerick Two-toots snuck up on me while I was casting a fireball? We call him two-toots because, well, nevermind that, it was just terrible timing, and momma was soo mad - my eyebrows are just now growing back....',26124),
(23186,'enUS','','Hey, bartender, another round!',26124),
(23187,'enUS','','You done cleaning that mug yet ...hic?',26124),
(23188,'enUS','','I can whip up better than thish, Jashon.',26124),
(23189,'enUS','','You should... you should send thish shtuff over to Petrov for his bombs!',26124),
(23190,'enUS','','That\'s a pretty dressh, Celeste. You\'re sho pretty. I love you guys ...hic!',26124),
(23191,'enUS','I think you\'ve had just about enough.','',26124),
(23192,'enUS','Uh huh.','',26124),
(23193,'enUS','Who\'s that talking? I can barely see the top of your head. Are you sure that you\'re old enough to be drinking?','',26124),
(23194,'enUS','Peppy, I swear you could drink a dwarf under the table.','',26124),
(23195,'enUS','I love you, pooky!','',26124),
(23196,'enUS','','I love you too, snookums!',26124),
(23197,'enUS','The bartender hums a tune while working.','',26124),
(23198,'enUS','','Lissan! Lissan White! Where is that girl?',26124),
(23199,'enUS','','You just can\'t get good help these days!',26124),
(23200,'enUS','','Lissan! I bet that girl is daydreaming at the well again!',26124),
(23201,'enUS','','<Grumble> Pretty dress indeed! <Grumble>',26124),
(23202,'enUS','','I need more shoveltusk!',26124),
(23203,'enUS','','Are those dock workers on break again?! I need those supplies!',26124),
(23204,'enUS','','%s sighs at all of the cooking she still has to do today.',26124),
(23205,'enUS','','Thank you, sweety. We love you, too.',26124),
(23206,'enUS','','Nope, not in that one either - well, it must be around here somewhere, by the way, did I mention how wonderful it is to be out of that stinky cage? It was almost impossible to run around in there but I did anyway but sometimes I got going so fast that I ended up walking on the walls of the  cage so finally I stopped trying and just turned around in circles....',26124),
(23207,'enUS','','There\'s my bag! At last I\'ve found it and now it\'s my gift to you and I truly hope you like it because I want you to all remember this wonderful moment for as long as you live and I hope that when you think of it you\'ll smile inside because I know I\'ll never forget it in a million years and I can\'t wait to tell momma all about it when I get back home.... Do you like my earrings?',26124),
(23208,'enUS','Ya saved me, mon! I thought they be drownin\' me for sure.','',26124),
(23209,'enUS','Just lemme know if there be anything I can help ya with, mon.','',26124),
(23210,'enUS','The Alliance team is running out of reinforcements!','The Alliance team is running out of reinforcements!',26124),
(23211,'enUS','The Horde team is running out of reinforcements!','The Horde team is running out of reinforcements!',26124),
(23212,'enUS','Ya know, without so many of them burly trolls wanderin\' about this place can be downright pleasant.','',26124),
(23213,'enUS','I wonder if I\'ll ever be the same after this. Heh, nuthin\' a pint won\'t cure I\'ll wager.','',26124),
(23214,'enUS','Quite an adventure, this. The boys back home won\'t believe a word of it....','',26124),
(23215,'enUS','I oughtta shuffle on down and poke around fer treasure while I\'m here - after all, what\'re the odds of a dwarf like me gettin\' pinched twice?','',26124),
(23216,'enUS','That rescue came just in time. Ya shoulda seen what them brutes did to their prisoners....','',26124),
(23217,'enUS','This\'ll make fer a great a story to tell the grandkids, that\'s fer sure... if I be livin\' long enough to have any, that is.','',26124),
(23218,'enUS','It be days like today that make ye grateful fer the kindness of strangers - brings a tear to me eye.... Heh, nuthin a good pint won\'t fix.','',26124),
(23219,'enUS','Mebbe I should write a book... \'Harkor\'s Guide to Zul\'Aman\'. Yeah, I like the sound a\' that.','',26124),
(23220,'enUS','People, really, there\'s nothing to worry about!','',26124),
(23221,'enUS','Alliance idiots! Don\'t they realize their efforts are futile?','',26124),
(23222,'enUS','Yes, let\'s all run around like chickens with their heads cut off.','',26124),
(23223,'enUS','Even the toads? Unbelievable!','',26124),
(23224,'enUS','The fools! I knew they\'d try this, which is why I fire-proofed the plague tanks. Muahahahahaha!','',26124),
(23225,'enUS','Ignore that... we have work to do!','',26124),
(23226,'enUS','Fools! It could very well be an increase in temperature that perfects the plague!','',26124),
(23227,'enUS','Oooh, a little fire. Everyone panic!','',26124),
(23228,'enUS','The plaguebringer sighs at the interruption.','',26124),
(23229,'enUS','Looking around, %s frowns at what he considers the overreactions of his compatriots.','',26124),
(23230,'enUS','%s shakes his head before continuing on with his research.','',26124),
(23231,'enUS','Seemingly unphased by the nearby plague tank on fire, %s appears inspired.','',26124),
(23232,'enUS','You can\'t... kill... me spirit!','',26124),
(23233,'enUS','Stop your cryin\'!','',26124),
(23234,'enUS','Ya got nothin\'!','',26124),
(23235,'enUS','I be da predator! You da prey...','',26124),
(23236,'enUS','All you be doin\' is wastin\' me time!','',26124),
(23237,'enUS','That should do it. The gate\'s primary locking mechanism has been nullified.','',26124),
(23238,'enUS','Thanks for the concern, but we intend to explore Zul\'Aman.','Thanks for the concern, but we intend to explore Zul\'Aman.',26124),
(23239,'enUS','Let me guess, another group of Budd\'s riff-raff?$b$bAway with you, $r, before you get hurt - or worse.','',26124),
(23240,'enUS','I\'m aware of the dangers of this place. Now move out of the way, I won\'t ask again.','I\'m aware of the dangers of this place. Now move out of the way, I won\'t ask again.',26124),
(23241,'enUS','I\'ve researched this site extensively and I won\'t allow any dim-witted treasure hunters to swoop in and steal what belongs in a museum. I\'ll lead this charge.','',26124),
(23242,'enUS','In fact, it would be best if you just stay here. You\'d only get in my way....','',26124),
(23243,'enUS','Regardless, stay out of my way, and don\'t bother calling for me when you get yourself into trouble....','',26124),
(23244,'enUS','Hey there!  Just because I can race rams better than anyone else, doesn\'t mean I won\'t pitch in and help out the brewers.  You can help out if you like.$b$bBut wait, there\'s more!$b$bHelping out with Brewfest means you get a chance to ride some of the fastest rams in the realms!','',26124),
(23245,'enUS','Do you still need some help shipping kegs from Kharanos?','Do you still need some help shipping kegs from Kharanos?',26124),
(23246,'enUS','I\'m only going to carve the runes I think will give you command over a giant.','',26124),
(23247,'enUS','I\'m omitting the runes for \"north\" and \"west\" because I\'m not sure how they impact the giant. I\'m also including a rune to limit how long you can control it.','',26124),
(23248,'enUS','There we go, the Rune of Command... hopefully. Not nearly as vicious as its Iron Dwarf cousin, but functional.','',26124),
(23249,'enUS','%s stares off to the Northeast!','',26124),
(23250,'enUS','%s looks toward the summoning stones and sighs.','',26124),
(23251,'enUS','Ahaha, ya see this? Griftah\'s BACK! Back in my stall, back with my old wares, and ready to pass on the deals to ya!$b$bWant to be better, stronger, faster? Each one of these amulets be guaranteed to do just what I say they be doin\'. Step up and buy one of these miraculous baubles! Cheap at twice the price!','',26124),
(23252,'enUS','More intruders! Sound da alarm!','',26124),
(23253,'enUS','Da spirits gonna feast today! Begin da ceremonies, sacrifice da prisoners... make room for our new guests!','',26124),
(23254,'enUS','Dark times make for strange friendships. It may be worth visiting old Lordaeron to watch the Forsaken burn their little man of wicker.','Dark times make for strange friendships. It may be worth visiting old Lordaeron to watch the Forsaken burn their little man of wicker.',26124),
(23255,'enUS','I understand this holiday is a creation not of our allies, but the Horde. Why we follow suit, I do not know.','I understand this holiday is a creation not of our allies, but the Horde. Why we follow suit, I do not know.',26124),
(23256,'enUS','We\'re celebrating the who breaking free of the what? Bah, who cares?! More candy!','We\'re celebrating the who breaking free of the what? Bah, who cares?! More candy!',26124),
(23257,'enUS','Why does everyone keep saying the LAST thing we gnomes need is more sugar?!','Why does everyone keep saying the LAST thing we gnomes need is more sugar?!',26124),
(23258,'enUS','All this free candy is just bad business, I tell you. Or... maybe it\'s just a loss leader... they get you in the inn, and then gouge you on the meat. It\'s brilliant!','All this free candy is just bad business, I tell you. Or... maybe it\'s just a loss leader... they get you in the inn, and then gouge you on the meat. It\'s brilliant!',26124),
(23259,'enUS','When Hallow\'s End is over we\'ll smash all these pumpkins. That\'ll be the greatest day I\'ve ever known!','When Hallow\'s End is over we\'ll smash all these pumpkins. That\'ll be the greatest day I\'ve ever known!',26124),
(23260,'enUS','To celebrate the birth of yet another deadly enemy is an odd thing, to say the least. Still, we will join our allies in their festivities.','To celebrate the birth of yet another deadly enemy is an odd thing, to say the least. Still, we will join our allies in their festivities.',26124),
(23261,'enUS','The Forsaken are right to celebrate their freedom. What else is more important?','The Forsaken are right to celebrate their freedom. What else is more important?',26124),
(23262,'enUS','I do not understand the significance of the Forsaken burning a great wicker effigy each night, but our own rituals must seem just as strange to them.','I do not understand the significance of the Forsaken burning a great wicker effigy each night, but our own rituals must seem just as strange to them.',26124),
(23263,'enUS','I don\'t know why the Forsaken burn a wicker man every night of Hallow\'s End instead of a real one, but it\'s their holiday.','I don\'t know why the Forsaken burn a wicker man every night of Hallow\'s End instead of a real one, but it\'s their holiday.',26124),
(23264,'enUS','During Hallow\'s End we celebrate the day that the Banshee Queen herself delivered us from the clutches of the Lich King and the Scourge. Be sure to attend the Wickerman Festival that is held each evening outside Undercity.','During Hallow\'s End we celebrate the day that the Banshee Queen herself delivered us from the clutches of the Lich King and the Scourge. Be sure to attend the Wickerman Festival that is held each evening outside Undercity.',26124),
(23265,'enUS','How could you have lost the evidence?!','',26124),
(23266,'enUS','I thought it was secure! If your peacekeepers had the clout to control the thieves of this city, this wouldn\'t have happened!','',26124),
(23267,'enUS','You blame the peacekeepers for your failure? You were entrusted with a simple task. The troll was obviously a fraud!','',26124),
(23268,'enUS','LOOK AT ME, I\'M RANDOMIZING! HERE IT COMES (IN 5 SECONDS)!','',26124),
(23270,'enUS','Mummified trolls... hastily embalmed by the looks of them.','',26124),
(23271,'enUS','Hmm. The significance of this bird eludes me.','',26124),
(23272,'enUS','These fires have been burning steadily for years. Unusual dedication for trolls.','',26124),
(23273,'enUS','Puzzling. They\'re clearly harnessing great power from their sacrifices. But for what?','',26124),
(23274,'enUS','Interesting use of materials here. Rich color, strong lines, deep symbolism.... striking.','',26124),
(23275,'enUS','This statuary is a significant departure from previous troll effigies.','',26124),
(23276,'enUS','Yes, yes, I\'m quite certain this represents a melding of entities. Fascinating.','',26124),
(23277,'enUS','Ugh. Matted clumps of hair, molted feathers, bits of bone, partially burnt material - clothing perhaps?','',26124),
(23278,'enUS','Trash packaged, stacked and neatly set aside. Such order in contrast with extreme barbarity... remarkable.','',26124),
(23279,'enUS','One can learn volumes about a culture by studying its refuse.','',26124),
(23280,'enUS','What\'s this? A broken tooth. Likely from a giant cat of some sort. Odd....','',26124),
(23281,'enUS','Ashes and charred bones, most unsettling. I must take a sample.','',26124),
(23282,'enUS','Strange... these mosaics don\'t resemble any known troll traditions.','',26124),
(23283,'enUS','Barrels like these are unique in this region. Short, round....','',26124),
(23284,'enUS','Happy Hallow\'s End!','Happy Hallow\'s End!',26124),
(23285,'enUS','I think I\'ve eaten too much candy...','I think I\'ve eaten too much candy...',26124),
(23286,'enUS','We should go trick or treating later.','We should go trick or treating later.',26124),
(23287,'enUS','You know... why DO we celebrate this holiday?','You know... why DO we celebrate this holiday?',26124),
(23288,'enUS','This time of year is quite important to our Forsaken allies.','This time of year is quite important to our Forsaken allies.',26124),
(23289,'enUS','Azeroth has many strange traditions. This one, I like.','Azeroth has many strange traditions. This one, I like.',26124),
(23290,'enUS','Why isn\'t there beer-flavored candy?!','Why isn\'t there beer-flavored candy?!',26124),
(23291,'enUS','More tricks, I say. Those are the REAL treats!','More tricks, I say. Those are the REAL treats!',26124),
(23292,'enUS','We should attend the next burning of the Wickerman.','We should attend the next burning of the Wickerman.',26124),
(23293,'enUS','Are there any more inns we can visit for treats?','Are there any more inns we can visit for treats?',26124),
(23294,'enUS','Curse this twisting of the night. The candy\'s good, though.','Curse this twisting of the night. The candy\'s good, though.',26124),
(23295,'enUS','The Forsaken are right to celebrate their freedom.','The Forsaken are right to celebrate their freedom.',26124),
(23296,'enUS','It is our duty to honor the sacred days of our allies, however strange.','It is our duty to honor the sacred days of our allies, however strange.',26124),
(23297,'enUS','Someone should make a candy with a chewy gnome center.','Someone should make a candy with a chewy gnome center.',26124),
(23298,'enUS','NOW is the time of the Forsaken!','NOW is the time of the Forsaken!',26124),
(23299,'enUS','There MUST be a way to make more money off of this holiday.','There MUST be a way to make more money off of this holiday.',26124),
(23300,'enUS','The innkeepers are mad to be giving away treats for free.','The innkeepers are mad to be giving away treats for free.',26124),
(23301,'enUS','Greetings and welcome to Blizzcon!  We are temporarily borrowing this dock to transport you to Northrend.  Your ride should be here shortly.  Enjoy!','',26124),
(23302,'enUS','And you\'re entrusted with keeping the city safe! How am I supposed to perform my \"simple task\" if the streets are thick with lowlifes? I can\'t spit in Shattrath without hitting some grubby burglar.','',26124),
(23303,'enUS','...not that I would spit, of course.','',26124),
(23304,'enUS','Ahem, Mister Kyle, I\'m trying to move across the room as hard as I can... please fix me!','',26124),
(23305,'enUS','What could be better than servin\' da bear spirit for eternity? Come closer now. Bring your souls to me!','',26124),
(23306,'enUS','I smell you, strangers. Don\'t be delayin\' your fate. Come to me now. I make your sacrifice quick.','',26124),
(23307,'enUS','My eagles gonna bear your spirits to me. Your sacrifices not gonna be in vain....','',26124),
(23308,'enUS','Your death gonna be quick, strangers. You shoulda never come to this place....','',26124),
(23309,'enUS','Come, fools. Fill ma empty cages....','',26124),
(23310,'enUS','I be waitin, strangers. Your deaths gonna make me stronger!','',26124),
(23311,'enUS','Arise from the earth, my brothers!','',26124),
(23312,'enUS','Our iron masters have a mission for us!','',26124),
(23313,'enUS','Come, friends. Your bodies gonna feed ma hatchlings, and your souls gonna fill me with power!','',26124),
(23314,'enUS','Come, strangers. The spirit of da dragonhawk be hungry for worthy souls.','',26124),
(23315,'enUS','Follow me into the mountains to carry out the plan of the masters!','',26124),
(23316,'enUS','Take your pick, trespassers! Any of ma priests be happy to accommodate ya.','',26124),
(23317,'enUS','Don\'t be shy. Thousands have come before you. Ya not be alone in your service.','',26124),
(23318,'enUS','Ya gonna fail, strangers. Many try before you, but dey only make us stronger!','',26124),
(23319,'enUS','I was trying to oust one of those lowlifes you so loathe permanently! Next time, I\'ll be certain to specify that I require a competent investigator!','',26124),
(23320,'enUS','Do you EVER cease prattling?','',26124),
(23321,'enUS','%s scowls and looks away.','',26124),
(23322,'enUS','That man didn\'t pay me enough to put up with this blowhard...','',26124),
(23323,'enUS','%s frowns at Investigator Asric and arches a brow.','',26124),
(23324,'enUS','What was that?','',26124),
(23325,'enUS','Oh, nothing. Merely thinking aloud.','',26124),
(23326,'enUS','Your efforts was in vain, trespassers. The rituals nearly be complete.','',26124),
(23327,'enUS','Soon da cages gonna be empty, da sacrifices be complete, and you gonna take dere places.','',26124),
(23328,'enUS','Time be running low, strangers. Soon you gonna join da souls of dem ya failed to save.','',26124),
(23329,'enUS','Make haste, ma priests! Da rituals must not be interrupted!','',26124),
(23330,'enUS','Many are the rare and precious objects that my clientele seek.$B$BYou could be the one to bring them to me, $c. In return I offer that which you covet.$B$BShall we speak more on that which I look to procure today?','',26124),
(23331,'enUS','An order is whispered upon the nether winds and Mah\'duun hears.$B$BA $g man : woman; comes before Mah\'duun, and they speak of those which the winds demand be slain today.','',26124),
(23332,'enUS','We will not fail!','',26124),
(23333,'enUS','Ya make a good try... but now you gonna join da ones who already fall.','',26124),
(23334,'enUS','Watch now. Every offering gonna strengthen our ties to da spirit world. Soon, we gonna be unstoppable!','',26124),
(23335,'enUS','Ya not do too bad.... Your efforts delay da inevitable for a small time. Come to me now. Ya prove yourselves worthy offerings.','',26124),
(23337,'enUS','%s begins sputtering.','',26124),
(23338,'enUS','Look, it works.','',26124),
(23339,'enUS','We set up this area to practice fire fighting.  You never know when the town will be imperiled!','We set up this area to practice fire fighting.  You never know when the town will be imperiled!',26124),
(23340,'enUS','','I bet ya think you\'re tough, eh, kid? I guess I might have something for ya if ya can hold your own in the arena. Good stuff, not like Krixel\'s. That\'s so last season, ya know?$b$bOh, and have a nice day.',26124),
(23341,'enUS','Here we practice fire fighting techniques.  Honor to the horde!','Here we practice fire fighting techniques.  Honor to the horde!',26124),
(23342,'enUS','Well done!  We\'ll be ready when the real fires begin!','Well done!  We\'ll be ready when the real fires begin!',26124),
(23343,'enUS','Quickly, $c!  Blazes rage through Razor Hill!  Go! Fight those fires!','Quickly, $c!  Blazes rage through Razor Hill!  Go! Fight those fires!',26124),
(23344,'enUS','$n, the village of Goldshire is burning!  Go help fight the fire!','$n, the village of Goldshire is burning!  Go help fight the fire!',26124),
(23345,'enUS','All right, so maybe the arenas ain\'t for you, right? Right. Turns out Vixton had some leftover armor from the first season, and we gotta get rid of it somehow. But nothing\'s free, know what I\'m sayin\'?','All right, so maybe the arenas ain\'t for you, right? Right. Turns out Vixton had some leftover armor from the first season, and we gotta get rid of it somehow. But nothing\'s free, know what I\'m sayin\'?',26124),
(23346,'enUS','Greetings, kind stranger, and thank you for your selfless act.','',26124),
(23347,'enUS','These heathens have robbed me of my belongings, but I can offer you this charm I took from my captors.','',26124),
(23348,'enUS','Farewell.','',26124),
(23349,'enUS','Next year, I\'m dressing up as either a corsair or an assassin.','Next year, I\'m dressing up as either a corsair or an assassin.',26124),
(23350,'enUS','What do you think of the mask?','What do you think of the mask?',26124),
(23351,'enUS','For the Alliance!','For the Alliance!',26124),
(23352,'enUS','Where\'s me gold? Where\'s me beer? Where\'s me feet?','Where\'s me gold? Where\'s me beer? Where\'s me feet?',26124),
(23353,'enUS','Waaah! I don\'t want to die! I want to live forever! It\'s not fair!','Waaah! I don\'t want to die! I want to live forever! It\'s not fair!',26124),
(23354,'enUS','Boo-hoo! I\'m a poor little gnome, and I don\'t have a capital ci... oh, wait.','Boo-hoo! I\'m a poor little gnome, and I don\'t have a capital ci... oh, wait.',26124),
(23355,'enUS','Ishnu-dal-dieb.','Ishnu-dal-dieb.',26124),
(23356,'enUS','Gaze upon my crazy tentacle-face and despair, Azerothian!','Gaze upon my crazy tentacle-face and despair, Azerothian!',26124),
(23357,'enUS','For the Horde!','For the Horde!',26124),
(23358,'enUS','Brains... braaaiiins!','Brains... braaaiiins!',26124),
(23359,'enUS','Zug zug! Mok\'ra! Er... Dabu!','Zug zug! Mok\'ra! Er... Dabu!',26124),
(23360,'enUS','Mooo!','Mooo!',26124),
(23361,'enUS','Me got the mad voodoo, mon!','Me got the mad voodoo, mon!',26124),
(23362,'enUS','I am a slender, delicate flower!','I am a slender, delicate flower!',26124),
(23363,'enUS','Hey! Did you eat the last of the chicken? I was saving that for a special occasion!','Hey! Did you eat the last of the chicken? I was saving that for a special occasion!',26124),
(23364,'enUS','For the Alliance! Wait... the Horde! Wait... which was I again?','For the Alliance! Wait... the Horde! Wait... which was I again?',26124),
(23365,'enUS','For the Horde! No... the Alliance! Uh... which mask did I have?','For the Horde! No... the Alliance! Uh... which mask did I have?',26124),
(23366,'enUS','You be sayin\' that now, but come dinner you\'ll think differently!','You be sayin\' that now, but come dinner you\'ll think differently!',26124),
(23367,'enUS','I wouldn\'t eat yer leftovers if the only other thing to eat was rubble!','I wouldn\'t eat yer leftovers if the only other thing to eat was rubble!',26124),
(23368,'enUS','Alright, now follow me, girl.','Alright, now follow me, girl.',26124),
(23369,'enUS','May it serve you well, $n.','',26124),
(23370,'enUS','Yeouch! Watch where you throw that stuff!','Yeouch! Watch where you throw that stuff!',26124),
(23371,'enUS','Fascinating! These embers somehow generate almost no heat.','',26124),
(23372,'enUS','This smoke is like nothing I\'ve smelled before. I wonder what they\'re burning here.','',26124),
(23373,'enUS','Hmm, thank you stranger.','',26124),
(23374,'enUS','I fear I have nothing but this old chest I discovered here. You\'re welcome to it.','',26124),
(23375,'enUS','I hope you find its contents... useful.','',26124),
(23376,'enUS','Until we next meet....','',26124),
(23377,'enUS','There\'s always a need for more kegs at Brewfest!$b$bI\'ll lend you the reins to one of my personal rams.$b$bEvery time you bring me a keg, I\'ll give you some tokens.  I\'ll even let you use the ram for a bit longer for every keg you bring me!  \n\nTake heed! Once you start this, you won\'t be able to do it again until tomorrow.\n\nAre you sure you\'re ready to do this?','There\'s always a need for more kegs at Brewfest!$b$bI\'ll lend you the reins to one of my personal rams.$b$bEvery time you bring me a keg, I\'ll give you some tokens.  I\'ll even let you use the ram for a bit longer for every keg you bring me!  \n\nTake heed! Once you start this, you won\'t be able to do it again until tomorrow.\n\nAre you sure you\'re ready to do this?',26124),
(23378,'enUS','I\'m ready to work for you today!  Give me the good stuff!','I\'m ready to work for you today!  Give me the good stuff!',26124),
(23379,'enUS','','Oooh! It\'s about time someone rescued me....',26124),
(23380,'enUS','','I suppose I should be grateful. Please, take this. I want nothing to remind me of this place.',26124),
(23381,'enUS','','I took it from one of these trolls as I was captured. Maybe you can find a way to use it against them.',26124),
(23382,'enUS','','I\'ve had quite enough of this place. Goodbye.',26124),
(23383,'enUS','','Ahhh, finally!',26124),
(23384,'enUS','','Say, I found this charm just before they caught me. Maybe it\'ll do you some good here....',26124),
(23385,'enUS','','I hope it helps. These vile beasts simply must be stopped!',26124),
(23386,'enUS','','Good luck to you!',26124),
(23387,'enUS','Well, now. What a pleasant turn of events.','',26124),
(23388,'enUS','It\'s most fortunate for you that you rescued me, and not one of these other poor sots.','',26124),
(23389,'enUS','Please accept this payment, as well as my gratitude, for your trouble.','',26124),
(23390,'enUS','Be well, $n.','',26124),
(23391,'enUS','Woohoo! I\'m saved! I thank you, $n.','',26124),
(23392,'enUS','Oh, my. What IS that smell - oh wait, heh, whoops! Guess my senses will take a little time to get readjusted.','',26124),
(23393,'enUS','My apologies, friends. Here, now. This should help to cover the expenses involved in my rescue.','',26124),
(23394,'enUS','See ya later!','',26124),
(23395,'enUS','Are those ingredients chopped up and cooked?  What\'s the hold up?!','',26124),
(23396,'enUS','We have a dozen more dishes to finish today!  Get a move on!','',26124),
(23397,'enUS','Put a little elbow grease into it!  And maybe some regular grease, while you\'re at it.  Those mag\'har sure like the clefthoof fat.','',26124),
(23398,'enUS','','Yeah, yeah!  Shut yer trap and let me finish this stew!',26124),
(23399,'enUS','','Can\'t make water boil any faster, genius!',26124),
(23400,'enUS','','It\'ll be done when it\'s done, darn it!',26124),
(23401,'enUS','Oh, can it be? I... I\'m free of that hideous curse? ','',26124),
(23402,'enUS','Words cannot express my gratitude, $n. Thank you for your kindness.','',26124),
(23403,'enUS','As you can see, I have but little after these savages got hold of me, but you\'re welcome to what I have. Come, have a look.','',26124),
(23404,'enUS','I must go now, before I get myself caught again. If you need anything, I won\'t be far.','',26124),
(23405,'enUS','','Mmmm, flies! Even better now that I can taste them.',26124),
(23406,'enUS','','Nice to be back among the unliving, thanks to you.',26124),
(23407,'enUS','','Perhaps I am able to offer something of interest to you? Come, see if there\'s anything you like.',26124),
(23408,'enUS','','I must be off now, $n. See you around.',26124),
(23409,'enUS','Drop point check commencing!','',26124),
(23410,'enUS','Gargoyle attack! Grab yer rifles, men!','',26124),
(23411,'enUS','','Weee! I\'m a girl again!',26124),
(23412,'enUS','','Thank you for rescuing me. I simply hate being a yucky frog!',26124),
(23413,'enUS','','I\'m really not supposed to talk to strangers, but you\'ve been so nice to me. Here\'s a special something I found just before I was kidnapped.',26124),
(23414,'enUS','','I should go now. Be careful!',26124),
(23415,'enUS','Warning! Power supply failing - activating emergency measures.','',26124),
(23416,'enUS','Time until Christmas: $3930d.','Time until Christmas: $3930d.',26124),
(23417,'enUS','Aww, nuts! You\'ve ruined everything!','',26124),
(23418,'enUS','Do you have any idea how neat it is to hop that far?','',26124),
(23419,'enUS','Oh well, I was starting to miss my pals anyway - they\'re not gunna believe this! Oh, here - you can have this, I found it playin\' hide and seek.','',26124),
(23420,'enUS','Let\'s see if I can still make that sound....','',26124),
(23421,'enUS','Hrmmph. Thanks all the same, but I didn\'t need any help.','',26124),
(23422,'enUS','I was working on a cantrip that would counteract my predicament and I was very close to finding a <CROOAAK>... Oh my!','',26124),
(23423,'enUS','Well, I suppose I do owe you a little something - here, take one of these. I\'ve got lots.','',26124),
(23424,'enUS','You may want to consider leaving this place. I think being transformed into a frog is one of the better things that can happen to one here.','',26124),
(23425,'enUS','','Oh! Back to my beautiful self? How lovely! I thought I would be a frog forever.',26124),
(23426,'enUS','','It was just terrible. I was all slimy, and I kept licking my eyes!',26124),
(23427,'enUS','','Thank goodness you came along when you did. Please, take one of these troll boxes to remember me by.',26124),
(23428,'enUS','','I never want to see this nasty pond again. Thank you, $n. I\'ll never forget you!',26124),
(23429,'enUS','I must have taken leave of my senses, allowing a Scryer to aid in such a delicate operation...','',26124),
(23430,'enUS','My services were rendered. The protection of the city is not my jurisdiction. I believe that\'s why they call you \"peacekeepers?\"','',26124),
(23431,'enUS','Had we been fully handling the investigation, I assure you, the evidence would have remained safe. Instead, we used your highly questionable methods...','',26124),
(23432,'enUS','Of course. My methods are questionable. It was my methodology, I\'ll note, that exposed that \"Griftah\" as a fraud in the first place! You had only to keep the peace, and you failed in that simple task!','',26124),
(23433,'enUS','Incompetent, sniveling dandy.','',26124),
(23434,'enUS','Pompous, uptight windbag.','',26124),
(23435,'enUS','%s and Investigator Asric glare at each other silently, their eyes narrowed.','',26124),
(23436,'enUS','','Hey there, good looking!  What can I do to help you out?',26124),
(23437,'enUS','So you want to know what I\'m looking for?  I like that... I\'m looking for someone strong and courageous.  Brains are one thing, but you\'ve gotta be able to back it up with some muscle.$b$bWhenever those pesky Dark Iron dwarves attack, you can attack them by throwing a mug at them.  Just down it and throw.  Simple.$b$bFor every dwarf you down, you\'ll be marked.  Talk to me and I\'ll give you a prize ticket for every mark you have.','So you want to know what I\'m looking for?  I like that... I\'m looking for someone strong and courageous.  Brains are one thing, but you\'ve gotta be able to back it up with some muscle.$b$bWhenever those pesky Dark Iron dwarves attack, you can attack them by throwing a mug at them.  Just down it and throw.  Simple.$b$bFor every dwarf you down, you\'ll be marked.  Talk to me and I\'ll give you a prize ticket for every mark you have.',26124),
(23438,'enUS','Ain\'t she a beauty? Want to take her for a spin?','',26124),
(23439,'enUS','I hear you\'re looking for Keg Protector marks.  What are those?','I hear you\'re looking for Keg Protector marks.  What are those?',26124),
(23440,'enUS','What\'s with your crazy goggles?','What\'s with your crazy goggles?',26124),
(23441,'enUS','Keep your voice down, $c. We wouldn\'t want them to hear us.','',26124),
(23442,'enUS','I have another question.','I have another question.',26124),
(23443,'enUS','Hey there!  Are you interested in learning some more about racing rams and ram racing?','Hey there!  Are you interested in learning some more about racing rams and ram racing?',26124),
(23444,'enUS','Do I get a free mount?','Do I get a free mount?',26124),
(23445,'enUS','How do I make my ram go faster?','How do I make my ram go faster?',26124),
(23446,'enUS','What\'s with the different speeds?','What\'s with the different speeds?',26124),
(23447,'enUS','Can I tire my ram out?','Can I tire my ram out?',26124),
(23448,'enUS','That all sounds very complicated...','That all sounds very complicated...',26124),
(23449,'enUS','When you take one of these tasks, we\'ll lend you a ram. It\'s a loan, so it won\'t last forever. The ram may seem slow, but just ease up on the reins a bit and he\'ll pick up the pace.$b$bOur rams love apples. We\'ve put a few bushels of apples out along the way, so make sure to stop by. Eating apples will make your ram forget about how tired he\'s been getting.','When you take one of these tasks, we\'ll lend you a ram. It\'s a loan, so it won\'t last forever. The ram may seem slow, but just ease up on the reins a bit and he\'ll pick up the pace.$b$bOur rams love apples. We\'ve put a few bushels of apples out along the way, so make sure to stop by. Eating apples will make your ram forget about how tired he\'s been getting.',26124),
(23450,'enUS','When you get a ram, you also get the reins. These aren\'t your grandma\'s reins though, you\'ve gotta use them!$b$bJust loosen up on the reins a few times to build up some speed.  Keep on loosening up and GIDDYUP!  You\'ll be flying!$b$bBut the faster he goes the quicker he\'ll get tired. So you have to be careful.\n','When you get a ram, you also get the reins. These aren\'t your grandma\'s reins though, you\'ve gotta use them!$b$bJust loosen up on the reins a few times to build up some speed.  Keep on loosening up and GIDDYUP!  You\'ll be flying!$b$bBut the faster he goes the quicker he\'ll get tired. So you have to be careful.\n',26124),
(23451,'enUS','Once you start loosening the reins on the ram, you\'ll see his speed change. He starts off walking. Ease up on the reins a bit more and he\'ll start to trot. Give him more slack on the reins while he\'s trotting and he\'ll go into a canter. Give him even more slack while he\'s in a canter and you will send him into a gallop.\n\n','Once you start loosening the reins on the ram, you\'ll see his speed change. He starts off walking. Ease up on the reins a bit more and he\'ll start to trot. Give him more slack on the reins while he\'s trotting and he\'ll go into a canter. Give him even more slack while he\'s in a canter and you will send him into a gallop.',26124),
(23452,'enUS','Keeping your ram in a canter or gallop for too long will exhaust him. If you want your ram to recover a bit, let him walk or trot. If there are apple bushels around, take him there to recover.\n\n','Keeping your ram in a canter or gallop for too long will exhaust him. If you want your ram to recover a bit, let him walk or trot. If there are apple bushels around, take him there to recover.',26124),
(23453,'enUS','Ram racing is easier than it seems, but it takes skill to master. Just use the reins, eat apples if you can and avoid exhausting your ram.\n\n','Ram racing is easier than it seems, but it takes skill to master. Just use the reins, eat apples if you can and avoid exhausting your ram.',26124),
(23454,'enUS','Hmm, that\'s strange, $c. I would have thought you\'d have found something connected with those scourging crystals.$B$BWe really should find a way to bring down their shields and destroy them. You think you could go back out there and kill some more Scourge until you find something?','',26124),
(23455,'enUS','This end have I reached before.  What new adventure lies in store?','',26124),
(23456,'enUS','','Yes? What is it?$B$BTime waits for no one!',26124),
(23457,'enUS','I\'ve been saving this just for you, big boy!','',26124),
(23458,'enUS','','Odd, I would have thought you\'d have found something useful on those Scourge that might help us deal with the scourging crystals.$B$BIf I may strongly suggest, and I do, $c, go back down to the beach and continue to slaughter them until you do find something of use to me.',26124),
(23459,'enUS','Things are going as planned, Lord Falconcrest. I assure you, it is only a matter of time.','Things are going as planned, Lord Falconcrest. I assure you, it is only a matter of time.',26124),
(23460,'enUS','I presume you come with good news?','I presume you come with good news?',26124),
(23461,'enUS','Is there a way to purchase one?','Is there a way to purchase one?',26124),
(23462,'enUS','If you earn enough Brewfest prize tickets, the ticket redeemer in the Brewfest camp can give you an \"Honorary Brewer\" hand stamp.$b$bThat stamp will allow me to sell you a Brewfest riding ram. But they don\'t come cheap, mind you!','If you earn enough Brewfest prize tickets, the ticket redeemer in the Brewfest camp can give you an \"Honorary Brewer\" hand stamp.$b$bThat stamp will allow me to sell you a Brewfest riding ram. But they don\'t come cheap, mind you!',26124),
(23463,'enUS','I\'d like to purchase a Brewfest riding ram.','I\'d like to purchase a Brewfest riding ram.',26124),
(23464,'enUS','Check out the 3-B entertainment! Brewfest\'s Barleybrew Brewmasters!','Check out the 3-B entertainment! Brewfest\'s Barleybrew Brewmasters!',26124),
(23465,'enUS','Barleybrew brew!  Won\'t fill you up, won\'t kill you...  The Thunderbrews can\'t say the same.','Barleybrew brew!  Won\'t fill you up, won\'t kill you...  The Thunderbrews can\'t say the same.',26124),
(23466,'enUS','Barleybrew will treat you right!  Check out the Barleybrews at Brewfest!','Barleybrew will treat you right!  Check out the Barleybrews at Brewfest!',26124),
(23467,'enUS','Brewfest has called down the thunder!  Thunderbrew, that is!','Brewfest has called down the thunder!  Thunderbrew, that is!',26124),
(23468,'enUS','Sometimes you want to party hard, Thunderbrew\'s got ya covered!  Check them out at Brewfest!','Sometimes you want to party hard, Thunderbrew\'s got ya covered!  Check them out at Brewfest!',26124),
(23469,'enUS','Can you feel the magic?  Thunderbrew brewmasters are on the loose!  Check them out at Brewfest!','Can you feel the magic?  Thunderbrew brewmasters are on the loose!  Check them out at Brewfest!',26124),
(23470,'enUS','Your life ends now invader!','Your life ends now invader!',26124),
(23471,'enUS','I\'ll send your soul to the afterlife little one!','I\'ll send your soul to the afterlife little one!',26124),
(23472,'enUS','We shall see if you are a worthy opponent!','We shall see if you are a worthy opponent!',26124),
(23473,'enUS','I will take great pleasure in slaughtering you, $c!','I will take great pleasure in slaughtering you, $c!',26124),
(23474,'enUS','Your spirit shall find no rest in these lands!','Your spirit shall find no rest in these lands!',26124),
(23475,'enUS','The cold darkness awaits your soul!','The cold darkness awaits your soul!',26124),
(23476,'enUS','I shall end your life and bind you to his service!','I shall end your life and bind you to his service!',26124),
(23477,'enUS','I thought you\'d never ask!','',26124),
(23478,'enUS','Now that\'s what I call froggy-style!','',26124),
(23479,'enUS','This won\'t take long, did it?','',26124),
(23480,'enUS','I promise not to give you warts...','',26124),
(23481,'enUS','There\'s just never enough Mojo to go around...','',26124),
(23482,'enUS','Listen, $n, I know of a little swamp not too far from here....','',26124),
(23483,'enUS','Your lily pad or mine?','',26124),
(23484,'enUS','Feelin\' a little froggy, are ya?','',26124),
(23485,'enUS','Mojo leaps into $n\'s pocket!','',26124),
(23486,'enUS','I can\'t show you anything else, kid. Go find Lebowski in Honor Hold - that\'s in Hellfire Peninsula. He can teach you more than I can!','',26124),
(23487,'enUS','I can\'t show you anything else, kid. Go find Zebig in Thrallmar - that\'s in Hellfire Peninsula. He can teach you more than I can!','',26124),
(23488,'enUS','We built this place with our bare hands! Blood and tears, my friend.$B$BBelieve me when I tell you this: We have no plans on ever giving up our hold on Valgarde.','',26124),
(23489,'enUS','RETREAT!!  We\'ve taken a beating and had $3151W casualties!  We can\'t keep taking these losses!  FALL BACK!!','',26124),
(23490,'enUS','We did it boys!  Now back to the Grim Guzzler and we\'ll drink to the $3151W that were injuredl!','',26124),
(23491,'enUS','Hey friend, what I\'ve got here is a breakthrough, the likes of which have never been seen!  And it\'s for sale, for cheap!$b$bYou see, I got tired of spending money in taverns looking for the perfect person.  So I made these goggles and now EVERYONE looks like pure perfection.  I mean you CAN\'T go wrong with these puppies!$b$bSo, you wanna try these out, help pad my pockets a bit?  Since you look soo good, I\'ll even give you a discount!','Hey friend, what I\'ve got here is a breakthrough, the likes of which have never been seen!  And it\'s for sale, for cheap!$b$bYou see, I got tired of spending money in taverns looking for the perfect person.  So I made these goggles and now EVERYONE looks like pure perfection.  I mean you CAN\'T go wrong with these puppies!$b$bSo, you wanna try these out, help pad my pockets a bit?  Since you look soo good, I\'ll even give you a discount!',26124),
(23492,'enUS','I\'m looking for all sorts of things honey!  But those marks you are talking about, the Keg Protector marks?  Those show me that you know how to handle yourself in a fight.$b$bEvery time you take down a Dark Iron dwarf, you get a mark.  For every mark you have, I\'ll give you a prize ticket.$b$bIt pains me to give these tickets away, but it also means I get to see you again, and see you leave again...','I\'m looking for all sorts of things honey!  But those marks you are talking about, the Keg Protector marks?  Those show me that you know how to handle yourself in a fight.$b$bEvery time you take down a Dark Iron dwarf, you get a mark.  For every mark you have, I\'ll give you a prize ticket.$b$bIt pains me to give these tickets away, but it also means I get to see you again, and see you leave again...',26124),
(23493,'enUS','I saw you across the way and was hoping you were going to stop by.  So what can I do for you sweetie?','',26124),
(23494,'enUS','I\'ve got Keg Protector marks to redeem...','I\'ve got Keg Protector marks to redeem...',26124),
(23495,'enUS','I hear you\'re looking for Keg Protector marks.  What are those?','I hear you\'re looking for Keg Protector marks.  What are those?',26124),
(23496,'enUS','What\'s with your crazy goggles?','What\'s with your crazy goggles?',26124),
(23497,'enUS','Hey, hey sweet thing!  Looking good!','',26124),
(23498,'enUS','Hey! Sweet cheeks, over here!','',26124),
(23499,'enUS','Yo! Big lady! You think you\'re big enough to handle me?','',26124),
(23500,'enUS','Hey tough stuff! Hey, $c! Do you like money?  I\'m loaded!  How about you come over here and check out my gold coins?','',26124),
(23501,'enUS','Hey, hey!  Nice build you got there honey!','',26124),
(23502,'enUS','Whoah!  Walk by again girl!','',26124),
(23503,'enUS','Didn\'t the foreman say he was going to bring some guards? Where are they?','Didn\'t the foreman say he was going to bring some guards? Where are they?',26124),
(23504,'enUS','If we don\'t expand the mine, there\'s no way we\'ll get all the ore we need. Captain Adams\'ll have our hides!','If we don\'t expand the mine, there\'s no way we\'ll get all the ore we need. Captain Adams\'ll have our hides!',26124),
(23505,'enUS','You\'re going to face Shatterhorn? You\'re brave, I\'ll give you that.','You\'re going to face Shatterhorn? You\'re brave, I\'ll give you that.',26124),
(23506,'enUS','Give \'im hell for us!','Give \'im hell for us!',26124),
(23507,'enUS','You know, we\'re not busy right now. We could start building a coffin for you...','You know, we\'re not busy right now. We could start building a coffin for you...',26124),
(23508,'enUS','Normal dogs won\'t come anywhere near me nowadays.  I was devastated when I found out... I used to love the beasts.$B$BPlaguehounds make for a fine substitute, however.  They\'re not quite as... easy on the eyes.  But then again, neither am I!','',26124),
(23509,'enUS','This isn\'t going to end well.','This isn\'t going to end well.',26124),
(23510,'enUS','Hmm....','Hmm....',26124),
(23511,'enUS','You won\'t find a better brew in Azeroth.','',26124),
(23512,'enUS','Hey mon, you ready to try da best brew in all da realms?','',26124),
(23513,'enUS','Hey you, the tall one...  Want to put some hair on your chest?  Drohn\'s Distillery can help you out!','Hey you, the tall one...  Want to put some hair on your chest?  Drohn\'s Distillery can help you out!',26124),
(23514,'enUS','Drohn\'s brew is the stuff legends are made of!  Come taste the legend!','Drohn\'s brew is the stuff legends are made of!  Come taste the legend!',26124),
(23515,'enUS','Drohn\'s Distillery has the best brew money can buy!  They were voted \"Outstanding Brew\" by Monthly Goblin Brew!','Drohn\'s Distillery has the best brew money can buy!  They were voted \"Outstanding Brew\" by Monthly Goblin Brew!',26124),
(23516,'enUS','We drink for the Horde!  Do you drink for the Horde?  Come show us at Drohn\'s Distillery!','We drink for the Horde!  Do you drink for the Horde?  Come show us at Drohn\'s Distillery!',26124),
(23517,'enUS','Hey you!  T\'chali\'s Voodoo Brewers have got a brew that won\'t kill you!  But they\'ve also got a brew that might...','Hey you!  T\'chali\'s Voodoo Brewers have got a brew that won\'t kill you!  But they\'ve also got a brew that might...',26124),
(23518,'enUS','If you wanna live life to the fullest, you gotta try T\'chali\'s Voodoo Brew!','If you wanna live life to the fullest, you gotta try T\'chali\'s Voodoo Brew!',26124),
(23519,'enUS','T\'chali\'s Voodoo Brewery has the best brew you can find!  They were voted \"Best Brew\" by the Goblin Brew Weekly!','T\'chali\'s Voodoo Brewery has the best brew you can find!  They were voted \"Best Brew\" by the Goblin Brew Weekly!',26124),
(23520,'enUS','Drohn\'s Distillery knows how to party hard!  Check them out at Brewfest!','Drohn\'s Distillery knows how to party hard!  Check them out at Brewfest!',26124),
(23521,'enUS','Celebrate Brewfest with orcs that know what a good drink really is!  Check out Drohn\'s Distillery at Brewfest!','Celebrate Brewfest with orcs that know what a good drink really is!  Check out Drohn\'s Distillery at Brewfest!',26124),
(23522,'enUS','If you think an orc can hit hard, check out their brew, it hits even harder!  See for yourself at Drohn\'s Distillery, only at Brewfest!','If you think an orc can hit hard, check out their brew, it hits even harder!  See for yourself at Drohn\'s Distillery, only at Brewfest!',26124),
(23523,'enUS','Join with your brothers and sisters at Drohn\'s Distillery and drink for the horde!','Join with your brothers and sisters at Drohn\'s Distillery and drink for the horde!',26124),
(23524,'enUS','Would you really drink brew from an orc or an ogre?  For a better choice check out T\'chali\'s Voodoo Brewery at Brewfest!','Would you really drink brew from an orc or an ogre?  For a better choice check out T\'chali\'s Voodoo Brewery at Brewfest!',26124),
(23525,'enUS','If you could use some exotic brew, T\'chali\'s Voodoo Brewery at Brewfest has got you covered!','If you could use some exotic brew, T\'chali\'s Voodoo Brewery at Brewfest has got you covered!',26124),
(23526,'enUS','Need to relax?  Visit T\'chali\'s Voodoo Brewery at Brewfest for drinks that go down smooth!','Need to relax?  Visit T\'chali\'s Voodoo Brewery at Brewfest for drinks that go down smooth!',26124),
(23527,'enUS','T\'chali\'s Voodoo Brews helps keep the party going!  Check out the party at Brewfest!','T\'chali\'s Voodoo Brews helps keep the party going!  Check out the party at Brewfest!',26124),
(23528,'enUS','Where ma hatcha? Get to work on dem eggs!','',26124),
(23529,'enUS','','Here we practice fire fighting techniques.  Power to the Forsaken!',26124),
(23530,'enUS','I have fallen! Fear not, brethren! Let nothing keep you from the Stoneforge!','',26124),
(23531,'enUS','','It hurts! Owww Ow Ow Owwwww!',26124),
(23532,'enUS','Clayton is AWESOME!!','Clayton is AWESOME!',26124),
(23533,'enUS','Clayton is NOT AWESOME!','Clayton is NOT AWESOME!',26124),
(23534,'enUS','%s cries out and writhes in agony before passing out.','',26124),
(23535,'enUS','I enjoy the screams most of all.','',26124),
(23536,'enUS','These outsiders are weak and easily crushed.','',26124),
(23537,'enUS','We shall see how much punishment these invaders can stand.','',26124),
(23538,'enUS','Good!  Good! You are still alive.  More fun for me!','',26124),
(23539,'enUS','They are hardier than I would expect for their size.','',26124),
(23540,'enUS','$n\'s concoction is ruined.  A new one must be created from scratch.','',26124),
(23541,'enUS','Give up your will to live! I can do this all day and night.','',26124),
(23542,'enUS','<Ulfang howls and sniffs at you, and you can understand what he says.>$B$BThe strange white worg of the north, Garwal, has taken my pack from me. We must rip out his throat so that I will be the alpha worg once again.','',26124),
(23543,'enUS','%s coos to the hatchlings.','',26124),
(23544,'enUS','That crash between here and Razor Hill really messed up the brew flow!  It doesn\'t help that Dark Iron dwarves seem to be attacking every hour or so!$b$bSo if you want to help, here\'s the deal.  I\'ll let you borrow some reins and one of my rams.$b$bEvery time you bring me a keg, I\'ll give you some tokens.  I\'ll even let you use the ram for a bit longer for every keg you bring me!$b$bBUT, once you start this, you won\'t be able to do it again until tomorrow.$b$bAre you sure you\'re ready to do this?','That crash between here and Razor Hill really messed up the brew flow!  It doesn\'t help that Dark Iron dwarves seem to be attacking every hour or so!$b$bSo if you want to help, here\'s the deal.  I\'ll let you borrow some reins and one of my rams.$b$bEvery time you bring me a keg, I\'ll give you some tokens.  I\'ll even let you use the ram for a bit longer for every keg you bring me!$b$bBUT, once you start this, you won\'t be able to do it again until tomorrow.$b$bAre you sure you\'re ready to do this?',26124),
(23545,'enUS','I\'m ready to work for you today!  Give me that ram!','I\'m ready to work for you today!  Give me that ram!',26124),
(23546,'enUS','Do you still need some help moving kegs from the crash site near Razor Hill?','Do you still need some help moving kegs from the crash site near Razor Hill?',26124),
(23547,'enUS','I see you checking out our legally obtained racing rams...  I can see you want in on the ram racing sensation...  But before you can play, you gotta work.$b$bWell, work and play are pretty much the same when it comes to these rams.','',26124),
(23548,'enUS','Y\'hear that, Jethan? You\'re not getting that Steelfeather trophy now that we know she\'s a mother.','',26124),
(23549,'enUS','Why not? Just think how much better it\'ll look with the hatchlings to either side --','',26124),
(23550,'enUS','Jethan!','',26124),
(23551,'enUS','What? I\'m just sayin\' that\'s how we do things in Grizzly Hills.','',26124),
(23552,'enUS','They keep their tools in boxes that look like this. Look for them near the pavilions.','',26124),
(23553,'enUS','I saw soldiers from Ironforge fighting a fire before.  They were heroes!','I saw soldiers from Ironforge fighting a fire before.  They were heroes!',26124),
(23554,'enUS','$n, don\'t just stand there! Kharanos is burning! Go help! Ach, all that brew...','$n, don\'t just stand there! Kharanos is burning! Go help! Ach, all that brew...',26124),
(23555,'enUS','If you\'re looking to practice fire fighting, this is the place. There may be a heap of snow hereabouts, but you never know when Steelgrill or those gnomes\'ll cause an explosion, eh?','If you\'re looking to practice fire fighting, this is the place. There may be a heap of snow hereabouts, but you never know when Steelgrill or those gnomes\'ll cause an explosion, eh?',26124),
(23556,'enUS','$n, the village of Azure Watch is burning!  Go help fight the fire!','$n, the village of Azure Watch is burning!  Go help fight the fire!',26124),
(23557,'enUS','We set up this area to practice fire fighting.  You never know when the town will be imperiled!','We set up this area to practice fire fighting.  You never know when the town will be imperiled!',26124),
(23558,'enUS','Ahoy, mon!  What be happenin\', ye salty \'at steppa!$B$BDis place be all chacka-chacka, ye scallywag!','',26124),
(23559,'enUS','Lookin\' mighty cris, me bucko!  Ye pillage a fat sutler?  Best ye spread da wealth... don\'t be a craven choke puppy, mon!','',26124),
(23560,'enUS','Ku ovah yonder, matey!  Dat scurvy bobo be all up inne quashie\'s face.  Dat hard-eared swab gonnna get salt, mon... gonna get keelhauled and gonna be made into a duppy, mon.','',26124),
(23561,'enUS','How much\'ll it cost me to get my mules shod?','',26124),
(23562,'enUS','We don\'t shoe no mules here. \'Sides, it\'s strictly expedition business right now.','',26124),
(23563,'enUS','You don\'t understand! If I\'m not ready to go soon, all the good homesteading land will be taken!','',26124),
(23564,'enUS','Not my problem! If yer so antsy to get yerself a house built, do it \'ere in the fort and quit yer whinin\'!','',26124),
(23565,'enUS','Issa truut, matey!  Neh tougher salts anyweh but da northsea freebootahs yahso, mon!$B$BBest not brindle s\'mady, mon.  Scuppah dat!  \'Alf eediat swabs get feh kiss da gunnah\'s dawta, mate!','',26124),
(23566,'enUS','Now, if you\'d be so kind as to get your ass away from my forge...','',26124),
(23567,'enUS','That, sir, is a mule!','',26124),
(23568,'enUS','Um... what was that?','Um... what was that?',26124),
(23569,'enUS','Now ye just be fass and facety, mon!  Ye fixin\' fe vex me, ye maga dog blaggard?$B$BG\'waan den, ye lily-livered scallywag.  Be seen ya first light!','',26124),
(23570,'enUS','Welcome to Fort Wildervar, brave homesteaders! There\'s a whole continent out there just waiting to be claimed!','',26124),
(23571,'enUS','True, Northrend is a hard land, but our people are strong, hardy, and equal to the task!','',26124),
(23572,'enUS','We will win this land with the sword, and break it with the plow! You are the men and women who will be remembered for taming the wild continent!','',26124),
(23573,'enUS','But, you will not be alone out there. My men and I have prepared pack mules carrying the supplies you\'ll need most.','',26124),
(23574,'enUS','Axes, picks, seed, nails, food, blankets, water... it\'s all there, waiting for you. I think you\'ll find my prices quite reasonable, too.','',26124),
(23575,'enUS','There are more than enough to go around. Should you need other goods, don\'t hesitate to ask!','',26124),
(23576,'enUS','Now, my loyal custo... err, friends, go forth and conquer this land for our people!','',26124),
(23577,'enUS','So you\'re the new hot shot in town, eh?$B$B<Zorek spits on the ground.>$B$BYea...','',26124),
(23578,'enUS','I don\'t know much about art... but I know what I like!','',26124),
(23579,'enUS','Yah, me bredren!  Galang now and pass us a grog, just dead men yahso.','',26124),
(23580,'enUS','Watch nah, ye bogfiddler!  I an\' I gunna show ye \'ow a jig meant fe be jigged to!','',26124),
(23581,'enUS','Dis a rankin\' set, mon, no scurvy dog gonna kass-kass me buckos an\' walk aweh! ','',26124),
(23582,'enUS','<Old Icefin draws in the sand. From the crude pictures he traces you can make out that he wants your help.>','',26124),
(23583,'enUS','Here we practice fire fighting techniques.','Here we practice fire fighting techniques.',26124),
(23584,'enUS','Quickly, $c!  Blazes rage through Falconwing Square!  Go! Fight those fires!','Quickly, $c!  Blazes rage through Falconwing Square!  Go! Fight those fires!',26124),
(23585,'enUS','It all be over now, mon!','',26124),
(23586,'enUS','Tazaga-choo!','',26124),
(23587,'enUS','Zul\'jin... got a surprise for you....','',26124),
(23588,'enUS','You done run outta time!','',26124),
(23589,'enUS','I burn ya now!','',26124),
(23590,'enUS','Spirits of da wind be your doom!','',26124),
(23591,'enUS','Da shadow gonna fall on you....','',26124),
(23592,'enUS','Ya don\' kill me yet... ya don\' get anudda chance!','',26124),
(23593,'enUS','Dis a nightmare ya don\' wake up from!','',26124),
(23594,'enUS','Azzaga choogo zinn!','',26124),
(23595,'enUS','Your will belong ta me now!','',26124),
(23596,'enUS','Darkness comin\' for you....','',26124),
(23597,'enUS','Your soul gonna bleed!','',26124),
(23598,'enUS','It not gonna make no difference.','',26124),
(23599,'enUS','You gonna die worse dan him.','',26124),
(23600,'enUS','Dat no bodda me.','',26124),
(23601,'enUS','Dis not... da end for me!','',26124),
(23602,'enUS','Have ya gone mad? Ya be da death of us all!','',26124),
(23603,'enUS','An electrical storm appears!','',26124),
(23604,'enUS','%s shimmers and begins to fade away...','',26124),
(23605,'enUS','','Remember, honey, we need to get a plot of land with a nice hot spring.',26124),
(23606,'enUS','Of course, darling.','',26124),
(23607,'enUS','','And I don\'t want our land to have any of those horrible wolves, or giants, or ugly rams!',26124),
(23608,'enUS','Yes, darling. You realize you\'ll be eating dire ram mutton for dinner until the crops are planted...','',26124),
(23609,'enUS','','I\'d sooner butcher that mule of yours! Why did you bring that beast in here, anyway?',26124),
(23610,'enUS','I\'d rather listen to his braying than yours, dear.','',26124),
(23611,'enUS','Chaga... choka\'jinn.','',26124),
(23612,'enUS','Get on ya knees and bow.... to da fang and claw!','',26124),
(23613,'enUS','You can\'t fight da power!','',26124),
(23614,'enUS','Ya all gonna fail!','',26124),
(23615,'enUS','Me gonna carve ya now!','',26124),
(23616,'enUS','You gonna leave in pieces!','',26124),
(23617,'enUS','You dare challenge Winterskorn?! I will impale you on your own puny flag!','',26124),
(23618,'enUS','The sacrifices now bring themselves to us? Have you no sense!?','',26124),
(23619,'enUS','Your remains will be fed to the sharks of Daggercap!','',26124),
(23620,'enUS','Down the free brew and pelt the Guzzlers with your mug!','Down the free brew and pelt the Guzzlers with your mug!',26124),
(23621,'enUS','Chug and chuck!  Chug and chuck!','Chug and chuck!  Chug and chuck!',26124),
(23622,'enUS','<Old Icefin eyes you warily, his fishy eye blinking as he bobs his head up and down once in a curt dismissal.>','',26124),
(23623,'enUS','The longhouse is destroyed! Alarms can be heard in the distance.','',26124),
(23624,'enUS','Defend yourself, soldier! Blow \'em out of the sky with the fiery lance! Give \'em a taste of their own medicine!','',26124),
(23625,'enUS','Direct hit on the dockhouse! Dragonflayer defenders have been alerted!','',26124),
(23626,'enUS','Don\'t give \'em an inch, soldier! Harpoon \'em out of the sky!','',26124),
(23627,'enUS','Here\'s to the Horde!','Here\'s to the Horde!',26124),
(23628,'enUS','To Brewfest!','To Brewfest!',26124),
(23629,'enUS','Here\'s to the Alliance!','Here\'s to the Alliance!',26124),
(23630,'enUS','To Brewfest!','To Brewfest!',26124),
(23631,'enUS','Here\'s to gold in our pockets!','Here\'s to gold in our pockets!',26124),
(23632,'enUS','To Brewfest!','To Brewfest!',26124),
(23633,'enUS','No other holiday matches the feasting and drinking of Brewfest!','No other holiday matches the feasting and drinking of Brewfest!',26124),
(23634,'enUS','$n, I would have words with you.','',26124),
(23635,'enUS','$R, a moment of your time?','',26124),
(23636,'enUS','A word to the wise, stranger, go back to wherever you\'re from.$b$bThis is no place for lighthearted adventurers. It\'ll chew up the likes of you and spit out your bones.','',26124),
(23637,'enUS','The Vrykul storage facility is up in flames! Dragonflayer defenders have been alerted!','',26124),
(23638,'enUS','Knock \'em out of the sky! Don\'t let them get in range of you, soldier!','',26124),
(23639,'enUS','The longhouse is destroyed! Alarms can be heard in the distance.','',26124),
(23640,'enUS','Direct hit on the dockhouse! Dragonflayer defenders have been alerted!','',26124),
(23641,'enUS','The Vrykul storage facility is up in flames! Dragonflayer defenders have been alerted!','',26124),
(23642,'enUS','Defend yourself, soldier! Blow \'em out of the sky with the fiery lance! Give \'em a taste of their own medicine!','',26124),
(23643,'enUS','Don\'t give \'em an inch, soldier! Harpoon \'em out of the sky!','',26124),
(23644,'enUS','Knock \'em out of the sky! Don\'t let them get in range of you, soldier!','',26124),
(23645,'enUS','Retrieving','Retrieving',26124),
(23646,'enUS','Phase 2 <PH>','',26124),
(23647,'enUS','Kael Weakened <PH>','',26124),
(23648,'enUS','Wow, that sucked. Oh well lets try again. <PH>','',26124),
(23649,'enUS','I think I saw a key on one of those Gjalerbron vrykul up top.','I think I saw a key on one of those Gjalerbron vrykul up top.',26124),
(23650,'enUS','This large jack-o\'-lantern rests in the middle of the village.','',26124),
(23651,'enUS','Smash the pumpkin!','Smash the pumpkin!',26124),
(23652,'enUS','The pumpkin has been smashed, and offers no more treasure.','',26124),
(23653,'enUS','Smashing the pumpkin reveals a hidden treasure!  This is the greatest day you\'ve ever known!','',26124),
(23654,'enUS','Say, you wouldn\'t happen to have an extra set of reins...','Say, you wouldn\'t happen to have an extra set of reins...',26124),
(23655,'enUS','','',26124),
(23656,'enUS','Whatcha lookin\' at, ye bilge rat?  Har, har.... just kiddin\' with ye, mate!','Whatcha lookin\' at, ye bilge rat?  Har, har.... just kiddin\' with ye, mate!',26124),
(23657,'enUS','Nothin\' finer than enjoying a fine beverage and the company of some fine buckos... hic!','Nothin\' finer than enjoying a fine beverage and the company of some fine buckos... hic!',26124),
(23658,'enUS','\"Yaaaaaaaaaarrr... it\'s driving me insane!\"  Wait... that\'s not quite how it goes...','\"Yaaaaaaaaaarrr... it\'s driving me insane!\"  Wait... that\'s not quite how it goes...',26124),
(23659,'enUS','Grab a seat and \'ave a drink, mate!  Grab me one while yer at it!','Grab a seat and \'ave a drink, mate!  Grab me one while yer at it!',26124),
(23660,'enUS','...that scurvy dog had two peg legs, a hook for a left hand, two glass eyes and a wooden nose!','...that scurvy dog had two peg legs, a hook for a left hand, two glass eyes and a wooden nose!',26124),
(23661,'enUS','Excellent, another sacrificial lamb.','',26124),
(23662,'enUS','So eager to die are we?','',26124),
(23663,'enUS','You too will serve the Lich King.','',26124),
(23664,'enUS','More ingredients to fuel our rituals here.','',26124),
(23665,'enUS','...so he says \"Of course I\'m not seeing double!  I\'ve only got one eye!\"','...so he says \"Of course I\'m not seeing double!  I\'ve only got one eye!\"',26124),
(23666,'enUS','Hello, little one. Come to play?','',26124),
(23667,'enUS','Your life for the Lich King!','',26124),
(23668,'enUS','I have so many wonders to show you.','',26124),
(23669,'enUS','There\'s always room for one more.','',26124),
(23670,'enUS','Kiss the gunner\'s daughter?  Why I haven\'t ever met the lass...','Kiss the gunner\'s daughter?  Why I haven\'t ever met the lass...',26124),
(23671,'enUS','I \'eard Terry fenced one of \'em pictures for a thousand gold.  Maybe I can get in some of that artwork dealin\' too!','I \'eard Terry fenced one of \'em pictures for a thousand gold.  Maybe I can get in some of that artwork dealin\' too!',26124),
(23672,'enUS','Yohoho!','Yohoho!',26124),
(23673,'enUS','Is this yer friend, Grezzix?  $g He : She; doesn\'t look very... piratey.','Is this yer friend, Grezzix?  $g He : She; doesn\'t look very... piratey.',26124),
(23674,'enUS','I\'m sure they\'re quite wonderful.  If you don\'t mind I have some drinking to get back to.  You coming, $n?','I\'m sure they\'re quite wonderful.  If you don\'t mind I have some drinking to get back to.  You coming, $n?',26124),
(23675,'enUS','Ahahahahahaha!','',26124),
(23676,'enUS','Fly away little soul.','',26124),
(23677,'enUS','For the Lich King!','',26124),
(23678,'enUS','Plucked ripe off the vine.','',26124),
(23679,'enUS','How disappointing; no resistance.','',26124),
(23680,'enUS','Your sacrifice will fuel our efforts.','',26124),
(23681,'enUS','Scalawag Point is just ahead.  I\'m just gonna lie down for a spell, if ye don\'t mind.  Me head is killin\' me.','Scalawag Point is just ahead.  I\'m just gonna lie down for a spell, if ye don\'t mind.  Me head is killin\' me.',26124),
(23682,'enUS','No more chatter for you.','',26124),
(23683,'enUS','So eager to be rescued, but no one came now did they?','',26124),
(23684,'enUS','Ahoy, umm.... \"matey!\"  This is the $g fellow : gal; I was telling you about, \"me bucko!\"  $g He : She;\'s a real \"terror of the seas!\"','',26124),
(23685,'enUS','Yarp? Yar wannar fly? Narp... No-no-no-norp gonnarp ha-hap-hap-happen!','',26124),
(23686,'enUS','Official Explorers\' League business, McGoyver. Take me to the Explorers\' League Outpost!','Official Explorers\' League business, McGoyver. Take me to the Explorers\' League Outpost!',26124),
(23687,'enUS','Quick, $n!  Put on your disguise!','',26124),
(23688,'enUS','Um...','',26124),
(23689,'enUS','Yarrrr!','',26124),
(23690,'enUS','Curse that frog!  Yes, I joined the Southsea crew - you want to make something of it, mate?  I\'ll cut you down here and now!','',26124),
(23691,'enUS','Ho there, and welcome to Brewfest!','',26124),
(23692,'enUS','Hello, friend! Welcome to the Brewfest Grounds!','',26124),
(23693,'enUS','Hail, good $c! Welcome to Ironforge\'s annual Brewfest celebration!','',26124),
(23694,'enUS','Foolish child, you will not stop what I have set in motion! Now, meet your doom!','',26124),
(23696,'enUS','Did you really think that by facing me, you have any hope of saving your friends?','',26124),
(23697,'enUS','Who or what would do something like this, man?!','',26124),
(23698,'enUS','Hey there, and welcome to Brewfest. Come in and have a drink or three!','',26124),
(23699,'enUS','It\'s BLOWIN\' my mind!','',26124),
(23700,'enUS','What\'s up, friend? Welcome to the Brewfest Grounds! Now go buy some drinks!','',26124),
(23701,'enUS','Hey hey, it\'s another $c! Welcome to my annual Brewfest celebration... now go feast and drink some!','',26124),
(23702,'enUS','You don\'t just come and do this to a dwarf\'s rug! You just don\'t do things like that!','',26124),
(23703,'enUS','','%s shakes her head.',26124),
(23704,'enUS','','Damn shame what they did to that rug.',26124),
(23705,'enUS','Yarrrrrrr!  Ye\'ll never get me spyglass, bilgesucker!','',26124),
(23706,'enUS','Hozzer, old boy!  Here comes daddy!','',26124),
(23707,'enUS','Who do ya think dun it, Needlemeyer?','',26124),
(23708,'enUS','I dun think nothin\', Wad! I know who\'d do such a heinous thing!','',26124),
(23709,'enUS','','Come on, Goodie, lets go scout the area.',26124),
(23710,'enUS','Twas those iron cousins of ours! For certain!','',26124),
(23711,'enUS','That\'s highly unlikely, brother.','',26124),
(23712,'enUS','','William, I saw a fresh growth of herbs out on the ridge. Go ask Becanna to pick them up.',26124),
(23713,'enUS','Unlikely, eh!? Pray tell why you be thinkin\' that, brother, when I know it be true in me bones!','',26124),
(23714,'enUS','Because they\'re made of iron ya big dummy! Ya ain\'t got none of da senses pappy left me with - that\'s for darn sure!','',26124),
(23715,'enUS','That\'s it! That\'s it! I\'ve had just \'bout enough of ya, brother! Ya had to bring in our pappy, didn\'t ya! Stand up and fight! I don\'t wanna belt ya while yer sittin\' and then hear ya cryin\' \'bout it later!','',26124),
(23716,'enUS','Settle down, will ya! No need to be gettin\' all riled up over nothin\'! Remember what happened last time? Now sit down!','',26124),
(23717,'enUS','%s grumbles something under his breath.','',26124),
(23718,'enUS','','Come on, just do it.',26124),
(23719,'enUS','What? Why do you want me to do it?','',26124),
(23720,'enUS','Alright, I\'ll tell her.','',26124),
(23721,'enUS','%s takes a deep breath.','',26124),
(23722,'enUS','Odd, she\'s usually here...','',26124),
(23723,'enUS','Hi, uh, Becanna, I mean... uh, Elenna found some herbs! Can you go pick them up?','',26124),
(23725,'enUS','Thanks! If you uh, need any help, just come pick me up... I mean, come get me and I\'ll help!','',26124),
(23726,'enUS','%s turns slightly red and walks away.','',26124),
(23727,'enUS','','Oh, these apples are utterly delicious!',26124),
(23728,'enUS','','My brother simply must try these.',26124),
(23729,'enUS','Thanks, but I\'m not very hungry right now.','',26124),
(23730,'enUS','','Hi, William, what\'s up?',26124),
(23731,'enUS','','Ah, thank you! I\'ll be sure to go get them soon.',26124),
(23732,'enUS','','Nah, I can handle it. Thanks.',26124),
(23733,'enUS','','I\'d better ask before I go herbing this time. I don\'t want to get attacked by another wolf.',26124),
(23734,'enUS','','That William is so funny. His face always turns bright red.',26124),
(23735,'enUS','',' I am sure a noble soldier of the Alliance has better things on his mind. Oh! Elenna found some herbs so I\'m going to go pick them up.',26124),
(23736,'enUS','','%s replants the herbs nearby.',26124),
(23737,'enUS','','Hmm... well, just be careful, he might be sweet on you. I don\'t trust that sister of his either...',26124),
(23738,'enUS','','Alright, Becca, just leave them in the garden next to the bush. Watch out for wolves!',26124),
(23739,'enUS','... and have I told you about the time when I ventured deep into the heart of Blackrock Mountain?','',26124),
(23740,'enUS','That was when I slew the Orc with a great slash and took away these spaulders.','',26124),
(23741,'enUS','I found a mighty axe there, freshly forged upon the fire.','',26124),
(23742,'enUS','There, I crafted this breastplate with my own hands, toiling for hours upon the forge.','',26124),
(23743,'enUS','There, deep within the pockets of a Troll was the beautiful gem, which I sold for a handsome price!','',26124),
(23744,'enUS','..with a mighty blow, I slew a Murloc, freeing the orb from his cold, slimy hands!','',26124),
(23745,'enUS','... not to forget that time I ventured deep within the forests of Zul\'Aman.','',26124),
(23746,'enUS','... the burning sands of Silithus scorched my face as we battled wave after wave of Silithid.','',26124),
(23747,'enUS','... the city was burned, a scorched ruin of what it once was. The armies of the undead rose where the people had once lived.','',26124),
(23748,'enUS','... did I tell you about the time that I explored the far reaches of Dire Maul?','',26124),
(23749,'enUS','%s sighs...','',26124),
(23750,'enUS','%s nods silently...','',26124),
(23751,'enUS','%s listens impatiently...','',26124),
(23752,'enUS','Vexallus discharges pure energy!','',26124),
(23753,'enUS','%s begins to channel from the nearby Fel Crystal. Destroy it!','',26124),
(23754,'enUS','Welcome, friend, to the Brewfest Grounds! There\'s much to enjoy here while we celebrate the spirit of friendly competition between rival breweries. If you have any questions, let me know!','',26124),
(23755,'enUS','Food & Drink','Food & Drink',26124),
(23756,'enUS','Tokens & Souvenirs','Tokens & Souvenirs',26124),
(23757,'enUS','Ram Racing','Ram Racing',26124),
(23758,'enUS','Greetings, $r. I am Hidalgo, master of the hunt and world class falconer. This killing machine that you see perched atop my shoulder is Excelsior.$B$BYou might be thinking to yourself, \"What does a falconer even do?\" Well I\'ll tell you what we do - we hunt! Falconry is the art of using a bird of prey to hunt and catch game. Perhaps you are interested in learning to hunt with a trained raptor? Hidalgo can teach you such things!','',26124),
(23759,'enUS','Brewfest is all about enjoying the very best food and drink in the lands, and that\'s no exaggeration! Just take a gander at the many invigorating hand-crafted beers and holiday sausages, pretzels, and cheeses available. You\'ll find nothing better, and for so little coin!','',26124),
(23760,'enUS','Next to the beer and sausage, the most popular part of Brewfest is the souvenirs! From traditional holiday garb to mini-kegs of tasty brew, all sorts of Brewfest-themed items are available from Belbi Quikswitch. Just be sure to have plenty of Brewfest Prize Tokens on hand, as it\'s the only way to buy them! You can earn prize tokens by helping out around the Brewfest Grounds.','',26124),
(23761,'enUS','BY FIRE BE PURGED! Hey what\'s up?','',26124),
(23762,'enUS','Ram racing is one of the great traditions of Brewfest. Speak to Pol Amberstill down by the ram stable if you want to learn more. It\'s a right hoot AND can be a great way to earn Brewfest Prize Tokens!','',26124),
(23763,'enUS','Hey there, welcome to Brewfest! There\'s a mess of ways to keep yourself entertained in there, so you got any questions, you let me know. Otherwise, go buy some beer and a pretzel!','',26124),
(23764,'enUS','Brewfest is all about the beer and the eats, and it don\'t get any better than what we\'re serving up. Think I\'m lying? Just check out all the tasty brews, sausages, pretzels, and cheeses we got. You\'ll see: Best chow around, and it don\'t get any cheaper!','',26124),
(23765,'enUS','Everyone loves those crazy Brewfest racing rams. Want to know more? Talk to Driz Tumblequick down by the ram stable. Have a blast and earn some Brewfest Prize Tokens while you\'re at it!','',26124),
(23766,'enUS','Hey hey, don\'t forget to grab yourself some Brewfest souvenirs! We got everything from traditional holiday garb to mini-kegs of tasty brew. Just talk to Blix Fixwidget, but make sure you got plenty of Brewfest Prize Tokens on hand... it\'s the only way to buy them! You can earn prize tokens by helping out around the Brewfest Grounds.','',26124),
(23767,'enUS','','Greetings, Light of Elune be with you.',26124),
(23768,'enUS','Can you read me Alicia\'s poem again?','Can you read me Alicia\'s poem again?',26124),
(23769,'enUS','','I would love to read it to you!\n\nDo not stand at my grave and weep,\nI am not there, I do not sleep.\n\nI am in a thousand winds that blow,\nacross Northrend\'s bright and shining snow.\n\nI am the gentle showers of rain,\non Westfall\'s fields of golden grain.\n\nI am in the morning hush,\nof Stranglethorn\'s jungle, green and lush.\n\nI am in the drums loud and grand,\nthe thunderous hooves across Nagrand.\n\nI am the stars warmly gleaming,\nover Darnassus softly dreaming.\n\nI am in the birds that sing,\nI am in each lovely thing.\n\nDo not stand at my grave and cry,\nI am not there. I do not die.\n ',26124),
(23770,'enUS','Wanna take a ride?','',26124),
(23771,'enUS','Yep!','Yep!',26124),
(23772,'enUS','[NODE 1] ARRIVING','',26124),
(23773,'enUS','[NODE 1] DEPARTING','',26124),
(23774,'enUS','[NODE 2] ARRIVING','',26124),
(23775,'enUS','[NODE 2] DEPARTING','',26124),
(23776,'enUS','[NODE 3] ARRIVING','',26124),
(23777,'enUS','[NODE 3] DEPARTING','',26124),
(23778,'enUS','[NODE 4] ARRIVING','',26124),
(23779,'enUS','[NODE 4] DEPARTING','',26124),
(23780,'enUS','[NODE 5] DEPARTING - PLEASE NOTE THAT NODE 5 HAS NO ARRIVAL EVENT.','',26124),
(23781,'enUS','Vexallus overloads!','',26124),
(23782,'enUS','I\'ll tell ya, the only proper way to hunt is when yer good an\' goggled!','',26124),
(23783,'enUS','*Squawk!*  Ahoy!  Look at me pirate disguise!  Yarrrr!  *Sqwak!*','',26124),
(23784,'enUS','*Caw!*  Talk like a pirate!  Yarrr! *Sqwaaaaak!*','',26124),
(23785,'enUS','*Sqwaaak!*  Shut up, stupid bird!  You\'ll get us all killed!  *Cawwwww!*','',26124),
(23786,'enUS','Shut your trap, you feathered idiot!  These pirates will cut you open and wear you for a hat!','',26124),
(23787,'enUS','<The creature pecks at your hand.>','',26124),
(23788,'enUS','<The falcon squawks hungrily for a grub.>','',26124),
(23789,'enUS','<Feed the grub to the rock falcon.>','<Feed the grub to the rock falcon.>',26124),
(23790,'enUS','We lost everything, brother.  We thank Kamagua for giving us shelter.','',26124),
(23791,'enUS','You aid us in our time of need.  May the oceans provide you a plentiful catch.','',26124),
(23792,'enUS','Thank you, Akiaruk.  We\'d heard of your kindness even in Iskaal.','',26124),
(23793,'enUS','May Tayutka repay you and your village.','',26124),
(23794,'enUS','Best keep yer head down, \"matey!\"  If ye know what I mean!$B$BYarrrr!','',26124),
(23795,'enUS','','Soon, my love. Soon you will waken and all of Azeroth will know fear!',26124),
(23796,'enUS','','Awaken, Ymiron, the time of your continued reign is nigh.',26124),
(23797,'enUS','','Sleep no longer, my love. With the might of the Lich King behind you, the world will tremble.',26124),
(23798,'enUS','','Why is this ritual taking so long? Your master promised that your assistance would speed the process!',26124),
(23799,'enUS','','Double your efforts! King Ymiron will awaken and then he will ascend!',26124),
(23800,'enUS','','Damn the titans for cursing us so! Ymiron, my king, open your eyes!',26124),
(23801,'enUS','','The time has come for my husband, our king, to rejoin us. Together we will scour this world of its unworthy infestation!',26124),
(23802,'enUS','','The ritual proceeds too slowly. More sacrifices are needed!',26124),
(23803,'enUS','Not yet, Ymiron, I have other plans for you. You will serve me better within Utgarde Pinnacle. And if these insects survive to find you again, you will get the chance to avenge your wife.','',26124),
(23804,'enUS','Who\'s hunting who?','',26124),
(23805,'enUS','Such easy prey...','',26124),
(23806,'enUS','Tonight we feast on you!','',26124),
(23807,'enUS','I run the fights around here.  You want to place a bet, gamble with confidence - anyone caught fixin\' fights gets to walk the plank.$B$BI\'ll make sure of that myself!','',26124),
(23808,'enUS','Blood elf treasure\'s unlike any other.  It\'s not just the gold or the silk or gems used as materials, sin\'dorei craftsmanship is valuable in and of itself.','',26124),
(23809,'enUS','Taruk sent me to collect what you owe.','Taruk sent me to collect what you owe.',26124),
(23810,'enUS','Do not test me, scurvy dog!  I\'m trained in the way of the Blood Knights!','',26124),
(23811,'enUS','I yield!  I yield!  By Quel\'thalas!  Don\'t kill me!','',26124),
(23812,'enUS','I\'ll pay!  I\'ll pay!  Eeeek!  Please don\'t hurt me!','',26124),
(23813,'enUS','Pay up, Harry!','Pay up, Harry!',26124),
(23814,'enUS','','Day in and day out all Mad Jonah Sterling wants me to do is swab the decks.$B$BSwab the decks?!$B$BI\'m a mage, I don\'t DO swabbin\'! At least not the mundane way.',26124),
(23815,'enUS','Drink up, ye scurvy mongrels!','',26124),
(23816,'enUS','Eat!  Drink!  Be merry!  Next round\'s on you!','',26124),
(23817,'enUS','Finish yer rum, bucko!  There\'s thirsty orphans in Goldshire, ye know?','',26124),
(23818,'enUS','','Keep quiet, will you?  If anyone catches on, we\'re both dead.',26124),
(23819,'enUS','','All right, fellas!  Who ordered the spiced rum?  Was it you, Jackie boy?',26124),
(23820,'enUS','','It\'s ok, sweetheart.  This one\'s on the house.',26124),
(23821,'enUS','Free rum?  Why... that\'s me favorite kind!','',26124),
(23822,'enUS','Sweet Neptulon!  That was... one drink... too many!','',26124),
(23823,'enUS','<This pirate has obviously had too much to drink.  He appears to be out cold for the time being.>','',26124),
(23824,'enUS','<Discreetly search the pirate\'s pockets for Taruk\'s payment.>','<Discreetly search the pirate\'s pockets for Taruk\'s payment.>',26124),
(23825,'enUS','What are you lot looking at?  Pour me another drink!','',26124),
(23826,'enUS','','What\'s it going to be, then?  Rum?  Ale?$B$BOr perhaps something else?',26124),
(23827,'enUS','I\'d like to buy Jack a drink.  Perhaps something... extra strong.','I\'d like to buy Jack a drink.  Perhaps something... extra strong.',26124),
(23828,'enUS','','You\'re going to pull off a stunt on Jack in front of his boys?$B$BThat takes a good amount of... stupidity.  Well, it\'s going to cost you.  I\'m not going to risk my life for anything less than a gold.  And you best wait til I\'m out of the way before you make a move.',26124),
(23829,'enUS','Here\'s a gold, buy yourself something nice.','Here\'s a gold, buy yourself something nice.',26124),
(23830,'enUS','Sure thing, love.  Put it on Harry\'s tab, will ya?  He owes me a drink!','',26124),
(23831,'enUS','','There we go, $n! This fat\'ll do the trick fer sure! And now for some real swabbin\'!',26124),
(23832,'enUS','','Look at \'em go! Spotless!',26124),
(23833,'enUS','Yarrrr!  If it\'s me treasure yer lookin\' for... yer gonna have to fight for it!','',26124),
(23834,'enUS','What ...hic?!','What ...hic?!',26124),
(23835,'enUS','That\'s it... no more grog for me!','That\'s it... no more grog for me!',26124),
(23836,'enUS','You ever tried on Synthebrew Goggles? They\'re surprisingly uncomfortable!','',26124),
(23837,'enUS','Dark Iron Dwarf Attacks','Dark Iron Dwarf Attacks',26124),
(23838,'enUS','Something\'s got those Dark Iron Dwarves riled up.  They show up almost every half-hour, break all the kegs, and leave!$b$bSo you\'re probably asking, \"Why should I care?\"$b$bI\'ll tell you...  Because the kegs they break stop us from giving out free brew!  You heard me right, free brew!$b$bSo if you are around when those dwarves show up, take a minute and help protect the kegs.','',26124),
(23839,'enUS','Brewfest is the perfect holiday!  But it\'s got one catch, Dark Iron dwarf attacks.  They happen nearly every half-hour!$b$bThe attackers target the kegs that dispense the FREE brew!  And it\'s really good brew that the brewmasters are giving out!$b$bLook, if you\'re around when the Dark Iron dwarves show up, lend a hand and protect the FREE brew.','',26124),
(23840,'enUS','The power! More, more, more!','',26124),
(23841,'enUS','It seethes and burns...','',26124),
(23842,'enUS','I\'ll never stop. Never...','',26124),
(23843,'enUS','Yer dead, landlubber!','',26124),
(23844,'enUS','Looks like me boys need a hand!','',26124),
(23845,'enUS','It\'s MINE!','',26124),
(23846,'enUS','You wish to steal the power!  Die!','',26124),
(23847,'enUS','Get away from my crystals!','',26124),
(23848,'enUS','Yarrrrr... dead again!','',26124),
(23849,'enUS','Yarrrr, mon!','',26124),
(23850,'enUS','Welcome back, $n.','',26124),
(23851,'enUS','Is this how you repay your master, you fleabag?  Arrrrrgghh!!','',26124),
(23852,'enUS','','That cursed Jonah Sterling will lead us right into doom.  If he spent more time outside of his cave, he would realize the folly of attacking professional navies in a time of war.',26124),
(23853,'enUS','','You\'d best scram, $n.  I do not want Jonah\'s death to be linked back to me.$B$BIt\'ll be hard enough to establish myself as leader of this lot without them knowing I had their previous skipper killed.',26124),
(23854,'enUS','%s devours his master\'s body.','',26124),
(23855,'enUS','Many changes come to the land and water: you, them... much change.$B$BKamagua\'s way of life is threatened by these changes. What will you do?','',26124),
(23856,'enUS','I\'m out of my element, eh? Walt doesn\'t know what he\'s talking about! I single-handedly kicked the iron out of these dwarves and set up camp to observe the goings-on of the dig site.\n','',26124),
(23857,'enUS','The Dude, over yonder, is pretty upset about his rug.','',26124),
(23858,'enUS','Evenin\', Gov\'na.','Evenin\', Gov\'na.',26124),
(23859,'enUS','The reef cow and her new bull find true love.','',26124),
(23860,'enUS','Launching.','',26124),
(23861,'enUS','Soldiers arise, stand and fight! Bring victory at last to this fallen knight!','',26124),
(23862,'enUS','Start the countdown!','Start the countdown!',26124),
(23863,'enUS','ONE!','ONE!',26124),
(23864,'enUS','TWO!','TWO!',26124),
(23865,'enUS','THREE!','THREE!',26124),
(23866,'enUS','FOUR!','FOUR!',26124),
(23867,'enUS','FIVE!','FIVE!',26124),
(23868,'enUS','Walt sent me to pick up some dark iron ingots.','Walt sent me to pick up some dark iron ingots.',26124),
(23869,'enUS','I su... sur... surpose that yar wanna ride back to der outpost. Yarp?','',26124),
(23870,'enUS','Yarp.','Yarp.',26124),
(23871,'enUS','Walt\'s work bench is ready for use.','',26124),
(23872,'enUS','<Get on the work bench and let Walt put you in the golem suit.>','<Get on the work bench and let Walt put you in the golem suit.>',26124),
(23873,'enUS','Behold my perfect creation!','',26124),
(23874,'enUS','Twice a day, at six fifteen in the morning and six fifteen in the evening, High Tinker Mekkatorque himself comes out to the Brewfest grounds for the Tapping of the Keg ceremony. Don\'t miss it!','',26124),
(23875,'enUS','WHOA, WHOA, WHOA! Hold everything, fellas!','',26124),
(23876,'enUS','The dwarves all burst out in laughter.','',26124),
(23877,'enUS','The Tapping of the Keg','The Tapping of the Keg',26124),
(23878,'enUS','Oh dear lords of stone and steel, what... I repeat... WHAT are ya gonna do with that?','',26124),
(23879,'enUS','Twice a day, at six fifteen in the morning and six fifteen in the evening, High Overlord Saurfang himself comes out to the Brewfest grounds for the Tapping of the Keg ceremony. You\'d be a fool to miss it!','',26124),
(23880,'enUS','Man, that will never work. The iron dwarves are never gonna fall for that hunk o\' junk!','',26124),
(23881,'enUS','Only 10 more minutes until High Overlord Saurfang taps the Brewfest keg!','',26124),
(23882,'enUS','In 20 minutes High Overlord Saurfang will tap the Brewfest Keg!','',26124),
(23883,'enUS','You\'re out of your element, Lebronski! Uncalled for! Those iron dwarves won\'t know what hit \'em! Now why don\'t you get back to uncovering the mystery of the gigantic turd on your rug and leave the real scientists to their work!','',26124),
(23884,'enUS','High Overlord Saurfang is on his way!  The \"Tapping of the Keg\" will take place in just a few short minutes!','',26124),
(23885,'enUS','','I\'m cryin\' here! Please, make the funny stop!',26124),
(23886,'enUS','In 20 minutes High Tinker Mekkatorque will tap the Brewfest Keg!','',26124),
(23887,'enUS','In just 10 minutes High Tinker Mekkatorque will tap the Brewfest Keg!','',26124),
(23888,'enUS','High Tinker Mekkatorque is on his way!  The \"Tapping of the Keg\" ceremony will begin in a few minutes!','',26124),
(23889,'enUS','If only our pappy were alive to see this!','',26124),
(23890,'enUS','What do you think you\'re doing, man? Lebronski does NOT appreciate you dragging your loose metal parts all over his rug.','',26124),
(23891,'enUS','Far out, man. This bucket of bolts might make it after all...','',26124),
(23892,'enUS','Model U-9207 Iron Rune Construct does not appreciate your tone of voice. Commencing total annihilation of your rug, Lebronski.','',26124),
(23893,'enUS','Come with me *crackle* if you want to live.','',26124),
(23894,'enUS','This barrel of ale is guarded by Jarven Thunderbrew.  As long as he\'s in the basement, no barrels may be disturbed.','',26124),
(23895,'enUS','Alert! Alert! Construct senses that enemies have breeched our defenses. Increase pace.','',26124),
(23896,'enUS','Construct class carrier reporting for duty. Primary function: Overseeing.','',26124),
(23897,'enUS','There is nothing to see here. Proceed with your mandated duties.','',26124),
(23898,'enUS','All hail the great creator.','',26124),
(23899,'enUS','To interfere with construct\'s function results in termination. Move along.','',26124),
(23900,'enUS','Construct must not be questioned by iron dwarf servant. Commence deconstruction.','',26124),
(23901,'enUS','Construct is not authorized to communicate with lesser beings. Being must double their efforts.','',26124),
(23902,'enUS','Did you lose your wallet? Construct has found wallet with overabundance of currency.','',26124),
(23903,'enUS','Halt! Identify yourself immediately!','',26124),
(23904,'enUS','This section is off-limits!','',26124),
(23905,'enUS','I\'ve never seen one of you around here.','',26124),
(23906,'enUS','Hold it! Stop!','',26124),
(23907,'enUS','Stop!! Stop!!! Scrap metal moves itself now?','',26124),
(23908,'enUS','Wrong answer!','',26124),
(23909,'enUS','Well played, $n. Well played, indeed...','',26124),
(23910,'enUS','Right... my bad. Now where was I?','',26124),
(23911,'enUS','All hail the great creator!','',26124),
(23912,'enUS','You\'re right, of course. Carry on.','',26124),
(23913,'enUS','Forgive my insolence!','',26124),
(23914,'enUS','Do you bring word from the creator?','',26124),
(23915,'enUS','We will double our efforts!','',26124),
(23916,'enUS','Work must continue. Double your efforts.','',26124),
(23917,'enUS','Brontes sees all.','',26124),
(23918,'enUS','Do not loiter.','',26124),
(23919,'enUS','Continue deconstruction.','',26124),
(23920,'enUS','Reinforcements en route. Function must be unabated.','',26124),
(23921,'enUS','Destroy earthen infestation.','',26124),
(23922,'enUS','Come, minions! Your master calls!','',26124),
(23923,'enUS','The work of your brothers in the Storm Peaks has reached a frenzied pace. Soon, Father will be freed.','',26124),
(23924,'enUS','Your brothers to the north have subjugated the stone behemoths and set them on the path to Ulduar. Soon, the remaining defenses of the Pantheon will be neutralized.','',26124),
(23925,'enUS','The three fissures opened by the mortals of this region must be silenced. The earth hears and sees what we do and will continue to interfere with our efforts if the way is not closed.','',26124),
(23926,'enUS','Bury this place! Your master demands it!','',26124),
(23927,'enUS','The sound of thunder roars throughout the cavern.','',26124),
(23928,'enUS','The sound of thunder dissipates.','',26124),
(23929,'enUS','I\'m ready to go, Walt.','I\'m ready to go, Walt.',26124),
(23930,'enUS','System failure in 3... 2...','',26124),
(23931,'enUS','Feed, me bruddahs!','',26124),
(23932,'enUS','Systems failing *click*','',26124),
(23933,'enUS','Crash imminent *clunk*','',26124),
(23934,'enUS','Construct going offline *beep*','',26124),
(23935,'enUS','*click* Flight systems malfunctioning *clang*','',26124),
(23936,'enUS','Be still, mortals, and hearken to my words.','',26124),
(23937,'enUS','As you peer into the orb, you feel a familiar force tugging at your mind.','',26124),
(23938,'enUS','Allow the orb to take you where it will....','Allow the orb to take you where it will....',26124),
(23939,'enUS','You are not yet attuned to the scrying orb.','',26124),
(23940,'enUS','Your mind is gradually opened as you focus on the orb before you....','',26124),
(23941,'enUS','Land ho, Mr. Kowalski! Port is in sight, sir!','',26124),
(23942,'enUS','Thank you, Mr. Henders.','',26124),
(23943,'enUS','Bring us into port, please, Mr. Mehran.','',26124),
(23944,'enUS','Captain Stash! We\'ll be arriving shortly, sir!','',26124),
(23945,'enUS','Thank you, Mr. Kowalski! You may return to your post to oversee docking!','',26124),
(23946,'enUS','Well done, all. Please bring us safely to our next port.','',26124),
(23947,'enUS','Cap\'n Stash is the BEST!','',26124),
(23948,'enUS','I swab the decks!','',26124),
(23949,'enUS','The Lady Mehley is the best ship EVER!','',26124),
(23950,'enUS','Swabbin\' decks cured my rickets!','',26124),
(23951,'enUS','Aye aye, Mr. Kowalski.','',26124),
(23952,'enUS','Times are changing, $n.  War has arrived.$B$BWill our people rise to the occasion and aid our allies... or will we linger in the sidelines?','',26124),
(23953,'enUS','I\'ve little time for talk, sorry.','',26124),
(23954,'enUS','','Can\'t ya see I\'m workin\' here, $glad:lass;? Off with ya, afore Kowalski sees me jawin.\'',26124),
(23955,'enUS','Fine day fer sailin\', innit?','',26124),
(23956,'enUS','Torgoley works us hard, but he\'s a good captain, aye.','',26124),
(23957,'enUS','There aren\'t many of us left, $n.  The return of our old enemy is a cause for great concern.','',26124),
(23958,'enUS','I must keep my eyes on ship and crew, good $gsir:madame;. You must forgive my not pausing to speak with you.','',26124),
(23959,'enUS','The Lady Mehley is in Theramore enough that we\'ve been assigned to guard her passengers.','The Lady Mehley is in Theramore enough that we\'ve been assigned to guard her passengers.',26124),
(23960,'enUS','Welcome to the majestic Lady Mehley. I am Captain Torgoley.$b$bIf you\'ve questions about the ship, feel free to ask; otherwise, please, enjoy the journey, as I always do... After all, to quote a favorite scribe of mine: My experience of ships is that on them one makes an interesting discovery about the world. One finds one can do without it completely.','',26124),
(23961,'enUS','The Lady Mehley','The Lady Mehley',26124),
(23962,'enUS','Food & Drink','Food & Drink',26124),
(23963,'enUS','Goods & Gear','Goods & Gear',26124),
(23964,'enUS','\"Stash?\"','\"Stash?\"',26124),
(23965,'enUS','Aye, that\'s her name, and a fine ship she is.$b$bThere\'s much to learn from such vessels, you know. A great poet once said: Ships that pass in the night, and speak each other in passing, only a signal shown, and a distant voice in the darkness; So on the ocean of life, we pass and speak one another, only a look and a voice, then darkness again and a silence.','',26124),
(23966,'enUS','Should you desire sustenance, Galley Chief Grace can tend to your needs.','',26124),
(23967,'enUS','Mr. Combs, the ship\'s engineer and quartermaster, can furnish you with whatever supplies you might require. He is a fair tinker, too, if your gear is in need of repair.','',26124),
(23968,'enUS','Ah, yes, that... the name. Well... as they say, a good name, like good will, is got by many actions and lost by one. No need to go into the hows or whys; suffice to say, that is how I am named by some.','',26124),
(23969,'enUS','The dead rise and seek vengeance on any that dare pass through their domain. Turn back!\n','',26124),
(23970,'enUS','From sundered ground the sacrament was stolen. The Shield of Aesirites is lost. Unrest will be eternal.','',26124),
(23971,'enUS','The Staff of Storm\'s Fury pilfered. A curse upon this land! The storms will never cease!\n','',26124),
(23972,'enUS','The Frozen Heart of Isuldof will consume this land until it is returned. Woe unto those that hold the heart as the curse of frozen blood besets them...\n','',26124),
(23973,'enUS','The anguish of ten-thousand years awaits any foolish enough to don the Ancient Armor of the Kvaldir. Beware the mist and fog, mortals; for with them comes your end.\n','',26124),
(23974,'enUS','I lucked out. Not many tauren get to be cabin boy on a frigate like this! Grezzix even lets me man these incredible battle canoes.','',26124),
(23975,'enUS','I don\'t have time for chit-chat, Lou. Take me to Scalawag Point.','I don\'t have time for chit-chat, Lou. Take me to Scalawag Point.',26124),
(23976,'enUS','The fury of the Vrykul will consume you!','',26124),
(23977,'enUS','Its power courses through me! I AM A GOD!','',26124),
(23978,'enUS','ABDUL IS STRONG LIKE BULL!','',26124),
(23979,'enUS','ARE YOU CHALLENGING ME? I HAVE THE STRENGTH OF TEN MEN!','',26124),
(23980,'enUS','HOW DARE YOU! ABDUL WILL PUT YOUR HEAD ON A PIKE!','',26124),
(23981,'enUS','I need... your help! Cannot... resist him much longer!','',26124),
(23982,'enUS','Agghh!! Help me before I lose my mind!','',26124),
(23983,'enUS','Hurry! There is not much of me left!','',26124),
(23984,'enUS','Unparalleled power... I... crave... more!','Unparalleled power... I... crave... more!',26124),
(23985,'enUS','Fel energy... courses through my veins!','Fel energy... courses through my veins!',26124),
(23986,'enUS','Your life force is my nourishment, demon... Kil\'jaeden\'s gift to us!','Your life force is my nourishment, demon... Kil\'jaeden\'s gift to us!',26124),
(23987,'enUS','I will soon be stronger than any elf!  I will serve at Kil\'jaeden\'s side!','I will soon be stronger than any elf!  I will serve at Kil\'jaeden\'s side!',26124),
(23988,'enUS','More... more... MORE!!!','More... more... MORE!!!',26124),
(23989,'enUS','If we are to be successful in the creation of a portal to the Isle of Quel\'Danas, and the Sunwell which rests upon it, we must acquire an energy source powerful enough to ignite the portal.$B$BWe are $3269w percent completed with our efforts. Will you assist us, $c?','',26124),
(23990,'enUS','This portal is not like the others that lead back to Azeroth. To maintain it, we must acquire more mana cells.$B$BIt is either that or risk losing our access to the Isle of Quel\'Danas and the Sunwell.','',26124),
(23992,'enUS','Begone from my sight!','',26124),
(23993,'enUS','%s unleashes a Spectral Blast!','',26124),
(23994,'enUS','What have you done?!','What have you done?!',26124),
(23995,'enUS','My power... is gone!','My power... is gone!',26124),
(23996,'enUS','No... no... NO!!!!!','No... no... NO!!!!!',26124),
(23997,'enUS','Fire! Fire, ya yella sea dogs!','',26124),
(23998,'enUS','MORE PIRATES FOR SORLOF TO SMASH!','',26124),
(23999,'enUS','Where are tiny men!? Just puny flag!','',26124),
(24000,'enUS','Sorlof been tricked! Aarrrrggghhh...','',26124),
(24001,'enUS','%s becomes unstable with brimming energy!','',26124),
(24002,'enUS','%s releases its energy, engulfing its surroundings in flames!','',26124),
(24003,'enUS','The rift\'s power is ours!','The rift\'s power is ours!',26124),
(24004,'enUS','Get away, this place is ours!','Get away, this place is ours!',26124),
(24005,'enUS','Mine! You shall not take this place!','Mine! You shall not take this place!',26124),
(24006,'enUS','It is not meant for you! Get away from here!','It is not meant for you! Get away from here!',26124),
(24007,'enUS','Arise and serve your eternal master!','',26124),
(24008,'enUS','Core overload detected. System malfunction detected...','Core overload detected. Recharging...',26124),
(24009,'enUS','The crystal pulses faintly.  Its protective energy has grown weak but is not entirely depleted.','',26124),
(24010,'enUS','','<The noble Flaskasaur nods at you in approval.>',26124),
(24011,'enUS','What do you have for me?','What do you have for me?',26124),
(24012,'enUS','We\'re currently focus testing Zul\'Aman, a 10 player raid dungeon in the Ghostlands. You must be at least level 68 to enter.','',26124),
(24013,'enUS','I\'m ready for Zul\'Aman, Jebediah. Teleport me!','I\'m ready for Zul\'Aman, Jebediah. Teleport me!',26124),
(24014,'enUS','Objective acquired.  Initiating security routines.','',26124),
(24015,'enUS','Commence location defense.','',26124),
(24016,'enUS','Deployment successful.  Trespassers will be neutralized.','',26124),
(24017,'enUS','The %s becomes energized with arcane power.','',26124),
(24018,'enUS','','Greetings, $r.$b$bMy shop is finally open. I hope you like what you see!',26124),
(24019,'enUS','','Good day to you, $c.$b$bThere\'s much to be done to assist in the effort here. Sadly, there\'s very little I can do for you until I get all of my supplies.$b$bI\'ve now got $3223w percent of the razorthorn roots I need to get started. Any assistance you provide will be well worth the effort, I assure you.',26124),
(24020,'enUS','Kwa! You cannot kill me, I am immortal!','',26124),
(24021,'enUS','Quickly! Use the flames and support the ground troops. Its ancient magic should cleanse Terokk\'s shield.','Quickly! Use the flames and support the ground troops. Its ancient magic should cleanse Terokk\'s shield.',26124),
(24022,'enUS','','This is the gateway that Kael\'s armies used to retreat to the Sunwell.  Some of his lapdogs remain here; the Legion has rewarded them in a most... unusual way.',26124),
(24023,'enUS','','Have you seen the damaged sentries that wander the island?  A few modifications to the crystals that control their behavior will allow us to gain control of them and use them to secure tactical locations.$B$BThe Sun\'s Reach Sanctum will be ours in no time.  We are $3244w percent done with this goal.',26124),
(24024,'enUS','','We succeeded in taking the Sanctum.  We can continue to convert sentries and use them as guards at other tactical locations.',26124),
(24025,'enUS','Ahoy! Ye be lookin\' to book passage board the Sister Mercy, matey? Ye\'ve come to the right place...','',26124),
(24026,'enUS','We must make sure not to lose any more souls to the seas.','We must make sure not to lose any more souls to the seas.',26124),
(24027,'enUS','Aim for the keester!','',26124),
(24028,'enUS','Fire! Fire for the booty, me hearties!','',26124),
(24029,'enUS','It may\'ave won in life, but it won\'t be winnin\' in the afterlife! FIRE!','',26124),
(24030,'enUS','Forgive me $c, but I must concentrate on my job.','Forgive me $c, but I must concentrate on my job.',26124),
(24031,'enUS','Many have been lost to the seas.  I, and the wisps, are charged with looking for those souls.  ','Many have been lost to the seas.  I, and the wisps, are charged with looking for those souls.',26124),
(24032,'enUS','Sorlof\'s booty falls to the floor.','',26124),
(24033,'enUS','The wisps and I watch the seas for any lost souls.','The wisps and I watch the seas for any lost souls.',26124),
(24034,'enUS','The seas are a dangerous place, $c.  We must be alert.','The seas are a dangerous place, $c.  We must be alert.',26124),
(24035,'enUS','I\'m afraid I cannot speak with you at the moment.','I\'m afraid I cannot speak with you at the moment.',26124),
(24036,'enUS','I hunger!','',26124),
(24037,'enUS','The power... it will be mine!','',26124),
(24038,'enUS','You will not stop me!','',26124),
(24039,'enUS','The crystal wards... I must feed!','',26124),
(24040,'enUS','So... much... power.','',26124),
(24041,'enUS','The energy; I can feel it!','',26124),
(24042,'enUS','We will retake these wards!','',26124),
(24043,'enUS','You cannot keep our wards!','',26124),
(24044,'enUS','Yo-ho-ho, and a bottle of gnomish spirits!','',26124),
(24045,'enUS','Thar she blows!','',26124),
(24046,'enUS','Rum and wenches for all!','',26124),
(24047,'enUS','Take that, landlubber!','',26124),
(24048,'enUS','The booty be ours!','',26124),
(24049,'enUS','... did you see how Kael\'thas looked?','',26124),
(24050,'enUS','Yes. He hasn\'t been the same since the attack on Tempest Keep.','',26124),
(24051,'enUS','He was beaten and left for dead. If Priestess Delrissa hadn\'t arrived when she did, who knows what might have happened!','',26124),
(24052,'enUS','That look in his eyes now... it scares me.','',26124),
(24053,'enUS','Yes, but we will follow him to the end. Its our duty to hold this sanctuary while he prepares.','',26124),
(24054,'enUS','Prepares? Prepares for what?','',26124),
(24055,'enUS','His... return.','',26124),
(24056,'enUS','%s gasps.','',26124),
(24057,'enUS','Blessings of the naaru upon you, my friend.','',26124),
(24058,'enUS','You don\'t get to see much action in my line of work.  Serving this close to the front lines in a combat zone is a nice change of pace.','',26124),
(24059,'enUS','Speaking of action, I\'ve been ordered to undertake an air strike.','Speaking of action, I\'ve been ordered to undertake an air strike.',26124),
(24060,'enUS','I utterly cannot stand the presence of these demons!','',26124),
(24061,'enUS','Yes! When was the last time you saw a doomguard take a bath?','',26124),
(24062,'enUS','... not to mention that those blasted abyssals patrol all over the flowerbeds.','',26124),
(24063,'enUS','Why do we need them anyways?','',26124),
(24064,'enUS','Lord Kael\'thas insisted upon it.','',26124),
(24065,'enUS','Well, I hope once they\'re done he\'ll send them right back through that portal...','',26124),
(24066,'enUS','%s nods in agreement.','',26124),
(24067,'enUS','Train harder! We are all that remains of the loyal defenders of Kael\'thas!','',26124),
(24068,'enUS','Put your shoulders into it! We must defend the Sunwell with our lives if needed!','',26124),
(24069,'enUS','Kael\'thas will not tolerate any further failures!','',26124),
(24070,'enUS','Again!','',26124),
(24071,'enUS','The Dawnblade will defend this land for all of the Sin\'dorei. There is no turning back!','',26124),
(24072,'enUS','This is no vacation - our hearts, our souls, the final escape from the addictions that bind us lie here on Quel\'Danas. ','',26124),
(24073,'enUS','Do you want to end up like one of the Wretched? No?! Then put your hearts into it this time!','',26124),
(24074,'enUS','Kil\'jaeden\'s patience wears thin!  Destroy the naaru\'s lackeys once and for all!','',26124),
(24075,'enUS','Coilskar Key','Coilskar Key',26124),
(24076,'enUS','You fear death?  Far worse awaits you, should you fail!  Slay the mortals!','',26124),
(24077,'enUS','Return to your posts!  The battle is not yet over!','',26124),
(24078,'enUS','The Sun\'s Reach Armory is ours!  We\'ve pushed the demons back to Dawning Square!','',26124),
(24079,'enUS','We\'ve taken the Sanctum at Sun\'s Reach!  Send word back to Shattrath, we make our move now!','',26124),
(24080,'enUS','Capturing the Sun\'s Reach Sanctum was the first step in our battle plan.  Our orders are to take control of the armory next.$B$BWe are $3233w percent done with our goal.','',26124),
(24081,'enUS','We have gained control of the armory, but our work on the island is not yet finished.','',26124),
(24082,'enUS','','My orders are to create a distraction at the Dead Scar so our forces can take the Sun\'s Reach Armory.  It might not be as glamorous as killing demons face to face, but if it wins us this battle then I\'m all for it.$B$BWe are $3233w percent done with our goal.',26124),
(24083,'enUS','','We\'ve captured the armory, $n.  Let\'s not rest on our laurels, however.  The Legion sure will not.',26124),
(24084,'enUS','Our efforts have paid off.  We\'ve captured the Sun\'s Reach Sanctum, $n.  Go there and see if there\'s anyone you can assist.','',26124),
(24085,'enUS','Arming the wards at the sanctum will help us secure it faster.  We don\'t want any Wretched getting in our way when we unleash a full scale attack on the Legion and Kael.$B$BWe are $3244w percent done with our goal.','',26124),
(24086,'enUS','$n, it\'s very good to see you again!','$n, it\'s very good to see you again!',26124),
(24087,'enUS','Everyone look, it\'s $n!','Everyone look, it\'s $n!',26124),
(24088,'enUS','Dawnblade, demons and naga beware, $n is back.','Dawnblade, demons and naga beware, $n is back.',26124),
(24089,'enUS','$G Milord : Milady;, $n, we are fortunate to have you here with us.','$G Milord : Milady;, $n, we are fortunate to have you here with us.',26124),
(24090,'enUS','... the Black Temple is under siege?','',26124),
(24091,'enUS','The forces of the Aldor and Scryers stormed the citadel shortly after Akama and his foul brethren slew Al\'ar. Its a good thing we left Illidan as soon as we did.','',26124),
(24092,'enUS','I had heard that a score of them broke into the Eye and slew him.','',26124),
(24093,'enUS','Twenty? Impossible, it couldn\'t have been less than fourty.','',26124),
(24094,'enUS','Well, maybe it was more like a hundred...','',26124),
(24095,'enUS','Its only a matter of time before that dog, Akama, betrays the Betrayer as well...','',26124),
(24096,'enUS','The Bravery\'s crew will do its best to make your journey as swift and pleasant as possible.','',26124),
(24097,'enUS','Sorry, but we\'ll have to speak some other time. Farewell.','',26124),
(24098,'enUS','The Shattered Sun Offensive is lucky to have $n on our side.','The Shattered Sun Offensive is lucky to have $n on our side.',26124),
(24099,'enUS','If it weren\'t for $n, we\'d all be long dead.','If it weren\'t for $n, we\'d all be long dead.',26124),
(24100,'enUS','$n, thank you again for helping us. We couldn\'t have achieved any of this without you.','$n, thank you again for helping us. We couldn\'t have achieved any of this without you.',26124),
(24101,'enUS','','Welcome to The Bravery, $gsir:madame;. Now if you\'ll excuse me...',26124),
(24102,'enUS','Three cheers for $n!','Three cheers for $n!',26124),
(24103,'enUS','It\'s an honor to serve with you, $n.','It\'s an honor to serve with you, $n.',26124),
(24104,'enUS','$n has kept the demons at bay countless times.','$n has kept the demons at bay countless times.',26124),
(24105,'enUS','','I\'m almost jealous of our Mr. Wavesinger. Why, he may well be prettier than me!',26124),
(24106,'enUS','If I were one of those Dawnblade blood elves, I\'d be swimming away from the island now that $n is here.','If I were one of those Dawnblade blood elves, I\'d be swimming away from the island now that $n is here.',26124),
(24107,'enUS','How many wretched do you think $n has put out of their misery?','How many wretched do you think $n has put out of their misery?',26124),
(24108,'enUS','Snap to attention, $n, one of our finest, is here!','Snap to attention, $n, one of our finest, is here!',26124),
(24109,'enUS','','Unlucky name fer a sailor, innit?',26124),
(24110,'enUS','Welcome back, $n.','Welcome back, $n.',26124),
(24111,'enUS','There\'s our $g hero : heroine; right there! How are you doing, $n?','There\'s our $g hero : heroine; right there! How are you doing, $n?',26124),
(24112,'enUS','I guarantee that without $n, this whole offensive would have been a failure.','I guarantee that without $n, this whole offensive would have been a failure.',26124),
(24113,'enUS','No matter what, your efforts will always be exalted here, $n!','No matter what, your efforts will always be exalted here, $n!',26124),
(24114,'enUS','This greyin\' seadog may be the oldest of the crew, but he\'s also the toughest of the lot! Eh? Eh? Arms like an ogre!','',26124),
(24115,'enUS','Lay waste to the demons on the Dead Scar lately, $n?','Lay waste to the demons on the Dead Scar lately, $n?',26124),
(24116,'enUS','$n, one of these days I want to buy you a drink.','$n, one of these days I want to buy you a drink.',26124),
(24117,'enUS','I don\'t even want to think about what\'ll happen here if $n ever decides not to come back.','I don\'t even want to think about what\'ll happen here if $n ever decides not to come back.',26124),
(24118,'enUS','','We\'ve sworn to do our very best to protect the passengers of The Bravery. The sea lane between Rut\'theran Village and Stormwind Harbor must remain safe.',26124),
(24119,'enUS','$n, you have no idea what a relief it is to see you!','$n, you have no idea what a relief it is to see you!',26124),
(24120,'enUS','What a coincidence... we were just talking about you, $n!','What a coincidence... we were just talking about you, $n!',26124),
(24121,'enUS','Who needs sentries? $n is here!','Who needs sentries? $n is here!',26124),
(24122,'enUS','Hey, $n, try to leave some of the glory for us, would ya?','Hey, $n, try to leave some of the glory for us, would ya?',26124),
(24123,'enUS','The Dawnblade forces have been driven from the Sun\'s Reach Harbor!  The day is ours!','',26124),
(24124,'enUS','Examining','Examining',26124),
(24125,'enUS','Hey, kid. You\'re aboard the Maiden\'s Fancy. The name\'s Captain Wrenchnozzle, and you\'ve got the privilege of sailing on the pride of the Blackwater Raiders. The Bloodsail don\'t come near us, not with my sharp crew and the large amount of gunpowder in the hold. Insurance, you know.$b$bIf you\'ve got questions, kid, I\'ll answer \'em.','',26124),
(24126,'enUS','The Maiden\'s Fancy','The Maiden\'s Fancy',26124),
(24127,'enUS','Yeah, that\'s her you\'re standing on. A beaut, isn\'t she? The Baron set me up as the captain a while back. She\'s not mine originally, so I didn\'t name her; if you want my opinion, kid, I think the sailor who named her spent a little too much time at sea and not enough time in port, if you catch my meaning.','',26124),
(24128,'enUS','If your stomach\'s rumbling, talk to Galley Chief Steelbelly, but just between you and me? You might want to wait. He\'s got that name for a reason.','',26124),
(24129,'enUS','What\'s a Steamwheedle ship without an engineer, eh? Torquespindle can help you with anything you need. He\'s handy with repairing things quickly, too, if that\'s what you\'re after.','',26124),
(24130,'enUS','Welcome aboard the Feathermoon Ferry.  We travel between Feathermoon Stronghold and the Forgotten Coast looking for those lost at sea.  The sea can be a dangerous place if you are not prepared.$b$bIf you need to get prepared, please speak to our provisioners.  They are more than happy to help you.','',26124),
(24131,'enUS','On behalf of the crew of the Moonspray, I welcome you $c.  I hope you take advantage of our provisions before parting with us.','',26124),
(24132,'enUS','Watch your step aboard Elune\'s Blessing, $r.  Though Elune\'s blessed us with the discovery of our new friends, we\'ve also had our share of hardships at sea.$b$bHowever, recovering souls lost at sea or lost in a new world is truly a blessing from Elune.','',26124),
(24133,'enUS','Elune has blessed us many times over with all the discoveries we have made.  But we must remain vigilant, $c.','Elune has blessed us many times over with all the discoveries we have made.  But we must remain vigilant, $c.',26124),
(24134,'enUS','','Forgive me, $r, I must focus on my job.',26124),
(24135,'enUS','','I\'m sorry, I\'ve little time for speaking to anyone other than the wisps and the captain to report my findings.  Forgive me.',26124),
(24136,'enUS','Welcome aboard the Maiden\'s Fancy. It should be smooth sailing all the way to port.','',26124),
(24137,'enUS','It\'s amazing what you can learn from a gnome if you squeeze them hard enough: clever little tricks about getting out of a bind, making delicious cookies, and even how to make a flying machine.','',26124),
(24138,'enUS','Flying machines?','Flying machines?',26124),
(24139,'enUS','Do you often squeeze gnomes?','Do you often squeeze gnomes?',26124),
(24140,'enUS','As often as I can.  It\'s great exercise and it keeps me informed on what they\'re up to--which, from my experience, is always no good.','',26124),
(24141,'enUS','That\'s... great.  What about these flying machines?','That\'s... great.  What about these flying machines?',26124),
(24142,'enUS','Thanks!  I\'ll try it right now.','Thanks!  I\'ll try it right now.',26124),
(24143,'enUS','%s goes into a killing frenzy!','',26124),
(24144,'enUS','%s becomes enraged!','',26124),
(24145,'enUS','Kite','Kite',26124),
(24146,'enUS','Rocket Chicken','Rocket Chicken',26124),
(24147,'enUS','Paper Airplane','Paper Airplane',26124),
(24148,'enUS','Urrrk... if that grubbing galley chief over there offers you his special, do yourself a favor and dump it in the ocean. It might kill a few makruras instead of your will to live.','',26124),
(24149,'enUS','','Hello, $r.$b$bLet\'s get busy! No sense waiting around for supplies that may never arrive.$b$bI need my anvil in order to outfit our troops properly. Right now It\'s $3228w percent complete.$b$bAnd when the anvil is completed, there will be many more powerful items that I will be able to smith for you.',26124),
(24150,'enUS','','Hello, $n.$b$bNow that I\'ve finished creating my anvil I can begin outfitting our troops. It\'s an important step, but there\'s still much to be done.$b$bMore importantly for you, there are new things that I can create, which you may be interested in.',26124),
(24151,'enUS','','We\'ve taken the harbor, and this ship is a nice bonus. Too bad she\'s not yet sea-worthy.$B$BIn the meantime, I\'ve been instructed to oversee the disruption of the naga on the Greengill Coast.$B$BThink you can help me out?',26124),
(24152,'enUS','I need to intercept the Dawnblade reinforcements.','I need to intercept the Dawnblade reinforcements.',26124),
(24153,'enUS','Welcome aboard the Thundercaller!$b$bDon\'t pay attention to the people that complain about explosions or the like.  I mean really, everyone makes mistakes.  We should cut people some slack.$b$bLook, I\'d understand if a captain managed to crash his ship 22 or 23 times... But anything less than that isn\'t worth mentioning.','',26124),
(24154,'enUS','<Grumbles>  I guess those mountains came out of nowhere...  All five times!','',26124),
(24155,'enUS','<Grumbles>  You\'d think it would be hard to crash a zeppelin into the ocean.  You\'d think it\'d be even harder to do it four separate times!','',26124),
(24156,'enUS','<Grumbles> I wish I could say we\'ve managed to avoid crash landing into lakes.  I wish I could say we\'ve only crashed into a lake once... but we\'ve managed to crash into four separate lakes, including Lordamere Lake!','',26124),
(24157,'enUS','I am impressed that pine tree branches don\'t seem to damage our ship much.$b$bNot that it excuses the three times we\'ve crashed into some forest.','',26124),
(24158,'enUS','I never thought I\'d get to see Teldrassil... I certainly never thought we\'d crash into Teldrassil.','',26124),
(24159,'enUS','We\'ve managed to squeeze through Thunder Bluff twice now!  ','',26124),
(24160,'enUS','<Grumbles> I still don\'t know how we managed to snake through Thousand Needles without a scratch, only to crash and burn in the Shimmering Flats!','',26124),
(24161,'enUS','','If you like excitement, our captain\'s the best!  I love this job!',26124),
(24162,'enUS','Don\'t ask...','',26124),
(24163,'enUS','You can\'t blame me for our mishaps... I can\'t even see where I\'m going!$b$bThough maybe that means you can blame me...$b$bNo!  Wait!  I can dock this ship just fine... It\'s gotta be the orders the captain issues!  Maybe he likes pushing us to our limits and testing out our survival and repair skills.','',26124),
(24164,'enUS','','Good work, $n.',26124),
(24165,'enUS','','I can use all of the cleansed metal that you can provide.',26124),
(24166,'enUS','','At this rate, our men and women will be the finest equipped in no time.',26124),
(24167,'enUS','','Thank you, $n!',26124),
(24168,'enUS','','Your form is excellent. Are you a blacksmith by chance?',26124),
(24169,'enUS','','Along with the naga\'s ore, the cleansed metal that you provide will form a nigh-invulnerable alloy.',26124),
(24170,'enUS','','Your work here is invaluable to the Offensive.',26124),
(24171,'enUS','','Thank you for purifying the armaments yourself, $n. I have much to do and very little time to do it in.',26124),
(24172,'enUS','I used to be known as Iolol until a secret vote was passed around town that resulted in me having to change my name. It was either change it or go the way of Corki. You would have done the same. What do you think of my new name? Huge improvement, right?$B$BBy the way, check the bulletin board if you\'re looking for work.','',26124),
(24173,'enUS','Dragonhawk incoming from the west!  Shoot that $c down!','',26124),
(24174,'enUS','Don\'t let that dragonhawk through!  Open fire!','',26124),
(24175,'enUS','Shattered Sun scum!  Fire at will!','',26124),
(24176,'enUS','We\'ve got your back, $n!','We\'ve got your back, $n!',26124),
(24177,'enUS','Move up and hit them from above.  Let\'s try to get $n some cover.','Move up and hit them from above.  Let\'s try to get $n some cover.',26124),
(24178,'enUS','It\'s showtime!  Blast them hard, blast them fast!','It\'s showtime!  Blast them hard, blast them fast!',26124),
(24179,'enUS','Something I can help you with? Looking for a pet pig, perhaps?','',26124),
(24180,'enUS','Golden Pig','Golden Pig',26124),
(24181,'enUS','Silver Pig','Silver Pig',26124),
(24182,'enUS','Fall into formation!  We\'re approaching the Dead Scar.','Fall into formation!  We\'re approaching the Dead Scar.',26124),
(24183,'enUS','Be quick with those charges.  Some of those demons are going to take more than one direct hit to bring down.','Be quick with those charges.  Some of those demons are going to take more than one direct hit to bring down.',26124),
(24184,'enUS','Keep your eye on the demons.  We\'re not concerned with killing Scourge today.','Keep your eye on the demons.  We\'re not concerned with killing Scourge today.',26124),
(24185,'enUS','Crush these stinking husks!','',26124),
(24186,'enUS','Smash them! Grind the bones into the dirt!','',26124),
(24187,'enUS','Harder, maggots! We must keep the sunwell clear for the master\'s return!','',26124),
(24188,'enUS','Burn their bodies, shred their skins, crush their creaking carapaces!','',26124),
(24189,'enUS','No horror here can compare with what you\'ll face when I\'m through with you!','',26124),
(24190,'enUS','Beat or be beaten! This is the way of the Legion!','',26124),
(24191,'enUS','Beat or be beaten! This is the way of the Legion!','',26124),
(24192,'enUS','I hear Pit Lords are born from maggots, Brutallus!','I hear Pit Lords are born from maggots, Brutallus!',26124),
(24193,'enUS','Big talk from a blue birdie! How about you come down and see if you can pluck this maggot from the dirt!','',26124),
(24194,'enUS','ATTENTION!','',26124),
(24195,'enUS','Hello to you new recruits. I\'m Drill Sergeant Bahduum. For the next few days, you\'re going to receive orientation.','',26124),
(24196,'enUS','The Isle of Quel\'Danas has been overrun by the forces of Prince Kael\'thas Sunstrider. Intel had him pegged as deceased. Intel was wrong.','',26124),
(24197,'enUS','Up on the plateau, he and his demon friends are trying to reignite the Sunwell and open a rift to bring their head-honcho, Kil\'Jaeden, back into the world.','',26124),
(24198,'enUS','Our job is to clear out as much of his fodder as we can, while supporting the specialists that the powers-that-be are having brought in.','',26124),
(24199,'enUS','Needless to say, a lot of us won\'t be going home. But if you remember your training and keep your wits about you, you\'ll greatly increase your chances.','',26124),
(24200,'enUS','That\'s all I have to say for now. Stay focused, boys and girls.','',26124),
(24201,'enUS','Golden Pig','Golden Pig',26124),
(24202,'enUS','Silver Pig','Silver Pig',26124),
(24203,'enUS','Come down! I tear your wings from your shoulders and feed you to the dirt. Then YOU be the maggot, dragon!','',26124),
(24204,'enUS','I prefer my meals a bit colder!','I prefer my meals a bit colder!',26124),
(24205,'enUS','Grraaarrr! You think to make an icicle out of me? Come down, then I will add real fire to your life.','',26124),
(24206,'enUS','What is this pathetic magic? How about you come back with twenty-four of your best friends and try again, $r!','',26124),
(24207,'enUS','Sir, we\'ve just flown in from the south. What are your orders?','Sir, we\'ve just flown in from the south. What are your orders?',26124),
(24208,'enUS','Yes, sir!','Yes, sir!',26124),
(24209,'enUS','Very good. Fall into formation with the rest of your squadron. There is work to be done.','',26124),
(24210,'enUS','Alright, quiet down. We have a lot to do and very little time to do it in, people.','',26124),
(24211,'enUS','I\'ve stood with some of you draenei before at Skettis, and others in Shadowmoon Valley. But now we\'re on Azeroth, and the situation looks grim.','',26124),
(24212,'enUS','First though, you sin\'dorei listen up. I run a tight ship... this isn\'t going to be like what you\'re used to with the Scryers. Pull your weight, or get back on the boat!','',26124),
(24213,'enUS','Now that that\'s out of the way, welcome to the Isle of Quel\'Danas. The Sunwell\'s on the plateau to the south, and Prince Kael\'thas is holed up in the Magisters\' Terrace to the east.','',26124),
(24214,'enUS','We\'re here as support for the so-called \'adventurers\' that the brass has called in. We\'ll help them hold the key points on the island, and keep the heat off so that they can do their jobs.','',26124),
(24215,'enUS','If none of you ladies have any questions, you can get further instructions and assignments from your squad leaders. That\'s it. Good luck!','',26124),
(24216,'enUS','Welcome to the Sunwell. Despite the mild temperatures and scenic vistas, you\'re not on vacation, ladies and gentlemen!','',26124),
(24217,'enUS','The current situation looks like this: we\'re holding what we can while those with more experience and better equipment are moving against Prince Kael\'thas.','',26124),
(24218,'enUS','I know, we thought he was dead too, but that\'s not the case. He\'s trying to use the Sunwell to bring the master of the Burning Legion, Kil\'Jaeden, into this world.','',26124),
(24219,'enUS','Let me assure you people that if he\'s successful, this world will suffer far worse than Outland ever did! So, let\'s make sure that doesn\'t come to pass.','',26124),
(24220,'enUS','Warriors will be deployed to hold key positions, while you marksmen will be assigned to keep the enemy fliers at bay.','',26124),
(24221,'enUS','I\'m awaiting orders on your specific assignments. In the meantime, stay here and be ready to move at a moment\'s notice!','',26124),
(24222,'enUS','What news of the fight to take the Sun\'s Reach Armory?','What news of the fight to take the Sun\'s Reach Armory?',26124),
(24223,'enUS','I am glad that you ask. Our efforts to take the armory are at $3233w percent of our projections.$B$BI know that Battlemage Arynna and Harbinger Inuuro need your help. Seek them inside the Sun\'s Reach Sanctum on the Isle of Quel\'Danas.','',26124),
(24224,'enUS','How close are we to the completion of the anvil and forge at the Sun\'s Reach Armory?','How close are we to the completion of the anvil and forge at the Sun\'s Reach Armory?',26124),
(24225,'enUS','Last I heard from Hauthaa, she indicated that we are $3228w percent of the way there.$B$BI cannot express how vital it is to our efforts that we get them created. Our men and women are going to need better armor and weapons, and the anvil and forge are the key to that.$B$BYou will find the smith behind the Sun\'s Reach Armory, $n.','',26124),
(24226,'enUS','I have something else to ask you about.','I have something else to ask you about.',26124),
(24227,'enUS','Exarch, have we taken the Sun\'s Reach Harbor yet?','Exarch, have we taken the Sun\'s Reach Harbor yet?',26124),
(24228,'enUS','No, unfortunately we have not yet taken the harbor. However, reports indicate that we are $3238w percent of the way towards doing so.$B$B$n, if you want to help out, look for Magister Ilastar and Vindicator Kaalan at the Sun\'s Reach Armory on the Isle of Quel\'Danas.','',26124),
(24229,'enUS','Nasuun, do you know how long until we have an alchemy lab at the Sun\'s Reach Harbor?','Nasuun, do you know how long until we have an alchemy lab at the Sun\'s Reach Harbor?',26124),
(24230,'enUS','The alchemy lab is not quite yet ready, $n. Mar\'nah says that she is $3223w percent done with its assembly, however.$B$BIf you would like to help her with that, you will find her inside the inn at the Sun\'s Reach Harbor.','',26124),
(24231,'enUS','What do you know about the magical gates at the Sunwell Plateau being brought down?','What do you know about the magical gates at the Sunwell Plateau being brought down?',26124),
(24232,'enUS','We are trying to bring Agamath, the First Gate down. Please, $c, go to the Isle of Quel\'Danas and help in any way that you can!','',26124),
(24233,'enUS','Agamath, the First Gate is breached and two of Kil\'jaeden\'s lieutenants, Lady Sacrolash and Grand Warlock Alythess, must be destroyed.$B$BGather your friends, $c, and see to it! Rohendor, the Second Gate is our next target.','',26124),
(24234,'enUS','Rohendor, the Second Gate has been brought down, but the last of the Sunwell Plateau\'s magical barriers, Archonisus, resists us, $n.$B$BMaintain your efforts to assist at the Sunwell in any way that you can.','',26124),
(24235,'enUS','We did it!  We survived another trip with our ship intact!  But that\'s no reason to slack off!  Push her hard until we dock!','',26124),
(24236,'enUS','','Prepare to dock!',26124),
(24237,'enUS','Full speed ahead Mister Copperbolt!','',26124),
(24238,'enUS','Take us out nice and fast Mister Copperpants.','',26124),
(24239,'enUS','Mister Copperpot, you may take us out.','',26124),
(24240,'enUS','Mister Coppertop... Punch it!','',26124),
(24241,'enUS','','Sir, my name is... Oh, never mind...',26124),
(24242,'enUS','','Mister Fairweather, slow ahead if you please!',26124),
(24243,'enUS','','By the way, my name is Coppernut, sir!',26124),
(24244,'enUS','','Close sir...',26124),
(24245,'enUS','','You almost got my name right that time, sir.',26124),
(24246,'enUS','','Sir, if you could at least get my gender correct...',26124),
(24247,'enUS','Should Kil\'jaeden rise up through the Sunwell our world will be thrown into a war the likes of which has not been seen for 10,000 years!\n','',26124),
(24248,'enUS','The first gate, Agamath, has been dismantled! The second gate of Rohendor now blocks our passage.$B$BOur mages are $3255w percent through the defenses of the second gate, Rohendor.','The first gate, Agamath, has been dismantled! The second gate of Rohendor now blocks our passage.$B$BOur mages are $3255w percent through the defenses of the second gate, Rohendor.',26124),
(24249,'enUS','Rohendor has been obliterated.  Only the gateway, Archonisus, remains.$B$BOur mages are $3257w percent through the defenses of the final gate, Archonisus.','',26124),
(24250,'enUS','Archonisus is no more. Alas, we are... we are too late...$B$BKil\'jaeden is unleashed! The heroes of the world are now our only hope.','',26124),
(24251,'enUS','Quickfix!!  We\'ve got our self a situation down here!!','',26124),
(24252,'enUS','Another successful trip!  Come on boys let\'s buzz the tower!','',26124),
(24253,'enUS','I can\'t believe how lucky we got on that trip!  I really am the greatest sky-captain in all the realms!','',26124),
(24254,'enUS','We\'re safe!  But we weren\'t going fast enough!  All I want to feel is the wind in my eyes!','',26124),
(24255,'enUS','','\"Iron Eagle.\" Hmph. It\'s a passenger ship, not a warbird! But hey, a job\'s a job, and I\'ll humor Captain \"Bombast\" so long as the prince is paying.$b$bIn any case, welcome aboard.',26124),
(24256,'enUS','Sorta busy.','Sorta busy.',26124),
(24257,'enUS','What? I\'m busy here.','What? I\'m busy here.',26124),
(24258,'enUS','On duty. GO. AWAY.','On duty. GO. AWAY.',26124),
(24259,'enUS','You need something fixed? Use the Vend-O-Tron D-Luxe.','You need something fixed? Use the Vend-O-Tron D-Luxe.',26124),
(24260,'enUS','We protect this airship on its way from Orgrimmar to Grom\'gol base camp in Stranglethorn Vale.','We protect this airship on its way from Orgrimmar to Grom\'gol base camp in Stranglethorn Vale.',26124),
(24261,'enUS','Not right now, $gpal:sugar;... I got things to do. See ya around.','',26124),
(24262,'enUS','I run the tightest airship in Azeroth. She used to be fitted with twin light cannons and enough bombs to flatten a city, you know... her mere shadow was enough to rout armies.$b$bWhat? Of course it\'s true!','',26124),
(24263,'enUS','%s transforms into a bear!','',26124),
(24264,'enUS','We\'ve almost consolidated our control over Sun\'s Reach.  If we manage to keep the harbor from getting any reinforcements we will certainly succeed.$B$BWe are $3238w percent done with our goal.','',26124),
(24266,'enUS','We\'ve done it, $n.  With Sun\'s Reach under our control we are but mere moments away from absolute victory.','',26124),
(24267,'enUS','','I\'m gathering funds to build a monument in honor of those who\'ve died in the war.  It is important to not forget the sacrifices we\'ve made to achieve victory.$B$BWe are $3275w percent done with this goal.',26124),
(24268,'enUS','','Isn\'t the memorial beautiful?  It is important to remember moments in our history when great sacrifices are made, lest we forget the price of all wars - even ones that are won.',26124),
(24269,'enUS','I\'m going to take a short nap.  Do you think you can handle the ship while she\'s not moving?','',26124),
(24270,'enUS','Alright, give me a second to get my bearings...','',26124),
(24271,'enUS','It\'s go time!','',26124),
(24272,'enUS','Time to get this show on the road!','',26124),
(24273,'enUS','Time to work my magic!','',26124),
(24274,'enUS','Go ahead, I can handle this part.','',26124),
(24275,'enUS','HELP ME!  WE ARE LEAVING!','',26124),
(24276,'enUS','WAKE UP!!  WE ARE SHOVING OFF!','',26124),
(24277,'enUS','NAP\'S OVER!! WE ARE HEADING OUT!','',26124),
(24278,'enUS','If you really want to get past those doors you\'ll lend me the strength of at least three people! Follow me!','',26124),
(24279,'enUS','','%s clears her throat loudly.',26124),
(24280,'enUS','','Watcher, we have docked.  On your feet!',26124),
(24281,'enUS','','Is your job so hard that you don\'t even have the energy to stand at the ready when we dock?  I gave you this post as a favor to your family.  Don\'t make me regret that decision.',26124),
(24282,'enUS','','Welcome aboard $c.  Take a load off and enjoy the trip.  Aboard \"The Purple Princess\" we want you to relax.  We have vending machines down below if there\'s anything you might need while aboard.',26124),
(24283,'enUS','Relaxation is the key to being an efficient crew.  Let the crew relax, and they\'ll perform better.','',26124),
(24284,'enUS','The captain\'s great!  We get time to relax when we dock.  Those are the times I look forward to the most.','',26124),
(24285,'enUS','Please allow me a few seconds of rest.','',26124),
(24286,'enUS','Let me sleep just five more minutes, mon...','',26124),
(24287,'enUS','I\'m busy right now.','I\'m busy right now.',26124),
(24288,'enUS','You need something fixed? Use the Vend-O-Tron.','You need something fixed? Use the Vend-O-Tron.',26124),
(24289,'enUS','I don\'t have time to talk right now.','I don\'t have time to talk right now.',26124),
(24290,'enUS','','The flight from Grom\'gol to Undercity is beautiful, though uneventful.  Though that is no excuse to fall asleep on the job.',26124),
(24291,'enUS','If my calculations are correct, banging on this gong will bring down that door. It\'s crazy, I know, but to be totally honest with you, I think it\'s an idea that might be ahead of its time!','',26124),
(24292,'enUS','','',26124),
(24293,'enUS','Come in out of the ash and muck. Dry yourself a spell.','',26124),
(24294,'enUS','Suit yourself. At least three of you must assist me if we\'re to get inside. Follow me....','',26124),
(24295,'enUS','According to my calculations, if enough of us bang the gong at once the seal on these doors will break and we can enter.','',26124),
(24296,'enUS','Cold feet, I assume. Probably better this way - nothing but death in there for the likes of you....','',26124),
(24297,'enUS','The Tauren Chieftains are staying in Silvermoon while I arrange their next tour. They often lounge on the balcony above me when they\'re not practicing. Feel free to wave... they love the attention.\n\nWe\'re not currently hiring for the show or the crew, but you can always check back later. Who knows what will arise?','',26124),
(24298,'enUS','Did you manage to see their show in Terokkar Forest? It was amazing!','Did you manage to see their show in Terokkar Forest? It was amazing!',26124),
(24299,'enUS','The Tauren Chieftains must be the best-known minstrels in all of Azeroth!','The Tauren Chieftains must be the best-known minstrels in all of Azeroth!',26124),
(24300,'enUS','I wonder how much longer they\'ll be in Silvermoon City. I hope they play here!','I wonder how much longer they\'ll be in Silvermoon City. I hope they play here!',26124),
(24301,'enUS','I\'d give nearly anything for a chance to go up there and speak with them...','I\'d give nearly anything for a chance to go up there and speak with them...',26124),
(24302,'enUS','','Do not fight the enemy unprepared, $n.  I can provide you with very powerful items... provided you have proven yourself to us.',26124),
(24303,'enUS','Kael\'s lackeys are about to be taught a lesson in humility.  We will crush the Dawnblade army and take Sun\'s Reach Harbor from them.$B$BWe are $3238w percent done with our goal.','',26124),
(24304,'enUS','Sun\'s Reach is ours.  Kael\'s dogs are on the run... it is time to put them out of their misery!','',26124),
(24305,'enUS','I\'m in charge of the workers that support the Tauren Chieftains.\n\nYou know: packing, driving, and unpacking the wagons, building and taking down the stage, setting up the pyrotechnics, all that sort of thing.','',26124),
(24306,'enUS','Schweitzer here is an old friend of mine... a valuable thing, that. Friendship, I mean. I thought I\'d forgotten the feeling until we met again in Shattrath City.\n\nHe\'s not in Tirisfal so much these days, so I thought I\'d take the Orb of Translocation here to give my hellos.','',26124),
(24307,'enUS','Mmrrglglglg? Glbmr brmmrggl glmrrbmrgl.$B$BGrglgrlbrr mrgl!!!','',26124),
(24308,'enUS','<Ahlurglgr looks surprised to be able to understand you.>','',26124),
(24309,'enUS','','Easy boy.  $n is here to help, $ghe:she;\'s not with the demons.',26124),
(24310,'enUS','Together we will fight our way out of here. Are you ready?','',26124),
(24311,'enUS','Then we leave!','',26124),
(24312,'enUS','This is far enough. I can make it on my own from here.','',26124),
(24313,'enUS','Thank you for rescuing me, $r. Please tell the king that I am back.','',26124),
(24314,'enUS','Hey you, stranger, come here!','',26124),
(24315,'enUS','If only there were someone nearby who would help me escape.','',26124),
(24316,'enUS','You can\'t hold me against my will! You\'ve all been brainwashed!','',26124),
(24317,'enUS','Living in these caverns and following that mad lobstrok, Clacker, is unnatural! Let me free!','',26124),
(24318,'enUS','Glrggg mbrrgl! Brmlgr glgglg uhmrgl grbmr.','',26124),
(24319,'enUS','Blrggl glbmrlgl grggl mrggl!','',26124),
(24320,'enUS','Grgggl! Glmrbrgl Uhglrglrglr!','',26124),
(24321,'enUS','Whatchoo been doin\', pacin\' yourselves?','',26124),
(24322,'enUS','Grglmbrgl? Mrgl glbmrgl rawglgl!','',26124),
(24323,'enUS','I hope I have a chance to visit with Greatfather Winter before Winter Veil is over.','I hope I have a chance to visit with Greatfather Winter before Winter Veil is over.',26124),
(24324,'enUS','The goblins of Smokywood Pastures always have such wonderful treats for sale this time of year.','The goblins of Smokywood Pastures always have such wonderful treats for sale this time of year.',26124),
(24325,'enUS','Where are all those wonderful winter hats coming from?','Where are all those wonderful winter hats coming from?',26124),
(24326,'enUS','The Dark Portal opens once again! What does it portend?','The Dark Portal opens once again! What does it portend?',26124),
(24327,'enUS','The Burning Legion has returned! What can we do to stop them?','The Burning Legion has returned! What can we do to stop them?',26124),
(24328,'enUS','The armies of the Burning Legion are attacking all across Azeroth. We need heroes to throw them back!','The armies of the Burning Legion are attacking all across Azeroth. We need heroes to throw them back!',26124),
(24329,'enUS','Happy Hallow\'s End!','Happy Hallow\'s End!',26124),
(24330,'enUS','I think I\'ve eaten too much candy...','I think I\'ve eaten too much candy...',26124),
(24331,'enUS','We should go trick or treating later.','We should go trick or treating later.',26124),
(24332,'enUS','Legend says that the great beast Omen sleeps in the waters of Lake Elune\'ara in Moonglade, only to appear once a year. But that\'s just a legend.','Legend says that the great beast Omen sleeps in the waters of Lake Elune\'ara in Moonglade, only to appear once a year. But that\'s just a legend.',26124),
(24333,'enUS','During the Lunar Festival, we should take time to seek out our elders and consider their wisdom.','During the Lunar Festival, we should take time to seek out our elders and consider their wisdom.',26124),
(24334,'enUS','Have you seen the fireworks? This is the best time of year to buy them.','Have you seen the fireworks? This is the best time of year to buy them.',26124),
(24335,'enUS','The druids of Nighthaven are holding a great celebration in Moonglade for the Lunar Festival.','The druids of Nighthaven are holding a great celebration in Moonglade for the Lunar Festival.',26124),
(24336,'enUS','Next year, I\'m dressing up as either a corsair or an assassin.','Next year, I\'m dressing up as either a corsair or an assassin.',26124),
(24337,'enUS','What do you think of the mask?','What do you think of the mask?',26124),
(24338,'enUS','Next year, I\'m dressing up as either a corsair or an assassin.','Next year, I\'m dressing up as either a corsair or an assassin.',26124),
(24339,'enUS','What do you think of the mask?','What do you think of the mask?',26124),
(24340,'enUS','I hope I have a chance to visit with Greatfather Winter before Winter Veil is over.','I hope I have a chance to visit with Greatfather Winter before Winter Veil is over.',26124),
(24341,'enUS','The goblins of Smokywood Pastures always have such wonderful treats for sale this time of year.','The goblins of Smokywood Pastures always have such wonderful treats for sale this time of year.',26124),
(24342,'enUS','Where are all those wonderful winter hats coming from?','Where are all those wonderful winter hats coming from?',26124),
(24343,'enUS','The Dark Portal opens once again! What does it portend?','The Dark Portal opens once again! What does it portend?',26124),
(24344,'enUS','The Burning Legion has returned! What can we do to stop them?','The Burning Legion has returned! What can we do to stop them?',26124),
(24345,'enUS','The armies of the Burning Legion are attacking all across Azeroth. We need heroes to throw them back!','The armies of the Burning Legion are attacking all across Azeroth. We need heroes to throw them back!',26124),
(24346,'enUS','Happy Hallow\'s End!','Happy Hallow\'s End!',26124),
(24347,'enUS','I think I\'ve eaten too much candy...','I think I\'ve eaten too much candy...',26124),
(24348,'enUS','We should go trick or treating later.','We should go trick or treating later.',26124),
(24349,'enUS','Legend says that the great beast Omen sleeps in the waters of Lake Elune\'ara in Moonglade, only to appear once a year. But that\'s just a legend.','Legend says that the great beast Omen sleeps in the waters of Lake Elune\'ara in Moonglade, only to appear once a year. But that\'s just a legend.',26124),
(24350,'enUS','During the Lunar Festival, we should take time to seek out our elders and consider their wisdom.','During the Lunar Festival, we should take time to seek out our elders and consider their wisdom.',26124),
(24351,'enUS','Have you seen the fireworks? This is the best time of year to buy them.','Have you seen the fireworks? This is the best time of year to buy them.',26124),
(24352,'enUS','The druids of Nighthaven are holding a great celebration in Moonglade for the Lunar Festival.','The druids of Nighthaven are holding a great celebration in Moonglade for the Lunar Festival.',26124),
(24353,'enUS','The best defense is a good offense; anyone can tell you that.','',26124),
(24354,'enUS','','A strong weapon is no good if you don\'t live long enough to wield it, $c.',26124),
(24355,'enUS','Gawurgggl! Blrgl-brgl grgl!','',26124),
(24356,'enUS','You have learned a trick to speak with us, $r, but I am not impressed.$B$BThere are Winterfin betrayers across the water that need killing.','',26124),
(24357,'enUS','Next!','',26124),
(24358,'enUS','Yeah.  We could use some more of you.  Report to the civilian liaison for work assignment.','',26124),
(24359,'enUS','I do have some openings in your line of work.  Report to the civilian liaison.','',26124),
(24360,'enUS','I thought we had enough in your line of work, but it looks like we have some openings.  Report to the civilian liaison.','',26124),
(24361,'enUS','Yes, you\'re well seasoned in your field of work.  Report to the civilian liaison at once, we need more like you!','',26124),
(24362,'enUS','I\'m not blind, you know. I can see what\'s going on around here!','',26124),
(24363,'enUS','Not anymore!  Here\'s your sword.  Report to the barracks for duty!','',26124),
(24364,'enUS','Ahglrglglrglgrrr!','',26124),
(24365,'enUS','Afraid not, friend.  Here\'s your sword and shield.  Report to the barracks for duty.','',26124),
(24366,'enUS','With a sword arm like that?  I\'m afraid we need you in the front lines, my friend.  Report to the barracks.','',26124),
(24367,'enUS','You\'re breaking my heart - I\'ve quotas to fill, you know?  Can you wield a sword?  Off to the barracks.','',26124),
(24368,'enUS','Looks like we have room for one more... no, my mistake.  That\'s a seven not a one.  Hope you\'re good with a sword - report to the barracks.','',26124),
(24369,'enUS','Keep it moving, people.','',26124),
(24370,'enUS','Next, please!','',26124),
(24371,'enUS','Carpenter, sir.','Carpenter.',26124),
(24372,'enUS','Shipwright, sir.','Shipwright.',26124),
(24373,'enUS','Farmhand, m\'lord.','Farmhand, sir.',26124),
(24374,'enUS','Tailor.','Seamstress, m\'lord.',26124),
(24375,'enUS','Blacksmith.','Blacksmith.',26124),
(24376,'enUS','Mason, sir.','Mason, sir.',26124),
(24377,'enUS','Miner.','Miner, sir.',26124),
(24378,'enUS','Cook.','Cook, sir.',26124),
(24379,'enUS','I recently came here to observe the Winterfin murlocs. Disguised as one of them, I kept my distance and took notes on their day-to-day life.$B$BHowever, not long after I arrived, that all changed.$B$BAn earthquake in Coldarra caused a landslide, which exposed the nearby caverns. Out came a strange makrura who stole away with the Winterfins\' tadpoles. When the murlocs went into the caverns to rescue their young, they re-emerged, glowing and under the makrura\'s influence.$B$BNow the unaffected have retreated to here, and I have reluctantly assumed their leadership.','',26124),
(24380,'enUS','King Mrgl-Mrgl, I somehow misplaced your spare murloc outfit. I\'m sorry.','King Mrgl-Mrgl, I somehow misplaced your spare murloc outfit. I\'m sorry.',26124),
(24381,'enUS','Not to worry, $n, one of the gatherers found the outfit where you accidentally dropped it.$B$BHere, take it, but please be more careful. I\'d hate for you to have to fight your way to Claximus and kill more of the Winterfin murlocs unnecessarily along the way.','',26124),
(24382,'enUS','State your profession.','',26124),
(24383,'enUS','Yes, then.  What is your trade?','',26124),
(24384,'enUS','Your profession?','',26124),
(24385,'enUS','Your previous line of work, recruit?','',26124),
(24386,'enUS','What did you do before you came to Northrend, then?','',26124),
(24387,'enUS','Blurg awrurgle mrr?','',26124),
(24388,'enUS','My brothers and sisters have gone insane! Do you think you could help me get out of here?','',26124),
(24389,'enUS','Glug bmrgl grggl!','',26124),
(24390,'enUS','No time to talk -- I have work to do!','',26124),
(24391,'enUS','You can understand me? I can understand you!','',26124),
(24392,'enUS','$R, why would I want to talk to you? Your people probably caused this mess in the first place!','',26124),
(24393,'enUS','There are clams to be collected and orcas to be killed. Help or stay out of the way!','',26124),
(24394,'enUS','Blurglgr murbrgl... just kidding, I can understand you.','',26124),
(24395,'enUS','You figure out yet why our brothers and sisters over in the village have gone insane?','',26124),
(24396,'enUS','I knew that we never should have gone into those caves. It\'s not natural!','',26124),
(24397,'enUS','There\'s something fishy about new King Mrgl-Mrgl, but I can\'t quite put my finger on it.','',26124),
(24398,'enUS','Mawurrgggl, gurgl lur!','',26124),
(24399,'enUS','Glumrggl?','',26124),
(24400,'enUS','Brggl-brggl Mrgl-Mrgl! Gluk!','',26124),
(24401,'enUS','Blrmrrgl gulrgl grr.','',26124),
(24402,'enUS','RAWGRLRLRLRRLGLRL!!!','',26124),
(24403,'enUS','Mrglrglrglrgl... glrgl?','',26124),
(24404,'enUS','Mrglmrgl Glrggl!','',26124),
(24405,'enUS','So I heard your brother joined the Scryers?','So I heard your brother joined the Scryers?',26124),
(24406,'enUS','Yeah, he did.','Yeah, he did.',26124),
(24408,'enUS','Wow, how much do they pay?','Wow, how much do they pay?',26124),
(24409,'enUS','Pay? Well, they don\'t pay anything at all.','Pay? Well, they don\'t pay anything at all.',26124),
(24410,'enUS','What? Why would he do a fool thing like that?','What? Why would he do a fool thing like that?',26124),
(24411,'enUS','I don\'t know, survival of his race, visions of the future, valiant deeds, blah, blah, blah.','I don\'t know, survival of his race, visions of the future, valiant deeds, blah, blah, blah.',26124),
(24412,'enUS','Sounds like a bunch of rotten Hawkstrider eggs to me.','Sounds like a bunch of rotten Hawkstrider eggs to me.',26124),
(24413,'enUS','Yeah, I could never do that. The pay\'s too good here.','Yeah, I could never do that. The pay\'s too good here.',26124),
(24414,'enUS','Yeah. I hope to retire next month to a little tract of land I bought off the coast of Azeroth.','Yeah. I hope to retire next month to a little tract of land I bought off the coast of Azeroth.',26124),
(24415,'enUS','Nice. Now that\'s the life...','Nice. Now that\'s the life...',26124),
(24416,'enUS','How long until Lord Kael\'thas reignites the sunwell?','How long until Lord Kael\'thas reignites the sunwell?',26124),
(24417,'enUS','Soon. I hear he has gathered the most powerful casters in Outland together to help perform the summoning.','Soon. I hear he has gathered the most powerful casters in Outland together to help perform the summoning.',26124),
(24418,'enUS','Truly, the Sin\'dorei are the greatest of races.','Truly, the Sin\'dorei are the greatest of races.',26124),
(24419,'enUS','Yes, we shall ascend beyond the mere trappings of our mortal coil and attain the power that were promised to us by Sargeras so long ago.','Yes, we shall ascend beyond the mere trappings of our mortal coil and attain the power that were promised to us by Sargeras so long ago.',26124),
(24420,'enUS','These foolish mortal races will soon see our power.','These foolish mortal races will soon see our power.',26124),
(24421,'enUS','For Kael\'thas and the Burning Legion!','For Kael\'thas and the Burning Legion!',26124),
(24422,'enUS','For Kael\'thas and the Legion!','For Kael\'thas and the Legion!',26124),
(24423,'enUS','','Shadow to the aid of fire!',26124),
(24424,'enUS','','Sacrolash directs Shadow Nova at $n.',26124),
(24425,'enUS','Charge!','',26124),
(24426,'enUS','','Alythess directs Conflagration at $n.',26124),
(24427,'enUS','Good girl, good girl. You just say right here and eat.','',26124),
(24428,'enUS','There, $n, now you will be able to speak with, and understand, the Winterfin murlocs.','',26124),
(24429,'enUS','My brothers have awoken. Your efforts are wasted...\n','',26124),
(24430,'enUS','Your offering has come too late, little one. Can you feel the mist closing in upon you? The Kvaldir return...','',26124),
(24431,'enUS','%s laughs.\n','',26124),
(24432,'enUS','Look to the seas, as your doom comes with the swell of tides.\n','',26124),
(24433,'enUS','From the mist and fog the Kvaldir approach. Flee while you still breathe the air of the living...','',26124),
(24434,'enUS','I am Atuik, chieftain of the Kalu\'ak of Kamagua.','',26124),
(24435,'enUS','What tiny morsel comes this way? Not one of the murloc I think.','',26124),
(24436,'enUS','It\'s been a long time since last I tasted $r.','',26124),
(24437,'enUS','What\'s this? You\'re not one of the Winterfin!','',26124),
(24438,'enUS','Did \'King Mrgl-Mrgl\' send you? I know what he truly is!','',26124),
(24439,'enUS','','We\'re running low on iron, lads!  I don\'t want to see a single bar go to waste, ye hear me now?',26124),
(24440,'enUS','','Oi!  Who\'s been using up all the tin?  Don\'t think just because I\'m a lass I won\'t kick yer behind for wasting materials!',26124),
(24441,'enUS','','Nice work so far.  The recruits keep on coming and they\'re all going to need new blades.  Keep it up!',26124),
(24442,'enUS','','These look good.  Nice work.',26124),
(24443,'enUS','','Not bad.  Try that trick I told you about when you temper the steel.',26124),
(24444,'enUS','','This won\'t do; it\'ll be brittle once it cools off.  Smelt the metal, we\'ll use it for ammunition.',26124),
(24445,'enUS','','Now that\'s what I call craftsmanship.  You\'ll have to show me how you did this.  Promise?',26124),
(24446,'enUS','$G Da-da : Ma-ma;?','',26124),
(24447,'enUS','Alurglgl.','',26124),
(24448,'enUS','Me go home?','',26124),
(24449,'enUS','Play!','',26124),
(24450,'enUS','Psst... $r, over here! Next to the dead whale.','',26124),
(24451,'enUS','Kael\'thas and his felbloods be damned! All we\'ve worked for is gone, but they\'re fools to think we won\'t fight back. Already, Lady Liadrin seeks a new source of power for our order. We will not be destroyed so easily.','',26124),
(24452,'enUS','','Alythess! Your fire burns within me!',26124),
(24453,'enUS','<The dragonhawk appears to be unsettled by the commotion in the surrounding area.>','',26124),
(24454,'enUS','Close!','',26124),
(24455,'enUS','No go with stranger!','',26124),
(24456,'enUS','Eww... $r!','',26124),
(24457,'enUS','You not $g da-da : ma-ma;!','',26124),
(24458,'enUS','The razing of Orgrimmar was not just an attack against orcs, it was an affront to the Horde. An assault against our very existence!$B$BThe Lich King sought to sow the seeds of fear.$B$BThis...$B$B<Garrosh points to the fortified walls that surround him.>$B$BThis is the result of Arthas\'s campaign.$B$BThe Horde fears nothing...\n','',26124),
(24459,'enUS','<Ride the dragonhawk to Sun\'s Reach.>','<Ride the dragonhawk to Sun\'s Reach.>',26124),
(24460,'enUS','You\'re not one of mine. King Mrgl-Mrgl must have sent you to talk terms of surrender. Come closer so that I might see you better.','',26124),
(24461,'enUS','Why do you suffer the presence of this despicable Lady Liadrin? She and her followers distort the Light and make a mockery of all we stand for!','',26124),
(24462,'enUS','Patience, general. The Light embraces all who enter Shattrath in good faith.','',26124),
(24463,'enUS','You are welcome in Shattrath, Lady Liadrin. We have long awaited your arrival.','',26124),
(24464,'enUS','','Thank you for allowing me to speak, A\'dal. I know many of your allies despise me and my knights for our treatment of M\'uru.',26124),
(24465,'enUS','','I\'ve come to realize our path was a false one. We were betrayed by the man we called our prince. In his lust for power, he sent the felblood to attack us, and to spirit M\'uru away to the Sunwell.',26124),
(24466,'enUS','Both our peoples have suffered greatly at the hands of Kael\'thas and his agents, Lady Liadrin. Your people were not the authors of their own fate, but they will die if they do not change.','',26124),
(24467,'enUS','M\'uru accepted his role in this long ago, knowing full well what would happen to him. Will you accept your own?','',26124),
(24468,'enUS','','I... I don\'t understand. You -- and M\'uru -- knew all along that this would occur?',26124),
(24469,'enUS','It wasn\'t I who foretold it, but Velen of the Draenei:','',26124),
(24470,'enUS','\'Silvery moon, washed in blood,\'','',26124),
(24471,'enUS','\'Led astray into the night, armed with sword of broken Light.\'','',26124),
(24472,'enUS','\'Broken, then betrayed by one, standing there bestride the sun.\'','',26124),
(24473,'enUS','\'At darkest hour, redemption comes, in knightly lady sworn to blood.\'','',26124),
(24474,'enUS','','I see it clearly now. I renounce my loyalties to House Sunstrider and its false prince.',26124),
(24475,'enUS','One last drink before we head to the front?','',26124),
(24476,'enUS','Sure, why not?','',26124),
(24477,'enUS','','We will fight beside you, A\'dal.',26124),
(24478,'enUS','Barkeep!  Bring out your strongest ale.  We\'re off to the front.','',26124),
(24479,'enUS','You\'ll surely make an exception for us, eh?  We might not come back.','',26124),
(24480,'enUS','The Shattered Sun Offensive will surely benefit from the addition of your knights, Lady Liadrin.','',26124),
(24481,'enUS','The battle for the Sunwell is but the first step on your new path, Lady Liadrin. Shattrath is open to you and all who follow you.','',26124),
(24482,'enUS','I guess that\'s it then.  Off we go.','',26124),
(24483,'enUS','That was the worst beer I\'ve ever had.','',26124),
(24484,'enUS','','I pledge the blades of my Blood Knights to the defeat of Kil\'jaeden and the restoration of Silvermoon.\n',26124),
(24485,'enUS','','When he was given to us by \'Prince\' Kael\'thas, we believed his power would help us lead our people into a new age.',26124),
(24486,'enUS','We are surrounded... Our enemies press in from all sides, young Hellscream.','',26124),
(24487,'enUS','The Scourge descends like locust from the north.','',26124),
(24488,'enUS','The Alliance holds the only secure shipping lane in this region, and even that is at risk of being lost to those dreaded mists.','',26124),
(24489,'enUS','Our only viable port for resupply is held by the Forsaken on the other side of this blasted continent!','',26124),
(24490,'enUS','Anything our zeppelins cannot haul must be brought in by ship and travel the length of Northrend to reach us.','',26124),
(24491,'enUS','%s grunts.','',26124),
(24492,'enUS','Shipping lanes... supplies... You bore me to death! We need nothing more than the warrior spirit of the Horde, Saurfang! Now that we are firmly entrenched in this frozen wasteland, nothing shall stop us!','',26124),
(24493,'enUS','Siege engines, ammunition, heavy armor... How do you propose to shatter the walls of Icecrown without those?','',26124),
(24494,'enUS','Propose? I will show you what I propose!','',26124),
(24495,'enUS','There... Now we now have a shipping lane.','',26124),
(24496,'enUS','And just for good measure...','',26124),
(24497,'enUS','So the prodigal son has spoken!','',26124),
(24498,'enUS','Your father\'s blood runs strong in you, Hellscream. Impatient as always... Impatient and reckless.','',26124),
(24499,'enUS','Interested in learning about inscription?','Interested in learning about inscription?',26124),
(24500,'enUS','You rush headlong into all-out war without a thought of the consequences.','',26124),
(24501,'enUS','Do not speak to me of consequences, old one. ','',26124),
(24502,'enUS','I drank of the same blood your father did, Garrosh. Mannoroth\'s cursed venom pumped through my veins as well.','',26124),
(24503,'enUS','I drove my weapons into the bodies and minds of my enemies.','',26124),
(24504,'enUS','And while Grom died a glorious death - freeing us all from the blood curse - he could not wipe away the terrible memory of our past.','',26124),
(24505,'enUS','His act could not erase the horrors we committed. ','',26124),
(24506,'enUS','%s pauses.','',26124),
(24507,'enUS','The winter after the curse was lifted, hundreds of veteran orcs like me were lost to despair.','',26124),
(24508,'enUS','Our minds were finally free, yes... Free to relive all of the unthinkable acts that we had performed under the Legions\' influence.','',26124),
(24509,'enUS','%s nods.','',26124),
(24510,'enUS','I think it was the sounds of the draenei children that unnerved most of them... You never forget...','',26124),
(24511,'enUS','Have you ever been to Jaggedswine Farm? When the swine are of age for the slaughter... It\'s that sound. The sound of the swine being killed... It resonates the loudest. Those are hard times for us older veterans.','',26124),
(24512,'enUS','But surely you cannot think that those children were born into innocence? They would have grown up and taken arms against us!','',26124),
(24513,'enUS','%s shakes his head.','',26124),
(24514,'enUS','%s looks grimly at Garrosh.','',26124),
(24515,'enUS','I am not speaking solely of the children of our enemies...','',26124),
(24516,'enUS','I won\'t let you take us down that dark path again, young Hellscream. I\'ll kill you myself before that day comes...','',26124),
(24517,'enUS','%s returns to his post.','',26124),
(24518,'enUS','How have you managed to survive for so long, Saurfang? Not fallen victim to your own memories?','',26124),
(24519,'enUS','I don\'t eat pork...','',26124),
(24520,'enUS','%s spits.','',26124),
(24521,'enUS','Aye, solja! Lift off time!','',26124),
(24522,'enUS','Yes sir!','Yes sir!',26124),
(24523,'enUS','Horde bonfire.','Horde bonfire.',26124),
(24524,'enUS','You\'ve reached a Horde bonfire! Desecrate this bonfire and stamp it out!','',26124),
(24525,'enUS','Cel\'s got what you need, friend.','',26124),
(24526,'enUS','Stamp out the Horde bonfire!','Stamp out the Horde bonfire!',26124),
(24527,'enUS','Alliance bonfire.','Alliance bonfire.',26124),
(24528,'enUS','The Midsummer Fire Festival has something for everyone to enjoy!','The Midsummer Fire Festival has something for everyone to enjoy!',26124),
(24529,'enUS','You\'ve reached an Alliance bonfire! Desecrate this bonfire and stamp it out!','',26124),
(24530,'enUS','Stamp out the Alliance bonfire!','Stamp out the Alliance bonfire!',26124),
(24531,'enUS','The Horde have tried to steal our flames.  I hope we return the favor.','The Horde have tried to steal our flames.  I hope we return the favor.',26124),
(24532,'enUS','The Alliance fires burn strong and true!','The Alliance fires burn strong and true!',26124),
(24533,'enUS','I\'d like to see the Alliance try to steal our flame.','I\'d like to see the Alliance try to steal our flame.',26124),
(24534,'enUS','The Horde fires will never be extinguished!','The Horde fires will never be extinguished!',26124),
(24535,'enUS','Midsummer Fire Festival is a great time to celebrate the summer!','Midsummer Fire Festival is a great time to celebrate the summer!',26124),
(24536,'enUS','I love the firework show at the end of Midsummer Firefestival.','I love the firework show at the end of Midsummer Firefestival.',26124),
(24537,'enUS','Fear has always been our greatest weapon. Entire wars have been won and lost upon the shifting shoulders of trepidation and doubt. So how, then, does one fight an enemy that knows no fear?$B$B<Saurfang shakes his head.>$B$BWe do not just fight the Scourge in Northrend, we fight to gain control of our senses before they tear us apart...\n','',26124),
(24538,'enUS','We need to get this outpost ready for the push into Sholazar Basin.$B$BDon\'t just stand there, $c. Go out and represent the Horde with honor and spilled blood!','',26124),
(24540,'enUS','','I have to clean up this mess, but I\'ll do it without complaint.$B$BYou\'ll help if you have any Horde pride at all!',26124),
(24541,'enUS','It\'s... too late for me....','It\'s... too late for me....',26124),
(24542,'enUS','Avenge me....','Avenge me....',26124),
(24543,'enUS','Avenge me....','Avenge me....',26124),
(24544,'enUS','Thank you, $r. I shall not forget your kindness.','Thank you, $r. I shall not forget your kindness.',26124),
(24545,'enUS','You\'ve saved me, $c. Thank you!','You\'ve saved me, $c. Thank you!',26124),
(24546,'enUS','Thank you, $r. Without your help I would have become one of them!','Thank you, $r. Without your help I would have become one of them!',26124),
(24547,'enUS','','The spirits speak all around us. Are you listening, $r?',26124),
(24548,'enUS','%s takes a deep breath.','%s takes a deep breath.',26124),
(24549,'enUS','Here lies the corpse of one of the Steeljaw\'s caravan guards.','Here lies the corpse of one of the Steeljaw\'s caravan guards.',26124),
(24550,'enUS','Here lies the corpse of one of the Steeljaw\'s caravan workers.','Here lies the corpse of one of the Steeljaw\'s caravan workers.',26124),
(24551,'enUS','The Twilight Cult seeks to undo everything we fight to preserve. It is our sworn duty to prevent this calamity from coming to pass, $r.','The Twilight Cult seeks to undo everything we fight to preserve. It is our sworn duty to prevent this calamity from coming to pass, $r.',26124),
(24552,'enUS','Lords, be on your guard! The Horde plan to breach our defenses and stop the ceremony!','',26124),
(24553,'enUS','What was your commander thinking? Taking your caravan through our sacred burial grounds!','',26124),
(24554,'enUS','Your Steeljaw is now haunting this place... I can feel it.','',26124),
(24555,'enUS','Do what you must to quell the restless spirits, Ragefist.','',26124),
(24556,'enUS','It is worth all of our lives to eliminate the spirit of your fallen commander.','',26124),
(24557,'enUS','The spirits of the taunka will not rest until Steeljaw is dealt with.','',26124),
(24558,'enUS','This is not a good start to relations between my people and your Horde.','',26124),
(24559,'enUS','When we move, we\'ll move fast. Be prepared to put to rest anything that gets in our way.','',26124),
(24560,'enUS','Your overlord promised me help. Where is this important person he intends to send?','',26124),
(24561,'enUS','$n is going to join us on our assault. Let us bring peace to my ancestors!','',26124),
(24562,'enUS','WE STRIKE!','',26124),
(24563,'enUS','An ambush. Return them to their rest!','',26124),
(24564,'enUS','Regain your strength. The place where Steeljaw was felled is just ahead.','',26124),
(24565,'enUS','There\'s the dog\'s banner and there\'s his corpse. What\'s that? He\'s upon us!','',26124),
(24566,'enUS','You fought well. Now go north to your orc outpost and inform Overlord Bor\'gorok of our success!','',26124),
(24567,'enUS','Free my soul if you can, cur!','',26124),
(24575,'enUS','I\'m freed! Thank you.','',26124),
(24579,'enUS','I am dishonored. I should have died with the farseer at Magmoth.$B$BLeave me to my thoughts.','',26124),
(24580,'enUS','The element of air here is restless. Beware... they will not let you pass unharmed.','',26124),
(24581,'enUS','Yes, yes, very good...','Yes, yes, very good...',26124),
(24582,'enUS','The Blood Prince should be very pleased with these...','The Blood Prince should be very pleased with these...',26124),
(24583,'enUS','This one looks a little fragile... well, no matter...','This one looks a little fragile... well, no matter...',26124),
(24584,'enUS','Perhaps we shall need more...','Perhaps we shall need more...',26124),
(24585,'enUS','Destroying','Destroying',26124),
(24586,'enUS','What is the meaning of this?! I have not yet finished my feast!','What is the meaning of this?! I have not yet finished my feast!',26124),
(24587,'enUS','We shall be needing more blood for the master soon...','We shall be needing more blood for the master soon...',26124),
(24588,'enUS','Ah, yes, it is almost time for the master\'s dinner...','Ah, yes, it is almost time for the master\'s dinner...',26124),
(24589,'enUS','Reading','Reading',26124),
(24590,'enUS','%s armed.','',26124),
(24591,'enUS','Detonation in 5...','',26124),
(24592,'enUS','4...','',26124),
(24593,'enUS','3...','',26124),
(24594,'enUS','2...','',26124),
(24595,'enUS','1...','',26124),
(24596,'enUS','Thank you for freeing me! May the tides always favor you.','',26124),
(24597,'enUS','You have my gratitude, $c. I thought I\'d never be free.','',26124),
(24598,'enUS','Do not allow Kaskala to forget what has happened here.','',26124),
(24599,'enUS','Thank you, $c. May the winds and seas always deliver you safely.','',26124),
(24600,'enUS','The people of Kaskala are in your debt, $c.','',26124),
(24601,'enUS','May the ancestors always aid you, $c, as you have aided me.','',26124),
(24602,'enUS','Honor my ancestors.','',26124),
(24603,'enUS','The burial site must be restored.','',26124),
(24604,'enUS','I die before my task is complete.','',26124),
(24605,'enUS','I go to join my ancestors here.','',26124),
(24606,'enUS','Nothing shall stop us!','',26124),
(24607,'enUS','To the grave with you!','',26124),
(24608,'enUS','The defilement of this sacred resting place comes to an end now!','',26124),
(24609,'enUS','I am a Proudhoof, I will not fail!','',26124),
(24610,'enUS','This is what happens when southerners come to our lands.','',26124),
(24611,'enUS','I will not stop until this place is once again at peace.','',26124),
(24612,'enUS','It pains me to see my ancestors disturbed from their graves.$B$BWe must strike down the cursed spirit of your Force-Commander Steeljaw, the one who foolishly led his caravan through these sacred grounds.','',26124),
(24613,'enUS','You do your people great honor, $r. Thank you again for helping me deal with Steeljaw\'s spirit.$B$BDespite this grievous misunderstanding, I\'m sure in time our peoples will come to be friends.','',26124),
(24614,'enUS','My axe is yours, hero! Together we will destroy these insects!','My axe is yours, hero! Together we will destroy these insects!',26124),
(24615,'enUS','I must return to Warsong Hold. Battle hard, hero!','I must return to Warsong Hold. Battle hard, hero!',26124),
(24616,'enUS','I must return to Warsong Hold, hero. May you swim in the blood of our enemies and feast upon their sorrow!','I must return to Warsong Hold, hero. May you swim in the blood of our enemies and feast upon their sorrow!',26124),
(24617,'enUS','Farewell, friend. I must return to Warsong Hold.','Farewell, friend. I must return to Warsong Hold.',26124),
(24618,'enUS','Until we meet again, hero. Duty calls!','Until we meet again, hero. Duty calls!',26124),
(24619,'enUS','Who disturbs my meditation?!','Who disturbs my meditation?!',26124),
(24620,'enUS','Spirits watch over you, friend. I must make my return to Warsong Hold.','Spirits watch over you, friend. I must make my return to Warsong Hold.',26124),
(24621,'enUS','Ancestors be with you, hero. Farewell!','Ancestors be with you, hero. Farewell!',26124),
(24622,'enUS','Rescued! You have my thanks and my aid, friend.','Rescued! You have my thanks and my aid, friend.',26124),
(24623,'enUS','We will battle together to rid this quarry of the Scourge!','We will battle together to rid this quarry of the Scourge!',26124),
(24624,'enUS','By the fury of the Sunwell, I am released!','By the fury of the Sunwell, I am released!',26124),
(24625,'enUS','Vengeance shall be mine! For Quel\'thalas! For the sin\'dorei!','Vengeance shall be mine! For Quel\'thalas! For the sin\'dorei!',26124),
(24626,'enUS','Huh? Where me at? Dis don\'t look good! Me run now!','',26124),
(24627,'enUS','HOORAY! ME FREE!','',26124),
(24628,'enUS','Tanks, buddy!','',26124),
(24629,'enUS','Mister Mortuus gonna be so mad! Me go home now.','',26124),
(24630,'enUS','Why it keep telling me to put da lotion in da basket? Me no like da lotion!','',26124),
(24631,'enUS','Look at \'em, Ug. You know what those are?','',26124),
(24632,'enUS','No, popo. They look kind of like the pigs. Are they pigs?','',26124),
(24633,'enUS','Those...','',26124),
(24634,'enUS','Those are cowards.','',26124),
(24635,'enUS','Are they cowardly pigs, popo?','',26124),
(24636,'enUS','%s shakes his head.','',26124),
(24637,'enUS','No, blood of my blood, they are soldiers of the Alliance. Our sworn enemies.','',26124),
(24638,'enUS','But popo, what are they afraid of? Why are they here?','',26124),
(24639,'enUS','They are here because they do not wish to defend their homes... their families...','',26124),
(24640,'enUS','They have given up and surrendered - willingly - to us.','',26124),
(24641,'enUS','Ug\'thor, they are afraid to die.','',26124),
(24642,'enUS','%s scratches his head.','',26124),
(24643,'enUS','I... I don\'t understand, popo.','',26124),
(24644,'enUS','%s puffs out his chest and stands on his tip-toes.','',26124),
(24645,'enUS','Lok\'tar ogar, popo!','',26124),
(24646,'enUS','%s laughs.','',26124),
(24647,'enUS','That\'s right, Ug. Victory or death!','',26124),
(24648,'enUS','[In Broken Common] Hear boy, cowards? Boy die! Boy die for freedom!','',26124),
(24649,'enUS','Kaganishu!','',26124),
(24650,'enUS','Etu Magmothregar, cha!','',26124),
(24651,'enUS','Grr... na su ka Magmoth!','',26124),
(24652,'enUS','Kada nu batteka, oht!','',26124),
(24653,'enUS','Captain... Nerub\'ar flyers! Hundreds of \'em! Coming... Coming from the south! Over our defenses!','Captain... Nerub\'ar flyers! Hundreds of \'em! Coming... Coming from the south! Over our defenses!',26124),
(24654,'enUS','There! There!','There! There!',26124),
(24655,'enUS','Settle down, soldier!','',26124),
(24656,'enUS','We\'ll be ready for \'em... You did a good job in warning us.','',26124),
(24657,'enUS','Marksmen! Front and center! Scourge attack incoming!','',26124),
(24658,'enUS','KAGANISHU!','',26124),
(24659,'enUS','Marksmen, lock and load!','',26124),
(24660,'enUS','The Nerub\'ar have been punished for their transgression!','',26124),
(24661,'enUS','Only you can save me from Kaganishu, $n.','',26124),
(24662,'enUS','Defend the inner sanctum at all costs!','',26124),
(24663,'enUS','Leave no survivors! Let Arthas sort \'em out...','',26124),
(24664,'enUS','For Hellscream! For the Horde!','',26124),
(24665,'enUS','Yes... Let the rage consume you!','',26124),
(24666,'enUS','STOP!','',26124),
(24667,'enUS','Tell Imperean that I will consider a cessation of hostilities. But first, Churn must stop his watery intrusions upon my rise!','',26124),
(24668,'enUS','I grow bored with you. Begone!','',26124),
(24669,'enUS','WAIT... NO MORE!','',26124),
(24670,'enUS','I... submit. As long as Simmer agrees to stop boiling my pool, I agree to an armistice.','',26124),
(24671,'enUS','Now, remove yourself from my presence. You would be wise not to come within sight of me again.','',26124),
(24672,'enUS','I will take great pleasure in tearing the forces of the Horde apart... limb from limb and piece by piece...','',26124),
(24673,'enUS','Let the forces of the Lich King gaze upon the carcass of this wretch and know that the Horde will not relent!','',26124),
(24674,'enUS','Gather, soldiers! Gather and take your trophies from the carapace of the enemy!','',26124),
(24675,'enUS','Who dares?!','',26124),
(24676,'enUS','I will turn your bones to ash!','',26124),
(24677,'enUS','You will be consumed!','',26124),
(24678,'enUS','There is no escape from my rise!','',26124),
(24679,'enUS','I will crush you under the weight of my waves!','',26124),
(24680,'enUS','You dare come into my pool?!','',26124),
(24681,'enUS','Your death will not be pleasant!','',26124),
(24682,'enUS','Your corpse will feed my fish.','',26124),
(24683,'enUS','','Oh no... they\'ve shackled his spirit!',26124),
(24684,'enUS','We\'ve lost a good many of our wind riders on scouting missions to the west. The Scourge is ruthless in their assault against any would-be spies.$B$BFortunately, I\'ve come up with a solution that only risks the life of the rider. It\'s seen a 30% survival rate to those being ferried across the Plains of Nasam. That\'s a 30% improvement over when we were using wind riders!','',26124),
(24685,'enUS','Send me to Garrosh\'s Landing, Yanni.','Send me to Garrosh\'s Landing, Yanni.',26124),
(24686,'enUS','','Farseer! I\'m so glad to see you again!',26124),
(24687,'enUS','I have been returned to the living.','',26124),
(24688,'enUS','And now, I must rest. Thank you for all that you have done.','',26124),
(24689,'enUS','No hurt the lifegiver!','',26124),
(24690,'enUS','No touch spores!','',26124),
(24691,'enUS','Protect lifegiver!','',26124),
(24692,'enUS','$C, I have something to ask of you.','',26124),
(24693,'enUS','I am dishonored. I should have died with the farseer at Magmoth.','',26124),
(24694,'enUS','%s can now be captured.','',26124),
(24695,'enUS','Protect the lifegiver!','',26124),
(24696,'enUS','I feel... different.','',26124),
(24697,'enUS','Farseer, it is good to see that you still live.','',26124),
(24698,'enUS','%s smiles and sits down for a well-deserved rest.','',26124),
(24699,'enUS','Farseer, you live!','',26124),
(24700,'enUS','','I look forward to further training when you are ready.',26124),
(24701,'enUS','What am I supposed to do without tools, Gorge!','',26124),
(24702,'enUS','Can\'t fix somethin\' as complicated as a tank without the proper equipment, buddy!','',26124),
(24703,'enUS','Have you heard anything from Warsong? We gonna be gettin\' some supplies soon?','',26124),
(24704,'enUS','I wanna go home... Take off this uniform and leave the Horde!','',26124),
(24705,'enUS','You peons work harder or I will come over there and beat you!','',26124),
(24706,'enUS','This outpost is not ready! What would happen if Malygos and the blue dragonflight decided to strike?','',26124),
(24707,'enUS','Work faster! We must push into Sholazar Basin before the Alliance!','',26124),
(24708,'enUS','You peons are falling behind. Half rations until you pick up the pace!','',26124),
(24709,'enUS','This is the most pathetic bunch of peons I\'ve ever seen! Where\'s my booterang?','',26124),
(24710,'enUS','I swear that if you do not work faster I\'m going to feed you to my worg!','',26124),
(24711,'enUS','Have you grunts no pride? You will have this outpost ready for the reinforcements from Warsong Hold or your worthless corpses will fill the graveyard!','',26124),
(24712,'enUS','Time for a five-minute break. Haha, just kidding! What do you think this is, the Alliance?!','',26124),
(24713,'enUS','Both Garrosh\'s Landing and Pal\'ea were wiped out by the mist. We\'re the only ones crazy enough to stay here, buddy!','',26124),
(24714,'enUS','','How am I supposed to get anything done with Fizzcrank breathing down my neck and me without all of my stuff?!',26124),
(24715,'enUS','','Here we go, bunky. One Crafty\'s Ultra-Advanced Proto-Typical Shortening Blaster at your service!',26124),
(24716,'enUS','What you see here on this coast is not a result of the Scourge. In fact, we believe that the Scourge also fear the mist - which might be why they do not come here.$B$BYou see, the mist is alive, friend. Inside those airy tendrils lies death...$B$BShould you step within its grasp, you will vanish. The mist will take you!$B$BWe have never seen anyone return alive from the mist.','',26124),
(24717,'enUS','Burn, land dweller! BURN!','',26124),
(24718,'enUS','The subjugation of these people has only just begun... so much time for fun and games.','',26124),
(24719,'enUS','Become ashes in the mist!','',26124),
(24720,'enUS','Since landing here I have seen horrors that had previously only haunted my darkest nightmares, but nothing could have prepared me for what lies beyond the mist.$B$B<Mootoo nods.>$B$BThrough that fog, not more than a few yards from us, stand the bloodthirsty creatures known as Kvaldir. None have returned from the fog and few that were originally at the landing when the mist rolled in have escaped. The area has since been condemned by Hellscream. Enter at your own risk...','',26124),
(24721,'enUS','','I... Are you...$B$B<Mootoo shivers.>$B$BAre you here to save me?',26124),
(24722,'enUS','The Serpent\'s Maw is engulfed in tuskarr fire!','',26124),
(24723,'enUS','The Kur Drakkar is engulfed in tuskarr fire!','',26124),
(24724,'enUS','Bor\'s Hammer is engulfed in tuskarr fire!','',26124),
(24725,'enUS','Bor\'s Anvil is engulfed in tuskarr fire!','',26124),
(24726,'enUS','You think to take my primal essence? Come, let us see if you are hard as stone and ice!','',26124),
(24727,'enUS','Frozen and destroyed. This is all your fleshy corpse is good for.','',26124),
(24728,'enUS','You are not welcome here. Die!','',26124),
(24729,'enUS','Your presence unbalances the land. You must be removed!','',26124),
(24730,'enUS','I wish to purchase torches.','I wish to purchase torches.',26124),
(24731,'enUS','Stand back!  This is real fire I\'m handling here, and it can really burn you!','',26124),
(24732,'enUS','Freezing mist engulfs the jetty.','',26124),
(24733,'enUS','Take their clothing.','Take their clothing.',26124),
(24734,'enUS','The Helmsman comes for you!','',26124),
(24735,'enUS','Pathetic fool! A servant of Malygos would sooner die than aid an enemy....','',26124),
(24736,'enUS','Aargh! Do your worst, $c! I\'ll tell you NOTHING!','',26124),
(24737,'enUS','Aahhhh! Release me! I am of no use to you. I swear it!','',26124),
(24738,'enUS','Stop! I beg you, please stop. Please....','',26124),
(24739,'enUS','Alright! I am beaten. Your precious archmage is held in a prison, elevated and sealed. Even if you manage to reach her, Salrand herself holds the key. Your mission is folly!','',26124),
(24740,'enUS','Enough! I\'ve told you all that I know. Your continued abuse is senseless!','',26124),
(24741,'enUS','Yes! Smash the pitiful naga statue.','Yes! Smash the pitiful naga statue.',26124),
(24742,'enUS','Death to Azshara and her lies!','Death to Azshara and her lies!',26124),
(24743,'enUS','We have slain the sea-witches and our god shall slay their queen!','We have slain the sea-witches and our god shall slay their queen!',26124),
(24744,'enUS','You lads know the drill.  No alcohol to servicemen on duty.  You want the general to kill me himself?','',26124),
(24745,'enUS','All right, all right... but you didn\'t get these from me!','',26124),
(24746,'enUS','','Thank you for doing this, $r. I... I think I know how to get back to my father. Please don\'t let the bad things hurt me.',26124),
(24747,'enUS','','I can feel my father\'s aura. He\'s definitely this way... come on, $n.',26124),
(24748,'enUS','','I see a break in the mist up ahead. We\'re getting closer!',26124),
(24749,'enUS','','FATHER! Father, I\'m saved!',26124),
(24750,'enUS','','%s hugs Elder Mootoo.',26124),
(24751,'enUS','Daughter! You have returned!','',26124),
(24752,'enUS','','Alrighty then, $n, here we go: one illusory-enhanced, Warsong orc disguise, complete with Smell-A-Vision!',26124),
(24753,'enUS','Mootoo thanks you, $n.','',26124),
(24754,'enUS','I will not be denied! This world shall fall!','',26124),
(24755,'enUS','Noooo! This torture is inhumane! You have what you want... why don\'t you just kill me?','',26124),
(24756,'enUS','I\'ve given you the information, $r! You\'re wasting your time....','',26124),
(24757,'enUS','','The mist is death... senseless, without compassion.',26124),
(24758,'enUS','What\'s the matter, $c?  Think you\'re too good to stand in line with the rest of us?','What\'s the matter, $c?  Think you\'re too good to stand in line with the rest of us?',26124),
(24759,'enUS','Crafty, I lost my Warsong orc disguise.','Crafty, I lost my Warsong orc disguise.',26124),
(24760,'enUS','Crafty, I need another Warsong banner.','Crafty, I need another Warsong banner.',26124),
(24761,'enUS','Hey, guys!  Wait up!','',26124),
(24762,'enUS','You\'re a sight for sore eyes! I\'m too weak to break the links on this rusty ball and chain.$B$BWell, don\'t just stand there! Get me loose!','',26124),
(24763,'enUS','Um, hello? Is there anyone out there?','',26124),
(24764,'enUS','Hey, you! Yes, you! I can hear you! Get over here and get me outa here!','',26124),
(24765,'enUS','I\'m beginning to think that they all forgot about me!','',26124),
(24766,'enUS','A gnome tries to make some friends, and then BAMM... the next thing you know, he\'s in shackles!','',26124),
(24767,'enUS','I\'m right here. I know you can hear me. Ya think you could let me out of these chains?','',26124),
(24768,'enUS','I\'ll make you a deal: if you get me out of here alive, you\'ll get a reward larger than you can imagine!','',26124),
(24769,'enUS','Hey! Over here in Magmothregar\'s pit!','',26124),
(24770,'enUS','What? You think I want to be Magmothregar\'s next appetizer? Get me outa here!','',26124),
(24771,'enUS','I\'ve got my hands full here at the moment, $c.$B$BWhat can I do for you?','',26124),
(24772,'enUS','Right then, no time to waste. Let\'s get outa here!','',26124),
(24773,'enUS','Here we go.','',26124),
(24774,'enUS','Ah, fresh air! I can get myself back to the airstrip from here. Be sure to tell Fizzcrank I\'m back and safe. Thanks so much, $n!','',26124),
(24775,'enUS','The airstrip at last! Thank you, I can make my way from here. Be sure to tell Fizzcrank I\'m back and safe!','',26124),
(24776,'enUS','I think it\'s up this way to the left.  Let\'s go!','',26124),
(24777,'enUS','Filthy creature!','',26124),
(24778,'enUS','I came here to talk, but you mindless things tried to kill me instead!','',26124),
(24779,'enUS','You won\'t put me in chains again!','',26124),
(24780,'enUS','I AM NOT AN APPETIZER!','',26124),
(24781,'enUS','The only good vermen is a dead vermen!','',26124),
(24782,'enUS','Enough fighting! Let\'s finish this and get outa here!','',26124),
(24783,'enUS','Hey! I\'m walking here!','',26124),
(24784,'enUS','I can\'t believe my own people forgot about me. Die!','',26124),
(24785,'enUS','Oh, sweet airstrip, I shall never see your wee runway again.','',26124),
(24786,'enUS','%s feasts on the helpless kodo.','',26124),
(24787,'enUS','Give the word, general.  I will have two regiments at your disposal in a month\'s time.','',26124),
(24788,'enUS','Very well, general.  Should you change your mind, my people will be more than willing to provide military assistance.','',26124),
(24789,'enUS','Our troops, general, consist mostly of villagers and peasants.  Good men, but not quite rid of the prejudices and superstitions of their upbringing.  They\'re not ready to fight alongside our more exotic allies.','',26124),
(24790,'enUS','Your offer will be carefully considered, harbinger.  In the meantime we will make use of your delegation in an advisory role.','',26124),
(24791,'enUS','The Scourge has us surrounded. We can hold the village for awhile, but if we can\'t defeat them, they will overrun us.','',26124),
(24792,'enUS','The choice is clear. We must attack. I know the odds are against us, but Taunka do not go quietly to the slaughter.','',26124),
(24793,'enUS','I\'ll die with my axes in my hands and drenched in the blood of our foes!','',26124),
(24794,'enUS','','These cages are bled dry. Get me more prisoners at once!',26124),
(24795,'enUS','','These prisons are to be filled at once or Malygos will know why!',26124),
(24796,'enUS','','Bring me more prisoners! Do not rest until Azeroth has been cleansed of its reckless magic-users!',26124),
(24797,'enUS','','Fill these prisons with mages! Malygos demands it!',26124),
(24798,'enUS','I won\'t sacrifice my warriors for romantic notions of glorious death on the battlefield. What use is fighting for survival if no one survives?','',26124),
(24799,'enUS','There will be a time for battle, Durm. But first, we must find a way to even the odds. What would you have me do, Aeire?','',26124),
(24800,'enUS','','The ancestors knew a way to confound an enemy\'s senses. We could use this knowledge to discover the Scourge\'s weakness or strike at their commanders. Without their leaders, the Scourge would fall before our warriors.',26124),
(24801,'enUS','A dishonorable scheme.','',26124),
(24802,'enUS','What is your honor worth, Durm? Your life? Mine? The life of blind old Greatfather Mahan, who raised you from childhood?','',26124),
(24803,'enUS','Honor is meaningless to a dead man. A warrior may throw himself into battle for honor\'s sake, but a chieftain is responsible for far more. We will follow Sage Aeire\'s plan and continue to defend our village.','',26124),
(24804,'enUS','','Speak slowly, child, I am new to your strange tongue.',26124),
(24805,'enUS','','Please, keep your voice down, $r. Hamat is old and needs her rest.',26124),
(24807,'enUS','The time has come to act. We must decide how to deal with the Scourge before it consumes us.','',26124),
(24808,'enUS','The expendable have perished. So be it! Now I shall succeed where Sargeras could not! I will bleed this wretched world and secure my place as the true master of the Burning Legion! The end has come! Let the unravelling of this world commence!','',26124),
(24809,'enUS','Your souls belong to the Scourge now, mortals.','',26124),
(24810,'enUS','Aeire, $n has brought your hides. Please, take them before they make me ill.','',26124),
(24811,'enUS','','I\'ll take those. We can\'t have the mighty chieftain cowering in fear of a few hides.',26124),
(24812,'enUS','','What is the meaning of this disturbance?!',26124),
(24813,'enUS','','Back to work! I\'ve dealt with our little distraction.',26124),
(24814,'enUS','More bodies for the master...','',26124),
(24815,'enUS','Unlocking','Unlocking',26124),
(24816,'enUS','','I\'ve destroyed the key! Your cherished archmage belongs to Malygos!',26124),
(24817,'enUS','Treacherous creatures! By Nazjatar\'s depths, Lady Azshara will avenge me!','Treacherous creatures! By Nazjatar\'s depths, Lady Azshara will avenge me!',26124),
(24818,'enUS','I go to be with the spirits of my ancestors...','I go to be with the spirits of my ancestors...',26124),
(24819,'enUS','You may have survived for our amusement, but now, you shall die at our hands!','You may have survived for our amusement, but now, you shall die at our hands!',26124),
(24820,'enUS','','Who dares interrupt my work!? Show yourself, coward!',26124),
(24821,'enUS','','Who dare interrupt my work!? Show yourself, coward!',26124),
(24822,'enUS','I will channel my powers into the orbs! Be ready!','',26124),
(24823,'enUS','Send in the next pair of prisoners, let them fight to see who lives!','Send in the next pair of prisoners, let them fight to see who lives!',26124),
(24824,'enUS','I have channeled all I can! The power is in your hands!','',26124),
(24825,'enUS','Do not harbor false hope! You cannot win!','',26124),
(24827,'enUS','Somebody please... Help...','',26124),
(24828,'enUS','Don\'t let them turn me into one of those aberrations!','',26124),
(24829,'enUS','Kill me... Kill me now!','',26124),
(24830,'enUS','Should I ever escape this prison...','',26124),
(24831,'enUS','Thank you, friend.','',26124),
(24832,'enUS','Freedom at last! I must return to Warsong Hold at once!','',26124),
(24833,'enUS','You have my thanks, stranger.','',26124),
(24834,'enUS','I am forever indebted to you, friend.','',26124),
(24835,'enUS','I require more bodies! Bring them to me at once!','',26124),
(24836,'enUS','I will reanimate them all as servants of the Lich King! Bring them here...','',26124),
(24837,'enUS','Bring the Flenser the fallen Horde! They will be reanimated as soldiers of the Lich King!','',26124),
(24838,'enUS','Excellent...','',26124),
(24839,'enUS','Yes... Report to the Plains of Nasam, my children...','',26124),
(24840,'enUS','A child has found a new toy! Crewman, take this infant\'s toy away!','',26124),
(24841,'enUS','Crewman, show this ant the might of the Kvaldir!','',26124),
(24842,'enUS','Crewman, tear this land walker apart!','',26124),
(24843,'enUS','Aye, captain!','',26124),
(24844,'enUS','','',26124),
(24845,'enUS','Now you face Orabus, fool!','',26124),
(24846,'enUS','I shall draw your soul into the mist!','I shall draw your soul into the mist!',26124),
(24847,'enUS','YAAARRRGH!','YAAARRRGH!',26124),
(24848,'enUS','Be consumed by the mist!','Be consumed by the mist!',26124),
(24849,'enUS','Look what\'s lost its way...','Look what\'s lost its way...',26124),
(24850,'enUS','I will heave your carcass into the ocean myself!','I will heave your carcass into the ocean myself!',26124),
(24851,'enUS','You\'re not even fit to be fed to Leviroth.','You\'re not even fit to be fed to Leviroth.',26124),
(24852,'enUS','You\'ve strayed too far from your comfortable soil, $r.','You\'ve strayed too far from your comfortable soil, $r.',26124),
(24853,'enUS','The Lich King shall consume all...','',26124),
(24854,'enUS','There is no escape...','',26124),
(24855,'enUS','Death will be only the beginning of your torture.','',26124),
(24856,'enUS','May the light bless you.','',26124),
(24857,'enUS','Your wounds are severe, but you will live.','',26124),
(24858,'enUS','Rest now, you have fought well today.','',26124),
(24859,'enUS','It\'s alive!','',26124),
(24860,'enUS','Purl one, knit one. Purl one, knit one....','',26124),
(24861,'enUS','What a lovely abomination you\'re going to be.','',26124),
(24862,'enUS','Not to worry, my pretties, we\'ll soon be flying high again.','',26124),
(24863,'enUS','I need more parts!','',26124),
(24864,'enUS','How can I be expected to work under these conditions?!','',26124),
(24865,'enUS','Spare the cleaver, spoil the patient.','',26124),
(24866,'enUS','I\'m going to need more parts soon.','',26124),
(24867,'enUS','Clear!','',26124),
(24868,'enUS','Live, damn you!','',26124),
(24869,'enUS','It\'s no good... you need more work first.','',26124),
(24870,'enUS','The doctor is in!','',26124),
(24871,'enUS','Fresh meat!','',26124),
(24872,'enUS','Ah, good... more parts!','',26124),
(24873,'enUS','I recommend evisceration!','',26124),
(24874,'enUS','Die!','',26124),
(24875,'enUS','You cannot stop us!','',26124),
(24876,'enUS','Filthy breather!','',26124),
(24877,'enUS','These repairs are behind schedule!','',26124),
(24878,'enUS','This will be completed if I have to destroy all of you to get it done!','',26124),
(24879,'enUS','If the Lich King finds out that we crashed Talramas due to a malfunction, we\'ll all be reduced to ashes.','',26124),
(24880,'enUS','Faster! We must be flying by the end of the day or the Lich King will destroy us for certain.','',26124),
(24881,'enUS','Here\'s your kodo, Torp!','Here\'s your kodo, Torp!',26124),
(24882,'enUS','Door-to-door kodo delivery!','Door-to-door kodo delivery!',26124),
(24883,'enUS','YES! It worked!','',26124),
(24884,'enUS','Great job!','',26124),
(24885,'enUS','%s is cured!','',26124),
(24886,'enUS','Mages! Take wing!','',26124),
(24887,'enUS','The way is cleared! Open the prison!','',26124),
(24888,'enUS','','Okay, $n, here we go. Cross your fingers, toes, eyes and whatever else you can cross!',26124),
(24889,'enUS','','Oh no, it didn\'t work! Somehow I feel... lighter.',26124),
(24890,'enUS','For Dalaran! Attack!','',26124),
(24891,'enUS','The Alliance Flag is now placed at its base.','',26124),
(24892,'enUS','The Horde Flag is now placed at its base.','',26124),
(24893,'enUS','Ahune, your strength grows no more!','Ahune, your strength grows no more!',26124),
(24894,'enUS','Your frozen reign will not come to pass!','Your frozen reign will not come to pass!',26124),
(24895,'enUS','The Ice Stone has melted!','The Ice Stone has melted!',26124),
(24896,'enUS','Tell me what\'s going on out here, Fizzcrank.','Tell me what\'s going on out here, Fizzcrank.',26124),
(24897,'enUS','Tell me your story again, Fizzcrank.','Tell me your story again, Fizzcrank.',26124),
(24898,'enUS','Fine then, have a seat. This might take a while.$B$BWhen we first came to this frozen hell, General Arlos, down in Valiance Keep, gave my group of flying daredevils and me a special task: to establish a forward airbase for Alliance operations.$B$BThis airstrip is the result. Let me tell you, it wasn\'t easy, what with all the nasty beasts and the ground rock-hard from being frozen! But we managed, and we did it quickly too!','',26124),
(24899,'enUS','Go on.','Go on.',26124),
(24900,'enUS','Anyway, we needed to pump up lots of sand and oil for the machinery. The nearby pools proved to be perfect for that.$B$BSome of the sand even proved to have magical properties... can you say possibilities!? But that\'s a different tale.$B$BSo, we drained most of the water out and built the pumping station smack dab in the middle. Everything was going swimmingly until one day the main suction pipe got clogged.','',26124),
(24901,'enUS','Wait, back up. What was that last thing you said?','Wait, back up. What was that last thing you said?',26124),
(24902,'enUS','Mind you, this part I learned later because I wasn\'t out there at the time.$B$BWhen they ratcheted up the suction on the pump, up came pieces of a robot that looked like a gnome! Of course the fools worked night and day to put it back together without telling us.$B$BThis is when we lost communication with the pumping station.','',26124),
(24903,'enUS','After a couple of days of silence, I sent a scouting party out to the platform. They never returned.$B$BI sent another group the next day with the same results, and lost a couple of flying machines out on aerial recon.$B$BAt that point I sent someone south to find help, and we hunkered down to prepare for the worst. We turned all of our attention to making armor, weapons and robots so that we could head out there in full force.$B$BWhen we did a few days ago, we couldn\'t believe our eyes!','',26124),
(24904,'enUS','As I was saying, what we saw out there defied explanation.$B$BMy people were nowhere to be found, but in their place was a veritable army of robots and androids going about their business!$B$BThe droids all looked like gnomes and they said that they\'d been expecting us. In fact, in their own strange way, they acted like they knew us. We were surrounded and quickly taken to the top of the pumping station.$B$BThat\'s where we saw their leader and what he was doing to the surviving gnomes!','',26124),
(24905,'enUS','He called himself Gearmaster Mechazod. When we arrived he was busy transforming the survivors into mechanical beings!$B$BHe greeted us warmly and explained that he was one of the first gnomes ever to be created by something he called \"The Grand Architect\", a Titan keeper from within the halls of fabled Ulduar.$B$BApparently, he was the blockage that my team had accidentally sucked up from where he\'d malfunctioned thousands of years ago. It was just our luck that we\'d built the pumping station right above him.','',26124),
(24906,'enUS','The station\'s mechanics had put him back together, bringing him back to \"life\".$B$BAnd now, by way of thanks, he was going to return the favor by curing all of us of what he called the \"Curse of the Flesh\".$B$BAccording to Mechazod, it\'s a condition that eventually befalls all of the creations of the Titans! In other words, we all supposedly start out as robots of some kind, and, over thousands of years, slowly turn into fleshy beings!$B$BPreposterous, I know.','',26124),
(24907,'enUS','It didn\'t look like much of a \"cure\" to me, and I wasn\'t about to stand around listening to some crazy robot while he was butchering my people!$B$BWe did what any sane gnome would do... we ran! Well, actually, most of us parachuted off the side of the platform, but you get the picture.$B$BNot many of us managed to make it back here, and we\'re still spread thin from having to deal with everything else too, like the magnataur to the north and the Scourge to the east. To make things worse, the Horde just setup shop to the northwest!','',26124),
(24908,'enUS','And that\'s where we find ourselves now, $n.$B$BWe can\'t possibly deal with all of this by ourselves, and quite frankly, I feel a little out of my depth. Jinky knows what needs to be done. You should go see her now.$B$BI just hope you\'ll be able to get us out of this mess with our bodies intact.','',26124),
(24909,'enUS','This is it, $n. The start of the end of the world. And you\'re here to see it off...','',26124),
(24910,'enUS','Let\'s go...','',26124),
(24911,'enUS','Is this it? Is this all the mighty Horde could muster?','',26124),
(24912,'enUS','Pathetic.','',26124),
(24913,'enUS','I\'ve never understood your type. The hero...','',26124),
(24914,'enUS','Why won\'t you just let go? Why do you fight the inevitable?','',26124),
(24915,'enUS','The Lich King cannot be stopped. Accept it.','',26124),
(24916,'enUS','This world is coming to an end. Let. It. Burn.','',26124),
(24917,'enUS','Take $g him:her; away and prepare $g him:her; for reanimation.','',26124),
(24918,'enUS','I\'ll rip your shriveled heart out with my bare hands before any harm comes to $n, necromancer.','',26124),
(24919,'enUS','You were never alone, $n.','',26124),
(24920,'enUS','This world that you seek to destroy is our home.','',26124),
(24921,'enUS','What\'s this now?','',26124),
(24922,'enUS','Intruder detected! Must notify defender bots!','',26124),
(24923,'enUS','Warning! Danger! Danger!','',26124),
(24924,'enUS','We will fight you with every fiber of our being - until we are nothing more than dust and debris. We will fight until the end.','',26124),
(24925,'enUS','Threat imminent! Beginning evasive action!','',26124),
(24926,'enUS','Then you are a fool.','',26124),
(24927,'enUS','A fool who is about to end you, necrolord. There will be nothing left of you for the Lich King to reanimate!','',26124),
(24928,'enUS','You? A lone orc? Against me and...','',26124),
(24929,'enUS','RISE!','',26124),
(24930,'enUS','The Earthen Ring\'s Assault Begins.','The Earthen Ring\'s Assault Begins.',26124),
(24931,'enUS','Ahune Retreats.  His defenses diminish.','Ahune Retreats.  His defenses diminish.',26124),
(24932,'enUS','Ahune will soon resurface.','Ahune will soon resurface.',26124),
(24933,'enUS','I... I can\'t believe it... Saurfang... I... I am honored... honored to have fought along side you, sir.','',26124),
(24934,'enUS','You should return to Warsong Hold now, friend. Hellscream will surely want to hear of what just happened here... of Saurfang...','',26124),
(24935,'enUS','%s nods.','',26124),
(24937,'enUS','Farewell...','',26124),
(24938,'enUS','You\'ll make no mention of me. Either of you!','',26124),
(24939,'enUS','Are you going to take me back to Valiance Keep?','Are you going to take me back to Valiance Keep?',26124),
(24940,'enUS','I can\'t understand a word that you\'re saying. Just follow me.','I can\'t understand a word that you\'re saying. Just follow me.',26124),
(24941,'enUS','Harumph! Alright, off I go!','Harumph! Alright, off I go!',26124),
(24942,'enUS','What? You\'re sending me back there?!','What? You\'re sending me back there?!',26124),
(24944,'enUS','I\'ll blast those gnomish wannabes back to the scrap heap!','I\'ll blast those gnomish wannabes back to the scrap heap!',26124),
(24945,'enUS','Ahh, nothing like a job well done!','Ahh, nothing like a job well done!',26124),
(24946,'enUS','Time to head in for a nice cup of Jinky\'s Magmatically Hot Chocolate!','Time to head in and see if I can\'t get a bit of Mordle\'s Mysterious Mead...',26124),
(24948,'enUS','It was a good day to fly!','It was a good day to fly!',26124),
(24949,'enUS','Now it\'s time to brag about how utterly awesome I am.','I wonder if that cute pilot with the pink hair is still around...',26124),
(24951,'enUS','Sir, I need another flying machine...','Sir, I need another flying machine...',26124),
(24952,'enUS','','Mordle get the outgoing on the transmatter fixed now!',26124),
(24953,'enUS','','Do you even know what you\'re doing?!',26124),
(24954,'enUS','','This transmatter\'s the key to our survival. If we don\'t get it fully operational, we\'re goners for sure!',26124),
(24955,'enUS','','If you don\'t get that thing fully operational, we\'re toast for sure!',26124),
(24956,'enUS','Foolish elemental slave! You and your master will pay for your meddling!','',26124),
(24957,'enUS','Jinkies, Jinky, I\'m tryin\' the best I know!','',26124),
(24958,'enUS','Do I look like a transmatter-tech to you?! At least we have incoming... sort of.','',26124),
(24959,'enUS','Look, it\'s not my fault that Tinky took off. This thing\'s her baby... I\'ve just watched her keep it going on spit and glue.','',26124),
(24960,'enUS','You\'re being soooooo helpful... NOT!','',26124),
(24961,'enUS','Yep, I think I finally have it. Just a twist of this dial, and... oops.','',26124),
(24962,'enUS','I wouldn\'t use it just yet, but you feel free to test it out yourself.','',26124),
(24963,'enUS','','With the power of the horn, I bind you to its wielder\'s will!',26124),
(24964,'enUS','','So cold...',26124),
(24965,'enUS','','Everyone is dead... Everyone and everything...',26124),
(24966,'enUS','Thank you, $r. I will take this miserable cur from you now.','',26124),
(24967,'enUS','I\'m flesh and blood again! Thank you, $c!','I\'m flesh and blood again! Thank you, $c!',26124),
(24968,'enUS','Thank you so much! I thought I\'d never wake up from that nightmare!','Thank you so much! I thought I\'d never wake up from that nightmare!',26124),
(24969,'enUS','Oh no, not the transmatter... it\'ll probably malfunction!','Oh no, not the transmatter... it\'ll probably malfunction!',26124),
(24970,'enUS','But... but... I was perfect!','But... but... I was perfect!',26124),
(24971,'enUS','Where am I? Who are you? What\'s that strange feeling?','Where am I? Who are you? What\'s that strange feeling?',26124),
(24972,'enUS','Mechazod is insane! You have to stop him before it\'s too late!','Mechazod is insane! You have to stop him before it\'s too late!',26124),
(24973,'enUS','It was horrible! They\'ve all been changed!','It was horrible! They\'ve all been changed!',26124),
(24974,'enUS','He called it the Curse of the Flesh. Mechazod is deranged!','He called it the Curse of the Flesh. Mechazod is deranged!',26124),
(24975,'enUS','The actions of these deserters shames us all. A shame so powerful that it must be witnessed to be understood. It is why Ug\'thor is here... The boy must learn.','',26124),
(24976,'enUS','I am embarassed to say it, Nork, but my deserter has gone missing.','I am embarassed to say it, Nork, but my deserter has gone missing.',26124),
(24977,'enUS','Try to not lose this one, $n. It is important that we at least try and keep up appearances with the Alliance.','',26124),
(24978,'enUS','Warning: $r incursion detected!','',26124),
(24979,'enUS','Activate counter-measures. Repel intruder.','',26124),
(24980,'enUS','Attention all units, $r inside the perimeter.','',26124),
(24981,'enUS','You have been detected. You will be assimilated or eliminated.','',26124),
(24982,'enUS','Gathering','Gathering',26124),
(24983,'enUS','Sathrovarr drives Kalecgos into a crazed rage!','',26124),
(24984,'enUS','I survived and I\'m flesh again!','I survived and I\'m flesh again!',26124),
(24985,'enUS','This is the worst contraption anyone ever devised!','This is the worst contraption anyone ever devised!',26124),
(24986,'enUS','I have vital information for Fizzcrank. Out of the way!','I have vital information for Fizzcrank. Out of the way!',26124),
(24987,'enUS','I said, NO transmatter! At least I\'m not a mechagnome anymore.','I said, NO transmatter! At least I\'m not a mechagnome anymore.',26124),
(24988,'enUS','I\'m flesh and blood again. That\'s all that matters!','I\'m flesh and blood again. That\'s all that matters!',26124),
(24989,'enUS','Don\'t go out there. The pools are crawling with robots and mechagnomes!','Don\'t go out there. The pools are crawling with robots and mechagnomes!',26124),
(24990,'enUS','I feel funny. I don\'t think you reintegrated me right....','I feel funny. I don\'t think you reintegrated me right....',26124),
(24991,'enUS','The commander needs to be told: Mechazod\'s planning an attack! We\'re doomed!','The commander needs to be told: Mechazod\'s planning an attack! We\'re doomed!',26124),
(24992,'enUS','','How positively awful! You were totally incapacitated? Weak? Hot flashes?',26124),
(24993,'enUS','There is no time to waste!','',26124),
(24994,'enUS','And remember, $n, the bloodspore powder can be used to weaken all magnataur in Gammoth.','',26124),
(24995,'enUS','','I thank you, friend of Dalaran.',26124),
(24996,'enUS','','We mustn\'t tarry here... stay close - I\'ll take us somewhere safe.',26124),
(24997,'enUS','Status: Life-giving substance collection completed.','',26124),
(24998,'enUS','Feebleminded tinkerer, do you really think your pathetic creation can stop me?','',26124),
(24999,'enUS','','Be careful around these parts, $r. The natives are ruthless.',26124),
(25000,'enUS','We are Mechagnome... resistance is futile.','',26124),
(25001,'enUS','You are cursed and we are the cure.','',26124),
(25002,'enUS','The flesh is weak. We will make you better, stronger... faster.','',26124),
(25003,'enUS','We can decurse you, we have the technology.','',26124),
(25004,'enUS','The Gearmaster has plans for your weak flesh.','',26124),
(25005,'enUS','Today, the Borean Tundra. Tomorrow, the world!','',26124),
(25006,'enUS','You will be decursed!','',26124),
(25007,'enUS','Come be perfect with us, $g brother : sister;.','',26124),
(25008,'enUS','Maintenance initiated.','',26124),
(25009,'enUS','Reporting for duty, $g sir : ma\'am;!','',26124),
(25010,'enUS','I am sworn by tuskarr law to avenge my kin... these murderers burned Pal\'ea to the ground.','',26124),
(25011,'enUS','I\'ve treated peasants, nobles, merchants\' sons and beggars.  Allow me to share one piece of wisdom with you - we\'re all the same when staring death in the face.','',26124),
(25012,'enUS','Twonky!','',26124),
(25013,'enUS','ED-210 online!','',26124),
(25014,'enUS','I am the herald of Mechazod. You will be decursed!','',26124),
(25015,'enUS','Your meddling is at an end. Mechazod will relieve your curse once I am done with you.','',26124),
(25016,'enUS','I wonder what Nesingwary will give me for your hide!','I wonder what Nesingwary will give me for your hide!',26124),
(25017,'enUS','I\'m sure ol\' Hemet can do something with your bones!','I\'m sure ol\' Hemet can do something with your bones!',26124),
(25018,'enUS','Just fifty more hooves and I\'ll have the new gun!','Just fifty more hooves and I\'ll have the new gun!',26124),
(25019,'enUS','KILL KILL KILL!!!!!!!','KILL KILL KILL!!!!!!!',26124),
(25020,'enUS','It\'s gonna be veal tonight!','It\'s gonna be veal tonight!',26124),
(25021,'enUS','Horns, antlers, hooves, tails, fur, hide, skin, WHATEVER!','Horns, antlers, hooves, tails, fur, hide, skin, WHATEVER!',26124),
(25022,'enUS','Now THIS is a sport!','Now THIS is a sport!',26124),
(25023,'enUS','Give it up, little beast!','Give it up, little beast!',26124),
(25024,'enUS','You were looking for me, child? Why do you come to kill me, $n? I only wish to help.','',26124),
(25025,'enUS','Now that I have been reassembled, we can return to a time of perfection... the time of the Titans!','',26124),
(25026,'enUS','But, I can see it in your eyes, hear it in your pulse rate. You would destroy me despite my offer of immortality!','',26124),
(25027,'enUS','Very well. It saddens me that it has come to this. I look upon all of you as if you were my children. I will slay you if I must!','',26124),
(25028,'enUS','Is your cause righteous and your heart true? If so, you are welcome here - among the druids for the ethical and humane treatment of animals. So long as you do not veer down the dark path of depravity and harm the animals that have allowed us to coexist within their world, D.E.H.T.A. will consider you an ally.\n','',26124),
(25029,'enUS','It\'s a miracle! The beast skinned itself!','It\'s a miracle! The beast skinned itself!',26124),
(25030,'enUS','Stupid beasts!','Stupid beasts!',26124),
(25031,'enUS','This is the last one that I need for the set of Nesingwary steak knives!','This is the last one that I need for the set of Nesingwary steak knives!',26124),
(25032,'enUS','I\'d like to return to the mainland.','I\'d like to return to the mainland.',26124),
(25033,'enUS','What would you like?','',26124),
(25034,'enUS','Jackpot!','Jackpot!',26124),
(25035,'enUS','%s loses consciousness from the brutal beating.','%s loses consciousness from the brutal beating.',26124),
(25036,'enUS','%s regains consciousness.','%s regains consciousness.',26124),
(25037,'enUS','Mother of pearl!','Mother of pearl!',26124),
(25038,'enUS','Clam skin dress shirt here I come!','Clam skin dress shirt here I come!',26124),
(25039,'enUS','The clam has given up the goods!','The clam has given up the goods!',26124),
(25040,'enUS','BAM!','BAM!',26124),
(25041,'enUS','This recon pilot did not survive his squadron\'s crash.','',26124),
(25042,'enUS','Search for the pilot\'s insignia.','Search for the pilot\'s insignia.',26124),
(25043,'enUS','Are you crazy? You\'re about to blow us sky high! I\'ll take care of this wreck once everything else is finished.','',26124),
(25044,'enUS','Them thar druids be sendin\' children to thar deaths now? The Clam Master obliges, matey!','',26124),
(25045,'enUS','Skin ye right up and our customers will never know the difference!','',26124),
(25046,'enUS','%s trumpets in approval!','',26124),
(25047,'enUS','X-51 Nether-Rocket Mount','X-51 Nether-Rocket Mount',26124),
(25048,'enUS','Pet Biscuit','Pet Biscuit',26124),
(25049,'enUS','Goblin Weather Machine - Prototype 01-B','Goblin Weather Machine - Prototype 01-B',26124),
(25050,'enUS','','Bring forth the imps!',26124),
(25051,'enUS','%s whimpers.','',26124),
(25052,'enUS','Do you think us fools! You\'re covered in animal blood!','Do you think us fools! You\'re covered in animal blood!',26124),
(25053,'enUS','BUTCHER! DIE!','BUTCHER! DIE!',26124),
(25054,'enUS','Calf killer! Murderer! You will pay for this!','Calf killer! Murderer! You will pay for this!',26124),
(25055,'enUS','Gathering','',26124),
(25056,'enUS','Truly pathetic. The sin\'dorei were not meant to mix with mongrels such as the draenei.','',26124),
(25057,'enUS','We\'ll deal with you soon enough.','',26124),
(25058,'enUS','You blood elves should rejoin the flock before it\'s too late.','',26124),
(25059,'enUS','Prince Kael\'thas has plans for all of you.','',26124),
(25060,'enUS','Run, dogs. Tell your naaru masters that the end is nigh!','',26124),
(25061,'enUS','Your little incursion upon the isle means nothing. Soon you will all be dead!','',26124),
(25062,'enUS','The power of the Sunwell will be harnessed once more!','',26124),
(25063,'enUS','In time, you too shall do our bidding just as the demons serve us.','',26124),
(25064,'enUS','New directives acquired.  Obey $g magister:magistrix; $n.','',26124),
(25065,'enUS','No deployment target found.  Searching for type: Sanctum.  Location: Sun\'s Reach.','',26124),
(25066,'enUS','$g Magister:Magistrix; $n is a great combatant.  $g Magister:Magistrix; $n must make Prince Kael\'thas very proud.','',26124),
(25067,'enUS','Protect the Sunwell from Arthas and the Scourge.  Error: Sunwell not found.','',26124),
(25068,'enUS','Across the lands our fires burn strong and true!','Across the lands our fires burn strong and true!',26124),
(25069,'enUS','Have you danced at the ribbon pole yet?','Have you danced at the ribbon pole yet?',26124),
(25070,'enUS','I admire the skill that torch jugglers have.','I admire the skill that torch jugglers have.',26124),
(25071,'enUS','You challenge Kaw, destroyer of mammoths!? Then face me and feel my thunder!','',26124),
(25072,'enUS','So, $n, which item are you interested in?','',26124),
(25073,'enUS','Be the first on your block to own the incredible Electrostatic Maculation Blaster!','',26124),
(25074,'enUS','Derived from cutting edge Shattered Sun Offensive military technology, it blasts away stubborn stains with ease!','',26124),
(25075,'enUS','Wine stains, grass stains, even pet stains are no match for the Electrostatic Maculation Blaster!','',26124),
(25076,'enUS','Don\'t wait! Order now and receive my Ultra-Kinetic Waffle Iron at no additional charge!','',26124),
(25077,'enUS','Ah - oddities and rarities. We specialize in Azeroth\'s more unique items for the discerning adventurer.$B$BSince you\'re speaking with me, you must already have an idea of what you\'re looking for.','',26124),
(25078,'enUS','Heroes of Azeroth','Heroes of Azeroth',26124),
(25079,'enUS','Points Redemption','Points Redemption',26124),
(25080,'enUS','Through the Dark Portal','Through the Dark Portal',26124),
(25081,'enUS','Fires of Outland','Fires of Outland',26124),
(25082,'enUS','March of the Legion','March of the Legion',26124),
(25083,'enUS','Servants of the Betrayer','Servants of the Betrayer',26124),
(25084,'enUS','What other promotions do you have?','What other promotions do you have?',26124),
(25085,'enUS','Hey, harbinger, how\'s that research coming along? There might be an Ultra-Kinetic Waffle Iron in it for you if you\'re prompt with the results!','',26124),
(25086,'enUS','It\'s coming along, Wafflefry. Haven\'t you got a product demonstration to do or something?','',26124),
(25087,'enUS','Kaw\'s halberd breaks in two and falls to the ground!','Kaw\'s halberd breaks in two and falls to the ground!',26124),
(25088,'enUS','','Did you know that alchemists can transmute certain gems?  Mar\'nah and I have been talking about this.$B$BI\'m convinced that given her prowess, once her lab is complete, she and I will be able to create gems that were thought to be lost in time.',26124),
(25089,'enUS','','We\'ve done it, $n.  Mar\'nah has learned how to transmute very special gems.  And I\'ve learned how to work them.',26124),
(25090,'enUS','Our victory in Sun\'s Reach is absolute!  The naaru bless us with their presence!','',26124),
(25091,'enUS','Do not be frightened, $r. Our ends are the same.','',26124),
(25092,'enUS','Who are you?','Who are you?',26124),
(25093,'enUS','I am Kalecgos, of the Blue Dragonflight.$b$bI have watched over the nascent powers of the Sunwell for some time, but now I see that its terrible power could usher in the end of our world!','',26124),
(25094,'enUS','What brings you to this place?','What brings you to this place?',26124),
(25095,'enUS','A friend and I have come to rescue a young human woman from the clutches of the Legionlord, Kil\'jaeden and his vile minions.$b$bWe\'ve discovered that Kael\'thas is trying to summon Kil\'jaeden from the depths of the Sunwell itself.$b$bFor the sake of this world - this cannot come to pass! I am committed to seeing that it does not.','',26124),
(25096,'enUS','What can we do to assist you?','What can we do to assist you?',26124),
(25097,'enUS','Defeating Kael\'thas is a task worthy of your undivided attention. $b$bBeyond that, if you are capable of organizing an army, there are many wrongs in the Sunwell to be addressed.$b$bPerhaps we shall meet again there.','',26124),
(25098,'enUS','You are not allowed to interfere!','You are not allowed to interfere!',26124),
(25099,'enUS','Our vision will be realized!','Our vision will be realized!',26124),
(25100,'enUS','The elements will crush you!','The elements will crush you!',26124),
(25101,'enUS','Welcome, $c. Have you come to honor this flame?$b$bRemember: Our festival fires burn in every land with an Alliance settlement. Make time to honor each of them, if you can.$b$bThe Horde, too, burns fires of their own. You would do well to desecrate such unworthy efforts when you see them.','Welcome, $c. Have you come to honor this flame?$b$bRemember: Our festival fires burn in every land with an Alliance settlement. Make time to honor each of them, if you can.$b$bThe Horde, too, burns fires of their own. You would do well to desecrate such unworthy efforts when you see them.',26124),
(25102,'enUS','You dare challenge Nedar, lord of the tundra!?','',26124),
(25103,'enUS','Your impetuousness will be your end!','',26124),
(25104,'enUS','You don\'t stand a chance!','',26124),
(25105,'enUS','Behold, the Flames of Summer!','Behold, the Flames of Summer!',26124),
(25106,'enUS','Careful, don\'t get burned!','Careful, don\'t get burned!',26124),
(25107,'enUS','Enjoying the Fire Festival?','Enjoying the Fire Festival?',26124),
(25108,'enUS','Welcome! Have you yet honored this land\'s flame?','Welcome! Have you yet honored this land\'s flame?',26124),
(25109,'enUS','','This world has been damaged in ways beyond what our eyes can see.  Even the passage of time feels different somehow.',26124),
(25110,'enUS','','You\'ve done a lot for us.  I am here on an important assignment but if you need passage to the Caverns of Time I\'d be glad to take you there.',26124),
(25111,'enUS','Take me to the Caverns of Time.','Take me to the Caverns of Time.',26124),
(25112,'enUS','Search the body for the pilot\'s emergency toolkit.','Search the body for the pilot\'s emergency toolkit.',26124),
(25113,'enUS','Thirty caribou hooves for a rifle that has a scope?! Sign me up!','Thirty caribou hooves for a rifle that has a scope?! Sign me up!',26124),
(25114,'enUS','I don\'t know about you guys, but that clam meat helmet for turning in ten pearls is looking mighty good!','I don\'t know about you guys, but that clam meat helmet for turning in ten pearls is looking mighty good!',26124),
(25115,'enUS','So let me get this straight: I give Lane fifteen mammoth trunks and he gives me a set of daggers that I can use as steak knives? How does he do it? How does he make such amazing deals??','So let me get this straight: I give Lane fifteen mammoth trunks and he gives me a set of daggers that I can use as steak knives? How does he do it? How does he make such amazing deals??',26124),
(25116,'enUS','No way! Rhino head helmet for the low, low price of thirty rhino heads? I\'ll take two at those prices!','No way! Rhino head helmet for the low, low price of thirty rhino heads? I\'ll take two at those prices!',26124),
(25117,'enUS','Nesingwary is going to go broke if he keeps this up! Lane probably has no idea what he\'s doing!','Nesingwary is going to go broke if he keeps this up! Lane probably has no idea what he\'s doing!',26124),
(25118,'enUS','He calls himself the Fur Baron - I call him a sucker! I get a brand new set of winter socks made of rat fur for merely killing and skinning fifty caribou fawns?','He calls himself the Fur Baron - I call him a sucker! I get a brand new set of winter socks made of rat fur for merely killing and skinning fifty caribou fawns?',26124),
(25119,'enUS','Harold Lane is overrun by a stampede!','Harold Lane is overrun by a stampede!',26124),
(25120,'enUS','You seek to deafen me? Pathetic... Wait... What\'s that sound?','',26124),
(25121,'enUS','Arena Battlemasters','Arena Battlemasters',26124),
(25122,'enUS','The Arena battlemasters are in the southeast lower city, along the wall.','The Arena battlemasters are in the southeast lower city, along the wall.',26124),
(25123,'enUS','','These stones should be the last of them. Our coordination with Neptulon\'s forces will be impeccable.',26124),
(25124,'enUS','','Yess. The Tidehunter will be pleased at this development. The Firelord\'s hold will weaken.',26124),
(25126,'enUS','','And your own preparations? Will the Frost Lord have a path to the portal?',26124),
(25127,'enUS','','Skar\'this has informed us well. We have worked our way into the slave pens and await your cryomancerss.',26124),
(25128,'enUS','','The ritual in Coilfang will bring Ahune through once he is fully prepared, and the resulting clash between Firelord and Frostlord will rend the foundations of this world. Our ultimate goals are in reach at last....',26124),
(25129,'enUS','The flag carriers have become vulnerable to attack!','',26124),
(25130,'enUS','The flag carriers have become increasingly vulnerable to attack!','',26124),
(25131,'enUS','While Nesingwary\'s advances upon the wildlife of Northrend has been halted, it is only a matter of time before he attempts another incursion. You must remain vigilant, $n!$B$BAbove all else, do not give in to whatever temptations may be set before you... The demon will attempt to charm you. When it happens, you must resist!','',26124),
(25132,'enUS','Fezzix, I think we\'ve solved your little engine problem.','',26124),
(25133,'enUS','Keep \'em hot you big dummy!','',26124),
(25134,'enUS','Those weapons ain\'t gonna build themselves! Faster!','',26124),
(25135,'enUS','You call that a hammer strike? What kind of amateurs am I workin\' with here?','',26124),
(25136,'enUS','You keep that garbage up and I\'ll ship you back to your momma in a box with a note strapped to your chest that reads: FAILURE.','',26124),
(25137,'enUS','And WHAT are our soldiers supposed to do with that shoddy piece of junk?','',26124),
(25138,'enUS','You\'re an embarassment to this entire operation! Pack up your stuff and get out!','',26124),
(25139,'enUS','With all these new parts, I can finally turn this hunk o\' junk into a flying machine!','',26124),
(25140,'enUS','Why won\'t this engine work? What\'s wrong with the power cells we recovered?','',26124),
(25141,'enUS','Back to square one, I guess. What\'s it going to take to get this thing off the ground?','',26124),
(25142,'enUS','Fezzix, I\'ve tried to tell you all that technical mumbo-jumbo you put your faith in would fail you. Luckily, I think I know an alternative.','',26124),
(25143,'enUS','It\'s really going to work this time... right?','',26124),
(25144,'enUS','Eat, brother wolf... Gather your strength.','',26124),
(25145,'enUS','Tomorrow we battle, brother. Today we feed.','',26124),
(25146,'enUS','You make me proud, brother wolf.','',26124),
(25147,'enUS','Eat now, brother. Feast, for tomorrow may never come...','',26124),
(25148,'enUS','It works, Dorain! Look! It actually works...','',26124),
(25149,'enUS','You will not master me, puny $r!','',26124),
(25150,'enUS','Here I goooooooooo!','',26124),
(25151,'enUS','OUCH!','',26124),
(25152,'enUS','I give up! So much for goblin ingenuity!','',26124),
(25153,'enUS','The Frost Lord has won.','',26124),
(25154,'enUS','What\'s this meeting about?','What\'s this meeting about?',26124),
(25155,'enUS','These tools are junk!','These tools are junk!',26124),
(25156,'enUS','How do they expect us to craft with these things!','How do they expect us to craft with these things!',26124),
(25157,'enUS','Are they all there?','',26124),
(25158,'enUS','All but one.','',26124),
(25159,'enUS','That\'s good enough for me.','',26124),
(25160,'enUS','Can I have your attention for a moment!\n','',26124),
(25161,'enUS','Because you\'re talkin\' about what? Talkin\' about the arclight spanner, whining about the smelting requirements of hardened adamantite, cryin\' about some gnome that ripped you off...','',26124),
(25162,'enUS','Let\'s talk about somethin\' important.','',26124),
(25163,'enUS','Put that Morning Glory dew DOWN! Morning Glory dew is for crafters only.','',26124),
(25164,'enUS','Do you think I\'m messin\' with you? I am not messin\' with you. I\'m here from Orgrimmar. I\'m here from Nogg\'s Machine Shop and I\'m here on a mission of mercy.','',26124),
(25165,'enUS','Your name\'s Leveny?','',26124),
(25166,'enUS','Yea.','',26124),
(25167,'enUS','And you call yourself a crafter, you son-of-a-gnome?','',26124),
(25168,'enUS','I don\'t have to listen to your guff, mister!','I don\'t have to listen to your guff, mister!',26124),
(25169,'enUS','You certainly don\'t pal, \'cause the good news is YOU\'RE FIRED! The bad news is you\'ve got - you\'ve all got - just one week to regain your jobs, starting tonight. Starting with tonight\'s build.','',26124),
(25170,'enUS','Oh... Have I got your attention now? Good, \'cause we\'re adding a little something to this month\'s crafting contest.','',26124),
(25171,'enUS','As you all know, first prize is a Turbo-Charged Flying Machine. Anyone want to see second prize?','',26124),
(25172,'enUS','Second prize is some fused wiring.','',26124),
(25173,'enUS','Third prize is YOU\'RE FIRED! You get the picture?','',26124),
(25174,'enUS','You\'re laughin\' now? You got tools! Thrall paid good money for those tools. Get out your blueprints and read them! If you can\'t build siege engines with the tools you\'re given, you can\'t build nothin\', you are nothin\', hit the bricks pal and take the first zeppelin out of here \'cause you are going out!','',26124),
(25175,'enUS','The tools are weak!','',26124),
(25176,'enUS','The tools are weak? You\'re weak! I\'ve been in this business fifty years.\n','',26124),
(25177,'enUS','Say, what\'s your name?','Say, what\'s your name?',26124),
(25178,'enUS','Gnome lover, that\'s my name! You know why, buddy? \'Cause you rode into this shop on a broken down unicycle and I flew in here on a 5,000 gold piece, top of the line, armored wyvern. THAT\'S my name!','',26124),
(25179,'enUS','A-B-C. A-always, B-be, C-crafting. Always be crafting. Always be crafting!','',26124),
(25180,'enUS','Cast with string ID on Action...','',26124),
(25181,'enUS','Cast with string ID in spell...','',26124),
(25182,'enUS','You\'re such a hero, you\'ve got so much gold - why you coming down here and wasting your time on a bunch of losers?','You\'re such a hero, you\'ve got so much gold - why you coming down here and wasting your time on a bunch of losers?',26124),
(25183,'enUS','You see this kodo? DO YOU SEE THIS KODO? This kodo cost more than that toolbox you call a house. You see, pal, that\'s who I am. And you\'re nothin\'.','',26124),
(25184,'enUS','Using this orb will create a portal leading to Naxxanar.','',26124),
(25185,'enUS','Use the orb.','Use the orb.',26124),
(25186,'enUS','These are the new tools. These are the Gadgetzan Power tools. And to you, they\'re gold. And you don\'t get \'em. Because to give them to you is just like throwin\' them into a scrap heap. They\'re for crafters. Crafters only!','',26124),
(25187,'enUS','It takes brass ball-bearings to craft siege engines for the Horde. Now get with the program or hit the bricks!','',26124),
(25188,'enUS','This orb will create a portal to Upper Naxxanar.','',26124),
(25189,'enUS','This orb will create a portal that will return you to the Temple City of En\'kilah.','',26124),
(25190,'enUS','Anveena, you must awaken! This world needs you!','',26124),
(25191,'enUS','You must let go! You must become what you were always meant to be! The time is now Anveena!','',26124),
(25192,'enUS','Anveena I love you! Focus on my voice! Come back for me now! Only you can cleanse the Sunwell!','',26124),
(25193,'enUS','Yes Anveena! Let fate embrace you now!','',26124),
(25194,'enUS','Goodbye Anveena, my love. Few will remember your name, yet this day you changed the course of destiny. What was once corrupt, is now pure. Heroes, do not let her sacrifice be in vain.','',26124),
(25195,'enUS','','I serve only the master now.',26124),
(25196,'enUS','','But I\'m... lost. I cannot find my way back.',26124),
(25197,'enUS','','Kalec... Kalec?',26124),
(25198,'enUS','','The nightmare is over! The spell is broken! Goodbye Kalec, my love!',26124),
(25199,'enUS','Aggghh! The powers of the Sunwell... turn... against me! What have you done? What have you done???','',26124),
(25200,'enUS','Unit entering energy conservation mode.','',26124),
(25201,'enUS','Local proximity threat detected. Exiting energy conservation mode.','',26124),
(25202,'enUS','Enemies spotted! Attack while I try to activate a Protector!','Enemies spotted! Attack while I try to activate a Protector!',26124),
(25203,'enUS','Enemy presence detected.','',26124),
(25204,'enUS','','Now, $n, let us release their souls and hear what they have to say.',26124),
(25205,'enUS','Thank you for saving us. We accidentally uncovered the pieces of Gearmaster Mechazod and reassembled him.','Thank you for saving us. We accidentally uncovered the pieces of Gearmaster Mechazod and reassembled him.',26124),
(25206,'enUS','Unit is now operational and attacking targets.','',26124),
(25207,'enUS','In return, he \'de-cursed\' us, saying that we were being \'fixed\' by returning us to the state of being mechanical constructs.','In return, he \'de-cursed\' us, saying that we were being \'fixed\' by returning us to the state of being mechanical constructs.',26124),
(25208,'enUS','He claims that all creations of the Titans fall prey to what he calls, \'The Curse of Flesh\'. He says that the original gnomes were once mechagnomes.','He claims that all creations of the Titans fall prey to what he calls, \'The Curse of Flesh\'. He says that the original gnomes were once mechagnomes.',26124),
(25209,'enUS','He\'s quite insane! Someone must put a stop to his madness before it\'s too late for everyone!','He\'s quite insane! Someone must put a stop to his madness before it\'s too late for everyone!',26124),
(25210,'enUS','Taking Readings','',26124),
(25211,'enUS','','This is dire news indeed!',26124),
(25212,'enUS','','I\'ll be damned if these blasted Scourge are going to drive us away!  Us settlers gave everything up to start new lives in Northrend.$B$BYou\'d better believe we\'re going to fight tooth and nail.',26124),
(25213,'enUS','This shard of ice echoes the deep, cracking rumble of invading glaciers.  Its cold turns your thoughts to a lifeless, endless winter.','',26124),
(25214,'enUS','Summon Ahune, the Frost Lord.','Summon Ahune, the Frost Lord.',26124),
(25215,'enUS','There is a noise from behind you!','',26124),
(25216,'enUS','Greetings, $n. I am Durkot Wolfbrother, protector of the pack.','',26124),
(25217,'enUS','The stone radiates a bitter cold, chilling the air around it and the platform on which it sits. Deep within its facets, a blue light pulses, waiting.','The stone radiates a bitter cold, chilling the air around it and the platform on which it sits. Deep within its facets, a blue light pulses, waiting.',26124),
(25218,'enUS','Lay your hand on the stone.','Lay your hand on the stone.',26124),
(25219,'enUS','The Scourge are everywhere!  This is... a nightmare!','',26124),
(25220,'enUS','Come try your luck!','',26124),
(25221,'enUS','','Hold, friends! There is information to be had before this devil meets his fate!',26124),
(25222,'enUS','Puny lizard! Death is the only answer you\'ll find here!','',26124),
(25223,'enUS','Bagh! Your magic is weak!','',26124),
(25224,'enUS','I will crush you!','',26124),
(25225,'enUS','That was fun, but I still await a true challenge!','',26124),
(25226,'enUS','','Where is Anveena, demon? What has become of Kalec?',26124),
(25227,'enUS','','You will tell me where they are!',26124),
(25228,'enUS','','Speak! I grow weary of asking! ',26124),
(25229,'enUS','','Malygos, my lord... I did my... best.',26124),
(25230,'enUS','Arthas thinks a few of his undead bugs are going to send us running back to the Eastern Kingdoms... he\'s got another thing coming.','',26124),
(25231,'enUS','Dark forces are at work in this land, $n.  Keep your eyes open and your courage strong.','',26124),
(25232,'enUS','','The Agamath Gate has been breached!',26124),
(25233,'enUS','','The Rohendor Gate has been shattered! Move forward, champions!',26124),
(25234,'enUS','','The Archonisus Gate is no more! The way to the Sunwell is clear!',26124),
(25235,'enUS','Some of us get to avoid military duty.  A good fisherman\'s always handy... even generals need to eat.','',26124),
(25236,'enUS','This way, $g sir:ma\'am;.','',26124),
(25237,'enUS','What do you know about the Cult of the Damned?','What do you know about the Cult of the Damned?',26124),
(25238,'enUS','%s howls in compliance.','',26124),
(25239,'enUS','I have reason to believe you\'re involved in cultist activity.','I have reason to believe you\'re involved in cultist activity.',26124),
(25240,'enUS','Just another day workin\' the kitchen.  Sure gets dull after a while.','',26124),
(25241,'enUS','My shift\'s almost over.  Can\'t wait to catch some shut-eye, know what I mean?','',26124),
(25242,'enUS','How long have you worked for the Cult of the Damned?','How long have you worked for the Cult of the Damned?',26124),
(25243,'enUS','Well...','',26124),
(25244,'enUS','I suppose this is it, then?  I won\'t go down quietly!','',26124),
(25245,'enUS','Finally!  This charade is over... Arthas give me strength!','',26124),
(25246,'enUS','You don\'t know who you\'re messing with, $c!  Death beckons!','',26124),
(25247,'enUS','I can teleport you to another race\'s zone.','I can teleport you to another race\'s zone.',26124),
(25248,'enUS','Human','Human',26124),
(25249,'enUS','Orc & Troll','Orc & Troll',26124),
(25250,'enUS','Dwarf & Gnome','Dwarf & Gnome',26124),
(25251,'enUS','Night Elf','Night Elf',26124),
(25252,'enUS','Undead','Undead',26124),
(25253,'enUS','Tauren','Tauren',26124),
(25254,'enUS','Blood Elf','Blood Elf',26124),
(25255,'enUS','Draenei','Draenei',26124),
(25256,'enUS','','',26124),
(25257,'enUS','Need gold? Here\'s 5,000 coins worth.','Need gold? Here\'s 5,000 coins worth.',26124),
(25258,'enUS','5,000 Gold','5,000 Gold',26124),
(25259,'enUS','I can stable your pets and maximize their loyalty.','I can stable your pets and maximize their loyalty.',26124),
(25260,'enUS','Pet Loyalty','Pet Loyalty',26124),
(25261,'enUS','Madrigosa deserved a far better fate. You did what had to be done, but this battle is far from over!','',26124),
(25262,'enUS','Stable','Stable',26124),
(25263,'enUS','I am forever in your debt. Once we have triumphed over Kil\'jaeden, this entire world will be in your debt as well.','',26124),
(25264,'enUS','','Arthas was once a human prince.  The army he led into Northrend suffered a horrible fate.$B$BMy brother, Thassarian, was a part of that army.',26124),
(25265,'enUS','I am ready to leave, Durkot.','I am ready to leave, Durkot.',26124),
(25266,'enUS','My fastest wolf is ready to take you to Taunka\'le Village, champion. Let me know when you are ready.','',26124),
(25267,'enUS','$g Sir:Ma\'am;, my life for the Horde!','$g Sir:Ma\'am;, my life for the Horde!',26124),
(25268,'enUS','Welcome back, champion.','Welcome back, champion.',26124),
(25269,'enUS','It is an honor to serve along your side, $g sir:ma\'am;.','It is an honor to serve along your side, $g sir:ma\'am;.',26124),
(25270,'enUS','Lok\'tar ogar!','Lok\'tar ogar!',26124),
(25271,'enUS','Throm-Ka, hero!','Throm-Ka, hero!',26124),
(25272,'enUS','With your strength and determination, we cannot fail!','With your strength and determination, we cannot fail!',26124),
(25273,'enUS','There walks a hero!','There walks a hero!',26124),
(25274,'enUS','It\'s $n! Bow your heads!','It\'s $n! Bow your heads!',26124),
(25275,'enUS','%s cheers at you.','%s cheers at you.',26124),
(25276,'enUS','We\'re miners, farmers and craftsmen - not soldiers.  But we\'ll defend our land with our bare fists if we must.','',26124),
(25277,'enUS','Sorry, but my services are only of use to hunters.','Sorry, but my services are only of use to hunters.',26124),
(25278,'enUS','Sorry, but my services are only of use to druids.','Sorry, but my services are only of use to druids.',26124),
(25280,'enUS','How may I help you, $c?','How may I help you, $c?',26124),
(25281,'enUS','Training','Training',26124),
(25282,'enUS','Unlearn Talents','Unlearn Talents',26124),
(25283,'enUS','is steamed!','',26124),
(25284,'enUS','I can erase all your talents so that you may choose new ones.$b$bThis becomes more expensive each time you do it.','I can erase all your talents so that you may choose new ones.$b$bThis becomes more expensive each time you do it.',26124),
(25285,'enUS','Confirm Unlearn Talents','Confirm Unlearn Talents',26124),
(25286,'enUS','Sorry, but my services are only of use to hunters.','Sorry, but my services are only of use to hunters.',26124),
(25287,'enUS','Sorry, but my services are only of use to mages.','Sorry, but my services are only of use to mages.',26124),
(25288,'enUS','Sorry, but my services are only of use to paladins.','Sorry, but my services are only of use to paladins.',26124),
(25289,'enUS','Sorry, but my services are only of use to priests.','Sorry, but my services are only of use to priests.',26124),
(25290,'enUS','Sorry, but my services are only of use to rogues.','Sorry, but my services are only of use to rogues.',26124),
(25291,'enUS','Sorry, but my services are only of use to shamans.','Sorry, but my services are only of use to shamans.',26124),
(25292,'enUS','Sorry, but my services are only of use to warlocks.','Sorry, but my services are only of use to warlocks.',26124),
(25293,'enUS','Sorry, but my services are only of use to warriors.','Sorry, but my services are only of use to warriors.',26124),
(25294,'enUS','Stop!','Stop!',26124),
(25295,'enUS','%s places a hand on the ground.','%s places a hand on the ground.',26124),
(25296,'enUS','What will become of us?','What will become of us?',26124),
(25297,'enUS','Is it really over? Is this the end of the taunka?','Is it really over? Is this the end of the taunka?',26124),
(25298,'enUS','So this is how it ends? A pity...','So this is how it ends? A pity...',26124),
(25299,'enUS','Look out!','Look out!',26124),
(25300,'enUS','Join us.','Join us.',26124),
(25301,'enUS','Death is the only salvation...','Death is the only salvation...',26124),
(25302,'enUS','Don\'t fight it...','Don\'t fight it...',26124),
(25303,'enUS','I was raised on this land... taught to hunt on this very tundra.','I was raised on this land... taught to hunt on this very tundra.',26124),
(25304,'enUS','%s cries.','%s cries.',26124),
(25305,'enUS','I... I don\'t think I can make it...','I... I don\'t think I can make it...',26124),
(25306,'enUS','Give me a moment to catch my breath.','Give me a moment to catch my breath.',26124),
(25307,'enUS','I am ready. Let us continue.','I am ready. Let us continue.',26124),
(25308,'enUS','Can I get you anything?  My selection is a little limited, but that\'s to be expected... all things considered.','',26124),
(25309,'enUS','Huh?','',26124),
(25310,'enUS','Dying for one\'s country is a soldier\'s duty.  But if calling this war folly is treason, then I\'m a traitor.','',26124),
(25311,'enUS','%s points northeast.','%s points northeast.',26124),
(25312,'enUS','The smoke in the distance... It is Wartook. He is trying to tell us something...','The smoke in the distance... It is Wartook. He is trying to tell us something...',26124),
(25313,'enUS','No... It cannot be true...','No... It cannot be true...',26124),
(25314,'enUS','Icemist... Not Icemist... NO!!! Come quickly, hero! Follow me!','Icemist... Not Icemist... NO!!! Come quickly, hero! Follow me!',26124),
(25315,'enUS','%s expertly identifies the messages hidden within the smoke signals.','%s expertly identifies the messages hidden within the smoke signals.',26124),
(25316,'enUS','','I\'m very busy right now, $r. Please leave me alone.',26124),
(25317,'enUS','','What happened, $n? Where is the evacuee that I entrusted you with?',26124),
(25318,'enUS','I regret to inform you that the evacuee I was charged with escorting is no more. Would you please allow me to escort another evacuee? I won\'t fail you again!','I regret to inform you that the evacuee I was charged with escorting is no more. Would you please allow me to escort another evacuee? I won\'t fail you again!',26124),
(25319,'enUS','','Hurry, $n! Get the evacuee to Wartook Iceborn in the Dragonblight!',26124),
(25320,'enUS','','Don\'t let me down again, $n. Make sure this evacuee reaches safety.',26124),
(25321,'enUS','Speak, Lich!  Undeath won\'t save you from what I\'ll put you through!','',26124),
(25322,'enUS','Hi $gmanly:womanly:c; $c, $ghow\'s it hangin?:you look pretty.;','Hello $gman:woman; how are you doing?',26124),
(25323,'enUS','Sleep now, young one....','',26124),
(25324,'enUS','A wonderful specimen.','',26124),
(25325,'enUS','Easy now, drakeling.','',26124),
(25326,'enUS','Yes, this one should advance my studies nicely....','',26124),
(25327,'enUS','New Pet','New Pet',26124),
(25328,'enUS','What sort of pet would you like?','What sort of pet would you like?',26124),
(25329,'enUS','I can both stable and give new pets.','I can both stable and give new pets.',26124),
(25330,'enUS','Bat','Bat',26124),
(25331,'enUS','Boar','Boar',26124),
(25332,'enUS','Carrion Bird','Carrion Bird',26124),
(25333,'enUS','Cat','Cat',26124),
(25334,'enUS','Dragonhawk','Dragonhawk',26124),
(25335,'enUS','Nether Ray','Nether Ray',26124),
(25336,'enUS','Bird of Prey','Bird of Prey',26124),
(25337,'enUS','Raptor','Raptor',26124),
(25338,'enUS','Ravager','Ravager',26124),
(25339,'enUS','Scorpid','Scorpid',26124),
(25340,'enUS','Serpent','Serpent',26124),
(25341,'enUS','Spider','Spider',26124),
(25342,'enUS','Warp Stalker','Warp Stalker',26124),
(25343,'enUS','Wind Serpent','Wind Serpent',26124),
(25344,'enUS','Wolf','Wolf',26124),
(25345,'enUS','Master... you want... I kill puny priest?  Make painful, yes?','',26124),
(25346,'enUS','Yes, weakling... beg Lurid for life!','',26124),
(25347,'enUS','You worship death, little man?  Death is here!','',26124),
(25348,'enUS','Arthas save us - we\'re doomed!','Arthas save us - we\'re doomed!',26124),
(25349,'enUS','The death knight... he\'s mad!','The death knight... he\'s mad!',26124),
(25350,'enUS','The ziggurat\'s lost!  Flee to the temple!','The ziggurat\'s lost!  Flee to the temple!',26124),
(25351,'enUS','[PH] - talks about the instability the nexus has been causing recently - about Malygos\' efforts to destroy the Kirin Tor and all mortal magic-users... Refers players to Raelorasz for more info about Malygos and the Nexus war.','',26124),
(25352,'enUS','Focus your mind, mortal. This is the front line of a war unlike any you\'ve witnessed.$b$bYou\'ll need full command of your faculties if you are to be of any use.','',26124),
(25353,'enUS','Please... all our orders come from Naxxanar... me and my men are kept in the dark!','',26124),
(25354,'enUS','I beg you, death knight!  Keep your minion away from me!  I\'ll do anything!','',26124),
(25355,'enUS','Mercy!  You were once with us!  Do you not remember?','',26124),
(25356,'enUS','Wating for dungeon particle effects to implement completion event for Buying Time quest.','',26124),
(25357,'enUS','My liege, the infiltration and control of the Alliance power structure by our cultists is well underway.','',26124),
(25358,'enUS','The power you\'ve bestowed upon me has granted me great mental influence over human minds.  I bear these offerings as proof of my progress.','',26124),
(25359,'enUS','Leryssa!','',26124),
(25360,'enUS','What have you done to my sister, you motherless elf scum!?','',26124),
(25361,'enUS','Allow me to take care of the intruders, lord.  I will feed their entrails to the maggots.','',26124),
(25362,'enUS','Your progress in this region has been impressive, blood prince.  I am pleased.','',26124),
(25363,'enUS','Now this is a surprise, Thassarian.  I hadn\'t heard from Mograine or the other death knights for months.  You\'ve come to rejoin the Scourge, I take it?','',26124),
(25364,'enUS','Do not fail me, San\'layn.  Return to Icecrown with this fool\'s head or do not bother to return.','',26124),
(25365,'enUS','Yes, my lord!','',26124),
(25366,'enUS','I would sooner slit my own throat.  You will pay for what you did to your own men, Arthas... for what you did to me!  I swear it.','',26124),
(25367,'enUS','What is that sound? Have the Twilight summoners arrived?','What is that sound? Have the Twilight summoners arrived?',26124),
(25368,'enUS','NO! It is too soon - Lord Ahune is not yet at full power!','NO! It is too soon - Lord Ahune is not yet at full power!',26124),
(25369,'enUS','I seem to have lost the Augmented Arcane Prison. Did I leave it here with you?','I seem to have lost the Augmented Arcane Prison. Did I leave it here with you?',26124),
(25370,'enUS','Here you are, $n.$b$bDo be more careful, won\'t you?','',26124),
(25371,'enUS','What is the cause of this conflict?','What is the cause of this conflict?',26124),
(25372,'enUS','You will not stop the Frost Lord from entering this world, mortal. The Tidehunter\'s might will crush that of Ragnaros once and for all, leaving your land a frozen paradise!','You will not stop the Frost Lord from entering this world, mortal. The Tidehunter\'s might will crush that of Ragnaros once and for all, leaving your land a frozen paradise!',26124),
(25373,'enUS','When Ahune surfaces, will we be ready?','When Ahune surfaces, will we be ready?',26124),
(25374,'enUS','You must survive Ahune\'s minions while we channel our flames.  Do not approach the Frost Lord until we can wither him.','You must survive Ahune\'s minions while we channel our flames.  Do not approach the Frost Lord until we can wither him.',26124),
(25375,'enUS','Strike now!  Strike Ahune\'s frozen core while he is weakened!','Strike now!  Strike Ahune\'s frozen core while he is weakened!',26124),
(25376,'enUS','The frozen deep beckons, $r!  Join us!','',26124),
(25377,'enUS','The phylactery is not yours to take, $n!  You will pay for your transgression.','',26124),
(25378,'enUS','The land is in great upheaval!$B$BThe Dark One rides forth again with his San\'layn, the dragons fight in their great Nexus War, and the vrykul are reawakened.$B$BYour people sail north on your wooden ships to fight them and one another, and we Kalu\'ak are caught in the middle.$B$BAnd now some great evil has been done so that the land explodes with the magical power of the world. We must find a safe haven where we will have a chance to survive.$B$BThese two ambassadors make my head hurt... perhaps you can help my people, $r?','',26124),
(25379,'enUS','Boy, what I wouldn\'t give for a bowl of old Salma Saldean\'s Westfall stew right about now.','',26124),
(25380,'enUS','Gruel and hardtack are no way to survive.','',26124),
(25381,'enUS','Y\'know, it\'s not really Saldean\'s recipe.','',26124),
(25382,'enUS','It\'s not Salma Saldean\'s recipe. It\'s my Ma\'s. She asked some passerby to deliver it to Salma right before she and Pa left Westfall with Old Blanchy.','',26124),
(25383,'enUS','What?','',26124),
(25384,'enUS','I am prepared to face Saragosa!','I am prepared to face Saragosa!',26124),
(25385,'enUS','Yeah? Well, at least the Saldeans didn\'t flee Westfall when things got tough.','',26124),
(25386,'enUS','Don\'t look so smug! I know what you\'re thinking, but Tempest Keep was merely a setback. Did you honestly believe I would trust the future to some blind, half-night elf mongrel?','',26124),
(25387,'enUS','Oh no, he was merely an instrument, a stepping stone to a much larger plan! It has all led to this... and this time you will not interfere!','',26124),
(25388,'enUS','Vengeance burns!','',26124),
(25389,'enUS','Felomin Ashal! ','',26124),
(25390,'enUS','I\'ll turn your world... upside... down.','',26124),
(25391,'enUS','Master, grant me strength.','',26124),
(25392,'enUS','Do not get... too comfortable.','',26124),
(25393,'enUS','My demise accomplishes nothing! The master will have you! You will drown in your own blood! The world shall burn! Aaaghh!','',26124),
(25394,'enUS','','It is truly a pleasure to see you again, $n.',26124),
(25395,'enUS','No one insults Ma and Pa! Take it back!','',26124),
(25396,'enUS','You heard what I said! Your parents are cowards, and so are you, Furlbrow!','',26124),
(25397,'enUS','The Kvaldir are without mercy, $n.  But I cannot abandon sacred Kaskala.  If we don\'t abandon the spirits, the spirits will not abandon us either.','',26124),
(25398,'enUS','Kaskala\'s under attack!  We must hold them off until we can escape.','',26124),
(25399,'enUS','OK, I take it back! Your Ma and Pa weren\'t cowards!','',26124),
(25400,'enUS','Cursed giant-men!  If they want a fight, a fight they\'ll get!','',26124),
(25401,'enUS','Glad you decided to see things my way...','',26124),
(25402,'enUS','Welcome, $c. Have you come to honor this flame?$b$bRemember: Our festival fires burn in every land with a Horde settlement. Make time to honor each of them, if you can.$b$bThe Alliance, too, burns fires of their own. You would do well to desecrate such unworthy efforts when you see them.','Welcome, $c. Have you come to honor this flame?$b$bRemember: Our festival fires burn in every land with a Horde settlement. Make time to honor each of them, if you can.$b$bThe Alliance, too, burns fires of their own. You would do well to desecrate such unworthy efforts when you see them.',26124),
(25403,'enUS','Mortal heroes - your victory here today was foretold long ago. My brother\'s anguished cry of defeat will echo across the universe - bringing renewed hope to all those who still stand against the Burning Crusade.','',26124),
(25404,'enUS','As the Legion\'s final defeat draws ever-nearer, stand proud in the knowledge that you have saved worlds without number from the flame.\n','',26124),
(25405,'enUS','Just as this day marks an ending, so too does it herald a new beginning...\n','',26124),
(25406,'enUS','Just as this day marks an ending, so too does it herald a new beginning...\n','',26124),
(25407,'enUS','The creature Entropius, whom you were forced to destroy, was once the noble naaru, M\'uru. In life, M\'uru channeled vast energies of LIGHT and HOPE. For a time, a misguided few sought to steal those energies...','',26124),
(25408,'enUS','','Our arrogance was unpardonable. We damned one of the most noble beings of all. We may never atone for this sin.',26124),
(25409,'enUS','Then fortunate it is, that I have reclaimed the noble naaru\'s spark from where it fell! Where faith dwells, hope is never lost, young blood elf.','',26124),
(25410,'enUS','','Can it be?',26124),
(25411,'enUS','Gaze now, mortals - upon the HEART OF M\'URU! Unblemished. Bathed by the light of Creation - just as it was at the Dawn.','',26124),
(25412,'enUS','In time, the light and hope held within - will rebirth more than this mere fount of power... Mayhap, they will rebirth the soul of a nation. \n','',26124),
(25413,'enUS','','Blessed ancestors! I feel it... so much love... so much grace... there are... no words... impossible to describe...',26124),
(25414,'enUS','Salvation, young one. It waits for us all.','',26124),
(25415,'enUS','Farewell...','',26124),
(25416,'enUS','The ore cart squeaks against the rails as it is released.','',26124),
(25417,'enUS','Do not be disheartened. Silvermoon will remain strong through this course of events.','',26124),
(25418,'enUS','Untrain Pet','Untrain Pet',26124),
(25419,'enUS','I can erase all your pet\'s talents so that you may teach it ones.$b$bThis becomes more expensive each time you do it.','I can erase all your pet\'s talents so that you may teach it ones.$b$bThis becomes more expensive each time you do it.',26124),
(25420,'enUS','Confirm Untrain Pet','Confirm Untrain Pet',26124),
(25421,'enUS','This young tuskarr appears to have been slain in combat rather than drowned.','',26124),
(25422,'enUS','<Search corpse for Issliruk\'s Totem.>','<Search corpse for Issliruk\'s Totem.>',26124),
(25423,'enUS','You only waste my time!','',26124),
(25424,'enUS','My hunger knows no bounds!','',26124),
(25425,'enUS','Yes!! I am a god!','',26124),
(25426,'enUS','No... more, I must have more!!','',26124),
(25427,'enUS','I am invincible!','',26124),
(25428,'enUS','Enough distractions!','',26124),
(25429,'enUS','I am... invinc--','',26124),
(25430,'enUS','','Annihilate them.',26124),
(25431,'enUS','','Not what I had... planned.',26124),
(25432,'enUS','','Oh, the horror!',26124),
(25433,'enUS','','Well aren\'t you lucky?',26124),
(25434,'enUS','','Now I\'m getting annoyed.',26124),
(25435,'enUS','','Lackeys be damned! I\'ll finish you myself!',26124),
(25436,'enUS','','I call that a good start.',26124),
(25437,'enUS','','I could have sworn there were more of you...',26124),
(25438,'enUS','','Not really much of a \"group\" anymore, is it?',26124),
(25439,'enUS','','One is such a lonely number.',26124),
(25440,'enUS','','It\'s been a kick, really.',26124),
(25441,'enUS','Keristrasa, I am finished here. Please return me to the Transitus Shield.','Keristrasa, I am finished here. Please return me to the Transitus Shield.',26124),
(25442,'enUS','The Festival Talespinner asked me to speak with you.','The Festival Talespinner asked me to speak with you.',26124),
(25443,'enUS','Then I am glad you came. Now that you know of our fires, and of honoring them... and of the fires of our enemies, and of extinguishing them... you may return to him and be rewarded.','Then I am glad you came. Now that you know of our fires, and of honoring them... and of the fires of our enemies, and of extinguishing them... you may return to him and be rewarded.',26124),
(25444,'enUS','Then I am glad you came. Now that you know of our fires, and of honoring them... and of the fires of our enemies, and of extinguishing them... you may return to him and be rewarded.','Then I am glad you came. Now that you know of our fires, and of honoring them... and of the fires of our enemies, and of extinguishing them... you may return to him and be rewarded.',26124),
(25445,'enUS','The Festival Loremaster asked me to speak with you.','The Festival Loremaster asked me to speak with you.',26124),
(25446,'enUS','','$n! I\'ve been wondering how you were. What\'s kept you?',26124),
(25447,'enUS','','I trust you\'re taking every precaution....$b$bThis is a dangerous place and I couldn\'t forgive myself if something were to happen to you.',26124),
(25448,'enUS','','We must hurry, $n. Malygos\' ruinous plans will soon be irreversible.',26124),
(25449,'enUS','','In times such as these, dear friends are invaluable.$b$bBe safe, $n. As safe as one can be in a place like this....',26124),
(25450,'enUS','','If you hadn\'t rescued me from that prison I surely would have succumbed by now.$b$bI have not forgotten....',26124),
(25451,'enUS','Show no mercy!  Kill every last one of the tuskarr!','',26124),
(25452,'enUS','','When our duty here is behind us, I shall find a way to repay you for my rescue.',26124),
(25453,'enUS','','My strength is returning, slowly....$b$bI hope to be able to show you the glory of my true form soon.',26124),
(25454,'enUS','Fight on, Kvaldir!  We\'ll burn Kaskala to the ground!','',26124),
(25455,'enUS','These tuskarr have seen nothing!  Show them what we\'re capable of!','',26124),
(25456,'enUS','Kill them!  Kill them all!','',26124),
(25457,'enUS','','Oh....$b$bWhere am I?',26124),
(25458,'enUS','In a word, magic.$b$bIrresponsible mortals with their brief lifespans think nothing of the lasting effects of their actions.$b$bArcane energies have been tapped too liberally, disrupting the world\'s balance. If this is allowed to continue, Azeroth will soon be annihilated.$b$bOn this, both sides agree. But before a council could even be appointed, Malygos put his own plan into action.$b$bWe had no choice but to confront him.','',26124),
(25459,'enUS','Who is Malygos?','Who is Malygos?',26124),
(25460,'enUS','We\'re making progress, $r, but far too slowly.','',26124),
(25461,'enUS','We must succceed! Azeroth\'s fate lies in the balance....','',26124),
(25462,'enUS','Malygos the Spellweaver, the Lord of Magic, Master of the Blue Dragonflight. He is the blue dragon aspect, one of the most ancient creatures on Azeroth.$b$bHe is said to be recovering from a madness which has lasted for millennia, but his recent actions lead me to believe that he is still far from sane.$b$bHis solution to our dilemma is to search out and destroy every magic-wielding mortal on Azeroth.$b$bAs the guardians of life, this has forced the red dragonflight to take action.$b$bDragon now fights against dragon, and the fate of our frail world lies in the balance.','',26124),
(25463,'enUS','','Raelorasz, it is good to see you again.',26124),
(25464,'enUS','Keristrasza! I wish that circumstances allowed for a more fitting welcome. Fate has been kind to return you to us.','',26124),
(25465,'enUS','Fate has been kind to return you to us.','',26124),
(25466,'enUS','','Fate, it seems, has been more than kind. A blow has been dealt to Malygos. When he learns of it, I am confident he will leave the safety of the Nexus.',26124),
(25467,'enUS','Malygos - in the open? I hadn\'t dared hope for an opportunity such as this. I\'ll assemble our brethren at once!','',26124),
(25468,'enUS','Of course, my lady. Until we meet again...','',26124),
(25469,'enUS','','Prepare them well, Raelorasz. Malygos\' power is like nothing they\'ve seen. We will likely only delay his plans with this diversion.',26124),
(25471,'enUS','','%s smiles',26124),
(25472,'enUS','','Farewell, Raelorasz.',26124),
(25473,'enUS','Patience, $g dearest: dear; $n. The time is not quite right. Fire the flare again soon and we shall begin....','Patience, $g dearest: dear; $n. The time is not quite right. Fire the flare again soon and we shall begin....',26124),
(25474,'enUS','','Stay close to me, $n. I could not bear for any harm to come to you.',26124),
(25475,'enUS','','MALYGOS!!',26124),
(25476,'enUS','','Your precious consort has failed you. You shall be the next to fall!',26124),
(25477,'enUS','','Come, Lord of Magic, and recover your precious consort....',26124),
(25478,'enUS','','...what remains of her!',26124),
(25479,'enUS','','Come, $n. Let us see the fruits of our efforts.',26124),
(25480,'enUS','Saragosa! What has become of you?','',26124),
(25481,'enUS','','Come with me. It is not safe here.',26124),
(25482,'enUS','Intruders! Do not let them into the Sanctum!','',26124),
(25483,'enUS','Constructs, defend the capital at all costs!','',26124),
(25484,'enUS','To battle, my children! Show the enemy no mercy!','',26124),
(25485,'enUS','Keristrasza! You\'ve bested my consort... and now YOU shall take her place!','',26124),
(25486,'enUS','For the thane! For Loken!','',26124),
(25487,'enUS','Crush the children of stone, my iron brethren!','',26124),
(25488,'enUS','Enough! You\'ve bested my consort... and now YOU shall take her place!','',26124),
(25489,'enUS','','Never!',26124),
(25490,'enUS','The tyranny of iron is at an end!','',26124),
(25491,'enUS','','Hurry, $n! Flee! Live to finish what we\'ve begun here....',26124),
(25492,'enUS','Your masters will never conquer the stone!','',26124),
(25493,'enUS','Loken will never triumph!','',26124),
(25494,'enUS','We do not fear you, child of iron!','',26124),
(25496,'enUS','Aggh!! No longer will I be a slave to Malygos! Challenge me and you will be destroyed!','',26124),
(25497,'enUS','I will purge you!','',26124),
(25498,'enUS','Your pain has only begun!','',26124),
(25499,'enUS','In the name of Kil\'jaeden!','',26124),
(25500,'enUS','You were warned!','',26124),
(25501,'enUS','My awakening is complete! You shall all perish!','',26124),
(25502,'enUS','Kil\'jaeden must be destroyed!','',26124),
(25503,'enUS','The fate of the world hangs in the balance!','',26124),
(25504,'enUS','There will be no reprieve! My work here is nearly finished!','',26124),
(25505,'enUS','I\'m never on the... losing... side!','',26124),
(25506,'enUS','Your misery is my delight!','',26124),
(25507,'enUS','I will watch you bleed!','',26124),
(25508,'enUS','Piteous mortal!','',26124),
(25509,'enUS','Haven\'t you heard? I always win!','',26124),
(25510,'enUS','I have toyed with you long enough!','',26124),
(25511,'enUS','','Depravity...hatred...chaos. These are the pillars.',26124),
(25512,'enUS','','Misery...confusion...mistrust. These are the hallmarks.',26124),
(25513,'enUS','','Fire to the aid of shadow!',26124),
(25514,'enUS','','Fires consume.',26124),
(25515,'enUS','','Edir harach!',26124),
(25516,'enUS','','Sacrolash!',26124),
(25517,'enUS','','Your luck has run its course!',26124),
(25518,'enUS','','Der\'ek... manul.',26124),
(25519,'enUS','','Shadows engulf.',26124),
(25520,'enUS','','Ee-nok Kryul!',26124),
(25521,'enUS','','Time is a luxury you no longer possess!',26124),
(25522,'enUS','','I... fade.',26124),
(25523,'enUS','','I\'m glad you are here, $c. The military situation in the Sunwell Plateau is rather grim.',26124),
(25524,'enUS','Give me a situation report, Captain.','Give me a situation report, Captain.',26124),
(25525,'enUS','','The Shattered Sun Offensive has made great progress in the outer areas of the Isle of Quel\'Danas. Kil\'jaeden\'s forces are being pushed back, and in the chaos I was able to lead a small scouting force here inside the Sunwell Plateau. My troops proceeded through Parhelion Plaza, spotted a group of Sunblade blood elves, and we then engaged the enemy. That fight quickly turned into a disaster.',26124),
(25526,'enUS','What went wrong?','What went wrong?',26124),
(25527,'enUS','','Kil\'jaeden\'s defenders here on the Sunwell Plateau are much stronger than anything we faced outside on the Island. The Legion have even twisted our Arcane Guardian technology with fel energy to create something much more sinister. Just one of those Sunblade Protectors decimated my troops, and I ordered a swift retreat. I expected my squad to be pushed completely off the plateau, but the enemy surprised me by calling off the pursuit.',26124),
(25528,'enUS','Why did they stop?','Why did they stop?',26124),
(25529,'enUS','','I don\'t know, but I\'m glad they did. The respite has allowed Anchorite Elbadon to save many of the men and women under my command. I\'ve sent a few of my stealthiest scouts forward, and they\'ve reported back something interesting. Nearly all of the Sunblade Protectors are powered down! Kil\'jaeden\'s forces appear to be conserving their energy, and seem content to merely contain us with one active Protector. If you and your companions want to force your way inside, allow me to suggest a plan of attack.',26124),
(25530,'enUS','Your insight is appreciated.','Your insight is appreciated.',26124),
(25531,'enUS','','Take advantage of their deactivated Sunblade Protectors. If one of their Sunblade Scouts spot you, I\'m sure the elf will try to reactivate a nearby Sunblade Protector. Kill him quickly to prevent this. With the blood elves eliminated, as long as you do not trigger the Protector\'s proximity sensors you should be able to move past them without a fight. That will save you both time and resources.',26124),
(25532,'enUS','Captain Selana has instructed me to assist you with your efforts here on the Sunwell Plateau.','',26124),
(25533,'enUS','What is the current state of the Sunwell\'s Gates?','What is the current state of the Sunwell\'s Gates?',26124),
(25534,'enUS','Agamath, the First Gate has been breached. Two of Kil\'jaeden\'s most powerful lieutenants, Lady Sacrolash and Grand Warlock Alythess, are now vulnerable to attack.','',26124),
(25535,'enUS','All three barriers are fully operational. Consult with Archmage Ne\'thul in Sun\'s Reach Harbor to aid the effort in unlocking the gates.','',26124),
(25536,'enUS','Agamath, the First Gate and Rohendor, the Second Gate are now destroyed. Only Archonisus, the Third Gate remains.','',26124),
(25537,'enUS','All of the barriers blocking you from reaching the Sunwell have been destroyed. Enter the Sunwell and stop Kil\'jaeden from entering this world!','',26124),
(25538,'enUS','With Kalecgos freed, can you provide a teleport up to Apex Point?','With Kalecgos freed, can you provide a teleport up to Apex Point?',26124),
(25539,'enUS','Now that Lady Sacrolash and Grand Warlock Alythess have been defeated, can you teleport me to the Witch\'s Sanctum.','Now that Lady Sacrolash and Grand Warlock Alythess have been defeated, can you teleport me to the Witch\'s Sanctum.',26124),
(25540,'enUS','We\'ve cleared the way to Kil\'jaeden! Can you transport me close to the Sunwell?','We\'ve cleared the way to Kil\'jaeden! Can you transport me close to the Sunwell?',26124),
(25541,'enUS','You are not alone! The blue dragonflight shall help you vanquish the Deceiver!','',26124),
(25542,'enUS','I have empowered another orb! Use it quickly!','',26124),
(25543,'enUS','Another orb is ready! Make haste!','',26124),
(25544,'enUS','All my plans have led to this!','',26124),
(25545,'enUS','Stay on task, do not waste time!','',26124),
(25546,'enUS','I have waited long enough!','',26124),
(25547,'enUS','Fail me and suffer for eternity!','',26124),
(25548,'enUS','Drain the girl! Drain her power until there is nothing but a vacant shell!','',26124),
(25549,'enUS','Another step toward destruction!','',26124),
(25550,'enUS','Anakh Kyree!','',26124),
(25551,'enUS','Who can you trust!','',26124),
(25552,'enUS','The enemy is among you!','',26124),
(25553,'enUS','Chaos!','',26124),
(25554,'enUS','Destruction!','',26124),
(25555,'enUS','Oblivion!','',26124),
(25556,'enUS','What\'s that, girl? You\'re hungry already? Don\'t worry, I\'ll get the oats.','',26124),
(25557,'enUS','Now, where do they keep those oats?','',26124),
(25558,'enUS','Hmm... maybe over there.','',26124),
(25559,'enUS','No... no oats here, either.','',26124),
(25560,'enUS','What brings you to the Sunwell?','What brings you to the Sunwell?',26124),
(25561,'enUS','A friend and I have come to rescue a young human woman from the clutches of the Legionlord, Kil\'jaeden and his vile minions.$b$bWe\'ve discovered that Kael\'thas is trying to summon Kil\'jaeden from the depths of the Sunwell itself.$b$bFor the sake of this world - this cannot come to pass! I am committed to seeing that it does not.\n','',26124),
(25562,'enUS','You\'re not alone here?','You\'re not alone here?',26124),
(25563,'enUS','Madrigosa accompanied me on this journey, but we have become separated in the Sunwell.$b$bMay fate keep her safe.\n','',26124),
(25564,'enUS','What would Kil\'jaeden want with a mortal woman?','What would Kil\'jaeden want with a mortal woman?',26124),
(25565,'enUS','Anveena is no mere mortal, $r. Those who recognize her true nature stop at nothing to possess her.$b$bShe once rescued me, and now I intend to return the favor. ','',26124),
(25566,'enUS','Enjoying the festival, $c?$b$bWhile the Flame Keepers tend to the fires of the present, I am more of a historian, keeping close the festivals past. I\'m also, of course, documenting this year\'s festivities. Things are going well thus far, don\'t you think?$b$bYou know, $n, there is power inherent in all festival fires burning throughout the holiday. We\'re taking care of ours, but I\'m certain there are sacred flames burning deep within our enemy\'s cities...','Enjoying the festival, $c?$b$bWhile the Flame Keepers tend to the fires of the present, I am more of a historian, keeping close the festivals past. I\'m also, of course, documenting this year\'s festivities. Things are going well thus far, don\'t you think?$b$bYou know, $n, there is power inherent in all festival fires burning throughout the holiday. We\'re taking care of ours, but I\'m certain there are sacred flames burning deep within our enemy\'s cities...',26124),
(25567,'enUS','Welcome to our camp, $c. You\'re free to rest here if you\'d like.','Welcome to our camp, $c. You\'re free to rest here if you\'d like.',26124),
(25568,'enUS','I wish to buy from you.','I wish to buy from you.',26124),
(25569,'enUS','There is nothing left for us here.','There is nothing left for us here.',26124),
(25570,'enUS','My family was slaughtered without mercy. Even the young.','My family was slaughtered without mercy. Even the young.',26124),
(25571,'enUS','May the Lich King burn in hellfire for what he has called down upon this land.','May the Lich King burn in hellfire for what he has called down upon this land.',26124),
(25572,'enUS','We are a people without a home to call our own now.','We are a people without a home to call our own now.',26124),
(25573,'enUS','The Scourge are a fearless machine set to bring about the end of all life on this world.','The Scourge are a fearless machine set to bring about the end of all life on this world.',26124),
(25574,'enUS','The one that they call Hellscream might be our only hope.','The one that they call Hellscream might be our only hope.',26124),
(25575,'enUS','Only the Horde can save us now.','Only the Horde can save us now.',26124),
(25576,'enUS','Maybe this is it... the end of days is finally upon us.','Maybe this is it... the end of days is finally upon us.',26124),
(25577,'enUS','My mate was slain while I was made to watch. Only vengeance remains in my heart.','My mate was slain while I was made to watch. Only vengeance remains in my heart.',26124),
(25578,'enUS','If given the chance, we should join the Horde. The Scourge would crumble beneath our collective strength.','If given the chance, we should join the Horde. The Scourge would crumble beneath our collective strength.',26124),
(25579,'enUS','Arthas... I spit on Arthas.','Arthas... I spit on Arthas.',26124),
(25580,'enUS','We were attacked on the road across Transborea by necromancers. What was I to do?','We were attacked on the road across Transborea by necromancers. What was I to do?',26124),
(25581,'enUS','Is it cowardly to run when faced with your own end?','Is it cowardly to run when faced with your own end?',26124),
(25582,'enUS','Without Taunka\'le, life is no longer worth living.','Without Taunka\'le, life is no longer worth living.',26124),
(25583,'enUS','I pray they give me a chance to prove myself.','I pray they give me a chance to prove myself.',26124),
(25584,'enUS','Well whatever happens, we must make a decision as a group.','Well whatever happens, we must make a decision as a group.',26124),
(25585,'enUS','Goodbye, beloved tundra.','Goodbye, beloved tundra.',26124),
(25586,'enUS','Brrrr... It\'s cold up here.','',26124),
(25587,'enUS','Buckets! Where\'s my laundry?','',26124),
(25588,'enUS','I\'m working on it, Molsen. If you want it done faster, do it yourself.','',26124),
(25589,'enUS','','The Horde will protect the Taunka. Be calm, friend.',26124),
(25590,'enUS','No way.','',26124),
(25591,'enUS','I\'m a soldier, Buckets. You know, a fighting man... You\'re the laundry boy.','',26124),
(25592,'enUS','And not a very good one! Remember what you did to my tabard?','',26124),
(25593,'enUS','','I am your tauren sister, taunka. Our blood is the same, and because of this no harm will come to you now. You are safe.',26124),
(25594,'enUS','','Garrosh will soon be sending his most capable soldiers. It is they who will guide you into the open and waiting arms of the Horde.',26124),
(25595,'enUS','','You will soon be behind the impenetrable walls of Agmar\'s Hammer, taunka.',26124),
(25596,'enUS','','Salvation comes to those whose cause is righteous and true. Join us and you will be saved.',26124),
(25597,'enUS','That was entirely your own fault, Molsen. Maybe you\'ll know to separate your colors from now on...','',26124),
(25598,'enUS','The tabard was pink when I got it back, Buckets. Pink! Think about that...','',26124),
(25599,'enUS','The whole squad laughed at me for a week! Don\'t let it happen again!','',26124),
(25600,'enUS','Fine. Have it your way.','',26124),
(25601,'enUS','%s cheers at Emissary Brighthoof.','%s cheers at Emissary Brighthoof.',26124),
(25602,'enUS','%s cries tears of happiness.','%s cries tears of happiness.',26124),
(25603,'enUS','%s roars in approval!','%s roars in approval!',26124),
(25604,'enUS','What\'s wrong with you? That was dinner!','',26124),
(25605,'enUS','Now it\'s laundry.','',26124),
(25606,'enUS','You\'re dead, Buckets! You hear me? Dead!','',26124),
(25607,'enUS','%s thanks Emissary Brighthoof.','%s thanks Emissary Brighthoof.',26124),
(25608,'enUS','','Hello sir, I\'m ready to rock!',26124),
(25609,'enUS','','Hey guys, I\'m your biggest fan!  I\'m ready to rock!',26124),
(25610,'enUS','','Check this out guys!  I can rock like you guys!',26124),
(25611,'enUS','','Whoa!  I managed to impress Sig Nicious!  I saw him crack a smile!  I bet I can join them next year!',26124),
(25612,'enUS','','Salandria waves her hands in the air.',26124),
(25613,'enUS','','Salandria begins to play air guitar and sing The Power of the Horde.',26124),
(25614,'enUS','Thank the spirits!  The blizzard will slow down the kvadir ships!','',26124),
(25615,'enUS','The spirits have listened!  Can you feel it, $n?','',26124),
(25616,'enUS','The skeletal horse appears to look towards the nearby ziggurat.','',26124),
(25617,'enUS','I need you to take me to the lich\'s phylactery, Dusk.','I need you to take me to the lich\'s phylactery, Dusk.',26124),
(25618,'enUS','%s mutters to himself incomprensibly.','',26124),
(25619,'enUS','The %s looks around, confused.','',26124),
(25620,'enUS','A momentary flash of awareness fades quickly from the eyes of the %s.','',26124),
(25621,'enUS','The %s seems lost in the horror of his village\'s cataclysm.','',26124),
(25622,'enUS','Event heard. Spawn, damn you!','',26124),
(25623,'enUS','Drain... life!','',26124),
(25625,'enUS','Un...leash.','',26124),
(25626,'enUS','Un...con...tainable.','',26124),
(25627,'enUS','Con...sume.','',26124),
(25628,'enUS','Ah, more lambs to the slaughter!','',26124),
(25629,'enUS','Perish, insect!','',26124),
(25630,'enUS','You are meat!','',26124),
(25631,'enUS','Too easy!','',26124),
(25632,'enUS','Bring the fight to me!','',26124),
(25633,'enUS','Another day, another glorious battle!','',26124),
(25634,'enUS','I live for this!','',26124),
(25635,'enUS','So much for a real challenge. Die!','',26124),
(25636,'enUS','Agghh! Well done! Now this gets... interesting...','',26124),
(25637,'enUS','','Glory to Kil\'jaeden! Death to all who oppose!',26124),
(25638,'enUS','','Choke on your final breath!',26124),
(25639,'enUS','','I am stronger than ever before!',26124),
(25640,'enUS','','I kill for the master!',26124),
(25641,'enUS','','The end has come!',26124),
(25642,'enUS','','No more hesitation! Your fates are written!',26124),
(25643,'enUS','','Kil\'jaeden will... prevail!',26124),
(25644,'enUS','<Budd holds very still, pretending not to hear you. Looking closely you see a bit of drool drip from under his mask.>','',26124),
(25645,'enUS','<Budd rocks back and forth on his haunches, muttering something that sounds like troll speech.>','',26124),
(25646,'enUS','Go away, mon.','',26124),
(25647,'enUS','No time to be talkin\', mon. I be needin\' to rest now....','',26124),
(25648,'enUS','No time to be talkin\', mon. I be needin\' to rest now....','',26124),
(25649,'enUS','Worry no more, taunka. The Horde will save and protect you and your people, but first you must swear allegiance to the Warchief by taking the blood oath of the Horde.','Worry no more, taunka. The Horde will save and protect you and your people, but first you must swear allegiance to the Warchief by taking the blood oath of the Horde.',26124),
(25650,'enUS','Will the Horde grant me the chance to battle the Scourge?','Will the Horde grant me the chance to battle the Scourge?',26124),
(25651,'enUS','Yes, taunka. Retribution is a given right of all members of the Horde.','Yes, taunka. Retribution is a given right of all members of the Horde.',26124),
(25652,'enUS','To avenge my people, to drive out the blight that has engulfed our land - I will take your oath. I will pledge all that I have and all that I am to the Horde.','To avenge my people, to drive out the blight that has engulfed our land - I will take your oath. I will pledge all that I have and all that I am to the Horde.',26124),
(25653,'enUS','Then repeat after me: \"Lok\'tar ogar! Victory or death - it is these words that bind me to the Horde. For they are the most sacred and fundamental of truths to any warrior of the Horde.\n\nI give my flesh and blood freely to the Warchief. I am the instrument of my Warchief\'s desire. I am a weapon of my Warchief\'s command.\n\nFrom this moment until the end of days I live and die - For the Horde!\"\n','Then repeat after me: \"Lok\'tar ogar! Victory or death - it is these words that bind me to the Horde. For they are the most sacred and fundamental of truths to any warrior of the Horde.\n\nI give my flesh and blood freely to the Warchief. I am the instrument of my Warchief\'s desire. I am a weapon of my Warchief\'s command.\n\nFrom this moment until the end of days I live and die - For the Horde!\"',26124),
(25654,'enUS','Lok\'tar ogar! Victory or death - it is these words that bind me to the Horde. For they are the most sacred and fundamental of truths to any warrior of the Horde.$B$BI give my flesh and blood freely to the Warchief. I am the instrument of my Warchief\'s desire. I am a weapon of my Warchief\'s command.$B$BFrom this moment until the end of days I live and die - FOR THE HORDE!','Lok\'tar ogar! Victory or death - it is these words that bind me to the Horde. For they are the most sacred and fundamental of truths to any warrior of the Horde.$B$BI give my flesh and blood freely to the Warchief. I am the instrument of my Warchief\'s desire. I am a weapon of my Warchief\'s command.$B$BFrom this moment until the end of days I live and die - FOR THE HORDE!',26124),
(25655,'enUS','For the Horde!\n\nArm yourself from the crates that surround us and report to Agmar\'s Hammer, east of here. Your first trial as a member of the Horde is to survive the journey.\n\nLok\'tar ogar!','For the Horde!\n\nArm yourself from the crates that surround us and report to Agmar\'s Hammer, east of here. Your first trial as a member of the Horde is to survive the journey.\n\nLok\'tar ogar!',26124),
(25656,'enUS','Come on, Budd. Time to play with the ice trolls!','Come on, Budd. Time to play with the ice trolls!',26124),
(25657,'enUS','Oooh, Shiney!','',26124),
(25658,'enUS','Ey, mon! Take me to mah troll bruddas!','',26124),
(25659,'enUS','Time to play some troll tag, mon!','',26124),
(25660,'enUS','My troll bruddas be in for some real fun today, mon!','',26124),
(25661,'enUS','Hee hee hee! Dis gunna be some fun, mon!','',26124),
(25662,'enUS','You sure we be goin\' da right way, mon?','',26124),
(25663,'enUS','<sniff, sniff> I can smell \'em, mon.','',26124),
(25664,'enUS','Nuttin\' says luvin\' like a little tap on da noggin.','',26124),
(25666,'enUS','Ok, Budd. Go tag a troll....','Ok, Budd. Go tag a troll....',26124),
(25667,'enUS','Victory or death! For the Horde!','Victory or death! For the Horde!',26124),
(25668,'enUS','You be it now, brudda!','',26124),
(25669,'enUS','No, no, mon. Dere be no trolls here....','',26124),
(25670,'enUS','Ok, mon. Tell me when we be close to mah troll bruddas.','',26124),
(25671,'enUS','All three of the gates at the Sunwell Plateau have been brought down, $n.$B$BYou must marshal your forces and stop Kil\'jaeden from entering Azeroth before all is lost!','',26124),
(25672,'enUS','%s reads through the most recent entries in Brann\'s journal.','',26124),
(25673,'enUS','Astounding! It says here that Brann discovered a mysterious runic plate deep in Thor Modan!','',26124),
(25674,'enUS','Brann writes that he was working on a guide to these runic symbols when the giants and their allies attacked.','',26124),
(25675,'enUS','He reports deciphering part of the writing on the runic plate, but it doesn\'t look like he recorded his translation.','',26124),
(25676,'enUS','By Magni\'s beard, we\'ve got to reconstruct the runic key he used to read the plate. We could be right on his heels!','',26124),
(25677,'enUS','I lost the Flute of the Ancients and require a replacement, Eridan.','I lost the Flute of the Ancients and require a replacement, Eridan.',26124),
(25678,'enUS','Don\'t ya be hurtin\' me, mon!','',26124),
(25679,'enUS','Troll powah, mon!','',26124),
(25680,'enUS','What be wrong wit you, mon? Ain\'t ya never seen a troll before?','',26124),
(25681,'enUS','I be thinkin\' you don\'t know where to find mah bruddas, mon.','',26124),
(25682,'enUS','Forget it, mon. I go find me bruddas myself.','',26124),
(25683,'enUS','I think we be lost, mon....','',26124),
(25684,'enUS','The fallen of Pal\'ea will not rest, son.  Find the naga priestess!','',26124),
(25685,'enUS','','Riplash will never return to its former glory, but these boat-riding scum will pay for their deeds - I swear it!',26124),
(25686,'enUS','\'Shall return to the cradle of iron and stone.\'','\'Shall return to the cradle of iron and stone.\'',26124),
(25687,'enUS','\'In Loken\'s name, destroy the scions of stone.\'','\'In Loken\'s name, destroy the scions of stone.\'',26124),
(25688,'enUS','\'Return to Ulduar, nestled in the embrace of the storm.\'','\'Return to Ulduar, nestled in the embrace of the storm.\'',26124),
(25689,'enUS','\'Sons of iron, heed the call. Hurry hence to Ulduar.\'','\'Sons of iron, heed the call. Hurry hence to Ulduar.\'',26124),
(25690,'enUS','\'Greatest of the Maker\'s children, arise and claim your birthright.\'','\'Greatest of the Maker\'s children, arise and claim your birthright.\'',26124),
(25691,'enUS','','It is our duty to protect these taunka and provide them with what little comfort we can offer.',26124),
(25692,'enUS','Emissary, I misplaced the Blood Oath of the Horde. Could you please give me a replacement?','Emissary, I misplaced the Blood Oath of the Horde. Could you please give me a replacement?',26124),
(25693,'enUS','','These infants will live. With love and affection they will grow to be strong members of the Horde, and with time the horrible reminders of their shattered lives will fade.',26124),
(25694,'enUS','','There, there, sweetheart. Everything is going to be ok.',26124),
(25695,'enUS','','My little angel. Are you hungry? Will you eat for auntie Twinbreeze? Just a little?',26124),
(25696,'enUS','','This one will grow to be a great warrior. Won\'t you, darling?',26124),
(25697,'enUS','','Maybe you will be a shaman like your auntie Twinbreeze?',26124),
(25698,'enUS','%s cries.','',26124),
(25699,'enUS','Thank you again, $n, for this delectable incense.','',26124),
(25700,'enUS','Wake up, Griselda. Here, girl.','',26124),
(25701,'enUS','They\'ll never find us here, will they? We won\'t let them get us like they got Limpy Joe and Flannel McGee!','',26124),
(25702,'enUS','No, we escaped from those monsters! They\'re nothing like us, Griselda.','',26124),
(25703,'enUS','We\'re hunters, you and I. No wolfmen here, no ma\'am.','',26124),
(25704,'enUS','Keep an eye out for them, girl! Don\'t let them get us!','',26124),
(25705,'enUS','Kil\'jaeden begins to channel dark energy.','',26124),
(25706,'enUS','Rise weaklings!  Rise and serve the Scourge!','',26124),
(25707,'enUS','You will tell your commander that I will not wait a moment longer! Does he want this alliance or not?!','',26124),
(25708,'enUS','I have been waiting here for an eternity since our last meeting! When will Goramosh be done with his ritual?','',26124),
(25709,'enUS','Casting kill credit on $n','',26124),
(25710,'enUS','This is insufferable! I represent a nexus-prince, I am not to be made to wait! Goramosh should be waiting on me!','',26124),
(25711,'enUS','I was personally assured by Malygos that your commander would make the details of this accord his top priority. Now let me pass!','',26124),
(25712,'enUS','If I have to wait much longer, I will be forced to reconsider the proposed accord between the Ethereum and the Blue Dragonflight!','',26124),
(25713,'enUS','You are nothing but an underling! I will not wait a moment longer! Escort me to Goramosh immediately!','',26124),
(25715,'enUS','What\'s this, more delays?!','',26124),
(25716,'enUS','You\'re too late! The accord has been negotiated. Only the details remain. Small details... like you!','',26124),
(25717,'enUS','%s devours the incense.  It\'s ravenous!','',26124),
(25718,'enUS','So good!  So packed with energy!','',26124),
(25719,'enUS','It has everything a growing scorchling needs!','',26124),
(25720,'enUS','%s bellows with laughter!','',26124),
(25721,'enUS','Now!  Finally!  Our plans can take effect!','',26124),
(25722,'enUS','KNEEL, LITTLE MORTAL!  KNEEL BEFORE THE MIGHT OF THE HERALD OF RAGNAROS!','',26124),
(25723,'enUS','YOU WILL ALL PERISH IN FLAMES!','',26124),
(25724,'enUS','%s blinks...','',26124),
(25725,'enUS','Ah.  I was merely jesting...','',26124),
(25726,'enUS','I am taunka of the Horde and I have come to drive the Scourge from this world!','I am taunka of the Horde and I have come to drive the Scourge from this world!',26124),
(25727,'enUS','Amidst the tragedy and chaos, this place stands defiantly against the Scourge! It is good to be Horde.','Amidst the tragedy and chaos, this place stands defiantly against the Scourge! It is good to be Horde.',26124),
(25728,'enUS','I have come to kill or be killed!','I have come to kill or be killed!',26124),
(25729,'enUS','Nothing will stand in the way of vengeance!','Nothing will stand in the way of vengeance!',26124),
(25730,'enUS','I can feel the power SURGING within me!','',26124),
(25731,'enUS','Do you sell any of this stuff?','Do you sell any of this stuff?',26124),
(25732,'enUS','%s is entranced by the sun\'s reflection on Zeh\'gehn\'s knife.','',26124),
(25733,'enUS','%s croaks eagerly while directing its gaze to the docked ship.','',26124),
(25734,'enUS','Ku into me carver, ye ugly croaker!  Ku and show me who dares cross me brethren!','',26124),
(25735,'enUS','Yes, yes, I am given to understand that the ley line has already been diverted. I will wait no longer... summon Goramosh this instant!','',26124),
(25736,'enUS','Your surge needle appears to have worked perfectly.  Surely Goramosh now has time to speak further of the proposed accord?','',26124),
(25737,'enUS','What ye be lookin\' at, matey?','',26124),
(25738,'enUS','Ummm... the frog says you\'re a traitor, \"matey.\"','Ummm... the frog says you\'re a traitor, \"matey.\"',26124),
(25739,'enUS','What is it you need?','',26124),
(25740,'enUS','Have you discovered something?','',26124),
(25741,'enUS','The elemental spirits are restless...','',26124),
(25742,'enUS','I\'ve lost my totemic beacon - may I have another?','I\'ve lost my totemic beacon - may I have another?',26124),
(25743,'enUS','Do you really want to bribe Olga?','Do you really want to bribe Olga?',26124),
(25744,'enUS','I never understood why some pirates bury their treasure.  Me... I like to keep it within arm\'s reach.','',26124),
(25745,'enUS','LUNCH!','',26124),
(25746,'enUS','The great sea turtle Walker of Waves travels from this dock to Moa\'ki Harbor in Dragonblight.','',26124),
(25747,'enUS','I\'d like to take the great sea turtle to Moa\'ki Harbor.','I\'d like to take the great sea turtle to Moa\'ki Harbor.',26124),
(25748,'enUS','The steam-powered Alliance icebreaker Northspear sails from here to Menethil Harbor in the Wetlands, across the sea in the Eastern Kingdoms.','',26124),
(25749,'enUS','I\'d like to take the ship to Menethil Harbor.','I\'d like to take the ship to Menethil Harbor.',26124),
(25750,'enUS','A ship runs between here and Westguard Keep, sometimes ferrying troops and the occasional passenger but most often carrying much-needed supplies.','',26124),
(25751,'enUS','I\'d like to take the ship to Westguard Keep.','I\'d like to take the ship to Westguard Keep.',26124),
(25752,'enUS','Moa\'ki Harbor is blessed with two great sea turtles: Walker of Waves and Green Island. They swim between Unu\'pe and Kamagua.','',26124),
(25753,'enUS','I\'d like to take the great sea turtle to Unu\'pe.','I\'d like to take the great sea turtle to Unu\'pe.',26124),
(25754,'enUS','I\'d like to take the great sea turtle to Kamagua.','I\'d like to take the great sea turtle to Kamagua.',26124),
(25755,'enUS','','Eager to get to Northrend, are you? The steam-powered Kraken sails from here to Valiance Keep in Borean Tundra.',26124),
(25756,'enUS','I\'d like to take the ship to Valiance Keep.','I\'d like to take the ship to Valiance Keep.',26124),
(25757,'enUS','If you\'re looking to travel to Northrend, the icebreaker Northspear sails from here to Valgarde in the Howling Fjord.','',26124),
(25758,'enUS','I\'d like to take the ship to Valgarde.','I\'d like to take the ship to Valgarde.',26124),
(25759,'enUS','','If you\'re looking to get to Valiance Keep, you can hop onto the cargo ship that runs between here and Borean Tundra. They don\'t mind taking on the occasional passenger or two.',26124),
(25760,'enUS','I\'d like to take the ship to Valiance Keep.','I\'d like to take the ship to Valiance Keep.',26124),
(25761,'enUS','Hey there! Miss the Eastern Kingdoms, huh? Well, the Kraken sails back to Stormwind if you\'re really itching to return. I know I\'d enjoy the warmer weather!','',26124),
(25762,'enUS','I\'d like to take the ship to Stormwind Harbor.','I\'d like to take the ship to Stormwind Harbor.',26124),
(25763,'enUS','Our blessed great sea turtle, Green Island, travels from here to Moa\'ki Harbor in Dragonblight.','',26124),
(25764,'enUS','I\'d like to take the great sea turtle to Moa\'ki Harbor.','I\'d like to take the great sea turtle to Moa\'ki Harbor.',26124),
(25765,'enUS','Yo. Lookin\' to get back to the Old World? Fly to Tirisfal Glades in style on the Cloudkisser.','',26124),
(25766,'enUS','I\'d like to take the zeppelin to Tirisfal Glades.','I\'d like to take the zeppelin to Tirisfal Glades.',26124),
(25767,'enUS','Hey there. If you wanna get to Northrend, then The Mighty Wind is the way to go. She\'ll fly you straight to Warsong Hold in the Borean Tundra.','',26124),
(25768,'enUS','I\'d like to take the zeppelin to Warsong Hold.','I\'d like to take the zeppelin to Warsong Hold.',26124),
(25769,'enUS','','Hey there, how ya doin\'? Lookin\' for a ride ta Warsong Hold? The Wild Wench will get ya there lickety-split. She\'s the fastest zeppelin in Northrend!',26124),
(25770,'enUS','I\'d like to take the zeppelin to Warsong Hold.','I\'d like to take the zeppelin to Warsong Hold.',26124),
(25771,'enUS','','Northrend awaits, $r. The majestic Cloudkisser will take you straight across the sea to Vengeance Landing in Howling Fjord.',26124),
(25772,'enUS','I\'d like to take the zeppelin to Vengeance Landing.','I\'d like to take the zeppelin to Vengeance Landing.',26124),
(25773,'enUS','Heading home, $c? The Mighty Wind will get you there, if home\'s in Kalimdor. She flies straight from here to Durotar.','',26124),
(25774,'enUS','I\'d like to take the zeppelin to Durotar.','I\'d like to take the zeppelin to Durotar.',26124),
(25775,'enUS','Faster! Faster! These armaments must be delivered to the Kor\'kron Vanguard TODAY!','',26124),
(25776,'enUS','I will happily replace you all with goblins! Do not fail me!','',26124),
(25777,'enUS','Overlord Agmar demands more of us! We must not disappoint!','',26124),
(25778,'enUS','Don\'t make me jump off of this crate! I will beat your head in, orc.','',26124),
(25779,'enUS','Yo. Looking for a ride to Vengeance Landing? The Wild Wench flies back and forth, day and night.','',26124),
(25780,'enUS','I\'d like to take the zeppelin to Vengeance Landing.','I\'d like to take the zeppelin to Vengeance Landing.',26124),
(25781,'enUS','Hey pretty lady, Zebu\'tan got two rugs over here! Why don\'t you come on over and keep he warm, eh?','',26124),
(25782,'enUS','Lookie what Zebu\'tan got for you! Roses for da rose!','',26124),
(25783,'enUS','%s grumbles.','',26124),
(25784,'enUS','','Not if you were the last troll on Azeroth!',26124),
(25785,'enUS','','Ewwww!',26124),
(25786,'enUS','','Never!',26124),
(25787,'enUS','','Get lost, creep!',26124),
(25788,'enUS','','I\'ve got a man! Now take a hike!',26124),
(25789,'enUS','Dis troll tink you got a crush on he! Come on over!','',26124),
(25790,'enUS','Don\'t be shy, elfy. Don\'t you feel dis burnin\' love formin\' between us?','',26124),
(25791,'enUS','To the front lines! The Kor\'kron Vanguard needs air support!','',26124),
(25792,'enUS','Orders, sir?','Orders, sir?',26124),
(25793,'enUS','Sir, yes, sir!','Sir, yes, sir!',26124),
(25794,'enUS','Right away, sir!','Right away, sir!',26124),
(25795,'enUS','I\'m on the way, sir!','I\'m on the way, sir!',26124),
(25796,'enUS','For the Horde!','For the Horde!',26124),
(25797,'enUS','Air raid on Icemist! Let the Anub\'ar feel the power of our air strikes!','',26124),
(25798,'enUS','Take this message to Lord Hellscream at once!','',26124),
(25799,'enUS','Supply drop at the Wrathgate! Ride with caution!','',26124),
(25800,'enUS','Aerial recon of New Hearthglen! Observe Scarlet Crusade activity!','',26124),
(25801,'enUS','Strange activity has been reported at Frostmourne Cave. Scout it out!','',26124),
(25802,'enUS','','Are you ready, Mr. Floppy? Stay close to me and watch out for those wolves!',26124),
(25803,'enUS','','Um... I think one of those wolves is back...',26124),
(25804,'enUS','','He\'s going for Mr. Floppy!',26124),
(25805,'enUS','','Let\'s get out of here before more wolves find us!',26124),
(25806,'enUS','','Oh, no! Look, it\'s another wolf, and it\'s a biiiiiiig one!',26124),
(25807,'enUS','','No, Mr. Floppy! No!',26124),
(25808,'enUS','','Oh, Mr. Floppy, this is hopeless!',26124),
(25809,'enUS','','Don\'t go toward the light, Mr. Floppy!',26124),
(25810,'enUS','','Mr. Floppy, you\'re ok! Thank you so much for saving Mr. Floppy!',26124),
(25811,'enUS','You\'ve successfully freed your spirit! You can serve as my eyes. Together we\'ll get to the bottom of this.','',26124),
(25812,'enUS','Wanted DEAD for treason and other treacherous acts against the Horde!$B$BAll bounties paid by Captain Gort.','',26124),
(25813,'enUS','You\'re coming up on the village now. Keep your eyes peeled.','',26124),
(25814,'enUS','Clear me for the teleporter, I\'m ready to go!','Clear me for the teleporter, I\'m ready to go!',26124),
(25815,'enUS','What\'s happened to the lake bed? Strange power is pouring out of it.','',26124),
(25816,'enUS','Welcome, $c!  I hope you aren\'t afraid of heights!$b$bI\'ve got a practice parachute for you.  These chutes are for quick landings.  If you want to gently soar to the ground, use a mount.  If you want action and an adrenaline rush, you fall.  At the last possible moment you use your chute.  That\'s how these were made.  Quick action!  Are you ready for some quick action?$b$bThe chute only lasts a few seconds.  So you\'ll need to time it just right.  I\'m not sure you can handle it, $c.  I\'d like to see you prove me wrong.','Welcome, $c!  I hope you aren\'t afraid of heights!$b$bI\'ve got a practice parachute for you.  These chutes are for quick landings.  If you want to gently soar to the ground, use a mount.  If you want action and an adrenaline rush, you fall.  At the last possible moment you use your chute.  That\'s how these were made.  Quick action!  Are you ready for some quick action?$b$bThe chute only lasts a few seconds.  So you\'ll need to time it just right.  I\'m not sure you can handle it, $c.  I\'d like to see you prove me wrong.',26124),
(25817,'enUS','No... no! My people are all dead spirits or deranged!','',26124),
(25818,'enUS','Elder Mana\'loa, the statue there, sees you. This is a good sign!','',26124),
(25819,'enUS','Come back, $n. If you\'re out of your body for too long, you run the risk of not being able to return. We have much to discuss.','',26124),
(25820,'enUS','G\'day mate! Sit an\' have yerself a sip, won\'t yeh?','',26124),
(25821,'enUS','I need some more of your fine grog, Mack.','I need some more of your fine grog, Mack.',26124),
(25822,'enUS','Strike now heroes, while he is weakened! Vanquish the Deceiver!','',26124),
(25823,'enUS','Pssst... Over here, by the mailbox. Come quickly and make sure you aren\'t followed.','',26124),
(25824,'enUS','','I am proud of you, child.',26124),
(25825,'enUS','','You will make a fine warrior of the Horde.',26124),
(25826,'enUS','','We will retake Icemist. The Anub\'ar will be expelled from our city.',26124),
(25827,'enUS','','The worst is behind us. Soon we will put an end to the Lich King\'s reign.',26124),
(25828,'enUS','Release me, fiends!','',26124),
(25829,'enUS','Pray to whatever gods you believe in that I am never freed!','',26124),
(25830,'enUS','I will break these bonds that hold me and send you all back to the hell from whence you came!','',26124),
(25831,'enUS','I will never succumb to your tortures! NEVER!','',26124),
(25832,'enUS','To the town hall, everyone!  We\'ve brought you weapons!  Arm yourselves and beat the Scourge back!','',26124),
(25833,'enUS','Time to kill!','',26124),
(25834,'enUS','It\'s about time!  Lurid was getting bored.','',26124),
(25835,'enUS','You Arthas lapdog?  You die!','',26124),
(25836,'enUS','This not... end well for you!','',26124),
(25837,'enUS','Lurid could get used... to working with you.','',26124),
(25838,'enUS','All I ever wished for was to serve my king once again.  For humanity, against a common enemy.$B$BInstead, I find that our numbers have been infiltrated by cultist scum.... and all signs point to Naxxanar as the origin of this rot.','',26124),
(25839,'enUS','This is where the cultists\' orders are coming from.  Their leader is bound to show up soon.$B$BLet\'s not miss this opportunity.','',26124),
(25840,'enUS','Let\'s do this, Thassarian.  It\'s now or never.','Let\'s do this, Thassarian.  It\'s now or never.',26124),
(25841,'enUS','What... what happened to me?','',26124),
(25842,'enUS','','Thassarian!  You\'re alive!',26124),
(25843,'enUS','','I thought... I thought you were... dead.',26124),
(25844,'enUS','Leryssa... you... you\'re all right!','',26124),
(25845,'enUS','I cannot return home with you just yet, Leryssa.  I am not quite done with the Scourge.','',26124),
(25846,'enUS','You might be right, sister.  My obligations to my land and King have been fulfilled.  But there is something that I still owe to myself.','',26124),
(25847,'enUS','Ugh!  My head won\'t stop spinning...','',26124),
(25848,'enUS','','Don\'t leave me again!  You want to fight for your country, but they don\'t even want you!  They sent you here to die!',26124),
(25849,'enUS','','I know that look in your eye... I\'m not going to be able to talk you out of this.  If you die on me again...',26124),
(25850,'enUS','Do not worry, Leryssa.  I will come back to you when I am done.  Nothing in the world will stop me from coming home to the only family that I have left.','',26124),
(25851,'enUS','We\'ve taken the harbor!  The enemy has been driven away.  Sun\'s Reach is ours!','',26124),
(25852,'enUS','Run for yer life, mon!','',26124),
(25853,'enUS','Da Scourge be everywhere, mon!','',26124),
(25854,'enUS','','Little $n, why do you call me forth? Are you working with the trolls of this land? Have you come to kill me and take my power as your own?',26124),
(25855,'enUS','Every troll for himself, mon!','',26124),
(25856,'enUS','Outta my way, mon!','',26124),
(25857,'enUS','Drak\'Tharon be lost, mon!','',26124),
(25858,'enUS','Da Scourge be everywhere!','',26124),
(25859,'enUS','Ruuun!','',26124),
(25860,'enUS','You have made a fatal mistake, mortal... There isss no essscape...','',26124),
(25861,'enUS','Betrayers! The day of reckoning comes and with it comes your end! See then if your Lich King saves you from the ancient one\'s judgment! Now you die!','',26124),
(25862,'enUS','Anveena\'s sacrifice has given us all a new hope for the future.','',26124),
(25863,'enUS','','I sense uncertainty in you, and I do not trust it whether you are with them, or not. If you wish my augury for the Kalu\'ak, you will have to prove yourself first.',26124),
(25864,'enUS','','I will lay a mild compulsion upon you. Jump into the depths before me so that you put yourself into my element and thereby display your submission.',26124),
(25865,'enUS','','Though you are compelled, the choice, and the last step before you leap, are yours. You have twenty more seconds to decide.',26124),
(25866,'enUS','','Very well, $n, you have failed to act. The prophecy is not yours to learn. Do not call upon me again until you have found your backbone!',26124),
(25867,'enUS','','Well done, $n. Your display of respect is duly noted. Now, I have information for you that you must convey to the Kalu\'ak.',26124),
(25868,'enUS','','Simply put, you must tell the tuskarr that they cannot run. If they do so, their spirits will be destroyed by the evil rising within Northrend.',26124),
(25869,'enUS','','Tell the mystic that his people are to stand and fight alongside the Horde and Alliance against the forces of Malygos and the Lich King.',26124),
(25870,'enUS','','Now swim back with the knowledge I have granted you. Do what you can for them, $r.',26124),
(25871,'enUS','Huh?  What?!  Go away.','',26124),
(25872,'enUS','','If I can make a new war machine, I know I can get a pretty penny for it over at the Wrath Gate.  $B$BSome of our previous iterations haven\'t been entirely... stable, but my flying machine should do the trick if I can just develop an effective bomb system for it.',26124),
(25873,'enUS','There\'s money to be made!  Just like pops always said - no better time for raking in the cash than a time of war. ','',26124),
(25874,'enUS','You feel a strange presence as you stand before this ancient idol.','',26124),
(25875,'enUS','Where the Eye of the Prophets rested for millennia, only an empty niche remains.','',26124),
(25876,'enUS','Remove the Eye of the Prophets from the idol\'s face.','Remove the Eye of the Prophets from the idol\'s face.',26124),
(25877,'enUS','I\'ll be waitin\' for ya, mon.','',26124),
(25878,'enUS','Hurry now, $n. I\'ll be waitin\' for ya, mon.','',26124),
(25879,'enUS','','This is an intriguing find, $n, but I don\'t know what to make of it.',26124),
(25880,'enUS','','The language is unfamiliar and for all we know, it\'s just some soldier\'s journal.',26124),
(25881,'enUS','Let me take a look at that.','',26124),
(25882,'enUS','Hmm...','',26124),
(25883,'enUS','This journal is written in dwarven. I can\'t read this scrawl, but I can make out one thing.','',26124),
(25884,'enUS','\'Brann Bronzebeard.\' The brother of Ironforge\'s king? You may have spoken too soon, Paluna.','',26124),
(25885,'enUS','','What do you mean?',26124),
(25886,'enUS','Think about how valuable a member of the dwarven royal family would be as a hostage.','',26124),
(25887,'enUS','If he\'s in the area, we must find him. First, though, we\'ll need a way to decipher this journal.','',26124),
(25888,'enUS','Come, cowards! FACE THE HORDE!','Come, cowards! FACE THE HORDE!',26124),
(25889,'enUS','Do you that dare challenge the Horde? Then come...','Do you that dare challenge the Horde? Then come...',26124),
(25890,'enUS','I will crush you all! For the Horde!','I will crush you all! For the Horde!',26124),
(25891,'enUS','Come! Come face your doom!','Come! Come face your doom!',26124),
(25892,'enUS','Leave this place or I will thrash you soundly!','Leave this place or I will thrash you soundly!',26124),
(25893,'enUS','Show yourselves so that I may crack your insectoid skeletons with my bare hands!','Show yourselves so that I may crack your insectoid skeletons with my bare hands!',26124),
(25894,'enUS','Hearty beatings will be dispensed in the name of the Horde!','Hearty beatings will be dispensed in the name of the Horde!',26124),
(25895,'enUS','Anub\'ar fear nothing, mortal...','',26124),
(25896,'enUS','A fine meal you will make...','',26124),
(25897,'enUS','Anub\'arak may have uses for your carcass...','',26124),
(25898,'enUS','The feast has arrived! DIE!','',26124),
(25899,'enUS','The Anub\'ar have destroyed the %s!','',26124),
(25900,'enUS','Welcome!  If you need a place to rest, I can solve that problem.','Welcome!  If you need a place to rest, I can solve that problem.',26124),
(25901,'enUS','','Scout Vor\'takh\'s hunch was correct. Brann Bronzebeard visited Thor Modan recently and this journal records his findings.',26124),
(25902,'enUS','','He managed to explore the ruins before the battle began, discovering three runic plates inscribed with prophecies.',26124),
(25903,'enUS','','Brann doesn\'t record the translations, but it says he committed them to memory before fleeing the battle.',26124),
(25904,'enUS','','If you can translate those plates, we can find and capture Brann.',26124),
(25905,'enUS','Magmoth Crusher is on the move!','',26124),
(25906,'enUS','Magmoth Crusher\'s moving off!','',26124),
(25907,'enUS','Bomber went down!  The pilot\'s out safe though!','',26124),
(25908,'enUS','We just lost a plane!','',26124),
(25909,'enUS','Incoming survivor!','',26124),
(25910,'enUS','We\'ve got a survivor inbound!','',26124),
(25911,'enUS','','Let us see what this journal reveals.',26124),
(25912,'enUS','I cannot.','I cannot.',26124),
(25913,'enUS','No.','No.',26124),
(25914,'enUS','You\'ll have to be patient.','You\'ll have to be patient.',26124),
(25915,'enUS','Goramosh is busy with a ritual right now.','Goramosh is busy with a ritual right now.',26124),
(25916,'enUS','My orders are that you must wait here.','My orders are that you must wait here.',26124),
(25917,'enUS','The master will be with you momentarily.','The master will be with you momentarily.',26124),
(25918,'enUS','It won\'t be long now.','It won\'t be long now.',26124),
(25919,'enUS','My apologies, ambassador. My orders were quite clear.','My apologies, ambassador. My orders were quite clear.',26124),
(25920,'enUS','We will crush Arthas! The Scourge cannot stand up to the might of the Horde!','',26124),
(25921,'enUS','You\'ll pay for this insult, $c!','',26124),
(25922,'enUS','','You are not welcome in our home.  Leave and go find some other land to pillage!',26124),
(25923,'enUS','I\'ll show you!  Give me that practice parachute!','I\'ll show you!  Give me that practice parachute!',26124),
(25924,'enUS','','The control components are working perfectly this time!',26124),
(25925,'enUS','','Who to test the bomb on?  The Harpies?  Ha ha... wait... what\'s that?',26124),
(25926,'enUS','','NO!  My machine... my bombs!  THAT\'S IT!  Those Harpies are going DOWN!',26124),
(25927,'enUS','Spirit, you will submit to my will.','',26124),
(25928,'enUS','You are bound to me, spirit! Your task is to keep the mill running - do not falter!','',26124),
(25929,'enUS','Bend the wind to the task of keeping the mill turning, spirit!','',26124),
(25930,'enUS','North wind! You will do as I command!','',26124),
(25931,'enUS','The wind immediately surrounding the mill picks up rapidly, causing the timbers to groan.','',26124),
(25932,'enUS','A chilly gust encircles the taunka mill, carrying with it soft, resentful mutterings in Kalimag.','',26124),
(25933,'enUS','The sails of the windmill grow taut against the sudden wind.','',26124),
(25934,'enUS','','Keep them away from the focus!',26124),
(25935,'enUS','','I\'m sorry, daddy....',26124),
(25936,'enUS','Anub\'et\'kan will... end you.','',26124),
(25937,'enUS','I gladly die for the master...','',26124),
(25938,'enUS','Your victory is meaningless.','',26124),
(25939,'enUS','I will rise again, more powerful... much... more...','',26124),
(25940,'enUS','Looking for an Arena Battlemaster? You can find them on the road between towns, or in the capitals.$B$BYou can bind here, at me. I can also teleport you to one of the capitals.','Looking for an Arena Battlemaster? You can find them on the road between towns, or in the capitals.$B$BYou can bind here, at me. I can also teleport you to one of the capitals.',26124),
(25941,'enUS','Bind Here','Bind Here',26124),
(25942,'enUS','Darnassus','Darnassus',26124),
(25943,'enUS','The Exodar','The Exodar',26124),
(25944,'enUS','Ironforge','Ironforge',26124),
(25945,'enUS','Orgrimmar','Orgrimmar',26124),
(25946,'enUS','Silvermoon City','Silvermoon City',26124),
(25947,'enUS','Stormwind','Stormwind',26124),
(25948,'enUS','Thunder Bluff','Thunder Bluff',26124),
(25949,'enUS','Undercity','Undercity',26124),
(25950,'enUS','Tear this pitiful village apart!','',26124),
(25951,'enUS','Leave no survivors!','',26124),
(25952,'enUS','Give in, Taunka! Your will cannot hold out against the Scourge!','',26124),
(25953,'enUS','A new day dawns, my children! Soon the undead legions of Azjol-Nerub will rise and take over this world!','',26124),
(25954,'enUS','I... am... FREE!','',26124),
(25955,'enUS','What have they done to my people...','',26124),
(25956,'enUS','You will face the full fury of the ancestors for what you have done, monster!','',26124),
(25957,'enUS','Rebirth comes, my brothers... Rise... Rise and fight once more.','',26124),
(25958,'enUS','FOR ICEMIST! FOR THE TAUNKA!','',26124),
(25959,'enUS','Your freedom will be short lived, Icemist!','',26124),
(25960,'enUS','','',26124),
(25961,'enUS','The Hulking Jormungar falters for a moment, opening its mouth wide.','',26124),
(25962,'enUS','Come down and face me, insect!','',26124),
(25963,'enUS','Then I will force you down! Wind grant me flight!','',26124),
(25964,'enUS','Insolent mortal! You will be consumed!','',26124),
(25965,'enUS','ARRGGH!! It cannot be! How...','',26124),
(25966,'enUS','Hello there!  Fizzcrank\'s pilots are the best of the best.  We stay that way through constant training.  That includes parachute training.  You never know when you will need to use your chute, but you do know that one day you\'ll have to use it.$b$bSo what we have here is a teleporter to the top of this spire.  Once you get up there, the only way for a real soldier to get back down is with a parachute.  We\'ve got another trooper stationed up top ready with the parachutes.$b$bIf you feel like trying it out, $c, I\'ll clear you for teleporter use.  Then just step onto the teleporter.','Hello there!  Fizzcrank\'s pilots are the best of the best.  We stay that way through constant training.  That includes parachute training.  You never know when you will need to use your chute, but you do know that one day you\'ll have to use it.$b$bSo what we have here is a teleporter to the top of this spire.  Once you get up there, the only way for a real soldier to get back down is with a parachute.  We\'ve got another trooper stationed up top ready with the parachutes.$b$bIf you feel like trying it out, $c, I\'ll clear you for teleporter use.  Then just step onto the teleporter.',26124),
(25967,'enUS','Iron masters, aid me in this battle!','',26124),
(25968,'enUS','YaY! WE WON!','YaY! WE WON!',26124),
(25969,'enUS','Why am I so good? ','Why am I so good?',26124),
(25970,'enUS','We go to scout out the sinkholes to the west, Chieftain.','',26124),
(25971,'enUS','OWNED!','OWNED!',26124),
(25972,'enUS','Get outa here! Good riddance!','Get outa here! Good riddance!',26124),
(25973,'enUS','','We will return swiftly with our report.',26124),
(25974,'enUS','There they are. Taima, are we close enough to see everything for the report?','',26124),
(25975,'enUS','','No. We\'ve known this much for some time. We need to get closer and see how deeply they go.',26124),
(25976,'enUS','Then we cut our way through the Nerubians.','',26124),
(25977,'enUS','%s grunts and nods.','',26124),
(25978,'enUS','Strike now!','',26124),
(25979,'enUS','Crush the small one!','',26124),
(25980,'enUS','We will destroy you, puny creature!','',26124),
(25981,'enUS','Children of iron, lend me your blades!','',26124),
(25982,'enUS','The enemy grows stronger! Aid me!','',26124),
(25983,'enUS','No one will keep us from our destiny!','',26124),
(25984,'enUS','For the glory of Loken!','',26124),
(25985,'enUS','You will pay for your interference!','',26124),
(25986,'enUS','You are a fool to fight Kurun\'s hopeless battle!','',26124),
(25987,'enUS','Your life is forfeit, ally of stone!','',26124),
(25988,'enUS','Hello, Pahu.','Hello, Pahu.',26124),
(25989,'enUS','A package changes hands between Pahu and the Longrunner, who packs it away safely.','A package changes hands between Pahu and the Longrunner, who packs it away safely.',26124),
(25990,'enUS','','Hello! I have your rations right here.',26124),
(25991,'enUS','Be cautious, but return quickly. We cannot afford to be blind.','',26124),
(25992,'enUS','%s flies away.','',26124),
(25993,'enUS','Ya shouldn\'a taken the boat north, mon!','',26124),
(25994,'enUS','Ah, Deino, mah sistah. Ta\'zinni die now.','',26124),
(25995,'enUS','Warning! Vehicle has left the operation area. Power-down imminent.','',26124),
(25996,'enUS','You\'ll pay for that!','',26124),
(25997,'enUS','I will not let you win!','',26124),
(25998,'enUS','','Not Haloke!',26124),
(25999,'enUS','Anub\'et\'kan is defeated! Take a fragment of his husk as proof of your victory!','',26124),
(26000,'enUS','Thank you, $c, for seeing to it that I received the letter from my daughter.$B$BRest assured, her death will not have been in vain. The blue dragonflight will pay in spades.$B$BI\'ll see to it personally!','',26124),
(26001,'enUS','Get ready to ride, $n.  If the military can\'t be bothered to send me an escort, I suppose you\'ll have to do.','Get ready to ride, $n.  If the military can\'t be bothered to send me an escort, I suppose you\'ll have to do.',26124),
(26002,'enUS','Silverbrook is due northwest of here.  A small community of hunters and trappers.  They know the lay of the land -- it would be good to have them on our side.','Silverbrook is due northwest of here.  A small community of hunters and trappers.  They know the lay of the land -- it would be good to have them on our side.',26124),
(26003,'enUS','We\'re taking a shortcut.  Be on the lookout for worgs.','We\'re taking a shortcut.  Be on the lookout for worgs.',26124),
(26004,'enUS','That\'s it up ahead.','That\'s it up ahead.',26124),
(26005,'enUS','The bodies hanging from the gate... something\'s very wrong here.','The bodies hanging from the gate... something\'s very wrong here.',26124),
(26006,'enUS','Hail!  By order of King Varian Wrynn, I\'ve been given the authority to extend an offer to the people of Silverbrook.','Hail!  By order of King Varian Wrynn, I\'ve been given the authority to extend an offer to the people of Silverbrook.',26124),
(26007,'enUS','You will find it in your interest to aid the Alliance war effort.  We are in need of scouts and trackers, as well as provisions for our troops.  Payment, in gold, will be delivered immediately from the king\'s treasury.','You will find it in your interest to aid the Alliance war effort.  We are in need of scouts and trackers, as well as provisions for our troops.  Payment, in gold, will be delivered immediately from the king\'s treasury.',26124),
(26008,'enUS','We\'d best head back, $n.  These simpletons don\'t know what a grave mistake they\'re making.','We\'d best head back, $n.  These simpletons don\'t know what a grave mistake they\'re making.',26124),
(26009,'enUS','You\'d better get outta here unless you want to find yourself in one of these cages....','',26124),
(26010,'enUS','What?! Impossible! RUNNN!','What?! Impossible! RUNNN!',26124),
(26011,'enUS','RUN FOR YOUR LIVES!','RUN FOR YOUR LIVES!',26124),
(26012,'enUS','It\'s comin right for us!','It\'s comin right for us!',26124),
(26013,'enUS','Awww man not again.','Awww man not again.',26124),
(26014,'enUS','I\'ve got a bad feeling about this.  If something happens to me, head back to Amberpine lodge and report to Lieutenant Dumont.','I\'ve got a bad feeling about this.  If something happens to me, head back to Amberpine lodge and report to Lieutenant Dumont.',26124),
(26015,'enUS','Now you ask for our help?  Where were you when we needed you?  Do you\'ve any idea what we\'ve been through?','Now you ask for our help?  Where were you when we needed you?  Do you\'ve any idea what we\'ve been through?',26124),
(26016,'enUS','We are damned.  If I were you, I\'d leave before it was too late.  You\'ll be lucky if you make it back alive.','We are damned.  If I were you, I\'d leave before it was too late.  You\'ll be lucky if you make it back alive.',26124),
(26017,'enUS','%s spits on the ground near the Alliance Envoy.','%s spits on the ground near the Alliance Envoy.',26124),
(26018,'enUS','What the -- ?','What the -- ?',26124),
(26019,'enUS','Thank you, $c, for seeing to it that I received the letter from my brother.$B$BRest assured, his death will not have been in vain. The blue dragonflight will pay for this.$B$BI\'ll see to it personally!','Thank you, $c, for seeing to it that I received the letter from my brother.$B$BRest assured, his death will not have been in vain. The blue dragonflight will pay for this.$B$BI\'ll see to it personally!',26124),
(26020,'enUS','My lady, the surge needle is fully operational.','',26124),
(26021,'enUS','','You have done well, Keldonus. Lord Malygos will be quite pleased with your progress.',26124),
(26022,'enUS','I live only to serve the master, my lady.','',26124),
(26023,'enUS','Chug and chuck!  Chug and chuck!','Chug and chuck!  Chug and chuck!',26124),
(26024,'enUS','The ley line beneath this night elf temple is now flowing into the Azure Dragonshrine. Our brothers should have all the power they need to crush our enemies.','',26124),
(26025,'enUS','','Deal with this interruption, Keldonus. After you are through, bring me the head of the one they call $n. I will decorate my chambers with $g his:her; skull.',26124),
(26026,'enUS','','This transgression against the Blue Dragonflight has been noted. I will take extra pleasure in separating the life energy from your body!',26124),
(26027,'enUS','Alright, kid. Stay behind me and you\'ll be fine.','',26124),
(26028,'enUS','Their ceremonial chamber, where I was to be sacrificed...','',26124),
(26029,'enUS','Time to put an end to all this!','',26124),
(26030,'enUS','Odd. That usually does it.','',26124),
(26031,'enUS','Do your part in keeping the Scourge at bay, soldier! Report all suspicious activity and kill first, ask questions later!','',26124),
(26032,'enUS','Mark my words, these forsaken fools will be the death of us all!','',26124),
(26033,'enUS','If you ask me, and you DID, I think we should kill all of the apothecaries before it\'s too late!','',26124),
(26034,'enUS','The Horde is about honor and war. I am certain that there is nothing honorable about what these apothecaries are doing.','',26124),
(26035,'enUS','I\'m keeping an eye on the forsaken idiots down there. You can never be too cautious around them!','',26124),
(26036,'enUS','What\'s this?','',26124),
(26037,'enUS','Aww, not a snake!','',26124),
(26038,'enUS','Ssssupper comess early?','',26124),
(26039,'enUS','The %s gives you its thanks.','',26124),
(26041,'enUS','Breaking off a piece of its bark, the %s hands it to you before departing.','',26124),
(26042,'enUS','The %s is angered by your request and attacks!','',26124),
(26043,'enUS','Time to feassst!','',26124),
(26044,'enUS','If you have dealings with the doctor over there, be cautious. Whatever they\'re up to, it\'s unnatural.','',26124),
(26045,'enUS','Mon, da west wastes of dis place be full o\' baddies. Stay away from dis here area if ya want to live!','',26124),
(26046,'enUS','Get that frostwyrm on the ground and I\'ll finish her.','Get that frostwyrm on the ground and I\'ll finish her.',26124),
(26047,'enUS','Don\'t ya worry, mon. Just leave it to Rokhan. She be comin\'.','',26124),
(26048,'enUS','Thank you, small one.','',26124),
(26049,'enUS','You have my gratitude.','',26124),
(26050,'enUS','I never thought I\'d be free from that terrible spell!','',26124),
(26051,'enUS','I thought I was doomed. Thank you for freeing me.','',26124),
(26052,'enUS','The Runebreaker fails to free the Runed Giant, weakening it and causing it to attack!','',26124),
(26053,'enUS','Just as well, I\'ve had enough of this place.','',26124),
(26054,'enUS','Take me to the Apothecary Camp.','Take me to the Apothecary Camp.',26124),
(26055,'enUS','Take me to Camp Oneqwah.','Take me to Camp Oneqwah.',26124),
(26056,'enUS','','Thank you!',26124),
(26057,'enUS','You\'re free to go, miss.','',26124),
(26058,'enUS','Take me to Conquest Hold.','Take me to Conquest Hold.',26124),
(26059,'enUS','My charge at Agmar\'s Hammer extends far beyond the care of the animals at the stables.','',26124),
(26060,'enUS','','',26124),
(26061,'enUS','Let us speak a moment, $r.','',26124),
(26062,'enUS','I can\'t offer you anything outside Howling Fjord. The bats still don\'t know their way abroad. Where do you want to go?','I can\'t offer you anything outside Howling Fjord. The bats still don\'t know their way abroad. Where do you want to go?',26124),
(26063,'enUS','Take me to Venomspite.','Take me to Venomspite.',26124),
(26064,'enUS','I have another task for you, should you be willing, little one.','',26124),
(26065,'enUS','Listen, kid. I can handle this thing. You just watch my back!','',26124),
(26066,'enUS','See ya \'round, kid!','',26124),
(26067,'enUS','Harrison Jones? Didn\'t you expire back in Zul\'aman?','Harrison Jones? Didn\'t you expire back in Zul\'aman?',26124),
(26068,'enUS','Expire? Me? Heh, not hardly, kid. That was just a scratch.','',26124),
(26069,'enUS','Take me to Amberpine Lodge.','Take me to Amberpine Lodge.',26124),
(26070,'enUS','Take me to Wyrmrest Temple.','Take me to Wyrmrest Temple.',26124),
(26071,'enUS','Take me to Agmar\'s Hammer.','Take me to Agmar\'s Hammer.',26124),
(26072,'enUS','Take me to the Westfall Brigade Encampment.','Take me to the Westfall Brigade Encampment.',26124),
(26073,'enUS','Take me to Wintergarde Keep.','Take me to Wintergarde Keep.',26124),
(26074,'enUS','Take me to Fordragon Hold.','Take me to Fordragon Hold.',26124),
(26075,'enUS','Take me to Star\'s Rest.','Take me to Star\'s Rest.',26124),
(26076,'enUS','Take me to Valiance Keep.','Take me to Valiance Keep.',26124),
(26077,'enUS','Take me to Fizzcrank Airstrip.','Take me to Fizzcrank Airstrip.',26124),
(26078,'enUS','','Talk to Narf.  Lets take care of those bird-brains once and for all.',26124),
(26079,'enUS','About time!  Get that lumber and get moving.  The horde won\'t be up there fighting forever, there\'s money to be made!','',26124),
(26080,'enUS','Impressive, aren\'t they? These giants would be the perfect fodd... er, allies.  This one is their leader, but he continues to refuse to speak with me.','',26124),
(26081,'enUS','Hello, $r.  You are welcome to share this canyon with us as refuge from the dragons.  Beware the goblin runt though... his kind cannot be trusted.','',26124),
(26082,'enUS','With enough money, I could take over the world...','',26124),
(26083,'enUS','This console stands before steaming rubble.  The sounds of an engine can be heard below.','This console stands before steaming rubble.  The sounds of an engine can be heard below.',26124),
(26084,'enUS','Pull the console\'s levers.','Pull the console\'s levers.',26124),
(26085,'enUS','You take my heart, now I take yours!','',26124),
(26086,'enUS','Why ya wanna mess wit me innards, mon?','',26124),
(26087,'enUS','Dat me liver you be squeezin, mon!','',26124),
(26088,'enUS','Come back here with me guts, $r!','',26124),
(26089,'enUS','What do you think you\'re doing?','',26124),
(26090,'enUS','You\'ll pay for this!','',26124),
(26091,'enUS','Fool! You\'ll never get away with this!','',26124),
(26092,'enUS','You dare to defy the sons of iron?','',26124),
(26093,'enUS','Dimitri!  Anton!  Don\'t you recognize me?  Do not worry, I will put your souls to rest!','',26124),
(26094,'enUS','I won\'t let your families see you like this!  Us miners have to look after each other!','',26124),
(26095,'enUS','I\'ll tell your story, friends!  I\'ll tell everyone about how the Hollowstone miners never gave in!','',26124),
(26096,'enUS','Welcome to Wyrmrest Temple, traveler.$B$BHere the dragonflights confer in peace with one another amidst the bones of their honored ancestors.$B$BAt least, we were peaceful until the Blue Dragonflight launched a surprise attack upon the temple itself.$B$BEnter with our blessing, but know that we will brook no aggression within our walls.','',26124),
(26098,'enUS','How dare you summon me without an offering!','',26124),
(26099,'enUS','','Would you like to head back down, $c?$B$BI can see to it that one of these drakes sees you safely to where you need to go.',26124),
(26100,'enUS','Yes, please, I would like to return to the ground level of the temple.','Yes, please, I would like to return to the ground level of the temple.',26124),
(26101,'enUS','Leave me be, fool!','',26124),
(26102,'enUS','The boy believed he could essssscape... Neither of you shall make it out alive.','',26124),
(26103,'enUS','Kill ussss all... More will come for him...','',26124),
(26104,'enUS','Relent! This ssssoul iss not worth sssaving...','',26124),
(26105,'enUS','You have made a grave misssstake...','',26124),
(26106,'enUS','You won\'t get away with this, you know?  You\'re just a kid.','',26124),
(26107,'enUS','How old are you, lass?','',26124),
(26108,'enUS','We\'ll all end up serving the Lich King, kid.  Better this way than becoming a rotten corpse.','',26124),
(26109,'enUS','Your father was weak, Sasha... he didn\'t have the guts to do what had to be done.','',26124),
(26110,'enUS','','I\'m old enough to shoot beasts like you right between the eyes... at twice this distance.',26124),
(26112,'enUS','','I\'d rather be dead than be one of you!  You think you\'re still human?  You\'re... animals!',26124),
(26113,'enUS','','Don\'t you dare talk about my father, monster.  He was twice the man you\'ll ever be.',26124),
(26114,'enUS','The boy believed that he was free, but free will has a price. The demons I kept at bay are now loosed upon him and all death knights that attempt to flee... \n','',26124),
(26115,'enUS','Mograine\'s sacrifice was for nothing. You will let Koltira know, won\'t you?\n','',26124),
(26116,'enUS','And remember this, mortal: for now, I give you the choice. I allow you to pick your allegiance, but in the end, you will be mine - one way or another.\n','',26124),
(26117,'enUS','Ah, the Horde... meddling, as always. I suppose a welcome is in order. So welcome, insects. Welcome to my world.\n','',26124),
(26118,'enUS','You have crossed into the world of the dead in search of answers. You wish to save your ally and have risked life and limb to be here. Allow me to help.','',26124),
(26119,'enUS','What? You want to train under me, $c? You better be ready to work.','',26124),
(26120,'enUS','I must return to the world of shadows, Koltira. Send me back.','I must return to the world of shadows, Koltira. Send me back.',26124),
(26121,'enUS','Foolish Troll, you will join our ranks. Zombie! Attack!','',26124),
(26122,'enUS','Zombie! Slay him!','',26124),
(26123,'enUS','We\'ll see how the Drakkari holds up against the might of the Scourge!','',26124),
(26124,'enUS','You can sleep in the barracks, if you\'d like. Just don\'t wake my men, or I\'ll throw you out in the snow myself.','',26124),
(26125,'enUS','Warm-up sequence initiated.','',26124),
(26126,'enUS','Thank you for rescuing me, $n. I will never forget your courage and determination.','',26124),
(26127,'enUS','Greetings High Chief. Would you do me the honor of accepting my invitation to join the Horde as an official member and leader of the Taunka?','Greetings High Chief. Would you do me the honor of accepting my invitation to join the Horde as an official member and leader of the Taunka?',26124),
(26128,'enUS','It would be an honor to battle alongside of you as a brother of the Horde, $n. I accept your offer.','',26124),
(26129,'enUS','It is you who honor me, High Chief. Please read from this scroll. It is the oath of allegiance.','It is you who honor me, High Chief. Please read from this scroll. It is the oath of allegiance.',26124),
(26130,'enUS','%s reads from the scroll as the other Taunka gather around him.','',26124),
(26131,'enUS','We will walk together, $n.','',26124),
(26132,'enUS','Yo. They weren\'t sure this elevator would be workin\' in time, so they called me and my brother in. You need a ride up?','',26124),
(26133,'enUS','I\'d like a ride up to the top of Warsong Hold.','I\'d like a ride up to the top of Warsong Hold.',26124),
(26134,'enUS','Heya. They weren\'t sure this elevator would be workin\' in time, so they called me and my brother in. You need a ride down?','',26124),
(26135,'enUS','I\'d like a ride up to the bottom of Warsong Hold.','I\'d like a ride up to the bottom of Warsong Hold.',26124),
(26136,'enUS','Gather, brothers and sisters.','',26124),
(26137,'enUS','Lok\'tar ogar! Victory or death - it is these words that bind me to the Horde! For they are the most sacred and fundamental of truths to any warrior of the Horde.','',26124),
(26138,'enUS','I give my flesh and blood freely to the Warchief. I am the instrument of my Warchief\'s desire. I am a weapon of my Warchief\'s command!','',26124),
(26139,'enUS','From this moment until the end of days I live and die - For the Horde!\n','',26124),
(26140,'enUS','For my Taunka brothers and sisters! FOR THE HORDE!\n','',26124),
(26141,'enUS','Welcome to the Horde, High Chief. Lok\'tar ogar!','',26124),
(26142,'enUS','FOR THE HORDE!','',26124),
(26143,'enUS','You not a real mon til you killed a dragon... mon.','',26124),
(26144,'enUS','There\'s no thrill like the thrill of a dragon hunt.','',26124),
(26145,'enUS','','Hello, $r.  I\'m sorry that you had to see our sacred land for the first time in such a state.',26124),
(26146,'enUS','Vrrrrroooom!','',26124),
(26147,'enUS','rubs his |Hitem:36863|h|cFFFFFFFF[Decahedral Dwarven Dice]|r|h between his hands and rolls.','rubs her |Hitem:36863|h|cFFFFFFFF[Decahedral Dwarven Dice]|r|h between her hands and rolls.',26124),
(26148,'enUS','Free at last, mon.','',26124),
(26149,'enUS','I could sleep forever, mon....','',26124),
(26150,'enUS','Where\'s mah mummy?','',26124),
(26151,'enUS','Finally, I can be restin\'...','',26124),
(26152,'enUS','casually tosses his |Hitem:36862|h|cFFFFFFFF[Worn Troll Dice]|r|h.','casually tosses her |Hitem:36862|h|cFFFFFFFF[Worn Troll Dice]|r|h.',26124),
(26153,'enUS','Initiating energy collection.','',26124),
(26154,'enUS','Energy collection complete.','',26124),
(26155,'enUS','Why do you disturb me?','',26124),
(26156,'enUS','I\'d like passage to the Transitus Shield.','I\'d like passage to the Transitus Shield.',26124),
(26157,'enUS','Take me to Amber Ledge.','Take me to Amber Ledge.',26124),
(26158,'enUS','Take me to Warsong Hold.','Take me to Warsong Hold.',26124),
(26159,'enUS','No mon, we dun want to be part of da Scourge!','',26124),
(26160,'enUS','Da Drakkari Empire won\'t stand for dis mon!','',26124),
(26161,'enUS','Resist it, me bruddas! Dun be turning to der side!','',26124),
(26162,'enUS','Hah!  My slaves brought back a real meal this time!','',26124),
(26163,'enUS','You only delay the inevitable! The dread citadel rises in the east as the armies of the dead march from the heart of Icecrown!','',26124),
(26164,'enUS','Hey dere. You need anythin\', you let me know.','',26124),
(26165,'enUS','Scourge aberrations... They\'ll get what\'s coming to them soon enough.','',26124),
(26166,'enUS','Xink\'s Shredder ready and available for woodland destruction.','',26124),
(26167,'enUS','Xink\'s Shredder security features activated.  Returning to base.','',26124),
(26168,'enUS','I have food, if you are hungry, and you may make use of my tent, should you require rest.','I have food, if you are hungry, and you may make use of my tent, should you require rest.',26124),
(26169,'enUS','The EMP disrupts Iron Thane Furyhammer\'s shield!','',26124),
(26170,'enUS','%s recovers from the EMP and restores Iron Thane Furyhammer\'s shield.','',26124),
(26171,'enUS','%s gains fuel.','',26124),
(26172,'enUS','Thanks, buddy! Let\'s see if I can\'t get this hunk o\' junk movin\' faster!','',26124),
(26173,'enUS','I will protect you, friend!','I will protect you, friend!',26124),
(26174,'enUS','Thank you, friend. Now these beasts shall feel the fury of the Sunwell!','Thank you, friend. Now these beasts shall feel the fury of the Sunwell!',26124),
(26175,'enUS','What you think you be doin? Get away from me!','',26124),
(26176,'enUS','','Preserve? Why? There\'s no truth in it. No no no... only in the taking! I see that now!',26124),
(26177,'enUS','Might not be snowy out there, but the nights here can freeze your nose right off. The bunks are in the back - just don\'t make a nuisance of yourself.','',26124),
(26178,'enUS','Heh. Nothing against you, pup, but you might want to find somewhere else to bed down for the night. Wouldn\'t want that tender skin of yours to get bruised.','',26124),
(26179,'enUS','Run away!','',26124),
(26180,'enUS','I don\'t wanna die!','',26124),
(26181,'enUS','Big guy will save us!','',26124),
(26182,'enUS','Ahh!!!','',26124),
(26183,'enUS','They\'re everywhere!','',26124),
(26184,'enUS','Come in by the fire and rest, $r. I hope you don\'t mind the smell of fish.','Come in by the fire and rest, $r. I hope you don\'t mind the smell of fish.',26124),
(26185,'enUS','Through the valleys and peaks of Mount Hyjal, across the shifting sands of Silithus, against the Legion\'s dread armies - we have fought. We are the nameless, faceless, sons and daughters of the Alliance. By the Light and by the might of the Alliance, the first strike belongs to us and the last strike is all that our enemies see.$B$BWe are 7th Legion.\n','',26124),
(26186,'enUS','You seek their leader... little thing, you wage war against the clans of Grom\'thar the Thunderbringer himself.  Don\'t be so eager to rush to your death.','You seek their leader... little thing, you wage war against the clans of Grom\'thar the Thunderbringer himself.  Don\'t be so eager to rush to your death.',26124),
(26187,'enUS','Hah!  So be it.  Blow the horn of a magnataur leader at the ring of torches south of the Blue Dragonshrine.  Make peace with your gods... Grom\'thar will come.  ','Hah!  So be it.  Blow the horn of a magnataur leader at the ring of torches south of the Blue Dragonshrine.  Make peace with your gods... Grom\'thar will come.  ',26124),
(26188,'enUS','Hah!  My slaves brought back a real meal this time!','',26124),
(26189,'enUS','Thank you for rescuing me, but the others are still held on the tiers above!','',26124),
(26190,'enUS','Thank goodness! I was worried they were going to press me into service in their war against the stone giants!','',26124),
(26191,'enUS','','These irons are crazy! They keep talking about serving their \'master Loken\' but from what I can tell, only a few receive orders from him.',26124),
(26192,'enUS','Greetings!  Do you need something?','',26124),
(26193,'enUS','This is all your fault, you know...','',26124),
(26194,'enUS','Of all the hair-brained, idiotic, BRAINLESS ideas... \"Yea, Brote, it\'ll be great... the Forsaken will rain gold coins down on our heads!\"','',26124),
(26195,'enUS','And you know what pisses me off more than anything, Skrotee? No, not that we\'ve been made into a living cuckoo clock for the amusement of the Forsaken. And not that we have to endure being spat upon and mocked every waking minute of our time here... What pisses me off the most is being made to wear these damned short-shorts...','',26124),
(26196,'enUS','Pray Skrotee... Find religion... Because if we ever get out of here, you will be wishing you were back in here!','',26124),
(26197,'enUS','I hope one of us dies. I hope that one is you, Skrotee.','',26124),
(26198,'enUS','Not this nonsense again...','',26124),
(26199,'enUS','Has it really been an hour?','',26124),
(26200,'enUS','If I ever get out of here, I will CRUSH every clock I come in contact with...','',26124),
(26201,'enUS','If I ever get out of here, I will CRUSH every clock I come in contact with...','',26124),
(26202,'enUS','At the bell\'s toll it will be 12:00am. Midnight to all you scary Forsaken! OOoooo...','',26124),
(26203,'enUS','At the bell\'s toll it will be 2:00am. Coincidentally, a perfect time to kill me and end my misery.','',26124),
(26204,'enUS','At the bell\'s toll it will be 4:00am. Don\'t you people ever sleep?','',26124),
(26205,'enUS','At the bell\'s toll it will be 6:00am *yawn*. Rise and shine.','',26124),
(26206,'enUS','At the bell\'s toll it will be 8:00am. I\'m sure you\'re all getting back from your morning jogs by now.','',26124),
(26207,'enUS','At the bell\'s toll it will be 10:00am. It\'s looking like there\'s gonna be more of the green poisonous cloud of death in today\'s weather forecast.','',26124),
(26208,'enUS','At the bell\'s toll it will be 12:00pm. Noon for those of you that can\'t count. That\'s right, I\'m looking at you, orcs.','',26124),
(26209,'enUS','At the bell\'s toll it will be 2:00pm. I want to take this opportunity to let you all know that Middleton\'s got a 2 for 1 sale going on right now! Buy 1 canister of his world famous poisonous biological agents and get the second free!','',26124),
(26210,'enUS','At the bell\'s toll it will be 4:00pm. That\'s HAPPY HOUR at Middleton\'s Apothecarium! Come on inside and get poisoned or gased or both for a mere 35 silver!','',26124),
(26211,'enUS','At the bell\'s toll it will be 6:00pm. Please kill my brother!','',26124),
(26212,'enUS','Ahhh! What be happenin\' to me, mon?','',26124),
(26213,'enUS','Is it my turn?','',26124),
(26214,'enUS','Is it lunch time?','',26124),
(26215,'enUS','I\'m gonna jump this time, Brote. I swear it!','',26124),
(26216,'enUS','At the bell\'s toll it will be 1:00am. If I ever break free, I will tear this town apart!!!','',26124),
(26217,'enUS','At the bell\'s toll it will be 3:00am. Time for bed!','',26124),
(26218,'enUS','At the bell\'s toll it will be 5:00am. End me!','',26124),
(26219,'enUS','At the bell\'s toll it will be 7:00am. Good morning to all you early risers!','',26124),
(26220,'enUS','At the bell\'s toll it will be 9:00am. It looks like another beautiful day in Dragonblight!','',26124),
(26221,'enUS','At the bell\'s toll it will be 11:00am. I want to take this opportunity to welcome all you new murderous, twisted Horde to Venomspite! So welcome, on behalf of me and my brother, Brote.','',26124),
(26222,'enUS','At the bell\'s toll it will be 1:00pm. We\'re right in the middle of the lunch time rush! Your poisons, plagues, and noxious gases are delivered in 60 seconds or your order is free!','',26124),
(26223,'enUS','At the bell\'s toll it will be 3:00pm. I think I soiled myself.','',26124),
(26224,'enUS','At the bell\'s toll it will be 5:00pm. To those that may have been keeping score, I did - in fact - soil myself.','',26124),
(26225,'enUS','At the bell\'s toll it will be 7:00pm. Another productive day at Venomspite comes to a close as night falls upon us.','',26124),
(26226,'enUS','At the bell\'s toll it will be 9:00pm. Break time for me! I\'ll see you all in 4 hours. Unless one of you kills me in my sleep (please).','',26124),
(26227,'enUS','','That spineless troll has failed me for the last time.  Anthis!  Break his legs!',26124),
(26228,'enUS','At once, my lady!','',26124),
(26229,'enUS','','I\'ve never seen you so eager to cause harm to someone, sister.  Such a pleasant development... very well, go!',26124),
(26230,'enUS','','My liege!  Allow me to go instead.',26124),
(26231,'enUS','','You... half-idiot... what got into you?  Pulling off something like that on her?  Did you think she wouldn\'t notice?',26124),
(26232,'enUS','You\'re late, overseer.','',26124),
(26233,'enUS','Destiny will not wait. Your craftsmen must increase their production of the war golems before the stone giant leader and his army reach Ulduar.','',26124),
(26234,'enUS','Tell your rune-smiths to continue converting what stone giants you can. Those that will not submit must be destroyed.','',26124),
(26235,'enUS','If the stone giants interfere with our work at Ulduar, I will hold you and your thane responsible. Mortals must not be allowed to come to the aid of the giants.','',26124),
(26236,'enUS','Return to your duties, overseer. Be certain to impress upon your workers the urgency of their tasks.','',26124),
(26237,'enUS','My S.T.O.U.T. is more than just a target for throwing steins, it\'s a valuable training asset.  If you can hit S.T.O.U.T. you can probably hit anything!$b$bJust try not to hit me.','',26124),
(26238,'enUS','Ringing','Ringing',26124),
(26239,'enUS','Let\'s see if this works.','',26124),
(26240,'enUS','Where... where am I?','',26124),
(26241,'enUS','Look alive, peasant! We\'ve got to get these structures back up!','',26124),
(26242,'enUS','That better be finished by the time Prince Arthas returns!','',26124),
(26243,'enUS','You\'re gonna have to hammer harder than that, fella! Get a move on!','',26124),
(26244,'enUS','Don\'t you wanna go home, peasant? These things aren\'t gonna rebuild themselves!','',26124),
(26245,'enUS','Attention!','',26124),
(26246,'enUS','At ease, lad. The Prince will be back soon and we\'ll be on our way back to Lordaeron.','',26124),
(26247,'enUS','You\'re doing a good job, soldier. Prince Arthas would be proud! Keep it up!','',26124),
(26248,'enUS','When all this is over, I\'m going to recommend you for an Alliance Mark of Honor.','',26124),
(26249,'enUS','Keep your eyes peeled for any suspicious activity, soldier. I\'ve spotted a few troublemakers mulling about.','',26124),
(26250,'enUS','Remain vigilant, soldier. This terrible war will be over soon.','',26124),
(26251,'enUS','You are among the Taunka of Camp Oneqwah, dwarf.','',26124),
(26252,'enUS','If you agree to help us against our mutual enemy, you will come to no harm here.','',26124),
(26253,'enUS','Think about it, prospector, but make up your mind swiftly. We must act soon.','',26124),
(26254,'enUS','I\'ve heard whisperings of intruders.  Be wary.','I\'ve heard whisperings of intruders.  Be wary.',26124),
(26256,'enUS','I sense the taint of this land in you, footman.  Report to the Bishop before the start of your next shift.','I sense the taint of this land in you, footman.  Report to the Bishop before the start of your next shift.',26124),
(26257,'enUS','You stink.  Take a shower.','You stink.  Take a shower.',26124),
(26258,'enUS','All rewards to be paid by High Executor Wroth upon verification.$B$BSerious-minded individuals inquire within.$B$BNO SOLICITORS!','',26124),
(26259,'enUS','I humbly offer myself to the will of the light.','I humbly offer myself to the will of the light.',26124),
(26260,'enUS','We will ravage the living... I mean the Scourge, of course.\n','',26124),
(26261,'enUS','Limpy Joe, it\'s you. It\'s really you!','',26124),
(26262,'enUS','Calm down. I want to you ask you about the iron dwarves and Loken.','Calm down. I want to you ask you about the iron dwarves and Loken.',26124),
(26263,'enUS','What brings you out here, little one?','',26124),
(26264,'enUS','What can you tell me about Loken and the iron dwarves?','What can you tell me about Loken and the iron dwarves?',26124),
(26265,'enUS','That\'s not something Limpy Joe would ask! But yeah, I know Loken.','',26124),
(26266,'enUS','He\'s out to get me, too! I\'d be careful around here if I was you, traveler. You never know which tree he\'s hiding behind!','',26124),
(26267,'enUS','Ah, yes. Loken is well known to me.','',26124),
(26268,'enUS','It is he who commands the sons of iron in their war against us.','',26124),
(26269,'enUS','From his hiding place, he oversees their preparations for war with the goal of exterminating the stone giants!','',26124),
(26270,'enUS','I humbly offer myself to the Light.','I humbly offer myself to the light.',26124),
(26271,'enUS','It is good that you have come my child.  The Light\'s protection has worn thin on you.','',26124),
(26272,'enUS','It is done.  Serve the Light well.','',26124),
(26273,'enUS','','Schlemiel!',26124),
(26274,'enUS','Huh?','',26124),
(26275,'enUS','','Apparently you flubbed this batch of blight. What do you have to say for yourself?',26124),
(26276,'enUS','<The Tuskarr eyes you suspiciously.>$b$bDo not stay long. You do not understand our people, and I don\'t want trouble.','<The Tuskarr eyes you suspiciously.>$b$bDo not stay long. You do not understand our people, and I don\'t want trouble.',26124),
(26277,'enUS','But... I followed your instructions precisely! Sorry?','',26124),
(26278,'enUS','','%s sighs.',26124),
(26279,'enUS','','Sorry? SORRY?! Here\'s sorry for you!',26124),
(26280,'enUS','','Oops. I guess it IS working! That\'s odd.',26124),
(26281,'enUS','Eep!','',26124),
(26282,'enUS','The sky is not safe, friend. Be alert!','',26124),
(26283,'enUS','No Effect!','',26124),
(26284,'enUS','One more beast saved from certain death!','One more beast saved from certain death!',26124),
(26285,'enUS','The Scourge are no match for me, Torp!','The Scourge are no match for me, Torp!',26124),
(26286,'enUS','Delivered as promised, Torp!','Delivered as promised, Torp!',26124),
(26287,'enUS','Return to the field of battle! Ejection imminent!','',26124),
(26288,'enUS','','Do watch your step in the garden of Ysera, mortal. Things are not always as they seem.',26124),
(26289,'enUS','','I\'m gonna need a cleanup and a new assistant over here!',26124),
(26290,'enUS','You need something? Maybe your armor or weapon repaired? Hmm?','',26124),
(26291,'enUS','I need some fresh meat... there hasn\'t been nearly enough blood shed today!','',26124),
(26292,'enUS','About time!','',26124),
(26293,'enUS','Any last words you impure mongrel?','',26124),
(26294,'enUS','On second thought, I don\'t care.  Burn in hell wretch!','',26124),
(26295,'enUS','Hah!  That never gets old.','',26124),
(26296,'enUS','Tell me if this hurts.','Tell me if this hurts.',26124),
(26297,'enUS','I think I\'ve got it this time...','I think I\'ve got it this time...',26124),
(26298,'enUS','Let\'s try this one out...','Let\'s try this one out...',26124),
(26299,'enUS','How\'d that feel?','How\'d that feel?',26124),
(26300,'enUS','Do you think that will get some answers?','Do you think that will get some answers?',26124),
(26302,'enUS','Was that potent enough?','Was that potent enough?',26124),
(26303,'enUS','','Do ye want ta live forever?',26124),
(26304,'enUS','Hmm... ','Hmm... ',26124),
(26305,'enUS','You need more bite.  Do not show our enemies any mercy.','You need more bite.  Do not show our enemies any mercy.',26124),
(26306,'enUS','The more pain we can inflict, the quicker we can get our answers.','The more pain we can inflict, the quicker we can get our answers.',26124),
(26307,'enUS','What more can you possibly want, $r?','',26124),
(26308,'enUS','Aargh!!','',26124),
(26309,'enUS','Stop!  Please...','',26124),
(26310,'enUS','Why are you here?','',26124),
(26311,'enUS','How can you possibly bring me lower?','',26124),
(26312,'enUS','What more can you take away from me?','',26124),
(26313,'enUS','You\'ve got a darkness in you, $r.','',26124),
(26314,'enUS','You aren\'t even asking me questions...','',26124),
(26315,'enUS','Are you trying to meet the real me?','',26124),
(26316,'enUS','You have shown me the face of true evil, $n.','',26124),
(26317,'enUS','','Desperate times call for desperate measures, $c.',26124),
(26318,'enUS','Do you have any items I can test?','Do you have any items I can test?',26124),
(26319,'enUS','True, but how far should we push?  At what point are we no better than our enemies?','True, but how far should we push?  At what point are we no better than our enemies?',26124),
(26320,'enUS','True, our enemies would show us no mercy.','True, our enemies would show us no mercy.',26124),
(26321,'enUS','Mounts. We need more mounts!','',26124),
(26322,'enUS','Mounts. We need more mounts!$B$BOh, you\'re probably here for your pet?','',26124),
(26323,'enUS','','The natural beauty of these hills belies a great darkness below.  Tread carefully, friend.',26124),
(26324,'enUS','The outhouse appears to be occupied at the moment.','',26124),
(26325,'enUS','Be wary, for the plagued tendrils of the Lich King lurk close.','Be wary, for the plagued tendrils of the Lich King lurk close.',26124),
(26326,'enUS','May the Light purge your infection, brave $n.','May the Light purge your infection, brave $n.',26124),
(26327,'enUS','My father has gifted me with his battle armor and axe. Soon I put it to good use.','',26124),
(26328,'enUS','If you are here to beg for the privilege of working for me, then your company is quite welcome. Otherwise, there is little chance you are of any use to me.','',26124),
(26330,'enUS','Tell me about yourself.','Tell me about yourself.',26124),
(26331,'enUS','Fortunately, the outhouse is currently vacant.','',26124),
(26332,'enUS','Use the outhouse.','Use the outhouse.',26124),
(26333,'enUS','','Our food and drink are in short supply.  I\'m afraid I do not have anything to offer you.',26124),
(26334,'enUS','','Thank you for your help, $n.  These frostberries are literally the fruits of your labor.',26124),
(26335,'enUS','You were all fools to come to this land!','',26124),
(26336,'enUS','I\'ll consume your flesh and pick my teeth with your bones!','',26124),
(26337,'enUS','You\'re no magnataur!  Where... did you... find... such strength?','',26124),
(26340,'enUS','Your women and children are next.  You\'ve failed your pitiful race.','',26124),
(26341,'enUS','HELP!','HELP!',26124),
(26342,'enUS','HELP! HELP!','HELP! HELP!',26124),
(26343,'enUS','YOU\'LL NEVER CATCH ME, FIENDS!','YOU\'LL NEVER CATCH ME, FIENDS!',26124),
(26344,'enUS','For the love of the Light, get me out of here!','For the love of the Light, get me out of here!',26124),
(26345,'enUS','I picked a bad day to stop drinking!','I picked a bad day to stop drinking!',26124),
(26346,'enUS','THEY\'RE TRYING TO KILL ME! HELP!','THEY\'RE TRYING TO KILL ME! HELP!',26124),
(26347,'enUS','I\'ll die before I let one of you fiends turn me!','I\'ll die before I let one of you fiends turn me!',26124),
(26348,'enUS','Where did this all come from! Somebody help!','Where did this all come from! Somebody help!',26124),
(26349,'enUS','Who woulda thought that we\'d have this problem again? Oh wait, EVERYBODY DID!','Who woulda thought that we\'d have this problem again? Oh wait, EVERYBODY DID!',26124),
(26350,'enUS','Alright Ben. We\'ve retrieved the amberseeds again. You know the drill.','',26124),
(26351,'enUS','I know, I know. Back in the bucket....','',26124),
(26352,'enUS','BRAIIIIINS!!!','',26124),
(26353,'enUS','I HUNGERRRRR!!','',26124),
(26354,'enUS','FEED ME!! FEED ME!!!','',26124),
(26355,'enUS','NOM NOM NOM!','',26124),
(26356,'enUS','NO RUN!!! NO MORE RUN!!!!','',26124),
(26357,'enUS','Thanks for your help, hero!','Thanks for your help, hero!',26124),
(26358,'enUS','You saved my life! Thanks!','You saved my life! Thanks!',26124),
(26359,'enUS','Are you sure you know how to fly this thing? Feels a little wobbly.','Are you sure you know how to fly this thing? Feels a little wobbly.',26124),
(26360,'enUS','I don\'t mean to sound ungrateful, but could you fly a little closer to the ground? I hate heights!','I don\'t mean to sound ungrateful, but could you fly a little closer to the ground? I hate heights!',26124),
(26361,'enUS','When I learned about my relatives here in the north, I came to learn more.  What I found was warring tribes acting against our very nature.$B$BI have no hope left, $r.  Even great Ursoc has been tainted by this cursed place.$B$BI\'ve lost all hope.','',26124),
(26362,'enUS','You are my guardian angel! Like a white knight you flew in from the heavens and lifted me from the pit of damnation!','You are my guardian angel! Like a white knight you flew in from the heavens and lifted me from the pit of damnation!',26124),
(26363,'enUS','How can I ever repay you for this, friend?','How can I ever repay you for this, friend?',26124),
(26364,'enUS','I\'m gettin\' a little woozy... Oooooof...','I\'m gettin\' a little woozy... Oooooof...',26124),
(26365,'enUS','Stealing','Stealing',26124),
(26366,'enUS','Come with me if you want to live.','Come with me if you want to live.',26124),
(26367,'enUS','Get on!','Get on!',26124),
(26368,'enUS','Take my hand, villager!','Take my hand, villager!',26124),
(26369,'enUS','I am here to save you, friend!','I am here to save you, friend!',26124),
(26370,'enUS','Get on the back of my gryphon, citizen!','Get on the back of my gryphon, citizen!',26124),
(26371,'enUS','Hurry! Climb aboard!','Hurry! Climb aboard!',26124),
(26372,'enUS','Return to Wintergarde or the Carrion Fields or your gryphon will drop you!','',26124),
(26373,'enUS','Stay behind me, $r.  I will do my best to protect you.','',26124),
(26374,'enUS','My freedom means nothing if we fail to save Ursoc.  Make haste, $n.','',26124),
(26375,'enUS','I will watch over you and your allies, $r.','',26124),
(26376,'enUS','Assume your druidic bear form, Tur.','Assume your druidic bear form, Tur.',26124),
(26377,'enUS','Help us subdue him.','Help us subdue him.',26124),
(26378,'enUS','We could use a healer.','We could use a healer.',26124),
(26379,'enUS','We have the purified ashes of Vordrassil\'s sapling.  If we can subdue Ursoc, we might be able to heal his soul.','We have the purified ashes of Vordrassil\'s sapling.  If we can subdue Ursoc, we might be able to heal his soul.',26124),
(26380,'enUS','Yes... I sense Vordrassil\'s magic... free of any perceivable taint.$B$BPlease!  You must allow me to help you.  Fate brought me here, perhaps I can serve a purpose yet!','',26124),
(26381,'enUS','Safe at last! Thank you, stranger!','Safe at last! Thank you, stranger!',26124),
(26382,'enUS','HURRAY!','HURRAY!',26124),
(26383,'enUS','Kindness is not lost with this one, Urik. Thank you, hero!','Kindness is not lost with this one, Urik. Thank you, hero!',26124),
(26384,'enUS','We made it! We actually made it!','We made it! We actually made it!',26124),
(26385,'enUS','My shop\'s doors will always be open to you, friend.','My shop\'s doors will always be open to you, friend.',26124),
(26386,'enUS','','We will never forget your bravery, $n. You are always welcome in Wintergarde.$B$BWould you like to make this inn your home?',26124),
(26387,'enUS','I would like to browse your goods, Illusia.','I would like to browse your goods, Illusia.',26124),
(26388,'enUS','Zybarus thanks you from the bottom of his heart, hero. Without you, Zybarus would have died, or worse, Zybarus would have become one of them...','',26124),
(26389,'enUS','The %s moans but seems otherwise unaffected by the blight.','',26124),
(26390,'enUS','Your protection is strong, child.  Continue your work.','Your protection is strong, child.  Continue your work.',26124),
(26391,'enUS','You require the Bishop\'s blessing.  Go to him soon.','You require the Bishop\'s blessing.  Go to him soon.',26124),
(26392,'enUS','Remain on the pure path.  The Light will protect you.','Remain on the pure path.  The Light will protect you.',26124),
(26393,'enUS','You are impure!','You are impure!',26124),
(26394,'enUS','Die, cur!','Die, cur!',26124),
(26395,'enUS','Be washed from my sight!','Be washed from my sight!',26124),
(26396,'enUS','By the Light!','By the Light!',26124),
(26397,'enUS','Wretch!','Wretch!',26124),
(26398,'enUS','Defiler!','Defiler!',26124),
(26399,'enUS','Abbendis will see you purged!','Abbendis will see you purged!',26124),
(26400,'enUS','You were a fool to come here.','You were a fool to come here.',26124),
(26401,'enUS','You will be cleansed!','You will be cleansed!',26124),
(26402,'enUS','In the name of the Light!','In the name of the Light!',26124),
(26403,'enUS','By the Light!','By the Light!',26124),
(26404,'enUS','Be purified by steel!','Be purified by steel!',26124),
(26405,'enUS','How dare you interrupt our righteous work?!','',26124),
(26406,'enUS','A rune on %s begins to glow brightly!','',26124),
(26407,'enUS','I once roamed the Grizzly Hills, son to the great Ursoc, who ruled over this land.$B$BBut now... now I\'m doomed to spend the rest of my life in this cave.','',26124),
(26408,'enUS','You\'re free to go Orsonn, but first tell me what\'s wrong with the furbolg.','You\'re free to go Orsonn, but first tell me what\'s wrong with the furbolg.',26124),
(26409,'enUS','You don\'t understand.  If I wanted to I could fight my way out of this cave.$B$BIt\'s my father, Ursoc.  He has returned from the dead... but he\'s not the same.$B$BHe gave his life during the War of the Ancients thousands of years ago.  For centuries, the furbolg who worshipped him tried to devise a way to resurrect him.$B$BFinally they decided they were to attempt to regrow the failed world tree, Vordrassil, and use its magic to bring back my father.','',26124),
(26410,'enUS','','Keep your voice down, $c. I\'m in disguise and spying for Venomspite.',26124),
(26411,'enUS','What happened then?','What happened then?',26124),
(26412,'enUS','The sapling they grew bore a fruit.  At first it seemed to work.  Ursoc did come back and I was filled with joy for a brief moment.$B$BAs he recovered, it was clear that he wasn\'t the same.  Neither were the furbolg.$B$BWhatever evil caused the ancient druids to tear down Vordrassil manifested itself in the new tree and turned them all into monsters filled with bloodlust.$B$BThe thing that now walks the Grizzly Hills is not my father and it must be put to rest.','',26124),
(26413,'enUS','Thank you, Son of Ursoc.  I\'ll see what can be done.','Thank you, Son of Ursoc.  I\'ll see what can be done.',26124),
(26414,'enUS','I am Kodian, daughter of Ursoc.  I watch over this once sacred shrine.$B$BI\'ve not seen a stranger come here in a long time.','',26124),
(26415,'enUS','Who was this stranger?','Who was this stranger?',26124),
(26416,'enUS','A furbolg named Tur Ragepaw.  Not one of ours.$B$BThis one came from the southern lands.  He was of the Timbermaw tribe.$B$BHe wanted to see Ursoc.  He seemed to think that Vordrassil\'s taint could be purified and used to save my father.$B$BIt is foolish to entertain such hopes.  You will agree when you see the darkness that has afflicted him like I have.','',26124),
(26417,'enUS','Thank you, Kodian.  I\'ll do what I can.','Thank you, Kodian.  I\'ll do what I can.',26124),
(26418,'enUS','My beautiful mill. You! You\'ll die for this!','',26124),
(26419,'enUS','Go with the Light, friend.','Go with the Light, friend.',26124),
(26420,'enUS','May the Light have mercy on your soul, fiend.','May the Light have mercy on your soul, fiend.',26124),
(26421,'enUS','They were once people... Now? Undead monsters with an appetite for flesh!','They were once people... Now? Undead monsters with an appetite for flesh!',26124),
(26422,'enUS','Ooooh! I think that one\'s head exploded!','Ooooh! I think that one\'s head exploded!',26124),
(26423,'enUS','Light take you!','Light take you!',26124),
(26424,'enUS','%s clears a jam from his rifle.','%s clears a jam from his rifle.',26124),
(26425,'enUS','Finally, a worthy offering!','',26124),
(26426,'enUS','Filthy cretin. Your kind doesn\'t deserve to live. Have at thee!','',26124),
(26427,'enUS','Ursoc, brother of Ursol and guardian of the furbolg tribes... show yourself!','',26124),
(26428,'enUS','Hey Celidh!  Do you have any pets you want me to take over to the stable?','',26124),
(26429,'enUS','Sure is busy here Celidh.  Do you have any pets you want me to move to the stables?','',26124),
(26430,'enUS','I bet with all these new people here, Celidh, you\'ve got to have some pets you want me to move to the stables.','',26124),
(26431,'enUS','C\'mon boy, let\'s get you away from all this noise.','',26124),
(26432,'enUS','Let\'s go boy.','',26124),
(26433,'enUS','This way, boy.  I\'ll take you to our nice stables in the back.','',26124),
(26434,'enUS','It sure is bright out here... and flat.','',26124),
(26435,'enUS','Tell me how to make those carrots!','Tell me how to make those carrots!',26124),
(26436,'enUS','I thank you all.  The druids of old were wise to tear down Vordrassil, for its roots seep deep into the dwelling of an ancient evil. ','',26124),
(26437,'enUS','You know their kind as old gods.  Beware Yogg-Saron, the beast with a thousand maws.  His evil extends beyond Vordrassil\'s roots.','',26124),
(26438,'enUS','','Think you could get me out of here, $c?',26124),
(26439,'enUS','I\'m afraid not, Schneider. Your time has come!','I\'m afraid not, Schneider. Your time has come!',26124),
(26440,'enUS','Oh good, you\'re here to rescue me. Now let me out of here!','',26124),
(26441,'enUS','Not today, senior scrivener!','Not today, senior scrivener!',26124),
(26442,'enUS','Hey, $g buddy : ma\'am;. I\'ve seen you around.$B$BMind getting me out of here?','',26124),
(26443,'enUS','Afraid not. Your days as a sanitation engineer are coming to an end.','Afraid not. Your days as a sanitation engineer are coming to an end.',26124),
(26444,'enUS','Attack now, my minions! Your master commands it!','',26124),
(26445,'enUS','End this mortal affront to the Lich King!','',26124),
(26446,'enUS','Their defenses are down! The time is now, minions! ATTACK!','',26124),
(26447,'enUS','I don\'t know what happened. I had just arrived at Venomspite and then all of a sudden I woke up in this cage!$B$BAre you here to rescue me?','',26124),
(26448,'enUS','No, chancellor, I wouldn\'t say that I\'m here to \'rescue\' you, per se.','No, chancellor, I wouldn\'t say that I\'m here to \'rescue\' you, per se.',26124),
(26449,'enUS','','What do you mean my time has come?! I\'ll kill you where you stand!',26124),
(26450,'enUS','You can\'t possibly mean to.... I\'ll write you up for this, $c!','',26124),
(26451,'enUS','','Hey, over here!',26124),
(26452,'enUS','If you\'d be so kind, please let me out of here!','',26124),
(26453,'enUS','Can someone let me out of here? I need to get back to Venomspite and finish my shift.','',26124),
(26454,'enUS','No! I beg you! Please don\'t kill me!','',26124),
(26455,'enUS','Legion, to the front lines!','',26124),
(26456,'enUS','Reinforce the gate! Do not let the Scourge through!','',26124),
(26457,'enUS','Hold the line! Legion, focus fire at the gates!','',26124),
(26458,'enUS','What is the meaning of this?! Stop! I\'ll double whatever they\'re paying you!','',26124),
(26459,'enUS','I just arrived in Venomspite. How could I have possibly wronged you?','',26124),
(26460,'enUS','','Greetings, $c.$B$BHow may I help you?',26124),
(26461,'enUS','Thane Torvald Eriksson\'s temperamental proto-drake is chained up here.','',26124),
(26462,'enUS','Unchain and control Flamebringer.','Unchain and control Flamebringer.',26124),
(26463,'enUS','Yes? What is it?','',26124),
(26464,'enUS','Rise my warriors and fight for your new liege!','',26124),
(26467,'enUS','Thank you, kind soul.','Thank you, kind soul.',26124),
(26468,'enUS','I\'ll never forget you, friend.','I\'ll never forget you, friend.',26124),
(26469,'enUS','Finally! A hero has come!','Finally! A hero has come!',26124),
(26470,'enUS','Good of you to come, champion! The beast almost had me!','Good of you to come, champion! The beast almost had me!',26124),
(26471,'enUS','Annihilate them.','',26124),
(26472,'enUS','Come to play?','',26124),
(26473,'enUS','Please enjoy their company, the Lich King sends his regards!','',26124),
(26474,'enUS','Don\'t be so quick to escape! I have a parting gift....','',26124),
(26475,'enUS','See this statue, boy?  This is the king of Stormwind, Varian Wrynn.','',26124),
(26476,'enUS','His son, Anduin Wrynn, was the king for a while.  He\'s about my age too.  Can you imagine if I were the king?','',26124),
(26477,'enUS','People used to come up to me because they thought I was the king.  I guess we look alike...','',26124),
(26478,'enUS','If I were king, I\'d have a horse like you.  I\'d make sure you didn\'t get lost, and I bet you\'d make sure I never got lost.','',26124),
(26479,'enUS','We\'d be best friends.  I bet me and Anduin would also be best friends, too.  Friends are important.  ','',26124),
(26480,'enUS','Ow! I\'ll tell you NOTHING, filthy $r!','',26124),
(26481,'enUS','Wait... WAIT! What is it that you want to know?! I know you\'re the $c named $n.','',26124),
(26482,'enUS','OW...NO! We know that you\'ve been stealing our armor and weapons and horses!','',26124),
(26483,'enUS','We know... that you don\'t... know why we\'re immune... to your so-called blight. Grand Admiral Westwind somehow gave the high abbot that prayer. I beg you... no more... please?!','',26124),
(26484,'enUS','AHHHHHHHHH! Please... we know... that you... have a spy... disguised as... one of us! There... that\'s all that I know. Please... mercy... STOP!','',26124),
(26486,'enUS','I\'ll take you to some other horses.  You probably miss being around other horses.  They can be your friend too.','',26124),
(26487,'enUS','Did that seem okay?','Did that seem okay?',26124),
(26488,'enUS','This is harder than it looks.','This is harder than it looks.',26124),
(26489,'enUS','This isn\'t easy.','This isn\'t easy.',26124),
(26490,'enUS','I think I\'m starting to get the hang of this.','I think I\'m starting to get the hang of this.',26124),
(26491,'enUS','My arm is getting sore.','My arm is getting sore.',26124),
(26492,'enUS','Hmm....','Hmm....',26124),
(26493,'enUS','I\'m just nervous.  Sorry.','I\'m just nervous.  Sorry.',26124),
(26494,'enUS','I just don\'t want to let anyone down.','I just don\'t want to let anyone down.',26124),
(26495,'enUS','I need to do something to keep myself busy.','I need to do something to keep myself busy.',26124),
(26496,'enUS','I TOLD YOU... I don\'t know... anything... else!','',26124),
(26497,'enUS','You aren\'t going to let me sleep are you?','You aren\'t going to let me sleep are you?',26124),
(26498,'enUS','Please... stop. I\'ll do... anything....','',26124),
(26499,'enUS','Just... end it.','',26124),
(26500,'enUS','Could you try to be a little quieter?','Could you try to be a little quieter?',26124),
(26501,'enUS','They all... begged... for their... lives!','',26124),
(26502,'enUS','Are you going to be doing this for much longer?','Are you going to be doing this for much longer?',26124),
(26503,'enUS','Every two years the Spirits of Competition grow especially fervent... and now is that time! We wear this tabard into the Battlegrounds to honor them, seeking to defeat our enemies and earn their favor.','Every two years the Spirits of Competition grow especially fervent... and now is that time! We wear this tabard into the Battlegrounds to honor them, seeking to defeat our enemies and earn their favor.',26124),
(26504,'enUS','I beg you... no more.','',26124),
(26505,'enUS','THIS IS TORTURE!','',26124),
(26506,'enUS','You won\'t get... anything else... out of me!','',26124),
(26507,'enUS','OWWWWWWWW!','',26124),
(26508,'enUS','How do I earn a Competitor\'s Tabard?','How do I earn a Competitor\'s Tabard?',26124),
(26509,'enUS','How can I gain the favor of a Spirit of Competition?','How can I gain the favor of a Spirit of Competition?',26124),
(26510,'enUS','You need only face our rivals in any of the Battlegrounds. Win or lose, if you stay for the duration of the battle, you will be mailed a Competitor\'s Tabard.','You need only face our rivals in any of the Battlegrounds. Win or lose, if you stay for the duration of the battle, you will be mailed a Competitor\'s Tabard.',26124),
(26511,'enUS','You must defeat our rivals in any of the Battlegrounds. With every victory, there is a chance that a Gold Medallion will be mailed to you.','You must defeat our rivals in any of the Battlegrounds. With every victory, there is a chance that a Gold Medallion will be mailed to you.',26124),
(26512,'enUS','You know of the Spirits of Competition, yes?$B$BEvery two years they draw close to the mortal realm. During such times, members of both the Alliance and Horde wear Competitor\'s Tabards into the Battlegrounds to honor the spirits, seeking to defeat one another and earn their favor.$B$BI stockpile souvenirs from such turbulent times. If you\'ve learned the proper word, I might be convinced to part with one...','You know of the Spirits of Competition, yes?$B$BEvery two years they draw close to the mortal realm. During such times, members of both the Alliance and Horde wear Competitor\'s Tabards into the Battlegrounds to honor the spirits, seeking to defeat one another and earn their favor.$B$BI stockpile souvenirs from such turbulent times. If you\'ve learned the proper word, I might be convinced to part with one...',26124),
(26513,'enUS','I would like to enter the secret code to receive my Competitor\'s Souvenir.','I would like to enter the secret code to receive my Competitor\'s Souvenir.',26124),
(26514,'enUS','Rise and fight! Kill the living! [PH]','',26124),
(26515,'enUS','We must kill these intruders! [PH]','',26124),
(26516,'enUS','Go my warrior! Slay the living! [PH]','',26124),
(26517,'enUS','Go forth my little pet, kill these mongrels and feast on their flesh! [PH]','',26124),
(26518,'enUS','','We are quickly learning the price of death in this frigid wasteland, $n. The Lich King\'s power extends across every inch of Northrend, permeating into the earth itself! He turns our own fallen people against us.$B$BFrom the sky, risen gryphon riders rain down their vengeful stormhammers as the walking dead assail us on the ground.\n',26124),
(26519,'enUS','Krenna must doubt my abilities. While our elite warriors march out to face the Alliance and their trapper allies, or wreak havoc among the trolls, I\'ve been assigned to mop up those pesky Dragonflayer vrykul.$B$BPerhaps if we combine our efforts, we can both prove ourselves in the conqueror\'s sight.','',26124),
(26520,'enUS','Welcome to Amberpine Lodge, $c.','',26124),
(26521,'enUS','','You\'re such a sweet lad.  Here, take this horse over to your stable.',26124),
(26522,'enUS','','All these folks are keeping me busy.  Take this horse over to your stables.',26124),
(26523,'enUS','','Here\'s a fine one for you.  Take good care of him.',26124),
(26524,'enUS','','Here, take this horse over to your stable.  Tell Ronald, \"Hello.\"',26124),
(26525,'enUS','Where is Senior Scrivener Barriga being held?','Where is Senior Scrivener Barriga being held?',26124),
(26526,'enUS','I think they put him in a cage over near the lumbermill.','I think they put him in a cage over near the lumbermill.',26124),
(26527,'enUS','Did you see where they took Sanitation Engineer Burke?','Did you see where they took Sanitation Engineer Burke?',26124),
(26528,'enUS','You must defeat your rivals in any of the Battlegrounds. With every victory, there is a chance that a Gold Medallion will be mailed to you.','You must defeat your rivals in any of the Battlegrounds. With every victory, there is a chance that a Gold Medallion will be mailed to you.',26124),
(26529,'enUS','I think he\'s on the south side of the abbey.','I think he\'s on the south side of the abbey.',26124),
(26530,'enUS','You need only face your rivals in any of the Battlegrounds. Win or lose, if you stay for the duration of the battle, you will be mailed a Competitor\'s Tabard.','You need only face your rivals in any of the Battlegrounds. Win or lose, if you stay for the duration of the battle, you will be mailed a Competitor\'s Tabard.',26124),
(26531,'enUS','Every two years the Spirits of Competition grow especially fervent... and now is that time! Both Alliance and Horde wear this tabard into the Battlegrounds to honor the spirits, seeking to defeat all enemies and earn their favor.','Every two years the Spirits of Competition grow especially fervent... and now is that time! Both Alliance and Horde wear this tabard into the Battlegrounds to honor the spirits, seeking to defeat all enemies and earn their favor.',26124),
(26532,'enUS','Any idea where they\'re keeping Deathguard Schneider?','Any idea where they\'re keeping Deathguard Schneider?',26124),
(26533,'enUS','I think they have her down near the gallows.','I think they have her down near the gallows.',26124),
(26534,'enUS','Can you tell me where they have Chancellor Amai caged?','Can you tell me where they have Chancellor Amai caged?',26124),
(26535,'enUS','I think I saw them take him over by the north side of the abbey, near the archery targets.','I think I saw them take him over by the north side of the abbey, near the archery targets.',26124),
(26536,'enUS','','%s flees back to its den....',26124),
(26537,'enUS','Backup! We need backup!','',26124),
(26538,'enUS','Help mon! There\'s too many of dem!','',26124),
(26539,'enUS','You don\'t even know, do you?  The trappers?  They\'re not human... we have to get out of here!  Come, quick!','',26124),
(26540,'enUS','Take Ducal\'s horse, he\'s one of them now!','',26124),
(26541,'enUS','What\'s going on here, sarge?','What\'s going on here, sarge?',26124),
(26542,'enUS','I don\'t know. Better kill them both to be on the safe side!','I don\'t know. Better kill them both to be on the safe side!',26124),
(26543,'enUS','HELP! HELP! THIS $g MAN : WOMAN; HAS STOLEN MY IMAGE!','HELP! HELP! THIS $g MAN : WOMAN; HAS STOLEN MY IMAGE!',26124),
(26544,'enUS','I know why you\'ve come - one of those foolish Magnataur on the plains meddled and managed to get the dragons involved.  Do you enjoy serving them like a dog?','I know why you\'ve come - one of those foolish Magnataur on the plains meddled and managed to get the dragons involved.  Do you enjoy serving them like a dog?',26124),
(26545,'enUS','The mine is lost. All of our defenders have perished and the miners resurrected as Scourge aberrations!','',26124),
(26546,'enUS','Flamebringer attempts to throw you from his back. Return to Voldrune!','',26124),
(26547,'enUS','Foolish errand $G boy:girl;... you will die for interrupting my work!','',26124),
(26548,'enUS','It does get worse, old friend. According to my calculations, without suitable materials to repair our parapets, the walls protecting this keep will crumble in twelve hours.','',26124),
(26549,'enUS','Grim news, my pint-sized companion. Should we suffer a defeat here the ramifications will be felt across this frozen wasteland. Lord Fordragon and our armies at the Wrathgate will be defenseless against an assault from Naxxramas.','',26124),
(26550,'enUS','We have been through worse and survived, Leoric. Do not forget Hyjal...','',26124),
(26551,'enUS','Yes, yes, I haven\'t forgotten Hyjal, or Silithus, or the march of the Legion, or every other damnable confrontation the 7th Legion has faced. It... I don\'t want the soldiers to hear this, Two-bit, but for the first time in my life...','',26124),
(26552,'enUS','Say no more, Leoric. We all feel the chill in our bones. Yet, each day, heroes arrive from across the world - and beyond.','',26124),
(26553,'enUS','I have heard whisperings from the east that our esteemed Scarab Lord has joined the battle, as have entire batallions from Shattrath: heroes blessed by A\'dal himself, granted rank as Hand of A\'dal!','',26124),
(26554,'enUS','You are right, of course, old friend. Let us hope that these heroes arrive soon.','',26124),
(26555,'enUS','No... NO! What have you done?! So many ancient wyrms wasted... what magic could do this? ','',26124),
(26556,'enUS','The Spirits of Competition have grown strong again.','The Spirits of Competition have grown strong again.',26124),
(26557,'enUS','The Battlegrounds are full of eager competitors today.','The Battlegrounds are full of eager competitors today.',26124),
(26558,'enUS','The battlemasters are pleased with how many are coming to compete.','The battlemasters are pleased with how many are coming to compete.',26124),
(26559,'enUS','I\'m proud to have earned my Competitor\'s Tabard, and seek a Gold Medallion next.','I\'m proud to have earned my Competitor\'s Tabard, and seek a Gold Medallion next.',26124),
(26560,'enUS','The Spirits of Competition have grown strong again.','The Spirits of Competition have grown strong again.',26124),
(26561,'enUS','The Battlegrounds are full of eager competitors today.','The Battlegrounds are full of eager competitors today.',26124),
(26562,'enUS','The battlemasters are pleased with how many are coming to compete.','The battlemasters are pleased with how many are coming to compete.',26124),
(26563,'enUS','I\'m proud to have earned my Competitor\'s Tabard, and seek a Gold Medallion next.','I\'m proud to have earned my Competitor\'s Tabard, and seek a Gold Medallion next.',26124),
(26564,'enUS','The Spirits of Competition have grown strong again.','The Spirits of Competition have grown strong again.',26124),
(26565,'enUS','The Battlegrounds are full of eager competitors today.','The Battlegrounds are full of eager competitors today.',26124),
(26566,'enUS','The battlemasters are pleased with how many are coming to compete.','The battlemasters are pleased with how many are coming to compete.',26124),
(26567,'enUS','I\'m proud to have earned my Competitor\'s Tabard, and seek a Gold Medallion next.','I\'m proud to have earned my Competitor\'s Tabard, and seek a Gold Medallion next.',26124),
(26568,'enUS','You are a black wyrm no longer.  Go... go and serve the Scourge.','',26124),
(26569,'enUS','Greetings, $c.$b$bYou want Darrok to send you to Venture Bay?','',26124),
(26570,'enUS','Yes, I am ready to travel to Venture Bay!','Yes, I am ready to travel to Venture Bay!',26124),
(26571,'enUS','The Destructive Ward has been destroyed.','',26124),
(26572,'enUS','Me hungry.','',26124),
(26573,'enUS','Me sleepy.','',26124),
(26574,'enUS','Me cold.','',26124),
(26575,'enUS','Me scared of bug things.','',26124),
(26576,'enUS','Me got stuck in sticky bug rope.','',26124),
(26577,'enUS','Me no like rock place full of bugs.','',26124),
(26578,'enUS','Me no like new cold place.','',26124),
(26582,'enUS','Ha ha.','',26124),
(26583,'enUS','That funny.','',26124),
(26584,'enUS','Ow.','',26124),
(26585,'enUS','Stop it!','',26124),
(26586,'enUS','That hurt.','',26124),
(26587,'enUS','What that sound?','',26124),
(26588,'enUS','Your head like rock.','',26124),
(26589,'enUS','It time for work! Zug zug!','',26124),
(26590,'enUS','What? Can\'t you see that I\'m busy here?$B$BYou think this transmatter is going to fix itself?!','',26124),
(26594,'enUS','Highlord Bolvar Fordragon fights for us all, newcomer. Were it not for him, Arthas would be sitting upon the throne of Stormwind right this very moment.','',26124),
(26595,'enUS','I am so very close to figuring this ore out. Any minute now and I will have the solution!','',26124),
(26596,'enUS','You are being misled! The Onslaught is all lies! The Scourge and the Forsaken are not our enemies! Wake up!','',26124),
(26597,'enUS','High General Abbendis personally told me that it was a mistake to come north and that we\'re doomed! I urge you all to lay down your weapons and leave before it\'s too late!','',26124),
(26598,'enUS','Renounce the Scarlet Onslaught! Don\'t listen to the lies of the high general and the grand admiral any longer!','',26124),
(26599,'enUS','Abbendis is nothing but a harlot and Grand Admiral Westwind is selling her cheap like he sold us out!','',26124),
(26600,'enUS','The bot will adjust its speed to match your own. I would suggest you mount up to speed things along. By the way, the bot was put together with salvaged components from a pile of scrap metal delivered to me from Outland. There were some side effects.','',26124),
(26601,'enUS','The Destructive Ward gains in power.','',26124),
(26602,'enUS','The Destructive Ward is fully charged!','',26124),
(26603,'enUS','Quarterflash, I need another homing bot.','Quarterflash, I need another homing bot.',26124),
(26604,'enUS','\'Ello, $c!$b$bYa ready ta head on down to Venture Bay and crack some Horde skulls?','',26124),
(26605,'enUS','Yes, I am ready to travel to Venture Bay!','Yes, I am ready to travel to Venture Bay!',26124),
(26606,'enUS','Perfect.  As long as you don\'t go hacking and slashing your way through, they\'ll never know the difference.','',26124),
(26607,'enUS','%s rises from the floor!','',26124),
(26608,'enUS','Boys, go see who\'s doing that.','',26124),
(26609,'enUS','Yes, your eminence. Come on!','',26124),
(26610,'enUS','Hey, who rang the bell?','',26124),
(26611,'enUS','The bodyguard grunts.','',26124),
(26612,'enUS','Yes, my $g son : daughter;?','',26124),
(26613,'enUS','I am busy, my child. Come back in a moment and we will speak.','',26124),
(26614,'enUS','Your eminence, may I have a word in private?','Your eminence, may I have a word in private?',26124),
(26615,'enUS','<The high abbot studies you a moment and then smiles.>$B$BVery well, I know a place, child. You just kiss my ring and let me know when you are ready.','',26124),
(26616,'enUS','I am ready, your grace. <kiss the ring>','I am ready, your grace. <kiss the ring>',26124),
(26617,'enUS','Then meet me at the entrance to the abbey. I\'ll be along in short order.','',26124),
(26618,'enUS','','The nerubian siege outside is chilling, Sagai. There seems to be no end to them.',26124),
(26619,'enUS','Yah. It be dem sinkholes. You see dem? Dere be talk of blowin\' dem up, cavin\' dem in.','',26124),
(26620,'enUS','','That\'s right... I recovered munitions from the quarry just yesterday for that purpose.',26124),
(26621,'enUS','','I hope the charges are set soon. Everyone could use a respite.',26124),
(26622,'enUS','You got dat right.','',26124),
(26623,'enUS','','Saurfang is here, Sagai! Saurfang! The brother of Broxigar himself, here to aid our efforts!',26124),
(26624,'enUS','I\'ve played my part in destroying entire civilizations... to have to lower myself to dealing with the wretched Cult of the Damned disgusts me.','',26124),
(26625,'enUS','Agent Skully, I need you to use the banshee\'s magic mirror on me again!','Agent Skully, I need you to use the banshee\'s magic mirror on me again!',26124),
(26626,'enUS','','Fine, but be more careful with it this time!',26124),
(26627,'enUS','It appears they are using those runes to deposit some of the power they\'ve drained.','',26124),
(26628,'enUS','Geist... disgusting. The Cult has infested this place.','',26124),
(26629,'enUS','I know a place nearby where we can speak in private, my child. Follow me.','',26124),
(26630,'enUS','I had hoped my suspicions were incorrect... they\'re resurrecting magmawyrms.  Come back to me immediately, it is time to purge this place of the Cult.','',26124),
(26631,'enUS','Did you think that I could not see through your flimsy disguise, $n?','',26124),
(26632,'enUS','There is much that you do not understand, $r. The Master sees all.','',26124),
(26633,'enUS','He told me that you would come for me. I won\'t die by your hand, though. I have seen what you have done to my compatriots.','',26124),
(26634,'enUS','No. I will leave this world in a manner of my own choosing. And I will return, the grand admiral\'s will permitting!','',26124),
(26635,'enUS','','Keep your voice down. We wouldn\'t want to attract any attention from these beasties!',26124),
(26636,'enUS','AAAEEEEIIIiiiiiiiiiiiiiiiiiiiiiiiiiiii........................................','',26124),
(26637,'enUS','Gah! What are you doing?','Gah! What are you doing?',26124),
(26638,'enUS','A member of the priesthood whom I\'ve never seen before.','A member of the priesthood whom I\'ve never seen before.',26124),
(26639,'enUS','By the Light, you killed Limpy Joe and took the meat! How did you know where to find us?','',26124),
(26640,'enUS','Were you bitten?','',26124),
(26641,'enUS','Answer me!  Were you bloody bitten?','',26124),
(26642,'enUS','Well, if you\'ve come to kill me, too, can you at least wait until I\'ve fed Griselda? Poor girl hasn\'t eaten in days.','',26124),
(26643,'enUS','Here, girl. I\'ve got one last meal for you before Limpy Joe\'s killer does us in!','',26124),
(26644,'enUS','There\'s lamp oil in the back - make use of it.  The fiends hate fire!','',26124),
(26645,'enUS','How could you kill poor, defenseless old Joe? And why did you bring the meat back?','',26124),
(26646,'enUS','You\'re an enigma, that\'s what you are... And let me tell you, enigmas and I don\'t get along....','',26124),
(26647,'enUS','I think you\'d best leave before Griselda decides she\'s in the mood for dessert.','',26124),
(26648,'enUS','With the orb returned, the search for answers begins!','',26124),
(26649,'enUS','Don\'t bother me with trifles!','',26124),
(26650,'enUS','Show mercy!','Show mercy!',26124),
(26651,'enUS','I was just doing what I was told.  Please...','I was just doing what I was told.  Please...',26124),
(26652,'enUS','This is not how I was supposed to die!','This is not how I was supposed to die!',26124),
(26653,'enUS','You win.  Please, just let me go.','You win.  Please, just let me go.',26124),
(26654,'enUS','Have pity...','Have pity...',26124),
(26655,'enUS','The Grand Admiral himself has come to see to our dedication.  If I see you slacking on your post again, I will gut you myself.','The Grand Admiral himself has come to see to our dedication.  If I see you slacking on your post again, I will gut you myself.',26124),
(26656,'enUS','Thank you, $c.','',26124),
(26657,'enUS','Ahh.... better.','',26124),
(26658,'enUS','Back to the fight!','',26124),
(26659,'enUS','Whoa - I nearly died there. Thank you, $r!','',26124),
(26660,'enUS','Can\'t you see that I\'m busy! We\'ll never have this base ready in time for the Prince\'s return!','',26124),
(26661,'enUS','If it weren\'t for those damned beasts burning our ships, we\'d have been home by now. Now leave me alone so I can get back to work!','',26124),
(26662,'enUS','The Argent Crusade is here in force, friend. We weren\'t going to let you have all the glory!','',26124),
(26663,'enUS','Orik, I need another murkweed elixir.','Orik, I need another murkweed elixir.',26124),
(26664,'enUS','Sorry to have bothered you, friend. Carry on!','Sorry to have bothered you, friend. Carry on!',26124),
(26665,'enUS','You dare invade Magnataur lands?  Bonesunder gladly smash you and take your limbs as payment!','',26124),
(26666,'enUS','Cower before me, runt!','',26124),
(26667,'enUS','Good!  I do so like my food fresh and lively.','',26124),
(26668,'enUS','I can smell your fear.','',26124),
(26669,'enUS','This is not the end... death only... strengthens... ','',26124),
(26670,'enUS','Those damned peasants need to work faster! I wanna get back home to Ironforge. I surely do miss my wife and children. ','',26124),
(26671,'enUS','The cap\'n says that as soon as Prince Arthas returns we\'ll be on our way back to Lordaeron.','',26124),
(26672,'enUS','I don\'t know what could be takin\' the young prince so long, but I don\'t think we can hold out for much longer. The cold is gettin\' to some of the soldiers.','',26124),
(26673,'enUS','I\'m sure Arthas will be back any day now, soldier. Keep your chin up!','I\'m sure Arthas will be back any day now, soldier. Keep your chin up!',26124),
(26674,'enUS','When we saw that the ships had been burned by those savage beasts our hearts sank. Never have I felt so helpless...','',26124),
(26675,'enUS','Rage. That\'s how I can sum up my feelings towards this whole mess. We worked our fingers to the bone trying to get through the woods to the shore only to find that we were too late. Our only way home had been destroyed.','',26124),
(26676,'enUS','Despite the hardships we\'ve had to go through in this wasteland, I believe that the young prince will see us to victory. I pray each night for his safety.','',26124),
(26677,'enUS','I must be going now, soldier. Stay vigilant!','I must be going now, soldier. Stay vigilant!',26124),
(26678,'enUS','<Forgotten footman shakes his head.>$B$BWe can\'t keep this up, friend. If Prince Arthas doesn\'t return soon we will all perish.','',26124),
(26679,'enUS','We\'ll never get these ships ready in time. The winter comes and with it our doom. I fear that the young prince has damned us all.','',26124),
(26680,'enUS','Arthas and Muradin have been gone a long time. I hope they aren\'t in danger.','',26124),
(26681,'enUS','I\'m sure everything will work out, footman.','I\'m sure everything will work out, footman.',26124),
(26682,'enUS','Bless you, friend. I nearly expired....','',26124),
(26683,'enUS','Thank you, $r!','',26124),
(26684,'enUS','I\'d nearly given up. You\'ve given me new life!','',26124),
(26685,'enUS','Without your help, I surely would have died....','',26124),
(26686,'enUS','NOOOOO! Mother! We\'ll avenge you!','',26124),
(26687,'enUS','A skunk, rabbit, and a fawn travelling together.  Now that\'s something you don\'t see every day.  No matter, I\'ll be dining on venison tonight!','',26124),
(26688,'enUS','Yah. Hellscream, he be a fierce one, but too eager to prove himself, I be thinkin\'. It be good Saurfang be here, for sure.','',26124),
(26689,'enUS','Where can I send ya to today?','',26124),
(26690,'enUS','','Saurfang is here, Sagai! Saurfang! The brother of Broxigar himself, here to aid our efforts!',26124),
(26691,'enUS','Huntin time!','',26124),
(26692,'enUS','A good club can make all the difference in the world.','A good club can make all the difference in the world.',26124),
(26693,'enUS','I\'d like to buy this month\'s brew.','I\'d like to buy this month\'s brew.',26124),
(26694,'enUS','Hey there friend!  I see you\'ve got some Brewfest tokens.  As it happens, I still have some Brewfest items for sale.','Hey there friend!  I see you\'ve got some Brewfest tokens.  As it happens, I still have some Brewfest items for sale.',26124),
(26695,'enUS','What do you have for me?','What do you have for me?',26124),
(26696,'enUS','Yo Ding-Dong.  Ding-Dong man.  Ding-dong.  Yo!','Yo Ding-Dong.  Ding-Dong.  Ding-dong yo!',26124),
(26697,'enUS','I need to get to Wintergarde Keep fast!','I need to get to Wintergarde Keep fast!',26124),
(26698,'enUS','Howdy, $r!$b$bIf you\'re lookin\' for a shredder to ride, you\'ll need to head on up into the hills.$b$bThis one\'s out of commission.','',26124),
(26699,'enUS','Key? What key?','Key? What key?',26124),
(26700,'enUS','Why, the refurbished shredder key, silly!$b$bIf you haven\'t already gotten one today you can talk to my brother, Synipus.','',26124),
(26701,'enUS','A good brew, is a strong brew.','A good brew, is a strong brew.',26124),
(26702,'enUS','Where can I find this brother of yours?','Where can I find this brother of yours?',26124),
(26703,'enUS','Why would I want to ride a shredder?','Why would I want to ride a shredder?',26124),
(26704,'enUS','Well, before all the hostilities broke out here we were fixing them up to harvest the local trees.$b$bLately, though, they\'ve been forced into service against the Horde. Turns out they make for a pretty fine fighting machine. If you\'ve got a key, you\'d be silly not to use it!','',26124),
(26705,'enUS','It\'s great bein\' a member of da \"Brew of the Month\" club.','It\'s great bein\' a member of da \"Brew of the Month\" club.',26124),
(26706,'enUS','Where can I get a Refurbished Shredder Key?','Where can I get a Refurbished Shredder Key?',26124),
(26707,'enUS','Why, up the river of course!$b$bHaha! Up the river... Okay, okay, you can find him working on shredders up at Blue Sky Logging Ground.$b$bOh, and you can tell him that if he sends me any more half-finished shredders he WILL be up a river!','',26124),
(26708,'enUS','My brother, Synipus has lots of them. You should head up north to Blue Sky Logging Grounds and talk to him.','',26124),
(26709,'enUS','I apologize, emissary, but the prince is away on an errand. What brings you to this desolate place?\n','',26124),
(26710,'enUS','By royal edict, you men are to return to Lordaeron immediately. Lord Uther has convinced the king to recall this expedition.\n','',26124),
(26711,'enUS','We\'re to just pick up and leave?','',26124),
(26712,'enUS','That\'s correct. My men report that the roads from here to the shore are held by the undead. You\'ll need to find an alternate route back to your ships.\n','',26124),
(26713,'enUS','To hell with the undead! We\'ll cut our way through the woods, men!\n','',26124),
(26714,'enUS','Captain, why are the guards not at their posts?','',26124),
(26715,'enUS','Well, milord, your father had our troops recalled at Lord Uther\'s request.\n','',26124),
(26716,'enUS','Uther had my troops recalled? Damn it! If my warriors abandon me, I\'ll never defeat Mal\'Ganis. The ships must be burned before the men reach the shore!\n','',26124),
(26717,'enUS','Isn\'t that a bit much, lad?\n','',26124),
(26718,'enUS','Burned down to their frames! No one goes home until our job here is done!\n','',26124),
(26719,'enUS','','Stop!  Put that knife away.  You don\'t have to do... whatever they sent you to do.  You\'re not like them yet!',26124),
(26720,'enUS','What\'s this now? Perhaps Prince Arthas returns to us today!\n','',26124),
(26721,'enUS','Look alive, lads! Today might be the day we leave this cursed land! O\' sweet Ironforge, how I missed ya!\n','',26124),
(26722,'enUS','NOOOOOOO!!!!','',26124),
(26723,'enUS','You lying wretch, Arthas! You doomed us all!','',26124),
(26724,'enUS','Our prince has forsaken us! All is lost!','',26124),
(26725,'enUS','You gave us your word, betrayer!','',26124),
(26726,'enUS','Our lives were worth far more than your blood feud...','',26124),
(26727,'enUS','But why?','',26124),
(26728,'enUS','It was all lies...','',26124),
(26729,'enUS','May your soul be torn asunder by the very thing you hate most, young prince.','',26124),
(26730,'enUS','','Thank you.  I... I should get going now.',26124),
(26731,'enUS','You lied to your men and betrayed the mercenaries who fought for you. What\'s happening to you, Arthas? Is vengeance all that\'s important to you?\n','',26124),
(26732,'enUS','Spare me, Muradin. You weren\'t there to see what Mal\'Ganis did to my homeland.\n','',26124),
(26733,'enUS','With enough tokens you can join the \"Brew of the Month\" club.  Being in the Brew of the Month club is like having Brewfest all year round!$b$bEvery month you will receive mail with a new brew to try out.  If you like that brew, you can go to the Stonefire Tavern in Ironforge and buy more from the vendors there.  ','',26124),
(26734,'enUS','Brew of the Month Club','Brew of the Month Club',26124),
(26735,'enUS','Bring the fight to the enemy, men!','',26124),
(26736,'enUS','Don\'t let those dirty orcs take the harbor!','',26124),
(26737,'enUS','Show no mercy!','',26124),
(26738,'enUS','','Show the enemy no mercy! This port will be ours!',26124),
(26739,'enUS','','Kill those Alliance dogs before they can regroup!',26124),
(26740,'enUS','','Fight for the glory of the Horde!',26124),
(26741,'enUS','Rest easy mon. [PH]','',26124),
(26742,'enUS','Take it easy, let the light heal you. [PH]','',26124),
(26743,'enUS','I will heal your wounds as best as I can. [PH]','',26124),
(26744,'enUS','With enough tokens you can join the \"Brew of the Month\" club.  Being in the Brew of the Month club is like having Brewfest all year round!$b$bEvery month you will receive mail with a new brew to try out.  If you like that brew, you can go to the Darkbriar Lodge in Orgrimmar\'s Valley of Spirits and buy more from the vendors there.  ','',26124),
(26745,'enUS','%s raises his talons menacingly!','',26124),
(26746,'enUS','Things seem to be going well.','Things seem to be going well.',26124),
(26747,'enUS','Impressive. The master said that you and your people would be a nuisance. No matter, your end draws near. Soon the combined might of Naxxramas will come down upon this place and shatter your meager existence.','',26124),
(26748,'enUS','Where do you think you\'re going with that, mortal? Put the tome down and I might spare you an eternity of anguish.','',26124),
(26749,'enUS','Soldiers of the frozen wastes, rise and hear the call of your master! Do not let $n escape with the tome!','',26124),
(26750,'enUS','Tome not yours...','',26124),
(26751,'enUS','Give... me... book...','',26124),
(26752,'enUS','%s looks at the gathered crowd and nods his head ponderously.','',26124),
(26753,'enUS','Join us...','',26124),
(26754,'enUS','Only ruin awaits...','',26124),
(26755,'enUS','The tide has brought me a story. Listen, and be enlightened.','',26124),
(26756,'enUS','Thel\'zan will have you...','',26124),
(26757,'enUS','Through sunsets beyond counting, the tusked people have dwelled here in the land of ice.','',26124),
(26758,'enUS','We have lived on the bounty of the sea. We have grown fat on the meat of the antlered ones.','',26124),
(26759,'enUS','The sea and the land has given us life.','',26124),
(26760,'enUS','Some seek to take the sea from us. The giant raiders have invaded our sacred place on the shore.','',26124),
(26761,'enUS','Brew of the Month Club?','Brew of the Month Club?',26124),
(26762,'enUS','You haven\'t heard of the \"Brew of the Month\" club?  Those gals love to party.  If they had their way, Brewfest would never end!  Sometimes last year, it felt like it didn\'t.$b$bBut now they\'ve figured, the best way to keep the Brewfest spirit going would be to allow people to join their club.$b$bFor a small fee, just a few tokens, you can join!  You get brew mailed to you every month and a chance to buy that same brew if you like it.  It\'s cutting edge stuff and a way to make sure that Brewfest\'s spirit is never really gone.','You haven\'t heard of the \"Brew of the Month\" club?  Those gals love to party.  If they had their way, Brewfest would never end!  Sometimes last year, it felt like it didn\'t.$b$bBut now they\'ve figured, the best way to keep the Brewfest spirit going would be to allow people to join their club.$b$bFor a small fee, just a few tokens, you can join!  You get brew mailed to you every month and a chance to buy that same brew if you like it.  It\'s cutting edge stuff and a way to make sure that Brewfest\'s spirit is never really gone.',26124),
(26763,'enUS','Some seek to take the land from us. The finned hunters squat upon the plains and devour the antlered ones themselves.','',26124),
(26764,'enUS','The curse is lifted!','The curse is lifted!',26124),
(26765,'enUS','Thel\'zan\'s enchantment is broken! I am safe!','Thel\'zan\'s enchantment is broken! I am safe!',26124),
(26766,'enUS','We are hunters, too. We are fighters. We can fight for the sea and the land.','',26124),
(26767,'enUS','What could this tome be hiding?','What could this tome be hiding?',26124),
(26768,'enUS','Thel\'zan cannot stop me! For the Alliance! For Lord Fordragon!','Thel\'zan cannot stop me! For the Alliance! For Lord Fordragon!',26124),
(26769,'enUS','But there is another threat to the tusked people.','',26124),
(26770,'enUS','What\'s the \"Brew of the Month\" club?','What\'s the \"Brew of the Month\" club?',26124),
(26771,'enUS','You haven\'t heard of the \"Brew of the Month\" club?  It\'s a bunch of really cute guys that want to celebrate Brewfest all year long!  They tried to bring Brewfest back in the past, but it never lasted very long.$b$bOnce you join the club you get mailed a different brew every month!  If you like that brew, you can talk to the vendors in Ironforge to get more brew.$b$bI think you are cute enough to join the club.  You give me a few prize tokens and I\'ll give you the forms.  Then maybe we can celebrate Brewfest together, all year round!','You haven\'t heard of the \"Brew of the Month\" club?  It\'s a bunch of really cute guys that want to celebrate Brewfest all year long!  They tried to bring Brewfest back in the past, but it never lasted very long.$b$bOnce you join the club you get mailed a different brew every month!  If you like that brew, you can talk to the vendors in Ironforge to get more brew.$b$bI think you are cute enough to join the club.  You give me a few prize tokens and I\'ll give you the forms.  Then maybe we can celebrate Brewfest together, all year round!',26124),
(26772,'enUS','%s bows his head a moment to gather his thoughts.','',26124),
(26773,'enUS','There is a power flowing through all things that live. It carries many names.','',26124),
(26774,'enUS','The tusked people call it Silap Inua.','',26124),
(26775,'enUS','This power is harnessed by all thinking peoples to heal or harm. It is the power of life. It is the power of souls living and dead.','',26124),
(26776,'enUS','The threat to Silap Inua is known as those who would cage it. They will be called the blue-scaled ones.','',26124),
(26777,'enUS','The blue-scaled ones have great power. They work to control Silap Inua and take it from the wide ranging peoples of the world.','',26124),
(26778,'enUS','They threaten not only the ways of the tusked people, but the existence of all who live.','',26124),
(26779,'enUS','The dead rise from our very own crypt!','',26124),
(26780,'enUS','I give you this story.','',26124),
(26781,'enUS','You made it $g lad:lass;! I thought you were a goner for sure!','',26124),
(26782,'enUS','We must fight those who would threaten our flesh, who would kill our children; we must look to our own.','',26124),
(26783,'enUS','But give what aid you can to the southern peoples, for they are the champions of Silap Inua.','',26124),
(26784,'enUS','What are you still doing here? Go back to town!','',26124),
(26785,'enUS','I heal ya up bruddas.  You be ready for anothuh battle soon.','',26124),
(26786,'enUS','Me totem fix ya up good bruddahs.','',26124),
(26787,'enUS','Da scourge don\'t know who they be messin with!','',26124),
(26788,'enUS','We hold dis place wid our lives mon!','',26124),
(26789,'enUS','Da Emporer say we need be holdin dis position mon!','',26124),
(26790,'enUS','Da Scourge think they can be takin our land? They not know who they dealin wit!','',26124),
(26791,'enUS','We be ready to strike back soon!','',26124),
(26792,'enUS','We be ready to strike back soon!','',26124),
(26793,'enUS','Stop da Scourge!','',26124),
(26794,'enUS','You shall not pass, mon!','',26124),
(26795,'enUS','Steward, please allow me to ride one of the drakes to the queen\'s chamber at the top of the temple.','Steward, please allow me to ride one of the drakes to the queen\'s chamber at the top of the temple.',26124),
(26796,'enUS','These kodo are in amazing condition.','',26124),
(26797,'enUS','Indeed, I heard they were recovered from the brink of death by a seasoned veteran of the Horde.','',26124),
(26798,'enUS','Queen Alexstrasza has placed me in charge of the defense of Wyrmrest Temple.$B$BAs you know, Malygos had his forces destroy a nearby ley line anchor. The forces of the dragonflight then redirected that power to the Azure Dragonshrine.$B$BThe blue dragons are using that power to strengthen themselves; so much so that they dare attack the temple itself! They\'re starting to win.$B$BAre you here to help us, $r?','',26124),
(26799,'enUS','%s says a prayer for the lost soul.','',26124),
(26800,'enUS','Stand back, $n, the beast might lash out and harm you.','',26124),
(26801,'enUS','GODFREY! Hear me, fiend! Hear me, for I am the Light, here to deliver you from evil!','',26124),
(26802,'enUS','%s growls.','',26124),
(26803,'enUS','Good. I have your attention, then, Godfrey?','',26124),
(26804,'enUS','We can do this in one of two ways, Godfrey. First, I will simply ask you to tell me what the unholy markings etched upon the pages of this tome mean. What say you?','',26124),
(26805,'enUS','%s hisses!','',26124),
(26806,'enUS','Tell you nothing, preacher.','',26124),
(26807,'enUS','What can you do to me that Kel\'Thuzad has not? That the Lich King will not?','',26124),
(26808,'enUS','The book is your salvation, yes... but nothing will you know! NOTHING I SAY! NOTHING! ','',26124),
(26809,'enUS','Then it is option two.','',26124),
(26810,'enUS','I say a prayer for you now, lost soul. May the Light take you gracefully.','',26124),
(26811,'enUS','Let the sermon begin.','',26124),
(26812,'enUS','LIGHT TAKE YOU, BEAST!','',26124),
(26813,'enUS','May the power of Light compel you!','',26124),
(26814,'enUS','LET THE LIGHT IN, GODFREY GOODARD!','',26124),
(26815,'enUS','Do not fight me, fiend! The time of your atonement is now!','',26124),
(26816,'enUS','BURN IN HOLY FIRE!','',26124),
(26817,'enUS','The power of the Lich King pales in comparison to the glory of the Light!','',26124),
(26818,'enUS','IT BURNSSSSS!','',26124),
(26819,'enUS','The pain is unbearable!','',26124),
(26820,'enUS','Make it stop! MAKE IT STOP!','',26124),
(26821,'enUS','I tell you anything you want!','',26124),
(26822,'enUS','No more LIGHT! NO MORE! I BEG YOU!','',26124),
(26823,'enUS','Never felt hurt like this!','',26124),
(26824,'enUS','I thought you would see the Light, Godfrey... Now speak quickly, fiend. What does it say?','',26124),
(26825,'enUS','It tells of the coming apocalypse. How this world will burn and be reborn from death.','',26124),
(26826,'enUS','RUBBISH! Godfrey do you take me for a fool? Do not spew your Scourge propaganda at a man of the Light, heathen! Speak now or I will have the peasants craft a holy water bath and dip you into it like a dog with fleas!','',26124),
(26827,'enUS','NOOOO!!! I tell you! I tell you everything!','',26124),
(26828,'enUS','Humans... Beneath the earth of Wintergarde Village you built a mausoleum! Why do you think Naxxramas attacked that spot? Thel\'zan hides deep in your own crypt and sends a thousand-thousand corpses at you! Perish you will...','',26124),
(26829,'enUS','What? There is a mausoleum beneath the old village? What fools we are to not have noticed! We will find and strike down your master now, Godfrey. We will end this nightmare.','',26124),
(26830,'enUS','You let us worry about how we kill the monster, Godfrey.','',26124),
(26831,'enUS','How? Humans truly are stupid, yes? Thel\'zan the Duskbringer! Thel\'zan the Lich! He who is born of human flesh and bone, sacrificed all for power, protected by the Lich King!','',26124),
(26832,'enUS','You cannot stop Thel\'zan! He bears the dark gift, bestowed upon him by the Lich King himself!','',26124),
(26833,'enUS','Return to Halford with the information that the good mayor was kind enough to submit, $n. I will finish here and squeeze whatever else this wretch might know about Thel\'zan. Now, I will show Godfrey the rarely seen \"option three.\"','',26124),
(26834,'enUS','Let\'s you and I have a chat about some things, Godfrey.','',26124),
(26835,'enUS','You will find no peace in death, wyrms!','You will find no peace in death, wyrms!',26124),
(26836,'enUS','Rise... rise and feast on their flesh!','Rise... rise and feast on their flesh!',26124),
(26837,'enUS','The time of the dragons is over...','The time of the dragons is over...',26124),
(26838,'enUS','Your struggle is meaningless.  You will all fall before the endless Scourge!','Your struggle is meaningless.  You will all fall before the endless Scourge!',26124),
(26839,'enUS','Every warrior that falls is one more for our mighty army.  There is no victory against us.','Every warrior that falls is one more for our mighty army.  There is no victory against us.',26124),
(26840,'enUS','There is no hope.  You will fail.','There is no hope.  You will fail.',26124),
(26841,'enUS','For the Alliance and Lord Fordragon!','For the Alliance and Lord Fordragon!',26124),
(26842,'enUS','HOO-WAH! The cavalry has arrived!','HOO-WAH! The cavalry has arrived!',26124),
(26843,'enUS','Great driving, soldier! Not a scratch on us!','Great driving, soldier! Not a scratch on us!',26124),
(26844,'enUS','Without you we\'d be lost. Thanks for the ride!','Without you we\'d be lost. Thanks for the ride!',26124),
(26845,'enUS','Return to the Carrion Fields or your vehicle will be destroyed!','',26124),
(26846,'enUS','Back to the ship!','',26124),
(26847,'enUS','Gotta get out of here!','',26124),
(26848,'enUS','We\'re all gonna die!','',26124),
(26849,'enUS','I didn\'t sign up for this!','',26124),
(26850,'enUS','Forget this! I\'m going home!','',26124),
(26851,'enUS','No way I\'m stickin\' around!','',26124),
(26852,'enUS','Cover me!','Cover me!',26124),
(26853,'enUS','Keep the bad guys off me!','Keep the bad guys off me!',26124),
(26854,'enUS','Keep \'em off me for about 15 seconds and this thing is as good as dead.','Keep \'em off me for about 15 seconds and this thing is as good as dead.',26124),
(26855,'enUS','When I\'m done with this plague wagon it\'ll look like a goblin built it! Keep me safe!','When I\'m done with this plague wagon it\'ll look like a goblin built it! Keep me safe!',26124),
(26856,'enUS','%s deftly assembles a strange machine.','%s deftly assembles a strange machine.',26124),
(26857,'enUS','Gather, gather. A story has come.','',26124),
(26858,'enUS','That oughta do it! Just a few more seconds now.','That oughta do it! Just a few more seconds now.',26124),
(26859,'enUS','Incoming!  Get your heads down!','',26124),
(26860,'enUS','Heads up!  Strafe incoming!','',26124),
(26861,'enUS','Fire on the way, clear the field!','',26124),
(26862,'enUS','Burn, you fiends!','',26124),
(26863,'enUS','Make way!  A wyrm is coming to our aid!','',26124),
(26864,'enUS','Red dragon incoming!','',26124),
(26865,'enUS','Rise, Arugal!  The power of the Lich King commands you!','',26124),
(26866,'enUS','','',26124),
(26867,'enUS','Yes... he shall suit our needs perfectly.  Have him sent to Solstice Village when you\'re ready.  Arthas will not be pleased if we fall behind schedule.','',26124),
(26868,'enUS','Hey, $c, did you see that? Out there, lingering near the water\'s surface....$b$bYou saw it too didn\'t ya?','',26124),
(26869,'enUS','You mean the iceberg?','You mean the iceberg?',26124),
(26870,'enUS','The wha-??$b$bWell, I refer to them as undefined floating obstructions. And where I\'m from, most deny their existence entirely.$b$bBut I know better! I\'ve even seen \'em up close! My recent years have been spent building this vessel to locate, track, document, and if needs be, eradicate them!','',26124),
(26871,'enUS','I\'ll admit, dwarf, I was pleasantly surprised to see your plan succeed.','',26124),
(26872,'enUS','All this equipment just to examine ice?','All this equipment just to examine ice?',26124),
(26873,'enUS','We can\'t just let you return to your companions and we can\'t take you with us...','',26124),
(26874,'enUS','Wait a minute here! You promised to spare me if I helped you. I held up my end o\' the bargain!','',26124),
(26875,'enUS','Stay your blade, Chieftain. He may yet have value to us.','',26124),
(26876,'enUS','Don\'t be fooled, $r. They\'re very elusive. One moment they\'re there, the next they\'re gone - virtually inexplicable!$b$bBetween you and me, I actually held a piece of one in my hand once! Sadly, before I could conduct any measurements it was gone! Just disappeared....','',26124),
(26877,'enUS','It\'s just ice. Why all the fuss?','It\'s just ice. Why all the fuss?',26124),
(26878,'enUS','Remember the dwarven journal that was discovered? Well, this dwarf could be exactly what we need to track down Brann Bronzebeard and capture him.','',26124),
(26879,'enUS','By the Light, Brann\'s alive? I\'d never help you capture him!','',26124),
(26880,'enUS','You will if you wish to keep your head attached to your shoulders.','',26124),
(26881,'enUS','Does that satisfy you, Tormak?','',26124),
(26882,'enUS','He will live so long as he proves useful. I\'d be careful if I was you, dwarf.','',26124),
(26883,'enUS','A lot you know...$b$bSome say they\'re just observing, some think they\'re altering our sea-life, and then others think they\'re here to take over Azeroth!$b$bOnce I take one down with my rocket propelled warheads I\'ll get the answers. You can believe that!','',26124),
(26884,'enUS','','Surprise, you scum!  You\'re going to tell me where my sister is or I\'ll put a bucketful of truesilver bullets through your wife\'s heart.',26124),
(26885,'enUS','Stop!  Do not shoot!  Do not hurt Tatjana!','',26124),
(26886,'enUS','The brat\'s held prisoner in the wolf den on the other side of the mountain.  She was to be taken to Arugal.  Are we free to go now?','',26124),
(26887,'enUS','Forgive me, Tatjana... ','',26124),
(26888,'enUS','Nothing you can do can compare to what Arugal can do to us!  I will tear you apart myself!','',26124),
(26889,'enUS','','Where is Anya?',26124),
(26890,'enUS','','There is one last thing.  I need to know where Arugal is.',26124),
(26891,'enUS','','Thank you for helping me to get back to the camp. Go tell Walter that I\'m safe now!',26124),
(26892,'enUS','','He\'s gonna eat Mr. Floppy! You gotta help Mr. Floppy! You just gotta!',26124),
(26893,'enUS','','There\'s a big meanie attacking Mr. Floppy! Help!',26124),
(26894,'enUS','','I think I see the camp! We\'re almost home, Mr. Floppy! Let\'s go!',26124),
(26895,'enUS','Greetings, $r.$B$BI have been expecting you.','',26124),
(26896,'enUS','We need to get into the fight. Are you ready?','We need to get into the fight. Are you ready?',26124),
(26897,'enUS','Very well, let\'s go!','',26124),
(26898,'enUS','This is our chance boys!  Push!','',26124),
(26899,'enUS','Push them back to the shrine!','',26124),
(26900,'enUS','Push them back and crush them!','',26124),
(26901,'enUS','Push!  Make a path to the shrine!','',26124),
(26902,'enUS','Emberwyrm incoming!  Pull back!  Pull back!','',26124),
(26903,'enUS','Incoming!  Get back down the pass!','',26124),
(26904,'enUS','Fall back!  Incoming Emberwyrm!','',26124),
(26905,'enUS','We\'ll hold them here for a moment.  Get into the shrine and stop those necromancers!','',26124),
(26906,'enUS','We can\'t hold them for long!  Get inside disrupt their necromancers!','',26124),
(26907,'enUS','We\'ll hold them a few more moments!  Get into the shrine while you can!','',26124),
(26908,'enUS','Take us into battle, $n!','',26124),
(26909,'enUS','Self-destruct sequence initiated.','',26124),
(26910,'enUS','The gryphons of the Northrend peaks are the most resilient of the species.','',26124),
(26911,'enUS','The High Commander said to speak with you to get a ride to Thorson\'s Post.','The High Commander said to speak with you to get a ride to Thorson\'s Post.',26124),
(26912,'enUS','The gryphon riders are standing 10 paces from us, friend. They\'ll be giving you a ride to Thorson\'s Post. Get going!','',26124),
(26913,'enUS','I just issued Kill Credit to $n!','',26124),
(26914,'enUS','','You won\'t eat me, will you?',26124),
(26915,'enUS','','Anya!!  You\'re all right!',26124),
(26916,'enUS','','Badmoon?  You mean Bloodmoon?',26124),
(26917,'enUS','','Don\'t worry, sister... no one can hurt you now.',26124),
(26918,'enUS','','Sister!  The mean men were going to take me to Badmoon Isle.  They wanted to turn me into one of them.',26124),
(26919,'enUS','','That\'s what I said!  Badmoon!  Sasha... don\'t ever leave me again!  First they took papa, then they took you... I don\'t want to be alone with them!',26124),
(26920,'enUS','','Do not think for a second that your past accomplishments entitle you to anything, $n.  They don\'t.$B$BIf you want my respect you\'re going to have to earn it.  This means following my orders without question and fulfilling them... without exceptions.',26124),
(26921,'enUS','Thorson\'s Post - coming right up!','Thorson\'s Post - coming right up!',26124),
(26922,'enUS','Hang on to your hat, pal! We\'re in for a bumpy ride.','Hang on to your hat, pal! We\'re in for a bumpy ride',26124),
(26923,'enUS','Keep your head low and be on the lookout for frostwyrms! YAAAW!','Keep your head low and be on the lookout for frostwyrms! YAAAW!',26124),
(26924,'enUS','This is your stop, pal. Safe landing!','This is your stop, pal. Safe landing!',26124),
(26925,'enUS','Unleash the war hounds!','',26124),
(26926,'enUS','We ride!','',26124),
(26927,'enUS','Abomination spotted! 5th Battalion, let\'s mount up and engage them!','Abomination spotted! 5th Battalion, let\'s mount up and engage them!',26124),
(26928,'enUS','Call the Gryphons!','Call the Gryphons!',26124),
(26929,'enUS','To the front, men!','To the front, men!',26124),
(26930,'enUS','Let them feel the fury of your Stormhammers!','Let them feel the fury of your Stormhammers!',26124),
(26931,'enUS','It\'s not enough! Let\'s show them the might of the 5th Battalion up close!','It\'s not enough! Let\'s show them the might of the 5th Battalion up close!',26124),
(26932,'enUS','The chill you feel is the herald of your doom!','',26124),
(26933,'enUS','Bolster my defenses! Hurry, curse you!','',26124),
(26934,'enUS','Hello. Squire Walter and I are responsible for taking care of Old Blanchy here, along with the rest of the mounts.','',26124),
(26935,'enUS','I\'d like to use the stables.','I\'d like to use the stables.',26124),
(26936,'enUS','Greetings, $r.$B$BIf you are interested in helping with the defense of the temple, please speak with Lord Afrasastrasz inside.','',26124),
(26937,'enUS','Thank you for freeing us, mortals.  Beware, the blue flight is alerted to your presence.  Even now, Malygos sends Varos Cloudstrider and his ring guardians to defend the Oculus.  You will need our help to stand a chance.','',26124),
(26938,'enUS','I\'m sorry, $r, but I just called to a defender for you.$B$BYou will have to wait a short time before I will do so again.','I\'m sorry, $r, but I just called to a defender for you.$B$BYou will have to wait a short time before I will do so again.',26124),
(26939,'enUS','','I\'ve lived here and kept this shrine with the blessing of the Alexstrasza for longer than I can remember.  In its darkest hour, I\'ve failed... I fell at the feet of that damned death knight...  Bloodbane.',26124),
(26940,'enUS','','The Lich King is stretching his hand far now... fearlessly treading on the most sacred lands of all of the flights.  He intends to force us to action.',26124),
(26941,'enUS','','My time is done... I offered myself to Alexstrasza in life, but I have nothing left to offer in death.  She will need a new keeper for her shrine.',26124),
(26942,'enUS','','And thank you... thank you for freeing me from the shackles of the damned.  You are a hero... I know you will go on to great deeds.',26124),
(26943,'enUS','','Dahlia spits on the ground at the thought of the name.',26124),
(26944,'enUS','','The Remnant of Dahlia Suntouch fades away...',26124),
(26945,'enUS','Welcome to Camp Oneqwah.','',26124),
(26946,'enUS','I\'d like to use the stables.','I\'d like to use the stables.',26124),
(26947,'enUS','S.T.O.U.T. is more than just a target for throwing steins, it\'s a valuable training asset.  If you can hit S.T.O.U.T. you can probably hit anything!$b$bJust try not to hit me.','',26124),
(26948,'enUS','I want to fly on the wings of the green flight.','I want to fly on the wings of the green flight.',26124),
(26949,'enUS','','Belgaristrasz speaks the truth; the situation is grave indeed.  \n\nI can grant you the power to call upon a drake from the green flight.  Speak to Belgaristrasz or Eternos if you prefer to draw on the power of the red or the bronze.',26124),
(26950,'enUS','Varos Cloudstrider and his ring guardians protect the second ring.  Your drakes are more than a match for the ring guardians, but Varos stands behind an impenetrable shield created from the energy of the Oculus itself.  Ten centrifuge constructs power the shield from the ring and platforms above.  Destroy them and Varos will be vulnerable.\n\nI can grant you the power to call upon a drake from the red flight.  Speak to Eternos or Verdisa if you prefer to draw on the power of the bronze or the green.','',26124),
(26951,'enUS','I want to fly on the wings of the red flight.','I want to fly on the wings of the red flight.',26124),
(26952,'enUS','Belgaristrasz speaks the truth; time is running out!\n\nI can grant you the power to call upon a drake from the bronze flight.  Speak to Belgaristrasz or Verdisa if you prefer to draw on the power of the red or the green.','',26124),
(26953,'enUS','I want to fly on the wings of the bronze flight.','I want to fly on the wings of the bronze flight.',26124),
(26954,'enUS','Reporting for duty, sir!','Reporting for duty, sir!',26124),
(26955,'enUS','My lord, I am ready to go.','My lord, I am ready to go.',26124),
(26956,'enUS','Lord Afrasastrasz, with your leave, I wish to defend the temple.','Lord Afrasastrasz, with your leave, I wish to defend the temple.',26124),
(26957,'enUS','For the queen. For Wyrmrest Temple!','For the queen. For Wyrmrest Temple!',26124),
(26958,'enUS','If the blues dare to attack the temple, then they have a deathwish.','If the blues dare to attack the temple, then they have a deathwish.',26124),
(26959,'enUS','By your leave, I will do what I can.','By your leave, I will do what I can.',26124),
(26960,'enUS','Their dragonshrine may have empowered them, but the blues will not wrest the temple from us this day!','Their dragonshrine may have empowered them, but the blues will not wrest the temple from us this day!',26124),
(26961,'enUS','I\'ve heard that the azure dragonshrine is being invested with the direct power of a ley line. I will defend the temple as best I can.','I\'ve heard that the azure dragonshrine is being invested with the direct power of a ley line. I will defend the temple as best I can.',26124),
(26962,'enUS','It is unconscionable that Malygos would have his forces attack the temple! With your permission, my lord, I will defend us with my life.','It is unconscionable that Malygos would have his forces attack the temple! With your permission, my lord, I will defend us with my life.',26124),
(26963,'enUS','What have we come to?','',26124),
(26964,'enUS','Do what must be done.','',26124),
(26965,'enUS','Defend the temple at all costs.','',26124),
(26966,'enUS','Thank you, my friend. Go.','',26124),
(26967,'enUS','It is regrettable, but necessary.','',26124),
(26968,'enUS','Yes. Do your best to return in one piece.','',26124),
(26969,'enUS','You have my leave.','',26124),
(26970,'enUS','In all of my centuries, I never dreamed that it would come to this.','',26124),
(26971,'enUS','I think I see one of their plague wagons!','I think I see one of their plague wagons!',26124),
(26972,'enUS','Did I ever tell you soldiers about the time I destroyed the Thandol Span? Yep, weren\'t no dark irons destroyed that bridge! Was me!','Did I ever tell you soldiers about the time I destroyed the Thandol Span? Yep, weren\'t no dark irons destroyed that bridge! Was me!',26124),
(26973,'enUS','It doesn\'t make any sense. Why don\'t they just fly Naxxramas over Wintergarde Keep and blow it up? I mean, that\'s what I would do if I were Kel\'Thuzad.','It doesn\'t make any sense. Why don\'t they just fly Naxxramas over Wintergarde Keep and blow it up? I mean, that\'s what I would do if I were Kel\'Thuzad.',26124),
(26974,'enUS','I wonder if we\'ll ever solve the mystery of the strange ore. There\'s gotta be some use for it!','I wonder if we\'ll ever solve the mystery of the strange ore. There\'s gotta be some use for it!',26124),
(26975,'enUS','Hey, do any of you know McGoyver over at Valgarde? He\'s my uncle. You know what his title is? Pro. Yea, just \"Pro.\" I want to be a pro too.','Hey, do any of you know McGoyver over at Valgarde? He\'s my uncle. You know what his title is? Pro. Yea, just \"Pro.\" I want to be a pro too.',26124),
(26976,'enUS','Something straight up stinks in here! It\'s definitely not me. Gnomes smell like butter and sunshine. Not like those dwarves that smell like they were born from a trogg\'s armpit! None of you are dwarves, are you?','Something straight up stinks in here! It\'s definitely not me. Gnomes smell like butter and sunshine. Not like those dwarves that smell like they were born from a trogg\'s armpit! None of you are dwarves, are you?',26124),
(26977,'enUS','I used to know a dwarf that claimed gnomes evolved from beneath the earth. That we all started out as sand gnomes. What a load of nonsense! Sand gnomes? PUH-LEASE!','I used to know a dwarf that claimed gnomes evolved from beneath the earth. That we all started out as sand gnomes. What a load of nonsense! Sand gnomes? PUH-LEASE!',26124),
(26978,'enUS','I\'ve never seen destruction like this...','I\'ve never seen destruction like this...',26124),
(26979,'enUS','Keep the chatter down, people. We need to stay alert!','Keep the chatter down, people. We need to stay alert!',26124),
(26980,'enUS','The smell of death covers every inch of this place.','The smell of death covers every inch of this place.',26124),
(26981,'enUS','Driver, I hear you single handedly airlifted our villagers out of this hell-hole. Is that true?','Driver, I hear you single handedly airlifted our villagers out of this hell-hole. Is that true?',26124),
(26982,'enUS','So does anyone know anything about Thel\'zan? Who is he? How did he come to leading the Scourge armies on the ground?','So does anyone know anything about Thel\'zan? Who is he? How did he come to leading the Scourge armies on the ground?',26124),
(26983,'enUS','Look at this mess... The Scourge will pay for this!','Look at this mess... The Scourge will pay for this!',26124),
(26984,'enUS','Where are all the corpses? What have they done to our people?','Where are all the corpses? What have they done to our people?',26124),
(26985,'enUS','I hope I\'m alive to see Arthas get what\'s coming to him.','I hope I\'m alive to see Arthas get what\'s coming to him.',26124),
(26986,'enUS','It burns!','',26124),
(26987,'enUS','Please!  Stop the burning!','',26124),
(26988,'enUS','Why !','',26124),
(26989,'enUS','Happy Winter\'s Veil!','',26124),
(26990,'enUS','Most of my brethren are disdainful of the Horde\'s \"barbaric\" ways, and I once counted myself among them. When I was first ordered to this somewhat humid and... fragrant place, I cursed my lot in life.$b$bDuring my studies, however, I grew to appreciate my surroundings. It has a certain charm, don\'t you think?$b$bAh, and my studies, of course, were to allow other mages to return here with a spell. Shall I teach you?','',26124),
(26991,'enUS','Most of my brethren are disdainful of the Horde\'s \"barbaric\" ways, and I once counted myself among them. When I was first ordered to this somewhat humid and... fragrant place, I cursed my lot in life.$b$bDuring my studies, however, I grew to appreciate my surroundings. It has a certain charm, don\'t you think?$b$b...you wouldn\'t be interested in my studies, of course, not being a mage yourself.','',26124),
(26992,'enUS','Ah, I love the smell of Stonard! It smells like... like... orc sweat. And rot. Still, combined, the effect can be quite pleasant! It\'s an acquired scent.','',26124),
(26993,'enUS','While visitors complain about the exceptionally humid air, I find it helps my complexion! Dry skin is unflattering.','',26124),
(26994,'enUS','It is a shame, a dreadful shame, that my brethren cannot see what benefits come from truly steeping oneself in a culture.','',26124),
(26995,'enUS','Here I am, in a rough-hewn stone tower squatting on marshy, muddy ground while clouds of midges fly unchecked through the open doorways, standing amongst hunched, greenskin figures of dubious hygiene and coarse manners. I\'ve never been happier.','',26124),
(26996,'enUS','Before I was stationed out here, I\'d only heard about the rejuvenating effects a mudbath can have on skin. When I first tripped over a tree root, I was exposed to the full benefits! Amazing what nature can do, even without a bit of magic to help it along.','',26124),
(26997,'enUS','To this day, I ponder why I, myself, was chosen for this particular station. I can only imagine my superior felt I was uniquely suited to the task and would quickly become accustomed to the quaint culture of the Horde found herein, but I heard a truly mean-spirited rumor that it may be because I talk too much.','',26124),
(26998,'enUS','Hrm? Oh. Pardon me if I seem distracted; I fear for the men of Northwatch. I should have sent some of my students to aid them. Now, how may I help you?','Hrm? Oh. Pardon me if I seem distracted; I fear for the men of Northwatch. I should have sent some of my students to aid them. Now, how may I help you?',26124),
(26999,'enUS','Hrm? Oh. Pardon me if I seem distracted; I fear for the men of Northwatch. I should have sent some of my students to aid them...','Hrm? Oh. Pardon me if I seem distracted; I fear for the men of Northwatch. I should have sent some of my students to aid them...',26124),
(27000,'enUS','Be quiet.','',26124),
(27001,'enUS','Remember how quiet it was before the elves came here? I miss that.','',26124),
(27002,'enUS','Shut up.','',26124),
(27003,'enUS','I\'m not sure which one\'s crazier.','',26124),
(27004,'enUS','I\'d give my pestle away for some earplugs.','',26124),
(27005,'enUS','','My teachings are only of use to mages. I cannot help you, $c.',26124),
(27006,'enUS','','Sinu a\'manore. If you seek to learn how to conjure a portal to Theramore, I can show you.',26124),
(27007,'enUS','You need to learn to appreciate your surroundings, Cersei!','',26124),
(27008,'enUS','Brewfest has undergone some changes since its first year.  We now issue Brewfest tokens instead of tickets.  If you have old tickets, I can exchange them for you.','Brewfest has undergone some changes since its first year.  We now issue Brewfest tokens instead of tickets.  If you have old tickets, I can exchange them for you.',26124),
(27009,'enUS','I\'d like to exchange the tickets in my inventory for the new tokens.','I\'d like to exchange the tickets in my inventory for the new tokens.',26124),
(27010,'enUS','Who keeps breaking this thing?!','',26124),
(27011,'enUS','Every time I fix this mailbox, it\'s vandalized again within a day.','',26124),
(27012,'enUS','If I ever catch whoever keeps damaging this holo-emitter...','',26124),
(27013,'enUS','Hrm. It appears to be functioning normally again...','',26124),
(27014,'enUS','Ladies and gentlemen... gather round the pit!','',26124),
(27015,'enUS','In one corner we have... $n, truly a world class $c.  Slayer of reptiles, mammals, mechanical constructs and the odd dragon...kin.  You\'ve never seen another $r like $g him : her;.','',26124),
(27016,'enUS','In the other corner, a serial killer, mass defenestrator, sentenced to death multiple times by noose and by blunt instrument!  Horgrenn... Hellcleave!  Ladies and gentlemen... place your bets!','',26124),
(27017,'enUS','Ladies and gentlemen, gather round the Conquest Pit!  Witness the battle of $r versus bear and place your bets with confidence!','',26124),
(27018,'enUS','Just when you think you\'ve seen it all!  $n will square off with an authentic Grizzly Hills crazed furbolg in front of your very eyes here at the Conquest Pit!  Place your bets, folks!','',26124),
(27019,'enUS','Gather round, folks!  Grab a warm drink and find a good seat for you\'re about to witness a showdown between $r and machine!','',26124),
(27020,'enUS','Straight out of Thor Modan and made of 100 percent authentic... metal... here is Rustblood, the lightning-powered iron golem!','',26124),
(27021,'enUS','Come back next year for a new surprise!','',26124),
(27022,'enUS','Explosion brought to you by Smokywood Pastures!','',26124),
(27023,'enUS','Forgive me, but I am spent and cannot use my magic to send you back Theramore. You have the look of a worldly adventurer about you; surely you know of another way to reach Theramore in time.','',26124),
(27024,'enUS','','Here for a ride, $r?$B$BOr, is something else bothering you?',26124),
(27025,'enUS','','I see you\'ve brought your pets.',26124),
(27026,'enUS','','It doesn\'t have to end this way, you know?',26124),
(27027,'enUS','','I used good judgment when you showed none.  I don\'t want to see you lead us into ruin, Krenna!',26124),
(27028,'enUS','','We\'ll see about that.',26124),
(27029,'enUS','','Good one, sister.  What about your pet?  Where is $n?',26124),
(27030,'enUS','','You went behind my back.  You neglected my orders.  You will pay the price.',26124),
(27031,'enUS','','Enough talk.  By the time I\'m through with you, not even the worgs are going to want to go near your corpse.',26124),
(27032,'enUS','Ladies and gentlemen!  Well... let\'s just say you don\'t want to miss this one!','',26124),
(27033,'enUS','','Why... why sister?  Why did it have to come to this?',26124),
(27034,'enUS','I want to exchange my Ruby Essence for Emerald Essence.','I want to exchange my Ruby Essence for Emerald Essence.',26124),
(27035,'enUS','I want to exchange my Amber Essence for Emerald Essence.','I want to exchange my Amber Essence for Emerald Essence.',26124),
(27036,'enUS','Rocket propelled warheads? Isn\'t that a bit aggressive?','Rocket propelled warheads? Isn\'t that a bit aggressive?',26124),
(27037,'enUS','Listen here, now. When you\'re looking for answers nothing beats a good explosion - the bigger, the better!$b$bBut that\'s probably enough with the questions for now, $r.$b$bMy warheads are classified material, and the element 115 that I created to power them is even more classified!$b$bIn fact, it\'s best that you just return to your everyday life and pretend we never met.','',26124),
(27038,'enUS','I want to exchange my Emerald Essence for Amber Essence.','I want to exchange my Emerald Essence for Amber Essence.',26124),
(27039,'enUS','I want to exchange my Ruby Essence for Amber Essence.','I want to exchange my Ruby Essence for Amber Essence.',26124),
(27040,'enUS','I want to exchange my Amber Essence for Ruby Essence.','I want to exchange my Amber Essence for Ruby Essence.',26124),
(27041,'enUS','I want to exchange my Emerald Essence for Ruby Essence.','I want to exchange my Emerald Essence for Ruby Essence.',26124),
(27042,'enUS','I would like to go to Lord Afrasastrasz in the middle of the temple.','I would like to go to Lord Afrasastrasz in the middle of the temple.',26124),
(27043,'enUS','My lord, I need to get to the top of the temple.','My lord, I need to get to the top of the temple.',26124),
(27044,'enUS','','Welcome, adventurer. You\'ve come just in the nick of time.',26124),
(27045,'enUS','Thel\'zan needs to die, if only to stop the incessant yammering!','',26124),
(27046,'enUS','Can I get a ride back to ground level, Lord Afrasastrasz?','Can I get a ride back to ground level, Lord Afrasastrasz?',26124),
(27047,'enUS','Official postings by Wintergarde citizenry and officials.','',26124),
(27048,'enUS','Can you spare a drake to take me to Lord Afrasastrasz in the middle of the temple?','Can you spare a drake to take me to Lord Afrasastrasz in the middle of the temple?',26124),
(27049,'enUS','','Does being in the presence of a Black Dragon make you nervous?$B$BGood. It should. It makes these dragons nervous too. They cling to their ancient virtues though - they wouldn\'t dare attack me here.$B$BFools.',26124),
(27050,'enUS','Next, I shall speak of the dread plague wing of Naxxramas, where the Scourge seek to improve upon the deadly blight which they spread across Lordaeron.','',26124),
(27051,'enUS','Next, I shall speak of the accursed spider wing of Naxxramas. It is there the Scourge breed even more poisonous and dangerous versions of their kin.','',26124),
(27052,'enUS','Next, I shall speak of the blighted abomination wing of Naxxramas. There, the Scourge develop the strongest and most hideous aberrations of their armies.','',26124),
(27053,'enUS','Next, I shall speak of the death knight wing of Naxxramas. Within its corrupted halls, the echo of battle rings day and night, as our finest warriors are corrupted and twisted into the Scourge\'s greatest warriors.','',26124),
(27054,'enUS','Next, I shall speak of the most powerful entities within the pinnacle of Naxxramas. Truly, these are two of the greatest threats to all of Northrend.','',26124),
(27055,'enUS','Behold, Noth the Plaguebringer. Responsible for the creation of the process that distills the souls of the living and places them within the cold cage of undeath, Noth was observed to be refining this process even now. ','',26124),
(27056,'enUS','Observe, Heigan the Unclean. The mastermind behind the plague cauldrons that turned the wilderness of Azeroth into the Plaguelands. ','',26124),
(27057,'enUS','It is said that Heigan has rigged the very walls and floors of Naxxramas itself with a vast array of traps, which he can trigger at will.','',26124),
(27058,'enUS','Loatheb. The hideous result of fusing the living plague of the Plaguelands with the bog beasts of Azeroth, Loatheb is said to control the power of healing itself. ','',26124),
(27059,'enUS','I shall leave this image on display for your perusal. Study your opponents\' strengths, for a creature\'s strength can also be its weakness.','',26124),
(27060,'enUS','Pay attention. This is Instructor Razuvious, Kel\'Thuzad\'s appointed trainer of all death knights. It is said that his own technique is so potent, only a disciple of his could possibly withstand his might.','',26124),
(27061,'enUS','Gothik, the Harvester. A master of necromancy and conjuration, Gothik is said to be able to beckon forth legions of the undead at a moment\'s notice. It is with his guidance that even the weakest of Death Knights can raise the dead.','',26124),
(27062,'enUS','The most powerful death knights within Naxxramas are the four horsemen. They represent the pinnacle of Kel\'Thuzad\'s guard. The first, Thane Korth\'azz, holds the power of flame. ','',26124),
(27063,'enUS','The next, Lady Blaumeux, calls forth the power of shadows, drawing the souls of the living into the voracious embrace.','',26124),
(27064,'enUS','Sir Zeliek, a paladin in life, so strong in his faith, that even in undeath, the power of the light still heeds his call, smiting his foes in battle.','',26124),
(27065,'enUS','The final death knight, Lord Mograine, was the finest warrior that the death knights had ever seen. However, after the events in Azeroth, he vanished without a trace. It is yet to be seen who Kel\'Thuzad has appointed in his place.','',26124),
(27066,'enUS','Anub\'Rekhan, one of the finest Spider Lords of Azjol\'Nerub, was brought under the control of the Scourge when he and his former commander, Anub\'arak, were finally defeated by Lich King many years ago. It is said that he was the most loyal of Anub\'arak\'s commanders.','',26124),
(27067,'enUS','Listen, $r.$b$bIf you\'re lookin\' for a shredder to ride, you\'ll need to head up into the hills just north there.$b$bThis one\'s out of commission.','',26124),
(27068,'enUS','Why would I want to ride a shredder?','Why would I want to ride a shredder?',26124),
(27069,'enUS','At first we repaired them to harvest the forests here, but ever since the alliance arrived and the fighting broke out we\'ve been using them as war machines.$b$bBelieve me, $c. If you\'ve got a key, you\'d be crazy not to use it.','',26124),
(27070,'enUS','The Grand Widow Faerlina, a botanist in life, breeder and caretaker of arachnids in death, she overseers the spider wing, developing the most potent of poisons for the Lich King. ','',26124),
(27071,'enUS','Where can I get a Refurbished Shredder Key?','Where can I get a Refurbished Shredder Key?',26124),
(27072,'enUS','Grekk holds them.$b$bMaybe he\'ll give you one if you help him out. The next time you\'re up north at Blue Sky logging Grounds be sure to talk to him.','',26124),
(27073,'enUS','Maexxna, born deep within the mountains of Northrend many ages ago, she was captured within the dread citadel Naxxramas, where she gives birth to her brood, feeding them the corpses of all who dare venture too deeply into Naxxramas.','',26124),
(27074,'enUS','Behold, Patchwerk. When word of his existence first reached the ears of the Brotherhood, none believed the tales of an abomination with such immense speed and strength. Fewer still believed it when he fell the first time...','',26124),
(27075,'enUS','Grobbulus, the first of what was to be an army of flesh giants. It carried the plague slime of Naxxramas within its body, injecting the living ooze into the bodies of its foe. The recipient of this foul injection would usually flee to his allies, bringing them down with him.','',26124),
(27076,'enUS','Yes?','',26124),
(27077,'enUS','Gluth, the foul plague-dog of Naxxramas, was said to have an appetite so voracious that even the living were not enough to satisfy his hunger. Feugen was said to feed him an army of zombies daily, recycling the remains of undead too weak to use in combat.','',26124),
(27078,'enUS','Thaddius, built from the flesh of women and children, it is said that their souls are fused together - eternally bound within that foul prison of flesh. ','',26124),
(27079,'enUS','Sapphiron. Once a noble blue dragon within the mountains of Northrend, Sapphiron was slain by Arthas during his campaign through the frozen north. Resurrected to serve him, Sapphiron guards Kel\'thuzad\'s lair eternally, awaiting those who would dare tresspass upon his master.','',26124),
(27080,'enUS','The lich, Kel\'Thuzad. He serves the Lich King without question, a necromancer of great prowess in life, turned into a master of necromancy after his death. It is said he is the most loyal of the Lich King\'s subjects.','',26124),
(27081,'enUS','Kel\'thuzad has survived trials that would have long since shattered the souls of even the greatest of the Brotherhood. He readily gave his life at Arthas\'s hand, later to be brought back - reborn in the power of the Sunwell. ','',26124),
(27082,'enUS','In the Plaguelands, Kel\'thuzad was again defeated by the agents of the Argent Dawn. However, his phylactery was delivered to a false agent of the Brotherhood. We have yet to discover who stole his phylactery or why. ','',26124),
(27083,'enUS','Come out, soldier! I\'ll cover you!','Come out, soldier! I\'ll cover you!',26124),
(27084,'enUS','Soldier, run to me! I\'ll clear a path with the chain gun!','Soldier, run to me! I\'ll clear a path with the chain gun!',26124),
(27085,'enUS','','%s peers at Modoru\'s Draenic robes.',26124),
(27086,'enUS','','Pssst. Naohain. Why does Modoru still wear those ridiculous robes? He looks like some interdimensional bumpkin who stumbled out of Ammen Vale not six hours past.',26124),
(27087,'enUS','Rifleman, get our soldier out of there! NOW NOW NOW!','Rifleman, get our soldier out of there! NOW NOW NOW!',26124),
(27088,'enUS','Rifleman he\'s close enough now to rescue! GO GET HIM!','Rifleman he\'s close enough now to rescue! GO GET HIM!',26124),
(27089,'enUS','Rifleman, cease fire! Our soldier is within range! GET HIM OUT OF THERE!','Rifleman, cease fire! Our soldier is within range! GET HIM OUT OF THERE!',26124),
(27090,'enUS','Why have I been sent back to this particular place and time?','Why have I been sent back to this particular place and time?',26124),
(27091,'enUS','','The Infinite Dragonflight is attempting to alter the destiny of Prince Arthas Menethil.$B$BYou know him now as the Lich King, but here and now he was still a Prince of Lordaeron trying to do what was best for his kingdom.$B$BArthas makes a very fateful choice today, leading to something we Keepers of Time call an inflection point in the timeline.',26124),
(27092,'enUS','What was this decision?','What was this decision?',26124),
(27093,'enUS','','Arthas gave the order to cull Stratholme, killing every single human within its walls.$B$BHe discovered evidence that the Scourge had infected the city with their insidious plague, and the disease doesn\'t just kill people.$B$BThose who die to this plague rise up as mindless zombies, further fueling the Scourge\'s war machine.',26124),
(27094,'enUS','So how does the Infinite Dragonflight plan to interfere?','So how does the Infinite Dragonflight plan to interfere?',26124),
(27095,'enUS','Thanks for the cover fire! It\'s a MADHOUSE down there! ','Thanks for the cover fire! It\'s a MADHOUSE down there! ',26124),
(27096,'enUS','Wow, I thought I was a goner! Thanks, friend!','Wow, I thought I was a goner! Thanks, friend!',26124),
(27097,'enUS','I was almost ghoul bait! Thanks for the rescue!','I was almost ghoul bait! Thanks for the rescue!',26124),
(27098,'enUS','It\'s a good thing you came along, ally! We were done for!','It\'s a good thing you came along, ally! We were done for!',26124),
(27099,'enUS','Show me what you have for sale, trapper.','Show me what you have for sale, trapper.',26124),
(27100,'enUS','He wants me to do WHAT?','',26124),
(27101,'enUS','Well, he\'d better keep the moonshine flowing if he wants my men to stop their research to serve the military\'s purposes!','',26124),
(27102,'enUS','','The Infinites are attempting something unusually subtle for them. They are trying to hide the evidence that will lead to Arthas deciding to cull Stratholme.$B$BTheir agents have used illusionary magic on the plagued grain shipments in the nearby countryside to make them appear normal.$B$BI need you to find the hidden grain, and use this Arcane Disruptor on the shipments. Arthas\' men are looking for plagued grain, and should find it quickly with the illusion gone.',26124),
(27103,'enUS','','I don\'t think we can afford to pass an opportunity to ingratiate ourselves with the red flight. With the battles ahead, having them as allies would be invaluable.',26124),
(27104,'enUS','In years past, the warlock Nekros Skullcrusher abused a powerful artifact to enslave Alexstrasza and much of the red dragonflight.  Zuluhed and Nekros are dead, but the debt we owe to the reds is far from repaid.','',26124),
(27105,'enUS','Do not stray too far down the pass, $n. Stay with the captain and his men... you\'re no use to us dead.','',26124),
(27106,'enUS','Be sure to go through the southern canyon when entering and exiting the shrine, $n. You will know the canyons where the battle is waged by the abominations that guard them... keep your distance.','',26124),
(27107,'enUS','The Alliance has maintained this remote lodge for a while.  It\'s seen some use by our hunters and woodsmen.$B$BWith the war going on, you\'d better believe the military is in charge here now, though.','',26124),
(27108,'enUS','','Let me take care of it, sister.',26124),
(27109,'enUS','','What were you thinking, provoking her like that?',26124),
(27110,'enUS','','You... half-idiot!  You really did it this time.  I\'m going to have to make it look like your leg\'s broken.',26124),
(27111,'enUS','','Now don\'t move if you ever want to walk again!',26124),
(27112,'enUS','No, please!  Don\'t!','',26124),
(27113,'enUS','<The commander stops his lesson and turns, his eyes appraising you, sizing you up.>$B$BI have use for one such as yourself, $c.','',26124),
(27114,'enUS','Yes, $c, what can I do for you?$B$BIf you\'re here for a lesson on Naxxramas, there\'s plenty of room.','',26124),
(27115,'enUS','Yes, $c, what is it?','',26124),
(27116,'enUS','It\'s good to see you again, $n.$B$BCome for a refresher in Scourge tactics?','',26124),
(27117,'enUS','A crack begins to open beneath your feet.','',26124),
(27118,'enUS','Darling, you simply can\'t complete your look without the right shoes.  Don\'t you agree?','Darling, you simply can\'t complete your look without the right shoes.  Don\'t you agree?',26124),
(27119,'enUS','','Darling, those shoes are to die for!  I mean that literally.  Who did you kill for them?',26124),
(27120,'enUS','I\'ll flush her out, $n! You just be ready for her when she comes in!','I\'ll flush her out, $n! You just be ready for her when she comes in!',26124),
(27121,'enUS','Ticket Exchange','Ticket Exchange',26124),
(27122,'enUS','Awaiting orders!','',26124),
(27123,'enUS','FIRE! FIRE! BRING HER DOWN!','',26124),
(27124,'enUS','Welcome to Granite Springs, friend.$b$bIf you manage to catch any of these ice trolls alive, be sure to let me know. We\'re paying well for \'em.','',26124),
(27125,'enUS','Thel\'zan\'s phylactery drops to the ground beneath Icestorm.','',26124),
(27126,'enUS','\'We like the trees, Fenrick. They provide cover.\' They won\'t let me chop them down, either.','',26124),
(27127,'enUS','What do they expect, making the bats come in at that angle? Broken necks and gamey bat stew, that\'s what they get.','',26124),
(27128,'enUS','I wonder how many reinforcements need to suffer injury before they allow us to chop down these idiotic trees. They\'re costing us a fortune in bats. Maybe I\'ll rig a harness or two...','',26124),
(27129,'enUS','Bat gizzards again for the gnomes tonight...','',26124),
(27130,'enUS','Hey, I see ya got some Brewfest tokens.  If ya want, I still got a few Brewfest goods to sell.','Hey, I see ya got some Brewfest tokens.  If ya want, I still got a few Brewfest goods to sell.',26124),
(27131,'enUS','Get out there.','',26124),
(27132,'enUS','Do your job, scum.','',26124),
(27133,'enUS','If you want to jump to your death this time, I won\'t stop you.','',26124),
(27134,'enUS','You\'re on, rats.','',26124),
(27135,'enUS','Top of the hour, boys. Go.','',26124),
(27136,'enUS','Get out there before I clock you. Clock. Get it?','',26124),
(27137,'enUS','Wyrmbait, eh? Welp, go fetch us Icestorm!','Wyrmbait, eh? Welp, go fetch us Icestorm!',26124),
(27138,'enUS','How things be treatin\' ya, $n?  Here to hang out with other members of da club?','How things be treatin\' ya, $n?  Here to hang out with other members of da club?',26124),
(27139,'enUS','Good seein\' you again, $n.  I hope our club be treatin\' ya right.','Good seein\' you again, $n.  I hope our club be treatin\' ya right.',26124),
(27140,'enUS','Hey, $n, how\'s life been treating you?  Are you here to hang out with other club members?','Hey, $n, how\'s life been treating you?  Are you here to hang out with other club members?',26124),
(27141,'enUS','Hey, $n!  I hope you\'ve been enjoying our club!','Hey, $n!  I hope you\'ve been enjoying our club!',26124),
(27143,'enUS','What is it?','What is it?',26124),
(27144,'enUS','It looks like a gateway to hell!','It looks like a gateway to hell!',26124),
(27145,'enUS','If I don\'t make it back to Wintergarde, let my family know that I did my best and that I love them...','If I don\'t make it back to Wintergarde, let my family know that I did my best and that I love them...',26124),
(27146,'enUS','Is this the end? If we stop this monster now, is victory assured at the Wrathgate?','Is this the end? If we stop this monster now, is victory assured at the Wrathgate?',26124),
(27147,'enUS','I\'m getting a little worried. Where is this hero that is supposed to lead us into battle?','I\'m getting a little worried. Where is this hero that is supposed to lead us into battle?',26124),
(27148,'enUS','Let it be known that it has been an honor and a privilege fighting alongside all of you.\n','Let it be known that it has been an honor and a privilege fighting alongside all of you.\n',26124),
(27149,'enUS','Come on... Let\'s get this over with!\n','Come on... Let\'s get this over with!\n',26124),
(27150,'enUS','Death comes for us all eventually, but sometimes it comes a little faster than anticipated. Today we call that blind heroics... Tomorrow someone may call it stupidity. \n','Death comes for us all eventually, but sometimes it comes a little faster than anticipated. Today we call that blind heroics... Tomorrow someone may call it stupidity. \n',26124),
(27152,'enUS','%s casts Frost Tomb on $n.','',26124),
(27153,'enUS','You have saved me from those vicious monsters. Thank you.','',26124),
(27154,'enUS','','$n, good to see you!$B$BOr is this the first time that we\'ve met?$B$BI\'m in so many places and times right now, I sometimes have a hard time keeping track of all of it.',26124),
(27155,'enUS','Steel yourselves, soldiers. $n has provided us with the final piece of this puzzle. The dread lich, Thel\'zan, will soon come out of hiding, only to be rendered powerless against us!','',26124),
(27156,'enUS','It is this phylactery - Thel\'zan\'s phylactery - that is the key to victory!','',26124),
(27157,'enUS','I was... once like you. Mortal. Soft. Only flesh and bone. WEAK AND TIMID!','',26124),
(27158,'enUS','LEGION, STEADY YOURSELVES!','',26124),
(27159,'enUS','Our lord, Arthas, saw in me the frailty of man.','',26124),
(27160,'enUS','\"Serve me in life and I will promise to rend the weakness from your soul. To erase it from existence!\" To be chosen... blessed by the Lich King in such a way.','',26124),
(27161,'enUS','So serve him I did... Were it not for me the glorious dread citadel of Naxxramas may never have returned to Northrend.','',26124),
(27162,'enUS','But enough talk... You have fought hard and come from the distant reaches of this world to face the Duskbringer. I shall not disappoint...\n','',26124),
(27163,'enUS','Just as our lord saved me, so too shall I save you!\n','',26124),
(27164,'enUS','Rise, my minions! Your master commands it!','',26124),
(27165,'enUS','Blight, Blight, Blight... that\'s all I hear about around here. I miss the diversity!$b$bHere, here. You have pets, yes? Of course you do. Of course. Little pets. I have a mixture for them. It will make them ca-- ah, clever and strong creatures, yes. Yes. Strong.$b$bTry it!','',26124),
(27166,'enUS','All right, I\'ll take this mixture of yours.','All right, I\'ll take this mixture of yours.',26124),
(27167,'enUS','Careful with it. It\'s unstable and loses its potency quickly. Use it soon! And... preferably within eyesight, yes...','',26124),
(27168,'enUS','Where did that cat go?','',26124),
(27169,'enUS','Patchy?','',26124),
(27170,'enUS','There you are, you little miscreant.','',26124),
(27171,'enUS','%s sighs in irritation.','',26124),
(27172,'enUS','Time to make another Patchy.','',26124),
(27173,'enUS','Honor, courage, compassion and justice! These were once the virtues you fought for as a cleric of the Argent Dawn, Thel\'zan.','',26124),
(27174,'enUS','You dedicated your whole life to fighting the Scourge. You saw what they did to our beloved Lordaeron. The Lich King took everything from you!','',26124),
(27175,'enUS','So how, then, did Father Inigo Montoy, bastion of virtue for the Argent Dawn, become the embodiment of that which he hated most?','',26124),
(27176,'enUS','THIS WILL BE THE LAST TIME YOU UTTER THAT NAME, PALADIN! Breathe your dying breath!','',26124),
(27177,'enUS','Good to see you still alive and kicking, $n. Don\'t think that I\'d forgetten what you did for me in Stormwind, oh so long ago.','',26124),
(27178,'enUS','It\'s the Highlord!','It\'s the Highlord!',26124),
(27179,'enUS','Lord Fordragon!','Lord Fordragon!',26124),
(27180,'enUS','Victory for the Alliance!','',26124),
(27181,'enUS','You have saved Wintergarde! With Thel\'zan\'s filth washed away, the 7th Legion will easily clean up the remaining Scourge. When you are done here, report to Angrathar!','',26124),
(27182,'enUS','Now, be free and join the battle! Let us end this together!','',26124),
(27183,'enUS','Wow, that\'s a nice one!','',26124),
(27184,'enUS','That\'s a mighty fine mustang ya got there.','',26124),
(27185,'enUS','Keep bringin\' ones like that!','',26124),
(27186,'enUS','I\'m gonna train that one myself.','',26124),
(27187,'enUS','I know just the soldier for that horse!','',26124),
(27188,'enUS','I think he likes Old Blanchy.','',26124),
(27189,'enUS','I left a war once to tend to the troubles back home in Westfall. That seems like a lifetime ago. Thank the Light that the Defias are no longer a threat.$B$BWe\'re a long way from home up here, but if we don\'t win this battle, there may not be a Westfall to return to.','',26124),
(27190,'enUS','Mr. Perelli, have you seen any suspicious activity by men wearing dark robes in the last few weeks?','',26124),
(27191,'enUS','Mr. Perelli, have you seen any signs of the undead? Any information you can provide would be appreciated by Prince Arthas.','',26124),
(27192,'enUS','Mr. Perelli, I know you travel around quite a bit hawking your goods. Surely you\'ve heard rumors or information about the Scourge?','',26124),
(27193,'enUS','Do you plan on leaving the area soon if we have further questions?','',26124),
(27194,'enUS','Mr. Perelli, have these goods been under your supervision at all times?','',26124),
(27195,'enUS','You wouldn\'t happen to have any canned turtle soup from Hillsbrad, would you?','',26124),
(27196,'enUS','The walls of Frostmourne Cavern shudder and shake.','The walls of Frostmourne Cavern shudder and shake.',26124),
(27197,'enUS','Mr. Perelli, if you happen across any signs of Scourge activity or shady dealings in your travels, let the nearest Lordaeron soldier know.','',26124),
(27198,'enUS','No, Sergeant.','',26124),
(27199,'enUS','No, sir.','',26124),
(27200,'enUS','Nope.','',26124),
(27201,'enUS','Yes, sir.','',26124),
(27202,'enUS','Yes, Sergeant Morigan.','',26124),
(27203,'enUS','Absolutely.','',26124),
(27204,'enUS','Xink\'s Shredder collapses and sputters to a stop.','',26124),
(27205,'enUS','You don\'t mind me checking out your merchandise for signs of tampering, do you?','',26124),
(27206,'enUS','Wait, what is this? You\'ve been holding out on me, Perelli!','',26124),
(27207,'enUS','Behold, Muradin, our salvation, Frostmourne.\n','',26124),
(27208,'enUS','What are you talking about, Sergeant!','',26124),
(27209,'enUS','Hold, lad. There\'s an inscription on the dais. It\'s a warning. It says, \"Whomsoever takes up this blade shall wield power eternal. Just as the blade rends flesh, so must power scar the spirit.\" Oh, I should\'ve known. The blade is cursed! Let\'s get the hell out of here!\n','',26124),
(27210,'enUS','I\'m confiscating this suspicious grain, Perelli. We were looking for signs of tampered food, and it would be in your best interest to stay put while Prince Arthas checks this out.','',26124),
(27211,'enUS','I would gladly bear any curse to save my homeland.\n','',26124),
(27212,'enUS','Leave it be, Arthas. Forget this business and lead your men home.\n','',26124),
(27213,'enUS','You have to believe me, I\'m innocent!','',26124),
(27214,'enUS','Damn the men! Nothing shall prevent me from having my revenge, old friend. Not even you.\n','',26124),
(27215,'enUS','Now, I call out to the spirits of this place. I will give anything or pay any price, if only you will help me save my people.\n','',26124),
(27216,'enUS','We\'ll see about that, Perelli. We\'ll see about that.','',26124),
(27217,'enUS','O\' my head... Wh... Where am I?\n','',26124),
(27218,'enUS','Who... Who am I?\n','',26124),
(27219,'enUS','','Let\'s see, we had chicken last night.',26124),
(27220,'enUS','','I\'ve got plenty of cured bacon, but he had some for breakfast.',26124),
(27221,'enUS','','I need to make something healthy for him, he\'s still not recovered from that illness from last week.',26124),
(27222,'enUS','','Strawberries! Oh wait, they\'re not in season.',26124),
(27223,'enUS','','Ah, I\'ll make him some fresh bread! I need to get some flour from Martha!',26124),
(27224,'enUS','','Martha, I\'m out of flour for bread. You wouldn\'t happen to have any grain from that recent shipment, would you?',26124),
(27225,'enUS','Off we go!','Off we go!',26124),
(27226,'enUS','Pay attention, friend! We\'re headin\' into hostile territory with both vrykul and Horde all over the place!','Pay attention, friend! We\'re headin\' into hostile territory with both vrykul and Horde all over the place!',26124),
(27227,'enUS','Keep a close eye on your surroundings. The route I\'m taking is the same route you can use to get back to Valgarde.','Keep a close eye on your surroundings. The route I\'m taking is the same route you can use to get back to Valgarde.',26124),
(27228,'enUS','Here ya go, friend! Icehammer is right inside that vrykul building! Give \'em hell!','Here ya go, friend! Icehammer is right inside that vrykul building! Give \'em hell!',26124),
(27229,'enUS','','Thanks, Martha! I owe you one.',26124),
(27230,'enUS','','Oh, dear.',26124),
(27231,'enUS','','Martha, something\'s wrong with this grain! Some of the Prince\'s soldiers were looking for this. I\'m going to go look for one.',26124),
(27232,'enUS','','Oh hello, Jena. Of course you can borrow some grain. Help yourself.',26124),
(27233,'enUS','My warmages are inbound and will arrive presently.$b$bSpeak to me again when they have returned,','',26124),
(27234,'enUS','Pardon me, $r, but I am on official business and cannot be disturbed.$b$bPlease excuse me.','',26124),
(27235,'enUS','','Oh, my.',26124),
(27236,'enUS','Looks like a storm\'s coming in, Scruffy...','',26124),
(27237,'enUS','%s begins to growl...','',26124),
(27238,'enUS','What\'s wrong, pal?','',26124),
(27239,'enUS','Hey there, $n, don\'t be alarmed. It\'s me... you... from the future.  I\'m here to help.','Hey there, $n, don\'t be alarmed. It\'s me... you... from the future.  I\'m here to help.',26124),
(27240,'enUS','What did you find, boy?','',26124),
(27241,'enUS','This is no good, Scruffy. Stay here and guard the house, I need to go find a soldier.','',26124),
(27242,'enUS','The Infinite Dragonflight has destroyed the %s!','',26124),
(27243,'enUS','','How will we overcome the mist?',26124),
(27244,'enUS','','I thought for sure that I would die like all the others!',26124),
(27245,'enUS','','What was that! Did you see that?',26124),
(27246,'enUS','','Have you heard of the taunka? They are supposedly related to tauren in some way. Can you imagine such a thing?',26124),
(27247,'enUS','Ok, enough work for now. Time for refreshments and a little conversation in the inn.','',26124),
(27248,'enUS','Wait, what\'s that smell?','',26124),
(27249,'enUS','Can\'t be me, I took a bath 3 days ago!','',26124),
(27250,'enUS','Oh, close call. It\'s just the grain here.','',26124),
(27251,'enUS','Heads up... here they come. I\'ll help as much as I can. Let\'s just keep them off of the hourglass!','Heads up... here they come. I\'ll help as much as I can. Let\'s just keep them off of the hourglass!',26124),
(27252,'enUS','Wait a second. Grain isn\'t supposed to smell like THAT! I better go find a guard.','',26124),
(27253,'enUS','I knew I should have secured the wagon lock better when I was in Andorhal.','',26124),
(27254,'enUS','This grain shipment has been nothing but trouble!','',26124),
(27255,'enUS','I\'m going to lose my on time bonus because of this!','',26124),
(27256,'enUS','I wasn\'t even supposed to be here today!','',26124),
(27257,'enUS','Well, guess I should load everything back into the cart.','',26124),
(27258,'enUS','Oh, come on! My cart broke, my horse lost a shoe, and now the cargo goes bad!','',26124),
(27259,'enUS','I guess I\'ll go find the authorities. If I\'m lucky they\'ll tell me it\'s the plague and that we\'re all going to die.','',26124),
(27260,'enUS','The %s claws at the ground.','',26124),
(27261,'enUS','Oh darn. You\'re our only hope. Survive!','Oh darn. You\'re our only hope. Survive!',26124),
(27262,'enUS','The Unstable Mur\'ghoul is about to explode!','',26124),
(27263,'enUS','All soldiers of Lordaeron should immediately report to the entrance of Stratholme, and await further orders from Prince Arthas.','',26124),
(27264,'enUS','Once again, all soldiers of Lordaeron are ordered to immediately report to the entrance of Stratholme, and await further instructions from Prince Arthas.','',26124),
(27265,'enUS','','Good work! Arthas now knows about the plagued grain in Stratholme, and is about to begin the culling.$B$BSomething is still not quite right, though. I sense a foreign presence in this timeline besides us, and that must mean the Infinite Dragonflight are here somewhere.',26124),
(27266,'enUS','What do you think they\'re up to?','What do you think they\'re up to?',26124),
(27267,'enUS','','I don\'t know, and that worries me. I\'ll do everything I can to find the Infinites.$B$BWhat I need you to do now is stay close to Arthas by joining his army.',26124),
(27268,'enUS','You want me to do what?','You want me to do what?',26124),
(27269,'enUS','','Well, you\'re not going to sign recruitment papers or anything, but you are going to fight alongside him.$B$BYou need to make sure Arthas culls Stratholme and defeats Mal\'Ganis. Without Uther and Jaina around, he\'ll need all the help he can get.$B$BIf you talk to Arthas, he\'ll put you to work destroying the forces of Mal\'Ganis. Follow along until I can figure out what\'s going on with the Infinites.',26124),
(27270,'enUS','Very well, Chromie.','Very well, Chromie.',26124),
(27271,'enUS','','Good luck, and be safe. Here comes Uther and Jaina now.',26124),
(27272,'enUS','Hang on to your hat, $n! To Scalawag we go!','',26124),
(27273,'enUS','YAAARRRRR! Here we be, matey! Scalawag Point!','',26124),
(27274,'enUS','Greenskin... I know why you\'ve come. You will not find allies in my kind for we do not trust you.','',26124),
(27275,'enUS','Look, $n, the hourglass has revealed Nozdormu!','Look, $n, the hourglass has revealed Nozdormu!',26124),
(27276,'enUS','%s waves dismissively.','',26124),
(27277,'enUS','Bah! You\'re as dumb as a rock! I hope the worms eat all of you.','',26124),
(27278,'enUS','OWWWW!','OWWWW!',26124),
(27279,'enUS','AYYYIEEE!!','AYYYIEEE!!',26124),
(27280,'enUS','YEEOOWCH!','YEEOOWCH!',26124),
(27281,'enUS','AAAAHHH!!','AAAAHHH!!',26124),
(27282,'enUS','<Drakuru extends his bleeding hand through the cage and looks at you with anticipation.>','',26124),
(27283,'enUS','Shake Drakuru\'s outstretched hand.','Shake Drakuru\'s outstretched hand.',26124),
(27284,'enUS','Time was when I\'d pull yer heart out ya just ta see da look on yer face....','',26124),
(27285,'enUS','Ey, mon!$b$bGood to be seein\' ya again... $n, right? Yes, yes, of course.$b$bYou and I gunna be real good friends. Drakuru know dese things.$b$b<A grin slowly spreads across the troll\'s painted face.>','',26124),
(27286,'enUS','I need another of your elixirs, Drakuru.','I need another of your elixirs, Drakuru.',26124),
(27287,'enUS','Farewell, $n. Keep us alive and get some better equipment!','Farewell, $n. Keep us alive and get some better equipment!',26124),
(27288,'enUS','There ya go, mon. Try ta be more careful with this one, won\'t ya?$b$bNow head down ta Drak\'Zin Ruins and drink it near the pedestal!','',26124),
(27289,'enUS','It is from this throne that I issue the command of Hellscream. His word is life and his word is death.','',26124),
(27290,'enUS','Shcourged trooolls roashting....','',26124),
(27291,'enUS','...on an open fire.....','',26124),
(27292,'enUS','That\'s it! Far as I got... Whatd\'ya think?','',26124),
(27293,'enUS','','Elune watch over you, $r.',26124),
(27294,'enUS','Admiral Keller sent me, Emilune. Please send me to Westguard Keep!','Admiral Keller sent me, Emilune. Please send me to Westguard Keep!',26124),
(27295,'enUS','I have arrived. Shall we set to work, then?','',26124),
(27296,'enUS','How may this one help you, $gsir:madame;?','',26124),
(27298,'enUS','How does this work?','How does this work?',26124),
(27299,'enUS','Show me what you have to trade.','Show me what you have to trade.',26124),
(27300,'enUS','My business partner slays things; I drain a portion of their essence... a pittance, really; the slightest of slivers. It won\'t be missed.$B$BStill, to fulfil my portion of the contract, I pay in Ethereal Credits.$B$BOne may redeem these credits for items I sell at any time. I\'m bound to have something that will interest you...','',26124),
(27301,'enUS','I can\'t believe that I used to wear that.','I can\'t believe that I used to wear that.',26124),
(27302,'enUS','','This is the only way Harry will even talk to me! I have to keep this stupid mask on all the time...',26124),
(27303,'enUS','Harry said I could take his bomber to Bael\'gun\'s. I\'m ready to go!','Harry said I could take his bomber to Bael\'gun\'s. I\'m ready to go!',26124),
(27304,'enUS','Look at you fight; no wonder I turned to drinking.','Look at you fight; no wonder I turned to drinking.',26124),
(27305,'enUS','What? Am I here alone. We both have a stake in this, you know!','What? Am I here alone. We both have a stake in this, you know!',26124),
(27306,'enUS','No matter what, you can\'t die, because that would mean that I would cease to exist, right? But, I was here before when I was you. I\'m so confused!','No matter what, you can\'t die, because that would mean that I would cease to exist, right? But, I was here before when I was you. I\'m so confused!',26124),
(27307,'enUS','Wow, I\'d forgotten how inexperienced I used to be.','Wow, I\'d forgotten how inexperienced I used to be.',26124),
(27308,'enUS','Mack belches loudly...','',26124),
(27309,'enUS','Oy, mon!$b$bThis not be what it looks like. Well, maybe...$b$bIt be complicated.','',26124),
(27310,'enUS','Oy mon! I know you?$b$bAhh yeah, Prigmon not forget a face.$b$bYou... followin\' me, mon? Cuz whatver it be, Prigmon never done it!','',26124),
(27311,'enUS','Sorry, but Chromie said that I couldn\'t reveal anything about your future to you. She said that if I did, I would cease to exist.','Sorry, but Chromie said that I couldn\'t reveal anything about your future to you. She said that if I did, I would cease to exist.',26124),
(27312,'enUS','Wish I could remember how many of the Infinite Dragonflight were going to try to stop you. This fight was so long ago.','Wish I could remember how many of the Infinite Dragonflight were going to try to stop you. This fight was so long ago.',26124),
(27313,'enUS','Listen. I\'m not supposed to tell you this, but there\'s going to be this party that you\'re invited to. Whatever you do, DO NOT DRINK THE PUNCH!','Listen. I\'m not supposed to tell you this, but there\'s going to be this party that you\'re invited to. Whatever you do, DO NOT DRINK THE PUNCH!',26124),
(27314,'enUS','Glad you could make it, Uther.','',26124),
(27315,'enUS','Watch your tone with me, boy. You may be the prince, but I\'m still your superior as a paladin!','',26124),
(27316,'enUS','As if I could forget. Listen, Uther, there\'s something about the plague you should know...','',26124),
(27317,'enUS','Oh, no. We\'re too late. These people have all been infected! They may look fine now, but it\'s just a matter of time before they turn into the undead!','',26124),
(27318,'enUS','What?','',26124),
(27319,'enUS','This entire city must be purged.','',26124),
(27320,'enUS','How can you even consider that? There\'s got to be some other way.','',26124),
(27321,'enUS','Damn it, Uther! As your future king, I order you to purge this city!','',26124),
(27322,'enUS','You are not my king yet, boy! Nor would I obey that command even if you were!','',26124),
(27323,'enUS','Then I must consider this an act of treason.','',26124),
(27324,'enUS','Treason? Have you lost your mind, Arthas?','',26124),
(27325,'enUS','Have I? Lord Uther, by my right of succession and the sovereignty of my crown, I hereby relieve you of your command and suspend your paladins from service.','',26124),
(27326,'enUS','','Arthas! You can\'t just--',26124),
(27327,'enUS','It\'s done! Those of you who have the will to save this land, follow me! The rest of you... get out of my sight!','',26124),
(27328,'enUS','You\'ve just crossed a terrible threshold, Arthas.','',26124),
(27329,'enUS','Jaina?','',26124),
(27330,'enUS','','I\'m sorry, Arthas. I can\'t watch you do this.',26124),
(27331,'enUS','For Drak\'Tharon!','',26124),
(27332,'enUS','Zim\'bo must live to slay our betrayer!','',26124),
(27333,'enUS','Zim\'bo cannot be stopped! Da keep must be liberated!','',26124),
(27334,'enUS','You be dyin\' along with all dese scourge!','',26124),
(27335,'enUS','Betrayed by one of our own we were. Disgraced....','',26124),
(27336,'enUS','Ah, more essence to capture...','',26124),
(27337,'enUS','','Enjoy the ride! It\'s a one way trip!',26124),
(27338,'enUS','There ya go, mon. Try ta be more careful with this one, won\'t ya?$b$bNow head up north to Zeb\'Halak and drink it near the pedestal!$b$bOh, and be sure ya get the Eye of the Prophets from the head on the ziggurat first...','',26124),
(27339,'enUS','There ya go, mon. Try ta be more careful with this one, won\'t ya?$b$bNow head up north to Zeb\'Halak and drink it near the pedestal!$b$bI\'ll instruct you further from there.','',26124),
(27340,'enUS','There ya go, mon. Try ta be more careful with this one, won\'t ya?$b$bNow head to the passage of Drak\'Atal to the northwest and drink the elixir at the pedestal there. $b$bI\'ll instruct you further when I see you again.','',26124),
(27341,'enUS','Here is your share.','',26124),
(27342,'enUS','Turn around and get back in the fight or I\'ll have to drop you off!','',26124),
(27343,'enUS','Welcome to me camp, $r.$b$bShe don\'t look like much, but she\'s home fer now.','',26124),
(27344,'enUS','Ulfang, I need to see through the Eyes of the Eagle again.','Ulfang, I need to see through the Eyes of the Eagle again.',26124),
(27345,'enUS','Very well. You are invested once more with her keen eyesight.','',26124),
(27346,'enUS','Teleport me to Amber Ledge, please.','Teleport me to Amber Ledge, please.',26124),
(27347,'enUS','','Mr. Floppy and I went for a walk, but then we got lost and I was really scared, cause there were these wolves, you know, and they chased us, but then I saw this tower and Mr. Floppy and I hid here and the wolves finally went away after a while and it was terrible and now we don\'t know how to get back home.',26124),
(27348,'enUS','','I think you should go, $g mister:miss;. You\'re scaring Mr. Floppy.',26124),
(27349,'enUS','May I use a drake to fly elsewhere?','May I use a drake to fly elsewhere?',26124),
(27350,'enUS','How can I help you, child?','How can I help you, child?',26124),
(27351,'enUS','Persistence or stupidity? It matters not. Let this be a lesson learned, mortal!','',26124),
(27352,'enUS','You are welcome in Wyrmrest Temple, $r. Forgive the commotion outside; with Malygos\' recent acts, we have found ourselves besieged. You may still rest here under our protection should you need it.','',26124),
(27353,'enUS','Tsk, tsk, there\'ll be none of that!','',26124),
(27354,'enUS','Kill them Abbendis! Do not fail me!','',26124),
(27355,'enUS','The grand admiral studies you a moment through narrowed eyes.','',26124),
(27357,'enUS','You served your purpose.','',26124),
(27358,'enUS','I will see you in Icecrown, weakling... if you live that long!','',26124),
(27359,'enUS','The forces of the Scourge bear down upon us.  Take heart, and fight on!','The forces of the Scourge bear down upon us.  Take heart, and fight on!',26124),
(27360,'enUS','Do not lose hope, my $gson:daughter;.  With faith, we will march through this darkness and once again see the dawn.','Do not lose hope, my $gson:daughter;.  With faith, we will march  through this darkness and once again see the dawn.',26124),
(27361,'enUS','We must resist!  Gird your soul!  Burn the foul plague wherever you find it!','We must resist!  Gird your soul!  Burn the foul plague wherever you find it!',26124),
(27362,'enUS','%s opens a Chaotic Rift!','',26124),
(27363,'enUS','%s shields himself and diverts his power to the rifts!','',26124),
(27364,'enUS','Path of Illidan','Path of Illidan',26124),
(27365,'enUS','Disco Ball','Disco Ball',26124),
(27366,'enUS','Ethereal Summoner','Ethereal Summoner',26124),
(27367,'enUS','Hunt for Illidan','Hunt for Illidan',26124),
(27368,'enUS','You think that you can get rid of me through meditation?','You think that you can get rid of me through meditation?',26124),
(27369,'enUS','Fool! I will destroy you and finally become that which has been building inside of you all of these years!','Fool! I will destroy you and finally become that which has been building inside of you all of these years!',26124),
(27370,'enUS','You cannot defeat me. I\'m an inseparable part of you!','You cannot defeat me. I\'m an inseparable part of you!',26124),
(27371,'enUS','NOOOOOOOoooooooooo!','NOOOOOOOoooooooooo!',26124),
(27372,'enUS','Test','',26124),
(27373,'enUS','Nice one, kid.','',26124),
(27374,'enUS','Another blue down. We make a great team!','',26124),
(27375,'enUS','With you and I working together, this battle will be over in no time.','',26124),
(27376,'enUS','I never thought that I\'d be riding into battle with a $r on my back.','',26124),
(27377,'enUS','I\'m glad you saw that one!','',26124),
(27378,'enUS','Just hang on. We\'ll get through this.','',26124),
(27379,'enUS','I\'ve never seen anything like this before. I\'m glad that you\'re here.','',26124),
(27380,'enUS','Malygos has clearly gone insane.','',26124),
(27381,'enUS','The %s directs the blinding swarm directly in front of it.','',26124),
(27382,'enUS','You have no idea what horrors lie ahead. You have seen nothing! The frozen heart of Naxxramas awaits you!','',26124),
(27383,'enUS','Greetings, $c!$b$bI hope you don\'t mind a little hard work. We could sure use a hand here.','',26124),
(27384,'enUS','','The wind and trees whisper of unseen troubles.  The land appears healthy, but there\'s more going on here than meets the eye.',26124),
(27385,'enUS','','<Thayreen\'s stare is blank.  Cleansing Vordrassil\'s corruption has taken its toll on the druid.>',26124),
(27386,'enUS','Hides for the Horde, mon!  Only the best for our troops!','',26124),
(27387,'enUS','Some supplies for the road?  Perhaps a refreshment to enjoy while you watch the fights?','',26124),
(27388,'enUS','Enemies are closing in on us from all sides, and all the elders talk of abandoning this post. I say we should stand and fight like the warriors we are.','',26124),
(27389,'enUS','Your greatest challenge lies ahead.  Ley-Guardian Eregos is a Blue dragon of immense power. You will find him flying above the uppermost ring.','',26124),
(27390,'enUS','You may only fly in Icemist Village.','',26124),
(27391,'enUS','','You really shouldn\'t be here, $r.',26124),
(27392,'enUS','You really should not be here, $r. Leave if you value your life.','',26124),
(27393,'enUS','Return to the field of battle or your dragon will drop you!','',26124),
(27394,'enUS','Across this vast expanse rest the bones of my ancestors. Their spirits have ascended to the Chamber of the Aspects.','',26124),
(27395,'enUS','What the Scourge has done here will reverberate throughout our world. The aberrations must be stopped!','',26124),
(27396,'enUS','Galakrond was the progenitor of dragonkind. It was from Galakrond that the Titans shaped the five Aspects.','',26124),
(27397,'enUS','You must remember that I have yet to mature into an elder wyrm. I must eat to renew my strength!','',26124),
(27398,'enUS','Today is a good day, friend. Long has it been since I have left Wyrmrest Temple, free to fly across the great Dragonblight.','',26124),
(27399,'enUS','The queen and her council have been speaking lately of a disaster at Ulduar. Something has happened in Storm Peaks!','',26124),
(27400,'enUS','It truly is a shame that the blue dragonflight has chosen such a heartless, cold path. It pains me greatly to do battle with Malygos\'s children.','',26124),
(27402,'enUS','Drakuru casts his gaze down on Drak\'Tharon Keep....','',26124),
(27403,'enUS','Ya done well, mon.','',26124),
(27404,'enUS','I have been called back to Wyrmrest, ally. Farewell!','',26124),
(27405,'enUS','Faster, dogs! We mustn\'t relent in our assault against the interlopers!','',26124),
(27406,'enUS','Soon, the bones of Galakrond will rise from their eternal slumber and wreak havoc upon this world!','',26124),
(27407,'enUS','Hear me, minions! Hear your lord, Antiok! Double your efforts or pay the consequences of failure!','',26124),
(27408,'enUS','The Lich King demands more frost wyrms be sent to Angrathar! Meet his demands or face my wrath!','',26124),
(27409,'enUS','Attackers are upon us! Let none through to this ancient grave!','',26124),
(27410,'enUS','The Scythe of Antiok drops to the ground!','',26124),
(27411,'enUS','What do we have here... those that would defy the Spell-Weaver? Those without foresight or understanding. How can I make you see? Malygos is saving the world from itself! Bah! You are hardly worth my time!','',26124),
(27412,'enUS','Poor blind fools!','',26124),
(27413,'enUS','Clearly my pets failed. Perhaps another demonstration is in order.','',26124),
(27414,'enUS','Still you fight. Still you cling to misguided principles. If you survive, you\'ll find me in the center ring.','',26124),
(27415,'enUS','You think you\'ve won, mortal? Face the unbridled power of Antiok!','',26124),
(27416,'enUS','Behold! The Scythe of Antiok!','',26124),
(27417,'enUS','I call \'er the Spirit of Gnomeregan. Isn\'t she a beaut? Without your help, she\'d\'ve never been restored.','',26124),
(27418,'enUS','Right!  Let\'s try this so-called dire brew...','',26124),
(27419,'enUS','By Bronzebeard\'s beard!  What a drink!','',26124),
(27420,'enUS','It is a shame Coren\'s Dire Brew can\'t quench more thirsting throats!  It\'s blasphemy, I know, but  I envy those Dark Iron dwarves!','',26124),
(27421,'enUS','$n, this beer... well, it might be the best of Brewfest!','',26124),
(27422,'enUS','Welcome to Argent Stand, $c.$b$bMake yourself at home, but don\'t get too comfortable. We\'re not out of the woods yet - far from it.$b$bIf we\'re going to make it out of here in one piece, everyone\'s going to have to do their share... including you.','',26124),
(27423,'enUS','The Dread Captain DeMeza has pulled into Booty Bay and declared it Pirates\' Day!$B$BShe\'s making anyone who\'s brave enough to share a drink with her an honorary crewmember.','The Dread Captain DeMeza has pulled into Booty Bay and declared it Pirates\' Day!$B$BShe\'s making anyone who\'s brave enough to share a drink with her an honorary crewmember.',26124),
(27424,'enUS','We\'re in a fine mess here.','',26124),
(27425,'enUS','The land is defiled by the presence of the Scourge on one side and the rituals of the Drakkari on the other.$B$BWe stand resolute betwixt the two.','',26124),
(27426,'enUS','Thank the Light for you!','Thank the Light for you!',26124),
(27427,'enUS','Hey there, $c. We\'re in the middle of a battle here.','Hey there, $c. We\'re in the middle of a battle here.',26124),
(27428,'enUS','What are you doing out here?','What are you doing out here?',26124),
(27429,'enUS','Aren\'t you $n? I\'d heard you were dead.','Aren\'t you $n? I\'d heard you were dead.',26124),
(27430,'enUS','Make it quick... the fighting here is grim. I need to stay sharp.','Make it quick... the fighting here is grim. I need to stay sharp.',26124),
(27431,'enUS','You a new recruit? That\'s not standard issue armor.','You a new recruit? That\'s not standard issue armor.',26124),
(27432,'enUS','Oh good, reinforcements!','Oh good, reinforcements!',26124),
(27433,'enUS','You have a message for me?','You have a message for me?',26124),
(27434,'enUS','Soldier, you have new orders. You\'re to pull back and report to the sergeant!','Soldier, you have new orders. You\'re to pull back and report to the sergeant!',26124),
(27435,'enUS','Well time\'s money, and time\'s wasting!  Let\'s have that drink...','',26124),
(27436,'enUS','Wow!  This really greases the steamplugs!','',26124),
(27437,'enUS','If I were an honest goblin, I\'d say this was the best beer of the festival...','',26124),
(27438,'enUS','Too bad Coren\'s dead.  If I could buy that brew from him and resell it -- watered down and rebottled under my own label, of course -- I\'d be rich!','',26124),
(27439,'enUS','Little hairier out here than you expected, $r?$b$bCan\'t say I\'m surprised. I hear that from most everyone who makes it this far.','',26124),
(27440,'enUS','I\'ll have you at Amberpine Lodge in no time, ally! We just have to make one brief stop first...','I\'ll have you at Amberpine Lodge in no time, ally! We just have to make one brief stop first...',26124),
(27441,'enUS','I am Ubungo. I represent the Zandalar tribe.$B$BBad things are afoot, $r. The Drakkari are going to be their own doom with what they\'re up to.$B$BSome trolls never learn.','',26124),
(27442,'enUS','We\'re gonna do a quick fly by Conquest Hold to see what those filthy, no good, Horde are up to. Keep your eyes peeled for their wind riders. Not that they\'d ever catch me!','We\'re gonna do a quick fly by Conquest Hold to see what those filthy, no good, Horde are up to. Keep your eyes peeled for their wind riders. Not that they\'d ever catch me!',26124),
(27443,'enUS','What in the name of Bronzebeard is goin\' on here? Look at this place! I think...','What in the name of Bronzebeard is goin\' on here? Look at this place! I think...',26124),
(27444,'enUS','Uh-oh. We\'ve got company! HOLD ON TIGHT! I\'m gonna try and lose \'em!','Uh-oh. We\'ve got company! HOLD ON TIGHT! I\'m gonna try and lose \'em!',26124),
(27445,'enUS','Thanks, $c.','Thanks, $c.',26124),
(27446,'enUS','Right. I\'d better get back to the sergeant then.','Right. I\'d better get back to the sergeant then.',26124),
(27447,'enUS','See you around.','See you around.',26124),
(27448,'enUS','Watch your back. These Drakkari are a nasty lot.','Watch your back. These Drakkari are a nasty lot.',26124),
(27449,'enUS','Careful here, $c. These trolls killed their own snake god!','Careful here, $c. These trolls killed their own snake god!',26124),
(27450,'enUS','Don\'t stay out here too long.','Don\'t stay out here too long.',26124),
(27451,'enUS','I wonder where we\'re headed to. And who\'s going to deal with these guys?','I wonder where we\'re headed to. And who\'s going to deal with these guys?',26124),
(27452,'enUS','These Drakkari are just bad news. We need to leave and head to Justice Keep!','These Drakkari are just bad news. We need to leave and head to Justice Keep!',26124),
(27453,'enUS','Ahoy, me hearty!$B$BToday\'s OUR day, ye know... PIRATES\' DAY!$B$BOl\' Chumbucket and I came up with the idea, and once the Dread Captain heard of it... well, here we are!','',26124),
(27454,'enUS','Tomorrow, the baron gets his town back... but for today - Pirates\' Day - it belongs to the Dread Captain DeMeza and her crew. Yarrr!$B$BAnd remember: lookin\' the part\'s only HALF the celebration. Talk like a pirate, $glad:lass;!','',26124),
(27455,'enUS','Hapana simply grunts and waves you away towards the Dread Captain DeMeza.$B$BBeneath the fur of one massive arm can be seen a tattoo of the word \"MAGATHA\" in an arrow-pierced heart.','',26124),
(27456,'enUS','SQUAWK! Keelhaul the lad! Keelhaul!','',26124),
(27457,'enUS','SQUAWK! Walk the plank! Walk!','',26124),
(27458,'enUS','SQUAWK! Shiver me timbers! Shiver!','',26124),
(27459,'enUS','SQUAWK! Avast, ye scurvy dogs! Avast!','',26124),
(27460,'enUS','','Ye\'ve got some stones comin\' up here, $glad:lass;. It\'s Pirates\' Day, ye know... and \'til the sun rises on the morrow, Booty Bay is MINE.$B$BSo! What do ye say? Raise a drink ta me and me crew, and join the celebration?',26124),
(27461,'enUS','Oh... I\'m feeling groggy...','',26124),
(27462,'enUS','Don\'t bother me, $c!  I have two whole cauldrons of bubbling brew here and I must ensure they taste just right!$B$BIf they don\'t, then Master Coren Direbrew will flay and boil me!','',26124),
(27463,'enUS','Here\'s to you, Dread Captain! Make me a pirate for the day.','Here\'s to you, Dread Captain! Make me a pirate for the day.',26124),
(27464,'enUS','May I help you taste?','May I help you taste?',26124),
(27466,'enUS','Take position here, and I will lead a small force inside Stratholme to begin the culling. We must contain and purge the infected for the sake of all of Lordaeron!','',26124),
(27467,'enUS','Welcome to Booty Bay, partner.  Don\'t mind DeMeza and her crew... we let the hellion run riot one day a year, Pirates\' Day, and then she leaves us in peace to go plunder the South Seas again.$B$BNow then... what can this humble servant of the Steamwheedle Cartel do for you?  Better still - what can you do for me, eh?','',26124),
(27468,'enUS','This is getting good!  It really warms the stomach!  And $n, I have to say, you\'re a sharp dressing $gfellow:lass;!','',26124),
(27469,'enUS','This is good stuff!  But it\'s a little weak.  I think I\'ll add a little more garlic breath to it...','',26124),
(27471,'enUS','','Ahoy! It\'s Pirates\' Day, ye know... and \'til the sun rises on the morrow, Booty Bay is MINE.',26124),
(27472,'enUS','I think we lost \'em! That was a close one! Welp, as promised, Amberpine Lodge in one piece! Keep your feet on the ground, friend!','I think we lost \'em! That was a close one! Welp, as promised, Amberpine Lodge in one piece! Keep your feet on the ground, friend!',26124),
(27473,'enUS','INTRUDERS! KILL THEM!','',26124),
(27474,'enUS','ALLIANCE FILTH! DIE! DIE!','',26124),
(27475,'enUS','Take their heads! For the Horde!','',26124),
(27476,'enUS','Truly, the horrors here surpass those we\'ve endured in the Plaguelands.$b$bThe Scourge are more powerful now than ever before.','',26124),
(27477,'enUS','I can\'t take it anymore....$b$bThey kill you, then eat you! And that\'s if you\'re lucky!','I can\'t take it anymore....$b$bThey kill you, then eat you! And that\'s if you\'re lucky!',26124),
(27478,'enUS','You gotta help me get outta here, $r!$b$bI don\'t wanna become like them!','You gotta help me get outta here, $r!$b$bI don\'t wanna become like them!',26124),
(27479,'enUS','I haven\'t been able to eat or sleep since I got here.$b$bI\'m just not cut out for the Crusade....','I haven\'t been able to eat or sleep since I got here.$b$bI\'m just not cut out for the Crusade....',26124),
(27480,'enUS','<sob> My uncle served in the Argent Dawn.$b$bHow was he able to face these foul things?','<sob> My uncle served in the Argent Dawn.$b$bHow was he able to face these foul things?',26124),
(27481,'enUS','Every time I close my eyes I see the scourge surrounding me!$b$bI gotta get outta here....','Every time I close my eyes I see the scourge surrounding me!$b$bI gotta get outta here....',26124),
(27482,'enUS','I\'m going to die here... I just know it.','I\'m going to die here... I just know it.',26124),
(27483,'enUS','We\'re doooomed!!','We\'re doooomed!!',26124),
(27484,'enUS','Get out of here while you can, $c!$b$bThere\'s no way we can win....','Get out of here while you can, $c!$b$bThere\'s no way we can win....',26124),
(27485,'enUS','','This is a fine mess.',26124),
(27486,'enUS','Get out there and make those Scourge wish they were never reborn!','Get out there and make those Scourge wish they were never reborn!',26124),
(27487,'enUS','This is good stuff!  But I think it\'s a little flat.  Let\'s round it out with a few squishy basilisk eyeballs...','',26124),
(27488,'enUS','Not bad, not bad... But it\'s missing spice!  How about adding scorpid venom?  Yes!  That\'ll fix it right up!','',26124),
(27489,'enUS','It\'s shaping up!  But it needs more kick.  Yep, you guessed it... Let\'s wash yesterday\'s socks in the cauldron... Mmmh, delicious!','',26124),
(27490,'enUS','Yes $gsir:ma\'am;, this is quite a drink!  Quite a drink indeed!','',26124),
(27491,'enUS','Let\'s sing a song!$B$BBrew, brawl,$BBrew, brawl!$BA Dark Iron\'s life for me!$B$BHah hah!  $n, I like you!','',26124),
(27492,'enUS','Now where was I?  I yeah...  So I said to her, \"But I need you!  I need you!\"... and she just laughed and slithered away!  It\'s the honest truth, $n.  Naga can be so cruel!','',26124),
(27493,'enUS','Let\'s taste more!','Let\'s taste more!',26124),
(27494,'enUS','Another drink!','Another drink!',26124),
(27495,'enUS','Another!','Another!',26124),
(27496,'enUS','You\'re right! What was I thinking? Bring on the Scourge!','You\'re right! What was I thinking? Bring on the Scourge!',26124),
(27497,'enUS','You\'re right! We can do this!','You\'re right! We can do this!',26124),
(27498,'enUS','We can win this war!','We can win this war!',26124),
(27499,'enUS','For the Argent Crusade! The Scourge shall fail!','For the Argent Crusade! The Scourge shall fail!',26124),
(27500,'enUS','We\'ll cleanse this place! Arthas beware!','We\'ll cleanse this place! Arthas beware!',26124),
(27501,'enUS','You dare summon me?!','',26124),
(27502,'enUS','Prepare to drown!','',26124),
(27503,'enUS','The depths consume you!','',26124),
(27504,'enUS','I will add your watery innards to my own.','',26124),
(27505,'enUS','%s looks for a nearby corpse to cannibalize.','',26124),
(27506,'enUS','The %s chews on nearby vegetation.','',26124),
(27507,'enUS','Drink deep my brothers!','',26124),
(27508,'enUS','The mojo of Sseratus is ours. Now all will be crushed under the might of the Drakkari!','',26124),
(27509,'enUS','They dare attack us? The fools! Do they not know we are now all-powerful?!','',26124),
(27510,'enUS','Kill these invaders who dare to defile our altar!','',26124),
(27511,'enUS','Finish them and then we will move south to kill their brethren!','',26124),
(27512,'enUS','With the power of the wild gods burning in our veins, none, not even the Lich King, can stand in our way!','',26124),
(27513,'enUS','I see you, insect! Come closer.','',26124),
(27514,'enUS','I will destroy the Argent Crusade! I will crush the Scourge!','',26124),
(27515,'enUS','I wouldn\'t do this on any other day, but... I\'m thirsty and I hate drinking alone.$B$BBottoms up!','',26124),
(27516,'enUS','Cheers!','Cheers!',26124),
(27517,'enUS','All officers should check in with me when their squads are ready. We\'ll enter Stratholme on my order.','',26124),
(27518,'enUS','Are you ready to do whatever must be done to protect Lordaeron?','',26124),
(27519,'enUS','BOOM!$b$bThat\'s the last thing I remember...','',26124),
(27520,'enUS','<sigh>... This is the end of me.','',26124),
(27521,'enUS','Thank you, friend. Were it not for your aid I would be no more.','',26124),
(27522,'enUS','<sigh>...$b$bA little help here, perhaps?','',26124),
(27523,'enUS','<sigh>... Well, I suppose it could be worse.','',26124),
(27524,'enUS','Yes, my Prince. We are ready.','Yes, my Prince. We are ready.',26124),
(27525,'enUS','Don\'t mind me. I\'m just an old man, waiting on an old... friend.','',26124),
(27526,'enUS','','Ohhh, the pain is... overwhelming....',26124),
(27527,'enUS','','Ohhh, I... cannot go on....',26124),
(27528,'enUS','','I am in your debt, friend. Thank you for my life.',26124),
(27529,'enUS','','Hurry, $r.$b$bTime is running out for me.',26124),
(27530,'enUS','Hurry, $g brother : sister;. I\'m leaking here....','',26124),
(27531,'enUS','Mmm, more mojo.','',26124),
(27532,'enUS','NOOOOOOOOooooooo.........!','',26124),
(27533,'enUS','<sigh>... Do you think we could move out, $c?$b$bI\'m losing fluid fast!','',26124),
(27534,'enUS','Fire! Must be the damned drakes again. Come on!','Fire! Must be the damned drakes again. Come on!',26124),
(27535,'enUS','Everyone looks ready. Remember, these people are all infected with the plague and will die soon. We must purge Stratholme to protect the remainder of Lordaeron from the Scourge. Let\'s go.','',26124),
(27536,'enUS','To the well! HURRY!','To the well! HURRY!',26124),
(27537,'enUS','Onward, you maggots!  This land is the Lich King\'s now!','',26124),
(27538,'enUS','Nothing can stop the Scourge!  Nothing!','',26124),
(27539,'enUS','Crush anything that stands in your path!  For the Lich King!','',26124),
(27540,'enUS','Im... possible...','',26124),
(27541,'enUS','Die like a dog!','',26124),
(27543,'enUS','HAH! How do you like THAT?!','',26124),
(27545,'enUS','You challenge Don Carlos? Guerrero! GO!','',26124),
(27546,'enUS','I\'ll take a ride to my first post, please.','I\'ll take a ride to my first post, please.',26124),
(27547,'enUS','Prince Arthas, may the light be praised! Many people in the town have begun to fall seriously ill, can you help us?','Prince Arthas, may the light be praised! Many people in the town have begun to fall seriously ill, can you help us?',26124),
(27548,'enUS','I can only help you with a clean death.','',26124),
(27549,'enUS','What? This can\'t be!','What? This can\'t be!',26124),
(27550,'enUS','%s begins to cast Magic Pull!','',26124),
(27552,'enUS','Oh, no...','Oh, no...',26124),
(27553,'enUS','That was just the beginning.','',26124),
(27554,'enUS','Drake incoming! OPEN FIRE!','Drake incoming! OPEN FIRE!',26124),
(27555,'enUS','She\'s attacking the keep! Bring her down!','She\'s attacking the keep! Bring her down!',26124),
(27556,'enUS','Damn it...','Damn it...',26124),
(27557,'enUS','Look lively! Keep firing!','Look lively! Keep firing!',26124),
(27558,'enUS','The keep is ablaze! Bombardiers, where in the Nether are you?!','The keep is ablaze! Bombardiers, where in the Nether are you?!',26124),
(27559,'enUS','On the move to the southern pass!','',26124),
(27560,'enUS','They\'re backing off here... get to the south pass! Quickly!','',26124),
(27561,'enUS','They\'re pushing in the south!','',26124),
(27562,'enUS','To the south! Move!','',26124),
(27563,'enUS','There are more to the south!','',26124),
(27564,'enUS','South! Now!','',26124),
(27565,'enUS','On the move back up to the eastern pass!','',26124),
(27566,'enUS','They\'re backing off here... get to the east pass! Quickly!','',26124),
(27567,'enUS','Head back up to the east pass! They\'re pushing hard!','',26124),
(27568,'enUS','Up to the eastern pass! Move!','',26124),
(27569,'enUS','There are more at the east pass!','',26124),
(27570,'enUS','East Pass! Now!','',26124),
(27571,'enUS','One of the cultists seems to have stumbled onto my blade and died... can I have a new disguise? I promise that I will be more careful this time.','One of the cultists seems to have stumbled onto my blade and died... can I have a new disguise? I promise that I will be more careful this time.',26124),
(27572,'enUS','Entering Phase 4 <PH>','',26124),
(27573,'enUS','My precious magmawyrms... perhaps not all is lost... perhaps there is something left to raise.','',26124),
(27574,'enUS','Yes, this is the beginning. I\'ve been waiting for you, young prince. I am Mal\'Ganis.','',26124),
(27575,'enUS','As you can see, your people are now mine. I will now turn this city household by household, until the flame of life has been snuffed out... forever.','',26124),
(27576,'enUS','Tabard of the Arcane','Tabard of the Arcane',26124),
(27577,'enUS','I won\'t allow it, Mal\'Ganis! Better that these people die by my hand than serve as your slaves in death!','',26124),
(27578,'enUS','Tabard of Brilliance','Tabard of Brilliance',26124),
(27579,'enUS','Tabard of the Defender','Tabard of the Defender',26124),
(27580,'enUS','Tabard of Fury','Tabard of Fury',26124),
(27581,'enUS','Tabard of Nature','Tabard of Nature',26124),
(27582,'enUS','Tabard of the Void','Tabard of the Void',26124),
(27583,'enUS','What is it? Can\'t you see that I\'m busy?','',26124),
(27584,'enUS','Mal\'Ganis will send out some of his Scourge minions to interfere with us. Those of you with the strongest steel and magic shall go forth and destroy them. I will lead the rest of my forces in purging Stratholme of the infected.','',26124),
(27585,'enUS','Come for training, have you?','Come for training, have you?',26124),
(27586,'enUS','You\'re no death knight. Away with you.','You\'re no death knight. Away with you.',26124),
(27587,'enUS','I am interested in death knight training.','I am interested in death knight training.',26124),
(27588,'enUS','Hey guys! Take care of that guy, I\'ll fix the machine thing! [PH]','',26124),
(27589,'enUS','This is a wee bit trickier than before... Oh, bloody--incomin\'!','',26124),
(27590,'enUS','What in the name o\' Madoran did THAT do? Oh! Wait: I just about got it...','',26124),
(27591,'enUS','Ha, that did it! Help\'s a-comin\'! Take this, ya glowin\' iron brute!','',26124),
(27592,'enUS','What are you looking down at?$B$BI\'ll have you know that the Pestlepots are a storied family with a long tradition of pestling.$B$BYes, that\'s a word!$B$BThere are no finer alchemists in all of Azeroth, or anywhere else for that matter, I can assure you!$B$BI may carry the title of apprentice at the moment, but my skill is second to none! One must endure such humilities though to get places in life.$B$BOf course, maybe you\'re just here to help me?$B$B<The diminuitive gnome grins arrogantly.>','',26124),
(27593,'enUS','','Now I\'ll show you the REAL power of the Onslaught!',26124),
(27594,'enUS','','Listen, you tell Schweitzer and Roitau that we\'ve got everything under control here. They don\'t gotta... what?$B$BThey didn\'t send you? Then what are you wasting my time for?$B$BI\'ve got work to do!',26124),
(27595,'enUS','Hey, can\'t you see I\'m busy here?!$B$BYou wanna watch the show? The band plays every night at eight.','',26124),
(27596,'enUS','','You\'ve come to test the might of the Onslaught?',26124),
(27597,'enUS','','Deal with this intrusion quickly. I don\'t have time for this!',26124),
(27598,'enUS','','You may want to rethink your actions, fool.',26124),
(27599,'enUS','','Am I going to have to deal with this intrusion myself?',26124),
(27600,'enUS','But I drove my mole machine all the way down here...','But I drove my mole machine all the way down here...',26124),
(27601,'enUS','Well... fine, fine. We need to test the equipment anyhow.$B$BGimme a few seconds. I\'ll have \'em come out to \"rehearse.\"$B$BYou ready?','',26124),
(27602,'enUS','I\'m ready.','I\'m ready.',26124),
(27603,'enUS','Let\'s wrap it up, Miz. They\'ll be here in a second.','',26124),
(27604,'enUS','<The Injured Rainspeaker Oracle groans in pain.>','',26124),
(27605,'enUS','No! You steal kill! Now you owe Gekgek!','',26124),
(27606,'enUS','Greetings, $r.$b$bI\'m afraid you must excuse me as I\'m terribly busy at the moment.','',26124),
(27607,'enUS','The %s screams with rage and rushes to the aid of her babies.','',26124),
(27608,'enUS','Time is of the essence here, $n. Are you prepared to be tested?','',26124),
(27609,'enUS','I\'m ready to begin. What is the first ingredient you require?','I\'m ready to begin. What is the first ingredient you require?',26124),
(27610,'enUS','Over here, to the southeast. I see they got you, too...','',26124),
(27611,'enUS','More intruders? You\'ll soon learn, no one messes with the Venture Company!','More intruders? You\'ll soon learn, no one messes with the Venture Company!',26124),
(27612,'enUS','I\'ll get you this time!','',26124),
(27613,'enUS','Well now, I\'m surprised to see other adventurers in a place such as this!$B$BNow that you\'re here, ye can help me get to the Tribunal. If my research theories about these halls is correct, information pertainin\' to the creation o\' the entire dwarven race lies within.','',26124),
(27614,'enUS','Brann, it would be our honor!','Brann, it would be our honor!',26124),
(27616,'enUS','Let\'s move Brann, enough of the history lesson!','Let\'s move Brann, enough of the history lesson!',26124),
(27617,'enUS','If only my dear brothers could be here with me at this moment in time. They would not believe what a discovery this will be!$B$BThe Tribunal are the librarians for the Titan discs, which are stored in this very room.$B$BLook! You can see the discs beneath the floor! We must hurry, the greatest discovery of Dwarven kind is just up ahead.','',26124),
(27618,'enUS','First we\'ll need to add a knotroot to the pot. Don\'t drag your feet, now....','',26124),
(27619,'enUS','Pitiful... just pitiful.','',26124),
(27620,'enUS','I\'ll send you on my flying machine. Keep your eyes peeled for clues about what might\'ve happened to Hemet!','',26124),
(27621,'enUS','WARNING: Missile lock detected. Engaging evasive maneuvers.','',26124),
(27622,'enUS','Rise and serve!','',26124),
(27623,'enUS','Now you will work off the offense of shooting down Kolramas for all eternity.','',26124),
(27624,'enUS','Death is no escape.','',26124),
(27625,'enUS','In the name of the Lich King.','',26124),
(27626,'enUS','Now you are in the Lich King\'s embrace.','',26124),
(27627,'enUS','Soon we will have the power of your gods!','',26124),
(27628,'enUS','Go forth and slay our enemies so that our army may grow.','',26124),
(27629,'enUS','Finally you know your true destiny.','',26124),
(27630,'enUS','Tastes like it needs more....','Tastes like it needs more....',26124),
(27631,'enUS','Could use a little...','Could use a little...',26124),
(27632,'enUS','Before it thickens, we must add...','Before it thickens, we must add...',26124),
(27633,'enUS','Quickly, get me some...','Quickly, get me some...',26124),
(27634,'enUS','Ahh, yes. I know just the thing...','Ahh, yes. I know just the thing...',26124),
(27635,'enUS','Yes, yes. Definitely needs more...','Yes, yes. Definitely needs more...',26124),
(27636,'enUS','I think it needs...','I think it needs...',26124),
(27637,'enUS','Find me some...','Find me some...',26124),
(27638,'enUS','','All of Northrend is colder than a witch\'s heart; yet here we are...  There must be some explanation!  Quite possibly one related to the crystal pillars!',26124),
(27639,'enUS','','The presence of titan architecture in this region is quite... interesting.',26124),
(27640,'enUS','','The similarities between this place and Un\'goro are uncanny.  Maybe the two are connected in some way.',26124),
(27641,'enUS','','How long until we can have another pilot airborne?  I need aerial surveys if my research is going to get anywhere.',26124),
(27642,'enUS','Scourge forces have been spotted near the King\'s Square fountain!','',26124),
(27643,'enUS','Scourge forces have been spotted near the Market Row Gate!','',26124),
(27644,'enUS','Scourge forces have been spotted near the Festival Lane Gate!','',26124),
(27645,'enUS','Scourge forces have been spotted near the Elder\'s Square Gate!','',26124),
(27646,'enUS','Scourge forces have been spotted near the Town Hall!','',26124),
(27647,'enUS','Knotroot!','Knotroot!',26124),
(27648,'enUS','Pickled Eagle Egg!','Pickled Eagle Egg!',26124),
(27649,'enUS','Speckled Guano!','Speckled Guano!',26124),
(27650,'enUS','Withered Batwing!','Withered Batwing!',26124),
(27651,'enUS','Seasoned Slider Cider!','Seasoned Slider Cider!',26124),
(27652,'enUS','Pulverized Gargoyle Teeth!','Pulverized Gargoyle Teeth!',26124),
(27653,'enUS','Muddy Mire Maggot!','Muddy Mire Maggot!',26124),
(27654,'enUS','Spiky Spider Egg!','Spiky Spider Egg!',26124),
(27655,'enUS','Hairy Herring Head!','Hairy Herring Head!',26124),
(27656,'enUS','Putrid Pirate Perspiration!','Putrid Pirate Perspiration!',26124),
(27657,'enUS','Icecrown Bottled Water!','Icecrown Bottled Water!',26124),
(27658,'enUS','Wasp\'s Wings!','Wasp\'s Wings!',26124),
(27659,'enUS','Prismatic Mojo!','Prismatic Mojo!',26124),
(27660,'enUS','Raptor Claw!','Raptor Claw!',26124),
(27661,'enUS','Amberseed!','Amberseed!',26124),
(27662,'enUS','Burning Ice!','Burning Ice!',26124),
(27663,'enUS','Shrunken Dragon\'s Claw!','Shrunken Dragon\'s Claw!',26124),
(27664,'enUS','Chilled Serpent Mucus!','Chilled Serpent Mucus!',26124),
(27665,'enUS','Crystallized Hogsnot!','Crystallized Hogsnot!',26124),
(27666,'enUS','Crushed Basilisk Crystals!','Crushed Basilisk Crystals!',26124),
(27667,'enUS','Trollbane!','Trollbane!',26124),
(27668,'enUS','Frozen Spider Ichor!','Frozen Spider Ichor!',26124),
(27669,'enUS','Destroy the Drakkari! Destroy the Argent Crusade! Make Scourge of them all!','',26124),
(27670,'enUS','My beautiful Kolramas! You will all pay dearly for this outrage!','',26124),
(27671,'enUS','Come fools, meet your doom! I\'m waiting.','',26124),
(27672,'enUS','Drakkari, this will not stop us from stealing the power of your wild gods. We will take it from them directly, or from you if you\'ve already killed them; it matters not.','',26124),
(27673,'enUS','Many Argent Dawn are numbered amongst the simpletons that have fallen before me. The Argent Crusade will prove no different.','',26124),
(27674,'enUS','If you kill them, I will simply reanimate their corpses. And when you die, I will do the same to you.','',26124),
(27675,'enUS','You cannot stand against the might of the Lich King, mortals!','',26124),
(27676,'enUS','Undeath is inevitable!','',26124),
(27677,'enUS','We need some...','We need some...',26124),
(27678,'enUS','It simply must have some...','It simply must have some...',26124),
(27679,'enUS','Next, we\'ll need...','Next, we\'ll need...',26124),
(27680,'enUS','Alright, now fetch me some...','Alright, now fetch me some...',26124),
(27681,'enUS','Almost finished! We still need...','Almost finished! We still need...',26124),
(27682,'enUS','Before it boils over, I need...','Before it boils over, I need...',26124),
(27683,'enUS','It\'s thickening! Quickly, get some...','It\'s thickening! Quickly, get some...',26124),
(27684,'enUS','Coming along nicely, but still needs...','Coming along nicely, but still needs...',26124),
(27685,'enUS','We\'re nearly there. Find me some...','We\'re nearly there. Find me some...',26124),
(27686,'enUS','Blast! You have failed me!','Blast! You have failed me!',26124),
(27687,'enUS','No! The serum is ruined!','No! The serum is ruined!',26124),
(27688,'enUS','You\'re too late. I must start again from the beginning....','You\'re too late. I must start again from the beginning....',26124),
(27689,'enUS','Burning Ice!','Burning Ice!',26124),
(27690,'enUS','Hmmm, I think it\'s time for...','Hmmm, I think it\'s time for...',26124),
(27691,'enUS','Useless pile of bones...','',26124),
(27693,'enUS','Even in undeath, you are useless.','',26124),
(27694,'enUS','Begone to your eternal torment.','',26124),
(27695,'enUS','You shall not enjoy this release.','',26124),
(27696,'enUS','Enough.','',26124),
(27697,'enUS','So the oracle has decided to aid you, outlander. Very well, I will offer you what I know.','',26124),
(27698,'enUS','Your companion seeks the shardhorn patriarch Farunn, who holds himself aloof from his brothers.','',26124),
(27699,'enUS','Farunn walks the lands north of what your people call the Bittertide Falls. You will find him alone, but you will see he requires no defenders.','',26124),
(27700,'enUS','Activating','Activating',26124),
(27701,'enUS','Return to your companion. Tell him to go forth and claim his prize in Farunn.','',26124),
(27702,'enUS','Once he has done so, tell him to leave this land in peace. He does not belong here.','',26124),
(27703,'enUS','I do not understand this fruit vendor or their ogre.  It seemed as though war was upon us... Yet nothing has happened.','I do not understand this fruit vendor or their ogre.  It seemed as though war was upon us... Yet nothing has happened.',26124),
(27704,'enUS','The fruit vendor has refused to accept my challenge and remove his cart.  Their ogre protector just sits and does nothing... What could his plan be?','The fruit vendor has refused to accept my challenge and remove his cart.  Their ogre protector just sits and does nothing... What could his plan be?',26124),
(27705,'enUS','We should sell these apples, but we will not allow peole to eat them.  Oh no!  We will sell apples to our friends, and they shall bring the fight to the fruit vendor for me!','We should sell these apples, but we will not allow peole to eat them.  Oh no!  We will sell apples to our friends, and they shall bring the fight to the fruit vendor for me!',26124),
(27706,'enUS','My army has not arrived.  I knew I could not trust the people I hired.  We will recruit new people.  We will sell these apples and our new army will crush them!','My army has not arrived.  I knew I could not trust the people I hired.  We will recruit new people.  We will sell these apples and our new army will crush them!',26124),
(27707,'enUS','It\'s time to deal with this fruit situtation on our terms.  We\'ve been far too accomidating to the fruit vendor.  Now we will simply sell the fruit.  But the fruit will not be for people to eat.  I forbid it!  No one will eat our fruit!','It\'s time to deal with this fruit situtation on our terms.  We\'ve been far too accomidating to the fruit vendor.  Now we will simply sell the fruit.  But the fruit will not be for people to eat.  I forbid it!  No one will eat our fruit!',26124),
(27708,'enUS','FRUIT VENDOR!!! Your cart is still in our way!  Your time is up!  You have new competition in selling fruit!','FRUIT VENDOR!!! Your cart is still in our way!  Your time is up!  You have new competition in selling fruit!',26124),
(27709,'enUS','YOU HAVE RUN OUT OF TIME FRUIT VENDOR!!  NOW I WILL SELL YOUR ROTTEN FRUIT!','YOU HAVE RUN OUT OF TIME FRUIT VENDOR!!  NOW I WILL SELL YOUR ROTTEN FRUIT!',26124),
(27710,'enUS','HA!  I CRUSHED AN APPLE, FRUIT VENDOR! NOW,  YOUR APPLES WILL BE SOLD TO OTHERS FOR THEM TO CRUSH AS WELL!','HA!  I CRUSHED AN APPLE, FRUIT VENDOR! NOW,  YOUR APPLES WILL BE SOLD TO OTHERS FOR THEM TO CRUSH AS WELL!',26124),
(27711,'enUS','IF WAR IS WHAT YOU WANT, WAR IS WHAT YOU SHALL GET, FRUIT VENDOR!  WE WILL SEE WHO SELLS MORE OF YOUR APPLES!','IF WAR IS WHAT YOU WANT, WAR IS WHAT YOU SHALL GET, FRUIT VENDOR!  WE WILL SEE WHO SELLS MORE OF YOUR APPLES!',26124),
(27712,'enUS','Drink, mortals!  Taste my blood!  Taste your death!','Drink, mortals!  Taste my blood!  Taste your death!',26124),
(27713,'enUS','I will suffer your presence no longer. Begone. Find someone else to extort.','',26124),
(27714,'enUS','The last thing that we needed was for the crazy Drakkari trolls to shoot down a Scourge necropolis in our backyard.$B$BHow did they manage to do that?!','',26124),
(27715,'enUS','','Ugh, I should never have volunteered to be a specialist. They always ask us to do the impossible!',26124),
(27716,'enUS','Play time!','',26124),
(27717,'enUS','You are too late, champion of Lordaeron. The dead shall have their day.','',26124),
(27718,'enUS','Hurry, $c!$b$bPut the ingredients directly in the pot. Time is of the essence!','',26124),
(27719,'enUS','Oops I tripped some sort of alarm! I can fix this, just cover my back! [PH]','',26124),
(27720,'enUS','Oh no, another face activated! [PH]','',26124),
(27721,'enUS','The last face is active, be careful! I am almost done, keep them back! [PH]','',26124),
(27722,'enUS','I got it! That should take care of it! [PH]','',26124),
(27723,'enUS','<The captive crocolisk lets out a low growl as you approach.>','',26124),
(27724,'enUS','You look safe enough... let\'s do this.','You look safe enough... let\'s do this.',26124),
(27725,'enUS','','Excellent day for a foray into the field wouldn\'t you say, $g sir : ma\'am;?',26124),
(27726,'enUS','Yes, yes, we should do whatever we can to help them.','',26124),
(27727,'enUS','Longrunner, your fodder... err, people will be a valuable resource against the vrykul. Did I say resource? I meant, \'ally.\' \n','',26124),
(27729,'enUS','No! Keep that thing away from my zeppelin!','',26124),
(27730,'enUS','Sir, yes sir!','',26124),
(27731,'enUS','%s sniffs the air, catching the scent of something unusual.','',26124),
(27732,'enUS','<Reach down and pull the Injured Rainspeaker Oracle to its feet.>','<Reach down and pull the Injured Rainspeaker Oracle to its feet.>',26124),
(27733,'enUS','Crusader! Take this wood and light a fire for the troops.','',26124),
(27734,'enUS','','Oh, these are sticky! I wonder how they shoot the webbing?',26124),
(27735,'enUS','','ACK! Oh no, I webbed myself! It\'s sticky. MY HAIR!',26124),
(27736,'enUS','','Okay! Let me just see if I can fashion these disgusting parts into something useful.',26124),
(27737,'enUS','','Eureka!',26124),
(27738,'enUS','Shaman Vekjik comes out of the underbrush nearby.','',26124),
(27739,'enUS','You help Rainspeaker! I saw you help Rainspeaker! Traitor thing!','',26124),
(27740,'enUS','If you want to be friends with big-tongues, you not friends with Frenzyheart! I tell village! We no trust you anymore!','',26124),
(27741,'enUS','Shaman Vekjik scurries off towards Frenzyheart Hill.','',26124),
(27742,'enUS','You must be one of the brave soldiers who have been fighting the Scourge forces of Mal\'Ganis. Well done.','',26124),
(27743,'enUS','Indeed. Mal\'Ganis is commanding the Scourge from Crusaders\' Square, but the gates leading there from the city entrance are closed.$B$BLittle does he know that a small force can still reach the Square by moving through the Town Hall. Will you join me in this attack?','',26124),
(27744,'enUS','We\'re only doing what is best for Lordaeron, your Highness.','We\'re only doing what is best for Lordaeron, your Highness.',26124),
(27745,'enUS','Lead the way, Prince Arthas.','Lead the way, Prince Arthas.',26124),
(27746,'enUS','Now we will see why this ore is so important to the Scourge.','',26124),
(27747,'enUS','Korfax, what can you tell from this saronite?','',26124),
(27748,'enUS','Never heard of it. Looks like pure evil.','',26124),
(27749,'enUS','Let\'s see how it holds up to the might of my axe!','',26124),
(27750,'enUS','What the? My reaper didn\'t even scratch it! That\'s the toughest ore I\'ve ever seen!','',26124),
(27751,'enUS','Home time!','Home time!',26124),
(27752,'enUS','Thanks!','Thanks!',26124),
(27753,'enUS','Home not far. Come!','Home not far. Come!',26124),
(27754,'enUS','Ahh! It\'s coming right for us!','',26124),
(27755,'enUS','Not the \'stache! Now I\'m asymmetrical!','',26124),
(27756,'enUS','My ear! You grazed my ear!','',26124),
(27757,'enUS','Ouch! That\'s it, I quit the target business!','',26124),
(27758,'enUS','No! That was my good side!','',26124),
(27759,'enUS','Rayne, Rimblat, what about the power of nature and the elements?','',26124),
(27760,'enUS','The avenger snorts, clearly unimpressed.','',26124),
(27761,'enUS','Calm down, lad, it\'s just birdshot!','',26124),
(27762,'enUS','Bah, it\'s an improvement.','',26124),
(27763,'enUS','','By the Goddess. It\'s as if Nature can\'t touch it!',26124),
(27764,'enUS','Stop whining. You\'ve still got your luck.','',26124),
(27765,'enUS','The only thing hurt is your pride, lad. Buck up!','',26124),
(27766,'enUS','Nothing.','',26124),
(27767,'enUS','Metz?','',26124),
(27768,'enUS','You know what.','',26124),
(27769,'enUS','No surprise there.','',26124),
(27770,'enUS','What?','',26124),
(27771,'enUS','Fine. Just remember though, the power of the Holy Light isn\'t something to be invoked casually, brother.','',26124),
(27772,'enUS','What\'s it doing?!','',26124),
(27774,'enUS','Clearly this is getting us nowhere. We need to get this saronite to Highlord Fordring for further study.','',26124),
(27775,'enUS','Thank you for trying, my friends. We\'ll unlock its secrets. Hopefully before it\'s too late.','',26124),
(27776,'enUS','%s grunts.','',26124),
(27777,'enUS','Surely you can see the futility of it all!','',26124),
(27778,'enUS','Good shot!','',26124),
(27779,'enUS','Saronite you say?','',26124),
(27780,'enUS','I smell... $r.  Delicious!','',26124),
(27781,'enUS','I shall consume you!','',26124),
(27782,'enUS','Drums of War','Drums of War',26124),
(27783,'enUS','Let us see if it is truly impervious.','',26124),
(27784,'enUS','%s rolls his eyes.','',26124),
(27785,'enUS','The Injured Rainspeaker Oracle rises clumsily to its feet.','The Injured Rainspeaker Oracle rises clumsily to its feet.',26124),
(27786,'enUS','','Gah!',26124),
(27787,'enUS','Whoa!','',26124),
(27788,'enUS','Oof!','',26124),
(27789,'enUS','%s dusts himself off.','',26124),
(27790,'enUS','NO!','NO!',26124),
(27791,'enUS','Help me!','Help me!',26124),
(27792,'enUS','Somebody help!','Somebody help!',26124),
(27793,'enUS','Shoot it down!','Shoot it down!',26124),
(27794,'enUS','Light save me!','Light save me!',26124),
(27795,'enUS','Let me go!','Let me go!',26124),
(27796,'enUS','Help!','Help!',26124),
(27797,'enUS','Gah!','Gah!',26124),
(27798,'enUS','Dumb big-tongue lover! You not friend of Frenzyheart no more. Frenzyheart will get you good.','',26124),
(27799,'enUS','Oh no! Some puppy-men followed!','Oh no! Some puppy-men followed!',26124),
(27800,'enUS','Follow me, I know the way through.','',26124),
(27801,'enUS','Sir, our customers are complaining that there\'s not enough Maiden\'s Anguish in our Deadly Poisons.','',26124),
(27802,'enUS','Sir, our customers are complaining that there\'s too much Deathweed in our Anesthetics.','',26124),
(27803,'enUS','Sir, I think we were close with the Lethargy Root in that last poison recipe.','',26124),
(27804,'enUS','Wright, have you finished that new concoction you\'ve been working on? I\'m tired of these spores filling up my shop!','',26124),
(27805,'enUS','Then put twice as much in next time!','',26124),
(27806,'enUS','Only put half as much in next time.','',26124),
(27807,'enUS','Remember, kid: You\'re always more wrong than you think you are. Double It!','',26124),
(27808,'enUS','I\'m working on it, I just don\'t want to sell it until I\'m happy with it. It shouldn\'t be long.','',26124),
(27809,'enUS','Skadi the Ruthless is within range of the harpoon launchers!','',26124),
(27810,'enUS','That\'s what you always say. Sometimes I think you\'re never going to finish that thing.','',26124),
(27811,'enUS','Ah, you\'ve finally arrived Prince Arthas. You\'re here just in the nick of time.','Ah, you\'ve finally arrived Prince Arthas. You\'re here just in the nick of time.',26124),
(27812,'enUS','Yes, I\'m glad I could get to you before the plague.','',26124),
(27813,'enUS','Ooh! Shinies!','',26124),
(27814,'enUS','What is this sorcery?','',26124),
(27815,'enUS','There\'s no need for you to understand, Arthas. All you need to do is die.','There\'s no need for you to understand, Arthas. All you need to do is die.',26124),
(27816,'enUS','The Horde has captured Wintergrasp Fortress!','',26124),
(27817,'enUS','The Alliance has captured Wintergrasp Fortress!','',26124),
(27818,'enUS','','If you\'ve got somewhere to go, I can get you there.',26124),
(27819,'enUS','Do you think I could take a ride on one of those flying machines?','Do you think I could take a ride on one of those flying machines?',26124),
(27820,'enUS','Kara, I need to be flown out to the Dens of Dying to find Bixie.','Kara, I need to be flown out to the Dens of Dying to find Bixie.',26124),
(27821,'enUS','Taunt Flag','Taunt Flag',26124),
(27822,'enUS','Bear Mount','Bear Mount',26124),
(27823,'enUS','I am ready to travel to your village now.','I am ready to travel to your village now.',26124),
(27824,'enUS','We wait until you ready.','',26124),
(27825,'enUS','Let us know when you ready.','',26124),
(27826,'enUS','You tell us when it home time.','',26124),
(27827,'enUS','Bg\'grrml brgl brm!','',26124),
(27828,'enUS','Let me out of here, $r!','',26124),
(27829,'enUS','So long, suckers. I\'m out of here!','',26124),
(27830,'enUS','I made it. Freedom at last!','',26124),
(27831,'enUS','You hear a low guttural growl from nearby.','',26124),
(27832,'enUS','Party G.R.E.N.A.D.E.','Party G.R.E.N.A.D.E.',26124),
(27833,'enUS','Vekjik no want to be bothered.','',26124),
(27834,'enUS','Shaman Vekjik, I have spoken with the big-tongues and they desire peace. I have brought this offering on their behalf.','Shaman Vekjik, I have spoken with the big-tongues and they desire peace. I have brought this offering on their behalf.',26124),
(27835,'enUS','Disgusting big-tongue friend, you no belong here. Go from Frenzyheart land or I call magic stuffs to kill you!','',26124),
(27836,'enUS','Frenzyheart never be friends of big-tongues. You dumb to come back here traitor thing!','',26124),
(27837,'enUS','Frenzyheart kill you if you come back. You no welcome here no more!','',26124),
(27838,'enUS','No no... I had no intentions of betraying your people. I was only defending myself. It was all a misunderstanding.','No no... I had no intentions of betraying your people. I was only defending myself. It was all a misunderstanding.',26124),
(27839,'enUS','Incoming $r flier! Shoot $g him : her; down!','',26124),
(27840,'enUS','Mal\'Ganis appears to have more than Scourge in his arsenal. We should make haste.','',26124),
(27841,'enUS','A masterpiece! Feed it to the troll, Hordum. He\'ll answer any question truthfully....','',26124),
(27842,'enUS','\'Bout time, Finklestein. Now, let\'s put this stuff to the test!','',26124),
(27843,'enUS','Arrite, troll. Down the hatch!','',26124),
(27844,'enUS','Don\'tcha make me get rough wit yeh, troll.','',26124),
(27845,'enUS','Hmm, fair enough, troll. Can\'t be any worse than the grog they serve around here...','',26124),
(27846,'enUS','There. Now drink up!','',26124),
(27847,'enUS','As a member of the Argent Crusade, I\'ve sworn an oath to set aside past grudges in the name of... gah - ungh....','',26124),
(27848,'enUS','I can\'t hardly stand the sight o\' them green-skinned savages!','',26124),
(27849,'enUS','They\'re ugly, they smell, they eat with their mouths open, and... ooof!','',26124),
(27850,'enUS','','You will be my salvation.$B$BYou may yet be my demise.',26124),
(27851,'enUS','You gotta be kiddin\' me, mon! I ain\'t about to be drinkin\' that muck...','',26124),
(27852,'enUS','Tell ya what, mon. You take a little taste so I know ya ain\'t tryin\' ta poison me. Then I\'ll drink.','',26124),
(27853,'enUS','Alright, mon. A deal be a deal. But first, just a little question....','',26124),
(27854,'enUS','How ya really be feelin\' about workin\' so closely wit orcs?','',26124),
(27855,'enUS','','What!?',26124),
(27856,'enUS','Where am I? What is this place?','Where am I? What is this place?',26124),
(27857,'enUS','I... I have awoken to a nightmare?','I... I have awoken to a nightmare?',26124),
(27858,'enUS','Who... who are you? Who... what am I?','Who... who are you? Who... what am I?',26124),
(27859,'enUS','I hurt... suffering unbearable... end my pain... I beg of you!','I hurt... suffering unbearable... end my pain... I beg of you!',26124),
(27860,'enUS','Dagnabbit, Hordum! Now I must cook up a whole new batch!','',26124),
(27861,'enUS','Another failure...','',26124),
(27862,'enUS','Useless...','',26124),
(27863,'enUS','I smell its fear...','',26124),
(27864,'enUS','This one has awoken too soon. It retains emotion and memory...','',26124),
(27865,'enUS','Pathetic...','',26124),
(27866,'enUS','You have been measured and found wanting...\n','',26124),
(27867,'enUS','Dispose of it...\n','',26124),
(27868,'enUS','Marvel at its tenacity and vigor! A champion has been found!','',26124),
(27869,'enUS','The Lich King will be pleased with this initiate.','',26124),
(27870,'enUS','Amidst the wretch, a champion has been found.','',26124),
(27871,'enUS','CHAOS! DOOM! DESTRUCTION! This one will claim them all!','',26124),
(27872,'enUS','A harbinger of death is reborn...','',26124),
(27873,'enUS','Place upon it the trappings befitting a herald of Arthas.\n','',26124),
(27874,'enUS','Yes, instructor.','Yes, instructor.',26124),
(27875,'enUS','Rise, minions. Rise and feast upon the weak!','Rise, minions. Rise and feast upon the weak!',26124),
(27876,'enUS','This one...\n','',26124),
(27877,'enUS','Dark energy courses through me... Such power! I hunger for more!','Dark energy courses through me... Such power! I hunger for more!',26124),
(27878,'enUS','Reborn, I shall become an instrument of doom...','Reborn, I shall become an instrument of doom...',26124),
(27879,'enUS','The voice... such splendor... Arthas... My king....','The voice... such splendor... Arthas... My king....',26124),
(27880,'enUS','I return from the grave to do my master\'s bidding.','I return from the grave to do my master\'s bidding.',26124),
(27881,'enUS','Right away, instructor.','Right away, instructor.',26124),
(27882,'enUS','More vile sorcery! Be ready for anything!','',26124),
(27883,'enUS','Stand and be measured! Rise, for your master awaits your arrival. Go now!\n','',26124),
(27884,'enUS','Listen, death knight... Listen for the voice of your master. He calls to you now.\n','Listen, death knight... Listen for the voice of your master. He calls to you now.\n',26124),
(27885,'enUS','As you command, instructor!','As you command, instructor!',26124),
(27886,'enUS','I live only to serve the Lich King!','I live only to serve the Lich King!',26124),
(27887,'enUS','Victory to the Scourge!','Victory to the Scourge!',26124),
(27888,'enUS','Death to all that oppose us!','Death to all that oppose us!',26124),
(27889,'enUS','Let\'s move on.','',26124),
(27890,'enUS','ugh...','ugh...',26124),
(27891,'enUS','Avenge me!','Avenge me!',26124),
(27892,'enUS','I am... finished.','I am... finished.',26124),
(27893,'enUS','My treasure! You no steal from Tartek, dumb big-tongue traitor thing.','',26124),
(27894,'enUS','It\'s too late for me.','It\'s too late for me.',26124),
(27895,'enUS','Tartek and nasty dragon going to kill you! You so dumb.','',26124),
(27896,'enUS','I\'m saved!','I\'m saved!',26124),
(27897,'enUS','I thought I was done for!','I thought I was done for!',26124),
(27898,'enUS','Thank you!','Thank you!',26124),
(27899,'enUS','I am in your debt, friend.','I am in your debt, friend.',26124),
(27900,'enUS','Have you ever seen drakes like the ones around here? Makes for perfect hunting.','',26124),
(27901,'enUS','Watch your backs: they have us surrounded in this hall.','',26124),
(27902,'enUS','Mal\'Ganis is not making this easy.','',26124),
(27903,'enUS','%s begins to cast Empowered Arcane Explosion!','',26124),
(27904,'enUS','They\'re very persistent.','',26124),
(27905,'enUS','What else can he put in my way?','',26124),
(27906,'enUS','The quickest path to Mal\'Ganis lies behind that bookshelf ahead.','',26124),
(27907,'enUS','Keep him weak!','Keep him weak!',26124),
(27908,'enUS','If Rhunok regains his strength, we all die!','If Rhunok regains his strength, we all die!',26124),
(27909,'enUS','The bear god must be kept enfeebled so that the prophet can finish the ritual.','The bear god must be kept enfeebled so that the prophet can finish the ritual.',26124),
(27910,'enUS','There are intruders about. Slay them before they ruin everything!','There are intruders about. Slay them before they ruin everything!',26124),
(27911,'enUS','Prince Arthas Menethil, on this day, a powerful darkness has taken hold of your soul. The death you are destined to visit upon others will this day be your own.','',26124),
(27912,'enUS','This is it, I just know it...','',26124),
(27913,'enUS','That boat is going to hit me for sure...','',26124),
(27914,'enUS','I can\'t look...','',26124),
(27915,'enUS','Can\'t they go a little slower?','',26124),
(27916,'enUS','I do what I must for Lordaeron, and neither your words nor your actions will stop me.','',26124),
(27917,'enUS','It\'s coming right for me!','',26124),
(27918,'enUS','It\'s not slowing down!','',26124),
(27919,'enUS','OH NO!','',26124),
(27920,'enUS','We\'ll see about that, young prince.','',26124),
(27921,'enUS','Look out!','',26124),
(27922,'enUS','It\'s all over...','',26124),
(27923,'enUS','I never got to tell my son how proud I am of him...','',26124),
(27924,'enUS','I\'m not ready to die...','',26124),
(27925,'enUS','There\'s so much I still wanted to do...','',26124),
(27926,'enUS','Did you hear something?','',26124),
(27927,'enUS','What is that sound?','',26124),
(27928,'enUS','Put a muzzle on that damned sword, Mograine. I am sick and tired of its incessant whining.','',26124),
(27929,'enUS','Shut that thing up! I cannot think with that sword blabbering nonstop!','',26124),
(27930,'enUS','I\'m sorry, our brews are exclusive to members of the \"Brew of the Month Club.\"','I\'m sorry, our brews are exclusive to members of the \"Brew of the Month Club.\"',26124),
(27931,'enUS','This post is secure, $r.$b$bThe enemy has been cleared from the area for some time now.','',26124),
(27932,'enUS','','The Scourge spread so rapidly, I often find myself wondering why they haven\'t already won this war.',26124),
(27933,'enUS','Ahh,  Back in Drak\'Tharon at last!','',26124),
(27934,'enUS','Drakuru casts his gaze down on Drak\'Tharon Keep.','',26124),
(27935,'enUS','Ya done well, mon....','',26124),
(27942,'enUS','Hah! Zepik right, big-tongues is the great hunt!','',26124),
(27943,'enUS','Killing big-tongues is fun! Goregek should go with slave thing more often!','',26124),
(27944,'enUS','Maybe Kartak come soon and eat whole village! Hah!','',26124),
(27945,'enUS','Bristlepine harder hunt than this! Dumb big-tongues.','',26124),
(27946,'enUS','Goregek best hunter, huh slave thing?','',26124),
(27947,'enUS','Try speartouched! Hah! Goregek so funny.','',26124),
(27954,'enUS','Ya surpassed my greatest hopes.','',26124),
(27955,'enUS','Wasp things fly where Goregek can\'t hit them.','',26124),
(27956,'enUS','This is Dajik\'s hunt. Let\'s go, slave thing.','',26124),
(27957,'enUS','No bristlepine here, let\'s go somewhere else.','',26124),
(27958,'enUS','Look, slave thing... Goregek got stung by big bad wasp queen once. Goregek all done with wasps.','',26124),
(27961,'enUS','Goregek like killing big-tongues, but there too many here, slave thing.','',26124),
(27962,'enUS','Not safe here, slave thing. This big-tongue home.','',26124),
(27963,'enUS','Frenzyheart not come here alone. Slave thing should not either.','',26124),
(27964,'enUS','You lure them out, slave thing. I stay here and watch. Good show.','',26124),
(27965,'enUS','Elder maybe says other stuff, but you always be slave thing to Goregek.','',26124),
(27966,'enUS','Why you just sit around? Get to work, slave thing!','',26124),
(27967,'enUS','You\'ll never be as good as Goregek.','',26124),
(27968,'enUS','Goregek the only good bristlepine hunter!','',26124),
(27969,'enUS','Pitch was weakling anyway... why else you think Goregek not bother with him?','',26124),
(27970,'enUS','You useless. Goregek not know why he bother with you.','',26124),
(27971,'enUS','Goregek slay so many bristlepine that he could fill River\'s Heart!','',26124),
(27972,'enUS','Goregek wonder if there more bristlepine over mountains. One day, Goregek will go see.','',26124),
(27973,'enUS','No bristlepine at broken pillar, just dead stuff. Goregek leaving, slave thing.','',26124),
(27974,'enUS','If slave thing want to be dead, slave thing keep going to broken pillar. Goregek go away and be not dead.','',26124),
(27975,'enUS','Why go to broken pillar? You dumb, slave thing. Goregek go.','',26124),
(27976,'enUS','Only dead things here. Goregek leaving.','',26124),
(27977,'enUS','Goregek never seen Kartak yet. Goregek not think he has bad as others say.','',26124),
(27978,'enUS','Rakjak say Kartak once ate whole village of big-tongues. They must be tasty.','',26124),
(27979,'enUS','Stay away from Kartak mouth, slave thing. He maybe eat you too.','',26124),
(27980,'enUS','Long time ago, Kartak came to Frenzyheart from mountains. Rakjak fed Kartak big-tongue slaves so now Kartak not eat Frenzyheart.','',26124),
(27981,'enUS','Frenzyheart feed Kartak big-tongues so Kartak not eat us. That why we smarter than you, slave thing.','',26124),
(27982,'enUS','Maybe Frenzyheart should feed you to Kartak, slave thing.','',26124),
(27983,'enUS','Frenzyheart the strongest!','',26124),
(27984,'enUS','Home! You better have brought back meat for Goregek, slave.','',26124),
(27985,'enUS','Goregek go get drink. You sit in corner til Goregek ready.','',26124),
(27986,'enUS','Goregek hungry. Go get on fire spit, slave thing. Tell Goregek when you well roasted.','',26124),
(27987,'enUS','You wait until Goregek ready.','',26124),
(27988,'enUS','Goregek get some sleep. Go bring foodstuffs back, slave thing.','',26124),
(27990,'enUS','There was hundreds of times these hardknuckles before Goregek.','',26124),
(27991,'enUS','Hardknuckles still walk on hands... seem kind of dumb to Goregek.','',26124),
(27992,'enUS','You just watch slave thing, Goregek take care of these hardknuckles!','',26124),
(27993,'enUS','Better not get in Goregek\'s way!','',26124),
(27994,'enUS','You just get yourself beat up! Hah! You so dumb, slave thing.','',26124),
(27995,'enUS','Careful slave thing, the big bad softnuckles might eat you! Hah!','',26124),
(28002,'enUS','Disgusting big-tongue thing! What it doing here?!','',26124),
(28003,'enUS','Kill the big-tongue, slave thing!','',26124),
(28004,'enUS','Hold Goregek back, slave thing! I going to beat up big-tongue bad! Hold Goregek back!','',26124),
(28005,'enUS','It stinks of big-tongue around here.','',26124),
(28006,'enUS','Ah! Look! Goregek can start big-tongue necklace!','',26124),
(28007,'enUS','Mmm, slave thing... I wonder what roasted big-tongue tastes like.','',26124),
(28008,'enUS','%s plants the Flag of Ownership in the corpse of $n.','%s plants the Flag of Ownership in the corpse of $n.',26124),
(28009,'enUS','Hah! Goregek\'s kill!','',26124),
(28010,'enUS','You should help next time, slave thing. Don\'t leave all work to Goregek.','',26124),
(28011,'enUS','Goregek best hunter... ever.','',26124),
(28012,'enUS','I stabbed it in the face! Goregek so good.','',26124),
(28013,'enUS','It not even see Goregek coming.','',26124),
(28014,'enUS','You going to help fight too or you just sit there, slave thing?','',26124),
(28015,'enUS','Why Goregek even bring you. You useless.','',26124),
(28016,'enUS','Next time, maybe Goregek let you try.','',26124),
(28017,'enUS','The Alliance tower was destroyed!','',26124),
(28018,'enUS','The Horde tower was destroyed!','',26124),
(28019,'enUS','','It is through the power of the unholy that we command death itself!',26124),
(28020,'enUS','I seek training, Lady Alistra.','I seek training, Lady Alistra.',26124),
(28021,'enUS','The blood is life... And as easily as the ebb and flow of blood is controlled, so too is the life of our enemies.','',26124),
(28022,'enUS','I seek training, Lord Thorval.','I seek training, Lord Thorval.',26124),
(28023,'enUS','We are what the cold wind carries. The icy chill of despair... The cold embrace of death...','',26124),
(28024,'enUS','I seek training, Amal\'thazad.','I seek training, Amal\'thazad.',26124),
(28025,'enUS','You leave your material body behind!','You leave your material body behind!',26124),
(28026,'enUS','What a fight you missed, Dorian! It was one for the ages!','',26124),
(28027,'enUS','There we were, riding into battle at full speed on the back of Stampy...','',26124),
(28028,'enUS','Everything was shaking all over the place. I could hardly steady my gun.','',26124),
(28029,'enUS','And then we saw her, the fearsome beast!','',26124),
(28030,'enUS','It took all of $n\'s skill to maintain control of Stampy.','',26124),
(28031,'enUS','It saddens all of us to see the Drakkari destroying themselves this way.$B$BThe power that they gain from killing the natural gods of the land is transitory.$B$BWhat is gained in the short run will be lost to them for all eternity.','',26124),
(28032,'enUS','The battle was a haze of blood, lead, and sweat. The broodmother\'s attacks came faster and faster!','',26124),
(28033,'enUS','But, in the end, $n and I prevailed through our wits and teamwork. And now we have this glorious trophy as a memento of our victory.','',26124),
(28034,'enUS','Your efforts... are in vain.','',26124),
(28035,'enUS','Such is the fate of all who oppose the Lich King!','',26124),
(28036,'enUS','Do I detect a bit of jealousy, Dorian?','',26124),
(28037,'enUS','Well, I don\'t know. I was here tending the fire and discussing the drawbacks of cogs with Zootfizzle. That\'s pretty epic, too, in its own way.','',26124),
(28038,'enUS','Gather your senses quickly, we must press on.','',26124),
(28039,'enUS','I\'m ready.','I\'m ready.',26124),
(28040,'enUS','This will only take a moment.','',26124),
(28041,'enUS','I\'m relieved this secret passage still works.','',26124),
(28043,'enUS','This isn\'t getting any easier. Stratholme is burning. We must brave the Scourge and the flames to reach Mal\'Ganis. Prepare yourselves.','',26124),
(28044,'enUS','For Lordaeron!','For Lordaeron!',26124),
(28045,'enUS','Rest a moment and clear your lungs, but we must move again soon.','',26124),
(28046,'enUS','','Zim\'Torga is able to provide us with a certain level of protection, but she has been greatly weakened by the presence of the Scourge and the actions of the Drakkari.$B$BIt falls to me and Ahunae to see to the rest of our defenses.',26124),
(28047,'enUS','That\'s enough; we must move again. Mal\'Ganis awaits.','',26124),
(28048,'enUS','At last some good luck. Market Row has not caught fire yet. Mal\'Ganis is supposed to be in Crusaders\' Square, which is just ahead. Tell me when you\'re ready to move forward.','',26124),
(28049,'enUS','','Now go, my friend. Thank you.',26124),
(28050,'enUS','','Zim\'Torga must be defended lest the Drakkari foolishly steal her power as well.',26124),
(28051,'enUS','','From the earth you arose. To the earth you shall return.',26124),
(28052,'enUS','','We are honored by your sacrifice.',26124),
(28053,'enUS','Lure it into the trap!','',26124),
(28054,'enUS','','The Drakkari must not be allowed to break through the defenses.',26124),
(28055,'enUS','','This is as strong as I can make you. Fight well, my earthen friend.',26124),
(28056,'enUS','Get out of way silly slave thing! Goregek\'s kill!','',26124),
(28057,'enUS','Hah! Goregek the greatest hunter ever! Goregek get biggest hardknuckle!','',26124),
(28058,'enUS','That how it done, slave thing. Maybe you figure out how someday.','',26124),
(28059,'enUS','Revenge is Goregek\'s! Teach dumb hardknuckle to knockdown Goregek from behind.','',26124),
(28060,'enUS','Time for food!','',26124),
(28061,'enUS','Goregek hungry.','',26124),
(28062,'enUS','You wait, slave thing. Goregek eating.','',26124),
(28063,'enUS','Go kill more stuff while Goregek eat.','',26124),
(28064,'enUS','Chicken! So delicious!','',26124),
(28065,'enUS','Gorgek gonna catch chicken good!','',26124),
(28066,'enUS','Slave thing! Go get chicken for Goregek!','',26124),
(28067,'enUS','No worry chicken. Goregek not going to put you in fire. Goregek nice wolvar.','',26124),
(28068,'enUS','Squeal! Squeal! So good!','',26124),
(28069,'enUS','Run away softknuckle! Goregek gonna get you!','',26124),
(28070,'enUS','Aww! So scared!','',26124),
(28071,'enUS','Run away dumb softknuckle! We gonna poke you more!','',26124),
(28072,'enUS','Ahunae\'s axe will be the end of the Drakkari.$B$BYou be takin\' care of any that get past my axe!','',26124),
(28073,'enUS','This looks like a good perch. Mark the target and signal me when you\'ve sighted the broodmother and are ready to attack.','',26124),
(28074,'enUS','Here, beastie. Come to Hemet!','',26124),
(28075,'enUS','Take that, beastie!','',26124),
(28076,'enUS','How d\'you like that one, eh?','',26124),
(28077,'enUS','Eat lead!','',26124),
(28078,'enUS','The bigger they are, the harder they fall.','',26124),
(28079,'enUS','The trickster Mage-Lord Urom protects the third ring.  He will appear alone and defenseless, but do not be fooled by appearances!  Urom is a powerful conjurer who commands a menagerie of Phantasmal creatures.  Seek him out above.','',26124),
(28080,'enUS','The trickster Mage-Lord Urom protects the third ring.  He will appear alone and defenseless, but do not be fooled by appearances!  Urom is a powerful conjurer who commands a menagerie of Phantasmal creatures.  Seek him out above.\n\nI can grant you the power to call upon a drake from the red flight.  Speak to Eternos or Verdisa if you prefer to draw on the power of the bronze or the green.','',26124),
(28081,'enUS','Your greatest challenge lies ahead.  Ley-Guardian Eregos is a Blue dragon of immense power. You will find him flying above the uppermost ring. \n\nThe full power of your drakes has been unlocked.  Use their power to defeat Eregos!','',26124),
(28082,'enUS','You have wrested control of the Oculus from the forces of Malygos.  The red flight is in your debt.','',26124),
(28083,'enUS','The bronze flight is in your debt.','',26124),
(28084,'enUS','','The green flight is in your debt.',26124),
(28085,'enUS','What abilities do ruby drakes have?','What abilities do ruby drakes have?',26124),
(28086,'enUS','What abilities do amber drakes have?','What abilities do amber drakes have?',26124),
(28087,'enUS','What abilities do emerald drakes have?','What abilities do emerald drakes have?',26124),
(28088,'enUS','What is the ultimate ability of the Ruby Drake?','What is the ultimate ability of the Ruby Drake?',26124),
(28089,'enUS','What is the ultimate ability of the amber drake?','What is the ultimate ability of the amber drake?',26124),
(28090,'enUS','What is the ultimate ability of the emerald drake?','What is the ultimate ability of the emerald drake?',26124),
(28091,'enUS','Ruby drakes excel at mitigating damage and protecting their allies.\n\nUsing searing wrath, they can breathe streams of liquid fire that jump from target to target, dealing increasing damage with each jump.\n\nWhenever a ruby drake is damaged by an enemy attack, it gains an evasive charge.  These charges can be used to perform a series of evasive maneuvers, allowing the drake to dodge incoming attacks and spells for a time.','',26124),
(28092,'enUS','Amber drakes excel at dealing damage by manipulating time to their advantage.\n\nUsing shock lance, they can disrupt the flow of time around an enemy target, instantly damaging it.  The power of this effect is dramatically increased by shock charges on the target.\n\nWhen threatened, an amber drake can briefly stop the flow of time for its enemies.  This time disruption stores a large amount of shock energy on affected targets in the form of shock charges.','',26124),
(28093,'enUS','','Emerald drakes excel at healing themselves while poisoning their enemies.\n\nUsing leeching poison, they can steal health from their enemies.  Repeated applications of this poison can increase the effect.\n\nWith touch the nightmare, emerald drakes can reach into the Dream, converting a portion of their life energy into a highly damaging attack that leaves the target weakened, reducing its damage for a short time.',26124),
(28094,'enUS','A Ruby Drake at full power can perform Martyr, which shields friendly targets by redirecting all hostile magic to the Ruby Drake for a short time.  Evasive Maneuvers can still be performed during Martyr.','',26124),
(28095,'enUS','An amber drake at full power can perform temporal rift, which creates a bubble of compressed time around an enemy.  Spells that pass through the bubble deal double damage and can generate shock charges on the target.','',26124),
(28096,'enUS','','An emerald drake at full power can perform dream funnel, which transfers the drake\'s own life energy to a friendly target, healing it.  Leeching poison can be used to restore health lost when using this ability.',26124),
(28097,'enUS','M-mistress... may I p-polish your armor...?','',26124),
(28098,'enUS','M-mistress... might I b-brush your mighty steed...?','',26124),
(28099,'enUS','M-mistress... does your axe n-need sharpening...?','',26124),
(28100,'enUS','M-mistress... did you n-need more corpse dust, p-perhaps...?','',26124),
(28101,'enUS','Yes, M-mistress...','',26124),
(28102,'enUS','','Get away from me, Edwards, lest I behead you.',26124),
(28103,'enUS','','No, you sniveling wretch. Now begone.',26124),
(28104,'enUS','','You can leave my sight, squire, before I slay you. Again.',26124),
(28105,'enUS','','No. Away with you, worm.',26124),
(28106,'enUS','Heathens! The day of reckoning comes!','Heathens! The day of reckoning comes!',26124),
(28107,'enUS','Light purge you from this world!','Light purge you from this world!',26124),
(28108,'enUS','You cannot stop the Scarlet Crusade!','You cannot stop the Scarlet Crusade!',26124),
(28109,'enUS','You have been branded as enemies of the Crusade, heathens!','You have been branded as enemies of the Crusade, heathens!',26124),
(28110,'enUS','All will fall before the might of the Scarlet Crusade!','All will fall before the might of the Scarlet Crusade!',26124),
(28111,'enUS','They will find me and they will free me... Your pathetic cages cannot hold me for long!','They will find me and they will free me... Your pathetic cages cannot hold me for long!',26124),
(28112,'enUS','May the Light forgive you for the evil that you do.','May the Light forgive you for the evil that you do.',26124),
(28113,'enUS','Have you not yet realized why we remain defiant?','Have you not yet realized why we remain defiant?',26124),
(28114,'enUS','The Argent Dawn will fight until the end!','The Argent Dawn will fight until the end!',26124),
(28115,'enUS','It\'s not too late, brothers and sisters. Repent! Repent and you may be saved.','It\'s not too late, brothers and sisters. Repent! Repent and you may be saved.',26124),
(28116,'enUS','Killing me will only strengthen the resolve of my brethren. Do your worst!','Killing me will only strengthen the resolve of my brethren. Do your worst!',26124),
(28118,'enUS','For your efforts, you be gettin\' da greatest of rewards....','',26124),
(28119,'enUS','Revelation!','',26124),
(28120,'enUS','Be still, friend, and behold da truth of things!','',26124),
(28121,'enUS','I\'m all kinds of busted up... might not... make it.','',26124),
(28122,'enUS','You test my patience, you now see the true might of the Blue.','',26124),
(28123,'enUS','Hah! You\'ll not get my treasure!','',26124),
(28124,'enUS','Kill them! Kill them all and take back Zim\'Torga!','',26124),
(28125,'enUS','Master, my mission be complete.','',26124),
(28126,'enUS','Death to the Zandalari and their puppets! Nothing can stop us now!','',26124),
(28127,'enUS','With da help of these mortals, dis region been cleansed of all who oppose us.','',26124),
(28128,'enUS','Miss Boulian... will you...','',26124),
(28129,'enUS','Will you accept my ring?','',26124),
(28130,'enUS','You have done well, Drakuru.','',26124),
(28131,'enUS','Your betrayal of the Drakkari Empire has borne me a new army.','',26124),
(28132,'enUS','','Oh, Chad... of course I will!',26124),
(28133,'enUS','Your army....','',26124),
(28134,'enUS','Arise, and accept my gift.','',26124),
(28135,'enUS','The full power of your drakes has been unlocked.  Use their power to defeat Eregos!','',26124),
(28136,'enUS','Welcome Friend.  Keep your head down and hold on tight!','',26124),
(28137,'enUS','Hardknuckles boring. Why we here again?','',26124),
(28138,'enUS','If you keep killing hardknuckles, you grow up to be like Goregek. You want be like Goregek?','',26124),
(28139,'enUS','If you here to poke more softknuckles, Dajik going to poke you too. That a bad Goregek habit.','',26124),
(28140,'enUS','Huh... where are we? This not right. I not tell you find hardknuckles, did I?','',26124),
(28141,'enUS','Frenzyheart came here not long ago for new home... big-tongue homes pretty nice, so we maybe take those too. They ugly anyway.','',26124),
(28142,'enUS','Stay a while and listen.','',26124),
(28143,'enUS','Make sure you not forget anything. I forgot stuff once.','',26124),
(28144,'enUS','I placed most of the spikes. Good amount of pointiness I think. You like?','',26124),
(28145,'enUS','Lot of strong Frenzyheart here. Dajik taught most of them. First time I teach something like you though. You not a Frenzyheart, you know.','',26124),
(28146,'enUS','Watch out for pups. Frenzyheart vicious when little.','',26124),
(28147,'enUS','I know you still learning, but big-tongues are bad. Frenzyheart good, big-tongues bad, okay?','',26124),
(28148,'enUS','Poke it in the eye, big-tongues hate that.','',26124),
(28149,'enUS','Okay, all done playing. Time to kill it.','',26124),
(28150,'enUS','I know they funny looking, but less starting, more killing.','',26124),
(28151,'enUS','Aww, you two going be friends? Maybe find nice place in swamp and have very own medium-tongues? So sweet... stop being dumb now.','',26124),
(28152,'enUS','I think it like you. Maybe we can bring it back to hill and ask it nice, \"Step in cooking pot, big-tongue.\" Yes?','',26124),
(28153,'enUS','Time for more smart Dajik tip! No try to ride Kartak.','',26124),
(28154,'enUS','Kartak like taste of big-tongues. If Kartak hungry though, he not mind taste of Frenzyheart, so make sure Kartak not hungry.','',26124),
(28155,'enUS','Maybe it just Dajik, but it seem like this fight been going for a while, yeah?','',26124),
(28156,'enUS','This not Frenzyheart Hill, where we again?','',26124),
(28157,'enUS','You not very fast learner. Just saying.','',26124),
(28158,'enUS','I bet you wonder where we get tall bird things for roast. Too bad, it secret.','',26124),
(28159,'enUS','Hah! Maybe you learn a little after all!','',26124),
(28160,'enUS','This not first queen slain by Frenzyheart. Seem like there always more.','',26124),
(28161,'enUS','No! You killed queen thing! What have you... wait, nevermind. Sorry, that okay.','',26124),
(28162,'enUS','Yes! Stab few more time just in case! Stab good!','',26124),
(28163,'enUS','Not sure how thing got here. Not matter if dead though.','',26124),
(28164,'enUS','Dajik\'s last learner eaten by sand-thing. We do better this time though!','',26124),
(28165,'enUS','Usually it just run away in sand. Not do so good at run away this time.','',26124),
(28166,'enUS','Not see these very much. That fine though, it not very pretty.','',26124),
(28167,'enUS','Time for more smart Dajik tip! Lot of dead things mean lot of chance of being dead thing. Dajik leaving now.','',26124),
(28168,'enUS','You all done with learning! Yup! All done! Dajik leave you and evil red pillar thing now.','',26124),
(28169,'enUS','Broken pillar not safe place. Dajik go now, you need go too.','',26124),
(28170,'enUS','Dead thing there already learn lesson of broken pillar. Leave this lesson for dumb, dead things. Going home now.','',26124),
(28171,'enUS','Time for more smart Dajik tip! If Goregek let chickens out again, make Goregek get chickens back again.','',26124),
(28172,'enUS','Maybe you not notice, chicken move kind of fast.','',26124),
(28173,'enUS','There reason Frenzyheart not chase back chickens. Look kind of dumb to lose to chicken.','',26124),
(28174,'enUS','Oh! Dajik has idea! Make chicken sounds and maybe they come to you!','',26124),
(28175,'enUS','All this running make Dajik not hungry for chicken anymore.','',26124),
(28176,'enUS','Let\'s just eat bristlepine instead, okay? All done with chasing.','',26124),
(28177,'enUS','Time for more smart Dajik tip! Make sure thing dead before reach in mouth for loots.','',26124),
(28178,'enUS','You do okay enough with that one. Just okay.','',26124),
(28179,'enUS','Get the stuff off of body! Dajik hate it when he go skin something and there stuff in the way. So annoying.','',26124),
(28180,'enUS','Dajik train pups that kill stuff faster than you. You got lot more learning left.','',26124),
(28181,'enUS','Did you see face? Looked so scared, \"Ah, big thing going to smash me!\" Hah.','',26124),
(28182,'enUS','That look painful.','',26124),
(28183,'enUS','Dajik not think he seen you eat anything. You eat sometimes, yeah?','',26124),
(28184,'enUS','What we doing here again? Dajik can\'t remember.','',26124),
(28185,'enUS','Time for more smart Dajik tip! Try not to catch stinger with face. Not work so much.','',26124),
(28186,'enUS','I was going draw picture of best attack plan... but you have my chalk.','',26124),
(28187,'enUS','Drone things not as tough as they look. Wasp things a bit nastier.','',26124),
(28188,'enUS','We came for something, yes? Can\'t remember.','',26124),
(28189,'enUS','Seem like there more wasps every time Dajik come back. Why they not run out?','',26124),
(28190,'enUS','In case you wonder, wasp sting not feel so good. No need to try.','',26124),
(28191,'enUS','Time for more smart Dajik tip! Crystals work little too good for back scratch. No try.','',26124),
(28192,'enUS','Sometimes big-tongues try to come get crystals. Not now because they not like it when we kill them.','',26124),
(28193,'enUS','Wasps like blue crystals. Dajik not sure why.','',26124),
(28194,'enUS','Something big make pillars and crystals and everything. Frenzyheart not care much cause it not here anymore.','',26124),
(28195,'enUS','Time for more smart Dajik tip! Messing up big-tongue shrine is fun, but make sure lot of big-tongues not watching first.','',26124),
(28196,'enUS','Zepik does great big-tongue hunt. Dajik tired to teach him when he was little, but he not very teachable.','',26124),
(28197,'enUS','Big-tongues like crystals for shrine things a lot. They not like when we smash them.','',26124),
(28198,'enUS','Dajik been seeing a lot more furless things like you. Frenzyheart not like giving up land, so you things better be careful.','',26124),
(28199,'enUS','Some furless things been making friends with big-tongues... seem pretty dumb to Dajik.','',26124),
(28200,'enUS','The sparky ones are more squishy! Get them first!','',26124),
(28201,'enUS','Dajik tried to show me ways of hunt, but I do better when I do things my way.','',26124),
(28202,'enUS','Bring back good meat and the camp treat you like high-shaman for a day. Good deal.','',26124),
(28203,'enUS','You should go let chickens out again and say Goregek did it. Never get old.','',26124),
(28204,'enUS','I not in a big hurry. We can rest here a while if want.','',26124),
(28205,'enUS','I not live here always... I traveled lot of world on my own not long ago. I like all the stories of beasts and dragons and gods and stuff.','',26124),
(28206,'enUS','Elder Harkek pretty good Frenzyheart. He help me a lot when I was littler and not liking Dajik.','',26124),
(28207,'enUS','Gorlocs are the bad-guys, just so you know.','',26124),
(28208,'enUS','I hope you planning something secret involving that big-tongue ending up dead.','',26124),
(28209,'enUS','If I step on its tail, it was an accident.','',26124),
(28210,'enUS','Normally I kill these things. You know that, yeah?','',26124),
(28211,'enUS','I not so happy about traveling with big-tongues.','',26124),
(28212,'enUS','I see what you doing... maybe if we treat it nice it will lead us back to more big-tongues.','',26124),
(28213,'enUS','Good to stay away from Kartak. He only a friend of Frenzyheart so long as we keep his belly full... and he\'s got a big belly.','',26124),
(28214,'enUS','I teach myself a lot of my big-tongue hunt here. Lot to kill.','',26124),
(28215,'enUS','Something about sound of battle make this place more relaxing than main hill.','',26124),
(28216,'enUS','Not mentioned much, but Kartak ate dozen Frenzyheart before became \"friend.\"','',26124),
(28217,'enUS','Ever met Tartek? He one of our best fighters... leads in the northwest. I hear he captured one of the dragon things. No lie, I a little jealous.','',26124),
(28218,'enUS','Shaman Jakjek is quiet for a Frenzyheart, but still very strong. He probably the only reason Kartak not turned on more of us.','',26124),
(28219,'enUS','My kind not welcome at broken pillar. I going back to hill - find me when you done.','',26124),
(28220,'enUS','Many Frenzyheart lost at broken pillar. Today is not Zepik\'s day to be lost too.','',26124),
(28221,'enUS','I thought about tricking big-tongues to come here, but it too dangerous for me. You have good luck and I meet you back at hill.','',26124),
(28222,'enUS','Bad plan to come here... many more adventures to be had before I risk this place. Be safe... I meet you later.','',26124),
(28223,'enUS','Hahah! You see that? Lightning bolt hit him right in the head!','',26124),
(28224,'enUS','BOOM! That so good! More! More!','',26124),
(28225,'enUS','Zap!','',26124),
(28226,'enUS','We need to do this more often! This so funny... lightning hitting big-tongues everywhere!','',26124),
(28227,'enUS','That lake near here actually full of sea things. Not sure how it all get here... maybe in floods?','',26124),
(28228,'enUS','I think one reason I like hunting big-tongues so much... they not as dumb as the other hunts. They give a real fight.','',26124),
(28229,'enUS','Mist big-tongues are smart with their shrine thing sometimes... cover whole area with mist and it get hard to find any.','',26124),
(28230,'enUS','Careful of big mistcaller guy... Zepik fought him once and barely got away. He lot stronger than rest of big-tongues here.','',26124),
(28231,'enUS','May not be great hunt, but this still fun after so many time.','',26124),
(28232,'enUS','You think they learn to keep Goregek away from chickens.','',26124),
(28233,'enUS','Goregek never \"stumble\" into chicken hut... Goregek always have to feed his dumb belly. Always one chicken missing when we catch them all.','',26124),
(28234,'enUS','You chickens are tougher than I thought! I\'ll have to improvise!','',26124),
(28235,'enUS','You pretty good! Natural at hunt, like me.','',26124),
(28236,'enUS','Goregek think he the boss of everyone, but he eat too much and hunt too little.','',26124),
(28237,'enUS','Dajik forget what he doing, where he at... sometime even forget his own name. Make him not so good teacher sometimes.','',26124),
(28238,'enUS','You ever fought big dragon or god or anything? Zepik like hearing stories.','',26124),
(28239,'enUS','Good one! It not even see it coming.','',26124),
(28240,'enUS','Hah! Leave some for Zepik too.','',26124),
(28241,'enUS','No more play?','',26124),
(28242,'enUS','Flame! Death! Destruction! The black fire rages within my heart! I must... release it! Hahah!','',26124),
(28243,'enUS','Not sure if you notice, but there rumbling sometimes from the water in the big hole. I think there something down there.','',26124),
(28244,'enUS','Big-tongues don\'t usually come down here anymore... I had a big fight and killed lots.','',26124),
(28245,'enUS','I always wonder where all the water go... doesn\'t make sense.','',26124),
(28246,'enUS','Vekjik likes finding big-tongues that wander too far to throw in the basin. He help me trap some of the dumb ones. You should watch him sometime... it pretty funny actually.','',26124),
(28247,'enUS','Battle here been going on for a while... these spark big-tongues have a lot more fight than the other ones.','',26124),
(28248,'enUS','Big-tongues here worship shrine, like at other places, but this shrine sometimes have a guardian. Careful if it shows up.','',26124),
(28249,'enUS','Feels good to hunt with a not dumb hunter. You good at this.','',26124),
(28250,'enUS','Maybe I not be the only one big-tongues fear much longer. You scary when in the fight.','',26124),
(28251,'enUS','Welcome to the camp, $c.','',26124),
(28252,'enUS','What is it that you need from Corvus?','',26124),
(28253,'enUS','I require repairs and supplies, Corvus.','I require repairs and supplies, Corvus.',26124),
(28254,'enUS','Use Searing Wrath to damage enemies and Evasive Maneuvers if I start taking damage.  Remember I need to build up Evasive Charges by taking damage to perform Evasive Maneuvers!','',26124),
(28255,'enUS','Use Leeching Poison to damage enemies and keep me healed.  Touch the Nightmare is very powerful, but it hurts me, so only use it when I have a lot of health!','',26124),
(28256,'enUS','Use Shock Lance to damage enemies.  If we get in trouble, Stop Time to freeze all enemies in place, then hit them with Shock Lance for massive damage!','',26124),
(28257,'enUS','I\'m badly injured!  I can\'t take much more of this!','',26124),
(28258,'enUS','Now that I am at my full power I can perform Temporal Rift.  You can use it to make enemies take extra damage and to get Shock Charges.  Save up Shock Charges and then Shock Lance for huge damage!','',26124),
(28259,'enUS','Now that I am at my full power I can perform Dream Funnel.  You can use it to heal other drakes, but it drains my health, so make sure you\'re using Leeching Poison too!','',26124),
(28260,'enUS','Now that I am at my full power I can perform Martyr.  You can use it to protect other drakes, but I will take lots of damage, so make sure you\'re using Evasive Maneuvers too!','',26124),
(28261,'enUS','Ooh! Shinies!','',26124),
(28265,'enUS','Treasure for Lafoo! Treasure for shrine!','',26124),
(28266,'enUS','Dig, dig, dig...','',26124),
(28267,'enUS','Maybe more shiny bugs! We like bugs!','',26124),
(28268,'enUS','Careful of big scary beast thing! It try to eat us!','',26124),
(28269,'enUS','So many puppy-men here. Think they want be friends now maybe?','',26124),
(28270,'enUS','Can we maybe, please go now? Little scary.','',26124),
(28271,'enUS','No bugs here... where all bugs go?','',26124),
(28272,'enUS','No. No good here. No no no.','',26124),
(28273,'enUS','Voices... voices everywhere and not alive! No stay.','',26124),
(28274,'enUS','All bugs gone. Badness here... we not be with badness.','',26124),
(28275,'enUS','We really not like it here. Maybe come find us when you done.','',26124),
(28276,'enUS','No more eat hatchlings, scary snake thing!','',26124),
(28277,'enUS','No come back this time!','',26124),
(28278,'enUS','You strong! Yay... you keep us safe!','',26124),
(28279,'enUS','Hiss... hiss... dead. All dead.','',26124),
(28280,'enUS','Food for bugs!','',26124),
(28281,'enUS','That look like it hurt. No hit us like that, okay?','',26124),
(28282,'enUS','I think... maybe it dead.','',26124),
(28283,'enUS','Ahh! It all safe now?','',26124),
(28284,'enUS','Oh hi. Who you? Want be friends?','',26124),
(28285,'enUS','It nice that it not snow here. Snow no good.','',26124),
(28286,'enUS','You got funny looking eyeballs.','',26124),
(28287,'enUS','Dead things not seem very happy.','',26124),
(28288,'enUS','Ahh! I hate you puppy-face! So mean!','',26124),
(28289,'enUS','Never met Great Ones. Nope, just met their shrines.','',26124),
(28290,'enUS','Big comfy tree. Good home.','',26124),
(28291,'enUS','Crunchy bugs so delicious. Want?','',26124),
(28292,'enUS','Soo-say really nice to us.  We like Soo-say.','',26124),
(28293,'enUS','One day maybe you can be Soo-dryskin. Like?','',26124),
(28294,'enUS','Hi.','',26124),
(28295,'enUS','Floaty sparks! Think they maybe give me one?','',26124),
(28296,'enUS','Puppy-men attack this place a lot. It scares off all the bugs... that why we don\'t come much.','',26124),
(28297,'enUS','Great Ones left big kitty protector thing. Not for us I think, but it good friend... keeps mean puppy-men away sometimes.','',26124),
(28298,'enUS','You\'ve got a lot of shinies. Lucky.','',26124),
(28299,'enUS','Sleep time yet?','',26124),
(28300,'enUS','Thanks for being nice.','',26124),
(28301,'enUS','It stinky around here. Why so stinky.','',26124),
(28302,'enUS','Be nice puppy-man. We nice, so you be nice too.','',26124),
(28303,'enUS','That weird. Someone took our bugs. You have maybe?','',26124),
(28304,'enUS','Puppy-men have so much hair! Looks ichy.','',26124),
(28305,'enUS','Ooh! Who he? He friend of yours? Maybe we be friends too?','',26124),
(28306,'enUS','You have pie? Someone gave us pie year ago. Really yummy.','',26124),
(28307,'enUS','More treasures! Treasures of all kinds! Yay treasures!','',26124),
(28308,'enUS','Shiny things! Shiny things! Not as shiny as my crystal, but still shiny!','',26124),
(28309,'enUS','We are fast digger! Really fast! See... all done! That was fast, huh?','',26124),
(28310,'enUS','Can never have too many shiny crystals! Nope!','',26124),
(28311,'enUS','Let\'s run circles around silly puppy-men! Weee!','',26124),
(28312,'enUS','Big yeti beast can\'t catch us! We way too fast.','',26124),
(28313,'enUS','Pow! Bam! Take that puppy-men!','',26124),
(28314,'enUS','Soo-holu going to get you! Silly puppy-men. Hahah!','',26124),
(28315,'enUS','Tartek no match for you! You got the skills. Yeah!','',26124),
(28316,'enUS','You think we scared of dragon thing? Not so much!','',26124),
(28317,'enUS','Teach you to steal our treasures! Our treasures are... ours, okay?!','',26124),
(28318,'enUS','Bet you not seen a puppy riding a dragon before? Hah! And not again I think.','',26124),
(28319,'enUS','Whoa! Why you come here? Silly, silly! No come here!','',26124),
(28320,'enUS','Nope! No more me. This place all yours. Bye!','',26124),
(28321,'enUS','Yeah... no.','',26124),
(28322,'enUS','Poof!','',26124),
(28323,'enUS','Ow! Hahah... er, that no good.','',26124),
(28324,'enUS','Wow! Lightning everywhere! We need to learn to make this on the puppy-men!','',26124),
(28325,'enUS','Dumb puppy-men messed up the shrine! Boo! Make it stop!','',26124),
(28326,'enUS','Ah! That was close! Quick, quick, stand under metal pole thing! That keep us safe, yeah?','',26124),
(28327,'enUS','Misty. Very misty. Seem sort of misty to you? Maybe not so much.','',26124),
(28328,'enUS','Mistwhisper not always like us. They say we \"damage their calm.\"','',26124),
(28329,'enUS','Mistwhisper kind of boring. Yeah, boring... little bit.','',26124),
(28330,'enUS','Mistcaller really good at controlling weather with shrine. They know just which crystals to use! Really good!','',26124),
(28331,'enUS','Bam! Hah! Got it good!','',26124),
(28332,'enUS','You like that? Bet not! Bet not cause you dead! Hahah!','',26124),
(28333,'enUS','Unstoppable!','',26124),
(28334,'enUS','Killing Spree!','',26124),
(28335,'enUS','You lose! Lose so bad!','',26124),
(28336,'enUS','We run circles around you! We so good!','',26124),
(28337,'enUS','Bet you wish you not dead! Too late though, can\'t wish when you dead! Hah!','',26124),
(28338,'enUS','Vic...tor...ious! Dun nun nun dun da da!','',26124),
(28339,'enUS','Home home home... place of the shinies!','',26124),
(28340,'enUS','Home good, but not stay long! More adventures!','',26124),
(28341,'enUS','Lets go jump off tree! Fun fun!','',26124),
(28342,'enUS','Chase the hatchlings! Chase the hatchlings! So fast!','',26124),
(28343,'enUS','Good home. Had it long time, still stay good.','',26124),
(28344,'enUS','Great Ones keep home safe because they like Oracles I think! They know we good and nice.','',26124),
(28345,'enUS','This my real home place! You believe we were a hatchling long time ago? We were!','',26124),
(28346,'enUS','Sparktouched best fighters for sure! Zap zap. Get things good!','',26124),
(28347,'enUS','Puppy-men not welcome! Come get zapped good!','',26124),
(28348,'enUS','Soo-holu appear to Sparktouched more than any other Oracle tribe. It\'s true!','',26124),
(28349,'enUS','Last time puppy-men attacked, Soo-holu chased them all the way back to their camp thing! It was glorious!','',26124),
(28350,'enUS','You pretty powerful! I bet you could kill big yeti beast thing! You could get him good!','',26124),
(28351,'enUS','Dumb puppy-men! We tried to be nice! You got it coming now!','',26124),
(28352,'enUS','We know you have dragon thing! We not scared! We going to get you and dragon thing!','',26124),
(28353,'enUS','Time to hide puppy-men! We coming for you... better get in your hill things!','',26124),
(28354,'enUS','Great Stones not for touching! Bad move! Bad move!','',26124),
(28355,'enUS','Tartek is dumb! All you puppy-men follow the dumb. Not so smart!','',26124),
(28356,'enUS','We going to break your spears! Don\'t cry about your spears puppy-men... don\'t cry about them being broken!','',26124),
(28357,'enUS','Hey puppy-man thing, you ever take bath? Bet not! Hahah.','',26124),
(28358,'enUS','My dryskin can beat your dryskin. Yup, definately.','',26124),
(28359,'enUS','You not look so tough. Weak puppy-thing.','',26124),
(28360,'enUS','Know what we don\'t like? Puppy-things! Like that one right there! See? We no like it.','',26124),
(28361,'enUS','What you doing here puppy-thing? Go away! Go chase stick or something.','',26124),
(28362,'enUS','Hey... psst... puppy-thing. How your family doing? I think my dryskin killed them all. Ahahah! Got you good!','',26124),
(28363,'enUS','Yay... more dirt.','',26124),
(28364,'enUS','Soo-say better appreciate these.','',26124),
(28365,'enUS','Hey... maybe we\'ll find some more useless bugs.','',26124),
(28366,'enUS','What the heck are shiny rabbits doing here anyway?','',26124),
(28367,'enUS','Are we done yet?','',26124),
(28368,'enUS','Here I am, digging up some useless bauble from the ground at the will of someone I just recently met... does that seem right to you?','',26124),
(28369,'enUS','Come wolvar! Your death beckons!','',26124),
(28370,'enUS','Soo-holu with see this battle done...','',26124),
(28371,'enUS','Kartak, I do not fear you!','',26124),
(28372,'enUS','These puppy-men have killed scores of us, yet we still still offer them peace... does that seem right to you?','',26124),
(28373,'enUS','Looking to rush to your death at the broken pillar? You\'re all alone in that one.','',26124),
(28374,'enUS','I\'ll come back when we\'ve mustered an army, perhaps. The broken pillar is not welcoming.','',26124),
(28375,'enUS','You certainly are brave, but you\'re alone when it comes to this place, dryskin.','',26124),
(28376,'enUS','I will follow you no further dryskin, too many have died at the broken pillar, and I will not be among them.','',26124),
(28377,'enUS','I can\'t believe... they\'re all... dead.','',26124),
(28378,'enUS','I thought our land was safe from the undead?','',26124),
(28379,'enUS','And so Arthas\'s armies break into the last untouched land in Northrend...','',26124),
(28380,'enUS','We should have been here... we should have stopped this from happening.','',26124),
(28381,'enUS','We can\'t let this stand. The undead must pay!','',26124),
(28382,'enUS','Soo-say didn\'t look into anything when the mosswalkers mentioned strange weather, now they\'re all dead... does that seem right to you?','',26124),
(28383,'enUS','As it should be.','',26124),
(28384,'enUS','Another falls to our onslaught.','',26124),
(28385,'enUS','Just try to stop us now!','',26124),
(28386,'enUS','Not bad for a dryskin.','',26124),
(28387,'enUS','Perhaps I\'ve met an adventurer worthy of my company... perhaps you will redeem my people.','',26124),
(28388,'enUS','How did you even stand Jaloot? Whenever he talks, I want to go dump him at Frenzyheart Hill.','',26124),
(28389,'enUS','Lafoo is Soo-says little pet. Probably the most incomptent gorloc I\'ve ever met... and that\'s saying something.','',26124),
(28390,'enUS','I fight more than all other Gorlocs combined, yet I still find time to learn your language the right way... does that seem right to you?','',26124),
(28391,'enUS','Yeah, let\'s go now.','',26124),
(28392,'enUS','I\'m done here.','',26124),
(28393,'enUS','There some reason why we\'re still here? I\'d love to hear it.','',26124),
(28394,'enUS','Planning to sit on your butt some more, or are we going to go do something that\'s actually useful?','',26124),
(28395,'enUS','Going to go take a nap? I apologize in advance for accidentally stepping on your face while you sleep.','',26124),
(28396,'enUS','I\'m the most intelligent, strongest, most cultured gorloc here, yet Soo-say calls all the shots... does that seem right to you?','',26124),
(28397,'enUS','There are more that might still be alive! We need to keep moving.','',26124),
(28398,'enUS','Where are they dragging those bodies? What are they doing to them?','',26124),
(28399,'enUS','It\'s hard to believe any of them survived this.','',26124),
(28400,'enUS','It\'s a small comfort to see that they haven\'t brought any back in undeath.','',26124),
(28401,'enUS','I know I talk down to them, but I never want to see any of my people die.','',26124),
(28402,'enUS','It\'s good to see some of the mosswalker were more resilient than I thought.','',26124),
(28403,'enUS','The sparktouched are some of the best fighters among us... they\'re carried most of the battle against the wolvar.','',26124),
(28404,'enUS','I have the most respect for the sparktouched out of all of the oracles... they have stood up for their land admirably.','',26124),
(28405,'enUS','Soo-holu was left behind by the Great Ones... you might know them as titans.','',26124),
(28406,'enUS','I\'ve come to believe Soo-holu was left here to guard the shrines, but like the shrines, he\'s powerless without the right crystals.','',26124),
(28407,'enUS','Let us carry the battle to the wolvar... this has gone on for too long. They must pay.','',26124),
(28408,'enUS','Here the sparktouched have been fighting the wolvar for days, yet no other oralces have come to their aid... does that seem right to you?','',26124),
(28409,'enUS','Filthy wolvar. I don\'t care if the dryskin vouches for you, I will not endure your presence for long.','',26124),
(28410,'enUS','You better have a good reason for letting this wolvar continue to breath.','',26124),
(28411,'enUS','Friendly with wolvar still, eh? Then I won\'t be surprised when you turn on us and side with them again','',26124),
(28412,'enUS','You keep the company of wolvar? Perhaps you didn\'t come with good intentions after all.','',26124),
(28413,'enUS','I do have a mighty roar.','',26124),
(28414,'enUS','Here I am, standing next to my mortal enemy, yet I haven\'t killed it... does that seem right to you?','',26124),
(28415,'enUS','Hey, hey!  Only my summoner should be able to see this.','Hey, hey!  Only my summoner should be able to see this.',26124),
(28416,'enUS','I charge you now with the cleansing of Zul\'Drak, Drakuru.','',26124),
(28417,'enUS','Fail me and it shall be your undoing...','',26124),
(28418,'enUS','Succeed, and even greater power shall be yours!','',26124),
(28419,'enUS','As you wish, master.','',26124),
(28420,'enUS','Forgive my deception, mon. It all been for your own good.','',26124),
(28421,'enUS','Ya needed ta prove yer worthiness....','',26124),
(28422,'enUS','I be needin\' worthy underlings in Zul\'Drak, mon. Ones ready to wield real power.','',26124),
(28423,'enUS','You see for yourself now. Da Lich King be generous to dem who obey.','',26124),
(28424,'enUS','Follow dis path, mon, and soon you be tastin\' immortality!','',26124),
(28425,'enUS','Ponder on da thing you have witnessed this day, $n.$b$bDa future already be written. Only thing to decide be your part in it, mon.','',26124),
(28426,'enUS','Malygos\' most powerful agents protect the rings above.  Alone, you cannot hope to defeat them.  We can grant you power to call upon drakes from our dragon flights.  Mounted on the back of a drake, you will be able to fly here in the Oculus and command powerful dragon magic.','',26124),
(28427,'enUS','So where do we go from here?','So where do we go from here?',26124),
(28428,'enUS','Belgaristrasz speaks the truth; time is running out!\n\nThe full power of your drakes has been unlocked.  Use their power to defeat Eregos!','',26124),
(28429,'enUS','','Belgaristrasz speaks the truth; the situation is grave indeed.  \n\nThe full power of your drakes has been unlocked.  Use their power to defeat Eregos!',26124),
(28430,'enUS','Yay we win! [PH]','',26124),
(28431,'enUS','Gods of old, we beseech you. What must we do? How can we save the gods of this land?','',26124),
(28432,'enUS','The spotted one must be sought. Their fates are entwined.','',26124),
(28433,'enUS','But she is chained. A way must be found to free her.','',26124),
(28434,'enUS','To her altar this mortal must travel. What they must do will not be easy. In the end it may prove impossible.','',26124),
(28435,'enUS','But try they must or all will be lost. The Drakkari will be the death of both themselves and their gods!','',26124),
(28436,'enUS','The gods have spoken, $n. We now know what you must do.','',26124),
(28437,'enUS','None know the Scourge better than we death knights.$b$bBelieve me, $r, there\'s nothing more effective than fighting fire with fire....','',26124),
(28438,'enUS','Take it easy on old Nass. He\'s not as young and resilient as he once was.','',26124),
(28439,'enUS','I\'ve lost Nass...','I\'ve lost Nass...',26124),
(28440,'enUS','Not sure how ol\' Nass always finds his way back here. Must be by smell....','',26124),
(28441,'enUS','','',26124),
(28442,'enUS','I say! I simply must find myself another line of work.','',26124),
(28443,'enUS','Perhaps some other kind of arrangement can be worked out here. A simple tap on the shoulder, maybe?','',26124),
(28444,'enUS','','',26124),
(28445,'enUS','Really, it\'s the anticipation that\'s so unnerving...','',26124),
(28446,'enUS','I pray that this is not what I\'m remembered for....','',26124),
(28447,'enUS','Might you focus your attention on the other cheek for a time?','',26124),
(28448,'enUS','If ever a cure for my condition is found, I should like to introduce Stefan to this boot of his.','',26124),
(28449,'enUS','Oof! I\'m beginning to think that you\'re having a bit of a jolly at my expense....','',26124),
(28450,'enUS','Oww! You\'ve got quite a swing there...','',26124),
(28451,'enUS','Umph! I\'m afraid that one was a bit of a waste.','',26124),
(28452,'enUS','Urgh! I can\'t smell any trolls nearby...','',26124),
(28453,'enUS','Now listen here! That was simply uncalled for!','',26124),
(28454,'enUS','Ouch! Enjoying this, are you?','',26124),
(28455,'enUS','Ooh! Well, at least your aim is true. I suppose that\'s something....','',26124),
(28456,'enUS','Aahh! At times like these, I question my decision to leave the Scourge.','',26124),
(28457,'enUS','Are we finished yet?','',26124),
(28458,'enUS','One more lock of scourge hair gained, one more shred of dignity lost....','',26124),
(28459,'enUS','If mother could see me now...','',26124),
(28460,'enUS','I sincerely hope that one was our last!','',26124),
(28461,'enUS','We knocked something loose with that last one.','',26124),
(28462,'enUS','I won\'t be the least bit upset if you choose to call it a day....','',26124),
(28463,'enUS','Let\'s go to Zul\'Drak he says. We can get to the bottom of this mess, he says...','',26124),
(28464,'enUS','Too soon, you have awakened me too soon! What is the meaning of this intrusion?','',26124),
(28465,'enUS','The Eye of Acherus is in your control.','',26124),
(28466,'enUS','Well, that enough of that! Going now.','',26124),
(28467,'enUS','Ow! That hurt. I going to limp over here.','',26124),
(28468,'enUS','I come back when we not getting butts kicked.','',26124),
(28469,'enUS','Not doing so good. I come back and find you later.','',26124),
(28470,'enUS','Dumb slave thing supposed to kill things, not let things kill Goregek!','',26124),
(28471,'enUS','Time for more smart Dajik tip! No let things beat your teacher up so badly. Going home now.','',26124),
(28472,'enUS','Ow... it okay if we go back now? Hurt so much... we sorry.','',26124),
(28473,'enUS','Okay, that hurt! We going over here fast! Be back soon!','',26124),
(28474,'enUS','There\'s no way I\'m dying for you.','',26124),
(28475,'enUS','Hah! This the fun part!','',26124),
(28476,'enUS','I been waiting to do again for so long!','',26124),
(28477,'enUS','Trust me - you going love this!','',26124),
(28478,'enUS','Eat it big-tongues!','',26124),
(28480,'enUS','Though my compatriots would have you take an active role in what is transpiring in Zul\'Drak, we Zandalari are primarily here to witness what is occurring and to chronicle the end of an empire.','',26124),
(28481,'enUS','Now, in Shattrath City: The Tauren Chieftains! Playing in the World\'s End Tavern at the top of the hour!','',26124),
(28482,'enUS','You still have lot of learning... most important, protect Dajik!','',26124),
(28483,'enUS','Dajik going to rest for a bit... hurt all over.','',26124),
(28484,'enUS','When you get hurt bad, remember rest and get strong again. Dajik show you how right now...','',26124),
(28485,'enUS','Slave thing, you so full of fail.','',26124),
(28486,'enUS','Ow. No slave thing, really... ow!','',26124),
(28487,'enUS','Dumb slave thing keep fighitng... Goregek going to not get butt kicked more now.','',26124),
(28488,'enUS','Death stalks us! Destroy it!','Death stalks us! Destroy it!',26124),
(28489,'enUS','Begone foul demon!','Begone foul demon!',26124),
(28490,'enUS','\'Tis the work of the Scourge!','\'Tis the work of the Scourge!',26124),
(28491,'enUS','Scourge! Do not let it escape!','Scourge! Do not let it escape!',26124),
(28492,'enUS','Dumb! Don\'t shoot at it! Gekgek want trophy in one piece!','',26124),
(28493,'enUS','No let it get away! We got it this time.','',26124),
(28494,'enUS','Gekgek finally trap dumb cat. You Gekgek\'s now!','',26124),
(28495,'enUS','Careful! No let it scratch you like last time.','',26124),
(28496,'enUS','Are you ready to rock? Then head over to the World\'s End Tavern! The Tauren Chieftains start their show at the top of the hour.','',26124),
(28497,'enUS','','It is not yet your time, champion. Rise! Rise and fight once more!',26124),
(28498,'enUS','Oops... not again.','',26124),
(28499,'enUS','Goregek maybe stumbled into chicken hut again...','',26124),
(28500,'enUS','Goregek not mean to let chickens get away! Help!','',26124),
(28501,'enUS','Goregek hung... er, sorry. Goregek sorry.','',26124),
(28502,'enUS','Who? The Tauren Chieftains! What? A live performance! Where? The World\'s End Tavern! When? The top of the hour! BE THERE!','',26124),
(28503,'enUS','Lighting','Lighting',26124),
(28504,'enUS','TAUREN CHIEFTAINS! Playing LIVE, in the WORLD\'S END TAVERN! Be there, at the top of the hour! Banished from Shattrath? SNEAK BACK IN!','',26124),
(28505,'enUS','','Here, troll... a gift!',26124),
(28506,'enUS','Are you ready to face Mal\'Ganis with me?','',26124),
(28507,'enUS','The Eye of Acherus launches towards its destination.','',26124),
(28508,'enUS','I\'m ready to battle the dreadlord, sire.','I\'m ready to battle the dreadlord, sire.',26124),
(28509,'enUS','','Ugh... disgusting!',26124),
(28510,'enUS','I\'d like to dress as a pirate.','I\'d like to dress as a pirate.',26124),
(28511,'enUS','For me? Really, mon?','',26124),
(28512,'enUS','It....it be beautiful!','',26124),
(28513,'enUS','Everything is set up and ready to go.','',26124),
(28514,'enUS','Beginning the distillation in 5 seconds.','',26124),
(28515,'enUS','Add another orange! Quickly!','',26124),
(28516,'enUS','Add bananas!','',26124),
(28517,'enUS','Put a papaya in the still!','',26124),
(28518,'enUS','The still needs heat! Light the brazier!','',26124),
(28519,'enUS','Pressure\'s too high! Open the pressure valve!','',26124),
(28520,'enUS','We\'re going to finish this right now, Mal\'Ganis. Just you... and me.','',26124),
(28521,'enUS','We\'ve done it! Come get the cask.','',26124),
(28522,'enUS','spirit of competition test','spirit of competition test',26124),
(28523,'enUS','It\'s no good! I\'m shutting it down...','',26124),
(28524,'enUS','Well done! Be ready for anything!','',26124),
(28525,'enUS','','Move along. Nothing to see here.',26124),
(28526,'enUS','','<Bloodrose eyes you curiously.>$b$bI cannot help but wonder what makes you worthy of such attention.$b$bNo offense....',26124),
(28527,'enUS','Stefan told me you would demonstrate the purpose of this item.','Stefan told me you would demonstrate the purpose of this item.',26124),
(28528,'enUS','Your journey has just begun, young prince. Gather your forces and meet me in the arctic land of Northrend. It is there that we shall settle the score between us. It is there that your true destiny will unfold.','',26124),
(28529,'enUS','I\'ll hunt you to the ends of the earth if I have to! Do you hear me? To the ends of the earth!','',26124),
(28530,'enUS','You performed well this day. Anything that Mal\'Ganis has left behind is yours. Take it as your reward. I must now begin plans for an expedition to Northrend.','',26124),
(28531,'enUS','The Drakkari are keeping my body close to death up in the altar building. They cannot see my spirit though.$B$BWe must work together to prevent them from getting my power.','',26124),
(28532,'enUS','I\'m ready to start the distillation, uh, Tipsy.','I\'m ready to start the distillation, uh, Tipsy.',26124),
(28533,'enUS','Nicely handled! Stay on your toes!','',26124),
(28534,'enUS','Good job! Keep your eyes open, now.','',26124),
(28535,'enUS','That\'ll do. Never know what it\'ll need next...','',26124),
(28536,'enUS','The structure above begins to hum with energy.','',26124),
(28537,'enUS','Rhunok, I need to be reimbued with your mojo.','Rhunok, I need to be reimbued with your mojo.',26124),
(28538,'enUS','Please hurry, $n. I am in a great deal of pain and time is running out.','',26124),
(28539,'enUS','Filthy $r intruder. DIE!','Filthy $r intruder. DIE!',26124),
(28540,'enUS','HELP! HELP!','HELP! HELP!',26124),
(28541,'enUS','SCOURGE! RUN AWAY! RUN AWAY!','SCOURGE! RUN AWAY! RUN AWAY!',26124),
(28542,'enUS','Light help us!','Light help us!',26124),
(28543,'enUS','IT\'S GHOULS!!!! GHOULS!!!!','IT\'S GHOULS!!!! GHOULS!!!!',26124),
(28544,'enUS','I will not simply lay here and allow you to slay me! You will have to earn your right to draw another breath if you want to kill me, mortal!','',26124),
(28545,'enUS','Hahaha, I\'m playin\' possum, mon. You gonna die!','',26124),
(28546,'enUS','','Sure!',26124),
(28547,'enUS','','Oh my...',26124),
(28548,'enUS','','Tastes like I\'m drinking... engine degreaser!',26124),
(28549,'enUS','Aye, I\'ll try it.','',26124),
(28550,'enUS','That\'s exactly what I needed!','',26124),
(28551,'enUS','It\'s got my vote! That\'ll put hair on your chest like nothing else will.','',26124),
(28552,'enUS','Scourge Disguise Failing! Find a safe place!','Scourge Disguise Failing! Find a safe place!',26124),
(28553,'enUS','The Alliance bridge is under attack!','',26124),
(28554,'enUS','I\'m always up for something of Grimbooze\'s.','',26124),
(28555,'enUS','The Horde bridge is under attack!','',26124),
(28556,'enUS','Well, so far, it tastes like something my wife would drink...','',26124),
(28557,'enUS','Now, there\'s the kick I\'ve come to expect from Grimbooze\'s drinks! I like it!','',26124),
(28558,'enUS','Care to try Grimbooze Thunderbrew\'s new jungle punch?','Care to try Grimbooze Thunderbrew\'s new jungle punch?',26124),
(28559,'enUS','YOU WANT DRINK?!  WE GOT DRINK!','',26124),
(28560,'enUS','HEY YOU!  DRINK OGRE BREWS!  MAKE YOU BIG AND STRONG!','',26124),
(28561,'enUS','YOU TRY DA\' BEST, NOW TRY DA\' REST!  OGRE BREW!!','',26124),
(28562,'enUS','Let\'s move through here as quickly as possible. If the undead don\'t kill us, the fires might.','',26124),
(28563,'enUS','Justice will be done.','',26124),
(28564,'enUS','Awww... look at da purty lil\' gool.$b$bJump, lil\' gool! Jump!$b$bHa, ha, ha.... Attsa guud lil\' gool.','',26124),
(28565,'enUS','','We\'re tryin\' ta blow this wall so Wick\'s men can work on the new Harbor gatehouse and road beyond, but the clueless sod is cryin\' about me using too much powder!$B$BTch. I\'ve been sappin\' since he was in diapers. This goes on much longer, I\'ll kick him into the canal and finish the whole blasted job meself!',26124),
(28566,'enUS','We\'re building another road down into Stormwind Harbor as soon as this wall has been removed... but this mad dwarf brought enough powder to level the entire quarter!$B$BI don\'t know what Master Alexston was thinking when he hired her... she\'s foul-mouthed, mean, and stubborn as an ox!','',26124),
(28567,'enUS','What are we to do? We\'ve lost everything!','What are we to do? We\'ve lost everything!',26124),
(28568,'enUS','','We fight! We push them back, just as we have always done!',26124),
(28569,'enUS','','The Scourge are a blemish upon these pristine lands.  By the might of my creators, I will crush every last one of their decrepit bones under my heel.',26124),
(28570,'enUS','What does the Light say to you now, Abbendis!','What does the Light say to you now, Abbendis!',26124),
(28571,'enUS','I didn\'t see the Light step in to save my wife and children!','I didn\'t see the Light step in to save my wife and children!',26124),
(28572,'enUS','Nor my husband and brothers!','Nor my husband and brothers!',26124),
(28574,'enUS','The Light has abandoned us!','The Light has abandoned us!',26124),
(28575,'enUS','','SILENCE! The Light has not abandoned us! The Light is stronger than ever among the pure!',26124),
(28576,'enUS','Havenshire is lost!','Havenshire is lost!',26124),
(28577,'enUS','The stables and mill are left abandoned! What will happen to our horses?','The stables and mill are left abandoned! What will happen to our horses?',26124),
(28578,'enUS','','We are sending crusaders to reclaim what is rightfully ours! Any Scourge that stand in our way will be turned to ashes.',26124),
(28579,'enUS','Where do you expect us to stay? New Avalon cannot hold all of us!','Where do you expect us to stay? New Avalon cannot hold all of us!',26124),
(28580,'enUS','','The pure of heart will be allowed to remain in New Avalon. Those that the inquisitors find bereft of the holy Light will be turned away.',26124),
(28581,'enUS','The crowd gasps.','The crowd gasps.',26124),
(28582,'enUS','But none of you could possibly have anything to worry about, right?','',26124),
(28583,'enUS','I want to stop the Scourge as much as you do.  How can I help?','I want to stop the Scourge as much as you do.  How can I help?',26124),
(28584,'enUS','','The titans did not create life overnight.  The process was gradual and required a great deal of experimentation and iteration.$B$BIt is for that reason that highly protected places such as Sholazar Basin exist.$B$BTo ensure the safety of their experimentation sites, the titans created a defense mechanism.  Its destructive force is unparalleled however, and I will reveal no more unless you swear your fealty to my cause.',26124),
(28585,'enUS','','It borders on sacrilege that these secrets be revealed to a mortal such as yourself, but I have little choice.$B$BEver since Freya, daughter of the titans, left me here I\'ve had but one task and I cannot fail.  Life must be protected at any cost.$B$BThere is a waygate that links this place with another very much like this one.  It is there that the weapon we seek can be found.',26124),
(28586,'enUS','You can trust me.  I am no friend of the Lich King\'s.','You can trust me.  I am no friend of the Lich King\'s.',26124),
(28587,'enUS','I will not fail.','I will not fail.',26124),
(28588,'enUS','What are you hiding under that fold of flesh?','What are you hiding under that fold of flesh?',26124),
(28589,'enUS','This outpost is a cog-free zone. Persons employing cogs in the construction of mechanical devices will be subject to unrelenting mockery.','',26124),
(28590,'enUS','Looks like you had the same idea I did. Hunting for fruit, are you?','Looks like you had the same idea I did. Hunting for fruit, are you?',26124),
(28591,'enUS','Loken?! That\'s downright bothersome... We might\'ve neutralized the iron dwarves, but I\'d lay odds there\'s another machine somewhere else churnin\' out a whole mess o\' these iron vrykul!','',26124),
(28592,'enUS','Ouch! Watch where you\'re tugging!','Ouch! Watch where you\'re tugging!',26124),
(28593,'enUS','Glad I could help!','Glad I could help!',26124),
(28594,'enUS','Can you spare an orange?','Can you spare an orange?',26124),
(28595,'enUS','Have a spare bunch of bananas?','Have a spare bunch of bananas?',26124),
(28596,'enUS','I could really use a papaya.','I could really use a papaya.',26124),
(28597,'enUS','Scourge filth! DIE!','Scourge filth! DIE!',26124),
(28598,'enUS','The Crusade will be victorious!','The Crusade will be victorious!',26124),
(28599,'enUS','I will present your head to Abbendis myself!','I will present your head to Abbendis myself!',26124),
(28600,'enUS','You\'re not welcome in these lands, monster!','You\'re not welcome in these lands, monster!',26124),
(28601,'enUS','Let the purging begin!','Let the purging begin!',26124),
(28602,'enUS','By the Light be cleansed!','By the Light be cleansed!',26124),
(28603,'enUS','Light bless you, my child.','Light bless you, my child.',26124),
(28604,'enUS','%s calls forth an army of frozen corpses.','',26124),
(28605,'enUS','Bonesunder begins to cast Crack Bone!','',26124),
(28606,'enUS','There are two zeppelin towers outside Orgrimmar. The eastern tower serves Tirisfal Glades and Stranglethorn Vale, while the western tower serves Northrend and Thunder Bluff.','There are two zeppelin towers outside Orgrimmar. The eastern tower serves Tirisfal Glades and Stranglethorn Vale, while the western tower serves Northrend and Thunder Bluff.',26124),
(28607,'enUS','Eastern Zeppelin Tower','Eastern Zeppelin Tower',26124),
(28608,'enUS','Western Zeppelin Tower','Western Zeppelin Tower',26124),
(28609,'enUS','Faster, brother! I don\'t know how much longer we can hold these Scourge monsters back!','Faster, brother! I don\'t know how much longer we can hold these Scourge monsters back!',26124),
(28610,'enUS','Double your efforts! Get this wood piled up and ready for shipment to New Avalon!','Double your efforts! Get this wood piled up and ready for shipment to New Avalon!',26124),
(28611,'enUS','I\'m workin\' as fast as I can, cap\'n!','',26124),
(28612,'enUS','I can\'t keep this pace up, sir! If the Scourge don\'t get me, exhaustion will!','',26124),
(28613,'enUS','I\'m on it!','',26124),
(28614,'enUS','Got another pile ready to go! Outta my way!','',26124),
(28615,'enUS','The horns of war have sounded! We haven\'t much time! Quicken your pace!','The horns of war have sounded! We haven\'t much time! Quicken your pace!',26124),
(28616,'enUS','Havenshire will soon be overrun with Scourge. We must hurry!','Havenshire will soon be overrun with Scourge. We must hurry!',26124),
(28617,'enUS','We gonna kill \'em all!','',26124),
(28618,'enUS','The puny zandalari are gonna be crushed!','',26124),
(28619,'enUS','Go, my strikers. Ride out and take Zim\'Torga back!','',26124),
(28620,'enUS','I gonna give you all the gold and gems you can carry if you bring me ten of their heads!','',26124),
(28621,'enUS','Are you blind? They\'re right there. Kill them!','',26124),
(28622,'enUS','I see you. Why don\'tcha come on up and we settle this Drakkari to maggot.','',26124),
(28623,'enUS','If they not willin\' to come out of Zim\'Torga, burn it to the ground!','',26124),
(28624,'enUS','Zandalari, Argent Crusade, Scourge... I don\'t care who you are. I\'m gonna crush you like a bug!','',26124),
(28625,'enUS','The Lightbringer...','',26124),
(28626,'enUS','Lord Uther...','',26124),
(28627,'enUS','Who\'s that beatin\' on my drum?','',26124),
(28628,'enUS','I\'m gonna come down there and kill you good, $r!','',26124),
(28629,'enUS','Now you gonna die!','',26124),
(28630,'enUS','Please take... my shinies. All done...','',26124),
(28631,'enUS','We saved. You nice, dryskin.','',26124),
(28632,'enUS','The mosswalker looks severely injured.','',26124),
(28633,'enUS','<Check for a pulse...>','<Check for a pulse...>',26124),
(28634,'enUS','These tracks must belong to Shango.','These tracks must belong to Shango.',26124),
(28635,'enUS','These aren\'t Shango\'s tracks.','These aren\'t Shango\'s tracks.',26124),
(28636,'enUS','','From this dock, The Bravery travels back and forth between Stormwind and Rut\'theran Village.',26124),
(28637,'enUS','Iceshatter begins to cast Pulsing Shards.','',26124),
(28638,'enUS','The mosswalker victim groans in pain.','',26124),
(28639,'enUS','The gas tank in %s is half full.','',26124),
(28640,'enUS','%s is almost out of fuel.','',26124),
(28641,'enUS','My poor flying machine. She didn\'t survive the crash and without spare parts, I\'ll never get \'er up and running again!','',26124),
(28642,'enUS','Bloodfeast summons Blood Maggots to his aid!','',26124),
(28643,'enUS','\'Ey dere, mon.$b$bkeep yerself busy. Dere be plenty ta do \'round here.','',26124),
(28644,'enUS','Soon, $n!$b$bSoon ya be tastin\' true power. Soon ya be rewarded for your dedication and service.\n','',26124),
(28645,'enUS','Ya be on da path, mortal....$b$bEndure, and ya be gettin\' great power!','',26124),
(28646,'enUS','Ah, the hero. Your little friends said you would come. This certainly saves me the trouble of hunting you down myself.','',26124),
(28647,'enUS','I have weathered a hundred years of war and suffering. Do you truly think it wise to pit your mortal body against a being that cannot die? I\'d venture you have more to lose.','',26124),
(28648,'enUS','Even shattered into countless pieces, the crystals all around weaken me... perhaps I should not have underestimated the titans so...','',26124),
(28649,'enUS','These two brave, ignorant fools despise each other, yet somehow they both spoke of you as a hero. Perhaps you just lack the will to choose a side... let me extend you that opportunity.','',26124),
(28650,'enUS','Arthas once mustered strength... of the very same sort... perhaps his is the path that you will follow.','',26124),
(28651,'enUS','Great and powerful Har\'koa, please call for one of your children that it might stealthily carry me into the Altar of Quetz\'lun.','Great and powerful Har\'koa, please call for one of your children that it might stealthily carry me into the Altar of Quetz\'lun.',26124),
(28652,'enUS','Thank you for saving me, $n. This is the least that I could do to return the favor. Hold on tight. Here we go.','',26124),
(28653,'enUS','Hold on tight. Here we go!','',26124),
(28654,'enUS','This doesn\'t look good. Whatever you do, don\'t fall off. There\'s a ton of nasty things in there!','',26124),
(28655,'enUS','Mphmm rmphhimm rrhumghph?','',26124),
(28656,'enUS','Oh no... Quetz\'lun is dead! Stay still. We\'ll sneak past the prophet.','',26124),
(28657,'enUS','Rmmurphum mmph hmrphum!','',26124),
(28658,'enUS','Umphrum mmphur, murruphru...','',26124),
(28659,'enUS','Uhh, can you send me on the tour of Zul\'Drak?','Uhh, can you send me on the tour of Zul\'Drak?',26124),
(28660,'enUS','We\'re spotted! Hang on. We have to get out of here!','',26124),
(28661,'enUS','We made it! Take care, $n, and thanks again!','',26124),
(28662,'enUS','He dead... we free! We glad you pick us instead of puppy-men. Very glad! Definately. Very glad!','',26124),
(28663,'enUS','What was that? I sense an intruder. Find and kill them!','',26124),
(28664,'enUS','We\'re off!  Watch out for those vines!','',26124),
(28665,'enUS','Looks like the Scourge have hit the area ahead pretty bad...','',26124),
(28666,'enUS','You see that?  She\'s... huge!','',26124),
(28667,'enUS','Here we go!  Hold on tight -- there\'s rough wind ahead!','',26124),
(28668,'enUS','They\'re coming at us!  Be quick with those rockets!','',26124),
(28669,'enUS','Aggggh!  I\'m hit!  You\'re going to have to get us back!  Quick, before the plane explodes!','',26124),
(28670,'enUS','Abomination, I require your assitance!','Abomination, I require your assitance!',26124),
(28671,'enUS','I think we\'re safe now. Let\'s get back!','',26124),
(28672,'enUS','Deliver these results to our apothecaries in the Undercity. And please, try not to digest the message this time?','Deliver these results to our apothecaries in the Undercity. And please, try not to digest the message this time?',26124),
(28673,'enUS','Welcome. May I offer you rest or sustenance?','Welcome. May I offer you rest or sustenance?',26124),
(28674,'enUS','Your...will...be...done...<burp>','Your...will...be...done...<burp>',26124),
(28675,'enUS','Dirty, stinkin\', horse thief!','',26124),
(28676,'enUS','Nobody steals Kitrik\'s horses!','',26124),
(28677,'enUS','You\'ll be hanging at the gallows soon...','',26124),
(28678,'enUS','How many more of you do I need to send back to the Lich King in pieces before he\'ll stop?','',26124),
(28679,'enUS','This specimen shows promise.  Where did we get it?','This specimen shows promise.  Where did we get it?',26124),
(28680,'enUS','The specimen was a male human.  A farmer.  He\'d killed his family and then wandered into Stormwind.','The specimen was a male human.  A farmer.  He\'d killed his family and then wandered into Stormwind.',26124),
(28681,'enUS','The specimen is a female gnome.  Even while infected, her insufferable cuteness let her get close to and infect a dozen others before being stopped.','The specimen is a female gnome.  Even while infected, her insufferable cuteness let her get close to and infect a dozen others before being stopped.',26124),
(28682,'enUS','','Do you like the new home that I\'ve carved out for my so-called worshippers?$B$BIn the throes of my death, I cursed them all and dragged them along with me into this special underworld of my own creation.$B$BI think that I shall delight in their eternal torment, but what I really want is to exact revenge upon my former prophet!',26124),
(28683,'enUS','%s calls upon the mighty armies of the Scourge!','',26124),
(28684,'enUS','Armies of the Scourge, hear my call! The scarlet apocalypse has begun! Tear this land asunder and leave only death in your wake!','',26124),
(28685,'enUS','That\'s the blood of a male orc.  He burned himself alive in order to halt his infection.','That\'s the blood of a male orc.  He burned himself alive in order to halt his infection.',26124),
(28686,'enUS','That\'s a female tauren.  She was watching over her village\'s children when the zombies came.  She stopped the attack, but was bitten and could not cure it before succumbing.','That\'s a female tauren.  She was watching over her village\'s children when the zombies came.  She stopped the attack, but was bitten and could not cure it before succumbing.',26124),
(28687,'enUS','Strange, the records on this one are incomplete.  It just says \"I killed it!\" in a rough scrawl, written in blood.','Strange, the records on this one are incomplete.  It just says \"I killed it!\" in a rough scrawl, written in blood.',26124),
(28688,'enUS','That one\'s a brother.  A forsaken.  Treat him with respect.','That one\'s a brother.  A forsaken.  Treat him with respect.',26124),
(28689,'enUS','That one\'s a male tauren.  A shaman.  He was infected and killed before he could cure himself.','That one\'s a male tauren.  A shaman.  He was infected and killed before he could cure himself.',26124),
(28690,'enUS','She was a female dwarf.  A paladin.  She used the last of her mana curing comrades before falling to her own infection.','She was a female dwarf.  A paladin.  She used the last of her mana curing comrades before falling to her own infection.',26124),
(28691,'enUS','A portion of this land already be mine, mon, but it only be da beginning!','',26124),
(28692,'enUS','This specimen shows concentrated necrosis.  What is its history?','This specimen shows concentrated necrosis.  What is its history?',26124),
(28693,'enUS','This blood has unique properties.  Where was it obtained?','This blood has unique properties.  Where was it obtained?',26124),
(28694,'enUS','We may learn much from this specimen...','We may learn much from this specimen...',26124),
(28695,'enUS','This sample is highly infected!  How was it acquired?','This sample is highly infected!  How was it acquired?',26124),
(28696,'enUS','I need more samples like this one.  Who was it?','I need more samples like this one.  Who was it?',26124),
(28697,'enUS','This latest sample is unique.  What is its history?','This latest sample is unique.  What is its history?',26124),
(28698,'enUS','We can learn much from these experiments...','We can learn much from these experiments...',26124),
(28699,'enUS','The glacier is seeping in from Icecrown... and undead everywhere!  Wait \'til the professor gets a hold of this!','',26124),
(28700,'enUS','Here, da self-righteous crusaders be standin\' in da way of our goal. Dey will fall!','',26124),
(28701,'enUS','Dis all soon gunna belong to da Lich King!','',26124),
(28702,'enUS','And keep the change, ya filthy animal!','',26124),
(28703,'enUS','Perhaps you\'ll think twice about stealin\' one of Kitrik\'s horses next time, eh?','',26124),
(28704,'enUS','Is that all you got?','',26124),
(28705,'enUS','What a colossal waste of time.','',26124),
(28706,'enUS','At least make me work for it next time.','',26124),
(28707,'enUS','Seriously?','',26124),
(28708,'enUS','Da Drakkari be destroyin\' their lands! Dey gunna be losin\' dem... soon, mon.','',26124),
(28709,'enUS','Ahh, dere be our destiny... Gundrak!','',26124),
(28710,'enUS','Mhrrumph rummrhum phurr!','',26124),
(28711,'enUS','The mortals will be tested!','The mortals will be tested!',26124),
(28712,'enUS','My blade thirsts for blood!','My blade thirsts for blood!',26124),
(28713,'enUS','Our enemies will fall!','Our enemies will fall!',26124),
(28714,'enUS','Vengeance!','Vengeance!',26124),
(28715,'enUS','Death to the living!','Death to the living!',26124),
(28716,'enUS','The fields will run red with the blood of the Scarlet Crusade!','The fields will run red with the blood of the Scarlet Crusade!',26124),
(28717,'enUS','I have heard the call, my lord!','I have heard the call, my lord!',26124),
(28718,'enUS','A dozen will fall before I am slain!','A dozen will fall before I am slain!',26124),
(28719,'enUS','Suffer well, death knight...','',26124),
(28720,'enUS','For the Lich King!','',26124),
(28721,'enUS','Strike them down in the name of the Scourge!','Strike them down in the name of the Scourge!',26124),
(28722,'enUS','Draw out their suffering, death knight!','',26124),
(28723,'enUS','Leave nothing for their clerics to resurrect!','',26124),
(28724,'enUS','Bring me their flesh...','',26124),
(28725,'enUS','No mercy for the living!','',26124),
(28726,'enUS','No mercy for the weak!','',26124),
(28727,'enUS','Command me, harvester!','Command me, harvester!',26124),
(28728,'enUS','More souls for the blade!','More souls for the blade!',26124),
(28729,'enUS','Suffering to the weak!','Suffering to the weak!',26124),
(28730,'enUS','CHAOS!','CHAOS!',26124),
(28731,'enUS','DESTRUCTION!','DESTRUCTION!',26124),
(28732,'enUS','Blood and terror, harvester!','Blood and terror, harvester!',26124),
(28733,'enUS','For the Lich King!','For the Lich King!',26124),
(28734,'enUS','By the might of Mograine!','By the might of Mograine!',26124),
(28735,'enUS','Death is their only escape!','',26124),
(28736,'enUS','APOCALYPSE!','',26124),
(28737,'enUS','End the mortal affront!','',26124),
(28738,'enUS','Suffer well, death knight!','',26124),
(28739,'enUS','They will be forgotten...','',26124),
(28740,'enUS','Wipe their existence from this world!','',26124),
(28741,'enUS','The Scourge shall reign supreme!','',26124),
(28742,'enUS','BLOOD AND TERROR!','',26124),
(28743,'enUS','At your beck and call, horseman!','At your beck and call, horseman!',26124),
(28744,'enUS','Heads will roll!','',26124),
(28745,'enUS','Let them run! There is nowhere to hide!','',26124),
(28746,'enUS','Show them the meaning of fear, death knight!','',26124),
(28747,'enUS','Devour their hearts! Siphon their souls!','',26124),
(28748,'enUS','Suffer well, death knight!','',26124),
(28749,'enUS','MORE PAIN!','',26124),
(28750,'enUS','Tear this land apart!','',26124),
(28751,'enUS','You will hear their cries from up here, my lord!','You will hear their cries from up here, my lord!',26124),
(28752,'enUS','I am ready for battle!','I am ready for battle!',26124),
(28753,'enUS','CARNAGE!','CARNAGE!',26124),
(28754,'enUS','The Crusade has been marked for death!','The Crusade has been marked for death!',26124),
(28755,'enUS','I will be your chosen knight, Salanar!','I will be your chosen knight, Salanar!',26124),
(28756,'enUS','The engine\'s blown!  Fly Vic\'s Flying Machine back to Lakeside Landing!','',26124),
(28757,'enUS','Mhrrumph rummrhum phurr!','',26124),
(28758,'enUS','Scourge Disguise Failing! Run for cover!','Scourge Disguise Failing! Run for cover!',26124),
(28759,'enUS','Scourge Disguise Failing! Hide quickly!','Scourge Disguise Failing! Hide quickly!',26124),
(28760,'enUS','','Indeed. Watch this, $r.',26124),
(28761,'enUS','Come to buy from Hargus, you have?','',26124),
(28762,'enUS','Yes, Hargus. I wish to purchase supplies.','Yes, Hargus. I wish to purchase supplies.',26124),
(28763,'enUS','P... Please don\'t...','P... Please don\'t...',26124),
(28764,'enUS','No! Please! I... I have children! I... I...','No! Please! I... I have children! I... I...',26124),
(28765,'enUS','Spare my life! I will leave this place forever! Please!','Spare my life! I will leave this place forever! Please!',26124),
(28766,'enUS','May the Light take mercy on your soul, death knight.','May the Light take mercy on your soul, death knight.',26124),
(28767,'enUS','Have mercy, $g sir:madam;!','Have mercy, $g sir:madam;!',26124),
(28768,'enUS','I almost... made it...','I almost... made it...',26124),
(28769,'enUS','You make my children orphans on this day, fiend!','You make my children orphans on this day, fiend!',26124),
(28770,'enUS','Why?','Why?',26124),
(28771,'enUS','No mercy.','',26124),
(28772,'enUS','Kill them all.','',26124),
(28773,'enUS','Mercy is for the weak.','',26124),
(28774,'enUS','End it.','',26124),
(28775,'enUS','Finish it.','',26124),
(28776,'enUS','No survivors.','',26124),
(28777,'enUS','Kill or be killed, $n.','',26124),
(28778,'enUS','Do not hesitate.','',26124),
(28779,'enUS','Harness your rage and focus!','',26124),
(28780,'enUS','Strike it down!','',26124),
(28781,'enUS','Suffering to the conquered!','',26124),
(28782,'enUS','Show it the meaning of terror.','',26124),
(28783,'enUS','End its miserable life.','',26124),
(28784,'enUS','Give in to the darkness, death knight.','',26124),
(28785,'enUS','Do you think it would hesitate to kill you? A monster like you?','',26124),
(28786,'enUS','Living or dead, you will serve me.','',26124),
(28787,'enUS','You\'re not taking me without a fight!','You\'re not taking me without a fight!',26124),
(28788,'enUS','I won\'t go down that easy!','I won\'t go down that easy!',26124),
(28789,'enUS','Die Scourge dog! DIE!','Die Scourge dog! DIE!',26124),
(28790,'enUS','Come then, death knight!','Come then, death knight!',26124),
(28791,'enUS','Is this the best the Scourge can do?','Is this the best the Scourge can do?',26124),
(28792,'enUS','You may take my life, but you won\'t take my freedom!','You may take my life, but you won\'t take my freedom!',26124),
(28793,'enUS','DIE!','DIE!',26124),
(28794,'enUS','The realm of shadows awaits...','',26124),
(28795,'enUS','Defeat me and take from me the deathcharger I ride. That is the only way to win and return to the world of the living, death knight. Are you ready?','',26124),
(28796,'enUS','I am ready, rider.','I am ready, rider.',26124),
(28797,'enUS','NOOOOOOOOOoooooooo.......!','',26124),
(28798,'enUS','%s is spun to death!','',26124),
(28799,'enUS','','The high priestess is reduced to charcoal.',26124),
(28800,'enUS','','FIRE! AHHHHHHHH!',26124),
(28801,'enUS','Another supplicant seeking the favors of da Lich King?$b$bOnly da worthy be obtainin\' da dark gifts....','',26124),
(28802,'enUS','BRRRRRR!','',26124),
(28803,'enUS','%s explodes!','%s explodes!',26124),
(28804,'enUS','Welcome to Dalaran\'s Guild Registry offices. How may I help you?','Welcome to Dalaran\'s Guild Registry offices. How may I help you?',26124),
(28805,'enUS','Noted.  Return to the conflict areas.  Concentrate our outfield efforts on procuring more victims of the zombie plague.','',26124),
(28806,'enUS','The objective is simple: kill me and take my deathcharger.','',26124),
(28807,'enUS','Should you actually succeed in accomplishing this monumental feat, return here, to Death\'s Breach, with my deathcharger and use the Horseman\'s Call to summon Salanar from the realm of the living.','',26124),
(28808,'enUS','Grand Apothecary Putress!  I come to report from the battlefronts...','Grand Apothecary Putress!  I come to report from the battlefronts...',26124),
(28809,'enUS','Are you prepared? The challenge begins on my mark!','',26124),
(28810,'enUS','3...','',26124),
(28811,'enUS','2...','',26124),
(28812,'enUS','1...','',26124),
(28813,'enUS','NOW!','',26124),
(28814,'enUS','Power to the Forsaken!','Power to the Forsaken!',26124),
(28815,'enUS','For the Banshee Queen!','For the Banshee Queen!',26124),
(28816,'enUS','Explosive Charges will detonate in 5 seconds...','',26124),
(28817,'enUS','Explosive Charges will detonate in 4 seconds...','',26124),
(28818,'enUS','Explosive Charges will detonate in 3 seconds...','',26124),
(28819,'enUS','Explosive Charges will detonate in 2 seconds...','',26124),
(28820,'enUS','Explosive Charges will detonate in 1 seconds...','',26124),
(28821,'enUS','Everyone I know seems to be coming down with something really bad.','Everyone I know seems to be coming down with something really bad.',26124),
(28822,'enUS','I haven\'t felt this bad since I tried to eat some Dragon\'s Breath Chili.','I haven\'t felt this bad since I tried to eat some Dragon\'s Breath Chili.',26124),
(28823,'enUS','My bed is looking pretty good right now.','My bed is looking pretty good right now.',26124),
(28824,'enUS','My boss is going to kill me if I have to stay home sick another day this month.','My boss is going to kill me if I have to stay home sick another day this month.',26124),
(28825,'enUS','Have you heard any news from the town leaders about the sickness going around?','Have you heard any news from the town leaders about the sickness going around?',26124),
(28826,'enUS','Have you talked to anyone who hasn\'t started getting sick?','Have you talked to anyone who hasn\'t started getting sick?',26124),
(28827,'enUS','It must be something in the water, I tell you.','It must be something in the water, I tell you.',26124),
(28828,'enUS','Oh, my. Excuse me a moment.','Oh, my. Excuse me a moment.',26124),
(28829,'enUS','Did you see that?','Did you see that?',26124),
(28830,'enUS','','It is done.',26124),
(28831,'enUS','','%s is visibly weakened.',26124),
(28832,'enUS','','TIME TO DIE, FOOL!',26124),
(28833,'enUS','What? How is this possible?','',26124),
(28834,'enUS','I hope the archmage appreciates what I\'ve gone through to uphold Hemet\'s end of the bargain.','',26124),
(28835,'enUS','Impressive, death knight. Return to me in the world of the living for your reward.','',26124),
(28836,'enUS','','You should be sticking close to Arthas right now!',26124),
(28837,'enUS','What is this you pathetic, little worm? Come to die?','',26124),
(28838,'enUS','I recognize your stench. You\'re the one who stealthed by me on the back of that snow leopard runt!','',26124),
(28839,'enUS','Not feel so good... maybe come back find us later?','',26124),
(28840,'enUS','We not want to die. We want to help though! Come back for us, okay?','',26124),
(28841,'enUS','We sorry... going home so not die now. We so sorry!','',26124),
(28842,'enUS','','I\'ve returned to invite you to my housewarming in the underworld!',26124),
(28843,'enUS','','I\'d say come along quietly, but we both know that\'s not going to happen. My little friend here is going to ease your way into the afterlife.',26124),
(28844,'enUS','Let the battle for the Strand of the Ancients begin!','',26124),
(28845,'enUS','The battle for the Strand of the Ancients begins in 1 minute.','',26124),
(28846,'enUS','The battle for the Strand of the Ancients begins in 30 seconds.  Prepare yourselves!','',26124),
(28847,'enUS','Only one of us may leave this world!','',26124),
(28848,'enUS','Is this it? Is this the best that Salanar could send against me?','',26124),
(28849,'enUS','Come, weakling! Strike me down!','',26124),
(28850,'enUS','You will never return to the world of the living!','',26124),
(28851,'enUS','Another pathetic wretch thinks they can defeat the Dark Rider of Acherus!','',26124),
(28852,'enUS','Give up, outsider!','',26124),
(28853,'enUS','I can smell your fear.','',26124),
(28854,'enUS','Pathetic...','',26124),
(28855,'enUS','NOOOOooooooooooooooooo!','',26124),
(28856,'enUS','','Let\'s get the hell out of here.',26124),
(28857,'enUS','','Listen up, Venture Company goons! Rule #1: Never keep the prisoner near the explosives.',26124),
(28858,'enUS','Your disguise doesn\'t fool me, fleshling! Your defeat will please Drakuru!','',26124),
(28859,'enUS','','Or THIS is what you get.',26124),
(28860,'enUS','','It\'s getting a little hot over here. Shall we move on?',26124),
(28861,'enUS','We will take everything from them, death knight.','',26124),
(28862,'enUS','','Oh, look, it\'s another cartload of explosives! Let\'s help them dispose of it.',26124),
(28863,'enUS','Salanar, I must return to the Realm of Shadows.','Salanar, I must return to the Realm of Shadows.',26124),
(28864,'enUS','','You really shouldn\'t play with this stuff. Someone could get hurt.',26124),
(28865,'enUS','','We made it! Thank you for getting me out of that hell hole. Tell Hemet to expect me!',26124),
(28866,'enUS','I don\'t understand...','I don\'t understand...',26124),
(28867,'enUS','What did I do?','What did I do?',26124),
(28868,'enUS','I didn\'t... deserve this...','I didn\'t... deserve this...',26124),
(28869,'enUS','Why?','Why?',26124),
(28870,'enUS','Ow, ow ow. Okay... ow!','',26124),
(28871,'enUS','Too fast for you! Can\'t catch us!','',26124),
(28872,'enUS','Hey! Where\'d Jaloot go? Poof!','',26124),
(28873,'enUS','This fight\'s all yours!','',26124),
(28874,'enUS','Well that\'s quite enough of that.','',26124),
(28875,'enUS','Find me at town if you\'re looking to try to throw me to death some more.','',26124),
(28876,'enUS','','Well done. I\'ll see to it that my prophet enjoys his eternal stay with me.',26124),
(28877,'enUS','Wait... STOP! You can\'t take back the power!!!','',26124),
(28878,'enUS','I need to heal!','',26124),
(28879,'enUS','We should get out of here. I need to renew!','',26124),
(28880,'enUS','I think it\'s time that I cast my renew!','',26124),
(28881,'enUS','Enjoy ride! Call me when you get there.','',26124),
(28882,'enUS','I don\'t know how much longer I can hold on!','',26124),
(28883,'enUS','Frenzyheart will take land for own. Big-tongues will leave or we kill them good.','',26124),
(28884,'enUS','Darmuk must die, mon!','',26124),
(28885,'enUS','Frenzyheart can be vicious, but we good people. You see if you stay long, we friends with smart and strong just fine.$B$BWe just don\'t like dumb.','',26124),
(28886,'enUS','This the Great Rain Stone. We keep it safe and bring it shinies and it take care of us.$B$BHave more shinies for stone maybe?','',26124),
(28887,'enUS','What I not have in height I make up for in magics. I take care of Great Mist Stone good... most of time anyway.$B$BDumb puppy-men.','',26124),
(28888,'enUS','Puppy-men been attacking us for days now. Great Lightning Stone is still safe though.$B$BSoo-holu come to help us like many times before... puppy-men not stand a chance.','',26124),
(28889,'enUS','Kartak comes for big-tongue meat. Frenzyheart make sure plenty is ready.','',26124),
(28890,'enUS','Champions, meet me at the Town Hall at once. We must take the fight to Mal\'Ganis.','Champions, meet me at the Town Hall at once. We must take the fight to Mal\'Ganis.',26124),
(28891,'enUS','Disguise Failing! Avoid Scourge Contact!','Disguise Failing! Avoid Scourge Contact!',26124),
(28892,'enUS','It\'s your lucky day, Zootfizzle. $n has brought more hatchlings for you.','',26124),
(28893,'enUS','I\'m not here to be the keeper of your hatchlings, Dorian. I\'m doing research of my own, as well.','',26124),
(28894,'enUS','Well, you can always go back to the camp and help Weslex with all his cogs...','',26124),
(28895,'enUS','No, not the cogs! Anything but the cogs!','',26124),
(28896,'enUS','Dey be stronger then I expect mon, attack dem!','',26124),
(28897,'enUS','Wait for me orders, I handle dis myself!','',26124),
(28898,'enUS','Where\'d this come from? I better get this down to the ships before the foreman sees it!','',26124),
(28899,'enUS','I\'ll just leave it here and nobody will be the wiser!','',26124),
(28900,'enUS','We gave shinies to shrine... we not greedy... why this happen?','',26124),
(28901,'enUS','Use my shinies... make weather good again... make undead things go away.','',26124),
(28902,'enUS','Thank... you.','',26124),
(28903,'enUS','We not do anything... to them... I no understand.','',26124),
(28904,'enUS','I do something bad? I sorry....','',26124),
(28905,'enUS','Thank you! You good!','',26124),
(28906,'enUS','Maybe you make weather better too?','',26124),
(28907,'enUS','I give more shinies to shrines! I promise! I sorry!','',26124),
(28908,'enUS','Help more mosswalkers, okay?','',26124),
(28909,'enUS','You save us! Yay for you!','',26124),
(28910,'enUS','Hello, dryskin.','',26124),
(28911,'enUS','You seem to have bested my guards. No matter, they were of little use anyway. Time to die! [PH]','',26124),
(28912,'enUS','Everything okay?','',26124),
(28913,'enUS','Yeah?','',26124),
(28914,'enUS','It nice having a good hunting partner.','',26124),
(28915,'enUS','Something wrong?','',26124),
(28919,'enUS','Hi! How you? We\'re good... yup, good good. Hi!','',26124),
(28920,'enUS','Ever trip over own feet? We have. Kind of hurt. No do it, not fun. Nope.','',26124),
(28921,'enUS','Hello! You\'re pretty strong and nice and stuff. I like you. Lets stay friends, okay?','',26124),
(28922,'enUS','Want us to help with something? What we help with? We good at helping.','',26124),
(28923,'enUS','What are you looking at?','',26124),
(28924,'enUS','Is there a reason we\'re still standing here?','',26124),
(28925,'enUS','I assume you want something.','',26124),
(28926,'enUS','','I am forever in your debt, $n.',26124),
(28927,'enUS','','$n, somehow I feel stronger from Mam\'toth\'s blood.',26124),
(28928,'enUS','','I\'m free! Quickly, enact Quetz\'lun\'s Revenge. I\'ll meet you afterward at Zim\'Torga.',26124),
(28929,'enUS','Can\'t... breathe...','',26124),
(28930,'enUS','Skin... burns... the... pain...','',26124),
(28931,'enUS','Vision... blurry... can\'t... see...','',26124),
(28932,'enUS','H-Help... Somebody... Anybody...','',26124),
(28933,'enUS','I\'m dying...','',26124),
(28934,'enUS','The attacking team failed to beat the defending team\'s capture time! No bonus for you!','',26124),
(28935,'enUS','Lets see you try that again! [PH]','',26124),
(28936,'enUS','Now you not catch us with back turned! Now we hurt you bad undead. BAD!','',26124),
(28937,'enUS','You going die big bad undead thing! You not catch Zepik sleeping this time!','',26124),
(28938,'enUS','Get in the pit you worthless pile of garbage!','',26124),
(28939,'enUS','It puts the ghoul in the pit or else it gets the lash!','',26124),
(28940,'enUS','GHOUL! PIT! NOW!','',26124),
(28941,'enUS','Get in that pit before I turn you into a pile of ash and feces!','',26124),
(28942,'enUS','Back you mindless wretch! Back to the pit!','',26124),
(28943,'enUS','The pit calls, minion. Go to it. NOW!','',26124),
(28944,'enUS','The Alliance captured the titan portal!','',26124),
(28945,'enUS','The Horde captured the titan portal!','',26124),
(28946,'enUS','The battle for the Strand of the Ancients has ended!','',26124),
(28947,'enUS','','$n, please come to me.  I\'m here in Zim\'Torga now.',26124),
(28948,'enUS','The prophet meditates on how best to handle stealing the power from his goddess.','',26124),
(28949,'enUS','The %s begins to pray to Har\'koa for advice, but then thinks better of it.','',26124),
(28950,'enUS','Muttering to himself about the slow speed at which his plans are proceeding, the %s continues with this rituals.','',26124),
(28951,'enUS','The prophet inclines his head slightly as if he has noticed something amiss.','',26124),
(28952,'enUS','I need to find Goregek, do you have his shackles?','I need to find Goregek, do you have his shackles?',26124),
(28953,'enUS','I need to find Dajik, do you have his chalk?','I need to find Dajik, do you have his chalk?',26124),
(28954,'enUS','I need to find Zepik, do you have his hunting horn?','I need to find Zepik, do you have his hunting horn?',26124),
(28955,'enUS','So hungry...','',26124),
(28956,'enUS','Must feed...','',26124),
(28957,'enUS','GIVE ME BRAINS!','',26124),
(28958,'enUS','Smell flesh... close...','',26124),
(28959,'enUS','Mommy?','',26124),
(28960,'enUS','$g Poppy:Mama;!','',26124),
(28961,'enUS','I need to find Lafoo, do you have his bug bag?','I need to find Lafoo, do you have his bug bag?',26124),
(28962,'enUS','I need to find Jaloot, do you have his favorite crystal?','I need to find Jaloot, do you have his favorite crystal?',26124),
(28963,'enUS','I need to find Moodle, do you have his stress ball?','I need to find Moodle, do you have his stress ball?',26124),
(28964,'enUS','I\'ll take you with me!','',26124),
(28965,'enUS','It won\'t be that easy, fiend!','',26124),
(28966,'enUS','The grave calls to us all!','',26124),
(28967,'enUS','YOU KILLED ME!','',26124),
(28968,'enUS','Die, Scourge filth!','',26124),
(28969,'enUS','Vengeance is mine!','',26124),
(28970,'enUS','Nice day for flying, isn\'t it?','',26124),
(28971,'enUS','I know an ace when I see one.  Thanks again for saving my life!','',26124),
(28972,'enUS','The Scourge has broken through!','The Scourge has broken through!',26124),
(28973,'enUS','BEHIND US! They\'ve taken the ships!','BEHIND US! They\'ve taken the ships!',26124),
(28974,'enUS','MONSTERS!','MONSTERS!',26124),
(28975,'enUS','How could this have happened!?','How could this have happened!?',26124),
(28976,'enUS','Get \'em off that ship! Kill every last one of \'em!','Get \'em off that ship! Kill every last one of \'em!',26124),
(28977,'enUS','Take cover! Take cover!','Take cover! Take cover!',26124),
(28978,'enUS','I don\'t believe it!','I don\'t believe it!',26124),
(28979,'enUS','Death to the Scourge!','Death to the Scourge!',26124),
(28980,'enUS','The Horde wins!','',26124),
(28981,'enUS','The Alliance wins!','',26124),
(28982,'enUS','Both sides defended the keep! Draw!','',26124),
(28983,'enUS','Yer gonna have to shoot faster than that! I\'ve already got 11 kills!','',26124),
(28984,'enUS','That\'s number 10! How many\'ve you got?','',26124),
(28985,'enUS','Number 9! I could do this with my eyes closed!','',26124),
(28986,'enUS','11! It\'s gonna take a bigger effort than that to beat ol\' Drostan!','',26124),
(28987,'enUS','Return to Sparktouched Haven or Kartak\'s Hold.','',26124),
(28988,'enUS','Return to Kartak\'s Hold or Sparktouched Haven.','',26124),
(28989,'enUS','Round 1 - Finished!','',26124),
(28990,'enUS','Return to the Altar of Mam\'toth!','',26124),
(28991,'enUS','Horde Defense Victory Calculation Here.','',26124),
(28992,'enUS','Alliance Defense Victory Calculation Here.','',26124),
(28993,'enUS','Now you gunna die, mon!','',26124),
(28994,'enUS','I come to avenge my bruddas, mon!','',26124),
(28995,'enUS','Die, nasty scourge!','',26124),
(28996,'enUS','Die, nasty scourge!','',26124),
(28997,'enUS','We gunna drive all da scourge outta Zul\'Drak, mon - startin\' with you!','',26124),
(28998,'enUS','Wha?!...','',26124),
(28999,'enUS','Aaah....','',26124),
(29000,'enUS','Ooof!','',26124),
(29001,'enUS','Owww!','',26124),
(29002,'enUS','Prepare to be Swarmed! [PH]','',26124),
(29003,'enUS','You feel a massive jolt of energy as your body binds with that of Soo-holu.','',26124),
(29004,'enUS','Look at what you have done, death knight! You have brought glory to the Scourge!','',26124),
(29005,'enUS','You feel rage rise within you as your body binds with Kartak.','',26124),
(29006,'enUS','','You get out of here!',26124),
(29007,'enUS','','Daddy!',26124),
(29008,'enUS','I\'ll kill you!','',26124),
(29009,'enUS','Please, no! Spare me!','Please, no! Spare me!',26124),
(29010,'enUS','Don\'t kill me! I only took this job for the benefits!','Don\'t kill me! I only took this job for the benefits!',26124),
(29011,'enUS','Let me live! I\'ll do whatever you say!','Let me live! I\'ll do whatever you say!',26124),
(29012,'enUS','I\'ve got five kids, $g man:lady;! They\'ll die without me!','I\'ve got five kids, $g man:lady;! They\'ll die without me!',26124),
(29013,'enUS','You don\'t have to do this! Nobody has to die!','You don\'t have to do this! Nobody has to die!',26124),
(29014,'enUS','I picked the wrong week to quit drinkin\'!','I picked the wrong week to quit drinkin\'!',26124),
(29015,'enUS','Ungh... I... I think I pooped...','Ungh... I... I think I pooped...',26124),
(29016,'enUS','I... I got a sick grandma at home... I... I\'m all she\'s got, $g mister:miss;.','I... I got a sick grandma at home... I... I\'m all she\'s got, $g mister:miss;.',26124),
(29017,'enUS','Ripe... for the harvest!','',26124),
(29018,'enUS','Lemme outta here, mon!','',26124),
(29019,'enUS','You Scourge not welcome in Zul\'Drak!','',26124),
(29020,'enUS','Zul\'Drak belongs to da Drakkari, mon. Always will!','',26124),
(29021,'enUS','You Scourge gunna fail here, mon.','',26124),
(29022,'enUS','Our people gunna kill every last one o\' you Scourge!','',26124),
(29023,'enUS','Get away from me, nasty Scourge!','',26124),
(29024,'enUS','You\'re no Scourge. What you doin\' here, mon?','',26124),
(29025,'enUS','Why da Scourge let you walk around in here, mon?','',26124),
(29026,'enUS','I think you be lost, mon....','',26124),
(29027,'enUS','My people gunna rescue me any minute, mon! ....I think.','',26124),
(29028,'enUS','What ya gunna do to us, mon?','',26124),
(29029,'enUS','Just kill me, mon! I don\'t wanna be a Scourge!','',26124),
(29030,'enUS','I\'m never gunna be servin\' da Lich King! Never!','',26124),
(29031,'enUS','Drakkari Empire gunna prevail! Da Scourge gunna die... again.','',26124),
(29032,'enUS','Hrm? Let\'s see what we get out of this one.','',26124),
(29033,'enUS','Blasted geists! They\'ve practically devoured this one whole...','',26124),
(29034,'enUS','Contemptible wretches! Stay away from the bodies!','',26124),
(29035,'enUS','This one is especially ugly. Perfect for a ghoul...','',26124),
(29036,'enUS','I think its spine is broken. Ghoul it is!','',26124),
(29037,'enUS','Is Gothik the Harvester going to have to choke a geist?','',26124),
(29038,'enUS','Surprise, surprise! Another ghoul!','',26124),
(29039,'enUS','Death is the only escape!','',26124),
(29040,'enUS','You have an enchanted tiki? YOU KILLED MY FAMILY!','',26124),
(29041,'enUS','I WILL KILL YOU, $n!','',26124),
(29042,'enUS','Soon now, $n.$b$bFinal preparations are being made, den our advance on Gundrak begins!','',26124),
(29043,'enUS','You will fly again, beast...','',26124),
(29044,'enUS','Death comes on bony wings...','',26124),
(29045,'enUS','Rise, minion. Rise and fly for the Scourge!','',26124),
(29046,'enUS','The time to feed is now, minion. Wake!','',26124),
(29047,'enUS','Open your eyes, brothers and sisters! GAZE UPON APOCALYPSE!','',26124),
(29048,'enUS','The sky itself feeds upon the suffering of the conquered!\n','',26124),
(29049,'enUS','The Scarlet Crusade is powerless to stop us!\n','',26124),
(29050,'enUS','The corpses of those that try only serve to feed our expanding host!','',26124),
(29051,'enUS','The Scarlet fleet lies in ruin upon the sundered coast!\n','',26124),
(29052,'enUS','With each enemy slain, our strength grows! We mustn\'t relent! \n','',26124),
(29053,'enUS','The Lich King has spoken to each of you! Let his words resonate among you once more!','',26124),
(29054,'enUS','ALL. MUST. DIE.','',26124),
(29055,'enUS','Leave no survivors in your wake, brothers and sisters!','',26124),
(29056,'enUS','No mercy for the weak!','',26124),
(29057,'enUS','TERROR!','',26124),
(29058,'enUS','CHAOS!','',26124),
(29059,'enUS','DESTRUCTION!','',26124),
(29060,'enUS','With the approaching darkness comes the end of the Scarlet Crusade. You will battle once more! For the Scourge! For the Lich King!','',26124),
(29061,'enUS','SUFFER WELL, DEATH KNIGHTS!','',26124),
(29062,'enUS','It might look like an ordinary pumpkin patch now, but once the plague cauldron is placed it will become a source of disease, rot and plague!','',26124),
(29063,'enUS','Noth, where is Heigan?','Noth, where is Heigan?',26124),
(29064,'enUS','How dare you! Get out of my sight!','',26124),
(29065,'enUS','That no good kiss-up is probably practicing ballet in his chambers.','',26124),
(29066,'enUS','NEVER say that name around me! Consider this your one and only warning!','',26124),
(29067,'enUS','I can tell you where he\'s not...','',26124),
(29068,'enUS','Heigan is probably performing maintenance on his slime and crap filled dance studio.','',26124),
(29069,'enUS','%s rears up, beckoning you to ride it.','',26124),
(29070,'enUS','My task is done!','',26124),
(29071,'enUS','It\'s only a matter of time before the plague overtakes New Avalon.','',26124),
(29072,'enUS','RUN FOR YOUR LIVES!','RUN FOR YOUR LIVES!',26124),
(29073,'enUS','The Scourge has broken through! RUN AWAY! RUN AWAY!','The Scourge has broken through! RUN AWAY! RUN AWAY!',26124),
(29074,'enUS','HELP! HELP!','HELP! HELP!',26124),
(29075,'enUS','SCOURGE!!! RUN!!!','SCOURGE!!! RUN!!!',26124),
(29076,'enUS','Spare my life, $n! Please!','Spare my life, $n! Please!',26124),
(29077,'enUS','Is nowhere safe from these monsters?','Is nowhere safe from these monsters?',26124),
(29078,'enUS','Somebody save me!','Somebody save me!',26124),
(29079,'enUS','We\'re all gonna die!!!','We\'re all gonna die!!!',26124),
(29080,'enUS','I\'m up to 15. Top that!','',26124),
(29081,'enUS','That\'s my 16th and I\'m still going easy on ya!','',26124),
(29082,'enUS','You\'re going to have to pick it up, or this isn\'t going to be much of a competition.','',26124),
(29083,'enUS','Ha! 16! How many\'ve you got? 10, maybe 11 if you\'re lucky?','',26124),
(29084,'enUS','That\'s my 25th kill. How far behind are you now?','',26124),
(29085,'enUS','The... They promised that we\'d be safe...','The... They promised that we\'d be safe...',26124),
(29086,'enUS','I\'m too young to die!','I\'m too young to die!',26124),
(29087,'enUS','I\'ll give you anything you want! Just let me live!','I\'ll give you anything you want! Just let me live!',26124),
(29088,'enUS','Ask for anything and you shall have it! Just spare my life!','Ask for anything and you shall have it! Just spare my life!',26124),
(29089,'enUS','Filthy coward! Get it over with...','Filthy coward! Get it over with...',26124),
(29090,'enUS','Scourge scum... May the Light purge you from this world!','Scourge scum... May the Light purge you from this world!',26124),
(29091,'enUS','26th! Are you going to start killing, or what?','',26124),
(29092,'enUS','My mother could hunt faster than you, $n.','',26124),
(29093,'enUS','Kill number 26 and I\'m still just warming up.','',26124),
(29094,'enUS','Fineous has what you need, friend.','',26124),
(29095,'enUS','I wish to make a purchase, Fineous.','I wish to make a purchase, Fineous.',26124),
(29096,'enUS','Well, now that I\'ve got a nice lead, I think I\'ll enjoy a little nap.','',26124),
(29097,'enUS','Well, that was a relaxing nap. How\'s the game hunting going over there?','',26124),
(29098,'enUS','We were promised safety! Security!','We were promised safety! Security!',26124),
(29099,'enUS','The Scourge are running freely through the streets!','The Scourge are running freely through the streets!',26124),
(29100,'enUS','My whole family\'s been killed! Where was the army when we needed them most?','My whole family\'s been killed! Where was the army when we needed them most?',26124),
(29101,'enUS','I\'ve got a nice lead, yet. Think I\'ll do some fishin\'.','',26124),
(29102,'enUS','No more lies, Quimby! We want answers!','No more lies, Quimby! We want answers!',26124),
(29103,'enUS','Where are those ships going, Quimby! Tell us the truth!','Where are those ships going, Quimby! Tell us the truth!',26124),
(29104,'enUS','We\'re done for! Save us, Quimby!','We\'re done for! Save us, Quimby!',26124),
(29105,'enUS','If you don\'t come out, we\'ll tear this place apart!','If you don\'t come out, we\'ll tear this place apart!',26124),
(29106,'enUS','Everybody is dying! Help us!','Everybody is dying! Help us!',26124),
(29107,'enUS','What\'s \"Crimson Dawn!\" We deserve to know the truth, Quimby!','What\'s \"Crimson Dawn!\" We deserve to know the truth, Quimby!',26124),
(29108,'enUS','Naxxramas is gone? Who cares! Acherus is here now and the death knights are killing everybody!','Naxxramas is gone? Who cares! Acherus is here now and the death knights are killing everybody!',26124),
(29109,'enUS','I assure you this much, Quimby, you won\'t be getting my vote next term!','I assure you this much, Quimby, you won\'t be getting my vote next term!',26124),
(29110,'enUS','You\'re useless, Quimby!','You\'re useless, Quimby!',26124),
(29111,'enUS','This is a slap in the face! We demand answers!','This is a slap in the face! We demand answers!',26124),
(29112,'enUS','Well, now we\'ve got a competition on our hands.','',26124),
(29113,'enUS','I want on that last ship! Don\'t leave us!','I want on that last ship! Don\'t leave us!',26124),
(29114,'enUS','So much for the Scarlet \"paradise!\"','So much for the Scarlet \"paradise!\"',26124),
(29115,'enUS','QUIMBY!!!!!!','QUIMBY!!!!!!',26124),
(29116,'enUS','Just got number 41! How\'s that for skill?','',26124),
(29117,'enUS','41! Two-thirds of the way there. Better step it up!','',26124),
(29118,'enUS','Hey! I was just lining up a shot on that one. Kill stealer!','',26124),
(29119,'enUS','Argh, just now getting number 48. This is getting tough.','',26124),
(29120,'enUS','Someone\'s been killing all the game out from under me. Hard-won number 48, here.','',26124),
(29121,'enUS','Number 48. Startin\' to slow down a bit, now.','',26124),
(29122,'enUS','Gotta go elsewhere to find some more game. Was hoping to be beyond 48 by now.','',26124),
(29123,'enUS','Ha, 54! In the home stretch now!','',26124),
(29124,'enUS','Number 54! No way I\'m gonna let you beat me!','',26124),
(29125,'enUS','54! Surely an insurmountable lead!','',26124),
(29126,'enUS','That was 54! Soon you\'ll be congratulating me!','',26124),
(29127,'enUS','Ahh... there you are. The master told us you\'d be arriving soon.','',26124),
(29128,'enUS','Please, follow me, $n. There is much for you to see....','',26124),
(29129,'enUS','HI!','',26124),
(29130,'enUS','Send me to Ebon Hold, horse.','Send me to Ebon Hold, horse.',26124),
(29131,'enUS','Send me to Eastern Plaguelands!','Send me to Eastern Plaguelands!',26124),
(29132,'enUS','','HI!',26124),
(29133,'enUS','What is the \"Crimson Dawn?\"','What is the \"Crimson Dawn?\"',26124),
(29134,'enUS','Tell me what you know about \"Crimson Dawn\" or the beatings will continue!','Tell me what you know about \"Crimson Dawn\" or the beatings will continue!',26124),
(29135,'enUS','I\'m through being courteous with your kind, human! What is the \"Crimson Dawn?\"','I\'m through being courteous with your kind, human! What is the \"Crimson Dawn?\"',26124),
(29136,'enUS','\"Crimson Dawn!\" What is it! Speak!','\"Crimson Dawn!\" What is it! Speak!',26124),
(29137,'enUS','I can keep this up for a very long time, Scarlet dog! Tell me about the \"Crimson Dawn!\"','I can keep this up for a very long time, Scarlet dog! Tell me about the \"Crimson Dawn!\"',26124),
(29138,'enUS','I\'ll tear the secrets from your soul! Tell me about the \"Crimson Dawn\" and your life may be spared!','I\'ll tear the secrets from your soul! Tell me about the \"Crimson Dawn\" and your life may be spared!',26124),
(29139,'enUS','Is your life worth so little? Just tell me what I need to know about \"Crimson Dawn\" and I\'ll end your suffering quickly.','Is your life worth so little? Just tell me what I need to know about \"Crimson Dawn\" and I\'ll end your suffering quickly.',26124),
(29140,'enUS','I grow tired of these games, human. Tell me of the \"Crimson Dawn\" or I will tear your spine out with my bare hands!','I grow tired of these games, human. Tell me of the \"Crimson Dawn\" or I will tear your spine out with my bare hands!',26124),
(29141,'enUS','I\'ll tell you nothing, Scourge filth!','I\'ll tell you nothing, Scourge filth!',26124),
(29142,'enUS','You\'ll have to kill me, monster. I will tell you NOTHING!','You\'ll have to kill me, monster. I will tell you NOTHING!',26124),
(29143,'enUS','Argh... The pain... The pain is almost as unbearable as the lashings I received in grammar school when I was but a child.','Argh... The pain... The pain is almost as unbearable as the lashings I received in grammar school when I was but a child.',26124),
(29144,'enUS','You... You\'ll get nothing... And like it...','You... You\'ll get nothing... And like it...',26124),
(29145,'enUS','Do you think this to be pain? To be suffering? HAH! Destroy this mortal shell so that I may ascend to the heavens!','Do you think this to be pain? To be suffering? HAH! Destroy this mortal shell so that I may ascend to the heavens!',26124),
(29146,'enUS','You hit like a girl. Honestly. Is that the best you can do?','You hit like a girl. Honestly. Is that the best you can do?',26124),
(29147,'enUS','The crimson what? Never heard of it...','The crimson what? Never heard of it...',26124),
(29148,'enUS','The pain is momentary. It pales in comparison to what the High General would do to me...','The pain is momentary. It pales in comparison to what the High General would do to me...',26124),
(29149,'enUS','I\'ll tell you everything! STOP! PLEASE!','I\'ll tell you everything! STOP! PLEASE!',26124),
(29150,'enUS','We... We have only been told that the \"Crimson Dawn\" is an awakening. You... You see, the Light speaks to the High General. It is the Light...','We... We have only been told that the \"Crimson Dawn\" is an awakening. You... You see, the Light speaks to the High General. It is the Light...',26124),
(29151,'enUS','The Light that guides us. This movement was set in motion before you came... We... We do as we are told. It is what must be done.','The Light that guides us. This movement was set in motion before you came... We... We do as we are told. It is what must be done.',26124),
(29152,'enUS','I know very litte else... The High General chooses who may go and who must stay behind. There\'s nothing else... You must believe me!','I know very litte else... The High General chooses who may go and who must stay behind. There\'s nothing else... You must believe me!',26124),
(29153,'enUS','NO! PLEASE! There is one more thing that I forgot to mention... A courier comes soon... From Hearthglen. It...','NO! PLEASE! There is one more thing that I forgot to mention... A courier comes soon... From Hearthglen. It...',26124),
(29154,'enUS','%s dies from the torture.','%s dies from the torture.',26124),
(29155,'enUS','You know nothing of pain, monster!','You know nothing of pain, monster!',26124),
(29156,'enUS','HAH! I\'ve survived three separate inquisitions! This is nothing in comparison!','HAH! I\'ve survived three separate inquisitions! This is nothing in comparison!',26124),
(29157,'enUS','Look out! There\'s a bee loose and it\'s on a stinging rampage!','Look out! There\'s a bee loose and it\'s on a stinging rampage!',26124),
(29158,'enUS','That one tickled...','That one tickled...',26124),
(29159,'enUS','I\'m going to send you back to the Lich King in pieces!','I\'m going to send you back to the Lich King in pieces!',26124),
(29160,'enUS','You\'ll be hanging in the gallows shortly, Scourge fiend!','You\'ll be hanging in the gallows shortly, Scourge fiend!',26124),
(29161,'enUS','I used to work for Grand Inquisitor Isillien! Your idea of pain is a normal mid-afternoon for me!','I used to work for Grand Inquisitor Isillien! Your idea of pain is a normal mid-afternoon for me!',26124),
(29162,'enUS','ARGH! You burned my last good tabard!','ARGH! You burned my last good tabard!',26124),
(29163,'enUS','LIES! The pain you are about to endure will be talked about for years to come!','LIES! The pain you are about to endure will be talked about for years to come!',26124),
(29164,'enUS','Cower, heathens, for a Scarlet Lord has joined the battle!','',26124),
(29165,'enUS','New Avalon shall be purged! All Scourge will be eradicated!','',26124),
(29166,'enUS','Crusaders...$B$B<Rivendare shakes his head.>$B$BI am convinced that they are a unique lot amongst the humans. My theory is that they lack higher brain function, unable to logically assess a situation and calculate an outcome. One has only to make mention of the Light to get them frothing and battle ready - at which point they will rush headlong into any engagement with complete disregard for their own well being.','',26124),
(29167,'enUS','','Come over here time traveller, we need to talk!',26124),
(29168,'enUS','','We meet again, time traveller!',26124),
(29169,'enUS','','Quick, over here!',26124),
(29171,'enUS','You should feel honored. You are the first of the master\'s prospects to be shown our operation.','',26124),
(29172,'enUS','Ever since his arrival from Drak\'Tharon, the master has spoken of the time you would be joining him here.','',26124),
(29173,'enUS','The things I show you now must never be spoken of outside Voltarus. The world shall come to know our secret soon enough!','',26124),
(29174,'enUS','Here lie our stores of blight crystal, without which our project would be impossible.','',26124),
(29175,'enUS','I understand that you are to thank for the bulk of our supply.','',26124),
(29176,'enUS','These trolls are among those you exposed on the battlefield. Masterfully done, indeed....','',26124),
(29177,'enUS','I\'M FREE, LITTLE DRAKKARI. TIME TO PAY FOR YOUR MANY TRESSPASSES!','',26124),
(29178,'enUS','Up here, $n. You weren\'t followed, were you?','',26124),
(29179,'enUS','ENOUGH!','',26124),
(29180,'enUS','And now, Akali, my master will have your blood and I will take some of your power as well!','',26124),
(29181,'enUS','$n! I\'ve been awaiting your return. What be takin\' ya so long, mon?$b$bIt be time to complete da conversion of da Blightbloods.$b$bJoin me and witness the creation of our army!','',26124),
(29182,'enUS','I am ready to accompany you, Drakuru.','I am ready to accompany you, Drakuru.',26124),
(29183,'enUS','It is done. Run back to your masters. Run back to Har\'koa. Tell her that I am coming!','',26124),
(29184,'enUS','So hungry...','',26124),
(29185,'enUS','Must feed...','',26124),
(29186,'enUS','GIVE ME BRAINS!','',26124),
(29187,'enUS','Smell flesh... close...','',26124),
(29188,'enUS','I seem to have misplaced your Shredder Control Device... might you have another?','I seem to have misplaced your Shredder Control Device... might you have another?',26124),
(29189,'enUS','Why do you care, Thassarian?','',26124),
(29190,'enUS','His weakness led to his capture.','',26124),
(29191,'enUS','Only the strong should survive. Not to mention...','',26124),
(29192,'enUS','What, Orbaz? That he\'s a blood elf?','',26124),
(29193,'enUS','In life we were hated enemies - this is true...','',26124),
(29194,'enUS','But in death... We are the children of the damned. The orphaned sons and daughters of the Scourge.','',26124),
(29195,'enUS','In death we are brothers.','',26124),
(29196,'enUS','To hell with you, Thassarian.','',26124),
(29197,'enUS','Damn the Crusade! I think my ribs are broken and I might be bleeding internally.','',26124),
(29198,'enUS','What\'re you looking at?','',26124),
(29199,'enUS','I\'m just trying to enjoy my drink.','',26124),
(29200,'enUS','What do you want?','',26124),
(29201,'enUS','I\'ll need to get my runeblade and armor... Just need a little more time.','',26124),
(29202,'enUS','Acolytes, chain them all up! Prepare them for questioning!','',26124),
(29203,'enUS','I\'m still weak, but I think I can get an anti-magic barrier up. Stay inside it or you\'ll be destroyed by their spells.','',26124),
(29204,'enUS','I\'m badly injured, but I\'ll do what I can to help. Try and stay inside of my anti-magic barrier or the acolytes\' magic will tear you apart.','',26124),
(29205,'enUS','Maintaining this barrier will require all of my concentration. Kill them all!','',26124),
(29206,'enUS','What you stand round for, you go back work!','',26124),
(29207,'enUS','There are more coming. Defend yourself! Don\'t fall out of the anti-magic field! They\'ll tear you apart without its protection!','',26124),
(29208,'enUS','I can\'t keep this barrier up much longer... Where is that coward?','',26124),
(29209,'enUS','What can I do for you, $r?','',26124),
(29210,'enUS','The High Inquisitor comes! Be ready, death knight! Do not let him draw you out of the protective bounds of my anti-magic field! Kill him and take his head!','',26124),
(29211,'enUS',' Okay, okay! Ya didn\'t hafta hit me! ',' Okay, okay! Ya didn\'t hafta hit me! ',26124),
(29212,'enUS','I require water breathing, Garren.','I require water breathing, Garren.',26124),
(29213,'enUS','Heh heh, stupid ogre.  Like I\'m going backta work.','Heh heh, stupid ogre.  Like I\'m going backta work.',26124),
(29214,'enUS','Scourge filth! By the Light be cleansed!','',26124),
(29215,'enUS','The Crusade will purge your kind from this world!','',26124),
(29216,'enUS','It seems that I\'ll need to deal with you myself. The High Inquisitor comes for you, Scourge!','',26124),
(29217,'enUS','There is a faint light emanating from deep within the orb and a blue mist swirls across its surface.','',26124),
(29218,'enUS','Your dark Scourge magic won\'t protect you from the Light!','',26124),
(29219,'enUS','Coward!','',26124),
(29220,'enUS','Come out and play.','',26124),
(29221,'enUS','LIGHT PURGE YOU!','',26124),
(29222,'enUS','You have come seeking deliverance? I have come to deliver!','',26124),
(29223,'enUS','%s\'s remains fall to the ground.','',26124),
(29224,'enUS','Stand your ground! Use my anti-magic barrier to dampen their spells!','',26124),
(29225,'enUS','Stay in the anti-magic field! Make them come to you!','',26124),
(29226,'enUS','Death grip! Use your powers, death knight! Pull them in!','',26124),
(29227,'enUS','Do not let them wear you down! Focus!','',26124),
(29228,'enUS','I can\'t keep this damned barrier up forever. Kill faster!','',26124),
(29229,'enUS','This is going to be a humbling defeat.','',26124),
(29230,'enUS','%s collapses to the ground.','',26124),
(29231,'enUS','You\'re done for, death knight!','',26124),
(29232,'enUS','Lafoo digs up some bugs from the dirt.','',26124),
(29233,'enUS','Once more we hear your call, Khufu. We have wisdom for you and $n. You face great peril and must act swiftly or you all and Har\'koa will die.','',26124),
(29234,'enUS','The unblemished heart of the guardian must be secured to show defiance and strength. Jealous Zim\'Rhuk keeps those who harbor it.','',26124),
(29235,'enUS','The gusty essence of deceased Quetz\'lun\'s wardens must be gathered to draw him near. To Har\'koa must both of these rarities be delivered.','',26124),
(29236,'enUS','And yet we see only doom in your future. It is your destiny that you do this, $n, but we fear that the prophet is too powerful for you and your friends. Still, you must try.','',26124),
(29237,'enUS','','No, not Akali too!',26124),
(29238,'enUS','','Looks over in the direction of the witch doctor and is thoughtful.',26124),
(29239,'enUS','The death of the High Inquisitor of New Avalon will not go unnoticed. You need to get out of here at once! Go, before more of them show up. I\'ll be fine on my own.','',26124),
(29240,'enUS','I\'ll draw their fire, you make your escape behind me.','',26124),
(29241,'enUS','Your High Inquisitor is nothing more than a pile of meat, Crusaders! There are none beyond the grasp of the Scourge!','',26124),
(29242,'enUS','<Koltira groans.>','',26124),
(29243,'enUS','Koltira, let\'s get out of here!','Koltira, let\'s get out of here!',26124),
(29244,'enUS','','This isn\'t quite what I signed up for, but hey... at least it\'s warm here.',26124),
(29245,'enUS','%s has earned the achievement $a!','%s has earned the achievement $a!',26124),
(29246,'enUS','The Scarlet Crusade will serve a new master - in death...','',26124),
(29247,'enUS','Still warm, just the way Rejek likes it.','',26124),
(29248,'enUS','Rejek feel strong! Rejek crush big-tongue skulls between his hands!','',26124),
(29249,'enUS','Rejek and $n will teach the enemies of the Frenzyheart to fear us!','',26124),
(29250,'enUS','What is this? I recognize you from when I killed Akali. You must be this $n that everyone is dreading.','',26124),
(29251,'enUS','You don\'t worry me, $g boy : girl;. Just the opposite - I look forward to killing you. Nothing will stand between me and Zim\'Torga now!','',26124),
(29252,'enUS','Fools! Nothing can stop us now!','',26124),
(29253,'enUS','How sad that only now do you grasp the truth - I wield the power of a god. You are a mere mortal. You cannot hope to defeat me!','',26124),
(29254,'enUS','Are you challenging me, $g brother:sister;?','Are you challenging me, $g brother:sister;?',26124),
(29255,'enUS','I challenge you, death knight!','I challenge you, death knight!',26124),
(29256,'enUS','You\'ve meddled in affairs that were none of your business. You are nothing but a foreign invader. Prepare to die!','',26124),
(29257,'enUS','The prophet begins to cast a ritual of annihilation.','',26124),
(29258,'enUS','The duel will begin in...','The duel will begin in...',26124),
(29259,'enUS','3...','3...',26124),
(29260,'enUS','2...','2...',26124),
(29261,'enUS','1...','1...',26124),
(29262,'enUS','You have challenged death itself!','You have challenged death itself!',26124),
(29263,'enUS','I\'m going to tear your heart out, cupcake!','Don\'t make me laugh.',26124),
(29264,'enUS','Here come the tears...','Here come the tears...',26124),
(29265,'enUS','No potions!','No potions!',26124),
(29266,'enUS','You\'re going down!','You\'re going down!',26124),
(29267,'enUS','You don\'t stand a chance, $n.','You don\'t stand a chance, $n.',26124),
(29268,'enUS','The Lich King will see his true champion on this day!','The Lich King will see his true champion on this day!',26124),
(29269,'enUS','','PROPHET!',26124),
(29270,'enUS','Remember this day, $n, for it is the day that you will be thoroughly owned.','Remember this day, $n, for it is the day that you will be thoroughly owned.',26124),
(29271,'enUS','What? HAR\'KOA?!','',26124),
(29272,'enUS','','YOU KEEP YOUR FILTHY DRAKKARI HANDS OFF OF THEM!',26124),
(29273,'enUS','Very well, kitten. I see no need to delay your inevitable demise. I look forward to dealing with you just as soon as I finish off this fool!','',26124),
(29274,'enUS','','I THINK NOT. YOU WILL DROP YOUR IMMUNITY, CEASE YOUR RITUAL NOW AND RELEASE THEM!',26124),
(29275,'enUS','NO! I will not be defeated!','',26124),
(29276,'enUS','','Thank you. Once again you have saved us all. I will see you back at Zim\'Torga.',26124),
(29277,'enUS','Well that didn\'t work.','Well that didn\'t work.',26124),
(29278,'enUS','Mental note, don\'t mix the blue one with the green one.','Mental note, don\'t touch the blue one.',26124),
(29279,'enUS','Yep, shoulda tried the red one!','Yep, shoulda gone with the red one!',26124),
(29280,'enUS','That certainly wasn\'t the reaction I wanted.','That was not the reaction I was hoping for.',26124),
(29281,'enUS','Study dis place well, mon. Ya gonna be helpin\' me conquer it!','',26124),
(29282,'enUS','%s groans.','%s groans.',26124),
(29283,'enUS','%s whimpers.','%s whimpers.',26124),
(29284,'enUS','%s cries softly.','%s cries softly.',26124),
(29285,'enUS','%s sobs.','%s sobs.',26124),
(29286,'enUS','Come to finish the job, have you?','',26124),
(29287,'enUS','You\'ll look me in the eyes when...','',26124),
(29288,'enUS','$n?','',26124),
(29289,'enUS','$n, I\'d recognize those horns anywhere... What... What have they done to you, $n?','',26124),
(29290,'enUS','You don\'t remember me, do you? Blasted Scourge... They\'ve tried to drain you of everything that made you a righteous force of reckoning. Every last ounce of good... Everything that made you a tauren!','',26124),
(29291,'enUS','Ahh yeah, mon! Dere be great glory ta be had here!','',26124),
(29292,'enUS','Da Lich King be sharin\' his power wit dem who serve him well, mon.','',26124),
(29293,'enUS','Come to me now, $n. I must be speakin\' wit ya.','',26124),
(29294,'enUS','Think, $n. Think back. Try and remember the rolling plains of Mulgore, where you were born. Remember the splendor of life, $g brother:sister;. You were a champion of the tauren once! This isn\'t you.','',26124),
(29295,'enUS','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!','',26124),
(29296,'enUS','The Gate of the Blue Sapphire is under attack!','',26124),
(29297,'enUS','The Gate of the Green Emerald is under attack!','',26124),
(29298,'enUS','The Gate of the Red Sun is under attack!','',26124),
(29299,'enUS','The Gate of the Purple Amethyst is under attack!','',26124),
(29300,'enUS','The Gate of the Yellow Moon is under attack!','',26124),
(29301,'enUS','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Mulgore. This world is worth saving.','',26124),
(29302,'enUS','Do it, $n! Put me out of my misery!','',26124),
(29303,'enUS','%s dies from his injuries.','',26124),
(29304,'enUS','The Gate of the Yellow Moon was destroyed!','',26124),
(29305,'enUS','The Gate of the Purple Amethyst was destroyed!','',26124),
(29306,'enUS','The Gate of the Red Sun was destroyed!','',26124),
(29307,'enUS','The Gate of the Green Emerald was destroyed!','',26124),
(29308,'enUS','The Gate of the Blue Sapphire was destroyed!','',26124),
(29309,'enUS','What\'s going on in there? What\'s taking so long, $n?','',26124),
(29310,'enUS','Come to finish the job, have you?','Come to finish the job, have you?',26124),
(29311,'enUS','I\'d like to stand for...','I\'d like to stand for...',26124),
(29312,'enUS','$n?','$n?',26124),
(29313,'enUS','$n, I\'d recognize that face anywhere... What... What have they done to you, $n?','$n, I\'d recognize that face anywhere... What... What have they done to you, $n?',26124),
(29314,'enUS','You don\'t remember me, do you? Blasted Scourge... They\'ve tried to drain you of everything that made you a righteous force of reckoning. Every last ounce of good... Everything that made you a human!','You don\'t remember me, do you? Blasted Scourge... They\'ve tried to drain you of everything that made you a righteous force of reckoning. Every last ounce of good... Everything that made you a human!',26124),
(29315,'enUS','Think, $n. Think back. Try and remember the hills and valleys of Elwynn, where you were born. Remember the splendor of life, $g brother:sister;. You were a champion of the Alliance once! This isn\'t you.','Think, $n. Think back. Try and remember the hills and valleys of Elwynn, where you were born. Remember the splendor of life, $g brother:sister;. You were a champion of the Alliance once! This isn\'t you.',26124),
(29316,'enUS','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!',26124),
(29317,'enUS','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Elwynn. This world is worth saving.','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Elwynn. This world is worth saving.',26124),
(29318,'enUS','Do it, $n! Put me out of my misery!','Do it, $n! Put me out of my misery!',26124),
(29319,'enUS','%s dies from her injuries.','%s dies from her injuries.',26124),
(29320,'enUS','What\'s going on in there? What\'s taking so long, $n?','',26124),
(29321,'enUS','','Worgen everywhere!  Don\'t give up yet, I\'m right behind you!',26124),
(29322,'enUS','Come to finish the job, have you?','Come to finish the job, have you?',26124),
(29323,'enUS','I\'d like to stand for...','I\'d like to stand for...',26124),
(29324,'enUS','$n?','$n?',26124),
(29325,'enUS','$n, I\'d recognize that face anywhere... What... What have they done to you, $n?','$n, I\'d recognize that face anywhere... What... What have they done to you, $n?',26124),
(29326,'enUS','You don\'t remember me? When you were a child your mother would leave you in my care while she served at the Temple of the Moon. I held you in my arms and fed you honey and sheep\'s milk to calm you until she would return. You were my little angel. Blasted Scourge... What have they done to you, $n?','You don\'t remember me? When you were a child your mother would leave you in my care while she served at the Temple of the Moon. I held you in my arms and fed you honey and sheep\'s milk to calm you until she would return. You were my little angel. Blasted Scourge... What have they done to you, $n?',26124),
(29327,'enUS','','I fear we haven\'t seen the last of Arugal...',26124),
(29328,'enUS','You must remember the splendor of life, $g brother:sister;. You were a champion of the kaldorei once! This isn\'t you!','You must remember the splendor of life, $g brother:sister;. You were a champion of the kaldorei once! This isn\'t you!',26124),
(29329,'enUS','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!',26124),
(29330,'enUS','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Teldrassil, our beloved home. This world is worth saving.','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Teldrassil, our beloved home. This world is worth saving.',26124),
(29331,'enUS','Do it, $n! Put me out of my misery!','Do it, $n! Put me out of my misery!',26124),
(29332,'enUS','What\'s going on in there? What\'s taking so long, $n?','',26124),
(29333,'enUS','%s dies from her injuries.','%s dies from her injuries.',26124),
(29334,'enUS','What\'s going on in there? What\'s taking so long, $n?','',26124),
(29335,'enUS','Come to finish the job, have ye?','Come to finish the job, have ye?',26124),
(29336,'enUS','Well this son o\' Ironforge would like...','Well this son o\' Ironforge would like...',26124),
(29337,'enUS','$n?','$n?',26124),
(29338,'enUS','$n, I\'d recognize that face anywhere... What... What have they done to ye, $g lad:lass;?','$n, I\'d recognize that face anywhere... What... What have they done to ye, $g lad:lass;?',26124),
(29339,'enUS','Ye don\'t remember me, do ye? Blasted Scourge... They\'ve tried to drain ye o\' everything that made ye a righteous force o\' reckoning. Every last ounce o\' good... Everything that made ye a $g son:daughter; o\' Ironforge!','Ye don\'t remember me, do ye? Blasted Scourge... They\'ve tried to drain ye o\' everything that made ye a righteous force o\' reckoning. Every last ounce o\' good... Everything that made ye a $g son:daughter; o\' Ironforge!',26124),
(29340,'enUS','Think, $n. Think back. Try and remember the snow capped mountains o\' Dun Morogh! Ye were born there, $g lad:lass;. Remember the splendor o\' life, $n! Ye were a champion o\' the dwarves once! This isn\'t ye!','Think, $n. Think back. Try and remember the snow capped mountains o\' Dun Morogh! Ye were born there, $g lad:lass;. Remember the splendor o\' life, $n! Ye were a champion o\' the dwarves once! This isn\'t ye!',26124),
(29341,'enUS','Listen to me, $n. Ye must fight against the Lich King\'s control. He\'s a monster that wants to see this world - our world - in ruin. Don\'t let him use ye to accomplish his goals. Ye were once a hero and ye can be again. Fight, damn ye! Fight his control!','Listen to me, $n. Ye must fight against the Lich King\'s control. He\'s a monster that wants to see this world - our world - in ruin. Don\'t let him use ye to accomplish his goals. Ye were once a hero and ye can be again. Fight, damn ye! Fight his control!',26124),
(29342,'enUS','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... For KHAAAAAAAAZZZ MODAAAAAANNNNNN!!!','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... For KHAAAAAAAAZZZ MODAAAAAANNNNNN!!!',26124),
(29343,'enUS','Do it, $n! Put me out of my misery!','Do it, $n! Put me out of my misery!',26124),
(29344,'enUS','%s dies from his injuries.','%s dies from his injuries.',26124),
(29345,'enUS','Get them!','',26124),
(29346,'enUS','What\'s going on in there? What\'s taking so long, $n?','',26124),
(29347,'enUS','Come to finish the job, have you?','Come to finish the job, have you?',26124),
(29348,'enUS','If you\'d allow me just one...','If you\'d allow me just one...',26124),
(29349,'enUS','$n?','$n?',26124),
(29350,'enUS','$n, I\'d recognize that face anywhere... What... What have they done to you, $n?','$n, I\'d recognize that face anywhere... What... What have they done to you, $n?',26124),
(29351,'enUS','You don\'t remember me, do you? Blasted Scourge... They\'ve tried to drain you of everything that made you a pint-sized force of reckoning. Every last ounce of good... Everything that made you a gnome!','You don\'t remember me, do you? Blasted Scourge... They\'ve tried to drain you of everything that made you a pint-sized force of reckoning. Every last ounce of good... Everything that made you a gnome!',26124),
(29352,'enUS','Think, $n. Think back. Try and remember Gnomeregan before those damned troggs! Remember the feel of an arclight spanner, $g brother:sister;. You were a champion of gnome-kind once! This isn\'t you.','Think, $n. Think back. Try and remember Gnomeregan before those damned troggs! Remember the feel of an arclight spanner, $g brother:sister;. You were a champion of gnome-kind once! This isn\'t you.',26124),
(29353,'enUS','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!',26124),
(29354,'enUS','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Gnomeregan! This world is worth saving.','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Gnomeregan! This world is worth saving.',26124),
(29355,'enUS','Do it, $n! Put me out of my misery!','Do it, $n! Put me out of my misery!',26124),
(29356,'enUS','%s dies from his injuries.','%s dies from his injuries.',26124),
(29357,'enUS','Come to finish the job, have you?','',26124),
(29358,'enUS','You\'ll look me in the eyes when...','',26124),
(29359,'enUS','$n?','',26124),
(29360,'enUS','$n, I\'d recognize those face tentacles anywhere... What... What have they done to you, $n?','',26124),
(29361,'enUS','You don\'t remember me, do you? Blasted Scourge... They\'ve tried to drain you of everything that made you a righteous force of reckoning. Every last ounce of good... Everything that made you a draenei!','',26124),
(29362,'enUS','Think, $n. Think back. Try and remember the proud mountains of Argus, where you were born. Remember the splendor of life, $g brother:sister;. You were a champion of the draenei once! This isn\'t you.','',26124),
(29363,'enUS','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!','',26124),
(29364,'enUS','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Argus. Don\'t let that happen to this world.','',26124),
(29365,'enUS','Do it, $n! Put me out of my misery!','',26124),
(29366,'enUS','%s dies from his injuries.','',26124),
(29367,'enUS','What\'s going on in there? What\'s taking so long, $n?','',26124),
(29368,'enUS','Come to finish the job, have you?','Come to finish the job, have you?',26124),
(29369,'enUS','You\'ll look me in the eyes when...','You\'ll look me in the eyes when...',26124),
(29370,'enUS','$n, I\'d recognize that face anywhere... What... What have they done to you, $n?','$n, I\'d recognize that face anywhere... What... What have they done to you, $n?',26124),
(29372,'enUS','$n?','$n?',26124),
(29373,'enUS','You don\'t remember me, do you? Blasted Scourge... They\'ve tried to drain you of everything that made you a righteous force of reckoning. Every last ounce of good... Everything that made you a blood elf!','You don\'t remember me, do you? Blasted Scourge... They\'ve tried to drain you of everything that made you a righteous force of reckoning. Every last ounce of good... Everything that made you a blood elf!',26124),
(29374,'enUS','Think, $n. Think back. Try and remember the majestic halls of Silvermoon City, where you were born. Remember the splendor of life, $g brother:sister;. You were a champion of the sin\'dorei once! This isn\'t you.','Think, $n. Think back. Try and remember the majestic halls of Silvermoon City, where you were born. Remember the splendor of life, $g brother:sister;. You were a champion of the sin\'dorei once! This isn\'t you.',26124),
(29375,'enUS','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!',26124),
(29376,'enUS','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Silvermoon. This world is worth saving.','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Silvermoon. This world is worth saving.',26124),
(29377,'enUS','Do it, $n! Put me out of my misery!','Do it, $n! Put me out of my misery!',26124),
(29378,'enUS','%s dies from her injuries.','',26124),
(29379,'enUS','What\'s going on in there? What\'s taking so long, $n?','',26124),
(29380,'enUS','What\'s going on in there? What\'s taking so long, $n?','',26124),
(29381,'enUS','What\'s going on in there? What\'s taking so long, $n?','',26124),
(29382,'enUS','What\'s going on in there? What\'s taking so long, $n?','',26124),
(29383,'enUS','Come to finish the job, have you?','Come to finish the job, have you?',26124),
(29384,'enUS','I want to die like an orc...','I want to die like an orc...',26124),
(29385,'enUS','$n?','$n?',26124),
(29386,'enUS','$n, I\'d recognize that face anywhere... What... What have they done to you, $n?','$n, I\'d recognize that face anywhere... What... What have they done to you, $n?',26124),
(29387,'enUS','You don\'t remember me, do you? Blasted Scourge... They\'ve tried to drain you of everything that made you a righteous force of reckoning. Every last ounce of good... Everything that made you an orc!','You don\'t remember me, do you? Blasted Scourge... They\'ve tried to drain you of everything that made you a righteous force of reckoning. Every last ounce of good... Everything that made you an orc!',26124),
(29388,'enUS','Think, $n. Think back. Try and remember Durotar, $g brother:sister;! Remember the sacrifices our heroes made so that we could be free of the blood curse. Harken back to the Valley of Trials, where we were reborn into a world without demonic influence. We found the splendor of life, $n. Together! This isn\'t you. You were a champion of the Horde once!','Think, $n. Think back. Try and remember Durotar, $g brother:sister;! Remember the sacrifices our heroes made so that we could be free of the blood curse. Harken back to the Valley of Trials, where we were reborn into a world without demonic influence. We found the splendor of life, $n. Together! This isn\'t you. You were a champion of the Horde once!',26124),
(29389,'enUS','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!',26124),
(29390,'enUS','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... For the Horde! This world is worth saving.','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... For the Horde! This world is worth saving.',26124),
(29391,'enUS','Do it, $n! Put me out of my misery!','Do it, $n! Put me out of my misery!',26124),
(29392,'enUS','%s dies from his injuries.','%s dies from his injuries.',26124),
(29393,'enUS','Come to finish the job, have you?','Come to finish the job, have you?',26124),
(29394,'enUS','Ironic, isn\'t it? To be killed...','Ironic, isn\'t it? To be killed...',26124),
(29395,'enUS','$n?','$n?',26124),
(29396,'enUS','$n, I\'d recognize that decay anywhere... What... What have they done to you, $n?','$n, I\'d recognize that decay anywhere... What... What have they done to you, $n?',26124),
(29397,'enUS','You don\'t remember me? We were humans once - long, long ago - until Lordaeron fell to the Scourge. Your transformation to a Scourge zombie came shortly after my own. Not long after that, our minds were freed by the Dark Lady.','You don\'t remember me? We were humans once - long, long ago - until Lordaeron fell to the Scourge. Your transformation to an Scourge zombie came shortly after my own. Not long after that, our minds were freed by the Dark Lady.',26124),
(29398,'enUS','A pact was made, $g brother:sister;! We vowed vengeance against the Lich King! For what he had done to us! We battled the Scourge as Forsaken, pushing them back into the Plaguelands and freeing Tirisifal! You and I were champions of the Forsaken!','A pact was made, $g brother:sister;! We vowed vengeance against the Lich King! For what he had done to us! We battled the Scourge as Forsaken, pushing them back into the Plaguelands and freeing Tirisifal! You and I were champions of the Forsaken!',26124),
(29399,'enUS','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals - AGAIN. You were once a hero and you can be again. Fight, damn you! Fight his control!','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals - AGAIN. You were once a hero and you can be again. Fight, damn you! Fight his control!',26124),
(29400,'enUS','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Tirisfal! This world is worth saving!','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Tirisfal! This world is worth saving!',26124),
(29401,'enUS','Do it, $n! Put me out of my misery!','Do it, $n! Put me out of my misery!',26124),
(29402,'enUS','%s dies from his injuries.','%s dies from his injuries.',26124),
(29403,'enUS','Come ta finish da job, mon?','Come ta finish the job, mon?',26124),
(29404,'enUS','Dis troll gonna stand for da...','Dis troll gonna stand for da...',26124),
(29405,'enUS','$n? Mon?','$n? Mon?',26124),
(29406,'enUS','$n, I\'d recognize dem tusks anywhere... What... What have dey done ta you, mon?','$n, I\'d recognize dem tusks anywhere... What... What have dey done ta you, mon?',26124),
(29407,'enUS','You don\'t remember me, mon? Damn da Scourge! Dey gone ta drain you of everytin\' dat made ya a mojo masta. Every last ounce a good... Everytin\' dat made ya a troll hero, mon!','You don\'t remember me, mon? Damn da Scourge! Dey gone ta drain you of everytin\' dat made ya a mojo masta. Every last ounce a good... Everytin\' dat made ya a troll hero, mon!',26124),
(29408,'enUS','TINK, $n. Tink back, mon! We be Darkspear, mon! Bruddas and sistas! Remember when we fought da Zalazane and done took he head and freed da Echo Isles? MON! TINK! You was a champion of da Darkspear trolls!\n','TINK, $n. Tink back, mon! We be Darkspear, mon! Bruddas and sistas! Remember when we fought da Zalazane and done took he head and freed da Echo Isles? MON! TINK! You was a champion of da Darkspear trolls!',26124),
(29409,'enUS','Listen ta me, $g brudda:sista;. You must fight against da Lich King\'s control. He be a monster dat want ta see dis world - our world - be ruined. Don\'t let he use you ta accomplish he goals. You be a hero once and you be a hero again! Fight it, mon! Fight he control!','Listen ta me, $g brudda:sista;. You must fight against da Lich King\'s control. He be a monster dat want ta see dis world - our world - be ruined. Don\'t let he use you ta accomplish he goals. You be a hero once and you be a hero again! Fight it, mon! Fight he control!',26124),
(29410,'enUS','Der... Der\'s no more time for me. I be done for. Finish me off, $n. Do it or dey\'ll kill us both. $n... Remember Sen\'jin Village, mon! Dis world be worth saving!','Der... Der\'s no more time for me. I be done for. Finish me off, $n. Do it or dey\'ll kill us both. $n... Remember Sen\'jin Village, mon! Dis world be worth saving!',26124),
(29411,'enUS','Do it, $n! Put me out a me misery!','Do it, $n! Put me out a me misery!',26124),
(29412,'enUS','%s dies from his injuries.','%s dies from his injuries.',26124),
(29413,'enUS','Hrm, what a strange tree. I must investigate.','Hrm, what a strange tree. I must investigate.',26124),
(29414,'enUS','One day, Rejek be mighty warrior.','',26124),
(29415,'enUS','What\'s this!? This isn\'t a tree at all! Guards! Guards!','What\'s this!? This isn\'t a tree at all! Guards! Guards!',26124),
(29416,'enUS','Stormwind Harbor','Stormwind Harbor',26124),
(29417,'enUS','Trying to reach Auberdine or Valiance Keep?  You can find Stormwind Harbor if you head through the Canals, between the Cathedral District and the Park.','Trying to reach Auberdine or Valiance Keep?  You can find Stormwind Harbor if you head through the Canals, between the Cathedral District and the Park.',26124),
(29418,'enUS','Stormwind Harbor is the fastest way to get to Auberdine or Valiance Keep.  You can find it between the Cathedral District and the Park.','Stormwind Harbor is the fastest way to get to Auberdine or Valiance Keep.  You can find it between the Cathedral District and the Park.',26124),
(29419,'enUS','Greetings, $c. I trust that you bring me good news concerning the Worldwide Invitational event? If you are, then surely that means you were given a secret code to tell me. In return for your code I will give you a gift, Tyrael\'s Hilt.$B$BJust whisper it in my ear when you are ready.','Greetings, $c. I trust that you bring me good news concerning the Worldwide Invitational event? If you are, then surely that means you were given a secret code to tell me. In return for your code I will give you a gift, Tyrael\'s Hilt.$B$BJust whisper it in my ear when you are ready.',26124),
(29420,'enUS','I would like to whisper my secret code to you to receive Tyrael\'s Hilt.','I would like to whisper my secret code to you to receive Tyrael\'s Hilt.',26124),
(29421,'enUS','The courier has arrived!','The courier has arrived!',26124),
(29422,'enUS','$g He\'s:She\'s; finally here! The courier is here!','$g He\'s:She\'s; finally here! The courier is here!',26124),
(29423,'enUS','Let $g him:her; through! Quickly, courier, to the High General!','Let $g him:her; through! Quickly, courier, to the High General!',26124),
(29424,'enUS','','I find you wanting.',26124),
(29425,'enUS','','Die!',26124),
(29426,'enUS','','Beg for your life. Plead. It will do you no good!',26124),
(29427,'enUS','','Eternal damnation is your future.',26124),
(29428,'enUS','','You killed me and now I will kill you... over and over!',26124),
(29429,'enUS','','There is no escape. There is only my wrath!',26124),
(29430,'enUS','','My judgment is final.',26124),
(29431,'enUS','','Burn in the fires of my fury!',26124),
(29432,'enUS','As you wish, Drakuru.','As you wish, Drakuru.',26124),
(29433,'enUS','We feel it best to position them here, where they might come to terms with their impending fate.','',26124),
(29434,'enUS','This is their destiny....','',26124),
(29435,'enUS','The blight slowly seeps into their bodies, gradually preparing them for their conversion.','',26124),
(29436,'enUS','This special preparation grants them unique powers far greater than they would otherwise know.','',26124),
(29437,'enUS','Soon, the master will grant them the dark gift, making them fit to serve the Lich King for eternity!','',26124),
(29438,'enUS','Stay for as long as you like, $n. Glory in the fruits of your labor!','',26124),
(29439,'enUS','Your service has been invaluable in fulfilling the master\'s plan. May you forever grow in power....','',26124),
(29440,'enUS','Farewell.','',26124),
(29441,'enUS','Behold, mon! We be creatin\' da greatest Scourge army ever seen!','',26124),
(29442,'enUS','These be da first of many! We shall sweep across Zul\'Drak like da wind....','',26124),
(29443,'enUS','Make haste, $n. Use the portal!','',26124),
(29444,'enUS','We are the chosen ones, $n. Death knights of the Scourge, sent to sow the seeds of the master\'s destruction.','',26124),
(29445,'enUS','I missed the gate to Acherus, Orbaz. Could you please open another?','I missed the gate to Acherus, Orbaz. Could you please open another?',26124),
(29446,'enUS','%s motions toward the icy water below.','',26124),
(29447,'enUS','','These monsters killed my father and kidnapped my sister.  They\'re going to pay for this!',26124),
(29448,'enUS','Round 2 of the Battle for the Strand of the Ancients begins in 1 minute.','',26124),
(29449,'enUS','Round 2 begins in 30 seconds.  Prepare yourselves!','',26124),
(29450,'enUS','Let the battle for the Strand of the Ancients begin!','',26124),
(29451,'enUS','Abomination Guts!','Abomination Guts!',26124),
(29452,'enUS','Ghoul Drool!','Ghoul Drool!',26124),
(29453,'enUS','Blight Crystal!','Blight Crystal!',26124),
(29454,'enUS','Revel in their suffering, death knights! Let it embolden your spirits!','',26124),
(29455,'enUS','Concentrate your attacks on the weak!','',26124),
(29456,'enUS','Hold the line!','',26124),
(29457,'enUS','Lambs to the slaughter...','',26124),
(29458,'enUS','The Scourge will consume you!','',26124),
(29459,'enUS','Why fight it? Give in, maggot!','',26124),
(29460,'enUS','Who wants to see Rejek\'s new helmet?','',26124),
(29461,'enUS','I wanna see!','',26124),
(29462,'enUS','Show me too!','',26124),
(29463,'enUS','Ok, Rejek show!','',26124),
(29464,'enUS','What you think?','',26124),
(29465,'enUS','Metalhead ate Rejek! Run!','',26124),
(29466,'enUS','Rejek like! If helmet scares pups, Rejek can\'t wait to see what it does to big-tongue cowards!','',26124),
(29467,'enUS','Suffer, insects!','',26124),
(29468,'enUS','I extend my gratitude for your aid in this matter, $n, although I also admit mild regret that you will not volunteer for our experiments...','',26124),
(29469,'enUS','Master Putress, a bat rider approaches!','Master Putress, a bat rider approaches!',26124),
(29470,'enUS','He must have news from the field.','He must have news from the field.',26124),
(29471,'enUS','Feel yourself change!','',26124),
(29472,'enUS','There\'s no time left! All remaining forces, attack the invaders!','',26124),
(29473,'enUS','The gate has been breached! Quickly, divert forces to deal with these invaders!','',26124),
(29474,'enUS','','Greetings traveler.',26124),
(29475,'enUS','I wish to travel to Light\'s Breach.','I wish to travel to Light\'s Breach.',26124),
(29476,'enUS','','Thank you for your aid in this desperate time, $n.  May the Light grant you speed and strength in the face of darkness.',26124),
(29477,'enUS','','You, honored paladin.  Please come here..',26124),
(29478,'enUS','Yes, Bishop.','',26124),
(29479,'enUS','','Spread the word that another artifact  will soon be brought to our defenders.',26124),
(29480,'enUS','','And $gbrother:sister;, be wary of scourge ambushes.',26124),
(29481,'enUS','Yes, lord.  I will, lord.','',26124),
(29482,'enUS','','Welcome to my kitchen! We prepare some of the finest food in Dalaran here.',26124),
(29483,'enUS','I\'m here for cooking training.','I\'m here for cooking training.',26124),
(29484,'enUS','Good day, friend.','',26124),
(29485,'enUS','I was told you could get me to Light\'s Breach....','I was told you could get me to Light\'s Breach....',26124),
(29486,'enUS','Hope you take it to big-tongues good. It about time they go away.','',26124),
(29487,'enUS','Great battle still going on at Sparktouched Haven.$B$BMaybe you find time to help sometime?','',26124),
(29488,'enUS','Greetings, $c!  Stormwind Harbor is quite a sight to behold.  It\'s even better seen from the air.  How would you like a bird\'s eye view of the harbor?','',26124),
(29489,'enUS','I\'d like to take a flight around Stormwind Harbor.','I\'d like to take a flight around Stormwind Harbor.',26124),
(29490,'enUS','','I do not believe you possess the mental acuity to grasp the nature of portal magic.$B$BHowever, you can use the crystal behind me to teleport to the ruins below Dalaran in Crystalsong Forest.',26124),
(29491,'enUS','','As a mage, you are one of a select group that can conjure a portal to transport you back to this very place.  I can teach you if you are ready.$B$BAnd remember that you can always use the crystal behind me to teleport down to the ruins beneath Dalaran in Crystalsong Forest.',26124),
(29492,'enUS','You have time?  Soo-nee teach you good song!','',26124),
(29493,'enUS','Greetings, $c.','Greetings, $c.',26124),
(29494,'enUS','I am ready to be teleported to Dalaran.','I am ready to be teleported to Dalaran.',26124),
(29495,'enUS','Welcome, friend, to the barbershop! Come for a cut? A coloring? Something else, perhaps?$B$BWe can groom facial hair, perform piercings, ink night elf tattoos, and even reshape draenei horns and tendrils!$B$BHave a seat and we\'ll get right to work. You\'re only a few coins away from a new, more attractive you...','Welcome, friend, to the barbershop! Come for a cut? A coloring? Something else, perhaps?$B$BWe can groom facial hair, perform piercings, ink night elf tattoos, and even reshape draenei horns and tendrils!$B$BHave a seat and we\'ll get right to work. You\'re only a few coins away from a new, more attractive you...',26124),
(29498,'enUS','Welcome, friend, to the barbershop! Come for a cut? A coloring? Something else, perhaps?$B$BWe can groom facial hair, perform piercings, reshape tusks and horns, and even modify undead features!$B$BHave a seat and we\'ll get right to work. You\'re only a few coins away from a new, more attractive you...','Welcome, friend, to the barbershop! Come for a cut? A coloring? Something else, perhaps?$B$BWe can groom facial hair, perform piercings, reshape tusks and horns, and even modify undead features!$B$BHave a seat and we\'ll get right to work. You\'re only a few coins away from a new, more attractive you...',26124),
(29499,'enUS','Grab a pint!','',26124),
(29500,'enUS','I was sent to get some of your famous hard ale. Have any to spare?','I was sent to get some of your famous hard ale. Have any to spare?',26124),
(29501,'enUS','Not sure who told you I had some ale left, but keep it quiet will ya? There ain\'t no way I have enough for the whole camp.','',26124),
(29502,'enUS','Ravage the living, minions!','',26124),
(29503,'enUS','This is the end!','',26124),
(29504,'enUS','The sacking of the Scarlet Enclave will be a lesson for history!','',26124),
(29505,'enUS','There is nowhere to run...','',26124),
(29506,'enUS','Let the destruction of this place serve as a lesson to all those who would dare oppose the Scourge!','',26124),
(29507,'enUS','You thought to wipe the undead from these lands? Taste the true might of the Scourge, and despair!','',26124),
(29508,'enUS','Leave no survivors!','',26124),
(29509,'enUS','Soon you will belong to the Scourge.','',26124),
(29510,'enUS','Where is your Light now, Crusaders?','',26124),
(29511,'enUS','Bow before your king!','',26124),
(29512,'enUS','The Light has abandoned you!','',26124),
(29513,'enUS','There is no Light. Only darkness!','',26124),
(29514,'enUS','Come to me, Crusaders. I will remake you!','',26124),
(29515,'enUS','Cower before my terrible creations!','',26124),
(29516,'enUS','Feast, my children! Feast upon the flesh of the living!','',26124),
(29517,'enUS','Lay down your arms and surrender your souls!','',26124),
(29518,'enUS','$3486W Centrifuge Constructs remain.  We must find and destroy them to disable Varos Cloudstrider\'s protective shield.  The constructs should be about halfway up The Oculus, on the Band of Acceleration.','',26124),
(29519,'enUS','One Centrifuge Construct remains.  We must find and destroy it to disable Varos Cloudstrider\'s protective shield.  The construct should be about halfway up The Oculus, on the Band of Acceleration.','',26124),
(29520,'enUS','The shield is down; Varos is vulnerable!  Defeating him should disperse the Azure Ring Guardians and allow us access to the upper bands.  Varos is on a floating platform about halfway up The Oculus, on the Band of Acceleration.','',26124),
(29521,'enUS','Mage-Lord Urom is our next target.  He should be hiding on one of the floating platforms on the Band of Transmutation, near the top of The Oculus.  Be warned, Urom is a powerful conjurer; he may not be alone.','',26124),
(29522,'enUS','Ley-Guardian Eregos is all that now stands between us and control of The Oculus.  He\'s flying above the Band of Alignment, at the very top of The Oculus.  Eregos is incredibly powerful; stay on my back when we engage him and leave the fighting to me.','',26124),
(29523,'enUS','We\'ve wrested control of The Oculus from the forces of Malygos.  You\'re not getting any lighter, little one.  My wings itch for the open sky.','',26124),
(29524,'enUS','','',26124),
(29525,'enUS','I wish to travel to Light\'s Breach.','I wish to travel to Light\'s Breach.',26124),
(29526,'enUS','You may serve me yet.','',26124),
(29527,'enUS','By all means, don\'t assess the situation, you halfwit! Just jump into the fray!','',26124),
(29528,'enUS','Skarvald, you incompetent slug! Return and make yourself useful!','',26124),
(29529,'enUS','See... you... soon.','',26124),
(29530,'enUS','There\'s no... greater... glory.','',26124),
(29531,'enUS','Dalronn! See if you can muster the nerve to join my attack!','',26124),
(29532,'enUS','Jarggn olkt!','',26124),
(29533,'enUS','Pfagh! What sort of necromancer lets death stop him? I knew you were worthless!','',26124),
(29534,'enUS','Not... over... yet.','',26124),
(29535,'enUS','A warrior\'s death.','',26124),
(29536,'enUS','Varos Cloudstrider and his ring guardians protect the second ring.  Your drakes are more than a match for the ring guardians, but Varos stands behind an impenetrable shield created from the energy of the Oculus itself.  Ten centrifuge constructs power the shield from the ring and platforms above.  Destroy them and Varos will be vulnerable.','Varos Cloudstrider and his ring guardians protect the second ring.  Your drakes are more than a match for the ring guardians, but Varos stands behind an impenetrable shield created from the energy of the Oculus itself.  Ten centrifuge constructs power the shield from the ring and platforms above.  Destroy them and Varos will be vulnerable.',26124),
(29537,'enUS','The trickster Mage-Lord Urom protects the third ring.  He will appear alone and defenseless, but do not be fooled by appearances!  Urom is a powerful conjurer who commands a menagerie of Phantasmal creatures.  Seek him out above.','The trickster Mage-Lord Urom protects the third ring.  He will appear alone and defenseless, but do not be fooled by appearances!  Urom is a powerful conjurer who commands a menagerie of Phantasmal creatures.  Seek him out above.',26124),
(29538,'enUS','Your greatest challenge lies ahead.  Ley-Guardian Eregos is a Blue dragon of immense power. You will find him flying above the uppermost ring.','Your greatest challenge lies ahead.  Ley-Guardian Eregos is a Blue dragon of immense power. You will find him flying above the uppermost ring.',26124),
(29539,'enUS','What should we do next?','What should we do next?',26124),
(29540,'enUS','The zeppelin to Vengeance Landing has just arrived! All aboard for Howling Fjord!','The zeppelin to Vengeance Landing has just arrived! All aboard for Howling Fjord!',26124),
(29541,'enUS','The Halls of Stone, a level 77-79 dungeon within Storm Peaks, is now available for testing. Please be in your full group before teleporting to the dungeon. Meeting Stones are not available for this dungeon yet.\n\nTo leave the Halls of Stone, simply exit through the normal exit inside the dungeon and you will be returned here. If you die and release, you should teleport back from this NPC.','',26124),
(29542,'enUS','I\'m in my group and ready to teleport to the Halls of Stone!','I\'m in my group and ready to teleport to the Halls of Stone!',26124),
(29543,'enUS','Take me back to the Halls of Stone!','Take me back to the Halls of Stone!',26124),
(29544,'enUS','I... I do not know.','',26124),
(29545,'enUS','The zeppelin to Undercity has just arrived! All aboard for Tirisfal Glades!','The zeppelin to Undercity has just arrived! All aboard for Tirisfal Glades!',26124),
(29546,'enUS','','Say, Modoru. Where did you get those... ah... \"wonderful\" robes of yours, hmmm?',26124),
(29547,'enUS','','Oh. Oh... I see. How nice!',26124),
(29548,'enUS','','%s bites back a laugh.',26124),
(29549,'enUS','The zeppelin to Warsong Hold has just arrived! All aboard for Borean Tundra!','The zeppelin to Warsong Hold has just arrived! All aboard for Borean Tundra!',26124),
(29550,'enUS','%s beams, unaware that she is teasing him, answering in his thickly-accented Common.','',26124),
(29551,'enUS','The zeppelin to Orgrimmar has just arrived! All aboard for Durotar!','The zeppelin to Orgrimmar has just arrived! All aboard for Durotar!',26124),
(29552,'enUS','Well! You see, was gift from Grandmother Oluba. She hand-weave from finest silk on Draenor! Am quite proud of, yes.','',26124),
(29553,'enUS','%s snickers, nuzzling into Sentinel Sweetspring\'s ankles.','',26124),
(29554,'enUS','%s purrs up at Sentinel Sweetspring.','',26124),
(29555,'enUS','','%s grins at Sentinel Amberline across the camp, waggling her long eyebrows suggestively.',26124),
(29556,'enUS','Crush....','',26124),
(29557,'enUS','','%s huffs with annoyance, glaring briefly at Sentinel Sweetspring before turning away with her nose in the air.',26124),
(29558,'enUS','Ha.... ha... hah....','',26124),
(29559,'enUS','Break.... you....','',26124),
(29560,'enUS','Uuuuhhhhhhhhhh......','',26124),
(29561,'enUS','Warning: life form pattern not recognized. Archival processing terminated.  Continued interference will result in targeted response.','',26124),
(29562,'enUS','','What are you doing all the way back here? You need to get back to Stratholme immediately!$B$BShall I teleport you to Stratholme?',26124),
(29563,'enUS','','You shouldn\'t have come... now you will die!',26124),
(29564,'enUS','','Why must it be this way?',26124),
(29565,'enUS','Yes, please!','Yes, please!',26124),
(29566,'enUS','','You had it coming!',26124),
(29567,'enUS','','My burden grows heavier...',26124),
(29568,'enUS','','This is your fault!',26124),
(29569,'enUS','','Target destroyed.',26124),
(29570,'enUS','','So much lost time... that you\'ll never get back!',26124),
(29572,'enUS','','Reevaluating threat index.',26124),
(29573,'enUS','Life form purged.','',26124),
(29574,'enUS','','I hope you all rot! I never... wanted... this.',26124),
(29575,'enUS','','Security breach in progress. Analysis of historical archives transferred to lower-priority queue. Countermeasures engaged.',26124),
(29576,'enUS','','Threat index threshold exceeded.  Celestial archive aborted. Security level heightened.',26124),
(29577,'enUS','Critical threat index. Void analysis diverted. Initiating sanitization protocol.','',26124),
(29578,'enUS','','Go find those hidden plagued grain crates and use your Arcane Disruptor on them!$B$BArthas will then have the evidence he needs to begin the culling of Stratholme.',26124),
(29579,'enUS','Alert: security fail-safes deactivated. Beginning memory purge and... ','',26124),
(29580,'enUS','System online. Life form pattern recognized.  Welcome, Branbronzan.  Query?','',26124),
(29581,'enUS','','What are you doing here?$B$BArthas is at the entrance to Stratholme right now and you should be with him! Go!',26124),
(29582,'enUS','Soft, vulnerable shells. Brief fragile lives. You cannot escape the curse of flesh!','',26124),
(29583,'enUS','Folvynn buul hrom onn!','',26124),
(29584,'enUS','Flesh is no match for iron!','',26124),
(29585,'enUS','Armies of iron will smother the world!','',26124),
(29586,'enUS','Loken will not rest... until the forge is retaken! You change... nothing!','',26124),
(29587,'enUS','My master has a message for you...','',26124),
(29588,'enUS','%s calls for assistance!','',26124),
(29589,'enUS','It is this: Welcome.','',26124),
(29590,'enUS','Welcome to a cold death.','',26124),
(29591,'enUS','Darkness waits.','',26124),
(29592,'enUS','I join... the night.','',26124),
(29593,'enUS','','You know what they say about curiosity....',26124),
(29594,'enUS','','I\'ll give you more than you can handle!',26124),
(29595,'enUS','','There\'s plenty of me to go around.',26124),
(29596,'enUS','','Now to finish the job!',26124),
(29597,'enUS','','Death becomes you.',26124),
(29598,'enUS','','Damn the... luck.',26124),
(29599,'enUS','Chaos beckons.','',26124),
(29600,'enUS','%s roars in pain as its spirit parts bodies with its host.','%s roars in pain as its spirit parts bodies with its host.',26124),
(29601,'enUS','Reality... unwoven.','',26124),
(29602,'enUS','Indestructible.','',26124),
(29603,'enUS','Expiration is necessary.','',26124),
(29604,'enUS','Of course.','',26124),
(29605,'enUS','Noo!','',26124),
(29606,'enUS','Tharon\'ja sees all! The work of mortals shall not end the eternal dynasty!','',26124),
(29607,'enUS','Kill!','',26124),
(29608,'enUS','Aaggh!','',26124),
(29609,'enUS','Back!','',26124),
(29610,'enUS','Bleed!','',26124),
(29611,'enUS','As Tharon\'ja predicted!','',26124),
(29612,'enUS','As it was written!','',26124),
(29613,'enUS','Your flesh serves Tharon\'ja now!','',26124),
(29614,'enUS','Tharon\'ja has a use for your mortal shell!','',26124),
(29615,'enUS','No! A taste... all too brief!','',26124),
(29616,'enUS','Agghh!! Tharon\'ja will have more!','',26124),
(29617,'enUS','Im... impossible! Tharon\'ja is eternal! Tharon\'ja... is....','',26124),
(29618,'enUS','','Stay. Enjoy your final moments.',26124),
(29619,'enUS','','Finish it! Finish it! Kill me, or I swear by the Dragonqueen you\'ll never see daylight again!',26124),
(29620,'enUS','','Now we\'ve come to the truth!',26124),
(29621,'enUS','','Dragonqueen... Life-Binder... preserve... me.',26124),
(29622,'enUS','What is this? Mok-thorin ka! Kill them!','',26124),
(29623,'enUS','Our task is not yet done!','',26124),
(29624,'enUS','Gaagh...','',26124),
(29625,'enUS','How do I train my pet?','How do I train my pet?',26124),
(29626,'enUS','Just like hunters, pets can choose specializations. Ferocious pets, like cats, can dish out damage but can\'t take it as well. Tenacious pets, like turtles, are more defensive and can occupy an enemy\'s attention while you stay at range. Cunning pets, like spiders, have a mix of offensive and defensive abilities and are particularly useful in Battlegrounds and Arenas.$b$bEach pet comes with a default specialization, but you can change it if you like.','Just like hunters, pets can choose specializations. Ferocious pets, like cats, can dish out damage but can\'t take it as well. Tenacious pets, like turtles, are more defensive and can occupy an enemy\'s attention while you stay at range. Cunning pets, like spiders, have a mix of offensive and defensive abilities and are particularly useful in Battlegrounds and Arenas.$b$bEach pet comes with a default specialization, but you can change it if you like.',26124),
(29627,'enUS','What? Where in the-- don\'t just stand around lads; kill somebody!','',26124),
(29628,'enUS','Now we\'re gettin\' someplace!','',26124),
(29629,'enUS','Is that all you\'ve...','',26124),
(29630,'enUS','I wish to unlearn my talents.','I wish to unlearn my talents.',26124),
(29631,'enUS','Are you certain?$B$BThere is no turning back once I wipe the knowledge of the talents you have learned from your mind.','Are you certain?$B$BThere is no turning back once I wipe the knowledge of the talents you have learned from your mind.',26124),
(29632,'enUS','I am certain. Please proceed.','I am certain. Please proceed.',26124),
(29633,'enUS','Very well. It is done.','Very well. It is done.',26124),
(29634,'enUS','We need more flesh!','',26124),
(29635,'enUS','The Highlord has requested more abominations!','',26124),
(29636,'enUS','Quicken your pace, maggots!','',26124),
(29637,'enUS','The Argent Dawn dogs will be consumed by the shadow of the Scourge!','',26124),
(29638,'enUS','Rise up, minions! To the Scourge front!','',26124),
(29639,'enUS','Double your efforts! The final assault draws near!','',26124),
(29640,'enUS','Yes! YES! More souls for the master!','',26124),
(29641,'enUS','Wi... Will it hurt?','Wi... Will it hurt?',26124),
(29642,'enUS','It tingles...','It tingles...',26124),
(29643,'enUS','Is it too late to change my mind? How about you just kill me instead?','Is it too late to change my mind? How about you just kill me instead?',26124),
(29644,'enUS','You\'re a monster!','You\'re a monster!',26124),
(29645,'enUS','Please! Spare me! I...','Please! Spare me! I...',26124),
(29646,'enUS','The horror! THE HORROR!!','The horror! THE HORROR!!',26124),
(29647,'enUS','Oh yes. Immensely. The pain will probably render you unconscious - hence the vat of slime you\'re floating in!','',26124),
(29648,'enUS','That\'s how you know it\'s working.','',26124),
(29649,'enUS','I AM going to kill you. What\'s the rush?','',26124),
(29650,'enUS','Flattery will get you nowhere.','',26124),
(29651,'enUS','Don\'t be ridiculous. Where would you even go if I did spare you? We just finished up eradicating your civilization. Remember?','',26124),
(29652,'enUS','Stop!','',26124),
(29653,'enUS','That enough!','',26124),
(29654,'enUS','Back off!','',26124),
(29655,'enUS','Fight over! You listen now!','',26124),
(29656,'enUS','Like music to my ears. Scream for me, human.','',26124),
(29657,'enUS','Time for listening. You listen to son of Zart, best scrapper Frenzyheart ever see!','',26124),
(29658,'enUS','Rakat, you stupid. You lose your nose if you keep sticking it where claws go. You lose nose, you can\'t smell. You can\'t smell, you hunt bad, you useless.','',26124),
(29659,'enUS','Ajark, you standing like rock. Rakat move more. You move or you get hurt by wasp sting or bristlepine tusk, you see. Move more!','',26124),
(29660,'enUS','Faster. Fight faster! Both of you slow like bigtongue. Maybe I dump you in water, make you slimy like bigtongues too, make them take you in.','',26124),
(29661,'enUS','Guard bellies or bellies get opened up! You hitting higher body, not watching lower.','',26124),
(29662,'enUS','Okay. Fight again. No more stupid.','',26124),
(29663,'enUS','GO!','',26124),
(29664,'enUS','Step forth disciple. Show me what you have learned.','',26124),
(29665,'enUS','Its spells would be less threatening if its incantations were slowed by your icy touch...','',26124),
(29666,'enUS','Do not let it consider its next spell so freely, disciple... freeze its mind.','',26124),
(29667,'enUS','It is time for your learning to be put to the test. Step forth.','',26124),
(29668,'enUS','Do not let the ice in your blood slow your step. Prove your prowess, disciple.','',26124),
(29669,'enUS','You have stood and listened long enough. Step forth.','',26124),
(29670,'enUS','Prove that you understand my teachings, disciple.','',26124),
(29671,'enUS','It is time for your challenge disciple. Use my teachings well.','',26124),
(29672,'enUS','','I will vanquish your soul!',26124),
(29673,'enUS','You are not overwhelmed just yet disciple... let the hungering cold of death halt this onslaught.','',26124),
(29674,'enUS','Frozen solid, ripe for the slaughter. Let loose a howling blast and shatter them into pieces, disciple.','',26124),
(29675,'enUS','','You were a fool to challenge the power of the Lich King!',26124),
(29676,'enUS','','Your will is done, my king!',26124),
(29677,'enUS','','Another soul for my master!',26124),
(29678,'enUS','','Your death approaches....',26124),
(29679,'enUS','','Go now to my master!',26124),
(29680,'enUS','','Your end is inevitable.',26124),
(29681,'enUS','','Yor-guul mak!',26124),
(29682,'enUS','','Any last words?',26124),
(29683,'enUS','','Nooo! I did not come this far... to...',26124),
(29684,'enUS','','My liege! I have done as you asked, and now beseech you for your blessing!',26124),
(29685,'enUS','','I\'ll never forget what you did for Thassarian.  I will always be in your debt.',26124),
(29686,'enUS','','The sensation is... beyond my imagining. I am yours to command, my king.',26124),
(29687,'enUS','','I will be happy to slaughter them in your name! Come, enemies of the Scourge! I will show you the might of the Lich King!',26124),
(29688,'enUS','Your sacrifice is a testament to your obedience.  Indeed you are worthy of this charge. Arise, and forever be known as Svala Sorrowgrave!','',26124),
(29689,'enUS','Your first test awaits you. Destroy our uninvited guests.','',26124),
(29690,'enUS','Here is where I sacrificed everything to free my father. Now I come to destroy it...','',26124),
(29691,'enUS','I am ready, Highlord. Let the siege of Light\'s Hope begin!','I am ready, Highlord. Let the siege of Light\'s Hope begin!',26124),
(29692,'enUS','My father once told me that life is meaningless... That it is in death that we are truly tested. I sense that the siege of Light\'s Hope will give meaning to his words. We strike soon, $n. Stand ready.','',26124),
(29693,'enUS','Death knights of Acherus, hear your master\'s call! The siege of Light\'s Hope is underway! We rally at the mill!\n','',26124),
(29694,'enUS','Soldiers of the Scourge, stand ready! Prepare to unleash your fury upon the Argent Dawn!','',26124),
(29695,'enUS','','Let us see what atrocity we can pull from the shadow realm this time...',26124),
(29696,'enUS','The sky weeps at the glorious devastation of these lands! Soon, Azeroth\'s futile tears will rain down upon us!','The sky weeps at the glorious devastation of these lands! Soon, Azeroth\'s futile tears will rain down upon us!',26124),
(29697,'enUS','Death knights of Acherus, the death march begins!','Death knights of Acherus, the death march begins!',26124),
(29698,'enUS','EVENT STEP 005 YELL! RAWR!','EVENT STEP 005 YELL! RAWR!',26124),
(29699,'enUS','Soldiers of the Scourge, death knights of Acherus, minions of the darkness: hear the call of the Highlord!','Soldiers of the Scourge, death knights of Acherus, minions of the darkness: hear the call of the Highlord!',26124),
(29700,'enUS','RISE!','RISE!',26124),
(29701,'enUS','','A druid! How curious... I wonder how it got in there.',26124),
(29702,'enUS','','Ghouls? We have quite enough of those already.',26124),
(29703,'enUS','Here is where I sacrificied everything to free my father. Now I come to destroy it...','',26124),
(29704,'enUS','','Wha... where am I?',26124),
(29705,'enUS','Mr. Bigglesworth. The last living creature in Naxxramas, this cat is said to be the last thread connecting Kel\'thuzad to his mortal life. It is said that any who dare to harm a hair on his head doom themselves to... wait a second, what is he doing on there?!','',26124),
(29706,'enUS','%s pounds on the display a few times.','',26124),
(29707,'enUS','Well, nevermind. I\'m sure no one would be foolish enough to lay a hand on Kel\'thuzard precious pet.','',26124),
(29708,'enUS','Quick!  Use the ashes on Ursoc\'s corpse.  We must purge its corruption!','',26124),
(29709,'enUS','Shur\'nab... shur\'nab... Yogg-Saron!','',26124),
(29710,'enUS','Scourge filth! DIE!','Scourge filth! DIE!',26124),
(29711,'enUS','The Crusade will be victorious!','The Crusade will be victorious!',26124),
(29712,'enUS','I will present your head to Abbendis myself!','I will present your head to Abbendis myself!',26124),
(29713,'enUS','You\'re not welcome in these lands, monster!','You\'re not welcome in these lands, monster!',26124),
(29714,'enUS','Let the purging begin!','Let the purging begin!',26124),
(29715,'enUS','By the Light be cleansed!','By the Light be cleansed!',26124),
(29716,'enUS','Scourge filth! DIE!','Scourge filth! DIE!',26124),
(29717,'enUS','The Crusade will be victorious!','The Crusade will be victorious!',26124),
(29718,'enUS','I will present your head to Abbendis myself!','I will present your head to Abbendis myself!',26124),
(29719,'enUS','You\'re not welcome in these lands, monster!','You\'re not welcome in these lands, monster!',26124),
(29720,'enUS','Let the purging begin!','Let the purging begin!',26124),
(29721,'enUS','By the Light be cleansed!','By the Light be cleansed!',26124),
(29722,'enUS','The skies turn red with the blood of the fallen! The Lich King watches over us, minions! Leave only ashes and misery in your destructive wake!','The skies turn red with the blood of the fallen! The Lich King watches over us, minions! Leave only ashes and misery in your destructive wake!',26124),
(29723,'enUS','Stand fast, brothers and sisters! The Light will prevail!','',26124),
(29724,'enUS','Scourge armies approach!','',26124),
(29725,'enUS','%s falls unconscious.','%s falls unconscious.',26124),
(29726,'enUS','Rise, minions! Destroy them!','',26124),
(29727,'enUS','Kneel before the Highlord!','',26124),
(29728,'enUS','You stand no chance!','',26124),
(29729,'enUS','The Scourge will destroy this place!','',26124),
(29730,'enUS','Your life is forfeit!','',26124),
(29731,'enUS','Life is meaningless without suffering!','',26124),
(29732,'enUS','How much longer will your forces hold out?','',26124),
(29733,'enUS','The Argent Dawn is finished!','',26124),
(29734,'enUS','Spare no one!','',26124),
(29735,'enUS','What is this?! My... I cannot strike...','',26124),
(29736,'enUS','OBEY ME, BLADE!','',26124),
(29737,'enUS','You will do as I command! I am in control here!','',26124),
(29738,'enUS','I... I cannot... The blade fights me...','',26124),
(29739,'enUS','What is happening to me?','',26124),
(29740,'enUS','Power... wanes...','',26124),
(29741,'enUS','Ashbringer defies me...','',26124),
(29742,'enUS','Minions, come to my aid!','',26124),
(29743,'enUS','You cannot win, Darion!','',26124),
(29744,'enUS','Have you learned nothing, boy? You have become all that your father fought against! Like that coward, Arthas, you allowed yourself to be consumed by the darkness, the hate... feeding upon the misery of those you tortured and killed!','',26124),
(29745,'enUS','Your master knows what lies beneath the chapel. That is why he dares not show his face! He\'s sent you and your death knights to meet their doom, Darion.','',26124),
(29746,'enUS','What you are feeling right now is the anguish of a thousand lost souls! Souls that you and your master brought here! The Light will tear you apart, Darion!','',26124),
(29747,'enUS','My powers are fading, Highlord!','',26124),
(29749,'enUS','What is happening? What is this?','',26124),
(29750,'enUS','We are being consumed by the Light!','',26124),
(29751,'enUS','It is decimating our armies!','',26124),
(29752,'enUS','What should we do, Highlord?','',26124),
(29753,'enUS','Can\'t... focus...','',26124),
(29754,'enUS','It is overwhelming... cannot fight...','',26124),
(29755,'enUS','D... Dying...','',26124),
(29756,'enUS','Bring them before the chapel!','',26124),
(29757,'enUS','Fool! You\'ve led us into a trap! I won\'t die here, Mograine!','',26124),
(29758,'enUS','%s flees.','',26124),
(29759,'enUS','%s kneels in defeat before Tirion Fordring.','',26124),
(29760,'enUS','Stand down, death knights. We have lost. The Light... this place... no hope...','',26124),
(29761,'enUS','Save your breath, old man. It might be the last you ever draw.','',26124),
(29762,'enUS','My son! My dear, beautiful boy!','',26124),
(29763,'enUS','Ashbringer!','Ashbringer!',26124),
(29764,'enUS','I... It can\'t be...','I... It can\'t be...',26124),
(29765,'enUS','Bow your heads!','Bow your heads!',26124),
(29766,'enUS','Bow your heads!','Bow your heads!',26124),
(29767,'enUS','Father!','',26124),
(29768,'enUS','Argh... what... is...','',26124),
(29769,'enUS','Father, you have returned!','',26124),
(29770,'enUS','You have been gone a long time, Father. I thought...','',26124),
(29771,'enUS','%s hugs his father.','',26124),
(29772,'enUS','%s cries.','',26124),
(29773,'enUS','Nothing could have kept me away from here, Darion. Not from my home and family.','',26124),
(29774,'enUS','Father, I wish to join you in the war against the undead. I want to fight! I can sit idle no longer!','',26124),
(29775,'enUS','Darion Mograine, you are barely of age to hold a sword, let alone battle the undead hordes of Lordaeron! I could not bear losing you. Even the thought...\n','',26124),
(29776,'enUS','If I die, Father, I would rather it be on my feet, standing in defiance against the undead legions! If I die, let me die with you!','',26124),
(29777,'enUS','My son, there will come a day when you will command the Ashbringer and, with it, mete out justice across this land. I have no doubt that when that day finally comes, you will bring pride to our people and that Lordaeron will be a better place because of you. But, my son, that day is not today.\n','',26124),
(29778,'enUS','Do not forget...','',26124),
(29779,'enUS','Touching...','',26124),
(29780,'enUS','He is mine now...','',26124),
(29781,'enUS','You... betrayed me. You betrayed us all, monster! Face the might of Mograine!','',26124),
(29782,'enUS','Pathetic...','',26124),
(29783,'enUS','You\'re a damned monster, Arthas!','',26124),
(29784,'enUS','You were right, Fordring. I did send them in to die. Their lives are meaningless, but yours...','',26124),
(29785,'enUS','How simple it was to draw the great Tirion Fordring out of hiding. You\'ve left yourself exposed, paladin. Nothing will save you.','',26124),
(29786,'enUS','%s gasps for air.','',26124),
(29787,'enUS','ATTACK!!','',26124),
(29788,'enUS','APOCALYPSE!','',26124),
(29789,'enUS','Remember... always...\n','',26124),
(29790,'enUS','','Dearest shadow realm, grace us with the presence of one of your many denizens.',26124),
(29791,'enUS','','Let us coldly greet another inhabitant of the shadow realm...',26124),
(29792,'enUS','','What beast lies in store for us...',26124),
(29793,'enUS','','There are many lessons left to learn, let us move onto our next subject...',26124),
(29794,'enUS','','Moving on...',26124),
(29795,'enUS','','Skeletons. Simple play things, but there are lessons to be learned even here.',26124),
(29796,'enUS','','Skeletal mages. A perfect opportunity to display the utility of some of our powers.',26124),
(29797,'enUS','','Strange, I did not think there were any of those left in the shadow realm. Beware disciples, this one is a bit dangerous.',26124),
(29798,'enUS','','Disciples... you will find with time that many healing spells fall victim to the degeneration of our strikes.',26124),
(29799,'enUS','','Some healers lack the knowledge to counter the diseases that we master.',26124),
(29800,'enUS','','This lack of knowledge is just one more weakness among many. There is little hope against the power of death itself.',26124),
(29801,'enUS','Tirion!','',26124),
(29802,'enUS','%s collapses.','',26124),
(29803,'enUS','ARTHAS!!!!','',26124),
(29804,'enUS','What is this?','',26124),
(29805,'enUS','%s cackles maniacally.','',26124),
(29806,'enUS','The quality of this workmanship is pathetic. Not even fit for a Ghoul to wield.','',26124),
(29807,'enUS','You call this a weapon? Keep this up, knave and I\'ll see that you\'re brought back as one of them. Maybe then you will learn how to put your back into it.','',26124),
(29808,'enUS','If this is the qualilty one can expect in a weapon of the Argent Dawn, then it is only a matter of time before they fall.','',26124),
(29809,'enUS','I\'ve seen forks stronger than this. Forge it again!','',26124),
(29810,'enUS','Are you perhaps confused, mortal? The metal end is for stabbing, not pricking! Sharpen it again!','',26124),
(29811,'enUS','You are unfit to serve the Lich King even in undeath. Work hard and I may yet release you forever from this world. Fail me, and you will fuel the fires with your flesh.','',26124),
(29812,'enUS','Finally... home...','',26124),
(29813,'enUS','Me... back... master...','',26124),
(29814,'enUS','Me come back... master. Me... loyal servant.','',26124),
(29815,'enUS','Sorry... me gone... so long... master.','',26124),
(29816,'enUS','','I often find the trouble with ghouls is that they outlive their usefulness too quickly. Let us let death and decay reclaim these.',26124),
(29817,'enUS','','At times, their corpses can prove more useful than the ghouls were themselves.',26124),
(29818,'enUS','','Hmm...',26124),
(29819,'enUS','','Unfortunate.',26124),
(29820,'enUS','It hurts...','',26124),
(29821,'enUS','Me... bad?','',26124),
(29822,'enUS','Master?','',26124),
(29823,'enUS','%s prepares to shatter his Brittle Golems!','',26124),
(29824,'enUS','That day is not today...','',26124),
(29825,'enUS','Impossible...','',26124),
(29826,'enUS','This... is not over!','',26124),
(29827,'enUS','When next we meet, it won\'t be on holy ground, paladin.','',26124),
(29828,'enUS','','Your spells will not be as potent as mine, but you will still find anti-magic shells to be entirely invaluable against a large number of magical attacks.',26124),
(29829,'enUS','','The power you absorb from spells with your shell can be used to counter with your other attacks.',26124),
(29830,'enUS','','Mages fear our kind... with reason. Play upon this fear, disciples.',26124),
(29831,'enUS','I\'ve lost my ensorcelled choker!','I\'ve lost my ensorcelled choker!',26124),
(29832,'enUS','%s switches to Battle Stance!','',26124),
(29833,'enUS','%s switches to Berserker Stance!','',26124),
(29834,'enUS','%s switches to Defensive Stance!','',26124),
(29835,'enUS','Rise, Darion, and listen...\n','',26124),
(29836,'enUS','Do not be frightened child... welcome the cold embrace of death...','',26124),
(29837,'enUS','Such is the price of failure.','',26124),
(29838,'enUS','Death is the reward for your weakness.','',26124),
(29839,'enUS','Your retention was poor.','',26124),
(29840,'enUS','Well done.','',26124),
(29841,'enUS','You have more learning ahead of you disciple. Return to your studies.','',26124),
(29842,'enUS','You have learned well. Continue on your path, disciple.','',26124),
(29843,'enUS','We have all been witness to a terrible tragedy. The blood of good men has been shed upon this soil! Honorable knights, slain defending their lives -- our lives!','',26124),
(29844,'enUS','A good start. Return, disciple.','',26124),
(29845,'enUS','And while such things can never be forgotten, we must remain vigilant in our cause!\n','',26124),
(29846,'enUS','The Lich King must answer for what he has done, and must not be allowed to cause further destruction in our world.','',26124),
(29847,'enUS','I make a promise to you now, brothers and sisters: the Lich King will be defeated! On this day, I call for a union.','',26124),
(29848,'enUS','The Argent Dawn and the Order of the Silver Hand will come together as one! We will succeed where so many before us have failed!\n','',26124),
(29849,'enUS','We will take the fight to Arthas, and we will tear down the walls of Icecrown!','',26124),
(29850,'enUS','The Argent Crusade comes for you, Arthas!\n','',26124),
(29851,'enUS','So too do the Knights of the Ebon Blade. Although our kind has no place in your world, we will fight to bring an end to the Lich King. This I vow!','',26124),
(29852,'enUS','%s moves up the tunnel!','',26124),
(29853,'enUS','Here you are, $n.$b$bNow please, return your focus to the task at hand....','',26124),
(29854,'enUS','Ghoul! Come here still for a moment!','Ghoul! Come here still for a moment!',26124),
(29855,'enUS','Here, eat this, our enemies shall be delighted.','Here, eat this, our enemies shall be delighted.',26124),
(29856,'enUS','%s places a stick of dynamite upon the ground.','%s places a stick of dynamite upon the ground.',26124),
(29857,'enUS','You are such a devious one! Whatever shall we do with you?','You are such a devious one! Whatever shall we do with you?',26124),
(29858,'enUS','Why, thank you. I do pride myself on knowing when a little bit of grease beats spending hours of sorcerous study for the same effect.','Why, thank you. I do pride myself on knowing when a little bit of grease beats spending hours of sorcerous study for the same effect.',26124),
(29859,'enUS','%s hurries over.','%s hurries over.',26124),
(29860,'enUS','%s chows down ravenously.','%s chows down ravenously.',26124),
(29861,'enUS','Your end.','',26124),
(29862,'enUS','Our storehouses have been depleted.  I have nothing to sell until we can get more supplies.','',26124),
(29863,'enUS','Because you\'ve managed to replenish some of our supplies I can get back to cooking.  Now, what can I do for you?','',26124),
(29864,'enUS','Looks like $n passed out. What should we do, Tirion?','',26124),
(29865,'enUS','%s begins to cast Lightning Nova!','',26124),
(29866,'enUS','','Look sharp, $r.$b$bIt\'s life or death out here!',26124),
(29867,'enUS','As disciples of blood, you strive to master the very lifeforce of your enemies.','',26124),
(29868,'enUS','Be it by blade or incantation, blood feeds our attacks and weakens our foes.','',26124),
(29869,'enUS','True masters learn to make blood serve more than just their strength in battle.','',26124),
(29870,'enUS','Stripping energy from our foes, both fighting and fallen, allows us to persevere where lesser beings fall exhausted.','',26124),
(29871,'enUS','And every foe that falls, energy sapped and stolen, only further fuels our assault.','',26124),
(29872,'enUS','As masters of blood, we know battle without end...','',26124),
(29873,'enUS','We know hunger never to be quenched...','',26124),
(29874,'enUS','We know power never to be overcome...','',26124),
(29875,'enUS','As masters of blood, we are masters of life and death itself.  Against us, even hope falls drained and lifeless.','',26124),
(29876,'enUS','Return to the field of battle or you will be dropped!','',26124),
(29877,'enUS','','Why is everyone looking at me as if I crashed the ship?',26124),
(29878,'enUS','Finally, we have the parts to repair the Spirit of Gnomeregan.','',26124),
(29879,'enUS','Let\'s see, just a tweak here and an adjustment there...','',26124),
(29880,'enUS','And there she is, the Spirit of Gnomeregan!','',26124),
(29881,'enUS','You can use her, but I don\'t want to hear any complaints about saw blades in your seat. I had to fix \'er with what we could find.','',26124),
(29882,'enUS','Hello, friend! I\'ve setup shop in this here factory. I\'d be happy to set you up in a shiny new vehicle - I\'ll even send the bill to your leaders after the assault. Best deal anywhere!','Hello, friend! I\'ve setup shop in this here factory. I\'d be happy to set you up in a shiny new vehicle - I\'ll even send the bill to your leaders after the assault. Best deal anywhere!',26124),
(29883,'enUS','I would like to drive a demolisher.','I would like to drive a demolisher.',26124),
(29884,'enUS','Hello, friend! I\'d love to give you a demolisher, but I\'m out of parts at the moment.','Hello, friend! I\'d love to give you a demolisher, but I\'m out of parts at the moment.',26124),
(29885,'enUS','What treachery is this?! You be payin\' for this deceit with your life, mon!','',26124),
(29886,'enUS','The Scepter of Domination glows brightly! Use it now!','',26124),
(29887,'enUS','A Crypt Guard joins the fight!','',26124),
(29888,'enUS','Avoid incoming Scarlet Crusade arrows and javelins by moving out of their line of fire!','',26124),
(29889,'enUS','Devour Scarlet Crusaders to replenish your energy!','',26124),
(29890,'enUS','I hope Jones is okay.','',26124),
(29891,'enUS','If Jones listened to me, he\'d live longer.','',26124),
(29892,'enUS','That Jones...','',26124),
(29893,'enUS','He\'s not nuts, he\'s crazy!  Always going off looking for fortune and glory...','',26124),
(29894,'enUS','Oh boy Jones and I have had some adventures...','',26124),
(29895,'enUS','Where Jones goes, I go.  Where he steps, I step.  But this time he told me to stay back.','',26124),
(29896,'enUS','I hope Jones makes it back okay.','',26124),
(29897,'enUS','Jones still owes me money from our last card game.  Can you believe he tried to cheat me!  I may be little, but he cheats very big.','',26124),
(29898,'enUS','Oh boy... I can\'t believe I just remembered that...','',26124),
(29899,'enUS','...so he dropped the potatoes, even though I told him to hold onto them.','',26124),
(29900,'enUS','%s looks around nervously.','',26124),
(29901,'enUS','%s sighs.','',26124),
(29902,'enUS','%s takes a deep breath and puffs out his chest.','',26124),
(29903,'enUS','%s looks off into the distance, annoyed.','',26124),
(29904,'enUS','%s can hardly control his laughter.  His story is constantly interrupted by his own laughter.','',26124),
(29905,'enUS','%s sighs.','',26124),
(29906,'enUS','Hmm... something familiar about your face $r...  Give me a moment...$B$BAh ha! Westfall, that\'s where I recognize you from.  You are $n!  It\'s good to see you again.  But, let\'s hope you can help us finish the job this time.$B$BNow we\'re a long way from Westfall up here, but if we don\'t win this battle, there may not be a home to return to.','',26124),
(29908,'enUS','$n!  I hardly recognized you in your new outfit.  Still have that tunic... or did you take the chausses... or was it the staff?   I can\'t recall, it was so long ago...$B$BWell, I\'m glad you are here to help out again.  We could use all the help we can get.  $n, if you perform the way you did back in Westfall with the People\'s Militia, we have a chance.$B$BThese are dire times, if we don\'t win this battle, there may not be a Westfall to return to.','',26124),
(29909,'enUS','With the Light\'s blessing and your help, $n, the Defias are no longer a threat.$B$BBut we\'re a long way from Westfall up here, and if we don\'t win this battle, there may not be a home to return to.','',26124),
(29910,'enUS','Good hunting out there, $c!','',26124),
(29911,'enUS','Good luck $r!','',26124),
(29912,'enUS','Watch your back, $r!','',26124),
(29913,'enUS','Incoming $c!','',26124),
(29914,'enUS','Inbound $r!','',26124),
(29915,'enUS','We\'ve got a $c inbound!','',26124),
(29916,'enUS','Fool! Ya coulda been havin\' great power, mon!','',26124),
(29917,'enUS','How could dis be? Da Lich King said he be havin\' great plans for you, mon...','',26124),
(29918,'enUS','I shoulda known not to be trustin\' nobody!','',26124),
(29919,'enUS','Ya done turned your back on destiny, mon. Now you gunna die!','',26124),
(29920,'enUS','Your betrayal not gunna be slowin\' me down none, mon.','',26124),
(29921,'enUS','I never needed ya, mon. I can crush Zul\'Drak without ya!','',26124),
(29922,'enUS','ENOUGH!','',26124),
(29923,'enUS','Dis foolish treachery has cost ya your destiny!','',26124),
(29924,'enUS','Remember, $n, this is no sprint. The true test of a hunter tests his endurance over the course of a long expedition.','',26124),
(29925,'enUS','The Eastern Graveyard has been captured by the Alliance!','',26124),
(29926,'enUS','The Western Graveyard has been captured by the Alliance!','',26124),
(29927,'enUS','The Southern Graveyard has been captured by the Alliance!','',26124),
(29928,'enUS','The Eastern Graveyard has been captured by the Horde!','',26124),
(29929,'enUS','The Western Graveyard has been captured by the Horde!','',26124),
(29930,'enUS','The Southern Graveyard has been captured by the Horde!','',26124),
(29931,'enUS','The air teems with latent energy... quite the harvest!','',26124),
(29932,'enUS','Urgreth begins to emanate a powerful dark energy!','',26124),
(29933,'enUS','Looks like you brought the whole family!  What\'s your business here, then?','',26124),
(29934,'enUS','Work?  You are aware this is a warzone, citizen?  What is your profession?','',26124),
(29935,'enUS','Right.  Go ahead.','',26124),
(29936,'enUS','Her Majesty sends Dark Rangers!  Stand aside, boys!','',26124),
(29938,'enUS','You must be the sorriest bunch of recruits I\'ve seen today!  Fall in formations and report to High Executor Anselm!','',26124),
(29939,'enUS','Aren\'t you a sorry sight!  I suppose you\'re a little better than yesterday\'s bunch.  Formations, now!  Report for duty!','',26124),
(29940,'enUS','Wipe that worthless grin off your faces, recruits!  If the High Executor sees you like that he will kill you all himself!','',26124),
(29941,'enUS','This not fun...','',26124),
(29942,'enUS','New toys!','',26124),
(29943,'enUS','Boring...','',26124),
(29944,'enUS','Why you stop moving?','',26124),
(29945,'enUS','Get up! Me not done!','',26124),
(29946,'enUS','You only advance... the master\'s plan...','',26124),
(29947,'enUS','Ah, the entertainment has arrived!','',26124),
(29948,'enUS','The fun is just beginning!','',26124),
(29949,'enUS','Ah! Quality materials.','',26124),
(29950,'enUS','Don\'t worry; I\'ll make good use of you!','',26124),
(29951,'enUS','Say hello to some friends of mine.','',26124),
(29952,'enUS','Come, citizens of Stratholme! Meet your \"saviors.\"','',26124),
(29953,'enUS','BOOM! Hahahahah...','',26124),
(29954,'enUS','Blood... destruction... EXHILARATING!','',26124),
(29955,'enUS','I want a sample...','',26124),
(29956,'enUS','Such strength... it must be mine!','',26124),
(29957,'enUS','Your flesh betrays you.','',26124),
(29958,'enUS','What can Korg do for you today?','',26124),
(29959,'enUS','Show me what you have for sale.','Show me what you have for sale.',26124),
(29960,'enUS','I am ready. Let\'s defend the temple!','',26124),
(29961,'enUS','I can\'t believe the blues would attack us. Let\'s give some of it back!','',26124),
(29962,'enUS','Where to first?','',26124),
(29963,'enUS','Your reputation precedes you, $n. This should be interesting.','',26124),
(29964,'enUS','Shall we destabilize the shrine first or disable the enemy?','',26124),
(29965,'enUS','We\'ve been expecting you, $n. Now we have the upper hand.','',26124),
(29966,'enUS','Are you ready for battle, $c?','',26124),
(29967,'enUS','Greetings, friend.','',26124),
(29968,'enUS','Fool!  You led us to the only being that could stand up to our armies!  You will never bring the Etymidian back to Northrend!','',26124),
(29969,'enUS','Master, dis mortal scum be double-crossin\' us. Dey must be made to suffer!','',26124),
(29970,'enUS','Fight on, or face me!','',26124),
(29971,'enUS','Var-jorgg gramalch!','',26124),
(29972,'enUS','Slay them all! No excuses! No mercy! No rest! ','',26124),
(29973,'enUS','Raze every structure! Silence every cry!','',26124),
(29974,'enUS','I\'ll paint my face with your blood!','',26124),
(29975,'enUS','I am a warrior born!','',26124),
(29976,'enUS','My life for the... death god!','',26124),
(29977,'enUS','I return! A second chance to carve your skull!','',26124),
(29978,'enUS','Mjul orm agn gjor!','',26124),
(29979,'enUS','No! I can do... better! I can...','',26124),
(29980,'enUS','','Ingvar! Your pathetic failure will serve as a warning to all... you are damned! Arise and carry out the master\'s will!',26124),
(29981,'enUS','Intriguing... a high quantity of arcane energy is near. Time for some prospecting...','',26124),
(29982,'enUS','It is you who should suffer. Be content that your death is a quick one....','',26124),
(29983,'enUS','As for you...','',26124),
(29984,'enUS','I spare your insignificant life as a reward for this amusing betrayal. There may yet be a shred of potential in you.','',26124),
(29985,'enUS','When next we meet I shall require much more to justify your life.','',26124),
(29986,'enUS','You have failed me, Drakuru!','',26124),
(29987,'enUS','DISCOVERY!   $n has discovered how to transmute eternal life into shadow.','DISCOVERY!   $n has discovered how to transmute eternal life into shadow.',26124),
(29988,'enUS','DISCOVERY!   $n has discovered how to transmute eternal life into fire.','DISCOVERY!   $n has discovered how to transmute eternal life into fire.\n',26124),
(29989,'enUS','Be warned...','',26124),
(29990,'enUS','DISCOVERY!   $n has discovered how to transmute eternal fire into water.','DISCOVERY!   $n has discovered how to transmute eternal fire into water.',26124),
(29991,'enUS','DISCOVERY!   $n has discovered how to transmute eternal fire into life.','DISCOVERY!   $n has discovered how to transmute eternal fire into life.',26124),
(29992,'enUS','DISCOVERY!   $n has discovered how to transmute eternal air into water.','DISCOVERY!   $n has discovered how to transmute eternal air into water.',26124),
(29993,'enUS','DISCOVERY!   $n has discovered how to transmute eternal air into earth.','DISCOVERY!   $n has discovered how to transmute eternal air into earth.\n',26124),
(29994,'enUS','DISCOVERY!   $n has discovered how to transmute eternal shadow into earth.','DISCOVERY!   $n has discovered how to transmute eternal shadow into earth.\n',26124),
(29995,'enUS','DISCOVERY!   $n has discovered how to transmute eternal shadow into life.','DISCOVERY!   $n has discovered how to transmute eternal shadow into life.\n',26124),
(29996,'enUS','DISCOVERY!   $n has discovered how to transmute eternal earth to air.','DISCOVERY!   $n has discovered how to transmute eternal earth to air.',26124),
(29997,'enUS','DISCOVERY!   $n has discovered how to transmute eternal earth to shadow.','DISCOVERY!   $n has discovered how to transmute eternal earth to shadow.\n',26124),
(29998,'enUS','DISCOVERY!   $n has discovered how to transmute eternal water to air.','DISCOVERY!   $n has discovered how to transmute eternal water to air.',26124),
(29999,'enUS','DISCOVERY!   $n has discovered how to transmute eternal water to fire.','DISCOVERY!   $n has discovered how to transmute eternal water to fire.\n',26124),
(30000,'enUS','DISCOVERY!   $n has discovered a new transmutation!','DISCOVERY!   $n has discovered a new transmutation!\n',26124),
(30001,'enUS','What is that bauble you carry?','',26124),
(30002,'enUS','Your little toy will not save you!','',26124),
(30003,'enUS','The Light is no match for the Lich King\'s might!','',26124),
(30004,'enUS','Say goodbye to those you love, $c...','',26124),
(30005,'enUS','Your kingdoms will fall, $r!','',26124),
(30006,'enUS','Your mighty castles will crumble and your loved ones will join the Lich King\'s ranks!','',26124),
(30007,'enUS','The stench of that holy trinket you carry disgusts me...','',26124),
(30008,'enUS','Why don\'t you discard it...','',26124),
(30009,'enUS','Join us, $n.  Swear liegance to the Lich King.  Give yourself to him and know peace... the peace you have been denied since your wailing, terrified birth.','',26124),
(30010,'enUS','There is no honor fighting us when the end has already been written.  Azeroth... will... die.','',26124),
(30011,'enUS','If you struggle, then before your death you will face pain and horror and the loss of all you love.','',26124),
(30012,'enUS','Greetings...','',26124),
(30013,'enUS','I see you...','',26124),
(30014,'enUS','Ah, there you are...','',26124),
(30016,'enUS','There.  I found you...','',26124),
(30017,'enUS','The Arena battle ends in 60 seconds.','',26124),
(30018,'enUS','Maintain your faith. The grand admiral will deliver us to victory over the Lich King.','Maintain your faith. The grand admiral will deliver us to victory over the Lich King.',26124),
(30019,'enUS','Accept this blessing in the name of the Holy Light.','Accept this blessing in the name of the Holy Light.',26124),
(30020,'enUS','Do not waver. Soon we shall sit within the hallowed presence of the Light.','Do not waver. Soon we shall sit within the hallowed presence of the Light.',26124),
(30021,'enUS','There are villains amongst us - remain vigilant. The Ebon Blade seeks to prevent us from destroying their true master, the Lich King.','There are villains amongst us - remain vigilant. The Ebon Blade seeks to prevent us from destroying their true master, the Lich King.',26124),
(30022,'enUS','Do not question what the Holy Light has put before you. Only those that sacrifice all will be delivered into its presence.','Do not question what the Holy Light has put before you. Only those that sacrifice all will be delivered into its presence.',26124),
(30023,'enUS','Grand Admiral Westwind has a plan... a vision. We must remain faithful and steadfast in its execution for the sake of the world.','Grand Admiral Westwind has a plan... a vision. We must remain faithful and steadfast in its execution for the sake of the world.',26124),
(30024,'enUS','This land is freezing, but I am warm, blanketed in the glow of the Holy Light. Do not be disheartened.','This land is freezing, but I am warm, blanketed in the glow of the Holy Light. Do not be disheartened.',26124),
(30025,'enUS','By order of the grand admiral, stay away from the southern side of the island upon pain of death. Spread the word.','By order of the grand admiral, stay away from the southern side of the island upon pain of death. Spread the word.',26124),
(30026,'enUS','Stormwind is still beset -- a necropolis looms at its walls and random Scourge outbreaks have been reported.','Stormwind is still beset -- a necropolis looms at its walls and random Scourge outbreaks have been reported.',26124),
(30027,'enUS','Freshly killed zombies are arriving via meat wagon, though their numbers are dwindling.','Freshly killed zombies are arriving via meat wagon, though their numbers are dwindling.',26124),
(30028,'enUS','The last attack in the Eastern Plaguelands yielded a large harvest of dead, from both sides.','The last attack in the Eastern Plaguelands yielded a large harvest of dead, from both sides.',26124),
(30029,'enUS','The Argent Dawn\'s agents scored a decisive victory in the deserts of Tanaris.','The Argent Dawn\'s agents scored a decisive victory in the deserts of Tanaris.',26124),
(30030,'enUS','Light\'s Hope Chapel remains a bastion in the Plaguelands.  Argent Dawn\'s foothold there is key to securing the area.','Light\'s Hope Chapel remains a bastion in the Plaguelands.  Argent Dawn\'s foothold there is key to securing the area.',26124),
(30031,'enUS','Git up, you!','',26124),
(30032,'enUS','Yes, the Lich King will fall to our might. We will have our final revenge.$B$BBut first, we will see to it that the plague known as the Scarlet Onslaught comes to an end once and for all!','',26124),
(30033,'enUS','Lord-Commander, I would hear your tale.','Lord-Commander, I would hear your tale.',26124),
(30034,'enUS','Very well, but if I were you, I would pay attention and not just blindly nod my head at what I heard.$B$BIt begins, as all good stories do, with betrayal. Oh, it\'s not that we were betrayed... not at all. The Lich King raised us death knights above all others.$B$BRather, it was we who betrayed him with the help of Highlord Darion Mograine.$B$BIn the final fight at Light\'s Hope Chapel in the Plaguelands, with the simpletons moments away from annihilation, Tirion Fordring helped Mograine break the Lich King\'s hold upon him and all of the rest of us that were present.','',26124),
(30035,'enUS','<You nod slightly but do not complete the motion as the lord-commander narrows his eyes before he continues.>','<You nod slightly but do not complete the motion as the lord-commander narrows his eyes before he continues.>',26124),
(30036,'enUS','Just give up and die already!','',26124),
(30037,'enUS','With the Lich King fleeing in fear of Fordring armed with the Ashbringer, we were able to easily wrest Ebon Hold from the remaining Scourge forces.$B$BThat didn\'t settle things between us and the Scarlet Crusade, however.$B$BAs the Forsaken have learned the hard way, the Scarlets cannot seem to differentiate between us and the Scourge.$B$BWe think on our own, we have our own motivations, we have almost all of the qualities of the living, and yet to them, we are no different than the mindless slaves of the Lich King.$B$BMistakenly they think we will roll over and play dead.','',26124),
(30038,'enUS','I thought that they now called themselves the Scarlet Onslaught?','I thought that they now called themselves the Scarlet Onslaught?',26124),
(30039,'enUS','Lord-Commander, would you repeat what you said before?','Lord-Commander, would you repeat what you said before?',26124),
(30040,'enUS','<The lord-commander fixes you with a stare before going on.>$B$BI was getting to that. Indeed, when High General Abbendis landed her forces on Northrend, she changed their name to the Scarlet Onslaught.$B$BIt was not long before Admiral Barean Westwind presented himself to her at New Hearthglen in the Dragonblight. From all accounts, she wasn\'t expecting him. Nor was she expecting that he would undermine her authority and take the reins of command away from her.$B$BLikely you were involved with her demise, but no matter. Once she was dead, the admiral made a mysterious exit and we lost track of him.','',26124),
(30041,'enUS','Mo\' guts! Mo\' blood! Mo\' food!','',26124),
(30042,'enUS','Me gonna carve you and eat you!','',26124),
(30043,'enUS','So hungry! Must feed!','',26124),
(30044,'enUS','Corpse go boom!','',26124),
(30045,'enUS','Where did the grand admiral go?','Where did the grand admiral go?',26124),
(30046,'enUS','As I said, we lost track of him, but this is something that I\'m sure you will be able to figure out for me. My suspicion is that he\'s down there somewhere, but my spies that have returned haven\'t been able to place him anywhere on the island.$B$BThe Forsaken at Venomspite did a good job of sabotaging New Hearthglen, but the Onslaught forces that are present down there are the battle-hardened remnant from that place. Unfortunately, they picked up better equipment along the way, as well as gryphons taken from fools somewhere.$B$BWhat I\'m trying to say is that this isn\'t going to be a stroll in the countryside, $n, even for you.','',26124),
(30047,'enUS','That\'s fine. When do I start?','That\'s fine. When do I start?',26124),
(30048,'enUS','We\'ll start in just a moment.$B$BI just want to be very clear -- we\'re not here to soften them up. We\'re not here to make a dent. We\'re here to put an end to the disease that calls itself the Scarlet Onslaught.$B$BIf you don\'t want any part of that, if you don\'t have the stomach, fly away now. I want someone with us who is going to be here every day until the job\'s done.$B$BAre you that $g man : woman;, $n?','',26124),
(30049,'enUS','Let\'s finish this!','Let\'s finish this!',26124),
(30050,'enUS','<The lord-commander flashes a rictus grin, looking you up and down discerningly.>$B$BThat\'s what I wanted to hear.','',26124),
(30051,'enUS','My king!  I cannot hear your voice!  Do not leave me!','',26124),
(30052,'enUS','Give me your brain!','',26124),
(30053,'enUS','I must feed...','',26124),
(30054,'enUS','My king!  I cannot hear your voice!  Do not leave me!','',26124),
(30055,'enUS','I must feed...','',26124),
(30056,'enUS','Give me your brain!','',26124),
(30057,'enUS','Where am I?  So dark...','',26124),
(30058,'enUS','Cling to your hope, mortal!','',26124),
(30059,'enUS','Hope sweetens the soul, and yours will be a fine dessert for the Lich King!','',26124),
(30060,'enUS','Please!  $n!  Destroy me!','',26124),
(30061,'enUS','I have done such vile things...','',26124),
(30062,'enUS','...killed loved ones... eaten them...','',26124),
(30063,'enUS','Please!  $n!  Destroy me!','',26124),
(30064,'enUS','Let the torture end!','',26124),
(30065,'enUS','Show mercy, $n!  Give me peace!','',26124),
(30066,'enUS','Please!  $n!  Destroy me!','',26124),
(30067,'enUS','You... I\'ve seen you in Shattrath...','',26124),
(30068,'enUS','My King knows of you.  He wants to see you...','',26124),
(30069,'enUS','Blood and souls for my King!','',26124),
(30070,'enUS','Blood and souls for my King!','',26124),
(30072,'enUS','There is fire in my eyes!  My mind!','',26124),
(30073,'enUS','Living flesh eases the pain...','',26124),
(30074,'enUS','Please, I just need a little.  A finger or an ear will do...','',26124),
(30075,'enUS','Living flesh eases the pain...','',26124),
(30076,'enUS','Please, I just need a little.  A finger or an ear will do...','',26124),
(30077,'enUS','Oh no!  $n is looking hurt!','Oh no!  $n is looking hurt!',26124),
(30078,'enUS','Come on $n!  I\'ve got good money riding on you!','Come on $n!  I\'ve got good money riding on you!',26124),
(30079,'enUS','Come on $n!  You can do it!','Come on $n!  You can do it!',26124),
(30080,'enUS','Don\'t show \'em any mercy $n!','Don\'t show \'em any mercy $n!',26124),
(30081,'enUS','$n!','$n!',26124),
(30082,'enUS','Do it, $n!','Do it, $n!',26124),
(30083,'enUS','Rip \'em apart, $n!','Rip \'em apart, $n!',26124),
(30084,'enUS','Pull it together, $n!','Pull it together, $n!',26124),
(30085,'enUS','Come on, $n!  Don\'t let me down!','Come on, $n!  Don\'t let me down!',26124),
(30086,'enUS','%s\'s Protective Bubble shatters!','',26124),
(30087,'enUS','%s begins to summon!','',26124),
(30088,'enUS','I heard that the Lich King  is stirring up north, in the Frozen Wastes.  He built a fortress, Icecrown, and plans our doom.','I heard that the Lich King  is stirring up north, in the Frozen Wastes.  He built a fortress, Icecrown, and plans our doom.',26124),
(30089,'enUS','Rumors say that giant men live in Northrend.  They have beards made of daggers and can put out fires with their dead, cold gaze.','Rumors say that giant men live in Northrend.  They have beards made of daggers and can put out fires with their dead, cold gaze.',26124),
(30090,'enUS','The chill creeping from the north gives my bones a fierce ache.','The chill creeping from the north gives my bones a fierce ache.',26124),
(30091,'enUS','The Stormwind Harbor is really bustling.  I wonder where the new boats will sail...','The Stormwind Harbor is really bustling.  I wonder where the new boats will sail...',26124),
(30092,'enUS','I heard the Tauren have cousins in Northrend.  I hope they\'re good hunters... I hope they hunt undead.','I heard the Tauren have cousins in Northrend.  I hope they\'re good hunters... I hope they hunt undead.',26124),
(30093,'enUS','If the blood elves go to Northrend, then vengeance shall be ours at last!  The Lich King will regret his march on our beloved Silvermoon City!','If the blood elves go to Northrend, then vengeance shall be ours at last!  The Lich King will regret his march on our beloved Silvermoon City!',26124),
(30094,'enUS','','Consider all of the suffering that the Scarlets have caused over the years. The torture, the zealotry, the murder.$B$BI won\'t allow that to continue. Will you?',26124),
(30095,'enUS','If we serve the Light, then we must go north and face the darkness residing there.','If we serve the Light, then we must go north and face the darkness residing there.',26124),
(30096,'enUS','The continent of Northrend is filled with history!  We must dig deep through the frozen ice and find our ancestors.','The continent of Northrend is filled with history!  We must dig deep through the frozen ice and find our ancestors.',26124),
(30097,'enUS','The unique magnetic fields of the polar regions pose millions of research possibilities!','The unique magnetic fields of the polar regions pose millions of research possibilities!',26124),
(30098,'enUS','I heard that the king is found!  He\'s returning to Stormwind!','I heard that the king is found!  He\'s returning to Stormwind!',26124),
(30099,'enUS','I can smell a market up north... time to pack up the goods and put on a heavy coat!','I can smell a market up north... time to pack up the goods and put on a heavy coat!',26124),
(30100,'enUS','I can smell a market up north... time to pack up the goods and put on my heavy coat!','I can smell a market up north... time to pack up the goods and put on my heavy coat!',26124),
(30101,'enUS','Ha!  I almost miss old Jum\'ja.  He was tough.  But Ironhide seemed to chew through him easy enough.','',26124),
(30102,'enUS','Rumors drift like leaves on the wind.  They say that Highborne live to the north!','Rumors drift like leaves on the wind.  They say that Highborne live to the north!',26124),
(30103,'enUS','One empty cage.  One troll lost to the pit.  Do any of you other trolls need more convincing?','',26124),
(30104,'enUS','What about you?  Are you ready to be Ironhide\'s next chew toy, or are you ready to talk?  I\'ll let you think about it for a while.','',26124),
(30105,'enUS','I bet you miss your neighbor.  I\'ll see if you can\'t join him soon enough.','',26124),
(30106,'enUS','Time is running out troll.  Whenever you feel like talking about Drak\'Tharon, let me know.','',26124),
(30107,'enUS','Drakkari Warrior, huh?  We\'ll see how much of a warrior you are when you fight Ironhide.','',26124),
(30108,'enUS','I\'ve got an idea troll.  How about you tell me about Drak\'Tharon, then I let old Ironhide have a snack?','',26124),
(30109,'enUS','So troll, have you given thought to my suggestion?  Whatever you decide, I\'m sure it\'ll make Ironhide happy.','',26124),
(30110,'enUS','Garrosh is eager to take the fight to the north, though Thrall urgres caution...','Garrosh is eager to take the fight to the north, though Thrall urgres caution...',26124),
(30111,'enUS','I wonder what there is to hunt in Northrend.  Fierce beasts, I wager.','I wonder what there is to hunt in Northrend.  Fierce beasts, I wager.',26124),
(30112,'enUS','The souls of the undead are cursed and tortured.  If I am infected, promise you\'ll burn me before I turn..','The souls of the undead are cursed and tortured.  If I am infected, promise you\'ll burn me before I turn.',26124),
(30113,'enUS','The apothecaries toil day and night on a cure for the Lich King\'s plague.  Without them, both the Horde and the Alliance would be lost.','The apothecaries toil day and night on a cure for the Lich King\'s plague.  Without them, both the Horde and the Alliance would be lost.',26124),
(30114,'enUS','Return to Icecrown or lose the Onslaught Gryphon!','',26124),
(30115,'enUS','Return to Onslaught Harbor or lose your Bone Gryphon!','',26124),
(30116,'enUS','There you go, mon. Your very own bone gryphon Now let\'s talk about you takin\' it out to fight the Onslaught!','',26124),
(30117,'enUS','That\'s quite a tale, lord-commander.','That\'s quite a tale, lord-commander.',26124),
(30118,'enUS','We\'re here for civilian work, sir.','',26124),
(30119,'enUS','Well... we\'re undertakers, sir.','',26124),
(30120,'enUS','Yes, sir!','Yes, sir!',26124),
(30121,'enUS','','%s flutters her lashes at the ignorant McGoyver.',26124),
(30122,'enUS','','%s sighs wistfully at McGoyver... or is it the flying machine?',26124),
(30123,'enUS','','%s gazes longingly at the flying machine... or is it McGoyver she\'s watching?',26124),
(30124,'enUS','Nasty little...A-ak, kaw! Kill! Yes, kill you!','',26124),
(30125,'enUS','','The Hyldsmeet is sacred.  Whoever earns victory is assured a lifetime next to Thorim.',26124),
(30126,'enUS','Bring it on, hot stuff!','Bring it on, hot stuff!',26124),
(30127,'enUS','Let\'s do this...','Let\'s do this...',26124),
(30128,'enUS','Kaaboooom!','Kaaboooom!',26124),
(30129,'enUS','Aaaah, it\'s beautiful!','Aaaah, it\'s beautiful!',26124),
(30130,'enUS','I love blowing things up!','I love blowing things up!',26124),
(30131,'enUS','Bombs are great!','Bombs are great!',26124),
(30132,'enUS','You messed with the wrong goblin.','You messed with the wrong goblin.',26124),
(30133,'enUS','Eat this, baddy!','Eat this, baddy!',26124),
(30134,'enUS','Dwarf... strange creature...','',26124),
(30135,'enUS','Does it have pain??','',26124),
(30136,'enUS','Soon you will be like us...','',26124),
(30137,'enUS','COWER, DWARFSSSESS!!','',26124),
(30138,'enUS','Vargul maybe eat you!','',26124),
(30139,'enUS','I\'m free?  I\'m free!','',26124),
(30140,'enUS','I can\'t believe it!  I\'m free to go!','',26124),
(30141,'enUS','Time to hightail it!  Thanks, friend!','',26124),
(30143,'enUS','Light be with you, friend.','',26124),
(30144,'enUS','Please, I must focus. This process is very intensive, and many innocent lives are depending on us.','Please, I must focus. This process is very intensive, and many innocent lives are depending on us.',26124),
(30145,'enUS','I am proud to have my dedication to the Light used in such a fashion. The Scourge\'s assault on our homelands is an act of genocide that we must counteract.','I am proud to have my dedication to the Light used in such a fashion. The Scourge\'s assault on our homelands is an act of genocide that we must counteract.',26124),
(30146,'enUS','','I don\'t know where the grand admiral is. Go to hell!',26124),
(30147,'enUS','Greetings, $n. ','',26124),
(30148,'enUS','','You\'ll get nothing out of me!',26124),
(30149,'enUS','','I\'ll have your gizzard for breakfast!',26124),
(30150,'enUS','Rilak, I\'ve lost Miniwing! HELP ME, PLEASE!','Rilak, I\'ve lost Miniwing! HELP ME, PLEASE!',26124),
(30151,'enUS','','Better than you have tried!',26124),
(30152,'enUS','','You may kill me, but I\'ll never tell you what you want!',26124),
(30153,'enUS','','I am Scarlet Onslaught. We don\'t rat out our leaders!',26124),
(30154,'enUS','','You\'re just a filthy pawn of the Ebon Blade. Die!',26124),
(30155,'enUS','','No, I don\'t know where he is and if I did, I wouldn\'t tell you -- even if my life depended on it!',26124),
(30156,'enUS','Welcome weary traveler.  You\'ve come a long way.  We hope you can find rest here at Camp Oneqwah.','',26124),
(30157,'enUS','','Your corpse will adorn my mast!',26124),
(30158,'enUS','Welcome to Camp Oneqwah.  Rest for a while and we will tend to your kodo.','',26124),
(30159,'enUS','','While the Forsaken deal with curing the plague from both sides of the Horde and Alliance, we have pledged ourselves to deal with the Scourge necropoli that lay siege to our cities.$B$BBy using concentrated Light energy, we can strike back at the Lich King\'s structures and, with luck, destroy them.',26124),
(30160,'enUS','Well met traveler.  I hope the journey from Camp Winterhoof to our humble outpost was not too taxing.','',26124),
(30161,'enUS','Archbishop Landgren must know! Aaaaaagggghhhh.....!','',26124),
(30162,'enUS','Greetings traveler.  It is good to see that you made your way here safely from Camp Winterhoof.','',26124),
(30163,'enUS','Guards help!','',26124),
(30164,'enUS','Please... wait... stop! I don\'t know where the grand admiral is, but I\'m sure we can work it out.','',26124),
(30165,'enUS','Did I mention that I have money and jewels? Don\'t kill me!','',26124),
(30166,'enUS','I have no idea where he\'s at. I haven\'t seen him since we landed!','',26124),
(30167,'enUS','Can anyone hear me? I\'m being attacked!','',26124),
(30168,'enUS','Stop! I could be convinced to join you!','',26124),
(30169,'enUS','Not the face! Not the face!','',26124),
(30170,'enUS','How dare you! Do you have any idea who I am?','',26124),
(30171,'enUS','Greetings $C.  Have you lost one of your pets?','',26124),
(30172,'enUS','A thousand-thousand lives I will sacrifice for you, my lord.','A thousand-thousand lives I will sacrifice for you, my lord.',26124),
(30173,'enUS','I am yours to command, my king!','I am yours to command, my king!',26124),
(30174,'enUS','My king, the world will tremble in reverence...','My king, the world will tremble in reverence...',26124),
(30175,'enUS','I am an instrument of your destruction, my king! Command me!','I am an instrument of your destruction, my king! Command me!',26124),
(30176,'enUS','Woe unto those that dare oppose the Scourge!','Woe unto those that dare oppose the Scourge!',26124),
(30177,'enUS','Our enemies will be annihilated!','Our enemies will be annihilated!',26124),
(30178,'enUS','Greetings, $c. I can help stable your pets or assist you in recovering lost companions.','Greetings, $c. I can help stable your pets or assist you in recovering lost companions.',26124),
(30179,'enUS','I am reborn, my king, only to serve you.','I am reborn, my king, only to serve you.',26124),
(30180,'enUS','There will be no survivors, my lord.','There will be no survivors, my lord.',26124),
(30181,'enUS','I\'d like to stable my pet here.','I\'d like to stable my pet here.',26124),
(30182,'enUS','I\'ve lost Miniwing.','I\'ve lost Miniwing.',26124),
(30183,'enUS','I\'ve lost my Jubling.','I\'ve lost my Jubling.',26124),
(30184,'enUS','First Mograine asks for arms, then he takes my servants away? Rubbish!','',26124),
(30185,'enUS','What is this nonsense about the Light? I have weapons and armor to make!','',26124),
(30186,'enUS','First, he gives away most of my precious Saronite, then he demands I begin crafting Runeblades of even greater power. Pah!','',26124),
(30187,'enUS','I may not have any mindless servants, but at least I can see a quality blade made from time to time.','',26124),
(30188,'enUS','If only I could resupply my stocks from Northrend, then I might be able to craft a weapon that could chill the heart of the unliving.','',26124),
(30189,'enUS','These Death Knights truly know no honor. First, they take my greatest arms and armor, crafted with care, forged with the Lich King\'s blessing. Then they wander off to who knows where and come back dressed like Goblins, mumbling something about pawning off their armor for a few coppers! Pathetic!','',26124),
(30190,'enUS','There is work to be done here, but do you see anyone jumping to help me? No! Wretches, all of them!','',26124),
(30191,'enUS','Fix my armor, Corvus! My blade is rusty, Corvus!  ... when will these damned mortals learn to care for themselves?','',26124),
(30192,'enUS','I\'ve lost my sprite darter hatchling.','I\'ve lost my sprite darter hatchling.',26124),
(30193,'enUS','We should fire another signal flare.  Perhaps we will get more help from Ebon Watch.','',26124),
(30194,'enUS','I will launch another flare.  Pray Ebon Watch is watching.','',26124),
(30195,'enUS','Perhaps Ebon Watch can spare some reinforcements.  Fire another signal flare.','',26124),
(30196,'enUS','I\'ve lost my worg pup.','I\'ve lost my worg pup.',26124),
(30197,'enUS','I\'ve lost my Smolderweb hatchling.','I\'ve lost my Smolderweb hatchling.',26124),
(30198,'enUS','Is it true?! Has someone finally come to get me out of this place?','',26124),
(30199,'enUS','No... no... that\'s not it, is it? That heartless lout probably sent you after the tools, didn\'t he?','',26124),
(30200,'enUS','Well... I guess I\'ll just keep an eye on the turrets... or something.','',26124),
(30201,'enUS','%s sighs.','',26124),
(30204,'enUS','There can be only one survivor!','There can be only one survivor!',26124),
(30205,'enUS','And now you die!','And now you die!',26124),
(30206,'enUS','Round 2 begins in 1 minute!','',26124),
(30207,'enUS','I will win my freedom and leave this cursed place!','I will win my freedom and leave this cursed place!',26124),
(30208,'enUS','You have made a grave error, fiend!','You have made a grave error, fiend!',26124),
(30209,'enUS','They brand me unworthy? I will show them unworthy!','They brand me unworthy? I will show them unworthy!',26124),
(30210,'enUS','I was a soldier of the Light once... Look at what I have become... ','I was a soldier of the Light once... Look at what I have become... ',26124),
(30211,'enUS','You will allow me a weapon and armor, yes?','You will allow me a weapon and armor, yes?',26124),
(30212,'enUS','You are hopelessly outmatched, $r.','You are hopelessly outmatched, $r.',26124),
(30213,'enUS','I will dismantle this festering hellhole!','I will dismantle this festering hellhole!',26124),
(30214,'enUS','Sate your hunger on cold steel, $r!','Sate your hunger on cold steel, $r!',26124),
(30215,'enUS','Death is the only cure!','Death is the only cure!',26124),
(30216,'enUS','There is no hope for our future...','There is no hope for our future...',26124),
(30217,'enUS','I\'ve lost my Prairie Chicken.','I\'ve lost my Prairie Chicken.',26124),
(30218,'enUS','To battle!','To battle!',26124),
(30219,'enUS','Monster! You will be the first casualty!','Monster! You will be the first casualty!',26124),
(30220,'enUS','It ends here!','It ends here!',26124),
(30221,'enUS','Let your fears consume you!','Let your fears consume you!',26124),
(30222,'enUS','HAH! You can barely hold a blade! Yours will be a quick death.','HAH! You can barely hold a blade! Yours will be a quick death.',26124),
(30223,'enUS','Well done. Let\'s get this over with.','',26124),
(30224,'enUS','I\'ve lost my wolpertinger.','I\'ve lost my wolpertinger.',26124),
(30225,'enUS','','There are more attackers coming from Garm. Get some mines on that field!',26124),
(30226,'enUS','','More magnataur attackers are getting close...',26124),
(30227,'enUS','','They\'re almost in sight - finish placing mines on that field!',26124),
(30228,'enUS','','They\'re here! Give\'m hell!',26124),
(30229,'enUS','Rigspark\'s vehicle shop is open for business!','Rigspark\'s vehicle shop is open for business!',26124),
(30230,'enUS','Sparklight\'s vehicle emporium is open for business!','Sparklight\'s vehicle emporium is open for business!',26124),
(30231,'enUS','Come, Landgren, cough up your soul so that I can ask you a very important question.','',26124),
(30232,'enUS','','Not bad, though some additional schooling wouldn\'t hurt! Here, watch my hips... like so!',26124),
(30233,'enUS','A pack of mechanical squirrels could mine faster than you!','',26124),
(30234,'enUS','Mine faster! I don\'t care if your actuators are rusty!','',26124),
(30235,'enUS','Your tinker must\'ve made you from tin, you lazy piles of slag!','',26124),
(30236,'enUS','Any worker who doesn\'t make his quota will be ingots before the day is out!','',26124),
(30237,'enUS','You\'re not worth the scrap you\'re made from!','',26124),
(30238,'enUS','Your mother was a wrench and your father smelled of seaforium!','',26124),
(30239,'enUS','You! You\'re not fit to punch arclight spanners from copper plates. Get out of my sight!','',26124),
(30240,'enUS','Even a target dummy could work faster than you! Pick it up!','',26124),
(30241,'enUS','YOU WILL TELL ME WHERE WESTWIND IS OR I WILL DESTROY YOUR SOUL!','',26124),
(30242,'enUS','You\'ll get nothing out of me, monster. I am beyond your ability to influence.','',26124),
(30243,'enUS','No.','',26124),
(30244,'enUS','Then you leave me no choice. I won\'t say that I won\'t enjoy this.','',26124),
(30245,'enUS','STOP! It isn\'t worth it. I\'ll tell you where he is.','',26124),
(30246,'enUS','Very well. Tell me!','',26124),
(30247,'enUS','On the south end of the island is a cave -- a hidden hollow. The grand admiral has holed himself up in there, preparing for the final battle against the Lich King.','',26124),
(30248,'enUS','A hidden hollow? How very interesting. You\'ve served your purpose, Landgren, but I\'m afraid there\'ll be no resurrection for you this time!','',26124),
(30250,'enUS','AAAEEEEIIIiiiiiiiiiiiiiiiiiiiiiiiiiiii........................................','',26124),
(30251,'enUS','Now that the unpleasantness is finished with, let\'s talk about you dealing with Grand Admiral Westwind.','',26124),
(30252,'enUS','%s roars!','',26124),
(30253,'enUS','Fallback!','Fallback!',26124),
(30254,'enUS','Move it soldiers!  We\'ll cover you!','Move it soldiers!  We\'ll cover you!',26124),
(30255,'enUS','You are covered soldiers!  Fallback!','You are covered soldiers!  Fallback!',26124),
(30256,'enUS','Let\'s fallback!','Let\'s fallback!',26124),
(30257,'enUS','We\'ve got you covered, now fallback!','We\'ve got you covered, now fallback!',26124),
(30258,'enUS','Return to me on Death\'s Rise when you and your friends have dealt with the grand admiral.','',26124),
(30259,'enUS','','Icefang has carried me through countless battles.$b$bDon\'t let her lack of armor fool you. She\'s the toughest bear I know.',26124),
(30260,'enUS','','Do not tarry here, wench!$b$bThere\'s fighting to be done!',26124),
(30261,'enUS','','We fight for the glory of Brunnhildar!',26124),
(30262,'enUS','The darkweaver metamorphizes into something terrible and demonic.','The darkweaver metamorphizes into something terrible and demonic.',26124),
(30263,'enUS','A terrible change comes over the %s as he cackles maniacally.','A terrible change comes over the %s as she cackles maniacally.',26124),
(30264,'enUS','With a horrible outcry, the %s transforms into a demonic nightmare.','With a horrible outcry, the %s transforms into a demonic nightmare.',26124),
(30265,'enUS','The darkweaver pierces you with an evil grin as he shifts into an entirely different form.','The darkweaver pierces you with an evil grin as she shifts into an entirely different form.',26124),
(30266,'enUS','Now you know. Now you must die!','Now you know. Now you must die!',26124),
(30267,'enUS','Even in death there will be no escape for you!','Even in death there will be no escape for you!',26124),
(30268,'enUS','I shall feast upon your soul!','I shall feast upon your soul!',26124),
(30269,'enUS','You will not leave this cavern alive!','You will not leave this cavern alive!',26124),
(30270,'enUS','Fallback!','Fallback!',26124),
(30271,'enUS','Move it soldiers!  We\'ll cover you!','Move it soldiers!  We\'ll cover you!',26124),
(30272,'enUS','You are covered soldiers!  Fallback!','You are covered soldiers!  Fallback!',26124),
(30273,'enUS','WHAT?! No matter. Even without my sphere, I will crush you! Behold my true identity and despair!','',26124),
(30274,'enUS','We\'ve got you covered, now fallback!','We\'ve got you covered, now fallback!',26124),
(30275,'enUS','Gah! I spent too much time in that weak little shell.','',26124),
(30276,'enUS','Kirel narak! I am Mal\'Ganis. I AM ETERNAL!','',26124),
(30277,'enUS','ENOUGH! I waste my time here. I must gather my strength on the homeworld.','',26124),
(30278,'enUS','You\'ll never defeat the Lich King without my forces. I\'ll have my revenge... on him AND you!','',26124),
(30279,'enUS','You thought I would just let you kill me?','',26124),
(30280,'enUS','The Scourge are breaching the southern wall!','The Scourge are breaching the southern wall!',26124),
(30281,'enUS','How did you find me? Did Landgren tell?','',26124),
(30282,'enUS','AHAHAHAHAHA! Incompetence at its finest!','',26124),
(30283,'enUS','The Scourge are breaching the western wall!','The Scourge are breaching the western wall!',26124),
(30284,'enUS','The Scourge are breaching the northern wall!','The Scourge are breaching the northern wall!',26124),
(30285,'enUS','','Icefang shows great courage for entering the battlefield unarmored.$b$bPerhaps her example could instill some courage in you, $n.',26124),
(30286,'enUS','This doesn\'t look pretty, lad.','',26124),
(30287,'enUS','I don\'t know, Bailey... it\'s not so bad. We could throw a rock at the tools from here.','',26124),
(30288,'enUS','That\'s strange... for a moment there, I could have swore you called me short.','',26124),
(30289,'enUS','That right? Well why don\'t you go prance your merry little self over and grab them, eh?','',26124),
(30290,'enUS','Toss me?! Okay, that\'s it punk.','',26124),
(30291,'enUS','Keep it to yourself.','',26124),
(30292,'enUS','You better hope they don\'t survive it, lad.','',26124),
(30293,'enUS','Cause I\'m just going to watch and laugh as they toss you in.','',26124),
(30294,'enUS','There\'s got to be a way in somewhere.','',26124),
(30295,'enUS','How\'d the goblin leave his tools there then?','',26124),
(30296,'enUS','That\'s it, lad! It looks totally safe. Go for it, I\'ll be right behind ya!','',26124),
(30297,'enUS','Well... I was just thinking... you\'re a bit smaller, so you\'re less likely to set off any of those mines.','',26124),
(30298,'enUS','No, no, no! Not short... it\'s just... well... maybe I could toss you across most of it?','',26124),
(30299,'enUS','I\'ve got an idea, Bailey...','',26124),
(30300,'enUS','No, no - this might work!','',26124),
(30301,'enUS','There\'s a path right there... only a few mines at the end in between us and the tools.','',26124),
(30302,'enUS','We wait for the next adventurer to come through and we tell him that\'s the way to go... then after they set off the mines, we just walk in and grab the tools!','',26124),
(30303,'enUS','It really doesn\'t look like it, Bailey.','',26124),
(30304,'enUS','Oh... good point. How about right there? That looks clear... kind of.','',26124),
(30305,'enUS','Uh... that\'s okay. It still kind of hurts from last time.','',26124),
(30306,'enUS','Ahhh!','',26124),
(30307,'enUS','Oh my...','',26124),
(30308,'enUS','I don\'t want to die!','',26124),
(30309,'enUS','No, no... no!','',26124),
(30310,'enUS','Ow!','',26124),
(30311,'enUS','That was close! You scared me.','',26124),
(30312,'enUS','Pansy.','',26124),
(30313,'enUS','','',26124),
(30314,'enUS','Hey $c, if you\'ve lost a key I might be able to help you out.','Hey $c, if you\'ve lost a key I might be able to help you out.',26124),
(30315,'enUS','I\'ve lost my key to Scholomance.','I\'ve lost my key to Scholomance.',26124),
(30316,'enUS','I\'ve lost my key to The Arcatraz.','I\'ve lost my key to The Arcatraz.',26124),
(30317,'enUS','I\'ve lost my key to The Shattered Halls.','I\'ve lost my key to The Shattered Halls.',26124),
(30318,'enUS','I\'ve lost my key to Searing Gorge.','I\'ve lost my key to Searing Gorge.',26124),
(30319,'enUS','I\'ve lost my Shadowforge Key.','I\'ve lost my Shadowforge Key.',26124),
(30320,'enUS','I\'ve lost The Eye of Haramad.','I\'ve lost The Eye of Haramad.',26124),
(30321,'enUS','I\'ve lost my key to Karazhan.','I\'ve lost my key to Karazhan.',26124),
(30322,'enUS','It\'s those blasted iron dwarves again! Somehow, they found him before we did.','',26124),
(30323,'enUS','They\'re not going to give up until they find him. We can\'t allow that to happen, $n, and Brann knows it.','',26124),
(30324,'enUS','There are some rather cryptic instructions in this note. Brann must\'ve had some kind of backup plan, but he can\'t keep evading capture forever...','',26124),
(30325,'enUS','It\'s up to you to find him before the irons do!','',26124),
(30326,'enUS','You stand before a master of the Arcane. One would be unwise to challenge me. Many corpses have been left ablaze in my wake.','',26124),
(30327,'enUS','','My life and spirit has been filled with memories of the insufferable Horde. Times of sorrow, desperation, and sacrifice have come to pass. The rage of battle could never leave my heart!',26124),
(30328,'enUS','','%s whistles while she works.',26124),
(30329,'enUS','','%s daydreams about princes and far off places.',26124),
(30330,'enUS','This is a portal to the Arathi Basin battleground.','',26124),
(30331,'enUS','This is a portal to the Alterac Valley battleground.','',26124),
(30332,'enUS','This is a portal to the Eye of the Storm battleground.','',26124),
(30333,'enUS','You are not yet strong enough to do battle in the Eye of the Storm. Return when you have gained more experience.','You are not yet strong enough to do battle in the Eye of the Storm. Return when you have gained more experience.',26124),
(30334,'enUS','This is a portal to the Warsong Gulch battleground.','',26124),
(30335,'enUS','Acquiring','',26124),
(30336,'enUS','You go now, bad troll!','',26124),
(30337,'enUS','Why you hurt Rageclaw? You crazy?','',26124),
(30338,'enUS','Rageclaw and troll friends no more!','',26124),
(30339,'enUS','You kill our pups! We kill you back!','',26124),
(30340,'enUS','You leave den the hard way!','',26124),
(30341,'enUS','You hurted the chief\'s lion seal! WHY YOU HURT LION SEAL??!','',26124),
(30342,'enUS','Why you smell so bad now? You smelled much less bad before!','',26124),
(30343,'enUS','Trolls is shameful. Trolls is killers!','',26124),
(30344,'enUS','The %s throws a bomb.','The %s throws a bomb.',26124),
(30345,'enUS','What be happening?$B$BYou here to eat, mon? Or maybe to learn cooking from the best, eh?','',26124),
(30346,'enUS','BURN, BABY, BURN!','',26124),
(30347,'enUS','Dat be da will o\' Drakuru!','',26124),
(30348,'enUS','Dis whole place gonna belong to da Scourge!','',26124),
(30349,'enUS','Da little beasties\' homes light up nice!','',26124),
(30350,'enUS','Noting can save you, beasties! Dis be Scourge land now!','',26124),
(30351,'enUS','Der ain\'t notin anybody can do about it!','',26124),
(30352,'enUS','Der be no stoppin\' us!','',26124),
(30353,'enUS','Looking for a tabard?','Looking for a tabard?',26124),
(30354,'enUS','I\'ve lost my Arathor Battle Tabard.','I\'ve lost my Arathor Battle Tabard.',26124),
(30355,'enUS','I\'ve lost my Battle Tabard of the Defilers.','I\'ve lost my Battle Tabard of the Defilers.',26124),
(30356,'enUS','I\'ve lost my Blood Knight Tabard.','I\'ve lost my Blood Knight Tabard.',26124),
(30357,'enUS','I\'ve lost my Tabard of the Argent Dawn.','I\'ve lost my Tabard of the Argent Dawn.',26124),
(30358,'enUS','I\'ve lost my Tabard of the Hand.','I\'ve lost my Tabard of the Hand.',26124),
(30359,'enUS','I\'ve lost my Green Trophy Tabard of the Illidari.','I\'ve lost my Green Trophy Tabard of the Illidari.',26124),
(30360,'enUS','I\'ve lost my Purple Trophy Tabard of the Illidari.','I\'ve lost my Purple Trophy Tabard of the Illidari.',26124),
(30361,'enUS','Greetings, $c. I can assist you in recovering lost companions.','Greetings, $c. I can assist you in recovering lost companions.',26124),
(30362,'enUS','I\'ve lost my Tabard of the Achiever.','I\'ve lost my Tabard of the Achiever.',26124),
(30363,'enUS','I\'ve lost my Tabard of the Protector.','I\'ve lost my Tabard of the Protector.',26124),
(30364,'enUS','It is time to show you my true power! [PH]','',26124),
(30365,'enUS','You\'ve been seen! Use the net and ice slick to keep the dwarves away!','',26124),
(30366,'enUS','The %s sniffs the ground to pickup the trail.','',26124),
(30367,'enUS','The %s has tracked the scent to its source.','',26124),
(30368,'enUS','The frosthound has located the thief\'s hiding place. Confront him!','',26124),
(30369,'enUS','Minionsss of the scale, heed my call!','',26124),
(30370,'enUS','A thousssand fangsss gonna rend your flesh!','',26124),
(30371,'enUS','TROLL MAKE ME ANGRY!','',26124),
(30372,'enUS','','Hello there! Care to buy some fishing supplies, or perhaps take a lesson or two?',26124),
(30373,'enUS','Assessing database integrity ...','',26124),
(30374,'enUS','Running a level three diagnostic ...','',26124),
(30375,'enUS','Defragmenting swap file ...','',26124),
(30376,'enUS','Verifying encryption key ...','',26124),
(30377,'enUS','Attempting to restore lost data ...','',26124),
(30378,'enUS','Implementing new security protocols ...','',26124),
(30379,'enUS','Too long have I been gone, fighting my way across Azeroth to rediscover my past and reclaim my throne. With all the challenges that have tested the Alliance in my absence, it warms my heart to see heroes such as yourself defending our coalition.','',26124),
(30380,'enUS','See to your arms! We must protect the harbor, or the Alliance\'s assault on Northrend will be halted before it can even begin!','',26124),
(30381,'enUS','This latest affront by the Lich King must be dealt with. Stormwind is doing what we can, but it will require the effort of everyone to overcome. Only after the threat at home has passed can we begin to deal with the Scourge threat abroad.$B$BThe traitor prince Arthas tests us from his seat of power in Northrend. Rest assured that the Alliance will not sit on its haunches. Preparations are already underway... for war.$B$BDefeating the Lich King and his armies will be a long and challenging ordeal. Death itself must be conquered. Many lives will be lost, but the future of Azeroth depends on our victory.$B$BI only hope that you\'ll be able to join the battle in Northrend and contribute your skill and strength to the cause.','',26124),
(30382,'enUS','No sooner does King Wrynn return to us that another king makes his presence known.  For five years, we have had the luxury of the Scourge keeping to their conquered lands while brave heroes dealt with threats both near and far.','',26124),
(30383,'enUS','Blast it, this isn\'t the time for talk! Scourge forces are pressing down upon our war ships. Take up your weapon of choice and protect those boats! If they are destroyed, our war effort will be set back months!','',26124),
(30384,'enUS','Our efforts in Lordaeron have been all for naught. Despite numerous setbacks, the Scourge remain unfazed. We must cut them off at the source.$B$BThe time draws near to sail for Northrend. I don\'t know what awaits us; only that our enemies are numerous and are eager for our slaughter.$B$BBut we cannot pursue any other path in good conscience. Azeroth depends on our vigilance.','',26124),
(30385,'enUS','%s begins to transform!','',26124),
(30386,'enUS','The Alliance has gone through some dramatic changes since I last walked among its citizens in the time of the Third War. Some good and some...$B$B<Broll glances forlornly at Valeera.>$B$B...that could have been regrettably avoided.$B$BWith all the focus on the Burning Legion and their attacks on Azeroth, the Scourge has grown into a formidable force. The Legion\'s corruption and Scourge\'s defilement of the land are one and the same: an aberration of the natural order that must end.','',26124),
(30387,'enUS','Save your words! If the Scourge succeeds here, then the Alliance\'s hopes of striking back at the Lich King are dashed!','',26124),
(30388,'enUS','%s transforms into a Mammoth!','',26124),
(30389,'enUS','I haven\'t seen such a buildup of forces since the Third War! Varian is dead set on addressing the Scourge threat directly. That\'s just like him....$B$BAre you heading to Northrend? I have never been there, but I hear it is both a beautiful and treacherous land. Sadly, urgent matters at home require my attention, so I will not be able to join Highlord Fordragon and his army on their journey.','',26124),
(30390,'enUS','','I see that look in your eyes. Don\'t think I\'m ignorant to the feelings of your people. I\'m just as uncomfortable having to suffer the distrusting glares of guard and citizen alike.$B$BI only stick around because of my obligation to Varian. He treats me as an equal... the way the Alliance should have treated my people.$B$BNow, if you\'re done gawking, the Scourge is making a mess of things in Stormwind. Why don\'t you go do something about it?',26124),
(30391,'enUS','','This is no time for talk! If those boats are destroyed, then the Alliance will keep fighting the Scourge in their home instead of the Lich King\'s! So make yourself useful and kill some undead!',26124),
(30392,'enUS','','I heard the Horde is amassing its own army to head to Northrend. HOPEFULLY your Alliance and the Horde can focus their aggression on the real threat. You know, instead of each other?$B$BSomehow I think that\'s unlikely to happen, if my experience here is any indication. Your people have been SO welcoming to me.$B$B<Valeera mutters angrily to herself.>',26124),
(30393,'enUS','FOOLS OF STORMWIND!  HEAR ME, NAIVE CHILDREN OF THE ALLIANCE!  TREMBLE AND KNOW YOUR DOOM, FOR THE LICH KING\'S GAZE IS FIXED UPON YOU!','',26124),
(30394,'enUS','ARGH!  THIS SMALL VICTORY WILL AVAIL YOU NOTHING!  COME!  COME TO NORTHREND.  MY MINIONS ARE WAITING, AND THEY ARE HUNGRY....','',26124),
(30395,'enUS','See to your arms! We must protect the harbor, or the Alliance\'s assault on Northrend will be halted before it can even begin!','',26124),
(30396,'enUS','Rageclaw free! Troll die now!','',26124),
(30397,'enUS','No more mister nice wolvar!','',26124),
(30398,'enUS','I poop on you, trollses!','',26124),
(30399,'enUS','Revenge for Rageclaw!','',26124),
(30400,'enUS','ARRRROOOOOGGGGAAAA!!!','',26124),
(30401,'enUS','This mean war!','',26124),
(30402,'enUS','Use of the Inventor\'s Disk detected. Emergency protocol gamma activated.','',26124),
(30403,'enUS','Verifying status of Norgannon\'s shell.','',26124),
(30404,'enUS','Norgannon\'s shell accounted for and secure. It will be available for transfer once user\'s identity has been verified.','',26124),
(30405,'enUS','Standby to verify identity as Keeper Mimir.','',26124),
(30406,'enUS','Identity verification failed. User is not Keeper Mimir.','',26124),
(30407,'enUS','The Inventor\'s Disk has fallen into the hands of an unauthorized user.  Activating defense protocol.','',26124),
(30408,'enUS','Impostor must be dealt with. The Inventor\'s Disk must be recovered.','',26124),
(30409,'enUS','You gave in too soon!','',26124),
(30410,'enUS','How disappointing for you.','',26124),
(30411,'enUS','Unfortunate. The best was yet to come.','',26124),
(30412,'enUS','Anakh kyree!','',26124),
(30413,'enUS','My Onslaught will wash over the Lich King\'s forces!','',26124),
(30414,'enUS','Your death is in vain, tiny mortal.','',26124),
(30415,'enUS','Your time has come to an end.','',26124),
(30416,'enUS','You\'re wasting time. Go kill the minions of the Lich King, $c!','',26124),
(30417,'enUS','How fare your efforts against the Lich King, $c?','',26124),
(30418,'enUS','It is good to see you again, $n. How could I ever forget the $g man : woman; who saved my sister\'s life?','',26124),
(30419,'enUS','It is good to see you again, $n.','',26124),
(30420,'enUS','Are you okay? I\'ve come to take you back to Frosthold if you can stand.','Are you okay? I\'ve come to take you back to Frosthold if you can stand.',26124),
(30421,'enUS','All systems online and functional!','',26124),
(30422,'enUS','Directive: Repair prototype console.','',26124),
(30423,'enUS','Implementing directive!','',26124),
(30424,'enUS','Prototype console repaired and returned to functional status.','',26124),
(30425,'enUS','Awaiting further instructions from Keeper Mimir.','',26124),
(30426,'enUS','Powering up!','',26124),
(30427,'enUS','<The Frostborn Scout attempts to rise to his feet as you approach, but stumbles back to the ground, clenching an obviously painful wound in his side.>','',26124),
(30428,'enUS','I don\'t think that\'s going to happen, $G lad:lass;. I\'ve lost a lot of blood... there\'s no way I\'m making it back.','',26124),
(30429,'enUS','I\'m sorry that I didn\'t get here sooner. What happened?','I\'m sorry that I didn\'t get here sooner. What happened?',26124),
(30430,'enUS','A pack of harpies came up from the valley. A big one named Sirana led them... I didn\'t have anywhere to escape. They haven\'t been this aggressive for a long time... I didn\'t expect it... I let my guard down.... it\'s my own fault.','',26124),
(30431,'enUS','I\'ll go get some help. Hang in there.','I\'ll go get some help. Hang in there.',26124),
(30432,'enUS','It\'s a little late... for that... $G lad:lass;.$B$B<The Frostborn Scout coughs up some blood on the snow.>$B$BGet... that wench in charge for me...$B$B<The Frostborn Scout slumps over as he breathes his last breath.>','',26124),
(30433,'enUS','Look around and let the devastation sink in, $c. Every last troll that lived here is either dead or has fled to the upper levels.$B$BIt gets worse.$B$BIn an act of desperation, the living Drakkari trolls sacrificed their own animal gods so that they could drink from the blood of the gods and gain untold power. While they succeeded in keeping the Scourge at bay with their newfound strength, the results were catastrophic. The ancient empire of Zul\'Drak lies in ruin as proof.\n','',26124),
(30434,'enUS','Do keep out of sight, will you? I\'m trying to pretend that I\'m still under the Lich King\'s control!','',26124),
(30435,'enUS','You almost done, Dan?','',26124),
(30436,'enUS','We need to get back to Lantinga and tell him about this place. Hurry it up!','',26124),
(30437,'enUS','If you would have let me drive, we wouldn\'t have gotten in this mess!','',26124),
(30438,'enUS','We won\'t survive another attack, Dan. You gotta get us out of here!','',26124),
(30439,'enUS','Hurry up, Reed!','',26124),
(30440,'enUS','Think you could calculate how many things out here want to kill us? I bet you\'d be surprised at the results.','',26124),
(30441,'enUS','I\'m working as fast as humanly possible, Pat. Stop interrupting me!','',26124),
(30442,'enUS','I\'m sure things would have been a lot better with you driving. We would have all probably died on the way here instead. I can see the headlines now: \"Heroes of the Argent Crusade Killed in Fatal Steam Tank Accident.\"','',26124),
(30443,'enUS','It\'s times like these that I remember why we\'re best friends, Pat. You\'re always so full of positive encouragement.','',26124),
(30444,'enUS','My goal is to work as slowly as possible, giving any murderous Scourge in the area a large window in which they can choose to kill us and then do terrible things to our corpses. Isn\'t that the plan? ','',26124),
(30445,'enUS','Maybe you should come bang on this thing with my wrench for awhile, eh? Then you can see what it feels like to be me! Let me tell you, it ain\'t easy!','',26124),
(30446,'enUS','One more word out of you and so help me...','',26124),
(30447,'enUS','Why couldn\'t they have taken you instead of Dargath? WHY! WHY! WHY!?','',26124),
(30448,'enUS','It\'s about to get crazy up in here, Pat. Don\'t say another word!','',26124),
(30449,'enUS','Gerk, Burr, Dargath: all gone... It\'s just MacKellar and I left out here. I hope you\'ve brought some good news.','',26124),
(30450,'enUS','Can you repair my gear?','Can you repair my gear?',26124),
(30451,'enUS','Tick tock, tick tock...','',26124),
(30452,'enUS','Not quick enough!','',26124),
(30453,'enUS','Let\'s get this over with.','',26124),
(30454,'enUS','There is no future for you.','',26124),
(30455,'enUS','This is the hour of our greatest triumph!','',26124),
(30456,'enUS','You were destined to fail.','',26124),
(30457,'enUS','The ink has dried on this chapter of history...','',26124),
(30458,'enUS','','You dare?! Where is Baron Sliver? I would have words with him!',26124),
(30459,'enUS','Mrmrmmrmrmrmrm... mrmrmrmr?!','',26124),
(30460,'enUS','Vile free? Vile love $n!','',26124),
(30461,'enUS','Crush... maim... DESTROY!','',26124),
(30462,'enUS','','Who intrudes upon my ritual?',26124),
(30463,'enUS','Mrrfrmrfrmrrrrr!','',26124),
(30464,'enUS','Enough!  I will not stand for this!','',26124),
(30465,'enUS','You\'re the one that\'s been disrupting things? This should be easy.','',26124),
(30466,'enUS','I\'ll kill every last one of your pawns, Lich King!','',26124),
(30467,'enUS','Take your flying fortresses back to Northrend, before I crush them with my bare hands!','',26124),
(30468,'enUS','Halt. If the core is in your possession, please place it safely on the ground to avoid any damage it make incur during your elimination.','',26124),
(30469,'enUS','Elimination will now commence. Thank you for your cooperation.','',26124),
(30470,'enUS','','My dear general, your time has come!',26124),
(30471,'enUS','SMASH!','',26124),
(30472,'enUS','MRMRFRMRFRMRRRR!','',26124),
(30473,'enUS','Not if I have something to say about it, sparky!','',26124),
(30474,'enUS','King Stormheart had me stop by to lend you hand - looks like it was good that I did. Good luck to ya.','',26124),
(30475,'enUS','That\'s enough.  Separate!','',26124),
(30476,'enUS','FOOLS! YOU WON\'T HOLD THE SHADOW VAULT FOR LONG!','',26124),
(30477,'enUS','Hurry! It\'s not safe for you to be seen with me here....','',26124),
(30478,'enUS','Be quick! We must not be seen together.','',26124),
(30479,'enUS','What news, friend?','',26124),
(30480,'enUS','Can you help me get down from here, Stefan?','Can you help me get down from here, Stefan?',26124),
(30481,'enUS','This should see you to the ground safely, $n.','',26124),
(30482,'enUS','Please to be quiet! Pups asleeping!','',26124),
(30483,'enUS','They are coming for you.','',26124),
(30484,'enUS','Give in to your fear.','',26124),
(30485,'enUS','Kill them all... before they kill you.','',26124),
(30486,'enUS','They have turned against you. Now... take your revenge.','',26124),
(30487,'enUS','Tell yourself again that these are not truly your friends.','',26124),
(30488,'enUS','There is no escape. Not in this life. Not in the next.','',26124),
(30489,'enUS','You are a pawn of forces unseen.','',26124),
(30490,'enUS','It WAS your fault.','',26124),
(30491,'enUS','Ugly little monsters, pray I don\'t get out!','',26124),
(30492,'enUS','I will crush you all!','',26124),
(30493,'enUS','Wretched beasts!','',26124),
(30494,'enUS','My brothers will come for me and then you will see what true power is!','',26124),
(30495,'enUS','Your torture only adds to my rage!','',26124),
(30496,'enUS','I will devour you whole!','',26124),
(30497,'enUS','How long do you think this cage can hold me, fiends!','',26124),
(30498,'enUS','I will take pleasure in gutting you!','I will take pleasure in gutting you!',26124),
(30499,'enUS','I will feed you to the dogs!','I will feed you to the dogs!',26124),
(30500,'enUS','Your entrails will make a fine necklace.','Your entrails will make a fine necklace.',26124),
(30501,'enUS','Die, maggot!','Die, maggot!',26124),
(30502,'enUS','You come to die!','You come to die!',26124),
(30503,'enUS','I spit on you!','I spit on you!',26124),
(30504,'enUS','Sniveling pig!','Sniveling pig!',26124),
(30505,'enUS','Ugglin oo bjorr!','Ugglin oo bjorr!',26124),
(30506,'enUS','Haraak foln!','Haraak foln!',26124),
(30507,'enUS','You come to die!','You come to die!',26124),
(30508,'enUS','I\'ll eat your heart!','I\'ll eat your heart!',26124),
(30509,'enUS','','Good work with the crates! Come talk to me in front of Stratholme for your next assignment!',26124),
(30510,'enUS','Farewell, friend. May we meet again under better circumstances. I\'ll never forget what you did for me!','',26124),
(30511,'enUS','Algar the Chosen is at the Reliquary of Pain to the northeast.\n\nPrince Navarius is on the other side of the Dead Fields to the east.','',26124),
(30512,'enUS','Go away, gnoll!','',26124),
(30513,'enUS','You not gonna steal no more parts from Dim!','',26124),
(30514,'enUS','My parts, gnoll!','',26124),
(30515,'enUS','Let me grab parts for goblin... stop stealing!','',26124),
(30516,'enUS','No! My parts!','',26124),
(30517,'enUS','No... no more steal.','',26124),
(30518,'enUS','Why? Why you not just leave Dim alone?','',26124),
(30519,'enUS','Dim just want to go back... let Dim finish, dumb gnoll.','',26124),
(30520,'enUS','','Casting kill credit at $n.',26124),
(30521,'enUS','%s begins to emerge from its Seed Pod.','',26124),
(30522,'enUS','Not yet... not ye--','',26124),
(30523,'enUS','Take a moment and relish this with me. Soon... all will be revealed. Okay then, let\'s do this!','',26124),
(30524,'enUS','Time to get some answers! Let\'s get this show on the road!','',26124),
(30525,'enUS','Now that\'s earnin\' your supper!','',26124),
(30526,'enUS','Press on; that\'s the way!','',26124),
(30527,'enUS','Press on; that\'s the way!','',26124),
(30528,'enUS','You wish to confront the master? You must first weather the storm!','',26124),
(30529,'enUS','The slightest spark shall be your undoing.','',26124),
(30530,'enUS','No one is safe!','',26124),
(30531,'enUS','Shocking, I know.','',26124),
(30532,'enUS','You attempt the impossible.','',26124),
(30533,'enUS','Your spark of life is... extinguished.','',26124),
(30534,'enUS','Master... you have guests.','',26124),
(30535,'enUS','What hope is there for you? None!','',26124),
(30536,'enUS','I have witnessed the rise and fall of empires... the birth and extinction of entire species... Over countless millennia the foolishness of mortals has remained the only constant. Your presence here confirms this.','',26124),
(30537,'enUS','My master has shown me the future, and you have no place in it. Azeroth will be reborn in darkness. Yogg-Saron shall be released! The Pantheon shall fall!','',26124),
(30538,'enUS','You cannot hide from fate!','',26124),
(30539,'enUS','Come closer. I will make it quick.','',26124),
(30540,'enUS','Your flesh cannot hold out for long.','',26124),
(30541,'enUS','Only mortal...','',26124),
(30542,'enUS','I... am... FOREVER!','',26124),
(30543,'enUS','What little time you had, you wasted!','',26124),
(30544,'enUS','My death... heralds the end of this world.','',26124),
(30545,'enUS','You stare blindly into the abyss!','',26124),
(30546,'enUS','Your ignorance is profound. Can you not see where this path leads?','',26124),
(30547,'enUS','You cross the precipice of oblivion!','',26124),
(30548,'enUS','The iron dwarves followed you! Use the net and the ice slick to escape!','',26124),
(30549,'enUS','Frostbite has tracked the scent to its source. Investigate the cave!','',26124),
(30550,'enUS','%s sniffs and finds the trail.','',26124),
(30551,'enUS','%s has tracked the scent to its source inside the cave.','',26124),
(30552,'enUS','Now keep an eye out! I\'ll have this licked in two shakes of a--','',26124),
(30553,'enUS','Oh, that doesn\'t sound good. We might have a complication or two...','',26124),
(30554,'enUS','Ah, you want to play hardball, eh? That\'s just my game!','',26124),
(30555,'enUS','Couple more minutes and I\'ll--','',26124),
(30556,'enUS','Heightened? What\'s the good news?','',26124),
(30557,'enUS','So that was the problem? Now I\'m makin\' progress...','',26124),
(30558,'enUS','Hang on! Nobody\'s gonna\' be sanitized as long as I have a say in it!','',26124),
(30559,'enUS','Ha! The old magic fingers finally won through! Now let\'s get down to--','',26124),
(30560,'enUS','Purge? No no no no no.. where did I-- Aha, this should do the trick...','',26124),
(30561,'enUS','Time to get some answers! Let\'s get this show on the road!','',26124),
(30562,'enUS','I\'m doin\' everything I can!','',26124),
(30563,'enUS','Light preserve ye!','',26124),
(30564,'enUS','I hope this is all worth it!','',26124),
(30565,'enUS','Query? What do you think I\'m here for, tea and biscuits? Spill the beans already!','',26124),
(30566,'enUS','Tell me how the dwarves came to be, and start at the beginning!','',26124),
(30567,'enUS','Right, right... I know the earthen were made from stone to shape the deep regions o\' the world. But what about the anomalies? Matrix non-stabilizin\' and what-not?','',26124),
(30568,'enUS','Necrowhatinthe-- Speak bloody Common, will ye?','',26124),
(30569,'enUS','You call that fighting? Let me go grab your dolly. Maybe she could teach you how to swing.','',26124),
(30570,'enUS','My dead grandmater, rest her soul, could beat you... even now!','',26124),
(30571,'enUS','I\'ve half a mind to cut you both down where you stand! The other half isn\'t arguing!','',26124),
(30572,'enUS','Well hello, ladies. What do you think this is... Skorn?','',26124),
(30573,'enUS','You will practice until your lungs are bursting and your arms are aching, and then we\'ll really start!','',26124),
(30574,'enUS','Only the best of the best get a shot in Valhalas to go to Ymirheim. Everyone else dies... or worse!','',26124),
(30575,'enUS','Stop trying to hit him and HIT HIM already!','',26124),
(30576,'enUS','Are you trying to make me look bad? That\'s the only thing that you\'re good for today!','',26124),
(30577,'enUS','Old Gods, huh? So they zapped the earthen with this Curse of Flesh... and then what?','',26124),
(30578,'enUS','If they killed the Old Gods, Azeroth would\'ve been destroyed...','',26124),
(30579,'enUS','What protectors?','',26124),
(30580,'enUS','Aesir and Vanir... Okay, so the Forge o\' Wills started makin\' new earthen... but what happened to the old ones?','',26124),
(30581,'enUS','Hold everything! The Aesir and Vanir went to war? Why?','',26124),
(30582,'enUS','This \"Loken\" sounds like a nasty character. Glad we don\'t have to worry about the likes o\' him anymore. So... if I\'m understandin\' ye right, the original earthen eventually woke up from this stasis, and by that time the destabili-whatever had turned \'em into proper dwarves. Or at least... dwarf ancestors.','',26124),
(30583,'enUS','Well, now... that\'s a lot to digest. I\'m gonna need some time to take all this in. Thank ye.','',26124),
(30584,'enUS','I\'ll use the forge to make batches o\' earthen to stand guard... But our greatest challenge still remains: find and stop Loken!','',26124),
(30585,'enUS','','Hefting',26124),
(30586,'enUS','STORMS GRANT ME POWER!','',26124),
(30587,'enUS','LIGHTNING GUIDE MY FURY!','',26124),
(30588,'enUS','LET THE STORM\'S FURY CONSUME YOU!','',26124),
(30589,'enUS','NO ESCAPE FOR THE WICKED!','',26124),
(30590,'enUS','AAARRRRRRGGGGGGHHHHHHH!! SUCH POWER!','',26124),
(30591,'enUS','THE LIGHTNING COURSES THROUGH ME!','',26124),
(30592,'enUS','IT IS THE WRATH OF THE STORM KING!','',26124),
(30593,'enUS','Delicious morsels have come to visit! Shall I use your bombs to cook you?','',26124),
(30594,'enUS','','Be welcome amongst us, $c.',26124),
(30595,'enUS','I will crush you under foot!','',26124),
(30596,'enUS','I\'ll wipe you off of my boots later!','',26124),
(30597,'enUS','Tiny creatures, I trample you!','',26124),
(30598,'enUS','Taste Gymer\'s size 600!','',26124),
(30599,'enUS','FREE!!! Soon you will feel the wrath of the storm king!','',26124),
(30600,'enUS','WOW! I... I\'ve never seen anything like him! Give \'em hell, $n!','',26124),
(30601,'enUS','The Scourge don\'t stand a chance!','',26124),
(30602,'enUS','Burning','Burning',26124),
(30603,'enUS','','Accessing... Creators arrived to extirpate symbiotic infection. Assessment revealed that Old God infestation had grown malignant. Excising parasites would result in loss of host--',26124),
(30604,'enUS','','Correct. Creators neutralized parasitic threat and contained it within the host. Forge of Wills and other systems were instituted to create new earthen. Safeguards were implemented, and protectors were appointed.',26124),
(30605,'enUS','','Designations: Aesir and Vanir. Or in the common nomenclature, storm and earth giants. Sentinel Loken designated supreme. Dragon Aspects appointed to monitor evolution on Azeroth.',26124),
(30606,'enUS','','Additional background is relevant to your query: following global combat between Aesir and Vanir--',26124),
(30607,'enUS','','Unknown. Data suggests that impetus for global combat originated with prime designate Loken, who neutralized all remaining Aesir and Vanir, affecting termination of conflict. Prime designate Loken then initiated stasis of several seed races, including earthen, giants and vrykul, at designated holding facilities.',26124),
(30608,'enUS','','Essentially that is correct.',26124),
(30609,'enUS','With my freedom comes the vengeance of storm!','',26124),
(30610,'enUS','Listen to what I have to tell you about our enemy before we start. You don\'t want to be unprepared while we\'re out smashing Scourge in the field.','',26124),
(30611,'enUS','Accessing prehistoric data... retrieved. In the beginning the earthen were created to--','',26124),
(30612,'enUS','Accessing... In the early stages of it\'s development cycle, Azeroth suffered infection by parasitic necrophotic symbiotes.','',26124),
(30613,'enUS','Designation: Old Gods. Old Gods rendered all systems, including earthen, defenseless in order to facilitate assimilation. This matrix destabilization has been termed \"the Curse of Flesh\". Effects of destabilization increased over time.','',26124),
(30614,'enUS','Acknowledged, Branbronzan. Session terminated.','',26124),
(30615,'enUS','Gymer, where are Algar, Navarius and Thrym?','Gymer, where are Algar, Navarius and Thrym?',26124),
(30616,'enUS','Gymer, what do I need to know? I\'ve never ridden on a giant.','Gymer, what do I need to know? I\'ve never ridden on a giant.',26124),
(30617,'enUS','I\'m ready, Gymer. Let\'s go!','I\'m ready, Gymer. Let\'s go!',26124),
(30618,'enUS','<Brann looks at you expectantly.>','',26124),
(30619,'enUS','Imagine all the wisdom and knowledge locked away within Ulduar. The very secrets of life could be held there!','',26124),
(30620,'enUS','Greetings.','',26124),
(30621,'enUS','Do you understand me? We should be able to understand each other now.','Do you understand me? We should be able to understand each other now.',26124),
(30622,'enUS','If the Explorers\' League sent men, I didn\'t see any trace of them. I found your note buried in a camp overrun by iron dwarves.','If the Explorers\' League sent men, I didn\'t see any trace of them. I found your note buried in a camp overrun by iron dwarves.',26124),
(30623,'enUS','A scout found the remains of your journal in Thor Modan. We\'ve been looking for you ever since.','A scout found the remains of your journal in Thor Modan. We\'ve been looking for you ever since.',26124),
(30624,'enUS','I... I can understand you now! Well, now that we can talk to each other, you have some explaining to do!','',26124),
(30625,'enUS','How did you get my communicator from the Explorers\' League?','',26124),
(30626,'enUS','You have my thanks for dispatching the iron dwarves. But why would the Horde have an interest in me?','',26124),
(30627,'enUS','That wouldn\'t be Scout Vor\'takh, would it? Even I know of his reputation for ruthlessness. He means to abduct me, then?','',26124),
(30628,'enUS','If you\'ve seen the journal, then you know what I\'ve been discovering. The titans\' own creations are at war with each other!','',26124),
(30629,'enUS','Loken and his iron dwarf minions have ousted the Earthen from Ulduar and taken over the city.','',26124),
(30630,'enUS','If we spend our time and strength fighting with each other, Loken will use Ulduar\'s resources to destroy both Horde and Alliance.','',26124),
(30631,'enUS','Speak to the commander at your post, $g lad:lass;, and persuade him to abandon Vor\'takh\'s foolish plan.','',26124),
(30632,'enUS','Boktar thinks this crash an unfortunate event, but I believe we\'re intended to learn something from it.','',26124),
(30633,'enUS','The Ymirjar battle lord, Algar the Chosen, rouses his Vargul armies at the Reliquary of Pain, northeast of this cage.$B$BPrince Navarius is across the Dead Fields, east of here, near the great steps leading up to the second level of Zul\'Drak.$B$BThrym\'s location is currently unknown, which is curious considering his size.$B$BAll must be dealt with!','',26124),
(30634,'enUS','I have a few more questions, Gymer.','I have a few more questions, Gymer.',26124),
(30635,'enUS','You\'re weak, old woman!','',26124),
(30636,'enUS','Hela take you!','',26124),
(30637,'enUS','I will feast in the halls of Ymirheim tonight and you will pour my mead, cur.','',26124),
(30638,'enUS','The runes foretold victory for me today!','',26124),
(30639,'enUS','Getting tired? Hahahahaha!','',26124),
(30640,'enUS','You\'ll sleep in the underworld tonight!','',26124),
(30641,'enUS','You\'ll wish you\'d never been awakened, boy.','',26124),
(30642,'enUS','You complain much, like a shield-maiden!','',26124),
(30643,'enUS','Poison... my insides are churning...','Poison... my insides are churning...',26124),
(30644,'enUS','I\'m ready - lets get you out of here.','I\'m ready - lets get you out of here.',26124),
(30645,'enUS','Let me know when you\'re ready. I\'d prefer sooner than later... what with the slowly dying from poison and all.','Let me know when you\'re ready. I\'d prefer sooner than later... what with the slowly dying from poison and all.',26124),
(30646,'enUS','I\'m going to bring the venom sac to Ricket... and then... you know... collapse. Thank you for helping me!','I\'m going to bring the venom sac to Ricket... and then... you know... collapse. Thank you for helping me!',26124),
(30647,'enUS','We must strike at Jotunheim continuously. Never give them a chance to catch their breath, never a chance to sleep, and never accept surrender!$B$BTirion Fordring with all the might of Ashbringer and the Argent Crusade behind him cannot hope to accomplish what you are doing!$B$BNow, be quick about your business, $n. There is too much occurring for idle chit-chat.','',26124),
(30648,'enUS','When you are ready I will place you atop my head and we will march into the heart of the Scourge in Zul\'Drak. You must direct me to smash and destroy our enemies!','',26124),
(30649,'enUS','You have reached Rank 1: Recruit','You have reached Rank 1: Recruit',26124),
(30650,'enUS','You have reached Rank 1: Corporal','You have reached Rank 1: Corporal',26124),
(30651,'enUS','You have reached Rank 2: First Lieutenant','You have reached Rank 2: First Lieutenant',26124),
(30652,'enUS','Gymer needs storm cloud badly!','',26124),
(30653,'enUS','Gymer is about to die! Find a storm cloud!','',26124),
(30654,'enUS','Ulduar\'s archives may hold the knowledge we need to stop Loken from using the city\'s resources against us. The problem is that the key to those archives was divided and hidden.$B$BI think I\'ve found out where one of the pieces is, in the Inventor\'s Library, which sits on the northern edge of the mountains northeast of you. The first thing you\'ll need to do is retrieve the fragments of an access disk from the library\'s guardians.','',26124),
(30655,'enUS','We\'re in over our heads, $r! Watch your back!','',26124),
(30656,'enUS','MASTER! NO!','',26124),
(30657,'enUS','THRYM CRUSH!','',26124),
(30658,'enUS','Thrym... Av... Avenge me...','',26124),
(30659,'enUS','Oh, you freed him, did you? No matter, his death and reconstruction will only be slightly delayed.','',26124),
(30660,'enUS','The Ebon Blade is indebted to you for your help in taking The Shadow Vault. We are lucky to have you.$B$BWhile the Alliance and the Horde fight each other, doing the Lich King\'s job for him, we will stay focused on the task at hand.$B$BWhere the Argent Crusade might falter and think twice about how best to crush the enemy, we will have no such moral difficulties.$B$BYou shall be our instrument of vengeance, $n.','',26124),
(30661,'enUS','','I will tear you limb from limb.',26124),
(30662,'enUS','','You challenge?',26124),
(30663,'enUS','','You don\'t look so tough.',26124),
(30664,'enUS','','You think you have what it takes?',26124),
(30665,'enUS','Let\'s do this, sister.','Let\'s do this, sister.',26124),
(30666,'enUS','','Well met, Battle-Sister. I can assist you in recovering lost companions.',26124),
(30667,'enUS','','Well met, Battle-Sister. I can help stable your pets or assist you in recovering lost companions.',26124),
(30668,'enUS','Death Knights... get over here!','',26124),
(30669,'enUS','','Come, Battle-Sister.$B$BFeast, sleep, so that you may fight with all your strength!',26124),
(30670,'enUS','Defend the Temple with your life!','',26124),
(30671,'enUS','Fight back the enemy!','',26124),
(30672,'enUS','They\'re under the ground. They\'re under the ground!','',26124),
(30673,'enUS','This is our home!','',26124),
(30674,'enUS','The challenger has been defeated!','',26124),
(30675,'enUS','They went down like a sack of orc skulls!','',26124),
(30676,'enUS','All that\'s left of the challenger is a red stain on the floor!','',26124),
(30677,'enUS','Call in the clowns! It\'s turned into a circus in there!','',26124),
(30678,'enUS','OOOF! That one\'s gonna require the \"scraper.\"','',26124),
(30679,'enUS','OUTTA NOWHERE -- WHAMO! DEAD!','',26124),
(30680,'enUS','Avert your eyes, ladies and gentlemen! It\'s a bloodbath!','',26124),
(30681,'enUS','The grand Amphitheater of Anguish awaits, $n. Remember, once a battle starts you have to stay in the arena. WIN OR DIE!','',26124),
(30682,'enUS','Here we are once again, ladies and gentlemen. The epic struggle between life and death in the Amphitheater of Anguish! For this round we have $n versus the hulking jormungar, Yg... Yggd? Yggdoze? Who comes up with these names?! $n versus big worm!','',26124),
(30683,'enUS','%s emerges!','',26124),
(30684,'enUS','$n has defeated Yg... Yggg-really big worm!','',26124),
(30685,'enUS','Prepare to make your stand, $n! Get in the Amphitheater and stand ready! Remember, you and your opponent must stay in the arena at all times or you will be disqualified!','',26124),
(30686,'enUS','The battle is about to begin! Am I reading this card right? It... It\'s the nefarious magnataur lord, STINKBEARD! Yes, folks, STINKBEARD! $n doesn\'t stand a chance!','',26124),
(30687,'enUS','And with AUTHORITY, $n dominates the magnataur lord! Stinkbeard\'s clan is gonna miss him back home in the Dragonblight!','',26124),
(30688,'enUS','Stinkbeard comin\' for you, little ones!','',26124),
(30689,'enUS','I\'ll melt the flesh off your bones!','',26124),
(30690,'enUS','You think you can challenge me, little $r?','',26124),
(30691,'enUS','Your race has no honor. But come anyway... you\'ll die like all the others!','',26124),
(30692,'enUS','By Thorim\'s beard, this should be good sport!','',26124),
(30693,'enUS','Come then, $r $c, I do not have all day!','',26124),
(30694,'enUS','It will not get me any closer to proving myself at Valhalas to kill you, but it should be entertaining!','',26124),
(30695,'enUS','If you seek death, you have found it!','',26124),
(30696,'enUS','A quick trip to the underworld for you, and a laugh for me. Sounds like a fair trade!','',26124),
(30697,'enUS','A Drakkari, one of the so-called Scarlet Onslaught, a gnome, a Hyldnir shield-maiden, and now you? Is this a joke?','',26124),
(30698,'enUS','Do you feel that folks? The air is crackling with energy! That can only mean one thing...','',26124),
(30699,'enUS','Coward!','',26124),
(30700,'enUS','Arise, brothers of the earth! Watch as Erathius destroys the mortals!','',26124),
(30701,'enUS','For Neptulon! Strength of storm and sea, crush my enemies!','',26124),
(30702,'enUS','Al\'Akir grant my enemies a cold, swift death!','',26124),
(30703,'enUS','This battle must be seen to be believed! Once a mild-mannered tuskarr fisherman, our next fighter turned to the life of a soulless mercenary when his entire family was wiped out by a vicious pack of lion seals and ill-tempered penguins! Now he\'s just in it for the gold! Ladies and gentlemen, ORINOKO TUSKBREAKER!!','',26124),
(30704,'enUS','Come, land-dwellers, face the fury of tusk and whisker!','',26124),
(30705,'enUS','Korrak has come, weaklings! Snowfall belongs to Winterax! Erm, Korrak mean to say amphitheater belong to Winterax!','',26124),
(30706,'enUS','No graveyard here for you to play wicked games on Korrak! DIE!','',26124),
(30707,'enUS','From the Savage Ledge of Icecrown, Vladof the Butcher and his mammoth, Enormos! There ain\'t gonna be a thing left of our challengers, folks! Prepare for a downpour of blood, guts and tears!','',26124),
(30708,'enUS','Yes, my precious, we will tear them apart! For the one true king!','',26124),
(30709,'enUS','Useless mongrel! I\'ll kill \'em myself!','',26124),
(30710,'enUS','Vladof dismounts!','',26124),
(30711,'enUS','What is this?!','',26124),
(30712,'enUS','By order of Duke Lankral, Commander of the Knights of the Ebon Blade, Vanquisher of the Scourge and Conqueror of The Shadow Vault, you are ordered to stand down. What is your answer?','By order of Duke Lankral, Commander of the Knights of the Ebon Blade, Vanquisher of the Scourge and Conqueror of The Shadow Vault, you are ordered to stand down. What is your answer?',26124),
(30713,'enUS','My answer? Here\'s my answer, little messenger!','',26124),
(30714,'enUS','The champion of the Winterax trolls has challenged you, $n! I hope you\'re ready!','',26124),
(30715,'enUS','Hailing from the distant mountains of Alterac, one of the fiercest competitors this arena has ever seen: KORRAK THE BLOODRAGER!!!','',26124),
(30716,'enUS','I DON\'T BELIEVE IT! WE HAVE A NEW CHAMPION OF ANGUISH!!! Vladof the Butcher has been defeated by a ragtag crew of nobodies! Incredible finish!','',26124),
(30717,'enUS','%s gathers its mojo and surges forward!','',26124),
(30718,'enUS','$n is impaled!','',26124),
(30719,'enUS','If there\'s nothing else that you can do, kill these things!','',26124),
(30720,'enUS','Thank you. I thought I was doomed.','',26124),
(30721,'enUS','I was certain I was going to die out here.','',26124),
(30722,'enUS','Let me fight by your side.','',26124),
(30723,'enUS','Let us fight the irons together!','',26124),
(30724,'enUS','I can take care of myself, $n.','',26124),
(30725,'enUS','Once a match starts there\'s two ways out: WIN OR DIE! Fleeing is not an option!','',26124),
(30726,'enUS','%s goes Berserk!','',26124),
(30727,'enUS','%s grows increasingly crazed!','',26124),
(30728,'enUS','Thrall... Warchief... your armies await your command. Let me lead them to Northrend to remove this undead menace!','',26124),
(30729,'enUS','Gragh! I cannot take this! While you talk and deliberate, our enemies grow stronger! Were it my choice, I would have put all our available forces onto that frozen rock and conquered it for the Horde!','',26124),
(30730,'enUS','After all that he did for YOU and YOUR people? MAK\'GORA!','',26124),
(30731,'enUS','So you refuse? Is the son of Durotan a coward?','',26124),
(30732,'enUS','What say you, Saurfang?','',26124),
(30733,'enUS','My soul burns for revenge, but the elements tell me to think clearly. The Lich King is a ruthless opponent... one who must be handled carefully.','',26124),
(30734,'enUS','We will send scouts to assess the situation. I will also convene with the Lady Proudmoore and see what plans the Alliance has.','',26124),
(30735,'enUS','If this is a trap, it is one I will not blindly walk into! Do not make the same mistakes as your father, Garrosh!','',26124),
(30736,'enUS','Warchief, it is clear that Northrend represents the gravest threat to our people, and that we must act against it. But this foe is unlike any other. Caution must be advised.','',26124),
(30737,'enUS','Warchief! Scourge forces are attacking Orgrimmar!','',26124),
(30738,'enUS','Yes, Warchief?','',26124),
(30739,'enUS','As you command, Warchief!','',26124),
(30740,'enUS','Something stirs in the pool of mojo...','',26124),
(30741,'enUS','What are YOU doing here?$B$BJust make sure that you stay out of my way. I didn\'t leave the Scarlet Onslaught to be distracted by the likes of you!','',26124),
(30742,'enUS','I challenge you to a duel, Scarlet scum!','I challenge you to a duel, Scarlet scum!',26124),
(30743,'enUS','Wait, wait... I surrender! Please, no more! I\'ll leave!','',26124),
(30744,'enUS','Ha! Efrem the Faithful wins again. Of course!','',26124),
(30745,'enUS','Come, vrykul dogs. I will fight you!','',26124),
(30746,'enUS','You dare to touch ME?! You won\'t keep me from proving myself to the Lich King!','',26124),
(30747,'enUS','Why do you not face me? Are you afraid of Efrem the Faithful?','',26124),
(30748,'enUS','I am not possessed of infinite patience! I came here to prove myself, and that is exactly what I intend to do!','',26124),
(30749,'enUS','Fight me now, vrykul, or be labeled a coward!','',26124),
(30750,'enUS','','Taste my steel, little $g boy : girl;!',26124),
(30751,'enUS','','Of course you lost. What did you expect?',26124),
(30752,'enUS','','Do not bother me, pest. I am studying the inept fighting of these so-called combatants.$B$BI will best them all, and then I will be elevated to serve the Lich King.',26124),
(30753,'enUS','I\'ve heard that vrykul women cannot fight at all. If you wish to prove me wrong, you can try.','I\'ve heard that vrykul women cannot fight at all. If you wish to prove me wrong, you can try.',26124),
(30754,'enUS','You look like you could make us some money. How about a spin inside the Amphitheater of Anguish, pal?','',26124),
(30755,'enUS','PUPS OF ORGRIMMAR!  HEAR ME, BRASH UPSTARTS OF THE HORDE!  TREMBLE, AND KNOW YOUR DOOM,  FOR THE LICH KING\'S GAZE IS FIXED UPON YOU!','',26124),
(30756,'enUS','You\'re the champion now, buddy! Do you think you have what it takes to defend your title?','',26124),
(30757,'enUS','%s begins to cast Poison Nova!','',26124),
(30758,'enUS','This unit is busy. Please inquire later.','',26124),
(30759,'enUS','Go back to work before the overseer sees us.','',26124),
(30760,'enUS','I\'m not a laborer. I\'m here to free you from servitude in the mines.','I\'m not a laborer. I\'m here to free you from servitude in the mines.',26124),
(30761,'enUS','%s explodes into a pool of plague!','',26124),
(30762,'enUS','Free again? Keeper Mimir\'s work awaits.','',26124),
(30763,'enUS','Thank you, $r. I will join your struggle against the stormforged.','',26124),
(30764,'enUS','New directive: leave mine and return to Inventor\'s Library.','',26124),
(30765,'enUS','New directive: assist in the defeat of the iron dwarves.','',26124),
(30766,'enUS','Does not compute. Unit malfunctioning. Directive: shut down.','',26124),
(30767,'enUS','I\'m the king of dirt, there is none higher! To my aid, minions - assist your sire!','',26124),
(30768,'enUS','To burn my kingdom, you can\'t use fire! Come my servants, I am not ready to retire!','',26124),
(30769,'enUS','I bring a gust so strong, it can knock down trees! Minions, assist me, they shall not do as they please!','',26124),
(30770,'enUS','I am the baddest of the bad, the coolest of the cool! To my side, my elements, let us freeze and rule!','',26124),
(30771,'enUS','Return to the Storm Peaks.','',26124),
(30772,'enUS','You challenge me, boy? I don\'t have time for this....','',26124),
(30773,'enUS','Inside!','',26124),
(30774,'enUS','Let\'s finish this quickly.','',26124),
(30775,'enUS','GYAH!','',26124),
(30776,'enUS','We will finish this another time... son of Grom.','',26124),
(30777,'enUS','Saurfang...','',26124),
(30778,'enUS','Your duties as warchief can wait. For now... we fight!','',26124),
(30779,'enUS','Hah! So, son of Durotan, what--','',26124),
(30780,'enUS','Well, Warchief? What say you now? Will you send me to Northrend?','',26124),
(30784,'enUS','Whisker! Where are you?! Assist me!','',26124),
(30785,'enUS','Marshal our forces. Contact our goblin shipwrights. The Horde prepares for war!','',26124),
(30786,'enUS','','Yes, Thrall. The time has come to kill Arthas. You can take my grand apothecary with you. His knowledge will be invaluable against whatever the Scourge will throw at you.',26124),
(30787,'enUS','','Excellent... most excellent.',26124),
(30788,'enUS','It would be an honor, Dark Lady.','',26124),
(30789,'enUS','','These are sacred halls! Your intrusion will be met with death!',26124),
(30791,'enUS','%s begins to spin, encased in a magical shield!','',26124),
(30792,'enUS','This likeness of the Horn of Hodir stands in memorial of King Arngrim and all others lost in the battle of Thunderfall.','',26124),
(30793,'enUS','Curse you!  You will not treat me like a beast!','',26124),
(30794,'enUS','Enough!  I will teach you some manners, wench!','',26124),
(30795,'enUS','I\'d rather die fighting than live like a slave!','',26124),
(30796,'enUS','Back... to work...','',26124),
(30797,'enUS','You treat us worse than animals!','',26124),
(30798,'enUS','We will have revenge... some day.','',26124),
(30799,'enUS','I\'m not looking to cause trouble, but if things don\'t change around here, you\'re going to have an insurrection on your hands.','',26124),
(30800,'enUS','I\'d be careful if I were you, Hyldnir.  We\'re not afraid to lose a few men if it means smashing your pretty blue faces in.','',26124),
(30801,'enUS','This is just a warning, wench.  You strike one of us again and we\'ll kill you in your sleep.','',26124),
(30802,'enUS','Get them!','',26124),
(30803,'enUS','Thank you, thank you!  Time to get away from these crazy blue women!','',26124),
(30804,'enUS','What can I do for you?','',26124),
(30805,'enUS','','This puny green pup was of no use at the mines.  No matter, he\'ll make for suitable warmup for battle.',26124),
(30806,'enUS','Skip the warmup, sister... or are you too scared to face someone your own size?','Skip the warmup, sister... or are you too scared to face someone your own size?',26124),
(30807,'enUS','','I\'m not afraid of anything -- bring it on!',26124),
(30808,'enUS','','May the best win!',26124),
(30809,'enUS','','Good luck...  You\'ll need it!',26124),
(30810,'enUS','','You will not defeat me!',26124),
(30811,'enUS','','You\'re not worthy of Thorim!',26124),
(30812,'enUS','Oh no!  $n is looking hurt!','Oh no!  $n is looking hurt!',26124),
(30813,'enUS','Come on $n!  I\'ve got good money riding on you!','Come on $n!  I\'ve got good money riding on you!',26124),
(30814,'enUS','Come on $n!  You can do it!','Come on $n!  You can do it!',26124),
(30815,'enUS','Don\'t show \'em any mercy $n!','Don\'t show \'em any mercy $n!',26124),
(30816,'enUS','$n!','$n!',26124),
(30817,'enUS','Do it, $n!','Do it, $n!',26124),
(30818,'enUS','Rip \'em apart, $n!','Rip \'em apart, $n!',26124),
(30819,'enUS','Pull it together, $n!','Pull it together, $n!',26124),
(30820,'enUS','Come on, $n!  Don\'t let me down!','Come on, $n!  Don\'t let me down!',26124),
(30821,'enUS','','You fight well, little one. I am bested for now. We will meet again I assure you. When we do I will be better prepared!',26124),
(30822,'enUS','','Grrrrrrrr! I\'ll kneecap ya!',26124),
(30823,'enUS','','Are you here to prove yourself to the Lich King as well?$B$BIt\'s kind of archaic, don\'t you think? Having to fight and survive?',26124),
(30824,'enUS','','Hey, I recognize you! I guess I have you to thanks for me being here. That teleport accident was the best thing that ever happened to me.$B$BIf you find yourself back in Borean Tundra, let my goody two-shoes nerd of a duplicate know that I\'ve moved up in the world quite a bit!',26124),
(30825,'enUS','Sorry, Tinky, but I can\'t afford you as a distraction while I\'m doing what needs to be done here.','Sorry, Tinky, but I can\'t afford you as a distraction while I\'m doing what needs to be done here.',26124),
(30826,'enUS','','YOU\'RE NO FUN!',26124),
(30827,'enUS','','Who\'s the bigshot now, huh?!',26124),
(30828,'enUS','','WHEE!!!',26124),
(30829,'enUS','Snacks for sale!','Snacks for sale!',26124),
(30830,'enUS','Snacks!','Snacks!',26124),
(30831,'enUS','Get your snacks here!','Get your snacks here!',26124),
(30832,'enUS','Snacks!  Get your snacks here!','Snacks!  Get your snacks here!',26124),
(30833,'enUS','Popcorn!  Get your popcorn!','Popcorn!  Get your popcorn!',26124),
(30834,'enUS','Peanuts!  Get your peanuts here!','Peanuts!  Get your peanuts here!',26124),
(30835,'enUS','Anguish Ale!  Cold Anguish Ale here!','Anguish Ale!  Cold Anguish Ale here!',26124),
(30836,'enUS','Popcorn!  Peanuts!  Ale!','Popcorn!  Peanuts!  Ale!',26124),
(30837,'enUS','Fjorn\'s Anvil now stands prominently in Dun Niffelem as a symbol of their victory over Fjorn and his armies.$b$bYou can\'t help but smile, knowing that your actions have had such a lasting impact on the world.','',26124),
(30838,'enUS','It\'s an honor to share the battlefiend with you, my liege.','',26124),
(30839,'enUS','All hail King Stormheart!','',26124),
(30840,'enUS','Haven\'t seen a battle like this since the Frost Giants!','',26124),
(30841,'enUS','We\'ll keep\'m busy, sir!','',26124),
(30842,'enUS','They\'ll learn to fear the Stormriders this day!','',26124),
(30843,'enUS','The training you gave us is paying off, sire!','',26124),
(30844,'enUS','It\'s good to be in the thick of it again.','',26124),
(30845,'enUS','You\'re the strongest of us - show\'m how it\'s done, my king!','',26124),
(30846,'enUS','','I no longer train Death Knights, having grown weary of cretinous Initiates and their constant questions.$B$BNow begone.',26124),
(30847,'enUS','Metallic specimen of foreign origin detected.','',26124),
(30848,'enUS','Beginning analysis ...','',26124),
(30849,'enUS','Specimen identified as an alloy of saronite and iron.','',26124),
(30850,'enUS','The ore used in this sample originated deep within the crust of Azeroth and was recently unearthed.','',26124),
(30851,'enUS','The saronite in this sample is nearly pure. Ores like this do not occur naturally on the surface of Azeroth.','',26124),
(30852,'enUS','Onu\'zun is defeated by the ugliest person ever!','',26124),
(30853,'enUS','Onu\'zun go now. You\'ll miss me.','',26124),
(30854,'enUS','This ore can only have been created by a powerful, malevolent force. Attempting to access databanks for more information ...','',26124),
(30855,'enUS','Onu\'zun is number one! You are number two!','',26124),
(30856,'enUS','Onu\'zun gonna kill you dead!','',26124),
(30857,'enUS','Onu\'zun here to challenge the vrykul and work himself up in the ranks.$B$BThen when Onu\'zun fight in Valhalas and win, Onu\'zun gonna be workin\' for the Lich King!','',26124),
(30858,'enUS','I have bad news for you Onu\'zun: I\'m gonna have to cut short your dreams!','I have bad news for you Onu\'zun: I\'m gonna have to cut short your dreams!',26124),
(30859,'enUS','Access denied?!','',26124),
(30860,'enUS','Further information can only be accessed from the archives within Ulduar, by order of Keeper Loken.','',26124),
(30861,'enUS','Directive completed. Returning to standby mode.','',26124),
(30862,'enUS','','Who among you is devoted?',26124),
(30863,'enUS','I give myself to the master!','I give myself to the master!',26124),
(30864,'enUS','How may I help you?','How may I help you?',26124),
(30865,'enUS','Greetings, $n. This is the workshop of Keeper Mimir.','',26124),
(30866,'enUS','I found this strange armor plate. Can you tell me more about it?','I found this strange armor plate. Can you tell me more about it?',26124),
(30867,'enUS','But one thing is for certain: this plate\'s size, thickness, and bolt holes point to a use as armor for a colossal structure.','',26124),
(30868,'enUS','No more ale for you $n.','No more ale for you $n.',26124),
(30869,'enUS','You\'ve been cut off, $n.  No more ale for you.','You\'ve been cut off, $n.  No more ale for you.',26124),
(30870,'enUS','I think you\'ve had enough ale, $n.','I think you\'ve had enough ale, $n.',26124),
(30871,'enUS','Sorry, $n, you\'ve had enough ale for now.','Sorry, $n, you\'ve had enough ale for now.',26124),
(30872,'enUS','Sorry, $n, we can\'t serve you anymore ale.','Sorry, $n, we can\'t serve you anymore ale.',26124),
(30873,'enUS','I\'ve lost my Scepter of Celebras.','I\'ve lost my Scepter of Celebras.',26124),
(30874,'enUS','You have my thanks. I\'m going back to The Shadow Vault now.','You have my thanks. I\'m going back to The Shadow Vault now.',26124),
(30875,'enUS','I\'ve tarried too long here. I must get back to The Shadow Vault. Farewell.','I\'ve tarried too long here. I must get back to The Shadow Vault. Farewell.',26124),
(30876,'enUS','I will see you back at The Shadow Vault.','I will see you back at The Shadow Vault.',26124),
(30877,'enUS','That\'s enough for me. I\'m heading back now.','That\'s enough for me. I\'m heading back now.',26124),
(30878,'enUS','I\'d love to stay and kill vrykul with you all day, but I\'m sure the baron will be wondering where I am.','I\'d love to stay and kill vrykul with you all day, but I\'m sure the baron will be wondering where I am.',26124),
(30879,'enUS','I have to go. You stay and kill more of these ugly mongrels.','I have to go. You stay and kill more of these ugly mongrels.',26124),
(30880,'enUS','Time to go. Don\'t let them capture you or they\'ll put you in the stew!','Time to go. Don\'t let them capture you or they\'ll put you in the stew!',26124),
(30881,'enUS','I\'m heading back now. I\'ll let the baron know that you liberated me.','I\'m heading back now. I\'ll let the baron know that you liberated me.',26124),
(30882,'enUS','Hey you! There are keys on the vrykul. Kill them, get a key and come over here to let me out of this damned cage!','Hey you! There are keys on the vrykul. Kill them, get a key and come over here to let me out of this damned cage!',26124),
(30883,'enUS','It gets the key. It comes here. It opens the lock.','It gets the key. It comes here. It opens the lock.',26124),
(30884,'enUS','Think you could bust me out of this cage?','Think you could bust me out of this cage?',26124),
(30885,'enUS','Good thing I don\'t really feel the cold.','Good thing I don\'t really feel the cold.',26124),
(30886,'enUS','I\'m over here in this cage. You can\'t miss it!','I\'m over here in this cage. You can\'t miss it!',26124),
(30887,'enUS','Let me out and we\'ll fight side-by-side. The slaughter will be glorious!','Let me out and we\'ll fight side-by-side. The slaughter will be glorious!',26124),
(30888,'enUS','Were you sent by Baron Sliver to get me out of this cage? Finally. Hurry up!','Were you sent by Baron Sliver to get me out of this cage? Finally. Hurry up!',26124),
(30889,'enUS','When you get me out of this cage, we\'re going to make them wish they were never awakened!','When you get me out of this cage, we\'re going to make them wish they were never awakened!',26124),
(30890,'enUS','Dun worry about me $G lad:lass;. I\'ve thought for a long time that age would claim me... I\'m glad I was wrong. Dun let these iron dwarves find what they\'re looking for.','',26124),
(30891,'enUS','At last, the tyranny of the stormforged is at its end!','',26124),
(30892,'enUS','Stormforged dwarves pour out of the broken corpse!','',26124),
(30893,'enUS','No more will your minions assail the creatures of stone and their allies.','',26124),
(30894,'enUS','I am your doom, Valduran!','',26124),
(30895,'enUS','How predictable! But then, who would expect a rock to think like anything other than one?','',26124),
(30896,'enUS','If you\'re so eager to fight, I\'ll oblige you. But know that nothing you do here can prevent the completion of the iron colossus!','',26124),
(30897,'enUS','I had it all, once. Fame, fortune, a full set of the very best gladiator\'s gear... and then I threw it all away.$B$BOnce the Cartel caught me rigging fights... trading wins... it was all over.$B$BNow I\'ve got nothing but these rags and a bad liver.','',26124),
(30898,'enUS','Let\'s do this.','Let\'s do this.',26124),
(30899,'enUS','Thanks. How can I help?','Thanks. How can I help?',26124),
(30900,'enUS','I can fight by your side for a few minutes before I need to return to The Shadow Vault.','I can fight by your side for a few minutes before I need to return to The Shadow Vault.',26124),
(30901,'enUS','Thank you, $c. I owe you.','Thank you, $c. I owe you.',26124),
(30902,'enUS','Excellent. Let\'s kill some vrykul!','Excellent. Let\'s kill some vrykul!',26124),
(30903,'enUS','It\'s time for revenge!','It\'s time for revenge!',26124),
(30904,'enUS','Where\'s my damned helmet? Well, at least they left my sword here. Idiots.','Where\'s my damned helmet? Well, at least they left my sword here. Idiots.',26124),
(30905,'enUS','Kill!','Kill!',26124),
(30906,'enUS','Sons of Hodir! I humbly present to you....','Sons of Hodir! I humbly present to you....',26124),
(30907,'enUS','The Helm of Hodir!','The Helm of Hodir!',26124),
(30908,'enUS','Who are you?$B$BGo away... I\'m exhausted from working so hard on the Harbor Road. It\'s time to drink some dwarven ale, have a good cry, and take a nap.','',26124),
(30909,'enUS','The worg sprints off in search of enemies.','',26124),
(30910,'enUS','Without hesitation, the ethereal worg sets off into the valley.','',26124),
(30911,'enUS','The worg hesitates for a moment, then changes direction.','',26124),
(30912,'enUS','After a moment\'s pause, the worg resumes the hunt.','',26124),
(30913,'enUS','Clearly on to something, the worg bares its fangs and follows the scent.','',26124),
(30914,'enUS','The worg growls as it closes in on its prey.','',26124),
(30915,'enUS','The frostworg howls, exposing its prey!','',26124),
(30916,'enUS','Found me, did ya? Now ya gotta die!','',26124),
(30917,'enUS','Die, friend of the frost!','',26124),
(30918,'enUS','You won\'t live to speak of this!','',26124),
(30919,'enUS','','Once, I had a home in the lush woods of Quel\'Thalas. Once, I had a family, a husband... children. Once, I was alive and one with the world. The Lich King took all of that away from me in the blink of an eye.$B$BThough I have not the power to strike at him directly, I will pay him back threefold!',26124),
(30920,'enUS','The Horde needs you! Beat back the Lich King\'s forces!','',26124),
(30921,'enUS','It was only a matter of time before we would have to deal with the Lich King. He represents a threat to all of Azeroth, not just the humans.$B$BBut, the decision to go to war is one that must not be made lightly. We would be fools to rush into Northrend. The Lich King has surely anticipated such an action.$B$BOur options must be weighed carefully. Our armies are mightier than ever, but a tactically unsound decision could ruin us.$B$BIf only Garrosh understood....','',26124),
(30922,'enUS','Since the founding of Orgrimmar, many trials have tested the Horde, but we have risen up and beaten back any who\'d seek to destroy us!$B$BBut this... this is something that even my power cannot defeat. It pains me deeply to watch my people suffer from this plague. I must rely on the Forsaken for their assistance.$B$BThe Lich King will hear the approaching war drums of the Horde, but not yet. First, we must help our people before exacting our revenge on the Scourge.','',26124),
(30923,'enUS','A true warrior does not stop in a battle to talk with his allies! Send these monstrosities back to their graves!','',26124),
(30924,'enUS','My arms grow restless, anxiously waiting to drive my axes into the skull of the Lich King. Thrall would have us wait and let the Scourge continue to grow in strength. I will not have this!$B$BIf we are to end the threat of the Lich King, we must sail to Northrend and give him the full might of the Horde! Our forces are ready and willing to exact revenge for the deaths wrought by the plague and invasion.$B$BThe time to strike is now!','',26124),
(30925,'enUS','I never believed Thrall until I saw it with my own eyes. Orcs... free of demonic corruption! Proud and honorable warriors making their place on this unbroken planet.$B$BEager am I to prove myself to Thrall and the Horde. My father never had to deal with this undead menace you call the Lich King, but by all descriptions he represents a dire threat to the Horde.$B$BI will implore Thrall to let me lead his finest warriors into Northrend and destroy the Lich King! But this plague takes precedent.','',26124),
(30926,'enUS','You there! Why are you not fighting? Kill these Scourge horrors before they do more damage to Orgrimmar!','',26124),
(30927,'enUS','I understand Garrosh\'s desires. The urge for battle is strong within every orc, especially against a foe that has killed our people. But, the warchief has proven time and again that strategy is as important as strength in a battle.$B$BWe will set out when the time is right. We are no longer a band of mindless, demon-manipulated savages. This is the new Horde.','',26124),
(30928,'enUS','We face an enemy we cannot kill through traditional means. The Lich King\'s plague is a force that no healer within our ranks has been able to deter. The Forsaken and their alchemists are the only hope we have, much to my disgust.$B$BIf we live through this, I promise you that the Horde will go to Northrend and bring the Lich King and his armies to their knees!','',26124),
(30929,'enUS','','I\'d choose your next words carefully if you value your life.$B$BSilence? How wise. Now destroy the Scourge!',26124),
(30930,'enUS','','I can feel Thrall\'s anger at Arthas, but it pales before my own. Were he as furious as any one of the Forsaken, the Horde\'s armies would unleash their rage upon Northrend and eradicate all Scourge from that cursed, frozen wasteland.$B$BBut I do not lead the Horde, and cannot give the command for war. Thrall wishes to weigh his options, despite this being a time of action. Still, our time will come... very soon.',26124),
(30931,'enUS','','Everything I am, I owe to Arthas. I savor the moment when I can repay him for this torment.$B$BI have longed for the time when the Forsaken could take the fight against the Scourge to Northrend, but we need the rest of the Horde\'s support. Our numbers are not great unless bolstered by the other races in our alliance.$B$BArthas\'s latest attack on the Horde will hopefully convince Thrall to declare war on Icecrown. He\'ll have my support when that happens.',26124),
(30932,'enUS','Do you know who I am?! I\'m a very important person! You\'re supposed to be protecting me from the Scourge, not dilly-dallying with pointless conversation!$B$BI\'m no fighter, but you are. So get out there!','',26124),
(30933,'enUS','<Putress looks you over in a very unsettling fashion.>$B$BAren\'t you a remarkable specimen....$B$BHave you considered making a sacrifice for the greater good?','',26124),
(30934,'enUS','What a landmark discovery! The Royal Apothecary Society has spent years working to break the secrets of the Lich King\'s plague, and I\'ve finally done it!$B$BDespite this turning point in history, there is still so much to discover. I have more experiments to conduct... test subjects to acquire...$B$BAt least I don\'t have to worry about Scourge necropoli. The Alliance is dealing with that problem. This leaves me plenty of time to delve into the secrets of the plague and uncover what I can.','',26124),
(30935,'enUS','It is an honor to work alongside Grand Apothecary Putress. His work has saved the world from the Lich King\'s plague and has given new hope to our cause.','It is an honor to work alongside Grand Apothecary Putress. His work has saved the world from the Lich King\'s plague and has given new hope to our cause.',26124),
(30936,'enUS','Where there are frostborn, there are eagles. They\'ve been our allies for longer than I\'ve walked the land... and I\'m not exactly young anymore, $G laddy:lass;.','',26124),
(30937,'enUS','King Stormheart sent me to be tested as a frostborn would.  I am ready for my test, Fjorlin.','King Stormheart sent me to be tested as a frostborn would.  I am ready for my test, Fjorlin.',26124),
(30938,'enUS','The Sunken Ring siege workshop has been captured by the Alliance!','',26124),
(30939,'enUS','The Broken Temple siege workshop has been captured by the Alliance!','',26124),
(30940,'enUS','The Sunken Ring siege workshop has been captured by the Horde!','',26124),
(30941,'enUS','The Broken Temple siege workshop has been captured by the Horde!','',26124),
(30942,'enUS','King Stormheart is putting you to the test, eh?  He must see something in you to begin with or I doubt he\'d put you through such a sacred ritual.','',26124),
(30943,'enUS','I know you\'re new to our kind, so I\'ll catch you up a bit while we\'re on our way over.','',26124),
(30944,'enUS','Years back, my father and several other frostborn were returning from a trek across Dragonblight. There was a heavy blizzard... far worse than we\'ve ever seen since.','',26124),
(30945,'enUS','They crossed a trail of blood-soaked snow and followed it to find a dwarf wandering and speaking in a dialect they couldn\'t make out... and not a dwarf of our kind mind you, but a mountain dwarf - something our kind had never seen before.','',26124),
(30946,'enUS','The dwarf seemed lost, having no memory of where he came from, or even of his own name. Not being the kind to leave a dwarven cousin to die in the snow, my father\'s party took him in and continued back towards Frosthold.','',26124),
(30947,'enUS','Not long later, out of nowhere, the snow burst before them and a jormungar the size of Veranus herself came down upon their party... one of them was swallowed whole before they even had time to react.','',26124),
(30948,'enUS','My father thought they were all doomed... but behind him, a furious roar rumbled across the snow, and he turned to see the mountain dwarf growing in size, his skin taking on a stone-like texture, and his hands sizzling with lightning.','',26124),
(30949,'enUS','The dwarf barreled forward with a sound like rolling thunder and hurled a shining metal hammer, lightning coursing over its surface, directly into the jormungar\'s throat.','',26124),
(30950,'enUS','The jormungar collapsed instantly, its head barely still attached to its convulsing body.  My father turned to the dwarf in awe and raised a fist in praise...','',26124),
(30951,'enUS','What can I do for you?','',26124),
(30952,'enUS','The stranger having no name of his own, my father deemed \"Yorg,\" a name reserved for champions of legend. Years later, he now stands before us as Yorg Stormheart, King of the Frostborn.','',26124),
(30953,'enUS','King Stormheart has trained us well... turned us into even more fearsome warriors than we could have boasted during the time of our war with the Frost Giants.','',26124),
(30954,'enUS','How you be doin\' mon?','',26124),
(30955,'enUS','And as one of the fiercest tests put upon a warrior of the frostborn, we are made to face a creature far larger than ourselves--giants, dragons, jormungar--as a testament to the fact that size will never be our weakness.','',26124),
(30956,'enUS','This is the test put before you this day. Return to us only once The Iron Watcher is dead, and be revered as a warrior of the frostborn.','',26124),
(30957,'enUS','Retrain me in Gem Perfection','Retrain me in Gem Perfection',26124),
(30958,'enUS','How may I serve you?','',26124),
(30959,'enUS','What do you want?','',26124),
(30960,'enUS','The Battle for Lake Wintergrasp is about to begin!','',26124),
(30961,'enUS','Let the battle begin!','',26124),
(30962,'enUS','WotLK - Stormwind Harbor Captain','WotLK - Stormwind Harbor Captain',26124),
(30963,'enUS','WotLK - Request Defender','WotLK - Request Defender',26124),
(30964,'enUS','Creaking echoes off of the nearby structures as the Iron Watcher comes to life.','',26124),
(30965,'enUS','As the hammer lands, more rust shakes free from the Iron Watcher\'s frame and its pace quickens.','',26124),
(30966,'enUS','The Iron Giant shudders slightly.','',26124),
(30967,'enUS','The Iron Watcher roars with fury, shaking more rust from its ancient frame.','',26124),
(30968,'enUS','The Iron Giant shudders slightly.','',26124),
(30969,'enUS','The Iron Watcher reels, reaching to its now useless eyes, and charges blindly.','',26124),
(30970,'enUS','The Iron Watcher loses its footing under the furious blow.','',26124),
(30972,'enUS','You didn\'t think that I was going to let you walk in here and take the Heart of the Storm, did you?','',26124),
(30973,'enUS','You may have killed Valduran, but that will not stop me from completing the colossus.','',26124),
(30974,'enUS','You are welcome here, as a friend and ally of the earthen.','',26124),
(30975,'enUS','Over here $G laddy:lass;, I have something I could use a hand with.','',26124),
(30976,'enUS','Might grace you, $c. Let the Scourge feel the fury of a million lost souls!','Might grace you, $c. Let the Scourge feel the fury of a million lost souls!',26124),
(30977,'enUS','Glory and strength to you, $c. I bless you with all the strength left in me. May this nightmare soon end!','Glory and strength to you, $c. I bless you with all the strength left in me. May this nightmare soon end!',26124),
(30978,'enUS','Wisdom of the ages upon you, noble $c.','Wisdom of the ages upon you, noble $c.',26124),
(30980,'enUS','Thank you and farewell, friend. I must return to the Argent Vanguard.','Thank you and farewell, friend. I must return to the Argent Vanguard.',26124),
(30981,'enUS','You are permitted to visit our stronghold, little $r.$b$bDo not bring us dishonor!','',26124),
(30982,'enUS','If it please you, King Jokkum, may I know what has become of Krolmir?','If it please you, King Jokkum, may I know what has become of Krolmir?',26124),
(30983,'enUS','I do not trust you enough to speak of such things.$b$bYou must respect the trials our people have endured, the burdens we have borne...$b$bPerhaps, if you were to bring great honor to Dun Niffelem, I would be inclined to share with you the knowledge of our people.','',26124),
(30984,'enUS','Very well, little $c.$b$bWhile there is much left for you to do to mend our relations with Thorim, I am compelled to share with you this one secret.$b$bSpeak to me again when you are ready to be shown that which you seek.','',26124),
(30985,'enUS','I am ready to be shown the fate of Krolmir.','I am ready to be shown the fate of Krolmir.',26124),
(30986,'enUS','This bear\'s flank is frozen solid.... try again.','This bear\'s flank is frozen solid.... try again.',26124),
(30987,'enUS','Hail! I hate to rush you, but there\'s an army of iron dwarves here to stop whatever you and Creteus are trying to do... we need to get out of here.','',26124),
(30988,'enUS','King Stormheart caught wind of the iron dwarves heading this way and brought all the best warriors he could muster on such short notice.','',26124),
(30989,'enUS','Quickly, Creteus is to the west. King Stormheart is holding them off, but they have the advantage of numbers.','',26124),
(30990,'enUS','By the watchers, look at him fight. I\'ve never seen a more vicious warrior... I\'m glad to call him my king.','',26124),
(30991,'enUS','We\'ll hold them off as long as we can. Do whatever you need to do quickly!','',26124),
(30992,'enUS','You there! $C! These men are dying! I need your assistance!','',26124),
(30993,'enUS','Don\'t just stand around $g boy:girl;! The Crusade needs your help!','',26124),
(30994,'enUS','What in the world are you doing? There are people dying all around you!','',26124),
(30995,'enUS','Friend, wipe the drool off of your chin and come lend me a hand!','',26124),
(30996,'enUS','Blessed Light! They are all dying!','',26124),
(30997,'enUS','I have no interest in buying anything that you are here to sell me, friend!','',26124),
(30998,'enUS','Did you think that you would be spared the sight of bloodshed and terror?!','',26124),
(30999,'enUS','My slack-jawed compatriot, the time to act is now! Pull yourself together and lend me a hand!','',26124),
(31000,'enUS','Hold on, little $r.','',26124),
(31001,'enUS','King Jokkum, you have summoned me?','',26124),
(31002,'enUS','The noble deeds of your $r $c servant defy $g his:her; stature, Stormlord. $g His:her; efforts have succeeded in softening the hearts of my people.','',26124),
(31003,'enUS','Jokkum, son of Arngrim, I have always regretted my actions here. In my grief, I brought great harm to those closest to me.','',26124),
(31004,'enUS','The Lich King reacted swiftly to the breach. Faster than I anticipated.','',26124),
(31005,'enUS','You are dealing with a being that holds within it the consciousness of the most cunning, intelligent, and ruthless individuals to ever live.','',26124),
(31006,'enUS','The Lich King is unlike any foe that you have ever faced, Highlord. Though you bested him upon the holy ground of Light\'s Hope Chapel, you tread now upon his domain.\n','',26124),
(31007,'enUS','You cannot win. Not like this...\n','',26124),
(31008,'enUS','What would you have me do, Darion?','',26124),
(31009,'enUS','Nothing. There is nothing that you can do while the Light binds you. It controls you wholly, shackling you to the ground with its virtues.','',26124),
(31010,'enUS','Choose your words wisely, death knight. You stand amidst the company of the devoted.','',26124),
(31011,'enUS','%s shakes his head.','',26124),
(31012,'enUS','Look upon the field, Highlord. The Lich King has halted your advance completely and won the upper hand!','',26124),
(31013,'enUS','The breach you created was sealed with Nerubian webbing almost as quickly as it was opened.','',26124),
(31014,'enUS','Your soldiers are being used as living shields to stave off artillery fire in the Valley of Echoes, allowing the forces of the Lich King to assault your base without impediment.','',26124),
(31015,'enUS','The Lich King knows your boundaries, Highlord. He knows that you will not fire on your own men. Do you not understand? He has no boundaries. No rules to abide. \n','',26124),
(31016,'enUS','We will do this with honor, Darion. We will not sink to the levels of the Scourge to be victorious. To do so would make us no better than the monster that we fight to destroy!','',26124),
(31017,'enUS','Then you have lost, Highlord.\n','',26124),
(31018,'enUS','Thorim! Come, show yourself!','',26124),
(31019,'enUS','','%s is affected by Widow\'s Embrace!',26124),
(31020,'enUS','Long ago, when the North Wind ruled these peaks alone, a powerful taunka chieftain\'s brother coveted these lands for himself.','',26124),
(31021,'enUS','The chieftain\'s brother, Stormhoof, gathered all his strength and set out to conquer the Storm Peaks from its rightful ruler, the North Wind.','',26124),
(31022,'enUS','Stormhoof ambushed the North Wind in the heart of its domain, and nearly succeeded in his plot. But the North Wind survived Stormhoof\'s treachery and executed the taunka as punishment for his invasion.','',26124),
(31023,'enUS','I can\'t thank you enough for all of your help in putting together the keystone. Great things will come of this, I assure you.','',26124),
(31024,'enUS','Iron dwarves... everywhere.... they\'re making their way down from the top. They certainly are persistent.','',26124),
(31025,'enUS','They\'re trying to take down the plane! I can\'t pull up any steeper... you need to keep them off of us!','',26124),
(31026,'enUS','There are more up ahead - keep at it!','',26124),
(31027,'enUS','We\'re almost out... just a little bit farther.','',26124),
(31028,'enUS','Barring stray boulders from those giants, we should be clear... it seems a mess down there though.','',26124),
(31029,'enUS','Their numbers are unbelievable... I\'m glad to hear King Stormheart came to your aid. I only hear good things of him - I think it\'s high time we meet.','',26124),
(31030,'enUS','Poor Creteus. He was a good keeper... I\'m glad he at least got to see his task to completion, I imagine that\'s all that really mattered to him.','',26124),
(31031,'enUS','We\'re coming up on Frosthold. I would be very appreciative if you would introduce me to King Stormheart before you go. I believe we are both very much in his debt.','',26124),
(31032,'enUS','By all the gods... it can\'t be... Muradin?!','',26124),
(31033,'enUS','Come on boy, there\'s no mistak\'n it - it\'s definitely you. Don\'t ya recognize your younger brother?!','',26124),
(31034,'enUS','I can\'t believe this! You were dead! All accounts said so... what happened, Muradin. How did you get here?','',26124),
(31035,'enUS','Indeed! Magni will be so happy to see you too! He\'s gotten nothing but bad news for a long while now, but this changes everything!','',26124),
(31036,'enUS','He\'s here in Northrend brother, looking for you. A seer in Wintergarde brought word that you were not dead, and he left Ironforge immediately to come find you.','',26124),
(31037,'enUS','What\'s that? You talkin\' to me, lad?','',26124),
(31038,'enUS','My brother... yes... I do have brothers...','',26124),
(31039,'enUS','Muradin clutches his head and reels for a moment as the memories rush back to him.','',26124),
(31040,'enUS','...Brann?','',26124),
(31041,'enUS','This isn\'t right at all, $n. In the tale Wind Tamer Barah told me, Stormhoof was a hero, not a villain.','',26124),
(31042,'enUS','I... I dun know, Brann. I\'ve been \'ere a long time... all I \'ave of me life before this place are flashes and nightmares.','',26124),
(31043,'enUS','It\'s good te see you though, brother. More than words can say.','',26124),
(31044,'enUS','The North Wind is the ancient enemy of the taunka, a ruler among the elements, and the very force which bleeds the life from these ancient people.','',26124),
(31045,'enUS','Magni! Forgive me, the memories are comin\' back slowly, brother.','',26124),
(31046,'enUS','They would rather die than bow before the North Wind. Something is amiss here.','',26124),
(31048,'enUS','The frostborn have been very good to me. They\'re strong people.','',26124),
(31049,'enUS','The Lorehammer...','',26124),
(31050,'enUS','It confirms our suspicions. The threads of time have been severed and rewoven in the wrong pattern. But, how?','',26124),
(31051,'enUS','The deeds of your $r servant defy $g his:her; stature, Stormlord. $g His:Her; efforts have succeeded in softening the hearts of my people.','',26124),
(31052,'enUS','Never have such humble words come from mighty Thorim. I shall deliver your words to Dun Niffelem.','',26124),
(31053,'enUS','The events of that dark day are hereby forgiven by my people.  They shall never again be spoken of.','',26124),
(31054,'enUS','To signify our reforged friendship, I have something which belongs to you...','',26124),
(31055,'enUS','I\'d like to build a demolisher.','I\'d like to build a demolisher.',26124),
(31056,'enUS','Hello, $r. How can I help you today?','Hello, $r. How can I help you today?',26124),
(31057,'enUS','As the great explosion filled the region, my father cast a rune at the great hammer that it might not be had by our enemies. It was his final act...','',26124),
(31058,'enUS','I\'d like to build a catapult.','I\'d like to build a catapult.',26124),
(31059,'enUS','We welcome the opportunity to fight by your side, mighty Thorim.','',26124),
(31060,'enUS','I must return to Dun Niffilem. We shall speak again soon, Stormlord.','',26124),
(31061,'enUS','I\'d like to build a siege engine.','I\'d like to build a siege engine.',26124),
(31062,'enUS','I would ask your forgiveness for the suffering I have caused you and your people.','',26124),
(31063,'enUS','Krolmir... I thank you Jokkum. I hadn\'t dared hope it still existed. It shall soon see glorious battle once again!','',26124),
(31064,'enUS','I\'d like to build a fighter jet.','I\'d like to build a fighter jet.',26124),
(31065,'enUS','What\'s on yer mind, lad?','',26124),
(31066,'enUS','Sorry, friend. Only certified officers of the Horde can authorize the purchase of a vehicle.','Sorry, friend. Only certified officers of the Horde can authorize the purchase of a vehicle.',26124),
(31067,'enUS','I\'d like to build a bomber.','I\'d like to build a bomber.\n',26124),
(31068,'enUS','I\'d like to build a shredder.','I\'d like to build a shredder.',26124),
(31069,'enUS','We lost a lot a good people today, laddy. The Lich King is gonna pay for all the lives he\'s ruined!','',26124),
(31070,'enUS','Eversong Woods, Dalfors. I\'m thinking about how beautiful it was before Arthas cut a swathe of death through it...','',26124),
(31071,'enUS','The end, Dalfors. I\'m thinking about how close we are to seeing an end to the Scourge.','',26124),
(31072,'enUS','How did they react so fast, Dalfors? Our plan was perfect. I just don\'t understand.','',26124),
(31073,'enUS','The wounds will heal, child.','',26124),
(31074,'enUS','That he is, Dalfors...','',26124),
(31075,'enUS','I have no doubt of that, Dalfors, but will we be alive to see it happen?','',26124),
(31076,'enUS','All the lives he has taken... Such misery and pain inflicted on the innocent. And for what?','',26124),
(31077,'enUS','Some injuries never heal, noble dwarf. A broken soul cannot be fixed.','',26124),
(31078,'enUS','It is time I put an end to my brother\'s madness.','',26124),
(31079,'enUS','Loken!!','',26124),
(31080,'enUS','Stand up and fight me, you worthless traitor!  ','',26124),
(31081,'enUS','Good to see ya again!$B$BKing Stormheart has informed me that he will be taking his leave for a time... a grim memory brought back to him has left him with a score to settle it seems. He was very insistent that we not join him, so we have respected his wishes as we always do.$B$BI have taken responsibility for our clan in the meantime. You are still welcome with us, of course.','',26124),
(31082,'enUS','You seem eager to join your beloved Sif, brother.','',26124),
(31083,'enUS','Do not dare...','',26124),
(31084,'enUS','Look Lagnus, I consider you a capable man, but my patience is wearing thin. I know that Muradin is here, can you point me to him or not?!','',26124),
(31085,'enUS','Brother! There you are! I can barely believe my eyes... you\'re alive!','',26124),
(31086,'enUS','It\'s so good to see you again, Muradin. And what\'s this I heard about you being a King in your own right now? The Bronzebeards were always destined to greatness.','',26124),
(31087,'enUS','Speaking of which...','',26124),
(31088,'enUS','So it seems! And you haven\'t lost any muscle yourself. Do you remember anything of what happened, Muradin? Fate has turned ill in your absence.','',26124),
(31089,'enUS','Not much, Magni. I\'ve had nightmares of a human... tall... light hair... death black armor. His name rests on the tip of me tongue, but...','',26124),
(31090,'enUS','The doctor entrusted me with the plans to Nergeld, our flesh giant amalgamation made entirely of vargul! It will be the most powerful creation of its kind and a whole legion of them will be created to destroy your pitiful forces!','',26124),
(31091,'enUS','...Arthas.','',26124),
(31092,'enUS','Magni nods.','',26124),
(31093,'enUS','He\'s not the boy of your memories anymore, Muradin. He\'s become something else entirely.','',26124),
(31094,'enUS','Aye, I know. I watched him turn... I watched him give up all that was right and I didn\'t lift a hand... I didn\'t even consider it until it was too late.','',26124),
(31095,'enUS','I will never give you the information you seek!','',26124),
(31096,'enUS','That\'s in the past, Muradin. Regrets won\'t change anything.','',26124),
(31097,'enUS','No... no they won\'t. But I can make this right... I have te. I\'m goin\' after the boy. I\'ll make\'m answer for everything he\'s done.','',26124),
(31098,'enUS','You waste my time. I will tell you nothing!','',26124),
(31099,'enUS','Are you sure Muradin? I just got you back after years of thinking you were dead. I do not want to lose you again.','',26124),
(31100,'enUS','I\'m sure, Magni. I\'ll see this through, don\'t ya worry.','',26124),
(31101,'enUS','So be it then. I have to return to my people, brothers. Come back to me in one piece.','',26124),
(31102,'enUS','Aye, be safe Muradin. I\'d join you, but I\'m on top of the most amazing discovery the world has yet seen. I can\'t abandon it now.','',26124),
(31103,'enUS','Go Brann. Bring me back an epic tale when we meet again. Farewell for now, brothers.','',26124),
(31104,'enUS','I\'ll kill you little one and then I will add your body parts to what we\'re creating!','',26124),
(31105,'enUS','I will not let you destroy our hard work! Nergeld will be the end of you all!','',26124),
(31106,'enUS','When the doctor returns, your pitiful Shadow Vault will be laid to waste.','',26124),
(31107,'enUS','Nergeld is only the first of a new army of vargul-powered flesh giants. You\'ve not known fear until now!','',26124),
(31108,'enUS','I have no time for this!','',26124),
(31109,'enUS','You\'re too late, puny one.','',26124),
(31110,'enUS','Looks like you can still best me in a fair fight, little brother.','',26124),
(31111,'enUS','Unfortunately for you.... this fight is anything but fair!','',26124),
(31112,'enUS','Thanks to your little friend, you\'ve left the Temple of Storms, where you were at your strongest.  Instead we fight closer to my master\'s power.','',26124),
(31113,'enUS','Get me out of here, friend!','Get me out of here, friend!',26124),
(31114,'enUS','Thank you, friend, but we\'re not out of trouble yet!','Thank you, friend, but we\'re not out of trouble yet!',26124),
(31115,'enUS','Let\'s get out of here! Quickly!','Let\'s get out of here! Quickly!',26124),
(31116,'enUS','Speak...','',26124),
(31117,'enUS','Her name!!','',26124),
(31118,'enUS','Over here! I\'m on top of the destroyed plague spreader! Help!','Over here! I\'m on top of the destroyed plague spreader! Help!',26124),
(31119,'enUS','You\'ve come for the doctor\'s plans! You\'ll only find death!','',26124),
(31120,'enUS','As you jump into Nergeld, the rotting flesh of the construct comes to life.','',26124),
(31121,'enUS','They\'re planning a huge attack! We need to warn Highlord Fordring!','They\'re planning a huge attack! We need to warn Highlord Fordring!',26124),
(31122,'enUS','Faster, hero! We must get back to the Argent Vanguard and warn them of the impending attack!','Faster, hero! We must get back to the Argent Vanguard and warn them of the impending attack!',26124),
(31123,'enUS','There are hundreds of them! Maybe thousands! They will attack at any moment! I\'m sure of it!','There are hundreds of them! Maybe thousands! They will attack at any moment! I\'m sure of it!',26124),
(31124,'enUS','Had you not come along I would have died for sure!','Had you not come along I would have died for sure!',26124),
(31125,'enUS','I... I think I saw the Lich King. It was only for a moment, but he was here... And it turned so cold, friend. So, so cold...','I... I think I saw the Lich King. It was only for a moment, but he was here... And it turned so cold, friend. So, so cold...',26124),
(31126,'enUS','ENOUGH!','',26124),
(31127,'enUS','As for your life, mortal.  I will be generous.  After all... why would I destroy my most useful servant?  I waited for you for weeks inside that Hyldnir mine.','',26124),
(31128,'enUS','Minions!  Take my brother and his drake to their new dwellings.  Make sure the beast makes it alive.  I have special plans for the broodmother.','',26124),
(31129,'enUS','...farewell brother.','',26124),
(31130,'enUS','Thank you, hero.','Thank you, hero.',26124),
(31131,'enUS','You may only fly in the Argent Vanguard, Valley of Echoes and Scourgeholme.','',26124),
(31132,'enUS','%s falls to pieces.','',26124),
(31133,'enUS','The shape wasn\'t mine, of course.  And had you not been so reckless, you would\'ve seen past my illusion.  But you came through for me, and for that... I must thank you!','',26124),
(31134,'enUS','WHO DARES?! I AM GOING TO FLAY THE FLESH FROM YOUR BONES EVEN IF I HAVE TO DESTROY NERGELD TO GET TO YOU!','',26124),
(31135,'enUS','HELP! I\'m wrapped up in webbing and unable to move!','HELP! I\'m wrapped up in webbing and unable to move!',26124),
(31136,'enUS','Over here! Down on the ground! Help!','Over here! Down on the ground! Help!',26124),
(31137,'enUS','Please don\'t leave us!','Please don\'t leave us!',26124),
(31138,'enUS','Save us!','Save us!',26124),
(31139,'enUS','Watch out! The Lich King is near!','Watch out! The Lich King is near!',26124),
(31140,'enUS','They\'re going to kill us all!','They\'re going to kill us all!',26124),
(31141,'enUS','We\'re done for!','We\'re done for!',26124),
(31142,'enUS','For the Argent Crusade!','For the Argent Crusade!',26124),
(31143,'enUS','Huh, whassat?','',26124),
(31144,'enUS','Just had a little snow in my eye, there...','',26124),
(31145,'enUS','You say something?','',26124),
(31146,'enUS','Oh yes, now... where were we?','',26124),
(31147,'enUS','Ahh, at last... Time for a little break.','',26124),
(31148,'enUS','Oh, hello, little $r.','',26124),
(31149,'enUS','You are no taunka. Why have you come to the sacred burial grounds of our warriors?','',26124),
(31150,'enUS','I am sorry to disturb your rest, chieftain, but your brother\'s spirit may be in danger. Would you tell me what you remember of him?','I am sorry to disturb your rest, chieftain, but your brother\'s spirit may be in danger. Would you tell me what you remember of him?',26124),
(31151,'enUS','My brother, Stormhoof, was a far greater warrior than I. While I trained to be the chieftain of our clan, he prepared for a larger quest.','',26124),
(31152,'enUS','How could he be in danger? All he wanted was to give us power over the elements that made life harsh for us here.','',26124),
(31153,'enUS','He sought an artifact... a horn, I think. He left the village on a long journey in search of it.','',26124),
(31154,'enUS','I know that a terrible enemy pursued him after he won the horn, but I... I don\'t recall... what happened... next.','',26124),
(31155,'enUS','It is as though my memories are shrouded in mist. I cannot even recall what became of my brother. Is this how you mean that he is in danger?','',26124),
(31156,'enUS','The disturbances in the tomb, they must be involved. Look around you, $n. Do you see them?','',26124),
(31157,'enUS','Yes, they are at fault, but I am powerless to stop them. Will you warn the people of Tunka\'lo, stranger, that their past and their ancestors are in danger?','',26124),
(31158,'enUS','%s lets out a bellowing roar as she descends upon the nest.','',26124),
(31159,'enUS','Look out below!','',26124),
(31160,'enUS','Easy there, girl!  Don\'t you recognize your old master?','',26124),
(31161,'enUS','I will see you at the Temple of Storms.  Looks like I\'m going to have to break her in again.','',26124),
(31162,'enUS','The engine\'s blown!  Fly Zak\'s Flying Machine back to K3!','',26124),
(31163,'enUS','','Look at them... all they care about is outdoing each other.',26124),
(31164,'enUS','Tell me about this proposal.','Tell me about this proposal.',26124),
(31165,'enUS','','You see, Thorim is not like these harpies.  He\'s a worthy being of near godlike stature.$B$BHe served the titans as guardian of Ulduar and the Terrace of the Makers.$B$BThat is until his wife, Sif, was cowardly slain by his brother.',26124),
(31166,'enUS','What happened then?','What happened then?',26124),
(31167,'enUS','','Thorim lost it.  He lashed out against his most beloved allies, the frost giants.$B$BThat\'s one reason why to this day, this land is torn apart by the war between the Hyldnir and the Sons of Hodir... and why Thorim has exiled himself to the Temple of Storms.',26124),
(31168,'enUS','You want me to take part in the Hyldsmeet to end the war?','You want me to take part in the Hyldsmeet to end the war?',26124),
(31169,'enUS','','What do I care if these she-wolves and the frost giants kill each other every day?$B$BNo, no... I want Thorim to break out of his stupor and rally all his allies to retake Ulduar.$B$BThe world will be torn asunder if he fails to accomplish this!$B$BAnd of course, I\'ll reward you appropriately.',26124),
(31170,'enUS','Very well.  I\'ll take part in this competition.','Very well.  I\'ll take part in this competition.',26124),
(31171,'enUS','The Lorehammer is reacting. This must be from Stormhoof\'s time.','The Lorehammer is reacting. This must be from Stormhoof\'s time.',26124),
(31172,'enUS','The Lorehammer is silent. This isn\'t from Stormhoof\'s time.','The Lorehammer is silent. This isn\'t from Stormhoof\'s time.',26124),
(31173,'enUS','I\'LL RISE AGAIN AND WHEN I DO I WILL HAVE MY REVENGE!','',26124),
(31174,'enUS','Leave me to my shame, $r.','',26124),
(31175,'enUS','','Men -- can\'t live with them, can\'t live without them.  Well, you can... but it\'s just really boring.',26124),
(31176,'enUS','','These mines are a dreadful place.  Fortunately, I don\'t plan on being here long.',26124),
(31177,'enUS','','Bears are beautiful creatures.  Wild, strong and fierce in battle... much like us, sister.',26124),
(31178,'enUS','Sorry, friend. I\'m afraid we\'ve used all of the parts we can spare at the moment.','Sorry, friend. I\'m afraid we\'ve used all of the parts we can spare at the moment.',26124),
(31179,'enUS','I have been chosen!','I have been chosen!',26124),
(31180,'enUS','Fool! You will never defeat me!','',26124),
(31181,'enUS','I will never allow you to use the Horn of Elemental Fury against us! Die, weakling!','',26124),
(31182,'enUS','My lord, Instructor Hroegar conveys that your warriors are ready. They spar on the ledge outside awaiting your orders','',26124),
(31183,'enUS','The horn! Use the horn on it while it\'s weak!','',26124),
(31184,'enUS','Thane Ufrang the Mighty, I bear ill news. The Shadow Vault over the mountain to the east has fallen.','',26124),
(31185,'enUS','Lord Ufrang, there are strangers on the ledge petitioning your warriors to honor duels. They are not vrykul.','',26124),
(31186,'enUS','My lord, this draenei was caught along with an entire contingent of death knights from The Shadow Vault. They are Knights of the Ebon Blade!','',26124),
(31187,'enUS','Milord, there have been reports of the other thanes preparing their forces for a strike against us. We should move quickly.','',26124),
(31188,'enUS','My thane, I bear untimely news. Your champion, Bethod, has fallen in the ring at Valhalas. As a vargul, he has been exiled to The Underhalls.','',26124),
(31189,'enUS','Tell Hroegar that he will be at the van of my forces when I give the word for them to strike.','',26124),
(31190,'enUS','','Someone called for me...?',26124),
(31191,'enUS','Then you must send a messenger to the Lich King. Ready my forces to attack upon his word.','',26124),
(31192,'enUS','Let them fight. If they fall to one of the lesser races then it was fated and they are worthless.','',26124),
(31193,'enUS','Leave him chained there. I will deal with him in good time. As for the others... see to it that they do not escape!','',26124),
(31194,'enUS','Call in all of our favors then. See to it that whatever they\'re up to, we know of it before it occurs. Then we shall see who strikes first!','',26124),
(31195,'enUS','No! That horn is MINE!','',26124),
(31196,'enUS','Bethod was a great warrior, but apparently not great enough. Find me a new champion. We cannot afford this dishonor now!','',26124),
(31197,'enUS','This will be your last incursion against the Scourge!','',26124),
(31198,'enUS','RISE!','',26124),
(31199,'enUS','As %s falls, the altar set into the floor on his balcony begins to glow faintly.','',26124),
(31200,'enUS','Ravage the living, minions!','',26124),
(31201,'enUS','Hello, hello!','',26124),
(31202,'enUS','','Hello, peach - good to have your company!',26124),
(31203,'enUS','','Hello, peach - good to have your company!',26124),
(31204,'enUS','Pleased to meet you, $c.','',26124),
(31205,'enUS','The mountains are rich with history... don\'t forget to stop and take it all in, $c.','',26124),
(31206,'enUS','You receive 7500 honor and 150 arena points.','',26124),
(31207,'enUS','<The Frostborn Scout appears to have breathed his last breath.>','',26124),
(31208,'enUS','We discovered these proto-drakes at the Bronze Dragonshrine in the Dragonblight. We knew at once that they were kin - our blood from ages past.$B$BMy apologies, $c. You are probably confused. I am Penumbrius of the bronze dragonflight. I have taken this form out of convenience. It is much easier to communicate and live amongst mortals while in the mortal guise.$B$BHow can I help you?\n','',26124),
(31209,'enUS','Bethod\'s Sword?!! Very well, $r, I accept your challenge. But first, you must best my champions. Volgur! Squash this insect!','',26124),
(31210,'enUS','The thane spits as the first of his champions falls.','',26124),
(31211,'enUS','Brita, create a pincushion of this puny $c!','',26124),
(31212,'enUS','You may have defeated my champions, $c. I am something else entirely.','',26124),
(31213,'enUS','Pray to your gods for a quick death.','',26124),
(31214,'enUS','Hello, $n! How can I help you today?','Hello, $n! How can I help you today?',26124),
(31215,'enUS','','Thane Illskar, you were challenged to honorable combat and failed.',26124),
(31216,'enUS','','You have been found wanting and are judged accordingly. Now rise, Thane Illskar the Damned!',26124),
(31217,'enUS','Speak, $c.','',26124),
(31218,'enUS','I\'ve hidden from my destiny long enough.  What I must do has never been clearer.$B$BLoken must be destroyed by my hand.','',26124),
(31219,'enUS','Can you tell me what became of Sif?','Can you tell me what became of Sif?',26124),
(31220,'enUS','For a moment I thought you were my beloved Sif... that strand of hair... but no!  It can\'t be... Sif is dead....$B$BMy... my brother.... killed her!','',26124),
(31221,'enUS','He did more than that, Thorim.  He controls Ulduar now.','He did more than that, Thorim.  He controls Ulduar now.',26124),
(31222,'enUS','Ulduar... I was sworn to protect Ulduar.$B$BSworn to protect the Terrace of the Makers.$B$BSworn to protect the pacts between the races of frost.$B$BBut I failed!  I let my brother trick me.  I let him turn me against my allies.  He tricked me into blaming Sif\'s death on a dear friend, Arngrim, the king of the frost giants.$B$BAfter I realized what I\'d done... I... gave in to despair.','',26124),
(31223,'enUS','It needn\'t end this way.','It needn\'t end this way.',26124),
(31224,'enUS','Who are you, little one?  To come speak these words to the mighty Thorim...$B$BI should... crush you!$B$BYet, you\'ve delivered me from my stupor.  Your presence here is a sign!$B$BIt was no accident that I mistook you for Sif.  What would she think of me?  I must prepare for battle.$B$BI must avenge her death and liberate the titans\' sacred grounds from my brother\'s madness!','',26124),
(31225,'enUS','I\'m with you, Thorim.','I\'m with you, Thorim.',26124),
(31226,'enUS','As the last remnants of the %s seep into the ground, the altar set into the floor nearby begins to glow faintly.','',26124),
(31227,'enUS','NOOOOOOOOOOOOOOOOOO!','',26124),
(31228,'enUS','Welcome to the Storm Peaks, $r.','',26124),
(31229,'enUS','I lost Brann\'s Communicator and need a replacement.','I lost Brann\'s Communicator and need a replacement.',26124),
(31230,'enUS','...zzz... ..snrk... c\'mere... gonna... gonna be Malowned... zzz..','',26124),
(31231,'enUS','...mrf... kids messin\'.. with th\' boxes... zzzz... teach \'em... lesson...','',26124),
(31232,'enUS','The north-western keep tower has been damaged!','',26124),
(31233,'enUS','The south-western keep tower has been damaged!','',26124),
(31234,'enUS','The south-eastern keep tower has been damaged!','',26124),
(31235,'enUS','The north-eastern keep tower has been damaged!','',26124),
(31236,'enUS','The north-eastern keep tower has been destroyed!','',26124),
(31237,'enUS','The south-eastern keep tower has been destroyed!','',26124),
(31238,'enUS','The south-western keep tower has been destroyed!','',26124),
(31239,'enUS','The north-western keep tower has been destroyed!','',26124),
(31240,'enUS','The western bridge has been damaged!','',26124),
(31241,'enUS','The southern bridge has been damaged!','',26124),
(31242,'enUS','The eastern bridge has been damaged!','',26124),
(31243,'enUS','The eastern bridge has been destroyed!','',26124),
(31244,'enUS','The southern bridge has been destroyed!','',26124),
(31245,'enUS','The western bridge has been destroyed!','',26124),
(31246,'enUS','The eastern tower has been damaged!','',26124),
(31247,'enUS','The southern tower has been damaged!','',26124),
(31248,'enUS','The western tower has been damaged!','',26124),
(31249,'enUS','The western tower has been destroyed!','',26124),
(31250,'enUS','The southern tower has been destroyed!','',26124),
(31251,'enUS','The eastern tower has been destroyed!','',26124),
(31252,'enUS','Where is Elder Arp?','Where is Elder Arp?',26124),
(31253,'enUS','Elder Arp spends time at the D.E.H.T.A camp in Borean Tundra.','Elder Arp spends time at the D.E.H.T.A camp in Borean Tundra.',26124),
(31254,'enUS','Elder Pamuya is just outside Warsong Hold.','Elder Pamuya is just outside Warsong Hold.',26124),
(31255,'enUS','Where is Elder Pamuya?','Where is Elder Pamuya?',26124),
(31259,'enUS','There\'s no doubt that something has distorted the true history of Stormhoof and the warriors of Camp Tunka\'lo. But, what?','',26124),
(31260,'enUS','Do not trouble yourself, little tauren. Neither Stormhoof, nor you and your ally will stand in my way.','',26124),
(31261,'enUS','Even now, my power grows. I have long waited for the day when my revenge would be complete.','',26124),
(31262,'enUS','Stormhoof and his kin will be erased from history and these lands will be restored to their rightful owner!','',26124),
(31263,'enUS','No! The true voice of history will triumph. We will restore all you have destroyed!','',26124),
(31264,'enUS','$n, we must hurry and discover when the North Wind has started distorting the timeline. Only then can we defeat him and correct it.','',26124),
(31266,'enUS','Where is Elder Igasho?','Where is Elder Igasho?',26124),
(31267,'enUS','Elder Igasho was last seen exploring within The Nexus.','Elder Igasho was last seen exploring within The Nexus.',26124),
(31268,'enUS','Where is Elder Northal?','Where is Elder Northal?',26124),
(31269,'enUS','You\'ll find Elder Northal inside the Transitus Shield in Coldarra.','You\'ll find Elder Northal inside the Transitus Shield in Coldarra.',26124),
(31270,'enUS','Where is Elder Sardis?','Where is Elder Sardis?',26124),
(31271,'enUS','Last I heard, Elder Sardis was venturing to Valiance Keep.','Last I heard, Elder Sardis was venturing to Valiance Keep.',26124),
(31272,'enUS','Where is Elder Bluewolf?','Where is Elder Bluewolf?',26124),
(31273,'enUS','Elder Bluewolf is trapped within the battle for Wintergrasp.','Elder Bluewolf is trapped within the battle for Wintergrasp.',26124),
(31274,'enUS','Where is Elder Wanikaya?','Where is Elder Wanikaya?',26124),
(31275,'enUS','Elder Wanikaya can be found at Rainspeaker Rapids in Sholazar Basin.','Elder Wanikaya can be found at Rainspeaker Rapids in Sholazar Basin.',26124),
(31276,'enUS','Where is Elder Sandrene?','Where is Elder Sandrene?',26124),
(31277,'enUS','Elder Sandrene has traveled to Lakeside Landing in Sholazar Basin.','Elder Sandrene has traveled to Lakeside Landing in Sholazar Basin.',26124),
(31278,'enUS','Where is Elder Morthie?','Where is Elder Morthie?',26124),
(31279,'enUS','Go to Stars\' Rest in Dragonblight and you will find Elder Morthie.','Go to Stars\' Rest in Dragonblight and you will find Elder Morthie.',26124),
(31280,'enUS','Where is Elder Thoim?','Where is Elder Thoim?',26124),
(31281,'enUS','Elder Thoim has spent many years at Moa\'ki Harbor in Dragonblight.','Elder Thoim has spent many years at Moa\'ki Harbor in Dragonblight.',26124),
(31282,'enUS','Where is Elder Skywarden?','Where is Elder Skywarden?',26124),
(31283,'enUS','Elder Skywarden can be found near Agmar\'s Hammer in Dragonblight.','Elder Skywarden can be found near Agmar\'s Hammer in Dragonblight.',26124),
(31284,'enUS','Where is Elder Nurgen?','Where is Elder Nurgen?',26124),
(31285,'enUS','Last I knew, Elder Nurgen was in Azjol-Nerub.','Last I knew, Elder Nurgen was in Azjol-Nerub.',26124),
(31286,'enUS','Where is Elder Whurain?','Where is Elder Whurain?',26124),
(31287,'enUS','You\'ll find Elder Whurain at Camp Oneqwah in Grizzly Hills.','You\'ll find Elder Whurain at Camp Oneqwah in Grizzly Hills.',26124),
(31288,'enUS','Where is Elder Chogan\'gada?','Where is Elder Chogan\'gada?',26124),
(31289,'enUS','Elder Chogan\'gada can be found in Utgarde Pinnacle.','Elder Chogan\'gada can be found in Utgarde Pinnacle.',26124),
(31290,'enUS','Where is Elder Lunaro?','Where is Elder Lunaro?',26124),
(31291,'enUS','Elder Lunaro is at the Ruins of Tethys in Grizzly Hills.','Elder Lunaro is at the Ruins of Tethys in Grizzly Hills.',26124),
(31292,'enUS','Where is Elder Beldak?','Where is Elder Beldak?',26124),
(31293,'enUS','Elder Beldak can be found at the Westfall Brigade Encampment in Grizzly Hills.','Elder Beldak can be found at the Westfall Brigade Encampment in Grizzly Hills.',26124),
(31294,'enUS','Where is Elder Jarten?','Where is Elder Jarten?',26124),
(31295,'enUS','Utgarde Keep is where you\'ll find Elder Jarten.','Utgarde Keep is where you\'ll find Elder Jarten.',26124),
(31296,'enUS','Where is Elder Kilias?','Where is Elder Kilias?',26124),
(31297,'enUS','Elder Kilias can be found inside Drak\'Tharon Keep.','Elder Kilias can be found inside Drak\'Tharon Keep.',26124),
(31298,'enUS','Where is Elder Tauros?','Where is Elder Tauros?',26124),
(31299,'enUS','Elder Tauros found his way to Zim\'Torga in Zul\'Drak.','Elder Tauros found his way to Zim\'Torga in Zul\'Drak.',26124),
(31300,'enUS','Where is Elder Ohanzee?','Where is Elder Ohanzee?',26124),
(31301,'enUS','Elder Ohanzee is located in Gundrak.','Elder Ohanzee is located in Gundrak.',26124),
(31302,'enUS','Where is Elder Graymane?','Where is Elder Graymane?',26124),
(31303,'enUS','Elder Graymane was last seen visiting K3 in the Storm Peaks.','Elder Graymane was last seen visiting K3 in the Storm Peaks.',26124),
(31304,'enUS','Where is Elder Muraco?','Where is Elder Muraco?',26124),
(31305,'enUS','Elder Muraco is just outside Camp Tunka\'lo in Storm Peaks.','Elder Muraco is just outside Camp Tunka\'lo in Storm Peaks.',26124),
(31306,'enUS','Where is Elder Fargal?','Where is Elder Fargal?',26124),
(31307,'enUS','Elder Fargal looks over Frosthold in Storm Peaks.','Elder Fargal looks over Frosthold in Storm Peaks.',26124),
(31308,'enUS','Where is Elder Stonebeard?','Where is Elder Stonebeard?',26124),
(31309,'enUS','Elder Stonebeard resides at Bouldercrag\'s Refuge in the Storm Peaks.','Elder Stonebeard resides at Bouldercrag\'s Refuge in the Storm Peaks.',26124),
(31310,'enUS','Where is Elder Yurauk?','Where is Elder Yurauk?',26124),
(31311,'enUS','Elder Yurauk can be found in the Halls of Stone.','Elder Yurauk can be found in the Halls of Stone.',26124),
(31312,'enUS','Mrfrrmrfrmrrr!$B$B<The geist clears his throat.>$B$BYes?','',26124),
(31313,'enUS','You are not yet strong enough to do battle in the Strand of the Ancients. Return when you have gained more experience.','You are not yet strong enough to do battle in the Strand of the Ancients. Return when you have gained more experience.',26124),
(31315,'enUS','We cannot allow the Horde to turn the hidden secrets of the Strand of the Ancients against us. Will you join our brave soldiers there?','We cannot allow the Horde to turn the hidden secrets of the Strand of the Ancients against us. Will you join our brave soldiers there?',26124),
(31316,'enUS','We cannot allow the Alliance to turn the hidden secrets of the Strand of the Ancients against us. Will you join our brave warriors there?','We cannot allow the Alliance to turn the hidden secrets of the Strand of the Ancients against us. Will you join our brave warriors there?',26124),
(31317,'enUS','You are leaving the greater Jotunheim region. Return or lose the proto-drake.','',26124),
(31318,'enUS','Shadron! Come to me! All is at risk!','',26124),
(31319,'enUS','Tenebron! The eggs are yours to protect as well!','',26124),
(31320,'enUS','Vesperon, the clutch is in danger! Assist me!','',26124),
(31321,'enUS','%s fixes his eyes on you!','%s fixes his eyes on you!',26124),
(31322,'enUS','Hey! Stop rooting around in my cellar! Clear out!','',26124),
(31323,'enUS','What were you doing in my cellar? There\'s a food scare going on, and the last thing I need is strangers rummaging around in my goods! Shoo!','',26124),
(31324,'enUS','This whole situation seems a bit paranoid, don\'t you think?','',26124),
(31325,'enUS','Orders are orders. If the Prince says jump...','',26124),
(31326,'enUS','It\'s a strange order, you can\'t deny. Suspicious food? Under that definition, you should arrest Belfast!','',26124),
(31327,'enUS','I HEARD THAT! No more ale for you! Not a drop!','',26124),
(31328,'enUS','Free to--mm--fly now. Ra-aak... Not find us--ekh-ekh! Escape!','',26124),
(31329,'enUS','Welcome back to the waking world, child.','',26124),
(31330,'enUS','I... am fury... unrestrained!','',26124),
(31331,'enUS','Do not lose faith.','',26124),
(31333,'enUS','The End of the Scourge draws near.','',26124),
(31334,'enUS','The time of the Argent Crusade is now!','',26124),
(31335,'enUS','We shall triumph!','',26124),
(31336,'enUS','Put your faith in the Light and all is possible!','',26124),
(31337,'enUS','Back in business! Now, to execute an exit strategy.','',26124),
(31338,'enUS','Have at you, fiends! You shall not escape the wrath of the Ashbringer!','',26124),
(31339,'enUS','I am... renewed.','',26124),
(31340,'enUS','Barber','Barber',26124),
(31341,'enUS','Such is the price... of failure....','',26124),
(31342,'enUS','','The Fleshwerks is the heart of the Scourge\'s ghoul, abomination, and flesh giant production. If we can take it out, the Lich King will be greatly weakened.',26124),
(31343,'enUS','He is slow from the rust of the ages... be quick on your feet and he will not best you. You have King Stormheart\'s favor - do not disappoint.','',26124),
(31344,'enUS','This will be a fine test, Prince Arthas.','',26124),
(31345,'enUS','Time out.','',26124),
(31346,'enUS','You seem tired.','',26124),
(31347,'enUS','All too easy.','',26124),
(31348,'enUS','The Dark Lord is displeased with your interference.','',26124),
(31349,'enUS','It is Prince Arthas I want, not you!','',26124),
(31350,'enUS','Fixin\' the tower and the wall! Keep the baddies off us!','',26124),
(31351,'enUS','Agh! Damn you, Mal\'Ganis! Father... Jaina... I have failed Lordaeron....','',26124),
(31352,'enUS','Protect your prince, soldiers of Lordaeron! I am in need of aid!','',26124),
(31353,'enUS','I am being overwhelmed! Assist me!','',26124),
(31354,'enUS','Mal\'Ganis will pay for this.','',26124),
(31355,'enUS','I can\'t afford to spare you.','',26124),
(31356,'enUS','One less obstacle to deal with.','',26124),
(31357,'enUS','I\'M COOKIN HERE!','',26124),
(31358,'enUS','Another hungry recruit?','',26124),
(31359,'enUS','What do you need?','',26124),
(31360,'enUS','What brings you to me?','',26124),
(31361,'enUS','Remind me how to make Northern Stew.','Remind me how to make Northern Stew.',26124),
(31362,'enUS','The lava surrounding %s churns!','',26124),
(31363,'enUS','Such flammable little insects....','',26124),
(31364,'enUS','Return to Jotunheim immediately. You can feel the Bone Witch\'s spell of possession failing!','',26124),
(31365,'enUS','','We serve Thorim, sister.',26124),
(31366,'enUS','I\'m ready to ride.','I\'m ready to ride.',26124),
(31367,'enUS','Reckoning Bomb READY! Purge the evil from this land!','',26124),
(31368,'enUS','This pathetic siege ends NOW!','',26124),
(31369,'enUS','','It is always a pleasure to meet heroes such as yourself in this forsaken land. Is there some form of assistance that I can offer you?',26124),
(31370,'enUS','Greetings, mage.  Shall I provide you with further insight into the world of magic?','Greetings, mage.  Shall I provide you with further insight into the world of magic?',26124),
(31371,'enUS','Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.','Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.',26124),
(31372,'enUS','It\'s a pleasure to meet you as well, Archdruid. I am on a task from Tirion and time is short. Might I trouble you for a portal to Moonglade?','It\'s a pleasure to meet you as well, Archdruid. I am on a task from Tirion and time is short. Might I trouble you for a portal to Moonglade?',26124),
(31373,'enUS','','Of course! Go with Elune\'s blessing.',26124),
(31374,'enUS','Fire a volley!','Fire a volley!',26124),
(31375,'enUS','Fire the even cannons!','Fire the even cannons!',26124),
(31376,'enUS','Fire the odd cannons!','Fire the odd cannons!',26124),
(31377,'enUS','Fire all the cannons!','Fire all the cannons!',26124),
(31378,'enUS','Fire a barrage!','Fire a barrage!',26124),
(31379,'enUS','Fire at will!','Fire at will!\n',26124),
(31380,'enUS','','Hail. I could not help but overhear your conversation. Please allow me to lend some assistance.',26124),
(31381,'enUS','','I\'m heading back to the Argent Vanguard through Dalaran if you\'d like to return with me, hero.',26124),
(31382,'enUS','Dis be a dark day in troll history, mon.','',26124),
(31383,'enUS','Dis be horrible, mon. I cannot bear to be watchin\'.','',26124),
(31384,'enUS','We couldn\'t have done it without you, $g sir:ma\'am;.','We couldn\'t have done it without you, $g sir:ma\'am;.',26124),
(31385,'enUS','There goes the hero of the Vanguard!','There goes the hero of the Vanguard!',26124),
(31386,'enUS','You honor us with your presence, $n.','You honor us with your presence, $n.',26124),
(31387,'enUS','With your steadfast determination, we cannot fail!','With your steadfast determination, we cannot fail!',26124),
(31388,'enUS','Thank you, $n. From the bottom of my heart. Thank you.','Thank you, $n. From the bottom of my heart. Thank you.',26124),
(31389,'enUS','Call on me anytime, $n.','Call on me anytime, $n.',26124),
(31390,'enUS','We will battle along side you until the bitter end, $g sir:ma\'am;!','We will battle along side you until the bitter end, $g sir:ma\'am;!',26124),
(31391,'enUS','Hero, I am honored.','Hero, I am honored.',26124),
(31392,'enUS','','It be my duty to record these tragic events for the good of generations to come.',26124),
(31393,'enUS','We mustn\'t lose our focus. The dangers inherent in getting lost in the moment could put us in peril. Alas, the soldiers need a respite from this madness.$B$BBask in the victory, $n. If not for you we might have lost the Vanguard.','',26124),
(31394,'enUS','If you are lost, my friend, perhaps I can be of assistance. What is it you need?','If you are lost, my friend, perhaps I can be of assistance. What is it you need?',26124),
(31395,'enUS','This city can be strange. Is there something I can do for you?','This city can be strange. Is there something I can do for you?',26124),
(31396,'enUS','Warning: This vehicle is not permitted to operate outside of Wintergrasp. Return immediately.','',26124),
(31397,'enUS','Brood Guardians reporting in!','',26124),
(31398,'enUS','Sanctum Guardians reporting in!','',26124),
(31399,'enUS','','Reinforcements, finally! The prison guards can\'t hold out against this invasion for much longer! You\'ll have to relieve my men and try to hold out for as long as you can. There\'s still some power in the defense system available. Use the activation crystals located around the prison to trigger a discharge if the situation worsens.',26124),
(31400,'enUS','It is my charge to watch over these eggs. I will see you burn before any harm comes to them!','',26124),
(31401,'enUS','Activate the crystals when we get in trouble, right.','Activate the crystals when we get in trouble, right.',26124),
(31402,'enUS','','%s begins to open a Twilight Portal!',26124),
(31403,'enUS','The Alliance has defended Wintergrasp Fortress!','',26124),
(31404,'enUS','Dying must have completely destroyed your ability to perform simple arithmetic. Can\'t you see that there is no way you\'re going to make that structure\'s layout work? It\'ll collapse!\n','',26124),
(31405,'enUS','The Horde has defended Wintergrasp Fortress!','',26124),
(31406,'enUS','How dare you! I am the chief architect here and I make the final call on layouts! If you have a problem with my plans, feel free to file a grievance with Highlord Fordring. Now if you don\'t mind, I have work to attend!\n','',26124),
(31407,'enUS','I am the greatest of my father\'s sons! Your end has come!','',26124),
(31408,'enUS','Give me your worst!','',26124),
(31409,'enUS','Defend yourself, for all the good it will do!','',26124),
(31410,'enUS','GRAAAAAH! Behold the fury of iron and steel!','',26124),
(31411,'enUS','So ends your curse.','',26124),
(31412,'enUS','Flesh... is... weak!','',26124),
(31413,'enUS','Bolvin umyol marnjar.','',26124),
(31414,'enUS','How can it be...? Flesh is not... stronger!','',26124),
(31415,'enUS','It is you who have destroyed my children? You... shall... pay!','',26124),
(31416,'enUS','Life from lifelessness... death for you.','',26124),
(31417,'enUS','Nothing is wasted in the process. You will see....','',26124),
(31418,'enUS','I will crush you beneath my boots!','',26124),
(31419,'enUS','All my work... undone!','',26124),
(31420,'enUS','The armies of iron will conquer all!','',26124),
(31421,'enUS','Feh! Pathetic!','',26124),
(31422,'enUS','You have cost me too much work!','',26124),
(31423,'enUS','The master was right... to be concerned.','',26124),
(31424,'enUS','','Is your entire party of adventurers ready to continue? I\'ll fire off a discharge from this activation crystal to cover the retreat of my guards.',26124),
(31425,'enUS','','Ok, if your party is ready then I\'m ready to fall back and let you continue the defense here. I\'ll overload the defenses to clear the prison long enough to let us leave and shut the door. After that, it\'s up to you to protect this door at all costs!',26124),
(31426,'enUS','Get your people to safety, we\'ll keep the Blue Dragonflight\'s forces at bay.','Get your people to safety, we\'ll keep the Blue Dragonflight\'s forces at bay.',26124),
(31427,'enUS','We fought back da Scourge. What chance joo thinkin\' JOO got?','',26124),
(31428,'enUS','Get ready for somethin\'... much... BIGGAH!','',26124),
(31429,'enUS','Da ground gonna swallow you up!','',26124),
(31430,'enUS','I crush joo cockroaches!','',26124),
(31431,'enUS','Who gonna stop me? You?','',26124),
(31432,'enUS','Not so tough now!!','',26124),
(31433,'enUS','If our gods can die... den so can we....','',26124),
(31434,'enUS','Fear not, young one, for this crusader shall not taste death.','',26124),
(31435,'enUS','In life, Bridenbrad was the bearer of great deeds. Now, in passing, he shall taste only paradise.','',26124),
(31436,'enUS','The light does not abandon its champions.','',26124),
(31437,'enUS','What I do for the Argent Crusade now should only be viewed as fulfillment of an obligation. A payment, if you will. The Highlord freed me from the grasp of the Lich King and laid before us all the path to salvation. With that said, it must be understood that our methods differ - greatly. I and the Knights of the Ebon Blade will help the Argent Crusade lay their foundations within Icecrown and then we will part ways. The payment made in full.$B$BA different destiny awaits us.','',26124),
(31438,'enUS','There is no question that these crusaders are the source of great discomfort, $g brother:sister;. But what is sacrifice without pain? You were with me at Light\'s Hope Chapel. You saw many great sacrifices made. We are here now to settle a debt to the Highlord. Payment in full for his sacrifice.$B$BOnce the Argent Crusade has established their foothold inside the walls of Icecrown, we will depart. A different destiny awaits us.','',26124),
(31439,'enUS','The Halls of Lightning, a level 80 dungeon within Storm Peaks, is now available for testing. Please be in your full group before teleporting to the dungeon. Meeting Stones are not available for this dungeon yet.\n\nTo leave the Halls of Lightning, simply exit through the normal exit inside the dungeon and you will be returned here. If you die and release, you should teleport back from this NPC.','',26124),
(31440,'enUS','I\'m in my group and ready to teleport to the Halls of Lightning!','I\'m in my group and ready to teleport to the Halls of Lightning!',26124),
(31441,'enUS','Take me back to the Halls of Lightning!','Take me back to the Halls of Lightning!',26124),
(31442,'enUS','Test','',26124),
(31443,'enUS','Entry 1','Entry 1',26124),
(31444,'enUS','First, an introduction.  I am Archmage Vargoth, leader of the first Kirin Tor expedition to Draenor.  We have accompanied Alliance forces through the Dark Portal, and now set up base camp - Kirin\'Var Village - in Farahlon, near the ancestral home of the Laughing Skull clan of orcs.  Such a lovely place!','First, an introduction.  I am Archmage Vargoth, leader of the first Kirin Tor expedition to Draenor.  We have accompanied Alliance forces through the Dark Portal, and now set up base camp - Kirin\'Var Village - in Farahlon, near the ancestral home of the Laughing Skull clan of orcs.  Such a lovely place!',26124),
(31445,'enUS','<The dusty journal is missing various entries>','<The dusty journal is missing various entries>',26124),
(31446,'enUS','My lady.','',26124),
(31447,'enUS','What this place? I will destroy you!','',26124),
(31448,'enUS','Entry 42','Entry 42',26124),
(31449,'enUS','Ley-line excavations continue, with pleasant results.  We were surprised to find several similarities in the ley-line structures between Azeroth and Draenor, possibly indicating a similar genesis?\nMy close associate Naberius reports that the Laughing Skulls have established a truce with the Alliance forces in the area. Always distrustful of orcs, I thought to myself, \"This could be heaven or this could be hell.\"','Ley-line excavations continue, with pleasant results.  We were surprised to find several similarities in the ley-line structures between Azeroth and Draenor, possibly indicating a similar genesis?\nMy close associate Naberius reports that the Laughing Skulls have established a truce with the Alliance forces in the area. Always distrustful of orcs, I thought to myself, \"This could be heaven or this could be hell.\"',26124),
(31450,'enUS','Entry 205','Entry 205',26124),
(31451,'enUS','Most of the Alliance forces have left for Azeroth.  Hopefully the carefully-compiled reports that we sent with General Turalyon will make it back to Dalaran safely.\nNer\'zhul\'s reckless portals have torn Farahlon apart, its green hills now quickly crumbling as the Twisting Nether corrupts the earth.  I have to find a passage back to the place I was before!','Most of the Alliance forces have left for Azeroth.  Hopefully the carefully-compiled reports that we sent with General Turalyon will make it back to Dalaran safely.\nNer\'zhul\'s reckless portals have torn Farahlon apart, its green hills now quickly crumbling as the Twisting Nether corrupts the earth.  I have to find a passage back to the place I was before!',26124),
(31452,'enUS','You die! That what master wants.','',26124),
(31453,'enUS','An easy task!','',26124),
(31454,'enUS','What mongrels dare intrude here? Look alive, my brothers!  A feast for the one that brings me their heads!','',26124),
(31455,'enUS','You challenge death itself! Come then, \"King.\" Face the might of Mograine!','',26124),
(31456,'enUS','I will see you back at the Valley of Echoes. Suffer well, ally.','',26124),
(31457,'enUS','I ask for vrykul to kill them, yet all I get are feeble whelps! By Ymiron, SLAUGHTER THEM!','',26124),
(31458,'enUS','If one more harpoon touches my drake I\'ll flay your miserable hides!','',26124),
(31459,'enUS','You motherless knaves! Your corpses will make fine morsels for my new drake!','',26124),
(31460,'enUS','Mjor na uul kval!','',26124),
(31461,'enUS','Not so brash now, are you?','',26124),
(31462,'enUS','I\'ll mount your skull from the highest tower!\n','',26124),
(31463,'enUS','ARGH! You call that... an attack? I\'ll...  show... aghhhh...','',26124),
(31464,'enUS','You invade my home and then dare to challenge me?  I will tear the hearts from your chests and offer them as gifts to the death god! Rualg nja gaborr!','',26124),
(31465,'enUS','Bjorn of the Black Storm! Honor me now with your presence!','',26124),
(31466,'enUS','Haldor of the Rocky Cliffs! Grant me your strength!','',26124),
(31467,'enUS','Ranulf of the Screaming Abyss!  Snuff these maggots with darkest night!','',26124),
(31468,'enUS','Tor of the Brutal Siege, bestow your might upon me!','',26124),
(31469,'enUS','Your death is only the beginning.','',26124),
(31470,'enUS','You have failed your people!\n','',26124),
(31471,'enUS','There is a reason I am king!\n','',26124),
(31472,'enUS','Breathe no more!','',26124),
(31473,'enUS','What... awaits me... now?','',26124),
(31474,'enUS','','Prison guards, we are leaving! These adventurers are taking over! Go go go!',26124),
(31475,'enUS','','I\'m locking the door. Good luck, and thank you for doing this.',26124),
(31476,'enUS','There is word from Jotunheim. The sleep-watchers there believe that they have found someone of significance.','',26124),
(31477,'enUS','The cultist practically sputters.','',26124),
(31478,'enUS','Look like, my lady? A vrykul, I suppose. They did not actually show him to me. Ever since The Shadow Vault....','',26124),
(31479,'enUS','A name? Oh, yes, the name! I believe it was Iskalder.','',26124),
(31480,'enUS','Right away, my lady.','',26124),
(31481,'enUS','','Report.',26124),
(31482,'enUS','','Describe this vrykul. What does he look like?',26124),
(31483,'enUS','','I am not interested in excuses. Perhaps they gave you a name?',26124),
(31484,'enUS','','Iskalder?! You fool! Have you no idea who that is? He\'s only the greatest vrykul warrior who ever lived!',26124),
(31485,'enUS','','Return to Jotunheim and tell them to keep him asleep until I arrive. I will judge this vrykul with my own eyes.',26124),
(31486,'enUS','Say hello to my little friend!','',26124),
(31487,'enUS','Arise, Melt!','',26124),
(31488,'enUS','We\'re done here. I\'m out.','',26124),
(31489,'enUS','','Too weak to finish your own battles? Very well then...',26124),
(31490,'enUS','','Anything else you need help with before I go? Right, I thought not...',26124),
(31491,'enUS','Ancient magic swirls within the depths of the eye. It gives you a feeling of vertigo, as if you might accidentally tumble into its iris and fall forever.','',26124),
(31492,'enUS','Grasp the Eye of the Lich King and focus your will upon it to scry for important information.','Grasp the Eye of the Lich King and focus your will upon it to scry for important information.',26124),
(31493,'enUS','Scrying upon many insignificant situations within Icecrown, you stumble upon something interesting...','Scrying upon many insignificant situations within Icecrown, you stumble upon something interesting...',26124),
(31497,'enUS','Anomalies form as %s shifts into the Astral Plane!','',26124),
(31498,'enUS','Temple of Invention analysis commencing.','',26124),
(31499,'enUS','Temple of Invention verified to be intact.','',26124),
(31500,'enUS','Mechanical servants appear to have turned against each other. Several attendants have been piled together in an unorganized manner.','',26124),
(31501,'enUS','Remaining mechagnome guardians corrupted by unknown source.','',26124),
(31502,'enUS','Watcher Mimir verified to no longer be present. Analysis complete.','',26124),
(31503,'enUS','The vrykul rests peacefully in his magical slumbering.','',26124),
(31504,'enUS','Temple of Winter analysis commencing.','',26124),
(31505,'enUS','Waken the slumbering mjordin to see if it is really the ancient hero, Iskalder.','Waken the slumbering mjordin to see if it is really the ancient hero, Iskalder.',26124),
(31506,'enUS','Temple of Winter verified to be in tact.','',26124),
(31507,'enUS','Temple guardians verified to be deceased. Sulfurous odor suggests that death resulted from a fire-based entity.','',26124),
(31508,'enUS','Previously established cold weather patterns at the temple have ceased.','',26124),
(31509,'enUS','Watcher Hodir verified to no longer be present. Analysis complete.','',26124),
(31510,'enUS','Watcher Freya verified to no longer be present. Analysis complete.','',26124),
(31512,'enUS','Temple of Life verified to be damaged beyond repair.','',26124),
(31513,'enUS','Evidence indicates a significant battle. The opponent of Watcher Freya estimated to be of similar size and strength to Watcher Freya.','',26124),
(31514,'enUS','Temple guardians are no longer present. Plant forms associated with temple are deceased.','',26124),
(31515,'enUS','Temple of Life analysis commencing.','',26124),
(31516,'enUS','Temple of Order analysis commencing.','',26124),
(31517,'enUS','Temple of Order verified to be in tact.','',26124),
(31518,'enUS','No indications of struggle are present. No guardians are present.','',26124),
(31519,'enUS','Watcher Tyr verified to no longer be present. Analysis complete.','',26124),
(31520,'enUS','<hic>$b$bIt be lonely in here without me mateys, $g lad:lass;.','',26124),
(31521,'enUS','Yarr! Someone be needin\' ta show these bloaks what fer!$b$b<hic>','',26124),
(31522,'enUS','It be time ta kick some arse an\' drink double-rum!$b$bAn\' I almost be outta double-rum....','',26124),
(31523,'enUS','It\'s Iskalder! Quickly, use The Bone Witch\'s Amulet!','It\'s Iskalder! Quickly, use The Bone Witch\'s Amulet!',26124),
(31524,'enUS','The portal has stabilized! Attack!','The portal has stabilized! Attack!',26124),
(31525,'enUS','Why do you defend the Kirin Tor...','Why do you defend the Kirin Tor...',26124),
(31526,'enUS','You shall not disrupt this portal!','You shall not disrupt this portal!',26124),
(31527,'enUS','Such a meaningless death!','Such a meaningless death!',26124),
(31528,'enUS','','Iskalder, there you are. What is this? Engaged in battle already?',26124),
(31529,'enUS','','Very well. Finish these lesser beings and let us be about our business.',26124),
(31530,'enUS','','NO! How is this possible?',26124),
(31531,'enUS','','I know not how this was possible, but you must still be judged Iskalder. Wait... what is this?',26124),
(31532,'enUS','','This? This is me taking control of you. This is me setting up my final revenge!',26124),
(31533,'enUS','','Stay away from me creature! Do not touch me!',26124),
(31534,'enUS','','Ahahahahahaha! It is done. Return to my cave. We have much to discuss!',26124),
(31535,'enUS','For the Spellweaver!','For the Spellweaver!',26124),
(31536,'enUS','The Nexus War will not be stopped!','The Nexus War will not be stopped!',26124),
(31537,'enUS','Your efforts have been in vain!','Your efforts have been in vain!',26124),
(31538,'enUS','The Blessed Banner of the Crusade is destroyed!\nThe Scourge are victorious!','',26124),
(31539,'enUS','The Blessed Banner of the Crusade has been planted.\nDefend the banner from all attackers!','',26124),
(31540,'enUS','Now fight me, $n! Kill Iskalder!','',26124),
(31541,'enUS','Seek out Catarina Stanford in the canals southwest of The Stockade.','Seek out Catarina Stanford in the canals southwest of The Stockade.',26124),
(31542,'enUS','Inscription','Inscription',26124),
(31544,'enUS','Jelinik\'s Barber Shop is in the northern section of the Trade District.','Jelenik\'s Barber Shop is in the northern section of the Trade District.',26124),
(31545,'enUS','THE MASTER\'S WILL BE DONE!','',26124),
(31546,'enUS','There you are! I think I\'ve just about got this door figured out. Let me know when you\'re ready and I\'ll open\'er up!','',26124),
(31547,'enUS','We\'re with you Brann! Open it!','We\'re with you Brann! Open it!',26124),
(31548,'enUS','Elise Brightletter is near the Great Forge adjacent to the Flight Master.','Elise Brightletter is near the Great Forge adjacent to the Flight Master.',26124),
(31549,'enUS','You can find the barber shop on the west portion of The Commons.','You can find the barber shop on the west portion of The Commons.',26124),
(31550,'enUS','Oh, bravo. Do you feel proud of yourself now that you\'ve unleashed this terrible mistake?','',26124),
(31551,'enUS','I already had him scheduled for disposal, but I suppose we can speed up the process a bit.','',26124),
(31552,'enUS','Feyden Darkin is on the second floor in the center of the Craftsman\'s Terrace.','Feyden Darkin is on the second floor in the center of the Craftsman\'s Terrace.',26124),
(31553,'enUS','It\'s a pity so many fine, and reusable, parts will go to waste... ','',26124),
(31554,'enUS','Patches not going to be cut open or sewn up no more!','',26124),
(31555,'enUS','Don\'t worry! Ol\' Brann\'s got yer back! Keep that metal monstrosity busy, and I\'ll see if I can\'t sweet talk this machine into helping ye!','',26124),
(31556,'enUS','Patches get revenge on Doctor Sabnok!','',26124),
(31557,'enUS','Thoth can teach you Inscription in The Crystal Hall.','Thoth can teach you Inscription in The Crystal Hall.',26124),
(31558,'enUS','Jo\'mah is in a building on the second floor of The Drag.','Jo\'mah is in a building on the second floor of The Drag.',26124),
(31559,'enUS','The barber? She\'s moved shop, out of the Cleft of Shadow and into the cliffs above the Valley of Strength, where the fruit vendor used to be.','The barber? She\'s moved shop, out of the Cleft of Shadow and into the cliffs above the Valley of Strength, where the fruit vendor used to be.',26124),
(31560,'enUS','BY THE LIGHT! Those damned monsters! Look at what they\'ve done to our people!','',26124),
(31561,'enUS','Burn it down, boys. Burn it all down.','',26124),
(31562,'enUS','Let \'em come. They\'ll pay for what they\'ve done!','',26124),
(31563,'enUS','You go find Margaux Parchley. She pretty lady in The Apothecarium.','You go find Margaux Parchley. She pretty lady in The Apothecarium.',26124),
(31564,'enUS','Barber? That is Naznik! He on top floor of Trade Quarter, near bank.','Barber? That is Naznik! He on top floor of Trade Quarter, near bank.',26124),
(31565,'enUS','Seek out Poshken Hardbinder in The Pools of Vision, below the Spirit Rise.','Seek out Poshken Hardbinder in The Pools of Vision, below the Spirit Rise.',26124),
(31566,'enUS','You can find the scribe, Zantasia in the Court of the Sun.','You can find the scribe, Zantasia in the Court of the Sun.',26124),
(31567,'enUS','Leave no survivors!','',26124),
(31568,'enUS','Cower before my terrible creations!','',26124),
(31569,'enUS','Feast my children! Feast upon the flesh of the living!','',26124),
(31570,'enUS','Lay down your arms and surrender your souls!','',26124),
(31571,'enUS','Bow before your king!','',26124),
(31572,'enUS','Eradicate.','',26124),
(31573,'enUS','We\'ve done it, lads! We\'ve taken the pinnacle from the Scourge! Report to Father Gustav at once and tell him the good news! We\'re gonna get to buildin\' and settin\' up! Go!','',26124),
(31574,'enUS','Know... my... pain.','',26124),
(31575,'enUS','Gaze... into the void.','',26124),
(31576,'enUS','More... energy.','',26124),
(31577,'enUS','Relinquish.','',26124),
(31578,'enUS','Fall... to shadow.','',26124),
(31579,'enUS','Disperse.','',26124),
(31580,'enUS','The Lithe Stalker is weakened by the assault.','',26124),
(31581,'enUS','How can I possibly help the city in such a widespread crisis?','',26124),
(31582,'enUS','Everyone is falling ill - this is an epidemic!','',26124),
(31583,'enUS','No remedy seems to work - the entire city has sickened...','',26124),
(31584,'enUS','The soldiers are spreading panic with the rumors of bad food. Neighbors are accusing one another of poison. The city will fall into bedlam!','',26124),
(31585,'enUS','The city is grinding to a halt as more and more workers become bedridden...','',26124),
(31586,'enUS','I\'m at a loss. What can one simple man do in the face of disaster?','',26124),
(31587,'enUS','I pray the illness I\'m feeling is due to stress ulcers...','',26124),
(31588,'enUS','The vrykul dies from being awakened improperly.','',26124),
(31589,'enUS','Interference with the wakening ritual causes the vrykul to die.','',26124),
(31590,'enUS','The incorrect application of the awakening rod causes the dormant vrykul to expire.','',26124),
(31591,'enUS','The dormant vrykul keels over.','',26124),
(31592,'enUS','The taking of Crusaders\' Pinnacle is only the first step in a long and dangerous journey. There is much left to do before we are able to assault Icecrown Citadel.$B$BIt can only be possible with help from you and others like you, hero.','',26124),
(31593,'enUS','Welcome to Dalaran, $c.','',26124),
(31594,'enUS','I\'m ready to fly to Sholazar Basin.','I\'m ready to fly to Sholazar Basin.',26124),
(31595,'enUS','','He\'s on his way!',26124),
(31596,'enUS','I\'ve lost my Loremaster\'s Colors.','I\'ve lost my Loremaster\'s Colors.',26124),
(31597,'enUS','You dare to challenge me? You haven\'t earned the right!','',26124),
(31598,'enUS','','Wrong, Balargarde. You WILL accept this challenge!',26124),
(31599,'enUS','Vardmadra?! Did the Lich King send you personally?','',26124),
(31600,'enUS','Very well. I will dispatch these creatures. It is only an inconvenience. Prepare to die!','',26124),
(31601,'enUS','Safirdrang, let them feel the chill of Icecrown!','',26124),
(31602,'enUS','Return to the Malykriss!','',26124),
(31603,'enUS','I\'ve lost my Tabard of the Explorer.','I\'ve lost my Tabard of the Explorer.',26124),
(31604,'enUS','Return to Brunnhildar Village!','',26124),
(31605,'enUS','Return to Blue Sky Logging Ground!','',26124),
(31606,'enUS','Return to Venture Bay!','',26124),
(31607,'enUS','I\'ve lost my Tabard of Brute Force.','I\'ve lost my Tabard of Brute Force.',26124),
(31608,'enUS','For me?','',26124),
(31609,'enUS','Present?','',26124),
(31610,'enUS','What bomb thing for?','',26124),
(31611,'enUS','Want me to deliver somewhere?','',26124),
(31612,'enUS','I not sure this safe, little geist.','',26124),
(31613,'enUS','This no go here.','',26124),
(31614,'enUS','What little geist want?','',26124),
(31615,'enUS','That not nice!','',26124),
(31616,'enUS','Insufferable skeletons.','',26124),
(31617,'enUS','I am yet a great warrior, do not toy with me, skeleton.','',26124),
(31618,'enUS','I am not slave labor... my patience wears thin.','',26124),
(31619,'enUS','My talents are wasted on this filth.','',26124),
(31621,'enUS','Look at me again skeleton. I will rip your skull from your flimsy frame!','',26124),
(31623,'enUS','Keep your brittle bones out of my way, mindless puppets.','',26124),
(31624,'enUS','The Skybreaker patrols Icecrown.  You will find no finer ship in all of the realms.','',26124),
(31625,'enUS','Take me to the ship.','Take me to the ship.',26124),
(31626,'enUS','Orgrim\'s Hammer is ready to strike in Icecrown.  You will find no finer vessel.','',26124),
(31627,'enUS','STOP! Kneel you fools, it\'s the Lich King!','',26124),
(31628,'enUS','Honor guard stay where you are.','',26124),
(31629,'enUS','Vardmadra. I\'d wondered where you disappeared to. How is Iskalder?','',26124),
(31631,'enUS','','My lord.',26124),
(31632,'enUS','I see through your disguise, Lady Nightswood. YOU THINK THAT YOU CAN FOOL ME?!','',26124),
(31633,'enUS','','But...!',26124),
(31634,'enUS','You may continue your combat, overthane.','',26124),
(31635,'enUS','But, my lord...?','',26124),
(31636,'enUS','But nothing! Finish them! DO NOT FAIL ME, BALARGARDE!','',26124),
(31637,'enUS','DIE DOGS!','',26124),
(31638,'enUS','<Highlord Darion Mograine nods.>','',26124),
(31639,'enUS','I require training, Highlord.','I require training, Highlord.',26124),
(31640,'enUS','Death knight come play?','',26124),
(31641,'enUS','Why you want hurt Patchwerk?','',26124),
(31642,'enUS','Lich King say Patchwerk \"on loan\" from Naxxramas. Loan make Patchwerk ANGRY!','',26124),
(31643,'enUS','Come play with Patchwerk! Patchwerk lonely!','',26124),
(31644,'enUS','Patchwerk miss Naxxramas. Maybe kill you all fast so Patchwerk go home?','',26124),
(31645,'enUS','The only reason that you still live is because of my curiosity.','',26124),
(31646,'enUS','Dalaran must fall!','Dalaran must fall!',26124),
(31647,'enUS','Destroy all who stand against us!','Destroy all who stand against us!',26124),
(31648,'enUS','The Kirin Tor must be stopped!','The Kirin Tor must be stopped!',26124),
(31649,'enUS','Magic must be... contained...','Magic must be... contained...',26124),
(31650,'enUS','You cannot stop us all!','You cannot stop us all!',26124),
(31651,'enUS','Dalaran will burn!','Dalaran will burn!',26124),
(31652,'enUS','I will defend this portal with my life!','I will defend this portal with my life!',26124),
(31653,'enUS','Your pathetic defense ends here!','Your pathetic defense ends here!',26124),
(31654,'enUS','More portals will take this one\'s place!','More portals will take this one\'s place!',26124),
(31655,'enUS','My death will not stop this invasion!','My death will not stop this invasion!',26124),
(31656,'enUS','Your efforts were misguided!','Your efforts were misguided!',26124),
(31657,'enUS','The way into Dalaran has been opened!','The way into Dalaran has been opened!',26124),
(31658,'enUS','The destruction of Dalaran is inevitable!','The destruction of Dalaran is inevitable!',26124),
(31659,'enUS','You receive 2500 honor and 50 arena points.','',26124),
(31660,'enUS','I think it\'s time to see what\'s behind the door near the entrance. I\'m going to sneak over there, nice and quiet. Meet me at the door and I\'ll get us in.','',26124),
(31661,'enUS','The blood red pool within the eye swirls, betraying images of a massing army of Scourge. The eye seems to pull at you, willing its way into your mind and triggering you to pull back instinctively. You feel very uneasy in the presence of this object.','',26124),
(31662,'enUS','Monster!','Monster!',26124),
(31663,'enUS','Murderer!','Murderer!',26124),
(31664,'enUS','You disgust me.','You disgust me.',26124),
(31665,'enUS','Traitorous dog!','Traitorous dog!',26124),
(31666,'enUS','Looks like we\'re going to have ourselves an execution.','Looks like we\'re going to have ourselves an execution.',26124),
(31667,'enUS','My family was wiped out by the Scourge! MONSTER!','My family was wiped out by the Scourge! MONSTER!',26124),
(31668,'enUS','How dare you set foot in our city!','How dare you set foot in our city!',26124),
(31669,'enUS','GET A ROPE!','GET A ROPE!',26124),
(31670,'enUS','%s cowers in fear.','%s cowers in fear.',26124),
(31671,'enUS','%s throws a rotten apple at $n.','%s throws a rotten apple at $n.',26124),
(31672,'enUS','%s throws a rotten banana at $n.','%s throws a rotten banana at $n.',26124),
(31673,'enUS','%s spits on $n.','%s spits on $n.',26124),
(31674,'enUS','','Whatever you\'re going to ask for, do it quickly.',26124),
(31675,'enUS','People of Stormwind! Citizens of the Alliance! Your king speaks!','',26124),
(31676,'enUS','Today marks the first of many defeats for the Scourge! Death knights, once in service of the Lich King, have broken free of his grasp and formed a new alliance against his tyranny!\n','',26124),
(31677,'enUS','You will welcome these former heroes of the Alliance and treat them with the respect that you would give to any ally of Stormwind!\n\n','',26124),
(31678,'enUS','Glory to the Alliance!\n','',26124),
(31679,'enUS','Murderer!','Murderer!',26124),
(31680,'enUS','You disgust me.','You disgust me.',26124),
(31681,'enUS','Traitorous dog!','Traitorous dog!',26124),
(31682,'enUS','Looks like we\'re going to have ourselves an execution.','Looks like we\'re going to have ourselves an execution.',26124),
(31683,'enUS','My family was wiped out by the Scourge! MONSTER!','My family was wiped out by the Scourge! MONSTER!',26124),
(31684,'enUS','How dare you set foot in our city!','How dare you set foot in our city!',26124),
(31685,'enUS','GET A ROPE!','GET A ROPE!',26124),
(31686,'enUS','Monster!','Monster!',26124),
(31687,'enUS','Horde, hear the call of your Warchief!','',26124),
(31688,'enUS','Today marks the first of many defeats for the Scourge! Death knights, once in service of the Lich King, have broken free of his grasp and formed a new alliance against his tyranny!\n','',26124),
(31689,'enUS','You will welcome these former heroes of the Horde and treat them with the respect that you would give to any ally of Orgrimmar!\n','',26124),
(31690,'enUS','For the Horde!\n','',26124),
(31691,'enUS','SCOURGE!!!! Stand back! Gamon will save us all!','',26124),
(31692,'enUS','We\'ve broken through the prison gate! The way into Dalaran is clear! Now we finally put an end to the Nexus War!','',26124),
(31693,'enUS','You have bested one of my finest, but your efforts are for naught.','',26124),
(31694,'enUS','','You did it! You held the Blue Dragonflight back and defeated their commander. Amazing work!',26124),
(31695,'enUS','The frozen heart of Icecrown awaits....','',26124),
(31696,'enUS','','We\'ll take over from here, you\'ve earned quite a respite after that battle.',26124),
(31697,'enUS','','%s smiles and flies off to return to possessing The Bone Witch.',26124),
(31698,'enUS','Warning: You\'ve entered a no-fly zone and are about to be dismounted!','Warning: You\'ve entered a no-fly zone and are about to be dismounted!',26124),
(31699,'enUS','','You there! Step forward!',26124),
(31700,'enUS','','Yogg-Saron! Grant me your power!',26124),
(31701,'enUS','','Master, a gift for you!',26124),
(31702,'enUS','','Glory to Yogg-Saron!',26124),
(31703,'enUS','','You are unworthy.',26124),
(31704,'enUS','','Get up! You haven\'t suffered enough.',26124),
(31705,'enUS','','Do not expect your sacrilege... to go unpunished.',26124),
(31706,'enUS','','The elements themselves will rise up against the civilized world! Only the faithful will be spared!',26124),
(31707,'enUS','','Immortality can be yours, but only if you pledge yourself fully to Yogg-Saron!',26124),
(31708,'enUS','','Here, on the very borders of his domain, you will experience power you could have never imagined!',26124),
(31709,'enUS','','You have traveled long and risked much to be here! Your devotion shall be rewarded.',26124),
(31710,'enUS','','The faithful shall be exalted, but there is more work to be done. We will press on until all of Azeroth lies beneath his shadow!',26124),
(31711,'enUS','Drakkari gonna kill anybody who tressspasss on these landsss!','',26124),
(31712,'enUS','You not breathin\'? Good.','',26124),
(31713,'enUS','Ssscared now?','',26124),
(31714,'enUS','I eat you next, mon.','',26124),
(31715,'enUS','I sssee now... Ssscourge wasss not... our greatessst enemy....','',26124),
(31716,'enUS','Hello. Master Fras Siabi is not in at this time. Please come back tomorrow to Fras Siabi\'s Premium Tobacco! Beep!','Hello. Master Fras Siabi is not in at this time. Please come back tomorrow to Siabi\'s Premium Tobacco! Beep!',26124),
(31717,'enUS','What is it?','',26124),
(31718,'enUS','','A valiant defense, but this city must be razed. I will fulfill Malygos\'s wishes myself!',26124),
(31719,'enUS','<Seize control of an Eidolon Watcher through the eye.>','<Seize control of an Eidolon Watcher through the eye.>',26124),
(31720,'enUS','','I hope you\'re not coming in here fixing for a fight. There are too many angry people on the streets today.',26124),
(31721,'enUS','','Look, I\'ll sell you shields today, but no maces. The last thing I want is for some innocent to get brained by one of my weapons.',26124),
(31722,'enUS','','I don\'t know how much longer I\'ll be open today with all the commotion outside. If you need something repaired, I\'ll take a quick look.',26124),
(31723,'enUS','','We finish this now, champions of Kirin Tor!',26124),
(31724,'enUS','The Stone Crow\'s closed today, sorry. There are too many health concerns, and I\'m not about to have Ed under fire for supposedly making people sick.','',26124),
(31725,'enUS','','I will end the Kirin Tor!',26124),
(31726,'enUS','','Dalaran WILL fall!',26124),
(31727,'enUS','','So ends you defiance of the Spell-Weaver.',26124),
(31728,'enUS','','Perhaps... we have... underestimated... you.',26124),
(31729,'enUS','I hate to disappoint people, but the Stone Crow\'s closed. If the kids from the orphanage were evacuated, I don\'t see why we should be open, either.','',26124),
(31730,'enUS','','What\'s the commotion outside?',26124),
(31731,'enUS','','Is something going on? I hear angry voices.',26124),
(31732,'enUS','','Everything\'s been so strange lately...',26124),
(31733,'enUS','The Argent Dawn coordinates the Scourge\'s opposition at Light\'s Hope Chapel in the Eastern Plaguelands.  Go there for instructions.','The Argent Dawn coordinates the Scourge\'s opposition at Light\'s Hope Chapel in the Eastern Plaguelands.  Go there for instructions.',26124),
(31735,'enUS','I would like to spend my runes.','I would like to spend my runes.',26124),
(31736,'enUS','You are not yet strong enough to do battle in Lake Wintergrasp. Return when you have gained more experience.','You are not yet strong enough to do battle in Lake Wintergrasp. Return when you have gained more experience.',26124),
(31737,'enUS','This portal leads to Lake Wintergrasp.','This portal leads to Lake Wintergrasp.',26124),
(31738,'enUS','Enter the portal.','Enter the portal.',26124),
(31740,'enUS','','Who among you can withstand my power?',26124),
(31741,'enUS','Take me to Lieutenant Icehammer, Zorek!','Take me to Lieutenant Icehammer, Zorek!',26124),
(31742,'enUS','','Many have fallen within Valhalas and their corpses are a testament to the strength of our ways.$B$BWill your bones litter this place of honor and battle as well, $n?',26124),
(31743,'enUS','I should kill you where you stand, $r!$B$BGet on with your inane prattling and then begone!','',26124),
(31744,'enUS','','Valhalas is yours to win or die in, $n. But whatever you do, stay within the bounds of the arena. To flee is to lose and be dishonored.',26124),
(31745,'enUS','','$n and $g his : her; comrades in arms have chosen to accept honorable combat within the sacred confines of Valhalas.',26124),
(31746,'enUS','','There can be only one outcome to such a battle: death for one side or the other. Let $n prove $g himself : herself; upon the bones of those outsiders who have fallen before!',26124),
(31747,'enUS','','The challengers have failed. Not being vrykul this was expected.',26124),
(31748,'enUS','','The dishonor of failure in combat is eternal.',26124),
(31749,'enUS','','Are there any others who would dare to challenge the might of Valhalas?',26124),
(31750,'enUS','','Valhalas is no place for games and fools.',26124),
(31751,'enUS','','We will give you who have fallen another chance. You are not vrykul, so you cannot be held to such a high standard.',26124),
(31752,'enUS','','More bones to honor the floor of Valhalas. Bring on the next group!',26124),
(31753,'enUS','','You were not prepared!',26124),
(31754,'enUS','','There are other fights to be had within Jotunheim if you are not skilled enough for Valhalas.',26124),
(31755,'enUS','','$n has defeated the fallen heroes of Valhalas battles past. This is only a beginning, but it will suffice.',26124),
(31756,'enUS','The fallen heroes of Valhalas emerge from the ground to do battle once more!','',26124),
(31757,'enUS','','You have not yet proven yourself worthy enough to issue a challenge within Valhalas, $n.$B$BReturn when you have earned a name for yourself.',26124),
(31758,'enUS','','Many have fallen within Valhalas and their corpses are a testament to the strength of our ways.$B$BWill your bones litter this place of honor and battle as well, $n?',26124),
(31759,'enUS','Lesser beings, intruding here! A shame that your excess courage does not compensate for your stupidity!','',26124),
(31760,'enUS','None but the blue dragonflight are welcome here. Perhaps this is the work of Alexstrasza? Well, then, she has sent you to your deaths!','',26124),
(31761,'enUS','What could you hope to accomplish? To storm brazenly into my domain... to employ magic... against ME?','',26124),
(31762,'enUS','I am without limits here. The rules of your cherished reality do not apply. In this realm, I am in control!','',26124),
(31763,'enUS','I give you one chance. Pledge fealty to me, and perhaps I will not slaughter you for your insolence.','',26124),
(31764,'enUS','My patience has reached its limit. I will be rid of you!','',26124),
(31765,'enUS','Few have experienced the pain I will now inflict upon you!','',26124),
(31767,'enUS','Your stupidity has finally caught up with you!','',26124),
(31768,'enUS','More artifacts to confiscate.','',26124),
(31769,'enUS','How very naive.','',26124),
(31770,'enUS','','$n has accepted the challenge of Khit\'rix the Dark Master. May the gods show mercy upon $g him : her; for Khit\'rix surely will not.',26124),
(31771,'enUS','','Prepare yourself. Khit\'rix will be entering Valhalas from the southeast. Remember, do not leave the ring or you will lose the battle.',26124),
(31772,'enUS','I had hoped to end your lives quickly, but you have proven more... resilient than I anticipated. Nonetheless, your efforts are in vain. It is you reckless, careless mortals who are to blame for this war. I do what I must, and if it means your extinction.... then SO BE IT!!','',26124),
(31773,'enUS','I will teach you ignorant children just how little you know of magic.','',26124),
(31774,'enUS','Watch helplessly as your hopes are swept away!','',26124),
(31775,'enUS','Your energy will be put to good use.','',26124),
(31776,'enUS','I am the Spell-Weaver! My power is infinite!','',26124),
(31777,'enUS','Your spirit will linger here forever!','',26124),
(31778,'enUS','ENOUGH! If you intend to reclaim Azeroth\'s magic, then you shall have it!','',26124),
(31779,'enUS','Now your benefactors make their appearance, but they are too late! The powers contained here are sufficient to destroy the world ten times over. What do you think they will do to you?','',26124),
(31780,'enUS','Submit!','',26124),
(31781,'enUS','You will not succeed while I draw breath!','',26124),
(31782,'enUS','The powers at work here exceed anything you could possibly imagine!','',26124),
(31783,'enUS','I am unstoppable!','',26124),
(31784,'enUS','Alexstrasza, another of your brood falls!','',26124),
(31785,'enUS','Little more than gnats!','',26124),
(31786,'enUS','Your red allies will share your fate!','',26124),
(31787,'enUS','Still standing? Not for long.','',26124),
(31788,'enUS','Your cause is lost!','',26124),
(31789,'enUS','Your fragile mind will be shattered!','',26124),
(31790,'enUS','Unthinkable! The mortals will destroy... everything! My sister, what have you...','',26124),
(31791,'enUS','I bought food from this stall just yesterday and now my family\'s taken ill!','I bought food from this stall just yesterday and now my family\'s taken ill!',26124),
(31792,'enUS','','Look, I\'m sorry, I really am, but all of my food is fresh!',26124),
(31793,'enUS','The prisoners shall not go free! The word of Malygos is law!','',26124),
(31794,'enUS','Tremble, worms!','',26124),
(31795,'enUS','I will crush you!','',26124),
(31796,'enUS','Can you fly?','',26124),
(31797,'enUS','It is too late to run!','',26124),
(31798,'enUS','Gather \'round....','',26124),
(31799,'enUS','None shall escape!','',26124),
(31800,'enUS','I condemn you to death!','',26124),
(31801,'enUS','A fitting punishment.','',26124),
(31802,'enUS','Sentence executed!','',26124),
(31803,'enUS','Another casualty of war!','',26124),
(31804,'enUS','The war... goes on.','',26124),
(31805,'enUS','It seems my freedom must be bought with blood!','',26124),
(31806,'enUS','Plentiful, exploitable resources... primed for acquisition!','',26124),
(31807,'enUS','It would seem that a renegotiation is in order.','',26124),
(31808,'enUS','Nothing personal.','',26124),
(31809,'enUS','Business concluded.','',26124),
(31810,'enUS','Profit!','',26124),
(31811,'enUS','This is an... unrecoverable... loss.','',26124),
(31812,'enUS','Intruders, your victory will be short-lived. I am Commander Varos Cloudstrider. My drakes control the skies and protect this conduit. I will see to it personally that the Oculus does not fall into your hands!','',26124),
(31813,'enUS','There will be no mercy!','',26124),
(31814,'enUS','Blast them! Destroy them!','',26124),
(31815,'enUS','Take no prisoners! Attack!','',26124),
(31816,'enUS','Strike now! Obliterate them!','',26124),
(31817,'enUS','You were warned.','',26124),
(31818,'enUS','The Oculus is ours!','',26124),
(31819,'enUS','They are... too strong! Underestimated their... fortitude.','',26124),
(31820,'enUS','','Khit\'rix the Dark Master has been defeated by $n and $g his : her; band of companions. Let the next challenge be issued!',26124),
(31821,'enUS','Not--caww--get in way of--rrak-rrak--flee!','',26124),
(31822,'enUS','Kekeke!','',26124),
(31823,'enUS','Precious life--ra-aak--wasted!','',26124),
(31824,'enUS','Only strong--ka-raaak-survive!','',26124),
(31825,'enUS','No--kaw, kaw--flee...','',26124),
(31826,'enUS','Thank the Light for granting me another chance. And thank you, $n.','',26124),
(31827,'enUS','Without your help, I would\'ve been doomed to a life of undeath among the Lich King\'s gruesome creations.','',26124),
(31828,'enUS','There will be time for a proper thanks later, but there is still a battle to be fought!','',26124),
(31829,'enUS','A taste... just a small taste... of the Spell-Weaver\'s power!','',26124),
(31830,'enUS','So much unstable energy... but worth the risk to destroy you!','',26124),
(31831,'enUS','If only you understood!','',26124),
(31832,'enUS','Now do you see? Do you?!','',26124),
(31833,'enUS','Unfortunate, but necessary.','',26124),
(31834,'enUS','Everything I have done... has been for Azeroth....','',26124),
(31835,'enUS','','I knew that you would come.',26124),
(31836,'enUS','When I am done here, I am going to mount your heads upon the walls of Azjol-Nerub!','',26124),
(31837,'enUS','My wife and children are sick in bed because of the poison you sold me!','My husband and children are sick in bed because of the poison you sold me!',26124),
(31838,'enUS','','It wasn\'t my food!',26124),
(31839,'enUS','Don\'t try to weasel out of this!','Don\'t try to weasel out of this!',26124),
(31840,'enUS','','Please, it\'s not my fault! If... if I give you a refund, maybe you can speak to a healer? I don\'t know what you expect me to do!',26124),
(31841,'enUS','Simpletons! You cannot comprehend the forces you have set in motion. The ley line conduit will not be disrupted! Your defeat shall be absolute!','',26124),
(31842,'enUS','That... no, keep your filthy money! It won\'t help my family!','That... no, keep your filthy money! It won\'t help my family!',26124),
(31843,'enUS','%s prepares a Great Feast!','%s prepares a Great Feast!',26124),
(31844,'enUS','$n prepares a Fish Feast!','$n prepares a Fish Feast!',26124),
(31845,'enUS','$n prepares a Small Feast!','$n prepares a Small Feast!',26124),
(31846,'enUS','$n prepares a Gigantic Feast!','$n prepares a Gigantic Feast!',26124),
(31847,'enUS','%s groans.','',26124),
(31848,'enUS','Cry to the heavens, Alliance filth. Pray that my wounds do not heal before yours.','',26124),
(31849,'enUS','Green-skinned dog! Be silent or I will cut your tongue out and feed it to your swine-like children.','',26124),
(31850,'enUS','YOU HAVE JUST SIGNED YOUR OWN DEATH WARRANT, MONGREL!','',26124),
(31851,'enUS','YOU SIGNED YOURS WHEN YOU MURDERED BOLVAR! DAMN YOU!','',26124),
(31852,'enUS','','You have some fight in you. I\'m impressed.',26124),
(31853,'enUS','','Well fought...',26124),
(31855,'enUS','I\'ve been waiting.','',26124),
(31856,'enUS','','That looked a bit painful.',26124),
(31857,'enUS','','I bet you wish you were undead about now.',26124),
(31858,'enUS','','Welcome to the world of the unliving.',26124),
(31859,'enUS','','Noble effort.',26124),
(31860,'enUS','Don\'t stop now, I\'ve almost broken a sweat.','',26124),
(31861,'enUS','I know no death. I will... be back... for you...','',26124),
(31862,'enUS','Your blood tastes sweet.','',26124),
(31863,'enUS','Another trophy for my collection.','',26124),
(31864,'enUS','Your blood is now mine.','',26124),
(31865,'enUS','Fragile thing.','',26124),
(31866,'enUS','No shining army? No righteous words? It seems your \'honor\' suits you no longer.','',26124),
(31867,'enUS','Such noble boasts, but in the end, we\'ve brought you down to reality.','',26124),
(31868,'enUS',' You too shall serve the Lich King.... your time comes.','',26124),
(31869,'enUS','After I finish with your friends, you shall be our newest initiate.','',26124),
(31870,'enUS','There will be no peace in death for you, that I promise.','',26124),
(31871,'enUS','Your eternal suffering is about to begin.','',26124),
(31872,'enUS','Your soul belongs to me now.','',26124),
(31873,'enUS','You brash interlopers are out of your element! I will ground you!','',26124),
(31874,'enUS','Such insolence... such arrogance... must be PUNISHED!','',26124),
(31875,'enUS','No magic of nature will help you now!','',26124),
(31876,'enUS','We command the arcane! It shall not be used against us!','',26124),
(31877,'enUS','It is trivial to extinguish your fire!','',26124),
(31878,'enUS','It\'s a long way down....','',26124),
(31879,'enUS','Back to the earth with you!','',26124),
(31880,'enUS','Enjoy the fall!','',26124),
(31881,'enUS','Savor this small victory, foolish little creatures. You and your dragon allies have won this battle, but we will win... the Nexus War.','',26124),
(31882,'enUS','','Ah, there you are! Remember me? Of course you do! Wait right there, I\'m coming down.',26124),
(31883,'enUS','','I told you I\'d be better prepared when next we met. I\'ve fought and won the Hyldsmeet, trained at Valkyrion, and here I am.  Come and get some!',26124),
(31884,'enUS','The secrets of the deep shall remain hidden.','',26124),
(31885,'enUS','','Carnage is coming!  Remember, no matter what you do, do NOT leave the battle ring or I will disqualify you and your group.',26124),
(31886,'enUS','The young must not go hungry....','',26124),
(31887,'enUS','Shhhad ak kereeesshh chak-k-k!','',26124),
(31888,'enUS','Sleep now in the cold dark....','',26124),
(31889,'enUS','For the Lich King!','',26124),
(31890,'enUS','Perhaps we will be allies soon.','',26124),
(31891,'enUS','Master... is my service... complete?','',26124),
(31892,'enUS','','Sigrid Iceborn has returned to the heights of Jotunheim to prove herself against $n.  When last they met, $n bested her in personal combat.  Let us see the outcome of this match.',26124),
(31893,'enUS','My---raaak--favorite! Awk awk awk! Raa-kaa!','',26124),
(31894,'enUS','An Ahn\'kahar Guardian hatches!','',26124),
(31895,'enUS','I will feast on your remains!','',26124),
(31896,'enUS','Your heartbeat is... music to my ears.','',26124),
(31897,'enUS','I am nowhere.... I am everywhere. I am the watcher unseen.','',26124),
(31898,'enUS','So... appetizing.','',26124),
(31899,'enUS','Fresh, warm blood... it has been too long.','',26124),
(31900,'enUS','Bin dorei am\'ovel!','',26124),
(31901,'enUS','I will drink no blood before its time.','',26124),
(31902,'enUS','One final... embrace.','',26124),
(31903,'enUS','Still I hunger. Still... I... thirst.','',26124),
(31904,'enUS','Your charred bones will litter the floor!','',26124),
(31905,'enUS','How much heat can you take?','',26124),
(31906,'enUS','All will be reduced to ash!','',26124),
(31907,'enUS','Burn, you miserable wretches!','',26124),
(31908,'enUS','You will make a fine meal for the hatchlings.','',26124),
(31909,'enUS','You are at a grave disadvantage.','',26124),
(31910,'enUS','This is why we call you lesser beings!','',26124),
(31911,'enUS','You will be alone in the end.','',26124),
(31912,'enUS','Trust is your weakness.','',26124),
(31913,'enUS','Hope is an illusion.','',26124),
(31914,'enUS','All that you know will fade.','',26124),
(31915,'enUS','This is madness! Cease this foolish battle!','',26124),
(31916,'enUS','Brothers and sisters, we must remain united! The Lich King will never fall to a world divided!','',26124),
(31917,'enUS','Can you not see that you play right into the Lich King\'s hands? He wants you to kill each other!','',26124),
(31918,'enUS','Join the Argent Crusade! United, we shall destroy the Lich King!','',26124),
(31919,'enUS','Judgment day comes, brothers and sisters! Will you be prepared?','',26124),
(31920,'enUS','How much of our efforts are being wasted by attacking the Alliance?','',26124),
(31921,'enUS','','$n has defeated Sigrid Iceborn for a second time.  Well, this time $g he : she; did it with the help of $g his : her; friends, but a win is a win!',26124),
(31922,'enUS','We must unite and focus our attention upon the true threat: THE LICH KING!','',26124),
(31923,'enUS','This is madness! Cease this foolish battle!','',26124),
(31924,'enUS','Brothers and sisters, we must remain united! The Lich King will never fall to a world divided!','',26124),
(31925,'enUS','Can you not see that you play right into the Lich King\'s hands? He wants you to kill each other!','',26124),
(31926,'enUS','Join the Argent Crusade! United, we shall destroy the Lich King!','',26124),
(31927,'enUS','Judgment day comes, brothers and sisters! Will you be prepared?','',26124),
(31928,'enUS','How much of our efforts are being wasted by attacking the Horde?','',26124),
(31929,'enUS','We must unite and focus our attention upon the true threat: THE LICH KING!','',26124),
(31930,'enUS','','From the bowels of the Underhalls comes Carnage.  Brave and foolish $n has accepted the challenge.  $G He : She; and $g his : her; group stand ready to face the monstrosity.',26124),
(31931,'enUS','','The horror known as Carnage is no more.  Could it be that $n is truly worthy of battle in Valhalas?  We shall see.',26124),
(31932,'enUS','Uhnhh.... Don\'t... bother with me.$b$bI am... finished...','Uhnhh.... Don\'t... bother with me.$b$bI am... finished....',26124),
(31933,'enUS','Gathering... information... on the Scourge.$b$bAlliance forces appeared...$b$bWe took cover - waited until they attacked the gate... then, we hit them from the rear.$b$bPinched between us... and the Scourge... it was too much for them....$b$b$g Brother:Sister;... it was... glorious.','Gathering... information... on the Scourge.$b$bAlliance forces appeared...$b$bWe took cover - waited until they attacked the gate... then, we hit them from the rear.$b$bPinched between us... and the Scourge... it was too much for them....$b$b$g Brother:Sister;... it was... glorious.',26124),
(31934,'enUS','Hold on, friend. Tell me what happened here.','Hold on, friend. Tell me what happened here.',26124),
(31935,'enUS','ENOUGH!  You tiny insects are not worthy to do battle within this sacred place!  You do not fight with honor!  You do not even ascend! ','',26124),
(31936,'enUS','Fight me and die you cowards!','',26124),
(31937,'enUS','','I can hear Sigrid Iceborn approaching from the northwest. She has been informed that she cannot use her proto-drake in battle here. Do not leave the battle ring!',26124),
(31938,'enUS','','Look to the southeast and you will see the thane upon the platform near Gjonner the Merciless when he shows himself. Let him come down.  Stay within the ring of Valhalas.',26124),
(31939,'enUS','','Thane Banahogg returns to Valhalas for the first time in ages to prove that the vrykul are the only beings worthy to fight within its sacred ring.  Will $n prove him wrong?',26124),
(31940,'enUS','','Thane Banahogg the Deathblow has fallen to $n and $g his : her; fighting companions.  $G He : She; has but one challenge ahead of $g him : her;.  Who will it be?',26124),
(31941,'enUS','The Light\'s blessing be upon you for aiding me in my time of need, $n.','',26124),
(31942,'enUS','I\'ve had my fill of this place. Let us depart.','',26124),
(31943,'enUS','I have you to thank for my life. I will return to my comrades and spread word of your bravery. Fight the Scourge with all the strength you can muster, and we will be by your side.','',26124),
(31944,'enUS','You must tell my brothers that I live.','',26124),
(31945,'enUS','','The unthinkable has happened... $n has slain Prince Sandoval!',26124),
(31946,'enUS','','In defeating him, $g he : she; and $g his : her; fighting companions have proven themselves worthy of battle in this most sacred place of vrykul honor.',26124),
(31947,'enUS','The time of judgment is nigh. In your heart, you know justice is the only true path.','',26124),
(31948,'enUS','','ALL HAIL $n, CHAMPION OF VALHALAS!',26124),
(31949,'enUS','','It\'s too late to run now.  Do not leave the ring.  Die bravely, $n!',26124),
(31950,'enUS','Face your judgment by the Light!','',26124),
(31951,'enUS','','From the depths of Icecrown Citadel, one of the Lich King\'s chosen comes to put an end to the existence of $n and $g his : her; friends.',26124),
(31952,'enUS','You will never take me alive!','',26124),
(31953,'enUS','The Argent Crusade never surrenders!','',26124),
(31954,'enUS','Forgive me, brothers, for I have failed you...','',26124),
(31955,'enUS','','Warriors of Jotunheim, I present to you, Blood Prince Sandoval!',26124),
(31956,'enUS','Hardly a fitting introduction, Spear-Wife.  Now, who is this outsider that I\'ve been hearing so much about?','',26124),
(31957,'enUS','I will make this as easy as possible for you.  Simply come here and die.  That is all that I ask for your many trespasses.  For your sullying of this exalted place of battle.','',26124),
(31958,'enUS','You have served honorably.. I shall make your victory known to all the Horde.','You have served honorably.. I shall make your victory known to all the Horde.',26124),
(31959,'enUS','Ah, the hand of the Ebon Blade has finally come to claim me. I tremble in fear.','',26124),
(31960,'enUS','I have given my all... for the Horde...','I have given my all... for the Horde...',26124),
(31961,'enUS','Hah! That\'s all you\'ve got? I\'m surprised you even made it to the citadel.','',26124),
(31962,'enUS','The Lich King has given me power beyond your wildest nightmares. Behold!','',26124),
(31963,'enUS','It all ends here.','',26124),
(31964,'enUS','There you are Darion! I was wondering when you\'d crawl forth.','',26124),
(31965,'enUS','So easily fooled by Tyrion\'s boasts upon holy ground, you rush to him thinking he would be victorious. You always were a coward, Darion. Just like your father.','',26124),
(31966,'enUS','%s chuckles knowingly.','',26124),
(31967,'enUS','The Lich King shall extinquish... every... last... one... of you.','',26124),
(31968,'enUS','Weakling.','',26124),
(31969,'enUS','One more slave for the Lich King.','',26124),
(31970,'enUS','That wasn\'t even a challenge.','',26124),
(31971,'enUS','Well look at that... you\'re dead.','',26124),
(31972,'enUS','FOR YOUR EFFRONTERY TO THE LICH KING!','',26124),
(31973,'enUS','You dare to think you have thwarted my will? That you have broken my plans?','',26124),
(31974,'enUS','You have accomplished nothing!','',26124),
(31975,'enUS','Orbaz Bloodbane, self proclaimed hand of the Lich King.','',26124),
(31976,'enUS','Your feeble resistance has only hastened your doom.','',26124),
(31977,'enUS','Couldn\'t wait for me to be out of the way so that you could sieze control?','',26124),
(31978,'enUS','Good riddance.','',26124),
(31979,'enUS','So spout your platitudes and flail until you are spent. In the end, you will be mine, and Morbidus will be the harbinger of your death!','',26124),
(31980,'enUS','Avenge me, $g brother:sister;....','Avenge me, $g brother:sister;....',26124),
(31981,'enUS','Morbidus, show them what happens to those who defy the will of their king!','',26124),
(31982,'enUS','Wait, $c....$b$bOne... final request...','Wait, $c....$b$bOne... final request...',26124),
(31983,'enUS','You\'ll never have what it takes to lead anything, Orbaz, not even a legion of mindless skeletons.','',26124),
(31984,'enUS','We... are superior! How could this... be?','',26124),
(31985,'enUS','I fear nothing! Least of all you!','',26124),
(31986,'enUS','You are insignificant.','',26124),
(31987,'enUS','Such mediocre resistance...','',26124),
(31988,'enUS','You are easily bested!','',26124),
(31989,'enUS','Father taught me well.','',26124),
(31990,'enUS','On you knees!','',26124),
(31991,'enUS','I will take pity on you, Sartharion, just this once.','',26124),
(31992,'enUS','Uhnhh.... It is too late for me, $g brother:sister;.$b$bI am... finished...','Uhnhh.... It is too late for me, $g brother:sister;.$b$bI am... finished...',26124),
(31993,'enUS','','You have no place here! Your place... is among the departed!',26124),
(31994,'enUS','','No contest.',26124),
(31995,'enUS','','Typical. Just as I was having fun...',26124),
(31996,'enUS','','To darkness I condemn you.',26124),
(31997,'enUS','','Arrogant little creatures, to challenge powers you do not yet understand.',26124),
(31998,'enUS','','I am no mere dragon. You will find that I am much, much more.',26124),
(31999,'enUS','','It is amusing to watch you struggle. Very well, witness how it is done!',26124),
(32000,'enUS','','I should not... have held back...',26124),
(32001,'enUS','','',26124),
(32002,'enUS','You pose no threat, lesser beings! Give me your worst!','',26124),
(32003,'enUS','The least you could do is put up a fight!','',26124),
(32004,'enUS','Was that the best you can do?','',26124),
(32005,'enUS','I will pick my teeth with your bones!','',26124),
(32006,'enUS','Aren\'t you tricky? I have a few tricks of my own...','',26124),
(32007,'enUS','Unlike you, I have many talents!','',26124),
(32008,'enUS','Father was right about you, Sartharion. You ARE a weakling.','',26124),
(32009,'enUS','I still have some... fight... in me-e-e...','',26124),
(32010,'enUS','Thank you for your help. You can find me at the Argent Vanguard if you require anything further.','',26124),
(32011,'enUS','','You must defeat Prince Sandoval. It is your only hope for survival, $c.',26124),
(32012,'enUS','Stay with me, friend. I must know what happened here.','Stay with me, friend. I must know what happened here.',26124),
(32013,'enUS','','Champion $n, it is good to see you again.$B$BHave you returned to Valhalas to assist a friend with their challenges?',26124),
(32014,'enUS','We attacked under cover of a blizzard....$b$bThe Scourge were caught off guard... our victory was certain....$b$bThen... from behind us... the Horde came from nowhere.$b$bThey cost us... everything....','We attacked under cover of a blizzard....$b$bThe Scourge were caught off guard... our victory was certain....$b$bThen... from behind us... the Horde came from nowhere.$b$bThey cost us... everything....',26124),
(32015,'enUS','Knights of the Ebon Blade, prepare for battle!','',26124),
(32016,'enUS','Enough of your blather! Knights, forward!','',26124),
(32017,'enUS','Wait, $g brother:m\'lady;....$b$bOne last thing...','Wait, $g brother:m\'lady;....$b$bOne last thing...',26124),
(32018,'enUS','Be strong, friend. Do what must be done...','Be strong, friend. Do what must be done...',26124),
(32019,'enUS','Yes, my king!','',26124),
(32020,'enUS','The figure at the front of the ruined chamber gestures and mouths inaudible words as a group of other spirits sit in rapt attention.','The figure at the front of the ruined chamber gestures and mouths inaudible words as a group of other spirits sit in rapt attention.',26124),
(32021,'enUS','The Lost Shandaral Spirit kneels silently before the violet waters, gazing into the tranquil surface of the pool.','The Lost Shandaral Spirit kneels silently before the violet waters, gazing into the tranquil surface of the pool.',26124),
(32022,'enUS','','Why, hello again!',26124),
(32023,'enUS','','Great job! Arthas is safely on his way to Northrend!',26124),
(32024,'enUS','Yes, please!','Yes, please!',26124),
(32025,'enUS','Has Prince Arthas turned against us?','',26124),
(32026,'enUS','Stand your ground, men!','',26124),
(32027,'enUS','The undead are upon us!','',26124),
(32028,'enUS','We make our stand here!','',26124),
(32029,'enUS','The rumors were true!  The prince has gone mad!','',26124),
(32030,'enUS','My family\'s sick!','My family\'s sick!',26124),
(32031,'enUS','The whole city\'s ill!','The whole city\'s ill!',26124),
(32032,'enUS','I think it\'s your grain that\'s making us sick!','I think it\'s your grain that\'s making us sick!',26124),
(32033,'enUS','You brought this down on us! I\'d bet gold on it!','You brought this down on us! I\'d bet gold on it!',26124),
(32034,'enUS','It\'s poison! Cartloads of poison!','It\'s poison! Cartloads of poison!',26124),
(32035,'enUS','We were fine until we ate from this tainted grain of yours!','We were fine until we ate from this tainted grain of yours!',26124),
(32036,'enUS','Give us one good reason why we shouldn\'t set fire to these sacks!','Give us one good reason why we shouldn\'t set fire to these sacks!',26124),
(32037,'enUS','This is all your fault!','This is all your fault!',26124),
(32038,'enUS','My Queen, do they know?','',26124),
(32039,'enUS','I just delivered it!','',26124),
(32040,'enUS','','No, my beloved.',26124),
(32041,'enUS','','They must not discover the fate of the young paladin. Not yet.',26124),
(32042,'enUS','I would like to enter the secret code to receive my Big Blizzard Bear.','I would like to enter the secret code to receive my Big Blizzard Bear.',26124),
(32043,'enUS','I didn\'t touch it! I promise you!','',26124),
(32044,'enUS','Please, I\'m just a delivery man!','',26124),
(32045,'enUS','I haven\'t done anything!','',26124),
(32046,'enUS','%s nods.','',26124),
(32047,'enUS','They will not.','',26124),
(32048,'enUS','','Come to me, $n.',26124),
(32049,'enUS','I... recede.','',26124),
(32050,'enUS','I AM a force of nature!','',26124),
(32051,'enUS','I SHALL pass!','',26124),
(32052,'enUS','You cannot stop the tide!','',26124),
(32053,'enUS','I will not be contained! Ngyah!!','',26124),
(32054,'enUS','I shall consume, decimate, devastate, and destroy! Yield now to the wrath of the pounding sea!','',26124),
(32055,'enUS','Water can hold any form, take any shape... overcome any obstacle.','',26124),
(32056,'enUS','Stand aside, mortals!','',26124),
(32057,'enUS','Where\'s Barthilas?!','Where\'s Barthilas?!',26124),
(32058,'enUS','We want to speak to the magistrate!','We want to speak to the magistrate!',26124),
(32059,'enUS','What are we supposed to do?!','What are we supposed to do?!',26124),
(32060,'enUS','We need leadership!','We need leadership!',26124),
(32061,'enUS','Stop hiding, Barthilas!','Stop hiding, Barthilas!',26124),
(32062,'enUS','Let us through!','Let us through!',26124),
(32063,'enUS','We\'ll drag you out here if we have to!','We\'ll drag you out here if we have to!',26124),
(32064,'enUS','Look alive marines!','',26124),
(32065,'enUS','On your guard marines!','',26124),
(32066,'enUS','At ease marines!','',26124),
(32067,'enUS','Marines, stand at ease!','',26124),
(32068,'enUS','','The magistrate is very busy.',26124),
(32069,'enUS','','Please, return to your homes.',26124),
(32070,'enUS','','Everyone, please remain calm...',26124),
(32071,'enUS','','Magistrate Barthilas is unavailable at the moment...',26124),
(32072,'enUS','Shield-Mages, get some shields up!','',26124),
(32073,'enUS','','Please don\'t go back there!',26124),
(32074,'enUS','','Don\'t disturb the magistrate, please!',26124),
(32075,'enUS','Let\'s get some protection here mages!  Put up some shields!','',26124),
(32076,'enUS','','Come back; we\'re not open!',26124),
(32077,'enUS','The western sewers entrance is beneath the stairway to the Violet Citadel.','The western sewers entrance is beneath the stairway to the Violet Citadel.',26124),
(32078,'enUS','The eastern sewers entrance is just outside the entrance to Krasus\' Landing.','The eastern sewers entrance is just outside the entrance to Krasus\' Landing.',26124),
(32079,'enUS','','Reavers, ready for battle!',26124),
(32080,'enUS','','Prepare for battle reavers!',26124),
(32081,'enUS','','Reavers, stand down!',26124),
(32082,'enUS','','Stand down reavers!',26124),
(32083,'enUS','','Shadow-Warders, prove your worth!',26124),
(32084,'enUS','The city\'s cemetery is just north of the Violet Citadel in western Dalaran.','The city\'s cemetery is just north of the Violet Citadel in western Dalaran.',26124),
(32085,'enUS','','Shield our vessel Shadow-Warders!',26124),
(32086,'enUS','The Eventide is a square in southern Dalaran. The enchanted fountain there is popular for fishing.','The Eventide is a square in southern Dalaran. The enchanted fountain there is popular for fishing.',26124),
(32087,'enUS','Runeweaver Square is a park at the very heart of Dalaran.','Runeweaver Square is a park at the very heart of Dalaran.',26124),
(32088,'enUS','The memorial park to Antonidas is located in northern Dalaran.','The memorial park to Antonidas is located in northern Dalaran.',26124),
(32089,'enUS','There is a well in northern Dalaran that some of the city\'s more... adventurous... visitors use to enter the sewers.','There is a well in northern Dalaran that some of the city\'s more... adventurous... visitors use to enter the sewers.',26124),
(32090,'enUS','Work harder fools, the Lich King has no time for your laziness!','',26124),
(32091,'enUS','Taskmistresses, do your jobs. Production must increase!','',26124),
(32092,'enUS','Must I come out there myself and do your job for you Taskmistresses?!','',26124),
(32093,'enUS','The Violet Hold, prison for the enemies of the Kirin Tor, is in southeast Dalaran.','The Violet Hold, prison for the enemies of the Kirin Tor, is in southeast Dalaran.',26124),
(32094,'enUS','Ah, new slaves have arrived. Taskmistresses, see that they are properly outfitted and set to work!','',26124),
(32095,'enUS','Do you see the massive spired tower in eastern Dalaran? That is the majestic Violet Citadel.','Do you see the massive spired tower in eastern Dalaran? That is the majestic Violet Citadel.',26124),
(32096,'enUS','The visiting Horde keep primarily to the Sunreaver\'s Sanctuary in northeastern Dalaran.$B$BThere is an inn there, as well as portals to the various battlegrounds and Orgrimmar.','The visiting Horde keep primarily to the Sunreaver\'s Sanctuary in northeastern Dalaran.$B$BThere is an inn there, as well as portals to the various battlegrounds and Orgrimmar.',26124),
(32097,'enUS','Visiting members of the Alliance keep primarily to the Silver Enclave in southwestern Dalaran.$B$BThere is an inn there, as well as portals to the various battlegrounds and Stormwind.','Visiting members of the Alliance keep primarily to the Silver Enclave in southwestern Dalaran.$B$BThere is an inn there, as well as portals to the various battlegrounds and Stormwind.',26124),
(32098,'enUS','There are at least three ways beneath Dalaran: Sewer entrances in the east and west, and a well in the north.','There are at least three ways beneath Dalaran: Sewer entrances in the east and west, and a well in the north.',26124),
(32099,'enUS','Eastern Sewer Entrance','Eastern Sewer Entrance',26124),
(32100,'enUS','Western Sewer Entrance','Western Sewer Entrance',26124),
(32101,'enUS','Well Entrance','Well Entrance',26124),
(32102,'enUS','There are many places of interest in Dalaran. Which do you seek?','There are many places of interest in Dalaran. Which do you seek?',26124),
(32103,'enUS','The Alliance Quarter','The Alliance Quarter',26124),
(32104,'enUS','The Horde Quarter','The Horde Quarter',26124),
(32105,'enUS','The Violet Citadel','The Violet Citadel',26124),
(32106,'enUS','The Violet Hold','The Violet Hold',26124),
(32107,'enUS','Sewers','Sewers',26124),
(32108,'enUS','Antonidas Memorial','Antonidas Memorial',26124),
(32109,'enUS','Runeweaver Square','Runeweaver Square',26124),
(32110,'enUS','The Eventide','The Eventide',26124),
(32111,'enUS','Cemetery','Cemetery',26124),
(32112,'enUS','Dalaran\'s arena and those who service it are found beneath the city, in the sewers.$B$BThere are at least three ways in: Entrances in the east and west, and a well in the north.','Dalaran\'s arena and those who service it are found beneath the city, in the sewers.$B$BThere are at least three ways in: Entrances in the east and west, and a well in the north.',26124),
(32113,'enUS','Portals to Stormwind and Orgrimmar and the various battlegrounds can be found in Dalaran\'s Alliance and Horde quarters: the Silver Enclave and the Sunreaver\'s Sancturary.','Portals to Stormwind and Orgrimmar and the various battlegrounds can be found in Dalaran\'s Alliance and Horde quarters: the Silver Enclave and the Sunreaver\'s Sancturary.',26124),
(32115,'enUS','','Work harder slave or I\'ll have your head!',26124),
(32116,'enUS','Y-y-y-yes Mistress, whatever you say Mistress.','',26124),
(32117,'enUS','The Fleshwerks will never again produce soldiers for the Lich King\'s armies.','',26124),
(32118,'enUS','Let\'s kill this... thing... and get this over with.','Let\'s kill this... thing... and get this over with.',26124),
(32119,'enUS','Amongst the Kirin Tor, it is my duty to see to the strategic interests of the magocracy.$B$BThere is much yet to be done this week. Will you assist me, $n?','',26124),
(32120,'enUS','The Magus Commerce Exchange is in northwest Dalaran, and holds most of the city\'s profession trainers.','The Magus Commerce Exchange is in northwest Dalaran, and holds most of the city\'s profession trainers.',26124),
(32121,'enUS','Trade District','Trade District',26124),
(32122,'enUS','The city\'s best tailors are in Talismanic Textiles in the Magus Commerce Exchange, northwest Dalaran.','The city\'s best tailors are in Talismanic Textiles in the Magus Commerce Exchange, northwest Dalaran.',26124),
(32123,'enUS','Skinners and leatherworkers of all sorts may be found at Legendary Leathers in the Magus Commerce Exchange, northwest Dalaran.','Skinners and leatherworkers of all sorts may be found at Legendary Leathers in the Magus Commerce Exchange, northwest Dalaran.',26124),
(32124,'enUS','Miners trainers and supplies are found in the All that Glitters Prospecting Co. in the Magus Commerce Exchange, northwest Dalaran.','Miners trainers and supplies are found in the All that Glitters Prospecting Co. in the Magus Commerce Exchange, northwest Dalaran.',26124),
(32125,'enUS','That would be Cartier & Co. Fine Jewelry in the Magus Commerce Exchange, northwest Dalaran.','That would be Cartier & Co. Fine Jewelry in the Magus Commerce Exchange, northwest Dalaran.',26124),
(32126,'enUS','Seek out The Scribe\'s Sacellum in the Magus Commerce Exchange, northwest Dalaran.','Seek out The Scribe\'s Sacellum in the Magus Commerce Exchange, northwest Dalaran.',26124),
(32127,'enUS','There is a greenhouse attached to the Agronomical Apothecary in the Magus Commerce Exchange, northwest Dalaran. You\'ll find the city\'s best herbalists there.','There is a greenhouse attached to the Agronomical Apothecary in the Magus Commerce Exchange, northwest Dalaran. You\'ll find the city\'s best herbalists there.',26124),
(32128,'enUS','One can learn to fish near the enchanted fountain in the Eventide, a square in southern Dalaran.','One can learn to fish near the enchanted fountain in the Eventide, a square in southern Dalaran.',26124),
(32129,'enUS','The city\'s premier urgent care center, First to your Aid, is located in the Magus Commerce Exchange, northwest Dalaran.','The city\'s premier urgent care center, First to your Aid, is located in the Magus Commerce Exchange, northwest Dalaran.',26124),
(32130,'enUS','Engineers often train at Like Clockwork in the Magus Commerce Exchange, northwest Dalaran.','Engineers often train at Like Clockwork in the Magus Commerce Exchange, northwest Dalaran.',26124),
(32131,'enUS','You\'ll want to visit Simply Enchanting, just outside the Magus Commerce Exchange in northwest Dalaran.','You\'ll want to visit Simply Enchanting, just outside the Magus Commerce Exchange in northwest Dalaran.',26124),
(32132,'enUS','Cooking trainers are located in the kitchens of the Alliance and Horde inns in their respective quarters.','Cooking trainers are located in the kitchens of the Alliance and Horde inns in their respective quarters.',26124),
(32133,'enUS','Alliance Inn','Alliance Inn',26124),
(32134,'enUS','Horde Inn','Horde Inn',26124),
(32136,'enUS','A Hero\'s Welcome is located right beside the Silver Enclave in southwestern Dalaran.$B$BThe place boasts a beer garden and one of the city\'s finest cooking trainer in its kitchen.','A Hero\'s Welcome is located right beside the Silver Enclave in southwestern Dalaran.$B$BThe place boasts a beer garden and one of the city\'s finest cooking trainer in its kitchen.',26124),
(32138,'enUS','You\'re looking for The Filthy Animal in the Horde quarter of Sunreaver\'s Sanctuary, northeastern Dalaran.$B$BI am told it is a rather rough place, but with an excellent cooking trainer in its kitchen.','You\'re looking for The Filthy Animal in the Horde quarter of Sunreaver\'s Sanctuary, northeastern Dalaran.$B$BI am told it is a rather rough place, but with an excellent cooking trainer in its kitchen.',26124),
(32139,'enUS','There is a large smithy and forge in the Magus Commerce Exchange, northwest Dalaran.$B$BLook for the massive enchanted anvil and stained glass windows in the shapes of axes and shields.','There is a large smithy and forge in the Magus Commerce Exchange, northwest Dalaran.$B$BLook for the massive enchanted anvil and stained glass windows in the shapes of axes and shields.',26124),
(32140,'enUS','Look for the potion-shaped door to the Agronomical Apothecary in the Magus Commerce Exchange, northwest Dalaran. It\'s quite impossible to miss!','Look for the potion-shaped door to the Agronomical Apothecary in the Magus Commerce Exchange, northwest Dalaran. It\'s quite impossible to miss!',26124),
(32141,'enUS','Which profession trainer were you looking for?','Which profession trainer were you looking for?',26124),
(32142,'enUS','Orgrimmar is under lock down. All shops are closed. Please visit Thunder Bluff or Silvermoon City if you require a merchant, auctioneer or trainer.$B$BStay clear of the Undercity!','Orgrimmar is under lock down. All shops are closed. Please visit Thunder Bluff or Silvermoon City if you require a merchant, auctioneer or trainer.$B$BStay clear of the Undercity!',26124),
(32143,'enUS','Engineering','Engineering',26124),
(32144,'enUS','Fishing','Fishing',26124),
(32145,'enUS','Herbalism','Herbalism',26124),
(32146,'enUS','Inscription','Inscription',26124),
(32147,'enUS','Mining','Mining',26124),
(32148,'enUS','Tailoring','Tailoring',26124),
(32149,'enUS','The high elf Hira Snowdawn teaches Cold Weather Flying.$B$BShe can be found upon her dragonhawk at Krasus\' Landing in eastern Dalaran.','The high elf Hira Snowdawn teaches Cold Weather Flying.$B$BShe can be found upon her dragonhawk at Krasus\' Landing in eastern Dalaran.',26124),
(32150,'enUS','The city\'s mage and portal trainers may be found in a large building in eastern Dalaran, between Runeweaver Square at the heart of the city and Krasus\' Landing.','The city\'s mage and portal trainers may be found in a large building in eastern Dalaran, between Runeweaver Square at the heart of the city and Krasus\' Landing.',26124),
(32151,'enUS','What sort of trainer were you trying to find?','What sort of trainer were you trying to find?',26124),
(32152,'enUS','Mage Trainer','Mage Trainer',26124),
(32153,'enUS','Portal Trainer','Portal Trainer',26124),
(32154,'enUS','Cold Weather Flying Trainer','Cold Weather Flying Trainer',26124),
(32155,'enUS','Dalaran\'s stable master is located inside the Magical Menagerie in northeast Dalaran.','Dalaran\'s stable master is located inside the Magical Menagerie in northeast Dalaran.',26124),
(32156,'enUS','The most popular inn in Dalaran is the Legerdemain Lounge, just north of the city\'s center.$B$BThe Alliance and Horde Quarters each have their own inns as well, and I am told there is one more beneath the city, in the sewers.','The most popular inn in Dalaran is the Legerdemain Lounge, just north of the city\'s center.$B$BThe Alliance and Horde Quarters each have their own inns as well, and I am told there is one more beneath the city, in the sewers.',26124),
(32157,'enUS','The city\'s best-known barber shop is located in northern Dalaran.','The city\'s best-known barber shop is located in northern Dalaran.',26124),
(32158,'enUS','You\'ll find the city\'s Flight Master at Krasus\' Landing in eastern Dalaran.','You\'ll find the city\'s Flight Master at Krasus\' Landing in eastern Dalaran.',26124),
(32159,'enUS','The Bank of Dalaran is in the northern part of the city.','The Bank of Dalaran is in the northern part of the city.',26124),
(32160,'enUS','The Dalaran Merchants\' Bank is in the southern part of the city, off the Eventide.','The Dalaran Merchants\' Bank is in the southern part of the city, off the Eventide.',26124),
(32161,'enUS','No! The workshop is about to explode! Evacuate, quickly!','No! The workshop is about to explode! Evacuate, quickly!',26124),
(32162,'enUS','There are three banks in the city: The Bank of Dalaran in the north, the Dalaran Merchants\' Bank in the south, and one more beneath the city, in the sewers.','There are three banks in the city: The Bank of Dalaran in the north, the Dalaran Merchants\' Bank in the south, and one more beneath the city, in the sewers.',26124),
(32163,'enUS','Northern Bank','Northern Bank',26124),
(32164,'enUS','Southern Bank','Southern Bank',26124),
(32165,'enUS','There are many mailboxes in Dalaran: On many corners, outside nearly every inn and bank, even upon Krasus\' Landing.','There are many mailboxes in Dalaran: On many corners, outside nearly every inn and bank, even upon Krasus\' Landing.',26124),
(32166,'enUS','Inn','Inn',26124),
(32167,'enUS','Bank','Bank',26124),
(32168,'enUS','Krasus\' Landing','Krasus\' Landing',26124),
(32169,'enUS','Krasus\' Landing is in easternmost Dalaran.$B$BThe city\'s flight master is there, as well as the cold weather flying trainer.','Krasus\' Landing is in easternmost Dalaran.$B$BThe city\'s flight master is there, as well as the cold weather flying trainer.',26124),
(32170,'enUS','Dalaran has no auction house of its own. You must take a portal back to one of your capitals.$B$BThey can be found in Dalaran\'s Alliance and Horde quarters: the Silver Enclave and the Sunreaver\'s Sancturary.','Dalaran has no auction house of its own. You must take a portal back to one of your capitals.$B$BThey can be found in Dalaran\'s Alliance and Horde quarters: the Silver Enclave and the Sunreaver\'s Sancturary.',26124),
(32171,'enUS','Destroy our raw materials, will you? Well, the master has a special plan in mind for you... ','',26124),
(32172,'enUS','Which service were you looking for?','Which service were you looking for?',26124),
(32173,'enUS','Look! What\'s a frostwyrm doing here? It\'s coming straight for us.','',26124),
(32174,'enUS','Auction House','Auction House',26124),
(32175,'enUS','Services','Services',26124),
(32176,'enUS','Trainers','Trainers',26124),
(32177,'enUS','Capital Portals','Capital Portals',26124),
(32179,'enUS','Arena','Arena',26124),
(32180,'enUS','Points of Interest','Points of Interest',26124),
(32181,'enUS','Visiting members of the Alliance keep primarily to the Silver Enclave in southwestern Dalaran.$B$BThere is an inn there, as well as portals to the various Alliance cities and battlegrounds.','Visiting members of the Alliance keep primarily to the Silver Enclave in southwestern Dalaran.$B$BThere is an inn there, as well as portals to the various Alliance cities and battlegrounds.',26124),
(32183,'enUS','Welcome to Dalaran, traveler.$B$BIs there something I might help you find?','Welcome to Dalaran, traveler.$B$BIs there something I might help you find?',26124),
(32184,'enUS','Please respect the laws of Dalaran while you are here, stranger.$B$BWere you lost? Is there something I might help you find?','Please respect the laws of Dalaran while you are here, stranger.$B$BWere you lost? Is there something I might help you find?',26124),
(32185,'enUS','This instance is about to reset. You will be forced from the instance shortly.','This instance is about to reset. You will be forced from the instance shortly.',26124),
(32186,'enUS','Dalaran\'s guild master is found in the visitor center, just south of the city\'s center.','Dalaran\'s guild master is found in the visitor center, just south of the city\'s center.',26124),
(32187,'enUS','This instance has reset.','This instance has reset.',26124),
(32189,'enUS','Guild Master & Vendor','Guild Master & Vendor',26124),
(32190,'enUS','This instance will reset in 10 minutes.','This instance will reset in 10 minutes.',26124),
(32191,'enUS','This instance will reset in 5 minutes.','This instance will reset in 5 minutes.',26124),
(32192,'enUS','This instance will reset in 3 minutes.','This instance will reset in 3 minutes.',26124),
(32193,'enUS','This instance will reset in 2 minutes.','This instance will reset in 2 minutes.',26124),
(32194,'enUS','This instance will reset in 1 minute.','This instance will reset in 1 minute.',26124),
(32195,'enUS','','Damn it, Olakin, get your arse back here! There\'s work to be done!',26124),
(32196,'enUS','This instance will reset in 30 seconds.','This instance will reset in 30 seconds.',26124),
(32197,'enUS','Battlemasters','Battlemasters',26124),
(32198,'enUS','You will pay for what you\'ve done! For the Argent Crusade!','',26124),
(32199,'enUS','Puny skeleton. My patience is over!','',26124),
(32200,'enUS','I foresee that you will speak with Archmage Lan\'dalock, $n.','',26124),
(32201,'enUS','Dalaran\'s only class trainers are mages. You must take a portal back to one of your capitals for others.$B$BThey can be found in Dalaran\'s Alliance and Horde quarters: the Silver Enclave and the Sunreaver\'s Sancturary.','Dalaran\'s only class trainers are mages. You must take a portal back to one of your capitals for others.$B$BThey can be found in Dalaran\'s Alliance and Horde quarters: the Silver Enclave and the Sunreaver\'s Sancturary.',26124),
(32202,'enUS','Class Trainer','Class Trainer',26124),
(32203,'enUS','There is a black market of sorts in the northeastern portion of the sewers.','There is a black market of sorts in the northeastern portion of the sewers.',26124),
(32204,'enUS','A tunnel leads out to the bottom of the city in the western sewers, just north of the Cantrips and Crows Tavern.$B$BSome of the more adventurous sorts use it to fly in and out of Dalaran.','A tunnel leads out to the bottom of the city in the western sewers, just north of the Cantrips and Crows Tavern.$B$BSome of the more adventurous sorts use it to fly in and out of Dalaran.',26124),
(32205,'enUS','You\'re looking for the Cantrips and Crows Tavern in the western sewers.','You\'re looking for the Cantrips and Crows Tavern in the western sewers.',26124),
(32206,'enUS','There is a goblin-run bank down here, just north of the Cantrips and Crows Tavern in the western sewers.','There is a goblin-run bank down here, just north of the Cantrips and Crows Tavern in the western sewers.',26124),
(32207,'enUS','The Steamwheedle Cartel hosts an entire arena circuit in the central sewers of Dalaran.$B$BYou\'ll find dueling rings there, too, at the Circle of Wills.','The Steamwheedle Cartel hosts an entire arena circuit in the central sewers of Dalaran.$B$BYou\'ll find dueling rings there, too, at the Circle of Wills.',26124),
(32208,'enUS','A ramp leads up to just outside Krasus\' Landing in the eastern sewers.','A ramp leads up to just outside Krasus\' Landing in the eastern sewers.',26124),
(32209,'enUS','A ramp leads up to near the Violet Citadel in the western sewers.','A ramp leads up to near the Violet Citadel in the western sewers.',26124),
(32210,'enUS','There are three ways out of the Underbelly: Ramps leading up to the east and west, and the tunnel that drops out of the bottom of Dalaran.$B$BBe certain you can fly before you take that tunnel, of course.','There are three ways out of the Underbelly: Ramps leading up to the east and west, and the tunnel that drops out of the bottom of Dalaran.$B$BBe certain you can fly before you take that tunnel, of course.',26124),
(32211,'enUS','Sewer Tunnel','Sewer Tunnel',26124),
(32212,'enUS','Welcome to the Underbelly. Something I can help you find?','Welcome to the Underbelly. Something I can help you find?',26124),
(32213,'enUS','The Scourge must be stopped at any cost. We cannot permit them to field the army they\'re constructing here.','',26124),
(32214,'enUS','%s runs to his anvil!','',26124),
(32215,'enUS','Sewer Exits','Sewer Exits',26124),
(32216,'enUS','Vendors','Vendors',26124),
(32217,'enUS','No one throws rocks at me!','',26124),
(32218,'enUS','You wouldn\'t like me when I\'m angry...','',26124),
(32220,'enUS','Finally! An excuse to squash you!','',26124),
(32221,'enUS','You die for good this time, skeleton!','',26124),
(32222,'enUS','Last straw...','',26124),
(32223,'enUS','I was waiting for a reason to tear you bone from bone!','',26124),
(32224,'enUS','That\'s the last mistake you\'ll make, skeleton.','',26124),
(32225,'enUS','Help us! Please!','Help us! Please!',26124),
(32226,'enUS','We\'ve lost Undercity. Nothing but demons and Putress\' apothecaries left there...','We\'ve lost Undercity. Nothing but demons and Putress\' apothecaries left there...',26124),
(32227,'enUS','You must help! We\'re homeless!','You must help! We\'re homeless!',26124),
(32228,'enUS','Could you spare a gold?','Could you spare a gold?',26124),
(32229,'enUS','They killed hundreds! We barely escaped with our lives! Help!','They killed hundreds! We barely escaped with our lives! Help!',26124),
(32230,'enUS','The Dark Lady fought off as many as she could, but in the end... I hope she survived. Please help!','The Dark Lady fought off as many as she could, but in the end... I hope she survived. Please help!',26124),
(32231,'enUS','We Forsaken are doomed! Take pity!','We Forsaken are doomed! Take pity!',26124),
(32232,'enUS','What is going on?\n','What is going on?\n',26124),
(32233,'enUS','What are all these Forsaken doing here?\n','What are all these Forsaken doing here?',26124),
(32234,'enUS','Why is the city under lock down?','Why is the city under lock down?',26124),
(32235,'enUS','We demand answers!','We demand answers!',26124),
(32236,'enUS','Where is the Warchief?','Where is the Warchief?',26124),
(32237,'enUS','When can we reopen our shops? I\'m losing gold here!','When can we reopen our shops? I\'m losing gold here!',26124),
(32238,'enUS','This is an outrage!','This is an outrage!',26124),
(32239,'enUS','Why is Thrall allowing this to happen to our city?','Why is Thrall allowing this to happen to our city?',26124),
(32240,'enUS','SILENCE!','',26124),
(32241,'enUS','We are on the brink of all out war with the Alliance!','',26124),
(32242,'enUS','Tragic events have unfolded in Northrend. The Warchief is doing all that he can to keep us safe.','',26124),
(32243,'enUS','All services and shops are to remain closed until further notice! That is all!','',26124),
(32244,'enUS','','%s looks around Krasus\' Landing, bored.',26124),
(32245,'enUS','','%s yawns quietly into the palm of her hand.',26124),
(32246,'enUS','Mine hit me!','Mine hit me!',26124),
(32247,'enUS','','Come, Cloudwing. Let\'s do a lap.',26124),
(32248,'enUS','Horde Hit!','Horde Hit!',26124),
(32249,'enUS','','%s sighs softly and rolls her shoulders.',26124),
(32250,'enUS','Alliance Hit!','Alliance Hit!',26124),
(32251,'enUS','','I\'m bored, Cloudwing. Go, go!',26124),
(32252,'enUS','','Feeling as restless as I am, Cloudwing? Then let us fly!',26124),
(32253,'enUS','','Our way is sacred.  We will choose death before we abandon Thorim and join the likes of the Lich King.',26124),
(32254,'enUS','For too long I tolerated my brother.  It is time to set things right.  It is time to destroy him and his followers.','',26124),
(32255,'enUS','DISCOVERY!   $n has discovered a new inscription!','DISCOVERY!   $n has discovered a new inscription!',26124),
(32256,'enUS','Please, $r.$b$bRelease me...','Please, $r.$b$bRelease me...',26124),
(32257,'enUS','Don\'t think, $c.$b$bJust... do it....','Don\'t think, $c.$b$bJust... do it....',26124),
(32258,'enUS','Tell my family...$b$bMy last thoughts were of them...','Tell my family...$b$bMy last thoughts were of them...',26124),
(32259,'enUS','Send me on my way... I beg you...','Send me on my way... I beg you...',26124),
(32260,'enUS','Do it, $c...Then... avenge me!','Do it, $c...Then... avenge me!',26124),
(32261,'enUS','Please, $r...$b$bLeave nothing for the Scourge to raise!','Please, $r...$b$bLeave nothing for the Scourge to raise!',26124),
(32262,'enUS','Travel well, hero of the Alliance!','Travel well, hero of the Alliance!',26124),
(32263,'enUS','Heed your blades, Orcs!','Heed your blades, Orcs!',26124),
(32264,'enUS','Prepare for battle, it looks like the Apothecarium already has their Blight aimed at the entrance!','Prepare for battle, it looks like the Apothecarium already has their Blight aimed at the entrance!',26124),
(32265,'enUS','Forward to glory, Orcs!','Forward to glory, Orcs!',26124),
(32266,'enUS','That wretch Putress won\'t get away with this!','That wretch Putress won\'t get away with this!',26124),
(32267,'enUS','How could we not have seen this coming, to think a Dreadlord could be trusted!','How could we not have seen this coming, to think a Dreadlord could be trusted!',26124),
(32268,'enUS','I can hardly believe the Cult was so careless as to leave these behind.','',26124),
(32269,'enUS','I am prepared to join the assault, Keritose. Do you have a skeletal gryphon ready for me?','I am prepared to join the assault, Keritose. Do you have a skeletal gryphon ready for me?',26124),
(32270,'enUS','<Seize control of a Lithe Stalker through the eye.>','<Seize control of a Lithe Stalker through the eye.>',26124),
(32271,'enUS','This kingdom belongs to the Scourge. Only the dead may enter!','',26124),
(32272,'enUS','Hassh tak heeeek ta!','',26124),
(32273,'enUS','You were foolish to come.','',26124),
(32274,'enUS','As Anub\'arak commands!','',26124),
(32275,'enUS','We are besieged! Strike out and bring back their corpses!','',26124),
(32276,'enUS','We must hold the gate. Attack! Tear them limb from limb!','',26124),
(32277,'enUS','The gate must be protected at all costs. Rip them to shreds!','',26124),
(32278,'enUS','Keep an eye on that tunnel. We must not let anyone through!','',26124),
(32279,'enUS','I hear footsteps. Be on your guard.','',26124),
(32280,'enUS','I sense the living. Be ready.','',26124),
(32281,'enUS','They hunger....','',26124),
(32282,'enUS','Dinner time, my pets!','',26124),
(32283,'enUS','I should be grateful... but I long ago lost the capacity....','',26124),
(32284,'enUS','Return to the Weeping Quarry!','',26124),
(32285,'enUS','Arthas\'s weakness is his pride. That weakness only grows as his power does. The Ebon Blade will have its chance to strike at the once-prince - of that I have no doubt.','',26124),
(32286,'enUS','Kor\'kron, stand down!','',26124),
(32287,'enUS','Jaina...','',26124),
(32288,'enUS','','Thrall, what has happened? The King is preparing for war...',26124),
(32289,'enUS','Jaina, what happened at the Wrath Gate. It was a betrayal from within...','',26124),
(32290,'enUS','','Lady Proudmoore, the Warchief speaks the truth. This subterfuge was set in motion by Varimathras and Grand Apothecary Putress. It was not the Horde\'s doing.',26124),
(32291,'enUS','','As the combined Horde and Alliance forces began their assault upon the Wrath Gate, an uprising broke out in the Undercity. Varimathras and hordes of his demonic brethren attacked. Hundreds of my people were slain in the coup. I barely managed to escape with my life.',26124),
(32292,'enUS','The Horde has lost the Undercity.','',26124),
(32293,'enUS','We now prepare to lay siege to the city and bring the perpetrators of this unforgivable crime to justice.','',26124),
(32294,'enUS','If we are forced into a conflict, the Lich King will destroy our divided forces in Northrend.','',26124),
(32295,'enUS','We will make this right, Jaina. Tell your king all that you have learned here.','',26124),
(32296,'enUS','','I will deliver this information to King Wrynn, Thrall, but...',26124),
(32297,'enUS','','Bolvar was like a brother to him. In the King\'s absence, Bolvar kept the Alliance united. He found strength for our people in our darkest hours. He watched over Anduin, raising him as his own. ',26124),
(32298,'enUS','','I fear that the rage will consume him, Thrall. I remain hopeful that reason will prevail, but we must prepare for the worst... for war.',26124),
(32299,'enUS','','Farewell, Warchief. I pray that the next time we meet it will be as allies.',26124),
(32300,'enUS','Kor\'kron, prepare transport to the Undercity.','',26124),
(32301,'enUS','TEXT GOES HERE','',26124),
(32302,'enUS','Take me to page 2.','Take me to page 2.',26124),
(32303,'enUS','','%s spins her web into a cocoon!',26124),
(32304,'enUS','','%s sprays strands of web everywhere!',26124),
(32305,'enUS','','Spiderlings appear on the web!',26124),
(32306,'enUS','%s teleports into the fray!','',26124),
(32307,'enUS','The central gate opens!','',26124),
(32308,'enUS','Eternal agony awaits you!','',26124),
(32309,'enUS','You shall experience my torment first hand!','',26124),
(32310,'enUS','You have made your choice.','',26124),
(32311,'enUS','Soon the master\'s voice will call to you.','',26124),
(32312,'enUS','Auum na-l ak-k-k-k, isshhh.','',26124),
(32313,'enUS','Come forth, my brethren! Feast on their flesh!','',26124),
(32314,'enUS','Your armor is useless against my locusts!','',26124),
(32315,'enUS','Uunak-hissss tik-k-k-k-k!','',26124),
(32316,'enUS','A pestilence upon you!','',26124),
(32317,'enUS','Ahhh... RAAAAAGH! Never thought... I would be free of him....','',26124),
(32318,'enUS','%s sprays slime across the room!','',26124),
(32319,'enUS','%s injects you with a mutagen!','',26124),
(32320,'enUS','How can I help?','',26124),
(32321,'enUS','%s decimates all nearby flesh!','',26124),
(32322,'enUS','','What can I be helping you with?',26124),
(32323,'enUS','Good Morning!','',26124),
(32324,'enUS','The polarity has shifted!','',26124),
(32325,'enUS','','Is there anything you can pay me to do?',26124),
(32326,'enUS','FIRE IN THE HOLE!','FIRE IN THE HOLE!',26124),
(32327,'enUS','This one\'s for Saurfang!','This one\'s for Saurfang!',26124),
(32328,'enUS','BURN IN HELLFIRE!','BURN IN HELLFIRE!',26124),
(32329,'enUS','We\'re taking it back!','We\'re taking it back!',26124),
(32330,'enUS','We\'ll burn it to the ground before giving it to you!','We\'ll burn it to the ground before giving it to you!',26124),
(32331,'enUS','%s teleports to the balcony above!','',26124),
(32332,'enUS','%s teleports and begins to channel a spell!','',26124),
(32333,'enUS','%s rushes to attack once more!','',26124),
(32334,'enUS','An aura of necrotic energy blocks all healing!','',26124),
(32335,'enUS','The aura fades away, allowing healing once more!','',26124),
(32336,'enUS','Good day to you!','',26124),
(32337,'enUS','Retrain me in Cloth Scavenging.','Retrain me in Cloth Scavenging.',26124),
(32338,'enUS','You shouldn\'t have done that!  He\'s not going to like it.','',26124),
(32339,'enUS','HEROES OF THE HORDE, YOUR WARCHIEF CALLS!','',26124),
(32340,'enUS','Blood and thunder, champions of the Horde! We fight on this day for our fallen brothers and sisters! Mourn them not for they all died with honor in their hearts!','',26124),
(32341,'enUS','Though we face great conflict, our might combined shall obliterate those who would oppose us! The grave injustices committed against the Horde will be met by an unstoppable force of reckoning!','',26124),
(32342,'enUS','I call to you great spirits! Grant the Horde your blessing! For on this day our cause is righteous and just!','',26124),
(32343,'enUS','','The air battle rages close, $n.  Both we and the Horde send bombers into the Bombardment and the Valley of Lost Hope.  Will you enter the fray?',26124),
(32344,'enUS','Give me a bomber!','Give me a bomber!',26124),
(32345,'enUS','The hum of magic energy in the air diminishes...','',26124),
(32346,'enUS','Sorta busy.','Sorta busy.',26124),
(32347,'enUS','What? I\'m busy here.','What? I\'m busy here.',26124),
(32348,'enUS','On duty. GO. AWAY.','On duty. GO. AWAY.',26124),
(32350,'enUS','Intruders! Who trespasses in the Old Kingdom?','',26124),
(32351,'enUS','Alright boys, let\'s do this!','',26124),
(32352,'enUS','Nice work! We can only rest a moment.','',26124),
(32353,'enUS','Thanks for keeping us covered back there! We\'ll hold the gate while we wait for reinforcements.','',26124),
(32354,'enUS','','$n\'s exotic fighting technique throws the Drakerider off-balance.',26124),
(32355,'enUS','','What the--?!',26124),
(32356,'enUS','','You fight like a beast!',26124),
(32357,'enUS','','Where did you learn that?',26124),
(32358,'enUS','Are you ready to begin the assault and win back the Undercity for the Horde, $n?','',26124),
(32359,'enUS','I am ready, Warchief.','I am ready, Warchief.',26124),
(32360,'enUS','The elements are with us in force, $n. With their help, we will do all that is in our power to stop Varimathras and Putress! LOK\'TAR OGAR!','',26124),
(32361,'enUS','Gather behind me at the gates of the Undercity! Soon we march upon our fallen city and reclaim it - FOR THE HORDE!','',26124),
(32362,'enUS','Spirits of wind, carry to Saurfang the Younger the song of war! May ALL of our fallen brethren be vindicated by this battle!\n','',26124),
(32363,'enUS','The battle for the Undercity begins now! Sound the horns of war! Champions of the Horde, be empowered by the might of your Warchief!','',26124),
(32364,'enUS','','Oh my gosh! Keep your voice down, $n! What? Are you trying to get us killed?!$B$BOf course I know who you are! Who in the Alliance doesn\'t know the name, $n?!$B$BSay, what do you think of my jumpbot? She\'s based off of the mechagnome design. Sleek and aerodynamic!',26124),
(32365,'enUS','Whoa, whoa, whoa! Keep it down, $n. Keep it down!$B$B<Blast looks around.>$B$BWe don\'t want those frosty vrykul noticing us, now do we?$B$BWhat do you think of my jumpbot? I based it off of the mechagnome. Pretty slick, huh?','',26124),
(32366,'enUS','ONWARD!','',26124),
(32367,'enUS','Great wind brother, clear our path!','',26124),
(32368,'enUS','You must answer to the elements, demon!','',26124),
(32369,'enUS','Great water spirit, wash away this corruption!','',26124),
(32370,'enUS','Return to Ymirheim or your jumpbot will fall to pieces!','',26124),
(32371,'enUS','I\'m ready, Brann. Let\'s make the keystone.','I\'m ready, Brann. Let\'s make the keystone.',26124),
(32372,'enUS','Back to work Cultists!','',26124),
(32373,'enUS','Suited up and ready to go, sir!','',26124),
(32374,'enUS','My men are prepped and ready - just give us the word!','',26124),
(32375,'enUS','Welcome to my kingdom of darkness!','',26124),
(32376,'enUS','Did you enjoy my minion\'s terrible creation? Potent, is it not?','',26124),
(32377,'enUS','We\'re prepped, sir.','',26124),
(32378,'enUS','Let us know when you\'d like us to lead the charge, commander!','',26124),
(32379,'enUS','We\'re ready, commander.','',26124),
(32380,'enUS','Armed and ready.','',26124),
(32381,'enUS','We\'re ready to bring the pain, sir.','',26124),
(32382,'enUS','Just give the order, sir.','',26124),
(32383,'enUS','But enough prattling! You wish to reclaim your city? Come then, heroes! Your souls will fuel the host! You will have this place back in pieces!','',26124),
(32384,'enUS','We don\'t have any easy path before us. If you\'ve got a strong arm on you, stick around until one of my squads is ready to ascend to Ymirheim. They could use all the help they can get.','',26124),
(32385,'enUS','Right. Let\'s see if we can finish this keystone.','',26124),
(32386,'enUS','Welcome, Brann Bronzebeard. I am all that remains of this temple\'s guardian.','',26124),
(32387,'enUS','You have proven yourself as an explorer and seeker of knowledge.','',26124),
(32388,'enUS','You have been a steadfast ally to the Earthen.','',26124),
(32389,'enUS','You and your companion have proven yourselves in combat and in the pursuit of the keystone.','',26124),
(32390,'enUS','Your motives are pure. The keystone\'s parts shall be reunited. Go to Ulduar and learn the answers to your questions, Brann Bronzebeard.','',26124),
(32391,'enUS','The keystone is completed! We\'ve done it, $n!','',26124),
(32392,'enUS','The Assurance has somehow become inundated with bugs and we are unable to set sail to Northrend.','',26124),
(32393,'enUS','Who knows what secrets await within Ulduar\'s archives? I\'m off to discover them. Thank you again for your help, $n. Without it, I\'d still be searching for that key.','',26124),
(32394,'enUS','We were all set to sail into Northrend, but we\'ve noticed a severe number of pests aboard our ship.','',26124),
(32395,'enUS','Before we can set sail to Northrend, we\'ve got to eliminate our pest problem aboard the Assurance.','',26124),
(32396,'enUS','ATTACK!!!!','',26124),
(32397,'enUS','Incoming!','',26124),
(32398,'enUS','Heads up!','',26124),
(32399,'enUS','On your feet, boys!','',26124),
(32400,'enUS','Ambush!','',26124),
(32401,'enUS','Watch out!','',26124),
(32402,'enUS','Find some cover!','',26124),
(32403,'enUS','Group up!','',26124),
(32404,'enUS','Vrykul attack!','',26124),
(32405,'enUS','On your feet, boys! Move, move move!','',26124),
(32406,'enUS','Well you\'re an ugly one! Don\'t mean you don\'t know how to fight though.$B$BOne of my squads should be geared and ready to march soon - get your sorry butt in line and make the climb with them!','',26124),
(32407,'enUS','Incoming!','',26124),
(32408,'enUS','Geared and ready, commander.','',26124),
(32409,'enUS','On the move, men!','',26124),
(32410,'enUS','Quickly, catch your breaths before we press to the gate!','',26124),
(32411,'enUS','On your feet, men! Move, move move!','',26124),
(32412,'enUS','You\'ve got some fight in you! Blood and honor, friend!','',26124),
(32413,'enUS','Ambush!','',26124),
(32414,'enUS','Vrykul!','',26124),
(32415,'enUS','Weapons out!','',26124),
(32416,'enUS','Time for some blood, men!','',26124),
(32417,'enUS','Leave none alive!','',26124),
(32418,'enUS','For the horde!','',26124),
(32419,'enUS','Show no mercy!','',26124),
(32420,'enUS','My men are eager for some blood, commander.','',26124),
(32421,'enUS','We\'re ready for glory, sir.','',26124),
(32422,'enUS','We\'re ready for the push.','',26124),
(32423,'enUS','Geared up and ready to die. What would you have of us, sir?','',26124),
(32424,'enUS','Hell awaits us. Give the order!','',26124),
(32425,'enUS','Ready for a vrykul massacre, just give us the word, sir.','',26124),
(32426,'enUS','On your word, commander.','',26124),
(32427,'enUS','','%s begins to sing.',26124),
(32428,'enUS','Ranked arena matches start again in $6318d.$B$BWould-be champions are already busy honing their skills and acquiring the best gear they can. Are you going to be ready?','Ranked arena matches start again in $6318d.$B$BWould-be champions are already busy honing their skills and acquiring the best gear they can. Are you going to be ready?',26124),
(32429,'enUS','How I can guide your path, young one?','How I can guide your path, young one?',26124),
(32430,'enUS','Guide me to the Fortress Graveyard.','Guide me to the Fortress Graveyard.',26124),
(32431,'enUS','Guide me to the Sunken Ring Graveyard.','Guide me to the Sunken Ring Graveyard.',26124),
(32432,'enUS','Guide me to the Broken Temple Graveyard.','Guide me to the Broken Temple Graveyard.',26124),
(32433,'enUS','Guide me to the Eastspark Graveyard.','Guide me to the Eastspark Graveyard.',26124),
(32434,'enUS','Guide me to the Westspark Graveyard.','Guide me to the Westspark Graveyard.',26124),
(32435,'enUS','Guide me back to the Alliance landing camp. ','Guide me back to the Alliance landing camp. ',26124),
(32436,'enUS','Guide me back to the Horde landing camp. ','Guide me back to the Horde landing camp. ',26124),
(32437,'enUS','YAAAAAAAARGGGGHHHHH!!!!','',26124),
(32438,'enUS','Lives depend on the actions we take here.  Be quick with what you have to say, $c.','',26124),
(32439,'enUS','Do you bring news of battle, $r?','',26124),
(32440,'enUS','The best war is a swift war.  The same can be said of conversation.  What say you $r?','',26124),
(32441,'enUS','','This portal leads to the Caverns of Time, deep beneath the earth in far-off Tanaris.$B$BI possess the power to send you there, should you so desire.',26124),
(32442,'enUS','','This portal leads to the Caverns of Time, deep beneath the earth in far-off Tanaris.$B$BUntil you have grown stronger, though, I must ask you not to travel there.',26124),
(32443,'enUS','','I can smell the gunpowder from all the bombs and rockets!  You want to get out there and join the fun?',26124),
(32444,'enUS','The voices are talking to me.','',26124),
(32445,'enUS','I must obey.','',26124),
(32446,'enUS','You have to get out of here before it gets to you, too!','',26124),
(32447,'enUS','Tell me about the Wispcloak Recipe.','Tell me about the Wispcloak Recipe.',26124),
(32448,'enUS','We\'re almost ready to depart. Just give us a little bit longer to finish our preparations.','',26124),
(32449,'enUS','We\'re still making preparations. We won\'t be ready to go for a while.','',26124),
(32450,'enUS','It\'s all around us. It\'s in my head!','',26124),
(32451,'enUS','My men are ready. Let\'s draw some Vrykul blood!','',26124),
(32452,'enUS','The saronite... there\'s something in it!','',26124),
(32453,'enUS','There\'s something here.  It\'s in the rocks and the earth!','',26124),
(32454,'enUS','In my travels I have learned the recipe for the Wispcloak.$B$BThis cloak is a tradeable Epic spellcasting cloak that grants Stamina, Spellpower, Intellect and Mana Recovery.   I am looking for someone worthy to teach this recipe to.$B$BSomeone who had completed all the normal dungeons of Northrend and had the \"Northrend Dungeonmaster\" achievement would be worthy of learning the recipe for the Wispcloak.','',26124),
(32455,'enUS','I am ready to learn the Wispcloak Recipe.','I am ready to learn the Wispcloak Recipe.',26124),
(32456,'enUS','I have to get out of here! Can you get me free?','',26124),
(32457,'enUS','Can you hear it speaking in your mind?','',26124),
(32458,'enUS','Go on, you\'re free.  Get out of here!','Go on, you\'re free.  Get out of here!',26124),
(32459,'enUS','I\'m ready to join your squad on the way to Ymirheim. Let\'s get moving.','I\'m ready to join your squad on the way to Ymirheim. Let\'s get moving.',26124),
(32460,'enUS','The courtyard is ours! Onward to the inner sanctum!','',26124),
(32461,'enUS','HOLD! They\'ve destroyed the elevator!','',26124),
(32462,'enUS','','The shaft is trapped, Warchief. A fall would mean certain death.',26124),
(32463,'enUS','I have ventured to dark places and learned the tailoring recipe for the Deathchill Cloak.$B$BThis cloak is a tradeable Epic cloak for spellcasters that grants Spellpower, Haste and Critical Strike.   I am looking for someone worthy to teach this recipe to.$B$BSomeone who had completed most of the quests across Northrend and had the \"Loremaster of Northrend\" achievement would be worthy of learning the recipe for the Deathchill Cloak.','',26124),
(32464,'enUS','Tell me about the Deathchill Cloak Recipe.','Tell me about the Deathchill Cloak Recipe.',26124),
(32465,'enUS','DISCOVERY!   $n has discovered a new recipe!','DISCOVERY!   $n has discovered a new recipe!',26124),
(32466,'enUS','I\'m coming, master!','',26124),
(32467,'enUS','My life for you!','',26124),
(32468,'enUS','I am ready to learn the Deathchill Cloak Recipe.','I am ready to learn the Deathchill Cloak Recipe.',26124),
(32469,'enUS','I won\'t leave!','',26124),
(32470,'enUS','NO! You\'re wrong! The voices in my head are beautiful!','',26124),
(32471,'enUS','I don\'t want to leave! I want to stay here!','',26124),
(32472,'enUS','I\'ll never return. The whole reason for my existence awaits below!','',26124),
(32473,'enUS','AHAHAHAHA... you\'ll join us soon enough!','',26124),
(32474,'enUS','I must get further underground to where he is. I must jump!','',26124),
(32475,'enUS','Since you are a tailor of some skill, I can tell you that I know some special recipes.   I know recipes for both the Wispcloak and the Deathchill Cloak.','',26124),
(32476,'enUS','Varimathras has released the Blight aberration!','',26124),
(32477,'enUS','The plague cauldron begins to boil vigorously!','',26124),
(32478,'enUS','Something emerges from the cauldron!','',26124),
(32479,'enUS','Something emerges from the cauldron!','',26124),
(32480,'enUS','Three decent elites!!','',26124),
(32481,'enUS','%s goes Berserk!','',26124),
(32482,'enUS','A SWARM of non-elites!','',26124),
(32483,'enUS','The cauldron continues to boil...','',26124),
(32484,'enUS','Neutralizing agent failing!$bAdd fluid soon!','',26124),
(32486,'enUS','Neutralizing agent failing!$bAdd fluid NOW!!','',26124),
(32487,'enUS','Neutralizing agent FAILED!','',26124),
(32488,'enUS','Plague batch neutralized!','',26124),
(32489,'enUS','','What have they done to my beautiful city!',26124),
(32490,'enUS','Great air spirit, hear my call once more!','',26124),
(32491,'enUS','The spirits of air have heard my call. Cyclones will lower us to safety. Now we jump!','',26124),
(32492,'enUS','Activating Defenses','Activating Defenses',26124),
(32493,'enUS','You! COME! Drink, feast, rest for the next battle.$B$BBut do not fight! Or I will feed you to my wolves.','You! COME! Drink, feast, rest for the next battle.$B$BBut do not fight! Or I will feed you to my wolves.',26124),
(32494,'enUS','We have breached the inner sanctum, heroes! We press on!','',26124),
(32495,'enUS','','The only redemption for the traitors responsible for this will be an agonizing death. My vengeance will be swift and without mercy.',26124),
(32496,'enUS','Lead the way, Dark Lady. We will follow.','',26124),
(32497,'enUS','','Very well, Warchief. The Royal Quarter is this way. Stay on guard. There is no telling what Varimathras and Putress have in store for us.',26124),
(32498,'enUS','','The penalty for treason is death!',26124),
(32499,'enUS','','You dare befoul my sanctum! Pay with your blood!',26124),
(32500,'enUS','','The Horde will be victorious!',26124),
(32501,'enUS','','You will be reunited with your master soon - in the afterlife.',26124),
(32502,'enUS','','You disgust me.',26124),
(32503,'enUS','','The Banshee Queen has plans for you!',26124),
(32504,'enUS','','Beg for your miserable life!',26124),
(32505,'enUS','','ON YOUR KNEES!',26124),
(32506,'enUS','Please, no more.','',26124),
(32507,'enUS','Hit me again and you\'ll regret it!','',26124),
(32508,'enUS','Ow!','',26124),
(32509,'enUS','I\'m sorry. I\'ll work harder.','',26124),
(32510,'enUS','Soon the master will reclaim me!','',26124),
(32511,'enUS','','I\'ll flay the flesh from your bones!',26124),
(32512,'enUS','','Enough crazy talk from you worms. More work!',26124),
(32513,'enUS','','There are no whispers in your mind. You\'re imagining it. Back to work!',26124),
(32514,'enUS','','The Lich King demands more saronite. Work harder fools or we\'ll feed you to the creature!',26124),
(32515,'enUS','','Perhaps cutting your rations in half will be incentive to get you to mine faster?',26124),
(32516,'enUS','Taskmistress, the next slave to stop mining is to be fed to the creature!','',26124),
(32517,'enUS','Intruders in the mines! Deal with them!','',26124),
(32518,'enUS','I see you, little one. Come over here, I wish to speak with you.','',26124),
(32519,'enUS','Do not listen to the creature\'s lies. Get back to your work!','',26124),
(32520,'enUS','','HOLD! I sense dark magic. Demon magic... Stand ready!',26124),
(32521,'enUS','Clever girl...','',26124),
(32522,'enUS','This is my stop!','',26124),
(32523,'enUS','Welcome to the home of the Kirin Tor.','',26124),
(32524,'enUS','My brothers have grown hungry. Your souls will sate their appetites.','',26124),
(32525,'enUS','I have lost my Schools of Arcane Magic - Mastery volume.  Can you provide me with a replacement?','I have lost my Schools of Arcane Magic - Mastery volume.  Can you provide me with a replacement?',26124),
(32526,'enUS','Dropping. Good luck, boys!','',26124),
(32527,'enUS','Thanks for the cover!','',26124),
(32528,'enUS','Destination reached - engaging in scouting mission.','',26124),
(32529,'enUS','Infiltration commencing.','',26124),
(32530,'enUS','Jeronimo!','',26124),
(32531,'enUS','See you on the battlefield.','',26124),
(32532,'enUS','I\'ll kill one just for you.','',26124),
(32533,'enUS','%s makes a strange noise that translates as laughter in your mind.','',26124),
(32534,'enUS','I\'m gonna spill your guts, mon!','',26124),
(32535,'enUS','Ain\'t gonna be nothin\' left after this!','',26124),
(32536,'enUS','You wanna see power? I\'m gonna show you power!','',26124),
(32537,'enUS','Gut them! Impale them!','',26124),
(32538,'enUS','KILL THEM ALL!','',26124),
(32539,'enUS','Say hello to my BIG friend!','',26124),
(32540,'enUS','What a rush!','',26124),
(32541,'enUS','Who needs gods when we ARE gods?','',26124),
(32542,'enUS','I told ya so!','',26124),
(32543,'enUS','Even the mighty... can fall.','',26124),
(32544,'enUS','The air around you crackles as Khanok the Impassable appears!','',26124),
(32545,'enUS','No hope for you!','',26124),
(32546,'enUS','You think you can wrest this rampart from my control?','',26124),
(32547,'enUS','I think not. When I\'ve finished beating the arrogance out of you, I\'ll impale your corpse on the spikes as an example to any other \'heroes\'!','',26124),
(32548,'enUS','Greetings, $c.$B$BWhen the Alliance controls Wintergrasp Fortress, I will open a portal for those who wish to travel there.$B$BThe next battle begins in $4354k.','Greetings, $c.$B$BWhen the Alliance controls Wintergrasp Fortress, I will open a portal for those who wish to travel there.$B$BThe next battle begins in $4354k.',26124),
(32549,'enUS','Teleport me to Lake Wintergrasp.','Teleport me to Lake Wintergrasp.',26124),
(32550,'enUS','Greetings, $c.$B$BWhen the Horde controls Wintergrasp Fortress, I will open a portal for those who wish to travel there.$B$BThe next battle begins in $4354k.','Greetings, $c.$B$BWhen the Horde controls Wintergrasp Fortress, I will open a portal for those who wish to travel there.$B$BThe next battle begins in $4354k.',26124),
(32551,'enUS','Greetings, $c.$B$BThe Alliance now controls Wintergrasp Fortress. Use the portal, if you like.$B$BThe next battle begins in $4354k.','Greetings, $c.$B$BThe Alliance now controls Wintergrasp Fortress. Use the portal, if you like.$B$BThe next battle begins in $4354k.',26124),
(32552,'enUS','Greetings, $c.$B$BThe Horde now controls Wintergrasp Fortress. Use the portal, if you like.$B$BThe next battle begins in $4354k.','Greetings, $c.$B$BThe Horde now controls Wintergrasp Fortress. Use the portal, if you like.$B$BThe next battle begins in $4354k.',26124),
(32553,'enUS','Is that all, demon? Have you nothing left to throw at us?','',26124),
(32554,'enUS','%s begins to open a Twilight Portal!','',26124),
(32556,'enUS','You may only fly in Icecrown, Sholazar Basin and the Storm Peaks.','You may only fly in Icecrown, Sholazar Basin and the Storm Peaks.',26124),
(32557,'enUS','','Adventurers, the door is beginning to weaken!',26124),
(32558,'enUS','','Only half of the door seal\'s strength remains! You must fight on!',26124),
(32559,'enUS','','The door seal is about to collapse! All is lost if the Blue Dragonflight breaks through the door!',26124),
(32560,'enUS','Enough, Michael. Business is hurting enough with this scare as it is. We can use every copper.','',26124),
(32561,'enUS','For the Horde!','',26124),
(32562,'enUS','Greetings, friend.  Something I can do for ya?','',26124),
(32563,'enUS','Hey there, hold on just one second.  I see you\'re not riding a flying mount of your own.$B$BYou probably won\'t be of much use to the other goblins here if you can\'t get around.  They\'ve paid me to loan my used mounts to people such as yourself -- at no cost to you.$B$BInterested?','',26124),
(32564,'enUS','We come for you! Prepare yourself!','',26124),
(32565,'enUS','COWARD! You think to stop the Warchief of the Horde with pebbles? I will show you the true power of the elements!','',26124),
(32566,'enUS','I\'m interested.','I\'m interested.',26124),
(32567,'enUS','','The Royal Quarter is just up ahead, Warchief.',26124),
(32568,'enUS','Bring down the halls! NOW!','',26124),
(32569,'enUS','%s grudgingly nods.','',26124),
(32570,'enUS','I can\'t argue with that.','',26124),
(32571,'enUS','The soldiers are doing important work. The safety of the people is more important, Mal, if you\'re interested in your customers living to spend another day.','',26124),
(32572,'enUS','Don\'t worry too much. By the time I went off duty, we hadn\'t found a scrap of befouled grain here.','',26124),
(32573,'enUS','Thank the Light for that.','',26124),
(32574,'enUS','%s nods.','',26124),
(32575,'enUS','Great spirits of the earth, help us in our hour of need!','',26124),
(32576,'enUS','What kind of help do you require?','What kind of help do you require?',26124),
(32577,'enUS','I\'ve got a lead on Norgannon\'s keystone, which guards access to Ulduar\'s archives, but the Titans divided it into two pieces and secreted them away.$B$BOne of the pieces, the keystone\'s shell, is held within the Inventor\'s Library on the northern coast, south of Ulduar itself. The first thing you\'ll need to do is retrieve the fragments of an access disk from the library\'s guardians.','',26124),
(32578,'enUS','It is time.  May the Light give us strength.','',26124),
(32579,'enUS','A thousand-thousand pardons, Master! I will deal with these intruders myself!','',26124),
(32580,'enUS','Welcome to your future -- what little there is left of it...','',26124),
(32581,'enUS','','When it comes to treasure, never be lookin\' sideways at lootin\' someone else\'s junk. Stolen goods be much sweeter, ya? But free is free, no matta how it got that way!',26124),
(32582,'enUS','Uninvited guests!  Did you think you\'d go unnoticed inside my dominion?','',26124),
(32583,'enUS','LET\'S GO! QUICKLY!','',26124),
(32584,'enUS','What is this?','',26124),
(32585,'enUS','I must confess... you were not altogether unexpected.  I hope you find your final resting place... to your liking.','',26124),
(32586,'enUS','','I always be up for a nice three-finger discount. Stealin\' be all in the wrist... and when that fails ya, then ya stick somethin\' sharp in between the ribs, and that\'s all in the wrist too.$B$BSkilled hands be worth more than a steady paycheck, ya heard?',26124),
(32587,'enUS','','I don\'t be worryin\' \'bout no Lich Kings. Seen a lotta big-shots come and go, dey always messin\' somethin\' up. It ain\'t long aftah that when a posse rolls on through and sends dem quick on dey way to da history books. Dis one ain\'t no different.',26124),
(32588,'enUS','Last time we met, you had the advantage of fighting on holy ground.  You\'ll find that our situation has been... reversed.','',26124),
(32589,'enUS','That might be, but I don\'t need to stand on holy ground to run that disembodied heart of yours with the Ashbringer.','',26124),
(32590,'enUS','The heart... the last remaining vestige of your humanity.  I had to stop it from being destroyed.  I had to see for myself.  And at last I\'m sure...','',26124),
(32592,'enUS','You sound a little too confident.  Especially considering the way our last encounter ended.','',26124),
(32593,'enUS','I call your bluff.  You\'re a paladin after all.  Your obsession with redemption goes beyond the inane.','',26124),
(32594,'enUS','You surely wouldn\'t destroy humanity\'s only chance to redeem its most wayward son.  You\'d sooner die!','',26124),
(32595,'enUS','Only shadows from the past remain.  There\'s nothing left to redeem!','',26124),
(32596,'enUS','Shgla\'yos plahf mh\'naus.','',26124),
(32597,'enUS','They who dine on lost souls know only hunger.','',26124),
(32598,'enUS','Ywaq ma phgwa\'cul hnakf.','',26124),
(32599,'enUS','Uulwi gag erh\'ongg w\'ssh.','',26124),
(32600,'enUS','Ywaq puul skshgn: on\'ma yeh\'glu zuq.','',26124),
(32601,'enUS','Iilth vwah, uhn\'agth fhssh za.','',26124),
(32602,'enUS','Ywaq maq oou; ywaq maq ssaggh. Ywaq ma shg\'fhn.','',26124),
(32603,'enUS','Gul\'kafh an\'shel. Yoq\'al shn ky ywaq nuul.','',26124),
(32604,'enUS','Gaze into the void. It is the perpetuity in which they dwell.','',26124),
(32605,'enUS','They are the whisper on the shivering wind.','',26124),
(32606,'enUS','Their shadow will choke the land for eternity.','',26124),
(32607,'enUS','They drink your fear: it is the blood of life.','',26124),
(32608,'enUS','Where one falls, many shall take its place.','',26124),
(32609,'enUS','They do not die; they do not live. They are outside the cycle.','',26124),
(32610,'enUS','Too long... Tireless, endless planning... It will not end like this...','',26124),
(32611,'enUS','Need more time... The Master is near...','',26124),
(32612,'enUS','Such power! Can you not feel it, mortals? Cease this foolishness and join me!','',26124),
(32613,'enUS','I will not fail! Not again!','',26124),
(32614,'enUS','I cannot hold... Destabilizing...','',26124),
(32615,'enUS','We lost many to the faceless ones, my lord.  But we succeeded in retrieving the heart from Naz\'anak.','We lost many to the faceless ones, my lord.  But we succeeded in retrieving the heart from Naz\'anak.',26124),
(32616,'enUS','Keep your heads down and follow my lead.','',26124),
(32617,'enUS','Years... wasted...','',26124),
(32618,'enUS','YOU HAVE FAILED ME, VARIMATHRAS!','',26124),
(32619,'enUS','Here it comes.  Stand ready.','',26124),
(32620,'enUS','Something\'s wrong... I sense a dark presence.','',26124),
(32621,'enUS','The Lich King is here.  May the Light guide our blades.','',26124),
(32622,'enUS','The prisoner sobs desperately, waiting for the end to come.','The prisoner sobs desperately, waiting for the end to come.',26124),
(32623,'enUS','Only a fool would mock the appearance of my battle-garb.$B$BThis raiment of well-worn steel is from an ancient place of learning!','',26124),
(32624,'enUS','I will not die so quickly this time!','',26124),
(32625,'enUS','','Champions! My children, blessed with my power, shall aid you in your fight!',26124),
(32626,'enUS','','I did what I had to, brother. You gave me no alternative.',26124),
(32627,'enUS','','And so ends the Nexus War. ',26124),
(32628,'enUS','','This resolution pains me deeply, but the destruction, the monumental loss of life had to end. Regardless of Malygos\' recent transgressions, I will mourn his loss. He was once a guardian, a protector. This day, one of the world\'s mightiest has fallen.',26124),
(32629,'enUS','','The red dragonflight will take on the burden of mending the devastation wrought on Azeroth. Return home to your people and rest. Tomorrow will bring you new challenges, and you must be ready to face them. Life... goes on.',26124),
(32630,'enUS','What?!','What?!',26124),
(32631,'enUS','Wait a minute, I didn\'t activate my...?','Wait a minute, I didn\'t activate my...?',26124),
(32632,'enUS','I feel funny all of a sudden.  Er?!','I feel funny all of a sudden.  Er?!',26124),
(32633,'enUS','Okay, who\'s the joker that threw an orb at me?','Okay, who\'s the joker that threw an orb at me?',26124),
(32634,'enUS','NOOOOOO!','NOOOOOO!',26124),
(32635,'enUS','Not a sentry!','Not a sentry!',26124),
(32636,'enUS','You\'ve got it all wrong. I\'m a subjugator!','You\'ve got it all wrong. I\'m a subjugator!',26124),
(32637,'enUS','It was an accident. I was framed. Don\'t drop me!','It was an accident. I was framed. Don\'t drop me!',26124),
(32638,'enUS','casually flips his |Hitem:44430|h|cff0070dd[Titanium Seal of Dalaran]|r|h.','casually flips her |Hitem:44430|h|cff0070dd[Titanium Seal of Dalaran]|r|h.',26124),
(32639,'enUS','How dare you interfere with our work!','',26124),
(32640,'enUS','Insignificant.','',26124),
(32641,'enUS','Your timeline is no more!','',26124),
(32642,'enUS','My time... has run out...','',26124),
(32643,'enUS','WE ARE VICTORIOUS!','',26124),
(32644,'enUS','The Undercity belongs to the Horde once more! LOK\'TAR!','',26124),
(32645,'enUS','You have my thanks for saving my existence in this timeline. Now I must report back to my superiors. They must know immediately of what I just experienced.','',26124),
(32646,'enUS','Dark Lady, join me! You have fought hard and spilled much blood for this right. The Royal Quarter belongs to you!','',26124),
(32647,'enUS','','Such will be the fate of all enemies of the Horde, Warchief.  Now we must deal with the wretch, Putress.',26124),
(32648,'enUS','We shall, Sylvanas...','',26124),
(32649,'enUS','Alliance horns? Stay on guard!','',26124),
(32650,'enUS','You\'ll find what you are looking for at One More Glass in northern Dalaran.','You\'ll find what you are looking for at One More Glass in northern Dalaran.',26124),
(32651,'enUS','The Militant Mystic in southern Dalaran should have what you desire.','The Militant Mystic in southern Dalaran should have what you desire.',26124),
(32652,'enUS','The Hunter\'s Reach in eastern Dalaran sells guns, bows, ammunition and the like.','The Hunter\'s Reach in eastern Dalaran sells guns, bows, ammunition and the like.',26124),
(32653,'enUS','The Arsenal Absolute in southeast Dalaran carries all manner of melee weapons.','The Arsenal Absolute in southeast Dalaran carries all manner of melee weapons.',26124),
(32654,'enUS','If I am ever freed of these chains, I will return one day and slay you myself.','',26124),
(32655,'enUS','This will be nothing when compared to the satisfaction I will feel when I crush your skull beneath my heel.','',26124),
(32656,'enUS','Jepetto Joybuzz\'s Wonderworks in western Dalaran carries such items.','Jepetto Joybuzz\' Wonderworks in western Dalaran carries such items.',26124),
(32657,'enUS','I\'d sooner serve the Dark Lord Alexander than be your pitiful pet.','',26124),
(32658,'enUS','I hear your kind squeals like a felhunter when roasted alive over a fire.','',26124),
(32659,'enUS','You have delved too far into our magics. I will claim your soul myself!','',26124),
(32660,'enUS','I play all of my records backwards. Except for the ones by Arrowsmite and Sons.','',26124),
(32661,'enUS','The Twisting Nether\'s coldest reaches shall not hide you from my vengeance.','',26124),
(32662,'enUS','I serve only Sargeras! You shall join him too someday, mortal...','',26124),
(32663,'enUS','catches the coin heads up!','catches the coin heads up!',26124),
(32664,'enUS','finds the coin face down for tails!','finds the coin face down for tails!',26124),
(32665,'enUS','Red at Glorious Goods in southeast Dalaran can provide most general trade supplies.$B$BIf you need something more specialized, try the Magus Commerce Exchange. Each trade shop there has its own supply vendor.','Red at Glorious Goods in southeast Dalaran can provide most general trade supplies.$B$BIf you need something more specialized, try the Magus Commerce Exchange. Each trade shop there has its own supply vendor.',26124),
(32666,'enUS','The process is finally complete! My work here is done.','',26124),
(32667,'enUS','Aimee\'s cart can usually be found in northern Dalaran, near the Bank of Dalaran.','Aimee\'s cart can usually be found in northern Dalaran, near the Bank of Dalaran.',26124),
(32668,'enUS','The Magical Menagerie is located in northeast Dalaran. Pet supplies, exotic mounts, and stables are all available there.','The Magical Menagerie is located in northeast Dalaran. Pet supplies, exotic mounts, and stables are all available there.',26124),
(32669,'enUS','You\'ll find reagants and more at the Sisters Sorcerous in western Dalaran.$B$BJust mind the Mooreheads\' black cat...','You\'ll find reagants and more at the Sisters Sorcerous in western Dalaran.$B$BJust mind the Mooreheads\' black cat...',26124),
(32670,'enUS','','Oh, no! Adventurers, something awful has happened! A colleague of mine has been captured by the Infinite Dragonflight, and they\'re doing something horrible to him!$B$BKeeping Arthas is still your highest priority, but if you act fast you could help save a Guardian of Time!',26124),
(32671,'enUS','Glorious Goods in southern Dalaran should have all the general goods you need.','Glorious Goods in southern Dalaran should have all the general goods you need.',26124),
(32672,'enUS','Applebough\'s fruit cart is usually in southwest Dalaran, near the Silver Enclave.','Applebough\'s fruit cart is usually in southwest Dalaran, near the Silver Enclave.',26124),
(32673,'enUS','You can normally find Miss Primrose\'s flower stand in southeast Dalaran.','You can normally find Miss Primrose\'s flower stand in southeast Dalaran.',26124),
(32674,'enUS','Adventurers may be rewarded for their just deeds in the Silver Enclave or Sunreaver\'s Sanctuary.','Adventurers may be rewarded for their just deeds in the Silver Enclave or Sunreaver\'s Sanctuary.',26124),
(32675,'enUS','Tanks for Everything in northern Dalaran is the city\'s most popular plate armor and shield merchant.','Tanks for Everything in northern Dalaran is the city\'s most popular plate armor and shield merchant.',26124),
(32676,'enUS','The various merchants of Curiosities & Moore in southern Dalaran sell trinkets, relics, heirlooms, and off-hand items of all sorts.','The various merchants of Curiosities & Moore in southern Dalaran sell trinkets, relics, heirlooms, and off-hand items of all sorts.',26124),
(32677,'enUS','Langrom\'s Leather & Links in southern Dalaran should have what you seek.','Langrom\'s Leather & Links in southern Dalaran should have what you seek.',26124),
(32678,'enUS','','Adventurers, you must hurry! The Guardian of Time cannot last for much longer!',26124),
(32679,'enUS','','I can barely sense the Guardian of Time! His timeline is fading quickly!',26124),
(32680,'enUS','The Threads of Fate in western Dalaran is the city\'s most popular supplier of clothing and cloth armor.','The Threads of Fate in western Dalaran is the city\'s most popular supplier of clothing and cloth armor.',26124),
(32681,'enUS','What sort of weapons?','What sort of weapons?',26124),
(32682,'enUS','Melee Weapons','Melee Weapons',26124),
(32683,'enUS','Ranged & Thrown Weapons','Ranged & Thrown Weapons',26124),
(32684,'enUS','Staves & Wands','Staves & Wands',26124),
(32685,'enUS','What sort of armor?','What sort of armor?',26124),
(32686,'enUS','Cloth Armor','Cloth Armor',26124),
(32687,'enUS','Tirion\'s down!  Defend him with your lives!','Tirion\'s down!  Defend him with your lives!',26124),
(32688,'enUS','Leather Armor','Leather Armor',26124),
(32689,'enUS','Mail Armor','Mail Armor',26124),
(32690,'enUS','Plate Armor','Plate Armor',26124),
(32691,'enUS','I was away for too long. My absence cost us the lives of some of our greatest heroes. Trash like you and this evil witch were allowed to roam free -- unchecked.','',26124),
(32692,'enUS','Shields','Shields',26124),
(32693,'enUS','The time has come to make things right. To disband your treacherous kingdom of murderers and thieves. Putress was the first strike. Many more will come.','',26124),
(32694,'enUS','Arrrrggggggggggh!!!!','',26124),
(32695,'enUS','Come to make yourself useful?','',26124),
(32696,'enUS','Come to make yourself useful?','',26124),
(32697,'enUS','I\'ve waited a long time for this, Thrall. For every time I was thrown into one of your damned arenas... for every time I killed a green-skinned aberration like you... I could think of only one thing.','',26124),
(32698,'enUS','You... will pay for that, old man.  Slay them all!','',26124),
(32699,'enUS','What our world could be without you and your twisted Horde... It ends now, Warchief.','',26124),
(32700,'enUS','ATTACK! FOR STORMWIND! FOR BOLVAR! FOR THE ALLIANCE!','',26124),
(32701,'enUS','Which vendor where you seeking?','Which vendor where you seeking?',26124),
(32702,'enUS','Armor','Armor',26124),
(32703,'enUS','Clothing','Clothing',26124),
(32704,'enUS','Justice Quartermasters','Justice Quartermasters',26124),
(32705,'enUS','Flowers','Flowers',26124),
(32706,'enUS','Fruit','Fruit',26124),
(32707,'enUS','Quick, through the portal!  He won\'t stay down for long.','',26124),
(32708,'enUS','Take courage, crusaders.  You do not fight alone!','',26124),
(32709,'enUS','','VARIAN, NO! STOP!',26124),
(32710,'enUS','I hope you fellows don\'t mind if we crash this party.  I brought some old friends with me!','',26124),
(32711,'enUS','','It did not have to be like this...',26124),
(32712,'enUS','General Goods','General Goods',26124),
(32713,'enUS','Jewelry','Jewelry',26124),
(32715,'enUS','Pet Supplies & Exotic Mounts','Pet Supplies & Exotic Mounts',26124),
(32716,'enUS','Pie, Pastry & Cakes','Pie, Pastry & Cakes',26124),
(32717,'enUS','Reagents & Magical Goods','Reagents & Magical Goods',26124),
(32718,'enUS','Toys','Toys',26124),
(32719,'enUS','Trade Supplies','Trade Supplies',26124),
(32720,'enUS','Trinkets, Relics & Off-hand Items','Trinkets, Relics & Off-hand Items',26124),
(32721,'enUS','Weapons','Weapons',26124),
(32722,'enUS','Looks like whatever Tirion did put some hurt on the Lich King.  It\'s too bad we can\'t finish him off.... ','',26124),
(32723,'enUS','Wine & Cheese','Wine & Cheese',26124),
(32724,'enUS','Vendors','Vendors',26124),
(32725,'enUS','The Lich King is badly hurt.  We ought to stay behind and finish him.','',26124),
(32726,'enUS','Patience... we will get our chance soon enough.  Be content that for once, it is Tirion who is in our debt.','',26124),
(32727,'enUS','The secret to goblin engineering has nothing to do with keeping things from exploding. It has everything to do with directing the explosions exactly where you want them.','',26124),
(32728,'enUS','It ends like it began...','',26124),
(32729,'enUS','All that we have fought for in this world is lost. The hopes and dreams carried by my father and mother... by Doomhammer... Gone...','',26124),
(32730,'enUS','If only you were here right now, old friend. You would know what to do.','',26124),
(32731,'enUS','I know what he would do.','',26124),
(32732,'enUS','He would say to you: Thrall. Lead your people.','',26124),
(32733,'enUS','Let\'s go home, old friend.','',26124),
(32734,'enUS','%s nods.','',26124),
(32735,'enUS','It\'s good to have you back, Varok, old friend. I\'m sorry about your boy.','',26124),
(32736,'enUS','%s joins in and grabs a bite to eat.','',26124),
(32737,'enUS','I am Xarantaur, the Witness.','',26124),
(32738,'enUS','Would you like to hear a story?','',26124),
(32739,'enUS','Do you have a story for me?','',26124),
(32740,'enUS','Ah yes, I have read of you, $n.','',26124),
(32741,'enUS','Tell me of yourself, Xarantaur. Why are you called the Witness?','Tell me of yourself, Xarantaur. Why are you called the Witness?',26124),
(32742,'enUS','I was one of the first tauren druids, of the last generation taught by Shan\'do Cenarius, before the Legion, before the Sundering, when the world was still young. Before everything changed.$B$BWhile my brethren hunted great beasts, I hunted stories. I had been drawn to the druidic arts by this hunger, this lust for knowledge. For a time, that hunger was sated as I learned to talk to the trees, rocks, and beasts, and heard their stories.$B$BBut then, the time came when Cenarius walked among us no more and my brethren began to forget what he had taught us. I could not forget, though, and I still needed to learn more about our world.$B$BSo I said my farewells and travelled beyond the lands of my people.','',26124),
(32743,'enUS','Please, go on.','Please, go on.',26124),
(32744,'enUS','I wandered for the rest of my natural life in search of knowledge, seeing more wonder and meeting more strange and mysterious races than any of my people before me. I travelled across the length and breadth of ancient Kalimdor until there was no more to see, no new lands across the horizon.$B$BYet... there was still so much I did not know as I felt my final journey approaching and I wept for the things I would never know.$B$BAs I fell, my life at an end, that is when they found me.','',26124),
(32745,'enUS','They?','They?',26124),
(32746,'enUS','The bronze dragonflight. They snatched me from the brink of death and took me before their master, Nozdormu. He said they had been watching me and wanted me to continue my hunt. He granted me immortality as a watcher, tasked to bear witness to the history of Azeroth as one of his agents.$B$BI am Xarantaur the Witness, and it is my duty to preserve the true history of Azeroth lest it be forgotten.','',26124),
(32747,'enUS','This is Camp Tunka\'lo, the village ruled by my brother, but I... I don\'t remember you.','',26124),
(32748,'enUS','And it very nearly didn\'t remember you. $n fought bravely against the North Wind to protect your story.','',26124),
(32749,'enUS','The North Wind? It still troubles my people?','',26124),
(32750,'enUS','Your battle with the wind was hundreds of years ago, Stormhoof. You weakened it so much that it has been silent all these years.','',26124),
(32751,'enUS','But the North Wind did not silently accept defeat. Instead, it gathered power and bided its time, deciding the best revenge was to destroy your memory, and with it, your village.','',26124),
(32752,'enUS','The wind used its minions to distort the history of this place, changing the stories your people told, destroying the spirits of the honored dead.','',26124),
(32753,'enUS','Khit\'rix the Dark Master skitters into Valhalas from the southeast!','',26124),
(32754,'enUS','It would\'ve succeeded if $n and I hadn\'t tracked the North Wind\'s historical corruptions to their source: your ancient battle.','',26124),
(32755,'enUS','With my help, $n travelled back in time to your battle, and ensured that history was set right. The North Wind\'s fate was sealed, and your story restored.','',26124),
(32756,'enUS','You both have my thanks and that of the village, though many will never know of your deeds.','',26124),
(32757,'enUS','Circling Valhalas, Sigrid Iceborn approaches to seek her revenge!','',26124),
(32758,'enUS','Lumbering in from the south, the smell of Carnage precedes him!','',26124),
(32759,'enUS','I cannot remain here. I must return to my cairn where I belong, but when I see the ancestors again, it is I who will tell your story.','',26124),
(32760,'enUS','Thane Banahogg appears upon the overlook to the southeast!','',26124),
(32761,'enUS','Without warning, Prince Sandoval magically appears within Valhalas!','',26124),
(32762,'enUS','Rest well, hero.','',26124),
(32763,'enUS','%s swipes at you with his claws!','',26124),
(32764,'enUS','Whoa! You\'re me, but from the future!  Hey, my equipment got an upgrade.  Cool!','Whoa! You\'re me, but from the future!  Hey, my equipment got an upgrade.  Cool!',26124),
(32765,'enUS','','Only time will tell...',26124),
(32766,'enUS','Alexstrasza, can you show me what happened here?','Alexstrasza, can you show me what happened here?',26124),
(32767,'enUS','Welcome to the Wonderworks!$B$BPlease take your time and browse the shop. We have wonderful toys for people young and old!','',26124),
(32768,'enUS','I have lost my Titanium Seal of Dalaran.  Can you provide me with a replacement?','I have lost my Titanium Seal of Dalaran.  Can you provide me with a replacement?',26124),
(32769,'enUS','Here come the Infinites!  I\'ve got to keep the hourglass safe.  Can you help?','Here come the Infinites!  I\'ve got to keep the hourglass safe.  Can you help?',26124),
(32770,'enUS','This equipment looks cool and all, but couldn\'t we have done a little better?  Are you even raiding?','This equipment looks cool and all, but couldn\'t we have done a little better?  Are you even raiding?',26124),
(32771,'enUS','So, how does it all turn out in Icecrown?','So, how does it all turn out in Icecrown?',26124),
(32772,'enUS','Chromie said that if I don\'t do this just right, I might wink out of existence.  If I go, then you go!','Chromie said that if I don\'t do this just right, I might wink out of existence.  If I go, then you go!',26124),
(32773,'enUS','Looks like I\'m an underachiever.','Looks like I\'m an underachiever.',26124),
(32774,'enUS','I think I\'m going to turn to drinking after this.','I think I\'m going to turn to drinking after this.',26124),
(32775,'enUS','It might help if you could tell me how many of these guys we\'re going to fight.  You can remember that, right, grandpa?','It might help if you could tell me how many of these guys we\'re going to fight.  You can remember that, right, grandma?',26124),
(32776,'enUS','I just want you to know that if we get through this alive, I\'m making sure that we turn out better than you.  No offense.','I just want you to know that if we get through this alive, I\'m making sure that we turn out better than you.  No offense.',26124),
(32777,'enUS','Wait a minute!  If you\'re here, then that means that in the not-so-distant future I\'m going to be you helping me?  Are we stuck in a time loop?!','Wait a minute!  If you\'re here, then that means that in the not-so-distant future I\'m going to be you helping me?  Are we stuck in a time loop?!',26124),
(32778,'enUS','How may I help you?','How may I help you?',26124),
(32779,'enUS','How may I help you?','How may I help you?',26124),
(32780,'enUS','How may I help you?','How may I help you?',26124),
(32781,'enUS','What the heck?  Nozdormu is up there!','What the heck?  Nozdormu is up there!',26124),
(32782,'enUS','I feel like I\'m being pulled away through time.  Thanks for the help....','I feel like I\'m being pulled away through time.  Thanks for the help....',26124),
(32783,'enUS','Sorry, I couldn\'t hold out.  I hope this doesn\'t mean that you\'re about to cease to exist....','Sorry, I couldn\'t hold out.  I hope this doesn\'t mean that you\'re about to cease to exist....',26124),
(32784,'enUS','Your Grip is Failing!','',26124),
(32785,'enUS','Who dares awaken me before the quickening?!','',26124),
(32786,'enUS','You are no match for me!','',26124),
(32787,'enUS','You should not have interfered...','',26124),
(32788,'enUS','My destiny is to serve the Lich King!','',26124),
(32789,'enUS','I shall not be stopped!','',26124),
(32790,'enUS','Put down your arms fools... you are too late!','',26124),
(32791,'enUS','Come, join my minions. Serve me as I serve the Lich King!','',26124),
(32792,'enUS','Too soon... too sooon....','',26124),
(32793,'enUS','Fools! Do not allow my rest to be interrupted again!','',26124),
(32794,'enUS','DODGED!','',26124),
(32795,'enUS','FATAL STRIKE MISSED! KEEP PRYING!','',26124),
(32796,'enUS','Corpse Scarabs appear from a Crypt Guard\'s corpse!','',26124),
(32797,'enUS','','We must avoid another war with the Horde at all costs!',26124),
(32798,'enUS','Lady Proudmoore, I am ready to go to Orgrimmar. Please open a portal.','Lady Proudmoore, I am ready to go to Orgrimmar. Please open a portal.',26124),
(32799,'enUS','','Do not do anything that would incite the Horde, $n. The Warchief has agreed to see us on good faith.',26124),
(32800,'enUS','','Let\'s go.',26124),
(32801,'enUS','Sapphiron lifts off into the air!','',26124),
(32802,'enUS','Sapphiron resumes his attacks!','',26124),
(32803,'enUS','Kel\'Thuzad strikes!','',26124),
(32804,'enUS','A Guardian of Icecrown enters the fight!','',26124),
(32805,'enUS','The aura\'s power begins to wane!','',26124),
(32806,'enUS','This vehicle looks like it\'s seen better days.','',26124),
(32807,'enUS','Welcome!','Welcome!',26124),
(32808,'enUS','Greetings, $c.','Greetings, $c.',26124),
(32809,'enUS','Greetings! Please have a look around.','Greetings! Please have a look around.',26124),
(32810,'enUS','Let me know if you need help finding anything, $c.','Let me know if you need help finding anything, $c.',26124),
(32811,'enUS','Welcome. May I help you find something?','Welcome. May I help you find something?',26124),
(32812,'enUS','Got somethin\' that needs tightening, $r?','',26124),
(32813,'enUS','%s shrieks in pain and twists around, grabbing you with his mouth!','',26124),
(32814,'enUS','The battle for control of Wintergrasp will begin in 1 hour!','',26124),
(32815,'enUS','The battle for control of Wintergrasp will begin in 1 hour!','',26124),
(32816,'enUS','For Bolvar! For the Alliance!','',26124),
(32817,'enUS','The battle for control of Wintergrasp will begin in 15 minutes!','',26124),
(32818,'enUS','The battle for control of Wintergrasp will begin in 5 minutes!  Prepare yourselves for batlle!','',26124),
(32819,'enUS','','We\'ve lost a few good people up here already. I\'m beginning to doubt that this place is worth our attention.',26124),
(32820,'enUS','','Greetings, my $r friend. You honor me with your presence.$B$BHow may I help you?',26124),
(32821,'enUS','','That\'s tiring... but fun.',26124),
(32822,'enUS','Return to the First Legion Forward Camp.','',26124),
(32823,'enUS','You\'ve come to address the men, sir?','',26124),
(32824,'enUS','It is good to see you among us again, $n.','It is good to see you among us again, $n.',26124),
(32825,'enUS','Welcome $n, dragonfriend.','Welcome $n, dragonfriend.',26124),
(32826,'enUS','It is an honor to have you among us, $n.','It is an honor to have you among us, $n.',26124),
(32827,'enUS','Take your much deserved rest in the peace of the temple, $n.','Take your much deserved rest in the peace of the temple, $n.',26124),
(32828,'enUS','Koltira... this might sound strange, but I keep seeing some kid\'s ghost.  Matthias Lehner... does the name mean anything to you?','Koltira... this might sound strange, but I keep seeing some kid\'s ghost.  Matthias Lehner... does the name mean anything to you?',26124),
(32829,'enUS','Stand ready, $n. We attack when all of our forces have arrived!','',26124),
(32830,'enUS','All this fighting is finally getting to you, $n.  Do not worry, I will not divulge your little secret -- lest the others think you\'re mad.$B$BGet some rest.  It\'ll do you good.','',26124),
(32831,'enUS','The battle for control of Wintergrasp will begin in 15 minutes!','',26124),
(32832,'enUS','Oh great Queen of the Dragons, I have somehow misplaced my Key to the Focusing Iris. Can you find it for me?','Oh great Queen of the Dragons, I have somehow misplaced my Key to the Focusing Iris. Can you find it for me?',26124),
(32833,'enUS','The battle for control of Wintergrasp will begin in 5 minutes!','',26124),
(32834,'enUS','Reporting for duty, your majesty! Let the assault begin!','Reporting for duty, your majesty! Let the assault begin!',26124),
(32836,'enUS','Oh great Queen of the Dragons, I have somehow misplaced my Heroic Key to the Focusing Iris. Can you find it for me?','Oh great Queen of the Dragons, I have somehow misplaced my Heroic Key to the Focusing Iris. Can you find it for me?',26124),
(32837,'enUS','The final battle will begin soon, $n. Stand at attention!','',26124),
(32838,'enUS','Reinforcements are needed on the Wintergrasp battlefield!  I have opened a portal for quick travel to the battle at The Silver Enclave.','',26124),
(32839,'enUS','','Yes, of course, but please be more careful in the future.',26124),
(32840,'enUS','Reinforcements are needed on the Wintergrasp battlefield!  I have opened a portal for quick travel to the battle at Sunreaver\'s Sanctuary.','',26124),
(32841,'enUS','We are victorious on the Wintergrasp battlefield!  The fortress is ours!  ','',26124),
(32842,'enUS','We are victorious on the Wintergrasp battlefield!  The fortress is ours!  ','',26124),
(32843,'enUS','Heroes of the Alliance, your King calls! Gather behind me at the entrance to the sewers!','',26124),
(32844,'enUS','Soon we will march upon this cursed place and cleanse it of its evil!','',26124),
(32845,'enUS','The Focusing Iris thrums, holding back an inconceivable amount of restrained power!','',26124),
(32846,'enUS','Use the key to open the Focusing Iris.','Use the key to open the Focusing Iris.',26124),
(32847,'enUS','The hour of redemption is close at hand! Prepare yourselves!','',26124),
(32848,'enUS','Take care and be safe, mortal; you are a valuable ally we do not wish to lose.','Take care and be safe, mortal; you are a valuable ally we do not wish to lose.',26124),
(32849,'enUS','The march upon the Undercity begins now! Be empowered by your King\'s strength! Follow me, heroes! FOR THE GLORY OF THE ALLIANCE!','',26124),
(32850,'enUS','Be safe, $n.','Be safe, $n.',26124),
(32851,'enUS','We will guard this place, $n, and hope for your safe return.','We will guard this place, $n, and hope for your safe return.',26124),
(32852,'enUS','Be careful with yourself, $n. I might actually hesitate for an instant if I saw your undead husk on the field.','Be careful with yourself, $n. I might actually hesitate for an instant if I saw your undead husk on the field.',26124),
(32853,'enUS','Stay alive, $n.','Stay alive, $n.',26124),
(32854,'enUS','$n, your strength is inspiring.','$n, your strength is inspiring.',26124),
(32855,'enUS','Avoid becoming plagued, $n. You deserve better.','Avoid becoming plagued, $n. You deserve better.',26124),
(32856,'enUS','Onward, brothers and sisters! Destiny awaits!','',26124),
(32857,'enUS','Good to see you still breathe, $n.','Good to see you still breathe, $n.',26124),
(32858,'enUS','Our descent into the depths of depravity begins! Be on guard! Jaina, lend us your strength!','',26124),
(32859,'enUS','What is this?! Stand your ground! Don\'t give them an inch!','',26124),
(32860,'enUS','$n is here!','$n is here!',26124),
(32861,'enUS','We\'re relieved to see you whole, $n.','We\'re relieved to see you whole, $n.',26124),
(32862,'enUS','You\'ve done the Crusade proud, $n!','You\'ve done the Crusade proud, $n!',26124),
(32863,'enUS','$n! Still fighting the good fight?','$n! Still fighting the good fight?',26124),
(32864,'enUS','You\'re integral to our operation here, $n.','You\'re integral to our operation here, $n.',26124),
(32865,'enUS','','Right away, your majesty!',26124),
(32866,'enUS','There goes the finest $c I have the honor of knowing.','There goes the finest $c I have the honor of knowing.',26124),
(32867,'enUS','$n, you\'re an inspiration.','$n, you\'re an inspiration.',26124),
(32868,'enUS','A fine example of a $g man:woman;, that $n.','A fine example of a $g man:woman;, that $n.',26124),
(32869,'enUS','You couldn\'t ask for a finer person than $n, I say.','You couldn\'t ask for a finer person than $n, I say.',26124),
(32870,'enUS','$n, wonderful to see you. Wonderful.','$n, wonderful to see you. Wonderful.',26124),
(32871,'enUS','$n! Ah, fantastic to see you out and about. Busy as always, hm?','$n! Ah, fantastic to see you out and about. Busy as always, hm?',26124),
(32872,'enUS','You are welcome here, friend and ally of the Dragonflights. Take your rest here in our halls.','',26124),
(32873,'enUS','Ah, it\'s you, $n! Welcome into our sanctuary. Rest and refresh yourself; you have more than earned it.','',26124),
(32874,'enUS','Rise, Sindragosa!  Rise and lead the Frostbrood into war!','',26124),
(32875,'enUS','Underbelly Croc stares at you hungrily as he licks his chops.','Underbelly Croc stares at you hungrily as he licks his chops.',26124),
(32877,'enUS','Look at us, elf. Look at us. Unemployed, destitute, and drinking swill from an establishment in the sewers named after a carrion bird!','',26124),
(32878,'enUS','Disgusting, I agree.','',26124),
(32879,'enUS','And above it all, I somehow find myself saddled with you, the very man who caused me to lose my job in the first place!','',26124),
(32880,'enUS','That was your doing, not mine, windbag. I found myself unemployed due to my unfortunate association with your failure.','',26124),
(32881,'enUS','My failure?! MY FAILURE?! It was your incompetence that landed us here, you insufferable prat!','',26124),
(32882,'enUS','%s rolls his eyes.','',26124),
(32883,'enUS','Come off it, Jadaar. That\'s all I\'ve heard out of you for months. No matter what happened, the point is we\'re free agents now! No longer tied to politics or duties, able to roam where we will!','',26124),
(32884,'enUS','Penniless and away from what we know in the middle of the frozen, undead-infested northland.','',26124),
(32885,'enUS','Perhaps, but with the opportunity to make names for ourselves! Think of the reception you\'d have in Shattrath as the savior of Azeroth, slayer of the Scourge!','',26124),
(32886,'enUS','Eh.. perhaps, after another drink.','',26124),
(32887,'enUS','Remind me again why I tolerate your company, Asric.','',26124),
(32888,'enUS','%s smirks wryly.','',26124),
(32889,'enUS','I have decades of practice handling blowhards like yourself, and I\'m the only one you know here in this abominably freezing land.','',26124),
(32890,'enUS','I am ready to head further into Storm Peaks.','I am ready to head further into Storm Peaks.',26124),
(32891,'enUS','I should leave you to rot in this sewer with the filth.','',26124),
(32892,'enUS','No doubt.','',26124),
(32893,'enUS','Merely being in your presence is an affront to my beliefs.','',26124),
(32894,'enUS','Oh, of course.','',26124),
(32895,'enUS','You are beneath me.','',26124),
(32896,'enUS','A lowly worm, I\'m sure.','',26124),
(32897,'enUS','Snake.','',26124),
(32898,'enUS','Snake, then, if you prefer.','',26124),
(32899,'enUS','Stop agreeing with me!','',26124),
(32900,'enUS','You\'re right, of course, it\'s a terrible practice.','',26124),
(32901,'enUS','AGH!','',26124),
(32902,'enUS','Arrogant.','',26124),
(32903,'enUS','Braggart.','',26124),
(32904,'enUS','Craven.','',26124),
(32905,'enUS','Craven?! I am most certainly not! Are we not in the middle of a war z... ah.','',26124),
(32906,'enUS','%s holds up a finger.','',26124),
(32907,'enUS','What were we on?  \'D\'?','',26124),
(32908,'enUS','%s nods.','',26124),
(32909,'enUS','Dolt.','',26124),
(32910,'enUS','$n, we must speak when the queen is done with you.','',26124),
(32911,'enUS','','It is done. You may now open the focusing iris.',26124),
(32912,'enUS','Prepare to die!','',26124),
(32913,'enUS','I.am.a.robot.','',26124),
(32914,'enUS','Mulfunction.  Error Code: .- .- .-','',26124),
(32915,'enUS','<The queen\'s consort nods in acknowledgment of your presence.>','',26124),
(32916,'enUS','','Your orders have been revoked until further notice.  Cool your jets and try to be more careful out there!',26124),
(32917,'enUS','','You\'ve taken a lot of bombers out and don\'t have much to show for it.  Use more caution or your flight priveledges will be revoked...',26124),
(32918,'enUS','Your heart and your humanity hold you back, Arthas.','',26124),
(32919,'enUS','','It\'s been a busy day in the air, eh $n?  Maybe you should take a moment to catch your breath before going back out.',26124),
(32920,'enUS','Rid yourself of your humanity and you will never bleed again!','',26124),
(32921,'enUS','Do not worry, Arthas.  Soon you will not need your heart.','',26124),
(32922,'enUS','','I just got order to pull your flight privilege, $n.  Came back later and we\'ll let you back into a bomber.',26124),
(32923,'enUS','The human blood in your veins is but a detriment.  Rid yourself of all emotion!','',26124),
(32924,'enUS','The pain in your chest will soon be gone... never to return!','',26124),
(32925,'enUS','','You\'ve been just as busy blowing yourself up as you have blowing up the opposition.  That sounds fun, but be careful or I\'ll stop giving you bombers...',26124),
(32926,'enUS','','I tell you, it sure is fun to see you work!  And you sure go through a lot of bombers!',26124),
(32927,'enUS','I\'ve finally caught up with you, Arthas.','',26124),
(32928,'enUS','Grand Apothecary Putress unleashes the Engorged Blight Worm!','',26124),
(32929,'enUS','King Stormheart sent me to be tested as a frostborn would.  I am ready for my test, Fjorlin.','King Stormheart sent me to be tested as a frostborn would.  I am ready for my test, Fjorlin.',26124),
(32930,'enUS','I am ready to join the battle against the wyrms. Do you have an eagle ready for me, Fjorlin?','I am ready to join the battle against the wyrms. Do you have an eagle ready for me, Fjorlin?',26124),
(32931,'enUS','Careful, $n.  Where are your cultist robes?','',26124),
(32932,'enUS','There you are.  Are you ready then?  Once we start, there is no turning back.','',26124),
(32933,'enUS','I\'m ready, Highlord.','I\'m ready, Highlord.',26124),
(32935,'enUS','Greetings.','Greetings.',26124),
(32936,'enUS','Welcome.','Welcome.',26124),
(32937,'enUS','Your aberrations are no match for the Alliance, Putress! We\'re coming for you!','',26124),
(32938,'enUS','Soldiers, fall in! Guard the halls!','',26124),
(32939,'enUS','','What\'s happened here? There are corpses everywhere... the stench... overwhelming...',26124),
(32940,'enUS','Horde. By the looks of the struggle, they are here in force - somewhere.','',26124),
(32941,'enUS','Stay alert and on guard. There\'s no telling what horrors await us.','',26124),
(32942,'enUS','ONWARD!','',26124),
(32943,'enUS','Do not let them pass, minions!','',26124),
(32944,'enUS','KILL THEM! My work must not be interrupted!','',26124),
(32945,'enUS','The main chamber is this way! Let\'s go!','',26124),
(32946,'enUS','THERE!','',26124),
(32947,'enUS','There\'s nowhere to run, monster!','',26124),
(32948,'enUS','It will not end like this! I\'ve worked too hard! So many years... I... I will consume more energy!','',26124),
(32949,'enUS','Stare into the abyss and watch as it blackens your souls!','',26124),
(32950,'enUS','The power washes through me! I see... EVERYTHING!','',26124),
(32951,'enUS','MORE SUFFERING AWAITS!','',26124),
(32952,'enUS','You are no match for my creations!','',26124),
(32953,'enUS','This cannot be happening!','',26124),
(32954,'enUS','Welcome to the Legerdemain Lounge, $c. I do hope you\'ll enjoy your stay.','Welcome to the Legerdemain Lounge, $c. I do hope you\'ll enjoy your stay.',26124),
(32955,'enUS','Welcome to the Cantrips and Crows Tavern, $r.$B$BWatch your back while you\'re here, hmmm? Narisa doesn\'t like scrubbing blood off the floor.','Welcome to the Cantrips and Crows Tavern, $r.$B$BWatch your back while you\'re here, hmmm? Narisa doesn\'t like scrubbing blood off the floor.',26124),
(32956,'enUS','The proto-drake smells freedom and flies homeward!','',26124),
(32957,'enUS','A Power Spark forms from a nearby rift!','',26124),
(32958,'enUS','A Shadron Disciple appears in the Twilight!','',26124),
(32959,'enUS','','Tenebron begins to hatch eggs in the Twilight!',26124),
(32960,'enUS','A Vesperon Disciple appears in the Twilight!','',26124),
(32961,'enUS','And justice is served!','',26124),
(32962,'enUS','What say you now, Putress?','',26124),
(32963,'enUS','Look around you, brothers and sisters. Open your eyes! Look at what they have done to our kingdom!','',26124),
(32964,'enUS','How much longer will we allow these savages free reign in our world?','',26124),
(32965,'enUS','I have seen the Horde\'s world. I have been inside their cities. Inside their minds...','',26124),
(32966,'enUS','I know what evil lies in the hearts of orcs.','',26124),
(32967,'enUS','','',26124),
(32968,'enUS','THRALL! HERE?','',26124),
(32969,'enUS','ONWARD! We end this now!','',26124),
(32970,'enUS','You should all know, the orcs have a battle cry: LOK\'TAR OGAR! It means \"victory or death.\" Fitting...','',26124),
(32971,'enUS','To the throne room!','',26124),
(32972,'enUS','','Varian, stop! I won\'t help you do this!',26124),
(32973,'enUS','If you\'re shot down and caught, don\'t tell them your real name.  Use a codename.','',26124),
(32974,'enUS','%s summons forth Skeletal Warriors!','',26124),
(32976,'enUS','%s teleports back into the battle!','',26124),
(32977,'enUS','%s raises more skeletons!','',26124),
(32978,'enUS','%s blinks away!','',26124),
(32979,'enUS','Hidden inside this defiled city is the wretch responsible for murdering our brothers and sisters at the Wrathgate! He must be brought to justice!','',26124),
(32980,'enUS','Death to the Frostpaw!','',26124),
(32981,'enUS','All who slay Frostpaw are our allies!','',26124),
(32982,'enUS','Grizzlemaw belongs to the Redfang!','',26124),
(32983,'enUS','Slay all Redfang!','',26124),
(32984,'enUS','Victory to the Frostpaw!','',26124),
(32985,'enUS','All enemies of the Redfang are welcome in our den!','',26124),
(32986,'enUS','','Most dragons would fear to tread here, $r.$b$bWhat could possibly bring a mortal to such a treacherous place?',26124),
(32987,'enUS','','Do you possess the courage to face Malygos\' elite drakes in their own realm, $r?',26124),
(32988,'enUS','I... I think so....','I... I think so....',26124),
(32989,'enUS','','My drakes have been eagerly awaiting your return, $c.$b$bAre you ready to take wing?',26124),
(32990,'enUS','I am ready, Lady Corastrasza.','I am ready, Lady Corastrasza.',26124),
(32991,'enUS','','Quite a work out! These fiends are relentless.',26124),
(32992,'enUS','','*Huff* Need to catch my breath...',26124),
(32993,'enUS','','Good to be fighting again, don\'t you think?',26124),
(32994,'enUS','','An elite Blue Dragonflight squad appears from the portal!',26124),
(32995,'enUS','','A Portal Guardian defends the new portal!',26124),
(32996,'enUS','','A Portal Keeper emerges from the portal!',26124),
(32997,'enUS','Sorry, friend. Only certified officers of the Alliance can authorize the purchase of a vehicle.','Sorry, friend. Only certified officers of the Alliance can authorize the purchase of a vehicle.',26124),
(32998,'enUS','Lexicon of Power','Lexicon of Power',26124),
(32999,'enUS','The ancient tomes are always found near inscription trainers.','The ancient tomes are always found near inscription trainers.',26124),
(33000,'enUS','Your vehicle is burning!','Your vehicle is burning!',26124),
(33001,'enUS','We did it! Can you believe what we\'re hearing? This is incredible!','',26124),
(33002,'enUS','There will be plenty of time for this later Brann, we need to get moving!','There will be plenty of time for this later Brann, we need to get moving!',26124),
(33003,'enUS','You\'re right, I can come back to this later. I think it\'s time to see what\'s behind the door near the entrance. I\'m going to sneak over there, nice and quiet. Meet me at the door and I\'ll get us in.','',26124),
(33004,'enUS','Omega Rune deployed.  Activation successful.','',26124),
(33005,'enUS','Isn\'t it just beautiful? Can you see the potential profit?','',26124),
(33006,'enUS','It\'s a mighty good day, is it not? I do hope we see a few fireworks before this day is through.','',26124),
(33007,'enUS','Hello, little $r.','',26124),
(33008,'enUS','','Just because something isn\'t broke doesn\'t mean you can\'t fix it.  You lookin\' for something, sweety?',26124),
(33009,'enUS','How do you fly in this cold climate?','How do you fly in this cold climate?',26124),
(33010,'enUS','I hear you sell motorcycle parts.','I hear you sell motorcycle parts.',26124),
(33011,'enUS','Return to The Nexus!','',26124),
(33012,'enUS','The U.D.E.D. dispenser rumbles at you expectantly.','',26124),
(33013,'enUS','<Retrieve a bomb from the dispenser.>','<Retrieve a bomb from the dispenser.>',26124),
(33014,'enUS','Thanks, buddy! Thanks for nothing!','',26124),
(33015,'enUS','Why do you treat Hakmud like this, buddy?','',26124),
(33016,'enUS','What is Hakmud supposed to do now, buddy?','',26124),
(33017,'enUS','Hakmud cannot work under these conditions! Goodbye!','',26124),
(33018,'enUS','I thought we were friend, buddy! You leave Hakmud stranded?','',26124),
(33019,'enUS','Nobody loves Gnimo...','',26124),
(33020,'enUS','Goodbye! You were Gnimo\'s best friend ever!','',26124),
(33021,'enUS','Time for Gnimo to shut down.','',26124),
(33022,'enUS','The view up here is amazing!','The view up here is amazing!',26124),
(33023,'enUS','Oh, I see how it is... You\'re gonna do me like that, eh?','',26124),
(33024,'enUS','Hey, yea, I\'ve always wanted to be stranded somewhere.','',26124),
(33025,'enUS','Our friendship is OVER!','',26124),
(33026,'enUS','You\'re just gonna leave me here? How am I supposed to get home?','',26124),
(33027,'enUS','','Really, mon? Just like dat you be leavin\' Mojodishu behind?',26124),
(33028,'enUS','','Dis bad mojo what you doin\'. Don\'t say Mojodishu didn\'t warn ya!',26124),
(33029,'enUS','','Be dat way den!',26124),
(33030,'enUS','The view up here is amazing!','The view up here is amazing!',26124),
(33031,'enUS','The view up here is amazing!','The view up here is amazing!',26124),
(33032,'enUS','Too bad I left my light feathers at home... Slow Fall would work perfect here!','Too bad I left my light feathers at home... Slow Fall would work perfect here!',26124),
(33033,'enUS','Hmm... Interesting.','Hmm... Interesting.',26124),
(33034,'enUS','So many books, so little time.','So many books, so little time.',26124),
(33035,'enUS','So many wonderful books...','',26124),
(33036,'enUS','Feels good to be home.','',26124),
(33037,'enUS','%s\'s brains are splattered by $n.','%s\'s brains are splattered by $n.',26124),
(33038,'enUS','Welcome $c, to my humble retreat.  I find this place very relaxing and I have always loved being at home in Dalaran.  Sometimes though, it can be a lonely place...  such a lonely place.','',26124),
(33039,'enUS','I have a book that might interest you.  Would you like to take a look?','I have a book that might interest you.  Would you like to take a look?',26124),
(33040,'enUS','Amazing!  There are passages in here that I have never seen before.  This must have taken quite a while for you to track down.  If you ever find anymore books like this, I would like to be notified immediately.\n\nPlease take one of my Kirin Tor Familiars with you just in case you stumble across anything.','',26124),
(33041,'enUS','Reading orders','Reading orders',26124),
(33042,'enUS','Treasure huntin\' and some hearty ale - doesn\'t get no better than this, $G lad:lass;.','',26124),
(33043,'enUS','Thank you!  I will be sure to notifiy you if I find anything else.','Thank you!  I will be sure to notifiy you if I find anything else.',26124),
(33044,'enUS','The Emerald Dream has become a dangerous place. I grow increasingly concerned for those who have sacrificed their waking life in Azeroth in hopes of saving it.','',26124),
(33045,'enUS','Please send me into the Emerald Dream to recover the acorns. I know of the danger and I do not fear it.','Please send me into the Emerald Dream to recover the acorns. I know of the danger and I do not fear it.',26124),
(33046,'enUS','Let\'s try this a new way...','Let\'s try this a new way...',26124),
(33047,'enUS','Request granted, $n.  Please wait for your flight window...','Request granted, $n.  Please wait for your flight window...',26124),
(33048,'enUS','$n, your bomber is ready.  Good luck!','',26124),
(33049,'enUS','','One moment, $n...',26124),
(33050,'enUS','Request granted, $n.  Please wait for your flight window...','Request granted, $n.  Please wait for your flight window...',26124),
(33051,'enUS','The hammers of the earthen stand united behind Bouldercrag. We will oppose Loken\'s minions to the end.','',26124),
(33052,'enUS','We\'ve defeated Valduran and we\'ll fell his colossus.','',26124),
(33053,'enUS','Well fought! The day is ours, but the war goes on!','',26124),
(33054,'enUS','Make it quick, $c.','',26124),
(33055,'enUS','%s has transferred your soul into the body of a Ghoul.','%s has transferred your soul into the body of a Ghoul.',26124),
(33056,'enUS','','One more bottle?  I don\'t see any reason why not!',26124),
(33057,'enUS','<The engine rumbles loudly.>','',26124),
(33058,'enUS','<Get in the bomber and return to Scalawag Point.>','<Get in the bomber and return to Scalawag Point.>',26124),
(33059,'enUS','The Sunken Ring siege workshop has been attacked by the Alliance!','',26124),
(33060,'enUS','The Sunken Ring siege workshop has been attacked by the Horde!','',26124),
(33061,'enUS','The Broken Temple siege workshop has been attacked by the Alliance!','',26124),
(33062,'enUS','The Broken Temple siege workshop has been attacked by the Horde!','',26124),
(33063,'enUS','We will miss you, Antonidas.','We will miss you, Antonidas.',26124),
(33064,'enUS','Thank you for all that you have done for us.  May you rest in peace.','Thank you for all that you have done for us.  May you rest in peace.',26124),
(33065,'enUS','Place Avruu\'s Orb on the altar.','Place Avruu\'s Orb on the altar.',26124),
(33066,'enUS','Gusty winds surround the altar.  There is an open spot where a small orb may have once rested.','',26124),
(33067,'enUS','Sometimes it\'s nice to get away from the sanctum and get some fresh air.','Sometimes it\'s nice to get away from the sanctum and get some fresh air.',26124),
(33068,'enUS','Luckily, the Lich King\'s grasp has not reached Dalaran yet.','Luckily, the Lich King\'s grasp has not reached Dalaran yet.',26124),
(33069,'enUS','She said to meet her right here... maybe I\'m in the wrong place?','She said to meet her right here... maybe I\'m in the wrong place?',26124),
(33070,'enUS','Finally!$b$bDa $r $c foretold in da prophecies has arrived!','',26124),
(33071,'enUS','I am ready to return to the realm of the living.','I am ready to return to the realm of the living.',26124),
(33072,'enUS','The relic chamber is under attack!','',26124),
(33073,'enUS','The chamber has been breached! The titan relic is vulnerable!','',26124),
(33074,'enUS','How can I help you, brother?','How can I help you, brother?',26124),
(33075,'enUS','How can I help you, warrior?','How can I help you, warrior?',26124),
(33076,'enUS','Yes, little one?','',26124),
(33077,'enUS','%s calls an Azure Ring Captain!','',26124),
(33078,'enUS','Big, sparkly, magic book help make Glyphs for spells and abilities. Always find near inscription trainer, in The Apothecarium.','Big, sparkly, magic book help make Glyphs for spells and abilities. Always find near inscription trainer, in The Apothecarium.',26124),
(33081,'enUS','Big, sparkly, magic book help make Glyphs for spells and abilities. Always find near inscription trainer, in The Apothecarium.','Big, sparkly, magic book help make Glyphs for spells and abilities. Always find near inscription trainer, in The Apothecarium.',26124),
(33082,'enUS','','Make it quick, $r. I am weary and have no time for pleasantries..',26124),
(33083,'enUS','Be wary, $r.$b$bThis is no place for the meek.','',26124),
(33084,'enUS','I lost Brann\'s Communicator and need a replacement.','I lost Brann\'s Communicator and need a replacement.',26124),
(33085,'enUS','%s lunges for $n!','',26124),
(33086,'enUS','The %s prepares to slam the ground in front of him!','',26124),
(33087,'enUS','','%s casts Unyielding Pain on everyone!',26124),
(33088,'enUS','%s casts Condemnation on everyone!','',26124),
(33089,'enUS','There you are!','',26124),
(33090,'enUS','I need you to show me again, Matthias.','I need you to show me again, Matthias.',26124),
(33091,'enUS','Return to Fjorn\'s Anvil!','',26124),
(33092,'enUS','','Perhaps I should explain...',26124),
(33093,'enUS','','I had arranged for a secret summit between Warchief Thrall and King Wrynn, here in Theramore.',26124),
(33094,'enUS','','The king was to travel here by ship, in secret. But the ship never arrived, and King Wrynn disappeared.',26124),
(33095,'enUS','','Your help enabled us to connect the Defias to the mastermind behind the abduction, Onyxia, who was posing as a member of the royal court.',26124),
(33096,'enUS','','Meanwhile, the king managed to escape his captors, and returned to Stormwind to deal with Onyxia.',26124),
(33097,'enUS','','I will send word that you have discovered the link to the Defias. I was a fool to think them broken with the defeat of Edwin VanCleef, and King Wrynn will want to make an example of all who remain.',26124),
(33098,'enUS','Lok\'tar! Have you come to serve the Horde in battle?','',26124),
(33099,'enUS','','Thank you, $n. The health of our soldiers depends upon your success.',26124),
(33100,'enUS','Be safe, $n. Remember, the Horde are also seeking the dragon bones. It might be easier to kill them than to kill the shades.','',26124),
(33101,'enUS','Show those animals no mercy, $n!','',26124),
(33102,'enUS','Stop the Horde from retrieving the embers, $n. We cannot risk them having the advantage when the battle resumes!','',26124),
(33103,'enUS','Destroy their foul machines of war, $n!','',26124),
(33104,'enUS','','The Glacial Falls is a dangerous place, $n. The Horde will be just as happy to claim your armor for their vile hoodoo magics.',26124),
(33105,'enUS','Bring us victory, $n, and we shall grant you the honor you deserve! Fight for the Alliance!','',26124),
(33106,'enUS','The forest is on the western side of Wintergrasp. Just look for the soul-leeching shades, I\'m sure they\'ll be glad to have some company...','',26124),
(33107,'enUS','The Alliance disgrace this land with their villainous poaching. Don\'t hesitate to claim the herbs from their corpses!','',26124),
(33108,'enUS','The Glacial Falls be to the east, mon. Bring back da best armor ya be findin\'. Those Alliance won\'t know what hit \'em.','',26124),
(33109,'enUS','Slay them all, $n!','',26124),
(33110,'enUS','Elemental embers burn hotter than Durotar during the fire festival. The Alliance cannot be permitted to claim them!','',26124),
(33111,'enUS','Smash da\' siege, $n! Murp will know.','',26124),
(33112,'enUS','Victory or Death, $n!','',26124),
(33113,'enUS','Protect our war machines, $n! Fight for the glory of the Alliance!','',26124),
(33114,'enUS','The Glacial Falls be to the east, mon. Bring back da best armor ya be findin\'. Those Alliance won\'t know what hit \'em.','',26124),
(33115,'enUS','Defend da\' siege, $n! Smash dem walls!','',26124),
(33116,'enUS','Death... will not stop me.','',26124),
(33117,'enUS','I seem to have misplaced the Horn of the Peaks.','I seem to have misplaced the Horn of the Peaks.',26124),
(33118,'enUS','Ah, Noblegarden. So amusing to watch others throw away their dignity in favor of hunting colored eggs. Still, they do have a curious magical aura to them...','Ah, Noblegarden. So amusing to watch others throw away their dignity in favor of hunting colored eggs. Still, they do have a curious magical aura to them...',26124),
(33119,'enUS','The time has come for Noblegarden once again! Time to thank the Light for the rebirth of the world.','The time has come for Noblegarden once again! Time to thank the Light for the rebirth of the world.',26124),
(33120,'enUS','Candy! That\'s what I\'m talking about; I just wish I didn\'t have to run around finding it!','Candy! That\'s what I\'m talking about; I just wish I didn\'t have to run around finding it!',26124),
(33121,'enUS','The celebration of the natural processes of the world is silly; it\'s going to happen whether we celebrate or not! But it\'s a great excuse for sugar!','The celebration of the natural processes of the world is silly; it\'s going to happen whether we celebrate or not! But it\'s a great excuse for sugar!',26124),
(33122,'enUS','Hey, if people want to run around rooting in the dirt for colored eggs, who am I to judge? I still get a cut of the profits on paint, and I invested in chickens this year.','Hey, if people want to run around rooting in the dirt for colored eggs, who am I to judge? I still get a cut of the profits on paint, and I invested in chickens this year.',26124),
(33123,'enUS','Noblegarden time! I\'ve already found a lot of eggs. Great weather for the hunt, eh?','Noblegarden time! I\'ve already found a lot of eggs. Great weather for the hunt, eh?',26124),
(33124,'enUS','Noblegarden is the time when the druids of Azeroth celebrate the rebirth of life. The eggs are a symbol of fertility and an excellent way to bring everyone into the spirit, don\'t you think?','Noblegarden is the time when the druids of Azeroth celebrate the rebirth of life. The eggs are a symbol of fertility and an excellent way to bring everyone into the spirit, don\'t you think?',26124),
(33125,'enUS','We\'re celebrating spring during Noblegarden. Affirmation of life and all that.','We\'re celebrating spring during Noblegarden. Affirmation of life and all that.',26124),
(33126,'enUS','Now is the time in which we pay homage to the birth of life, and the eggs are symbols representing the spring and rebirth. May you enjoy the spring.','Now is the time in which we pay homage to the birth of life, and the eggs are symbols representing the spring and rebirth. May you enjoy the spring.',26124),
(33127,'enUS','Yah, mon, this be the time to be glad of life and spring. Ya collect lots of eggs yet?','Yah, mon, this be the time to be glad of life and spring. Ya collect lots of eggs yet?',26124),
(33128,'enUS','This entire holiday is nonsensical. Colored eggs and \"life affirmation,\" bah.','This entire holiday is nonsensical. Colored eggs and \"life affirmation,\" bah.',26124),
(33129,'enUS','%s senses his destiny!','',26124),
(33130,'enUS','Grab the explosive on the docks and bring down those doors, men!','Grab the explosive on the docks and bring down those doors, men!',26124),
(33131,'enUS','Grab the explosive on the docks and bring down those doors, men!','Grab the explosive on the docks and bring down those doors, men!',26124),
(33132,'enUS','Hail, friend! Have you come to serve the sons of Azeroth in battle?','',26124),
(33135,'enUS','Well met, friend. Enjoying Noblegarden, I hope? Why not join in the fun?','Well met, friend. Enjoying Noblegarden, I hope? Why not join in the fun?',26124),
(33136,'enUS','Greetings, $c.$B$BWhen the Alliance controls Wintergrasp Fortress, I will open a portal for those who wish to travel there.$B$BThe battle currently enues. Hurry to Wintergrasp and support our forces!','Greetings, $c.$B$BWhen the Alliance controls Wintergrasp Fortress, I will open a portal for those who wish to travel there.$B$BThe battle currently enues. Hurry to Wintergrasp and support our forces!',26124),
(33137,'enUS','Greetings, $c.$B$BWhen the Horde controls Wintergrasp Fortress, I will open a portal for those who wish to travel there.$B$BThe battle currently ensues. Hurry to Wintergrasp to support our forces.','Greetings, $c.$B$BWhen the Horde controls Wintergrasp Fortress, I will open a portal for those who wish to travel there.$B$BThe battle currently ensues. Hurry to Wintergrasp to support our forces.',26124),
(33138,'enUS','With the help of our new taunka allies, the Northrend will belong to the Horde.','',26124),
(33139,'enUS','I wish to return to Archdruid Lilliandra. Can you send me back to her?','I wish to return to Archdruid Lilliandra. Can you send me back to her?',26124),
(33140,'enUS','','Greetings $c!  Welcome aboard the Cloudkisser.  Northrend can be a very harsh place.  I hope you have prepared yourself.',26124),
(33141,'enUS','Locksmith','Locksmith',26124),
(33142,'enUS','You\'ll be after Benik Boltshear, then. He\'s located in the heart of the Dwarven District by the blacksmiths.','You\'ll be after Benik Boltshear, then. He\'s located in the heart of the Dwarven District by the blacksmiths.',26124),
(33143,'enUS','Him Walter Soref. Work in Rogue District. He make keys.','Him Walter Soref. Work in Rogue District. He make keys.',26124),
(33144,'enUS','If you are seeking a locksmith, might I suggest the sewers? That\'s where you\'ll find more... disreputable types.','If you are seeking a locksmith, might I suggest the sewers? That\'s where you\'ll find more... disreputable types.',26124),
(33145,'enUS','Interlopers! You mortals who dare to interfere with my sport will pay.... Wait--you...','',26124),
(33146,'enUS','<Allyndia\'s body bobs gently in the surf. It appears that she\'s been dead for some time.>','<Allyndia\'s body bobs gently in the surf. It appears that she\'s been dead for some time.>',26124),
(33147,'enUS','<As you approach, you hear Cerellean gasp for breath. He looks to stand a chance if rescued soon.>','<As you approach, you hear Cerellean gasp for breath. He looks to stand a chance if rescued soon.>',26124),
(33148,'enUS','Impertinent whelps, you dare challenge me atop my pedestal? I will crush you myself!','',26124),
(33149,'enUS','<Volcor\'s body lies motionless.  As you begin to move away, a hand reaches out and grabs your ankle. He\'s alive!>','<Volcor\'s body lies motionless.  As you begin to move away, a hand reaches out and grabs your ankle. He\'s alive!>',26124),
(33150,'enUS','<A whisper escapes Shaldyn\'s throat as you approach.>\n\nHelp... please.','<A whisper escapes Shaldyn\'s throat as you approach.>\n\nHelp... please.',26124),
(33151,'enUS','<Gershala rolls onto his side to look at you as you approach and you see a hopeful smile creep onto his face.>','<Gershala rolls onto his side to look at you as you approach and you see a hopeful smile creep onto his face.>',26124),
(33156,'enUS','<As you turn Barithras\' limp body over in the water, a brutal injury on his head makes it very apparent why he did not make it.>','<As you turn Barithras\' limp body over in the water, a brutal injury on his head makes it very apparent why he did not make it.>',26124),
(33157,'enUS','<Dalmond\'s body looks almost peaceful, buried only slightly in the sand.>','<Dalmond\'s body looks almost peaceful, buried only slightly in the sand.>',26124),
(33158,'enUS','<Grondal reaches futilely towards you as you approach, but his arm collapses as life slips from him.>','<Grondal reaches futilely towards you as you approach, but his arm collapses as life slips from him.>',26124),
(33159,'enUS','<Terenthis\' eyes stare unblinking into the distance, betraying the sorrow of his last moments.>','<Terenthis\' eyes stare unblinking into the distance, betraying the sorrow of his last moments.>',26124),
(33160,'enUS','<Vicious gashes line Valdaron\'s body. You need not check his pulse to know that he has already passed.>','<Vicious gashes line Valdaron\'s body. You need not check his pulse to know that he has already passed.>',26124),
(33161,'enUS','<The night elf turns to you as you approach and reaches for your hand.>\n\nIt is too late for me. We earned our fate with our pride. Go... others may have made it. Save any that you can.\n\n<Her grip loosens as life slips from her.>','<The night elf turns to you as you approach and reaches for your hand.>\n\nIt is too late for me. We earned our fate with our pride. Go... others may have made it. Save any that you can.\n\n<Her grip loosens as life slips from her.>',26124),
(33162,'enUS','So this... is what it feels like... to be mortal?\n\n<The question trails off as Mavralyn\'s breathing stops.>','So this... is what it feels like... to be mortal?\n\n<The question trails off as Mavralyn\'s breathing stops.>',26124),
(33163,'enUS','Turkey Hunter!','Turkey Hunter!',26124),
(33164,'enUS','Turkey Domination!','Turkey Domination!',26124),
(33165,'enUS','Turkey Slaughter!','Turkey Slaughter!',26124),
(33166,'enUS','Vesprystus\' hippogryphs will bear you swiftly to your destination.','Vesprystus\' hippogryphs will bear you swiftly to your destination.',26124),
(33167,'enUS','TURKEY TRIUMPH!','TURKEY TRIUMPH!',26124),
(33168,'enUS','It is Vesprystus that you seek.  He watches over the hippogryphs that come and go from the base of Teldrassil.','It is Vesprystus that you seek.  He watches over the hippogryphs that come and go from the base of Teldrassil.',26124),
(33169,'enUS','','Hey! Over here!',26124),
(33170,'enUS','','Get me out of here, will ya?',26124),
(33171,'enUS','','That brute has the key. ',26124),
(33172,'enUS','The mule looks at you expectantly.','',26124),
(33173,'enUS','This is not your mule.','',26124),
(33174,'enUS','','Our home was destroyed during the Cataclysm!$B$BAll of the rest of the survivors moved north to build Lor\'danel, but those of us that stayed behind are here for a reason. We WILL retake the Ruins of Auberdine from those Twilight\'s Hammer scum just as soon as we heal up.$B$BI hope that you can help us to deal with them in the meantime.',26124),
(33175,'enUS','On my flight south from Darnassus to seek out Malfurion Stormrage, I came across these injured refugees from the Ruins of Auberdine.$B$BTheir cause is just and I am helping to heal them, but their injuries are numerous, and it will take time.$B$BI trust that you will be willing to lend them your aid as well.','',26124),
(33176,'enUS','Warning: Golem can only be used in Dun Argol!','',26124),
(33177,'enUS','','Many years ago I died tragically while attempting to help with a local murloc problem. However, I was content to stay and watch my family and friends instead of passing on to be with the Goddess.$B$BNow they are all gone, or worse, dead, and I have only one reason to stay.$B$BVengeance.',26124),
(33178,'enUS','Need a shoeshine, $c?','Need a shoeshine, $c?',26124),
(33179,'enUS','Take care of that shine, $c.','Take care of that shine, $c.',26124),
(33180,'enUS','One shoeshine coming up!','One shoeshine coming up!',26124),
(33181,'enUS','Let me shine your shoes, $c.','Let me shine your shoes, $c.',26124),
(33182,'enUS','Shiny!','Shiny!',26124),
(33183,'enUS','Another shiny, happy person.  Take care, $c!','Another shiny, happy person.  Take care, $c!',26124),
(33184,'enUS','Thank you for saving me, stranger.','',26124),
(33185,'enUS','Thundris Windweaver\'s corpse lays sprawled out here, the apparent victim of the Twilight\'s Hammer\'s machinations.','',26124),
(33186,'enUS','Coax Thundris Windweaver\'s spirit.','Coax Thundris Windweaver\'s spirit.',26124),
(33187,'enUS','Thundris Windweaver\'s spirit is coaxed forth.','',26124),
(33188,'enUS','Artruis is shielded. You must choose your side quickly to break his spell.','',26124),
(33189,'enUS','The frost leopard lays here tranquilized.','',26124),
(33190,'enUS','Lift the frost leopard\'s tail to check if it\'s a male or a female.','Lift the frost leopard\'s tail to check if it\'s a male or a female.',26124),
(33191,'enUS','It\'s an angry male!','',26124),
(33192,'enUS','It\'s a female.','',26124),
(33193,'enUS','The icepaw bear lays here tranquilized.','',26124),
(33194,'enUS','Lift the icepaw bear\'s tail to check if it\'s a male or a female.','Lift the icepaw bear\'s tail to check if it\'s a male or a female.',26124),
(33195,'enUS','Farewell.','Farewell.',26124),
(33196,'enUS','','Thirsty? How about flagon of sweet, warm honeycomb mead? Come on over!',26124),
(33197,'enUS','Where am I?  Hic!','',26124),
(33198,'enUS','Where\'s my bottle?  Have you seen it?','',26124),
(33199,'enUS','I used to have 1850 spell power, what happaned?','',26124),
(33200,'enUS','','Nothin\' will warm your belly like a cup of caraway burnwine. Buy it here!',26124),
(33201,'enUS','','Fine, snowplum brandy sold here! Buy a snifter, and experience its wonders...',26124),
(33202,'enUS','','Drinks, here! Delicious drinks! From snowplum brandy to Westfall bourbon... get your drinks!',26124),
(33203,'enUS','','What are you doing out here? You should be inside fighting off the Blue Dragonflight!',26124),
(33204,'enUS','I\'m not fighting, so send me in now!','I\'m not fighting, so send me in now!',26124),
(33205,'enUS','I know, I know... \"fishing in a sewer?\" But you\'d be surprised by what you can catch down here. I\'ve even heard stories of sharks, if you can believe it.','',26124),
(33206,'enUS','','The sentinel\'s body rests here, the apparent victim of the elemental onslaught that has overtaken the town.',26124),
(33207,'enUS','Coax the spirit out of Sentinel Elissa Starbreeze\'s corpse.','Coax the spirit out of Sentinel Elissa Starbreeze\'s corpse.',26124),
(33208,'enUS','Here\'s where Taldan served his last drink.','',26124),
(33209,'enUS','Coax Taldan\'s corpse to give up its spirit.','Coax Taldan\'s corpse to give up its spirit.',26124),
(33210,'enUS','','Far too powerful for these elementals, Caylais and her hippogryphs must have been struck down by something else.',26124),
(33211,'enUS','Coax the spirit out of Caylais Moonfeather\'s still corpse.','Coax the spirit out of Caylais Moonfeather\'s still corpse.',26124),
(33212,'enUS','','Lor\'danel is next, fool. With Aetherion almost completely in this world, it is only a matter of time!',26124),
(33213,'enUS','','This place was only the beginning. We will crush your refugee camp and then lead our elementals north to destroy Lor\'danel with Aetherion as our vanguard!',26124),
(33214,'enUS','','Lor\'danel must have been desperate to send you. We\'ll deal with them soon enough!',26124),
(33215,'enUS','Our master will break the world asunder and all that you know will come to an end. This is only a taste of what\'s to come!','',26124),
(33216,'enUS','You will not stop our final ritual to bring Aetherion into the world. Too bad that you won\'t live to see it!','',26124),
(33217,'enUS','If you only knew the power that I serve, you would not hesitate to kneel before me and join our ranks. Sadly, your ignorance will prove to be your undoing!','',26124),
(33218,'enUS','Whatcha doin\', mon? Don\'tcha know the end o\' the world be nigh? Here, I show you!','',26124),
(33219,'enUS','Ya be messin\' with Tzu-Tzu? It no matter... Aetherion\'s here, mon. We gonna roll on ya refugee camp an\' then bring the hurt to ya Lor\'denal. But first, ya die!','',26124),
(33220,'enUS','Gots no time for playin\' with ya. Aetherion just about ready to go!','',26124),
(33221,'enUS','I HAVE ALMOST ARRIVED. TWILIGHT\'S HAMMER, DO NOT RUSH THE SUMMONING OR I WILL DESTROY YOU AS WELL!','',26124),
(33222,'enUS','I SEE YOU, INSECT. RUN WHILE YOU CAN. RUN AND TELL YOUR PATHETIC LOR\'DANEL THAT I AM COMING TO DESTROY IT!','',26124),
(33223,'enUS','MALFURION, CAN YOU HEAR ME?! WHEN I HAVE DESTROYED THE CHILDREN OF ELUNE, I WILL COME AND PUT AN END TO YOU!','',26124),
(33224,'enUS','MY MASTER COMES, MORTALS! I AM BUT ONE OF A LEGION OF HERALDS. YOUR WORLD IS ABOUT TO UNDERGO A TRANSFORMATION THAT WILL SEE THE END OF YOU!','',26124),
(33225,'enUS','PATIENCE! THE RITUAL TO BRING ME INTO THIS WORLD IS COMPLEX AND MUST NOT BE RUSHED!','',26124),
(33226,'enUS','JOIN THE TWILIGHT\'S HAMMER NOW. THOSE WHO DO NOT BELONG WHEN I FULLY ENTER THE WORLD WILL KNOW ONLY DEATH!','',26124),
(33227,'enUS','THERE IS BUT ONE OUTCOME POSSIBLE. THE CATACLYSM WAS ONLY THE BEGINNING. THE WORLD AS YOU KNOW IT IS AT AN END!','',26124),
(33228,'enUS','YOU MORTALS ARE MADE OF THE STUFF OF THE ELEMENTS. HOW CAN YOU POSSIBLY HOPE TO PREVAIL? PREPARE TO RETURN TO YOUR TRUER, MORE BASIC NATURES!','',26124),
(33229,'enUS','YOU DARE?! TODAY WILL SEE THE END OF LOR\'DANEL, MALFURION, AND YOU!','',26124),
(33230,'enUS','I do not judge others by their stature, $r, but by their courage and loyalty.','',26124),
(33231,'enUS','No, Aetherion, we will not allow that to happen!','',26124),
(33232,'enUS','WHAT IS THIS? YALDA? AHAHAHAHAHA, THERE IS NOTHING THAT YOU OR THESE OTHER SPIRITS CAN DO TO STOP ME!','',26124),
(33233,'enUS','We shall see. Let us weaken him, my friends!','',26124),
(33234,'enUS','This is a fine mess we\'ve gotten ourselves into. We\'re overdue to join up with our forces in Icecrown and now we\'re entangled in this debacle, stuck between the Scourge and the Drakkari.$B$BI told the highlord it was a mistake to come here.$B$BSee what you can do to help out there.','',26124),
(33235,'enUS','Can you hear it, $c? The elements cry out that this land is almost dead. The Drakkari are stealing the power of their gods by killing them just to defend themselves against the Scourge.$B$BThey are short-sighted and will be their own undoing in the end.','',26124),
(33236,'enUS','','After the Plaguelands and the Battle for Light\'s Hope Chapel, I didn\'t think that we would witness anything more horrible.$B$BI was wrong.',26124),
(33237,'enUS','EVEN IN THIS WEAKENED FORM, I WILL DESTROY YOU!!!','',26124),
(33238,'enUS','Your lungs are filled and you are ready for action!','Your lungs are filled and you are ready for action!',26124),
(33239,'enUS','Your knuckes are cracked and ready for action!','Your knuckes are cracked and ready for action!',26124),
(33240,'enUS','Are you ready to face the observer? [PH]','',26124),
(33241,'enUS','Indeed Frizzer, shake and bake! [PH]','Indeed Frizzer, shake and bake! [PH]',26124),
(33242,'enUS','Your muscles are stretched out and ready for action!','Your muscles are stretched out and ready for action!',26124),
(33244,'enUS','%s begins to Summon Collapsing Stars!','',26124),
(33245,'enUS','The stars come to my aid!','',26124),
(33246,'enUS','','Goddess bless you.',26124),
(33247,'enUS','','Accept Elune\'s gift.',26124),
(33248,'enUS','','Cerellean! You made it!',26124),
(33249,'enUS','','I\'ll get him back to Lor\'danel.  Thank you for your help, stranger.',26124),
(33250,'enUS','','Elune be with you.',26124),
(33251,'enUS','Thank you, priestess.','Thank you, priestess.',26124),
(33252,'enUS','Elune be praised!','Elune be praised!',26124),
(33253,'enUS','I feel much better. Thank you.','I feel much better. Thank you.',26124),
(33254,'enUS','We must take back Auberdine!','We must take back Auberdine!',26124),
(33255,'enUS','The Twilight\'s Hammer will pay for what they\'ve done.','The Twilight\'s Hammer will pay for what they\'ve done.',26124),
(33256,'enUS','Elune-Adore.','Elune-Adore.',26124),
(33257,'enUS','','Goddess watch over you.',26124),
(33258,'enUS','','Gershala... Dentaria will be so happy to see you alive.',26124),
(33259,'enUS','','I\'ll take him back to the priestess. Thank you for your kindness.',26124),
(33260,'enUS','','I will see to it that Shaldyn is returned safely. Thank you, hero.',26124),
(33261,'enUS','','Shaldyn!',26124),
(33262,'enUS','','Volcor... I\'m so glad to see that you made it. But where is Grimclaw?',26124),
(33263,'enUS','','We\'ll worry about him later. I need to get you to safety.',26124),
(33264,'enUS','','Thank you for your help, friend. I\'ll take it from here.',26124),
(33265,'enUS','Elder Ironbranch casts Iron Roots!','',26124),
(33266,'enUS','Elder Stonebark begins to cast |cFFFF0000Ground Tremor!|r','',26124),
(33267,'enUS','%s surrounds itself with a crackling Runic Barrier!','',26124),
(33268,'enUS','Elder Stonebark begins to cast Fists of Stone!\n','',26124),
(33269,'enUS','Witness the fury of the cosmos!','',26124),
(33270,'enUS','I remember you... in the mountains.... But you... what is this? Where am--','',26124),
(33271,'enUS','Portals of Outland','Portals of Outland',26124),
(33272,'enUS','The Burning Legion','The Burning Legion',26124),
(33273,'enUS','%s acquires a new target.','',26124),
(33274,'enUS','Failures!  Weaklings!','',26124),
(33275,'enUS','Fan the Flames! $B$B\n|TInterface\\Icons\\INV_Misc_EngGizmos_04.blp:64|t','Fan the Flames! $B$B\n|TInterface\\Icons\\INV_Misc_EngGizmos_04.blp:64|t',26124),
(33276,'enUS','The Flame Leviathan begins to overload!','',26124),
(33277,'enUS','Purge the Spark Plugs! $B$B\n|TInterface\\Icons\\INV_Misc_EngGizmos_12.blp:64|t\n','Purge the Spark Plugs! $B$B\n|TInterface\\Icons\\INV_Misc_EngGizmos_12.blp:64|t',26124),
(33278,'enUS','Adjust the gears! $B$B\n|TInterface\\Icons\\INV_Misc_EngGizmos_13.blp:64|t','Adjust the gears! $B$B\n|TInterface\\Icons\\INV_Misc_EngGizmos_13.blp:64|t\n$B$B',26124),
(33279,'enUS','The engine got too hot!$BPressure was lost.','The engine got too hot!$BPressure was lost.',26124),
(33280,'enUS','The spark plugs misfired!$BPressure was lost.\n','The spark plugs misfired!$BPressure was lost.\n',26124),
(33281,'enUS','You ground the gears!$BPressure was lost.','You ground the gears!$BPressure was lost.',26124),
(33282,'enUS','The engine got too cold!$BAll pressure was lost.\n','The engine got too cold!$BAll pressure was lost.\n',26124),
(33283,'enUS','The spark plugs were clogged!$BAll pressure was lost.','The spark plugs were clogged!$BAll pressure was lost.',26124),
(33284,'enUS','The gears went unshifted!$BAll pressure was lost.\n','The gears went unshifted!$BAll pressure was lost.\n',26124),
(33285,'enUS','The flames burn hotter!$BGood job!\n','The flames burn hotter!$BGood job!\n',26124),
(33286,'enUS','The spark plugs are clear!$BWell done!\n','The spark plugs are clear!$BWell done!\n',26124),
(33287,'enUS','The engine shifted properly!$BNice work!\n','The engine shifted properly!$BNice work!\n',26124),
(33288,'enUS','Welcome to the Demolisher Engineering Console v0.1 alpha.','Welcome to the Demolisher Engineering Console v0.1 alpha.',26124),
(33289,'enUS','This system allows you to manually control$Bthe power and speed of your siege unit.','This system allows you to manually control$Bthe power and speed of your siege unit.',26124),
(33290,'enUS','Once the system activates, you will be required to manually$B respond to emergencies that occur within the engine.\n','Once the system activates, you will be required to manually$B respond to emergencies that occur within the engine.\n',26124),
(33291,'enUS','Properly responding to these events builds power$Bwithin the Demolisher  5000\'s overflow tank.$B\n|TInterface\\Icons\\INV_Misc_EngGizmos_04.blp:32|t |TInterface\\Icons\\INV_Misc_EngGizmos_12.blp:32|t |TInterface\\Icons\\INV_Misc_EngGizmos_13.blp:32|t\n','Properly responding to these events builds power$Bwithin the Demolisher  5000\'s overflow tank.$B\n|TInterface\\Icons\\INV_Misc_EngGizmos_04.blp:32|t |TInterface\\Icons\\INV_Misc_EngGizmos_12.blp:32|t |TInterface\\Icons\\INV_Misc_EngGizmos_13.blp:32|t\n',26124),
(33292,'enUS','Pressure can be used to boost the demolisher\'s$Bspeed, damage and defenses.$B|TInterface\\Icons\\INV_Gizmo_RocketBootExtreme.blp:32|t |TInterface\\Icons\\INV_Weapon_Rifle_31.blp:32|t','Pressure can be used to boost the demolisher\'s speed, damage and defenses.$B|TInterface\\Icons\\INV_Gizmo_RocketBootExtreme.blp:32|t |TInterface\\Icons\\INV_Weapon_Rifle_31.blp:32|t',26124),
(33293,'enUS','The DEC operator can also choose to load themselves into the loading arm,$B allowing the Demolisher driver to launch them into the distance.$B|TInterface\\Icons\\INV_Misc_EngGizmos_27.blp:32|t','The DEC operator can also choose to load themselves into the loading arm,$B allowing the Demolisher driver to launch them into the distance.$B|TInterface\\Icons\\INV_Misc_EngGizmos_27.blp:32|t',26124),
(33294,'enUS','GG Engineering Inc. is |cFFFF2222not responsible|r$B for the loss of life, limbs or facial hair$B when using the Demolisher in this way.','GG Engineering Inc. is |cFFFF2222not responsible|r$B for the loss of life, limbs or facial hair$B when using the Demolisher in this way.',26124),
(33295,'enUS','$B$B','$B$B',26124),
(33296,'enUS','The first of the Alliance towers has fallen! Destroy all three and we will hasten their retreat!','',26124),
(33297,'enUS','Lok\'tar! The second tower falls! Destroy the final tower and we will hasten their retreat!','',26124),
(33298,'enUS','The Alliance towers have fallen! We have forced their hand. Finish off the remaining forces!','',26124),
(33299,'enUS','The first of the Horde towers has fallen! Destroy all three and we will hasten their retreat!','',26124),
(33300,'enUS','The second tower has fallen! Destroy the final tower and we will hasten their retreat!','',26124),
(33301,'enUS','The Horde towers have fallen! We have forced their hand. Finish off the remaining forces!','',26124),
(33302,'enUS','Enter code to receive Frost Whelp pet.','Enter code to receive Frost Whelp pet.',26124),
(33303,'enUS','','The Conservatory must be protected!',26124),
(33304,'enUS','%s\'s circuits overloaded.','',26124),
(33305,'enUS','%s reactivated. Resuming combat functions.','',26124),
(33306,'enUS','Welcome to the Demolisher Mechanic Console v0.1 alpha.','Welcome to the Demolisher Mechanic Console v0.1 alpha.',26124),
(33307,'enUS','This system allows you to manually adjust$B the ammuniction and speed of your siege unit.','This system allows you to manually adjust$B the ammuniction and speed of your siege unit.',26124),
(33308,'enUS','Once the system activates, you will be required to manually$B maintain your demolisher. ','Once the system activates, you will be required to manually$B maintain your demolisher. ',26124),
(33309,'enUS','Oiling the gears will increase the $Bmovement speed of the demolisher.$B\n|TInterface\\Icons\\INV_Misc_Gem_Pearl_01.blp:32|t','Oiling the gears will increase the $Bmovement speed of the demolisher.$B\n|TInterface\\Icons\\INV_Misc_Gem_Pearl_01.blp:32|t',26124),
(33310,'enUS','Ammunition for the main unit must be regularly reloaded.$B|TInterface\\Icons\\INV_Misc_Ammo_Bullet_02.blp:32|t','Ammunition for the main unit must be regularly reloaded.$B|TInterface\\Icons\\INV_Misc_Ammo_Bullet_02.blp:32|t',26124),
(33311,'enUS','','',26124),
(33312,'enUS','','Freya begins to cast |cFFFF0000Ground Tremor!|r',26124),
(33313,'enUS','%s gains Frozen Blows!','',26124),
(33314,'enUS','%s begins to cast Flash Freeze!','',26124),
(33315,'enUS','Back to work you lazy dead cur!','Back to work you lazy dead cur!',26124),
(33316,'enUS','They say there\'s no rest for the wicked. That means you!','They say there\'s no rest for the wicked. That means you!',26124),
(33317,'enUS','This is coward\'s work. We should be crushing the Alliance now!','This is coward\'s work. We should be crushing the Alliance now!',26124),
(33318,'enUS','A potion to melt the elves? Maybe you\'ll need it, Forsaken. I have my mace to crush their skulls!','A potion to melt the elves? Maybe you\'ll need it, Forsaken. I have my mace to crush their skulls!',26124),
(33319,'enUS','I could use some more blood ale to quench my thirst!','I could use some more blood ale to quench my thirst!',26124),
(33320,'enUS','Work faster for the glory of the Horde!','Work faster for the glory of the Horde!',26124),
(33321,'enUS','Warchief Hellscream will have your head if you don\'t pick up the pace, Forsaken!','Warchief Hellscream will have your head if you don\'t pick up the pace, Forsaken!',26124),
(33322,'enUS','How special... you\'re good at picking flowers. Are you going to send me a bouquet? Hahahaha!','How special... you\'re good at picking flowers. Are you going to send me a bouquet? Hahahaha!',26124),
(33323,'enUS','%s shatters the Rare Cache of Hodir!','',26124),
(33325,'enUS','','Thorim, my lord!  Why else would these invaders have come into your sanctum but to slay you?  They must be stopped!',26124),
(33326,'enUS','The moonstalker wakes suddenly and lets out a low growl.','',26124),
(33327,'enUS','','Hail to the night!',26124),
(33328,'enUS','You will not stop us, filthy $r!','You will not stop us, filthy $r!',26124),
(33329,'enUS','Some nice contagion of rot for you, my pretty?','Some nice contagion of rot for you, my pretty?',26124),
(33330,'enUS','What are you doing here?!','What are you doing here?!',26124),
(33331,'enUS','Someone! Help!','Someone! Help!',26124),
(33332,'enUS','I\'ll crush you, puny $r!','I\'ll crush you, puny $r!',26124),
(33333,'enUS','Lok\'tar ogar!','Lok\'tar ogar!',26124),
(33334,'enUS','Good, the Alliance has come to play!','Good, the Alliance has come to play!',26124),
(33335,'enUS','Finally someone to smash!','Finally someone to smash!',26124),
(33336,'enUS','For Ashenvale!','For Ashenvale!',26124),
(33337,'enUS','Death to the Horde!','Death to the Horde!',26124),
(33338,'enUS','For Elune!','For Elune!',26124),
(33339,'enUS','Zomg, I\'m totally a Stag. Do you like my antlers? I just had them polished. (Temp text)','',26124),
(33340,'enUS','Meow. I\'m a cat lawl.  Don\'t pick me up or I might scratch you. Have any catnip? (Temp text)','',26124),
(33341,'enUS','Are you dumb? I\'m a freaking bear. Back off, punk. (Temp text)','',26124),
(33342,'enUS','Give me some quest credit, yo.','Give me some quest credit, yo.',26124),
(33343,'enUS','','The forest is crawling with Horde, $c. Be mindful of your surroundings!',26124),
(33344,'enUS','I am here to do my master\'s bidding, no matter what the cost. A little girl\'s life hangs in the balance and what could be more important?','',26124),
(33345,'enUS','Dig rats make some surprisingly tasty stew.','',26124),
(33346,'enUS','Return to the ocean... return to the tides.','',26124),
(33347,'enUS','The tides do as Elune commands.','',26124),
(33348,'enUS','We thank you mortal.  The ocean\'s will is to be free.','',26124),
(33349,'enUS','Welcome, $g sir : my lady;. This is a much better camp than the one that I used to have.$B$BIt\'s good to have company. They\'ve been nice enough to teach me some of their fighting techniques so that I can hold my own against the Horde.','',26124),
(33350,'enUS','','Greetings, $c. Our position here is a bit exposed given the build up of the Horde\'s forces to the south.$B$BAnything that you can do to help will be greatly appreciated.',26124),
(33351,'enUS','Welcome, champions! All of our attempts at bringing her down have failed. We could use a hand in bringing her down with these harpoon guns.','Welcome, champions! All of our attempts at bringing her down have failed. We could use a hand in bringing her down with these harpoon guns.',26124),
(33353,'enUS','We are ready to help!','We are ready to help!',26124),
(33354,'enUS','','Prepare yourselves. We attack at high tide!',26124),
(33355,'enUS','','Assemble the schools. We will wash away even the memories of the Alliance and the Horde from Ashenvale!',26124),
(33356,'enUS','','Our great queen beckons us forward. Let us turn the waters red with the blood of our enemies!',26124),
(33357,'enUS','','Let the might of Zoram rise! Let our enemies be crushed within our coils! Go forth and teach them what it means to face the Wrathtail!',26124),
(33358,'enUS','','Destroy Zoram\'gar Outpost! Destroy the Blackfathom Camp! We march on Maestra\'s Post and by nightfall Astranaar will lie in ruins!',26124),
(33359,'enUS','','The Cataclysm is only the beginning. Let the two-legs drown in a sea of their own blood!',26124),
(33360,'enUS','','To arms! Invaders approach! Strike them down! Let none survive!',26124),
(33361,'enUS','','I see you, land-walker. Come to me... we shall parlay.',26124),
(33362,'enUS','','I thought I\'d never be free from that terrible curse. You have my gratitude, stranger.',26124),
(33363,'enUS','Glad to help, my lady. I\'m told you were once the guardian of a fabled sword. Do you know where I might find it?','Glad to help, my lady. I\'m told you were once the guardian of a fabled sword. Do you know where I might find it?',26124),
(33364,'enUS','','Take it with my gratitude, $c.',26124),
(33365,'enUS','My patience has reached its limit!','',26124),
(33366,'enUS','','Can it really be? Free after all these years?',26124),
(33367,'enUS','','And now, I must return to the waters of the lake.',26124),
(33368,'enUS','','These pathetic mortals are harmless, beneath my station.  Dispose of them!',26124),
(33369,'enUS','','Impossible!  Lord Thorim, I will bring your foes a frigid death!',26124),
(33370,'enUS','','A |cFF00FFFFLifebinder\'s Gift|r begins to grow!',26124),
(33371,'enUS','','Hey! Anybody out there?',26124),
(33372,'enUS','','Need some help here! Damsel in distress! <snort>',26124),
(33373,'enUS','','Come to the top of the inn! They have me chained up!',26124),
(33374,'enUS','','Somebody please! Get me out of here before they sacrifice me!',26124),
(33375,'enUS','','Up here on the second floor of the inn! Hurry!',26124),
(33376,'enUS','','Please! Someone! Anyone! Help me get out of here!',26124),
(33377,'enUS','','Ohmygosh! I didn\'t think that I was ever going to see anyone ever again!$B$BYou have to get me out of here!',26124),
(33378,'enUS','','Great! Let\'s get out of here. I don\'t have a weapon, so I\'d really appreciate it if you could... you know... protect me?',26124),
(33379,'enUS','','Let\'s go.',26124),
(33380,'enUS','','There\'s the refugee camp!',26124),
(33381,'enUS','','I\'ll race you!',26124),
(33382,'enUS','','Hollee!',26124),
(33383,'enUS','','Elisa! Oh, it\'s so good to get out of there! Auberdine is completely overrun with cultists and elementals!',26124),
(33384,'enUS','','I know, lass, but you\'re safe now and with friends. I thought you were dead!',26124),
(33386,'enUS','','I have a favor to ask. Could you reward my friend here? I haven\'t any coin. I can pay you when we get back to Ironforge.',26124),
(33387,'enUS','','Of course. Don\'t think anything of it. And I won\'t hear of you trying to pay me back, either!',26124),
(33388,'enUS','','Oh, thank you, Elisa! Thank you!',26124),
(33389,'enUS','','Anytime, lass. Anytime.',26124),
(33390,'enUS','','Time for a very short breather.',26124),
(33391,'enUS','','We have to get out of here.',26124),
(33392,'enUS','','How many elementals do they have?!',26124),
(33393,'enUS','','This has to be said... the Twilight\'s Hammer sucks!',26124),
(33394,'enUS','','That was the last one, right?',26124),
(33395,'enUS','','Why did I ever let Remtravel convince me to come to Darkshore?!',26124),
(33396,'enUS','','I\'d be dead if it weren\'t for you.',26124),
(33397,'enUS','','This would never have happened to Ironforge!',26124),
(33398,'enUS','','You cultists are going to pay! Someone get me out of here!',26124),
(33399,'enUS','','I am an archaeologist with the Explorers\' League! I can assure you that King Magni will hear of this outrage!',26124),
(33400,'enUS','What may I do for you, $GSir:Dame;?','',26124),
(33401,'enUS','Stormwind Champion\'s Pennant','Stormwind Champion\'s Pennant',26124),
(33402,'enUS','','Taldan!',26124),
(33403,'enUS','','This isn\'t happening. Oh no... my friends!',26124),
(33404,'enUS','','Hurry! We have to check on them!',26124),
(33405,'enUS','','It\'s trashed, but it doesn\'t look like there are any bodies.',26124),
(33406,'enUS','','Sorry, but I had to check. Okay, let\'s get out of here.',26124),
(33407,'enUS','Are you certain you want my help in the battle against Yogg-Saron?','',26124),
(33408,'enUS','Mortals, I am indebted to you for freeing me from the terrible corruption that besets this place. Though I have not yet recovered fully, I can help you battle Yogg-Saron.\n\nI can grant you and your friends the Fortitude of Frost, increasing your damage and reducing damage taken from enemy attacks. Should one of you be about to fall in battle, I can freeze you in a block of ice, protecting you from all damage for a short time. Know that this ability taxes my power, and I must rest after using it.','',26124),
(33409,'enUS','','Mortals, I am indebted to you for freeing me from the terrible corruption that besets this place. Though I have not yet recovered fully, I can help you battle Yogg-Saron.\n\nI can grant you and your friends the Resilience of Nature, increasing your damage and increasing healing taken from spells and effects. In addition, I can conjure Sanity Wells that will allow you to recover your Sanity when your grip on reality falters.',26124),
(33410,'enUS','','Greetings, $c.',26124),
(33411,'enUS','I\'m ready for my scouting mission.','I\'m ready for my scouting mission.',26124),
(33412,'enUS','Mortals, I am indebted to you for freeing me from the terrible corruption that besets this place. Though I have not yet recovered fully, I can help you battle Yogg-Saron.\n\nI can grant you and your friends the Speed of Invention, increasing your damage and movement speed. In addition, I can destabilize the matrices of certain Saronite based life-forms, reducing their attack and casting speeds.','',26124),
(33413,'enUS','Mortals, I am indebted to you for freeing me from the terrible corruption that besets this place. Though I have not yet recovered fully, I can help you battle Yogg-Saron.\n\nI can grant you and your friends the Fury of the Storm, increasing your damage and maximum health. Should you be faced with evil so malevolent that it cannot be destroyed, I can channel all my power into a final Titanic Storm that will destroy even Immortals.','',26124),
(33415,'enUS','','Are you certain you want my help in the battle against Yogg-Saron?',26124),
(33418,'enUS','Lend us your aid, keeper. Together we will defeat Yogg-Saron.','Lend us your aid, keeper. Together we will defeat Yogg-Saron.',26124),
(33419,'enUS','Blood and thunder, $r!','Blood and thunder, $r!',26124),
(33420,'enUS','For the Horde!','For the Horde!',26124),
(33421,'enUS','Death to the Alliance!','Death to the Alliance!',26124),
(33422,'enUS','Many thanks, $c!','Many thanks, $c!',26124),
(33423,'enUS','','Are those winter hyacinths? For me?',26124),
(33424,'enUS','','It\'s been so long since a traveler has come here bearing flowers.',26124),
(33425,'enUS','','The lake has been too lonely these past years. The travelers stopped coming and evil came to these waters.',26124),
(33426,'enUS','','Your gift is a rare kindness, traveler. Please take this blade with my gratitude. Long ago, another traveler left it here, but I have little use for it.',26124),
(33427,'enUS','','Allies of Nature have appeared!',26124),
(33429,'enUS','Are you sure you are ready for mounted combat?','Are you sure you are ready for mounted combat?',26124),
(33430,'enUS','I am ready to fight!','I am ready to fight!',26124),
(33431,'enUS','I don\'t like you anymore!','',26124),
(33432,'enUS','%s ignores $n.','',26124),
(33433,'enUS','Come near, $c. I haven\'t got much time....','',26124),
(33434,'enUS','The mortally wounded orc seems to be unconscious.','',26124),
(33435,'enUS','<The orc\'s lifeless body is no longer responsive....>','',26124),
(33436,'enUS','','Thank you, mortal, for freeing me from this curse. I beg you, take this blade.',26124),
(33437,'enUS','','It has brought me naught but ill. Mayhap you can find someone who will contain its power.',26124),
(33438,'enUS','I\'ve lost my Tabard of Summer Skies.','I\'ve lost my Tabard of Summer Skies.',26124),
(33439,'enUS','I\'ve lost my Tabard of Summer Flames.','I\'ve lost my Tabard of Summer Flames.',26124),
(33440,'enUS','Thank you, friend. I could not rest knowing that my mission had not been completed.','',26124),
(33441,'enUS','...and that my mens\' sacrifice had not been avenged.','',26124),
(33442,'enUS','We must hurry, now. I sense that my time is short.','',26124),
(33443,'enUS','Follow me closely, and prepare for battle!','',26124),
(33444,'enUS','Captain Elendilad conceals himself on the island ahead, cowardly issuing orders to his underlings.','',26124),
(33445,'enUS','He must fall!','',26124),
(33446,'enUS','So tired. I will rest for just a moment!','',26124),
(33447,'enUS','%s\'s heart is exposed and leaking energy.','',26124),
(33448,'enUS','I\'m ready to play!','',26124),
(33449,'enUS','Show yourself, elf-coward! Face your death with honor!','',26124),
(33450,'enUS','','Good to see you, $c.$B$BSorry... can\'t talk. We\'re in a bit of a fight here.',26124),
(33451,'enUS','','Just let me know when you\'re ready to take a squad out.$B$BI\'m holding some in reserve, so if you need a few more, come back.',26124),
(33452,'enUS','It\'s rough out there. I need some replacements, Sentinel Onaeya.','It\'s rough out there. I need some replacements, Sentinel Onaeya.',26124),
(33453,'enUS','NO! NO! NO! NO! NO!','',26124),
(33454,'enUS','%s begins to cause the earth to quake.','',26124),
(33455,'enUS','How many times must I have you killed, orc?!','',26124),
(33456,'enUS','','Thanks for the rescue. Let\'s get out of here!',26124),
(33457,'enUS','','Thanks for getting me out of there. I should be able to swim back from here, but before I go, one quick thing...',26124),
(33458,'enUS','','First, Morra will be interested to know that it sounds like the Warsong clan spurred these trolls out of the mountain to attack us, so I suspect they\'re going to attack in Ashenvale as well.',26124),
(33459,'enUS','','I was afforded a brief chance to attack their leader, and he was protected by some kind of magic. Make sure Morra hears of this before leading any kind of attack.',26124),
(33460,'enUS','','Farewell newcomer. May Elune\'s blessing be with you.',26124),
(33461,'enUS','You have no idea what you\'re meddling with!','',26124),
(33462,'enUS','Curse you, $r vermin! This forest belongs to the Kaldorei...','',26124),
(33463,'enUS','The %s withers into the earth and begins to regenerate.','',26124),
(33464,'enUS','With the help of its allies the %s regenerates back to life.','',26124),
(33465,'enUS','%s begins to cast Flame Jets!','',26124),
(33466,'enUS','Epic Purple Shirt','Epic Purple Shirt',26124),
(33467,'enUS','Sandbox Tiger','Sandbox Tiger',26124),
(33468,'enUS','Foam Sword Rack','Foam Sword Rack',26124),
(33469,'enUS','Blood of Gladiators','Blood of Gladiators',26124),
(33470,'enUS','Mission complete. Thank you, friend.','',26124),
(33471,'enUS','General Vezax roars and surges with dark might!','',26124),
(33472,'enUS','I\'ll carve your heart out, maggot!','',26124),
(33473,'enUS','A $r? I spit on you!','',26124),
(33474,'enUS','So you\'re the Alliance\'s so-called champion. With your death this place will easily fall.','',26124),
(33475,'enUS','Pathetic weakling. You\'ll die quickly!','',26124),
(33476,'enUS','I can see you, worm. Are you grunts blind? Kill them!','',26124),
(33477,'enUS','That one, over there. Target them. Do NOT let them get past you!','',26124),
(33478,'enUS','Surrender, Maestra, and I will see to it that your deaths are quick!','',26124),
(33479,'enUS','Smash them! Destroy them! Lok\'tar ogar!','',26124),
(33480,'enUS','Your time has past, night elves. Ashenvale is ours!','',26124),
(33481,'enUS','I want that one killed! The one right there that doesn\'t look like the others!','',26124),
(33482,'enUS','There is no hope for you. Your Darkshore lies in ruins. Astranaar will fall before the end of the day as will this place. Retreat to Darnassus while you still can.','',26124),
(33483,'enUS','There is no blood easier spilt than that of a puny night elf!','',26124),
(33484,'enUS','I... I am released from his grasp... at last.','',26124),
(33485,'enUS','NO! Garrosh, I have failed you....','',26124),
(33486,'enUS','Remember, the warlock at the top of the tower will see through your invisibility!','',26124),
(33487,'enUS','Hostile entities detected. Threat assessment protocol active. Primary target engaged. Time minus 30 seconds to re-evaluation.','',26124),
(33488,'enUS','Threat re-evaluated. Target assessment complete. Changing course.','',26124),
(33489,'enUS','Pursuit objective modified. Changing course.','',26124),
(33490,'enUS','Hostile entity\'s stratagem predicted. Re-routing battle function. Changing course.','',26124),
(33491,'enUS','Orbital countermeasures enabled.','',26124),
(33492,'enUS','*ALERT* Static defense system failure. Orbital countermeasures disabled.','',26124),
(33493,'enUS','Hodir\'s Fury online. Acquiring target.','',26124),
(33494,'enUS','%s activates Hodir\'s Fury.','',26124),
(33495,'enUS','Mimiron\'s Inferno online. Acquiring target.','',26124),
(33496,'enUS','%s activates Mimiron\'s Inferno.','',26124),
(33497,'enUS','Freya\'s Ward online. Acquiring target.','',26124),
(33498,'enUS','%s activates Freya\'s Ward.','',26124),
(33499,'enUS','Thorim\'s Hammer online. Acquiring target.','',26124),
(33500,'enUS','%s activates Thorim\'s Hammer.','',26124),
(33501,'enUS','Unauthorized entity attempting circuit overload. Activating anti-personnel countermeasures.','',26124),
(33502,'enUS','%s pursues $n.','',26124),
(33503,'enUS','System malfunction. Diverting power to support systems.','',26124),
(33504,'enUS','Combat matrix overload. Powering doooow...','',26124),
(33505,'enUS','System restart required. Deactivating weapons systems.','',26124),
(33506,'enUS','Total systems failure. Defense protocols breached. Leviathan unit shutting down.','',26124),
(33507,'enUS','Threat assessment routine modified. Current target threat level: 0. Acquiring new target.','',26124),
(33508,'enUS','New toys? For me? I promise I won\'t break them this time!','',26124),
(33509,'enUS','I... I think I broke it.','',26124),
(33510,'enUS','I guess it doesn\'t bend that way.','',26124),
(33511,'enUS','You are bad... Toys... Very... Baaaaad ','',26124),
(33512,'enUS','I\'m tired of these toys. I don\'t want to play anymore!','',26124),
(33513,'enUS','What is it, $c?','',26124),
(33514,'enUS','Truun is in need of lumber from the Warsong Camp. I need to use Brutusk to haul it.','Truun is in need of lumber from the Warsong Camp. I need to use Brutusk to haul it.',26124),
(33515,'enUS','Very well, $c. But be careful, Brutusk can be very... spirited.','',26124),
(33516,'enUS','Deactivating','Deactivating',26124),
(33517,'enUS','','Eonar, your servant requires aid!',26124),
(33518,'enUS','','The swarm of the elements shall overtake you!',26124),
(33519,'enUS','','Children, assist me!',26124),
(33520,'enUS','','Elders grant me your strength!',26124),
(33521,'enUS','Kill the Kodo and capture the rider!','Kill the Kodo and capture the rider!',26124),
(33522,'enUS','Do not let it pass!','Do not let it pass!',26124),
(33523,'enUS','%s fortifies nearby allies with runic might!','',26124),
(33524,'enUS','','His hold on me dissipates. I can see clearly once more. Thank you, heroes.',26124),
(33525,'enUS','Yes.','Yes.',26124),
(33526,'enUS','Fire!','Fire!',26124),
(33527,'enUS','Bombs away!','Bombs away!',26124),
(33528,'enUS','Take that, night elf scum!','Take that, night elf scum!',26124),
(33529,'enUS','Have a nice day!','Have a nice day!',26124),
(33530,'enUS','Careful with that fuse!','Careful with that fuse!',26124),
(33531,'enUS','Range set.','Range set.',26124),
(33532,'enUS','One! Two! Five!... THREE!','One! Two! Five!... THREE!',26124),
(33533,'enUS','Um, could one of you grunts take care of those guys right there?!','Um, could one of you grunts take care of those guys right there?!',26124),
(33534,'enUS','I\'m off. Stay safe - I\'ll be back as quickly as I\'m able.','',26124),
(33535,'enUS','We have need of your explosives. I\'ll take pleasure in killing you for them.','',26124),
(33536,'enUS','You\'re on the wrong side for this one, old friends. Your caravan is ours now.','',26124),
(33537,'enUS','Brutusk roars as he leaps into the ambush!','',26124),
(33538,'enUS','Automatic repair sequence initiated.','',26124),
(33539,'enUS','Weapons systems offline.','',26124),
(33540,'enUS','','Now, I will imbue this crystal with the Light\'s power to cut through lies and deceit.',26124),
(33541,'enUS','','Grant us the ability to know the truth. If a murderer walks in our midst, guide us in our search for justice.',26124),
(33542,'enUS','Me not workin\' til elfs is gone!','Me not workin\' til elfs is gone!',26124),
(33543,'enUS','Elfs kill too many peons in forest. Me sittin\' here where it safe.','Elfs kill too many peons in forest. Me sittin\' here where it safe.',26124),
(33544,'enUS','Me not dyin\' for a little wood!','Me not dyin\' for a little wood!',26124),
(33545,'enUS','Come now, friend. You chop and I will protect you from the elves, ok?','Come now, friend. You chop and I will protect you from the elves, ok?',26124),
(33546,'enUS','Good work! I\'m glad to see some revenge taken on that traitor. Go ahead and take the path Miran did to the east and let Prospector Ironband know we\'re all set. I\'m sure he\'ll have some work for you as well.','',26124),
(33547,'enUS','I appreciate your help in this. We never would have suspected Saean as a sympathizer - we just weren\'t prepared for this.','',26124),
(33548,'enUS','','Greetings, $c.',26124),
(33549,'enUS','Hmm. You don\'t look very tough... but okay.','Hmm. You don\'t look very tough... but okay.',26124),
(33550,'enUS','You stay close, $r. And don\'t let elfs near me!','You stay close, $r. And don\'t let elfs near me!',26124),
(33551,'enUS','You not gunna let me die, huh? Okay, then...','You not gunna let me die, huh? Okay, then...',26124),
(33552,'enUS','Sentinel, I would like to ride one of your nightsabers to Astranaar.','Sentinel, I would like to ride one of your nightsabers to Astranaar.',26124),
(33553,'enUS','You keep a lookout, $r! The elfs are everywhere!','You keep a lookout, $r! The elfs are everywhere!',26124),
(33554,'enUS','Lay down and die.','',26124),
(33555,'enUS','Death is but the inevitable conclusion to your life.','',26124),
(33556,'enUS','We are everywhere underneath you.','',26124),
(33557,'enUS','This is the new beginning. Rejoice in your coming doom.','',26124),
(33558,'enUS','Embrace the future that rises from below.','',26124),
(33559,'enUS','Keeper Heartwise, cease your resistance.','',26124),
(33560,'enUS','Mortal creature, you are the infestation that must be cleansed.','',26124),
(33561,'enUS','Come, speak to me at your leisure. Let us discuss matters in a civil manner.','',26124),
(33562,'enUS','Return whence you came, foul creature!','',26124),
(33563,'enUS','You will be destroyed!','',26124),
(33564,'enUS','Back, I say!','',26124),
(33565,'enUS','Light of Elune take you!','',26124),
(33566,'enUS','I know not what you are, but I do know that you will die!','',26124),
(33567,'enUS','Wither in Elune\'s grace!','',26124),
(33568,'enUS','I will cleanse you from the face of the world!','',26124),
(33569,'enUS','Unnatural!','',26124),
(33570,'enUS','I\'m trusting you... Don\'t let me die!','I\'m trusting you... Don\'t let me die!',26124),
(33571,'enUS','There you go, $r.','There you go, $r.',26124),
(33572,'enUS','','How may I help you, $c?',26124),
(33573,'enUS','Here I go! Keep an eye out....','Here I go! Keep an eye out....',26124),
(33574,'enUS','I have bad feeling about this....','I have bad feeling about this....',26124),
(33575,'enUS','Watch my back, $r!','Watch my back, $r!',26124),
(33576,'enUS','','No longer shall we tolerate your presence here, orc!',26124),
(33577,'enUS','','Ashenvale belongs to the Kaldorei!',26124),
(33578,'enUS','','Death to the Horde!',26124),
(33579,'enUS','','The Horde is not welcome in our lands, orc! Now die!',26124),
(33580,'enUS','Avenge me, $n.','',26124),
(33582,'enUS','|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 Sanity Low!|r','|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 Sanity Low|r',26124),
(33583,'enUS','Your remains will feed IT which rises!','',26124),
(33584,'enUS','This form means nothing. We are without end.','',26124),
(33585,'enUS','%s returns to stone until the next battle resolves.','',26124),
(33586,'enUS','%s senses the approaching battle and prepares to return to stone.','',26124),
(33587,'enUS','A cloud of saronite vapors coalesces nearby!','',26124),
(33588,'enUS','Luara, I would like to take one of your nightsabers to Maestra\'s Post.','Luara, I would like to take one of your nightsabers to Maestra\'s Post.',26124),
(33589,'enUS','Managed to find me, eh? No matter, you won\'t live to tell anyone of it!','',26124),
(33590,'enUS','','Make it quick, $r.',26124),
(33591,'enUS','','Hurry, $c! There is no time to waste!$b$bSplintertree must not fall!',26124),
(33592,'enUS','I am ready, Gorka. To Kadrak!','I am ready, Gorka. To Kadrak!',26124),
(33593,'enUS','','Follow me, $n! Hurry!',26124),
(33594,'enUS','The saronite vapors mass and swirl violently, merging into a monstrous form!','',26124),
(33595,'enUS','Vindicator, please loan me your elekk to ride to Forest Song.','Vindicator, please loan me your elekk to ride to Forest Song.',26124),
(33596,'enUS','','Gorka calls for Brutusk!',26124),
(33597,'enUS','Exotic Pet','Exotic Pet',26124),
(33598,'enUS','Chimaera','Chimaera',26124),
(33599,'enUS','Core Hound','Core Hound',26124),
(33600,'enUS','Devilsaur','Devilsaur',26124),
(33601,'enUS','Clefthoof','Clefthoof',26124),
(33602,'enUS','Silithid','Silithid',26124),
(33603,'enUS','Spirit Beast','Spirit Beast',26124),
(33604,'enUS','Worm','Worm',26124),
(33605,'enUS','','You have strayed too far. Wasted too much time....',26124),
(33606,'enUS','Move quickly! She won\'t remain grounded for long!','',26124),
(33607,'enUS','Be on the lookout! Mole machines will be surfacing soon with those nasty Iron dwarves aboard!','',26124),
(33608,'enUS','Your resilience is admirable.','',26124),
(33609,'enUS','I will break you... as I broke him!','',26124),
(33610,'enUS','Arrrrrrgh!','',26124),
(33611,'enUS','I\'m not afraid of you!','',26124),
(33612,'enUS','Glory to Stormwind and King Wrynn!','',26124),
(33613,'enUS','It seems you were not ready for mounted combat.','It seems you were not ready for mounted combat.',26124),
(33614,'enUS','I do not have all day to fight you.  Challenge me when your skills have improved.','I do not have all day to fight you.  Challenge me when your skills have improved.',26124),
(33615,'enUS','','Hold on, $n! This won\'t be easy!',26124),
(33616,'enUS','A thousand deaths....','',26124),
(33617,'enUS','Or one murder.','',26124),
(33618,'enUS','I want those elves and their draenei friends dead, now!','',26124),
(33619,'enUS','','To Mor\'shan!!',26124),
(33620,'enUS','Assemble a company! March on Forest Song!','',26124),
(33621,'enUS','Cut down the forest! Flush the elves out!','',26124),
(33622,'enUS','Take no prisoners!','',26124),
(33623,'enUS','The warchief will have all of our hides if production doesn\'t double!','',26124),
(33624,'enUS','You there, have you filled your quota of lumber and elf ears today?!','',26124),
(33625,'enUS','We are the backbone of the Ashenvale offensive. Failure is NOT an option!','',26124),
(33626,'enUS','Get out there and kill those Alliance dogs!','',26124),
(33627,'enUS','Your petty quarrels only make me stronger.... BOW to the god of death!','',26124),
(33628,'enUS','Yrr n\'lyeth... shuul anagg!','',26124),
(33629,'enUS','He will learn... no king rules forever; only death is eternal!','',26124),
(33630,'enUS','That\'s far enough, orc! Dismount and submit or die!','That\'s far enough, orc! Dismount and submit or die!',26124),
(33631,'enUS','','Out of our way, fools!',26124),
(33632,'enUS','My, my, I never thought I would have the chance to see Ulduar myself. Why, when Brann asked me to help fund this expedition, how could I refuse?!','',26124),
(33633,'enUS','I never thought we\'d escape from that steamy jungle! Now I\'m the lead engineer of this expedition. ','',26124),
(33634,'enUS','What can these siege engines do?','What can these siege engines do?',26124),
(33635,'enUS','These babies may look like scrap, but they can rush ahead, knocking enemies aside. The front ram has been overloaded with a electroscopic hyper capacitor, letting it discharge electrical blasts. $B$BEven the turret has been upgraded with anti-air rockets, providing it with a definitive edge over those blasted demolishers.','These babies may look like scrap, but they can rush ahead, knocking enemies aside. The front ram has been overloaded with a electroscopic hyper capacitor, letting it discharge electrical blasts. $B$BEven the turret has been upgraded with anti-air rockets, providing it with a definitive edge over those blasted demolishers.',26124),
(33636,'enUS','We haven\'t much time, friends! You\'re going to help me test out my latest and greatest creation. Now, before you change your minds, remember that you kind of owe it to me after the mess you made with the XT-002.','',26124),
(33637,'enUS','Here I have amassed what may well be the greatest depository of lore in all of Outland. Even the grand libraries of Silvermoon City pale in comparison.$B$BPlease... look, read, browse to your heart\'s content. You\'ll find everything organized and clearly labeled.','',26124),
(33638,'enUS','WONDERFUL! Positively marvelous results! Hull integrity at 98.9 percent! Barely a dent! Moving right along.','',26124),
(33639,'enUS','Behold the VX-001 Anti-personnel Assault Cannon! You might want to take cover.','',26124),
(33640,'enUS','Kill her!!','Kill her!!',26124),
(33641,'enUS','Ahhh!','Ahhh!',26124),
(33642,'enUS','Shoot!','Shoot!',26124),
(33643,'enUS','Fire!!','Fire!!',26124),
(33644,'enUS','','Unghh!',26124),
(33645,'enUS','','Hurry, Brutusk. I\'m wounded!',26124),
(33646,'enUS','A saronite barrier appears around General Vezax!','',26124),
(33647,'enUS','The saronite barrier protecting General Vezax shimmers and fades away!','',26124),
(33648,'enUS','We were in luck to find enough parts to get these babies working again!$BHow can I help you?','',26124),
(33649,'enUS','Tell me about demolishers.','Tell me about demolishers.',26124),
(33650,'enUS','These babies can hurl fire like none other. We\'ve even attached a secondary cannon, a grappling hook and added a manual fuel injection system.  If you can obtain liquid pyrite from the mechanognomes, you can use it to hurl high-density explosives, or turbo-boost your movement speed. \n\nLet\'s see those Explorers\' League twirps beat that!','These babies can hurl fire like none other. We\'ve even attached a secondary cannon, a grappling hook and added a manual fuel injection system.  If you can obtain liquid pyrite from the mechanognomes, you can use it to hurl high-density explosives, or turbo-boost your movement speed. \n\nLet\'s see those Explorers\' League twirps beat that!',26124),
(33651,'enUS','It\'s a good thing you guys showed up! The Iron Dwarves have pushed us back to this location, and we\'re barely managing to hold the line here. \n\nEven worse, they\'ve begun to power up their magical defenses. If we don\'t attack soon, they\'ll be able to annihilate us in the blink of an eye!\n\nWe\'ve managed to rebuild several siege machines, demolishers and motorcycles from the Alliance and Horde expeditions that were here before us. However, all of our pilots died in the last assault.\n\nYou must take the vehicles and storm the gates of Ulduar! \n\nPlease, $n! You\'re our last hope!','',26124),
(33652,'enUS','We\'re ready. Begin the assault!','We\'re ready. Begin the assault!',26124),
(33653,'enUS','','I am... finished....',26124),
(33654,'enUS','','$n... You have served the Horde well.$b$bHurry now... speak with Kadrak....$b$bSave Splintertree!!',26124),
(33655,'enUS','I shall not fail, Gorka!','I shall not fail, Gorka!',26124),
(33656,'enUS','It is done. All have given that which must be given. I now seal the Dragon Soul forever.','',26124),
(33657,'enUS','%s takes a deep breath...','%s takes a deep breath...',26124),
(33658,'enUS','','That terrible glow... should that be?',26124),
(33659,'enUS','For it to be as it must, yes.','',26124),
(33660,'enUS','It is a weapon like no other. It must be like no other.','',26124),
(33661,'enUS','Who dares summon the mighty Pengoro?','',26124),
(33662,'enUS','I am hungry','I am hungry',26124),
(33663,'enUS','His brood learned their lesson before too long. You will soon learn yours!','',26124),
(33664,'enUS','','Bad news, sire.',26124),
(33665,'enUS','','The clans are united under Blackhand in this assault. They will stand together until Stormwind has fallen.',26124),
(33666,'enUS','','Gul\'dan is bringing up his warlocks by nightfall. Until then, the Blackrock clan will be trying to take the Eastern Wall.',26124),
(33667,'enUS','','The orc leaders agree with your assessment.',26124),
(33668,'enUS','Thank you, friends! Your efforts have yielded some fantastic data! Now, where did I put-- oh, there it is.','',26124),
(33669,'enUS','Isn\'t it beautiful? I call it the magnificent aerial command unit!','',26124),
(33670,'enUS','We will hold until the reinforcements come. As long as men with stout hearts are manning the walls and the throne, Stormwind will hold.','',26124),
(33671,'enUS','Pentarus, you heard the $gman:woman;. Have your mages release the shield and let these brave souls through!','',26124),
(33672,'enUS','We\'re here with you Brann, you can trust in your brothers of earth.','',26124),
(33673,'enUS','Of course, Brann. We will have the shield down momentarily.','',26124),
(33674,'enUS','Brothers, prepare yourselves! Take up defensive positions along the ramp and make way to let the vehilces through. Born from the earth, to the earth shall we return. Let the might of the Makers burn deep within you!','',26124),
(33675,'enUS','Darnassus Champion\'s Pennant','Darnassus Champion\'s Pennant',26124),
(33676,'enUS','Exodar Champion\'s Pennant','Exodar Champion\'s Pennant',26124),
(33677,'enUS','Mages of the Kirin Tor, on Brann\'s Command, release the shield! Defend this platform and our allies with your lives! For Dalaran!','',26124),
(33678,'enUS','Gnomeregan Champion\'s Pennant','Gnomeregan Champion\'s Pennant',26124),
(33679,'enUS','Ironforge Champion\'s Pennant','Ironforge Champion\'s Pennant',26124),
(33680,'enUS','Something I can do for you, Boss?','',26124),
(33681,'enUS','Darkspear Champion\'s Pennant','Darkspear Champion\'s Pennant',26124),
(33682,'enUS','Forsaken Champion\'s Pennant','Forsaken Champion\'s Pennant',26124),
(33683,'enUS','Orgrimmar Champion\'s Pennant','Orgrimmar Champion\'s Pennant',26124),
(33684,'enUS','Okay! Let\'s move out. Get into your machines; I\'ll speak to you from here via the radio!','',26124),
(33685,'enUS','Silvermoon Champion\'s Pennant','Silvermoon Champion\'s Pennant',26124),
(33686,'enUS','Thunder Bluff Champion\'s Pennant','Thunder Bluff Champion\'s Pennant',26124),
(33687,'enUS','Our allies are ready. Bring down the shield and make way!','',26124),
(33688,'enUS','This test has lasted too long.  You are not ready to be a valiant.','This test has lasted too long.  You are not ready to be a valiant.',26124),
(33689,'enUS','You are far to slow on the field of battle.  Perhaps you need to further hone your skills.','You are far to slow on the field of battle.  Perhaps you need to further hone your skills.',26124),
(33690,'enUS','Well done!  It seems that you are worthy of the valiant rank!','Well done!  It seems that you are worthy of the valiant rank!',26124),
(33691,'enUS','Impressive skills indeed.  I believe that you are more than ready for the rank of valiant.','Impressive skills indeed.  I believe that you are more than ready for the rank of valiant.',26124),
(33692,'enUS','Greetings.','',26124),
(33693,'enUS','I know the troops need food, but this is ridiculous.','',26124),
(33694,'enUS','I still don\'t know why we can\'t just conjur a refreshment table.','',26124),
(33695,'enUS','All the arcane power in the world, and here I am, summoning more food and water.','',26124),
(33696,'enUS','I\'m a waitress.','',26124),
(33698,'enUS','You believe yourself ready for the rank of valiant?  We shall see.','You believe yourself ready for the rank of valiant?  We shall see.',26124),
(33699,'enUS','The rank of valiant is not easily won.  Prepare yourself!','The rank of valiant is not easily won.  Prepare yourself!',26124),
(33700,'enUS','It would seem that you are not yet ready for the rank of valiant.  Some more training may serve you well.','It would seem that you are not yet ready for the rank of valiant.  Some more training may serve you well.',26124),
(33701,'enUS','I\'m afraid you are not ready to become a valiant.  However I suspect you will be ready soon enough.','I\'m afraid you are not ready to become a valiant.  However I suspect you will be ready soon enough.',26124),
(33702,'enUS','','I heard a story or two of a Lore Keeper in Uldaman that fit your description. Do you serve a similar purpose?',26124),
(33703,'enUS','I was constructed to serve as a repository for essential information regarding this complex. My primary functions include communicating the status of the frontal defense systems and assessing the status of the entity that this complex was built to imprison.','',26124),
(33704,'enUS','','Frontal defense systems? Is there something I should let Brann know before he has anyone attempt to enter the complex?',26124),
(33705,'enUS','Access to the interior of the complex is currently restricted. Primary defensive emplacements are active. Secondary systems are currently non-active.','',26124),
(33706,'enUS','','Can you detail the nature of these defense systems?',26124),
(33707,'enUS','Compromise of complex detected, security override enabled - query permitted.','',26124),
(33708,'enUS','','Got it. At least we don\'t have to deal with those orbital emplacements.',26124),
(33709,'enUS','','Rhydian, make sure you let Brann and Archmage Pentarus know about those defenses immediately.',26124),
(33710,'enUS','','And you mentioned an imprisoned entity? What is the nature of this entity and what is its status?',26124),
(33711,'enUS','Entity designate: Yogg-Saron. Security has been compromised. Prison operational status unknown. Unable to contact Watchers for notification purposes.','',26124),
(33712,'enUS','Primary defensive emplacements consist of iron constructs and Storm Beacons, which will generate additional constructs as necessary. Secondary systems consist of orbital defense emplacements.','',26124),
(33713,'enUS','','Yogg-Saron is here? It sounds like we really will have our hands full then.',26124),
(33714,'enUS','','Looks like the battle\'s about to get under way, that\'s my cue to leave. We\'ll have to pick this up later.',26124),
(33715,'enUS','','%s nods.',26124),
(33716,'enUS','','%s whispers something to Brann.',26124),
(33717,'enUS','The Silver Covenant welcomes you to the tournament. The Argent Crusade has asked us to register and train those interested in competing.','',26124),
(33718,'enUS','No room for mistakes this time! I don\'t want any of these siege engines breaking down on the field. ','',26124),
(33719,'enUS','That better be the last one that blows up on our watch. They\'re paying top dollar for these things.','',26124),
(33720,'enUS','Looks like you know a good machine when you see one. Give\'m hell!','Looks like you know a good machine when you see one. Give\'m hell!',26124),
(33721,'enUS','Don\'t forget to get some of that extra pyrite if your friends can shoot it down.','Don\'t forget to get some of that extra pyrite if your friends can shoot it down.',26124),
(33722,'enUS','Wish I could be going with ya. Blow\'m up good!','Wish I could be going with ya. Blow\'m up good!',26124),
(33723,'enUS','I hope you like explosions. They\'re my specialty.','I hope you like explosions. They\'re my specialty.',26124),
(33724,'enUS','You treat my baby nice, alright? I don\'t want to find any dents when you\'re done with her.','You treat my baby nice, alright? I don\'t want to find any dents when you\'re done with her.',26124),
(33725,'enUS','Now with new passenger tossing capability! I\'m sure your buds will love ya.','Now with new passenger tossing capability! I\'m sure your buds will love ya.',26124),
(33726,'enUS','We\'ve only got a limited amount of pyrite stocked, use it sparingly.','We\'ve only got a limited amount of pyrite stocked, use it sparingly.',26124),
(33727,'enUS','All yours. Make good use of her!','All yours. Make good use of her!',26124),
(33728,'enUS','These things should bring down those towers in no time!','These things should bring down those towers in no time!',26124),
(33729,'enUS','We upgraded these with some advanced armor plating - they should be able to take quite a beating now!','We upgraded these with some advanced armor plating - they should be able to take quite a beating now!',26124),
(33730,'enUS','Roll\'m!','Roll\'m!',26124),
(33731,'enUS','The Anti-Air Rockets should be perfect for taking down those air transports to get at the extra pyrite.','The Anti-Air Rockets should be perfect for taking down those air transports to get at the extra pyrite.',26124),
(33732,'enUS','I call her Betty. She\'s a beauty, eh?','I call her Betty. She\'s a beauty, eh?',26124),
(33733,'enUS','Trust me, this thing will make those goblins jealous. It\'s a work of art.','Trust me, this thing will make those goblins jealous. It\'s a work of art.',26124),
(33734,'enUS','Made to far exceed Brann\'s specifications. You won\'t be disappointed.','Made to far exceed Brann\'s specifications. You won\'t be disappointed.',26124),
(33735,'enUS','This thing should wreck that iron army. One better, it won\'t explode in your face... unlike some machines I\'ve seen. Not saying names or anything.','This thing should wreck that iron army. One better, it won\'t explode in your face, unlike some machines I\'ve seen. Not saying names or anything, Blastwrench.',26124),
(33736,'enUS','Into riding in style? I like your taste.','Into riding in style? I like your taste.',26124),
(33737,'enUS','Nothing\'s going to catch you on this baby!','Nothing\'s going to catch you on this baby!',26124),
(33738,'enUS','She\'s all fixed up and ready to go. Treat her nice!','She\'s all fixed up and ready to go. Treat her nice!',26124),
(33739,'enUS','We put together some sweet custom horns for these things. Enjoy!','We put together some sweet custom horns for these things. Enjoy!',26124),
(33740,'enUS','Make good use of those tar pools. Your friends should be able to light them on fire if they\'re smart about it.','Make good use of those tar pools. Your friends should be able to light them on fire if they\'re smart about it.',26124),
(33741,'enUS','Born to be Wi-i-ild!','Born to be Wi-i-ild!',26124),
(33742,'enUS','Nothing like feeling the wind in your hair! Make sure you wear some goggles though, I bet those Iron dwarves are going to be made into a bit of a mess.','Nothing like feeling the wind in your hair! Make sure you wear some goggles though, I bet those Iron dwarves are going to be made into a bit of a mess.',26124),
(33743,'enUS','Drive some circles around\'m!','Drive some circles around\'m!',26124),
(33744,'enUS','|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 2%% Sanity Lost|r','|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 2%% Sanity Lost|r',26124),
(33745,'enUS','The console appears ancient though there is no sign of dilapidation or decay.  A single slot appears to fit large circular discs.','',26124),
(33746,'enUS','|cFFCCCCCC%s is loaded into the launching arm of your demolisher.$BWeapon systems offline until launched.|r','|cFFCCCCCC%s is loaded into the launching arm of your demolisher.$BWeapon systems offline until launched.|r',26124),
(33747,'enUS','Are you sure you are ready to fight a valiant?','Are you sure you are ready to fight a valiant?',26124),
(33748,'enUS','It would be unwise to assume that fighting a valiant would be a simple task.  Are you sure you are ready?','It would be unwise to assume that fighting a valiant would be a simple task.  Are you sure you are ready?',26124),
(33749,'enUS','Are you sure you are ready to fight me?','Are you sure you are ready to fight me?',26124),
(33750,'enUS','Prepare yourself!','Prepare yourself!',26124),
(33752,'enUS','On your guard!','On your guard!',26124),
(33753,'enUS','Ready yourself!','Ready yourself!',26124),
(33754,'enUS','Let it begin!','Let it begin!',26124),
(33755,'enUS','Prepare yourself!','Prepare yourself!',26124),
(33756,'enUS','On your guard!','On your guard!',26124),
(33757,'enUS','Ready yourself!','Ready yourself!',26124),
(33758,'enUS','Let it begin!','Let it begin!',26124),
(33759,'enUS','I have been defeated.  Good fight!','I have been defeated.  Good fight!',26124),
(33760,'enUS','I have been defeated.  Good fight!','I have been defeated.  Good fight!',26124),
(33761,'enUS','Dual Specialization allows you to keep two active Class Specialization, Talent, and Glyph sets and easily switch between them.\n\nYou also will have separate glyph panes and action bars for each set.\n\nSwitching between the two sets cannot be done while in combat and will consume your available resources.','Dual Specialization allows you to keep two active Class Specialization, Talent, and Glyph sets and easily switch between them.\n\nYou also will have separate glyph panes and action bars for each set.\n\nSwitching between the two sets cannot be done while in combat and will consume your available resources.',26124),
(33762,'enUS','How do I learn Dual Specialization?','How do I learn Dual Specialization?',26124),
(33763,'enUS','It seems you still need more practice.  Perhaps another time.','It seems you still need more practice.  Perhaps another time.',26124),
(33764,'enUS','It seems you still need more practice.  Perhaps another time.','It seems you still need more practice.  Perhaps another time.',26124),
(33765,'enUS','I wish to learn Dual Specialization.','I wish to learn Dual Specialization.',26124),
(33766,'enUS','Are you sure you would like to purchase Dual Specialization?','Are you sure you would like to purchase Dual Specialization?',26124),
(33767,'enUS','I yield to you.','I yield to you.',26124),
(33768,'enUS','It would seem I underestimated your skills.  Well done.','It would seem I underestimated your skills.  Well done.',26124),
(33769,'enUS','That was a well fought battle.  I yield to you.','That was a well fought battle.  I yield to you.',26124),
(33770,'enUS','%s surges with power as its companion perishes!','%s surges with power as its companion perishes!',26124),
(33771,'enUS','Victory is mine!','Victory is mine!',26124),
(33772,'enUS','I am afraid you will need more practice to defeat me.','I am afraid you will need more practice to defeat me.',26124),
(33773,'enUS','I have won.  Better luck another time, friend.','I have won.  Better luck another time, friend.',26124),
(33774,'enUS','I yield to you.','I yield to you.',26124),
(33775,'enUS','It would seem I underestimated your skills.  Well done.','It would seem I underestimated your skills.  Well done.',26124),
(33776,'enUS','That was a well fought battle.  I yield to you.','That was a well fought battle.  I yield to you.',26124),
(33777,'enUS','Victory is mine!','Victory is mine!',26124),
(33778,'enUS','I am afraid you will need more practice to defeat me.','I am afraid you will need more practice to defeat me.',26124),
(33779,'enUS','I have won.  Better luck another time, friend.','I have won.  Better luck another time, friend.',26124),
(33780,'enUS','','Glory will be ours when we win this tournament in the name of Silvermoon.',26124),
(33781,'enUS','You have now learned Dual Specialization.','You have now learned Dual Specialization.',26124),
(33782,'enUS','You have shown that you are ready for the rank of champion.','You have shown that you are ready for the rank of champion.',26124),
(33783,'enUS','Most impressive.  You are worthy to gain the rank of champion.','Most impressive.  You are worthy to gain the rank of champion.',26124),
(33784,'enUS','We have come to compete for honor, renown, and the right to fight the Scourge alongside the brothers of the Argent Crusade.','',26124),
(33785,'enUS','','King Magni expects us to win the tournament and make him proud. We will not fail.',26124),
(33786,'enUS','Gnomeregan\'s finest have come to compete in the tournament. Wish us luck!','',26124),
(33787,'enUS','You think you are ready to become a champion.  We shall see.','You think you are ready to become a champion.  We shall see.',26124),
(33788,'enUS','You believe you are ready to be a champion?  Defend yourself!','You believe you are ready to be a champion?  Defend yourself!',26124),
(33789,'enUS','We of Darnassus look forward to competing in the tournament.','',26124),
(33790,'enUS','It seems you are not ready for the rank of champion.  Some more training may serve you well.','It seems you are not ready for the rank of champion.  Some more training may serve you well.',26124),
(33791,'enUS','You have been defeated.  But do not give up.  I sense that one day you will join our ranks as a champion.','You have been defeated.  But do not give up.  I sense that one day you will join our ranks as a champion.',26124),
(33792,'enUS','This test has lasted too long.  You are not ready to be a champion.','This test has lasted too long.  You are not ready to be a champion.',26124),
(33793,'enUS','Surely you can do do better than this.  This fight has wasted my time.  You are not yet ready to be a champion.','Surely you can do do better than this.  This fight has wasted my time.  You are not yet ready to be a champion.',26124),
(33794,'enUS','When the tournament starts, all will see the Forsaken emerge triumphant.','',26124),
(33795,'enUS','The competition will be fierce, but Orgrimmar\'s champions will decimate all who stand in our way.','',26124),
(33796,'enUS','We compete not only for glory, but to bring honor to our ancestors and to our people.','',26124),
(33797,'enUS','The Darkspears stand ready to face the competition and the enemy.','',26124),
(33798,'enUS','On behalf of the Sunreavers, I welcome you to the tournament. The Argent Crusade has asked us to register and train those interested in competing.','',26124),
(33799,'enUS','Are you prepared to fight a valiant of the Argent Crusade?','Are you prepared to fight a valiant of the Argent Crusade?',26124),
(33800,'enUS','When you are ready to test for the rank of valiant, I will call forth a member of the Argent Crusade.','When you are ready to test for the rank of valiant, I will call forth a member of the Argent Crusade.',26124),
(33801,'enUS','This is the ring where the champions practice fighting each other. It\'s my job to summon the knights to their practice battles.','',26124),
(33802,'enUS','Ask Cavin to summon the Black Knight.','Ask Cavin to summon the Black Knight.',26124),
(33803,'enUS','$n challenges the Black Knight to trial by combat!','',26124),
(33804,'enUS','Good luck, $n.','',26124),
(33805,'enUS','Someone\'s already made a challenge. The ring will be free when the fight is over.','',26124),
(33806,'enUS','The Black Knight has been defeated!','',26124),
(33807,'enUS','Enough of this insolence! Prepare to die!','',26124),
(33808,'enUS','Deactivating.','',26124),
(33809,'enUS','You\'re going to be so nice and warm down here with us forever, beautiful!','',26124),
(33810,'enUS','Welcome, friend, welcome! There\'s always room for one more!','',26124),
(33811,'enUS','Hi! My name\'s Uthil. We\'re going to be such good friends once you\'re dead!','',26124),
(33812,'enUS','Grow, little one.','',26124),
(33813,'enUS','There you are.','',26124),
(33814,'enUS','Help shield us from these cutting winds, little sapling.','',26124),
(33815,'enUS','Good luck to you in there. I\'ll try to find you farther inside once the concourse is clear.','',26124),
(33816,'enUS','Ready to move out, keep those dwarves off of our backs!','Ready to move out, keep those dwarves off of our backs!',26124),
(33817,'enUS','Stand back, $n. I must cleanse the Forest Heart.','',26124),
(33818,'enUS','We have lost our engineers, this will not end well!','',26124),
(33819,'enUS','There, the Forest Heart is now purified. Its power will replenish Ashenvale once more. We are forever in your debt, young one.','',26124),
(33820,'enUS','Give us a moment to prepare to build the turrets.','Give us a moment to prepare to build the turrets.',26124),
(33821,'enUS','Fires out! Let\'s rebuild those turrets!','Fires out! Let\'s rebuild those turrets!',26124),
(33822,'enUS','Me not like ground shaking....','Me not like ground shaking....',26124),
(33823,'enUS','Wh-what happening!?!','Wh-what happening!?!',26124),
(33824,'enUS','Splintertree under attack!!','Splintertree under attack!!',26124),
(33825,'enUS','Splintertree is surrounded!','Splintertree is surrounded!',26124),
(33826,'enUS','%s surrounds itself with a void barrier as a dark shadow coalesces nearby!','',26124),
(33827,'enUS','How did we get up here, anyways?','How did we get up here, anyways?',26124),
(33828,'enUS','NOW look where the ground is! Let me drive.','NOW look where the ground is! Let me drive.',26124),
(33829,'enUS','Get to work, dogs! We\'re behind schedule!','',26124),
(33830,'enUS','Dig! Dig! Dig!','',26124),
(33831,'enUS','Dig faster! This ore won\'t mine itself!','',26124),
(33832,'enUS','No time for breaks! Get back to work!','',26124),
(33833,'enUS','You\'ve defeated the Iron Council and unlocked the Archivum!  Well done, lads!','',26124),
(33834,'enUS','Show support for your favorite champion! Wear their colors at the next bout and let \'em know who you love!','',26124),
(33835,'enUS','Want to show your pride without flailing around on one of those beasts? Whichever city you\'re rooting for, I got what you need!','',26124),
(33836,'enUS','Hey! Check out these doublets! Now you can sport your city\'s colors without having a tabard flapping around and getting in the way!','',26124),
(33837,'enUS','This tournament is the biggest event in ages! Buy something to bring home to your family and show your kids.','',26124),
(33838,'enUS','$n!','$n!',26124),
(33839,'enUS','$n is looking winded!','$n is looking winded!',26124),
(33840,'enUS','On your guard, $n!','On your guard, $n!',26124),
(33841,'enUS','Be strong, $n!','Be strong, $n!',26124),
(33842,'enUS','Hit them harder, $n!','Hit them harder, $n!',26124),
(33843,'enUS','I cannot believe $n is still standing!','I cannot believe $n is still standing!',26124),
(33844,'enUS','Do not lower your guard, $n!','Do not lower your guard, $n!',26124),
(33845,'enUS','Do not give up, $n!','Do not give up, $n!',26124),
(33846,'enUS','$n!','$n!',26124),
(33847,'enUS','$n is looking winded!','$n is looking winded!',26124),
(33848,'enUS','On your guard, $n!','On your guard, $n!',26124),
(33849,'enUS','Be strong, $n!','Be strong, $n!',26124),
(33850,'enUS','Hit them harder, $n!','Hit them harder, $n!',26124),
(33851,'enUS','I cannot believe $n is still standing!','I cannot believe $n is still standing!',26124),
(33852,'enUS','Do not lower your guard, $n!','Do not lower your guard, $n!',26124),
(33853,'enUS','Do not give up, $n!','Do not give up, $n!',26124),
(33854,'enUS','|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 4%% Sanity Lost|r','|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 4%% Sanity Lost|r',26124),
(33855,'enUS','You must remain within the Argent Tournament grounds.','You must remain within the Argent Tournament grounds.',26124),
(33856,'enUS','%s consumes a scrap bot to repair himself!','',26124),
(33857,'enUS','Harpoon Turret is ready for use!','',26124),
(33858,'enUS','','You there! We need able bodies as fast as possible. Lives depend on it!',26124),
(33859,'enUS','There are secrets contained within these halls that are beyond our wildest dreams.','',26124),
(33860,'enUS','','Priestesses, I am to bring word that there are more survivors incoming. They are doing everything they can to sift through for the ones that are still alive, please send any help that you can!',26124),
(33861,'enUS','','Understood, Sentinel. Return to the beach and aid them in bringing back any that are still alive.',26124),
(33862,'enUS','','When the wounded arrive, we will be putting them up in the Inn while we tend to their recovery. Please find us there when you return.',26124),
(33863,'enUS','','Of course, Priestess.',26124),
(33864,'enUS','Kologarn casts Stone Grip!','',26124),
(33865,'enUS','Are you sure you are ready to fight a champion?','Are you sure you are ready to fight a champion?',26124),
(33866,'enUS','It would be unwise to assume that fighting a champion would be a simple task.  Are you sure you are ready?','It would be unwise to assume that fighting a champion would be a simple task.  Are you sure you are ready?',26124),
(33867,'enUS','Are you sure you are ready to fight me?','Are you sure you are ready to fight me?',26124),
(33868,'enUS','I have been defeated.  Good fight!','I have been defeated.  Good fight!',26124),
(33869,'enUS','%s whirs and beeps menacingly...','',26124),
(33870,'enUS','It seems you still need more practice.  Perhaps another time.','It seems you still need more practice.  Perhaps another time.',26124),
(33871,'enUS','LET IT BE FINISHED!','',26124),
(33872,'enUS','Commencing watcher Freya status analysis.','',26124),
(33873,'enUS','Watcher powers augmented by presence of elder servants.','',26124),
(33874,'enUS','Analyzing Elder Brightleaf enhancement.... Persistent area defenses powered by solar amplification.','',26124),
(33875,'enUS','Elder Stonebark analysis reveals a sonic defense that disrupts use of magic.','',26124),
(33876,'enUS','Elder Ironbranch scans have uncovered plant-based immobilization mechanisms.','',26124),
(33877,'enUS','In addition, my analysis links each elder to an increase in Freya\'s spellcasting, physical, or summoning capabilities.','',26124),
(33878,'enUS','Destruction of elder servants will result in loss of enhancements on watcher Freya. However, permanent damage to Freya\'s person and possessions, including her watcher sigil, highly probable.','',26124),
(33880,'enUS','Commencing watcher Thorim status analysis.','',26124),
(33881,'enUS','An external influence, under illusory guise of Thorim\'s deceased mate, Sif, has been detected.','',26124),
(33882,'enUS','Mental interference from this presence dangerously close to triggering partial memory damage.','',26124),
(33883,'enUS','Commencing watcher Hodir status analysis.','',26124),
(33884,'enUS','Hodir\'s sigil appears to be located inside a cache of artifacts.','',26124),
(33885,'enUS','Watcher Hodir\'s temperament and behavior highly unstable. Destruction of cache highly probable during prolonged combat.','',26124),
(33886,'enUS','Allies present in the field of battle are likely to provide synergies and minimize combat duration.','',26124),
(33887,'enUS','Commencing watcher Mimiron status analysis.','',26124),
(33888,'enUS','Watcher Mimiron\'s sigil is linked to a self-destruct mechanism connected to the entirety of the Corridors of Ingenuity.','',26124),
(33889,'enUS','Trigger for self-destruct mechanism is codenamed \"Big Red Button\", Mimiron\'s own creation.','',26124),
(33890,'enUS','To retrieve Mimiron\'s sigil, initiate self-destruct sequence and defeat Mimiron before its completion.','',26124),
(33891,'enUS','|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 12%% Sanity Lost|r','|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 12%% Sanity Lost|r',26124),
(33892,'enUS','Well, $c, that was... subtle.','',26124),
(33893,'enUS','I must resume my duties, $c.','',26124),
(33894,'enUS','Entry denied.  Access level insufficient.','',26124),
(33895,'enUS','Access to the Archivum granted.  Intrusion protection mechanisms suspended.','',26124),
(33896,'enUS','Initiating query.  The Algalon Failsafe is an automated emergency signal following a Prime Designate\'s demise.','',26124),
(33897,'enUS','Affirmative.  Timestamp of Prime Designate Loken\'s destruction coincides with signal activation.','',26124),
(33898,'enUS','Searching...  Destruction of Prime Designate is considered the first warning sign of systemic  planetary failure.  Algalon observer entity\'s arrival is followed by planetary diagnostics resulting in one of two possible reply signals.  Reply-code Alpha, signaling \"All is well\" and Reply-code Omega, signaling planetary re-origination.','',26124),
(33899,'enUS','The decomposition of the planet and its living organisms into base elements: metals, rocks, gases. This is followed by a period of reconstitution of each element into the original planetary blueprint.','',26124),
(33900,'enUS','Request denied.  Reply-codes built into Algalon observer entity.  He is both messenger and message.','',26124),
(33901,'enUS','Algalon diagnostics assess danger of systemic Old God corruption in planetary vital functions.  Calculating chance of Omega Reply-code...','',26124),
(33902,'enUS','Ninety-nine point nine nine percent.','',26124),
(33903,'enUS','That\'s repeating, of course.','',26124),
(33904,'enUS','Now, this is what we call a nice find!','',26124),
(33905,'enUS','I\'ll show ye access, ye wretched machine. Here it is again: Norgannon\'s key!','',26124),
(33906,'enUS','Looks just like all the other titan archives me lads have found... only older... and bigger.','',26124),
(33907,'enUS','Wait a second: this doesn\'t look right! Next to this blinking light... what\'s this Algalon signal? ','',26124),
(33908,'enUS','Prime Designate? Where have I \'eard that before? By my grandfather\'s beard, Loken is Azeroth\'s Prime Designate. Loken\'s death triggered this!','',26124),
(33909,'enUS','Well? Who\'s on the listening side of the signal? What\'s going to happen?','',26124),
(33910,'enUS','Planetary re-origination? Speak plainly, ye blasted machine!','',26124),
(33911,'enUS','Hear that, lads? It\'s only the end of the world! Well, what are ye waiting for, ye rusty machine? Initiate Reply-code Alpha. All is well! Pints are on me!','',26124),
(33912,'enUS','Well, what\'s this Algalon going to be looking for with his diagnostics? What are our chances?','',26124),
(33913,'enUS','Blast it, lads. Looks like we\'ve got a fight ahead of us.','',26124),
(33914,'enUS','','Hefting',26124),
(33915,'enUS','A thousand deaths...','',26124),
(33916,'enUS','Or one murder.','',26124),
(33917,'enUS','Blood of War','Blood of War',26124),
(33918,'enUS','The Displacement Pad appears to be active and stable.','The Displacement Pad appears to be active and stable.',26124),
(33919,'enUS','Teleport to the Expedition Base Camp.','Teleport to the Expedition Base Camp.',26124),
(33920,'enUS','Teleport to the Formation Grounds.','Teleport to the Formation Grounds.',26124),
(33921,'enUS','Teleport to the Colossal Forge.','Teleport to the Colossal Forge.',26124),
(33922,'enUS','Teleport to the Scrapyard.','Teleport to the Scrapyard.',26124),
(33923,'enUS','Teleport to the Antechamber of Ulduar.','Teleport to the Antechamber of Ulduar.',26124),
(33924,'enUS','Teleport to the Shattered Walkway.','Teleport to the Shattered Walkway.',26124),
(33925,'enUS','Teleport to the Halls of Winter.','Teleport to the Halls of Winter.',26124),
(33926,'enUS','Teleport to the Conservatory of Life.','Teleport to the Conservatory of Life.',26124),
(33927,'enUS','Teleport to the Spark of Imagination.','Teleport to the Spark of Imagination.',26124),
(33928,'enUS','Teleport to the Descent into Madness.','Teleport to the Descent into Madness.',26124),
(33929,'enUS','','On behalf of the Argent Crusade, I welcome you to the Argent Tournament.',26124),
(33930,'enUS','No one builds it faster, cheaper, and better than the Blastbolt brothers!','',26124),
(33931,'enUS','%s is grounded permanently!','%s is grounded permanently!',26124),
(33932,'enUS','New orders! Unlock the entry to the Celestial Planetarium.','',26124),
(33933,'enUS','Four watchers? Sigils? Could ye be a little less cryptic, confounded machine?','',26124),
(33934,'enUS','How do we get the sigils from them, then? Just walk up to them and ask them nicely?','',26124),
(33935,'enUS','You\'re going to tell us how to... \"un-compromise\" the sigils, aren\'t you?','',26124),
(33936,'enUS','I\'ve dreamed of roaming the halls of the titans for years. I never thought I\'d be pitted against their creations.','',26124),
(33937,'enUS','Request denied. Access requires manual verification of the four watchers\' sigils.','',26124),
(33938,'enUS','The four watchers of Ulduar: Freya, Thorim, Hodir, and Mimiron. The sigils are tied to their physical and mental integrity. All four sigils are required for access to the Celestial Planetarium.','',26124),
(33939,'enUS','Analyzing watcher status. Please wait.','',26124),
(33940,'enUS','Corruption found. External influence gaining control over watchers. Sigils compromised.','',26124),
(33941,'enUS','Sufficient use of force would trigger a reset in watcher functions, removing the external influence.','',26124),
(33942,'enUS','As for not endangering the sigils during this process, I can analyze each watcher\'s status and make that information available to you upon completion of calculations.','',26124),
(33943,'enUS','An %s attacks the treekiller.','',26124),
(33944,'enUS','A spirit appears to avenge the Crystalsong Oak!','',26124),
(33945,'enUS','An %s emerges from the dying Crystalsong Oak!','',26124),
(33946,'enUS','It\'s a real honor to be able to aid Brann in exploring ancient Ulduar.','',26124),
(33947,'enUS','Brann taught me everything I know about exploring.','Brann taught me everything I know about exploring.',26124),
(33948,'enUS','Stay your arms! I yield!','',26124),
(33949,'enUS','I feel as though I am awakening from a nightmare, but the shadows in this place yet linger.','',26124),
(33950,'enUS','Sif... was Sif here? Impossible--she died at my brother\'s hand. A dark nightmare indeed....','',26124),
(33951,'enUS','I need time to reflect.... I will aid your cause if you should require it. I owe you at least that much. Farewell.','',26124),
(33952,'enUS','You! Fiend, you are not my beloved! Begone!','',26124),
(33953,'enUS','Behold the hand behind all the evil that has befallen Ulduar, left my kingdom in ruins, corrupted my brother, and slain my wife.','',26124),
(33954,'enUS','And now it falls to you, champions, to avenge us all. The task before you is great, but I will lend you my aid as I am able. You must prevail.','',26124),
(33955,'enUS','|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 100%% Sanity Lost|r','|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 100%% Sanity Lost|r',26124),
(33956,'enUS','','For the Horde!!',26124),
(33957,'enUS','','Die, elves!!',26124),
(33958,'enUS','','Lok\'tar Ogar!!',26124),
(33959,'enUS','','Blood and thunder!!',26124),
(33960,'enUS','|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 9%% Sanity Lost|r','|TInterface\\Icons\\Spell_Arcane_MindMastery.blp:24|t|cFFFF8900 9%% Sanity Lost|r',26124),
(33961,'enUS','%s cries out for help!','',26124),
(33962,'enUS','Stand still and stare into the light!','',26124),
(33963,'enUS','Well met, $c.$B$BI train Aspirants in the art of mounted close combat.','',26124),
(33964,'enUS','Show me how to train with a Melee Target.','Show me how to train with a Melee Target.',26124),
(33965,'enUS','What is it, puny mort-$b$bErr... yes, $r? What can I do for you?','',26124),
(33966,'enUS','Preliminary testing phase complete. Now comes the true test!','',26124),
(33967,'enUS','Yes, $c? What is it?','',26124),
(33968,'enUS','The Melee Target trains Aspirants in both mounted attack and defense.$B$BApproach the Melee Target and strike it with a Thrust attack. The force of the blow often spins the target hard enough to injure you or your mount. This is where defense comes into play.$B$BBe certain to have at least one layer of Defend before attacking the target, and continue to stack and refresh Defend throughout the training exercise. Otherwise, you may well find yourself dismounted.$B$BThe same holds true in actual mounted combat: Balance attack and defense, Thrusting at every opportunity and maintaining your layers of Defend as best you can.','',26124),
(33969,'enUS','Good to see you, $n.$b$bI trust everything is going according to plan?','',26124),
(33970,'enUS','Durak, I have lost my disguise!','Durak, I have lost my disguise!',26124),
(33971,'enUS','Back to work, dogs! We\'re behind schedule!','',26124),
(33972,'enUS','Don\'t let a little elf attack get in the way of your work!','',26124),
(33973,'enUS','Get back to digging! This ore won\'t mine itself!','',26124),
(33974,'enUS','No time for breaks! Get back to work!','',26124),
(33975,'enUS','Hey there, how are ye?$B$BCome ta learn the art o\' the Charge, $c?','',26124),
(33976,'enUS','Show me how to train with a Charge Target.','Show me how to train with a Charge Target.',26124),
(33977,'enUS','Well then! A mounted Charge is about more than just kickin\' yer mount ta full speed an\' hollerin\' yer lungs out... though that IS the fun part, heh! But the Charge Target will teach ye the finer points.$B$BA good Charge is all about distance and timing. Ye can\'t be TOO close, or ye won\'t get enough speed. But ye can\'t be too far away either or yer mount will tire! As for timin\'...$B$BYe\'ll want ta make sure the Charge Target doesn\'t have a layer o\' Defend up before ye rush in. If it does, use yer Shield Breaker ta make it vulnerable, and THEN Charge in!$B$BSame goes for the real thing: Try ta drop yer opponent defenses before ye Charge!','',26124),
(33978,'enUS','%s catches a fish!','',26124),
(33979,'enUS','Well. Another $c, come to learn the ways of the Shield-Breaker...?','',26124),
(33980,'enUS','Show me how to train with a Ranged Target.','Show me how to train with a Ranged Target.',26124),
(33981,'enUS','The ranged Shield-Breaker attack is simple to learn, but difficult to master. Alone it may seem weak, but in conjunction with Thrusts and Charges the Shield-Breaker makes a successful jouster.$B$BFind a Ranged Target. Take a moment to understand the Shield-Breaker\'s range... how much space you need, and how far you can hurl the lance.$B$BAfter that? Well. Start throwing, and do not stop until you\'ve broken every last layer of Defend and pierced the vulnerable target.$B$BThis tactic will serve you well in actual mounted combat: Break down your opponents\' defenses... and then crush them!','',26124),
(33982,'enUS','We received Brann\'s message, and we have begun preparations.','',26124),
(33983,'enUS','Citizens of Dalaran! Raise your eyes to the skies and observe!','',26124),
(33984,'enUS','Today our world\'s destruction has been averted in defiance of our very makers!','',26124),
(33985,'enUS','Algalon the Observer, herald of the titans, has been defeated by our brave comrades in the depths of the titan city of Ulduar.','',26124),
(33986,'enUS','Algalon was sent here to judge the fate of our world.','',26124),
(33987,'enUS','He found a planet whose races had deviated from the titans\' blueprints. A planet where not everything had gone according to plan.','',26124),
(33988,'enUS','Cold logic deemed our world not worth saving. Cold logic, however, does not account for the power of free will. It\'s up to each of us to prove this is a world worth saving.','',26124),
(33989,'enUS','That our lives... our lives are worth living.','',26124),
(33990,'enUS','%s mutters to himself in Forsaken.','',26124),
(33991,'enUS','','Freya casts |cFF00FF00Strengthened Iron Roots!|r',26124),
(33993,'enUS','%s goes berserk, extinguishing all life!','',26124),
(33994,'enUS','Behold the tools of creation!','',26124),
(33995,'enUS','Your actions are illogical. All possible results for this encounter have been calculated. The Pantheon will receive the Observer\'s message regardless of outcome.','',26124),
(33996,'enUS','Loss of life unavoidable.','',26124),
(33997,'enUS','I do what I must.','',26124),
(33998,'enUS','See your world through my eyes: A universe so vast as to be immeasurable - incomprehensible even to your greatest minds.','',26124),
(33999,'enUS','Beware...','',26124),
(34000,'enUS','I have seen worlds bathed in the Makers\' flames, their denizens fading without as much as a whimper. Entire planetary systems born and razed in the time that it takes your mortal hearts to beat once. Yet all throughout, my own heart devoid of emotion... of empathy. I. Have. Felt. Nothing. A million-million lives wasted. Had they all held within them your tenacity? Had they all loved life as you do?','',26124),
(34001,'enUS','You are out of time.','',26124),
(34002,'enUS','Gorebag has shown me the Drakkari Empire. I am eager to help you conquer it!','Gorebag has shown me the Drakkari Empire. I am eager to help you conquer it!',26124),
(34003,'enUS','All in good time, mon. I be havin\' more work for you to do soon....','',26124),
(34004,'enUS','%s begins to Overload!','',26124),
(34005,'enUS','I have whipped the Blight Geists into shape!','I have whipped the Blight Geists into shape!',26124),
(34006,'enUS','Analysis complete. There is partial corruption in the planet\'s life-support systems as well as complete corruption in most of the planet\'s defense mechanisms.','',26124),
(34007,'enUS','Indeed you have, mon. Our stores of blight crystals be nearly sufficient!','',26124),
(34008,'enUS','I have defeated Darmuk! How else may I serve you?','I have defeated Darmuk! How else may I serve you?',26124),
(34010,'enUS','Darmuk\'s incompetence be hinderin\' us no more! Patience, mon. Dere soon be more for you to do....','',26124),
(34011,'enUS','The Drakkari Chieftains have been captured! What more would you have me do?','The Drakkari Chieftains have been captured! What more would you have me do?',26124),
(34012,'enUS','Perhaps it is your imperfections... that which grants you free will... that allows you to persevere against all cosmically calculated odds. You prevail where the Titan\'s own perfect creations have failed.','',26124),
(34013,'enUS','I\'ve rearranged the reply code - your planet will be spared. I cannot be certain of my own calculations anymore.','',26124),
(34014,'enUS','Begin uplink: Reply Code: \'Omega.\' Planetary re-origination requested.','',26124),
(34015,'enUS','Farewell, mortals. Your bravery is admirable, for such flawed creatures.','',26124),
(34016,'enUS','I lack the strength to transmit the signal. You must... hurry... find a place of power... close to the skies.','',26124),
(34017,'enUS','I know just the place. Will you be all right?','',26124),
(34018,'enUS','Do not worry about my fate, Bronzen. If the signal is not transmitted in time, re-origination will proceed regardless. Save... your world...','',26124),
(34019,'enUS','With da chieftains out of da way, we be poised to make our assault! Soon, $n....','',26124),
(34020,'enUS','I have witnessed your magnificent operation, Drakuru. When do we put your plan into effect?','I have witnessed your magnificent operation, Drakuru. When do we put your plan into effect??',26124),
(34021,'enUS','Now ya be knowin\' everything, mon! Prepare yourself... we attack soon!','',26124),
(34022,'enUS','%s opens his mouth wide!','',26124),
(34023,'enUS','%s\'s heart is severed from his body.','',26124),
(34024,'enUS','I was here visiting relatives when Lordaeron fell, and then... well. I suppose I won\'t ever be returning to Westfall, now.$B$BSometimes I wonder if my family is still alive. More often, though, I wonder why I no longer care.','',26124),
(34025,'enUS','We did it, lads! We got here before Algalon\'s arrival... maybe we can rig the systems to interfere with his analysis...','',26124),
(34026,'enUS','Translocation complete. Commencing planetary analysis of Azeroth.','',26124),
(34027,'enUS','Stand back, mortals. I\'m not here to fight you.','',26124),
(34028,'enUS','It is in the universe\'s best interest to re-originate this planet should my analysis find systemic corruption. Do not interfere.','',26124),
(34029,'enUS','I\'ll head back to the Archivum and see if I can jam his signal. I might be able to buy us some time while you take care of him.','',26124),
(34031,'enUS','Now try out your skills.','',26124),
(34032,'enUS','Put up Defend$B|TInterface\\Icons\\Ability_Warrior_ShieldMastery.blp:32|t$BThen use Thrust on a Melee Target.$B|TInterface\\Icons\\INV_Sword_65.blp:32|t','Put up Defend$B|TInterface\\Icons\\Ability_Warrior_ShieldMastery.blp:32|t$BThen use Thrust on a Melee Target.$B|TInterface\\Icons\\INV_Sword_65.blp:32|t',26124),
(34033,'enUS','Gaze upon its magnificence! Bask in its glorious, um, glory! I present you with... V-07-TR-0N!','',26124),
(34034,'enUS','Use Shield-Breaker on a Charge Target.$B|TInterface\\Icons\\Ability_Warrior_ShieldBreak.blp:32|t$BFollow up with Charge while the target is vulnerable.$B|TInterface\\Icons\\Ability_Mount_Charger.blp:32|t','Use Shield-Breaker on a Charge Target.$B|TInterface\\Icons\\Ability_Warrior_ShieldBreak.blp:32|t$BFollow up with Charge while the target is vulnerable.$B|TInterface\\Icons\\Ability_Mount_Charger.blp:32|t',26124),
(34035,'enUS','Use Shield-Breaker on a Ranged Target.$B|TInterface\\Icons\\Ability_Warrior_ShieldBreak.blp:32|t$BThen use Shield-Breaker while the target is defenseless.$B|TInterface\\Icons\\Ability_Warrior_ShieldBreak.blp:32|t','Use Shield-Breaker on a Ranged Target.$B|TInterface\\Icons\\Ability_Warrior_ShieldBreak.blp:32|t$BThen use Shield-Breaker while the target is defenseless.$B|TInterface\\Icons\\Ability_Warrior_ShieldBreak.blp:32|t',26124),
(34036,'enUS','The strong odor coming from the bowl smells like a mixture of various herbs with burning hair.','',26124),
(34037,'enUS','Portals open into %s\'s mind!','',26124),
(34038,'enUS','Watcher Analysis: Freya','Watcher Analysis: Freya',26124),
(34039,'enUS','Watcher Analysis: Hodir','Watcher Analysis: Hodir',26124),
(34040,'enUS','I am ready to accompany you to Splintertree, Kadrak!','I am ready to accompany you to Splintertree, Kadrak!',26124),
(34041,'enUS','Watcher Analysis: Thorim','Watcher Analysis: Thorim',26124),
(34042,'enUS','Watcher Analysis: Mimiron','Watcher Analysis: Mimiron',26124),
(34043,'enUS','A Tempest Minion appears to defend Emalon!','',26124),
(34044,'enUS','Breathe in the smoke to entice visions of the great animal spirits.','Breathe in the smoke to entice visions of the great animal spirits.',26124),
(34045,'enUS','I will check back with you shortly, Kadrak.','I will check back with you shortly, Kadrak.',26124),
(34046,'enUS','Brutusk is out watering the bushes right now.$b$bStay close though, $n. He should be ready for our ride to Splintertree very soon.','',26124),
(34047,'enUS','Now... witness the power of a war kodo in the hands of a master!','',26124),
(34048,'enUS','%s cries out, \"I will have my vengeance!\"','',26124),
(34049,'enUS','To Splintertree!','',26124),
(34050,'enUS','You thought to stand before the legions of death and survive?','',26124),
(34051,'enUS','Defiance... a flaw of mortality.','',26124),
(34052,'enUS','Your defeat was inevitable.','',26124),
(34053,'enUS','Your destruction will herald a new age of suffering!','',26124),
(34054,'enUS','Oh, what horrors await....','',26124),
(34055,'enUS','The black blood of Yogg-Saron courses through me! I. AM. UNSTOPPABLE!','',26124),
(34056,'enUS','Behold now: terror absolute!','',26124),
(34057,'enUS','%s goes into a berserker rage!','',26124),
(34058,'enUS','Tactical analysis suggests approaching the arena from the front and splitting secondary force through a side passage at the ground level. This will maximize odds of reaching Thorim\'s outlook before mental domination by external presence is complete.','',26124),
(34059,'enUS','Preservation of cache is essential to recovering Hodir\'s sigil.','',26124),
(34060,'enUS','Please hold still for a moment.','',26124),
(34061,'enUS','Fragment analysis underway.','',26124),
(34062,'enUS','Object identified: Val\'anyr, hammer of ancient kings.','',26124),
(34063,'enUS','Created by the titans themselves, Val\'anyr was given to the first earthen king, Urel Stoneheart. With the hammer he was to create and give life to the rest of his brethren.','',26124),
(34064,'enUS','Val\'anyr was shattered during the first war between the earthen and the iron dwarves. The weapon\'s remnants were believed lost in the conflict.','',26124),
(34065,'enUS','Probability of successful repair by ordinary means available in this world is close to nil. Please hold while theoretical means are analyzed.','',26124),
(34066,'enUS','Powerful acidic content theoretically found inside the being known as Yogg-Saron would account for the liquification of saronite. Submersion in this substance might be sufficient to rebind an alloy of titan origin.','',26124),
(34067,'enUS','Sporebat','Sporebat',26124),
(34068,'enUS','Cunning Pet','Cunning Pet',26124),
(34069,'enUS','Ferocious Pet','Ferocious Pet',26124),
(34070,'enUS','Tenacious Pet','Tenacious Pet',26124),
(34071,'enUS','Aid your companions little one; the battle is joined!','',26124),
(34072,'enUS','','Aid your companions little one; the battle is joined!',26124),
(34073,'enUS','Hail, champion. Yogg-Saron\'s defeat echoes through these halls.','',26124),
(34074,'enUS','Hyena','Hyena',26124),
(34075,'enUS','Moth','Moth',26124),
(34076,'enUS','Tallstrider','Tallstrider',26124),
(34077,'enUS','Wasp','Wasp',26124),
(34078,'enUS','','Hail, champion. Yogg-Saron\'s defeat echoes through these halls.',26124),
(34079,'enUS','Bear','Bear',26124),
(34080,'enUS','Crab','Crab',26124),
(34081,'enUS','Crocolisk','Crocolisk',26124),
(34082,'enUS','Gorilla','Gorilla',26124),
(34083,'enUS','Turtle','Turtle',26124),
(34084,'enUS','Just in time. Let\'s see this thing off, then.','',26124),
(34085,'enUS','%s crackles and surges with raw energy!','',26124),
(34086,'enUS','It would appear that I\'ve made a slight miscalculation. I allowed my mind to be corrupted by the fiend in the prison, overriding my primary directive. All systems seem to be functional now. Clear.','',26124),
(34087,'enUS','Teach them the meaning of blood and thunder!','',26124),
(34088,'enUS','It is done. The spirit is bound with you and you will carry it with you anytime you are in Darkshore. May you serve nature well.','',26124),
(34089,'enUS','You must be riding a tournament mount before I can instruct you.$B$BEquip a lance and find a tournament mount outside your faction\'s pavilion.','',26124),
(34090,'enUS','Tell me more about Defend and Thrust.','Tell me more about Defend and Thrust.',26124),
(34091,'enUS','Tell me more about using the Shield-Breaker.','Tell me more about using the Shield-Breaker.',26124),
(34092,'enUS','Tell me more about the Charge.','Tell me more about the Charge.',26124),
(34093,'enUS','Now there\'s some REAL blood and thunder!!','',26124),
(34094,'enUS','Lok\'tar Ogar!!','',26124),
(34095,'enUS','','Greetings.',26124),
(34096,'enUS','','Would you like a ride?',26124),
(34097,'enUS','','Is there anything that I can help with?',26124),
(34098,'enUS','','Good to see you.',26124),
(34099,'enUS','','Looking for a ride?',26124),
(34100,'enUS','','How are you, $c?',26124),
(34101,'enUS','','A bit cold out, don\'t you think?',26124),
(34102,'enUS','','I\'m glad to see that you\'re well.',26124),
(34103,'enUS','My advice is no good to ye unless ye\'re ridin\' a tournament mount.$B$BEquip a lance and grab a tournament mount outside yer faction\'s pavilion.','',26124),
(34104,'enUS','Only champions of Stormwind may purchase what I have to offer.','',26124),
(34105,'enUS','I\'d like to travel to the Ruins of Mathystra.','I\'d like to travel to the Ruins of Mathystra.',26124),
(34106,'enUS','','Forgive me.',26124),
(34107,'enUS','','From your death springs life anew!',26124),
(34108,'enUS','I\'d like to travel to Shatterspear Vale.','I\'d like to travel to Shatterspear Vale.',26124),
(34109,'enUS','I\'d like to travel to the Bashal\'Aran.','I\'d like to travel to the Bashal\'Aran.',26124),
(34110,'enUS','I\'d like to travel to Lor\'danel.','I\'d like to travel to Lor\'danel.',26124),
(34111,'enUS','Not far now....','',26124),
(34112,'enUS','Splintertree...','',26124),
(34113,'enUS','We must break the siege!','',26124),
(34114,'enUS','For the Horde!!','For the Horde!!',26124),
(34115,'enUS','Matron, the Conservatory has been breached!','',26124),
(34116,'enUS','Not so fast, $r!$B$BOnly champions of Ironforge can purchase what I got ta offer.','',26124),
(34117,'enUS','Open the gates brothers! Let us welcome our visitors in true Horde fashion!','',26124),
(34118,'enUS','Fertilizer.','',26124),
(34119,'enUS','Your corpse will nourish the soil.','',26124),
(34120,'enUS','Apologies, $r, but only champions of Thunder Bluff may purchase what I have to offer.','',26124),
(34121,'enUS','Matron, one has fallen!','',26124),
(34122,'enUS','','Away with you, $c!$B$BOnly champions of Undercity may purchase what I have to offer.',26124),
(34123,'enUS','Mortals have no place here!','',26124),
(34124,'enUS','I return you whence you came!','',26124),
(34125,'enUS','BEGONE!','',26124),
(34126,'enUS','Freya! They come for you.','',26124),
(34127,'enUS','','Only champions of Orgrimmar may purchase what I have to offer.',26124),
(34128,'enUS','','Only champions of the Exodar may purchase what I have to offer.',26124),
(34129,'enUS','This place will serve as your graveyard.','',26124),
(34130,'enUS','Such a waste....','',26124),
(34131,'enUS','','Hi there!$B$BSorry, friend, but only champions of Gnomeregan can buy what I\'ve got.',26124),
(34132,'enUS','Matron, flee! They are ruthless....','',26124),
(34133,'enUS','None shall pass!','',26124),
(34134,'enUS','Alas, only champions of Darnassus may purchase what I have to offer.','',26124),
(34135,'enUS','KOL-THARISH!','',26124),
(34136,'enUS','','Samamba tinkin\' joo be at da wrong quartermaster!$B$BWhat she got only for de Sen\'jin champions...',26124),
(34137,'enUS','YOU FAIL!','',26124),
(34138,'enUS','I will squeeze the life from you!','',26124),
(34139,'enUS','Alas, only the esteemed champions of Silvermoon City may purchase what I have to offer.','',26124),
(34140,'enUS','OBLIVION!','',26124),
(34141,'enUS','Master, they come....','',26124),
(34142,'enUS','I am invincible!','',26124),
(34143,'enUS','Just a scratch!','',26124),
(34144,'enUS','Only a flesh wound!','',26124),
(34145,'enUS','The iron dwarves have been seen emerging from the bunkers at the base of the pillars straight ahead of you! Destroy the bunkers, and they\'ll be forced to fall back!','',26124),
(34146,'enUS','Watch out! Our air scouts report that the generators for the missile silos are coming online!','',26124),
(34147,'enUS','There are four generators powering the defense structures. If you sabotage the generators, the missile attacks will stop!','',26124),
(34148,'enUS','This tower powers the Hammer of Hodir. It is said to have the power to turn entire armies to ice! ','',26124),
(34149,'enUS','You\'re approaching the tower of Freya. It contains the power to turn barren wastelands into jungles teeming with life overnight. ','',26124),
(34150,'enUS','This generator powers Mimiron\'s Gaze. In moments, it can turn earth to ash, stone to magma--we cannot let it reach full power!','',26124),
(34151,'enUS','Ah, the tower of Krolmir. It is said that the power of Thorim has been used only once... and that it turned an entire continent to dust. ','',26124),
(34152,'enUS','The control unit for the missile generator is on the top floor of the tower. If you can find a way to get up there, you can shut it down yourselves.','',26124),
(34153,'enUS','It appears you are near a repair station! Drive your vehicle onto the platform, and it should be automatically repaired.','',26124),
(34154,'enUS','You\'ve done it! You\'ve broken the defenses of Ulduar. In a few moments, we will be dropping in to...','',26124),
(34155,'enUS','What is that? Be careful! Something\'s headed your way!','',26124),
(34156,'enUS','Quickly! Evasive action! Evasive act--','',26124),
(34157,'enUS','Okay! Let\'s move out. Get into your machines; I\'ll speak to you from here via the radio!','',26124),
(34158,'enUS','','Be sure to stop by the bridges southeast of town. You should be able to secure a nightsaber to get you down to the ruins.',26124),
(34159,'enUS','','Don\'t forget to check near the bridges southeast of town for a ride up to our forward post.',26124),
(34160,'enUS','Make \'em pay, Brutusk!','',26124),
(34161,'enUS','We did it, lads! We got here before Algalon\'s arrival. Maybe we can rig the systems to interfere with his analysis--','',26124),
(34162,'enUS','','%s begins to activate the Feral Defender!',26124),
(34163,'enUS','Your flesh is forfeit!','',26124),
(34164,'enUS','Blood and Thunder!','Blood and Thunder!',26124),
(34165,'enUS','Drive them back! Back to Darnassus!','',26124),
(34166,'enUS','I want to see every scrap of paper you wretches get your claws on.','',26124),
(34167,'enUS','I said, SEARCH the bodies BEFORE you eat them!','',26124),
(34168,'enUS','Leave no stone unturned. I mean that literally, you heaps of decay! Tear this place apart if you have to.','',26124),
(34169,'enUS','Get off that horse and fight me man-to-man!','',26124),
(34170,'enUS','%s prepares to unleash Empowering Shadows!','',26124),
(34171,'enUS','Brutusk... NOOOOOO!!','',26124),
(34172,'enUS','Everyone... back to Splintertree at once!','',26124),
(34173,'enUS','Getting these replacements up here was no easy feat. Make it worth our while, will ya?','Getting these replacements up here was no easy feat. Make it worth our while, will ya?',26124),
(34174,'enUS','You\'ll get\'m this time. Show no mercy!','You\'ll get\'m this time. Show no mercy!',26124),
(34175,'enUS','Replacement siege vehicles brought right to your doorstep in no time flat. Can\'t ask for better service than that!','Replacement siege vehicles brought right to your doorstep in no time flat. Can\'t ask for better service than that!',26124),
(34176,'enUS','That last time was just practice, right? You\'ve got this!','That last time was just practice, right? You\'ve got this!',26124),
(34177,'enUS','Don\'t worry one bit, we had replacements ready. Can\'t expect to always get it first go, you know.','Don\'t worry one bit, we had replacements ready. Can\'t expect to always get it first go, you know.',26124),
(34178,'enUS','Wow, that\'s one big tank! You\'ve got more guts than I do. Good luck to ya!','Wow, that\'s one big tank! You\'ve got more guts than I do. Good luck to ya!',26124),
(34179,'enUS','We\'ve got your back... and a hefty supply of vehicles to fix up too apparently.','We\'ve got your back... and a hefty supply of vehicles to fix up too apparently.',26124),
(34180,'enUS','Aww, I told you take care of her. I poured my heart and soul into that thing, you know? Take it easy this time around.','Aww, I told you take care of her. I poured my heart and soul into that thing, you know? Take it easy this time around.',26124),
(34181,'enUS','','%s quietly slips into the underbrush.',26124),
(34182,'enUS','The siege is broken... for now. Follow me to Splintertree.','',26124),
(34183,'enUS','Not a bit. For the life of me, I can\'t figure out how this thing works.','Not a bit. For the life of me, I can\'t figure out how this thing works.',26124),
(34184,'enUS','Any luck?','Any luck?',26124),
(34185,'enUS','I will not fail you, master!','',26124),
(34186,'enUS','Keep at it. If our suspicions are right and this is a transporter, it could prove extremely useful in our assault.','Keep at it. If our suspicions are right and this is a transporter, it could prove extremely useful in our assault.',26124),
(34187,'enUS','I know, I know... I haven\'t given up yet. Don\'t get your hopes up though, this technology is way beyond me.','I know, I know... I haven\'t given up yet. Don\'t get your hopes up though, this technology is way beyond me.',26124),
(34188,'enUS','Your petty quarrels only make me stronger.','',26124),
(34189,'enUS','The darned thing just started working! This should take you right up to the end of the concourse, where you last fought the Flame Leviathan.','The darned thing just started working! This should take you right up to the end of the concourse, where you last fought the Flame Leviathan.',26124),
(34190,'enUS','We\'ve moved the replacement vehicles up already so that you can take the thing down this time. Good luck!','We\'ve moved the replacement vehicles up already so that you can take the thing down this time. Good luck!',26124),
(34191,'enUS','Rip it to pieces!','Rip it to pieces!',26124),
(34192,'enUS','Thank you all for attending this sermon. It\'s wonderful to see so many familiar faces!','Thank you all for attending this sermon. It\'s wonderful to see so many familiar faces!',26124),
(34193,'enUS','Today I would like to touch on the three virtues of the Light.','Today I would like to touch on the three virtues of the Light.',26124),
(34194,'enUS','These are dark and difficult times for us all. The armies of the Scourge amass to the south. Companions fall on the battlefield and rise to serve our enemy moments later.','These are dark and difficult times for us all. The armies of the Scourge amass to the south. Companions fall on the battlefield and rise to serve our enemy moments later.',26124),
(34195,'enUS','What can you tell me, Keynira?','',26124),
(34196,'enUS','Many of you have experienced a betrayal of trust.','Many of you have experienced a betrayal of trust.',26124),
(34197,'enUS','Yet you persevere, as we all must. In these times, no one is a stranger to the virtue of tenacity. In the face of despair and hatred, we continue to stand true to our beliefs and fight on.','Yet you persevere, as we all must. In these times, no one is a stranger to the virtue of tenacity. In the face of despair and hatred, we continue to stand true to our beliefs and fight on.',26124),
(34198,'enUS','That will do for the moment. And the tower? What of Althalaxx?','',26124),
(34199,'enUS','There can be no doubt as to your tenacity... but there are other virtues to consider.','There can be no doubt as to your tenacity... but there are other virtues to consider.',26124),
(34200,'enUS','Respect is the first virtue taught to those joining the path of the Light.','Respect is the first virtue taught to those joining the path of the Light.',26124),
(34201,'enUS','Look across the aisle to those you would call enemy. Despite the hatred that separates you, there are qualities to respect in your opponent. Their prowess should be acknowledged.','Look across the aisle to those you would call enemy. Despite the hatred that separates you, there are qualities to respect in your opponent. Their prowess should be acknowledged.',26124),
(34202,'enUS','All of us gathered here have a concept of honorable combat. Conducting yourself with honor and treating your opponent as you wish to be treated shows respect.','All of us gathered here have a concept of honorable combat. Conducting yourself with honor and treating your opponent as you wish to be treated shows respect.',26124),
(34203,'enUS','Respect your opponent on the field, whether he be your brother or your sworn enemy. No matter where your beliefs truly lie, such respect is acknowledging a connection...','Respect your opponent on the field, whether he be your brother or your sworn enemy. No matter where your beliefs truly lie, such respect is acknowledging a connection...',26124),
(34204,'enUS','That\'s all you\'ve got for me? I want numbers, locations, intentions - we\'re as good as blind. Get back out in the field!','',26124),
(34205,'enUS','...and in acknowledging those connections, you are closer to the Light.','...and in acknowledging those connections, you are closer to the Light.',26124),
(34206,'enUS','There is one further step on the path of Light: compassion.','There is one further step on the path of Light: compassion.',26124),
(34207,'enUS','Rivalries abound in this day and age. It is easy to see differences wherever you turn.','Rivalries abound in this day and age. It is easy to see differences wherever you turn.',26124),
(34208,'enUS','The challenge is in looking beyond appearances and understanding our similarities. Through this understanding, you can feel compassion for the losses others have suffered...','The challenge is in looking beyond appearances and understanding our similarities. Through this understanding, you can feel compassion for the losses others have suffered...',26124),
(34209,'enUS','...even if the victim bears another banner.','...even if the victim bears another banner.',26124),
(34210,'enUS','By feeling and understanding compassion in enemy and ally alike, you reaffirm your connection with the world.','By feeling and understanding compassion in enemy and ally alike, you reaffirm your connection with the world.',26124),
(34211,'enUS','Acting on these tenets, these virtues, help make the world a place we all can appreciate. A world of honor and justice.','Acting on these tenets, these virtues, help make the world a place we all can appreciate. A world of honor and justice.',26124),
(34212,'enUS','Think on my words, friends. In the darkness that surrounds us all, the Light is needed more than ever.','Think on my words, friends. In the darkness that surrounds us all, the Light is needed more than ever.',26124),
(34213,'enUS','','The catapults remain disabled. I\'ve burned several and trapped the others.',26124),
(34214,'enUS','','I - I don\'t know. There\'s movement in the ruins.',26124),
(34215,'enUS','','Shhhh - Please don\'t give away my position when I\'m out in the field. Mathas needs to know what\'s happening out here.',26124),
(34216,'enUS','I\'ll be behind the confessional screen if anyone wishes to speak with me. Any doubts, any worries, any uncertainties I will happily soothe.','I\'ll be behind the confessional screen if anyone wishes to speak with me. Any doubts, any worries, any uncertainties I will happily soothe.',26124),
(34217,'enUS','%s begins to cast Plasma Blast!','',26124),
(34218,'enUS','','Let us put an end to this Shatterspear threat for good. Sentinels, attack now!',26124),
(34219,'enUS','','I\'ve shattered the shield protecting their leader! Quickly, kill him!',26124),
(34220,'enUS','We do not act alone in this. Whatever happens to us this day, the night elves will still fall!','',26124),
(34221,'enUS','','It was folly for them to think us weak amidst recent events. There is no more hope for these trolls  - we will end this today.',26124),
(34222,'enUS','I am ready. Begin the attack.','I am ready. Begin the attack.',26124),
(34223,'enUS','','Let me know when you are ready to begin the attack.',26124),
(34224,'enUS','','We\'re expecting the Shatterspear Leader to show here at any moment. Be patient if you wish to join the attack.',26124),
(34225,'enUS','What a battle! Did you see that, Rhydian?!','',26124),
(34226,'enUS','Perhaps so, but it\'s only a matter of time until we break back into Ulduar. Any luck finding a way to teleport inside?','',26124),
(34227,'enUS','','Our friends fought well, Brann, but we\'re not done yet.',26124),
(34228,'enUS','','None at all. I suspect it has something to do with that giant mechanical construct that our scouts spotted in front of the gate.',26124),
(34229,'enUS','Oi. So we\'ll have to contend with that thing after all then?','',26124),
(34230,'enUS','','The Kirin Tor can\'t possibly spare any additional resources to take on anything that size. We may not have to though.',26124),
(34231,'enUS','What about the plated proto-drake and the fire giant that were spotted nearby? Think your mages can handle those?','',26124),
(34232,'enUS','','We can sneak past them. As long as we can take down that construct in front of the gate, we should be able to get inside.',26124),
(34233,'enUS','Sneak?! What do you think we are, marmots?','',26124),
(34234,'enUS','','We\'re hunting an old god, Brann. ',26124),
(34235,'enUS','Fine. If our allies are going to be the ones getting their hands dirty, we\'ll leave it to them to decide how to proceed.','',26124),
(34236,'enUS','Great job with that metal monstrosity. There appears to be only a few more obstacles in our way.$B$BOnce you clear out that clanking robot at the end of the hall, we\'ll be inside Ulduar.$B$BWe also noticed an enormous, fire-breathing protodrake and a molten giant. They aren\'t in our way, though, if you\'d like to just avoid them. ','',26124),
(34237,'enUS','You must remain within the field of battle.','You must remain within the field of battle.',26124),
(34238,'enUS','I am on a task from Kadrak. I must get to Zoram\'gar right away!','I am on a task from Kadrak. I must get to Zoram\'gar right away!',26124),
(34239,'enUS','Can\'t you at least put up a fight?','',26124),
(34240,'enUS','Pathetic.','',26124),
(34241,'enUS','Do not hold back! Destroy them!','',26124),
(34242,'enUS','Welcome to the tournament, $n.','',26124),
(34243,'enUS','','It\'s good to see you here, $n.',26124),
(34244,'enUS','Now, why would you go and do something like that? Didn\'t you see the sign that said, \"DO NOT PUSH THIS BUTTON!\"? How will we finish testing with the self-destruct mechanism active?','',26124),
(34245,'enUS','I seek training in Fishing.','I seek training in Fishing.',26124),
(34246,'enUS','I don\'t know if I can compete! Everyone is so much bigger!','I don\'t know if I can compete! Everyone is so much bigger!',26124),
(34247,'enUS','I\'ve calculated the probability of my success, and it\'s distressingly low!','I\'ve calculated the probability of my success, and it\'s distressingly low!',26124),
(34248,'enUS','I can\'t accurately assess the mathematics behind the charge of my turbostrider while keeping hold of my lance at the precise angle needed and keeping my shield in the exact location for maximum protection at any given second!','I can\'t accurately assess the mathematics behind the charge of my turbostrider while keeping hold of my lance at the precise angle needed and keeping my shield in the exact location for maximum protection at any given second!',26124),
(34249,'enUS','...and some of those mounts can trample me!','...and some of those mounts can trample me!',26124),
(34250,'enUS','Take heart. Size isn\'t what matters, but how you use the skills you have.','Take heart. Size isn\'t what matters, but how you use the skills you have.',26124),
(34251,'enUS','What you lack in size you make up for in ambition and dedication, little one. Go with the Light.','What you lack in size you make up for in ambition and dedication, little one. Go with the Light.',26124),
(34252,'enUS','I punched a penguin on my way in here.','I punched a penguin on my way in here.',26124),
(34253,'enUS','Nah, not really. I just wanted to see the look on your face.','Nah, not really. I just wanted to see the look on your face.',26124),
(34254,'enUS','Oh, my. Do you feel remorseful, at least?','Oh, my. Do you feel remorseful, at least?',26124),
(34255,'enUS','Lass, I\'ve a confession to make to ya.','Lass, I\'ve a confession to make to ya.',26124),
(34256,'enUS','I\'ve been feelin\'... urges.','I\'ve been feelin\'... urges.',26124),
(34257,'enUS','It was a powerful feelin\' while I was listenin\' to yer sermon, and it\'s drivin\' me nuts!','It was a powerful feelin\' while I was listenin\' to yer sermon, and it\'s drivin\' me nuts!',26124),
(34258,'enUS','...I NEED A DRINK!','...I NEED A DRINK!',26124),
(34259,'enUS','Drink in moderation, then, my dwarven friend, but you may want to turn in your lance and reins for the time being. Go with the Light.','Drink in moderation, then, my dwarven friend, but you may want to turn in your lance and reins for the time being. Go with the Light.',26124),
(34260,'enUS','My heart hangs heavier with each passing day, Confessor.','My heart hangs heavier with each passing day, Confessor.',26124),
(34261,'enUS','I have been ordered here, and here I stay and fight under the banner of Stormwind. But everything I do here is empty.','I have been ordered here, and here I stay and fight under the banner of Stormwind. But everything I do here is empty.',26124),
(34262,'enUS','Beyond these reaches, the Scourge continue their work, destroying more and more of what we\'ve built. The fight should be there. I should be there.','Beyond these reaches, the Scourge continue their work, destroying more and more of what we\'ve built. The fight should be there. I should be there.',26124),
(34263,'enUS','How can I justify jousting while people die without my protection?','How can I justify jousting while people die without my protection?',26124),
(34264,'enUS','Your heart is in the right place, and I know you seek to serve the Light. But these small strikes do little to the great undead host.','Your heart is in the right place, and I know you seek to serve the Light. But these small strikes do little to the great undead host.',26124),
(34265,'enUS','This tournament is helping to form a strong, concerted force, though it may not appear obvious. When we\'re ready, the eyes of the Crusade and all its champions will turn toward Icecrown.','This tournament is helping to form a strong, concerted force, though it may not appear obvious. When we\'re ready, the eyes of the Crusade and all its champions will turn toward Icecrown.',26124),
(34266,'enUS','We will bring the might of all races to the Lich King, and he will be defeated.','We will bring the might of all races to the Lich King, and he will be defeated.',26124),
(34267,'enUS','I know this does not seem like the obvious path to you, but it will bring you closer to the Light. Fight well, brother.','I know this does not seem like the obvious path to you, but it will bring you closer to the Light. Fight well, brother.',26124),
(34268,'enUS','','Self-destruct sequence initiated.',26124),
(34269,'enUS','This isn\'t honorable combat. I long to face my opponents in battle with my axe in hand!','This isn\'t honorable combat. I long to face my opponents in battle with my axe in hand!',26124),
(34270,'enUS','These are my enemies. YOU would be my enemy in battle! Your king has declared war on my kind!','These are my enemies. YOU would be my enemy in battle! Your king has declared war on my kind!',26124),
(34271,'enUS','But instead of fighting as my people would, as my people should, I find myself with a long, unwieldy pole, attempting to coax my wolf into charging my opponent without attacking.','But instead of fighting as my people would, as my people should, I find myself with a long, unwieldy pole, attempting to coax my wolf into charging my opponent without attacking.',26124),
(34272,'enUS','This is not how orcs fight! My duty to the Warchief wars with my personal honor. I hold no faith in your Light, but as you seem an advisor, I would hear your words.','This is not how orcs fight! My duty to the Warchief wars with my personal honor. I hold no faith in your Light, but as you seem an advisor, I would hear your words.',26124),
(34273,'enUS','','This area will self-destruct in six minutes.',26124),
(34274,'enUS','','This area will self-destruct in five minutes.',26124),
(34275,'enUS','','This area will self-destruct in four minutes.',26124),
(34276,'enUS','','This area will self-destruct in three minutes.',26124),
(34277,'enUS','','This area will self-destruct in two minutes.',26124),
(34278,'enUS','','This area will self-destruct in one minute.',26124),
(34279,'enUS','','Self-destruct sequence finalized. Have a nice day!',26124),
(34280,'enUS','','This area will self-destruct in seven minutes.',26124),
(34281,'enUS','','This area will self-destruct in eight minutes.',26124),
(34282,'enUS','','This area will self-destruct in nine minutes.',26124),
(34283,'enUS','','This area will self-destruct in ten minutes.',26124),
(34284,'enUS','','Self-destruct sequence terminated. Override code A-9-0-5.',26124),
(34285,'enUS','I understand your frustration. Your people are ferocious in battle, and this isn\'t what you\'re used to.','I understand your frustration. Your people are ferocious in battle, and this isn\'t what you\'re used to.',26124),
(34286,'enUS','But this is a different sort of honorable combat. Difficult to adapt to, perhaps, but with your prowess I\'m sure you\'ll show everyone the strength in your people.','But this is a different sort of honorable combat. Difficult to adapt to, perhaps, but with your prowess I\'m sure you\'ll show everyone the strength in your people.',26124),
(34287,'enUS','Besides... while an axe can be a valuable tool in war, lances have their uses as well.','Besides... while an axe can be a valuable tool in war, lances have their uses as well.',26124),
(34288,'enUS','Go with the Light, orc.','Go with the Light, orc.',26124),
(34289,'enUS','This fighting is endless. I\'m not certain how much more of it I can stand.','This fighting is endless. I\'m not certain how much more of it I can stand.',26124),
(34290,'enUS','All of this posturing, all of this dancing about in rings... it seems pointless. What\'s the use?','All of this posturing, all of this dancing about in rings... it seems pointless. What\'s the use?',26124),
(34291,'enUS','And I\'m beginning to get HELMET HAIR. This is a travesty!','And I\'m beginning to get HELMET HAIR. This is a travesty!',26124),
(34292,'enUS','It may seem pointless, but try to find pride in a good fight. The time will come when all this practicing and competition will be put to good use.','It may seem pointless, but try to find pride in a good fight. The time will come when all this practicing and competition will be put to good use.',26124),
(34293,'enUS','And your hair looks wonderful.','And your hair looks wonderful.',26124),
(34294,'enUS','The illusion shatters and a path to the central chamber opens!','',26124),
(34295,'enUS','The Left Arm has regrown!','',26124),
(34296,'enUS','The Right Arm has regrown!','',26124),
(34297,'enUS','It takes a lot of dedication to train and ride a Venomhide.','',26124),
(34298,'enUS','Oh, my! I wasn\'t expecting company! The workshop is such a mess. How embarrassing.','',26124),
(34299,'enUS','MEDIC!','',26124),
(34300,'enUS','I can fix that... or  maybe not! Sheesh, what a mess...','',26124),
(34301,'enUS','Fascinating. I think they call that a \"clean kill\".','',26124),
(34302,'enUS','Note to self: Cannon highly effective against flesh.','',26124),
(34303,'enUS','Outplayed!','',26124),
(34304,'enUS','You can do better than that!','',26124),
(34305,'enUS','Oh, my! It would seem that we are out of time, my friends.','',26124),
(34306,'enUS','Insolent whelps! Your blood will temper the weapons used to reclaim this world!','',26124),
(34307,'enUS','Arise, soldiers of the iron crucible! The Maker\'s will be done!','',26124),
(34308,'enUS','I will burn away your impurities!','',26124),
(34309,'enUS','Let the inferno consume you!','',26124),
(34310,'enUS','BURN! Burn in the Maker\'s fire!','',26124),
(34311,'enUS','More scraps for the scrap heap.','',26124),
(34312,'enUS','Your bones will serve as kindling.','',26124),
(34313,'enUS','I. Have. Failed.','',26124),
(34314,'enUS','Whether the world\'s greatest gnats or the world\'s greatest heroes, you are still only mortal.','',26124),
(34315,'enUS','A merciful kill!','',26124),
(34316,'enUS','HAH!','',26124),
(34317,'enUS','Let the storm clouds rise and rain down death from above!','',26124),
(34318,'enUS','The power of the storm lives on.','',26124),
(34319,'enUS','You rush headlong into the maw of madness!','',26124),
(34320,'enUS','This meeting of the Assembly of Iron is adjourned!','',26124),
(34321,'enUS','You will not defeat the Assembly of Iron so easily, invaders!','',26124),
(34322,'enUS','So fragile and weak!','',26124),
(34323,'enUS','Flesh... such a hindrance.','',26124),
(34324,'enUS','You seek the secrets of Ulduar? Then take them!','',26124),
(34325,'enUS','My death only serves to hasten your demise.','',26124),
(34326,'enUS','Impossible...','',26124),
(34327,'enUS','This meeting of the Assembly of Iron is adjourned!','',26124),
(34328,'enUS','Nothing short of total decimation will suffice.','',26124),
(34329,'enUS','The world suffers yet another insignificant loss.','',26124),
(34330,'enUS','Death is the price of your arrogance.','',26124),
(34331,'enUS','Decipher this!','',26124),
(34332,'enUS','Face the lightning\'s surge!','',26124),
(34333,'enUS','The legacy of storms shall not be undone.','',26124),
(34334,'enUS','What have you gained from my defeat? You are no less doomed, mortals.','',26124),
(34335,'enUS','This meeting of the Assembly of Iron is adjourned!','',26124),
(34336,'enUS','You will suffer for this trespass!','',26124),
(34337,'enUS','Tragic. To come so far, only to fail.','',26124),
(34338,'enUS','Welcome to the endless winter.','',26124),
(34339,'enUS','Winds of the north consume you!','',26124),
(34340,'enUS','ENOUGH! This ends now!','',26124),
(34341,'enUS','','Some things are better left alone!',26124),
(34342,'enUS','','HELP ME! Please get them off of me!',26124),
(34343,'enUS','','What do you want from me? Leave me alone!',26124),
(34344,'enUS','','Yes! YES! Show them no mercy! Give no pause to your attacks!',26124),
(34345,'enUS','','Let hatred and rage guide your blows!',26124),
(34346,'enUS','','The time to strike at the head of the beast will soon be upon us! Focus your anger and hatred on his minions!',26124),
(34347,'enUS','','Suffocate upon your own hate!',26124),
(34348,'enUS','','Tremble, mortals, before the coming of the end!',26124),
(34349,'enUS','','Powerless to act....',26124),
(34350,'enUS','','Could they have been saved?',26124),
(34351,'enUS','','I am the lucid dream.',26124),
(34352,'enUS','','The monster in your nightmares.',26124),
(34353,'enUS','','The fiend of a thousand faces.',26124),
(34354,'enUS','','The secret dies with you.',26124),
(34355,'enUS','','There is no escape.',26124),
(34356,'enUS','','Cower before my true form.',26124),
(34357,'enUS','BOW DOWN BEFORE THE GOD OF DEATH!','',26124),
(34358,'enUS','','You waste my time!',26124),
(34359,'enUS','Weak-minded fool!','',26124),
(34360,'enUS','Look upon the true face of death, and know that your end comes soon!','',26124),
(34361,'enUS','MADNESS WILL CONSUME YOU!','',26124),
(34362,'enUS','Eternal suffering awaits!','',26124),
(34363,'enUS','Your will is no longer your own.','',26124),
(34364,'enUS','Destroy them, minion! Your master commands it!','',26124),
(34365,'enUS','Your fate is sealed. The end of days is finally upon you and ALL who inhabit this miserable little seedling. Uulwi ifis halahs gag erh\'ongg w\'ssh.','',26124),
(34366,'enUS','The veil of winter will protect you, champions!','',26124),
(34367,'enUS','','Eonar, your servant calls for your blessing!',26124),
(34368,'enUS','Combat matrix enhanced. Behold wonderous rapidity!','',26124),
(34369,'enUS','Golganneth, lend me your strength! Grant my mortal allies the power of thunder!','',26124),
(34370,'enUS','As the Molten Colossus weakens, a single ominous word rumbles through the air like rolling thunder: \"BURN\"','',26124),
(34371,'enUS','Return to Astranaar!','',26124),
(34372,'enUS','Tread lightly through these woods, $c. It is as though the trees themselves have eyes and whisper to our foes.','',26124),
(34373,'enUS','Send me to the Mor\'shan Ramparts, Kulg.','Send me to the Mor\'shan Ramparts, Kulg.',26124),
(34374,'enUS','Your target has evaded your Charge.','Your target has evaded your Charge.',26124),
(34375,'enUS','Your target has been knocked off-balance.','Your target has been knocked off-balance.',26124),
(34376,'enUS','Your target was waiting for your Charge with a readied lance.','Your target was waiting for your Charge with a readied lance.',26124),
(34377,'enUS','How do the Argent Crusade riders fight?','How do the Argent Crusade riders fight?',26124),
(34378,'enUS','The Argent Crusade riders believe in balance and precision, deftly mixing attack and defense.$B$BHowever, they will often open themselves to Charges by trying to gain range on you.$B$BClose that range with a Charge before they can do the same, and then Shield-Break them as you wheel around for more Thrusts.','The Argent Crusade riders believe in balance and precision, deftly mixing attack and defense.$B$BHowever, they will often open themselves to Charges by trying to gain range on you.$B$BClose that range with a Charge before they can do the same, and then Shield-Break them as you wheel around for more Thrusts.',26124),
(34379,'enUS','The Stormwind riders pride themselves on fearless and devastating charges. Such is their skill and ferocity that even when charged themselves they simply charge right back.$B$BTry staying close and Thrusting, and when they attempt to gain range, throw them off-balance with a Shield-Breaker before you Charge. Otherwise, they\'ll meet you head-on every time.','The Stormwind riders pride themselves on fearless and devastating charges. Such is their skill and ferocity that even when charged themselves they simply charge right back.$B$BTry staying close and Thrusting, and when they attempt to gain range, throw them off-balance with a Shield-Breaker before you Charge. Otherwise, they\'ll meet you head-on every time.',26124),
(34380,'enUS','The Gnomeregan riders believe in balance and precision, deftly mixing attack and defense.$B$BHowever, they will often open themselves to Charges by trying to gain range on you.$B$BClose that range with a Charge before they can do the same, and then Shield-Break them as you wheel around for more Thrusts.','The Gnomeregan riders believe in balance and precision, deftly mixing attack and defense.$B$BHowever, they will often open themselves to Charges by trying to gain range on you.$B$BClose that range with a Charge before they can do the same, and then Shield-Break them as you wheel around for more Thrusts.',26124),
(34382,'enUS','The Darnassus riders count on their nimbleness and skill at range.$B$BThey are quick and cunning enough to avoid your Charges, so try using a mixture of close-range Thrusts and the occasional Shield-Breaker to defeat them.','The Darnassus riders count on their nimbleness and skill at range.$B$BThey are quick and cunning enough to avoid your Charges, so try using a mixture of close-range Thrusts and the occasional Shield-Breaker to defeat them.',26124),
(34383,'enUS','The Ironforge riders are a tenacious lot, relying heavily on their defenses and steadfastly trading blows with their opponents, strike for strike.$B$BTrying wearing them down with Charges while maintaining your own Defense... meet them with a defensive advantage so that they will suffer the most with each exchange.','The Ironforge riders are a tenacious lot, relying heavily on their defenses and steadfastly trading blows with their opponents, strike for strike.$B$BTrying wearing them down with Charges while maintaining your own Defense... meet them with a defensive advantage so that they will suffer the most with each exchange.',26124),
(34384,'enUS','The Exodar riders are massive and powerful combatants, terrifying at close range.$B$BTry to stay out of their defense-crushing Thrust range, breaking down their defenses with Shield-Breakers before risking a Charge.','The Exodar riders are massive and powerful combatants, terrifying at close range.$B$BTry to stay out of their defense-crushing Thrust range, breaking down their defenses with Shield-Breakers before risking a Charge.',26124),
(34385,'enUS','The Sen\'jin riders count on their nimbleness and skill at range.$B$BThey are quick and cunning enough to avoid your Charges, so try using a mixture of close-range Thrusts and the occasional Shield-Breaker to defeat them.','The Sen\'jin riders count on their nimbleness and skill at range.$B$BThey are quick and cunning enough to avoid your Charges, so try using a mixture of close-range Thrusts and the occasional Shield-Breaker to defeat them.',26124),
(34386,'enUS','The Thunder Bluff riders are massive and powerful combatants, terrifying at close range.$B$BTry to stay out of their defense-crushing Thrust range, breaking down their defenses with Shield-Breakers before risking a Charge.','The Thunder Bluff riders are massive and powerful combatants, terrifying at close range.$B$BTry to stay out of their defense-crushing Thrust range, breaking down their defenses with Shield-Breakers before risking a Charge.',26124),
(34387,'enUS','The Silvermoon riders believe in balance and precision, deftly mixing attack and defense.$B$BHowever, they will often open themselves to Charges by trying to gain range on you.$B$BClose that range with a Charge before they can do the same, and then Shield-Break them as you wheel around for more Thrusts.','The Silvermoon riders believe in balance and precision, deftly mixing attack and defense.$B$BHowever, they will often open themselves to Charges by trying to gain range on you.$B$BClose that range with a Charge before they can do the same, and then Shield-Break them as you wheel around for more Thrusts.',26124),
(34388,'enUS','The Undercity riders are a tenacious lot, relying heavily on their defenses and steadfastly trading blows with their opponents, strike for strike.$B$BTrying wearing them down with Charges while maintaining your own Defense... meet them with a defensive advantage so that they will suffer the most with each exchange.','The Undercity riders are a tenacious lot, relying heavily on their defenses and steadfastly trading blows with their opponents, strike for strike.$B$BTrying wearing them down with Charges while maintaining your own Defense... meet them with a defensive advantage so that they will suffer the most with each exchange.',26124),
(34389,'enUS','The Orgrimmar riders pride themselves on fearless and devastating charges. Such is their skill and ferocity that even when charged themselves they simply charge right back.$B$BTry staying close and Thrusting, and when they attempt to gain range, throw them off-balance with a Shield-Breaker before you Charge. Otherwise, they\'ll meet you head-on every time.','The Orgrimmar riders pride themselves on fearless and devastating charges. Such is their skill and ferocity that even when charged themselves they simply charge right back.$B$BTry staying close and Thrusting, and when they attempt to gain range, throw them off-balance with a Shield-Breaker before you Charge. Otherwise, they\'ll meet you head-on every time.',26124),
(34390,'enUS','Murloc pests, I have come to steal your treasure! Attempt to stop me! Quickly!','',26124),
(34391,'enUS','Detonation imminent.','',26124),
(34392,'enUS','Welcome to our little chapel of the Light. Please, take a seat. Enjoy a respite from the world\'s ills.','Welcome to our little chapel of the Light. Please, take a seat. Enjoy a respite from the world\'s ills.',26124),
(34394,'enUS','Let\'s get to it, $r.$b$bThere\'s little time and much to do.','',26124),
(34395,'enUS','You\'ve already bested one of our riders today, so I cannot accept your challenge.','You\'ve already bested one of our riders today, so I cannot accept your challenge.',26124),
(34396,'enUS','You may wish to put some more signal powder on the brazier next time. I\'m not sure they could see that from Orgrimmar....','',26124),
(34397,'enUS','You didn\'t need to use the whole sack at once, did you?','',26124),
(34398,'enUS','When this is over, you may want to brush up on your secrecy skills....','',26124),
(34399,'enUS','The %s prepares to unleash a staggering shout!','',26124),
(34400,'enUS','Are you here for the confessor\'s sermon? Good luck findin\' a place to sit...','',26124),
(34401,'enUS','The Ancient Gate of the Keepers unlocks!','',26124),
(34402,'enUS','A kaldorei assassin evades $n\'s gaze and slips into the shadows.','A kaldorei assassin evades $n\'s gaze and slips into the shadows.',26124),
(34403,'enUS','Return to Shatterspear Vale.','',26124),
(34404,'enUS','The Eastspark siege workshop has been captured by the Alliance!','',26124),
(34405,'enUS','The Westspark siege workshop has been captured by the Alliance!','',26124),
(34406,'enUS','The Eastspark siege workshop has been captured by the Horde!','',26124),
(34407,'enUS','The Westspark siege workshop has been captured by the Horde!','',26124),
(34408,'enUS','The Eastspark siege workshop has been attacked by the Alliance!','',26124),
(34409,'enUS','The Eastspark siege workshop has been attacked by the Horde!','',26124),
(34410,'enUS','The Westspark siege workshop has been attacked by the Alliance!','',26124),
(34411,'enUS','The Westspark siege workshop has been attacked by the Horde!','',26124),
(34412,'enUS','You have a feeling someone is watching you....','You have a feeling someone is watching you....',26124),
(34413,'enUS','You hear a shuffling noise nearby, but see nothing.','You hear a shuffling noise nearby, but see nothing.',26124),
(34414,'enUS','You think you see a shadowy figure out of the corner of your eye.','You think you see a shadowy figure out of the corner of your eye.',26124),
(34415,'enUS','A kaldorei assassin leaps from the shadows and attacks $n!','A kaldorei assassin leaps from the shadows and attacks $n!',26124),
(34416,'enUS','My lady.$b$bI was unable to protect her. How can I return to Silvermoon...','',26124),
(34417,'enUS','As you wish, $n.','',26124),
(34418,'enUS','','As you wish, $n.',26124),
(34419,'enUS','Activating secondary defensive systems will result in the extermination of unauthorized life forms via orbital emplacements.$B$BYou are an unauthorized life form. Please confirm.','',26124),
(34420,'enUS','Activate secondary defensive systems.','Activate secondary defensive systems.',26124),
(34421,'enUS','Confirmed.','Confirmed.',26124),
(34422,'enUS','Security override permitted. Secondary defensive systems activated.$B$BBackup deactivation for secondary systems can be accessed via individual generators located on the concourse.','',26124),
(34423,'enUS','It is an honor to represent the Argent Crusade in this tournament.','',26124),
(34424,'enUS','Access to the interior of the complex is currently restricted. Primary and secondary defensive emplacements are active.','',26124),
(34425,'enUS','','Strange, I don\'t remember any mention of those orbital emplacements last time. I wonder what dolt activated them.',26124),
(34426,'enUS','The Argent Tournament has begun in the northern reaches of Icecrown, $c. If you\'ve yet to find your way there, I can pay your way.$B$BThe more we have participating in the melee, the stronger we\'ll be when we strike against the Lich King.','',26124),
(34427,'enUS','I\'ll take the flight.','I\'ll take the flight.',26124),
(34428,'enUS','Yeehaw! Let\'s do this!','Yeehaw! Let\'s do this!',26124),
(34429,'enUS','Throw me up there!','Throw me up there!',26124),
(34430,'enUS','Let\'s show this piece of scrap what real mettle is made of.','Let\'s show this piece of scrap what real mettle is made of.',26124),
(34431,'enUS','I am ready, let\'s do this!','I am ready, let\'s do this!',26124),
(34432,'enUS','This is going to hurt, isn\'t it?','I hope I don\'t chip my nails...',26124),
(34433,'enUS','Throw me!','Throw me!',26124),
(34434,'enUS','Quit wasting time! Let\'s do this!','Quit wasting time! Let\'s do this!',26124),
(34435,'enUS','That oversized toy is no match for me!','That oversized toy is no match for me!',26124),
(34436,'enUS','The moonstalker rouses from its slumber with a deep growl.','',26124),
(34437,'enUS','The moonstalker jumps to its feet, teeth bared.','',26124),
(34438,'enUS','The moonstalker rises, angry at being disturbed.','',26124),
(34443,'enUS','','I want to see some sweat, here. If I don\'t start seeing sweat, I guarantee I\'ll start seeing blood.',26124),
(34444,'enUS','','Step up the pace, you peons! ...Don\'t make me use the stick.',26124),
(34445,'enUS','','Get this caravan loaded! Crossroads needs these supplies.',26124),
(34446,'enUS','','What... What did you just do, $n?! Brann! Braaaaannn!',26124),
(34447,'enUS','','Brann! $n just activated the orbital defense system! If we don\'t get out of here soon, we\'re going to be toast!',26124),
(34448,'enUS','Prognosis: Negative!','',26124),
(34449,'enUS','You\'re not going to get up from that one, friend.','',26124),
(34450,'enUS','','%s begins to cast Terrifying Screech.',26124),
(34451,'enUS','Teleport to the Prison of Yogg-Saron.','Teleport to the Prison of Yogg-Saron.',26124),
(34452,'enUS','Teleport to the Ulduar Tram.','Teleport to the Ulduar Tram.',26124),
(34453,'enUS','How dare you disturb our last link to this world?!','',26124),
(34454,'enUS','The cold comes...','The cold comes...',26124),
(34455,'enUS','Join us... forever.','Join us... forever.',26124),
(34456,'enUS','Stay with us mortal... live eternal.','Stay with us mortal... live eternal.',26124),
(34457,'enUS','Death welcomes you.','Death welcomes you.',26124),
(34458,'enUS','Let loneliness guide you... give in.','Let loneliness guide you... give in.',26124),
(34459,'enUS','The strain of living... just let go...','The strain of living... just let go...',26124),
(34460,'enUS','Your quest is meaningless.','Your quest is meaningless.',26124),
(34461,'enUS','Your life has no purpose.','Your life has no purpose.',26124),
(34462,'enUS','{skull} I DIED! {skull}','{skull} I DIED! {skull}',26124),
(34463,'enUS','Welcome, child.','',26124),
(34464,'enUS','','I shouldn\'t have expected these filthy trolls to stay peaceful forever. There\'s no place for trust with any sympathizers of the Horde.',26124),
(34465,'enUS','%s begins to cast Big Bang!','',26124),
(34467,'enUS','Blood and Thunder, $n!','',26124),
(34468,'enUS','The %s begins to self destruct!','',26124),
(34469,'enUS','There are many dangers facing us, but we cannot find ourselves neglecting nature, lest it neglect us in our time of need. We\'ve learned this lesson before.','',26124),
(34470,'enUS','Standing in the way of nature is heresy.  Even when nature\'s force is a destructive one.$B$BThe forces that would destroy Darkshore are not natural, however.  I will not let this land be torn asunder.','',26124),
(34471,'enUS','Scorch is extinguished by the water!','',26124),
(34472,'enUS','How do you do? I\'m Gary, and I assume Gorbold sent you.\n\nIf you\'re here to help, the plan\'s pretty simple. I\'ve rigged up some decoy bots. We prance the little fellows in near the murlocs and activate their countdown. They\'ll pulse light and sound to attract the murlocs, and after several seconds, they\'ll explode, taking the murlocs with them.\n\nIf we get enough of these in there, we should be able to make our way to the ships\' holds again. With less casualties this time hopefully. That part\'s not for you though, just get to blowing those little fish men up!','',26124),
(34473,'enUS','','While the elements are doing their best to tear Darkshore asunder, I\'ve been struggling to protect the remaining wildlife.$B$BCan I count on your help, $c?\n',26124),
(34474,'enUS','A challenge?! Stand still so that I can blast your corpse all over the ground.','',26124),
(34475,'enUS','You think you can best Lorenth Thundercall? Stand still, silly gnat, so that I can swat you.','',26124),
(34476,'enUS','Don\'t move, little adventurer. I have the death you seek.','',26124),
(34477,'enUS','Hah! Stay right there while I cast this spell! It won\'t hurt much.','',26124),
(34478,'enUS','','Company! Stay in sight, love, so that I can welcome you properly.',26124),
(34479,'enUS','','Prey! Move away from those pillars so that I can show you the err in your trespass. ',26124),
(34480,'enUS','','Welcome! Don\'t be shy... move away from those pillars so that I can see you fully.',26124),
(34481,'enUS','','Hello there! Don\'t you dare step behind those pillars. Let me welcome you properly.',26124),
(34482,'enUS','And don\'t worry about the trolls underfoot while you\'re up there. They\'ll be trampled into the ground by the ancients\' strides.','',26124),
(34483,'enUS','Don\'t just stand around, $r...$b$bThere\'s work to be done!','',26124),
(34484,'enUS','There is a creature half-buried in the silt, a hideous collection of limbs and tentacles with no discernable face. You can\'t bring yourself to touch the eerily translucent flesh.$B$BAlthough the beast is dead, the water around the shapeless body appears clean, and the corpse itself curiously shows no sign of decay.','',26124),
(34485,'enUS','Be still, little one, and you can hear this ancient land speak. It cries out in pain.','',26124),
(34486,'enUS','Ancient Onu, where may I find a Seed of the Earth?','Ancient Onu, where may I find a Seed of the Earth?',26124),
(34487,'enUS','Hum, hrm. A powerful reagent for one so young. You will kill many foes in the name of your Alliance, but it is important to remember that in the great cycle, birth is as powerful as death.$B$B<Onu slowly reaches up to his head and withdraws an inconspicuous acorn. He lowers his arm to you with unhurried calm.>$B$BThis is extremely potent.$B$B...I apologize, I did not wish that to sound like a boast.','',26124),
(34488,'enUS','','We will suffer no interruptions!',26124),
(34489,'enUS','','Queen Azshara will return and your land will be forfeit.',26124),
(34490,'enUS','','You live on borrowed time. The sea will consume you.',26124),
(34491,'enUS','','The age of the night elves is coming to a close.',26124),
(34492,'enUS','Let us see if we can freeze the enemy where they stand, little $r.','',26124),
(34493,'enUS','Arctanus, I am ready to lead one of your freezing surgers into battle.','Arctanus, I am ready to lead one of your freezing surgers into battle.',26124),
(34494,'enUS','Our brother has lost his way. He scorches the ground, he vaporizes the water, and devours too much air.$B$BHelp us to bring him back into balance and harmony.','',26124),
(34495,'enUS','I am ready to be one with the whirling vortex and defeat Lord Magmathar.','I am ready to be one with the whirling vortex and defeat Lord Magmathar.',26124),
(34496,'enUS','%s is already consumed and is beyond help!','',26124),
(34497,'enUS','%s is now protected from the consumption.','%s is now protected from the consumption.',26124),
(34498,'enUS','%s catches the meat and gobbles it hungrily.','',26124),
(34499,'enUS','%s purrs contentedly.','',26124),
(34500,'enUS','%s begins to cast Cosmic Smash!','',26124),
(34501,'enUS','Withers absorbs the water, growing back to full size.','',26124),
(34502,'enUS','There is no escape! There is only the fiery embrace of my lava!','',26124),
(34503,'enUS','Death rises from below and erupts from above! There is no escape!','',26124),
(34504,'enUS','Scorch the ground, boil the water, and ignite the skies!','',26124),
(34505,'enUS','The Earthen Ring cannot withstand my fury!','',26124),
(34506,'enUS','Destroy them, my minions!','',26124),
(34507,'enUS','I am free of the bonds of the earth never to return again!','',26124),
(34508,'enUS','ASHENVALE WILL BURN!','',26124),
(34509,'enUS','Like moths to the flame!','',26124),
(34510,'enUS','<*Rumble*Rumble*Rumble*>','',26124),
(34511,'enUS','%s overcharges a Tempest Minion!','',26124),
(34512,'enUS','','I appreciate your help defending the wildlife here. Hopefully we\'re not too late.\n',26124),
(34513,'enUS','','Thank you for your help, $n! These woods may never be safe from the evils that once dwelled here, but I feel better knowing that heroes like you are helping me keep watch.\n',26124),
(34514,'enUS','Who are the Old Ones?','Who are the Old Ones?',26124),
(34515,'enUS','','I wish I could tell you more, but until recently nobody believed such creatures existed. Long before the Titans shaped Azeroth into the world we see today, before the natural cycle of life and death as we know it, the Old Ones ruled over the elements and corrupted creation to serve their own malignant ends.$B$BFrom what Onu here tells me, the Titans ultimately defeated the Old Ones. Or, at least, they imprisoned them under the earth. Can something like that ever really die? I wish I knew more, but this is all pre-prehistory for me, and I\'ve been around a while.$B$BI know that there are some that worship the Old Ones, if you can believe that. That\'s like praying for the end of the world. These Old Gods make people crazy!\n',26124),
(34516,'enUS','%s hungrily devours the egg.','',26124),
(34517,'enUS','<The hatchling looks at you as if trying to determine whether or not you\'re its mother.>','',26124),
(34518,'enUS','I lost my venomhide hatchling. Have you seen him?','I lost my venomhide hatchling. Have you seen him?',26124),
(34519,'enUS','The %s devours the food.','',26124),
(34520,'enUS','The %s catches the food in its mouth and swallows it in one gulp.','',26124),
(34521,'enUS','The %s\'s strong jaws tear into the food.','',26124),
(34522,'enUS','The %s quickly finishes the food and glances around for more.','',26124),
(34523,'enUS','Abandon the dig? Ridiculous! In my long industrious career, I\'ve never abandoned a site. Not intentionally. Misplaced a few, maybe. Who are you again? What are we doing here?','',26124),
(34524,'enUS','Superb! Gather your strength, whats-your-face. We\'ve got a long way to travel.','',26124),
(34525,'enUS','Ready? Let\'s move!','',26124),
(34526,'enUS','The ruins you see here are identical to ones I dug up a few months ago, but they\'re flooded! Curious, eh?','',26124),
(34527,'enUS','Ah, we\'re almost there, whos-yer-face! The camp where I left my notes is just around the corner!','',26124),
(34528,'enUS','By the three hammers, will you look at that! More ruins!','',26124),
(34529,'enUS','These ruins I\'ve found are IDENTICAL to the ones I just left! It\'s the find of a lifetime!','',26124),
(34530,'enUS','You big duffer, these ARE the same ruins. You\'re wandering in circles again.','',26124),
(34531,'enUS','Nonsense. See? Here\'s my journal, right here. ','',26124),
(34532,'enUS','What do you make of this, Ferd?','',26124),
(34534,'enUS','Where did this $n come from? Honestly now.','',26124),
(34535,'enUS','Who dug up this $n, anyways?','',26124),
(34536,'enUS','Why did the ancients build their cities next to all these $ns?','',26124),
(34537,'enUS','Let\'s see what this artifact tells us...','',26124),
(34538,'enUS','I knew it! It\'s calling up a message!','',26124),
(34539,'enUS','Kill it!','',26124),
(34540,'enUS','Mother?','',26124),
(34541,'enUS','...Diagnostic ... Diagnostic ... Fail. ','',26124),
(34542,'enUS','The site has been compromised. The aspects must be alerted.','',26124),
(34543,'enUS','Amazing. Prospector Remtravel\'s done it again! We\'ll see if Ironforge can make sense of this.','',26124),
(34544,'enUS','With his razor sharp claws, Avrus digs into his chest and removes his beating heart, placing it with the fallen moonstones.','',26124),
(34545,'enUS','Miraculously, the satyr does not die. Instead he is bathed in a warm light.','',26124),
(34546,'enUS','This dig here is compromised - the Explorers\' League wants us to grab whatever\'s left of value and clear out. Easily said, not so easily done.','',26124),
(34547,'enUS','%s is transformed!','',26124),
(34548,'enUS','Murlocs. Bah!','',26124),
(34549,'enUS','Grimfang has ordered me to Hellscream\'s Watch.','Grimfang has ordered me to Hellscream\'s Watch.',26124),
(34550,'enUS','','The body of the fallen dryad lies here where she lost her life to the Horde.',26124),
(34551,'enUS','The ritual of soothing has begun.  Defend the totem at all costs!','',26124),
(34552,'enUS','A %s emerges from the shell!','',26124),
(34553,'enUS','The ritual of soothing has completed.','',26124),
(34554,'enUS','','The Lich King\'s cruel reign has inflicted great suffering on all of Northrend\'s inhabitants, particularly the children. If you are a friend to the Oracles or Frenzyheart Tribe of Sholazar, perhaps you might consider caring for an orphan for a week.',26124),
(34555,'enUS','We can has aged yolk?','',26124),
(34556,'enUS','Do Great Ones ever run out of bag space for shinies?','',26124),
(34557,'enUS','Why you think puppy-man hatchlings keep asking if we pity Lafoo? Lafoo talks a lot, but he\'s our friend.','',26124),
(34558,'enUS','Soo-$n, maybe you give us whistle for when we need to call you. Oki?','',26124),
(34559,'enUS','Maybe we be a $r when we grow up. Think so?','',26124),
(34560,'enUS','Are you alone because puppy-men killed your parents too?','',26124),
(34561,'enUS','You should stay away from walrus-men. They could pup-nap you.','',26124),
(34562,'enUS','Kekek take you hunting. You be good bait.','',26124),
(34563,'enUS','Orcs always point and laugh at Kekek, but he get revenge one day.','',26124),
(34564,'enUS','Know what? If Kekek closes his eyes, you can\'t see him.','',26124),
(34565,'enUS','Caught three chickens for lunch. Bet you couldn\'t catch any.','',26124),
(34566,'enUS','Kekek took big-tongue hatchling\'s favorite toy. Maybe it help you get to sleep at night.','',26124),
(34567,'enUS','Ask about the orphans.','Ask about the orphans.',26124),
(34568,'enUS','','The orphans we have taken in come from war torn Sholazar Basin. You can choose to care for either an orphaned Oracle hatchling or a Frenzyheart pup. Either will be happy to make a new friend, but you will only be able to care for one of them.',26124),
(34569,'enUS','','You may choose to care for an Oracle orphan or a Wolvar orphan, but you will not be able to help both.',26124),
(34570,'enUS','','We must do more than hold the tree, $r. The Horde will never give up.$B$BWe must destroy them!',26124),
(34571,'enUS','','Hop on!',26124),
(34572,'enUS','Recover the Laughing Sister\'s corpse.','Recover the Laughing Sister\'s corpse.',26124),
(34576,'enUS','We here! Only, if this is world tree, how come it broke when they tried to put whole world in?','',26124),
(34579,'enUS','','Hold on tight! I\'ll take care of the flying, you focus on the wildlife below.',26124),
(34580,'enUS','','From the air, you should be able to cast your protective ward on whole groups of animals at once.',26124),
(34581,'enUS','We thank you, Aroom.  And we thank $n.  We return to Elune... finally.','',26124),
(34582,'enUS','','The Horde is here, $n! Quickly, we must invoke the shade of Shadumbra!',26124),
(34583,'enUS','','',26124),
(34584,'enUS','I have been assisting the flight masters to round up the Hippogryphs that fled their post when the land tore itself apart. Even now our birds remain squeamish.','',26124),
(34585,'enUS','Orseus, Kathrena sent me to borrow one of your Hippogryphs.','Orseus, Kathrena sent me to borrow one of your Hippogryphs.',26124),
(34586,'enUS','I am ready to invoke the shade of Shadumbra.','I am ready to invoke the shade of Shadumbra.',26124),
(34587,'enUS','Head outside and destroy the Horde!','',26124),
(34588,'enUS','Return to Raynewood Retreat!','',26124),
(34589,'enUS','','Whitetail deer have been repopulating this whole area.',26124),
(34590,'enUS','','Hold on, the updraft from the fires can be fierce.',26124),
(34591,'enUS','','Moonstalkers displaced by the fires patrol this strand, we need to keep them safe!',26124),
(34592,'enUS','','Look below - some of those thistle bears haven\'t been consumed yet. We\'re not too late.',26124),
(34593,'enUS','','Why would anyone want to dig up something so horrific? I\'m convinced those things are behind what\'s happening to the animals here.',26124),
(34594,'enUS','','Good work! Let Orseus know if we need to take another pass. Otherwise, I\'ll meet you in the grove!',26124),
(34595,'enUS','Use the Moonwell at the base of the tree for rapid health recovery out of combat.','',26124),
(34596,'enUS','','Who dares oppose Queen Azshara?  You will soon beg for a swift death!',26124),
(34597,'enUS','The artifact shatters as Yoth\'al the Devourer gasps his last breath.','',26124),
(34598,'enUS','It\'s over Azshara!  You and your naga will return to the bottom of the seas where you belong!','',26124),
(34599,'enUS','Our men are almost finished unearthing great Soggoth.  Is the ritual ready?','',26124),
(34600,'enUS','','Not quite.  We shall need a great many offerings of sacrifice before the Herald of the Old Gods roams the land again.',26124),
(34601,'enUS','Do not worry.  Like I said, our men are almost done unearthing the Slithering One.  They will make for a suitable -- and even voluntary -- sacrifice.  Soggoth will rise!','',26124),
(34602,'enUS','Take with you the blessing of the wind\'s embrace. May it make your descent from Aldrassil more... direct.','',26124),
(34603,'enUS','You think maybe one day, Kekek lead Frenzyheart home, like bear-men fight to get tree-city back? Kekek want own home, not city with purple men, not jungle with big-tongues.','',26124),
(34604,'enUS','I am to bomb Astranaar! Captain Goggath\'s orders.','I am to bomb Astranaar! Captain Goggath\'s orders.',26124),
(34605,'enUS','Why are we digging this thing up anyway, boss?','Why are we digging this thing up anyway, boss?',26124),
(34606,'enUS','Look! Is that us? We think it\'s us. A bit older, maybe?','',26124),
(34607,'enUS','Looks like we blessed by Great Ones! Shrines give magic, make us high-oracle someday? Maybe?','',26124),
(34608,'enUS','Watch your tongue, worm.  You will not refer to Soggoth the Slitherer as \"that thing\" or you\'ll find yourself eating your own heart for dinner.','',26124),
(34609,'enUS','Now, back to work!  Your superiors are watching from the outlook above and they do not take kindly to idleness!','',26124),
(34610,'enUS','Look! That must be Kekek as a mighty warrior! See? What Kekek tell you?','',26124),
(34611,'enUS','This is a temporary object, quest will use autolaunch.','',26124),
(34612,'enUS','','Can you feel it?$B$BThe spirit world draws close during the Day of the Dead. This is why we decorate the graves of our dearly departed with flowers and candles and offerings: To welcome them back, even if only for a time.$B$BSo come! Dance with me! Let us cherish and honor those we have lost in their ghostly presence, so that they might eat and drink and smile and know that they are loved.',26124),
(34613,'enUS','During the Day of the Dead, people gather in graveyards to celebrate with and cherish the spirits of those they have lost.$B$BYou can find the festivities in the cemeteries of any major city, where you\'ll be able to cook, dance, don costumes, and more.','During the Day of the Dead, people gather in graveyards to celebrate with and cherish the spirits of those they have lost.$B$BYou can find the festivities in the cemeteries of any major city, where you\'ll be able to cook, dance, don costumes, and more.',26124),
(34614,'enUS','','Before you make your way into Fel Rock, be sure to speak to Tallonkai Swiftroot at the top of the tree. He has a task he would ask of you as well.',26124),
(34615,'enUS','We made a new friend!','',26124),
(34616,'enUS','Look!','',26124),
(34617,'enUS','Wanna see what I can do?','',26124),
(34618,'enUS','We can dance too!','',26124),
(34619,'enUS','Now dance together!','',26124),
(34620,'enUS','Look!','',26124),
(34621,'enUS','Got you good!','',26124),
(34622,'enUS','Got you back!','',26124),
(34623,'enUS','Good snowball fight!','',26124),
(34624,'enUS','Better watch out!','',26124),
(34625,'enUS','Defend the Caravan Kodo!','',26124),
(34626,'enUS','','Head \'em up! Move \'em out!',26124),
(34627,'enUS','','I\'m honor-bound to get these supplies to the Crossroads. Pitch in or step aside.',26124),
(34628,'enUS','','Well, $n - are you ready to roll? It won\'t be easy!',26124),
(34629,'enUS','Yes, I\'m ready. Let\'s do this thing!','Yes, I\'m ready. Let\'s do this thing!',26124),
(34630,'enUS','','Mount up, $n! Do not fail me.',26124),
(34631,'enUS','So that\'s the queen of the dragons? Hmm... we thought she\'d be bigger. Yes, we did.','',26124),
(34632,'enUS','How come she doesn\'t look like the other dragons? Could she turn into a big ol\' dragon if she wanted to?','',26124),
(34633,'enUS','Um... Your Majesty, would you turn into a dragon for us?','',26124),
(34634,'enUS','Oki... How about now?','',26124),
(34635,'enUS','','If I was in my dragon form, there wouldn\'t be any room for anyone else, little one.',26124),
(34636,'enUS','Hmm... that Kekek very old. Must be elder, leader of Frenzyheart. This good. Kekek have good future as warrior and leader. Kekek very happy you bring him here. Orphan-lady never do that for Kekek.','',26124),
(34637,'enUS','Elune guide us, $c.','',26124),
(34638,'enUS','We must not allow an inch to our enemy.  If they strike in Darkshore we will fight them back just as if they had attacked Darnassus itself.','',26124),
(34639,'enUS','The battle will begin in 30 seconds.','The battle will begin in 30 seconds.',26124),
(34640,'enUS','You are too late... the relic is being offered to Azshara above us as we speak!','',26124),
(34641,'enUS','','Need some help finding your way? I know this place like the back of my hand.',26124),
(34642,'enUS','Where is the Rune of Nesting?','Where is the Rune of Nesting?',26124),
(34643,'enUS','Where is the Sapphire of Sky?','Where is the Sapphire of Sky?',26124),
(34644,'enUS','Where is the Black Feather Quill?','Where is the Black Feather Quill?',26124),
(34645,'enUS','Where is the Raven Claw Talisman?','Where is the Raven Claw Talisman?',26124),
(34646,'enUS','Where I can find Oben Rageclaw?','Where I can find Oben Rageclaw?',26124),
(34647,'enUS','The battle will begin in 60 seconds.','The battle will begin in 60 seconds.',26124),
(34648,'enUS','The battle will begin in 15 seconds.','The battle will begin in 15 seconds.',26124),
(34649,'enUS','The battle has begun!','The battle has begun!',26124),
(34650,'enUS','','The Rune of Nesting is located across the bridge in the upper section of the southern chamber.',26124),
(34651,'enUS','','The Sapphire of Sky is located at the separate room in the lower section of the northern chamber.',26124),
(34652,'enUS','','The Black Feather Quill is located down the ramp in the lower section of the southern chamber.',26124),
(34653,'enUS','','The Raven Claw Talisman is located on the ledge in the upper section of the northern chamber.',26124),
(34654,'enUS','','Oben Rageclaw resides at the double bridges in the western chamber, near the hallway that leads out of the Barrow Den.',26124),
(34655,'enUS','Kekek thought we go see dragon queen. This just some elf-lady with funny horns.','',26124),
(34656,'enUS','For the Horde!','For the Horde!',26124),
(34657,'enUS','For Warchief Hellscream!','For Warchief Hellscream!',26124),
(34658,'enUS','Destroy the elves!','Destroy the elves!',26124),
(34659,'enUS','Ashenvale is ours!','Ashenvale is ours!',26124),
(34660,'enUS','Kalimdor for the Horde!','Kalimdor for the Horde!',26124),
(34661,'enUS','Lok\'tar ogar!','Lok\'tar ogar!',26124),
(34662,'enUS','Gol\'Kosh!','Gol\'Kosh!',26124),
(34663,'enUS','Kill them all and burn their tower!','Kill them all and burn their tower!',26124),
(34664,'enUS','But why? Dragons big and powerful. Elf-lady weak. Kekek want to see dragon queen\'s real form.','',26124),
(34665,'enUS','Rest assured, Kekek, she is the queen of the dragons. We often take the forms of smaller beings when we work with them.','',26124),
(34666,'enUS','Oh! Now Kekek understand. Not want to be crushed by big dragon-lady. Maybe come back sometime when not so crowded. Nice to meet you, dragon-lady.','',26124),
(34667,'enUS','Excellent work! I\'ll unload the goods. You should check in with Kranal Fiss.','',26124),
(34668,'enUS','','The mist will lead the way.',26124),
(34669,'enUS','','The exit is to the northwest... the mist will lead the way.',26124),
(34670,'enUS','Can you lead me to the exit?','Can you lead me to the exit?',26124),
(34671,'enUS','','I can\'t go on... I need to retreat and recover.',26124),
(34672,'enUS','Wow! A real Great One? We don\'t even think Soo-say has met a real Great One!','',26124),
(34673,'enUS','Um, hello, Mr. Great One. We are honored to meet you.','',26124),
(34674,'enUS','Maybe you\'re asleep, Mr. Great One? We understand. Must be hard working being Great One, collecting all the shinies we leave for you.','',26124),
(34675,'enUS','We brought you a gift, Great One. Maybe you see it when you wake up. Maybe you remember we came to see you, oki?','',26124),
(34676,'enUS','Flat-nosed filth! Get off of my land!','',26124),
(34677,'enUS','Pigs! Scum! I will cleave your fat heads like apples!','',26124),
(34678,'enUS','I will tear your tusks out. You hear me?','',26124),
(34679,'enUS','That\'s right! Die, vermin! The Horde will have your heads for this.','',26124),
(34680,'enUS','I will RIP off your HEADS and EAT your filthy faces!','',26124),
(34681,'enUS','That\'s right, squeal you maggots. I will gut you lengthwise and roast you when we are through!','',26124),
(34682,'enUS','Nobody steals my livestock!','',26124),
(34683,'enUS','Eat axe you bacon-brained porkchops!','',26124),
(34684,'enUS','It\'s good to visit with friends and family again, celebrating and sharing stories of old.','It\'s good to visit with friends and family again, celebrating and sharing stories of old.',26124),
(34685,'enUS','Wow. At last, Kekek get to meet Hemet Nesingwary!','',26124),
(34686,'enUS','Even Frenzyheart know all about you after you come to Sholazar. Maybe you teach Kekek your tricks?','',26124),
(34687,'enUS','Well, lad, you can start by readin\' The Green Hills of Stranglethorn. Then, maybe you can join me on one of my safaris. What do you say?','',26124),
(34688,'enUS','Not sure how reading helps. Kekek can\'t read anyway, but if Hemet Nesingwary say, Kekek try.','',26124),
(34689,'enUS','Maybe give up and throw book at animals, but try.','',26124),
(34690,'enUS','%s breaks out of the net.','',26124),
(34691,'enUS','%s is ensnared!','',26124),
(34692,'enUS','<Snort> Is this how cowards fight, $r?','',26124),
(34693,'enUS','<Pound this chump.>','<Pound this chump.>',26124),
(34694,'enUS','','Some of our huntresses have already made their way to Ban\'ethil Barrow Den. They will find you when you get inside. Go ahead and speak to Citarre to secure a ride there.',26124),
(34695,'enUS','Double Pelt!','Double Pelt!',26124),
(34696,'enUS','Multi-Pelt!','Multi-Pelt!',26124),
(34697,'enUS','Mega-Pelt!','Mega-Pelt!',26124),
(34698,'enUS','Pelting Spree!','Pelting Spree!',26124),
(34699,'enUS','Ultra-Pelt!','Ultra-Pelt!',26124),
(34700,'enUS','Monster Pelt!','Monster Pelt!',26124),
(34701,'enUS','Epic Pelt!','Epic Pelt!',26124),
(34702,'enUS','Legendary Pelt!','Legendary Pelt!',26124),
(34703,'enUS','BY THE LIGHT!!','BY THE LIGHT!!',26124),
(34704,'enUS','If you want, go get, big-tongue baby!','',26124),
(34705,'enUS','Give toy back!','',26124),
(34706,'enUS','Stop!','',26124),
(34707,'enUS','%s sinks to the ground and falls unconscious.','',26124),
(34708,'enUS','','The quilboar have always scavenged the fringes of our camps for food and supplies, but direct assaults on our farms and homesteads? Something has sent them on a rampage recently.',26124),
(34709,'enUS','Togrik, can you wake up the prisoner again?','Togrik, can you wake up the prisoner again?',26124),
(34710,'enUS','<The quilboar fixes his beady black eyes on you.>','',26124),
(34711,'enUS','<The quilboar wrinkles his nose at you and snorts.>','',26124),
(34712,'enUS','What now, $r? Do your worst.','',26124),
(34713,'enUS','We\'re warriors, $n. <Snort> Many and proud.','',26124),
(34714,'enUS','We tell orphan matron on you!','',26124),
(34715,'enUS','','Children, please behave yourselves! No one will want to adopt you if you keep acting like that!',26124),
(34716,'enUS','Who sent you!?','Who sent you!?',26124),
(34717,'enUS','<Punch him in the mouth.>','<Punch him in the mouth.>',26124),
(34718,'enUS','<Kick him in his big fat face.>','<Kick him in his big fat face.>',26124),
(34719,'enUS','<Offer food.>','<Offer food.>',26124),
(34720,'enUS','<Tickle Time!>','<Tickle Time!>',26124),
(34721,'enUS','','Hi there!',26124),
(34722,'enUS','Shael\'dryn, I need the Rod of Dartol.','Shael\'dryn, I need the Rod of Dartol.',26124),
(34723,'enUS','Raene, I need Dartol\'s Rod!','Raene, I need Dartol\'s Rod!',26124),
(34724,'enUS','<The furbolg sniffs at you and grunts.>','',26124),
(34725,'enUS','Krolg, I need Dartol\'s Rod!','Krolg, I need Dartol\'s Rod!',26124),
(34726,'enUS','The %s warily takes the offered food.','',26124),
(34728,'enUS','Mnn, <snort> why you cook this meat? Tortusk tells us meat taste best when stolen and raw.','',26124),
(34729,'enUS','Oh - I\'ve said too much!','',26124),
(34730,'enUS','Ow! <Snort>','',26124),
(34731,'enUS','Unf. You learn nothing from me!','',26124),
(34732,'enUS','Unf - Not the face!','',26124),
(34733,'enUS','Oof! I not talking!','',26124),
(34734,'enUS','<Snort!> That all you got?','',26124),
(34735,'enUS','Ow-oooh! I not talk for nothing!','',26124),
(34736,'enUS','You waste your strength! Tortusk train us warriors never to talk.','',26124),
(34737,'enUS','<Snort!>','',26124),
(34738,'enUS','I say nothing!','',26124),
(34739,'enUS','I not scared of you!','',26124),
(34740,'enUS','I say nothing! <snort>','',26124),
(34741,'enUS','Haha - <snort> ha - heee! <snort> Haha no stop haha <SNORT> <wheeze> Hee hee! Battlemaster Tortusk never prepared us for this!','',26124),
(34742,'enUS','These lands will be ours!','',26124),
(34743,'enUS','Tortusk barks, grunts, and snorts angry instructions to his followers.','',26124),
(34744,'enUS','We Razormane ... must ... survive ...','',26124),
(34745,'enUS','%s laughs softly.','',26124),
(34746,'enUS','All right, Aponi. I\'ve enough on my mind to share. Have you ever spoken to the elves of Moonglade?','',26124),
(34747,'enUS','The elves speak of a moon goddess, did you know? They put great stock in the light given by the moon.','',26124),
(34748,'enUS','Just like her. The parallels I\'ve heard are interesting. And it\'s no secret all druids, Shu\'halo and elf alike, can call upon Mu\'sha\'s light.','',26124),
(34749,'enUS','I wonder. Hamuul has guided us well, and I\'ve learned so much from him. The legends say that our people were druids when time began...','',26124),
(34750,'enUS','...but what Hamuul teaches is what the elves know. The night elves. They put such stock in their moon goddess, as creatures of the night.','',26124),
(34751,'enUS','No! No, nothing like that. He is an elder for good reason, sister. Mu\'sha is one of the Earthmother\'s eyes, and she watches over us. That isn\'t sinister. ','',26124),
(34752,'enUS','Freya drains the essence of Eonar\'s Gift, healing nearby allies!','Freya drains the essence of Eonar\'s Gift, healing nearby allies!',26124),
(34753,'enUS','But we\'re nothing if not people who strive for balance. Our warriors fight only when there is need. Our hunters take only what the tribes require to live, and use all they can when they do. The shaman stand as guide and mediator to the elemental spirits.','',26124),
(34754,'enUS','And while we, as druids, are guardians of nature, I wonder if we\'ve overlooked a key aspect of balance in all things.','',26124),
(34755,'enUS','No, no. No need for him to trouble about a student\'s idle philosophizing while he entertains a friend.','',26124),
(34756,'enUS','Well, it isn\'t exactly a new thought, sister.','',26124),
(34757,'enUS','Surely you\'ve been a student once in your life, $c. You learned from an instructor, and you gained respect for them in some way, yes? Maybe not as a person, but at the least, as one who knew more than you and was willing to teach you. If not, use your imagination...$b$bWhat would you do if you came to realize your instructor may not know as much as you thought, and that you may have found a better path?','',26124),
(34758,'enUS','','This is awful! I shouldn\'t be sitting here, useless, when there\'s so much to be done! If only my arm hadn\'t gotten injured up in Northrend... No use dwelling on it, though! Tahu will have me patched up and cured eventually, and we\'ll still help around here in the meantime.\n\nJust because we\'re not at the front doesn\'t mean we can\'t help out somehow.',26124),
(34759,'enUS','Nom nom nom nom nom...','',26124),
(34760,'enUS','The revitalized kodo rises to its feet, shaking off the dust.','',26124),
(34761,'enUS','','Another new face? It\'s so good to meet you. I\'m Dellylah.',26124),
(34762,'enUS','','Talk to me, Tahu. Something. Anything! I\'m going stir-crazy.',26124),
(34763,'enUS','','Not much.',26124),
(34764,'enUS','','Like Mu\'sha.',26124),
(34765,'enUS','','Where are you going with this?',26124),
(34766,'enUS','','I hear the \"but\" in your voice...',26124),
(34767,'enUS','','Do you think his teachings are wrong?',26124),
(34768,'enUS','','So are you going to bring this up to the elder?',26124),
(34769,'enUS','','I suppose so. It\'s not silly, though, what you said.',26124),
(34770,'enUS','','I see that thoughtful frown, Tahu.',26124),
(34771,'enUS','','But something is on your mind, right?',26124),
(34772,'enUS','','What about it?',26124),
(34773,'enUS','','There\'s a phrase... \"It\'s always darkest before the dawn.\" The dawn will come, though, Tahu. The sun will rise. The balance will shift back to where it should be.',26124),
(34774,'enUS','','%s smiles and gestures to the north.',26124),
(34775,'enUS','','Even on the glacier itself, the sun manages to peek through the gloom. I have hope, Tahu. I think we\'ll make it through this, no matter how dire it looks.',26124),
(34776,'enUS','','But I\'d still rather be there on the front lines helping it happen rather than trying to placate myself with belief. We can\'t just sit around and hope it happens.',26124),
(34777,'enUS','','And through that hope, strengthen our side in the fight?',26124),
(34778,'enUS','Sorry, sister. It\'s nothing to worry about.','',26124),
(34779,'enUS','I\'m thinking about the front to the north. The one you\'re so eager to return to.','',26124),
(34780,'enUS','I know I\'m counseling patience, Aponi, but I don\'t like remaining here any more than you do. Times are bleak, and failing to act only makes me worry that my idle hand may have been the one to turn the tide.','',26124),
(34781,'enUS','Still... there is balance in all things, even death. I simply hate the concept that such destruction and darkness might be necessary.','',26124),
(34782,'enUS','Mmmm... There\'s nothing like good, home-cooked human food.','',26124),
(34783,'enUS','I know, sister. I know. We\'ll return to fighting one day. For now, though, maybe it\'s best to spread the word to others... give them the hope you have.','',26124),
(34784,'enUS','That\'s the idea.','',26124),
(34785,'enUS','I lied. Your miserable food stinks, but not as much as this town is going to stink!','',26124),
(34786,'enUS','Hey! Just what do you think you\'re doing?','',26124),
(34787,'enUS','Not again!','',26124),
(34788,'enUS','','I know all is not well in Shadowglen, but coming back to these woods is always like coming back home.$B$BEver peaceful. Ever pure.',26124),
(34789,'enUS','No Pennant','No Pennant',26124),
(34790,'enUS','Ho, $n! My brother Balgor tells me you\'re quite the shot from the back of a kodo. Great work getting that caravan here from Far Watch in one piece.$B$BListen, there\'s plenty of work for you here in Grol\'dom... but I could use your trigger fingers for the rest of the ride to Crossroads.$B$BCome see me when you\'re ready!','',26124),
(34791,'enUS','Used to be hauling gear and food from Orgrimmar to Crossroads was peon-work. Nowadays my neck\'s always on the line.','',26124),
(34792,'enUS','Much has changed for our people since the Battle of Mount Hyjal.','',26124),
(34793,'enUS','Nordrassil lies a pale shadow of what it once was, its power used to defeat Archimonde and drive back the Burning Legion.','',26124),
(34794,'enUS','Our immortality-the very essence of our beings!-was lost.','',26124),
(34795,'enUS','The Betrayer was freed from his prison, and Shand\'do Stormrage disappeared into the emerald dream.','',26124),
(34796,'enUS','A dark time for all.','',26124),
(34797,'enUS','With Malfurion Stormrage gone, the druids were left in disarray and in desperate need of a new leader.','',26124),
(34798,'enUS','Archdruid Fandral Staghelm roused the druids and convinced the Circle of Ancients in Darkshore that it was time for our people to rebuild.','',26124),
(34799,'enUS','In an effort to regain immortality for our people, and with the approval of the Circle, Staghelm and the most powerful druids grew Teldrassil, upon whose boughs you now stand.','',26124),
(34800,'enUS','Though we have our new home, our immortal lives have not been restored.','',26124),
(34801,'enUS','The Archdruid approached the dragons for their blessings, as the dragons had placed on Nordrassil in ancient times.','',26124),
(34802,'enUS','But Nozdormu, Lord of Time, refused to give his blessing, chiding the druid for his arrogance.','',26124),
(34803,'enUS','In agreement, Alexstrasza also refused Staghelm, and without her blessing, Teldrassil\'s growth has been flawed and unpredictable.','',26124),
(34804,'enUS','Staghelm retreated to his enclave in Darnassus, ever seeking a new direction by which to bless Teldrassil, and restore the immortality of our people.','',26124),
(34805,'enUS','Over time, Staghelm only grew more disconnected from our people.','',26124),
(34806,'enUS','Some pose that he blames us, his people, for the loss of his son, long ago during the War of the Shifting Sands.','',26124),
(34807,'enUS','Others cite rumors of his escalating conflicts with Tyrande Whisperwind, the shining light of our people, our leader in Darnassus.','',26124),
(34808,'enUS','But many druids of the Cenarion Circle stand firm that he wants only what is best for all of the Kaldorei, and serve him unerringly towards that end.','',26124),
(34809,'enUS','Fandral Staghelm carries the burden of our sins and our follies, and in so doing deserves the respect of us all.','',26124),
(34810,'enUS','In weeks past, all of those living atop Teldrassil have found their memories blurry, as if time itself seized a portion of their lives.','',26124),
(34811,'enUS','We break from this haze to find that Fandral Staghelm and many of his closest followers have disappeared without a word.','',26124),
(34812,'enUS','But in his place, Shan\'do Stormrage awoke from the dream and returned to his beloved Tyrande Whisperwind.','',26124),
(34813,'enUS','And with his return came Alexstrasza and Ysera, to at long last offer their blessings upon Teldrassil.','',26124),
(34814,'enUS','Though a small corruption lingers, desperately longing to be cleansed, the boughs of Teldrassil itself seem changed.  Growth has begun anew.','',26124),
(34815,'enUS','None know what to expect next, but with Malfurion and Tyrande reunited, a new hope dawns on the Kaldorei.','',26124),
(34816,'enUS','Are you ready to do this, $n?','',26124),
(34817,'enUS','Bring it on, Rocco.','Bring it on, Rocco.',26124),
(34818,'enUS','There she is. Mount up!','',26124),
(34819,'enUS','%s stares into the moonwell, lost in distant memories.','',26124),
(34820,'enUS','The Shade of the Kaldorei closes its eyes and fades away.','',26124),
(34821,'enUS','Incredible shooting! I\'ll try to calm the animals down. Report to Thork, he will want to know of this attack.','',26124),
(34822,'enUS','Work it!','',26124),
(34823,'enUS','Make it!','',26124),
(34824,'enUS','Do it!','',26124),
(34825,'enUS','Harder, better, faster, stronger!','',26124),
(34826,'enUS','This is The Bomb to end all bombs!','',26124),
(34827,'enUS','Somebody set us up The Bomb!','',26124),
(34828,'enUS','Someone get me somebody stupid enough to move this thing into Stonetalon!','',26124),
(34829,'enUS','I can\'t wait any longer. I\'m going to set it off! Muahahahahahaha!','',26124),
(34830,'enUS','Let\'s put this stuff to the test...','',26124),
(34831,'enUS','Just a pinch...','',26124),
(34832,'enUS','%s fades into existence as you approach, nodding a subtle greeting.','',26124),
(34833,'enUS','%s rests on the side of the moonwell in peaceful contemplation.','',26124),
(34834,'enUS','%s approaches the moonwell slowly, a familiar, thoughtful look upon its face.','',26124),
(34835,'enUS','%s smiles at you knowingly as it approaches.','',26124),
(34836,'enUS','Wahoo!!','',26124),
(34837,'enUS','','Ahahahaha, you\'ve fallen into my trap, $n!',26124),
(34838,'enUS','Beware, $n!','',26124),
(34839,'enUS','Bolyun, is Kariva still about?','Bolyun, is Kariva still about?',26124),
(34840,'enUS','Yes, look out behind you, $n!','',26124),
(34841,'enUS','What is it, $r? Time is money!','',26124),
(34842,'enUS','Good day to you, $r.','',26124),
(34843,'enUS','The savior of the forest! Were it not for your actions, Astranaar and then the rest of Ashenvale surely would have fallen to the Burning Legion.$B$BI hope that this day finds you well, $n!','',26124),
(34844,'enUS','Do not give in to the curse!  You were men and women of Gilneas once... you can be men and women of Gilneas again!','',26124),
(34845,'enUS','Gilneas needs you!  Now is not the time to retreat to the woods like a pack of wild animals!  Face the enemy and live or die as Gilneans not as beasts!','',26124),
(34846,'enUS','You might have gone feral, but Gilnean blood still pumps through your veins.  Defend our homelands agains the Horde!','',26124),
(34847,'enUS','Fields of Honor','Fields of Honor',26124),
(34848,'enUS','Path of Cenarius','Path of Cenarius',26124),
(34849,'enUS','Ogre Pinata','Ogre Pinata',26124),
(34850,'enUS','Magic Rooster Mount','Magic Rooster Mount',26124),
(34851,'enUS','Kologarn focuses his eyes on you!','',26124),
(34852,'enUS','Hey mon, how\'d you find me? I gotta find a better hiding spot.','',26124),
(34853,'enUS','You call yourself, $n? That is a strange name for a furbolg.$B$BYou\'re not from Ashenvale.','',26124),
(34854,'enUS','That\'s not important right now. Ota Wen, listen to me. You must rise up against the orcs!','That\'s not important right now. Ota Wen, listen to me. You must rise up against the orcs!',26124),
(34855,'enUS','<Ota Wen\'s eyes, already dull from his enslavement, glaze over even more at your suggestion. You feel the power of Dartol\'s Rod begin to course through you and reach out to touch the furbolg.>$B$BRise up?','',26124),
(34856,'enUS','Yes, rise up! Tell your fellow furbolg to break out of this cage and to slay the Horde. The power of the rod compels you!','Yes, rise up! Tell your fellow furbolg to break out of this cage and to slay the Horde. The power of the rod compels you!',26124),
(34857,'enUS','<A strange light ignites in Ota Wen\'s eyes as he stands up straight, roaring at the heavens.>$B$BYES, WE WILL RISE UP! RISE UP AND DESTROY OUR JAILORS!','',26124),
(34858,'enUS','I\'m ready to make a run for Stonetalon!','I\'m ready to make a run for Stonetalon!',26124),
(34859,'enUS','Soon, one known as $n, soon we will have destroyed our captors!','',26124),
(34860,'enUS','','Playing possum is super easy, $n.  Just watch....',26124),
(34861,'enUS','','%s begins to play possum.',26124),
(34862,'enUS','','See?! That wasn\'t hard, was it? You\'ll have no problem fooling stinky old Oso Bramblepaw and his guardians now.',26124),
(34863,'enUS','Tonga\'s eagle calls out, then circles toward the peak.','',26124),
(34864,'enUS','Well done, friend! From here we can survey the land.','',26124),
(34865,'enUS','Merciful Earthmother, look at the scope of the devastation! We\'re lucky the entirety of the Barrens isn\'t crumbling into the sea.','',26124),
(34866,'enUS','But what\'s this? Something else is happening to the land south of the fissure.','',26124),
(34867,'enUS','Indeed, the flora is growing unchecked, devouring the land. Similar to our findings from the oases.','',26124),
(34868,'enUS','We must do everything in our power to stop the same from happening here. We\'ll have to step up our investigations of the oases and stop this phenomenon at the source. We\'ll talk again at Crossroads!','',26124),
(34869,'enUS','Take a deep breath, $c. The air atop Thunderhead Summit is thin, but free of the choking dust that strangles the land below.','',26124),
(34870,'enUS','Calculating route...','',26124),
(34871,'enUS','Warning... danger detected!','',26124),
(34872,'enUS','System malfunction detected... recalculating route...','',26124),
(34873,'enUS','Recalculation underway...','',26124),
(34874,'enUS','Recalculation complete. Resuming transport.','',26124),
(34875,'enUS','Commencing transport. Destination, Windshear Crag.','',26124),
(34876,'enUS','Some help, my little friend?','',26124),
(34877,'enUS','Hah, yes $n! That\'s what I want to hear. Let\'s make some noise!','',26124),
(34878,'enUS','Come get some, you horsefaced maggot farms!','',26124),
(34879,'enUS','More.... More!','',26124),
(34881,'enUS','Ah, there\'s our target. I can smell him from here.','',26124),
(34882,'enUS','Victory!','',26124),
(34883,'enUS','Simply amazing!$B$BYou\'re reading this which means that DAN IS THE MAN!','',26124),
(34884,'enUS','','Death to the Horde!',26124),
(34885,'enUS','','Destroy the bomb!',26124),
(34886,'enUS','','Don\'t let it get to Stonetalon!',26124),
(34887,'enUS','','For Ashenvale!',26124),
(34888,'enUS','','Shoot it! Destroy it!',26124),
(34889,'enUS','','Stop the Bomb!',26124),
(34890,'enUS','','Quit your pacing, mon! You\'re gonna be seen.',26124),
(34891,'enUS','Bah! Perhaps I WANT to be seen? I tire of skulking.','',26124),
(34892,'enUS','','Please $c, don\'t encourage Gorgal. We\'re supposed to observe and report - not raise up a ruckus.',26124),
(34893,'enUS','Wait \'til Shoe hears about THIS.','',26124),
(34894,'enUS','%s flees in terror as Kurak falls.','',26124),
(34895,'enUS','Sneak, sneak, sneak. Let me tell you something about Gorgal: Gorgal doesn\'t sneak.','',26124),
(34896,'enUS','Ha hah! That was glorious! I would fight by your side any day, $n.','',26124),
(34897,'enUS','Bomb Condition: 80 Percent!','Bomb Condition: 80 Percent!',26124),
(34898,'enUS','Bomb Condition: 60 Percent!','Bomb Condition: 60 Percent!',26124),
(34899,'enUS','Bomb Condition: 40 Percent!','Bomb Condition: 40 Percent!',26124),
(34900,'enUS','Bomb Condition: Critical!','Bomb Condition: Critical!',26124),
(34901,'enUS','Weep for Gilneas!','Weep for Gilneas!',26124),
(34902,'enUS','Your land is doomed!','Your land is doomed!',26124),
(34903,'enUS','For the Horde!','For the Horde!',26124),
(34904,'enUS','Lok\'tar!','Lok\'tar!',26124),
(34905,'enUS','Our wolves will feast on your bones!','Our wolves will feast on your bones!',26124),
(34906,'enUS','Your days are numbered, shapeshifter!','Your days are numbered, shapeshifter!',26124),
(34907,'enUS','Bomb Condition: Fully Repaired','Bomb Condition: Fully Repaired',26124),
(34908,'enUS','Death to the Horde!','',26124),
(34909,'enUS','We have not lost hope...','',26124),
(34910,'enUS','You\'ll never make it to Stonetalon!','',26124),
(34911,'enUS','Fool! Your deeds in Ashenvale shall not go unpunished!','',26124),
(34912,'enUS','Ashenvale belongs to the Kaldorei!','',26124),
(34913,'enUS','Approaching Stonetalon. Prepare for heavy resistance!','',26124),
(34914,'enUS','I will send these to Thunder Bluff to confirm my findings. I may need your assistance again soon, friend.','',26124),
(34915,'enUS','Systems failing....','',26124),
(34916,'enUS','','Look around you, servant of the Horde...',26124),
(34917,'enUS','','Your remains shall soon join those of them who have come before you.',26124),
(34918,'enUS','','Take aim, sisters...',26124),
(34919,'enUS','','Fire!!!',26124),
(34920,'enUS','This portal leads to the Stair of Destiny in Hellfire Peninsula... that\'s right, Outland.$B$BAre you prepared...?','',26124),
(34921,'enUS','Hold it!','',26124),
(34922,'enUS','What are you two conspiring? Hand me that package. ','',26124),
(34923,'enUS','$C, you should know the Warchief doesn\'t trust the undead. Have you heard what happened at the Wrathgate?','',26124),
(34924,'enUS','You should do well to consider where your loyalties lie, $r.','',26124),
(34925,'enUS','We\'ve seen the results of your \'research\' before. I\'ll deliver this package to Orgrimmar for study.','',26124),
(34926,'enUS','','What, this? This is nothing. Just some ... wildlife research.',26124),
(34927,'enUS','','Nonsense! You\'re overreacting. Have you been watching me this whole time?',26124),
(34928,'enUS','','%s mutters angrily to herself.',26124),
(34929,'enUS','You heard the lady, boys... Give \'em some fire!','',26124),
(34930,'enUS','The bloodhound has caught the scent.  Follow it!','',26124),
(34931,'enUS','The bloodhound has spotted a piece of parchment at the end of the trail.','',26124),
(34932,'enUS','Walk away, fool!  You are no match for me!','',26124),
(34933,'enUS','','Hey there, boss. I trust that you\'re enjoying your new promotion?$B$BWe all think that you\'re the one who\'s going to finally be able to replace that stinky ol\' Gallywix and take the title of Trade $g Prince : Princess;. But you didn\'t hear that from me!$B$BWe have a lot to do and very little time. Hope you\'re ready!',26124),
(34934,'enUS','We just need to knock the centrifugal rotary ball clutch back into alignment. Easy!','',26124),
(34935,'enUS','Billowing clouds of white smoke... Is that by design?','',26124),
(34936,'enUS','Hey $r. Seeing any profit lately?','',26124),
(34937,'enUS','Okay, my Personal People-Porter is ready for testing! I mean, ready for use. I wouldn\'t test unproven hardware on you, would I?','',26124),
(34938,'enUS','I\'m ready to teleport. I think.','I\'m ready to teleport. I think.',26124),
(34939,'enUS','Welcome to Stonetalon Mountains, friend! Saurboz is expectin\' ya.','',26124),
(34940,'enUS','Stand still, $n! And hold your breath in case you end up over the ocean...','',26124),
(34941,'enUS','Yep, $Ghe:she;\'s a goner.','',26124),
(34942,'enUS','','Waaaahhh! It\'s raining $r!!',26124),
(34943,'enUS','Locomotion systems operable. Resuming transport,','',26124),
(34944,'enUS','I need another Gahz\'ridian Detector.','I need another Gahz\'ridian Detector.',26124),
(34945,'enUS','These monkeys are a real pain!','',26124),
(34946,'enUS','Hey, $n, good to see you. These monkeys are driving me insane!$B$BWhat do you need?','',26124),
(34947,'enUS','Let\'s get this samophlange operational!','',26124),
(34948,'enUS','All I have to do is resequence the oscillating coolant pressure valves...','',26124),
(34949,'enUS','What? $n, you\'re not a warlock.$B$BThere\'s nothing that I can teach a $c like you, $g sir : ma\'am;.','',26124),
(34950,'enUS','$n, I\'m glad that you\'re here. Maybe I can teach you a thing or two.$B$BWhat do you think, $g sir : ma\'am;?','',26124),
(34951,'enUS','Somehow I doubt that you want training from me, $n. I\'m not sure those fingers can handle a firebolt.','',26124),
(34952,'enUS','I don\'t know about you, $n, but I for one do not intend to be marooned on this island forever!$B$BIf only I\'d stayed at the academy and learned how to use teleport magic....','',26124),
(34953,'enUS','Can you believe these monkeys, $n?','',26124),
(34954,'enUS','Ah good, there $g he : she; is... my future $g master : mistress; of the elements! What kind of training would you like today?','',26124),
(34955,'enUS','','You don\'t have to be a priest to tithe. Your coin is just as welcome, $g sir : ma\'am;.',26124),
(34956,'enUS','','Remember, $n, if you\'re going to be a $g priest : priestess; of the Light, you\'re going to need a lot of gold to keep things running smoothly.$B$BNever be afraid to ask for donations.',26124),
(34957,'enUS','','I\'m surprised that a $c like you could even see me, $n. I\'m stealth on a stick!',26124),
(34958,'enUS','','Sure, $n, I\'ll train you, $n. Just keep an eye out for those monkeys!',26124),
(34959,'enUS','Warrior-Matic NX-01 is currently offline.','',26124),
(34960,'enUS','Warrior-Matic NX-01 is online.$B$BPlease insert coins for training.','',26124),
(34961,'enUS','It\'s beautiful! ...have we figured out what it does yet?','',26124),
(34962,'enUS','No idea. But it\'s doing it perfectly!','',26124),
(34963,'enUS','Right away, Noz.','',26124),
(34964,'enUS','Is that a working samophlange? Throttle it up! MAX POWER!','',26124),
(34965,'enUS','Sputtervalve you\'re a genius! I\'ll take 30.','',26124),
(34966,'enUS','','Sometimes the mist cannot find its way if we are too far. Let\'s venture further and try again.',26124),
(34967,'enUS','','%s begins to cast |cFFFFFFFFLight Vortex!|r Switch to |cFFFFFFFFLight|r Essence!',26124),
(34968,'enUS','','%s begins to cast |cFF9932CDDark Vortex!|r Switch to |cFF9932CDDark|r Essence!',26124),
(34969,'enUS','Horde scum!','',26124),
(34970,'enUS','Die, filth!','',26124),
(34971,'enUS','$R, I\'ll have your head.','',26124),
(34972,'enUS','For Northwatch!','',26124),
(34973,'enUS','The Rear Admiral will hear of this.','',26124),
(34974,'enUS','','%s begins to cast  |cFFFF0000Twin\'s Pact!|r',26124),
(34975,'enUS','','%s begins to cast Twin\'s Pact!',26124),
(34976,'enUS','Forty five seconds until the Arena battle begins!','',26124),
(34977,'enUS','C\'mere! Here boy!','C\'mere! Here boy!',26124),
(34978,'enUS','...we\'ve got a nice bone for you, puppy.','...we\'ve got a nice bone for you, puppy.',26124),
(34979,'enUS','Gimmie that key, you stupid mutt!','Gimmie that key, you stupid mutt!',26124),
(34980,'enUS','%s whistles at Charlie the dog.','%s whistles at Charlie the dog.',26124),
(34981,'enUS','Tie game!','',26124),
(34982,'enUS','The Alliance captured the last flag!','',26124),
(34983,'enUS','It\'s the gallows for me...','It\'s the gallows for me...',26124),
(34984,'enUS','','Need some help finding your way? I know this place like the back of my hand.',26124),
(34985,'enUS','','You\'re finally here. Take the scenic route?',26124),
(34986,'enUS','','Glad to see that you\'ve arrived. Shall we get to it then?',26124),
(34987,'enUS','','Kyra said that you might need some help.',26124),
(34988,'enUS','','There you are! I thought the furbolgs might have caught you before you could even get here.',26124),
(34989,'enUS','','Good to see you. They\'re all throughout the tunnels, we\'ll have to stay on our guard.',26124),
(34990,'enUS','','I\'m hurt! Go on without me.',26124),
(34991,'enUS','','I\'ll need to find a place to rest a while. Continue on... don\'t leave without the relics.',26124),
(34992,'enUS','','I\'m injured! I need to rest a bit.',26124),
(34993,'enUS','','It saddens me to see the furbolg all corrupted so readily. These used to be our friends.',26124),
(34994,'enUS','','This place is infested... we\'ll need to make our way out of here with the relics as quickly as possible.',26124),
(34995,'enUS','','I haven\'t seen any of the sleeping druids. They must have been taken from here already.',26124),
(34996,'enUS','','We should have seen this coming. The corruption has been spreading for quite some time.',26124),
(34997,'enUS','','If the furbolg could be this far gone, what does that say for the rest of Teldrassil?',26124),
(34998,'enUS','','There has to be a way to stop this corruption before it consumes us all.',26124),
(34999,'enUS','','Damn you, Fandral! What have you gotten us into with this cursed \"World Tree?\"',26124),
(35000,'enUS','Yaaarr!','Yar!',26124),
(35001,'enUS','The Horde captured the last flag!','',26124),
(35002,'enUS','What, are you crazy?! Trying to blow me to smithereens like that!','What, are you crazy?! Trying to blow me to smithereens like that!',26124),
(35003,'enUS','$n, it\'s you! Thanks, $g man : sweetie;!','$n, it\'s you! Thanks, $g man : sweetie;!',26124),
(35004,'enUS','Blowing open my escape pod. I like your style, $n!','Blowing open my escape pod. I like your style, $n!',26124),
(35005,'enUS','$n? I heard you were dead.','$n? I heard you were dead.',26124),
(35006,'enUS','Couldn\'t you have just used a crowbar?','Couldn\'t you have just used a crowbar?',26124),
(35007,'enUS','$n! Please tell me that monster, the Trade Prince, didn\'t survive?!','$n! Please tell me that monster, the Trade Prince, didn\'t survive?!',26124),
(35008,'enUS','Thanks, $n. You still owe me that money, $g man : lady;!','Thanks, $n. You still owe me that money, $g man : lady;!',26124),
(35009,'enUS','What were those Alliance ships doing firing at us?! Did I see a Horde ship, too?','What were those Alliance ships doing firing at us?! Did I see a Horde ship, too?',26124),
(35010,'enUS','Time Expired!','',26124),
(35011,'enUS','<The drunken engineer blinks blearily at you.>','',26124),
(35012,'enUS','<Club him unconscious.>','<Club him unconscious.>',26124),
(35013,'enUS','','Hahaha, very nice, $n!',26124),
(35014,'enUS','I\'m going deaf. That big green harpy won\'t shut up for five seconds. I know how to drive this thing, all right? I\'m not an idiot!','',26124),
(35015,'enUS','','Zippik would drive us straight into the Bluff if I wasn\'t here. Moron.',26124),
(35016,'enUS','It\'s a pretty smooth ride if you don\'t mind the dust.','It\'s a pretty smooth ride if you don\'t mind the dust.',26124),
(35017,'enUS','Keep away from the edge there, champ. Don\'t want you falling.','Keep away from the edge there, champ. Don\'t want you falling.',26124),
(35018,'enUS','I\'m workin\', here.','I\'m workin\', here.',26124),
(35019,'enUS','<The Engineer slumbers fitfully on the floor.>','',26124),
(35020,'enUS','<Rifle through his pockets.>','<Rifle through his pockets.>',26124),
(35021,'enUS','Hey. I\'m on break.','',26124),
(35022,'enUS','Welcome aboard the Zephyr, the smoothest ride you\'re likely to get across the Barrens. Sit back and enjoy the flight, eh, kid? Ain\'t nothing like that sweet, dry air mixed with the scent of oil.','',26124),
(35023,'enUS','','Shh! Someone\'s here.',26124),
(35024,'enUS','Don\'t get me wrong... I\'m grateful to have Shando Stormrage back, but this is all really suspicious. What happened to Fandral?','',26124),
(35025,'enUS','I be Tolwe. Job be to keep da peace an\' watch. So I be watchin\'.','',26124),
(35026,'enUS','Dere be a bird!','',26124),
(35027,'enUS','Dat cloud look like da Warchief.','',26124),
(35028,'enUS','Ware da ship! A harpy! ...wait, dat be another bird.','',26124),
(35029,'enUS','Dere be a bug.','',26124),
(35030,'enUS','And there\'s Orgrimmar, huge and menacing like always. Take a quick break, boys, then it\'s back to the Bluff!','',26124),
(35031,'enUS','Next stop, Thunder Bluff!','',26124),
(35032,'enUS','Watch your step! Don\'t want you becoming a smudge down there. Welcome to Thunder Bluff!','',26124),
(35033,'enUS','Okay, boys, let\'s get this baby over to Orgrimmar!','',26124),
(35034,'enUS','','Careful. CAREFUL! Did I feel a shudder? You\'re going to knock that tower down, oaf!',26124),
(35035,'enUS','','We\'re behind schedule! Turn this tub east! EAST!',26124),
(35036,'enUS','I\'m ready to depart for Ban\'ethil Barrow Den.','I\'m ready to depart for Ban\'ethil Barrow Den.',26124),
(35037,'enUS','','Move it, Zippik! We don\'t have all day!',26124),
(35038,'enUS','','Hey, sweetheart. The zeppelin that parks here\'ll take ya straight to Thunder Bluff, free of charge. Who needs wyverns when you got us goblins here, am I right?',26124),
(35039,'enUS','','The zeppelin to Thunder Bluff has arrived! All aboard for a smooth ride across the Barrens!',26124),
(35040,'enUS','Can you believe it? They finally opened this place up for us to fly a zeppelin through here! No fly zone no more, am I right? We only crashed one zeppelin into a cliff on the test run. I don\'t see why they were so worried.','',26124),
(35041,'enUS','Step right up! The zeppelin to Orgrimmar has arrived! All aboard to Durotar!','',26124),
(35042,'enUS','Limpet Mine Planted! Detonation in:','',26124),
(35043,'enUS','...5...','',26124),
(35044,'enUS','...4...','',26124),
(35045,'enUS','...3...','',26124),
(35046,'enUS','...2...','',26124),
(35047,'enUS','...1...','',26124),
(35048,'enUS','What\'re ye starin\' at, $r? Come ta torment the condemned?','',26124),
(35049,'enUS','<The Baron lifts his manacles.>$B$BCome on then, $c. Do ye trust me?','',26124),
(35050,'enUS','Never, you two-timing dog!','Never, you two-timing dog!',26124),
(35051,'enUS','<Break Longshore\'s manacles and free him.>','<Break Longshore\'s manacles and free him.>',26124),
(35052,'enUS','Har! Pleasure doin\' business with ye, $n.','',26124),
(35053,'enUS','Well? Don\'t ye have heads ta roll an\' treasure ta dig up?','',26124),
(35054,'enUS','Suit yerself, mate. Me an\' the treasure can both be buried.','',26124),
(35055,'enUS','Hello, $n. If you\'re looking for cooking training, you\'ve come to the right place. I usually get lots of new students when Pilgrim\'s Bounty rolls around.','Hello, $n. If you\'re looking for cooking training, you\'ve come to the right place. I usually get lots of new students when Pilgrim\'s Bounty rolls around.',26124),
(35056,'enUS','Gagsprocket! Shave this for me - pronto!','',26124),
(35057,'enUS','Thanks.','',26124),
(35058,'enUS','Sure thing, boss.','',26124),
(35059,'enUS','Digging','Digging',26124),
(35060,'enUS','Hold it, $r! I promised told ye where the treasure is, but never promised ye could keep it!','',26124),
(35061,'enUS','If you\'re interested in learning more about the traditional Pilgrim\'s Bounty feast, speak to any of the hostesses.','',26124),
(35062,'enUS','I seek training.','I seek training.',26124),
(35063,'enUS','Grah! Gormok smash you!','Grah! Gormok smash you!',26124),
(35064,'enUS','Me hungry!','Me hungry!',26124),
(35065,'enUS','Me stab you good!','Me stab you good!',26124),
(35067,'enUS','Gormok smash cage, you see!','Gormok smash cage, you see!',26124),
(35068,'enUS','Smelly fat thing give food!','Smelly fat thing give food!',26124),
(35069,'enUS','Are you here to celebrate Pilgrim\'s Bounty with us?','',26124),
(35070,'enUS','%s unleashes a Leeching Swarm to heal himself!','',26124),
(35071,'enUS','%s burrows into the ground!','',26124),
(35072,'enUS','C\'mon mates! Take the ship and give no quarter!','',26124),
(35073,'enUS','Right, Cuthbert should be below decks. Come with me, mon!','',26124),
(35074,'enUS','Mutiny!','',26124),
(35075,'enUS','More of Gormok\'s vermin. Keep them fed.','',26124),
(35076,'enUS','There she is, mon! Let\'s finish this business.','',26124),
(35077,'enUS','','Do not trifle with me, $r.',26124),
(35078,'enUS','','I should\'ve known you were behind this, Two-Tusk. Have at it, traitor!',26124),
(35079,'enUS','','Another mutiny put to rest. Now get this blood off my decks!',26124),
(35080,'enUS','','Cap\'n Garvey will hear of this!',26124),
(35081,'enUS','Your shredder is nearly ready, really!$b$bAny moment now... just keep checking with me!','',26124),
(35082,'enUS','Help me out here, mon!','',26124),
(35083,'enUS','I\'m countin\' on it!','',26124),
(35084,'enUS','We did it! The Maiden\'s Dagger is mine, all mine!','',26124),
(35085,'enUS','You tell Dizzywig that I\'m open to negotiations....','',26124),
(35086,'enUS','The shredder... It\'s done! Where\'d that driver go...','',26124),
(35087,'enUS','','Welcome! Have you come to join us for a Pilgrim\'s Bounty feast? Please, have a seat at a Bountiful Table.$B$BTry everything! I\'m certain you\'ll find something to your liking.',26124),
(35088,'enUS','','Welcome! Have you come to join us for a Pilgrim\'s Bounty feast? Please, have a seat at a Bountiful Table.$B$BTry everything! I\'m certain you\'ll find something to your liking.',26124),
(35089,'enUS','As you say. They are restless creatures.','',26124),
(35090,'enUS','They will get their chance to fight.','',26124),
(35091,'enUS','\"Pilgrim\'s Bounty.\" Hrm. I can understand the tauren\'s eagerness to express their sense of gratitude and comraderie to the Horde\'s warchief, but the Forsaken?$B$BI imagined they would have dropped such sentimental traditions long ago.','\"Pilgrim\'s Bounty.\" Hrm. I can understand the tauren\'s eagerness to express their sense of gratitude and comraderie to the Horde\'s warchief, but the Forsaken?$B$BI imagined they would have dropped such sentimental traditions long ago.',26124),
(35092,'enUS','I am told Pilgrim\'s Bounty is a time to reflect upon one\'s good fortune and share with all around you.$B$BWe are lucky to have found this world and its bold inhabitants; it is only fitting that we lend our knowledge and strength to these new-found allies.','I am told Pilgrim\'s Bounty is a time to reflect upon one\'s good fortune and share with all around you.$B$BWe are lucky to have found this world and its bold inhabitants; it is only fitting that we lend our knowledge and strength to these new-found allies.',26124),
(35093,'enUS','Humans can\'t brew their way out of a tattered linen pouch, but there sure know how to cook. Pilgrim\'s Bounty? I\'m all for it!','Humans can\'t brew their way out of a tattered linen pouch, but there sure know how to cook. Pilgrim\'s Bounty? I\'m all for it!',26124),
(35094,'enUS','The logistics involved in the optimal celebration of Pilgrim\'s Bounty are quite staggering... so many raw materials, so much labor, thousands upon thousands of crates of finished product shipped here and there and everywhere for countless Bountiful Tables.$B$BHonestly, I\'m quite impressed! And hungry... I can smell pumpkin pie. Can you smell that pie?','The logistics involved in the optimal celebration of Pilgrim\'s Bounty are quite staggering... so many raw materials, so much labor, thousands upon thousands of crates of finished product shipped here and there and everywhere for countless Bountiful Tables.$B$BHonestly, I\'m quite impressed! And hungry... I can smell pumpkin pie. Can you smell that pie?',26124),
(35095,'enUS','\"Pilgrim\'s Bounty?\" More like \"Fool\'s Folly!\"$B$BHundreds of cargo holds full of food given away for free... FREE! It boggles the mind!$B$BStill, I suppose I should shift some of my Poultry Portfolio funds to turkey... I can\'t believe how big of a bust that chicken investment was. Where did all those Noblegarden eggs COME from?!','\"Pilgrim\'s Bounty?\" More like \"Fool\'s Folly!\"$B$BHundreds of cargo holds full of food given away for free... FREE! It boggles the mind!$B$BStill, I suppose I should shift some of my Poultry Portfolio funds to turkey... I can\'t believe how big of a bust that chicken investment was. Where did all those Noblegarden eggs COME from?!',26124),
(35096,'enUS','Pilgrim\'s Bounty is a time to reflect upon one\'s good fortune and share with all around you.$B$BWe hope that all of our noble allies will join us in feasting and celebration.','Pilgrim\'s Bounty is a time to reflect upon one\'s good fortune and share with all around you.$B$BWe hope that all of our noble allies will join us in feasting and celebration.',26124),
(35097,'enUS','Such a stark contrast, this holiday, to typical human behavior. Who\'d have thought such a relentlessly voracious people would make a celebration of giving and sharing?$B$BIt\'s pleasant to see. Darnassus should do its utmost to support and encourage it.','Such a stark contrast, this holiday, to typical human behavior. Who\'d have thought such a relentlessly voracious people would make a celebration of giving and sharing?$B$BIt\'s pleasant to see. Darnassus should do its utmost to support and encourage it.',26124),
(35098,'enUS','The orcs and tauren are fortunate to have found one another, for each people\'s strengths compliment the other\'s.  We are glad to join them in this celebration.$B$BEven the Forsaken partake, though to what end I am not certain...','The orcs and tauren are fortunate to have found one another, for each people\'s strengths compliment the other\'s.  We are glad to join them in this celebration.$B$BEven the Forsaken partake, though to what end I am not certain...',26124),
(35099,'enUS','Pilgrim\'s Bounty is a time to reflect upon one\'s good fortune and share with all around you.$B$BIn Mulgore and the Horde, we have found both a home and friends to enjoy its many fruits with.$B$BIt is our hope that every one of our allies will be able to join us in feasting and celebration.','Pilgrim\'s Bounty is a time to reflect upon one\'s good fortune and share with all around you.$B$BIn Mulgore and the Horde, we have found both a home and friends to enjoy its many fruits with.$B$BIt is our hope that every one of our allies will be able to join us in feasting and celebration.',26124),
(35100,'enUS','Dem tauren, dey be KNOWIN\' how ta cook. Have ya SEEN all de food dey be servin\'?$B$BI\'m gonna eat \'til I die... an\' den come back from de grave ta be eatin\' some more!','Dem tauren, dey be KNOWIN\' how ta cook. Have ya SEEN all de food dey be servin\'?$B$BI\'m gonna eat \'til I die... an\' den come back from de grave ta be eatin\' some more!',26124),
(35101,'enUS','Why do we celebrate Pilgrim\'s Bounty...? Who can say. Habit, I suppose. I certainly can\'t taste any of it.$B$BPumpkin pie, virulent plagues... Does it really matter WHAT we\'re cooking up?','Why do we celebrate Pilgrim\'s Bounty...? Who can say. Habit, I suppose. I certainly can\'t taste any of it.$B$BPumpkin pie, virulent plagues... Does it really matter WHAT we\'re cooking up?',26124),
(35102,'enUS','Ratchet security is a joke, open to the highest bidder. Our coffers will buy us the guards.','',26124),
(35103,'enUS','The Southsea Pearl and the Conquest will be joining us within the week to help with the invasion.','',26124),
(35104,'enUS','The Conquest will sail into Ratchet harbor first. Noise is her aim: Double-shot the guns, sew havoc.','',26124),
(35105,'enUS','I\'ll helm the Maiden\'s Dagger and lead the shore parties myself.','',26124),
(35106,'enUS','With Ratchet as our new base of operations, Orgrimmar harbor will be ripe for the plucking!','',26124),
(35107,'enUS','Get away from the rum!','',26124),
(35108,'enUS','How do the Bountiful Tables work?','How do the Bountiful Tables work?',26124),
(35109,'enUS','','A Bountiful Table is laid out with five Pilgrim\'s Bounty foods, one in front of each chair.$B$BWhile in a chair, you may eat as much of that food as you like, as well as pass servings of that food to the other chairs. Feast and share with friends!$B$BIf you eat enough of any one food, you\'ll gain benefits unique to that food.$B$BIn addition, if you eat enough of every food, you\'ll gain the Spirit of Sharing!',26124),
(35110,'enUS','','A Bountiful Table is laid out with five Pilgrim\'s Bounty foods, one in front of each chair.$B$BWhile in a chair, you may eat as much of that food as you like, as well as pass servings of that food to the other chairs. Feast and share with friends!$B$BIf you eat enough of any one food, you\'ll gain benefits unique to that food.$B$BIn addition, if you eat enough of every food, you\'ll gain the Spirit of Sharing!',26124),
(35111,'enUS','<The troll before you is covered head-to-toe with gashes and scars, including a fresh slice across his face that has fattened his lip.>$B$BHewwo!$B$BAs you know, twolls wide waptors. The pwobwem is cowwecting the wild waptors for twaining! That\'s where I come in. I\'m a waptor twapper.','',26124),
(35112,'enUS','Sorry, mon. It won\'t happen again.','Sorry, mon. It won\'t happen again.',26124),
(35113,'enUS','I\'m going. I\'m going!','I\'m going. I\'m going!',26124),
(35114,'enUS','Oops, break\'s over.','Oops, break\'s over.',26124),
(35115,'enUS','Don\'t tase me, mon!','Don\'t tase me, mon!',26124),
(35116,'enUS','The trap emits a raptor-like screech!','',26124),
(35117,'enUS','','FOR MOTHER RUSSIA!\n',26124),
(35118,'enUS','Oh - I fowgot the voodoo to enwawge them.','',26124),
(35119,'enUS','...We\'re gonna need some smawwer twolls!','',26124),
(35121,'enUS','Hewwo.','',26124),
(35122,'enUS','Be caweful with the waptors, they can be wewy wewy smawt.$B$BLast week two hewd me down while a thiwd beat me with a stick.','',26124),
(35123,'enUS','Megs, I misplaced the keys to the cruiser. Did you find them?','Megs, I misplaced the keys to the cruiser. Did you find them?',26124),
(35124,'enUS','','%s calls out for her mate!',26124),
(35125,'enUS','Verog the Dervish howls with rage!','',26124),
(35126,'enUS','Darn, you got me!','',26124),
(35127,'enUS','Darn, you got me!','',26124),
(35128,'enUS','Pay up, Bruno!','Pay up, Bruno!',26124),
(35129,'enUS','','What? Fine, fine... I\'ll pay my protection moolah to your goons!',26124),
(35130,'enUS','Hand it over, Frankie!','Hand it over, Frankie!',26124),
(35131,'enUS','','What? Fine, fine... I got it, I got it!',26124),
(35132,'enUS','%s grunts and gives up, clearly beaten.','',26124),
(35133,'enUS','<Grunt>','',26124),
(35134,'enUS','Don\'t play stupid with me, Jack. I know that you have the moolah!','Don\'t play stupid with me, Jack. I know that you have the moolah!',26124),
(35135,'enUS','Not the face, not the face!','',26124),
(35136,'enUS','Not the face, not the face!','',26124),
(35137,'enUS','Business been bad lately, Sudsy?','Business been bad lately, Sudsy?',26124),
(35138,'enUS','Ride hard and show no mercy!','',26124),
(35139,'enUS','The Burning Blade? What are they doing here? Shoot to kill!','',26124),
(35140,'enUS','','$G Mr. : Ms.; $n, so very good to see you.$B$BI hope that you are enjoying the Kaja\'Cola marketing campaign. We\'re planning a massive set of explosions for the next phase of the campaign. That always goes over well with our target demographic.',26124),
(35141,'enUS','You\'ll find Krendle Bigpockets near the zeppelin\'s perch on the western edge of Spirit Rise. I\'m not fond of the goblin contraption flying through here... but it will take you to Orgrimmar if you can stand it. From Orgrimmar you can risk another zeppelin to Undercity or Silvermoon City in the Eastern Kingdoms or one to Warsong Hold in Northrend.','You\'ll find Krendle Bigpockets near the zeppelin\'s perch on the western edge of Spirit Rise. I\'m not fond of the goblin contraption flying through here... but it will take you to Orgrimmar if you can stand it. From Orgrimmar you can risk another zeppelin to Undercity or Silvermoon City in the Eastern Kingdoms or one to Warsong Hold in Northrend.',26124),
(35142,'enUS','The true crusader is more than just a hero in the battle against evil... he is an exemplar, a rallier to the cause, a champion in the eyes of all his people.$B$BAs High Crusader, it is my duty to task such men and women with worthy quests.','',26124),
(35143,'enUS','The blood elves of Silvermoon cheer for $n.','The blood elves of Silvermoon cheer for $n.',26124),
(35144,'enUS','The draenei of the Exodar cheer for $n.','The draenei of the Exodar cheer for $n.',26124),
(35145,'enUS','The dwarves of Ironforge begin a cheer for $n.','The dwarves of Ironforge begin a cheer for $n.',26124),
(35146,'enUS','The gnomes of Gnomeregan cheer for $n.','The gnomes of Gnomeregan cheer for $n.',26124),
(35147,'enUS','The humans of Stormwind cheer for $n.','The humans of Stormwind cheer for $n.',26124),
(35148,'enUS','The night elves of Darnassus cheer for $n.','The night elves of Darnassus cheer for $n.',26124),
(35149,'enUS','The orcs of Orgrimmar cheer for $n.','The orcs of Orgrimmar cheer for $n.',26124),
(35150,'enUS','The tauren of Thunder Bluff cheer for $n.','The tauren of Thunder Bluff cheer for $n.',26124),
(35151,'enUS','The trolls of the Sen\'jin Village begin a chant to celebrate $n.','The trolls of the Sen\'jin Village begin a chant to celebrate $n.',26124),
(35152,'enUS','The forsaken of the Undercity cheer for $n.','The forsaken of the Undercity cheer for $n.',26124),
(35153,'enUS','$n prepares a Bountiful Feast!','$n prepares a Bountiful Feast!',26124),
(35154,'enUS','You no take... me!','',26124),
(35155,'enUS','No!','',26124),
(35156,'enUS','Grrrrr!','',26124),
(35157,'enUS','No kill me!','',26124),
(35158,'enUS','Net not stop me! No... net stop me.','',26124),
(35159,'enUS','Me not afraid!','',26124),
(35160,'enUS','','There are some rewards fit only for those who have attained the title of Crusader, exalted in the eyes of the Argent Crusade as well as all their allied peoples.$B$BTirion himself has charged me with the finding of such heroes and bestowing upon them the proper decorations.',26124),
(35161,'enUS','The Alliance spectators cheer for $n.','The Alliance spectators cheer for $n.',26124),
(35162,'enUS','The Horde spectators cheer for $n.','The Horde spectators cheer for $n.',26124),
(35163,'enUS','%s begins to boil upon touching $n!','',26124),
(35164,'enUS','The gates have been breached! Defend the keep!','',26124),
(35165,'enUS','The gates have been breached! Defend the keep!','',26124),
(35166,'enUS','Stand your ground, men!','',26124),
(35167,'enUS','Defeat these foul beasts!','',26124),
(35168,'enUS','Protect the civilians!','',26124),
(35169,'enUS','Push them back!','',26124),
(35170,'enUS','Take heart, men!  We must protect our city!','',26124),
(35171,'enUS','Welcome, champion! Have you gathered your forces in preparation for the challenges of the Trials of the Crusader?','',26124),
(35172,'enUS','Yes. We are prepared for the challenges ahead of us.','Yes. We are prepared for the challenges ahead of us.',26124),
(35173,'enUS','Are you ready for the first challenge, then?','',26124),
(35174,'enUS','Bring forth the first challenge!','Bring forth the first challenge!',26124),
(35175,'enUS','','I heard Lord Xavius left today for his tower in Ashenvale. ',26124),
(35176,'enUS','Oh? Do you think his promise of an even greater source of power will come true?','',26124),
(35177,'enUS','','As one of the greatest of the Highborne, he will succeed where others have failed.',26124),
(35178,'enUS','I\'m still wary of the risks. While I agree that Malfurion and his dirt-loving brothers are quite mad, this Lord Sargeras must have another agenda...','',26124),
(35179,'enUS','','Shush! Quiet... before the others hear you.  ',26124),
(35180,'enUS','Thank you, $c.','Thank you, $c.',26124),
(35181,'enUS','They\'re killing the prisoners! Hurry, help the others.','They\'re killing the prisoners! Hurry, help the others.',26124),
(35182,'enUS','I thought I\'d never make it out of here alive.','I thought I\'d never make it out of here alive.',26124),
(35183,'enUS','I thought I was going to die in there!','I thought I was going to die in there!',26124),
(35184,'enUS','I knew I shouldn\'t have come to the tournament!','I knew I shouldn\'t have come to the tournament!',26124),
(35185,'enUS','My friends, my colleagues. Put yourselves at ease.','',26124),
(35186,'enUS','The recent decrease in our magical powers is being reviewed as we speak. Even Lord Xavius has said that the ebb and flow of magic is normal. ','',26124),
(35187,'enUS','However, our new allies, formed from within the Twisting Nether promise new sources of power, and untold mastery of our magic. Keep faith in Lady Azshara, as she keeps her faith in you. ','',26124),
(35188,'enUS','%s nods warmly.','',26124),
(35189,'enUS','Please show me your documents before proceeding.','',26124),
(35190,'enUS','%s creates a Nether Portal!','',26124),
(35191,'enUS','%s creates an |cFF00FF00Infernal Volcano!|r','',26124),
(35192,'enUS','By orders of the Queen, all possessions must be inspected before entry into the city is permitted.','',26124),
(35193,'enUS','Patience, patience. We will be with you shortly.','',26124),
(35194,'enUS','$n has |cFFFF0000Legion Flames!|r\n','',26124),
(35195,'enUS','$n has |cFF00FFFFIncinerate Flesh!|r','',26124),
(35196,'enUS','Placing','Placing',26124),
(35197,'enUS','Oh, Illyanna, your eyes, they are so beautiful.','',26124),
(35198,'enUS','','Yes. They are even more beautiful without your reflection in them. ',26124),
(35199,'enUS','Illyanna, why do you spurn me? I would weave a web to catch the sun, if you were to ask me to do so!','',26124),
(35200,'enUS','','Then why don\'t you go and do that? My friends and I have better things to do!',26124),
(35201,'enUS','To hold you in my arms would be the fulfillment of my dreams. Come down from there, let us travel far away from here!','',26124),
(35202,'enUS','','You go ahead and start your travels. I\'ll catch up with you right after I finish tending to my hair. ',26124),
(35203,'enUS','Oh, Illyanna, I love you!','',26124),
(35204,'enUS','','%s shudders.',26124),
(35205,'enUS','That was the greatest moment of my life...','',26124),
(35206,'enUS','','Away from me, lowborn scum! Perhaps you did not notice my boot in your face the first time!',26124),
(35207,'enUS','%s giggles.','%s giggles.',26124),
(35208,'enUS','','The sisters go into a Berserker Rage!',26124),
(35209,'enUS','','Come in, come in! One at a time.',26124),
(35210,'enUS','','Browse my wares to your hearts content! From the finest in enchantments, to the latest in fashion, you can find it all here.',26124),
(35211,'enUS','','I recommend you buy like there was no tomorrow. Who knows how long it will be until you find deals this good again.',26124),
(35212,'enUS','','All I\'m saying is don\'t be caught dead in those outdated fashions!',26124),
(35213,'enUS','Those beasts are amazing specimens. You should feel no shame at being bested by them.','',26124),
(35214,'enUS','Excellent! Let me know when you are ready for the next attempt.','',26124),
(35215,'enUS','We want another shot at those beasts!','We want another shot at those beasts!',26124),
(35216,'enUS','We\'re ready. This time things will be different.','We\'re ready. This time things will be different.',26124),
(35217,'enUS','You are not yet strong enough to do battle on the Isle of Conquest. Return when you have gained more experience.','You are not yet strong enough to do battle on the Isle of Conquest. Return when you have gained more experience.',26124),
(35218,'enUS','The Isle of Conquest is laden with valuable resources we cannot allow to fall into Horde hands. Will you join the fight?','The Isle of Conquest is laden with valuable resources we cannot allow to fall into Horde hands. Will you join the fight?',26124),
(35219,'enUS','The Isle of Conquest is laden with valuable resources we cannot allow to fall into Alliance hands. Will you join the fight?','The Isle of Conquest is laden with valuable resources we cannot allow to fall into Alliance hands. Will you join the fight?',26124),
(35220,'enUS','I\'d like a pair of Synthebrew Goggles.','I\'d like a pair of Synthebrew Goggles.',26124),
(35221,'enUS','We want everyone to have fun at Brewfest.  It would also help if we had some people remember it as well.$b$bThese goggles allow anyone to experience what it\'s like to be drunk, but without the drinking part.  Put the goggles on, and it\'s like you\'re drunk!  Take them off, and you\'re sober!$b$bAre you interested in a pair?','We want everyone to have fun at Brewfest.  It would also help if we had some people remember it as well.$b$bThese goggles allow anyone to experience what it\'s like to be drunk, but without the drinking part.  Put the goggles on, and it\'s like you\'re drunk!  Take them off, and you\'re sober!$b$bAre you interested in a pair?',26124),
(35222,'enUS','What are Synthebrew Goggles?','What are Synthebrew Goggles?',26124),
(35223,'enUS','What did you say earlier?','What did you say earlier?',26124),
(35224,'enUS','You are not yet seasoned enough to enter a battleground, $c. Return when you have gained more experience.','You are not yet seasoned enough to enter a battleground, $c. Return when you have gained more experience.',26124),
(35225,'enUS','Are you ready to fight for the Horde, $c?','Are you ready to fight for the Horde, $c?',26124),
(35226,'enUS','Are you ready to fight for the Alliance, $c?','Are you ready to fight for the Alliance, $c?',26124),
(35227,'enUS','You dare to challenge Drottinn Hrothgar, king of the seas?','',26124),
(35228,'enUS','All aboard the gunship! Man the guns!','',26124),
(35229,'enUS','','Well, then. Let us begin.',26124),
(35230,'enUS','Thank you!','Thank you!',26124),
(35231,'enUS','','Even the darkest memory fades when confronted!',26124),
(35232,'enUS','','Excellent work!',26124),
(35233,'enUS','%s grabs a Snobold Vassal off his back and prepares to hurl it into battle!','',26124),
(35234,'enUS','Protect me, please!','Protect me, please!',26124),
(35235,'enUS','What in the world?  Let\'s get out of here!','What in the world?  Let\'s get out of here!',26124),
(35236,'enUS','Let\'s go!','Let\'s go!',26124),
(35237,'enUS','No time to waste!','No time to waste!',26124),
(35238,'enUS','Worgen!  Worgen everywhere!','Worgen!  Worgen everywhere!',26124),
(35239,'enUS','This place isn\'t safe.  Let\'s leave!','This place isn\'t safe.  Let\'s leave!',26124),
(35240,'enUS','Flee!  They\'re everywhere!','Flee!  They\'re everywhere!',26124),
(35241,'enUS','All aboard the gunship! Man the guns!','',26124),
(35242,'enUS','$n','',26124),
(35243,'enUS','What recipes do you sell?','What recipes do you sell?',26124),
(35244,'enUS','Live Update Works again!','Hello!',26124),
(35245,'enUS','Proud and strong, give a cheer for Marshal Jacob Alerius, the Grand Champion of Stormwind!','',26124),
(35246,'enUS','The might of the dwarves is represented today by the Grand Champion of Ironforge, Lana Stouthammer!','',26124),
(35247,'enUS','Coming out of the gate is Colosos, the towering Grand Champion of the Exodar!','',26124),
(35248,'enUS','Here comes the small but deadly Ambrose Boltspark, Grand Champion of Gnomeregan!','',26124),
(35249,'enUS','Entering the arena is the Grand Champion of Darnassus, the skilled sentinel Jaelyne Evensong!','',26124),
(35250,'enUS','Well done! Your fighting against all those beasts was splendid! I hear the next challenge should be even tougher!','',26124),
(35251,'enUS','What new challenge awaits us?','What new challenge awaits us?',26124),
(35252,'enUS','We\'re holding Lord Jaraxxus back for now, but we can\'t keep him bound for much longer.','',26124),
(35253,'enUS','You\'ll find out soon enough. Are you ready for the next challenge?','',26124),
(35254,'enUS','We\'re ready to fight the sorceror again.','We\'re ready to fight the sorceror again.',26124),
(35255,'enUS','','Hi, babe! How do I look?',26124),
(35256,'enUS','That\'s great, just give me the signal for when to drop the binding spells.','',26124),
(35257,'enUS','We\'re ready for the next challenge.','We\'re ready for the next challenge.',26124),
(35258,'enUS','Now.','Now.',26124),
(35259,'enUS','The Silver Covenant is pleased to present their contenders for this event, Highlord.','',26124),
(35260,'enUS','The Sunreavers are proud to present their representatives in this trial by combat.','',26124),
(35261,'enUS','I adore you! You believe me? Right, baby?','',26124),
(35262,'enUS','','I missed you so much! Where have you been?$B$BAre you going to answer me, or just stand there?',26124),
(35263,'enUS','','Do you like my outfit?  It\'s for the party. I charged it to your account.',26124),
(35264,'enUS','','There was another guy just hitting on me. Oh, the nerve!$B$BWill you beat him up for me, sweetie? Thanks. Love ya!',26124),
(35265,'enUS','','I can\'t wait for the day when you rise to the top. Just think, I\'ll be able to call myself Mrs. Trade Prince$B$BNot to mention buy all that stuff I\'ve always wanted!!!',26124),
(35266,'enUS','','Be careful out there. I heard that there are Southsea pirates in the bay.$B$BHmm, maybe I should go check for myself...',26124),
(35267,'enUS','','Can we go on a nice, romantic picnic on top of Mount Kajaro?$B$BMake sure you pickup my favorite champagne!',26124),
(35268,'enUS','','You\'ve got a miscievious look in your eye. What have you been up to, babe?$B$BWell?',26124),
(35269,'enUS','Sweetie, where have you been? You know how worried I get when you don\'t check in with me!','',26124),
(35270,'enUS','What do you think of my abs, baby? I just got back from the gym.$B$BI am one fine piece of meat!','',26124),
(35271,'enUS','Those other women are just friends, baby.','',26124),
(35272,'enUS','I like what you\'re wearing!','',26124),
(35273,'enUS','I know that I promised you last night, and the night before that, but I\'m taking you out someplace really nice tomorrow night!','',26124),
(35275,'enUS','I heard that some Southsea pirates pulled into dock earlier. Be careful if you go into town!$B$BThey even have women pirates! Hmm, maybe I should go check it out myself? Just to make sure it\'s safe for you out there, baby.','',26124),
(35276,'enUS','How\'s my hot, company executive girlfriend today? With the way you run things around here, I think that any day now we\'ll be calling you Trade Princess $n!$B$BI cannot wait! I\'m gonna spend my days at the gym and working on my tan by the pool.','',26124),
(35277,'enUS','A cunning $c, a proud $r.  We are pleased to present $n to you.','',26124),
(35278,'enUS','$n has assaulted the workshop!','',26124),
(35279,'enUS','The Alliance has taken the workshop!','',26124),
(35280,'enUS','The Horde has taken the workshop!','',26124),
(35281,'enUS','One of the fiercest $cs on the field of battle, we present $n.','',26124),
(35282,'enUS','Words can scarce describe the deeds that this $c has performed on the battlefield.  We are proud to present $n.','',26124),
(35283,'enUS','We present to you, $n.  One of the finest $cs we have seen in action.','',26124),
(35284,'enUS','If you do not yet know this name, we are certain you will after these battles.  We present, $n.','',26124),
(35285,'enUS','Sassy, get me another ride down to the Kaja\'mite Mine.','Sassy, get me another ride down to the Kaja\'mite Mine.',26124),
(35286,'enUS','$n has defended the workshop!','',26124),
(35289,'enUS','Hey there, boss-$g man : lady;. This batch of troll slaves has got to be the worst yet!$B$BLucky for us that the kaja\'mite doesn\'t seem to be making their soft brains any smarter, eh?','',26124),
(35290,'enUS','Dampwick, I need a ride back to headquarters, pronto!','Dampwick, I need a ride back to headquarters, pronto!',26124),
(35291,'enUS','At last... now I can rest.','At last... now I can rest.',26124),
(35292,'enUS','My nightmare, is it finally over?','My nightmare, is it finally over?',26124),
(35293,'enUS','It was awful... I dreamt I was fighting against my friends.','It was awful... I dreamt I was fighting against my friends.',26124),
(35294,'enUS','I can\'t hear the screams anymore. Is this the end?','I can\'t hear the screams anymore. Is this the end?',26124),
(35295,'enUS','I\'m so tired. Just let me rest for a moment.','I\'m so tired. Just let me rest for a moment.',26124),
(35296,'enUS','Here we go!','',26124),
(35297,'enUS','Hold on!','',26124),
(35298,'enUS','This won\'t take long.','',26124),
(35299,'enUS','May I say that it\'s an honor to be your driver?','',26124),
(35300,'enUS','The mines have been at peak efficiency under your leadership, despite the worms and lazy trolls.','',26124),
(35301,'enUS','I\'ve been delivering mail for a month now. Are there any executive openings? I have my resume right here.','',26124),
(35302,'enUS','Nice weather wouldn\'t you say?','',26124),
(35303,'enUS','These earthquakes have just been crazy!','',26124),
(35304,'enUS','$n has risen to the ranks of champion in our tournament.  We are proud to present $ghim:her; to you today.','',26124),
(35305,'enUS','Champions on the tournament grounds speak highly of this $c.  Today we present, $n.','',26124),
(35306,'enUS','One would be hard pressed to find a more steadfast champion than this $c.  Today we present, $n. ','',26124),
(35307,'enUS','We offer a mighty champion, a capable $c, an honorable $r.  We present, $n.','',26124),
(35308,'enUS','Many champions have fallen to the skills displayed by $n.  We are proud to present this formidable $c.','',26124),
(35309,'enUS','You\'re gonna hear from my lawyer!','You\'re gonna hear from my lawyer!',26124),
(35310,'enUS','Watch where you\'re going!','Watch where you\'re going!',26124),
(35311,'enUS','Learn how to drive you maniac!','Learn how to drive you maniac!',26124),
(35312,'enUS','Ouch!','Ouch!',26124),
(35313,'enUS','My neck! I\'m gonna sue!','My neck! I\'m gonna sue!',26124),
(35314,'enUS','I\'ll get you, $n!','I\'ll get you, $n!',26124),
(35315,'enUS','You\'re a public nuisance, $n!','You\'re a public nuisance, $n!',26124),
(35316,'enUS','The Trade Prince will hear about this, $n!','The Trade Prince will hear about this, $n!',26124),
(35317,'enUS','%s crashes into the Coliseum wall and is stunned!','',26124),
(35318,'enUS','Trampling combatants underfoot, %s goes into a frothing rage!','',26124),
(35319,'enUS','Are you ready for your first challenge, $c?','',26124),
(35320,'enUS','I am ready.','I am ready.',26124),
(35321,'enUS','Welcome, champions. Today, before the eyes of your leaders and peers, you will prove yourselves worthy combatants.','',26124),
(35322,'enUS','I have no taste for these games, Tirion. Still... I trust they will perform admirably.','',26124),
(35323,'enUS','','Of course they will.',26124),
(35324,'enUS','Admirably? Hah! I will enjoy watching your weak little champions fail, human.','',26124),
(35325,'enUS','Garrosh, enough.','',26124),
(35326,'enUS','Fight well, Horde! Lok\'tar Ogar!','',26124),
(35327,'enUS','Finally, a fight worth watching.','',26124),
(35328,'enUS','I did not come here to watch animals tear at each other senselessly, Tirion.','',26124),
(35329,'enUS','','They\'re worthy fighters, you\'ll see.',26124),
(35330,'enUS','You will first be facing three of the Grand Champions of the Tournament! These fierce contenders have beaten out all others to reach the pinnacle of skill in the joust.','',26124),
(35331,'enUS','Begin!','',26124),
(35332,'enUS','You come to learn how to ride?','',26124),
(35333,'enUS','For years I served in this backwater corner of the world, learning the terrain and biding my time. At last our time has come. The full might of Orgrimmar is now turned to Azshara, our gateway to Ashenvale and dominance over this continent. Welcome to the front lines, $c.','',26124),
(35334,'enUS','Presenting the fierce Grand Champion of Orgrimmar, Mokra the Skullcrusher!\n','',26124),
(35335,'enUS','Entering the arena is the lean and dangerous Zul\'tore, Grand Champion of Sen\'jin!\n','',26124),
(35336,'enUS','Tall in the saddle of his kodo, here is the venerable Runok Wildmane, Grand Champion of Thunder Bluff!\n','',26124),
(35337,'enUS','Representing the tenacity of the Forsaken, here is the Grand Champion of the Undercity, Deathstalker Visceri!\n','',26124),
(35338,'enUS','Coming out of the gate is Eressea Dawnsinger, skilled mage and Grand Champion of Silvermoon!\n','',26124),
(35339,'enUS','Syntax Error Line 14, Sequence: Flee for Life. Entering passive mode. *Click!*','',26124),
(35340,'enUS','What was that?','What was that?',26124),
(35341,'enUS','Run for your lives!','Run for your lives!',26124),
(35342,'enUS','Whatever, I\'ve felt worse.','Whatever, I\'ve felt worse.',26124),
(35343,'enUS','Did you feel that?','Did you feel that?',26124),
(35344,'enUS','I knew I should have paid my earthquake insurance!','I knew I should have paid my earthquake insurance!',26124),
(35345,'enUS','Mount the Hippogryph and prepare for battle!','Mount the Hippogryph and prepare for battle!',26124),
(35346,'enUS','<The Hippogryph looks anxious and ready to go!>','',26124),
(35347,'enUS','Are you up to the challenge? I will not hold back.','',26124),
(35348,'enUS','','Yeah? Whatdya want?',26124),
(35349,'enUS','Beat it, pal, before I give you the ol\' Chip Endale fist to the face!','',26124),
(35350,'enUS','Welcome to First Bank of Kezan, a wholly-owned subsidiary of the Bilgewater Traders & Merchants Bank Of The South Seas.$B$BWhat can I do for you today?','',26124),
(35351,'enUS','I need to make a withdrawal. Ten stacks of macaroons!','I need to make a withdrawal. Ten stacks of macaroons!',26124),
(35352,'enUS','A pleasure doing business with you as always, $g Mr. : Ms.; $n.$B$BHave a nice day.','',26124),
(35353,'enUS','Yo! You look like a $g man : woman; of discerning tastes.$B$BWhat can I do you for?','',26124),
(35354,'enUS','Set me up with the phattest, shiniest bling you got!','Set me up with the phattest, shiniest bling you got!',26124),
(35355,'enUS','That bling is phat like your momma!','',26124),
(35356,'enUS','What up, G? Don\'t look like you gots enough macaroons to afford the class of bling I specialize in.$B$BYou might want to get yoself up to the bank. Dig?','',26124),
(35357,'enUS','What do you think you\'re doing?','What do you think you\'re doing?',26124),
(35358,'enUS','You\'re too late to stop our plan.','You\'re too late to stop our plan.',26124),
(35359,'enUS','See to it that I\'m not followed.','See to it that I\'m not followed.',26124),
(35360,'enUS','Gladly.','',26124),
(35361,'enUS','Look what I have to work with. Szabo can perform miracles?$B$B<Szabo sighs>$B$BYes, yes. Szabo thinks he can do something with you.','',26124),
(35362,'enUS','You cannot afford Szabo\'s services. We do not work for free, little waif.$B$BAway with you to the bank. Bring Szabo all of your macaroons.','',26124),
(35363,'enUS','Szabo, I need a hip, new outfit for the party I\'m throwing!','Szabo, I need a hip, new outfit for the party I\'m throwing!',26124),
(35364,'enUS','Oh, just look at what Szabo has done. A masterpiece!$B$BYou are not worthy of such an outfit, but Szabo needs the money. <sigh>','',26124),
(35365,'enUS','$n has assaulted the docks!','',26124),
(35366,'enUS','$n has defended the docks!','',26124),
(35367,'enUS','The Alliance has taken the docks!','',26124),
(35368,'enUS','The Horde has taken the docks!','',26124),
(35369,'enUS','$n has assaulted the hangar!','',26124),
(35370,'enUS','$n has defended the hangar!','',26124),
(35371,'enUS','The Alliance has taken the hangar!','',26124),
(35372,'enUS','The Horde has taken the hangar!','',26124),
(35373,'enUS','$n has assaulted the quarry!','',26124),
(35374,'enUS','$n has defended the quarry!','',26124),
(35375,'enUS','The Alliance has taken the quarry!','',26124),
(35376,'enUS','The Horde has taken the quarry!','',26124),
(35377,'enUS','$n has assaulted the oil refinery!','',26124),
(35378,'enUS','$n has defended the oil refinery!','',26124),
(35379,'enUS','The Alliance has taken the oil refinery!','',26124),
(35380,'enUS','The Horde has taken the oil refinery!','',26124),
(35381,'enUS','','I gots all kinds of brands of shades. Yous name it, I sell it!',26124),
(35382,'enUS','','Yeah? Yous don\'t look like you got the moolah to buy anything from me.$B$B<Missa pops her bubblegum.>$B$BMaybe yous forgot to go to the bank?',26124),
(35383,'enUS','I need some cool shades. What will two stacks of macaroons get me?','I need some cool shades. What will two stacks of macaroons get me?',26124),
(35384,'enUS','','Here yous go. My best pair and I\'m giving them to ya cheap!$B$BYous gonna look sharp in them!',26124),
(35385,'enUS','Go for the face! Go for the face!','Go for the face! Go for the face!',26124),
(35386,'enUS','Is this the deadbeat?','Is this the deadbeat?',26124),
(35387,'enUS','Get \'em!','Get \'em!',26124),
(35388,'enUS','I never liked you anyway!','I never liked you anyway!',26124),
(35389,'enUS','It\'s payback time!','It\'s payback time!',26124),
(35390,'enUS','You do NOT mess with us!','You do NOT mess with us!',26124),
(35391,'enUS','You lookin\' at me?','You lookin\' at me?',26124),
(35392,'enUS','I been waitin\' all day for this!','I been waitin\' all day for this!',26124),
(35393,'enUS','Foolish $c, you cannot stop the Kvaldir!','',26124),
(35394,'enUS','Hello. Would you like to fight the Northrend Beast encounter for the Argent Colosseum raid? \n\nYou will face the version of this encounter that corresponds to the current raid difficulty you have selected. This encounter is a work in progress. Please be sure to report any bugs you experience on the Blizzard forums.\n\nAre you ready to begin the encounter?','',26124),
(35395,'enUS','Yes.','Yes.',26124),
(35396,'enUS','Hello. Would you like to fight the Lord Jaraxxus encounter for the Argent Colosseum raid? \n\nYou will face the version of this encounter that corresponds to the current raid difficulty you have selected. This encounter is a work in progress. Please be sure to report any bugs you experience on the Blizzard forums.\n\nAre you ready to begin the encounter?','',26124),
(35397,'enUS','You already gots the shiniest bling on the island, $g brother : sister;!','',26124),
(35398,'enUS','Shredder Blades Activated.','',26124),
(35399,'enUS','','There\'s no warranty on those shades yous bought!',26124),
(35400,'enUS','Szabo already made you an outfit worthy of a trade prince. Move along now, you are scaring all of Szabo\'s customers away.','',26124),
(35401,'enUS','','Welcome to our shop.  We have everything you need... if you need alchemy supplies.',26124),
(35402,'enUS','Do you actually sell anything?','Do you actually sell anything?',26124),
(35403,'enUS','OK...','OK...',26124),
(35404,'enUS','','No, I\'m the intellectual one, and I am not to be taken lightly.  I could brew a healing potion from dishwater and dandelions, although that\'s not something I\'ll show you!$b$bAnyhow, if you\'d like to make a purchase, please speak with Patricia.',26124),
(35405,'enUS','Swift Spectral Tiger Mount','Swift Spectral Tiger Mount',26124),
(35406,'enUS','X-51 Nether-Rocket X-TREME Mount','X-51 Nether-Rocket X-TREME Mount',26124),
(35407,'enUS','Fine, then how about some training?','Fine, then how about some training?',26124),
(35408,'enUS','%s targets $n with the Hammer of the Righteous!','',26124),
(35409,'enUS','The front gate of the Horde keep has been destroyed!','',26124),
(35410,'enUS','The front gate of the Alliance keep has been destroyed!','',26124),
(35411,'enUS','The west gate of the Horde keep has been destroyed!','',26124),
(35412,'enUS','The west gate of the Alliance keep has been destroyed!','',26124),
(35413,'enUS','The east gate of the Horde keep has been destroyed!','',26124),
(35414,'enUS','The east gate of the Alliance keep has been destroyed!','',26124),
(35415,'enUS','%s begins to radiate light. Shield your eyes!','',26124),
(35416,'enUS','Grenade Launcher Armed.','',26124),
(35417,'enUS','A fresh glass of bubbly. Just what the doctor ordered, $n.','A fresh glass of bubbly. Just what the doctor ordered, $n.',26124),
(35418,'enUS','Thanks for the refill, $g sir : ma\'am;!','Thanks for the refill, $g sir : ma\'am;!',26124),
(35419,'enUS','This sparkling white wine is delicious! Wherever did you get it?','This sparkling white wine is delicious! Wherever did you get it?',26124),
(35420,'enUS','I think this one will have to be my last. I\'m driving home after the party.','I think this one will have to be my last. I\'m driving home after the party.',26124),
(35421,'enUS','Thanksh!','Thanksh!',26124),
(35422,'enUS','I feel much better now...hic!','I feel much better now...hic!',26124),
(35423,'enUS','Oh, my head hurtsh.','Oh, my head hurtsh.',26124),
(35424,'enUS','Shorry about your shoes.','Shorry about your shoes.',26124),
(35425,'enUS','A disco ball?! Groovy!','A disco ball?! Groovy!',26124),
(35426,'enUS','How do you like my moves, $n?','How do you like my moves, $n?',26124),
(35427,'enUS','We should totally have a pants-off dance-off!','We should totally have a pants-off dance-off!',26124),
(35428,'enUS','Shake it like a goblinoid picture!','Shake it like a goblinoid picture!',26124),
(35429,'enUS','Wow! That sure beats this puny, little sparkler!','Wow! That sure beats this puny, little sparkler!',26124),
(35430,'enUS','You really stop at no expense, $n! Amazing!','You really stop at no expense, $n! Amazing!',26124),
(35431,'enUS','Best... Party... Evar!','Best... Party... Evar!',26124),
(35432,'enUS','Woo hoo, fireworks! More, more!','Woo hoo, fireworks! More, more!',26124),
(35433,'enUS','Thanks. I was almost out. So hungry!','Thanks. I was almost out. So hungry!',26124),
(35434,'enUS','These are the most delicious hors d\'oeurves I have ever tasted. You must share your recipe, $n!','These are the most delicious hors d\'oeurves I have ever tasted. You must share your recipe, $n!\n',26124),
(35435,'enUS','Finger licking good!','Finger licking good!',26124),
(35436,'enUS','Nom, nom, nom!','Nom, nom, nom!',26124),
(35437,'enUS','Defend the gates!','Defend the gates!',26124),
(35438,'enUS','Drive this scum back into the woods!','Drive this scum back into the woods!',26124),
(35439,'enUS','I lost my shades!','I lost my shades!',26124),
(35440,'enUS','I need a new outfit!','I need a new outfit!',26124),
(35441,'enUS','I misplaced my shiny bling!','I misplaced my shiny bling!',26124),
(35442,'enUS','Hammer of the Righteous!','',26124),
(35443,'enUS','Emergency Power Reserves Online.','',26124),
(35444,'enUS','You\'re dressed to impress! Use your new powers below to make your party guests happy!','You\'re dressed to impress! Use your new powers below to make your party guests happy!',26124),
(35445,'enUS','What was that?','What was that?',26124),
(35446,'enUS','I need another Oracle Orphan Whistle.','I need another Oracle Orphan Whistle.',26124),
(35447,'enUS','Yarr!','Yarr!',26124),
(35448,'enUS','Where be the booty?','Where be the booty?',26124),
(35449,'enUS','Let\'s have a dance!','Let\'s have a dance!',26124),
(35450,'enUS','We be here courtesy o\' the trade prince.','We be here courtesy o\' the trade prince.',26124),
(35451,'enUS','Got some rum?','Got some rum?',26124),
(35452,'enUS','Alright boys, shake \'em down!','Alright boys, shake \'em down!',26124),
(35453,'enUS','It be gold we\'re after!','It be gold we\'re after!',26124),
(35454,'enUS','Who be in charge here?','Who be in charge here?',26124),
(35455,'enUS','I lost my totems. Can you help?','I lost my totems. Can you help?',26124),
(35456,'enUS','Please be more careful, $n. This relic was created by the Earthen Ring, and it is our gift to you.','Please be more careful, $n. This relic was created by the Earthen Ring, and it is our gift to you.',26124),
(35457,'enUS','The spirits of the elements are wise. They\'ve been here long before us and will persist long after we\'re gone. When they speak to us, we must listen.','',26124),
(35458,'enUS','The spirits of the elements surround us. We must always listen. I have seen firsthand the consequences when we ignore their warnings...','',26124),
(35459,'enUS','$n has defended the alliance keep!','',26124),
(35460,'enUS','$n has defended the horde keep!','',26124),
(35461,'enUS','$n has assaulted the alliance keep!','',26124),
(35462,'enUS','$n has assaulted the horde keep!','',26124),
(35463,'enUS','The Alliance has taken the alliance keep!','',26124),
(35464,'enUS','The Alliance has taken the horde keep!','',26124),
(35465,'enUS','The Horde has taken the horde keep!','',26124),
(35466,'enUS','The Horde has taken the alliance keep!','',26124),
(35467,'enUS','Outstanding party, $n. Thanks for the disco ball!','',26124),
(35468,'enUS','<You can\'t quite make out what Gobber is saying with all of the food that is stuffed in his mouth. You\'re pretty sure that it\'s a thanks, however.>','',26124),
(35469,'enUS','','There\'s my best friend! Come on, $n, dance with us!',26124),
(35470,'enUS','The Talrendis Ancient howls out in pain!','',26124),
(35471,'enUS','Somebody help!','',26124),
(35472,'enUS','Pirates? PIRATES!','',26124),
(35473,'enUS','But my protection money is all paid up!','',26124),
(35474,'enUS','Who hired the pirates? This is great! What a party! Ouch that hurt! THEY HAVE REAL WEAPONS!','',26124),
(35475,'enUS','How much are you being paid? I\'ll double it... triple?!  Oh no!','',26124),
(35476,'enUS','Southsea Freebooters? This place is really going downhill.','',26124),
(35477,'enUS','Come on! If we band together, we can take them! Aaaagh!','',26124),
(35478,'enUS','Begone, insect. You do not belong in these lands. Do not provoke my ire.','',26124),
(35479,'enUS','You\'ll be hearing from my lawyer!','',26124),
(35480,'enUS','Why, what brings you all the way over here, young $r? Please be cautious. Our foes stream forth from a hole in the mountain to the east - they have done irreparable harm to this land.','',26124),
(35481,'enUS','Keep your machines away from me, $r! You\'ll be cleansed from this land like the weeds you are!','',26124),
(35482,'enUS','Thanks again for the help with these lazy cretins, boss-$g man : lady;.$B$BIf you ask me, we shouldn\'t have been so lenient with the trolls when we freed ourselves from being their slaves.','',26124),
(35483,'enUS','Thank you for saving me, $g Mr. : Ms.; $n.','Thank you for saving me, $g Mr. : Ms.; $n.',26124),
(35484,'enUS','Why would the trade prince do this?','Why would the trade prince do this?',26124),
(35485,'enUS','So, when\'s the next party?','So, when\'s the next party?',26124),
(35486,'enUS','Have you seen my girlfriend?','Have you seen my boyfriend?',26124),
(35487,'enUS','Is the party over?','Is the party over?',26124),
(35488,'enUS','Please take me off of your guest list.','Please take me off of your guest list.',26124),
(35489,'enUS','I had no idea the party was going to have a pirate theme. I would have brought my eyepatch!','I had no idea the party was going to have a pirate theme. I would have brought my eyepatch!',26124),
(35490,'enUS','$G Mr. : Ms.; $n, what\'s wrong with the volcano?','$G Mr. : Ms.; $n, what\'s wrong with the volcano?',26124),
(35491,'enUS','%s begins to invoke the Waking Nightmare!','%s begins to invoke the Waking Nightmare!',26124),
(35492,'enUS','We remember this visit, yes we do. Never forget what you learn from your new friend, little Roo. You got great future ahead.','',26124),
(35493,'enUS','No worry, Kekek. You grow up, be strong for Frenzyheart. You lead people back to old home, where there no big-tongue babies.','',26124),
(35494,'enUS','The crate of explosives is on fire!','',26124),
(35495,'enUS','Come and get us, you motherless beasts!','',26124),
(35496,'enUS','Over here, you fleabags!','',26124),
(35497,'enUS','You\'ll never catch us, you blasted mongrels!','',26124),
(35498,'enUS','Let\'s round up as many of them as we can.  Every worgen chasing us is one less worgen chasing the survivors!','',26124),
(35499,'enUS','Warning!  Warning!  Stealthed intruder detected!','',26124),
(35500,'enUS','I\'ve lost my key to the Violet Hold.','I\'ve lost my key to the Violet Hold.',26124),
(35501,'enUS','Yes, $c?','',26124),
(35502,'enUS','I am here on Sorrem\'s errand, You are to call Furien\'s dragonhawk for me.','I am here on Sorrem\'s errand, You are to call Furien\'s dragonhawk for me.',26124),
(35503,'enUS','$n is my target!','',26124),
(35504,'enUS','The Goblin All-In-1der Belt\'s battery is depleted.','The Goblin All-In-1der Belt\'s battery is depleted.',26124),
(35505,'enUS','See those seaforium bombs? Use them on the gates while I repair the siege engine!','',26124),
(35506,'enUS','Safe travels, $c.','',26124),
(35507,'enUS','I\'m halfway there! Keep the Horde away from here.  They don\'t teach fighting in engineering school!','',26124),
(35508,'enUS','My finest work so far! This siege engine is ready for action!','',26124),
(35509,'enUS','It\'s broken already?! No worries. It\'s nothing I can\'t fix.\n','',26124),
(35510,'enUS','Go get dressed for the party.','',26124),
(35511,'enUS','Gobber grunts his good-byes.','',26124),
(35512,'enUS','','See ya at the party, babe!',26124),
(35513,'enUS','Visit a bank.','Visit a bank.',26124),
(35514,'enUS','%s nods at the line of guards and motions for Jaina to follow.','',26124),
(35515,'enUS','Visit a trader.','Visit a trader.',26124),
(35516,'enUS','Visit the Stables.','Visit the Stables.',26124),
(35517,'enUS','I\'ll work on the siege engine, just watch my back.  Use those seaforium bombs on the gates if you need them!','',26124),
(35518,'enUS','I\'m about halfway done! Keep the Alliance away - fighting\'s not in my contract!','',26124),
(35519,'enUS','The siege engine is ready to roll!','',26124),
(35520,'enUS','It\'s broken again?! I\'ll fix it... just don\'t expect the warranty to cover this.\n','',26124),
(35521,'enUS','Tirion.','',26124),
(35522,'enUS','King Varian, Lady Jaina. Welcome to the tournament. Your place in the coliseum is waiting.','',26124),
(35523,'enUS','','Thank you. It\'s the least I can do to support this; we need to stand together.',26124),
(35524,'enUS','You ask much of me, Tirion, to sit and watch, trusting the savages to keep themselves in check.','',26124),
(35525,'enUS','My people are here to ensure they honor the rules of engagement. It will do your subjects well to see you in the stands.','',26124),
(35526,'enUS','%s nods and gestures for his guests to follow.','',26124),
(35527,'enUS','Perhaps. I doubt the effectiveness of this gambit. We would be better served preparing our armies for the final assault.','',26124),
(35528,'enUS','But if my presence is required in these games to gain your support in the battle, then I will remain.  For now.','',26124),
(35529,'enUS','','I\'m sure Thrall will have his people under control...',26124),
(35530,'enUS','There are some who desire to stop gaining experience from their actions; to forever remain at the level of strength they are now, and never grow stronger.$B$BI can make this possible... for a fee, of course.$B$BBut understand this: Once you pay me, you will NO LONGER GAIN EXPERIENCE. None. Not one whit.$B$BShould you change your mind afterwards and want to start gaining experience again, I can undo the process for the same fee.','There are some who desire to stop gaining experience from their actions; to forever remain at the level of strength they are now, and never grow stronger.$B$BI can make this possible... for a fee, of course.$B$BBut understand this: Once you pay me, you will NO LONGER GAIN EXPERIENCE. None. Not one whit.$B$BShould you change your mind afterwards and want to start gaining experience again, I can undo the process for the same fee.',26124),
(35531,'enUS','I no longer wish to gain experience.','I no longer wish to gain experience.',26124),
(35532,'enUS','I wish to start gaining experience again.','I wish to start gaining experience again.',26124),
(35533,'enUS','Are you certain you wish to start gaining experience again?','Are you certain you wish to start gaining experience again?',26124),
(35534,'enUS','Visit a mailbox.','Visit a mailbox.',26124),
(35535,'enUS','Are you certain you wish to stop gaining experience?','Are you certain you wish to stop gaining experience?',26124),
(35536,'enUS','That was an impressive display.  But are you ready for your next challenge?','',26124),
(35537,'enUS','You\'ve impressed everyone here today with your skills in the arena.  It is now time to be recognized before all as a champion of the tournament.','',26124),
(35538,'enUS','I am ready for the next challenge.','I am ready for the next challenge.',26124),
(35539,'enUS','I am ready.','I am ready.',26124),
(35540,'enUS','So the dogs have returned to sniff around?','',26124),
(35541,'enUS','Well fought! Your next challenge comes from the Crusade\'s own ranks. You will be tested against their considerable prowess.','',26124),
(35542,'enUS','Entering the arena, a paladin who is no stranger to the battlefield or tournament ground, the Grand Champion of the Argent Crusade, Eadric the Pure!','',26124),
(35543,'enUS','The next combatant is second to none in her passion for upholding the Light. I give you Argent Confessor Paletress!','',26124),
(35544,'enUS','Well done. You have proven yourself today-','',26124),
(35545,'enUS','What\'s that, up near the rafters?','',26124),
(35546,'enUS','You spoiled my grand entrance, rat.','',26124),
(35547,'enUS','What is the meaning of this?','',26124),
(35548,'enUS','Did you honestly think an agent of the Lich King would be bested on the field of your pathetic little tournament?','',26124),
(35549,'enUS','I\'ve come to finish my task.','',26124),
(35550,'enUS','Don\'t just stand there; kill him!','',26124),
(35551,'enUS','Tear him apart!','',26124),
(35552,'enUS','Garrosh, I expect you to control yourself here. I do not want a repeat of the Violet Citadel.','',26124),
(35553,'enUS','Pah! That was a show of strength, worthy of a leader. I only regret I did not kill that human before the mage interfered.','',26124),
(35554,'enUS','What honor is there in thrashing about with blunted sticks? This is a waste of time.','',26124),
(35555,'enUS','Speak for yourself, Thrall.','',26124),
(35556,'enUS','Words of a fool, you mean. The Horde will destroy the undead without your aid, human, or that of the pompous king.','',26124),
(35557,'enUS','Bah.','',26124),
(35558,'enUS','We are guests here, Garrosh, and you will conduct yourself honorably.','',26124),
(35559,'enUS','Thank you for the invitation, Lord Fordring. We look forward to observing these games.','',26124),
(35560,'enUS','Wise words.','',26124),
(35561,'enUS','Garrosh, enough!','',26124),
(35562,'enUS','Of course, Tirion. I apologize for his outburst.  It will not be repeated.','',26124),
(35563,'enUS','This monument hums and crackles with perpetual ancient energies.','',26124),
(35564,'enUS','Finding yourself without a Vortex Gem, you reach into the runestone to acquire another.','Finding yourself without a Vortex Gem, you reach into the runestone to acquire another.',26124),
(35565,'enUS','You\'re looking at the most state-of-the-art mining operation in the world. Only rubes would bother to tunnel under a mountain to get at the minerals below. We moved the whole mountain! Now we can just scoop the precious metals right off of the ground.','',26124),
(35566,'enUS','You are breaking into the vault to retrieve your Personal Riches!','',26124),
(35567,'enUS','Use what is called for in your Goblin All-In-1-Der Belt below to crack open the vault!$B|TInterface\\Icons\\INV_Misc_EngGizmos_20.blp:64|t |TInterface\\Icons\\INV_Misc_Bomb_07.blp:64|t |TInterface\\Icons\\INV_Misc_Ear_NightElf_02.blp:64|t |TInterface\\Icons\\INV_Misc_EngGizmos_swissArmy.blp:64|t |TInterface\\Icons\\INV_Weapon_ShortBlade_21.blp:64|t','',26124),
(35568,'enUS','The vault will be cracked once the |cFFFF2222Vault Breaking progress bar reaches 100 percent!|r$B|TInterface\\Icons\\INV_Misc_coin_02.blp:64|t$BDoing the wrong thing at the wrong time will reduce the progress of the bar.','',26124),
(35569,'enUS','Good luck!','',26124),
(35570,'enUS','I\'m free!','I\'m free!',26124),
(35571,'enUS','I\'m outta here...','I\'m outta here...',26124),
(35572,'enUS','The nightmare is over!','The nightmare is over!',26124),
(35573,'enUS','I can still clock in for the time I was petrified, right?','I can still clock in for the time I was petrified, right?',26124),
(35574,'enUS','Give that $gman:woman; a raise!','Give that $gman:woman; a raise!',26124),
(35575,'enUS','No job is worth this!','No job is worth this!',26124),
(35576,'enUS','Use your |cFFFF2222Kaja\'mite Drill!|r$B|TInterface\\Icons\\INV_Weapon_ShortBlade_21.blp:64|t','',26124),
(35577,'enUS','Use your |cFFFF2222Blastcrackers!|r$B|TInterface\\Icons\\INV_Misc_Bomb_07.blp:64|t','',26124),
(35578,'enUS','Use your |cFFFF2222Ear-O-Scope!|r$B|TInterface\\Icons\\INV_Misc_Ear_NightElf_02.blp:64|t','',26124),
(35579,'enUS','Use your |cFFFF2222Infinifold Lockpick!|r$B|TInterface\\Icons\\INV_Misc_EngGizmos_swissArmy.blp:64|t','',26124),
(35581,'enUS','I quit, I QUIT!','I quit, I QUIT!',26124),
(35582,'enUS','That was surprisingly restful.','That was surprisingly restful.',26124),
(35583,'enUS','%s goes crazy-go-nuts!','%s goes crazy-go-nuts!',26124),
(35675,'enUS','%s glares at $n and lets out a bellowing roar!','',26124),
(35676,'enUS','%s\'s spikes pursue $n!','',26124),
(35677,'enUS','You may begin!','',26124),
(35678,'enUS','','At long last we have an opportunity to study the ruins that dot this landscape... Provided these moneygrubbers don\'t level the place first.',26124),
(35679,'enUS','Tell me about the nearby ruins.','Tell me about the nearby ruins.',26124),
(35680,'enUS','','Die, tresspasser!',26124),
(35681,'enUS','','You do not belong here, $r!',26124),
(35682,'enUS','','You are treading upon sacred ground!',26124),
(35683,'enUS','','Your kind is not welcome here, $r!',26124),
(35684,'enUS','HAH!','',26124),
(35685,'enUS','Hardly a challenge.','',26124),
(35686,'enUS','Worthless scrub.','',26124),
(35687,'enUS','Is this the best the Horde has to offer?','',26124),
(35688,'enUS','The Alliance doesn\'t need the help of a demon lord to deal with Horde filth! Come, pig!','',26124),
(35689,'enUS','Fight for the glory of the Alliance, heroes! Honor your king and your people!','',26124),
(35690,'enUS','Our honor has been besmirched! They make wild claims and false accusations against us. I demand justice! Allow my champions to fight in place of your knights, Tirion. We challenge the Horde!','',26124),
(35691,'enUS','GLORY TO THE ALLIANCE!','',26124),
(35692,'enUS','Not even the Lich King\'s most powerful minions can stand against the Alliance. All hail our victors!','',26124),
(35693,'enUS','Your beasts will be no match for my champions, Tirion!','',26124),
(35694,'enUS','Weakling!','',26124),
(35695,'enUS','Finding yourself without a Raging Vortex Gem, you reach into the runestone to acquire another.','Finding yourself without a Raging Vortex Gem, you reach into the runestone to acquire another.',26124),
(35696,'enUS','Pathetic.','',26124),
(35697,'enUS','Overpowered...','',26124),
(35698,'enUS','Lok\'tar!','',26124),
(35699,'enUS','Treacherous Alliance dogs! You summon a demon lord against warriors of the Horde? Your deaths will be swift!','',26124),
(35700,'enUS','Use your |cFFFF2222Amazing G-Ray!|r$B|TInterface\\Icons\\INV_Misc_EngGizmos_20.blp:64|t','',26124),
(35701,'enUS','Show them no mercy, Horde champions! LOK\'TAR OGAR! ','',26124),
(35702,'enUS','Correct!','',26124),
(35703,'enUS','The Horde demands justice! We challenge the Alliance! Allow us to battle in place of your knights, paladin. We will show these dogs what it means to insult the Horde.','',26124),
(35704,'enUS','Incorrect!','',26124),
(35705,'enUS','That was just a taste of what the future brings. FOR THE HORDE!','',26124),
(35706,'enUS','Do you still question the might of the Horde, paladin? We will take on all comers!','',26124),
(35707,'enUS','I\'ve seen more worthy challenges in the Ring of Blood. You waste our time, paladin.','',26124),
(35708,'enUS','Welcome, champions! You have heard the call of the Argent Crusade and you have boldly answered! It is here, in the Crusaders\' Coliseum, that you will face your greatest challenges. Those of you who survive the rigors of the coliseum will join the Argent Crusade on its march to Icecrown Citadel.','',26124),
(35709,'enUS','Let the games begin!','',26124),
(35710,'enUS','Hailing from the deepest, darkest caverns of the Storm Peaks, Gormok the Impaler! Battle on, heroes!','',26124),
(35711,'enUS','Steel yourselves, heroes, for the twin terrors, Acidmaw and Dreadscale, enter the arena!','',26124),
(35712,'enUS','The air itself freezes with the introduction of our next combatant, Icehowl! Kill or be killed, champions!','',26124),
(35713,'enUS','The monstrous menagerie has been vanquished!','',26124),
(35714,'enUS','Tragic... They fought valiantly, but the beasts of Northrend triumphed. Let us observe a moment of silence for our fallen heroes.','',26124),
(35715,'enUS','Grand Warlock Wilfred Fizzlebang will summon forth your next challenge. Stand by for his entry.','',26124),
(35716,'enUS','Quickly, heroes, destroy the demon lord before it can open a portal to its twisted demonic realm!','',26124),
(35717,'enUS','The loss of Wilfred Fizzlebang, while unfortunate, should be a lesson to those that dare dabble in dark magic. Alas, you are victorious and now must face the next challenge.','',26124),
(35718,'enUS','Everyone calm down! Compose yourselves! There is no conspiracy at play here! The warlock acted on his own volition, outside of influences from the Alliance. The tournament must go on!','',26124),
(35719,'enUS','The next battle will be against the Argent Crusade\'s most powerful knights! Only by defeating them will you be deemed worthy...','',26124),
(35720,'enUS','Very well. I will allow it. Fight with honor!','',26124),
(35721,'enUS','A shallow and tragic victory. We are weaker as a whole from the losses suffered today. Who but the Lich King could benefit from such foolishness? Great warriors have lost their lives. And for what? The true threat looms ahead - the Lich King awaits us all in death.','',26124),
(35722,'enUS','Only by working together will you overcome the final challenge. From the depths of Icecrown come two of the Scourge\'s most powerful lieutenants: fearsome val\'kyr, winged harbingers of the Lich King!','',26124),
(35723,'enUS','A mighty blow has been dealt to the Lich King! You have proven yourselves as able bodied champions of the Argent Crusade. Together we will strike against Icecrown Citadel and destroy what remains of the Scourge! There is no challenge that we cannot face united!','',26124),
(35724,'enUS','Arthas! You are hopelessly outnumbered! Lay down Frostmourne and I will grant you a just death.','',26124),
(35725,'enUS','Welcome to the Trials of the Crusader! Only the most powerful combatants of Azeroth are allowed to undergo these trials. You are among the worthy few.','',26124),
(35726,'enUS','Thank you, Highlord. Now, challengers, I will begin the ritual of summoning. When I am done a fearsome doomguard will appear!','',26124),
(35727,'enUS','Prepare for oblivion!','',26124),
(35728,'enUS','A-HA! I\'ve done it! Behold the absolute power of Wilfred Fizzlebang, master summoner! You are bound to me, demon!','',26124),
(35729,'enUS','But I\'m in charge here...','',26124),
(35730,'enUS','Trifling gnome! Your arrogance will be your undoing!','',26124),
(35731,'enUS','You face Jaraxxus, Eredar Lord of the Burning Legion!','',26124),
(35732,'enUS','Insignificant gnat!','',26124),
(35733,'enUS','Banished to the Nether!','',26124),
(35734,'enUS','Another will take my place. Your world is doomed...','',26124),
(35735,'enUS','FLESH FROM BONE!','',26124),
(35736,'enUS','Come forth, sister! Your master calls!','',26124),
(35737,'enUS','IN-FER-NO!','',26124),
(35738,'enUS','','In the name of our dark master. For the Lich King. You. Will. Die.',26124),
(35739,'enUS','','You have been measured and found wanting.',26124),
(35740,'enUS','','Unworthy!',26124),
(35741,'enUS','','The Scourge cannot be stopped...',26124),
(35743,'enUS','','You are finished!',26124),
(35744,'enUS','','CHAOS!',26124),
(35745,'enUS','','Let the dark consume you!',26124),
(35746,'enUS','','Let the light consume you!',26124),
(35747,'enUS','You will have your challenge, Fordring.','',26124),
(35748,'enUS','The Nerubians built an empire beneath the frozen wastes of Northrend. An empire that you so foolishly built your structures upon. MY EMPIRE.','',26124),
(35749,'enUS','The souls of your fallen champions will be mine, Fordring.','',26124),
(35750,'enUS','Ahhh, our guests have arrived, just as the master promised.','',26124),
(35751,'enUS','This place will serve as your tomb!','',26124),
(35752,'enUS','F-lakkh shir!','',26124),
(35753,'enUS','Another soul to sate the host.','',26124),
(35754,'enUS','I have failed you, master...','',26124),
(35756,'enUS','Auum na-l ak-k-k-k, isshhh. Rise, minions. Devour...','',26124),
(35757,'enUS','The swarm shall overtake you!','',26124),
(35758,'enUS','Prepare yourselves!','',26124),
(35759,'enUS','You! You need more practice.','',26124),
(35760,'enUS','Nay, nay, and I say yet again nay! Not good enough.','',26124),
(35761,'enUS','I yield! I submit. Excellent work. May I run away now?','',26124),
(35762,'enUS','','Thank you, good herald. Your words are too kind.',26124),
(35763,'enUS','','May the Light give me strength to provide a worthy challenge.',26124),
(35764,'enUS','','Take this time to consider your past deeds.',26124),
(35765,'enUS','','Take your rest.',26124),
(35766,'enUS','','Be at ease.',26124),
(35767,'enUS','This farce ends here!','',26124),
(35768,'enUS','Pathetic.','',26124),
(35769,'enUS','A waste of flesh.','',26124),
(35770,'enUS','No! I must not fail... again...','',26124),
(35771,'enUS','My rotting flesh was just getting in the way!','',26124),
(35772,'enUS','I have no need for bones to best you!','',26124),
(35773,'enUS','Timed Out!','',26124),
(35774,'enUS','','Are you familiar with the War of the Ancients, $n? That is what we call the period of time 10,000 years ago, when the demons of the Burning Legion first breached the realm of Azeroth and attempted to devour this entire world as they have countless others. The ancient capital of Azshara, a city that once dominated this landscape, was ground zero for the invasion. The ancient wreckage you\'ll find scattered throughout the area stands in broken testament to the egotism of our forebears.',26124),
(35775,'enUS','What are you doing here?','What are you doing here?',26124),
(35776,'enUS','','My concern for the moment is with the ruins that surround Lake Mennar, to our east. Thousands of years ago the Mennar Academy was among the first to study the arcane arts. It was a beautiful terraced structure built in a ring around a tranquil lake, a place of quiet contemplation and focused study. It was there that my ancestors first discovered the potential of the magical energies seeping from the Well of Eternity.$B$BI\'m sorry - is this all too much to take in? I\'ve immersed myself in arcane history for several decades now, I forget that others do not share my passion.',26124),
(35777,'enUS','No, please go on.','No, please go on.',26124),
(35778,'enUS','','Suffice it to say that the academy was cautious in its application of these newfound powers - what few writings remain indicate that the mages there worried about arcane addiction, a problem my race suffers from to this day.$B$BThis restraint put the mages of Mennar in opposition to Queen Azshara and her highborne lackeys, who sought ever greater power with wild abandon, throwing caution to the wind and delving into ever more dangerous applications of the arts.',26124),
(35779,'enUS','What happened to the mages?','What happened to the mages?',26124),
(35780,'enUS','','By the time the Burning Legion began its assault, the mages at the Mennar Academy had fallen far from the Queen\'s graces. They would\'ve been a powerful asset in the war to come, but they refused to fall back when the rest of the city fell.$B$BInstead of regrouping outside the city to join in the counter-assault, they stayed behind, erecting magical barriers and turning their once quiet home into a fortress. Refugees streamed to the Mennar Academy in the first terrible days of the invasion, and survivors rallied to mount a defense.',26124),
(35781,'enUS','Were they able to hold out?','Were they able to hold out?',26124),
(35782,'enUS','','Hold out? Against a full frontal assault from the legion\'s vanguard? Not likely!$B$BNo, history doesn\'t record what happened next... for there were no survivors. The raging demons left little more than the ruins you see today, and the secrets of the academy lay buried under the soil of Azshara.',26124),
(35783,'enUS','And we\'re going to dig them up.','And we\'re going to dig them up.',26124),
(35784,'enUS','','I like the way you think, $r!$B$BUntil recently, the latent magical energies of the academy grounds attracted the attention of the Blue Dragonflight, and I wasn\'t able to study them. The attention of the dragons is now elsewhere, but a worse threat is in the making - these little green brutes want to level the ruins to make way for a fuel depot! Knowledge lost for ten thousand years is days away from being lost forever. We\'ve got to act fast.',26124),
(35785,'enUS','Welcome, Warchief Thrall. Overlord Hellscream.','',26124),
(35786,'enUS','I hope you\'ll see the merit of these events in time, Garrosh. We cannot win against the Scourge if we continue to war against one another.','',26124),
(35787,'enUS','Under my roof, gentlemen, I trust you will behave.','',26124),
(35788,'enUS','If you will follow me, then.','',26124),
(35789,'enUS','Thank the Light! I\'ll never do anything this foolish again!','',26124),
(35790,'enUS','They were seconds from strapping me to one of those altars and sucking my soul out. Let\'s get out of here!','',26124),
(35791,'enUS','Let me at those crazy cultists! I\'ll cleave \'em in half!','',26124),
(35792,'enUS','Let\'s rescue the rest of those aspirants and get back to camp. I\'m going to need a whole keg of ale after this!','',26124),
(35793,'enUS','Teach those cultists a lesson, $n. No one messes with Crusader Kul and gets away with it!','',26124),
(35794,'enUS','Well done, Horde!','',26124),
(35795,'enUS','You fought well.','',26124),
(35796,'enUS','My congratulations, champions. Through trials both planned and unexpected, you have triumphed.','',26124),
(35797,'enUS','Go now and rest; you\'ve earned it.','',26124),
(35798,'enUS','','You have Touch of |cFFFFFFFFLight.|r  Switch to |cFFFFFFFFLight|r Essence!',26124),
(35799,'enUS','Combatants of the Alliance and Horde! You are welcome under the banner of the Argent Crusade.','',26124),
(35800,'enUS','To the south lies our goal. We will march to the Citadel and cut out the heart of the Scourge where it dwells.','',26124),
(35801,'enUS','But this is no task to be taken lightly.','',26124),
(35802,'enUS','A massive attack with every able-bodied man would end in needless slaughter. Every soldier lost would rise as the enemy. Azeroth would be left defenseless against the undead threat.','',26124),
(35803,'enUS','Instead, we require a small, concentrated strike force for the attack to succeed. For that reason, we have created the Argent Tournament.','',26124),
(35804,'enUS','','You have Touch of |cFF9932CDDarkness.|r  Switch to |cFF9932CDDark|r Essence!',26124),
(35805,'enUS','Within these walls, you will be tested. Your skill in combat will be matched against the fiercest dangers Northrend has to offer under the watchful eyes of your leaders.','',26124),
(35806,'enUS','Your prowess, your might, and your cunning will be under close watch. These games will determine the best Azeroth has to offer.','',26124),
(35807,'enUS','The victors will take their rightful place in the assault upon the Citadel. We will stand together in the face of evil, and Arthas WILL fall!','',26124),
(35808,'enUS','','%s sifts through the recovered treasures until something catches her eye.',26124),
(35809,'enUS','','Ah! This ring will do nicely...',26124),
(35810,'enUS','His Majesty, King Varian Wrynn, and Lady Jaina Proudmoore have touched down upon the tournament grounds! Make way!','',26124),
(35811,'enUS','The Warchief of the Horde, Thrall, and Overlord Garrosh Hellscream have arrived upon the tournament grounds! Clear the way to the entrance!','',26124),
(35812,'enUS','Highlord Tirion Fordring approaches the stage to address those gathered upon the tournament grounds! Make way to the stage area to attend him!','',26124),
(35813,'enUS','Keep him asleep, that\'s it. No need to wake him before it\'s time.','Keep him asleep, that\'s it. No need to wake him before it\'s time.',26124),
(35814,'enUS','The wind fiercely cuts across this bluff, and most life has long since fled this corner of Icecrown. However, all it takes is a bit of coaxing for it to return, and that is why I walk these grounds. One day these trees will tower over us all.','',26124),
(35815,'enUS','I, Wilfred Fizzlebang, have been invited to this quaint tournament to make use of my extensive knowledge of the summoning arts. What better choice?','',26124),
(35816,'enUS','Soon all the world will know the name of Wilfred!','',26124),
(35817,'enUS','It won\'t be long before Fizzlebang is a household word, used to scare children into bed! \"Beware, or Fizzlebang will summon a mighty demon to eat you!\"','',26124),
(35818,'enUS','Of course I was the one chosen to summon a demon for the competitors. I am Wilfred Fizzlebang, master summoner! Demons quail before the mere thought of being under my will!','',26124),
(35819,'enUS','','Fools! Did you think our master blind? Did you think we did not know of this intrusion? Our elder sisters come, and there will be no escape from their wrath!',26124),
(35820,'enUS','','Our sisters have been captured! Fall back!',26124),
(35821,'enUS','What\'s that, to the southeast?','What\'s that, to the southeast?',26124),
(35822,'enUS','Val\'kyr! Take cover!','Val\'kyr! Take cover!',26124),
(35823,'enUS','Protect the innocent!','Protect the innocent!',26124),
(35824,'enUS','Look! Frostwyrms, to the south!','Look! Frostwyrms, to the south!',26124),
(35825,'enUS','On your guard!','On your guard!',26124),
(35826,'enUS','Attack!','Attack!',26124),
(35827,'enUS','Attack!','Attack!',26124),
(35828,'enUS','The Val\'kyr are attacking! Take cover!','',26124),
(35829,'enUS','\'Ware the grounds! Frostwyrms are attacking!','',26124),
(35830,'enUS','Gormok will be free, runts!','',26124),
(35831,'enUS','Free me!','',26124),
(35832,'enUS','RAAAAGH!','',26124),
(35833,'enUS','NO! My servants!','',26124),
(35834,'enUS','','The Gumps are letting me help them run their shop! I just love flowers.$B$B<Little Adeline suddenly squints at you, looking very serious.>$B$BDo you like flowers?',26124),
(35835,'enUS','Yes I do!','Yes I do!',26124),
(35836,'enUS','','I ain\'t \'fraid of no ghost!',26124),
(35837,'enUS','','Surveyor? I hardly know her! Hah HAH!',26124),
(35838,'enUS','','Don\'t botch this - I\'m angling for Sr. Grade by the end of the year.',26124),
(35839,'enUS','','Let\'s do this thing.',26124),
(35840,'enUS','The magnataur are not as stupid as they appear. Keeping Gormok until his time is a difficult task, but he is bound tightly enough that there is no danger.','',26124),
(35841,'enUS','I tend these creatures of Gormok as he cannot. I do not fully agree with this slaughter, but at the least he will have his chance to fight.','',26124),
(35842,'enUS','The yeti is a fierce, cunning creature, and this one is one of the strongest of his kind. We keep him asleep through herbs in his food.$b$bDo not think he will be lethargic in the ring, however.','',26124),
(35843,'enUS','We have been tending these worms for some time. I hope they will be fit in time for the ring event of this organization. You must face not one, but two jormungar, after all.','',26124),
(35844,'enUS','We may operate in the shadows of polite society, but out here on the battlefront our powers are properly respected at last.','We may operate in the shadows of polite society, but out here on the battlefront our powers are properly respected at last.',26124),
(35845,'enUS','You! Yes, you!$b$bGaze upon me and treasure this moment of meeting, for soon the world will come to know and fear the name and stern visage of Wilfred Fizzlebang! Once my magnificent summoning is complete, no one will doubt my ability!','',26124),
(35846,'enUS','','Watch my back, I need to concentrate on this...',26124),
(35847,'enUS','','There\'s the survey marker!',26124),
(35848,'enUS','','Here we go - keep those things off of me while I work!',26124),
(35849,'enUS','','I got it!',26124),
(35850,'enUS','|TInterface\\Icons\\Spell_Shadow_Darkritual.blp:36|tYou have Empowered Darkness!','|TInterface\\Icons\\Spell_Shadow_Darkritual.blp:36|tYou have Empowered Darkness!',26124),
(35851,'enUS','|TInterface\\Icons\\Spell_Holy_Searinglightpriest.blp:36|tYou have Empowered Light!','|TInterface\\Icons\\Spell_Holy_Searinglightpriest.blp:36|tYou have Empowered Light!',26124),
(35852,'enUS','Success! You have your Personal Riches!$B$B|TInterface\\Icons\\INV_Misc_coin_02.blp:64|t','',26124),
(35853,'enUS','Stand your ground, men!','Stand your ground, men!',26124),
(35854,'enUS','Wh-what is that thing!!','Wh-what is that thing!!',26124),
(35855,'enUS','I - I think there\'s someone INSIDE that thing!','I - I think there\'s someone INSIDE that thing!',26124),
(35856,'enUS','Stay out of its way! It\'ll burn you alive!','Stay out of its way! It\'ll burn you alive!',26124),
(35857,'enUS','Protect Nijel\'s Point with your lives!','Protect Nijel\'s Point with your lives!',26124),
(35858,'enUS','Leave ... this ... place ...','',26124),
(35859,'enUS','These grounds ... are not ... yours ...','',26124),
(35860,'enUS','Turn ... back ...','',26124),
(35861,'enUS','The first challenge requires you to be mounted on an Argent Warhorses.  You will find these mounts along the walls of this coliseum.$b$bPlease, mount the warhorse, speak to me, and then we can proceed.','',26124),
(35862,'enUS','','That\'s how it\'s done!',26124),
(35863,'enUS','','I\'ll never make Sr. Grade at this rate...',26124),
(35864,'enUS','','I\'m going to put in for hazard pay.',26124),
(35865,'enUS','','...and stay dead!',26124),
(35866,'enUS','I... I lost control of the mines!$B$BPlease, $g sir : ma\'am;, don\'t fire me!','',26124),
(35867,'enUS','$n pops open the engine hatch and mucks around with the machine\'s innards...','',26124),
(35868,'enUS','%s shudders as piles of green sludge ooze out of the exhaust pipes!','',26124),
(35869,'enUS','Queue for Wintergrasp.','Queue for Wintergrasp.',26124),
(35870,'enUS','','You see the world through Kalytha\'s eyes...',26124),
(35871,'enUS','The champions of the world\'s great nations have gathered at the Argent Tournament Grounds in northeastern Icecrown to face all challengers.','',26124),
(35872,'enUS','Hello. By odd twist of fortune, we have obtained the remains of Kel\'Thuzad\'s feared abomination Patchwerk.  Our researchers are able to reassemble them in various ways to test the mettle of your band of would-be heroes, should you so desire.  \n\nWe can construct a sturdy Patchwerk against which to measure your ability to do damage, a brutal Patchwerk who will deliver rapid and mighty blows to any who would dare stand before him, or a well-rounded Patchwerk who will test your entire fighting force.\n\nWhich would you prefer?','',26124),
(35873,'enUS','I want to test our damage-dealers.','I want to test our damage-dealers.',26124),
(35874,'enUS','I want to test our tanks.','I want to test our tanks.',26124),
(35875,'enUS','No more play.','No more play.',26124),
(35876,'enUS','Good day, $n.  If you require my services as an auctioneer, I regret to inform you: no.  Only grand master engineers possess the minimum intellectual capacity to interface with my superior functions.$b$bMore importantly, why are you still talking to me?','',26124),
(35877,'enUS','What\'s on the auction house today?','What\'s on the auction house today?',26124),
(35878,'enUS','We mustn\'t allow them through!','',26124),
(35879,'enUS','More? Where are they all coming from!?','',26124),
(35880,'enUS','Stop them!','',26124),
(35881,'enUS','They\'re storming the walls!','',26124),
(35882,'enUS','We\'re being overrun!','',26124),
(35883,'enUS','Hold them off - just hold them off. The Archmage has a plan.','',26124),
(35884,'enUS','Kalytha - you\'re still alive! Find some cover, there\'s no end to these ... things!','',26124),
(35885,'enUS','Am I still bleeding? I can\'t ... I can\'t keep this up much longer. Have you seen any of the archmages?','',26124),
(35886,'enUS','Hmph. I suppose these are the consequences of magic. You reap what you sew ... Elune help us all.','',26124),
(35887,'enUS','Kalytha! Archmage Selwyn was looking for you. She should be nearby...','',26124),
(35888,'enUS','These creatures ... so many of them. So many dead! Look at Azshara burn. What have the highborne done?','',26124),
(35889,'enUS','Why didn\'t I flee with the others? They\'ve got the academy surrounded. We\'re trapped here.','',26124),
(35890,'enUS','','I\'ve got to keep the arcane wards charged.',26124),
(35891,'enUS','','My strength ... is beginning ... to falter. Kalytha, please tell me the Archmages have a backup plan...',26124),
(35892,'enUS','','I can\'t maintain this shield much longer. Kalytha - are any of us going to survive this?',26124),
(35893,'enUS','','More of these creatures! Where are they coming from? What\'s going on in the capital?',26124),
(35894,'enUS','','Kalytha! Hurry - Archmage Selwyn wanted to see you, she said it was urgent. Maybe we can win this thing?',26124),
(35895,'enUS','','It\'s all I can do to keep these wards up. Find one of the Archmages, Kalytha! I feel like I\'m about to collapse...',26124),
(35896,'enUS','The Argent Crusade invites you to test your skills in honorable combat against other heroes of Azeroth at the Argent Tournament.','',26124),
(35897,'enUS','','Kalytha ... it is done. The Sarcen Stone is fully charged and is already diverting energy from the portal. Are you still the incredible swimmer I knew those many years ago? The stone must not be found by either the demons or our \"beloved\" Queen.$B$BSwim to the bottom of the lake, Kalytha, and bury the stone deep under the center arch. Hopefully the demonic invaders will not discover it when they raze the surrounding temple. Go!',26124),
(35898,'enUS','Yes Archmage. I will hide the stone.','Yes Archmage. I will hide the stone.',26124),
(35902,'enUS','','<The shimmering vision does not acknowledge your presence. She is lost in her own world, reacting to events that played out thousands of years ago.>',26124),
(35903,'enUS','<Merge with the spirit.>','<Merge with the spirit.>',26124),
(35904,'enUS','I will join in the assault upon Icecrown Citadel when the time to strike is upon us.','',26124),
(35905,'enUS','Arms ready!  Here they come!  HERE THEY COME!!!','',26124),
(35906,'enUS','All you slaves better step it up!','',26124),
(35907,'enUS','You! Yes, you! Get back to work!','',26124),
(35908,'enUS','Don\'t make me come in there with my brutes!','',26124),
(35909,'enUS','I swear you trolls are the worst batch of workers we\'ve ever had!','',26124),
(35910,'enUS','Do I have to come in there and show you how it\'s done?!','',26124),
(35911,'enUS','Worthless! You\'re all just worthless! I\'m afraid we\'re going to have dump you all into the Maelstrom!','',26124),
(35912,'enUS','TIME IS MONEY, TROLLS!','',26124),
(35913,'enUS','It\'s back to the Undermine with the lot of you!','',26124),
(35914,'enUS','You mooks be on the lookout for any looters. Treat them with extreme prejudice!','',26124),
(35915,'enUS','I see great profit possibility on the horizon. All of Bilgewater Port\'s assets are about to flow to me.','',26124),
(35916,'enUS','It doesn\'t matter that Mount Kajaro has blown. All that matters is that I stay on top!','',26124),
(35917,'enUS','You brutes make sure that my number one executive doesn\'t get anywhere near the villa.','',26124),
(35918,'enUS','Ready my yacht! We ride with the tide and only the most wealthy and fit will be welcome to come with us!','',26124),
(35919,'enUS','We shall sail for distant Azshara. There, I will forge a new trade empire. One that will crush the Steamwheedle Cartel! And I shall carve my likeness upon that distant land\'s mountains. All will pay tribute to me!','',26124),
(35920,'enUS','Next please!','',26124),
(35921,'enUS','Hello. Would you like to fight the Faction Champions encounter for the Argent Colosseum raid? \n\nYou will face the version of this encounter that corresponds to the current raid difficulty you have selected. This encounter is a work in progress. Please be sure to report any bugs you experience on the Blizzard forums.\n\nAre you ready to begin the encounter?','',26124),
(35922,'enUS','Greetings, $c.$B$BThe Horde currently control Wintergrasp Fortress.  When the battle is about to begin, talk to me to enter the battle.$B$B','Greetings, $c.$B$BThe Horde currently control Wintergrasp Fortress.  When the battle is about to begin, talk to me to enter the battle.$B$B',26124),
(35923,'enUS','Hear me, invaders of Desolace! The Burning Blade shall use you all as sacrifices!','Hear me, invaders of Desolace! The Burning Blade shall use you all as sacrifices!',26124),
(35924,'enUS','Greetings, $c.$B$BThe Horde currently control Wintergrasp Fortress, but the battle has begun.  Hurry to Wintergrasp and support our forces!','Greetings, $c.$B$BThe Horde currently control Wintergrasp Fortress, but the battle has begun.  Hurry to Wintergrasp and support our forces!',26124),
(35925,'enUS','The time is nearly here! We shall sweep across this land, sacrificing all who defy us!','The time is nearly here! We shall sweep across this land, sacrificing all who defy us!',26124),
(35926,'enUS','With the help of the Burning Blade, demons shall rule all of Azeroth!','With the help of the Burning Blade, demons shall rule all of Azeroth!',26124),
(35927,'enUS','Bring on any opposition! The Burning Blade shall make a feast of your soul!','Bring on any opposition! The Burning Blade shall make a feast of your soul!',26124),
(35928,'enUS','All of Azeroth, prepare! The age of the Burning Blade is nigh!','All of Azeroth, prepare! The age of the Burning Blade is nigh!',26124),
(35929,'enUS','Invaders of Desolace, come join the Burning Blade or suffer the consequences of defiance!','Invaders of Desolace, come join the Burning Blade or suffer the consequences of defiance!',26124),
(35930,'enUS','Hello. Would you like to fight the Val\'kyr encounter for the Argent Colosseum raid? \n\nYou will face the version of this encounter that corresponds to the current raid difficulty you have selected. This encounter is a work in progress. Please be sure to report any bugs you experience on the Blizzard forums.\n\nAre you ready to begin the encounter?','',26124),
(35931,'enUS','Muahhaah! You are far too late. The summoning of your doom is nearly complete!','Muahhaah! You are far too late. The summoning of your doom is nearly complete!',26124),
(35932,'enUS','Hello. Would you like to fight the Anub\'arak encounter for the Argent Colosseum raid? \n\nYou will face the version of this encounter that corresponds to the current raid difficulty you have selected. This encounter is a work in progress. Please be sure to report any bugs you experience on the Blizzard forums.\n\nAre you ready to begin the encounter?','',26124),
(35933,'enUS','Greetings, $c.$B$BThe Alliance currently control Wintergrasp Fortress, but the battle has begun!  Hurry to Wintergrasp and support our forces!','Greetings, $c.$B$BThe Alliance currently control Wintergrasp Fortress, but the battle has begun!  Hurry to Wintergrasp and support our forces!',26124),
(35934,'enUS','Greetings, $c.$B$BThe Alliance currently control Wintergrasp Fortress.  When the battle is about to begin, talk to me to enter the battle.$B$B','Greetings, $c.$B$BThe Alliance currently control Wintergrasp Fortress.  When the battle is about to begin, talk to me to enter the battle.$B$B',26124),
(35935,'enUS','Queue for Wintergrasp.','Queue for Wintergrasp.',26124),
(35936,'enUS','Good day, $gsir:madam;!  How may I be of assistance?','',26124),
(35938,'enUS','This tear in the fabric of time and space looks ominous.  Different scenes flash by at terrifying speed.  A very brave person might try to jump through at the right time...','',26124),
(35939,'enUS','Borean Tundra','Borean Tundra',26124),
(35940,'enUS','Sholazar Basin','Sholazar Basin',26124),
(35941,'enUS','Icecrown','Icecrown',26124),
(35942,'enUS','Storm Peaks','Storm Peaks',26124),
(35943,'enUS','Howling Fjord','Howling Fjord',26124),
(35944,'enUS','Fool! You shall pay dearly for your interference!','',26124),
(35945,'enUS','%s sighs.','',26124),
(35946,'enUS','It is not safe out here, $n.  Seek shelter before it\'s too late.','',26124),
(35947,'enUS','Hello there, $n. So nice of you to rescue me. No hard feelings, right?','',26124),
(35948,'enUS','%s says: Look out! He\'s gonna blow!','',26124),
(35950,'enUS','Somone stop that ghoul!','',26124),
(35952,'enUS','That had to hurt! Brains!','',26124),
(35953,'enUS','','Marooned! Blasted to bits by the Alliance and stranded on some island in the middle of who-knows-where?!$B$BBusiness as usual, right, $n?',26124),
(35954,'enUS','What a Brains shot!','',26124),
(35955,'enUS','Greetings, $c.$B$BThe Horde currently control Wintergrasp Fortress, but the next battle starts soon.   Get ready to head to Wintergrasp and support our forces!$B$BThe next battle begins in $4354k.','Greetings, $c.$B$BThe Horde currently control Wintergrasp Fortress, but the next battle starts soon.   Get ready to head to Wintergrasp and support our forces!$B$BThe next battle begins in $4354k.',26124),
(35956,'enUS','Greetings, $c.$B$BThe Alliance currently control Wintergrasp Fortress, but the next battle starts soon.   Get ready to head to Wintergrasp and support our forces!$B$BThe next battle begins in $4354k.','Greetings, $c.$B$BThe Alliance currently control Wintergrasp Fortress, but the next battle starts soon.   Get ready to head to Wintergrasp and support our forces!$B$BThe next battle begins in $4354k.',26124),
(35957,'enUS','$n is trampled!','$n is trampled!',26124),
(35958,'enUS','Greetings, $c.$b$bLook around you. Have you stopped to ponder what all of this means?','',26124),
(35959,'enUS','','Justicar Mariel Trueheart has asked us to see to the needs of the tournament. Those who have earned the right to stand as champions and who have proven themselves in our eyes are asked to assist with these duties.',26124),
(35960,'enUS','','Justicar Mariel Trueheart has entrusted us with the duty of overseeing many of the tournament\'s affairs. Unfortunately, she tasked the Sunreavers with the same duty, which means we must work twice as hard to solve the problems created by those fools!',26124),
(35961,'enUS','','',26124),
(35962,'enUS','Sabotage! I\'m ruined....$b$bWhoever\'s behind this will pay! I promise you that....','',26124),
(35963,'enUS','$n? $G Sir : Ma\'am;, you\'re not a hunter, you\'re a $c.','$n? $G Sir : Ma\'am;, you\'re not a hunter, you\'re a $c.',26124),
(35964,'enUS','Oh, you and I are going to have a great time. I have so much to teach you about the ways of the hunter.','Oh, you and I are going to have a great time. I have so much to teach you about the ways of the hunter.',26124),
(35965,'enUS','We need you, $n!  There are worgen everywhere!','',26124),
(35966,'enUS','It\'s just horrible. I think they\'re all dead.$B$BHow will I get the kaja\'mite out of there now?','',26124),
(35967,'enUS','Rargh! Not another one!','',26124),
(35968,'enUS','%s emerges from the ground!','',26124),
(35969,'enUS','Leave Balboa alone you shiny gnats!','',26124),
(35970,'enUS','Who did that?! Stop it!','',26124),
(35971,'enUS','No more! I no like that!','',26124),
(35972,'enUS','','The whispering winds have made it known to me that a $r $c would come; that $ghe:she; would assist me where many others have failed.$b$bCould you be the one?',26124),
(35973,'enUS','I am ready to be shown this threat you speak of, Korrah.','I am ready to be shown this threat you speak of, Korrah.',26124),
(35974,'enUS','I can\'t offer you any training, $n, but I sure could use your help against these damn monkeys!','',26124),
(35975,'enUS','There\'s my favorite warlock! What dark secret can I whisper in your ear today?','',26124),
(35976,'enUS','Hey there, $g Mr. : Ms.; $n. I can\'t train you in the ways of magic, but all of this finger-waggling means that I can give a mean neck massage.','Hey there, $g Mr. : Ms.; $n. I can\'t train you in the ways of magic, but all of this finger-waggling means that I can give a mean neck massage.',26124),
(35977,'enUS','If you\'ll excuse me, I\'m afraid I have other business I must attend to.  Please call on me again in the future.','',26124),
(35978,'enUS','What a wonderful day for some training in the mystical arts. Wouldn\'t you agree, $g Mr. : Ms.; $n?','What a wonderful day for some training in the mystical arts. Wouldn\'t you agree, $g Mr. : Ms.; $n?',26124),
(35979,'enUS','Let me give you a moment to get our opponents ready for battle.','Let me give you a moment to get our opponents ready for battle.',26124),
(35980,'enUS','You\'re doing a great job, $g Mr. : Ms.; $n. Keep up the good work.','',26124),
(35981,'enUS','I see such a bright future for you, my $g boy : girl;! What shall I teach you today?','',26124),
(35982,'enUS','','Shipwrecked on an island infested with bomb-throwing monkeys? What\'s next... is there a volcano that\'s going to blow?!',26124),
(35983,'enUS','','We\'re... er, I mean the Light, is going to need a lot of gold, now more than ever.$B$BSpeaking of which, do you need any training?',26124),
(35984,'enUS','','You can see me? How can you see me, boss?$B$BI\'m going to have to work on that.',26124),
(35985,'enUS','','Training, massages, whatever you need, boss. Just don\'t forget me when you\'re the new Trade $g Prince : Princess;!',26124),
(35986,'enUS','That warlock certainly didn\'t summon a Doomguard! Your next challenge will find you fighting knights of the Argent Crusade. Think you\'re up for the challenge?','',26124),
(35987,'enUS','Of course!','Of course!',26124),
(35988,'enUS','Well then, I\'ll give the signal to Tirion when you are ready to go.','',26124),
(35989,'enUS','Give the signal! We\'re ready to go!','Give the signal! We\'re ready to go!',26124),
(35990,'enUS','That fight was savage and brutal. I haven\'t seen a grand melee like that in many years! Amazing!','',26124),
(35991,'enUS','You\'ll be even more amazed after we take them out!','You\'ll be even more amazed after we take them out!',26124),
(35992,'enUS','I can\'t wait to see it! They seem ready for another round now, so prepare yourselves!','',26124),
(35993,'enUS','We\'re ready for anything!','We\'re ready for anything!',26124),
(35994,'enUS','The swoop egg is destroyed...','',26124),
(35995,'enUS','Okay, here we go. You\'re gonna cover me, right?','Okay, here we go. You\'re gonna cover me, right?',26124),
(35996,'enUS','','The number of naga here continue to rise steadily....',26124),
(35997,'enUS','','The cataclysm split the land apart here, allowing the naga to stretch inland...',26124),
(35998,'enUS','','A priestess of Azshara! Could she be leading their efforts?',26124),
(35999,'enUS','','They are scouring the entire region. We must discover what it is that they seek!',26124),
(36000,'enUS','','The water itself rises to fight against them here, but why? Many questions and few answers...',26124),
(36001,'enUS','','Return to me now, $c. There is much to do.',26124),
(36002,'enUS','I thought you were going to keep these things off of me?','I thought you were going to keep these things off of me?',26124),
(36003,'enUS','How can I get my mining done if I\'m being attacked?','How can I get my mining done if I\'m being attacked?',26124),
(36004,'enUS','We\'re going to die in here like all the others, aren\'t we?','We\'re going to die in here like all the others, aren\'t we?',26124),
(36005,'enUS','I want to go home now.','I want to go home now.',26124),
(36006,'enUS','They\'re not paying me enough for this. Wait! They\'re not paying me at all!','They\'re not paying me enough for this. Wait! They\'re not paying me at all!',26124),
(36007,'enUS','I\'m here to mine, you\'re here to fight. Get it straight!','I\'m here to mine, you\'re here to fight. Get it straight!',26124),
(36008,'enUS','These cave paintings are creeping me out. NOT TO MENTION THE MONKEYS TRYING TO KILL ME!','These cave paintings are creeping me out. NOT TO MENTION THE MONKEYS TRYING TO KILL ME!',26124),
(36009,'enUS','I\'m certain that the kaja\'mite is having the same intelligence-increasing effect on the monkeys that it had on our ancient ancestors.','I\'m certain that the kaja\'mite is having the same intelligence-increasing effect on the monkeys that it had on our ancient ancestors.',26124),
(36010,'enUS','Let\'s move on.','Let\'s move on.',26124),
(36011,'enUS','This chunk\'s been picked clean.','This chunk\'s been picked clean.',26124),
(36012,'enUS','I can\'t get anything else out of this one.','I can\'t get anything else out of this one.',26124),
(36013,'enUS','We\'ve hit the jackpot in this place!','We\'ve hit the jackpot in this place!',26124),
(36014,'enUS','Did I ever tell you that I was a mid-level accountant with the company back on Kezan? I worked for you for years. Do you even know my name?','Did I ever tell you that I was a mid-level accountant with the company back on Kezan? I worked for you for years. Do you even know my name?',26124),
(36015,'enUS','The monkeys already extracted most of the kaja\'mite out of this deposit.','The monkeys already extracted most of the kaja\'mite out of this deposit.',26124),
(36016,'enUS','What I wouldn\'t give for some explosives right about now.','What I wouldn\'t give for some explosives right about now.',26124),
(36017,'enUS','Hey, why am I doing all of the work here?','Hey, why am I doing all of the work here?',26124),
(36018,'enUS','That\'s good enough for now. I\'ll make my way out on my own. Thanks for the escort, $n.','That\'s good enough for now. I\'ll make my way out on my own. Thanks for the escort, $n.',26124),
(36019,'enUS','We suffered a lot of casualties when capturing your next challenge!','',26124),
(36020,'enUS','Er, Dampwick, I need another miner....','Er, Dampwick, I need another miner....',26124),
(36021,'enUS','%s roars at the sight of the surviving beasts and fights with renewed vigor!','',26124),
(36022,'enUS','Underground...','Underground...',26124),
(36023,'enUS','The Val\'kyrs\'  teamwork is rather astounding. I now see why we had such problems capturing the two of them.','',26124),
(36024,'enUS','That tough, huh?','That tough, huh?',26124),
(36025,'enUS','We\'ll just have to improve our own teamwork to match the two of them.','We\'ll just have to improve our own teamwork to match the two of them.',26124),
(36026,'enUS','You better believe it! You\'re going to face two of Arthas\' most powerful Val\'kyr lieutenants!','',26124),
(36027,'enUS','Val\'kyr? We\'re ready for them.','Val\'kyr? We\'re ready for them.',26124),
(36028,'enUS','Well I hope you improve quickly!','',26124),
(36029,'enUS','Just bring them out again, then watch.','Just bring them out again, then watch.',26124),
(36030,'enUS','Mortar strike called in. Let \'em have it, Hackel!','',26124),
(36031,'enUS','%s realizes he needs some Leggings of the Fang.','%s realizes he needs some Leggings of the Fang.',26124),
(36032,'enUS','%s daydreams of Lucky Fishing Hats.','%s daydreams of Lucky Fishing Hats.',26124),
(36033,'enUS','','The tournament\'s seneschal has asked us to shoulder some of the burden of running the competition now that the coliseum is finished. Those who have earned the right to stand as champions and who have proven themselves in our eyes are asked to assist with these duties.',26124),
(36034,'enUS','%s bemoans the loss of his Nethercleft Leg Armor.','%s bemoans the loss of his Nethercleft Leg Armor.',26124),
(36035,'enUS','','Justicar Mariel Trueheart has asked us to help administer and defend the tournament now that the coliseum is complete. She wants us to work with those worthless Silver Covenant curs, but they\'re just getting in the way.',26124),
(36036,'enUS','%s plans a Stranglethorn Vale fishing trip.','%s plans a Stranglethorn Vale fishing trip.',26124),
(36037,'enUS','It\'s coming right for me!','It\'s coming right for me!',26124),
(36038,'enUS','Help me, please!','Help me, please!',26124),
(36039,'enUS','There\'s one after me!','There\'s one after me!',26124),
(36040,'enUS','Help!','Help!',26124),
(36041,'enUS','I don\'t want to die!','I don\'t want to die!',26124),
(36042,'enUS','When I trained as a guard in Orgrimmar, Thrall urged us to be patient and cautious when dealing with enemies.$B$BBut Naga threaten to overrun this peninsula, and Thrall is no longer my Warchief. The time has come to shed some blood, $c.','',26124),
(36043,'enUS','','Why are you interrupting my work here?! Explain yourself!',26124),
(36044,'enUS','','You\'d better have good reason to approach me, minnow!',26124),
(36045,'enUS','','What\'s this? What do you want with me, minnow?',26124),
(36046,'enUS','Splendid, you\'ve proven yourselves as great champions here today. With you fighting alongside the Argent Crusade, victory against the Scourge is inevitable!','',26124),
(36047,'enUS','Your words of praise are appreciated, Coliseum Master.','Your words of praise are appreciated, Coliseum Master.',26124),
(36048,'enUS','The praise is well deserved. Tirion will want to praise you himself, shortly. Hey, have you noticed it getting a bit cold all of a sudden?','',26124),
(36049,'enUS','That is strange... ','That is strange...',26124),
(36050,'enUS','You will pay for disturbing us!','',26124),
(36051,'enUS','I\'ll silence that infernal drum once and for all!','',26124),
(36052,'enUS','What do you think you\'re doing, fool?','',26124),
(36053,'enUS','No one provokes the servants of Loken and gets away with it!','',26124),
(36054,'enUS','Keep that sword arm straight, $n.','',26124),
(36055,'enUS','You\'re not a warrior!  You\'d better go back inside the perimeter to where it\'s safe... no offense.','',26124),
(36056,'enUS','My humblest apologies, Champion, but you have run out of opportunities to complete the Trial of the Grand Crusader. As a reminder, you and your fellow adventurers are able to begin the Trial of the Grand Crusader once every week. May the lessons learned this week bring you one step closer to final victory here and against the Scourge!','',26124),
(36057,'enUS','','Your efforts here shall not be forgotten, $n! I shall make certain of that.',26124),
(36058,'enUS','','You are not initiated in the old ways.  There is nothing I can teach you, child.',26124),
(36059,'enUS','','The worgen will pass.  We shall pass.$B$BOnly the earth and her secrets will remain.  Are you willing to learn, $n?',26124),
(36060,'enUS','I seek further training in the old ways of the druids.','I seek further training in the old ways of the druids.',26124),
(36061,'enUS','The last batch of orcs. They should fall quickly!','The last batch of orcs. They should fall quickly!',26124),
(36062,'enUS','Die, orc scum!','Die, orc scum!',26124),
(36063,'enUS','First these orcs and then those pathetic goblins down on the shore.','First these orcs and then those pathetic goblins down on the shore.',26124),
(36064,'enUS','Kill them all!','Kill them all!',26124),
(36065,'enUS','We\'ll get through this, $n.  We\'ll be wearing these beasts\' pelts when we\'re done.','',26124),
(36066,'enUS','Be very, very quiet.  There\'s worgen everywhere.','',26124),
(36067,'enUS','I seek further training.','I seek further training.',26124),
(36068,'enUS','','Of course, I will share my knowledge with you.  Especially if it helps us defeat the worgen.',26124),
(36069,'enUS','','I\'d have a hard time teaching you.  It takes years of mental preparation to become attuned to the powers of the arcane.',26124),
(36070,'enUS','','Ask me for help and advice... just don\'t ask me for money, okay?',26124),
(36071,'enUS','','I swear this wasn\'t my fault.  Why are you looking at me like that?',26124),
(36072,'enUS','','Even now, in the darkest of times, the teachings of the Light will guide you throught this world.',26124),
(36073,'enUS','','The Light is with you, $c.  No harm will come to you today.',26124),
(36074,'enUS','I think that we might have angered them.','',26124),
(36075,'enUS','I will gladly share my forbidden knowledge with you in this time of great peril.  The darkness will protect us, $gbrother : sister;.','',26124),
(36076,'enUS','Even the most superficial glimpse into the secrets I hold would drive you mad, $c.','',26124),
(36077,'enUS','Yes, fleshling?','',26124),
(36078,'enUS','Rescue Krennan Aranas by using your vehicle\'s ability.$B|TInterface\\Icons\\inv_misc_groupneedmore.blp:64|t','Rescue Krennan Aranas by using your vehicle\'s ability.$B|TInterface\\Icons\\inv_misc_groupneedmore.blp:64|t',26124),
(36079,'enUS','I am prepared to join you in battle, Hydronis!','I am prepared to join you in battle, Hydronis!',26124),
(36080,'enUS','Welcome, champion! Have you gathered your forces in preparation for the challenges of the Trial of the Grand Crusader? Only the most powerful and accomplished of combatants are able to participate in these trials. To participate in these trials, you must have completed the normal Trial of the Crusader.','',26124),
(36082,'enUS','I have completed the Trial of the Crusader.','I have completed the Trial of the Crusader.',26124),
(36083,'enUS','I have not completed the Trial of the Crusader.','I have not completed the Trial of the Crusader.',26124),
(36084,'enUS','Come back again when you have achieved success in the Trial of the Crusader.','',26124),
(36085,'enUS','The Trial of the Grand Crusader is a more difficult version of the Trial of the Crusader. Each encounter is more difficult, and you will not be able to freely attempt the encounters until you win. After 50 unsuccessful attempts, the Trial of the Grand Crusader will end for the week. After successfully completing the Trial of the Grand Crusader, you will receive an additional tribute chest of rewards as compensation. Are you prepared for this trial?','',26124),
(36086,'enUS','My apologies, adventurer. The grand warlock Wilfred Fizzlebang has not arrived on the tournament grounds yet, so the next challenge of the trial is not available. We expect him next week.','',26124),
(36087,'enUS','Delays, delays, and more delays. The Trial of the Crusader has currently been placed on hold, pending the results of an investigation into the actions of Wilfred Fizzlebang. Next week the trial will continue, so be ready to fight the best knights of the Argent Crusade!','',26124),
(36088,'enUS','We dispatched a force of knights to capture a pair of Arthas\' Scourge lieutenants to serve as the next challenge of the trial. The knights have not returned with their prey yet, so the next phase of the trial is on hold. Check back next week.','',26124),
(36089,'enUS','That was simply spendid! Unbelievable! Well done! We already have plans in motion to celebrate your victory. Our preperations will be finished next week, see you then!','',26124),
(36090,'enUS','Hold the barricades!  Do not give them an inch!','',26124),
(36091,'enUS','Fire!','',26124),
(36092,'enUS','Keep them back!','',26124),
(36093,'enUS','','The plan is to keep moving south.  We can\'t go back to the Merchant Square.  It\'s not safe.',26124),
(36094,'enUS','','We must stick together to survive.  Move around in groups.',26124),
(36095,'enUS','','The king\'s men will protect us.  We\'re almost there.',26124),
(36096,'enUS','','You shall pay for what what you\'ve done to my minnows, fool!',26124),
(36097,'enUS','<Kilag motions you to keep your voice down.>','',26124),
(36098,'enUS','','%s hisses with horror and rage!',26124),
(36099,'enUS','We\'ve got Aranas!  Fire at will!','',26124),
(36100,'enUS','','You cannot save... Neptulon!',26124),
(36101,'enUS','','%s emits a piercing scream as her power dissipates!',26124),
(36102,'enUS','Whoa! What\'s with all of the cave paintings? Ack, do I hear monkeys?!','Whoa! What\'s with all of the cave paintings? Ack, do I hear monkeys?!',26124),
(36103,'enUS','We need to keep the worgen\'s attention in the city, Genn.  It\'s the only shot we have for the survivors to make it to Duskhaven.','',26124),
(36104,'enUS','Not a chance, boy.  Gilneas is going to need its king\'s undivided attention.  Can\'t have your father wondering whether his child is alive or not.','',26124),
(36105,'enUS','My men and I will hole up inside the Light\'s Dawn Cathedral.  I\'ve already given the order and the cannons are on their way.  Lead our people well, Genn.','',26124),
(36106,'enUS','I\'ll stay behind with the Royal Guard, father.  It is my duty to Gilneas.','',26124),
(36107,'enUS','If we can make it past the gates into Duskhaven we\'ll be safe.  The eastern mountains are virtually impassable.','',26124),
(36108,'enUS','We were fools to take up arms against each other, Darius.  The worgen would\'ve never stood a chance.','',26124),
(36109,'enUS','We will move ahead, Kilag.','',26124),
(36110,'enUS','$n has cleared a path. We will go ahead.','',26124),
(36111,'enUS','Do not wait long, Kilag. We will scout ahead.','',26124),
(36112,'enUS','Goblin technology is strange and deadly. I approve!','',26124),
(36113,'enUS','We will scout ahead to the Wild Overlook and see you there, Kilag.','',26124),
(36114,'enUS','Be wary. There are deadlier things in this jungle than these plants!','',26124),
(36115,'enUS','Time to go. I hope that we will meet again, $n.','',26124),
(36116,'enUS','We should move now.  See you at the Wild Overlook.','',26124),
(36117,'enUS','The goggles! They do nothing!','The goggles! They do nothing!',26124),
(36118,'enUS','Fire ... FIRE!','Fire ... FIRE!',26124),
(36119,'enUS','Again with the flames and the hurt.','Again with the flames and the hurt.',26124),
(36120,'enUS','This whole place is gonna blow!','This whole place is gonna blow!',26124),
(36121,'enUS','This is one of our less productive colossal disasters.','This is one of our less productive colossal disasters.',26124),
(36122,'enUS','I\'m on fire. Note that in the logs!','I\'m on fire. Note that in the logs!',26124),
(36123,'enUS','My flesh!','My flesh!',26124),
(36124,'enUS','Stand ready, guards!  We don\'t know how many intruders we\'re dealing with, but the Headlands are overrun and we\'re cut off from the harbor towns.  Expect to be outnumbered.','',26124),
(36125,'enUS','I want the perimeter secured and the gates manned by two guards at all times.  No one gets in, no one gets out.','',26124),
(36126,'enUS','We protected Gilneas from the Scourge.  We protected Gilneas during the Northgate rebellion.  We will protect Gilneas from whatever this new threat may be.','',26124),
(36127,'enUS','I\'m leaving for the next rendezvous point in a few seconds.','',26124),
(36128,'enUS','Thank you, thank you!','Thank you, thank you!',26124),
(36129,'enUS','Champions, you\'re alive! Not only have you defeated every challenge of the Trial of the Crusader, but also thwarted Arthas\' plans! Your skill and cunning will prove to be a powerful weapon against the Scourge. Well done! Allow one of the Crusade\'s mages to transport you to the surface!','',26124),
(36130,'enUS','Whew, thanks! I\'m going to check and see if these results are repeatable.','Whew, thanks! I\'m going to check and see if these results are repeatable.',26124),
(36131,'enUS','I should really try to burst into flames less often.','I should really try to burst into flames less often.',26124),
(36132,'enUS','Make a note: Fire bad.','Make a note: Fire bad.',26124),
(36133,'enUS','Hurry - save the others!','Hurry - save the others!',26124),
(36134,'enUS','Champions, you\'ve defeated the Trial of the Grand Crusader! Only the most battle tested adventurers could ever hope to complete this Trial. I present to you this tribute chest as a well deserved reward! May the contents serve you well in our upcoming campaign against Arthas in the heart of Icecrown Citadel!','',26124),
(36135,'enUS','Now that you have completed the Trial of the Crusader, you should consider returning to take part in the Trial of the Grand Crusader. Only the strongest adventurers can hope to complete the Trial, but you will be rewarded well for your efforts.','',26124),
(36136,'enUS','I\'m gonna go find some ointment.','I\'m gonna go find some ointment.',26124),
(36137,'enUS','That wasn\'t as bad as it looked.','That wasn\'t as bad as it looked.',26124),
(36139,'enUS','In coming here, you have made a grave mistake. These tournament grounds are a bastion of the Light, and your power cannot match it.','In coming here, you have made a grave mistake. These tournament grounds are a bastion of the Light, and your power cannot match it.',26124),
(36140,'enUS','I am sorry, but you do not belong here, and you cannot be allowed to harm the innocents on the grounds.','I am sorry, but you do not belong here, and you cannot be allowed to harm the innocents on the grounds.',26124),
(36141,'enUS','Congratulations, please take the portal to Dalaran when you\'re ready!','',26124),
(36142,'enUS','The quantity and quality of rewards inside the tribute chest is based upon how many unsuccessful attempts you had during the Trial of the Grand Crusader. The fewer unsuccessful attempts, the better the rewards.','',26124),
(36143,'enUS','I wish to unlearn my Gnomish Engineering specialization!','I wish to unlearn my Gnomish Engineering specialization!',26124),
(36144,'enUS','Do you really want to unlearn your Gnomish Engineering specialization and lose all associated recipes?','Do you really want to unlearn your Gnomish Engineering specialization and lose all associated recipes?',26124),
(36145,'enUS','Do you really want to unlearn your Goblin Engineering specialization and lose all associated recipes?','Do you really want to unlearn your Goblin Engineering specialization and lose all associated recipes?',26124),
(36146,'enUS','I wish to unlearn my Goblin Engineering specialization!','I wish to unlearn my Goblin Engineering specialization!',26124),
(36147,'enUS','Upon seeing its companion perish, %s becomes enraged!','',26124),
(36148,'enUS','Kilag, I... uh, somehow... er, lost my scout.','Kilag, I... uh, somehow... er, lost my scout.',26124),
(36149,'enUS','You two be more careful! There are only so many of us!','',26124),
(36150,'enUS','What?! You think I\'m made out of miners?$B$BHow bad can it be in there?','',26124),
(36151,'enUS','Once more I apologize, but you chose this fate.','Once more I apologize, but you chose this fate.',26124),
(36152,'enUS','','Do you see the gyrochoppa on the far side of the beach, $n?!',26124),
(36153,'enUS','Get the keys and then get to that gyrochoppa!','',26124),
(36154,'enUS','','This cannot be!',26124),
(36155,'enUS','','We will have vengeance!',26124),
(36156,'enUS','WARNING: Reactor Core Flushed!','',26124),
(36157,'enUS','Hey! Get away from my flying machine!','',26124),
(36158,'enUS','Don\'t forget to keep your goggles on, $n. That\'s the only way we\'ll spot them before they can jump us.','',26124),
(36159,'enUS','We must push little cart!','',26124),
(36160,'enUS','Get to the gyrochoppa! Do it now!','',26124),
(36161,'enUS','','Ah, you did it! Excellent work.',26124),
(36162,'enUS','Wow - is that refined Azsharite?','Wow - is that refined Azsharite?',26124),
(36163,'enUS','I never thought I\'d see such a pure sample.','I never thought I\'d see such a pure sample.',26124),
(36164,'enUS','I have been shown the future, $r.$b$bCentaur lands will be forever corrupted if we fail to act quickly.','',26124),
(36165,'enUS','I am ready to do battle with the Magram clan!','I am ready to do battle with the Magram clan!',26124),
(36166,'enUS','Now, $r! Place the spear!','',26124),
(36167,'enUS','The Azsharite Core momentarily cools off.','',26124),
(36168,'enUS','Bleh! Clearly built by gnomes.','',26124),
(36169,'enUS','Hop in and take off!','Hop in and take off!',26124),
(36170,'enUS','The Azsharite Core is Overheating - use the Fireliminator to cool it!','',26124),
(36171,'enUS','Azsharite Core at 60 percent integrity...','',26124),
(36172,'enUS','The Azsharite Core is dangerously close to overheating.','',26124),
(36173,'enUS','The Azsharite Core is about to go critical!','',26124),
(36174,'enUS','Hurry! Before we\'re discovered!','',26124),
(36175,'enUS','You failed to plant the spear! We must make another attempt... soon!','',26124),
(36176,'enUS','%s goes critical!','',26124),
(36177,'enUS','Find the Precious Cargo!','',26124),
(36178,'enUS','Kolkar clan! Attack!!','',26124),
(36179,'enUS','A goblin? I must be seeing things. Throm-Ka and thank you, little one!','',26124),
(36180,'enUS','Give the orc warchief some smelling salts to rouse him from his drugged stuppor.','Give the orc warchief some smelling salts to rouse him from his drugged stuppor.',26124),
(36181,'enUS','That seems to have done the trick.','',26124),
(36182,'enUS','A goblin? I must be seeing things. Throm-Ka and thank you, little one.','',26124),
(36184,'enUS','The Spear of the Kolkar Khan has been broken...','',26124),
(36185,'enUS','Retreat!!','',26124),
(36186,'enUS','The spear is broken! Retreat!','',26124),
(36187,'enUS','Enough! What is this about?!','',26124),
(36188,'enUS','$n, sit on down. The fire\'s warm and the monkeys don\'t seem to like it.','',26124),
(36189,'enUS','Who would\'ve thought we\'d wind up here after everything we\'ve been through?','',26124),
(36190,'enUS','Hey, look guys, it\'s $n!','',26124),
(36191,'enUS','Looks like we\'re in a pretty tight jam. Think you can get us out of here?','',26124),
(36192,'enUS','','Oh, $n, we\'re marooned!',26124),
(36193,'enUS','','I miss Kezan. Will we ever see Bilgewater Port again, $n?',26124),
(36194,'enUS','','Sit with me a while. We can roast crabs over the fire and sing songs.',26124),
(36195,'enUS','','I put this all on you, but what are you doing to get us off of this island?',26124),
(36196,'enUS','<Gobber grunts.>$B$BMe banker now!','',26124),
(36197,'enUS','','Nice to see you again, $n.',26124),
(36198,'enUS','Spirits of the sea, rise and lay waste to my enemies!','',26124),
(36199,'enUS','Power of the ocean, heed my call!','',26124),
(36200,'enUS','Children of the watery depths, lay waste to those who foul your realm!','',26124),
(36201,'enUS','Speed of the storm, heed my call!','',26124),
(36202,'enUS','Winds of boundless fury, unleash your tempest upon the Alliance!','',26124),
(36203,'enUS','Sons of Stormwall, descend and destroy those who would prevent me from protecting this world!','',26124),
(36204,'enUS','I\'m feeling much better already.','',26124),
(36205,'enUS','Lok\'tar ogar, $n!','',26124),
(36206,'enUS','Warchief, I need another cyclone.','Warchief, I need another cyclone.',26124),
(36207,'enUS','Go to the center of the temple and use the Horn of Elemental Fury!','',26124),
(36208,'enUS','There were worgen everywhere.... it should\'ve been me....','',26124),
(36209,'enUS','Gilneas will soon belong to the Forsaken!','Gilneas will soon belong to the Forsaken!',26124),
(36210,'enUS','You\'ll find them in the Apothecarium. Names are Doctor Herbert Halsey and Doctor Marsh. Just watch your back.','You\'ll find them in the Apothecarium. Names are Doctor Herbert Halsey and Doctor Marsh. Just watch your back.',26124),
(36211,'enUS','Doctor Herbert Halsey is who you want. Just don\'t try anything funny. Any more of that plague nonsense and you\'ll find an axe in uncomfortable places.','Doctor Herbert Halsey is who you want. Just don\'t try anything funny. Any more of that plague nonsense and you\'ll find an axe in uncomfortable places.',26124),
(36212,'enUS','Grizzle Halfmane in the Royal Quarter is the orc you\'re looking for.','Grizzle Halfmane in the Royal Quarter is the orc you\'re looking for.',26124),
(36213,'enUS','The battlemaster serving Undercity is Grizzle Halfmane - a fierce fighter in his day. He\'s in the Royal Quarter.','The battlemaster serving Undercity is Grizzle Halfmane - a fierce fighter in his day. He\'s in the Royal Quarter.',26124),
(36214,'enUS','You want Sir Malory Wheeler. He\'s in the Royal Quarter with the rest of the battlemasters.','You want Sir Malory Wheeler. He\'s in the Royal Quarter with the rest of the battlemasters.',26124),
(36215,'enUS','You want to help the Defilers? Head to the Royal Quarter and speak with Sir Malory Wheeler. He\'s your man.','You want to help the Defilers? Head to the Royal Quarter and speak with Sir Malory Wheeler. He\'s your man.',26124),
(36216,'enUS','Head to the central ring; you\'ll find auctioneers stationed there.','Head to the central ring; you\'ll find auctioneers stationed there.',26124),
(36217,'enUS','If you want to access the market here, get to the central ring of the city.','If you want to access the market here, get to the central ring of the city.',26124),
(36218,'enUS','Kawphi? Memory potion? Hah! This isn\'t a memory potion.','',26124),
(36219,'enUS','The bank? It\'s that tower in the middle of the Trade Quarter.','The bank? It\'s that tower in the middle of the Trade Quarter.',26124),
(36220,'enUS','So Ergll, is that all that you needed for your memory potion?','So Ergll, is that all that you needed for your memory potion?',26124),
(36221,'enUS','What is it then?','What is it then?',26124),
(36222,'enUS','I wakes me up in the mornings. The sun makes me tired. Hard to think.','',26124),
(36223,'enUS','All of that just to wake you up? I\'m sure I have several weapons that could have managed that fine.','All of that just to wake you up? I\'m sure I have several weapons that could have managed that fine.',26124),
(36224,'enUS','More reliable this way I think.','',26124),
(36225,'enUS','So... where can I find Azuregos, Ergll?','So... where can I find Azuregos, Ergll?',26124),
(36226,'enUS','Azuregos! I remember him. Tall, blue, big fangs. Nice sort really, if a little loopy. Haven\'t seen him in weeks.','',26124),
(36227,'enUS','It\'s right in the center of the city. The hub of the wheel.','It\'s right in the center of the city. The hub of the wheel.',26124),
(36228,'enUS','Naznik\'s the local barber. He set up shop on the top ring of the Trade Quarter.','Naznik\'s the local barber. He set up shop on the top ring of the Trade Quarter.',26124),
(36229,'enUS','Michael Garrett tends the Undercity\'s bats. He\'s in the upper ring of the Trade Quarter.','Michael Garrett tends the Undercity\'s bats. He\'s in the upper ring of the Trade Quarter.',26124),
(36230,'enUS','The bat handler has his roost on the upper ring of the Trade Quarter. You can\'t miss the smell.','The bat handler has his roost on the upper ring of the Trade Quarter. You can\'t miss the smell.',26124),
(36231,'enUS','The battlemasters are stationed in the Royal Quarter; you\'ll find them around the throne room.','The battlemasters are stationed in the Royal Quarter; you\'ll find them around the throne room.',26124),
(36232,'enUS','Which battleground calls you?','Which battleground calls you?',26124),
(36233,'enUS','James Van Brunt runs a decent forge in the War Quarter. He\'s on the inner ring.','James Van Brunt runs a decent forge in the War Quarter. He\'s on the inner ring.',26124),
(36234,'enUS','The blacksmith here works in the War Quarter, close to where his weapons will be put to use. He\'s there on the inner ring.','The blacksmith here works in the War Quarter, close to where his weapons will be put to use. He\'s there on the inner ring.',26124),
(36235,'enUS','Eunice Burch cooks what passes for food here over in the Trade Quarter. It\'s your stomach, not mine.','Eunice Burch cooks what passes for food here over in the Trade Quarter. It\'s your stomach, not mine.',26124),
(36236,'enUS','The cook around here is in the Trade Quarter. Her name\'s Eunice Burch.','The cook around here is in the Trade Quarter. Her name\'s Eunice Burch.',26124),
(36237,'enUS','Lavinia Crowe\'s the local enchanter. She\'s set up shop on the inner ring of the Apothecarium.','Lavinia Crowe\'s the local enchanter. She\'s set up shop on the inner ring of the Apothecarium.',26124),
(36238,'enUS','If you want to learn enchanting, go find Lavinia Crowe on the inner ring of the Apothecarium.','If you want to learn enchanting, go find Lavinia Crowe on the inner ring of the Apothecarium.',26124),
(36239,'enUS','The engineer here is called Franklin Lloyd. He tinkers in the Rogues\' Quarter, on the outer ring.','The engineer here is called Franklin Lloyd. He tinkers in the Rogues\' Quarter, on the outer ring.',26124),
(36240,'enUS','Look, if you want to go talk to those engineers on the outer ring of the Rogues\' Quarter, it\'s your hide.','Look, if you want to go talk to those engineers on the outer ring of the Rogues\' Quarter, it\'s your hide.',26124),
(36241,'enUS','Mary Edras is the one you want. She\'s set up at the inner ring of the Rogues\' Quarter.','Mary Edras is the one you want. She\'s set up at the inner ring of the Rogues\' Quarter.',26124),
(36242,'enUS','Really? Weeks? Don\'t you have anything better than that?','Really? Weeks? Don\'t you have anything better than that?',26124),
(36243,'enUS','He was always prattling on about finding this or that magic artifact. Said Azshara was full of them, he did. He was a bit obsessive if you ask me.$B$BLast I heard, he was trying to make friends with that Archmage person. Xylem? He said Xylem had found some grand old magic item.\n','',26124),
(36244,'enUS','Archmage Xylem? Where can I find this Archmage, Ergll?','Archmage Xylem? Where can I find this Archmage, Ergll?',26124),
(36245,'enUS','Xylem\'s a little bit lacking in the social graces. He talks to his apprentices a bit, but mostly he just talks to himself. Tends to brush everyone else off.$B$BWouldn\'t take me as an apprentice - said I was too slimy. Said that my mind wasn\'t any good to study being all mucked up with magic and all.\n','',26124),
(36246,'enUS','Any idea on how I could get him to answer some questions?','Any idea on how I could get him to answer some questions?',26124),
(36247,'enUS','Become an apprentice I suppose. Pretty high turnover really.$B$BI\'ve met maybe a dozen washed up apprentices this last month alone. He leaves them kind of damaged. They keep coming though. I guess there aren\'t many options in the Archmage racket.$B$BI met another one just today. He was heading over to the west, to that big pillar that\'s being built.\n','',26124),
(36248,'enUS','It\'s a start. Thanks Ergll.','It\'s a start. Thanks Ergll.',26124),
(36249,'enUS','Yup yup! Say hi for me if you find him.','',26124),
(36250,'enUS','Hello! Someone who doesn\'t smell like fish. I like.','',26124),
(36251,'enUS','Even the walking dead need to mend themselves. Mary Edras handles it here. She\'s in the Rogues\' Quarter, on the inner ring.','Even the walking dead need to mend themselves. Mary Edras handles it here. She\'s in the Rogues\' Quarter, on the inner ring.',26124),
(36252,'enUS','The crazy fisherman is on the dock in the Magic Quarter.','The crazy fisherman is on the dock in the Magic Quarter.',26124),
(36253,'enUS','Greetings, friend.$b$bEnjoying the glade, I trust?','',26124),
(36257,'enUS','I don\'t know what he\'s trying to catch there, but Armand Cromwell is on the dock in the Magic Quarter.','I don\'t know what he\'s trying to catch there, but Armand Cromwell is on the dock in the Magic Quarter.',26124),
(36258,'enUS','The guild master is Christopher Drakul. He\'s on the eastern platform in the Trade Quarter.','The guild master is Christopher Drakul. He\'s on the eastern platform in the Trade Quarter.',26124),
(36259,'enUS','The guild master handles his business in the Trade Quarter. He\'s up on the eastern platform.','The guild master handles his business in the Trade Quarter. He\'s up on the eastern platform.',26124),
(36260,'enUS','The herbalist around here is Martha Alliestar. She\'s over on the inner ring of the Apothecarium.','The herbalist around here is Martha Alliestar. She\'s over on the inner ring of the Apothecarium.',26124),
(36261,'enUS','Head to the Apothecarium\'s inner ring. Martha Alliestar is there, and she\'ll instruct you in herbalism.','Head to the Apothecarium\'s inner ring. Martha Alliestar is there, and she\'ll instruct you in herbalism.',26124),
(36262,'enUS','The inn - if you can call it that - is on the upper ring of the Trade Quarter. They don\'t even have beds.','The inn - if you can call it that - is on the upper ring of the Trade Quarter. They don\'t even have beds.',26124),
(36263,'enUS','Innkeeper Norman keeps a dusty crack in the wall he calls an inn on the upper ring of the Trade Quarter.','Innkeeper Norman keeps a dusty crack in the wall he calls an inn on the upper ring of the Trade Quarter.',26124),
(36264,'enUS','The scribe of the city is in the Apothecarium, someone named Margaux Parchley.','The scribe of the city is in the Apothecarium, someone named Margaux Parchley.',26124),
(36265,'enUS','The city\'s leatherworker is in the inner ring of the Rogues\' Quarter.','The city\'s leatherworker is in the inner ring of the Rogues\' Quarter.',26124),
(36266,'enUS','Arthur Moore is the leatherworker. He tends the trainees over in the Rogues\' Quarter, on the inner ring.','Arthur Moore is the leatherworker. He tends the trainees over in the Rogues\' Quarter, on the inner ring.',26124),
(36267,'enUS','If you need keys, talk to Walter Soref in the Rogues\' Quarter, but watch yourself.','If you need keys, talk to Walter Soref in the Rogues\' Quarter, but watch yourself.',26124),
(36268,'enUS','Mages? They\'re in the Magic Quarter, in the central building. Thought you\'d be smart enough to figure that out.','Mages? They\'re in the Magic Quarter, in the central building. Thought you\'d be smart enough to figure that out.',26124),
(36269,'enUS','On the outer ring of the Magic Quarter you\'ll find a large, stepped building. That\'s where the mages hide.','On the outer ring of the Magic Quarter you\'ll find a large, stepped building. That\'s where the mages hide.',26124),
(36270,'enUS','The mailbox is in the Trade Quarter by that coffin storage closet they call an inn.','The mailbox is in the Trade Quarter by that coffin storage closet they call an inn.',26124),
(36271,'enUS','Mailbox? You want to head to the inn in the center of the city\'s upper ring. It\'s right there.','Mailbox? You want to head to the inn in the center of the city\'s upper ring. It\'s right there.',26124),
(36272,'enUS','If you want to learn to mine, talk to Brom Killian at the inner ring of the War Quarter.','If you want to learn to mine, talk to Brom Killian at the inner ring of the War Quarter.',26124),
(36273,'enUS','The miner here works in the War Quarter on the inner ring. His name\'s Brom Killian.','The miner here works in the War Quarter on the inner ring. His name\'s Brom Killian.',26124),
(36274,'enUS','If you want to find a paladin, you\'ll have to go to the Royal Quarter. There\'s some elf there who can teach you.','If you want to find a paladin, you\'ll have to go to the Royal Quarter. There\'s some elf there who can teach you.',26124),
(36275,'enUS','The priests are located on the outer ring of the War Quarter.','The priests are located on the outer ring of the War Quarter.',26124),
(36276,'enUS','Head to the War Quarter. The priests are there on the outer ring making sure no limb remains unattached for long.','Head to the War Quarter. The priests are there on the outer ring making sure no limb remains unattached for long.',26124),
(36277,'enUS','The rogues are in the Rogues\' Quarter. Simple as that. Look for them on the outer ring.','The rogues are in the Rogues\' Quarter. Simple as that. Look for them on the outer ring.',26124),
(36278,'enUS','Go to the outer ring of the Rogues\' Quarter if you want to find rogues.','Go to the outer ring of the Rogues\' Quarter if you want to find rogues.',26124),
(36279,'enUS','The skinner here is named Killian Hagey. He works in the Rogues\' Quarter on the inner ring.','The skinner here is named Killian Hagey. He works in the Rogues\' Quarter on the inner ring.',26124),
(36281,'enUS','If you want to learn how to skin things, head to the Rogues\' Quarter. The skinner has his place on the inner ring.','Us have skinning hook.  We get it from Killian Hagey who teach us how to skin kills.  You have nice skin.  You find him on inner ring of Rogues\' Quarter.',26124),
(36282,'enUS','If you really trust some undead with your pets, you can talk to Anya Maulray at the inn on the upper ring of the Trade Quarter.','If you really trust some undead with your pets, you can talk to Anya Maulray at the inn on the upper ring of the Trade Quarter.',26124),
(36283,'enUS','You can talk to Anya Maulray up by the inn on the upper ring of the Trade Quarter. I wouldn\'t recommend it, but they\'re your pets.','You can talk to Anya Maulray up by the inn on the upper ring of the Trade Quarter. I wouldn\'t recommend it, but they\'re your pets.',26124),
(36284,'enUS','The tailor here\'s Josef Gregorian. He\'s in the Magic Quarter on the inner ring.','The tailor here\'s Josef Gregorian. He\'s in the Magic Quarter on the inner ring.',26124),
(36285,'enUS','Go to the Magic Quarter and head to the inner ring. The tailor\'s there.','Go to the Magic Quarter and head to the inner ring. The tailor\'s there.',26124),
(36286,'enUS','You have guts asking me about warlocks. Go to the Magic Quarter\'s outer ring and get out of my sight.','You have guts asking me about warlocks. Go to the Magic Quarter\'s outer ring and get out of my sight.',26124),
(36287,'enUS','You\'ll find the warlocks in the Magic Quarter\'s main building, but I better not hear of any trouble that comes of this.','You\'ll find the warlocks in the Magic Quarter\'s main building, but I better not hear of any trouble that comes of this.',26124),
(36288,'enUS','The warriors are in the War Quarter, practicing on the outer ring.','The warriors are in the War Quarter, practicing on the outer ring.',26124),
(36289,'enUS','In the War Quarter is where you\'ll find the warriors. Head to the outer ring there.','In the War Quarter is where you\'ll find the warriors. Head to the outer ring there.',26124),
(36290,'enUS','If you want to learn how to wield weapons, go to Archibald on the inner ring of the War Quarter.','If you want to learn how to wield weapons, go to Archibald on the inner ring of the War Quarter.',26124),
(36291,'enUS','Good to see someone wanting to learn something useful. Head to Archibald on the inner ring of the War Quarter.','Good to see someone wanting to learn something useful. Head to Archibald on the inner ring of the War Quarter.',26124),
(36292,'enUS','I don\'t blame you for wanting to get out of here. Go up topside and head north of the ruins. The zeppelins leave from the two towers there.','I don\'t blame you for wanting to get out of here. Go up topside and head north of the ruins. The zeppelins leave from the two towers there.',26124),
(36293,'enUS','The zeppelin towers are just north of the Undercity.','The zeppelin towers are just north of the Undercity.',26124),
(36294,'enUS','Surprised to see an orc here? Don\'t be.$b$bThe forsaken need watching. If we\'d been paying closer attention from the start, maybe the Wrath Gate wouldn\'t have happened.','Surprised to see an orc here? Don\'t be.$b$bThe forsaken need watching. If we\'d been paying closer attention from the start, maybe the Wrath Gate wouldn\'t have happened.',26124),
(36295,'enUS','Hope you\'re not looking for those abominations. The apothecaries can\'t be trusted, and that means none of their little constructs patrolling the halls. We\'re here to keep things safe.','Hope you\'re not looking for those abominations. The apothecaries can\'t be trusted, and that means none of their little constructs patrolling the halls. We\'re here to keep things safe.',26124),
(36296,'enUS','Lok\'tar. Don\'t try anything suspicious around here. If these undead are going to be part of the Horde, they\'re going to mind themselves under our watch.','Lok\'tar. Don\'t try anything suspicious around here. If these undead are going to be part of the Horde, they\'re going to mind themselves under our watch.',26124),
(36297,'enUS','What\'s wrong, bonebag? Looking for someone else? I\'m all you\'ve got now, so if you want something, make it quick.','What\'s wrong, bonebag? Looking for someone else? I\'m all you\'ve got now, so if you want something, make it quick.',26124),
(36298,'enUS','Make it quick, $r.','',26124),
(36299,'enUS','I\'ve got my eye on you, Faranell.','',26124),
(36300,'enUS','No abominations protecting you. No secrecy. No plotting in the dark.','',26124),
(36301,'enUS','If you so much as spit without my permission, this place shuts down. Forcefully.','',26124),
(36302,'enUS','I assure you, overseer, the Royal Apothecary Society dearly wishes to make up for the tragic misguidance which ended so many lives.','',26124),
(36303,'enUS','We will cause you no trouble. We seek only to continue our research in peace.','',26124),
(36304,'enUS','We\'ll see about that.','',26124),
(36305,'enUS','Get that rotten nut to shut his trap!','',26124),
(36306,'enUS','Shut your face, you gibbering idiot!','Shut your face, you gibbering idiot!',26124),
(36307,'enUS','I bet you rotters thought you were pretty clever at the Wrath Gate, didn\'t you? Playtime\'s over. We\'re here to make sure you don\'t try anything.','I bet you rotters thought you were pretty clever at the Wrath Gate, didn\'t you? Playtime\'s over. We\'re here to make sure you don\'t try anything.',26124),
(36308,'enUS','I\'ll tell you what you need to know, but I don\'t have to like it. We\'re watching you and your kind.','I\'ll tell you what you need to know, but I don\'t have to like it. We\'re watching you and your kind.',26124),
(36309,'enUS','This pit stinks and I\'m surrounded by snakes, but I\'m here to do a job.$b$bEver since Putress pulled his stunt at the Wrath Gate, the Warchief doesn\'t trust these people as far as he can throw them. That\'s why we\'re here. The apothecaries can\'t do a thing without me.','',26124),
(36310,'enUS','GAH!!!!  I CAN\'T SEE IN HERE!!!!','',26124),
(36311,'enUS','Barrel smell like gunpowder...','',26124),
(36312,'enUS','This not be good...','',26124),
(36313,'enUS','Uh-oh... this gonna hurts me...','',26124),
(36314,'enUS','I gots bad feeling...','',26124),
(36315,'enUS','Get back here!  I smashes you!','',26124),
(36316,'enUS','[DND] To use my services you must have the proper certification.','[DND] To use my services you must have the proper certification.',26124),
(36317,'enUS','[DND] I have the proper certification to use the bank.','[DND] I have the proper certification to use the bank.',26124),
(36318,'enUS','[DND] Have you filled out the proper paper work and paid the appropriate fees to gain access to the bank?','[DND] Have you filled out the proper paper work and paid the appropriate fees to gain access to the bank?',26124),
(36319,'enUS','I failed to defend my people in Gilneas City.  It seems the fates have given me a second chance, $n.  I will not fail again!','',26124),
(36320,'enUS','[DND] Have you filled out the proper paper work and paid the appropriate fees to gain access to the auction house?','[DND] Have you filled out the proper paper work and paid the appropriate fees to gain access to the auction house?',26124),
(36321,'enUS','It is so nice to see the Undercity returned to the calming wheezes and gas-expulsions of the abominations. The orcs smelled far worse.','',26124),
(36322,'enUS','I have the proper certification to use the bank.','I have the proper certification to use the bank.',26124),
(36323,'enUS','You have been infected with a Paralytic Toxin!','You have been infected with a Paralytic Toxin!',26124),
(36324,'enUS','Don\'t hurt me!  I was just looking for my sisters!  I think Ashley\'s inside that house!','',26124),
(36325,'enUS','','You are scary!  I just want my mommy!',26124),
(36326,'enUS','','Are you one of the good worgen, $g mister:ma\'am;?  Did you see Cynthia hiding in the sheds outside?',26124),
(36327,'enUS','May I browse your ancient gem recipes?','May I browse your ancient gem recipes?',26124),
(36328,'enUS','Your mother\'s in the basement next door.  Get to her now!','Your mother\'s in the basement next door.  Get to her now!',26124),
(36329,'enUS','It\'s not safe here.  Go to the Allens\' basement.','It\'s not safe here.  Go to the Allens\' basement.',26124),
(36330,'enUS','What is it, $c? I\'ve got a lot to see to around here now that the demon\'s gone. Someone has to shuffle the paperwork and make sure we don\'t see another lapse like the one with Putress.$b$bLucky me.','',26124),
(36331,'enUS','Join the others inside the basement next door.  Hurry!','Join the others inside the basement next door.  Hurry!',26124),
(36332,'enUS','','Look around you, $c!$b$bIsn\'t it all just beautiful?',26124),
(36333,'enUS','','It really is you, isn\'t it?  I remember those eyes.',26124),
(36334,'enUS','How yeh doin\', $glad:lass;?','',26124),
(36335,'enUS','','You can\'t be serious!  Did you forget everything that $n did for us?  $gHe:She; stayed behind... for us!',26124),
(36336,'enUS','Give it up, Krennan.  It\'s time to put this one down.  It\'s protocol.','',26124),
(36337,'enUS','DEPRECATED','',26124),
(36338,'enUS','DEPRECATED','',26124),
(36339,'enUS','DEPRECATED','',26124),
(36340,'enUS','Tell me, Godfrey.  Those that stayed in Gilneas City so that we could live.  Were they following protocol?','',26124),
(36341,'enUS','I didn\'t think so.  Now hand me that potion, Krennan... and double the dosage.','',26124),
(36342,'enUS','DEPRECATED.','',26124),
(36343,'enUS','You can\'t be serious!  Did you forget everything that $n did for us?','',26124),
(36344,'enUS','I am not giving up on you.  I don\'t have a cure for the Curse yet... but there are treatments.  You will have control again.','',26124),
(36345,'enUS','Ooga booga!','',26124),
(36346,'enUS','Eekum Bokum!','',26124),
(36347,'enUS','Sooie nah mi juju, gobin!','',26124),
(36348,'enUS','Taronto bosch!','',26124),
(36349,'enUS','Mkay, m\'ne ta oor!','',26124),
(36350,'enUS','<Gormungan\'s voice booms deep from within, hurting your ears and reverberating in the very ground beneath your feet.>$B$BHallo, softling.$B$BYour kind dashes about, always running, never stopping. Rest with me a while.','',26124),
(36351,'enUS','I brought you something to eat.','I brought you something to eat.',26124),
(36352,'enUS','Ha - harrrum! Food? We don\'t eat squishlings, friend, not unless they aggravate us. We eat rocks and stones and earth. Though I sometimes find the crunch of bones makes a delightful seasoning.$B$B<Gormungan lifts up a boulder and, with one enormous hand, smashes the corpses you\'ve given him onto the boulder as one would put icing on a cupcake. He crunches his treat, rumbling happily.>','',26124),
(36353,'enUS','Do you know anything about azsharite?','Do you know anything about azsharite?',26124),
(36354,'enUS','Azsharite? You soft ones come up with new names for everything. What is this \"azsharite?\"','',26124),
(36355,'enUS','Those piles of blue-ish crystals we find on the ground.','Those piles of blue-ish crystals we find on the ground.',26124),
(36356,'enUS','<Gormungan\'s laugh, deep and long, rumbles the ground and causes distant rockslides.>$B$BOh - hah! Harroooo - Ha harum! Little friend, I am sorry. I suppose my kind does not pick up after ourselves as you do.','',26124),
(36357,'enUS','So the giants have been dropping the azsharite? But where does it come from?','So the giants have been dropping the azsharite? But where does it come from?',26124),
(36358,'enUS','It comes from - harum - what is your word for it? Harrrm. Let us say that my kind does not have bathrooms. Do you understand?','',26124),
(36359,'enUS','It\'s ... your droppings!? And the goblins have been running around scooping it up?','It\'s ... your droppings!? And the goblins have been running around scooping it up?',26124),
(36360,'enUS','It would seem so. You and your friends are welcome to as much as you can find. I suppose it\'s very potent. We don\'t need to go that often.','',26124),
(36361,'enUS','How often do you, uh, \"go?\"','How often do you, uh, \"go?\"',26124),
(36362,'enUS','We don\'t live our lives as quickly as you do, my mushy friend. A healthy giant eats three square meals a decade, although I am known to indulge in a snack every couple of years. We\'ll go to the bathroom every 15 to 25 years... barring any tummy trouble.','',26124),
(36363,'enUS','15 to 25 years? Assistant Greely isn\'t going to want to hear that!','15 to 25 years? Assistant Greely isn\'t going to want to hear that!',26124),
(36364,'enUS','<Gormungan emits a good-natured snort.>$B$BHaaarrum! I have never had my personal habits scrutinized so. Your kind never ceases to surprise me. Farewell, friend, and good luck with ... whatever it is you are on about.','',26124),
(36365,'enUS','Tell me again about Azsharite?','Tell me again about Azsharite?',26124),
(36366,'enUS','Got one!','Over here!',26124),
(36367,'enUS','Snagged one!','Takedown!',26124),
(36368,'enUS','Zap \'em!','Zap \'em!',26124),
(36369,'enUS','','No offense, babe, but Chip is my boyfriend and I\'m working for the Trade Prince now.$B$BMove along, would ya? You\'re blocking my view.',26124),
(36370,'enUS','','Yeah? Whadya want?',26124),
(36371,'enUS','Listen, $n, I can\'t be seen talking with you. You\'re not exactly at the top of the Trade Prince\'s list these days and I need to think about my future.$B$BYou understand, right, babe? Besides, I\'m with Candy now.','',26124),
(36372,'enUS','Move along, bub.','',26124),
(36373,'enUS','My house!','',26124),
(36374,'enUS','<The trade prince lowers his voice to barely a whisper.>$B$BDon\'t think for a moment that I\'ve forgotten how much I despise you, $n, rescue or not.$B$BDon\'t worry your $g simple : pretty; head. I\'ll get my revenge soon enough, mark my words!$B$BYou\'ll fare far worse than being my slave. There\'ll be no escape for you this time.','',26124),
(36375,'enUS','','Barely a scratch on you! Way to go!',26124),
(36376,'enUS','Marvelous! You bound ahead with more haste than a flame-laden kitten. Quite suitable indeed!','',26124),
(36377,'enUS','Oh, I think we all know who\'s really responsible for the mess we\'re in! Don\'t worry, I\'m going to see to it that $n gets what $g he : she; deserves!','',26124),
(36379,'enUS','Nobody panic! I\'ll see to it we get off of this deplorable island. You\'ll see... I\'ve got it all planned out!','',26124),
(36380,'enUS','Never fear, Trade Prince Gallywix is here. We\'ll be on our way to our new home in Azshara before you know it! Despite the bumbling interference of $n.','',26124),
(36381,'enUS','I can\'t help but think that if it weren\'t for the meddling of $n back on Kezan, we\'d all be safe and sound in Azshara by now.','',26124),
(36382,'enUS','I\'ve got my eye on you, $n. Let\'s just say that only one of us will be leaving this island, and that goblin\'s name begins with Trade Prince!','',26124),
(36383,'enUS','You thought to take my place on Kezan, $n? You reach too far! I made you what you were... were being the operative word. You\'re nothing now. Nothing!','',26124),
(36384,'enUS','I want you all to listen good... anyone who\'s not with me can start looking for a new job!','',26124),
(36385,'enUS','No worries, everyone. This is just a short pit stop on our way to our new home.','',26124),
(36386,'enUS','We owe you a debt that will be hard to repay, $n.','',26124),
(36387,'enUS','','Thank you for freeing Thrall, $n. He\'s been missed.$B$B<Aggra looks over at the Warchief.>',26124),
(36388,'enUS','Return to the battle in Shok\'Thokar or the centaur will abandon you!','',26124),
(36389,'enUS','I swear this line\'s not moving!','I swear this line\'s not moving!',26124),
(36390,'enUS','What\'s the hold up?','What\'s the hold up?',26124),
(36391,'enUS','Time is money, friend!','Time is money, friend!',26124),
(36392,'enUS','Is that a volcano over on that other island?','Is that a volcano over on that other island?',26124),
(36393,'enUS','That rocket looks unsafe even by our standards!','That rocket looks unsafe even by our standards!',26124),
(36394,'enUS','Why are we rocketing over to an island that has a volcano? Didn\'t we barely survive this scenario on Kezan?','Why are we rocketing over to an island that has a volcano? Didn\'t we barely survive this scenario on Kezan?',26124),
(36395,'enUS','By the looks of that thing, I might take my chances swimming with the sharks!','By the looks of that thing, I might take my chances swimming with the sharks!',26124),
(36396,'enUS','I knew I should have brought my folding chair.','I knew I should have brought my folding chair.',26124),
(36397,'enUS','Hallo again, soft little friend. What\'s that you have there?','',26124),
(36398,'enUS','Hey, $g bro : lady;. Rocket ride! Yeah!','',26124),
(36399,'enUS','Here, eat this! It\'s a special chocolate rock.','Here, eat this! It\'s a special chocolate rock.',26124),
(36400,'enUS','','Oh, $n, you\'ve saved us again! Thank you for getting rid of those evil humans before they could get us!',26124),
(36401,'enUS','<Gormungan eyes the laxative with suspicion, then sniffs it. With visible irritation, he begins smooshing and molding the laxative into the shape of a goblin.>$B$BI suspect your little green friends are putting you up to no good. Please explain to them that we giants are not to be toyed with.$B$B<To demonstrate his point, Gormungan twists the head off of his chocolaty goblin statue before handing it back to you.>','',26124),
(36402,'enUS','Pentigast! Bring the new $r up to speed, would you?','',26124),
(36403,'enUS','Always good to see you, friend!','',26124),
(36404,'enUS','','Grapplehammer relies on me to get things done. A mind like his needs to be free of distractions.',26124),
(36405,'enUS','','Are you ready to be shrunkified? This may sting a little. And burn. The agony and convulsions will pass quickly, however.',26124),
(36406,'enUS','I\'m ready. Shrink me!','I\'m ready. Shrink me!',26124),
(36407,'enUS','','Move fast, $n! You\'ll revert to regular-size in just a couple of minutes.',26124),
(36408,'enUS','I have to aim for the Forsaken ships.','I have to aim for the Forsaken ships.',26124),
(36409,'enUS','Hum - Wha?','',26124),
(36410,'enUS','SQUEAK!!','SQUEAK!!',26124),
(36411,'enUS','<The enormous giant peers down at your tiny form.>$B$B$n, did you change your hair?','',26124),
(36412,'enUS','%s casts Meteor Fists!','',26124),
(36413,'enUS','Steady yourself, friend...$b$bThese next hours shall determine the fate of our clans.','',26124),
(36414,'enUS','I am ready! I want to join in the battle!','I am ready! I want to join in the battle!',26124),
(36415,'enUS','Sons of Cenarion, UNITE!','',26124),
(36416,'enUS','Voctory is ours, $n!','',26124),
(36417,'enUS','Thank you... *gasp*   I owe you my life.','Thank you... *gasp*   I owe you my life.',26124),
(36418,'enUS','I... I thought I was a goner.  Thanks.','I... I thought I was a goner.  Thanks.',26124),
(36419,'enUS','The land gave way from under our feet...  I thought I was dead.  I owe you one.','The land gave way from under our feet...  I thought I was dead.  I owe you one.',26124),
(36420,'enUS','I\'ll be taking this cat.  It seems to work as the perfect bait.  Prepare to die now, fool!','',26124),
(36421,'enUS','','You do not mess with my kitty you son of a mongrel!',26124),
(36422,'enUS','Lovely outfit. Dressed for the part!','',26124),
(36423,'enUS','I\'m ready to begin my trials.','I\'m ready to begin my trials.',26124),
(36424,'enUS','EeeeEEEEEEKK!','',26124),
(36425,'enUS','Oh, $n, it was just you. Please don\'t scare me like that.','',26124),
(36426,'enUS','<A hand-lettered sign reads:>$B$B          Secret Lab Archives$B     X. Nizzlebex, Lab Director$B$B$BPlease ring buzzer for service.','',26124),
(36427,'enUS','<Ring the Buzzer>','<Ring the Buzzer>',26124),
(36428,'enUS','Sentinel, I would speak with your High Priestess.','',26124),
(36429,'enUS','Must I? I doubt Tyrande has more pressing business.','',26124),
(36430,'enUS','The lure of power is great. Mistakes were made.','',26124),
(36431,'enUS','I will not return until I am heard. There is too much at stake.','',26124),
(36432,'enUS','There is change on the wind, and we cannot ignore it. I have traveled from the dust and ruin of the past to come to an accord.','',26124),
(36433,'enUS','The time may soon come when the kaldorei require the knowledge and skill we have to offer.','',26124),
(36434,'enUS','I will wait, Sentinel... but I will have my audience.','',26124),
(36435,'enUS','Calm yourself, Sentinel. I do not seek to use it. I am merely... remembering.','',26124),
(36436,'enUS','Enough. I have been apart from this for centuries. The well within this temple may be a pale spectre of the Well of Eternity, but it still holds the same... beauty. Purity.','',26124),
(36437,'enUS','I had forgotten.','',26124),
(36438,'enUS','I do not believe admiration and wistful thoughts are against the societal norm.','',26124),
(36439,'enUS','You were the one who challenged me for merely looking. I still await my audience with Tyrande.','',26124),
(36440,'enUS','%s looks over at the moonwell with a sigh.','',26124),
(36441,'enUS','We stand united as sons of Cenarion, thanks to you.$b$bYour deeds here shall live on as long as our clans draw breath, $n!','',26124),
(36442,'enUS','Never again shall we allow our differences to divide us.$b$bLong live the children of Cenarion!','',26124),
(36443,'enUS','May the blessings of Cenarion rain down upon you as it has this land, $r.','',26124),
(36444,'enUS','Garfrost tired of puny mortals. Now your bones will freeze!','',26124),
(36445,'enUS','Axe too weak. Garfrost make better and CRUSH YOU.','',26124),
(36446,'enUS','','You must wait for an audience.',26124),
(36447,'enUS','','You show some nerve coming to Teldrassil, Highborne. Your kind are unwelcome here. We have not forgotten the War of the Ancients or the minds behind it.',26124),
(36448,'enUS','','And we would not see those mistakes repeated. Return to your exile.',26124),
(36449,'enUS','','Take your gaze off the moonwell, exile. The power within is not yours to wield.',26124),
(36450,'enUS','','Recalling your treachery?',26124),
(36451,'enUS','','Watch yourself, Highborne.',26124),
(36452,'enUS','','In good time.',26124),
(36453,'enUS','Hey there, $n. I know, it\'s not much, but the trade prince\'s wreck is home for now.','',26124),
(36454,'enUS','','Greetings, $r. Please do not alarm yourself. I am indeed speaking to you in your native tongue.$B$BMy own considerable raptor intelligence has been augmented through a series of experiments. You may refer to me as \"Subject Nine,\" an identity recently bestowed to me by my creators, who are otherwise at the moment occupied or deceased. Perhaps you can render me some assistance?',26124),
(36455,'enUS','','With the benefit of my improved cognitive capacity, I am able to turn fresh eyes upon the rest of my race. A majority of our energies were spent in the hunt of fresh prey. Why, I wonder, did we not invest that time developing a store of domesticated creatures from which to draw our food supply?$B$BI am naturally inclined to think that humans would make excellent foodstock. They breed quickly, fatten up nicely, and can be trained to do menial chores for the herd until harvest time. Hmmm.',26124),
(36456,'enUS','I suppose I should not be surprised at this cold reception. We have long been in hiding, and the separation from our brethren was necessary.$b$bThat time, however, is done. Whether the residents of this young tree come to accept us or not, the Highborne are returning to light, and we will not turn our backs on what we are.','',26124),
(36457,'enUS','Is this really a good idea?','',26124),
(36458,'enUS','Up, Up & Away!','Up, Up & Away!',26124),
(36459,'enUS','My brothers and I can reach northern Gilneas by boat in a matter of days.  As soon as we finish the repairs, that is.','',26124),
(36460,'enUS','You think you\'re such a bigshot, saving everyone and making friends with these orc savages?!','',26124),
(36461,'enUS','I\'m gonna crush you! I\'m the Trade Prince! Me! I gotta plan that\'s gonna get me off of this island and make me the king of Azshara!','',26124),
(36462,'enUS','Mark my words! I\'m gonna get you, $n! I\'ll get you all! Out of my way!','',26124),
(36463,'enUS','Tuskarr Kite','Tuskarr Kite',26124),
(36464,'enUS','Mini-Mount','Mini-Mount',26124),
(36465,'enUS','Mini-Mount','Mini-Mount',26124),
(36466,'enUS','Spectral Tiger Cub','Spectral Tiger Cub',26124),
(36467,'enUS','Scourgewar','Scourgewar',26124),
(36468,'enUS','Oh, pay no attention to me. I\'m just a messenger. The leader of the Deathstalkers certainly wouldn\'t be stupid enough to stand here on the dais waiting to be gutted. No need for history to repeat itself.','',26124),
(36469,'enUS','Out of the frying pan and into the fire, eh $n?','',26124),
(36470,'enUS','Out of the frying pan and into the fire, eh $n? Need any training?','',26124),
(36471,'enUS','I\'ve been patient up to this point, but if they don\'t get that rocket sling working soon, I\'m going to shadow bolt someone!','',26124),
(36472,'enUS','I\'ve been patient up to this point, but if they don\'t get that rocket sling working soon, I\'m going to shadow bolt someone!$B$BNeed some training, $n?','',26124),
(36473,'enUS','I saw Dampwick ride across on that thing. I\'d rather use a Slow Fall spell, but I don\'t know that one yet.','',26124),
(36474,'enUS','I saw Dampwick ride across on that thing. I\'d rather use a Slow Fall spell, but I don\'t know that one yet.$B$BWant some training, $n?','',26124),
(36475,'enUS','Good job, $n! Isn\'t this all very exciting? I wonder what the next island will be like?','',26124),
(36476,'enUS','Good job, $n! Isn\'t this all very exciting? I wonder what the next island will be like?$B$BCan I teach you anything new?','',26124),
(36477,'enUS','','Sounds like you\'ve had quite the adventure, $n. There must have been plenty of moolah on those Alliance creeps.',26124),
(36478,'enUS','','Sounds like you\'ve had quite the adventure, $n. There must have been plenty of moolah on those Alliance creeps.$B$BWant to purchase some training?',26124),
(36479,'enUS','','Hey there, $n. I for one am glad to be away from those damned monkeys!',26124),
(36480,'enUS','','Hey there, $n. I for one am glad to be away from those darned monkeys!$B$BSo, want to hone your skills with a little training?',26124),
(36481,'enUS','Warrior-Matic NX-01 is currently offline.','',26124),
(36482,'enUS','Warrior-Matic NX-01 online.$B$BPlease insert coins for training.','',26124),
(36483,'enUS','Summoned by a fumbling $r? Unbelievable. Desperate or stupid, this will be your final mistake.','',26124),
(36484,'enUS','%s takes a drink of his brew and jitters uncontrollably for a few moments.','',26124),
(36485,'enUS','That\'s the stuff! All awake now. Tasty!','',26124),
(36486,'enUS','','I would like to reiterate how pleased I am with the continued development of our working relationship, $n. In the weeks following my stunning cognitive enhancement, my goblin benefactors became apprehensive, perhaps outright distrustful, as my intellect eclipsed theirs.$B$BWhat a shame that my progenitors were unable to prevent this recent cascading series of industrial \'accidents\' that now allows me to operate so unencumbered...',26124),
(36487,'enUS','','My sweet, adorable progeny!',26124),
(36488,'enUS','%s\'s wounds begin to heal.','',26124),
(36489,'enUS','','Farewell, Azeroth. I leave behind a world steeped in filth and wracked by cataclysm.',26124),
(36490,'enUS','','Let\'s light this candle!',26124),
(36491,'enUS','Your miniscule intellect is no match for my superior claws!','',26124),
(36492,'enUS','Ah, fresh sustenance!','',26124),
(36493,'enUS','First you, $r. Tomorrow: the world!','',26124),
(36494,'enUS','','Did you hear that, Clubnik? Those that died defending Lake Mennar are heroes. Their selfless actions may have even saved this entire world! A memorial should be erected.',26124),
(36495,'enUS','','Clubnik? I hope you die. In a fire.',26124),
(36496,'enUS','Sure I hear ya.','',26124),
(36497,'enUS','Howsabout a ... Memorial  Fuel Depot?','',26124),
(36498,'enUS','It\'ll be very tasteful!','',26124),
(36499,'enUS','Silence, fool!','',26124),
(36500,'enUS','I pity the fool!','',26124),
(36501,'enUS','Do not anger me!','',26124),
(36502,'enUS','%s makes a heavy snort as he sniffs and nibbles at Sorata\'s clothes.','',26124),
(36503,'enUS','Praise to the Light, $gbrother:sister; $n! Let\'s take a look here...','',26124),
(36504,'enUS','Well, there\'s your problem! You have what we call a ghost in the machine.','',26124),
(36505,'enUS','This calls for an old-fashioned bulldozer exorcism! Give me a hand if she gets uppity, will ya?','',26124),
(36506,'enUS','Whoa! We got a live one here!','',26124),
(36507,'enUS','I cast you out! Unclean spirit - Begone!','',26124),
(36508,'enUS','The power tools compel you! The power tools compel you!','',26124),
(36509,'enUS','I cleanse thee with holy fire!','',26124),
(36510,'enUS','Die, goblin!','Die, goblin!',26124),
(36511,'enUS','Terrific! That went down nice and clean.','',26124),
(36512,'enUS','Let Clubnik know that the priesthood will be sending him a bill. For the Light!','',26124),
(36513,'enUS','Hmmm, once again I\'ve forgotten who I am and what I\'m doing here. Call me back if anything comes up.','',26124),
(36514,'enUS','I uh - I could use a little help here?','',26124),
(36515,'enUS','GASP, THIS IS A TEST','',26124),
(36516,'enUS','You\'ll want to look in the Undercity.  In the old Ruins of Lordaeron, south of here, you\'ll find an elevator down. Once you\'re there, ask an Undercity Guardian for further directions.','You\'ll want to look in the Undercity.  In the old Ruins of Lordaeron, south of here, you\'ll find an elevator down. Once you\'re there, ask an Undercity Guardian for further directions.',26124),
(36517,'enUS','Use your Infrared Heat Focals!','',26124),
(36518,'enUS','You need to get to the cliffs and Scout Brax, $n.','',26124),
(36519,'enUS','I need to borrow your tamed jungle cat to get to the cliffs, Kilag.','I need to borrow your tamed jungle cat to get to the cliffs, Kilag.',26124),
(36520,'enUS','Refresh my memory on the whole kaja\'mite thing.','Refresh my memory on the whole kaja\'mite thing.',26124),
(36521,'enUS','Kaja\'mite... you know, the stuff that legend holds helped the entire goblin race to evolve into the ultimate masters of alchemy and engineering?!$B$BIt\'s the stuff that helped us to overthrow our jungle troll oppressors, to take control of Kezan -- may she rest in peace -- and is the most valuable ore in all of existence!$B$BHey, you don\'t think that it\'s having any effect on those monkeys do you?','',26124),
(36522,'enUS','The ruins scattered throughout this area are remnants of the night elven civilization at its former peak. They are a treasure trove of information for those who study the arcane.$B$BAnd it would seem they have attracted the attention of a most unusual group of night elven mages. Yes, you heard me $r - night elves are trying to reclaim their magical heritage! I would find it amusing but for the terrible potential should they discover anything of value here.','',26124),
(36523,'enUS','Night elven mages. Pah!','',26124),
(36524,'enUS','More souls to power the engine!','',26124),
(36525,'enUS','My soul for you, master.','',26124),
(36526,'enUS','The vortex of the harvested calls to you!','',26124),
(36527,'enUS','<The \"voice\" of the construct seems to emanate from the air around you, ringing in your ears while the hairs on your arms stand up. The construct speaks to you in a language you can\'t understand, with words that sound like multiple voices talking at once.>','',26124),
(36528,'enUS','Um... Al\'teth ... la c\'tolgar? Or something.','Um... Al\'teth ... la c\'tolgar? Or something.',26124),
(36529,'enUS','%s is chasing you. Run!','',26124),
(36530,'enUS','%s is chasing $n.','',26124),
(36531,'enUS','%s begins to unleash a toxic poison cloud!','',26124),
(36532,'enUS','My flesh!','My flesh!',26124),
(36533,'enUS','Aaiiiiieee!','Aaiiiiieee!',26124),
(36534,'enUS','My eyes - auuugh!','My eyes - auuugh!',26124),
(36535,'enUS','The %s surges with uncontrolled arcane energies.','',26124),
(36536,'enUS','No, that one! That one! Get that one!','',26124),
(36537,'enUS','Quickly! Poison them all while they\'re still close!','',26124),
(36538,'enUS','Enough moving around! Hold still while I blow them all up!','',26124),
(36539,'enUS','Look out - it\'s loose...','Look out - it\'s loose...',26124),
(36540,'enUS','What is that $r doing here!?','What is that $r doing here!?',26124),
(36541,'enUS','How do we stop it?','How do we stop it?',26124),
(36542,'enUS','%s takes in a deep breath...','',26124),
(36543,'enUS','Gizmo, what are you doing just sitting there? Don\'t you recognize who that is laying next to you?!','',26124),
(36544,'enUS','That\'s $n! $G He\'s : She\'s; the whole reason we\'re still breathing and not crispy fried critters back on Kezan.','',26124),
(36545,'enUS','Stay back, I\'m going to resuscitate $g him : her;! I hope these wet jumper cables don\'t kill us all!','',26124),
(36546,'enUS','Come on! Clear!','',26124),
(36547,'enUS','That\'s all I\'ve got. It\'s up to $g him : her; now. You hear me, $n? Come on, snap out of it! Don\'t go into the Light!','',26124),
(36548,'enUS','You made the right choice. We all owe you a great deal, $n. Try not to get yourself killed out here.','',26124),
(36549,'enUS','There are more survivors to tend to. I\'ll see you on the shore.','',26124),
(36550,'enUS','%s begins rapidly conjuring explosive mines!','',26124),
(36551,'enUS','$n, my $g boy : girl;!$B$BWant me to teach you any of my thermal palms healing techniques?$B$BNo? How about bandages? Do you want to learn about bandages?','',26124),
(36552,'enUS','Har! You look uglier than usual, $n!','',26124),
(36553,'enUS','%s creates a whirling storm of bone!','',26124),
(36554,'enUS','BONE STORM!','',26124),
(36555,'enUS','That\'s a primitive disguise spell, $r, but it should suffice.','',26124),
(36556,'enUS','No hard feelings, $n.  You might be a feral killing machine, but it looks like you\'re with us for now.','',26124),
(36557,'enUS','We have been betrayed!','',26124),
(36558,'enUS','I will see you up top, $n. Thank you again for my freedom!','',26124),
(36559,'enUS','Get out of my sight! The Blackmaw want nothing to do with you, $r.','',26124),
(36560,'enUS','Welcome, ally. We have much to discuss.$B$BThe beasts you call the \"Horde\" ravage these woods. Their terrible stone ribbon slices through our land, frightens the animals we hunt, and fills the air with noise and ash.$B$BTell me, friend. How can we Blackmaw join this \"Alliance\" of yours?','',26124),
(36561,'enUS','Not so fast, bearface. First I need a foot-rub.','Not so fast, bearface. First I need a foot-rub.',26124),
(36562,'enUS','What tactic is this that you come into my home and start barking demands of my people?','',26124),
(36563,'enUS','What\'s that smell? Is that you? Seriously.','What\'s that smell? Is that you? Seriously.',26124),
(36564,'enUS','What? We negotiate in good faith and you come to me with insults?','',26124),
(36565,'enUS','The Alliance demands a delivery of fresh baby with each new moon for our infant labor camps.','The Alliance demands a delivery of fresh baby with each new moon for our infant labor camps.',26124),
(36566,'enUS','Haggrum\'s plan to infiltrate Blackmaw Hold is an ambitious one. Quite duplicitous, actually, for an orc. Put on that enchanted disguise before I teleport you over there.','',26124),
(36567,'enUS','The magic that makes that disguise possible will hold up only a few minutes. I will teleport you directly into the heart of Blackmaw Hold. Enter into negotiations with their Chieftain immediately... and be prepared to fight your way out.','',26124),
(36568,'enUS','I am ready. Teleport me to Blackmaw Hold.','I am ready. Teleport me to Blackmaw Hold.',26124),
(36569,'enUS','Poor $n. You\'ve sent $ghim:her; on a suicide mission, Haggrum.','',26124),
(36570,'enUS','You\'d better get used to it, jerkyloins. The Alliance primarily views you as pets. Do you do tricks?','You\'d better get used to it, jerkyloins. The Alliance primarily views you as pets. Do you do tricks?',26124),
(36571,'enUS','Shut it, hair-vomit! Soon you will learn to submit to your gnomish overlords!!','Shut it, hair-vomit! Soon you will learn to submit to your gnomish overlords!!',26124),
(36572,'enUS','Your tone enrages me, outsider. If this is what we can expect from your so-called \"Alliance,\" we will have no part in it!','',26124),
(36573,'enUS','You will have no choice once your people are enslaved by the jackbooted Alliance death squads!','You will have no choice once your people are enslaved by the jackbooted Alliance death squads!',26124),
(36574,'enUS','You keep talking, but all I hear is \"Blah blah my people bathe in our own filth.\"','You keep talking, but all I hear is \"Blah blah my people bathe in our own filth.\"',26124),
(36575,'enUS','<Yank out his belly piercing.>','<Yank out his belly piercing.>',26124),
(36576,'enUS','Warriors - the Alliance filth have betrayed us! Slay them!','',26124),
(36577,'enUS','That\'s $n?! Sorry, Doc, I thought $g he : she; was dead!','',26124),
(36578,'enUS','I remember when my brother and I would camp alone in the Azshara wilderness. Look at it now. ','',26124),
(36579,'enUS','So... cold...','',26124),
(36580,'enUS','Argh!','',26124),
(36581,'enUS','This is impossible!','',26124),
(36582,'enUS','This Xylem guy is a jerk.','',26124),
(36583,'enUS','Why did I sign up for this?','',26124),
(36584,'enUS','You have to be kidding me...','',26124),
(36585,'enUS','By the Light!  This must be the end of the world!','By the Light!  This must be the end of the world!',26124),
(36586,'enUS','Will these earthquakes ever stop?','Will these earthquakes ever stop?',26124),
(36587,'enUS','What have we done to deserve this?','What have we done to deserve this?',26124),
(36588,'enUS','Oh, no.  Not another one!','Oh, no.  Not another one!',26124),
(36589,'enUS','The end is upon us!','The end is upon us!',26124),
(36590,'enUS','We should not let those who bear the Curse walk among us.  It\'s just not right.','',26124),
(36591,'enUS','Watch your back, $n.  If you weren\'t Krennan\'s pet you would\'ve died a long time ago.','',26124),
(36592,'enUS','The worgen killed my parents, $n.  Watch yourself.','',26124),
(36593,'enUS','','It really is good to see you again, $n.  Fur and all.',26124),
(36594,'enUS','Thank you, $r. Your endurance and dedication to the preservation of your race has inspired your people and your friends.  Allow me to thank you with the presentation of this reward.  Raise your hand and accept your prize, $n!','',26124),
(36595,'enUS','You just won a video card!!','',26124),
(36596,'enUS','Breath, damn it!','',26124),
(36598,'enUS','Detonating','Detonating',26124),
(36599,'enUS','My ribs are broken.','',26124),
(36600,'enUS','Throm-Ka, goblin!','',26124),
(36601,'enUS','Aka\'Magosh, goblin!','',26124),
(36602,'enUS','Lok\'tar!','',26124),
(36603,'enUS','I give you thanks for my life.','',26124),
(36604,'enUS','Lok-Regar, Kilag!','',26124),
(36605,'enUS','Keep your sights straight, $n.','',26124),
(36606,'enUS','You need something, $c?','',26124),
(36607,'enUS','Did you see that?','Did you see that?',26124),
(36608,'enUS','Did... did you see that?','Did... did you see that?',26124),
(36609,'enUS','Did... did that just happen?','Did... did that just happen?',26124),
(36610,'enUS','No... it can\'t be.','No... it can\'t be.',26124),
(36611,'enUS','Curse this land.  We can\'t stay here.','Curse this land.  We can\'t stay here.',26124),
(36612,'enUS','Don\'t shoot! Let \'em burn!','',26124),
(36613,'enUS','Are we just going to let $ghim:her; through?','',26124),
(36614,'enUS','$gHe\'s:She\'s; one of Krennan\'s -- King\'s orders.  Besides, it looks like we have bigger problems coming our way.','',26124),
(36615,'enUS','Even if this potion works... we can\'t just have worgen running around our town, Krennan.','',26124),
(36616,'enUS','Even if this potion works...  we just can\'t have worgen running amok in our town, Krennan.','',26124),
(36617,'enUS','Do exercise caution.  Don\'t expect anyone to invite you to their homes just yet.  But at least they won\'t shoot you outright.','',26124),
(36618,'enUS','','Welcome back, $n.  You were fortunate.  Krennan\'s treatment doesn\'t always work this well on people who\'ve had the Curse as long as you.',26124),
(36619,'enUS','Not bad for a goblin.','',26124),
(36620,'enUS','What was that $c trick you did during the fight?','',26124),
(36621,'enUS','These humans are cowards. You hear me HUMANS? Come out and fight with honor!','',26124),
(36622,'enUS','I thought that goblins were only good for selling trinkets and blowing themselves up.','',26124),
(36623,'enUS','Did you hear that? Have a look around, $n, to see if any are trying to sneak up on us.','',26124),
(36624,'enUS','So tell me, goblin, why did your slave ship wander through our battle?','',26124),
(36625,'enUS','You thought to kill me, puny human? This tiny goblin has more courage than your pathetic race!','',26124),
(36626,'enUS','So what else do you have in that belt?','',26124),
(36627,'enUS','Ahaha! You\'re gonna love this stuff!','',26124),
(36628,'enUS','%s roars and swells with dark might!','',26124),
(36629,'enUS','Many changes are occuring here, young one.  Do not fret if you see anything out of place...such as me.  Moo.','',26124),
(36630,'enUS','Protect the Captain!','',26124),
(36631,'enUS','Hold your ground, men.','',26124),
(36632,'enUS','Hold your positions, men!','',26124),
(36633,'enUS','','What\'s happening?!',26124),
(36634,'enUS','Get on, quickly! We cannot not that drake escape!','',26124),
(36635,'enUS','','Can I provide you with anything, $n?',26124),
(36636,'enUS','Can I interest you in a new weapon, $c?','',26124),
(36637,'enUS','What do you know of ancient swords?','What do you know of ancient swords?',26124),
(36638,'enUS','I witnessed the handiwork of our new goblin allies when I was stranded in the Lost Isles. But now we put their ingenuity to the test: here we face down our foes in their own stronghold.','',26124),
(36639,'enUS','There are some who do not believe in the legendary Night Elf Mohawks.$B$BI pity the fools.','',26124),
(36640,'enUS','I believe in you.','I believe in you.',26124),
(36641,'enUS','','Follow my lead, $n!',26124),
(36642,'enUS','Well met, fellow Mohawk $GBrother:Sister;.','',26124),
(36643,'enUS','','Don\'t give away our position, $n! That tower is crawling with bodyguards.',26124),
(36644,'enUS','I\'m ready, Slinky. Let\'s do this.','I\'m ready, Slinky. Let\'s do this.',26124),
(36645,'enUS','','Grab the Captain\'s head - I\'m arming the explosives. ',26124),
(36646,'enUS','','Okay, this place is set to blow. Let\'s get out of here!',26124),
(36647,'enUS','','Hop on!',26124),
(36648,'enUS','Rimefang, destroy this fool!','',26124),
(36649,'enUS','The frostwyrm Rimefang gazes at $n and readies an icy attack!','',26124),
(36650,'enUS','You can only ride the Mountain Horse in the Crowley Stable Grounds and the Crowley Orchard.','',26124),
(36651,'enUS','Due to the, ah, \"misunderstanding\" in Dragonblight, we\'ve had to relocate our facilities to this decrepit mess of a castle.$B$BStill, we\'ve now plenty of space and time to work on various new and lovely... products...','',26124),
(36652,'enUS','Begin the battle.','Begin the battle.',26124),
(36653,'enUS','Arming','Arming',26124),
(36654,'enUS','Hear my words, $c!','',26124),
(36655,'enUS','','',26124),
(36656,'enUS','Guards! They\'re up to something at the base of the tower. Stop them!','',26124),
(36657,'enUS','I am ready.  However, I\'d like to skip the pageantry.','I am ready.  However, I\'d like to skip the pageantry.',26124),
(36658,'enUS','%s begins to cast Wailing Souls!','',26124),
(36659,'enUS','%s begins to |cFFFF0000Unleash Souls!|r','',26124),
(36660,'enUS','Azeroth has been assaulted from forces beyond this plane of existence...','',26124),
(36661,'enUS','From her depths she cries out for aid, but few can hear her pleas.','',26124),
(36662,'enUS','I hear them, $r. Allow me to translate...','',26124),
(36663,'enUS','Take up the sword and defeat the enemy of our world.','',26124),
(36664,'enUS','[ph] Foolish creatures, your pithy complaints mean nothing before the will of the Lich King. You will serve him, even beyond death!','',26124),
(36665,'enUS','[ph] Enough of your miserable complaints. You WILL carry on. These miserable dogs shall serve the Lich King, even beyond death!','',26124),
(36666,'enUS','[ph] Now your skeletons shall labor for all of eternity... wait... intruders? Here?! Dispose of them immediately!','',26124),
(36667,'enUS','[ph] Please, I cannot labor any longer! Spare us for just a few minutes!','[ph] Please, I cannot labor any longer! Spare us for just a few minutes!',26124),
(36668,'enUS','Fail and she shall perish, and we with her!','',26124),
(36669,'enUS','','Great blessings be upon you, good $r.',26124),
(36670,'enUS','The first challenge requires you to be mounted on an Argent Battleworg.  You will find these mounts along the walls of this coliseum.$b$bPlease, mount the battleworg, speak to me, and then we can proceed.','',26124),
(36671,'enUS','Find some cover!','',26124),
(36672,'enUS','Spread out!','',26124),
(36673,'enUS','Get in positions.','',26124),
(36674,'enUS','Squad, move.','',26124),
(36675,'enUS','Get out of the open.','',26124),
(36676,'enUS','Squad, you know what to do.','',26124),
(36677,'enUS','Find some flanking positions.','',26124),
(36678,'enUS','Move out.','',26124),
(36679,'enUS','We\'ve got a live one.','',26124),
(36680,'enUS','Target sighted.','',26124),
(36681,'enUS','12 o\'clock.','',26124),
(36682,'enUS','Spotted.','',26124),
(36683,'enUS','','Hostile ahead.',26124),
(36684,'enUS','','Enemy here.',26124),
(36685,'enUS','Messy.','',26124),
(36686,'enUS','BOOM!','',26124),
(36687,'enUS','Anyone up for a barbeque?','',26124),
(36688,'enUS','Turnin\' up the heat!','',26124),
(36689,'enUS','Medic!','Medic!',26124),
(36690,'enUS','Gob Squad reporting.','',26124),
(36691,'enUS','We\'ve got your back.','',26124),
(36692,'enUS','Lead the way.','',26124),
(36693,'enUS','Awaiting your orders.','',26124),
(36694,'enUS','Hostile down.','',26124),
(36695,'enUS','That\'s for looking at me funny.','',26124),
(36696,'enUS','Roasted.','',26124),
(36697,'enUS','I\'m melting... melting!','',26124),
(36698,'enUS','','Target down.',26124),
(36699,'enUS','','By a girl. Ouch.',26124),
(36700,'enUS','Meatbag spotted.','',26124),
(36701,'enUS','Incoming.','',26124),
(36702,'enUS','Enemy down.','',26124),
(36703,'enUS','Headshot!','',26124),
(36704,'enUS','I\'ve little more than a cursory knowledge of magical artifacts, and the blue flight has enough troubles of its own.$B$BThere was a book in the library about the blades we forged for our mortal allies, but I\'m afraid I\'ve already loaned it to a representative of the Sunreavers. You\'re not the first person to come asking after information on those ancient swords, $n.','',26124),
(36705,'enUS','I\'ve little more than a cursory knowledge of magical artifacts, and the blue flight has enough troubles of its own.$B$BThere was a book in the library about the blades we forged for our mortal allies, but I\'m afraid I\'ve already loaned it to a representative of the Silver Covenant. You\'re not the first person to come asking after information on those ancient swords, $n.','',26124),
(36706,'enUS','%s releases Gas Spores!','',26124),
(36707,'enUS','%s begins to cast |cFFFF7F00Pungent Blight!|r','',26124),
(36708,'enUS','Your pursuit shall be in vain, intruders, for the Lich King has placed an army of undead at my command! Behold!','Your pursuit shall be in vain, intruders, for the Lich King has placed an army of undead at my command! Behold!',26124),
(36709,'enUS','Persistent whelps! You will not reach the entrance of my lord\'s lair! Soldiers, destroy them!','Persistent whelps! You will not reach the entrance of my lord\'s lair! Soldiers, destroy them!',26124),
(36710,'enUS','On it.','',26124),
(36711,'enUS','Almost done.','',26124),
(36712,'enUS','It\'s set. Get clear!','',26124),
(36713,'enUS','Ticker, blow this thing.','',26124),
(36714,'enUS','Rimefang, trap them within the tunnel! BURY THEM ALIVE!','Rimefang, trap them within the tunnel! BURY THEM ALIVE!',26124),
(36715,'enUS','The spirit is displeased and attacks!','',26124),
(36716,'enUS','They\'ve sent you to finish me off? Is this the best your Horde can muster?','',26124),
(36717,'enUS','This ... doesn\'t end here ... $r.','',26124),
(36718,'enUS','This way! We\'re about to mount an assault on the Scourgelord\'s location! ','This way! We\'re about to mount an assault on the Scourgelord\'s location! ',26124),
(36719,'enUS','%s goes into a frenzy!','',26124),
(36720,'enUS','|TInterface\\Icons\\Spell_Fire_Flameshock.blp:20|t|cFFBC0000 OVERHEAT  |r|TInterface\\Icons\\Spell_Fire_Flameshock.blp:20|t','',26124),
(36721,'enUS','','I really should charge you for that.',26124),
(36722,'enUS','','Light be with you... for the very low price of a one silver tithe!',26124),
(36723,'enUS','','Nothing wrong with a little drive-by fortitude!',26124),
(36724,'enUS','','Hope you don\'t mind the extra fortitude, boss-$g man : lady;.',26124),
(36725,'enUS','','That one\'s free of charge, $g sir : ma\'am;.',26124),
(36726,'enUS','','I was wondering when I\'d see you again, $n.',26124),
(36727,'enUS','','It\'s not much, but it just might keep your green skin intact.',26124),
(36728,'enUS','','Just wanted to let you know that we\'re all counting on you!',26124),
(36729,'enUS','<The orc before you looks greener than usual.>$B$B$C, the goblins have brought \"all you can eat seafood\" to our shores. It is ... *urp* ... like a cataclysm in my belly.','',26124),
(36730,'enUS','*Urp!*','',26124),
(36731,'enUS','Shouldn\'t have had ... the clams ...','',26124),
(36732,'enUS','It was ... the chowder.','',26124),
(36733,'enUS','\"All you can eat\" he says. *Gulp*','',26124),
(36734,'enUS','The ... clam strips ...','',26124),
(36735,'enUS','What was in that \"bisque?\"','',26124),
(36736,'enUS','Please! No more. I can\'t handle any more of this!','Please! No more. I can\'t handle any more of this!',26124),
(36737,'enUS','If you ask me, the night elves lost this area ten thousand years ago. Their expulsion today at our hands is merely a formality.','',26124),
(36738,'enUS','The enormous stone shimmers with focused arcane energy.','',26124),
(36739,'enUS','<Use the stone to teleport back to Valormok.>','<Use the stone to teleport back to Valormok.>',26124),
(36740,'enUS','The enormous stone shimmers with focused arcane energy.$B$BIf Andorel\'s instructions are to be believed, it should be easy to refocus the stone\'s energies.','',26124),
(36741,'enUS','Well done, $n! Now then, let me assemble the team...','',26124),
(36742,'enUS','Very good. Whatever it is you boys do... Do a lot of it.','',26124),
(36743,'enUS','Don\'t forget, $n - you can now use the summoning stone to port yourself back to my location in Valormok! ','',26124),
(36744,'enUS','Now comes our chance at redemption, Jadaar. We could become heroes through this tournament!','',26124),
(36745,'enUS','I don\'t know. I am uncertain this is the proper vehicle to heroism.','',26124),
(36746,'enUS','What could be holding you back? You\'re hale, hearty... missing an eye perhaps, but that shouldn\'t keep you from competing!','',26124),
(36747,'enUS','I dislike elekks. Strongly.','',26124),
(36748,'enUS','Ah. That might be a problem.','',26124),
(36749,'enUS','Why aren\'t you competing?','',26124),
(36750,'enUS','I had a... situation some time back with one of the individuals now heading up the Sunreavers here. A falling out, if you will.','',26124),
(36751,'enUS','Needless to say, when I walked into the pavilion there was something of an altercation.','',26124),
(36752,'enUS','They refused to train you?','',26124),
(36753,'enUS','He suggested I do something else with the lance, instead. It\'s not my place to repeat vulgarities.','',26124),
(36754,'enUS','You realize, of course, that we would likely have to joust one another should we enter the tournament.','',26124),
(36755,'enUS','There is no doubt in my mind you\'d lose. Speed and wit triumphs over brute strength and bullheadedness any day of the week.','',26124),
(36756,'enUS','Okay, form it up! If it moves, shoot it. If it shoots... Move it!','',26124),
(36757,'enUS','Gassed up and good to go.','',26124),
(36758,'enUS','Boom, baby!','',26124),
(36759,'enUS','Are you surprised to see me here? Everyone needs clean laundry, and what better way to do it than with your own water elemental?$B$BSimply bring your laundry, pay a nominal fee, and before you know it, everything will be fresh and clean!','',26124),
(36760,'enUS','Arcanist Tybalin said you might be able to lend me a certain tabard.','Arcanist Tybalin said you might be able to lend me a certain tabard.',26124),
(36761,'enUS','You\'re in luck. I\'ve got just what you need in the load I\'m about to wash.','',26124),
(36762,'enUS','See the piles of laundry and the bucket of water? I\'ll call out what I need next, and you put it in the tub. Ready?','',26124),
(36763,'enUS','Oh, no! That wasn\'t right. Now I\'ll have to go get more detergent so we can start over!','',26124),
(36764,'enUS','Well done!','',26124),
(36765,'enUS','Another shall take his place. You waste your time.','',26124),
(36766,'enUS','[ph] What a miserable gnome. That beast would have better off fighting without him.','',26124),
(36767,'enUS','Warning: shredder is programmed only to function in Azshara.','',26124),
(36768,'enUS','Oops.','Oops.',26124),
(36769,'enUS','Bullheadedness? It is my perseverance that has gotten us this far, dandy. You wouldn\'t last five seconds.','',26124),
(36770,'enUS','Typical empty boasting. Still, the stables are rather distant and the drinks here are decent enough.','',26124),
(36771,'enUS','I hear those lances are rough-hewn, too. I\'m no fan of splinters.','',26124),
(36772,'enUS','Just as well.','',26124),
(36773,'enUS','If we do succeed here, you realize what comes next.','',26124),
(36774,'enUS','The Citadel, correct? Facing the Lich King\'s most powerful minions.','',26124),
(36775,'enUS','The two of us against the vast undead sea.','',26124),
(36776,'enUS','Indeed.','',26124),
(36777,'enUS','...perhaps we should seek our fortune somewhere less likely to be fatal.','',26124),
(36778,'enUS','Discretion is the better part of valor, after all.','',26124),
(36779,'enUS','Would one of you hurry up and finish off the other? Some of us are trying to make some moolah here!','',26124),
(36780,'enUS','Taking all bets on who wins between these two idiots.','',26124),
(36781,'enUS','You two mooks stow it. The boss is here!','',26124),
(36782,'enUS','Shadow and fire, how quaint. Ride the lightning!','',26124),
(36783,'enUS','Next time, I won\'t miss!','',26124),
(36784,'enUS','I can\'t wait to learn how to Hex. The two of you are going to be frogs for the rest of your miserable lives!','',26124),
(36785,'enUS','How did the two of you ever make it to the executive level?','',26124),
(36786,'enUS','They don\'t pay me enough to put up with this kind of unprofitable behavior!','',26124),
(36787,'enUS','Toss some pants in to the tub!','',26124),
(36788,'enUS','Quick, add some shirts to the laundry!','',26124),
(36789,'enUS','Add the unmentionables... uh, I mean, the \'delicates\'!','',26124),
(36790,'enUS','The tub needs more water!','',26124),
(36791,'enUS','See how easy that was with everyone working together? Just take what you need from the clean laundry here, but don\'t forget to return it when you\'re finished.','',26124),
(36792,'enUS','I\'m going to need you to do something else in a moment.','',26124),
(36793,'enUS','Your salvation has arrived... and it\'s affordably priced!','',26124),
(36794,'enUS','I\'ll take my fee out of your paycheck.','',26124),
(36795,'enUS','','',26124),
(36796,'enUS','Have I got a heal for you!','',26124),
(36797,'enUS','I\'ve got the best heals, anywhere!','',26124),
(36798,'enUS','Health from above!','',26124),
(36799,'enUS','I love the smell of salvation in the morning.','',26124),
(36800,'enUS','I\'ve got what you need!','',26124),
(36801,'enUS','Light is money, friend.','',26124),
(36802,'enUS','Rez incoming!','',26124),
(36803,'enUS','No more lying down on the job.','',26124),
(36804,'enUS','Not getting out of your debts that easy.','',26124),
(36805,'enUS','Back to work!','',26124),
(36806,'enUS','Walk it off.','',26124),
(36807,'enUS','That\'s 3 for you, buddy. One more and my fee goes up.','',26124),
(36808,'enUS','I\'m charging you for hazard pay on this one, pal.','',26124),
(36809,'enUS','You didn\'t even make it 20 more feet that time.','',26124),
(36810,'enUS','<A hand-lettered sign reads:>$B$B          Secret Lab Archives$B     X. Nizzlebex, Lab Director$B$B$B<It appears nobody is home right now. Perhaps you should come back later?>','',26124),
(36811,'enUS','Pirates?! Nobody said anything about pirates!$B$BDon\'t let them get me, boss. I\'m too young to die!!!','',26124),
(36812,'enUS','My, that\'s quite a load you have there.','',26124),
(36813,'enUS','Chilly tickles!','',26124),
(36814,'enUS','You make face soaky.','',26124),
(36815,'enUS','My mouth tastes wet!','',26124),
(36816,'enUS','...Is drink time?','',26124),
(36817,'enUS','Aquanos, stop sending the clothes so high! You didn\'t have to see the look on Aethas Sunreaver\'s face when he found his pants in the fountain!','',26124),
(36818,'enUS','To your health, windbag.','',26124),
(36819,'enUS','And to yours, brat.','',26124),
(36820,'enUS','','Pirates are NOT in my contract!',26124),
(36821,'enUS','','He is too powerful. We must leave this place at once! My magic can hold him in place for only a short time. Come quickly, heroes!',26124),
(36822,'enUS','What is your business here, $c?','',26124),
(36823,'enUS','At last, you\'re here. We have to get this tome to Icecrown as quickly as we can.','',26124),
(36824,'enUS','I\'m ready to deliver the tome, Magister Hathorel.','I\'m ready to deliver the tome, Magister Hathorel.',26124),
(36825,'enUS','Never trust the Sunreavers. They are hard at work undermining us in the eyes of our Argent Crusade allies.','',26124),
(36826,'enUS','Please, no more! I just need to rest for a moment!','Please, no more! I just need to rest for a moment!',26124),
(36827,'enUS','I\'ll... get... back... to... work... I... promise.','I\'ll... get... back... to... work... I... promise.',26124),
(36828,'enUS','There you are! I was beginning to think that the Sunreavers had intercepted you. Are you ready to deliver the tome to our representatives in Icecrown?','',26124),
(36829,'enUS','I\'ll deliver the tome to our contacts in Icecrown, arcanist.','I\'ll deliver the tome to our contacts in Icecrown, arcanist.',26124),
(36830,'enUS','Would you renew my Sunreaver disguise?','Would you renew my Sunreaver disguise?',26124),
(36831,'enUS','THIS IS A TEST','',26124),
(36832,'enUS','Would you renew my Silver Covenant disguise, Magister Hathorel?','Would you renew my Silver Covenant disguise, Magister Hathorel?',26124),
(36833,'enUS','','<The raptor peers at you, growls, and slobbers.>$B$B<It appears Subject Nine left behind an un-augmented clone of herself in order to cover her tracks. Clever girl! You ponder over what exactly you\'ve unleashed onto the cosmos...>',26124),
(36834,'enUS','It\'s hard to believe that I once respected Arthas.','It\'s hard to believe that I once respected Arthas.',26124),
(36835,'enUS','Slaves to our own prince, we\'re treated worse alive than dead. ','Slaves to our own prince, we\'re treated worse alive than dead. ',26124),
(36836,'enUS','I\'m shocked they didn\'t take our clothing with our weapons...','I\'m shocked they didn\'t take our clothing with our weapons...',26124),
(36837,'enUS','What does the Lich King need with living servants? Why doesn\'t he just kill us all?','What does the Lich King need with living servants? Why doesn\'t he just kill us all?',26124),
(36838,'enUS','We came here to investigate and were caught like a gnome with his hand on King Mekkatorque\'s throne. ','We came here to investigate and were caught like a gnome with his hand on King Mekkatorque\'s throne. ',26124),
(36839,'enUS','That worg of a taskmaster. It\'s only a matter of time before he gets what\'s coming to him.','That worg of a taskmaster. It\'s only a matter of time before he gets what\'s coming to him.',26124),
(36840,'enUS','Ugh... taking so long... my limbs... can\'t go on...','Ugh... taking so long... my limbs... can\'t go on...',26124),
(36841,'enUS','Wait! Stop! Don\'t kill me, please! I\'ll tell you everything!','',26124),
(36842,'enUS','What you seek is in the master\'s lair, but you must destroy Tyrannus to gain entry. Now, within the Halls of Reflection you will find Frostmourne. It... It holds the truth.','',26124),
(36843,'enUS','I swear it is true! Please, don\'t kill me!!','',26124),
(36844,'enUS','Urg... no!!','',26124),
(36845,'enUS','','Why should the Banshee Queen spare your miserable life?',26124),
(36846,'enUS','','Frostmourne? The Lich King is never without his blade. If you are lying to me...',26124),
(36847,'enUS','','A fitting end for a traitor. Come, we must free the slaves and see what is within the Lich King\'s chamber for ourselves.',26124),
(36848,'enUS','%s runs away!','',26124),
(36849,'enUS','Be sure to keep an eye out for recruitment posters in Gobland. Once we get that operation under way, it would be good to have you on board again.','',26124),
(36850,'enUS','Good to see you again, $n.','',26124),
(36851,'enUS','$n! Come here. I have a ... \"special project\" requiring your assistance.','',26124),
(36852,'enUS','Worthless gnat! Death is all that awaits you!','',26124),
(36853,'enUS','Do not think that I shall permit you entry into my master\'s sanctum so easily. Pursue me if you dare.','',26124),
(36854,'enUS','','I\'m not so naive as to believe your appeal for clemency, but I will listen.',26124),
(36855,'enUS','','What a cruel end. Come, heroes. We must see if the gnome\'s story is true. If we can separate Arthas from Frostmourne, we might have a chance at stopping him.',26124),
(36856,'enUS','','Frostmourne lies unguarded? Impossible!',26124),
(36857,'enUS','Kalec sent me...','Kalec sent me...',26124),
(36858,'enUS','Kalecgos?! That\'s your good foot forward?$B$BGood luck with that one, buddy.','',26124),
(36859,'enUS','No no no, you don\'t understand. I\'m here to help.','No no no, you don\'t understand. I\'m here to help.',26124),
(36860,'enUS','Of course you are. Here to save big blue from himself, spending all his time in the spirit world, obsessing over magical artifacts. Kalec doesn\'t understand though, I\'ve turned a new leaf.$B$BI\'ve met someone.','',26124),
(36861,'enUS','Met someone? I didn\'t know there were any other dragons out here.','Met someone? I didn\'t know there were any other dragons out here.',26124),
(36862,'enUS','A dragon? Hah! Don\'t be ridiculous.$B$BYou know $r, you\'re awfully rude. She\'s standing right here!','',26124),
(36863,'enUS','...the spirit healer?\n','...the spirit healer?\n',26124),
(36864,'enUS','She has a name, you know. Anara. You\'d do well to treat her with the respect she deserves.$B$BHow many times have she and her sisters brought you back from the grip of death itself? You\'re just all kinds of inconsiderate, aren\'t you?','',26124),
(36865,'enUS','I\'m sorry, I didn\'t mean to be rude, I just...','I\'m sorry, I didn\'t mean to be rude, I just...',26124),
(36866,'enUS','I know. I KNOW. We could never be, right? Dragon and Spirit Healer... two different worlds! Not to mention the physiological problems.$B$BBut you\'re wrong. We have a deeper connection than that. Anara and I, we\'re involved.$B$BBesides, I kind of like it here. No adventurers to poke and prod me with no provocation.','',26124),
(36867,'enUS','That\'s not what I was saying at all.','That\'s not what I was saying at all.',26124),
(36868,'enUS','Well get to it then. You\'re the one veering off onto all these unnecessary topics.','',26124),
(36869,'enUS','I\'m the... forget it. I\'m here to warn you that the black dragonflight is here hunting you.','I\'m the... forget it. I\'m here to warn you that the black dragonflight is here hunting you.',26124),
(36870,'enUS','Oh. That? Thought I hadn\'t noticed the scorched earth and senseless slaughter that usually give them away? I\'m not THAT old.','',26124),
(36871,'enUS','You already know? Why don\'t you go stop them then?','You already know? Why don\'t you go stop them then?',26124),
(36872,'enUS','Why bother? It\'s not like they actually have even the slightest clue where I am. They\'re not going to do any harm to the already-found artifacts around here.$B$BAnyway, one of the amusingly convenient things about evil and destruction is that they tend to just evilly destruct each other eventually.','',26124),
(36873,'enUS','But Kalecgos is already out there trying to stop them. He needs your help.','But Kalecgos is already out there trying to stop them. He needs your help.',26124),
(36874,'enUS','He\'s going after them? And he sent you to ask me for help? Was there begging? Were there tears?$B$B<Azuregos stares off into the distance as a toothy smile creeps onto his face.>$B$BYou know, if I came to his rescue, there\'s no way he could ever live it down. Maybe he\'d make me one of those little Sunwell girls of my very own.$B$BNo offense, Anara.','',26124),
(36875,'enUS','You\'ll come then?','You\'ll come then?',26124),
(36876,'enUS','Yeah yeah, I\'ll come to his rescue.$B$BDon\'t you fall into his little center-of-the-world hero bit though! He just likes the attention. I swear, he thinks he\'s going to be the next Aspect. It\'s laughable.','',26124),
(36877,'enUS','I\'m going to let him know right away. Meet us at Sable Ridge.','I\'m going to let him know right away. Meet us at Sable Ridge.',26124),
(36878,'enUS','Yeah yeah. I\'m on my way. Don\'t get your chain panties in a bunch.','',26124),
(36879,'enUS','You call that a trigger assembly? This is not a toy, people!','',26124),
(36880,'enUS','Step it up, Horvik. You too, Gleenix! Grapplehammer demands nothing less than perfection here. ','',26124),
(36881,'enUS','What is this? I told you I wanted stepped threads on the interrupted breechblock! We\'re going to have to re-engineer the whole loading mechanism! ','',26124),
(36882,'enUS','Blazcowiz, you\'d better get those recoil cylinders greased. Or I will grease them with your FACE.','',26124),
(36883,'enUS','Flink, did you compile the compression data for the hydropneumatic recoil jack yet? Chop chop!','',26124),
(36884,'enUS','Is this supposed to be a counterrecoil recuperating cylinder? I call it CRAP. Build it again!','',26124),
(36885,'enUS','We\'re ready! Let\'s go!','We\'re ready! Let\'s go!',26124),
(36886,'enUS','','I cannot hold him for long, we must leave at once!',26124),
(36887,'enUS','What on earth is going on here?!?!','',26124),
(36888,'enUS','It takes a few good crashes to really \"season\" a flying machine.$B$BNo goblin in their right mind flies one pristine.','',26124),
(36889,'enUS','Grapplehammer wants me to do WHAT? He\'s finally finished his bomb and he wants ME to fly it across the harbor? No-sir-ee!$B$BHere, I\'ll set one of my \'copters on autopiliot for you. Good luck!$B$BI\'ll be in my shelter.','',26124),
(36890,'enUS','Just give me the \'copter, Friz.','Just give me the \'copter, Friz.',26124),
(36891,'enUS','This is all YOUR fault, Sten!','',26124),
(36892,'enUS','You seek Azuregos? Bane of the Bitter Reaches? Scourge of the Bay of Storms? Lord of all magic in Azshara?$B$BWell, you\'ve found him.$B$B<Azuregos appears to be smiling.>','',26124),
(36893,'enUS','I\'ve had enough of this!','',26124),
(36894,'enUS','So have I, Grimtotem.','',26124),
(36895,'enUS','','Do not worry, young one. I knew that our arrangement was... temporary. I will be fine.$B$BYou though, you do not belong here. It is not yet your time. I shall aid your journey back to the realm of the living.$B$BThis one is on me.',26124),
(36896,'enUS','Baine! You\'ve shown yourself! GET HIM!','',26124),
(36897,'enUS','You may have saved Azuregos, $r, but your life ends here.','',26124),
(36898,'enUS','I don\'t think so, little wyrm.','',26124),
(36899,'enUS','You will die in shame like your pathetic father.','',26124),
(36900,'enUS','It took a coward\'s poison and the fury of Hellscream to bring my father down.','',26124),
(36901,'enUS','WHAT CHANCE HAVE YOU?','',26124),
(36902,'enUS','[PH] Do not think to defy the master\'s will!','',26124),
(36903,'enUS','Why you break our home?!','',26124),
(36904,'enUS','You break our cave, I break your skull!','',26124),
(36905,'enUS','Trogg cave all gone!  You pay for this!!','',26124),
(36906,'enUS','And so it is done.','',26124),
(36908,'enUS','','You\'ve come seeking your death? Happy to oblige.',26124),
(36909,'enUS','You got here just in time.  Thanks!','You got here just in time.  Thanks!',26124),
(36910,'enUS','I wasn\'t ready to die in a marsh.  Thanks again!','I wasn\'t ready to die in a marsh.  Thanks again!',26124),
(36911,'enUS','Time to run!','Time to run!',26124),
(36912,'enUS','Let\'s get out of this marsh!','Let\'s get out of this marsh!',26124),
(36913,'enUS','You puny thief!  Koroth find you!  Koroth smash your face in!','',26124),
(36914,'enUS','Who dares to touch Koroth\'s banner!?','',26124),
(36915,'enUS','The %s bursts into a cloud of mysterious spores.','',26124),
(36916,'enUS','It is for you.','',26124),
(36917,'enUS','This isn\'t over, Baine...','',26124),
(36918,'enUS','%s is reclaimed by the earth!','',26124),
(36919,'enUS','The old wounds still linger, $g lad:lass;. I can feel \'em in me bones, even now. Aye, I got a score to settle with Arthas and ye can believe I\'m gonna give that boy the beatin\' I shoulda given \'im when he was a wee lad. Always knew there was something wrong with \'im.$B$BTell me when yer crew is ready and we\'ll lift off for the top o\' the citadel.$B$BArthas won\'t be expectin\' this!','',26124),
(36920,'enUS','My companions are all accounted for, Muradin. Let\'s go!','My companions are all accounted for, Muradin. Let\'s go!',26124),
(36921,'enUS','Master, I have failed...','',26124),
(36922,'enUS','Found!','Found!',26124),
(36923,'enUS','This is our final stand. What happens here will echo through the ages. Regardless of outcome, they will know that we fought with honor. That we fought for the freedom and safety of our people.$B$BRemember, hero, fear is your greatest enemy in these befouled halls. Steel your heart and your soul will shine brighter than a thousand suns. The enemy will falter at the sight of you. They will fall as the light of righteousness envelops them!','',26124),
(36924,'enUS','$G Sir.:Ma\'am.;','',26124),
(36925,'enUS','Dismissed!','Dismissed!',26124),
(36926,'enUS','<Make a series of complicated hand gestures.>','<Make a series of complicated hand gestures.>',26124),
(36927,'enUS','What the heck was that?','',26124),
(36928,'enUS','','Was that... Yoga?',26124),
(36929,'enUS','','You want me to steal third?',26124),
(36930,'enUS','%s looks confused.','',26124),
(36931,'enUS','What did you just call my mother?','',26124),
(36932,'enUS','Now that\'s just rude...','',26124),
(36933,'enUS','Leading under the influence...','',26124),
(36934,'enUS','I don\'t think that\'s physically possible, sir.','',26124),
(36935,'enUS','Sir, I think the explosions and gunfire gave us away. You don\'t have to use hand signals.','',26124),
(36936,'enUS','Most definitely.  Might you mentor me?','Most definitely.  Might you mentor me?',26124),
(36937,'enUS','Testing, 1... 2... 3!','',26124),
(36938,'enUS','The elements favor you.  What will you ask of them?','The elements favor you.  What will you ask of them?',26124),
(36939,'enUS','The elements are fickle and best left out of untrained hands.  My apologies, but I have no need for yours.','The elements are fickle and best left out of untrained hands.  My apologies, but I have no need for yours.',26124),
(36940,'enUS','Ooooh... looking sexy!','',26124),
(36941,'enUS','I am truly blessed to have so many loyal and dedicated apprentices. My work would be impossible without this influx of test subjects.','',26124),
(36942,'enUS','Can you open a portal to your tower for me, Archmage Xylem?','Can you open a portal to your tower for me, Archmage Xylem?',26124),
(36943,'enUS','I have opened the portal to my retreat. Go and rest. I\'ll need you lively when our studies resume in the morning, you nimble little thing.','',26124),
(36944,'enUS','With the price they\'re getting on this operation, I\'m hoping for a nice hefty profit sharing check. They better not shortchange us again.','',26124),
(36945,'enUS','Ready your arms, my Argent Brothers. The Vrykul will protect the Frost Queen with their lives.','',26124),
(36946,'enUS','Enough idle banter! Our champions have arrived - support them as we push our way through the hall!','',26124),
(36947,'enUS','Guards! I expect this $r to be clapped into chains!','',26124),
(36948,'enUS','Even dying here beats spending another day collecting reagents for that madman, Finklestein. ','',26124),
(36949,'enUS','I am from the elemental plane!','',26124),
(36950,'enUS','%s grows more unstable!','',26124),
(36951,'enUS','No hit me! Tell Peake I been good.','',26124),
(36952,'enUS','%s is growing volatile!','',26124),
(36953,'enUS','First da fire, and now da $r!  You gonna die!','',26124),
(36954,'enUS','You go attack him first, mon.  I don\' attack him quite yet.','',26124),
(36955,'enUS','I don\' wanna die in a fire, mon.','',26124),
(36956,'enUS','%s can barely maintain its form!','',26124),
(36957,'enUS','','What we gon\' do now, you ask?  We wait.',26124),
(36958,'enUS','','I don\' know why the spirits be rejectin\' us so.',26124),
(36959,'enUS','','Don\' worry, child.  Grik\'nir gonna help us get through this.',26124),
(36960,'enUS','','Grik\'nir says he gon\' talk to the elemental, get it to fight on our side.',26124),
(36961,'enUS','','Soon enough we take over dis valley.  Soon enough.',26124),
(36962,'enUS','','Da spirits be angry with us.',26124),
(36963,'enUS','','Our land be a land of ice an\' snow.',26124),
(36964,'enUS','','But beneath the earth, child, there always be fire.',26124),
(36965,'enUS','','De spirit come from deep down to talk with Grik\'nir.',26124),
(36966,'enUS','We grunts were ordered to charge once more - into a wall of pikes - I could not do it, $c. My weapon slid from my hands and my legs did not move.$B$BI am dishonored.','',26124),
(36967,'enUS','My commander was butchered before my eyes - my brothers dead all around me - I could not fight on. I am so ashamed, $c. I did not avenge them.','',26124),
(36968,'enUS','Do not look at me, $r. I have disgraced the Horde. I am done.','',26124),
(36969,'enUS','No orc should ever flee from battle as I did. Leave me to my disgrace. Would that I would die in this tower, but I dread learning what my ancestors think of my cowardice.','',26124),
(36970,'enUS','','Get ta work, boys!',26124),
(36971,'enUS','','Don\'t fret, we\'ll be outta here soon.',26124),
(36972,'enUS','','Let\'s keep this fire going, dwarves!',26124),
(36973,'enUS','','What\'s Joren doin\' out there, anyhow?',26124),
(36974,'enUS','Your jormungar can only move if you\'ve submerged beneath the snow, but it cannot attack while submerged. Once your jormungar emerges, it can use its powerful acid attack to wear through the armor of the Iron Colossus. Be ready to submerge to escape from the Iron Colossus\'s most devastating attacks.','',26124),
(36975,'enUS','I recovered your armor and weapons. Victory or death!','I recovered your armor and weapons. Victory or death!',26124),
(36976,'enUS','Thank goodness you arrived when you did, heroes. Orgrim\'s Hammer has already left. Quickly now, to the Skybreaker! If you leave soon, you may be able to catch them.','',26124),
(36977,'enUS','Lok\'tar ogar!','',26124),
(36978,'enUS','Vengeance...','',26124),
(36979,'enUS','No team\'s ever come back from this far behind!','',26124),
(36980,'enUS','Coach, get me back into the game!','Coach, get me back into the game!',26124),
(36981,'enUS','This ought to help!','This ought to help!',26124),
(36982,'enUS','Thanks!  I can make it from here.','Thanks!  I can make it from here.',26124),
(36983,'enUS','Yer a lifesaver!  For Ironforge!','Yer a lifesaver!  For Ironforge!',26124),
(36984,'enUS','Ahh, much better.  I owe ya one.','Ahh, much better.  I owe ya one.',26124),
(36985,'enUS','Throw your Footbombs at those Steamwheedle Sharks!','',26124),
(36986,'enUS','Lost your Rocket Pack? Have you checked your bags?','',26124),
(36987,'enUS','Curse this foul cage...','Curse this foul cage...',26124),
(36988,'enUS','Ah, to be finally free of that cage...','Ah, to be finally free of that cage...\n',26124),
(36989,'enUS','I would like to receive training.','I would like to receive training.',26124),
(36990,'enUS','','Forgive me, heroes. I should have listened to Uther. I... I just had to see for myself. To look into his eyes one last time. I am sorry.',26124),
(36991,'enUS','','We now know what must be done. I will deliver this news to King Varian and Highlord Fordring.',26124),
(36992,'enUS','','It... It\'s a dead end. We have no choice but to fight. Steel yourselves, heroes, for this is our last stand!',26124),
(36993,'enUS','FIRE! FIRE!','',26124),
(36994,'enUS','Nowhere to run... You\'re mine now!','',26124),
(36995,'enUS','You have my thanks. We were outnumbered until you arrived. ','You have my thanks. We were outnumbered until you arrived. ',26124),
(36996,'enUS','Captain Muradin is waiting aboard the Skybreaker. We\'ll secure the area until you are ready for take off.','Captain  Muradin is waiting aboard the Skybreaker. We\'ll secure the area until you are ready for take off.',26124),
(36997,'enUS','Quickly, climb aboard! We mustn\'t tarry here! There\'s no telling when this whole mountainside will collapse.','',26124),
(36998,'enUS','','There\'s an opening up ahead. GO NOW!',26124),
(36999,'enUS','','These hills and hidden trails are my home. For years I have used them on the hunt.$B$BI never thought I\'d use them to fight a war.',26124),
(37000,'enUS','Skybreaker infantry, hold position!','Skybreaker infantry, hold position!',26124),
(37001,'enUS','Aye aye!','Aye aye!',26124),
(37002,'enUS','Years ago, the Grimtotem raided my village. The pain, the anger, the loss - still they weigh on my heart.$B$BAnd now I find myself giving comfort and aid to others who have lost their village to a savage attack.','',26124),
(37003,'enUS','Alright, so you\'re just going to head through this tunnel and whaaaaa....?','',26124),
(37004,'enUS','I recommend that you return to Anvilmar, $n... and quickly!  I\'ll send the signal to the Gnomeregan Airmen.','',26124),
(37005,'enUS','From these hidden paths we can rain terror down on our enemies below.$B$BThere is not much honor in hit-and-run strikes, but a good warrior knows to keep his foe off-balance.','',26124),
(37006,'enUS','Look for a fellow by the name of Milo Geartwinge.  I suppose I\'ll see what I can do about this cave-in.','',26124),
(37007,'enUS','Get back, ye filthy beast!','',26124),
(37008,'enUS','Eat dwarven lead!','',26124),
(37009,'enUS','For Ironforge!','',26124),
(37010,'enUS','Take that, ye cave-dwellin\' mongrel!$b$bAhh... how can I help ye, $n?','',26124),
(37011,'enUS','','What d\'ye want, $c?',26124),
(37012,'enUS','The trolls are acting strangely, $n.  I don\'t like it.  I don\'t like it one bit.','',26124),
(37013,'enUS','Draw them back to us, and we\'ll assist you. ','',26124),
(37014,'enUS','Push forward! ','',26124),
(37015,'enUS','Quickly, push on!','',26124),
(37016,'enUS','Her reinforcements will arrive shortly, we must bring her down quickly!','',26124),
(37017,'enUS','I\'ll draw her attacks. Return our brothers to their graves, then help me bring her down!','',26124),
(37018,'enUS','I\'ll remain and inform Tirion of our progress. You must press on and bring down Sindragosa. Lok\'tar, champions! ','',26124),
(37019,'enUS','I AM FROM THE ELEMENTAL PLANE!','',26124),
(37020,'enUS','','Foolish Crok. You brought my reinforcements with you. Arise, Argent Champions, and serve the Lich King in death!',26124),
(37021,'enUS','Hurry,  before that Val\'kyr picks us off!','',26124),
(37022,'enUS','','You may have once fought beside me, Crok, but now you are nothing more than a traitor. Come, your second death approaches!',26124),
(37024,'enUS','','You may have once fought beside me, Crok, but now you are nothing more than a traitor. Come, your second death approaches!',26124),
(37025,'enUS','Why you\'re just the $c I was looking for! I\'m testing a new rocket-powered flying device, and I need your help!\n\nJust take one of these harnesses and put it on under your armor.  Hit the button on the side, and BOOM, off you go.\n\nDon\'t go trying to steal my work though. Each of these babies is fitted with a Transponster 8000 linked to the one in my hand. If you get too far from me the Transponster will shut down the main rocket and you\'ll be unable to lift off until you return.\n\nNow where did I put those liability forms?','',26124),
(37026,'enUS','Yeah, I\'m sure safety is your top priority. Give me a rocket pack.','Yeah, I\'m sure safety is your top priority. Give me a rocket pack.',26124),
(37027,'enUS','This is our final stand. What happens here will echo through the ages. Regardless of outcome, they will know that we fought with honor. That we fought for the freedom and safety of our people!\n','',26124),
(37028,'enUS','Remember, heroes, fear is your greatest enemy in these befouled halls. Steel your heart and your soul will shine brighter than a thousand suns. The enemy will falter at the sight of you. They will fall as the light of righteousness envelops them!','',26124),
(37029,'enUS','Our march upon Icecrown Citadel begins now!','',26124),
(37030,'enUS','You now stand upon the hallowed ground of the Scourge. The Light won\'t protect you here, paladin. Nothing will protect you...','',26124),
(37031,'enUS','ARTHAS! I swore that I would see you dead and the Scourge dismantled! I\'m going to finish what I started at Light\'s Hope!','',26124),
(37032,'enUS','You could have been my greatest champion, Fordring: A force of darkness that would wash over this world and deliver it into a new age of strife.','',26124),
(37033,'enUS','But that honor is no longer yours. Soon, I will have a new champion.','',26124),
(37034,'enUS','The breaking of this one has been taxing. The atrocities I have committed upon his soul. He has resisted for so long, but he will bow down before his king soon.','',26124),
(37035,'enUS','NEVER! I... I will never... serve... you...','',26124),
(37036,'enUS','In the end, you will all serve me.','',26124),
(37037,'enUS','Could it be, Lord Fordring? If Bolvar lives, mayhap there is hope fer peace between the Alliance and the Horde. We must reach the top o\' this cursed place and free the paladin!','',26124),
(37038,'enUS','By the Light, it must be so!','',26124),
(37039,'enUS','Intruders have entered your master\'s domain. Signal the alarms!','',26124),
(37040,'enUS','Hrmph, fodder. Not even fit to labor in the quarry. Relish these final moments, for soon you will be nothing more than mindless undead.','',26124),
(37041,'enUS','What did that dragon do to Mount Kajaro?!!!','What did that dragon do to Mount Kajaro?!!!',26124),
(37042,'enUS','Your last waking memory will be of agonizing pain.','',26124),
(37043,'enUS','Prepare the Skybreaker fer an aerial assault on the citadel!','',26124),
(37044,'enUS','Minions, destroy these interlopers.','',26124),
(37045,'enUS','We are outnumbered here, our ties to Crossroads and Durotar severed. But one orc is worth 10 Alliance cowards.$B$BWe will bottle them up in this pass and gut them like swine.','',26124),
(37046,'enUS','Heroes, ye must fight yer way to a clear extraction point within Icecrown. We\'ll try an\' rendezvous on the ramparts!','',26124),
(37047,'enUS','Kilrok, how did we lose Honor\'s Stand?','Kilrok, how did we lose Honor\'s Stand?',26124),
(37048,'enUS','It was a clever ruse, $n. Alliance forces streamed out of Northwatch and marched up the gold road, besieging Crossroads as dusk fell. Then, in the heart of the night, they force-marched southward, leaving their campfires burning behind.$B$BOur meager forces at Honor\'s Stand were caught unawares as the Alliance poured through the pass at dawn\'s first light. Many of our bravest warriors fell before their blades.','',26124),
(37049,'enUS','Good news, everyone! I\'ve fixed the poison slime pipes!','',26124),
(37050,'enUS','Kick the Footbomb between the smokestacks up and behind the opposing goal!','',26124),
(37051,'enUS','The paladin still lives? Is it possible, Highlord? Could he have survived?','',26124),
(37052,'enUS','This was before the Cataclysm?','This was before the Cataclysm?',26124),
(37053,'enUS','Then we must save him! If we rescue Bolvar Fordragon, we may quell the unrest between the Alliance and the Horde.','',26124),
(37054,'enUS','Our mission is now clear: The Lich King will answer for his crimes and we will save Highlord Bolvar Fordragon!','',26124),
(37055,'enUS','Kor\'kron, prepare Orgrim\'s Hammer for its final voyage! Champions, our gunship will find a point to dock on the upper reaches of the citadel. Meet us there!','',26124),
(37056,'enUS','The power of the Light knows no bounds, Saurfang. His soul is under great strain, but he lives - for now.','',26124),
(37057,'enUS','Yes. We regrouped east of the pass and prepared a counter-attack, but the next day, the skies reddened and the land was cleaved in two, as easily as a child might split open a cactus apple. See how the devastation stretches from horizon to horizon?$B$BOur Alliance foes in their makeshift bunkers were as surprised and disorganized as we were by the disaster. It would\'ve been the perfect time to strike! But Warlord Gar\'dul insisted we pull back to the south to refortify.$B$B<Kilrok spits on the ground.>$B$BNot all of us followed. I stood toe-to-toe with demons in the last war, $n. I\'m not about to turn tail and let the Alliance plant roots on my soil.','',26124),
(37058,'enUS','You and your men stayed behind to fight.','You and your men stayed behind to fight.',26124),
(37059,'enUS','To fight, yes. To die? Likely. But we will give them no ground, $c.$B$BWe are outnumbered. Our armor is patchwork, our weapons scavenged.$B$BBut this is our land! Our tauren allies know every hidden trail, crevice, and pass through these hills. We descend from the high ground where they least expect us, then disappear into the terrain like phantoms. Fear is our weapon, and we will strike at them unceasingly.','',26124),
(37060,'enUS','Oh dear.  Things aren\'t looking good for Felix.','',26124),
(37061,'enUS','','',26124),
(37062,'enUS','Give me another shot at kicking the winning goal, coach!','Give me another shot at kicking the winning goal, coach!',26124),
(37063,'enUS','I tink I made an angry poo-poo. It gonna blow!','',26124),
(37064,'enUS','|TInterface\\Icons\\spell_shadow_unstableaffliction_2.blp:16|t%s begins to cast |cFFFF0000Unstable Ooze Explosion!|r','',26124),
(37065,'enUS','','Miserable creatures! Die! ',26124),
(37066,'enUS','When d\'ye think we can leave?  I need ta get back to work.','When d\'ye think we can leave?  I need ta get back to work.',26124),
(37067,'enUS','Where are all these troggs coming from?  Were they livin\' underground the whole time?','Where are all these troggs coming from?  Were they livin\' underground the whole time?',26124),
(37068,'enUS','Might as well make yerself comfortable.  Ironstock\'s not lettin\' anybody out until the troggs die down.','Might as well make yerself comfortable.  Ironstock\'s not lettin\' anybody out until the troggs die down.',26124),
(37069,'enUS','Have ye any news from outside?  I hear the trolls have been actin\' up too.','Have ye any news from outside?  I hear the trolls have been actin\' up too.',26124),
(37070,'enUS','It\'s gettin\' awful crowded in here.  I don\'t do well in confined spaces.','It\'s gettin\' awful crowded in here.  I don\'t do well in confined spaces.',26124),
(37071,'enUS','Ye\'d think that, after an earthquake of cataclysmic proportions, the LAST place ye\'d want ta be is indoors, wouldn\'t ye?','Ye\'d think that, after an earthquake of cataclysmic proportions, the LAST place ye\'d want ta be is indoors, wouldn\'t ye?',26124),
(37072,'enUS','$n!  I hear you\'re Ironstock\'s new little whipping $r.  What\'s she got ya doin\' now?','$n!  I hear you\'re Ironstock\'s new little whipping $r.  What\'s she got ya doin\' now?',26124),
(37073,'enUS','I feel like I\'ve been cooped up in here forever.  Is it Brewfest yet?','I feel like I\'ve been cooped up in here forever.  Is it Brewfest yet?',26124),
(37074,'enUS','Never... could reach... the top shelf...','',26124),
(37075,'enUS','THAT was for bringing me spoiled spider ichor!\n','',26124),
(37076,'enUS','You miserable fools never did manage to select a decent bat wing.','',26124),
(37077,'enUS','Don\'t... let Finklestein use me... for his potions...','',26124),
(37078,'enUS','My gosh, it\'s full of rocks!','',26124),
(37079,'enUS','I\'d almost given up hope.','I\'d almost given up hope.',26124),
(37080,'enUS','As you can see, we\'ve cleared out the rockslide.  The tremendous loss of life was regrettable, but you can now pass freely through the trogg-infested tunnel.$b$bYou\'re welcome!','',26124),
(37081,'enUS','How do you do, $c?','',26124),
(37082,'enUS','By dusk, the flames towered into the sky. I lost everything. Everything.$B$BWhy would they burn an inn?','',26124),
(37083,'enUS','<Kelsuwa doesn\'t make eye contact with you.>$B$BI escaped amidst the fighting, but not before freeing all the stabled animals.$B$BI couldn\'t keep them with me. They scattered into the smoke...','',26124),
(37086,'enUS','Tapping','Tapping',26124),
(37087,'enUS','','Heroes of the Alliance, attack!',26124),
(37088,'enUS','','NO! YOU MONSTER!',26124),
(37089,'enUS','','I do what I must. Please forgive me, noble soldiers.',26124),
(37090,'enUS','','You will have to make your way across this quarry on your own.',26124),
(37091,'enUS','','Free any Alliance slaves that you come across. We will most certainly need their assistance in battling Tyrannus. I will gather reinforcements and join you on the other side of the quarry.',26124),
(37093,'enUS','Intruders have entered the master\'s domain. Signal the alarms!','',26124),
(37094,'enUS','Hrmph, fodder. Not even fit to labor in the quarry. Relish these final moments for soon you will be nothing more than mindless undead.','',26124),
(37095,'enUS','Your last waking memory will be of agonizing pain.','',26124),
(37096,'enUS','Minions, destroy these interlopers!','',26124),
(37098,'enUS','Volcano rocks! Get your volcano rocks here!','',26124),
(37099,'enUS','Volcano rocks for sale! Hot off the mountain! You want \'em, I got \'em!','',26124),
(37100,'enUS','Volcano rocks - new low price! You\'re gonna love my rocks.','',26124),
(37101,'enUS','Get your volcano rocks here! ...Great for cats!','',26124),
(37102,'enUS','Take home a piece of the Cataclysm! Volcano rocks for sale - hot, Hot, HOT!','',26124),
(37103,'enUS','Papers to weigh? Doors to stop? Windows to break? bam, Bam, BAM! Volcano rocks.','',26124),
(37104,'enUS','Volcano rocks. Million and one uses. Lava, java, sauna, banana....','',26124),
(37105,'enUS','You must not approach the Frost Queen. Quickly, stop them!','You must not approach the Frost Queen. Quickly, stop them!',26124),
(37106,'enUS','Volcano rocks! Limited time offer! Papers of authenticity and everything!','',26124),
(37107,'enUS','Vinny, I just gotta get me a genuine Cataclysm souvenir!','Vinny, I just gotta get me a genuine Cataclysm souvenir!',26124),
(37108,'enUS','','%s prepares to unleash a wave of blistering cold!',26124),
(37109,'enUS','','Now, feel my master\'s limitless power and despair!',26124),
(37110,'enUS','','In our native tongue, \"Una\'fe\" can be translated as \"Refuge.\" But the name no longer fits. From the moment we set up this camp, this strange jungle has threatened to engulf it. ',26124),
(37111,'enUS','','They attacked Taurajo while our strongest were on the hunt. By some miracle, there was a gap in the Alliance lines through which myself and some others were able to carry the little ones...$B$B<Tawane trails off, trying not to cry in front of the children.>',26124),
(37112,'enUS','','Hush, hush. It\'s okay little one.',26124),
(37113,'enUS','','Sleep now, little one. We\'ll find your parents soon.',26124),
(37114,'enUS','','There there, little hunter. I\'m here for you.',26124),
(37115,'enUS','<Static>$bIs this thing on?  Hello?','',26124),
(37116,'enUS','','I will delay here until more reinforcements arrive, but you have to keep moving.$B$BWe won\'t have much time until Arthas realizes we\'re here.',26124),
(37117,'enUS','Ahh, there you are.  Hello!  I figured that, while you\'re flying to Kharanos, I\'d give you some data about what\'s going on outside of Coldridge Valley.','',26124),
(37118,'enUS','It seems you Coldridge folks are dreadfully under-informed about the events of the last few days.','',26124),
(37119,'enUS','If you thought you had problems with trolls in Coldridge, wait \'til you get to Kharanos!  That big cataclysm got the trolls all stirred up out here.','',26124),
(37120,'enUS','Free at last!','Free at last!',26124),
(37121,'enUS','Thank you!','Thank you!',26124),
(37122,'enUS','I only understand a few words of the quilboar tongue, but I didn\'t like what I heard.','I only understand a few words of the quilboar tongue, but I didn\'t like what I heard.',26124),
(37123,'enUS','Are the refugees still gathering at Camp Una\'fe?','Are the refugees still gathering at Camp Una\'fe?',26124),
(37124,'enUS','You\'re a savior! I don\'t know what those things wanted from us...','You\'re a savior! I don\'t know what those things wanted from us...',26124),
(37125,'enUS','What is this? <Gurgle> <Snort> The $r has come? To challenge mighty Sabersnout <Snort>?','',26124),
(37126,'enUS','I will make example of $r <Snort>! Prepare yourself <Gurgle> soft-for-face.','',26124),
(37127,'enUS','%s laughs.','',26124),
(37128,'enUS','You, <Snort> you are strong <Gurgle>. But...','',26124),
(37129,'enUS','Strong enough for THE BOARPOCALYPSE?','',26124),
(37130,'enUS','You ... survive the boars? <Snort> So many boars! So sad! <Gurgle>','',26124),
(37131,'enUS','<Snort>? <Gurgle>!','',26124),
(37132,'enUS','I must break you now.','',26124),
(37133,'enUS','','Perish!',26124),
(37134,'enUS','','The flaw of mortality....',26124),
(37135,'enUS','','Perhaps... you were right, Crok. ',26124),
(37136,'enUS','','Your incursion ends here! None shall survive!',26124),
(37137,'enUS','','Can you feel the cold hand of death upon your heart?',26124),
(37138,'enUS','','Suffer, mortals, as your pathetic magic betrays you!',26124),
(37139,'enUS','','Free... at last....',26124),
(37140,'enUS','','Enough! I tire of these games!',26124),
(37141,'enUS','Hah hah! <Snort> You lose most everything.','',26124),
(37142,'enUS','Whew! I\'m never eating asparagus again.','Whew! I\'m never eating asparagus again.',26124),
(37143,'enUS','I\'ve had enough of this jungle!','I\'ve had enough of this jungle!',26124),
(37144,'enUS','Get ... me ... out of here!','Get ... me ... out of here!',26124),
(37145,'enUS','I think this jungle wants to eat me!','I think this jungle wants to eat me!',26124),
(37146,'enUS','Thank you! That thing was shaking me like a ragdoll.','Thank you! That thing was shaking me like a ragdoll.',26124),
(37147,'enUS','I remember when the Barrens was ... barren. And we liked it!','I remember when the Barrens was ... barren. And we liked it!',26124),
(37148,'enUS','These appear to be the remains of Thalorien Dawnseeker, the last wielder of Quel\'Delar.','',26124),
(37149,'enUS','Examine the remains.','Examine the remains.',26124),
(37150,'enUS','Help. Help!','Help. Help!',26124),
(37151,'enUS','It\'s got me!','It\'s got me!',26124),
(37152,'enUS','Waaah - I\'m gonna be sick!','Waaah - I\'m gonna be sick!',26124),
(37153,'enUS','Overloading','Overloading',26124),
(37154,'enUS','We must defend the Sunwell from the enemy at all costs.','',26124),
(37155,'enUS','I am ordering you to withdraw to the Sunwell proper to help prepare the defenses.','',26124),
(37156,'enUS','I will make my stand here and buy you as much time as I am able. Use it well and make our prince proud.','',26124),
(37157,'enUS','It has been a great honor to fight beside you in defense of our land and our people.','',26124),
(37158,'enUS','You, stranger... you are not one of my soldiers. Will you stay and stand with me to face the enemy?','',26124),
(37159,'enUS','Listen well, Scourge defilers. None of you will reach the Sunwell so long as I stand!','',26124),
(37160,'enUS','You will fall as your lands and your city have before you. My lord will win a great victory here, and none will remember your name!','',26124),
(37161,'enUS','A screeching cry pierces the air above!','',26124),
(37162,'enUS','Forward!','',26124),
(37163,'enUS','','They died so easily. No matter.',26124),
(37164,'enUS','Augh! I must rest for a moment. \n','',26124),
(37165,'enUS','Champions! I cannot hold her back any longer.','',26124),
(37166,'enUS','I would like to receive training.','I would like to receive training.',26124),
(37167,'enUS','I shall kill you myself!','',26124),
(37168,'enUS','','He\'s... too powerful. Heroes, quickly... come to me! We must leave this place at once! I will do what I can to hold him in place while we flee.',26124),
(37169,'enUS','','I cannot hold him for long, we must leave at once!',26124),
(37170,'enUS','','BLASTED DEAD END! So this is how it ends. Prepare yourselves, heroes, for today we make our final stand!',26124),
(37171,'enUS','','We are safe... for now. His strength has increased tenfold since our last battle. It will take a mighty army to destroy the Lich King. An army greater than even the Horde can rouse.',26124),
(37172,'enUS','Your allies have arrived, Jaina, just as you promised. You will all become powerful agents of the Scourge.','',26124),
(37173,'enUS','I will not make the same mistake again, Sylvanas. This time there will be no escape. You will all serve me in death!','',26124),
(37174,'enUS','Death\'s cold embrace awaits.','',26124),
(37175,'enUS','Succumb to the chill of the grave.','',26124),
(37176,'enUS','Another dead end.','',26124),
(37177,'enUS','There is no escape!','',26124),
(37178,'enUS','The forgemaster is dead! Get geared up men, we have a Scourgelord to kill.','',26124),
(37179,'enUS','Ready yourself, $c.$b$bThe time has come for the Lich King\'s reign to come to an end.','',26124),
(37180,'enUS','What is the Ashen Verdict?','What is the Ashen Verdict?',26124),
(37181,'enUS','The Ashen Verdict is a select group of the most talented craftsmen in the Ebon Blade and Argent Crusade. Its creation symbolizes the unity of our forces as we mount this final assault on the Lich King and his minions.$b$bIt is through the Ashen Verdict\'s efforts that we have discovered how to bend primordial saronite to our will.','',26124),
(37182,'enUS','How can I learn to work Primordial Saronite?','How can I learn to work Primordial Saronite?',26124),
(37183,'enUS','Speak with Alchemist Finklestein, $c. He can set you on the path.$b$bDemonstrate your loyalty and their methods shall be made known to you.','',26124),
(37184,'enUS','With Frostmourne, could I defeat the Lich King?','With Frostmourne, could I defeat the Lich King?',26124),
(37185,'enUS','Foolishness! Do you know nothing of that accursed blade, $c?$b$bIt would devour all that you are. Whatever remained of your lifeless husk would spend eternity in the enemy\'s service.$b$bIt is that same rationale that bought Arthas his fate, costing Azeroth legions of its best champions.$b$bStill, there may be something....','',26124),
(37186,'enUS','Tell me then, Highlord Mograine. What can be done?','Tell me then, Highlord Mograine. What can be done?',26124),
(37187,'enUS','I have pondered the matter unceasingly.$b$bI believe that a weapon might be fashioned which would rival Frostmourne in power without enslaving  its master.$b$bNevermind it, $r. Even if it were possible, there\'s not time to create such an artifact.$b$bIt is best that you focus your energies on our assault.','',26124),
(37188,'enUS','If there is any hope, you must allow me to try!','If there is any hope, allow me to try!',26124),
(37189,'enUS','Perhaps, $c... perhaps.$b$bBut if you would be the one to attempt its creation, you must learn the ways of the Argent Verdict Forgemasters.$b$bAssociate yourself with them and show them your loyalty and dedication.$b$bWhen this is done, we shall discuss the matter further.','Perhaps, $c... perhaps.$b$bBut if you would be the one to attempt its creation, you must learn the ways of the Argent Verdict Forgemasters.$b$bAssociate yourself with them and show them your loyalty and dedication.$b$bWhen this is done, we shall discuss the matter further',26124),
(37190,'enUS','Capturing','Capturing',26124),
(37191,'enUS','Please, tell me more of this artifact, Highlord Mograine.','Please, tell me more of this artifact, Highlord Mograine.',26124),
(37192,'enUS','Perhaps, $c... perhaps.$b$bBut if you would be the one to attempt its creation, you must learn the ways of the Argent Verdict Forgemasters.$b$bAssociate yourself with them and prove your loyalty and dedication.$b$bWhen this is done, we shall discuss the matter further.','',26124),
(37193,'enUS','What is Shadowfrost?','What is Shadowfrost?',26124),
(37194,'enUS','First, the blade must be fed with the souls of those who serve our enemy. Then, before the blade draws upon their power, I must encase it in Shadowfrost. This will insulate you from the corrupting voices that would otherwise consume you... I hope. ','',26124),
(37195,'enUS','The Lich King is near, $n. His voice taunts me...$b$bLet us silence him at last!','',26124),
(37196,'enUS','I... I wasn\'t meant to survive this attack.','',26124),
(37197,'enUS','Why has this happened? Why have you come here?','',26124),
(37198,'enUS','It\'s Quel\'Delar! You possess the sword!','',26124),
(37199,'enUS','I don\'t know how, but the blade has chosen you to be its new wielder. Take it with my blessing, and wield it against the Scourge as I once did.','',26124),
(37200,'enUS','Ages ago the demon lord Kil\'jaeden subjected the shaman, Ner\'zhul, to a seemingly endless torture before sealing his soul in a frozen crystal. It is this prison, forged in the depths of the twisting nether, that we have come to call the Frozen Throne.$b$bIt was not until Arthas smashed the crystal with Frostmourne that he merged with the soul of Ner\'zhul and became the Lich King. This breaking of the throne created the frozen fragments of [shadowfrost] that now lie scattered throughout the citadel.','',26124),
(37201,'enUS','Halt! Do not carry that blade any further!','',26124),
(37202,'enUS','Do you realize what you\'ve done?','',26124),
(37203,'enUS','Another faulty electrical-gas-flammable bed-fireworks accident?!','',26124),
(37204,'enUS','You have forged this blade from saronite, the very blood of an old god. The power of the Lich King calls to this weapon.','',26124),
(37205,'enUS','There is only one way to cleanse this sword. Make haste for the Sunwell and immerse the blade in its waters.','',26124),
(37206,'enUS','I can resist Frostmourne\'s call no more...','',26124),
(37207,'enUS','Why must I retrieve Light\'s Vengeance?','Why must I retrieve Light\'s Vengeance?',26124),
(37208,'enUS','There is great potential in the hammer Arthas cast aside when he took up Frostmourne.$b$bIt has helped to bring about events that have shaped this world\'s destiny. It possesses a great capacity for power that few comprehend.$b$bWith ample saronite I can reforge the hammer into an artifact to rival Frostmourne itself.$b$bIt is then that your most dangerous trial begins....','',26124),
(37209,'enUS','I am eager to begin our work, Highlord Mograine!','I am eager to begin our work, Highlord Mograine!',26124),
(37210,'enUS','Bridle your enthusiasm, $r.$b$bYou embark upon a fool\'s errand that will likely be your undoing. Forces that have corrupted the most noble among us will relentlessly assault you.$b$bKnow this; succumb and I shall have no choice but to deliver you from this world.','',26124),
(37211,'enUS','%s prepares to attack!','',26124),
(37212,'enUS','Get on board, now! This whole mountainside could collapse at any moment.','',26124),
(37213,'enUS','Quickly, climb aboard! We mustn\'t tarry here! There\'s no telling when this whole mountainside will collapse.','',26124),
(37214,'enUS','Defend the hill!','',26124),
(37215,'enUS','Success! The hill is yours!','',26124),
(37216,'enUS','Defeat! The defenders couldn\'t hold the hill.','',26124),
(37217,'enUS','The Grimtotem will never surrender!','',26124),
(37218,'enUS','Tiny creatures under feet, you bring Garfrost something good to eat!','',26124),
(37219,'enUS','Will save for snack. For later.','',26124),
(37220,'enUS','That one maybe not so good to eat now. Stupid Garfrost! BAD! BAD!','',26124),
(37221,'enUS','Garfrost hope giant underpants clean. Save boss great shame. For later.','',26124),
(37222,'enUS','Our work must not be interrupted! Ick, take care of them!','',26124),
(37223,'enUS','We could probably use these parts.','',26124),
(37224,'enUS','Arms and legs are in short supply! Thanks for your contribution!','',26124),
(37225,'enUS','I\'ve changed my mind, go get that one instead!','',26124),
(37226,'enUS','What are you attacking him for? The dangerous one is over there!','',26124),
(37227,'enUS','Yo! I\'m here representing the Crown Chemical Company.$B$BYou looking for a gift? A job? Maybe a little something for yourself? Well, you\'ve come to the right place, friend.$B$BIf I don\'t have what you need, our mascot Kwee or the Lovely Merchant beside me will.','',26124),
(37228,'enUS','Okay, Sassy, I\'m ready to go.','Okay, Sassy, I\'m ready to go.',26124),
(37229,'enUS','We\'ll make use of these supplies to get everyone ready for a fight.$B$BContinue on. We\'ll meet you ahead.','',26124),
(37230,'enUS','I\'ll gather up the rest of slaves and get them ready to fight. We\'ll catch up with you before you engage Scourgelord Tyrannus.','',26124),
(37231,'enUS','From the safety of Camp Taurajo I once trained young hunters in the ways of the wild.$B$BWe have no such luxury now - skills must be learned in the heat of battle against a foe camped on our very doorstep.','',26124),
(37232,'enUS','Heroes! We will hold off the undead as long as we can, even to our dying breath. Deal with the Scourgelord!','',26124),
(37233,'enUS','Alas, brave, brave adventurers, your meddling has reached its end. Do you hear the clatter of bone and steel coming up the tunnel behind you? That is the sound of your impending demise.','',26124),
(37234,'enUS','Ha, such an amusing gesture from the rabble. When I have finished with you, my master\'s blade will feast upon your souls. Die.','',26124),
(37235,'enUS','We will follow your lead, heroes. The Scourgelord will die this eve.','',26124),
(37236,'enUS','scatters a handful of grain into the wind.','',26124),
(37237,'enUS','Thank you!','Thank you!',26124),
(37238,'enUS','It\'s true then?  Even those afflicted by the Curse are fighting the Forsaken!','It\'s true then?  Even those afflicted by the Curse are fighting the Forsaken!',26124),
(37239,'enUS','The Forsaken will pay for what they\'ve done!','The Forsaken will pay for what they\'ve done!',26124),
(37240,'enUS','What\'s this I hear about a party? I wasn\'t invited!','',26124),
(37241,'enUS','You\'re all lazy! Get back to work. Especially you, $n!','',26124),
(37242,'enUS','It\'s demotions for everyone if the Sharks beat the Buccaneers!','',26124),
(37243,'enUS','Is that you, $n? What are you doing away from headquarters? Get back to work!','',26124),
(37244,'enUS','All hail the greatest trade prince on Azeroth... me!','',26124),
(37245,'enUS','Thank you for your hard work and dedication. Unpaid overtime is approved for all!','',26124),
(37246,'enUS','Drink Kaja\'Cola!','',26124),
(37247,'enUS','I\'m beginning to regret promoting you, $n!','',26124),
(37248,'enUS','So, it has begun....','',26124),
(37249,'enUS','Behold! The binding of sacred and corrupt; the forging of Shadow\'s Edge, a weapon of untold potential!','',26124),
(37250,'enUS','Bend it to your will, and you shall wield unspeakable power!','',26124),
(37251,'enUS','Fail, and your soul shall forever be its slave.\n','',26124),
(37252,'enUS','A final warning, mortal; Fail, and you shall fall by my hand!\n\n','',26124),
(37253,'enUS','Work harder, you maggots!  This ore is not going to mine itself!','',26124),
(37254,'enUS','Consider yourselves lucky to be alive, Gilnean dogs!  Now get to work before we change our minds!','',26124),
(37255,'enUS','This mine and everything in it are now property of Queen Sylvanas.  That includes all you worms -- so get back to work!','',26124),
(37256,'enUS','','Hang on! I\'m putting the pedal to the metal!!!',26124),
(37257,'enUS','','We\'ll have to go around.',26124),
(37258,'enUS','','OUT OF THE WAY!',26124),
(37259,'enUS','','Here we are, safe and... OH NO! We\'ve been double-crossed!',26124),
(37260,'enUS','%s casts |cFF00AACCDeep Freeze|r at $n.','',26124),
(37261,'enUS','Thank you, heroes. I will stay behind and round up the slaves as you free them. If you kill the Forgemaster to the east, we should be able to get ourselves equipped for battle.','',26124),
(37262,'enUS','I thought I might die in this pit. Thank you!','I thought I might die in this pit. Thank you!',26124),
(37263,'enUS','I owe you a long night of drinking, my friend.','Have my babies.',26124),
(37264,'enUS','Don\'t let a single one of them live.','Don\'t let a single one of them live.',26124),
(37265,'enUS','Please, carry out our vengeance on the Scourgelord.','Please, carry out our vengeance on the Scourgelord.',26124),
(37266,'enUS','When you kill the Pit Master, spit on his corpse for me, will you?','When you kill the Pit Master, spit on his corpse for me, will you?',26124),
(37267,'enUS','I can barely feel my arms, but I\'ll stand with you once I find some weapons.','I can barely feel my arms, but I\'ll stand with you once I find some weapons.',26124),
(37268,'enUS','I\'d lost all track of time in this forsaken place. You\'re a sight for sore eyes, friend.','I\'d lost all track of time in this forsaken place. You\'re a sight for sore eyes, friend.',26124),
(37269,'enUS','You\'re a beautiful sight... you have no idea.','You\'re a beautiful sight... you have no idea.',26124),
(37270,'enUS','Too many of us died in this pit. Far too many.','Too many of us died in this pit. Far too many.',26124),
(37271,'enUS','I\'m so glad you\'re here. I wouldn\'t have made it much longer.','I\'m so glad you\'re here. I wouldn\'t have made it much longer.',26124),
(37272,'enUS','I\'ll join you as soon as I catch my breath, heroes. Thank you.','I\'ll join you as soon as I catch my breath, heroes. Thank you.',26124),
(37273,'enUS','Now is the time for revenge.','Now is the time for revenge.',26124),
(37274,'enUS','You deserve a mighty man-hug.','I could just kiss you!',26124),
(37275,'enUS','I will find a way to repay you someday, hero.','I will find a way to repay you someday, hero.',26124),
(37276,'enUS','I can hardly believe my eyes. Thank you. Really, thank you.','I can hardly believe my eyes. Thank you. Really, thank you.',26124),
(37277,'enUS','%s nods his thanks.','%s nods her thanks.',26124),
(37278,'enUS','%s offers an appreciative smile.','%s offers an appreciative smile.',26124),
(37279,'enUS','%s almost collapses as he stumbles towards you.','%s almost collapses as he stumbles towards you.',26124),
(37280,'enUS','%s stares at you for a moment, clearly finding it hard to believe that you\'re real.','%s stares at you for a moment, clearly finding it hard to believe that you\'re real.',26124),
(37281,'enUS','%s offers a quick, cynical laugh at his fortune.','%s offers a quick, cynical laugh at her fortune.',26124),
(37282,'enUS','%s raises an empty hand in toast to you.','%s blows a kiss your way.',26124),
(37283,'enUS','%s closes his eyes, savoring freedom for a moment.','%s closes her eyes, savoring freedom for a moment.',26124),
(37284,'enUS','%s lets his mining pick drag on the ground as she approaches, clearly exhausted.','%s lets her mining pick drag on the ground as she approaches, clearly exhausted.',26124),
(37285,'enUS','I\'m with you, hero.','I\'m with you, hero.',26124),
(37286,'enUS','I owe you my life.','I owe you my life.',26124),
(37287,'enUS','If by life or death I can repay you, I will.','If by life or death I can repay you, I will.',26124),
(37288,'enUS','I\'ll fight by your side. Offer them no mercy.','I\'ll fight by your side. Offer them no mercy.',26124),
(37293,'enUS','I\'m going to return to help free the rest of the slaves.  Thank you again, hero.','I\'m going to return to help free the rest of the slaves.  Thank you again, hero.',26124),
(37294,'enUS','I\'m going to return to the front of the quarry. Kill a few extra for me.','I\'m going to return to the front of the quarry. Kill a few extra for me.',26124),
(37295,'enUS','','The Barrens may be dry, but these plains once teemed with life. We roamed, we hunted, and we lived off the land.$B$BThen the Alliance came... slashing, burning, killing. We call these the Fields of Blood now, $c.$B$BThe refugees have all fled. Those who remain behind remain to fight.',26124),
(37296,'enUS','','The gate\'s meager defenses are prepared, $n. Are you?',26124),
(37297,'enUS','','Thank you, $n! With Baine and our Horde allies working together, we may yet push the invaders back to the swamp they washed in from.',26124),
(37298,'enUS','Placeholder! WHAMS!','',26124),
(37299,'enUS','I am ready. Send me to the gates!','I am ready. Send me to the gates!',26124),
(37300,'enUS','Stickybombing','Stickybombing',26124),
(37301,'enUS','Ghouls, slay this pathetic high elf!','',26124),
(37302,'enUS','You will fall before the might of the Scourge. Crypt raiders, attack!','',26124),
(37303,'enUS','This is an Emergency Evacuation Portal.','',26124),
(37304,'enUS','Take me out of the city.','Take me out of the city.',26124),
(37305,'enUS','','$n - please see me. I need your help.',26124),
(37306,'enUS','Be on your guard! The weather worsens, and the elementals are soon to follow! Seek shelter!','Be on your guard! The weather worsens, and the elementals are soon to follow! Seek shelter!',26124),
(37307,'enUS','Clear the streets!  The skies darken and elementals will soon attack.  Be on your guard!','Clear the streets!  The skies darken and elementals will soon attack.  Be on your guard!',26124),
(37308,'enUS','The disease has been cured and you feel normal again!','',26124),
(37309,'enUS','Hurry it up. The soldiers have already pulled out of here.','Hurry it up. The soldiers have already pulled out of here.',26124),
(37310,'enUS','Grab anything you think we can fence.','Grab anything you think we can fence.',26124),
(37311,'enUS','Have we cleaned out the inn yet? Burn the rest of it when you\'re done!','Have we cleaned out the inn yet? Burn the rest of it when you\'re done!',26124),
(37312,'enUS','Most of this stuff is beads and hides. Where\'s all the treasure?','Most of this stuff is beads and hides. Where\'s all the treasure?',26124),
(37313,'enUS','Time is wasting. I want this place picked clean before they counter-attack.','Time is wasting. I want this place picked clean before they counter-attack.',26124),
(37314,'enUS','Hey, did anyone loot the mailbox yet?','Hey, did anyone loot the mailbox yet?',26124),
(37315,'enUS','There\'s got to be more. Doublecheck the bodies!','There\'s got to be more. Doublecheck the bodies!',26124),
(37316,'enUS','Unwrap your Awesome Party Ensemble and wear your Cool Shades, Hip New Outfit, and Shiny Bling!','Unwrap your Awesome Party Ensemble and wear your Cool Shades, Hip New Outfit, and Shiny Bling!',26124),
(37317,'enUS','Has anyone seen the quilboar they had caged up over here?','Has anyone seen the quilboar they had caged up over here?',26124),
(37318,'enUS','','Go get \'em, boss!',26124),
(37319,'enUS','I ran to wake up the others when the attack hit. Were they able to escape? I tried to fight off the soldiers with a skinning knife...','',26124),
(37320,'enUS','Brave champions, we owe you our lives, our freedom.... Though it be a tiny gesture in the face of this enormous debt, I pledge that from this day forth, all will know of your deeds, and the blazing path of light you cut through the shadow of this dark citadel. ','',26124),
(37321,'enUS','This day will stand as a testament not only to your valor, but to the fact that no foe, not even the Lich King himself, can stand when Alliance and Horde set aside their differences and---','',26124),
(37322,'enUS','I can feel the embrace now of all living things, the Earthmother\'s eternal peace. Thank you.','',26124),
(37323,'enUS','','Alliance - they\'ve surrounded the camp! What are they doing here? Why are they attacking Taurajo? Get the children - run! RUN!',26124),
(37324,'enUS','No, stay with the others. Escort them north, away from the fighting. I will stay here with the wyverns and cover your escape. Go!','',26124),
(37325,'enUS','...wait, it is over? I\'ve been run through ... Ah. Of course. I understand now. I am expected elsewhere.','',26124),
(37326,'enUS','I\'ve got it: Squeezeable rocks!','I\'ve got it: Squeezeable rocks!',26124),
(37327,'enUS','Leashes... with pre-attached pets.','Leashes... with pre-attached pets.',26124),
(37328,'enUS','Shirts with leg-holes. Reversable shirtshorts!','Shirts with leg-holes. Reversable shirtshorts!',26124),
(37329,'enUS','Tauren Paladins!','Tauren Paladins!',26124),
(37330,'enUS','Chocolate-flavored vanilla!','Chocolate-flavored vanilla!',26124),
(37331,'enUS','Motorized gravy-boat. With laser lump vaporizer.','Motorized gravy-boat. With laser lump vaporizer.',26124),
(37332,'enUS','Headshoes!','Headshoes!',26124),
(37333,'enUS','How about this: Instant water! Just add... oh.','How about this: Instant water! Just add... oh.',26124),
(37334,'enUS','So I have this idea for a movie. Three gnomes find a bracelet of power...','So I have this idea for a movie. Three gnomes find a bracelet of power...',26124),
(37335,'enUS','It\'s like bungie-jumping, right? But without a cord, see? And you start at the bottom. I guess it\'s just sorta like regular jumping. But with guns.','It\'s like bungie-jumping, right? But without a cord, see? And you start at the bottom. I guess it\'s just sorta like regular jumping. But with guns.',26124),
(37336,'enUS','Edible rocket fuel!','Edible rocket fuel!',26124),
(37337,'enUS','Portable gasoline squirt-guns!','Portable gasoline squirt-guns!',26124),
(37338,'enUS','Half man...half sharkalligator!','Half man...half sharkalligator!',26124),
(37339,'enUS','Thirteen-sided dice!','Thirteen-sided dice!',26124),
(37340,'enUS','Goblins with gills!','Goblins with gills!',26124),
(37341,'enUS','Attach two vehicles to a bigger vehicle, and then have the passengers jump from one vehicle to the other!','Attach two vehicles to a bigger vehicle, and then have the passengers jump from one vehicle to the other!',26124),
(37342,'enUS','Electrical wires used to send messages over great distances... no, impractical. Giant rockets, with speakers attached....','Electrical wires used to send messages over great distances... no, impractical. Giant rockets, with speakers attached....',26124),
(37343,'enUS','Feed pigs rubber, \'til they bounce. There\'s got to be an application for that.','Feed pigs rubber, \'til they bounce. There\'s got to be an application for that.',26124),
(37344,'enUS','Murder permits!','Murder permits!',26124),
(37345,'enUS','Gloves with built-in clappers, for hands-free clapping.','Gloves with built-in clappers, for hands-free clapping.',26124),
(37346,'enUS','State-sponsored healthcare!','State-sponsored healthcare!',26124),
(37347,'enUS','A truck that delivers ice-cream. With a catapult.','A truck that delivers ice-cream. With a catapult.',26124),
(37348,'enUS','How about smiling monkey wallets?','How about smiling monkey wallets?',26124),
(37349,'enUS','Dwarves. In. Space!','Dwarves. In. Space!',26124),
(37350,'enUS','A spring-loaded plunger with blades attached, for processing food. Or people you disagree with.','A spring-loaded plunger with blades attached, for processing food. Or people you disagree with.',26124),
(37351,'enUS','Bathrobes with integrated shower-nozzles.','Bathrobes with integrated shower-nozzles.',26124),
(37352,'enUS','Clowns. Except instead of making you laugh, they\'re there for beating.','Clowns. Except instead of making you laugh, they\'re there for beating.',26124),
(37353,'enUS','Nose-stenders. For smelling things in different rooms.','Nose-stenders. For smelling things in different rooms.',26124),
(37354,'enUS','Invisible bunnies!  We\'ll put them all over the place, and they\'ll control everything!','Invisible bunnies!  We\'ll put them all over the place, and they\'ll control everything!',26124),
(37355,'enUS','What if we were to ORGANIZE crime?','What if we were to ORGANIZE crime?',26124),
(37356,'enUS','We put a whole town... in a tiny little box!','We put a whole town... in a tiny little box!',26124),
(37357,'enUS','A big convention, see? To show off all of our inventions. We\'ll call it GoblinCon. And we\'ll give away special pets! Except most people will probably sell them for profit on the auction house.','A big convention, see? To show off all of our inventions. We\'ll call it GoblinCon. And we\'ll give away special pets! Except most people will probably sell them for profit on the auction house.',26124),
(37358,'enUS','A binary number system. It uses only two numbers. 6 and 11.','A binary number system. It uses only two numbers. 6 and 11.',26124),
(37359,'enUS','Giant gnomes. No, wait... tiny giants!','Giant gnomes. No, wait... tiny giants!',26124),
(37360,'enUS','Invisible condiments. For an unobstructed view of your food.','Invisible condiments. For an unobstructed view of your food.',26124),
(37361,'enUS','Shoes with wheels on them. And gloves with wheels - for when you fall down.','Shoes with wheels on them. And gloves with wheels - for when you fall down.',26124),
(37362,'enUS','Soap on a rope! Attached to a chain. Mounted via a steel cable. To some soap.','Soap on a rope! Attached to a chain. Mounted via a steel cable. To some soap.',26124),
(37363,'enUS','Edible beds. So you can have breakfast in bed. Beds... for breakfast!','Edible beds. So you can have breakfast in bed. Beds... for breakfast!',26124),
(37364,'enUS','A globe that shows the inside of the planet... on the outside. So you know where to dig!','A globe that shows the inside of the planet... on the outside. So you know where to dig!',26124),
(37365,'enUS','Stairways... for horizontal surfaces!','Stairways... for horizontal surfaces!',26124),
(37366,'enUS','Hey, pal, I don\'t know who you are or why you\'ve been following me around, but I\'m about to board a ship and I want to be left alone, got it?','',26124),
(37367,'enUS','I have a rocket here with your mark on it, Snivel.','I have a rocket here with your mark on it, Snivel.',26124),
(37368,'enUS','%s casts |cFFFFFF00Mirrored Soul!|r','',26124),
(37369,'enUS','','Excellent work, champions! We shall set up our base camp in these chambers. My magi will get the Scourge transport device working shortly. Step inside it when you are ready for your next mission. I will meet you on the other side.',26124),
(37370,'enUS','','Thank the Light for seeing you here safely! We have much work to do if we are to defeat the Lich King and put an end to the Scourge.',26124),
(37371,'enUS','','Our allies within the Argent Crusade and the Knights of the Ebon Blade have broken through the front gate of Icecrown and are attempting to establish a foothold within the citadel. ',26124),
(37372,'enUS','','Their success hinges upon what we discover within these cursed halls. Although our mission is fraught with peril, we must persevere!',26124),
(37373,'enUS','','With the attention of the Lich King drawn towards the front gate, we will be working our way through the side in search of information that will enable us to defeat the Scourge once and for all.',26124),
(37374,'enUS','','King Varian\'s SI:7 agents have gathered information about a private sanctum of the Lich King\'s deep within a place called the Halls of Reflection. ',26124),
(37375,'enUS','','We will carve a path through this wretched place and find a way to enter the Halls of Reflection. I sense powerful magic hidden away within those halls. Magic that could be the key to destroying the Scourge!',26124),
(37376,'enUS','','Your first mission is to destroy the machines of death within this malevolent engine of souls and clear a path for our soldiers. ',26124),
(37377,'enUS','','Make haste, champions! I will prepare the troops to fall in behind you.',26124),
(37379,'enUS','Grabbing','Grabbing',26124),
(37380,'enUS','','The Argent Crusade and the Knights of the Ebon Blade have assaulted the gates of the Icecrown Citadel and are preparing for a massive attack upon the Scourge. Our mission is a bit more subtle, but equally as important.',26124),
(37381,'enUS','','With the attention of the Lich King turned towards the front gate, we\'ll be working our way through the side in search of information that will enable us to defeat him - once and for all.',26124),
(37382,'enUS','','Our scouts have reported that the Lich King has a private chamber, outside of the Frozen Throne, deep within a place called the Halls of Reflection. That is our target, champions. ',26124),
(37383,'enUS','','We will cut a swath of destruction through this cursed place and find a way to enter the Halls of Reflection. If there is anything of value to be found here, it will be found in the halls.',26124),
(37384,'enUS','','The Dark Lady watches over you. Make haste!',26124),
(37387,'enUS','','Excellent work, champions! We shall set up our base camp in these chambers. My magi will get the Scourge transport device working shortly. Step inside when you are ready for your next mission. I will meet you on the other side.',26124),
(37388,'enUS','So it is. You have my thanks, $n, for restoring Quel\'Delar to its rightful owners.','',26124),
(37389,'enUS','What is the meaning of this treachery?','',26124),
(37390,'enUS','Drop your weapon and surrender, traitor.','',26124),
(37391,'enUS','Our champions have lost much blood in the struggle to activate this Scourge transporter. We must be prepared to return the favor. Follow me, men!','',26124),
(37392,'enUS','','Soldiers of the Horde, attack!',26124),
(37393,'enUS','','Pathetic weaklings.',26124),
(37394,'enUS','','You will have to battle your way through this cesspit on your own.',26124),
(37395,'enUS','','Free any Horde slaves that you come across. We will most certainly need their assistance in battling Tyrannus. I will gather reinforcements and join you on the other side of the quarry.',26124),
(37397,'enUS','','I will delay here until more reinforcements arrive, but you must keep moving. Arthas will soon realize that we\'re here.',26124),
(37398,'enUS','Bloody Forsaken!  They\'ll pay for what they\'ve done!','',26124),
(37399,'enUS','This is our land -- they\'re not going to take it away without a fight!','',26124),
(37400,'enUS','We will not die as slaves... we\'re Gilneans!','',26124),
(37401,'enUS','Drink Kaja\'Cola!','',26124),
(37402,'enUS','All new Kaja\'Cola! Now with 100 percent more ideas!','',26124),
(37403,'enUS','Take the Kaja\'Cola Taste Test Challenge!','',26124),
(37404,'enUS','Kaja\'Cola! It gives you IDEAS!','',26124),
(37405,'enUS','Kaja\'Cola! Jinxy the Weasel says, Drink it... or else!','',26124),
(37406,'enUS','Kaja\'Cola is a proud sponsor of the Bilgewater Buccaneers!','',26124),
(37407,'enUS','Kaja\'Cola! When your tinkering has to be second to none!','',26124),
(37408,'enUS','Enjoy the refreshingly intelligent taste of all new Kaja\'Cola!','',26124),
(37409,'enUS','Corpse-men take Koroth\'s banner!  Corpse-men get smashed to bitses!!!','',26124),
(37410,'enUS','Just in time, $n.  Here come the Forsaken.','',26124),
(37411,'enUS','You will come no further, Forsaken scum!  By the war banner of the ancient Greymane clan, I expel you from our ancestral lands!','',26124),
(37412,'enUS','Worthless mongrel.  I will order our outhouses cleaned with this rag you call a banner.','',26124),
(37413,'enUS','Fake food! Created by grinding up real food and pressing it into shapes of different food. With artificial flavoring!','Fake food! Created by grinding up real food and pressing it into shapes of different food. With artificial flavoring!',26124),
(37414,'enUS','Mom detectors.','Mom detectors.',26124),
(37415,'enUS','Houses made of dirt! When you clean them... THEY\'RE GONE.','Houses made of dirt! When you clean them...THEY\'RE GONE.',26124),
(37416,'enUS','Recycling! But, for stuff that\'s never been used before.','Recycling! But, for stuff that\'s never been used before.',26124),
(37417,'enUS','Flerberts. I\'m not sure what they do, but I\'d better lock down the name with a trademark.','Flerberts. I\'m not sure what they do, but I\'d better lock down the name with a trademark.',26124),
(37418,'enUS','Spoon sharpeners!','Spoon sharpeners!',26124),
(37419,'enUS','One-sided paper!','One-sided paper!',26124),
(37420,'enUS','Bagel-holes!','Bagel-holes!',26124),
(37421,'enUS','Water-proof soap!  For underwater use!','Water-proof soap!  For underwater use!',26124),
(37422,'enUS','Handheld one-way mirrors!','Handheld one-way mirrors!',26124),
(37423,'enUS','Mouse-sized beartraps... no... Bear-sized mousetraps!!','Mouse-sized beartraps... no... Bear-sized mousetraps!!',26124),
(37424,'enUS','Upside-down boats!  They\'ll never capsize!','Upside-down boats!  They\'ll never capsize!',26124),
(37425,'enUS','Explosive fire extinguishers!  We\'ll fight fire... WITH fire!','Explosive fire extinguishers!  We\'ll fight fire... WITH fire!',26124),
(37426,'enUS','Tether-footbomb!','Tether-footbomb!',26124),
(37427,'enUS','Games you can play with your face!','Games you can play with your face!',26124),
(37428,'enUS','String-less kites!','String-less kites!',26124),
(37429,'enUS','Earwax. It\'s got to be good for SOMETHING.','Earwax. It\'s got to be good for SOMETHING.',26124),
(37430,'enUS','This is not my doing, Rommath. There is no treachery here.','',26124),
(37431,'enUS','Call off your men. Lor\'themar\'s own foolishness caused his injuries. Quel\'Delar is not chosen; it chooses its master.','',26124),
(37432,'enUS','Guards, return to your posts.','',26124),
(37433,'enUS','It seems the captain is correct. Quel\'Delar is not to be ours after all.','',26124),
(37434,'enUS','You will have what you have come for, $n. Take the sword and begone. And you, Auric, have a care what you say in this sacred place.','',26124),
(37435,'enUS','By the light, the transporter worked!','',26124),
(37436,'enUS','The chill of this place freezes the marrow of my bones. ','',26124),
(37437,'enUS','I can feel the Lich King reaching out...watching us. ','',26124),
(37438,'enUS','%s hurls a massive saronite boulder at you!','',26124),
(37439,'enUS','My Lord Regent! What have they done to you?','',26124),
(37440,'enUS','Carry the sword back to Dalaran through that portal, $n. You have done what many quel\'dorei have dreamt of for years. Quel\'Delar has been restored at last.','',26124),
(37441,'enUS','Can that really be Quel\'Delar?','',26124),
(37442,'enUS','We shall see.','',26124),
(37443,'enUS','The master\'s sanctum has been disturbed!','',26124),
(37444,'enUS','Look at it, Lor\'themar. It is certainly Quel\'Delar.','',26124),
(37445,'enUS','\'Twas a fierce battle, $n! Take a moment to rest and gather yer forces. Who knows what lies beyond that door?$B$BLet me know when yer ready and we\'ll begin our ascent into the upper reaches of the citadel.','',26124),
(37446,'enUS','We\'re ready, Muradin.','We\'re ready, Muradin.',26124),
(37447,'enUS','Are ye sure, $g lad:lass;? Ye don\'t need another minute or two?','',26124),
(37448,'enUS','We\'re sure. Let\'s go!','We\'re sure. Let\'s go!',26124),
(37449,'enUS','It is indeed Quel\'Delar. I had not thought I\'d live to see the day when Thalorien Dawnseeker\'s legendary sword would be restored to us.','',26124),
(37450,'enUS','You are a hero and an inspiration to the sin\'dorei, $n, a symbol of our endurance in the face of tragedy and treachery.','',26124),
(37451,'enUS','The regent speaks truly, $n. Thalorien\'s sacrifice could not prevent the fall of this very Sunwell.','',26124),
(37452,'enUS','When you found the sword, it was broken and abandoned, much like Silvermoon after Kael\'thas\'s betrayal.','',26124),
(37453,'enUS','Let Quel\'Delar be a sign that we will never give up, that we will face any enemy without fear.','',26124),
(37454,'enUS','Quel\'Delar is not held in high esteem by the sin\'dorei alone. It holds a place in the heart of all children of Silvermoon.','',26124),
(37455,'enUS','This blade has been returned to us for a reason, my lords. Now is the time to rally behind the bearer of Quel\'Delar and avenge the destruction of Silvermoon and the Sunwell.','',26124),
(37456,'enUS','Reclaim the sword, $n, and bear it through that portal to Dalaran. Archmage Aethas Sunreaver will be waiting to congratulate you.','',26124),
(37457,'enUS','Let\'s get a move on then! Move ou...','',26124),
(37458,'enUS','For every Horde soldier that you killed -- for every Alliance dog that fell, the Lich King\'s armies grew. Even now the val\'kyr work to raise your fallen as Scourge.\n','',26124),
(37459,'enUS','Things are about to get much worse. Come, taste the power that the Lich King has bestowed upon me!','',26124),
(37460,'enUS','A lone orc against the might of the Alliance???','',26124),
(37461,'enUS','Charge!!!\n','',26124),
(37462,'enUS','This is Desolation Hold, $c. Here we bide our time until we are ready to strike back against the Alliance.','',26124),
(37463,'enUS','Make this quick, $c. The Warchief personally sent me to evaluate our progress in the Barrens, and when I get here I find our towns aflame and Alliance dogs running amok.','',26124),
(37464,'enUS','You have a lot of potential, $n. I\'m going to need soldiers like you if we\'re going to regain the initiative here in the Barrens.','',26124),
(37465,'enUS','I knew this was a dragonforged blade when I first laid eyes on it.','',26124),
(37466,'enUS','But can it be? Is this really --','',26124),
(37467,'enUS','Are you ready to ride to Desolation Hold as my Vanguard, $n?$B$BGar\'dul may try to give you the runaround. Let him know his judgment is coming.','',26124),
(37468,'enUS','I am ready to ride, Warlord!','I am ready to ride, Warlord!',26124),
(37469,'enUS','The style of this blade and its markings hinted that it might be a dragonforged sword. At last, we will have our answer.','',26124),
(37470,'enUS','After all these years, can it really be --','',26124),
(37471,'enUS','Dwarves...','',26124),
(37472,'enUS','I\'m here on behalf of Warlord Bloodhilt, who wants you to know he will be arriving shortly.','I\'m here on behalf of Warlord Bloodhilt, who wants you to know he will be arriving shortly.',26124),
(37473,'enUS','Warlord Bloodhilt? Garrosh\'s pet?$B$BThere\'s no need for him to be here, as you can see, ah, tell him I have the situation well in hand.','',26124),
(37474,'enUS','I\'ll be sure to tell the Taurajo refugees that. Those that lived.','I\'ll be sure to tell the Taurajo refugees that. Those that lived.',26124),
(37475,'enUS','But, ah, supplies have been tight. I\'ve got, ah, a manpower shortage. Tell Bloodhilt that, ah -','',26124),
(37476,'enUS','Tell him yourself. He\'s almost here!','Tell him yourself. He\'s almost here!',26124),
(37477,'enUS','I... Am... Released...','',26124),
(37478,'enUS','','The Frost Queen is gone. We must keep moving - our objective is near.',26124),
(37479,'enUS','','Heroes, to me!',26124),
(37480,'enUS','','I... I could not save them... Damn you, Arthas! DAMN YOU!',26124),
(37481,'enUS','Don\'t delay, he\'s - ah - he\'s almost here!$B$BMeet me at the top of the northernmost tower.','',26124),
(37482,'enUS','Thank you, $n. I trust you will, ah, defer to my authority on this matter.','',26124),
(37483,'enUS','What do you need, $c?$b$bStormwind is under siege by elementals!  We have evacuated most of the city and our guards are fighting to hold the elementals at bay.$b$bI suggest you head to a safer area.  We do not have the manpower to defend the city and worry about you.','',26124),
(37484,'enUS','','Quel\'Delar.',26124),
(37485,'enUS','','As Quel\'Serrar was forged by the dragons and given to the kaldorei, its twin, Quel\'Delar, was given to my people.',26124),
(37486,'enUS','','The king bestowed the blade upon my friend, Thalorien Dawnseeker.',26124),
(37487,'enUS','','But even Thalorien\'s skill and Quel\'Delar\'s magic could not save Silvermoon from the might of the Scourge.',26124),
(37488,'enUS','','Thalorien fell before the gates of the Sunwell, buying time for others to escape.',26124),
(37489,'enUS','I swore that nothing would stir me to take up this blade again.$B$BI was a fool.','',26124),
(37490,'enUS','','After the battle, I recovered the sword from the field. I bore it to Northrend in the service of my prince, seeking to avenge our people\'s defeat.',26124),
(37491,'enUS','','Arthas shattered our forces and took the most powerful of us into his service as the San\'layn.',26124),
(37492,'enUS','','My memories of Thalorien went cold and so did his blade.',26124),
(37493,'enUS','','It was I who brought Quel\'Delar here, to return it to its makers. In breaking the weapon, so did I break its power.',26124),
(37494,'enUS','','Quel\'Delar will never serve another!',26124),
(37495,'enUS','So this is where you\'re hiding, Gar\'dul.','',26124),
(37496,'enUS','You cower behind your walls! If it wasn\'t for $n here the Alliance would be marching through Mulgore.','',26124),
(37497,'enUS','Your excuses sicken me! Consider yourself relieved of command.','',26124),
(37498,'enUS','So! You DO have a spine!','',26124),
(37499,'enUS','Hiding? Listen Bloodhilt - I\'ve, ah, reinforced our grip on the Barrens.','',26124),
(37500,'enUS','But they\'ve, ah, they\'ve gotten reinforcements! From the Eastern Kingdoms. Whereas I\'ve been, ah, cut off -','',26124),
(37501,'enUS','Relieved? Over my dead body!','',26124),
(37502,'enUS','%s gasps for air.','',26124),
(37503,'enUS','That was Saurfang\'s boy - the Horde commander at the Wrath Gate. Such a tragic end...','',26124),
(37504,'enUS','What in the... There, in the distance!\n','',26124),
(37505,'enUS','Soldiers, fall in! Looks like the Horde are comin\' to take another shot!\n','',26124),
(37506,'enUS','So predictable...','',26124),
(37507,'enUS','Did you truly expect to fulfill Mograine\'s task unopposed?','',26124),
(37508,'enUS','You both shall suffer as his father does...','',26124),
(37509,'enUS','...in eternal unrest!','',26124),
(37510,'enUS','Die well, fool.','',26124),
(37511,'enUS','','You are fools to have come to this place. The icy winds of Northrend will consume your souls!',26124),
(37512,'enUS','I\'ve got it this time!','',26124),
(37513,'enUS','%s cries out in death with an echoing roar.','',26124),
(37514,'enUS','It falls to us to see Quel\'Delar restored for the Sunreavers.','',26124),
(37515,'enUS','Wait, ah - wait! I yield. I yield!','',26124),
(37516,'enUS','Yield? You ... YIELD?','',26124),
(37517,'enUS','What part of \"Victory or Death\" don\'t you understand!?','',26124),
(37518,'enUS','I vow that the Silver Covenant will see Quel\'Delar restored.','',26124),
(37519,'enUS','This is it. I can sense that this was once the site of great tragedy; mortal suffering still echoes through it. No doubt this is what the horrors beyond have seized onto.$B$BTo fully seal this intrusion into our world, I must first fully open it. I will need your strength to hold back whatever may attempt to come through.$B$BAre you prepared?','',26124),
(37520,'enUS','I\'m ready, Naralex.','I\'m ready, Naralex.',26124),
(37521,'enUS','Opening','Opening',26124),
(37522,'enUS','Garrosh\'s Horde does not tolerate failure.','',26124),
(37523,'enUS','Meet me down below and we\'ll discuss our upcoming counter-attack.','',26124),
(37524,'enUS','Don\'t force me hand, orc. We can\'t let ye pass.','',26124),
(37525,'enUS','Behind you lies the body of my only son. Nothing will keep me from him. ','',26124),
(37526,'enUS','I... I can\'t do it. Get back on yer ship and we\'ll spare yer life. ','',26124),
(37527,'enUS','Stand down, Muradin. Let a grieving father pass.','',26124),
(37528,'enUS','Blood and thunder, my son.','',26124),
(37529,'enUS','I will not forget this... kindness. I thank you, Highness','',26124),
(37530,'enUS','I... I was not at the Wrath Gate, but the soldiers who survived told me much of what happened. Your son fought with honor. He died a hero\'s death. He deserves a hero\'s burial.','',26124),
(37531,'enUS','%s nods.','',26124),
(37532,'enUS','hmpf','',26124),
(37533,'enUS','You have done much in this war against the Scourge. May the light embrace you. ','',26124),
(37534,'enUS','The loss of our comrades was unpreventable. They lived and died in the service of the Argent Crusade.','',26124),
(37535,'enUS','What can possibly redeem this unholy place? Thank you.','',26124),
(37536,'enUS','Beware the dangers that lie ahead... and do try to remain in one piece. ','',26124),
(37537,'enUS','Rocket Pack Active!','Rocket Pack Active!',26124),
(37538,'enUS','Rocket Pack Disabled. Move closer to Zafod Boombox to re-activate.','Rocket Pack Disabled. Move closer to Zafod Boombox to re-activate.',26124),
(37539,'enUS','You\'ll make a great addition to Silas\' menagerie, Lobos.','',26124),
(37540,'enUS','','Take cover behind me! Quickly!',26124),
(37541,'enUS','','I thought he\'d never shut up. At last, Sindragosa silenced that long-winded fool. To the Halls of Reflection, champions! Our objective is near... I can sense it.',26124),
(37542,'enUS','','%s cries.',26124),
(37543,'enUS','Jaina? Why are you crying?','',26124),
(37544,'enUS','','%s wipes her tears away and smiles at King Varian Wrynn.',26124),
(37545,'enUS','Bah! Muradin, secure the deck and prepare our soldiers for an assault on the upper citadel. I\'ll send out another regiment from Stormwind.\n','',26124),
(37546,'enUS','','It was nothing, your majesty. Just... I\'m proud of my king.',26124),
(37547,'enUS','Right away, yer majesty!','',26124),
(37548,'enUS','','We have no time to waste, $c. Why do you delay here?',26124),
(37549,'enUS','What would you have of me, Banshee Queen?','What would you have of me, Banshee Queen?',26124),
(37550,'enUS','','We do not have much time, hero. What do you need?',26124),
(37551,'enUS','What would you have of me, my lady?','What would you have of me, my lady?',26124),
(37552,'enUS','Magister Hathorel said you might be able to lend me a certain tabard.','Magister Hathorel said you might be able to lend me a certain tabard.',26124),
(37553,'enUS','I\'ve brought in the best gnomes we\'ve got to get those doors open, $n! They\'re estimatin\' that it\'s gonna take another $4939W days before that door comes down!','',26124),
(37554,'enUS','<He looks at the rocket and flashes a nervous grin.>$b$bOkay, yeah, so maybe I made a couple rockets for some guys. So what? The gold was good and I was paid for my work. It\'s not like anyone died. That\'s about as honest as work gets. What\'s it to you?','',26124),
(37555,'enUS','There\'s a chemical inside the rocket. What is it?','There\'s a chemical inside the rocket. What is it?',26124),
(37556,'enUS','Look, I don\'t know, okay? I don\'t know!$b$bI just got paid to make rockets that deliver an airborne chemical payload, and that\'s what I did. Job\'s done, pal. They\'re all made, packaged, and sent off. I got the money and I was TRYING to enjoy myself a little when you started chasing me all over town.  I don\'t have any more of that chemical and I don\'t know what it was.','',26124),
(37557,'enUS','Where were they delivered?','Where were they delivered?',26124),
(37558,'enUS','You expect me to remember all that off the top of my head? Look. They didn\'t pay me enough to put up with this, and the contract only asked for my silence. So I\'m just gonna drop my ledger on the floor here, and you\'re going to take it and leave me alone.$b$bGot it?','',26124),
(37559,'enUS','Did you know about our \"Charitable Charms\" program?$B$BOfficial Crown event mascots like myself are authorized to distribute Lovely Charm Collector\'s Kits.$B$BYou can then use the Lovely Charms you gather to create Lovely Charm Bracelets for friends and loved ones, or turn them in to Lovely Merchants for Love Tokens!$B$BOne popular activity is making bracelets for your favorite leaders to let them know they\'re appreciated and adored...','',26124),
(37560,'enUS','Good show!','',26124),
(37561,'enUS','I\'d like a Lovely Charm Collector\'s Kit.','I\'d like a Lovely Charm Collector\'s Kit.',26124),
(37562,'enUS','I told you what I know, now shove off!','',26124),
(37563,'enUS','Whatever you need, Brazie Getz! Get it?$B$BAnd I\'m not just talkin\' about the \"legal\" stuff, either. WHATEVER YOU NEED, PAL! Anything...','',26124),
(37564,'enUS','','Standing this close to the blade that ended my life... The pain... It is renewed.',26124),
(37565,'enUS','I\'m not into any of that creepy stuff you like, Brazie. Just show me the \"legal\" wares.','I\'m not into any of that creepy stuff you like, Brazie. Just show me the \"legal\" wares.',26124),
(37566,'enUS','Can you remove the sword?','Can you remove the sword?',26124),
(37567,'enUS','Dark Lady, I think I hear Arthas coming. Whatever you\'re going to do, do it quickly.','Dark Lady, I think I hear Arthas coming. Whatever you\'re going to do, do it quickly.',26124),
(37568,'enUS','','I... I don\'t believe it! Frostmourne stands before us - unguarded - just as the gnome claimed. Come, heroes!',26124),
(37569,'enUS','','Standing this close to the blade that ended my life... The pain... It is renewed.',26124),
(37570,'enUS','','I dare not touch it. Stand back! Stand back as I attempt to commune with the blade! Perhaps our salvation lies within...',26124),
(37571,'enUS','','Uther... Uther the Lightbringer. How...',26124),
(37572,'enUS','','The Lich King is here? Then my destiny shall be fulfilled on this day! ',26124),
(37573,'enUS','','There must be a way...',26124),
(37574,'enUS','','Who could bear such a burden?',26124),
(37575,'enUS','','The Frozen Throne...',26124),
(37576,'enUS','','You will not escape me that easily, Arthas! I will have my vengeance! ',26124),
(37580,'enUS','You\'re late, courier. No, I don\'t want any excuses; this errand is far too important.','',26124),
(37581,'enUS','Here\'s the tome our representative brought from Wyrmrest. Get this to Myralion Sunblaze immediately.','',26124),
(37582,'enUS','Watch your back, courier. I needn\'t remind you of the value of the book, nor the fact that the Silver Covenant will stop at nothing to take it from us.','',26124),
(37583,'enUS','Careful, girl. I\'ve heard talk of that cursed blade saving us before. Look around you and see what has been born of Frostmourne.','',26124),
(37584,'enUS','You haven\'t much time. The Lich King sees what the sword sees. He will be here shortly. ','',26124),
(37585,'enUS','You cannot defeat the Lich King. Not here. You would be a fool to try. He will kill those that follow you and raise them as powerful soldiers of the Scourge. But for you, Sylvanas, his reward for you would be worse than the last.','',26124),
(37586,'enUS','Perhaps, but know this: there must always be a Lich King. Even if you were to strike down Arthas, another would have to take his place, for without the control of the Lich King, the Scourge would wash over this world like locusts, destroying all that they touched.','',26124),
(37587,'enUS','I do not know, Banshee Queen. I suspect that the piece of Arthas that might be left inside the Lich King is all that holds the Scourge from annihilating Azeroth.','',26124),
(37588,'enUS','Alas, the only way to defeat the Lich King is to destroy him at the place where he was created.','',26124),
(37589,'enUS','Aye. ARRRRRRGHHHH... He... He is coming. You... You must...','',26124),
(37590,'enUS','Uther shakes his head.','',26124),
(37591,'enUS','','The chill of this place... I can feel my blood freezing.',26124),
(37592,'enUS','','What is that! Up ahead! Could it be? Heroes, at my side!',26124),
(37593,'enUS','','Frostmourne: the blade that destroyed our kingdom...',26124),
(37594,'enUS','','Stand back! Touch that blade and your soul will be scarred for all eternity! I must attempt to commune with the spirits locked away within Frostmourne. Give me space. Back up, please. ',26124),
(37595,'enUS','','Uther! Dear Uther! I... I\'m so sorry.',26124),
(37596,'enUS','','Arthas is here? Maybe I...',26124),
(37597,'enUS','','But Uther, if there\'s any hope of reaching Arthas. I... I must try.',26124),
(37598,'enUS','','Tell me how, Uther? How do I destroy my prince? My...',26124),
(37599,'enUS','','You\'re right, Uther. Forgive me. I... I don\'t know what got a hold of me. We will deliver this information to the King and the knights that battle the Scourge within Icecrown Citadel.',26124),
(37600,'enUS','','Who could bear such a burden?',26124),
(37601,'enUS','','Then maybe there is still hope...',26124),
(37602,'enUS','','You won\'t deny me this, Arthas! I must know... I must find out... ',26124),
(37603,'enUS','Jaina! Could it truly be you?','',26124),
(37604,'enUS','Jaina, you haven\'t much time. The Lich King sees what the sword sees. He will be here shortly. ','',26124),
(37605,'enUS','No, girl. Arthas is not here. Arthas is merely a presence within the Lich King\'s mind. A dwindling presence...','',26124),
(37606,'enUS','Jaina, listen to me. You must destroy the Lich King. You cannot reason with him. He will kill you and your allies and raise you all as powerful soldiers of the Scourge.','',26124),
(37607,'enUS','Snap out of it, girl. You must destroy the Lich King at the place where he merged with Ner\'zhul - atop the spire, at the Frozen Throne. It is the only way.','',26124),
(37608,'enUS','There is... something else that you should know about the Lich King. Control over the Scourge must never be lost. Even if you were to strike down the Lich King, another would have to take his place. For without the control of its master, the Scourge would run rampant across the world - destroying all living things.','',26124),
(37609,'enUS','A grand sacrifice by a noble soul...','',26124),
(37610,'enUS','I do not know, Jaina. I suspect that the piece of Arthas that might be left inside the Lich King is all that holds the Scourge from annihilating Azeroth.','',26124),
(37611,'enUS','No, Jaina! ARRRRRRGHHHH... He... He is coming. You... You must...','',26124),
(37612,'enUS','Uther shakes his head.','',26124),
(37613,'enUS','SILENCE, PALADIN!','',26124),
(37614,'enUS','So you wish to commune with the dead? You shall have your wish.','',26124),
(37615,'enUS','Falric. Marwyn. Bring their corpses to my chamber when you are through.','',26124),
(37616,'enUS','I will not make the same mistake again, Sylvanas. This time there will be no escape. You will all serve me in death!','',26124),
(37617,'enUS','Foolish girl. You seek that which I killed long ago. He is merely a ghost now. A faint echo in my mind... ','',26124),
(37618,'enUS','','Why do you interrupt me, $c?',26124),
(37619,'enUS','You\'re an odd little guy.','You\'re an odd little guy.',26124),
(37620,'enUS','It\'s good to finally see you, courier. Krasus has entrusted us with one of the few remaining copies of Ancient Dragonforged Blades.','',26124),
(37621,'enUS','Here is the book. You must ensure it gets to Caladis Brightspear in Icecrown before the Sunreavers realize what is happening.','',26124),
(37622,'enUS','Travel quickly! The Sunreavers will not waste any time once they realize that we have the information they seek.','',26124),
(37623,'enUS','Citizens and guests of Stormwind.  Our city is under attack!  Take up your arms and defend our capital!  If you do not want to answer the call of battle, then grab sandbags and line the streets to prevent flooding!','',26124),
(37624,'enUS','Elemental rifts have opened up around the city.  We need to shut them down now! Evacuate all non-combat ready citizens.  Make sure they get to safety!','',26124),
(37625,'enUS','$B$BQuick, use the Ice Stones at each corner of the city to open a portal to the elemental plane and summon in those responsible.$B$BActivate each stone at the same time to ensure victory.','',26124),
(37626,'enUS','Place sandbags around Stormwind to ward off flooding!$B$BPick up a sandbag from any sandbag pile located around the city$B$Band place them at a location marked with a red arrow |TInterface\\Icons\\ABILITY_HUNTER_MARKEDFORDEATH.blp:32|t.','',26124),
(37627,'enUS','Take down the rifts and use the totems given by the Earthen Ring Defenders to free Trapped Citizens!','',26124),
(37628,'enUS','The Horde now dominates the Battlescar!','',26124),
(37629,'enUS','The Alliance now dominates the Battlescar!','',26124),
(37630,'enUS','Brave soldier of the Horde, I salute you! We would have surely been destroyed by the Alliance gunship had it not been for you and your allies.$B$BTake a moment to rest before we begin our assault upon the upper reaches of the citadel.','',26124),
(37631,'enUS','We are ready to go, High Overlord. The Lich King must fall!','We are ready to go, High Overlord. The Lich King must fall!',26124),
(37632,'enUS','Are you sure, $n? We must face the Scourge at full strength if we are to succeed. If you do not require more rest, we will begin.','',26124),
(37633,'enUS','Lok\'tar ogar! We are ready! Onward, brother orc!','Lok\'tar ogar! We are ready! Onward, brother orc!',26124),
(37634,'enUS','Kor\'kron, move out! Champions, watch your backs. The Scourge have been...','',26124),
(37635,'enUS','Join me, father. Join me and we will crush this world in the name of the Scourge -- for the glory of the Lich King!','',26124),
(37636,'enUS','I have heard tale of my boy being here. That he\'s now a powerful death knight in service of the Lich King. If this is true, then it must be me that ends the bloodline.$B$BMy charge now is to command Orgrim\'s Hammer to the top of Icecrown Citadel and destroy all Scourge that get in our way. We leave when you and your allies are ready.','',26124),
(37637,'enUS','My companions are all accounted for, Saurfang. Let\'s go!','My companions are all accounted for, Saurfang. Let\'s go!',26124),
(37638,'enUS','My boy died at the Wrath Gate. I am here only to collect his body.','',26124),
(37639,'enUS','Stubborn and old. What chance do you have? I am stronger, and more powerful than you ever were.','',26124),
(37640,'enUS','We named him Dranosh - It means \"Heart of Draenor\" in orcish. I would not let the warlocks take him. My boy would be safe, hidden away by the elders of Garadar.','',26124),
(37641,'enUS','I made a promise to his mother before she died; that I would cross the Dark Portal alone - whether I lived or died, my son would be safe. Untainted...','',26124),
(37642,'enUS','Today, I fulfill that promise.','',26124),
(37643,'enUS','%s charges!','',26124),
(37644,'enUS','Pathetic old orc! Come then, heroes. Come and face the might of the Scourge!','',26124),
(37645,'enUS','Quel\'Delar leaps to life in the presence of Frostmourne!','',26124),
(37646,'enUS','%s coughs.','',26124),
(37647,'enUS','%s weeps over the corpse of his son.','',26124),
(37648,'enUS','You will have a proper ceremony in Nagrand, next to the pyres of your mother and ancestors.\n','',26124),
(37649,'enUS','Honor, young heroes... no matter how dire the battle... never forsake it.','',26124),
(37650,'enUS','I hear and obey, master...','',26124),
(37651,'enUS','The enemy shall suffer greatly, master!','',26124),
(37652,'enUS','His spirit is free from the grasp of the Lich King. We must now focus our attention on breaking down the walls that block our passage into the upper reaches. It is only a matter of time now, $n. The siege engineers should have the door down in $4939W days.','',26124),
(37653,'enUS','','Come, Scourgebane. I\'ll show the master which of us is truly worthy of the title of \"Champion\"!',26124),
(37654,'enUS','','What a pitiful choice of an ally, Crok!',26124),
(37655,'enUS','It is done, master.','',26124),
(37656,'enUS','Master... I have... failed.','',26124),
(37657,'enUS','Fear not, master. I shall rend the flesh of your enemy!','',26124),
(37658,'enUS','It doesn\'t hurt anymore, does it?\n','',26124),
(37659,'enUS','I\'m sorry...','',26124),
(37660,'enUS','Can you feel the burn?','',26124),
(37661,'enUS','What... have I done? No!','',26124),
(37662,'enUS','So that\'s what happens what you stand too close to a bomb!','',26124),
(37663,'enUS','What an... explosive ending!','',26124),
(37664,'enUS','What? This strength...? All of the pain is gone! You... must join me in the eternal embrace of death!\n','',26124),
(37665,'enUS','No amount of healing can save me now. Fight on, brothers...','',26124),
(37666,'enUS','Please... burn my remains. Let me live warm in the afterlife...','',26124),
(37667,'enUS','No! Why was I denied a death by flame? You must all BURN!  ','',26124),
(37668,'enUS','It was... a worthy afterlife.','',26124),
(37669,'enUS','There is no escaping the Lich King\'s will. Prepare for an explosive encounter!','',26124),
(37670,'enUS','The transporter glimmers with a crystalline light.','The transporter glimmers with a crystalline light.',26124),
(37671,'enUS','Teleport to Light\'s Hammer.','Teleport to Light\'s Hammer.',26124),
(37672,'enUS','','Such easy prey.  Sylvanas will be most pleased!',26124),
(37673,'enUS','','How did you--?!  It doesn\'t matter -- I don\'t need a trap to defeat you.',26124),
(37674,'enUS','','Use Belysra\'s Talisman to escape before the Dark Scout shoots you!$B$B|TInterface\\Icons\\inv_jewelry_talisman_10.blp:64|t',26124),
(37675,'enUS','Now - to the business of winning this war!$B$BAcross the scarred terrain to the east, the Alliance hopes to build an overland link between their coastal strongholds. They think to build a fortress here, in the center of the Barrens. In the center of MY Barrens.$B$BIt will not stand.','',26124),
(37676,'enUS','It was dreadful, $c. Unceremoniously booted from Orgrimmar, jars of fresh squirming body parts smashed to the ground as I was hauled through the gates.$B$BLike I was some kind of monster!$B$BFortunately I\'ve been able to continue my research here, where there\'s no shortage of fresh corpses.','',26124),
(37677,'enUS','Fire up the engines! We got a meetin\' with destiny, lads!','',26124),
(37678,'enUS','Hold on to yer hats!','',26124),
(37679,'enUS','What in the world is that? Grab me spyglass, crewman!','',26124),
(37680,'enUS','By me own beard! HORDE SAILIN\' IN FAST \'N HOT!','',26124),
(37681,'enUS','EVASIVE ACTION! MAN THE GUNS!','',26124),
(37682,'enUS','Cowardly dogs! Ye blindsided us!','',26124),
(37683,'enUS','Not me battle? I dunnae who ye think ye are, mister, but I got a score to settle with Arthas and yer not gettin\' in me way! FIRE ALL GUNS! FIRE! FIRE!','',26124),
(37684,'enUS','The Scourge will wash over this world as a swarm of death and destruction!','',26124),
(37685,'enUS','This is not your battle, dwarf. Back down or we will be forced to destroy your ship.','',26124),
(37686,'enUS','More bones for the offering!','More bones for the offering!',26124),
(37687,'enUS','Languish in damnation!','Languish in damnation!',26124),
(37688,'enUS','I see... Only darkness.','I see... Only darkness.',26124),
(37689,'enUS','Rise up, sons and daughters of the Horde! Today we battle a hated enemy of the Horde! LOK\'TAR OGAR!','',26124),
(37690,'enUS','THE MASTER\'S RAGE COURSES THROUGH ME!','THE MASTER\'S RAGE COURSES THROUGH ME!',26124),
(37691,'enUS','Kor\'kron, take us out!','',26124),
(37692,'enUS','What is that? Something approaching in the distance.','',26124),
(37693,'enUS','The only escape is death!','The only escape is death!',26124),
(37694,'enUS','ALLIANCE GUNSHIP! ALL HANDS ON DECK!','',26124),
(37695,'enUS','Bound by bone!','Bound by bone!',26124),
(37696,'enUS','Stick around!','Stick around!',26124),
(37697,'enUS','You answer to Saurfang now!','',26124),
(37698,'enUS','You will know our business soon. Kor\'kron, ANNIHILATE THEM!','',26124),
(37699,'enUS','Move yer jalopy or we\'ll blow it out of the sky, orc! The Horde\'s got no business here.','',26124),
(37700,'enUS','Riflemen, shoot faster!','',26124),
(37701,'enUS','Mortar team, reload!','',26124),
(37702,'enUS','Marines, Sergeants, attack!','',26124),
(37703,'enUS','We\'re taking hull damage, get a sorcerer out here to shut down those cannons!','',26124),
(37704,'enUS','What\'s this then?! Ye won\'t be takin\' this son o\' Ironforge\'s vessel without a fight!','',26124),
(37705,'enUS','Don\'t say I didn\'t warn ya, scoundrels! Onward, brothers and sisters!','',26124),
(37706,'enUS','Captain Bartlett, get us out of here! We\'re taken too much damage to stay afloat!','',26124),
(37707,'enUS','This isn\'t lookin\' good, lads!','',26124),
(37708,'enUS','Axethrowers, hurl faster!','',26124),
(37709,'enUS','Rocketeers, reload!','',26124),
(37710,'enUS','Reavers, Sergeants, attack!','',26124),
(37711,'enUS','We\'re taking hull damage, get a battle-mage out here to shut down those cannons!','',26124),
(37712,'enUS','You DARE board my ship? Your death will come swiftly.','',26124),
(37713,'enUS','The Alliance falter. Onward to the Lich King!','',26124),
(37714,'enUS','Damage control! Put those fires out. You haven\'t seen the last of the Horde!','',26124),
(37715,'enUS','We have failed.','',26124),
(37716,'enUS','<A cockroach slithers from Calder\'s mouth and scurries back into his skull through an empty eye socket.>','',26124),
(37717,'enUS','<On seeing you approach, Calder re-hinges his jaw to speak with you.>','',26124),
(37718,'enUS','<You find Calder idly picking at his ear with a dagger.>','',26124),
(37719,'enUS','Do you know what I like, $n?','',26124),
(37720,'enUS','No Calder. What do you like?','No Calder. What do you like?',26124),
(37721,'enUS','Murder.','',26124),
(37722,'enUS','Teleport to the Oratory of the Damned.','Teleport to the Oratory of the Damned.',26124),
(37723,'enUS','Teleport to the Rampart of Skulls.','Teleport to the Rampart of Skulls.',26124),
(37724,'enUS','Teleport to the Deathbringer\'s Rise.','Teleport to the Deathbringer\'s Rise.',26124),
(37725,'enUS','Teleport to the Upper Spire.','Teleport to the Upper Spire.',26124),
(37726,'enUS','Teleport to the Frozen Throne.','Teleport to the Frozen Throne.',26124),
(37727,'enUS','Just as Goldrinn\'s spirit once blessed our druids, let $n be blessed with the wisdom of his race and the ferocity of the wolf god.','',26124),
(37728,'enUS','Teleport to Sindragosa\'s Lair.','Teleport to Sindragosa\'s Lair.',26124),
(37729,'enUS','','Just as Daral\'nir soothes the cursed druids who gave into the beast and abandoned balance, let Tal\'doren soothe $n.',26124),
(37730,'enUS','Let the Scythe unbind that which was not meant to be bound!  Let the soul master the beast, lest the beast master the soul!','',26124),
(37731,'enUS','','Hey! Come here, $n.',26124),
(37732,'enUS','%s bobbles after you happily.','',26124),
(37733,'enUS','Looting','Looting',26124),
(37734,'enUS','Thank the spirits for you, brothers and sisters. The Skybreaker has already left. Quickly now, to Orgrim\'s Hammer! If you leave soon, you may be able to catch them.','Thank the spirits for you, brothers and sisters. The Skybreaker has already left. Quickly now, to Orgrim\'s Hammer! If you leave soon, you may be able to catch them.',26124),
(37735,'enUS','This should be helpin\' ya!','This should be helpin\' ya!',26124),
(37736,'enUS','Aka\'Magosh, brave warriors. The alliance is in great number here.','Aka\'Magosh, brave warriors. The alliance is in great number here.',26124),
(37737,'enUS','Captain Saurfang will be pleased to see you aboard Orgrim\'s Hammer. Make haste, we will secure the area until you are ready for take-off.','Captain Saurfang will be pleased to see you aboard Orgrim\'s Hammer. Make haste, we will secure the area until you are ready for take-off.',26124),
(37738,'enUS','Orgrim\'s Hammer infantry, hold position!','Orgrim\'s Hammer infantry, hold position!',26124),
(37739,'enUS','Lok\'tar!','Lok\'tar!',26124),
(37740,'enUS','','Come, Mankrik. Sit beside me and rest.',26124),
(37741,'enUS','%s grunts.','',26124),
(37742,'enUS','','Look at this land, Mankrik. The Horde and Alliance tear the earth apart just to claw at each other in spite.',26124),
(37743,'enUS','','Such hatred is only bringing us destruction. I can see it in you as you fight the quilboar...your anger does nothing but wear you away.',26124),
(37744,'enUS','','You\'re destroying yourself, Mankrik.',26124),
(37745,'enUS','There is nothing left for me. I seek a warrior\'s death. Is that wrong?','',26124),
(37746,'enUS','','You seek escape, not glory. It\'s suicide.',26124),
(37747,'enUS','So what if it is? Why do you even care?','',26124),
(37748,'enUS','','Because...',26124),
(37749,'enUS','','Because despite what you think, there may be people in this world who would mourn your passing.',26124),
(37750,'enUS','Mahka...','',26124),
(37751,'enUS','','Please, Mankrik. Let go. Set down your blade.',26124),
(37752,'enUS','This hatred has burned in me for years, Mahka. Your words cannot lift it from me so easily.','',26124),
(37753,'enUS','','Then...you do not need to bear it alone. Just sit next to me and forget your troubles, if only for a while.',26124),
(37754,'enUS','','Come see me whenever you are weary.',26124),
(37755,'enUS','Mahka wants you to come see her, Mankrik.','Mahka wants you to come see her, Mankrik.',26124),
(37756,'enUS','Mahka wishes to see me? ...very well. Return to her, I will follow.','',26124),
(37757,'enUS','Swiftclaw isn\'t stopping!  Steer him back to the raptor pens near Darkspear Hold.','Swiftclaw isn\'t stopping!  Steer him back to the raptor pens near Darkspear Hold.',26124),
(37758,'enUS','%s places a cup against the wall of Desolation Hold and listens in.','',26124),
(37759,'enUS','%s sneezes, rattling the bush he\'s hiding in.','',26124),
(37760,'enUS','%s yips in appreciation.','',26124),
(37761,'enUS','%s bounces up and down.','',26124),
(37762,'enUS','%s lets out a little screech.','',26124),
(37763,'enUS','%s waves its horn at you.','',26124),
(37764,'enUS','%s skips after you.','',26124),
(37765,'enUS','%s almost falls on his face in excitement.','',26124),
(37766,'enUS','%s taps his little claws on the ground as he runs to you.','',26124),
(37767,'enUS','You\'ll never run us out of the city, Silver Covenant thug!','You\'ll never run us out of the city, Silver Covenant thug!',26124),
(37768,'enUS','You Sunreaver lackeys are all the same.','You Sunreaver lackeys are all the same.',26124),
(37769,'enUS','You\'re too late, $n. Another visitor from Dalaran came asking after information about the same prismatic dragon blades.','',26124),
(37770,'enUS','From your description, I\'m certain that the book I loaned our visitor could allow you to easily identify the weapon.','',26124),
(37771,'enUS','Psssstt - $n! Over here! By the tree.','',26124),
(37772,'enUS','I\'m afraid you\'ll have to ask the -- Well, perhaps Kalecgos can help.','',26124),
(37773,'enUS','$n may have found the remains of a prismatic blade, Kalecgos. Will you offer your help to our visitor?','',26124),
(37774,'enUS','Are you certain you should be helping these mortals in their quest for the sword?','',26124),
(37775,'enUS','These blades, Krasus... They were made long ago, when things were... different.','',26124),
(37776,'enUS','','',26124),
(37777,'enUS','<Karthog offers you a drink from his waterskin.>$B$BOnce we called this the Gold Road, $c. Today it runs red with blood.$B$BAlliance blood, if I have anything to do with it.','',26124),
(37778,'enUS','You believe our allies will not be able to control the power of the swords?','',26124),
(37779,'enUS','Slow down, friend. You say the General is coming?$B$BNow THERE\'S a trophy for my wall! I\'ll distract the bodyguards, but it will be up to you to kill General Hawthorne himself. Are you ready to strike?','',26124),
(37780,'enUS','I am ready, Karthog. For the Horde!','I am ready, Karthog. For the Horde!',26124),
(37781,'enUS','','Mortal champions have long used these weapons to combat evil. I see no reason to keep the swords from them in this battle.',26124),
(37782,'enUS','Our enemies once turned our strongest weapon against us. What makes you think the prismatic blades will be any different?','',26124),
(37783,'enUS','As you wish, my queen. I will not stand in their way, but I will keep a close watch.','',26124),
(37784,'enUS','Stay close men - it\'s an ambush. To arms!','',26124),
(37785,'enUS','As will we all.','',26124),
(37786,'enUS','They come! Everyone, get ready...','',26124),
(37787,'enUS','Blood and thunder!','',26124),
(37788,'enUS','I lost my Crown Perfume Sprayer.','I lost my Crown Perfume Sprayer.',26124),
(37789,'enUS','I lost my Crown Cologne Sprayer.','I lost my Crown Cologne Sprayer.',26124),
(37790,'enUS','I lost my Crown Choclate Sampler.','I lost my Crown Choclate Sampler.',26124),
(37791,'enUS','%s nods.','',26124),
(37792,'enUS','...thank you, Mahka.','',26124),
(37793,'enUS','He\'s ours! The Butcher of Taurajo is dead!','',26124),
(37794,'enUS','We\'ll string his body from the trees and leave him swinging in the wind for the Alliance to discover. Go back and tell Warlord Bloodhilt the news!','',26124),
(37795,'enUS','Keep them occupied, my brothers!  Allow $n to retrieve the scythe!','',26124),
(37796,'enUS','Fall back!  Retreat into the woods!','',26124),
(37797,'enUS','The Butcher of Taurajo will pay.','',26124),
(37798,'enUS','I will not rest, $n. Not until they are driven back to the sea.','',26124),
(37799,'enUS','Yes! Grok\'thar More\'gar. Bok choy, friend. Um. Zub zub! ','',26124),
(37800,'enUS','What? Who are you? What clan are you from?','What? Who are you? What clan are you from?',26124),
(37801,'enUS','Okidoki. Uh. R-ready to work!','',26124),
(37802,'enUS','You\'re no orc. You\'re a spy! Alliance spy!','You\'re no orc. You\'re a spy! Alliance spy!',26124),
(37803,'enUS','Only those who have the ranger-general\'s approval may enter the Sunwell Plateau.','Only those who have the ranger-general\'s approval may enter the Sunwell Plateau.',26124),
(37804,'enUS','I will escort you into the Sunwell when you\'re ready.','I will escort you into the Sunwell when you\'re ready.',26124),
(37805,'enUS','%s rifles through the fortress supplies, looking for something.','',26124),
(37806,'enUS','I\'m ready to enter the Sunwell.','I\'m ready to enter the Sunwell.',26124),
(37808,'enUS','Curse your eyes, $r!','',26124),
(37809,'enUS','','My brothers and sisters, words cannot describe what I felt upon seeing the Sunwell rekindled.',26124),
(37810,'enUS','Darius!  The Dark Rangers have the Scythe!  They got to it before we were able to reach it.','',26124),
(37811,'enUS','','In that moment, the Light revealed to me the truth of the terrible things I had done.',26124),
(37812,'enUS','It will be done!','',26124),
(37813,'enUS','','Our people had walked a dark path and mine was among the darkest of them all.',26124),
(37814,'enUS','','But the Light showed me that I was not lost. It helped me to find the strength to survive in spite of all that had happened and all the evil I had wrought.',26124),
(37815,'enUS','','It is a strength that we sin\'dorei all share. It is a strength we will need to free ourselves of the addiction ravaging our people.',26124),
(37816,'enUS','','It will be the most difficult battle we have ever faced, but our resolve and the power of the Sunwell will sustain us until we have been restored to our greatness.',26124),
(37817,'enUS','Well said, my lady. We sin\'dorei will be free and we shall be great again!','Well said, my lady. We sin\'dorei will be free and we shall be great again!',26124),
(37818,'enUS','Ya, mon. Let\'s crack some tiki target skulls!','',26124),
(37819,'enUS','Get our men in position immediately, Tobias.  We cannot let the Scythe fall into the hands of the Forsaken!!','',26124),
(37820,'enUS','My lords and ladies, I present $n, bearer of Quel\'Delar.','',26124),
(37821,'enUS','$n. Zuni. Ya\'ll find ya trainer in the trainin\' grounds to the east. Bring pride to the Darkspear.','',26124),
(37822,'enUS','I told Gar\'dul not to build a fortress on top of a Silithid colony.$B$BDid he listen to Crawgol? No!','',26124),
(37823,'enUS','Fun time?','',26124),
(37824,'enUS','Daddy, I did it!','',26124),
(37825,'enUS','Dead, dead, dead!','',26124),
(37826,'enUS','Da ... Ddy...','',26124),
(37827,'enUS','Fun time over!','',26124),
(37829,'enUS','I not feel so good...','',26124),
(37830,'enUS','No! You killed Stinky! You Pay!','',26124),
(37831,'enUS','WEEEEEE!','',26124),
(37832,'enUS','I brokes-ded it...','',26124),
(37833,'enUS','Daddy make new toys out of you!','',26124),
(37834,'enUS','Bad news, daddy...','',26124),
(37835,'enUS','SLEEPY TIME!','',26124),
(37836,'enUS','Icky sticky!','',26124),
(37837,'enUS','What? Precious? Noooooooooo!!!','',26124),
(37838,'enUS','Good news, everyone! I think I\'ve perfected a plague that will destroy all life on Azeroth!','',26124),
(37839,'enUS','Hrm, interesting...','',26124),
(37840,'enUS','That was unexpected!','',26124),
(37841,'enUS','Bad news, everyone... I don\'t think I\'m going to make it...','',26124),
(37842,'enUS','Great news, everyone!','',26124),
(37843,'enUS','Just an ordinary gas cloud, but watch out because that\'s no ordinary gas cloud!','',26124),
(37844,'enUS','Hrm, I don\'t feel a thing. Wha?! Where\'d those come from?','',26124),
(37845,'enUS','Tastes like... Cherry! OH! Excuse me!','',26124),
(37846,'enUS','Two oozes, one room. So many delightful possibilities!','',26124),
(37847,'enUS','Terrible news, everyone. Rotface is dead, but great news everyone! He left behind plenty of ooze for me to use! What? I\'m a poet and I didn\'t know it... Astounding!','',26124),
(37848,'enUS','Oh Festergut, you were always my favorite -- next to Rotface.  The good news is that you left behind so much gas. I can practically taste it!','',26124),
(37849,'enUS','%s cries out with a loud, baying howl!','%s cries out with a loud, baying howl!',26124),
(37850,'enUS','The heat comes. Prepare to defend against the elemental attack! Lok\'tar ogar!','The heat comes. Prepare to defend against the elemental attack! Lok\'tar ogar!',26124),
(37851,'enUS','Prepare yourselves brothers and sisters.  The elements conspire against our city.  Be ready for battle!','Prepare yourselves brothers and sisters.  The elements conspire against our city.  Be ready for battle!',26124),
(37852,'enUS','I AM RENEWED! Ysera grant me the favor to lay these foul creatures to rest!','',26124),
(37853,'enUS','My genius cannot be contained within a box!$B$BWait, this isn\'t Azshara?! What is this place? That\'s a dormant volcano!$B$BI have half a mind to go join the Trade Prince! The other half of my mind is considering the possible weaponization of the clucker eggs!','',26124),
(37854,'enUS','','When we were packed into the Town-In-A-Box, they told us we\'d be deployed somewhere in Azshara. Is this Azshara?$B$BI ask you: who prepares a Town-In-A-Box and doesn\'t supply it with enough food to live on?! One measly Poultryizer?!$B$BWe all know how the \"Micro\" Mechachicken worked out.',26124),
(37855,'enUS','I must ask that you reforge Shadow\'s Edge for me, Highlord Mograine.','I must ask that you reforge Shadow\'s Edge for me, Highlord Mograine.',26124),
(37856,'enUS','Woo! Feel the burn!','',26124),
(37857,'enUS','Toasty!','',26124),
(37858,'enUS','Burning up the dance floor!','',26124),
(37859,'enUS','I\'m on fire!','',26124),
(37860,'enUS','So sexy it hurts!','',26124),
(37861,'enUS','Best. Workout. Ever.','',26124),
(37862,'enUS','It burns so good!','',26124),
(37863,'enUS','Yes ladies, I\'m single.','',26124),
(37864,'enUS','Furious Fire Elementals Killed: $4582W/$4862W','',26124),
(37865,'enUS','Elementals are invading the area.  Prepare to defend Orgrimmar!','',26124),
(37866,'enUS','Searing Fire Elementals Killed: $4584W/$4863W','',26124),
(37867,'enUS','There are new, stronger elementals attacking, but the fires are out of control!  Eliminate the elementals and get a handle on those fires.','',26124),
(37868,'enUS','$B$BQuick, use the Ice Stones at each corner of the city to open a portal to the elemental plane and summon in those responsible.$B$BActivate each stone at the same time to ensure victory.','',26124),
(37869,'enUS','The fires threaten to destroy all of Orgrimmar.  If you think you are strong enough to go in there, be my guest.  Otherwise, stay out of the city and let us take care of it.','The fires threaten to destroy all of Orgrimmar.  If you think you are strong enough to go in there, be my guest.  Otherwise, stay out of the city and let us take care of it.',26124),
(37870,'enUS','Kneel beside me, friend. I caught a bullet during that last raid.$B$B<Gann grunts in pain as he tries to shift position. His left hand clutches a wound, blood welling between his quivering fingers.>$B$BWhen the dwarves first invaded the Barrens, I contented myself with harassing their diggers and sabotaging their equipment. I should\'ve struck a killing blow when I had the chance.','',26124),
(37871,'enUS','Weezil Slipshadow - master of disguise!','',26124),
(37872,'enUS','|TInterface\\Icons\\ability_creature_disease_02.blp:16|tYou have |cFF00FF00Mutated Infection!|r','',26124),
(37873,'enUS','Please, mortal, speak with Arcanist Tybalin in Dalaran. He may be able to negotiate with the Sunreavers for access to the book.','',26124),
(37874,'enUS','Please, mortal, seek out Magister Hathorel in Dalaran. He might be able to negotiate with the Silver Covenant for access to the book.','',26124),
(37875,'enUS','Heroes, lend me your aid. I... I cannot hold them off much longer. You must heal my wounds!','',26124),
(37876,'enUS','I have opened a portal into the Dream. Your salvation lies within, heroes...','',26124),
(37877,'enUS','I will not last much longer.','',26124),
(37878,'enUS','My strength is returning. Press on, heroes!','',26124),
(37879,'enUS','You won\'t escape from us so easily!','You won\'t escape from us so easily!',26124),
(37880,'enUS','Did you think you would escape with your life?','Did you think you would escape with your life?',26124),
(37881,'enUS','%s sets his eyes upon you!','%s sets his eyes upon you!',26124),
(37882,'enUS','Fires Extinguished: $4857W/$4864W','',26124),
(37884,'enUS','This ain\'t much of a big challenge, mon, but we gotta know ya can handle the pit before we can take ya in.','This ain\'t much of a big challenge, mon, but we gotta know ya can handle the pit before we can take ya in.',26124),
(37885,'enUS','I\'m ready to face my challenge.','I\'m ready to face my challenge.',26124),
(37886,'enUS','Get in the pit and show us your stuff, $G boy:girl;.','Get in the pit and show us your stuff, $G boy:girl;.',26124),
(37887,'enUS','You are not welcome here, minion of the Lich King!','You are not welcome here, minion of the Lich King!',26124),
(37888,'enUS','The Forsaken think we\'re weak.  A broken people.  They think we\'ll roll over like a scared dog.','',26124),
(37889,'enUS','They\'re in mid challenge, mon. Be patient.','They\'re in mid challenge, mon. Be patient.',26124),
(37890,'enUS','And if we find ourselves surrounded and disarmed... wounded and overwhelmed... we will lift our heads in defiance and spit in their faces.','',26124),
(37891,'enUS','We will fight them on the streets until the last shot is fired.  And when there\'s no more ammunition, we\'ll crush their skulls with the stones that pave our city.','',26124),
(37892,'enUS','We will fight them in the alleys, until our knuckles are skinned and bloody and our rapiers lay on the ground shattered.','',26124),
(37893,'enUS','How wrong they are.  We will fight them in the fields until the last trench collapses and the last cannon is silenced.','',26124),
(37894,'enUS','','Quiet, fools. If I had wished to kill you, you\'d already be dead.',26124),
(37895,'enUS','And if we find ourselves surrounded and disarmed... wounded and without hope... we will lift our heads in defiance and spit in their faces.','',26124),
(37896,'enUS','But we will... NEVER SURRENDER!!!!!','',26124),
(37897,'enUS','FOR GILNEAS!!!','FOR GILNEAS!!!',26124),
(37898,'enUS','Well done, $n!','Well done, $n!',26124),
(37899,'enUS','Take them, mortal, these souls will again be mine soon enough.','',26124),
(37900,'enUS','Soon, mortal, you too shall have a blade for a prison.','',26124),
(37901,'enUS','Remember hero: I, too, once sought a weapon of great power...','',26124),
(37902,'enUS','I see you too are gathering souls for your own ends. Are we really so different, champion?','',26124),
(37903,'enUS','Yes, do it! Create your monstrous new weapon. It too will serve me when your soul is mine.','',26124),
(37904,'enUS','Bring me your weapon, champion, that I might feed it the soul of its master!','',26124),
(37905,'enUS','Look at you, child; would-be wielder of souls... you cannot fathom the power that lies at my command!','',26124),
(37906,'enUS','Come to me, pretender! Feed MY blade!','',26124),
(37907,'enUS','My challenges have strengthened you, champion. You shall serve me well!','',26124),
(37908,'enUS','Never have I had cause to regret sparing your life, mortal. Always, you find ways to amuse me.','',26124),
(37909,'enUS','The moment is soon at hand, mortal. You shall toil for eternity in a new Azeroth!','',26124),
(37910,'enUS','More souls... yes, more... you will find it hard to stop, mortal.','',26124),
(37911,'enUS','The hunger your weapon feels is but a shade of what awaits. You want to see real hunger? Real power? Continue onward, hero. I am waiting.','',26124),
(37912,'enUS','You stumble about in darkness. There is no light here. No mercy! Icecrown has claimed the souls of better heroes than you.','',26124),
(37913,'enUS','Your heart - its incessant drumming disgusts me. I will silence it as I did my own.','',26124),
(37914,'enUS','The Light will abandon you, hero, just as it did me.','',26124),
(37915,'enUS','A-Me have many locomotion speed modes.  A-Me design specification U-2502 state that user may define A-Me locomotion mode to suit user preference.$b$bIn Amble Mode, A-Me move at speed of normal $r.$b$bIn Run Mode, A-Me move at speed of normal horse or wolf.$b$bIn Overdrive Mode, A-Me move at speed of VERY FAST horse or wolf.$b$bWhich mode you prefer?','',26124),
(37916,'enUS','I think I\'ll go with Amble Mode, A-Me.','I think I\'ll go with Amble Mode, A-Me.',26124),
(37917,'enUS','Let\'s try Run Mode.','Let\'s try Run Mode.',26124),
(37918,'enUS','Overdrive Mode!  Let\'s do this!','Overdrive Mode!  Let\'s do this!',26124),
(37919,'enUS','Input recognized.  Please prepare for journey.','',26124),
(37920,'enUS','Good.  Good.  User appear ready.  Now we go.','',26124),
(37921,'enUS','Wait.  A-Me forget something.  We make quick stop, then return to escape protocol.','',26124),
(37922,'enUS','A-Me pounds her chest and calls out to a nearby gorilla.','',26124),
(37923,'enUS','Wooga... you came.  Good.  A-Me need you listen now.','',26124),
(37924,'enUS','This not easy for A-Me to say... A-Me going home.  It finally time for A-Me to leave.','',26124),
(37925,'enUS','A-Me need you tell others.  Tell Rakoo thanks for teach A-Me how to make lightning.  And tell Misko thanks for teach A-Me how to fight dinosaur.','',26124),
(37926,'enUS','But most of all... thank you, Wooga, for teach A-Me how to love.','',26124),
(37927,'enUS','A single drop of coconut milk leaks out of A-Me 01\'s eye as she takes one long, last look at Wooga.','',26124),
(37928,'enUS','Not bad, $n. Not bad.','Not bad, $n. Not bad.',26124),
(37929,'enUS','I don\'t like the look of this \'Crown Chemical Co.\' one bit.','',26124),
(37930,'enUS','Take care of ya weapons an\' they\'ll take care of ya back.','',26124),
(37931,'enUS','Men, women, and children... None were spared the master\'s wrath. Your death will be no different.','',26124),
(37932,'enUS','','The elements chaotic and wild. Only through learnin\' can we keep in touch wit\' them and keep them controlled.',26124),
(37933,'enUS','I can\'t help ya. Go talk ta Nortet if ya want warrior trainin\'.','I can\'t help ya. Go talk ta Nortet if ya want warrior trainin\'.',26124),
(37934,'enUS','I can\'t help ya. Go talk ta Nekali if ya want shaman trainin\'.','I can\'t help ya. Go talk ta Nekali if ya want shaman trainin\'.',26124),
(37935,'enUS','I can\'t help ya. Go talk ta Zen\'Tabra if ya want druid trainin\'.','I can\'t help ya. Go talk ta Zen\'Tabra if ya want druid trainin\'.',26124),
(37936,'enUS','I can\'t help ya. Go talk ta Legati if ya want rogue trainin\'.','I can\'t help ya. Go talk ta Legati if ya want rogue trainin\'.',26124),
(37937,'enUS','I can\'t help ya. Go talk ta Tunari if ya want priest trainin\'.','I can\'t help ya. Go talk ta Tunari if ya want priest trainin\'.',26124),
(37938,'enUS','I can\'t help ya. Go talk ta Soratha if ya want mage trainin\'.','I can\'t help ya. Go talk ta Soratha if ya want mage trainin\'.',26124),
(37939,'enUS','I can\'t help ya. Go talk ta Ortezza if ya want hunter trainin\'.','I can\'t help ya. Go talk ta Ortezza if ya want hunter trainin\'.',26124),
(37940,'enUS','We can\'t help ya \'ere, mon.','We can\'t help ya \'ere, mon.',26124),
(37941,'enUS','Sniveling maggot!','',26124),
(37942,'enUS','The children of Stratholme fought with more ferocity!','',26124),
(37943,'enUS','Marwyn, finish them...','',26124),
(37944,'enUS','Soldiers of Lordaeron, rise to meet your master\'s call!','',26124),
(37945,'enUS','Despair... so delicious...','',26124),
(37946,'enUS','Fear... so exhilarating...','',26124),
(37947,'enUS','As you wish, my lord.','',26124),
(37948,'enUS','Death is all that you will find here!','',26124),
(37949,'enUS','I saw the same look in his eyes when he died. Terenas could hardly believe it.','',26124),
(37950,'enUS','Choke on your suffering!','',26124),
(37951,'enUS','Yes... Run... Run to meet your destiny... Its bitter, cold embrace, awaits you.','',26124),
(37952,'enUS','The master surveyed his kingdom and found it... Lacking. His judgment was swift and without mercy: DEATH TO ALL!','',26124),
(37953,'enUS','As you wish, my lord.','',26124),
(37954,'enUS','Your flesh shall decay before your very eyes!','',26124),
(37955,'enUS','Waste away into nothingness!','',26124),
(37956,'enUS','','Darkspear trolls \'ave age old connections wit\' nature, but only lately \'ave we come ta know the druidic arts. Try ta keep an open mind, $n.',26124),
(37957,'enUS','Strike swiftly an\' fade away. You\'ll know ya beginin\' ta master ya skills when people know ya deeds, but never heard of you.','',26124),
(37958,'enUS','','In tha chaos of battle, it\'s tha balance of light and shadow that leads us ta victory.',26124),
(37959,'enUS','A squire is the right hand of the knight.  As you are already fully aware, hands are especially good at carrying things, and thus your first duty will be to carry my sundries, knickknacks, and other miscellaneous paraphernalia while I dispense justice across the land.  To lug around such etcetera is a job unbefitting of a knight.','',26124),
(37960,'enUS','Understandable.','Understandable.',26124),
(37961,'enUS','Very good.  Secondly, you must know that a knight embraces no tenet more tightly than that of chivalry.  He clings to his generosity as tightly as he clings to his lance.  His valor shines as brightly as his armor.  And while his smallsword may be sharp, his manner among allies is soft and courteous.$b$bNow tell me $n, do you give your oath to hold to the teachings of chivalry and gallantry?','',26124),
(37962,'enUS','I give you my oath.','I give you my oath.',26124),
(37963,'enUS','Yes, sir.','Yes, sir.',26124),
(37964,'enUS','Ha!  Did I not just say, good $n, chivalry and gallantry are the charge of the KNIGHT?  You seek only to be a SQUIRE.  The colossal burden of chivalry is unfit for the squire, for as I mentioned before, the only colossal burden that you are to bear is that of my belongings.','',26124),
(37965,'enUS','This is ridiculous!  I don\'t have to put up with this!','This is ridiculous!  I don\'t have to put up with this!',26124),
(37966,'enUS','Moving on!  As chivalry is the way of the knight, and I am a knight, you must know then that my own intentions are indeed valorous.  It is true, I fight for my Lady Doloria, to proclaim her beauty and majesty across all the lands.  Any who question her beauty are without a doubt the most vile of enemies, and must be brought to justice.$b$bAs I speak, it occurs to me that I am a failure.  We have come quite far in the squiring ceremony, yet I have not yet ascertained whether or not you deserve my charity or my righteous fury.$b$bI must know, now, do you agree that my Lady Doloria is unquestionably the fairest Lady across all of Azeroth?','',26124),
(37967,'enUS','I\'m rather glad to hear that.  Congratulations, $n, for you have completed your training.  You may now ride beside me into the fray.','',26124),
(37968,'enUS','Wit\' practice, ya\'ll find that magic can be much stronga than any weapon.','',26124),
(37969,'enUS','Umm... yes, yes she is.  Unquestionably.','Umm... yes, yes she is.  Unquestionably.',26124),
(37970,'enUS','Woo hoo!','Woo hoo!',26124),
(37971,'enUS','','Trust in ya bow. It\'ll be there for ya when ya need it most.',26124),
(37972,'enUS','','Nature will guide ya when all else fails.',26124),
(37973,'enUS','<Maximillian is deep in prayer, oblivious to your presence.>','',26124),
(37974,'enUS','Stay your sword and loosen your cap.  Before we do battle with our blades, I first have prepared an assault to unleash upon your ears.$b$bAre you prepared?','',26124),
(37975,'enUS','Alright, I\'m ready.','Alright, I\'m ready.',26124),
(37976,'enUS','This whole place is gonna blow. Get to the exit!','',26124),
(37977,'enUS','%s has impaled $n!','%s has impaled $n!',26124),
(37978,'enUS','%s\'s Aether Shield has been shattered by $n!','%s\'s Aether Shield has been shattered by $n!',26124),
(37979,'enUS','It appears that adventure has made itself apparent.  Look, for as yonder maiden treads innocently through the jungle, a hatchling phoenix stalks her as its prey!','',26124),
(37980,'enUS','Watch as the accursed bird becomes flame and ash as soon as it is slayed.','',26124),
(37981,'enUS','For Doloria!','',26124),
(37982,'enUS','Curiously the bird does not become flame and ash.  A phoenix that does not become flame and ash \'pon its slaying is a dire omen indeed.','',26124),
(37983,'enUS','Maiden: if your curiosity gnaws at you, then you may know your salvation was delivered by Maximillian of Northshire.','',26124),
(37984,'enUS','','Squawky...',26124),
(37985,'enUS','Clean and tidy!','',26124),
(37986,'enUS','That\'s how it\'s done!','',26124),
(37987,'enUS','Nice. I don\'t want to know what that stain was.','',26124),
(37988,'enUS','Aquanos can hardly keep up!','',26124),
(37989,'enUS','I should keep you around.','',26124),
(37990,'enUS','BY THE MIGHT OF THE LICH KING!','',26124),
(37991,'enUS','You are nothing!','',26124),
(37992,'enUS','Your soul will find no redemption here!','',26124),
(37993,'enUS','I... Am... Released...','',26124),
(37994,'enUS','I have become... DEATH!','',26124),
(37995,'enUS','The ground runs red with your blood!','',26124),
(37996,'enUS','Feast, my minions!','',26124),
(37997,'enUS','','Foolish mortals. You thought us defeated so easily? The San\'layn are the Lich King\'s immortal soldiers! Now you shall face their might combined!',26124),
(37998,'enUS','Dinner... is served.','',26124),
(37999,'enUS','Do you see NOW the power of the Darkfallen?','',26124),
(38000,'enUS','BOW DOWN BEFORE THE SAN\'LAYN!','',26124),
(38001,'enUS','Naxxanar was merely a setback! With the power of the orb, Valanar will have his vengeance!','',26124),
(38002,'enUS','My cup runneth over.','',26124),
(38003,'enUS','Were you ever a threat?','',26124),
(38004,'enUS','Truth is found in death.','',26124),
(38005,'enUS','My queen, they... come.','',26124),
(38006,'enUS','Such wondrous power! The Darkfallen Orb has made me INVINCIBLE!','',26124),
(38007,'enUS','Blood will flow.','',26124),
(38008,'enUS','Worm food.','',26124),
(38009,'enUS','Beg for mercy!','',26124),
(38010,'enUS','Tremble before Taldaram, mortals, for the power of the orb flows through me!','',26124),
(38011,'enUS','Delight in the pain!','',26124),
(38012,'enUS','You dare look upon the host of souls? I SHALL DEVOUR YOU WHOLE!','',26124),
(38013,'enUS','Damnation!','',26124),
(38014,'enUS','','Damnation!',26124),
(38015,'enUS','Doomed for eternity!','',26124),
(38016,'enUS','','Doomed for eternity!',26124),
(38017,'enUS','The swell of souls will not be abated! You only delay the inevitable.','',26124),
(38018,'enUS','','The swell of souls will not be abated! You only delay the inevitable.',26124),
(38019,'enUS','SUFFERING! ANGUISH! CHAOS! RISE AND FEED!','',26124),
(38020,'enUS','','Stare into the abyss and see your end.',26124),
(38021,'enUS','No snooping around, friend.$B$BIf you\'re looking to buy Crown holiday goods, you\'ll have to do it at the Lovely Merchant in the city.','No snooping around, friend.$B$BIf you\'re looking to buy Crown holiday goods, you\'ll have to do it at the Lovely Merchant in the city.',26124),
(38022,'enUS','Time is money, friend. Go go go!','Time is money, friend. Go go go!',26124),
(38023,'enUS','The Lovely Merchant is waiting for that. Hurry it up!','The Lovely Merchant is waiting for that. Hurry it up!',26124),
(38024,'enUS','That crate won\'t deliver itself, friend. Get a move on!','That crate won\'t deliver itself, friend. Get a move on!',26124),
(38025,'enUS','Don\'t you have some packages to move?','Don\'t you have some packages to move?',26124),
(38026,'enUS','I need another disguise.','I need another disguise.',26124),
(38027,'enUS','If we don\'t slow down soon, I might pass out.','',26124),
(38028,'enUS','Umm... I think I might need a hand here...','',26124),
(38029,'enUS','Ugh... maybe if you could lightly slap me on the cheek...','',26124),
(38030,'enUS','Hey!  A little help over here!','',26124),
(38031,'enUS','You didn\'t have to hit me so HARD!','',26124),
(38032,'enUS','Okay, okay, I\'m going!','',26124),
(38033,'enUS','Thanks, I needed that.','',26124),
(38034,'enUS','Do you know that you are very strong?','',26124),
(38035,'enUS','','This is a great day for all who oppose the Lich King! Brave $n has taken up the ancient blade, Quel\'Delar, in the name of the Silver Covenant!',26124),
(38036,'enUS','As the leader of the Sunreavers, it is with great pride that I present $n as the new bearer of Quel\'Delar!','',26124),
(38037,'enUS','Something stinks, and for once it\'s not my socks.','Something stinks, and for once it\'s not my socks.',26124),
(38038,'enUS','Hope wanes...','',26124),
(38039,'enUS','','Crusaders and combatants, a true hero stands before you this day! $n, of the Silver Covenant, has restored the ancient blade of Quel\'Delar as a symbol of our resolve to defeat the Lich King!',26124),
(38040,'enUS','The end has come!','',26124),
(38041,'enUS','Face now your tragic end.','',26124),
(38042,'enUS','Frostmourne hungers...','',26124),
(38043,'enUS','Frostmourne, OBEY ME!','',26124),
(38044,'enUS','Frostmourne feeds on the soul of your fallen ally!','',26124),
(38046,'enUS','I will freeze you from within until all that remains is an icy husk.','',26124),
(38047,'enUS','Watch as the world around you collapses!','',26124),
(38048,'enUS','','You have made an... unwise... decision.',26124),
(38049,'enUS','APOCALYPSE!','',26124),
(38050,'enUS','Bow down before your lord and master!','',26124),
(38052,'enUS','Val\'kyr, your master calls!','',26124),
(38053,'enUS','','Just a taste...',26124),
(38054,'enUS','You now stand upon the hallowed ground of the Scourge. The Light won\'t protect you here, paladin. Nothing will protect you...','',26124),
(38055,'enUS','You could have been my greatest champion, Fordring: A force of darkness that would wash over this world and deliver it into a new age of strife.','',26124),
(38056,'enUS','But that honor is no longer yours. Soon, I will have a new champion. ','',26124),
(38057,'enUS','The breaking of this one has been taxing. The atrocities I have committed upon his soul... He has resisted for so long, but he will bow down before his king soon.','',26124),
(38058,'enUS','','Know my hunger!',26124),
(38059,'enUS','In the end, you will all serve me.','',26124),
(38060,'enUS','','Death is no escape!',26124),
(38061,'enUS','','SUFFER!',26124),
(38062,'enUS','','Can you handle this?',26124),
(38063,'enUS','','Here it comes...',26124),
(38064,'enUS','','How... unfortunate.',26124),
(38065,'enUS','','Yes! Feed, my precious one! You are mine now!',26124),
(38066,'enUS','','Really...? Is that all you\'ve got?',26124),
(38067,'enUS','','Such a pity.',26124),
(38068,'enUS','','This ends NOW!',26124),
(38069,'enUS','','But... we were getting along... so... well...',26124),
(38070,'enUS','So the Light\'s vaunted justice has finally arrived? Shall I lay down Frostmourne and throw myself at your mercy, Fordring?','',26124),
(38071,'enUS','You\'ll learn of that first hand. When my work is complete, you will beg for mercy -- and I will deny you. Your anguished cries will be testament to my unbridled power...','',26124),
(38072,'enUS','I\'ll keep you alive to witness the end, Fordring. I would not want the Light\'s greatest champion to miss seeing this wretched world remade in my image.','',26124),
(38073,'enUS','Come then, champions. Feed me your rage!','',26124),
(38074,'enUS','No questions remain unanswered. No doubts linger. You ARE Azeroth\'s greatest champions. You overcame every challenge I laid before you. My mightiest servants have fallen before your relentless onslaught... your unbridled fury... ','',26124),
(38075,'enUS','Is it truly righteousness that drives you? I wonder...','',26124),
(38076,'enUS','You trained them well, Fordring. You delivered the greatest fighting force this world has ever known... right into my hands - exactly as I intended! You shall be rewarded for your unwitting sacrifice.','',26124),
(38077,'enUS','Watch now as I raise them from the dead to become masters of the Scourge. They will shroud this world in chaos and destruction. Azeroth\'s fall will come at their hands -- and you will be the first to die.','',26124),
(38078,'enUS','I delight in the irony.','',26124),
(38079,'enUS','','Rise up, brothers, and destroy our enemies!',26124),
(38080,'enUS','Impossible...','',26124),
(38081,'enUS','BAH! You gnats actually hurt me... Perhaps I\'ve toyed with you long enough... Now - taste the VENGEANCE OF THE GRAVE!','',26124),
(38082,'enUS','AARRRGGHHH!','',26124),
(38083,'enUS','Take them, mortal, these souls will again be mine soon enough.','',26124),
(38084,'enUS','','Crusaders and combatants, a true hero stands before you this day! $n, of the Sunreavers, has restored the ancient blade of Quel\'Delar as a symbol of our resolve to defeat the Lich King!',26124),
(38085,'enUS','Soon, mortal, you too shall have a blade for a prison.','',26124),
(38086,'enUS','Remember hero: I, too, once sought a weapon of great power...','',26124),
(38087,'enUS','I see you too are gathering souls for your own ends. Are we really so different, \'champion\'?','',26124),
(38088,'enUS','Yes, do it! Create your monstrous new weapon. It too will serve me when your soul is mine.','',26124),
(38089,'enUS','Bring me your weapon, champion, that I might feed it the soul of its master!','',26124),
(38090,'enUS','Look at you, child; would-be wielder of souls... you cannot fathom the power that lies at my command!','',26124),
(38091,'enUS','Come to me, pretender! Feed MY blade!','',26124),
(38092,'enUS','My challenges have strengthened you, champion. You shall serve me well!','',26124),
(38093,'enUS','Never have I had cause to regret sparing your life, mortal. Always, you find ways to amuse me.','',26124),
(38094,'enUS','The moment is soon at hand, mortal. You shall toil for eternity in a new Azeroth!','',26124),
(38095,'enUS','More souls...  yes, more...  you will find it hard to stop, mortal.','',26124),
(38096,'enUS','The hunger your weapon feels is but a shade of what awaits. You want to see real hunger? Real power? Continue onward, hero. I am waiting.','',26124),
(38097,'enUS','You stumble about in darkness. There is no light here. No mercy! Icecrown has claimed the souls of better heroes than you.','',26124),
(38098,'enUS','Your heart -it\'s incessant drumming disgusts me. I will silence it as I did my own.','',26124),
(38099,'enUS','The Light will abandon you, hero, just as it did me.','',26124),
(38100,'enUS','Slap Ringo before he passes out!','',26124),
(38101,'enUS','Water...','',26124),
(38102,'enUS','The canteen... get the canteen...','',26124),
(38103,'enUS','Need water... not much time...','',26124),
(38104,'enUS','So... so very thirsty...','',26124),
(38105,'enUS','Truly an amazing sword, don\'t you think? That\'s no weapon of dwarven make, no, it\'s far more ancient than that.$B$BThese Sunreaver and Silver Covenant representatives seem intent on getting to the bottom of the mystery. I\'m already working on a report for Brann.','',26124),
(38106,'enUS','Greely, load The Biggest Egg Ever into the Poultryizer. Mechnuggets for everyone!','',26124),
(38107,'enUS','As Druids, we are tasked with protecting the balance of nature. My life\'s work has gone against this. In my folly, I have sewn chaos, and this deviant crop must be reaped before it spreads further.','',26124),
(38108,'enUS','I will stay here and watch over the land as it heals.  Do keep an eye out for any stragglers from here...','',26124),
(38109,'enUS','We\'ll grant you a swift death, Arthas. More than can be said for the thousands you\'ve tortured and slain.','',26124),
(38110,'enUS','So be it. Champions, attack!','',26124),
(38111,'enUS','LIGHT GRANT ME ONE FINAL BLESSING! GIVE ME THE STRENGTH... TO SHATTER THESE BONDS!','',26124),
(38112,'enUS','No more, Arthas! No more lives will be consumed by your hatred!','',26124),
(38113,'enUS','The Lich King must fall!!','',26124),
(38114,'enUS','You have come to bring Arthas to justice? To see the Lich King destroyed?','',26124),
(38115,'enUS','First, you must escape Frostmourne\'s hold, or be damned as I am; trapped within this cursed blade for all eternity. ','',26124),
(38116,'enUS','Aid me in destroying these tortured souls! Together we will loosen Frostmourne\'s hold and weaken the Lich King from within!','',26124),
(38117,'enUS','Free at last! It is over, my son. This is the moment of reckoning.','',26124),
(38118,'enUS','Rise up, champions of the Light!','',26124),
(38119,'enUS','','Genius idea, sir. Your brain power never ceases to amaze me!',26124),
(38120,'enUS','Great news, everyone! The slime is flowing again!','',26124),
(38121,'enUS','%s\'s Mana Barrier shimmers and fades away!','',26124),
(38122,'enUS','What is this disturbance? You dare trespass upon this hallowed ground? This shall be your final resting place!','',26124),
(38123,'enUS','Do you yet grasp the futility of your actions?','',26124),
(38124,'enUS','Embrace the darkness... darkness eternal.','',26124),
(38125,'enUS','All part of the Master\'s plan.... Your end is inevitable....','',26124),
(38126,'enUS','Enough! I see I must take matters into my own hands!','',26124),
(38127,'enUS','You are weak, powerless to resist my will!','',26124),
(38128,'enUS','This charade has gone on long enough!','',26124),
(38129,'enUS','Long have I waited for this day, hero. Are you and your allies prepared to bring the Lich King to justice? We charge on your command!','',26124),
(38130,'enUS','Take this blessing and show these intruders a taste of the Master\'s power!','',26124),
(38131,'enUS','We are prepared, Highlord. Let us battle for the fate of Azeroth! For the light of dawn!','We are prepared, Highlord. Let us battle for the fate of Azeroth! For the light of dawn!',26124),
(38132,'enUS','I release you from the curse of flesh!','',26124),
(38133,'enUS','Arise, and exult in your pure form!','',26124),
(38134,'enUS','Fix your eyes upon your crude hands: the sinew, the soft meat, the dark blood coursing within.','',26124),
(38135,'enUS','It is a weakness; a crippling flaw....  A joke played by the Creators upon their own creations.','',26124),
(38136,'enUS','The sooner you come to accept your condition as a defect, the sooner you will find yourselves in a position to transcend it.','',26124),
(38137,'enUS','Through our Master, all things are possible. His power is without limit, and his will unbending.','',26124),
(38138,'enUS','Those who oppose him will be destroyed utterly, and those who serve -- who serve wholly, unquestioningly, with utter devotion of mind and soul -- elevated to heights beyond your ken.','',26124),
(38139,'enUS','You have found your way here, because you are among the few gifted with true vision in a world cursed with blindness.','',26124),
(38140,'enUS','You can see through the fog that hangs over this world like a shroud, and grasp where true power lies.','',26124),
(38141,'enUS','','This thing is huge! Reverse the polarity on the Poultryizer. We\'ll have to shove it in through the outtake.',26124),
(38142,'enUS','','There it goes.  It should only be a moment now....',26124),
(38143,'enUS','Father...','',26124),
(38144,'enUS','It is complete.\n\n','',26124),
(38145,'enUS','Where most would falter, you have overcome.\n','',26124),
(38146,'enUS','You have withstood the torment of the Lich King himself, and now Shadowmourne is yours.\n','',26124),
(38147,'enUS','Go now...','',26124),
(38148,'enUS','Wield this mighty weapon and direct the souls that empower it.','',26124),
(38149,'enUS','Go now, and defeat the Prince of Darkness. (DO NOT USE?)','',26124),
(38150,'enUS','Father. I feared for your... your sanity.','',26124),
(38151,'enUS','Father... For you, I would give my life a thousand times.','',26124),
(38152,'enUS','Darion, my son.','',26124),
(38153,'enUS','At last, I am able to lay my eyes upon you again.','',26124),
(38154,'enUS','The Lich King tormented me without end, Darion.','',26124),
(38155,'enUS','Endlessly, he sought to break my will, to force me to serve him, to bind me to his blade...','',26124),
(38156,'enUS','Finally, when events demanded his full attention, he left me.','',26124),
(38157,'enUS','The one memory, I clung to, Darion... The one thought that kept me from giving in...','',26124),
(38158,'enUS','It was your sacrifice, my son, that again saved me from eternal peril.','',26124),
(38159,'enUS','','Aid me, friends. Let us call upon the spirits for vision.',26124),
(38160,'enUS','Arthas...','',26124),
(38161,'enUS','Alas, hero of Azeroth, you give me a greater gift than you know.','',26124),
(38162,'enUS','Long have I struggled to forgive the prince for his terrible transgressions.','',26124),
(38163,'enUS','My soul has been wracked with unbearable anxiety, dark thoughts... distancing me from the Light.','',26124),
(38164,'enUS','Maximillian, I am ready for adventure.','Maximillian, I am ready for adventure.',26124),
(38165,'enUS','I recall clearly the gleam of pride in his eye as he stood before me, eager to defeat the enemies of the Light...','',26124),
(38166,'enUS','Eager to defend his people, no matter the cost.','',26124),
(38167,'enUS','It is this memory of Arthas that I choose to keep in my heart.','',26124),
(38168,'enUS','I shall always be in your debt, friend.','',26124),
(38169,'enUS','Thank you.','',26124),
(38170,'enUS','Shut it down, shut it down! The eggs are bad!!!','',26124),
(38171,'enUS','Oh, lad...','',26124),
(38172,'enUS','How I miss those endless days in Lordaeron...','',26124),
(38173,'enUS','...sharpenin\' yer skill with this dull blade...','',26124),
(38174,'enUS','...forgin\' ya into a weapon meant to withstand the demands of a great destiny.','',26124),
(38175,'enUS','Heh... Yeh sure put them skills ta use, didn\'t yeh, lad?','',26124),
(38176,'enUS','If only I\'da been able ta stop yeh that day, how different things mighta been.','',26124),
(38177,'enUS','If only I\'da never discovered that accursed blade...','',26124),
(38178,'enUS','Farewell, Arthas... my brother.','',26124),
(38179,'enUS','','So, it is done.',26124),
(38180,'enUS','','I had not dared to trust my senses - too many times has the Lich King made me to be a fool.',26124),
(38181,'enUS','','Finally, he has been made to pay for the atrocities he imposed upon my people.',26124),
(38182,'enUS','Come, Squire $n, for adventure awaits us!','',26124),
(38183,'enUS','','May Azeroth never fail to remember the terrible price we paid for our weakness... for our pride.',26124),
(38184,'enUS','','But what now, hero? What of those freed from his grasp, but still shackled to their mortal coils?',26124),
(38185,'enUS','','Leave me. ',26124),
(38186,'enUS','','I have much to ponder.',26124),
(38187,'enUS','I think I\'ll adventure alone for a while.','I think I\'ll adventure alone for a while.',26124),
(38188,'enUS','','Agamaggan will not rise again without BLOOD! His body demands sacrifice!',26124),
(38189,'enUS','','Go!  Go and take our land! When all belongs to the quilboar, we will be delivered, and Agamaggan will rise again!',26124),
(38190,'enUS','','This he has spoken to me...go, and KILL!',26124),
(38191,'enUS','','I see...she\'s using him to manipulate them all..',26124),
(38192,'enUS','Look squire, yon maiden has lost her purse to the sulfurous waters of the Golakka Hot Springs.','',26124),
(38193,'enUS','Maiden!  Fear not, I seek only to steady the quiver in thine lower lip.  Is that your purse that floats \'pon the water, so agonizingly close yet so perilously far away?','',26124),
(38194,'enUS','What?  Yes, that\'s my... crate.  And I\'m not a...','',26124),
(38195,'enUS','You\'re not a what?  Not available?  Worry not, for my heart belongs only to the lady Doloria, though one as fair as you must command the hearts of many.','',26124),
(38196,'enUS','My squire will retrieve your purse for you.','',26124),
(38197,'enUS','I\'m not sure I know what to make of all of this, other than I\'m very insulted, and thank you for returning my purse.  I mean crate!','',26124),
(38198,'enUS','Come, squire.  Adventure waits not!','',26124),
(38199,'enUS','Bael Modan... the dwarves...  ','',26124),
(38200,'enUS','The scar is sealed! Thank Cenarius...','',26124),
(38201,'enUS','','What\'s this!?',26124),
(38202,'enUS','','He... he kept it? All this time, he kept it!?',26124),
(38203,'enUS','','I knew! ',26124),
(38204,'enUS','','I sensed a part of him still alive! Trapped... struggling... Oh, Arthas!',26124),
(38205,'enUS','','Perhaps - perhaps he might someday remember what he once was.',26124),
(38206,'enUS','','By the Light, may he at last find rest, free from the icy grip of that terrible blade.',26124),
(38207,'enUS','You again...I hope you didn\'t put too much faith in your actions settling my spirit. I\'ve realized there will be no peace without her, not anymore.$B$BI will see their very homes razed. Are you ready to slay more of these disgusting murderers?','',26124),
(38208,'enUS','Save me!  I\'ve dropped my belongings into the hot springs.$b$bMy gowns are in there!','',26124),
(38209,'enUS','Luck is with us today!  A damsel appears before us, stuck in a crag, without hope of escape!  Let us go save her!','',26124),
(38210,'enUS','Maiden!  Fear not, for Maximillian of Northshire has arrived to deliver you from your rocky tomb!','',26124),
(38211,'enUS','Hup!','',26124),
(38212,'enUS','Now, cry not, as you fall not to your death, but into the waiting arms of my squire!  Off you go now!','',26124),
(38213,'enUS','Before I take my leave, you must be told that it is not by my fault that you lay stretched on the ground, but by the fault of my squire.','',26124),
(38214,'enUS','Nevertheless, you are now freed from the mountains\' grip and safe from harm.  Marshal\'s Stand lies to the east, I believe.','',26124),
(38215,'enUS','The Kalu\'ak Fishing Derby starts in 20 minutes!','',26124),
(38216,'enUS','The Kalu\'ak Fishing Derby starts in 10 minutes!','',26124),
(38217,'enUS','The Kalu\'ak Fishing Derby starts in 5 minutes!','',26124),
(38218,'enUS','The Kalu\'ak Fishing Derby has begun!  The first person to bring a blacktip shark to me in Dalaran will be declared the winner!  Blacktip sharks can be caught anywhere you can catch a pygmy suckerfish.','',26124),
(38219,'enUS','$n has won the Kalu\'ak Fishing Derby!','',26124),
(38220,'enUS','Only 10 minutes remain before the Kalu\'ak Fishing Derby ends!','',26124),
(38221,'enUS','The Kalu\'ak Fishing Derby ends in 5 minutes!','',26124),
(38222,'enUS','The Kalu\'ak Fishing Derby has ended!  If you caught a shark, please bring it to me within the hour.','',26124),
(38223,'enUS','Be flung!  To safety!','',26124),
(38224,'enUS','I was once a paladin, $n.  Now the Light shuns me, for my sins are too great.$B$BI will aid my allies as best I can, but never again will I wield the powers of darkness.','',26124),
(38225,'enUS','A self-inflicted wound, friend.  I could not bear to look upon a world where I\'d committed so many horrors under the Lich King\'s grasp.$B$BIt was my first step towards redemption, and if my sins are unforgivable, then I will attempt to atone for them for the rest of my life.','',26124),
(38226,'enUS','Ormus, what happened to your eyes?','Ormus, what happened to your eyes?',26124),
(38227,'enUS','I appear to have lost my ring.','I appear to have lost my ring.',26124),
(38228,'enUS','Lost?$B$BI am deeply disappointed, $n.$B$BThat ring was one of a kind, crafted out of the remnants of the armor of our fallen heroes and the purified metal from our enemy\'s blades.$B$BLet\'s not allow this to happen again.','',26124),
(38229,'enUS','It won\'t.','It won\'t.',26124),
(38230,'enUS','Turn back, mon. The naga be controlin\' the island to the north. It not safe for ya there.','Turn back, mon. The naga be controlin\' the island to the north. It not safe for ya there.',26124),
(38231,'enUS','The Fossil-Finder 3000 indicates that there is a large fossil to the north of here.','The Fossil-Finder 3000 indicates that there is a large fossil to the north of here.',26124),
(38232,'enUS','From up here you can see the full scope of the cataclysm\'s destruction. It is chilling to see just how fragile our world really is.','',26124),
(38233,'enUS','The Fossil-Finder 3000 indicates that there is a large fossil to the northwest of here.','The Fossil-Finder 3000 indicates that there is a large fossil to the northwest of here.',26124),
(38234,'enUS','The Fossil-Finder 3000 indicates that there is a large fossil to the west of here.','The Fossil-Finder 3000 indicates that there is a large fossil to the west of here.',26124),
(38235,'enUS','The Fossil-Finder 3000 indicates that there is a large fossil to the southwest of here.','The Fossil-Finder 3000 indicates that there is a large fossil to the southwest of here.',26124),
(38236,'enUS','The Fossil-Finder 3000 indicates that there is a large fossil to the south of here.','The Fossil-Finder 3000 indicates that there is a large fossil to the south of here.',26124),
(38237,'enUS','The Fossil-Finder 3000 indicates that there is a large fossil to the southeast of here.','The Fossil-Finder 3000 indicates that there is a large fossil to the southeast of here.',26124),
(38238,'enUS','The Fossil-Finder 3000 indicates that there is a large fossil to the east of here.','The Fossil-Finder 3000 indicates that there is a large fossil to the east of here.',26124),
(38239,'enUS','The Fossil-Finder 3000 indicates that there is a large fossil to the northeast of here.','The Fossil-Finder 3000 indicates that there is a large fossil to the northeast of here.',26124),
(38240,'enUS','It is beeping and flashing wildly.  Dig here!','It is beeping and flashing wildly.  Dig here!',26124),
(38241,'enUS','It is now flashing brightly.  You\'re very close!','It is now flashing brightly.  You\'re very close!',26124),
(38242,'enUS','It is beeping loudly, suggesting that you are only a few paces away.','It is beeping loudly, suggesting that you are only a few paces away.',26124),
(38243,'enUS','It is beeping regularly, about once a second.','It is beeping regularly, about once a second.',26124),
(38244,'enUS','It is beeping regularly, about once every two seconds.','It is beeping regularly, about once every two seconds.',26124),
(38245,'enUS','It is beeping quietly every 5 seconds or so.','It is beeping quietly every 5 seconds or so.',26124),
(38246,'enUS','It is beeping very faintly.  You are still quite far away.','It is beeping very faintly.  You are still quite far away.',26124),
(38247,'enUS','You hear it beeping very faintly.  The fossil must be very, very far away.','You hear it beeping very faintly.  The fossil must be very, very far away.',26124),
(38248,'enUS','A foul wind blows from the East, $c.','',26124),
(38249,'enUS','Professor Putricide has removed your mutation!','',26124),
(38250,'enUS','I have a few ideas on how to help heal the overgrowth, $c.$B$BUnfortunately, Naralex is so upset, he refuses to take any more chances.','',26124),
(38251,'enUS','Gorerot crush puny worgen!!','',26124),
(38253,'enUS','This\'ll teach you to mind your own business!','',26124),
(38254,'enUS','Maximillian, I am ready for more adventure.','Maximillian, I am ready for more adventure.',26124),
(38255,'enUS','Ya momma was bait fish.','',26124),
(38256,'enUS','Die snakefish!','',26124),
(38257,'enUS','If I fished ya up, I\'d throw ya back. Waste of good fish meat.','',26124),
(38258,'enUS','Go suck on a trident.','',26124),
(38259,'enUS','Ya mest with da wrong trolls, fishhead.','',26124),
(38260,'enUS','Ya about to be darkspeared.','',26124),
(38261,'enUS','Wow. Ya even ugly for a naga.','',26124),
(38262,'enUS','Oi mon, it reeks of bad fish in \'ere.','',26124),
(38263,'enUS','Light, give us the strength we need to defeat the vile broodmother of Un\'Goro.','',26124),
(38264,'enUS','Light, give us the courage we need to enter battle with Un\'Goro\'s corrupted dragons.','',26124),
(38265,'enUS','Light, grant us the ability to bring Un\'Goro\'s dragons to their demise.','',26124),
(38266,'enUS','I also ask you to sprinkle wildflowers around the feet of my beautiful Doloria, where\'er she may walk.','',26124),
(38267,'enUS','I also ask you to shine your glorious light upon the immaculate face of my lady Doloria.','',26124),
(38268,'enUS','I request that you summon birds to sing pleasant meadow-tunes into my Doloria\'s ears, while she sleeps.','',26124),
(38269,'enUS','Finally, please find it in your heart to forgive my squire, for I see that you are smiting him.','',26124),
(38270,'enUS','Finally, I entreat you to stop buffeting my squire with punches and kicks.','',26124),
(38271,'enUS','Finally, I humbly request that you cease venting your hostility \'pon my good squire.','',26124),
(38272,'enUS','Squire!  Please stand next to me as I request the blessing of this Light-blessed spirit.','',26124),
(38273,'enUS','I accept your blessing.','',26124),
(38274,'enUS','It\'s alive, $n. It\'s alive!','',26124),
(38275,'enUS','Go forth, my beautiful angel! Ah, it is so very sad when one\'s children leave the nest, isn\'t it?','',26124),
(38276,'enUS','What are you staring at? Haven\'t you ever seen a genius before?','',26124),
(38277,'enUS','Squire!  I understand you are newly trained, but must I tell you not to kill the spirits of the Light?','',26124),
(38278,'enUS','Thank the Earth Mother!','Thank the Earth Mother!',26124),
(38279,'enUS','I can move again!','I can move again!',26124),
(38280,'enUS','The quilboar will pay!','The quilboar will pay!',26124),
(38282,'enUS','Return to the Dire Strait or the Mechashark X-Steam will mysteriously fall apart.','',26124),
(38284,'enUS','I fear I must now depart you and your ex-phoenix.  Light be with you!','',26124),
(38285,'enUS','That\'s right, I\'d like to list some of these \'fireworks\'.','',26124),
(38286,'enUS','Those\'ll net me a nice profit when I return from the South Seas.','',26124),
(38287,'enUS','You... Don\'t think I don\'t see you. Leave me alone!','',26124),
(38288,'enUS','Thanks for the great cut and shave, buddy.','',26124),
(38289,'enUS','Here\'s a little somethin\' extra since I\'ll be away.','',26124),
(38290,'enUS','On second thought, keep the whole bag. I have to, uh, get going.','',26124),
(38291,'enUS','Did you really think you could corner me this easily?','',26124),
(38292,'enUS','We must not let our grief weaken us. Our people will stand strong against the invaders.','',26124),
(38293,'enUS','Finally, the backup I\'ve been waiting for! I prepared the paperwork that Snagglebolt requested. All that remains is for someone to serve it.','',26124),
(38294,'enUS','','You are weak Vol\'jin, like your father was weak. Today I will finish what I started long ago - the Darkspear shall be wiped from existence!',26124),
(38295,'enUS','My lady, thank you for coming to our aid. I assure you that we\'ll do whatever we can to help.','',26124),
(38296,'enUS','You know, that does smell pretty... Hey! Stop spraying that thing at me!','',26124),
(38297,'enUS','A DRAGON!','',26124),
(38298,'enUS','DRAGON!','',26124),
(38299,'enUS','DRAGON, I SHALL RUN YOU THROUGH!','',26124),
(38300,'enUS','FOR DOLORIA!','',26124),
(38301,'enUS','I want to test our entire raid.','I want to test our entire raid.',26124),
(38302,'enUS','','It is my role to test our young initiates on the ways of the hunt.$B$BAnd that hasn\'t changed. Today, the quilboar are our prey.',26124),
(38303,'enUS','Earth Mother, into your arms we give one of our own. She is Unaya Hawkwind, my mother, and Greatmother to us all; the wisest of our tribe.','',26124),
(38304,'enUS','May her spirit fly to you swiftly; may the winds carry her gently, and the grass whisper her name.','',26124),
(38305,'enUS','Watch over her as she has watched over us; let her look down on us with joy, through the eternal gaze of An\'she and Mu\'sha, until we too join her in death.','',26124),
(38306,'enUS','For we are all born of you, and shall all return to you.','',26124),
(38307,'enUS','I\'m glad you\'re out here with us, $n. It\'s not easy getting stuff from naga!','',26124),
(38308,'enUS','','Welcome to Honor\'s Stand, $c! We ripped this valley from the claws of the Horde, but keeping this chokepoint open has proven to be another matter entirely.',26124),
(38309,'enUS','Hail, $c! Just up ahead you\'ll find Honor\'s Stand, the Alliance\'s only link between Stonetalon and the coast.$B$BThe road\'s a treacherous one, though. I speak from experience.','',26124),
(38310,'enUS','','I came over here to see if we could open up trade with these naga. Their reply wasn\'t very nice.',26124),
(38311,'enUS','My achy bones. Achy knees. Achy face. I shoulda stayed in school I shoulda.','',26124),
(38312,'enUS','','Greetings, $c. We shaman have gathered here at Firestone Point to watch over the land and tend to its wounds.',26124),
(38313,'enUS','Come, user.  We prepare for escape protocol.  You use mount now, if you have one.','',26124),
(38314,'enUS','Poison Explosion incoming!  Take cover behind something!','',26124),
(38315,'enUS','The Colossus burrows underground!','',26124),
(38316,'enUS','She has returned. Tha revenge of the Darkspear finally comes to pass dis day.$B$BLet me know when ya ready, $n. We\'ll not let her slip away again.','',26124),
(38317,'enUS','I am ready, Vol\'jin.','I am ready, Vol\'jin.',26124),
(38318,'enUS','Ya were foolish to come \'ere, Sea Witch. Ya escaped our vengeance once, but the Darkspear Tribe will not abide ya trespassin\' again.','',26124),
(38319,'enUS','Varimathras? No, he hasn\'t reported in for some time. No doubt he\'s off on an errand of importance for his queen.','',26124),
(38320,'enUS','While Varimathras is, uh... away, I\'ve been assigned to assist Captain Bragor in his duties.','',26124),
(38321,'enUS','With the bulk of Undercity\'s forces deployed to Vengeance Landing in Northrend, the Warchief has sent us to reinforce the city\'s defenses.','With the bulk of Undercity\'s forces deployed to Vengeance Landing in Northrend, the Warchief has sent us to reinforce the city\'s defenses.',26124),
(38322,'enUS','','The villagers were thankful to have Emberstone back.  They brought us a little something to help against the Forsaken!',26124),
(38323,'enUS','Squealer take this land! Tauren will burn!','',26124),
(38324,'enUS','','',26124),
(38325,'enUS','','Are you interested in making some money?',26124),
(38326,'enUS','We came here to Un\'Goro with one objective in mind: profit.  My associates and I are always looking for business partners, if you\'re interested.','',26124),
(38327,'enUS','Heya, $n. I\'m sure glad that you\'re here. This is turning into a mess.','',26124),
(38328,'enUS','What happened here?','What happened here?',26124),
(38329,'enUS','Did you know that the Barrens was once a lush forest? Thousands of years ago, before the first Sundering, it was verdant and thriving, watched over by the Kaldorei. But when the continents were torn apart, and this land became separated as what we call Kalimdor, this valley of nature became a harsh, sun-scorched plain.$B$BWhen I first learned this, I saw it as a great tragedy. I decided I would find a way to regrow the forests once more.','',26124),
(38330,'enUS','How?','How?',26124),
(38331,'enUS','While studying the land, I discovered a cave that stretched deep beneath the earth. These waterways carried underground rivers for miles beneath the parched savannah above. I named them the Wailing Caverns, for the howls made by the wind and steam as they coursed through its depths.$B$BThis would be the instrument of revival, I thought. The water had already bubbled to the surface as small, lush oases throughout the Barrens...if it were imbued, enhanced, this growth could spread across the entire land.','',26124),
(38332,'enUS','So what did you do?','So what did you do?',26124),
(38333,'enUS','My plan was to connect these underground waters directly to the Emerald Dream itself. With my faithful disciples, I journeyed deep within the Wailing Caverns, settled into meditation, and entered the Dream. Through my own body, this world was connected to it.$B$BIt was there that everything went wrong.','',26124),
(38334,'enUS','What happened?','What happened?',26124),
(38335,'enUS','I came upon what I can only describe as an overwhelming corruption within the Emerald Dream. An unending nightmare that seized me in its claws and tore at my very mind. I could not break free of its grasp; my disciples were unable to wake me.$B$BWhatever this corruption was, it found its way into our world through my body. I did indeed channel its energies into the Wailing Caverns, and its horrible influence twisted the wildlife there into chaotic, deviate forms. Even my disciples were affected; their minds overcome by madness and savagery, they took on the forms of serpents, and called themselves the Druids of the Fang.','',26124),
(38336,'enUS','How did you escape?','How did you escape?',26124),
(38337,'enUS','I was saved by my last disciple, Muyoh, and a band of adventurers. I considered the entire incident a failure. It wasn\'t until the Cataclysm occured that I realized I\'d been far too successful!$B$BWhen the Barrens was cracked apart, a great font of underground water was breached and flowed up to the surface, full of the energies it was imbued with in the Wailing Caverns. Life immediately sprung from the earth around it, and the animals thrived...and then it continued to grow, uncontrollably, unchecked.$B$BNow I have to answer for my arrogance in thinking I could dictate the flow and shape of nature myself. This overgrowth must be stopped, before it chokes out the natural wildlife entirely.','',26124),
(38338,'enUS','WHO DARES?!','',26124),
(38339,'enUS','Where would one go about finding damsels?','Where would one go about finding damsels?',26124),
(38340,'enUS','I don\'t see any dragons anywhere.','I don\'t see any dragons anywhere.',26124),
(38341,'enUS','A fair question.$b$bOne might check the perimeter of the hot springs.  Or one might look for signal fires up in the cliffs to the west.  Finally, the path to Silithus, far to the north, is often wrought with danger.$b$bThose would be the places I\'d check.','',26124),
(38342,'enUS','Nonsense.  Have I hired a blind squire?  There are dragons everywhere.$b$bMy neighbor Spark refers to them as \"dinosaurs\", but I know a dragon when I see one.  They must be slayed.','',26124),
(38343,'enUS','I\'ll turn you into a fossil, $r!','',26124),
(38344,'enUS','I\'ve dug my own grave...','',26124),
(38345,'enUS','You\'re a sight for sore eyes, Lorna.  Let\'s get those cannons manned!  The rest of you, lure the abominations into the open!','',26124),
(38346,'enUS','Little goblins? I remember when your race was created.','',26124),
(38347,'enUS','The Master\'s will remains inviolate...','The Master\'s will remains inviolate...',26124),
(38348,'enUS','You cannot escape the Master\'s Wrath...','You cannot escape the Master\'s Wrath....',26124),
(38349,'enUS','I care nothing for your threats or these naga. Prepare to be removed from existence.','',26124),
(38350,'enUS','The Lich King is unstoppable...','The Lich King is unstoppable...',26124),
(38351,'enUS','Give in... to the cold embrace of death...','Give in... to the cold embrace of death...',26124),
(38352,'enUS','Release yourself from the chains of life...','Release yourself from the chains of life...',26124),
(38353,'enUS','Death consumes you...','Death consumes you...',26124),
(38354,'enUS','He watches your every move...','He watches your every move...',26124),
(38355,'enUS','Cry out in torment... Let your pain overcome your might...','Cry out in torment... Let your pain overcome your might...',26124),
(38356,'enUS','I got these little hellions on a short leash, $n. The naga won\'t attack us while we have their hatchlings.','',26124),
(38357,'enUS','You ready to make their leader surrender, $g buddy : lady;? Okay, here we go.','',26124),
(38358,'enUS','Um, dude, this does not look good. I\'m out of here!','',26124),
(38359,'enUS','Now, young $n, you will die!','',26124),
(38360,'enUS','Crowley\'s troops are up ahead!  Press on!','',26124),
(38361,'enUS','Let us join your father\'s force\'s, Liam.  They\'ll need our help against Sylvanas.','',26124),
(38362,'enUS','Abominations are blocking the way towards the military district!  This won\'t be easy.','',26124),
(38363,'enUS','%s begins to cast Slime Spray!','',26124),
(38364,'enUS','Block their retreat, Liam!  We\'ve got them right where we want them!','',26124),
(38365,'enUS','SYLVANAS!!','',26124),
(38366,'enUS','','Enough!',26124),
(38367,'enUS','','No way in hell I\'m staying out of this fight.  Let\'s go!',26124),
(38368,'enUS','','Let\'s see how brave Gilneas gets on without its stubborn leader!',26124),
(38369,'enUS','FATHER!!!','',26124),
(38370,'enUS','','Such a waste.  That arrow\'s poison was not meant to be wasted on your whelp.  We\'ll meet again, Genn!',26124),
(38371,'enUS','We did it, father...','',26124),
(38372,'enUS','We took back our city... we took back...','',26124),
(38373,'enUS','Out of our way, or your hatchlings get it!','',26124),
(38374,'enUS','You naga keep your distance. We\'re not kidding around here!','',26124),
(38375,'enUS','We\'ve got your hatchlings. You better not attack us if you know what\'s good for you!','',26124),
(38376,'enUS','Prepare to surrender to the Bilgewater Cartel!','',26124),
(38377,'enUS','We know you were getting ready to attack us. You brought this on yourselves.','',26124),
(38378,'enUS','Nobody make any sudden movements! We\'ll just negotiate your surrender and leave peaceably.','',26124),
(38379,'enUS','We\'re planning on having a special naga appreciation sale after your surrender is all wrapped up.  Thirty percent off most goods we have in stock. Red light savings on Kaldorei artifacts today only!','',26124),
(38380,'enUS','We don\'t want any trouble. Just keep our path clear and everything will be fine. Nobody needs to get hurt. Especially me!','',26124),
(38381,'enUS','Alright, naga leader, come on out from hiding and surrender in the name of $n and the Bilgewater Cartel!','',26124),
(38382,'enUS','Don\'t tempt me! Do you even know what\'s in those things?','',26124),
(38383,'enUS','My lady, I think I hear Arthas coming. Whatever you\'re going to do, do it quickly.','My lady, I think I hear Arthas coming. Whatever you\'re going to do, do it quickly.',26124),
(38384,'enUS','','Whoah, what\'s that?',26124),
(38385,'enUS','','After countless failures of our agents to secure workable samples of Scourge blight for analysis, I\'ve come up to the front lines myself to oversee the efforts. Like they say, if you want a job done right....',26124),
(38386,'enUS','','Looks like you\'ve had a fun time playing with Rotface, but to harvest a proper specimen I\'m afraid I will need BOTH strains of blight at the same time!',26124),
(38387,'enUS','','Looks like you\'ve had a fun time playing with Festergut, but to harvest a proper specimen I\'m afraid I will need BOTH strains of blight at the same time!',26124),
(38388,'enUS','Alchemist, I am covered with living blight!','Alchemist, I am covered with living blight!',26124),
(38389,'enUS','Alchemist, I am covered with living blight!','Alchemist, I am covered with living blight!',26124),
(38390,'enUS','','This is incredible! You\'re covered in potent, virulent, fantastic blight! Please, allow me to harvest these pristine samples. I will remove any lingering infection from your allies as well, and reward you all for your bravery and self-sacrifice in the name of medicine! Let me know if you are ready to proceed.\n\n[Before proceeding, make sure that ALL raid members are nearby in order for them to receive credit for your accomplishment.]',26124),
(38391,'enUS','Go ahead. Harvest your specimens.','Go ahead. Harvest your specimens.',26124),
(38392,'enUS','','There is nothing here for you.  Now go.',26124),
(38393,'enUS','I\'d like to return to Marshal\'s Stand, please.','I\'d like to return to Marshal\'s Stand, please.',26124),
(38394,'enUS','','Do you understand now, $n?',26124),
(38395,'enUS','My patron requests your presence.','',26124),
(38396,'enUS','I\'m ready to go to The Shaper\'s Terrace.','I\'m ready to go to The Shaper\'s Terrace.',26124),
(38397,'enUS','I\'d like to return to The Shaper\'s Terrace.','I\'d like to return to The Shaper\'s Terrace.',26124),
(38398,'enUS','Yes, $n?','',26124),
(38399,'enUS','Let us go at once.  We will track Sylvanas down.  For Gilneas!','',26124),
(38400,'enUS','Follow Tobias Mistmantle into the Cathedral District.','',26124),
(38401,'enUS','Let\'s do our best not to be seen, $n.','',26124),
(38402,'enUS','Did you hear that, $n?  Sylvanas is headed to the cathedral.  Let\'s hurry!','',26124),
(38403,'enUS','Quick!  Hide in the water!','',26124),
(38404,'enUS','Who are you?  What do you want with our tribe?','',26124),
(38405,'enUS','Nablya, is that you?','',26124),
(38406,'enUS','Welcome, outsider, to our home.','',26124),
(38407,'enUS','Have you come to observe?  Would you like a coconut?','',26124),
(38408,'enUS','What can you teach me, Thunderer?','What can you teach me, Thunderer?',26124),
(38409,'enUS','What can you teach me, Stomper?','What can you teach me, Stomper?',26124),
(38410,'enUS','What can you teach me, Gorilla?','What can you teach me, Gorilla?',26124),
(38411,'enUS','A few of our tribe have harnessed the power of thunder.  We use it to defend ourselves against invaders, whether human, orc, or dinosaur.$b$bOur thunder stuns all dinosaurs, you know.','',26124),
(38412,'enUS','Individual strength is important, but tribal strength is more so.  Our tribe is only as strong as its weakest member.','',26124),
(38413,'enUS','The lashers to the south will eat small creatures, like frogs and parrots.  We, the gorillas, will eat the lashers.  And dinosaurs will eat gorillas.  All this is honorable and natural.$b$bThe humans and orcs also hunt the gorilla, but they take the skin and leave the body to rot.  This is why we attack the humans and orcs.','',26124),
(38414,'enUS','SCOURGE! INCOMING!','SCOURGE! INCOMING!',26124),
(38415,'enUS','I understand.  Thank you.','I understand.  Thank you.',26124),
(38416,'enUS','It is complete.','',26124),
(38417,'enUS','Where most would falter, you have overcome.','',26124),
(38418,'enUS','You have withstood the torment of the Lich King himself, and now Shadowmourne is yours.','',26124),
(38419,'enUS','Go now...','',26124),
(38420,'enUS','Wield this mighty weapon and direct the souls that empower it.','',26124),
(38421,'enUS','Go forth, and defeat the Prince of Darkness.','',26124),
(38422,'enUS','','You can assure Garrosh that this is a minor setback.  Our victory in Gilneas will be absolute.',26124),
(38423,'enUS','','You\'d do well to watch your tone, General.  Neither you nor Garrosh have anything to worry about.  We\'ve ceased all production of the Plague, as he ordered.  We\'d never deploy it without his permission.',26124),
(38424,'enUS','','Go with honor, General.',26124),
(38425,'enUS','','What kind of question is that?  Of course we\'re deploying the Plague as planned!  Let the Gilneans enjoy their small victory.  Not even their bones will remain by tomorrow.',26124),
(38426,'enUS','It appears you\'re losing control of Gilneas, Sylvanas.  Garrosh fears he\'s going to have to carry out this invasion himself.','',26124),
(38427,'enUS','You sound very confident, your Majesty.  I seriously hope you do not plan to use the Plague.  Garrosh has explicitly forbidden it.','',26124),
(38428,'enUS','I will deliver my report to our leader, then.  By your leave, my lady.','',26124),
(38429,'enUS','I want you to test your Bite skill on the people of Marshal\'s Stand.','I want you to test your Bite skill on the people of Marshal\'s Stand.',26124),
(38430,'enUS','|TInterface\\Icons\\inv_misc_monsterfang_02.blp:32|t  Use Bite on 5 humanoid targets.$B$B|TInterface\\Icons\\inv_misc_bone_02.blp:32|t Use Bony Armor to increase your armor.','|TInterface\\Icons\\inv_misc_monsterfang_02.blp:32|t  Use Bite on 5 humanoid targets.$B$B|TInterface\\Icons\\inv_misc_bone_02.blp:32|t Use Bony Armor to increase your armor.',26124),
(38431,'enUS','I want you to speak with the local gorillas.','I want you to speak with the local gorillas.',26124),
(38432,'enUS','Speak with one of each type - Gorilla, Stomper, and Thunderer -$band learn what they have to teach you.','Speak with one of each type - Gorilla, Stomper, and Thunderer -$band learn what they have to teach you.',26124),
(38433,'enUS','I want you to test the limits of your wings.','I want you to test the limits of your wings.',26124),
(38434,'enUS','Fly high up above the jungle canopy.$b$bUse Pterrordash to temporarily increase your flight speed.$b$b|TInterface\\Icons\\ability_druid_dash.blp:32|t','Fly high up above the jungle canopy.$b$bUse Pterrordash to temporarily increase your flight speed.$b$b|TInterface\\Icons\\ability_druid_dash.blp:32|t',26124),
(38435,'enUS','I want you to pit the Bloodpetal against one another.','I want you to pit the Bloodpetal against one another.',26124),
(38436,'enUS','Challenge and defeat another Bloodpetal in one-on-one combat.','Challenge and defeat another Bloodpetal in one-on-one combat.',26124),
(38437,'enUS','Could you please resummon the Un\'Goro Examinant?','Could you please resummon the Un\'Goro Examinant?',26124),
(38438,'enUS','The flora of Un\'Goro Crater are quite remarkable, to be sure.  Wouldn\'t you agree, $n?','',26124),
(38439,'enUS','Could you transport me to the pylon up above?','Could you transport me to the pylon up above?',26124),
(38440,'enUS','My Lady!  Should I order my men to stop the deployment of the Plague?  Or are we to continue as planned?','',26124),
(38441,'enUS','As you wish!','',26124),
(38442,'enUS','Each moment you tarry here, Quel\'Delar drinks in the evil of this place.','',26124),
(38443,'enUS','Just like old times, eh, $n?','',26124),
(38444,'enUS','Just like old times, eh, $n?$B$BI\'m not too busy here to train you. These guys are creampuffs.','',26124),
(38445,'enUS','A little help here?','',26124),
(38446,'enUS','A little help here? Or do you need more training, $n?$B$BI\'m kinda busy at the moment if you hadn\'t noticed.','',26124),
(38447,'enUS','Could you help with this please? I don\'t have unlimited mana.','',26124),
(38448,'enUS','Could you help with this please? I don\'t have unlimited mana.$B$BOf course, if you need some training....','',26124),
(38449,'enUS','This place seems nice enough, I suppose. Needs a little elbow grease.$B$BYou looking for a job, $n?','',26124),
(38450,'enUS','These little things are a pain in my backside!','',26124),
(38451,'enUS','These little things are a pain in my backside!$B$BSo, you need some training?','',26124),
(38452,'enUS','','These pygmies are cutting into profits!',26124),
(38453,'enUS','','These pygmies are cutting into profits!$B$BSeeking enlightenment, $n?',26124),
(38454,'enUS','','You\'ve got the moves, $n. Use them!',26124),
(38455,'enUS','','You\'ve got the moves, $n. Now use them!$B$BOr are you looking for some new moves?',26124),
(38456,'enUS','Warrior-Matic NX-01 destroy!','',26124),
(38457,'enUS','Warrior-Matic NX-01 is online.$B$BInsert coins for further instructional training.','',26124),
(38458,'enUS','Arg!','',26124),
(38459,'enUS','Ack!','',26124),
(38460,'enUS','Ugh....','',26124),
(38461,'enUS','...','',26124),
(38462,'enUS','','Worthless spy, if there were a single morsel of information inside that hollow vessel you call a skull, you would have coughed it up by now. I tire of this exercise. Now perish!',26124),
(38463,'enUS','Hey, did you hear the one about the $r $c?  OK, here goes:$b$bA $r $c walks into a cave and starts fighting gorillas.  The leader of the gorillas says, \"Hey, why are you doing that?!\"  So then the $r $c says, \"A goblin told me to.\"$b$bThe gorilla leader says, \"Do you do everything that goblins tell you to do?\"  And the $r $c says, \"Yes, because I\'m stupid and smelly and I walk on two legs.\"$b$bPretty funny, huh?  Hmm... maybe it needs some work...','',26124),
(38464,'enUS','BY THE MIGHT OF THE LICH KING!','',26124),
(38465,'enUS','','Hrm, well I\'ve come this far, but now how am I going to get a hold of those samples...?',26124),
(38466,'enUS','Feast, my minions!','',26124),
(38467,'enUS','','Un\'Goro Crater serves a very specific purpose, $n.  It is now time for you to learn that purpose.',26124),
(38468,'enUS','Eep!','',26124),
(38469,'enUS','','Well, well, what do we have here...? You must know many secrets....',26124),
(38470,'enUS','Who are you?','Who are you?',26124),
(38471,'enUS','What are you doing here?','What are you doing here?',26124),
(38472,'enUS','Tests?  What kind of tests?','Tests?  What kind of tests?',26124),
(38473,'enUS','His creations?  So you\'re saying that all the creatures here in the crater are Khaz\'goroth\'s creations?','His creations?  So you\'re saying that all the creatures here in the crater are Khaz\'goroth\'s creations?',26124),
(38474,'enUS','Why are you telling me all of this?','Why are you telling me all of this?',26124),
(38475,'enUS','Nablya, I must ask... did Khaz\'goroth create me and the rest of my race?','Nablya, I must ask... did Khaz\'goroth create me and the rest of my race?',26124),
(38476,'enUS','Thank you Nablya.','Thank you Nablya.',26124),
(38477,'enUS','','I am Nablya, apprentice to Khaz\'goroth and envoy to Un\'Goro Crater.  I am known as the Watcher.$b$bI stand here in the place of my master, who has since left Azeroth.  He once stood in this very spot when he shaped many of his creations.',26124),
(38478,'enUS','','I am observing.  It is my charge to watch over Un\'Goro, and I do so from this spot.$b$bI am also performing tests, and recording the results.  These tests allow me to observe that which most interests me.',26124),
(38479,'enUS','','Simple stimulus-response tests.  Normally my kind does not interfere with the matters of Azeroth, but here in Un\'Goro, we are free to take a more direct approach.  As Un\'Goro is the experimental ground of the Titans, it is our right to do so.$b$bFor example, say Khaz\'goroth wants to know what happens when one of his creations is exposed to a sulfurous hot spring.  He could wait for millennia, observing, and waiting for the creature to accidentally stumble and fall in.  Or, he could place the creature in the water himself.$b$bIn Un\'Goro, we may do so.',26124),
(38480,'enUS','','Not exactly.  In fact, many of the creatures here in the crater existed long before my master arrived... but some did not.$b$bNevertheless, we observe them all, without prejudice.',26124),
(38481,'enUS','','When the cataclysm struck Azeroth, it disrupted the cloaking mechanism that kept this terrace hidden.  At that point, it was only a matter of time until the intelligent races discovered me here.$b$bThis was a scenario that, quite honestly, we did not foresee.  It required us to perform some new tests.  And you, $n, are my test subject.',26124),
(38482,'enUS','','I am not authorized to answer that question.  I am, however, permitted to offer you a suggestion:$b$bSeek out Brann Bronzebeard.$b$bHe has already learned much of what there is to know about us, and he is teetering on the verge of another discovery.  Help him, and he may help you uncover the knowledge that you desire.',26124),
(38483,'enUS','The time to take back Gilneas City is at hand.','',26124),
(38484,'enUS','Let us take back our city!','Let us take back our city!',26124),
(38485,'enUS','LIAM!!  NO!!!','',26124),
(38486,'enUS','Finally, a captive audience!','',26124),
(38487,'enUS','The Devourer awaits...','',26124),
(38488,'enUS','The vortex of the harvested calls to you!','',26124),
(38489,'enUS','I will sever your soul from your body!','',26124),
(38490,'enUS','Fodder for the engine.','',26124),
(38491,'enUS','Another soul to strengthen the host!','',26124),
(38492,'enUS','I will attempt to seal the scar, $n. Make sure nothing from the other side makes its way through!','',26124),
(38493,'enUS','Gilneas will prevail!','',26124),
(38494,'enUS','Your time is up, Forsaken scum!','',26124),
(38495,'enUS','Attack!','',26124),
(38496,'enUS','Push them back!','',26124),
(38497,'enUS','','Mortals, you have saved me from a fate worse than death. Left to their devices, the sorcerers of the Lich King would have broken my will eventually, and condemned me to a tortured eternity of unlife. Ahead of you lies one who was not so fortunate: the once-proud consort of Malygos, Sindragosa.$B$BMortally wounded after Neltharion\'s betrayal and left to die alone in the snows of Icecrown, she exists now as a being of pure hatred. And yet, beneath those layers of malevolence still remains the noble spirit of a dragon queen. I believe there is yet hope that Sindragosa\'s soul may find peaceful respite.',26124),
(38498,'enUS','%s cast |cFFFF7F00Choking Gas Bomb!|r','',26124),
(38499,'enUS','|TInterface\\Icons\\inv_misc_herb_evergreenmoss.blp:16|t%s cast |cFF00FF00Malleable Goo!|r','',26124),
(38500,'enUS','%s begins to cast Unstable Experiment!','',26124),
(38501,'enUS','Professor Putricide cast |cFF00FF00Malleable Goo!|r','',26124),
(38502,'enUS','Our work must not be interrupted! Ick, take care of them!','',26124),
(38503,'enUS','We could probably use these parts.','',26124),
(38504,'enUS','Arms and legs are in short supply! Thanks for your contribution!','',26124),
(38505,'enUS','No, that one! That one! Get that one!','',26124),
(38506,'enUS','I\'ve changed my mind, go get that one instead!','',26124),
(38507,'enUS','What are you attacking him for? The dangerous one is over there!','',26124),
(38508,'enUS','This is the beginning AND the end, mortals. None may enter the master\'s sanctum!','',26124),
(38509,'enUS','Greetings, $r. I sense some confusion at my presence here. The others harbor suspicion as well, and I cannot blame them, after what my brethren have put them through.$B$BMuch has happened since the events at the Sunwell, little of it good. And so it falls to me to pick up the pieces, and attempt to salvage the pride of my flight. There is much to say, and more to do, but know this: Not all in the Blue Dragonflight blame the mortal races of Azeroth for the troubles that have befallen the world.$B$BSome of us have more sense than that.','',26124),
(38510,'enUS','','He\'s truly gone, isn\'t he?$b$bI... I can feel it.',26124),
(38511,'enUS','','Was there truly no way to save him?$b$bI fear I shall always wonder.',26124),
(38512,'enUS','Wh- where am I...?  What a nightmare I have had....  But this is no time to reflect, I have much information to report!','',26124),
(38513,'enUS','It\'s time to join the fray, $n!  With you on our side the scales will surely tip in our favor!','',26124),
(38514,'enUS','Make sure everything is ready.  The orcs\' emissary is ready to meet Sylvanas inside the cathedral.','',26124),
(38515,'enUS','You thirst for blood!','You thirst for blood!',26124),
(38516,'enUS','Die, intruders! None shall interfere with the Cult\'s plans!','',26124),
(38517,'enUS','I... awaken!','',26124),
(38518,'enUS','Who... goes there...?','',26124),
(38519,'enUS','Our master commands us.','Our master commands us.',26124),
(38520,'enUS','Even in death we serve.','Even in death we serve.',26124),
(38521,'enUS','','Why hello there, fellow member of the Alliance!$B$BAs an official representative of Gadgetzan, I\'m here to make sure we poor scattered gnomes can peacefully co-exist with the Steamwheedle goblins here in Gadgetzan! We may even be open to tolerating the presence of their new Horde goblin friends.$B$BI\'m sure we can all come to an agreeable decision with your help!',26124),
(38522,'enUS','Once more we fight for our master.','Once more we fight for our master.',26124),
(38523,'enUS','Why do you seek death in this place?','Why do you seek death in this place?',26124),
(38524,'enUS','The living do not belong here.','The living do not belong here.',26124),
(38525,'enUS','Our torment is eternal.','Our torment is eternal.',26124),
(38526,'enUS','This is not our final rest.','This is not our final rest.',26124),
(38527,'enUS','All serve the master in death.','All serve the master in death.',26124),
(38528,'enUS','This is but a brief repose...','This is but a brief repose...',26124),
(38529,'enUS','Our souls will never be freed.','Our souls will never be freed.',26124),
(38530,'enUS','Hail, $c! Admiral Aubrey is expecting you up above.','',26124),
(38531,'enUS','','$n, you gotta get in there and save our people!',26124),
(38532,'enUS','You will not interfere.','',26124),
(38533,'enUS','You shall not contaminate the investigation site.','',26124),
(38534,'enUS','Do not disturb the investigation protocol.','',26124),
(38535,'enUS','You can\'t come in here all dirty like that. You need that nasty flesh scrubbed off first!','',26124),
(38536,'enUS','','I will destroy this barrier. You must hold the undead back!',26124),
(38537,'enUS','','Another ice wall! Keep the undead from interrupting my incantations so that I may bring this wall down.',26124),
(38538,'enUS','','We\'re almost there... Don\'t give up!',26124),
(38539,'enUS','','Your barriers can\'t hold us back much longer, monster! I will shatter them all!',26124),
(38540,'enUS','','No wall can hold the Banshee Queen. Keep the undead at bay, heroes. I will tear this barrier down!',26124),
(38541,'enUS','','Another barrier? Stand strong, champions. I will bring the wall down.',26124),
(38542,'enUS','','I grow tired of these games, Arthas! Your walls can\'t stop me!',26124),
(38543,'enUS','','You won\'t impede our escape, fiend! Keep the undead off me while I bring this barrier down.',26124),
(38544,'enUS','Hrm, interesting...','',26124),
(38545,'enUS','That was unexpected!','',26124),
(38546,'enUS','Great news, everyone!','',26124),
(38547,'enUS','The swell of souls will not be abated! You only delay the inevitable.','',26124),
(38548,'enUS','Damnation!','',26124),
(38549,'enUS','Doomed for eternity!','',26124),
(38550,'enUS','','Aaagh! It burns! What sorcery is this!?',26124),
(38551,'enUS','','There\'s an opening up ahead. GO NOW!',26124),
(38552,'enUS','GOBIN!!!','',26124),
(38553,'enUS','Killum gobins! Na cayno da BOOM!','',26124),
(38554,'enUS','Gobin ookum ta z\'mbee!','',26124),
(38555,'enUS','Echuta, gobin!','',26124),
(38556,'enUS','Meesa na watun ta longa!','',26124),
(38557,'enUS','Admiral Aubrey is expecting you upstairs, $gsir:ma\'am;.','',26124),
(38558,'enUS','F\'dun ta gobins ta da Beeg Badda!','',26124),
(38560,'enUS','Tay\'kn gobins!','',26124),
(38562,'enUS','You... cannot escape us!','You... cannot escape us!',26124),
(38563,'enUS','Quickly! We\'ll ambush them from behind!','Quickly! We\'ll ambush them from behind!',26124),
(38564,'enUS','The living... here?!','The living... here?!',26124),
(38565,'enUS','I\'m free! I owe you my life!','I\'m free! I owe you my life!',26124),
(38566,'enUS','I thought I was a goner for sure!','I thought I was a goner for sure!',26124),
(38567,'enUS','I felt my life slipping out of me.','I felt my life slipping out of me.',26124),
(38568,'enUS','They were trying to change me into a zombie!!!','They were trying to change me into a zombie!!!',26124),
(38569,'enUS','I gotta get out of here before they catch me again!','I gotta get out of here before they catch me again!',26124),
(38570,'enUS','I really can\'t thank you enough!','I really can\'t thank you enough!',26124),
(38571,'enUS','They took the others up into the volcano. Some to turn into zombies, some to sacrifice to their turtle god, Volcanoth!','They took the others up into the volcano. Some to turn into zombies, some to sacrifice to their turtle god, Volcanoth!',26124),
(38572,'enUS','The other captives are up in the volcano... they\'re being sacrificed, or worse, zombiefied!','The other captives are up in the volcano... they\'re being sacrificed, or worse, zombiefied!',26124),
(38573,'enUS','We must hold fast. If Northwatch falls, there is nothing to our backs but the sea!','',26124),
(38574,'enUS','Admiral, can I get a ride to the Blackpool?','Admiral, can I get a ride to the Blackpool?',26124),
(38575,'enUS','I\'m not here on vacation, pal. Noggenfogger sent me down here with a mission: Find out how to turn a profit on these silithid, or wipe \'em clean.$B$BIf a $r like you wants to do some favors for the Steamwheedle Cartel, I could use a hand.','',26124),
(38576,'enUS','Shadows amass and swarm around $n!','Shadows amass and swarm around $n!',26124),
(38577,'enUS','','I don\'t even know how to use this weapon... but I reckon if I stand here looking menacing, the worgen might go somewhere else.',26124),
(38579,'enUS','PR\'PR TA DI, GOBIN!!!','',26124),
(38580,'enUS','All hands topside! Run \'em through!','',26124),
(38581,'enUS','Captain, I need a ride back to Northwatch Hold.','Captain, I need a ride back to Northwatch Hold.',26124),
(38582,'enUS','Godspeed, $c!','',26124),
(38583,'enUS','Mister Blaine? Flag down a gryphon for $n if you please.','',26124),
(38584,'enUS','Aye aye sir! Immediately, sir!','',26124),
(38585,'enUS','Assuming we make it through this, it\'ll take a month to clean the brains off my brasswork.','',26124),
(38586,'enUS','Did they bother to tell you who I am and why I am doing this?','',26124),
(38588,'enUS','Invocation of Blood jumps to Prince Keleseth!','',26124),
(38589,'enUS','Invocation of Blood jumps to Prince Valanar!','',26124),
(38590,'enUS','Invocation of Blood jumps to Prince Taldaram!','',26124),
(38591,'enUS','But what does it matter.  It is time for this to end.','',26124),
(38592,'enUS','Baxter! Get in here and help! NOW!','',26124),
(38593,'enUS','It is time, Frye!  Attack!','',26124),
(38594,'enUS','Apothecaries! Give your life for the Crown!','',26124),
(38595,'enUS','It has been the greatest honor of my life to serve with you, Hummel.','',26124),
(38596,'enUS','Great. We\'re not gutless, we\'re incompetent.','',26124),
(38597,'enUS','...please don\'t think less of me.','',26124),
(38598,'enUS','Izzy, you don\'t happen to know where Yngwie\'s body is, do you?','Izzy, you don\'t happen to know where Yngwie\'s body is, do you?',26124),
(38599,'enUS','','Look, don\'t ask me how I found it. Just toss  it onto that big blue bonfire and destroy Yngwie\'s soul before it\'s too late!',26124),
(38600,'enUS','...or are they just using you like they do everybody else?','',26124),
(38601,'enUS','We ought to leave Crowley in prison with those beasts!','',26124),
(38602,'enUS','Enough!  I\'ve made up my mind.  We need Crowley on our side.','',26124),
(38603,'enUS','Do other decks exist?','Do other decks exist?',26124),
(38604,'enUS','You are astute to ask, young $c.  Scribes are capable of inscribing tarot cards of great power, although even they do not have full control of what they make.  The fates decide for them.$b$bIf you manage to obtain a completed deck, please bring it to me for a magnificent reward.','',26124),
(38605,'enUS','Get your head in the game, $n!','',26124),
(38606,'enUS','Alright, people, hold that line!','',26124),
(38607,'enUS','The play is a Kilo Tango Charlie Blitz on three. One... two... three! Um... guys?!','',26124),
(38608,'enUS','We\'re up against pterrodax, sharks, teraptors, and bomb-throwing monkeys. It\'s going to take a miracle to win!','',26124),
(38609,'enUS','This isn\'t footbomb, kids. This is the real deal!','',26124),
(38610,'enUS','Goldskimmer, are you ready to run with it?','',26124),
(38611,'enUS','Are we gonna let them make a bunch of monkeys out of us? NO!','',26124),
(38612,'enUS','What I wouldn\'t give for one of my Buccaneer shredder suits right about now!','',26124),
(38613,'enUS','Bilgewater Buccaneers for life!','',26124),
(38614,'enUS','Heya, kid. Great job out there!$B$BSee you on the other side.','',26124),
(38615,'enUS','All this talk about food is making me hungry!','',26124),
(38616,'enUS','It\'s afraid.','',26124),
(38617,'enUS','You know the plays, kid. Execute them!','',26124),
(38618,'enUS','','$n! How ya doin\', hon?',26124),
(38619,'enUS','Shadows amass and swarm around $n!','Shadows amass and swarm around $n!',26124),
(38620,'enUS','Holy cats! It worked! Soothfancy, come look at this!','',26124),
(38621,'enUS','What\'s it thinking?','',26124),
(38622,'enUS','It\'s afraid!','',26124),
(38623,'enUS','Spirits appear and surround the altar!','Spirits appear and surround the altar!',26124),
(38624,'enUS','Empowered Flames speed toward $n!','',26124),
(38625,'enUS','','Remain calm!  We will take care of everybody.',26124),
(38626,'enUS','','We have carriages at the ready, we\'re just waiting for King Greymane\'s word.',26124),
(38627,'enUS','Seems I\'ll be cuttin\' yer throat by me self!','',26124),
(38628,'enUS','','We will overcome this.  Do not give into panic.',26124),
(38629,'enUS','I\'ve a surprise for ye, dogs!','',26124),
(38630,'enUS','%s goes into a frenzy!','',26124),
(38631,'enUS','%s\'s Blood Beasts gain the scent of blood!','',26124),
(38632,'enUS','It\'s over Godfrey.  You have no support left among the eastern lords.','',26124),
(38633,'enUS','No... I\'d sooner die than have one of your kind for a king!','',26124),
(38634,'enUS','It is not the time to turn against one another, $n.','',26124),
(38635,'enUS','I need a horse.','I need a horse.',26124),
(38636,'enUS','','Father!',26124),
(38637,'enUS','No, old friend.  I\'ve come to you as an equal.','',26124),
(38638,'enUS','It is decided, then.  We will unite all Gilneans and drive the Forsaken from our lands.','',26124),
(38639,'enUS','Crowley!  You and your elven allies are hereby ordered to serve along the king\'s army.  Cursed or not, you are still bound by Gilnean law!','',26124),
(38640,'enUS','Does this toad speak for you, Genn?  Do you come to our dwelling as a friend?  Or do you come as a tyrant?','',26124),
(38641,'enUS','Lorna!','',26124),
(38642,'enUS','Aye, Genn.  It is not law that binds us.  It is something far stronger.  My men are ready to give their lives under your command.','',26124),
(38643,'enUS','They sunk the Collingwood off the coast, but we managed to drag her carronades to the shore.$B$BThose animals won\'t set one filthy green foot on this beach! Not while I\'ve got powder!','',26124),
(38644,'enUS','Bull\'s-eye!','Bull\'s-eye!',26124),
(38645,'enUS','Ooh, that\'s gotta hurt!','Ooh, that\'s gotta hurt!',26124),
(38646,'enUS','What do you think? Zombie Kill of the Week?','What do you think? Zombie Kill of the Week?',26124),
(38647,'enUS','Have you heard of Azshara? There are no zombies there.','Have you heard of Azshara? There are no zombies there.',26124),
(38648,'enUS','Don\'t worry. The zombies are looking for brains. You\'re safe.','Don\'t worry. The zombies are looking for brains. You\'re safe.',26124),
(38649,'enUS','Smoker!','Smoker!',26124),
(38650,'enUS','Quick is the word and sharp is the action, $gMister:Miss; $n.','',26124),
(38651,'enUS','The zombies are coming.','The zombies are coming.',26124),
(38652,'enUS','That\'s right. Look at the pretty flags.','That\'s right. Look at the pretty flags.',26124),
(38653,'enUS','Mister Blaine, signal the shore batteries and let Mr. Whessan know $n is on $ghis:her; way. Handsomely, now.','',26124),
(38654,'enUS','Landro\'s Pet Box','Landro\'s Pet Box',26124),
(38655,'enUS','We got the final barrier blockin\' entry to Frostwing Halls down, $g lad:lass;. Only Sindragosa stands between the Lich King and divine retribution! What are ye waitin\' for?!','',26124),
(38656,'enUS','The barrier to the Crimson Hall be open, $g lad:lass;! I got me best gnomes workin\' on gettin\' the barrier to the Frostwing Halls open. Looks like it\'s gonna be another $4939W days! Fer now, it\'s probably best that you go face the blood princes and their queen!','',26124),
(38657,'enUS','We got the door down and the barrier preventin\' entry to the Plagueworks busted open! My gnomes are werkin\' on gettin\' the barrier to the Crimson Hall down. It\'ll be another $4939W days before that thing comes down.$B$BGet in there and take out some Scourge!\n','',26124),
(38658,'enUS','All barriers are now down, $n! Only Sindragosa stands between the Lich King and us. Justice comes soon...','',26124),
(38659,'enUS','The barrier preventing access to the Crimson Halls has been smashed. The blood princes and their queen await our... arrival. Let\'s not keep them waiting.$B$BThe last barrier, preventing our access to Frostwing Halls, will be dismantled in $4939W days.','',26124),
(38660,'enUS','The goblins have finally managed to take down the door leading to the upper reaches of the spire. Our magi have also successfully deactivated the first of three barriers within the sanctum. Access to the Plagueworks is now open. Get in there and crack some skulls!$B$BWe should have the barrier to the Crimson Halls open in $4939W days.\n','',26124),
(38661,'enUS','Impossible!','',26124),
(38662,'enUS','He\'s too strong!  Use the catapults to bring him down!','',26124),
(38663,'enUS','|TInterface\\Icons\\spell_shadow_unstableaffliction_1.blp:16|t%s cast |cFFFF0000Volatile Experiment!|r','',26124),
(38664,'enUS','You are not worthy to face the Lich King!','',26124),
(38665,'enUS','Not my gears - not my beautiful gears! ','',26124),
(38666,'enUS','\'ey! That\'s the Admiral\'s finest silver!','',26124),
(38667,'enUS','The end is upon you.  Enter... oblivion.','',26124),
(38668,'enUS','How long can you fight it?','',26124),
(38669,'enUS','Arise minions.  Do not let them pass.','',26124),
(38670,'enUS','Minions, sieze them.  Bring their corpses back to me.','',26124),
(38671,'enUS','Foolish girl!  You seek that which I killed long ago.  A faint echo in my mind.','',26124),
(38672,'enUS','','%s fires a frozen orb towards $n!',26124),
(38673,'enUS','We\'re in a pretty tight pickle here, $n.','',26124),
(38674,'enUS','','I definitely did NOT sign up for this! Pygmies, zombies... Hobart better give me a huge raise!',26124),
(38675,'enUS','','Just when I thought it couldn\'t get any worse....',26124),
(38676,'enUS','What are we doing up here? Shouldn\'t we be trying to find a way off of this island?!!!','',26124),
(38677,'enUS','This Town-In-A-Box is a remarkable feat of engineering!','',26124),
(38679,'enUS','$n is infected with the Death Plague!','',26124),
(38680,'enUS','Now is not the time for idle chit-chat, squire $n.  We are in the middle of a quest.','',26124),
(38681,'enUS','FIRE! FIRE!','',26124),
(38682,'enUS','Intruders have breached the inner sanctum. Hasten the destruction of the green dragon! Leave only bones and sinew for the reanimation!','',26124),
(38683,'enUS','We sally forth in search of the dragons\' despicable broodmother.  Follow me, squire!','',26124),
(38684,'enUS','You should try using my stallion\'s stomp ability.  Her powerful hooves will cleave the ground itself, stunning any nearby dragons.','',26124),
(38685,'enUS','What luck!  Pimento\'s hooves have kicked up some stones that we may use against the mighty dragons.  Oh glorious day!','',26124),
(38686,'enUS','I see the dragon up ahead.  She is larger than I had first anticipated.','',26124),
(38687,'enUS','Dragon!  Hear me out!  I am Maximillian of Northshire, and I have come to deliver you.  Your blood shall fill...','',26124),
(38688,'enUS','Great Uther\'s ghost, it\'s chasing after us!  Squire, do something!  Throw rocks at it!  I have no plan!','',26124),
(38689,'enUS','Wait, I have an idea!  Here, throw my Light-blessed shield at the beast!','',26124),
(38690,'enUS','That shield-toss worked remarkably well.  Quickly, hurl my holy shoulder-plate!','',26124),
(38691,'enUS','I have managed to remove my gloves.  You may lob them at our foe.','',26124),
(38692,'enUS','The ironclad heel of my armored boot should prove to be quite destructive.','',26124),
(38693,'enUS','Eat my other shoulder-plate, vile lizard!','',26124),
(38694,'enUS','If you can heft my breastplate, then throw it!  Throw it for Doloria!','',26124),
(38695,'enUS','This is quickly becoming humiliating... and drafty.  Hopefully my legplates shall deal the deathblow.','',26124),
(38696,'enUS','We have done it!  Un\'Goro is cleansed.','',26124),
(38697,'enUS','Squire, meet me back at my camp for your reward.','',26124),
(38698,'enUS','Bravo, $n! It wasn\'t pretty, but it worked.','',26124),
(38699,'enUS','Perhaps you should try hurling them at the nearby dragons to practice your throwing arm.','',26124),
(38700,'enUS','Maximillian has handed you his shield.  Throw it at the Devilsaur!  Er... dragon!','',26124),
(38701,'enUS','Keep throwing Maximillian\'s armor!','',26124),
(38702,'enUS','Your health is faltering.  Allow me to help.','',26124),
(38703,'enUS','Why do these bandages smell like wet dog?','',26124),
(38704,'enUS','Thank you - this was turning into a massacre...','',26124),
(38705,'enUS','These bandages reek! I guess I shouldn\'t complain.','',26124),
(38706,'enUS','I think I can limp back to the fortress...','',26124),
(38707,'enUS','Can\'t ... give up...','',26124),
(38708,'enUS','Orcs and trolls! Everywhere!','',26124),
(38709,'enUS','','By wearing, holding, or otherwise using this Bilgewater Cartel Life Rocket, you agree to be bound by the terms of the end user license agreement!',26124),
(38710,'enUS','','Every Life Rocket comes with a two-year contract and FREE non-arbitration clause!',26124),
(38711,'enUS','','The Bilgewater Cartel thanks you for your frequent future purchases!',26124),
(38712,'enUS','','Our Bilgewater Cartel representatives are waiting to help find the payment plan that\'s right for you as soon as you land!',26124),
(38713,'enUS','','Be sure to fill out all included paperwork during your flight!',26124),
(38714,'enUS','Impossible.... Rimefang.... warn....','',26124),
(38715,'enUS','Such a shameful display. You are better off dead.','',26124),
(38716,'enUS','Perhaps you should have stayed... in the mountains!','',26124),
(38717,'enUS','Power... overwhelming!','',26124),
(38718,'enUS','I shall not fail the Lich King. Come and meet your end!','',26124),
(38719,'enUS','Coach, can I get some rocket boots?','Coach, can I get some rocket boots?\n',26124),
(38720,'enUS','Sure thing, kid!','',26124),
(38722,'enUS','Greely, why do the Super Booster Rocket Boots only work on the zombies?','Greely, why do the Super Booster Rocket Boots only work on the zombies?',26124),
(38723,'enUS','','I\'m so glad that you asked, $n!$B$BNo one ever asks how stuff works. It\'s just here, gimme that, I\'m gonna blow stuff up. Or, don\'t bore me with the details, just let me point and shoot. Or, worse yet, who cares how it works, is it a bigger explosion than last time?$B$BI swear sometimes, I could just scream, you know? It\'s like I\'m always doing all of Hobart\'s work for him, but I never get any of the credit! I have got to be the most underappreciated, overworked, and underpaid tinkers assistant ever!$B$BWait, what did you ask about?',26124),
(38724,'enUS','Maximillian, I am ready to ride.','Maximillian, I am ready to ride.',26124),
(38725,'enUS','It\'s a good thing I love building ships, because these pirates love blowing them up.','',26124),
(38726,'enUS','Megs sent me to get a boat.','Megs sent me to get a boat.',26124),
(38727,'enUS','%s cast Volatile Ooze Adhesive!','',26124),
(38728,'enUS','%s cast Gaseous Bloat!','',26124),
(38729,'enUS','Thank you!  I owe you my life.','',26124),
(38730,'enUS','Yes, yes, that\'s all very interesting, but as you can see here, we\'re in a fight for our lives, and these pygmies are the least of our problems compared to what\'s inside that cave!$B$BWhere\'s my worthless assistant when I need her the most? Probably off being lazy somewhere and complaining that no one asks her how her day is going....','',26124),
(38731,'enUS','Keep it down lady!','Keep it down lady!',26124),
(38732,'enUS','We\'ve been getting a lot of complaints about your yelling.  Keep it down.','We\'ve been getting a lot of complaints about your yelling.  Keep it down.',26124),
(38733,'enUS','Lady, you need to lower your voice.','Lady, you need to lower your voice.',26124),
(38734,'enUS','No one wants your bread lady.  But what we do want is for you to keep it down.','No one wants your bread lady.  But what we do want is for you to keep it down.',26124),
(38735,'enUS','Anywhere but here...','',26124),
(38736,'enUS','What\'s wrong with me??!','',26124),
(38737,'enUS','My face!  What\'s wrong with my face!','',26124),
(38738,'enUS','My hands... don\'t look at my hands!!','',26124),
(38739,'enUS','The pain is unbearable!','',26124),
(38740,'enUS','Make it stop!','',26124),
(38741,'enUS','I can\'t fight it!','',26124),
(38742,'enUS','Bastoon! Humiliate the interlopers.','',26124),
(38743,'enUS','I\'m ready to pilot our silithid.','I\'m ready to pilot our silithid.',26124),
(38744,'enUS','','This mastiff will help you find the hidden worgen.',26124),
(38745,'enUS','Oke doke, boss. I will finish this.','',26124),
(38746,'enUS','Is that all you\'ve got, \'Hexmaster?\'','',26124),
(38747,'enUS','It be time to squeal, little piggy!','',26124),
(38748,'enUS','BAH! Your shadows frighten no one, Bastoon. This one is mine.','',26124),
(38749,'enUS','HAH! Weakness! I expected nothing more.','',26124),
(38750,'enUS','No - no! This land... is ours...','',26124),
(38751,'enUS','','I don\'t see any good reason for these ogres to waste their lives sitting out here in the sand when they could join the Horde and work for us.$B$BI mean look at them! If we don\'t exploit them, who will?',26124),
(38752,'enUS','What want?','',26124),
(38753,'enUS','Ogre look funny.','',26124),
(38754,'enUS','Me hungry.','',26124),
(38755,'enUS','Me not like sand.','',26124),
(38756,'enUS','You sign charter! Is good!','You sign charter! Is good!',26124),
(38757,'enUS','We get tabard?','',26124),
(38758,'enUS','Me still hungry.','',26124),
(38759,'enUS','Thank you, funny ogre!','',26124),
(38760,'enUS','Me not understand.','',26124),
(38761,'enUS','Read make head hurt.','',26124),
(38762,'enUS','...me forget what you said.','',26124),
(38763,'enUS','Yay!','',26124),
(38764,'enUS','Okay. Me sign.','',26124),
(38765,'enUS','','My power is waning... you fool! I will come for you next!',26124),
(38766,'enUS','Doc!','Doc!',26124),
(38767,'enUS','Little help here!','Little help here!',26124),
(38768,'enUS','Help me, help me!','Help me, help me!',26124),
(38769,'enUS','Ouch!','Ouch!',26124),
(38770,'enUS','I\'m bleeding!','I\'m bleeding!',26124),
(38771,'enUS','Medic!','Medic!',26124),
(38772,'enUS','Doc! Help!','Doc! Help!',26124),
(38773,'enUS','That hurt!','That hurt!',26124),
(38775,'enUS','On my way!','',26124),
(38776,'enUS','Just a sec!','',26124),
(38777,'enUS','I only have two hands and two feet here!','',26124),
(38778,'enUS','I hope I don\'t run out of bandages!','',26124),
(38779,'enUS','I need an assistant!','',26124),
(38780,'enUS','Someone needs to do something about that giant turtle in the cave!','',26124),
(38781,'enUS','This is exhausting!','',26124),
(38782,'enUS','Twenty CCs of Kaja\'Cola, stat! Not for the patient... for me!','',26124),
(38783,'enUS','We\'ve got an eye on you, pie vendor.','We\'ve got an eye on you, pie vendor.',26124),
(38784,'enUS','We know all about you, and the perfume, and the rose petals.  Watch it!','We know all about you, and the perfume, and the rose petals.  Watch it!',26124),
(38785,'enUS','We\'re watching you, pie vendor.','We\'re watching you, pie vendor.',26124),
(38786,'enUS','Watch your step, pie vendor.  You are flirting with disaster.','Watch your step, pie vendor.  You are flirting with disaster.',26124),
(38787,'enUS','We\'ve been getting some complaints about your pies.  Clean up your act!','We\'ve been getting some complaints about your pies.  Clean up your act!',26124),
(38788,'enUS','Keep it down fruit vendor!','Keep it down fruit vendor!',26124),
(38789,'enUS','We\'ve been getting reports about your noise.  Quiet down!','We\'ve been getting reports about your noise.  Quiet down!',26124),
(38790,'enUS','We\'ve gotten complaints that your fruit is not as fresh as you claim.','We\'ve gotten complaints that your fruit is not as fresh as you claim.',26124),
(38791,'enUS','We\'ve heard that you are selling some bad apples.','We\'ve heard that you are selling some bad apples.',26124),
(38792,'enUS','We\'re watching you, meat vendor.','We\'re watching you, meat vendor.',26124),
(38793,'enUS','Watch your step around here, meat vendor.','Watch your step around here, meat vendor.',26124),
(38794,'enUS','We\'ve heard reports of people getting sick off of bad meat.  We\'re watching you, meat vendor!','We\'ve heard reports of people getting sick off of bad meat.  We\'re watching you, meat vendor!',26124),
(38795,'enUS','Watch where you\'re going, meat vendor.','Watch where you\'re going, meat vendor.',26124),
(38796,'enUS','Show me the armor of Scourge lords, Ormus.','Show me the armor of Scourge lords, Ormus.',26124),
(38797,'enUS','I wish to join the battle underway.','I wish to join the battle underway.',26124),
(38798,'enUS','The Battle for Gilneas City is underway!  You can head to the frontlines or wait until our men regroup for the next attack.','',26124),
(38799,'enUS','Our men are regrouping.  They will be ready for battle in mere minutes.','',26124),
(38800,'enUS','Me help goblin lady make friend with ogres.','',26124),
(38801,'enUS','','Hey, ogre. Now that your tribe\'s signed the proper paperwork, what can we do to actually convince all of them to come do work for us?',26124),
(38802,'enUS','','WHAT OGRE LIKE. WHAT GOOD FUN FOR GIVE OGRE.',26124),
(38803,'enUS','','%s sighs.',26124),
(38804,'enUS','','The silithid? Those things are disgusting and completely inedible...oh, whatever.',26124),
(38805,'enUS','','',26124),
(38806,'enUS','Greetings, hero. I craft and sell Freya\'s Lasherweave armor for druids.','Greetings, hero. I craft and sell Freya\'s Lasherweave armor for druids.',26124),
(38807,'enUS','I wish to browse your wares.','I wish to browse your wares.',26124),
(38808,'enUS','...me not know what you say.','',26124),
(38809,'enUS','Greetings, hero. I craft and sell Frost Witch armor for shaman.\n','Greetings, hero. I craft and sell Frost Witch armor for shaman.\n',26124),
(38810,'enUS','Greetings, hero. I craft and sell Shadowblade armor for rogues.\n','Greetings, hero. I craft and sell Shadowblade armor for rogues.\n',26124),
(38811,'enUS','Greetings, hero. I craft and sell Ahn\'kahar Blood Hunter armor for hunters.','Greetings, hero. I craft and sell Ahn\'kahar Blood Hunter armor for hunters.',26124),
(38812,'enUS','Greetings, hero. I craft and sell Ymirjar Lord\'s armor for warriors.','',26124),
(38813,'enUS','Greetings, hero. I craft and sell Lightsworn armor for paladins.\n','Greetings, hero. I craft and sell Lightsworn armor for paladins.\n',26124),
(38814,'enUS','Greetings, hero. I craft and sell Crimson Acolyte armor for priests.\n','Greetings, hero. I craft and sell Crimson Acolyte armor for priests.\n',26124),
(38815,'enUS','Greetings, hero. I craft and sell Bloodmage armor for magi.\n','Greetings, hero. I craft and sell Bloodmage armor for magi.\n',26124),
(38816,'enUS','Greetings, hero. I craft and sell Dark Coven armor for warlocks.\n','Greetings, hero. I craft and sell Dark Coven armor for warlocks.\n',26124),
(38817,'enUS','Oh. Ogre like eat bug. Get bug from west.','',26124),
(38818,'enUS','Spirits rise once again!','Spirits rise once again!',26124),
(38819,'enUS','','Leave the fire alone, pesky trolls! Just give up and die.',26124),
(38820,'enUS','','No! I will make your death slow and painful, little trolls.',26124),
(38821,'enUS','','You were a fool to touch my fires! When Vol\'jin falls, you know who dies next!',26124),
(38822,'enUS','','What is this?! Release me!',26124),
(38823,'enUS','','This is not right - this is not how it was supposed to end!',26124),
(38824,'enUS','','The waves shall rise and consume your tribe, Vol\'jin! You should never have returned!',26124),
(38825,'enUS','She\'s drawing power from the fires! Stamp out the braziers, quickly!','',26124),
(38826,'enUS','','Take care of her spirits! We be handlin\' Zar\'jira.',26124),
(38827,'enUS','<The unfortunate soldier you find at the side of the road has been gutted with what appears to have been long knives. Rolling the body over, you notice teeth marks.>$B$B<Could wild animals have done this?> ','',26124),
(38828,'enUS','The Sea Witch is \'ere, I can sense it. Stay and she\'s sure to come out of her hole soon enough.','',26124),
(38829,'enUS','It be done. Our ancient enemy is defeated.','',26124),
(38830,'enUS','[DND] Have you filled out the proper paper work and paid the appropriate fees to gain access to the auction house?','[DND] Have you filled out the proper paper work and paid the appropriate fees to gain access to the auction house?',26124),
(38831,'enUS','I have the proper certification to use the bank.','I have the proper certification to use the bank.',26124),
(38832,'enUS','[DND] Have you filled out the proper paper work and paid the appropriate fees to gain access to the bank?','[DND] Have you filled out the proper paper work and paid the appropriate fees to gain access to the bank?',26124),
(38833,'enUS','I been waitin\' a long time for a chance to avenge my father. A great weight has been lifted from my shoulders.','',26124),
(38834,'enUS','I must be returnin\' ta Darkspear Hold. Please meet me there once Vanira is done with her healin\' of the boy.','',26124),
(38835,'enUS','','I\'m afraid there\'s nothin\' I can do for our brother... her power tore away at his soul.',26124),
(38836,'enUS','','I\'ll send some watchers ta get his body so we can offer a proper farewell... I wish I could do more.',26124),
(38837,'enUS','','Vol\'jin rushed off in eagerness, but I can take us back to safety. Just give me the word when ya ready, mon.',26124),
(38838,'enUS','','An ancient score is settled today.',26124),
(38839,'enUS','Now then, $n. Let\'s see what this what this crazy stick is capable of...','',26124),
(38840,'enUS','Interesting. Very ... interesting.','',26124),
(38841,'enUS','Look at this mess. I was told the Barrens would be... barren.$B$BThis jungle appeared overnight and has already swallowed up my camp and choked off the roads!','',26124),
(38842,'enUS','Have you come to join the hunt, $n?','Have you come to join the hunt, $n?',26124),
(38843,'enUS','Be gone, $c.  I have no need of you in my hunt.','Be gone, $c.  I have no need of you in my hunt.',26124),
(38844,'enUS','Gol-Crawdad!?','',26124),
(38845,'enUS','Frappin\' cratchet! Sonnova HEY what!?','',26124),
(38846,'enUS','\'magonna - git! Git! Horkin\' nit, unfh, DABBIT!','',26124),
(38847,'enUS','Stay out of the way of Volcanoth\'s breath!','',26124),
(38848,'enUS','','Stop shooting you senile idiot! You\'re going to kill somebody!',26124),
(38849,'enUS','Hang in there ol\' buddy!','',26124),
(38850,'enUS','[ph]Citizens of Thunder Bluff! Our matriarch Magath requires citizens wanting to access their vault to pay a small service fee.  ','[ph]Citizens of Thunder Bluff! Our superior matriarch Magath requires citizens wanting to access their vault to pay a small service fee.  ',26124),
(38851,'enUS','[ph]This fee ensures the use of the bank for a limited amount of time.  ','[ph]This fee ensures the use of the bank for a limited amount of time.  ',26124),
(38852,'enUS','[ph]Citizens who refuse to pay this fee will not be allowed to use the banking services here on Thunder Bluff.','[ph]Citizens who refuse to pay this fee will not be allowed to use the banking services here on Thunder Bluff.',26124),
(38853,'enUS','[ph]Purchase a permission slip from me and access to your vault will be granted.','[ph]Purchase a permission slip from me and access to your vault will be granted.',26124),
(38854,'enUS','The %s is ready to be captured!','',26124),
(38855,'enUS','[ph]Attention Citizens of Thunder Bluff!','[ph]Attention Citizens of Thunder Bluff!',26124),
(38856,'enUS','[ph]For a small fee, you can have an all access pass to either Grimtotem auctioneer.','[ph]For a small fee, you can have an all access pass to either Grimtotem auctioneer.',26124),
(38857,'enUS','[ph]All money collected will be used for the betterment of the Horde.','[ph]All money collected will be used for the betterment of the Horde.',26124),
(38858,'enUS','To use the convienent Grimtotem Auctioneering services, you must have the permission of the great Magatha Grimtotem!','To use the convienent Grimtotem Auctioneering services, you must have the permission of the great Magatha Grimtotem!',26124),
(38859,'enUS','[ph]Citizens unwilling to pay will be refused access to the Auction services.','[ph]Citizens unwilling to pay will be refused access to the Auction services.',26124),
(38860,'enUS','$n - help! The ropes ... please...','',26124),
(38861,'enUS','Untying','Untying',26124),
(38862,'enUS','Ah, thank you! Suffice it to say... Negotiations did proceed as planned.','',26124),
(38863,'enUS','I should be able to get back to camp on my own.','',26124),
(38864,'enUS','[ph]Caire is dead?  It\'s hard to imagine.','[ph]Caire is dead?  It\'s hard to imagine.',26124),
(38865,'enUS','[ph]It is still fortunate for us.  Magatha has guided us well.  She knew this day would come.','[ph]It is still fortunate for us.  Magatha has guided us well.  She knew this day would come.',26124),
(38866,'enUS','[ph] So soon though?  I do not think even she thought this invasion would go as swiftly as it did.','[ph]Thinking about things?  What do YOU have to think about?',26124),
(38867,'enUS','[ph]To be standing in Thunder Bluff....OUR Thunder Bluff so soon after Cairne died is not luck.','[ph]To be standing in Thunder Bluff....OUR Thunder Bluff so soon after Cairne died is not luck.',26124),
(38868,'enUS','What do you need papers for?','What do you need papers for?',26124),
(38869,'enUS','What do you need?','What do you need?',26124),
(38870,'enUS','What are you trying to use?','What are you trying to use?',26124),
(38871,'enUS','What?','What?',26124),
(38872,'enUS','Don\'t worry, your money is safe with us.','Don\'t worry, your money is safe with us.',26124),
(38873,'enUS','I\'ve filled out my paperwork for the bank.','I\'ve filled out my paperwork for the bank.',26124),
(38874,'enUS','','Hang on, $n! We have to get out of here, NOW!',26124),
(38875,'enUS','Blood...more BLOOD!','',26124),
(38876,'enUS','Tha Sea Witch is dead, our home is reclaimed, but our future still be uncertain.','',26124),
(38877,'enUS','Dere\'s only one with tha answers I seek. Ya can stay and watch if ya like.','',26124),
(38878,'enUS','I\'ve no love for Garrosh, dat much is sure, but leavin\' tha Horde is not a decision I be takin\' lightly.','',26124),
(38879,'enUS','Indeed.  Someone did try to kill me, but that is not my greatest concern at this moment.  The world itself calls for my aid.','',26124),
(38880,'enUS','Thrall!  I am glad ya be well.  Dere were rumors otherwise.','',26124),
(38881,'enUS','Vol\'jin, I chose Garrosh because he has the strength to lead our people in these trying times. ','',26124),
(38882,'enUS','I must beg ya council, my friend.  I can\'t be standin\' by Garrosh while he be turnin\' our people against each other for tha sake of war.  My respect for you does not extend to dis new Horde... I am tinkin\' of leadin\' my people away.','',26124),
(38883,'enUS','For all my supposed wisdom, there have been moments that I\'ve barely been able to hold the Horde together. The Wrath Gate and Undercity displayed that clearly enough.','',26124),
(38884,'enUS','The Horde cries for a hero of old. An orc of true blood that will bow to no human and bear no betrayal. A warrior that will make our people proud again. Garrosh can be that hero.','',26124),
(38885,'enUS','I understand, brotha. I will tink on this and be troublin\' ya no furtha. You have a world to be savin\'.','',26124),
(38887,'enUS','Ya be strong and proud, youngblood.  Tha Darkspear will be honored ta have you fight beside d\'em.','',26124),
(38888,'enUS','Throm\'ka, old friend.','',26124),
(38889,'enUS','Dese be dark times, but our people will be stayin\' with tha Horde for tha good of all.  ','',26124),
(38890,'enUS','Thrall\'s words be true. Dey always be. The Horde is much more den a few old, stubborn leaders and a handful of heroes from Northrend. The people be cryin\' Garrosh\'s name... at least for now.','',26124),
(38891,'enUS','So, you wanna find de fabled swords of de Sandfury, eh?$B$BYa be ready ta kill for Sul\'thraze? Spill de blood across de sands? In search of treasure, of power?$B$BIf ya are...welcome to de desert, mon.','',26124),
(38892,'enUS','I have sometin\' to show ya. It be easier to understand if ya see it yourself.','',26124),
(38893,'enUS','','Eekrala gree-kay. By blood and by thorn...',26124),
(38894,'enUS','','New life from clay. Dead earth... reborn.',26124),
(38895,'enUS','','They come... <Snort> Pretty $r, yes? So pretty...',26124),
(38896,'enUS','You deserve to lose this land, for what your people did to us!  Now back off, or face the wrath of the worgen!','',26124),
(38897,'enUS','Don\'t talk back to me, troll.  You know who was left in charge here.  Haven\'t you stopped to ask yourself why Thrall chose me instead of you?','',26124),
(38898,'enUS','Dere be no question why, Garrosh.  He gave ya tha title because ya be Grom\'s son and because tha people be wantin\' a war hero.','',26124),
(38899,'enUS','Ya be no Warchief of mine.  Ya not earned my respect and I\'ll not be seein\' tha Horde destroyed by ya foolish thirst for war.','',26124),
(38900,'enUS','I know exactly what I\'ll be doin\' about it, son of Hellscream.  I\'ll watch and wait as ya people slowly become aware of ya ineptitude.  I\'ll laugh as dey grow ta despise ya as I do.','',26124),
(38901,'enUS','You have sealed your fate, troll.','',26124),
(38903,'enUS','You are lucky that I don\'t gut you right here, whelp.  You are foolish to think that you can speak to your Warchief in such ways.','',26124),
(38904,'enUS','And what exactly do you think that you are going to do about it?  Your threats are hollow.  Go slink away with the rest of your kind to the slums, I will endure your filth in my throne room no longer.','',26124),
(38905,'enUS','And when tha time comes dat ya failure is complete and ya \"power\" is meaningless, I will be dere to end ya rule swiftly and silently.','',26124),
(38906,'enUS','%s spits at Vol\'jin\'s feet.','',26124),
(38908,'enUS','','$n, come on! Get over here!!!',26124),
(38909,'enUS','','EeeKKeech - it stings! It crushes! $GHe:She; tricked us, kills $ghim:her;, kill!',26124),
(38910,'enUS','I will see ta it personally dat the Darkspear rise as a power in their own right.','',26124),
(38911,'enUS','Can you tell me of the time when the Darkspear left Orgrimmar, Vol\'jin?  I need to see Garrosh\'s actions for myself.','Can you tell me of the time when the Darkspear left Orgrimmar, Vol\'jin?  I need to see Garrosh\'s actions for myself.',26124),
(38912,'enUS','Joke\'s on you, mon. I found Jang\'thraze long ago. Had both of de halves...\'til some wily one come and steal one away in de night.','',26124),
(38913,'enUS','Now dat Sang\'thraze is mine again, de only thing ya be findin\' here...is ya own fresh grave.','',26124),
(38914,'enUS','Behold! Sul\'thraze the Lasher be rejoined!','',26124),
(38915,'enUS','Enough\'a dis...Chief Sandscalp can\'t reward me if I\'m dead, yah? Farewell, mon...for good.','',26124),
(38916,'enUS','You can trust our auctioneers.','You can trust our auctioneers.',26124),
(38917,'enUS','I\'ve filled out all the paperwork for the auction house.','I\'ve filled out all the paperwork for the auction house.',26124),
(38918,'enUS','[ph] And to think...no one even saw it coming.','[ph] And to think...no one even saw it coming.',26124),
(38919,'enUS','[ph]She must have been planning this for a long time.','[ph]She must have been planning this for a long time.',26124),
(38920,'enUS','[ph]Attacking Thunder Bluff was easier than expected.','[ph]Attacking Thunder Bluff was easier than expected.',26124),
(38921,'enUS','[ph] Without Cairne, the citizens of Thunder Bluff really didn\'t have much fight in them.','[ph] Without Cairne, the citizens of Thunder Bluff really didn\'t have much fight in them.',26124),
(38922,'enUS','[ph] Now that we have control, there are going to be some changes around here.','[ph] Now that we have control, there are going to be some changes around here.\n',26124),
(38923,'enUS','[ph] I just hope Stormsong was able to take out the Pretender.  With Baine dead, we could take some of these extra guard patrols down.','[ph] I just hope Stormsong was able to take out the Pretender.  With Baine dead, we could take some of these extra guard patrols down.',26124),
(38924,'enUS','[ph] Have you heard anything from the attack on Bloodhoof Village?','[ph] Have you heard anything from the attack on Bloodhoof Village?',26124),
(38925,'enUS','[ph] Not yet.  When I last talked to Tarakor, it should have started already.','[ph] Not yet.  When I last talked to Tarakor, it should have started already.',26124),
(38926,'enUS','[ph] Just stay alert.  Any sign of Bloodhoof and we\'ll have a true fight on our hands.','[ph] Just stay alert.  Any sign of Bloodhoof and we\'ll have a true fight on our hands.',26124),
(38927,'enUS','This ain\'t the first time I been stuck up to me teef in a jungle that up an\' done ambushed me. I been all over the world, $gson:missy;, an\' I\'ll be hog-smacked if this one\'s gonna be the end of me.','',26124),
(38928,'enUS','Tell me a story, Ol\' Durty Pete!','Tell me a story, Ol\' Durty Pete!',26124),
(38929,'enUS','Back in the day \'afore the day, me and me mates didn\'t have much in the way of drinkin\' money, as is we spent our pay on booze an\' that didn\'t leave none left over for more casual drinkin\'.$B$BSo we decide we\'re gonna comm-an-deer one of them epic-sized kegs of ol\' Barkerstout from the loft of Barky\'s Brewpub.$B$BWe chopped the supports out with hatchets and that ol\' boy just up an\' ROLLED on out through the side of the thatch roof like a baby bird leavin\' the nest, but some sort of big round beer bird, that could crush a man.','',26124),
(38930,'enUS','You know why they call it stout? \'Cuz once it were rolling down the hill it couldnae be bargained wit\', couldnae be reasoned wit\'. It felt no pity, no remorse, no fear.$B$BIt were like a beervalanche, which is a damn fine way to die.$B$BSo that keg explodered soon as it hit the orphanage at the bottom of the hill, and I dove inta the mud puddle wit\' me mouth open, an\'... Come to think of it, I don\'t \'member how this story ends. Wanna see the tattoo?$B$B<Ol\' Durty Pete drops his pants.>','',26124),
(38931,'enUS','You see this here gun, $gboy:missy;?$B$B<Ol\' Durty Pete casually waves his weapon directly at your face.>$B$BThis here gun\'s seen action on every continent but for Northrend. It\'s saved me life more times than I can count: Seven. One time, \"Big Mackie\" MacDungal - not the wee MacDungal now, but his pappy - offered me his youngest daughter in barter for me gun.$B$BLet me tell you somethin\' about Edie: she and me gun had a lot in common. Wide-mouthed. Buck-toofed. Dangerous from the biz-ness end. Likin\' to go oft half-cocked.$B$BYou heard about the time wee Edie bet Chuck Brandybeard 25 silver she could kick \'im in the head so hard he would weep snot?','',26124),
(38932,'enUS','Ayup, word got around fast and soon the whole of Menethil gathered around to see it through, with bettin\' and fruit vendors and the like, an\' there were some consternation over the rules that had to be ironed out with a big rigamarole, \'til the mayor hisself agreed that weepin\' blood tain\'t count fer nothin\'.$B$BSo Chuck kneels down an\' she gets up on a stool and REARS back with that big \'ol thick leg of hers and - but I\'m digressin\'. Point is, I shoulda taken the deal, \'cuz this gun\'s a bit dodgy.','',26124),
(38933,'enUS','They didn\'t always call me Ol\' Durty Pete.$B$BOnce, when I were young an\' durty, I thought I\'d impress a sweet buxom lass named Bellie with me chiselin\' styles.$B$BOl\' Bellie! She were somthin\' else. Firm, that one. All big but for the middle, like they was meant to be.$B$BSo I found me a chunk of limestone white like her skin and I set about to chiselin\' and carvin\' and creatin\' what you\'d call a masterpiece, but I got me scale all wrong, see? I ended up with an enormous, what would you call it? Butt.','',26124),
(38934,'enUS','You heard me, $glad:lass; - a butt! Not a fitting gift for a lady. But I liked it. So I offered to donate it to me local drinkin\' hole.$B$BThey called it Durty Pete\'s Bottom, and eventually named the pub after it, afore them orcs burned it to toast, and all that\'s left today is me big blackened bottom amidst a heap of rubble.$B$B<Ol\' Durty Pete sheds a single tear.> ','',26124),
(38935,'enUS','Back in the war - not that one, the udder one - when them orcs rode dragons? Me and Whistler set out to cross from Southshore to Menethil Harbor inna rowboat we\'d built outta knotty pine while soused to our eyeballs on Cherry Grog.$B$BAn\' we got about a third the way by my reckoning, which were mostly far judgin\' by the fact that there were nothing all around us but the sea, when my feet got to start feelin\' wet.','',26124),
(38936,'enUS','Now let me tell you somethin\' about knotty pine, it\'s got knots, $gson:missy;.$B$BAnd knots is just big holes in trees, which makes for a stupid rowboat and I blamed Whistler but he had his own ideas about my choice of tar (I chose to forget it) so we decided to settle it by drinking.$B$BWhen the grog ran out, that\'s when we had the knife fight. For sport.$B$BAnyways, we never made it to Menethil, and I\'m pretty sure one or both of us drowned.','',26124),
(38937,'enUS','That sounds serious.','That sounds serious.',26124),
(38938,'enUS','Tell me another story, Ol\' Durty Pete!','Tell me another story, Ol\' Durty Pete!',26124),
(38939,'enUS','Weep SNOT!?','Weep SNOT!?',26124),
(38940,'enUS','A butt?','A butt?',26124),
(38941,'enUS','That\'s not good.','That\'s not good.',26124),
(38942,'enUS','I\'ve heard this one. Tell me another...','I\'ve heard this one. Tell me another...',26124),
(38943,'enUS','','OH MY GOSH! BEHIND YOU!!!',26124),
(38944,'enUS','Ya will spend ya reign glancin\' over ya shoulda and fearin\' tha shadows, for when tha time comes and ya blood be slowly drainin\' out, ya will know exactly who fired tha arrow dat pierced ya black heart.\n','',26124),
(38946,'enUS','You spoke of communing with Thrall?  Did I miss it?','You spoke of communing with Thrall?  Did I miss it?',26124),
(38947,'enUS','And you yours, \"Warchief.\"','',26124),
(38948,'enUS','Keep hacking at the overgrowth! If that doesn\'t work, we\'re going to start burning.','',26124),
(38949,'enUS','I like the way you think, Bridgewater.','',26124),
(38950,'enUS','','Is that your plan, Teegan? Set fire to anything that gets in our way?',26124),
(38951,'enUS','%s slaps a mosquito on his neck.','',26124),
(38952,'enUS','Disgusting! We\'ll have to slash and burn our way to Forward Command.','',26124),
(38953,'enUS','In a word? No.','',26124),
(38954,'enUS','','Aren\'t you the least bit curious why the Barrens are suddenly in bloom, seemingly overnight?',26124),
(38955,'enUS','','WE\'RE ON FIRE!',26124),
(38956,'enUS','Stinking. Disgusting. Filthy animals!','',26124),
(38957,'enUS','I was talking about you and Durty Pete.','',26124),
(38958,'enUS','','YEEEEEEEEEEE HAAAAAAAAAAAA!!!',26124),
(38959,'enUS','Aye, the quilboar are a foul lot.','',26124),
(38960,'enUS','%s belches loudly.','',26124),
(38961,'enUS','There\'s some good huntin\' to be found here in the Barrens, if you\'ve the stomach for it.','',26124),
(38962,'enUS','We\'re still cut off from Forward Command, but thanks to your \'negotiations\' with the quilboar, we should be able to re-open the roads with a little elbow grease.','',26124),
(38963,'enUS','','The Corporal\'s a good man, but he\'s got tunnel-vision when it comes to his orders.$B$BSomething unnatural is happening to the land here, $n. This jungle shouldn\'t be here!',26124),
(38964,'enUS','People tink raptors wild and vicious, but little else. In truth, they be loyal and cunnin\' in ways ya hardly know.','',26124),
(38965,'enUS','','Up and away, hon. I\'ll steer, you just keep an eye out.',26124),
(38966,'enUS','','Alright, throw the Life-Rocket packs down to the survivors, and drop the bombs on the pirates. Try not to mix those up, okay?',26124),
(38967,'enUS','','Geronimo!',26124),
(38968,'enUS','','GENERAL TRIGGER 4 SENT, REMOVE THIS ACTION!',26124),
(38969,'enUS','','See you back in town, babe!',26124),
(38970,'enUS','','We\'re coming up on the Town-In-A-Box now...',26124),
(38971,'enUS','','Oh no! Where is everyone? I dropped them off here!',26124),
(38972,'enUS','%s begins casting Empowered Shock Vortex!','',26124),
(38973,'enUS','','Get in the back seat. We\'re getting out of here. I know where our old friends, the orcs, are!',26124),
(38974,'enUS','Behind you, $n! Look out - incoming!','',26124),
(38975,'enUS','Incoming! Horde incoming - Look out behind you, $n!','',26124),
(38977,'enUS','|TInterface\\Icons\\ability_creature_cursed_01.blp:12|t %s cast |cFFFF7F00Vile Gas!|r','',26124),
(38978,'enUS','Ya want to join the attack on the naga?','',26124),
(38979,'enUS','Yes.  Do you have a raptor that can take me there?','Yes.  Do you have a raptor that can take me there?',26124),
(38980,'enUS','','Get away from me, you monster!  Don\'t look at me!  I\'m hideous!',26124),
(38981,'enUS','You\'re not hideous, Lilian... you\'re one of us.  Here, look in this mirror, see for yourself.','You\'re not hideous, Lilian... you\'re one of us.  Here, look in this mirror, see for yourself.',26124),
(38982,'enUS','','You don\'t understand... I CAN\'T be undead!  Not me, not now...',26124),
(38983,'enUS','','Father, NO!  Wait... where am I?',26124),
(38984,'enUS','','Ahh!  Get away from me, you fiend!',26124),
(38985,'enUS','','What are you doing here?  Get out of here!',26124),
(38986,'enUS','I\'m here to rescue you.','I\'m here to rescue you.',26124),
(38987,'enUS','','First of all, I don\'t need to be rescued.  Second of all, I\'d never allow myself to be rescued by an abomination like you!',26124),
(38988,'enUS','Lilian, you\'re one of the Forsaken, like me.  Which brings the question: why did the Scarlet Crusade put you in a cage?  They usually kill the undead on sight.','Lilian, you\'re one of the Forsaken, like me.  Which brings the question: why did the Scarlet Crusade put you in a cage?  They usually kill the undead on sight.',26124),
(38989,'enUS','Why did the Scarlet Crusade put you in a cage?  They usually kill the undead on sight.','Why did the Scarlet Crusade put you in a cage?  They usually kill the undead on sight.',26124),
(38990,'enUS','','I\'m NOT undead!  Not for long, anyway.  My father will rescue me, I know it...',26124),
(38991,'enUS','Your father?','Your father?',26124),
(38992,'enUS','','First Kezan and now here. We are toast if we don\'t find a way off of this island soon!',26124),
(38993,'enUS','The time has come, my little captive... word has come back from your father.','',26124),
(38994,'enUS','','Gebler, you came!  What did he say?',26124),
(38995,'enUS','High Priest Voss denounces you as a daughter.  He\'s ordered that you be executed immediately.','',26124),
(38996,'enUS','','What?  NO!  This can\'t be!  Gebler, you know me... we were friends once!',26124),
(38997,'enUS','The High Priest sends his regrets.  He had hoped that one day you would be a powerful weapon against our enemies.','',26124),
(38998,'enUS','Unfortunately, you were too dangerous in life, and you\'re far too dangerous in undeath.  I will enjoy killing you, you Scourged witch...','',26124),
(38999,'enUS','','The world of the living may have turned its back on me, but I\'m no damned Scourge.  Just go.',26124),
(39000,'enUS','','Yes, my... wait, be quiet!  I hear the lieutenant approaching.',26124),
(39001,'enUS','','Gebler, father, why would you...',26124),
(39002,'enUS','I\'ve never been more proud ta be a Darkspear. Vol\'jin leads us ta glory.','',26124),
(39003,'enUS','Now I stand, the lion before the lambs... and they do not fear.','',26124),
(39004,'enUS','They cannot fear...','',26124),
(39005,'enUS','A day of celebration and of mourning, hero...','',26124),
(39006,'enUS','Where we go from here is unknown, hero. What we do know is that none of this would have been possible without your aid.$B$BThe Knights of the Ebon Blade salute you.','',26124),
(39007,'enUS','','So cold...',26124),
(39008,'enUS','','The cold dark beckons...',26124),
(39009,'enUS','','Save me from the cold!',26124),
(39010,'enUS','[ph]It appears the Grimtotem clan now has a home to build upon.','[ph]It appears the Grimtotem clan now has a home to build upon.',26124),
(39011,'enUS','[ph]I would not say that so soon.','[ph]I would not say that so soon.',26124),
(39012,'enUS','','I have returned to finish what I started, Darkspear. These islands shall run with your blood.',26124),
(39013,'enUS','Atennnn ... SHUN!','',26124),
(39014,'enUS','','Your father was a weakling, Vol\'jin. I shall enjoy sucking the life from you as I did him.',26124),
(39015,'enUS','','Ah, another Darkspear Warrior sacrificed on my altar. One by one, you shall all perish.',26124),
(39016,'enUS','','Thrall is not here to save you this time, Darkspear. Slink away to the shadows, for I shall hunt every last one of you down.',26124),
(39017,'enUS','','The tides shall wash away the entire Darkspear Tribe.',26124),
(39018,'enUS','','Troll weaklings, there is no hope. Your death has been foretold by the tides.',26124),
(39019,'enUS','','When I am finished with your tribe, I shall hunt down that orcish cur that saved you from my wrath once before. None will survive.',26124),
(39020,'enUS','','You were fools to leave the safety of your city. Your return to the ocean has assured your demise.',26124),
(39021,'enUS','Aaarrrmms ... ABOUT!','',26124),
(39022,'enUS','Right shoulder ... ARMS!','',26124),
(39023,'enUS','PRESENT!','',26124),
(39024,'enUS','Look lively there, Grizwald.','',26124),
(39025,'enUS','When\'s the last time you cleaned that weapon, Holmberg?','',26124),
(39026,'enUS','Barkley, we do NOT aim with our eyes closed!','',26124),
(39027,'enUS','Remember, you will not fire until you see the - whatever color their eyes are.','',26124),
(39028,'enUS','Fast. But not fast enough. We\'ll do it again.','',26124),
(39029,'enUS','Jackson, you\'ve spilled your powder all over the ground. <Sigh>','',26124),
(39030,'enUS','Gentlemen, our business is murder. And business is GOOD.','',26124),
(39031,'enUS','At ease.','',26124),
(39032,'enUS','[ph] We will not have anything to speak of if the Pretender comes here.','[ph] We will not have anything to speak of if the Pretender comes here.',26124),
(39033,'enUS','[ph]Baine?  He would be crazy to come here.  We outnumber him at least two to one.  He\'s the one that should be worried.','[ph]Baine?  He would be crazy to come here.  We outnumber him at least two to one.  He\'s the one that should be worried.',26124),
(39034,'enUS','[ph]Do not underestimate members of the Bloodhoof.  Did you ever see that totem that Cairne carried around?','[ph]Do not underestimate members of the Bloodhoof.  Did you ever see that totem that Cairne carried around?',26124),
(39035,'enUS','[ph]I\'ve only heard stories.  Some say it can only be picked up with two hands, but Cairne could wield it easily in one.','[ph]I\'ve only heard stories.  Some say it can only be picked up with two hands, but Cairne could wield it easily in one.',26124),
(39036,'enUS','[ph] Exactly.  Let us hope that Baine has less than half the strength of his father...or we are going to need more guards.','[ph] Exactly.  Let us hope that Baine has less than half the strength of his father...or we are going to need more guards.',26124),
(39037,'enUS','Now we\'re cooking, $n.','',26124),
(39038,'enUS','Come an\' get it!','',26124),
(39039,'enUS','Yessir, those stormsnouts pack quite a punch.','',26124),
(39040,'enUS','I want you to know that I sincerely appreciate your aid, $c. We are not fighting beasts out here, but a foe both cunning and fanatical. We must stick together or hang separately.','',26124),
(39041,'enUS','What is your name, $c? $n?$B$BWelcome to the Barrens. You are standing at the vanguard of one of our most important operations on this continent. I would be honored if you were to lend us your strength.','',26124),
(39042,'enUS','Tha Darkspear shall never give in to ya kind, Zar\'jira. We\'re stronga\' than you\'ll eva\' be.','',26124),
(39043,'enUS','I\'ll get the fires dis time!','',26124),
(39044,'enUS','','ZUNI! NOOOO!',26124),
(39045,'enUS','','Not so fast, little troll!',26124),
(39046,'enUS','What\'s going on?','What\'s going on?',26124),
(39047,'enUS','Why... what happened...','Why... what happened...',26124),
(39048,'enUS','So cold...','So cold...',26124),
(39049,'enUS','By the Light, I\'m alive again...','By the Light, I\'m alive again...',26124),
(39050,'enUS','What is this place?','What is this place?',26124),
(39051,'enUS','I used to be handsome...','I used to be beautiful...',26124),
(39052,'enUS','The plague... is it over?','The plague... is it over?',26124),
(39053,'enUS','It feels like I\'ve been sleeping for years...','It feels like I\'ve been sleeping for years...',26124),
(39054,'enUS','Ah, I see.  Well, I guess I\'m off to work then.','Ah, I see.  Well, I guess I\'m off to work then.',26124),
(39055,'enUS','...I think I understand what\'s going on.  At least I still have my free will.','...I think I understand what\'s going on.  At least I still have my free will.',26124),
(39056,'enUS','Ah, I see.  Looks like I\'m part of the Horde now.','Ah, I see.  Looks like I\'m part of the Horde now.',26124),
(39057,'enUS','Ah, I understand.  Off to work!','Ah, I understand.  Off to work!',26124),
(39058,'enUS','Undead?  I will have my vengeance against the Lich King!','Undead?  I will have my vengeance against the Lich King!',26124),
(39059,'enUS','Aha, I understand now.  Thank you for waking me.','Aha, I understand now.  Thank you for waking me.',26124),
(39060,'enUS','It\'s so dark in here.  I\'m not sure I like being undead.','It\'s so dark in here.  I\'m not sure I like being undead.',26124),
(39061,'enUS','That was a good nap.  Wait, where\'s my elbows and knees?!','That was a good nap.  Wait, where\'s my elbows and knees?!',26124),
(39062,'enUS','The Scourge will destroy you all!  Death will sweep the lands!','',26124),
(39063,'enUS','Prepare to die!','',26124),
(39064,'enUS','Not so fast! Save some for me, mon!','',26124),
(39065,'enUS','Dis is wild! Vol\'jin\'s not messin\' around. He\'s going afta tha Sea Witch wit a vengeance.','',26124),
(39066,'enUS','Wait up, mon!','',26124),
(39067,'enUS','You finished with ya trainin\' too? Glad you make it through, mon!','',26124),
(39068,'enUS','I know dis is prolly busy work, but I don\'t mind. Dese baby raptors are cute lil devils.','',26124),
(39069,'enUS','Try not ta make me look too bad, eh?','',26124),
(39070,'enUS','Ha! I caught up with ya! Let\'s stick together in \'ere, okay?','',26124),
(39071,'enUS','Take me back to Darkspear Hold if you would, Vanira.','Take me back to Darkspear Hold if you would, Vanira.',26124),
(39072,'enUS','Hey $gman:woman;, I\'m just tryin\' to get my slice of the pie.','Hey $gman:woman;, I\'m just tryin\' to get my slice of the pie.',26124),
(39073,'enUS','You want in on this? Smash and grab, baby!','You want in on this? Smash and grab, baby!',26124),
(39074,'enUS','Hurry up, $c! Take everything you can!','Hurry up, $c! Take everything you can!',26124),
(39075,'enUS','All these dead Tauren got on \'em is beads and junk. Did you score anything good? ','All these dead Tauren got on \'em is beads and junk. Did you score anything good? ',26124),
(39076,'enUS','Hey, $c! This place is pretty picked over but you might still be able to find somethin\' worth your time.','Hey, $c! This place is pretty picked over but you might still be able to find somethin\' worth your time.',26124),
(39077,'enUS','Whoa, you aren\'t here to bust us, are you?','Whoa, you aren\'t here to bust us, are you?',26124),
(39078,'enUS','You\'re under arrest.','You\'re under arrest.',26124),
(39079,'enUS','I ain\'t goin\' back to the clink, $gman:lady;!','I ain\'t goin\' back to the clink, $gman:lady;!',26124),
(39080,'enUS','You\'ll never take me alive, $c!','You\'ll never take me alive, $c!',26124),
(39081,'enUS','Cheese it! It\'s the fuzz!','Cheese it! It\'s the fuzz!',26124),
(39082,'enUS','It didn\'t have to go down this way, $c.','It didn\'t have to go down this way, $c.',26124),
(39083,'enUS','No way I\'m letting them ship me back to the stockades!','No way I\'m letting them ship me back to the stockades!',26124),
(39084,'enUS','I yield. I\'ll go quietly.','I yield. I\'ll go quietly.',26124),
(39085,'enUS','...Busted!','...Busted!',26124),
(39086,'enUS','Okay, stop! I give up!','Okay, stop! I give up!',26124),
(39087,'enUS','Ya trainer should be somewhere in the grounds \'ere. I\'ll catch you lata, mon.','',26124),
(39088,'enUS','','I expect this operation to proceed without major incident.',26124),
(39089,'enUS','I sshal ssslaughter you, Darksspear runt! ','',26124),
(39090,'enUS','The Sssea Witch will kill you all.','',26124),
(39091,'enUS','They sssend you to your death, youngling.','',26124),
(39092,'enUS','I sshal tasste your blood, landling.','',26124),
(39093,'enUS','Hold the line!','',26124),
(39094,'enUS','We will throw these Alliance curs back into the sea!','',26124),
(39095,'enUS','Lok\'tar ogar!','',26124),
(39096,'enUS','Thrall Hall!','',26124),
(39097,'enUS','Teach these cowards the true meaning of war!','',26124),
(39098,'enUS','Fight for your ancestors and your true warchief!','',26124),
(39099,'enUS','The Alliance sends gnomes and dwarves against us? Is this some kind of joke?!','',26124),
(39100,'enUS','Our little friend is here. I weep for the dwarves if the goblin has their weed whacker!','',26124),
(39101,'enUS','Why are you playing with them? It\'s cruel.','',26124),
(39102,'enUS','They eagerly rush to their deaths. What fools!','',26124),
(39103,'enUS','Perhaps they should send their gnomes down here? They could do no worse!','',26124),
(39104,'enUS','They spoil the coast with their cowardly mines. Disgusting!','',26124),
(39105,'enUS','There is no better day than one filled with the blood of dwarves!','',26124),
(39106,'enUS','Tighten it up a little. We wouldn\'t want them to slip through and miss all of the fun.','',26124),
(39107,'enUS','I\'ve seen what our goblin friend can do. These dwarves are in for a nasty surprise!','',26124),
(39108,'enUS','The Kor\'kron could not fight better! For the Horde!','',26124),
(39109,'enUS','Your friends were all taken prisoner by Trade Prince Gallywix while the volcano was exploding.$B$BWe are going to have to deal with the Alliance quickly if we\'re to rescue them and get off of this island.','',26124),
(39110,'enUS','Throm-Ka, $n. It is good to see you again.','',26124),
(39111,'enUS','Working for Jerrod isn\'t all that bad.  He might lose his temper now and again, but he pays well, and he even gives me a boost when I can\'t reach something in the cart.','',26124),
(39112,'enUS','What is it I can do for you?','',26124),
(39113,'enUS','<Deathguard Simmer looks at you expectantly.>','',26124),
(39114,'enUS','Me sorry! No hurt!','',26124),
(39115,'enUS','Any savage can win a war. The true hero aims not merely for victory on the battlefield, but to attain a lasting peace after the final arrow falls.','',26124),
(39116,'enUS','Get back into the skies on the Tranquil Coast or be ejected!','',26124),
(39117,'enUS','You\'re doing incredible work here in the Barrens, $n.$B$BWith the help of heroes like you, we can secure Kalimdor, and in doing so ensure a lasting peace in our homelands.','',26124),
(39118,'enUS','','The Warchief has promised to help us rescue our people and deal with Gallywix if we help them with the Alliance.$B$BIt sounds like a fair deal to me. The enemy of my friend is my enemy, right?',26124),
(39119,'enUS','Get me up into the skies, Sassy!','Get me up into the skies, Sassy!',26124),
(39120,'enUS','$n! How can I help you, old friend?','',26124),
(39121,'enUS','Just between you and me, I worry that the good General here doesn\'t have the stomach to do what needs to be done.$B$BThis is the Horde we\'re dealing with. History shows there can never be peace.$B$BOur goal should be ... annihilation.','',26124),
(39122,'enUS','You might not think that a Worgen like myself would know how to cook a fine steak.$B$BJust \'cuz I like my meat raw... Still panting from flight... Arterial spray in my face...$B$BWhat were we talking about? Oh yes! I was quite the gourmet back in Gilneas.','',26124),
(39123,'enUS','Tell me what happened at Taurajo.','Tell me what happened at Taurajo.',26124),
(39124,'enUS','Ah yes, our assault on the Horde town of Taurajo. I struggled with the implications of the decision.$B$BTaurajo was admittedly what you might call a \'soft target,\' primarily a hunters\' camp. Still, it had been used to recruit, equip, and train Horde infantry for many years.$B$BWhen our scouts reported that Taurajo\'s most dangerous units were out on the hunt, we had to act quickly.','',26124),
(39125,'enUS','We sacked the town?','We sacked the town?',26124),
(39126,'enUS','<Hawthorne wrinkles his brow.>$B$BI would prefer not to use the term \'sacked,\' but yes, the attack went off flawlessly. We removed Taurajo from the equation, confiscated its arms, and destroyed its smithing facilities. The assault gave our forces considerable breathing room and knocked the enemy off balance.$B$BNonetheless, during the assault, I instructed my men to leave a gap open in our lines...','',26124),
(39127,'enUS','Why did you do that?','Why did you do that?',26124),
(39128,'enUS','Taurajo had a significant civilian population. I wanted to ensure that they could escape the fighting, and many did, finding refuge in the north.$B$BThere are some, even in Alliance High Command, who argued that I let an opportunity slip away. That I should\'ve taken hostages. But I don\'t see the value in those sort of terror-tactics.$B$BHear me out, $n: I want this war to end someday. It won\'t ever stop if we butcher or imprison civilians.$B$BI just pray that there are those on the other side who see things as I do.','',26124),
(39129,'enUS','Going somewhere?','',26124),
(39130,'enUS','I\'ll take that flight to Brill now.','I\'ll take that flight to Brill now.',26124),
(39131,'enUS','I\'d like to purchase a bat ride.','I\'d like to purchase a bat ride.',26124),
(39132,'enUS','$n! You\'re alive! Have you heard?','$n! You\'re alive! Have you heard?',26124),
(39133,'enUS','They killed him! General Hawthorne - he was ambushed on the road by Horde assassins.','They killed him! General Hawthorne - he was ambushed on the road by Horde assassins.',26124),
(39134,'enUS','His body was found strung up from a tree. Those animals... Those filthy animals!','His body was found strung up from a tree. Those animals... Those filthy animals!',26124),
(39135,'enUS','The lesson we\'ve learned here in the Barrens is that nothing short of scorched earth will rout these Horde animals. No quarter!','',26124),
(39136,'enUS','Were he still alive to avenge himself, General Hawthorne would have no doubt ordered a retaliatory massacre of biblical proportions.','',26124),
(39137,'enUS','You are quite right, Trask.','',26124),
(39138,'enUS','','Father!',26124),
(39139,'enUS','Lilian... you\'re... it\'s so nice to see you well.','',26124),
(39140,'enUS','','Shut up.',26124),
(39141,'enUS','','You raised me to be a killer.  How am I doing, daddy?',26124),
(39142,'enUS','I, ah...','',26124),
(39143,'enUS','','But wait... I remember now.  You taught me to only kill the undead.  So do you want me to kill myself, daddy?',26124),
(39144,'enUS','Lilian, I...','',26124),
(39145,'enUS','','Then again, why kill myself... when I can kill YOU instead!',26124),
(39146,'enUS','','Thanks for everything... father.',26124),
(39147,'enUS','Turn over the tablets and I will allow you a quick death.','Turn over the tablets and I will allow you a quick death.',26124),
(39148,'enUS','Very well, dwarf. Have it your way. I shall kill you and take the tablets.','Very well, dwarf. Have it your way. I shall kill you and take the tablets.',26124),
(39149,'enUS','','Can I help you with something?',26124),
(39150,'enUS','','Are you ready to begin the procedure?',26124),
(39151,'enUS','We do our best here to heal the broken earth. It was difficult enough before we started getting raided at night.','',26124),
(39152,'enUS','I am ready.','I am ready.',26124),
(39153,'enUS','','Very well.  Follow me.',26124),
(39154,'enUS','','Now it is time for us to begin.',26124),
(39155,'enUS','','Devlin Agamand!  Listen to my voice!',26124),
(39156,'enUS','','Your mortal remains have been gathered, here in this place where you spent your childhood!',26124),
(39157,'enUS','','Resist the Lich King\'s will, Devlin!  Come to us!',26124),
(39158,'enUS','','I had better return to my post.  You can find me downstairs if you need anything.',26124),
(39159,'enUS','','I\'m a little busy at the moment, $c... return when I\'m less preoccupied.',26124),
(39160,'enUS','What\'s going on here?','',26124),
(39161,'enUS','Wait, am I... home?','',26124),
(39162,'enUS','You people... what are you doing here?  Why are you in my house?','',26124),
(39163,'enUS','Mother... father... Thurman... where are you?  Come help me!','',26124),
(39164,'enUS','No... I remember.  My family is dead.  And so am I.','',26124),
(39165,'enUS','And my soul... my soul belongs to the Scourge!','',26124),
(39166,'enUS','DIE, YOU WRETCHES!','',26124),
(39167,'enUS','Into the Thunderdrome, $n! There\'s no getting out until someone\'s hit the sand. Let\'s start the show!','',26124),
(39168,'enUS','','Thank you, $n! Now I can begin my final assembly...',26124),
(39169,'enUS','','Okay... structure? Check. Power? Check. Danger? Double-check. Let\'s fire up my masterpiece!',26124),
(39170,'enUS','','Our equipment is really taking a beating out here!',26124),
(39171,'enUS','Hmmmm... aye. But it\'s a wee bit - uh - wee, innit?','',26124),
(39172,'enUS','Simmer say Gordo got guts, but got no brains.  Why he mean?','',26124),
(39173,'enUS','Gordo like picking flowers.  Pick flowers kind of like killing.','',26124),
(39174,'enUS','It drafty out here.','',26124),
(39175,'enUS','Johaan say Gordo need a tailor to fix Gordo tummy.','',26124),
(39176,'enUS','Gordo, do you think you could repair my gear?','Gordo, do you think you could repair my gear?',26124),
(39177,'enUS','','Nonsense! Miniaturization is the future of warfare.',26124),
(39178,'enUS','Sniff for pheromones to find your way into the hive!','Sniff for pheromones to find your way into the hive!',26124),
(39179,'enUS','','I should mention I reversed the gearbox to accommodate the smaller form-factor.',26124),
(39180,'enUS','On behalf of the illustrious and still neutral Steamwheedle Cartel, I hope you enjoy your stay.$B$BRemember, everyone is welcome in Gadgetzan! Everyone except pirates.','',26124),
(39181,'enUS','Welcome back, friend! It feels like it\'s been years since you helped me whip up my first Noggenfogger Elixer.$B$BNow I\'m running the whole city! Those things still sell like crazy.','',26124),
(39182,'enUS','','The blood of the fallen cries out for justice.',26124),
(39183,'enUS','Any Ladies and Gentlemen present should LEAVE NOW...for only REAL MEN AND WOMEN will be able to handle the gory spectacle about to unfold! Introducing the first fighter, the warrior of the Wastewander, the Ayatollah of Kaja-Cola...THE GINORMUS!','',26124),
(39184,'enUS','Don\'t be a hero. Just walk away.','',26124),
(39185,'enUS','No... it can\'t be.  Our forward outpost has been obliterated!','',26124),
(39186,'enUS','Is it too late?  I feel Deathwing\'s presence nearby!','',26124),
(39187,'enUS','We can afford no delay. Fort Triumph must be completed and reinforced, or any hope we have for permanent settlement on this continent will be erased.','',26124),
(39188,'enUS','When me and my Wildhammer Mercenaries were hired on to secure Fort Triumph, I imagined we\'d be fighting the Horde.$B$BBut we\'re set on from all sides! \'Sploding goblins, burrowing bugs, electro-fied lizards... ','',26124),
(39189,'enUS','The Firelord has risen!  We must send word to the others.  Let us hurry!','',26124),
(39190,'enUS','','The Battlescar is a dangerous place. All the armor in the world can\'t save a steam tank that\'s swallowed up by the earth.',26124),
(39191,'enUS','','What I\'m cooking up is way ahead of its time, $n.$B$BLook at these blueprints! It\'s like licking the future.',26124),
(39192,'enUS','','Sure, it\'s got bugs to work out. But the microtank is a marvel of engineering.$B$Bit uses one quarter the materials of a full-sized siege engine, and it can be mass-produced by anyone! ...with really tiny hands!',26124),
(39193,'enUS','','The Bilgewater Cartel will be in business here by the end of the day, mark my words.',26124),
(39194,'enUS','','<Clarice stares over the body, her eyes vacant.>$B$BI rode here from Theramore as soon as the news reached me.$B$BJohn and I had always talked about settling down when the conflict subsided.$B$BI don\'t think the fighting will ever stop. Do you?',26124),
(39195,'enUS','Our next fighter was found in the deepest tombs of Zul\'Farrak! Gorged on cursed blood, raised from death countless times, he now knows only fury and violence! Dare you face the mindless wrath of...ZUMONGA!','',26124),
(39196,'enUS','The Ginormus has fallen! $n looks like $Ghe\'s:she\'s; ready for more!','',26124),
(39197,'enUS','ZUMONGA...KILL...','',26124),
(39198,'enUS','I can breathe!','',26124),
(39199,'enUS','What day is it?','',26124),
(39200,'enUS','Hey! Those bugs took my watch!','',26124),
(39201,'enUS','Thanks a ton, pal!','',26124),
(39202,'enUS','I\'m alive!','',26124),
(39203,'enUS','Thrall Hall, $n! Here to help kill some misguided dwarves and gnomes?','',26124),
(39204,'enUS','Bastia, let\'s ride!','Bastia, let\'s ride!',26124),
(39205,'enUS','','This might be the only cool place left on the island... right next to the volcano!',26124),
(39206,'enUS','Hey there, $n. You heading in?','',26124),
(39207,'enUS','$n! You wanna help me out here with Fizz? He\'s up to no good again!','',26124),
(39208,'enUS','Evol Fingers must pay! For the love of profit, $n, help me!','',26124),
(39209,'enUS','Turn away, $c.$B$BBefore the cataclysm hit, we found something.$B$BWe dug something up that should\'ve stayed buried.$B$BPray to whatever you believe in that the landslide was enough to keep it down...','Turn away, $c.$B$BBefore the cataclysm hit, we found something.$B$BWe dug something up that should\'ve stayed buried.$B$BPray to whatever you believe in that the landslide was enough to keep it down...',26124),
(39210,'enUS','Grab the gear - we gotta clear out!','Grab the gear - we gotta clear out!',26124),
(39211,'enUS','They\'re everywhere!','They\'re everywhere!',26124),
(39212,'enUS','Save what you can - every Dwarf for himself!','Save what you can - every Dwarf for herself!',26124),
(39213,'enUS','Don\'t let them make off with any of the artifacts!','Don\'t let them make off with any of the artifacts!',26124),
(39214,'enUS','I can\'t believe that Fizz and Evol are at each other\'s throats again. It\'s the pressure. We need you now more than ever, $n.','',26124),
(39215,'enUS','Panic!','Panic!',26124),
(39216,'enUS','','Are you going in there? I\'m not going back in there!',26124),
(39217,'enUS','Please insert coins.','',26124),
(39218,'enUS','That\'s me job, $c. The General goes out on patrol, and I carry his banner and plant it in the dirt.$B$BImagine a General out and about without his banner. He might as well not wear pants.','',26124),
(39219,'enUS','We\'ll let you into the city, this time.','We\'ll let you into the city, this time.',26124),
(39220,'enUS','Hey! Hands off the banner, $gson:missy;.','',26124),
(39221,'enUS','I\'ve filled out my paperwork to enter the city.','I\'ve filled out my paperwork to enter the city.',26124),
(39222,'enUS','You\'re papers look to be in order.  Proceed.','You\'re papers look to be in order.  Proceed.',26124),
(39223,'enUS','Haven\'t I seen you before?  We\'ll be keeping an eye on you, citizen.','Haven\'t I seen you before?  We\'ll be keeping an eye on you, citizen.',26124),
(39224,'enUS','You are only allowed into the city for an hour.  Be quick with your business.','You are only allowed into the city for an hour.  Be quick with your business.',26124),
(39225,'enUS','You have permission to enter the city.','You have permission to enter the city.',26124),
(39226,'enUS','','This was going to be a walk in the park until that airhead over there came out of nowhere with an army of gnomes.$B$BGallywix will have my head if we let these creepy runts one-up us here.',26124),
(39227,'enUS','You\'ll find Marley Twinbraid up top, $gsir:ma\'am;.','',26124),
(39228,'enUS','Mine it\'s mine I found it. Mine I say! Mine! ','',26124),
(39229,'enUS','Do not loiter; we\'ve work to do here.','',26124),
(39230,'enUS','He\'s in here. Let\'s get \'im!','',26124),
(39231,'enUS','What ... what is happening to me?','',26124),
(39232,'enUS','$n has done it again! Zumonga dies once more!','',26124),
(39233,'enUS','The faint of heart may wish to shield their eyes! Being brought into the ring now is a horror, captured from the dark tunnels of the Centipaar Hive! I give you the skittering death: SARINEXX!','',26124),
(39234,'enUS','This is the truth of it! Fighting leads to killing, and killing leads to warring. And that was nearly the end of all our customers!$B$BNow, when men get to fighting, it happens here. And it finishes here! For maximum viewing potential!','',26124),
(39235,'enUS','There is no stopping $n! Sarinexx has been massacred!','',26124),
(39236,'enUS','We\'ve spared no expense for the crowd, folks! We\'re determined to kill $n at any cost, for you, the viewer! Taken all the way from the hidden jungle of Un\'goro Crater, cower in fear at...KING KRAW!','',26124),
(39237,'enUS','UNBELIEVABLE! $n is victorious! King Kraw is no more!','',26124),
(39238,'enUS','','',26124),
(39239,'enUS','I\'ve heard about this Nesingwary guy, out of Stranglethorn Vale, hunting all sorts of beasts for sport.$B$BFor SPORT. What a complete idiot, right? Think of all the profit he\'s letting rot in the field!','',26124),
(39240,'enUS','','Okay. We\'re going to move away from the exploding volcano and try to hook up with the orcs for the final assault on the Trade Prince. See you on the other side... I hope.',26124),
(39241,'enUS','Return to Echo Isles.','',26124),
(39242,'enUS','I used to be overcome with frequent, debilitating fits of rage. But since I met Driz, I\'ve been able to live a happy, productive life.$B$BAnd I get to tear things apart with my bare hands.','',26124),
(39243,'enUS','Just let me know when ya ready, mon.','',26124),
(39244,'enUS','Our ship from Northrend was attacked by Twilight\'s Hammer! I don\'t know how they got aboard, but they killed everyone.','',26124),
(39245,'enUS','Using a crystal Brann sent with the tablets, I managed to protect myself and escape, but one of the attackers followed me!','',26124),
(39246,'enUS','I\'ll use the crystal to shield the tablets. See if it will grant you powers to defend me. If Twilight\'s Hammer\'s minions break through my shield, they\'ll kill me and take the tablets!','',26124),
(39247,'enUS','Hold on tight back there! Seat belts are for chumps.','',26124),
(39248,'enUS','We\'re all very proud of Bael Modan. It was the first dwarven settlement in Kalimdor.','',26124),
(39249,'enUS','Up ahead is Bael\'dun Keep. Isn\'t she a beauty? That stronghold is indestructible!','',26124),
(39250,'enUS','...What the? The keep is under attack!','',26124),
(39251,'enUS','I... I can\'t hold it! Mayday! MAYDAY!','',26124),
(39252,'enUS','Bah! Rowdy tauren don\'t scare me none.','',26124),
(39253,'enUS','It\'s a one-seater plane, but you can always sit up on the fuselage. It\'s perfectly safe.$B$BYou ready?','',26124),
(39254,'enUS','I\'m ready, Marley. Let\'s fly!','I\'m ready, Marley. Let\'s fly!',26124),
(39255,'enUS','Kelsey sent me to get a boat.','Kelsey sent me to get a boat.',26124),
(39256,'enUS','Who\'s the little guy?','Who\'s the little guy?',26124),
(39257,'enUS','He\'s my assistant.$B$BSure, he\'s not been plagued in the same manner as we have, but he is clearly plagued nonetheless.  He\'s bent the knee to Sylvanas, so he\'s as much one of us as you or I.$b$bAnd just between you and me... to be perfectly honest, I think the Dark Lady thought he was already bending his knee when he entered her chamber!','',26124),
(39258,'enUS','','We have to rescue everyone and get out of here before the volcano explodes for real!',26124),
(39259,'enUS','','I\'VE GOT AN IDEA!',26124),
(39260,'enUS','That cursed crystal! We will not give up so easily. We will have that tablet for our ascendants. Perhaps not today, but soon!','That cursed crystal! We will not give up so easily. We will have that tablet for our ascendants. Perhaps not today, but soon!',26124),
(39261,'enUS','You must help me safeguard the Tablets of Earth. Twilight\'s Hammer will not stop until they\'ve taken the tablets.','',26124),
(39262,'enUS','I\'ll help you defend the tablets.','I\'ll help you defend the tablets.',26124),
(39263,'enUS','Hmm... very impressive.  Alright, you\'ve passed my test.','',26124),
(39264,'enUS','','Impressive!  You learn quickly, my pupil.',26124),
(39265,'enUS','You\'ve done it! You\'ve saved the tablets. Hurry and bring them to Ironforge. I\'ll be along once I\'ve had some time to recover.','',26124),
(39266,'enUS','Duokna... this is embarrassing.','',26124),
(39267,'enUS','Duokna, what are you doing?','',26124),
(39268,'enUS','Get down from there this instant!','',26124),
(39269,'enUS','How are you not burning your feet?','',26124),
(39270,'enUS','At last, the tablets are ours!','At last, the tablets are ours!',26124),
(39271,'enUS','Brace yourself, $r.$b$bThe naga could attack again any moment.','',26124),
(39272,'enUS','This region is one of the epicenters of the cataclysm that threatens to rend our world.$b$bIf we manage to survive, we must try to discover its cause.','',26124),
(39273,'enUS','The attacks on these ships, they are clearly not random.$b$bWe must discover the motives of the naga here.','',26124),
(39274,'enUS','This whole keep is going to collapse!','This whole keep is going to collapse!',26124),
(39275,'enUS','Thank you, thank you!','Thank you, thank you!',26124),
(39276,'enUS','How could this have happened?','How could this have happened?',26124),
(39277,'enUS','There are still others - search the barracks!','There are still others - search the barracks!',26124),
(39278,'enUS','How could they have done this?','How could they have done this?',26124),
(39279,'enUS','The roof over the mess hall collapsed. So many - dead!','The roof over the mess hall collapsed. So many - dead!',26124),
(39280,'enUS','This place is up crap creek an\' I ain\'t got no shovel.','I thought I was cooked like a turkey dinner!',26124),
(39281,'enUS','I thought I was done for! Thank you!','I thought I was done for! Thank you!',26124),
(39282,'enUS','Elementals, I bid you come forth and slay this enemy of Twilight\'s Hammer!','Elementals, I bid you come forth and slay this enemy of Twilight\'s Hammer!',26124),
(39283,'enUS','Ouch! I can\'t take much more o\' this!','',26124),
(39284,'enUS','By the Light, that hurts!','',26124),
(39285,'enUS','It\'s trying to bash me skull in!','',26124),
(39286,'enUS','Pouring','Pouring',26124),
(39287,'enUS','I\'ve been here in this valley since before the dark portal opened, $glad:lass;. I don\'t plan on letting a handful of blood elves traipse in here and plunder these ruins!','',26124),
(39288,'enUS','Need something?','',26124),
(39289,'enUS','Can I catch a ride to Razor Hill?','Can I catch a ride to Razor Hill?',26124),
(39290,'enUS','The zeppelin from Northrend was attacked by Twilight\'s Hammer! I don\'t know how they found us, but they killed everyone.','',26124),
(39291,'enUS','We discovered this crystal and tablets in a Titan archive. I used the crystal to buy some time, but they\'re still following me!','',26124),
(39292,'enUS','Use the crystal\'s power to defend me and the tablets. If Twilight\'s Hammer\'s minions break through my shield, they\'ll kill me and take the tablets!','',26124),
(39293,'enUS','At last, you\'ve driven them off. Take the tablets to Earthmender Norsala in the Valley of Strength at once! Tell her that I\'ll be along once I\'ve had some time to recover.','',26124),
(39294,'enUS','Hurry, I need help!','',26124),
(39295,'enUS','Don\'t let them overpower us!','',26124),
(39296,'enUS','These Twilight\'s Hammer fools would tear the very earth apart to get these tablets.','',26124),
(39297,'enUS','','NOOOOOOO!',26124),
(39298,'enUS','%s is casting Envenom!  Place your totem down now!','',26124),
(39299,'enUS','Thank you, $r... I was close to death.  May I stay by your side for a moment?','Thank you, $r... I was close to death.  May I stay by your side for a moment?',26124),
(39300,'enUS','I was supposed to die in battle... ah well, another day.  I will follow you until I recover.','I was supposed to die in battle... ah well, another day.  I will follow you until I recover.',26124),
(39301,'enUS','You\'ve saved my life, $c.  Protect me for a few more moments while I recover.','You\'ve saved my life, $c.  Protect me for a few more moments while I recover.',26124),
(39302,'enUS','For the Warchief!  You lead, I will follow.','For the Warchief!  You lead, I will follow.',26124),
(39303,'enUS','I feel much better now.  For the Horde!','I feel much better now.  For the Horde!',26124),
(39304,'enUS','Thank you again.  I will return to Razor Hill now.','Thank you again.  I will return to Razor Hill now.',26124),
(39305,'enUS','It was an honor to watch you fight, $n.','It was an honor to watch you fight, $n.',26124),
(39306,'enUS','You fight well.  I will leave you now.  Lok\'tar ogar!','You fight well.  I will leave you now.  Lok\'tar ogar!',26124),
(39307,'enUS','You have to help me, $c! Twilight\'s Hammer attacked my zeppelin and their men tried to take the tablets and the crystal I was transporting to Orgrimmar.','',26124),
(39308,'enUS','I\'ll help you defend the tablets.','I\'ll help you defend the tablets.',26124),
(39312,'enUS','','We\'re not a part of your system!',26124),
(39313,'enUS','What... what are those things on the rooftops?','What... what are those things on the rooftops?',26124),
(39314,'enUS','Back to work!','',26124),
(39315,'enUS','You no slave! Work or die!','',26124),
(39316,'enUS','Me get big bonus for capture you!','',26124),
(39317,'enUS','At last it is time for the exiled gnomes to return.$B$BOnce again Gnomeregan will be our home!','',26124),
(39318,'enUS','Trade Prince say hurt you!','',26124),
(39319,'enUS','You no mine ore, you get beating!','',26124),
(39320,'enUS','Me like beat you up!','',26124),
(39321,'enUS','Me overseer, you slave!','',26124),
(39322,'enUS','Break time over!','',26124),
(39323,'enUS','What is your plan?','What is your plan?',26124),
(39324,'enUS','The dwarves have kept us safe in their home for some time now, and for that we thank them.  However, the traitorous Thermaplugg\'s occupation of our home must at last come to an end.$B$BGnomeregan has festered beneath the atomic weight of our ill-conceived plan for too long. The detonation of the radiation bombs drove us from our city, but we now possess the technology to take it back!$B$BWe will regain what is ours... and bring Thermaplugg to justice!','',26124),
(39326,'enUS','Operation: Gnomeregan is divided into a number of phases:$B$BFirst, we must retake the air tower.  This will allow our planes give us air support as we move towards Gnomeregan\'s main entrance.$B$BIn addition, a cache of mechanized Battle Suits was discovered in one of the nearby buildings.  Once we have those suits, our assault on the entrance should be unstoppable.$B$BThen, we go straight for Thermaplugg in the heart of Gnomeregan!','',26124),
(39327,'enUS','Somebody... anybody...','Somebody... anybody...',26124),
(39328,'enUS','I\'ll never see my wife again...','I\'ll never see my husband again...',26124),
(39329,'enUS','H-help me!','H-help me!',26124),
(39330,'enUS','I can\'t fight any longer...','I can\'t fight any longer...',26124),
(39332,'enUS','What is going on here?','What is going on here?',26124),
(39333,'enUS','','%s appears to be weakening!',26124),
(39334,'enUS','[PH] We shall not fail or falter.','',26124),
(39335,'enUS','[PH] We shall not weaken or tire.','',26124),
(39336,'enUS','[PH] Neither the sudden shock of battle, nor the long-drawn trials of vigilance and exertion will wear us down.','',26124),
(39337,'enUS','[PH] Give us the tools...','',26124),
(39338,'enUS','[PH]..and we will finish the job!','',26124),
(39339,'enUS','[PH] For Gnomeregan!','',26124),
(39340,'enUS','What? You\'re not supposed to be here. You\'re dead!','',26124),
(39341,'enUS','','Kill that goblin, quickly!',26124),
(39342,'enUS','The mine cart is prepped and ready to go.','',26124),
(39343,'enUS','Welcome to the field, $c! You can\'t get a feel for the tactical situation if you\'re hiding in a fortress all day. I always like to get my boots dirty.','',26124),
(39344,'enUS','Be sure to check in with my son Marley at the digsite. He\'s a good kid - my eyes and ears over at Bael Modan.','',26124),
(39345,'enUS','Have you been to Bael Modan? What\'s going on over there?','',26124),
(39346,'enUS','They\'re going to pay, $n. They\'re all going to pay.','',26124),
(39347,'enUS','These crazy tauren - always trying to blow up my flying machine. This has been going on for years!','',26124),
(39348,'enUS','Relax, friend. You have not passed away... yet. Sadly, these others cannot say the same.','',26124),
(39349,'enUS','You trespass on sacred soil!','',26124),
(39350,'enUS','%s explodes in a frothing, feral rage!','',26124),
(39351,'enUS','The Barrens ... will ... devour you, $r.','',26124),
(39352,'enUS','Everybody panic!','',26124),
(39353,'enUS','They\'re through the gates! I\'m outta here!','',26124),
(39354,'enUS','I\'m taking the next ship back home.','',26124),
(39355,'enUS','Run for your lives! Every gnome for himself!','',26124),
(39356,'enUS','Do you think I can make it to Theramore on foot?','',26124),
(39357,'enUS','Where did I leave my voltometer? Bah, no matter. The Horde can keep it!','',26124),
(39358,'enUS','','So much data... so little time...',26124),
(39359,'enUS','','The gyros are all spun up. Are you ready to fly my survey?',26124),
(39360,'enUS','I\'m ready to fly.','I\'m ready to fly.',26124),
(39361,'enUS','','Interesting. Even this far from the epicenter, Azeroth\'s crust is completely torn asunder.',26124),
(39362,'enUS','','What\'s all this? This jungle wasn\'t here during last week\'s survey. What is happening to the Barrens?',26124),
(39363,'enUS','','That\'s seawater. It\'s breached the ocean. Do you think the fissure is growing?',26124),
(39364,'enUS','','Hold everything - the walls of Northwatch have been breached! We\'re under attack!',26124),
(39365,'enUS','','Coach is here?! He\'ll have a plan.',26124),
(39366,'enUS','What is this?  Another unworthy pupil?','',26124),
(39368,'enUS','Yours will be a lesson in pain!','',26124),
(39369,'enUS','Only the worthy will learn the secrets we keep!','',26124),
(39370,'enUS','Ride the mine cart.','Ride the mine cart.',26124),
(39371,'enUS','You will wish you never came here, worm!','',26124),
(39372,'enUS','Your only lesson will be death.','',26124),
(39373,'enUS','Your flesh will burn, mortal!','',26124),
(39374,'enUS','You think you are good enough to learn from us?  You will pay for your insolence!','',26124),
(39375,'enUS','Very well, shaman. I shall slay you and carry the tablets to Cho\'Gall.','Very well, shaman. I shall slay you and carry the tablets to Cho\'Gall.',26124),
(39376,'enUS','I\'ve got a game plan, kid!','',26124),
(39377,'enUS','Don\'t know how long we\'re gonna be able to hold them off, $g bud : lady;. Hope you have a plan!','',26124),
(39378,'enUS','<Grunt>','',26124),
(39379,'enUS','People of Orgrimmar, listen. We have been blind for too long! I ask you to open your eyes to the truth!','People of Orgrimmar, listen. We have been blind for too long! I ask you to open your eyes to the truth!',26124),
(39380,'enUS','The end of our world nears, my brothers and sisters! Azeroth will be no more!','The end of our world nears, my brothers and sisters! Azeroth will be no more!',26124),
(39381,'enUS','Flames will consume the world. Storms will wash away all hope. The elements will reign at last!','Flames will consume the world. Storms will wash away all hope. The elements will reign at last!',26124),
(39382,'enUS','But do not despair, people of Orgrimmar! Join us and learn the truth.','But do not despair, people of Orgrimmar! Join us and learn the truth.',26124),
(39383,'enUS','The first thing you need to learn is proper discipline.','',26124),
(39384,'enUS',' However, the most important part of battle is how you celebrate a good hard earned victory!','',26124),
(39385,'enUS','When you go into combat, it is important that you know how to intimidate the enemy with a deafening battle roar!','',26124),
(39386,'enUS','Remember though, a key factor in winning any battle is positive reinforcement.','',26124),
(39387,'enUS','Everyone, cheer!','',26124),
(39388,'enUS','Salvaging','Salvaging',26124),
(39389,'enUS','','Where the heck did all of these shredders come from?!',26124),
(39390,'enUS','I can\'t believe you\'d do this to me!','',26124),
(39391,'enUS','Cast off your lives of war and drudgery, be reborn in elements and claim your rightful place in this new world!','Cast off your lives of war and drudgery, be reborn in elements and claim your rightful place in this new world!',26124),
(39392,'enUS','All right, you twisted mess of broken gears, let\'s get to work!','',26124),
(39393,'enUS','Why should we believe you?','Why should we believe you?',26124),
(39394,'enUS','Okay, recruits, salute!','',26124),
(39395,'enUS','Let me hear that battle roar!','',26124),
(39396,'enUS','First you tell us the world is ending, now you tell us not to worry. What ruse is this?','First you tell us the world is ending, now you tell us not to worry. What ruse is this?',26124),
(39397,'enUS','There has been too much violence. Too much pain. But I have an honorable compromise. Just walk away.','',26124),
(39398,'enUS','I am gravely disappointed. Again you have made me unleash my dogs of war. ','',26124),
(39399,'enUS','What a puny plan.','',26124),
(39400,'enUS','The continued sacrifice of the Ashen Verdict and heroes such as yourself bring us all closer to final victory. Now I have come to Icecrown Citadel to lend aid to those who fight against the Scourge. Together we will end the tyranny of the Lich King!','',26124),
(39401,'enUS','With all due respect, your Highness, we can do this alone.','With all due respect, your Highness, we can do this alone.',26124),
(39402,'enUS','You can do this alone, you say? Is this simple foolishness or misplaced confidence I see before me?\n\nNo, I can see it in your eyes. You have to know. You have to prove to yourself that you can do this alone. Very well. I will retreat from the battlefield if you so wish it.','',26124),
(39403,'enUS','Now, dance!','',26124),
(39404,'enUS','I am going to teach you all what it takes to be a proper soldier! ','',26124),
(39405,'enUS','We do wish for you to stand down, your Highness.','We do wish for you to stand down, your Highness.',26124),
(39406,'enUS','You will need more than bravery to defeat the Lich King. Good luck.','',26124),
(39407,'enUS','Your choice has been made. Whether you live or die by that choice is now up to you.','',26124),
(39408,'enUS','Hope you enjoyed the ride, i\'m out!','',26124),
(39409,'enUS','I want to be reborn. Tell me what I must do!','I want to be reborn. Tell me what I must do!',26124),
(39410,'enUS','Yes, tell us!','Yes, tell us!',26124),
(39411,'enUS','When I give the signal, let loose your greatest roar!','',26124),
(39412,'enUS','I don\'t want to die!','I don\'t want to die!',26124),
(39413,'enUS','Show me that discipline with a proper salute when I say so!','',26124),
(39414,'enUS','Calm down, friends. There will be plenty of time to answer all your questions.','Calm down, friends. There will be plenty of time to answer all your questions.',26124),
(39415,'enUS','The word is given. The Lich King will die by our hands!','The word is given. The Lich King will die by our hands!',26124),
(39416,'enUS','Northrend requires your attention Overlord Hellscream. We will deal with the Lich King and his minions without your aid.','Northrend requires your attention Overlord Hellscream. We will deal with the Lich King and his minions without your aid.',26124),
(39417,'enUS','With the Warsong Offensive here in Icecrown Citadel, victory is within our grasp! The death of the Lich King will bring glory to the Horde!','',26124),
(39418,'enUS','You turn away the might of the Warsong Offensive? Has the chaos of battle turned you mad? With my help, victory is at hand! Without my help, your fight will be difficult.','',26124),
(39419,'enUS','Glory to the Horde!','',26124),
(39420,'enUS','If you are interested in our message, I will be holding a gathering. Speak with me if you wish to know more, but beware, for Orgrimmar is full of people who would silence the truth.','If you are interested in our message, I will be holding a gathering. Speak with me if you wish to know more, but beware, for Orgrimmar is full of people who would silence the truth.',26124),
(39421,'enUS','I will prove myself!','I will prove myself!',26124),
(39422,'enUS','I\'ve trained for this moment for years!','I\'ve trained for this moment for years!',26124),
(39423,'enUS','Your choice was bold! I respect your desire for glory and honor! Die well, $n!','',26124),
(39424,'enUS','I will not fail!','I will not fail!',26124),
(39425,'enUS','I will triumph in THEIR name!','I will triumph in THEIR name!',26124),
(39426,'enUS','Enough lessons!  It\'s time for action!','Enough lessons!  It\'s time for action!',26124),
(39427,'enUS','I will not die here today, creature!','I will not die here today, creature!',26124),
(39428,'enUS','Reward your fellow soldiers in battle with a resounding cheer.  Now, cheer at me when I tell you to!','',26124),
(39429,'enUS','Show me your best victory dance when I give the signal!','',26124),
(39430,'enUS','Nice job!','',26124),
(39431,'enUS','Wow, nice and scary! ','',26124),
(39432,'enUS','Fantastic!','',26124),
(39433,'enUS','Superb!','',26124),
(39434,'enUS','You might be the best set of recruits I\'ve ever seen!  Let\'s go through all of that again!','',26124),
(39435,'enUS','Aaaaaaaaargggh!!','Aaaaaaaaargggh!!',26124),
(39436,'enUS','I\'ve become one with fire!  I\'ve... auuuggggh!!!  It burnssss!!!','I\'ve become one with fire!  I\'ve... auuuggggh!!!  It burnssss!!!',26124),
(39437,'enUS','The flesh is weak!  Only fire purifies!','The flesh is weak!  Only fire purifies!',26124),
(39438,'enUS','One day, The Wolf was very hungry, so he ran east to look for some food.','One day, The Wolf was very hungry, so he ran east to look for some food.',26124),
(39439,'enUS','He happened upon a pair of battling kodos.$bClever as he was, The Wolf decided to wait for one to defeat the other.','He happened upon a pair of battling kodos.$bClever as he was, The Wolf decided to wait for one to defeat the other.',26124),
(39440,'enUS','When the weaker Kodo died, The Wolf approached and tried to eat it.','When the weaker Kodo died, The Wolf approached and tried to eat it.',26124),
(39441,'enUS','The remaining Kodo, angry at The Wolf\'s impetuousness,$bswiftly killed The Wolf before he had a chance to eat.','The remaining Kodo, angry at The Wolf\'s impetuousness,$bswiftly killed The Wolf before he had a chance to eat.',26124),
(39442,'enUS','Things used to be so much better... what happened to us?','',26124),
(39443,'enUS','Can you tell me your fable, Shin?','Can you tell me your fable, Shin?',26124),
(39444,'enUS','The Wolf ran and ran, looking for an easy meal.','The Wolf ran and ran, looking for an easy meal.',26124),
(39445,'enUS','He was hungry for kodo meat.','He was hungry for kodo meat.',26124),
(39446,'enUS','The Wolf was lazy, and didn\'t want to work for his meal.','The Wolf was lazy, and didn\'t want to work for his meal.',26124),
(39447,'enUS','The more he ran, the more his stomach growled.','The more he ran, the more his stomach growled.',26124),
(39448,'enUS','The Wolf did not care for raptor meat.','The Wolf did not care for raptor meat.',26124),
(39449,'enUS','The Wolf found scorpid meat to be too bitter.','The Wolf found scorpid meat to be too bitter.',26124),
(39450,'enUS','The Wolf had grown tired of eating boar meat.','The Wolf had grown tired of eating boar meat.',26124),
(39451,'enUS','He scoured the sands of Durotar, hunting for his prey.','He scoured the sands of Durotar, hunting for his prey.',26124),
(39452,'enUS','','I\'m tired of wading in water.  Let\'s make this a little bit easier on ourselves, shall we?  Spirit of water, come to our aid!',26124),
(39453,'enUS','','There, isn\'t that much better?',26124),
(39454,'enUS','','Raggaran, I\'m safe.',26124),
(39455,'enUS','Grandmatron... you\'re alive!','',26124),
(39456,'enUS','','Let us be off then.  Take me to my grandson Raggaran.',26124),
(39457,'enUS','','No!  M-my ankle!  I\'m not sure I can make it... after we\'ve come so far...',26124),
(39458,'enUS','','Spirits of air!  Come to my aid!',26124),
(39459,'enUS','','We can continue now, I think.  Let us press on.',26124),
(39460,'enUS','So many bells and whistles!','',26124),
(39461,'enUS','Push the Big Red Button!','Push the Big Red Button!',26124),
(39462,'enUS','Board the Flying Machine.','Board the Flying Machine.',26124),
(39463,'enUS','Looks just powerful enough to carry one gnome.  Maybe two.','',26124),
(39464,'enUS','','All the rest of our people are down there!',26124),
(39465,'enUS','','But, sweetie...?',26124),
(39466,'enUS','I am at a loss. Perhaps only the Earth Mother herself knows the cause of this. But we must do something before this continues...','',26124),
(39467,'enUS','','Your sincerity is moving, druid.',26124),
(39468,'enUS','Konu! Behind us! A night elf.','',26124),
(39469,'enUS','You are no night elf...this is the guise of a green dragon! By the Earth Mother, I...','',26124),
(39470,'enUS','','I deserve no such respect or reverance, druid. I have betrayed my own kind. The illness of this land is my fault.',26124),
(39471,'enUS','','The sickness is born of the Nightmare within the Emerald Dream, and the dragon Taerar spreads it. He is but a crazed shade of his former self, but will see this land devoured.',26124),
(39472,'enUS','','I cannot face him myself. To even approach him would risk letting the same corruption overtake me once more.',26124),
(39473,'enUS','What must we do?','',26124),
(39474,'enUS','','The earth itself weeps in its suffering. Gather its tears, and use them to seal the portal at the Great Tree. The connection to the Dream must be cut.',26124),
(39475,'enUS','','Be brave, heroes.',26124),
(39476,'enUS','Tiragarde belongs to Northwatch now!','',26124),
(39477,'enUS','$n, you have to hunt down the Trade Prince!','',26124),
(39478,'enUS','If Fizz hadn\'t been so clumsy, we never would have been caught!','',26124),
(39479,'enUS','If Evol hadn\'t been so clumsy, we never would have been caught!','',26124),
(39480,'enUS','','The Twilight\'s Hammer is a major power to be reckoned with.  Thanks to us, Deathwing is free.  Thanks to us, Old Gods have risen from the bowels of the earth.  Thanks to us... Hyjal burns.$B$BWhat do you think you have to offer us?',26124),
(39481,'enUS','The path before us has been revealed. Let us return.','',26124),
(39482,'enUS','You\'re the one, $n. You must defeat the Trade Prince or all is lost.','',26124),
(39483,'enUS','','This whole situation is highly unprofitable. You must bring the Trade Prince back into line, $n!',26124),
(39484,'enUS','','Don\'t worry about us, $n. You just get over there and make sure that the Trade Prince gets dealt with.',26124),
(39485,'enUS','Hey.','',26124),
(39486,'enUS','Please insert coins and then proceed to deal with the Trade Prince.','',26124),
(39487,'enUS','Any luck out there?','',26124),
(39488,'enUS','','',26124),
(39489,'enUS','No earthquake, flood, or any other act of the spirits will stop me from doing my duty.','',26124),
(39490,'enUS','Everything has been leading to this, $n. You must not fail, or all is lost and we will die with this island.','',26124),
(39491,'enUS','Honestly, how do these people keep getting captured? It\'s massive incompetence, I tell you!$B$BIt almost makes me ashamed to be a goblin.$B$BSpeaking of shame, where\'s that lazy assistant of mine? No doubt she\'s just sitting around somewhere doing nothing.$B$BOh the burdens that come with genius. I suppose I\'ll just have to think us all out of this mess by myself.','',26124),
(39492,'enUS','We are here to pay respect to the great forest, and take part in the wonder of the Earth Mother\'s gifts.','',26124),
(39493,'enUS','','Are you here to help, $c? This valley serves as a natural chokepoint. If we can strangle this supply line, we buy our companions at the World Tree time to mount a counter-attack.',26124),
(39494,'enUS','','I don\'t understand where these supplies are coming from. Somehow Twilight\'s Hammer has found a way to assault the entire mountain at once...',26124),
(39495,'enUS','Let\'s go to the top of the Colossal.','Let\'s go to the top of the Colossal.',26124),
(39496,'enUS','Um... you do realize there\'s a bottom to this cage?!','Um... you do realize there\'s a bottom to this cage?!',26124),
(39497,'enUS','Mommy!','Mommy!',26124),
(39498,'enUS','3... 2... 1...','3... 2... 1...',26124),
(39499,'enUS','Tell my wife I love her very much!','Tell my husband I love him very much!',26124),
(39500,'enUS','Just open the door... oh no!','Just open the door... oh no!',26124),
(39501,'enUS','What are those rockets for?!','What are those rockets for?!',26124),
(39502,'enUS','$n, you and Hobart are going to be the death of me!','$n, you and Hobart are going to be the death of me!',26124),
(39503,'enUS','The pirates have keys!','The pirates have keys!',26124),
(39504,'enUS','','',26124),
(39505,'enUS','Hobart, I need more single-stage booster rockets!','Hobart, I need more single-stage booster rockets!',26124),
(39506,'enUS','What? You think these grow on trees? Please show me one of these trees!$B$BI can\'t work like this!','',26124),
(39509,'enUS','You have failed the test.  Try again.','You have failed the test.  Try again.',26124),
(39510,'enUS','<This robotic gorilla appears to be damaged.>','',26124),
(39511,'enUS','CRASH REPORT XX1-017$B$BCHECKSUM ERROR 0081$B$BFLUID LEVELS DANGEROUSLY LOW$b$BMISSION FAILURE$b$bNEVER GOT A CHANCE TO SEE OUTLANDS','',26124),
(39518,'enUS','','What do you want, $r?',26124),
(39519,'enUS','I\'m here to challenge you in combat.','I\'m here to challenge you in combat.',26124),
(39520,'enUS','Do I frighten you, $r?','',26124),
(39521,'enUS','What\'s the matter, chum... never seen a worgen before?','',26124),
(39522,'enUS','Anything for King Mekkatorque!','Anything for King Mekkatorque!',26124),
(39523,'enUS','Is this going to hurt?','Is this going to hurt?',26124),
(39524,'enUS','I\'d love to help!','I\'d love to help!',26124),
(39525,'enUS','Can I bring my wrench?','Can I bring my wrench?',26124),
(39526,'enUS','Sign me up!','Sign me up!',26124),
(39527,'enUS','','$n hurry! Thrall needs your help!',26124),
(39528,'enUS','Wow! We\'re taking back Gnomeregan?  I\'m in!','Wow! We\'re taking back Gnomeregan?  I\'m in!',26124),
(39529,'enUS','I want to drive a Spider Tank!','I want to drive a Spider Tank!',26124),
(39530,'enUS','I SEE THE TRAITOR IS HERE TO RESCUE YOU, WARCHIEF. HOW CONVENIENT. YOU WILL BOTH BOW TO ME OR FALL TOGETHER!','',26124),
(39531,'enUS','Blast these rocky Durotar roads!  I\'ve got places to be, and this isn\'t one of them.','',26124),
(39532,'enUS','Up the ramp, $n! Help Thrall defeat the Trade Prince!','',26124),
(39533,'enUS','Thrall\'s fighting the Trade Prince up top on the other side of the docks. Hurry, $n!','',26124),
(39534,'enUS','Assist me, $n. The Trade Prince has become far more powerful!$B$BI do not know how much longer I can hold out.','',26124),
(39536,'enUS','I\'m beaten. You\'ve shown me the error of my ways. From here on out, I promise to reform the way the cartel is run!','',26124),
(39537,'enUS','My wrench of vengance awaits!','My wrench of vengance awaits!',26124),
(39538,'enUS','Do you have any idea where you are going?','Do you have any idea where you are going?',26124),
(39539,'enUS','I love the smell of grease in the morning!','I love the smell of grease in the morning!',26124),
(39540,'enUS','Do you think they will let me keep my uniform when I\'m done?','Do you think they will let me keep my uniform when I\'m done?',26124),
(39541,'enUS','How soon until the victory party starts? I\'m ready to dance!','How soon until the victory party starts? I\'m ready to dance!',26124),
(39542,'enUS','Uncle! Uncle! I give! You guys are too much for me!','',26124),
(39543,'enUS','I\'m your goblin, Thrall. What would you have of me?','',26124),
(39544,'enUS','','The Gordunni Ogres have blighted this land long enough. We are here to take this land and its resources for the Horde.',26124),
(39545,'enUS','These ogres are on our side?','These ogres are on our side?',26124),
(39546,'enUS','','The Stonemaul clan serves the Horde!$B$BDuring the founding of Orgrimmar, when Kalimdor was being tamed as our people\'s homeland, the hero Rexxar defeated the chief of the Stonemaul ogre clan.$B$BThey have served the Horde ever since, and I\'ve called them in here to do the heavy lifting against the Gordunni clan.',26124),
(39547,'enUS','Yes.','Yes.',26124),
(39548,'enUS','No.','No.',26124),
(39549,'enUS','That depends on what your definition of \"is\"... is.','That depends on what your definition of \"is\"... is.',26124),
(39550,'enUS','Only a non-believer would ask such a question!  Are you a non-believer?','Only a non-believer would ask such a question!  Are you a non-believer?',26124),
(39551,'enUS','Here, I need to unload some toxic assets!','',26124),
(39552,'enUS','Well... what do you think the answer is?','Well... what do you think the answer is?',26124),
(39553,'enUS','Yes and no.  It really depends on how you look at it... I suppose.  Did that answer your question?','Yes and no.  It really depends on how you look at it... I suppose.  Did that answer your question?',26124),
(39554,'enUS','Well that\'s all semantics, really.','Well that\'s all semantics, really.',26124),
(39555,'enUS','Only if Lord Deathwing commands it!','Only if Lord Deathwing commands it!',26124),
(39556,'enUS','I\'m downsizing the cartel, starting with you!','',26124),
(39557,'enUS','The Bilgewater Cartel has grown too large. Time to downsize!','',26124),
(39558,'enUS','Gotta trim some fat around here. I\'m downsizing the company!','',26124),
(39559,'enUS','Excuse me while I dispose of these toxic assets all over you!','',26124),
(39560,'enUS','I need to move these toxic assets onto a sucker... like you!','',26124),
(39561,'enUS','You\'re fired!','',26124),
(39563,'enUS','I\'m all fired up over finally gettin\' rid of you!','',26124),
(39564,'enUS','You burned down my headquarters. Now I\'m gonna burn down you!','',26124),
(39565,'enUS','Do dogs bark?','Do dogs bark?',26124),
(39566,'enUS','Is vinegar sour?','Is vinegar sour?',26124),
(39567,'enUS','Is fire hot?','Is fire hot?',26124),
(39568,'enUS','Are the oceans filled with water?','Are the oceans filled with water?',26124),
(39569,'enUS','Are slaves free?','Are slaves free?',26124),
(39570,'enUS','Are deserts lush?','Are deserts lush?',26124),
(39571,'enUS','Do liars speak the truth?','Do liars speak the truth?',26124),
(39572,'enUS','Here\'s some of that moolah back that I took from you!','',26124),
(39573,'enUS','I like you. Here\'s a raise!','',26124),
(39574,'enUS','I\'m so money!','',26124),
(39575,'enUS','Do rivers flow upstream?','Do rivers flow upstream?',26124),
(39576,'enUS','Are you a $c?','Are you a $c?',26124),
(39577,'enUS','Does Cho\'Gall lead the Twilight\'s Hammer?','Does Cho\'Gall lead the Twilight\'s Hammer?',26124),
(39578,'enUS','Does our cult serve the Old Gods?','Does our cult serve the Old Gods?',26124),
(39579,'enUS','Return to the Slave Pits or the Gallywix Docks, or forfeit your footbomb uniform!','',26124),
(39580,'enUS','<Fizzle\'s body bobs lifelessly.  His orb is clutched tightly in his right hand.>','',26124),
(39581,'enUS','<Attempt to remove the orb.>','<Attempt to remove the orb.>',26124),
(39582,'enUS','<You grab at the orb, but Fizzle\'s hand clutches around it even tighter.  The orb glows slightly.>','',26124),
(39583,'enUS','<Attempt to remove Fizzle\'s Hand, then.>','<Attempt to remove Fizzle\'s Hand, then.>',26124),
(39584,'enUS','<Give up.  This is too scary.>','<Give up.  This is too scary.>',26124),
(39585,'enUS','Thrall grunts and thinks a moment on what to do with the Trade Prince.','',26124),
(39586,'enUS','For now, you will remain the Trade Prince of the Bilgewater Cartel.','',26124),
(39587,'enUS','I will send a representative from amongst your people to the new warchief, Garrosh Hellscream in Orgrimmar.','',26124),
(39588,'enUS','You will have a new home in Azshara and the Bilgewater Cartel will become a part of the Horde!','',26124),
(39589,'enUS','It will be as you say! Long live the Bilgewater Cartel! For the Horde!','',26124),
(39590,'enUS','Try to ignore the firm, feathery behinds of the harpies... the creatures are really quite deadly!','',26124),
(39591,'enUS','Lok\'tar ogar, soldier.','',26124),
(39592,'enUS','FOR DA HORDE!','',26124),
(39593,'enUS','For now we cannot return to Kalimdor. Only Chawg is going back with you.  Another ship is coming to take the rest of us on to our destination.$B$BThe greatest adventure is yet ahead of you, $n. Our paths will cross again, and when they do, the fate of the world will be in your hands!','',26124),
(39594,'enUS','','Looks like this is it, boss-$g man : lady;. It\'s been a real honor. I\'m sure we\'ll see each other again real soon.$B$BJust let me know when you\'re ready to head out for Orgrimmar.',26124),
(39595,'enUS','Sassy, let\'s set sail for Orgrimmar before the island blows for good!','Sassy, let\'s set sail for Orgrimmar before the island blows for good!',26124),
(39596,'enUS','Prove yourselves, my ogres! Slay this insect! (Blood for the master! Blood and suffering!)','',26124),
(39597,'enUS','Lok\'tar, $c.','',26124),
(39598,'enUS','Um... I\'m gonna need your battleworg again.','Um... I\'m gonna need your battleworg again.',26124),
(39599,'enUS','We\'re Orgrimmar bound, $g bud : girlie;, and then on to our new home in Azshara. See you there!','',26124),
(39600,'enUS','','It\'s been a long journey to get here, hon. Thank you!$B$BLet\'s get off of this island now.',26124),
(39601,'enUS','Thank... you...','',26124),
(39602,'enUS','','You\'re a true $g hero : heroine;, $n! The poster-$g boy : girl; for the Bilgewater Cartel.$B$BOur stock is going to skyrocket now and I\'m going to get a raise!',26124),
(39603,'enUS','','This does not look good for the future of the cartel. Not one bit.$B$BYou have to pull our fat out of the fire, $n, or we might as well all just walk into that volcano up there.',26124),
(39604,'enUS','','Oh goodness, you did it, $n, you really did it!$B$BNow, by my calculations, if we do not get this bucket sailing very very soon, there is the increasing likelihood of one of those giant volcano rocks shooting through the air and smashing the yacht to smithereens.$B$BShall we?',26124),
(39605,'enUS','There\'s always just enough time for a last minute sale to the $g hero : heroine; of the Bilgewater Cartel, $n.','',26124),
(39606,'enUS','This right here is what you\'d call bad for business!','',26124),
(39607,'enUS','','What a mess! How am I going to spin this?$B$BAnd really... goblin zombies?!!',26124),
(39608,'enUS','You got the stuff, kid! You got the ball into the endzone and you detonated it for the win!$B$BNow let\'s get out of here. I\'m thinking that the new team might need to be called the $n Explosion!','',26124),
(39609,'enUS','You did it, my $g boy : girl;, you did it!$B$BNow, let\'s get to Azshara so that I can set up my new practice. This has been a long vacation and I have bills to pay!','',26124),
(39610,'enUS','I don\'t suppose that there\'s any way that you can get us out of here? No?$B$BAh well, I suppose it won\'t be too painful as the lava slowly pours into this pit.','',26124),
(39611,'enUS','We\'re all going to DIE in here!!!$B$BI\'m a slave foreman... I wonder if it\'s too late to side with the Trade Prince?','',26124),
(39612,'enUS','I knew you had it in you all along, $n.$B$BNow, do you think there\'ll be a position for me in Azshara? Do they have trolls there?','',26124),
(39613,'enUS','I just wanted to say thanks, $n.$B$BI\'m sure glad that the doc here was able to shock you back to life or we\'d all be dead by now, or worse!','',26124),
(39614,'enUS','I am NOT going to sweep the ground of a mud pit, I can tell you that!$B$BYou need to deal with that rat, the Trade Prince, that\'s what I think!','',26124),
(39615,'enUS','Three cheers for $n!!!$B$BI really cannot wait to setup my own little bed and breakfast in Azshara. What do you think it\'s like there?','',26124),
(39616,'enUS','You did a superb job, $n. Top notch!$B$BNow, of course, you couldn\'t have done it without my tinkering genius, which I\'m sure you\'ll put in your company report, but you really pulled it off, despite the bumbling of my assistant here.','',26124),
(39617,'enUS','We\'re Orgrimmar and Azshara bound. Let\'s get this baby out to sea!','',26124),
(39618,'enUS','Please insert coins into ship in order to move away from exploding island.','',26124),
(39619,'enUS','Let\'s jump Fizz right before we set sail. I\'ll hit him high and you go low!','',26124),
(39620,'enUS','Let\'s deal with that punk, Evol, once and for all. Azshara\'s not big enough for the two of us!','',26124),
(39621,'enUS','I knew you had it in you, $n! You saved our skins.$B$BNow let\'s get out of here before I have to kill Fizz and Evol.','',26124),
(39622,'enUS','','Do you have any idea how much time and moolah you\'ve saved us, $n? This could have been a complete disaster and you\'ve single-handedly saved the entire cartel.$B$BToo bad that you and Thrall spared Gallywix. I think that you would make an excellent Trade $g Prince : Princess;!',26124),
(39623,'enUS','','No one could have done what you did, $n. Why you spared Gallywix is beyond me. You should have had his job.$B$BHere\'s to hoping that setting up our new home in Azshara is uneventful. I\'m looking forward to retiring.',26124),
(39624,'enUS','I\'m not talking to you right now. If I were you, I wouldn\'t count on getting a raise this year, $n.','',26124),
(39625,'enUS','You did it! We\'re saved!','You did it! We\'re saved!',26124),
(39626,'enUS','Are we really finally going to Azshara? Is there a volcano there, too?','Are we really finally going to Azshara? Is there a volcano there, too?',26124),
(39627,'enUS','How can I ever thank you, $n?','How can I ever thank you, $n?',26124),
(39628,'enUS','I\'d keep my eyes and ears open if I were you. There\'s a rumor going around that you caused both Mount Kajaro and the Lost Isles volcanoes to explode.$B$BCrazy, I know. But people will gossip about anything and love to tear down their heroes, especially if there\'s a chance for profit and promotion.','I\'d keep my eyes and ears open if I were you. There\'s a rumor going around that you caused both Mount Kajaro and the Lost Isles volcanoes to explode.$B$BCrazy, I know. But people will gossip about anything and love to tear down their heroes, especially if there\'s a chance for profit and promotion.',26124),
(39629,'enUS','Let\'s leave dock before the volcano destroys us all!','Let\'s leave dock before the volcano destroys us all!',26124),
(39630,'enUS','Ready to go when you are, $g sir : ma\'am;!','Ready to go when you are, $g sir : ma\'am;!',26124),
(39631,'enUS','I don\'t know. I think I\'m going to miss this place. We had some pretty good times here.','I don\'t know. I think I\'m going to miss this place. We had some pretty good times here.',26124),
(39632,'enUS','I have an idea... this time let\'s not wander through a naval battle between the Alliance and the Horde.$B$BI\'m just saying.','I have an idea... this time let\'s not wander through a naval battle between the Alliance and the Horde.$B$BI\'m just saying.',26124),
(39633,'enUS','','May the Earth Mother watch over you, $n. Thank you for your help.',26124),
(39634,'enUS','The song of your life will be sung by the mighty, $n. Until we meet again.','',26124),
(39635,'enUS','I have other business that must be done in Azshara, so I will join you on your journey, $n.','',26124),
(39636,'enUS','You have the heart of a giant, $n. It has been an honor!','',26124),
(39637,'enUS','','Looks like this is it, boss-$g man : lady;. It\'s been a real honor. I\'m sure we\'ll see each other again real soon.',26124),
(39638,'enUS','Welcome, friend.  Let\'s ride through Grim Batol and strike a blow against Deathwing that he won\'t soon forget!','',26124),
(39639,'enUS','Log\'loth og shandai, mortal. Only death is eternal. You will be undone.','',26124),
(39640,'enUS','Fate subjugates faith, mortal. Your prayers are meaningless here.','',26124),
(39641,'enUS','Now you\'re just wasting my time!','Now you\'re just wasting my time!',26124),
(39642,'enUS','Ahoy!','',26124),
(39643,'enUS','I\'m saaaailing!','',26124),
(39644,'enUS','If I had a silver for every time I heard the world was going to end, I\'d be richer than a goblin trade prince!','If I had a silver for every time I heard the world was going to end, I\'d be richer than a goblin trade prince!',26124),
(39645,'enUS','Doomsday cultists? Well, the orcs have already survived the end of one world, so what\'s another?','Doomsday cultists? Well, the orcs have already survived the end of one world, so what\'s another?',26124),
(39646,'enUS','Put these cultists on a zeppelin and send them to Stormwind! We don\'t need this kind of thing in Orgrimmar.','Put these cultists on a zeppelin and send them to Stormwind! We don\'t need this kind of thing in Orgrimmar.',26124),
(39647,'enUS','Well, that must be why my neighbor shaved his head and donned those robes. Maybe he\'ll let me have his stuff.','Well, that must be why my neighbor shaved his head and donned those robes. Maybe he\'ll let me have his stuff.',26124),
(39648,'enUS','Who would join something like this? If the world is really going to end, do they really think it would bother warning us?','Who would join something like this? If the world is really going to end, do they really think it would bother warning us?',26124),
(39649,'enUS','Looks like it\'s time for the grunts to clean out the Drag and the Cleft of Shadow again.','Looks like it\'s time for the grunts to clean out the Drag and the Cleft of Shadow again.',26124),
(39650,'enUS','Out on a boat... way far away from the dock...\n','',26124),
(39651,'enUS','Into the wind with the sky and everything...\n','',26124),
(39652,'enUS','Oooh... shiny!','',26124),
(39653,'enUS','I ain\'t askin\' for me alone, Great Spirit, but on behalf of da Darkspear Tribe... on behalf of me PEOPLE.','',26124),
(39654,'enUS','I lost my Motivate-a-Tron. May I have another?','I lost my Motivate-a-Tron. May I have another?',26124),
(39655,'enUS','You want something?','You want something?',26124),
(39656,'enUS','You have something to show me?','You have something to show me?',26124),
(39657,'enUS','Fine.  I\'ll come with you.  This had better be important.','Fine.  I\'ll come with you.  This had better be important.',26124),
(39658,'enUS','Come aboard, now. Step right up!\n','',26124),
(39659,'enUS','Cap\'n Samir is navigatin\' this here ship non-stop to that there ocean over yonder...\n','',26124),
(39660,'enUS','...where we\'ll commence to assistin\' the Alliance in their little skirmish with them Horde fellers.\n','',26124),
(39661,'enUS','Easy money! Commission\'s to be dispersed evenly among any and all survivors!\n','',26124),
(39662,'enUS','I\'m ready for the trip back down.','I\'m ready for the trip back down.',26124),
(39663,'enUS','Ouch!  That... that really hurt!','Ouch!  That... that really hurt!',26124),
(39664,'enUS','Lead the Twilight Recruit away from the group and use the Blackjack to knock him out.','Lead the Twilight Recruit away from the group and use the Blackjack to knock him out.',26124),
(39665,'enUS','Starting test.  Casting trigger spell now.','',26124),
(39666,'enUS','Trigger spell received. Idling.','',26124),
(39667,'enUS','Chromie, you and I both know what\'s going to happen in this time stream. We\'ve seen this all before. Can you just skip us ahead to all the real action?','Chromie, you and I both know what\'s going to happen in this time stream. We\'ve seen this all before. Can you just skip us ahead to all the real action?',26124),
(39668,'enUS','','That\'s right, I\'ve seen you here before! How could I forget?$B$BI can teleport you to Stratholme now, if you wish.',26124),
(39669,'enUS','Mighty Eye of Twilight, guide your humble servant!','',26124),
(39670,'enUS','Speak now, Eye of Twilight.','',26124),
(39671,'enUS','What are your orders, Eye of Twilight?','',26124),
(39672,'enUS','','Captain! Shipwreck off the starboard bow! There appear to be survivors!',26124),
(39673,'enUS','Where is two-head? What do Eye tell us now?','',26124),
(39674,'enUS','Who talk to Eye last? Is Eye happy? Tell Gar\'gol!','',26124),
(39675,'enUS','Cave is too filthy! Put filth in filth piles marked with flag. ','',26124),
(39676,'enUS','Dinnertime for Gar\'gol! Go get chef. Cook chef if dinner not ready.','',26124),
(39677,'enUS','The Eye talks in shadow-talk. I do what Eye says! You do what Gar\'gol says!','',26124),
(39678,'enUS','The Eye have no lips, but the Eye whispers to Gar\'gol. The Eye knows everything!','',26124),
(39679,'enUS','If you don\'t like what we do here, you talk to the Eye. But it will not listen. It\'s not the Ear.','',26124),
(39680,'enUS','Don\'t pay Budd no nevermind... poor fella\'s got a few screws missin\'.','',26124),
(39681,'enUS','You did it, $n! The shrine is ours again!','You did it, $n! The shrine is ours again!',26124),
(39682,'enUS','Enough! I\'ll stain my hands with your blood! (Hyehahahaha! Murder! MURDER!)','',26124),
(39683,'enUS','Pathetic! Behold the true might of my chosen...','',26124),
(39684,'enUS','Ian Duran is waiting for you in camp.','Ian Duran is waiting for you in camp.',26124),
(39685,'enUS','Takrik Ragehowl has asked for you up in the camp.','Takrik Ragehowl has asked for you up in the camp.',26124),
(39686,'enUS','My life for you, master!','',26124),
(39687,'enUS','What the... ?','',26124),
(39688,'enUS','%s begins to cast Defile!','',26124),
(39689,'enUS','If I had a silver for every time I heard the world was going to end, I\'d be richer than a goblin trade prince!','If I had a silver for every time I heard the world was going to end, I\'d be richer than a goblin trade prince!',26124),
(39690,'enUS','Doomsday cultists? Just what we need after all the trouble with those Defias thugs.','Doomsday cultists? Just what we need after all the trouble with those Defias thugs.',26124),
(39691,'enUS','Put these cultists on a boat and send it into the Maelstrom! We don\'t need this kind of thing in Stormwind!','Put these cultists on a boat and send it into the Maelstrom! We don\'t need this kind of thing in Stormwind!',26124),
(39692,'enUS','Well, that must be why my neighbor shaved his head and donned those robes. Maybe he\'ll let me have his stuff.','Well, that must be why my neighbor shaved his head and donned those robes. Maybe he\'ll let me have his stuff.',26124),
(39693,'enUS','If the world is going to end, do these cultists really think it would bother warning us?','If the world is going to end, do these cultists really think it would bother warning us?',26124),
(39694,'enUS','Looks like it\'s time for the guards to clean out Old Town again.','Looks like it\'s time for the guards to clean out Old Town again.',26124),
(39695,'enUS',' |TInterface\\Icons\\ability_creature_disease_02.blp:16|t You have been infected by |cFFBC05FFNecrotic Plague|r! |TInterface\\Icons\\ability_creature_disease_02.blp:16|t',' |TInterface\\Icons\\ability_creature_disease_02.blp:16|t You have been infected by |cFFBC05FFNecrotic Plague|r! |TInterface\\Icons\\ability_creature_disease_02.blp:16|t',26124),
(39696,'enUS','','Cry havoc, brothers and sisters!',26124),
(39697,'enUS','Hooray for meat! HIP HIP HOORAY!','',26124),
(39698,'enUS','Butcherbot will harvest meat, tra la la la la.','',26124),
(39699,'enUS','I want the arterieeeeeeeeees!','',26124),
(39700,'enUS','No part goes to waste! Yay!','',26124),
(39701,'enUS','Chop chop chop!','',26124),
(39702,'enUS','VWHHHHHRRRRRRRRRRRRRRRRHHHHHHMNNNGHHHGH','',26124),
(39703,'enUS','Increase your profit potential with Butcherbot!','',26124),
(39704,'enUS','Yaaaaaaaaaaaaaaaaaaaaaay!','',26124),
(39705,'enUS','Gann\'s head is lolled to one side, and his breathing grows ragged.$B$BHe doesn\'t acknowledge your presence.','',26124),
(39706,'enUS','I seem to have misplaced the remote control fireworks.','I seem to have misplaced the remote control fireworks.',26124),
(39707,'enUS','Well, of course, here are some extras. I\'m just made of fireworks....','',26124),
(39708,'enUS','They may take our lives, but they\'ll never take...','',26124),
(39709,'enUS','What I want out of each and every one of you is a hard-target search of every refuelling station, residence, warehouse, farmhouse, henhouse, outhouse and doghouse in this area. ','',26124),
(39710,'enUS','We will not go quietly into the night! We will not vanish without a fight!','',26124),
(39711,'enUS','Hmm, I suppose it could work.  But it could really use a little more umph!','',26124),
(39712,'enUS','','What?  I don\'t even know what you\'re talking about!  That\'s terrible!',26124),
(39713,'enUS','Horrible! Well, all right, maybe it just needs a little cleaning up?','',26124),
(39714,'enUS','Thoth\'al amun Ree\'thael vormos! Vormos! Vormos!','',26124),
(39715,'enUS','Al\'tha, Al\'tha bormaz. Ni bormaz ta\'thall? It comes, it walks in flames, $r!','',26124),
(39716,'enUS','The shadow sees. Bo\'al lal arwi C\'toth. The end comes, cloaked in silent fire.','',26124),
(39717,'enUS','Mar\'kowa tallol ye\'tarin, it knows, it knows.','',26124),
(39718,'enUS','Fear broils forth from the heart of the infinite. Don\'t make me look! I\'ve seen more than I can stand!','',26124),
(39719,'enUS','We are nothing. Tulall par\'okoth. Far\'al, ka\'kar. The void devours.','',26124),
(39720,'enUS','<The Twilight Servitor gurgles at you, white spittle foaming and bubbling from his mouth.>','',26124),
(39721,'enUS','H\'thon, the column of darkness stretching beyond sight. H\'thon marwol qualar: the infinite grasp of night.','',26124),
(39722,'enUS','...our INNOVATION!','',26124),
(39723,'enUS','Your fugitive\'s name is Mekgineer Thermaplugg.','',26124),
(39724,'enUS','Go get him.','',26124),
(39725,'enUS',' We\'re going to live on! We\'re going to survive! Today we celebrate...','',26124),
(39726,'enUS','...our Autonomy Day!','',26124),
(39727,'enUS','','$n, the Twilight slaves you and others have been rescuing from Wolf\'s Run are wandering into camp, but they can\'t tell me who they are and they speak in riddles and gibberish.$B$BI thought Twilight\'s Hammer kept the slaves in line the old fashioned way - you know, whips and chains - but it\'s clear that there\'s some brainwashing at work...\n',26124),
(39728,'enUS','You must remain in Steelgrill\'s Depot.','You must remain in Steelgrill\'s Depot.',26124),
(39729,'enUS','<Administer the draught.>','<Administer the draught.>',26124),
(39730,'enUS','Wha - what? Where am I? I\'ve got to get out of here!','',26124),
(39731,'enUS','What happened to me? I\'m leaving!','',26124),
(39732,'enUS','...What am I saying? Nothing makes sense anymore. I\'ve got to get out of this place!','',26124),
(39733,'enUS','My ... brain ... hurts!','',26124),
(39734,'enUS','Whoa, you made the voices go away. I\'m outta here!','',26124),
(39735,'enUS','What did they do to me? I\'ve got to get back to camp...','',26124),
(39736,'enUS','','Any luck out there? Just trying to hold a conversation with the freed slaves makes my head hurt.$B$BThey straddle the line in discord and rhyme.\n',26124),
(39737,'enUS','','Thanks for your help, $n.\n',26124),
(39738,'enUS','I don\'t know if it\'s good to have my mind back.$B$BKnowing what I know... Knowing what may happen to our world...$B$B<He shudders and falls silent.>','',26124),
(39739,'enUS','Thanks for rescuing us, $c.$B$BWe\'ll accompany the next caravan off of this mountain, but... I don\'t think I\'ll ever be the same...','',26124),
(39740,'enUS','Leave us in peace, stranger. We have done nothing to you.','Leave us in peace, stranger. We have done nothing to you.',26124),
(39741,'enUS','We have withdrawn from life in the city to await our fates here, where the truth has been revealed to us.','We have withdrawn from life in the city to await our fates here, where the truth has been revealed to us.',26124),
(39742,'enUS','Do you seek to join us? We have messengers in the city who will tell you what you must do, seeker.','Do you seek to join us? We have messengers in the city who will tell you what you must do, seeker.',26124),
(39743,'enUS','','The forces of the Sentinel Army hold back the Horde across all of Kalimdor. While the war continues in Ashenvale and Stonetalon, our forces are also needed here, to protect these remaining wilds and prevent our enemies from gaining further footholds.',26124),
(39744,'enUS','What do you think you\'re doing, $c? Get away from those instruments!','',26124),
(39745,'enUS','You cannot ... control the Eye! Cho\'gall will know. You will be ... punished.','',26124),
(39746,'enUS','Take me to Mekkatorque!','Take me to Mekkatorque!',26124),
(39747,'enUS','The sun of life will set forever, as light gives way to eternal night! (Oblivion looms! It calls!)','',26124),
(39748,'enUS','The Twilight\'s Hammer is the instrument of this grand destruction, the method of glorious annihilation! (Tear aside the veil! Open your mind to emptiness!) Through us will you find true power.','',26124),
(39749,'enUS','Join us (Join us!) and be granted strength beyond strength! (Strength! His STRENGTH! His MIGHT!)','',26124),
(39750,'enUS','I am the Eye of Twilight... Behold your new master!','I am the Eye of Twilight... Behold your new master!',26124),
(39751,'enUS','Your work in Hyjal is done - return from whence you came.','Your work in Hyjal is done - return from whence you came.',26124),
(39752,'enUS','Kill anyone who tells you otherwise. So sayeth the Eye!','Kill anyone who tells you otherwise. So sayeth the Eye!',26124),
(39753,'enUS','','Have you come here to bother us, outsider?',26124),
(39754,'enUS','','Do not be afraid, $c. We embrace all who seek the truth.',26124),
(39755,'enUS','We only want to be left alone. Why is that so difficult to understand?','',26124),
(39756,'enUS','The end of the world approaches, but there is time to set things right, $c.','',26124),
(39757,'enUS','Enjoy your hollow victory, insects. (The darkness comes...) May it console you as your world rots.','',26124),
(39758,'enUS','Hello, $c. I imagine you have a lot of questions.$B$BSuffice it to say that Royce Duskwhisper sent me into the middle of an ogre cave for some \"Eye of Twilight\" jib-job, and it hasn\'t gone well.$B$BIf I ever get my hands on that lanky, heartless, mealy-mouthed little night elf...$B$B<Kristoff wriggles helplessly as he dangles in the air, his face reddening.>','',26124),
(39759,'enUS','You should return to Orgrimmar. Your family is worried.','You should return to Orgrimmar. Your family is worried.',26124),
(39760,'enUS','','No, I cannot return to Orgrimmar. I grieve for my family, but they have made their choices and I have made mine. My future is here, among my chosen brethren.',26124),
(39761,'enUS','Your family has asked about you. They\'re worried.','Your family has asked about you. They\'re worried.',26124),
(39762,'enUS','','I will not leave. Tell my family that I am at peace here and that I wish them well.',26124),
(39763,'enUS','','One day, I, too, will ascend.',26124),
(39764,'enUS','','It amazes me that in a city full of people, only the small handful here heeded the warnings of the elements.',26124),
(39765,'enUS','Work hard, $c. We have little time to complete our tasks before the prophecies are fulfilled.','',26124),
(39766,'enUS','Our world will end soon, but together we will ascend and inherit the power of the elements.','',26124),
(39767,'enUS','Your family wants you to return to Orgrimmar.','Your family wants you to return to Orgrimmar.',26124),
(39768,'enUS','You smell somethin\'?','',26124),
(39769,'enUS','I\'d lend a hand, but I\'ve got... chain rash. I\'ll just hang back a little.','',26124),
(39770,'enUS','You\'re one unusual $c, $n. I don\'t mean that it a negative way. I\'m just sayin\', you\'re kinda funny.','',26124),
(39771,'enUS','How long was I hanging back there? It felt like days.','',26124),
(39772,'enUS','I don\'t recommend hanging from a chain like that. But, to be honest, it did great things for my hair.','',26124),
(39773,'enUS','Ogres.$B$BI hate ogres.','',26124),
(39774,'enUS','Do you always talk so much when there\'s stuff to kill?','',26124),
(39775,'enUS','Less yap flappin\'. More ogre thwappin\'. Deal?','',26124),
(39776,'enUS','They had their chance to come with me, and instead they mocked my beliefs. They are nothing to me.','',26124),
(39777,'enUS','Your wife is concerned for you. She wants you to return to Orgrimmar.','Your wife is concerned for you. She wants you to return to Orgrimmar.',26124),
(39778,'enUS','Doesn\'t she realize I wanted her to come with me? I\'m young; I don\'t want to die. We should have many good years ahead of us and this is the only way. Tell her these things. Make her understand.','',26124),
(39779,'enUS','Okay, let\'s do this! You fight the ogres, and I will... not fight them. Head for the exit!','',26124),
(39780,'enUS','I\'ve been given another chance to serve?  I will not fail again!','I\'ve been given another chance to serve?  I will not fail again!',26124),
(39781,'enUS','Alexstrasza has chosen capable allies.... A pity that I must END YOU!','',26124),
(39782,'enUS','You thought you stood a chance?','',26124),
(39783,'enUS','It\'s for the best.','',26124),
(39784,'enUS','HALION! I....','',26124),
(39785,'enUS','Turn them to ash, minions!','',26124),
(39786,'enUS','We made it! I\'ll find my way back on my own. Do me a favor and go tell Royce Duskwhisper where he can stick his stupid Eye of Twilight.','',26124),
(39787,'enUS','I see you are growing in numbers, my brethren. Tell me of your progress in implementing our master\'s plan.','',26124),
(39788,'enUS','Then all is in order. The master has given us a mission of the utmost importance and he will not suffer failure.','',26124),
(39789,'enUS','Behold! The world you see before you has been judged. (Fire, water, earth, air!) All shall perish before the elements! (Burn and drown and crush and suffocate!)','',26124),
(39790,'enUS','Join us, and embrace the inevitable end. (The Master\'s power calls!) You will be reborn, stronger than flesh! (Strength beyond form! Power in the infinite!)','',26124),
(39791,'enUS','Swear your allegiance to me (The master wants! He sees and wants and hungers!) and you will be remade in my image. (Wait! INFIDEL! A heathen among us!) An intruder! YOU! Show yourself...','',26124),
(39792,'enUS','Work on the devices is proceeding as you have directed. We will soon be ready to carry out the next phase of your orders.','',26124),
(39793,'enUS','You are the instrument the master will use to bring an end to this world and reforge it in his image.','',26124),
(39794,'enUS','When they are completed, you will hide these devices all over Orgrimmar.','',26124),
(39795,'enUS','That one\'s huge. You shouldn\'t have made him angry.','',26124),
(39796,'enUS','At the appointed time, they will unleash fire elementals, consuming the city in flame and setting the stage for our master\'s glorious return!','',26124),
(39797,'enUS','Look out!','',26124),
(39798,'enUS','Ogre!','',26124),
(39799,'enUS','This one smells particularly bad.','',26124),
(39800,'enUS','Kill that one! I\'ll stay over here.','',26124),
(39801,'enUS','What, more ogres?','',26124),
(39802,'enUS','Don\'t get stepped on.','',26124),
(39803,'enUS','He doesn\'t see me, does he?','',26124),
(39804,'enUS','Is that the Twilight Apocrypha? I\'ll be boiled alive - it DOES exist!','',26124),
(39805,'enUS','Hi. Yeah, I know. I got captured again.$B$BI don\'t want to talk about it.$B$BYou ready?','',26124),
(39806,'enUS','Well? Are you going to help me down?','',26124),
(39807,'enUS','Okay, let\'s try this again.','Okay, let\'s try this again.',26124),
(39808,'enUS','Um, no. Would you mind hanging out a little longer? I have some stuff I need to take care of first.','Um, no. Would you mind hanging out a little longer? I have some stuff I need to take care of first.',26124),
(39809,'enUS','You... WHAT?$B$BCome over here and say that!$B$B<Kristoff kicks and flails his limbs in a frothing rage, his head twisting around to glare at you.>$B$BSo help me, I will - I am going to - I will knock your brains out! I will fill the empty cavity left behind with my boot! Come here! GET BACK HERE!$B$B<Kristoff strains to grasp your neck, his fingers wriggling inches from your face.>','',26124),
(39810,'enUS','So how is your research into the Eye coming along?','So how is your research into the Eye coming along?',26124),
(39811,'enUS','$n, $n. Can I call you $n?$B$BI am hanging from a meathook in the back of an ogre cave.$B$BHow do you THINK my research is progressing, you pompous dirt-sucking ass-$c? C\'mere! C\'mere you son of a swineherd!$B$B<Kristoff flutters back and forth on his chain, trying desperately to kick you in the face.>','',26124),
(39812,'enUS','<Kristoff grunts.>','',26124),
(39813,'enUS','And then, my brothers and sisters, we shall shed these frail forms and ascend to immortality!','',26124),
(39814,'enUS','Of all the ancients, Goldrinn is the most magnificent. His fury, his resolve... you would do well to emulate.','',26124),
(39815,'enUS','It will be as you say, my lord.','',26124),
(39816,'enUS','It should be me in your place!  I\'ll show you!','It should be me in your place!  I\'ll show you!',26124),
(39817,'enUS','I\'ll kill you and take your place, scum!','I\'ll kill you and take your place, scum!',26124),
(39818,'enUS','We live or die in THEIR service!','We live or die in THEIR service!',26124),
(39819,'enUS','I should be the one learning the secrets of the Old Gods!  I\'ll show you!','I should be the one learning the secrets of the Old Gods!  I\'ll show you!',26124),
(39820,'enUS','I was chosen!  I will prevail!','I was chosen!  I will prevail!',26124),
(39821,'enUS','Heed me, Twilight Lords!  Accept this $r as a humble offering!','Heed me, Twilight Lords!  Accept this $r as a humble offering!',26124),
(39822,'enUS','Master Taerar no longer dwells here, fool. He has bestowed me with enough power to stop you!','',26124),
(39823,'enUS','','I don\'t recognize you. Are you new here?',26124),
(39824,'enUS','What are those devices that everyone is building?','What are those devices that everyone is building?',26124),
(39825,'enUS','','Ah, you are new. These devices are a part of our master\'s plan to bring about the transformation of the world. They will unleash the fires of judgment and allow us to ascend to immortality. This is the master\'s promise.',26124),
(39826,'enUS','','You don\'t belong here, outsider. Leave before you get yourself in trouble.',26124),
(39827,'enUS','Noooooooooooooooo!','',26124),
(39828,'enUS','','Taerar has not fled Feralas. He acts as a conduit to the nightmare through his own form.',26124),
(39829,'enUS','','I will run no longer. Seek me atop the peak to the east.',26124),
(39830,'enUS','Blood guard, you have to help me find him. He just went missing!','Blood guard, you have to help me find him. He just went missing!',26124),
(39831,'enUS','Surely you can help. He just went out to the market and never came back.','Surely you can help. He just went out to the market and never came back.',26124),
(39832,'enUS','There has to be something you can do, blood guard.','There has to be something you can do, blood guard.',26124),
(39833,'enUS','He would never leave on his own! Where could he have gone?','He would never leave on his own! Where could he have gone?',26124),
(39834,'enUS','My husband has disappeared. Please, blood guard, he is no warrior. You must help me find him.','My husband has disappeared. Please, blood guard, he is no warrior. You must help me find him.',26124),
(39835,'enUS','You are a reasonable man, blood guard. Where would you turn if your kin went missing?','You are a reasonable man, blood guard. Where would you turn if your kin went missing?',26124),
(39836,'enUS','Do you think he was kidnapped? Will I ever see him again?','Do you think he was kidnapped? Will I ever see him again?',26124),
(39837,'enUS','I am not the only one who is here to report a disappearance. There are others, many others.','I am not the only one who is here to report a disappearance. There are others, many others.',26124),
(39838,'enUS','There\'s something going on in Orgrimmar, and I don\'t like the look of it. These women complain that people have disappered. Others say the world will end. What does it mean?','',26124),
(39839,'enUS','BY FIRE BE PURGED!!!!','',26124),
(39840,'enUS','The end of the world nears, $c. There is no need to despair. Hear what I say and what my brethren have to offer.','The end of the world nears, $c. There is no need to despair. Hear what I say and what my brethren have to offer.',26124),
(39841,'enUS','I will hear what you have to say.','I will hear what you have to say.',26124),
(39842,'enUS','%s hastily scrawls a page of notes into his manuscript. ','',26124),
(39843,'enUS','%s consults his manuscript, grunting.','',26124),
(39844,'enUS','%s tinkers with a bizarre array of equipment on his workbench.','',26124),
(39845,'enUS','%s chuckles softly to himself, carefully logging his progress in his manuscript.','',26124),
(39846,'enUS','You\'re interrupting work your feeble mind cannot possibly comprehend!','',26124),
(39847,'enUS','I want to join your movement.','I want to join your movement.',26124),
(39848,'enUS','I need another robe.','I need another robe.',26124),
(39849,'enUS','Gather around the altar, brothers and sisters! Revelation awaits!','',26124),
(39850,'enUS','Citizens and friends of Gnomeregan!','',26124),
(39851,'enUS','No more shall our people live as refugees, as outcasts, as wretched, irradiated slaves chained to the yoke of a madman\'s war machine!','',26124),
(39852,'enUS','The end of Thermaplugg\'s reign draws near!','',26124),
(39853,'enUS','Our tactics, our science, our bravery and determination shall prevail.','',26124),
(39854,'enUS','Operation: Gnomeregan begins NOW!','',26124),
(39855,'enUS','Targets in sight! Squads, deploy: Destroy all enemy rocket launchers!','',26124),
(39856,'enUS','That\'s one down. Keep attacking!','',26124),
(39857,'enUS','There\'s another destroyed. Maintain the assault!','',26124),
(39858,'enUS','Excellent work. Don\'t let up!','',26124),
(39859,'enUS','The airfield is ours, and with it, the skies over Gnomeregan.','',26124),
(39860,'enUS','Today is the day we take back our glorious city from that vile traitor Thermaplugg! ','',26124),
(39861,'enUS','Gather around me as we prepare to reclaim our homeland!','',26124),
(39862,'enUS','Gather now at the staging area!','',26124),
(39863,'enUS','The assault begins in but a moment!','',26124),
(39864,'enUS','Initiate Phase I: Recapture the enemy airfield! ','',26124),
(39865,'enUS','Destroy their rocket launchers and achieve total air superiority!','',26124),
(39866,'enUS','Now our Multi-Bombers can obliterate the Thermaplugg\'s shielded Tankbuster Cannons.','',26124),
(39867,'enUS','Initiate Phase II: Capture the Surface Command Post!','',26124),
(39868,'enUS','Our Multi-Bombers have destroyed Tankbuster Cannons\' shields. Take them down and secure the Surface Command Post!','',26124),
(39869,'enUS','IT\'S A TRAP! That\'s a fully functional irradiator!','',26124),
(39870,'enUS','We\'ve secured the surface! Operation: Gnomeregan is proceeding with 93%% efficiency...well done, everyone!','',26124),
(39871,'enUS','I\'ll shut down the defensive radiation pumps. Squads, commandeer the remaining mechanized suits and move up to the Main Entry.','',26124),
(39872,'enUS','We stand at the brink of victory, my friends. Initiate Phase III: Into the tunnels!','',26124),
(39873,'enUS','Once we capture the underground railway and loading dock, we\'ll use them to make a rapid attack on the heart of the city. ','',26124),
(39874,'enUS','Gnomeregan is within our grasp!','',26124),
(39875,'enUS','NEVER! Wait...is this thing on? Is it...this button? Testing...testing. Ah! *ahem* ','',26124),
(39876,'enUS','NEVER! Gnomeregan is MINE, Mekkatorque. ','',26124),
(39877,'enUS','You think you\'ll just march into MY city? ','',26124),
(39878,'enUS','Activate the Expendable Atomic Defense System: DRIVE FORTH THE TROGGS!!!','',26124),
(39879,'enUS','My GEARS...that\'s got to be every last trogg in the city! Squads, dig in!','',26124),
(39880,'enUS','Frag bombs and suppressing fire...HOLD THE LINE! We won\'t be turned back now!','',26124),
(39882,'enUS','Sweet baby titans! That\'s got to be the biggest trogg I\'ve ever seen! Keep firing...take it down!','',26124),
(39883,'enUS','It\'s too quiet. Where are Thermaplugg\'s defense forces?\n','',26124),
(39884,'enUS','What is that? That looks like the radiation bomb that poisoned Gnomeregan...wait! Incoming!','',26124),
(39885,'enUS','No! No, no, NO!!! I won\'t allow you into my kingdom, usurper! I WON\'T ALLOW IT! ','',26124),
(39886,'enUS','Activate the Ultimate Atomic Protection System.','',26124),
(39887,'enUS','...DISINTEGRATE THEM ALL!','',26124),
(39888,'enUS','It is... and twenty-six TIMES more powerful than the first! ','',26124),
(39889,'enUS','TEN MINUTES?! You left the factory setting on? Give me that controller, you idiot!','',26124),
(39890,'enUS','You\'ve FAILED, Mekkatorque! I\'ve caught and defeated you before you even set FOOT in my precious city!','',26124),
(39891,'enUS','Now DIE!','',26124),
(39892,'enUS','Oh, I\'d love to see that old cog\'s face. I bet he...what? It\'s still on? WELL TURN IT O-','',26124),
(39893,'enUS','Ten minutes? Plenty of time to disarm the device.','',26124),
(39894,'enUS','Hinkles, hand me that Whirring Bronze Gizmo and some Fresh Spring Water. Cogspin, toss me that Dirty Trogg Cloth and a Handful of Copper Bolts...','',26124),
(39895,'enUS','Whuh-oh! We\'ve got to get out of here! Lapforge, beam us back, quickly!','',26124),
(39896,'enUS','Curses! We had to fall back. But Thermaplugg\'s lost, and he knows it...he\'s only bought himself time. ','',26124),
(39897,'enUS','We hold the surface, and when the radiation clears we\'ll assault and recapture Gnomeregan with a force twice this size.','',26124),
(39898,'enUS','Someone has to report this!','Someone has to report this!',26124),
(39899,'enUS','Talk, ogre. Who\'s giving your clan these trinkets?','',26124),
(39901,'enUS','Warriors of the Horde, we should honor $n for $g his:her; courage in uncovering the Twilight\'s Hammer plot against Orgrimmar!','',26124),
(39902,'enUS','We must uncover the truth about these rumors and stop this Twilight\'s Hammer campaign to spread fear among us!','',26124),
(39903,'enUS','Not gonna talk.','',26124),
(39904,'enUS','AAAAAAAAAAAAAAGH!','',26124),
(39905,'enUS','WHO HAS GIVEN YOU POWER?','',26124),
(39906,'enUS','Cho\'gall!','',26124),
(39907,'enUS','The Twilight\'s Hammer?! Where are they?','',26124),
(39908,'enUS','Good. Now throw yourself off.','',26124),
(39909,'enUS','Dire Maul! DIRE MAUL!','',26124),
(39912,'enUS','Chief Spirithorn, I beseech you to send aid to Westreach Summit now, before it is too late.','',26124),
(39913,'enUS','Thousand Needles lies in ruins under hundreds of feet of water. Can you spare any braves to assist us?','',26124),
(39914,'enUS','The Cataclysm crumbled the eastern mountains. The South Seas poured in and submerged all of Thousand Needles! Can you aid us in our time of need?','',26124),
(39915,'enUS','Please. We are staging a relief effort at Westreach Summit. Thousand Needles has been decimated!','',26124),
(39916,'enUS','I understand that the Cataclysm has struck Feralas as well, but Camp Mojache appears relatively safe. Can you not spare any braves?','',26124),
(39917,'enUS','If you cannot send any help to Westreach Summit, may the refugees from Freewind Post stay on the edge of Camp Mojache?','',26124),
(39918,'enUS','I fear that if we do not receive reinforcements in Thousand Needles quickly, the Grimtotem will act. We are in no position to defend ourselves for very long.','',26124),
(39919,'enUS','If the Shu\'halo of Thousand Needles fall, the Grimtotem clan will be at your tent flap soon after. The time for action is now, Chief Spirithorn!','',26124),
(39920,'enUS','','I\'m here to study the ways of the muisek spirits, the wild magic. Witch Doctor Uzeri sent me here to start practicing with the lesser creatures of the forest.',26124),
(39921,'enUS','Greetings, $c.$B$BThe mountains have crumbled and the Cataclysm has caused the seas to rush in and drown Thousand Needles.$B$BWe need your help, now!','',26124),
(39922,'enUS','Shyn, I need to get to Westreach Summit!','Shyn, I need to get to Westreach Summit!',26124),
(39923,'enUS','Please, help me! They\'re going to kill me!','',26124),
(39924,'enUS','The crystal has granted you new abilities! Use them to defeat the summoned elementals.','',26124),
(39925,'enUS','','Burn in the master\'s flame!',26124),
(39926,'enUS','Use the crystal\'s powers to defeat the elementals! I won\'t last long...','',26124),
(39927,'enUS','This was a good man, $r. We\'d served together through many battles...$b$bThese beasts have a debt to pay!','',26124),
(39928,'enUS','Irradiator 3000 activated. Attention. Emergency. You now have ten minutes to reach minimum safe distance.','',26124),
(39929,'enUS','*BEEP* Attention. Emergency. You now have ten seconds to reach minimum safe distance.','',26124),
(39930,'enUS','Interact with the Mysterious Crystal to gain new abilities and use them to defend Durak Flamespeaker.','',26124),
(39931,'enUS','We will never fall to these cowards! The Horde stands united against all enemies! Lok\'tar Ogar!','',26124),
(39932,'enUS','','You will sssuffer for this intrusion!',26124),
(39933,'enUS','','As it should be....',26124),
(39934,'enUS','','Halion will be pleased.',26124),
(39935,'enUS','Ah, the entertainment has arrived.','',26124),
(39936,'enUS','I... didn\'t see that coming....','',26124),
(39937,'enUS','Baltharus leaves no survivors!','',26124),
(39938,'enUS','This world has enough heroes.','',26124),
(39939,'enUS','Twice the pain and half the fun.','',26124),
(39940,'enUS','Blasted titans... Why do they use a different set of mechanisms at each of their installations?','',26124),
(39941,'enUS','Thank you for saving me. I\'ll make my way back to Orgrimmar once I recover a bit.','',26124),
(39942,'enUS','Meddlesome insects! You are too late. The Ruby Sanctum is lost!','',26124),
(39943,'enUS','Meep!  $R is good friend.  Follow now!  We find intruder!','',26124),
(39944,'enUS','We finds evil one!  Quick!','',26124),
(39945,'enUS','How did you find me?  It matters little... you will die!','How did you find me?  It matters little... you will die!',26124),
(39946,'enUS','I\'ve been spotted?  Time to die!','I\'ve been spotted?  Time to die!',26124),
(39947,'enUS','You will not give away my position, $c!','You will not give away my position, $c!',26124),
(39948,'enUS','You might have found me, but you won\'t bring word back to the others!','You might have found me, but you won\'t bring word back to the others!',26124),
(39949,'enUS','You will never get the tablets!','',26124),
(39950,'enUS','Continue the assault!','Continue the assault!',26124),
(39951,'enUS','I will have those tablets!','I will have those tablets!',26124),
(39952,'enUS','Slay the courier!','Slay the courier!',26124),
(39953,'enUS','','Our prayers to Aessina go unanswered. The burning minions of Ragnaros have driven us to the brink. If they are not stopped here, the World Tree will be little more than a stump amidst the conflagration!',26124),
(39954,'enUS','','The strands of life have been severed.$B$BThe dreamers must be avenged.',26124),
(39956,'enUS','','Come forth, Taerar! I stand before you!',26124),
(39957,'enUS','I knew you\'d return, Ysondre...It was only a matter of time...','',26124),
(39958,'enUS','Peace? PEACE?','',26124),
(39959,'enUS','','I\'ve returned only to end this, Taerar. This land will finally have peace.',26124),
(39960,'enUS','','Have you come here to bother us? We only want to be left alone.',26124),
(39961,'enUS','Snooping around here won\'t help you much, friend. You can find out more about us from our members in the city.','',26124),
(39962,'enUS','This is no place for outsiders, stranger. Go back to Stormwind.','',26124),
(39963,'enUS','My essence...will...persist...','',26124),
(39964,'enUS','The end of the world is at hand!','The end of the world is at hand!',26124),
(39965,'enUS','Azeroth is coming to an end. Make your peace now!','Azeroth is coming to an end. Make your peace now!',26124),
(39966,'enUS','Come with me, brothers and sisters, and learn the truth!','Come with me, brothers and sisters, and learn the truth!',26124),
(39967,'enUS','Our world will be torn apart. Join us, so that you may live!','Our world will be torn apart. Join us, so that you may live!',26124),
(39968,'enUS','It is not too late to save yourselves from the coming catastrophe!','It is not too late to save yourselves from the coming catastrophe!',26124),
(39969,'enUS','This world will be consumed by the elements!','This world will be consumed by the elements!',26124),
(39970,'enUS','You needn\'t perish with Azeroth. Follow me and live!','You needn\'t perish with Azeroth. Follow me and live!',26124),
(39971,'enUS','Leave behind your homes, your possessions, and your cares, and join us!','Leave behind your homes, your possessions, and your cares, and join us!',26124),
(39972,'enUS','You haven\'t completed the quest!','',26124),
(39973,'enUS','You\'ve completed the quest!','',26124),
(39974,'enUS','Just what we need, more of this lunacy!','Just what we need, more of this lunacy!',26124),
(39975,'enUS','Don\'t you people get tired of repeating the same thing over and over?','Don\'t you people get tired of repeating the same thing over and over?',26124),
(39976,'enUS','Stop disturbing the peace, cultist!','Stop disturbing the peace, cultist!',26124),
(39977,'enUS','As if I\'m going to listen to anyone dressed up in that outfit!','As if I\'m going to listen to anyone dressed up in that outfit!',26124),
(39978,'enUS','Hey, look, Lady Sylvanas has a new court fool!','Hey, look, Lady Sylvanas has a new court fool!',26124),
(39979,'enUS','Why don\'t you take it where somebody cares?','Why don\'t you take it where somebody cares?',26124),
(39980,'enUS','That\'s enough of that doomsday nonsense!','That\'s enough of that doomsday nonsense!',26124),
(39981,'enUS','Look, the warchief\'s sent us some entertainment!','Look, the warchief\'s sent us some entertainment!',26124),
(39982,'enUS','Stonemaul comin\' in FOR DA HORDE!','Stonemaul comin\' in FOR DA HORDE!',26124),
(39983,'enUS','Ugh...$b$bI don\'t... feel so good...','',26124),
(39984,'enUS','','Thank you, $c.$b$bI nearly died out there.',26124),
(39985,'enUS','I can hold out no longer...','',26124),
(39986,'enUS','','This is...',26124),
(39987,'enUS','This is truly grave. We must find the true cause of this illness, for the sake of the land.','',26124),
(39988,'enUS','A green dragon in mortal guise! I never thought I would receive the honor of...','',26124),
(39989,'enUS','We are here to preserve these lands for our people.','',26124),
(39990,'enUS','Hold on tight!\n\n|TInterface\\Icons\\misc_arrowlup.blp:32|t','Hold on tight!\n\n|TInterface\\Icons\\misc_arrowlup.blp:32|t',26124),
(39991,'enUS','Lean right!\n\n|TInterface\\Icons\\misc_arrowright.blp:32|t','Lean right!\n\n|TInterface\\Icons\\misc_arrowright.blp:32|t',26124),
(39992,'enUS','Well done!\n','Well done!\n',26124),
(39993,'enUS','You\'re losing grip.  Be careful!\n','You\'re losing grip.  Be careful!\n',26124),
(39994,'enUS','|TInterface\\Icons\\ability_warrior_charge.blp:20|tGeneral Umbriss sets his eyes on |cFFFF0000$n|r and begins to cast |cFFFF0000|Hspell:74670|h[Blitz]|h|r!','',26124),
(39995,'enUS','$R. Have you been sent to speak with me? How long has it been since the master\'s demise on these very slopes?','',26124),
(39996,'enUS','Patience, friend. Allow me to assist in preparing another attempt.','',26124),
(39997,'enUS','Who gave your clan these orbs, ogre?','',26124),
(39998,'enUS','','Welcome, $c.$B$BHyjal burns and the world I\'ve spent my life protecting is on the brink of oblivion.$B$BTell me: Have you ever heard of Tyrus Blackhorn?',26124),
(39999,'enUS','You disgusting creature. You spread your filth among glorious Eldre\'thalas, and now you DARE defy me? TALK!','',26124),
(40000,'enUS','The Twilight\'s Hammer...fascinating. They are within your \"Dire Maul\"?','',26124),
(40001,'enUS','You will no longer live there, ogre. Pray you land somewhere safe, for it\'s more than you deserve.','',26124),
(40002,'enUS','Years of my research have led me here.$b$bI\'m not about to turn back now...','',26124),
(40003,'enUS','C-c-cold...','',26124),
(40004,'enUS','Who is Tyrus Blackhorn?','Who is Tyrus Blackhorn?',26124),
(40005,'enUS','Ch-ch-Cho\'gall gives us...orbs...Twilight\'s Hammer clan makes us strong...','',26124),
(40006,'enUS','Yes! Dire Maul! Let go...so cold...','',26124),
(40007,'enUS','','A decade ago, a great battle took place here on the summit of Mount Hyjal. Archimonde the Defiler commanded a swarm of demons to march upon the World Tree and claim its power for his own.$B$BHis defeat signaled the end of the Legion\'s invasion of Azeroth... But many of his corrupted supporters remained behind.',26124),
(40008,'enUS','Blackhorn is a demon?','Blackhorn is a demon?',26124),
(40009,'enUS','','Yes and no. He may be a demon now, but Tyrus Blackhorn was a night elf once. Like many of his brothers he was wooed and transformed by the promises of power the demonic army whispered in his ear.$B$BHe was captured after his master\'s defeat and imprisoned here on the summit, his immortal form bound by sacred energies.$B$BBut perhaps the dimmest flicker of a soul still burns within him... We must at least reach out to know for sure.',26124),
(40010,'enUS','Yes, Blackhorn. I\'ve been sent to request your aid, if you are willing.','Yes, Blackhorn. I\'ve been sent to request your aid, if you are willing.',26124),
(40011,'enUS','My help? Have things really grown so dire?$B$B<The distant flames flicker in Blackhorn\'s cruel, dark eyes.>$B$BTell me why I shouldn\'t let your world burn.','',26124),
(40012,'enUS','I\'m only here in case someone faints. The new recruits get a little excited and occasionally overexert themselves.\n\n...well, that, and sometimes one of the new mechano-tank prototypes explode. Whoops!','I\'m only here in case someone faints. The new recruits get a little excited and occasionally overexert themselves.\n\n...well, that, and sometimes one of the new mechano-tank prototypes explode. Whoops!',26124),
(40013,'enUS','You were a mortal once, Blackhorn. One of us.','You were a mortal once, Blackhorn. One of us.',26124),
(40014,'enUS','Mortal? Yes I was once mortal. Weak.$B$BYou see my bonds now? These restraints are nothing compared to being shackled within a mortal coil.$B$BEven now the master\'s gifts stir within me, ready to be unleashed.$B$BNo, $c, my mortal days have passed, and if any flame of my former life still flickers within I would wish it extinguished. You\'ll have to do better than that, $r.','',26124),
(40015,'enUS','You\'ll be destroyed if the Twilight\'s Hammer brings this mountain down!','You\'ll be destroyed if the Twilight\'s Hammer brings this mountain down!',26124),
(40016,'enUS','Destroyed? Yes, that\'s possible. At night I am haunted with visions of this world being torn asunder from within. I feel neither sorrow nor rage. Merely... curiosity.$B$BI served my master in exchange for power, $c. But those you fight... they strive for oblivion. A strange motivation.','',26124),
(40017,'enUS','Matoclaw believes that you may yet be redeemed. This is your chance to atone for siding with demons.','Matoclaw believes that you may yet be redeemed. This is your chance to atone for siding with demons.',26124),
(40018,'enUS','<Blackhorn strains against his bonds, for the first time visibly upset.>$B$BRedemption! You act as if there\'s an escape from the Burning Legion. So smug! As though your efforts a decade ago or in Outland have slowed the Legion a single iota! They will come, $r. They will return. And I will be here to welcome them.','',26124),
(40019,'enUS','Where is your master now, Blackhorn? It\'s not too late to turn to the light...','Where is your master now, Blackhorn? It\'s not too late to turn to the light...',26124),
(40020,'enUS','Will you help us to defeat them?','Will you help us to defeat them?',26124),
(40021,'enUS','Assuming there\'s a world left for your legion to conquer. The Twilight\'s Hammer seeks to destroy everything.','Assuming there\'s a world left for your legion to conquer. The Twilight\'s Hammer seeks to destroy everything.',26124),
(40022,'enUS','%s emits a shrill cry!','',26124),
(40023,'enUS','<Cough.>$b$bHave I... died?','',26124),
(40024,'enUS','You have talent, $n. But mercy makes you weak.','',26124),
(40025,'enUS','Who are you, friend?','Who are you, friend?',26124),
(40026,'enUS','Who are you? What is this place?','',26124),
(40027,'enUS','My life is forfeit. If in my final hour I can be of some service, you needn\'t bother asking. Do with me what you will....','',26124),
(40028,'enUS','Brave soldier, I shall see to it that your noble sacrifice is not forgotten.','',26124),
(40029,'enUS','...master?','',26124),
(40030,'enUS','When they are completed, you will hide these devices all over Stormwind.','',26124),
(40031,'enUS','Lean left!\n\n|TInterface\\Icons\\misc_arrowleft.blp:32|t','Lean left!\n\n|TInterface\\Icons\\misc_arrowleft.blp:32|t',26124),
(40032,'enUS','This region was an epicenter of the cataclysm.$b$bThe naga activity here is certainly no coincidence. Their intentions must be unveiled!','',26124),
(40033,'enUS','Looks like the king got himself a new court jester!','Looks like the king got himself a new court jester!',26124),
(40034,'enUS','You normally have to pay to see a show like this.','You normally have to pay to see a show like this.',26124),
(40035,'enUS','He just went missing and I don\'t know what to do!','He just went missing and I don\'t know what to do!',26124),
(40036,'enUS','You have to help! He just went to the market and never came back!','You have to help! He just went to the market and never came back!',26124),
(40037,'enUS','There has to be someone who can help me!','There has to be someone who can help me!',26124),
(40038,'enUS','He would never just disappear like this! It\'s not like him.','He would never just disappear like this! It\'s not like him.',26124),
(40039,'enUS','My husband just disappeared. You have to help me, captain. I\'m no warrior.','My husband just disappeared. You have to help me, captain. I\'m no warrior.',26124),
(40040,'enUS','You seem like a reasonable man, captain. What would you do if someone in your family went missing?','You seem like a reasonable man, captain. What would you do if someone in your family went missing?',26124),
(40041,'enUS','Do you think he was kidnapped? Will I ever see him again?','Do you think he was kidnapped? Will I ever see him again?',26124),
(40042,'enUS','I\'m not the only one who has lost a family member. There are others, many others!','I\'m not the only one who has lost a family member. There are others, many others!',26124),
(40043,'enUS','Your family is worried and wants you to come back to Stormwind.','Your family is worried and wants you to come back to Stormwind.',26124),
(40044,'enUS','','I can\'t go back, not after the horrible fight I had with them. I\'m sorry, $n, I just can\'t.',26124),
(40045,'enUS','','I cannot return. Now that I\'ve learned the truth, my place is here among my new brothers and sisters.',26124),
(40046,'enUS','I am on the path to ascension, $n. There is no going back. Tell my family that I wish them well, and I will be here if they decide to join me.','',26124),
(40047,'enUS','Why should I return, $n? The world is ending and I have a chance to become something more. If their paths lead them to the truth, as mine did, then we will see each other again. If not, I cannot open their eyes.','',26124),
(40048,'enUS','Hear me, citizens of Stormwind. We have long been in the dark. I beg you to open your eyes as I have!','Hear me, citizens of Stormwind. We have long been in the dark. I beg you to open your eyes as I have!',26124),
(40049,'enUS','The end of our world nears, my brothers and sisters! Azeroth will be no more!','The end of our world nears, my brothers and sisters! Azeroth will be no more!',26124),
(40050,'enUS','Flames will consume the world. Storms will wash away all hope. The elements will reign at last!','Flames will consume the world. Storms will wash away all hope. The elements will reign at last!',26124),
(40051,'enUS','Do not despair! Turn away from the false Light, and instead embrace the hope and truth I offer you!','Do not despair! Turn away from the false Light, and instead embrace the hope and truth I offer you!',26124),
(40052,'enUS','Cast off your lives of war and drudgery, be reborn in elements and claim your rightful place in this new world!','Cast off your lives of war and drudgery, be reborn in elements and claim your rightful place in this new world!',26124),
(40053,'enUS','Calm down, friends. There will be plenty of time to answer all your questions.','Calm down, friends. There will be plenty of time to answer all your questions.',26124),
(40054,'enUS','If you are interested in our message, I will be holding a gathering. Speak with me if you wish to know more, but beware, for Stormwind is full of people who would silence the truth.','If you are interested in our message, I will be holding a gathering. Speak with me if you wish to know more, but beware, for Stormwind is full of people who would silence the truth.',26124),
(40055,'enUS','Fool of a mortal. Flesh burns.','',26124),
(40056,'enUS','LEAVE THIS PLACE!','',26124),
(40057,'enUS','I love you, Sensiria, but I must leave here.','',26124),
(40058,'enUS','','Oh, Verinias. You poor fool. You should have left earlier.',26124),
(40059,'enUS','I will leave to follow Dath\'remar and the others. The Shen\'dralar have gone too far. To traffic with demons...we\'re giving ourselves over to corruption.','',26124),
(40060,'enUS','No! NO!','',26124),
(40061,'enUS','','It\'s too late to stop them. Let me show you their glory...',26124),
(40062,'enUS','Interact with the Mysterious Crystal to gain new abilities and use them to defend Courier Tormun!','',26124),
(40063,'enUS','The crystal has granted you new abilities! Use them to defeat the summoned elementals.','',26124),
(40064,'enUS','Your world teeters on the brink of annihilation. You will ALL bear witness to the coming of a new age of DESTRUCTION!','',26124),
(40065,'enUS','Relish this victory, mortals, for it will be your last. This world will burn with the master\'s return!','',26124),
(40066,'enUS','Another \"hero\" falls.','',26124),
(40067,'enUS','You will find only suffering within the realm of twilight! Enter if you dare!','',26124),
(40068,'enUS','The heavens burn!','',26124),
(40069,'enUS','Beware the shadow!','',26124),
(40070,'enUS','Very well, dwarf. I shall slay you and carry the tablets to Cho\'Gall.','Very well, dwarf. I shall slay you and carry the tablets to Cho\'Gall.',26124),
(40071,'enUS','The orbiting spheres pulse with dark energy!','',26124),
(40072,'enUS','I am the light and the darkness! Cower, mortals, before the herald of Deathwing!','',26124),
(40073,'enUS','Let the enemies of Stormwind and the Alliance know, I will not allow them to spread fear and rumors among the people!','',26124),
(40074,'enUS','With heroes like $n fighting on our behalf, Stormwind stands ready to face any Twilight\'s Hammer threat!','',26124),
(40075,'enUS','There will be time enough to speak of preparations for battle against Twilight\'s Hammer. Today, we celebrate $n\'s victory!','',26124),
(40076,'enUS','A strange mood has come over the city, $c. The people are afraid of something and many have gone missing. We must get to the bottom of it.','',26124),
(40077,'enUS','Someone should tell the king. A chat with Lo\'gosh would set these cultists straight!','Someone should tell the king. A chat with Lo\'gosh would set these cultists straight!',26124),
(40078,'enUS','Others will come... the age of mortals... has passed.','',26124),
(40079,'enUS','Your companions\' efforts force %s further into the physical realm!','',26124),
(40080,'enUS','Your companions\' efforts force %s further into the twilight realm!','',26124),
(40081,'enUS','Sons and daughters of de Darkspear! Friends of de tribe!','',26124),
(40082,'enUS','We be gettin\' ready to march to de Isles, an\' FREE dem of Zalazane\'s wicked rule! Join me!','',26124),
(40083,'enUS','Zalazane\'s time has come! De Darkspear will have a proper home again. Be ready!','',26124),
(40084,'enUS','You came, wise sista! De Darkspear be grateful.','',26124),
(40085,'enUS','','Of course, Son of Sen\'jin. Zen\'tabra always keep her word.',26124),
(40086,'enUS','De time has come! Warrior of de Darkspear, make ready! Da Loa walk wit us! Are ya ready, Vanira, Zen\'tabra?','',26124),
(40087,'enUS','','De elements be walkin\' wit us, too...',26124),
(40088,'enUS','','...as do de beasts of de Isles.',26124),
(40089,'enUS','Den we go! First, to Bwonsamdi... if we gonna win dis, we need his mojo on our side.','',26124),
(40090,'enUS','WHO BE STIRRIN\' UP MY BONES? Dem\'s Bwonsamdi\'s charges, and not ta be touched!','',26124),
(40091,'enUS','I be Vol\'jin, Son of Sen\'jin, here ta ask your aid, o great Bwonsamdi.','',26124),
(40092,'enUS','I know who ya are, shadow hunter. An\' I know what ya WANT. But what makes you tink I\'m gonna help YOU? Ain\'t a wise ting, callin\' me from de Other Side...','',26124),
(40093,'enUS','Darkspear...  it been a long time since I heard de drums...  since I drank de ritual offerings. I be watchin\' over your dead, Vol\'jin, and for NOTHIN\'. Why have de Darkspear forsaken Bwonsamdi, eh?','',26124),
(40094,'enUS','We were driven away, Great Spirit. Hexmaster Zalazane took de Isles from us...  drove us mad, made us fight one another. De only trolls left in de Echo Isles are his mindless voodoo slaves.','',26124),
(40095,'enUS','Zalazane...','',26124),
(40096,'enUS','Aid us, Bwonsamdi! Help us regain our home! Return de Darkspear to de Isles, and hear your drums again! Drink your ritual offerings once more! Dis, as de Son of Sen\'jin, I swear.','',26124),
(40097,'enUS','Hrmmm. Time ta see how bad ya want dis, shadow hunter. Time ta see if you be WORTHY.','',26124),
(40098,'enUS','Ya tink ya got what it takes ta face ME? Give up, shadow hunter!','',26124),
(40099,'enUS','ENOUGH!  You got some BIG mojo, Vol\'jin. Maybe you worth helpin\' after all...','',26124),
(40100,'enUS','Not me, Great Spirit. Me TRIBE.','',26124),
(40101,'enUS','Mrm.','',26124),
(40102,'enUS','Go to de old village, across de water. Take it back. I\'ll help ya den.','',26124),
(40103,'enUS','At the appointed time, they will unleash storm elementals, washing away the city and setting the stage for our master\'s glorious return!','',26124),
(40104,'enUS','This symbol, I think I\'ve seen this before... ','',26124),
(40105,'enUS','Dey be waitin\' for us, all. We fight now for our old home... we gonna reclaim what be OURS!','',26124),
(40106,'enUS','Spirits of de Darkspear... ARISE! Take up de ancient masks, take up de bloody spears... you be followin\' VOL\'JIN, now!','',26124),
(40107,'enUS','Now GO! Use me boon wisely.','',26124),
(40108,'enUS','So be it. Al\'galar thol, thol al\'thaug: The end is the beginning. ','',26124),
(40109,'enUS','Don\' be underestimatin\' Zalazane... he be a tricky foe, cunnin\' and strong with de voodoo. Are ya ready? MOVE ON!','',26124),
(40110,'enUS','It be TIME, Hexmaster! De sons and daughters of de Darkspear have returned! We gonna drive you into de sea...','',26124),
(40111,'enUS','You ain\'t doin\' nothin\' of de sort, shadow hunter. De Echo Isles are MINE! ','',26124),
(40112,'enUS','Ha ha ha ha!','',26124),
(40113,'enUS','We can\'t be lettin\' him get away!','',26124),
(40114,'enUS','','Der ain\'t no escapin\' Zen\'tabra. Not while he on dese islands.',26124),
(40115,'enUS','Den find him, wise one. Go!','',26124),
(40116,'enUS','','He be just west of here, workin\' at some black magic.',26124),
(40117,'enUS','Not for long. Time ta finish dis ting.','',26124),
(40118,'enUS','Give up, Zalazane. It be over, now.','',26124),
(40119,'enUS','You fool! I ain\'t runnin\' away. I lured ya here, ta kill ya wit\' your own precious tribe!','',26124),
(40120,'enUS','No matter! I can\'t be touched. No living ting can make its way trough dis barrier! Da Echo Isles be Zalazane\'s ta rule, shadow hunter! Now, and FOREVER!','',26124),
(40121,'enUS','BWAH HAH HAH HAH HAH!','',26124),
(40122,'enUS','Who... who dat be?','',26124),
(40123,'enUS','ZALAZANE. What you tinkin\', takin\' dat which be mine? De Darkspear dead are MY domain, sorcerer... and now you gonna be one of dem!','',26124),
(40124,'enUS','No! No... NOOO!','',26124),
(40125,'enUS','A fittin\' end for so foul a troll. Bwonsamdi; you have my tanks, and dat of all de Darkspear. We will continue to honor you, as is proper.','',26124),
(40126,'enUS','It\'ll be good to hear de Darkspear drums once more. You take care now, Son of Sen\'jin.  Bwonsamdi will be waitin\' for ya... on de Other Side...','',26124),
(40127,'enUS','Time to return to de village. Time to rebuild our home... de Darkspear\'s home. Will you be stayin\' wit\' us, wise Zen\'Tabra?','',26124),
(40128,'enUS','','Me fate be entwined wit\' yours now, Vol\'jin, for good or for ill. I be stayin\'.',26124),
(40129,'enUS','Great, ye found yer way here!$b$bNo time to waste. Ye ready?','',26124),
(40130,'enUS','','The nightmare reigns!',26124),
(40131,'enUS','We\'re ready! Go, Brann!','We\'re ready! Go, Brann!',26124),
(40132,'enUS','','The strands of life...',26124),
(40133,'enUS','','Join us! Join us!',26124),
(40134,'enUS','','Hear his voice...',26124),
(40135,'enUS','The dark ashes swirl around %s, who utters an incantation:','',26124),
(40136,'enUS','Ashes from the plane below, scattered by the hand of foe...','',26124),
(40137,'enUS','Gods of terror, quake and thunder, tear these mortal bonds asunder!','',26124),
(40138,'enUS','%s barks a cruel laugh.','',26124),
(40139,'enUS','Thank you, mortal! Your heroism in The Inferno has made my escape possible.','',26124),
(40140,'enUS','As a reward, I will allow you to live.','',26124),
(40141,'enUS','But your time will come soon enough. Yes, mortal. Soon enough...','',26124),
(40142,'enUS','Hinkles rummages through his backpack looking for supplies.','',26124),
(40143,'enUS','Cogspin searches his \"Gigantique\" bag looking for the items.','',26124),
(40144,'enUS','Heading to the Wild Overlook.','',26124),
(40145,'enUS','Our defenses are impenetrable! WE are the true sons of Gnomeregan!\n','',26124),
(40146,'enUS','Use the Mechashark\'s REPAIR!','',26124),
(40147,'enUS','But enough words, comrades!  This is a call to action!  We will not let these \"chosen ones\" take what is ours!  We captured this prisoner and offer him to the Old Gods ourselves!!','But enough words, comrades!  This is a call to action!  We will not let these \"chosen ones\" take what is ours!  We captured this prisoner and offer him to the Old Gods ourselves!!',26124),
(40148,'enUS','It is in this moment, friends, that we should ask ourselves.  What would the Old Gods want us to do?','It is in this moment, friends, that we should ask ourselves.  What would the Old Gods want us to do?',26124),
(40149,'enUS','Remember the words of C\'thun!  Remember them well! \"Your friends will betray you!\"  And betray us they have!','Remember the words of C\'thun!  Remember them well! \"Your friends will betray you!\"  And betray us they have!',26124),
(40150,'enUS','And yes, Cho\'gall might have founded the Twilight\'s Hammer, but who made it what it is today?  Who preached the truth and faced persecution in the orc and human cities?','And yes, Cho\'gall might have founded the Twilight\'s Hammer, but who made it what it is today?  Who preached the truth and faced persecution in the orc and human cities?',26124),
(40151,'enUS','It is truly a great time for the Twilight\'s Hammer.  The greatest of times.  First, Lord Deathwing\'s arrival.  And now... now great Ragnaros has returned!','It is truly a great time for the Twilight\'s Hammer.  The greatest of times.  First, Lord Deathwing\'s arrival.  And now... now great Ragnaros has returned!',26124),
(40152,'enUS','One by one... our enemies will perish!  One by one... they will be destroyed!','One by one... our enemies will perish!  One by one... they will be destroyed!',26124),
(40153,'enUS','There will be no surrender!  There will be no escape!  There will be no quarter!','There will be no surrender!  There will be no escape!  There will be no quarter!',26124),
(40154,'enUS','And sometimes you have to ask yourself: \"Is it worth it?\"  And the answer is plain: \"Pain is not the cost, but the reward!\"','And sometimes you have to ask yourself: \"Is it worth it?\"  And the answer is plain: \"Pain is not the cost, but the reward!\"',26124),
(40155,'enUS','F\'tagh nah\'hat!  I\'mmathan!  Sha\'lub nahab!  Sha\'lub nahab, my friends!','F\'tagh nah\'hat!  I\'mmathan!  Sha\'lub nahab!  Sha\'lub nahab, my friends!',26124),
(40156,'enUS','And you will be rewarded!  If you fall in battle, yours will be a virtuous death!  You will be at HIS side when he rises again!  You will share in HIS glory!','And you will be rewarded!  If you fall in battle, yours will be a virtuous death!  You will be at his side when he rises!  You will share in his glory!',26124),
(40157,'enUS','And there is no hope!  There is no hope but in the loss of all hope.  That\'s right, brothers and sisters.  Only hopelessness can grant true hope!','And there is no hope!  There is no hope but in the loss of all hope.  That\'s right, brothers and sisters.  Only hopelessness can grant true hope!',26124),
(40158,'enUS','Yes, my fellow initiates.  The friend of my enemy\'s enemy... well he is also the enemy of my friend.  And yes... he shall perish too!','Yes, my fellow initiates.  The friend of my enemy\'s enemy... well he is also the enemy of my friend.  And yes... he shall perish too!',26124),
(40159,'enUS','And these incidents... these divisive acts of hate against other members of our organization.  They were cowardly and ugly, yes.  But maybe... they were NECESSARY!','And these incidents... these divisive acts of hate against other members of our organization.  They were cowardly and ugly, yes.  But maybe... they were NECESSARY!',26124),
(40160,'enUS','Look at how far we\'ve come!  Yesterday we lived in the shadows of civilization... hunted like rats!  But today!  Today... HYJAL BURNS!!!','Look at how far we\'ve come!  Yesterday we lived in the shadows of civilization... hunted like rats!  But today!  Today... HYJAL BURNS!!!',26124),
(40161,'enUS','And some will preach unity!  But does unity prevent a chain from breaking at its weakest link?','And some will preach unity!  But does unity prevent a chain from breaking at its weakest link?',26124),
(40162,'enUS','Do not think it is luck that brought you here.  Luck had nothing to do with it.  Our MASTERS\' WILL brought us here!','Do not think it is luck that brought you here.  Luck had nothing to do with it.  Our MASTERS\' WILL brought us here!',26124),
(40163,'enUS','I look upon the symbol that unites us.  This hammer.  It is the hammer that builds and creates.  But it is also the hammer that bludgeons and destroys!','I look upon the symbol that unites us.  This hammer.  It is the hammer that builds and creates.  But it is also the hammer that bludgeons and destroys!',26124),
(40164,'enUS','And to those who call for harmony among our ranks... to them I ask: \"Does not ALL strife please our masters?  Does not ALL bloodshed feed their thirst?\"','And to those who call for harmony among our ranks... to them I ask: \"Does not ALL strife please our masters?  Does not ALL bloodshed feed their thirst?\"',26124),
(40165,'enUS','','I be one of da first to answer Vol\'jin\'s call to arms. Will you be joinin\' us?',26124),
(40166,'enUS','Landro\'s Gift Box','Landro\'s Gift Box',26124),
(40167,'enUS','Instant Statue','Instant Statue',26124),
(40168,'enUS','Blazing Hippogryph','Blazing Hippogryph',26124),
(40169,'enUS','Paint Bomb','Paint Bomb',26124),
(40170,'enUS','Portal Stone','Portal Stone',26124),
(40171,'enUS','Rhino Mount','Rhino Mount',26124),
(40172,'enUS','Wrathgate','Wrathgate',26124),
(40173,'enUS','Icecrown','Icecrown',26124),
(40174,'enUS','I\'m not quite convinced.','I\'m not quite convinced.',26124),
(40175,'enUS','Meh.','Meh.',26124),
(40176,'enUS','*yawn*','*yawn*',26124),
(40177,'enUS','Yea... I don\'t know about this.','Yea... I don\'t know about this.',26124),
(40178,'enUS','Blood!','Blood!',26124),
(40179,'enUS','Death!','Death!',26124),
(40180,'enUS','Raaahhh!!!!','Raaahhh!!!!',26124),
(40181,'enUS','Kill!!!','Kill!!!',26124),
(40182,'enUS','Crush!','Crush!',26124),
(40183,'enUS','Kill them all!','Kill them all!',26124),
(40184,'enUS','I hear the voices!','I hear the voices!',26124),
(40185,'enUS','It\'s like... it\'s like the void just touched my mind.','It\'s like... it\'s like the void just touched my mind.',26124),
(40186,'enUS','Immalanath, yasoth nalarub!!!','Immalanath, yasoth nalarub!!!',26124),
(40187,'enUS','The end is nigh!  The end is a new beginning!','The end is nigh!  The end is a new beginning!',26124),
(40188,'enUS','This $gguy:girl; gets it!','This $gguy:girl; gets it!',26124),
(40189,'enUS','Tell it like it is, $g brother:sister;!','Tell it like it is, $g brother:sister;!',26124),
(40190,'enUS','$ndamus, you\'re a born leader!','$ndamus, you\'re a born leader!',26124),
(40191,'enUS','That\'s how it\'s done!  Yeah!','That\'s how it\'s done!  Yeah!',26124),
(40192,'enUS','It\'s like I\'m hearing the Old Gods themselves!','It\'s like I\'m hearing the Old Gods themselves!',26124),
(40193,'enUS','Truer words were never spoken!','Truer words were never spoken!',26124),
(40194,'enUS','History in the making!','History in the making!',26124),
(40195,'enUS','Who is this guy?','Who is this guy?',26124),
(40196,'enUS','Sit down!','Sit down!',26124),
(40197,'enUS','You lie!','You lie!',26124),
(40198,'enUS','Huh?','Huh?',26124),
(40199,'enUS','What are you talking about?','What are you talking about?',26124),
(40200,'enUS','','I\'d imagined my first adventure into the ocean as more peaceful and enlightening. Becoming one with nature perhaps?$B$BThere is very little natural about this place. The elements all around us scream for vengeance.',26124),
(40201,'enUS','Not all of you will ascend to glory. Look to your left. Look to your right. THEY will perish in the end times. But YOU will become immortal.','Not all of you will ascend to glory. Look to your left. Look to your right. THEY will perish in the end times. But YOU will become immortal.',26124),
(40202,'enUS','Eons ago, the \"Titans\" came and cast down our Masters. But this is NOT their world, and it never was! Judgment comes at last!','Eons ago, the \"Titans\" came and cast down our Masters. But this is NOT their world, and it never was! Judgment comes at last!',26124),
(40203,'enUS','But a bitter stench blows into our ranks. The answer is to purge! PURGE! Purge until the Twilight\'s Hammer is pure again!\n','But a bitter stench blows into our ranks. The answer is to purge! PURGE! Purge until the Twilight\'s Hammer is pure again!\n',26124),
(40204,'enUS','We walk the edge of a precipice. Some of us must be pushed over for the rest of us to continue.\n','We walk the edge of a precipice. Some of us must be pushed over for the rest of us to continue.',26124),
(40205,'enUS','But always remember that our movement cannot stay pure if some traitors among you still draw breath. You know who I mean.\n','But always remember that our movement cannot stay pure if some traitors among you still draw breath. You know who I mean.\n',26124),
(40206,'enUS','Place a palm across your heart and reach forward with your other hand to touch the infinite. Does it feel soft? NO! It feels... immense.  \n','Place a palm across your heart and reach forward with your other hand to touch the infinite. Does it feel soft? NO! It feels... immense.  \n',26124),
(40207,'enUS','The blood we shed speaks to us. It says  \"Thank you.\"','The blood we shed speaks to us. It says \"Thank you.\"\n',26124),
(40208,'enUS','If ya need a bat, ya come to da right place. I be handlin\' all de bats for de scouts.','',26124),
(40209,'enUS','YOU!$B$BYou think you can just waltz in here and take my spot? Think again, $g boy : girl;!$B$BI\'ve heard the whispering in the boardroom. The people you\'ve surrounded yourself with at headquarters are all boot-licking sycophants who will do anything to get ahead. I should know... I hired all of them.$B$BYour meteoric rise to power is a fluke, and I\'m fully prepared to knock you down a gear or two! Watch your step, $n. Who knows when you\'re going to need me on your side?','',26124),
(40210,'enUS','%s cackles in glee.','%s cackles in glee.',26124),
(40211,'enUS','Are you prepared for war, $r?','',26124),
(40212,'enUS','Take me to Sardor Island.','Take me to Sardor Island.',26124),
(40213,'enUS','Hey deres, boss.','',26124),
(40214,'enUS','Yous be careful. Trolls bad!','',26124),
(40215,'enUS','Why we not gets no Kaja\'Cola? We wants to have ideas!','',26124),
(40216,'enUS','We watch dem trolls real good!','',26124),
(40217,'enUS','Trolls been saying stuff, boss.','',26124),
(40218,'enUS','You wants us go bash bad trolls?','',26124),
(40219,'enUS','Dem trolls wanna fight?','',26124),
(40220,'enUS','How kaja\'mite rock made into Kaja\'Cola?','',26124),
(40221,'enUS','Vanira told me to speak to you about borrowing a bat.','Vanira told me to speak to you about borrowing a bat.',26124),
(40222,'enUS','I could really use a refill on my drink here.','I could really use a refill on my drink here.',26124),
(40223,'enUS','Ugh... I need a bucket!','Ugh... I need a bucket!',26124),
(40224,'enUS','If only I had someone to dance with.','If only I had someone to dance with.',26124),
(40225,'enUS','I love fireworks!','I love fireworks!',26124),
(40226,'enUS','This is delicious! Are there more hors d\'oeuvres?','This is delicious! Are there more hors d\'oeuvres?',26124),
(40227,'enUS','Your efforts force %s further out of the twilight realm!','',26124),
(40228,'enUS','Your efforts force %s further out of the physical realm!','',26124),
(40229,'enUS','Sampling Successful!','',26124),
(40230,'enUS','Sampling interrupted. Sambino products offers its sincere apologies. Please attempt sample extraction again at your soonest convenience.','',26124),
(40231,'enUS','Right, let\'s go! Just need to input the final entry sequence into the door mechanism... and...','',26124),
(40232,'enUS','That did the trick! The control room should be right behind this... oh... wow...','',26124),
(40233,'enUS','What? This isn\'t the control room! There\'s another entire defense mechanism in place, and the blasted Rock Troggs broke into here somehow. Troggs. Why did it have to be Troggs!','',26124),
(40234,'enUS','Ok, let me think a moment.','',26124),
(40235,'enUS','Four platforms with huge elementals.','',26124),
(40236,'enUS','I got it! I saw a tablet that mentioned this chamber. This is the Vault of Lights! Ok, simple enough. I need you adventurers to take out each of the four elementals to trigger the opening sequence for the far door!','',26124),
(40237,'enUS','Yep, destroy the four elementals, then the door will open. I\'m sure of it. Just watch out for the Troggs. Nasty tempered, filthy creatures, even if they have not succumbed to the Curse of Flesh.','',26124),
(40238,'enUS','I don\'t know about you, pal, but I can\'t breathe water.','',26124),
(40239,'enUS','|TInterface\\Icons\\inv_mace_15.blp:20|t%s equips his |cFFFF0000Mace|r and is |cFFFF0000|Hspell:75007|h[Encumbered]|h|r!','',26124),
(40240,'enUS','Mirrors pointing all over the place.','',26124),
(40241,'enUS','','All I need to prove myself here are my claws!',26124),
(40242,'enUS','What\'s with the hat?','What\'s with the hat?',26124),
(40243,'enUS','You\'re with the Earthen Ring, I just figured you\'d have a water breathing spell like the rest of them.','You\'re with the Earthen Ring, I just figured you\'d have a water breathing spell like the rest of them.',26124),
(40244,'enUS','Sign me up!','Sign me up!',26124),
(40245,'enUS','And miss out on wearing my awesome custom-made helmet? Not a chance.','',26124),
(40246,'enUS','Can I have an Earthbind Totem instead?','Can I have an Earthbind Totem instead?',26124),
(40247,'enUS','Can I have a Stoneclaw Totem instead?','Can I have a Stoneclaw Totem instead?',26124),
(40248,'enUS','Can I have a Strength of Earth Totem instead?','Can I have a Strength of Earth Totem instead?',26124),
(40249,'enUS','I\'d be glad to help.','I\'d be glad to help.',26124),
(40250,'enUS','Can I have an Earth Elemental Totem instead?','Can I have an Earth Elemental Totem instead?',26124),
(40251,'enUS','Anythin\' for Vol\'jin!','Anythin\' for Vol\'jin!',26124),
(40252,'enUS','Well you\'re a picky little $r, aren\'t you? Fine. Just go get me that sample.','Well you\'re a picky little $r, aren\'t you? Fine. Just go get me that sample.',26124),
(40253,'enUS','Just point me at de enemy!','Just point me at de enemy!',26124),
(40254,'enUS','No. Stop being greedy.','No. Stop being greedy.',26124),
(40255,'enUS','I\'m the bleeding edge, baby! Elemental infused technologies. Exploring the depths of Azeroth for lost knowledge and new resources.$B$BRemember the name.','',26124),
(40256,'enUS','Mussst ressissst....','',26124),
(40257,'enUS','Naga ssshall never ssserve your kind!','',26124),
(40258,'enUS','Better to die than to sssubmit...','',26124),
(40259,'enUS','You wassste your time with me, sssoftsskin!','',26124),
(40260,'enUS','Cannot... sstop!','',26124),
(40261,'enUS','','For Shandris!',26124),
(40262,'enUS','Move back!  His flames are too intense!','',26124),
(40263,'enUS','Ssso... assshamed...','',26124),
(40264,'enUS','Can I have a Stoneskin Totem instead?','Can I have a Stoneskin Totem instead?',26124),
(40265,'enUS','','A lot of work goes into training and caring for our animals, but it\'s all worth it.$B$BI could always use a bit of extra help, though.',26124),
(40266,'enUS','Slinky, I need a new mook disguise!','Slinky, I need a new mook disguise!',26124),
(40267,'enUS','Fall back!!!','',26124),
(40268,'enUS','','Sure thing, $n.',26124),
(40269,'enUS','Look out!','',26124),
(40270,'enUS','One down!','',26124),
(40271,'enUS','Another one down! Just look at those light beams! They seem to be connecting to the far door!','',26124),
(40272,'enUS','One more elemental to go! The door is almost open!','',26124),
(40273,'enUS','That\'s it, you\'ve done it! The vault door is opening! Now we can... oh, no!','',26124),
(40274,'enUS','Oh I\'m sorry... did my totem offend your delicate sensibilities? Fine. Here. Now get to work!','Oh I\'m sorry... did my totem offend your delicate sensibilities? Fine. Here. Now get to work!',26124),
(40275,'enUS','Jeeze... would you like me to have Felice give you a massage while you\'re at it? Here, take it. Go get me my sample!','Would you like me to have Felice give you a massage while you\'re at it? Here, take it. Go get me my sample!',26124),
(40276,'enUS','Wait a second... who\'s working for who here? If I give you the new totem, will you just finish the darn task?!','Wait a second... who\'s working for who here? If I give you the new totem, will you just finish the darn task?!',26124),
(40277,'enUS','This unit has been activated outside normal operating protocols. Downloading new operational parameters. Download complete. Full unit self defense routines are now active. Destruction of foreign units in the system shall now commence.','',26124),
(40278,'enUS','','The Trade Prince\'s yacht is about to set sail. Everyone, get to the dock! Hand over the keys, boss. I\'m driving. Just let me know when you\'re ready to go.',26124),
(40279,'enUS','New troll here!','New troll here!',26124),
(40280,'enUS','Reportin\' for duty.','Reportin\' for duty.',26124),
(40281,'enUS','Ready to take de fight to Zalazane.','Ready to take de fight to Zalazane.',26124),
(40282,'enUS','Ready to fight beside Vol\'jin!','Ready to fight beside Vol\'jin!',26124),
(40283,'enUS','When does de trainin\' start?','When does de trainin\' start?',26124),
(40284,'enUS','I\'m glad you are here, friend!$B$BThe fires have driven the wildlife to seek shelter in this grove. They can run no farther. We must protect the survivors!','',26124),
(40285,'enUS','Move back!','',26124),
(40286,'enUS','Here it comes, fall back!','',26124),
(40287,'enUS','Get away from him until the fire dies down!','',26124),
(40288,'enUS','','Lady Shandris is counting on me. I will not fail her.',26124),
(40289,'enUS','Heya, $g dude : toots;! The word is that you\'re gunning for the Trade Prince\'s job.$B$BThat true?','',26124),
(40290,'enUS','<Gobber mostly grunts. You\'re not even certain that he can talk.>','',26124),
(40291,'enUS','','Hiya, $g babe : hon;! What\'s this I hear about you and $g Candy : Chip;?',26124),
(40292,'enUS','','Nice day for digging up the last known deposits of kaja\'mite in the world, wouldn\'t you say, $n?',26124),
(40293,'enUS','','Isn\'t it weird how kaja\'mite made us smart thousands of years ago, but it doesn\'t seem to be having any effect on our trolls?',26124),
(40294,'enUS','','Distilling Kaja\'Cola out of kaja\'mite was a stroke of pure genius on your part, $n. The Trade Prince has got to be worried that you\'re going to take his title!',26124),
(40295,'enUS','Witness de power of me voodoo... you ain\'t leavin\' dis island ALIVE!','',26124),
(40296,'enUS','I\'d like to punch that Chip right in the kisser! I\'d also like to kiss that Candy right in the kisser, too!','',26124),
(40297,'enUS','Did someone say, party?','',26124),
(40298,'enUS','This Kaja\'Cola thing\'s got me thinking. Do we really want the competition to have ideas?','',26124),
(40299,'enUS','Distilling the juice out of kaja\'mite to make a delicious, carbonated beverage that will give people IDEAS! Hey, wait a minute...','Distilling the juice out of kaja\'mite to make a delicious, carbonated beverage that will give people IDEAS! Hey, wait a minute...',26124),
(40300,'enUS','We find evil ones now!  Follow!','',26124),
(40301,'enUS','They hide this way!  Quick!','',26124),
(40302,'enUS','We look for the evil ones now, yes?','',26124),
(40303,'enUS','Over here!  You must stop them!','',26124),
(40304,'enUS','You must fight now, $n!','',26124),
(40305,'enUS','Over here, $n!','',26124),
(40306,'enUS','Hey, hey! Cease your hostilities! I\'m one of those frequently encountered and completely harmless neutral goblins, not the Horde kind!','',26124),
(40307,'enUS','Hey look, it\'s $n. I bet $g he\'s : she\'s; loaded. I hear that $g he\'s : she\'s; going after the Trade Prince\'s job!','Hey look, it\'s $n. I bet $g he\'s : she\'s; loaded. I hear that $g he\'s : she\'s; going after the Trade Prince\'s job!',26124),
(40308,'enUS','Szabo. He\'s so hot right now!','Szabo. He\'s so hot right now!',26124),
(40309,'enUS','$n scoops up a squirming bear cub.','',26124),
(40310,'enUS','','I was once a priestess, but I\'ve always been a scholar. The chance to learn from the Highborne seemed more valuable than practicing strict ignorance.$B$BWhat\'s more most of the apprentices here are youths who came of age during the third war. They need guidance, wisdom...$B$BI only wish those who used to call me friend understood.',26124),
(40311,'enUS','','You\'re looking at me...can you see me?$B$BPlease, help...',26124),
(40312,'enUS','Work was bettah in da Undermine!','Work was bettah in da Undermine!',26124),
(40313,'enUS','What I doin\' wrong? Don\'t I get a lunch and two breaks a day, mon?','What I doin\' wrong? Don\'t I get a lunch and two breaks a day, mon?',26124),
(40314,'enUS','Ouch! Dat hurt!','Ouch! Dat hurt!',26124),
(40315,'enUS','I report you to HR!','I report you to HR!',26124),
(40316,'enUS','','Help... please, if you can hear me, help...',26124),
(40317,'enUS','','You\'ve been so nice, $n. I\'ve been trapped here so long thanks to Verinias. That young elf was the first soul I\'ve tasted in ages.',26124),
(40318,'enUS','','Even after I gifted him with that form, he insisted on keeping me trapped. He even hoarded all the souls just so I couldn\'t have any...so stubborn.',26124),
(40319,'enUS','','I owe you a favor, darling...someday I\'ll be back to repay it.',26124),
(40320,'enUS','','Dat be enough for now!',26124),
(40321,'enUS','','Don\'t be lookin\' so surprised. Your shaman friend has sharp eyes, or should I say, sharp frogs.',26124),
(40322,'enUS','','My kind, da druids, we been layin\' low for some time now. We been waitin\' to see when an\' if Vol\'jin might return.',26124),
(40323,'enUS','','Now dat it looks like de Darkspear be returnin\' to these isles, maybe de time has come for us to reveal ourselves.',26124),
(40324,'enUS','','Go back to Vol\'jin an\' tell him dis: Zen\'tabra stands ready to help him in de coming battle.',26124),
(40325,'enUS','It\'s all in ruins...','It\'s all in ruins...',26124),
(40326,'enUS','The waters rushed in and drowned everything!','The waters rushed in and drowned everything!',26124),
(40327,'enUS','You have to go to Thousand Needles and help. Please!','You have to go to Thousand Needles and help. Please!',26124),
(40328,'enUS','May the Earth Mother preserve us.','May the Earth Mother preserve us.',26124),
(40329,'enUS','Freewind Post is lost. Thousand Needles is destroyed.','Freewind Post is lost. Thousand Needles is destroyed.',26124),
(40330,'enUS','','Securing this area for the Sentinels will be the final part of our defense of Feralas.',26124),
(40331,'enUS','Why did the Earth Mother not protect us?','Why did the Earth Mother not protect us?',26124),
(40332,'enUS','Chieftain Spirithorn must send help to Freewind Post soon.','Chieftain Spirithorn must send help to Freewind Post soon.',26124),
(40333,'enUS','They\'re calling it the Cataclysm. What caused this destruction? Why us?','They\'re calling it the Cataclysm. What caused this destruction? Why us?',26124),
(40334,'enUS','','O spirit of de tigers, lend $n your power and help us find de answers we seek!',26124),
(40335,'enUS','The tiger matriarch appears! Prove yourself in combat!','',26124),
(40336,'enUS','','Brogg, I beseech you to send some of your goblins to Westreach Summit now, before it is too late.',26124),
(40337,'enUS','I think I\'ve lost a tabard.','I think I\'ve lost a tabard.',26124),
(40338,'enUS','','Thousand Needles lies in ruins under hundreds of feet of water. Can you spare any goblins to assist us?',26124),
(40339,'enUS','','The Cataclysm crumbled the eastern mountains. The South Seas poured in and submerged all of Thousand Needles! Can you aid us in our time of need?',26124),
(40340,'enUS','','Please. We are staging a relief effort at Westreach Summit. Thousand Needles has been decimated!',26124),
(40341,'enUS','','I understand that the Cataclysm has struck Dustwallow Marsh as well, but Mudsprocket appears relatively safe. Can you not spare any goblins?',26124),
(40342,'enUS','','If you cannot send any help to Westreach Summit, may we send refugees here?',26124),
(40343,'enUS','','I fear that if we do not receive reinforcements in Thousand Needles quickly, the Grimtotem will act. We are in no position to defend ourselves for very long.',26124),
(40344,'enUS','','If the Shu\'halo of Thousand Needles fall, the Grimtotem clan will be at your doorstep soon after. The time for action is now, Brogg!',26124),
(40345,'enUS','You must remain in the Echo Isles, Darkspear Strand, or Sen\'jin Village.','',26124),
(40346,'enUS','','Brogg. You don\'t mind me calling you that, right? Wait, which head am I talking to?',26124),
(40347,'enUS','','We need help from you and your goblins. Thousand Needles is destroyed! Thalanaar is underwater!',26124),
(40348,'enUS','','Which one of you is in charge? We need help at New Thalanaar now!',26124),
(40349,'enUS','','You must send us assistance in our time of need. An attack upon New Thalanaar is imminent!',26124),
(40350,'enUS','','Yes, we can pay.',26124),
(40351,'enUS','','You\'re not with the Gordok or Gordunni tribes, right?',26124),
(40352,'enUS','','The Cataclysm has struck hardest in Thousand Needles. Please, can you lend us your aid?',26124),
(40353,'enUS','','Bunnies and fawns? Yes, we have those. Will you now come and help us at New Thalanaar? Wait... why do you want to know?',26124),
(40354,'enUS','','The Cataclysm has destroyed the western mountains of Thousand Needles. The South Sea has rushed in and the canyons are flooded.$B$BPlease, $c, you must come to our aid at New Thalanaar!',26124),
(40355,'enUS','','The Cataclysm has destroyed Thousand Needles, $c. Will you help us in our greatest time of need?',26124),
(40356,'enUS','','Your training has progressed well, sisters. It won\'t be long before you lead your own people, with no further need of my teaching.',26124),
(40357,'enUS','He\'s vulnerable to our magic now! Hold him down!','He\'s vulnerable to our magic now!  Hold him down!',26124),
(40359,'enUS','','It is time for you to show me that leadership. Tambre, you will spearhead the offensive on Sardor Isle. Your ferocity will be needed there.',26124),
(40360,'enUS','','Silvia, I\'m sending you to the Tower of Estulan to drive out the Gordunni ogres. Your diplomacy and strategy will both be put to the test.',26124),
(40361,'enUS','','Adella, you will strike out far to the east. Our forces must retake the eastern wilds, and observe the Horde unseen. May your judgment be as keen as your marksmanship.',26124),
(40362,'enUS','Dyslix, I need to get to Westreach Summit!','Dyslix, I need to get to Westreach Summit!',26124),
(40363,'enUS','','I expect much of you. Do not fail me. Dismissed!',26124),
(40364,'enUS','Dyslix, I need to get to New Thalanaar!','Dyslix, I need to get to New Thalanaar!',26124),
(40365,'enUS','Hm? You found something, boy?','',26124),
(40366,'enUS','That\'s right, dig it up. Leave no living thing behind!','',26124),
(40367,'enUS','What did you find, pig?','',26124),
(40368,'enUS','Thata girl! Dig it all up - leave no stone unturned.','',26124),
(40369,'enUS','Stupid pig. This ground is already dead. Move on!','',26124),
(40370,'enUS','Dig, dig, dig. Burn, burn, burn. Scour this earth clean!','',26124),
(40371,'enUS','The %s sniffs and digs into the scorched soil.','',26124),
(40372,'enUS','Seyala, I need to get to New Thalanaar!','Seyala, I need to get to New Thalanaar!',26124),
(40373,'enUS','Adeline, can you not ask any of your friends to come help us at New Thalanaar?','',26124),
(40374,'enUS','Thousand Needles has been swallowed by the South Sea. Thalanaar is submerged!','',26124),
(40375,'enUS','The eastern mountains of Thousand Needles crumbled into the waters and the South Sea poured in. All is lost.','',26124),
(40376,'enUS','Test','',26124),
(40377,'enUS','The Cataclysm has destroyed Thousand Needles. We need your help so that we can save as many lives as possible!','',26124),
(40378,'enUS','Now is the time to prove your allegiance to the Alliance. Please send whatever aid you can to New Thalanaar.','',26124),
(40379,'enUS','We have lost Thalanaar, but not by much. We were the fortunate ones to be only at the very edge of the flooding. I cannot begin to imagine how many lives were lost. Please send as much help as you can to New Thalanaar.','',26124),
(40380,'enUS','Relatively speaking, Feralas has barely been touched by the Cataclysm. Surely you can send some aid to New Thalanaar?','',26124),
(40381,'enUS','We\'re staging a relief effort at New Thalanaar for all of the survivors of Thousand Needles. We need your help now!','',26124),
(40382,'enUS','Enough! Have your cave, little shaman.','',26124),
(40383,'enUS','$C, the cataclysm has crumbled the mountains and the South Sea has rushed in to drown Thousand Needles.$B$BWe need your help, now!','',26124),
(40384,'enUS','May de spirits guide ya, $c.','',26124),
(40385,'enUS','Let us consult the omens.','Let us consult the omens.',26124),
(40386,'enUS','','The Grimtotem attacked us by surprise. We\'re barely hanging on here.',26124),
(40387,'enUS','Darkspears, we consult de spirits! Drummers, take your places!','',26124),
(40388,'enUS','Spirits, we be gathered here to ask for your guidance.','',26124),
(40389,'enUS','Our leader, Vol\'jin, son of Sen\'jin, issued de call to all Darkspears: reclaim de Echo Isles for our tribe.','',26124),
(40390,'enUS','Spirits! I offer me own body to you! Speak through me! Is de time right for mighty Vol\'jin\'s undertaking?','',26124),
(40391,'enUS','De ancestors hear ya, witch doctor!','',26124),
(40392,'enUS','Know dat your plans please us, Darkspears. De son of Sen\'jin walks de right path.','',26124),
(40393,'enUS','De task in front of ya will not be easy, but ya have our blessin\'.','',26124),
(40394,'enUS','Ya gave up your home an\' ya gave up de loas of your ancestors when ya left de Echo Isles. Dey will not be pleased dat you been ignorin\' dem.','',26124),
(40395,'enUS','Ya must make amends wit\' Bwonsamdi, de guardian of de dead, if ya hope to defeat Zalazane. It be de only way. Tell de son of Sen\'jin dese things.','',26124),
(40396,'enUS','De spirits have blessed us wit\' an answer! De Echo Isles will be ours again!','',26124),
(40397,'enUS','I will not die to save your hide, Twilight dude!','',26124),
(40398,'enUS','How could the Grimtotem do this to us in our greatest time of need?','',26124),
(40399,'enUS','Motega, can I get another Water Explorer?','Motega, can I get another Water Explorer?',26124),
(40400,'enUS','Look at this devastation, $c! Blood and ash, as far as the eye can see.$B$BBut nature is not so easily put down. With some effort, we may yet coax life from this scorched soil.','',26124),
(40401,'enUS','','I thought Runetotem reckless to set up camp right in the middle of this devastation, but I wasn\'t about to let the Archdruid travel here alone.$B$BHe\'s planning something. Something big.',26124),
(40402,'enUS','','These Grimtotem beasts will soon be sent to their maker!',26124),
(40403,'enUS','Rendow, can I get a ride with another Water Traveler?','Rendow, can I get a ride with another Water Traveler?',26124),
(40404,'enUS','Warriors of de Darkspear Tribe, our leader, de great Vol\'jin prepares to reclaim de Echo Isles.','',26124),
(40405,'enUS','De battle ahead will be de true test of de warrior\'s skill, de true test of loyalty.','',26124),
(40406,'enUS','We be gatherin\' here, on de shores of Sen\'jin Village, to be takin\' BACK what is ours!','',26124),
(40407,'enUS',' Come, now! Join in de liberation of de Echo Isles! Zalazane will FALL!','',26124),
(40408,'enUS','De spirits of our ancestors will be watchin\' us and aidin\' us in dis battle.','',26124),
(40409,'enUS','Do dem proud! Show dem your bravery and your ferocity! Bring honor to their spirits!','',26124),
(40410,'enUS','An\' most of all, we be showin\' Zalazane dat his time be at an end! Dat he will give back what be rightfully ours!','',26124),
(40411,'enUS','Zalazane got most of his hexed trolls hidden under de canopy on de big island.','Zalazane got most of his hexed trolls hidden under de canopy on de big island.',26124),
(40412,'enUS','He got a big army, an\' he be plannin\' somethin\' down dere.','He got a big army, an\' he be plannin\' somethin\' down dere.',26124),
(40413,'enUS','Thank ya, scout. Keep up da patrols. But for now, a rest is in order. Dismissed.','',26124),
(40414,'enUS','My raptor can take on ANYTHING and ANYONE!','',26124),
(40415,'enUS','You!  Your mutt killed my Butcher!  I will crush you!','',26124),
(40416,'enUS','Instructor Devoran sends a contender against your raptor.','Instructor Devoran sends a contender against your raptor.',26124),
(40417,'enUS','Run away from the Blazing Trainer!','',26124),
(40418,'enUS','I have sometin\' to show you. It be easier to understand if ya see it yourself.','',26124),
(40419,'enUS','What do you want, Vol\'jin? I\'m busy planning a war.','',26124),
(40420,'enUS','%s rallies the other combatants with a battle roar!','',26124),
(40421,'enUS','I\'m tellin\' you, that Coren Direbrew\'s a madman.\n\nIt\'s not MY fault he didn\'t get invited to compete at Brewfest! But that didn\'t stop him and all his Dark Iron cronies from roughin\' up my employees and drinking all my brew.\n\nSomeone\'s got to put an end to this!','',26124),
(40422,'enUS','Queue for the Coren Direbrew battle.','Queue for the Coren Direbrew battle.',26124),
(40424,'enUS','','The Frost Lord, Ahune, must be stopped.\n\nEven now he is taking form, summoned from his elemental prison by the mad cultists of the Twilight\'s Hammer.\n\nIf he\'s allowed to enter our world completely, he\'ll bury us beneath an eternal winter.',26124),
(40425,'enUS','Queue for The Frost Lord Ahune battle.','Queue for The Frost Lord Ahune battle.',26124),
(40426,'enUS','Please... help...\n\nThe Headless Horseman... must be stopped...\n\nHe has slain so many... and yet rides out for more victims with every rising moon!','',26124),
(40427,'enUS','Queue for The Headless Horseman battle.','Queue for The Headless Horseman battle.',26124),
(40428,'enUS','Someone\'s got to stop the Crown Chemical Co. I\'d bet my gold-plated Nether-Rocket they\'re cooking up the next big plague on the chocolate-crazed citizenry\'s coin...\n\nIf only I could find someone to serve their apothecaries with court papers! Then we could put an end to it... and maybe seize all their assets, while we\'re at it!','',26124),
(40429,'enUS','Queue for The Crown Chemical Co. battle.','Queue for The Crown Chemical Co. battle.',26124),
(40430,'enUS','Ye\'ve got some stones, $glad:lass;, comin\' in here unannounced.\n\nWhat do ye want?','',26124),
(40431,'enUS','Insult Coren Direbrew\'s brew.','Insult Coren Direbrew\'s brew.',26124),
(40432,'enUS','What?!  What did ye say?!  How dare ye!  Me beer can stand up to any of that rot they serve at Brewfest!\n\nYou\'ll pay for this insult, $c!','',26124),
(40433,'enUS','Fight.','Fight.',26124),
(40434,'enUS','Apologize.','Apologize.',26124),
(40435,'enUS','I need to get to Razor Hill to recruit on behalf of Vol\'jin.  May I borrow a bat?','I need to get to Razor Hill to recruit on behalf of Vol\'jin.  May I borrow a bat?',26124),
(40436,'enUS','I am ready to take back the Echo Isles.  Take me to the staging area!','I am ready to take back the Echo Isles.  Take me to the staging area!',26124),
(40437,'enUS','How DARE you! You will not stop the coming of Lord Ahune!','',26124),
(40438,'enUS','The Frostlord... will... destroy you...','',26124),
(40439,'enUS','This is going to be fascinating!','This is going to be fascinating!',26124),
(40441,'enUS','Welcome to Tinker Town!','',26124),
(40442,'enUS','This shard of ice echoes the deep, cracking rumble of invading glaciers.  Its cold turns your thoughts to a lifeless, endless winter.','',26124),
(40443,'enUS','Disturb the stone and summon Lord Ahune.','Disturb the stone and summon Lord Ahune.',26124),
(40444,'enUS','Vol\'jin kneels at the skull pile and begins a chant.','',26124),
(40445,'enUS','Would you call down the Spirit of the Tiger again, Vanira?','Would you call down the Spirit of the Tiger again, Vanira?',26124),
(40446,'enUS','Defend the flameward!','',26124),
(40447,'enUS','Victory! The flameward has been defended.','',26124),
(40448,'enUS','Zalazane\'s time be runnin\' out. De Echo Isles will belong to de Darkspear Tribe again!','',26124),
(40449,'enUS','De Darkspears have a home again! An\' we couldn\'t have done it wit\'out ya helpin\', $n. Now, we celebrate!','',26124),
(40450,'enUS','Dis breach leads to tha plane of water. Tha realm of Neptulon, tha Tidehunter.','',26124),
(40451,'enUS','Tha naga and de Twilight Cult be workin\' together, and dis be the focus of dey\'re efforts.','',26124),
(40452,'enUS','Disturbin\' prospects. And there be little we can be doin\' about it witout more men.','',26124),
(40453,'enUS','','Fizzle & Pozzik\'s Speedbarge my sweet patootie! I built this thing! Not them, not Razzeric!$B$BIt should be called Jinky\'s Speedbarge!',26124),
(40454,'enUS','De warriors are finishin\' de job of clearin\' up de rest of Zalazane\'s creations.','De warriors are finishin\' de job of clearin\' up de rest of Zalazane\'s creations.',26124),
(40455,'enUS','Ya should be able to send in de builders anytime now. Dere be a lot of work ahead of dem.','Ya should be able to send in de builders anytime now. Dere be a lot of work ahead of dem.',26124),
(40456,'enUS','Thank ya, scout. Tell de builders dey be needed on de isles. De Darkspears be home again!','',26124),
(40457,'enUS','Warriors of de Darkspear tribe, Vol\'jin, son of Sen\'jin has led us to victory!','',26124),
(40458,'enUS','De bravery and de skill of our warriors be plain for all to see!','',26124),
(40459,'enUS','De ancestors watched your actions wit\' pride, my brothers!','',26124),
(40460,'enUS','Thanks be to de ancestors! Thanks be to de great Bwonsamdi! We all be makin\' offerings in gratitude!','',26124),
(40461,'enUS','Let us not forget de help of our allies, of de members of de Horde who came to help us! Now is de time to be celebratin\' dis great victory together!','',26124),
(40462,'enUS','','It\'s my job to ensure that this whole assault runs like clockwork.$B$BHigh Tinker Mekkatorque is out in the field now, but he\'s scheduled to come back to get some more troops any time now.  $B$BHe\'s never late, so just stick around and he\'ll be here.',26124),
(40463,'enUS','','Okay! We\'re running a little behind, but the assaut is SCHEDULED to start in $5071W minutes.$B$BI mean, everything looks ready to go, and the Gyrocopters, Mechanotanks and Infantry are all here.$B$BIt looks like Mekkatorque is waiting on a few more things before the assault begins.  Let\'s hope we start on time or I may lose my job!',26124),
(40464,'enUS','|TInterface\\Icons\\ability_druid_infectedwound.blp:20|t%s rears back for a |cFF01FFE1Shredding Swipe!|r\n','',26124),
(40465,'enUS','|TInterface\\Icons\\spell_fire_elemental_totem.blp:20|t%s Summons an |cFFFF6F00|Hspell:75218|h[Invocation of Flame]|h|r!','',26124),
(40466,'enUS','','Hurry! You should talk to Mekkatorque! If we don\'t start the assault soon, we\'re going to be late.$B$BAnd my boss HATES it when we\'re late!',26124),
(40467,'enUS','Defeat! The flameward has been destroyed.','',26124),
(40468,'enUS','|cFFFF2222Bloodthirsty Shark goes into a feeding frenzy!|r','',26124),
(40469,'enUS','Fizzle, Pozzik, Jinky... they all think that they saved us. But it was me! I built the ship!$B$BIt should be called, Razzeric\'s Speedbarge!','',26124),
(40470,'enUS','What?  I\'ll show that pipsqueak!','',26124),
(40471,'enUS','Vol\'jin told me ta keep hittin\' da drum till he gets back.  If ya be waitin\' for him, he\'d be back soon to take back da Isles.$B$BJust wait here and enjoy da music!','',26124),
(40472,'enUS','Vol\'jin be waitin for ya.  You should talk wit him now, my arms are gettin\' tired.$B$BDis echo isle attack betta be startin\' soon. ','',26124),
(40473,'enUS','Where?!  Where is he?','',26124),
(40474,'enUS','Curses!  Who killed the human!?  This is not good!','',26124),
(40475,'enUS','De Echo Isles attack be startin\' soon!$B$BSit back and relax, dis song will be over in anotha $5071W minutes and then we\'d be going.','',26124),
(40476,'enUS','Without pressure in both realms, %s begins to regenerate.','',26124),
(40477,'enUS','With Cho\'gall\'s leadership and unity among our ranks we will crush all our enemies!','',26124),
(40478,'enUS','|cFFFF2222Fire Harpoon Gun!|r','',26124),
(40479,'enUS','What\'s going on here?','What\'s going on here?',26124),
(40480,'enUS','How do we do that?','How do we do that?',26124),
(40481,'enUS','We\'d be gettin\' ready to take back da Echo Isles. Zalazane has been workin\' his voodoo magic for some time, convincing folks dat he be dead and performing ancient dark rituals.$B$BHe knows we\'d be coming, so we have ta make sure we be prepared.','',26124),
(40482,'enUS','We require da help of allies on da islands.$B$BZen\'tabra has been watching over da animals of de Islands for some time now.  We\'d need her help and da help of da animal creatures.$B$BBwonsamdi is a powerful loa dat controls de spirits of de dead on da islands.  His blessing is crucial for our attack.$B$BOnce our allies have joined us, Zalazane and his army of mind-controlled trolls will have no chance!  Then, da Echo Isles will be de Darkspears!','',26124),
(40483,'enUS','%s is distracted by the odor of fresh meat.','',26124),
(40484,'enUS','Stand still! Rom\'ogg crack your skulls!','',26124),
(40485,'enUS','These are definitely the ones that raided our boats, but I don\'t see any of our missing people. Where did they take them?','',26124),
(40486,'enUS','$n!','$n!',26124),
(40487,'enUS','BAR FIGHT!','BAR FIGHT!',26124),
(40488,'enUS','$n!','$n!',26124),
(40489,'enUS','Thank ya for aidin\' us in our battle.','Thank ya for aidin\' us in our battle.',26124),
(40490,'enUS','Wit\'out your help, ancestors, we would still be fearin\' Zalazane.','Wit\'out your help, ancestors, we would still be fearin\' Zalazane.',26124),
(40491,'enUS','May de spirits of de dead continue to watch over us.','May de spirits of de dead continue to watch over us.',26124),
(40492,'enUS','Thank ya for your guidance, spirits.','Thank ya for your guidance, spirits.',26124),
(40493,'enUS','Guide dose who died in dis battle, Bwonsamdi.','Guide dose who died in dis battle, Bwonsamdi.',26124),
(40494,'enUS','It is a poor offerin\' but I be givin\' it in thanks for your help.','It is a poor offerin\' but I be givin\' it in thanks for your help.',26124),
(40495,'enUS','Ah, so you\'ve left your hole?  The Lady will claim you soon enough.','',26124),
(40496,'enUS','I\'d appreciate if someone started to take my work seriously. Just because I\'m not wrestling sharks or tying eels in knots doesn\'t mean this isn\'t important.','',26124),
(40497,'enUS','','Break it up! The Brute Squad is coming!',26124),
(40498,'enUS','%s roars in fury!','',26124),
(40499,'enUS','%s is angry - run for it!','',26124),
(40500,'enUS','<The ancient\'s eyes are vast and deep.>$B$B<The creature speaks slowly, in a language you do not understand. Chills run up your spine. You\'re overwhelmed with feelings of terror and confusion.>','',26124),
(40501,'enUS','<The ancient\'s eyes open slowly, revealing deep pools of pain and fear.>','',26124),
(40502,'enUS','','Hey, come on in out of the sun.$B$BCan I get you a drink? Not like I have anything else to do around here.',26124),
(40503,'enUS','Good work!\n','Good work!\n',26124),
(40504,'enUS','Good!\n','Good!\n',26124),
(40505,'enUS','Excellent!\n','Excellent!\n',26124),
(40506,'enUS','Unshakable!\n','Unshakable!\n',26124),
(40507,'enUS','Smooth moves!\n','Smooth moves!\n',26124),
(40508,'enUS','Redeem Battleground Marks for Honor.','Redeem Battleground Marks for Honor.',26124),
(40509,'enUS','Disabling','Disabling',26124),
(40510,'enUS','No - No! This one is ours...','',26124),
(40511,'enUS','The master\'s grasp is not so easily severed...','',26124),
(40512,'enUS','Wretched... bag of ... flesh!','',26124),
(40513,'enUS','Mortal! You overreach.','',26124),
(40514,'enUS','The master will not suffer this insult!','',26124),
(40515,'enUS','<The ancient\'s enormous dark eyes peer at you distrustfully.>','',26124),
(40516,'enUS','If you ask me, I think my brother should do something about all of these goblins! It\'s said that one of them set off the Cataclysm with a footbomb!$B$BWe need to get rid of all of them before it\'s really too late!','',26124),
(40517,'enUS','Jinky, can I get another Speedbarge Diving Helm?','Jinky, can I get another Speedbarge Diving Helm?',26124),
(40518,'enUS','','Oh yeah, I got a million spares just hanging around.',26124),
(40519,'enUS','Have you seen my river boat? I can\'t find it anywhere!','Have you seen my river boat? I can\'t find it anywhere!',26124),
(40520,'enUS','Sure thing, $g pal : gal;!','',26124),
(40521,'enUS','We wouldn\'t be in this mess if it weren\'t for the gnomes!$B$BIt\'s a well-known fact that they were the ones that caused the Cataclysm with all of their world-enlarging devices, and other such nonsense!','',26124),
(40522,'enUS','Mama?','',26124),
(40523,'enUS','It\'s all I can do to keep this ship from tearing itself apart and I still have to deal with puffed up baffoons like Fizzle here!','',26124),
(40524,'enUS','I tell ya this guy\'s driving me nuts! Does anyone truly believe that a goblin could help run anything so magnificent as this speedbarge?$B$BAll they know how to do is blow stuff up and half of the time, they take themselves out doing even that!','',26124),
(40525,'enUS','Monsters! Monsters come to take our gold!','Monsters! Monsters come to take our gold!',26124),
(40526,'enUS','Where did we land that has such hideous creatures?!','Where did we land that has such hideous creatures?!',26124),
(40527,'enUS','Aaaaaaaaaahhh! AAAAAAAAAAAHHHHHH!!','Aaaaaaaaaahhh! AAAAAAAAAAAHHHHHH!!',26124),
(40528,'enUS','Kill the pig! Spill its blood!!','Kill the pig! Spill its blood!!',26124),
(40529,'enUS','Protect the wise one! Protect Meatface!','Protect the wise one! Protect Meatface!',26124),
(40530,'enUS','You\'ll never take me alive!','You\'ll never take me alive!',26124),
(40531,'enUS','You must remain inside Darkwhisper Gorge and its surrounding areas!','',26124),
(40535,'enUS','You are straying from the events of the past. Turn around immediately.','You are straying from the events of the past. Turn around immediately.',26124),
(40536,'enUS','','The paperwork\'s ready for you to sign, Marin. My people are just waiting on your decision.',26124),
(40537,'enUS','','Gosh, Mr. Noggenfogger, I know you wouldn\'t want to damage your reputation as a neutral trade entity by forming closer ties to the Horde!',26124),
(40538,'enUS','','This is laughable. You know what it\'s like trying to do business with gnomes.',26124),
(40539,'enUS','','Oh, oh, I know this one! It\'s better than doing business with failed goblins that had to beg others for help!',26124),
(40540,'enUS','','Why you little irradiated...',26124),
(40541,'enUS','AGH! Enough! You two are driving me INSANE! Start getting some freakin\' work done around here or get the heck out of my town!','',26124),
(40542,'enUS','Stop, thief!','Stop, thief!',26124),
(40543,'enUS','Ah, $n! A little bird told me you would be coming.$B$BThat\'s how Aviana sends messages around.','',26124),
(40544,'enUS','Smoke and ash. If the heat doesn\'t kill me, I may suffocate.','',26124),
(40545,'enUS','Harken, cur! Tis you I spurn! Now feel... the burn!','',26124),
(40546,'enUS','Your body lies beaten, battered and broken! Let my curse be your own, fate has spoken!','',26124),
(40547,'enUS','I owe you a debt that I can never repay, $n. Or, can\'t I?$B$BHmm?','',26124),
(40548,'enUS','Listen, $n, I hate being indebted to anyone. So can you make sure to keep this on the down-low, just between the two of us?$B$BI\'d hate for my creditors to find out.','',26124),
(40549,'enUS','The drag master escapes from the outhouse and gestures wildly up at the speedbarge.','',26124),
(40550,'enUS','Rugfizzle escapes from the outhouse and gestures wildly up at the speedbarge.','',26124),
(40551,'enUS','To the depths with you, beast!','',26124),
(40552,'enUS','What you want, $r?','',26124),
(40553,'enUS','Yeah?  What\'s the matter?','',26124),
(40554,'enUS','Boss, one of the boys is causing some trouble outside.','Boss, one of the boys is causing some trouble outside.',26124),
(40555,'enUS','I\'ve got a bad feeling about this.','',26124),
(40556,'enUS','Hold on, $r!','',26124),
(40557,'enUS','Press Flap to Flap Your Wings!','',26124),
(40558,'enUS','Wave One:','',26124),
(40559,'enUS','Prepare to Joust, Buzzard Bait!','',26124),
(40560,'enUS','Load those cannons, ye wretches!','',26124),
(40561,'enUS','If any of you dogs stops for so much as to scratch your nose, I\'ll take off the hand you did it with!','',26124),
(40562,'enUS','Move it! MOVE IT!','',26124),
(40563,'enUS','You rats call that cannoneering? You make me sick!','',26124),
(40564,'enUS','You scurvy dogs make yourselves useful! KEEP FIRING!','',26124),
(40565,'enUS','','Gus... you gotta... get me one of them gnome medics...',26124),
(40566,'enUS','Chelsea, baby, that\'s crazy talk! You\'re delirious! Just hold on a while longer...','',26124),
(40567,'enUS','','There you go, Mister Noggenfogger! You won\'t have to worry about those giants anymore!',26124),
(40568,'enUS','That\'s actually a load off my plate. Thanks, kid.','',26124),
(40569,'enUS','','Tch. Amateurs.',26124),
(40570,'enUS','','See, Marin? We\'ve got you covered, babe. No sweat.',26124),
(40571,'enUS','I must admit I like what I\'m seeing, Ms. Dreadshredder.','',26124),
(40572,'enUS','','Gosh, Miss Megs, maybe next time you can actually do some work!',26124),
(40573,'enUS','That be property \'o the Southsea Freebooters now, landlubber!','',26124),
(40574,'enUS','Ye\'ll not get around our blockade with scavengin\'!','',26124),
(40575,'enUS','The Southsea Freebooters own this shore!','',26124),
(40576,'enUS','Thank you, $r.$b$bYou saved me from certain death.','',26124),
(40577,'enUS','Did you see the size of that thing!?','',26124),
(40578,'enUS','I owe you, $c.$b$bThought I was a gonner.','',26124),
(40579,'enUS','How are we going to get out of here?','',26124),
(40580,'enUS','If it\'s my time to die, I\'m going to go down swinging!','',26124),
(40581,'enUS','It\'s just a matter of time before the naga find us here.$b$bWhat will we fight them with?','',26124),
(40582,'enUS','It\'s a good thing the captain made it through. He\'ll know how to get us out of this mess.','',26124),
(40583,'enUS','RAAAAAAAAAAHHHHHHGGGGHHH!!','',26124),
(40584,'enUS','Meat! MEAT! Hahahahaha!','',26124),
(40585,'enUS','So much blood!','',26124),
(40586,'enUS','I am GIANT!','',26124),
(40587,'enUS','We must get the parts Driz wants. THE REST IS OURS!','',26124),
(40588,'enUS','The red thing\'s connected to the... squiggly thing... the squiggly thing\'s connected to my... wristband...','',26124),
(40589,'enUS','How exhilirating!','',26124),
(40590,'enUS','How exhilirating!','',26124),
(40591,'enUS','You will find a pair of draenei conversing with Elissa Dumas - the human mage who minds the magical portals - on the ground floor of The Temple of the Moon.$B$BThey will know how to help you.','You will find a pair of draenei conversing with Elissa Dumas - the human mage who minds the magical portals - on the ground floor of The Temple of the Moon.$B$BThey will know how to help you.',26124),
(40592,'enUS','Bring on the naga! I\'m hungry for battle!','',26124),
(40593,'enUS','At least now we have a fighting chance, thanks to you.','',26124),
(40594,'enUS','I may fall, but I\'ll take a dozen of those beasts with me!','',26124),
(40595,'enUS','Time for revenge!','',26124),
(40596,'enUS','You\'ve done well, $c.$b$bMy men and I are now prepared to face the enemy.','',26124),
(40597,'enUS','The naga must pay for what they\'ve done here!','',26124),
(40598,'enUS','','Help! I am trapped within this tree!  I require aid!',26124),
(40599,'enUS','','Thank you! I could not have held out for much longer.... A terrible thing has happened here.',26124),
(40600,'enUS','','We believed the Sanctum was well-fortified, but we were not prepared for the nature of this assault.',26124),
(40601,'enUS','','The Black dragonkin materialized from thin air, and set upon us before we could react.',26124),
(40602,'enUS','','We did not stand a chance. As my brethren perished around me, I managed to retreat here and bar the entrance.',26124),
(40603,'enUS','','They slaughtered us with cold efficiency, but the true focus of their interest seemed to be the eggs kept here in the Sanctum.',26124),
(40604,'enUS','','The commander of the forces on the ground here is a cruel brute named Zarithrian, but I fear there are greater powers at work.',26124),
(40605,'enUS','','In their initial assault, I caught a glimpse of their true leader, a fearsome full-grown twilight dragon.',26124),
(40606,'enUS','','I know not the extent of their plans, heroes, but I know this:  They cannot be allowed to succeed!',26124),
(40607,'enUS','I sssaw you leaving that ssship, sssoftsskin! Sssoon we sshall have you all!','',26124),
(40608,'enUS','Captain! The naga! They\'ve followed $n back to the ship!','',26124),
(40609,'enUS','|TInterface\\Icons\\spell_shadow_shadowfury.blp:20|t%s begins to cast |cFFA043E7|Hspell:75694|h[Shadow Gale]|h|r!','',26124),
(40610,'enUS','|TInterface\\Icons\\spell_shadow_sacrificialshield.blp:20|t%s begins to cast |cFF006EFD|Hspell:75809|h[Shield of Nightmares]|h|r on the |cFF006EFDFaceless Corruptor!|r','',26124),
(40611,'enUS','Sssoftsskinss! Sssoon you shall ssserve my Lady!','',26124),
(40612,'enUS','Come, suffering... enter, chaos!','',26124),
(40613,'enUS','%s begins to cast |cFFFF0000Oblivion!|r','',26124),
(40614,'enUS','Your power wanes, ancient one.... Soon you will join your friends.','',26124),
(40616,'enUS','Die, beast!','',26124),
(40617,'enUS','We be meetin\' again so soon...','',26124),
(40618,'enUS','We\'ve been discovered... Hurry $n, there\'s little time!','',26124),
(40619,'enUS','','You always secretly thought I looked fat!',26124),
(40620,'enUS','','I spent most of your money on getting a decent massage, goodness knows you could never do it right!',26124),
(40621,'enUS','','You never tried to get anywhere. I\'m so glad I finally found a real goblin who can satisfy my shopping needs.',26124),
(40622,'enUS','You gotta help me! My poor, poor Chelsea...','',26124),
(40623,'enUS','','I\'ve met cabin boys who were manlier than you. To think I ever wasted my time...',26124),
(40624,'enUS','','You told him I was fat behind my back, didn\'t you?!',26124),
(40625,'enUS','','You\'re just jealous I found a man with skills AND a fat wallet.',26124),
(40626,'enUS','','You can never replace me. Chip will never stoop to dating someone who makes a brute look attractive!',26124),
(40627,'enUS','','How can you even go OUT like that? What, did you just wash up on a beach somewhere?!',26124),
(40628,'enUS','To battle, men!','',26124),
(40629,'enUS','The lasher is not fit for mortal hands!','',26124),
(40630,'enUS','For Stormwind!','',26124),
(40631,'enUS','Here we go, this should do it.','',26124),
(40632,'enUS','Chelsea, baby, please drink this. It\'ll make you feel better.','',26124),
(40633,'enUS','','Hmm? Okay...',26124),
(40634,'enUS','','What is this? Tastes kinda... urrrrrgh... I\'m gonna lay back down now.',26124),
(40635,'enUS','Chelsea, baby, sit up! I\'ve got it! This is gonna cure you!','',26124),
(40636,'enUS','','Urgh. Gus, I ain\'t drinking that, I can smell it from here. Just lemme sleep the food poisoning off, okay?',26124),
(40637,'enUS','...food poisoning? Wait, you mean those basilisk steaks? That\'s all it is?','',26124),
(40638,'enUS','Nothing, honey. I\'m just glad you\'re okay...','',26124),
(40639,'enUS','','Blech! Don\'t even say it. Of course it was, those were so undercooked...what\'d you think poisoned me?',26124),
(40640,'enUS','Reinforce the front! We are being invaded!','',26124),
(40641,'enUS','Alright i\'m sweating now, Twilight\'s Hammer get in here and defend me!','',26124),
(40642,'enUS','Cover the rear! Alexstrasza\'s brood decimate our ranks!','',26124),
(40643,'enUS','On second thought, Drahga may need help after all! Fall in!','',26124),
(40644,'enUS','You\'re going to put out the fires and stop those pirates from boarding us, right?','',26124),
(40645,'enUS','Get me into my boat, Griznak.','Get me into my boat, Griznak.',26124),
(40646,'enUS','Oh gosh! Oh golly! You\'re gonna put out the fires and stop those pirates from getting on the Speedbarge, right?!!','',26124),
(40647,'enUS','Get me into my boat, Mazzer.','Get me into my boat, Mazzer.',26124),
(40648,'enUS','That was a close one, $n.','',26124),
(40649,'enUS','Hi there! Welcome to Fizzle & Pozzik\'s Speedbarge.$B$BWe have everything there is under the sky and over the deeps.','',26124),
(40650,'enUS','Pirates and centaurs and Grimtotem, oh my!$B$BAnd I think I saw something big fly overhead last night. It was so big it blocked out the moon!','',26124),
(40651,'enUS','Don\'t worry - I\'ve got you.','',26124),
(40652,'enUS','Be more careful out there, $n!','',26124),
(40653,'enUS','Welcome to Fizzle & Pozzik\'s Speedbarge. You\'ll find just about anything you\'re looking for here.','',26124),
(40654,'enUS','It\'s okay $n - you\'re safe now.','',26124),
(40655,'enUS','Caught you in the nick of time, $n!','',26124),
(40656,'enUS','We may be surrounded by all sorts of nasties here, but at least we\'re out over the open water.$B$BThat won\'t protect us from whatever it was that I saw fly over last night, though. It was big... I mean, really big!','',26124),
(40657,'enUS','Dedicated to those that fell to the Scourge during the war in the frozen wastes.','',26124),
(40658,'enUS','See the fall of the Lich King.','See the fall of the Lich King.',26124),
(40659,'enUS','I\'m doing Chain Lightning!! pew pew...','',26124),
(40660,'enUS','Hold your ground, soldiers! Here they come!','',26124),
(40661,'enUS','There are too many! Shaman, do something!','',26124),
(40662,'enUS','Rest while you can, men. That wasn\'t the last of them....','',26124),
(40663,'enUS','','Hello, $c!$B$BThese poor creatures are giving everything they have to fight the minions of the Twilight\'s Hammer in this dark place.$B$BI\'ve done my best to revive those that have fallen.$B$BIf you need an additional mount, these birds are ready to take wing again. Treat them well!',26124),
(40664,'enUS','Wave Two:','',26124),
(40665,'enUS','The sky is falling!','',26124),
(40666,'enUS','Egg Wave:','',26124),
(40667,'enUS','Destroy the Firelands Eggs!','',26124),
(40668,'enUS','','You\'ve gotten in my way one too many times, gnome.',26124),
(40669,'enUS','','You have fully depleted my patience as well.',26124),
(40670,'enUS','','There isn\'t room in this town for both of us!',26124),
(40671,'enUS','','I will attempt to not take undue pleasure in utterly destroying you.',26124),
(40672,'enUS','','BRING IT, PIPSQUEAK!',26124),
(40673,'enUS','And that\'s that, folks! This conflict\'s been settled the proper way, with VIOLENCE! Let\'s hear it for our contestants!','',26124),
(40674,'enUS','','I\'m not through with you yet!',26124),
(40675,'enUS','','Fine! You win! I\'m shrewd, not crazy...',26124),
(40676,'enUS','Brace yourselves, men!','',26124),
(40677,'enUS','Stay alert! Don\'t let them drag you away!','',26124),
(40678,'enUS','','Urk... no...',26124),
(40679,'enUS','What the... disgusting!','What the... disgusting!',26124),
(40680,'enUS','Oh come on. As if I haven\'t been through enough.','Oh come on. As if I haven\'t been through enough.',26124),
(40681,'enUS','I don\'t want to be ungrateful, but was that absolutely necessary?','I don\'t want to be ungrateful, but was that absolutely necessary?',26124),
(40682,'enUS','Hexascrub, right?  Of course.','Hexascrub, right?  Of course.',26124),
(40683,'enUS','Thanks... I think.','Thanks... I think.',26124),
(40684,'enUS','Do I want to know where this stuff is from?','Do I want to know where this stuff is from?',26124),
(40685,'enUS','A fish?  For me?  It\'s adorable.','A fish?  For me?  It\'s adorable.',26124),
(40686,'enUS','This will make me feel a tad safer from those murlocs.  Thank you.','This will make me feel a tad safer from those murlocs.  Thank you.',26124),
(40687,'enUS','','You can be sure to tell Gallywix not to underestimate Gnomeregan anymore.',26124),
(40688,'enUS','','Until next time, Megs. Don\'t forget today\'s lesson.',26124),
(40689,'enUS','Open up! I\'ve got a message for you!','',26124),
(40690,'enUS','Hey! Cho\'gall said you had information for me!','',26124),
(40691,'enUS','Hey! Let me in, or you-know-who will hear about this!','',26124),
(40692,'enUS','No! Ahhhhh.....','',26124),
(40693,'enUS','A Ravenous Oceanic Broadhead has caught the scent of your clams.','',26124),
(40694,'enUS','Gah... heeelp!','',26124),
(40695,'enUS','My men - they\'re all taken... Go! Save youselves!','',26124),
(40696,'enUS','A healthy one! My Lady will be mosst pleased...','',26124),
(40697,'enUS','You shall sssserve the Lady for the resst of your daysss!','',26124),
(40698,'enUS','None essscape!','',26124),
(40699,'enUS','Come, sssoftsskin. We have work for you to do!','',26124),
(40700,'enUS','Your laborss sshall be an offering to the Lady...','',26124),
(40701,'enUS','You ssserve or you die, sssoftsskin!','',26124),
(40702,'enUS','You cannot hide, breather!','',26124),
(40703,'enUS','Sshe will find you....','',26124),
(40704,'enUS','Make them pay!','',26124),
(40705,'enUS','Don\'t give up! Fight! Fight for the Alliance!','',26124),
(40706,'enUS','Their numbers are... endless...','',26124),
(40707,'enUS','What a fine ssspecimen you are.','',26124),
(40708,'enUS','My Lady will be mosst grateful for my effortsss.','',26124),
(40709,'enUS','Your willingnesss to obey ssshall determine the length of your life.','',26124),
(40710,'enUS','We were most fortunate to escape, $n. Follow me.','',26124),
(40711,'enUS','*ksssshk* ...no profit down here! These bugs are *kssssshhhk* nothing to eat *khhhhshhk* going to punch this gnome if he keeps *kssssssssssssssssshhhhk*','',26124),
(40712,'enUS','Affirmative, stalker, we are Oscar Mike! Repeat, we are Oscar Mike!','',26124),
(40713,'enUS','','And now all your goblin friends are safe and happy again and there\'s no more pirates to blow up your ships!',26124),
(40714,'enUS','','Well gosh, I\'m so flattered! I\'d love to! You hang on just a giggle, now...',26124),
(40715,'enUS','','All units cleared for deployment. Execute scenario delta. Casualties not a concern.',26124),
(40716,'enUS','I\'ve never seen a gnome clean house like that, kid. I could use someone like you to take care of the rest of those pirates, permanently.','',26124),
(40717,'enUS','','Oh no you don\'t. I\'m two steps ahead of you, squirt. We\'ll see who razes Lost Rigger Cove first.',26124),
(40718,'enUS','The terrified bear cub refuses to leave the tree!','',26124),
(40719,'enUS','Stupid Gronn, you\'ll obey us or... or... well you better!','Stupid Gronn, you\'ll obey us or... or... well you better!',26124),
(40720,'enUS','I\'m about fed up with you! Don\'t make me get Forgemaster Throngus over here!','I\'m about fed up with you! Don\'t make me get Forgemaster Throngus over here!',26124),
(40721,'enUS','You will move that Elemenitum whether you like it or not!','You will move that Elemenitum whether you like it or not!',26124),
(40722,'enUS','Keep it down back there or you\'ll join your friends!','',26124),
(40723,'enUS','Sniveling cowards! Hellscream\'s Horde will leave all of your brothers and sisters to a similar fate!','',26124),
(40724,'enUS','Pitiful little creatures! Thundrak will show you no mercy!','',26124),
(40725,'enUS','Toss your refuse and fecal matter in the back so these gnomes have some company!','',26124),
(40726,'enUS','Shut your quivering yaps or I\'ll feed you to the wolves!','',26124),
(40727,'enUS','P-p-p-lease don\'t hurt us m-m-m-ister Painmaster, sir!','P-p-p-lease don\'t hurt us m-m-m-ister Painmaster, sir!',26124),
(40728,'enUS','Calm yaself. Let yaself get lost in tha flames.','',26124),
(40729,'enUS','Be wary, allies. There are bound to be traps to protect the Firelord from our incursion.','',26124),
(40730,'enUS','I am ready to begin the battle against Ragnaros.','I am ready to begin the battle against Ragnaros.',26124),
(40731,'enUS','','Hi there, $g handsome : gorgeous;. Welcome to the Speedbarge Bar.$B$BWhat\'ll it be?',26124),
(40732,'enUS','What drinks do you have?','What drinks do you have?',26124),
(40733,'enUS','','Greetings, $c.  I hope you find your accomodations suitable, even in this time of war.',26124),
(40734,'enUS','','$n, please stop those pirates before they destroy the Speedbarge!',26124),
(40735,'enUS','I\'ll take care of the pirates. But first, maybe some liquid courage.','I\'ll take care of the pirates. But first, maybe some liquid courage.',26124),
(40736,'enUS','Once Hamuul and Malfurion arrive, we shall begin...','',26124),
(40737,'enUS','We are ready, Cenarius.','',26124),
(40738,'enUS','We shall face the Firelord and drive every ember of his being out of our realm!','',26124),
(40739,'enUS','Use the Leave Vehicle button to quickly get back onto the Speedbarge.','Use the Leave Vehicle button to quickly get back onto the Speedbarge.',26124),
(40740,'enUS','I shall call upon the chilling mountain winds to protect us from Ragnaros\' flame. Malfurion and Hamuul will shatter the Firelord\'s defenses, allowing us to force him back.','',26124),
(40741,'enUS','Let us begin.  It is only a matter of time before the Firelord becomes aware of our presence and comes to the spire\'s defense.','',26124),
(40742,'enUS','WHO DARES TO DEFILE THE HALLS OF LIVING FLAME? I SHALL SEAR YOUR ESSENCE FROM YOUR FLESH!','',26124),
(40743,'enUS','Quickly, everyone move into position! Force him back into the Firelands!','',26124),
(40744,'enUS','Take me to Smuggler\'s Scar.','Take me to Smuggler\'s Scar.',26124),
(40745,'enUS','Take me to Silver Tide Hollow.','Take me to Silver Tide Hollow.',26124),
(40746,'enUS','|TInterface\\Icons\\ability_dualwield.blp:20|t%s equips his |cFFFF0000Swords|r and gains |cFFFF0000|Hspell:74981|h[Dual Blades]|h|r!','',26124),
(40747,'enUS','|TInterface\\Icons\\inv_shield_76.blp:20|t%s equips his |cFFFF0000Shield|r and gains |cFFFF0000|Hspell:74908|h[Personal Phalanx]|h|r!','',26124),
(40748,'enUS','Return to Thousand Needles or lose your River Boat.','',26124),
(40749,'enUS','The forces we are up against here go beyond the Twilight\'s Hammer, Ragnaros or even Deathwing.  We must succeed here if our world is going to survive at all.','',26124),
(40750,'enUS','Hyjal is lost!  Give up!','',26124),
(40751,'enUS','No prison will hold me, fool!','',26124),
(40752,'enUS','The corruption is everywhere!  You cannot succeed!','',26124),
(40753,'enUS','','I fear for Alysra\'s fate.  Fandral\'s corruption ran deeper than anything I encountered in the nightmare.  Yet we can\'t afford to dwell on this.',26124),
(40754,'enUS','','During my stay in the dream I made a vital discovery. The rift that weakens the boundaries of this world has hastened the return of powerful allies.',26124),
(40755,'enUS','','The Ancient Guardians are coming back.  Cenarius, Aviana, Goldrinn... I can feel their presence.  We must make sure we usher them into this world.  Their timely aid will be indispensable.',26124),
(40756,'enUS','','Rudimentary analysis suggests... that I am unable to continue.',26124),
(40757,'enUS','','You gave it a good shot, kid. But this is goblin turf now. I suggest you get used to it.',26124),
(40758,'enUS','','Ciao, babe. Let me know if you\'d like to do lunch sometime. We\'ll work something out now that you\'ve learned some manners.',26124),
(40759,'enUS','An Azsh\'ir Monitor has spotted you!','',26124),
(40760,'enUS','An Azsh\'ir Monitor calls for help!','',26124),
(40761,'enUS','Wants to kill us does it?  Wants to know our secrets...','',26124),
(40762,'enUS','We must destroys it.','',26124),
(40763,'enUS','We burns it, we burns! Bring fire, yes!','',26124),
(40764,'enUS','Come winds, whisper whisper... Blows it, blows it, blows it away!','',26124),
(40765,'enUS','We ... crushes it! Must ... make crush. Hurry friends!','',26124),
(40766,'enUS','It mustn\'t know... it mustn\'t learn... what\'s ours...','',26124),
(40767,'enUS','','The odds appear to be against us, but we cannot falter, $n.  We are all that stands between the enemy\'s hordes and Nordrassil.',26124),
(40768,'enUS','','I...I\'m running out of breath... I must turn back!',26124),
(40769,'enUS','','Come inside, $r. I must repay your kindness.',26124),
(40770,'enUS','','Please, $r.$b$bI don\'t know how much longer I can make it here...',26124),
(40771,'enUS','Follow me! I\'ll lead you to Smuggler\'s Scar.','Follow me! I\'ll lead you to Smuggler\'s Scar.',26124),
(40772,'enUS','Ready, aim... FIRE!','Ready, aim... FIRE!',26124),
(40773,'enUS','Wizzle, you idiot! Everything would have been fine if you\'d just kept your mouth shut!','',26124),
(40774,'enUS','Someone get me out of this cage!!!','',26124),
(40775,'enUS','I\'m going to throttle you as soon as I get out of here, Wizzle!','',26124),
(40776,'enUS','I had a good thing going here. Was going to sell these pirates a bunch of rifles and make a fortune! But no! Wizzle had to tag along and try to sell them his cheap engineering parts. Blew up a few of their cannons and my rifles in the process! We\'re doomed!','',26124),
(40777,'enUS','','Oh, thank you!',26124),
(40778,'enUS','Who\'s there? Let me out! Let me out before these stinking pirates decide to put me on a spit and make green eggs and ham from me!','',26124),
(40779,'enUS','On behalf of the Bilgewater Cartel, allow me to offer a very generous reward to the first person that gets me free of this cage! Of course, standard contractual stipulations apply, but don\'t worry about the fine print. Just get me out of here!','',26124),
(40780,'enUS','Hey, you pirates?! Come on now, stop kidding around. Let me out of here and I\'ll get you all a brand new delivery of rifles just as soon as I can get them from the Speedbarge!','',26124),
(40781,'enUS','Would someone please do something about those cannons? I can\'t think straight here!','',26124),
(40782,'enUS','Synge, I can\'t believe you got us into this mess, you stupid goblin!','',26124),
(40783,'enUS','%s calls forth creatures from elsewhere in the Firelands.','',26124),
(40784,'enUS','Oh my goodness! Oh my goodness! Someone get me out of here! I have claustro.. claustro... claustro.. er, a fear of being trapped in a cage!','',26124),
(40785,'enUS','%s calls forth creatures from Skywall.','',26124),
(40786,'enUS','%s calls forth creatures from the heart of Deepholm.','',26124),
(40787,'enUS','Hey you, over there! Please, please, please, get me out of this cage!','',26124),
(40788,'enUS','I\'m making a list of all of the things that I can transform you into with my Super Adaptive Transformative Shape Changing Ray, Synge! I hope that you end up as something completely useless to match your pathetic life.','',26124),
(40789,'enUS','Pirate friends, listen. I\'m not with this Synge character. Let me assure you that if you let me out of this cage, I\'ll be the best engineer you\'ve ever had. I mean, really, have you seen the accuracy of your cannons? So close, yet soooooo far away!','',26124),
(40790,'enUS','Who wants to let an innocent gnome out of a cage? Come on now. How often do you get an offer like that?','',26124),
(40791,'enUS','Synge, I\'m going to slap you around some, and then some more! Just watch. I\'m going to get out of this cage and then gloat and laugh at you!','',26124),
(40792,'enUS','Um, pirates, my brothers are going to be very worried about me going missing. Maybe you could let me go? Rizzle has a drinking problem and Fizzle has a problem with his blood pressure!','',26124),
(40793,'enUS','Did you see that?','Did you see that?',26124),
(40794,'enUS','Alright!','Alright!',26124),
(40795,'enUS','For the Horde!','For the Horde!',26124),
(40796,'enUS','Bullseye!','Bullseye!',26124),
(40797,'enUS','','Magic is a tool, some would even say a gift. But you should never forget its fundamental nature.',26124),
(40798,'enUS','','Arcane magic twists the boundaries of our world. It weakens the laws of this realm to allow the impossible to happen, if only for a moment.',26124),
(40799,'enUS','','That single moment is all a demon needs to wreak havoc. The Burning Legion has watched us for millennia, always waiting for the smallest rift to slip through, the smallest stirring to whisper from.',26124),
(40800,'enUS','','Remember this, young ones. Every spell you cast, no matter how minor, cuts both ways. This is why sorcery must never be used frivolously.',26124),
(40802,'enUS','','The Twilight\'s Hammer is more than an organization to me.  It\'s a family.$B$BAs such, I take great care in making sure no unworthy candidates make it past the training phase.',26124),
(40803,'enUS','I need to find a safe place soon.$b$bOl\' Mack\'s not doin\' so well.','',26124),
(40804,'enUS','Make for that cave to the west. It\'s safe and dry.','Make for that cave to the west. It\'s safe and dry.',26124),
(40805,'enUS','I can\'t take it, man! I\'m freakin\' out here!','',26124),
(40806,'enUS','What\'s going on?! We need to act NOW! NOW I SAY!','',26124),
(40807,'enUS','We\'re wastin\' time here, professor! The orcs are slaughtering us!','',26124),
(40808,'enUS','I didn\'t sign up for this garbage! I coulda been back helping Mekkatorque reclaim Gnomeregan!','',26124),
(40809,'enUS','You vorry too much, Gnombuz. Zettle yourzelf down!','',26124),
(40810,'enUS','Zis iz ridiculous! Ve vill go vhen ve are rezy!','',26124),
(40811,'enUS','You are making ze night elvez nervouz, Gnombuz!','',26124),
(40812,'enUS','Keep it up, boys!  We\'ve got work to do!','Keep it up, boys!  We\'ve got work to do!',26124),
(40813,'enUS','','Your aid is required, $n. Help us stop the brutish Horde!',26124),
(40814,'enUS','PAIN is all that you will find here, $r!','',26124),
(40815,'enUS','Thanks, friend. We owe ya one.','',26124),
(40816,'enUS','Hang in there, Mack...','',26124),
(40817,'enUS','I thought I\'d been left behind for sure.  Thanks for coming back for me!','I thought I\'d been left behind for sure.  Thanks for coming back for me!',26124),
(40818,'enUS','Thank you, stranger! We\'re free!','Thank you, stranger! We\'re free!',26124),
(40819,'enUS','HOORAY! HOORAY!','HOORAY! HOORAY!',26124),
(40820,'enUS','Yippee! We\'re saved!','Yippee! We\'re saved!',26124),
(40821,'enUS','You\'re a life saver, $c.','You\'re a life saver, $c.',26124),
(40822,'enUS','I owe you.  Big time.','I owe you.  Big time.',26124),
(40823,'enUS','I won\'t forget this.  Thank you.','I won\'t forget this.  Thank you.',26124),
(40824,'enUS','I\'m going to name my firstborn $n.','I\'m going to name my firstborn $n.',26124),
(40825,'enUS','How many times is that that you\'ve saved me today?  I lost count.','How many times is that that you\'ve saved me today?  I lost count.',26124),
(40826,'enUS','None left behind, eh?  You\'re a stand-up $r.','None left behind, eh?  You\'re a stand-up $r.',26124),
(40827,'enUS','I could kiss you.  I\'ll spare you the shell-breath though.','I could kiss you.  I\'ll spare you the shell-breath though.',26124),
(40828,'enUS','%s howls in fury as he is doused by water!','',26124),
(40829,'enUS','I\'ll get you, mortal! And your little wolves, too!','',26124),
(40830,'enUS','It ... burns!','',26124),
(40831,'enUS','This <glub> is not over yet, mortal...','',26124),
(40832,'enUS','How? What is this trickery?','',26124),
(40833,'enUS','Water! Here!?','',26124),
(40834,'enUS','Aiiieeee!','',26124),
(40835,'enUS','You infuriate me, mortal!','',26124),
(40836,'enUS','FACE ME, INSECTS. I SHALL CRUSH YOU FIRSTHAND!','',26124),
(40837,'enUS','YOUR FAILURE TODAY MORTALS HERALDS THE END OF YOUR WORLD. MY CHILDREN USHER IN A NEW ERA, RULED  BY THE FLAME!','',26124),
(40838,'enUS','I need an overseer over here, NOW!','',26124),
(40839,'enUS','Look at this blade thrower.  The pride of the orcs... HAH!','',26124),
(40840,'enUS','Overseer!  Tell me what you see.','',26124),
(40841,'enUS','Wrong!  Come with me.','',26124),
(40842,'enUS','Defeat the fire elementals attacking %s!','',26124),
(40843,'enUS','A... a blade thrower, sir.','A... a blade thrower, sir.',26124),
(40844,'enUS','Impurity! Your fragile flesh defiles my work.','',26124),
(40845,'enUS','Defeat the fire elementals attacking %s!','',26124),
(40846,'enUS','%s has fallen!','',26124),
(40847,'enUS','%s has recovered and resumes fighting!','',26124),
(40848,'enUS','%s has fallen!','',26124),
(40849,'enUS','%s has recovered and resumes fighting!','',26124),
(40850,'enUS','Thonk is waiting for you at the top of the tower, $c.','Thonk is waiting for you at the top of the tower, $c.',26124),
(40851,'enUS','Do these blades look sharp to you?  DO THEY, OVERSEER?','',26124),
(40852,'enUS','ASSIST ME, MY CHILDREN!','',26124),
(40853,'enUS','BURN THEIR FLESH AND SEAR THEIR BONES!','',26124),
(40854,'enUS','YOU HAVE ONLY DELAYED THE INEVITABLE, CENARIUS. FROM THE FIRELANDS SHALL MY ARMIES BE REBORN...','',26124),
(40855,'enUS','What in blazes do you orcs think you\'re doing?','',26124),
(40856,'enUS','Fishing poles... you fish like tuskarr.  Or worse, like humans.','',26124),
(40857,'enUS','Let an old orc show you how it\'s done!','',26124),
(40858,'enUS','As you were, orcs.  Let\'s make Hellscream proud.','',26124),
(40859,'enUS','This area is looking good, orcs.  Keep up the good work.','',26124),
(40860,'enUS','Say, did I ever tell you about the dwarf that tried to kill me in the battle for Grim Batol?','',26124),
(40861,'enUS','He tried to sneak up behind me and plant his blade in my skull.  Lucky for me, I can smell a dwarf a mile away... and my skull\'s a lot thicker than most.','',26124),
(40862,'enUS','Of course, back then, I had a lot more hair to protect it.','',26124),
(40863,'enUS','Anyhow, I turned around, took his blade, his life, his head, and his mount.','',26124),
(40864,'enUS','You orcs ever dream about battle?','',26124),
(40865,'enUS','Yes sir.','Yes sir.',26124),
(40866,'enUS','Very much, sir.','Very much, sir.',26124),
(40867,'enUS','Ha ha!  Excellent!  Maybe I\'ll see to it that you get your names recommended to Garrosh.  Now, back to work!  Lok\'tar ogar!','',26124),
(40868,'enUS','OVERSEER!  What\'s going on here?','',26124),
(40869,'enUS','BE BATHED IN FLAME!','',26124),
(40870,'enUS','BURN IN LIQUID FLAME!','',26124),
(40871,'enUS','Last I checked, your title was overseer, not overeater.','',26124),
(40872,'enUS','I\'ve walked by here twice now, and both times you\'ve been sitting here by the fire, lazing around while your men work.','',26124),
(40873,'enUS','Sir, I... my orcs were working well, so I just... thought I\'d...','Sir, I... my orcs were working well, so I just... thought I\'d...',26124),
(40874,'enUS','I see bandages stacked in the same piles as weapons.  I see food that clearly has been left to expire in the sun, when I CLEARLY provided you with a tent for shade.','',26124),
(40875,'enUS','Who is overseeing these men?','',26124),
(40876,'enUS','I... I am, sir.','I... I am, sir.',26124),
(40877,'enUS','Let\'s make sure that it stays that way then.  Back to work, overseer.','',26124),
(40878,'enUS','Gor, Shin, you shouldn\'t really be spending all your time in this hut.  Get out there and work with the orcs!','',26124),
(40879,'enUS','Actually, shaman, I don\'t really care what you do.  I\'m not even sure why Hellscream brought you here.','',26124),
(40880,'enUS','Gor, when you\'re feeling less like a youngling, why don\'t you come outside with me and actually start ENFORCING for once?','',26124),
(40881,'enUS','Farmer, come out.  We must speak.','',26124),
(40882,'enUS','These swine, they are weak.  They\'re not good for breeding, not good for eating, and certainly no good for combat.','',26124),
(40883,'enUS','You need to be more selective in your breeding.  The Horde has no place for weaklings, even in its swine pens.','',26124),
(40884,'enUS','There.  I don\'t want to have to do this again.  That\'s your job, swineherd.','',26124),
(40885,'enUS','','Nooooo!!!',26124),
(40886,'enUS','Nice shooting! The sniper cannon is a miraculous wonder!','',26124),
(40887,'enUS','Defeat these sons of Ragnaros so that I can aid Cenarius!','',26124),
(40888,'enUS','I am under assault! Assist me!','',26124),
(40889,'enUS','%s is under attack from Ragnaros. Heal him!','',26124),
(40890,'enUS','Ragnaros\'s assault has taxed my strength... Heal me!','',26124),
(40891,'enUS','Let this be a lesson to those who would defile Hyjal.','',26124),
(40892,'enUS','You know nothing of fury, worm!','',26124),
(40893,'enUS','PUNY $R! DIE!','',26124),
(40894,'enUS','Feel the fury of Ragnaros!','',26124),
(40895,'enUS','','This heat. This stifling heat.$B$BIt makes me want to hurt things.',26124),
(40896,'enUS','Here I come!  Don\'t you dare hide behind those trees!','',26124),
(40897,'enUS','Someone else from beyond the portal! I hope you\'re ready for a fight, $c.','',26124),
(40898,'enUS','We\'re behind enemy lines, $n. We\'ve got to do as much damage as we can!','',26124),
(40899,'enUS','If we allow Twilight\'s Hammer to open up portals like these all over Azeroth, no army in the world can save the planet. We\'ve got to shut this tunnel network down!','',26124),
(40900,'enUS','We must perservere, $n. That is something I learned from our beloved wolf ancient.$B$BNever, never, never give up.','',26124),
(40901,'enUS','Pyrendius is slain! Our work here is done.$B$BJust step through the flamegate to return to Mount Hyjal, $c. I\'ll make sure the gate is taken care of.','',26124),
(40902,'enUS','I lost my Fang of Lo\'Gosh. Can I have another?','I lost my Fang of Lo\'Gosh. Can I have another?',26124),
(40903,'enUS','I lost my Fang of Goldrinn. Can I have another?','I lost my Fang of Goldrinn. Can I have another?',26124),
(40904,'enUS','','You\'ll soon learn that lightning and water don\'t mix!',26124),
(40905,'enUS','Later.','',26124),
(40906,'enUS','In honor of our benevolent ruler and protector, Matron Elestara Vashj.$B$BFor 100 years, she has faithfully sheltered us, protected us, and lead us steadily into a modern age of prosperity.$B$BUnder Queen Azshara\'s gaze, may she reign for 100 year more.','',26124),
(40907,'enUS','What coward dares attack my young while I\'m away?  I will feed your entrails to my brood!','',26124),
(40908,'enUS','It took all of our combined strength, but we have pushed Ragnaros back into the Firelands.','',26124),
(40909,'enUS','Woohooo!','',26124),
(40910,'enUS','We must not let down our guard.  It\'s only a matter of time before he regains his strength and returns to turn Nordrassil into ash.  ','',26124),
(40911,'enUS','We must confer with the leaders of the Horde and the Alliance.  Ragnaros must be defeated in his home realm.  Only then will he forever be vanquished.','',26124),
(40912,'enUS','Let us leave this place for now.  We must return to the surface and restore the damage our enemies have caused.','',26124),
(40913,'enUS','','You will not defile the winds of Hyjal, monster!',26124),
(40914,'enUS','Master Taerar will show you such wonder!','',26124),
(40915,'enUS','We are all a part of him...','',26124),
(40916,'enUS','The nightmare reigns!','',26124),
(40917,'enUS','For Taerar!','',26124),
(40918,'enUS','','Huntress, there! What is that!?',26124),
(40919,'enUS','','I... is that it over there, $n? This land is doomed if the Horde manages to set that off.',26124),
(40920,'enUS','What is that, a siege tank first aid kit? You must know Pilot Stonegear!','',26124),
(40921,'enUS','*POP* Not zat von! Keep going!','*POP* Not zat von! Keep going!',26124),
(40922,'enUS','*crackle* WRONG! Ze correct goblin driller iz down ze path!','*crackle* WRONG! Ze correct goblin driller iz down ze path!',26124),
(40923,'enUS','Slay her now, before Aviana\'s magic wears off!','',26124),
(40924,'enUS','Show yourself, beast!  We will destroy you and your corrupt spawn no matter where you hide!','',26124),
(40925,'enUS','You no take ore!','',26124),
(40926,'enUS','%s is weak enough to capture!','',26124),
(40927,'enUS','WAAAARRRRRRGH!','',26124),
(40928,'enUS','I\'ll hold onto this orb for...safe keeping. Go inform Rok Orhan of our cultist problem.','',26124),
(40929,'enUS','Who dat? Somebody der?','',26124),
(40930,'enUS','MOVE! DIS ROCK HEAVY!','',26124),
(40931,'enUS','NO CAN SEE NOTHIN! Move out of da way!','',26124),
(40932,'enUS','Why me have to carry big rock? Dey said less work under da new Warchief! Dey promised change!','',26124),
(40933,'enUS','Maybe me put dis rock down and say hello. Maybe.','',26124),
(40934,'enUS','Walking blindly tru dark mine wit big rock in arms. Much better dan last job.','',26124),
(40935,'enUS','Move or I tell da overseer dat you pooped in da bucket!','',26124),
(40936,'enUS','Sleepy... so sleepy...','',26124),
(40937,'enUS','OK boss, I get back to tree-hitting.','',26124),
(40938,'enUS','Just was resting eyes!  Back to work now!','',26124),
(40939,'enUS','Shhhh! Keep it down! You\'ll blow our cover.','',26124),
(40940,'enUS','Thank you for taking the time to help us test the Cataclysm content for World of Warcraft. \n\nWhere would you like to go?','Thank you for taking the time to help us test the Cataclysm content for World of Warcraft. \n\nWhere would you like to go?',26124),
(40941,'enUS','Take me to Orgrimmar, I wish to travel through Vashj\'ir Landing.','Take me to Orgrimmar, I wish to travel through Vashj\'ir Landing.',26124),
(40942,'enUS','Take me to Stormwind Harbor, I wish to travel to Vashj\'ir Landing.','Take me to Stormwind Harbor, I wish to travel to Vashj\'ir Landing.',26124),
(40943,'enUS','Take me to Hyjal, I wish to help the Druids protect Nordrassil.','Take me to Hyjal, I wish to help the Druids protect Nordrassil.',26124),
(40944,'enUS','I wish to travel directly to Vashj\'ir Landing.','I wish to travel directly to Vashj\'ir Landing.',26124),
(40945,'enUS','This is where we play a movie of you turning into a worgen!  We also flash-forward to the present!','',26124),
(40946,'enUS','HIJACKER! DIE!','',26124),
(40947,'enUS','You won\'t get away with this!','',26124),
(40948,'enUS','You can\'t stop us! The Horde will never fall!','',26124),
(40949,'enUS','The chief will pay big money for your head!','',26124),
(40950,'enUS','Get off! Get off!','',26124),
(40951,'enUS','***MALFUNCTION***','',26124),
(40952,'enUS','***REROUTING POWER SOURCE***','',26124),
(40953,'enUS','***REMOTE ACCESS ENABLED***\n','',26124),
(40954,'enUS','***RETURN COMMAND INITIATED***','',26124),
(40955,'enUS','***EJECTING ALL UNAUTHORIZED PASSENGERS***','',26124),
(40956,'enUS','','<Though Ysera\'s physical form stands in front of you, her consciousness appears to shift between this world and another.>',26124),
(40957,'enUS','','Have you been to Ashenvale lately? How are things?',26124),
(40958,'enUS','Yes, my brethren!  We are claiming this prisoner for the True Sons of the Twilight!  These ogre scum are not fit to offer him as sacrifice!  They are not worthy of the Old Gods\' grace!','',26124),
(40959,'enUS','Come on now commander.  Let\'s get you out of here.  $n, meet us at the Gates of Sothann -- Ysera awaits!','',26124),
(40960,'enUS','','%s begins to channel a Supernova. Look away!',26124),
(40961,'enUS','We are still beset by threats here. I cannot leave the camp unguarded.','',26124),
(40962,'enUS','It is all I can do to protect those who have made it here.','',26124),
(40963,'enUS','I have sent all the warriors I can. Had I but even one more for you...','',26124),
(40964,'enUS','Leaving ourselves unguarded on two sides will bring even more suffering, Jawn.','',26124),
(40965,'enUS','We must keep the guards here to protect the refugees.','',26124),
(40966,'enUS','The grimtotem lurk in Feralas as well. They wait for the chance to strike this very camp.','',26124),
(40967,'enUS','Hmm, good treasure.','',26124),
(40968,'enUS','%s becomes protected by his defense beacons! Disable them by pulling the levers below!','',26124),
(40969,'enUS','Want fight admiral? Lots of treasure. Me outa here!','',26124),
(40970,'enUS','No want trouble. Want gold.','',26124),
(40971,'enUS','This lots of gold! Me look other way.','',26124),
(40972,'enUS','Two-Tusk never give me treasure!','',26124),
(40973,'enUS','Me hide treasure. Go on break.','',26124),
(40974,'enUS','Lots of shiny. Maybe me like you more than admiral.','',26124),
(40975,'enUS','You not bad for $r scum.','',26124),
(40976,'enUS','','Wake up, Mr. P!',26124),
(40977,'enUS','','All good girls listen to their daddies!',26124),
(40978,'enUS','Oh no! The key broke in the lock! I\'ll never get out of this cage!','',26124),
(40979,'enUS','','Are you there, Mr. P?',26124),
(40980,'enUS','','Wake up, Mr. P! You\'ve gotta save the spirits!',26124),
(40981,'enUS','Oh no! The key broke in the lock! I\'ll never get out of this cage!','',26124),
(40982,'enUS','Ryan\'s the name, trading\'s the game! What\'ll ya have?','',26124),
(40983,'enUS','Show me what you\'ve got, Ryan.','Show me what you\'ve got, Ryan.',26124),
(40984,'enUS','','We Druids of the Talon aren\'t cut out for front-line duty. We\'re aerial spies, infiltrators...$B$BBut occasionally I like to get my talons dirty. ',26124),
(40985,'enUS','Watch yerself down here, $c. These wendigos are savage fighters.','',26124),
(40986,'enUS','Captain Tharran wants you to deploy your remote observation bots and withdraw to Kharanos.','Captain Tharran wants you to deploy your remote observation bots and withdraw to Kharanos.',26124),
(40987,'enUS','Fools! Simpletons! Look at you milling about, oblivious to the coming of the end!','',26124),
(40988,'enUS','Allow me to ask a simple question: Is a man allowed - entitled even - the sweat of his brow?','',26124),
(40989,'enUS','I\'ve seen enough of this cave for a lifetime. I can\'t wait to get back to Kharanos.','',26124),
(40990,'enUS','\'No\' says the orc in Orgrimmar, \'it belongs to the Horde!\'','',26124),
(40991,'enUS','\'No\' says the human in Stormwind, \'it belongs to the Alliance!\'','',26124),
(40992,'enUS','I knew a man once that rejected those answers! A great man that built a home for those that felt as he did! A man that chose the impossible!','',26124),
(40993,'enUS','That man was Genn Greymane and that impossible choice was Gilneas!','',26124),
(40994,'enUS','These wendigos are an annoyance, sure, but the real fight is with those Frostmane refugees.','',26124),
(40995,'enUS','','Come ... closer ... $c. They are ... pulling me away ...',26124),
(40996,'enUS','','A %s appears above the circle, hazy and indistinct.',26124),
(40997,'enUS','','Elune watch over you, $n.',26124),
(40998,'enUS','','Your kindness will not be forgotten!',26124),
(40999,'enUS','','I am eternally grateful, $n!',26124),
(41000,'enUS','','Curse the wretched Horde! I would have died without you!',26124),
(41001,'enUS','','You think you\'re clever, don\'t you, ganging up on me like this... well, prepare to face: THE DREADSHREDDER!',26124),
(41002,'enUS','','Hurry...',26124),
(41003,'enUS','','Grrr... I was going to fight you fair and square, but you decided to bring friends. Fine! Behold the Alloy-Pounder Zero!',26124),
(41004,'enUS','%s appears above your head with an ear-splitting caw!','',26124),
(41005,'enUS','Tell Captain Tharran that I\'ll be back in Kharanos as soon as I\'ve verified that the bot is working correctly.','',26124),
(41006,'enUS','I can\'t wait to get out there and help in the fight against those trolls.','',26124),
(41007,'enUS','','Sister! I... too... have f-failed...',26124),
(41008,'enUS','We\'ve been fighting nonstop since the cataclysm. It\'ll be nice to get a rest, if a brief one.','',26124),
(41009,'enUS','','Well done, $n! Return to Windshear Hold and notify Lord Fallowmere of the Horde\'s intentions. I will venture to the Thal\'darah Overlook and warn our soldiers.',26124),
(41010,'enUS','','Ack! Not the face!',26124),
(41011,'enUS','','Whaaaa!!!!!',26124),
(41012,'enUS','Now you all die!','',26124),
(41013,'enUS','I could hear the sound of your trident breaking from the gardens! The skulls of these Kvaldir are as strong as rock.','',26124),
(41014,'enUS','','A single prong. Hardly enough to stop me from slaughtering hundreds more.',26124),
(41015,'enUS','First and foremost, I\'m a businessman. Bring me back to life and I\'ll stop haunting you. There may even be a reward in it for you.','',26124),
(41016,'enUS','Indeed. I doubt much would.','',26124),
(41017,'enUS','You know, if you\'d just been reasonable about the whole thing, I might have simply sold the key to you. Not that it would have done you any good. Broke off in the lock. Muahahahahahahaha!','',26124),
(41018,'enUS','Sorry about having to deal with my wife, mon. She\'s crazy, but I still love her, you know?','',26124),
(41019,'enUS','This afterlife thing isn\'t all that bad. I can see lots of business opportunities here. Plenty of spirits that are waiting for the right deal to come along.','',26124),
(41020,'enUS','You know, the attacks on the Speedbarge are just a business misunderstanding. When you get me rezzed, I\'ll consider negotiating a contract with Fizzle and Pozzik.','',26124),
(41021,'enUS','You got something to eat? I\'m hungry!','',26124),
(41022,'enUS','You don\'t like me following you around? Too bad! Maybe next time you go murdering someone just to get a key, you\'ll think twice!','',26124),
(41023,'enUS','What\'s the weather like? I can\'t tell... it\'s all grey and dark, swirling clouds here.','',26124),
(41024,'enUS','That whole thing with Ajamon\'s sister was a big misunderstanding. I didn\'t do it, I swear! I think it was Seadog Fajardo. The little brat kinda looks like him.','',26124),
(41025,'enUS','Oh, mon, I had an itch when I died and now it won\'t go away. Please tell me it doesn\'t last for eternity?! You gotta get me rezzed!!!','',26124),
(41026,'enUS','They say I have a bad reputation as a pirate, but you don\'t see me sailing around indiscrimanately killing people just to make a profit. Oh, wait....','',26124),
(41027,'enUS','Ajamon took her maiden name again. Despite everything, I kinda miss her, you know?','',26124),
(41028,'enUS','You want to know why women are no-good? Because you think that all they\'re doing is calling upon the spirits of the dead. But then, you catch them doing a little more than talking! I mean, how does that even work with a ghost?','',26124),
(41029,'enUS','When I get back into my body, I\'m going to kill you, mon! Er... no, what I meant to say is that I\'m going to hug you. Yeah, that\'s right, I\'m going to hug you and give you a big reward. Nevermind what I said about the killing.','',26124),
(41030,'enUS','Kulratha. Things are going well, I see.','',26124),
(41031,'enUS','Didn\'t take me long to build a pirate empire out of almost nothing. Ah, the Barrens. Now those were the days. Hey, did anyone ever find out what happened with Mankrik\'s wife?','',26124),
(41032,'enUS','You\'re just the kind of scum that I\'m looking for in my organization. You know, we\'re an independetly run franchise of the Southsea Freebooters. We have pretty good benefits, vacation, and full medical, dental, and vision. Maybe we should talk after you bring me back to life.','',26124),
(41033,'enUS','The blessed beast Gahz\'rilla, adored pet of the Old Gods, grows larger and stronger by the day... as does the Cult of Twilight\'s Hammer.','',26124),
(41034,'enUS','Continue your work here, Hydromancer. Soon, this world will be remade...','',26124),
(41035,'enUS','...and as devoted servants to our master, you and the Sandfury tribe shall  be justly rewarded!','',26124),
(41036,'enUS','INTERLOPERS! Slay them!','',26124),
(41037,'enUS','','You think you\'re all brave facing me, eh, Steelsparks?! Those pig tails won\'t protect you from THE DOOMSAW!',26124),
(41038,'enUS','','Careful, $n! Warlord Roktrog is near. He should be back any minute!',26124),
(41039,'enUS','','Soon, the rifts will be large enough for Gahz\'rilla to assault the heathens\' cities directly. She will reduce them to frozen rubble!',26124),
(41040,'enUS','Where is the Warlord? I will kill him and free you!','Where is the Warlord? I will kill him and free you!',26124),
(41041,'enUS','','Lady Vashj is nothing like her mother. It is little wonder she left this city so long ago.',26124),
(41042,'enUS','Stonetalon has always had its fill of problems, $n, but never has the land and its people suffered so badly. The Horde will destroy us all if left unchecked.','',26124),
(41043,'enUS','Oh, dearest Gilneas, how I miss thee...','',26124),
(41044,'enUS','Come to my aid, Drake!','',26124),
(41045,'enUS','','Ouch! That burns!!',26124),
(41046,'enUS','','Ow ow! Ow ow ow..!',26124),
(41047,'enUS','','Sharp!',26124),
(41048,'enUS','','This is the one. The ancient will be ours.',26124),
(41049,'enUS','','Take the others to the Firelands Hatchery! Soon we will possess the skies.',26124),
(41050,'enUS','','Mother of all winged creatures, hear my prayer and reveal yourself... a vision! What could this mean, $n? I will report this to Omnuron.',26124),
(41051,'enUS','','Let\'s see how all of that dynamite in your pocket likes the KS-L10 Steelspark, Megs!',26124),
(41052,'enUS','','Yikes! That stings!',26124),
(41053,'enUS','','Yeouuwch!!!',26124),
(41054,'enUS','You\'ve got to save me here, $c! He\'s gone mad... mad I telll you! His inability to stop the flooding of Thousand Needles has caused him to go completely bonkers!$B$BHe blames me for everything, including the Cataclysm. He probably thinks that I\'m Deathwing in disguise, or something!$B$BHelp!','',26124),
(41055,'enUS','I hear that you sell Ancona chickens?','I hear that you sell Ancona chickens?',26124),
(41056,'enUS','','Gotcha Chickenlips! You\'d best get talky, or I\'ll get stabby.',26124),
(41057,'enUS','','I\'m not sure that\'s strictly necessary.',26124),
(41058,'enUS','','You\'ll get nothing from me, $r!',26124),
(41059,'enUS','','<Marion squaks loudly and glares at you.>',26124),
(41060,'enUS','','Your cities will fall, $r. You\'ll perish in the darkness of the new regime!',26124),
(41061,'enUS','','Do what you will. My new masters will carve my name into your flesh before they execute you.',26124),
(41062,'enUS','<Soften her up.>','<Soften her up.>',26124),
(41063,'enUS','Attack them now, brothers!','',26124),
(41064,'enUS','Kill the females! I will handle these \"warriors.\"','',26124),
(41065,'enUS','Attack the Sea Witches - stop their spells!','',26124),
(41066,'enUS','Slaughter them all.','',26124),
(41067,'enUS','Squash these snakes!','',26124),
(41068,'enUS','Men, attack now!','',26124),
(41069,'enUS','Stand still you worthless chicken!','',26124),
(41070,'enUS','I could have stopped the sea if not for your incessant clucking!','',26124),
(41071,'enUS','I\'ll pluck you, Johnson!','',26124),
(41072,'enUS','What shall it be this time: fire or frost? Hmm?','',26124),
(41073,'enUS','','Wait, was I supposed to be the good cop?',26124),
(41074,'enUS','','We don\'t need to tell Omnuron about this.',26124),
(41075,'enUS','','Easy, friend. We still need the info.',26124),
(41076,'enUS','','Hey, you don\'t waste any time.',26124),
(41077,'enUS','','There\'s more where that came from, Marion!',26124),
(41078,'enUS','','Brutal!',26124),
(41079,'enUS','I know what I\'m having for dinner tonight and it rhymes with \"Sucky\"!','',26124),
(41080,'enUS','Don\'t resist... I\'m only trying to change you back into a man.','',26124),
(41081,'enUS','Dance, Johnson, dance!','',26124),
(41082,'enUS','Oh, and I\'ll be taking my Ancona chickens back, thank you!','',26124),
(41083,'enUS','Would you hurry it up over there? I don\'t have all day!','',26124),
(41084,'enUS','Johnson, are you selling my Ancona chickens again? Nooooooo!','',26124),
(41085,'enUS','Hey! Why aren\'t you polymorphed? Enjoy it while it lasts, \"Plucky\"!','',26124),
(41086,'enUS','If you\'d been a better assistant this whole Cataclysm thing could have been avoided!','',26124),
(41087,'enUS','Does anyone hear that voice? Make it stop!','',26124),
(41088,'enUS','Bored now!','',26124),
(41089,'enUS','Johnson, tell your friend to move along. It\'s past time for your demise.','',26124),
(41090,'enUS','I better get a cut of those sales! Better yet, I\'ll just fry you up and take all of the profit for myself.','',26124),
(41091,'enUS','Why are you stealing eggs?','Why are you stealing eggs?',26124),
(41092,'enUS','','She asked for eggs. Eggs for her fiery hatchery in another realm.$B$BAnd one egg... a special egg... she sought more than any other.',26124),
(41093,'enUS','Who? Who are you giving the eggs to?','Who? Who are you giving the eggs to?',26124),
(41094,'enUS','','She of the skies, but also of darkness. Brood of the Earth-Warder. Invincible!',26124),
(41095,'enUS','Brood of the Earth-Warder... you answer to a black dragon? Give me a name!','Brood of the Earth-Warder... you answer to a black dragon? Give me a name!',26124),
(41096,'enUS','','Foolish $r! There is a new order. Aviana is dead. DEAD! And never coming back.$B$BTell that to the druids in the trees.$B$BSethria will soon be the master of the skies, and she has made sure Aviana will never be reborn. The egg is hers.$B$BYou are too late.',26124),
(41097,'enUS','','It\'s your call, $n. Marion brought this on herself when she attacked our matron\'s sacred shrine.',26124),
(41098,'enUS','<Order Thisalee to kill the harpy.>','<Order Thisalee to kill the harpy.>',26124),
(41099,'enUS','','Hooray, Mr. P! You\'re back! Do you remember how to shoot all your guns? Why don\'t you take a minute to learn how to fight again! Just in case.',26124),
(41100,'enUS','<Ask Thisalee to release the harpy.>','<Ask Thisalee to release the harpy.>',26124),
(41101,'enUS','','You\'re a better person than I, $n. But I suppose the harpies are just pawns here.',26124),
(41102,'enUS','','Be really careful, Mr. P. If you see a big group of goblins, use your magnetic pull! Once you\'ve got \'em all sucked up, launch \'em to their death! YAY!',26124),
(41103,'enUS','','Get \'em, Mr. P!',26124),
(41104,'enUS','','Break their bones, papa!',26124),
(41105,'enUS','','Make \'em sorry for hurting you, Mr. P!',26124),
(41106,'enUS','','YAY!',26124),
(41107,'enUS','','Hurt \'em some more! MORE!',26124),
(41108,'enUS','','BAD, BAD, HORDIE!',26124),
(41109,'enUS','Need some smithin\'?','',26124),
(41110,'enUS','I need repairs, Irongoat.','I need repairs, Irongoat.',26124),
(41111,'enUS','I LIVE!','',26124),
(41112,'enUS','Thanks, mon. You\'ve been true to your word and I can respect that.','',26124),
(41113,'enUS','I need to get back. I\'m sure we\'ll cross paths again. Next time, I\'ll get to return the favor.','',26124),
(41114,'enUS','Bye, hon. See you later tonight.','',26124),
(41115,'enUS','','No you won\'t, Tony. Go away, I\'m busy summoning up a date for later!',26124),
(41116,'enUS','Meet me back at Aviana\'s Shrine, $n!','',26124),
(41117,'enUS','Aaaahh!!!','Aaaahh!!!',26124),
(41118,'enUS','Help us!','Help us!',26124),
(41119,'enUS','Get me out of here!','Get me out of here!',26124),
(41120,'enUS','It came from below!','It came from below!',26124),
(41121,'enUS','Save us!','Save us!',26124),
(41122,'enUS','Let\'s get back to work, people!','Let\'s get back to work, people!',26124),
(41123,'enUS','Let\'s get back to work, people!','Let\'s get back to work, people!',26124),
(41124,'enUS','Remain calm!','Remain calm!',26124),
(41125,'enUS','Please return to your places!','Please return to your places!',26124),
(41126,'enUS','Well, this is a little embarrassing....','',26124),
(41127,'enUS','You\'ll pay for your meddling, $c!','Step away from there, $c!',26124),
(41128,'enUS','','Time\'s up, Marion.',26124),
(41129,'enUS','','Ice cream!',26124),
(41130,'enUS','I\'m ready to help with Mr. P, kid. Let me in.','I\'m ready to help with Mr. P, kid. Let me in.',26124),
(41131,'enUS','What\'s a $r like you doin\' in a place like this? ...especially at a time like now?$b$bHmmmm?','',26124),
(41132,'enUS','That vile beast has been driven off, but my precious waters have been tainted! I must cleanse them at once.$b$bIf you insist on lingering here, prepare to defend yourself.\n','',26124),
(41133,'enUS','We are ready!','We are ready!',26124),
(41134,'enUS','Welcome, $c! Welcome to the Shrine of Aviana, a haven for all creatures of the sky.$B$BAviana may no longer be with us, but her heart and her ferocity live on in all winged creatures.$B$BSpeak with Choluna down below if you are curious about Aviana\'s story.','',26124),
(41135,'enUS','Thisalee tells me that the harpies are in league with the dragons? But something doesn\'t add up. We need to know more.$B$BPlease assist Choluna with her work here, and see if we can tie this all together... ','',26124),
(41136,'enUS','Choluna told me of your vision. Very puzzling. Is our beloved ancient to be reborn? If so, where is she now?$B$BWe need to know more! Please help Thisalee gather more information for us, then we will act.','',26124),
(41137,'enUS','I don\'t know what I\'m doing here. I have no experience as a contract negotiatior.$B$BI used to serve drinks for a living, but Daisy put me out of business. Time for a new career, I guess.','',26124),
(41138,'enUS','Choluna and Thisalee have both given me their reports. It\'s all very clear to me now...$B$B$n, I believe Aviana may soon return to us, but only if we can stop the black dragon Sethria!','',26124),
(41139,'enUS','','Psst - over here! Stay out of sight for the moment...',26124),
(41140,'enUS','I used to be a simple ticket redeemer at the racetrack. Well, no more racetrack, so no more job.$B$BI\'m trying my hand at negotiations now. Could you help me get things going here? They have oil!','',26124),
(41141,'enUS','The resurrection ritual has failed!','',26124),
(41142,'enUS','Kravel Koalbeard is stunned. Steal the Alliance\'s Proposal now!','',26124),
(41143,'enUS','What\'s the meaning of this?','',26124),
(41144,'enUS','Protect %s until the ritual completes!','',26124),
(41145,'enUS','What are you doing?!','',26124),
(41146,'enUS','Trackmaster Zherin is stunned. Steal the Horde\'s Proposal now!','',26124),
(41147,'enUS','%s is under attack!  Protect him!','',26124),
(41148,'enUS','<The Arcane Guardian gestures towards the Lower City\'s bazaar.>','',26124),
(41149,'enUS','I would like to start the Blood Ritual, Lynnore.','I would like to start the Blood Ritual, Lynnore.',26124),
(41150,'enUS','','Blood magic is shunned by many as a dark and forgotten art.  In that and many other ways, it shares some distinct characteristics with demonic magic.  Here, in the demon-scourged remains of the Black Morass, we believe that our blood studies will flourish.',26124),
(41151,'enUS','You can teach a soldier how to kill, but you can\'t teach him to want to kill.  That is one thing we don\'t have to worry about down here.  Every single one of my boys can\'t wait to take a piece out of those naga for what they did to us, and I can\'t say I feel  much different.$B$BWe need to find a way to make contact with the surface, but before that, I want to make a bit of \"contact\" with these naga.  We have some brothers to avenge.','',26124),
(41152,'enUS','','Let me have a look at that shard, would you Admiral?  I could feel its power radiating from the other side of the cave.',26124),
(41153,'enUS','Of course.  It\'s all yours.','',26124),
(41154,'enUS','','Thank you.',26124),
(41155,'enUS','You have already witnessed this vision.','You have already witnessed this vision.',26124),
(41156,'enUS','You need to attune yourself further with the Naz\'jar Battlemaiden to participate in this vision.','You need to attune yourself further with the Naz\'jar Battlemaiden to participate in this vision.',26124),
(41157,'enUS','Disabling the shadow cloak reveals one of Sethria\'s hatchlings!','',26124),
(41158,'enUS','I... What sorcery is this?','I... What sorcery is this?',26124),
(41159,'enUS','You will regret your actions!','You will regret your actions!',26124),
(41160,'enUS','I... I have no control. Bound by your infernal contraption.','I... I have no control. Bound by your infernal contraption.',26124),
(41161,'enUS','What are we going to tell Forba?','',26124),
(41162,'enUS','Ha! You\'re the one who was supposed to be watchin\' the keg!','',26124),
(41163,'enUS','You were drunk on the job!','',26124),
(41164,'enUS','We? More like what are YOU going to tell Forba!','',26124),
(41165,'enUS','You\'re the one who was supposed to be watching for orcs!','',26124),
(41166,'enUS','So were you!','',26124),
(41167,'enUS','This is it! You\'ve found Aviana\'s Egg! Keep it safe while I go get help.','',26124),
(41168,'enUS','Disabling the shadow cloak reveals Aviana\'s Egg!','',26124),
(41169,'enUS','Defend the Egg!','',26124),
(41170,'enUS','','So help me, if I can get a single one of these lazy sods on his gorram feet, I\'m puttin\' him to work beating the others black and blue!$B$BWe\'ve got WORK to do here!',26124),
(41171,'enUS','Listen, you... do you have any idea how hard it is to conduct a geological survey? It\'s exacting, precise work!$B$BAn\' it\'s even harder when you\'re drunk.','',26124),
(41172,'enUS','You\'re a lifesaver.','You\'re a lifesaver.',26124),
(41173,'enUS','Thanks.','Thanks.',26124),
(41174,'enUS','\'Bout time.','\'Bout time.',26124),
(41175,'enUS','Keep up the good work.','Keep up the good work.',26124),
(41176,'enUS','Good timing - I was almost out.','Good timing - I was almost out.',26124),
(41177,'enUS','Their attacks are getting more frequent. You better keep moving.','Their attacks are getting more frequent. You better keep moving.',26124),
(41178,'enUS','We\'ll keep you covered. Good luck with the assault!','We\'ll keep you covered. Good luck with the assault!',26124),
(41179,'enUS','Good to know they\'ve still got our backs. Thanks!','Good to know they\'ve still got our backs. Thanks!',26124),
(41180,'enUS','%s gasps for air.','%s gasps for air.',26124),
(41181,'enUS','Thank you for freeing me!','Thank you for freeing me!',26124),
(41182,'enUS','Rofilian Dane is deeper in the mine.  Just follow these tracks.','Rofilian Dane is deeper in the mine.  Just follow these tracks.',26124),
(41183,'enUS','Dane awaits you in the next chamber.','Dane awaits you in the next chamber.',26124),
(41184,'enUS','How peculiar.','How peculiar.',26124),
(41185,'enUS','Was that box there a second ago?','Was that box there a second ago?',26124),
(41186,'enUS','The battle for Twin Peaks begins in 1 minute.','',26124),
(41187,'enUS','The battle for Twin Peaks begins in 30 seconds.  Prepare yourselves!','',26124),
(41188,'enUS','Hmm...','Hmm...',26124),
(41189,'enUS','I do declare... a moving box.  The engineers have really done it this time!','I do declare... a moving box.  The engineers have really done it this time!',26124),
(41190,'enUS','Return to the Nethergarde Mines.','',26124),
(41191,'enUS','I know who you are, $n! I\'ll not surrender the Sacred Flame to a filthy meatbag such as yourself!','',26124),
(41192,'enUS','Amazing materials down here. Amazing! Substitutes for everything. Substitutes for substitutes. Everything\'s possible!','',26124),
(41193,'enUS','I\'m ready to begin the assault on the terrace.','I\'m ready to begin the assault on the terrace.',26124),
(41194,'enUS','Explode\'m good!','',26124),
(41195,'enUS','Is that box walking on its own?  Am I going mad?  Quick, someone check the canary!','',26124),
(41196,'enUS','Here, we are even more exposed than before, $r.$b$bWe must find safe shelter soon!','',26124),
(41197,'enUS','We must find your allies and discover the naga motives in this region.$b$bBut first, we must find a more secure location.','',26124),
(41198,'enUS','I feel that we are just scratching the surface of the naga presence here.$b$bI have never seen them so organized and disciplined before.','',26124),
(41199,'enUS','Village... gone.  Family gone.  Naga take... everything.','',26124),
(41200,'enUS','Murloc, I know that you hold the Amulet of Sevine.  I need it.','Murloc, I know that you hold the Amulet of Sevine.  I need it.',26124),
(41201,'enUS','You will never take amulet!  Grol lives forever!','',26124),
(41202,'enUS','You hear a noise behind you.','',26124),
(41203,'enUS','Grol will kill you!','',26124),
(41204,'enUS','What is this? FAKE! Splithoof, $n and the gnomes have tried to fool us. Kill $g him : her;!','',26124),
(41205,'enUS','What is this? FAKE! Splithoof, $n and the goblins have tried to fool us. Kill $g him : her;!','',26124),
(41206,'enUS','Get away from those!','Get away from those!',26124),
(41207,'enUS','What do you think you\'re doing?','What do you think you\'re doing?',26124),
(41208,'enUS','Begone, Horde thief!','Begone, Horde thief!',26124),
(41209,'enUS','You are little more than insects! When I am done with you, I will burn your shrine to the ground!','',26124),
(41210,'enUS','You buy time... but not your lives... my hatchery remains...','',26124),
(41211,'enUS','We\'re coming, $n! Keep her occupied while we loop around for an attack.','',26124),
(41212,'enUS','It\'s been hard on all of us, but we\'re getting by.$B$BYou\'ve just gotta roll up your sleeves and do what needs to be done.','',26124),
(41213,'enUS','The Splithoof Heights centaur have destroyed the oil drilling rig!','',26124),
(41214,'enUS','<The injured soldier\'s pained groans are somewhat distorted by the water.>','<The injured soldier\'s pained groans are somewhat distorted by the water.>',26124),
(41215,'enUS','<The injured soldier appears to still be breathing. Thankfully, his bubble remains intact.>','<The injured soldier appears to still be breathing. Thankfully, her bubble remains intact.>',26124),
(41216,'enUS','<There is a a painful looking gash along the soldier\'s side.>','<There is a a painful looking gash along the soldier\'s side.>',26124),
(41217,'enUS','<It looks as if this solider might be feigning to throw off naga suspicion. It likely saved his life.>','<It looks as if this solider might be feigning to throw off naga suspicion. It likely saved her life.>',26124),
(41218,'enUS','You\'re a welcome sight.','You\'re a welcome sight.',26124),
(41219,'enUS','I was told that losing my mount was a death sentence. Thanks for proving the Admiral wrong.','I was told that losing my mount was a death sentence. Thanks for proving the Admiral wrong.',26124),
(41220,'enUS','You\'re a beautiful, beautiful sight, friend.','You\'re a beautiful, beautiful sight, friend.',26124),
(41221,'enUS','Did everyone else make it? Did the attack succeed?','Did everyone else make it? Did the attack succeed?',26124),
(41222,'enUS','Got it. Thanks.','Got it. Thanks.',26124),
(41223,'enUS','The way to the rendevous point is mostly clear. You should get moving.','The way to the rendevous point is mostly clear. You should get moving.',26124),
(41224,'enUS','You don\'t have to tell me twice.','You don\'t have to tell me twice.',26124),
(41225,'enUS','That is *exactly* what I wanted to hear. Thanks.','That is *exactly* what I wanted to hear. Thanks.',26124),
(41226,'enUS','Looks like I owe you another one.','Looks like I owe you another one.',26124),
(41227,'enUS','I\'m all over that. Thanks.','I\'m all over that. Thanks.',26124),
(41228,'enUS','On my way. Thank you.','On my way. Thank you.',26124),
(41229,'enUS','You\'re almost too good to be true.','You\'re almost too good to be true.',26124),
(41230,'enUS','It was a glorious assault. I\'ll give it that.','It was a glorious assault. I\'ll give it that.',26124),
(41231,'enUS','The souls of the Third Fleet are cursed to roam this shore, for eternity, $r. The Eye of Paleth lay claim to our lives, and trapped us in the mire forevermore.','',26124),
(41232,'enUS','Demon!  I have returned from beyond the grave to destroy you!','',26124),
(41233,'enUS','Death has not erased my memory.  I still know your name...','',26124),
(41234,'enUS','RAKH\'LIKH!  Come, and know demise!','',26124),
(41235,'enUS','Fool of a demon hunter.  How many pieces must I cut you into this time?','',26124),
(41236,'enUS','Enough games!','',26124),
(41237,'enUS','What\'s this?  Loramus... I see, they used the Altar of Storms, didn\'t they?','',26124),
(41238,'enUS','You must feel it already then... the demonic energy entering your heart, your lungs, your soul...','',26124),
(41239,'enUS','Allow me to speed up the process a bit!','',26124),
(41240,'enUS','The pain!  Oh, sweet sassy molassey, the pain!','',26124),
(41241,'enUS','Now, heroes!  Finish me, while Rakh\'likh possesses my body!','',26124),
(41242,'enUS','Quickly!  Use the knife on me!  Time runs short!','',26124),
(41243,'enUS','The delights of death await you.','',26124),
(41244,'enUS','The stone knife!  Use it NOW!  I can\'t maintain control of him for much longer...','',26124),
(41245,'enUS','Return to me!','',26124),
(41246,'enUS','It is done.  Leave me here, then, while I wrestle with Rakh\'likh in the next world.  Your job here is done, heroes.','',26124),
(41247,'enUS','Thank the Light! I\'m saved!','',26124),
(41248,'enUS','Are... Are they dead? The assassins?','',26124),
(41249,'enUS','Is it safe?','',26124),
(41250,'enUS','What in tarnation?','What in tarnation?',26124),
(41251,'enUS','A box that walks?  I should ask Hondo about this... nah, maybe later.','A box that walks?  I should ask Hondo about this... nah, maybe later.',26124),
(41252,'enUS','Oh my.','Oh my.',26124),
(41253,'enUS','Get back to work!  Oh wait... you\'re just a box, never mind.','Get back to work!  Oh wait... you\'re just a box, never mind.',26124),
(41254,'enUS','Shh, mon!  We be hidin\' here.','',26124),
(41255,'enUS','Okrilla doesn\'t like to let us non-orcs into town, but that doesn\'t stop her from putting us to work.  No matter... I prefer it out here anyway.','',26124),
(41256,'enUS','You orcs are lucky... the Warmatron lets you stay in Dreadmaul Hold, while the rest of us get sent out on field duty.  No matter... in some ways, I prefer to be out here than under her roof.','',26124),
(41257,'enUS','','You are in orc territory.  What do you need, $r?',26124),
(41258,'enUS','','Welcome, $g brother: sister;.',26124),
(41259,'enUS','Here goes nothin\'! Keep your fingers crossed, $n!','',26124),
(41260,'enUS','YIPPY! SHE\'S ALL CLOSED UP! NO MORE HORDE BACKDOORIN\' US!','',26124),
(41261,'enUS','Hey, $n, come over here, would ya? I\'ve got something for you to do.','',26124),
(41262,'enUS','$n, over here if you please.','',26124),
(41263,'enUS','Flood\'s not so bad. Not as bad as the ones we\'ve had in Ironforge.','',26124),
(41264,'enUS','You watch your tongue, ya blootered chuff! That was an honest mistake!','',26124),
(41265,'enUS','Aye, you mean the one you caused?','',26124),
(41266,'enUS','You put a floodgate on a channel from the inside and trapped yerself!','',26124),
(41267,'enUS','An\' then you tunneled from the channel straight into a dining hall!','',26124),
(41268,'enUS','We were findin\' carp behind the furniture for weeks!','',26124),
(41269,'enUS','An honest mistake!','',26124),
(41270,'enUS','Well, at least the ale was safe.','',26124),
(41271,'enUS','\'Tis a tragedy, boys. The curse of Menethil be on us all.','',26124),
(41272,'enUS','Aye, and a damn fine job she did of it! But not as good as the Admiral.','',26124),
(41273,'enUS','We held our place here as long as we could, but it still wasn\'t enough.','',26124),
(41274,'enUS','Nobody could hold a place like him, lads. Nobody.','',26124),
(41275,'enUS','Cap\'n, the Virtue hasn\'t set sail in years. It was just sittin\' there.','',26124),
(41276,'enUS','We know, cap\'n.  We know.','',26124),
(41277,'enUS','We have arrived, $n. Does he still live?','',26124),
(41278,'enUS','Blowing','Blowing',26124),
(41279,'enUS','This should warm the lad up!','',26124),
(41280,'enUS','Grol!!','',26124),
(41281,'enUS','You, what have you done?','',26124),
(41282,'enUS','You dare call upon a lord of Skywall, $n? I will destroy you and cast your carcass back down into the pit of slime from whence you crawled!','',26124),
(41283,'enUS','I see... this is the path I must take.  Meet up with me back in the cave, heroes.','',26124),
(41284,'enUS','Holy moley!','',26124),
(41285,'enUS','This is horrible!','',26124),
(41286,'enUS','Hey!  Get out of our mine!','Hey!  Get out of our mine!',26124),
(41287,'enUS','Look out!  It\'s an invading $r!','Look out!  It\'s an invading $r!',26124),
(41288,'enUS','Stand back, or I\'ll pick you to death!','Stand back, or I\'ll pick you to death!',26124),
(41289,'enUS','What?  How\'d you get in here?','What?  How\'d you get in here?',26124),
(41290,'enUS','Gadzooks!  Would ya look at that?','Gadzooks!  Would ya look at that?',26124),
(41291,'enUS','Heavens to Betsy!','Heavens to Betsy!',26124),
(41292,'enUS','Hey!  Somebody\'s ambulatory cube is escaping!','Hey!  Somebody\'s ambulatory cube is escaping!',26124),
(41293,'enUS','I think I\'ve been down in this mine too long.','I think I\'ve been down in this mine too long.',26124),
(41294,'enUS','Look out!  It\'s a box-demon!','Look out!  It\'s a box-demon!',26124),
(41295,'enUS','Looks like somebody\'s getting a special delivery.','Looks like somebody\'s getting a special delivery.',26124),
(41296,'enUS','I need you to do what I say, $r.  If we falter, then we may be playing right into Razelikh\'s hands.  ','',26124),
(41297,'enUS','We appear to be dealing with something far bigger than any in the Earthen Ring had suspected.','',26124),
(41298,'enUS','We appear to be dealing with something far bigger than any in the Earthen Ring had suspected.','',26124),
(41299,'enUS','There is a great concentration of naga just outside of this cavern.$b$bWe were fortunate to reach this place unnoticed.','',26124),
(41300,'enUS','Our soldiers... they\'re all captives now.','',26124),
(41301,'enUS','Many of us tried to escape the naga.$b$bI am the only one who succeeded...','',26124),
(41302,'enUS','I don\'t know why, but those monsters are going out of their way to keep our men alive...','',26124),
(41303,'enUS','Fine!  Amulet take, but $r help Rockpool.','',26124),
(41304,'enUS','We lived under the same waves, breathed the same water, and worshipped the same god.  Why, then, would the naga turn against us?','',26124),
(41305,'enUS','The Eye of Paleth was retrieved and cleansed a long time ago, $c. We thought the curse lifted.','',26124),
(41306,'enUS','Not a year ago, poor old Fitzsimmons passed on, his body ruined by drink.','',26124),
(41307,'enUS','Ever since, now and then, people claim he\'s spoken to them and told them to get the eye...','',26124),
(41308,'enUS','Cursed to roam the earth forever...not even poor Fitzsimmons could escape.','',26124),
(41309,'enUS','Don\'t ask me what you actually brought me, $c. You\'re better off forgetting this ever happened.','',26124),
(41310,'enUS','Hellscream\'s armies march upon us, brothers and sisters!','',26124),
(41311,'enUS','Fight on! Magatha commands it!','',26124),
(41312,'enUS','Do not despair! All is not lost! Not yet!','',26124),
(41313,'enUS','I have seen the future, brothers and sisters, and in it the Horde are no more!','',26124),
(41314,'enUS','We will be victorious! Do not relent!','',26124),
(41315,'enUS','ATTACK! Grimtotem must fall! ALL MUST FALL!','ATTACK! Grimtotem must fall! ALL MUST FALL!',26124),
(41316,'enUS','FOR HELLSCREAM! FOR THE HORDE!','FOR HELLSCREAM! FOR THE HORDE!',26124),
(41317,'enUS','','Goldrinn is the wolf ancient, known as \"Lo\'Gosh\" in the Horde tongue. His tenacity is legendary.$B$BA shrine dedicated to him is in a basin west of the World Tree, but its keepers have fallen silent in the wake of the attack. I fear the worst.$B$BBefore we can move on, you must save the shrine, discover the whereabouts of the wolf ancient, and beat back his foes.',26124),
(41318,'enUS','','Aessina is the spirit of nature, my everlasting companion in both this world and the dream beyond. Her shrine in western Hyjal is at the forefront of the Twilight offensive, and may be ablaze this very moment.$B$B$n, we will never restore Mount Hyjal without Aessina\'s help. Save her shrine from the fires, and save the nearby animals threatened by the blaze. We must do this or the entire mountain is lost.',26124),
(41319,'enUS','','Aviana is the lost guardian of the skies, a bird goddess who perished fighting the demon hordes ten thousand years ago. A shrine is dedicated to her memory just southwest of Nordrassil, within the boughs of a great tree.$B$BThe Druids of the Talon are based within the shrine, and we will need their support. You must aid them. And aid Aviana, should she find her way back into this world...',26124),
(41320,'enUS','','I have dispatched Archdruid Hamuul Runetotem to the burned out husk of the Sanctuary of Malorne. He is behind the front lines, on scorched terrain known as the Flamewake. He is looking into how we can undo the damage, and investigating the whereabouts of the turtle ancient Tortolla.$B$BBut before you can help him, you must first ensure that the Shrine of Aessina to the west is secure and the animals are saved from the flames. Otherwise all is lost! Concentrate on matters at the Grove of Aessina first, and they will send you to the Archdruid in good time.',26124),
(41321,'enUS','Tell me about the Shrine of Goldrinn.','Tell me about the Shrine of Goldrinn.',26124),
(41322,'enUS','What is happening at the Grove of Aessina?','What is happening at the Grove of Aessina?',26124),
(41323,'enUS','How can I help the Shrine of Aviana?','How can I help the Shrine of Aviana?',26124),
(41324,'enUS','Is there something I can do at the Sanctuary of Malorne?','Is there something I can do at the Sanctuary of Malorne?',26124),
(41325,'enUS','','I\'ve tried everythin\' short of a righteous beating to get these dwarves up off their lazy duffs.$B$BAre you made of sterner stuff?',26124),
(41326,'enUS','','Scour the mines! Leave no survivors!',26124),
(41327,'enUS','','The assassin with the most kills will be invited to the feast at the Overlord\'s table!',26124),
(41328,'enUS','','Hellscream\'s eyes are upon you, brothers!',26124),
(41329,'enUS','Khaz Modan will crumble! ALL WILL BE RUINED IN HIS NAME!','',26124),
(41330,'enUS','You cannot stop... the end...','',26124),
(41331,'enUS','LEAVE...THIS PLACE...','',26124),
(41332,'enUS','It may not be quite comfy out here, but it\'s still Khaz Modan, so it\'s still our home.','',26124),
(41333,'enUS','Our town\'s under the blasted ocean, our keep\'s full of Dark Iron traitors, and I\'m laid up with such a wound I can\'t do a single thing about any of it.$B$BSo welcome to Menethil Harbor!','',26124),
(41334,'enUS','Stand back, $n! When \"Cookie\" cooks things be gettin\' crazy!','',26124),
(41335,'enUS','Now to mix it all together and add me special spices!','',26124),
(41336,'enUS','BAM!','',26124),
(41337,'enUS','THE FLAMES SHALL CONSUME YOU! THEY SHALL CONSUME US ALL!','',26124),
(41338,'enUS','Glory... to Ragnaros...','',26124),
(41339,'enUS','Mmmm, mmmm! Smells delicious, \"Cookie!\" Who could resist such a meal? $n, get this meaty offering to the Grimtotem ambassador immediately!','',26124),
(41340,'enUS','Return to the Red Reaches.','',26124),
(41341,'enUS','Ysera has sent me here to make contact with the wilderness spirit of Aessina.$B$BYet the ancient remains silent.','',26124),
(41342,'enUS','We didn\'t bring the war to the Horde, the Horde brought the war to us.','',26124),
(41343,'enUS','Grundig is nearby. Look there.','',26124),
(41344,'enUS','The Horde sends assassins! Kill them all!','',26124),
(41345,'enUS','What\'s this?','What\'s this?',26124),
(41346,'enUS',' Such a powerful weapon!',' Such a powerful weapon!',26124),
(41347,'enUS','The Horde shall tremble before me!','The Horde shall tremble before me!',26124),
(41348,'enUS','The Horde will taste Alliance steel!','The Horde will taste Alliance steel!',26124),
(41349,'enUS','The Horde cannot win!','The Horde cannot win!',26124),
(41350,'enUS','The Horde General\'s chest drops to the ground.','',26124),
(41351,'enUS','Brothers, Vol\'tar has fallen!','',26124),
(41352,'enUS','I shall not suffer the same fate as Vaurajo! Die!','',26124),
(41353,'enUS','Face the fury of the mag\'har!','',26124),
(41354,'enUS','Just when I thought we\'d gotten a break by getting away from those raptors, things get even worse around here.$B$BNo use bellyaching though. We\'re gonna face this like proper dwarves!','',26124),
(41355,'enUS','Don\'t even ask about the raptors. Just don\'t.','',26124),
(41356,'enUS','','Welcome to our home away from home, $c. I wish we had a bit more hospitality to offer.',26124),
(41357,'enUS','','Be careful in the vale, $n. Enemies abound!',26124),
(41358,'enUS','Show me your wares, Lyanath.','Show me your wares, Lyanath.',26124),
(41359,'enUS','','Need to do some shopping?',26124),
(41360,'enUS','Show me your wares, please.','Show me your wares, please.',26124),
(41361,'enUS','Gear all banged up, eh?','',26124),
(41362,'enUS','Gobber, I need to look in my pack.','Gobber, I need to look in my pack.',26124),
(41363,'enUS','<These baby murlocs seem to have been abandoned here.>','',26124),
(41364,'enUS','<These baby Rockpool murlocs seem to have been abandoned here.  You suspect that they are in trouble, and that Neptool would want you to bring them back to the ocean, where they stand a chance of escaping the naga.>','',26124),
(41365,'enUS','<Help the Rockpool tadpoles.>','<Help the Rockpool tadpoles.>',26124),
(41366,'enUS','<Leave them to fend for themselves.>','<Leave them to fend for themselves.>',26124),
(41367,'enUS','Private Reginald Pollard, 13th brigade, Stormwind infantry... $gsir:ma\'am;.','',26124),
(41368,'enUS','How did you get down here?','How did you get down here?',26124),
(41369,'enUS','We had them in our sights... the Horde ships... then out of nowhere, tentacles reached up and seized our ship... broke it right in two!$b$bThe survivors... we were captured by naga as soon as we hit the water.$b$bThat was nearly a week ago.','',26124),
(41370,'enUS','What can you tell me about your captors?','What can you tell me about your captors?',26124),
(41371,'enUS','Strange... never thought the naga would go out of their way to keep us alive.$b$bThey create these pearly bubbles... one per man... made it so we could breathe.$b$bEvery day they send a bunch of the prisoners off... somewhere.$b$bNever see them again....','',26124),
(41372,'enUS','How did you escape, Pollard?','How did you escape, Pollard?',26124),
(41373,'enUS','Ahahahaha! I\'ve always been with the Grimtotem! You fools are all going to die!','',26124),
(41374,'enUS','Another soldier somehow got free and broke a bunch of our pearls... freed us.$b$bSome swam up towards the surface... some saw this cave and swam for it.$b$bI\'m the only one that made it....','',26124),
(41375,'enUS','Ack!  Stay back, $r!','',26124),
(41376,'enUS','Did you see Captain Taylor and his men?','Did you see Captain Taylor and his men?',26124),
(41377,'enUS','No telling...$b$bThey brought new soldiers in every day. Horde and Alliance, both.$b$bSome would get hauled away the same day... others, like me, kept there for a week... maybe more.','',26124),
(41378,'enUS','Are there any weaknesses we can exploit? Any holes in the naga defenses?','Are there any weaknesses we can exploit? Any holes in the naga defenses?',26124),
(41379,'enUS','Don\'t even try, $r.$b$bGet out of here while you can...$b$bThere are too many... certain death...','',26124),
(41380,'enUS','','The blood ritual is complete... and I can now see where Loramus Thalipedes awaits you.',26124),
(41381,'enUS','','Very well.  Stand back... this may get messy.',26124),
(41382,'enUS','You\'ll talk sooner or later!','You\'ll talk sooner or later!',26124),
(41383,'enUS','I hope you like pain.','I hope you like pain.',26124),
(41384,'enUS','When do your people counter-attack? Tell me and I\'ll end your suffering.','When do your people counter-attack? Tell me and I\'ll end your suffering.',26124),
(41385,'enUS','Nothing personal. We\'re just a little tired of being pushed out of our homes. Now it\'s our turn to push back.','Nothing personal. We\'re just a little tired of being pushed out of our homes. Now it\'s our turn to push back.',26124),
(41386,'enUS','Tell me everything, you miserable cow!','Tell me everything, you miserable cow!',26124),
(41387,'enUS','Now that we have Freewind Post, all that\'s left is that stupid barge. Gnome and goblins. How sad your people are.','Now that we have Freewind Post, all that\'s left is that stupid barge. Gnome and goblins. How sad your people are.',26124),
(41388,'enUS','I grow bored with your resistance. I\'m going to kill you now and get my answers from one of your other friends.','I grow bored with your resistance. I\'m going to kill you now and get my answers from one of your other friends.',26124),
(41389,'enUS','I don\'t have time for this! Speak or die!','I don\'t have time for this! Speak or die!',26124),
(41390,'enUS','I would like to start the Amulet Ritual, Lynnore.','I would like to start the Amulet Ritual, Lynnore.',26124),
(41391,'enUS','','With the power within the amulets of Razelikh...',26124),
(41392,'enUS','','... I bind you to his lair!',26124),
(41393,'enUS','The city has been routed. The Azsh\'ir cry your name as a victory call. You\'ve earned much respect this day.','',26124),
(41394,'enUS','I\'d not expected the city to be taken so quickly. It seems we\'ll have much time to prepare for the invasion.','',26124),
(41395,'enUS','','The summoning incantations have been prepared, but we were depending on the Crucible of Nazsharin to draw power for our spell. The artifact must be recovered.',26124),
(41396,'enUS','','Mathias Shaw himself appointed me to assist the night elves.',26124),
(41397,'enUS','','Who are you, $c, to bear such a burden?',26124),
(41398,'enUS','','Protector of the animals...  Slayer of dragons...  Champion of the ancients...',26124),
(41399,'enUS','','My dearest old friend Nordu has bestowed to you a great gift, $r. The gift of life.',26124),
(41400,'enUS','','Now I entrust you with an even greater responsibility.',26124),
(41401,'enUS','','By your hand, this mountain will bloom again. It is yours to protect and defend.',26124),
(41402,'enUS','','See that it thrives. Drive out those who would do it harm. Do this in my name.',26124),
(41403,'enUS','','There will be no second chances, $r.',26124),
(41404,'enUS','$n! You did it! I can\'t believe my eyes... the Inferno is gone... What has Aessina done!?','',26124),
(41405,'enUS','Elune help us.','',26124),
(41406,'enUS','What will become of us? Of Stonetalon?','',26124),
(41407,'enUS','Garrosh Hellscream, curse the day you were born.','',26124),
(41408,'enUS','We teeter on the brink of annihilation. Is there no one left to help us?','',26124),
(41409,'enUS','The future of Kalimdor looks grim.','',26124),
(41410,'enUS','What\'s the damage, Razzle?','',26124),
(41411,'enUS','The Catacylsm has created chaos in Dun Morogh. The troggs have come to the surface in numbers we haven\'t seen before, driving our traditional enemies, the Frostmane trolls, ever closer to our settlements.$B$BIronforge has dispatched my mountaineer company to help deal with the problems.','',26124),
(41412,'enUS','New life from the ashes of old... this is Aessina\'s gift.$B$BWithout you, this miracle never would\'ve happened.','',26124),
(41413,'enUS','<The ancient turns to gaze at you with eyes larger than your entire head. Peering into them is like falling into a deep blue ocean.>','',26124),
(41414,'enUS','May I rest here?','May I rest here?',26124),
(41415,'enUS','Do you have any supplies?','Do you have any supplies?',26124),
(41416,'enUS','When we\'re done here, those Frostmanes will fear us more than the troggs. They\'ll have no choice but to leave.','',26124),
(41417,'enUS','Wha - Where  am I? Are you one of them?','Wha - Where  am I? Are you one of them?',26124),
(41418,'enUS','Is it all over yet?','Is it all over yet?',26124),
(41419,'enUS','Must ... return to ... Irontree!','Must ... return to ... Irontree!',26124),
(41420,'enUS','You\'re not from Twilight\'s Hammer. What is happening out there?','You\'re not from Twilight\'s Hammer. What is happening out there?',26124),
(41421,'enUS','I\'m burned. Badly.','I\'m burned. Badly.',26124),
(41422,'enUS','Twilight\'s Hammer... I heard them screaming and running... are we making a counter-attack?','Twilight\'s Hammer... I heard them screaming and running... are we making a counter-attack?',26124),
(41423,'enUS','The town... demolished! We couldn\'t stop them.','The town... demolished! We couldn\'t stop them.',26124),
(41424,'enUS','They\'ve opened gateways to the Firelands... tell me there\'s still hope!','They\'ve opened gateways to the Firelands... tell me there\'s still hope!',26124),
(41425,'enUS','On your feet, soldier. The ancients are with us, and the mountain is healed!','On your feet, soldier. The ancients are with us, and the mountain is healed!',26124),
(41426,'enUS','We\'re still in this fight? I\'ve got to report to Irontree!','We\'re still in this fight? I\'ve got to report to Irontree!',26124),
(41427,'enUS','Thank you, $c! Back to the fight!','Thank you, $c! Back to the fight!',26124),
(41428,'enUS','The tide has turned? I\'ve got to get back to the fight!','The tide has turned? I\'ve got to get back to the fight!',26124),
(41429,'enUS','I... I think I can make it back to Irontree. We can win this!','I... I think I can make it back to Irontree. We can win this!',26124),
(41430,'enUS','Go on ahead, I\'ll catch up at Irontree\'s emcampment. Thank you!','Go on ahead, I\'ll catch up at Irontree\'s emcampment. Thank you!',26124),
(41431,'enUS','Twilight\'s Hammer is on the run? I\'ve got to get back to the front!','Twilight\'s Hammer is on the run? I\'ve got to get back to the front!',26124),
(41432,'enUS','My weapons are nearby - we can regroup with Irontree.','My weapons are nearby - we can regroup with Irontree.',26124),
(41433,'enUS','Your petty triumphs have been futile. The power of the Twilight\'s Hammer is absolute!','',26124),
(41434,'enUS','Balgaras?! And the others...you were all dead! What foul trick is this?','',26124),
(41435,'enUS','Return to Thal\'darah Overlook, Battlescar Valley, Stonetalon Peak or Thal\'darah Grove or your hippogryph will drop you!','',26124),
(41436,'enUS','Get on!','Get on!',26124),
(41437,'enUS','This whole place is going to blow up! Let\'s go!','This whole place is going to blow up! Let\'s go!',26124),
(41438,'enUS','Get on my hippogryph. We haven\'t much time!','Get on my hippogryph. We haven\'t much time!',26124),
(41439,'enUS','Take my hand, young one.','Take my hand, young one.',26124),
(41440,'enUS','Master Thal\'darah has sent me to rescue you. Climb on!','Master Thal\'darah has sent me to rescue you. Climb on!',26124),
(41441,'enUS','Won\'t somebody help us?','Won\'t somebody help us?',26124),
(41442,'enUS','We\'re all going to die!','We\'re all going to die!',26124),
(41443,'enUS','Orcs everywhere!','Orcs everywhere!',26124),
(41444,'enUS','Where is Master Thal\'darah!?','Where is Master Thal\'darah!?',26124),
(41445,'enUS','HELP!','HELP!',26124),
(41446,'enUS','Thank you, friend.','Thank you, friend.',26124),
(41447,'enUS','I will never forget this act of kindness.','I will never forget this act of kindness.',26124),
(41448,'enUS','I will repay you one day.','I will repay you one day.',26124),
(41449,'enUS','All of Darnassus will know what you have done for us.','All of Darnassus will know what you have done for us.',26124),
(41450,'enUS','I thought I was done for!','I thought I was done for!',26124),
(41451,'enUS','Could we fly higher?','Could we fly higher?',26124),
(41452,'enUS','You are a hero.','You are a hero.',26124),
(41453,'enUS','Thank you. You saved my life.','Thank you. You saved my life.',26124),
(41454,'enUS','Our world needs more heroes like you.','Our world needs more heroes like you.',26124),
(41455,'enUS','I am forever indebted to you, friend.','I am forever indebted to you, friend.',26124),
(41456,'enUS','May Elune watch over you.','May Elune watch over you.',26124),
(41457,'enUS','','I will send some of my priestesses to aid you. Find the artifact quickly so that I can begin summoning our allies for the battles to come.',26124),
(41458,'enUS','You will have some of my best men, do not worry Battlemaiden. Return to us quickly - I am eager to begin hunting the Tidehunter.','',26124),
(41459,'enUS','You shall have your reinforcements, Battlemaiden. I had already intended to collect Kvaldir to labor in Nespirah, so your timing is opportune.','',26124),
(41460,'enUS','I am to hunt the Crucible of Nazsharin. Do you have warriors to assist me?','I am to hunt the Crucible of Nazsharin. Do you have warriors to assist me?',26124),
(41461,'enUS','On your knees!','',26124),
(41462,'enUS','Spirit of Life, lend me your aid!','',26124),
(41463,'enUS','Grant me the clarity to speak with this creature!','',26124),
(41464,'enUS','Earthmender Duarn shuffles uncomfortably.','',26124),
(41465,'enUS','Nothing is happening... something must be preventing me from speaking with her.','',26124),
(41466,'enUS','This creature... she is quite old, and very wise.  We stand to learn a great deal about Vashj\'ir and the naga, if we can only speak with Nespirah.','',26124),
(41467,'enUS','Whenever you\'re ready, Duarn.','Whenever you\'re ready, Duarn.',26124),
(41468,'enUS','Let this be a lesson to all Kvaldir. You are weak! Facing Azshara brings only death.','',26124),
(41469,'enUS','Slink back to your pathetic mist. Return and we will slaughter every last one of you.','',26124),
(41470,'enUS','This old inn isn\'t much to look at anymore, but it makes for a great stronghold.','',26124),
(41471,'enUS','Thank you!','Thank you!',26124),
(41472,'enUS','You\'ve saved my life!','You\'ve saved my life!',26124),
(41473,'enUS','I\'ll be glad to get out of this hellhole.','I\'ll be glad to get out of this hellhole.',26124),
(41474,'enUS','You have no idea what they put us through...','You have no idea what they put us through...',26124),
(41475,'enUS','The naga are monsters!','The naga are monsters!',26124),
(41476,'enUS','I\'m forever in your debt, hero.','I\'m forever in your debt, hero.',26124),
(41477,'enUS','Thank you!','Thank you!',26124),
(41478,'enUS','You\'ve saved my life!','You\'ve saved my life!',26124),
(41479,'enUS','You have no idea what they put us through...','You have no idea what they put us through...',26124),
(41480,'enUS','I\'ll be glad to get out of this hellhole.','I\'ll be glad to get out of this hellhole.',26124),
(41481,'enUS','The naga are monsters!','The naga are monsters!',26124),
(41482,'enUS','I\'m forever in your debt, hero.','I\'m forever in your debt, hero.',26124),
(41483,'enUS','They attacked while you were gone... the Admiral didn\'t make it. The rest retreated to the cave, you should do the same.','They attacked while you were gone... the Admiral didn\'t make it. The rest retreated to the cave, you should do the same.',26124),
(41484,'enUS','Rejoice, for you shall be first to die. We will sweep across Khaz Modan and burn all to ash.','',26124),
(41485,'enUS','I don\'t care how many times I have to kill you...I\'ll take you all on to save this land!','',26124),
(41486,'enUS','','Aye, and so will we!',26124),
(41487,'enUS','Look there! The Krom\'gar balloon is heading towards the grove! We must hurry!','',26124),
(41488,'enUS','We\'re too late. The grove is destroyed and with it our hopes and dreams.','',26124),
(41489,'enUS','The Horde will pay for this atrocity. Hellscream must answer for this crime!','',26124),
(41490,'enUS','What luck! The offerings throw themselves upon the altar!','',26124),
(41491,'enUS','ATTACK! LET NONE SURVIVE!','',26124),
(41492,'enUS','FOR KHAZ MODAN!','FOR KHAZ MODAN!',26124),
(41493,'enUS','Burnnnnnnn...','',26124),
(41494,'enUS','Flesh, living flesh...','',26124),
(41495,'enUS','Give yourself to the flame.','',26124),
(41496,'enUS','Brittle bones and stringy flesh. Come, come! Feed the flames!','',26124),
(41497,'enUS','Blaze bright and fade away, $r.','',26124),
(41498,'enUS','Join me in darkness and fire.','',26124),
(41499,'enUS','Your suffering fans the flames!','',26124),
(41500,'enUS','Become one with the fire!','',26124),
(41501,'enUS','','What is it, Elder? I\'ve never seen anything like it... not even when Teldrassil was sick.',26124),
(41502,'enUS','','I do not know, sentinel. What I sense is dark magic. Pure evil.',26124),
(41503,'enUS','','Is it the Horde? Could they be responsible for the corruption?',26124),
(41504,'enUS','','No, dear, this is something far worse than the Horde. The darkness emanating from Stonetalon Peak is ancient. Older than the world itself.',26124),
(41505,'enUS','','How will we survive, Elder? How can we fend off the Horde and this ancient evil force?',26124),
(41506,'enUS','','I do not know, child.',26124),
(41507,'enUS','','A dark force grips Stonetalon Peak.',26124),
(41508,'enUS','I cannot fathom the origin or purpose of this place.$B$BThese corridors are used for troop movements, yes, but they\'re also littered with charred and tortured corpses, some partially devoured, most simply crushed and beaten.$B$BWe are in the Firelands, but I feel as though we\'ve crossed the threshold into hell.','',26124),
(41509,'enUS','I lost my turtle companion. Can I have another?','I lost my turtle companion. Can I have another?',26124),
(41510,'enUS','Of course, $n. You rescued these turtles from the Twilight\'s Hammer - they will follow you anywhere.','',26124),
(41511,'enUS','How do you get yourself into these messes, Poppy???','',26124),
(41512,'enUS','What is this thing anyway? I\'ll just hit it some more with my wrench. Hopefully the violent beatings will fix whatever is broken.','',26124),
(41513,'enUS','Next time, Poppy... Next time...','',26124),
(41514,'enUS','\"Absolutely, yes, I will take the job in Stonetalon Mountains to fix night elf junk.\" Poppy, you\'re an idiot.','',26124),
(41515,'enUS','Maybe this thing\'s crazy wings will collapse on top of me and put me out of my misery. I\'ll just hit it harder and faster to help speed this along.','',26124),
(41516,'enUS','%s approaches the Nemesis Crystal and cautiously examines it.','',26124),
(41517,'enUS','You will be removed from the Darnassian Glaive Thrower if you do not return to Thal\'darah Overlook or Battlescar Valley.','',26124),
(41518,'enUS','Little $r. You are in MY realm now!','',26124),
(41519,'enUS','If you want your rams back, come get them, cowards!','',26124),
(41520,'enUS','%s is about to erupt! Get under Tooga\'s shell!','',26124),
(41521,'enUS','Does anyone hear something strange?','Does anyone hear something strange?',26124),
(41522,'enUS','There it is again! I know I heard something!','There it is again! I know I heard something!',26124),
(41523,'enUS','Frostmane raiders! Sound the alarm!','Frostmane raiders! Sound the alarm!',26124),
(41524,'enUS','To arms, mountaineers! Take back those rams!','To arms, mountaineers! Take back those rams!',26124),
(41525,'enUS','The Frostmane trolls have been raiding the ranch continuously.','',26124),
(41526,'enUS','As it is, there are barely enough of us to keep them from taking everything.','',26124),
(41527,'enUS','They just take the rams and go. The herd can\'t take any more.','',26124),
(41528,'enUS','One of the mountaineers has seen something. Keep your eyes open!','',26124),
(41529,'enUS','We\'ve done it! Good work, lads!','',26124),
(41530,'enUS','Let\'s speak with Nespirah.','Let\'s speak with Nespirah.',26124),
(41531,'enUS','Kkkk... aaahhh...!','',26124),
(41532,'enUS','What\'s happening?  Can you hear me?','',26124),
(41533,'enUS','I can\'t see you, but I can sense your presence.  I\'ll explain what I can.','',26124),
(41534,'enUS','The naga are suppressing my will.  I can feel what they\'re doing, but I am powerless to act.','',26124),
(41535,'enUS','They mine my pearls, they carve my body, and they distort my mind.  I can feel my will breaking, strangers... they mean to use me for war!','',26124),
(41536,'enUS','I will NOT be a tool of the naga.  I will resist as long as I can, but I can\'t last forever.  Please, someone, stop them!','',26124),
(41537,'enUS','Thank you!','',26124),
(41538,'enUS','I thought I would die down here.','',26124),
(41539,'enUS','I thought they were going to tear me apart!','',26124),
(41540,'enUS','Light bless you, stranger. You\'ve saved me!','',26124),
(41541,'enUS','You\'re the best thing I\'ve seen since the troggs showed up!','',26124),
(41542,'enUS','I can\'t wait to get home to my family. Thank you, stranger.','',26124),
(41543,'enUS','I\'ve tried explaining to Salsbury time and time again that there is no possible way that I could transform him into a worgen. He refuses to listen and has instead convinced himself that if he gains my trust I will let him in on the secret.$B$BGnomes are very strange.','',26124),
(41544,'enUS','Listen up! FALL IN!','',26124),
(41545,'enUS','Overlord Krom\'gar has called for infantry in Stonetalon Mountains.','',26124),
(41546,'enUS','We\'re gonna march in there and do one thing and one thing only:','',26124),
(41547,'enUS','KILL ALLIANCE!','',26124),
(41548,'enUS','','Ahem. Don\'t forget about the bomb, Aldo.',26124),
(41549,'enUS','Correction. We\'re gonna do TWO things:','',26124),
(41550,'enUS','KILL ALLIANCE and make sure our new goblin bomb gets to Stonetalon in one piece...','',26124),
(41551,'enUS','And then use it to KILL ALLIANCE!','',26124),
(41552,'enUS','Now, do I have any volunteers?','',26124),
(41553,'enUS','Sounds good. First battalion prepare yourselves! And never forget...','',26124),
(41554,'enUS','Hellscream\'s eyes are upon you!','',26124),
(41555,'enUS','Her body appears even larger from the inside.  Fascinating!','',26124),
(41556,'enUS','Look, $r.  I see man and orc, chained up as slaves, mining Nespirah\'s pearls.  And I see naga holding the whip.  Something must be done.','',26124),
(41557,'enUS','What\'s this over here?','',26124),
(41558,'enUS','Goldrinn\'s tenacity is the stuff of legend.$B$BWarriors from all walks visit this shrine in hopes of tapping into that kind of battle prowess. ','',26124),
(41559,'enUS','You are too late, you foolsss!  The ancient one\'sss will is broken!  The processs is nearly complete!','',26124),
(41560,'enUS','Now, you will watch as I complete the ritual and turn the beast against you!','',26124),
(41561,'enUS','No!  Nessspirah belongsss to the naga!','',26124),
(41562,'enUS','Aghhh!  My sssphere!','',26124),
(41563,'enUS','No!  My bubble is weakening!','',26124),
(41564,'enUS','Nessspirah!  Why do you turn againssst me?','',26124),
(41565,'enUS','It isss done!  Nessspirah isss mine!!!','',26124),
(41566,'enUS','Hold on tight, it\'s gonna be a bumpy ride. Be on the lookout for night elves!','',26124),
(41567,'enUS','Got another shipment of fresh meat for you, Saurboz. Let\'s hope these ones don\'t end up back as corpses on my wagon like the last battalion.','',26124),
(41568,'enUS','Few things I like more than killing Alliance.','',26124),
(41569,'enUS','What could an orc as depraved as you enjoy more than killing Alliance, Utvoch?','',26124),
(41570,'enUS','You know I can\'t resist tauren women, Donty. They\'re my one weakness...','',26124),
(41571,'enUS','You are a sick, sick orc, Ut.','',26124),
(41572,'enUS','More fodder for the Horde war machine.','',26124),
(41573,'enUS','Looks like we\'ve got some of Rockrain\'s soldiers here. Dontrag, Utvoch, we\'re gonna need your expertise over at Krom\'gar Fortress.','',26124),
(41574,'enUS','As for the rest of you grunts, suit up! We got some killin\' to do.','',26124),
(41575,'enUS','In all my days, $r, I\'ve never seen such a thing...','',26124),
(41576,'enUS','We are poorly equipped to do battle here.$b$bPreparations must be made...','',26124),
(41577,'enUS','Yes, sir! Let\'s go Ut.','',26124),
(41578,'enUS','You got shiny?','',26124),
(41579,'enUS','What\'s it got in its pockets? Hmm?','',26124),
(41580,'enUS','We kill them and we take their stuffs...','',26124),
(41581,'enUS','What you bring us? Treasures from the surface?','',26124),
(41582,'enUS','Morale is growing higher, thanks to your efforts, $c.','',26124),
(41583,'enUS','If we find a way to fight our way out of here, Hellscream will know of your deeds, $r.','',26124),
(41584,'enUS','These orcs and I have served together through many battles.$b$bI do not envy any naga that enters this place.','',26124),
(41585,'enUS','They\'re upon us! Hurry, $n, my axe thirsts for the blood of these naga!','',26124),
(41586,'enUS','The naga! They\'ve followed $n back to the ship!','',26124),
(41587,'enUS','He never gave up - Captain Irontree - said he\'d make them pay for every inch of ground they defile. He may still be alive down there!','',26124),
(41588,'enUS','Blood and Thunder!','',26124),
(41589,'enUS','For Hellscream!','',26124),
(41590,'enUS','Axes ready! The enemy approaches!','',26124),
(41591,'enUS','They swarm us, shaman! Make yourself useful!','',26124),
(41592,'enUS','Keep your wits, warriors! There are naga yet to kill!','',26124),
(41593,'enUS','%s gasps for air and shivers in the cold.','%s gasps for air and shivers in the cold.',26124),
(41594,'enUS','Mix and stir, apply heat...','',26124),
(41595,'enUS','How well does the mortal shell handle extreme temperature change? Must find out! For science!','',26124),
(41596,'enUS','This one\'s a little unstable, but what\'s progress without failure?','',26124),
(41597,'enUS','I have secured escape for us, $n.  You are to come with me.','',26124),
(41598,'enUS','Duarn - excellent work.  Do not dally long within Nespirah\'s shell.  You know as well as I do the dangers posed by an angry demigod.','',26124),
(41599,'enUS','Now, follow me!','',26124),
(41600,'enUS','Board the seahorse, friend.  You probably do not want to be near Nespirah when she turns on the naga.','',26124),
(41601,'enUS','K-k-k-k-kkkah!  I am freed from the naga\'s servitude, and my will is once again my own!','',26124),
(41602,'enUS','My body is already starting to fight the naga infection.  Please, I ask you to get to safety before I unleash my wrath!','',26124),
(41603,'enUS','You may leave now, friend.  The tauren\'s friend Erunak should be waiting outside with seahorses.  In fact, it looks like he is here now.','',26124),
(41604,'enUS','Worry not, Erunak.  The tauren will be safe.','',26124),
(41605,'enUS','What are we waiting for?  Let\'s go!','What are we waiting for?  Let\'s go!',26124),
(41606,'enUS','Warriors! Make \'em Bleed!','',26124),
(41607,'enUS','For the Horde!','',26124),
(41608,'enUS','Stand your ground... fight!','',26124),
(41609,'enUS','Fight like the orcs you were born to be! There is no retreat!','',26124),
(41610,'enUS','We are... beaten. Escape if you can...','',26124),
(41611,'enUS','Thrall\'s balls! They\'re everywhere...','',26124),
(41612,'enUS','Nazgrim! They have me....','',26124),
(41613,'enUS','Grahhhh!!','',26124),
(41614,'enUS','%s becomes impaled on the spike, exposing his head!','',26124),
(41615,'enUS','Amazing!','',26124),
(41616,'enUS','This job is well-suited for you, Duarn.  I must attend to matters outside.','',26124),
(41617,'enUS','Good luck to you too, $n.','',26124),
(41618,'enUS','','Let me have a look at that shard, would you Captain?  I could feel its power radiating from the other side of the cave.',26124),
(41619,'enUS','Not good enough....','',26124),
(41620,'enUS','Can\'t complain about the materials down here. Substitutes for everything. Substitutes for substitutes. Gimme a few days and I\'ll build a aquatic hotrod out of kelp and shells!','',26124),
(41621,'enUS','The Horde has lost control of the Stoneward Prison!','',26124),
(41622,'enUS','The Alliance has lost control of the Stoneward Prison!','',26124),
(41623,'enUS','The Alliance has taken control of the Stoneward Prison!','',26124),
(41624,'enUS','The Horde has taken control of the Stoneward Prison!','',26124),
(41625,'enUS','When pushed to the edge, results may become unpredictable...','',26124),
(41626,'enUS','The Horde has lost control of Merchant Quarter!','',26124),
(41627,'enUS','The Alliance has lost control of Merchant Square!','',26124),
(41628,'enUS','The Alliance has taken control of Merchant Quarter!','',26124),
(41629,'enUS','The Horde has taken control of Merchant Quarter!','',26124),
(41630,'enUS','The Horde has lost control of the Cathedral Quarter!','',26124),
(41631,'enUS','The Alliance has lost control of the Cathedral Quarter!','',26124),
(41632,'enUS','The Alliance has taken control of the Cathedral Quarter!','',26124),
(41633,'enUS','The Horde has taken control of the Cathedral Quarter!','',26124),
(41634,'enUS','The Horde has lost control of Greymane Court!','',26124),
(41635,'enUS','The Alliance has lost control of Greymane Court!','',26124),
(41636,'enUS','The Alliance has taken control of Greymane Court!','',26124),
(41637,'enUS','Oh gods! It\'s not dead! RUN!','',26124),
(41638,'enUS','The Horde has taken control of Greymane Court!','',26124),
(41639,'enUS','Don\'t eat my head!','',26124),
(41640,'enUS','I\'m too young to die! Hell, I\'m too pretty to die!','',26124),
(41641,'enUS','HELP!','',26124),
(41642,'enUS','Somebody kill it!','',26124),
(41643,'enUS','Mommy!','',26124),
(41644,'enUS','It\'s all your fault! It was supposed to be dead! Now it ate your brains!','',26124),
(41645,'enUS','Get away! Get away!','',26124),
(41646,'enUS','We\'re all going to die!','',26124),
(41647,'enUS','|cFF68228BDIE.|r','|cFF68228BDIE.|r',26124),
(41649,'enUS','|cFF68228BI COME FROM BELOW.|r','|cFF68228BI COME FROM BELOW.|r',26124),
(41650,'enUS','|cFF68228BINSIGNIFICANT MORTALS.|r','|cFF68228BINSIGNIFICANT MORTALS.|r',26124),
(41651,'enUS','|cFF68228BYOU WILL SERVE ME AND THEN DIE PAINFULLY.|r','|cFF68228BYOU WILL SERVE ME AND THEN DIE PAINFULLY.|r',26124),
(41652,'enUS','|cFF68228BI SEE YOU.|r','|cFF68228BI SEE YOU.|r',26124),
(41653,'enUS','|cFF68228BYOUR WORLD CRUMBLES BEFORE YOU.|r','|cFF68228BYOUR WORLD CRUMBLES BEFORE YOU.|r',26124),
(41654,'enUS','|cFF68228BYOU WILL NOT SURVIVE.|r','|cFF68228BYOU WILL NOT SURVIVE.|r',26124),
(41655,'enUS','|cFF68228BYOUR SIMPLE MIND CANNOT GRASP WHAT IS TRANSPIRING.|r','|cFF68228BYOUR SIMPLE MIND CANNOT GRASP WHAT IS TRANSPIRING.|r',26124),
(41656,'enUS','','Filthy beast!',26124),
(41657,'enUS','','Leave our lands!',26124),
(41658,'enUS','','Not so fast!',26124),
(41659,'enUS','This place isn\'t quite as cool as the ruins, and the air in here is a bit humid if I do say so myself, but it does have a comfy, home feel to it.$B$BDon\'t you think?','',26124),
(41660,'enUS','Hexascrub, let me see that merciless one again.','Hexascrub, let me see that merciless one again.',26124),
(41661,'enUS','I don\'t know about you, but I really miss the unlimited raw materials that were down in the ruins!$B$BI\'m not even sure if I could make a dud grenade out of the little that can be scrounged in this cave!','',26124),
(41662,'enUS','Fiasco, I need to see that merciless corpse again.','Fiasco, I need to see that merciless corpse again.',26124),
(41663,'enUS','Naga.$B$B<Vilethorn spits on the ground in disgust.>$B$BIt was foolish of them to think they could make an orc labor at their whip. We will make every last one of them regret not killing us when they had the chance.','',26124),
(41664,'enUS','Welcome, friend.\n\nWe have little to offer by way of supplies, but I will assist you however I can.','',26124),
(41665,'enUS','My rescue plan is brilliant. Infallible. Only a goblin could possibly stop me from succeeding. A goblin with fins. Scary thought.','',26124),
(41666,'enUS','Gah! Orcs... This is gunna take some gettin\' used to...','',26124),
(41667,'enUS','','Wake up, Mr. D!',26124),
(41668,'enUS','Return to Durotar!','',26124),
(41669,'enUS','','All good girls listen to their daddies!',26124),
(41670,'enUS','','Are you there, Mr. D?',26124),
(41671,'enUS','','Wake up, Mr. D! You\'ve gotta save the spirits!',26124),
(41672,'enUS','What the... $n?','',26124),
(41673,'enUS','','This is marbles and conkers!',26124),
(41674,'enUS','','This is crazy you idiots!',26124),
(41675,'enUS','From the moment the wild creatures first stirred on Azeroth, Goldrinn was there. His is the spirit of the hunter, the animal instinct that kicks in when wild things smell food or feel their children are in jeopardy. He appears as a great white wolf, ferocious and cunning.$B$BHe\'s known across all cultures. The orcs even have their own name for him: \"Lo\'Gosh.\"$B$BTen thousand years ago, when demons first breached Azeroth, Goldrinn stood with the other ancients to mount a desperate defense.','',26124),
(41676,'enUS','It was during those darkest of days that Goldrinn\'s tenacity in war became legendary. While others quaked at the visage of those demon hordes, their multitudes only spurred the great wolf ancient to ever greater feats of strength. He would wade into their ranks, fangs bared and spattered with their vile ichor, his great claws thrashing them by the dozen...$B$BIt was said he stayed behind to cover the Night Elf retreat from Eldre\'Thalas, the ancient city we know now as Dire Maul.$B$BDid he die? I\'m not certain the spirit of animal ferocity can ever truly die, $n.','',26124),
(41677,'enUS','Coming or going?','',26124),
(41678,'enUS','Let me see your wares, Felonius.','Let me see your wares, Felonius.',26124),
(41679,'enUS','The tenacity of the wolf ancient is the stuff of legend.$B$BLearn from his example, $c, and victory is all but certain.','',26124),
(41680,'enUS','Lo\'Gosh is the spirit of the hunter, the animal instinct that kicks in when one smells food or sees one\'s children in jeopardy. He has always been with us, a part of our Horde, in our instincts and in our blood.$B$BHe has appeared in many forms, both on our world and here. On Azeroth, he is seen as a great white wolf, ferocious and cunning. The night elves call him \"Goldrinn.\"$B$BThey tell of a legendary battle ten thousand years ago, where Lo\'Gosh fought off the demon hordes. Do you want to hear about it?','',26124),
(41681,'enUS','Ten thousand years ago demons first breached this world, just as they had the orc homeworld of Draenor. They flooded across the terrain in legion. The great ancients of Azeroth helped the mortal races to mount a desperate defense.$B$BThe tenacity of Lo\'Gosh in these dark days became the stuff of legend. He feared no demon. He would wade into their ranks, fangs bared and spattered with their vile ichor, his great claws thrashing them by the dozen...$B$BHis stand against the demons inspires us all. We can all learn from his example.','',26124),
(41682,'enUS','','Fair Aviana, the Mistress of Birds! All winged creatures of Azeroth once owed her allegiance, especially we Druids of the Talon. It\'s by her grace that we were granted the ability to shift forms and take to the skies.$B$BAviana was both beautiful and terrible, like the great birds of prey she counted among her children. She lived in the towering spirit realm of G\'Hanir, the Mother Tree, but appeared on Azeroth in the form of a great winged goddess.',26124),
(41683,'enUS','','<Choluna\'s face darkens.>$B$BTen thousand years ago demons flooded across Azeroth in the War of the Ancients. Aviana called her children to the skies and fought off the demon hordes from the front lines. Her wrath was inescapable.$B$BHundreds fell before the fury of her talons. But ultimately she was surrounded by Doomguards, their barbed lances piercing her sides...$B$BIt is said that her blood itself attacked the demons, searing their flesh, destroying them even as she herself fell from the sky.',26124),
(41684,'enUS','','Aviana perished on the battlefield that day, but the mortal races and the remaining ancients ultimately triumphed. The first druids found her body among the carnage, and bore it up here, to the highest mountain.$B$BShe was laid to rest just outside this shrine, within a circle of sacred stones.$B$BA seed of G\'Hanir was used to plant the World Tree, and it is all that remains of that sacred realm, which otherwise perished with her.',26124),
(41685,'enUS','','We mortal races know so little of Aessina, the spirit of the wilderness who lurks in dense untamed woods. She is the soul of the forest, its beating heart, the source of life energy that breaks down stone, devours ancient ruins, and fills dense thickets with mystery and fear. Aessina is the center of the web of life.$B$BThe night elves have built shrines to her throughout Kalimdor. She is revered, yes... But not understood.$B$BWhat would it be like, do you think, to get even a glimpse of this reclusive, powerful ancient?  ',26124),
(41686,'enUS','Ah, Tortolla! Often misunderstood and always, always underestimated. Creatures who move effortlessly between land and sea look to Tortolla as their patron ancient.$B$BTen thousand years ago the Burning Legion invaded Azeroth, and Tortolla was among the ancients who took to the field of battle alongside Cenarius and the mortal races.$B$BAs the demon hordes crashed against the front lines of the beleaguered defenders, they didn\'t know what to make of Tortolla. At first they tried to ignore him, but his terrible weight and crushing jaws laid waste to hundreds...','',26124),
(41687,'enUS','Tortolla never fell. Eventually the greatest Doomguards of the legion surrounded him, but couldn\'t pierce his stony skin and invulnerable shell. Oh, how they raged! Tortolla held his ground and covered a final retreat, before the mortal races regrouped and managed to seal the portal and end the invasion.$B$BIt was said that after the battle, Tortolla was found underneath a mountain of demon corpses. He shook the bodies free and his head emerged from the gore. Then, quietly, slowly... he asked if we had won.$B$B<Hamuul rests a hand on his stomach and bellows a deep, unselfconscious laugh.>','',26124),
(41688,'enUS','Tell me about Goldrinn.','Tell me about Goldrinn.',26124),
(41689,'enUS','What happened to him?','What happened to him?',26124),
(41690,'enUS','Tell me about the wolf ancient, Lo\'Gosh.','Tell me about the wolf ancient, Lo\'Gosh.',26124),
(41691,'enUS','Yes, tell me more.','Yes, tell me more.',26124),
(41692,'enUS','','Welcome, $c!',26124),
(41693,'enUS','Tell me about Aviana.','Tell me about Aviana.',26124),
(41694,'enUS','You speak in the past tense. What happened to her?','You speak in the past tense. What happened to her?',26124),
(41695,'enUS','What became of her?','What became of her?',26124),
(41696,'enUS','Tell me about the spirit of Aessina.','Tell me about the spirit of Aessina.',26124),
(41697,'enUS','Tell me about Tortolla.','Tell me about Tortolla.',26124),
(41698,'enUS','The Earthwatchers won\'t allow faction squabbling to jeopardize the Earthen Ring\'s work here.\n\nThose who break the peace will be dealt with... harshly.','',26124),
(41699,'enUS','Then what happened?','Then what happened?',26124),
(41700,'enUS','The Wildhammers have always embraced shamanism, aye, but to find ourselves beneath the sea as part of the Earthen Ring?\n\nIt would\'ve taken more than a few tankards for me to believe that one, a year ago.','',26124),
(41701,'enUS','Further attuning yourself with the Battlemaiden, you have gained a new ability!','Further attuning yourself with the Battlemaiden, you have gained a new ability!',26124),
(41702,'enUS','Our warriors... they\'re all captives now.','',26124),
(41703,'enUS','Many of us tried to escape the naga.$b$bI am the only one who succeeded...','',26124),
(41704,'enUS','It makes no sense, but those vermin are going to great lengths to keep our troops alive...','',26124),
(41705,'enUS','Tell me your name, orc.','Tell me your name, orc.',26124),
(41706,'enUS','I am Gurrok, of Hellscream\'s Vanguard.','',26124),
(41707,'enUS','How did you get down here?','How did you get down here?',26124),
(41708,'enUS','We had them!$b$bWretched Alliance ships... we could\'ve cut a path to Stormwind and put an end to them!$b$b...But out of nowhere, gigantic tentacles reached up and seized our ship... broke it right in two!$b$bThe survivors... we were captured by naga as soon as we hit the water.','',26124),
(41709,'enUS','Tell us about your captors, Gurrok.','Tell us about your captors, Gurrok.',26124),
(41710,'enUS','Strange that the naga would go out of their way to keep us alive.$b$bThey create prisons from mystical pearls - cells that allowed us to breathe, but little else..$b$bThey ship the prisoners off... somewhere.$b$bNever see them again....','',26124),
(41711,'enUS','How were you able to get away?','How were you able to get away?',26124),
(41712,'enUS','One of our warriors broke free and smashed many of the prisons... we were free - at least for a moment.$b$bSome swam up towards the surface... some saw this cave and swam for it.$b$bI\'m the only one that lived....','',26124),
(41713,'enUS','Grunts, ATTENTION!','',26124),
(41714,'enUS','Did you see Nazgrim and his troops?','Did you see Nazgrim and his troops?',26124),
(41715,'enUS','I do not know what became of them.$b$bThere was a constant flow of captives. Horde and Alliance, both - all barely alive.$b$bThey must\'ve been hauled away beyond the trench, or they have perished.','',26124),
(41716,'enUS','What is there to report of these beasts, Gurrok? How do we defeat them?','What is there to report of these beasts, Gurrok? How do we defeat them?',26124),
(41717,'enUS','Their numbers are too many to count. Their defenses look impenetrable.$b$bI saw no weaknesses to exploit, $r.','',26124),
(41718,'enUS','You hold still, fish!','',26124),
(41719,'enUS','Why must you taunt me so?','',26124),
(41720,'enUS','Oh, Captain Jewels is going to be angry...','',26124),
(41721,'enUS','Get... back... over... here...','',26124),
(41722,'enUS','AHA! A FISH!','',26124),
(41723,'enUS','Here, fishie fishie...','',26124),
(41724,'enUS','I am perplexed. Troubled by what I witness...','',26124),
(41725,'enUS','','Get me out of here!',26124),
(41726,'enUS','','Who puts a \"dead\" sea demon on their head, really?!',26124),
(41727,'enUS','','Fiasco, you\'re an idiot! Next time just blow something up!',26124),
(41728,'enUS','','Why am I afraid of this?',26124),
(41729,'enUS','','I want to go home!',26124),
(41730,'enUS','','Why did I ever leave Brill?',26124),
(41731,'enUS','','Do not EVER bring cyclopean demonic octopi into the cove again!',26124),
(41732,'enUS','','Somebody kill it!',26124),
(41733,'enUS','','Nutmegs don\'t fail me now!',26124),
(41734,'enUS','','I\'m jumping jack in Gilneas on the spot!',26124),
(41735,'enUS','','Hexascrub, you elekk\'s trunk? You haven\'t got a pot of glue!',26124),
(41736,'enUS','','You\'re all fore and aft for putting that on!',26124),
(41737,'enUS','','Knock it off of their lump of lead!',26124),
(41738,'enUS','','You\'ve gone mum and dad, you have!',26124),
(41739,'enUS','','I\'m gonna need me a good ol\' tiddlywink after this!',26124),
(41740,'enUS','How has our revered Warchief failed you?','',26124),
(41741,'enUS','','What\'s that rabbit and pork it\'s going on about?',26124),
(41742,'enUS','Your families no longer starve.','',26124),
(41743,'enUS','Your loved ones live with shelter over their heads.','',26124),
(41744,'enUS','Ambassador. We have been expecting you.','',26124),
(41745,'enUS','You may walk through the streets of Orgrimmar with pride!','',26124),
(41746,'enUS','We are the new Horde, and under Warchief Hellscream, we are masters of our own destinies.','',26124),
(41747,'enUS','WHY THEN, have we failed to take Stonetalon Mountains?','',26124),
(41748,'enUS','How have the Alliance been able to halt the great Horde war machine?','',26124),
(41749,'enUS','From this day forth, failure is no longer an option.','',26124),
(41750,'enUS','Under Hellscream\'s watchful guise, live or die, we take Stonetalon.','',26124),
(41751,'enUS','Do not falter, for Hellscream\'s eyes are upon you all!','',26124),
(41752,'enUS','Looking through the portal only nets you an eye full of sand.  A pool of water surrounded by desert ruins is all that you can make out.  Where could this portal lead?','',26124),
(41753,'enUS','Enter the Portal.','Enter the Portal.',26124),
(41754,'enUS','The portal shows old, ancient desert ruins.  The wind picks up, there must be a sandstorm brewing inside.  This portal must lead somewhere important, but where?','',26124),
(41755,'enUS','Enter the Portal.','Enter the Portal.',26124),
(41756,'enUS','You fools stop running around! Face it!','',26124),
(41757,'enUS','Somebody knock that thing off of $n\'s head!','',26124),
(41758,'enUS','Hellscream\'s eyes are upon us all!','',26124),
(41759,'enUS','Angry, want kill gong plz.','',26124),
(41760,'enUS','A large humanoid hand print is embedded on the surface of the orb. A soft green glow seems to pulse within.','',26124),
(41761,'enUS','','These lands are the frontier of the Dark Lady\'s conquest, $n. Look upon them; in time, it shall all be in the grasp of the Forsaken.',26124),
(41762,'enUS','Ha ha ha ha ha! The heroes have made it to the glorious finale. I take it you are in good spirits? Prepared for the final battle? Then gaze now upon my ultimate creation! RISE, SISTER!','',26124),
(41763,'enUS','Help me!','Help me!',26124),
(41764,'enUS','Who is doing this to us?','Who is doing this to us?',26124),
(41765,'enUS','What is happening?','What is happening?',26124),
(41766,'enUS','The Dark Lady watch over you...','',26124),
(41767,'enUS','How can I keep a clean inn with all of this going on? Are you going to take care of this pygmy problem?','',26124),
(41768,'enUS','Goblin zombies?! What\'s next... the volcano exploding?','',26124),
(41769,'enUS','The crucible looks abandoned and powerless.$BPerhaps there is a place nearby where you can attune yourself to the Battlemaiden...','The crucible looks abandoned and powerless.$BPerhaps there is a place nearby where you can attune yourself to the Battlemaiden...',26124),
(41770,'enUS','','Hooray, Mr. D! You\'re back! Do you remember how to shoot all your guns? Why don\'t you take a minute to learn how to fight again! Just in case.',26124),
(41771,'enUS','','Be really careful, Mr. D. If you see a big group of gnomes, use your magnetic pull! Once you\'ve got \'em all sucked up, launch \'em to their death! YAY!',26124),
(41772,'enUS','','Get \'em, Mr D!',26124),
(41773,'enUS','','Break their bones!',26124),
(41774,'enUS','','Make \'em sorry for hurting you, Mr. D!',26124),
(41775,'enUS','','YAY!',26124),
(41776,'enUS','','Hurt \'em some more! MORE!',26124),
(41777,'enUS','','BAD, BAD, ALLIANCE!',26124),
(41778,'enUS','I\'m ready to help with Mr. D, kid. Let me in.','I\'m ready to help with Mr. D, kid. Let me in.',26124),
(41779,'enUS','','Return to the temple immediately. The ritual will begin soon.',26124),
(41780,'enUS','','The Lady has requested you back at the temple, Honor Guard.',26124),
(41781,'enUS','','You\'re relieved, Honor Guard. Return to the temple.',26124),
(41782,'enUS','','Back to the temple. I will pick up the slack here.',26124),
(41783,'enUS','','The Lady has sent word for your return to the temple. Do not delay.',26124),
(41784,'enUS','','The priestesses will require your aid soon. The Lady requests your return.',26124),
(41785,'enUS','','Fall back for the ritual. Our Lady awaits.',26124),
(41786,'enUS','','The Mistress of the Tides will need your defense back at the temple. Make your way there immediately.',26124),
(41787,'enUS','','Yes, Battlemaiden?',26124),
(41788,'enUS','Lady Sira\'kess has sent for you. You are needed for the ritual.','Lady Sira\'kess has sent for you. You are needed for the ritual.',26124),
(41789,'enUS','','I will head there immediately Battlemaiden. Thank you.',26124),
(41790,'enUS','','In Azshara\'s name.',26124),
(41791,'enUS','','The Tidehunter will fall.',26124),
(41792,'enUS','','I hope that you will grace our defense with your trident. The Kvaldir numbers are still increasing.',26124),
(41793,'enUS','','You do me an honor by delivering this message, Battlemaiden.',26124),
(41794,'enUS','','For her grace, Lady Naz\'jar.',26124),
(41795,'enUS','','I will find the Mistress of the Tides immediately. Thank you for delivering this message, Battlemaiden.',26124),
(41796,'enUS','','I see. Thank you for informing me personally, Battlemaiden.',26124),
(41797,'enUS','Battlemaiden, you honor me with your presence. Is it time for the ritual to commence?','',26124),
(41798,'enUS','Yes, Fathom-Caller. The Mistress awaits.','Yes, Fathom-Caller. The Mistress awaits.',26124),
(41799,'enUS','Of course. I will finish shortly and meet the Mistress at the temple. Thank you, Battlemaiden.','',26124),
(41800,'enUS','As you say, my lady.','As you say, my lady.',26124),
(41801,'enUS','At once, my lady.','At once, my lady.',26124),
(41802,'enUS','By your order.','By your order.',26124),
(41803,'enUS','Immediately, my lady.','Immediately, my lady.',26124),
(41804,'enUS','Understood, my lady.','Understood, my lady.',26124),
(41805,'enUS','I will not delay.','I will not delay.',26124),
(41806,'enUS','Of course, my lady.','Of course, my lady.',26124),
(41807,'enUS','On my way.','On my way.',26124),
(41808,'enUS','Oof! You touch naughty spot!','',26124),
(41809,'enUS','Which way to go???','',26124),
(41810,'enUS','Tanks!','',26124),
(41811,'enUS','You is friend. Tanks!','',26124),
(41812,'enUS','Why dis happen???','',26124),
(41813,'enUS','The rifts are down and Stormwind is safe!  These portals must be the second half of their attack.$B$BQuickly! Into the portal! We must press the attack while we have the advantage!','',26124),
(41814,'enUS','You will be crushed in the depthsss!','',26124),
(41815,'enUS','Help!','Help!',26124),
(41816,'enUS','Let me out!','Let me out!',26124),
(41817,'enUS','Are we under attack?','Are we under attack?',26124),
(41818,'enUS','Get me out of here!','Get me out of here!',26124),
(41819,'enUS','Let no one forget the name, $n, a true champion and savior of Stormwind!  All hail $n!','Let no one forget the name, $n, a true champion and savior of Stormwind!  All hail $n!',26124),
(41820,'enUS','%s is attracted by your dangling lure!','',26124),
(41821,'enUS','Long live the Dark Iron!','',26124),
(41822,'enUS','Return to Holding Pens!','',26124),
(41823,'enUS','FIRE!','',26124),
(41824,'enUS','DESTROY THEM ALL!','',26124),
(41825,'enUS','MORE INCOMING! FIRE! FIRE!','',26124),
(41826,'enUS','TEAR THE SKY ASUNDER!','',26124),
(41827,'enUS','FOR THE HORDE!','',26124),
(41828,'enUS','OOF!','',26124),
(41829,'enUS','I\'M HIT!','',26124),
(41830,'enUS','HELP! HELP!','',26124),
(41831,'enUS','ALLIANCE ALL OVER THE PLACE!','',26124),
(41832,'enUS','THIS WHOLE PLACE IS GONNA BLOW!','',26124),
(41833,'enUS','Throm-ka, Legionnaire!','Throm-ka, Legionnaire!',26124),
(41834,'enUS','Lok\'tar ogar!','Lok\'tar ogar!',26124),
(41835,'enUS','Bow your heads! $n walks among us!','Bow your heads! $n walks among us!',26124),
(41836,'enUS','$g Sir:Ma\'am;!','$g Sir:Ma\'am;!',26124),
(41837,'enUS','There walks a true soldier of the Horde!','There walks a true soldier of the Horde!',26124),
(41838,'enUS','For the Horde!','For the Horde!',26124),
(41839,'enUS','Hellscream\'s eyes are upon you!','Hellscream\'s eyes are upon you!',26124),
(41840,'enUS','','Back!',26124),
(41841,'enUS','Why must we ride to battle on a mercenary ship? Used to be that we\'d kill pirates as soon as look at them.','',26124),
(41842,'enUS','','Shoo!',26124),
(41843,'enUS','','I don\'t want to hurt you, but I will!',26124),
(41844,'enUS','','Smell blood, do you?',26124),
(41845,'enUS','','You\'ll not be eating me today!',26124),
(41846,'enUS','','Away, creature of the depths!',26124),
(41847,'enUS','','Do not force me to call upon the lightning!',26124),
(41848,'enUS','','Stay away from Wil\'hai!',26124),
(41849,'enUS','See those ships in dock?','',26124),
(41850,'enUS','They\'re the only ones that have returned from battle, and they\'re being repaired.','',26124),
(41851,'enUS','I don\'t like it either, but it boils down to this...','',26124),
(41852,'enUS','We pay the mercs to get us out there, or our troops get no reinforcements.','',26124),
(41853,'enUS','That makes sense, I suppose. Just doesn\'t feel right...','',26124),
(41854,'enUS','','What you want?',26124),
(41855,'enUS','Show me your goods, Denni\'ka.','Show me your goods, Denni\'ka.',26124),
(41856,'enUS','Welcome to the military, recruit.','',26124),
(41857,'enUS','OK! OK! Me do what $r wants!','',26124),
(41858,'enUS','Please no whip me! Me help Horde!','',26124),
(41859,'enUS','Hurts! Stop!','',26124),
(41860,'enUS','No more hurt! Me join you!','',26124),
(41861,'enUS','NO! ME NO HELP HORDE!','',26124),
(41862,'enUS','Whip make me angry!','',26124),
(41863,'enUS','Me shove whip down face!','',26124),
(41864,'enUS','Me make you eat whip!','',26124),
(41865,'enUS','You is BAD $r!','',26124),
(41866,'enUS','ME SO ANGRY!','',26124),
(41867,'enUS','Such power! I AM INVINCIBLE!','Such power! I AM INVINCIBLE!',26124),
(41868,'enUS','For the Horde!','For the Horde!',26124),
(41869,'enUS','ALL WILL PERISH!','ALL WILL PERISH!',26124),
(41870,'enUS','Death to the Grimtotem!','Death to the Grimtotem!',26124),
(41871,'enUS','Death to the Alliance!','Death to the Alliance!',26124),
(41872,'enUS','Cower before the Horde!','Cower before the Horde!',26124),
(41873,'enUS','KILL PINK SKINS! KILL! KILL!','',26124),
(41874,'enUS','Champion $n!','Champion $n!',26124),
(41875,'enUS','You bring great pride to the Horde, Champion $n.','You bring great pride to the Horde, Champion $n.',26124),
(41876,'enUS','Orders, $g sir:ma\'am;?','Orders, $g sir:ma\'am;?',26124),
(41877,'enUS','Champion $n fights alongside us! We cannot lose!','Champion $n fights alongside us! We cannot lose!',26124),
(41878,'enUS','$g Sir:Ma\'am;, would you sign my weapon? My young ones would be most thankful.','$g Sir:Ma\'am;, would you sign my weapon? My young ones would be most thankful.',26124),
(41879,'enUS','The Alliance must fall!','The Alliance must fall!',26124),
(41880,'enUS','For the Horde! For Hellscream!','For the Horde! For Hellscream!',26124),
(41881,'enUS','It is an honor to stand in your presence, Champion $n.','It is an honor to stand in your presence, Champion $n.',26124),
(41882,'enUS','Hey! Hey Jibbly! This place STINKS!','Hey! Hey Jibbly! This place STINKS!',26124),
(41883,'enUS','WATCH OUT! INCOMING TURD!','WATCH OUT! INCOMING TURD!',26124),
(41884,'enUS','I shoulda just stayed on Kezan and taken my chances with the volcano.','I shoulda just stayed on Kezan and taken my chances with the volcano.',26124),
(41885,'enUS','I can\'t work under these conditions, man! I\'m losin\' it!','I can\'t work under these conditions, man! I\'m losin\' it!',26124),
(41886,'enUS','This has got to be some type of health violation!','This has got to be some type of health violation!',26124),
(41887,'enUS','Jibbly, get someone to clean up these turds!','Jibbly, get someone to clean up these turds!',26124),
(41888,'enUS','WORST. JOB. EVER.','WORST. JOB. EVER.',26124),
(41889,'enUS','I\'m feeling ill...','I\'m feeling ill...',26124),
(41890,'enUS','I QUIT! I\'d rather take my chances getting shot at by Alliance!','I QUIT! I\'d rather take my chances getting shot at by Alliance!',26124),
(41891,'enUS','I\'m out!','I\'m out!',26124),
(41892,'enUS','The Horde doesn\'t pay me enough for this... this crap!','The Horde doesn\'t pay me enough for this... this crap!',26124),
(41893,'enUS','Take your stinking job and stick it where the sun don\'t shine!','Take your stinking job and stick it where the sun don\'t shine!',26124),
(41894,'enUS','I\'ve had it! Find someone else to guard your precious turd filled base!','I\'ve had it! Find someone else to guard your precious turd filled base!',26124),
(41895,'enUS','I\'M MAD AS HELL AND I\'M NOT GONNA TAKE IT ANYMORE! I QUIT!','I\'M MAD AS HELL AND I\'M NOT GONNA TAKE IT ANYMORE! I QUIT!',26124),
(41896,'enUS','Find another sucker to stand watch over your enormous mound of poop. I\'m done!','Find another sucker to stand watch over your enormous mound of poop. I\'m done!',26124),
(41897,'enUS','I\'m free!  You\'ve saved me!','',26124),
(41898,'enUS','Noooo!  Not again!!!','',26124),
(41899,'enUS','Ah!  Umm... hello there.  I was just inspecting this shell, here.  Carry on!  Nothing to see here!','',26124),
(41900,'enUS','I stopped by the park district on my way here. There\'s nothing left of it...\n','',26124),
(41901,'enUS','Aye. I was here when the dragon attacked.','',26124),
(41902,'enUS','He could\'ve destroyed the entire city if he willed it. We were powerless to stop him.','',26124),
(41903,'enUS','What drove him off, then?','',26124),
(41904,'enUS','No idea. It made no sense...','',26124),
(41905,'enUS','If you ask me, the beast is insane.','',26124),
(41906,'enUS','He flew in, torched the park, then just flew off.','',26124),
(41907,'enUS','Why are you upside-down?','Why are you upside-down?',26124),
(41908,'enUS','Why is that?','Why is that?',26124),
(41909,'enUS','Fascinating.','Fascinating.',26124),
(41910,'enUS','You will be removed from the Krom\'gar Demolisher if you do not return to Battlescar Valley.','',26124),
(41911,'enUS','How did you get all the way over here, then?','How did you get all the way over here, then?',26124),
(41912,'enUS','Sounds impressive.','Sounds impressive.',26124),
(41913,'enUS','That\'s too bad.  Anyhow...','That\'s too bad.  Anyhow...',26124),
(41914,'enUS','I really need to get going now.','I really need to get going now.',26124),
(41915,'enUS','...','...',26124),
(41916,'enUS','I seem to be having a... floating problem.','',26124),
(41917,'enUS','I couldn\'t tell ya.  Maybe I\'ve got a low bone density, or a larger-than average lung capacity.  Maybe it\'s all that cheese I had for lunch.$b$bEither way, this shell is the only thing that\'s keeping me from rocketing to the surface.','',26124),
(41918,'enUS','Aye, and it runs in the family.  The Digsongs have always had buoyancy issues, I\'m afraid.','',26124),
(41919,'enUS','Hand over hand, $g lad: lass;... hand over aching hand.  I can\'t tell ya how many gallons of seawater went right up my nose.$b$bYou shoulda seen me fight off that pyreshell crab using my feet and my teeth, though!  \'Twas a thing of glory, \'twas.','',26124),
(41920,'enUS','I remember when I was just a wee little lad... the other boys would swim down to the bottom of Loch Modan to pick up sand dollars and seashells.  Oskar and I were stuck on the lake\'s surface, kicking our legs uselessly into the air, but we couldn\'t join them.','',26124),
(41921,'enUS','I can\'t even remember how many times I\'ve spotted a beautiful mining vein at the bottom of a lake or river, glimmering mockingly at me.  I\'m forced to float orelessly by, mining pick in hand, only to watch some blasted orc or blood elf swim down to the bottom and take it away from me.','',26124),
(41922,'enUS','Ya have no idea what it\'s like to be stuck here in Vashj\'ir like this!  Do ya know how many fish have confused me for a piece of seaweed, nibbling on my toes and hiding between pieces of my armor?$b$bThe tickling alone is enough to drive a dwarf mad!','',26124),
(41923,'enUS','I can tell ya don\'t want to hear my grumbling.  That\'s fine.$b$bJust don\'t forget how lucky you are, with your \"sea legs\" and your \"ability to swim in a direction other than up\".','',26124),
(41924,'enUS','Earthquakes every other day, a crazy dragon tearing up the world, what\'s next?','',26124),
(41925,'enUS','Put all of that out of your head, recruit.\n','',26124),
(41926,'enUS','I\'ve been fightin\' Horde for ten years now, and I\'ve never seen it worse than this.','',26124),
(41927,'enUS','Just stay focused on the battle in front of us, or you won\'t live to worry about the rest.','',26124),
(41928,'enUS','Where\'d you ship in from, soldier?','',26124),
(41929,'enUS','Just arrived from the Barrens.','',26124),
(41930,'enUS','Hairy? You heard wrong. It\'s downright desperate!','',26124),
(41931,'enUS','I couldn\'t believe it when they ordered half of us to ship out...','',26124),
(41932,'enUS','Ahh, the Battle Scar. Pretty hairy out there, I hear.','',26124),
(41933,'enUS','Goutgut very special. Goutgut am first to get to crush puny humans in new place.$B$BGoutgut so happy.','',26124),
(41934,'enUS','','Victory for Sylvanas! These lands will be ours.',26124),
(41935,'enUS','Without reinforcements, our positions there will be overrun in days.','',26124),
(41936,'enUS','Light be with them, brother - and with us, for that matter. We\'re spread pretty thin these days.','',26124),
(41937,'enUS','We\'ve destroyed hundreds of elementals, $n, and now they seem to be gaining strength!  Our guards are holding firm, but I\'m sure they could use your support.  King Varian Wrynn is leading the defense in the Trade district, Lady Jaina Proudmoore is helping defend the Mage district and Archbishop Benedictus is holding firm at the Cathedral of the Light.$b$bNo matter where you go in Stormwind, $n, you will be more than helpful.','',26124),
(41938,'enUS','$n! Stormwind is under siege by elementals and needs your strength!$b$bWe\'ve evacuated most of the city.  King Wrynn is holding the Trade District while Lady Proudmoore and the Archbishop defend the Mage and Cathedral Districts.$b$bWherever you go, you\'ll be of great help.\n','',26124),
(41939,'enUS','We\'ve beaten back the elementals, $n.  But they have left behind odd portals.$b$bThe King has gone through the portal, contrary to reason, to see where they lead. The portals have been reported in the Trade district, Cathedral district and Mage district$b$bI must remain here to see to the clean up of the city and the return of the citizens.  Go and help the King!','',26124),
(41940,'enUS','Your claims are outrageous, General.','',26124),
(41941,'enUS','The only thing you will find at Thal\'darah Grove are terrified young druids. They have no weapon of mass destruction.','',26124),
(41942,'enUS','Careful, tauren, your words could be construed as treason.','',26124),
(41943,'enUS','Yessir.','',26124),
(41944,'enUS','My scouts have informed me that the grove holds a powerful weapon. A weapon that the Alliance will use against us if they are not stopped.','',26124),
(41945,'enUS','Furthermore, I am here by the authority of Overlord Krom\'gar, who was himself appointed by our Warchief, Garrosh Hellscream. You will do his bidding or suffer the consequences.','',26124),
(41946,'enUS','I have sent my boy to Thal\'darah Grove to fetch you proof. You will soon see that they pose no threat to us.','',26124),
(41947,'enUS','Arf!','',26124),
(41948,'enUS','%s seems to be appreciative.','',26124),
(41949,'enUS','I\'m not going anywhere until I find her!','',26124),
(41950,'enUS','I think I can just make it out from here. Right on the edge of the horizon.','',26124),
(41951,'enUS','The new island - just surfaced after the last earthquakes.','',26124),
(41952,'enUS','It\'s what we\'re fighting for. On this front, at least.','',26124),
(41953,'enUS','This\'ll be my third time now.','',26124),
(41954,'enUS','Toughest fighting I\'ve seen...','',26124),
(41955,'enUS','We lose that island to the Horde and Stormwind\'s as good as gone... and they know it.','',26124),
(41956,'enUS','','My baby boy... NO!!!!! WHY!???',26124),
(41957,'enUS','Masha, go to our tent and hide yourself away.','Masha, go to our tent and hide yourself away.',26124),
(41958,'enUS','I will not leave you! Do not forget that I am the huntress in this family!','I will not leave you! Do not forget that I am the huntress in this family!',26124),
(41959,'enUS','%s sighs.','%s sighs.',26124),
(41960,'enUS','Oh Masha...','Oh Masha...',26124),
(41961,'enUS','That\'s enough, soldier.','',26124),
(41962,'enUS','Stormwind still stands, and we won\'t be losing anything to the Horde!','',26124),
(41963,'enUS','GENERAL! Come out from your tent and face me!','GENERAL! Come out from your tent and face me!',26124),
(41964,'enUS','Now get your minds right! We\'ll be killing orcs within the hour.','',26124),
(41965,'enUS','Make what out, exactly?','',26124),
(41966,'enUS','Have you been there?','',26124),
(41967,'enUS','Yeah, I... I think I can see it too.','',26124),
(41968,'enUS','Foolish old tauren, you dare display such disrespect?!','Foolish old tauren, you dare display such disrespect?!',26124),
(41969,'enUS','What is the meaning of this interruption?','What is the meaning of this interruption?',26124),
(41970,'enUS','Did you lose this, General?','Did you lose this, General?',26124),
(41971,'enUS','My insignia! Yes. I did lose it. Where did you find it, tauren?','My insignia! Yes. I did lose it. Where did you find it, tauren?',26124),
(41972,'enUS','$n found it.','$n found it.',26124),
(41973,'enUS','On the corpse of my only child, you miserable son of a pig.','On the corpse of my only child, you miserable son of a pig.',26124),
(41974,'enUS','%s laughs.','%s laughs.',26124),
(41975,'enUS','Your boy was weak. Spineless. Just like his father.','Your boy was weak. Spineless. Just like his father.',26124),
(41976,'enUS','And as for you, $n, disappointing. You are a disgrace to the Horde!','And as for you, $n, disappointing. You are a disgrace to the Horde!',26124),
(41977,'enUS','The punishment for you all is DEATH!','The punishment for you all is DEATH!',26124),
(41978,'enUS','That was for my son!','That was for my son!',26124),
(41979,'enUS','Masha, we have to run. We must get far away from here. They will come for us.','Masha, we have to run. We must get far away from here. They will come for us.',26124),
(41980,'enUS','Thank you for returning Wolf.','',26124),
(41981,'enUS','For the Alliance!','For the Alliance!',26124),
(41982,'enUS','For the Horde!','For the Horde!',26124),
(41983,'enUS','Listen up! Our transport should be here momentarily.','',26124),
(41984,'enUS','Fall in!','',26124),
(41985,'enUS','Alright, folks... Once task 37066 is implemented, the boat will arrive \'now-ish\'. In the meantime, I invite you to join us in a little dance to fill the time...','',26124),
(41986,'enUS','Don\'t be shy now, we\'re all friends here...','',26124),
(41987,'enUS','Alright, men! Move out!','',26124),
(41988,'enUS','We bring victory...','We bring victory...',26124),
(41989,'enUS','I laugh at you, feeble $n, but I will oblige. Now, let us return to my master, below!','',26124),
(41990,'enUS','Someone is using these beakers and alchemy tools to perform experiments with various types of submarine fuel.','Someone is using these beakers and alchemy tools to perform experiments with various types of submarine fuel.',26124),
(41991,'enUS','Our people were held as prisoners, as slaves, in this very camp by the humans. I was locked in these cages; I saw my brothers held in these stocks, hung in these gallows.$B$BI saw Orgrim Doomhammer, leader of us all, stabbed in the back. His blood stained black the earth we stand on.$B$BAnd look at us now. This is our legacy: Hammerfall, where we lost everything, and then took it back with our own hands.','',26124),
(41992,'enUS','Several small samples of oil sit in front of you, along with an empty beaker.  The beaker looks like it can probably fit about five samples inside of it.$b$bWhat kind of oil will you take first?','Several small samples of oil sit in front of you, along with an empty beaker.  The beaker looks like it can probably fit about five samples inside of it.$b$bWhat kind of oil will you take first?',26124),
(41993,'enUS','What type of oil will you select next?','What type of oil will you select next?',26124),
(41994,'enUS','You now have two samples of oil.  Which sample will you select next?','You now have two samples of oil.  Which sample will you select next?',26124),
(41995,'enUS','You now have three samples.  Which sample will you select next?','You now have three samples.  Which sample will you select next?',26124),
(41996,'enUS','You have four samples, and only have room to test one more.  Which one will it be?','You have four samples, and only have room to test one more.  Which one will it be?',26124),
(41997,'enUS','You have selected all five of your samples.','You have selected all five of your samples.',26124),
(41998,'enUS','Terrapin Oil Sample','Terrapin Oil Sample',26124),
(41999,'enUS','Remora Oil Sample','Remora Oil Sample',26124),
(42000,'enUS','Hammerhead Oil Sample','Hammerhead Oil Sample',26124),
(42001,'enUS','You can use these beakers and alchemy tools to perform experiments with various types of submarine fuel.','You can use these beakers and alchemy tools to perform experiments with various types of submarine fuel.',26124),
(42002,'enUS','Let\'s get started!','Let\'s get started!',26124),
(42003,'enUS','Mix the samples together!','Mix the samples together!',26124),
(42004,'enUS','I want to start over.','I want to start over.',26124),
(42005,'enUS','','How dare you storm into my throne room and attempt to spread this conspiratorial nonsense!',26124),
(42006,'enUS','','I will not let you and this treasonous Commander Stonebreaker steal my son\'s birthright!',26124),
(42007,'enUS','That is quite an accusation, Moira. It\'s hardly your throne room in the first place.','',26124),
(42008,'enUS','I know Commander Stonebreaker and I will vouch for his loyalty and his honesty. We must take his word.','',26124),
(42009,'enUS','Here, I made a Billowing Fuel Sample.  It\'s really smoky!','Here, I made a Billowing Fuel Sample.  It\'s really smoky!',26124),
(42010,'enUS','Here, I made an Atomic Fuel Sample.  It seems to be a little too hot.','Here, I made an Atomic Fuel Sample.  It seems to be a little too hot.',26124),
(42011,'enUS','Here, I made an Anemic Fuel Sample.  It seems... weak.','Here, I made an Anemic Fuel Sample.  It seems... weak.',26124),
(42012,'enUS','What cause do the Dark Irons have for taking up arms against Ironforge? Are you unable to control your own people, Moira?','',26124),
(42013,'enUS','Here, I made a Perduring Fuel Sample.  What do you think?','Here, I made a Perduring Fuel Sample.  What do you think?',26124),
(42014,'enUS','Here, I made a Smoky Fuel Sample.  Pretty, isn\'t it?','Here, I made a Smoky Fuel Sample.  Pretty, isn\'t it?',26124),
(42015,'enUS','Here, I made a Quick-Burning Fuel Sample.  Is this good enough?','Here, I made a Quick-Burning Fuel Sample.  Is this good enough?',26124),
(42016,'enUS','Here, I made a Promising Fuel Sample.  Three parts hammerhead and two parts remora.','Here, I made a Promising Fuel Sample.  Three parts hammerhead and two parts remora.',26124),
(42017,'enUS','Muradin has a point. If you cannot govern your own people, you have no place at this table.','',26124),
(42018,'enUS','Bah!  <cough>  Far too smoky!  <cough>   Looks like you put in too much terrapin oil!  Try again!','',26124),
(42019,'enUS','Yes, this will definitely burn too hot.  Do you want to blow up the ship?  Cut back on remora oil next time.','',26124),
(42020,'enUS','You\'re right, far too weak.  Needs more remora.  Try it again!','',26124),
(42021,'enUS','This looks pretty good... but it burns too long!  I need to be able to stop the fire instantly.  Cut back on hammerhead oil next time.','',26124),
(42022,'enUS','','Both of you know I would never order such a thing! Why would I set one half my son\'s inheritance against the other?',26124),
(42023,'enUS','We\'re getting close... but it\'s still a little too smoky.  Don\'t put in any terrapin oil next time.  <cough>  Too much smoke.  Give it another shot!','',26124),
(42024,'enUS','How\'d you manage to make this one?  It burns like flash powder... far too quick.  Add more hammerhead.','',26124),
(42025,'enUS','This is it!  The perfect bio-fuel!  Good work, $n!','',26124),
(42026,'enUS','','No, this is the work of a traitor to both our peoples. Despite my best efforts, some Dark Irons remain in the grip of Twilight\'s Hammer.',26124),
(42027,'enUS','You have discovered a new type of bio-fuel!  Bring it to Engineer Hexascrub for testing.','You have discovered a new type of bio-fuel!  Bring it to Engineer Hexascrub for testing.',26124),
(42028,'enUS','','The cult must have someone in the city to coordinate this kind of attack. That only leaves one suspect, Ambassador Slaghammer!',26124),
(42029,'enUS','Watch now, Cliffwalker, as this battle comes to its glorious conclusion.','Watch now, Cliffwalker, as this battle comes to its glorious conclusion.',26124),
(42030,'enUS','You are about to cross a terrible threshold, Krom\'gar. May the Earth Mother have mercy on your soul.','You are about to cross a terrible threshold, Krom\'gar. May the Earth Mother have mercy on your soul.',26124),
(42031,'enUS','You have discovered a new type of bio-fuel!  Bring it to Fiasco Sizzlegrin for testing.','You have discovered a new type of bio-fuel!  Bring it to Fiasco Sizzlegrin for testing.',26124),
(42032,'enUS','Bah!  <cough>  Far too smoky!  <cough>   Looks like you put in too much terrapin oil!  Try again!','',26124),
(42033,'enUS','Yes, this will definitely burn too hot.  Do you want to blow up the ship?  Cut back on remora oil next time.','',26124),
(42034,'enUS','You\'re right, far too weak.  Needs more remora.  Try it again!','',26124),
(42035,'enUS','This looks pretty good... but it burns too long!  I need to be able to stop the fire instantly.  Cut back on hammerhead oil next time.','',26124),
(42036,'enUS','We\'re getting close... but it\'s still a little too smoky.  Don\'t put in any terrapin oil next time.  <cough>  Too much smoke.  Give it another shot!','',26124),
(42037,'enUS','How\'d you manage to make this one?  It burns like flash powder... far too quick.  Add more hammerhead.','',26124),
(42038,'enUS','This is it!  The perfect bio-fuel!  Good work, $n!','',26124),
(42039,'enUS','Glad to see that Dark Iron scum is finally getting what he deserves!','',26124),
(42040,'enUS','Quiet! Moira\'s in a foul mood and if she hears you, she\'ll have your head...','',26124),
(42041,'enUS','These are grave times for Azeroth, $n.','These are grave times for Azeroth, $n.',26124),
(42042,'enUS','I need a totem to break the elemental prisons!','I need a totem to break the elemental prisons!',26124),
(42043,'enUS','Do as you will with me. I am not afraid. That halfbreed runt will never be my emperor! Long live Twilight\'s Hammer!','',26124),
(42044,'enUS','','If we were in Shadowforge City, I would have you tossed into the Ring of Law for your transgressions, Ambassador. The darkest dungeons of Ironforge will have to do for now.',26124),
(42045,'enUS','Look upon the world, Cliffwalker, and see the might of the Horde!','Look upon the world, Cliffwalker, and see the might of the Horde!',26124),
(42046,'enUS','I go willingly, $c. My purpose in my master\'s plan is fulfilled.','',26124),
(42047,'enUS','What have you done, Krom\'gar?','',26124),
(42048,'enUS','I\'ll escort you to your new \'accommodations\', Your Excellency.','',26124),
(42049,'enUS','Warchief! I... I was carrying out your command!','',26124),
(42050,'enUS','My command?','',26124),
(42051,'enUS','Was my command to murder innocents, Krom\'gar?','',26124),
(42052,'enUS','Magmaw begins to break free from the single chain binding him!','',26124),
(42053,'enUS','Warchief... Sir... I...','',26124),
(42054,'enUS','Am I a murderer, Krom\'gar?','',26124),
(42055,'enUS','No, Warchief!','',26124),
(42056,'enUS','Then I ask you again: WHAT HAVE YOU DONE!','',26124),
(42057,'enUS','I sent you into Stonetalon Mountains with an army.  Your orders were to secure this land for the Horde.','',26124),
(42058,'enUS','Instead, you laid waste to the land. Murdered innocents. Children even...','',26124),
(42059,'enUS','I spent a very long time in Northrend, Krom\'gar. I learned much about the Horde in that time.','',26124),
(42060,'enUS','While there, a wise old war hero told me something that I would carry with me forever...','',26124),
(42061,'enUS','\"Honor,\" Krom\'gar, \"No matter how dire the battle... never forsake it.\"','',26124),
(42062,'enUS','Overlord Krom\'gar, you have disgraced the Horde.','',26124),
(42063,'enUS','You have brought shame to us as a people.','',26124),
(42064,'enUS','By my right as Warchief, I hereby relieve you of duty.','',26124),
(42065,'enUS','YOU ARE DISMISSED.','',26124),
(42066,'enUS','And you, $r!','',26124),
(42067,'enUS','Wait, Warchief! Please! $n was the hero responsible for uncovering this corruption. $g He:She; tried to stop Krom\'gar!','',26124),
(42068,'enUS','Have mercy, Warchief.','',26124),
(42069,'enUS','Mercy... Your wife and child were murdered. Your kin wiped out. Your home burned to the ground.','',26124),
(42070,'enUS','Mercy... Chieftain, on this day I learn from you.','',26124),
(42071,'enUS','Mountaineer Barleybrew said you could help me get to Loch Modan.','Mountaineer Barleybrew said you could help me get to Loch Modan.',26124),
(42075,'enUS','$n, Krom\'gar\'s army is no more. Your rank no longer has meaning. If you wish to truly help the Horde, your considerable power could be used in Desolace or in the Southern Barrens.','',26124),
(42076,'enUS','The choice is yours to make.','',26124),
(42077,'enUS','Let honor guide you, $n. Do not forget that Hellscream\'s eyes are always upon you.','',26124),
(42078,'enUS','<Furien groans.>','',26124),
(42079,'enUS','Ha ha! There\'s no way they\'ll miss that, cannon fire or not.','',26124),
(42080,'enUS','Don\'t worry - if they try to pretend they didn\'t see it, I\'ll swim over there and drag them off of their ships myself.','',26124),
(42081,'enUS','We\'ve killed dozens of naga to get this far, but they still keep coming.  What will it take to escape this wretched cavern?','',26124),
(42082,'enUS','I don\'t care if I die inside this husk, $n.  I\'ll pay these naga back for every one of my fellow soldiers they\'ve killed or enslaved!$b$bThe others can worry about escape.  I\'ll worry about doling out punishment to these snakes.','',26124),
(42083,'enUS','','Why are they doing this?  For pearls?  For war?  This ancient, Nespirah, is far more powerful than the naga understand.  If they\'re able to turn her towards their will... the damage they could cause would be tremendous.',26124),
(42084,'enUS','Sitting here injured and watching my brothers fight is almost too much to bear, but even I understand that I\'m more valuable alive than dead.','',26124),
(42085,'enUS','','I don\'t like the feel of this place, $n.  Naga sorceresses and slavedrivers aside... all I can sense inside this cavern is pain.  The ancient one is trying to cry out, but it cannot speak.',26124),
(42086,'enUS','We need your help, $c.  We\'ve fought tooth and nail to get here, but the naga keep coming.','',26124),
(42087,'enUS','My wounds are not healing, $r.  I fear I may die inside this creature\'s gut if we do not act soon.','',26124),
(42088,'enUS','If you have naga blood on your hands, then you\'re an ally of mine.$b$bA long time ago, I swore I\'d never be anyone\'s slave again, and I kept that bargain until Idra\'kess captured us.  Now I can barely contain my fury.  All I want is blood... not food, not sleep, not even victory... only blood.','',26124),
(42089,'enUS','Aww, Budd. Now what\'d ya go an\' do that for?\n','',26124),
(42090,'enUS','Civilians...','',26124),
(42091,'enUS','Fall in, men!','',26124),
(42092,'enUS','That island on the horizon is our destination.','',26124),
(42093,'enUS','It\'s where we will do our duty, for our king, for Stormwind and for her people...','',26124),
(42094,'enUS','Every orc you slay today will bring honor to them, and to every soldier who has come before you.','',26124),
(42095,'enUS','Hellscream has sent his best to take this island. We shall see to it that none return home...','',26124),
(42096,'enUS','Today Hellscream shall learn the lesson that Thrall failed to teach him...','',26124),
(42097,'enUS','Stormwind shall never fall!','',26124),
(42098,'enUS','You\'ve been paid good coin for non-stop passage, miss. We have no time for delays...','',26124),
(42099,'enUS','Now make ready, for soon we\'ll be ashore.','',26124),
(42100,'enUS','A stake has been driven into the rock, and a long braid of rope draped around it.$B$BThis must have some purpose.','',26124),
(42101,'enUS','Tie your lure off and let it loose.','Tie your lure off and let it loose.',26124),
(42102,'enUS','<L\'ghorek\'s voice booms inside your mind.>$B$BI AM ALMOST... DEAD. YOU MUST HELP... STOP... THE TWILIGHT\'S HAMMER.$B$BTHEY DRAIN... MY ENERGY TO... CREATE... THEIR ASCENDANTS. THEY ARE A... GRAVE THREAT IN... THE IMMINENT WAR... VERSUS... NEPTULON.','',26124),
(42104,'enUS','I believe you had a turtle prepared for me?','I believe you had a turtle prepared for me?',26124),
(42107,'enUS','Tha elements be crying out in rage. It ain\'t no coincidence dat da naga are here. Dey be wantin\' someting.','',26124),
(42108,'enUS','I am ready to join you in the vision, Farseer.','I am ready to join you in the vision, Farseer.',26124),
(42109,'enUS','Let me know when ya be ready ta leave.','',26124),
(42110,'enUS','','Budd! Noooo!',26124),
(42111,'enUS','','Move forward! Hold the bridge!',26124),
(42113,'enUS','Take us out, Mister Gearchum.','',26124),
(42114,'enUS','Chart a course east with all possible speed. We\'ll rendezvous with the main fleet.','',26124),
(42115,'enUS','What is the status on new recruits, Marshal? We desperately need more soldiers. The Blackrock orcs invading our territory must be stopped!','',26124),
(42116,'enUS','Oh gods, someone get me out of this cage!','Oh gods, someone get me out of this cage!',26124),
(42117,'enUS','I\'m too young to die as a sacrifice!','I\'m too young to die as a sacrifice!',26124),
(42118,'enUS','When I get out of here, I\'m going to kill every last one of you Twilight\'s Hammer scum!','When I get out of here, I\'m going to kill every last one of you Twilight\'s Hammer scum!',26124),
(42119,'enUS','You don\'t have to sacrifice me. I\'d make a great cultist!','You don\'t have to sacrifice me. I\'d make a great cultist!',26124),
(42120,'enUS','You cultists are cowards. You make me sick!','You cultists are cowards. You make me sick!',26124),
(42121,'enUS','Hey you. Yeah, you. You\'re not one of the cultists. Get me out of here!','Hey you. Yeah, you. You\'re not one of the cultists. Get me out of here!',26124),
(42122,'enUS','One of them has the key. Find it and get me out of here!','One of them has the key. Find it and get me out of here!',26124),
(42123,'enUS','I never thought that it would end like this.','I never thought that it would end like this.',26124),
(42124,'enUS','Thank you, $n. Thank you!','Thank you, $n. Thank you!',26124),
(42125,'enUS','I never thought that I\'d be rescued by you, $n!','I never thought that I\'d be rescued by you, $n!',26124),
(42126,'enUS','I\'ll make sure to tell Captain Taylor that you\'re destroying the Hammers in here.','I\'ll make sure to tell Captain Taylor that you\'re destroying the Hammers in here.',26124),
(42127,'enUS','$n is on the job! I better get back to the captain.','$n is on the job! I better get back to the captain.',26124),
(42128,'enUS','They\'re transforming themselves into some kind of super-elemental they call an Ascendant. You gotta stop them, $n!','They\'re transforming themselves into some kind of super-elemental they call an Ascendant. You gotta stop them, $n!',26124),
(42129,'enUS','I thought I was a goner for sure. Thank you, $n!','I thought I was a goner for sure. Thank you, $n!',26124),
(42130,'enUS','See you on the other side, $g brother : sister;. Which way is out?','See you on the other side, $g brother : sister;. Which way is out?',26124),
(42131,'enUS','What about this one, McBride? Surely this $c could join the cause!','',26124),
(42132,'enUS','Excellent. $n, you are going to make a fine $c. McBride will teach you everything that you will need to know to join the ranks of the Stormwind guard!','',26124),
(42133,'enUS','I\'ve been in here for days. They were just about to sacrifice me!','I\'ve been in here for days. They were just about to sacrifice me!',26124),
(42134,'enUS','Farewell, $n. Until we meet again...','',26124),
(42135,'enUS','FOR THE HORDE!','',26124),
(42136,'enUS','This land belongs to the Horde!  Attack!','',26124),
(42137,'enUS','Crush these Nethergarde maggots!','',26124),
(42138,'enUS','Feel the wrath of the Okril\'lon!  Blasted Lands is ours!','',26124),
(42139,'enUS','Hellscream\'s eyes are upon you, men!','',26124),
(42140,'enUS','Match altitude and speed, Mister Gearchum.','',26124),
(42141,'enUS','Signal the fleet to fall into formation.','',26124),
(42142,'enUS','Someone get me out of this cage!','Someone get me out of this cage!',26124),
(42143,'enUS','I\'m too good-looking to die as a sacrifice!','I\'m too good-looking to die as a sacrifice!',26124),
(42144,'enUS','When I get out of here, I\'m going to rip every last one of you Twilight\'s Hammer curs to shreds!','When I get out of here, I\'m going to rip every last one of you Twilight\'s Hammer curs to shreds!',26124),
(42145,'enUS','Maybe we can make a deal. I\'d make a great cultist!','Maybe we can make a deal. I\'d make a great cultist!',26124),
(42146,'enUS','You cultists are cowards. You make me sick!','You cultists are cowards. You make me sick!',26124),
(42147,'enUS','You over there. You\'re not one of the cultists. Get me out of here!','You over there. You\'re not one of the cultists. Get me out of here!',26124),
(42148,'enUS','One of them has the key. Find it and get me out of this cage!','One of them has the key. Find it and get me out of this cage!',26124),
(42149,'enUS','I will not die powerless like this!','I will not die powerless like this!',26124),
(42150,'enUS','I give you thanks, $n.','I give you thanks, $n.',26124),
(42151,'enUS','I never thought that I\'d be saved by you, $n!','I never thought that I\'d be saved by you, $n!',26124),
(42152,'enUS','I\'ll tell Legionnaire Nazgrim that you\'re destroying the Hammers in here.','I\'ll tell Legionnaire Nazgrim that you\'re destroying the Hammers in here.',26124),
(42153,'enUS','I better get back to Nazgrim.','I better get back to Nazgrim.',26124),
(42154,'enUS','They\'re changing themselves into some kind of super-elemental they call an Ascendant. You must stop them, $n!','They\'re changing themselves into some kind of super-elemental they call an Ascendant. You must stop them, $n!',26124),
(42155,'enUS','I thought I was dead for sure. Thanks, $n!','I thought I was dead for sure. Thanks, $n!',26124),
(42156,'enUS','See you outside, $g brother : sister;. Is that the way out?','See you outside, $g brother : sister;. Is that the way out?',26124),
(42157,'enUS','I\'ve been in here for days. They were about to sacrifice me!','I\'ve been in here for days. They were about to sacrifice me!',26124),
(42158,'enUS','Peering through the portal, you see the inner portion of an underground cave.  The sound of water falling is muffled by the sound of earth shifting.  This portal must have been opened for a reason, but why?','',26124),
(42159,'enUS','Enter the portal.','Enter the portal.',26124),
(42160,'enUS','As you near the portal, you are struck by intense heat radiating out. The sound of hammers echoing through a canyon create a faint steady rhythm all around.  Where does this portal go?','',26124),
(42161,'enUS','Enter the Portal.','Enter the Portal.',26124),
(42162,'enUS','What say you, $n? We need all the help we can muster if we are to defeat Deathwing and his minions!','',26124),
(42163,'enUS','Yes. Highness! We will prepare $n for the coming battle!','',26124),
(42164,'enUS','Order the fleet into close formation. Keep it tight, everyone!','',26124),
(42165,'enUS','','Our allies have arrived! Push them back over the edge, my brethren.',26124),
(42166,'enUS','Sir! The fleet is straight ahead.','',26124),
(42167,'enUS','Approaching the Thandol Span, sir.','',26124),
(42168,'enUS','','We are victorious.  In Azshara\'s name!',26124),
(42169,'enUS','','My Battlemaiden, once again you have earned my respect, and the respect of all our people.',26124),
(42170,'enUS','','You have surpassed your title. You are a Battlemaiden no longer. Take your new crown, Nar\'jira, champion of Azshara.',26124),
(42171,'enUS','','With the summoning complete and the armies of Azshara gathering for war, Neptulon the Tidehunter will soon fall.',26124),
(42172,'enUS','Ach, it\'s hard enough keeping order around here without all these new troubles popping up!  I hope you have good news, $n...','',26124),
(42173,'enUS','I wish to ride the Stormwind charger, sir.','I wish to ride the Stormwind charger, sir.',26124),
(42175,'enUS','We have suffered a major setback, but we must see our mission through nevertheless.','',26124),
(42176,'enUS','Pull yourself together, $n.$b$bWe must make for the breach and prevent the naga from entering the Plane of Water!','',26124),
(42177,'enUS','Wow, it\'s totally wrecked! Let\'s try somewhere else.','Wow, it\'s totally wrecked! Let\'s try somewhere else.',26124),
(42178,'enUS','Heart of Orgrimmar, you\'re coming in too low. Too low!','',26124),
(42179,'enUS','Pull up! Pull down! PULL SOMETHING!','',26124),
(42180,'enUS','|TInterface\\Icons\\spell_fire_selfdestruct.blp:20|t%s rears back and casts |cFFFF0000|Hspell:77982|h[Searing Flame]|h|r!\n','',26124),
(42181,'enUS','Arise, friend. We have no time to lick our wounds!','',26124),
(42182,'enUS','While the loss of this vehicle is a setback, we must persist. We must succeed!','',26124),
(42183,'enUS','Think they\'ll ever fix all this? Let\'s go to the other side.','Think they\'ll ever fix all this? Let\'s go to the other side.',26124),
(42184,'enUS','I kill off any stragglers and send an event...','',26124),
(42185,'enUS','We must make our way to the crater!','',26124),
(42186,'enUS','The submarine\'s gonna blow! Move out!','',26124),
(42187,'enUS','Where does it hurt?','',26124),
(42188,'enUS','That foul sea-witch has overpowered our ship! Brace for impact!!!','',26124),
(42189,'enUS','%s throws his spell focus to the ground!','%s throws her spell focus to the ground!',26124),
(42190,'enUS','','You have foolishly trespassed upon our waters, Horde fools. Be whipped by the lash of my storm!',26124),
(42191,'enUS','Oh, the Goblinity!','',26124),
(42192,'enUS','The valley should mask our movements. Stay low. Stay close.','',26124),
(42193,'enUS','I don\'t want to see any more mistakes!','',26124),
(42194,'enUS','Fellow warriors of the Horde. Hear me now!','',26124),
(42195,'enUS','Ahead hides our foe. Worshippers of chaos who seek to remake the world.','',26124),
(42196,'enUS','A new world is coming, friends. But it is not the world of their design.','',26124),
(42197,'enUS','Together, we will crush the Twilight\'s Hammer, raze their stronghold,','',26124),
(42198,'enUS','salt the earth, and burn the bodies. All will tremble at our might. ','',26124),
(42199,'enUS','Then we will stand astride this world as its masters -','',26124),
(42200,'enUS','united in our conviction, unrivaled in strength, beholden to no one. ','',26124),
(42201,'enUS','Today, WE will remake the world. OUR world. FOR THE HORDE!','',26124),
(42202,'enUS','Coming up on the Twilight Highlands, Captain. ','',26124),
(42203,'enUS','Look - dwarves. Hah! They sulk like prairie dogs in holes in the ground.','',26124),
(42204,'enUS','Captain, sir! Alliance naval fleet sighted off the port bow.','',26124),
(42205,'enUS','The Alliance steams in close formation without escort.','',26124),
(42206,'enUS','Air guard, attack!! Strafe them now, while they cannot maneuver!','',26124),
(42207,'enUS','What - WHAT!? What does he think he\'s DOING? The carriers are unprotected.','',26124),
(42208,'enUS','What kind of madman orders away his close air support?','',26124),
(42209,'enUS','Mister Gearchum, signal the fleet. Defensive formations!','',26124),
(42210,'enUS','We\'re without our escort. I want to see interlocking fields of fire. Now, now!','',26124),
(42211,'enUS','|TInterface\\Icons\\spell_fire_selfdestruct.blp:20|tThe Blind Dragon rears back and casts |cFFFF0000Searing Flame!|r','',26124),
(42212,'enUS','A winner.','',26124),
(42213,'enUS','I would like to start the Blood Ritual, Kasim.','I would like to start the Blood Ritual, Kasim.',26124),
(42214,'enUS','Very well.  Stand back... this may get messy.','',26124),
(42215,'enUS','The blood ritual is complete... and I can now see where three amulets await you.','',26124),
(42216,'enUS','I would like to start the Amulet Ritual, Kasim.','I would like to start the Amulet Ritual, Kasim.',26124),
(42217,'enUS','With the power within the amulets of Razelikh...','',26124),
(42218,'enUS','... I bind you to his lair!','',26124),
(42219,'enUS','Turn your head and cough twice.','',26124),
(42220,'enUS','To have seen the things I\'ve seen, to have done the things I\'ve done, and to still breathe... I am a lucky gnome.','',26124),
(42221,'enUS','What the WHAT!?','',26124),
(42222,'enUS','The guns, man the guns! Fire everything we\'ve got!','',26124),
(42223,'enUS','It\'s an attack!','',26124),
(42224,'enUS','It\'s a bloodbath, lieutenant. They\'ve been murdered.','',26124),
(42225,'enUS','Given the body temperature, I\'d say they\'ve been dead no more than 6 hours.','',26124),
(42226,'enUS','Damn shame what they did to Old Blanchy...','',26124),
(42227,'enUS','No kidding, rookie...','',26124),
(42228,'enUS','Looks like they really put the cart...','',26124),
(42229,'enUS','...before the horse.','',26124),
(42230,'enUS','Operation: Gnomeregan was a success. Sure, that dastardly Thermaplugg had an unforeseen trick up his sleeve, but we have him on the run! It\'s only a matter of time before Gnomeregan is cleaned up and in our hands again!','',26124),
(42231,'enUS','Harvesting','Harvesting',26124),
(42232,'enUS','Cooking for the King is an honor, not a job.  Do you have time to help me on some errands?','Cooking for the King is an honor, not a job.  Do you have time to help me on some errands?',26124),
(42233,'enUS','Never stop training, $n. I want every gnome ready for the day when we take down the traitor Thermaplugg for good.','',26124),
(42234,'enUS','','The end of Operaton: Gnomeregan meant a chance to rest for most people. However, my assistants and I have been caring for the wounded and for the survivors that the S.A.F.E. teams rescue from inside the city.',26124),
(42235,'enUS','','Things can get a little stuffy here in Nethergarde.  Sometimes a dwarf just needs a brew to take her mind off her duty for a bit.',26124),
(42236,'enUS','I was just taking a rest.  Eternal watch is not as easy as it sounds, $r.','',26124),
(42237,'enUS','Return to L\'ghorek!','',26124),
(42238,'enUS','','Erunak, take a look at this. This looks like a sufficient focus for the vision magics I was speaking to you about.',26124),
(42239,'enUS','Erunak examines the shard and nods in agreement.','Erunak examines the shard and nods in agreement.',26124),
(42240,'enUS','','I will prepare the enchantment right away then. This may finally shed some light on the means and intentions of the naga.',26124),
(42241,'enUS','The Trade District is secured!  Now, secure the rest of the city!','',26124),
(42242,'enUS','','We have secured the Mage District! All invaders have been repelled and the evacuation has been completed!',26124),
(42243,'enUS','','Greetings, $n. I can offer you training in the way of the mage.',26124),
(42244,'enUS','The Cathedral District is under Stormwind Control again. The Light always prevails!','',26124),
(42245,'enUS','','I\'m sorry, $c, I cannot help you. You\'ll have to find a $c trainer.',26124),
(42246,'enUS','Begone, Alliance thief!','Begone, Alliance thief!',26124),
(42247,'enUS','Sorry, I cannot train you.','',26124),
(42248,'enUS','Keep pressing the fight, $n!','Keep pressing the fight, $n!',26124),
(42249,'enUS','Don\'t let up, $n!','Don\'t let up, $n!',26124),
(42250,'enUS','Show these monsters the might of Stormwind, $n!','Show these monsters the might of Stormwind, $n!',26124),
(42251,'enUS','Fight on, $n!','Fight on, $n!',26124),
(42252,'enUS','Continue the attack, $n!','Continue the attack, $n!',26124),
(42253,'enUS','It seems your reputation as a formidable $c is well earned, $n!','It seems your reputation as a formidable $c is well earned, $n!',26124),
(42254,'enUS','Your skills in battle are impressive, $n.','Your skills in battle are impressive, $n.',26124),
(42255,'enUS','How can Stormwind fall when we have $cs such as $n to defend it?  FOR STORMWIND!','How can Stormwind fall when we have $cs such as $n to defend it?  FOR STORMWIND!',26124),
(42256,'enUS','They attacked while you were gone... the Captain fell fighting them off. The rest retreated to the cave, you should do the same.','',26124),
(42257,'enUS','Fresh air! By the light, I missed it. We have some ships just in sight to the north, $n - fire the flare in their direction.','',26124),
(42258,'enUS','Fresh air! Grom\'s beard, I missed it. We have some ships just in sight to the north, $n - fire the flare in their direction.','',26124),
(42259,'enUS','Say \"Ahhhhh\".','',26124),
(42260,'enUS','When was your last check up?','',26124),
(42261,'enUS','What are you doing?  You threaten my work!  The Tainted Scar\'s revival is all thanks to me!','',26124),
(42262,'enUS','Take two potions and call me in the morning.','',26124),
(42263,'enUS','You should consider losing some weight.','',26124),
(42264,'enUS','I only wanted to... do something... good...','',26124),
(42265,'enUS','Before the day is done, you will all be slaves and corpses!','',26124),
(42266,'enUS','Another brief confrontation with naga here.','',26124),
(42267,'enUS','Press forward...','',26124),
(42268,'enUS','Die, worm!','',26124),
(42269,'enUS','More delays... Form up, men!','',26124),
(42270,'enUS','Our goal is in sight - press forward...','',26124),
(42271,'enUS','Neptulon\'s minions are growing desperate! We must hurry!','',26124),
(42273,'enUS','We\'ve been spotted! Make ready!','',26124),
(42274,'enUS','','Kelsey Steelspark of Gnomeregan Covert Operations at your service! If you\'re looking for rogue training, you\'ve come to the right place.',26124),
(42275,'enUS','','I\'m sorry, I can\'t offer you training. You\'ll have to find someone more familiar with your skills.',26124),
(42276,'enUS','','Welcome back, $n. That took longer than expected. Learn anything useful?',26124),
(42277,'enUS','Erunak! We don\'t have time for this...','',26124),
(42278,'enUS','We\'re being besieged by the naga attempting to breech our airlocks! Defend the ship topside!','',26124),
(42279,'enUS','Goblin! Status report!','',26124),
(42280,'enUS','Continue the bombardment of the ocean floor! Show those Naga the might of the Horde!','',26124),
(42281,'enUS','Naga attacking from the port and starboard! Faceless ones attacking head on...! We\'re heavily  outnumbered, but the ship is holding, sir!','',26124),
(42282,'enUS','','This miserable can is nothing compared to the might of <Kraken Name here>!',26124),
(42283,'enUS','','The Park\'s been ruined... we\'ll have to go another way, today. Miserable dragon!',26124),
(42284,'enUS','More naga! Brace yourselves!','',26124),
(42285,'enUS','','Thank the waves, you\'re back! The others have already retreated, we need to get out of here!',26124),
(42286,'enUS','L\'ghorek Dies!','',26124),
(42287,'enUS','Quickly, $n!  We haven\'t much time before Razelikh makes his return.','',26124),
(42288,'enUS','','Quickly, $n!  We haven\'t much time before Razelikh makes his return.',26124),
(42289,'enUS','<These baby Rockpool murlocs look toward the ocean.>','',26124),
(42290,'enUS','<Continue helping the Rockpool tadpoles.>','<Continue helping the Rockpool tadpoles.>',26124),
(42291,'enUS','Hold on!','',26124),
(42292,'enUS','Ah!  Get back over here!','',26124),
(42293,'enUS','Citizens of Stormwind! Begin to evacuate the city!','Citizens of Stormwind! Begin to evacuate the city!',26124),
(42294,'enUS','Guests of Stormwind please find shelter from the coming storm!','Guests of Stormwind please find shelter from the coming storm!',26124),
(42295,'enUS','Clear the streets!','Clear the streets!',26124),
(42296,'enUS','Evacuate the city!  Clear the streets of Stormwind!','Evacuate the city!  Clear the streets of Stormwind!',26124),
(42297,'enUS','Enough!','',26124),
(42298,'enUS','Enough!  The Earthen Ring will temporarily stop the invasion.  But be warned, the elementals will return!','Enough!  The Earthen Ring will temporarily stop the invasion.  But be warned, the elementals will return!',26124),
(42299,'enUS','We must make haste! The elementals cannot endure this siege.','',26124),
(42300,'enUS','','You have foolishly trespassed upon our waters, Alliance fools. Be whipped by the lash of my storm!',26124),
(42301,'enUS','','Ahh, visitorsss!',26124),
(42302,'enUS','','What an unexpected sssurprise.',26124),
(42303,'enUS','','You mussst forgive me... I have no time to ssstay and play.',26124),
(42304,'enUS','','In my absssence, my ssservantsss will... sssee to your needs. ',26124),
(42305,'enUS','','Do enjoy yourssselves!',26124),
(42306,'enUS','Pssst...','',26124),
(42307,'enUS','You need something, $g mack:lady;?','',26124),
(42308,'enUS','Whatever you need, I can get...','',26124),
(42309,'enUS','Nice stuff. You must be rich.','',26124),
(42310,'enUS','What\'re you doin\' out here? Slummin\'?','',26124),
(42311,'enUS','Whaddya need? Information? I got that too!','',26124),
(42312,'enUS','You lookin\' for somethin\' a little more... exotic?','',26124),
(42313,'enUS','I think we can do business.','',26124),
(42314,'enUS','Keep your head low, $g buddy:lady;.','',26124),
(42315,'enUS','We don\'t die that easily, sea-witch!','',26124),
(42316,'enUS','If we are to die, let it be with honor against our hated enemies!','',26124),
(42318,'enUS','What the hell happened here?','',26124),
(42319,'enUS','The final battle against the naga is imminent. We will triumph or die trying in the Abyssal Breach.','',26124),
(42320,'enUS','Looks like the Furlbrow\'s were murdered...','',26124),
(42321,'enUS','What\'s happened to us? We\'re in worse shape now than when the Defias ran amok!','',26124),
(42322,'enUS','Yep. That King is good for nothin\'.','',26124),
(42323,'enUS','Let\'s get out of here before they try and pin this on us.','',26124),
(42324,'enUS','Good call.','',26124),
(42325,'enUS','Before we can join the final battle, we must ensure that whatever\'s happening inside of that Ancient across from us is put to an end. Otherwise, we will not stand a chance.$B$BLend Erunak your full assistance, $n.','',26124),
(42326,'enUS','L\'ghorek is the name of the Ancient god that sits across the chasm from us. It is being infested by something.$B$BWe must put an end to this or we will certainly all meet our doom!','',26124),
(42327,'enUS','In spite of our best efforts, the naga have attacked the breach!$B$BThe Plane of Water must be defended!','',26124),
(42328,'enUS','There is a battle brewing at the Abyssal Breach. I hope that the reinforcements that arrived with the Pincer X2 will be enough.','',26124),
(42329,'enUS','Let us in!','Let us in!',26124),
(42330,'enUS','Down with the king!','Down with the king!',26124),
(42331,'enUS','This is horse poop!','This is horse poop!',26124),
(42332,'enUS','What right do you have keeping us out?','What right do you have keeping us out?',26124),
(42333,'enUS','We\'re hungry and cold! Help us!','We\'re hungry and cold! Help us!',26124),
(42334,'enUS','Heartless monsters!','Heartless monsters!',26124),
(42335,'enUS','Is this equality and justice for all?','Is this equality and justice for all?',26124),
(42336,'enUS','What do you expect us to do?','What do you expect us to do?',26124),
(42337,'enUS','Before we join the final battle at the Abyssal Breach, we must stop whatever\'s happening inside of that Ancient across from us. Otherwise, we will fail.$B$BLend Erunak all of your might, $n.','',26124),
(42338,'enUS','The final battle against the naga has begun. We will destroy them or gloriously die trying in the Abyssal Breach.','',26124),
(42339,'enUS','','You ask me, I think we let the soup and gravy take care of this ready and write.$B$BIt\'s bird lime to kick and prance ourselves out of here before we\'re all brown bread.$B$BCatch my meaning, love?',26124),
(42340,'enUS','WHOA THERE, BUDDY!','WHOA THERE, BUDDY!',26124),
(42341,'enUS','Where do you think you two are going?','Where do you think you two are going?',26124),
(42342,'enUS','We\'re just trying to get a decent meal and maybe a comfortable night\'s sleep.','',26124),
(42343,'enUS','','Just between you and me, hon, I\'m too short to pull this kind of duty. One more month and I\'m out.$B$BI\'ve already died once. No sense doing it a second time.',26124),
(42344,'enUS','Can\'t you read, pal? Probably not, huh?','Can\'t you read, pal? Probably not, huh?',26124),
(42345,'enUS','The sign here says: \"ABSOLUTELY NO BUMS!\" Now get lost!','The sign here says: \"ABSOLUTELY NO BUMS!\" Now get lost!',26124),
(42346,'enUS','','Dealing with the first ancient, Nespirah, was hard enough. The one across from us, L\'ghorek, is dying.$B$BI can sense its cries of agony. Something is stealing its life force. But to what end?',26124),
(42347,'enUS','Dirty, rotten pig-lickers. You\'ll get your come-uppance some day.','',26124),
(42348,'enUS','Let\'s get the hell out of here. I hope this place burns to the ground.','',26124),
(42349,'enUS','','I wish that I was going to fight by your side in the upcoming battle, but Erunak wants me to remain here.$B$BGood luck, $n.',26124),
(42350,'enUS','','These depths truly are a nightmare.$B$BAlthough, the battle that is about to be joined down in the breach below will make this look like kittens and rainbows.',26124),
(42351,'enUS','JACKPOT!','JACKPOT!',26124),
(42352,'enUS','Looks like I found us a savory and clean piece of dirt! Tonight we eat like kings, Mr. Penguin! Of course I\'ll share it with you! You\'re my best friend!','Looks like I found us a savory and clean piece of dirt! Tonight we eat like kings, Mr. Penguin! Of course I\'ll share it with you! You\'re my best friend!',26124),
(42353,'enUS','I\'m starving!','I\'m starving!',26124),
(42354,'enUS','HAHAHAH! Good one, Mr. Penguin! GOOD ONE!','HAHAHAH! Good one, Mr. Penguin! GOOD ONE!',26124),
(42355,'enUS','Get off my land!','Get off my land!',26124),
(42356,'enUS','I don\'t think I\'m gonna make it...','I don\'t think I\'m gonna make it...',26124),
(42357,'enUS','What happened to me? I used to be the king of Stormwind!','What happened to me? I used to be the king of Stormwind!',26124),
(42358,'enUS','Looks like we\'ll be eating shoe leather for dinner again.','Looks like we\'ll be eating shoe leather for dinner again.',26124),
(42359,'enUS','I wonder if it\'s possible to eat rocks? Got plenty of rocks around here. Just imagine it! I\'d be the richest person in the world for making that discovery!','I wonder if it\'s possible to eat rocks? Got plenty of rocks around here. Just imagine it! I\'d be the richest person in the world for making that discovery!',26124),
(42360,'enUS','I miss being robbed by the Defias. At least they\'d leave you a little something to eat from time to time.','I miss being robbed by the Defias. At least they\'d leave you a little something to eat from time to time.',26124),
(42361,'enUS','HEY! HEY YOU! GET OFF MY PROPERTY!','HEY! HEY YOU! GET OFF MY PROPERTY!',26124),
(42362,'enUS','Does $g he:she; have boots? Get \'em!','',26124),
(42363,'enUS','MINE!','',26124),
(42364,'enUS','Check $g his:her; pockets!','',26124),
(42365,'enUS','Whaddya want?','Whaddya want?',26124),
(42366,'enUS','I ain\'t tellin\' you nothin\'!','I ain\'t tellin\' you nothin\'!',26124),
(42367,'enUS','Get lost.','Get lost.',26124),
(42368,'enUS','Oh the big hero has arrived. I\'m saved! Yea, right...','Oh the big hero has arrived. I\'m saved! Yea, right...',26124),
(42369,'enUS','You wanna talk? Pay up.','You wanna talk? Pay up.',26124),
(42370,'enUS','Did you see who killed the Furlbrows?','Did you see who killed the Furlbrows?',26124),
(42371,'enUS','Maybe a couple copper will loosen your tongue. Now tell me, did you see who killed the Furlbrows?','Maybe a couple copper will loosen your tongue. Now tell me, did you see who killed the Furlbrows?',26124),
(42372,'enUS','','',26124),
(42373,'enUS','Are you sure you want to give this hobo money?','Are you sure you want to give this hobo money?',26124),
(42374,'enUS','You can\'t buy me! DIE!','You can\'t buy me! DIE!',26124),
(42375,'enUS','The only thing I\'ll tell you is to get the hell out of here!','The only thing I\'ll tell you is to get the hell out of here!',26124),
(42376,'enUS','You got no business here, lout! Beat it!','You got no business here, lout! Beat it!',26124),
(42377,'enUS','They died of natural causes...','They died of natural causes...',26124),
(42378,'enUS','You\'ll get nothing out of me!','You\'ll get nothing out of me!',26124),
(42379,'enUS','Judgment day comes! The brotherhood will be reborn!','Judgment day comes! The brotherhood will be reborn!',26124),
(42380,'enUS','Listen, $g pal:lady;, I don\'t want any trouble, ok? I didn\'t see who murdered \'em, but I sure heard it! Lot of yelling. Human voices... you dig? Now get out of here before I change my mind about beating you up and takin\' your shoes.','Listen, $g pal:lady;, I don\'t want any trouble, ok? I didn\'t see who murdered \'em, but I sure heard it! Lot of yelling. Human voices... you dig? Now get out of here before I change my mind about beating you up and takin\' your shoes.',26124),
(42381,'enUS','I didn\'t see who killed \'em, $g bub:lady;, but I got a whiff. Smelled rich, kinda like you. Damn shame too. Furlbrows were a fixture around here. Nice people, always willin\' to share a meal or a patch of dirt.','I didn\'t see who killed \'em, $g bub:lady;, but I got a whiff. Smelled rich, kinda like you. Damn shame too. Furlbrows were a fixture around here. Nice people, always willin\' to share a meal or a patch of dirt.',26124),
(42382,'enUS','Who killed the Furlbrows? I\'ll tell you who killed the Furlbrows: KING VARIAN WRYNN, THAT\'S WHO! And he\'s killin\' the rest of us too. One bum at a time. The only thing I can tell you is that I saw some gnolls leavin\' the place a few hours before the law arrived.','Who killed the Furlbrows? I\'ll tell you who killed the Furlbrows: KING VARIAN WRYNN, THAT\'S WHO! And he\'s killin\' the rest of us too. One bum at a time. The only thing I can tell you is that I saw some gnolls leavin\' the place a few hours before the law arrived.',26124),
(42383,'enUS','Between you, me, and the tree, murlocs killed the Furlbrows. Yep, saw \'em with my own two eyes. Think they\'d been casin\' the joint for days, maybe months. They left in a hurry once they got wind of \"Johnny Law\" and the idiot brigade over there...','Between you, me, and the tree, murlocs killed the Furlbrows. Yep, saw \'em with my own two eyes. Think they\'d been casin\' the joint for days, maybe months. They left in a hurry once they got wind of \"Johnny Law\" and the idiot brigade over there...',26124),
(42384,'enUS','You rich punks are all the same!','You rich punks are all the same!',26124),
(42385,'enUS','I ain\'t tellin\' you a damn thing!','I ain\'t tellin\' you a damn thing!',26124),
(42386,'enUS','Livin\' like an animal is hard enough without your insults!','Livin\' like an animal is hard enough without your insults!',26124),
(42387,'enUS','Maybe I can sell your liver for some gold.','Maybe I can sell your liver for some gold.',26124),
(42388,'enUS','I TOLD YOU TO PAY UP, PAL!','I TOLD YOU TO PAY UP, PAL!',26124),
(42389,'enUS','Now you\'ve gone and done it! TIME FOR THE FIST!','Now you\'ve gone and done it! TIME FOR THE FIST!',26124),
(42390,'enUS','You want my foot in your front or in your rear? Make the call.','You want my foot in your front or in your rear? Make the call.',26124),
(42391,'enUS','Begin the Assault!','Begin the Assault!',26124),
(42392,'enUS','These are grave times for Azeroth, $n.  The elementals have imprisoned both citizens around the city and those they battle with.  We can give you a totem that will break the elemental prison.','These are grave times for Azeroth, $n.  The elementals have imprisoned both citizens around the city and those they battle with.  We can give you a totem that will break the elemental prison.',26124),
(42393,'enUS','You heard him, men. We make our stand here!','',26124),
(42394,'enUS','Let us re-convene by my camp, as friends and fellow heroes, to discuss our final and most dangerous quest.  Hup Hup, Pimento!','',26124),
(42395,'enUS','Fight on, $n!','',26124),
(42396,'enUS','Lok\'tar, $n!','',26124),
(42397,'enUS','Your deeds bring glory and honor to the Horde, $n!','',26124),
(42398,'enUS','Bring these invaders a swift death, $n!','',26124),
(42399,'enUS','Crush these elementals, $n!  Drive them from our land!','',26124),
(42400,'enUS','This is it! The entrance to Neptulon\'s realm...','',26124),
(42401,'enUS','Fight dem back, $n!','',26124),
(42402,'enUS','Don\'t be lettin\' up, $n!','',26124),
(42403,'enUS','De elements don\'t stand a chance against ya, $n!','',26124),
(42404,'enUS','De elements be in for a world of hurt!  Follow my lead, $n!','',26124),
(42405,'enUS','Ya got some powerful mojo, $n!','',26124),
(42406,'enUS','','Come, children of Azshara! At last, we lay claim to the Plane of Water!',26124),
(42407,'enUS','','Go, my naga! Welcome the mighty Tidehunter to Azeroth!',26124),
(42408,'enUS','We assembled a mighty force and defeated Thermaplugg\'s servants, fighting our way into the city. But, the usurper Thermaplugg had one last trick up his sleeve...','',26124),
(42409,'enUS','Sandfury trolls working with the Twilight\'s Hammer?! No matter. That foul witch won\'t be sending her monster to MY city.','',26124),
(42410,'enUS','Come, brave ones! We\'ll slick the sand with their gore and return home triumphant.','',26124),
(42411,'enUS','We were forced to retreat. Thermaplugg continues to hide behind the radiation, sending his crony, Crushcog, to harass us here on the surface.','',26124),
(42412,'enUS','The Valley of Strength is Horde again! This pathetic attack on Orgrimmar will be crushed.  For the Horde!','',26124),
(42413,'enUS','Da voodoo is da strength of da horde.  Da Valley of da Sprits is now under Vol\'jin control! ','',26124),
(42414,'enUS','The Valley of Honor has been secured!','',26124),
(42415,'enUS','The Pincer X2 will be arriving shortly! Get your gear and form up, boys!','',26124),
(42417,'enUS','The Pincer X2 has docked. All aboard!','',26124),
(42418,'enUS','What little humie want? Why you call Glubtok?','',26124),
(42419,'enUS','','Sad... Is this the life that you had hoped for, Glubtok? Running two-bit extortion operations out of a cave?',26124),
(42420,'enUS','Glubtok crush you!','',26124),
(42421,'enUS','','Oh will you? Do you dare cross that line and risk your life?',26124),
(42422,'enUS','What option two?','',26124),
(42423,'enUS','','You may attempt to kill me - and fail - or you may take option two.',26124),
(42424,'enUS','','You join me and I shower wealth and power upon you.',26124),
(42425,'enUS','So Glubtok have two choices: die or be rich and powerful?','',26124),
(42426,'enUS','Well done, $n!  Stormwind is in your debt.','Well done, $n!  Stormwind is in your debt.',26124),
(42427,'enUS','Glubtok take choice two.','',26124),
(42428,'enUS','','I thought you\'d see it my way.',26124),
(42429,'enUS','','I will call for you when the dawning is upon us.',26124),
(42430,'enUS','GET!','',26124),
(42431,'enUS','OFF!','',26124),
(42432,'enUS','MY!','',26124),
(42433,'enUS','SHIP!','',26124),
(42434,'enUS','You and your scaly worms are no match for me...','',26124),
(42435,'enUS','','You fool! This day shall be your last!',26124),
(42436,'enUS','Get a totem from any Earthen Ring member! Use it to free citizens or defenders from the Elemental Prisons!','Get a totem from any Earthen Ring member! Use it to free citizens or defenders from the Elemental Prisons!',26124),
(42437,'enUS','They\'re after the Warchief -','',26124),
(42438,'enUS','The Warchief\'s zeppelin is in flames! It\'s going down!','',26124),
(42439,'enUS','Did you... Did you meet her?','',26124),
(42440,'enUS','Yep. She\'s for real.','',26124),
(42441,'enUS','She wanted me to tell you lugs that she appreciates the job that we did for her on the Furlbrows. Gave me a pile o\' gold to split with you all.','',26124),
(42442,'enUS','See her face? Is it really...','',26124),
(42443,'enUS','Whoa, what do we have here? Looks like we have ourselves an eavesdropper, boys.','',26124),
(42444,'enUS','Only one thing to do with a lousy, good-for-nothin eavesdropper.','',26124),
(42445,'enUS','DIE!','',26124),
(42446,'enUS','Hurry back to the Furlbrow\'s Cottage!','',26124),
(42447,'enUS','Doesn\'t look good, rookie.','',26124),
(42448,'enUS','The land suffers... it cries for mercy, $r, it cries for mercy.','',26124),
(42449,'enUS','This was an execution. Whoever did this was sending a message...','',26124),
(42450,'enUS','A message for anyone that would dare snitch on these criminals.','',26124),
(42451,'enUS','It would appear that poor Lou really put his foot...','',26124),
(42452,'enUS','In his mouth.','',26124),
(42453,'enUS','Please heroes, help my brothers and we shall assist you!','',26124),
(42454,'enUS','Thank you for rescuing me, now please aid the rest of my brood!','',26124),
(42455,'enUS','Feeding a Horde army is no easy task.  I have lots to do, do you have time to help?','Feeding a Horde army is no easy task.  I have lots to do, do you have time to help?',26124),
(42456,'enUS','You were standing right here! What the hell did you see? Speak up!','',26124),
(42457,'enUS','I... I didn\'t see nothin\'! He... he died of natural causes.','I... I didn\'t see nothin\'! He... he died of natural causes.',26124),
(42458,'enUS','Natural causes? Two bullets in the chest and his shoes are on his head. What kind of natural death would that be?','',26124),
(42459,'enUS','','We must do whatever it takes to recombine the fragments of the World Pillar.$B$BBut first, we must regain all of them.',26124),
(42460,'enUS','Been in Westfall all my life, $g brother:sister;. I can remember a day when Westfall was the lushest land this side of Stranglethorn Vale. Those days are long gone.$B$BWhile we no longer have Defias causing problems, the fallout from their reign of terror can still be felt. To make matters worse we\'re in the worst economic downturn in history. All that gold we spent on fighting the Scourge left anyone not in a military related occupation jobless and eventually homeless.$B$BGuess where all those people ended up?','',26124),
(42461,'enUS','Enough!  The Earthen Ring will temporarily stop the invasion.  But bewarned, the elementals will return!','Enough!  The Earthen Ring will temporarily stop the invasion.  But bewarned, the elementals will return!',26124),
(42462,'enUS','Egah - all hands aft. One\'s aboard. Shoot it! Kill it!','',26124),
(42463,'enUS','Somebody, DO SOMETHING! That\'s an order!','',26124),
(42464,'enUS','It\'s tangled up in the rigging.','',26124),
(42465,'enUS','Well done, heroes. Let us return through the very portal that witch meant to send this beast through! Much work awaits me in Stormwind.','',26124),
(42466,'enUS','Place barricades around Orgrimmar to protect the city!$B$BPick up a barricade from a box scattered around the city$B$Band then place them at a location marked by a red arrow |TInterface\\Icons\\ABILITY_HUNTER_MARKEDFORDEATH.blp:32|t.','',26124),
(42467,'enUS','Oh sure, she said, it\'ll be a simple trip out into the wastes.','',26124),
(42468,'enUS','','Thank you, $n. Your kindness will not be forgotten.',26124),
(42469,'enUS','','Dinner\'s ready! Come and get it!',26124),
(42470,'enUS','I\'m so happy. Thank you, mama and thank you, $n.','I\'m so happy. Thank you, mama and thank you, $n.',26124),
(42471,'enUS','She\'s going to blow! Get a parachute and jump!','',26124),
(42472,'enUS','YAY FOR $n!','YAY FOR $n!',26124),
(42473,'enUS','%s cries.','%s cries.',26124),
(42474,'enUS','%s buries itself in the sand!','',26124),
(42475,'enUS','You may only ride the Overloaded Harvest Golem at the Molsen Farm.','',26124),
(42476,'enUS','Initiating cleanup ... ...','',26124),
(42477,'enUS','She\'s breaking up, sir!','',26124),
(42478,'enUS','Tamp down the inflammants. Batten up the gear carriage. Rudder for the shore.','',26124),
(42479,'enUS','Everyone, to the parachutes!','',26124),
(42480,'enUS','Mayday! Mayday! Mayday! Bail out everyone. BAIL!','',26124),
(42481,'enUS','%s disperses!','',26124),
(42482,'enUS','Even here, among the surf and sun, I can feel the darkness that lurks in these lands.$B$BIt\'s fascinating, don\'t you think?','',26124),
(42483,'enUS','Even here, among the surf and sun, I can feel the darkness that lurks in these lands.$B$BIt\'s fascinating, isn\'t it?','',26124),
(42484,'enUS','Da elementals be gone!  Da Valley of Spirits be ours!','',26124),
(42485,'enUS','We are proud to call ourselves the last tribe of Forest Trolls to serve the Horde.$B$BIn time, we will overcome the other tribes, and the dwarves, and the Hinterlands will be ours.','',26124),
(42486,'enUS','Thank you, kind and gentle stranger.','Thank you, kind and gentle stranger.',26124),
(42487,'enUS','Westfall stew? I\'ll never forget this moment!','Westfall stew? I\'ll never forget this moment!',26124),
(42488,'enUS','I\'d know that smell anywhere! Salma\'s famous stew!','I\'d know that smell anywhere! Salma\'s famous stew!',26124),
(42489,'enUS','Maybe... maybe life is worth living.','Maybe... maybe life is worth living.',26124),
(42490,'enUS','Bless you, friend.','Bless you, friend.',26124),
(42491,'enUS','Perhaps one day I will repay you for this kind act.','Perhaps one day I will repay you for this kind act.',26124),
(42492,'enUS','I can\'t help ya. Go talk ta Voldreka if ya want warlock trainin\'.','I can\'t help ya. Go talk ta Voldreka if ya want warlock trainin\'.',26124),
(42493,'enUS','Wit\' practice, ya\'ll find that the dark arts can be much stronga than any weapon.','',26124),
(42494,'enUS','','The trolls here are quite accepting of my kind. After all, they spoke to the dead for centuries before the Forsaken even existed.$B$BIt\'s good for business.',26124),
(42495,'enUS','','In my youth, my family did not approve of my interest in shamanism. Brash and foolish as I was, I ran away from them and practiced on my own.  Upon returning to my home one day, I found my parents gone. My home destroyed. They never found who did it.\n\nI\'ve spent my life striving to extend my shamanistic visions to see into the past - to find out what happened to my family and who is responsible. I\'ve come a great way. I\'ve learned to focus in on impactful events in the recent past, but I have much further to go if I ever hope to glimpse something that occurred so long ago.',26124),
(42496,'enUS','I misplaced the enchanted blade that you gave me. Have you seen it?','I misplaced the enchanted blade that you gave me. Have you seen it?',26124),
(42497,'enUS','<Wind howls past the statue as you stand in front of it.>','',26124),
(42498,'enUS','Akil\'darah, return me to my allies.','Akil\'darah, return me to my allies.',26124),
(42499,'enUS','Jintha\'alor gonna be ours, mon. The vilebranch be weak, nasty traitors, undeservin\' of the favor of the loa.','',26124),
(42500,'enUS','Send me to Akil\'darah at the middle terrace.','Send me to Akil\'darah at the middle terrace.',26124),
(42505,'enUS','You have our full cooperation, lieutenant. The Furlbrows were good people. Their deaths will not go unpunished.','',26124),
(42506,'enUS','That\'s good to hear, marshal. While $n has brought the perpetrators to justice, their ringleader is still on the loose. Perhaps with the aid of the Westfall Brigade we will finally be able to solve this case.','',26124),
(42507,'enUS','Might I ask, what\'s with the worgen in the stocks?','',26124),
(42508,'enUS','We caught this beast slaughtering sheep in the countryside. He is unrepentant and easily agitated. Keep your distance, lieutenant.','',26124),
(42509,'enUS','When I break out of these stocks I\'m going to rip out your heart and devour it whole!','',26124),
(42510,'enUS','Wow, the marshal wasn\'t kidding.','',26124),
(42511,'enUS','But is your bark...','',26124),
(42512,'enUS','Worse than your bite?','',26124),
(42518,'enUS','You\'ve reached too far, serpent. You shall suffer greatly for your trespass!','',26124),
(42526,'enUS','%s attempts to hide on the ocean floor!','',26124),
(42527,'enUS','The war in Northrend took its toll on us as a people, $n. While we were victorious in the frozen wastes, our own land fell into disarray.\n','',26124),
(42528,'enUS','Do you know anything about this, beast? Who is the admiral? Speak!','',26124),
(42529,'enUS','The dawning comes, Stoutmantle, and with it comes your end.','',26124),
(42530,'enUS','Gibberish from a mad wolf. Bah!','',26124),
(42531,'enUS','','I\'ve got your back, $n.',26124),
(42532,'enUS','','Headshot!',26124),
(42533,'enUS','','Not a chance.',26124),
(42534,'enUS','','Easy peasy.',26124),
(42535,'enUS','','Got him!',26124),
(42536,'enUS','The gnolls have failed, mistress. ','',26124),
(42537,'enUS','','They provided the distraction I required. We continue as planned.',26124),
(42538,'enUS','But mistress, the admiral is sti...','',26124),
(42539,'enUS','','We will free the admiral during the dawning.',26124),
(42540,'enUS','Yes, mistress.','',26124),
(42541,'enUS','','Judgment day is soon upon us, Helix.',26124),
(42542,'enUS','','Call for the people. I wish to speak to them one last time before the dawning.',26124),
(42543,'enUS','Moonbrook, mistress?','',26124),
(42544,'enUS','','Aye. Tonight.',26124),
(42545,'enUS','','To me, my minions! Strike now!',26124),
(42546,'enUS','','Do not relent! He is weakening!',26124),
(42547,'enUS','Ahhhhh!','',26124),
(42548,'enUS','Nooooo!','',26124),
(42549,'enUS','Naz\'jar and her honor guard! Fight for your lives!','',26124),
(42550,'enUS','Naz\'jar and her honor guard... Fight for your lives!','',26124),
(42551,'enUS','Little early to the party, aren\'t ya?','',26124),
(42552,'enUS','This is the end of the line, pal!','',26124),
(42553,'enUS','Where do you think you\'re goin\'?','',26124),
(42554,'enUS','If you ain\'t with us, you\'re against us! DIE!','',26124),
(42555,'enUS','Ready for inspection, $gsir:ma\'am;!','',26124),
(42556,'enUS','This baby is all mine! I call her, \"The Throttler.\"','',26124),
(42557,'enUS','Ready for inspection! ...Be gentle.','',26124),
(42558,'enUS','See that? Ironclad!','',26124),
(42559,'enUS','That\'s right. Takes a lickin\' but keeps on kickin\' butt!','',26124),
(42560,'enUS','There is nothing left for us but to wait... and hope.','',26124),
(42561,'enUS','Uh oh. Um. Oops.','',26124),
(42562,'enUS','Look, look, it\'s okay! It\'s just a tiny little glitch. See?','',26124),
(42563,'enUS','A little paint and it\'ll be fine!','',26124),
(42564,'enUS','I ... I never wanted to be an engineer anyways.','',26124),
(42565,'enUS','I always wanted to be... a dancer! Power tools frighten me.\n','',26124),
(42566,'enUS','I can float. On my toes. I\'m like a butterfly. Wanna see?','',26124),
(42567,'enUS','%s takes off running.','',26124),
(42568,'enUS','It\'s still good enough to ship. I can fix it with a patch!','',26124),
(42569,'enUS','','The rally is about to begin!',26124),
(42570,'enUS','','Gather, brothers and sisters! Come, all, and listen!',26124),
(42571,'enUS','','Brothers. Sisters. We are ABANDONED - the orphaned children of Stormwind.',26124),
(42572,'enUS','','Our \"king\" sits atop his throne made of gold and shrugs at our plight!',26124),
(42573,'enUS','','Meanwhile, our children die of starvation on these very streets!',26124),
(42574,'enUS','','HIS war, not ours, cost us our livelihood. WE paid for the Alliance\'s victories with our blood and the blood of our loved ones!',26124),
(42575,'enUS','','The time has come, brothers and sisters, to stop this injustice!',26124),
(42576,'enUS','','The government of Stormwind, of the ALLIANCE, must be made accountable for what it has done to us!',26124),
(42577,'enUS','','Today, we are reborn! Today, we take a stand as men and women, not nameless, faceless numbers!',26124),
(42578,'enUS','%s throws his fish at you and attempts to run away in fear!\n','%s throws his fish at you and attempts to run away in fear!\n',26124),
(42579,'enUS','Thank you for breaking me out of here!','',26124),
(42580,'enUS','I don\'t ever want to smell unwashed trogg again!','',26124),
(42581,'enUS','Thanks. Now, let\'s blow up that cave!','',26124),
(42582,'enUS','You have no idea how happy I am to see you!','',26124),
(42583,'enUS','Finally, someone who\'s not a trogg!','',26124),
(42584,'enUS','I\'m free! I\'m really free!','',26124),
(42585,'enUS','Friends of the tribe, our city is under attack!  Take up your arms and defend our home!  If you do not wish to battle, then grab weather breakers and line our city to protect it\'s citzens from the elements!','',26124),
(42586,'enUS','Place weather breakers around Thunder Bluff to protect the city!$B$BPick up wind breaks in crates around the city$B$Band place them at locations marked with a red arrow |TInterface\\Icons\\ABILITY_HUNTER_MARKEDFORDEATH.blp:32|t.','',26124),
(42587,'enUS','We\'ll get right on this, $gsir:ma\'am;!','',26124),
(42588,'enUS','The Center Rise has been reclaimed!  The Earthmother be praised!','',26124),
(42589,'enUS','We\'re on it!','',26124),
(42590,'enUS','Yes $gsir:ma\'am;! Right away, $gsir:ma\'am;! ','',26124),
(42591,'enUS','','We have secured the Hunter\'s Rise! All invaders have been repelled and the evacuation has been completed!',26124),
(42592,'enUS','Spirit Rise is secure! The invaders have been eliminated and the evacuation is complete!','',26124),
(42593,'enUS','There\'s nowhere left to hide, VanCleef! The Defias are THROUGH!','',26124),
(42594,'enUS','We\'re here to finish this! Face us, coward!','',26124),
(42595,'enUS','None may challenge the Brotherhood!','',26124),
(42596,'enUS','Make your preparations, $n, but do it quickly!','',26124),
(42597,'enUS','I am prepared, Erunak. Let\'s go!','I am prepared, Erunak. Let\'s go!',26124),
(42598,'enUS','Cover the door - we\'ve got him!','Cover the door - we\'ve got him!',26124),
(42599,'enUS','Oh no not de bar! Take it outside, mon!','',26124),
(42600,'enUS','I\'m stopping my patrol now!','',26124),
(42601,'enUS','I\'m starting my patrol now!','',26124),
(42602,'enUS','Victory for the Alliance! Glory to Stormwind!','',26124),
(42603,'enUS','Let us return to Sentinel Hill, allies, and inform Gryan of VanCleef\'s demise!','',26124),
(42604,'enUS','','Daddy...',26124),
(42605,'enUS','The wind and air elementals threaten to destroy Thunder Bluff.  If you think you are strong enough to go in there, be my guest.  Otherwise, stay out of the city and let us take care of it.','',26124),
(42606,'enUS','Elemental rifts have opened up around the city.  We need to shut them down now! Evacuate all non-combat ready citizens.  Make sure they get to safety!','',26124),
(42607,'enUS','Keep pressing the fight, $n!','Keep pressing the fight, $n!',26124),
(42608,'enUS','Don\'t let up, $n!','Don\'t let up, $n!',26124),
(42609,'enUS','Fight on, $n!','Fight on, $n!',26124),
(42610,'enUS','Continue the attack, $n!','Continue the attack, $n!',26124),
(42611,'enUS','It seems your reputation as a formidable $c is well earned, $n!','It seems your reputation as a formidable $c is well earned, $n!',26124),
(42612,'enUS','Your skills in battle are impressive, $n.','Your skills in battle are impressive, $n.',26124),
(42613,'enUS','Leave this old Dragonmaw to his drink, $c.$B$BI\'ve fought creatures that would curl your spine and I\'ve seen my people all but slaughtered in the swamps of the wetlands and amidst the ruins of Outland.$B$BGet. Lost.','',26124),
(42614,'enUS','What\'s this, $c? You know my name?$B$BDo you know, then, of my reputation?$B$BI am Flametusk of the Dragonmaw clan. I commanded legions, flew on dragonback, witnessed the sundering of Grim Batol...$B$BCurse the Twilight\'s Hammer, and curse their ogre lapdogs. Look at me now. All talk and cheap liquor.','',26124),
(42615,'enUS','The Dragonmaw can be great again. Help our conquest of the Twilight Highlands - can you give me a map?','The Dragonmaw can be great again. Help our conquest of the Twilight Highlands - can you give me a map?',26124),
(42616,'enUS','I will help, but know that you\'re stepping into a viper\'s nest. Let me draw you a map - wha - behind you!','',26124),
(42617,'enUS','So, Twilight\'s Hammer is trying to finish me off? Honorless filth!$B$BI will definitely help you, $c. You say you need a map?','',26124),
(42618,'enUS','','No matter what\'s going on elsewhere, Ironforge hasn\'t forgotten this land, nor any of Khaz Modan.',26124),
(42619,'enUS','You sense that you are being followed...','',26124),
(42620,'enUS','You fight without honor and die like vermin!','',26124),
(42621,'enUS','Twilight scum.','',26124),
(42622,'enUS','Feel the bite of the Dragonmaw!','',26124),
(42623,'enUS','Another worm driven to the ground.','',26124),
(42624,'enUS','Only the weak hide in shadows, Twilight filth!','',26124),
(42625,'enUS','Yes, a map of the coastal approaches.','Yes, a map of the coastal approaches.',26124),
(42626,'enUS','%s scrawls out a depiction of his home port on a torn parchment.','',26124),
(42627,'enUS','There you have it, $n. All the safe approaches to the Twilight Highlands. Unleash havoc on our foes!','',26124),
(42628,'enUS','Twilight\'s Hammer. Bah. Bunch of prancing purple... pussycats. Back to business. Gravy! What am I drinking?','',26124),
(42629,'enUS','Good. Then keep it coming.','',26124),
(42630,'enUS','You be drinkin\' everyting, mon.','',26124),
(42631,'enUS','%s motions for you to speak with him again.','',26124),
(42632,'enUS','What are you still doing here, $c?$B$BShouldn\'t you be in Twilight Highlands laying waste to that wretched cult?','',26124),
(42633,'enUS','They poisoned our supplies... we had cultists onboard all along...','They poisoned our supplies... we had cultists onboard all along...',26124),
(42634,'enUS','They tricked us into ambushing the Horde gunship... but why?','They tricked us into ambushing the Horde gunship... but why?',26124),
(42635,'enUS','I heard them praying to their dark gods as everything went black... the Twilight\'s Hammer did this!','I heard them praying to their dark gods as everything went black... the Twilight\'s Hammer did this!',26124),
(42636,'enUS','Everyone started dropping like flies... everyone who ate the rations.','Everyone started dropping like flies... everyone who ate the rations.',26124),
(42637,'enUS','Twilight scum!  You did this to us!','Twilight scum!  You did this to us!',26124),
(42638,'enUS','Throw de big skull in de pot!','',26124),
(42639,'enUS','Throw de mojos on de skull!','',26124),
(42640,'enUS','Magic\'s done.','',26124),
(42641,'enUS','Watch Nimboya do what Nimboya does best.','',26124),
(42642,'enUS','Warriors. You\'ve fought hard in the frozen wastes. Your courage is to be tested again.','',26124),
(42643,'enUS','My warriors! You have already proven your valor. This is why the Warchief has selected you.','',26124),
(42644,'enUS','Heroes of the Horde! Are you ready to create history?','',26124),
(42645,'enUS','We embark soon for distant shores, to hurl ourselves at the enemy homeland.','',26124),
(42646,'enUS','Our enemy, cloaked in shadow, seeks to unmake our world. We will not lose another home.','',26124),
(42647,'enUS','Our destination is the Twilight Highlands. We strike at the beating heart of our enemy.','',26124),
(42648,'enUS','We assemble an enormous fleet: land, sea, and air. We are legion!','',26124),
(42649,'enUS','When our fury is unleashed, our enemies will cower!','',26124),
(42650,'enUS','Our wrath will paint the highlands red  - or whatever color our enemies bleed!','',26124),
(42651,'enUS','The eyes of Hellscream are upon you.','',26124),
(42652,'enUS','Let\'s see some spirit. Strike! Strike! Strike!','',26124),
(42653,'enUS','Show me what you\'ve got!','',26124),
(42654,'enUS','Now. Show me your fury. Show me!','',26124),
(42655,'enUS','I don\'t like this, $n. Stay alert!','',26124),
(42656,'enUS','','You bastards will burn for what you did.',26124),
(42657,'enUS','Hope! Wha..','',26124),
(42658,'enUS','','Hope? Is that what I was supposed to feel when I saw my father decapitated by your henchmen?',26124),
(42659,'enUS','','Hope is a cruel joke, played upon us by a harsh and uncaring world. There is no Hope, there is only Vanessa. Vanessa VanCleef.',26124),
(42660,'enUS','','RISE UP BROTHERHOOD! THE DAWNING DAY IS UPON US!',26124),
(42661,'enUS','','Tie them up.',26124),
(42662,'enUS','','Admiral, your hat.',26124),
(42663,'enUS','Thank you, my dear.','',26124),
(42664,'enUS','Boden the Imposing, I come on behalf of the Earthen Ring. We wish your kind no harm. We seek to repair the rift between our worlds. Why do you attack us?','Boden the Imposing, I come on behalf of the Earthen Ring. We wish your kind no harm. We seek to repair the rift between our worlds. Why do you attack us?',26124),
(42665,'enUS','Hah! Did you mistake me for Diamant, $r? Or perhaps some other whimpering, compliant stone trogg who cares?','',26124),
(42666,'enUS','If you seek peace, relinquish the World Pillar and leave Deepholm. This is our realm. Your only welcome here shall be found underneath my stone foot.','',26124),
(42667,'enUS','Jessup McCree, of McCree\'s Mountain Movers, at your service.','',26124),
(42668,'enUS','If you need a mountain moved, I can do that. I can make \'em for you, too. ','',26124),
(42669,'enUS','This isn\'t the biggest job I\'ve done, not even close. This cataclysm may just be the best thing that ever happened to us!','',26124),
(42670,'enUS','What can I do for you, chief?','What can I do for you, chief?',26124),
(42671,'enUS','Thanks for the help. That one was far tougher for some reason.','Thanks for the help. That one was far tougher for some reason.',26124),
(42672,'enUS','','Leave nothing but ashes in your wake, brothers! Burn Sentinel Hill to the ground!',26124),
(42673,'enUS','','And you, $n, I will spare your life. You have done much to help our cause, albeit unwittingly, but the next time we meet it will be as enemies. ',26124),
(42674,'enUS','Just tell me one thing, Vanessa.','',26124),
(42675,'enUS','Why\'d you have the Furlbrows killed?','',26124),
(42676,'enUS','','I had no choice, lieutenant. They recognized me. The only people in the world who even knew I existed, recognized my face from when I was an infant.',26124),
(42677,'enUS','','I took no pleasure in their deaths.',26124),
(42678,'enUS','','So it is certain den. Dese elementals were bound from dormant stone only recently.',26124),
(42679,'enUS','','Only an elemental lord could bind so many elementals so quickly. It seems we\'re at war with da Stonemother herself...',26124),
(42680,'enUS','','May da elements protect us.',26124),
(42681,'enUS','$n, get to Stormwind. Tell King Wrynn everything. EVERYTHING! GO NOW!','',26124),
(42682,'enUS','A chance to catch my breath! Thank you.','A chance to catch my breath! Thank you.',26124),
(42683,'enUS','By the elements... that one... just wouldn\'t die...','By the elements... that one... just wouldn\'t die...',26124),
(42684,'enUS','Thanks for the relief. It\'s getting hairy out here.','Thanks for the relief. It\'s getting hairy out here.',26124),
(42685,'enUS','I\'d started to think we\'d been left out here. Thanks for the hand!','I\'d started to think we\'d been left out here. Thanks for the hand!',26124),
(42686,'enUS','Careful out here, they don\'t stop coming.','Careful out here, they don\'t stop coming.',26124),
(42687,'enUS','Don\'t stay out here too long, there will be more on top of you any second.','Don\'t stay out here too long, there will be more on top of you any second.',26124),
(42688,'enUS','Thank you. I could use the rest.','Thank you. I could use the rest.',26124),
(42689,'enUS','Nice job! Let\'s finish him off.','',26124),
(42690,'enUS','Need a hand?','',26124),
(42691,'enUS','I saw that move you pulled with the grapple. The boys will be hearing about that one when we get back for sure.','',26124),
(42692,'enUS','Quick! Finish him while he\'s down!','',26124),
(42693,'enUS','That\'s more like it.','',26124),
(42694,'enUS','Not tossing boulders at us anymore, are ya?','',26124),
(42695,'enUS','Where can I get one of those ropes?! That was brilliant.','',26124),
(42696,'enUS','And now to make sure he doesn\'t get back up...','',26124),
(42697,'enUS','Brothers and sisters, Ironforge is under attack!  Take up your arms and defend our capital!  If you do not want to answer the call of battle, then grab some fortifications and line help keep the walls from collapsing on us!','',26124),
(42698,'enUS','The Commons are secured!  Now, secure the rest of the city!','',26124),
(42699,'enUS','Fortify the walls of Ironforge to prevent the city from collapsing!$B$BPick up wall fortifications in crates around the city$B$Band place them at locations marked with a red arrow |TInterface\\Icons\\ABILITY_HUNTER_MARKEDFORDEATH.blp:32|t.','',26124),
(42700,'enUS','Do it!  Give him de raptor!  I don\'t like havin\' this sword in my face!','',26124),
(42701,'enUS','I think I lost them.','',26124),
(42702,'enUS','Optical sensor malfunction detected! Shutting down...','',26124),
(42703,'enUS','The Military Ward is clear of rifts and we have completed the evacuation of the citizens in this district!','',26124),
(42704,'enUS','There\'d be no more elementals in the Mystic Ward now. We\'ve also cleared out all of those trapped folks too! ','',26124),
(42705,'enUS','I\'VE BEEN INTERRUPTED! CALL ALEX!','I\'VE BEEN INTERRUPTED! CALL ALEX!',26124),
(42706,'enUS','The giant is down.  Kill it quickly!','The giant is down.  Kill it quickly!',26124),
(42707,'enUS','Ironforge is under attack!  You\'d better be strong enough to defend the city if ya want to go in there.$B$BKing Magni ordered a full evacuation of the city and put me in charge of seeing that through.  Don\'t go in there, get yerself hurt and then blame me!','',26124),
(42708,'enUS','I hope you can fly, pipsqueak!','',26124),
(42709,'enUS','That\'s the way, $n!','That\'s the way, $n!',26124),
(42710,'enUS','Don\'t ya let up now, $n!','Don\'t ya let up now, $n!',26124),
(42711,'enUS','Keep on fightin\', $n!','Keep on fightin\', $n!',26124),
(42712,'enUS','Fight on, $n!','Fight on, $n!',26124),
(42713,'enUS','Continue the attack, $n!','Continue the attack, $n!',26124),
(42714,'enUS','Yer reputation as a formidable $c is well earned, $n!','Yer reputation as a formidable $c is well earned, $n!',26124),
(42715,'enUS','Yer skills in battle are impressive, $n.','Yer skills in battle are impressive, $n.',26124),
(42716,'enUS','Precisely how to do it, $n!','Precisely how to do it, $n!',26124),
(42717,'enUS','Do not even think of letting up, $n!','Do not even think of letting up, $n!',26124),
(42718,'enUS','Stay on the attack, $n!','Stay on the attack, $n!',26124),
(42719,'enUS','You are a most effective fighter, $n!','You are a most effective fighter, $n!',26124),
(42720,'enUS','Hey, $c!$B$BGot any leads on some lucrative contracts? I\'ll cut you in on one tenth! Of a percent! ','',26124),
(42721,'enUS','What\'s the deal, $c?$B$BWord on the docks is that you\'ve been poking around my construction sites...','',26124),
(42722,'enUS','Nobody shorts Garrosh Hellscream. You finish those ships - and finish them right - or this gets personal.','Nobody shorts Garrosh Hellscream. You finish those ships - and finish them right - or this gets personal.',26124),
(42723,'enUS','','Eek!',26124),
(42724,'enUS','Nobody tells me how to run my business here.','',26124),
(42725,'enUS','Be ready! The ground shakes and the fires burn hotter! Get out if ya still can!','Be ready! The ground shakes and the fires burn hotter! Get out if ya still can!',26124),
(42726,'enUS','Watch fer fallin\' rocks!  The ground shakes harder.  Flee the city!','Watch fer fallin\' rocks!  The ground shakes harder.  Flee the city!',26124),
(42727,'enUS','Citizens of Ironforge! Begin the evacuation!','Citizens of Ironforge! Begin the evacuation!',26124),
(42728,'enUS','Guests of Ironforge! Get out of the city! It may collapse at any moment!','Guests of Ironforge! Get out of the city! It may collapse at any moment!',26124),
(42729,'enUS','Watch out fer fallin\' rocks!  Clear the streets!','Watch out fer fallin\' rocks! Clear the streets!',26124),
(42730,'enUS','Flee the city!  The ground can\'t stop shakin\'!','Flee the city!  The ground can\'t stop shakin\'!',26124),
(42731,'enUS','The sky darkens and the elements are restless! Seek shelter!','The sky darkens and the elements are restless! Seek shelter!',26124),
(42732,'enUS','Be on your guard! The clouds move in and the wind picks up! Seek shelter!','Be on your guard! The clouds move in and the wind picks up! Seek shelter!',26124),
(42733,'enUS','Citizens of Thunder Bluff! Evacuate the city!','Citizens of Thunder Bluff! Evacuate the city!',26124),
(42734,'enUS','The wind grows stronger! Take the lifts to safer ground!','The wind grows stronger! Take the lifts to safer ground!',26124),
(42735,'enUS','Clear the paths! Stay away from the sides of the bluff!','Clear the paths! Stay away from the sides of the bluff!',26124),
(42736,'enUS','Evacuate Thunder Bluff!  Stay away from the sides of the bluff!','Evacuate Thunder Bluff!  Stay away from the sides of the bluff!',26124),
(42738,'enUS','It was just a couple of rivets. That ship had plenty!','',26124),
(42739,'enUS','I\'m sure it would\'ve been seaworthy in calm waters.','',26124),
(42740,'enUS','Less rivets mean a cleaner environment!','',26124),
(42741,'enUS','...can we settle this with cash?','',26124),
(42742,'enUS','Okay okay, stop! Stop! You make a compelling argument.','',26124),
(42743,'enUS','I\'ll double the worker shifts and put in my own money to get those ships seaworthy and back on schedule. Count on it!','',26124),
(42744,'enUS','Dere be nothin\' chaotic about dis attack. Da elementals and giants be organizin\' against us. It be seemin\' dat somehow we\'ve earned da ire of Therazane, da Stonemother herself.','',26124),
(42745,'enUS','Welcome to Zul\'Gurub, little one.  It might not look like much now, but give it time...','',26124),
(42746,'enUS','Ahh... it\'s good to be home.','',26124),
(42747,'enUS','There\'s plenty others of your kind here, but I wouldn\'t worry about competition.  You\'re from the bloodline of Ohgan, my oldest friend.  You see... our souls are intertwined, yours and mine.','',26124),
(42748,'enUS','Here we are.  Get ready for your training, little one.  I recommend you forget about that worthless $r $c and start thinking about your duties here in Zul\'Gurub.','',26124),
(42749,'enUS','NO MORE! ONGOLONGO GO HOME!','',26124),
(42750,'enUS','PUNY TROLLS NOT STOP ONGOLONGO!','',26124),
(42751,'enUS','','Priestess knows much about Zul\'Gurub.$b$bPriestess thinks you need her help.',26124),
(42752,'enUS','I am ready for the Mind Vision ritual, Hu\'rala.','I am ready for the Mind Vision ritual, Hu\'rala.',26124),
(42753,'enUS','You get back in dat pen!','',26124),
(42754,'enUS','Crushcog\'s defeat will send a powerful message to his master, Thermaplugg. The gnomes of Gnomeregan will not be stopped!','',26124),
(42755,'enUS','I\'m ready to start the assault.','I\'m ready to start the assault.',26124),
(42756,'enUS','I have deduced that you must die!','',26124),
(42757,'enUS','I should have... predicted... this...','',26124),
(42758,'enUS','Mekgineer Thermaplugg refuses to acknowledge that his defeat is imminent! He has sent Razlo Crushcog to prevent us from rebuilding our beloved Gnomeregan!','',26124),
(42759,'enUS','But $n has thwarted his plans at every turn, and the dwarves of Ironforge stand with us!','',26124),
(42760,'enUS','Let\'s send him crawling back to his master in defeat!','',26124),
(42761,'enUS','You! How did you escape detection by my sentry-bots?','',26124),
(42762,'enUS','No matter! My guardians and I will make short work of you. To arms, men!','',26124),
(42763,'enUS','We\'ve done it! We\'re victorious!','',26124),
(42764,'enUS','SAMOPHLANGE!','',26124),
(42765,'enUS','With Crushcog defeated, Thermaplugg is sure to be quaking in his mechano-tank, and rightly so. You\'re next Thermaplugg. You\'re next!','',26124),
(42766,'enUS','That\'ll teach you to mess with the might of Ironforge and Gnomeregan!','',26124),
(42767,'enUS','Aye, let\'s teach this addle-brained gnome a lesson!','',26124),
(42768,'enUS','$n stiff-arms Smoot and throws him to the ground.','',26124),
(42769,'enUS','Oh samophlange... I have failed you!','',26124),
(42770,'enUS','They need you on the northwestern field! Go!','',26124),
(42771,'enUS','The temple is under siege. We need you outside, now!','',26124),
(42772,'enUS','Get to the battlefield!','',26124),
(42773,'enUS','Keep moving! They need you on the field!','',26124),
(42774,'enUS','We\'re holding them in the northwest - reinforce the line!','',26124),
(42775,'enUS','Our brothers are falling to the northwest. Get out there and help them!','',26124),
(42776,'enUS','The earth elementals have turned on us. Get onto the field and hold them back!','',26124),
(42777,'enUS','We are besieged by elementals and giants! Your help is needed in the northwest, Earthguard!','',26124),
(42778,'enUS','Bind at this location.','Bind at this location.',26124),
(42779,'enUS','Purchase food and water.','Purchase food and water.',26124),
(42780,'enUS','You may rest here, and there is food and water.','You may rest here, and there is food and water.',26124),
(42781,'enUS','You will never defeat the true sons of Gnomeregan!','',26124),
(42782,'enUS','All hail Samophlange!','',26124),
(42783,'enUS','One Samophlange to rule them all!','',26124),
(42784,'enUS','Behold: The Samophlange.','',26124),
(42785,'enUS','I have built it. And it is mine. Samophlange!','',26124),
(42786,'enUS','Oh, Samophlange. Is there nothing you can\'t do?','',26124),
(42787,'enUS','I love you, Samophlange!','',26124),
(42788,'enUS','And upon the dawn of the first day the Samophlange beheld what it had wrought, and lo, it was good.','',26124),
(42789,'enUS','You are brave to try to escape, young Ohgan\'aka.$b$bBefore you continue, let me teach you how to use your teeth to bite through the trolls\' nets.','',26124),
(42790,'enUS','<Learn to bite through nets from the elder raptor.>','<Learn to bite through nets from the elder raptor.>',26124),
(42791,'enUS','You are leaving the raptor dens?  I was commanded to guard this post and prevent escapes, but... I think I understand why you want to leave.$b$bFine.  You may pass, but first, I have a request.$b$bThe trolls often carry packs of raptor food, and I haven\'t been fed in days.  You don\'t stand a chance in combat, but you\'re small enough that you might be able to steal it from one of the sleeping trolls inside the tents...','',26124),
(42792,'enUS','Alright, Tenjiyu.  I\'ll go get you some food from the sleeping trolls.','Alright, Tenjiyu.  I\'ll go get you some food from the sleeping trolls.',26124),
(42793,'enUS','I\'ve brought some food for you.','I\'ve brought some food for you.',26124),
(42794,'enUS','Quite impressive to have made it this far, Ohgan\'aka.  You are truly a talented young raptor... but the toughest test is yet to come.$b$bThe trolls patrol the bridges up ahead, and they will be difficult to distract.  If you drop a skull in their path, however, you may be able to cause them to trip and fall...','',26124),
(42795,'enUS','<Learn to drop skulls from the elder raptor.>','<Learn to drop skulls from the elder raptor.>',26124),
(42796,'enUS','Gotcha!','',26124),
(42797,'enUS','I am ready for the Mind Control ritual, Hu\'rala.','I am ready for the Mind Control ritual, Hu\'rala.',26124),
(42798,'enUS','The line is secured to his ankle.  Pull away to trip him!','The line is secured to his ankle.  Pull away to trip him!',26124),
(42799,'enUS','','Over here, you ugly whale!',26124),
(42800,'enUS','You!  Let me go now!  Wait... no!  Don\'t let go!','',26124),
(42801,'enUS','$n, along with High Tinker Mekkatorque and Mountaineer Stonegrind, has defeated Razlo Crushcog!','',26124),
(42802,'enUS','The victorious heroes have returned! Control of Chill Breeze Valley is ours once again!','',26124),
(42803,'enUS','$gSir:Ma\'am;!','',26124),
(42804,'enUS','$gSir, yes sir:Ma\'am, yes ma\'am;!','',26124),
(42805,'enUS','Three cheers for $n!','Three cheers for $n!',26124),
(42806,'enUS','$gRight away, sir:Right away ma\'am;!','',26124),
(42807,'enUS','Victory at last!','Victory at last!',26124),
(42808,'enUS','I\'m sorry, $gsir:ma\'am;!','',26124),
(42809,'enUS','I\'ll drink to that!','I\'ll drink to that!',26124),
(42810,'enUS','It won\'t happen again, $gsir:ma\'am;.','',26124),
(42811,'enUS','Please don\'t tell the Warlord...','',26124),
(42812,'enUS','','Meet me back up top.  This two-headed freak has a few questions to answer!',26124),
(42813,'enUS','Ok, ok, I give up!  I\'ll tell you everything!','',26124),
(42814,'enUS','chews out an AWOL grunt.','chews out an AWOL grunt.',26124),
(42815,'enUS','You\'re no superior of mine!','',26124),
(42816,'enUS','I think this $c is spoiling for a fight.','',26124),
(42817,'enUS','You want some of this!?','',26124),
(42818,'enUS','You want some of this!?','',26124),
(42819,'enUS','Stupid $r think $ghe\'s:she\'s; the boss of me.','',26124),
(42820,'enUS','$C, you just earned yourself a beating.','',26124),
(42821,'enUS','I\'m sorry - I\'ll return to my post!','',26124),
(42822,'enUS','Enough! I shouldn\'t have questioned your orders...','',26124),
(42823,'enUS','That\'s the best brawl I\'ve had in weeks! I\'ll save the rest for our enemies.','',26124),
(42824,'enUS','You fight well! I hope to have you by my side in the highlands.','',26124),
(42825,'enUS','Blackrock Caverns, a level 79-81 dungeon on Blackrock Mountain, is now available for testing. Please be in your full group before teleporting to the dungeon. Meeting Stones are not available for this dungeon yet.\n\nTo leave the Halls of Stone, simply exit through the normal exit inside the dungeon and you will be teleported to Dalaran. If you die and release, you should teleport back from this NPC.','',26124),
(42826,'enUS','I\'m in my group and ready to teleport to the Blackrock Caverns!','I\'m in my group and ready to teleport to the Blackrock Caverns!',26124),
(42827,'enUS','Take me back to Blackrock Caverns!','Take me back to Blackrock Caverns!',26124),
(42828,'enUS','The AWOL Grunt throws some dice.','',26124),
(42829,'enUS','Mekkatorque-Cannon!','',26124),
(42830,'enUS','The dice do not lie!','',26124),
(42831,'enUS','You cheat.','',26124),
(42832,'enUS','Mekkatorque-Ray!','',26124),
(42833,'enUS','Mekkatorque-Missiles!','',26124),
(42834,'enUS','Mekkatorque-Beam!','',26124),
(42835,'enUS','Who left this here, mon?  Whooaahh...','Who left this here, mon?  Whooaahh...',26124),
(42836,'enUS','Must... regain... balance... mon...','Must... regain... balance... mon...',26124),
(42837,'enUS','Uh oh...','Uh oh...',26124),
(42838,'enUS','Ouch, mon!  I be trippin\'!','Ouch, mon!  I be trippin\'!',26124),
(42839,'enUS','Aaaaahhh!','Aaaaahhh!',26124),
(42840,'enUS','Where you goin\', little one?','',26124),
(42841,'enUS','You tryin\' to escape from Zul\'Gurub?','',26124),
(42842,'enUS','Ain\'t NO ONE gonna escape Zul\'Gurub!  Not with Jin\'do in charge!','',26124),
(42843,'enUS','You\'re lucky I don\'t kill ya right now... but I got bigger plans for ya.','',26124),
(42844,'enUS','Ya see... to summon Hakkar, I need Mandokir.  And Mandokir, he needs you.','',26124),
(42845,'enUS','Hello, Ohgan\'aka.','',26124),
(42846,'enUS','Bloodlord, you gonna take better care of your possessions?','',26124),
(42847,'enUS','Oh yeah, Jin\'do.  We gonna take REAL good care of Ohgan\'aka.','',26124),
(42848,'enUS','I got a new cage built up, and we got plenty of ways to... teach her not to escape again.','',26124),
(42849,'enUS','Good, Good.  And you... yes, you... the meddling worm inside dat Mind Control spell.  Don\'t think Jin\'do can\'t see you.','',26124),
(42850,'enUS','Whenever you get the GUTS to come back here, you better be ready.  \'Cause Jin\'do\'s got a surprise for you...','',26124),
(42851,'enUS','Throm\'ka, friend!$B$BThe Warchief has ordered me to assemble his greatest veterans for an assault on the Twilight Highlands.$B$BYou look like one tough $c, but we need soldiers who are a bit more... battle-hardened. Perhaps someday you and I will fight side-by-side. Until then, continue your training!  ','',26124),
(42852,'enUS','Throm\'ka, friend! It is good to see a fellow veteran of the Northrend campaign.$B$BThe Warchief has ordered me to assemble his greatest warriors for an assault on the Twilight Highlands.$B$B<Warlord Krogg looks you up and down.>$B$BWe may need your help. Check in with the Warchief in Orgrimmar and see if he has a use for you yet.','',26124),
(42853,'enUS','|TInterface\\Icons\\inv_misc_net_01.blp:32|t$b$bUse the Eat Through Net ability to chew through Gurubashi nets!','|TInterface\\Icons\\inv_misc_net_01.blp:32|t$b$bUse the Eat Through Net ability to chew through Gurubashi nets!',26124),
(42854,'enUS','Steal food from sleeping Gurubashi Soldiers!','Steal food from sleeping Gurubashi Soldiers!',26124),
(42855,'enUS','|TInterface\\Icons\\spell_fire_fire.blp:32|t$b$bPick up Burning Twigs from braziers, then use Light Fire to burn down Zul\'Gurub Tikis!','|TInterface\\Icons\\spell_fire_fire.blp:32|t$b$bPick up Burning Twigs from braziers, then use Light Fire to burn down Zul\'Gurub Tikis!',26124),
(42856,'enUS','|TInterface\\Icons\\inv_misc_bone_orcskull_01.blp:32|t$b$bPick up Gurubashi Skulls from skullpiles, then drop them in troll paths!','|TInterface\\Icons\\inv_misc_bone_orcskull_01.blp:32|t$b$bPick up Gurubashi Skulls from skullpiles, then drop them in troll paths!',26124),
(42857,'enUS','A soldier could get into a lot of trouble in a town like this.$B$BA lot of trouble.','',26124),
(42858,'enUS','Thank you.$b$bIn return, I will teach you how to distract the trolls up ahead.','',26124),
(42859,'enUS','Da tiki!  Put it out!','Da tiki!  Put it out!',26124),
(42860,'enUS','It\'s a fire!  Hurry up mon!','It\'s a fire!  Hurry up mon!',26124),
(42861,'enUS','Someone been burnin\' my tiki!','Someone been burnin\' my tiki!',26124),
(42862,'enUS','Get over here, bruddas, quick!','Get over here, bruddas, quick!',26124),
(42863,'enUS','You wish to escape?  That is fine, but you must know some things first.$b$bStay away from the trolls.  They will not kill you, but they will trap you and bring you back here.$b$bSpeak with every raptor you see.  Not only can they teach you new abilities, but they will help you remember your progress and make your path out of Zul\'Gurub much easier.$b$bYou already have a Dash ability - use it to get out of tight spots.$b$bOh... and stay out of the water.$b$bGood luck!','',26124),
(42864,'enUS','|cFF768EBDFive years ago, in the heart of the Deadmines...|r |TInterface\\QuestFrame\\UI-QUESTLOG-BOOKICON.BLP:32|t','',26124),
(42865,'enUS','Yarrrr, yeh don\'t want none of what I be dealin\', $gSonny:missy;.$B$BBegone wit\' yeh!','',26124),
(42866,'enUS','Oh, ho! Oh ho ho.$B$BYo ho ho, even.$B$BThe flight to Twilight Highlands event is being worked on. In the meantime, I\'l take yeh there, lickety-split.$B$BDo yeh trust me, $c?','',26124),
(42867,'enUS','Yes, teleport me!','Yes, teleport me!',26124),
(42869,'enUS','Tha Darkspear are \'ere because I led dem here.  Orgrimmar be no home as long as it be under Hellscream\'s hand. ','',26124),
(42870,'enUS','Still, I fear I was lettin\' my temper drive me ta bein\' rash. Thrall devoted himself to makin\' the Horde what it is, so I\'ve no eagerness to be leavin\' it on a whim.  Dis will be needin\' much more thought.','',26124),
(42871,'enUS','Vol\'jin.  It\'s good to see you, brother.','',26124),
(42872,'enUS','One last favor from old Zuni.','',26124),
(42873,'enUS','Ya gonna go on to great ting\'s. Don\'t forget me, mon.','',26124),
(42876,'enUS','Orc KILL $r!','Orc KILL $r!',26124),
(42877,'enUS','Beg for life!','Beg for life!',26124),
(42878,'enUS','Eat you!','Eat you!',26124),
(42879,'enUS','Blackrock take forest!','Blackrock take forest!',26124),
(42880,'enUS','The grapes were VERY TASTY!','The grapes were VERY TASTY!',26124),
(42881,'enUS','Give me all your gold!','Give me all your gold!',26124),
(42882,'enUS','No one here gets out alive!','No one here gets out alive!',26124),
(42883,'enUS','You\'re in the wrong place at the wrong time, $g pal:missy;!','You\'re in the wrong place at the wrong time, $g pal:missy;!',26124),
(42884,'enUS','Your money or your life!','Your money or your life!',26124),
(42885,'enUS','Fate has brought you to me!','Fate has brought you to me!',26124),
(42886,'enUS','She\'s not lying.  Nordrassil is in danger.  I must make haste and prepare for Hyjal\'s defense.','',26124),
(42887,'enUS','It will be up to you to use the Horn of the Ancients and stop Soggoth\'s return.','',26124),
(42888,'enUS','','Ah... Malfurion Stormrage.  I\'d hoped to keep you occupied for a little longer.  It was my goal to keep you away from Hyjal while my allies attacked.  It would seem I have succeeded.',26124),
(42889,'enUS','','I\'ve no need to fight you, for it appears I\'ve already won.  You cannot stop our attack on Darkshore and save Hyjal at the same time!',26124),
(42890,'enUS','You do not belong in this world, foul being!  Suffer the wrath of nature!','',26124),
(42891,'enUS','I will devour your souls, insolent mortals!','',26124),
(42892,'enUS','Send me to Orgrimmar.','Send me to Orgrimmar.',26124),
(42893,'enUS','We\'re done here. Mulgore will no longer suffer the hatred of the Grimtotem.','',26124),
(42894,'enUS','I will meet you again in Thunder Bluff.','',26124),
(42895,'enUS','<Learn to light fires from the elder raptor.>','<Learn to light fires from the elder raptor.>',26124),
(42896,'enUS','Is there something you need?','',26124),
(42897,'enUS','The blade cuts into the Mosh\'Ogg Bounty, forcing it open!','The blade cuts into the Mosh\'Ogg Bounty, forcing it open!',26124),
(42898,'enUS','%s skin','',26124),
(42899,'enUS','You stay back!  Da troll is mine!','',26124),
(42900,'enUS','Skullsplitter... is... forever... mon...','',26124),
(42901,'enUS','Zanzil is creating an army that will wash over all of Stranglethorn!  Bloodscalps, Skullsplitter, Gurubashi and Horde... all will serve Zanzil!','',26124),
(42902,'enUS','...where we\'ll commence to assistin\' the Horde in their little skirmish with them Alliance fellers.\n','',26124),
(42903,'enUS','You do not belong here!','',26124),
(42904,'enUS','Those who are not of the earth must be destroyed!','',26124),
(42905,'enUS','You do not belong in the realm of earth!','',26124),
(42906,'enUS','Uh oh...I\'m gonna...urp!','Uh oh...I\'m gonna...urp!',26124),
(42907,'enUS','Thanks so much for the cookies!','Thanks so much for the cookies!',26124),
(42908,'enUS','Yeah, thanks!','Yeah, thanks!',26124),
(42909,'enUS','See ya!','See ya!',26124),
(42910,'enUS','Welcome to Grom\'gol, $c.  Before we get off on the wrong foot, I\'ll have you know that I won\'t have slackers in my Base Camp.  I expect a healthy $r like you to pull your own weight around here.','',26124),
(42911,'enUS','Even in this remote corner of the world, know that Hellscream\'s eyes are upon you.','',26124),
(42912,'enUS','The trolls of Stranglethorn don\'t take too kindly to us Darkspear.  I\'m not afraid of no Bloodscalp or Skullsplitter, but still... Grom\'gol\'s high walls make me feel safe.','',26124),
(42913,'enUS','Maybe I wasn\'t as safe as I thought I was here in Grom\'gol.$b$bA troll\'s gotta watch his neck wherever he goes.','',26124),
(42914,'enUS','<The cauldron bubbles.>','',26124),
(42915,'enUS','My brother has spent years working on a cure for leper gnomes. Using his notes, I think I\'ve perfected a process for restoring gnomes who\'ve devolved to sludge.','',26124),
(42916,'enUS','','The cannoneer\'s hands are black with gunpowder.',26124),
(42917,'enUS','<The troll sings to himself and stares into the cauldron.  He appears to be injured.>','',26124),
(42918,'enUS','Let\'s give this a try. Goggles, everyone!','',26124),
(42919,'enUS','There\'s a lot of money out there in that jungle, $r.  Can you see it?$b$bNo, it doesn\'t look like gold or copper.  It looks like raptor hides, and mineral veins, and ancient troll artifacts.$b$bOK, maybe the mineral veins might look like gold or copper.$b$bBut still, you get my point, right?','',26124),
(42920,'enUS','The great Rastakhan sends his greetings to you, member of the Horde.','',26124),
(42921,'enUS','What... what happened to me?','',26124),
(42922,'enUS','Absolutely amazing! We\'ve done it!','',26124),
(42923,'enUS','Sure, he\'s a little small, even by gnome standards, but he\'s all there! The real question is, what will he remember?','',26124),
(42924,'enUS','Don\'t talk about me like I\'m not here! All I know is I\'m hungry and I need to get out of these hideous, smelly clothes!','',26124),
(42925,'enUS','Wait, come back! I have readings to take!','',26124),
(42926,'enUS','You need to see a medic!','',26124),
(42927,'enUS','','What have we here, $n?',26124),
(42928,'enUS','We are going to the Temple of Earth, yes?','',26124),
(42929,'enUS','Take me to this Earthen Ring friend of yours. I have important news for the two of you.','',26124),
(42930,'enUS','The Captain\'s Log lies nearby.','',26124),
(42931,'enUS','The only thing that matters is that we rescue my father.','',26124),
(42932,'enUS','You must drop everything that you\'re doing to help me free my father, our leader the Stonefather.','',26124),
(42933,'enUS','We must hurry and speak with your Earthen Ring friend.','',26124),
(42934,'enUS','I was on my way to the temple when I was jumped. My father must be rescued before the stone troggs kill him.','',26124),
(42935,'enUS','The war between the Earthen and the stone troggs has raged for time beyond measure. But now in the chaos, the Stonefather, prisoner. They are threatening to kill him if we do not surrender.','',26124),
(42936,'enUS','You would be wise not to waste time. If my father dies, he takes with him the knowledge of where the middle fragment of the World Pillar is hidden. I know that you people want it.','',26124),
(42937,'enUS','Earthcaller, my father, Stonefather Oremantle, has been taken prisoner by the stone troggs of Needlerock Spire.','',26124),
(42938,'enUS','I demand that you send aid to Stonehearth. Help us with our war and to free Stonefather Oremantle.','',26124),
(42939,'enUS','This one that assisted me should be adequate. Have them report to our force commander, Crag Rockcrusher at Stonehearth.','',26124),
(42940,'enUS','You must fly up to Stonehearth, aid my people against the stone troggs, and free my father.$B$BI will meet you there shortly after speaking with the Earthcaller.$B$BDon\'t let him die, $n, or I will put you in the ground myself!','',26124),
(42941,'enUS','I am ready to meet with your so-called Earthcaller.','',26124),
(42942,'enUS','The shell\'s markings read: \"STORMWIND ROYAL INDUSTRIES\"','',26124),
(42943,'enUS','You ever been to the jungle, $r?$b$bIt\'s real nice.','',26124),
(42944,'enUS','Stranglethorn, $g man: babe;.  That\'s where it\'s AT!','',26124),
(42945,'enUS','Hi.','',26124),
(42946,'enUS','Ah, to be back in Stranglethorn.  The screeching raptors, the troll wars, jungle creatures as far as the eye see, just ASKING to be killed...$b$b<Bort sighs.>','',26124),
(42947,'enUS','Time to put the finishing touches on my bot.','',26124),
(42948,'enUS','At last, it\'s finished.','',26124),
(42949,'enUS','Arise my, uh... what shall I call you? How about \'multi-bot\'? Arise, my multi-bot!','',26124),
(42950,'enUS','Uh... a couple more tweaks should do it, I think...','',26124),
(42951,'enUS','I don\'t suppose you brought another squad with you, did you? We\'ve got our hands full out here.','',26124),
(42958,'enUS','Inbound $r!','Inbound $r!',26124),
(42959,'enUS','Incoming $r!','Incoming $r!',26124),
(42960,'enUS','We\'ve got another $r flying in!','We\'ve got another $r flying in!',26124),
(42961,'enUS','$R inbound!','$R inbound!',26124),
(42962,'enUS','Welcome to Redridge, $c!','Welcome to Redridge, $c!',26124),
(42963,'enUS','Be on your guard, $c.','Be on your guard, $c.',26124),
(42964,'enUS','Stay alert, $c.','Stay alert, $c.',26124),
(42965,'enUS','We got another $c inbound!','We got another $c inbound!',26124),
(42971,'enUS','Among the Twilight cult are magics that threaten us greatly.$B$BWe have every desire to wipe their existence from our home.$B$BWe are divided, and so we cannot.$B$BAnd so I watch...$B$BAnd wait...','',26124),
(42982,'enUS','Another rockworm is upon us! Kill it quickly!','',26124),
(42983,'enUS','We are under attack! To arms!','',26124),
(42984,'enUS','Another rockworm in the encampment! Send for the drakes!','',26124),
(42985,'enUS','By the elements, this one is even bigger than the last!','',26124),
(42986,'enUS','Outgoing, $c.','Outgoing, $c.',26124),
(42987,'enUS','Good hunting, $n!','Good hunting, $n!',26124),
(42988,'enUS','$R departing Redridge!','$R departing Redridge!',26124),
(42989,'enUS','$C departing Redridge!','$C departing Redridge!',26124),
(42990,'enUS','Good luck out there, $n!','Good luck out there, $n!',26124),
(42991,'enUS','The Earthen Ring shall fall!','The Earthen Ring shall fall!',26124),
(42992,'enUS','Deepholm shall collapse upon you!','Deepholm shall collapse upon you!',26124),
(42993,'enUS','You face the glorious wrath of the Twilight!','You face the glorious wrath of the Twilight!',26124),
(42994,'enUS','Deathwing\'s shadow settles over you.','Deathwing\'s shadow settles over you.',26124),
(42995,'enUS','Therazane\'s doom is assured!','Therazane\'s doom is assured!',26124),
(42996,'enUS','Your world is broken! Soon, you shall join it in death!','Your world is broken! Soon, you shall join it in death!',26124),
(42997,'enUS','There is no hope for enemies of the Twilight!','There is no hope for enemies of the Twilight!',26124),
(42998,'enUS','Dusk approaches! Tremble in fear!','Dusk approaches! Tremble in fear!',26124),
(42999,'enUS','Razlo Crushcog is no more! The people of Ironforge and Gnomeregan speak with one voice this day. Hear us well, Thermaplugg. The day of your defeat approaches!','',26124),
(43022,'enUS','Better make that a rocket scientist.','',26124),
(43037,'enUS','Strange... Just yesterday, I was dispatched to Ashenvale. ','',26124),
(43038,'enUS','Halfway there I got orders to meet you all here. This must be important.','',26124),
(43039,'enUS','Have you not heard?','',26124),
(43040,'enUS','An island has emerged from the depths... just off the coast of Stormwind.','',26124),
(43041,'enUS','We\'re gunna take it.','',26124),
(43042,'enUS','And once we do, Stormwind\'s days are numbered.','',26124),
(43043,'enUS','An island rose up from the sea... within striking distance of Stormwind? ','',26124),
(43044,'enUS','Take me to Revantusk Village.','Take me to Revantusk Village.',26124),
(43045,'enUS','This is no coincidence! Azeroth herself has cast her lot with the Horde!','',26124),
(43046,'enUS','','',26124),
(43047,'enUS','','',26124),
(43049,'enUS','Here, warrior. Eat this.','',26124),
(43050,'enUS','Your reflexes will quicken, and your stamina will increase.','',26124),
(43051,'enUS','Hah! I don\'t need your crutches, friend. ','',26124),
(43052,'enUS','I\'ve faced the best that Stormwind has to offer, and still I stand.','',26124),
(43053,'enUS','My axe has split as many Alliance skulls as yours, brother. Maybe more.','',26124),
(43054,'enUS','Hellscream will settle for nothing short of total victory. ','',26124),
(43055,'enUS','Should we fail, he\'ll chase us into the afterlife to take his retribution.','',26124),
(43056,'enUS','There is wisdom in your words, brother. I\'ll take that food of yours...','',26124),
(43058,'enUS','Indeed, brother. It would seem so...','',26124),
(43076,'enUS','Best of luck, $n!','Best of luck, $n!',26124),
(43080,'enUS','Aye, as will I.','',26124),
(43081,'enUS','We are Hellscream\'s Vanguard!','',26124),
(43082,'enUS','Why must we ride to battle in some pathetic mercenary vessel?','',26124),
(43083,'enUS','The rest of the fleet has already been sent to the region.','',26124),
(43084,'enUS','...their return is long overdue.','',26124),
(43085,'enUS','Hah! They should\'ve known to send us in the first place.','',26124),
(43086,'enUS','Agreed, brother, but the Horde fights many fires these days and the Vanguard are few in number...','',26124),
(43087,'enUS','Fortunately for our enemies, we can be in only one place at a time.','',26124),
(43088,'enUS','','Prepare for war! We will no longer tolerate the Vilebranch!',26124),
(43089,'enUS','Enough jawing! There\'s our ride.','',26124),
(43090,'enUS','That ship\'s been commissioned by Hellscream himself.','',26124),
(43091,'enUS','You\'re all under strict orders - No harassing her crew!','',26124),
(43092,'enUS','We must put an end to the corruption permeating Ashenvale.','',26124),
(43093,'enUS','Gah... this ship reeks of human.','',26124),
(43094,'enUS','Hah! Humans...','',26124),
(43095,'enUS','Hear my words, brothers!','',26124),
(43096,'enUS','We sail to a virgin island, a gift from Azeroth to the Horde!','',26124),
(43097,'enUS','Securing this land will win us our war!','',26124),
(43098,'enUS','The enemy has fought well, for Alliance...but they grow weary.','',26124),
(43099,'enUS','We shall crush what remains of them and lay claim to this land.','',26124),
(43100,'enUS','From its shores, we shall conquer Stormwind, and with it any hope the enemy clings to.','',26124),
(43101,'enUS','Azeroth will be reforged under a single banner!','',26124),
(43102,'enUS','This banner!!','',26124),
(43103,'enUS','We can\'t afford to let our enemy, Thermaplugg, continue to tighten his grip on the rest of Gnomeregan.','',26124),
(43104,'enUS','He has ordered his crony, Razlo Crushcog, to keep us on the defensive. Hinkles, what\'s the latest intelligence on Razlo and his men?','',26124),
(43105,'enUS','It\'s been hard for our scouts to get information on what Crushcog is planning.','',26124),
(43106,'enUS','Come aboard, now. Step on up!\n','',26124),
(43107,'enUS','Cap\'n Samir is navigatin\' this here ship non-stop to that there ocean over yonder...\n','',26124),
(43108,'enUS','...where we\'ll commence to assistin\' the Horde in their little skirmish with them Alliance fellers.\n','',26124),
(43109,'enUS','Easy money! Commission\'s to be dispersed evenly among any and all survivors!\n','',26124),
(43110,'enUS','What we do know is that Crushcog is using an advanced mechano-tank prototype and his irradiated gnomes are trying to repair more at the old arsenal.','',26124),
(43111,'enUS','','We\'re going to have a hard time handling this one alone. I sent a message to the dwarven capital of Ironforge asking for their support.',26124),
(43112,'enUS','And if you\'ll look to your left, you\'ll see that the gnomes have retaken Gnomeregan.  Hooray for us!','',26124),
(43113,'enUS','There\'s plenty else going on out here, too.  We\'ve opened up the path to the airport, there\'s rumors of Dark Irons in the east... oh, and I think something weird is going on with that dwarf king, Magni.  Might want to check it out.','',26124),
(43114,'enUS','What is the meaning of this!?','',26124),
(43115,'enUS','And here we are!  Welcome to Kharanos!  Watch your step on the way out.','',26124),
(43116,'enUS','We have a battle to win!','',26124),
(43117,'enUS','','A messenger reached us from Brewnall Village this morning. The dwarves are sending a squad of mountaineers to help us.',26124),
(43118,'enUS','We have to be in position to strike against Crushcog when the mountaineers arrive.','',26124),
(43119,'enUS','With Crushcog defeated, Thermaplugg is sure to be quaking in his mechano-tank, and rightly so. You\'re next, Thermaplugg. You\'re next!','',26124),
(43120,'enUS','','Ready for a tussle, $Glad:lass;?',26124),
(43121,'enUS','','Meddlesome gnats! You think us defeated so easily?',26124),
(43122,'enUS','Stand your ground, brothers! Make it bleed!','',26124),
(43123,'enUS','Deepholm was a slow, quiet place. Always alive. Steadily moving. Never rushed. In this time, I strived to become one with the earth, and to a large degree, I succeeded.$B$BLater, the Earthwarder returned, injured. He did not upset the balance at first. He\'d stayed here before, and we knew of him. The shift did not truly begin until the Twilight cult joined him.','',26124),
(43124,'enUS','When the Earthwarder began to recover, he became ill content with the quiet. With the peace. It was not long before he turned the stone dragons upon us.$B$BWith Deathwing gone, they are without purpose again. We can remind them of our strength. Bring them back to the Earthmother.','',26124),
(43125,'enUS','And so I see that you have appealed to Diamant. I have been bidden to abide your passing, fleshling. But that shall be the extent of the welcome you shall receive from me.$B$BDo not forget our first conversation. My trust for you is shallow. You have much to prove.$B$BYou would do best to leave. I grow tired of being wary of where my feet fall.','',26124),
(43126,'enUS','Step aboard, friends! Carefully now...','',26124),
(43127,'enUS','There ya go, all aboard. That\'s right...','',26124),
(43128,'enUS','And please. Pay no heed to the... uhh... diversity of our crew.','',26124),
(43129,'enUS','Rest assured, they\'ll deliver ya safely to yer destination.','',26124),
(43130,'enUS','That being the fresh piece of land just off the coast of the Eastern Kingdoms.','',26124),
(43131,'enUS','Alright then. Make ready everyone... here we go!','',26124),
(43132,'enUS','You hear the sound of shuffling stones behind you.','',26124),
(43133,'enUS','Pebble bounces up and down happily.','',26124),
(43134,'enUS','Pebble shuffles around happily.','',26124),
(43135,'enUS','Pebble races in circles, clearly happy.','',26124),
(43136,'enUS','Pebble shuffles up against your leg happily.','',26124),
(43137,'enUS','Pebble slumps down sadly.','',26124),
(43138,'enUS','Pebble turns away sadly.','',26124),
(43139,'enUS','Pebble looks up at you hopefully.','',26124),
(43140,'enUS','Your hear the Pebble\'s stones jittering about inside of him. He\'s clearly excited about something.','',26124),
(43141,'enUS','Pebbles stones burst apart onto the ground, then slowly reform into a full fledged, happy Pebble.','',26124),
(43142,'enUS','Pebble sees the crystals ahead and excitedly rushes towards them!','',26124),
(43143,'enUS','Hold your ground!','',26124),
(43144,'enUS','Put those stone troggs back into the earth!','',26124),
(43145,'enUS','We have reinforcements! For the Stonefather!','',26124),
(43146,'enUS','Do you want to live forever?','',26124),
(43147,'enUS','Shore up those flanks!','',26124),
(43148,'enUS','This Is Stonehearth!','',26124),
(43149,'enUS','By Khaz\'goroth\'s hammer, we will break them!','',26124),
(43150,'enUS','For Stonefather Oremantle!','',26124),
(43151,'enUS','I can\'t do this while they\'re attacking me!','',26124),
(43152,'enUS','Get these stone troggs off of me so that I can summon the rockslide!','',26124),
(43153,'enUS','I can\'t perform the ritual while they\'re beating on me!','',26124),
(43154,'enUS','A little help here first, $c?','',26124),
(43155,'enUS','Give me the reagents again when these stone troggs are dead.','',26124),
(43156,'enUS','Keep them from hitting me and I\'ll seal the hatch!','',26124),
(43157,'enUS','I don\'t know how they found a way up from underneath, but I can\'t seal the hatch until they\'re off of me!','',26124),
(43158,'enUS','We have to deal with these stone troggs first. Then hand me the reagents.','',26124),
(43159,'enUS','Pebble bobbles around appreciatively.','',26124),
(43160,'enUS','For the Stonefather!','',26124),
(43161,'enUS','For Stonefather Oremantle!','',26124),
(43162,'enUS','For Stonehearth!','',26124),
(43163,'enUS','Kill the stone troggs!','',26124),
(43164,'enUS','Hail, citizen. I would recommend that you speak with Watch Captain Parker. He\'s currently at the top of this tower.','',26124),
(43165,'enUS','Pebble\'s excitement has drawn the attention nearby rock flayers!','',26124),
(43166,'enUS','','All right, sunshine.  Time to spill your guts before I spill \'em for ya!',26124),
(43167,'enUS','Wait!  You can\'t do this!  You people must have a code of honor or something!','',26124),
(43168,'enUS','','I\'m a daughter of the Wildhammer Clan and a shaman of the Earthen Ring.  My code compels me to honor my ancestors and the elements.',26124),
(43169,'enUS','','Doesn\'t say a damn thing about dog-ugly ogres.',26124),
(43170,'enUS','','You can start by telling us where the World Pillar fragment is.  My gryphon\'s starting to look a bit tired from hauling you around.',26124),
(43171,'enUS','Stop it, you tiny, angry woman!  I\'ll tell you everything!  What do you want to know?','',26124),
(43172,'enUS','It was delivered to the forgemaster at Deathwing\'s Fall.  I swear... that\'s all I know!','',26124),
(43173,'enUS','Somebody... please... get... rock... off... me...','',26124),
(43174,'enUS','Hurts... Hurts so bad...','',26124),
(43175,'enUS','Please... kill... me...','',26124),
(43176,'enUS','I... just... wanted... to... build... the... damned... bridge...','',26124),
(43177,'enUS','','You were never in any danger, sweetheart.  My friends down below would\'ve caught you.  You\'re worth too much to us alive!',26124),
(43178,'enUS','Happy now?  Pull me up, you vicious little dwarf!','',26124),
(43179,'enUS','What? What have you done?  No!  Do you have any idea what the Twilight Council will do to me when they find out I\'ve talked!?  I would sooner die!','',26124),
(43180,'enUS','','Interesting.  I\'d never heard of the Twilight Council until now.',26124),
(43181,'enUS','PUT YOUR BACKS INTO IT, BOYS!','',26124),
(43182,'enUS','HEAVE!','',26124),
(43183,'enUS','HO!','',26124),
(43184,'enUS','DAMN ROCK WON\'T BUDGE!','',26124),
(43185,'enUS','PUSH HARDER!','',26124),
(43186,'enUS','I\'M PUSHIN\' AS HARD AS I CAN! THING WEIGHS A TON!','',26124),
(43187,'enUS','We\'ll get you out of there, Foreman, just HANG ON!','',26124),
(43188,'enUS','Going ashore, $n?$B$BSay the word and I\'ll lower a boat for you.','',26124),
(43189,'enUS','Send me ashore, Horzog.','Send me ashore, Horzog.',26124),
(43190,'enUS','Well, it\'s not good. The battle has taken its toll on both your steam tanks. My salvage teams will secure what\'s left of them as soon as it\'s safe.','',26124),
(43191,'enUS','With an ample supply of gyromechanic gears, and a team of engineers, your tanks can make a full recovery, but it\'s going to be a long journey.','',26124),
(43192,'enUS','Poor, poor Trollplow. At least the old gal went out doin\' something she loved.','',26124),
(43193,'enUS','Pull yerself togther, Stone! You\'re a steam tank pilot, for Light\'s sake!','',26124),
(43194,'enUS','How dare they take our king prisoner!$B$BWe will take back Stonehearth and then move through the front to crush the stone troggs in their home!','',26124),
(43195,'enUS','Horzog orders a landing boat to be lowered into the water. ','',26124),
(43196,'enUS','','',26124),
(43197,'enUS','Let\'s get out there and put those stone troggs back into the ground, $r!','',26124),
(43198,'enUS','Razzle, tell him everything\'s going to be fine!','',26124),
(43199,'enUS','I need you out on the front, $n.$B$BYou\'re going to make the difference. We\'ll crush the stone troggs once and for all.$B$BWe must rescue King Oremantle!','',26124),
(43200,'enUS','Yes, yes, everything will be fine! Wonderful, in fact. She\'ll be better than ever!','',26124),
(43201,'enUS','<Clay grumbles and sneers.>$B$BDamn kids these days.','',26124),
(43202,'enUS','In fact, I\'ll go see about those gears right now!','',26124),
(43203,'enUS','There, see? Ol\' Trollplow\'ll be better in no time! Before you know it, you\'ll be bragging about out-gunning me again...','',26124),
(43204,'enUS','C\'mon, let\'s get you another ale.','',26124),
(43206,'enUS','By the time the ritual is complete, Marnal will arrive, and my men will help carve up this grotesque creature.','',26124),
(43207,'enUS','Imagine the most amazing elevator you have ever seen... right here. Yea, its sweet isn\'t it? Sadly, its not ready yet.','',26124),
(43208,'enUS','Just teleport me for now. But I can\'t wait for that sweet sweet elevator!','Just teleport me for now. But I can\'t wait for that sweet sweet elevator!',26124),
(43209,'enUS','Patience... our turn will come.','',26124),
(43210,'enUS','<The murloc looks at you with thirsty eyes.>','',26124),
(43211,'enUS','<Offer the murloc a drink.>','<Offer the murloc a drink.>',26124),
(43212,'enUS','$R come to look at Orgus?  Take picture, last longer.','',26124),
(43213,'enUS','<Offer the ogre a drink.>','<Offer the ogre a drink.>',26124),
(43214,'enUS','Yarr, thar be nary a soul s\'thirsty as me, says I.','',26124),
(43215,'enUS','<Offer the pirate a drink.>','<Offer the pirate a drink.>',26124),
(43216,'enUS','Deathwing\'s entry into our world opened a rift between it and Deepholm.$B$BRebuilding the World Pillar is the only way to stabilize the rift.','',26124),
(43217,'enUS','Negotiations aren\'t going well, $n. The Dragonmaw are not yet free orcs.$B$BSomehow, we MUST get them to join the Horde!$B$BLet me know if you need transport back to the fleet.','',26124),
(43218,'enUS','ROCK NOT SO HEAVY! PUNY HUMIES!','',26124),
(43219,'enUS','Can I get a ride back to the fleet?','Can I get a ride back to the fleet?',26124),
(43220,'enUS','Where trow? TROW ON BRIDGE??','',26124),
(43221,'enUS','Gmurgl starts to follow you.','',26124),
(43222,'enUS','OK! Me trow in water!','',26124),
(43223,'enUS','Ornak orders a boat to push off for the fleet.','',26124),
(43224,'enUS','Oh... Orgus not feel so good...','',26124),
(43225,'enUS','Orgus think something wrong with $r lemonade...','',26124),
(43226,'enUS','BYE, BYE, DADDY!','',26124),
(43227,'enUS','Well blow me down!  The landlubber scalawag comes bearin\' rum!','',26124),
(43228,'enUS','Yarr?','',26124),
(43229,'enUS','Shiver me timbers!','',26124),
(43230,'enUS','NO, NO, NO! Please!','',26124),
(43231,'enUS','NOOOOOO!!!','',26124),
(43232,'enUS','ANYWHERE BUT THE BRIDGE!','',26124),
(43233,'enUS','Where to, buddy?','Where to, buddy?',26124),
(43234,'enUS','See me if you need a boat to the shore, $n!','',26124),
(43235,'enUS','We\'re getting bogged down in the fight against the Frostmane trolls.','',26124),
(43236,'enUS','Most of our steam tanks are out of commission and we\'re losing mountaineers quickly.','',26124),
(43237,'enUS','Very well, Zaela. I trust you to do the right thing. $C, I can help your fallen warriors...','',26124),
(43238,'enUS','I ... I can\'t give you any of our supplies! Our Warchief... He would...','',26124),
(43239,'enUS','','Gregor, you coward! Orcs of pure blood are dying off our shores. If you doom them, you doom us all.',26124),
(43240,'enUS','Welcome to the Orgrimmar Rocketway Exchange! You still look to be in one piece.','Welcome to the Orgrimmar Rocketway Exchange! You still look to be in one piece.',26124),
(43241,'enUS','','$n, know that our \"Warchief\" does not speak for us all. There are those among us who hope to see the Dragonmaw great again... and free from corruption.',26124),
(43242,'enUS','','It won\'t be long before we\'re out of supplies too, Captain. Between the trolls and the yeti raids, we\'ll be down to half rations within a week.',26124),
(43243,'enUS','We can\'t keep up the operation much longer. Delber and his team must launch their attack from Steelgrill\'s Depot as soon as possible!','',26124),
(43244,'enUS','Not so fast, wet guy!','Not so fast, wet guy!',26124),
(43245,'enUS','Delber and his men are working overtime, captain. He has devised a means of delivering an assault team to the rear flank of the battle.','Delber and his men are working overtime, captain. He has devised a means of delivering an assault team to the rear flank of the battle.',26124),
(43246,'enUS','Orgrimmar Rocketway Exchange, please.','Orgrimmar Rocketway Exchange, please.',26124),
(43247,'enUS','Zombie pirates?!  Kill it!','Zombie pirates?!  Kill it!',26124),
(43248,'enUS','We\'ve also secured air support for the operation and will be ready to deploy soon. If any of your men want to join the assault team, just send them to Delber.','We\'ve also secured air support for the operation and will be ready to deploy soon. If any of your men want to join the assault team, just send them to Delber.',26124),
(43249,'enUS','Southern Rocketway Terminus, please.','Southern Rocketway Terminus, please.',26124),
(43250,'enUS','Gallywix Rocketway Exchange, please.','Gallywix Rocketway Exchange, please.',26124),
(43251,'enUS','Northern Rocketway Exchange, please.','Northern Rocketway Exchange, please.',26124),
(43252,'enUS','Northern Rocketway Terminus, please.','Northern Rocketway Terminus, please.',26124),
(43253,'enUS','Glad to hear it. I\'ll send Delber any forces I can spare.','Glad to hear it. I\'ll send Delber any forces I can spare.',26124),
(43254,'enUS','We Dragonmaw have seen so much suffering... our defeat at Grim Batol... the loss of so many great warriors in Outland... and now incursions from Twilight\'s Hammer.$B$BI sometimes wonder if we will ever be great again. But younglings like Zaela, they give this old heap of bones some hope.','',26124),
(43255,'enUS','What is it you need, outsider? I shouldn\'t be speaking with you...','',26124),
(43256,'enUS','Our warriors are dying. Do you have medical supplies I can take back with me?','Our warriors are dying. Do you have medical supplies I can take back with me?',26124),
(43257,'enUS','Welcome to the Gallywix Rocketway Exchange! Debts to pay or get the heck away.','Welcome to the Gallywix Rocketway Exchange! Debts to pay or get the heck away.',26124),
(43258,'enUS','Welcome to the Northern Rocketway Exchange! We at Rocketway Relations are glad you survived that last turn!','Welcome to the Northern Rocketway Exchange! We at Rocketway Relations are glad you survived that last turn!',26124),
(43259,'enUS','Welcome to the Northern Rocketway Terminus! You probably took a wrong turn, but we\'re happy to have you anyway!','Welcome to the Northern Rocketway Terminus! You probably took a wrong turn, but we\'re happy to have you anyway!',26124),
(43260,'enUS','Welcome to the Southern Rocketway Terminus! Home of the world famous Secret Lab!','Welcome to the Southern Rocketway Terminus! Home of the world famous Secret Lab!',26124),
(43261,'enUS','This ancient totem is fashioned into the shape of a bat.','',26124),
(43262,'enUS','We\'re finished! I might as well call for an evacuation now and clear out Lakeshire before the orcs march.','',26124),
(43263,'enUS','And right when we finally finished building that damned bridge! What hope is there, $n?','',26124),
(43264,'enUS','There is hope, Solomon.','',26124),
(43265,'enUS','What hope, colonel? What could possibly save us from the impending assault?','',26124),
(43266,'enUS','He served 248 consecutive tours of duty across the First, Second and Third Wars.','',26124),
(43267,'enUS','Captured five years ago by a battalion of filthy, pig sucking Blackrocks, five clicks out from the southern DMZ.','',26124),
(43268,'enUS','Tortured and kept alive as a urinal for young orc warriors. For FIVE YEARS.','',26124),
(43269,'enUS','JOHN J. KEESHAN.','',26124),
(43270,'enUS','Keeshan\'s alive? I thought he died.','',26124),
(43271,'enUS','He\'s alive alright, and been living like an outcast in Lakeshire for the past five months. Or hadn\'t you noticed? Now enough chatter. We\'ve got people to save!','',26124),
(43272,'enUS','I misplaced my Negotiator. In fact, he\'s probably dead. Is another available?','I misplaced my Negotiator. In fact, he\'s probably dead. Is another available?',26124),
(43273,'enUS','I\'m sick of sittin\' in this hole. I hope whatever sorry pencil-pusher is holdin\' up Danath\'s return gets a punch in the jimmies.','',26124),
(43274,'enUS','Hey, does this red shirt make me look expendable?','',26124),
(43275,'enUS','I am ready, $n. Soon the Dragonmaw will join the Horde!','',26124),
(43276,'enUS','I hear a great Dragonmaw medicine man lives here, in the large hut to our right.','',26124),
(43277,'enUS','This ancient totem is fashioned into the shape of a bat.  It must be the totem that Chabal spoke of.','',26124),
(43278,'enUS','Place the incense at the foot of the statue.','Place the incense at the foot of the statue.',26124),
(43279,'enUS','After these negotiations, I am looking forward to a long and prosperous life.','',26124),
(43280,'enUS','The Dragonmaw Warchief is in the largest building up on the hilltop here. I\'m sure he\'ll be reasonable.','',26124),
(43281,'enUS','This is it! Stay close and let me do the talking. I\'m an expert.','',26124),
(43282,'enUS','Welcome to Aerie Peak, home of the Wildhammer Clan.$B$BWith High Thane Falstad off in Ironforge, you\'ll be dealin\' with me.','',26124),
(43283,'enUS','The battle begins in 1 minute.','',26124),
(43284,'enUS','The battle begins in 30 seconds.  Prepare yourselves!','',26124),
(43285,'enUS','The spirits o\' this land won\'t tolerate this dark magic and vicious sacrifice any longer.$B$BThe Vilebranch have got to go!','',26124),
(43286,'enUS','Ya head\'s gonna make a nice bag!','',26124),
(43287,'enUS','Let\'s get this over with. I\'d rather be back home at Aerie Peak than starin\' down these ugly trolls.','',26124),
(43288,'enUS','You thought those long arms gave you an advantage, $r? Think again!','',26124),
(43289,'enUS','Leave Ongo\'longo ALONE!','',26124),
(43290,'enUS','Let\'s not waste time! There\'s undead afoot.','',26124),
(43291,'enUS','Hold it now. Let\'s not rush in.','',26124),
(43292,'enUS','I\'ve had enough of this!  Time to take a break...','',26124),
(43293,'enUS','Zanzil\'s back!','',26124),
(43294,'enUS','If I ever get out of here I\'m gonna crap all over your head, you pig sucking orc.','',26124),
(43295,'enUS','Where\'s the rest of my crew??!','',26124),
(43296,'enUS','You think these bars can hold me? HAH!','',26124),
(43297,'enUS','','High Priestess Jeklik is nearly healed!',26124),
(43298,'enUS','Most esteemed Warchief -','',26124),
(43299,'enUS','Warchief, you misunderstand. Garrosh Hellscream will have a beach head on these shores, with or without your help. What we ask -','',26124),
(43300,'enUS','What\'re you doin\' here?  Don\' matter, I\'m gonna resurrect Jeklik before you get a chance to interfere!','',26124),
(43301,'enUS','But the Horde has assembled an enormous host! A vast fleet of war machines and hardened veterans. Hellscream would as soon crush you as-','',26124),
(43302,'enUS','This is madness!','',26124),
(43303,'enUS','','I LIVE!',26124),
(43304,'enUS','Uh oh... Jin\'do\'s not gonna be happy about this...','',26124),
(43305,'enUS','Time to get out of here!','',26124),
(43306,'enUS','Quit wasting words, worm. If you want the aid of the Dragonmaw, you should\'ve come on bent knee and with offerings of gold.','',26124),
(43307,'enUS','Was that a THREAT? I knew Hellscream in Outland. A whimpering whelp. He is no Warchief.','',26124),
(43308,'enUS','Bring him on!','',26124),
(43309,'enUS','This is...','',26124),
(43310,'enUS','DRAGONMAW!!','',26124),
(43311,'enUS','Keep the $c alive. $gHe:She; will be our bargaining chip.','',26124),
(43312,'enUS','Call for the others. We will crush Hellscream\'s Horde and hurl their bodies to the sea...','',26124),
(43313,'enUS','Keeping the bomb warm, obviously. What does it look like I\'m doing?!','',26124),
(43314,'enUS','What are you doing just sitting there?!','',26124),
(43315,'enUS','High Priest Venoxis is nearly healed!','',26124),
(43316,'enUS','Take me to the battle at the Ruins of Feathermoon.','Take me to the battle at the Ruins of Feathermoon.',26124),
(43318,'enUS','Will you do whatever it takes to save your kingdom?','',26124),
(43319,'enUS','I must return to Feathermoon Stronghold!','I must return to Feathermoon Stronghold!',26124),
(43320,'enUS','You\'re back for more, huh?  Too bad, because I\'ve got a stronger potion mixed up this time!  Venoxis will live!','',26124),
(43321,'enUS','I can\'t take much more of this...','',26124),
(43322,'enUS','Here comes Zanzil!','',26124),
(43323,'enUS','Ahahaha!  Zanzil is the winner this time!  And look who came to celebrate!','',26124),
(43324,'enUS','Nooo!  Zanzil is a failure...','',26124),
(43326,'enUS','','The Kvaldir have been purged from the city. Now we can begin our preparations.',26124),
(43327,'enUS','','Battlemaiden, I have a task that requires your attention.',26124),
(43328,'enUS','','Battlemaiden! You are needed on the battlefield. The Kvaldir have broken through our lines!',26124),
(43329,'enUS','Welcome!','Welcome!',26124),
(43330,'enUS','Greetings, $c.','Greetings, $c.',26124),
(43331,'enUS','','Stand fast! The ritual is almost complete.',26124),
(43332,'enUS','','Cut them down, Battlemaiden!',26124),
(43333,'enUS','Greetings! Please have a look around.','Greetings! Please have a look around.',26124),
(43334,'enUS','','Hold them back! Keep them away from the temple!',26124),
(43335,'enUS','Let me know if you need help finding anything, $c.','Let me know if you need help finding anything, $c.',26124),
(43336,'enUS','Welcome. May I help you find something?','Welcome. May I help you find something?',26124),
(43337,'enUS','Greetings.','Greetings.',26124),
(43338,'enUS','Welcome.','Welcome.',26124),
(43339,'enUS','Welcome!','Welcome!',26124),
(43340,'enUS','Greetings, $c.','Greetings, $c.',26124),
(43341,'enUS','Greetings! Please have a look around.','Greetings! Please have a look around.',26124),
(43342,'enUS','Let me know if you need help finding anything, $c.','Let me know if you need help finding anything, $c.',26124),
(43343,'enUS','Welcome. May I help you find something?','Welcome. May I help you find something?',26124),
(43344,'enUS','Greetings.','Greetings.',26124),
(43345,'enUS','Welcome.','Welcome.',26124),
(43346,'enUS','Slaughter them all! Show no mercy, brothers!','',26124),
(43347,'enUS','The only peace you shall find is in death, Kvaldir!','',26124),
(43348,'enUS','Your march to your deaths! Azshara shall see you wiped from the seas!','',26124),
(43349,'enUS','You press on... to your deaths... fools.','',26124),
(43350,'enUS','Fools. Weaklings. ','',26124),
(43351,'enUS','You should have accepted your defeat.','',26124),
(43352,'enUS','Your return brings you only death.','',26124),
(43353,'enUS','Slavery and death are all that away you.','',26124),
(43354,'enUS','Kvaldir are pouring across the bridge! Battlemaiden, Lady Naz\'jar calls for you!','',26124),
(43355,'enUS','Back to the sands with you, wretch!','',26124),
(43356,'enUS','Kind of them to stream in one by one.','',26124),
(43357,'enUS','About as tough as seaweed too.','',26124),
(43358,'enUS','They must really like this city. Maybe it\'s the view?','',26124),
(43359,'enUS','The Gurubashi are dead, and Hakkar with them.  Most of my fellow Zandalar have returned to their homeland.$b$bIt falls on me, Maywiki, and the Darkspears of Bambala to watch over Zul\'Gurub now.','',26124),
(43360,'enUS','Chabal, I was hunting Zanzil and I lost track of what I was doing.  Can remind me where to go next?','Chabal, I was hunting Zanzil and I lost track of what I was doing.  Can remind me where to go next?',26124),
(43361,'enUS','','The Kvaldir have returned to take the city back from us, Battlemaiden. They will need you outside.',26124),
(43362,'enUS','Jin\'do the Hexxer!  It\'s been a while since I\'ve seen that mask.','',26124),
(43363,'enUS','What brings you out to my part of Stranglethorn?  I\'m not accustomed to taking visitors from the esteemed Zul\'Gurub.','',26124),
(43364,'enUS','You know well enough about why I\'m here, Zanzil.','',26124),
(43365,'enUS','The Gurubashi have fallen on hard times.  I live, and Mandokir has returned... but the rest of us are gone.','',26124),
(43366,'enUS','What a shame... but not a concern for an old exile like Zanzil.','',26124),
(43367,'enUS','Well, Zanzil, I\'d like to make it your concern.  I\'ve recovered the bodies of High Priestess Jeklik and High Priest Venoxis.','',26124),
(43368,'enUS','I remember what you can do with those elixirs of yours.  Can your elixirs help out an old friend?','',26124),
(43369,'enUS','Friend?  You were among those who spit and threw stones, Jin\'do.  But let\'s let bygones be bygones, eh?','',26124),
(43370,'enUS','So your bat and your snake need Zanzil\'s help?  Very well.  I\'ll see you inside Zul\'Gurub... old friend.','',26124),
(43371,'enUS','Kvaldir never die... this city is ours...','',26124),
(43372,'enUS','','There\'s more to this than we know, $n.  I can guarantee you that much.',26124),
(43373,'enUS','','Thank you.',26124),
(43374,'enUS','','Erunak, take a look at this. This looks like a sufficient focus for the vision magics I was speaking to you about.',26124),
(43375,'enUS','','I will prepare the enchantment right away then. This may finally shed some light on the means and intentions of the naga.',26124),
(43376,'enUS','Of course.  It\'s all yours.','',26124),
(43377,'enUS','I thought we\'d killed everybody... Mor\'norokk should be pleased with this!','',26124),
(43378,'enUS','Your race is a disease upon the sea.','',26124),
(43379,'enUS','Neptulon will rise and wash your kind from Azeroth.','',26124),
(43380,'enUS','Choke upon the sands of the Kvaldir!','',26124),
(43381,'enUS','You should have left this city to the waves.','',26124),
(43382,'enUS','What\'s goin\' on in here?','',26124),
(43383,'enUS','Zanzil!  Finish with Venoxis, then we\'ll talk about your failures.','',26124),
(43384,'enUS','Yes, Jin\'do.','',26124),
(43385,'enUS','And you.  You\'ve interfered with my plans for the last time.','',26124),
(43386,'enUS','Hakkar grows impatient.  And so do I.','',26124),
(43387,'enUS','You may have slain Jeklik, but you will not leave Zul\'Gurub alive.','',26124),
(43388,'enUS','Prepare to die!','',26124),
(43389,'enUS','','And if you\'ll look to your right, you\'ll see... my friend, about to get killed!',26124),
(43390,'enUS','','Quick!  Grab onto the ladder!',26124),
(43391,'enUS','Take her in slowly, number two.','',26124),
(43392,'enUS','Fire! Fire! Blow it out of the water!','',26124),
(43393,'enUS','Don\'t worry, number two. We\'ll get another chance. And we\'ll be ready.','',26124),
(43394,'enUS','We are approaching the cavern, Captain.','',26124),
(43395,'enUS','The reports were accurate! The beast is here...','',26124),
(43396,'enUS','Steady, number two...','',26124),
(43397,'enUS','The beast escaped! By Gallywix\'s gut, it was fast!','',26124),
(43398,'enUS','Take her in slowly, number two.','',26124),
(43399,'enUS','Steady, number two...','',26124),
(43400,'enUS','Fire! Fire! Blow it out of the water!','',26124),
(43401,'enUS','Don\'t worry, number two. We\'ll get another chance. And we\'ll be ready.','',26124),
(43402,'enUS','We are approaching the cavern, Captain.','',26124),
(43403,'enUS','The reports were accurate! The beast is here...','',26124),
(43404,'enUS','The beast escaped! By Mekkatorque\'s moustache, it was fast!','',26124),
(43405,'enUS','You orcs are gonna be sorry when I get out of here.','',26124),
(43406,'enUS','Payback\'s gonna hurt.','',26124),
(43407,'enUS','Haaadoouuuu....','',26124),
(43408,'enUS','... KEN!!','',26124),
(43409,'enUS','Zanzil teleports to another location!','',26124),
(43410,'enUS','','Welcome to Hardwrench Hideaway!$b$bLooking to get away from the hustle and bustle of city life?  You\'ve come to the right place!$b$bWant to witness the marvels of Azeroth\'s famous jungle firsthand?  Look no further!$b$bShopping for some freshly pumped bio-fuel or weapons-grade mineral ores?  Then you\'ve come to the right place, $c!',26124),
(43411,'enUS','','Hey, boss.',26124),
(43412,'enUS','How can I help you?  Here for some of our famous Lobstrok Thermidor?','',26124),
(43413,'enUS','Thank you, $r.','',26124),
(43414,'enUS','I think I can make it back on my own.','',26124),
(43415,'enUS','You\'re a strange-looking creature. Thank you.','',26124),
(43416,'enUS','What happened?','',26124),
(43417,'enUS','Kill a few for me, would you?','',26124),
(43418,'enUS','Don\'t worry about me. We have to rescue the king!','',26124),
(43419,'enUS','We can\'t leave these refugees like this, Kelaan. Buin here has sold his weapons and armor to buy food for them. He cannot do it alone.','',26124),
(43420,'enUS','You need to kill Troggzor the Earthinator!','',26124),
(43421,'enUS','I have to report back. Thank you, $c!','',26124),
(43422,'enUS','I am not blind to their suffering, Lowan, but our mission here is to learn about what the cataclysm has wrought. Azeroth itself is suffering.','',26124),
(43423,'enUS','I have sent to Light\'s Hope Chapel for a grant of gold for the care of the refugees. Carry out your mission, but help as you can.','',26124),
(43424,'enUS','Thank you, Father Gavin. The world needs more like you and Buin in these dark times.','',26124),
(43425,'enUS','So much senseless loss.','',26124),
(43426,'enUS','Fishing has always come naturally to my family.  You look like you could use a little help though.  How about running a few errands for a Master Angler?','',26124),
(43427,'enUS','Eat dirt you filthy mongrel!','',26124),
(43428,'enUS','Back to your maker!','',26124),
(43429,'enUS','No good piece of crap!','',26124),
(43430,'enUS','Nowhere to run!','',26124),
(43431,'enUS','You messed with the wrong soldier!','',26124),
(43432,'enUS','And keep the change you filthy animal!','',26124),
(43433,'enUS','I\'m just gettin\' warmed up!','',26124),
(43434,'enUS','Is that the best you can do?','',26124),
(43435,'enUS','I don\'t even have my gear on!','',26124),
(43436,'enUS','GET SOME!','',26124),
(43437,'enUS','And just like that, you\'re dead!','',26124),
(43438,'enUS','HAH!','',26124),
(43439,'enUS','I\'ve had tougher craps.','',26124),
(43440,'enUS','Welcome to hell!','',26124),
(43441,'enUS','Toe up...','',26124),
(43442,'enUS','Did you hear that crack?!','',26124),
(43443,'enUS','Revenge is a dish best served with a butt whompin\'!','',26124),
(43444,'enUS','Here\'s to you!  Here\'s to me!  May we never disagree.$b$bBut if we do... BLAST YOU!  Here\'s to me.','',26124),
(43445,'enUS','I hear you\'ve got some drinks I can buy, Slim.','I hear you\'ve got some drinks I can buy, Slim.',26124),
(43446,'enUS','%s belches.','',26124),
(43447,'enUS','This lifeboat appears to be abandoned.  Maybe it belongs to some of the nearby pirates?','',26124),
(43448,'enUS','This must be the lifeboat that Captain Hecklebury Smotts spoke about.','',26124),
(43449,'enUS','You take a moment to silently remember when you used this lifeboat to defeat Negolash.  Those were the good days.','',26124),
(43450,'enUS','<Place the food and drink inside the lifeboat.>','<Place the food and drink inside the lifeboat.>',26124),
(43451,'enUS','You know, I\'ve always wondered why they call themselves orcs.','',26124),
(43452,'enUS','It\'s an ugly word, you know? It\'s a word I\'d use to describe defecating. For example:','',26124),
(43453,'enUS','After that Pilgrim\'s Bounty dinner, I took a huge smelly orc.','',26124),
(43454,'enUS','We\'ve come to try to help, but it seems that their favor for you does not yet extend to us.','',26124),
(43455,'enUS','I really missed you, Danforth.','',26124),
(43456,'enUS','I remember this one time, Keeshan and I were out fishing at the Lakeshire bridge and Keeshan farted. Don\'t think Oslow ever forgave Keeshan for that one...','',26124),
(43457,'enUS','You know, Keeshan lost his wife to Blackrock orcs. He was never the same after that day. Was like the sun just set on his life. Darkness, $g man:lady;. Pure darkness.','',26124),
(43458,'enUS','They called us the Bravo Company. When things needed killin\', we did the spillin\'... of blood.','',26124),
(43459,'enUS','Messner is a master of fire magic. We invite him to all of our barbecues.','',26124),
(43460,'enUS','Jorgensen is real dainty, by the way. He\'s a paladin, so be careful what you say around him or you\'re liable to make him cry.','',26124),
(43461,'enUS','So I hear Varian Wrynn is back. That true? Sorry, I\'m a bit out of the loop.','',26124),
(43462,'enUS','You ever notice how sarcastic the people living in Redridge are? Sometimes I feel like I just want to take a blow torch to that jackass Solomon\'s town hall.','',26124),
(43463,'enUS','','Hurry, Gorthul. Undo $ghis:her; bonds.',26124),
(43464,'enUS','','$n, I\'ve rescued your equipment for you. I think you\'ve seen all you need to see.',26124),
(43465,'enUS','I feel weak. I mean weaker than normal. Like as if the Light is less powerful this week. Probably just something I ate. Orc food gives me the craps.','',26124),
(43466,'enUS','You ever seen Keeshan kill an orc? It\'s a sight to behold, $g man:lady;.','',26124),
(43467,'enUS','','Remember, $n. Not all Dragonmaw are your enemies!',26124),
(43468,'enUS','Can\'t believe we\'re putting the old team back together. All thanks to you, $n.','',26124),
(43469,'enUS','So I heard Thrall left the Horde. That true?','',26124),
(43470,'enUS','You know, I kept hearing the Blackrock orcs talk about the return of Hellscream to the Horde. What\'s that all about? Isn\'t Hellscream dead?','',26124),
(43471,'enUS','I\'m probably the most important member of this team, being a paladin and all.','',26124),
(43472,'enUS','Wait\'ll these orcs get a load of us. Bravo Company BACK IN BUSINESS!','',26124),
(43473,'enUS','I\'m in my group and ready to teleport to the Throne of the Tides!','I\'m in my group and ready to teleport to the Throne of the Tides!',26124),
(43474,'enUS','So whatever happened to that hot little number in Stormwind? Lady Prestor was her name.','',26124),
(43475,'enUS','It\'s weird. My butt hurts. Not sure why.','',26124),
(43476,'enUS','Throne of the Tides, a level 79-81 dungeon in Vashj\'ir, is now available for initial testing. The dungeon is very much a work in progress, and the final boss is not available. Please be in your full group before teleporting to the dungeon. Meeting Stones are not available for this dungeon yet.\n\nTo leave the Throne of the Tides, simply exit through the normal exit inside the dungeon and you will be teleported to Dalaran. If you die and release, you should teleport back from this NPC.','',26124),
(43477,'enUS','Keeshan\'s a good man, $n. Any of us would give our lives for him.','',26124),
(43478,'enUS','When this is all over, I\'m taking a vacation.','',26124),
(43479,'enUS','Take me back to Throne of the Tides!','Take me back to Throne of the Tides!',26124),
(43480,'enUS','We all owe our lives to Keeshan. He\'s saved our hides a hundred times.','',26124),
(43481,'enUS','Being a mage has its advantages, but the laundry bills are hell to pay.','',26124),
(43482,'enUS','So what\'s up with the bridge in Lakeshire? Oslow ever finish building it?','',26124),
(43483,'enUS','I think I\'m gonna go to Dalaran after this is over. Help \'em get that city up and floating.','',26124),
(43484,'enUS','I need to use the restroom.','',26124),
(43485,'enUS','These orcs are in for a rude awakening once Bravo Company is back up and running.','',26124),
(43486,'enUS','','World-famous Noggenfogger Elixir sold here!$B$BHome brewed from all-natural ingredients, bottled and sold locally right here in Gadgetzan. And it\'s delicious, of course!',26124),
(43487,'enUS','Make mine Noggenfogger!','Make mine Noggenfogger!',26124),
(43488,'enUS','Ah, Maloriak. How gracious of you to finally appear from that quarantine you call a laboratory. What have you got this time?','',26124),
(43489,'enUS','By all means, enlighten me. ','',26124),
(43490,'enUS',' It appears as though your experiment has failed. That whelp has gone completely blind! Look at him.','',26124),
(43491,'enUS','LOOK AT HIM!','',26124),
(43492,'enUS','No, not yet.','',26124),
(43493,'enUS','This object of your chagrin may still prove... valuable... to me.','',26124),
(43494,'enUS','Leave now, pathetic alchemist. I anxiously await your next failure.','',26124),
(43495,'enUS','My sincerest apologies for the disturbance, my liege. But I believe I have something you may be very interested in!','',26124),
(43496,'enUS','Yes, yes! ','',26124),
(43497,'enUS','By extracting agents from the blood of various dragonflights I have created a salve that will bestow the wearer sight beyond sight!','',26124),
(43498,'enUS','I present to you experiment number 25463-D!','',26124),
(43502,'enUS','How could this be?! I will dispose of him immediately! \n','',26124),
(43503,'enUS','I beg your mercy, my lord.','',26124),
(43504,'enUS','I can\'t do business with you, $c. Warchief\'s Orders.','I can\'t do business with you, $c. Warchief\'s Orders.',26124),
(43505,'enUS','I have nothing I\'m allowed to sell to you.','I have nothing I\'m allowed to sell to you.',26124),
(43506,'enUS','Get lost, $c! I don\'t want the enforcers to see me doing business with you...','Get lost, $c! I don\'t want the enforcers to see me doing business with you...',26124),
(43507,'enUS','Go away, I don\'t want the Warchief to find out I\'ve been talking to the Horde.','Go away, I don\'t want the Warchief to find out I\'ve been talking to the Horde.',26124),
(43508,'enUS','My goods aren\'t for sale to the Horde. Don\'t like it? Take it up with the Warchief!','My goods aren\'t for sale to the Horde. Don\'t like it? Take it up with the Warchief!',26124),
(43509,'enUS','Warchief Mor\'ghor ordered us not to do business with the Horde.$B$B<The merchant spits on the ground, infuriated, but refuses to speak any more on the subject.>','Warchief Mor\'ghor ordered us not to do business with the Horde.$B$B<The merchant spits on the ground, infuriated, but refuses to speak any more on the subject.>',26124),
(43512,'enUS','Me not feel so good.','',26124),
(43513,'enUS','I can\'t help you, $c. Warchief Mor\'ghor would have me executed if I allowed the Horde to use one of our wind riders.$B$BSome day he\'ll get what\'s coming to him...','',26124),
(43514,'enUS','Senses beyond this realm of mortality!','',26124),
(43515,'enUS','Eureka!','',26124),
(43516,'enUS','Looks like we got a war to win.','',26124),
(43517,'enUS','PAIN TRAIN INCOMING!','',26124),
(43518,'enUS','JOHNNY\'S BACK, BABY! YEA!','',26124),
(43519,'enUS','Er... did you mention something about a Personal Arcane Assistant?','Er... did you mention something about a Personal Arcane Assistant?',26124),
(43520,'enUS','Cowards! Face the brood mother or face DIRE consequences!','',26124),
(43521,'enUS','The air crackles with electricity!','',26124),
(43522,'enUS','There\'s no substitute for live observers, but I need those mountaineers here. We\'ll have to rely on those little gnomish observer bots for now...','',26124),
(43523,'enUS','Not a bad place here, if you aren\'t into the whole \"sunshine\" thing.','',26124),
(43524,'enUS','Take us out, Messner.','',26124),
(43525,'enUS','You got it, Johnny!','',26124),
(43526,'enUS','We\'re here, everybody out!','',26124),
(43527,'enUS','Excuse me, I need to get back to my work.','',26124),
(43528,'enUS','Juntz, I\'m here to collect a debt.  Pay up.','Juntz, I\'m here to collect a debt.  Pay up.',26124),
(43529,'enUS','The gorillas are fascinating creatures.  Better than night elves, who do foolish things, like... gambling away all their money and getting put on Sea Wolf MacKinley\'s hit list.','',26124),
(43530,'enUS','So you know why I\'m here then.  All right Midriff, pay up.','So you know why I\'m here then.  All right Midriff, pay up.',26124),
(43531,'enUS','How did you find me!?','',26124),
(43532,'enUS','I haven\'t got any money!  Get away!','',26124),
(43533,'enUS','Go ahead, $r. Give me an excuse.','',26124),
(43534,'enUS','Warchief Mor\'ghor runs the show here. Don\'t forget it.','',26124),
(43535,'enUS','<The enforcer\'s eyes flash red.>$B$BI hope your pathetic Horde tries to attack us. I am itching to shed some blood, $c!','',26124),
(43536,'enUS','The fury! The power! I have never felt so strong in all my life.$B$BSoon, ALL the Dragonmaw will feel as I do.','',26124),
(43537,'enUS','Don\'t try anything funny, $c.$B$B<The enforcer tenses his fingers near the hilt of his blade, eager for you to make a scene.>','',26124),
(43538,'enUS','Warchief Mor\'ghor will make the Dragonmaw great again!$B$BWe have no need for your pathetic Horde.','',26124),
(43539,'enUS','CRUSH!','',26124),
(43540,'enUS','KILL!','',26124),
(43541,'enUS','DESTROY!','',26124),
(43542,'enUS','What do we do now? Surely the Warchief would want us to storm the port in force!','',26124),
(43543,'enUS','Perhaps. And perhaps we would win, but at what cost? Maybe $n has a better plan...','',26124),
(43544,'enUS','SMASH!','',26124),
(43545,'enUS','POUND!','',26124),
(43546,'enUS','ANNIHILATE!','',26124),
(43547,'enUS','PULVERIZE!','',26124),
(43548,'enUS','BREAK!','',26124),
(43549,'enUS','Alright, let\'s try cracking this thing open!','',26124),
(43550,'enUS','Get ready everyone!  Here come de apes!','',26124),
(43553,'enUS','Yes, my lord.','',26124),
(43554,'enUS','Atramedes! Your master beckons.','',26124),
(43555,'enUS','Witness the sheen of immeasurable power!','',26124),
(43556,'enUS','The excitement of the crowd, the thrill of the fight - you should have seen it!  Ever since those ogres took control of the Dire Maul arena, I\'ve been forced to camp out here.  Griniblix the Spectator - ha!  Spectator of what?  This campfire?  That shrub?  Or how about this odd purple tree?\n\nListen, if you\'re looking for a fight, Skarr was headed towards the Lariss Pavilion, and The Razza was soaring in the direction of the New Thalanaar.  Just be sure to let me in on the betting before the bloodbath begins!','',26124),
(43557,'enUS','No no no! Leave Glop alone! My mushrooms! Mine!','',26124),
(43558,'enUS','Mushrooms grow big and strong. Too big to stomp on! So strong they stomp back!','',26124),
(43559,'enUS','Why you must come here? My cave. My cave! Me never hurt your cave!','',26124),
(43560,'enUS','Stay back! Back!','',26124),
(43561,'enUS','Real funny, Danforth.','',26124),
(43562,'enUS','','This stone trogg is behind the growth in the Crimson Expanse.$B$BI sense a strange power in this place... be careful.',26124),
(43563,'enUS','I\'m ready when you are, Norsala.','I\'m ready when you are, Norsala.',26124),
(43564,'enUS','Yarr, and what be ye?  A bilge-lickin\' $r with some fancy $c pants and a mug like a $g sea giant: harpy;.  I\'d rather take a bite o\' Keelhaul\'s boot than take a weakling like yerself into the Bloodsails.$b$bCome back when ye got a little more wind in yer sails.','',26124),
(43565,'enUS','Yarr.','',26124),
(43566,'enUS','Yarr, thar be a traitor!  An ugly one at that!  Get out o\' me office, before I blow ye down to Pirate-town!','',26124),
(43567,'enUS','<Bossy is busy trying to figure out how to get back downstairs.>','',26124),
(43568,'enUS','<Bossy looks at you with large, liquid black eyes.>','',26124),
(43569,'enUS','<Bossy lowers her head nobly, almost as if she understands the gravity and the meaning of your request.>','',26124),
(43570,'enUS','Bossy, I need to ask something great of you.  I need to cut off your head to prove my loyalty to the Bloodsail Buccaneers, so they will allow me to infiltrate their ranks and hopefully discover their true intentions.\n\nBooty Bay needs you, Bossy... now more than ever.\n\n','Bossy, I need to ask something great of you.  I need to cut off your head to prove my loyalty to the Bloodsail Buccaneers, so they will allow me to infiltrate their ranks and hopefully discover their true intentions.\n\nBooty Bay needs you, Bossy... now more than ever.\n\n',26124),
(43571,'enUS','Moo.','Moo.',26124),
(43572,'enUS','<Do the deed.>','<Do the deed.>',26124),
(43573,'enUS','<Chicken out.>','<Chicken out.>',26124),
(43574,'enUS','%s breathes a heavy sigh of relief.','',26124),
(43575,'enUS','Care to purchase some piratey items?','',26124),
(43576,'enUS','I need an extra-large pirate hat.  Seahorn\'s orders.','I need an extra-large pirate hat.  Seahorn\'s orders.',26124),
(43577,'enUS','Tell him this is the last one.  It breaks poor Narkk\'s heart to have to carve horn-holes in his beautiful hats!','',26124),
(43578,'enUS','What\'ve you got?','What\'ve you got?',26124),
(43579,'enUS','Mean... rock fiends...','',26124),
(43580,'enUS','','Let\'s finish with this quickly.',26124),
(43581,'enUS','','You\'ve caused enough damage, Glop. The earth welcomes you no longer.',26124),
(43582,'enUS','','After him, quickly!',26124),
(43583,'enUS','','Slippery little stone trogg.',26124),
(43584,'enUS','','You kiddin\' me...',26124),
(43585,'enUS','','Good riddance.',26124),
(43586,'enUS','Hey Baron, go long!','',26124),
(43587,'enUS','Welcome to Booty Bay, $r.','',26124),
(43588,'enUS','That\'ll do.','',26124),
(43589,'enUS','Here\'s the head and the hat, Fleet Master.','Here\'s the head and the hat, Fleet Master.',26124),
(43590,'enUS','You\'re the boss.','You\'re the boss.',26124),
(43591,'enUS','This looks good, but I think it\'ll look even better if we beat it up a little bit.  You know, to sell the illusion of a fight.  What do you think?','',26124),
(43592,'enUS','Danforth, report.','',26124),
(43593,'enUS','The Blackrock orcs blew up the bridge leading to Stonewatch Keep. Frontal assault is out of the question.','',26124),
(43594,'enUS','Krakauer?','',26124),
(43595,'enUS','Two ways to get behind enemy lines, Johnny. Three if you count bein\' dead.','',26124),
(43596,'enUS','North through Alther\'s Mill, but we\'d have to cut through an army of bloodthirsty worgs or south through Render\'s Valley.','',26124),
(43597,'enUS','Jorgensen, what do you have on Render\'s Valley?','',26124),
(43598,'enUS','Blackrocks all over the damned place, Johnny. One main tower at the choke and two smaller huts. It\'s a death trap.\n','',26124),
(43599,'enUS','Death trap, eh? Messner, I got a plan. Gonna need some seaforium.','',26124),
(43600,'enUS','Seaforium? Where the hell am I gonna get seaforium from, Johnny?','',26124),
(43601,'enUS','Not my problem, Messner. Make it happen.','',26124),
(43602,'enUS','$n, get your crap ready. I\'m sending you out into the field.','',26124),
(43603,'enUS','Don\'t let stains sit for too long!','',26124),
(43604,'enUS','A stain is about to ruin the deck!','',26124),
(43605,'enUS','You spot a stain on the deck!','',26124),
(43606,'enUS','Two more stains appear!  Keep cleaning!','',26124),
(43607,'enUS','The stains are appearing more quickly now!','',26124),
(43608,'enUS','The deck is ruined.  Pick up another mop and try again.','',26124),
(43609,'enUS','My brothers are strong, but my brothers are passive.$B$BChange does not occur without movement, contention, and violence. Our enemies live this, whether they fully realize it or not. The passive nature of my brothers makes them weak and vulnerable to these new enemies.$B$BNot I. I have no fear of change. I will tear at the ground and move the mountains. I embrace change.','',26124),
(43610,'enUS','You have your mop, now look for stains to swab!','',26124),
(43611,'enUS','','Me remain to make sure the rest of their substance is destroyed.',26124),
(43612,'enUS','Follow the trail of homeless to the Deadmines dungeon entrance.','',26124),
(43613,'enUS','On your feet! Naga attack!','',26124),
(43614,'enUS','We must hurry! Do something, shaman!','',26124),
(43615,'enUS','That sub\'s gunna blow! We have to move, now!','',26124),
(43616,'enUS','More naga... make ready!','',26124),
(43617,'enUS','Thralls balls! I\'m sick of fighting naga!','',26124),
(43618,'enUS','What the hell is that?','',26124),
(43619,'enUS','I don\'t like this...','',26124),
(43620,'enUS','Is there someone here?','',26124),
(43621,'enUS','I smell something... Poop.','',26124),
(43622,'enUS','I\'m staying put. Go check it out!','',26124),
(43623,'enUS','%s casts stealth detection. Keep your distance!','',26124),
(43624,'enUS','','A thief!!',26124),
(43625,'enUS','Yarr!  I pilfered those limes fair \'n\' square!','Yarr!  I pilfered those limes fair \'n\' square!',26124),
(43626,'enUS','Arr!  Get back here, ye swill-swallowin\' swabbie!','Arr!  Get back here, ye swill-swallowin\' swabbie!',26124),
(43627,'enUS','I was just gonna make some limeade fer me hearties!  I swear it!','I was just gonna make some limeade fer me hearties!  I swear it!',26124),
(43628,'enUS','Dead men steal no limes!','Dead men steal no limes!',26124),
(43629,'enUS','Belay yer lime-stealin\' ways, ye scurvy scallywag!','Belay yer lime-stealin\' ways, ye scurvy scallywag!',26124),
(43630,'enUS','No, not me limes, says I!','No, not me limes, says I!',26124),
(43631,'enUS','','Energy begins to arc across Onyxia\'s body as her electrical charge increases.',26124),
(43632,'enUS','','The arcing bolts intensify as Onyxia\'s electrical charge reaches dangerous levels!',26124),
(43633,'enUS','','Miniature bolts of lightning burn across Onyxia\'s skin. Her electrical charge is at critical levels!',26124),
(43634,'enUS','I should get going back to the Crimson Veil.  See you there.','',26124),
(43635,'enUS','Let\'s take these ninjas out, boss.  I already see some of \'em up ahead.','',26124),
(43636,'enUS','What\'s that?','What\'s that?',26124),
(43637,'enUS','Did you hear that?','Did you hear that?',26124),
(43638,'enUS','We\'re free! RUN FOR YOUR LIVES!','We\'re free! RUN FOR YOUR LIVES!',26124),
(43639,'enUS','We\'ve stirred up a hornet\'s nest, $n!$B$BI hope you have a plan for finishing this. Krogg\'s warriors are tearing up the dragonmaw, but we\'re taking heavy losses for every inch of ground...','',26124),
(43640,'enUS','I\'ll die someday, sea-witch...','',26124),
(43641,'enUS','...but not today!','',26124),
(43642,'enUS','Stay close! We are too few already!\n','',26124),
(43643,'enUS','You were nearly lost! Do not wander off!\n','',26124),
(43644,'enUS','Follow me! You stand no chance here alone!\n','',26124),
(43645,'enUS','Your interference shall cosst you your life, $r!','',26124),
(43646,'enUS','You have successfully planted the seaforium at the munitions hut.','',26124),
(43647,'enUS','You have successfully planted the seaforium at the Blackrock tower.','',26124),
(43648,'enUS','Your have no businesss here, $r!','',26124),
(43649,'enUS','The beassst will find you tasssty, sssoftsskin!','',26124),
(43650,'enUS','I am ready to escort a group of elementals across the open.','I am ready to escort a group of elementals across the open.',26124),
(43651,'enUS','Be swift, $c. The stone dragons will not give up easily.','',26124),
(43652,'enUS','Activate your Bravo Company Field Kit now.|TInterface\\Icons\\INV_MISC_ENGGIZMOS_20.BLP:16|t$BStealth your party using Camouflage.|TInterface\\Icons\\SPELL_NATURE_PROTECTIONFORMNATURE.BLP:16|t','',26124),
(43653,'enUS','We\'re nearing Render\'s Valley. These orcs are tough! Make sure you are camo\'d!|TInterface\\Icons\\SPELL_NATURE_PROTECTIONFORMNATURE.BLP:16|t\n','',26124),
(43654,'enUS','Create a distraction so that you and Jorgensen can slip by unnoticed.|TInterface\\Icons\\ABILITY_ROGUE_BLOODYEYE.BLP:16|t\n\n','',26124),
(43655,'enUS','Sometimes you just need to take out one target. Use chloroform while behind the enemy!|TInterface\\Icons\\SPELL_NATURE_SLEEP.BLP:16|t\n','',26124),
(43656,'enUS','Are you here to help the Dragonmaw reclaim our freedom?$B$BSpeak with Zaela - she\'s coordinating our resistance!','',26124),
(43657,'enUS','','Abandon the port? Has Mor\'ghor beaten all the sense out of you? This attack is our best opportunity to take our destiny into our own - wait! Here comes $n from the Horde!',26124),
(43658,'enUS','My heals really don\'t have the \'OOMPH\' that they used to, $n. You know what I\'m saying?','',26124),
(43659,'enUS','Being a paladin is rough. The Light behaves so erratically. Some days I wake up and it feels like all of my powers have been weakened.','',26124),
(43660,'enUS','Yarr, hold on tight, me hearty, fer thar be nary an oarsman so capable as I!','',26124),
(43661,'enUS','I don\'t know, maybe the grass really is greener on the other side. You know? Krakauer and Danforth really kick butt as warriors. Maybe I should drop this paladin thing and try out being a warrior.','',26124),
(43662,'enUS','We be headin\' up t\' where the goblins say they found black gold.  That gold belongs t\' the Bloodsail!','',26124),
(43663,'enUS','Messner kills bad guys so fast. I wish I could kill as fast as him. WHY can\'t I shoot fireballs? What does the LIGHT have against fireballs?','',26124),
(43664,'enUS','I\'ll steer, you handle Ol\' Blasty.  An\' don\'t tie yer skivvies in a knot... I\'ll slow down when we get closer!','',26124),
(43665,'enUS','Here we are!  Fire at will!','',26124),
(43666,'enUS','Ready... open fire!','',26124),
(43667,'enUS','They be on either side of us!  Send \'em down to Neptulon\'s Locker!','',26124),
(43668,'enUS','One time, Keeshan told me that he could take on five of me at once. Why am I so weak?','',26124),
(43669,'enUS','That gold is ours!  Open fire, says I!','',26124),
(43670,'enUS','Make sure we always have camouflage up. The orcs in Render\'s Valley will kill us both if we\'re spotted.','',26124),
(43671,'enUS','Retreat, says I!','',26124),
(43672,'enUS','On t\' the next one!','',26124),
(43673,'enUS','Belay your attacks!  We\'re movin\' on!','',26124),
(43674,'enUS','While camouflaged, we are harder to detect when we are BEHIND creatures.','',26124),
(43675,'enUS','Ahoy!  I see more o\' those goblins over there!','',26124),
(43676,'enUS','Sometimes a distraction can backfire and cause the orcs to become suspicious. In those instances the orcs will actively search for us. It\'s best to keep a good distance from any orc detecting stealth.','',26124),
(43677,'enUS','Aye-aye, sir.  Heavin\' to and returnin\' back t\' shore.','',26124),
(43678,'enUS','Once in a while we\'ll come up against a lone orc that stands between us and victory. Chloroform is often best used in those situations. Just remember to apply chloroform we have to be behind the enemy.','',26124),
(43679,'enUS','Aye, what need ye?','',26124),
(43680,'enUS','Ahoy matey!  Hoist anchor, trim the mainsail, batton down the hatches and set to sea!  Today we scuttle the Venture Company\'s blasted contraptions and send \'em all to feed the fishes!  Now hop to, before I put the black spot on ye!','Ahoy matey!  Hoist anchor, trim the mainsail, batton down the hatches and set to sea!  Today we scuttle the Venture Company\'s blasted contraptions and send \'em all to feed the fishes!  Now hop to, before I put the black spot on ye!',26124),
(43681,'enUS','I... I need a boat.','I... I need a boat.',26124),
(43682,'enUS','|cFF768EBDI\'ve got the seaforium charges ready. We need to get to the munitions hut and tower.|r|TInterface\\Icons\\INV_MISC_BOMB_04.BLP:24|t\n','',26124),
(43683,'enUS','Perusing','Perusing',26124),
(43684,'enUS','A barrel of grog.  Pirates love this stuff.','',26124),
(43685,'enUS','A barrel of grog.  Pirates love this stuff.$b$bThe cork does not seem to fit too tightly in the bunghole.','',26124),
(43686,'enUS','<Nudge the cork.>','<Nudge the cork.>',26124),
(43687,'enUS','The grog leaks out of the barrel.  A lot of pirates are going to be very unhappy about this.','',26124),
(43688,'enUS','A barrel of gunpowder.  Highly explosive.','',26124),
(43689,'enUS','A barrel of gunpowder.  There is a pitcher of water sitting nearby.','',26124),
(43690,'enUS','<Pour the water onto the gunpowder.>','<Pour the water onto the gunpowder.>',26124),
(43691,'enUS','The gunpowder is completely soaked.  Nobody\'s going to be using this to fire cannons anytime soon.','',26124),
(43692,'enUS','An enormous crate, filled to the brim with cannonballs.','',26124),
(43693,'enUS','An enormous crate, filled to the brim with cannonballs.  There is a can of cooking grease sitting innocently nearby.','',26124),
(43694,'enUS','<Grease the cannonballs.>','<Grease the cannonballs.>',26124),
(43695,'enUS','You pour grease all over the heavy metal projectiles.  Firallon\'s crew is certainly going to have a hard time loading these.','',26124),
(43696,'enUS','','Attack!',26124),
(43697,'enUS','','Secure the rafters!',26124),
(43698,'enUS','','I want two sharpshooters to stay behind and cover the deck.  Everyone else, use the ropes to rappel down.  Let\'s give them hell!',26124),
(43699,'enUS','','We\'ve got the explosives  in the furnace room.  Just hold them off now!',26124),
(43700,'enUS','Ahoy!','',26124),
(43701,'enUS','Avast!','',26124),
(43702,'enUS','Arr!','',26124),
(43703,'enUS','Yarr!','',26124),
(43704,'enUS','Blow me down!','',26124),
(43705,'enUS','Gangway!','',26124),
(43706,'enUS','You\'re a mutinous dog!  Draw steel!','You\'re a mutinous dog!  Draw steel!',26124),
(43707,'enUS','I\'d never leave the Buccaneers, ye whale-tail skivvy-sniffer!','',26124),
(43708,'enUS','Draw yer own steel, ye harpy-lovin\' scoundrel!','',26124),
(43709,'enUS','I\'d never turn sides, ye green-gilled murloc!','',26124),
(43710,'enUS','Mutiny?  I\'ll show ye mutiny, ye cockle-knuckled squiffy!','',26124),
(43711,'enUS','I\'ll run ye through, ye cannon-kissin\' cannonface!','',26124),
(43712,'enUS','I\'ll send ye down to Neptulon\'s Locker, ye three-gallon pufferfish!','',26124),
(43713,'enUS','I\'ll send ye to feed the fishes, ye flat-shanty trogg!','',26124),
(43714,'enUS','I\'ll poke out yer deadlights, ye lily-livered eel!','',26124),
(43715,'enUS','DRAGONMAW!!','DRAGONMAW!!',26124),
(43716,'enUS','For the Horde!','For the Horde!',26124),
(43717,'enUS','Victory for the Dragonmaw!','Victory for the Dragonmaw!',26124),
(43718,'enUS','Just a bunch of meaningless scribbles.','',26124),
(43719,'enUS','These plans list the details on the upcoming attack!','',26124),
(43720,'enUS','Peak, I\'m ready to escort the catapult.','Peak, I\'m ready to escort the catapult.',26124),
(43721,'enUS','It is the day of reckoning, $c!','',26124),
(43722,'enUS','Have you come to help overthrow Mor\'ghor?','',26124),
(43723,'enUS','Zaela told us the Horde would help! What can I do?','',26124),
(43724,'enUS','Don\'t give me any armor. Just gimmie a blade and tell me who to kill.','',26124),
(43725,'enUS','The Horde has come! It\'s about time we got some real leadership around here.','',26124),
(43726,'enUS','I\'ll fight by your side, $c. You won\'t regret helping us!','',26124),
(43727,'enUS','Fight with me! Take up this blade and be a warrior.','Fight with me! Take up this blade and be a warrior.',26124),
(43728,'enUS','Looks like I picked the wrong day to stop killin\' fel orcs.','Looks like I picked the wrong day to stop killin\' fel orcs.',26124),
(43729,'enUS','It\'s a day of reckoning, $c!','It\'s a day of reckoning, $c!',26124),
(43730,'enUS','Put me in, coach! I\'m ready to fight!','Put me in, coach! I\'m ready to fight!',26124),
(43731,'enUS','Today Mor\'ghor\'s tyranny will end.','Today Mor\'ghor\'s tyranny will end.',26124),
(43732,'enUS','This is it, $c! The revolution has come.','This is it, $c! The revolution has come.',26124),
(43733,'enUS','$c! Zaela said the Horde would provide us with weapons. What do you have?','$c! Zaela said the Horde would provide us with weapons. What do you have?',26124),
(43734,'enUS','Ahoy there!','',26124),
(43735,'enUS','Long John Copper, is the Brashtide Crew ready for battle?','Long John Copper, is the Brashtide Crew ready for battle?',26124),
(43736,'enUS','Yes, $g sir: ma\'am;!  We\'ve been biding our time in Gilneas for far too long.  We\'re ready for blood!','',26124),
(43737,'enUS','What\'re y\' looking at, $r?','',26124),
(43739,'enUS','What can you tell me about the Brashtide Crew?','What can you tell me about the Brashtide Crew?',26124),
(43740,'enUS','We used to roam the seas... \'til that damned King Greymane shut down the harbors in Gilneas!  If it weren\'t for him, we wouldn\'t be...','',26124),
(43741,'enUS','','Can I help you?',26124),
(43742,'enUS','You know the battle plan, right?','You know the battle plan, right?',26124),
(43743,'enUS','','Yes, $g sir: ma\'am;.  We attack from the north at your signal.  The Brashtide will wash over Booty Bay!  Aroooo!!!!',26124),
(43744,'enUS','Support and heal me! Take up this warhammer and be a shaman.','Support and heal me! Take up this warhammer and be a shaman.',26124),
(43745,'enUS','My spouse has gone missing! Please help!','My spouse has gone missing! Please help!',26124),
(43746,'enUS','Townspeople are disappearing, Solomon. What are you going to do about it?','Townspeople are disappearing, Solomon. What are you going to do about it?',26124),
(43747,'enUS','It\'s time to wake up, magistrate! These aren\'t ordinary gnoll attacks!','It\'s time to wake up, magistrate! These aren\'t ordinary gnoll attacks!',26124),
(43748,'enUS','Where is the help that we requested from Stormwind?','Where is the help that we requested from Stormwind?',26124),
(43749,'enUS','What are we paying our taxes for if your guards can\'t even keep gnolls out?','What are we paying our taxes for if your guards can\'t even keep gnolls out?',26124),
(43750,'enUS','My children were kidnapped while they slept! I WANT ANSWERS, SOLOMON!','My children were kidnapped while they slept! I WANT ANSWERS, SOLOMON!',26124),
(43751,'enUS','You better do something quick or you\'ll have a riot on your hands, Solomon!','You better do something quick or you\'ll have a riot on your hands, Solomon!',26124),
(43752,'enUS','The gnolls have never been this aggressive. What\'s going on, Solomon? Tell us!','The gnolls have never been this aggressive. What\'s going on, Solomon? Tell us!',26124),
(43753,'enUS','How long must we stand here before our pleas are heard?','How long must we stand here before our pleas are heard?',26124),
(43754,'enUS','Get this damned line moving!','Get this damned line moving!',26124),
(43755,'enUS','You\'re good for nothing, Solomon!','You\'re good for nothing, Solomon!',26124),
(43756,'enUS','You can forget about re-election, magistrate!','You can forget about re-election, magistrate!',26124),
(43757,'enUS','No justice, no peace!','No justice, no peace!',26124),
(43758,'enUS','If you don\'t do something about these gnolls, we will!','If you don\'t do something about these gnolls, we will!',26124),
(43759,'enUS','Please help me! I\'m the last member of my family left. Everyone else has been kidnapped!','Please help me! I\'m the last member of my family left. Everyone else has been kidnapped!',26124),
(43760,'enUS','Forget you, Solomon. I\'ll find my family by myself.','Forget you, Solomon. I\'ll find my family by myself.',26124),
(43761,'enUS','This pathetic revolution ends here!','',26124),
(43762,'enUS','DEBUG Event Sent - Mode to Daily Quest (IDLE_GAME_EVENT)','',26124),
(43763,'enUS','DEBUG Event Sent - Mode to Game Startup (POPULATING_GAME_EVENT)','',26124),
(43764,'enUS','DEBUG Event Sent - Mode to Game Active (ACTIVE_GAME_EVENT)','',26124),
(43765,'enUS','DEBUG Event Sent - Mode to Game Finish (CONCLUDED_GAME_EVENT)','',26124),
(43766,'enUS','DEBUG Event Sent - Number Players Changed (NUM_CHANGED_EVENT)','',26124),
(43767,'enUS','DEBUG Event Sent - Reduce Game Timer (REDUCE_TIME_EVENT)','',26124),
(43768,'enUS','DEBUG Event Sent - Attackers Win (ATTACKERS_WIN_EVENT)','',26124),
(43769,'enUS','DEBUG Event Sent - Defenders Win (DEFENDERS_WIN_EVENT)','',26124),
(43770,'enUS','DEBUG Event Sent - Control Victory Achieved (END_EARLY_EVENT)','',26124),
(43771,'enUS','<Baron Revilgaz\'s private stock.  Do not touch under any circumstances!>','',26124),
(43772,'enUS','Ask yourself, $n: is this good for the Venture Company?','Ask yourself, $n: is this good for the Venture Company?',26124),
(43773,'enUS','I tink ya be even more like ya father den ya thought, even witout da demon blood.','',26124),
(43774,'enUS','But dese be worries for older minds.  Ya still have much to learn.  Go help tha people of tha Darkspear.  I am sure we\'ll be speakin\' again real soon.','',26124),
(43775,'enUS','I did not make this decision lightly, Vol\'jin. I know our alliances will suffer for it. I know the Horde will be irreversibly changed. But I made this choice with confidence that Garrosh is exactly what the Horde needs.','',26124),
(43776,'enUS','I\'m trusting you and the other leaders to not let this divide our people. You are stronger than that.','',26124),
(43777,'enUS','Still, I be hopin\' Thrall will return to us one day. Tha future right now be lookin\' very grim... and very bloody.','',26124),
(43778,'enUS','Go now. Make tha Darkspear proud. Dere are many wars ahead of us, an\' I\'m sure ya be havin\' a part to play in all of dem.','',26124),
(43779,'enUS','AAAAAAAHHHHHHHHHHHHHHHHH!','',26124),
(43780,'enUS','AAAAAAAAAAAHH!','',26124),
(43781,'enUS','HEEEEEELLLLLLLP!','',26124),
(43782,'enUS','OH MY GOD, THEY\'RE HERE! AHHHHHHHH!','',26124),
(43783,'enUS','PIRATES!  AAAAAHHHHH!','',26124),
(43784,'enUS','Johnny, you do realize that we just blew up half of Redridge, right?','',26124),
(43785,'enUS','NOW IS THE TIME TO PANIC, EVERYBODY!','',26124),
(43786,'enUS','Redridge\'ll heal, but them orcs sure won\'t...','',26124),
(43787,'enUS','I\'M SCARED!','',26124),
(43788,'enUS','Batton down the hatches, mateys!','',26124),
(43789,'enUS','Blow the lily-livered scalawags out of the water!','',26124),
(43790,'enUS','Brashtide and Bloodsail be damned!  The Blackwater Raiders hold Booty Bay!','',26124),
(43791,'enUS','Put out those fires!','',26124),
(43792,'enUS','Hold yer positions, men!  We can outlast \'em!','',26124),
(43793,'enUS','Scuttle \'em all, says I!','',26124),
(43794,'enUS','Firallon, come out and fight like a goblin!','',26124),
(43795,'enUS','Ye walk on the Baron\'s land now, ye scurvy worgen scum!','',26124),
(43796,'enUS','So...tired...','',26124),
(43797,'enUS','You dealt the most damage during this battle ground!','You dealt the most damage during this battle ground!',26124),
(43798,'enUS','You healed the most damage during this battle!','You healed the most damage during this battle!',26124),
(43799,'enUS','You slew the most foes during this battle!','You slew the most foes during this battle!',26124),
(43800,'enUS','The pathway to damnation awaits...','',26124),
(43801,'enUS','You realize not the error of your ways, but soon you will cower before Darkblaze.','',26124),
(43802,'enUS','Mount me on the vehicle.','Mount me on the vehicle.',26124),
(43803,'enUS','Pokey find a fish!','',26124),
(43804,'enUS','GAME OVER, MAN!!!','',26124),
(43805,'enUS','The elements demand vengeance!','',26124),
(43806,'enUS','MINION, to my aid!','',26124),
(43807,'enUS','Heads up! PAYLOAD INCOMING!','',26124),
(43808,'enUS','Where the hell did this come from?','',26124),
(43809,'enUS','Troteman.','',26124),
(43810,'enUS','Troteman?','',26124),
(43811,'enUS','At your service.','',26124),
(43812,'enUS','Bitsy help. Buy meat, rest in tent.','',26124),
(43813,'enUS','Time to go!','',26124),
(43814,'enUS','Hop on a hippogryph, now\'s our chance!','',26124),
(43815,'enUS','We must wait for the right time to strike!','',26124),
(43816,'enUS','We must bide our time.  They won\'t know what hit them.','',26124),
(43817,'enUS','','Hands up, greenskins!  My men will give you your new bearing.  You try anything funny and we\'ll fill you with lead.',26124),
(43818,'enUS','','The rest of you, follow me downstairs!',26124),
(43819,'enUS','You sure picked an interesting time to chat with Ol\' Kebok.','',26124),
(43820,'enUS','Sorry, not here to chat.  I need a wind rider to take on a special mission.','Sorry, not here to chat.  I need a wind rider to take on a special mission.',26124),
(43821,'enUS','[Orcish] Dabu?','',26124),
(43822,'enUS','AAHHHHHHHHH!!!!','',26124),
(43823,'enUS','AAHHHHHHHHHHHHHHHHHH!!!!','',26124),
(43824,'enUS','AAAAAAAAAAAHHHHHHHHHHHHH!!!!','',26124),
(43825,'enUS','BLOOD AND THUNDER, RIGHT!?','',26124),
(43826,'enUS','I CAN\'T FIND YOUR LEGS, JOEY! I CAN\'T FIND YOUR DAMNED LEGS!','',26124),
(43827,'enUS','AAAHHHH!','',26124),
(43828,'enUS','RUN TO YOUR DARK GODS, YOU FILTHY ANIMALS!','',26124),
(43829,'enUS','THERE ARE NO FRIENDLY CIVILIANS!','',26124),
(43830,'enUS','Who are you? What is this place?','',26124),
(43831,'enUS','What shall the Light teach you?','What shall the Light teach you?',26124),
(43832,'enUS','The Light protect you, $c.','The Light protect you, $c.',26124),
(43833,'enUS','The light of the Sun illuminates the path to wisdom.  Where shall we walk today, friend?','The light of the Sun illuminates the path to wisdom.  Where shall we walk today, friend?',26124),
(43834,'enUS','May the Sun\'s light protect you, $c.','May the Sun\'s light protect you, $c.',26124),
(43835,'enUS','Now to destroy this foul substance...','',26124),
(43836,'enUS','Arrghhhhh!','',26124),
(43837,'enUS','We\'ll set flight once everyone is ready.','',26124),
(43838,'enUS','Patience, friends.  We will strike soon.','',26124),
(43839,'enUS','Hold your horses, friend.  We\'ll hit them when we\'re all ready.','',26124),
(43840,'enUS','Let\'s give everyone time to gather.  We\'ll need a handful of people to come with us.','',26124),
(43841,'enUS','The Scoured Reach lies to the west.','',26124),
(43842,'enUS','Not wasted, Stonemother.  It has been very useful.','',26124),
(43843,'enUS','It stands to reason that it may be here for exactly the reasons it says it is.','',26124),
(43844,'enUS','You still have much to prove.  But you brought the stone.  That is an excellent start.','',26124),
(43845,'enUS','Place the stone upon the ground before me.','',26124),
(43846,'enUS','The other Stone Lords have already heard my words.','',26124),
(43847,'enUS','Take this signet as a testament of my good will.  I pray that my trust is not misplaced.','',26124),
(43848,'enUS','','Is this the one you are wasting your time with, Diamant?',26124),
(43849,'enUS','','Then you take responsibility for its actions, Stone Lord.  You will be the one answering to me when it shows its true intent.',26124),
(43850,'enUS','','And you fleshling, consider for a moment that you are entirely surrounded by rock in this place.  The very earth you walk on bends to my will.',26124),
(43851,'enUS','','If you betray us, there will be no escape for you.  I will crush your body so slowly that you shall hear every single one of your bones break.',26124),
(43852,'enUS','','I\'m glad we had this talk.',26124),
(43853,'enUS','You\'ve come to prove yourself, fleshling?  The Crumbling Depths lie northeast.  The stone you seek is within.','',26124),
(43854,'enUS','Strike the crystals when you are ready and we shall face the Broodmother together.','',26124),
(43855,'enUS','You\'ve strayed too far from the Stonemother\'s gaze, dragon.  It is time that you be put in your place.','',26124),
(43856,'enUS','She submits.  Well done, fleshling.','',26124),
(43857,'enUS','','You stand here trying to convince me that these beings of flesh should be trusted.',26124),
(43858,'enUS','','They are the literal incarnation of corruption.  Their very skin screams it.',26124),
(43859,'enUS','','They seek only power, as the Twilight do.  Yet you are confident that they will not turn on us.  Did I raise you to be fools?',26124),
(43860,'enUS','','They slaughtered stone troggs, Gorik?  This is supposed to sway me?  It is not much of a feat.',26124),
(43861,'enUS','','What of you Boden?  What do you see in this \"champion?\"',26124),
(43862,'enUS','','That very well may be.  Even fools have uses though.  I keep you around after all.',26124),
(43863,'enUS','I have no love for the intruders, Stonemother, but these fleshlings went well out of their way to cleanse the filth from the Crimson Expanse. ','',26124),
(43864,'enUS','They are not the Twilight.  I see no reason to oppose their goals.','',26124),
(43865,'enUS','I\'ve not spoken with the strangers, but I bore witness to their champion treading deep into the Crumbling Depths and returning unscathed.  It is clearly capable.','',26124),
(43866,'enUS','This champion also faced the Stone Dragons and their Broodmother with no glimpse of fear or hesitation.  I\'ve seen the most hardy of giants falter where the fleshling did not.','',26124),
(43867,'enUS','You know where I stand, Stonemother.','',26124),
(43868,'enUS','It\'s not bravery that drives it.  It strode before me like it thought this place its home. It is a fool.  It will surely get itself killed soon enough.','',26124),
(43869,'enUS','','And so the \"champion\" arrives.',26124),
(43870,'enUS','','So small.  So soft.  It\'s a wonder you\'ve even lasted this long down here, fleshling.',26124),
(43871,'enUS','','Or perhaps a testament to your abilities?',26124),
(43872,'enUS','','All of this for a piece of the World Pillar?  What exactly, shaman, do you intend to do with it?',26124),
(43873,'enUS','','And what then? Will you leave Deepholm to its denizens?',26124),
(43874,'enUS','','I\'m glad you\'re at least that perceptive.',26124),
(43875,'enUS','','I propose this: We will march on the Twilight cult and extinguish any utterings of Deathwing\'s name from this realm.  Your Earthen Ring will march with us.',26124),
(43876,'enUS','','You do this, and I will send Gorsik to the temple with our piece of the World Pillar.',26124),
(43877,'enUS','','Seal the rift and leave this place.',26124),
(43878,'enUS','','Save your thanks.  We march upon the Twilight Precipice as soon as our forces are gathered. I expect to see you on the battlefield.',26124),
(43879,'enUS','We came here to seal da rift Deathwing tore into Azeroth. We need the World Pillar to repair da hole on dis side.','',26124),
(43880,'enUS','We\'ll leave. We\'ve no desire to stay where we\'re not welcome.','',26124),
(43881,'enUS','We\'ll be doin\' exactly that then. Ya have our tanks, Stonemother.','',26124),
(43882,'enUS','','The earth has come to claim you, cult!',26124),
(43886,'enUS','','Your trespass shall see no forgiveness.  Deathwing is no longer here to coddle you.',26124),
(43887,'enUS','','Cower as the very ground reaches up to swallow you!',26124),
(43888,'enUS','','Well done, $r.  Return to the temple, Gorsik shall meet you there, as promised.',26124),
(43889,'enUS','Welcome to Deepholm, cultist.','',26124),
(43891,'enUS','What about you, cultist?  Do you know how to fly?','',26124),
(43892,'enUS','Do you find me imposing?  Be honest.  I\'m going for imposing.','',26124),
(43893,'enUS','Run all you want whelps.','',26124),
(43894,'enUS','You built your dwellings upon our very rockface.  Your ignorance shall be your undoing.','',26124),
(43895,'enUS','Soon you shall be nothing more than a stain to clean off of my foot.','',26124),
(43896,'enUS','Look at this one... standing bravely with earth beneath his feet, thinking to challenge me.','',26124),
(43897,'enUS','You\'ve some sting in you, human.','',26124),
(43898,'enUS','You make a very tenacious corpse.','',26124),
(43899,'enUS','Quite brave for one so small and fragile.','',26124),
(43900,'enUS','The Stone Dragons are here, fleshling.  Take wing!','',26124),
(43901,'enUS','Deathwing will have his way with your Stonemother.','',26124),
(43902,'enUS','Twilight shall fall upon you, even in this deep, dark hole.','',26124),
(43903,'enUS','Agh...','',26124),
(43904,'enUS','You\'re in ova ya head, bud.','',26124),
(43905,'enUS','Ya handle yaself on da ground.  How about in da skies?','',26124),
(43906,'enUS','Ya need ta be more swift den that!','',26124),
(43907,'enUS','Stay on dem, beasts!  Rip dem from the air!','',26124),
(43908,'enUS','Me tink I\'ve had my fill of ya, mon.','',26124),
(43909,'enUS','No! Noooo...','',26124),
(43910,'enUS','','Therazane\'s finally gathered the nerve to challenge us, has she?',26124),
(43911,'enUS','','Come closer, love.  I have a point to make.',26124),
(43912,'enUS','','You do realize there\'s no hope, don\'t you?  Deathwing has already risen.  Your world is doomed.',26124),
(43913,'enUS','','Stay close, gorgeous.  I\'m worth chasing.',26124),
(43914,'enUS','','I\'m not that easy, hon.  Perhaps another time.',26124),
(43915,'enUS','[Broken Common] Death here for you.','',26124),
(43916,'enUS','Your corpses will feed the Blackrock war machine.','',26124),
(43917,'enUS','Forgive me, master... I have failed you.','',26124),
(43918,'enUS','Killin\'s as easy as breathin\'.','',26124),
(43919,'enUS','Best wishes from the Bravo Company.','',26124),
(43920,'enUS','He won\'t be gettin\' up from that one.','',26124),
(43921,'enUS','AHHHHHHHHHH!','',26124),
(43922,'enUS','AAAAAAHHHHHHHHHHHHHHH!','',26124),
(43923,'enUS','The final piece of the World Pillar has been recovered!  We have only to bind it together to prevent this realm from collapsing into Azeroth.','',26124),
(43924,'enUS','Gather, brothers and sisters!  Let us fulfill our duties and return to Thrall victorious!','',26124),
(43925,'enUS','You\'ve proven more than capable of defeating any enemy.  I would be honored if you stand guard through the ritual, young hero.','',26124),
(43926,'enUS','Twilight assassins are upon us!  Do not let them interrupt the ritual!','',26124),
(43927,'enUS','Nooo!  Lorvarius...','',26124),
(43928,'enUS','They are... subsiding.  Renew your efforts, brothers!  We must complete the ritual before they can return!','',26124),
(43929,'enUS','I have... failed...','',26124),
(43930,'enUS','Keep dese assassins off of me!','',26124),
(43931,'enUS','Dey\'ve returned!  To arms!','',26124),
(43932,'enUS','Stop her!  We can still complete da binding!','',26124),
(43933,'enUS','Thank da elements...','',26124),
(43934,'enUS','It is done!  We are finished.','',26124),
(43935,'enUS','With the pillar restored, dis realm is safe.  We must now attend to the wound on the surface.','',26124),
(43937,'enUS','I\'m gravely wounded... I cannot hold...','',26124),
(43938,'enUS','','Your tale ends here, shaman. ',26124),
(43939,'enUS','','Deathwing shall bring destruction upon your entire order.  And this day, I shall be his blade!',26124),
(43940,'enUS','','Hah...',26124),
(43941,'enUS','','You should have taken the hint when we destroyed your precipice, cultist.',26124),
(43942,'enUS','','Ma\'haat, slaughter these rabble.  I will deal with the fool priestess.',26124),
(43943,'enUS','','Returning has ensured your death.',26124),
(43944,'enUS','','Da ritual is almost complete!',26124),
(43945,'enUS','','Thank you, Stonemother.  It was an honor to have...',26124),
(43946,'enUS','','You\'ve proven true to your word, Earthmender.  For that, we will spare you our wrath.  ',26124),
(43947,'enUS','','Once your wounded are gathered, you can thank me by leaving.',26124),
(43948,'enUS','','$n, get into the Ultimate Footbomb Uniform behind you and get down to the docks. Help Thrall kick the Trade Prince\'s butt!',26124),
(43949,'enUS','Always nice to get a gift hand delivered by the second-in-command. I\'ll unwrap this right now!','',26124),
(43950,'enUS','OUCH!','',26124),
(43951,'enUS','All cannons!  Open fire on the Crimson Veil!','',26124),
(43952,'enUS','Okay, okay! I got the message!','',26124),
(43953,'enUS','Traitor!  I\'ll die before I surrender me ship to you!','',26124),
(43954,'enUS','','Haha! That should be a blast!',26124),
(43955,'enUS','Look out! Here they come!','',26124),
(43956,'enUS','$n, I\'m going to need your help!','',26124),
(43957,'enUS','Damn, stone troggs! Over there!','',26124),
(43958,'enUS','Stone troggs incoming!','',26124),
(43959,'enUS','Firing at will!','',26124),
(43960,'enUS','Now who\'s going to get pummelled?!','',26124),
(43961,'enUS','You took my king, I take your miserable life!','',26124),
(43962,'enUS','Here they come! Protect the catapult at all costs!','',26124),
(43963,'enUS','My ring... Who holds my family ring... Tilloa, is that you?','',26124),
(43964,'enUS','Tobias...','',26124),
(43965,'enUS','It\'s all true, brother. Every word. You doubted it?','',26124),
(43966,'enUS','Brother!','',26124),
(43967,'enUS','Tell me it\'s not true, brother. Tell me you didn\'t die a murderer!','',26124),
(43968,'enUS','You know why!','',26124),
(43969,'enUS','Alright, let\'s get going.','',26124),
(43970,'enUS','We need to keep moving!','',26124),
(43971,'enUS','Let\'s head out. Just keep those stone troggs off of us.','',26124),
(43972,'enUS','The faster we can get to the other side of the front, the faster we can reduce Needlerock Slag to rubble.','',26124),
(43973,'enUS','But why?! How could you?','',26124),
(43974,'enUS','Moving out!','',26124),
(43975,'enUS','How\'d that feel, you stone trogg scum?!','',26124),
(43976,'enUS','Oh yeah! Tremble at the might of our catapults!','',26124),
(43977,'enUS','You stone troggs have no idea of what\'s coming!','',26124),
(43978,'enUS','Surely you\'ve felt anger. Anger so foul and vicious that it makes you want to tear someone to shreds...','',26124),
(43979,'enUS','Aren\'t you feeling it right now?','',26124),
(43980,'enUS','No... NO! STOP IT!','',26124),
(43981,'enUS','You see, brother... we\'re not so different...','',26124),
(43982,'enUS','No...','',26124),
(43983,'enUS','I don\'t care how low the success rate here is. If we save even one worgen from the madness and savagery of the woods, our struggles are not in vain.','',26124),
(43984,'enUS','','The dead cry for solace. Their anguish echoes on the wind.',26124),
(43985,'enUS','Guards, leave us.','',26124),
(43986,'enUS','I must admit, we did not bring you here for introductions and pleasantries.','',26124),
(43987,'enUS','I will get straight to the point.  We have something to ask of you.','',26124),
(43988,'enUS','We have a traitor within our walls.  Someone who is well connected.','',26124),
(43989,'enUS','','One of our best sentinels was on his trail - we assume it\'s a \"he\" - but it appears that she was discovered.',26124),
(43990,'enUS','','She was found by our patrols this morning.  Murdered within our own city.',26124),
(43991,'enUS','','It is difficult to know who to trust.  You are new here... relatively unknown.  That works in your favor in this case.',26124),
(43992,'enUS','We need your help hunting this traitor down.  Are you willing?','',26124),
(43993,'enUS','','One more thing.  We\'ve arranged for one of our own to accompany you.',26124),
(43994,'enUS','','This is Lillorilen.',26124),
(43995,'enUS','','Call me Lilly, please.',26124),
(43996,'enUS','','The sentinel I told you about was Lilly\'s sister.  She can be trusted.',26124),
(43997,'enUS','','We\'ll track this traitor down, priestess.  You\'ve no reason to worry.',26124),
(43998,'enUS','','I trust that you will, but please, be careful.',26124),
(43999,'enUS','','...it looks like there was barely a struggle at all.',26124),
(44000,'enUS','','That\'s so unlike her.  She would have fought tooth and nail if she knew the danger.',26124),
(44001,'enUS','','Do you think he took her that unaware?  Even though she thought she had his trail?',26124),
(44002,'enUS','','Keep a sharp eye out.  There must be a clue here somewhere that can help us track him down.',26124),
(44003,'enUS','','Have you found something?',26124),
(44004,'enUS','','A mud-stained leaf...',26124),
(44005,'enUS','','%s sniffs at the leaf briefly.',26124),
(44006,'enUS','','Verdantleaf!  This is quite fortunate.',26124),
(44007,'enUS','','This only grows in a single area in Darnassus. Perhaps our killer dragged it here on his boot.',26124),
(44008,'enUS','','The building we\'re looking for is on the Craftsman\'s Terrace.  Let\'s go.',26124),
(44009,'enUS','','Velora was several years my elder.',26124),
(44010,'enUS','','We\'d been having a rough spot these past months.  Everyone has I guess.',26124),
(44011,'enUS','','Have you ever had that feeling when you just can\'t remember something, but you know it\'s important?  It\'s been like that for all of us since Malfurion came back.',26124),
(44012,'enUS','','I get flashes sometimes of these horrific images.  Shadows assaulting us in the night.  Friends turning and attacking each other.',26124),
(44013,'enUS','','It\'s hard to put into words.  Things should be wonderful.  Malfurion\'s returned.  Teldrassil was finally blessed by the dragon aspects... some of them anyway.',26124),
(44014,'enUS','','But I guess I just feel... I feel a little piece of my life is missing.  Faded.  Like waking from a dream.',26124),
(44015,'enUS','','It\'s a strain, but I shouldn\'t have let it affect me.  I... I should have been better to my sister.\n',26124),
(44016,'enUS','','Enough of my regrets.  This is the building.  Let\'s check it out.',26124),
(44017,'enUS','','These rooms are normally offered to guests of the city.  Really, anyone could have been staying here.',26124),
(44018,'enUS','','This is a map of Darkshore.  There are paths drawn from Auberdine towards Lor\'danel... and towards several other safe-havens as well.',26124),
(44019,'enUS','','Some kind of attack plan?  Auberdine was ravaged during the first throes of the cataclysm.  What value could it have to anyone?',26124),
(44020,'enUS','','These could be escape routes I suppose.',26124),
(44021,'enUS','','The route across the beach is circled.  Let\'s get there and see if there\'s anything to find.',26124),
(44022,'enUS','','I\'m going to stop by  to inform Tyrande and Malfurion of our progress.  I\'ll meet you at the beach as soon as I can.',26124),
(44023,'enUS','','You better head straight there, but be cautious.',26124),
(44024,'enUS','','By Elune!  They were all ambushed... betrayed...',26124),
(44025,'enUS','','The traitor helped planned this!  He helped to massacre them.',26124),
(44026,'enUS','','He was wounded.  I think I can pick up the trail.',26124),
(44027,'enUS','','This way!  Stay with me.',26124),
(44028,'enUS','','There\'s a set of fresh tracks following the forest\'s edge back towards town.  It\'s hard to tell if they\'re his though.',26124),
(44029,'enUS','','Here!  A blood stain.  We\'re going the right way.',26124),
(44030,'enUS','','Right by our guards?  Confident scum...',26124),
(44031,'enUS','','Sentinel!  Did you see a wounded night elf pass by this way?',26124),
(44032,'enUS','','Yes.  Towards the falls.  I tried to convince him to get his wounds treated, but he just ignored me.',26124),
(44033,'enUS','','Come, friend.  Quickly!',26124),
(44034,'enUS','','There!  Who is that he\'s meeting with?',26124),
(44035,'enUS','','Let\'s move!',26124),
(44036,'enUS','','...where did they go?',26124),
(44037,'enUS','','There\'s no way they could have escaped by land.  Did they...',26124),
(44038,'enUS','','I hope you know how to swim, worgen.',26124),
(44039,'enUS','','Glad you made it.',26124),
(44040,'enUS','','They\'re just up ahead.  The sound of the water should cover our approach.  Let me know when you\'re ready.',26124),
(44041,'enUS','','Let\'s finish this.',26124),
(44042,'enUS','','I\'ll take the cultist.  You handle the traitor.',26124),
(44043,'enUS','','Do NOT let him go!',26124),
(44044,'enUS','','Stop.  Let me finish him.',26124),
(44045,'enUS','','No, Lilly.  Do not kill him.',26124),
(44046,'enUS','','But... I... yes, my lady.  As you wish.',26124),
(44047,'enUS','Why, Denatharion?  I knew you when you were a boy.  You had hope in your heart.','',26124),
(44048,'enUS','Hope?  Like the hope Fandral had for bringing our people  back to glory?  Back to immortality?','',26124),
(44049,'enUS','In your jealousy, you condemn him and dispatch him to your secret prison.  Just as eagerly as you did your own brother.','',26124),
(44050,'enUS','If I cannot find a home amongst my own people, where else am I to turn, \"Shand\'do?\"','',26124),
(44051,'enUS','%s turns away, clearly disturbed.','',26124),
(44052,'enUS','','Lilly, please take the prisoner back to the sentinels so that we can deal with him properly.',26124),
(44053,'enUS','','Of course, my Lady.',26124),
(44054,'enUS','','And you, my dear worgen, you\'ve done a great thing for us this day.',26124),
(44055,'enUS','','Malfurion may not say it aloud, but he was greatly concerned for the coming of your people.',26124),
(44056,'enUS','','He knows well of your curse and of the terrible things that can come of it.  He may even hold himself to blame for it to some degree.',26124),
(44057,'enUS','','I think that today, you may have settled some of his worries.  You show nobility and control.  Perhaps more than he thought possible.',26124),
(44058,'enUS','','Thank you.  Truly.',26124),
(44059,'enUS','','Let me know when you are ready to depart this place.',26124),
(44060,'enUS','','It is good to see you again, friend.',26124),
(44061,'enUS','Bring that back up to Yancey, by the waterfall.  The ignorant human\'ll have no idea that it\'s not me.','',26124),
(44062,'enUS','Pathetic worms. Prepare to face the Mor\'ghor Slam!','',26124),
(44063,'enUS','','This is Gregory.',26124),
(44064,'enUS','At your service. ','',26124),
(44065,'enUS','','Gregory is one of our new allies from Gilneas.  It is easy to assume that he cannot be involved in this, so we\'ve decided to trust him.',26124),
(44066,'enUS','We will track this traitor down, my lady.  You\'ve no reason to worry.','',26124),
(44067,'enUS','...it looks like there was barely a struggle at all.','',26124),
(44068,'enUS','Would a sentinel have truly fallen so easy?  I thought these were fierce warriors.','',26124),
(44069,'enUS','Perhaps he took her unaware.  Perhaps he is that well trusted.','',26124),
(44070,'enUS','Keep a sharp eye out.  There must be a clue here somewhere that can help us track him down.','',26124),
(44071,'enUS','Have you found something?','',26124),
(44072,'enUS','A mud-stained leaf...','',26124),
(44073,'enUS','%s sniffs at the leaf briefly.','',26124),
(44074,'enUS','A very distinct scent.  There doesn\'t appear to be anything like it in the direct area.','',26124),
(44075,'enUS','I should be able to pick up the trail with this.  Let\'s hope it was the killer that dragged it here.','',26124),
(44076,'enUS','The trail leads to the northeast.  Follow me if you would.','',26124),
(44077,'enUS','I\'ve known nothing but Gilneas for a very long time.  I\'d feared we\'d not find a place we could call home again anytime soon.','',26124),
(44078,'enUS','Tyrande and Malfurion welcomed us in with open arms.  Almost as if we were long lost family.  It was strange and comforting.','',26124),
(44079,'enUS','I hear whispers though... whispers of confusion... perhaps even whispers of dissent.','',26124),
(44080,'enUS','I asked Malfurion of this, and he said that the city recently suffered a great tragedy.  That one of the leaders was taken away and that lives were lost.','',26124),
(44081,'enUS','He seems to know more than the whispering citizens, and he seems convinced that this traitor is the one last remnant of the cities troubles, Cataclysm aside.','',26124),
(44082,'enUS','Malfurion strikes me as both wise and honest.  I take him at his word.  I\'d welcome more answers, but it\'s not my place.','',26124),
(44083,'enUS','Enough of my ramblings.  The trail leads here.  That entire building is covered in plants with leaves like the one we found.','',26124),
(44084,'enUS','The guest rooms.  These were offered to some of my people.','',26124),
(44085,'enUS','Too general in use to tell us who is behind this.  Perhaps we\'ll find something inside.','',26124),
(44086,'enUS','You\'ve found something?','',26124),
(44087,'enUS','A map of Darkshore.  I saw this place shortly before I arrived in Rut\'theran Village.','',26124),
(44088,'enUS','There are routes traced from this Auberdine to several locations.  It almost looks like an evacuation plan.','',26124),
(44089,'enUS','The route across this western beach is circled.  Do you know your way there?','',26124),
(44090,'enUS','I promised Malfurion that I would inform him if we made any progress.  I\'ll meet you at the beach as soon as I can.','',26124),
(44091,'enUS','You better head straight there, but be cautious.','',26124),
(44092,'enUS','This was a massacre.  A planned ambush?  Who do these elementals bend to?','',26124),
(44093,'enUS','We will hunt this traitor down.  That I promise.','',26124),
(44094,'enUS','He was wounded.  I can easily pick up his trail.','',26124),
(44095,'enUS','This way!  Stay with me.','',26124),
(44096,'enUS','His trail is still fresh.  We\'re not far behind.','',26124),
(44097,'enUS','Come, friend.  Quickly!','',26124),
(44098,'enUS','There!  Who is that he\'s meeting with?','',26124),
(44099,'enUS','Let\'s move!','',26124),
(44100,'enUS','...where did they go?','',26124),
(44101,'enUS','There\'s no way they could have escaped by land.  Did they...','',26124),
(44102,'enUS','I hope you know how to swim.','',26124),
(44103,'enUS','Glad you made it.','',26124),
(44104,'enUS','They\'re just up ahead.  The sound of the water should cover our approach.  Let me know when you\'re ready.','',26124),
(44105,'enUS','Let\'s finish this.','',26124),
(44106,'enUS','I\'ll take the cultist.  You handle the traitor. ','',26124),
(44107,'enUS','No so fast, betrayer.','',26124),
(44108,'enUS','There will be no easy escape for you.  You answer to the temple.','',26124),
(44109,'enUS','','I\'m impressed Gregory.  I must admit, I had not expected such restraint.',26124),
(44110,'enUS','My people have come a long way in those regards, my lady.  I\'m sorry if I gave you any cause to doubt.','',26124),
(44111,'enUS','','Gregory, please take the prisoner back to the sentinels so that we can deal with him properly.',26124),
(44112,'enUS','Of course, my Lady.','',26124),
(44113,'enUS','','And you, my dear friend, you\'ve done a great thing for us this day.',26124),
(44114,'enUS','','It is a difficult thing for us to trust someone so new to our city.  You\'ve come upon us during a somewhat desperate time.',26124),
(44115,'enUS','','To our great fortune, you\'ve proven quite honorable and dedicated.',26124),
(44116,'enUS','It is good to see you again, friend.','',26124),
(44117,'enUS','Back so soon?','',26124),
(44118,'enUS','Yes - I need another wind rider.','Yes - I need another wind rider.',26124),
(44119,'enUS','I will not be pulled outside into your trap! Face me here, coward!','',26124),
(44120,'enUS','Be careful out there, $n.  You don\'t want to be on that ship too long... a few more cannonballs and she\'ll be sunk.','',26124),
(44121,'enUS','Rghaaaa! Face the fury of Mor\'ghor!','',26124),
(44122,'enUS','Prepare to be punished! Mor\'ghor Slam!','',26124),
(44123,'enUS','Hope for lasting relief from the shadow that has been cast on our people for so long.','',26124),
(44124,'enUS','The Verne will be arriving shortly! Get your gear and form up, boys!','',26124),
(44125,'enUS','The Verne has docked. All aboard!','',26124),
(44126,'enUS','The worgen stares and hesitates!','The worgen stares and hesitates!',26124),
(44127,'enUS','WAR IS IN MY BLOOD!','',26124),
(44128,'enUS','You brought this on yourself!','',26124),
(44129,'enUS','Shoulda just left us alone.','',26124),
(44130,'enUS','FEEL THE THUNDER!','',26124),
(44131,'enUS','You\'re nothing!','',26124),
(44132,'enUS','Your pain excites me!','',26124),
(44133,'enUS','The world\'s gone to hell, $n.','',26124),
(44134,'enUS','I remember a time when there were no orcs. Can you imagine it? No damned orcs!','',26124),
(44135,'enUS','Maybe we\'ll have peace again someday. And maybe I\'ll poop gold out my butt.','',26124),
(44136,'enUS','When this is all over I\'m gonna buy you a drink, $n.','',26124),
(44137,'enUS','If I didn\'t mention it earlier, $n, welcome to Bravo Company.','',26124),
(44138,'enUS','You\'re alright, $n. Not like those no good, money grubbing politicians in Stormwind.','',26124),
(44139,'enUS','After we clean this place up, maybe we can start rebuilding it. Maybe they\'ll give it to Bravo Company. We\'ll call it: BRAVO KEEP!','',26124),
(44140,'enUS','I don\'t like this... Feels too easy.','',26124),
(44141,'enUS','Did $n tell you about how we found Danforth, Johnny? I think the orcs may have touched him inappropriately.','',26124),
(44142,'enUS','Tired of orcs. We need to kill \'em all and let Thrall sort \'em out.','',26124),
(44143,'enUS','Anyone hear from my girl? Darcy?','',26124),
(44144,'enUS','After we\'re done here, I think I\'ll go to Ironforge. Get me a few pints of Ironforge\'s finest and some friendly dwarven wenches.','',26124),
(44145,'enUS','I have a clear shot here! Get me more ammo!','',26124),
(44146,'enUS','You heard him! Keep that gun stocked with ammo!','',26124),
(44147,'enUS','Aye, sir!','',26124),
(44148,'enUS','Now, this is what I call a target rich environment!','',26124),
(44149,'enUS','Use caution when firing those shells...','',26124),
(44150,'enUS','Neptulon\'s revenants must not consider us enemies!','',26124),
(44151,'enUS','Keep those naga away from the crater!','',26124),
(44152,'enUS','If they get a foothold in the plane of water, we\'ll never get \'em out!','',26124),
(44153,'enUS','Calculating trajectory...','',26124),
(44154,'enUS','Calibrating fuse...','',26124),
(44155,'enUS','Munitions ready!','',26124),
(44156,'enUS','Commence Fire!','',26124),
(44157,'enUS','Wahoo!','',26124),
(44158,'enUS','Where\'s the mighty Neptulon, shaman?!','',26124),
(44159,'enUS','Why are we stuck protecting his domain?','',26124),
(44160,'enUS','The lords of the elemental planes are beings of pure chaos, Nazgrim.','',26124),
(44162,'enUS','No one can discern their motives...','',26124),
(44163,'enUS','Bah! Unless he wants his home overrun by these serpents, he\'d better show himself...','',26124),
(44164,'enUS','Look at the size of those things! What ARE they?','',26124),
(44165,'enUS','The naga have enlisted the aid of the Old God\'s minions.','',26124),
(44166,'enUS','Twisted creatures bent on the destruction of all living beings.','',26124),
(44167,'enUS','Sorry I asked...','',26124),
(44168,'enUS','The elementals are grossly outnumbered.','',26124),
(44169,'enUS','They don\'t stand a chance...','',26124),
(44170,'enUS','I sense desperation in them.','',26124),
(44171,'enUS','Without aid, they will fail.','',26124),
(44172,'enUS','The Bravo Company, all present and accounted for...','',26124),
(44173,'enUS','Did you truly believe that the orcs had the presence of mind required to plan an invasion of this magnitude?','',26124),
(44174,'enUS','No matter. You will die now, a paltry offering to Deathwing as our march upon Stormwind begins.','',26124),
(44175,'enUS','Feed the master\'s rage! COME AND DIE!','',26124),
(44176,'enUS','I grow tired of these games!','',26124),
(44177,'enUS','Suffer in flames!','',26124),
(44178,'enUS','Enough of this!','',26124),
(44179,'enUS','We waste our time here just floating about...','',26124),
(44180,'enUS','If we are to defend the rift, we must do it directly!','',26124),
(44181,'enUS','Set us down next to the crater!','',26124),
(44182,'enUS','Th-there\'s no way, sir! The current... it\'s too strong! ','',26124),
(44183,'enUS','I have a clear shot here! Get me more ammo!','',26124),
(44184,'enUS','Keep moving, men! I want a steady stream of shells for these guns!','',26124),
(44185,'enUS','Aye, sir!','',26124),
(44186,'enUS','Wahoo! This is what I call a target rich environment!','',26124),
(44187,'enUS','Keep those naga away from the crater!','',26124),
(44188,'enUS','If they manage to enter the breach, we\'ll never get them out!','',26124),
(44189,'enUS','Calculating trajectory...','',26124),
(44190,'enUS','Calibrating fuse...','',26124),
(44191,'enUS','Munitions ready!','',26124),
(44192,'enUS','Commence Fire!','',26124),
(44193,'enUS','Wahoo!','',26124),
(44194,'enUS','Where is Neptulon in all of this, shaman?','',26124),
(44195,'enUS','Why does he not protect his own domain?','',26124),
(44196,'enUS','The lords of the elemental planes are beings of pure chaos, captain.','',26124),
(44197,'enUS','If he doesn\'t defend his home, he\'ll soon be without one.','',26124),
(44198,'enUS','Look at the size of those things! What ARE they?','',26124),
(44199,'enUS','Sorry I asked...','',26124),
(44200,'enUS','The elementals are clearly outnumbered.','',26124),
(44201,'enUS','They fight in vain...','',26124),
(44202,'enUS','This isn\'t helping!','',26124),
(44203,'enUS','We cannot hold off the naga this way.','',26124),
(44204,'enUS','If we are to defend the rift, we must do it directly!','',26124),
(44205,'enUS','Impossible sir! The current\'s too strong!','',26124),
(44206,'enUS','What hubrisss these fools possessss!','',26124),
(44207,'enUS','It ssshall profit them nothing, sssave it be a ssspeedy demise...','',26124),
(44208,'enUS','','Dessstroy them!',26124),
(44209,'enUS','You will die with me, Keeshan! This world has enough heroes!','',26124),
(44210,'enUS','You gutless bastard! You\'ve killed \'em all! Now I kill you!','',26124),
(44211,'enUS','','Now! Unleash the kraken!',26124),
(44212,'enUS','Aaaaaahhh...','',26124),
(44213,'enUS','','Follow me, my pets! The realm of the mighty Neptulon is ours at last!',26124),
(44214,'enUS','What now, old friend?','',26124),
(44215,'enUS','We have suffered a tragic defeat.','',26124),
(44216,'enUS','Any hope for the future of our world has grown much bleaker.','',26124),
(44217,'enUS','Thrall must be told of this day\'s events.','',26124),
(44218,'enUS','He will guide our next steps...','',26124),
(44219,'enUS','Erunak! Noooo!','',26124),
(44220,'enUS','Graaaahahhhh.','',26124),
(44221,'enUS','','That\'s... one big orc.',26124),
(44222,'enUS','','It\'s about to blow, jump on the Wyverns!',26124),
(44223,'enUS','','You were a true man of the people, Liam.  Unlike any Royal I ever met.  We\'ll make them pay for this.',26124),
(44224,'enUS','Die, worm!','',26124),
(44225,'enUS','Well, shaman, what now?','',26124),
(44226,'enUS','Erunak! Behind you!','',26124),
(44227,'enUS','What dis...?','',26124),
(44228,'enUS','No! Ahhhhh.....','',26124),
(44229,'enUS','Gah... heeelp!','',26124),
(44230,'enUS','Ahhhhh!','',26124),
(44231,'enUS','Nooooo!','',26124),
(44232,'enUS','','We must hold off the enemy for just a while longer.  In mere moments, Cenarius will walk among us.',26124),
(44233,'enUS','','Hurry - she is breaking free!',26124),
(44234,'enUS','Hold the line!','',26124),
(44235,'enUS','Push them back!','',26124),
(44236,'enUS','I\'d rather be brewin\' than fightin\'!$B$BBut with any luck, I can manage both, eh?','',26124),
(44237,'enUS','Let us go to Hyjal while we can still make a difference!','',26124),
(44238,'enUS','Dat not good.','',26124),
(44239,'enUS','','The blessing of the land be with you.',26124),
(44240,'enUS','Deepholm is the realm of earth.  It is here that Deathwing retreated when he was first defeated.','',26124),
(44241,'enUS','His followers helped him regain his strength inside this very temple.  Plates of powerful elementium were grafted onto his skin.','',26124),
(44242,'enUS','Deathwing\'s return to Azeroth caused a major rift within the two worlds.  This breach is the force largely behind the cataclysm that threatens to destroy our lands.','',26124),
(44243,'enUS','Thrall is using all of his power to stabilize the rift from Azeroth\'s side.  We are doing what we can to stabilize it here as well.','',26124),
(44244,'enUS','Deathwing\'s escape didn\'t just damage our world.  A powerful stone created by the Titans used to be in this room before the breach shattered it.  It was known as the World Pillar.','',26124),
(44245,'enUS','It was not merely a name, for the World Pillar supported more than just the weight of this temple.  It must be rebuilt or all of Deepholm will collapse into Azeroth, with disastrous consequences for both worlds.','',26124),
(44246,'enUS','Three fragments were lost after the World Pillar shattered.  We must recover them or else the fate of our world is doomed.','',26124),
(44247,'enUS','We have to keep those fungal terrors off of the front. They\'re too powerful!','',26124),
(44248,'enUS','My father is close, I know it! We have to bust through their defenses and rescue him!','',26124),
(44249,'enUS','Cho\'gall begins casting Flaming Pillar of Certain Doom!','',26124),
(44250,'enUS','Set us down as close to the crater as possible!','',26124),
(44251,'enUS','','Shandris raises her bow to the stars!',26124),
(44252,'enUS','Burn! Burn, you wretches!','',26124),
(44253,'enUS','','Elune, guide my arrows!',26124),
(44254,'enUS','If you want to hire a gryphon, you\'ve come to the right place.','',26124),
(44255,'enUS','','Your reign has come to an end, oh Lord of the Waves! ',26124),
(44256,'enUS','','Sssoon, your preciousss throne will lie in ruins!',26124),
(44257,'enUS','','Your tentacled head, a mere trophy for my queen...',26124),
(44258,'enUS','You are in my realm now, serpent!','',26124),
(44259,'enUS','Did you think me unprepared for such an assault?','',26124),
(44260,'enUS','The method of your cleansing lies within your grasp...','',26124),
(44261,'enUS','...yet forever out of your reach.','',26124),
(44262,'enUS','','Scour this place, my legions! Find the Tidehunter\'s trap!',26124),
(44263,'enUS','Ahh - my fearless assistants, I assume.','',26124),
(44264,'enUS','You may yet regret your presence here.','',26124),
(44265,'enUS','As I purify these waters, the servants of filth will surely be stirred. Beware!','',26124),
(44266,'enUS','Augh... Their filthiness stains me!','',26124),
(44267,'enUS','I grow... weary...','',26124),
(44268,'enUS','Fools! Make yourselves useful...','',26124),
(44269,'enUS','Patience, guests. The waters are nearly cleansed.','',26124),
(44270,'enUS','The beast has returned! It must not pollute my waters!','',26124),
(44271,'enUS','Behold the power of pure water!','',26124),
(44272,'enUS','My waters are cleansed! Drink in their power!','',26124),
(44273,'enUS','Your kind... cannot be... trusted.','',26124),
(44274,'enUS','You are unworthy of my domain...','',26124),
(44275,'enUS','My attention... was wasted on you...','',26124),
(44276,'enUS','My realm has at last been cleansed of the vile filth.','',26124),
(44277,'enUS','You are free to take your leave.','',26124),
(44278,'enUS','','Thank you!  I don\'t know how much longer we would have survived.',26124),
(44279,'enUS','','That cage was stifling my magic.',26124),
(44280,'enUS','','If you don\'t mind, I\'m going to teleport us back to the Rebel Camp.  We\'ll thank you in person later.',26124),
(44281,'enUS','','Mor\'ghor! You should\'ve stayed in Outland with the rest of your half-demon scum. There\'s no place for you here.',26124),
(44282,'enUS','Woo hoo.','',26124),
(44283,'enUS','Freedom!  Sweet, sweet freedom!','',26124),
(44284,'enUS','','A piercing warcry echos through the maul!',26124),
(44285,'enUS','','He\'s too strong! Retreat!',26124),
(44286,'enUS','','Wherever the Horde takes us, we will keep our heads high and our blood pure. Good riddance, Mor\'ghor. A new Dragonmaw dawns this day.',26124),
(44287,'enUS','Zaela ... traitorous fool ... have you sold your soul to the Horde? Are you and I so different? Cast your lot with Hellscream, then. See where he takes you.','',26124),
(44288,'enUS','It\'s working. Hold him still, Jitters.','',26124),
(44289,'enUS','I... I can\'t...','',26124),
(44290,'enUS','Damn it, Jitters, I said HOLD!','',26124),
(44291,'enUS','Jitters...','',26124),
(44292,'enUS','JITTERS!','',26124),
(44293,'enUS','I remember now... it\'s all your fault!','',26124),
(44294,'enUS','You brought the worgen to Duskwood! You led the Dark Riders to my farm, and hid while they murdered my family!','',26124),
(44295,'enUS','Every speck of suffering in my life is YOUR PATHETIC FAULT! I SHOULD KILL YOU!','',26124),
(44296,'enUS','Letting him go is the only thing that\'s going to separate you from the beasts now, my friend.','',26124),
(44297,'enUS','You\'ve got a lot to make up for, Jitters. I won\'t give you the easy way out.','',26124),
(44298,'enUS','','I\'ll show you true power!',26124),
(44299,'enUS','','Orhan focuses her might!',26124),
(44300,'enUS','Here we go...','',26124),
(44301,'enUS','','Welcome to Dolanaar, $c. Let me know if you need any recipes or basic cooking ingredients.',26124),
(44302,'enUS','Alright, we just add this in here...','',26124),
(44303,'enUS','Centrifugate...','',26124),
(44304,'enUS','Bingo!  Look at this!','',26124),
(44305,'enUS','The Stone Dragon Broodmother bows her head in surrender.','',26124),
(44306,'enUS','','I hope you weren\'t looking for something to eat, $c.',26124),
(44307,'enUS','Enough of this foolishness!','',26124),
(44308,'enUS','We will handle them!','',26124),
(44309,'enUS','','Hello again.',26124),
(44310,'enUS','','You rang?',26124),
(44311,'enUS','','Need something?',26124),
(44312,'enUS','The Stone Dragon Broodmother approaches.','',26124),
(44313,'enUS','$n! The Warchief is alive - he was rescued off the coast. Come outside, quickly. The town is ours!','',26124),
(44314,'enUS','','Hellscream, I am Zaela of the Dragonmaw. Your people have freed mine from tyranny. We are your instrument. The strength of the Dragonmaw is yours to command. For the Horde!',26124),
(44315,'enUS','Speak with Terrath the Steady when you are ready to begin.','',26124),
(44316,'enUS','Yes, I live! No Twilight Dragon can keep this orc down.','',26124),
(44317,'enUS','Ahh, there she is. The battle-maiden of the Dragonmaw. Let me see your face.','',26124),
(44318,'enUS','Blood and honor, hero. The Horde welcomes you. Your people will be put to the test as we obliterate Twilight\'s Hammer and lay claim to this distant shore. But first... some unfinished business.','',26124),
(44319,'enUS','Come and face me! *snort* I can smell your $r stench from here.','',26124),
(44320,'enUS','An impressive display...','',26124),
(44321,'enUS','...to have made it this far.','',26124),
(44322,'enUS','But now, witness true power...','',26124),
(44323,'enUS','...the fury of the elements!','',26124),
(44324,'enUS','$n? It\'s about time you got here. What kept you? My father\'s life is in jeopardy!','',26124),
(44325,'enUS','','I made it!  I need to get Mr. Oinky to watch my back while I\'m out adventuring.',26124),
(44326,'enUS','Do something.','',26124),
(44327,'enUS','','Hey there, I\'d like to get my pet, Mr. Oinky out please!',26124),
(44328,'enUS','','Mr. Oinky!  Poor, poor Mr. Oinky...  ',26124),
(44329,'enUS','','Mr. Oinky!! Come back to me Mr. Oinky!',26124),
(44330,'enUS','Mr. Oinky... Yeah... Well...','',26124),
(44331,'enUS','Right... He ran away!  He\'s a big, juicy guy and he just got away from us here.  I\'m sorry miss.','',26124),
(44332,'enUS','Vernon looks around nervously, making sure to not look at the pig on the spit.','',26124),
(44333,'enUS','','Lok\'tar ogar! This young $r $c has conquered the great Echeyakee. Let $ghis:her; actions show the might of the new Horde!',26124),
(44334,'enUS','%s has been subdued.','%s has been subdued.',26124),
(44335,'enUS','The Battle for Gilneas','The Battle for Gilneas',26124),
(44336,'enUS','BEHOLD YOUR DOOM!','',26124),
(44337,'enUS','Eradicate....','',26124),
(44338,'enUS','Annihilate....','',26124),
(44339,'enUS','Impossible....','',26124),
(44340,'enUS','You are not yet strong enough to enter The Battle for Gilneas. Return when you have gained more experience.','You are not yet strong enough to enter The Battle for Gilneas. Return when you have gained more experience.',26124),
(44341,'enUS','Ahh, the jungle.  It\'s good to get out of town every once in a while, you know?','',26124),
(44342,'enUS','You are not yet strong enough to do battle in Twin Peaks. Return when you have gained more experience.','You are not yet strong enough to do battle in Twin Peaks. Return when you have gained more experience.',26124),
(44343,'enUS','Twin Peaks','Twin Peaks',26124),
(44344,'enUS','','What hubrisss these fools possessss!',26124),
(44345,'enUS','','It ssshall profit them nothing, sssave it be a ssspeedy demise...',26124),
(44346,'enUS','','Dessstroy them!',26124),
(44347,'enUS','','Then this starts happening...',26124),
(44348,'enUS','%s goes into a berserker rage upon seeing Runty\'s lifeless body!','%s goes into a berserker rage upon seeing Runty\'s lifeless body!',26124),
(44349,'enUS','Runty\'s death sends %s into a berserker rage!','Runty\'s death sends %s into a berserker rage!',26124),
(44350,'enUS','$n, you\'re going to want to fly over these giants and stone troggs. Don\'t try to ride through them.','',26124),
(44352,'enUS','Slay stone troggs.','',26124),
(44353,'enUS','Destroy.','',26124),
(44354,'enUS','Reactivated.','',26124),
(44356,'enUS','The great Rastakhan sends his greetings to you, member of the Alliance.','',26124),
(44357,'enUS','The orcs of Stonetalon will suffer your rampage no more, foul beast.','',26124),
(44358,'enUS','This is MY WAGON!\n\nMINE!','',26124),
(44359,'enUS','First one to move gets a lightning bolt to the head!','First one to move gets a lightning bolt to the head!',26124),
(44360,'enUS','Keep those hands where we can see them!','First one to move gets a lightning bolt to the head!',26124),
(44361,'enUS','Do as you\'re told and no one gets hurt!','Do as you\'re told and no one gets hurt!',26124),
(44362,'enUS','You disgrace the elements.  Don\'t give us an excuse to end your pathetic lives!','You disgrace the elements.  Don\'t give us an excuse to end your pathetic lives!',26124),
(44363,'enUS','Your Lord will feel every moment of the pain you are about to endure.','',26124),
(44364,'enUS','You\'ll never catch me alive!','',26124),
(44365,'enUS','To hell with this, I\'m running for it!','',26124),
(44366,'enUS','The faithful shall serve by HIS side!  Aiiiiigh!!!','',26124),
(44367,'enUS','No prison can hold me!!','',26124),
(44368,'enUS','You\'re $n, right? Gazlowe told me to take ya up the river! Hop in when you\'re ready to go.','',26124),
(44369,'enUS','Here we go again...','',26124),
(44370,'enUS','Not another one...','',26124),
(44371,'enUS','I got this one...','',26124),
(44372,'enUS','He\'s not going anywhere.','',26124),
(44373,'enUS','No one\'s allowed to leave. Prince Liam\'s orders.','',26124),
(44374,'enUS','It isn\'t safe to leave, there\'s something lurking out there in the woods.','',26124),
(44375,'enUS','Stay calm. We have everything under control.','',26124),
(44376,'enUS','','Step on through, $n!',26124),
(44377,'enUS','You can\'t do this to us!','You can\'t do this to us!',26124),
(44378,'enUS','My children are in Stormglen alone! I have to get to them!','My children are in Stormglen alone! I have to get to them!',26124),
(44379,'enUS','What\'s going on? I thought I saw something on the rooftops.','What\'s going on? I thought I saw something on the rooftops.',26124),
(44380,'enUS','Ey mon, what you need?','',26124),
(44381,'enUS','Skeezy says he already paid for my flight to Hardwrench Hideaway.  I\'m ready to depart.','Skeezy says he already paid for my flight to Hardwrench Hideaway.  I\'m ready to depart.',26124),
(44382,'enUS','Keep your eyes open, $c. Even Durotar is not safe from our enemies.','',26124),
(44383,'enUS','Yes, $n?','',26124),
(44384,'enUS','Wulfred says that he paid for my trip to the Explorers\' League Digsite.  I\'m ready to depart.','Wulfred says that he paid for my trip to the Explorers\' League Digsite.  I\'m ready to depart.',26124),
(44385,'enUS','The Explorers\' League exists to uncover the hidden secrets within this world.  While the cataclysm was devastating for most, for us, it provided access to untold troves of information and wealth.','',26124),
(44386,'enUS','Whew, that was a bit of a tight squeeze, but the rest of the trip should be a breeze.','',26124),
(44387,'enUS','There\'s nothing quite like the smell of Durotar on a warm, comfortable boat ride.','',26124),
(44388,'enUS','This is where you\'d expect something to go wrong on a beautiful trip like this.','',26124),
(44389,'enUS','Everyone always says, \"Horton, why do you drive a boat up and down the river?\" I ask them, \"Why don\'t you?\"  ... that\'s usually where I run out of witty retorts.','',26124),
(44390,'enUS','We\'re pulling up near your stop. Head due west along the road to reach Nozzlepot\'s Outpost.','',26124),
(44391,'enUS','Why are the gates closed?','Why are the gates closed?',26124),
(44392,'enUS','Did you hear that?','Did you hear that?',26124),
(44393,'enUS','We have to get out of here! The howling gets louder every night.','We have to get out of here! The howling gets louder every night.',26124),
(44394,'enUS','They told us Gilneas City was safe...','They told us Gilneas City was safe...',26124),
(44395,'enUS','Stay here with the others and don\'t try anything funny.','Stay here with the others and don\'t try anything funny.',26124),
(44396,'enUS','Don\'t let them break the line!','',26124),
(44397,'enUS','For Stormglen! For Gilneas!','',26124),
(44398,'enUS','Die, foul beast!','',26124),
(44399,'enUS','snarls at Stormglen Defender.','',26124),
(44400,'enUS','I train only warriors, $c. You\'ll have to look elsewhere.','I train only warriors, $c. You\'ll have to look elsewhere.',26124),
(44401,'enUS','Are you ready to train, warrior?','Are you ready to train, warrior?',26124),
(44402,'enUS','It\'s good to see you made it through, $n. ','',26124),
(44403,'enUS','Show me today\'s selection of pies.','Show me today\'s selection of pies.',26124),
(44404,'enUS','Why pie over cake?','Why pie over cake?',26124),
(44405,'enUS','Pie is far better than cake. Everyone knows that! Shouldn\'t a $c of your standing be well-informed about such important matters?','',26124),
(44406,'enUS','I\'ll keep that in mind.','I\'ll keep that in mind.',26124),
(44407,'enUS','Hear anything interesting, $n? Your little revelation about me is about to cost you your life.','',26124),
(44408,'enUS','Pathetic. The Horde grows weaker by the day...','',26124),
(44409,'enUS','The Twilight\'s Hammer has agents everywhere! Kill me and a dozen take my place!','',26124),
(44410,'enUS','My powers of sight... I beheld the future... I have seen what is to come...','',26124),
(44411,'enUS','This world unravels. If you could see the horrors I have seen... ','',26124),
(44412,'enUS','To serve is madness, but defiance ... impossible!','',26124),
(44413,'enUS','','We will defeat the Twilight\'s Hammer wherever they may hide.  Not even the elemental planes will be a safe haven for their kind.',26124),
(44414,'enUS','You should have your pet wait for you here. Beware the Blackrock Worg Captain! |TInterface\\Icons\\SPELL_NATURE_TIMESTOP.BLP:24|t','',26124),
(44415,'enUS','Don\'t forget to command your pet to follow you! |TInterface\\Icons\\ABILITY_TRACKING.BLP:24|t','',26124),
(44416,'enUS','When Deathwing destroyed the World Pillar, he broke open a rift between your world and ours. These spores and fungi are one consequence.$B$BLet\'s see if we can deal with them together.','',26124),
(44417,'enUS','Don\'t forget to grab a war guardian, $n.','',26124),
(44418,'enUS','Bravo Company Field Kit ACTIVE. New abilities are now available on your action bar.$BToggle Bravo Company Field Kit to DEACTIVATE.','Bravo Company Field Kit ACTIVE. New abilities are now available on your action bar.$BToggle Bravo Company Field Kit to DEACTIVATE.',26124),
(44419,'enUS','Bravo Company Field Kit ACTIVE. Plant Seaforium is now available on your action bar.$BToggle Bravo Company Field Kit to DEACTIVATE.','Bravo Company Field Kit ACTIVE. Plant Seaforium is now available on your action bar.$BToggle Bravo Company Field Kit to DEACTIVATE.',26124),
(44420,'enUS','','Hey, $n!',26124),
(44421,'enUS','Bouldergut, you coward! Fight someone your own size!','',26124),
(44422,'enUS','Let me out of these chains! I\'ll reduce you to rubble!','',26124),
(44423,'enUS','Flint! Get out of here! He\'s too powerful!','',26124),
(44424,'enUS','Damned stinking stone trogg! You\'ll never get the World Pillar fragment!','',26124),
(44425,'enUS','You\'re too late, Bouldergut. The proverbial cavalry has arrived!','',26124),
(44426,'enUS','','Hello, $c.  Care to purchase something?',26124),
(44427,'enUS','Nothing in all of the elemental planes will stop me from killing you once I get out of these chains, Bouldergut!','',26124),
(44428,'enUS','Free me now before it\'s too late! Deepholm cannot survive much longer without the World Pillar intact!','',26124),
(44429,'enUS','You don\'t know what you\'re doing, Bouldergut! By keeping me captive, you\'re dooming Deepholm and us all!','',26124),
(44430,'enUS','$n! You\'re a sight for sore eyes. Get over here and give me a hand, would you?','',26124),
(44431,'enUS','We just mix these two together...','',26124),
(44432,'enUS','...give a little swirl...','',26124),
(44433,'enUS','...alchemy, alchemy, alchemy...','',26124),
(44434,'enUS','...and, we put the potion on the sample...','',26124),
(44435,'enUS','There we go.  The substance that you have brought me is approximately... 150,000 years old?  What!?  I\'m going to need to run another test.','',26124),
(44436,'enUS','','The Gurubashi are dead, and Hakkar with them.  Most of my fellow Zandalar have returned to their homeland.$b$bIt falls on me, Chabal, and the Darkspears of Bambala to watch over Zul\'Gurub now.',26124),
(44437,'enUS','Maywiki, I was hunting Zanzil and I lost track of what I was doing.  Can you remind me where to go next?','Maywiki, I was hunting Zanzil and I lost track of what I was doing.  Can you remind me where to go next?',26124),
(44438,'enUS','This ancient totem is fashioned into the shape of a bat.  It must be the totem that Maywiki spoke of.','',26124),
(44439,'enUS','Titan artifacts are largely inert.  Something like Zanzil\'s mixture should have no effect whatsoever.  Let\'s try it out!','',26124),
(44440,'enUS','That was... unexpected.','',26124),
(44441,'enUS','Oh, hey $n.','',26124),
(44442,'enUS','You\'ve saved both myself and my son.','',26124),
(44443,'enUS','You have my gratitude and that of my people.','',26124),
(44444,'enUS','Return to Pyrium Lodestone with the good news. We\'ll see you back at Stonehearth shortly.','',26124),
(44445,'enUS','This hero represents the Earthen Ring. They need the middle fragment.','',26124),
(44446,'enUS','Hey!  What are you doing down there?','',26124),
(44447,'enUS','Quick, grab onto the ladder!  That troll doesn\'t look too friendly!','',26124),
(44448,'enUS','The prince has run off. This is bad!','',26124),
(44449,'enUS','Zub zub.$B$BWhat? Go away.','',26124),
(44450,'enUS','Zub zub.$B$BWhat? Two zubs not good \'nuff for you, $c?','',26124),
(44451,'enUS','Why ask me? I know nothing of the Twilight\'s Hammer.','',26124),
(44452,'enUS','<The peon sweats and twitches.>$B$BI was ... what I meant ... um, bad!','',26124),
(44453,'enUS','<The peon\'s eyes widen in terror.>$B$BNo! You\'ve discovered Sauranok is the new cult leader in Orgrimmar? He told me his secret is safe!\n','',26124),
(44454,'enUS','Wait, uh - you put words in my mouth! Not fair!','',26124),
(44455,'enUS','Has a secret cult infiltrated the Orgrimmar skyway?','Has a secret cult infiltrated the Orgrimmar skyway?',26124),
(44456,'enUS','I didn\'t say Twilight\'s Hammer. YOU said Twilight\'s Hammer.','I didn\'t say Twilight\'s Hammer. YOU said Twilight\'s Hammer.',26124),
(44457,'enUS','I know all about your cult master.','I know all about your cult master.',26124),
(44458,'enUS','So it\'s true? Sauranok IS guilty of treason!','So it\'s true? Sauranok IS guilty of treason!',26124),
(44459,'enUS','Silence, idiot.','',26124),
(44460,'enUS','Zub zub!','',26124),
(44461,'enUS','Orgrimmar is stronger than ever!','',26124),
(44462,'enUS','Can I help?','',26124),
(44463,'enUS','Hello, $c!$B$BOrgrimmar\'s skyway is the center of the world. The north zeppelin tower will take you to Stranglethorn or Undercity. The south tower wll take you to Thunderbluff or all the way to Northrend.$B$BFlight Master Doras can send you all over Kalimdor - at least, anyplace you\'ve already explored.','',26124),
(44464,'enUS','Cult? I don\'t know. Seen some suspicious types lingering around the south zeppelin tower, though.','',26124),
(44465,'enUS','I don\'t know nothing! Ask the others.','',26124),
(44466,'enUS','Secret cult? Is that who I see having meetings at the base of the south zeppelin tower?','',26124),
(44467,'enUS','Secret cult? You\'re not with those creepy orcs who lurk around the south zeppelin tower, are you?','',26124),
(44468,'enUS','I\'m too dumb to be in a cult. Been that way since I felled off the back of the zeppelin. And hit them propellors. Landed on a rock. They fixed my head up with a metal bowl to make it round and hard.$B$B<He thunks his fist against his skull.>$B$BThen the lightning done come.','',26124),
(44469,'enUS','I hear strange orcs whispering all the time inside the south zeppelin tower. They always shut up whenever I get near.','',26124),
(44470,'enUS','I don\'t know.$B$BDon\'t hit me!','',26124),
(44471,'enUS','Dig faster! Faster! No stop!','',26124),
(44472,'enUS','Dig! Rock-mans! For everlasting peace!','',26124),
(44473,'enUS','Nasty rock-mans! Do as we say!','',26124),
(44474,'enUS','Dig ore! Rock-mans dig ore now!','',26124),
(44475,'enUS','Rock-mans so lazy! Why rock-mans so lazy?!','',26124),
(44476,'enUS','Rock-mans dig or kobold hit more!','',26124),
(44477,'enUS','','I\'m sorry, but I can\'t offer you training.',26124),
(44478,'enUS','','Choosing the path of a mage is to choose a path of great difficulty. Many do not understand us. Our own people struggle to accept our arts.',26124),
(44479,'enUS','Father! Let me get you free of those chains.','',26124),
(44480,'enUS','','Are you here to help Ironforge, or just gawk at me all day?',26124),
(44481,'enUS','Leaping Leper Gnomes! You\'re a sight for sore eyes. I was worried the giant magma worm out front would deter visitors. Now that you\'re here you can give me a hand.','',26124),
(44482,'enUS','I suppose you\'ll be needing a key for this cage? Wait, don\'t tell me. The horrific gibbering monster behind me ate it, right?','I suppose you\'ll be needing a key for this cage? Wait, don\'t tell me. The horrific gibbering monster behind me ate it, right?',26124),
(44483,'enUS','You have my undying gratitude and that of my people, $n.','',26124),
(44484,'enUS','|TInterface\\Icons\\ability_rogue_shadowdance.blp:20|t%s begins to summon |cFFFF0000Corrupted Adherents|r to aid him!\n','',26124),
(44485,'enUS','$C, over here.','',26124),
(44486,'enUS','The middle fragment of the World Pillar has been dug up and is missing!','',26124),
(44487,'enUS','I can offer you a free bunk if you\'d like to rest.  They\'re not comfortable, but it doesn\'t look like you get much sleep anyway. ','I can offer you a free bunk if you\'d like to rest.  They\'re not comfortable, but it doesn\'t look like you get much sleep anyway. ',26124),
(44488,'enUS','On my way down here from Dun Algaz I saw a gnoll hunting Threshadons in the middle of a lake.  If you\'ve never seen a dog try to use a spear, you\'re in for a treat!','',26124),
(44489,'enUS','They say that the raptor matriarch lives deep within Raptor Ridge, protecting her clutch of eggs.','',26124),
(44490,'enUS','I was up at Whelgar\'s a few days ago attempting to...er...liberate...some titan relics from the bones of the dead raptors, and I saw him!  Sarltooth lives!  \n\nWell, he\'s undead, so I guess he doesn\'t live, but he exists.  Sarltooth exists!','',26124),
(44491,'enUS','The Dragonmaw are attempting to push out of the Angerfang Encampment and are already raiding the caravan to the east.  They\'ve called in two powerful warriors who are leading the charge.  If you\'re up for a challenge, you might find them at the Encampment, planning and strategizing and doing other evil, Orcish things.','',26124),
(44492,'enUS','Slate, did the Axe of Earthly Sundering return to you?','Slate, did the Axe of Earthly Sundering return to you?',26124),
(44493,'enUS','Yes, it did. Try to be more careful.$B$BWe wouldn\'t want to lose the king\'s axe!','',26124),
(44494,'enUS','I cannot help you with your training. Seek out a $c trainer.','I cannot help you with your training. Seek out a $c trainer.',26124),
(44495,'enUS','Are you here to train, hunter?','Are you here to train, hunter?',26124),
(44496,'enUS','Lok\'tar! We need your help!','',26124),
(44497,'enUS','With your strength, murlocs, our plan will succeed. Our kobold friends will mine us plenty of ore...','',26124),
(44498,'enUS','And, armed with gnoll-forged weapons of indestructible copper, you murlocs will be unstoppable!','',26124),
(44499,'enUS','What was that? And what the heck is that smell?','',26124),
(44500,'enUS','...why are you looking at me like that?','',26124),
(44501,'enUS','You\'ll regret this! This is your only chance, you fishy fools!','',26124),
(44502,'enUS','AAAAAAGH! CURSE YOUR SUDDEN YET INEVITABLE BETRAYAL!','',26124),
(44503,'enUS','EEEEEEEEEEE! RUN AWAY!','',26124),
(44504,'enUS','*sniff sniff*','',26124),
(44505,'enUS','Rrglrglrglrglrgl.','',26124),
(44506,'enUS','Rrglrglrglrglrgl!','',26124),
(44507,'enUS','RRGLRGLRGLRGLRLR!!','',26124),
(44508,'enUS','Archaeology is the search for fact. Not truth.','',26124),
(44509,'enUS','If it\'s truth you\'re interested in, Cuddy Nordlinger\'s Philosophy class is right down the hall.','',26124),
(44510,'enUS','So forget any ideas you\'ve got about lost cities, exotic travel, and digging up the world.','',26124),
(44511,'enUS','You do not follow maps to buried treasure and \"X\" never, ever, marks the spot.','',26124),
(44512,'enUS','Seventy percent of all archaeology is done in the library. Research. Reading.','',26124),
(44513,'enUS','We cannot afford to take mythology at face value.','',26124),
(44514,'enUS','Ahem! Well... ah, next week: \"Tanaris.\" Starting with the excavation of Broken Pillar by Marvon Rivetseeker in Year 22.','',26124),
(44515,'enUS','I will be here doing research if anybody\'s got any problems for the next hour and a half.','',26124),
(44516,'enUS','','%s flutters her eyelashes at Harrison Jones.',26124),
(44517,'enUS','L\'ghorek, can you give me another Attuned Runestone of Binding?','L\'ghorek, can you give me another Attuned Runestone of Binding?',26124),
(44518,'enUS','TRY NOT TO... LOSE... THAT ONE.','',26124),
(44519,'enUS','','%s laughs.',26124),
(44520,'enUS','Are you here to train in Archaeology?','Are you here to train in Archaeology?',26124),
(44521,'enUS','','I just love these wisps! They\'re so pretty!',26124),
(44522,'enUS','','Quiet, Issara. Your chatter is going to get us killed.',26124),
(44523,'enUS','','Invaders have breached the sanctum halls!',26124),
(44524,'enUS','','Wake up you fools! We\'re under attack!',26124),
(44525,'enUS','','Welcome to Nethergarde, $c.  Call me \"Mama,\" I\'m here to take care of you.',26124),
(44526,'enUS','Arch Geomancer, I am ready for the ritual.','Arch Geomancer, I am ready for the ritual.',26124),
(44527,'enUS','','In death, we are reborn.',26124),
(44528,'enUS','Abyssion is casting a powerful Shadow Nova, seek cover!','',26124),
(44529,'enUS','The First World Pillar Fragment drops from Abyssion\'s lifeless corpse!','',26124),
(44530,'enUS','Abyssion is snared!  Stay on the move to avoid his attacks.','',26124),
(44531,'enUS','Do me know you? No matter. Me crush your bones!','',26124),
(44532,'enUS','NOOOOOOOOOoooooo....... not again!','',26124),
(44533,'enUS','You must stay within the Talrendis Point attack area!','',26124),
(44534,'enUS','Please! Free the others from their Nets!','',26124),
(44535,'enUS','Once we are all free, we shall fly with you through Grim Batol!','',26124),
(44536,'enUS','The mutant goblin\'s tentacles break free and slither across the ground!','',26124),
(44537,'enUS','Ya\'ll need to find a different trainer, $c. I cannot help ya.','',26124),
(44538,'enUS','Return any time ya need trainin\'.','',26124),
(44539,'enUS','Zoram\'gar will be a new bastion of power against our enemies under my watch.$B$BGlory to the Horde! ','',26124),
(44540,'enUS','','It\'s an honor to have a hero like you among us, $n.',26124),
(44541,'enUS','No, no, no... you took my family, but you won\'t take my land!','',26124),
(44542,'enUS','Get back, $r!','',26124),
(44543,'enUS','Why won\'t you leave us alone?','',26124),
(44544,'enUS','Get out of my kitchen!','',26124),
(44545,'enUS','I must have lived a charmed life, $n.  To return to the world as a member of the Forsaken and the Apothecary Society... I couldn\'t have asked for a more suitable fate.','',26124),
(44546,'enUS','Let...me...go...','',26124),
(44547,'enUS','You only...prolong...your doom...','',26124),
(44548,'enUS','You...will...burn...','',26124),
(44549,'enUS','Chaos...','',26124),
(44550,'enUS','Your efforts...are futile...','',26124),
(44551,'enUS','','The druids and sentinels prefer to keep separate company, but we have always worked well together.$B$BNever mistake privacy for aversion.',26124),
(44552,'enUS','','A beautiful city, is it not? As was Gilneas, in its time.$B$BBut such things pass, as shall we.  Only the earth and her secrets will remain.$B$BAre you willing to learn, $n?',26124),
(44553,'enUS','Now THAT\'s what I call oomph!  I wish all our potions did this!','',26124),
(44554,'enUS','Climb the guard towers!','',26124),
(44555,'enUS','Use the Accursed Ore to direct artillery fire!','',26124),
(44556,'enUS','The Quilboar here are too dangerous to get riled up over outside conflicts, $r. I cannot ward them off forever.$B$BWe must put a stop to their transgressions against nature.','',26124),
(44557,'enUS','Looks like you brought the whole fleet with you, $n!  And a pack of angry Brashtide to boot!$b$bI hope you\'re battle-ready, because these guys sure came packin\'.','',26124),
(44558,'enUS','I\'m getting too old for this!  There\'s too many of them!$b$b<Fleet Master Seahorn pauses to catch his breath.>$b$bWhat am I saying?  There\'s not enough of them!  HAVE AT YOU, YOU MANGY CURS!','',26124),
(44559,'enUS','Aaaa-oooo! Aaaa-ooo! A pirate\'s life fer me.','',26124),
(44560,'enUS','We pillage, we plunder, we steal sheep and fight, wolf out, me \'earties, aaa-ooo!','',26124),
(44561,'enUS','We kidnap and ravage and rage by moonlight, drink up me \'earties, aaaa-ooo!','',26124),
(44562,'enUS','We\'re alphas, we\'re playas, we\'re straight from Gilneas, wolf out, me \'earties, aaaa-ooo!','',26124),
(44563,'enUS','We\'ll take Booty Bay or Firallon\'ll spay us, howl out, me \'earties, aaaa-ooo!','',26124),
(44564,'enUS','We\'re mangy, we\'re matted, we\'re worgen and how, wolf out, me \'earties, aaaa-ooo!','',26124),
(44565,'enUS','We sniff \'em an\' mark \'em and rip \'em to chow, sing out, me \'earties: aaaa-ooo!','',26124),
(44566,'enUS','What? Of course not! I could easily escape this simple contraption, but I\'m much too busy. See, a while back I spent a few months inside the belly of a beast...','',26124),
(44567,'enUS','You were trapped, as I recall. This situation seems oddly similar.','You were trapped, as I recall. This situation seems oddly similar.',26124),
(44568,'enUS','It wasn\'t strictly voluntary, but I discovered something truly incredible. The beast seemed to be able to consume almost anything with no ill effects.','',26124),
(44569,'enUS','Gnomes in Lava Suits, for example.','Gnomes in Lava Suits, for example.',26124),
(44570,'enUS','As a final act of revenge, Baron Geddon has made you a living bomb!  Move away from your allies!','',26124),
(44571,'enUS','','That pygmy helm should fool them, at least for a little while. Get back to town!',26124),
(44572,'enUS','Exactly. I ran some tests on the residual digestive fluid coating my suit and...\n\n<Finkle trails off>\n\nSay, you haven\'t seen my skinning knife anywhere, have you? I seem to have misplaced it.','',26124),
(44573,'enUS','No. I, uh, haven\'t seen it. You were saying?','No. I, uh, haven\'t seen it. You were saying?',26124),
(44574,'enUS','Oh yes, the bile; it\'s amazing stuff. With the proper catalysts it renders anything to which it\'s applied practically immortal*. I\'ve been harvesting it with my reprogrammed Bile-O-Tron 800 and I\'m certain I\'ve got the mixture right this time. I just need a few volunteers to test it out against a suitable creature. What do you say, friend?\n\n*Immortality subject to certain restrictions.','',26124),
(44575,'enUS','','Begone. I have neither the ability nor the inclination to instruct you.',26124),
(44576,'enUS','','I will help you learn to wield the powers our enemies would deny us.',26124),
(44577,'enUS','Restrictions? What restrictions?','Restrictions? What restrictions?',26124),
(44578,'enUS','This is terrible, Durak! Saurfang will have nothing to do with you! What can we do?!','This is terrible, Durak! Saurfang will have nothing to do with you! What can we do?!',26124),
(44579,'enUS','Saurfang\'s involved, you say?','',26124),
(44580,'enUS','Well then there is only one thing left to be done...','',26124),
(44581,'enUS','They keep coming!  Push them back!  We must make sure we save as many Gilneans as possible!','',26124),
(44582,'enUS','This is all happening sooner than I would have liked.','',26124),
(44583,'enUS','I need a horse to rescue Krennan.','I need a horse to rescue Krennan.',26124),
(44584,'enUS','I am afraid that you, $n, have outgrown your usefulness...','',26124),
(44585,'enUS','Oops! That lever activates the Bile-O-Tron. Oh, and if you happen to come across a key...','',26124),
(44586,'enUS','Trick-or-treat!','Trick-or-treat!',26124),
(44587,'enUS','Trick-or-treat!','Trick-or-treat!',26124),
(44588,'enUS','There are two: The Trader\'s Hall in the Trade District, and the Stormwind Auction House in the Dwarven District.','There are two: The Trader\'s Hall in the Trade District, and the Stormwind Auction House in the Dwarven District.',26124),
(44589,'enUS','This is the kind of spirit I expected to see when we joined the Horde!','',26124),
(44590,'enUS','Another courageous soul! I have a good feeling about this one...','',26124),
(44591,'enUS','One of these is BOUND to get through!','',26124),
(44592,'enUS','Dwarven District Auction House','Dwarven District Auction House',26124),
(44593,'enUS','The Bile-O-Tron springs to life and begins to emit a foul smelling substance.','',26124),
(44594,'enUS','You\'ll find it in the northernmost part of the Dwarven District, near the Northern Landing.','You\'ll find it in the northernmost part of the Dwarven District, near the Northern Landing.',26124),
(44595,'enUS','There are two banks in the city: The Stormwind Counting House in the Trade District, and the Royal Bank of Stormwind in the Dwarven District.','There are two banks in the city: The Stormwind Counting House in the Trade District, and the Royal Bank of Stormwind in the Dwarven District.',26124),
(44596,'enUS','Trade District Bank','Trade District Bank',26124),
(44597,'enUS','Dwarven District Bank','Dwarven District Bank',26124),
(44598,'enUS','Stormwind\'s Royal Bank is in the northernmost corner of the Dwarven District, just inside the Northern Landing.','Stormwind\'s Royal Bank is in the northernmost corner of the Dwarven District, just inside the Northern Landing.',26124),
(44599,'enUS','%s snorts loudly.','',26124),
(44600,'enUS','%s grunts and opens one eye.','',26124),
(44601,'enUS','%s wakes up!','',26124),
(44602,'enUS','Stormwind\'s two most popular inns are located in the Trade and Dwarven Districts: The Gilded Rose and The Golden Keg.','Stormwind\'s two most popular inns are located in the Trade and Dwarven Districts: The Gilded Rose and The Golden Keg.',26124),
(44603,'enUS','Trade District Inn','Trade District Inn',26124),
(44604,'enUS','Dwarven District Inn','Dwarven District Inn',26124),
(44605,'enUS','The Golden Keg is in the northen part of the Dwarven District, right by the fountain.','The Golden Keg is in the northen part of the Dwarven District, right by the fountain.',26124),
(44606,'enUS','Mailboxes are scattered throughout the city. You can find one in front of any auction house, bank, or inn.','Mailboxes are scattered throughout the city. You can find one in front of any auction house, bank, or inn.',26124),
(44607,'enUS','Stormwind has many points of interest, from the Deeprun Tram to Stormwind Keep.$B$BWhat were you looking for?','Stormwind has many points of interest, from the Deeprun Tram to Stormwind Keep.$B$BWhat were you looking for?',26124),
(44608,'enUS','There are stable masters in both Old Town and the Dwarven District.','There are stable masters in both Old Town and the Dwarven District.',26124),
(44609,'enUS','Dwarven District Stable Master','Dwarven District Stable Master',26124),
(44610,'enUS','Old Town Stable Master','Old Town Stable Master',26124),
(44611,'enUS','Karin can be found in easternmost Stormwind, through the gates at the back of Old Town.','Karin can be found in easternmost Stormwind, through the gates at the back of Old Town.',26124),
(44612,'enUS','Vendor','Vendor',26124),
(44613,'enUS','','Thank the waves, you\'re back! The others have already retreated, we need to get out of here!',26124),
(44614,'enUS','The naga priestesses look to be summoning a near endless stream of reinforcements!','',26124),
(44615,'enUS','The assault looks like it did almost no damage at all. They\'re already back in formation!','',26124),
(44616,'enUS','','There were too many... our assault seems to have barely even scratched at their ranks. We lost so many men! Something must come of this...',26124),
(44617,'enUS','Blast these beasts back to hell!','',26124),
(44618,'enUS','They keep coming!  Stand your ground!','',26124),
(44619,'enUS','Hold them back!  For Gilneas!','',26124),
(44620,'enUS','Hold your positions as long as you can!','',26124),
(44621,'enUS','Up you go!','',26124),
(44622,'enUS','We\'re unda attack!','',26124),
(44623,'enUS','Da naga won\'t be givin\' up. We need to be findin\' our friends and takin\' the fight to dem.','',26124),
(44624,'enUS','I\'m going in after Erunak... alone if I have to!','',26124),
(44625,'enUS','Remtravel has been a hero to the archaeology world for nearly 40 years. If he could only remember them, oh, the stories he would tell...','',26124),
(44626,'enUS','Well, I suppose I should go in there after him.$b$bCan\'t be any worse than facing Hellscream after this...','',26124),
(44627,'enUS','Auction House','Auction House',26124),
(44628,'enUS','Bank','Bank',26124),
(44629,'enUS','Inn','Inn',26124),
(44630,'enUS','With the destruction of Stormwind\'s park - and most of the night elves within, the poor, unlucky souls - your best bet would be to seek out old Celestine just outside the Dwarven District.$B$BThere are stairs leading down from the Northern Landing... you can see her cottage from there.','With the destruction of Stormwind\'s park - and most of the night elves within, the poor, unlucky souls - your best bet would be to seek out old Celestine just outside the Dwarven District.$B$BThere are stairs leading down from the Northern Landing... you can see her cottage from there.',26124),
(44631,'enUS','There are hunters training in Old Town\'s Command Center as well as in the Dwarven District.','There are hunters training in Old Town\'s Command Center as well as in the Dwarven District.',26124),
(44632,'enUS','Dwarven District Hunter Trainer','Dwarven District Hunter Trainer',26124),
(44633,'enUS','Old Town Hunter Trainer','Old Town Hunter Trainer',26124),
(44634,'enUS','You can always find a handful of hunters just outside Old Town\'s east gate.','You can always find a handful of hunters just outside Old Town\'s east gate.',26124),
(44635,'enUS','Lion\'s Rest','Lion\'s Rest',26124),
(44636,'enUS','Lion\'s Rest is a place of contemplation and remembrance, a tranquil park dedicated in honor of those who have made the ultimate sacrifice on our behalf.','Lion\'s Rest is a place of contemplation and remembrance, a tranquil park dedicated in honor of those who have made the ultimate sacrifice on our behalf.',26124),
(44637,'enUS','Stormwind Keep','Stormwind Keep',26124),
(44638,'enUS','The keep is in northren Stormwind.$B$BJust follow the canals north and you\'ll eventually come across a drawbridge... that leads into the keep\'s courtyard.','The keep is in northren Stormwind.$B$BJust follow the canals north and you\'ll eventually come across a drawbridge... that leads into the keep\'s courtyard.',26124),
(44639,'enUS','The Stockade','The Stockade',26124),
(44640,'enUS','The prison? Why would you want to go there? It\'s in the center of the city, just northeast of the Mage Quarter.$B$BIf you\'re truly going there, be careful. I\'ve heard news of riots.','The prison? Why would you want to go there? It\'s in the center of the city, just northeast of the Mage Quarter.$B$BIf you\'re truly going there, be careful. I\'ve heard news of riots.',26124),
(44641,'enUS','The caravan is uprotected - I\'m turning back!','',26124),
(44642,'enUS','','I\'m sorry, I cannot train you.',26124),
(44643,'enUS','','How can I help you, $c?',26124),
(44644,'enUS','We\'ve been hearing reports of elemental disturbances around Azeroth for some time now.  Our sources indicate that the phenomenon is not entirely natural, but we haven\'t quite been able to determine the source.  We have some theories though, but nothing concrete.$B$BKeep your eye out for any suspicious elemental activity as you walk around.  If you find anything worthwhile, please let an Earthen Ring Emissary know.  You can find us in any capital city.$B$BKeep your eye open.  Trouble is brewing.','We\'ve been hearing reports of elemental disturbances around Azeroth for some time now.  Our sources indicate that the phenomenon is not entirely natural, but we haven\'t quite been able to determine the source.  We have some theories though, but nothing concrete.$B$BKeep your eye out for any suspicious elemental activity as you walk around.  If you find anything worthwhile, please let an Earthen Ring Emissary know.  You can find us in any capital city.$B$BKeep your eye open.  Trouble is brewing.',26124),
(44645,'enUS','The elements in Azeroth are becoming more disturbed each passing day.  The key to this disturbance lies here, in Nagrand.  When Draenor was torn apart, all of the elemental planes were thrown into great turmoil and have never recovered.  The rifts here form naturally and are a sign of a severely damaged world.$B$BTo see this same kind of disruption on Azeroth is not just unnerving, it could be a precursor to a type of destruction the world has never seen before.$B$B$n, bring me any information you may find when walking around Outland.$B$BI must spend time with the elements here, researching a way to calm the elements again in Azeroth...before it\'s too late.','',26124),
(44646,'enUS','We\'re trying to find a solution to the growin\' elemental disturbances in Azeroth. Here in Nagrand, we see the same rifts formin\', but as a direct consequence of Draenor bein\' torn to shreds. They\'re a sign of a weakened planet and of an elemental plane in upheaval.$B$BYet, on Azeroth, there\'s no solid explanation for it.$B$BIf ya find any information about these rifts when adventurin\' in the Outland, please let us know. We\'ll continue to speak with the elements here and find a way to calm the elements in Azeroth...before it\'s too late.\n','',26124),
(44647,'enUS','Jewelcrafting','Jewelcrafting',26124),
(44648,'enUS','Denman Family Jewelers, between the northern Trade District and The Canals, should have everything you\'re looking for.','Denman Family Jewelers, between the northern Trade District and The Canals, should have everything you\'re looking for.',26124),
(44649,'enUS','Archaeology','Archaeology',26124),
(44650,'enUS','Harrison Jones teaches Archaeology in Stormwind Keep\'s Royal Library when not out in the field.','Harrison Jones teaches Archaeology in Stormwind Keep\'s Royal Library when not out in the field.',26124),
(44651,'enUS','Profession vendors can always be found near their respective trainers. Other sorts of vendors are scattered throughout Stormwind.$B$BWhat were you looking for?','Profession vendors can always be found near their respective trainers. Other sorts of vendors are scattered throughout Stormwind.$B$BWhat were you looking for?',26124),
(44652,'enUS','Champions\' Hall','Champions\' Hall',26124),
(44653,'enUS','The Champions\' Hall is located in the southeastern end of Old Town.$B$BThe Honor and Conquest quartermasters can be found there.','The Champions\' Hall is located in the southeastern end of Old Town.$B$BThe Honor and Conquest quartermasters can be found there.',26124),
(44654,'enUS','Justice & Valor Quartermasters','Justice & Valor Quartermasters',26124),
(44655,'enUS','In the Command Center, just outside of Old Town\'s southeast gates, you\'ll find the quartermasters.','In the Command Center, just outside of Old Town\'s southeast gates, you\'ll find the quartermasters.',26124),
(44656,'enUS','Honor & Conquest Quartermasters','Honor & Conquest Quartermasters',26124),
(44657,'enUS','Horse Breeder','Horse Breeder',26124),
(44658,'enUS','There are stables just beyond Old Town\'s southeast gates. You can find a riding trainer and a horse breeder there.','There are stables just beyond Old Town\'s southeast gates. You can find a riding trainer and a horse breeder there.',26124),
(44659,'enUS','Gryphon Handler','Gryphon Handler',26124),
(44660,'enUS','If only I could get to the Launch Bay. Gimme one, just one, of those beautiful airborne machines and I could retake Gnomeregan and scare the goggles off of B.E Barechus at the same time!$B$BIf you need another parachute, we\'ve stored some in chests near the drop points.','',26124),
(44661,'enUS','Do you know of the Gryphon Roost off the Trade District, where the Flight Master may be found?$B$BA pair of Wildhammer dwarves raises and sells gryphons there, and can even train you to ride the beasts.','Do you know of the Gryphon Roost off the Trade District, where the Flight Master may be found?$B$BA pair of Wildhammer dwarves raises and sells gryphons there, and can even train you to ride the beasts.',26124),
(44662,'enUS','We are bound by will to serve the Banshee Queen.','We are bound by will to serve the Banshee Queen.',26124),
(44663,'enUS','Riding','Riding',26124),
(44664,'enUS','Flying','Flying',26124),
(44665,'enUS','','I\'ll even get you started.',26124),
(44666,'enUS','You look exhausted. Is something wrong?','You look exhausted. Is something wrong?',26124),
(44667,'enUS','Good to see you.','Good to see you.',26124),
(44668,'enUS','Yes?','Yes?',26124),
(44669,'enUS','Have you recovered the final piece?','Have you recovered the final piece?',26124),
(44670,'enUS','Any luck with Therazane?','Any luck with Therazane?',26124),
(44671,'enUS','You look intent. Is there something I can help with?','You look intent. Is there something I can help with?',26124),
(44672,'enUS','Am I needed?','Am I needed?',26124),
(44673,'enUS','And I thought I might get a bit of rest. Silly me.','And I thought I might get a bit of rest. Silly me.',26124),
(44674,'enUS','We are joining an assault on Lorthuna\'s Gate. You are needed.','We are joining an assault on Lorthuna\'s Gate. You are needed.',26124),
(44675,'enUS','I\'m on my way.','I\'m on my way.',26124),
(44676,'enUS','Got it. I\'ll head there right away.','Got it. I\'ll head there right away.',26124),
(44677,'enUS','Elements be with us.','Elements be with us.',26124),
(44678,'enUS','Some action. Glad to hear it.','Some action. Glad to hear it.',26124),
(44679,'enUS','I\'m glad to hear we\'re fighting along side the Stonemother herself this time.','I\'m glad to hear we\'re fighting along side the Stonemother herself this time.',26124),
(44680,'enUS','That encampment has been begging for our attention. Let\'s get this done.','That encampment has been begging for our attention. Let\'s get this done.',26124),
(44681,'enUS','Exactly what I wanted to hear. Let\'s go.','Exactly what I wanted to hear. Let\'s go.',26124),
(44682,'enUS','Understood. I\'ll head there right away.','Understood. I\'ll head there right away.',26124),
(44683,'enUS','The blessed warmth of the sun courses through your veins!','',26124),
(44684,'enUS','You not let them near fragment!','',26124),
(44685,'enUS','Kill them! Kill all!','',26124),
(44686,'enUS','Crush them! I take fragment to Stone Mother.','',26124),
(44687,'enUS','We control World Pillar!','',26124),
(44688,'enUS','Ignore Twilight\'s Hammer! They stupid. Kill other one, now!','',26124),
(44689,'enUS','You not take World Pillar fragment from me!','',26124),
(44690,'enUS','Therazane be happy to get middle fragment.','',26124),
(44691,'enUS','Smash them! Then we join attack upon Temple of Earth!','',26124),
(44695,'enUS','','Where is that ogre-headed buffoon?',26124),
(44696,'enUS','','Ah, speak of the devil...',26124),
(44699,'enUS','This better be important, Sylvanas. You know how I detest this place and its foul stench. Why have you called for me?','',26124),
(44700,'enUS','And more importantly, what are those Scourge fiends doing here?','',26124),
(44701,'enUS','','Warchief, so glad you could make it.',26124),
(44702,'enUS','','With the death of the Lich King, many of the more intelligent Scourge became... unemployed. Those \'fiends,\' as you so delicately put it, are called val\'kyr. They are under my command now...',26124),
(44703,'enUS','','...and they are part of the reason that I asked to see you.',26124),
(44704,'enUS','Get on with it, Sylvanas.','',26124),
(44705,'enUS','','Very well, Warchief. I have solved the plight of the Forsaken!',26124),
(44706,'enUS','','As a race, we Forsaken are unable to procreate.',26124),
(44707,'enUS','','With the aid of the val\'kyr, we are now able to take the corpses of the fallen and create new Forsaken.',26124),
(44709,'enUS','','Agatha, show the Warchief!',26124),
(44713,'enUS','ABBERATION!','',26124),
(44714,'enUS','What you have done here, Sylvanas... it goes against the laws of nature. Disgusting is the only word I have to describe it.','',26124),
(44715,'enUS','','Warchief, without these new Forsaken my people would die out... Our hold upon Gilneas and northern Lordaeron would crumble.',26124),
(44716,'enUS','Have you given any thought to what this means, Sylvanas?','',26124),
(44717,'enUS','What difference is there between you and the Lich King now?','',26124),
(44718,'enUS','','Isn\'t it obvious, Warchief? I serve the Horde.',26124),
(44719,'enUS','Watch your clever mouth, bitch.','',26124),
(44720,'enUS','Cromush, you stay behind and make sure the Banshee Queen is well \"guarded.\" I will be expecting a full report when next we meet.','',26124),
(44721,'enUS','Remember, Sylvanas, eventually we all have to stand before our maker and face judgment. Your day may come sooner than others\'....','',26124),
(44728,'enUS','','Move quickly, $n. Your work will be for nothing if Mograine notices us before your work is done. ',26124),
(44729,'enUS','Twilight\'s Hammer has infiltrated my city. Left unchecked, they\'ll rot it to the core. Before we besiege their stronghold in the Highlands, I must be certain that Stormwind is safe from their machinations.$B$BI need more feet on the ground, reliable eyes and ears throughout the city. An experienced $c like yourself would be invaluable.$B$BAre you prepared to help Stormwind\'s cause?','',26124),
(44730,'enUS','Tell me more about Deepholm and the World Pillar.','Tell me more about Deepholm and the World Pillar.',26124),
(44731,'enUS','My name ISN\'T FRONKLE!','',26124),
(44732,'enUS','Veer left!','',26124),
(44733,'enUS','Look out for that turtle!','',26124),
(44734,'enUS','I\'ll have the Kickin\' Chimeroak Chops, extra kick!','',26124),
(44735,'enUS','Stop calling me Fronkle!','',26124),
(44736,'enUS','Dive!  Dive!  Dive!','',26124),
(44737,'enUS','','Tremble, crusaders, before the might of the Forsaken!',26124),
(44738,'enUS','As you command, Warchief!','',26124),
(44739,'enUS','','Flesh Rippers, hold the forward courtyard for our champions!',26124),
(44740,'enUS','','The Scarlet Monastery belongs to the Forsaken now!',26124),
(44741,'enUS','','How does it feel to watch your men slaughtered by your mortal enemies, Inquisitor?',26124),
(44742,'enUS','Welcome to Stormwind, $c.','',26124),
(44743,'enUS','<Anduin sizes you up.>$B$B$n, is it? A few of your triumphs have been the talk of the court.$B$BWhat was it like to serve in Northrend? Have you seen the World Tree? Are the stories about Vashj\'ir true? I have so many questions!','',26124),
(44744,'enUS','Come with me, your highness.','Come with me, your highness.',26124),
(44745,'enUS','Could you forsee this, fool?','',26124),
(44746,'enUS','I\'ve always wondered what it would be like to be a druid. Where do your clothes go when you change into a bear?','',26124),
(44747,'enUS','So you\'re a hunter? My father has taught me to be pretty handy with a bow, myself.','',26124),
(44748,'enUS','You\'re a mage, like Jaina Proudmoore? How long have you studied the arcane? It seems so difficult to master.','',26124),
(44749,'enUS','You\'re a paladin? Highlord Fordragon was, as well. He taught me a great deal. I... I still miss him.','',26124),
(44750,'enUS','I\'m training to be a priest, myself. One day I hope I can command as much power as you.','',26124),
(44751,'enUS','This is great, I never get to talk to Stormwind\'s rogues. They\'re always so quiet and secretive...','',26124),
(44752,'enUS','What\'s it like to be a shaman? I met Thrall once. My father doesn\'t trust him but he seemed very wise.','',26124),
(44753,'enUS','Being a powerful warlock must be hard. Do you ever worry you\'ll lose control of one of your demons?','',26124),
(44754,'enUS','You\'re one of the fiercest-looking warriors I\'ve ever seen, $n!','',26124),
(44755,'enUS','$n, I remember when you first came to see my father after the battle for Ebon Hold. I\'m glad you\'re still with us. ','',26124),
(44756,'enUS','','Hey there, cutie!  Mind rubbing some lotion on my exposed areas?',26124),
(44757,'enUS','Defilers! Wretches! Fiends! Begone from here!','',26124),
(44758,'enUS','I send you to your deity.','',26124),
(44759,'enUS','I take this life as an offering!','',26124),
(44760,'enUS','Blazing rays of light, take me!','',26124),
(44761,'enUS','Can you feel it? The blessed warmth of the sun?','',26124),
(44762,'enUS','You fear that which you cannot control. But can you control your fear?','',26124),
(44763,'enUS','Embrace the end!','',26124),
(44764,'enUS','Do you understand now?','',26124),
(44765,'enUS','Yes! Harness... your... hatred.','',26124),
(44766,'enUS','Behold as infinite darkness befalls your world!','',26124),
(44767,'enUS','This chamber will flourish with your life energy!','',26124),
(44768,'enUS','Wither away!','',26124),
(44769,'enUS','Waste of energy.','',26124),
(44770,'enUS','The cycle continues...','',26124),
(44771,'enUS','Your life, UNLEASHED!','',26124),
(44772,'enUS','','Gaze to the heavens! What do you see?',26124),
(44773,'enUS','','The glimmer of your life, extinguished.',26124),
(44774,'enUS','','Insignificant!',26124),
(44775,'enUS','','Eons of darkness... by your hand.',26124),
(44776,'enUS','','My luster... wanes.',26124),
(44777,'enUS','','Bask in my radiance!',26124),
(44778,'enUS','More carrion for the swarm...','',26124),
(44779,'enUS','Dust to dust.','',26124),
(44780,'enUS','Ptah... is... no more...','',26124),
(44781,'enUS','The earth TREMBLES!','',26124),
(44782,'enUS','Turn back, intruders! These halls must not be disturbed!','',26124),
(44783,'enUS','A product of your own insolence.','',26124),
(44784,'enUS','What... have you... done?','',26124),
(44785,'enUS','Beacons of light, bestow upon me your aegis!','',26124),
(44786,'enUS','I regret nothing.','',26124),
(44787,'enUS','I trust you and my son are getting along? Anduin is anything but shy.','',26124),
(44788,'enUS','Final stop, the Forsaken Front! EVERYBODY OUT!','Final stop, the Forsaken Front! EVERYBODY OUT!',26124),
(44789,'enUS','When Stormwind is secure, we will take this fight to the Highlands.','',26124),
(44790,'enUS','This is a one way trip, kid, and you definitely don\'t want to be comin\' back on the other wagon.','This is a one way trip, kid, and you definitely don\'t want to be comin\' back on the other wagon.',26124),
(44791,'enUS','Begone infidels, you are not welcome here!','',26124),
(44792,'enUS','Death is only the beginning!','',26124),
(44793,'enUS','May peace find you now.','',26124),
(44794,'enUS','The heavens take you!','',26124),
(44795,'enUS','Kneel before me and repent!','',26124),
(44796,'enUS','ALL ABOARD! Next stop: The Sepulcher.','ALL ABOARD! Next stop: The Sepulcher.',26124),
(44797,'enUS','ALL ABOARD! Last stop: The Forsaken Front!','ALL ABOARD! Last stop: The Forsaken Front!',26124),
(44798,'enUS','Make your time, mortals.  You will never defeat the Occulus!','',26124),
(44799,'enUS','Such insolence....such arrogance...','',26124),
(44800,'enUS','We control the ebb and flow of time!  The Infinite Dragonflight cannot be defeated!','',26124),
(44801,'enUS','My former brethren, your time draws short!  Join us, before you are lost to the sands of eternity!','',26124),
(44802,'enUS','The sands of time count out the days to your annihilation!','',26124),
(44803,'enUS','Children of Nozdormu, hear me!  The folds of time are innumerable, and we are many!  You will not, can not, defeat us all!','',26124),
(44804,'enUS','','The cult is upon us! We need help in the Respite Chambers!',26124),
(44805,'enUS','We\'ve retaken the Idol of Akil\'darah thanks to you, $n! Come over here and I\'ll take you deep into Jintha\'Alor on the winds of her blessin\'!','',26124),
(44806,'enUS','The eagle spirit of the Hinterlands be on our side now, $n.$B$BWith her idol free from the Vilebranch, I can transport you straight to it on the upper tier of Jintha\'Alor. Strike at their hearts!','',26124),
(44807,'enUS','','Hi. Welcome to my salon.$B$BYou look great! But if you\'re in the mood for a change, just sit right down in one of the chairs.',26124),
(44808,'enUS','Sharpbeak\'s the finest gryphon in Aerie Peak. He\'ll get you right to the top of Jintha\'Alor, and we\'ll take the top terraces in no time.','',26124),
(44809,'enUS','','We must take what is ours. Our survival depends on it.',26124),
(44810,'enUS','I need to get to the top of Jintha\'Alor. Time to ride Sharpbeak!','I need to get to the top of Jintha\'Alor. Time to ride Sharpbeak!',26124),
(44811,'enUS','','Anastasia, stay close please. We\'ll go do something fun soon.',26124),
(44812,'enUS','','You\'re going to have a play date with William and Donna later. How does that sound?',26124),
(44813,'enUS','','I saw Little Timmy the other day, Ana. Would you like a kitten?',26124),
(44814,'enUS','','We\'ll go ice skating as soon as the lake freezes over, honey.',26124),
(44815,'enUS','The Scarlet Crusade will return to its noble roots!','',26124),
(44816,'enUS','','We\'re going to do little Andi\'s braids soon. Would you like your\'s done too, sweetie?',26124),
(44817,'enUS','','Ana, ten more minutes, then you need to wash up. We\'re having your favorite. Mac and cheese.',26124),
(44818,'enUS','','Ana, how would you like to go down to the harbor in a little while?',26124),
(44819,'enUS','','I\'m going to be giving the king a haircut tomorrow. Would you like to come and meet him, Ana?',26124),
(44820,'enUS','I know this looks grim, but our enemies will pay for what they have done. I\'ll make sure they do.','',26124),
(44821,'enUS','If one such as I can be captured by that lumbering oaf, then you must be brave indeed to venture here.\n\nIf you can distract Halfus and break the chains binding me then I will fight alongside you.\n\nMy ability to slow the passage of time in an area will help you evade the Proto-Behemoth\'s Fireball Barrage.','',26124),
(44822,'enUS','Gryphon Master Talonaxe has ordered me sent to Stormfeather Outpost!','Gryphon Master Talonaxe has ordered me sent to Stormfeather Outpost!',26124),
(44823,'enUS','','Awesome!',26124),
(44824,'enUS','','Whatever.',26124),
(44825,'enUS','','Cool.',26124),
(44826,'enUS','','Yah, mom... woooo!',26124),
(44827,'enUS','','No way.',26124),
(44828,'enUS','','Oh yah, uh huh.',26124),
(44829,'enUS','','\'kay.',26124),
(44830,'enUS','','Yes!',26124),
(44831,'enUS','','You will speak when spoken to.',26124),
(44832,'enUS','Ozumat is back! Oh noes~ [PH]','',26124),
(44833,'enUS','Enough of this... ITS GO TIME! [PH]','',26124),
(44834,'enUS','We win! Heres some loot, thx. [PH]','',26124),
(44835,'enUS','Thanks. That beast was a handful!','Thanks. That beast was a handful!',26124),
(44836,'enUS','That beast came from nowhere!','That beast came from nowhere!',26124),
(44837,'enUS','Worgen filth! I spit on your corpse!','Worgen filth! I spit on your corpse!',26124),
(44838,'enUS','They won\'t take our land without a fight!','They won\'t take our land without a fight!',26124),
(44839,'enUS','Thank you, hero!','Thank you, hero!',26124),
(44840,'enUS','','We\'re trying to find out what\'s so important up at the Masters\' Gate.$B$BI just know that those Hammer jerks are up to no good. No fair! We came all this way following a clue and now we can\'t even get close.',26124),
(44841,'enUS','','I am the mistress of the skies, and they who threaten my children shall suffer.',26124),
(44842,'enUS','Well done, $n!  Thunder Bluff is in your debt.','Well done, $n!  Thunder Bluff is in your debt.',26124),
(44843,'enUS','Well done, $n!  Orgrimmar is in your debt.','Well done, $n!  Orgrimmar is in your debt.',26124),
(44844,'enUS','Well done, $n!  Ironforge is in your debt.','Well done, $n!  Ironforge is in your debt.',26124),
(44845,'enUS','All hail, $n, a true champion and protector of Thunder Bluff!  Let no one forget the brave deeds performed by, $n!','All hail, $n, a true champion and protector of Thunder Bluff!  Let no one forget the brave deeds performed by, $n!',26124),
(44846,'enUS','Lok\'tar! Let no one forget the name, $n, a true champion of Orgrimmar!  All hail $n!','Lok\'tar! Let no one forget the name, $n, a true champion of Orgrimmar!  All hail $n!',26124),
(44847,'enUS','All hail, $n, a true champion and protector of Ironforge!  Let no one forget the brave deeds performed by, $n!','All hail, $n, a true champion and protector of Ironforge!  Let no one forget the brave deeds performed by, $n!',26124),
(44848,'enUS','Thank you... I wish I could help you find the forgemaster.','',26124),
(44849,'enUS','The forgemaster\'s a terrible murderer.  Are you sure you want to go looking for him?','',26124),
(44850,'enUS','Ah, yes... I know about the forgemaster!  I just overheard that he\'s not in the camp right now.','',26124),
(44851,'enUS','The forgemaster is meeting with the Twilight leadership.  Trust me, I traded some gossip for a loaf of stale bread!','',26124),
(44852,'enUS','I don\'t know nothin\' bout no forgemaster.  Now tell me where this safe place you came from is!','',26124),
(44853,'enUS','I heard the forgemaster keeps notes about his meetings  in a book at the tower overlooking the camp.','',26124),
(44854,'enUS','','Call me Twin. That\'s what Mowi calls me.$B$BNo, we don\' look alike. Are ye blind? She\'s a gnome fer the Light\'s sake! We act alike. \'specially when we\'re fightin\'.$B$BAs fer my name... have ya na heard o\' the storied Wildhammer Brewers? Care fer a pint?',26124),
(44855,'enUS','Ouch!','',26124),
(44856,'enUS','Oof!','',26124),
(44857,'enUS','Ow, mon!','',26124),
(44858,'enUS','It burns!','',26124),
(44859,'enUS','Yowch!','',26124),
(44860,'enUS','Stop dat!','',26124),
(44861,'enUS','It burns like the moon!','',26124),
(44862,'enUS','Cut it out!','',26124),
(44863,'enUS','Leap!','',26124),
(44864,'enUS','Pounce!','',26124),
(44865,'enUS','Attack!','',26124),
(44866,'enUS','Meow!','',26124),
(44867,'enUS','Get back over here, mon!','',26124),
(44868,'enUS','Here comes Zen\'Kiki!','',26124),
(44869,'enUS','Rawr!','',26124),
(44870,'enUS','Haha!','',26124),
(44871,'enUS','','The Twilight\'s Hammer has most certainly uncovered something of interest up at the Masters\' Gate.$B$BPerhaps a $g skilled : lovely; $c such as yourself would help me with that?',26124),
(44872,'enUS','As my lovely companion may have already enlightened you, we are in pursuit of something mysterious and powerful. All of our clues point to the Masters\' Gate.$B$BUnfortunately, the nihilistic cultists known as the Twilight\'s Hammer have prevented our attempts to research the area. Surely a $c with your reputation can assist the Reliquary in its time of need?','',26124),
(44873,'enUS','I\'ll get him!','',26124),
(44874,'enUS','Am I hitting him?','',26124),
(44875,'enUS','Rawr!!','',26124),
(44876,'enUS','Maul!  Swipe!  MANGLE!','',26124),
(44877,'enUS','Zen\'Kiki is in control!','',26124),
(44878,'enUS','Get over here, you coward!','',26124),
(44879,'enUS','No, hit me!  Over here, mon!','',26124),
(44880,'enUS','I got dis one!','',26124),
(44881,'enUS','Shapeshift!  Here come de moonfire!','',26124),
(44882,'enUS','Shapeshift!  Get ready for de moonfire!','',26124),
(44883,'enUS','Shapeshift!  Here it comes, mon!','',26124),
(44884,'enUS','Shapeshift!  Zen\'Kiki\'s ready to pounce!','',26124),
(44885,'enUS','Shapeshift!  Time for cat form!','',26124),
(44886,'enUS','Shapeshift!  Get ready to taste my claws!','',26124),
(44887,'enUS','Shapeshift!  Zen\'Kiki will absorb de damage!','',26124),
(44888,'enUS','Shapeshift!  Time for bear form!','',26124),
(44889,'enUS','Shapeshift!  Over here, mon!','',26124),
(44890,'enUS','Shapeshift!  Uh oh... wait a minute here...','',26124),
(44891,'enUS','Shapeshift!  Oh no!  Not again...','',26124),
(44892,'enUS','Shapeshift!  Try to swim away now, mon!','',26124),
(44893,'enUS','A little help here...','',26124),
(44894,'enUS','I seem to be... stuck...','',26124),
(44895,'enUS','Zen\'kiki\'s real sorry about this.','',26124),
(44896,'enUS','This isn\'t right.','',26124),
(44897,'enUS','Can Zen\'Kiki get a little nudge?','',26124),
(44898,'enUS','Why you guys upside down?','',26124),
(44899,'enUS','harshly interrogates a cowering dock worker.','harshly interrogates a cowering dock worker.',26124),
(44900,'enUS','Can I help you with the Twilight\'s Hammer investigation? We don\'t have to tell my father...','',26124),
(44901,'enUS','There you are, $n! I thought you\'d forgotten about me.','',26124),
(44902,'enUS','Eliminate all murlocs by using the Blight Concoction!$B$B|r|TInterface\\Icons\\INV_ALCHEMY_POTION_05.BLP:24|t','Eliminate all murlocs by using the Blight Concoction!$B$B|r|TInterface\\Icons\\INV_ALCHEMY_POTION_05.BLP:24|t',26124),
(44903,'enUS','Returning to Forsaken High Command!$B$B|r|TInterface\\Icons\\ACHIEVEMENT_ZONE_SILVERPINE_01.BLP:24|t','Returning to Forsaken High Command!$B$B|r|TInterface\\Icons\\ACHIEVEMENT_ZONE_SILVERPINE_01.BLP:24|t',26124),
(44904,'enUS','What do you want? Can\'t you see I have bat droppings to clean up?','',26124),
(44905,'enUS','I need to take a bat to the Dawning Isles.','I need to take a bat to the Dawning Isles.',26124),
(44906,'enUS','You better bring that bat back in one piece, $n!','',26124),
(44907,'enUS','Lorthuna is preparing a powerful spell - get behind cover!','Lorthuna is preparing a powerful spell - get behind cover!',26124),
(44908,'enUS','Twilight\'s Hammer? I don\'t know anything! Why are you asking me?','',26124),
(44909,'enUS','I don\'t know anything about a cult! Please let me get back to work...','',26124),
(44910,'enUS','Tw- Tw- Twilight\'s Ha- Hammer? Keep them away from me!','',26124),
(44911,'enUS','What, that crazy end-of-the-world cult? If I hear anything, you\'ll be the first to know!','',26124),
(44912,'enUS','What are you asking me for? I just schlepp boxes!','',26124),
(44913,'enUS','I swear that guy was dead when I found him! What - oh - Twilight\'s Hammer? No, I don\'t know anything about that.','',26124),
(44914,'enUS','I haven\'t heard a thing. I swear!','',26124),
(44915,'enUS','I\'m innocent. Innocent I tell you! The Cataclysm isn\'t my fault!','',26124),
(44916,'enUS','Yarrr!','Yarrr!',26124),
(44917,'enUS','Avast!','Avast!',26124),
(44918,'enUS','Ahoy!','Ahoy!',26124),
(44920,'enUS','','Your presence is not welcome here, Amnennar.',26124),
(44921,'enUS','|TInterface\\Icons\\spell_nature_earthquake.blp:20|t%s begins to cast |cFFFF0000|Hspell:83445|h[Shockwave]!|h|r','',26124),
(44922,'enUS','','What brings you inside these cursed lands?',26124),
(44923,'enUS','The Twilight\'s Hammer has unearthed a titan Waygate and it appears that they\'re attempting to activate it.','',26124),
(44924,'enUS','With the death of the Lich King, all I have left is my duty.  There is no family, there are no friends... there is only this.$b$bWar.','',26124),
(44925,'enUS','Hmmmm... no valuable information there.','',26124),
(44926,'enUS','You really have a way with people, $n. They fear and respect you.','',26124),
(44927,'enUS','Does this feel like a wild goose chase to you? These workers don\'t know anything!','',26124),
(44928,'enUS','MORE Ghaz\'ridian?  Why would you think I would want any MORE of those infernal things?  I\'m stuck with about nine thousand, and they\'re not selling!  Why did I ever think anyone would want a statue of an overgrown snake?  Pah!','',26124),
(44929,'enUS','I saw the Wastewander and their leader, Caliph Scorpidsting, heading south of here.  Watch out, they look like they\'ve toughened up some!','',26124),
(44930,'enUS','I saw the biggest bug you\'ve ever seen wandering around one of those Silithid hives.  Or maybe it was both of them.  I think the heat\'s getting to me...do you see that sand kitten over there?','',26124),
(44931,'enUS','I don\'t know much about dragons, but a big, scary one showed up one day just over yonder, near the entrance to the Caverns of Time.  He kept yelling something about...what was it...the end of time as we know it?  I wasn\'t really paying much attention.','',26124),
(44932,'enUS','An old friend of mine named Frokle was supposed to be heading in to Gadgetzan, but him and the rest of the Bilgewater crew manning the ship never arrived.  I\'ve heard rumors of a crazy goblin that hangs out near a downed flying machine in the far south, could it be...?','',26124),
(44933,'enUS','I found a broken-down cart amongst the dunes when I was checking out the potential profitibility of Centipaar Silithid Snacks (patent pending).  I thought to myself, \"hey, free cart!\"  That is, until the biggest basilisk you\'ve ever seen showed up, and I had to leave the whole thing behind!','',26124),
(44934,'enUS','Have you seen those huge dirt mounds moving around beneath the dunes?  They belong to a species of tunneling worm the likes of which Azeroth has never seen!  I\'m sure that battling one would be a great learning experience for a seasoned adventurer such as yourself.','',26124),
(44935,'enUS','When the Cataclysm happened, the links bounding elementals across Azeroth weakened significantly.  One such elemental, Aquementas, is no longer imprisoned.  I hear he\'s causing some major problems for the Southsea gang!','',26124),
(44936,'enUS','You\'ll never catch me alive!','',26124),
(44937,'enUS','Are you often sent to gather things for people? I suppose a hero\'s work is never done.','',26124),
(44938,'enUS','All of our explosives are missing!? $n, something sinister is definitely happening here.','',26124),
(44939,'enUS','<The outhouse is silent.>','',26124),
(44940,'enUS','Yorick, you in there? I\'m ready to do this! Let\'s go!','Yorick, you in there? I\'m ready to do this! Let\'s go!',26124),
(44941,'enUS','Come fools. Come to your doom. The end of days is here!','',26124),
(44942,'enUS','The titan Waygate is almost opened. We will assist the Tol\'vir to reconfigure Uldum and bring about the end of all life on Azeroth!','',26124),
(44943,'enUS','We have labored long and hard for our lord Deathwing. Let us give our all in his name that we will bask in his flames at the end of days!','',26124),
(44944,'enUS','Lord Deathwing\'s sundering of the Well of Eternity has brought down Uldum\'s defenses. Prepare yourselves. We will march through the Waygate soon!','',26124),
(44945,'enUS','','How do you do, $n?',26124),
(44946,'enUS','Long ago, before the last great war, my father ran the Northridge Lumber Mill. It was his life, and he was committed to it. Then the war came, and as much as it pained him, we had to flee to Stormwind.$B$BWith the passing of the Scourge and the flight of the Scarlet Crusade, however... Northridge is ours again.','',26124),
(44947,'enUS','Unimaginable power courses through me to the Waygate! Muahahahahahaha!','',26124),
(44948,'enUS','Decrypt the final instructions. We activate the Waygate within the hour!','',26124),
(44949,'enUS','There is an intruder amongst us. Destroy them! Nothing must interfere with Lord Deathwing\'s plan!','',26124),
(44950,'enUS','It is true that we serve Deathwing, but we also serve a higher power. Never forget that!','',26124),
(44951,'enUS','','We haven\'t got much time. Crowley will be arriving shortly. Let\'s go!',26124),
(44952,'enUS','Quit yer pokin\', mon!','',26124),
(44953,'enUS','Hey, that tickles, mon!','',26124),
(44954,'enUS','Alright, here I go!','',26124),
(44955,'enUS','','THERE! Hide in the armoire! I\'ll hide in the shadows next to you.',26124),
(44956,'enUS','Ready to go, mon!','',26124),
(44957,'enUS','Have you given any more thought to my proposal, Ivar?','',26124),
(44958,'enUS','Return to Western Plaguelands or your mustang will kick you off!','',26124),
(44959,'enUS','Why trust you now, Crowley? You abandoned us. Left us to die.','',26124),
(44960,'enUS','If we\'re to win this war we will need your help. Our packs must unite! The Forsaken will destroy us otherwise.','',26124),
(44961,'enUS','You are the alpha male, Ivar. The rest of the ferals in Silverpine will do as you command.','',26124),
(44962,'enUS','I don\'t care about your war, Crowley.','',26124),
(44963,'enUS','But...','',26124),
(44964,'enUS','I have seen firsthand what the Forsaken are capable of doing. It is true. They hunt us... slaughter the defenseless.','',26124),
(44965,'enUS','So you will help?','',26124),
(44966,'enUS','Aye, I will gather my pack... we...','',26124),
(44967,'enUS','%s sniffs at the air.','',26124),
(44968,'enUS','It would appear that we are being watched, Crowley. You have grown soft... Likely Greymane\'s fault.','',26124),
(44969,'enUS','Treacherous little pup!','',26124),
(44970,'enUS','What say you now, spy?','',26124),
(44971,'enUS','','I live... and die... for the Banshee Queen.',26124),
(44972,'enUS','I was hoping you\'d say that...','',26124),
(44973,'enUS','I will prepare the pack. It will take some time to gather them all, but we will join... for now.','',26124),
(44974,'enUS','You will be destroyed!','',26124),
(44975,'enUS','I\'M HIT!','',26124),
(44976,'enUS','','$n, you\'ve returned! Is that the middle fragment?',26124),
(44977,'enUS','I need more encrypted plans.','I need more encrypted plans.',26124),
(44978,'enUS','What?! You\'re immune to my air magic?','',26124),
(44979,'enUS','My firebolt is useless! No matter you smug little insect. I will still destroy you!','',26124),
(44980,'enUS','You\'re immune to my water spell! How can this be?','',26124),
(44981,'enUS','Th... thank you.','',26124),
(44982,'enUS','\'Ey, mon!  You come to help Zen\'Kiki out?','',26124),
(44983,'enUS','Yes, Zen\'Kiki.  Let\'s go run some combat practice.','Yes, Zen\'Kiki.  Let\'s go run some combat practice.',26124),
(44984,'enUS','Dis is a lot of fun, mon!  I love bein\' a druid!','',26124),
(44985,'enUS','Zen\'Kiki, why don\'t you head back to the Menders\' Stead for a while?','Zen\'Kiki, why don\'t you head back to the Menders\' Stead for a while?',26124),
(44986,'enUS','%s gasps.','%s gasps.',26124),
(44987,'enUS','What IS this place? Ugh, and that smell...','',26124),
(44988,'enUS','Some sort of rituals were performed at this altar. It looks like a kind of pagan initiation ritual that Velen once told me about. Bloody. Disgusting.','',26124),
(44989,'enUS','Who do you think - wait - $n, look out behind you!','',26124),
(44990,'enUS','Where to going, captain?','',26124),
(44991,'enUS','Dis not so bad. Maybe little heavy, but me ok.','',26124),
(44992,'enUS','OOF! Maybe trow little softer, captain?','',26124),
(44993,'enUS','Heavy... no can see notin.','',26124),
(44994,'enUS','Maybe captain carry one box too?','',26124),
(44995,'enUS','Ugh... dese boxes too heavy. Dey might fall!','',26124),
(44996,'enUS','Captain, pup need help!','',26124),
(44997,'enUS','Dis giving me a hernia. Captain, what is hernia?','',26124),
(44998,'enUS','ME NO SIGN UP FOR DIS! WAIT! Yes, me did sign up for dis.','',26124),
(44999,'enUS','Please, captain, I can put box down?','',26124),
(45000,'enUS','CAN NO SEE! WHERE TO GO!? WHAT DOING?!','',26124),
(45001,'enUS','Please... Kill... Me...','',26124),
(45002,'enUS','Dis hurt so bad. Like da time poop came out sideways.','',26124),
(45003,'enUS','NO MORE! DIS IS MAXI... MAXIMO... ME... DIS TOO MUCH!','',26124),
(45004,'enUS','Look out - I see another!','',26124),
(45005,'enUS','Fight them back - I can\'t hold this shield up much longer!','',26124),
(45006,'enUS','$n, you did it. It looks like they\'re fleeing.','',26124),
(45007,'enUS','I knew the puny ones weren\'t to be trusted!  Smash them!','',26124),
(45008,'enUS','Agghh!  So many of them!','',26124),
(45009,'enUS','You runts want to riot?  I\'ll show you!','',26124),
(45010,'enUS','','Forgemaster!  I\'ve been informed the enemy has disrupted your operations.  Where is the fragment?',26124),
(45011,'enUS','','Well done.  Meet me inside the Stonecore for further instructions.',26124),
(45012,'enUS','','Let\'s just say we have friends in high places, forgemaster.',26124),
(45013,'enUS','The fragment is now in the dragon\'s custody, ma\'am.','',26124),
(45014,'enUS','Of course, ma\'am.  At once!','',26124),
(45015,'enUS','If you don\'t mind me asking.  How did we manage to recover the fragment?  How did we infiltrate our enemies\' forces without their knowledge?','',26124),
(45016,'enUS','You hear rustling of heavy wings in the distance.  The matriarch approaches!','',26124),
(45017,'enUS','Hey $n, we don\'t have to tell my father about that little ambush. If he finds out about an attempt on my life, he\'d never allow me out of that keep...','',26124),
(45018,'enUS','','Who\'s not drunk, Torok?',26124),
(45019,'enUS','Including me?','',26124),
(45020,'enUS','','Yes.',26124),
(45021,'enUS','<hic!> Well... Let\'s see... By my count, nobody. The whole crew\'s drunk out of their gourds, admiral... \'cept the sea pups... <hic!>','',26124),
(45022,'enUS','','I\'ll burn this place to the ground before I am shamed in the eyes of Hellscream!',26124),
(45023,'enUS','I seem to have misplaced my sea pup, admiral. Do you have another that you could lend to me?','I seem to have misplaced my sea pup, admiral. Do you have another that you could lend to me?',26124),
(45024,'enUS','OOF!','',26124),
(45025,'enUS','Where to put? Dey falling! HELP!','',26124),
(45027,'enUS','This is the place. Samuelson\'s files should be on the third floor, all the way up the spiral staircase.','',26124),
(45028,'enUS','Here we go. Nobody here will question it if the Prince wants to glance through some files.','',26124),
(45029,'enUS','Hmmmm....','',26124),
(45030,'enUS','This is all wrong. There\'s nothing in here about the Twilight\'s Hammer. What is Samuelson playing at?','',26124),
(45042,'enUS','For the Alliance!','',26124),
(45043,'enUS','For the Horde!','',26124),
(45044,'enUS','Enough of this.  The Cult of the Damned doesn\'t need Andorhal.  This worthless city is yours to fight over.','',26124),
(45045,'enUS','Koltira!  I had heard rumors that you were here in Lordaeron.','',26124),
(45046,'enUS','You heard correctly, Thassarian.  I wanted to give you a chance to kill me again.','',26124),
(45047,'enUS','%s laughs.','',26124),
(45048,'enUS','It looks like it may have to come to that.','',26124),
(45049,'enUS','Yes, it may... but not today.  With the Scourge out of the way, I plan to pull my troops back and regroup.','',26124),
(45050,'enUS','I see.  Then I will do the same.','',26124),
(45051,'enUS','But you must be aware, Koltira: we are brothers no longer.  You are a member of the Horde now, and I of the Alliance.','',26124),
(45052,'enUS','Eventually, we will fight this battle for Andorhal, and only one of us can walk off of this battlefield victorious.','',26124),
(45053,'enUS','Yes, I know.  And don\'t think I\'ll go easy on you.','',26124),
(45054,'enUS','%s laughs.','',26124),
(45055,'enUS','Very well.  I look forward to it.','',26124),
(45056,'enUS','You are not to speak to ANYONE about the agreement that was made today, $n.  Consider this an order from your direct superior.','',26124),
(45059,'enUS','I\'ll go back to the throne room and keep an eye on Samuelson while you speak with Mathias. Stay safe!','',26124),
(45061,'enUS','What\'sh with the huuuuge bush chick-a-doodle?','',26124),
(45062,'enUS','It\'sh makin\' me hungry... why\'s it shooo big? You shome kind of idiot or shomething? Makin\' a chicken sho big... Who doesh that?','',26124),
(45063,'enUS','Forshaken do... that\'sh who...It\'sh sho big... Look at it\'sh big shtupid neck. I jusht want to choke it to death!','',26124),
(45069,'enUS','Touch my chicken and I will kill you in your sleep. Am I understood?','',26124),
(45075,'enUS','Here she comes, boss!','',26124),
(45076,'enUS','','There is little time for idle chatter. Our people are in crisis and every sin\'dorei has a role to play in our restoration.',26124),
(45077,'enUS','Welcome to the party, $g pal:lady;!','',26124),
(45078,'enUS','Thank you, friend. Let\'s kill us some overgrown... spiders. Sounded better in my head.','',26124),
(45079,'enUS','We gotta find the matriarch of this operation and end her!','',26124),
(45080,'enUS','I need a drink!','',26124),
(45085,'enUS','I can instruct you in blacksmithing as well as supply the necessary tools.$B$BHow may I help you?','I can instruct you in blacksmithing as well as supply the necessary tools.$B$BHow may I help you?',26124),
(45086,'enUS','I can instruct you in fishing, and sell fishing poles and supplies.$B$BHow may I help you?','I can instruct you in fishing, and sell fishing poles and supplies.$B$BHow may I help you?',26124),
(45087,'enUS','','Your soul is mine.',26124),
(45088,'enUS','','Rise, Forsaken!',26124),
(45089,'enUS','','You serve the Banshee Queen now, mortal.',26124),
(45090,'enUS','','Death is only the beginning.',26124),
(45091,'enUS','','Rise, $n! Become Forsaken!',26124),
(45092,'enUS','','Waste no time, $n. We mustn\'t keep the Banshee Queen waiting.',26124),
(45093,'enUS','','Different master, same insatiable thirst for power.',26124),
(45094,'enUS','','I sense doom in your future, $n.',26124),
(45095,'enUS','','The warmth of this place sickens me.',26124),
(45096,'enUS','','I long for the frozen wastes of Northrend.',26124),
(45097,'enUS','','Do you feel it, $n? The darkness surrounds us.',26124),
(45098,'enUS','','Life is meaningless. It is in the afterlife that we are truly tested.',26124),
(45099,'enUS','','Through me the Banshee Queen sees all...',26124),
(45100,'enUS','','He\'s coming.  Get ready, lads!',26124),
(45101,'enUS','The Bishop moves diagonally!','',26124),
(45102,'enUS','Bishop threatens pawn...','',26124),
(45103,'enUS','Check!','',26124),
(45104,'enUS','The game isn\'t over yet...','',26124),
(45105,'enUS','Pawn ... takes ... bishop ...','',26124),
(45106,'enUS','I am Forsaken.','I am Forsaken.',26124),
(45107,'enUS','For the glory of the Dark Lady!','For the glory of the Dark Lady!',26124),
(45108,'enUS','Wha... What has happened?','Wha... What has happened?',26124),
(45109,'enUS','I am eternal... I am death.','I am eternal... I am death.',26124),
(45110,'enUS','At your command.','At your command.',26124),
(45111,'enUS','I LIVE!','I LIVE!',26124),
(45112,'enUS','What have you done to me!?','What have you done to me!?',26124),
(45113,'enUS','The Black Bishop\'s shields dissipate as the wretched traitor breathes his last.','',26124),
(45114,'enUS','','Bow before your new master!',26124),
(45115,'enUS','','Rise and destroy our enemies!',26124),
(45116,'enUS','Thanks for helpin\' me out, mon!  No more shapeshifts for me... I\'m gonna work on my healing!','',26124),
(45117,'enUS','The game is afoot! But you are a mere pawn, whereas I am ... THE BLACK BISHOP!','',26124),
(45118,'enUS','Checkmate.','',26124),
(45119,'enUS','Greetings, young one, it is good to see a noble soul again.$B$BDire Maul, formerly Eldre\'thalas, is corrupt to its very core. I have watched my brethren fall to the forces of darkness and chaos. Many would have this place razed to the ground to end its horrors forever.$B$BBut Dire Maul is worth saving, mortal. Help me, and perhaps together we can unleash the vast power lost here for the forces of good, as they once were so long ago.','',26124),
(45120,'enUS','I can instruct you in fishing as well as offer helpful supplies.$B$BHow may I help you?','I can instruct you in fishing as well as offer helpful supplies.$B$BHow may I help you?',26124),
(45121,'enUS','I can instruct you in herbalism as well as offer helpful supplies.$B$BHow may I help you?','I can instruct you in herbalism as well as offer helpful supplies.$B$BHow may I help you?',26124),
(45122,'enUS','How may I be helpin\' ya, Child of de Earth?','How may I be helpin\' ya, Child of de Earth?',26124),
(45123,'enUS','Dark is de jungle, but fertile is its soil.$B$BMay de spirits of de earth watch over ya, $c.','Dark is de jungle, but fertile is its soil.$B$BMay de spirits of de earth watch over ya, $c.',26124),
(45124,'enUS','I wish to learn more of the earth spirits\' secrets. Please train me.','I wish to learn more of the earth spirits\' secrets. Please train me.',26124),
(45125,'enUS','Da Gordok no like Dagg\'thol, so he kill them. Da stupid trees and goat men no like Dagg\'thol, so he want kill them too.$B$BPuny $r like Dagg\'thol and help him take dis place for Master? Or does Dagg\'thol need kill you too?$B$BStupid tree keep staring at Ambassador Dagg\'thol...','',26124),
(45126,'enUS','I\'m completely out of supplies and the road is blocked by orcs, just my luck!','',26124),
(45127,'enUS','They come!','They come!',26124),
(45128,'enUS','Hurry, my lord! The enemy is upon us!','Hurry, my lord! The enemy is upon us!',26124),
(45129,'enUS','<The Major nods curtly.>','',26124),
(45130,'enUS','Back so soon, $n? Did you learn anything from the dockworkers?','',26124),
(45131,'enUS','It\'s over, Samuelson. We know who you are and I put a stop to your little cathedral scheme.','It\'s over, Samuelson. We know who you are and I put a stop to your little cathedral scheme.',26124),
(45132,'enUS','Don\'t we have ANY coffee left?','',26124),
(45133,'enUS','How do I always end up with these assignments?','',26124),
(45134,'enUS','Search for clues?  Here\'s a clue: it was the orcs.  Here\'s another clue: orcs smell.','',26124),
(45135,'enUS','My gut is telling me that it\'s about time we jump into action and start drinking.','',26124),
(45136,'enUS','Blasted lands - what a fitting name.  Blast this place, blast this keep, and blast the other identical keep.','',26124),
(45137,'enUS','I can\'t see!','',26124),
(45138,'enUS','The underside of this table is REALLY dirty!','',26124),
(45139,'enUS','I wonder if Ma Stonefield ever fixed the lock on that window...','',26124),
(45140,'enUS','Orcs!  It\'s the orcs!  No, wait, it\'s just Krolan\'s stomach again.','',26124),
(45141,'enUS','Yes... yes $c. It\'s all true. I am not ashamed. The powers I submit to make mortal kings look like insects.','',26124),
(45142,'enUS','I hate you, Nobsy.','',26124),
(45143,'enUS','I got a strange feelin\' in me gut, Commander.  Think it might have been that murloc fin soup?','',26124),
(45144,'enUS','At least ye didn\'t have to leave a wife back in Ironforge.  I can\'t imagine what she\'s up to without me around.  Ya ken how ladies are around ore.','',26124),
(45145,'enUS','D\'ya think Enohar might be willin ta spot us a few barrels o\' brew?  Helps the mind focus on strategizin\'.','',26124),
(45146,'enUS','%s suddenly draws out a hidden dagger!','',26124),
(45147,'enUS','But I am not yet finished. Death to the king!','',26124),
(45148,'enUS','Abyssion is approaching.  Get ready!','',26124),
(45149,'enUS','','I\'m down!  You must defeat him on your own!',26124),
(45150,'enUS','Father, watch out!','',26124),
(45151,'enUS','%s protects his father with Power Word: Shield.','',26124),
(45152,'enUS','No! I won\'t let you interfere!  My transformation is not yet complete!','',26124),
(45153,'enUS','Thank you for saving me!','Thank you for saving me!',26124),
(45154,'enUS','I need to get out of here!','I need to get out of here!',26124),
(45155,'enUS','I\'m free! Thank you!','I\'m free! Thank you!',26124),
(45156,'enUS','I thought I was going to die in there.','I thought I was going to die in there.',26124),
(45157,'enUS','It\'s lucky that you came along.','It\'s lucky that you came along.',26124),
(45158,'enUS','I care far too deeply about redeeming Eldre\'thalas to deal with any other matter. War, strife, allegiances, none of it matters until this city is safe.','',26124),
(45159,'enUS','May the light embrace you.','',26124),
(45160,'enUS','Farewell, $n.  Send my regards to the good men and women at the Menders\' Stead.','',26124),
(45161,'enUS','The Forsaken have broken through your defenses, magistrate.','',26124),
(45162,'enUS','You are out of time.','',26124),
(45163,'enUS','A decision must be made!','',26124),
(45164,'enUS','Die in battle and be raised as a servant of the Forsaken or...','',26124),
(45165,'enUS','Drink in my blood and be reborn as worgen, immune to the depravity of the Forsaken.\n','',26124),
(45166,'enUS','Help us destroy the Forsaken and retake Lordaeron for the Alliance!','',26124),
(45167,'enUS','We would rather die than be turned into worgen, but seeing as how even death provides no relief from the atrocities of this war...','',26124),
(45168,'enUS','We choose vengeance!','',26124),
(45169,'enUS','','I hope you have a strong stomach.  Travelling through the breach is not for the weak.',26124),
(45170,'enUS','','We\'re at the center of the Maelstrom, the rift between Deepholm and Azeroth.  Watch as it threatens to tear your world apart!',26124),
(45171,'enUS','','Let us hope Thrall and the others can contain it while you\'re inside.',26124),
(45172,'enUS','','This is it!  Brace yourself!',26124),
(45173,'enUS','','Deathwing\'s taint shall be wiped from Deepholm, and his Twilight cultists with it.',26124),
(45174,'enUS','The Alliance has successfully defended Tol Barad!','',26124),
(45175,'enUS','','You made it!  Good!',26124),
(45176,'enUS','','This is the Temple of Earth.  It\'s the most important structure in Deepholm.',26124),
(45177,'enUS','Gods of shadow, lords of twilight ... give me strength!','',26124),
(45178,'enUS','Stone troggs are attacking!','',26124),
(45179,'enUS','Here come more stone troggs. Defend the catapult!','',26124),
(45180,'enUS','','There was once a Titan-made stone inside.  It was known as the World Pillar.  The name was literal.  It bore the weight of all the elemental and magnetic forces in Deepholm.',26124),
(45181,'enUS',' Looks like a last ditch effort by the stone troggs. Your destination is just around the corner!','',26124),
(45182,'enUS','','It was shattered when Deathwing broke through the dome above and created the rift between the two worlds.  All of Deepholm is going to collapse into Azeroth if we do not put the World Pillar back together.',26124),
(45184,'enUS','','Run...',26124),
(45185,'enUS','','RUN!',26124),
(45186,'enUS','','The first fragment was going to be delivered to us by a Horde gunship known as the Storm\'s Fury.  It never made it here.',26124),
(45187,'enUS','','We\'ve taken control of the temple and we\'re containing as much of the damage as we can.  Go inside and speak to Maruut; he\'s in charge.',26124),
(45188,'enUS','The Horde has successfully defended Tol Barad!','',26124),
(45189,'enUS','The Alliance has successfully taken Tol Barad!','',26124),
(45190,'enUS','The Horde has successfully taken Tol Barad!','',26124),
(45191,'enUS','','We are all counting on you.',26124),
(45192,'enUS','Al\'golath mal shal\'nel... darkness consumes... ','',26124),
(45193,'enUS','','This way, $n. We will take them by surprise.',26124),
(45194,'enUS','I was in Ironforge during the takeover - it was chaos.$B$BNo wonder father gets so protective when I leave the keep. ','',26124),
(45195,'enUS','We\'ve got to get out of here!','',26124),
(45196,'enUS','What WAS that thing?','',26124),
(45197,'enUS','Hm?','',26124),
(45198,'enUS','How did you manage to get here on foot alive? You must be quite the hero to brave Dire Maul.','',26124),
(45199,'enUS','Alright, here we go!','',26124),
(45200,'enUS','Come in, mon... forget yer cares for a while!$B$BRest de body, rest de soul.','Come in, mon... forget yer cares for a while!$B$BRest de body, rest de soul.',26124),
(45201,'enUS','','I have not always been the Banshee Queen, $n.',26124),
(45202,'enUS','','And my people have not always been the Forsaken.',26124),
(45203,'enUS','','Long ago this land comprised the northern kingdoms of Lordaeron, ruled by King Terenas Menethil.',26124),
(45204,'enUS','','Terenas had a son named Arthas.',26124),
(45205,'enUS','','Arthas... even saying his name makes my body quiver in rage.',26124),
(45206,'enUS','','This man-child, Arthas, took for himself a cursed blade known as Frostmourne.',26124),
(45207,'enUS','','Through Frostmourne, Arthas killed his own father and razed this land along with every living creature in it!',26124),
(45208,'enUS','','My own death came at the hands of Arthas when he and his armies sacked my homeland, Quel\'Thalas, and murdered my people.',26124),
(45209,'enUS','','In his vast cruelty, Arthas severed my spirit from my body and raised me as a banshee to serve in his Scourge army.',26124),
(45210,'enUS','','A similar fate befell all that would die to the Scourge war machine.',26124),
(45211,'enUS','','Cleanse your soul in the flames of the abyss!',26124),
(45212,'enUS','','Repent, mortals!  Repent in the face of unstoppable annihilation!',26124),
(45214,'enUS','','Bow down before your superiors, and you may yet survive the destruction of this puny world!',26124),
(45215,'enUS','','Sacrifice the nonbeliever!  In the name of Sargeras!',26124),
(45216,'enUS','','The eyes of the great lord Sargeras can see your betrayal, your desires, your utter destruction!',26124),
(45217,'enUS','','In death, they were reborn as mindless undead.',26124),
(45218,'enUS','','But Arthas was not invincible! With each passing day his power waned - his grip over the will of the damned loosening.',26124),
(45219,'enUS','','It was when Arthas was at his weakest that I struck!',26124),
(45220,'enUS','','And though the hour of his atonement had come, the worm managed to escape his fate, returning to the frozen wastes of Northrend.',26124),
(45221,'enUS','','With Arthas gone, so too was the control he held over the undead masses of Lordaeron. After recovering my body, I freed the remaining Scourge that were left behind.',26124),
(45222,'enUS','','From the cruelty and mercilessness of Arthas, the man who would be the Lich King, the Forsaken were born.',26124),
(45223,'enUS','','Our goal... Our sole purpose was to destroy the Lich King. We threw our lot in with the Horde and began our journey towards redemption.',26124),
(45224,'enUS','','Now the Lich King is dead and we have returned. ',26124),
(45225,'enUS','','The people who called this land their home in life, do so in death as well.',26124),
(45226,'enUS','','But the Alliance does not recognize our rights. They claim this land is their own while attempting to invalidate the claims of the founders of this kingdom.',26124),
(45227,'enUS','','I will never allow it... Never!',26124),
(45228,'enUS','','Lordaeron belongs to the Forsaken - always and forever.\n',26124),
(45229,'enUS','','The materials I offer are rare and powerful.',26124),
(45230,'enUS','You have proven capable. Resourceful. I think you will be the one to take the fight to the gyreworms where we cannot. You will be the one to make your way deep into the Crumbling Depths, the only place where we cannot pass.','',26124),
(45231,'enUS','INFERNO!','',26124),
(45232,'enUS','The legion will conquer all!','',26124),
(45233,'enUS','Go forth, minions of destruction, and bathe this world in the flames of the twisting nether!','',26124),
(45234,'enUS','The sky darkens with your impending demise!','',26124),
(45235,'enUS','The time has come!  March onward, and bring doom to the frightened denizens of this blasted land!','',26124),
(45236,'enUS','NOOOOOO! You tell Goldmine he\'s a dead goblin! Our contract is over!','',26124),
(45237,'enUS','The Stonescale Matriarch is snared!  Avoid her attacks by staying on the move!','',26124),
(45238,'enUS','Deepholm? I hate this place. Wait... you\'re not Initiate Goldmine!','',26124),
(45239,'enUS','I know what you\'re after. I can sense it!','',26124),
(45240,'enUS','This is not in my contract! Die, $r!','',26124),
(45241,'enUS','Um, Goldmine, I seem to have misplaced your fire totem.','Um, Goldmine, I seem to have misplaced your fire totem.',26124),
(45242,'enUS','I\'m not made of fire totems, you know!','',26124),
(45243,'enUS','Weldon is nothing more than a damned coward. He fled from the scourge and now dares to come here as if he were some sort of hero?$B$BBah!','',26124),
(45244,'enUS','Don\'t listen to anything Alexi says. He was a fool to stay during the plague and now look at him - he\'s no better than the other abominations in this place.$B$BDon\'t fret, we will reclaim Scholomance and the surrounding lands for the last living son of Barov - the rightful heir.','',26124),
(45245,'enUS','','Koltira!  Your queen summons you!',26124),
(45246,'enUS','Your highness.  I deliver to you... Andorhal.','',26124),
(45247,'enUS','','Enough of this insolence.  Do you think that I\'m blind to everything that goes on outside of the Undercity?',26124),
(45248,'enUS','I... your majesty, we were victorious!','',26124),
(45249,'enUS','','No thanks to you.  Andorhal should have been ours days ago, when we defeated the Scourge.',26124),
(45250,'enUS','','I know your secret, Koltira.  I\'m aware of your friendship with the Alliance death knight, Thassarian.',26124),
(45251,'enUS','Y... your majesty...','',26124),
(45252,'enUS','','Arthas clearly failed when he created his death knights.  You are still weak.',26124),
(45253,'enUS','','Fortunately, I have agents that can help you... erase this weakness.  Beneath the Undercity you go.',26124),
(45254,'enUS','No!','',26124),
(45255,'enUS','','Shh... quiet, death knight.  When I\'m finished with you, your fear will be gone.',26124),
(45256,'enUS','','You can thank me later.',26124),
(45257,'enUS','You\'re not thinkin\' about stealing my explosives again, are ya?','',26124),
(45258,'enUS','Just look at this place!$b$bIt\'s an archaeologist\'s dream...','',26124),
(45259,'enUS','How about you don\'t go runnin\' off with my explosives this time, okay?','',26124),
(45260,'enUS','I\'d love to stop and chat awhile, but these explosives aren\'t going to move themselves...','',26124),
(45261,'enUS','The triumphant $g hero : heroine; returns!$B$BYou haven\'t seen Magmatooth around, have you?$B$B<The initiate looks worried.>','',26124),
(45262,'enUS','','Keep starin\', I don\'t get any prettier.',26124),
(45263,'enUS','DEBUG Event Sent - North - Horde Progress','',26124),
(45264,'enUS','DEBUG Event Sent - North - Alliance Progress','',26124),
(45265,'enUS','DEBUG Event Sent - North - Horde Contested','',26124),
(45266,'enUS','DEBUG Event Sent - North - Alliance Contested','',26124),
(45267,'enUS','The rifts are down and Thunder Bluff is safe!  These portals must be the second half of their attack.$B$BQuickly! Into the portal! We must press the attack while we have the advantage!','',26124),
(45268,'enUS','DEBUG Event Sent - North - Horde Neutral','',26124),
(45269,'enUS','DEBUG Event Sent - North - Alliance Neutral','',26124),
(45270,'enUS','DEBUG Event Sent - North - Alliance Win','',26124),
(45271,'enUS','DEBUG Event Sent - North - Horde Win','',26124),
(45272,'enUS','They can drain the Loch until it\'s little more than a drip of mud, and we\'ll still fight to keep it ours.','',26124),
(45273,'enUS','','$n, may I have a moment of your time?',26124),
(45274,'enUS','De secrets I have ta share would blast your soul apart, $c.$B$BTrust me: You be wantin\' ta talk ta someone else about trainin\'.','De secrets I have ta share would blast your soul apart, $c.$B$BTrust me: You be wantin\' ta talk ta someone else about trainin\'.',26124),
(45275,'enUS','Who knows what dark an\' horrid tings be gibberin\' in de outer darkness... tings dat\'d drive a soul mad ta see?$B$B-We- be knowin\'. An\' you\'ve come lookin\' ta know -more,- haven\'t ya?','Who knows what dark an\' horrid tings be gibberin\' in de outer darkness... tings dat\'d drive a soul mad ta see?$B$B-We- be knowin\'. An\' you\'ve come lookin\' ta know -more,- haven\'t ya?',26124),
(45276,'enUS','Greetin\'s, $n.  Are ya here ta be learnin\' of de Hidden Arts?','Greetin\'s, $n.  Are ya here ta be learnin\' of de Hidden Arts?',26124),
(45277,'enUS','Greetin\'s, $c.\n\nIt be a sad ting, de way de secrets of de world are hidden from ya: Time, Fate, de burnin\' stars an\' de cold, cold darkness between... never will ya know de truth of such tings!','Greetin\'s, $c.\n\nIt be a sad ting, de way de secrets of de world are hidden from ya: Time, Fate, de burnin\' stars an\' de cold, cold darkness between... never will ya know de truth of such tings!',26124),
(45278,'enUS','Let me know when you\'re ready, $n.','',26124),
(45279,'enUS','Just let me know when you\'re ready for the ritual, $n.','',26124),
(45280,'enUS','Kill nearest mystic.','',26124),
(45281,'enUS','Prepare to die, $r!','',26124),
(45282,'enUS','You just let Zen\'Kiki know when you\'re ready!  I\'ll bring one of these birds down for ya!','',26124),
(45283,'enUS','AYYYIEEE!!','AYYYIEEE!!',26124),
(45284,'enUS','Whoa... easy, now.','',26124),
(45286,'enUS','Quick, $n! Into the chests!','',26124),
(45287,'enUS','Good day, $g brave: fair; $c.  How can I be of service?','',26124),
(45288,'enUS','Have you noticed anything strange lately?  Any new customers in the blacksmith shop?','Have you noticed anything strange lately?  Any new customers in the blacksmith shop?',26124),
(45289,'enUS','Well, let\'s see... I saw some drudges running away from that mine over there.  Said something about a spider.  New customers?  Well, there\'s Jeralee, the lovely young gnome, who bought an axe twice her size last week.  Oh, and Magus Bisp came by asking for armor.  Not sure why he\'d need plate armor...','',26124),
(45290,'enUS','Can I help you?','',26124),
(45291,'enUS','Have you noticed anything strange lately?  Any new customers, buying anything suspicious?','Have you noticed anything strange lately?  Any new customers, buying anything suspicious?',26124),
(45292,'enUS','What is this, an interrogation?  You\'re not one of Fordring\'s internal affairs guys, are you?$b$bWell, I\'ve got nothing to hide.  Let me look over my records.  Last week I sold a ball gown to Lieutenant Myner, which struck me as odd.  What else... Magus Bisp bought several dozen leather jerkins, which he couldn\'t give a reason for.  Oh, and Friar Burlingham came by to stock up on swimwear for his trip to Hardwrench Hideaway.  That\'s about it.$b$bNow if you don\'t mind, I have customers!','',26124),
(45293,'enUS','','Hello there, $c!',26124),
(45294,'enUS','Hello, ma\'am.  Heard any interesting rumors lately?','Hello, ma\'am.  Heard any interesting rumors lately?',26124),
(45295,'enUS','','Well, let\'s see.  I heard that Magus Bisp has been spending his time cooped up on top of his tower, working on some new spell, or something.$b$bI heard that Del Gahrron was planning on retiring and heading back to his farm.  He may have already left, in fact.$b$bOh, and I heard that there\'s some $r $c running around town, asking people all sorts of annoying questions!$b$bJust playing with you, love.  Hope that information helped.',26124),
(45296,'enUS','May the Light watch over you, child.  And how may I help you this fine day?','',26124),
(45297,'enUS','I\'m looking for someone who may have stolen some supplies from Hearthglen.  Have any leads for me?','I\'m looking for someone who may have stolen some supplies from Hearthglen.  Have any leads for me?',26124),
(45298,'enUS','Stolen supplies?  Well, let me think about it...$b$bI know a certain priest named Daria who took all the extra wine after last week\'s service, but didn\'t throw it out as I asked.  I believe she\'ll be apologizing soon, though.$b$b<Alphus winks at you.>$b$bI\'ve also heard an abnormal number of confessions this week from one of the mages... what was his name?  Crisp?  Lisp?  Something along those lines.$b$bNow, be on your way.','',26124),
(45299,'enUS','W-what are you doing up here, $r?  Can\'t you see you\'re interfering with OFFICIAL ARGENT CRUSADE BUSINESS!?','',26124),
(45300,'enUS','I was just wondering what you knew about the gnolls to the south.  Someone has been giving them supplies to practice necromancy.','I was just wondering what you knew about the gnolls to the south.  Someone has been giving them supplies to practice necromancy.',26124),
(45301,'enUS','You\'ll pay with your life for interfering with my plans, you miserable scum!','',26124),
(45302,'enUS','<Grunt>$b$bYou need something, $r?','<Grunt>$b$bYou need something, $r?',26124),
(45303,'enUS','What is it?  I\'m a little busy here.','What is it?  I\'m a little busy here.',26124),
(45304,'enUS','I\'m training right now.  Can this wait?','I\'m training right now.  Can this wait?',26124),
(45305,'enUS','Yes?','Yes?',26124),
(45306,'enUS','Lieutenant Myner asked me to challenge you to a duel.','Lieutenant Myner asked me to challenge you to a duel.',26124),
(45307,'enUS','Fine.  You want some of this?','Fine.  You want some of this?',26124),
(45308,'enUS','The time for the Crusade is now!','The time for the Crusade is now!',26124),
(45309,'enUS','Fine... but I won\'t hold back!','Fine... but I won\'t hold back!',26124),
(45311,'enUS','Get ready, \'cause here I come!','Get ready, \'cause here I come!',26124),
(45312,'enUS','Well fought.','Well fought.',26124),
(45313,'enUS','I suppose I need some more practice.','I suppose I need some more practice.',26124),
(45314,'enUS','Mom was right... I\'ll NEVER make it into the Argent Crusade.','Mom was right... I\'ll NEVER make it into the Argent Crusade.',26124),
(45315,'enUS','You win.  This time.','You win.  This time.',26124),
(45316,'enUS','%s fires up the Goblin Barbecue!  Get ready to party!','%s fires up the Goblin Barbecue!  Get ready to party!',26124),
(45317,'enUS','You\'d be surprised how often that works.','',26124),
(45318,'enUS','Hefting','Hefting',26124),
(45319,'enUS','The fleet was mostly intact as it limped into harbor after our engagement with the Horde. We weighed anchor in the shadow of Highbank here to regroup.$B$BThen the naga came.$B$BScaly, glistening hands clambering up the anchor chains... dragging men, screaming, into the depths...$B$BThese are cursed shores, $n. Cursed. ','',26124),
(45320,'enUS','Slaughter them, $c! Destroy as many naga as you can to honor those that fell.','',26124),
(45321,'enUS','The broodmother flies above us! Do not fear, fleshling, I am called \"The Steady\" for a reason...','',26124),
(45322,'enUS','Jump from rock to rock to attract the attention of the Broodmother!','',26124),
(45323,'enUS','We cannot fail, $n.  The future of multiple worlds is at stake here.','',26124),
(45324,'enUS','You no take crate!','',26124),
(45325,'enUS','Thanks... this\'ll give us a couple more hours of not running into the rocks.  No guarantees after that.','',26124),
(45326,'enUS','Take me to Baradin Hold.','Take me to Baradin Hold.',26124),
(45327,'enUS','Take me to the Slagworks.','Take me to the Slagworks.',26124),
(45328,'enUS','Take me to the Ironclad Garrison.','Take me to the Ironclad Garrison.',26124),
(45329,'enUS','Throw me back up!','Throw me back up!',26124),
(45330,'enUS','Take me to the Warden\'s Vigil.','Take me to the Warden\'s Vigil.',26124),
(45331,'enUS','Take me to the East Spire.','Take me to the East Spire.',26124),
(45332,'enUS','Take me to the West Spire.','Take me to the West Spire.',26124),
(45333,'enUS','Take me to the South Spire.','Take me to the South Spire.',26124),
(45334,'enUS','I must be going now...','',26124),
(45335,'enUS','Well, I\'ve said my goodbyes.  Time to move on.','',26124),
(45336,'enUS','I\'ve waited here for too long.  Time to say goodbye.','',26124),
(45337,'enUS','I... I think I\'m ready to leave now.','',26124),
(45338,'enUS','Who are you?  What have you done to me?','',26124),
(45339,'enUS','Get away from here!','',26124),
(45340,'enUS','You thoughtless $r!  You\'ll pay for your interference!','',26124),
(45341,'enUS','Fool!','',26124),
(45342,'enUS','The rifts are down and Orgrimmar is safe!  These portals must be the second half of their attack.$B$BQuickly! Into the portal! We must press the attack while we have the advantage!','',26124),
(45343,'enUS','Sorry about my earlier rudeness. I was worried about my father. Friends?','',26124),
(45344,'enUS','I\'ll see to it that you get the middle fragment of the World Pillar.','',26124),
(45345,'enUS','How may I assist you in the afterlife?','How may I assist you in the afterlife?',26124),
(45347,'enUS','I am unable to assist you.','I am unable to assist you.',26124),
(45348,'enUS','Here she comes. Oh, foul temptress of the sea...','',26124),
(45349,'enUS','Avert yer eyes! Don\'t look at her!','',26124),
(45350,'enUS','Don\'t listen to her voice!','',26124),
(45351,'enUS','Don\'t look at her... ruby red... soft... sensual lips! Oh...','',26124),
(45352,'enUS','There! She reveals herself. Attack!','',26124),
(45353,'enUS','Inspecting','Inspecting',26124),
(45354,'enUS','This crate looks like it was used to store weapons and armor.','',26124),
(45355,'enUS','','Glad to have a chance to catch my breath. Thanks for the help!',26124),
(45356,'enUS','Thought I couldn\'t handle them? Don\'t let my size be follin\' ya. Anyway, thanks for the hand.','',26124),
(45357,'enUS','','Good to see you again! Thanks for the hand. I\'ll be back on my feet in just a moment.',26124),
(45358,'enUS','I can\'t see a thing with this mask on, but I\'m not about to tell HER that.','',26124),
(45359,'enUS','Weapons...armor...these are the keys to victory. Any warrior, no matter how strong, is essentially defenseless without them.$B$BI have crafted many a legend in my day, $r. You will find nothing like them in all of Azeroth. They are the key to my brethren\'s success.','',26124),
(45360,'enUS','Gory always wanted to be a farmer.','',26124),
(45361,'enUS','Gory just happy to be in the sun.','',26124),
(45362,'enUS','Gory wants to help out on farm.  Gory already has his own scythe!','',26124),
(45363,'enUS','Gory not very good at planting, but Gory VERY good at reaping.','',26124),
(45364,'enUS','If you really want to help out, you can help me and my friends with some combat practice.','If you really want to help out, you can help me and my friends with some combat practice.',26124),
(45365,'enUS','These so-called paladins won\'t let me through so I can see if any of the legendary Fras Siabi\'s famous tobacco remains in Stratholme! They\'re no better than the scourge, if you ask me.$B$BBetween you an\' me, I think their \'brotherhood of the light\' is a hoax. An elaborate ploy I tell ya!','',26124),
(45366,'enUS','You want to fight?  Alright, Gory fight.','',26124),
(45367,'enUS','Gory give up!  You farmers fight more good!','',26124),
(45368,'enUS','Come to die, have you?','',26124),
(45369,'enUS','Shovel meet head!','',26124),
(45370,'enUS','You take a wrong turn, mon? Heh heh heh.\n\nWhat can I be helpin\' ya find?','You take a wrong turn, mon? Heh heh heh.\n\nWhat can I be helpin\' ya find?',26124),
(45371,'enUS','Don\'t see many a\' your kind \'round here, mon.\n\nWhat can I be helpin\' ya find?','Don\'t see many a\' your kind \'round here, mon.\n\nWhat can I be helpin\' ya find?',26124),
(45372,'enUS','This rock is about to fall! Jump to another!','This rock is about to fall! Jump to another!',26124),
(45373,'enUS','You be a LONG way from home, mon. Heh heh heh.\n\nWhat can I be helpin\' ya find?','You be a LONG way from home, mon. Heh heh heh.\n\nWhat can I be helpin\' ya find?',26124),
(45374,'enUS','Hey, mon. What can I be helpin\' ya find?','Hey, mon. What can I be helpin\' ya find?',26124),
(45375,'enUS','I\'ve been meaning to investigate this site.$b$bNo time like the present!','',26124),
(45376,'enUS','Barber','Barber',26124),
(45377,'enUS','Battlemasters','Battlemasters',26124),
(45378,'enUS','Class Trainer','Class Trainer',26124),
(45379,'enUS','Flight Master','Flight Master',26124),
(45380,'enUS','Guild Master & Vendor','Guild Master & Vendor',26124),
(45381,'enUS','Mailbox','Mailbox',26124),
(45382,'enUS','Profession Trainer','Profession Trainer',26124),
(45383,'enUS','Stable Master','Stable Master',26124),
(45385,'enUS','She\'s beautiful...','',26124),
(45386,'enUS','Ready then? Let\'s get a move on! Try and keep up, $n.','',26124),
(45387,'enUS','Onward, brothers and sisters!','',26124),
(45388,'enUS','What\'s this then?','',26124),
(45389,'enUS','Your doom!','',26124),
(45391,'enUS','BOMB! IT\'S A TRAP! RUN!','',26124),
(45392,'enUS','I\'m ready, Doctor Jones!','I\'m ready, Doctor Jones!',26124),
(45393,'enUS','I\'ve heard much about you, $n.  The world needs people like you now more than ever.','',26124),
(45394,'enUS','Remember this day as the day that Forteski saved your hide. Now run! Get back to Sylvanas!','',26124),
(45395,'enUS','Hey der, mon.$B$BDid ya want ta be stablin\' yer pets, or were ya lookin\' for a lost companion?','Hey der, mon.$B$BDid ya want ta be stablin\' yer pets, or were ya lookin\' for a lost companion?',26124),
(45396,'enUS','Hey der, mon.$B$BDid ya need help recoverin\' a lost companion?','Hey der, mon.$B$BDid ya need help recoverin\' a lost companion?',26124),
(45397,'enUS','Sorry, $c.$B$BI ain\'t believin\' ya got de right mind for graspin\' de nature of portal magic.','Sorry, $c.$B$BI ain\'t believin\' ya got de right mind for graspin\' de nature of portal magic.',26124),
(45398,'enUS','Hey der, mon.$B$BIf ya be ready, I can teach ya how ta be conjurin\' up a portal back ta dis place...','Hey der, mon.$B$BIf ya be ready, I can teach ya how ta be conjurin\' up a portal back ta dis place...',26124),
(45399,'enUS','De auction house and bank be at de top of de tall building in de middle of de valley, mon.$B$BLook for Ziji and Makavu.','De auction house and bank be at de top of de tall building in de middle of de valley, mon.$B$BLook for Ziji and Makavu.',26124),
(45400,'enUS','You be wantin\' Sijambi, mon.$B$BShe be in de tall building in de middle of de valley.','You be wantin\' Sijambi, mon.$B$BShe be in de tall building in de middle of de valley.',26124),
(45401,'enUS','Right outside de valley\'s inn, mon.$B$BIt be de tall building in de middle.','Right outside de valley\'s inn, mon.$B$BIt be de tall building in de middle.',26124),
(45402,'enUS','Which ya be lookin\' for?','Which ya be lookin\' for?',26124),
(45403,'enUS','Hunter','Hunter',26124),
(45404,'enUS','Mage','Mage',26124),
(45405,'enUS','Priest','Priest',26124),
(45406,'enUS','Rogue','Rogue',26124),
(45407,'enUS','Warlock','Warlock',26124),
(45408,'enUS','Warrior','Warrior',26124),
(45409,'enUS','Druid','Druid',26124),
(45410,'enUS','Shaman','Shaman',26124),
(45411,'enUS','Mage & Portal','Mage & Portal',26124),
(45412,'enUS','The Brotherhood of the Light transcends the ability of any other group to eradicate affronts to the Light. We will take any actions necessary to rid the world of foul beasts like these undead. Nothing will stand in our way.$B$BAre you with us, or against us?','',26124),
(45413,'enUS','Witch Doctor Umbu spends his time walkin\' about de valley, tendin\' to de people and elemental spirits alike.$B$BLook for him around de central building.','Witch Doctor Umbu spends his time walkin\' about de valley, tendin\' to de people and elemental spirits alike.$B$BLook for him around de central building.',26124),
(45414,'enUS','Kuzari and Zanga are trainin\' headhunters on one of de small islets towards de southeast end of de valley, mon.','Kuzari and Zanga are trainin\' headhunters on one of de small islets towards de southeast end of de valley, mon.',26124),
(45415,'enUS','Break this unnatural thing!','Break this unnatural thing!',26124),
(45416,'enUS','You\'re polluting our new home!','You\'re polluting our new home!',26124),
(45417,'enUS','To arms, brothers and sisters! They are destroying the land!','To arms, brothers and sisters! They are destroying the land!',26124),
(45418,'enUS','Find your black gold somewhere else!','Find your black gold somewhere else!',26124),
(45419,'enUS','There Will Be Blood!','There Will Be Blood!',26124),
(45420,'enUS','Junk shot that thing!','Junk shot that thing!',26124),
(45421,'enUS','Cap it!','Cap it!',26124),
(45423,'enUS','No gold for oil!','No gold for oil!',26124),
(45424,'enUS','Dey be on top of de tall building in de southeast end of de valley.','Dey be on top of de tall building in de southeast end of de valley.',26124),
(45425,'enUS','There are no emotions. There are no morals. There are no zealots.$B$BThere is only the Brotherhood.$B$BHere, in the very chapel where Uther the Lightbringer joined the Order of the Silver Hand, I, Korfax, Champion of the Light, will inspire fear into the fearless.$B$BNothing will curb my fury - not the Scarlet Crusade, not the Argent Dawn, not my brothers, not even you.','',26124),
(45426,'enUS','Like an angel...','',26124),
(45427,'enUS','','This may look like a losing battle, but the Scarlet Crusade will prevail. I believe wholly in our capability to eradicate the scourge in Stratholme. And though I do not look favorably upon the Argent Dawn, the Brotherhood of the Light is much closer to how I like to work.$B$BEnough idle chatter, $c. Let\'s get started. ',26124),
(45428,'enUS','Shadow-Walker Zuru can help ya.$B$BYou\'ll find him on de lowest floor of de taller building in de southeast.','Shadow-Walker Zuru can help ya.$B$BYou\'ll find him on de lowest floor of de taller building in de southeast.',26124),
(45429,'enUS','Ku\'nanji, de Night-Stalker, is who yer lookin\' for.$B$BHe be just north of de Valley of Spirits\' central building.','Ku\'nanji, de Night-Stalker, is who yer lookin\' for.$B$BHe be just north of de Valley of Spirits\' central building.',26124),
(45430,'enUS','You be lookin\' for Sesebi, mon.$B$BShe most often be sleepin\' under de tree by old Umbehto, de fisherman, lookin\' like a big ol\' tiger.','You be lookin\' for Sesebi, mon.$B$BShe most often be sleepin\' under de tree by old Umbehto, de fisherman, lookin\' like a big ol\' tiger.',26124),
(45431,'enUS','You be crazy, mon, meddlin\' with dat bad mojo. But I ain\'t one ta stop ya.$B$BUnjari Feltongue is in de taller building in de southeast, past de shadow priest\'s shrine.','You be crazy, mon, meddlin\' with dat bad mojo. But I ain\'t one ta stop ya.$B$BUnjari Feltongue is in de taller building in de southeast, past de shadow priest\'s shrine.',26124),
(45432,'enUS','Cooking','Cooking',26124),
(45433,'enUS','Zamja be de best cook in Orgrimmar, mon.$B$BYou can find her just south of de valley\'s central building. Batamsi sells de food Zamja makes, too, if ya just be hungry.','Zamja be de best cook in Orgrimmar, mon.$B$BYou can find her just south of de valley\'s central building. Batamsi sells de food Zamja makes, too, if ya just be hungry.',26124),
(45434,'enUS','Herbalism','Herbalism',26124),
(45435,'enUS','Jandi and Zeal\'aya work from a hut just north of de valley\'s central building.$B$BDey can help ya wit\' whatever ya need, mon.','Jandi and Zeal\'aya work from a hut just north of de valley\'s central building.$B$BDey can help ya wit\' whatever ya need, mon.',26124),
(45436,'enUS','Fishing','Fishing',26124),
(45437,'enUS','AAAAAAAAAALLLLLLLLLLEEEEEEEEE!!! ARRRRRRRRGGGHHHH!','',26124),
(45438,'enUS','Crush and clobber! Bobber slobber!','',26124),
(45439,'enUS','HELL OF A KICK TO THAT ALE!','',26124),
(45440,'enUS','My power has returned!','',26124),
(45441,'enUS','ORC NEEDS PEANUTS!','',26124),
(45442,'enUS','I may or may not have pissed myself.','',26124),
(45443,'enUS','Old Umbehto be on a lil\' islet east of de valley\'s central buildin\'.','Old Umbehto be on a lil\' islet east of de valley\'s central buildin\'.',26124),
(45444,'enUS','General Goods','General Goods',26124),
(45445,'enUS','Trade Supplies','Trade Supplies',26124),
(45446,'enUS','Poisons & Reagents','Poisons & Reagents',26124),
(45447,'enUS','Pet Snakes','Pet Snakes',26124),
(45448,'enUS','Huju and Xen\'to can take care of ya.$B$BFind dem in de valley\'s central building, mon.','Huju and Xen\'to can take care of ya.$B$BFind dem in de valley\'s central building, mon.',26124),
(45449,'enUS','','Kneel, Alliance!  Kneel before the might of the Forsaken!',26124),
(45451,'enUS','Hold fast, $c. This is for yer own protection.','',26124),
(45452,'enUS','A small group of us, druids and sentinels, have come to aid the tauren of Freewind Post with our common enemy: the Grimtotem Clan.','',26124),
(45453,'enUS','The East Spire has been heavily damaged!','',26124),
(45454,'enUS','The East Spire has been destroyed!','',26124),
(45455,'enUS','Xan\'tish and his snakes are slitherin\' around de valley\'s central building, mon.','Xan\'tish and his snakes are slitherin\' around de valley\'s central building, mon.',26124),
(45456,'enUS','The West Spire has been destroyed!','',26124),
(45457,'enUS','The West Spire has been heavily damaged!','',26124),
(45458,'enUS','The South Spire has been heavily damaged!','',26124),
(45459,'enUS','The South Spire has been destroyed!','',26124),
(45460,'enUS','','They attacked us when the waters rushed in! It was almost as if they knew what was going to happen.$B$BThey should all suffer for what they\'ve done.',26124),
(45461,'enUS','','You, too, shall serve!',26124),
(45462,'enUS','The Alliance has lost control of the Ironclad Garrison!','',26124),
(45463,'enUS','The Alliance has gained control of the Ironclad Garrison!','',26124),
(45464,'enUS','The Horde has taken the Ironclad Garrison!','',26124),
(45465,'enUS','The Horde has lost the Ironclad Garrison!','',26124),
(45466,'enUS','The Alliance has lost control of the Slagworks!','',26124),
(45467,'enUS','The Alliance has gained control of the Slagworks!','',26124),
(45468,'enUS','The Horde has taken the Slagworks!','',26124),
(45469,'enUS','The Horde has lost the Slagworks!','',26124),
(45470,'enUS','The Alliance has lost control of Warden\'s Vigil!','',26124),
(45471,'enUS','The Alliance has gained control of Warden\'s Vigil!','',26124),
(45472,'enUS','The Horde has taken Warden\'s Vigil!','',26124),
(45473,'enUS','The Horde has lost Warden\'s Vigil!','',26124),
(45474,'enUS','Watch your step!','',26124),
(45475,'enUS','Let\'s go, $n. Stay close.','',26124),
(45476,'enUS','Stay alert, now. There\'s no telling what we might run into down here...','',26124),
(45477,'enUS','If you should need reagents, I have a full selection available.','',26124),
(45478,'enUS','I cannot offer ya trainin\', friend.','I cannot offer ya trainin\', friend.',26124),
(45479,'enUS','Welcome ta Moonglade, $c. All be welcome \'ere, as long as ya be keepin\' the sacred peace.','Welcome ta Moonglade, $c. All be welcome \'ere, as long as ya be keepin\' the sacred peace.',26124),
(45480,'enUS','','If you desire, in addition to training, I have it within my power to erase the knowledge of your talents from your mind.  Be warned that every time you undergo this procedure the more difficult it is to perform, and therefore the more expensive it becomes.',26124),
(45481,'enUS','I. AM. UNLEASHED!','',26124),
(45482,'enUS','Nothing more than dust in the wind.','',26124),
(45483,'enUS','Winds of the south, rise and come to your master\'s aid!','',26124),
(45484,'enUS','The sky... Beckons...','',26124),
(45485,'enUS','Suffer the storm!','',26124),
(45486,'enUS','Your city will be buried, your lives forfeit to the elements!','',26124),
(45487,'enUS','Cower before the tempest storm!','',26124),
(45488,'enUS','I will need some time to study these samples, $n.  I will speak to you again when I have completed my analysis.','',26124),
(45489,'enUS','We are winning this battle, $n.  As long as those farmers keep chipping away at the Forsaken\'s flanks, we will overtake them.','',26124),
(45490,'enUS','I spoke too quickly, $n.  Even with your support, things are looking grim for our forces out there.','',26124),
(45491,'enUS','I hadn\'t planned on fighting soldiers AND farmers.  With these farmers nipping at our flank, we risk losing focus on the task at hand: taking Andorhal.','',26124),
(45492,'enUS','','Now this is how you win a war!  Someone ought to teach that death knight some military strategy.',26124),
(45493,'enUS','','Ishnu-alah, $c. Good fortune to you.',26124),
(45494,'enUS','','I will rejoin you soon. We will teach these Grimtotem savages the meaning of honor.',26124),
(45495,'enUS','Is that a.. a val\'kyr?','',26124),
(45496,'enUS','Nechi owachi, $c. Hello and thank you.','',26124),
(45498,'enUS','I will join you soon. Together, we will teach these Grimtotem cowards the meaning of fear!','',26124),
(45499,'enUS','De tauren says that she\'ll teach me to heal if we do a good job!  Let\'s go, mon!','',26124),
(45500,'enUS','Don\'t go in there!','Don\'t go in there!',26124),
(45501,'enUS','Good day.','Good day.',26124),
(45502,'enUS','Eh - what? Who? What\'s going on?','',26124),
(45503,'enUS','Alright, $n. Time to see what this staff of yours has to show us.','',26124),
(45504,'enUS','Lok\'tar! Let us return through that portal we left behind... much work awaits me in Orgrimmar.','',26124),
(45505,'enUS','Well done, heroes. Let us return through the very portal meant to send this beast through! Much work awaits me in Thunder Bluff.','',26124),
(45506,'enUS','Well done, heroes. Let us return through that portal we left behind... much work awaits me in Ironforge.','',26124),
(45509,'enUS','Training','Training',26124),
(45510,'enUS','<Quality you can depend upon until the explosive end!>$B$B<Insert moolah for profession training and vending services.>','',26124),
(45511,'enUS','','Join me ... in the depths.',26124),
(45512,'enUS','I\'d like to purchase primary profession training.','I\'d like to purchase primary profession training.',26124),
(45513,'enUS','Access profession vending machine','Access profession vending machine',26124),
(45514,'enUS','You may rest here, if you like. The Temple of Earth is under our care, now.','',26124),
(45515,'enUS','','With the proper technology, you can fix anything, $n. Of course there are always malfunctions, short circuits, and uncooperative patients to keep things interesting.',26124),
(45516,'enUS','Gandling is strong, but do not worry.  I will join you shortly after you begin to fight him.','',26124),
(45517,'enUS','','We have much to do and very little time to do it if we\'re to assist the Freewind Post tauren and push the Grimtotem back.$B$BTor ilisar\'thera\'nal! Let our enemies beware!',26124),
(45518,'enUS','The Grimtotem have struck us for the last time. Since they cannot be taught the error of their ways, we will destroy them like beasts.$B$BEarth Mother forgive us.','',26124),
(45519,'enUS','May I have another vial of Elemental Sapta?','May I have another vial of Elemental Sapta?',26124),
(45520,'enUS','May I have another Cleansing Totem?','May I have another Cleansing Totem?',26124),
(45521,'enUS','','<The Stonemother stares down at you. Through you. As if she\'s peering into your soul.>$B$BMy daughter, Theradras, sequestered herself deep within the Crystal Caverns of Terramok to grieve for her lost love, Zaetar. There, heartless, stoneless beings invaded and slaughtered her amidst her mourning.$B$BIf I had any reason to trust a creature afflicted by the curse of flesh, it was stripped from me that day. And yet in your arrogance, you persist.$B$BOne day, you will outlive your usefulness.',26124),
(45522,'enUS','I\'ve come at your call, Stonemother.','I\'ve come at your call, Stonemother.',26124),
(45523,'enUS','The Alliance now controls the Twilight Shores beach head.','',26124),
(45524,'enUS','The Horde now controls the Twilight Shores beach head.','',26124),
(45525,'enUS','','Do not be afraid. I will not let you fall.',26124),
(45526,'enUS','Warning: This vehicle is not permitted to operate outside of Tol Barad. Turn back now.','',26124),
(45527,'enUS','Sorry, friend. You\'ll have to seek training elsewhere.','',26124),
(45528,'enUS','For a small donation, I can train you in the priestly arts.','',26124),
(45529,'enUS','Bwaaaah! You no take da treasure!!!','',26124),
(45530,'enUS','Gwaaaaaaaaaaaahhh!!!','',26124),
(45531,'enUS','','How can I help ye, $c?',26124),
(45532,'enUS','Do you have any supplies?','Do you have any supplies?',26124),
(45533,'enUS','Can you repair equipment?','Can you repair equipment?',26124),
(45534,'enUS','','Nay, but ye can talk ta Earthmender Doros over there... the big draenei, lookin\' over what\'s left o\' the Twilight camp.',26124),
(45535,'enUS','Little of their camp has been left intact. Still, there might be something we can make use of.$B$BDid you require something of me, $r?','',26124),
(45536,'enUS','I have nothing for you.$B$BHegrid, though, has been gathering Twilight supplies to replenish our own. You might speak with her.','',26124),
(45537,'enUS','Well done, heroes. Balnazzar had been a threat for far too long. He had a hand in the Scourge and the Scarlet Crusade, two of our most difficult foes. The Risen may have tipped the balance against us, had they time to fester.','',26124),
(45538,'enUS','Regrettably, Balnazzar is not yet finished. Defeating a dreadlord in the mortal plane only sends it back to the Twisting Nether. He will be back one day, perhaps even working again with his brothers, Varimathras and Detheroc. ','',26124),
(45539,'enUS','For now, we have regained control over this half of Stratholme and should rejoice for that. The former Bastion of the Silver Hand is back in the hands of its rightful owners. Countless treasures to the order reside here, and we now have a fortified location to launch our next assault.','',26124),
(45540,'enUS','That is where you come in, heroes. The war for Stratholme is not yet over. Leave this area and travel east to the Eastwall Gate. It is the service entrance to the city, and the last remaining opening into Lord Aurius Rivendare\'s scourge-infested domain. If we defeat him, Stratholme will be ours once more.','',26124),
(45541,'enUS','I will meet you in Alonsus Chapel. It is the holy place where Uther the Lightbringer was ordained into the Silver Hand. It is the only building the Scourge cannot touch, and will be our forward base of operations in that half of the city. With your help, Stratholme will become the capital of the Light and a new beginning for Lordaeron.','',26124),
(45542,'enUS','This blight is useless.','This blight is useless.',26124),
(45543,'enUS','What did they test this crap on? Murlocs?','What did they test this crap on? Murlocs?',26124),
(45544,'enUS','Bwagauugh!!! Augh feed you to da crocs!!!','',26124),
(45545,'enUS','Watered down garbage. Doesn\'t even slow \'em down.','Watered down garbage. Doesn\'t even slow \'em down.',26124),
(45546,'enUS','We\'re gonna lose this war to \"regulations.\" What\'s next? Only wooden swords may be used???','We\'re gonna lose this war to \"regulations.\" What\'s next? Only wooden swords may be used???',26124),
(45547,'enUS','This is a war, right? We\'re supposed to be able to kill our enemies with our weapons, right?','This is a war, right? We\'re supposed to be able to kill our enemies with our weapons, right?',26124),
(45548,'enUS','','It will be a pleasure cleaving you in half!',26124),
(45549,'enUS','','What have we here? A beaten coward and a meddling outsider?',26124),
(45550,'enUS','','You\'ll soon learn to kneel before the might of the Grimtotem! If I let you live.',26124),
(45551,'enUS','','Well, well, well, it looks like you people have a spine after all.',26124),
(45552,'enUS','The rifts are down and Ironforge is safe!  These portals must be the second half of their attack.$B$BQuickly! Into the portal! We must press the attack while we have the advantage!','',26124),
(45553,'enUS','That which falls, I collect.$B$BOf late, there have been many things to gather.','',26124),
(45554,'enUS','I cannot. I merely collect.$B$BIbdil may help you. His way is to mend.','',26124),
(45555,'enUS','That which has broken, I mend.$B$BSo much has been broken in recent time. So very much.','',26124),
(45557,'enUS','Chosen of the Elder Crone! You don\'t realize yet, do you? I\'ll put an end to you first! You and your friend!','',26124),
(45558,'enUS','Why would she choose... an outsider?','',26124),
(45559,'enUS','Can we fire some more cannons? I dunnae think we\'re firin\' nearly enough cannons.','',26124),
(45560,'enUS','Thas\'it! Pulverize the beach! Leave nuthin\' but ... sand.','',26124),
(45561,'enUS','So long as we\'re sendin\' troops up the beach, we should double-up the artillery-fire. You know, to help.','',26124),
(45562,'enUS','More artillery... more! I never liked peninsulas.','',26124),
(45563,'enUS','There is nothing I call my own that would be of use to you.$B$BPerhaps D\'lom will have something of interest to you in his collection.','',26124),
(45564,'enUS','','How can I help you, $c?',26124),
(45565,'enUS','I knew you were on your way. I don\'t care what they\'re saying about you or your connection to Arikara. This ends here!','',26124),
(45566,'enUS','After everything, this is how it ends? Here on Darkcloud Pinnacle?','',26124),
(45567,'enUS','Once you go shaman, you don\'t go back.$B$BI completely underestimated the usefulness of fire elementals. Easy to discipline too: just add water.','',26124),
(45568,'enUS','Da Twilight\'s Hammer have been assaultin\' our rings all over da highlands, and dey\'ve taken many for demselves in da process. Dis be our last and we have no intention of givin\' it up, no matter what kind of horrors dey be summonin\' from the earth to assault us.','',26124),
(45569,'enUS','You\'re the one my aunt sent? A test, no doubt. I\'ll kill you quickly and prove myself to her once again.','',26124),
(45570,'enUS','NO! Magatha, forgive me! Bring me back!','',26124),
(45571,'enUS','Well done, $c! You can follow simple clues.','',26124),
(45572,'enUS','Oh, do be a dear and kill Arnak for me along the way. He\'s become something of an embarassment to the family.','',26124),
(45573,'enUS','Now, hurry along, little $n. I\'ve one more challenge to see if you\'re worthy of the honor.','',26124),
(45574,'enUS','','Where are those lunkheads?',26124),
(45575,'enUS','','Earth Mother be merciful!',26124),
(45576,'enUS','Shotgun!','',26124),
(45577,'enUS','Hey now!  Why do you get to sit in front?','',26124),
(45578,'enUS','Because I won our bet.  And because I called shotgun.','',26124),
(45579,'enUS','Who says you won the bet?  We haven\'t compared tallies yet.','',26124),
(45580,'enUS','Fine.  I killed five zombies.  And they were huge.  How many undead did you kill?','',26124),
(45581,'enUS','I\'m pretty sure I killed six.','',26124),
(45582,'enUS','I\'m going to bet that you only killed four.','',26124),
(45583,'enUS','H... how did you know that?','',26124),
(45584,'enUS','I didn\'t.  You just told me!','',26124),
(45585,'enUS','So seriously, how did your undead hunting go?  I want to hear stories.','',26124),
(45586,'enUS','Gidwin?  Are you ignoring me?','',26124),
(45587,'enUS','Giddy... you\'re mad at me, aren\'t you?','',26124),
(45588,'enUS','Remember when we were kids, Gidwin?  We would spend all day pretending to fight the trolls, or the murlocs, or the girls.','',26124),
(45589,'enUS','Don\'t do this, Tarenar.','',26124),
(45590,'enUS','We had a name we called ourselves... what was it?','',26124),
(45591,'enUS','You remember damn well enough what it was.','',26124),
(45592,'enUS','I\'m dead serious.  I\'ve completely forgotten.','',26124),
(45593,'enUS','<Sigh>... \"The Paladin Pals\".','',26124),
(45594,'enUS','','Gidwin, you can sit in front with me next time.',26124),
(45595,'enUS','Maybe now I don\'t want to.  Maybe I like it better sitting back here with my new friend.  It smells like horses up there.','',26124),
(45596,'enUS','','There\'s a tower coming up on our left.  What do you say we stop and rest a bit?',26124),
(45597,'enUS','We just rested a few minutes ago!  Let\'s just go to Light\'s Hope Chapel!','',26124),
(45598,'enUS','','The roads here are rough, Gidwin.  I don\'t want to risk losing a horse.',26124),
(45599,'enUS','We won\'t lose a horse.  Look at them!  They look exactly like they did when we started.','',26124),
(45600,'enUS','Actually, I agree with Fiona.','',26124),
(45601,'enUS','The Argent Crusade can wait for us a little while longer.  Besides... our guest may want to get off the caravan soon.','',26124),
(45602,'enUS','','Here we are!',26124),
(45603,'enUS','Carlin, do you have the extended Annals of Darrowshire?','Carlin, do you have the extended Annals of Darrowshire?',26124),
(45604,'enUS','Why, yes... does Chromie need this?  I suppose she would.$b$bYes, you may have it.  Feel free to leaf through the pages.  Inside you will find the history of Darrowshire, and the details of the events that led to the deaths of so very many men.','',26124),
(45605,'enUS','Alliance reinforcements have arrived.','Alliance reinforcements have arrived.',26124),
(45606,'enUS','You\'ve done it, heroes! Stratholme is ours! Come, we wait just outside the Slaughterhouse!','',26124),
(45607,'enUS','Your actions were pivotal in successfully reclaiming the city. Rivendare\'s death signifies the beginning of a new era for the Plaguelands. The few remaining Scourge should fall easily, and the land will at last be reborn.','',26124),
(45608,'enUS','Stratholme may take quite some time to be rebuilt and fully cleansed, but it is an effort I will take great pleasure in watching unfold. Perhaps one day we will see the next great defender of the Light armed in the Bastion of the Silver Hand, or ordained in Alonsus Chapel. No matter the outcome, our work here will bear great fruit one day.','',26124),
(45609,'enUS','Thank you, brave heroes. Thank you for showing Azeroth that no matter how overhwelming the darkness becomes, a single Light can pierce through.','',26124),
(45610,'enUS','Never underestimate the power of proper supply management. The warriors may win the battles, but it\'s the supplies that win the war. ','',26124),
(45611,'enUS','Thank you for the gifts. Let us see if you are worthy, $c!','',26124),
(45613,'enUS','Stop! You have bested my wind serpent.','',26124),
(45614,'enUS','I have been taken prisoner by the Twilight\'s Hammer.','',26124),
(45615,'enUS','I\'m not certain where. Start with their western base overlooking Highperch.','',26124),
(45616,'enUS','I would like to go back and see one of the visions again. Do you still have the enchanted blade?','I would like to go back and see one of the visions again. Do you still have the enchanted blade?',26124),
(45617,'enUS','Surrender? I\'ll scrawl out the terms of our surrender in their blood.','',26124),
(45618,'enUS','I cannot promise that your rest will be peaceful, $c.  These orcs do not know when to quit.','I cannot promise that your rest will be peaceful, $c.  These orcs do not know when to quit.',26124),
(45619,'enUS','A drunk orc is  a sight to see.  An army of drunk orcs is a sight I wish to never see again.','A drunk orc is  a sight to see.  An army of drunk orcs is a sight I wish to never see again.',26124),
(45620,'enUS','If my mother had told me there would be days like this I would not have believed her.','If my mother had told me there would be days like this I would not have believed her.',26124),
(45621,'enUS','Hey, \"Salty\" when are you going to get a new name? Thish town ain\'t big \'nough for two of ussh...','Hey, \"Salty\" when are you going to get a new name? Thish town ain\'t big \'nough for two of ussh...',26124),
(45623,'enUS','Hey over there!  Hey!  Hey!  Over there!  How\'sh everything going Gororgararar?','Hey over there!  Hey!  Hey!  Over there!  How\'sh everything going Gororgararar?',26124),
(45624,'enUS','Yoo hoo!  \"Shmaltzy!\"  Hey, why come your shupplies... Whe... Oh... Um... You got lots of boxes to keep track of...','Yoo hoo!  \"Shmaltzy!\"  Hey, why come your shupplies... Whe... Oh... Um... You got lots of boxes to keep track of...',26124),
(45625,'enUS','Pssst!  Pssst!  Hey!  \"Pepper!\"  Are you done hording all the shupplies!  You shee what I just did? Horde..  For the horde!','Pssst!  Pssst!  Hey!  \"Pepper!\"  Are you done hording all the shupplies!  You shee what I just did? Horde..  For the horde!',26124),
(45626,'enUS','\"Malty!\"  Hey, \"Malty!\"  I thought you were going to get us shome more booze!  What\'sh the hold up?','\"Malty!\"  Hey, \"Malty!\"  I thought you were going to get us shome more booze!  What\'sh the hold up?',26124),
(45627,'enUS','It\'s \"Salty!\"  I got here firsht!  I got off the boat and onto land firsht!  I called the name \"Salty.\"  Hey... Where\'s your pet at?','It\'s \"Salty!\"  I got here firsht!  I got off the boat and onto land firsht!  I called the name \"Salty.\"  Hey... Where\'s your pet at?',26124),
(45628,'enUS','Maybe you should worry about your pet and not me!  I\'m taking care of my bushinesh jusht fine!','Maybe you should worry about your pet and not me!  I\'m taking care of my bushinesh jusht fine!',26124),
(45629,'enUS','\"Shalty.\"  That\'s my name!  Your name should be \"I can\'t hold onto petsh.\"  I can\'t believe anyone would trusht you with a beasht.  ','\"Shalty.\"  That\'s my name!  Your name should be \"I can\'t hold onto petsh.\"  I can\'t believe anyone would trusht you with a beasht.',26124),
(45631,'enUS','Hey, shtop bothering me.  You\'re a dishgrace to us all.  You can\'t even hold onto your own petsh!','Hey, shtop bothering me.  You\'re a dishgrace to us all.  You can\'t even hold onto your own petsh!',26124),
(45632,'enUS','Shhh!  SHHH!!!!!  Maybe if you shtay quiet your pet might come back to you!','Shhh!  SHHH!!!!!  Maybe if you shtay quiet your pet might come back to you!',26124),
(45633,'enUS','My pet! Oh no!  Uh... I am shure that pet is around here somewhere...','My pet! Oh no!  Uh... I am shure that pet is around here somewhere...',26124),
(45634,'enUS','HA! Shows how much you know.  I left the critter back on the third ship!','HA! Shows how much you know.  I left the critter back on the third ship!',26124),
(45636,'enUS','Wait... Where is my pet?  It\'s gone! No need to panic... Just need a quick drink and I can figure out where he went to.','Wait... Where is my pet?  It\'s gone! No need to panic... Just need a quick drink and I can figure out where he went to.',26124),
(45637,'enUS','I didn\'t like that pet anyways.  Beshides... People stop by all the time and give me their pets.  If I lost one, it doesn\'t matter, I\'ve got dozens more to lose!','I didn\'t like that pet anyways.  Beshides... People stop by all the time and give me their pets.  If I lost one, it doesn\'t matter, I\'ve got dozens more to lose!',26124),
(45638,'enUS','I sent my pet out to get me shome more to drink.  You\'ll be shorry when he shows up with a wagon full of Mudder\'s Milk and you don\'t get any.','I sent my pet out to get me shome more to drink.  You\'ll be shorry when he shows up with a wagon full of Mudder\'s Milk and you don\'t get any.',26124),
(45639,'enUS','I think I see them! HERE! HERE!','I think I see them! HERE! HERE!',26124),
(45640,'enUS','I can smell you!','I can smell you!',26124),
(45641,'enUS','We were hoping you wouldn\'t surrender peacefully!','We were hoping you wouldn\'t surrender peacefully!',26124),
(45642,'enUS','We\'re coming for you!','We\'re coming for you!',26124),
(45643,'enUS','NO ESCAPE!','NO ESCAPE!',26124),
(45644,'enUS','We will find you, monster!','We will find you, monster!',26124),
(45645,'enUS','','We mustn\'t fail the Banshee Queen.',26124),
(45646,'enUS','','Mine is not to question why.',26124),
(45647,'enUS','','Death to all that would oppose the Forsaken!',26124),
(45648,'enUS','','This Godfrey must be quite an extraordinary individual. The mistress has sacrificed much for his return.',26124),
(45649,'enUS','','Mortals... They never cease to amaze me.',26124),
(45650,'enUS','','These pathetic pups cannot hope to withstand the might of the Forsaken.',26124),
(45651,'enUS','','The Banshee Queen sees all.',26124),
(45652,'enUS','','There were two others that were already recovered. Godfrey is the final piece.',26124),
(45653,'enUS','Godfrey spent his life defending Gilneas. When the worgen curse spread across Gilneas he turned his attention towards thwarting the worgen assault.','',26124),
(45654,'enUS','I am told that Godfrey snapped when he learned of his king\'s affliction. Could you imagine the sense of betrayal he must have felt? His own king one of the very beasts that he spent his existence killing?','',26124),
(45655,'enUS','Godfrey will be our ace in the hole. With his knowledge of Gilneas and of the worgen, we cannot fail.','',26124),
(45656,'enUS','My men recovered the corpses of two of Godfrey\'s lieutenants: Baron Ashbury and Lord Walden.','',26124),
(45657,'enUS','With Godfrey on our side, we will crush this uprising!','',26124),
(45658,'enUS','The Alliance will never recover from the blow that we are about to deal them!','',26124),
(45659,'enUS','I am more alive now than I ever was as a human. THIS is life, $n. This is living!','',26124),
(45660,'enUS','Let them come! All will fall before the Dark Lady\'s war machine!','',26124),
(45661,'enUS','%s coats his weapons in wolfsbane oil.','',26124),
(45662,'enUS','Are you interested in joining our caravan?  We\'re headed to Light\'s Hope Chapel.','Are you interested in joining our caravan?  We\'re headed to Light\'s Hope Chapel.',26124),
(45663,'enUS','Well, I am headed in that direction.  I\'ve only been dallying here at Crown\'s Guard because of all the wildlife activity on the roads.$b$bI\'ll make you a deal: help me clear the roads, and yes, I\'ll join your group.','',26124),
(45664,'enUS','You\'ve helped me clear the roads of all that nasty wildlife, so I suppose I have no choice.  Let\'s get going!','',26124),
(45665,'enUS','I\'ve spent far too long in that town.  It\'s a wonderful place, and I enjoyed my service there, but I think I\'d prefer to stay here.','',26124),
(45666,'enUS','Ugh!  No, I could never.  Afraid of horses.','',26124),
(45667,'enUS','','No thanks!  Maybe sometime in the future.  Or the past.  Not today.',26124),
(45668,'enUS','','I\'m sorry, I can\'t.  I\'ve been tasked to watch this hippogryph post.  These things might seem tame, but they really require a twenty-four hour vigil.',26124),
(45669,'enUS','Hail.','',26124),
(45670,'enUS','Yes, traveler?','',26124),
(45671,'enUS','','Hello again, $c.',26124),
(45672,'enUS','','Farewell for now.',26124),
(45673,'enUS','Until we meet again.','',26124),
(45674,'enUS','Inside the caravan are boxes of vendor supplies, along with the personal belongings of Fiona and her companions.','',26124),
(45675,'enUS','Ride Fiona\'s Caravan to its next destination.','Ride Fiona\'s Caravan to its next destination.',26124),
(45676,'enUS','This place is an archaeologist\'s dream!$b$bI wish there were time to conduct a proper excavation.','',26124),
(45677,'enUS','This here terrain is terrible! Spongy ground, all lumpy-like with stumps and stones. Like angry oatmeal. The mud\'ll practically swallow a steam tank whole.$B$BOur gear\'s all mired in the muck, getting thumped by the Horde!','',26124),
(45678,'enUS','What can I do to help?','What can I do to help?',26124),
(45679,'enUS','','Do you need to return to Vashj\'ir?',26124),
(45680,'enUS','Help Joseph Carlin\'s troops defend Darrowshire!','',26124),
(45681,'enUS','Protect Davil Lightfire!','',26124),
(45682,'enUS','Horgus the Ravager has appeared!  Kill him quickly!','',26124),
(45683,'enUS','Captain Redpath has appeared on the battlefield!  Protect him!','',26124),
(45684,'enUS','Captain Joseph Redpath has been corrupted!  Kill him quickly!','',26124),
(45685,'enUS','Speak with Joseph Redpath in the center of Darrowshire.','',26124),
(45686,'enUS','Just stand back, $n. We wouldn\'t want $gyou:a pretty little thing like you; getting hurt.','',26124),
(45687,'enUS','Yes. Please take me to Vashj\'ir.','Yes. Please take me to Vashj\'ir.',26124),
(45688,'enUS','Do not be alarmed. I am not as I appear.$B$BMy name is Acridostrasz, though you may call me Acride. My Queen sent me here to stop Nefarian, and I will not rest until my task is complete. However, there are other foes here guarding his lair that I cannot take on alone.$B$BHelp me dispose of them, and you will be in the favor of Alexstrasza. You may not know that name, but you will one day be thankful you do, of this I am certain. ','',26124),
(45689,'enUS','Let us begin.','',26124),
(45690,'enUS','Are we not going to have more witnesses?','',26124),
(45691,'enUS','I do not wish to make an event of this.  Such frivolities are expensive and merely serve our vanity.  But if you wish to have a celebration...','',26124),
(45692,'enUS','No, Warchief, this is enough.','',26124),
(45693,'enUS','You know that these are troubling times for the Horde.  Our supplies dwindle.  Our lands are barren.  Our warriors are in need of rest.  These are tasks that must be addressed for the good of the Horde.','',26124),
(45694,'enUS','Da people be happy with our success in Northrend.','',26124),
(45695,'enUS','\"Our\" success?  Troll, you played no part in the Horde\'s victories in Northrend.  While I led our warriors against the Lich King, you merely took back a few scattered islands.','',26124),
(45696,'enUS','Watch yourself, young one. You don\'t-','',26124),
(45697,'enUS','Garrosh! Vol\'jin!  Hold your tongues.  There are larger issues at stake.','',26124),
(45698,'enUS','Forgive my outburst.  Warchief, please, continue.','',26124),
(45699,'enUS','Despite our success in Northrend, we face serious problems that cannot be solved simply by axe and sword.  Earthquakes shake every region.  Elementals ravage the countryside.  I can hear our land, Azeroth, cry out in pain.','',26124),
(45700,'enUS','These are the reasons that you must leave.','',26124),
(45701,'enUS','','What about you, Belmont? How will you get back?',26124),
(45702,'enUS','I\'ll be fine, Arthura. The worgen lost our scent. It\'s doubtful that they even know we\'re here.','',26124),
(45703,'enUS','I\'ll probably make it back to the Forsaken Front before you two, er, three.','',26124),
(45704,'enUS','Now move out! You must not keep the Banshee Queen waiting.','',26124),
(45705,'enUS','You and your coin are -always- welcome here.','You and your coin are -always- welcome here.',26124),
(45706,'enUS','','So be it. Farewell, Belmont.',26124),
(45707,'enUS','','Oh my... hang on tight!',26124),
(45708,'enUS','Now, brothers!  Attack the $r!','',26124),
(45709,'enUS','You do not need to fight me, $r.  I mean you no ill will.','',26124),
(45710,'enUS','Can I take your test again, Vex\'tul?','Can I take your test again, Vex\'tul?',26124),
(45711,'enUS','Horton motions to the rickety riverboat nearby.','',26124),
(45712,'enUS','It will be an honor to carry out King Wrynn\'s commission for a warrior so dedicated to the Alliance.','',26124),
(45713,'enUS','Any friend of SI:7 is a friend of mine. Wouldn\'t want to end up on the wrong side o\' me own blade, now, would I?','',26124),
(45714,'enUS','She\'s hung up in the debris and I\'ve lost steam pressure. This terrain is murder!$B$BCan you get us out of this?','She\'s hung up in the debris and I\'ve lost steam pressure. This terrain is murder!$B$BCan you get us out of this?',26124),
(45715,'enUS','|TInterface\\Icons\\spell_shadow_shadetruesight.blp:20|t%s begins to cast |cFFFF0000|Hspell:82299|h[Fester Blood]|h|r!','',26124),
(45716,'enUS','Needless to say, it is an honor to work on behalf of such an upstanding servant of the Light and the Alliance.','',26124),
(45717,'enUS','Here are some spare parts. I\'ll cover you while you make repairs!','Here are some spare parts. I\'ll cover you while you make repairs!',26124),
(45718,'enUS','Aye, protect the tank while the boys make repairs! I\'ll try to get her moving again...','Aye, protect the tank while the boys make repairs! I\'ll try to get her moving again...',26124),
(45719,'enUS','The cauldron bubbles violently.','',26124),
(45720,'enUS','Put in a drop of liquid, as Betina requested.','Put in a drop of liquid, as Betina requested.',26124),
(45721,'enUS','Throw in an entire flask.','Throw in an entire flask.',26124),
(45722,'enUS','Throw in all 12 flasks.','Throw in all 12 flasks.',26124),
(45723,'enUS','The metals do not speak to me as the elements speak to you, but I hope that you will find this weapon worthy. King Wrynn and your farseer both have great confidence in your abilities.','',26124),
(45724,'enUS','It\'s been years since I last worked moonsteel, but I haven\'t forgotten the technique. Dane, join me at the anvil.','',26124),
(45725,'enUS','Your weapon is finished, $n. Wield it as an example to all who serve the Alliance.','',26124),
(45726,'enUS','Nothing seems to happen.  The plague cauldron may be ruined, but it certainly doesn\'t look any different.  What will you do?','',26124),
(45727,'enUS','Do nothing.  Betina said only one drop was needed.','Do nothing.  Betina said only one drop was needed.',26124),
(45728,'enUS','We are ready to proceed.  Magni, you have called this meeting.  What concerns you?','',26124),
(45729,'enUS','You\'ve no doubt noticed the string of earthquakes we\'ve had in the last weeks.  Something doesn\'t feel right about them.','',26124),
(45730,'enUS','','What do you mean?',26124),
(45731,'enUS','We dwarves have a connection to the earth.  We can feel her pain.  And right now the earth is crying out.  These earthquakes... they are both natural and not.  I wanted to gather you all together and discuss them.','',26124),
(45732,'enUS','','Even in Darnassus we have noticed the earth is at odds with something.',26124),
(45733,'enUS','I\'ve received word from my brother Brann in Northrend.  In his exploring of Ulduar he came across some unusual tablets... something ancient.','',26124),
(45734,'enUS','Nothing good has come from that dreadful place.\n','',26124),
(45735,'enUS','This might just change your mind.  Brann is shipping the tablets to me as we speak. Preliminary reports from the Explorers\' League state that they may be able to help us understand what is going on with the earthquakes.','',26124),
(45736,'enUS','Our top minds have been looking into the seismic activities... Well, we\'ve mostly been looking at how to secure a building\'s frame while at the same time simulating tectonic shifts...\n','',26124),
(45737,'enUS','','So is that why you have moved out?',26124),
(45738,'enUS','Ha, not at all!  Though it is a striking coincidence.  Gnomeregan has been and continues to shame our people.  It is long past time we reclaim our homeland.','',26124),
(45739,'enUS','Well, it is good that things have turned out... better for you and your people, High Tinker.  But not all of us have the luxury of up and moving our kingdom.','',26124),
(45740,'enUS','','Rise, Lord Vincent Godfrey. Be reborn as an instrument of my vengeance!',26124),
(45741,'enUS','I live again...','',26124),
(45742,'enUS','','You live to serve me, Godfrey. Together we will crush the worgen uprising and retake Gilneas for the Forsaken.',26124),
(45743,'enUS','For the Horde...','',26124),
(45744,'enUS','','Yes, of course...',26124),
(45745,'enUS','The irony of what I have become is not lost upon me, Lady Sylvanas.','',26124),
(45746,'enUS','Though as I have always said, better dead than worgen.','',26124),
(45747,'enUS','Or in this case, better undead than worgen.','',26124),
(45748,'enUS','','Prepare your men. The Gilneas Liberation Front amasses at the Greymane Wall. Soon their reinforcements from Stormwind will arrive. We haven\'t a minute to waste.',26124),
(45749,'enUS','As you wish, Banshee Queen.','',26124),
(45750,'enUS','','Armor, weapons, whatever you may need, you will find at the supply depot behind me. Go now.',26124),
(45751,'enUS','','Once again you have impressed me, $n. Without your aid, we would have not made it this far. Walk with me...',26124),
(45752,'enUS','<You may train in up to two primary professions. Please choose from the following selections:>','',26124),
(45753,'enUS','Alchemy','Alchemy',26124),
(45754,'enUS','Blacksmithing','Blacksmithing',26124),
(45755,'enUS','Enchanting','Enchanting',26124),
(45756,'enUS','Engineering','Engineering',26124),
(45757,'enUS','Inscription','Inscription',26124),
(45758,'enUS','Jewelcrafting','Jewelcrafting',26124),
(45759,'enUS','Leatherworking','Leatherworking',26124),
(45760,'enUS','Tailoring','Tailoring',26124),
(45761,'enUS','I\'d like to purchase secondary profession training.','I\'d like to purchase secondary profession training.',26124),
(45762,'enUS','<You may train any of the secondary professions. Please choose from the following selections:>','',26124),
(45763,'enUS','Cooking','Cooking',26124),
(45765,'enUS','First Aid','First Aid',26124),
(45766,'enUS','<Error retrieving data.... Please see Doc Zapnozzle for further instruction.>','',26124),
(45767,'enUS','Fishing','Fishing',26124),
(45768,'enUS','Herbalism','Herbalism',26124),
(45769,'enUS','Mining','Mining',26124),
(45770,'enUS','Skinning','Skinning',26124),
(45771,'enUS','Defend the Siege Tank!','',26124),
(45772,'enUS','Ahh, blast it. C\'mon, c\'mon already!','Ahh, blast it. C\'mon, c\'mon already!',26124),
(45773,'enUS','There! We got it! Let\'s get \'er outta here.','There! We got it! Let\'s get \'er outta here.',26124),
(45774,'enUS','The Siege Tank explodes!','',26124),
(45775,'enUS','Success! The Siege Tank is able to retreat.','',26124),
(45776,'enUS','A commission from King Wrynn is always an honor. I\'ll get to work on it right away.','',26124),
(45777,'enUS','So you\'re the one who ventured into Shadowfang Keep to retreive the rare and powerful materials hidden there?','',26124),
(45778,'enUS','Among the items you found in the keep is one that will serve as a powerful focus for your new staff.','',26124),
(45779,'enUS','Jessara, hand me those dusts and shards.','',26124),
(45780,'enUS','Where did I put that scroll? Ah, yes, here it is...','',26124),
(45781,'enUS','At last, $n, here is your staff. Wield it proudly in service to the Alliance.','',26124),
(45782,'enUS','','Of course, Lucan. Here they are.',26124),
(45783,'enUS','','You\'ve crossed into the domain of red dragons, $r.',26124),
(45784,'enUS','','I know not whether you\'ve come on the call and beckon of your new Dragonmaw allies. Nor do I really care to trust you even if you do not.',26124),
(45785,'enUS','','Fortunately for you, your fate is not mine to decide. Calen awaits you by the tree.',26124),
(45786,'enUS','','My drakes shall be watching you. Choose your words and your actions carefully, $r.',26124),
(45787,'enUS','','You and your allies have struck against my kind at the gates to Grim Batol in the past. You\'ve shown no respect for the sacred oath we would die to keep. You\'ll find no trust with me.',26124),
(45788,'enUS','You must be the talented hunter that Wulf mentioned, the hunter who has managed to attract King Wrynn\'s attention.','',26124),
(45789,'enUS','The materials you have gathered from that cursed old keep will certainly make a worthy bow.','',26124),
(45790,'enUS','No offense, but you don\'t look like you could shoot the broad side of a pack kodo.$B$BHow about we stop wastin\' each other\'s time and you go find the right trainer.','No offense, but you don\'t look like you could shoot the broad side of a pack kodo.$B$BHow about we stop wastin\' each other\'s time and you go find the right trainer.',26124),
(45791,'enUS','Yo. Up for a little target practice?','Yo. Up for a little target practice?',26124),
(45794,'enUS','There you have it, $n. A mighty bow for a mighty hunter. Use it well in service of the Alliance.','',26124),
(45795,'enUS','Hey there, $n. Here for a lesson? I ain\'t got all day...','Hey there, $n. Here for a lesson? I ain\'t got all day...',26124),
(45796,'enUS','Hey, it ain\'t MY fault ya didn\'t learn proper spellcraft.\n\nGo pester a $c trainer, yeah?','Hey, it ain\'t MY fault ya didn\'t learn proper spellcraft.\n\nGo pester a $c trainer, yeah?',26124),
(45797,'enUS','Nothin\' ta see here, mon.  Be on yer way, why don\'cha?','Nothin\' ta see here, mon.  Be on yer way, why don\'cha?',26124),
(45798,'enUS','I heard ya comin\' a league away, mon. Maybe ya need some more trainin\'?','I heard ya comin\' a league away, mon. Maybe ya need some more trainin\'?',26124),
(45799,'enUS','What?  I look like a $c to you?$B$BGet outta here, will ya?','What?  I look like a $c to you?$B$BGet outta here, will ya?',26124),
(45800,'enUS','Lookin\' good, kid.$B$BWhat\'s the word? Up for some trainin\'?','Lookin\' good, kid.$B$BWhat\'s the word? Up for some trainin\'?',26124),
(45801,'enUS','You need somethin\'?$B$BToo bad. I got nothin\' for ya, $c.','You need somethin\'?$B$BToo bad. I got nothin\' for ya, $c.',26124),
(45802,'enUS','\"Controlling the Elements for Fun and Profit.\"$B$BThat\'s what it\'s all about, am I right?  Let\'s get ta work.','\"Controlling the Elements for Fun and Profit.\"$B$BThat\'s what it\'s all about, am I right?  Let\'s get ta work.',26124),
(45803,'enUS','Look. You don\'t even WANNA know the sorta stuff I could teach ya.$B$BSeriously. It\'d melt yer brain. Go play nice somewhere else.','Look. You don\'t even WANNA know the sorta stuff I could teach ya.$B$BSeriously. It\'d melt yer brain. Go play nice somewhere else.',26124),
(45804,'enUS','You gotta love fel energy: Cheap, renewable, and guaranteed to blow things up.$B$BSure, you risk losin\' your eternal will to Unimaginable Horrors from Beyond Time and Space, but hey, risk versus reward!$B$BNow, what did you wanna see me about, hmmm?','You gotta love fel energy: Cheap, renewable, and guaranteed to blow things up.$B$BSure, you risk losin\' your eternal will to Unimaginable Horrors from Beyond Time and Space, but hey, risk versus reward!$B$BNow, what did you wanna see me about, hmmm?',26124),
(45805,'enUS','Let the trial begin.  Rise, champions!  Rise, and meet these three in combat!','',26124),
(45806,'enUS','Your warm-up is complete.  Now, the real trial begins!','',26124),
(45807,'enUS','You will have to pry the relics of the Dalaran archmages from my dead hands!','',26124),
(45808,'enUS','It did not have to be this way!  I only wish to see my family again...to share with them this gift!','',26124),
(45809,'enUS','They will pay for forsaking us.  For leaving us here amongst the beastly undead to rot...','',26124),
(45810,'enUS','I will be goin\' now.  I have no reason to remain here.  I may be undead, but my will is my own.','',26124),
(45811,'enUS','I will see you in green fields on the other side, $n.','',26124),
(45812,'enUS','Well-done, heroes.  You have passed my test of combat.','',26124),
(45813,'enUS','Good luck.','Good luck.',26124),
(45814,'enUS','Come on already!  Let\'s go!','',26124),
(45815,'enUS','Tarenar, you dolt!  The chapel is twenty yards away!  Let\'s get moving!','',26124),
(45816,'enUS','Can we go yet, Tarenar?  I want to join the Crusade!','',26124),
(45817,'enUS','<The dimensional portal hums.>','',26124),
(45818,'enUS','<Use the Ambermill Dimensional Portal.>','<Use the Ambermill Dimensional Portal.>',26124),
(45819,'enUS','SOUND THE ALARMS! INTRUDERS HAVE BREACHED THE PORTAL!','',26124),
(45820,'enUS','I... *cough*  I thank you, stranger.','',26124),
(45821,'enUS','I owe you my life.  My people have paid a high price for defying Deathwing.','',26124),
(45822,'enUS','I\'d only heard about your kind in stories, $r.  I never thought I\'d owe my life to one of you.','',26124),
(45824,'enUS','Minions, destroy the interloper! The shield must not come down!','',26124),
(45825,'enUS','You will not succeed, monster!','',26124),
(45826,'enUS','We will... never... give up!','',26124),
(45827,'enUS','The armies of the Alliance will march upon your bones!','',26124),
(45828,'enUS','Lordaeron belongs to the Alliance. You only delay the inevitable...','',26124),
(45829,'enUS','RUN! DO NOT LET THEM TURN YOU!','',26124),
(45830,'enUS','Hop aboard, $n. Let\'s move!','',26124),
(45831,'enUS','I hope you Alliance are here to give them Dragonmaw Orcs a good thumpin\'.','',26124),
(45832,'enUS','You\'ve got quite the setup here, friend. Come with me while I find out who\'s in charge.','',26124),
(45833,'enUS','Stuff me like a haggis! Kurdran Wildhammer - in the flesh. He lives!','',26124),
(45834,'enUS','I have to admit, you\'re not what I expected when I received the warchief\'s commission.','',26124),
(45835,'enUS','If you\'ve earned the respect of the warchief, there must be something to you. If you can lift the weapon, it\'s yours.','',26124),
(45836,'enUS','Perhaps you won\'t need to rely on your chanting so much with a proper weapon by your side.','',26124),
(45837,'enUS','Still, looks are deceiving for the likes of you. Don\'t worry, I\'ll make something that favors your style of fighting.','',26124),
(45838,'enUS','Still, the elements clearly speak to you, and when I\'m done, you\'ll have a fine weapon to help you harness their power.','',26124),
(45839,'enUS','I haven\'t worked moonsteel in years, but it\'s not the kind of thing you forget. Apprentices, it\'s time to show you how to work real metal!','',26124),
(45840,'enUS','Aye, friend. How fare the Wildhammer clans? We\'ve much to discuss!','',26124),
(45841,'enUS','Forget this, Crablegs.  It\'s takin\' too long!','',26124),
(45842,'enUS','Your weapon is finished. I think you will find our work a fitting reward for your loyalty to the Horde. Use it to remind our enemies why they should fear us!','',26124),
(45843,'enUS','','The dimensional barrier is broken! TAKE THEM NOW! FOR THE BANSHEE QUEEN!',26124),
(45844,'enUS','','Rise, magi! Be reborn as Forsaken!',26124),
(45845,'enUS','Yet I am a true servant of the warchief and he does not grant boons lightly. His wisdom guides my hammer.','',26124),
(45846,'enUS','','Eliza isss pretty....sssso pretty...',26124),
(45847,'enUS','My bird! Lightning - they shot her! Those filthy beasts shot her from the sky!','',26124),
(45848,'enUS','Poor Lightning. She\'s gonna need some time to recouperate.','',26124),
(45849,'enUS','And those that did know how dangerous these earthquakes can be.  To this day, the Exodar is still shaking from our rather abrupt arrival.','',26124),
(45850,'enUS','...because on the one hand, this could be a handy device, the \"Shake-a-Ton 2000.\"  But on the other hand, the last thing we gnomes want to see is the mountains of Dun Morogh collapse and crush Ironforge.\n','',26124),
(45851,'enUS','Well then. Ready to fly?','',26124),
(45852,'enUS','I\'m ready. Let\'s go!','I\'m ready. Let\'s go!',26124),
(45853,'enUS','','I\'m not certain we could organize our people to move even if we wanted to.  We\'ve also received word of hostile elementals appearing randomly across the lands, sometimes in towns, sometimes across the countryside.  Moving may not be an option.',26124),
(45854,'enUS','Well, there is at least a wee bit of good news... no offense, Gelbin.  The shaking seems to have stirred up The Earthen Ring.  Even the Wildhammer shaman have offered their help.','',26124),
(45855,'enUS','','Perhaps these events are also what have brought forth the Highborne from Shen\'dralar.',26124),
(45856,'enUS','It seems as if this world is coming apart at the seams.  I\'ve seen these symptoms before, on Draenor... We may not be able to stop this.  Fleeing may be our best option.','',26124),
(45857,'enUS','Fleeing is not an option I wish to entertain at this point. We will find another way.  Perhaps these tablets from Ulduar will shed some light on our situation.','',26124),
(45858,'enUS','','Hopefully we can get these answers quickly.  The people are frightened, and cultists are taking advantage of that fear.',26124),
(45859,'enUS','These cultists only exacerbate the problem.  They preach the end of the world, or that the world is having birthing pains... Hyperbole that is hard for the populace to ignore.','',26124),
(45860,'enUS','','Troubling times indeed. Fear of the unknown makes people do foolish things.',26124),
(45861,'enUS','And our lack of answers only fuels the confusion.','',26124),
(45862,'enUS','All the more reason we need to reach the bottom of this.  This tablet from Ulduar will lead us in the right direction.  Brann is sure of it.  And if Brann is certain, then I am certain.','',26124),
(45863,'enUS','','I\'ve made it a point not to argue with a dwarf when it comes to the earth.  If the Bronzebeards are sure this tablet will help solve the earth\'s problems, then by all means we should support them.',26124),
(45864,'enUS','','Adventurers are such hypocrites!  Like YOU just FOUND your weapon on the side of the road!',26124),
(45865,'enUS','','You won\'t find a finer firearm anywhere else in Orgrimmar.',26124),
(45866,'enUS','','Ormak told me to expect you, $n.',26124),
(45867,'enUS','','These materials you brought from Shadowfang Keep are no common things. They will invest your weapon with great power.',26124),
(45868,'enUS','','Your bow is complete, $n. I hope it will serve you as well as you have served the Horde.',26124),
(45869,'enUS','Jhag, did you set aside those formulas and regeants I asked for?','',26124),
(45870,'enUS','That should complete the enchantment. Here is your new staff, $n. Always use it in service to the Horde.','',26124),
(45871,'enUS','I\'ve gathered them here for you, master.','',26124),
(45872,'enUS','','Loganaar said that you would be bringing powerful artifacts from Shadowfang Keep. At first, I questioned the value of these materials.',26124),
(45873,'enUS','I will tell you nothing, $r-pig!','',26124),
(45874,'enUS','I do not fear death at your hands, $r!','',26124),
(45875,'enUS','The dwarf belongs to our kind now!  Not yours!','',26124),
(45876,'enUS','','But now that I have the items, I can sense the power Loganaar spoke about. They will make a fitting weapon for you.',26124),
(45877,'enUS','The Plaguewood is too big!  Your friend is gone!  You will never find him!','',26124),
(45878,'enUS','She will never return the dwarf to you!','',26124),
(45879,'enUS','Foolish $r!  You seek the dwarf?  Baroness Anastari has hidden him well!','',26124),
(45880,'enUS','You will never stop us!','',26124),
(45881,'enUS','Aarrghhh...','',26124),
(45882,'enUS','You can never stop the Scourge!','',26124),
(45883,'enUS','Death means nothing to me, $r!','',26124),
(45884,'enUS','','Oh, my... The enchantment succeeded even beyond my expectations.',26124),
(45885,'enUS','','With this staff, the circle is entrusting an item of great power to you, $n. Use it to uphold the tenets of our order.',26124),
(45886,'enUS','Scraping','Scraping',26124),
(45887,'enUS','$n has assaulted the waterworks!','',26124),
(45888,'enUS','$n has assaulted the waterworks!','',26124),
(45889,'enUS','The Alliance has taken the waterworks!','',26124),
(45890,'enUS','The Horde has taken the waterworks!','',26124),
(45891,'enUS','$n has defended the waterworks!','',26124),
(45892,'enUS','$n has defended the waterworks!','',26124),
(45893,'enUS','$n claims the waterworks!  If left unchallenged, the Alliance will control it in 1 minute!','',26124),
(45894,'enUS','$n claims the waterworks!  If left unchallenged, the Horde will control it in 1 minute!','',26124),
(45895,'enUS','$n has assaulted the mines!','',26124),
(45896,'enUS','$n has assaulted the mines!','',26124),
(45897,'enUS','The Alliance has taken the mines!','',26124),
(45898,'enUS','The Horde has taken the mines!','',26124),
(45899,'enUS','$n has defended the mines!','',26124),
(45900,'enUS','$n has defended the mines!','',26124),
(45901,'enUS','$n claims the mines!  If left unchallenged, the Alliance will control it in 1 minute!','',26124),
(45902,'enUS','$n claims the mines!  If left unchallenged, the Horde will control it in 1 minute!','',26124),
(45903,'enUS','$n has assaulted the lighthouse!','',26124),
(45904,'enUS','$n has assaulted the lighthouse!','',26124),
(45905,'enUS','The Alliance has taken the lighthouse!','',26124),
(45906,'enUS','The Horde has taken the lighthouse!','',26124),
(45907,'enUS','$n has defended the lighthouse!','',26124),
(45908,'enUS','$n has defended the lighthouse!','',26124),
(45909,'enUS','$n claims the lighthouse!  If left unchallenged, the Alliance will control it in 1 minute!','',26124),
(45910,'enUS','$n claims the lighthouse!  If left unchallenged, the Horde will control it in 1 minute!','',26124),
(45911,'enUS','','We have pledged to open an elemental gateway from Stormwind to the Highlands, but interference from the Bastion of Twilight hampers our efforts.$B$BWhat madness are they engaged in over there?',26124),
(45912,'enUS','At the appointed time, they will unleash wind and water elementals, engulfing the city in a tempest and setting the stage for our master\'s glorious return!','',26124),
(45913,'enUS','What is happening?','What is happening?',26124),
(45914,'enUS','What is going on?','What is going on?',26124),
(45915,'enUS','Take the scout\'s Journal.','Take the scout\'s Journal.',26124),
(45916,'enUS','When will this end?','When will this end?',26124),
(45917,'enUS','Earthquake!','Earthquake!',26124),
(45918,'enUS','We are doomed!','We are doomed!',26124),
(45919,'enUS','I\'ve found an incredible site!$b$bThe whole area pulsates with the hum of ancient architecture.$b$bIf it were not so late in the day, I would investigate the chamber immediately!$b$bSleeping, tonight, will be a struggle...','',26124),
(45920,'enUS','I don\'t want to die!','I don\'t want to die!',26124),
(45921,'enUS','Why is this happening?','Why is this happening?',26124),
(45922,'enUS','Please... Make it stop.','Please... Make it stop.',26124),
(45923,'enUS','','By wind and wave, by earth and fire... To Stormwind we go, $n!',26124),
(45924,'enUS','','The portal has been opened! Thanks to your efforts, we can now quickly travel from Stormwind to Twilight Highlands.',26124),
(45925,'enUS','There\'s nothing more exciting than to soar through the air.$B$BWell, maybe to fight while soaring through the air, and a good tankard of ale afterward!','',26124),
(45926,'enUS','Angus, I\'m here to lead the Wildhammer squad and drop off the SI:7 agents.','Angus, I\'m here to lead the Wildhammer squad and drop off the SI:7 agents.',26124),
(45927,'enUS','Well, why didn\'t you say so? Give those Twilight cultists a good one from me, will ya?','',26124),
(45928,'enUS','Don\'t let anybody tell you that the Scourge is defeated.  Look... do they not still roam the Plaguewood?  They cling to their corrupted land like a child\'s blanket.$b$bI have no choice but to fight.  Until my last breath, I will fight them.','',26124),
(45929,'enUS','We are looking into these cultists groups.','',26124),
(45930,'enUS','We are looking into the missing person reports you filed.','',26124),
(45931,'enUS','As soon as we have some news we will let you know.','',26124),
(45932,'enUS','We are doing everything we can.','',26124),
(45933,'enUS','We have the situation under control.','',26124),
(45934,'enUS','We are investigating the cultists activities as we speak.','',26124),
(45935,'enUS','We take these missing person reports very seriously, ma\'am.','',26124),
(45936,'enUS','We have our best people looking into these issues.','',26124),
(45937,'enUS','Is it safe?','Is it safe?',26124),
(45938,'enUS','Are... are they all dead?','Are... are they all dead?',26124),
(45939,'enUS','They struck from the shadows. We didn\'t stand a chance.','They struck from the shadows. We didn\'t stand a chance.',26124),
(45940,'enUS','I thought I was done for!','I thought I was done for!',26124),
(45941,'enUS','You must be the hero that everyone is talking about. Thank you.','You must be the hero that everyone is talking about. Thank you.',26124),
(45942,'enUS','You filthy cultists have taken my husband from me! He just left us behind and went to follow all this \'end of the world\' nonsense you\'re spouting!','You filthy cultists have taken my husband from me! He just left us behind and went to follow all this \'end of the world\' nonsense you\'re spouting!',26124),
(45943,'enUS','They\'re EVERYWHERE! WATCH OUT!','They\'re EVERYWHERE! WATCH OUT!',26124),
(45944,'enUS','We overheard their orders... no survivors...','We overheard their orders... no survivors...',26124),
(45945,'enUS','Begone! Isn\'t it enough that you have taken my husband? What more do you want?','Begone! Isn\'t it enough that you have taken my husband? What more do you want?',26124),
(45946,'enUS','Take your vile message away from this city! You will steal no more citizens away with your fake \'prophecies\'!','Take your vile message away from this city! You will steal no more citizens away with your fake \'prophecies\'!',26124),
(45947,'enUS','Cowardly dog. Run back to your mommy and hide.','',26124),
(45948,'enUS','The Dark Lady lets these mongrels live? Useless...','',26124),
(45949,'enUS','Haven\'t you poisoned the minds of enough men with your lies? Stay away from me!','Haven\'t you poisoned the minds of enough men with your lies? Stay away from me!',26124),
(45950,'enUS','I would have burned this whole place down with them in it...','',26124),
(45951,'enUS','These cowering troopers should die in shame. This is an embarassment.','',26124),
(45952,'enUS','Get out of my sight before I execute you!','',26124),
(45953,'enUS','$g He:She; died in battle. Bow your heads...','',26124),
(45954,'enUS','This is a mercy killing.','',26124),
(45955,'enUS','Cowards don\'t get to return home.','',26124),
(45956,'enUS','Worthless maggot.','',26124),
(45957,'enUS','You will own this peninsula, $c.$B$BYou will be a weapon.$B$BYou will be a minister of death, praying for war.','',26124),
(45958,'enUS','Take your lies and leave me in peace, cultist. You\'ve already done enough damage here!','Take your lies and leave me in peace, cultist. You\'ve already done enough damage here!',26124),
(45959,'enUS','A most productive day, today!$b$bThe chamber is indeed of ancient origin, and houses a magnificent mechanism which seems to be in disrepair.$b$bI will investigate further tomorrow.$b$bThis discovery will surely force Schnottz to take notice of me!$b$bHow could he deny me a promotion after something like this?','',26124),
(45960,'enUS','It has taken me all day to wrestle the cipher from these hieroglyphs:$b$b$b   Through eyes of blue is starlight$b              revealed.$b$b   Ten shards, one rod, and the veil$b             disappears.$b$b$bForget Schnottz and his empty promises!$b$bIf I can just unravel this riddle, its secrets shall be mine!','',26124),
(45961,'enUS','Report!','',26124),
(45962,'enUS','I\'ve done it!$b$bUsing sapphire from the chamber\'s adornments, I have fashioned a pair of goggles. With them, I am able to see things...Amazing things!$b$bWith luck, my next entry will find me a newly rich man!','',26124),
(45963,'enUS','After a quick assessment, you determine that this fellow has expired within the last several hours.','',26124),
(45964,'enUS','There were... too many!','There were... too many!',26124),
(45966,'enUS','They came out of nowhere!','They came out of nowhere!',26124),
(45967,'enUS','Get to the drop point!','Get to the drop point!',26124),
(45968,'enUS','Wildhammers!','Wildhammers!',26124),
(45969,'enUS','Let\'s get these humans to the drop point.','Let\'s get these humans to the drop point.',26124),
(45970,'enUS','We need to lighten the load here.','We need to lighten the load here.',26124),
(45971,'enUS','Hang on tight. It\'s going to get bumpy!','Hang on tight. It\'s going to get bumpy!',26124),
(45973,'enUS','Let\'s get something straight... we\'re not your taxi service!','Let\'s get something straight... we\'re not your taxi service!',26124),
(45974,'enUS','Some people only want to watch the world burn. Others want to be the ones responsible for burning it...','',26124),
(45975,'enUS','Through fire we purge this land of its impurities.','',26124),
(45976,'enUS','Reduced to ashes... Soon nothing will be left of Gilneas or the worgen taint.','',26124),
(45977,'enUS','Stinking ettins!','Stinking ettins!',26124),
(45978,'enUS','Aaaagghhh!','Aaaagghhh!',26124),
(45980,'enUS','Twilight\'s Hammer pukes!','Twilight\'s Hammer pukes!',26124),
(45981,'enUS','For Kurdran!','For Kurdran!',26124),
(45982,'enUS','We must stop Cho\'gall from creating his ultimate weapon at all costs, even if that means sacrificing ourselves.','',26124),
(45983,'enUS','We\'re out of here. Good luck!','We\'re out of here. Good luck!',26124),
(45984,'enUS','Thanks for the company!','Thanks for the company!',26124),
(45985,'enUS','Kill these ettins so that we can come back and finish the job.','Kill these ettins so that we can come back and finish the job.',26124),
(45986,'enUS','See you back at Victor\'s Point!','See you back at Victor\'s Point!',26124),
(45987,'enUS','Aaaeeeiiii!','Aaaeeeiiii!',26124),
(45988,'enUS','Dey came at us from everywhere, mon!','Dey came at us from everywhere, mon!',26124),
(45989,'enUS','For dey Horde!','For dey Horde!',26124),
(45990,'enUS','Stinkin\' ettins!','Stinkin\' ettins!',26124),
(45991,'enUS','Get ta dey drop point!','Get ta dey drop point!',26124),
(45992,'enUS','Dey were too many, mon!','Dey were too many, mon!',26124),
(45993,'enUS','Twilight scum!','Twilight scum!',26124),
(45994,'enUS','Kill dem for me!','Kill dem for me!',26124),
(45995,'enUS','Someone needs ta lose some weight, mon.','Someone needs ta lose some weight, mon.',26124),
(45996,'enUS','Let\'s get ta dey drop point!','Let\'s get ta dey drop point!',26124),
(45997,'enUS','Assassins? What we need ta do is drop some firebombs on dem!','Assassins? What we need ta do is drop some firebombs on dem!',26124),
(45998,'enUS','Why we gotta taxi you? Canna ya just sneak in dere, mon?','Why we gotta taxi you? Canna ya just sneak in dere, mon?',26124),
(45999,'enUS','Okey dokey. We outta here, mon!','Okey dokey. We outta here, mon!',26124),
(46000,'enUS','Bye-bye now!','Bye-bye now!',26124),
(46001,'enUS','You kill dese ettins so we be comin\' back ta finish dey job, mon!','You kill dese ettins so we be comin\' back ta finish dey job, mon!',26124),
(46002,'enUS','Be seein\' ya back at Crushblow.','Be seein\' ya back at Crushblow.',26124),
(46003,'enUS','Dere\'s nothin\' bettah dan flyin\' ovah ya enemies an\' droppin\' dey boom-boom bombs on dem!$B$BDat, or droppin\' two-hundred, fifty pound orcs on dere heads. Right, mon?','',26124),
(46004,'enUS','Jon-Jon, I\'m here to lead your wind rider squad and drop off the Kor\'kron assassins.','Jon-Jon, I\'m here to lead your wind rider squad and drop off the Kor\'kron assassins.',26124),
(46005,'enUS','','Drinking a healing potion!  I won\'t be able to use another one for a while!',26124),
(46006,'enUS','Hey, why not you say so? Give dem Twilight\'s the ol\' one-two, den ya comin\' back here an\' we party!$B$BI gots me a sweet lil\' place down on dey beach with me lady. You comin\' by!','',26124),
(46007,'enUS','','Lady Windrunner herself sent me to serve as the Horde liaison to Zaela and the Dragonmaw clan. She and the new Warchief, Garrosh, are attempting to mend their broken fences, it would seem.$B$BIn any case, we must put an end to the Twilight threat once and for all. Most importantly, though, we must keep Cho\'gall from creating his ultimate weapon.',26124),
(46008,'enUS','Drinking a healing potion!  I won\'t be able to use another one for a while!','',26124),
(46009,'enUS','|TInterface\\Icons\\ability_warrior_charge.blp:20|tGeneral Umbriss sets his eyes on |cFFFF0000$n|r and begins to cast |cFFFF0000|Hspell:74670|h[Blitz]|h|r!','',26124),
(46010,'enUS','|TInterface\\Icons\\ability_warrior_shieldreflection.blp:20|tOzruk casts |cFFFF0000|Hspell:78939|h[Elementium Bulwark]|h|r!','',26124),
(46011,'enUS','Good! I\'m glad you\'re here, $n. We have much to discuss.','',26124),
(46012,'enUS','See, Cassius. I told you that we could depend upon $n.','',26124),
(46013,'enUS','We Wildhammer are a proud bunch. I trust that you have as much pride in the Alliance, $n?','',26124),
(46014,'enUS','That\'s my $g boy : girl;! How goes the fight, $n?','',26124),
(46015,'enUS','','Good to see you again, $n. I look forward to fighting by your side once more.',26124),
(46016,'enUS','','These Twilight scum can\'t hold out much longer. The Dragonmaw Clan has waited a long time for this, $n.',26124),
(46017,'enUS','','You see, Cozwynn, I told you that we could rely upon $n.',26124),
(46018,'enUS','','The Dragonmaw stand proudly with the Horde. The Twilight Citadel will fall, $n!',26124),
(46019,'enUS','','The Firelord will bring about the end of Azeroth at long last! You will burn in his fury, fools!',26124),
(46020,'enUS','I feel slightly unhinged. I am not taking well to this... condition.','',26124),
(46021,'enUS','Crowley? I knew him. He was nothing more than a criminal before the curse took hold of our land. Now he\'s a great worgen hero? Sickening...','',26124),
(46022,'enUS','Bloodfang? When the attacks upon Gilneas first occurred, it was Bloodfang\'s worgen that lead the charge. This monster and his pack have been terrorizing these lands for years.','',26124),
(46023,'enUS','Just do as I say and this war will end without incident. Unless you count the death of every worgen in Lordaeron as an incident.','',26124),
(46024,'enUS','Never did I dream that our \"king\" would betray us as he did. To think that he had been a worgen in secret while he ruled over us. Sickening...','',26124),
(46025,'enUS','\"It\'s over, Godfrey...\" That\'s what he told me right before I jumped off of the cliff. NOTHING IS OVER, GREYMANE! I LIVE AGAIN!','',26124),
(46026,'enUS','We used to burn the worgen when we killed them - to be sure that they were dead.','',26124),
(46027,'enUS','Gilneas was an impossible dream. Only a man of true vision could have seen it through... but Greymane? Never...','',26124),
(46028,'enUS','For pity\'s sake, Ashbury, cover yourself. Your leg bones are popping out.','',26124),
(46029,'enUS','I did not bring this wretched affliction upon myself, Godfrey. It was a \"gift,\" remember? Now kindly enjoy the \"gift\" and shut up.','',26124),
(46030,'enUS','They should have burned my damned corpse.','',26124),
(46031,'enUS','Being Forsaken has its benefits. Let me see... I am able to practically live underwater. I can stay submerged 233%% longer than any fleshy mortal. Yes, count it, 233%%.','',26124),
(46032,'enUS','Oh, and I am now able to shrug off mind controlling effects - BECAUSE I LACK A BRAIN!','',26124),
(46033,'enUS','And perhaps the best part, I now have a hungering for the flesh of other humanoids. Cannibalizing their rotting corpses grants me power. Yes, DE-LI-CIOUS...','',26124),
(46034,'enUS','This is undoubtedly Godfrey\'s fault.','',26124),
(46035,'enUS','I always loved Silverpine -- until the Lich King let loose his rampaging Scourge armies and turned the land into a massive rotting corpse pit. Now the sight of it boils my green blood.','',26124),
(46036,'enUS','Keep the conversations curt. I am in no mood for whining or rambling.','',26124),
(46037,'enUS','I\'m losing my mind. Can\'t keep my thoughts together...','',26124),
(46038,'enUS','Rage is the only emotion I have left.','',26124),
(46039,'enUS','Vengeance will be ours!','',26124),
(46040,'enUS','I am more than Forsaken... more than a man... I am something new. Something... else.','',26124),
(46041,'enUS','Wha? What happened to me? WHO ARE YOU PEOPLE?','',26124),
(46042,'enUS','HELP! HELP! I\'ve been captured by monsters!','',26124),
(46043,'enUS','HAH! Don\'t you recognize us, Dempsey? It\'s Godfrey. I have here Lord Walden and Baron Ashbury. We\'ve \"saved\" you and this is the thanks that we get?','',26124),
(46044,'enUS','Your theft is forbidden, trespasser!','',26124),
(46045,'enUS','You tread on sacred ground! You must be purified!','',26124),
(46048,'enUS','We have sworn to serve, intruder. And so shall you.','',26124),
(46049,'enUS','You... You saved me? I\'m a damned monster! YOU\'RE A DAMNED MONSTER! LOOK AT YOURSELF!','',26124),
(46050,'enUS','Those who behold the starlight must forever protect it!','',26124),
(46051,'enUS','Once a thief, I am now a servant of the Stars.','',26124),
(46052,'enUS','I welcome you into an eternity of service, thief.','',26124),
(46053,'enUS','You always were a spineless coward, Dempsey.','',26124),
(46054,'enUS','','You won\'t be able to open the back door yourself to escape once you\'ve started the chaos. You\'ll have to either get the guards to open it by killing bar patrons, get Private Rocknot drunk so he causes property damage, or see if Spazzring has the key on him!',26124),
(46055,'enUS','Deathwing has returned. He\'s seized Grim Batol and much of the highlands, and I feel near powerless to stop him.$B$BSoon, our queen shall arrive, and together we shall put the once Earthwarder in his place.','',26124),
(46056,'enUS','3...','',26124),
(46057,'enUS','2...','',26124),
(46058,'enUS','1...','',26124),
(46059,'enUS','WHAT WAS THAT?!','',26124),
(46060,'enUS','THERE\'S NOTHING HERE EXCEPT FOR THIS FOG!','',26124),
(46061,'enUS','KEEP FIGHTING! I\'M GOING UP TOP TO SPEAK WITH CHO\'GALL!','',26124),
(46062,'enUS','','I\'ve been watching the Dark Iron for a long time...plotting, hoping, wishing for the chance to drive them away and take back my land.$B$BThey can keep Blackrock Mountain. I hope it erupts again and takes them all with it. I want what is now called the Burning Steppes, my part of the Redridge Mountains that their fiery overlord destroyed.$B$B$C, I\'m going to show the world the potential left in my land. I\'ll build a kingdom of peace and justice atop the death and trickery they leave behind them. My vigil is over. I\'m here to fight for what\'s rightfully mine.$B$BAnd I\'m willing to die for it.',26124),
(46063,'enUS','ASSASSINS! I\'ll take chunks out o\' you!','',26124),
(46064,'enUS','You\'ll never get away with this, you ugly, stinkin\' witch!','',26124),
(46065,'enUS','','Oh really?  What exactly will you do, dwarf?  There\'s nobody to save you here.',26124),
(46066,'enUS','You\'re wrong, banshee.  We\'ve come to take Gidwin back.','',26124),
(46067,'enUS','','Just the two of you?  You\'ll never stand a chance.',26124),
(46068,'enUS','I beg to differ.','',26124),
(46069,'enUS','Charge!','',26124),
(46070,'enUS','It\'s hard to explain to the Dragonmaw concepts like, \"Fields of Fire\" or \"Suppressive Barrage.\"$B$BFortunately, they have a firm grasp of \"Kill Zones\" and ... uh, \"Murder.\"','',26124),
(46071,'enUS','I asked for reinforcements to help us hold the beach. And the Horde sent these tiny little men and their small metal tubes.$B$B<Gralok eyes the nearby goblins with disdain.>','',26124),
(46072,'enUS','','So the Banshee Queen has sent assassins?',26124),
(46073,'enUS','Lorna, is that how you greet old friends? ','',26124),
(46074,'enUS','','Godfrey? So the rumors are true.',26124),
(46075,'enUS','','You would betray your kingdom out of spite?',26124),
(46076,'enUS','My kingdom? My kingdom is no more.','',26124),
(46077,'enUS','Your father and Greymane saw to that... No, Gilneas died when they allowed murderous beasts to reign free. Unchecked.','',26124),
(46078,'enUS','Now lay down your arms and surrender. We are not here to kill you. Not yet.','',26124),
(46079,'enUS','','HAH! You\'ll have to kill me! DIE!',26124),
(46080,'enUS','','%s falls unconscious.',26124),
(46081,'enUS','','You won\'t be able to open the back door yourself to escape once you\'ve started the chaos. You\'ll have to either get the guards to open it by killing bar patrons, get Private Rocknot drunk so he causes property damage, or see if Spazzring has the key on him!',26124),
(46082,'enUS','','This stronghold is fortified, but our enemies close in from all sides. We would be wise to secure our position on the coast before advancing farther inland. ',26124),
(46083,'enUS','Hold the line!','',26124),
(46084,'enUS','Quickly! We must head back to the Forsaken Front before we are discovered!','',26124),
(46085,'enUS','Spirits of the Firelands, fill me with your rage!','',26124),
(46086,'enUS','We will always remember Kargath Bladefist for what he once was to the Horde. He was one of the finest warriors to ever live, even the Alliance recognizes this.$B$BThe Kargath Expeditionary force was named in his honor, and I plan to ensure we live up to his name. We will drive out the Dark Iron Dwarves and claim Blackrock Mountain, and all of the surrounding areas, for the Horde as they so rightfully belong.$B$BYou will be the Warchief\'s blade against Thaurissan. Wear that honor proudly.','',26124),
(46087,'enUS','Spirits of Skywall, heed my call!','',26124),
(46088,'enUS','Spirits of Deepholm, grant me your strength!','',26124),
(46089,'enUS','','Looks like they found their way back home.  I\'m relieved.$b$bYou came back, too!  Are you interested in joining us?',26124),
(46090,'enUS','','By the way, you\'re welcome to borrow any supplies you find inside the caravan... as long as you bring them back when you\'re done!',26124),
(46091,'enUS','','I\'d like to set up shop in Light\'s Hope Chapel someday.  I\'m not much of a fighter, but that doesn\'t mean I can\'t help the cause.',26124),
(46092,'enUS','','The boys and I have only traveled together for a little while, but I already can\'t imagine life without either one of them.',26124),
(46093,'enUS','','I hope you\'ve made yourself welcome to the items inside my caravan.  If we\'re not using them, you might as well borrow them.',26124),
(46094,'enUS','','Why would he run off like that?!',26124),
(46095,'enUS','','Promise me you\'ll find him, $n.',26124),
(46096,'enUS','','<Fiona is rather upset.  She doesn\'t seem to be in the mood to talk.>',26124),
(46097,'enUS','','Good to see you again, $n!',26124),
(46098,'enUS','','Hey, $n!  You here to visit, or did you want to buy something?',26124),
(46099,'enUS','','Well, well... look who\'s here!',26124),
(46100,'enUS','I can\'t BELIEVE that we\'re stopping!  We\'ve got a duty to do here!','',26124),
(46101,'enUS','Why haven\'t we left yet?  I\'m ready to head off on my own if we don\'t get going.','',26124),
(46103,'enUS','What\'s the holdup, Fiona?','',26124),
(46104,'enUS','Alright, Gidwin... deep breaths...','',26124),
(46105,'enUS','$R! Your corpse will feed the sea.','',26124),
(46106,'enUS','Incoming mortar barrage!','',26124),
(46107,'enUS','Take the scout\'s spectacles.','Take the scout\'s spectacles.',26124),
(46108,'enUS','That useless blood elf!  We have a DUTY to perform, and he wastes our time!','',26124),
(46109,'enUS','I don\'t know why I put up with his nonsense.  He never takes anything seriously.','',26124),
(46110,'enUS','Tyrosus himself sent us to Northdale!  So why are we wasting our time with upstart nerubians?!','',26124),
(46111,'enUS','I\'ll throw my hammer upside his head if he makes us wait any longer.','',26124),
(46112,'enUS','Gidwin is nearby... I know it.  Paladin\'s intuition.','',26124),
(46113,'enUS','We must avenge our mother!\n\nDistract the monster who slew her, free us from this cage, and we will fight by your side.\n\nOur ability to reduce the damage an enemy inflicts will help you survive the Proto-Behemoth\'s Scorching Breath.','',26124),
(46114,'enUS','If one such as I can be captured by that lumbering oaf, then you must be brave indeed to venture here.\n\nIf you can distract Halfus and break the chains binding me then I will fight alongside you.\n\nMy ability to blind the eyes of an enemy will help you withstand Halfus\' Frenzied Assault.','',26124),
(46115,'enUS','If one such as I can be captured by that lumbering oaf, then you must be brave indeed to venture here.\n\nIf you can distract Halfus and break the chains binding me then I will fight alongside you.\n\nMy ability to temporarily paralyze an enemy\'s body will grant you respite from Halfus\' Malevolent Strikes.','',26124),
(46116,'enUS','If one such as I can be captured by that lumbering oaf, then you must be brave indeed to venture here.\n\nIf you can distract Halfus and break the chains binding me then I will fight alongside you.\n\nMy ability to engulf an enemy in a furious tempest will impair Halfus\' efforts to unleash Shadow Novas.','',26124),
(46117,'enUS','Oh, ahh... hello there, good traveler!  What can this fine goblin do for you today?$b$bI\'ll assure you that I\'m here in Light\'s Hope Chapel solely due to my hatred of the Scourge which I share with these Argent Crusaders, and definitely not because I\'m running away from any sort of embarrassing zeppelin crash!$b$bI\'ll stop talking now, before I implicate myself any further!','',26124),
(46118,'enUS','You present an interesting option, $r.  I\'ll take that into consideration.$b$bAlright, I\'ve considered it.  Sure, I\'ll join you.  I\'ve probably stayed in Light\'s Hope Chapel for too long anyhow.  Like a gnome at a urinal, I\'m gonna have to stay on my toes!  Heh heh!','',26124),
(46119,'enUS','You know, if you\'re looking for a place to hide out, you\'re free to join us in our caravan.','You know, if you\'re looking for a place to hide out, you\'re free to join us in our caravan.',26124),
(46120,'enUS','Hey boss.  You need someone to help drive the caravan, you just let ol\' Beezil know.','',26124),
(46121,'enUS','Stompers, defend your Chieftan!','',26124),
(46122,'enUS','Reavers, at my side!','',26124),
(46123,'enUS','Geomancers, bury them in stone and flame!','',26124),
(46124,'enUS','','The T.A.D. units have the priority targets!',26124),
(46125,'enUS','','Engage secondary targets!',26124),
(46126,'enUS','You will be punished for this transgression, thief!','',26124),
(46127,'enUS','','The creature is gaining power from the ancestral Grimtotem!  We must put them to rest if we are to defeat this beast!',26124),
(46128,'enUS','Good to see you again, $n. We snuck some more of us in here while you were prepping the Gates for the attack.$B$BI\'ll show you where we\'re to rendezvous with Master Shaw.$B$B<The squad leader produces a map of the Twilight Citadel and points to the spot.>$B$BLet me know when you\'re ready, and we\'ll all head up together.','',26124),
(46129,'enUS','I\'m ready, commander, let\'s head up.','I\'m ready, commander, let\'s head up.',26124),
(46130,'enUS','Fire!','',26124),
(46131,'enUS','Let \'em have it!','',26124),
(46132,'enUS','Blast \'em!','',26124),
(46133,'enUS','Fire in the hole!','',26124),
(46134,'enUS','The creature is gaining power from the ancestral Grimtotem!  We must put them to rest if we are to defeat this beast!\n','',26124),
(46135,'enUS','','Relax, spend some coin... we\'ve got everything from money changers and laundry services to exotic drinks.$B$BAnd if anyone gives you any trouble? You just let ME know, and I\'ll handle it.$B$BI\'m Mida... the boss.$B$BOh, the renovations? Yeah, I\'m always willing to help our new allies for the right price!',26124),
(46136,'enUS','','Look around... business is BOOMIN\'!$B$BWhile Gallywix is wastin\' time pickin\' custom wallpaper for his Pompous Palace in the Azsharan boondocks, I\'m makin\' twice the coin movin\' and shakin\' for Big G.$B$BYou heard me: Counting houses, trade halls, construction and maintenance, the war-works, supply lines...$B$BDon\'t even get me STARTED on transit! Orcs can fight, but they can\'t move goods; my boys ship it twice as fast for half the cost! Well... when it doesn\'t blow up along the way, hee.$B$BAnyhow! Take a load off, huh? Enjoy yourself, spend some coin... we\'ve got everything from money changers and laundry services to exotic drinks and fishing trainers.',26124),
(46137,'enUS','It\'s good to have traveling companions.  The road gets lonely out here.','',26124),
(46138,'enUS','Greetings, $n.','',26124),
(46139,'enUS','','Onward, $n! We will beat back the Alliance dogs and secure Lordaeron for the Forsaken! For the Horde!',26124),
(46140,'enUS','Not now, $gpal:lady;.$B$BI gotta re-tune the boss\' shredder.$B$BShe don\'t like movin\' around the city on foot like any old chump, ESPECIALLY if she\'s gotta go deal with the warchief.','',26124),
(46141,'enUS','','I will leave your cities in dust and your lives in ruin!',26124),
(46142,'enUS','','Lay down your arms and surrender!',26124),
(46143,'enUS','','Look at them, $p. They scurry like rats, veering headlong to their doom. Surely Crowley and Bloodfang can see the futility in this!',26124),
(46144,'enUS','','To the Greymane Wall! We will force their hand.',26124),
(46145,'enUS','Yes, I leave for Nagrand to learn from the elements there.  They have suffered and seen many of these same symptoms.','',26124),
(46146,'enUS','How long you gonna be gone?','',26124),
(46147,'enUS','It may take time to learn what I must.  I trust I will not be gone too long, but it could be weeks - even months.','',26124),
(46148,'enUS','In my absence, I am instructing you, Garrosh Hellscream, to lead the Horde.  You have the strength and courage that our people need to survive in these trying times.','',26124),
(46149,'enUS','I am honored, warchief.  But I feel unprepared for the life of a ruler.','',26124),
(46150,'enUS','You will not be alone.  You will have advisors: Cairne, Eitrigg, Vol\'jin.  They will help guide you.','',26124),
(46151,'enUS','And though I am leaving soon, I can also instruct you.','',26124),
(46152,'enUS','A good first test may be dealin\' with dese cultists.  Da people be scared.  Dey aren\'t sure what\'s goin\'on.','',26124),
(46153,'enUS','But even we are not sure of all that is happening.  Should we capture these cultists and force their silence?  But that may anger the rest of the people... Still, we cannot allow the cult to spread fear and lies...','',26124),
(46154,'enUS','Now you are thinking like a ruler, Garrosh.  You must look at all sides of a problem.  Consult with your advisors and act with confidence.','',26124),
(46155,'enUS','They will help you Garrosh.  And I will help you.  I will find the answers that we need to assuage the fears of the people and soothe the elements.','',26124),
(46156,'enUS','I will not fail you, Warchief.  I will lead as well as I can, and I will consult with the advisors you suggest.  I know what a tremendous honor you do me, and I will strive to be worthy of it.','',26124),
(46157,'enUS','Then it is done.','',26124),
(46158,'enUS','Let everything you do be done for the Horde.','',26124),
(46159,'enUS','For da Horde!','',26124),
(46160,'enUS','For the Horde!','',26124),
(46161,'enUS','For the Horde!','',26124),
(46162,'enUS','I don\'t get many visitors this deep in the Plaguewood.  Abominations, mostly.$b$bCan I help you with something?','',26124),
(46163,'enUS','The Admiral was killed during our last naval engagement. I\'ve turned this ship into a fortress.$B$BWe\'re improvising here, $c.','',26124),
(46164,'enUS','Remember: Hellscream\'s eyes are upon you, $n!','',26124),
(46165,'enUS','The hieroglyphs on your tablets indicate that there\'s a way to get this mechanism working again.$b$bWe just need to figure out how...','',26124),
(46166,'enUS','It looks like your predecessor had time to set the flares up, but they have not yet been launched.$b$bThis is your time to shine, $n.','',26124),
(46167,'enUS','The flare launcher has been emptied.','',26124),
(46168,'enUS','Gnugat... Can you wait until we are OFF of the boat before you take it apart?','',26124),
(46170,'enUS','Gnugat, does it seem wise to you to tear apart a ship underneath your own feet?','',26124),
(46171,'enUS','Gnugat, if your goblins strip any more of this ship\'s supports, it\'ll plunge into the surf!','',26124),
(46172,'enUS','Time is money, friend!','',26124),
(46173,'enUS','Nobody ever made money by keeping themselves alive, Rok\'tar.','',26124),
(46174,'enUS','Who needs this hunk of metal more, Rok\'tar? You? ...Or the highest bidder?','',26124),
(46175,'enUS','The trees here in the Highlands are made of stout wood. And some of them... stone. I don\'t pretend to understand.$B$BWe\'ve got diamond-bladed shredders to harvest the stuff, but the Alliance keeps whacking them.','',26124),
(46176,'enUS','Here we go, $gbub:toots;. Watch how things get done.','Woohoo, $gsweet-thing:lady;! Step aside and watch the magic.',26124),
(46177,'enUS','Cover my butt in case we\'re ambushed.','Cover my butt in case we\'re ambushed.',26124),
(46178,'enUS','This shredder looks like it can be repaired. You fire off a signal...','',26124),
(46179,'enUS','Throm-Ka, $n. We snuck a few more in while you were preparing the Gates for attack.$B$BI\'ll show you where we\'re to meet with Garona.$B$B<The squad leader produces a map of the Twilight Citadel and points to the spot.>$B$BLet me know when you\'re ready, and we\'ll go together.','',26124),
(46180,'enUS','Well, stuff it. This thing is busted beyond hope. I\'m outta here!','Well, stuff it. This thing is busted beyond hope. I\'m outta here!',26124),
(46181,'enUS','We did it! Let\'s fire this masterpiece up...','We did it! Let\'s fire this masterpiece up...',26124),
(46182,'enUS','We should move out, $n. Up the ramp and then straight to Master Shaw.','',26124),
(46183,'enUS','Deathblade ... activated! System integrity check: 57 percent nominal.','',26124),
(46184,'enUS','That\'s actually pretty good by Bilgewater standards. ','',26124),
(46185,'enUS','Deploy mobile rocket platform pods! .... Oh yes.','',26124),
(46186,'enUS','COME, HUMANS! LICK THE STAINLESS STEEL BOOTS OF YOUR NEW GOD!','',26124),
(46187,'enUS','Wait! Do you hear something?','',26124),
(46188,'enUS','','Crowley, your forces have fallen before my mighty army. You have lost!',26124),
(46189,'enUS','It\'s not over, Sylvanas. Not yet.','',26124),
(46190,'enUS','','You frivolously throw away the lives of your people while your own king sits atop his throne of lies, nary lifting a finger to help.',26124),
(46191,'enUS','','Is Gilneas worth the lives that have been lost? The lives that will be lost? You cannot win.',26124),
(46193,'enUS','We will die trying!','',26124),
(46194,'enUS','','And your daughter? You could have saved her... You could have offered her your blood, yet you did not. Why?',26124),
(46195,'enUS','LORNA? What... Where is she!? What have you done to her!?','',26124),
(46196,'enUS','','Nothing, yet...',26124),
(46197,'enUS','','I now present you with a choice - a choice that I was never given.',26124),
(46198,'enUS','','I offer you the life of Lorna for your unconditional surrender.',26124),
(46199,'enUS','','Choose your next words wisely, Crowley. Deny me and she will serve me in undeath - forever.',26124),
(46200,'enUS','','Bring her, Godfrey!',26124),
(46202,'enUS','Hello, old friend!','',26124),
(46203,'enUS','GODFREY! You deceitful maggot!','',26124),
(46204,'enUS','Lorna... I... Release her. I will sound the retreat.','',26124),
(46205,'enUS','You can\'t be serious, Crowley. You miserable bastard!','',26124),
(46206,'enUS','','Release her, Godfrey.',26124),
(46207,'enUS','Of course, mistress.','',26124),
(46208,'enUS','','Now leave here, Crowley, and never return.',26124),
(46209,'enUS','','Lordaeron belongs to the Forsaken.',26124),
(46210,'enUS','Forgive me, daughter...','',26124),
(46211,'enUS','','SOLDIERS OF THE HORDE! WE ARE VICTORIOUS! LORDAERON IS W...',26124),
(46212,'enUS','','%s dies.',26124),
(46213,'enUS','WHAT HAVE YOU DONE, GODFREY!','',26124),
(46214,'enUS','Something that should have been done a long time ago, you filthy animal.\n','',26124),
(46215,'enUS','Gilneas belongs to me, and so soon will the rest of Lordaeron!','',26124),
(46216,'enUS','NOW JOIN YOUR MISTRESS IN DEATH!','',26124),
(46217,'enUS','FALL BACK, BROTHERS! TO SHADOWFANG!','',26124),
(46218,'enUS','This land will quiver and shake in the wake of our destruction!','',26124),
(46219,'enUS','Fix her... FIX HER!','',26124),
(46220,'enUS','','We are bound to her, sisters...',26124),
(46221,'enUS','','It will destroy us, sister...',26124),
(46222,'enUS','','It is our sacred duty. The pact was sealed, the bargain made...',26124),
(46223,'enUS','','Then let it be done.',26124),
(46224,'enUS','','I saw... only darkness.',26124),
(46225,'enUS','','And as I drifted towards nothingness, a brilliant light appeared, then another, and another... My dear val\'kyr.',26124),
(46226,'enUS','','I know now - beyond a shadow of a doubt - that the val\'kyr are our future.',26124),
(46227,'enUS','','We will never stop fighting for Lordaeron. Never...',26124),
(46228,'enUS','My people have enjoyed a good relationship with the Wildhammer for quite some time now.$B$BA few of us have settled here... those who have found this land to be a home worth defending.','',26124),
(46229,'enUS','Filthy, filthy orcs! Unhand those whelps!','',26124),
(46230,'enUS','You cannot escape the highlands, orcs!','',26124),
(46231,'enUS','Murderous scum! Treacherous filth!','',26124),
(46233,'enUS','Burn! BURN AND SUFFER!','',26124),
(46234,'enUS','Follow me if you dare!','',26124),
(46235,'enUS','It\'s time for a tactical retreat!','',26124),
(46238,'enUS','You\'re gonna be sorry!','',26124),
(46239,'enUS','Don\'t say I didn\'t warn ya!','',26124),
(46240,'enUS','Prison taught me one very important lesson, well, two if you count how to hold your soap, but yes! SURVIVAL!','',26124),
(46241,'enUS','Ah-ha! I\'ve got you right where I want you!','Ah-ha! I\'ve got you right where I want you!',26124),
(46242,'enUS','Now... witness the full power of Millhouse Manastorm!','Now... witness the full power of Millhouse Manastorm!',26124),
(46243,'enUS','Alliance soldiers! So bold, so cavalier. (Scurry, scurry, scurry, mortals.) Your numbers are small, and you are too late. (Helpless and hopeless, helpless and hopeless.)','',26124),
(46244,'enUS','Cho\'gall!','',26124),
(46245,'enUS','Kill him!','',26124),
(46246,'enUS','','Even in these bright days after the reign of Kel\'thuzad, after the fall of the Lich King: the Brotherhood lives on.',26124),
(46247,'enUS','None may pass into the World\'s Heart!','',26124),
(46248,'enUS','The cycle is complete.','',26124),
(46249,'enUS','Break yourselves upon my body. Feel the strength of the earth!','',26124),
(46250,'enUS','A protector has fallen. The World\'s Heart lies exposed!','',26124),
(46251,'enUS','','For my death, countless more will fall. The burden is now yours to bear.',26124),
(46252,'enUS','','Minions, followers, children of the Worldbreaker, I call to you now! The hallowed halls of our father have been befouled! Kill the intruders!',26124),
(46253,'enUS','','Witness the power bestowed upon me by Deathwing! Feel the fury of earth!',26124),
(46254,'enUS','','A sacrifice for you, master.',26124),
(46255,'enUS','','The world will be reborn in flames!',26124),
(46256,'enUS','Hakkar is known by many names. Some call him the Blood God, others simply refer to him as The Soulflayer. Titles aside, he is an entity of enormous power with malicious intentions for our world.$B$BMy flight discovered this temple early on and sank it beneath the Swamp of Sorrows. Unfortunately, we only seemed to aid the Atal\'ai by ensuring their efforts to summon Hakkar went on undisturbed. Many of the dragons tasked with guarding the temple have been corrupted, and the Soulflayer\'s presence grows with each passing day.$B$BI cannot stop them alone. Together, though, we might have enough time to stop this madness.','',26124),
(46257,'enUS','','Accompany Lady Sylvanas Windrunner across the Battlefront.',26124),
(46258,'enUS','(Finish it! Finish them all!)','',26124),
(46259,'enUS','Pathetic flesh!','',26124),
(46260,'enUS','Horde scum! I was once like you. (Our old masters, small and hungry.) You cling to your mortal shells... (Bags of blood and bone and tears). ...trying to deny your insignificance.','',26124),
(46261,'enUS','Let\'s move out quickly, $n. Up the ramp and straight to Garona.','',26124),
(46262,'enUS','With Stormwind\'s park district destroyed by Deathwing\'s pass over the city, we\'re returning to Darnassus for a time.','',26124),
(46263,'enUS','The Highborne have returned, and with them spellcraft lost to the world for centuries.$B$BDo you have something for me to examine?','The Highborne have returned, and with them spellcraft lost to the world for centuries.$B$BDo you have something for me to examine?',26124),
(46264,'enUS','Reforge an item.','Reforge an item.',26124),
(46265,'enUS','What is reforging?','What is reforging?',26124),
(46266,'enUS','Arcane Reforgers can modify the magical effects of a item; this magically complex process is known simply as reforging.$B$BThrough reforging, a secondary attribute of any piece of weaponry, armor, or jewelry may be reduced in order to add an additional secondary attribute. In this manner one may customize their equipment to best match their role and skills.$B$BFor example, if an item afforded you a bonus to strike your enemies but you\'d rather it made you attack more quickly, an Arcane Reforger could, for a price, reforge the item to have less Hit but increase your Haste.','Arcane Reforgers can modify the magical effects of a item; this magically complex process is known simply as reforging.$B$BThrough reforging, a secondary attribute of any piece of weaponry, armor, or jewelry may be reduced in order to add an additional secondary attribute. In this manner one may customize their equipment to best match their role and skills.$B$BFor example, if an item afforded you a bonus to strike your enemies but you\'d rather it made you attack more quickly, an Arcane Reforger could, for a price, reforge the item to have less Hit but increase your Haste.',26124),
(46267,'enUS','If you\'re looking for an Arcane Reforger, there is a highborne mage inside the enchanting shop just outside the Mage District.','If you\'re looking for an Arcane Reforger, there is a highborne mage inside the enchanting shop just outside the Mage District.',26124),
(46268,'enUS','Reforge','Reforge',26124),
(46269,'enUS','This hardly seems fair!!','',26124),
(46270,'enUS','Why do I have to sit up top with all the stuff?!','',26124),
(46271,'enUS','','Because you\'re the bravest, dear.',26124),
(46272,'enUS','Because you\'re short.','',26124),
(46273,'enUS','Hey!  I oughtta bounce one of these trunks off of your head, Tarenar.','',26124),
(46274,'enUS','','I know I promised you the front seat, Giddy, but we have an elderly guest.  I\'m sorry.',26124),
(46275,'enUS','Fiona, I must warn you: Gidwin only wants to sit in front because he wants to kiss you.','',26124),
(46276,'enUS','Oh shut up, you dolt.  YOU probably want to kiss her a hundred times.','',26124),
(46277,'enUS','Do not!','',26124),
(46278,'enUS','Ahem!  I, ah, appreciate the ride, Madam Fiona.  It\'s nice to get off my feet for once.','',26124),
(46279,'enUS','','Do you normally walk these roads alone?',26124),
(46280,'enUS','Yes, I do, though it was easier when I was younger.  These days, I have to be more careful.','',26124),
(46281,'enUS','If you don\'t mind my askin\', what do you do that requires walking so much?','',26124),
(46282,'enUS','I service the five Argent towers.  Mostly repairs and maintenance, and some minor magical work.','',26124),
(46283,'enUS','Without proper upkeep, buildings within the plaguelands tend to... waste away.','',26124),
(46284,'enUS','Noble work.','',26124),
(46285,'enUS','I find it satisfying.  I enjoy working with my hands.','',26124),
(46286,'enUS','By the way, if any of you need anything repaired, let me know.  I am at your service.','',26124),
(46287,'enUS','So you\'re part of the Argent Crusade, eh?','',26124),
(46288,'enUS','Think you can put in the good word for us?  We\'re looking to join the order.','',26124),
(46289,'enUS','Certainly.  I don\'t make it out to Light\'s Hope very often anymore, but when you arrive, tell Max Tyrosus that I sent you.','',26124),
(46290,'enUS','Whoah... he lets you call him Max?','',26124),
(46291,'enUS','Ma\'am, would you mind dropping me off at Light\'s Shield Tower, just up ahead?  I have to stop here.','',26124),
(46292,'enUS','','Of course I\'m not just going to drop you off, Master Highbeacon.  We\'ll be happy to wait for you.',26124),
(46293,'enUS','NOOOOOOO!  Stopped again!','',26124),
(46294,'enUS','Light\'s Hope isn\'t far, young paladin.  Might I suggest walking?','',26124),
(46295,'enUS','Walking, eh...?','',26124),
(46296,'enUS','I can\'t believe I let Gidwin run off like that!','',26124),
(46297,'enUS','','It\'s not your fault, Tarenar.  He ran off on his own will.  None of us could stop him.',26124),
(46298,'enUS','We can\'t be certain that he was killed.  Maybe he just ran off somewhere.','',26124),
(46299,'enUS','No, he\'d never just leave his prayer book behind!  He was always nose-deep in that book, studying.','',26124),
(46300,'enUS','He was always studying, always trying to get better.','',26124),
(46301,'enUS','Even more reason to believe that he\'s still alive.','',26124),
(46302,'enUS','A paladin like Gidwin makes a fine death knight.  Any member of the Scourge powerful enough to defeat him would know that.','',26124),
(46303,'enUS','It\'s likely that he\'s being held somewhere, awaiting a death ritual.','',26124),
(46304,'enUS','','Really?  That\'s great news!',26124),
(46305,'enUS','','Well, actually, that\'s pretty bad news, but considering the alternatives... ',26124),
(46306,'enUS','If we\'re to find him, we\'re headed in the right direction.  It\'s likely that he was taken to Stratholme, or potentially to the Plaguewood.','',26124),
(46307,'enUS','Both are places of great evil.  This is the leg of my journey that I shun the most.','',26124),
(46308,'enUS','I\'m not sure I\'m ready to go in there alone.','',26124),
(46309,'enUS','','You\'re not alone, Tarenar.  You\'ve made allies along the way.  And besides, you\'re a skilled paladin in your own right.',26124),
(46310,'enUS','Me, skilled?  No, no, Gidwin was the good paladin.  He\'s the one who stayed up for hours every night practicing... ','',26124),
(46311,'enUS','','...yet it was you that continually kept up with him.  Without practice.',26124),
(46312,'enUS','','I\'ve watched both of you fight, Tarenar.  You\'ve got natural talent - more than Gidwin ever will.',26124),
(46313,'enUS','Perhaps that\'s why he left without you.','',26124),
(46314,'enUS','What do you mean?','',26124),
(46315,'enUS','Perhaps he felt he needed to prove that he was as talented as you.','',26124),
(46316,'enUS','This is all my fault.  I\'ve got to go find him, to set things right.','',26124),
(46317,'enUS','I wouldn\'t say that it\'s your fault, Tarenar.  But don\'t let that stop you from saving Gidwin.','',26124),
(46318,'enUS','','Let\'s get something straight, $r. I\'m here for just one thing: to kill Cho\'gall!$B$BYour job is to keep him from finishing the creation of his ultimate weapon. It\'s an artifact that\'s supposedly being created with the power of an Old God.',26124),
(46319,'enUS','There\'s an artifact, a weapon, being forged with the power of an Old God. We don\'t know exactly what it is, but we need to get to it before it\'s completed by Cho\'gall.$B$BEverything else is secondary. Everyone is expendable, including you and I.','',26124),
(46320,'enUS','Be wary of taking to the sky above these ruins, $glad:lass;. The Twilight drakes have a taste for things that fly.','',26124),
(46323,'enUS','Commencing decontamination sequence... ','',26124),
(46324,'enUS','Decontamination complete. Standby for delivery.','',26124),
(46325,'enUS','Warning, system overload. Malfunction imminent!','',26124),
(46326,'enUS','Aye aye!','',26124),
(46327,'enUS','Burn dem all ta cinders!','',26124),
(46328,'enUS','Light da fuses, boys!','',26124),
(46329,'enUS','We gonna show you why treasure be a pirate\'s best friend!','',26124),
(46330,'enUS','Blowin \'em to bits, boss!','',26124),
(46331,'enUS','Peck \'dere eyes out!','',26124),
(46332,'enUS','Hit dem wit da most powaful \'ting you got!','',26124),
(46333,'enUS','','Powering up a high-powered shot!',26124),
(46334,'enUS','','Kill the engineer before she can get a shot off!',26124),
(46335,'enUS','Do you know my dad?','',26124),
(46336,'enUS','Load me into that cannon, boy!','Load me into that cannon, boy!',26124),
(46337,'enUS','Ey!  Get outta my treasure ya dirty sea rat!','',26124),
(46338,'enUS','Mrrglrglrgl?','',26124),
(46339,'enUS','Mrrglrgl, mmrglrlglrrrglrggl!','',26124),
(46340,'enUS','','We were fools to entrust an imbecile like Cho\'gall with such a sacred duty! I will deal with you intruders myself!',26124),
(46341,'enUS','No, not the Sanitron... it was my pride and joy!','',26124),
(46342,'enUS','Ugh! Not this again! I\'m asking for a new station next expedition...','',26124),
(46343,'enUS','','My brood will feed on your bones!',26124),
(46344,'enUS','','Powerless....',26124),
(46345,'enUS','','I tire of this.  Do you see this clutch amidst which you stand?  I have nurtured the spark within them, but that life-force is and always will be mine.  Behold, power beyond your comprehension!',26124),
(46346,'enUS','Ah, but which one is da real one?','',26124),
(46348,'enUS','Poor dear, you must be exhausted.$B$BThere\'s food and drink, if you like, and it\'s safe to rest here.','Poor dear, you must be exhausted.$B$BThere\'s food and drink, if you like, and it\'s safe to rest here.',26124),
(46349,'enUS','Looking for something to eat, $c?$B$BOr just a place to rest your weary bones for a while?','Looking for something to eat, $c?$B$BOr just a place to rest your weary bones for a while?',26124),
(46350,'enUS','Oh man, I\'m glad someone is here! Things are CRAZY down here! Crazier than usual!','',26124),
(46352,'enUS','No...da world...is mine...','',26124),
(46353,'enUS','On behalf of the illustrious and always-neutral Steamwheedle Cartel, welcome to Bogpaddle! We\'re proud to be the only beachfront resort and military-grade weapons yard in the Eastern Kingdoms.$B$BYou guys may have that little war ragin\' just south of here, but inside these walls, it\'s all fun and games. So take a load off, have some R&R and a drink or two, and keep out of trouble... or my bruisers will remind your skull what \"neutral territory\" means.','',26124),
(46354,'enUS','|TInterface\\Icons\\spell_arcane_arcaneresilience.blp:20|t%s begins to cast|cFFFE1CF7|Hspell:79729|h [Power Conversion]!|r','',26124),
(46355,'enUS','|TInterface\\Icons\\spell_nature_lightningshield.blp:20|t%s begins to cast|cFF1CF2FE|Hspell:79900|h [Unstable Shield]!|r','',26124),
(46356,'enUS','|TInterface\\Icons\\spell_nature_nullifydisease.blp:20|t%s begins to cast|cFF1CFE1C|Hspell:79835|h [Poison Soaked Shell]!|r','',26124),
(46357,'enUS','|TInterface\\Icons\\spell_fire_firearmor.blp:20|t%s begins to cast|cFFFF9A20|Hspell:79582|h [Barrier]!|r','',26124),
(46358,'enUS','Torben Zapblast, teleportation solutions engineer at your service!','',26124),
(46359,'enUS','|TInterface\\Icons\\ability_hunter_mastermarksman.blp:20|t%s sets his eye on |cFFFF0000$n|r and begins to cast|cFFFF0000|Hspell:79501|h [Acquiring Target]!|r','',26124),
(46360,'enUS','Send me to the surface, Torben.','Send me to the surface, Torben.',26124),
(46361,'enUS','Okay so you\'ve got two pygmies in the box. Now all you have to do is chop carefully, aiming for the empty space between them.','',26124),
(46362,'enUS','Like this?','',26124),
(46363,'enUS','No, no! Where\'s your sense of showmanship? Theatrics!','',26124),
(46364,'enUS',' Put your might into it! Really crack that crate in half, watch!','',26124),
(46365,'enUS','GWAAAAAAAAAAAAH!','',26124),
(46366,'enUS','Did you just..?','',26124),
(46367,'enUS',' Yes I think I did.','',26124),
(46368,'enUS','Oh... oh my...','',26124),
(46369,'enUS','I guess we\'re going to need some more pygmies.','',26124),
(46370,'enUS','I am a path smoothing test for action trigger splines with spells inbetween.','',26124),
(46371,'enUS','I am a path smoothing test for action trigger splines with events inbetween.','',26124),
(46372,'enUS','I am a path smoothing test for spawn event splines with spells inbetween.','',26124),
(46373,'enUS','I am a chain actions test using spawn event splines with events inbetween.','',26124),
(46374,'enUS','Yo.$B$BYou here to stable your pets, or lookin\' for a lost companion?','Yo.$B$BYou here to stable your pets, or lookin\' for a lost companion?',26124),
(46375,'enUS','Yo.$B$BYou lookin\' for a lost companion?','Yo.$B$BYou lookin\' for a lost companion?',26124),
(46376,'enUS','There will be more time to talk once we get back to the surface safely.','',26124),
(46377,'enUS','','Come on, you two. I want another dozen barrels full before we\'re done!',26124),
(46378,'enUS','','Ah, liquid gold. Gather up every last drop!',26124),
(46379,'enUS','','I love the smell of raw crude in the morning. The smell, ya know, that sour sulphur smell... the whole place. Smells like... profit.',26124),
(46380,'enUS','','Out of the water, into the barrels. Move it! Time is money, ya know.',26124),
(46381,'enUS','','Now THIS is what I call profit skimming. HEY! You missed some, over there.',26124),
(46382,'enUS','We have to break through those mindless leper gnomes if we want to get out of here alive!','',26124),
(46383,'enUS','Take the squad\'s last teleport beacon and get those survivors out of here. Thanks to your help, my men and I should be able to fight our way out of here.','',26124),
(46384,'enUS','Greetings, my name is Tae\'thelan Bloodwatcher. I have spent the better part of a lifetime training in the art of sorcery and gathering like-minded blood elves to form The Reliquary.$B$BYou see, there are ancient, powerful relics spread throughout this world that I plan to use to free my people from their addiction and unify them again  as the proud, indomitable race we once were.$B$BMagic is something to be embraced and, I assure you, a force that can be utilized free of corruption with proper teaching.$B$BAs it stands, the other races of the Alliance and even the Horde mock our kind for our half-destroyed capital, still-standing statues of Sunstrider and blunder after blunder across the world.$B$BNo more.','',26124),
(46385,'enUS','Please help me!','',26124),
(46386,'enUS','I don\'t want to die down here!','',26124),
(46387,'enUS','Don\'t let them eat me!','',26124),
(46388,'enUS','Some help! Anyone!','',26124),
(46389,'enUS','I\'m too young to die!','',26124),
(46390,'enUS','I\'m really going to die down here, aren\'t I?','',26124),
(46391,'enUS','Help! I\'m too weak to make it on my own.','',26124),
(46392,'enUS','Leave Smuggler\'s Scar to signal Adarrah','Leave Smuggler\'s Scar to signal Adarrah',26124),
(46393,'enUS','The Abyssal Seahorse seems very displeased.','',26124),
(46394,'enUS','Satekh!','',26124),
(46395,'enUS','Kadesh!','',26124),
(46396,'enUS','Osadi!','',26124),
(46397,'enUS','','I salvaged what I could from the nearby wreckage, but I can only stay down for so long...',26124),
(46398,'enUS','My eternal thanks to you.','',26124),
(46399,'enUS','There are Twilight\'s Hammer to be slain.','',26124),
(46400,'enUS','I am enslaved no longer!','',26124),
(46401,'enUS','Time for vengeance, mortals!','',26124),
(46402,'enUS','It is but a small token of my appreciation. My thanks to you.','',26124),
(46403,'enUS','Excuse me. I have some former captors to speak with.','',26124),
(46404,'enUS','Run, little Twilight cultists. Your doom draws near!','',26124),
(46405,'enUS','Time for a bit of revenge before I return home.','',26124),
(46406,'enUS','Your kind will be made to suffer for this, $r.','',26124),
(46407,'enUS','You ally yourself with these fiends? You, too, shall someday burn!','',26124),
(46408,'enUS','<The enormous black drake, covered with open wounds, stares you down with malice in his eyes. It does not blink.>','',26124),
(46409,'enUS','<The ferocious black drake strains at the chains that bind it. It\'s best to keep your distance.>','',26124),
(46410,'enUS','The bonds that hold me are not so permanent, $c. Pray you are not near when I have my vengeance.','',26124),
(46411,'enUS','Dragons are no mere beasts, like hogs or cattle. They are a force of nature. Powerful... Primal.$B$BTo bend them to your will is to harness the world.$B$BTo take up their reigns is to take destiny into your hands.','',26124),
(46412,'enUS','','I\'ve been mixing potions since before the cartel wars, and I don\'t plan to stop anytime soon.$B$BAs long as there\'s a buyer to be had, Ol\' Baba will be ready with a sale!',26124),
(46413,'enUS','That was some real firepower. Maybe there\'s more to these runty little goblins than meets the eye.','',26124),
(46414,'enUS','Grab the Seahorse while it\'s distracted!','Grab the Seahorse while it\'s distracted!',26124),
(46415,'enUS','Well done, $n! I imagine your journeys beneath the waves will be much smoother from here out.','',26124),
(46416,'enUS','Hear the call... serve him... join ussssssssssss...','',26124),
(46417,'enUS','C\'mon boys, let\'s take back our homes!','',26124),
(46418,'enUS','','We could have been civil about this, but no!',26124),
(46419,'enUS','Ya see that pass ahead dere, $glad:lass;?','',26124),
(46420,'enUS','Yeah...','Yeah...',26124),
(46421,'enUS','That\'s an ambush.','',26124),
(46422,'enUS','You seem very certain.','You seem very certain.',26124),
(46423,'enUS','Oh yeah, $glad:lass;! Been through 4 times already.','',26124),
(46424,'enUS','And I take it you\'re going again...','And I take it you\'re going again...',26124),
(46425,'enUS','Damn right!','',26124),
(46426,'enUS','Well, let\'s get to it then.','Well, let\'s get to it then.',26124),
(46427,'enUS','That\'s tha spirit!','',26124),
(46428,'enUS','That\'s right, show \'em our colors. Let \'em come!','',26124),
(46429,'enUS','If Keely sent ya to be ropin\' me back in, ya can just forget it. There\'s Twilight that need bashin\'.','',26124),
(46430,'enUS','I\'ll be headin\' back shortly, $glad:lass;. Just one more go, for good time\'s sake.','',26124),
(46431,'enUS','That all ya got?!','',26124),
(46432,'enUS','Cayden\'s got an axe with your name on it!','',26124),
(46433,'enUS','Come\'n get it!','',26124),
(46434,'enUS','I know there\'s more of ya, hidin\' in your little holes...','',26124),
(46435,'enUS','Weee! Shinies all over this place!$b$bTake a look at what I found diggin\' right here...$b$bIt\'s a breathin\' hat!\n','',26124),
(46436,'enUS','Get up you lazy bums, there\'s fighting to do!','Get up you lazy bums, there\'s fighting to do!',26124),
(46437,'enUS','Knock, knock!','',26124),
(46438,'enUS','Come outta ya holes, cowards!','',26124),
(46439,'enUS','Hidin\' from ol\' Cayden, are ya...','',26124),
(46440,'enUS','Anyone home?','',26124),
(46442,'enUS','Move out - strike them now! ','Move out - strike them now! ',26124),
(46443,'enUS','See you soon.','',26124),
(46444,'enUS','That was fun.','',26124),
(46445,'enUS','Not bad.','',26124),
(46446,'enUS','I\'m heading back now.','',26124),
(46447,'enUS','You\'re telegraphing your moves.','',26124),
(46448,'enUS','One less cultist for us to worry about.','',26124),
(46449,'enUS','Leave the bodies here, that they may see the futility of fighting the Dragonmaw.','Leave the bodies here, that they may see the futility of fighting the Dragonmaw.',26124),
(46450,'enUS','','See you later.',26124),
(46451,'enUS','','That was great fun.',26124),
(46452,'enUS','','Not bad, I guess.',26124),
(46453,'enUS','','I\'m heading back now.',26124),
(46454,'enUS','','You\'re telegraphing your moves.',26124),
(46455,'enUS','','One less cultist to worry about.',26124),
(46456,'enUS','For the glory of the Dragonmaw!','For the glory of the Dragonmaw!',26124),
(46457,'enUS','Start fighting, or start bleeding!','Start fighting, or start bleeding!',26124),
(46458,'enUS','Time to fight!','Time to fight!',26124),
(46459,'enUS','Freedom!','Freedom!',26124),
(46460,'enUS','Kill this fool, or Randolph will kill us!','Kill this fool, or Randolph will kill us!',26124),
(46461,'enUS','Fight for your miserable, worthless lives!','Fight for your miserable, worthless lives!',26124),
(46462,'enUS','Greetings, $r. I am Lord Itharius of the Green Dragonflight.$B$BI am here to free my kin from the evil within this temple, hopefully for good. Will you assist me?','',26124),
(46463,'enUS','','I knew you were coming. No one can resist me, not even you!',26124),
(46464,'enUS','You\'ve come for training. Good!','',26124),
(46465,'enUS','You there - $n! Help us defend this square.','',26124),
(46466,'enUS','Look out, more Dragonmaw. And the Horde is with them!','',26124),
(46467,'enUS','Come, we\'ve done enough damage here. Let\'s prepare another ambush.','Come, we\'ve done enough damage here. Let\'s prepare another ambush.',26124),
(46468,'enUS','We did it! Cover the roads and keep this place locked down.','',26124),
(46469,'enUS','Have you checked out my breathin\' hat?$b$bNo more suckin\' on clams for Budd! No sirree...\n','',26124),
(46470,'enUS','','Nurse Lillian sighs.',26124),
(46471,'enUS','Help Cenarius defeat Ragnaros!','',26124),
(46472,'enUS','You\'ll pay for this, Hogger!','',26124),
(46473,'enUS','One day...I will have my revenge...','',26124),
(46474,'enUS','Forest just setback!','',26124),
(46475,'enUS','Kill now, eat later!','',26124),
(46476,'enUS','Yiiipe!','',26124),
(46477,'enUS','Thank the Light! I\'ve made it.','',26124),
(46478,'enUS','It\'s a relief to be surrounded by normal gnomes again!','',26124),
(46479,'enUS','I thought I was goner!','',26124),
(46480,'enUS','You... you\'re not going to try to eat me, are you?','',26124),
(46481,'enUS','I never would\'ve made it on my own...','',26124),
(46482,'enUS','Thank you for getting me out of there!','',26124),
(46483,'enUS','My family... did you find my family?','',26124),
(46484,'enUS','Ah, a new arrival. Right this way, sir.','',26124),
(46485,'enUS','%s realizes it\'s been spotted and quickly plays dead!','',26124),
(46486,'enUS','Fathom-Lord Zin\'jatar has entered the battle!','',26124),
(46487,'enUS','ALL MUST BURN!','',26124),
(46488,'enUS','ASH!','',26124),
(46489,'enUS','FIRE... EXTINGUISHED!','',26124),
(46490,'enUS','Stay back in the name of the King!','',26124),
(46491,'enUS','You shall not pass!','',26124),
(46492,'enUS','Hold the line! Don\'t let them through!','',26124),
(46493,'enUS','Warden Thelwater, we need to push forward!','',26124),
(46494,'enUS','We need to make a move now, while we still can!','',26124),
(46495,'enUS','Allow me to introduce myself. I am Randolph Moloch, and I will be killing you all today.','',26124),
(46496,'enUS','Such a tragic waste of life.','',26124),
(46497,'enUS','My epic schemes, my great plans! Gone!','',26124),
(46498,'enUS','Steady men...steady...','',26124),
(46499,'enUS','Hold your fire! Warden\'s orders..no shootin\'...yet.','',26124),
(46500,'enUS','Keep \'em in your sights. If they make a move on the guards, they\'re dead.','',26124),
(46501,'enUS','Stay with me. You\'re going to make it out of here.','Stay with me. You\'re going to make it out of here.',26124),
(46502,'enUS','We\'re going to get you some help.','We\'re going to get you some help.',26124),
(46503,'enUS','You\'re doing well... you\'re going to be fine.','You\'re doing well... you\'re going to be fine.',26124),
(46504,'enUS','Freeing','Freeing',26124),
(46505,'enUS','The naga escaped out of the tunnel ahead. Show them no mercy, $c.','',26124),
(46506,'enUS','','I am eternally grateful to you, $n.',26124),
(46507,'enUS','',' I\'ll take care of the drakes. You worry about the rest of the Twilight rubbish.',26124),
(46508,'enUS','Ramkahen will only wage war against Neferset if the High Council\'s vote is unanimous.$B$BThe odds are against us, but my brother needs to understand there is no reasoning with Deathwing\'s allies.','',26124),
(46509,'enUS','There\'s one - get it!','There\'s one - get it!',26124),
(46510,'enUS','Keep your eyes peeled for dwarven pigs.','Keep your eyes peeled for dwarven pigs.',26124),
(46511,'enUS','','$n, is that you? Please free me from these chains.',26124),
(46512,'enUS','They\'ve got one of ours! No mercy for the Dragonmaw!','',26124),
(46513,'enUS','Hand over the bird, yeh filthy beasts. WILDHAMMER!!','',26124),
(46514,'enUS','Are you with the Neferset scum?  Did they send you to do their dirty work?  Speak!','',26124),
(46515,'enUS','I\'m looking for Tahet.  Let\'s get you out of these chains.','I\'m looking for Tahet.  Let\'s get you out of these chains.',26124),
(46516,'enUS','It ain\'t all bad...$b$bI still got my breathin\' hat!\n','',26124),
(46517,'enUS','Rescue the Gryphon','',26124),
(46518,'enUS','Defend the captured prize','',26124),
(46519,'enUS','You! $C! Help us defend against a counterattack.','You! $C! Help us defend against a counterattack.',26124),
(46520,'enUS','Wait!  Here come the Neferset guards!  Fight near me so I can beat their skulls in!','',26124),
(46521,'enUS','Freedom at last.  I thank you, stranger.  Tahet is no longer here.  A cruel Neferset warlord called Caimas took him.','',26124),
(46522,'enUS','I must warn you.  Caimas does horrible things to prisoners... he forces them to fight his pet beasts.  Prepare for the worst, friend.','',26124),
(46523,'enUS','Look out - the Alliance is aiding the Wildhammer!','Look out - the Alliance is aiding the Wildhammer!',26124),
(46524,'enUS','%s picks up a key from Neferset Enforcer.','',26124),
(46525,'enUS','That\'s one more for the Wildhammer!','That\'s one more for the Wildhammer!',26124),
(46526,'enUS','Ahoy!\n','',26124),
(46527,'enUS','Ride into the Holding Pens and DEVOUR naga!','',26124),
(46528,'enUS','The Horde war machine needs you!','',26124),
(46529,'enUS','Are you here to help the cause? Mount Hyjal burns!','',26124),
(46530,'enUS','Could you please send me to Moonglade, Emissary?','Could you please send me to Moonglade, Emissary?',26124),
(46531,'enUS','','The admiral and his forces pushed forward to take one of the bases you scouted for him earlier. You should go and meet them.',26124),
(46532,'enUS','That giant squid didn\'t stand a chance. The Verne\'s already rearmed and ready for another go... now we just wait.$B$BIt\'ll be back.$B$BYou\'ll see.','',26124),
(46533,'enUS','Great work, everyone. Take a moment to grab your gear and let\'s move on.','',26124),
(46534,'enUS','This will keep you occupied!','',26124),
(46535,'enUS','DRAGONMAW!','DRAGONMAW!',26124),
(46536,'enUS','Jump to shake off the young crocolisks!','',26124),
(46537,'enUS','Come. There\'s more havoc elsewhere on the ridge.','Come. There\'s more havoc elsewhere on the ridge.',26124),
(46538,'enUS','','Ah... I do not have many visitors here.$B$BPlease, sit a while.',26124),
(46539,'enUS','The Alliance needs you. Answer the hero\'s call!','',26124),
(46540,'enUS','Now we finish the job.','Now we finish the job.',26124),
(46541,'enUS','Bah!  Mere luck!  My pets will make mincemeat out of you yet!','',26124),
(46542,'enUS','Enough!  I grow tired of you!','',26124),
(46543,'enUS','','Are you here to help the cause? Mount Hyjal burns!',26124),
(46544,'enUS','Search the town. Kill any survivors!','Search the town. Kill any survivors!',26124),
(46545,'enUS','Psst! $n! Over here...','',26124),
(46546,'enUS','Lure Caimas over the Croc Eggs without stepping on them yourself!','',26124),
(46547,'enUS','Over the wall, HUP!','',26124),
(46548,'enUS','For glory! For honor! FOR THUNDERMAR!','',26124),
(46549,'enUS','That heap o\' rubble yonder was me family\'s homestead fer five generations.$B$BWe\'re takin\' it back.$B$BWe\'re outnumbered... But we\'re Wildhammer! Are yeh with me?','',26124),
(46550,'enUS','Let\'s go!','Let\'s go!',26124),
(46551,'enUS','Short work, an\' none too pretty! ','Aye, that\'s how the hammer falls, gents!',26124),
(46552,'enUS','Right! Burn the bodies of this filth while I search the ol\' homestead.','',26124),
(46553,'enUS','Aw, hell\'s hangover. They trashed the place!','',26124),
(46554,'enUS','We\'ve got what we need. Clear out. We\'ll hit them again elsewhere.','',26124),
(46555,'enUS','Farewell, friend! Good treasure hunting!','',26124),
(46556,'enUS','I\'ll deliver the news to Thundermar.','I\'ll deliver the news to Thundermar.',26124),
(46557,'enUS','$C! Look sharp. I smell the stench of Wildhammer nearby...','$C! Look sharp. I smell the stench of Wildhammer nearby...',26124),
(46558,'enUS','Look out - more dwarves attacking from the rear!','Look out - more dwarves attacking from the rear!',26124),
(46559,'enUS','Egad! My sophisticated heart!','',26124),
(46560,'enUS','Hah! Another legendary Dragonmaw triumph.','Hah! Another legendary Dragonmaw triumph.',26124),
(46561,'enUS','Mortimer Moloch collapses from a heart attack!','',26124),
(46562,'enUS','Sweep the area for anything of use. Quickly now - they\'ll attack again soon.','Sweep the area for anything of use. Quickly now - they\'ll attack again soon.',26124),
(46563,'enUS','I remember it well.  It was a bright, shiny day...','',26124),
(46564,'enUS','I was just mindin\' my own business, when all of a sudden, Deathwing appeared!','',26124),
(46565,'enUS','I said to myself, \"I\'m gonna punch that dragon in the face!\"','',26124),
(46566,'enUS','I\'m gonna punch that dragon in the face!','',26124),
(46567,'enUS','Unfortunately, the cataclysm had knocked loose a bunch of angry elementals.','',26124),
(46568,'enUS','\"You dang-blasted rock elementals!\", I said.  \"I\'ll punch you too!\"','',26124),
(46569,'enUS','You dang-blasted rock elementals!','',26124),
(46570,'enUS','I\'ll punch you too!','',26124),
(46571,'enUS','This ends here, Hogger!','',26124),
(46572,'enUS','He\'s...he\'s dead? ','',26124),
(46573,'enUS','It\'s simply too good to be true. You couldn\'t have killed him so easily!','',26124),
(46574,'enUS','','',26124),
(46575,'enUS','Get punched!','',26124),
(46576,'enUS','Taste my fist!','',26124),
(46577,'enUS','P-p-punch!','',26124),
(46578,'enUS','I\'m coming for you, Deathwing!','',26124),
(46579,'enUS','Theldurin the Lost!','',26124),
(46580,'enUS','I\'m going to punch that dragon right in the face!','',26124),
(46581,'enUS','Face punch!','',26124),
(46582,'enUS','Take that, dangerous enemy!','',26124),
(46584,'enUS','You have no right to keep us out!','You have no right to keep us out!',26124),
(46585,'enUS','We\'ve committed no wrongs against the city or its king...','We\'ve committed no wrongs against the city or its king...',26124),
(46586,'enUS','You have to let me in, my customers are waiting.','You have to let me in, my customers are waiting.',26124),
(46587,'enUS','As a tax-paying subject, I have a right to visit the city!','As a tax-paying subject, I have a right to visit the city!',26124),
(46588,'enUS','What does King Wrynn fear from his own people?','What does King Wrynn fear from his own people?',26124),
(46589,'enUS','You can\'t treat us this way!','You can\'t treat us this way!',26124),
(46590,'enUS','I want to speak to Marshal McBride! This is an outrage!','I want to speak to Marshal McBride! This is an outrage!',26124),
(46591,'enUS','I have powerful friends, and they will not be happy to hear I was treated this way!','I have powerful friends, and they will not be happy to hear I was treated this way!',26124),
(46592,'enUS','You lookin\' for me?','',26124),
(46593,'enUS','Tell me that story again, Theldurin.','Tell me that story again, Theldurin.',26124),
(46594,'enUS','No, no, no, Theldurin.  You\'re telling the story wrong!','',26124),
(46595,'enUS','Hmm... I didn\'t go this direction.  I think I\'m telling the story wrong.','',26124),
(46596,'enUS','More bones to gnaw on...','',26124),
(46597,'enUS','What?! What was that?! Impossible! His body is right here! Unless...','',26124),
(46598,'enUS','%s\'s eyes begin to glow. Take cover quickly!','',26124),
(46599,'enUS','Secure the main road. We can launch our main assault from here.','',26124),
(46600,'enUS','Heroes, I know this is the real Hogger. I see my eye hanging from his belt. The implications of what has taken place down here are very dark indeed. His power is...beyond our understanding...','',26124),
(46601,'enUS','','Dad lets me shoot things!',26124),
(46602,'enUS','Calm down! We\'ll get to everybody in time...','Calm down! We\'ll get to everybody in time...',26124),
(46603,'enUS','The more you shout, the longer it will take to resolve this.','The more you shout, the longer it will take to resolve this.',26124),
(46604,'enUS','What? MORE Wildhammer? These fools have a death wish!','',26124),
(46605,'enUS','Let me see what you have for sale, Fiona.','Let me see what you have for sale, Fiona.',26124),
(46606,'enUS','This way. Stay together now!','This way. Stay together now!',26124),
(46607,'enUS','Keep it down! We\'ll get this sorted out as soon as we can.','Keep it down! We\'ll get this sorted out as soon as we can.',26124),
(46608,'enUS','If you don\'t settle down, you\'ll be spending the night inside the Stockade!','If you don\'t settle down, you\'ll be spending the night inside the Stockade!',26124),
(46609,'enUS','Be patient, citizens. Yelling at us won\'t change anything.','Be patient, citizens. Yelling at us won\'t change anything.',26124),
(46610,'enUS','The king is only doing what\'s necessary to keep the city safe.','The king is only doing what\'s necessary to keep the city safe.',26124),
(46611,'enUS','I could just close the gates, and then nobody would get in...','I could just close the gates, and then nobody would get in...',26124),
(46612,'enUS','What a mess! We come back from saving Deepholm and what do we find?$B$BThe Twilight\'s Stinkin\' Hammer!$B$BGood thing you\'re here to straighten this all out!','',26124),
(46613,'enUS','Mr. Goldmine, I\'m ready for that wild ride.','Mr. Goldmine, I\'m ready for that wild ride.',26124),
(46614,'enUS','You have no right to keep us out!','You have no right to keep us out!',26124),
(46615,'enUS','We\'ve committed no wrongs against the city or the Horde...','We\'ve committed no wrongs against the city or the Horde...',26124),
(46616,'enUS','You have to let me in, my customers are waiting.','You have to let me in, my customers are waiting.',26124),
(46617,'enUS','I have honored the Horde with years of service, and this is how I am treated?','I have honored the Horde with years of service, and this is how I am treated?',26124),
(46618,'enUS','Why do our leaders keep us out?','Why do our leaders keep us out?',26124),
(46619,'enUS','You can\'t treat us this way!','You can\'t treat us this way!',26124),
(46620,'enUS','This is an outrage!','This is an outrage!',26124),
(46621,'enUS','I have powerful friends, and they will not be happy to hear I was treated this way!','I have powerful friends, and they will not be happy to hear I was treated this way!',26124),
(46622,'enUS','Calm down! We\'ll get to everybody in time...','Calm down! We\'ll get to everybody in time...',26124),
(46623,'enUS','The more you shout, the longer it will take to resolve this.','The more you shout, the longer it will take to resolve this.',26124),
(46624,'enUS','Keep it down! We\'ll get this sorted out as soon as we can.','Keep it down! We\'ll get this sorted out as soon as we can.',26124),
(46625,'enUS','If you don\'t settle down, you\'ll find yourself tossed in with the rest of the arrested cultists.','If you don\'t settle down, you\'ll find yourself tossed in with the rest of the arrested cultists.',26124),
(46626,'enUS','Be patient, citizens. Yelling at us won\'t change anything.','Be patient, citizens. Yelling at us won\'t change anything.',26124),
(46627,'enUS','We are only doing what\'s necessary to keep the city safe.','We are only doing what\'s necessary to keep the city safe.',26124),
(46628,'enUS','If you want to speed this process up then make sure you have your papers in order!','If you want to speed this process up then make sure you have your papers in order!',26124),
(46629,'enUS','You\'re gonna have to protect me, $n. Without my weapons and totems, I\'m defenseless!','',26124),
(46630,'enUS','Randolph Moloch vanishes!','',26124),
(46631,'enUS','Hogger enrages!','',26124),
(46632,'enUS','Halthar is dead! Sound the trumpets, and spread the news from Highbank to Thundermar!','Halthar is dead! Sound the trumpets, and spread the news from Highbank to Thundermar!',26124),
(46633,'enUS','If this is the best these dwarves can muster, the Highlands will soon be ours.','',26124),
(46634,'enUS','Watch the roads. They may be foolish enough to try another assault.','',26124),
(46635,'enUS','Wildhammer assaults on this square have been relentless, $n. But they will never take me down. Watch and learn.','',26124),
(46636,'enUS','I... *cough* I owe you my life, stranger.  Thank you.','',26124),
(46637,'enUS','I\'m afraid your friend won\'t be waking up any time soon.  I always sedate my croc\'s food.  I hate to see them struggle with their meal.','',26124),
(46638,'enUS','But perhaps I will make an exception for you.  Let the crocs out!  IT\'S FEEDING TIME!','',26124),
(46639,'enUS','That\'s it? Ya gotta have more than that!','',26124),
(46640,'enUS','Ain\'t no messin\' with Cayden Dunwald!','',26124),
(46641,'enUS','Bah! Dere\'s got to be some here somewhere...','',26124),
(46642,'enUS','Of all the buildings in all of Dunwald, why this one?!','',26124),
(46643,'enUS','They\'ve gone too far! Some Twilight are goin\' to be dyin\' this day!','',26124),
(46644,'enUS','The ale?! Why would they destroy the ale?! Monsters!','',26124),
(46645,'enUS','Soul-less, ale-hatin\', uncultured vagabonds! Ya better hide!','',26124),
(46646,'enUS','All my sweet delicious ale... gone... the horror...','',26124),
(46647,'enUS','So... thirsty...','',26124),
(46648,'enUS','Eoin, there\'s a full well right there.','Eoin, there\'s a full well right there.',26124),
(46649,'enUS','Water?! Are you daft?! I need some ALE!','',26124),
(46650,'enUS','I shouldn\'t have to submit to this.','I shouldn\'t have to submit to this.',26124),
(46651,'enUS','I can explain why I\'m here.','I can explain why I\'m here.',26124),
(46652,'enUS','I have nothing to hide.','I have nothing to hide.',26124),
(46653,'enUS','Can you hurry? I have to be somewhere.','Can you hurry? I have to be somewhere.',26124),
(46654,'enUS','Thank you. I\'ll be on my way.','Thank you. I\'ll be on my way.',26124),
(46655,'enUS','What is this? I have done nothing!','What is this? I have done nothing!',26124),
(46656,'enUS','Citizens of Stormwind, as you know, a dangerous cult threatens to tear our city apart. Until this cult has been destroyed, King Wrynn decrees that all who wish to enter Stormwind must submit to searches and questioning.','Citizens of Stormwind, as you know, a dangerous cult threatens to tear our city apart. Until this cult has been destroyed, King Wrynn decrees that all who wish to enter Stormwind must submit to searches and questioning.',26124),
(46658,'enUS','Keep your hands off me ale, ya unclean pint-hatin\' mongels!','',26124),
(46659,'enUS','Everything is ok, you can go.','Everything is ok, you can go.',26124),
(46660,'enUS','You can enter the city.','You can enter the city.',26124),
(46661,'enUS','You\'re free to enter Stormwind.','You\'re free to enter Stormwind.',26124),
(46662,'enUS','Everything\'s in order. You\'re free to go.','Everything\'s in order. You\'re free to go.',26124),
(46663,'enUS','All clear, you can go.','All clear, you can go.',26124),
(46664,'enUS','That\'s a cultist robe. Guard!','That\'s a cultist robe. Guard!',26124),
(46665,'enUS','This looks suspicious. I can\'t let you in.','This looks suspicious. I can\'t let you in.',26124),
(46666,'enUS','This is cultist literature. The only way you\'re entering Stormwind is in chains.','This is cultist literature. The only way you\'re entering Stormwind is in chains.',26124),
(46667,'enUS','A Twilight\'s Hammer medallion? Guard!','A Twilight\'s Hammer medallion? Guard!',26124),
(46668,'enUS','This is cultist propaganda. You\'re under arrest.','This is cultist propaganda. You\'re under arrest.',26124),
(46669,'enUS','I can\'t let you into the city with these cultist articles.','I can\'t let you into the city with these cultist articles.',26124),
(46670,'enUS','What are these suspicious papers? Guard, take this citizen into custody.','What are these suspicious papers? Guard, take this citizen into custody.',26124),
(46671,'enUS','Follow me, citizen.','Follow me, citizen.',26124),
(46672,'enUS','Ooh, this is gonna be good!','',26124),
(46673,'enUS','Hang on!','',26124),
(46674,'enUS','OH NO!','',26124),
(46675,'enUS','My totems!!!','',26124),
(46676,'enUS','JUMP!!!','',26124),
(46677,'enUS','Your life is forfeit.','',26124),
(46678,'enUS','I\'m going to search you, citizen.','I\'m going to search you, citizen.',26124),
(46679,'enUS','Not the ale!','Save the ale!',26124),
(46680,'enUS','%s begins to transform into a Force of Earth!','',26124),
(46681,'enUS','You\'re ours now, $r.','You\'re ours now, $r.',26124),
(46682,'enUS','You can trust a goblin to COUNT your coins, but not to GUARD them.','You can trust a goblin to COUNT your coins, but not to GUARD them.',26124),
(46683,'enUS','You won\'t find all of us!','',26124),
(46684,'enUS','We will win in the end.','',26124),
(46685,'enUS','Don\'t think you\'ve won.','',26124),
(46686,'enUS','This city will fall!','',26124),
(46687,'enUS','Unhand me, loyalist scum.','',26124),
(46688,'enUS','','No, no, silly $r...',26124),
(46689,'enUS','','No one rides the Lady!',26124),
(46690,'enUS','Someone took refuge here after the attack, but no sign of Beak.','',26124),
(46691,'enUS','This room reeks of a massacre. No sign of Beak.','',26124),
(46692,'enUS','These buildings lie entirely in ruin. Nowhere for Beak to hide here.','',26124),
(46693,'enUS','Beak! Where are ya Beak?','',26124),
(46694,'enUS','Beak! Come back to Donnelly. Donnelly keep you safe!','',26124),
(46695,'enUS','Come back, Beak! Don\'t get hurt!','',26124),
(46696,'enUS','Beak! No more hiding. Come out right now!','',26124),
(46697,'enUS','You seem to have gained a companion. You should bring him back to Donnelly.','',26124),
(46698,'enUS','This dwarf\'s body is severely battered. The Twilight\'s Hammer must take pleasure in their killing.','This dwarf\'s body is severely battered. The Twilight\'s Hammer must take pleasure in their killing.',26124),
(46699,'enUS','Kill the Alliance $c!','Over here - an Alliance $c!',26124),
(46700,'enUS','I have to give these Twilight a wee bit of credit... what they lack in skill, they make up for in numbers and tenacity. They got a few good licks in during our last bout.','',26124),
(46701,'enUS','','The Dunwald family is built tough, but they let it go to their heads. I worry that me brothers put their repuation to the test a wee bit too often.',26124),
(46702,'enUS','Work harder, dark iron dogs!','',26124),
(46703,'enUS','More Elementium! Now!','',26124),
(46704,'enUS','Cho\'gall will rip your heart out of your puny, little body and laugh while he eats it!','',26124),
(46705,'enUS','I\'m going to turn you to ash if you don\'t work faster!','',26124),
(46706,'enUS','Don\'t let those spiders eat the Elementium!','',26124),
(46707,'enUS','I see you there! Yes, you! Come here. I\'m going to bury you!','',26124),
(46708,'enUS','More Elementium for the Bastion of Twilight!','',26124),
(46709,'enUS','Mining\'s all you dwarves are good for!','',26124),
(46710,'enUS','A Son of Kor has arrived to assist you, but watch out for his boulders!','',26124),
(46711,'enUS','|TInterface\\Icons\\spell_fire_twilightflamebreath.blp:20|t%s begins to cast |cFFFF0000|Hspell:86840|h[Devouring Flames]|h|r!','',26124),
(46712,'enUS','|TInterface\\Icons\\spell_fire_twilightfire.blp:20|t%s takes a |cFFFF0000|Hspell:86059|h[Deep Breath]|h|r!','',26124),
(46713,'enUS','|TInterface\\Icons\\spell_holy_consumemagic.blp:20|t%s begins to cast |cFF00EEFF|Hspell:86622|h[Engulfing Magic]|h|r!','',26124),
(46714,'enUS','|TInterface\\Icons\\spell_fire_twilightpyroblast.blp:20|t%s begins to cast |cFF00EEFF|Hspell:86408|h[Dazzling Destruction]|h|r!','',26124),
(46715,'enUS','Ahoy!','',26124),
(46716,'enUS','Hah! My brothers be itchin\' for a fight. It was all I could do ta hold them back this long.$B$BYou in?','',26124),
(46717,'enUS','Let\'s give\'m a proper Dunwald welcome, brothers!','',26124),
(46718,'enUS','I\'m in.','I\'m in.',26124),
(46719,'enUS','Let me know when you\'re ready. Sooner is better - Cayden\'s lookin a mite vicious.','',26124),
(46720,'enUS','Ya not be gettin\' me dat easy! Atal\'ai gonna rise up...','',26124),
(46721,'enUS','You are truly great heroes for vanquishing the Gnoll King. People all throughout Elwynn Forest and Westfall will speak highly of your triumph for years to come. Thank you.','',26124),
(46722,'enUS','Let\'s get back to work, people!','Let\'s get back to work, people!',26124),
(46723,'enUS','These ships are not going to build themselves!','These ships are not going to build themselves!',26124),
(46724,'enUS','I expect the highest quality craftmanship from my workforce.  Double your efforts!','I expect the highest quality craftmanship from my workforce.  Double your efforts!',26124),
(46725,'enUS','Your time is coming to an end.','Your time is coming to an end.',26124),
(46726,'enUS','Gloat all you want, but you\'ll see we were right.','Gloat all you want, but you\'ll see we were right.',26124),
(46727,'enUS','I may be restrained now, but my master will set me free when his vengeance rains down upon this city.','I may be restrained now, but my master will set me free when his vengeance rains down upon this city.',26124),
(46728,'enUS','I am on the path to ascension and no petty, aspiring hero is going to stop me.','I am on the path to ascension and no petty, aspiring hero is going to stop me.',26124),
(46729,'enUS','It is your life that will end soon; mine is just beginning.','It is your life that will end soon; mine is just beginning.',26124),
(46730,'enUS','We must contain the arcane power we have unleashed!','We must contain the arcane power we have unleashed!',26124),
(46731,'enUS','We cannot allow the arcane power to build up further!','We cannot allow the arcane power to build up further!',26124),
(46732,'enUS','We must dissipate this power before it is noticed by elf or demon.','We must dissipate this power before it is noticed by elf or demon.',26124),
(46733,'enUS','By the time you realize the truth, it will be too late.','By the time you realize the truth, it will be too late.',26124),
(46734,'enUS','My power is waning - support me, brothers!','My power is waning - support me, brothers!',26124),
(46735,'enUS','What were you and the others doing inside the city?','What were you and the others doing inside the city?',26124),
(46736,'enUS','The magic required to move Dalaran was too great!  We cannot hold it back forever!','The magic required to move Dalaran was too great!  We cannot hold it back forever!',26124),
(46737,'enUS','The mages of Dalaran are the most powerful in Azeroth!  We will not fail!','The mages of Dalaran are the most powerful in Azeroth!  We will not fail!',26124),
(46738,'enUS','I can feel the arcane energies building up yet again!  The archmage must be warned!','I can feel the arcane energies building up yet again!  The archmage must be warned!',26124),
(46739,'enUS','My arm is tired...','My arm is tired...',26124),
(46740,'enUS','We came to bring the master\'s prophecy into being. The rituals have already begun and we are too numerous for you to stop us all.','We came to bring the master\'s prophecy into being. The rituals have already begun and we are too numerous for you to stop us all.',26124),
(46741,'enUS','It\'s good to be back, overseer. I want to help carry out the ritual.','It\'s good to be back, overseer. I want to help carry out the ritual.',26124),
(46742,'enUS','','We were afraid you\'d been caught, but I wouldn\'t think of leaving you out of the portal ritual.',26124),
(46743,'enUS','','Take this book and practice the ritual. It must be performed perfectly, or else the elementals will not leave the portals at the proper time.',26124),
(46744,'enUS','You destroyed their Earth rune! I bet there are three others. And, I bet they\'re all linked to the fire portal in the back.','',26124),
(46745,'enUS','Ancients of wind and water, I have prepared the way for you. Come forth and raze Stormwind.','Ancients of wind and water, I have prepared the way for you. Come forth and raze Stormwind.',26124),
(46746,'enUS','We better destroy them all. But first, I need to get the shrapnel out of my backside.','',26124),
(46747,'enUS','Did you get wet? I\'m soaked! Okay, what do you want to bet the next rune is attuned to air?','',26124),
(46748,'enUS','The blast of air totally dried my hair. That gives me a great idea for a spare flying machine engine!','',26124),
(46749,'enUS','Beak squeaks in joy at the sight of Donnelly!','',26124),
(46750,'enUS','Ahahahaha, that\'s the last of their runes! Twilight Suckers, no more elemental power for you!','',26124),
(46751,'enUS','Go home to Keely, Beak. She keep you safe til Donnelly come back.','',26124),
(46752,'enUS','Wait! What\'s that over there?','',26124),
(46753,'enUS','Magmatooth?! NOOOOOOOO!','',26124),
(46754,'enUS','An\' where you think you\'re goin\', sonny?!','',26124),
(46755,'enUS','GOLDMINE! YOU THINK I\'VE FORGOTTEN?! I TOLD YOU THAT I\'D GET MY REVENGE!!!','',26124),
(46756,'enUS','Help!  Up here!','',26124),
(46757,'enUS','','I will now remove the fog from your eyes.  Behold, our captive.',26124),
(46758,'enUS','','Deathwing\'s madness overcomes him, and we, the red dragons, must take this opportunity to steal his black dragons from beneath him.  We will remake the black dragons as they were intended to be: the warders of the earth.',26124),
(46759,'enUS','%s slumps down in exhaustion.','',26124),
(46760,'enUS','%s appears to be waking up!','',26124),
(46761,'enUS','Attack!','',26124),
(46762,'enUS','Like a Dunwald. I like you.','',26124),
(46763,'enUS','You fool! This is a ritual, not a recipe!','',26124),
(46764,'enUS','We are betrayed! You may have won here, but the ritual will succeed!','',26124),
(46765,'enUS','There\'s a lot of gear here we can still use. Fan out. And step lively! The Dragonmaw are near.','Grab what supplies you can and move quick. Expect the Dargonmaw any minute!',26124),
(46766,'enUS','Keep yer eyes open fer Dragonmaw.','Keep yer eyes open fer Dragonmaw.',26124),
(46767,'enUS','Ancients of wheat and water, I have peppered the way for you. Come forth and glaze Stormwind!','Ancients of wheat and water, I have peppered the way for you. Come forth and glaze Stormwind!',26124),
(46768,'enUS','','Guards, let $n serve as an example to you in defending Stormwind from its enemies.',26124),
(46769,'enUS','','But these cultists are determined to bring Stormwind to ruin. Men, we must remain vigilant for our city and our king, as $n as done!',26124),
(46770,'enUS','YOU\'RE BOTH GOING TO BURN!','',26124),
(46771,'enUS','We serve Stormwind faithfully, my lady!','We serve Stormwind faithfully, my lady!',26124),
(46772,'enUS','More cultist traitors? Good job gettin\' \'em off the streets.','',26124),
(46773,'enUS','','At last, you\'re back! We were beginning to worry that you\'d been arrested.',26124),
(46774,'enUS','How many coconuts can we get for the ugly one?','',26124),
(46775,'enUS','Eat dirt, stumpy!','',26124),
(46776,'enUS','Now stay dead.','',26124),
(46777,'enUS','Weakness. These dwarves are nothing!','',26124),
(46778,'enUS','Another one dead.','',26124),
(46779,'enUS','Pathetic, bearded little rodents!','',26124),
(46780,'enUS','That was close!','',26124),
(46781,'enUS','More Wildhammer scum. Assault the ridge!','',26124),
(46782,'enUS','Heads up, $n. The Dragonmaw are about to attack!','Heads up, $n. The Dragonmaw are about to attack!',26124),
(46783,'enUS','Sweep the ridge! Kill the Wildhammer!','Sweep the ridge! Kill the Wildhammer!',26124),
(46784,'enUS','I\'LL GET YOU, GOLDMINE!','',26124),
(46785,'enUS','What in Cho\'Gall\'s name are you doing?!','',26124),
(46786,'enUS','The portals will open and your precious city will be swept away!','',26124),
(46787,'enUS','Nothing warms my bones like this trusty southsea rum!','Nothing warms my bones like this trusty southsea rum!',26124),
(46788,'enUS','Yarg!','Yarg!',26124),
(46789,'enUS','Yo ho, Yo ho, a pirates life for me!','Yo ho, Yo ho, a pirates life for me!',26124),
(46790,'enUS','You\'ll pay for this, traitor!','',26124),
(46791,'enUS','You think you\'ve won, but the forces of Twilight will triumph in the end!','',26124),
(46792,'enUS','That\'s right! They can keep on comin\', we\'ll keep knockin\' \'em down!','THAT\'s how you handle an orc, boys.',26124),
(46793,'enUS','Okay, back to work. If we\'re fast we can finish up here before another attack.','Okay, back to work. If we\'re fast we can finish up here before another attack.',26124),
(46794,'enUS','Let\'s hurry, Thundermar needs these supplies.','Let\'s hurry, Thundermar needs these supplies.',26124),
(46795,'enUS','We did it! That\'ll learn those Dragonmaw to try an\' ambush a Wildhammer.','We did it! That\'ll learn those Dragonmaw to try an\' ambush a Wildhammer.',26124),
(46796,'enUS','This world is imperfect!  We must begin anew!','',26124),
(46797,'enUS','The secrets of Uldum will be ours only!','',26124),
(46798,'enUS','You cannot stop us!  We will wield the power beneath the tombs!','',26124),
(46799,'enUS','We will destroy all who oppose us!','',26124),
(46800,'enUS','Another notch in my sword.','Another triumph! Another set of beards to hang from my belt.',26124),
(46801,'enUS','Hah! Get these Wildhammer off their gryphons and look what kind of a fight they put up. Nothing! ','',26124),
(46802,'enUS','Let\'s go. My blade grows hungry.','',26124),
(46803,'enUS','It is done. Scour the place clean. Leave them nothing to return to!','It is done. Scour the place clean. Leave them nothing to return to!',26124),
(46804,'enUS','','<The console whirrs and buzzes as you approach it.>',26124),
(46805,'enUS','I suppose we\'ll just have to throw these away... WAIT!  I think I\'m having an idea.','',26124),
(46806,'enUS','Yes, definitely an idea.','',26124),
(46807,'enUS','Hubba-hubba!','',26124),
(46809,'enUS','You could bounce a washer off those legs!','',26124),
(46810,'enUS','Shake it like a sine wave, baby!','',26124),
(46811,'enUS','It\'s the TXR-5000!','',26124),
(46812,'enUS','200 horsepower, dual combustion engine with modified flux capacitors!  ZOING!','',26124),
(46813,'enUS','I didn\'t know it came in lightning-blue!  AWESOME!!','',26124),
(46814,'enUS','Check out the modified leg articulation!  Perfect for off-roading!','',26124),
(46815,'enUS','I\'d like to survey those curves!','',26124),
(46816,'enUS','So... EPIC!!!','',26124),
(46817,'enUS','Weaponized sharks?  Why didn\'t I think of that!?','',26124),
(46818,'enUS','ROCK ON!!!','',26124),
(46819,'enUS','Brilliant!','',26124),
(46820,'enUS','Our captors have allied with Deathwing, $r.','',26124),
(46821,'enUS','No mercy remains in them. Make your peace.','',26124),
(46822,'enUS','The hulking statue stands inert, untouched for centuries.','',26124),
(46823,'enUS','While it is clearly quite old, this statue does not appear to have crumbled at all over the centuries.','',26124),
(46824,'enUS','<Place the pawn in the indentation.>','<Place the pawn in the indentation.>',26124),
(46825,'enUS','Citizens of Orgrimmar, as you know, a dangerous cult threatens to tear our city apart. Until this cult has been destroyed, Warchief Garrosh Hellscream, hero of Northrend, champion of the people, decrees that all who wish to enter Orgrimmar must submit to searches and questioning.','Citizens of Orgrimmar, as you know, a dangerous cult threatens to tear our city apart. Until this cult has been destroyed, Warchief Garrosh Hellscream, hero of Northrend, champion of the people, decrees that all who wish to enter Orgrimmar must submit to searches and questioning.',26124),
(46826,'enUS','Judging by its color, this must be The Warden.$b$bYou see a small indentation where your pawn might fit.','',26124),
(46827,'enUS','This red statue looks a lot like the Sentinel\'s pawn that you hold.$b$bThe statue has a small indentation that matches the size of your pawn.','',26124),
(46828,'enUS','Ancients of fire and earth, I have prepared the way for you. Come forth and raze Orgrimmar.','Ancients of fire and earth, I have prepared the way for you. Come forth and raze Orgrimmar.',26124),
(46829,'enUS','Ancients of flour and earth, I have peppered the way for you. Come forth and glaze Orgrimmar!','Ancients of flour and earth, I have peppered the way for you. Come forth and glaze Orgrimmar!',26124),
(46830,'enUS','$n, over here. What do you have to report? Were you followed?','',26124),
(46831,'enUS','We need to figure out everything there is to know about Cho\'gall\'s mystery weapon before it\'s too late.','',26124),
(46832,'enUS','Looks like it\'s just you, me, and those two Earthen Ringers over at the mine. Let\'s work fast, $n, before we\'re discovered.','',26124),
(46833,'enUS','It\'s good to be back out in the field. Nice change of pace from being cooped up in Stormwind all of the time.','',26124),
(46834,'enUS','We\'re going to have to deal with Cho\'gall and Skullcrusher sooner rather than later. Are you up to it, $n?','',26124),
(46835,'enUS','This might be a one-way mission, $n. If you\'re not comfortable with that, you can walk away at any time, though I\'d rather that you didn\'t.','',26124),
(46836,'enUS','We need to take care of everything out here before we can launch the final assault on the Bastion of Twilight.','',26124),
(46837,'enUS','Did I tell you about the time when the Twilight\'s Hammer actually tried to recruit me? True story.','',26124),
(46838,'enUS','','It\'s just you and me, $r. Let\'s get this wrapped up quickly so that I can go kill Cho\'gall.',26124),
(46839,'enUS','THREE? He woulda paid five, easy... Dummy!','',26124),
(46840,'enUS','','Greetings.',26124),
(46841,'enUS','','We\'re glad to see you here again, $n. With so many of our brethren seized by the Warchief\'s forces, we thought we\'d never see you again.',26124),
(46842,'enUS','','Over here. Find out anything? Were you tailed, $n?',26124),
(46843,'enUS','','We need to figure out everything there is to know about the weapon Cho\'gall\'s working on and we need to do it fast!',26124),
(46844,'enUS','','These Twilight idiots have no idea of the pain that\'s coming their way.',26124),
(46845,'enUS','','Cho\'gall\'s keeping himself hidden inside of the Bastion of Twilight. I hope he decides to come out and play.',26124),
(46846,'enUS','','I hope that you\'re ready for a one-way mission, $n.',26124),
(46847,'enUS','','We need to kill all of these cultists and their leaders out here before we can take out the Bastion of Twilight.',26124),
(46848,'enUS','','Cho\'gall once held sway over my mind with the simple utterance of a magic word. He made me do a lot of things that I\'m not proud of. I\'m going to repay him tenfold, and you\'re going to help me do it, $n!',26124),
(46849,'enUS','Let\'s move, cultist filth.','Let\'s move, cultist filth.',26124),
(46850,'enUS','Okay, I\'ll lead the caravan to our destination. You stay in the back and make sure our tail is clean. Let me know when you\'re ready. ','',26124),
(46851,'enUS','How dare you question me.','How dare you question me.',26124),
(46852,'enUS','You insult my honor with your inquiries.','You insult my honor with your inquiries.',26124),
(46853,'enUS','I have nothing to hide.','I have nothing to hide.',26124),
(46854,'enUS','Make your search fast, I have to be somewhere.','Make your search fast, I have to be somewhere.',26124),
(46855,'enUS','Hope you brought your mining pick, pilgrim.  No place better than here for digging up ancient treasure.','',26124),
(46856,'enUS','Everything seems ok, you may go now.','Everything seems ok, you may go now.',26124),
(46857,'enUS','You can enter the city.','You can enter the city.',26124),
(46858,'enUS','You\'re free to enter Orgrimmar.','You\'re free to enter Orgrimmar.',26124),
(46859,'enUS','Everything\'s in order. You\'re free to go.','Everything\'s in order. You\'re free to go.',26124),
(46860,'enUS','All clear, you can go.','All clear, you can go.',26124),
(46861,'enUS','Thank you. I\'ll be on my way.','Thank you. I\'ll be on my way.',26124),
(46862,'enUS','That\'s a cultist robe. Guard!','That\'s a cultist robe. Guard!',26124),
(46863,'enUS','This looks suspicious. I can\'t let you in.','This looks suspicious. I can\'t let you in.',26124),
(46864,'enUS','This is cultist literature. The only way you\'re entering Orgrimmar is in chains.','This is cultist literature. The only way you\'re entering Orgrimmar is in chains.',26124),
(46865,'enUS','A Twilight\'s Hammer medallion? Guard!','A Twilight\'s Hammer medallion? Guard!',26124),
(46866,'enUS','This is cultist propaganda. You\'re under arrest!','This is cultist propaganda. You\'re under arrest!',26124),
(46867,'enUS','I can\'t let you into Orgrimmar with these cultist articles.','I can\'t let you into Orgrimmar with these cultist articles.',26124),
(46868,'enUS','What are these suspicious papers? Guard, take this citizen into custody.','What are these suspicious papers? Guard, take this citizen into custody.',26124),
(46869,'enUS','What is this? I have done nothing!','What is this? I have done nothing!',26124),
(46870,'enUS','Let me know when you\'re loaded in and ready, $n.','',26124),
(46871,'enUS','Let\'s go!','Let\'s go!',26124),
(46872,'enUS','May the elements curse you!','',26124),
(46873,'enUS','You are nothing more than the warchief\'s dog!','',26124),
(46874,'enUS','After the fall of the Burning Blade Clan, we blademasters swore to free ourselves and our people from demonic control.$B$BThis may be done, but my honor remains unsatisfied.$B$BI shall fight for the Horde - and train other warriors to do so - until I die gloriously in battle. This is the only path I may tread.$B$BSo. Are you ready to train?','After the fall of the Burning Blade Clan, we blademasters swore to free ourselves and our people from demonic control.$B$BThis may be done, but my honor remains unsatisfied.$B$BI shall fight for the Horde - and train other warriors to do so - until I die gloriously in battle. This is the only path I may tread.$B$BSo. Are you ready to train?',26124),
(46875,'enUS','Another fly enters the spider\'s web...','Another fly enters the spider\'s web...',26124),
(46876,'enUS','The false Kingpin has fallen thanks to you adventurers.','',26124),
(46877,'enUS','After the fall of the Burning Blade Clan, we blademasters swore to free ourselves and our people from demonic control.$B$BThis may be done, but my honor remains unsatisfied.$B$BI shall fight for the Horde - and train other warriors to do so - until I die gloriously in battle. This is the only path I may tread.','After the fall of the Burning Blade Clan, we blademasters swore to free ourselves and our people from demonic control.$B$BThis may be done, but my honor remains unsatisfied.$B$BI shall fight for the Horde - and train other warriors to do so - until I die gloriously in battle. This is the only path I may tread.',26124),
(46878,'enUS','Vanessa VanCleef is still out there somewhere, plotting against us. Thankfully, without this base she is largely powerless against the might of the Alliance.','',26124),
(46879,'enUS','I\'ll be sure to keep an eye on things as we begin cleaning the Deadmines out. Hopefully we can use it again soon as the famous gold mine it once was. As for the kingpin\'s fate...','',26124),
(46880,'enUS','That\'s the way...','',26124),
(46881,'enUS','...the Cookie crumbles.','',26124),
(46882,'enUS','More traitors? Put \'em down in the pit, where they belong!','',26124),
(46883,'enUS','Guarding the bank and treasures of the Horde is far more satisfying than dispensing coins and trade goods from inside a cage of iron.$B$BI would not exchange places with one of those quill-pushing goblins for a moment.','Guarding the bank and treasures of the Horde is far more satisfying than dispensing coins and trade goods from inside a cage of iron.$B$BI would not exchange places with one of those quill-pushing goblins for a moment.',26124),
(46884,'enUS','Find the interlopers! I know that they have someone sneaking around to the north!','',26124),
(46885,'enUS','Keep your weak, fleshy eyes open! There are intruders amongst us.','',26124),
(46886,'enUS','Work harder for the glory of Cho\'gall!','',26124),
(46887,'enUS','I sense one amongst us that does not belong!','',26124),
(46888,'enUS','The weapon will soon be completed. The Wildhammer and the Dragonmaw are about to be no more.','',26124),
(46889,'enUS','Gather a force and go to the lake.  I want Countess Verrall destroyed by the end of the day!','',26124),
(46890,'enUS','Power to the Twilight\'s Hammer!','',26124),
(46891,'enUS','Prepare to attack Crushblow and Victor\'s Point!','',26124),
(46892,'enUS','Your dad says to fire me across the bay.','Your dad says to fire me across the bay.',26124),
(46893,'enUS','Keegan, sir. More elementals are breaking through on the west side of the rift.','Keegan, sir. More elementals are breaking through on the west side of the rift.',26124),
(46894,'enUS','Yes sir!','Yes sir!',26124),
(46895,'enUS','Find Iain. Secure whatever gryphon riders he\'s gathered to cut them off before they reach the town.','Find Iain. Secure whatever gryphon riders he\'s gathered to cut them off before they reach the town.',26124),
(46896,'enUS','Boot-up protocol completed.  Scanning for objective...','',26124),
(46897,'enUS','Objective identified.  Scanning...','',26124),
(46898,'enUS','Anomaly detected.  Probable source: Azerothian Old God.  Attempting to excise anomaly...','',26124),
(46899,'enUS','Anomaly excised.  Repeating sub-protocol...','',26124),
(46900,'enUS','Anomaly excised.  Re-assembling remaining material...','',26124),
(46901,'enUS','Viable subject compiled.  No anomalies detected.','',26124),
(46902,'enUS','User-objective protocol complete.  Stasis protocol re-enabled.','',26124),
(46903,'enUS','Tremble in fear as I call forth the mighty Doomskull!','Tremble in fear as I call forth the mighty Doomskull!',26124),
(46904,'enUS','Behold the sheer size of it!  Are you not afraid, mortal?  Have you ever witnessed doom of this magnitude?','Behold the sheer size of it!  Are you not afraid, mortal?  Have you ever witnessed doom of this magnitude?',26124),
(46905,'enUS','Cower, monster, as I summon a veritable army of Wolfoids!','Cower, monster, as I summon a veritable army of Wolfoids!',26124),
(46906,'enUS','Now you are surrounded by Wolfoids!  What will you do?  Where can you run?','Now you are surrounded by Wolfoids!  What will you do?  Where can you run?',26124),
(46907,'enUS','Take this, you ungrateful elemental. After all I\'ve done for you!','',26124),
(46908,'enUS','AHAHAHAHAHAHA, FIRE? REALLY?','',26124),
(46909,'enUS','YOU\'RE NEXT JUST AS SOON AS I FINISH OFF YOUR FRIEND HERE!','',26124),
(46910,'enUS','Oh yeah? Um... get him!!!','',26124),
(46911,'enUS','Good riddance, you overblown, halfbaked, bomb ignition wannabe! See if I ever summon YOU again!','',26124),
(46912,'enUS','Okay, let\'s get the controller off of him and use the portal to get out of here.','',26124),
(46913,'enUS','Wh... what is this?','',26124),
(46914,'enUS','I\'m dead! Murdered by the Twilight\'s Hammer.','',26124),
(46915,'enUS','The Spirit of the Loch sent you here. You seek information.','',26124),
(46916,'enUS','They captured and enslaved us. Put us to work on a weapon.','',26124),
(46917,'enUS','A special project... an artifact for Cho\'gall.','',26124),
(46918,'enUS','We were to be rewarded for the best work we\'d ever done, and we were... with this.','',26124),
(46919,'enUS','They imbued it with the power of an Old God.','',26124),
(46920,'enUS','The weapon which you seek is called the Hammer of Twilight.','',26124),
(46921,'enUS','Now leave me be. I see the Light....','',26124),
(46922,'enUS','The power...is too much...I cannot hold...any longer...','',26124),
(46923,'enUS','She\'s sent you to do her dirty work, has she? I\'ll deal with the countess after I\'ve killed you, fleshling!','',26124),
(46924,'enUS','','The Twilight\'s Hammer invaded these once-pristine waters, and the surrounding lands, a short time ago.$B$BThey have polluted my loch and I would have them gone so that I may purify it once more.',26124),
(46925,'enUS','Destroy Arcane Fiends near Archmage Ataeric to overload the shield!','',26124),
(46926,'enUS','Take this!','Take this!',26124),
(46927,'enUS','Aye aye, sir.','',26124),
(46928,'enUS','','This land is where orcs and humans first spilled each other\'s blood. Not a mile south lurks Stonard, where the orcs first grouped to invade our lands.$B$BIt was here they amassed their armies before we even knew they existed. It was here that they started the first of three wars with their attack on a small Alliance town to the west.$B$BMy town. The town where my parents died to save me.$B$BBut I\'m not here to settle a grudge... I\'m here to win a war.',26124),
(46929,'enUS','Whoa...','',26124),
(46930,'enUS','Gah!  Wrong again!','',26124),
(46931,'enUS','I must... concentrate!','',26124),
(46932,'enUS','So... difficult!','',26124),
(46933,'enUS','C\'mon then lads, set up a perimeter. We hold \'em here or Thundermar is next!','',26124),
(46934,'enUS','Take the weapons!','',26124),
(46935,'enUS','Disarming','Disarming',26124),
(46936,'enUS','Yipe!  Help Hogger!','',26124),
(46937,'enUS','Grrr...','',26124),
(46938,'enUS','Nooooo...','',26124),
(46939,'enUS','Hogger is eating!  Stop him!','',26124),
(46940,'enUS','Hogger is stunned!','',26124),
(46941,'enUS','Gah!!!  What... how did you..?','',26124),
(46942,'enUS','Twizzleflux!  What insanity are you up to?  We brought the additional crew you requested, but there is no... research going on here.  Only madness!','',26124),
(46943,'enUS','What the-????   AGGHGHhh...','',26124),
(46944,'enUS','Fools!  It is too late for them  And it is too late for all of you! You will join us and together we will unearth secrets that will unravel this world!','',26124),
(46945,'enUS','And you... are next!','',26124),
(46946,'enUS','','Hi! You\'re new. Did you lose your home too? You can sit with me if you want.',26124),
(46947,'enUS','','Oh my gosh! Thank you SO much! You have no idea how much this means to me. You\'re the sweetest thing!',26124),
(46948,'enUS','','You\'re definitely not Wildhammer. What brings you here? Your timing is pretty horrid, that\'s for sure.',26124),
(46949,'enUS','','Wha... my roses?! Did Cailin tell you?  I really can\'t thank you enough. I thought I\'d never smell home again...',26124),
(46950,'enUS','Pleasure to meet ya, young $gman:lady;.','',26124),
(46951,'enUS','What the-??','',26124),
(46952,'enUS','My family hammer?! What could have possibly possessed you... never mind, I don\'t care.  You\'ll always be welcome in our home - we\'ll save a place for you at the table.  Thank you.','',26124),
(46953,'enUS','No... nooooo!','',26124),
(46954,'enUS','','For the Bilgewater Cartel! For the Shattered Hand! FOR THE HORDE!',26124),
(46955,'enUS','What\'s happening to me?','',26124),
(46956,'enUS','I found this in the ruins. Cailin told me it was yours...','I found this in the ruins. Cailin told me it was yours...',26124),
(46957,'enUS','Hahahah!','',26124),
(46958,'enUS','I believe these are yours, Meara.','I believe these are yours, Meara.',26124),
(46959,'enUS','If I\'m not mistaken, this belongs to you.','If I\'m not mistaken, this belongs to you.',26124),
(46960,'enUS','They took us unaware... attacked all of the highlands all at once, burstin\' forth from the ground, swoopin\' from the air. Most of the gryphon wings were scattered, and far too many good dwarves lost their lives.$B$BThere\'d be little hope at all if Keegan hadn\'t rallied us together. I owe that man my life. At least now we have a chance.','',26124),
(46961,'enUS','You\'re certainly not local. Matters to me little though. I\'ll put my life on the line for anyone here as long as they pull their weight.','',26124),
(46962,'enUS','Use the Mech Control Scrambler to disable Twizzleflux\'s vehicle!','',26124),
(46963,'enUS','I came here long ago to study our cursed brothers, in search of a way to cure their affliction.$B$BMagtoor welcomed me with open arms. Living here, he became my closest friend.$B$BAnd now, before my eyes, he is dying...','',26124),
(46964,'enUS','I have failed you, my friend. I am so sorry.','',26124),
(46965,'enUS','It is my time, Avuun. Nobody is to blame...','',26124),
(46966,'enUS','','...',26124),
(46967,'enUS','You look like you could make us some money. How about a spin inside the Crucible of Carnage, pal?','',26124),
(46968,'enUS','Avoid the lava waves!','',26124),
(46969,'enUS','All of the highlands belong to the Dragonmaw, even this pit!','',26124),
(46970,'enUS','My little sister could best the lot of ya. This ain\'t no arena. This is a nursery!','',26124),
(46971,'enUS','Calder said that if I kill you, I get to have your parts!','',26124),
(46972,'enUS','Why hello chaps, I have a not so surprising surprise for you this eve.','',26124),
(46973,'enUS','This land shall be purged in the Twilight\'s Flame! ','',26124),
(46974,'enUS','','I\'ll just leave this right here.',26124),
(46975,'enUS','','Now to get the egg...',26124),
(46976,'enUS','','How\'s my little baby doing?',26124),
(46977,'enUS','','No... it\'s... it\'s you!  NO!',26124),
(46979,'enUS','You impetuous little whelp... I know exactly what you and the mortal are up to.','',26124),
(46980,'enUS','Are you ready to die, dragon?','',26124),
(46981,'enUS','','Yes.  Just... just show mercy to the egg.',26124),
(46982,'enUS','Mercy?!','',26124),
(46983,'enUS','THERE IS NO MERCY!  YOU WILL BURN FOR THIS, DRAGON!','',26124),
(46984,'enUS','Back, vermin! (Insects! Weak and small!)','',26124),
(46985,'enUS','Look, mortal, upon the instrument of your undoing. (The Hammer, hand of the Gods Below.) Forged of molten blood... (...gift of the master. His gift!) Shaped upon the Last Altar of Storm.','',26124),
(46986,'enUS','The Hammer of Twilight. (The Hammer of Twilight!) Commissioned by the Aspect of Death. It is the breaker of worlds. It is not yours to wield. (Kill the intruders!) Kill them all!','',26124),
(46987,'enUS','What Deathwing has set in motion... (...no man can stop.) No man! Least of all you wretches. (Show them. Show them their end!)','',26124),
(46988,'enUS','The grand Crucible of Carnage awaits, $n. Remember, once a battle starts you have to stay in the arena. WIN OR DIE!','',26124),
(46989,'enUS','Here we are once again, ladies and gentlemen. The epic struggle between life and death in the Crucible of Carnage! For this round we have $n versus... a really fat ogre? Wait, seriously?! That\'s all we could come up with on short notice? What am I paying you for? ','',26124),
(46990,'enUS','Whatever, let the fight begin!','',26124),
(46991,'enUS','The battle is about to begin! $n vs. the vicious Dragonmaw, Torg Drakeflayer! I THINK he\'s vicious anyway - hard to tell. I just let him because they let us take over their old arena here. Here\'s hoping for some blood!','',26124),
(46992,'enUS','I\'ve got a LITTLE somethin\' special for ya this time, folks! You aren\'t half the man of this half-man! $n vs. the vicious Wildhammer... SULLY KNEECAPPER!!!','',26124),
(46993,'enUS','This match is sure to be SHORT! Okay, okay, I\'m done. Let the bloodbath begin!','',26124),
(46994,'enUS','Imagine my surprise when I was approached by the genius forsaken, Calder Gray, and propsitioned with a combatant made of all the best features of our previous champions... LITERALLY! Who could refuse a chance to challenge CALDER\'S CREATION?!','',26124),
(46995,'enUS','You know what they say... if you can\'t beat \'em, join \'em! And in this case, you won\'t have the choice! Cruicible of Carnage, I adore you so.','',26124),
(46996,'enUS','Hailing from the semi-distant wreck of a landscape that was once Gilneas, our champion arises! Keep your pants up $n, you don\'t want to show this guy a full moon!','',26124),
(46997,'enUS','The Twilight\'s Hammer: happy to serve local nefarious schemes anytime, anywhere. And today is no exception! Our final combatant hails from the not so distant Bastion of Twilight! Or is it the Twilight Bastion... bah, who cares!','',26124),
(46998,'enUS','W-W-W-WINNER! We have a winner! Good job and stuff!','',26124),
(46999,'enUS','I DON\'T BELIEVE IT! WE HAVE A NEW CHAMPION OF CARNAGE!!! Our big, bad beefy challenger has been defeated by a ragtag crew of nobodies! Incredible finish!','',26124),
(47000,'enUS','No hurt Hogger!','',26124),
(47001,'enUS','We obey, blood guard. For the Horde!','We obey, blood guard. For the Horde!',26124),
(47002,'enUS','Grunts, $n has lead Orgrimmar\'s fight against the doomsday cultists.','',26124),
(47003,'enUS','The cultists have not stopped their attacks. Spread the word: double the guard and arrest anyone suspicious. These orders come from the warchief himself!','',26124),
(47004,'enUS','Hold your blade, adventurer!','',26124),
(47005,'enUS','General Hammond Clay!','General Hammond Clay!',26124),
(47006,'enUS','Wow!','Wow!',26124),
(47007,'enUS','This beast leads the Riverpaw gnoll gang and may be the key to ending gnoll aggression in Elwynn.','',26124),
(47008,'enUS','We\'re taking him into custody in the name of King Varian Wrynn.','',26124),
(47009,'enUS','Take us to the Stockades, Andromath.','',26124),
(47010,'enUS','The gryphon appears to be injured. Perhaps healing or first aid could get it back on its feet.','',26124),
(47011,'enUS','The gryphon looks at you intently, clearly smelling a familiar scent on your clothing.','',26124),
(47012,'enUS','The gryphon appears to be trapped. It looks like it would be easily possible to break its bonds though.','',26124),
(47013,'enUS','You have 1 Holy Power!','',26124),
(47014,'enUS','You have 2 Holy Power!','',26124),
(47015,'enUS','You have 3 Holy Power!','',26124),
(47016,'enUS','Let the gryphon smell the piece of charred highland birch.','Let the gryphon smell the piece of charred highland birch.',26124),
(47017,'enUS','The gryphon muscles tense and eyes tighten as soon as the bark is extended towards it.','',26124),
(47018,'enUS','Yo you got through the gauntlet! I\'m out!\n','',26124),
(47019,'enUS','','My suffering is eternal!',26124),
(47020,'enUS','The gryphon looks at you with genuine appreciation.','',26124),
(47021,'enUS','','A vision of Ysera materializes before you.',26124),
(47022,'enUS','','$n, you have unleashed the wolf ancient and defeated his shadow. Your actions already reverberate across the dream - thank you. But more remains to be done...',26124),
(47023,'enUS','','<Ysera\'s image flutters before your eyes, as if in a dream. Nobody else sees her here, yet the vision senses your presence.>',26124),
(47024,'enUS','The gryphon screams with glee as you break it free.','',26124),
(47025,'enUS','','So Tortolla has risen to fight at our side. You are wise, $n; it is difficult to earn that ancient\'s trust. He will be a stalwart companion.',26124),
(47026,'enUS','','The guardian of the skies has taken flight again! This is encouraging news, $n. But much remains undone, and we must turn our attention elsewhere...',26124),
(47027,'enUS','','<A dream-like vision of Ysera floats before you, her attention divided. After a moment, she addresses you.>$B$BFor many years, Aviana fluttered at the periphery of my dreams. I wondered if she should ever return to us. I fear her spirit has darkened with the passage of time...$B$BBut we have more immediate concerns if we hope to save this mountain.',26124),
(47028,'enUS','There can be no disruptions! Mustn\'t keep the master waiting! Mustn\'t fail again!','',26124),
(47029,'enUS','Nothing goes to waste... ','',26124),
(47030,'enUS','Strip the flesh, harvest the organs!','',26124),
(47031,'enUS','There will never be another like me...','',26124),
(47032,'enUS','What they lack in intelligence they make up for in ferocity!','',26124),
(47033,'enUS','My failings will be your downfall!','',26124),
(47034,'enUS','Too early, but no choice... They must be tested! Face now my prime subjects!','',26124),
(47035,'enUS','Meet the brawn to my brains! Prime subjects, devour them!','',26124),
(47036,'enUS','|TInterface\\Icons\\INV_POTION_24.BLP:20|tMaloriak throws a |cFFFF0000red|r vial into the cauldron!','',26124),
(47037,'enUS','|TInterface\\Icons\\INV_POTION_20.BLP:20|tMaloriak throws a |cFF809FFEblue|r vial into the cauldron!','',26124),
(47038,'enUS','|TInterface\\Icons\\INV_POTION_162.BLP:20|tMaloriak throws a |cFF33FF00green|r vial into the cauldron!','',26124),
(47039,'enUS','Please champions, rescue my brethren from the Twilight\'s Hammer!','',26124),
(47040,'enUS','The Twilight Dragonkin must be stopped! Rescue the other Red Dragonflight and we shall assist you!','',26124),
(47041,'enUS','Some have spent decades meditating upon this mystery, Avuun. I do not wish the same fate upon you.','',26124),
(47042,'enUS','The Light wishes suffering on none, my child. But it does not reign unopposed in our realm.','',26124),
(47043,'enUS','Even now, the true battle between the forces of Light and Darkness approaches. We will all be called to join, and in the face of this conflict, all mortal suffering will be meaningless.','',26124),
(47044,'enUS','Magtoor, you have endured your plight bravely. Are you ready to return to the embrace of the Light?','',26124),
(47045,'enUS','Then may the Light save you and raise you up.','',26124),
(47046,'enUS','Remember, Avuun. Not all who wander are lost.','',26124),
(47047,'enUS','Even now, nothing. Why? Why would the Light forsake the innocent?','',26124),
(47048,'enUS','Prophet Velen!','',26124),
(47049,'enUS','...thank you, Prophet. You have given both of us great comfort. I will continue my work, in faith and memory of Magtoor.','',26124),
(47050,'enUS','Hey, look!  It\'s flying!','',26124),
(47051,'enUS','Yes...','',26124),
(47052,'enUS','','It\'s lovely here, don\'t you think?$b$bA bit hot, perhaps, but it\'s a dry heat...',26124),
(47053,'enUS','Dad always told me the big fellas hit hard, but that they\'re slow...$b$bI\'m pretty sure dad never met this guy!','',26124),
(47054,'enUS','Madness. Chaos. Much as I thrill to see the titans\' work undone, I do wish to remain alive when the master returns. I will help you.','',26124),
(47055,'enUS','<Blackhorn gazes out across the distant inferno, then turns his attention back to you.>','',26124),
(47056,'enUS','All I wanted was a little peace and quiet!','',26124),
(47057,'enUS','Foolish mortals!  You toy with arcane powers beyond your understanding!  I will put an end to this mockery of magic!','',26124),
(47058,'enUS','Heroes, you are not alone in this dark place!','',26124),
(47059,'enUS','Sintharia, your master owes me a great debt -- one that I intend to extract from his consort\'s hide!','',26124),
(47060,'enUS','Those filthy mutts forced me out of Fenris Keep, I won\'t be forced out of my camp as well!','',26124),
(47061,'enUS','','Hail to the queen!',26124),
(47062,'enUS','','No mercy for the weak!',26124),
(47063,'enUS','It was inevitable!','',26124),
(47064,'enUS','You die in vain!','',26124),
(47065,'enUS','That\'ll learn ye!','',26124),
(47066,'enUS','Get back up! I DARE YE!','',26124),
(47067,'enUS','Ho, ho! That had to hurt!','',26124),
(47068,'enUS','Hah! Too easy!','',26124),
(47069,'enUS','They should show you a degree of trust.','',26124),
(47070,'enUS','At least enough so that you can prove yourself.','',26124),
(47071,'enUS','This champion has proved intent and capable.','',26124),
(47072,'enUS','I see no reason to deny our trust.','',26124),
(47073,'enUS','An inconspicuous marble slab.','',26124),
(47074,'enUS','Place the statue down on the slab.','Place the statue down on the slab.',26124),
(47075,'enUS','An inconspicuous stone slab.','',26124),
(47076,'enUS','Cenarius has fallen!','',26124),
(47077,'enUS','<The enormous ancient remains wary of you, but speaks to you as an ally.>','',26124),
(47078,'enUS','Get back up there and get into the fight!','Get back up there and get into the fight!',26124),
(47079,'enUS','','All the oceans shall be ours, and then we shall look beyond.',26124),
(47080,'enUS','','I took Helgrum under my wing when I arrived in Stonard. Under my harsh glare, he became an even greater tracker than before... and my only companion.$B$BI thought myself strong. I thought no suffering could break my spirit. When I saw the humans sink their swords into Helgrum... into my mate... I found out how wrong I was.',26124),
(47081,'enUS','Find a Tree to Climb','',26124),
(47082,'enUS','Grab a Bear Cub','',26124),
(47083,'enUS','Climb to the Tree Top','',26124),
(47084,'enUS','Chuck the Bear Cub!','',26124),
(47085,'enUS','I am Prince Nadun of Ramkahen.  The Neferset tribe has turned against the other tol\'vir.$B$BHelp me escape so that I may lobby my brother, the king, to wage war against these traitors!','',26124),
(47086,'enUS','I am Prince Nadun of Ramkahehn.  My people are tol\'vir... or descended from the tol\'vir to be precise.$B$BThe people of Neferset were like us, made of flesh and blood...$B$BUntil Deathwing came.','',26124),
(47087,'enUS','He offered all of us a chance to regain our former glory... to be true tol\'vir again.$B$BBut only... if we swore allegiance to him.','',26124),
(47088,'enUS','We are keepers of the secrets of Uldum.  Beneath the sand... under the pyramids... there exists great power.$B$BThe power to make and break an entire world.$B$BHe cannot access this power without us, however.','',26124),
(47089,'enUS','He\'s got one of the tribes on his side.  The Neferset.$B$BOrsis has made its defiance clear.$B$BRamkahen has tried to find a peaceful solution, but there is no peace possible with Deathwing and his allies.','',26124),
(47090,'enUS','Free me.$B$BFree me so that we may rally my people against Deathwing together.$B$BAnd if that\'s not reason enough, you will be rewarded with great riches.  I am still a prince after all.','',26124),
(47091,'enUS','Who are you?','Who are you?',26124),
(47092,'enUS','Deathwing came here and didn\'t slay you all?','Deathwing came here and didn\'t slay you all?',26124),
(47093,'enUS','Why does he need you?','Why does he need you?',26124),
(47094,'enUS','So not all of your people have allied with him?','So not all of your people have allied with him?',26124),
(47095,'enUS','Agreed.  So what do you want from me?','Agreed.  So what do you want from me?',26124),
(47096,'enUS','Quick! Into the plane!','',26124),
(47097,'enUS','$n prepares a feast of Broiled Dragon!','$n prepares a feast of Broiled Dragon!',26124),
(47098,'enUS','$n prepares a feast of Seafood Magnifique!','$n prepares a feast of Seafood Magnifique!',26124),
(47099,'enUS','Pathetic. ','',26124),
(47100,'enUS','Keep moving forward. My men will dispose of this sorry bag of bones.','',26124),
(47101,'enUS','The Bloodfang Berserkers begin to salivate heavily.','',26124),
(47102,'enUS','Control yourselves! We\'re here for Godfrey\'s head above all else. Relish in the spoils of war later!','',26124),
(47103,'enUS','We have to push forward if we\'re to put an end to him. Follow me, I\'ll open the courtyard so that you can spearhead our assault.','',26124),
(47104,'enUS','Get zhem!! Now! Go, go, go!','',26124),
(47105,'enUS','I can teach you the basics of any gathering or production profession, but that\'s all.\n\nTo learn more than an apprentice\'s skills, you\'ll need to visit a specialist dedicated to only one profession.\n\nYou can learn up to two professions: Two gathering, two production, or one of each.\n\nSecondary skills like Archaeology, Cooking, First Aid, and Fishing don\'t count towards your two professions; you can learn as many of those as you like.','I can teach you the basics of any gathering or production profession, but that\'s all.\n\nTo learn more than an apprentice\'s skills, you\'ll need to visit a specialist dedicated to only one profession.\n\nYou can learn up to two professions: Two gathering, two production, or one of each.\n\nSecondary skills like Archaeology, Cooking, First Aid, and Fishing don\'t count towards your two professions; you can learn as many of those as you like.',26124),
(47106,'enUS','Tell me about gathering professions.','Tell me about gathering professions.',26124),
(47107,'enUS','Tell me about production professions.','Tell me about production professions.',26124),
(47108,'enUS','Gathering professions allow you to acquire raw materials used by production professions: gathering herbs; mining ore, stone, and jewels; or skinning beasts for their hides.\n\nYou can either support a related production profession with gathering, or simply sell the raw materials on the auction house.','Gathering professions allow you to acquire raw materials used by production professions: gathering herbs; mining ore, stone, and jewels; or skinning beasts for their hides.\n\nYou can either support a related production profession with gathering, or simply sell the raw materials on the auction house.',26124),
(47109,'enUS','Train me in Alchemy.','Train me in Alchemy.',26124),
(47110,'enUS','Train me in Blacksmithing.','Train me in Blacksmithing.',26124),
(47111,'enUS','Train me in Enchanting.','Train me in Enchanting.',26124),
(47112,'enUS','Train me in Herbalism.','Train me in Herbalism.',26124),
(47113,'enUS','Train me in Inscription.','Train me in Inscription.',26124),
(47114,'enUS','Train me in Jewelcrafting.','Train me in Jewelcrafting.',26124),
(47115,'enUS','Train me in Leatherworking.','Train me in Leatherworking.',26124),
(47116,'enUS','Train me in Mining.','Train me in Mining.',26124),
(47117,'enUS','Train me in Skinning.','Train me in Skinning.',26124),
(47118,'enUS','Train me in Tailoring.','Train me in Tailoring.',26124),
(47119,'enUS','Train me in Engineering.','Train me in Engineering.',26124),
(47120,'enUS','Hold your ground. We Wildhammer go down fighting to the end!','',26124),
(47121,'enUS','First of all, it wasn\'t sunny out.  It was cloudy when Deathwing appeared.','',26124),
(47122,'enUS','The cowardly dragon must have seen me, because he turned away and flew into the clouds.','',26124),
(47123,'enUS','Luckily, I had been tinkering with my world-shrinking device.','',26124),
(47124,'enUS','\"I\'ll find you in those clouds, you worm!\" I yelled.  \"And then I\'ll throw you to Kalimdor!\"','',26124),
(47125,'enUS','I\'ll find you in those clouds, you worm!','',26124),
(47126,'enUS','And then I\'ll throw you to Kalimdor!','',26124),
(47127,'enUS','I decided to keep shrinking the world until I could reach the clouds.$b$b|TInterface\\Icons\\inv_helmet_47.blp:32|t','',26124),
(47128,'enUS','The High Shaman is here - I can see the storm clouds. Crush him, that we may take his skull as a trophy!','The High Shaman is here - I can see the storm clouds. Crush him, that we may take his skull as a trophy!',26124),
(47129,'enUS','Production professions allow you to turn raw materials into items that you can use yourself, give to companions, or sell at an auction house.\n\nThey are often paired with a gathering profession so that you can gather your own raw materials, but it is possible to simply buy materials on the auction house.','Production professions allow you to turn raw materials into items that you can use yourself, give to companions, or sell at an auction house.\n\nThey are often paired with a gathering profession so that you can gather your own raw materials, but it is possible to simply buy materials on the auction house.',26124),
(47130,'enUS','Herbalism allows you to locate and gather herbs from the wild. These can be sold at the auction house or used to support the Alchemy or Inscription professions.\n\nSkilled herbalists can also use their knowledge of the earth to heal themselves.','Herbalism allows you to locate and gather herbs from the wild. These can be sold at the auction house or used to support the Alchemy or Inscription professions.\n\nSkilled herbalists can also use their knowledge of the earth to heal themselves.',26124),
(47131,'enUS','Mining allows you to locate and mine ore, minerals and stone from mining nodes in the wilderness and underground. These can be sold at the auction house or used to support the Blacksmithing, Engineering, or Jewelcrafting professions.\n\nSkilled miners also become tough and gain increased Stamina.\n\nYou\'ll need a Mining Pick in order to mine; this can be purchased from trade or Mining vendors.','Mining allows you to locate and mine ore, minerals and stone from mining nodes in the wilderness and underground. These can be sold at the auction house or used to support the Blacksmithing, Engineering, or Jewelcrafting professions.\n\nSkilled miners also become tough and gain increased Stamina.\n\nYou\'ll need a Mining Pick in order to mine; this can be purchased from trade or Mining vendors.',26124),
(47132,'enUS','Skinning allows you to remove and prepare the hides from slain creatures. These can be sold at the auction house or used to support the Leatherworking profession.\n\nSkilled Skinners also become masters of anatomy, increasing their chances to critically hit a target.\n\nYou\'ll need a Skinning Knife in order to skin creatures; this can be purchased from trade or Leatherworking vendors.','Skinning allows you to remove and prepare the hides from slain creatures. These can be sold at the auction house or used to support the Leatherworking profession.\n\nSkilled Skinners also become masters of anatomy, increasing their chances to critically hit a target.\n\nYou\'ll need a Skinning Knife in order to skin creatures; this can be purchased from trade or Leatherworking vendors.',26124),
(47133,'enUS','Alchemy allows you to use herbs and other materials to create a wide variety of useful elixirs, potions, oils, flasks and cauldrons. You\'ll also gain greater, longer-lasting benefits when using your own elixirs and flasks.\n\nHighly skilled alchemists may also transmute elemental materials and certain minerals for use by other production professions.\n\nAlchemy pairs well with Herbalism as it allows you to gather your own herbs.','Alchemy allows you to use herbs and other materials to create a wide variety of useful elixirs, potions, oils, flasks and cauldrons. You\'ll also gain greater, longer-lasting benefits when using your own elixirs and flasks.\n\nHighly skilled alchemists may also transmute elemental materials and certain minerals for use by other production professions.\n\nAlchemy pairs well with Herbalism as it allows you to gather your own herbs.',26124),
(47134,'enUS','Blacksmithing allows you to forge items from metals, minerals and stones: melee weapons, mail and plate heavy armor, raw materials used by other production professions, and upgrades to pieces of equipment such as sharpening stones and shield spikes.\n\nHighly skilled blacksmiths can add a gem slot to their own bracers and gloves, as well as to their own or others\' belts. These gem slots may then be filled with magical gems that make the gemmed item more powerful.\n\nBlacksmithing pairs well with Mining as it allows you to gather your own ore and minerals.','Blacksmithing allows you to forge items from metals, minerals and stones: melee weapons, mail and plate heavy armor, raw materials used by other production professions, and upgrades to pieces of equipment such as sharpening stones and shield spikes.\n\nHighly skilled blacksmiths can add a gem slot to their own bracers and gloves, as well as to their own or others\' belts. These gem slots may then be filled with magical gems that make the gemmed item more powerful.\n\nBlacksmithing pairs well with Mining as it allows you to gather your own ore and minerals.',26124),
(47135,'enUS','Dragonmaw attack! Protect the High Shaman.','Look out - Dragonmaw!',26124),
(47136,'enUS','Enchanting allows you to enchant items with a wide variety of beneficial effects, as well as disenchant items and create magical wands and oils.\n\nHighly skilled enchanters can even enchant their own rings, which no one else may do.\n\nMost raw materials for Enchanting must be gathered via disenchanting, a process which destroys the disenchanted item. For this reason the profession pairs well with Tailoring, as you can disenchant the magical Tailoring items you create for raw materials.\n\nEnchanters may also place enchantments upon vellum, which allows the enchantment to be sold or saved for later use. Vellum and other useful Enchanting materials may be purchased from Enchanting vendors.','Enchanting allows you to enchant items with a wide variety of beneficial effects, as well as disenchant items and create magical wands and oils.\n\nHighly skilled enchanters can even enchant their own rings, which no one else may do.\n\nMost raw materials for Enchanting must be gathered via disenchanting, a process which destroys the disenchanted item. For this reason the profession pairs well with Tailoring, as you can disenchant the magical Tailoring items you create for raw materials.\n\nEnchanters may also place enchantments upon vellum, which allows the enchantment to be sold or saved for later use. Vellum and other useful Enchanting materials may be purchased from Enchanting vendors.',26124),
(47137,'enUS','Engineering allows you to construct a wide variety of useful, amazing, and just plain weird items like rifles and scopes, motorcycles, and mechanical squirrels. However, many of these are only usable by yourself or other engineers, such as special goggles, mechanical additions to belts, boots, gloves and cloaks, and flying machines.\n\nMost raw Engineering materials are metals gathered by Mining, so the two professions pair well.\n\nMany creations require the use of a Blacksmith Hammer; this and other necessary materials, such as gun stocks or flux, may be purchased from trade or Engineering vendors.','Engineering allows you to construct a wide variety of useful, amazing, and just plain weird items like rifles and scopes, motorcycles, and mechanical squirrels. However, many of these are only usable by yourself or other engineers, such as special goggles, mechanical additions to belts, boots, gloves and cloaks, and flying machines.\n\nMost raw Engineering materials are metals gathered by Mining, so the two professions pair well.\n\nMany creations require the use of a Blacksmith Hammer; this and other necessary materials, such as gun stocks or flux, may be purchased from trade or Engineering vendors.',26124),
(47138,'enUS','Inscription allows you to create magical scrolls, glyphs, off-hand tomes, Darkmoon cards, and even recipes for other professions.\n\nMany raw materials for Inscription come from milling herbs gathered by Herbalism, so the two professions pair well.\n\nYou\'ll need a Virtuoso Inking Set for inscribing things; this and other necessary materials, such as parchment, may be purchased from Inscription vendors.','Inscription allows you to create magical scrolls, glyphs, off-hand tomes, Darkmoon cards, and even recipes for other professions.\n\nMany raw materials for Inscription come from milling herbs gathered by Herbalism, so the two professions pair well.\n\nYou\'ll need a Virtuoso Inking Set for inscribing things; this and other necessary materials, such as parchment, may be purchased from Inscription vendors.',26124),
(47139,'enUS','Jewelcrafting allows you to fashion magical rings, amulets, and trinkets as well as cut gems.\n\nThe gems used in Jewelcrafting may be purchased or acquired via Prospecting from ore gathered by Mining; for this reason the two professions pair well.\n\nMost Jewelcrafting designs also require a Jeweler\'s Kit while more advanced creations require a Simple Grinder; these may be purchased from Jewelcrafting vendors.','Jewelcrafting allows you to fashion magical rings, amulets, and trinkets as well as cut gems.\n\nThe gems used in Jewelcrafting may be purchased or acquired via Prospecting from ore gathered by Mining; for this reason the two professions pair well.\n\nMost Jewelcrafting designs also require a Jeweler\'s Kit while more advanced creations require a Simple Grinder; these may be purchased from Jewelcrafting vendors.',26124),
(47140,'enUS','Leatherworking allows you to fashion armor, cloaks, armor-reinforcing kits, and other similar items from leather, hides, and scales. Other materials required for leatherworking can be purchased at trade and Leatherworking vendors.\n\nLeatherworking pairs well with Skinning as it allows you to gather your own raw materials; other necessary items, such as threads and dyes, can be purchased from trade or Leatherworking vendors.\n\nHighly skilled leatherworkers can also enforce their bracers and leg armor.','Leatherworking allows you to fashion armor, cloaks, armor-reinforcing kits, and other similar items from leather, hides, and scales. Other materials required for leatherworking can be purchased at trade and Leatherworking vendors.\n\nLeatherworking pairs well with Skinning as it allows you to gather your own raw materials; other necessary items, such as threads and dyes, can be purchased from trade or Leatherworking vendors.\n\nHighly skilled leatherworkers can also enforce their bracers and leg armor.',26124),
(47141,'enUS','Tailoring allows you to fashion armor, cloaks, clothing, bags, spellthread, and other similar items from various types of cloth, which can be purchased or taken from slain humanoid enemies. Additional necessary materials such as threads and dyes can be purchased from trade or Tailoring vendors.\n\nHighly skilled tailors can also upgrade their cloaks with magical embroidery.\n\nEnchanters are often tailors as well, since they can disenchant the magical items they create.','Tailoring allows you to fashion armor, cloaks, clothing, bags, spellthread, and other similar items from various types of cloth, which can be purchased or taken from slain humanoid enemies. Additional necessary materials such as threads and dyes can be purchased from trade or Tailoring vendors.\n\nHighly skilled tailors can also upgrade their cloaks with magical embroidery.\n\nEnchanters are often tailors as well, since they can disenchant the magical items they create.',26124),
(47142,'enUS','Tell me about Herbalism.','Tell me about Herbalism.',26124),
(47143,'enUS','Tell me about Mining.','Tell me about Mining.',26124),
(47144,'enUS','Tell me about Skinning.','Tell me about Skinning.',26124),
(47145,'enUS','Tell me about Alchemy.','Tell me about Alchemy.',26124),
(47146,'enUS','Tell me about Blacksmithing.','Tell me about Blacksmithing.',26124),
(47147,'enUS','Tell me about Enchanting.','Tell me about Enchanting.',26124),
(47148,'enUS','Tell me about Engineering.','Tell me about Engineering.',26124),
(47149,'enUS','Tell me about Inscription.','Tell me about Inscription.',26124),
(47150,'enUS','Tell me about Jewelcrafting.','Tell me about Jewelcrafting.',26124),
(47151,'enUS','Tell me about Leatherworking.','Tell me about Leatherworking.',26124),
(47152,'enUS','Tell me about Tailoring.','Tell me about Tailoring.',26124),
(47153,'enUS','What? MORE Dragonmaw? Stay close - they\'re comin\' from all sides!','',26124),
(47154,'enUS','Once the world was small enough, I started to hunt for Deathwing in the clouds.$b$b|TInterface\\Icons\\spell_frost_arcticwinds.blp:32|t','',26124),
(47155,'enUS','Great fight, everyone! A few more notches in my hammer and a few less Dragonmaw to threaten Thundermar.','',26124),
(47156,'enUS','Guard the main road. These Dragonmaw are just stupid enough to try again.','',26124),
(47157,'enUS','The Bloodfang come for you, worgen hunters!','',26124),
(47158,'enUS','Commander Springvale is down that hall, heroes.','',26124),
(47160,'enUS','The Wildhammer High Shaman is finished. Count up our dead. Bloodgulch will want to hear of our triumph!','The Wildhammer High Shaman is finished. Count up our dead. Bloodgulch will want to hear of our triumph!',26124),
(47161,'enUS','They will return soon. Let\'s get back to Bloodgulch.','They will return soon. Let\'s get back to Bloodgulch.',26124),
(47162,'enUS','Use the meteor on the ground to launch a critical attack on the %s!','Use the meteor on the ground to launch a critical attack on the %s!',26124),
(47163,'enUS','I had searched every cloud, but I couldn\'t find Deathwing.','',26124),
(47164,'enUS','It was then that I realized: he was hiding in the sun.  I looked up.','',26124),
(47165,'enUS','','You have a bad feeling about this basement...',26124),
(47166,'enUS','The sun burned me bad, but I got my hands around his slimy neck.','',26124),
(47167,'enUS','I summoned all my strength, faced west, and threw him to Kalimdor.','',26124),
(47168,'enUS','You\'ve got to try some of this beer.','',26124),
(47169,'enUS','Tell me that story again, Lucien.','Tell me that story again, Lucien.',26124),
(47170,'enUS','Where are you, dragon?','',26124),
(47171,'enUS','Are you hiding in this cloud?','',26124),
(47172,'enUS','Lucien\'s gonna getcha!','',26124),
(47173,'enUS','Surprise, dragon!  Aw, shucks.','',26124),
(47174,'enUS','Where you at?','',26124),
(47175,'enUS','He can\'t have gotten far...','',26124),
(47176,'enUS','When I find that dragon, I\'m gonna throw him to Kalimdor.','',26124),
(47177,'enUS','I hate you, Deathwing.','',26124),
(47178,'enUS','Wow, Lucien.  You need to stop drinking RIGHT NOW.','',26124),
(47179,'enUS','If you\'re not here to work, then please see yourself away from our excavation.','',26124),
(47180,'enUS','Hey there, good lookin\'.','Hey there, good lookin\'.',26124),
(47181,'enUS','You got room for one more, sugar?','You got room for one more, sugar?',26124),
(47182,'enUS','Going my way?','Going my way?',26124),
(47183,'enUS','Can a lady get a ride?','Can a lady get a ride?',26124),
(47184,'enUS','You\'re looking very handsome today, Martek.','You\'re looking very handsome today, Martek.',26124),
(47185,'enUS','Ooh, Martek, can I ride with you?','Ooh, Martek, can I ride with you?',26124),
(47186,'enUS','Martek, you are the bravest orc I know.','Martek, you are the bravest orc I know.',26124),
(47187,'enUS','Save me, Martek!  I need you!','Save me, Martek!  I need you!',26124),
(47188,'enUS','Hop in, baby.','Hop in, baby.',26124),
(47189,'enUS','I\'ve picked up Walden\'s foul scent. Fill the air with his blood!','',26124),
(47190,'enUS','Bones?','',26124),
(47191,'enUS','','This path only leads deeper into the city. Keep going south toward the Loading Room.',26124),
(47192,'enUS','I\'m gonna punch that dragon in the face!','',26124),
(47193,'enUS','Let\'s move!','',26124),
(47194,'enUS','I\'ve got a bad feeling about this...','',26124),
(47195,'enUS','One of Clay\'s catapult teams is broken down on the front. $n, I need you to get some parts from him and get that catapult back in the fight!','',26124),
(47196,'enUS','Vhat a pleasure, $c.$b$bVe get so few visitors zhese days.','',26124),
(47197,'enUS','','Vhat a surprise!$b$bVe veren\'t expecting anyvone today...',26124),
(47198,'enUS','The day that Deathwing came, blood rained from the skies.','',26124),
(47199,'enUS','I believe I was showing my motorcycle to some hot babes at the time.','',26124),
(47200,'enUS','After Deathwing appeared, they became quite frightened, but I only had room to rescue one of them.','',26124),
(47201,'enUS','Obviously, I picked the orc.','',26124),
(47202,'enUS','Obviously, I picked the human.','',26124),
(47203,'enUS','Obviously, I picked the night elf.','',26124),
(47204,'enUS','Obviously, I picked the blood elf.','',26124),
(47205,'enUS','We rode off down the canyon, careful to avoid falling rocks.','',26124),
(47206,'enUS','When I reached the end of the canyon, I remembered that my motorcycle could fly.','',26124),
(47207,'enUS','That would have been helpful to know earlier.','',26124),
(47208,'enUS','I flew to the top of the pillar located just north of the canyon.','',26124),
(47209,'enUS','Atop the pillar, I saw him: Deathwing.  The time for the ultimate confrontation had arrived.','',26124),
(47210,'enUS','Hey, stop it Theldurin!  This is my story!','',26124),
(47211,'enUS','Cut it out guys!  Quit interrupting!','',26124),
(47212,'enUS','Fine.  You don\'t get to hear about how I beat Deathwing in a knife fight.  Your loss.','',26124),
(47213,'enUS','During the flight, I shared a tender moment with the lovely orc.','',26124),
(47214,'enUS','During the flight, I shared a tender moment with the attractive human.','',26124),
(47215,'enUS','During the flight, I shared a tender moment with the grateful young night elf.','',26124),
(47216,'enUS','During the flight, I shared a tender moment with the strapping blood elf.','',26124),
(47217,'enUS','You disturb my work, $c.','',26124),
(47218,'enUS','I have ... failed the master...','',26124),
(47219,'enUS','Ve meet again, Doctor Jones! Zhanks to your vork in zhis region, my mission has become much easier.','',26124),
(47220,'enUS','I need another Doomsday Message board.','I need another Doomsday Message board.',26124),
(47221,'enUS','Gather close. We\'re doing this. Let\'s roll!','',26124),
(47222,'enUS','No!  I love you, Martek!','No!  I love you, Martek!',26124),
(47223,'enUS','Why?  Why are you leaving me?','Why?  Why are you leaving me?',26124),
(47224,'enUS','I loved you, Martek!','I loved you, Martek!',26124),
(47225,'enUS','I\'m just happy to have known you while I lived, Martek.','I\'m just happy to have known you while I lived, Martek.',26124),
(47226,'enUS','Goodbye, Martek.','Goodbye, Martek.',26124),
(47227,'enUS','Rest here a moment. Gather your strength.','',26124),
(47228,'enUS','I can die in peace, knowing that my last few moments were with Martek.','I can die in peace, knowing that my last few moments were with Martek.',26124),
(47229,'enUS','I\'ll never forget that magical summer we shared, Martek.','I\'ll never forget that magical summer we shared, Martek.',26124),
(47230,'enUS','Woo hoo!  Martek picked me!','Woo hoo!  Martek picked me!',26124),
(47231,'enUS','Right then! Keep your eyes open for civilians. Let\'s move. For Thundermar!','',26124),
(47232,'enUS','We\'ve done all we can here. Let\'s get back to Thundermar!','',26124),
(47233,'enUS','I must admit, I am intrigued by this ambitious little upstart.$b$bI\'m not rushing to judgment, mind you, but I\'ve heard some unsettling rumors.$b$bTime will tell if his motives are just.','',26124),
(47234,'enUS','This is quite an operation here, wouldn\'t you say?','',26124),
(47235,'enUS','What... is that thing?!','The statue is alive?!',26124),
(47236,'enUS','I know what you\'re up to, Schnottz! Deathwing will never have the coffer, not if I can help it!','',26124),
(47237,'enUS','Quite an operation, indeed. What do you think of our host?','Quite an operation, indeed. What do you think of our host?',26124),
(47238,'enUS','Fists of frost!','',26124),
(47239,'enUS','Fists of flame!','',26124),
(47240,'enUS','What brings you to a bunch of old, washed-up desert dogs like us?','',26124),
(47241,'enUS','Look out - Dragonmaw ambush!','',26124),
(47242,'enUS','Tell me that story again, Martek.','Tell me that story again, Martek.',26124),
(47243,'enUS','I\'ve encountered some of his underlings out in the field. They\'ve been quite hostile.','I\'ve encountered some of his underlings out in the field. They\'ve been quite hostile.',26124),
(47244,'enUS','I\'m not surprised.$b$bSo many questions, I cannot ignore...$b$bWhy all these weapons for an archaeological dig? And what is being done with the unearthed relics? Under what authority is the excavation being conducted?$b$bThe answers don\'t seem to be forthcoming. I\'ll just have to find out for myself, I suppose.','',26124),
(47245,'enUS','Vell in zhat case, ve must ensure zhat you and your friend are out of zhe picture.','',26124),
(47246,'enUS','Eediot!$b$bAvay vizh you!$b$bCan\'t you see zhat I am concentratink?','',26124),
(47247,'enUS','The rockling rumbles in appreciation.','',26124),
(47248,'enUS','The rockling looks confused for a moment before running off.','',26124),
(47249,'enUS','The rockling clatters its crystals together in thanks.','',26124),
(47250,'enUS','The rockling looks up at you questioningly.','',26124),
(47251,'enUS','You hear a loud cracking noise as the rockling tries to smile.','',26124),
(47252,'enUS','The rockling thuds happily upon the ground.','',26124),
(47253,'enUS','The rockling offers a great gravelly sigh of appreciation.','',26124),
(47254,'enUS','The rockling scampers into the distance, excited by its newfound freedom.','',26124),
(47255,'enUS','Sorry about the interruption, Martek.  You\'ve gotta admit though... I made your story about fifty times better.  Next drink\'s on me.','',26124),
(47256,'enUS','Glubtok show you da power of de arcane!','',26124),
(47257,'enUS','I say! Raise a glass, my friend!$b$bTake in the sights here.$b$bThis entire region has been hidden away for ages, you know.','',26124),
(47258,'enUS','What do you know of our generous host, sir?','What do you know of our generous host, sir?',26124),
(47259,'enUS','Why, just look at the treasure he has accumulated!$b$bI\'m not always comfortable with his methods, but there\'s no denying the results...$b$bBest not to dwell upon unpleasant thoughts. It\'s bad manners, you know.','',26124),
(47260,'enUS','Hmmm, well what is it that brings you to these parts?','Hmmm, well what is it that brings you to these parts?',26124),
(47261,'enUS','Speculation, my dear $gboy:girl;!$b$bOnce our eager little furrier has unearthed enough treasure, he\'ll be one of Azeroth\'s most influential figures.$b$bWe\'ll all be properly positioned when that comes to pass.','',26124),
(47262,'enUS','They haven\'t noticed us yet. Hurry, maybe we can still stop them!','',26124),
(47263,'enUS','I figured I might see you again, Schnottz.','',26124),
(47264,'enUS','Not so fast, Schnottz! ','',26124),
(47265,'enUS','Permanently!','',26124),
(47266,'enUS','You von\'t live to see your precious coffer, Jones!','',26124),
(47267,'enUS','Now, isn\'t this the place to be?$b$bTouring unexplored corners of the world with likeminded fellows?$b$bWhat could be better?','',26124),
(47268,'enUS','Indeed! And how do you find the Commander, friend?','Indeed! And how do you find the Commander, friend?',26124),
(47269,'enUS','He\'s a bit animated for my tastes, but the world needs all kinds, I suppose.$b$bWhy do you ask?\n','',26124),
(47270,'enUS','Destroy the Obsidian Colossus!','Destroy the Obsidian Colossus!',26124),
(47271,'enUS','His troops, these guards... it all seems a little intense.','His troops, these guards... it all seems a little intense.',26124),
(47272,'enUS','I see what you mean, I suppose...$b$bYou know, I\'m just here because I want to expand my horizons a bit, see the world and whatnot.$b$bI\'m not terribly concerned with the goings on of others.$b$bNice to meet you, though.\n','',26124),
(47273,'enUS','Avoid the beams of searing light!','',26124),
(47274,'enUS','','Exquisite weather here, wouldn\'t you say, $c?',26124),
(47275,'enUS','I\'m out of here!','I\'m out of here!',26124),
(47276,'enUS','Ahh, yes. How have you been enjoying your time here?','Ahh, yes. How have you been enjoying your time here?',26124),
(47277,'enUS','','Oh, it\'s been wonderful!$b$bThe commander is so confident, and that accent! I must admit, he\'s quite captivating.$b$bDo you know if he\'s married?',26124),
(47278,'enUS','Uhhh.. I\'m not sure. Anything else you can tell me about him?','Uhhh.. I\'m not sure. Anything else you can tell me about him?',26124),
(47279,'enUS','','Word has it that some of the relics in these parts hold mystical power!$b$bHe seems to be fascinated with such things...',26124),
(47280,'enUS','What do you think about the troops he\'s arming? Seems a little excessive, no?','What do you think about the troops he\'s arming? Seems a little excessive, no?',26124),
(47281,'enUS','','I\'m sorry, $c.$b$bI really don\'t know enough to discuss such things. And honestly, I would prefer to keep it that way.',26124),
(47282,'enUS','So, zhis is zhe $r $c I haf heard so much about, hmm?','',26124),
(47283,'enUS','State your business, $r.','',26124),
(47284,'enUS','Ve\'re vatchink you, $r...','',26124),
(47285,'enUS','...alvays vatchink!','',26124),
(47286,'enUS','If you can\'t fight Zoltrik at range, use your Jump Drakes! ability:\n\n|TInterface\\Icons\\ability_vehicle_launchplayer.blp:64|t','If you can\'t fight Zoltrik at range, use your Jump Drakes! ability:\n\n|TInterface\\Icons\\ability_vehicle_launchplayer.blp:64|t',26124),
(47287,'enUS','','Dragon\'s Mouth was established to give the Alliance their first real foothold here in the Badlands.  Despite its position between Stormwind and Dun Morogh, the Badlands have traditionally been Horde territory.$b$bIf that\'s ever to change, we need to start asserting ourselves.  Of course, the dragon attacks on New Kargath don\'t hurt our cause either.',26124),
(47288,'enUS','I was as surprised as you to find the black dragonflight asserting its will against New Kargath.  Gorn is stubborn, and refuses help from anyone.$b$bEven so, High Examiner Bloodwatcher has asked me to watch from a distance, to make sure things do not become... ugly.','',26124),
(47289,'enUS','We must keep Therazane\'s forces from attacking Stonehearth.$B$BIf they do, they will steal the middle fragment of the World Pillar.','',26124),
(47290,'enUS','Heroes!  My power wanes....','',26124),
(47291,'enUS','','You mistake this for weakness?  Fool!',26124),
(47292,'enUS','','Enough!  Drawing upon this source will set us back months.  You should feel honored to be worthy of its expenditure.  Now... die!',26124),
(47293,'enUS','The fires dim, champions....  Take this, the last of my power.  Succeed where I have failed.  Avenge me.  Avenge the world....','',26124),
(47294,'enUS','A new victim! Me was almost don wit dis one anyway. ','',26124),
(47295,'enUS','All hail, $n! Huzzah!','',26124),
(47296,'enUS','Huzzah!','',26124),
(47297,'enUS','Indeed!','',26124),
(47298,'enUS','','Need something?',26124),
(47299,'enUS','A boat ride to the Badlands, please.','A boat ride to the Badlands, please.',26124),
(47300,'enUS','We fish, we sleep, and we explode things.  What could be better than that?','',26124),
(47301,'enUS','Could I get a boat ride to Eastern Plaguelands, please?','Could I get a boat ride to Eastern Plaguelands, please?',26124),
(47302,'enUS','Zeppelin arrival in six minutes.','',26124),
(47303,'enUS','Zeppelin arrival in five minutes.','',26124),
(47304,'enUS','Zeppelin arrival in four minutes.','',26124),
(47305,'enUS','Zeppelin arrival in three minutes.','',26124),
(47306,'enUS','Zeppelin arrival in two minutes.','',26124),
(47307,'enUS','Zeppelin arrival in one minute. One minute.','',26124),
(47308,'enUS','Boarding the Spear of Durotar, are we? You are to be envied, Horde marine!','',26124),
(47309,'enUS','You are about to rip the horizon a new sky-hole aboard a sensational new era in aeronautical innovation. ','',26124),
(47310,'enUS','It\'s been recklessly engineered with a merciless disregard for both budgetary concerns and those cumbersome, inefficient \"laws of physics.\"','',26124),
(47311,'enUS','While you wait for its arrival, my assistant and I will momentarily demonstrate some of the features of this remarkable aircraft.','',26124),
(47312,'enUS','As you know, air weighs nothing. So to create a lighter-than-air vessel, we had to bend a few rules.','',26124),
(47313,'enUS','The Spear of Durotar is filled to the bursting point with combustible, super-heated gas.','',26124),
(47314,'enUS','Bilgewater engineers have taken advantage of its inherent high-altitude instability and resultant low-cost.','',26124),
(47315,'enUS','We\'ve mitigated the explosive instability of the gas by putting it under IMMENSE pressure.','',26124),
(47316,'enUS','Doing so required the removal of a number of safety valves that kept erupting. ','',26124),
(47317,'enUS','Oh my, yes. In order to maximize both range and payload, we\'ve concocted an unorthodox blend of rocket fuels for the state-of-the-art engines.','',26124),
(47318,'enUS','It is so energy-dense as to combust at the slightest provocation.','',26124),
(47319,'enUS','This stuff is so volatile, it probably shouldn\'t be moved. Much less... flown.','',26124),
(47320,'enUS','Your course today will take you directly across the great sea.','',26124),
(47321,'enUS','An enormous, unforgiving expanse of pounding grey waves, freezing temperatures, and ravenous sea life.','',26124),
(47322,'enUS','Trust me, friend, a rapid pill-induced death is far preferable to the long, agonizing process of hypothermia and subsequent dismemberment by sharks.','',26124),
(47323,'enUS','Don\'t ask how we know what they taste like.','',26124),
(47324,'enUS','Should your zeppelin be attacked en-route, panic is inadvisable.','',26124),
(47325,'enUS','Instead, look for a number of deck-mounted flak cannons positioned for just such an emergency.','',26124),
(47326,'enUS','Greely, show them how the guns work.','',26124),
(47327,'enUS','Simply aim and pull the trigger. Or don\'t aim. I wash my hands of the whole thing.','',26124),
(47328,'enUS','Greely, you\'re not randomly firing that thing into Bilgewater Port, are you?','',26124),
(47329,'enUS','In the unlikely event that a catastrophic failure does not instantly kill everyone aboard...','',26124),
(47330,'enUS','...a number of parachutes will appear along the railings.','',26124),
(47331,'enUS','Simply grab a nearby parachute to be vaulted clear of the burning zeppelin. Hopefully onto dry land.','',26124),
(47332,'enUS','Greely, would you like to demonstrate how our parachutes work?','',26124),
(47333,'enUS','Very well then. I see that the Spear of Durotar has almost arrived.','',26124),
(47334,'enUS','Your safety and well-being are no longer any concern of mine.','',26124),
(47335,'enUS','Have fun storming the Highlands!','',26124),
(47336,'enUS','','Not a penny was wasted on comfort or personal safety! ',26124),
(47337,'enUS','','We bent the crap outta them!',26124),
(47338,'enUS','','We passed the savings on to us.',26124),
(47339,'enUS','','Ask yourself: what good is a \"safety\" valve if it keeps going off? That doesn\'t sound very safe to me.',26124),
(47340,'enUS','','Tell \'em about the engines, boss.',26124),
(47341,'enUS','','We call it \"Doom Juice.\"',26124),
(47342,'enUS','','Even verbal.',26124),
(47343,'enUS','','To ensure a rapid crew response in the event of a fire, fuel storage has been moved away from the crew quarters and placed beneath the passenger compartment.',26124),
(47344,'enUS','','In the unlikely event of a water \"landing,\" please reach under your seat cushion where a cyanide capsule has been located for your convenience.',26124),
(47345,'enUS','','For those of you allergic to almonds, our cyanide capsules come in an assortment of flavors.',26124),
(47346,'enUS','','You\'ll also find a complementary bag of peanuts.',26124),
(47347,'enUS','','Nothing keeps a fleet of combustible dirigibles safer than randomly flinging molten metal in every conceivable direction!',26124),
(47348,'enUS','','With Pleasure!',26124),
(47349,'enUS','','I can hit my house from here!',26124),
(47350,'enUS','','No.',26124),
(47351,'enUS','','Maybe.',26124),
(47352,'enUS','','A little.',26124),
(47353,'enUS','','We call them \"Emergency Rampless Debarkation Devices.\"',26124),
(47354,'enUS','','Oh hells no! Those things are death-traps!',26124),
(47355,'enUS','','From all of us at Bilgewater Harbor...',26124),
(47356,'enUS','','Have fun storming the Highlands!',26124),
(47357,'enUS','Avoid the shadow runes!','Avoid the shadow runes!',26124),
(47358,'enUS','Carefully Collecting','Carefully Collecting',26124),
(47359,'enUS','Daaaaaaamn... Loss of potential revenue is devastating.','',26124),
(47360,'enUS','Zhat vhich you seek vill soon be mine, Doctor Jones!','',26124),
(47361,'enUS','Glubtok ready?','',26124),
(47362,'enUS','Let\'s do it!','',26124),
(47363,'enUS','ARCANE POWER!!!','',26124),
(47364,'enUS','Crowley is a disgrace to our kind for giving in to the Forsaken. My pack will show them the true face of the worgen and the relentless fury that comes with our presence!','',26124),
(47365,'enUS','What a pathetic lock! Godfrey is going to have to try harder than this if he wants to defeat us.','',26124),
(47366,'enUS','Your time has finally come, Godfrey!','',26124),
(47367,'enUS','','I travelled all this way to speak with the famed \"Seer of the Dragonmaw.\" I wanted to see inside Cho\'gall\'s dark heart before I tear it out.$B$BBut she\'s worthless to me. All riddles and rhyme. Maybe you can help.',26124),
(47368,'enUS','The coffer is just beyond these ruins.$b$bLet\'s go!','',26124),
(47369,'enUS','I\'m ready. Let\'s go!','I\'m ready. Let\'s go!',26124),
(47370,'enUS','For too long we have ignored the secrets of the Arcane.$B$BAre you here to learn, as well?','For too long we have ignored the secrets of the Arcane.$B$BAre you here to learn, as well?',26124),
(47371,'enUS','For too long we have ignored the secrets of the Arcane.$B$BSadly, they will remain a secret to you.','For too long we have ignored the secrets of the Arcane.$B$BSadly, they will remain a secret to you.',26124),
(47372,'enUS','Get behind the Colossus!','Get behind the Colossus!',26124),
(47373,'enUS','Thank you for rescuing the king... and the prince, $n.','',26124),
(47374,'enUS','You\'ve taught me what it means to have friends, $n.','',26124),
(47375,'enUS','I see that you did it, $n. You\'re a credit to your race.','',26124),
(47376,'enUS','The perimeter is secure, commander.','The perimeter is secure, commander.',26124),
(47377,'enUS','Man am I tired!','Man am I tired!',26124),
(47378,'enUS','Attack, my brothers! Make him feel the fury of the pack!','',26124),
(47379,'enUS','Sorry, $c. $B$BYour grasp of the arcane isn\'t strong enough to understand portal magic.','Sorry, $c. $B$BYour grasp of the arcane isn\'t strong enough to understand portal magic.',26124),
(47380,'enUS','You too are a student of the arcane, yes?$B$BI can teach you about portal magic, if you wish to learn.','You too are a student of the arcane, yes?$B$BI can teach you about portal magic, if you wish to learn.',26124),
(47381,'enUS','Very vell, zhen. Let me just check my notes vone lasht time...','',26124),
(47382,'enUS','Mmm-hmmm, yes, yes... simple enough...\n','',26124),
(47383,'enUS','Oh, Gobbles! Ve\'re ready to begin! Come, come!','',26124),
(47384,'enUS','You\'d best hurry if you want any of the spoils.','',26124),
(47385,'enUS','Hold on, Gobbles! Shtand back everyvone!','',26124),
(47386,'enUS','Use your Storm Shield before the Static Charge finishes!\n\n|TInterface\\Icons\\spell_nature_lightningshield.blp:32|t','Use your Storm Shield before the Static Charge finishes!\n\n|TInterface\\Icons\\spell_nature_lightningshield.blp:32|t',26124),
(47387,'enUS','You\'ve absorbed 3 Static Charges. Your next Storm Hammer will deal massive AoE damage!\n\n|TInterface\\Icons\\spell_nature_lightningoverload.blp:32|t','You\'ve absorbed 3 Static Charges. Your next Storm Hammer will deal massive AoE damage!\n\n|TInterface\\Icons\\spell_nature_lightningoverload.blp:32|t',26124),
(47388,'enUS','VHAT!?','',26124),
(47389,'enUS','Vhat could haf possibly gone vrong? I followed every lasht detail...','',26124),
(47390,'enUS','Vait a shekkont! Vhat\'s zhis!?','',26124),
(47391,'enUS','You only brought me eight idols!','',26124),
(47392,'enUS','Zhe ritual shpecifically calls for NINE!!','',26124),
(47393,'enUS','NINE! NINE! NINE! NINE! NINE!!!','',26124),
(47394,'enUS','Out of my sight, vizh you! Auch...','',26124),
(47395,'enUS','My poor Gobbles...','',26124),
(47396,'enUS','No one attacks the Big G and lives!','',26124),
(47397,'enUS','Eat it!','',26124),
(47398,'enUS','What in hell\'s name is going on out here?','',26124),
(47399,'enUS','You may enter this hill alive, but I guarantee you won\'t leave alive.','You may enter this hill alive, but I guarantee you won\'t leave alive.',26124),
(47400,'enUS','Tol Barad is mine, it\'s mine I tell you!','Tol Barad is mine, it\'s mine I tell you!',26124),
(47401,'enUS','Just one final push and the island will be ours.  Chin up men, we move out first thing in the morning.','Just one final push and the island will be ours.  Chin up men, we move out first thing in the morning.',26124),
(47402,'enUS','Go away, whoever you are! Forgotten Hilll is mine... mine!','Go away, whoever you are! Forgotten Hilll is mine... mine!',26124),
(47403,'enUS','I don\'t know why the door is closed, heroes. My pack should have already taken care of Godfrey by now...','',26124),
(47404,'enUS','We will stand idle no longer! The time to act is now!','',26124),
(47405,'enUS','Look out spider!  Here come Lunk!','',26124),
(47406,'enUS','Lunk ride spider now!','',26124),
(47407,'enUS','Spider tummy time!','',26124),
(47408,'enUS','You hold still, spider!','',26124),
(47409,'enUS','Lunk will ride you now!','',26124),
(47410,'enUS','Ha ha ha!','',26124),
(47411,'enUS','I got some venom for you.','',26124),
(47412,'enUS','Lunk got you some venom with his tummy.','',26124),
(47413,'enUS','See?  No kill spider for venom.  Just ride.','',26124),
(47414,'enUS','Spider left some venom on Lunk\'s tummy.  You want?','',26124),
(47415,'enUS','Here, I got you this.','',26124),
(47416,'enUS','Here, you can scrape venom off Lunk\'s tummy.','',26124),
(47418,'enUS','I\'ll make sure nothing interferes. Go now heroes! Kill Godfrey!','',26124),
(47419,'enUS','I\'m afraid I cannot help you, $r, but I am sure Khaelyn Steelwing can.','I\'m afraid I cannot help you, $r, but I am sure Khaelyn Steelwing can.',26124),
(47420,'enUS','I\'m afraid I cannot assist you, $r, but I am certain Georgia can.','I\'m afraid I cannot assist you, $r, but I am certain Georgia can.',26124),
(47421,'enUS','Good work, $glad:lass;! Now to attack their leader!','Good work, $glad:lass;! Now to attack their leader!',26124),
(47422,'enUS','TOO...MUCH...POWER!!!','',26124),
(47423,'enUS','A nearby Gargoyle comes to life!','',26124),
(47424,'enUS','Lunk tired of all this killing!  Lunk quits!','',26124),
(47425,'enUS','Lunk going to find some real adventures!','',26124),
(47426,'enUS','This special plague we\'re spreading will keep Godfrey\'s forces from leaving the keep, but will still allow us to move our troops in to take it for the Forsaken!','',26124),
(47427,'enUS','We have confirmed the Horde presence at Dragonmaw Port, master. They are now in league.','',26124),
(47428,'enUS','Our agents have been outed and killed, master.','',26124),
(47429,'enUS','The Alliance has made landfall master, and in great numbers upon the shore.','',26124),
(47430,'enUS','This changes nothing. (Nothing nothing changes. Crush them, crush.)','',26124),
(47431,'enUS','What of our agents in Stormwind? (Stormwind! The eye, the eye sees into the city heart.) Bring me the eye.','',26124),
(47432,'enUS','What of our agents in Orgrimmar? (City engulfed in stone and sand, we see it! The Eye sees into its heart.) Bring me the eye.','',26124),
(47433,'enUS','(Blaspheme! Blaspheme disgust hate hate...) No matter. Where one eye closes, another opens. (The Master sees all! The Master knows all!) We will know our enemy\'s hearts, for they are weak. The eye. Now.','',26124),
(47434,'enUS','\'Sploded dat one!','',26124),
(47435,'enUS','Move away before the Static Flux explodes!\n\n|TInterface\\Icons\\ability_vehicle_electrocharge.blp:32|t','Move away before the Static Flux explodes!\n\n|TInterface\\Icons\\ability_vehicle_electrocharge.blp:32|t',26124),
(47436,'enUS','The shadow of the Master covers this world... (Darkness, all darkness.) Our enemies fight one another, across the Highland. Fools. (Blood, blood.) WAIT! There is another!','',26124),
(47437,'enUS','A mortal dares peer into the eye! (Brave little plaything.) I see you, little one! You want to see what the Eye sees, do you? (Show it! Show it all!)','',26124),
(47438,'enUS','Behold the chaos to come. (Madness, madness, bliss!) Do you like what you see mortal?','',26124),
(47439,'enUS','(The master sees you! He sees! He sees! He wants! Wants wants...)','',26124),
(47440,'enUS','You\'re more skilled in combat than I thought.','',26124),
(47441,'enUS','Very well then. Let\'s get the courtyard door open so we can continue our mission!','',26124),
(47442,'enUS','This lock should be easy enough to pick.','',26124),
(47443,'enUS','There we go! ','',26124),
(47444,'enUS','Say, would you mind just blocking the sun with your shadow for a little while?$b$bThat\'d be great...','',26124),
(47445,'enUS','You know, I just don\'t really feel much like working today.','',26124),
(47446,'enUS','It\'s far too hot to work out here - especially in these uniforms.','',26124),
(47447,'enUS','I was promised substantial wealth to come out here.$b$bWhat a joke!','',26124),
(47448,'enUS','They\'re working us like dogs and we\'re getting nothing to show for it!','',26124),
(47449,'enUS','Schnottz is making a fortune because of us... where\'s ours?!','',26124),
(47450,'enUS','Enough slacking! You\'re behind schedule...','Enough slacking! You\'re behind schedule...',26124),
(47451,'enUS','I didn\'t sign up for this...','',26124),
(47452,'enUS','I should never have left Tanaris.','',26124),
(47453,'enUS','I was happier as a Wastewander.','',26124),
(47454,'enUS','Yeah, yeah. When aren\'t we behind schedule?','',26124),
(47455,'enUS','I\'m not working for that maniac anymore!','',26124),
(47456,'enUS','I have a message for you to deliver to that tyrant!','',26124),
(47457,'enUS','I haven\'t been paid since I got here! I\'m through with this place!\n','',26124),
(47458,'enUS','I\'m done working in this heat!\n','',26124),
(47459,'enUS','I can\'t believe I fell for Schnottz\'s lies! I\'m out of here!','',26124),
(47460,'enUS','He\'s castin\' something big! Stop\'m!','He\'s castin\' something big! Stop\'m!',26124),
(47461,'enUS','How do you zhink Gobbles vould feel about you if he vere here?$b$bHmm?','',26124),
(47462,'enUS','After zhat ritual debacle, you owe me, $r.$b$bAnd I plan on collectink!','',26124),
(47463,'enUS','Keep it quiet in there. They only get thirty minute rest shifts, and I\'ll not have ya distrubin\' them.','Keep it quiet in there. They only get thirty minute rest shifts, and I\'ll not have ya distrubin\' them.',26124),
(47464,'enUS','Listen, I\'ve been doin\' a little celebratory drinkin\' since our escape, and I\'ve been thinkin\'...$b$bThose little men that jumped us need to be brought to justice!$b$bIf somethin\' ain\'t done, then every unsuspectin\' explorer who sets foot in this place is gunna get sold into slavery - or worse!','',26124),
(47465,'enUS','Through this portal, Tol Barad awaits.','Through this portal, Tol Barad awaits.',26124),
(47466,'enUS','Excellent. Now, to plague this area and move on to-','',26124),
(47467,'enUS','Cromush! What\'re you doing here? This is a covert operation!','',26124),
(47468,'enUS','Unless I\'m mistaken, the Warchief explicity forbids using the full plague, no matter the circumstance.','',26124),
(47469,'enUS','My apologies, Cromush, but I assure you there is no problem. We are using an extremely dilute plague.','',26124),
(47470,'enUS','In fact, it really only serves to scare off the worgen from trying to follow us in here. It\'s completely harmless.','',26124),
(47471,'enUS','Then I\'m sure you won\'t mind if I accompany you on your mission.','',26124),
(47472,'enUS','Be warned, Belmont. If I find out that you\'re lying...','',26124),
(47473,'enUS','You\'ll see the Warchief\'s wrath firsthand.','',26124),
(47474,'enUS','The mistress will pay me handsomely for your heads!','',26124),
(47475,'enUS','Bombs away!\n','',26124),
(47476,'enUS','Ready Oafie? Throw!\n','',26124),
(47477,'enUS','Mortals! You dare breach our inner sanctum. (Unbelievers. Heretics! Burn burn)\n You cross a threshold from which there is no return. (burn burn the heretics will burn.)','',26124),
(47478,'enUS','Halfus! Hear me! (The Master calls, the Master wants.) Protect our secrets, Halfus. Destroy the intruders. (Murder for His glory. Murder for His hunger.)','',26124),
(47479,'enUS','But of course. We have the Horde\'s best interests in mind, sir. These heroes were just about to continue on and kill Springvale for us.','',26124),
(47480,'enUS','No...NO!','',26124),
(47481,'enUS',' Flesh and sinew, weak but proud. Dare they part the Master\'s shroud? They stumble fumble groping blind. Finding fate and chaos intertwined.','',26124),
(47482,'enUS','I\'ve sent my men forward on the rooftops to secure the area around Lord Walden.','',26124),
(47483,'enUS','Of course, somebody\'s going to have to take care of the small army between here and there.','',26124),
(47484,'enUS','Deathstalker Command Belmont grins.','',26124),
(47485,'enUS','Brothers in chaos, the Twilight has come! (Shadows lengthen, endless night.) Deathwing has sundered this world. (Doors once opened never close.) So that its true Lords may return. (The Master comes, He comes He comes.)','',26124),
(47486,'enUS','The time has come, soldiers! Godfrey lies just ahead! Have no mercy! We fight-','',26124),
(47487,'enUS','FOR THE HORDE!!!','',26124),
(47488,'enUS','Mortals, you merely separate the wheat from the chaff. (Unworthy, unworthy).','',26124),
(47489,'enUS','You\'d better hurry up if you want in on all the fun.','',26124),
(47490,'enUS','Heed His call! Cast down the heretics!','',26124),
(47491,'enUS','Aaagh! Curse you! I\'ll be back up in a minute, just you watch!','',26124),
(47492,'enUS','Go away, kid, you\'re botherin\' me!','',26124),
(47493,'enUS','Follow me, $n, and I\'ll introduce you to your trainer, Alamar Grimm.','Follow me, $n, and I\'ll introduce you to your trainer, Alamar Grimm.',26124),
(47494,'enUS','Alamar, I\'d  like to introduce you to $n, a recent escapee from Gnomeregan.','Alamar, I\'d  like to introduce you to $n, a recent escapee from Gnomeregan.',26124),
(47495,'enUS','','I am well aware that the demonic presence in this forest can be considered the fault of my kind.$B$BI am also not the first Highborne to attempt to make amends for this, and I thank the Emerald Circle for being pragmatic enough to allow my help.',26124),
(47496,'enUS','You are His chosen ones. (He calls you, He knows you). Born of flesh- (flesh) purified by blood- (blood) destined for immortality!','',26124),
(47497,'enUS','Brothers of the Hammer, to me! (Their will is still their own.) The unbelievers still stand. Destroy them! (Crush their bodies, crush their will.)','',26124),
(47498,'enUS','This is... worse... than death...','',26124),
(47499,'enUS','Ugh!  Why are you WET!?','',26124),
(47500,'enUS','Why is the door shut? What in Sylvanas\' name is going on here...','',26124),
(47501,'enUS','Light... fading... dying?  No, just sleeping...','',26124),
(47502,'enUS','Cromush! What happened?','',26124),
(47503,'enUS','The Earthen Ring have set up portals to various regions of the world on a small lake islet northwest of Stormwind Keep.\n\nThere are representatives from the Baradin Wardens there as well, offering transport to Tol Barad.','The Earthen Ring have set up portals to various regions of the world on a small lake islet northwest of Stormwind Keep.\n\nThere are representatives from the Baradin Wardens there as well, offering transport to Tol Barad.',26124),
(47504,'enUS','The coward...killed them...poisoned...me...','',26124),
(47505,'enUS','','Do not let prejudice or ancient grudges interfere with our mission here, Kaldorei. There will be plenty of time for squabbling and distrustful looks when we are done here.',26124),
(47506,'enUS','Where... did... he... come from...','',26124),
(47507,'enUS','Other Continents','Other Continents',26124),
(47508,'enUS','You\'ll pay for this Godfrey!','',26124),
(47509,'enUS','But... but...','',26124),
(47510,'enUS','That\'s... one... giant... keester...','',26124),
(47511,'enUS','Heroes, you must kill Godfrey! I\'ll make sure nothing interferes!','',26124),
(47512,'enUS','Why did it have to be... a smelly ogre...','',26124),
(47513,'enUS','The Earthen Ring have set up portals to various regions of the world on the cliffs north of the zeppelin towers.\n\nThere are representatives from Hellscream\'s Reach there as well, offering transport to Tol Barad.','The Earthen Ring have set up portals to various regions of the world on the cliffs north of the zeppelin towers.\n\nThere are representatives from Hellscream\'s Reach there as well, offering transport to Tol Barad.',26124),
(47514,'enUS','I can\'t feel my legs...','',26124),
(47515,'enUS','A trio of ethereal technomancers has set up shop in Orgrimmar, along the eastern Drag.\n\nLook for the weird machinery and purple lights... you can\'t miss it.\n\nThey offer just the sort of services you\'re looking for.','A trio of ethereal technomancers has set up shop in Orgrimmar, along the eastern Drag.\n\nLook for the weird machinery and purple lights... you can\'t miss it.\n\nThey offer just the sort of services you\'re looking for.',26124),
(47516,'enUS','Follow me, $n, and I\'ll introduce you to your trainer, Drill Sergeant Steamcrank.','Follow me, $n, and I\'ll introduce you to your trainer, Drill Sergeant Steamcrank.',26124),
(47517,'enUS','Sergeant, allow me to introduce $n, who helped us rescue survivors in Gnomeregan.','Sergeant, allow me to introduce $n, who helped us rescue survivors in Gnomeregan.',26124),
(47518,'enUS','Valiona, Theralion, put them in their place.','',26124),
(47519,'enUS','Follow me, $n, and I\'ll introduce you to your trainer, Kelsey Steelspark.','Follow me, $n, and I\'ll introduce you to your trainer, Kelsey Steelspark.',26124),
(47520,'enUS','Kelsey, allow me to introduce $n, who helped us rescue survivors in Gnomeregan.','Kelsey, allow me to introduce $n, who helped us rescue survivors in Gnomeregan.',26124),
(47521,'enUS','The master was clearly speaking to you, Valiona. I am far too busy to attack ANYONE.','',26124),
(47522,'enUS','How dare you call me worthless! You will see why I am mother\'s favored child!','',26124),
(47523,'enUS','Do as the master commands, Theralion! Kill them!','',26124),
(47524,'enUS','You are worthless, Theralion!','',26124),
(47525,'enUS','Here, I stealed this from little dwarf.','',26124),
(47526,'enUS','He will be sleepy for a while.  Lunk know.  Lunk do before.','',26124),
(47527,'enUS','Here, you can have dwarf\'s things.','',26124),
(47528,'enUS','You take dwarf\'s things.  No need to kill.','',26124),
(47529,'enUS','Sitting easier than killing.','',26124),
(47530,'enUS','Here you go.','',26124),
(47531,'enUS','Follow me, $n, and I\'ll introduce you to your trainer, Bipsi Frostflinger.','Follow me, $n, and I\'ll introduce you to your trainer, Bipsi Frostflinger',26124),
(47532,'enUS','Bipsi, this is $n, one of the most recent survivors to emerge from Gnomeregan.','Bipsi, this is $n, one of the most recent survivors to emerge from Gnomeregan.',26124),
(47533,'enUS','Follow me, $n, and I\'ll introduce you to your trainer, \"Doc\" Cogspin.','Follow me, $n, and I\'ll introduce you to your trainer, \"Doc\" Cogspin.',26124),
(47534,'enUS','Doc, this is $n, who helped Nevin\'s team get a number of survivors out of Gnomeregan.','Doc, this is $n, who helped Nevin\'s team get a number of survivors out of Gnomeregan.',26124),
(47535,'enUS','Let me out of here! It smells like ELVES!','',26124),
(47536,'enUS','Niby sold me out! HE SOLD ME OUT!','',26124),
(47537,'enUS','You can\'t do this! I have my own soul shard!','',26124),
(47538,'enUS','(Come closer, closer.  Let us see your faces. All will be humbled before his power.)','',26124),
(47539,'enUS','Do you HAVE to flail around like such an idiot?!','',26124),
(47540,'enUS','It burns in here! Wait, that\'s just my feet.','',26124),
(47541,'enUS','Let me out and I\'ll give you three wishes! I swear!','',26124),
(47542,'enUS','Nine, nine, NINE! Vhat could be so hard to undershtand?!','',26124),
(47543,'enUS','Zhe secrets of zhe obelisks vhill soon be mine!','',26124),
(47544,'enUS','Helix attaches a bomb to $n\'s chest!','',26124),
(47545,'enUS','Zhe coffer of promise is nearly vizhin my reach!','',26124),
(47546,'enUS','Zhe treasure is piling up nicely... soon, zhere vill be no shtoppink me!','',26124),
(47547,'enUS','Zhis whole cataclysm zhing has really vorked out in my favor.','',26124),
(47548,'enUS','%s senses $n\'s cowardice and unleashes a blast of lightning!','',26124),
(47549,'enUS','The wind abruptly shifts direction at %s\' command!','',26124),
(47550,'enUS','Right in the face! Ow ow ow...','',26124),
(47551,'enUS','Catch Impsy in the sack!','',26124),
(47552,'enUS','Zhe shtatues! Zhey\'re aliiive!','',26124),
(47553,'enUS','What are you talking about, goblin?! Speak!!','',26124),
(47554,'enUS','I\'ll talk, I\'ll talk! Anything! Just keep that perfumed bag away from me!','',26124),
(47555,'enUS','<The Mullan Gryphon Rider stays still, eyes locked forward, not acknowledging your presence.>','<The Mullan Gryphon Rider stays still, eyes locked forward, not acknowledging your presence.>',26124),
(47556,'enUS','Not backing out, are you?','Not backing out, are you?',26124),
(47557,'enUS','Them\'s DEFINITELY fightin\' words!','Them\'s DEFINITELY fightin\' words!',26124),
(47558,'enUS','Hide your vives! Hide your children! Zhey\'re killink everyvone up in he\'ah!','',26124),
(47559,'enUS','Zhey\'re runnink around killink everyzhink! Shtompink! Like zhis!!','',26124),
(47560,'enUS','Off course, sir! At Vonce!','',26124),
(47561,'enUS','Seek out The Reliquary in the Royal Exchange; doubtless one of that organization\'s many archaeologists will be there and can likely assist you.','Seek out The Reliquary in the Royal Exchange; doubtless one of that organization\'s many archaeologists will be there and can likely assist you.',26124),
(47562,'enUS','What are you waiting for? Get out there and stop them!','',26124),
(47563,'enUS','Fine! Fine. You win this one.','Fine! Fine. You win this one.',26124),
(47564,'enUS','','Only the highest-ranking members of The Reliquary know where our order\'s Grand Vault is located.$B$BSome say it is not even upon this plane of existence...',26124),
(47565,'enUS','Duglas send you over to get roughed up?','Duglas send you over to get roughed up?',26124),
(47566,'enUS','Lookin\' to scrap?','Lookin\' to scrap?',26124),
(47567,'enUS','You look like you want a piece of me...','You look like you want a piece of me...',26124),
(47568,'enUS','Lookin\' for some punishment?','Lookin\' for some punishment?',26124),
(47569,'enUS','History? Culture? Tch. Such is the realm of scholars and scribes.$B$BWe of The Reliquary concern ourselves with... the immediate, and perhaps the future.$B$BWe discover, acquire, and amass lost artifacts, wealth, and lore so that it cannot be used against us. Power does, after all, belong in the hands of those who would use it best... wouldn\'t you agree?','',26124),
(47570,'enUS','Hide your vives! Hide your children! H-h-hide you husbands!! Zhey\'re killink everyvone up in he\'ah!','',26124),
(47571,'enUS','$n, you gonna save us from those pirates, or what?!','',26124),
(47572,'enUS','','May I suggest that you save us from the pirates, my dear $n?!',26124),
(47573,'enUS','I didn\'t need him! Not when I\'ve got YOU oafs!','',26124),
(47574,'enUS','Only ten copper? You\'re not even worth killing!','',26124),
(47575,'enUS','The scales...have...tipped...','',26124),
(47576,'enUS','Gimme some more of that swim tonic!','Gimme some more of that swim tonic!',26124),
(47577,'enUS','You want Master Hossack. He in south part of Mage District, inner ring.','You want Master Hossack. He in south part of Mage District, inner ring.',26124),
(47578,'enUS','Extricating','Extricating',26124),
(47579,'enUS','You\'ll want to find Adam Hossack. He\'s got an office in the southern Mage Quarter along the inner ring.$B$BIf he\'s not out exploring, he\'ll likely be there.','You\'ll want to find Adam Hossack. He\'s got an office in the southern Mage Quarter along the inner ring.$B$BIf he\'s not out exploring, he\'ll likely be there.',26124),
(47580,'enUS','There\'s always something new to investigate.','',26124),
(47581,'enUS','','Be quick about it.',26124),
(47582,'enUS','Nothing can stop the wrath of the Banshee Queen.','',26124),
(47583,'enUS','The Bloodfang will prevail.','',26124),
(47584,'enUS','Time to expand my ice cream empire.$B$BTigule and Foror are going down!','',26124),
(47585,'enUS','Welcome, mortals. (Frail little children). Few have laid eyes on this inner sanctum. (They reach out to touch the fire!)','',26124),
(47586,'enUS','','Do you see me now, Cho\'gall? I\'m coming for you! I\'m going to rip off your head while the other watches!',26124),
(47587,'enUS','It is here the chosen realize their destiny. (One with eternity). And it is here that you will realize yours.(End of the flesh. End of the flesh)!','',26124),
(47588,'enUS','Brothers of Twilight! The Hammer calls to you! (Fire water earth air). Leave your mortal shell behind. (Fire water earth air). Embrace your new forms for here and everafter! (Burn and drown and crush and suffocate). And use your gifts to destroy the unbelievers. (Burn and drown and crush and suffocate)!!','',26124),
(47589,'enUS','Remain steady always.','',26124),
(47590,'enUS','','For Sylvanas!',26124),
(47591,'enUS','Foolish mortals-(Usurper\'s children!) nothing you have done- (Spawn of a lesser god!) I am TRYING to speak here. (Words, words, words. The Master wants murder.) ALL falls to chaos. ALL will be destroyed. (Chaos, chaos!) Your work here today changes nothing. (Chaos, chaos, all things end) No mortal may see what you have and live. Your end has come.','',26124),
(47592,'enUS','These notes are horribly organized. I can\'t tell if Arugal was brilliant or simply an imbecile.','',26124),
(47593,'enUS','I must give Arugal some credit, his lines of research were quite novel.','',26124),
(47594,'enUS','Missing pages, broken equipment, tainted samples! How does someone work in these conditions!','',26124),
(47595,'enUS','This library should prove to be useful to my own research.','',26124),
(47596,'enUS','Foe Reaper 5000 on-line.  All systems nominal.','',26124),
(47597,'enUS','Places like Uldaman hold secrets as to the mysteries of my people\'s past!','',26124),
(47598,'enUS','Slay the Idra\'kess Mistresses to destroy the shield!','',26124),
(47599,'enUS','Nespirah is waking up! Use the Nespirah Fluid to kill Idra\'kess.','',26124),
(47600,'enUS','Dedlow Wormwood\'s the corpse you want. He\'s usually around the south end of town.','Dedlow Wormwood\'s the corpse you want. He\'s usually around the south end of town.',26124),
(47601,'enUS','Brill\'s only chef is in the middle of town.$B$BWe don\'t know why he\'s out there; he won\'t sell anything he makes. We also don\'t know where he\'s getting that fresh raw meat.$B$BWell, no matter. Good luck.','Brill\'s only chef is in the middle of town.$B$BWe don\'t know why he\'s out there; he won\'t sell anything he makes. We also don\'t know where he\'s getting that fresh raw meat.$B$BWell, no matter. Good luck.',26124),
(47602,'enUS','Ice cream, Brivelthwerp. I need ice cream!','Ice cream, Brivelthwerp. I need ice cream!',26124),
(47603,'enUS','%s slumps forward, exposing his pincers!','',26124),
(47604,'enUS','A little busy here, $c.  What d\'ye want?','',26124),
(47605,'enUS','Can I help ye with somethin\'?','',26124),
(47606,'enUS','Aye.','',26124),
(47607,'enUS','Care to join our dance?','Care to join our dance?',26124),
(47608,'enUS','Attack and Weaken the Black Drake!','',26124),
(47609,'enUS','Overdrive engine activated.','',26124),
(47610,'enUS','You\'re the last of your tribe with any sense left.  As a reward for giving us Prince Nadun, I grant you the gift that is your birthright and more!','',26124),
(47611,'enUS','Your makers failed you... your flawed race succumbed to the curse of flesh!  Lord Deathwing\'s gift makes you perfect again!','',26124),
(47612,'enUS','Flap Your Wings Rapidly to Re-Gain Altitude!','',26124),
(47613,'enUS','This orc is severely injured.','This orc is severely injured.',26124),
(47614,'enUS','End the orc\'s misery.','End the orc\'s misery.',26124),
(47615,'enUS','Pardon me, friend, but I\'m busier than it might appear.$b$bI\'ve been commissioned to document the discoveries of the commander in this region, you see.$b$bThey\'re certain to be most profound!','',26124),
(47616,'enUS','I\'m working on a biographical piece for Commander Schnottz, among other things.$b$bYou\'ll have to excuse me.','',26124),
(47617,'enUS','I bestow upon you the power that is our birthright... and more!','',26124),
(47618,'enUS','And with the powers of the South Wind, we will reclaim this city and seal it from those who would trespass upon our territory!','',26124),
(47619,'enUS','There is fight left in me yet, scum.','There is fight left in me yet, scum.',26124),
(47620,'enUS','Help the injured orc up.','Help the injured orc up.',26124),
(47621,'enUS','I supply the Krom\'gar army with equipment.','',26124),
(47622,'enUS','Show me your wares, quartermaster.','Show me your wares, quartermaster.',26124),
(47623,'enUS','','Smells like... gold!',26124),
(47624,'enUS','|TInterface\\Icons\\spell_fire_twilightnova.blp:20|t%s casts |cFFFF0000|Hspell:86788|h[Blackout]|h|r!','',26124),
(47625,'enUS','','I saw them loading a shipment of artifacts onto the boats the other day.$b$bIt was the most gold I\'ve ever seen in one place!',26124),
(47626,'enUS','Years ago, I was trapped here while trying to study the wind riders. But once I made my way to freedom, I resolved to return and protect them.$B$BNow the Cataclysm has struck and the Twilight\'s Hammer is capturing all of these sacred creatures, or worse, destroying them.','',26124),
(47627,'enUS','I care little about the wars between the Horde and the Alliance. What matters is that we save the sacred wind riders of Highperch.$B$BIf not for their sake, then at least to keep them from falling into the hands of the Twilight\'s Hammer, $r.','',26124),
(47628,'enUS','Acquiring target...','',26124),
(47629,'enUS','Target acquired.  Harvesting servos engaged.','',26124),
(47630,'enUS','Target destroyed.','',26124),
(47631,'enUS','I\'m ready to take the flight into the Cauldron!','I\'m ready to take the flight into the Cauldron!',26124),
(47632,'enUS','Who are you?','Who are you?',26124),
(47633,'enUS','Get out of here, before the slavers see you!','Get out of here, before the slavers see you!',26124),
(47634,'enUS','Are you... here to save me?','Are you... here to save me?',26124),
(47635,'enUS','Come on, let\'s get out of here!','Come on, let\'s get out of here!',26124),
(47636,'enUS','Never!  I love working for the Dark Iron!','Never!  I love working for the Dark Iron!',26124),
(47637,'enUS','Intruder!  The intruder is trying to save me!','Intruder!  The intruder is trying to save me!',26124),
(47638,'enUS','I\'ll never leave!  I wouldn\'t know what to do outside!','I\'ll never leave!  I wouldn\'t know what to do outside!',26124),
(47639,'enUS','I knew the Thorium Brotherhood would come through!','I knew the Thorium Brotherhood would come through!',26124),
(47640,'enUS','Oh, thank you!  Thank you!','Oh, thank you!  Thank you!',26124),
(47641,'enUS','It\'s about time!  I\'m sick of being a slave!','It\'s about time!  I\'m sick of being a slave!',26124),
(47642,'enUS','Safety restrictions off-line.  Catastrophic system failure imminent.','',26124),
(47643,'enUS','Overheat threshold exceeded.  System failure.  Wheat clog in port two.  Shutting down.','',26124),
(47644,'enUS','Grab a Lance from the Racks','',26124),
(47645,'enUS','Equip the Lance','',26124),
(47646,'enUS','Mount One of Aviana\'s Guardians','',26124),
(47647,'enUS','You are here to stop the Archduke?','',26124),
(47648,'enUS','Let\'s do this!  Let\'s take out Maltorius and Arkkus!','Let\'s do this!  Let\'s take out Maltorius and Arkkus!',26124),
(47649,'enUS','Now ye\'re talkin\'!  I\'ll take the Twilight guy.  You focus on the little dwarf.','',26124),
(47650,'enUS','Hang tight, $n.  We gotta wait for Maltorius and Arkkus to come back before we can fight \'em.','',26124),
(47651,'enUS','Pitiful meat bags! Feel the full force of the Dragonmaw!','',26124),
(47652,'enUS','Perhaps ye filthy animals would like another taste o the dirt!','',26124),
(47653,'enUS','Now that\'s what ye call heavy hands!','',26124),
(47654,'enUS','%s is weakened!  Banish him now!','',26124),
(47655,'enUS','Heartrazor bellows his appreciation.','',26124),
(47656,'enUS','NOOOOOO!  THIS CANNOT BE!  I... AM... IMMORTAL...!','',26124),
(47657,'enUS','Fools!  You cannot defeat me!  I will only return again...','',26124),
(47658,'enUS','','Stand tall and proud, $n. Don\'t let any of these scrubs give you any trouble. Show them who\'s boss!',26124),
(47659,'enUS','','I see one coming now! Looks like a real winner. Keep it cool, $n. Keep it cool.',26124),
(47660,'enUS','HI! HI! HELP!','',26124),
(47661,'enUS','HI! I\'M NEW! BIG WHITE LIGHT CREATURE WITH WINGS MADE ME ALIVE! I SERVE THE BANSHEE QUEEN! YAY!$B$BHELP!$B$BHI!','',26124),
(47662,'enUS','Maybe you should go take a nap or something. I don\'t know if I have any work for you.','Maybe you should go take a nap or something. I don\'t know if I have any work for you.',26124),
(47663,'enUS','OK! THANKS! I\'LL JUST WAIT HERE WITH YOU! THANKS! OK!','',26124),
(47664,'enUS','Wait a minute. It looks like something just came up. Yes, right here on this sheet of paper. You need to head southeast to the Azurelode Mine and report to Captain Keyton. Southeast is that way *you point southeast*.','Wait a minute. It looks like something just came up. Yes, right here on this sheet of paper. You need to head southeast to the Azurelode Mine and report to Captain Keyton. Southeast is that way *you point southeast*.',26124),
(47665,'enUS','NORTH! GOT IT! THANKS! BYE! THANKS!','',26124),
(47666,'enUS','','These new Forsaken tend to be a little... um... stupid. It usually takes awhile for them to acclimate.',26124),
(47667,'enUS','','Oh great... not this one again. I know this orc. He\'s got no business being here, but since he\'s a bottom-feeding pansy he likes to hang around here and prey on the helpless. Don\'t let him bully you.',26124),
(47668,'enUS','CAN YOU SMELL WHAT THE LOK\'TAR IS COOKIN\'?!','',26124),
(47669,'enUS','HAH! Looks like you\'re running out of idiots to put atop this horse, Darthalia. This is the puniest one yet.','',26124),
(47670,'enUS','What have you got for me today, weakling?! Point me to where the Alliance hide and I shall DOMINATE THEM!','',26124),
(47671,'enUS','I will freeze the blood in your veins!','',26124),
(47672,'enUS','%s begins to cast Glaciate!','',26124),
(47673,'enUS','I have seen the fall of the Lich King. Creations of the titans have fallen before my mighty axe. When called upon, I alone spearheaded a victory for the Argent Crusade against the beasts of Northrend. Now, I come for the ultimate challenge. What does Hillsbrad Foothills have to offer Kingslayer Orkus???','',26124),
(47674,'enUS','Um... Apparently there is some trouble at Southshore. Something about worgen insurgents. Maybe you could help with them?','Um... Apparently there is some trouble at Southshore. Something about worgen insurgents. Maybe you could help with them?',26124),
(47675,'enUS','Insurgents you say? Is there any risk of death or dismemberment to me?','',26124),
(47676,'enUS','None.','None.',26124),
(47677,'enUS','Then Orkus WILL DO IT! YES!','',26124),
(47678,'enUS','Right, thanks. Just go ahead and head southeast. More south than east. Probably off the coast.','Right, thanks. Just go ahead and head southeast. More south than east. Probably off the coast.',26124),
(47679,'enUS','Yes, cowardly quest giver, sit atop your pale horse while Orkus brings glory to the Horde! I shall return with a thousand skulls!','',26124),
(47680,'enUS','','Here\'s to hoping he never returns. Maybe he\'ll drown?',26124),
(47681,'enUS','','Ah, crap. You\'re on your own with this one, $p.',26124),
(47682,'enUS','Johnny Awesome has arrived, philistine. Present me with your menial tasks so that I may complete them with only mild enthusiasm and most likely a complete disregard for any directions that you provide that are more complicated than what my map is able to display.','',26124),
(47683,'enUS','Look at me, peasant. Heirlooms cover my body from head to toe, gifted to me by the greatest heroes Azeroth has ever known.$B$BNow look at yourself.$B$BQuickly, look back at me.$B$BYes, this horse IS made of STARS.$B$BWhat pointless series of tasks befitting a mentally deficient orc have you prepared for me?','',26124),
(47684,'enUS','Well, we are having some problems at the Sludge Fields, located northeast of here. Warden Stillwater could use your help.','Well, we are having some problems at the Sludge Fields, located northeast of here. Warden Stillwater could use your help.',26124),
(47685,'enUS','Fine, fine, what else?','',26124),
(47686,'enUS','That\'s all.','That\'s all.',26124),
(47687,'enUS','That\'s all? One quest? Surely you jest. Are there not bear asses to collect? Perhaps a rare flower that I could pick from which you will make some mildly hallucinogenic tonic which you will then drink, resulting in visions of a great apocalypse? Perhaps the local populace of mildly annoying, ill-tempered gophers are acting up and need to be brought to justice? No? Nothing?','',26124),
(47688,'enUS','THAT\'S ALL, JOHNNY AWESOME. TAKE IT OR LEAVE IT!','THAT\'S ALL, JOHNNY AWESOME. TAKE IT OR LEAVE IT!',26124),
(47689,'enUS','I will do this ONE thing that you ask of me, quest giver. Pray I find more menial tasks to accomplish or you will be hearing from me again and I assure you that my commentary on forums of public opinion will be most unkind.','',26124),
(47690,'enUS','You dwarves are worthless!  You come to Ragnaros seeking ascendance, but you have nothing to offer!','',26124),
(47691,'enUS','Nothing to offer, except your backs and your shovels.  So you will dig.','',26124),
(47692,'enUS','Dig wide, dig deep.  Seek out the places of fire beneath the world.  My brothers and sisters yearn to be free.','',26124),
(47693,'enUS','Succeed, and you may ascend after all.  Fail, and burn.','',26124),
(47694,'enUS','Ever heard of the Thorium Brotherhood?  Sure, we might look a lot like those dwarves down in the gorge, or in Blackrock Depths, but trust me: we\'re not anything like them.$b$bThose scoundrels dug too deep, and now they serve a darker force: Ragnaros, the Firelord.  We\'re happy to be more independent of will and purpose, although most of the time our purpose ends up being the prevention of whatever trouble they\'re causing.','',26124),
(47695,'enUS','Think you could repair my gear, Burrian?','Think you could repair my gear, Burrian?',26124),
(47696,'enUS','Could you repair my gear, Argus?','Could you repair my gear, Argus?',26124),
(47697,'enUS','The Dark Irons in Blackrock have got nothin\' on me.  Neither do those boys up at Thorium Point.$b$bI\'m independent as can be, and that\'s the way I like it.  Of course, for the right price, I\'d listen to either side...','',26124),
(47698,'enUS','Why you do that?  Why you kill?','',26124),
(47699,'enUS','You stop killing now!  Lunk doesn\'t like!','',26124),
(47700,'enUS','No!  No kill!','',26124),
(47701,'enUS','You hurt Lunk\'s feelings when you kill.','',26124),
(47702,'enUS','Please, no kill when Lunk is around.','',26124),
(47703,'enUS','Oh no!  Why do you kill it?','',26124),
(47704,'enUS','You will suffer!  You will face the wrath of the Twilight\'s Hammer!','',26124),
(47705,'enUS','Only pain awaits you!','',26124),
(47706,'enUS','Die, creep!','',26124),
(47707,'enUS','It will be a pleasure shooting you down!','',26124),
(47708,'enUS','Useless wind rider! I don\'t need you anyway!','',26124),
(47709,'enUS','No flights out right now, $r. By order of Garrosh, these windriders are for military use only until the night elves are wiped out.','',26124),
(47710,'enUS','Let\'s see what this ember does... whaaaa?','',26124),
(47711,'enUS','No! Get away! Get off of me!','',26124),
(47712,'enUS','NOOOOOO!','',26124),
(47713,'enUS','Aaaaaiiiiiiiiiiiiii......!','',26124),
(47714,'enUS','What\'s this? Shoo!','',26124),
(47715,'enUS','BURN!','',26124),
(47716,'enUS','More fuel for the fire!','',26124),
(47717,'enUS','Perish!','',26124),
(47718,'enUS','Wind, hear my call!','',26124),
(47719,'enUS','%s begins to cast Thundershock!','',26124),
(47720,'enUS','Merely a whisper in the wind....','',26124),
(47721,'enUS','The soil welcomes your bones!','',26124),
(47722,'enUS','The earth will devour you!','',26124),
(47723,'enUS','%s begins to cast Quake!','',26124),
(47724,'enUS','You will die for your insolence!','',26124),
(47725,'enUS','You dare invade our lord\'s sanctum?','',26124),
(47726,'enUS','FEEL THE POWER!','',26124),
(47727,'enUS','The surrounding air crackles with energy....','',26124),
(47728,'enUS','The ground beneath you rumbles ominously....','',26124),
(47729,'enUS','Go forth, my beautiful angel! Ah, it is so very sad when one\'s children leave the nest, isn\'t it?','',26124),
(47730,'enUS','I guess it\'s time for a rebuilding phase...','',26124),
(47731,'enUS','What... my creation! It didn\'t even blot out the sky! I\'d better recheck my notes...','',26124),
(47732,'enUS','%s is reviled by your ugliness!','',26124),
(47733,'enUS','Eww! Get away from me, you nasty thing!','',26124),
(47734,'enUS','As you wish, Daddy!','',26124),
(47735,'enUS','Oh! Too full... oh no... ','',26124),
(47736,'enUS','It\'s time for your ultimate attack, my darling!','',26124),
(47737,'enUS','This Schnottz fellow is proving to be a wise investment.$b$bGood that I was insightful enough to get in on the ground floor.','',26124),
(47738,'enUS','Like father always said; it takes a shrewd mind, sharp instincts, and unfailing courage to become a successful investor.$b$bI must admit, I smelled this opportunity a mile away.','',26124),
(47739,'enUS','Don\'t forget to replace your main weapon!','',26124),
(47740,'enUS','Someone, or something, seems to have done in the Ambassador!','',26124),
(47741,'enUS','I dare say I\'ve had enough of this. Time to bring out... THE BEAST WITHIN!','',26124),
(47742,'enUS','Who could have done such a thing?','Who could have done such a thing?',26124),
(47743,'enUS','Who knows?$b$bHe was becoming quite critical of this operation, but that\'s not proof of anything.','',26124),
(47744,'enUS','Will you investigate the murder?','Will you investigate the murder?',26124),
(47745,'enUS','Who, me?$b$bWhy, I\'d hardly consider myself qualified to, uh... No, I should think not.','',26124),
(47746,'enUS','Well, you WILL at least write about it, won\'t you?','Well, you WILL at least write about it, won\'t you?',26124),
(47747,'enUS','Wh-what?! Well, I...$b$bIn this midst of such an exciting excavation, I\'m not certain it would be appropriate to focus on such a thing.$b$bIt would make for a most troubling story, you know.','',26124),
(47748,'enUS','','Don\'t - don\'t touch me...$b$bWhat\'s happening?!',26124),
(47749,'enUS','Just calm down. Are you alright?','Just calm down. Are you alright?',26124),
(47750,'enUS','','No! Of course I\'m not alright!$b$bI-I\'ve never seen an actual corpse before...',26124),
(47751,'enUS','Did you see what happened?','Did you see what happened?',26124),
(47752,'enUS','','He just came stumbing out of the barracks.$b$bI screamed for help, but the guards wouldn\'t even look at me!',26124),
(47753,'enUS','Maybe you should go lie down for a little while.','Maybe you should go lie down for a little while.',26124),
(47754,'enUS','','Yes.$b$bThat sounds like a good idea.',26124),
(47755,'enUS','Good lord! Manservants, aid your master!!','',26124),
(47756,'enUS','Enough toying around! It\'s time to get my hands dirty!','',26124),
(47757,'enUS','Grab a seat, chaps. Let me coach you on some true carnage!','',26124),
(47758,'enUS','Our men have secured the walkway. Focus on helping those in the main room.','Our men have secured the walkway. Focus on helping those in the main room.',26124),
(47759,'enUS','|TInterface\\Icons\\spell_shaman_staticshock.blp:20|t%s casts|cFF1CF2FE|Hspell:79888|h [Lightning Conductor]|h|r at |cFF1CF2FE$n|r!','',26124),
(47760,'enUS','I will burn you from the inside out!','',26124),
(47761,'enUS','An easy kill!','',26124),
(47762,'enUS','You should have come better prepared!','',26124),
(47763,'enUS','Hold On!','Hold On!',26124),
(47764,'enUS','Valiona, finish them! Avenge me!','',26124),
(47765,'enUS','INCINERATE THEM, MINIONS!','',26124),
(47766,'enUS','BY FIRE BE... BURNED!','',26124),
(47767,'enUS','Dragon, you will do as I command! Catch me!','',26124),
(47768,'enUS','I will not die for you, Drahga.','',26124),
(47769,'enUS','If they do not kill you, I will do it myself!','',26124),
(47770,'enUS','The darkest days are still ahead!','',26124),
(47771,'enUS','Ahahaha!','',26124),
(47772,'enUS','Flesh for the offering.','',26124),
(47773,'enUS','Ywaq maq oou; ywaq maq ssaggh. Ywaq ma shg\'fhn.','',26124),
(47774,'enUS','F\'lakh ghet! The shadow\'s hunger cannot be sated!','',26124),
(47775,'enUS','This cannon appears to be pointed directly at the shore, with a fresh charge of powder and fuse already set.$B$BHow convenient!','',26124),
(47776,'enUS','I\'ll get in and fire it! What could go wrong?','I\'ll get in and fire it! What could go wrong?',26124),
(47777,'enUS','NO! Throngus get whipped again if he no finish!','',26124),
(47778,'enUS','Throngus use your corpse on body. Somewhere...','',26124),
(47779,'enUS','You break easy!','',26124),
(47780,'enUS','Death... Good choice. Not best choice maybe, but better than fail and live.','',26124),
(47781,'enUS','You not get through defenses!','',26124),
(47782,'enUS','Oh, this gonna HURT!','',26124),
(47783,'enUS','Throngus SLICE you up!','',26124),
(47784,'enUS','A million more await my orders. What chance do you have?','',26124),
(47785,'enUS','Vermin, your dinner awaits!','',26124),
(47786,'enUS','Messy...','',26124),
(47787,'enUS','Clear the terrace for landing!  Shoot at Cauldron Defenders!','',26124),
(47788,'enUS','Newt, you\'re up! Break out the gatestone!','',26124),
(47789,'enUS','Have you come for training, hunter?','Have you come for training, hunter?',26124),
(47790,'enUS','','You got it boss. Er... where do I put it?',26124),
(47791,'enUS','You put it right in the... wait... where\'s the keyhole? What kind of racket is this?','',26124),
(47792,'enUS','Screw it. Ticker, you\'re up!','',26124),
(47793,'enUS','Right away, boss!','',26124),
(47794,'enUS','I can\'t believe that we\'re doing this.  I know that Calcinder\'s presence threatens us all, but really?  Doesn\'t this seem like the domain of the Earthen Ring, or something?$b$bWhy\'s the Thorium Brotherhood gotta come save the day all the time?','',26124),
(47795,'enUS','Charges are set. Might want to get clear!','',26124),
(47796,'enUS','Death is my only option.','',26124),
(47797,'enUS','Like a  charm. Who needs a key anyway...','',26124),
(47798,'enUS','All in my path shall be destroyed!','',26124),
(47799,'enUS','Attack you cowardly vermin!','',26124),
(47800,'enUS','%s retracts her cyclone shield!','',26124),
(47801,'enUS','Welcome to Thorium Point.  As Overseer, I\'m responsible for all the activities of the Thorium Brotherhood.  While that mainly involves mining, smithing, and some minor guard duty, we\'ve lately become more of a martial organization... out of necessity.','',26124),
(47802,'enUS','We\'ve made it this far into the Slag Pit, $n.  Now it\'s time to finish the job.','',26124),
(47803,'enUS','You\'re welcome among us anytime, $n.','',26124),
(47804,'enUS','%s conjures a temporary grounding field!','',26124),
(47805,'enUS','Fools.  Obsidion!  Rise, and destroy the interlopers!','',26124),
(47806,'enUS','The Exodar has not answered my pleas, $n. I am afraid you are the only one who can help poor Magtoor.','',26124),
(47807,'enUS','I will continue my research in memory of Magtoor.','',26124),
(47808,'enUS','Is there anything we can do to help?','Is there anything we can do to help?',26124),
(47809,'enUS','Is there anything my troops or I can do?','Is there anything my troops or I can do?',26124),
(47810,'enUS','Are you sure there is nothing more we can do Neeka?','Are you sure there is nothing more we can do Neeka?',26124),
(47811,'enUS','Is there nothing we can do for Helgrum?','Is there nothing we can do for Helgrum?',26124),
(47812,'enUS','Stand your posts and keep any Alliance filth from us.','Stand your posts and keep any Alliance filth from us.',26124),
(47813,'enUS','Stand your ground and keep alert for any Alliance that may try to attack.','Stand your ground and keep alert for any Alliance that may try to attack.',26124),
(47814,'enUS','Watch for any more Alliance.  We will make them suffer should they try to attack again.','Watch for any more Alliance.  We will make them suffer should they try to attack again.',26124),
(47815,'enUS','Make sure you are all on guard for any more Alliance attacks.','Make sure you are all on guard for any more Alliance attacks.',26124),
(47816,'enUS','Hee hee... hee hee hee... ha ha ha!','',26124),
(47817,'enUS','Shh! They can hear you, dummy!','',26124),
(47818,'enUS','Don\'t call me dummy, dummy!','',26124),
(47819,'enUS','Ow! Now they can see us!','',26124),
(47820,'enUS','Run!','',26124),
(47821,'enUS','That\'s right, beast. You belong to the Dragonmaw now.','',26124),
(47822,'enUS','And if you don\'t obey, we\'re cutting you up for parts. ','',26124),
(47823,'enUS','','Impressive. Complete domination of the animal while it\'s weakened.',26124),
(47824,'enUS','','Tell me, what is this charm you\'re using?',26124),
(47825,'enUS','The Demon Chain. It projects our will like a physical force.','',26124),
(47826,'enUS','The Horde? I SPIT on your Horde! Our enemies are weak and splintered, yet you bargain with Hellscream? Dragonmaw stand alone!','',26124),
(47827,'enUS','I will prove it to you. I will strike the Wildhammer at Thundermar.','',26124),
(47828,'enUS','When I return victorious, we will see who the Dragonmaw call \"Warchief\".','',26124),
(47829,'enUS','How did you get here?  I will destroy you!','',26124),
(47830,'enUS','','With your wing of drake riders and the support of the Horde, we can make an assault on the Bastion of Twilight.',26124),
(47831,'enUS','','Another treasonous word and I will put you in your place, Narkrall.',26124),
(47832,'enUS','','Narkrall! If you want to challenge me, you do so here. Do NOT squander our forces on a fool crusade.',26124),
(47833,'enUS','','I owe you a great deal for my freedom, $n.$B$BNow, let us see if we can free Magatha and put an end to the Twilight\'s Hammer in Thousand Needles.',26124),
(47834,'enUS','','Hi there. All clear down here.',26124),
(47835,'enUS','BEES! Jump in water to get them off!','BEES! Jump in water to get them off!',26124),
(47836,'enUS','Face me, $r, and know the legion\'s wrath!','',26124),
(47837,'enUS','These worgen are our prisoners. Their fate is in the hands of High Command.','',26124),
(47842,'enUS','Hop on to the drake!','',26124),
(47843,'enUS','What do you want, scrub? Get out of my face before I knock that grin off of yours with my hammer!','',26124),
(47844,'enUS','','I will use the crying violet to bind our words... our voices will be carried to you even in the deepest reaches of Jaedenar and Shadow Hold.',26124),
(47845,'enUS','No pathetic $r will deny me my birthright!','',26124),
(47846,'enUS','How can I help you, $g handsome : gorgeous;?','',26124),
(47847,'enUS','What is it? I\'m very busy, defender.','',26124),
(47848,'enUS','The dragons have bought us an opportunity to sieze the gates from the Twilight\'s Hammer. We would do well not to waste it.','',26124),
(47849,'enUS','I\'m ready to press up the canyon. Is the Gob Squad prepped?','I\'m ready to press up the canyon. Is the Gob Squad prepped?',26124),
(47850,'enUS','They\'ve been waiting on you, $c.','',26124),
(47851,'enUS','(Blood for the master!)','',26124),
(47852,'enUS','Such is your fate.','',26124),
(47853,'enUS','Pathetic flesh!','',26124),
(47854,'enUS','(Finish it! Finish them all!)','',26124),
(47855,'enUS','Embrace your end.','',26124),
(47856,'enUS','Give me your strength!','',26124),
(47857,'enUS','Behold the might of the hammer!','',26124),
(47858,'enUS','(Stop. Hammertime!)','',26124),
(47859,'enUS','Enough! (To His will all flesh succumbs. From His kingdom, chaos comes.) Yes - what he said.','',26124),
(47860,'enUS','(Infinite suffering!)','',26124),
(47861,'enUS','(*Snort*)','',26124),
(47862,'enUS','Behold the destiny of your fragile world!','',26124),
(47863,'enUS','More. More!','',26124),
(47864,'enUS','(Come, brothers! Feast on hope!)','',26124),
(47865,'enUS','There\'s another one! Kill the $r!','Get away from there, $r scum!',26124),
(47866,'enUS','(More. They need more.)','',26124),
(47867,'enUS','The Alliance ... they\'re defending the Wildhammer... ','',26124),
(47868,'enUS','Brother, it cannot be... (Destiny has come!) My strength... (Too proud! He speaks in blood! Listen!) My mind... (It is for His glory we serve!) What... is happening... (Gone is the dawn. Come shades of Twilight. Come madness, come havoc, come Infinite Night!)','',26124),
(47869,'enUS','Squad reporting.','',26124),
(47870,'enUS','In the gut!','',26124),
(47871,'enUS','Messy...','',26124),
(47872,'enUS','You want some of this?!','',26124),
(47873,'enUS','Bring it on!','',26124),
(47874,'enUS','Thank you. I will not forget.','Thank you. I will not forget.',26124),
(47875,'enUS','Good luck to you. I\'m grateful.','Good luck to you. I\'m grateful.',26124),
(47876,'enUS','Are you here for the Elder Crone, Magatha Grimtotem? They\'re holding her to the east.','Are you here for the Elder Crone, Magatha Grimtotem? They\'re holding her to the east.',26124),
(47877,'enUS','These cultists are insane. They\'re trying to bring about the end of the world!','These cultists are insane. They\'re trying to bring about the end of the world!',26124),
(47878,'enUS','They were going to sacrifice me to summon more of their elementals!','They were going to sacrifice me to summon more of their elementals!',26124),
(47879,'enUS','Get some vengeance for me.','Get some vengeance for me.',26124),
(47880,'enUS','I overheard them talking. They\'re getting ready to summon up something big at their base to the east!','I overheard them talking. They\'re getting ready to summon up something big at their base to the east!',26124),
(47881,'enUS','There\'s been too much death. Too much destruction. Put an end to them!','There\'s been too much death. Too much destruction. Put an end to them!',26124),
(47882,'enUS','(Body and soul, to be swallowed whole!)','',26124),
(47883,'enUS','Everyone succumbs in the end.','',26124),
(47884,'enUS','(Now they see the darkness! Their eyes are open!)','',26124),
(47885,'enUS','Now the Master has them.','',26124),
(47886,'enUS','(Chaos, madness! Like a hug for your brain.)','',26124),
(47887,'enUS','','Nothing new here.',26124),
(47888,'enUS','','Yep, still good.',26124),
(47889,'enUS','','We\'re fine. We\'re all fine here now, thank you. How are you?',26124),
(47890,'enUS','What a pleasure, $c.$b$bWe get so few visitors these days.','',26124),
(47891,'enUS','What a surprise!$b$bWe weren\'t expecting anyone today...','',26124),
(47892,'enUS','It is finished. (The fate of all.)','',26124),
(47893,'enUS',' Brother, we are shattered. (But the Master... I still hear... so angry... Master...?)','',26124),
(47894,'enUS','Brother, we are shattered. Let her finish them. (The Master does not want them near her... Brother?  The Master seethes...)','',26124),
(47895,'enUS','So, zhis is zhe $r $c I\'ve heard so much about, hmm?$b$bAs you know, zhere is vone obelisk zhat has yet to be activated....$b$bVhen zhe time comes to restore zhis ancient mechanism, vhill you be zhere? Vill history remember you?$b$bZhat depends on your villingness to cooperate!','',26124),
(47896,'enUS','','I am new to the burdens of leadership. I should\'ve seen Narkrall\'s insubordination coming. Instead I am cleaning up his mess.$B$BI don\'t know how Garrosh Hellscream does it. He must possess great strength to hold together a force as diverse as the Horde... I should like to know him more.',26124),
(47897,'enUS','|TInterface\\Icons\\spell_shadow_shadesofdarkness.blp:20|t%s begins to summon |cFFFF0000Darkened Creations|r to aid him!\n','',26124),
(47898,'enUS','The Vortex Pinnacle, a level 82-84 dungeon in Uldum, is now available for initial testing. The dungeon is a work in progress. Please be in your full group before teleporting to the dungeon.\n\nTo leave the Vortex Pinnacle, you must teleport out with a Hearthstone or similar method. If you die and release, you should teleport back from this NPC.','',26124),
(47899,'enUS','(The claws of fate grasp the unbelievers!)','',26124),
(47900,'enUS','(The Master sees, the Master sees!)','',26124),
(47901,'enUS','What madness have we wrought? (Not yet enough!)','',26124),
(47902,'enUS',' I...  can\'t take much more... (Brother, it merely begins!)','',26124),
(47903,'enUS','(The Master\'s eye sees all that was and all to be, or not!)','',26124),
(47904,'enUS','I\'m in my group and ready to teleport to the Vortex Pinnacle!','I\'m in my group and ready to teleport to the Vortex Pinnacle!',26124),
(47905,'enUS','Take me back to the Vortex Pinnacle!','Take me back to the Vortex Pinnacle!',26124),
(47906,'enUS','The dragons have bought us an opportunity to seize the gates from the Twilight\'s Hammer. We would do well not to waste it.','',26124),
(47907,'enUS','I\'m ready to press up the canyon. Is the squad prepped?','I\'m ready to press up the canyon. Is the squad prepped?',26124),
(47908,'enUS','Bare your soul to me, mortal.','',26124),
(47909,'enUS','They\'re already assembled. I\'m trusting you to secure the route to Grim Batol. Don\'t let me down.','',26124),
(47910,'enUS','I knew I should have stayed out of this...','',26124),
(47911,'enUS','You are not the boss of me, Valiona! I will engulf as I please!','',26124),
(47912,'enUS','There is no escape from the fury of the twilight flight!','',26124),
(47913,'enUS','WRITHE IN AGONY!','',26124),
(47914,'enUS','Do you feel that chill running up your spine?','',26124),
(47915,'enUS','The fog is rolling in...','',26124),
(47916,'enUS','My suffering is at an end, $r. But yours has just begun!','',26124),
(47917,'enUS','','Here he comes, $n! Beat him down while I dominate him with the Demon Chain.',26124),
(47918,'enUS','','Keep fighting, $c! The Demon Chain will eventually win out.',26124),
(47919,'enUS','Purge of unauthorized entities commencing.','',26124),
(47920,'enUS','Omega Stance activated. Annihilation of foreign unit is now imminent.','',26124),
(47921,'enUS','Target annihilated.','',26124),
(47922,'enUS','Purge complete.','',26124),
(47923,'enUS','Anraphet unit shutting down...','',26124),
(47924,'enUS','Electron unit activated.','',26124),
(47925,'enUS','Magmatron unit activated.','',26124),
(47926,'enUS','Toxitron unit activated.','',26124),
(47927,'enUS','Arcanotron unit activated.','',26124),
(47928,'enUS','Electron unit shield systems online.','',26124),
(47929,'enUS','Magmatron unit shield systems online.','',26124),
(47930,'enUS','Arcanotron unit shield systems online.','',26124),
(47931,'enUS','Rerouting excess energy to Magmatron unit. Engage flamethrower device.','',26124),
(47932,'enUS','Intruders detected. Primary defense matrix initiated.','',26124),
(47933,'enUS','The good Doktor Professor Ironpants may be found in the Hall of Explorers.','The good Doktor Professor Ironpants may be found in the Hall of Explorers.',26124),
(47934,'enUS','Defense systems obliterated. Powering down...','',26124),
(47935,'enUS','Ye\'ll find an Arcane Reforger in Gimble\'s shop, Thistlefuzz Arcanery, right by the Gryphon Master at The Great Forge.$B$BHe\'s one o\' them long-lost Highborne elves, but he\'ll do ye right.','Ye\'ll find an Arcane Reforger in Gimble\'s shop, Thistlefuzz Arcanery, right by the Gryphon Master at The Great Forge.$B$BHe\'s one o\' them long-lost Highborne elves, but he\'ll do ye right.',26124),
(47936,'enUS','I am ready to fight Torth!','I am ready to fight Torth!',26124),
(47937,'enUS','Hey you. Can you get me out of here?','Hey you. Can you get me out of here?',26124),
(47938,'enUS','A little help here?','A little help here?',26124),
(47939,'enUS','You\'re lucky you\'re on the other side of these bars!','You\'re lucky you\'re on the other side of these bars!',26124),
(47940,'enUS','Let me out of here!','Let me out of here!',26124),
(47941,'enUS','What are you going to do to me?','What are you going to do to me?',26124),
(47942,'enUS','You, over there. Come kill my jailer!','You, over there. Come kill my jailer!',26124),
(47943,'enUS','I will not be manipulated!','',26124),
(47944,'enUS','','His will - it\'s too strong!',26124),
(47945,'enUS','There is a blood elf in the Valley of Strength\'s central fortress, part of a delegation from Silvermoon: Belloc. He is who you want.','There is a blood elf in the Valley of Strength\'s central fortress, part of a delegation from Silvermoon: Belloc. He is who you want.',26124),
(47946,'enUS','The mages may be found in Cleft of Shadow.  There are two entrances: One between the valleys of Strength and Wisdom, and the other in The Drag.','The mages may be found in Cleft of Shadow.  There are two entrances: One between the valleys of Strength and Wisdom, and the other in The Drag.',26124),
(47947,'enUS','I ... will not ... serve!','',26124),
(47948,'enUS','','Then you will die.',26124),
(47949,'enUS','','So be it. It is done.',26124),
(47950,'enUS','','Meet me in the Gullet, $n. Fly west, across the river, and look for a small cave along the ridgeline...',26124),
(47951,'enUS','Good working with you.','',26124),
(47952,'enUS','See you around!','',26124),
(47953,'enUS','I kind of like you. Try not to get killed out there.','I kind of like you. Try not to get killed out there.',26124),
(47954,'enUS','Deethuk, you\'re a little snot! Wait... what\'s wrong with your code device?','Deethuk, you\'re a little snot! Wait... what\'s wrong with your code device?',26124),
(47955,'enUS','Huh? What?','',26124),
(47956,'enUS','Toxitron unit shield systems online.','',26124),
(47957,'enUS','$n! I\'m glad you made it.','',26124),
(47958,'enUS','%s prepares to massacre his foes!','',26124),
(47959,'enUS','Breathe your dying breath!','',26124),
(47960,'enUS','At least... Theralion dies with me...','',26124),
(47961,'enUS','Theralion, I will engulf the hallway. Cover their escape!','',26124),
(47962,'enUS','Enter Twilight!','',26124),
(47963,'enUS','Careful, $r.$b$bSchnottz is in a foul mood after the failed ritual incident.','',26124),
(47964,'enUS','The ambassador lies dead in a pool of his own gore.$b$bThrough his rent clothing, you can make out a row of enormous, deep teethmarks.$b$bEven stranger, the wounds appear to be cauterized, even charred in places.','',26124),
(47965,'enUS','%s weakens! Capture them with your shackles!','%s weakens! Capture them with your shackles!',26124),
(47966,'enUS','<The man barely acknowledges your presence. It is clear that he isn\'t interested in speaking with you.>','',26124),
(47967,'enUS','Break out the gatestone. Open this thing up.','',26124),
(47968,'enUS','','Right away sir. Er... I don\'t see a slot to put it in?',26124),
(47969,'enUS','It\'s never easy, is it? That\'s alright, we came prepared.','',26124),
(47970,'enUS','Blow it open. There isn\'t a problem that some explosives can\'t solve.','',26124),
(47971,'enUS','On it.','',26124),
(47972,'enUS','Charges are set. Might want to get clear!','',26124),
(47973,'enUS','That\'s what I like to see. Who needs a gatestone anyway...','',26124),
(47974,'enUS','Paratroopers?!','',26124),
(47975,'enUS','Commander, behind you! Gnomeregan paratroopers!','Commander, behind you! Gnomeregan paratroopers!',26124),
(47976,'enUS','Look! Behind you! A mirror!','Look! Behind you! A mirror!',26124),
(47977,'enUS','A mirror? How wonderful!','',26124),
(47978,'enUS','Move along, $r.$b$bYour presence is of no consequence to me.','',26124),
(47979,'enUS','<The emissary sneers without looking at you.>$b$bGo about your business, $r.','',26124),
(47980,'enUS','Terrible business!$b$bThere was a horrific growling noise that seemed to echo throught the region.$b$bPoor fellow...$b$bYou\'ll excuse me - I do believe I need a drink.','',26124),
(47981,'enUS','I cannot be certain of what I saw.$b$bIt was over before I realized what was happening.','',26124),
(47982,'enUS','How unfortunate!$b$bLet\'s get this cleaned up, shall we?$b$bWouldn\'t want to make any more of this than needs be...','',26124),
(47983,'enUS','Don\'t you want to know what happened to the man?','Don\'t you want to know what happened to the man?',26124),
(47984,'enUS','I\'m curious, of course, but what\'s done is done.$b$bWe wouldn\'t want to stir up any unneccesary panic. That simply wouldn\'t be prudent!','',26124),
(47985,'enUS','Your only concern here is your stake in this operation?','Your only concern here is your stake in this operation?',26124),
(47986,'enUS','Certainly not!$b$bI mean, I do have my entire fortune at risk here... and honestly, what good would a public crisis do anyone?','',26124),
(47987,'enUS','What\'s happening out here!?$b$bDid you see the man\'s wounds?!$b$bWhat kind of monster DOES that?\n','',26124),
(47988,'enUS','Just take a deep breath. Did you see anything?','Just take a deep breath. Did you see anything?',26124),
(47989,'enUS','No, but I don\'t need to have seen it to know that we\'re all going to DIE!$b$bDo you hear me?!\n','',26124),
(47990,'enUS','Just relax... Panicking will only make it worse.','Just relax... Panicking will only make it worse.',26124),
(47991,'enUS','Easy for you to say.$b$bI\'m not cut out for this! I need to find a way out of here!\n','',26124),
(47992,'enUS','','<The starlet stares at you blankly.>',26124),
(47993,'enUS','Archmage Pratt, an Arcane Reforger recently from Dalaran, is usually working with Lavinia Crowe, the local enchanter. They\'re both in the Apothecarium.','Archmage Pratt, an Arcane Reforger recently from Dalaran, is usually working with Lavinia Crowe, the local enchanter. They\'re both in the Apothecarium.',26124),
(47994,'enUS','My advice to you is simple, $r.$b$bDo not get in the way here.','',26124),
(47995,'enUS','Ah, you seek one of the returned Highborne.$B$BOne of their Arcane Reforgers has been spending time with Taladan, the enchanter.  Seek them out in the Craftsmen\'s Terrace.','Ah, you seek one of the returned Highborne.$B$BOne of their Arcane Reforgers has been spending time with Taladan, the enchanter.  Seek them out in the Craftsmen\'s Terrace.',26124),
(47996,'enUS','There is a scholar, Hammond the Jaded, who can assist you.  You will find him in the Temple of the Moon, often conversing with one of the returned Highborne.','There is a scholar, Hammond the Jaded, who can assist you.  You will find him in the Temple of the Moon, often conversing with one of the returned Highborne.',26124),
(47997,'enUS','Do I know you? No? Welcome to the Twilight\'s Hammer.','Do I know you? No? Welcome to the Twilight\'s Hammer.',26124),
(47998,'enUS','The end days are nigh!','The end days are nigh!',26124),
(47999,'enUS','There\'s a little blood on your armor there. Are you okay?','There\'s a little blood on your armor there. Are you okay?',26124),
(48000,'enUS','New recruit? Have you reported to the commander yet?','New recruit? Have you reported to the commander yet?',26124),
(48001,'enUS','Hey, you haven\'t seen Grom-Grom have you? Orc, about this tall. No?$B$BHmm. No one\'s seen him for a while. Probably went a.w.o.l.','Hey, you haven\'t seen Grom-Grom have you? Orc, about this tall. No?$B$BHmm. No one\'s seen him for a while. Probably went a.w.o.l.',26124),
(48002,'enUS','Something big\'s brewing at the Withering to the east.$B$BWhatever it is, I hope that it\'ll be over soon and we get restationed somewhere nicer.','Something big\'s brewing at the Withering to the east.$B$BWhatever it is, I hope that it\'ll be over soon and we get restationed somewhere nicer.',26124),
(48003,'enUS','Keep your eyes peeled. They say that freak that was attacking people earlier might still be around.','Keep your eyes peeled. They say that freak that was attacking people earlier might still be around.',26124),
(48004,'enUS','Isn\'t it weird that we\'re keeping Magatha Grimtotem captive here? Good thing all of her totems were destroyed.$B$BI even heard that she poisoned Cairne Bloodhoof. Wish she were on our side.','Isn\'t it weird that we\'re keeping Magatha Grimtotem captive here? Good thing all of her totems were destroyed.$B$BI even heard that she poisoned Cairne Bloodhoof. Wish she were on our side.',26124),
(48005,'enUS','You will find a blood elf Arcane Reforger, Herim, at Dawnstrider Enchanters on the middle rise.  She will be able to assist you.','You will find a blood elf Arcane Reforger, Herim, at Dawnstrider Enchanters on the middle rise.  She will be able to assist you.',26124),
(48006,'enUS','I can smell your fear...','',26124),
(48007,'enUS','I will rip your heart from your chest!','',26124),
(48008,'enUS','Ha ha ha ha ha!  Rah ha ha ha ha ha!','',26124),
(48009,'enUS','Your blood only increases my hunger!','',26124),
(48010,'enUS','You will...NOT find her...until it is too late...','',26124),
(48011,'enUS','Warlord Krogg sent me here to keep this front locked down. But he hasn\'t sent me any soldiers yet.$B$BLook at this place! I\'ve got ogres. I\'ve got Twilight\'s Hammer. I\'ve got... nothing.','',26124),
(48012,'enUS','$n! Ovah he\'ah!','',26124),
(48013,'enUS','Zhis vay, $n! Come! Come!','',26124),
(48014,'enUS','Hurry, $n! Zhere is little time!','',26124),
(48015,'enUS','Come, $n! Into zhe siege tank! NOW!','',26124),
(48016,'enUS','I am free after ten thousand years, yet still my own brother thinks I am a villain! I\'ll show him my true power! I\'ll show him that the demons have no hold over me!','',26124),
(48017,'enUS','Are you certain of that, demon hunter? Are you certain your will is your own?','',26124),
(48018,'enUS','You reek of death, human. You\'ll regret approaching me.','',26124),
(48019,'enUS','Come then. You\'ll find that we\'re evenly matched.','',26124),
(48020,'enUS','We could go on fighting like this forever. What is it you truly want?','',26124),
(48021,'enUS','The dreadlord who commands this undead army is called Tichondrius. He commands a powerful warlock artifact called the Skull of Gul\'dan.','',26124),
(48022,'enUS','It is responsible for corrupting these forests.','',26124),
(48023,'enUS','And you wish for me to steal it. Why?','',26124),
(48024,'enUS','Otoh Greyhide spends much of time in the Hall of Elders on the Elder Rise.  Seek him out there, and he will help you.','Otoh Greyhide spends much of time in the Hall of Elders on the Elder Rise.  Seek him out there, and he will help you.',26124),
(48025,'enUS','Let\'s just say that I have no love for Tichondrius, and the lord I serve would... benefit from the Legion\'s downfall.','',26124),
(48026,'enUS','You will find the Sunwalker\'s Lodge on Hunter\'s Rise.','You will find the Sunwalker\'s Lodge on Hunter\'s Rise.',26124),
(48027,'enUS','The Seers of Elder Rise will help you.  Seek them out in the Hall of Elders there.','The Seers of Elder Rise will help you.  Seek them out in the Hall of Elders there.',26124),
(48028,'enUS','Paladin','Paladin',26124),
(48029,'enUS','','The Elder Crone rubs her wrists as she flashes a toothy grin your way.',26124),
(48030,'enUS','I have no need for eyes to see my enemies. Your clumsy footsteps and foul stench give you away!','',26124),
(48031,'enUS','Sighted, but blind to the truth. Embrace the finality of it all!','',26124),
(48032,'enUS','','I\'m surprised that you made it this far.',26124),
(48033,'enUS','Death waits in the darkness!','',26124),
(48034,'enUS','This miserable existence finally ends.','',26124),
(48035,'enUS','','I suppose I should thank you for freeing me. We\'ll soon see if you think that was a wise decision.',26124),
(48036,'enUS','You cannot hide from searing flame!','',26124),
(48037,'enUS','','Meet me just outside of the Twilight Withering down the path to the east.',26124),
(48038,'enUS','Yes, run! With every step your heart quickens. The beating, loud and thunderous... Almost deafening. You cannot escape!','',26124),
(48039,'enUS','The city\'s Arcane Reforger, Enchantress Fira, will be able to help you.  She is most often found with Sedana and her enchanter\'s apprentices, off the Court of the Sun.','The city\'s Arcane Reforger, Enchantress Fira, will be able to help you.  She is most often found with Sedana and her enchanter\'s apprentices, off the Court of the Sun.',26124),
(48040,'enUS','','Find the codes to release me from these infernal bonds!',26124),
(48041,'enUS','One of Darnassus\' Highborne, an Arcane Reforger, is working with the Exodar\'s enchanters.  You\'ll find them all in the Crystal Hall, opposite the jewel crafters.','One of Darnassus\' Highborne, an Arcane Reforger, is working with the Exodar\'s enchanters.  You\'ll find them all in the Crystal Hall, opposite the jewel crafters.',26124),
(48042,'enUS','You vorry about zhe killink!','',26124),
(48043,'enUS','It\'s all gone to hell, $c!','',26124),
(48044,'enUS','Looking for Diya, wandering among the images around the Seat of the Naaru. She will be more than happy to help you.','Looking for Diya, wandering among the images around the Seat of the Naaru. She will be more than happy to help you.',26124),
(48045,'enUS','I vill vorry about zhe drivink!','',26124),
(48046,'enUS','','Dese caves be haunted, mon. Filled with the worst juju.$B$BIn days when de Twilight\'s Hammer be settin\' up atop de mountain, the unworthy were tossed into dese caverns. Into de Gullet. Food for de black drakes dat once nested here.$B$BDem people, dey never come out. Not even de spirits.',26124),
(48047,'enUS','','Greetings, $c!',26124),
(48048,'enUS','Sarus, I lost my spider. Could I have another?','Sarus, I lost my spider. Could I have another?',26124),
(48049,'enUS','Boduro the Seeker can often be found in the merchant\'s bazaar within the Lower City. I would look for him there.','Boduro the Seeker can often be found in the merchant\'s bazaar within the Lower City. I would look for him there.',26124),
(48050,'enUS','The Highborne Archmage, Aranhir Starsinger, is a master of arcane reforging... you might convince him to aid you.\n\nHe can often be found discussing his craft with those of Simply Enchanting, just outside the Magus Commerce Exchange in northwest Dalaran.','The Highborne Archmage, Aranhir Starsinger, is a master of arcane reforging... you might convince him to aid you.\n\nHe can often be found discussing his craft with those of Simply Enchanting, just outside the Magus Commerce Exchange in northwest Dalaran.',26124),
(48051,'enUS','The high elf mage and scholar Dariness is the city\'s most learned archaeologist... and the most sociable.$B$BShe can often be found in the Legerdemain Lounge, just north of the city\'s center, enjoying the atmosphere or discussing her wild adventures with the proprieters and patrons both.','The high elf mage and scholar Dariness is the city\'s most learned archaeologist... and the most sociable.$B$BShe can often be found in the Legerdemain Lounge, just north of the city\'s center, enjoying the atmosphere or discussing her wild adventures with the proprieters and patrons both.',26124),
(48052,'enUS','|c00FF0000Chimaeron\'s Massacre has knocked the Bile-O-Tron offline!|r','',26124),
(48053,'enUS','|c0000FF00The Bile-O-Tron is back online!|r','',26124),
(48054,'enUS','','Beat me to it, I see. Your exit awaits...',26124),
(48055,'enUS','No... NO! This is my domain! You cannot have... it...','',26124),
(48056,'enUS','Pathetic mortal... I will build a new empire atop your corpse!','',26124),
(48057,'enUS','THANKS! HI! LET\'S ROUND UP SOME HUMANS FOR THE CAPTAIN!','',26124),
(48058,'enUS','Escort Dumass out of the mine safely. Keep Dumass away from webbed humans.','',26124),
(48059,'enUS','WHAT\'S TAKING SO LONG? I\'M LEAVING! BYE!','',26124),
(48060,'enUS','YAY! CAPTAIN I AM BACK! HOORAY!','',26124),
(48061,'enUS','Wow, yea, that\'s great. I\'m SO HAPPY to see that $P helped you out of the mine, postponing your tragic and inevitable death. Now why don\'t you scurry along now. I hear Tarren Mill is looking for Forsaken just like you, Dumass.','',26124),
(48062,'enUS','TARREN MILL! OK! IS THAT IN THE BARRENS! I\'M ON MY WAY! THANKS!','',26124),
(48063,'enUS','BEAT THEM DOWN THEN KILL! THEN SHACKLE!','',26124),
(48064,'enUS','THIS IS EASY! YES!','',26124),
(48065,'enUS','HERE\'S ONE!','',26124),
(48066,'enUS','HOW DID ALL THESE PEOPLE GET IN HERE?!?','',26124),
(48067,'enUS','THIS ONE IS ANGRY!','',26124),
(48068,'enUS','These glorious fields weren\'t always here, $c. Only through determination and the strength of will did we turn the decrepit human farms into Lordaeron\'s largest and most productive sludge and mushroom plantation.$B$BNow all of that could be lost due to a simple accident!','',26124),
(48069,'enUS','I USED TO BE A FARMER!','',26124),
(48070,'enUS','THERE\'S ONE OVER THERE!','',26124),
(48071,'enUS','THESE HUMANS LOOK DANGEROUS!','',26124),
(48072,'enUS','THANKS FOR RESCUING ME!','',26124),
(48073,'enUS','WHEN I WOKE UP I SAW THE BANSHEE QUEEN TALKING TO A BIG BROWN ORC!','',26124),
(48074,'enUS','WHO ARE OUR FRIENDS?','',26124),
(48075,'enUS','WERE YOU IN SILVERPINE WHEN THE BANSHEE QUEEN KILLED ALL OF THE WORGEN!?','',26124),
(48076,'enUS','Grows larger...','',26124),
(48077,'enUS','Grows even larger...','',26124),
(48078,'enUS','Looks like he\'s about to explode!','',26124),
(48079,'enUS','DESTROY!','',26124),
(48080,'enUS','That is where the skull of Gul\'dan is being kept! These paltry demons will not prevent me from claiming it!','',26124),
(48081,'enUS','Now at least the demons will no longer corrupt the forests. But, if I claim this power as my own, I will become stronger than any of Archimonde\'s lieutenants.','',26124),
(48082,'enUS','Yes... the power should be mine!','',26124),
(48083,'enUS','Now I am complete!','',26124),
(48084,'enUS','','Bad juju ain\'t got nothin\' on you, $gsweetie:girl;.',26124),
(48085,'enUS','Turn back, $c. Dere be some serious darkness in dis cave, and I ain\'t talkin\' about de lack of light.','',26124),
(48086,'enUS','Dis be it, mon! You got de light? You hold it tight, no matter what happens.$B$BSay de word and I put you in de spirit realm. De spirits, dey will come after you, try to drag you down into de darkness.$B$BShine dat light on de nasties!','',26124),
(48087,'enUS','De dirty business be done, mon. Dis cave be safe now.$B$BDis place can be quite de home. What do you think? Maybe a few more masks, yes?','',26124),
(48088,'enUS','You be not afraid of nothin\', $c!$B$BBuunu be waitin\' for you outside.','',26124),
(48089,'enUS','You lookin\' for trainin\'? No can do. I ain\'t your guy.','You lookin\' for trainin\'? No can do. I ain\'t your gal.',26124),
(48090,'enUS','You lookin\' to train up, bruiser?','You lookin\' to train up, bruiser?',26124),
(48091,'enUS','You can follow me to the Loading Room, $n.','You can follow me to the Loading Room, $n.',26124),
(48092,'enUS','Walk to the Three Shrines Within the Cave','',26124),
(48093,'enUS','Aim Your Light of Souls at the Spirits to Banish Them!','',26124),
(48094,'enUS','Placeholder - Quest Not Yet Implemented','',26124),
(48095,'enUS','I am ready, Uchek!','I am ready, Uchek!',26124),
(48096,'enUS','','I don\'t be hearin\' de whispers no more, $n. What happened in de cave?',26124),
(48097,'enUS','','Do you want to see the utter destruction of what\'s left of Thousand Needles?$B$BNo?$B$BThen do exactly as I command.',26124),
(48098,'enUS','You will pay for this intrusion!','',26124),
(48099,'enUS','','This is where we gather the surivors to prepare them for decontamination. From there, it\'s just a short trip to the surface!',26124),
(48100,'enUS','I\'m sure I don\'t need to remind you to stay alert down here.','',26124),
(48101,'enUS','A prisoner has escaped!  Slay $g him:her;!','',26124),
(48102,'enUS','You won\'t make it far!','',26124),
(48103,'enUS','I will spill your blood in Deathwing\'s name!','',26124),
(48104,'enUS','If slavery does not suit you, maybe death will!','',26124),
(48105,'enUS','I will show you the weakness of flesh!','',26124),
(48106,'enUS','You\'re going to wish you\'d never set foot in Uldum!','',26124),
(48107,'enUS','|TInterface\\Icons\\spell_fire_felrainoffire.blp:20|t%s begins to cast |cFFFF0000|Hspell:88972|h[Fel Firestorm]|h|r!','',26124),
(48108,'enUS','Yeah, I got it. That\'s weird.$B$BWho loses their river boat, cap\'n?','',26124),
(48109,'enUS','','How exactly does one lose an entire river boat, $n?',26124),
(48110,'enUS','Everything here is completely on the up and up!','',26124),
(48111,'enUS','Um... I hate to say this, but... I kinda lost the I-Scream Cryocannon.','Um... I hate to say this, but... I kinda lost the I-Scream Cryocannon.',26124),
(48112,'enUS','Wait... what? Um, sure.$B$BHere\'s my spare.','',26124),
(48113,'enUS','The Wildhammer dwarves are our mortal enemy. It\'s them or us.','',26124),
(48114,'enUS','','This is the most moronic... half-assed... ridiculous plan you\'ve ever come up with, Budd!',26124),
(48115,'enUS','','But I suppose it\'s the only plan we\'ve got.',26124),
(48116,'enUS','','What am I grabbing again?',26124),
(48117,'enUS','OAF SMASH!!','',26124),
(48118,'enUS','Free... at last.  Your reward will be substantial, friends.','',26124),
(48119,'enUS','Your approach is... unorthodox.  Though, I suppose with the smoke from the fires, all they\'ll see is your silhouettes.','',26124),
(48120,'enUS','LOOK AT ME!!!!  I\'M A MANATAUR!!!','',26124),
(48121,'enUS','','No one rides the Lady!',26124),
(48122,'enUS','','Shut your stupid face, Budd.  SHUT IT!!',26124),
(48123,'enUS','Let\'s go!','',26124),
(48124,'enUS','Let\'s see how confident you are against one of your own kind, dreadlord.','',26124),
(48125,'enUS','Zhat\'s it!$b$bZhe scrubs vill clean up zhe rest.$b$bBack to zhe base ve go!','Zhat\'s it!$b$bZhe scrubs vill clean up zhe rest.$b$bBack to zhe base ve go!',26124),
(48126,'enUS','Ice Cream! Get your tasty, cold, sweet, delicious ice cream right here!','',26124),
(48127,'enUS','Brivelthwerp\'s Ice Cream Empire. Now offering TWO flavors!','',26124),
(48128,'enUS','Try all new Brivelthwerp\'s Sililicious Crunch ice cream. Chock-full of real silithid. Accept no imitations!','',26124),
(48129,'enUS','Ice cream, candy, bubblegum!','',26124),
(48130,'enUS','Don\'t settle for anything but the best. Brivelthwerp\'s!','',26124),
(48131,'enUS','Leave me be.','',26124),
(48132,'enUS','It\'s unseasonably hot. Time for Brivethwerp\'s Sililicious Crunch!','',26124),
(48133,'enUS','I\'m here to put an end to your killing.','I\'m here to put an end to your killing.',26124),
(48134,'enUS','Brivelthwerp\'s, it\'s what\'s for dessert!','',26124),
(48135,'enUS','All the kids are just dying for some Brivelthwerp\'s ice cream!','',26124),
(48136,'enUS','Blind fool! You have no idea what you are doing!','',26124),
(48137,'enUS','Enough! Stay your hand!','',26124),
(48138,'enUS','I vill discovah who vas behind zhis cowardly act!$b$bAnd vhen I do....','',26124),
(48139,'enUS','|cFFFFFFFFThere\'s trouble at the Sludge Fields...|r','',26124),
(48140,'enUS','If ever there comes a time that I have something to say to you, you should run.','',26124),
(48141,'enUS','You foolishly stumble about here, $r, oblivious to what forces surround you.','',26124),
(48142,'enUS','There is fear in you, mortal.$b$bI can smell it.','',26124),
(48143,'enUS','State your business.  Be brief, if possible.','',26124),
(48144,'enUS','King Phaoris sent me to ask you about Neferset activity.','King Phaoris sent me to ask you about Neferset activity.',26124),
(48145,'enUS','The king is sending a stranger to gather information for him?  I suppose you must be that... what\'s the word?  $R?  Yes, that $r that rescued Prince Nadun.$B$BAt any rate, I haven\'t seen any signs of the Neferset scum this far north.  There are plenty of other nuisances to be dealt with, however.','',26124),
(48146,'enUS','I\'ve heard of you, $n.  Are you here to help us?','',26124),
(48147,'enUS','I might be able to help.  Were the Neferset behind this?','I might be able to help.  Were the Neferset behind this?',26124),
(48148,'enUS','No.  This was the work of common Wastewander bandits.$B$BIt is rumored they\'re joining a more regimented group to the west.  Their violence is barbaric.','',26124),
(48149,'enUS','I heard you were in town.  What a strange creature you are.$B$BYou wish to speak to me?','',26124),
(48150,'enUS','The king wishes to be informed about recent Neferset activity.','The king wishes to be informed about recent Neferset activity.',26124),
(48151,'enUS','No, no Neferset movement.  But I just received word that the city of Orsis is being hit by the largest sandstorm anyone has ever witnessed.$B$BI was about to send word to the king myself, but perhaps you can relay the information.','',26124),
(48152,'enUS','Greely, can you get me back into that footbomb uniform?','Greely, can you get me back into that footbomb uniform?',26124),
(48153,'enUS','','We\'ve long held out hope of redeeming the Earthwarden and his children. At some point, we must have the wisdom to realize that no amount of redemption can atone for the destruction these dragons are unleashing upon the world.$B$BAt some point, we are forced to intervene.',26124),
(48154,'enUS','Follow the hatchlings into the Obsidian Lair.','Follow the hatchlings into the Obsidian Lair.',26124),
(48155,'enUS','Alright, let\'s move.','Alright, let\'s move.',26124),
(48156,'enUS','Follow me! Zhere is much to be done!','',26124),
(48157,'enUS','Auch! Zhis is an outrage!','',26124),
(48158,'enUS','You take a group of miserable bandits, make them part of somezhink historical, and zhis is vhat you get?','',26124),
(48159,'enUS','I am goink find out who is behind zhis treachery, and you are goink to help me!','',26124),
(48160,'enUS','Zhis vork is bigger zhan you or me... Bigger zhan anyvone knows!','',26124),
(48161,'enUS','Zhese vould-be assassins don\'t know who zhey are meddling vizh!','',26124),
(48162,'enUS','Soon, zhey shall learn... and vhen zhey do, zhey vill tremble!','',26124),
(48163,'enUS','','Oh... I wish I\'d never come to this place!',26124),
(48164,'enUS','How did I ever get myself into this?!\n','',26124),
(48165,'enUS','I was blinded by all of the excitement.$b$bI should have seen this coming from a mile away...','',26124),
(48166,'enUS','My life\'s fortune... gone.$b$bThere\'s no hope left for me.','',26124),
(48167,'enUS','','This is all too much to bear.$b$bI wish I had the nerve to... <sob>.',26124),
(48168,'enUS','I thought he had all the right answers.$b$bI... hoped.$b$bHe\'s nothing that he portrayed himself to be.$b$bI was a fool.','',26124),
(48169,'enUS','The seahorse floats patiently.','',26124),
(48170,'enUS','Show me where I can go.','Show me where I can go.',26124),
(48171,'enUS','I need to get to Nespirah.','I need to get to Nespirah.',26124),
(48172,'enUS','Use the shovel to smash in the human seedling\'s heads.|TInterface\\Icons\\INV_MISC_SHOVEL_01.BLP:24|t$B$BOR$B$B[Right Click] the human seedlings to free them from the dirt.|TInterface\\Cursor\\SKINALLIANCE.BLP:24|t$B$BDo the right thing.','',26124),
(48173,'enUS','M... maybe you\'re not all bad after all...','M... maybe you\'re not all bad after all...',26124),
(48174,'enUS','Thank you for saving my life. I owe you a debt of gratitude.','Thank you for saving my life. I owe you a debt of gratitude.',26124),
(48175,'enUS','I won\'t soon forget this kindness, $r.','I won\'t soon forget this kindness, $r.',26124),
(48176,'enUS','It... they planted us in the dirt like crops! Stillwater is insane! Get out of here while you still can!','It... they planted us in the dirt like crops! Stillwater is insane! Get out of here while you still can!',26124),
(48177,'enUS','He killed everyone! EVERYONE!','He killed everyone! EVERYONE!',26124),
(48178,'enUS','Should you ever be buried neck deep in a field of feces and urine, I will be sure to lend you a hand.','Should you ever be buried neck deep in a field of feces and urine, I will be sure to lend you a hand.',26124),
(48179,'enUS','Ah, fresh meat!','',26124),
(48180,'enUS','These documents implicate several troll spies.  Consider their heads forfeit.  Take your compensation and spend it wisely; it\'s drawn from the taxpayers of Stormwind.','',26124),
(48181,'enUS','These documents implicate several orcish spies.  Our best assassins will be dispatched for this treachery.  Take your compensation and spend it wisely; it\'s drawn from the taxpayers of Stormwind.','',26124),
(48182,'enUS','You honor us by delivering this information.  It seems as if we\'ve finally found the spy in the city... a homeless man whom we will execute shortly.  Take your reward, you\'ve done well!','',26124),
(48183,'enUS','Oh my... someone became ill from my bread?  How can this be?  Please, I hope my meager earnings are enough to help out.','',26124),
(48184,'enUS','All our items are carefully inspected and shipped with precision!  If this wasn\'t signed by the king himself you\'d never see a dime.','',26124),
(48185,'enUS','Oh... I think I\'m going to be sick.  How could I have cut off someone\'s ear and not have noticed?  Please take this money to a healer and have it reattached.','',26124),
(48186,'enUS','','I can\'t be held responsible every time someone falls off their mount.  I don\'t know how you got the official seal on this, but take your payment and don\'t question my horses again!',26124),
(48187,'enUS','This is a dangerous game you play... take your gold for now, but know that I\'m watching you.\n','',26124),
(48188,'enUS','I could swear I just paid a fine like this...\n','',26124),
(48189,'enUS','Her bag of gold should be in the mail!  It\'s insulting she sends someone to collect from me while I\'m working.','',26124),
(48190,'enUS','I\'ve heard of mice trapped in ale bottles before, but never in bread.  P-p-please take everything and don\'t speak of this to anyone.','',26124),
(48191,'enUS','I don\'t usually give refunds for haircuts, but I must admit I did a terrible job on yours.  My apologies.','',26124),
(48192,'enUS','','I must have been pretty tipsy the night I promised you a pony.  Take your money and no hard feelings, okay?',26124),
(48193,'enUS','We usually handle this all through the mail...','',26124),
(48194,'enUS','Wow.  I didn\'t even realize we sold this kind of thing.','',26124),
(48195,'enUS','Alright everyone. Follow me and uhh... just act natural.','',26124),
(48196,'enUS','There is nothing of interest on the table.','',26124),
(48197,'enUS','Several piles of supplies rest on the table.  You decide to start with the worg hides.','',26124),
(48198,'enUS','You see the stack of worg hides that you collected earlier.  These will be used for the bulk of your costume.','',26124),
(48199,'enUS','Looking over, you see the obsidian-flecked mud that you collected from the lava beds.  This will be used to color your disguise.','',26124),
(48200,'enUS','Finally, you see some thread, which will be used to hold the disguise together.','',26124),
(48201,'enUS','You have gathered your supplies.  Bring them to Thelaron Direneedle to assemble.','',26124),
(48202,'enUS','Take one hide.','Take one hide.',26124),
(48203,'enUS','Take two hides.','Take two hides.',26124),
(48204,'enUS','Take three hides.','Take three hides.',26124),
(48205,'enUS','Take four hides.','Take four hides.',26124),
(48206,'enUS','Take one handful of mud.','Take one handful of mud.',26124),
(48207,'enUS','Take two handfuls of mud.','Take two handfuls of mud.',26124),
(48208,'enUS','Take three handfuls of mud.','Take three handfuls of mud.',26124),
(48209,'enUS','Take four handfuls of mud.','Take four handfuls of mud.',26124),
(48210,'enUS','Take one spool of thread.','Take one spool of thread.',26124),
(48211,'enUS','Take two spools of thread.','Take two spools of thread.',26124),
(48212,'enUS','Take three spools of thread.','Take three spools of thread.',26124),
(48213,'enUS','Take four spools of thread.','Take four spools of thread.',26124),
(48214,'enUS','Investigate the hides.','Investigate the hides.',26124),
(48215,'enUS','So you caught a thief.  Enjoy your finder\'s fee!','',26124),
(48216,'enUS','It appears as if that gold we recovered from the dead rogue was yours.  You certainly are lucky...','',26124),
(48217,'enUS','I couldn\'t have miscalculated your interest... because we don\'t give any!  I\'d rather pay than be subjected to the trials, so take my personal cash.','',26124),
(48218,'enUS','An account of all the fractions of copper we round off... brilliant.','',26124),
(48219,'enUS','','They had what on them?  Tell the tailor my ceremonial robes had better be perfect with everything she\'s charging me.',26124),
(48220,'enUS','','I can\'t believe you sell those here, of all places.  I\'ll swing by the cook later to pick them up.',26124),
(48221,'enUS','I really need to stop gambling.  Tell them no more cards for me.','',26124),
(48222,'enUS','I really need to stop gambling.  Tell them no more cards for me.','',26124),
(48223,'enUS','I know I worked a hundred and sixty eight hours last week... but if the paperwork says I didn\'t clock in, maybe you\'re right.','',26124),
(48224,'enUS','','Thanks so much!  I\'m glad I could extend the warranty on my cast iron pots for another month.',26124),
(48225,'enUS','','My... brother died?  I can\'t believe I never even met him.  Take this money and give him a good funeral.',26124),
(48226,'enUS','','My... sister died?  I can\'t believe I never even met her.  Take this money and give him a good funeral.',26124),
(48227,'enUS','','My... uncle died?  I can\'t believe I never even met him.  Take this money and give him a good funeral.',26124),
(48228,'enUS','','My... aunt died?  I can\'t believe I never even met her.  Take this money and give him a good funeral.',26124),
(48229,'enUS','I heard of what you did in Orsis.  I will be honored to fight along your side.','',26124),
(48230,'enUS','The $r that rescued Prince Nadun is the only $r that I\'ll ever take orders from.','',26124),
(48231,'enUS','It\'s about time we started doing something.','',26124),
(48232,'enUS','I will defend Ramkahen with my bare hands if I have to!','',26124),
(48233,'enUS','We will defend our lands!','',26124),
(48234,'enUS','If the rumors about you are true, stranger, I will gladly join you in the fight against the Neferset!','',26124),
(48235,'enUS','There\'s not nearly enough hide here to make a proper disguise.','',26124),
(48236,'enUS','Alright, this is far too much mud.  Your disguise will be too dark and gloppy.','',26124),
(48237,'enUS','You\'ve brought me way too much worg-hide, $n!','',26124),
(48238,'enUS','We\'re going to need more mud to properly color your disguise.','',26124),
(48239,'enUS','I\'ve got the proper amounts of mud and hide, but not enough thread to hold it together.','',26124),
(48240,'enUS','Ach!  Everything else looks good, but there\'s too much thread!','',26124),
(48241,'enUS','This... this is perfect!  This disguise shall be my masterpiece!','',26124),
(48242,'enUS','Ye\'ll not find a finer craftsman than I in all the Dark Irons!$b$bHammerin\', smithin\', and diggin\' be damned!  A needle and a thimble\'s all the metal I need!','',26124),
(48243,'enUS','I brought you some hides, mud, and thread.','I brought you some hides, mud, and thread.',26124),
(48244,'enUS','What have ye brought me?','',26124),
(48245,'enUS','Somebody shut this little girl up!','',26124),
(48246,'enUS','Do you want a dolly, little girl? Would that make it better?','',26124),
(48247,'enUS','KILL ME OR KILL THE GIRL!','',26124),
(48248,'enUS','Is this Stillwater\'s plan? To torture me before he kills me?','',26124),
(48249,'enUS','WHAT ARE YOU WAITING FOR STILLWATER! KILL ME! DO IT NOW!','',26124),
(48250,'enUS','How much longer are you going to cry?','',26124),
(48251,'enUS','Curse the Dragonmaw!$B$BThey kill our birds, attack our families, take our land. Even as the world crashes down around us, still they assault our homes.$B$BIf your Alliance wants the help of the Wildhammer, there\'s only one way to win us over: Stop. The. Dragonmaw.','',26124),
(48252,'enUS','<Blundy peers up from his cups.>$B$BAye, that\'s right. The High Shaman is out in the field, fighting to retake the Thundermar Wreckage. I\'m whatcha call the \"Low Shaman.\"$B$BWhile he\'s away, he left me here, to take care of all of Thundermar\'s Shamanin\'in... nin.','',26124),
(48253,'enUS','','Thundermar is the last holdout of the Wildhammer. My brother\'s trying to keep up the fight while our little town fills up with refugees.',26124),
(48254,'enUS','Urrrrrrgh...','',26124),
(48255,'enUS','HLORRHGH!','',26124),
(48256,'enUS','','Open wide, Mr. Tauren! Here comes the hippogryph into the roost!',26124),
(48257,'enUS','YOU THERE! Yes, you, $c! I have been captured against my will and imprisoned illegaly by Warden Stillwater. Get me out of this cage and I will explain everything.','',26124),
(48258,'enUS','','Kitty... KITTY! I\'M SO SORRY, KITTY! COME BACK! DON\'T LEAVE ME LIKE THIS!',26124),
(48259,'enUS','Twilight essence begins to bubble forth from the corpse of the whelp....','',26124),
(48260,'enUS','%s is revived by the commingled essences!','',26124),
(48261,'enUS','%s\'s corpse disintegrates into frothing twilight essence.','',26124),
(48262,'enUS','I\'m from the Highbank advance unit, trying to win over the Wildhammer here at Thundermar.$B$BI think I can help them out, but can you believe that they don\'t have a single tri-cyclic alternating current re-polarization device? Not a one!$B$BHow do they even get by?','',26124),
(48263,'enUS','We\'re done practicing so soon?  Very well, I\'ll see you later.','',26124),
(48264,'enUS','Greetings, $c! I\'m from the Highbank advance scouting unit, trying to win over the Wildhammer here at Thundermar.$B$BTheir gryphon riders are having a tough time bringing down Dragonmaw drake riders. I\'ve got a plan for a contraption that will help, but I\'m going to need supplies. Lots of supplies.$B$BCan you help?','',26124),
(48265,'enUS','Here I am, $g sir:madam; $n!','',26124),
(48266,'enUS','I don\'t need your pity, $C.','I don\'t need your pity, $C.',26124),
(48267,'enUS','The dreadlord who commands this undead army is called Tichondrius.  He controls a powerful warlock artifact called the Skull of Gul\'dan.  It is responsible for corrupting these forests.','',26124),
(48268,'enUS','We could go on fighting like this forever.  What is it you truly want?','',26124),
(48269,'enUS','Taste my axe, coward!','Taste my axe, coward!',26124),
(48270,'enUS','Get your filthy hands off of me, $R.','Get your filthy hands off of me, $R.',26124),
(48271,'enUS','','Please don\'t break... please don\'t break....',26124),
(48272,'enUS','','Crap!  That was my last lock pick!',26124),
(48273,'enUS','','Here comes the guard, $n!  Take him out!',26124),
(48274,'enUS','','Well done!  I was about to jump in!  But it looked like you had it under control.',26124),
(48275,'enUS','','That cat-creature chained back there looks like he wants to talk.  Maybe he can help us... but be careful.',26124),
(48276,'enUS','A shadowy figure appears in the ship\'s cabin!','',26124),
(48277,'enUS','Take a look at this holotable. I want to show you a bit about Operation: Gnomeregan.','',26124),
(48278,'enUS','I\'m going to need to research what we\'ve learned here, $n.','',26124),
(48279,'enUS','There\'s no telling how we might use the power these mechanisms create.','',26124),
(48280,'enUS','Meet me in Ramkahen and I\'ll tell you what our next step should be.','',26124),
(48281,'enUS','See ya around, kid.','',26124),
(48282,'enUS','','Feed, children!  Take your fill from their meaty husks!',26124),
(48283,'enUS','TWINKLES! TWINKLES! NOOOOO!!','',26124),
(48284,'enUS','I won\'t let them get away with this, Twinkles. They will pay! They will all pay!','',26124),
(48285,'enUS','You\'re not leaving me to rot in this place! Take me with you!','',26124),
(48286,'enUS','Beatdown received.  Optimizing strategy for next battle...','',26124),
(48287,'enUS','Pummeling received.  Adjusting battle parameters...','',26124),
(48288,'enUS','Battle result: embarrassing failure.  Incorporating new methods into battle regimen.','',26124),
(48289,'enUS','Defeated.  Shame level: High.  Adjusting strategy for future battles.','',26124),
(48290,'enUS','Greetings, friend of the Brotherhood.','',26124),
(48291,'enUS','I\'m here to help you with your combat training, golem.','I\'m here to help you with your combat training, golem.',26124),
(48292,'enUS','See now the product of your meddling!','',26124),
(48293,'enUS','BURN IN MY HATRED!','',26124),
(48294,'enUS','Self-training complete!','',26124),
(48295,'enUS','Training level sufficient.  Returning to guard duty.  Thank you.','',26124),
(48296,'enUS','You find a few salvageable parts in the ruined creature\'s hull.  It looks like you will only be able to salvage one part.','',26124),
(48297,'enUS','Salvage the Flux Exhaust Sieve.','Salvage the Flux Exhaust Sieve.',26124),
(48298,'enUS','Salvage the Obsidian Piston.','Salvage the Obsidian Piston.',26124),
(48299,'enUS','Salvage the Thorium Gearshaft.','Salvage the Thorium Gearshaft.',26124),
(48300,'enUS','Salvage the Stone Power Core.  These are rare!','Salvage the Stone Power Core.  These are rare!',26124),
(48301,'enUS','Eh, wot?','',26124),
(48302,'enUS','Pack yer bags, $n! We\'re off to the Twilight Highlands. You ready?','',26124),
(48303,'enUS','I\'m ready, Flintlocke. Take me to the Highlands!','I\'m ready, Flintlocke. Take me to the Highlands!',26124),
(48304,'enUS','Thank the stars!  Now turn around so I can put them on.','Thank the stars!  Now turn around so I can put them on.',26124),
(48305,'enUS','I\'ve been placed in command of Alliance joint operations in the Twilight Highlands.$B$BThe independant Wildhammer clans still dot this countryside. If we can unite them under the Alliance banner, nothing can stop us! But enemies close in on all sides. I hope you\'re ready for a fight, $c.','',26124),
(48306,'enUS','Lydon!? Alive?','',26124),
(48307,'enUS','Now I know where your allegiances lie, $n!','',26124),
(48308,'enUS','And you, Jenny? I thought we had a connection. You\'ve broken my heart for the last time.','',26124),
(48309,'enUS','Warden Stillwater, you are deranged and a threat to our way of life. By authority of the Dark Lady herself, I hereby impose upon you the harshest penalty allowed under Forsaken law - true death.','',26124),
(48310,'enUS','That goes for all of you traitorous scum who supported this fool!','',26124),
(48311,'enUS','KNEEL!','',26124),
(48312,'enUS','I AM A THREAT? I AM DERANGED?! ','',26124),
(48313,'enUS','What I\'ve created here is an evolution! THIS is how the Forsaken will thrive, not through some magical winged fairy sprinkling happy dust on corpses!','',26124),
(48314,'enUS','Kill them all! They will serve as subjects for our next study!','',26124),
(48315,'enUS','I\'m back, Sis!','I\'m back, Sis!',26124),
(48316,'enUS','Thank heavens!  It\'s so good to see...  Why are your pants on backwards?','Thank heavens!  It\'s so good to see...  Why are your pants on backwards?',26124),
(48317,'enUS','Woohoo!$b$bWe\'ll have to do that again sometime!$b$bWell, I\'m off to do some more research. I\'ll catch up to you when I\'m ready.','',26124),
(48318,'enUS','Nope.. not yet.','',26124),
(48319,'enUS','','You stupid mongrels!  I ought to whip you all to death!',26124),
(48320,'enUS','','You wolves are worthless!  Worthless!',26124),
(48321,'enUS','','You stinking curs had better enjoy the taste of my whip!',26124),
(48322,'enUS','','I\'ll make you bleed, you weak little sacks of bones!',26124),
(48323,'enUS','','Quit your whining, you worthless wolves!',26124),
(48324,'enUS','You think that you\'ve won? THINK AGAIN! Stand before my new form and tremble!','',26124),
(48325,'enUS','','Ahh!  I... I can\'t move!',26124),
(48326,'enUS','','No... no... get them away from me!',26124),
(48327,'enUS','','NO!  AHHHHHHH!!!!',26124),
(48328,'enUS','OW, MON!','',26124),
(48329,'enUS','HEX YOU!  HEX YOU!  HEX YOU!','',26124),
(48330,'enUS','OWIE!  GORLOP CAN\'T MOVE!  GORLOP GONNA FALL!','',26124),
(48331,'enUS','HEY! You dere! You want treasure? Augh know where to gets golds and shinies. Follow Augh to Lost City of Tol\'vir? Augh promise no steal.','',26124),
(48332,'enUS','Augh sounds like a name I can trust. Lead the way!','Augh sounds like a name I can trust. Lead the way!',26124),
(48333,'enUS','Polishing Vigorously','Polishing Vigorously',26124),
(48334,'enUS','This lava hot.','',26124),
(48335,'enUS','Gorlop wonder if other lava hot?','',26124),
(48336,'enUS','I bring you back from the brink of death, $Gbrother:sister;. We are in need of your aid!','',26124),
(48337,'enUS','I have done some pretty twisted things, but what you\'re doing here is crossing a threshold even for me.','',26124),
(48338,'enUS','You know, you can probably just free them. I won\'t tell anyone.','',26124),
(48339,'enUS','CUT IT OUT! You\'re getting blood all over my robe.','',26124),
(48340,'enUS','You have issues.','',26124),
(48341,'enUS','Disgusting. They\'re of no use to us without their heads.','',26124),
(48342,'enUS','This is your idea of doing the right thing???','',26124),
(48343,'enUS','%s throws up.','',26124),
(48344,'enUS','Please stop.','',26124),
(48345,'enUS','I want to go home.','',26124),
(48346,'enUS','You are a very bad person.','',26124),
(48347,'enUS','I am thankful for all you\'ve done, $n.  But I am afraid I will be even further in your debt before this ordeal is through.','',26124),
(48348,'enUS','...','...',26124),
(48349,'enUS','Now I can return with dignity!','Now I can return with dignity!',26124),
(48350,'enUS','Our enemies can bury entire cities under the sand.  Our traditions have not prepared us for such a war.','',26124),
(48351,'enUS','In time, we will rebuild this place and restore it to its former glory - minus all of the annoying humans.','',26124),
(48352,'enUS','Now that we have captured this wretched isle, we need to do some work to get it into shape.  Can you help us out $n?','Now that we have captured this wretched isle, we need to do some work to get it into shape.  Can you help us out $n?',26124),
(48353,'enUS','I am not a fan of that d-block place everyone keeps talking about it.  We do have some tasks that must be completed before we can use it though.','I am not a fan of that d-block place everyone keeps talking about it.  We do have some tasks that must be completed before we can use it though.',26124),
(48354,'enUS','I assume you have heard of the hole by now, $r.  If not, you are going to know a whole lot about it soon.','I assume you have heard of the hole by now, $r.  If not, you are going to know a whole lot about it soon.',26124),
(48355,'enUS','Welcome to Tol Barad, $c.  Time\'s a wastin\' so let\'s get to work.','Welcome to Tol Barad, $c.  Time\'s a wastin\' so let\'s get to work.',26124),
(48356,'enUS','Foul demon! What have you done with my brother?','',26124),
(48357,'enUS','At the cost of your soul? You are no brother of mine! Begone from this place, and never set foot in our lands again!','',26124),
(48358,'enUS','','No! Illidan, how could you?',26124),
(48359,'enUS','It is I, Malfurion. This is what I\'ve become.','',26124),
(48360,'enUS','The leader of the undead has been destroyed, and the forests will heal in time.','',26124),
(48361,'enUS','So be it... brother.','',26124),
(48362,'enUS','What? Who are... you?','',26124),
(48363,'enUS','We do not choose to go to war, $n.  War comes to us.$B$BWe must do what we must to be ready.','',26124),
(48364,'enUS','It sees us...','',26124),
(48365,'enUS','Tear its eyes out!','',26124),
(48366,'enUS','You will tell no one!','',26124),
(48367,'enUS','Intruder...','',26124),
(48368,'enUS','Quit lookin\' at me, ya big purple eye-face! Ah, blast it all, $n. ','',26124),
(48369,'enUS','It ain\'t easy gettin\' a contract with the Blackrock orcs.  I mean, come on!  The Blackrock orcs!  These guys have been through more battles than Aggramar, AND they\'re sittin\' on a mountain made of dark iron to boot!  Cha-ching!','',26124),
(48370,'enUS','Your death will tell a different story!','',26124),
(48371,'enUS','You\'re accused of being a demon in disguise, Navarax... if that\'s even your real name!','You\'re accused of being a demon in disguise, Navarax... if that\'s even your real name!',26124),
(48372,'enUS','I\'d like to challenge your magma lord to a fight.','I\'d like to challenge your magma lord to a fight.',26124),
(48373,'enUS','Yes, my child?','',26124),
(48374,'enUS','It\'s a good thing I showed up when I did!$b$bI\'m guessing we haven\'t seen the last of that Schnottz fellow.','',26124),
(48375,'enUS','Alright boys, we got a challenger!  Time to show the general what our little captive can do!','',26124),
(48376,'enUS','Nooo!  My baby...','',26124),
(48377,'enUS','NOBUNDO! NOOO!','',26124),
(48379,'enUS','You will die this day, Earthwarder! $n will see to it!','',26124),
(48380,'enUS','Aggra... this can\'t be... this has gone too far...','',26124),
(48381,'enUS','Do something, you useless $r. My allies are giving their lives for you!','',26124),
(48382,'enUS','Muln falls! And the Earthen Ring dies with him.','',26124),
(48383,'enUS','You\'ve failed us all, $n. Deathwing has won. The world is doomed.','',26124),
(48384,'enUS','Wake up! We need you, $n!','Wake up! We need you, $n!',26124),
(48385,'enUS','The magma lord is a little... indisposed right now.  Stick around, this won\'t take more than a minute or two.','',26124),
(48386,'enUS','We\'re surrounded! Its defenses are too great. $n! Wake up!','',26124),
(48387,'enUS','Ah ha ha!  Well done!','',26124),
(48388,'enUS','Listen to the Orc. He has a point.','',26124),
(48389,'enUS','You\'re the great champion brought to battle the Aspect of Death?','',26124),
(48390,'enUS','You\'re the hero that is supposed to be my undoing?','',26124),
(48391,'enUS','You\'re helpless. You can\'t even leave that rock.','',26124),
(48392,'enUS','You\'ve failed your race. You\'ve failed all life on Azeroth. Because of you, everyone you\'ve ever known will die... gruesomely and painfully.','',26124),
(48393,'enUS','We need to make for the oasis, $n.$b$bYou about ready to go?','',26124),
(48394,'enUS','<The seedling tilts its leaves up towards you, as if looking in your direction.>','',26124),
(48395,'enUS','Focus, $n.$b$bWe have to get to the Coffer of Promise before Schnottz does!','',26124),
(48396,'enUS','Zhis vas clearly an inside job!$b$bNovone is above suspicion!','',26124),
(48397,'enUS','Uhhh, I suppose I\'m ready...','Uhhh, I suppose I\'m ready...',26124),
(48398,'enUS','The Sludge Fields - BOSS EMOTE','',26124),
(48399,'enUS','I\'m ready to go, Doctor Jones!','I\'m ready to go, Doctor Jones!',26124),
(48400,'enUS','You can command the lions to move with the Move ability.$B$B|TInterface\\Icons\\misc_arrowleft.blp:64|t','',26124),
(48401,'enUS','Hyenas approach from your left flank.  Engage them!','',26124),
(48402,'enUS','%s begins to aim a charged shot at $n!','',26124),
(48403,'enUS','Hello!','',26124),
(48404,'enUS','Wakey wakey!','',26124),
(48405,'enUS','I\'m a tree!','',26124),
(48406,'enUS','Welcome, friend, to the Oasis of Vir\'sar!$b$bA paradise on Azeroth!','',26124),
(48407,'enUS','Could you spare two of your fine tents, Asaq?','Could you spare two of your fine tents, Asaq?',26124),
(48408,'enUS','A strange request, $r, but after what you have done for our prince it would be wrong of me to deny you.','',26124),
(48409,'enUS','They approach from both sides in great numbers now!','',26124),
(48410,'enUS','%s starts sobbing uncontrollably!','',26124),
(48411,'enUS','%s flees in terror!','',26124),
(48412,'enUS','%s screams at the top of its lungs!','',26124),
(48413,'enUS','Follow.','',26124),
(48414,'enUS','Have I chosen wisely, $n?','',26124),
(48415,'enUS','They approach from the right now!  Use your Fierce Roar ability if your lions become overwhelmed!$B$B|TInterface\\Icons\\ability_druid_skinteeth.blp:64|t','',26124),
(48416,'enUS','What does it mean?!','',26124),
(48417,'enUS','It\'s so intense!','',26124),
(48418,'enUS','It burns! IT BURNS!','',26124),
(48419,'enUS','The colors! Nooooooooooooooo!','',26124),
(48420,'enUS','It\'s too much!','',26124),
(48421,'enUS','Get it away!','',26124),
(48422,'enUS','Make it stop! MAKE IT STOP!','',26124),
(48423,'enUS','AAAAAAAAAAAAHHH!!','',26124),
(48424,'enUS','Hey, wait a minute...','Hey, wait a minute...',26124),
(48425,'enUS','I don\'t recognize you...','I don\'t recognize you...',26124),
(48426,'enUS','Hmm... are you new around here...?','Hmm... are you new around here...?',26124),
(48427,'enUS','You\'re not one of us, are you...?','You\'re not one of us, are you...?',26124),
(48428,'enUS','Ouch!  What did I do?','Ouch!  What did I do?',26124),
(48429,'enUS','Hey!  Who gave you the cudgel?','Hey!  Who gave you the cudgel?',26124),
(48430,'enUS','It wasn\'t me, I swear!  You can\'t prove anything!','It wasn\'t me, I swear!  You can\'t prove anything!',26124),
(48431,'enUS','Sorry!  Won\'t happen again, sir!','Sorry!  Won\'t happen again, sir!',26124),
(48432,'enUS','You\'ve been spotted!  Club your target to death before you are unmasked!','You\'ve been spotted!  Club your target to death before you are unmasked!',26124),
(48433,'enUS','You\'ve been unmasked!  Get to safety, then put your disguise back on!','You\'ve been unmasked!  Get to safety, then put your disguise back on!',26124),
(48434,'enUS','What do you think you\'re doing, soldier!?','',26124),
(48435,'enUS','I\'ll slice you in two!  Wait a minute... who are you?','',26124),
(48436,'enUS','Stop that, I\'m no soldier!  Hmm... are you?','',26124),
(48437,'enUS','Is that a mask you\'re wearing, soldier?','',26124),
(48438,'enUS','Heads up, $n! They\'re here. Dragonmaw ... everywhere!','',26124),
(48439,'enUS','Don\'t forget to put on that disguise!','',26124),
(48440,'enUS','What was that? Oh no, the Dragonmaw are here!','',26124),
(48441,'enUS','Fine.  Let\'s see what you and your lions can do.','Fine.  Let\'s see what you and your lions can do.',26124),
(48442,'enUS','Some day I\'ll be able to put my skills at the service of Ramkahen.','',26124),
(48443,'enUS','You hit rock or me hit you!','',26124),
(48444,'enUS','You want me hit rock with you head?','',26124),
(48445,'enUS','More smash rock!  Rar!','',26124),
(48446,'enUS','This is it! They\'re making their final assault. There\'s no place to run. We hold Thundermar or die with hammer in hand.$B$BFor the Wildhammer!!','',26124),
(48447,'enUS','Slow kobold look tasty!','',26124),
(48448,'enUS','Me has whole box of candles!  Maybe give you some if hit rock good!','',26124),
(48449,'enUS','You want get punched?  You make rock die now!','',26124),
(48450,'enUS','Me rip slow kobold to pieces!','',26124),
(48451,'enUS','You too slow!  Want me get Glubtok?','',26124),
(48452,'enUS','Dis look warm!  Me getting sleepy...','',26124),
(48453,'enUS','Yes, this is the spot.','',26124),
(48454,'enUS','Farewell, $n...','',26124),
(48455,'enUS','Look at all dem boxes.  What in dis box?','',26124),
(48456,'enUS','Hey $n! Over here. We need you!','',26124),
(48457,'enUS','Those of the Explorers\' League and The Reliquary are very much alike: Archaeology is our religion, yet we have both fallen from the pure faith.\n\nOur methods have not differed as much as they pretend. We are but a shadowy reflection of them.\n\nIt would take only a nudge to make them like us. To push them out of the light...','',26124),
(48458,'enUS','D\'ye hear it, $n? The beating of great leathery wings over the treetops... Narkrall is closing in.','',26124),
(48459,'enUS','I\'m ready to fight him!','I\'m ready to fight him!',26124),
(48460,'enUS','Here he comes, $n! Flying in from the west. Get your weapons ready!','',26124),
(48461,'enUS','Why stinky candle talk so much?','',26124),
(48462,'enUS','TAKE ITS HEAD!','',26124),
(48463,'enUS','You lose!','',26124),
(48464,'enUS','Vengeance will be ours!','',26124),
(48465,'enUS','Death has found you!','',26124),
(48466,'enUS','SUFFER!','',26124),
(48467,'enUS','I suppose my aim\'s a little off today.','',26124),
(48468,'enUS','I can\'t... miss.. again...','',26124),
(48469,'enUS','Come on... right between the eyes... no.  I suppose not this time.','',26124),
(48470,'enUS','That\'s not fair... my target... it moved!','',26124),
(48471,'enUS','The visions are clouded... like these waters.','',26124),
(48472,'enUS','','Perhaps you did not hear me. I said, get me free of these chains!',26124),
(48473,'enUS','Your disguise has dropped. Be careful!','Your disguise has dropped. Be careful!',26124),
(48474,'enUS','Firelord! I beseech ye... Give me... yer... strength...','',26124),
(48475,'enUS','They\'re alive...','',26124),
(48476,'enUS','THEY\'RE ALIVE!!!','',26124),
(48477,'enUS','RUN!','',26124),
(48478,'enUS','NOOOOOOO!!!','',26124),
(48479,'enUS','Intruders?! Burn them, Pyromancer! Show these heathens the power of RAGNAROS\' FLAME!','',26124),
(48480,'enUS','Your faithful service to the Firelord has not gone unnoticed, Pyromancer.','',26124),
(48481,'enUS','Word of your bold attacks upon surface has reached even our master\'s ears; Cho\'gall himself is pleased.','',26124),
(48482,'enUS','Let the assault continue. Reduce their capital to cinders! Revel in the sacred flame!','',26124),
(48483,'enUS','NOOO! Curse you, mortal! YOU STRUGGLE IN VAIN!','',26124),
(48484,'enUS','You will perish in the Firelord\'s Flame!','',26124),
(48485,'enUS','The will o\' the Firelord be done, Grand Ambassador.','',26124),
(48486,'enUS','There are rumors o\' heroes fightin\' back the elementals, but we\'ll conjure more.','',26124),
(48487,'enUS','In an hour\'s time, their precious city will be nothin\' but ASH.','',26124),
(48488,'enUS','You are close enough to reach Magmaw\'s head!','You are close enough to reach Magmaw\'s head!',26124),
(48489,'enUS','It looks like the cultists had their eye on the druids!$B$BYou can see Wildheart Point through the swirling portal. Stepping through it will take you on a one-way trip back to the camp.$B$BOnce your business here is finished, this would be a good way to make a quick exit.','It looks like the cultists had their eye on the druids!$B$BYou can see Wildheart Point through the swirling portal. Stepping through it will take you on a one-way trip back to the camp.$B$BOnce your business here is finished, this would be a good way to make a quick exit.',26124),
(48490,'enUS','Step through the portal and return to Wildheart Point.','Step through the portal and return to Wildheart Point.',26124),
(48491,'enUS','The Blight Slimes are beginning to react negatively towards your prodding.','The Blight Slimes are beginning to react negatively towards your prodding.',26124),
(48492,'enUS','The Blight Slimes are getting ANGRY!','The Blight Slimes are getting ANGRY!',26124),
(48493,'enUS','The Blight Slimes want your blood!','The Blight Slimes want your blood!',26124),
(48494,'enUS','I can feel my branches surging with life. I cannot wait to give it back to the land.','',26124),
(48495,'enUS','No longer are you bound here, great Princess. Have you not heard?','',26124),
(48496,'enUS','The vaults of the Titans grow weak as chaos flourishes. This prison can no longer contain you.','',26124),
(48497,'enUS','Very well. With your permission, Princess.','',26124),
(48498,'enUS','','Watch your tongues, servant of Deathwing. Do you think me a fool?!',26124),
(48499,'enUS','','Terramok is my home, not my prison. The remains of my beloved make it so.',26124),
(48500,'enUS','','But do not despair, ogre. I will continue to aid you and your... cult. ',26124),
(48501,'enUS','','It pleases me, after all, to cause such strife in the world above... to shake, to shatter, to swallow and crush...',26124),
(48502,'enUS','','...but here I shall remain, forever.',26124),
(48503,'enUS','','Go.',26124),
(48504,'enUS','Use the Keys to the Hot Rod |TInterface\\Icons\\inv_misc_key_12.blp:32|t to get into your car. Pick up your friends, Izzy, Ace, and Gobber.','Use the Keys to the Hot Rod |TInterface\\Icons\\inv_misc_key_12.blp:32|t to get into your car. Pick up your friends, Izzy, Ace, and Gobber.',26124),
(48505,'enUS','Thanks, boss!','Thanks, boss!',26124),
(48506,'enUS','We\'d gone an hour without an injury report. That\'s a new record!','We\'d gone an hour without an injury report. That\'s a new record!',26124),
(48507,'enUS','I hope this isn\'t coming out of my pocket!','I hope this isn\'t coming out of my pocket!',26124),
(48508,'enUS','This healing stuff sure does beat having to pay for medical insurance!','This healing stuff sure does beat having to pay for medical insurance!',26124),
(48509,'enUS','Working conditions are horrible under Trade Prince Gallywix. I hope you become the new Trade $g Prince : Princess;!','Working conditions are horrible under Trade Prince Gallywix. I hope you become the new Trade $g Prince : Princess;!',26124),
(48510,'enUS','Normally, I\'d just shrug off an explosion like that, but I think someone got the nitro and kaja\'mite mixture wrong.','Normally, I\'d just shrug off an explosion like that, but I think someone got the nitro and kaja\'mite mixture wrong.',26124),
(48511,'enUS','It\'s that crazy Hobart Grapplehammer\'s fault! Someone ought to fire that guy and promote his assistant!','It\'s that crazy Hobart Grapplehammer\'s fault! Someone ought to fire that guy and promote his assistant!',26124),
(48512,'enUS','You know I\'d gladly blow myself up for the company with you in charge, boss!','You know I\'d gladly blow myself up for the company with you in charge, boss!',26124),
(48513,'enUS','','Our enemies will perish!',26124),
(48514,'enUS','','I am renewed!',26124),
(48515,'enUS','','Lordaeron is ours!',26124),
(48516,'enUS','','Such glorious, beautiful power!',26124),
(48517,'enUS','','Victory to the Forsaken!',26124),
(48518,'enUS','What is it, underling?  Can\'t you see I\'m busy?','',26124),
(48519,'enUS','I can\'t stand being cooped up in here with all these warlocks.  This is Xi\'lun\'s job, not mine!$b$bI can\'t wait for this battle to start.  I need to be outside, with my dragons.','',26124),
(48520,'enUS','Well look who it is!  The cudgel-bearer $g himself: herself;!','',26124),
(48521,'enUS','','You\'re truly a force to be reckoned with. The beast is done with. Let\'s get out of here. ',26124),
(48522,'enUS','Howdy, partner! Miss Darla built me to make sure all you lil\' pilgrims stay nice an\' safe!$B$BBe sure to listen to Deputy Clunky\'s down-home safety tips! Yeehaw!','',26124),
(48523,'enUS','Me da best bodyguard!','',26124),
(48524,'enUS','No, me!','',26124),
(48525,'enUS','Me got a big board for hit things!','',26124),
(48526,'enUS','Mine gots a nail in it!','',26124),
(48527,'enUS','Mine gots a bigger nail!','',26124),
(48528,'enUS','Mine gots a RUSTY nail!','',26124),
(48529,'enUS','Dats dangerous.','',26124),
(48530,'enUS','Only for da bad guys.','',26124),
(48531,'enUS','But I\'m da best at watchin\' da door.','',26124),
(48532,'enUS','No I am!','',26124),
(48534,'enUS','The land suffers... and RAGES!','',26124),
(48535,'enUS','We are nearly prepared to start this battle, brothers.  Thorg\'izog, what is the matter?  Why are you covering your butt like that?','',26124),
(48536,'enUS','WHAT?  No reason... it\'s just... something is very wrong with my stomach.  I think it\'s something I ate.','',26124),
(48537,'enUS','Can you still lead your troops?  Do you need to promote one of your sergeants?','',26124),
(48538,'enUS','Timan fell from the Pillar of Ash.  Othana was eaten by wolves.  Gorlop fell in lava.  And most of my sergeants were killed in a freak cudgelling accident.','',26124),
(48539,'enUS','I see.  Well, do the best you can.  And Neeralak, why are you all black and smoky?','',26124),
(48540,'enUS','Those imps you had delivered... they woke up and started shooting fireballs at everybody!  It was chaos!','',26124),
(48541,'enUS','Delivered?  Woke up?  What are you even talking about?  Were you attacked by flamekin?','',26124),
(48542,'enUS','Imps, flamekin, whatever!  I don\'t know warlock crap.  Demons all look the same to me!','',26124),
(48543,'enUS','Besides, I\'ve been busy dealing with other issues.  Dozens of my dragons died when those two enemies swept through the front lines.','',26124),
(48544,'enUS','You\'re both failures.  But it doesn\'t matter: with a pit lord on our side, we won\'t need foot soldiers OR dragons.  Behold!','',26124),
(48545,'enUS','One, two, three, four, I declare a thumb war!','',26124),
(48546,'enUS','And now to quickly use the Orb of Domination, before the pit lord turns on us.','',26124),
(48547,'enUS','It... it\'s not doing anything!  The pit lord is loose!','',26124),
(48548,'enUS','The pit lord\'s loose!  We\'re doomed!  Retreat!','',26124),
(48549,'enUS','Quickly, everyone run toward those dragons!  All troops, towards the dragons!  The dragons will save us!','',26124),
(48550,'enUS','I never called any dragons...','',26124),
(48551,'enUS','Alsudar the Bastion and the other warrior trainers may be found overlooking Farstriders\' Square, from near the foundry.','Alsudar the Bastion and the other warrior trainers may be found overlooking Farstriders\' Square, from near the foundry.',26124),
(48552,'enUS','Ah, our esteemed guests have arrived!','',26124),
(48553,'enUS','Cut, bruised, and covered with blood - looks like we have a new winner!','',26124),
(48554,'enUS','Ladies and gentlemen, these deliverers of dismemberment have come out VICTORIOUS! Bets on the next round start now! Let\'s get this money flowin\'.','',26124),
(48555,'enUS','Painful but beautiful! Gurgthock gives you what you want! The best display of carnage in Azeroth. Show me some love, people!','',26124),
(48556,'enUS','OOOOOOOH! Check that mess out! Amazing win! Way to stick it through him!','',26124),
(48557,'enUS','Bah, couldn\'t you have dragged it out a bit! People don\'t pay me when you make it look that easy! Add some theatrics to it, will ya?!','',26124),
(48558,'enUS','WHOA! Call in the cleaning crew. They made a mess of that challenger!','',26124),
(48559,'enUS','DESTROYED! DOMINATED! DECIMATED! DELICIOUSLY DISMEMBERED! You do it just like I like it!','',26124),
(48560,'enUS','I felt that one from the stands! I think we have a clear winner here boys, and the bodyparts littering the arena agree','',26124),
(48561,'enUS','Doubtless they are incensed by my meddling with their fragile little homes.','',26124),
(48562,'enUS','See to it that they are made to feel MOST welcome, hmmm? After all, their bones will be lying here for a long, LONG time...','',26124),
(48563,'enUS','Would I be here if this were not serious?','',26124),
(48564,'enUS','','I have heard you before.  You are here to save your world; to learn from ours.  Greatmother Geyah has charged me with instructing you, and as such, you will listen to me, Go\'el.',26124),
(48565,'enUS','I have told you to call me Thrall.','',26124),
(48566,'enUS','','Yes I know, Go\'el.  Thrall is the leader of the Horde, but you are not here in that capacity.  Look at you: At what you are wearing...',26124),
(48567,'enUS','','You say you have come to seek knowledge and understanding, but you are dressed for battle.  That is why I question you and your willingness to do what must be done.',26124),
(48568,'enUS','My clothing?!  Is that what this has come to now?  We debate the merits of my clothing?','',26124),
(48569,'enUS','The clothing is merely a manifestation of a larger problem.  I\'ve no doubt that you are here to learn, but you must commit yourself both in spirit and in form.','',26124),
(48570,'enUS','','The dwarf speaks the truth.  If you wish to commune with the elements you must do so from the heart.  ',26124),
(48571,'enUS','','Your heart, your love for your land and your people is what has led you here.  It was neither your armor nor your weapons.',26124),
(48572,'enUS','Thrall, you must fully devote yourself to the cause.','',26124),
(48573,'enUS','Aggra shoots Gavan a disapproving look.','Aggra shoots Gavan a disapproving look.',26124),
(48574,'enUS','','Go\'el.  You cannot continue to ride the line between Warchief and Shaman.  The time will come when you must commit to one side fully.  That time is fast approaching.',26124),
(48575,'enUS','I hear what both of you are saying and am grateful for the counsel.','',26124),
(48576,'enUS','If I am to understand all that is transpiring, if I am to make a difference, then my devotion must be absolute.  I must submit.','',26124),
(48577,'enUS','This... is only... the beginning, mortals! You will... ALL DIE!','',26124),
(48578,'enUS','Lots to be done around here, $r.  Are you ready to help?','Lots to be done around here, $r.  Are you ready to help?',26124),
(48579,'enUS','Welcome to baradin base camp.  I know it does not look like much now, but with a little hard work we can whip this place into shape.','Welcome to baradin base camp.  I know it does not look like much now, but with a little hard work we can whip this place into shape.',26124),
(48580,'enUS','There\'s no denying it - they really put that dog down! So much for our former champion!','',26124),
(48581,'enUS','Seems like we never run out of things to do around here.  New orders arrive every day at 3am, it\'s really strange.','Seems like we never run out of things to do around here.  New orders arrive every day at 3am, it\'s really strange.',26124),
(48582,'enUS','It looks like we have one more challenger yet to face though, so let\'s get those wagers in!','',26124),
(48583,'enUS','The Horde have been relentless out here.  Feels like we are fighting two battles at one time.','The Horde have been relentless out here.  Feels like we are fighting two battles at one time.\n',26124),
(48584,'enUS','You all love to hate him, and he\'s glad to shower his hate right back down on ya. LETS... GET... BLOODY!!!','',26124),
(48585,'enUS','Enjoy my fine wares.','',26124),
(48586,'enUS','Thank you, $n. My torment is now at an end.','Thank you, $n. My torment is now at an end.',26124),
(48587,'enUS','The curse ends!','The curse ends!',26124),
(48588,'enUS','Finally, the agony ceases....','Finally, the agony ceases....',26124),
(48589,'enUS','Friends. The Wildhammer way of life is threatened. Our enemies are too numerous for us to remain isolated from one another. We must unite!','',26124),
(48590,'enUS','The Conclave of Wind is nearing full strength!','',26124),
(48591,'enUS','Your bodies are all magnificent! If you\'d be willing to take a small whiff of this chloroform, I promise that you will all wake up 10 times stronger and 100 times more... unified in purpose.','',26124),
(48592,'enUS','No? Well... my offer stands. Just come by anytime and I\'ll be glad to give you the makeover you\'ve always dreamed of.','',26124),
(48593,'enUS','%s begins to gather strength from the remaining Wind Lords!','',26124),
(48594,'enUS','Gentlemen, please -','',26124),
(48595,'enUS','Ach! This\'ll be harder than I thought.','',26124),
(48596,'enUS','%s begins to gather strength from the remaining Wind Lord!','',26124),
(48597,'enUS','Oh, that\'s just like a Firebeard, can\'t see anything past yer own fat nose. We were up to arses and elbows in Dragonmaw. But did you send a single bird to help? NO!','',26124),
(48598,'enUS','I don\'t have to take this. I\'ll be part of no Alliance that has a Firebeard innit. That\'s me final word!','',26124),
(48599,'enUS','Unity? Now? The Thundermars weren\'t exactly unitin\' when them Twilight Shaman tore open our stronghold on the shore.','',26124),
(48600,'enUS','Thundermar, if we weren\'t on holy ground I\'d pop you one so hard yer shoes would be the only thing left standin\'!','',26124),
(48601,'enUS','Oh... OH! YES! Orkus has regained his senses! The foul human mage must have cursed Orkus\' mind. Quickly we must get to shore! Kasha is hurt!','',26124),
(48602,'enUS','Kasha! Come to me! I am fine!','',26124),
(48603,'enUS','KASHA! NO!!','',26124),
(48604,'enUS','I will not survive!$B$B*GULP*$B$BHELP ME!','',26124),
(48605,'enUS','Your feet are touching the ground, Orkus. This is shallow water. Just stand up and walk to shore.','Your feet are touching the ground, Orkus. This is shallow water. Just stand up and walk to shore.',26124),
(48606,'enUS','Explain to Orkus that he is standing in shallow water.|TInterface\\GossipFrame\\GOSSIPGOSSIPICON.blp:32|t','',26124),
(48607,'enUS','Since the fall of Grim Batol, we Wildhammers have never truly been united. Out here in the Highlands, forgotten by the rest of the world, the different clans have all gone their separate ways.$B$BTo join them all back together isn\'t going to be easy. ','',26124),
(48608,'enUS','Yes $n, I heard the whole miserable thing from out here.$B$BI was hoping my old Wildhammer brothers could work things out among themselves, but it doesn\'t look like it.$B$BYou and I are going to have to get creative.  ','',26124),
(48609,'enUS','Come! Walk with me, $n.','',26124),
(48610,'enUS','What a beautiful land this is, wouldn\'t you say?','',26124),
(48611,'enUS','It becomes so easy to take it all for granted when danger surrounds us at every turn.','',26124),
(48612,'enUS','When it becomes difficult to tell friend from foe...','',26124),
(48613,'enUS','But that will all change one day, $n. And when it does, those with vision will be prepared.','',26124),
(48614,'enUS','Uldum is full of treasures, my friend.','',26124),
(48615,'enUS','Some are easy for even simple men to discern, while others require wisdom to see.','',26124),
(48616,'enUS','Lira sent me to watch your backs. If Obsidia is in here, I\'ll keep her busy while you finish her off.','',26124),
(48617,'enUS','I can see that Uldum will one day transform from a dangerous wilderness to a tourist magnet!','',26124),
(48618,'enUS','Haaaaaalp!','',26124),
(48619,'enUS','People will come from all over Azeroth to marvel at her wonders.','',26124),
(48620,'enUS','The Glopgut ogres stormed Thundermar while Colin was here at the summit. They kidnapped Fanny and ran for the hills!','',26124),
(48621,'enUS','I plan on creating a wonder of my own for them to behold...','',26124),
(48622,'enUS','Colin is massing the Thundermars for a full-on assault of Glopgut\'s Hollow. ','',26124),
(48623,'enUS','Here, what\'s this?','',26124),
(48624,'enUS','|cFFFFFFFFI had just finished making use of the facilities on the docks when...|r','',26124),
(48625,'enUS','Ugh, the lok\'tar must have been cooking up a turd - which would explain the smell.','',26124),
(48626,'enUS','$B$B|cFFFFFFFFAs I emerged from the outhouse, I saw them! It should be noted that Orkus prefers silence when he is doing his duty.|r$B','',26124),
(48627,'enUS','By Hellscream\'s axe!','',26124),
(48628,'enUS','It\'s broken.','It\'s broken.',26124),
(48629,'enUS','It\'s not broken!','It\'s not broken!',26124),
(48630,'enUS','Why\'s it shooting steam out of the side there, then?','Why\'s it shooting steam out of the side there, then?',26124),
(48631,'enUS','That\'s the...pressure release valve.','That\'s the...pressure release valve.',26124),
(48632,'enUS','In the middle of the pipe?','In the middle of the pipe?',26124),
(48633,'enUS','Er...backup release valve?','Er...backup release valve?',26124),
(48634,'enUS','We should tell the Admiral.','We should tell the Admiral.',26124),
(48635,'enUS','Oy, \'Linda, where are we meetin\' up with this Ivar Bloodfang fella? An\' what in Bronzebeard\'s name is that terrible smell?','',26124),
(48636,'enUS','You tell him.','You tell him.',26124),
(48637,'enUS','No way!  He gives me the creeps!','No way!  He gives me the creeps!',26124),
(48638,'enUS','I know!  The way he looks at you with those hungry eyes.  I\'m afraid to even turn my back!','I know!  The way he looks at you with those hungry eyes.  I\'m afraid to even turn my back!',26124),
(48639,'enUS','','They are massing at Purgation Isle, just west of us here, off the coast. We are to meet them there, general.',26124),
(48640,'enUS','','As for the smell... *Balinda sniffs at the air* I think it\'s coming from over there...',26124),
(48641,'enUS','Look there, \'Linda! What in the...','',26124),
(48642,'enUS','%s roars and regains control with a burst of will!','',26124),
(48643,'enUS','You face Kingslayer Orkus now, dwarf!','',26124),
(48644,'enUS','KASHA! Your master needs you!','',26124),
(48645,'enUS','ENOUGH TOYIN\' AROUND!!!','',26124),
(48646,'enUS','Let\'s get outta here, \'Linda. We dun wanna draw any unwanted attention!','',26124),
(48647,'enUS','','Aye, general!',26124),
(48648,'enUS','The sights, the sounds, the smells...','',26124),
(48649,'enUS','And I invite you to take part in its creation.','',26124),
(48650,'enUS','Together, we will make history!','',26124),
(48651,'enUS','Soon, our sideshow will be the talk of Azeroth!','',26124),
(48652,'enUS','People will come from far and wide to witness the fruits of our labor, $n.','',26124),
(48653,'enUS','Return to Dreadmaul Rock, or you will be dropped!','',26124),
(48654,'enUS','I will accompany you, Sullah.','I will accompany you, Sullah.',26124),
(48655,'enUS','Come, friend.$b$bWalk with me a while. There is something I want to show you.','',26124),
(48656,'enUS','The Blackrock forces are panicking!  Strike at them now!','',26124),
(48657,'enUS','Rummaging','Rummaging',26124),
(48658,'enUS','Meanwhile, atop Dreadmaul Rock...','',26124),
(48659,'enUS','Completion Event Forthcoming','',26124),
(48660,'enUS','','Suck it down, orc!',26124),
(48661,'enUS','','NOBODY steps on MY town, orc!',26124),
(48662,'enUS','','Is that all you\'ve got!?',26124),
(48663,'enUS','','You want the Fanny? You can\'t HANDLE the Fanny!',26124),
(48664,'enUS','','Oh, you ain\'t so much once yer off yer dragon, are ya?',26124),
(48665,'enUS','','C\'mere! I\'mma give you a pounding, orc!',26124),
(48666,'enUS','','That\'s right, orc. I\'mma beat your tattoos clean off!',26124),
(48667,'enUS','','I will shut you down, orc. I will put you in the dirt!',26124),
(48668,'enUS','Shroud effect expiring!$b$bFind Cover!','',26124),
(48669,'enUS','$n has brought you mudsnout blossom, Kasha. Eat it and you will be healed.','',26124),
(48670,'enUS','%s feeds Kasha the mudsnout blossoms.','',26124),
(48671,'enUS','TO PURGATION ISLE, KASHA! RIDE LIKE THUNDER!','',26124),
(48672,'enUS','These brutes think to raid MY town when my back is turned!? They\'re going to get a taste of Wildhammer justice they will!','',26124),
(48673,'enUS','I\'ve got a ride to Irontree Clearing waiting for me on behalf of Fez Hobnob.','I\'ve got a ride to Irontree Clearing waiting for me on behalf of Fez Hobnob.',26124),
(48674,'enUS','','If we don\'t increase production as much as possible, the Horde might lose this war. If the Horde loses the war, we\'re out on our butts at best and dead at worst.$B$BI hate to break it to you, but the pretty things you might have heard at Whisperwind Grove won\'t save us... but hard work might.',26124),
(48675,'enUS','|cFFFFFFFF$n, Orkus and Kasha flew off to Purgation Isle...|r','|cFFFFFFFF$n, Orkus and Kasha flew off to Purgation Isle...|r',26124),
(48676,'enUS','BEWARE!$b$bMyzerian can see through your disguise!','',26124),
(48677,'enUS','Time to do what I do best... Ruuuuuuuuuuuuuunnn!','',26124),
(48678,'enUS','Sabotaging','Sabotaging',26124),
(48679,'enUS','Wow! Where am I?!','',26124),
(48680,'enUS','That\'s enough! Time to act like a goblin!','',26124),
(48681,'enUS','You don\'t have to tell me that twice!','',26124),
(48682,'enUS','I got it! I got it!','',26124),
(48683,'enUS','Deep breaths... deep breaths!','',26124),
(48684,'enUS','I\'m okay!','',26124),
(48685,'enUS','Pull it together!','',26124),
(48686,'enUS','That felt kinda good!','',26124),
(48687,'enUS','Will you accompany Orkus to Purgation Isle?','',26124),
(48688,'enUS','I will not leave Kasha\'s side.','',26124),
(48689,'enUS','I am ready for Purgation Isle.','I am ready for Purgation Isle.',26124),
(48690,'enUS','I am here to bear witness to the memory of my master, and the truth of the past.','',26124),
(48691,'enUS','What is going on in here?!','',26124),
(48692,'enUS','The Archdruid... how in the world...?','',26124),
(48693,'enUS','I... I must tell the others. You should find Huntress Selura right away.','',26124),
(48694,'enUS','The enemy approaches.  Use the Move ability to move the Ramkahen Champions to the southern ramp.$B$B|TInterface\\Icons\\misc_arrowleft.blp:64|t','',26124),
(48695,'enUS','Use your archers to support your infantry.  A few volleys of flaming arrows will take down most groups.$B$B|TInterface\\Icons\\ability_searingarrow.blp:64|t','',26124),
(48696,'enUS','I\'ve been spotted!','I\'ve been spotted!',26124),
(48697,'enUS','Wretched $r!','Wretched $r!',26124),
(48698,'enUS','This place reeks of evil. It must be purged!','',26124),
(48699,'enUS','Use the Sun\'s Radiance ability if you get overwhelmed!  It will heal your units and deal terrible damage to the opponent.$B$B|TInterface\\Icons\\spell_holy_divineprovidence.blp:64|t','',26124),
(48700,'enUS','The Denmother will have your head!','The Denmother will have your head!',26124),
(48701,'enUS','Leave these forests!','Leave these forests!',26124),
(48702,'enUS','Worgen and dwarves working together... What has this world come to?','',26124),
(48703,'enUS','I\'ll tear you to shreds!','I\'ll tear you to shreds!',26124),
(48704,'enUS','Grrrr...','Grrrr...',26124),
(48705,'enUS','I am sorry that I called you puny, $n. When we first met I thought you just another one of Darthalia\'s pawns.','',26124),
(48706,'enUS','$n, you and I are friends.','',26124),
(48707,'enUS','KROSHIUS CRUSH!','',26124),
(48708,'enUS','Garrosh Hellscream: great warchief or greatest warchief?','',26124),
(48709,'enUS','Don\'t get me wrong, $n, I like Thrall. He was a strong leader, but I don\'t think he was cut out to lead the Horde. Not in a time of war!','',26124),
(48710,'enUS','Did I ever tell you about the time I met Varok Saurfang? I asked him to sign my massive pectoral muscles. He backhanded me instead, which is why I sometimes forget things now. It was totally worth it.','',26124),
(48711,'enUS','Varian Wrynn... I saw him fight once at Dire Maul. He killed five feral scar yetis with his bare hands. Pretty good for a human, no?','',26124),
(48712,'enUS','I wasn\'t there, but I heard that Sylvanas died in Silverpine and that her precious val\'kyr resurrected her at the cost of their own lives. Know anything about it?','',26124),
(48713,'enUS','If Ivar Bloodfang is here, where is Darius Crowley?','',26124),
(48714,'enUS','I liked the worgen better when they were a disorganized mess that you\'d run into in small packs. This new Gilnean worgen alliance is much more difficult to deal with.','',26124),
(48715,'enUS','$n, just between you and me, I never saw the fall of the Lich King. And... well... I\'ve never been to Ulduar. I... well... I am a dungeon explorer. Yes. I prefer exploring dungeons with allies. The pay is excellent and the risk is low.','',26124),
(48716,'enUS','Hillsbrad has changed. Back in my day Hillsbrad was a place of constant battle. The humans and dwarves of Southshore would constantly attack the Horde at Tarren Mill. There were days when you could look out past the intersection at Darrow Hill and see a thousand people battling. Glory days, $n - they\'ll pass you by.','',26124),
(48717,'enUS','I found Kasha in Icecrown. She was injured and dying. I managed to carry her back to the Shadow Vault where the death knights helped nurse her back to health. We are now the best of friends.','',26124),
(48718,'enUS','I have heard tale of the Maelstrom itself opening up, threatening to devour the world. Could you imagine such a thing?','',26124),
(48719,'enUS','If we stop these dwarves and worgen we will be celebrated as great heroes of the Horde!','',26124),
(48720,'enUS','If you\'ve been wrasslin\' with oil, be sure to avoid all sources of sparks or open flame, such as candles, lighters, mages, Kester\'s shop, and Deputy Clunky!','',26124),
(48721,'enUS','Always wear head protection while on the job! You never know when Miss Darla might have to smack you in the face!','',26124),
(48722,'enUS','Deputy Clunky wants all his buckaroos to stay safe, and have a good ol\' fun time, assumin\' you meet your contract-stipulated servitude quota! Gosh!','',26124),
(48723,'enUS','When you\'re doggone tired, it\'s mighty easy to slip up on the job, pardner! Be sure to get at least two hours\' rest between shifts!','',26124),
(48724,'enUS','Oil leak! OIL LEAK! Someone\'s done flipped the switch!','',26124),
(48725,'enUS','None pass!','',26124),
(48726,'enUS','Thank you for saving me! But don\'t tell Ferli, ok? I said I busted out on my own!','',26124),
(48727,'enUS','I have a ride to Talonbranch Glade courtesy of James Hallow.','I have a ride to Talonbranch Glade courtesy of James Hallow.',26124),
(48728,'enUS','Keep your voice low, and your scent downwind.','',26124),
(48729,'enUS','','A few of us here have lived in this land since the Scythe of Elune first passed through it. Most suffered through the fall of Gilneas.$B$BWe have settled in this forest to learn the ways of nature and uphold its balance. In this cursed land, our cursed people have found a new way of life.',26124),
(48730,'enUS','If I had my way, you would be long dead. Your kind disgusts me.','',26124),
(48731,'enUS','I\'m trying to convince Godfrey to just kill all of you to end your misery, but he keeps telling me no. More pain and suffering for the lot of you, then!','',26124),
(48732,'enUS','Bastard.','',26124),
(48733,'enUS','Better to rot in this cell than live as a dishonorable traitor.','',26124),
(48734,'enUS','Brothers and sisters of the Horde, Orgimmar is under attack!  Take up your arms and defend our capital!  If you are unable to wage war against the intruders, then help place barricades to fortify our city!  LOK\'TAR OGAR!','',26124),
(48735,'enUS','','Woo!',26124),
(48736,'enUS','','$n? What are you doing here? And is that Keegan Firebeard behind you?',26124),
(48737,'enUS','','Took yer sweet time, didn\'tcha?',26124),
(48738,'enUS','','Aye, they was getting\' a wee handsy, so I took care of it. C\'mon then, I\'m done here.',26124),
(48739,'enUS','Aye! We\'re here to rescue you!','',26124),
(48740,'enUS','The ogres - ya kilt \'em!','',26124),
(48741,'enUS','Did you see that, $n? What a woman!','',26124),
(48742,'enUS','I won\'t let those damned orcs invade Redridge again!','',26124),
(48743,'enUS','This all feels like a long shot.  We\'ve got a lot riding on this plan.  Redridge\'s freedom, for one.','',26124),
(48744,'enUS','STOP! GET DOWN, $n!','',26124),
(48745,'enUS','CAREFUL! Vanndar, Balinda and Bloodfang are right there also.','',26124),
(48746,'enUS','Ye\'ve made yer way to Chiselgrip, $g lad: lass;.  Best make yerself useful.','',26124),
(48747,'enUS','Look there, near the map table! The Stormpike Battle Master holds the Alliance battle plans!','',26124),
(48748,'enUS','You gotta be friendly with the Bilgewater Cartel goblins before I\'ll teach you how to ride.','You gotta be friendly with the Bilgewater Cartel goblins before I\'ll teach you how to ride, babe.',26124),
(48749,'enUS','You gotta be exalted with the Bilgewater Cartel goblins before I\'ll teach you how to ride.','You gotta be exalted with the Bilgewater Cartel goblins before I\'ll teach you how to ride, babe.',26124),
(48750,'enUS','You ready to ride?','You ready to ride, babe?',26124),
(48751,'enUS','Your Blackrock Disguise has fallen off!','Your Blackrock Disguise has fallen off!',26124),
(48752,'enUS',' I... I have a plan of my own.','',26124),
(48753,'enUS','I will kill the guard at the table and then I will draw the attention of the trio.','',26124),
(48754,'enUS','While I have them distracted you get the plans from the guard\'s corpse. I will call Kasha to pick you up as soon as I see you get the plans.','',26124),
(48755,'enUS','Do not worry about Orkus, $n. I... I will be fine.','',26124),
(48756,'enUS','Stone troggs... the vermin of the deeps.','',26124),
(48757,'enUS','Tell me when you are ready and we will go!|TInterface\\GossipFrame\\GOSSIPGOSSIPICON.blp:32|t','',26124),
(48758,'enUS','Are you ready? You will have to act quickly, $n. I do not know how long I can hold them all off for! Get the plans and get out!','',26124),
(48759,'enUS','I\'m ready, Orkus. Let\'s do this!','I\'m ready, Orkus. Let\'s do this!',26124),
(48760,'enUS','I wish I could make you a deal, partner - I really do - but you\'ll need to be friendly with the Bilgewater Cartel, first.','I wish I could make you a deal, partner - I really do - but you\'ll need to be friendly with the Bilgewater Cartel, first.',26124),
(48761,'enUS','I lost my Blackrock Disguise, Colonel.  May I have another?','I lost my Blackrock Disguise, Colonel.  May I have another?',26124),
(48762,'enUS','I wish I could make you a deal, partner - I really do - but you\'ll need to be exalted with the Bilgewater Cartel, first.','I wish I could make you a deal, partner - I really do - but you\'ll need to be exalted with the Bilgewater Cartel, first.',26124),
(48763,'enUS','Yo! I\'m Kall Worthaton, Bilgewater Trikes.$B$BGo ahead, look over the lot. Pick out the trike that you REALLY want!$B$BA trike that\'s a blast to ride... a trike that\'s dangerous and death-defying... a trike you can be PROUD of!$B$BYou let me know when you see it, and we\'ll make a deal.','Yo! I\'m Kall Worthaton, Bilgewater Trikes.$B$BGo ahead, look over the lot. Pick out the trike that you REALLY want!$B$BA trike that\'s a blast to ride... a trike that\'s dangerous and death-defying... a trike you can be PROUD of!$B$BYou let me know when you see it, and we\'ll make a deal.',26124),
(48764,'enUS','CAN YOU SMELL WHAT THE LOK\'TAR IS COOKIN\'?!','',26124),
(48765,'enUS','GET THE PLANS AND GO!','',26124),
(48766,'enUS','The %s flickers warmly, granting a poriton of its power to $n in thanks.','',26124),
(48767,'enUS','She\'s a real powder-keg that one. She\'d make a fine Firebeard! Y\'think the Thundermars would go for it?','',26124),
(48768,'enUS','\"Archmage Pratt\"? To fel with formality; my vanity died with the rest of me. \"Charles\" or even a simple \"Chaz\" will do, thank you.','',26124),
(48769,'enUS','KASHA, GET $P OUT OF HERE!','',26124),
(48770,'enUS','Let\'s keep moving. There\'s a lot at stake here.','',26124),
(48771,'enUS','FORGET ABOUT ME, KASHA! GO!','',26124),
(48772,'enUS','K... Kasha... you... came back for me...','',26124),
(48773,'enUS','I... I never knew anyone like you. You saved me, $p. More than once. I... I know it\'s selfish, but I have something to ask of you.','',26124),
(48774,'enUS','Somewhere safe...','',26124),
(48775,'enUS','','Be sure to talk to the MacGraffs, inside the sanctuary. They\'ll be orchestratin\' the ceremonies.',26124),
(48776,'enUS','Are you really here to rescue me?  Great, lets go!','Are you really here to rescue me?  Great, lets go!',26124),
(48777,'enUS','I think I can use that horse to make it the rest of the way.  Thanks!','I think I can use that horse to make it the rest of the way.  Thanks!',26124),
(48778,'enUS','You are the best friend that Orkus has ever had, $p. *Orkus coughs*','',26124),
(48779,'enUS',' Please take care of Kasha. Make sure she finds a cold place to live.','',26124),
(48780,'enUS','Flamestar!  I can return these dragons to their kind.  Let me take care of them.','',26124),
(48781,'enUS','As you wish.  Just make sure they don\'t come to no harm.','',26124),
(48782,'enUS','Don\'t forget that disguise!','',26124),
(48783,'enUS','Your conspirator has informed me of your plan.  I shall see you on the battlefield... painted with the ashes of the elementals.','',26124),
(48784,'enUS','Come on boys, let\'s eat!  My favorite soldier brought enough worg for everyone!','',26124),
(48785,'enUS','I guess I\'ll just... leave the sleeping imps right over here?  Are these even... imps?  Gah!','',26124),
(48786,'enUS','You know, I\'m going to be using this orb to perform a powerful ritual in just a few minutes.  Don\'t tell anyone this... but I\'ll be summoning a pit lord.  Redridge will bow to the Blackrock!','',26124),
(48787,'enUS','Ready when you are, Doctor Jones!','Ready when you are, Doctor Jones!',26124),
(48788,'enUS','There\'s no gettin\' away this time, orc! You\'ve sung your last lok\'tar!','',26124),
(48789,'enUS','Alright, $n. Follow me!','',26124),
(48790,'enUS','The cannon was rigged with an explosive trap!','',26124),
(48791,'enUS','My gut\'s telling me....','',26124),
(48792,'enUS','...this way!','',26124),
(48793,'enUS','This should just take a moment.','',26124),
(48794,'enUS','The Bile-O-Tron signals in the affirmative and shuts down permanently.','',26124),
(48795,'enUS','Codes accepted. Activating mechanism.','',26124),
(48796,'enUS','Burn in the liquid heat of the Firelands!','',26124),
(48797,'enUS','What happened? What have you got in your hands there?','',26124),
(48798,'enUS','%s reads the Alliance battle plan.','',26124),
(48799,'enUS','He... He died to get this here?','',26124),
(48800,'enUS','%s lifts Orkus\' lifeless body up.','',26124),
(48801,'enUS','Do not mourn Orkus. He died with honor... with pride. He died a hero of the Horde.','',26124),
(48802,'enUS','From Lordaeron to Kalimdor, they will know his name and they will sing songs of glory, praising the fallen champion of the Horde.','',26124),
(48803,'enUS','Know that what you did will save hundreds, maybe thousands of lives. You are also a true hero of the Horde, $n.','',26124),
(48804,'enUS','Well, that went smoothly for a change.','',26124),
(48805,'enUS','Too good to be true. I might have known.','',26124),
(48806,'enUS','Looks like we do this the hard way. Let\'s go!','',26124),
(48807,'enUS','System failure. Internal data corruption detected.$b$bConstructing defense mechanism.','',26124),
(48808,'enUS','Constructing defense mechanism.','',26124),
(48809,'enUS','Even the skies burn with my fury!','',26124),
(48810,'enUS','Dey be on top of de tall building in de southeast end of de valley.','Dey be on top of de tall building in de southeast end of de valley.',26124),
(48811,'enUS','Inscription','Inscription',26124),
(48812,'enUS','|TInterface\\Icons\\ability_whirlwind.blp:20|t Foe Reaper 5000 begins to activate |cFFFF0000|Hspell:88481|h[Overdrive]|h|r!','',26124),
(48813,'enUS','You be here ta learn fishin\', mon? Or maybe ta buy some tings for it?','You be here ta learn fishin\', mon? Or maybe ta buy some tings for it?',26124),
(48815,'enUS','Take out those crystals, $n! That should shut it down!','',26124),
(48816,'enUS','The sun has set on this mortal world, fools. Make peace with your end, for the hour of twilight falls!','',26124),
(48817,'enUS','Tally ho! The hunt begins!','',26124),
(48818,'enUS','There was no sport in that kill.','',26124),
(48819,'enUS','Pathetic.','',26124),
(48820,'enUS','Killed by lowly commoners. How droll...','',26124),
(48821,'enUS','Leave this accursed place at once!','',26124),
(48822,'enUS','%s\'s bindings have been released! Full powers unlocked.','',26124),
(48823,'enUS','This death is only a temporary respite from my curse.','',26124),
(48824,'enUS','May your soul rest in peace.','',26124),
(48825,'enUS','I hope your spirit finds solace.','',26124),
(48826,'enUS','Intruders in the keep! To arms!','',26124),
(48827,'enUS','One step closer to victory!','',26124),
(48828,'enUS','The attackers weaken!','',26124),
(48829,'enUS','Our vigilance is eternal...','',26124),
(48830,'enUS','Even here I find myself beset by fools!','',26124),
(48831,'enUS','You shall annoy me no longer!','',26124),
(48832,'enUS','This childish effort ends now!','',26124),
(48833,'enUS','My new life was just beginning...','',26124),
(48834,'enUS','Ivar\'s pack failed horribly, so now he sends mercenaries. No matter, your journey ends in agony.','',26124),
(48835,'enUS','That bitch Sylvanas sent you too, did she? No matter, your journey ends in agony.','',26124),
(48836,'enUS','This is the quality of assassin sent to kill me? Laughable.','',26124),
(48837,'enUS','Murder never gets old.','',26124),
(48838,'enUS','I thank you for the clean death. I would not have done the same...','',26124),
(48839,'enUS','Listen!$b$bTaking out those crystals should drain the construct.','',26124),
(48840,'enUS','We have to make our way to the coffer without tipping off Schnottz and his boys.','',26124),
(48841,'enUS','%s begins channelling power for a massive attack!','',26124),
(48842,'enUS','A Rabid Mastiff growls...','',26124),
(48843,'enUS','The Rabid Mastiff slobbers all over the floor...','',26124),
(48844,'enUS','Use your Hot Rod |TInterface\\Icons\\inv_misc_key_12.blp:32|t to run over Hired Looters and get their loot.','Use your Hot Rod |TInterface\\Icons\\inv_misc_key_12.blp:32|t to run over Hired Looters and get their Stolen Loot.',26124),
(48845,'enUS','The dog stares blankly at the wall...','',26124),
(48846,'enUS','Tear him apart!','',26124),
(48847,'enUS','Yeah, get him!','',26124),
(48848,'enUS','Hah!$b$bYou\'ve really stirred up a sandstorm, $n.','',26124),
(48849,'enUS','The Blackrock orcs are my kin.  My father was a Blackrock, as was his father before him.  My mother was a Blackrock.  And I am a Blackrock.$b$bBut before anything else, I am an orc.  And that means honor above all else.$b$bMy Highlord has granted me leave to complete my task here in the Burning Steppes.  And I will not leave until the Blackrock orcs here learn the error of their ways.','',26124),
(48850,'enUS','I serve my father and respect his plan... but I also serve my own sense of justice.  I have seen enough treachery from my Blackrock brothers to fill a thousand books.  And now they plan to invade Redridge, for no reason other than blind territorialism.$b$bThe treachery stops here.  It\'s time for the final chapter.  And it\'s not going to be a happy ending.','',26124),
(48851,'enUS','I lost my Blackrock Disguise, sir.  May I have another?','I lost my Blackrock Disguise, sir.  May I have another?',26124),
(48852,'enUS','It was all her fault! She told us to steal it!','It was all her fault! She told us to steal it!',26124),
(48853,'enUS','My children... what have I done?','My children... what have I done?',26124),
(48854,'enUS','No... I was to live forever... I will still...','No... I was to live forever... I will still...',26124),
(48855,'enUS','It\'s our fault... the destruction is all our fault...','It\'s our fault... the destruction is all our fault...',26124),
(48856,'enUS','The crystal can still be found... if we can just find it again...','The crystal can still be found... if we can just find it again...',26124),
(48857,'enUS','So tired... just want to rest...','So tired... just want to rest...',26124),
(48858,'enUS','The crystal will save us! We can be saved!','The crystal will save us! We can be saved!',26124),
(48859,'enUS','He had it coming.','',26124),
(48860,'enUS','Good show!','',26124),
(48861,'enUS','','Why\'s the ground shaking, $n?!',26124),
(48862,'enUS','What was that thing, $g dude : toots;?','',26124),
(48863,'enUS','I was just comin\' to see you. Honest!','',26124),
(48864,'enUS','I\'m tryin\' to run a business here!','',26124),
(48865,'enUS','<Jack grunts something about the hammer being his weapon... you think.>','',26124),
(48866,'enUS','','Oh no you didn\'t!',26124),
(48867,'enUS','I am freed! Let us slay Hallazeal in Neptulon\'s name, $n. He lurks within the temple.','I am freed! Let us slay Hallazeal in Neptulon\'s name, $n. He lurks within the temple.',26124),
(48868,'enUS','Derak Nightfall, at your service!','',26124),
(48869,'enUS','I wish to buy from you, Derak.','I wish to buy from you, Derak.',26124),
(48870,'enUS','%s goes into a murderous rage!','%s goes into a murderous rage!',26124),
(48871,'enUS','I had no idea Sullah had so many... acquaintances.','',26124),
(48872,'enUS','See you there, $n!','',26124),
(48873,'enUS','Hallo, friend!$B$BRussell\'s the name, and music is my business. All the great Wildhammer heroes from ages past are kept alive with song. Through the strings of my lute and the sound of my voice, our warriors gain immortality.$B$BStay a while, and listen!','',26124),
(48874,'enUS','Let\'s get started! The first verse is all about dear Fanny, but I just can\'t quite put it together.$B$BWhat rhymes with \"Eyes?\"','',26124),
(48875,'enUS','Ah, I see what kind of $c you are, $n! Now then, the second verse is all about Fanny and Firebeard getting together.$B$BWhat rhymes with \"Professed?\"','',26124),
(48876,'enUS','...Hmmm, okay, I think I can make that work. Last verse! A rousing celebration of love calling the Wildhammer to action!$B$BAll I need is a rhyme for \"Unite...\"','',26124),
(48877,'enUS','[Romantic:] \"Wise.\"','[Romantic:] \"Wise.\"',26124),
(48878,'enUS','I need a gryphon, Guthrum.  I\'m headed to Western Plaguelands.  My king needs me!','I need a gryphon, Guthrum.  I\'m headed to Western Plaguelands.  My king needs me!',26124),
(48879,'enUS','[Silly:] \"Pint-Sized.\"','[Silly:] \"Pint-Sized.\"',26124),
(48880,'enUS','[Bawdy:] \"Thighs!\"','[Bawdy:] \"Thighs!\"',26124),
(48881,'enUS','[Romantic:] \"Blessed.\"','[Romantic:] \"Blessed.\"',26124),
(48882,'enUS','[Silly:] \"Arrest.\"','[Silly:] \"Arrest.\"',26124),
(48883,'enUS','[Bawdy:] \"...Chest?','[Bawdy:] \"...Chest?\"',26124),
(48884,'enUS','[Romantic:] \"Alight.\"','[Romantic:] \"Alight.\"',26124),
(48885,'enUS','[Silly:] \"Knifefight.\"','[Silly:] \"Knifefight.\"',26124),
(48886,'enUS','[Bawdy:] \"Tight!\"','[Bawdy:] \"Tight!\"',26124),
(48887,'enUS','Speak your peace, $c.','',26124),
(48888,'enUS','I need a bat, Kellen.  I\'m headed to Western Plaguelands.  The Dark Lady needs me!','I need a bat, Kellen.  I\'m headed to Western Plaguelands.  The Dark Lady needs me!',26124),
(48889,'enUS','I\'m ready, Russell. Let\'s write a song!','I\'m ready, Russell. Let\'s write a song!',26124),
(48890,'enUS','I need a bat, Timothy.  I\'m headed to Andorhal.  The Dark Lady needs me!','I need a bat, Timothy.  I\'m headed to Andorhal.  The Dark Lady needs me!',26124),
(48891,'enUS','I need a gryphon, Bibilfaz.  I\'m headed to Andorhal.  My king needs me!','I need a gryphon, Bibilfaz.  I\'m headed to Andorhal.  My king needs me!',26124),
(48892,'enUS','My lute is all tuned up. Are we ready to compose something?','',26124),
(48893,'enUS','|cFFFFFFFFSofera\'s Naze, the first of the four fingers of Hillsbrad.|r','',26124),
(48894,'enUS','','I wasn\'t expecting anyone down here. Come to keep me company, or just looking for a way out?',26124),
(48895,'enUS','I\'d like to leave this place.','I\'d like to leave this place.',26124),
(48896,'enUS','Relief at last...','Relief at last...',26124),
(48897,'enUS','Thank you...','Thank you...',26124),
(48898,'enUS','Leave now... you do not deserve to suffer the crystal\'s wrath...','Leave now... you do not deserve to suffer the crystal\'s wrath...',26124),
(48899,'enUS','It\'s time to go...','It\'s time to go...',26124),
(48900,'enUS','The crystal has returned. You must leave...','The crystal has returned. You must leave...',26124),
(48901,'enUS','|cFFFFFFFFCorrahn\'s Dagger, the second of the four fingers of Hillsbrad.|r','',26124),
(48902,'enUS','|cFFFFFFFFThe Headland, the third of the four fingers of Hillsbrad.|r','',26124),
(48903,'enUS','|cFFFFFFFFGavin\'s Naze, the fourth and final finger of Hillsbrad.|r','',26124),
(48904,'enUS','|cFFFFFFFFThe Stormpike have enlisted the help of SI:7 operatives. This is their scouting outpost.|r','',26124),
(48905,'enUS','You\'re dissolving! Find the aid of an Earthen Ring Shaman!','You\'re dissolving! Find the aid of an Earthen Ring Shaman!',26124),
(48906,'enUS','|cFFFFFFFFThe Stormpike are using this as a forward base camp for their soldiers.|r','',26124),
(48907,'enUS','|cFFFFFFFFThey train their military here, teaching them new and exciting ways to kill us.|r','',26124),
(48908,'enUS','|cFFFFFFFFMost well protected of the fingers. Their terrible siege engines are assembled here.|r','',26124),
(48909,'enUS','|cFFFFFFFFTogether the fingers represent the grasp of Stormpike closing upon us. They must be destroyed.|r','',26124),
(48910,'enUS','In Thundermar the tales proclaimed','',26124),
(48911,'enUS','Of a beauty destined for fame','',26124),
(48912,'enUS','Soft emerald green eyes framed a countenance, wise','',26124),
(48913,'enUS','The people cried \"Fanny,\" her name.','',26124),
(48914,'enUS','Of her suitors she was unimpressed','',26124),
(48915,'enUS','\'Til Mighty Firebeard crossed heart and professed','',26124),
(48916,'enUS','To the heavens above our hero claimed love','',26124),
(48917,'enUS','Of a depth the like few can be blessed.','',26124),
(48918,'enUS','Now let cheering dispel the twilight','',26124),
(48919,'enUS','And let the Wildhammers unite!','',26124),
(48920,'enUS','Answer the call, know that love conquers all','',26124),
(48921,'enUS','And let\'s set these whole Highlands alight!','',26124),
(48922,'enUS','She came from Thundermar, they say','',26124),
(48923,'enUS','Ballyhoo hip hip hooray!','',26124),
(48924,'enUS','Guys sighed and plied eyes on this pint-sized prize','',26124),
(48925,'enUS','\'Twas Fanny fo Fanny hey hey.','',26124),
(48926,'enUS','Then Firebeard decreed his plea','',26124),
(48927,'enUS','Ho diddly whoa diddly dee','',26124),
(48928,'enUS','His goal he professed was marital arrest','',26124),
(48929,'enUS','Oh Fanny! No Fanny, don\'t flee!','',26124),
(48930,'enUS','Now the Wildhammers are one!','',26124),
(48931,'enUS','Whoa doggy hot diggity dun','',26124),
(48932,'enUS','Unite and take flight, it\'s a Twilight knifefight','',26124),
(48933,'enUS','For Fanny! For Firebeard! For fun!','',26124),
(48934,'enUS','In Thundermar the tales proclaimed','',26124),
(48935,'enUS','Of a bold lass destined for fame','',26124),
(48936,'enUS','With emerald green eyes and big man-crushing thighs','',26124),
(48937,'enUS','And \"Fanny,\" a most fitting name.','',26124),
(48938,'enUS','Ol\' Firebeard he made her his quest','',26124),
(48939,'enUS','On one knee his love he professed:','',26124),
(48940,'enUS','\"Oh Fanny me Fanny, do marry me can ye?','',26124),
(48941,'enUS','I loves ya and I loves yer chest.\"','',26124),
(48942,'enUS','Now let cheering dispel the twilight','',26124),
(48943,'enUS','And let the Wildhammers unite!','',26124),
(48944,'enUS','They\'re short an\' they\'re stout, but no man can doubt:','',26124),
(48945,'enUS','Firebeard and his Fanny are tight.','',26124),
(48946,'enUS','You don\'t understand! I had to study it. I HAD TO!','',26124),
(48947,'enUS','Forgive... me...','',26124),
(48948,'enUS','I thought for sure I was going to be this smelly beast\'s dinner!','I thought for sure I was going to be this smelly beast\'s dinner!',26124),
(48949,'enUS','','Good evening.',26124),
(48950,'enUS','','I hope my people have been welcoming to you. These are burdened times, so I fear much may be competing with their good graces.',26124),
(48951,'enUS','Not at all, priestess. We are very grateful for all that you\'ve offered us here.','',26124),
(48952,'enUS','','When we spoke previously, you offered to repay the favor. I may have to act on that sooner than I would have liked.',26124),
(48953,'enUS','','There is trouble at Lor\'danel, a village of ours across the waters from Rut\'theran.',26124),
(48954,'enUS','','If any of your people can be spared, I fear war encroaching upon us in Kalimdor.',26124),
(48955,'enUS','I know the perfect people for such a task. I will send them immediately, priestess.','',26124),
(48956,'enUS','Thank you, Genn. I am glad to see such poise and composure from your people. Perhaps your curse does not define you after all.','',26124),
(48957,'enUS','','Priestess Tyrande! We did not expect you. Good evening.',26124),
(48958,'enUS','','We will take our leave. Again, welcome to all of you.',26124),
(48959,'enUS','Careful there, $gladdie:lass;. Between the worg down below and the orcs lurking in the pass, a $c could get $ghisself:herself; killed up here.','',26124),
(48961,'enUS','%s binds the $n to his will!','',26124),
(48962,'enUS','','You are mine!',26124),
(48963,'enUS','','The Banshee Queen has plans for you, human.',26124),
(48964,'enUS','','Nowhere to run!',26124),
(48965,'enUS','','Death is only the beginning.',26124),
(48966,'enUS','%s roars furiously!','',26124),
(48967,'enUS','You are not of the dark path! You do not belong here, $r.','',26124),
(48968,'enUS','The shadows will consume you. You are not prepared to face the void.','',26124),
(48969,'enUS','That foul thing got stains all over my new robes!','That foul thing got stains all over my new robes!',26124),
(48970,'enUS','Cho\'gall will have your heads! ALL OF THEM!','',26124),
(48971,'enUS','The wyrms will eat well tonight!','',26124),
(48972,'enUS','The burden of the damned falls upon you!','',26124),
(48973,'enUS','I\'m... so... dizzy. ','I\'m... so... dizzy. ',26124),
(48974,'enUS','Thanks fer savin\' me! When you passed out, I thought we were done fer!','Thanks fer savin\' me! When you passed out, I thought we were done fer!',26124),
(48975,'enUS','Call in a Banshee with the Banshee Mirror!','Call in a Banshee with the Banshee Mirror!',26124),
(48976,'enUS','When I said we should strike at the heart of the beast, going through it\'s stomach wasn\'t what I had in mind...','When I said we should strike at the heart of the beast, going through it\'s stomach wasn\'t what I had in mind...',26124),
(48977,'enUS','The power of the elements is strong here. Little wonder this is where they chose to summon a servant of the old gods.','The power of the elements is strong here. Little wonder this is where they chose to summon a servant of the old gods.',26124),
(48978,'enUS','I had a terrible vision - the sky was blotted out and there was dirt everywhere. ...I thought I\'d gone back to Deepholm.','I had a terrible vision - the sky was blotted out and there was dirt everywhere. ...I thought I\'d gone back to Deepholm.',26124),
(48979,'enUS','It\'s about time we returned to the Highlands! \"Twilight\" be damned.','It\'s about time we returned to the Highlands! \"Twilight\" be damned.',26124),
(48980,'enUS','I think I saw something like this on the Exodar once...','I think I saw something like this on the Exodar once...',26124),
(48981,'enUS','Many confuse the Earthen Ring with the Cenarion Circle. ...I TOLD Thrall we should rename ourselves the \"Earthen Square\".','Many confuse the Earthen Ring with the Cenarion Circle. ...I TOLD Thrall we should rename ourselves the \"Earthen Square\".',26124),
(48982,'enUS','|TInterface\\Icons\\spell_fire_twilightflamebreath.blp:20|t%s begins to cast |cFFFF0000|Hspell:90949|h[Devouring Flames]|h|r!','',26124),
(48983,'enUS','Shaman and druid ways are very different. When was the last time you saw one of us turn into a wild beast?  ... nevermind.','Shaman and druid ways are very different. When was the last time you saw one of us turn into a wild beast?  ... nevermind.',26124),
(48984,'enUS','We command the power of the elements. Storm, Earth and Fire!  I\'d never dress like an oversized chicken and shoot moon beams from the sky. ','We command the power of the elements. Storm, Earth and Fire!  I\'d never dress like an oversized chicken and shoot moon beams from the sky. ',26124),
(48985,'enUS','THE MASTER WOULD HAVE YOU SILENT.','',26124),
(48986,'enUS','I command the power of the storm. It sounds impressive, but you wake up with static cling every morning.','I command the power of the storm. It sounds impressive, but you wake up with static cling every morning.',26124),
(48987,'enUS','I can\'t wait to smash that old god brain between me fists!','I can\'t wait to smash that old god brain between me fists!',26124),
(48988,'enUS','FEAR NOT ZIN-MALOR. IT WILL NEVER BELONG TO ANOTHER.','',26124),
(48989,'enUS','Do ye know how hard it was to find a set of weapons that matched me armor?','Do ye know how hard it was to find a set of weapons that matched me armor?',26124),
(48990,'enUS','Other shaman used to say, \"Only yer offhand should be flaming.\" What were they going on about?','Other sshaman used to say, \"Only yer offhand should be flaming.\" What were they going on about?',26124),
(48991,'enUS','Thanks fer saving me, $gladdie:lassie;, I had a horrible vision. I was trapped in a cave of flame, forced to drop totems and heal irate warriors for years on end without seeing a single piece of shaman gear.','Thanks fer saving me, $gladdie:lassie;, I had a horrible vision. I was trapped in a cave of flame, forced to drop totems and heal irate warriors for years on end without seeing a single piece of shaman gear.',26124),
(48992,'enUS','To restore life is to restore the natural order of the elements.','To restore life is to restore the natural order of the elements.',26124),
(48993,'enUS','Shamanistic healing is a complex art. You can\'t just chain heal all day.','Shamanistic healing is a complex art. You can\'t just chain heal all day.',26124),
(48994,'enUS','Few truly understand the shamanistic connection to the earth. It binds wounds, protects us from harm.','Few truly understand the shamanistic connection to the earth. It binds wounds, protects us from harm.',26124),
(48995,'enUS','I fail to understand why they banned totemic cleansing. No one was ever in range, anyways.','I fail to understand why they banned totemic cleansing. No one was ever in range, anyways.',26124),
(48996,'enUS','','Alright den... you just take de bits here, any bits, it don\' matter, livin\' or stone or what...',26124),
(48997,'enUS','I need a flight to Dustwallow Marsh.','I need a flight to Dustwallow Marsh.',26124),
(48998,'enUS','','An\' if you cross ya eyes, an\' hold ya thumbs toward de sky, an\' press REAL hard...',26124),
(48999,'enUS','','...de E\'ko sometime come out! Just like dat.',26124),
(49000,'enUS','Even though these presents are empty, they help remind me of old friends and better times.','',26124),
(49001,'enUS','Iso\'rath\'s stomach begins to churn as the brain is attacked!','Iso\'rath\'s stomach begins to churn as the brain is attacked!',26124),
(49002,'enUS','HEY! What the heck, guy?!','',26124),
(49003,'enUS','Of all the slimy, inconsiderate, bullheaded...','',26124),
(49004,'enUS','HAH! Are ye lost little $g boy:girl;?','HAH! Are ye lost little $g boy:girl;?',26124),
(49005,'enUS','Yer time is up, $g lad:lass;! The Stormpike are takin\' Hillsbrad!','Yer time is up, $g lad:lass;! The Stormpike are takin\' Hillsbrad!',26124),
(49006,'enUS','What\'s this then?','What\'s this then?',26124),
(49007,'enUS','OY! GET A ROPE!','OY! GET A ROPE!',26124),
(49008,'enUS','You\'ve stumbled upon the wrong camp!','You\'ve stumbled upon the wrong camp!',26124),
(49009,'enUS','High alert, soldiers! Reports are comin\' in of some enemy activity near Sofera\'s Naze!','',26124),
(49010,'enUS','How\'s it lookin\' over here? Any activity?','',26124),
(49011,'enUS','Keep yer cool, soldiers. We\'ll be on the move soon.','',26124),
(49012,'enUS','','You\'re the most handsome boyfriend a girl could hope for. Knock \'em dead, honey!',26124),
(49013,'enUS','Look at you! I\'m the luckiest boyfriend on the island!!!','',26124),
(49014,'enUS','|TINTERFACE\\ICONS\\Spell_Frost_WindWalkOn.blp:20|t%s begins to cast |cFFFF0000|Hspell:87770|h[Wind Burst]|h|r!','',26124),
(49015,'enUS','','You better get upstairs pronto, boss. Trade Prince Gallywix is waiting for you.',26124),
(49016,'enUS','','$n, you have to hurry and break your moolah out of the bank!',26124),
(49017,'enUS','Boss, tell Sassy that I\'ll get her more Kaja\'Cola just as soon as production resumes.','',26124),
(49018,'enUS','','He\'ll get me more later? How are we supposed to get you promoted to Trade $g Prince : Princess; without our number one product on the shelves?!!!',26124),
(49019,'enUS','','Ooh, I think you\'re gonna like this, boss!',26124),
(49020,'enUS','','There they are! Okay, you three make sure that you help $g him : her; out today. $G He\'s : She\'s; got a lot of stuff to take care of before the party!',26124),
(49021,'enUS','','Ace, Izzy, Gobber, you three make sure you tag along with $n and help $g him : her; take care of those deadbeats!',26124),
(49022,'enUS','Make sure you pull plenty of moolah out of the bank. I don\'t want you buying any of that cheap clothing you usually like to wear. This party\'s important!','',26124),
(49023,'enUS','','Make sure you pull plenty of moolah out of the bank. I don\'t want you buying any of that cheap clothing you usually like to wear. This party\'s important!',26124),
(49024,'enUS','You people cool your heels! $n is here. $G He\'s : She\'s; gonna be the next Trade $G Prince : Princess;!','',26124),
(49025,'enUS','You gotta hurry, kid. We gotta get you into the game. But first, we gotta get the parts for that shredder!','',26124),
(49026,'enUS','Get into that shredder and win the game. The Bilgewater Cartel\'s counting on you!','',26124),
(49027,'enUS','You got the juice, kid. That\'s for sure! Too bad that dragon had to come and ruin everything. No matter. You made us proud. Now get back to headquarters.','',26124),
(49028,'enUS','All you gotta do is let me teach you how to do a Steady Shot and then use it on these training dummies right here.','',26124),
(49029,'enUS','All you gotta do is learn how to cast Frost Nova. Then, head over to the training dummies that Bamm is shooting at and let \'er rip.','',26124),
(49030,'enUS','','All you gotta do is learn Shadow Word: Pain and use it on some of the training dummies around here!',26124),
(49031,'enUS','','All you gotta do is let me teach you how to do an Eviscerate. Then, head over to one of those training dummies that Bamm is shooting at and attack it with a Sinister Strike. Once you\'ve done that, finish it off with the Eviscerate.',26124),
(49032,'enUS','All you gotta do is let me teach you how to perform a Primal Strike and then use it on these training dummies that Bamm is shooting at.','',26124),
(49033,'enUS','All you gotta do is learn how to cast Corruption, and then go use it on these training dummies that Bamm is shooting at. Corrupt \'em!','',26124),
(49034,'enUS','Insert coins to let Warrior-Matic NX-01 teach you how to Charge. Then use it on the training dummies.','',26124),
(49035,'enUS','','I\'ll set the cap to auto-activate once you\'re at the villa. Just make sure you avoid those pigs!',26124),
(49036,'enUS','I need a flight to Chillwind Camp, please.','I need a flight to Chillwind Camp, please.',26124),
(49037,'enUS','I need a flight to the Bulwark, please.','I need a flight to the Bulwark, please.',26124),
(49038,'enUS','I can\'t believe the nerve of those trolls. Rebelling after all that I\'ve done for them!','',26124),
(49039,'enUS','Ya got some nerve, mon!','',26124),
(49040,'enUS','Ya bring down da big badda dragon an\' destroy da island!','',26124),
(49041,'enUS','I not gonna take it anymore, mon!','',26124),
(49042,'enUS','Kezan for da trolls!','',26124),
(49043,'enUS','Outa my way, mon. I\'m off ta join da pirates!','',26124),
(49044,'enUS','Maybe I take dem bombs from ya an\' we see who go boom!','',26124),
(49045,'enUS','Dis here be our kaja\'mite! We mine it up with our own sweat an\' blood!','',26124),
(49046,'enUS','Lil\' green goblin gonna bleed for all ya done!','',26124),
(49047,'enUS','Yeah? Whadya want, ya mook? Be on the lookout for that no-good $n!$B$BNow get back to work!','',26124),
(49048,'enUS','','Need a ride, $g sugar: scumbag;?  Hop on.  We\'re headed down to Bogpaddle, and it\'s a one way trip.',26124),
(49049,'enUS','Alright!  Let\'s head down to the Swamp of Sorrows!','Alright!  Let\'s head down to the Swamp of Sorrows!',26124),
(49050,'enUS','I\'m here to escort a delivery to Kirthaven.','I\'m here to escort a delivery to Kirthaven.',26124),
(49051,'enUS','Keep yer eyes open, $n! That road is crawling with Dragonmaw.','',26124),
(49052,'enUS','Woohoo! We got us a convoy!','',26124),
(49053,'enUS','Mortals that fancy themselves HEROES have entered the Broken Hall. Oh, I do hope this \"raid\" will amuse me more than the last.','',26124),
(49054,'enUS','Hmm... the Omnotron Defense System. Centuries ago these constructs were considered the Dwarves\' greatest technical achievements. With so many counters to each construct\'s attacks, I\'ll have to rectify these designs for them to provide me any entertainment.','',26124),
(49055,'enUS','You would like to move away from that, wouldn\'t you? Too bad.','',26124),
(49056,'enUS','Stupid Dwarves and your fascination with runes! Why would you create something that would help your enemy?','',26124),
(49057,'enUS','Lightning Conductor works much better in a crowd, yes?','',26124),
(49058,'enUS','Were you planning on using Toxitron\'s chemicals to damage the other constructs? Clever plan, let me ruin that for you.','',26124),
(49059,'enUS','I should have known better than to rely on something so stupidly named to entertain me for long.','',26124),
(49060,'enUS','I found this fascinating specimen in the lava underneath this very room. Magmaw should provide an adequate challenge for your pathetic little band.','',26124),
(49061,'enUS','On second thought, what fun is an \"adequate\" challenge?','',26124),
(49062,'enUS','You won? How... disappointing. I could have easily watched you all continue to stand in the fire.','',26124),
(49063,'enUS','Ah, Chimaeron, truly a living testament to my scientific prowess. I reworked and twisted his form countless times over the years, and the final result is truly something to behold.','',26124),
(49064,'enUS','Oh, you were expecting something else to happen just then, weren\'t you? Let\'s see how well YOU adapt after a new set of \"adjustments,\" shall we?','',26124),
(49065,'enUS','Stop fighting yourself this instant, Chimaeron!','',26124),
(49066,'enUS','This fight has gotten a bit stale; allow me to spice things up!','',26124),
(49067,'enUS','Hmm... a shame to lose that experiment.','',26124),
(49068,'enUS','Maloriak, try not to lose to these mortals. Semicompetent help is SO hard to create.','',26124),
(49069,'enUS','Your mixtures are weak, Maloriak! They need a bit more... kick!','',26124),
(49070,'enUS','Congratulations! Allow me to grant you a title befitting the amazing achievement you just performed. Henceforth you shall be known as the \"Slayer of Stupid, Incompetent, and Disappointing Minions.\"','',26124),
(49071,'enUS','','I can\'t stand to watch. So many good memories. So much profit.',26124),
(49072,'enUS','Welcome, friend of the Wildhammer!$B$BKirthaven is the spiritual center of our people, the one place where the varied clans can come together in peace.$B$BIt\'s here we honor our dead heroes, before burying them with their gryphons atop Mount Thunderstrike. There they spend eternity at one with the sky.','',26124),
(49073,'enUS','You begin to cast |cFFFF0000|Hspell:91317|h[Worshipping]|h|r!','',26124),
(49074,'enUS','Atramedes, are you going deaf as well as blind? Hurry up and kill them all.','',26124),
(49075,'enUS','Atramedes, the heroes are right THERE!','',26124),
(49076,'enUS','These shields are proving quite the nuisance.','',26124),
(49077,'enUS','You should have been disposed of a long time ago.','',26124),
(49078,'enUS','A wedding, eh? If that doesn\'t bring this bunch together, I\'ll eat my hammer!$B$BWe need to make sure this wedding is spectacular, $n, and we\'re going to need your help. There\'s an old Wildhammer saying... let me think... how does it go?','',26124),
(49079,'enUS','Perhaps we ought to give the enemy what they\'re after... and spare our people the coming bloodshed.','',26124),
(49080,'enUS','If that is all they want then perhaps war can be avoided.  The coming bloodshed could be prevented!','',26124),
(49081,'enUS','I must act to protect my people first.  Our enemies buried Orsis in the desert.  How do you fight against that sort of power?','',26124),
(49082,'enUS','Your words ring true, brother.... but even a king cannot make this decision alone.  I will put the issue to a High Council vote.','',26124),
(49083,'enUS','The wedding\'s a go! I\'m going to need a gift for the happy couple, of course. Something important.$B$BThe future of the Wildhammer really hinges on this one last chance to bring us all together!','',26124),
(49084,'enUS','Cho\'gall beckons and casts |cFF006EFD|Hspell:91303|h[Conversion]|h|r!','',26124),
(49085,'enUS','I urge you to reconsider, Phaoris. Deathwing would use the scepters\' power to unravel the secrets of Uldum and unleash great destruction.','',26124),
(49086,'enUS','We fight to the death, Phaoris!  Our race was created to guard this land.  We must not betray that legacy.','',26124),
(49087,'enUS','I defer to your wisdom, brother.  Let us pray we are quick to come to a decision.  The enemy will not wait.','',26124),
(49088,'enUS','Now that you\'ve helped me to establish my ice cream empire, make sure to enjoy one of my many tasty concoctions!','',26124),
(49089,'enUS','So you have come seeking our aid?','',26124),
(49090,'enUS','%s coughs.','',26124),
(49091,'enUS','I... *cough* I have been alive for a very long time. In that time I have seen and done terrible things.','',26124),
(49092,'enUS','Things that still keep me awake at night.','',26124),
(49093,'enUS','But these terrible things that I have done and the people that I have harmed - I know them... I face them... and I feel remorse for them.','',26124),
(49094,'enUS','But the Forsaken. *cough* What do they feel?','',26124),
(49095,'enUS','They ravage the land and destroy everything that they touch. How many lives have been lost to their vile poisons?','',26124),
(49096,'enUS','How many innocents have fallen before the Forsaken war machine?','',26124),
(49097,'enUS','Countless... countless lives... *cough*','',26124),
(49098,'enUS','Yes... I have done terrible things, but nothing could ever be as terrible as lending aid to the Forsaken.','',26124),
(49099,'enUS','You go back to that spineless orc who would not come see me and you tell him that the Frostwolf clan will not aid the Forsaken. Not now, not ever!','',26124),
(49100,'enUS','BEGONE!','',26124),
(49101,'enUS','Prepare the Micro Mechachicken!','',26124),
(49102,'enUS','','You don\'t have to yell, Hobart, I\'m standing right here. Sheesh!',26124),
(49103,'enUS','','There. One Micro Mechachicken. I\'ll never understand how you come up with these names.',26124),
(49104,'enUS','There\'s a great deal that you do not understand, my dear Greely. That is why you are the assistant and I... I am Hobart Grapplehammer!','',26124),
(49105,'enUS','','Greely sighs and rolls her eyes.',26124),
(49106,'enUS','','Yes, Doctor Grapplehammer.',26124),
(49107,'enUS','Excellent. Now back away from the Ultra Concave Fissionable Testing Platform. Slowly, if you please.','',26124),
(49108,'enUS','Thank you. Now behold as I stabilize the highly unstable miniaturization process.','',26124),
(49109,'enUS','','The assistant shakes her head.',26124),
(49110,'enUS','I am going to end the horrible problem of food storage cutting into the profits of the Bilgewater Cartel!','',26124),
(49111,'enUS','I\'ll soon be revered as the greatest goblin tinker of all time! Besides, that negligence case involving the creation of the gilgoblins will never stick.','',26124),
(49112,'enUS','Flip the switch!','',26124),
(49113,'enUS','','Greely coughs.',26124),
(49114,'enUS','','Um, Hobart, you\'re at the controls.',26124),
(49115,'enUS','Quite right, Greely. You passed today\'s pop quiz.','',26124),
(49116,'enUS','I am now flipping the switch!','',26124),
(49117,'enUS','Greely, can you feel it? My moment of success is at hand!','',26124),
(49118,'enUS','Grocery store owners everywhere will owe me a percentage of their profits!','',26124),
(49119,'enUS','I\'m flipping the second switch!','',26124),
(49120,'enUS','Wait... something\'s wrong!','',26124),
(49121,'enUS','','Ya think? Hobart, the Micro Mechachicken is destablizing. It\'s expanding!',26124),
(49122,'enUS','I know... I know! Where\'s the override? The override?!','',26124),
(49123,'enUS','','It\'s the one on the far right! Hurry, Hobart! It\'s going to eggsplode!',26124),
(49124,'enUS','Here goes nothing. I always loved you, Greely!','',26124),
(49125,'enUS','Flipping the override switch now!','',26124),
(49126,'enUS','','WHAT?!!!',26124),
(49127,'enUS','Are we still alive?','',26124),
(49128,'enUS','','We\'re still alive, Doctor Grapplehammer, despite your best efforts.',26124),
(49129,'enUS','Well of course we are, my dear Greely. And look there. The Micro Mechachicken\'s stabilization appears to be a complete success!','',26124),
(49130,'enUS','Hobart\'s jaw hits the ground.','',26124),
(49131,'enUS','','Is that egg on your face?',26124),
(49132,'enUS','','Now what\'s this about you \'always loved me\', Grapplehammer?',26124),
(49133,'enUS','I haven\'t the foggiest notion what you\'re talking about, Miss Greely.','',26124),
(49134,'enUS','','We can both agree on that, doctor.',26124),
(49135,'enUS','','Hey. How ya doing, boss? Hobart and I are working on some things that will ensure that you have phenomenal backup products for when the kaja\'mite runs out.$B$BThere\'s only so much of it left down there in the mines, and when it\'s gone, all of the Kaja\'Cola is going to go with it, I\'m afraid.',26124),
(49136,'enUS','Good to see you, $n!$B$BI just wanted to make sure that you appreciate all of the products that my genius has brought to the Kajaro Trading Company?$B$BThese include, but are not limited to: Kaja\'Cola, the Poultryizer, Town-In-A-Box, my Ingenious Cap of Mook Foolery, KTC Train-a-Tron Deluxe, the Amazing G-Ray, Never-Deflating Pool Ponies, the Big Ones, Warrior-Matic NX-01, and gilgoblins. No strike that last one. Under advice of counsel, I had nothing to do with them.$B$BAnyway, I\'m working on a few more things here that I think you\'ll find interesting, such as the Micro Mechachicken and a little something I like to call Subject Nine.','',26124),
(49137,'enUS','You don\'t look right, buddy. There\'s somethin\' wrong with you.','',26124),
(49138,'enUS','Hey, $g man : lady;, are we gonna get through this okay?','',26124),
(49139,'enUS','','It looks like this is the end, but I\'ll be brave if you will, $n.',26124),
(49140,'enUS','WATER!','WATER!',26124),
(49141,'enUS','<Gobber acts tough, but you can tell that deep down, he\'s scared.>','',26124),
(49142,'enUS','Thank the Light! I\'m parched!','Thank the Light! I\'m parched!',26124),
(49143,'enUS','Ah, yer a lifesaver, lad!','Ah, yer a lifesaver, lad!',26124),
(49144,'enUS','I feel like I could drink a lake!','I feel like I could drink a lake!',26124),
(49145,'enUS','Ugh... I don\'t feel so good.','Ugh... I don\'t feel so good.',26124),
(49146,'enUS','So tired...','So tired...',26124),
(49147,'enUS','ARGH! THROAT ON FIRE!','ARGH! THROAT ON FIRE!',26124),
(49148,'enUS','Wha.. ungh...','Wha.. ungh...',26124),
(49149,'enUS','Hey mon!$b$bDis area been goin\' through lotsa changes.  Tel\'aporta gonna take you somewhere else.','',26124),
(49150,'enUS','Take me to the Echo Isles, Tel\'aporta!','Take me to the Echo Isles, Tel\'aporta!',26124),
(49151,'enUS','Gwaaaaaaahhh!!!','',26124),
(49152,'enUS','Take me to the Mulgore, Tel\'aporta!','Take me to the Mulgore, Tel\'aporta!',26124),
(49153,'enUS','|TInterface\\Icons\\ability_mage_firestarter.blp:20|tUse |cFFFF0000|Hspell:74040|h[Engulfing Flames]|h|r to destroy the Twilight\'s Hammer!','',26124),
(49154,'enUS','...','...',26124),
(49155,'enUS','|TInterface\\Icons\\spell_holy_innerfire.blp:20|t Glubtok creates a moving |cFFFF0000|Hspell:91398|h[Fire Wall]|h|r!','',26124),
(49156,'enUS','MEDIC!','MEDIC!',26124),
(49157,'enUS','I\'m going to the infirmary!','I\'m going to the infirmary!',26124),
(49158,'enUS','OY! Piss off, eh?','',26124),
(49159,'enUS','Dirty, stinkin\' Wildhammer. You know these dwarves only consider you as half a dwarf, right? What does that make you? A gnome?','Dirty, stinkin\' Wildhammer. You know these dwarves only consider you as half a dwarf, right? What does that make you? A gnome?',26124),
(49160,'enUS','What did ye say, Sally?! The only one of us who resembles a gnome is you - after I\'m done cuttin\' you into wee pieces!','',26124),
(49161,'enUS','Come on then, Nancy! Let\'s go!','',26124),
(49162,'enUS','I\'m busy, lad. Why don\'t ye go find some Forsaken goo and take a bath, eh?','',26124),
(49163,'enUS','I guess it\'s true then. I didn\'t want to believe that you were a yellow-bellied snow licker, but there\'s no doubt about it now.','I guess it\'s true then. I didn\'t want to believe that you were a yellow-bellied snow licker, but there\'s no doubt about it now.',26124),
(49164,'enUS','What did ye call me? I\'ll show ye what a \"snow licker\" can do!','',26124),
(49165,'enUS','Crudbeard? You are one ugly little girl. I didn\'t even know they let little girls become death knights. Was the Lich King trying to meet his quota when he made you or something? I would have thrown you back.','Crudbeard? You are one ugly little girl. I didn\'t even know they let little girls become death knights. Was the Lich King trying to meet his quota when he made you or something? I would have thrown you back.',26124),
(49166,'enUS','Leave or I\'ll be forced to pound yer face in!','',26124),
(49167,'enUS','Oh, I\'m gonna enjoy this more than I probably should.','',26124),
(49168,'enUS','When I\'m through with ya, yer head\'s gonna be firmly placed between yer ass cheeks!','',26124),
(49169,'enUS','GAAAH! How you kill croc?!','',26124),
(49170,'enUS','Augh smart! Augh already steal treasure while you no looking! ','',26124),
(49171,'enUS','Augh da boss! Oh yeah!','',26124),
(49172,'enUS','Who bad?! Augh bad!! Ugn!','',26124),
(49173,'enUS','Augh steal your treasure. Uhn uhn uhnnn!','',26124),
(49174,'enUS','','Yeah? Whadya want?',26124),
(49175,'enUS','','I don\'t talk to no $g scrub : trash;!',26124),
(49176,'enUS','','You\'re not quite in my league, honey.',26124),
(49177,'enUS','','I didn\'t talk to you back in school and I\'m sure not going to start now.',26124),
(49178,'enUS','','That\'s an interesting... \"outfit\" you\'re wearing.',26124),
(49179,'enUS','','Yes. I\'d love a refill. Fetch one and be quick about it.',26124),
(49180,'enUS','','This is the Trade Prince\'s party, sweetie. Invite only!',26124),
(49181,'enUS','','$n, right? Word of advice: don\'t let the Trade Prince catch you around here. He knows you\'re after his job.$B$BEveryone knows.',26124),
(49182,'enUS','','A mook?! I don\'t speak to brutes. How dare you!',26124),
(49183,'enUS','','What are we calling you things these days? Brutes? Hobgoblins?$B$BI can\'t keep it straight. Get out of here.',26124),
(49184,'enUS','','You\'re big and strong. But you need a bath. Go jump in the pool.',26124),
(49185,'enUS','','Oh no you did not just talk to me!',26124),
(49186,'enUS','','What smells around here? Oh, that\'d be you.$B$BBeat it!',26124),
(49187,'enUS','','What\'s your name?$B$BI guess it\'s a good thing you brutes can\'t talk. Otherwise, I\'d have to tell the Trade Prince how you annoyed me.$B$BNow scram!',26124),
(49188,'enUS','','Touch me one more time and I\'ll make sure that they send you to the Undermine!',26124),
(49189,'enUS','','Oh, you\'re just disgusting! Why is it always the ugly ones that try to pickup on me?!',26124),
(49190,'enUS','I got a very bad feeling about this, $n. I think the smart play now is to get yourself off of the island any way that you can.$B$BI\'m going see if I can get into the Trade Prince\'s Town-In-A-Box.','',26124),
(49191,'enUS','Blowin\' em\' to bits, boss!','',26124),
(49192,'enUS','I hope you\'re ready! I\'ve souped up this Blood Elf boat with the best Goblin parts money could buy... which wasn\'t much, sadly, but I\'ll take what I can get.','I hope you\'re ready! I\'ve souped up this Blood Elf boat with the best Goblin parts money could buy... which wasn\'t much, sadly, but I\'ll take what I can get.',26124),
(49193,'enUS','The race is about to begin!','The race is about to begin!',26124),
(49194,'enUS','|cFFFF00003...|r','|cFFFF00003...|r',26124),
(49195,'enUS','|cFFFF80402...|r','|cFFFF80402...|r',26124),
(49196,'enUS','|cFFFFFF001...|r','|cFFFFFF001...|r',26124),
(49197,'enUS','|cFF00FF00Go!|r','|cFF00FF00Go!|r',26124),
(49198,'enUS','<To your astonishment, the Raptor hatchling is able to communicate with you.>$B$B$G Papa : Mama;...?','',26124),
(49199,'enUS','A big day, Firebeard. The Wildhammer united can never be stopped!','',26124),
(49200,'enUS','Never doubt it. Here, allow me to give you my wedding gift.','',26124),
(49201,'enUS','The only surviving egg of my late gryphon, Sky\'ree.  Honor it and care for it; her child is yours.','',26124),
(49202,'enUS','I\'ll not hear a word of it. The egg is yours. I want you to see how committed I am to this union.','',26124),
(49203,'enUS','And how committed the Alliance is to the Wildhammer cause!','',26124),
(49204,'enUS','Ah, look. Here comes $n, escorting your bride!','',26124),
(49205,'enUS','I hope you\'re right, Kurdran old friend.','',26124),
(49206,'enUS','Kurdran - no, I couldn\'t! Sky\'ree was a legend, I can\'t-','',26124),
(49207,'enUS','Aye. Thank you, Kurdran.','',26124),
(49208,'enUS','I do.','',26124),
(49209,'enUS','Ladies and gentledwarves, we gather here in the shadow of Thunderstrike to honor the union of Fanny Thundermar and Keegan Firebeard.','',26124),
(49210,'enUS','May their bond be as eternal as the wind, waves, stone and fire. ','',26124),
(49211,'enUS','Do you, Keegan and Fanny, accept one another into your lives, that two become as one, in union everlasting?','',26124),
(49212,'enUS','Then, by the powers vested in me... the powers vested in me...','',26124),
(49213,'enUS','...BY BLOOD AND SHADOW!','',26124),
(49214,'enUS','I shall consume your lifeblood in the name of the master!!','',26124),
(49215,'enUS','','I do.',26124),
(49216,'enUS','<To your astonishment, the Raptor hatchling is able to communicate with you.>$B$BI hunger... therefore, I am.','',26124),
(49217,'enUS','<To your astonishment, the Raptor hatchling is able to communicate with you.>$B$BWhat does \"$c\" mean? Are you the goblin $g patriarch : matriarch;?','',26124),
(49218,'enUS','It\'s one of them!','',26124),
(49219,'enUS','Get him!','',26124),
(49220,'enUS','<To your astonishment, the Raptor hatchling is able to communicate with you.>$B$BThey call you $n. Is this your unique signifier, or is it an honorary title?','',26124),
(49221,'enUS','Stop that thing!','',26124),
(49222,'enUS','Waaaaahhhhh!!','',26124),
(49223,'enUS','SAVE THE WEDDING!','',26124),
(49224,'enUS','<To your astonishment, the Raptor hatchling is able to communicate with you.>$B$BGreetings. I recently emerged from an egg. You?','',26124),
(49225,'enUS','<To your astonishment, the Raptor hatchling is able to communicate with you.>$B$BIs it true that you cook your meat? Curious.','',26124),
(49226,'enUS','<To your astonishment, the Raptor hatchling is able to communicate with you.>$B$BYou lack a helmet. Does this diminish your intellectual capacities?','',26124),
(49227,'enUS','<To your astonishment, the Raptor hatchling is able to communicate with you.>$B$BThe ends of your fingers are dull and round. Is this why you carry around other implements for use in combat?$B$BHow interesting.','',26124),
(49228,'enUS','The races are coming, $g lad : lass;! We\'re working hard on getting the track setup and I\'ve been busy signing some worthy competitors.$B$BTell your friends!','',26124),
(49229,'enUS','Serpents of the depths!  Come and aid your master!','',26124),
(49230,'enUS','Come, my children!  Defend me!','',26124),
(49231,'enUS','$n?! What are you still doing here?$B$BYou have to get off of the island, or better yet, into one of my Town-In-A-Boxes!$B$BDon\'t wait too long, my $g boy : girl;! The Cataclysm is upon us!','',26124),
(49232,'enUS','We have to get off the island! Quick, Greely, grab the schematics! And my toothbrush!','',26124),
(49233,'enUS','Get everything packed! We have to find a way off of Kezan! We\'ll jump into the closest Town-In-A-Box! They\'ll load it on the Trade Prince\'s yacht.','',26124),
(49234,'enUS','Whatever you do, don\'t let me forget my Ingenious Cap of Mook Foolery!','',26124),
(49235,'enUS','Deathwing?! The Cataclysm?! We\'re doomed!! We have to get off of Kezan before Mount Kajaro blows for good!!!','',26124),
(49236,'enUS','How are we going to get Subject Nine through customs? I know! Pack her into the Lab-In-A-Box!','',26124),
(49237,'enUS','The sky is falling!','',26124),
(49238,'enUS','A party? Can you believe it? A party and the whole island is about to explode?! What are they thinking!!!','',26124),
(49239,'enUS','There\'s just not enough time to pack all of this stuff up! Grab only the important stuff! Where\'d I put my Blastproof Underwater G-Ray Goggles?!','',26124),
(49240,'enUS','','Don\'t worry about Hobart, boss. He\'s just having a bit of a breakdown right now.$B$BThe Cataclysm couldn\'t have come at a worse time for him. He was so close to being done with the Micro Mechachicken.',26124),
(49241,'enUS','','I\'m on it, doctor. Schematics, check. Toothbrush, check.',26124),
(49242,'enUS','','I will, I will. But, Hobart, you have to calm down. Your blood pressure! You\'re turning deep green!',26124),
(49243,'enUS','','Hmm, I know I saw it around here somewhere, but are you sure? That thing turns the user into a brute instead of projecting an image of one about fifty percent of the time. And then they explode!',26124),
(49244,'enUS','','You\'re going to blow if you don\'t calm down! Don\'t you think it was a little bit convenient? The dragon flying over right as the winning field goal for the footbomb finals was kicked into Mount Kajaro?',26124),
(49245,'enUS','','Right away. I\'ll flag the Lab-In-A-Box for deployment in Azshara.  I\'ll pack her little cushion in with her, too. She\'s so cute!',26124),
(49246,'enUS','','Technically speaking, that\'s not true, doctor. The rocks that fly out of a volcano like Mount Kajaro are called ejecta. It\'s not the sky. It\'s molten rock, or tephra. It cools as it descends, becoming lava bombs. Very appropriate, wouldn\'t you say?',26124),
(49247,'enUS','','Yeah, a real party that I was actually invited to. Why does something always happen and I never get to go? I could use a drink.',26124),
(49248,'enUS','','Um, Hobart, you\'re wearing them.',26124),
(49249,'enUS','Ye can defuse it, right Magruder?!','',26124),
(49250,'enUS','Holy... What in the hell is this?','',26124),
(49251,'enUS','Are you kidding me? Look at all this crap! There\'s like a million wires. I\'m a three wire kind of guy...\n','',26124),
(49252,'enUS','RUN!!!!!!\n','',26124),
(49253,'enUS','My father has trained me since I was a wee lad to respect the elements. Earth and fire, wind and sea - they possess great power, $c.$B$B<Grundy gets a gleam in his eye.>$B$BMore than you realize.','',26124),
(49254,'enUS','I\'ll keep my eyes open, Grundy. Let the wedding commence!','I\'ll keep my eyes open, Grundy. Let the wedding commence!',26124),
(49255,'enUS','LOK\'TAR! HILLSBRAD IS OURS!','',26124),
(49256,'enUS','FOOD FOR GROLNAR!','',26124),
(49257,'enUS','On the matter of war against the rebel tribe of Neferset... has each member of the High Council reached a decision?','',26124),
(49258,'enUS','','Watch and weep.',26124),
(49259,'enUS','','You see? Nothing beats the crushing power of my hammers.',26124),
(49260,'enUS','Yes, your majesty.  The Sword of Ramkahen casts its vote in favor of war.  Your armies are standing at the ready.','',26124),
(49261,'enUS',' The Voice of Ramkahen casts its vote in favor of war as well.','',26124),
(49262,'enUS','The Faith of Ramkahen... abstains.','',26124),
(49263,'enUS','For hours, I agonized over the visions the waters of the river showed me.','',26124),
(49264,'enUS','In my visions, negotiations with the enemy brought our people a fleeting peace... followed by terrible betrayal and destruction.','',26124),
(49265,'enUS','Only one vision offered a faint glimmer of hope.  And in that vision... the High Council did not make this decision for you, Phaoris.','',26124),
(49266,'enUS','Here she is, $n... the coffer of promise!','',26124),
(49267,'enUS','Vell done, Doctah Jones!','',26124),
(49268,'enUS','Not only haf you led me right to zhe coffer, but you haf removed its protektions!','',26124),
(49269,'enUS','Such a pity...','',26124),
(49270,'enUS','I vould offer you a prestigious position in my organization if I didn\'t haf to kill you.','',26124),
(49271,'enUS','But first!','',26124),
(49272,'enUS','You shall vitness zhe destruction of zhat vhich you hold so dear!','',26124),
(49273,'enUS','The Coffer!? You wouldn\'t...','',26124),
(49274,'enUS','Oh, don\'t be such a fool! I never vanted your silly chest for myself.','',26124),
(49275,'enUS','Zhat artifact is zhe only zhink preventink Deazhvink from activatink zhe reorigination mechanism!','',26124),
(49276,'enUS','Vonce his lust for vengeance is sated, I vill be free to rule Azerozh as I see fit!','',26124),
(49277,'enUS','Hmm? Vhat vas zhat?','',26124),
(49278,'enUS','No matter! In a moment, nozhink vill remain of any of zhis!','',26124),
(49279,'enUS','Close your eyes, kid. This ain\'t gunna be pretty...','',26124),
(49280,'enUS','Now! Destroy zhe coffer! And zhem vhizh it!','',26124),
(49281,'enUS','And in the vision... the High Council did not make this decision for you, Phaoris.','',26124),
(49282,'enUS','But war, waged by a leader reluctantly following protocol, brought an even swifter demise to our nation.','',26124),
(49283,'enUS','I am a psylosopher. What that means is that I am smarter than you. Now move along before I diagnose you.','',26124),
(49284,'enUS','My liege, a skirmish along the Neferset border just occurred.  A patrol led by your brother was involved...','',26124),
(49285,'enUS','He\'s been... mortally wounded, sir.','',26124),
(49286,'enUS','We attack Neferset city at first light.','',26124),
(49287,'enUS','Commander.  Move all forward regiments westward.','',26124),
(49288,'enUS','Nadun...','',26124),
(49289,'enUS','Och!$b$b\'Bout time ye showed up.$b$bI been expectin\' ye fer days now.$b$bLeavin\' an ol\' dwarf ta swelter... I trained junior better than that.','',26124),
(49290,'enUS','The bombs are set! Run to the balcony and jump to escape!','',26124),
(49291,'enUS','3...','',26124),
(49292,'enUS','2...','',26124),
(49293,'enUS','1...','',26124),
(49294,'enUS','BOOM!','',26124),
(49295,'enUS','The Shadow Grave is this way.  Follow me, $n.','',26124),
(49296,'enUS','This way!','',26124),
(49297,'enUS','Now, where could those supplies be?','',26124),
(49298,'enUS','Maybe they\'re over here?','',26124),
(49299,'enUS','Hmm...','',26124),
(49300,'enUS','No, not over here.','',26124),
(49301,'enUS','Hey, give me a hand, $n!  I can\'t find the supplies that Mordo needed!','',26124),
(49302,'enUS','Let\'s see now... where could they be...','',26124),
(49303,'enUS','Nice work!  You\'ve found them.  Let\'s bring these back to Mordo.','',26124),
(49304,'enUS','I saw someone up there whose jaw fell off.  I wonder if Mordo can fix him up?','',26124),
(49305,'enUS','Greetings, $n.','',26124),
(49306,'enUS','','We\'re through, $n! I\'m with Chip now.',26124),
(49307,'enUS','We\'re through, $n! I\'m with Candy now.','',26124),
(49308,'enUS','Why flail around when all you need...','',26124),
(49309,'enUS','...is just one CHOP!','',26124),
(49310,'enUS','Invaders, you shall go no further!','',26124),
(49311,'enUS','Insolent rat!','',26124),
(49312,'enUS','Siamat must not be freed! Turn back before it is too late!','',26124),
(49313,'enUS','Murkash!','',26124),
(49314,'enUS','Tread Lightly.','',26124),
(49315,'enUS','A stray jolt from the Foe Reaper has disrupted the foundry controls!','',26124),
(49316,'enUS','The molten slag begins to bubble furiously!','',26124),
(49317,'enUS','Help! I\'m trapped in here!','',26124),
(49318,'enUS','Hey! Over here!','',26124),
(49319,'enUS','A little help?','',26124),
(49320,'enUS','Poor little fella.','',26124),
(49321,'enUS','Uh oh! He looks pretty mad now!','',26124),
(49322,'enUS','Great job guys! The key should be in his guts somewhere. Just, uh, fish around in there \'till you find it.','',26124),
(49323,'enUS','Thanks for freeing me! I\'m off to have more amazing adventures.','',26124),
(49324,'enUS','Hit the icicle to break free!','',26124),
(49325,'enUS','It has now been six weeks since your release. Are you ready to have the shackles removed?','',26124),
(49326,'enUS','I need time to think. It... it\'s too soon.','',26124),
(49327,'enUS','Six weeks? I spent six years in Durnholde! You cannot possibly expect me to just throw aside something that has been a part of my life for so long!','',26124),
(49328,'enUS','What I want to know is this: WHY DO YOU CARE IF I HAVE A BALL AND CHAIN SHACKLED TO MY ANKLE!?','',26124),
(49329,'enUS','Can\'t you just see me for me, doc? Why does it always have to be about Teddy?','',26124),
(49330,'enUS','NO, DAMN IT! For the hundredth time, NO!','',26124),
(49331,'enUS','You\'ll be free to take it off when I die.','',26124),
(49332,'enUS','You know, when I was first captured I hated Teddy. He dug into my skin and prevented me from moving around freely. But let me tell you something, doc; after six years with the guy I can honestly say that I have feelings for him.','',26124),
(49333,'enUS','I\'m with Drull, doc. Laverne and I are happy together. Why try and separate us?','',26124),
(49334,'enUS','','Get away from me, you abomination!',26124),
(49335,'enUS','','The undead are a taint upon Azeroth!  Every one of you creatures deserves to be destroyed!',26124),
(49336,'enUS','And we don\'t appreciate you refering to our friends as a \'ball and chain,\' doc.','',26124),
(49337,'enUS','','No.  You\'re lying!  My father will protect me!',26124),
(49338,'enUS','I\'d go back if I could. I had a life in Durnholde. Towards the end there I was beaten maybe once a week at MOST.','',26124),
(49339,'enUS','I\'m not an abomination, I\'m simply undead.  I just want to speak with you.','I\'m not an abomination, I\'m simply undead.  I just want to speak with you.',26124),
(49340,'enUS','Lilian, do you realize that you are undead yourself?','Lilian, do you realize that you are undead yourself?',26124),
(49341,'enUS','Frankly, I\'m getting a little tired of these therapy sessions. We\'re fine! Just let us go.','',26124),
(49342,'enUS','My official diagnosis is that you are both idiots! IDIOTS I SAY!','',26124),
(49343,'enUS','Stand back, monster.  You want to fight?  Because I\'ll fight you.$b$bI\'ll fight any one of you creatures!  Do you hear me?','',26124),
(49344,'enUS','Oh really?$b$bFine.  I don\'t want to join you and your Forsaken.  Maybe I\'ll start my own Forsaken!  Maybe I\'ll invent Forsaken with elbows!','',26124),
(49345,'enUS','Who are you calling a monster? You\'re the monster! I\'m just a man who died.','',26124),
(49346,'enUS','I\'m not here to fight.  I\'ve only been asked to speak with you.','I\'m not here to fight.  I\'ve only been asked to speak with you.',26124),
(49347,'enUS','You are free to do whatever you like.','You are free to do whatever you like.',26124),
(49348,'enUS','What... what\'s going on?  Who are you?  What happened to me?','',26124),
(49349,'enUS','I... died?$b$bYes, you\'re right.  I died.  It was an orc... he cut off my hands, and left me to die.$b$b<Valdred looks down at his hands.>$b$bThese aren\'t my hands!  THESE AREN\'T MY HANDS!','',26124),
(49350,'enUS','<Valdred looks back down at his hands.>$b$bI suppose this is my fate then.  Hah!  Part of an undead army.  Somehow I never considered that I might end up fighting for the Forsaken.$b$b<He looks back up at you.>$b$bWhat do I do now?','',26124),
(49351,'enUS','I see.  Well then, let\'s get to work, $n!  The Dark Lady needs us, right?','',26124),
(49352,'enUS','Don\'t you remember?  You died.','Don\'t you remember?  You died.',26124),
(49353,'enUS','Calm down, Valdred.  Undertaker Mordo probably sewed some new ones on for you.','Calm down, Valdred.  Undertaker Mordo probably sewed some new ones on for you.',26124),
(49354,'enUS','You talk to Undertaker Mordo.  He\'ll tell you what to do.  That\'s all I know.','You talk to Undertaker Mordo.  He\'ll tell you what to do.  That\'s all I know.',26124),
(49355,'enUS','','It\'s your big coming out party. We\'ll make you a Trade $G Prince : Princess; yet, $n!$B$BGet out there and strut your stuff!',26124),
(49356,'enUS','','Pirates?! Boss, you have to deal with this! They\'re ruining the party!',26124),
(49357,'enUS','Now hold yer breeks. The zeppelin will take a minute or so to pull around.','',26124),
(49358,'enUS','Bah, predictable! They\'ll see it comin\'!','',26124),
(49359,'enUS','It\'s almost here. Get ready!','',26124),
(49360,'enUS','','This isn\'t looking good, boss.',26124),
(49361,'enUS','She\'s here! Get in that cannon, damnit! Get ready to fire!','',26124),
(49362,'enUS','','Boss, we gotta get you a bazillion macaroons by any means possible!',26124),
(49363,'enUS','','We gotta finish up here and get you to the dock before the Trade Prince leaves us all behind!',26124),
(49364,'enUS','','Heya, hon. Um... we need to talk, but later.$B$BOkay?',26124),
(49365,'enUS','Oh, heya, toots. Yeah... we need to talk.$B$BLater, okay?','',26124),
(49366,'enUS','','No amount of marketing is going to get us out of this one. The only thing that\'s going to work is a bazillion macaroons!$B$BYou have to get that moolah and get to the docks, pronto!',26124),
(49367,'enUS','Rush their positions!  $n is with us -- our victory is assured!','',26124),
(49368,'enUS','He\'s sent one of his cowards in to kill me, has he?','He\'s sent one of his cowards in to kill me, has he?',26124),
(49369,'enUS','Do it while I\'m standing...','Do it while I\'m standing...',26124),
(49370,'enUS','$n?','$n?',26124),
(49371,'enUS','$n, I\'d recognize that face anywhere... What... What have they done to you, $n?','$n, I\'d recognize that face anywhere... What... What have they done to you, $n?',26124),
(49372,'enUS','You don\'t remember me? We were both servants of Arugal back in Silverpine Forest. We put up with his merciless torture for ages. It was you who saved me on that fateful night when we escaped Shadowfang Keep. Without you I would have died. YOU! The most noble worgen I ever knew. What have they done to you, $n? How could this have happened?','You don\'t remember me? We were both servants of Arugal back in Silverpine Forest. We put up with his merciless torture for ages. It was you who saved me on that fateful night when we escaped Shadowfang Keep. Without you I would have died. YOU! The most noble worgen I ever knew. What have they done to you, $n? How could this have happened?',26124),
(49373,'enUS','Ah, my back!','',26124),
(49374,'enUS','Remember the worgen that you once were, $g brother:sister;! You were our savior! Fight this!','Remember the worgen that you once were, $g brother:sister;! You were our savior! Fight this!',26124),
(49375,'enUS','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!',26124),
(49376,'enUS','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Gilneas, our beloved home. This world is worth saving.','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Gilneas, our beloved home. This world is worth saving.',26124),
(49377,'enUS','Do it, $n! Put me out of my misery!','Do it, $n! Put me out of my misery!',26124),
(49378,'enUS','%s dies from his injuries.','%s dies from his injuries.',26124),
(49379,'enUS','What\'s going on in there? What\'s taking so long, $n?','',26124),
(49380,'enUS','C... can\'t we work this out somehow?','C... can\'t we work this out somehow?',26124),
(49381,'enUS','Alright, j... just let me... let me st... stand up.','Alright, j... just let me... let me st... stand up.',26124),
(49382,'enUS','$n?','$n?',26124),
(49383,'enUS','$n, I\'d recognize that face anywhere... What... What have they done to you, $n?','$n, I\'d recognize that face anywhere... What... What have they done to you, $n?',26124),
(49384,'enUS','You don\'t remember me, $n? I lost count of the number of jobs you and I ran back in the day on Kezan. Then I picked up a real bad Kaja\'Cola habit and you saved me! It was you who took me to Kalimdor to join the Steamwheedle Cartel. You were the only good goblin I knew. That\'s how I ended up in the Argent Dawn, because I knew it was what you woulda done. How could this have happened to you?','You don\'t remember me, $n? I lost count of the number of jobs you and I ran back in the day on Kezan. Then I picked up a real bad Kaja\'Cola habit and you saved me! It was you who took me to Kalimdor to join the Steamwheedle Cartel. You were the only good goblin I knew. That\'s how I ended up in the Argent Dawn, because I knew it was what you woulda done. How could this have happened to you?',26124),
(49385,'enUS','Remember the goblin that you once were, $g brother:sister;! You were my best friend! Fight this!','Remember the goblin that you once were, $g brother:sister;! You were my best friend! Fight this!',26124),
(49386,'enUS','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!','Listen to me, $n. You must fight against the Lich King\'s control. He is a monster that wants to see this world - our world - in ruin. Don\'t let him use you to accomplish his goals. You were once a hero and you can be again. Fight, damn you! Fight his control!',26124),
(49387,'enUS','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Kezan, our beloved home. This world is worth saving.','There... There\'s no more time for me. I\'m done for. Finish me off, $n. Do it or they\'ll kill us both. $n... Remember Kezan, our beloved home. This world is worth saving.',26124),
(49388,'enUS','Do it, $n! Put me out of my misery!','Do it, $n! Put me out of my misery!',26124),
(49389,'enUS','%s dies from his injuries.','%s dies from his injuries.',26124),
(49390,'enUS','Beak! Get down here, Beak!','',26124),
(49391,'enUS','Aww, c\'mon Beak. It weren\'t nothin\' but a big ... tentacle thing. Donnelly will keep ya safe!','',26124),
(49392,'enUS','Take it easy, Beak. Come back here!','',26124),
(49393,'enUS','You\'re safe now, Beak. C\'mon back to Donnelly!','',26124),
(49394,'enUS','Beak. Beak!','',26124),
(49395,'enUS','I love yoooouuu man ... *hic* like a BROTHER!','',26124),
(49396,'enUS','You\'re okay, Firebeard. *urp* You\'re okay by me.','',26124),
(49397,'enUS','Tha\'s the way we Wildhammer ... get hitched, it was. *hic* That were BEAUTIFUL!','',26124),
(49398,'enUS','*hic* You an\' me, Firebeard. Wildhammers FOREVER.','',26124),
(49399,'enUS','BEST! WEDDING! EVAR! *Hic*','',26124),
(49400,'enUS','Wildhammer stay ta\'gether wot slay ta\'gether!','',26124),
(49401,'enUS','','Twilight\'s Hammer don\'t scare me none. Bring \'em on!',26124),
(49402,'enUS','','Wiiiiiildhammmmmer!',26124),
(49403,'enUS','','Get it! Kill it!',26124),
(49404,'enUS','I\'m ready to start whenever you are! I\'ll keep the bride and groom close in case the Twilight\'s Hammer tries anything.$B$BAre you ready?','',26124),
(49405,'enUS','The Dark Pharaoh has fallen!  His immortal colossi tumble like toys!','',26124),
(49406,'enUS','Neferset City will fall!  ATTACK!!!','',26124),
(49407,'enUS','The bomb is set! Get clear!','',26124),
(49408,'enUS','Valdred Moray, reporting for duty, sir!','',26124),
(49409,'enUS','A Massive Wave of Zombies is Approaching!','A Massive Wave of Zombies is Approaching!',26124),
(49410,'enUS','Finally someone to deal with that unsightly pest! You have my thanks, \"heroes.\"','',26124),
(49411,'enUS','That malfunctioning piece of junk was murder on the repair bills.','',26124),
(49412,'enUS','Now that was really unnecessary.','',26124),
(49413,'enUS','Impressive. You have managed to destroy one of my most horrific creations, a task I had thought impossible until now.','',26124),
(49414,'enUS','We never did see eye to eye... Good riddance I say!','',26124),
(49415,'enUS','Welcome to my personal sanctum, heroes! I hope you find the accommodations to your liking. Herein you will find many of my failed experiments and ultimately my greatest triumph!','',26124),
(49416,'enUS','Behold the brood mother, Onyxia, REBORN! Perhaps my finest work.','',26124),
(49417,'enUS','My dearest sibling, do you hunger? THEN FEAST UPON OUR ENEMIES!','',26124),
(49418,'enUS','See how the shadowflame animates their bones! They fight at my command!','',26124),
(49419,'enUS','Flesh turns to ash!','',26124),
(49420,'enUS','Curse you, mortals! Such a callous disregard for one\'s possessions must be met with extreme force!','',26124),
(49421,'enUS','I hope you can swim... in molten lava!','',26124),
(49422,'enUS','I have tried to be an accommodating host, but you simply will not die! Time to throw all pretense aside and just... KILL YOU ALL!','',26124),
(49423,'enUS','Mortal minds... So easily manipulated.','',26124),
(49424,'enUS','It has been a pleasure!','',26124),
(49425,'enUS','HAH!','',26124),
(49426,'enUS','You really have to want it!','',26124),
(49427,'enUS','Defeat has never tasted so bitter...','',26124),
(49428,'enUS','I thank you for coming, but you really all must die now!','',26124),
(49429,'enUS','','Mortal, I want you to bear witness to this, but for your own safety stay back. Calen, you too.',26124),
(49430,'enUS','','Your life isn\'t yours to throw away, Calen. Should I fail, the fate of this world may rest on your shoulders.',26124),
(49431,'enUS','','It pains me, Neltharion - but I must end you, as I have ended Malygos.',26124),
(49432,'enUS','','I see the hollow metal shell of a once great ally, and the precious gift of the Titans wasted.',26124),
(49433,'enUS','','Neltharion! Look at yourself. Misshapen. Twisted. You\'re coming apart.',26124),
(49434,'enUS','','The Earth Warder... he is dead.',26124),
(49435,'enUS','','The black aspect\'s blood is cursed. Wherever it was shed - nothing will grow for ten thousand years.',26124),
(49436,'enUS','','Alexstrasza winches in pain.',26124),
(49437,'enUS','','But it is over. We can work now to bottle up the horrors he has unleashed.',26124),
(49438,'enUS','','Impossible!',26124),
(49439,'enUS','','Calen, no!',26124),
(49440,'enUS','','No!',26124),
(49441,'enUS','Lifebinder! Do you presume that I am at your beck and call? I have a world to unmake.','',26124),
(49442,'enUS','\"End\" me? Lifebinder, you think life is yours to take away?','',26124),
(49443,'enUS','Then witness my new gifts, bestowed by this world\'s true masters.','',26124),
(49444,'enUS','Just as all life ends in death ... all order must end in chaos ... Come! Embrace the inevitable, as I have!','',26124),
(49445,'enUS','The sun has set on this mortal world, fools. Make peace with your end, for the hour of Twilight falls.','',26124),
(49446,'enUS','You think to entrap me!?','',26124),
(49447,'enUS','I will not leave your side.','',26124),
(49448,'enUS','Yes, mother.','',26124),
(49449,'enUS','Don\'t let them out of sight! Quickly - come with me!','',26124),
(49450,'enUS','There - they\'ve fallen!','',26124),
(49451,'enUS','Mother, stay still. Your wounds are great.','',26124),
(49452,'enUS','Deathwing - he lives!','',26124),
(49453,'enUS','Mortal, take the dragon queen. Carry her to safety. Now! RUN! Get her away from here!','',26124),
(49454,'enUS','I will delay the Aspect of Death. Take her to safety. GO!','',26124),
(49455,'enUS','Hello again.','',26124),
(49456,'enUS','I know the way to Deathknell.  Come with me!','',26124),
(49457,'enUS','Good, you\'re still here.  Now, where\'s Deathguard Saltain?','',26124),
(49458,'enUS','Ah, here he is.','',26124),
(49459,'enUS','Let\'s get moving, $n.  Saltain said that we\'d find some corpses up here.','',26124),
(49460,'enUS','I think I see some corpses up ahead.  Let\'s go, $n!  You do the searching and fighting.  I\'ll do the lifting.','',26124),
(49461,'enUS','Think you have what it takes to face the challenges of Azeroth\'s dungeons? Inquire within...','',26124),
(49462,'enUS','I wish to browse your wares, Yasmin.','I wish to browse your wares, Yasmin.',26124),
(49463,'enUS','Oh you poor thing, you\'re covered head to toe in sand!  Please feel free to rest and rejuvenate yourself here at this beautiful oasis.','Oh you poor thing, you\'re covered head to toe in sand!  Please feel free to rest and rejuvenate yourself here at this beautiful oasis.',26124),
(49464,'enUS','','Alexstrasza will be here shortly. Come, we will prepare the sanctuary.',26124),
(49465,'enUS','','One fire burns for lives long lost; their essence now shared with all living things.',26124),
(49466,'enUS','','One fire burns for lives to come; nascent souls awakening in the womb.',26124),
(49467,'enUS','','One fire burns for lives born anew; the passion of youth and the energy they bear.',26124),
(49468,'enUS','','One fire burns for lives in their prime; struggling to make and reshape the world.',26124),
(49469,'enUS','','One fire burns for lives at their end; their work may be done, but their contribution eternal.',26124),
(49470,'enUS','','And so the circle of life is complete. All is prepared.',26124),
(49471,'enUS','','Ah - here comes Alexstrasza now.',26124),
(49472,'enUS','Hmm... I can\'t remember which way to go here.  Let\'s try this side!','Hmm... I can\'t remember which way to go here.  Let\'s try this side!',26124),
(49473,'enUS','Bah!  This just looks like a dead end.  Let\'s head back the other way.','Bah!  This just looks like a dead end.  Let\'s head back the other way.',26124),
(49474,'enUS','Hmmm...  This stairway does not look promising at all.  Let\'s head back to the courtyard and see if there is another way out.','Hmmm...  This stairway does not look promising at all.  Let\'s head back to the courtyard and see if there is another way out.',26124),
(49475,'enUS','Now we are making progress!  This is the way out for sure.  Looks like a lot of guards though so I really need you to help me out!','Now we are making progress!  This is the way out for sure.  Looks like a lot of guards though so I really need you to help me out!',26124),
(49476,'enUS','','You hear a noise from above the cabin door!',26124),
(49477,'enUS','','I\'ve been waiting a long time for this, you know.',26124),
(49478,'enUS','','Biding my time, building my forces, studying the minds of my enemies.',26124),
(49479,'enUS','','I was never very good at hand-to-hand combat, you know.  Not like my father.',26124),
(49480,'enUS','','But I always excelled at poisons.',26124),
(49481,'enUS','','Especially venoms that affect the mind.',26124),
(49482,'enUS','How\'s it going.','',26124),
(49483,'enUS','','Vanessa injects you with the Nightmare Elixir!',26124),
(49484,'enUS','Did you really zhink you vould get avay vizh it, $p? Hmm?','',26124),
(49485,'enUS','First, you come traipsing into Uldum as if you owned zhe place...','',26124),
(49486,'enUS','Clumsily interferink vizh my operation...','',26124),
(49487,'enUS','Zhen you mercilessly kill my loyal vorkers...','',26124),
(49488,'enUS','But -','But -',26124),
(49489,'enUS','Cage the pygmy!','',26124),
(49490,'enUS','Sorry, I have to set a broken leg on a baby dragon. Can you come back in a few minutes?','Sorry, I have to set a broken leg on a baby dragon. Can you come back in a few minutes?',26124),
(49491,'enUS','NO BUT! Silence! Keep Movink!','',26124),
(49492,'enUS','If zhat vere not enough, you sabotaged my ritual and caused Gobbles\' death!','',26124),
(49493,'enUS','Zhen, on top of everyzhink, you nearly take my life... ME!','',26124),
(49494,'enUS','You vill pay, $p. Deazh by firink sqvad!','',26124),
(49495,'enUS','You are fortunate zhat I am too busy to make you suffer as you deserve.','',26124),
(49496,'enUS','Zhat\'s far enough!','',26124),
(49497,'enUS','I can take it from here, my friends. Report to your master zhat zhe problem has been dealt vizh.','',26124),
(49498,'enUS','Tell him zhat zhere vill be no furzher interruptions.','',26124),
(49499,'enUS','Be certain there aren\'t, Schnottz. Deathwing\'s patience wears thin.','',26124),
(49500,'enUS','Now, zhen, vhere vere ve?','',26124),
(49501,'enUS','Ahh, yes. Any last vords? Hmm?','',26124),
(49502,'enUS','VHAAAT?! Vhat is zhe meanink of zhis?','',26124),
(49503,'enUS','You haven\'t seen zhe last of me, $p!','',26124),
(49504,'enUS','Placeholder','',26124),
(49505,'enUS','Placeholder','',26124),
(49506,'enUS','Placeholder','',26124),
(49507,'enUS','Placeholder','',26124),
(49508,'enUS','Placeholder','',26124),
(49509,'enUS','You alright, $n?','',26124),
(49510,'enUS','Beat it, Schnottz!','',26124),
(49511,'enUS','Placeholder','',26124),
(49512,'enUS','Placeholder','',26124),
(49513,'enUS','Placeholder','',26124),
(49514,'enUS','','I understand that Alexstrasza has pronounced judgment on Deathwing. Perhaps this whole ordeal will end, right here?',26124),
(49515,'enUS','I am ready for Deathwing!','I am ready for Deathwing!',26124),
(49516,'enUS','That oughta do it!','',26124),
(49517,'enUS','Would you look at that...','',26124),
(49518,'enUS','$p! We\'ve done it!','',26124),
(49519,'enUS','Brann!? Wha?! How...','',26124),
(49520,'enUS','Placeholder','',26124),
(49521,'enUS','Placeholder','',26124),
(49522,'enUS','Placeholder','',26124),
(49523,'enUS','Och! Come on now, ye buggar...','',26124),
(49524,'enUS','Destroy zhe - Vait... vhat is ZHAT?!','',26124),
(49525,'enUS','Auckh!!!','',26124),
(49526,'enUS','Placeholder','',26124),
(49527,'enUS','Placeholder','',26124),
(49528,'enUS','Placeholder','',26124),
(49529,'enUS','Ahah! Fresh air at last!','',26124),
(49530,'enUS','Two steps ahead of ya again, junior! As usual.','',26124),
(49531,'enUS','Better sharpen up, laddie! I may not be there to pull yer bacon outta the fire next time.','',26124),
(49532,'enUS','You can help me out of here?  Well  there is no reason to stand around, let\'s go!','You can help me out of here?  Well  there is no reason to stand around, let\'s go!',26124),
(49533,'enUS','I don\'t remember which way the exit is here.  Let\'s try this doorway over here.','I don\'t remember which way the exit is here.  Let\'s try this doorway over here.',26124),
(49534,'enUS','Bah, this just looks like a dead end.  That bed does look comfy though.  Let\'s try the other way.','Bah, this just looks like a dead end.  That bed does look comfy though.  Let\'s try the other way.',26124),
(49535,'enUS','This does not look familar to me at all.  Let\'s head back to the courtyard and see if there is another way.  I don\'t really like long stairwells anyways.','This does not look familar to me at all.  Let\'s head back to the courtyard and see if there is another way.  I don\'t really like long stairwells anyways.',26124),
(49536,'enUS','Ok, this is the right way for sure.  Quite a few guards out there so be on your toes.','Ok, this is the right way for sure.  Quite a few guards out there so be on your toes.',26124),
(49537,'enUS','Thanks $n, I think I can take one of these horses and make it back to camp from here.  I could not have made it without your help.','Thanks $n, I think I can take one of these horses and make it back to camp from here.  I could not have made it without your help.',26124),
(49538,'enUS','I\'ll see ya there, $n! Don\'t be late!','',26124),
(49539,'enUS','Arrite, now... Let\'s see here.','',26124),
(49540,'enUS','Arrite, $r.$b$bEverything looks ta be in its proper place.','',26124),
(49541,'enUS','I\'m ready, Brann. Go ahead and activate the coffer.','I\'m ready, Brann. Go ahead and activate the coffer.',26124),
(49542,'enUS','Well, look who\'s here!','',26124),
(49543,'enUS','Hi, $n!  What do you think about my new gear?','',26124),
(49544,'enUS','They\'re making me into a Deathguard.  Can you believe it?','',26124),
(49545,'enUS','I\'ll probably be staying here in Deathknell.  If things work out, though... who knows?  Maybe I\'ll get to meet the Dark Lady herself.','',26124),
(49546,'enUS','How about you?  I\'ve heard that Sarvis is going to send you off to Calston Estate.  Big assignment, eh?','',26124),
(49547,'enUS','Well, I won\'t hold you up.  It\'s been a pleasure, $n.  I hope our paths cross again soon.','',26124),
(49548,'enUS','%s calls a Twilight Drake to aid him!','',26124),
(49549,'enUS','','I\'m going to stay and do what I can to free these spiders. Thank you for your help, $n.',26124),
(49550,'enUS','','You\'ve come to help, $c? Let us stay together for a while.',26124),
(49551,'enUS','You survived the attack!$BRocknut Unlocked!','You survived the attack!$BRocknut Unlocked!',26124),
(49552,'enUS','Tutorial Completed!$BYou\'ve unlocked the Sunflower.','Tutorial Completed!$BYou\'ve unlocked the Sunflower.',26124),
(49553,'enUS','Good job!','Good job!',26124),
(49554,'enUS','Use this Blast Tape to seal them faulty valves up real good, chief.','',26124),
(49555,'enUS','Just a few more minutes...  Cenarius is almost here!','',26124),
(49556,'enUS','You might not have that long.  Enemy reinforcements are already underway.','',26124),
(49557,'enUS','Goldrinn!  It\'s true then... the Ancients walk among us again!','',26124),
(49558,'enUS','Keep placing spitters in the center lane to hold off the zombies.','Keep placing spitters in the center lane to hold off the zombies.',26124),
(49559,'enUS','Collect Solar Power and place Spitters in the center lane to fight the zombies!','Collect Solar Power and place Spitters in the center lane to fight the zombies!',26124),
(49560,'enUS','','There will be time to celebrate later, commander.  Twilight dragons approach!',26124),
(49561,'enUS','Internal: Zombie Wave to 50%%.','Internal: Zombie Wave to 50%%.',26124),
(49562,'enUS','Internal: Ghoul Wave to 50%%.','Internal: Ghoul Wave to 50%%.',26124),
(49563,'enUS','Internal: Aberration Wave to 50%%.','Internal: Aberration Wave to 50%%.',26124),
(49564,'enUS','What you two are lacking...','',26124),
(49565,'enUS','...is control.','',26124),
(49566,'enUS','Plant Sunflowers to create additional solar power, which will help you survive zombie attacks.','Plant Sunflowers to create additional solar power, which will help you survive zombie attacks.',26124),
(49567,'enUS','Build at least 3 Sunflowers to survive this mission.','Build at least 3 Sunflowers to survive this mission.',26124),
(49568,'enUS','%s summons a |cFFFF0000Faceless Corruptor|r!','',26124),
(49569,'enUS','Welcome to Starfall Village, traveler. Have you come to assist us?','',26124),
(49570,'enUS','Filthy beasts! Your presence in Skywall will not be tolerated!','',26124),
(49571,'enUS','Ravaged!','',26124),
(49573,'enUS','YOU tread upon the sacrosanct! Mortals have no place amidst the clouds.','',26124),
(49574,'enUS','BACK to the earth with you!','',26124),
(49575,'enUS','Al\'Akir, your servant calls for aid!','',26124),
(49576,'enUS','The winds take me!','',26124),
(49577,'enUS','My family\'s been clearing out swarms for years! Not that we\'re above a bit of hired help...','',26124),
(49578,'enUS','%s begins to pursue $n!','',26124),
(49579,'enUS','Boss Cho\'gall not gonna be happy \'bout dis!','',26124),
(49580,'enUS','Dat\'s what you get! Noting!','',26124),
(49582,'enUS','Rom\'ogg sorry...','',26124),
(49583,'enUS','RAZ SMASH!','',26124),
(49584,'enUS','Raz... Tired...','',26124),
(49585,'enUS','','HERETICS! You will suffer for this interruption!',26124),
(49586,'enUS','','There is only one true path of enlightenment! DEATH!',26124),
(49587,'enUS','','Bask in his power! Rise as an agent of the master\'s rage!',26124),
(49588,'enUS','','For the master I\'d die a thousand times... A thousan...',26124),
(49589,'enUS','Bodies to test my armaments upon!','',26124),
(49590,'enUS','Merely an impurity in the compound...','',26124),
(49591,'enUS','Feel the burn!','',26124),
(49592,'enUS','We number in the millions! Your efforts are wasted...','',26124),
(49593,'enUS','You come seeking answers? Then have them! Look upon your answer to living!','',26124),
(49594,'enUS','Your kind has no place in the master\'s world.','',26124),
(49595,'enUS','Earth can be shaped, molded... You cannot! You are useless!','',26124),
(49596,'enUS','I cannot be destroyed... Only... de... layed...','',26124),
(49597,'enUS','RAZ, NOOOOOOOOOOO!!!!','',26124),
(49598,'enUS','Quick!  Do not let them disrupt Ysera\'s magic!','',26124),
(49599,'enUS','Hold them back as long as you can!','',26124),
(49600,'enUS','Use Rocknuts to protect your Spitters and Sunflowers.','Use Rocknuts to protect your Spitters and Sunflowers.',26124),
(49601,'enUS','The void sucks at your soul. It is content to feast slowly.','',26124),
(49602,'enUS','When we were ambushed by Rom\'ogg he threw chains around Raz and then hit him with the |cff71d5ff|Hspell:75543|h[The Skullcracker]|h|r! Luckily I moved away before he landed that final blow!','',26124),
(49603,'enUS','In the sunken city, he lays dreaming.','',26124),
(49604,'enUS','Y\'knath k\'th\'rygg k\'yi mrr\'ungha gr\'mula.','',26124),
(49605,'enUS','All places, all things have souls. All souls can be devoured.','',26124),
(49606,'enUS','There is no sharp distinction between the real and the unreal.','',26124),
(49607,'enUS','Thanks, $n!','Thanks, $n!',26124),
(49608,'enUS','In the land of Ny\'alotha there is only sleep.','',26124),
(49609,'enUS','Do you dream while you sleep or is it an escape from the horrors of reality?','',26124),
(49610,'enUS','I\'m saved!','I\'m saved!',26124),
(49611,'enUS','In the sleeping city of Ny\'alotha walk only mad things.','',26124),
(49612,'enUS','A pool pony in the nick of time!','A pool pony in the nick of time!',26124),
(49613,'enUS','I was gonna drown for sure!','I was gonna drown for sure!',26124),
(49614,'enUS','The silent, sleeping, staring houses in the backwoods always dream. It would be merciful to tear them down.','',26124),
(49615,'enUS','It\'s about time! You know how long I\'ve been treading water here?','It\'s about time! You know how long I\'ve been treading water here?',26124),
(49616,'enUS','The stars sweep chill currents that make men shiver in the dark.','',26124),
(49617,'enUS','With the pool pony, I can make it back.','With the pool pony, I can make it back.',26124),
(49618,'enUS','Ny\'alotha is a city of old, terrible, unnumbered crimes.','',26124),
(49619,'enUS','Even death may die.','',26124),
(49620,'enUS','Thanks, friend. My rocket jump fizzled.','Thanks, friend. My rocket jump fizzled.',26124),
(49621,'enUS','You\'re a miracle worker, $n!','You\'re a miracle worker, $n!',26124),
(49622,'enUS','You will all be alone in the end.','',26124),
(49623,'enUS','The drowned god\'s heart is black ice.','',26124),
(49624,'enUS','There is a little lamb lost in dark woods.','',26124),
(49625,'enUS','The giant rook watches from the dead trees. Nothing breathes beneath his shadow.','',26124),
(49626,'enUS','Have you had the dream again? A black goat with seven eyes that watches from the outside.','',26124),
(49627,'enUS','Look around. They will all betray you. Flee screaming into the black forest.','',26124),
(49628,'enUS','At the bottom of the ocean even light must die.','',26124),
(49629,'enUS','Open me! Open me! Open me! Then only will you know peace.','',26124),
(49630,'enUS','You gained Strangler Vine seeds!','You gained Strangler Vine seeds!',26124),
(49631,'enUS','The fish know all the secrets. They know the cold. They know the dark.','',26124),
(49632,'enUS','It is standing right behind you. Do not move. Do not breathe.','',26124),
(49633,'enUS','The tortured spirits of your ancestors cling to you, screaming in silence. Apparently they are quite numerous.','',26124),
(49634,'enUS','What can change the nature of a man?','',26124),
(49635,'enUS','A Ghoul dropped something onto the field!','A Ghoul dropped something onto the field!',26124),
(49636,'enUS','You resist. You cling to your life as if it actually matters. You will learn.','',26124),
(49637,'enUS','Life is weak, mortal, fleeting ... fragile.','',26124),
(49638,'enUS','Death is final. Death is eternal. Death is ... my realm.','',26124),
(49639,'enUS','Look upon me and you see death incarnate, the unmaker of worlds.','',26124),
(49640,'enUS','','Congratulations, adventurer.',26124),
(49641,'enUS','Continue reading... <Note: This will alert Vanessa to your presence!>','Continue reading... <Note: This will alert Vanessa to your presence!>',26124),
(49642,'enUS','','You\'ve managed to walk right into my trap!',26124),
(49643,'enUS','You\'re the bomb-diggity, $n!','',26124),
(49644,'enUS','I have plenty of emergency pool ponies, $n. Please throw them to our laborers in the water below.','',26124),
(49645,'enUS','$n, Savior of the Krazzworks!','',26124),
(49646,'enUS','%s nods silently in greeting.','',26124),
(49647,'enUS','Arrite then! Follow me!','',26124),
(49648,'enUS','Somebody help!','Somebody help!',26124),
(49649,'enUS','I can\'t swim!','I can\'t swim!',26124),
(49650,'enUS','I\'m gonna drown! Help!','I\'m gonna drown! Help!',26124),
(49651,'enUS','The Halls of Origination lie due east of here, near the desert sands of Tanaris. It be a bit of a walk, so we\'d best get movin\'.','',26124),
(49652,'enUS','Shark!!!','Shark!!!',26124),
(49653,'enUS','I don\'t want to die!','I don\'t want to die!',26124),
(49654,'enUS','That... will not be necessary.','',26124),
(49655,'enUS','I\'m so tired....','I\'m so tired....',26124),
(49656,'enUS','If only I\'d remembered to wear my standard-issue emergency pool pony vest.','If only I\'d remembered to wear my standard-issue emergency pool pony vest.',26124),
(49657,'enUS','Hey you! Help!','Hey you! Help!',26124),
(49658,'enUS','','A note falls to the floor!',26124),
(49659,'enUS','Me back still be a wee bit stiff from bein\' stuck inside that coffer for so long. Bear with me if I\'m a little slow...','',26124),
(49660,'enUS','Stay close, now! Ya never know when Deathwing\'s agents might be swoopin\' in and puttin\' an early end to our quest!','',26124),
(49661,'enUS','It be a journey, but if we can avoid harrassment we should be able ta make it by day\'s end. Do ye have any food on ye?','',26124),
(49662,'enUS','I just be pullin\' yer leg, $glad:lass;! The slow walkin\'... always good fer a laugh!','',26124),
(49663,'enUS','You go on ahead. I\'ll meet ya there as soon as I get these discs decrypted.','',26124),
(49664,'enUS','You\'ll find the trainer inside of Aldrassil, $n.','',26124),
(49665,'enUS','','Shadowthread Cave lies to the north. Be careful, it\'s dangerous there of late.',26124),
(49666,'enUS','','The moonwell is to the northeast, on the other side of the pool and up the hill.',26124),
(49667,'enUS','','The ramp up to Aldrassil is just in sight over there. Circle around and find Tenaron up top.',26124),
(49668,'enUS','','Iverron\'s poison is cured, but it will take some time for him to recover.',26124),
(49669,'enUS','','The corruption is buried deep within him.',26124),
(49670,'enUS','','They are surely unredeemable, but it still hurts to see them die.',26124),
(49671,'enUS','','My dear friends... I\'m so sorry...',26124),
(49672,'enUS','','His body screams for death, but his soul screams for mercy.',26124),
(49673,'enUS','','The corruption goes much further than these spiders. I fear the true source is not within this cave.',26124),
(49674,'enUS','','I weep at these atrocities we commit. It is almost unbearable.',26124),
(49675,'enUS','','Corruption this deep could not have come from outside.',26124),
(49676,'enUS','','It almost seems as if he was born with this corruption inside of him.',26124),
(49677,'enUS','','I have no further training for you.  Continue east, to the Menders\' Stead, for now.  You will be summoned when the Battle for Andorhal commences.  Hopefully Koltira doesn\'t wait too long...',26124),
(49678,'enUS','You defended against the attack!$BPumpkin Bombs unlocked!','You defended against the attack!$BPumpkin Bombs unlocked!',26124),
(49679,'enUS','Dark Lady watch over you.','',26124),
(49680,'enUS','Activate the steam valves to free yourself!','Activate the steam valves to free yourself!',26124),
(49681,'enUS','I\'m sorry, Huntress. None of our new $cs are ready. They still have much to learn.','',26124),
(49682,'enUS','','I fear time may not be on our side, Ilthalaine. The battle may carry to Teldrassil itself if we do not act soon.',26124),
(49683,'enUS','','We will leave you to your training, Ilthalaine. This is your area of expertise.',26124),
(49684,'enUS','','Study well, $n. We may need you fighting by our side before the next moon fills.',26124),
(49685,'enUS','A zombie dropped something onto the field!','A zombie dropped something onto the field!',26124),
(49686,'enUS','You gained Freeza seeds!','You gained Freeza seeds!',26124),
(49687,'enUS','We\'ve done it! The control room is breached!','',26124),
(49688,'enUS','Here we go! Now this should only take a moment...','',26124),
(49689,'enUS','Cenarius!  Excellent!  With the portal active, we can move our forces to the frontlines unfettered.','',26124),
(49690,'enUS','You are a most welcome sight, son of Malorne!  We  must preserve your power so you can spearhead the attack against the Firelord.','',26124),
(49691,'enUS','','Leave that to me.',26124),
(49692,'enUS','Zombies ate your brains!','Zombies ate your brains!',26124),
(49693,'enUS','$n, get these Wildhammer off of my airfield!','',26124),
(49694,'enUS','I hear I have you to thank for helping to cure me. Thank you. Truly.','',26124),
(49695,'enUS','What about the Twilight dragons?  There will be more where those came from.','',26124),
(49696,'enUS','Greetings, $c.','',26124),
(49697,'enUS','','This totem has been corrupting the eggs! It seems a greater threat looms. The Gnarlpine remain tainted by something most foul.',26124),
(49698,'enUS','All we had to do was deploy the Krazzworks airfield-in-a-box and begin a routine surveying mission.$B$BI\'m surrounded by idiots!','',26124),
(49699,'enUS','','Helgrum!',26124),
(49700,'enUS','You are only foolish in your shame, Neeka...','',26124),
(49701,'enUS','You used to tell me how we must be tough... how you cannot afford to be soft...','',26124),
(49702,'enUS','As tough as you were, you were always soft in my arms.','',26124),
(49703,'enUS','Be strong, Neeka. I will watch over you...','',26124),
(49704,'enUS','','Be strong, Neeka. I will watch over you...',26124),
(49705,'enUS','The Nightmare Elixir takes hold!','The Nightmare Elixir takes hold!',26124),
(49706,'enUS','You have entered Glubtok\'s Nightmare!','You have entered Glubtok\'s Nightmare!',26124),
(49707,'enUS','The nightmare shifts!','The nightmare shifts!',26124),
(49708,'enUS','You have entered Helix\'s nightmare!','You have entered Helix\'s nightmare!',26124),
(49709,'enUS','You have entered the mechanical nightmare!','You have entered the mechanical nightmare!',26124),
(49710,'enUS','You have entered Ripsnarl\'s nightmare!','You have entered Ripsnarl\'s nightmare!',26124),
(49711,'enUS','Save Emme Harrington!','Save Emme Harrington!',26124),
(49712,'enUS','Save Erik Harrington!','Save Erik Harrington!',26124),
(49713,'enUS','Save Calissa Harrington!','Save Calissa Harrington!',26124),
(49714,'enUS','The Nightmare Elixir wears off!','The Nightmare Elixir wears off!',26124),
(49715,'enUS','','Poor Glubtok.  When his powers manifested, his own ogre mound was the first to burn.',26124),
(49716,'enUS','','Deep within his soul, the one thing he feared most of all was...himself.',26124),
(49717,'enUS','What is it you seek, $r?  Knowledge?  Money?  Honor?$b$bFor me, it has always been further enlightenment in the arcane arts.  My quest for knowledge has taken me around Azeroth countless times, and each time I learn something new about the magic this world has to offer.$b$bJust kidding!  I\'m in it for the money.','',26124),
(49718,'enUS','Are you ready to leave Stranglethorn Vale?','',26124),
(49719,'enUS','Yes.  Please prepare the portal, Arman.','Yes.  Please prepare the portal, Arman.',26124),
(49720,'enUS','I\'ve been sent here by my superiors to investigate some strange occurrences here in Booty Bay.  This goblin town withstood a tidal wave remarkably well, especially given the reputation of goblin engineering.  I\'m surprised the place didn\'t explode on impact.$b$bI suspect there may be magical forces at play here.  There may be more to Booty Bay than you\'d expect, $c...','',26124),
(49721,'enUS','Are you ready to leave Stranglethorn Vale?','',26124),
(49722,'enUS','Yes.  Please prepare the portal, Erallier.','Yes.  Please prepare the portal, Erallier.',26124),
(49723,'enUS','','Most rogues prefer to cloak themselves in the shadows, but not Helix.',26124),
(49724,'enUS','','You never know what skitters in the darkness.',26124),
(49725,'enUS','','Can you imagine the life of a machine?',26124),
(49726,'enUS','','A simple spark can mean the difference between life...and death.',26124),
(49727,'enUS','All is lost....  Forgive me, my Queen....','',26124),
(49728,'enUS','Flame of Life!  Burn within me and renew my vigor!','',26124),
(49729,'enUS','','Deathwing!  I have fallen....  The brood... is lost.',26124),
(49730,'enUS','','The energy infused within my clutch is mine to reclaim!',26124),
(49731,'enUS','I serve the Dark Lady!','I serve the Dark Lady!',26124),
(49732,'enUS','','Suffer!',26124),
(49733,'enUS','I am yours to command.','I am yours to command.',26124),
(49734,'enUS','','Feel my hatred!',26124),
(49735,'enUS','I am reborn!','I am reborn!',26124),
(49736,'enUS','For the Forsaken!','For the Forsaken!',26124),
(49737,'enUS','I... I don\'t understand...','I... I don\'t understand...',26124),
(49738,'enUS','','Come forth, children of twilight....',26124),
(49739,'enUS','','Your mother calls!',26124),
(49740,'enUS','You are weakening, Sintharia!  Accept the inevitable!','',26124),
(49741,'enUS','Who are you?  What happened?','Who are you?  What happened?',26124),
(49742,'enUS','','Ripsnarl wasn\'t always a bloodthirsty savage.  Once, he even had a family.',26124),
(49743,'enUS','Where am I?','Where am I?',26124),
(49744,'enUS','AHHHHH!','AHHHHH!',26124),
(49745,'enUS','','He was called James Harrington.  A tragedy in three parts.',26124),
(49746,'enUS','Och!$b$bWhy can\'t it just be easy fer once?!','',26124),
(49747,'enUS','Use Pumpkin Bombs to defeat large clusters of zombies or weaken difficult ones.','Use Pumpkin Bombs to defeat large clusters of zombies or weaken difficult ones.',26124),
(49748,'enUS','','I will not share my father\'s fate!  Your tale ends here!',26124),
(49749,'enUS','','The first of many.',26124),
(49750,'enUS','','Did you really think I would come to this fight alone?',26124),
(49751,'enUS','','Fools!  This entire ship is rigged with explosives!  Enjoy your fiery deaths!',26124),
(49752,'enUS','','If I\'m going to die, I\'m taking you all with me!',26124),
(49753,'enUS','','ENOUGH!  I will not give you the pleasure!',26124),
(49754,'enUS','','MY FATE IS MY OWN!',26124),
(49755,'enUS','','Vanessa has detonated charges on the ship!  Get to the ropes at the side of the boat!',26124),
(49756,'enUS','','Vanessa is detonating more charges!  Get to the ropes at the side of the boat!',26124),
(49757,'enUS','','Vanessa pulls out a final barrel of mining powder and ignites it!  RUN!',26124),
(49758,'enUS','','Deathwing is victorious! Try again once Alexstrasza recovers.',26124),
(49759,'enUS','','The circle of life is not yet prepared for Alexstrasza. Speak with me again as soon as I have finished my preparations.',26124),
(49760,'enUS','','Alexstrasza is already engaged with Deathwing! If you hurry, there may still be time to help!',26124),
(49761,'enUS','Calissa...I am so sorry...','',26124),
(49762,'enUS','','James...please...I love you...',26124),
(49763,'enUS','','Calissa is dying!',26124),
(49764,'enUS','Good work with them constructs, $glad:lass;.$b$bYou just bought us unfettered access to the repository.','',26124),
(49765,'enUS','I bring greetings from King Wrynn, $c. Behind me is the Hero\'s Call board, a collection of proclamations from the King of Stormwind directing adventurers to locations where their talents can best aid the Alliance.','',26124),
(49766,'enUS','Lok\'tar, $c. Behind me is the Warchief\'s Command board containing our leader\'s instructions to members of the Horde. It will tell you where your skills will best serve the Horde in battle against its foes.','',26124),
(49767,'enUS','Remember ta always show yer respect for the elements.','Remember ta always show yer respect for the elements.',26124),
(49768,'enUS','Always strive ta understand the balance maintained by our world\'s elemental spirits.','Always strive ta understand the balance maintained by our world\'s elemental spirits.',26124),
(49769,'enUS','','Keep him distracted!',26124),
(49770,'enUS','','Gut him! Tear him apart!',26124),
(49771,'enUS','','H-help! Get him off me!',26124),
(49772,'enUS','You defended against the attack!$BThe Warden will not be happy about this...','You defended against the attack!$BThe Warden will not be happy about this...',26124),
(49773,'enUS','Bring elevator to first floor.','Bring elevator to first floor.',26124),
(49774,'enUS','Help Alexstrasza by killing the Twilight Corruptors.','',26124),
(49775,'enUS','Bring elevator to second floor.','Bring elevator to second floor.',26124),
(49776,'enUS','Bring elevator to third floor.','Bring elevator to third floor.',26124),
(49777,'enUS','Choose a destination.','Choose a destination.',26124),
(49778,'enUS','Summon elevator to current floor.','Summon elevator to current floor.',26124),
(49779,'enUS','','Alexstrasza is hurt. Keep the beams red by killing Twilight Corruptors, or she will lose the fight!',26124),
(49780,'enUS','$n, get to one of the Krazz Cannons and shoot those Stormtalons down before they bring this whole place down on us!','',26124),
(49781,'enUS','I wish I could have seen the looks on their faces when they realized you were shooting them down with our junk.','',26124),
(49782,'enUS','Inconceivable! You may actually defeat my lava worm! Perhaps I can help... tip the scales. ','',26124),
(49783,'enUS','The sacrifices of my Argent Dawn brothers must never be forgotten. They believed in the Dawn, though none lived to see the return of the Light to these lands.','',26124),
(49784,'enUS','Use the Flame Jet attack to engulf enemies in flames!','Use the Flame Jet attack to engulf enemies in flames!',26124),
(49785,'enUS','','Your time ends now!',26124),
(49786,'enUS','If you pay the right price, the Light can always protect you, $c.','If you pay the right price, the Light can always protect you, $c.',26124),
(49787,'enUS','If you\'ve got the money, I\'m sure the Light\'s got something to teach you.','If you\'ve got the money, I\'m sure the Light\'s got something to teach you.',26124),
(49788,'enUS','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BWe are the preservers of the balance, now and forever, with Malfurion watching over us.  Never forget this.','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.$B$BWe are the preservers of the balance, now and forever, with Malfurion watching over us.  Never forget this.',26124),
(49789,'enUS','Our master Malfurion has returned from the Dreaming, $c.  His is the light of a beacon that shows the way for us, and we must do everything in our power to preserve that light.','Our master Malfurion has returned from the Dreaming, $c.  His is the light of a beacon that shows the way for us, and we must do everything in our power to preserve that light.',26124),
(49790,'enUS','I must admit, I couldn\'ta done this one without yer help.','',26124),
(49791,'enUS','There we go. That should do it!','',26124),
(49792,'enUS','Accessing data... stand by.','',26124),
(49793,'enUS','|TInterface\\Icons\\INV_ELEMENTAL_PRIMAL_SHADOW.BLP:20|t%s throws |cFF660099dark|r magic into the cauldron!','',26124),
(49794,'enUS','Accessing reorigination device override.','',26124),
(49795,'enUS','Yeah, yeah. Just read the discs and gimme access already...','',26124),
(49796,'enUS','Repository access denied. Reorigination subroutine initiated.','',26124),
(49797,'enUS','What!? Wait! That\'s no good! That\'s no good at all...','',26124),
(49798,'enUS','Warning!$bReorigination device activated. Detonation in one minute.','',26124),
(49799,'enUS','One minute!? Come on, Brann! Think!','',26124),
(49800,'enUS','I\'m goin\' in manually! There\'s gotta be a way!','',26124),
(49801,'enUS','Detonation in thirty seconds.','',26124),
(49802,'enUS','Arrite! Fuses exposed! Now which one ta break? Red? Or blue...?','',26124),
(49803,'enUS','Och! I can\'t decide!','',26124),
(49804,'enUS','Come, monsters! We will crush you!','',26124),
(49805,'enUS','Arrite, here goes nuthin\'!','',26124),
(49806,'enUS','Your filthy dogs won\'t be enough!','',26124),
(49807,'enUS','I\'ll kill a hundred more of your battle worgs!','',26124),
(49808,'enUS','Your worgs are no match for the might of Stormwind!','',26124),
(49809,'enUS','Look alive, men! There are orcs and worgs about!','',26124),
(49810,'enUS','Pebble bounces around and looks up at you hopefully. He definitely remembers you.','',26124),
(49811,'enUS','Come little guy, let\'s get out of here.','Come little guy, let\'s get out of here.',26124),
(49812,'enUS','Pebble\'s stones jitter as he obediently falls in beside you.','',26124),
(49813,'enUS','Pebble bounces up and down happily as he disappears into the distance.','',26124),
(49814,'enUS','Pebble shuffles around happily and disappears into the distance.','',26124),
(49815,'enUS','Pebble shuffles up against your leg happily, then races off into the distance.','',26124),
(49816,'enUS','Pebble bobbles around appreciatively and then disappears into the distance.','',26124),
(49817,'enUS','How about, in consideration of all ye\'ve done, we go with...','',26124),
(49818,'enUS','RED! For the HORDE!','',26124),
(49819,'enUS','Blue! For the Alliance!','',26124),
(49820,'enUS','Reorigination device detonation aborted.','',26124),
(49821,'enUS','Escaping from this place is proving harder than I thought.$B$BWhere do you go when there is nowhere to go in sight?','',26124),
(49822,'enUS','Wahooo!','',26124),
(49823,'enUS','Azeroth lives to see another day!','',26124),
(49824,'enUS','Yeah, there\'s tons of people still trapped in the escape pods, boss. Oh, wait. I guess you\'re not the boss anymore. Anyways, they\'re all probably going to drown if you don\'t get them out.','',26124),
(49825,'enUS','I cannot help you, $c.','I cannot help you, $c.',26124),
(49826,'enUS','You move with grace, rogue. How may I help you?','You move with grace, rogue. How may I help you?',26124),
(49827,'enUS','','We need all of our bombs and tools to survive on this deserted island, $n.',26124),
(49828,'enUS','$n, you gotta get those teraptor hatchlings before they get us!','',26124),
(49829,'enUS','Did you hear the matriarch growling up on the cliff? Steer clear of her!','',26124),
(49830,'enUS','The monkeys are going to get a kick out of those bananas!','',26124),
(49831,'enUS','That was the most beautiful thing that I\'ve ever seen!','',26124),
(49832,'enUS','','Dampwick\'s at the cave entrance just to the southeast.',26124),
(49833,'enUS','The kaja\'mite has gone and made these monkeys smart! Keep that miner safe, $n.','',26124),
(49834,'enUS','On behalf of the Bilgewater Cartel, I lay claim to this mine!','',26124),
(49835,'enUS','','We need some new friends if we\'re going to survive all of this. Hopefully, the orcs won\'t just kill you on sight.',26124),
(49836,'enUS','It\'s been quite the pleasure workin\' with yeh, $glad:lass;.$b$bI\'d be honored ta do so again sometime.','',26124),
(49837,'enUS','We\'ll kill anybody for the right price!','We\'ll kill anybody for the right price!',26124),
(49838,'enUS','Time to join your friends, kissin\' the dirt!','Time to join your friends, kissin\' the dirt!',26124),
(49839,'enUS','DIE!!!','DIE!!!',26124),
(49840,'enUS','We\'re gonna burn this place to the ground!','We\'re gonna burn this place to the ground!',26124),
(49841,'enUS','Enough of your pesky pea-shooters. Let them shoot at this!','Enough of your pesky pea-shooters. Let them shoot at this!',26124),
(49842,'enUS','','Deepholm has changed much in recent years. It\'s hardly recognizable.$B$BStill... here I am free from corruption. Free from the tainting influence of ancient gods. It seems that sometimes your freedom must be stripped away for you to truly appreciate its value.',26124),
(49843,'enUS','','Kilag Gorefang should be down the path to the west, goblin.',26124),
(49844,'enUS','%s begins to cast Rising Flames!','',26124),
(49845,'enUS','','I know you. I have you to thank for my freedom from the deepening corruption that consumed me for so many years.$B$BWelcome to my home. Deepholm.  It is a shadow of what it used to be, but still, here I can be free. I shall never take such freedom for granted after what we have endured.$B$BI know not why you are here, but I hope you find what you seek within the stone walls of this place. Stay safe, $n.',26124),
(49846,'enUS','Use your weed whacker to mow down these plants, little goblin!','',26124),
(49847,'enUS','This mole machine is a little rusty, but it still looks operational.','',26124),
(49848,'enUS','Hit the button labeled \"Just past the Grim Guzzler\".','Hit the button labeled \"Just past the Grim Guzzler\".',26124),
(49849,'enUS','Hit the button labeled \'Into the Domicile\'.','Hit the button labeled \'Into the Domicile\'.',26124),
(49850,'enUS','Hit the button labeled \'Entrance\'.','Hit the button labeled \'Entrance\'.',26124),
(49851,'enUS','Attention. Attention, everyone. I would like to offer my sincerest apologies that I am so much richer than all of you. I truly hope you find a way to continue on.','',26124),
(49852,'enUS','Good for you. Good for all of you to go on living your lives knowing you can never have the wealth that I do. I\'m proud of you for sticking it out.','',26124),
(49853,'enUS','Sometimes... sometimes it hurts to have so much money. It\'s so lonely. Just me and all my gold.','',26124),
(49854,'enUS','Hahahah! This reminds me of that little boy who came up and told me he wanted to be just like me, sitting on his own pile of gold someday. So adorable. I told him to get back to mopping and stop being lazy. I mean, really.','',26124),
(49855,'enUS','Go back to Aggra and tell her that we\'re moving northwest.','',26124),
(49856,'enUS','Three cheers for all of you! Keep on riding that rocketway and buying from those vendors. You\'re contributing to the most noble cause in all of Azeroth: my pockets!','',26124),
(49857,'enUS','Thank you. Thank you all for coming to stare at my enormous, bulging piles of gold. It must feel like such a wonderful privilege to be in my presence.','',26124),
(49858,'enUS','I am so... darn... beautiful. Look at these guns. Look at this gold. Look at these girls. Who wouldn\'t want to be me?','',26124),
(49859,'enUS','','',26124),
(49860,'enUS','','Head back through the vale and meetup with Kilag at the Wild Overlook.',26124),
(49861,'enUS','<PLACEHOLDER: Exciting Cinematic!>','',26124),
(49862,'enUS','Why are you talking to me? You don\'t make nearly as much money as me.$B$BGo mingle with your own kind, pal.','',26124),
(49863,'enUS','Ride Bastia! Find Brax!','',26124),
(49864,'enUS','','Uh oh, it\'s the Trade Prince.',26124),
(49865,'enUS','Zen\'tabra, are you one of the druids from the rumors? Were there druids on the Echo Isles long ago?','Zen\'tabra, are you one of the druids from the rumors? Were there druids on the Echo Isles long ago?',26124),
(49866,'enUS','','<Zen\'tabra laughs.>$B$BWe spread dose rumors, mon. Keep\'n Zalazane and others off our tails. Don\'t be believin\' everyting ya hear.$B$BNo, we be new ta de craft, only learnin\' a few years ago. But in some ways, we spent our lives preparin\' ta answer de call....',26124),
(49867,'enUS','What were you before you were druids, then?','What were you before you were druids, then?',26124),
(49868,'enUS','','Some o\' us be loa priests, witch doctors before. Like Zalazane...$B$B<Zen\'tabra\'s face grows hard as her gaze drifts south.>$B$BWe thought de spirits be angry wit us; we did not suspect it be Zalazane slowly cuttin\' us off from dem. We knew he be strong, but not dat strong... and by de time his voodoo had reached de other isles, we was powerless ta stop \'im. ',26124),
(49869,'enUS','How did you escape Zalazane?','How did you escape Zalazane?',26124),
(49870,'enUS','','<Zen\'tabra closes her eyes and shakes her head.>$B$BWhen Vol\'jin called for everyone ta flee, we... we couldn\'t face de tribe after failing dem so badly. So, we fled south, ta de untamed jungle islands.$B$BDe wilds claimed a few o\' us dat first night. We found safety in a deep cave in de center o\' de isle, but me dreams dere were not peaceful: I be havin\' a vision!',26124),
(49871,'enUS','What was the vision?','What was the vision?',26124),
(49872,'enUS','The battle is about to begin!','',26124),
(49873,'enUS','|TInterface\\Icons\\spell_fire_flamebolt.blp:32|t  Use Your Fire Blast to incinerate Twilight Shadowdrakes.','',26124),
(49874,'enUS','','<Zen\'tabra\'s head snaps back to you, her eyes bright and her smile wide around her tusks.>$B$B\'Twas a jungle bigger and wilder dan I ever seen! And before me, de ancient raptor loa only talked about in Zandalari tales-Gonk, de Great Hunter! $B$BDe raptor spirit spoke ta me, told me he had brought me spirit to a place called de Emerald Dream. De spirit had been trapped, like de other loa on de Echo Isles, by Zalazane\'s magic. But Gonk, bein\' an ancient spirit, was able ta reach across and bring me spirit ta him, even through Zalazane\'s voodoo. ',26124),
(49875,'enUS','|TInterface\\Icons\\ability_druid_ravage.blp:32|t  When your enemies are weak, tear them from the sky with your Finishing Strike!','',26124),
(49876,'enUS','What did the spirit want?','What did the spirit want?',26124),
(49877,'enUS','|TInterface\\Icons\\spell_nature_healingway.blp:32|t  Your Lifebinder Boon will heal others while restoring your health and mana.','',26124),
(49878,'enUS','','Zalazane\'s mindless servants were killin\' all de beasts o\' de isles, burnin\' up de trees and plants too. Gonk needed us ta save de life on de isles. But since we not be able ta draw upon de power o\' de loa wit Zalazane in power, Gonk be showin\' us a new way ta connect wit ALL de spirits o\' nature, ta work WIT de spirits, not just be servin\' a single loa at a time. $B$BIt be difficult at first, ya, mon, but Gonk be showin\' us how ta also reach inta de Emerald Dream ta speak wit de spirits and learn from dem directly!',26124),
(49879,'enUS','How did the other loa react to this?','How did the other loa react to this?',26124),
(49880,'enUS','','<Zen\'tabra laughs.>$B$BDe other loa, \'specially Shirvallah, did not much care for dis plan. Dey still be wantin\' us ta work just for one o\' dem at a time, not wit all de spirits at once. But Gonk had forced dere hands, and dey knew it was de only way ta save de isles while Zalazane still ruled.$B$BI be tinkin\' dat Gonk did not care for de other loa much either. He be teasin\' de other loa all de time while we be learnin\' from dem.',26124),
(49881,'enUS','So what happened then?','So what happened then?',26124),
(49882,'enUS','','We been workin\' wit de spirits for many moons now, mon, but many o\' us already knew de forms o\' de loa we served before. It not be easy, but de Emerald Dream be a powerful teacher by itself-havin\' de spirits demselves also teachin\' ya... it hurries tings along.$B$BDat don\'t mean \'twas easy keepin\' safe from Zalazane. Even wit our new tricks combined wit de loa givin\' what help dey could, we lost a few bruddas and sistas over de years ta his voodoo and mindless servants. But we kept de life o\' de isles alive, and when Vol\'jin and de Darkspears returned, we knew just how ta take Zalazane down.',26124),
(49883,'enUS','So are the loa still holding to their side of the deal?','So are the loa still holding to their side of the deal?',26124),
(49884,'enUS','','Ya, mon, for now. Dey not be too keen on teachin\' many more o\' our kind, but dey be helpin\' us \'long as we be keepin\' de life o\' de isles flourishin\'. When Gonk left after de fall o\' Zalazane, he be tellin\' us how ta contact him if de other loa don\'t keep dey end o\' de bargain.$B$BI be hopin\' it never come ta dat... but just in case, we be openin\' up channels wit dat Cenarion Circle group. $B$B<Zen\'tabra cackles madly.>$B$BOh, ya shoulda seen de look on dat night elf\'s face....',26124),
(49885,'enUS','Most of my men were killed while infiltrating the Neferset borders.$B$BIt is my duty to make that sacrifice count for something.','',26124),
(49886,'enUS','Hurry, $n, deploy the Town-In-A-Box. Our people are trapped inside! Oh! I almost forgot your parachute.','',26124),
(49887,'enUS','This is the longest day of my life.','',26124),
(49888,'enUS','Hobart\'s right behind you, $g sir : ma\'am;.','',26124),
(49889,'enUS','Be healed, $g brother:sister;!','',26124),
(49890,'enUS','AND I LAY MY HANDS UPON YOU!','',26124),
(49891,'enUS','Let the Holy Light embrace you!','',26124),
(49892,'enUS','BY THE LIGHT BE RENEWED!','',26124),
(49893,'enUS','FIGHT ON, $G BROTHER:SISTER;!','',26124),
(49894,'enUS','It\'s really quite simple, $n. Just attach these fireworks to the wild cluckers and I\'ll use this controller to fly them into the cage.','',26124),
(49895,'enUS','I could use a heal, brother!','',26124),
(49896,'enUS','Make yourself useful and heal me, Paxton!','',26124),
(49897,'enUS','HELP!','',26124),
(49898,'enUS','I need a heal!','',26124),
(49899,'enUS','Now get us some real eggs.','',26124),
(49900,'enUS','Don\'t underestimate the Mechachicken, $n. After all, it is a Hobart Grapplehammer invention!','',26124),
(49901,'enUS','Scrying','Scrying',26124),
(49902,'enUS','Are you enjoying Pilgrim\'s Bounty, $n?  Let me know if you need help finding anything.','Are you enjoying Pilgrim\'s Bounty, $n?  Let me know if you need help finding anything.',26124),
(49903,'enUS','Happy Pilgrim\'s Bounty, $c!','Happy Pilgrim\'s Bounty, $c!',26124),
(49904,'enUS','Hello there, $n.  Happy Pilgrim\'s Bounty!','Hello there, $n.  Happy Pilgrim\'s Bounty!',26124),
(49905,'enUS','Are you enjoying Pilgrim\'s Bounty, $n?  Let me know if you need help finding anything.','Are you enjoying Pilgrim\'s Bounty, $n?  Let me know if you need help finding anything.',26124),
(49906,'enUS','Happy Pilgrim\'s Bounty, $c!','Happy Pilgrim\'s Bounty, $c!',26124),
(49907,'enUS','Hello there, $n.  Happy Pilgrim\'s Bounty!','Hello there, $n.  Happy Pilgrim\'s Bounty!',26124),
(49908,'enUS','Are you enjoying Pilgrim\'s Bounty, $n?  Let me know if you need help finding anything.','Are you enjoying Pilgrim\'s Bounty, $n?  Let me know if you need help finding anything.',26124),
(49909,'enUS','Happy Pilgrim\'s Bounty, $c!','Happy Pilgrim\'s Bounty, $c!',26124),
(49910,'enUS','Hello there, $n.  Happy Pilgrim\'s Bounty!','Hello there, $n.  Happy Pilgrim\'s Bounty!',26124),
(49911,'enUS','','$n, get to the Mechashark X-Steam Controller. Rid us of the Hammer menace!',26124),
(49912,'enUS','Has Pilgrim\'s Bounty got you in the shopping spirit, $c?  Well, you have come to the right place!','Has Pilgrim\'s Bounty got you in the shopping spirit, $c?  Well, you have come to the right place!',26124),
(49913,'enUS','Has Pilgrim\'s Bounty got you in the shopping spirit, $c?  Well, you have come to the right place!','Has Pilgrim\'s Bounty got you in the shopping spirit, $c?  Well, you have come to the right place!',26124),
(49914,'enUS','Has Pilgrim\'s Bounty got you in the shopping spirit, $c?  Well, you have come to the right place!','Has Pilgrim\'s Bounty got you in the shopping spirit, $c?  Well, you have come to the right place!',26124),
(49915,'enUS','Thank the Light!','',26124),
(49916,'enUS','Bless you, hero!','',26124),
(49917,'enUS','I will fear no evil!','',26124),
(49918,'enUS','I live to fight another day!','',26124),
(49919,'enUS','I... I\'m ok! I\'m ok!','',26124),
(49920,'enUS','Happy Winter Veil, $n!','Happy Winter Veil, $n!',26124),
(49921,'enUS','A happy Winter Veil to you, $c!','A happy Winter Veil to you, $c!',26124),
(49922,'enUS','You\'re $n! The hero that everyone has been talking about! Thank you!','',26124),
(49923,'enUS','Looking for the perfect Winter Veil gift, $c, or are you just here to treat yourself?','Looking for the perfect Winter Veil gift, $c, or are you just here to treat yourself?',26124),
(49924,'enUS','I hope you are having a wonderous Winter Veil, $n!','I hope you are having a wonderous Winter Veil, $n!',26124),
(49925,'enUS','Happy Winter Veil, $n!','Happy Winter Veil, $n!',26124),
(49926,'enUS','A happy Winter Veil to you, $c!','A happy Winter Veil to you, $c!',26124),
(49927,'enUS','Looking for the perfect Winter Veil gift, $c, or are you just here to treat yourself?','Looking for the perfect Winter Veil gift, $c, or are you just here to treat yourself?',26124),
(49928,'enUS','I hope you are having a wonderous Winter Veil, $n!','I hope you are having a wonderous Winter Veil, $n!',26124),
(49929,'enUS','Hail, $n.  We\'re in need of your assistance.','',26124),
(49930,'enUS','Happy Winter Veil, $n!','Happy Winter Veil, $n!',26124),
(49931,'enUS','A happy Winter Veil to you, $c!','A happy Winter Veil to you, $c!',26124),
(49932,'enUS','Looking for the perfect Winter Veil gift, $c, or are you just here to treat yourself?','Looking for the perfect Winter Veil gift, $c, or are you just here to treat yourself?',26124),
(49933,'enUS','I hope you are having a wonderous Winter Veil, $n!','I hope you are having a wonderous Winter Veil, $n!',26124),
(49934,'enUS','The marketing research Megs has conducted suggests that a naga invasion is imminent!','',26124),
(49935,'enUS','Happy Lunar Festival, $n!','Happy Lunar Festival, $n!',26124),
(49936,'enUS','May your elders bless you, $n, and bring you luck in the coming year.','May your elders bless you, $n, and bring you luck in the coming year.',26124),
(49937,'enUS','Congratulations and may you be prosperous, $c.','Congratulations and may you be prosperous, $c.',26124),
(49938,'enUS','','You hear that, naga? $n is on $g his : her; way to settle our \"negotiations\"!',26124),
(49939,'enUS','May this Lunar Festival and season be good to you, $c.','May this Lunar Festival and season be good to you, $c.',26124),
(49940,'enUS','Happy Lunar Festival, $n!','Happy Lunar Festival, $n!',26124),
(49941,'enUS','May your elders bless you, $n, and bring you luck in the coming year.','May your elders bless you, $n, and bring you luck in the coming year.',26124),
(49942,'enUS','Congratulations and may you be prosperous, $c.','Congratulations and may you be prosperous, $c.',26124),
(49943,'enUS','May this Lunar Festival and season be good to you, $c.','May this Lunar Festival and season be good to you, $c.',26124),
(49944,'enUS','Happy Lunar Festival, $n!','Happy Lunar Festival, $n!',26124),
(49945,'enUS','May your elders bless you, $n, and bring you luck in the coming year.','May your elders bless you, $n, and bring you luck in the coming year.',26124),
(49946,'enUS','Congratulations and may you be prosperous, $c.','Congratulations and may you be prosperous, $c.',26124),
(49947,'enUS','May this Lunar Festival and season be good to you, $c.','May this Lunar Festival and season be good to you, $c.',26124),
(49948,'enUS','We can discuss the cut after you come back with the hides. I\'m thinking ninety-ten.','',26124),
(49949,'enUS','Happy Brewfest, $n!','Happy Brewfest, $n!',26124),
(49950,'enUS','Enjoying the Midsummer Fire Festival, $c?','Enjoying the Midsummer Fire Festival, $c?',26124),
(49951,'enUS','','Everybody loves a pool pony. It\'s our fastest selling toy behind the Kablooey Bombs: Infant Edition.',26124),
(49952,'enUS','Festive Midsummer, $c!','Festive Midsummer, $c!',26124),
(49953,'enUS','Midsummer Fire Festival is a great time to adventure, but it\'s also a great time to shop!','Midsummer Fire Festival is a great time to adventure, but it\'s also a great time to shop!',26124),
(49954,'enUS','Merry Midsummer, $n!','Merry Midsummer, $n!',26124),
(49955,'enUS','Enjoying the Midsummer Fire Festival, $c?','Enjoying the Midsummer Fire Festival, $c?',26124),
(49956,'enUS','Festive Midsummer, $c!','Festive Midsummer, $c!',26124),
(49957,'enUS','Midsummer Fire Festival is a great time to adventure, but it\'s also a great time to shop!','Midsummer Fire Festival is a great time to adventure, but it\'s also a great time to shop!',26124),
(49958,'enUS','Merry Midsummer, $n!','Merry Midsummer, $n!',26124),
(49959,'enUS','Enjoying the Midsummer Fire Festival, $c?','Enjoying the Midsummer Fire Festival, $c?',26124),
(49960,'enUS','Festive Midsummer, $c!','Festive Midsummer, $c!',26124),
(49961,'enUS','Midsummer Fire Festival is a great time to adventure, but it\'s also a great time to shop!','Midsummer Fire Festival is a great time to adventure, but it\'s also a great time to shop!',26124),
(49962,'enUS','Are you having a good time during Brewfest, $c?','Are you having a good time during Brewfest, $c?',26124),
(49963,'enUS','When you are at the Brewfest grounds, have a drink for me, $c!','When you are at the Brewfest grounds, have a drink for me, $c!',26124),
(49964,'enUS','Have you tried the pretzels at Brewfest?  They are amazing, $c!','Have you tried the pretzels at Brewfest?  They are amazing, $c!',26124),
(49965,'enUS','Happy Brewfest, $n!','Happy Brewfest, $n!',26124),
(49966,'enUS','Are you having a good time during Brewfest, $c?','Are you having a good time during Brewfest, $c?',26124),
(49967,'enUS','When you are at the Brewfest grounds, have a drink for me, $c!','When you are at the Brewfest grounds, have a drink for me, $c!',26124),
(49968,'enUS','Have you tried the pretzels at Brewfest?  They are amazing, $c!','Have you tried the pretzels at Brewfest?  They are amazing, $c!',26124),
(49969,'enUS','Happy Brewfest, $n!','Happy Brewfest, $n!',26124),
(49970,'enUS','Are you having a good time during Brewfest, $c?','Are you having a good time during Brewfest, $c?',26124),
(49971,'enUS','When you are at the Brewfest grounds, have a drink for me, $c!','When you are at the Brewfest grounds, have a drink for me, $c!',26124),
(49972,'enUS','Have you tried the pretzels at Brewfest?  They are amazing, $c!','Have you tried the pretzels at Brewfest?  They are amazing, $c!',26124),
(49973,'enUS','','$n, hop into one of those B.C. Eliminators and wipe out the pygmies!',26124),
(49974,'enUS','','You\'re going to have to take the fight to them, $n. Look for Izzy just outside their village.',26124),
(49975,'enUS','I cannot help you, $c.','I cannot help you, $c.',26124),
(49976,'enUS','You move with grace, rogue. How may I help you?','You move with grace, rogue. How may I help you?',26124),
(49977,'enUS','The Twilight Documents go flying through the air!','',26124),
(49978,'enUS','I\'m in charge of this operation.$B$BI don\'t want to hear any yammering about our transport exploding or our enemies being taller than we are. We\'re professionals and we\'re getting this job done without a hitch.','',26124),
(49979,'enUS','Feast ye eyes upon the dreadful, clever, all-powerful, hate-filled, sword-swingin\', face-punchin\', insult-flingin\', and all around handsome, BURGY BLACKHEART.','',26124),
(49980,'enUS','Seriously. Feast away. I\'m quite beautiful.','',26124),
(49983,'enUS','[DEBUG] I left combat!!!','[DEBUG] I left combat!!!',26124),
(49984,'enUS','Build some defenses before Warden Stillwater arrives!','Build some defenses before Warden Stillwater arrives!',26124),
(49985,'enUS','Slay Warden Stillwater before you\'re overwhelmed!','Slay Warden Stillwater before you\'re overwhelmed!',26124),
(49986,'enUS','Enough fooling around. It\'s time for some hands-on management!','Enough fooling around. It\'s time for some hands-on management!',26124),
(49987,'enUS','What?! No! This lawn... was... mine...','What?! No! This lawn... was... mine...',26124),
(49988,'enUS','<The SI:7 agent is unconscious.>','',26124),
(49989,'enUS','The shadow sees. Bal\'qwari Og Shadar. The end comes!','The shadow sees. Bal\'qwari Og Shadar. The end comes!',26124),
(49990,'enUS','The sun eclipses. Darkness crawls through earth and ash. The seas are as blood...','The sun eclipses. Darkness crawls through earth and ash. The seas are as blood...',26124),
(49991,'enUS','Fear broils forth from the heart of the infinite... Don\'t make me look! I\'ve seen more than I can stand!','Fear broils forth from the heart of the infinite... Don\'t make me look! I\'ve seen more than I can stand!',26124),
(49992,'enUS','Nothing, nothing, we are nothing. The grasper touches our hearts and clenches his fist.','Nothing, nothing, we are nothing. The grasper touches our hearts and clenches his fist.',26124),
(49993,'enUS','I\'m going in after Erunak. Follow me, $n!','',26124),
(49994,'enUS','Gillari, geth\'shar. Gillari, teko\'shar. It sees. It knows.','Gillari, geth\'shar. Gillari, teko\'shar. It sees. It knows.',26124),
(49995,'enUS','My eyes are opened, yet they see only black.','My eyes are opened, yet they see only black.',26124),
(49996,'enUS','Shethnoth, ol\'goth, grell. Such is the mantra of those who come.','Shethnoth, ol\'goth, grell. Such is the mantra of those who come.',26124),
(49997,'enUS','The harbinger has come. The world heaves.','The harbinger has come. The world heaves.',26124),
(49998,'enUS','You want take Dormus camels?  NO!  MY CAMELS!  DORMUS KILL YOU!!!','',26124),
(49999,'enUS','Hey, make sure not to walk into that smoker!  The last unfortunate $r to do that didn\'t survive the heat.$b$bThat poor, delicious $r.','',26124),
(50000,'enUS','I\'m going in after Erunak. Follow me, $n!','',26124),
(50001,'enUS','Please, try and be sensitive to an orc\'s condition.  I\'m having a rough couple of days, and I\'d prefer if you kept your comments to yourself.','',26124),
(50002,'enUS','I\'d love nothing more than to take down Naz\'jar and her minions, but someone\'s got to cover your back...','',26124),
(50003,'enUS','I\'d love nothing more than to wring that witch\'s neck myself, but someone\'s got to keep these naga off of your back...$b$bDo not fail me, $n!','',26124),
(50004,'enUS','Let\'s clean this up and get these boys out. I\'ve got another operation waiting.','',26124),
(50005,'enUS','','Your ride\'s waitin\', buddy. Let\'s ditch this place!',26124),
(50006,'enUS','Press on, friend.$b$bI shall find my way out when strength returns to me.','',26124),
(50007,'enUS','','$n, you gotta get in there and rescue our people!',26124),
(50008,'enUS','','Goblin zombies? The Town-In-A-Box has to be warned!',26124),
(50009,'enUS','Yep! Off we go.','',26124),
(50010,'enUS','Easy ... does it...','',26124),
(50011,'enUS','Right then. I hate long plane rides. So I\'mma gonna kick in the after-market burners and ignite our entire fuel supply in one go.','',26124),
(50012,'enUS','Whatever yeh do... Don\'t. Black. Out!','',26124),
(50013,'enUS','','Those zombies are slow. You don\'t have to run right through them. Don\'t let them eat your brains, $n!',26124),
(50014,'enUS','What can I do for you, $n?','',26124),
(50015,'enUS','What can I do for you, $n? Need some training?','',26124),
(50016,'enUS','Oh man, zombies?$B$BNeed some training?','',26124),
(50017,'enUS','In spite of our losses here, Hellscream will be pleased to know that the naga general was defeated.','',26124),
(50018,'enUS','Oh man, zombies?','',26124),
(50019,'enUS','Despite our losses here, the king will be pleased to know that the naga general was defeated.','',26124),
(50020,'enUS','Nice work deploying the Town-In-A-Box, $n.$B$BNeed any training?','',26124),
(50021,'enUS','Nice work deploying the Town-In-A-Box, $n.','',26124),
(50022,'enUS','Those zombies are so slow. It\'s a turkey shoot out there!$B$BNeed any training before you head out?','',26124),
(50023,'enUS','Those zombies are so slow. It\'s a turkey shoot out there!','',26124),
(50024,'enUS','A Town-In-A-Box. Nice!$B$BNeed any training, $n?','',26124),
(50025,'enUS','A Town-In-A-Box. Nice!','',26124),
(50026,'enUS','I\'d watch my step around that machine, $c.','',26124),
(50027,'enUS','Careful, you don\'t want to end up like the last $r that used that machine.','',26124),
(50028,'enUS','That machine is a piece of junk.  But once you are done using it, come see me for your first aid needs, $c.','',26124),
(50029,'enUS','You are really going to risk life and limb on that busted up machine?  There are far more reputable trainers in Orgrimmar.','',26124),
(50030,'enUS','How dare they change our people into zombies and throw them at us!$B$BNeed some training before you go up there and kick their butts?','',26124),
(50031,'enUS','How dare they change our people into zombies and throw them at us!','',26124),
(50032,'enUS','Do you smell the burning?  Do you see the shoes? Can you piece this puzzle together, $c?','',26124),
(50033,'enUS','Are you sure you don\'t want first aid training?  If you use that machine, I may get a chance to practice my skills on you, $c.','',26124),
(50034,'enUS','The last $c to use that machine got the boot... Or rather, the machine got their boots.','',26124),
(50035,'enUS','We need to give this another try.','We need to give this another try.',26124),
(50036,'enUS','Don\'t touch those boots!  I\'m waiting for the authorities to show up and collect the evidence.','',26124),
(50037,'enUS','Keeping the fusion core stable is taxing nearly all my computational powers.$B$BLet us hope that floating-point error got worked out during my last maintenance cycle.','',26124),
(50038,'enUS','A Town-In-A-Box. Are we not the greatest tinkers in the world?$B$BNeed any training, my young protege?','',26124),
(50039,'enUS','A Town-In-A-Box. Are we not the greatest tinkers in the world?','',26124),
(50040,'enUS','That\'s some nice work there!','',26124),
(50041,'enUS','Hmm... interesting choice of parts.','',26124),
(50042,'enUS','Boy I wish I had a ride like this!','',26124),
(50043,'enUS','I bet this baby has got some real orcpower inside.','',26124),
(50044,'enUS','This probably isn\'t a smooth ride, but I bet I\'d look smooth in this ride.','',26124),
(50045,'enUS','The flag is a nice touch.  I bet a few more accessories will really make this rocket stand out.','',26124),
(50046,'enUS','Goblin zombies? Goblin zombies! Wreck those pygmies, $n!$B$BNeed any training before you go?','',26124),
(50047,'enUS','Goblin zombies? Goblin zombies! Wreck those pygmies, $n!','',26124),
(50048,'enUS','','Great work getting this place going, $n!',26124),
(50049,'enUS','','You gotta do something about these pygmies, $n!',26124),
(50050,'enUS','There was a time when I could ask whatever I wished from those who sought out my master.  But now, he takes pretty much anyone in as an apprentice and they can pass through his portals all they please.$B$BIt is upsetting to me, but I do not question his orders.  I can only take enjoyment in making fun of the ridiculous clothes you wear or the pathetic look on your face.  Even that bores me...$B$BEven this rambling bores me!  Go. Be gone. Share your depressing sense of style with someone else.','',26124),
(50051,'enUS','','How much did you charge to deploy this place?$B$BWant to spend some of that moolah on training?',26124),
(50052,'enUS','','How much did you charge to deploy this place?',26124),
(50053,'enUS','','Zombies, goblin or not, are an abomination in the eyes of the Light. Besides, there\'s no profit in them.$B$BNot yet anyway.$B$BNeed any training, $n?',26124),
(50054,'enUS','','Zombies, goblin or not, are an abomination in the eyes of the Light. Besides, there\'s no profit in them.$B$BNot yet anyway.',26124),
(50055,'enUS','','Deploying an urban setting in the middle of the wild. I love it!$B$BNeed any training, $n?',26124),
(50056,'enUS','','Deploying an urban setting in the middle of the wild. I love it!',26124),
(50057,'enUS','You\'ll find Ergll to the northeast. This should help you get across the bay more quickly.','',26124),
(50058,'enUS','','Can you sneak up on zombies? Don\'t they smell your brains when you get close?$B$BHalf the people around here have nothing to worry about then.$B$BNeed any training, $n?',26124),
(50059,'enUS','','Can you sneak up on zombies? Don\'t they smell your brains when you get close?$B$BHalf the people around here have nothing to worry about then.',26124),
(50060,'enUS','Warrior-Matic NX-01 is offline.','',26124),
(50061,'enUS','Warrior-Matic NX-01 destroy!$B$BInsert coins for further instructional training.','',26124),
(50062,'enUS','Warrior-Matic NX-01 is online.$B$BInsert coins for further instructional training.','',26124),
(50063,'enUS','Warrior-Matic NX-01 is offline.','',26124),
(50064,'enUS','I\'ve come too far to be chased off by a few undead bullies.','I\'ve come too far to be chased off by a few undead bullies.',26124),
(50065,'enUS','Everyone\'s a critic, ladies.','',26124),
(50066,'enUS','When you are a genius, you have to put up with a lot of strange actions.','',26124),
(50067,'enUS','I want to see how long I can last against the waves of undead.','I want to see how long I can last against the waves of undead.',26124),
(50068,'enUS','Ladies, ladies... It\'s going to be alright.  I\'ve already captured the creature\'s essence in my painting.','',26124),
(50069,'enUS','It\'ll be okay ladies.  Just look at my painting and remember better days.  Or you can just look at me and imagine a better future.','',26124),
(50070,'enUS','Well that\'s one way to voice your opinion.','',26124),
(50071,'enUS','Ladies, please.  The boar will live on in my art.  Please don\'t shed another tear, unless it is because my art moves you so.','',26124),
(50072,'enUS','Get in there and show those zombies what the Bilgewater Buccaneers are made of, kid!','',26124),
(50073,'enUS','','It\'s amazing!',26124),
(50074,'enUS','','Sooo lifelike!',26124),
(50075,'enUS','','It\'s looks just like it!',26124),
(50076,'enUS','','It\'s beautiful!',26124),
(50077,'enUS','','Absolutely stunning!',26124),
(50078,'enUS','','The colors are so vivid!',26124),
(50079,'enUS','','I\'ve never seen something so beautiful in all my life!',26124),
(50080,'enUS','','You should paint me sometime, Sudsy.',26124),
(50081,'enUS','Remember, look for the pygmy leaders: Gaahl, Malmo, and Teloch.','',26124),
(50082,'enUS','','Look for the mounds of glowing stuff on the ground.',26124),
(50083,'enUS','You\'re going to love this!','',26124),
(50084,'enUS','That Schnottz is a madman! I ain\'t never goin\' back!','',26124),
(50085,'enUS','Oh, like you coulda done any better.','',26124),
(50086,'enUS','Take your time, my $g boy : girl;. Now what can I modify this shredder boot to be? Hmm.','',26124),
(50087,'enUS','I\'ve set the Bootzooka to fire several rockets per shot. I\'m fairly certain that I perfectly calibrated the targeting.','',26124),
(50088,'enUS','','Greetings, $n.',26124),
(50089,'enUS','All those dragon essences I\'ve collected... the power... is exhilerating!','',26124),
(50090,'enUS','You can\'t take this away from me!  Not now, not ever!','',26124),
(50091,'enUS','Flintlocke, if we have a big giant cannon, why don\'t we just shoot ... a cannonball?','',26124),
(50092,'enUS','But once ol\' $p here blasts through their bulkhead in a hail of splintered wood, blood, and phlegm then starts crawlin\' across the deck with both legs broken, oh aye, they\'ll not see THAT comin\' by a sweet mile, no sir!','',26124),
(50093,'enUS','I specialize in two things: taking tiny things and making them blow up into huge things, and making huge things fit into itty-bitty places.$b$bWhich one do you need today?','',26124),
(50094,'enUS','','Deliver justice for our dead, $n.',26124),
(50095,'enUS','','Goblin grenades versus gnomish land mines. Show them who\'s better, $n!',26124),
(50096,'enUS','','You honor us with your actions on behalf of our dead, $n.',26124),
(50097,'enUS','','I forget... did you take flying lessons back on Kezan?',26124),
(50098,'enUS','','It is no use.  My magic is ineffective on these creatures.',26124),
(50099,'enUS','','Better hurry up, $n. I think that Thrall has news on where our people are being held.',26124),
(50100,'enUS','Run, Bastia! Get $n to Sky Falls and the labor mine.','',26124),
(50101,'enUS','','Greely drools a little as she continues her mindless labor.',26124),
(50102,'enUS','','We\'ve got to get our people out of here, $n! The key is to get them to drink plenty of Kaja\'Cola Zero-One!',26124),
(50103,'enUS','','$n, we need to escape through the northern tunnel!',26124),
(50104,'enUS','','Hold on!',26124),
(50105,'enUS','','Get rid of those Steamwheedle Sharks before they trounce us!',26124),
(50106,'enUS','We\'re gonna make you the ultimate footbomb uniform, kid. But first, we need parts. Lots of them.','',26124),
(50107,'enUS','','You cannot let him walk all over you like that! Go get his heart, girl!',26124),
(50108,'enUS','I never liked that guy. He stole your girlfriend. I say, good riddance!','',26124),
(50109,'enUS','','It\'s time for a little sabotage!',26124),
(50110,'enUS','We need oil and lots of it if we\'re going to get your footbomb uniform running, kid!','',26124),
(50111,'enUS','','Deliver the footbomb uniform to the Slave Pits. Hurry, $n!',26124),
(50112,'enUS','Booster rockets for cages. What will I think of next? I am a genius!','',26124),
(50113,'enUS','There\'s nothing I hate more than mercenaries. They are without honor!','',26124),
(50114,'enUS','','First she left you for Chip, and now the Trade Prince! She was never good enough for you, $n.',26124),
(50115,'enUS','','She stole your man, girlfriend! You know what you gotta do!',26124),
(50116,'enUS','Victory or death, $c!','',26124),
(50117,'enUS','[Right-Click] |cFFFFFFFFon Injured Stormwind Infantry that you find in the north field.|r','[Right-Click] |cFFFFFFFFon Injured Stormwind Infantry that you find in the north field.|r',26124),
(50118,'enUS','','Rise from the grave and serve the Dark Lady!',26124),
(50119,'enUS','','In the name of Sylvanas, the Banshee Queen, I bestow this gift upon you!',26124),
(50120,'enUS','','Rise from death\'s slumber and join your brothers!',26124),
(50121,'enUS','','Waken, sleeper. Your new life awaits.',26124),
(50122,'enUS','','You are returned to life. The Banshee Queen asks for your service.',26124),
(50123,'enUS','Oh come on! What about us?!','Oh come on! What about us?!',26124),
(50124,'enUS','You\'re kidding, right? You came all the way here for THAT?!','You\'re kidding, right? You came all the way here for THAT?!',26124),
(50125,'enUS','Hey bud, I\'ll sell ya my wife if you get me outta here. She won\'t mind!','Hey bud, I\'ll sell ya my wife if you get me outta here. She won\'t mind!',26124),
(50126,'enUS','Let\'s see, I just saw a corpse with a jaw that would fit you...','',26124),
(50127,'enUS','That should do the job. Come back right away if it falls off again.','',26124),
(50128,'enUS','T-thank you, Undert-t-taker.','',26124),
(50129,'enUS','The end of all things is upon us!','The end of all things is upon us!',26124),
(50130,'enUS','Behold the powers of the master!','Behold the powers of the master!',26124),
(50131,'enUS','You only delay the inevitable.','You only delay the inevitable.',26124),
(50132,'enUS','I bask in the twilight.','I bask in the twilight.',26124),
(50133,'enUS','Your life is meaningless. ','Your life is meaningless. ',26124),
(50134,'enUS','A waste of my time...','A waste of my time...',26124),
(50135,'enUS','Give in. ','Give in. ',26124),
(50136,'enUS','You will make an excellent sacrifice.','You will make an excellent sacrifice.',26124),
(50137,'enUS','Do you not feel the master\'s gaze?! It watches us all!','Do you not feel the master\'s gaze?! It watches us all!',26124),
(50138,'enUS','The master will end everything! ','The master will end everything! ',26124),
(50139,'enUS','All will fall to the master\'s call....','All will fall to the master\'s call....',26124),
(50140,'enUS','This is the end... for you, and for the world.','This is the end... for you, and for the world.',26124),
(50141,'enUS','Embrace the coming of the end!','Embrace the coming of the end!',26124),
(50142,'enUS','I will prove myself to the master!','I will prove myself to the master!',26124),
(50143,'enUS','Whispers... whispers... I can hear the whispers.... ','Whispers... whispers... I can hear the whispers.... ',26124),
(50144,'enUS','Biting... clawing... clutching... tearing...','Biting... clawing... clutching... tearing...',26124),
(50145,'enUS','Rrrr... kill! Eat! ','Rrrr... kill! Eat! ',26124),
(50146,'enUS','Guuuurarrrrgh!','Guuuurarrrrgh!',26124),
(50147,'enUS','Me... break... ','Me... break... ',26124),
(50148,'enUS','Grrr... crush!','Grrr... crush!',26124),
(50149,'enUS','Kill! Kill! Kill!','Kill! Kill! Kill!',26124),
(50150,'enUS','Rarrrargh! Rip! Rip!','Rarrrargh! Rip! Rip!',26124),
(50151,'enUS','Aaaaraaaargh!','Aaaaraaaargh!',26124),
(50152,'enUS','Me... smash!','Me... smash!',26124),
(50153,'enUS','To the crushing depths with you!','To the crushing depths with you!',26124),
(50154,'enUS','These waters were ours even before the Sundering!','These waters were ours even before the Sundering!',26124),
(50155,'enUS','Tides take you!','Tides take you!',26124),
(50156,'enUS','These waters will be your grave. ','These waters will be your grave. ',26124),
(50157,'enUS','A curse upon your kind, trespasser! ','A curse upon your kind, trespasser! ',26124),
(50158,'enUS','Tides, give me strength!','Tides, give me strength!',26124),
(50159,'enUS','I will crush the breath from your lungs!','I will crush the breath from your lungs!',26124),
(50160,'enUS','You will never take these waters from us!','You will never take these waters from us!',26124),
(50161,'enUS','Blasted Horde! ','Blasted Horde! ',26124),
(50162,'enUS','Waste your energy on the Twilight\'s Hammer, monster, not us!','Waste your energy on the Twilight\'s Hammer, monster, not us!',26124),
(50163,'enUS','If you want a fight, you\'ll get one!','If you want a fight, you\'ll get one!',26124),
(50164,'enUS','Confounded beasts! You\'ll pay for what you did to our fleet!','Confounded beasts! You\'ll pay for what you did to our fleet!',26124),
(50165,'enUS','Begone from here, Horde filth!','Begone from here, Horde filth!',26124),
(50166,'enUS','Where\'s your \"honor\" now, Horde scum?','Where\'s your \"honor\" now, Horde scum?',26124),
(50167,'enUS','You Horde are as bad as the Twilight\'s Hammer!','You Horde are as bad as the Twilight\'s Hammer!',26124),
(50168,'enUS','This land belongs to the Alliance, Horde wretch! Away with you!','This land belongs to the Alliance, Horde wretch! Away with you!',26124),
(50169,'enUS','Killin\' time! ','Killin\' time! ',26124),
(50170,'enUS','Ah, I be needin\' a new shrunken head....','Ah, I be needin\' a new shrunken head....',26124),
(50171,'enUS','Relax, mon, I be makin\' dis quick.','Relax, mon, I be makin\' dis quick.',26124),
(50172,'enUS','Ya be trespassin\' on our land now, mon.','Ya be trespassin\' on our land now, mon.',26124),
(50173,'enUS','De Shatterspears own dese lands, and ya not be welcome!','De Shatterspears own dese lands, and ya not be welcome!',26124),
(50174,'enUS','HA! Let\'s at least keep it interesting.','',26124),
(50175,'enUS','I be stabbin\' first and askin\' later!','I be stabbin\' first and askin\' later!',26124),
(50176,'enUS','We gonna be dancin\' on ya grave tonight, mon!','We gonna be dancin\' on ya grave tonight, mon!',26124),
(50177,'enUS','I be movin\' to de groove; ya be movin\' to de grave!','I be movin\' to de groove; ya be movin\' to de grave!',26124),
(50178,'enUS','This is just too easy...','',26124),
(50179,'enUS','Ungh!','Ungh!',26124),
(50180,'enUS','Oof!','Oof!',26124),
(50181,'enUS','Ugh...','Ugh...',26124),
(50182,'enUS','','Your skill at range would be best suited to the fight higher up. Use your hooks to ascend to one of the upper Vermillion Skyscreamers, then pick off the circling Pyrewings from there.',26124),
(50183,'enUS','The drake under you is mortally wounded and about to fall! Move to another drake, quickly!\n\n|TInterface\\Icons\\inv_misc_hook_01.blp:32|t','',26124),
(50184,'enUS','Keep it up.','Keep it up.',26124),
(50185,'enUS','Here\'s some more water.','Here\'s some more water.',26124),
(50186,'enUS','We\'ll keep the buckets coming.','We\'ll keep the buckets coming.',26124),
(50187,'enUS','Over there! The fire\'s flarin\' up!','Over there! The fire\'s flarin\' up!',26124),
(50188,'enUS','We\'ve got your back.','We\'ve got your back.',26124),
(50189,'enUS','Ready for some more?','Ready for some more?',26124),
(50190,'enUS','We\'re not done yet.','We\'re not done yet.',26124),
(50191,'enUS','','Vanessa begins throwing poison vials!  Climb up quickly!',26124),
(50192,'enUS','You\'ve been bitten by a worgen.  It\'s probably nothing, but it sure stings a little.$B$B|TInterface\\Icons\\INV_Misc_monsterfang_02.blp:32|t','',26124),
(50193,'enUS','A chest is revealed near the rear entrance!','A chest is revealed near the rear entrance!',26124),
(50194,'enUS','What... what\'s happening to me? Why have you done this to me?','',26124),
(50195,'enUS','I should be dead and to death I will return!','',26124),
(50196,'enUS','This is Lady Sylvanas\'s doing?','',26124),
(50197,'enUS','What magic is this that turns back the hand of death?','',26124),
(50198,'enUS','I... I don\'t remember... Why have you done this?','',26124),
(50199,'enUS','What use has the Dark Lady for me?','',26124),
(50200,'enUS','If the Banshee Queen has offered me this chance, I will gladly serve.','',26124),
(50201,'enUS','I never asked for this! Leave me alone!','',26124),
(50202,'enUS','Ha! You throw like my greatmother.','',26124),
(50203,'enUS','Watch and learn, pup.','',26124),
(50204,'enUS','Prepare to witness perfection.','',26124),
(50205,'enUS','Not bad... you might be able to hit the broad side of a sickly kodo.','',26124),
(50206,'enUS','This one\'s going straight through.','',26124),
(50207,'enUS','Two silver says I can split that arrow down the shaft.','',26124),
(50208,'enUS','These dragons aren\'t messin\' around. I\'m not sure all of these scrubs know what they\'re in for.$B$BWe\'ll be fine though. My boys can lead the charge and get this job done. All we need is some space to work.','',26124),
(50209,'enUS','When you are ready, touch the altar to begin.','',26124),
(50210,'enUS','When the trial begins, shadows from under you will periodically break free, traveling to a nearby portal to summon a Weeping Soul.','',26124),
(50211,'enUS','The Weeping Souls may be frightening, but they are somewhat predictable. Lure them into the rune traps spread across the ground.','',26124),
(50212,'enUS','Each time you successfully trap a Weeping Soul, you will receive a stack of Shadow Bait.','',26124),
(50213,'enUS','Each time a Weeping Soul strikes you, you will lose a stack of Shadow Bait.','',26124),
(50214,'enUS','Attain 20 stacks of Shadow Bait to complete the trial.','',26124),
(50215,'enUS','...','...',26124),
(50216,'enUS','Every few seconds, many of the nearby runes will burst with fire.','',26124),
(50217,'enUS','As each rune bursts, a bolt of fire will travel to one or more nearby runes, triggering it to be one of the next runes to burst.','',26124),
(50218,'enUS','If you watch these bolts of fire closely to see which runes are not hit, you can spot safe spots for the next burst.','',26124),
(50219,'enUS','Occassionally, some runes will fizzle with black smoke, preventing them from firing during the following burst.','',26124),
(50220,'enUS','Stay within the runes without getting hit by fire until you have 10 stacks of Fire Dancing to complete the trial.','',26124),
(50221,'enUS','Beware: straying from the runes for too long or getting hit by multiple bursts in a row will require you to start over.','',26124),
(50222,'enUS','Spread across the plateau are frost orbs that will grant you stacks of Essence of Ice if you approach them.','',26124),
(50223,'enUS','Avoid the rotating frost burn effects, or you will take damage and lose a stack of Essence of Ice.','',26124),
(50224,'enUS','The frost runes on the ground will fling you into the air if you touch them, which can be a boon or an inconvenience.','',26124),
(50225,'enUS','Do not stray too close to the chilled ground or you will find moving significantly more strenuous.','',26124),
(50226,'enUS','Be nimble, think ahead, and give dangers a wide berth, and gather 20 stacks of Essence of Ice to complete this trial.','',26124),
(50228,'enUS','Spread across the ledge of the Arcane Pinnacle are 6 pedestals that will energize you if touched.','',26124),
(50229,'enUS','Using the energy pads on the ground, ascend the Arcane Pinnacle, touching all the pedestals along the way.','',26124),
(50230,'enUS','Keep moving or you will risk being hit by arcane detonations that will hurl you into the waters below.','',26124),
(50231,'enUS','If you fall into the water below, don\'t be discouraged. Swim back to the first ledge and start again.','',26124),
(50232,'enUS','Reach the top of the Arcane Pinnacle with 6 stacks of Energized to complete the trial.','',26124),
(50233,'enUS','Welcome to Fuselight-by-the-Sea, a picturesque seaside town founded by explosives enthusiasts for explosives enthusiasts.','',26124),
(50234,'enUS','I\'d like to make this my home.','I\'d like to make this my home.',26124),
(50235,'enUS','Well, hop to it then!','',26124),
(50236,'enUS','How does the Trial of Frost work?','',26124),
(50237,'enUS','How does this work exactly?','',26124),
(50238,'enUS','How does the Trial of Fire work?','',26124),
(50239,'enUS','How does the Trial of Shadow work?','',26124),
(50240,'enUS','Good work. I\'ll keep the men pushing from here. Move forward and take the last gate.','',26124),
(50241,'enUS','Good work. I\'ll keep the men pushing from here. Move forward and take the last gate.','',26124),
(50242,'enUS','|TInterface\\Icons\\INV_FIREARM_2H_RIFLE_CATACLYSM_B_01.BLP:20|t%s begins to cast |cFFFF0000|Hspell:93520|h[Pistol Barrage]|h|r!','',26124),
(50243,'enUS','','Here we go. Hold on tight!',26124),
(50244,'enUS','','Watch those tentacles! Their reach is frightening.',26124),
(50245,'enUS','','NOO! Let go you filthy beast!',26124),
(50246,'enUS','Hey, Zak, what\'s the average life-expectancy for one of your explosive analysts?','',26124),
(50247,'enUS','That bad, eh?','',26124),
(50248,'enUS','With that new super-charged elementium blasting powder? You don\'t want to know...','',26124),
(50249,'enUS','','Baleflame! Your tender flesh shall be an appropriate meal for my whelps!',26124),
(50250,'enUS','Come, my children! Awaken and feast upon their flesh!','Come, my children! Awaken and feast upon their flesh!',26124),
(50251,'enUS','Hatch and rise, carry out the legacy of the Black Dragonflight!','Hatch and rise, carry out the legacy of the Black Dragonflight!',26124),
(50252,'enUS','Bathe in the flaming blood of the earth!','Bathe in the flaming blood of the earth!',26124),
(50253,'enUS','Burn!','Burn!',26124),
(50254,'enUS','No! My clutch is the last...! Father... I\'ve failed you...','No! My clutch is the last...! Father... I\'ve failed you...',26124),
(50255,'enUS','I didn\'t sign up for this!','',26124),
(50256,'enUS','Hey, nothin\' personal, but you gotta die.','',26124),
(50257,'enUS','It\'s me or you, buddy, and it ain\'t gonna be me.','',26124),
(50258,'enUS','Gimme all ya got, and I\'ll make it quick.','',26124),
(50259,'enUS','I got orders sayin\' you gotta die, and you\'re not the one payin\' my bills.','',26124),
(50260,'enUS','Time for you to take a long nap in the sand....','',26124),
(50261,'enUS','I love gettin\' paid for this.','',26124),
(50262,'enUS','Bah, I\'m not gettin\' paid enough for this.','',26124),
(50263,'enUS','They\'re turning our people into MONSTERS!!','They\'re turning our people into MONSTERS!!',26124),
(50264,'enUS','Hold them back!  We must protect the survivors!','Hold them back!  We must protect the survivors!',26124),
(50265,'enUS','Don\'t look into their eyes!  They\'re not the people you once knew!','Don\'t look into their eyes!  They\'re not the people you once knew!',26124),
(50266,'enUS','Welcome to the Shrine of Aviana, $c. Here we sit atop the world and touch the sky.','',26124),
(50267,'enUS','Ah, $n! We meet once more. I helped you attain your swift flight form in Outland.$B$B<Morthis tightens his jaw and shakes his head, his withered eyes sad.>$B$BThese young druids today... they have it too easy.','',26124),
(50268,'enUS','','I get a lot of mail, $n. Most of it is junk, but some of them might be helpful to a helpful $c like you. Here\'s a couple letters sent to Everlook, looking for help in the far corners of the world.$b$bIt\'s almost as if you have a choice for where you go next!  Now, let\'s see...',26124),
(50269,'enUS','','That statue\'s provin\' ta be quite the pain.  I thought we could lift it up an\' outta the water with a crane an\' some well timed explosives.  But Wick thought we\'d be safer an\' do less damage by rolling it up this ramp.$B$BNow look at it...  We\'ve got it angled all wrong.  An\' once we get it to the top, then what?$B$BI\'ve gotta bad feeling we\'re gonna to be here a long time.  A real long time...',26124),
(50270,'enUS','You think after doing such good work on Stormwind Harbor I\'d get a bit of slack from this dwarf...$B$BI just want to get this statue up the ramp and back in place as fast as possible.  But she\'s got a complaint every step of the way.  Her solution to every problem is to blow it up.  It feels like I\'m working with a gnome or a goblin.  But at least they\'d be sober.$B$BLook at our work crew, no discipline.  You know why?  Because she undermines me!$B$BA bad attitude, a lazy crew... This isn\'t going to be a quick fix at all.','',26124),
(50271,'enUS','The Cenarion Circle been around a long time, mon. We trolls are newcomers to this party.','',26124),
(50272,'enUS','I guess that\'s the way...','',26124),
(50273,'enUS','...the cookie crumbles.','',26124),
(50274,'enUS','','The pitiful human escaped!',26124),
(50275,'enUS','','COWARD!',26124),
(50276,'enUS','|TInterface\\Icons\\spell_frost_frostnova.blp:20|t The wedding party is afflicted with |cFFFF0000|Hspell:91978|h[Cold Feet]|h|r!','|TInterface\\Icons\\spell_frost_frostnova.blp:20|t The wedding party is afflicted with |cFFFF0000|Hspell:91978|h[Cold Feet]|h|r!',26124),
(50277,'enUS','I don\'t think a weapon that big is legal in this town...','',26124),
(50278,'enUS','And who do you think you are? I\'ll use as large a weapon as I please!','',26124),
(50279,'enUS','I\'m the warden, and you know that! You\'d better not make any trouble, because I\'ll know the moment that you try anything...','',26124),
(50280,'enUS','Russell Brower begins to play a wedding hymn!  Stand near him to receive its regenerative effects!','Russell Brower begins to play a wedding hymn!  Stand near him to receive its regenerative effects!',26124),
(50281,'enUS','Oh, not that! Look, I\'m quaking in my boots...','',26124),
(50282,'enUS','As most of you know, we\'re about to begin another intensive round of demolitions testing.','',26124),
(50283,'enUS','It won\'t be easy. It\'s true that six out of every seven analysts won\'t live to see Demolitions Analyst II.','',26124),
(50284,'enUS','The important thing to remember is that we\'re all here because of our love for explosions!','',26124),
(50285,'enUS','So let\'s make every explosion a quality asplosion!','',26124),
(50286,'enUS','|TInterface\\Icons\\spell_holy_prayerofshadowprotection.blp:20|t The Beast Unleashed begins to emit an |cFFFF0000|Hspell:93717|h[Aura of Darkness]|h|r!','|TInterface\\Icons\\spell_holy_prayerofshadowprotection.blp:20|t The Beast Unleashed begins to emit an |cFFFF0000|Hspell:93717|h[Aura of Darkness]|h|r!',26124),
(50287,'enUS','','Ha ha! I have your Grindgear Gorilla!',26124),
(50288,'enUS','','I wonder if your Grindgear Gorilla can jump across the Park!',26124),
(50289,'enUS','','I have your gorilla! Nyah nyah!',26124),
(50290,'enUS','','I wonder how far the gears turn?',26124),
(50291,'enUS','','If you want him back you\'re gonna have to beg... like a monkey!!',26124),
(50292,'enUS','','Now who\'s the crybaby, crybaby!?',26124),
(50293,'enUS','','Baby wants his dolly!',26124),
(50294,'enUS','','Whoops!',26124),
(50295,'enUS','','So, doctor, how goes your research?',26124),
(50296,'enUS','We\'re nearing completion on the next batch of high-powered elementium explosives.','',26124),
(50297,'enUS','I\'m hoping this is the breakthrough that will allow us to pack more explosive power into a smaller bomb.','',26124),
(50298,'enUS','No fair!  Gimme back my gorilla!!','',26124),
(50299,'enUS','Gimmie back Jum-jump!','',26124),
(50300,'enUS','You better not break Jum-jump!  It\'s not fair!','',26124),
(50301,'enUS','WAAAHHH!!!','',26124),
(50302,'enUS','You\'re being mean!  I\'m telling Mommy!','',26124),
(50303,'enUS','Stop twisting his legs, they aren\'t supposed to bend that way!','',26124),
(50304,'enUS','You\'re breaking him!','',26124),
(50305,'enUS','Stop it! You\'ll break his legs off!','',26124),
(50306,'enUS','The good doctor is being modest. He knows precisely how much powder to put in the charge, down to the very grain.','',26124),
(50307,'enUS','Welcome back to Thundermar, $n. Fighting continues all across the shire, but with Alliance help I think we can gain the upper hand.','',26124),
(50308,'enUS','%s roars wildly, initiating a massive stomp attack!','',26124),
(50309,'enUS','He already knows it will be a smashing success!','',26124),
(50310,'enUS','','To success, then!',26124),
(50311,'enUS','Use Eoin\'s mug to replenish your health!','Use Eoin\'s mug to replenish your health!',26124),
(50312,'enUS','Greetings, $c. We Wildhammer reward our friends.','',26124),
(50313,'enUS','','This was one of the royal cities of the elves in the days when Azshara was queen. In this city lie the keys to lore long lost and artifacts of unimaginable historical value. ',26124),
(50314,'enUS','','The captain and his forces pushed forward to take one of the bases you scouted for him earlier. You should go and meet them.',26124),
(50315,'enUS','The totem is halfway finished with taking its sample.','',26124),
(50316,'enUS','The totem has finished taking its sample!','',26124),
(50317,'enUS','You\'ve succeeded in defending the bridge. The summon ritual has been completed.','',26124),
(50318,'enUS','Can\'t... lift... tools...','',26124),
(50319,'enUS','What you do to me?','',26124),
(50320,'enUS','Who am I?','Who am I?',26124),
(50321,'enUS','No make me small!','',26124),
(50322,'enUS','Why everyone else get so big?','',26124),
(50323,'enUS','Repel the intruders!','',26124),
(50324,'enUS','I\'ll kill you!','I\'ll kill you!',26124),
(50325,'enUS','Look what they\'ve done to me!','Look what they\'ve done to me!',26124),
(50326,'enUS','BLEEAAAGGHHH! I\'m a monster, don\'t look at me!','',26124),
(50327,'enUS','Attention!','',26124),
(50328,'enUS','Bartlett the Brave has set up gryphon roosts here in town.  If you\'re looking to take a ride, then talk to him.','Bartlett the Brave has set up gryphon roosts here in town.  If you\'re looking to take a ride, then talk to him.',26124),
(50329,'enUS','You can\'t come in here!','',26124),
(50330,'enUS','By Kurzen\'s sword!','',26124),
(50331,'enUS','Kill the intruder!','',26124),
(50332,'enUS','','You\'ll die in this cave!',26124),
(50333,'enUS','Activate the altars to gain the blessings of the elements, but avoid the deadly shadow altar!','Activate the altars to gain the blessings of the elements, but avoid the deadly shadow altar!',26124),
(50334,'enUS','Revive your fallen companion by right-clicking on their unconscious body!','Revive your fallen companion by right-clicking on their unconscious body!',26124),
(50335,'enUS','','You have already lost.',26124),
(50336,'enUS','MOLDFANG STRONG!','',26124),
(50337,'enUS','For the Wildhammer!','For the Wildhammer!',26124),
(50338,'enUS','If you can\'t fight at range, use your Jump Drakes! ability:\n\n|TInterface\\Icons\\ability_vehicle_launchplayer.blp:64|t','If you can\'t fight at range, use your Jump Drakes! ability:\n\n|TInterface\\Icons\\ability_vehicle_launchplayer.blp:64|t',26124),
(50339,'enUS','','I will kill you, or I will die trying.',26124),
(50340,'enUS','The Wildhammer horn falls from Kurdran\'s unconscious body!','The Wildhammer horn falls from Kurdran\'s unconscious body!',26124),
(50341,'enUS','Die!','',26124),
(50342,'enUS','Druids?  I haven\'t seen any druids around here.  Although I am sure that in Stormwind you could find one.  You should ask a guard in Stormwind.','Druids?  I haven\'t seen any druids around here.  Although I am sure that in Stormwind you could find one.  You should ask a guard in Stormwind.',26124),
(50343,'enUS','The Dragonmaw drums fall from Zaela\'s unconscious body!','The Dragonmaw drums fall from Zaela\'s unconscious body!',26124),
(50344,'enUS','I\'ll fill your corpses with arrows!','',26124),
(50345,'enUS','Your pain is my release.','',26124),
(50346,'enUS','Blow into the Wildhammer horn to call for reinforcements!','Blow into the Wildhammer horn to call for reinforcements!',26124),
(50347,'enUS','Play the Dragonmaw drums to call for reinforcements!','Play the Dragonmaw drums to call for reinforcements!',26124),
(50348,'enUS','The Scarlet Crusade is not over! Undeath is merely a setback!','',26124),
(50349,'enUS','He\'s too powerful!  You\'ve got to find a way to use those altars to give us an edge!','He\'s too powerful!  You\'ve got to find a way to use those altars to give us an edge!',26124),
(50350,'enUS','The Scourge will rise again, under a dark new master... Ix\'lar!','',26124),
(50351,'enUS','Man down!  We\'ve got a man down!  Get him back up as soon as you can!','Man down!  We\'ve got a man down!  Get him back up as soon as you can!',26124),
(50352,'enUS','Kurdran is down!  You\'ve got to get him back into the fight or we\'re done for!','Kurdran is down!  You\'ve got to get him back into the fight or we\'re done for!',26124),
(50353,'enUS','Lok\'tar ogar!','Lok\'tar ogar!',26124),
(50354,'enUS','Benjamin Foxworthy and his pet, Sly, can be found just behind the smithy, here in Goldshire.  Maybe you should go see if he could help you.','Benjamin Foxworthy and his pet, Sly, can be found just behind the smithy, here in Goldshire.  Maybe you should go see if he could help you.',26124),
(50355,'enUS','I\'ll rip out your eyeballs, weakling...','',26124),
(50356,'enUS','Active.','',26124),
(50357,'enUS','He is too powerful!  Use the altars to harness the powers of the elements and we may stand a chance!','He is too powerful!  Use the altars to harness the powers of the elements and we may stand a chance!',26124),
(50358,'enUS','You must tend to the wounded!  Quickly!','You must tend to the wounded!  Quickly!',26124),
(50359,'enUS','Online.','',26124),
(50360,'enUS','Zaela has fallen!  Revive her or we will meet our end on this forsaken altar!','Zaela has fallen!  Revive her or we will meet our end on this forsaken altar!',26124),
(50361,'enUS','My kin won\'t forget what you\'ve done! We will rage, mortals!','',26124),
(50362,'enUS','Wildhammer reinforcements have arrived!','Wildhammer reinforcements have arrived!',26124),
(50363,'enUS','Wha... who... GET OUT OF MY DIGSITE!','',26124),
(50364,'enUS','Dragonmaw reinforcements have arrived!','Dragonmaw reinforcements have arrived!',26124),
(50365,'enUS','So you\'re the ones causing all that ruckus!','',26124),
(50366,'enUS','The flames of Ragnaros will burn you all.','',26124),
(50367,'enUS','A shaman trainer?  Not here in Goldshire.$B$BBut the Wildhammer dwarves in Stormwind\'s Dwarven District may be able to help you out.','A shaman trainer?  Not here in Goldshire.$B$BBut the Wildhammer dwarves in Stormwind\'s Dwarven District may be able to help you out.',26124),
(50368,'enUS','Lok-Narash! To battle!','',26124),
(50369,'enUS','You dare challenge me?','',26124),
(50370,'enUS','KREEEEAAGH!','',26124),
(50371,'enUS','Stay out of Redridge!','',26124),
(50372,'enUS','AAAAHHHHH!','',26124),
(50373,'enUS','You want more? YOU WANT MORE?','',26124),
(50374,'enUS','Oh no... I\'m not done with you.','',26124),
(50375,'enUS','AAAAAAAAHHHHHHHH!!!','',26124),
(50376,'enUS','There\'s nowhere for you to run. The disease is inside you.','',26124),
(50377,'enUS','Damn these orcs.','',26124),
(50378,'enUS','Killin\'s as easy as breathin\'.','',26124),
(50379,'enUS','See you in hell.','',26124),
(50380,'enUS','You maggots brought this on yourselves.','',26124),
(50381,'enUS','More blood! I want more blood!','',26124),
(50382,'enUS','My apologies, $c, but the arcane secrets of the Highborne will forever remain secrets to you.','My apologies, $c, but the arcane secrets of the Highborne will forever remain secrets to you.',26124),
(50383,'enUS','You fight without HONOR!','',26124),
(50384,'enUS','I am the favored of the master Cho\'gall.  I WILL NOT FALL TO YOU.','I am the favored of the master Cho\'gall.  I WILL NOT FALL TO YOU.',26124),
(50385,'enUS','Skullcrusher the Mountain goes into a frenzy!','Skullcrusher the Mountain goes into a frenzy!',26124),
(50386,'enUS','We cannot hold out against power of this magnitude!  You must use the horn!','We cannot hold out against power of this magnitude!  You must use the horn!',26124),
(50387,'enUS','He is too powerful!  You must use the drums!','He is too powerful!  You must use the drums!',26124),
(50388,'enUS','Cho\'gall will...rip you...to pieces...','Cho\'gall will...rip you...to pieces...',26124),
(50389,'enUS','Lok\'tar ogar!','',26124),
(50390,'enUS','Your blood... my axe.','',26124),
(50391,'enUS','You have many lessons to learn.','',26124),
(50392,'enUS','You fought without honor.','',26124),
(50393,'enUS','Ha! I expected a challenge!','',26124),
(50394,'enUS','There\'s more where that came from. I am a well of rage.','',26124),
(50395,'enUS','Feel my rage!','',26124),
(50396,'enUS','And stay down!','',26124),
(50397,'enUS','This is too easy.','',26124),
(50398,'enUS','Serve the Dragonmaw and you will be handsomely rewarded, $c.','',26124),
(50399,'enUS','Take that! Taste the Light!','',26124),
(50400,'enUS','Wow. Is it just me, or did that one die really fast?','',26124),
(50401,'enUS','Ahhhhh ha ha haa!','',26124),
(50402,'enUS','The magic of today pales in comparison to that of millennia past. Still, we Highborne know much of the arcane. Are you ready to learn?','The magic of today pales in comparison to that of millennia past. Still, we Highborne know much of the arcane. Are you ready to learn?',26124),
(50403,'enUS','Did you see that, Tarenar?','',26124),
(50404,'enUS','Ka-boom!','',26124),
(50405,'enUS','FOR CLAN WILDHAMMER!','',26124),
(50406,'enUS','Can we slow down just a bit?','',26124),
(50407,'enUS','I can\'t believe we\'re actually fighting for the Crusade!','',26124),
(50408,'enUS','Take that, ye beardless coward!','',26124),
(50409,'enUS','When I\'m done with ye, ye won\'t have a toe to stand on!','',26124),
(50410,'enUS','Say goodbye to yer kneecaps, baddie!','',26124),
(50411,'enUS','I\'ve had about enough of this aleless inbreed!','',26124),
(50412,'enUS','|TInterface\\Icons\\spell_holy_healingaura.blp:20|tBaron Ashbury begins to cast |cFFFF0000|Hspell:93468|h[Stay of Execution]|h|r!','',26124),
(50413,'enUS','How\'s about a nice, refreshing ale?!','',26124),
(50414,'enUS','I grow tired of this hunt... Time to die!','',26124),
(50415,'enUS','Aye, Broland Galebeard, here in Kharanos, can get ya where ya want ta go.','Aye, Broland Galebeard, here in Kharanos, can get ya where ya want ta go.',26124),
(50416,'enUS','Do you hear it, $r? Place your ear to the ground. Can you hear the echoing drums of war? The earth trembles in anticipation, yet I have heard it coming all along. We must prepare ourselves, young one - for this shall be a war to end all wars. It will be an honor to serve with you on the battle field. I trust that you will stand ready.','',26124),
(50417,'enUS','I stand vigilant here on these steps where my ancestors thrived. Until now, I have enjoyed a lifetime of freedom. I must do what I can to ensure that my children and my children\'s children live their lives free of the perils of war. Praise be to King Phaoris and all of his heroic efforts for my people. Our people. I can not quite place it, $r, but I trust you. Go now, $gsister:brother;, there is much to do before the skies darken with conflict.\n','',26124),
(50418,'enUS','Halbin Frosthammer, from the Wildhammer clan, can be found in Thunderbrew Distillery.  He can help teach ya the ways of the shaman.','Halbin Frosthammer, from the Wildhammer clan, can be found in Thunderbrew Distillery.  He can help teach ya the ways of the shaman.',26124),
(50419,'enUS','I smash your mushrooms!','I smash your mushrooms!',26124),
(50420,'enUS','I smash your mushrooms!','I smash your mushrooms!',26124),
(50421,'enUS','I smash your mushrooms!','I smash your mushrooms!',26124),
(50422,'enUS','I smash your mushrooms!','I smash your mushrooms!',26124),
(50423,'enUS','I smash your mushrooms!','I smash your mushrooms!',26124),
(50424,'enUS','I smash your mushrooms!','I smash your mushrooms!',26124),
(50425,'enUS','I smash your mushrooms!','I smash your mushrooms!',26124),
(50426,'enUS','I smash your mushrooms!','I smash your mushrooms!',26124),
(50427,'enUS','I smash your mushrooms!','I smash your mushrooms!',26124),
(50428,'enUS','I smash your mushrooms!','I smash your mushrooms!',26124),
(50429,'enUS','Greetings, $n.','Greetings, $n.',26124),
(50430,'enUS','Looking to fly somewhere?  Anette Williams, in the western part of town, can get you there on one of her trained bats.','Looking to fly somewhere?  Anette Williams, in the western part of town, can get you there on one of her trained bats.',26124),
(50431,'enUS','The end of all things is upon us!','The end of all things is upon us!',26124),
(50432,'enUS','Behold the powers of the master!','Behold the powers of the master!',26124),
(50433,'enUS','Stormwind Cemetery','Stormwind Cemetery',26124),
(50434,'enUS','You only delay the inevitable.','You only delay the inevitable.',26124),
(50435,'enUS','I bask in the twilight.','I bask in the twilight.',26124),
(50436,'enUS','Your life is meaningless. ','Your life is meaningless. ',26124),
(50437,'enUS','A waste of my time...','A waste of my time...',26124),
(50438,'enUS','Give in. ','Give in. ',26124),
(50439,'enUS','You will make an excellent sacrifice.','You will make an excellent sacrifice.',26124),
(50440,'enUS','Greetings, $n.','',26124),
(50441,'enUS','Do you not feel the master\'s gaze?! It watches us all!','',26124),
(50442,'enUS','Innkeeper Renee has moved to the large building in the center of town.  It\'s the biggest building in Brill... Very hard to miss.','Innkeeper Renee has moved to the large building in the center of town.  It\'s the biggest building in Brill... Very hard to miss.\n',26124),
(50443,'enUS','The master will end everything! ','',26124),
(50444,'enUS','All will fall to the master\'s call....','',26124),
(50445,'enUS','This is the end... for you, and for the world.','',26124),
(50446,'enUS','Embrace the coming of the end!','',26124),
(50447,'enUS','I will prove myself to the master!','',26124),
(50448,'enUS','Whispers... whispers... I can hear the whispers....','',26124),
(50449,'enUS','Biting... clawing... clutching... tearing...','',26124),
(50450,'enUS','I will crush your bones to dust.','I will crush your bones to dust.',26124),
(50451,'enUS','Stones of the earth, obey the call of the Twilight\'s Hammer!','Stones of the earth, obey the call of the Twilight\'s Hammer!',26124),
(50452,'enUS','But a pebble against the avalanche...','But a pebble against the avalanche...',26124),
(50453,'enUS','Excellent, another stone to grind!','Excellent, another stone to grind!',26124),
(50454,'enUS','Crush... pound... rend... yes, master...','Crush... pound... rend... yes, master...',26124),
(50455,'enUS','I control the very air you breathe....','I control the very air you breathe....',26124),
(50456,'enUS','Your screams will carry far on the winds....','Your screams will carry far on the winds....',26124),
(50457,'enUS','Forecasts call for... your demise.','Forecasts call for... your demise.',26124),
(50458,'enUS','Storms of the sky, obey the call of the Twilight\'s Hammer!','Storms of the sky, obey the call of the Twilight\'s Hammer!',26124),
(50459,'enUS','Whispers... whispers in the wind... yes, master...','Whispers... whispers in the wind... yes, master...',26124),
(50460,'enUS','Your death shall be... electrifying.','Your death shall be... electrifying.',26124),
(50461,'enUS','Allow me to catch you up on... current events.','Allow me to catch you up on... current events.',26124),
(50462,'enUS','I\'m afraid I\'ll have to... charge you extra.','I\'m afraid I\'ll have to... charge you extra.',26124),
(50463,'enUS','Lightning above, obey the call of the Twilight\'s Hammer!','Lightning above, obey the call of the Twilight\'s Hammer!',26124),
(50464,'enUS','Crackling... howling... the screams... always screaming...','Crackling... howling... the screams... always screaming...',26124),
(50465,'enUS','This world will burn.','',26124),
(50466,'enUS','All will be ash.','',26124),
(50467,'enUS','Do I look to you like I cast spells?  Well, I did hear that Cain Firesong now hangs out in the laboratory, always working on something unsavory.','Do I look to you like I cast spells?  Well, I did hear that Cain Firesong now hangs out in the laboratory, always working on something unsavory.',26124),
(50468,'enUS','I just want to set the world on fire....','',26124),
(50469,'enUS','Flames below, obey the call of the Twilight\'s Hammer!','',26124),
(50470,'enUS','The flames... they lick... they bite... always biting...','',26124),
(50471,'enUS','May the Light bless the spirits of our ancestors, for they\'ve chosen to allow my son to rest upon this holy ground.','',26124),
(50472,'enUS','It is here, surrounded by the heroes and patriots of Gilneas where he belongs.','',26124),
(50473,'enUS','We\'ll return, Liam.  I swear this to you.','',26124),
(50474,'enUS','Break, broke, broken! Ahahahahaha!','',26124),
(50475,'enUS','Burn, burned, burnt! Hahahahaha!','',26124),
(50476,'enUS','The end is here! The end is now!','',26124),
(50477,'enUS','Gilneas will remember your courage forever, Liam.','',26124),
(50478,'enUS','I\'m sorry... I\'m sorry... I\'m sorry... I\'m sorry... I\'m sorry...','',26124),
(50479,'enUS','I can hear them! Hear them calling! I answer the call! ','',26124),
(50480,'enUS','De Hammer be hungry for ya, mon.','',26124),
(50481,'enUS','Ya be lookin\' good... in a stew.','',26124),
(50482,'enUS','Dey gonna make a fine stew outta ya, mon.','',26124),
(50483,'enUS','Always be room in de pot for more!','',26124),
(50484,'enUS','If ya be lucky, dey eat your head first....','',26124),
(50485,'enUS','Ah, you seek Dark Cleric Beryl.  He\'s now resides in the eastern building.','Ah, you seek Dark Cleric Beryl.  He\'s now resides in the eastern building.',26124),
(50486,'enUS','Yay! Dinner come to ME!','',26124),
(50487,'enUS','Mmm... yum yums!','',26124),
(50488,'enUS','Me kill you with da truffle shuffle!','',26124),
(50489,'enUS','Uh oh! You be in double truffle-shuffle trouble now!','',26124),
(50490,'enUS','You want fight me?! We have triple truffle-shuffle scuffle!','',26124),
(50491,'enUS','Can me eat you? Me be quick.','',26124),
(50492,'enUS','Why you poke me when me eating?!','',26124),
(50493,'enUS','Marion Call is lurking under the stairs in the inn.','Marion Call is lurking under the stairs in the inn.',26124),
(50494,'enUS','Me want eat you, but me full. Me kill you instead.','',26124),
(50495,'enUS','That\'s Rupert Boch you\'re looking for.  He now resides in the basement of the inn.','That\'s Rupert Boch you\'re looking for.  He now resides in the basement of the inn.',26124),
(50496,'enUS','Yeah, that would be Austil de Mon.  You will find him standing guard near one of the meatwagons, near the inn.','Yeah, that would be Austil de Mon.  You will find him standing guard near one of the meatwagons, near the inn.',26124),
(50497,'enUS','Look for The Wyvern\'s Tail, just outside the Hall of the Brave.','Look for The Wyvern\'s Tail, just outside the Hall of the Brave.',26124),
(50498,'enUS','It\'s across the bridge from the gate to The Drag. Listen for the sound of shouting goblins.','It\'s across the bridge from the gate to The Drag. Listen for the sound of shouting goblins.',26124),
(50499,'enUS','Skymaster Skyles stands just before the gate to Eversong Woods.','Skymaster Skyles stands just before the gate to Eversong Woods.',26124),
(50500,'enUS','','It was a pleasure. Stay safe $p.',26124),
(50501,'enUS','It\'s in the Valley of Strength, east of the entrance to Grommash Hold.','It\'s in the Valley of Strength, east of the entrance to Grommash Hold.',26124),
(50502,'enUS','You will find Lothan Silverblade where you can find weapons and armor.  A warrior is never far from his blade.','You will find Lothan Silverblade where you can find weapons and armor.  A warrior is never far from his blade.',26124),
(50503,'enUS','Is blood red?','Is blood red?',26124),
(50504,'enUS','Do wolves howl?','Do wolves howl?',26124),
(50505,'enUS','','You have interfered with our plans for the last time, mortals!',26124),
(50506,'enUS','','Depths take you!',26124),
(50507,'enUS','Do murderers kill?','Do murderers kill?',26124),
(50508,'enUS','','The Abyss awaits!',26124),
(50509,'enUS','','Ulthok, stop them...',26124),
(50510,'enUS','','Armies of the depths, wash over our enemies as a tide of death!',26124),
(50511,'enUS','Do maggots feast on corpses?','Do maggots feast on corpses?',26124),
(50513,'enUS','','Take arms, minions! Rise from the icy depths!',26124),
(50514,'enUS','','Destroy these intruders! Leave them for the great dark beyond!',26124),
(50515,'enUS','Nothing frees the spirit like soaring through the sky.  You may speak with Tak, the Wind Rider Master, in the center of the village, if you wish to soar through the air.','Nothing frees the spirit like soaring through the sky.  You may speak with Tak, the Wind Rider Master, in the center of the village, if you wish to soar through the air.',26124),
(50516,'enUS','Time\'s a wastin, let\'s get to work.','Time\'s a wastin, let\'s get to work.',26124),
(50517,'enUS','Even though we are situatated a distance away from the main island, our mission here is still important.','Even though we are situatated a distance away from the main island, our mission here is still important.',26124),
(50518,'enUS','Gah, the smell of those dirty humans makes me more upset by the second.','Gah, the smell of those dirty humans makes me more upset by the second.',26124),
(50519,'enUS','The peninsula is not a place to be trifled with $r.  Those foul Alliance can be found all over the island.','The peninsula is not a place to be trifled with $r.  Those foul Alliance can be found all over the island.',26124),
(50520,'enUS','Now that we have taken the island back, it\'s time to get to work.  Talk to me again when you are ready to help.','Now that we have taken the island back, it\'s time to get to work.  Talk to me again when you are ready to help.',26124),
(50521,'enUS','You seek a Sunwalker.  Sunwalker Iopi resides with many of our other trainers.','You seek a Sunwalker.  Sunwalker Iopi resides with many of our other trainers.',26124),
(50522,'enUS','Iilth vwah, uhn\'agth fhssh za.','',26124),
(50523,'enUS','Where one falls, many shall take its place...','',26124),
(50524,'enUS','The Hole is a foul place $n.  I would not venture down there unless you are well armed and ready for battle.','The Hole is a foul place $n.  I would not venture down there unless you are well armed and ready for battle.',26124),
(50525,'enUS','Gul\'kafh an\'shel.','',26124),
(50526,'enUS','Gaze into the void.','',26124),
(50527,'enUS','They do not die.','',26124),
(50528,'enUS','The demons in D-Block have been giving us trouble since we got here.  Can you help us out?','The demons in D-Block have been giving us trouble since we got here.  Can you help us out?\n',26124),
(50529,'enUS','Ywaq maq oou.','',26124),
(50530,'enUS','If you seek to walk a righteous path then you should speak with Seer Alsoomse.','If you seek to walk a righteous path then you should speak with Seer Alsoomse.',26124),
(50531,'enUS','Thanks for your help taking the island back $n.  Now we need your help in the Cursed Depths.','Thanks for your help taking the island back $n.  Now we need your help in the Cursed Depths.\n',26124),
(50532,'enUS','Do giants tread lightly?','Do giants tread lightly?',26124),
(50533,'enUS','I thank you, my friends. Forgive me. I... I have grown too weak to be of any assistance.','',26124),
(50534,'enUS','A new host must be found.','',26124),
(50535,'enUS','Too weak to serve.','',26124),
(50536,'enUS','Only your memory remains...','',26124),
(50537,'enUS','The Valley of Honor\'s bank is just before the gate to The Drag.','The Valley of Honor\'s bank is just before the gate to The Drag.',26124),
(50538,'enUS','They are outside the cycle...','',26124),
(50539,'enUS','Does fire consume stone?','Does fire consume stone?',26124),
(50540,'enUS','There is only Ghur\'sha.','',26124),
(50541,'enUS','Give in...','',26124),
(50542,'enUS','Who are your allies?','',26124),
(50543,'enUS','Is. This. Reality?','',26124),
(50544,'enUS','Do rocks float on water?','Do rocks float on water?',26124),
(50545,'enUS','The Valley of Strength\'s bank is south of the entrance to Grommash Hold, northwest of the main gate.','The Valley of Strength\'s bank is south of the entrance to Grommash Hold, northwest of the main gate.',26124),
(50546,'enUS','Hunter','Hunter',26124),
(50547,'enUS','Is ice hot?','Is ice hot?',26124),
(50548,'enUS','Is it that hard for you to find the wind rider master on your own?  Burok is at the southern end of town, next to the wind riders.','Is it that hard for you to find the wind rider master on your own?  Burok is at the southern end of town, next to the wind riders.',26124),
(50549,'enUS','The hippogryphs are well-tended by Zaldaan, in the northern part of town.','The hippogryphs are well-tended by Zaldaan, in the northern part of town.',26124),
(50550,'enUS','It... it worked!  We will defend Nahom with the power stored within this temple!','',26124),
(50551,'enUS','Sir.  The reinforcements were cut off by Neferset troops.  We are on our own.','',26124),
(50552,'enUS','Speak with Un\'Thuwa outside of the Razor Hill barracks.','Speak with Un\'Thuwa outside of the Razor Hill barracks.',26124),
(50553,'enUS','The Conclave of Wind has dissipated. Your honorable conduct and determination have earned you the right to face me in battle, mortals. I await your assault on my platform! Come!','',26124),
(50554,'enUS','Thank you sergeant.  You may return to your post.','',26124),
(50555,'enUS','This is not good, $n.  We have to find a way to hold on to Nahom.','',26124),
(50556,'enUS','This confrontation no longer serves any purpose. I shall end it.','',26124),
(50557,'enUS','Well done. Find Lirastrasza and let her know that we\'ve succeeded.','Well done. Find Lirastrasza and let her know that we\'ve succeeded.',26124),
(50565,'enUS','Your challenge is accepted, mortals! Know that you face Al\'Akir, Elemental Lord of Air! You have no hope of defeating me!','',26124),
(50568,'enUS','The cypher is powering mechanisms deep within the temple!','',26124),
(50569,'enUS','Like swatting insects...','',26124),
(50571,'enUS','Believe me when I tell you, $p, you\'re in on the ground floor of something big!','',26124),
(50573,'enUS','This little one shall vex me no longer.','',26124),
(50580,'enUS','After every storm, comes the calm...','',26124),
(50583,'enUS','You have run out of time, mortals! Your lives are forfeit!','',26124),
(50584,'enUS','Your futile persistance angers me!','',26124),
(50585,'enUS','Enough! I will no longer be contained!','',26124),
(50586,'enUS','Winds! Obey my command!','',26124),
(50587,'enUS','Storms! I summon you to my side!','',26124),
(50588,'enUS','Lightning! Destroy my enemies!','',26124),
(50589,'enUS','The honor of slaying the interlopers shall be mine, brothers! Their feeble bodies will freeze solid from my wind\'s icy chill!','',26124),
(50590,'enUS','Frozen solid.','',26124),
(50591,'enUS','Another mortal has taken their last breath!','',26124),
(50592,'enUS','You throw away your honor and flee as cowards? Then die!','',26124),
(50593,'enUS','If you wish to use a hippogryph, speak with Fidelio.','If you wish to use a hippogryph, speak with Fidelio.',26124),
(50594,'enUS','The power of our winds, UNLEASHED!','',26124),
(50595,'enUS','Brothers, beware! These mortals are dangerous. I must pause and gather my strength.','',26124),
(50596,'enUS','It shall be I that earns the favor of our lord by casting out the intruders. My calmest wind shall still prove too much for them!','',26124),
(50597,'enUS','Begone, outsider!','',26124),
(50598,'enUS','Your presence shall no longer defile our home!','',26124),
(50599,'enUS','You think to outrun the wind? A fatal mistake.','',26124),
(50600,'enUS','The power of our winds, UNLEASHED!','',26124),
(50601,'enUS','My power grows feeble, brothers. I shamefully must rely on you for a time.','',26124),
(50602,'enUS','As I am the strongest wind, it shall be I that tears the invaders apart!','',26124),
(50603,'enUS','Blown away!','',26124),
(50604,'enUS','Mere dust...','',26124),
(50605,'enUS','The Highborne, Irriende, inside of the inn, can train you in the ways of the arcane.','The Highborne, Irriende, inside of the inn, can train you in the ways of the arcane.',26124),
(50606,'enUS','Why do you flee, mortals? There is nowhere you can run or hide here!','',26124),
(50607,'enUS','The intruders stand fast, brothers, I cannot break them. Allow me a brief respite to strengthen my winds.','',26124),
(50608,'enUS','','I... I will stay with you, father.',26124),
(50609,'enUS','','Everybody onboard the ships now!',26124),
(50610,'enUS','Someone must stay behind and keep the Forsaken from gaining a foothold.  Farewell, Genn.','',26124),
(50611,'enUS','Lead our people to their new home.','',26124),
(50612,'enUS','Crowley!  You\'ve done enough.  I cannot allow you to stay behind again...','',26124),
(50613,'enUS','We will return, dear friend.  We will come back, to take what belongs to us.  This I swear!','',26124),
(50614,'enUS','Father... why must we endure such hardship?  Why can\'t we live somewhere sunny and lush?  A tropical island perhaps?','',26124),
(50615,'enUS','Toughen up, lad.  I raised you better than that.  Stiff upper lip!','',26124),
(50616,'enUS','Have you seen my latest invention? It\'s going to be a hit... if it doesn\'t explode.','',26124),
(50617,'enUS','I need a new GS-9x Multibot.','I need a new GS-9x Multibot.',26124),
(50618,'enUS','%s prepares to unleash The Skullcracker on nearby enemies!','',26124),
(50619,'enUS','','A Twilight Zealot has evolved!',26124),
(50620,'enUS','%s\'s armor shimmers with heat. Strike now!','',26124),
(50621,'enUS','%s prepares to trade places with one of his shadows!','',26124),
(50622,'enUS','Reforging','Reforging',26124),
(50623,'enUS','There is a Highborne archmage visiting the city\'s Enchanting trainer. You can have your items reforged there.','There is a Highborne archmage visiting the city\'s Enchanting trainer. You can have your items reforged there.',26124),
(50624,'enUS','We\'re glad to have your help.','',26124),
(50625,'enUS','I will mark the location upon your map.','I will mark the location upon your map.',26124),
(50626,'enUS','Which one?','Which one?',26124),
(50627,'enUS','The Valley of Strength','The Valley of Strength',26124),
(50628,'enUS','The Valley of Honor','The Valley of Honor',26124),
(50629,'enUS','Neferset City will fall!','',26124),
(50632,'enUS','I need another Slitherblade Charm, Korrah.','I need another Slitherblade Charm, Korrah.',26124),
(50633,'enUS','I need another trident.','I need another trident.',26124),
(50634,'enUS','holds his |Hitem:64383|h|cff0070dd[Kaldorei Wind Chimes]|r|h to the wind.','holds her |Hitem:64383|h|cff0070dd[Kaldorei Wind Chimes]|r|h to the wind.',26124),
(50635,'enUS','lifts his |Hitem:64383|h|cff0070dd[Kaldorei Wind Chimes]|r|h into the rain.','lifts her |Hitem:64383|h|cff0070dd[Kaldorei Wind Chimes]|r|h into the rain.',26124),
(50636,'enUS','lifts his |Hitem:64383|h|cff0070dd[Kaldorei Wind Chimes]|r|h into the snow.','lifts her |Hitem:64383|h|cff0070dd[Kaldorei Wind Chimes]|r|h into the snow.',26124),
(50637,'enUS','%s is ready to be fed.','',26124),
(50638,'enUS','Augh appears from the distance!','',26124),
(50639,'enUS','This chest must have been resting here for millennia.','',26124),
(50640,'enUS','Examine the chest.','Examine the chest.',26124),
(50641,'enUS','You must return to eastern Uldum or the Fusion Core will deactivate!','',26124),
(50642,'enUS','I\'m ready to face Shadra!','I\'m ready to face Shadra!',26124),
(50643,'enUS','%s weakens! Capture it with your harness!','%s weakens! Capture it with your harness!',26124),
(50644,'enUS','I can\'t believe they\'ve keep me waiting this long!','I can\'t believe they\'ve keep me waiting this long!',26124),
(50645,'enUS','I just need to get into the city. Why should that be so difficult?','I just need to get into the city. Why should that be so difficult?',26124),
(50646,'enUS','What\'s going on, anyway? They haven\'t told us anything and I\'m starting to get angry!','What\'s going on, anyway? They haven\'t told us anything and I\'m starting to get angry!',26124),
(50647,'enUS','I need to search you.','I need to search you.',26124),
(50648,'enUS','I am... weary. You must carry on without me. I shall take my leave once my strength has returned.','',26124),
(50649,'enUS','Take curse away!','',26124),
(50650,'enUS','','When we returned from Deepholm, we found that the Twilight\'s Hammer had established a base here and taken control of the elemental portals.$B$BPlease, $n, you must stop them before Cho\'gall can complete whatever it is that he\'s up to inside the Bastion of Twilight!',26124),
(50651,'enUS','You must return to the Duskmist Shore!','',26124),
(50652,'enUS','Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.','Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.',26124),
(50653,'enUS','Greetings.  Have you come to master matters magical?','Greetings.  Have you come to master matters magical?',26124),
(50654,'enUS','Kill Aeonaxx before his whelps overwhelm you!','Kill Aeonaxx before his whelps overwhelm you!',26124),
(50655,'enUS','The sun has set on this mortal world, fools. Make peace with your end, for the hour of Twilight falls.','',26124),
(50656,'enUS','I require more of the Secret Signal Powder, Kadrak.','I require more of the Secret Signal Powder, Kadrak.',26124),
(50661,'enUS','Grim Campfire','Grim Campfire',26124),
(50662,'enUS','Landro\'s Lil\' XT','Landro\'s Lil\' XT',26124),
(50663,'enUS','Mottled Drake','Mottled Drake',26124),
(50664,'enUS','Worldbreaker','Worldbreaker',26124),
(50665,'enUS','%s is no longer protected by the beacons!','',26124),
(50666,'enUS','|TInterface\\Icons\\spell_nature_earthquake.blp:20|tGeneral Umbriss begins to cast |cFFFF0000|Hspell:74634|h[Ground Siege]|h|r!','',26124),
(50667,'enUS','Take this enchanted shard, $n. I will be able to hear the dwarves myself through its twin.','',26124),
(50669,'enUS','Wretched gnat... none but us may command the silithid!','',26124),
(50670,'enUS','casually tosses his |Hitem:63269|h|cFFFFFFFF[Loaded Gnomish Dice]|r|h.','casually tosses her |Hitem:63269|h|cFFFFFFFF[Loaded Gnomish Dice]|r|h.',26124),
(50671,'enUS','Release me from this torment!','',26124),
(50672,'enUS','Have I not paid enough yet for my sins?','',26124),
(50673,'enUS','I only did it for my clan!','',26124),
(50674,'enUS','Who are you to judge me?','',26124),
(50675,'enUS','I must warn... Hive\'Ashi...','',26124),
(50676,'enUS','Champions, hold on while I fly you back to Khardros\' Anvil!','',26124),
(50677,'enUS','Would you like the portcullis opened?','',26124),
(50678,'enUS','Open it.','Open it.',26124),
(50679,'enUS','Hear me, minions of Twilight. (Hear! Hear and obey!)','',26124),
(50680,'enUS','The foolish weaklings of the Alliance and Horde make their way to the Twilight Highlands as we speak. (FOOLS! Blind and weak and tasty...)','',26124),
(50681,'enUS','Do not forget your task here! Continue the rituals while the meddlesome heroes of the world turn a blind eye to this desolate wasteland.','',26124),
(50682,'enUS','Every sacrifice brings more of the master\'s heralds into this world. (The hives sing of madness, of chaos!)','',26124),
(50683,'enUS','Bring the sacrifices to the master\'s flesh and blood within the other hives. (They hunger...)','',26124),
(50684,'enUS','The end of all approaches. The unmaking is at hand. (End of all! The curtain falls!) Do not fail me.','',26124),
(50685,'enUS','Ohh, my head...','Ohh, my head...',26124),
(50686,'enUS','Where am I? Are we underground?','Where am I? Are we underground?',26124),
(50687,'enUS','I wasn\'t even shackled... but I don\'t think I was asleep...','I wasn\'t even shackled... but I don\'t think I was asleep...',26124),
(50688,'enUS','A moment... just give me a moment.','A moment... just give me a moment.',26124),
(50689,'enUS','Champions, hold on while I fly you back to the Scarred Terrace!','',26124),
(50690,'enUS','Go away! You shouldn\'t be here!','',26124),
(50691,'enUS','Can you take me to the Great Hall?','Can you take me to the Great Hall?',26124),
(50692,'enUS','Can you take me to the Chapel?','Can you take me to the Chapel?',26124),
(50693,'enUS','Can you take me to the Ramparts?','Can you take me to the Ramparts?',26124),
(50694,'enUS','Can you take me to the Laboratory?','Can you take me to the Laboratory?',26124),
(50695,'enUS','Weary of one of your demonic charges? Hoping for one with a more pleasing name?\n\nFor a price, I can assist you in the obliteration of a current minion so that you may summon an entirely new one...','Weary of one of your demonic charges? Hoping for one with a more pleasing name?\n\nFor a price, I can assist you in the obliteration of a current minion so that you may summon an entirely new one...',26124),
(50696,'enUS','Abandon Imp','Abandon Imp',26124),
(50697,'enUS','Abandon Voidwalker','Abandon Voidwalker',26124),
(50698,'enUS','Abandon Succubus','Abandon Succubus',26124),
(50699,'enUS','Abandon Felhunter','Abandon Felhunter',26124),
(50700,'enUS','Abandon Felguard','Abandon Felguard',26124),
(50701,'enUS','Are you sure you want to pay to abandon your minion?','Are you sure you want to pay to abandon your minion?',26124),
(50702,'enUS','Avoid the Twilight Guards while gathering the intelligence!','',26124),
(50703,'enUS','Get back to the ship!','Get back to the ship!',26124),
(50704,'enUS','Heya, $g champ : lady;. What\'s shakin\'?','',26124),
(50705,'enUS','Heya, Ace. Remember when we were shipwrecked on the Lost Isles?','Heya, Ace. Remember when we were shipwrecked on the Lost Isles?',26124),
(50706,'enUS','','You didn\'t honestly think I would only plant ONE set of explosives, did you?',26124),
(50707,'enUS','Hello, sucker!','',26124),
(50708,'enUS','Fine, slap the manacles on. But know this, Gallywix, you\'ll get yours!','Fine, slap the manacles on. But know this, Gallywix, you\'ll get yours!',26124),
(50710,'enUS','This is it, $n!  This is where we make our stand!','',26124),
(50711,'enUS','','After all we\'ve been through, we Gilneans have not given up hope.',26124),
(50712,'enUS','I don\'t remember much about how I got to Duskhaven.  Tell me what you know.','I don\'t remember much about how I got to Duskhaven.  Tell me what you know.',26124),
(50713,'enUS','|TInterface\\Icons\\spell_fire_totemofwrath.blp:20|t Foe Reaper 5000 |cFFFF0000|Hspell:88522|h[Safety Restrictions are Off-line]|h|r!','',26124),
(50714,'enUS','Spawn Nefarian please!','Spawn Nefarian please!',26124),
(50715,'enUS','This teleportation device appears to have been used recently to teleport various goods deeper into the mine.','This teleportation device appears to have been used recently to teleport various goods deeper into the mine.',26124),
(50716,'enUS','Press the button labeled \'Wood and Lumber.\'','Press the button labeled \'Wood and Lumber.\'',26124),
(50717,'enUS','Press the button labeled \'Metal and Scraps.\'','Press the button labeled \'Metal and Scraps.\'',26124),
(50718,'enUS','Press the button labeled \'Ship Parts.\'','Press the button labeled \'Ship Parts.\'',26124),
(50720,'enUS','%s is revived by the molten energy of the boiling magma!','',26124),
(50721,'enUS','Greetings, $c.','',26124),
(50722,'enUS','Ouch, my head...what day is it?','',26124),
(50723,'enUS','Where\'s that bright light coming from? Ahhhh, get it away from me!','',26124),
(50724,'enUS','He said he had candy...','',26124),
(50725,'enUS','','The barrier protecting the Pulsing Twilight Eggs dissipates as Sinestra harnesses their power!',26124),
(50726,'enUS','|TInterface\\Icons\\ability_whirlwind.blp:10|t OMG I\'m casting |cFFFF0000|Hspell:88481|h[Overdrive]|h|r!','',26124),
(50727,'enUS','OMG I\'m casting |TInterface\\Icons\\ability_whirlwind.blp:10|t|cFFFF0000|Hspell:88481|h[Overdrive]|h|r that\'s crazy!','',26124),
(50728,'enUS','Did you hear?  |TInterface\\Icons\\ability_whirlwind.blp:10|t OMG I\'m casting |cFFFF0000|Hspell:88481|h[Overdrive]|h|r!  That\'s Crazy!','',26124),
(50729,'enUS','$n, thank goodness you\'re here!','',26124),
(50730,'enUS','Thank goodness, you look like a capable $c with some brains.','',26124),
(50731,'enUS','Yayyyy!','',26124),
(50732,'enUS','But dis place be OURS! Dis be da land of de ogres and da trolls!','',26124),
(50733,'enUS','Da humans and da green skins took dis land, our ancestor\'s land.','',26124),
(50734,'enUS','Boulderfist strong. Witherbark strong. Together we smash enemies!  Roaaarrrr!','',26124),
(50737,'enUS','','This isn\'t over, $n.  Not by a long shot.',26124),
(50738,'enUS','I am ready for the Mind Vision ritual, Thaalia.','I am ready for the Mind Vision ritual, Thaalia.',26124),
(50739,'enUS','I am ready for the Mind Control ritual, Thaalia.','I am ready for the Mind Control ritual, Thaalia.',26124),
(50740,'enUS','Haleh, I have lost the Bluescale Sigil. Could you fashion another?','Haleh, I have lost the Bluescale Sigil. Could you fashion another?',26124),
(50741,'enUS','You seek the newly-arrived Highborne? So be it.\n\nYou\'ll find them in the western wing of the Temple of the Moon. There may be one of them at the Howling Oak, as well.','You seek the newly-arrived Highborne? So be it.\n\nYou\'ll find them in the western wing of the Temple of the Moon. There may be one of them at the Howling Oak, as well.',26124),
(50742,'enUS','Umm... Pebblebitty... the gate is open.','Umm... Pebblebitty... the gate is open.',26124),
(50743,'enUS','','Ahh... so it is, so it is.  Carry on then.  Carry on t\'yer death.',26124),
(50744,'enUS','','I don\'t care to hear it, $n. Nope, no way are you going to be let into the Searing Gorge. Impossible. Not going to happen. How many times do I have to tell you - I can\'t let you in! Do you not speak Common? Are you an orc in disguise? N-O. NO!$B$BIf I let you in, then I have to let everybody in. Pretty soon your close friends will want in, then their distant relatives, then their friends, and so on and so forth. The last time that happened... well, we won\'t talk about the last time it happened.$b$bI will NOT open that gate!',26124),
(50746,'enUS','One of the Gilneans, Vitus  Darkwalker, can help you. Find him at the Howling Oak.','One of the Gilneans, Vitus  Darkwalker, can help you. Find him at the Howling Oak.',26124),
(50747,'enUS','','Welcome to the Wickerman Festival, $c!$B$BOn the observance of Hallow\'s End, we burn a Wickerman to represent a cleansing of the self. As the woods sigh and shed their leaves, we too must undergo a catharsis. Fears, sorrows, regrets: by throwing a branch into the blaze, you can relieve yourself of any burden you would not bear into winter.$B$BPlease, grab a branch from the bonfire and join the celebration!',26124),
(50748,'enUS','Can you feel the evil that taints the very ground, $c? It comes from deep down within the Shadow Hold. Unchecked, it will swallow everything in its path.$B$B<The night elf coughs, revealing a bloody wound at his side.>','',26124),
(50749,'enUS','Sons and daughters of Gilneas! Friends and allies old and new! Please, come close!','',26124),
(50750,'enUS','As you know, Hallow\'s End is a celebration of transition... of change.','',26124),
(50751,'enUS','Only the most valiant and honorable amongst the tribe can earn the honor of being laid to rest at Red Rocks.','',26124),
(50752,'enUS','However, this is a time of neither mourning nor grief.','',26124),
(50753,'enUS','New struggles await us with each dawn, and uncertainty weighs upon us all.','',26124),
(50754,'enUS','Let this wickerman embody any unrest within us.','',26124),
(50755,'enUS','The cub tilts its head and looks at you expectantly. Shouldn\'t you know what to do, $g dad:mom;?','',26124),
(50756,'enUS','Torches ready!','',26124),
(50757,'enUS','Let the flames fly! Hallow\'s End is upon us!','',26124),
(50758,'enUS','Though many flames are fought over, extinguished and re-lit, all are welcome to show honor to the flame, $c.$b$bHere among the Earthen Ring, we simply honor the flame, rather than engage in other frivolities.$b$bHere, we will honor the flame as tradition dictates.  Will you join with us in honoring the flame, $n?','Though many flames are fought over, extinguished and re-lit, all are welcome to show honor to the flame, $c.$b$bHere among the Earthen Ring, we simply honor the flame, rather than engage in other frivolities.$b$bHere, we will honor the flame as tradition dictates.  Will you join with us in honoring the flame, $n?',26124),
(50759,'enUS','So I uh, lost my Fireliminator X-21. Can I get a new one?','So I uh, lost my Fireliminator X-21. Can I get a new one?',26124),
(50760,'enUS','','The cartel has a name for people like you, $n. \"Fiscal Liability.\"',26124),
(50761,'enUS','You\'ve reached an Earthen Ring bonfire!','',26124),
(50762,'enUS','Honor the Earthen Ring bonfire!','Honor the Earthen Ring bonfire!',26124),
(50763,'enUS','','The Wickerman festivities will begin in ten minutes! Please join us just outside the gates of Stormwind City and celebrate Hallow\'s End!',26124),
(50764,'enUS','One of those blasted Jaedenar demons saw me! Gave me a good slash in the side. The wound isn\'t pretty, but I\'ll live.$B$BThere are more urgent matters at hand, like stopping the Shadow Council from launching a full-scale attack on our friends at Wildheart Point. I\'m in no shape to fight, so you\'ll have to go in my place.','',26124),
(50765,'enUS','The people of Gilneas understand the gravity of change all too well.','',26124),
(50766,'enUS','%s pounces on the snow-covered hare burrow.','',26124),
(50767,'enUS','%s is at half health!','',26124),
(50768,'enUS','%s is nearly defeated!','',26124),
(50769,'enUS','','She\'s coming! Quiet down, you fools! The Dark Lady approaches...',26124),
(50770,'enUS','Oh great, thanks. That looks...um...delicious.','Oh great, thanks. That looks...um...delicious.',26124),
(50771,'enUS','I heard that Gott Weedlespan fired his last assistant...by pushing him off a cliff! Best not to get on his bad side.','I heard that Gott Weedlespan fired his last assistant...by pushing him off a cliff! Best not to get on his bad side.',26124),
(50772,'enUS','The Assistant Resort Director doesn\'t like to see us taking breaks. We don\'t like to see him, either.','The Assistant Resort Director doesn\'t like to see us taking breaks. We don\'t like to see him, either.',26124),
(50773,'enUS','Oh goody! I haven\'t had a break since the day before yesterday!','Oh goody! I haven\'t had a break since the day before yesterday!',26124),
(50774,'enUS','I want to go home and see my family, but Gott won\'t let us off this mountain!','I want to go home and see my family, but Gott won\'t let us off this mountain!',26124),
(50775,'enUS','Food? What about my last paycheck? Did you bring that too?','Food? What about my last paycheck? Did you bring that too?',26124),
(50776,'enUS','Heehee! You can\'t catch me!','Heehee! You can\'t catch me!',26124),
(50777,'enUS','Ooooh, a $c! Try to catch me, slowpoke!','Ooooh, a $c! Try to catch me, slowpoke!',26124),
(50778,'enUS','I can run fast! Daddy let me get a speed enchant on my shoes!','I can run fast! Daddy let me get a speed enchant on my shoes!',26124),
(50779,'enUS','Weeeeeeeeeeeeeeeeeeeeeeeee!','\nWeeeeeeeeeeeeeeeeeeeeeeeee!',26124),
(50780,'enUS','Am I fast? I wanna be a $c like you!','Am I fast? I wanna be a $c like you!\n',26124),
(50781,'enUS','Awww, we were just playing!','Awww, we were just playing!',26124),
(50782,'enUS','Guess I need to run faster next time.','Guess I need to run faster next time.',26124),
(50783,'enUS','I don\'t wanna go inside! It was fun out here!','I don\'t wanna go inside! It was fun out here!',26124),
(50784,'enUS','Where are you taking us? Are we there yet?','Where are you taking us? Are we there yet?\n',26124),
(50786,'enUS','Me will mark where on your map.','Me will mark where on your map.',26124),
(50787,'enUS','','Now, we burn this wickerman as a symbol of our victory against old enemies!',26124),
(50788,'enUS','','We are the instruments of an unyielding ire...',26124),
(50789,'enUS','%s looks towards the cave entrance, but A-Me 01 is nowhere to be seen.','',26124),
(50790,'enUS','%s is having trouble sleeping.','',26124),
(50791,'enUS','Help! I can\'t swim!','Help! I can\'t swim!',26124),
(50792,'enUS','Over here, $c! Help me!','Over here, $c! Help me!',26124),
(50793,'enUS','','Hallow\'s End is upon us, $c.  I hope you are enjoying the festivities.',26124),
(50794,'enUS','I\'m ready to fly, let\'s bomb the Undercity!','I\'m ready to fly, let\'s bomb the Undercity!',26124),
(50797,'enUS','Ugh, what is this swill? It tastes like wet dog fur!','Ugh, what is this swill?  It tastes like wet dog fur!',26124),
(50798,'enUS','Who in their right mind would want to drink THIS? Blecchhhh!','Who in their right mind would want to drink THIS? Blecchhhh!',26124),
(50799,'enUS','Have I seen anything suspicious? The only suspicious things around here are the outrageous prices.','Have I seen anything suspicious? The only suspicious things around here are the outrageous prices.',26124),
(50800,'enUS','I haven\'t seen a thing. Now stop bothering me about Twilight\'s Hammer and let me get back to my tan.','I haven\'t seen a thing. Now stop bothering me about Twilight\'s Hammer and let me get back to my tan.',26124),
(50801,'enUS','I might have seen someone in a Twilight\'s Hammer robe. They were very tall. I\'m sure of it.','I might have seen someone in a Twilight\'s Hammer robe. They were very tall. I\'m sure of it.\n',26124),
(50802,'enUS','I saw someone setting one of those fire totems. It was dark, but I remember they were wearing red.','I saw someone setting one of those fire totems. It was dark, but I remember they were wearing red.',26124),
(50803,'enUS','Suspicious activity? Assistant Director Weedlespan doesn\'t want anyone going to the north side of the lake. Weird, don\'t you think?','Suspicious activity? Assistant Director Weedlespan doesn\'t want anyone going to the north side of the lake. Weird, don\'t you think?\n',26124),
(50804,'enUS','Yes, I overheard someone talking about Twilight\'s Hammer at the party last night. I didn\'t see them, but they were extremely rude.','Yes, I overheard someone talking about Twilight\'s Hammer at the party last night. I didn\'t see them, but they were extremely rude.\n',26124),
(50805,'enUS','Accuse','Accuse',26124),
(50806,'enUS','Greetings! Wonderful day, isn\'t it?','Greetings! Wonderful day, isn\'t it?',26124),
(50807,'enUS','How dare you accuse me of being a Twilight Cultist! Do I look crazy to you?','How dare you accuse me of being a Twilight Cultist! Do I look crazy to you?',26124),
(50808,'enUS','<Gott sneers contemptuously at you.>$B$BCan you possibly work any slower? I\'m surrounded by useless idiots!','',26124),
(50809,'enUS','Hey. Have we met before?','Hey. Have we met before?',26124),
(50810,'enUS','If ye want me advice, don\'t go strugglin\' tae much. Ye\'ll just encourage them.','',26124),
(50811,'enUS','If ye climb up another notch, I\'ll share me brew with ye!','',26124),
(50812,'enUS','Nae, I\'m enjoying me fine some Ironforge mead. Might be the last drink we have for a while yet.','',26124),
(50813,'enUS','And who forgot tae grab the ale on the way up? Not me! Hahahaha!','',26124),
(50814,'enUS','Stop drinking tha last o\' our ale and help me off this blasted branch!','',26124),
(50815,'enUS','Mebbe someone will come around and get us out of this mess!','',26124),
(50816,'enUS','I told ye not tae leave the boar ribs out! Why couldna yae had a proper stomach and eaten yer dinner like the rest o\' us Buckeys?','',26124),
(50817,'enUS','Come any closer ya wee bear and I\'ll punch ya in the face!','',26124),
(50818,'enUS','Wow! A haunted lighthouse with a pirate captain\'s ghost and everything! D\'you think he\'ll tell us where the treasure is buried?','',26124),
(50819,'enUS','Holy Light! Look what happened to the dam! The other orphans aren\'t gonna believe this!','',26124),
(50820,'enUS','Wow, the big bear is still here! Do you think he gets mad when everyone puts their treasure in his tummy? That must hurt...','',26124),
(50821,'enUS','','Welcome to the Menders\' Stead, $c.',26124),
(50822,'enUS','Is Zen\'Kiki available for some more combat practice?','Is Zen\'Kiki available for some more combat practice?',26124),
(50823,'enUS','Do you feel it? It\'s almost like Arthas is still here right in this room! But he\'s gone, right? This place still feels like evil...','',26124),
(50824,'enUS','What\'re ye lookin\' at, ye tuskarr-faced bung?','',26124),
(50825,'enUS','Yarr!','',26124),
(50826,'enUS','Scuttle me skivvies!','',26124),
(50827,'enUS','The tale of ol\' Duncan is a sad one, I\'m afraid.  I used to be captain of me own ship, ye know?$b$bOne more demotion and I\'ll be a swabbie again.  I don\'t think I could take the humiliation.','',26124),
(50828,'enUS','Whatever, Duncan.  Grab a mop and get to work.','Whatever, Duncan.  Grab a mop and get to work.',26124),
(50829,'enUS','Wow, these docks are huge! The ships that dock here must be as big as zeppelins! Is this the same ocean I can see from Orgrimmar?','',26124),
(50830,'enUS','I can see those dirty night elves from here! When I grow up, I want to fight for the warchief just like these warriors!','',26124),
(50831,'enUS','Will you pay \"Pretty Boy\" Duncan 1 gold to swab the decks for you?','Will you pay \"Pretty Boy\" Duncan 1 gold to swab the decks for you?',26124),
(50832,'enUS','Having some trouble there, sailor?  Need some help?','',26124),
(50833,'enUS','This is humiliating.','',26124),
(50834,'enUS','I can\'t believe it\'s come to this.','',26124),
(50835,'enUS','A mop?  Really?','',26124),
(50836,'enUS','I suppose sometimes y\'need to hit rock bottom before y\'can crawl yer way back up.','',26124),
(50837,'enUS','Maybe I need a new nickname.','',26124),
(50838,'enUS','Warchief, you are a hero to my young ward. Would you mind signing an autograph for him?','Warchief, you are a hero to my young ward. Would you mind signing an autograph for him?',26124),
(50839,'enUS','Of course, $c. What is the young warrior\'s name?$B$BI wish more of our people shared your concern for the orphans of Orgrimmar.','',26124),
(50840,'enUS','While I miss Gilneas greatly, there\'s ancient ruins to explore!','While I miss Gilneas greatly, there\'s ancient ruins to explore!',26124),
(50841,'enUS','Tadpoles!  Tadpoles is the winner!','',26124),
(50842,'enUS','Hi!  You there!  Does it smell green to you?','',26124),
(50843,'enUS','The score is fourty-six to fifty-two!','',26124),
(50844,'enUS','Hand me the wizzlesproket, you dwarf-brained son of a human!  No, not that one, the other one!','',26124),
(50845,'enUS','I was head editor of the Tinker Town Tattler!','',26124),
(50846,'enUS','There is NOTHING random about what I say!  Nothing!','',26124),
(50847,'enUS','The darkness beneath Tirisfal will consume us all...','',26124),
(50848,'enUS','SLUDGE SAYS DRINK!','',26124),
(50849,'enUS','I want to learn about Archaeology.','I want to learn about Archaeology.',26124),
(50850,'enUS','A treasure hunter\'s life is a treacherous one. Don\'t be foolin\' yerself.','',26124),
(50851,'enUS','Multiple vapors appear from the fog!  Kill Admiral Ripsnarl before you are overwhelmed!','',26124),
(50852,'enUS','Hostile forces detected.  Defense mode activated.','',26124),
(50853,'enUS','Beetle','Beetle',26124),
(50854,'enUS','Dog','Dog',26124),
(50855,'enUS','Fox','Fox',26124),
(50856,'enUS','Monkey','Monkey',26124),
(50857,'enUS','Shale Spider','Shale Spider',26124),
(50858,'enUS','Our brothers at Baradin Hold on Tol Barad are very busy and not always available when you need them.  I have been stationed here around the clock to help you with tasks they might have given you.','Our brothers at Baradin Hold on Tol Barad are very busy and not always available when you need them.  I have been stationed here around the clock to help you with tasks they might have given you.',26124),
(50860,'enUS','You no belong here!','You no belong here!',26124),
(50861,'enUS','You break and enter?! Me break YOU!','You break and enter?! Me break YOU!',26124),
(50862,'enUS','You not allowed here!','You not allowed here!',26124),
(50863,'enUS','Ozumat is vulnerable, strike now!','Ozumat is vulnerable, strike now!',26124),
(50864,'enUS','Cowards!  I will not fall so easily into your trap!','',26124),
(50865,'enUS','You there! Hiding like a coward when you should be fighting these devils?','',26124),
(50866,'enUS','Quit running and DO SOMETHING!','',26124),
(50867,'enUS','Feckless cowards, the lot of you! Maybe if you\'d show some backbone, I would actually pay your wages!','',26124),
(50868,'enUS','Idiots! Dolts! Morons! Imbeciles! Fools! Dimwits! Ignoramuses! Shall I go on?','',26124),
(50869,'enUS','Maybe someone should go fetch some water. A person with a brain would have done that already!','',26124),
(50870,'enUS','You nincompoops! This place deserves to burn.','',26124),
(50871,'enUS','Nightmare spiders appear in the darkness!  Kill Helix before his nightmare overwhelms you!','',26124),
(50874,'enUS','You\'ve impressed me so far, $n. How do you feel about helping me in creating the ultimate dish?','',26124),
(50875,'enUS','|TInterface\\Icons\\spell_nature_cyclone.blp:20|t%s begins to cast|cFFFF9A20|Hspell:86193|h [Wind Blast]!|r','',26124),
(50876,'enUS','%s begins to resurrect a |cFF3366CCZanzili Berserker|r!','%s begins to resurrect a |cFF3366CCZanzili Berserker|r!',26124),
(50877,'enUS','%s begins to resurrect a swarm of |cFFCC0000Zanzili Zombies|r!','%s begins to resurrect a swarm of |cFFCC0000Zanzili Zombies|r!',26124),
(50878,'enUS','%s fills the area with a |cFF33FF00toxic gas|r!','%s fills the area with a |cFF33FF00toxic gas|r!',26124),
(50879,'enUS','Woooweeee! Look at her run! Just relax and enjoy the view. I\'ll have us across the lake in no time.','',26124),
(50880,'enUS','Enjoying your stay? One dip in the steam pools and you come out looking 10 years younger. Just look at me if you want proof!','',26124),
(50881,'enUS','Have you tried any of Chef Tramsay\'s dishes yet? I really enjoyed his Moth Soup. Delicious!','',26124),
(50882,'enUS','Wait, do you see that light up there? What\'s going on?','',26124),
(50883,'enUS','The...they\'re agents of the Twilight\'s Hammer! Is that...the Assistant Resort Director with them?','',26124),
(50884,'enUS','Oh no! They\'ve spotted us! Hang on -- I\'ll get us out of here!','',26124),
(50885,'enUS','We barely made it out alive. You\'d better run and tell Lasha what you\'ve seen. We\'ve got a serious problem to deal with!','',26124),
(50886,'enUS','I seek other veterans of the campaign here in Northrend. We are urgently needed to face new foes at home.','',26124),
(50887,'enUS','Preparations for Tol Barad will begin in 5 minutes!','',26124),
(50888,'enUS','The Battle for Tol Barad will begin in 2 minutes!','',26124),
(50889,'enUS','The Battle for Tol Barad will begin in 1 minute!','',26124),
(50890,'enUS','','The darkness is closing in!  I will not go without a fight, monster!',26124),
(50892,'enUS','Hi, my name is Kevin, do you want to play a movie ?','Hi, my name is Kevin, do you want to play a movie ?',26124),
(50893,'enUS','I intend to fight the Soulflayer, but I have no way of summoning him.  Can you assist me?','I intend to fight the Soulflayer, but I have no way of summoning him.  Can you assist me?',26124),
(50894,'enUS','Victory in Tol Barad is ours! While the Horde offensive is crippled, we need your immediate efforts to gather resources and secure the island!','',26124),
(50895,'enUS','Victory in Tol Barad is ours! While the Alliance offensive is crippled, we need your immediate efforts to gather resources and secure the island!','',26124),
(50896,'enUS','Greetings, hapless adventurer.  I ask only that you wait a moment...and BLEED!','',26124),
(50897,'enUS','If you\'re looking for a place to rest, I can help.','If you\'re looking for a place to rest, I can help.',26124),
(50898,'enUS','You choose my corpse over another ally against the undead?  So be it.','',26124),
(50899,'enUS','Burn...my corpse...do not let me join them...','',26124),
(50900,'enUS','','Plot revenue minus supply expenditures against the elasticity of demand, considering assets and liabilities inflected across the regression quotient....oh hi! How are you?',26124),
(50901,'enUS','Do you have what it takes to stay in my kitchen?','',26124),
(50902,'enUS','Have you seen the outrageous prices here?','Have you seen the outrageous prices here?',26124),
(50903,'enUS','Could you go get me a drink? I\'d do it myself, but I\'m working on my tan.','Could you go get me a drink? I\'d do it myself, but I\'m working on my tan.',26124),
(50904,'enUS','The Twilight\'s Hammer will rise again! The very earth beneath your feet will be swallowed by the fury of our resurgence!','',26124),
(50905,'enUS','Ah ken see very well through this haze, but I\'d know tha\' smell anywhere!  Die ye foul ogre!','',26124),
(50906,'enUS','Ooooooooh...','',26124),
(50907,'enUS','To the plaguelands went old Duggan, ta\' send them Scourge back inta\' th\' groun\'.','',26124),
(50908,'enUS','Where th\' scent of death is on th\' wind and everythin\' is mostly brown.','',26124),
(50909,'enUS','An\' when he did arrive there, what\'d his dwarf eyes see?','',26124),
(50910,'enUS','A hundred crates of barley there ta\' be makin\' inta\' mead!','',26124),
(50911,'enUS','But tha\' mead was cursed with th\' plague o\' death, and now old Duggan, too.','',26124),
(50912,'enUS','An\' surrounded by the Lich King\'s beasts, what could old Duggan do?','',26124),
(50913,'enUS','But though I feel the plague within, my hopes \'ave not yet sunk.','',26124),
(50914,'enUS','If\'n I\'m gonna be Scourge anyway, I might as well be drunk!','',26124),
(50915,'enUS','This teleporter will transport you to Grom\'gol in Northern Stranglethorn.$B$BUsually.$B$BI mean, sometimes it\'ll just disintegrate you, or reduce all your soft tissues into a greenish, foul-smelling mist, but mostly it\'s safe!$B$B...mostly.','',26124),
(50916,'enUS','This teleporter will transport you to the irradiated ruins of Gnomeregan, deep beneath Dun Morogh.$B$BDon\'t worry, there\'s another one there that\'ll send you back here... well, if it doesn\'t turn you inside-out or transmogrify your organs into unstable organic explosives, that is!$B$BWell? What are you waiting for? Hop on in!','',26124),
(50917,'enUS','Finally out from under the boot of that she-witch Abbendis, and free to pursue my own interests: BLOOD, BLOOD, AND MORE BLOOD!','Finally out from under the boot of that she-witch Abbendis, and free to pursue my own interests: BLOOD, BLOOD, AND MORE BLOOD!',26124),
(50918,'enUS','I haven\'t eaten in weeks; this bread is mine!  FOR THE SANDWICH!','',26124),
(50919,'enUS','I judge you...DELICIOUS!','',26124),
(50920,'enUS','Abbendis will return, and I will be waiting for her!  SHE WILL COME BACK FOR US!','Abbendis will return, and I will be waiting for her!  SHE WILL COME BACK FOR US!',26124),
(50921,'enUS','','I will drive your foul stench from the forest, monster!',26124),
(50923,'enUS','Welcome to de great show, friends. Just wait \'til ya see what I got in store for ya.','',26124),
(50924,'enUS','No... NOOOO!!!','',26124),
(50925,'enUS','Ain\'t NO ONE gonna stop Jin\'do!','',26124),
(50927,'enUS','Grass, sand, and sludge mix together to form the vague resemblance of a footprint.','',26124),
(50928,'enUS','The tracks are smeared, almost as if the creature drags its feet.','',26124),
(50929,'enUS','Mixed in with the mud are traces of oily sludge from the nearby rig.','',26124),
(50930,'enUS','This trail is bloody. You follow it to a nearby bush, where you find the remains of the creature\'s last meal.','',26124),
(50931,'enUS','These tracks are fresh, and they lead down into the water...','',26124),
(50933,'enUS','','Did Brak say this teleporter thing was tested? Well, if you\'re ready to go back to Nozzlepot\'s Outpost, just say the word! I hope you get there in one piece.',26124),
(50934,'enUS','','Did you see that? Someone just fell out of the sky!',26124),
(50935,'enUS','Send me back to Nozzlepot\'s Outpost.','Send me back to Nozzlepot\'s Outpost.',26124),
(50936,'enUS','Wow, this sure goes fast!','',26124),
(50937,'enUS','You disssssturb the plans of Gurubashi, little one.  It\'sss too late for you.  Too late for all of you!','',26124),
(50938,'enUS','','Haaa ha ha haa!  Now, heathens... face the TRUE might of Bethekk!',26124),
(50939,'enUS','','What have you done? I can\'t... control... RRAAAARRRGHHH!',26124),
(50940,'enUS','I\'m ready. Let\'s go!','I\'m ready. Let\'s go!',26124),
(50941,'enUS','$n, glad to see you\'re still in one piece! I saw a rocket fly by earlier and heard your voice screaming, so I was a bit worried.$B$BWe have one last shipment to take care of. Talk to me when you\'re ready and we\'ll get going.','',26124),
(50942,'enUS','Everybody on board! This caravan\'s leaving for the Mor\'shan Rampart!','',26124),
(50943,'enUS','How are you doing back there? Not too bumpy I hope.','',26124),
(50944,'enUS','Our enemies wouldn\'t dare attack us this close to the Crossroads. It\'s further out that we\'ll have to watch our backs.','',26124),
(50945,'enUS','Hope you don\'t mind, but we\'ll stop at Dreadmist Camp to pick up additional supplies and fresh mounts for the last leg of the journey.','',26124),
(50949,'enUS','','How can Bwemba aid ya?',26124),
(50950,'enUS','Yesss...ssssuccumb to the venom...','',26124),
(50951,'enUS','I need your help to remove the poison from these adventurers.','I need your help to remove the poison from these adventurers.',26124),
(50952,'enUS','You seek power, yes? But will you walk the cursed path I do for it?','You seek power, yes? But will you walk the cursed path I do for it?',26124),
(50953,'enUS','My path is a dark and cursed one, $c. You do not wish to walk with me.','My path is a dark and cursed one, $c. You do not wish to walk with me.',26124),
(50954,'enUS','We\'re here. Just wait a moment while we load up---HEY! What\'s happening!?','',26124),
(50955,'enUS','','Quickly now! Grab one of them while I take the supply cart!',26124),
(50956,'enUS','Guild Services','Guild Services',26124),
(50957,'enUS','You may find Shattrath\'s guild master - as well as guild and tabard vendors - within the Terrace of Light\'s central structure, in the middle of the city.','You may find Shattrath\'s guild master - as well as guild and tabard vendors - within the Terrace of Light\'s central structure, in the middle of the city.',26124),
(50958,'enUS','Thank you for your help.','Thank you for your help.',26124),
(50959,'enUS','Class trainers may be found in the various ground-floor wings of the Terrace of Light\'s central structure.$B$BAldor, Scryer or otherwise, someone will be able to help you.','Class trainers may be found in the various ground-floor wings of the Terrace of Light\'s central structure.$B$BAldor, Scryer or otherwise, someone will be able to help you.',26124),
(50960,'enUS','You saved my life!','You saved my life!',26124),
(50961,'enUS','Another troll?  At least you aren\'t a serpent...','Another troll?  At least you aren\'t a serpent...',26124),
(50962,'enUS','The serpents, they are everywhere!','The serpents, they are everywhere!',26124),
(50963,'enUS','The serpents overwhelmed us.','The serpents overwhelmed us.',26124),
(50964,'enUS','I thought I was going to die in this awful jungle.','I thought I was going to die in this awful jungle.',26124),
(50965,'enUS','I had just about given up hope.','I had just about given up hope.',26124),
(50966,'enUS','Thank you for saving my life.','Thank you for saving my life.',26124),
(50967,'enUS','<The Arcane Guardian gestures towards the city\'s center.>','',26124),
(50968,'enUS','Ho, Nagala! How about some lunch for your starving brother?','',26124),
(50969,'enUS','','You\'ve grown a few inches around the waist, little brother! Come down here and give your sister a hug!',26124),
(50970,'enUS','Which one should I take?','',26124),
(50971,'enUS','','Balgor! No!',26124),
(50972,'enUS','Attack the nightmare illusions and defend your sleeping allies!','Attack the nightmare illusions and defend your sleeping allies!',26124),
(50973,'enUS','','Bwemba be watchin\' you, young one.',26124),
(50974,'enUS','Now, have a taste of Jin\'do\'s true powah!','',26124),
(50975,'enUS','','The fat one! He\'ll make for a nice sacrifice.',26124),
(50976,'enUS','The Burning Blade sends its greetings.','',26124),
(50977,'enUS','Look, someone\'s attacking Sentinel Hill. C\'mon guards, you just hafta win!','',26124),
(50978,'enUS','I\'ve never seen a flying tree before. Let\'s get closer!','',26124),
(50979,'enUS','That looks fun! I wanna drive, but the orphan matron says I can\'t get a mount \'til I\'m older.','',26124),
(50980,'enUS','Look at all that slime. One is flying straight at me!','',26124),
(50981,'enUS','Eeeeeeeeeeeeeeew, it\'s on my head! Help!','',26124),
(50982,'enUS','%s is about to blast you with lightning! Get away!','%s is about to blast you with lightning! Get away!',26124),
(50983,'enUS','My tummy doesn\'t feel so good...','',26124),
(50984,'enUS','Whoa! Did you see how high we went?','',26124),
(50985,'enUS','That was great! Let\'s do it again!','',26124),
(50986,'enUS','You disssssturb the plans of Gurubashi, little one.  It\'sss too late for you.  Too late for all of you!','',26124),
(50987,'enUS','My ssssserpents, dey already ssssslither beneath every rock an\' shrub of Ssssstranglethorn.','',26124),
(50988,'enUS','We will reclaim thisss land. Gurubashi land.  An\' we kill anyone dat getssss in our way!','',26124),
(50989,'enUS','We reclaiming our land, Gurubashi land.  An\' we gonna kill anyone dat get in our way.','',26124),
(50990,'enUS','Go an\' get dem, Ohgan! We WON\'T be fooled again!','',26124),
(50991,'enUS','Shaman...? A troll mystic of some sort has come to the city recently to visit Harene upon the Walk of Elders. She might be able to help you.','Shaman...? A troll mystic of some sort has come to the city recently to visit Harene upon the Walk of Elders. She might be able to help you.',26124),
(50992,'enUS','I thought the Park fell into a big hole, but this one\'s way bigger and it has a whirlwind!','',26124),
(50993,'enUS','They\'re planning to sacrifice me! Their demons are already licking their chops over my corpse.$B$B<Balgor shudders.>$B$BMakes me think twice about my own diet.$B$B Anyway, they\'ve got a guard watching my every move. I can get myself out of here, but I need a good distraction.','',26124),
(50994,'enUS','','What!? The Burning Blade kidnapped my brother?',26124),
(50995,'enUS','','All the supplies flowing north to Ashenvale stop here to rest and re-fuel. It\'s important to keep our operations running smoothly.',26124),
(50996,'enUS','I\'m ready to ride.','I\'m ready to ride.',26124),
(50997,'enUS','There is a pair of tauren visiting the city. I\'m told they\'ve come from Mulgore to learn more about the Forsaken \"condition,\" or something to that effect.$B$BSeek them out near the herbalist by the Apothecarium.','There is a pair of tauren visiting the city. I\'m told they\'ve come from Mulgore to learn more about the Forsaken \"condition,\" or something to that effect.$B$BSeek them out near the herbalist by the Apothecarium.',26124),
(50998,'enUS','|TInterface\\Icons\\ability_heroicleap.blp:20|t%s begins to cast |cFFFF0000|Hspell:96740|h[Devastating Slam]|h|r!','',26124),
(50999,'enUS','This has to be the biggest diamond ever!','',26124),
(51000,'enUS','It looks just like the paintings of King Magni too! Did he really do this to himself?','',26124),
(51001,'enUS','Aye, lad. He tried to use an old titan ritual to keep his people safe, but this is what it did to him.','',26124),
(51002,'enUS','Wow, I don\'t think that was such a good idea...','',26124),
(51003,'enUS','I\'m really sorry you lost your king. But in a way, it\'s like he\'s with you forever!','',26124),
(51004,'enUS','They\'ve spotted us! Defend the caravan!','',26124),
(51005,'enUS','This was my fault, my lord. I should\'ve done more research on those tablets...','',26124),
(51006,'enUS','Thank you, lad.','',26124),
(51007,'enUS','It\'s got me!','',26124),
(51008,'enUS','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.','Welcome, my $g brother : sister;.  If you are here to train, then I would be delighted to train you.',26124),
(51009,'enUS','If you seek training in the Old Ways, I cannot help you.','If you seek training in the Old Ways, I cannot help you.',26124),
(51010,'enUS','There\'s a worgen druid by the name of Dareth just outside the city gates; he might be able to help you.$B$BBig beast of a fellow, covered in white leather and furs. You can\'t miss him.','There\'s a worgen druid by the name of Dareth just outside the city gates; he might be able to help you.$B$BBig beast of a fellow, covered in white leather and furs. You can\'t miss him.',26124),
(51011,'enUS','Wow, you sure don\'t look like any night elf I\'ve seen before!','',26124),
(51012,'enUS','Our orphan matron says druids can turn into birds, cats, and bears, but you look like a combination of all of them!','',26124),
(51013,'enUS','I see what you\'re doing. You\'re gonna take all the druid forms and make them into one super-form!','',26124),
(51014,'enUS','The Emerald Dream doesn\'t sound like a place for me. What if it turns me into a turtle? I\'ve always wanted wings, though...','',26124),
(51015,'enUS','Wheeee! I\'m a bird-boy!','',26124),
(51016,'enUS','No, little one, it\'s nothing like that. My spirit spent many years in the Emerald Dream while my body slept, and it started to take on attributes of our animal forms.','',26124),
(51017,'enUS','Good day! Need some screws tightened or some bolts loosened? You\'ve come to the right place.','',26124),
(51018,'enUS','Huuuuuuuunnnnnngggrryyyy!','',26124),
(51019,'enUS','Meeeee sooooorrryyyy....','',26124),
(51020,'enUS','Wow, wow, wow! I can\'t believe Sputtervalve actually let me drive this baby! Have I mentioned this is my first time flying? Don\'t worry though. I have everything under control.','',26124),
(51021,'enUS','Man, oh man...Just look at that amazing view! Are those LIONS? Oops, almost let go of the steering wheel there.','',26124),
(51022,'enUS','Wait until the guys back home find out about this! This is soooo totally geared out!','',26124),
(51023,'enUS','My dream is to be as brilliant as Sputtervalve someday. You should see his design for a two-wheeled tricycle!','',26124),
(51024,'enUS','Huh? Hold on, the engine stalled...','',26124),
(51025,'enUS','Whoa! What\'s going on?','',26124),
(51026,'enUS','No, no, no...this can\'t be happening. This wasn\'t part of the travel plan!','',26124),
(51027,'enUS','Auuugh! Looks like we\'re taking an unexpected detour! Hold on tight!','',26124),
(51028,'enUS','Maybe if I press this green button. No, what about this blue one? Hold on, let me try resplicing some wires. Ow!','',26124),
(51029,'enUS','Nothing\'s working!','',26124),
(51030,'enUS','Oh no, Sputtervalve is going to kill me! Sigh...You\'d better find your own transportation from here. I have to pick up the pieces and start the long walk back to camp...','',26124),
(51031,'enUS','Well here we are, back at the Crossroads, safe and sound.','',26124),
(51032,'enUS','The mists around the Altar of Hethiss dissipate as Venoxis prepares a powerful spell!','',26124),
(51033,'enUS','|TInterface\\Icons\\ability_creature_poison_06.blp:20|t High Priest Venoxis begins casting |cFFFF0000|Hspell:96637|h[Bloodvenom]|h|r!','',26124),
(51034,'enUS','High Priest Venoxis is exhausted!','',26124),
(51035,'enUS','I can\'t stop it. We\'re in for a crash landing!','',26124),
(51036,'enUS','Inspect the body.','Inspect the body.',26124),
(51037,'enUS','The large cat doesn\'t seem quite as big as the hunter lead you to believe.','The large cat doesn\'t seem quite as big as the hunter lead you to believe.',26124),
(51038,'enUS','Let\'s see what we got here...','',26124),
(51039,'enUS','Hmm...  The beast looks smaller than I would have thought.','',26124),
(51040,'enUS','','Death to your kind!',26124),
(51041,'enUS','','Serena Bloodfeather will rip out your eyes and feast upon your heart!',26124),
(51042,'enUS','','You will pay for my sister\'s death!',26124),
(51043,'enUS','','Our matron craves the taste of your blood!',26124),
(51044,'enUS','','Rexxar\'s ally! Murderer!',26124),
(51045,'enUS','The Argent Crusade stands behind you.','',26124),
(51046,'enUS','Ahoy!','',26124),
(51047,'enUS','Mrfmmmm... mrrr.','',26124),
(51048,'enUS','Heeeeere\'s... Theldurin!','',26124),
(51049,'enUS','Senior Initiate Goldmine, reporting for duty!','',26124),
(51050,'enUS','This is gonna be a bloodbath. A bloodbath... of flames!','',26124),
(51051,'enUS','Fear not. Johnny Awesome fights by your side.','',26124),
(51052,'enUS','','Two knives and a goblin. What more could you ask for?',26124),
(51053,'enUS','Did somebody call for a paladin?','',26124),
(51054,'enUS','Ahoy there, captain.','',26124),
(51055,'enUS','What ho, fellow knights! Are we fully barded and armored? Then let us thrust ourselves deeply into that which they call adventure!','',26124),
(51056,'enUS','You have my sword.','',26124),
(51057,'enUS','Let\'s see what kind of trouble we can get into today.','',26124),
(51058,'enUS','Lok\'tar, hero. Today I fight with you.','',26124),
(51059,'enUS','','My talons will slice you to shreds, invader.',26124),
(51060,'enUS','Hello.','',26124),
(51061,'enUS','Let the slaughter begin.','',26124),
(51062,'enUS','Here come Zen\'Kiki!','',26124),
(51063,'enUS','','Light be with you.',26124),
(51064,'enUS','','The Earthen Ring stands behind you.',26124),
(51065,'enUS','The druids of DEHTA support your efforts here in Hyjal.','',26124),
(51066,'enUS','I heard Azeroth needed saving. May I lend a hand?','',26124),
(51067,'enUS','I prefer my fish boiled AFTER they\'ve been caught. Let\'s put out these fires.','',26124),
(51068,'enUS','Lunk here to help.','',26124),
(51069,'enUS','','Da Darkspear fight alongside ya.',26124),
(51070,'enUS','','Reporting for duty, commander.',26124),
(51071,'enUS','Let me at \'em! I\'ll blast \'em off the side o\' the mountain!','',26124),
(51072,'enUS','Congratulations. Today you will have the honor of fighting alongside me.','',26124),
(51073,'enUS','Fire elementals must die!','',26124),
(51074,'enUS','','Wait a minute... where am I? WHEN am I? Are we in Hyjal?',26124),
(51075,'enUS','Calder Gray, reporting for mayhem... er, duty.','',26124),
(51076,'enUS','Did somebody say Grapplehammer? No? Oh well, here I am.','',26124),
(51077,'enUS','If only Gidwin were here... he\'d love to see this.','',26124),
(51078,'enUS','By Light be purged!','',26124),
(51079,'enUS','Hah! I was expecting a challenge.','',26124),
(51080,'enUS','I\'m fiiiighting!','',26124),
(51081,'enUS','Weee!','',26124),
(51082,'enUS','Bonk! Yes sir!','',26124),
(51083,'enUS','MRRRFFFFMMMMRRR!','',26124),
(51084,'enUS','MRRRFRRRR!','',26124),
(51085,'enUS','mmmmmMMMMMMRRRF!','',26124),
(51086,'enUS','Take that, dangerous enemy!','',26124),
(51087,'enUS','Too bad for you... I brought my fists with me!','',26124),
(51088,'enUS','Look out Ragnaros! You\'re next!','',26124),
(51089,'enUS','I\'ve got a history with fire elementals, you know. I consider myself somewhat of an expert on the subject.','',26124),
(51090,'enUS','Yeesh! These guys are really hot!','',26124),
(51091,'enUS','Maybe after this, they\'ll take away my \"Initiate\" title.','',26124),
(51092,'enUS','Oh, don\'t MAKE me summon my troll-servant.','',26124),
(51093,'enUS','Behold the might that is Gurgthock!','',26124),
(51094,'enUS','You\'re about to enter your own personal arena of pain, jerk!','',26124),
(51095,'enUS','Haha! Yes!','',26124),
(51096,'enUS','Johnny! Awesome!','',26124),
(51097,'enUS','You never stood a chance!','',26124),
(51098,'enUS','','Stabby stabby stab stab!',26124),
(51099,'enUS','','What\'s that? I can\'t hear you with my KNIFE IN YOUR FACE!',26124),
(51100,'enUS','','Oh yeah. Slinky\'s going to cut you.',26124),
(51101,'enUS','Nobody told me how big these guys were going to be.','',26124),
(51102,'enUS','Take that, ye stinkin\' fire-donkey!','',26124),
(51103,'enUS','For the Crusade! Hyaaah!','',26124),
(51104,'enUS','I\'ve always wanted my very own dragon!','',26124),
(51105,'enUS','Come and get your pain!','',26124),
(51106,'enUS','I am... a tauren... of the SEA!','',26124),
(51107,'enUS','Yarrr!','',26124),
(51108,'enUS','For Doloria!','',26124),
(51109,'enUS','Be slain by me, villainous cretin!','',26124),
(51110,'enUS','Be proud, dragon. Today you fall to the blade of Azeroth\'s greatest hero. And also to my blade.','',26124),
(51111,'enUS','That was fun! Can I keep the kite, please?','',26124),
(51112,'enUS','Excuuuse me, princess!','',26124),
(51113,'enUS','Oh, boy! I\'m so hungry, I could eat a fire elemental!','',26124),
(51114,'enUS','I\'m not used to fighting with other people.','',26124),
(51115,'enUS','I\'ve got a proposition for you: You die now.','',26124),
(51116,'enUS','They used to call me Tony THREE-Tusk.','',26124),
(51117,'enUS','I\'m going to take you down to pain town.','',26124),
(51118,'enUS','For the Horde!','',26124),
(51119,'enUS','Blood and thunder!','',26124),
(51120,'enUS','LOK\'TAR OGAR!!','',26124),
(51121,'enUS','For the Forsaken! For Lordaeron!','',26124),
(51122,'enUS','This one won\'t be coming back.','',26124),
(51123,'enUS','You\'ll get no mercy from me.','',26124),
(51124,'enUS','RRRAAAAGGHHH!','',26124),
(51125,'enUS','DIE!','',26124),
(51126,'enUS','MY WIFE DIED, YOU MONSTERS!','',26124),
(51127,'enUS','Zen\'Kiki really tempted to shapeshift right now...','',26124),
(51128,'enUS','De Cenarion Circle gonna getcha, mon!','',26124),
(51129,'enUS','Dis is no problem for a mighty druid like Zen\'Kiki.','',26124),
(51130,'enUS','','Go with the Light.',26124),
(51131,'enUS','','None escape the judgment of the Light.',26124),
(51132,'enUS','','Confess your sins, and be forgiven!',26124),
(51133,'enUS','','Leave Azeroth be!',26124),
(51134,'enUS','','Azeroth has no place for you!',26124),
(51135,'enUS','','Be gone!',26124),
(51136,'enUS','These abominations are responsible for the deaths of dozens of squirrels! They deserve no mercy!','',26124),
(51137,'enUS','No surrender! No mercy! For AZEROTH!','',26124),
(51138,'enUS','MRGLLL GLRRM GL! Translation: I will kill you!','',26124),
(51139,'enUS','We ogres are not all bad.','',26124),
(51140,'enUS','You have the support of Ogri\'la.','',26124),
(51141,'enUS','We are friends of the world that you call Azeroth. I am happy to provide any assistance that I can.','',26124),
(51142,'enUS','Hook, line, and slaughter!','',26124),
(51143,'enUS','You know, this isn\'t really my scene. I\'m glad to help, though.','',26124),
(51144,'enUS','I could use a nap right about now.','',26124),
(51145,'enUS','You go away now!','',26124),
(51146,'enUS','Lunk warn you one last time!','',26124),
(51147,'enUS','Lunk no kill!!','',26124),
(51148,'enUS','','De elements walk wit\' us!',26124),
(51149,'enUS','','Dese spirits don\'t belong!',26124),
(51150,'enUS','','For de Darkspear!',26124),
(51151,'enUS','My family has been running caravan routes in the Barrens since Orgrimmar was settled. We raise and train the kodos ourselves. My sister Nagala is the best kodo breeder outside of Mulgore.','',26124),
(51152,'enUS','','Nature\'s fury overwhelms you!',26124),
(51153,'enUS','','Hyjal shall not fall!',26124),
(51154,'enUS','','Ancients be praised!',26124),
(51155,'enUS','Blam! Right between the eyes!','',26124),
(51156,'enUS','The thrill of the hunt, right lads?!','',26124),
(51157,'enUS','I\'ve got a present for ye! Here, let me just get it out of my gun...','',26124),
(51158,'enUS','You have been tested... and you have failed.','',26124),
(51159,'enUS','Time to fight fire with fire! And frost! And shadow!','',26124),
(51160,'enUS','You\'ve fallen right into my trap!','',26124),
(51161,'enUS','I think I knocked that one into next week.','',26124),
(51162,'enUS','I came all the way from Dalaran, and this is the welcoming I get?','',26124),
(51163,'enUS','The ruling council has ordered you banished. I plan to see those orders out.','',26124),
(51164,'enUS','','I can\'t believe you guys are still fighting here in Hyjal. You should see what happens after this.',26124),
(51165,'enUS','','You know what time it is? That\'s right, it\'s time to DIE!',26124),
(51166,'enUS','','You just got Chromie\'d!',26124),
(51168,'enUS','There\'s really nothing I enjoy more than the sound of screaming victims. Especially if they\'re MY victims.','',26124),
(51169,'enUS','You know the worst thing about fire creatures? No harvestable organs.','',26124),
(51170,'enUS','Fire and rocks don\'t really do anything for me. I\'m really more of a flesh man.','',26124),
(51171,'enUS','You know what? You remind me of the Ambulatory Campfire prototype that I\'ve been working on.','',26124),
(51172,'enUS','If you can dodge a double-binary fluxcillometric auto-wrench, you can dodge a ball!','',26124),
(51173,'enUS','I\'m a genius!','',26124),
(51174,'enUS','What, are we done already?','',26124),
(51175,'enUS','Toodly-doo!','',26124),
(51176,'enUS','Mrmrffmm. Ffm.','',26124),
(51177,'enUS','Wait until the guys hear about this!','',26124),
(51178,'enUS','Glad to be of service!','',26124),
(51179,'enUS','Back to work for me. I\'m a busy goblin!','',26124),
(51180,'enUS','While you may be sad to see me go, I\'m sure you will enjoy watching me leave.','',26124),
(51181,'enUS','','Hey, good show out there!  You let me know if you need anything else stabbed.',26124),
(51182,'enUS','The Crusade appreciates the work you\'re doing out here, $n.','',26124),
(51183,'enUS','Thanks for the opportunity to take it to Ragnaros.','',26124),
(51184,'enUS','You have, in the face of terrifying adversity, shown true valor and chivalry. From one glimmering beacon of heroism to another: I salute you!','',26124),
(51185,'enUS','Well fought. Farewell, hero.','',26124),
(51186,'enUS','Until next time! Try to stay alive!','',26124),
(51187,'enUS','You fight well, hero. I look forward to fighting by your side again.','',26124),
(51188,'enUS','Dark Lady watch over you.','',26124),
(51189,'enUS','Back to de plaguelands!','',26124),
(51190,'enUS','','Stand strong, combatants.',26124),
(51191,'enUS','','Always know that you have allies in Deepholm, if you be needin\' us.',26124),
(51192,'enUS','And with that, I shall return to my research.','',26124),
(51193,'enUS','It is time that I returned to Ogri\'la. I hope you do not forget about us, as we have not forgotten you.','',26124),
(51194,'enUS','So long, and thanks for all the fights!','',26124),
(51195,'enUS','Lunk think you killed too much bad guy. But Lunk still think you OK $g guy:lady;.','',26124),
(51196,'enUS','','Thank you for the opportunity. I shall report to Vol\'jin with your regards.',26124),
(51197,'enUS','','I will never stop fighting to protect Hyjal. Not after all we\'ve done to heal her.',26124),
(51198,'enUS','I hope ye had as much fun as I did.','',26124),
(51199,'enUS','This was not worth my time.','',26124),
(51200,'enUS','Until we meet again... you know where to find me.','',26124),
(51201,'enUS','','See you next time!',26124),
(51202,'enUS','I should really be going. All this killing reminded me I still have some fresh corpses that aren\'t sewn to one another.','',26124),
(51203,'enUS','There we have it! Back to the labs!','',26124),
(51204,'enUS','My rage is not silenced... but it is quieter. For now.','',26124),
(51205,'enUS','Fall back!','',26124),
(51206,'enUS','Belay your attack orders, men!','',26124),
(51207,'enUS','Stay your blades, heroes. This dragon\'s scales glow red with flame.','',26124),
(51208,'enUS','Everybody, stop your attacks!','',26124),
(51209,'enUS','Hold your fire!','',26124),
(51210,'enUS','Hold your weapons!','',26124),
(51211,'enUS','Hold your attacks while the shield is up!','',26124),
(51212,'enUS','Stop your attacks! Its shield will overwhelm you.','',26124),
(51213,'enUS','I AM here!','',26124),
(51214,'enUS','Bet you didn\'t know that a kodo can eat its own weight in grass each day. Sure is a lot to shovel when it comes out the other end.','',26124),
(51215,'enUS','Handmade toys from all over Azeroth!','',26124),
(51216,'enUS','','I can hear the howls of the Burning Blade as we speak. The kodos are ready to ride for the Mor\'shan Ramparts. Tell me when you are ready to leave.',26124),
(51217,'enUS','Don\'t attack it while the shield is up!','',26124),
(51218,'enUS','','Not now, mortal.$b$bI am here on urgent business.',26124),
(51219,'enUS','Let\'s see what be wrong wit\' dis creature?','Let\'s see what be wrong wit\' dis creature?',26124),
(51220,'enUS','','Da whispers of Hethiss gonna poison ya\' mind!',26124),
(51221,'enUS','I\'m gonna turn ya\' blood ta venom!','',26124),
(51222,'enUS','','Kilnara laughs maniacally.',26124),
(51223,'enUS','','You kill him - you kill my cat! Why must I suffer so?\n',26124),
(51224,'enUS','','Stranglethorn belongs to da Gurubashi. You best be leavin\' before we bury you here.',26124),
(51225,'enUS','','Or stay if you want. We always be needin\' more to sacrifice.',26124),
(51226,'enUS','By the skin of our teeth, we made it! I haven\'t seen shooting like that since...well...ever! I wish we could ride together again, but Kadrak has more important work for you. Thank you for delivering us safely, my friend.','',26124),
(51227,'enUS','Thank you, old friend. Our warriors thank you.','',26124),
(51228,'enUS','Good to see you again, friend. Make haste and hop on while the way is still clear.','',26124),
(51229,'enUS','Look sharp! They\'re closing in on our heels!','',26124),
(51230,'enUS','Watch out above us! Use your rocket!','',26124),
(51231,'enUS','They\'re coming from all sides! Hang on just a little longer - we\'re almost there!','',26124),
(51232,'enUS','Galenges is weakened by Malorne\'s Antlers! Attack him now!','',26124),
(51233,'enUS','Good shooting! That one won\'t be getting up anytime soon.','',26124),
(51234,'enUS','','Do not take offense, $r.$b$bI simply haven\'t the time for distractions.',26124),
(51235,'enUS','','Forgive my abruptness, $c.$b$bPressing matters of great import require my undivided attention.',26124),
(51236,'enUS','Ahh! What is the meaning of this!?','',26124),
(51237,'enUS','A noble effort... but it will take more than one of your puny stags to take down Galenges, the UNBREAKABLE!','',26124),
(51238,'enUS','','Ahh! There you are, $n.$b$bI must speak with you at once.',26124),
(51239,'enUS','You stand no chance against me!','',26124),
(51240,'enUS','Which one dares to challenge Galenges? Stand forward, weakling!','',26124),
(51241,'enUS','Da Gurubashi be takin\' our land back.','',26124),
(51242,'enUS','We let you stay here too long.','',26124),
(51243,'enUS','You tink you strong.  You tink you brave.  You tink you can survive.','',26124),
(51244,'enUS','But we know...','',26124),
(51245,'enUS','You and all you people, you already dead.','',26124),
(51246,'enUS','An\' once you dead, den you serve da Gurubashi.','',26124),
(51247,'enUS','Kill dese worms!','',26124),
(51248,'enUS','Welcome to the Cold of Cold, friend! Our unique ice cream is chilled to order by one of Stormwind\'s finest apprentice mages!','',26124),
(51249,'enUS','|TInterface\\Icons\\inv_misc_eye_04.blp:20|t%s begins to cast |cFFFF0000|Hspell:96920|h[Eyes of Occu\'thar]|h|r!','',26124),
(51250,'enUS','Rocket launch in 3...','',26124),
(51251,'enUS','Rocket launch in 2...','',26124),
(51252,'enUS','Rocket launch in 1...','',26124),
(51253,'enUS','GO!','',26124),
(51254,'enUS','Shh! I\'m working undercover here.','',26124),
(51255,'enUS','What are you looking at?','',26124),
(51256,'enUS','Have we met?','',26124),
(51257,'enUS','I heard Tortolla was being held here, so I came over as quickly as I could.$b$bMount Hyjal is really tall.','',26124),
(51258,'enUS','Are you ready to face Nemesis? I hope you have your totem ready.$b$bLet me know when you want to summon him.','',26124),
(51259,'enUS','I am ready to meet with Anachronos, Ziradormi. ','I am ready to meet with Anachronos, Ziradormi. ',26124),
(51260,'enUS','I am prepared to face Nemesis, Tooga.','I am prepared to face Nemesis, Tooga.',26124),
(51261,'enUS','NOW, YOUNG ONES! ATTACK THE PORTAL! FOR TORTOLLA!','',26124),
(51262,'enUS','I am ready to meet with Anachronos, Coridormi. ','I am ready to meet with Anachronos, Coridormi. ',26124),
(51263,'enUS','Ye don\' want ta\' be goin up dis\' way, mon.  Da spirits be restless.\n\nMebbe if ye\' know a ting or two about ancient artifacts, ye can fin\' a way to put dem to rest.','',26124),
(51264,'enUS','','You mustn\'t tarry, $n.$b$bAnachronos awaits!',26124),
(51265,'enUS','CLIMB.','',26124),
(51266,'enUS','','Sacrifice yo\' bodies ta Hethiss mah bruddahs, da voodoo will protect you!',26124),
(51267,'enUS','Though this artifact seems to be in pristine condition, you sense nothing particularly special about it.','',26124),
(51268,'enUS','This artifact appears to be intact, though it is so thoroughly coated in dirt and mud that it is difficult to tell for sure.  There does not seem to be anything inherently magical about it.','',26124),
(51269,'enUS','This artifact has weathered many storms, and shows significant signs of deterioration.  It is doubtful that any powers it once held remain.','',26124),
(51270,'enUS','Several leaves and branches cling to this object, indicating that it may have been used as part of a nest for some creature.  There is otherwise nothing of note.','',26124),
(51271,'enUS','Several strange carvings adorn this object, perhaps made by the trolls in an attempt to decipher its origins.  They did not seem to meet with much success, as the object remains inert.','',26124),
(51272,'enUS','Mysterious runes adorn this artifact, though they appear to be unpowered at this time.','',26124),
(51273,'enUS','This object is of low quality and is likely one of many fake artifacts that have been flooding the black market.','',26124),
(51274,'enUS','Several spots of dried blood can be seen on this object, likely a result of the struggle to obtain the artifact by the trolls.  The object is quite plain, however, and may not have been worth the struggle.','',26124),
(51275,'enUS','','Ruby, do you want a treat?',26124),
(51276,'enUS','','Ruby, play dead.',26124),
(51277,'enUS','','Ruby, speak.',26124),
(51278,'enUS','','Ruby, jump.',26124),
(51279,'enUS','','Ruby, walk backwards.',26124),
(51280,'enUS','','Ruby, dance.',26124),
(51281,'enUS','','Good girl, Ruby!',26124),
(51282,'enUS','','That\'s a good widdle waptor!',26124),
(51283,'enUS','','You\'re a smart girl, aren\'t you?',26124),
(51284,'enUS','','Yay! That was amazing!',26124),
(51285,'enUS','Wow, I never knew mages could make ice cream. That was good!','',26124),
(51286,'enUS','When I grow up, I want to put strange things together too!','',26124),
(51287,'enUS','What about... putting soap on a fork? Then it would have a handle and everything!','',26124),
(51288,'enUS','And when the soap\'s gone, you\'d have a new fork!','',26124),
(51289,'enUS','There is something odd about this particular object...','',26124),
(51290,'enUS','Examine the object.','',26124),
(51291,'enUS','This artifact has been cursed by the troll witch doctors!  At your touch, it begins to emit a foul glow.','',26124),
(51292,'enUS','Be at ease, mortal. Our time together here must be productive, and unclouded by tension.$b$bMuch depends on your ability to think clearly and reason well.','',26124),
(51293,'enUS','Examine the object.','',26124),
(51294,'enUS','Examine the object.','Examine the object.',26124),
(51295,'enUS','Let me see what you have for sale.','Let me see what you have for sale.',26124),
(51297,'enUS','','Children, $n has brought a gift for you! Why don\'t you come take a look?',26124),
(51298,'enUS','Wow, a surprise! I love surprises!','Wow, a surprise! I love surprises!',26124),
(51299,'enUS','BOOO!  Did I scare you?$b$bHallow\'s End is all about two things, tricks and treats!  Some adults think it\'s more.  They tried to tell me, but I got bored, until things got set on fire.  That was cool!$b$bBut still, even fire can get boring.  I can tell you what doesn\'t get boring... Tricking people and eating candy!$b$bBut I only want one kind of candy, Candy Coins!  They are the best.  They look like real gold coins!  Also, if you have too many coins, you can eat them!  It\'s like being rich and eating your money!  It\'s crazy!$b$bSo... Do you have some coins you want to trade?','BOOO!  Did I scare you?$b$bHallow\'s End is all about two things, tricks and treats!  Some adults think it\'s more.  They tried to tell me, but I got bored, until things got set on fire.  That was cool!$b$bBut still, even fire can get boring.  I can tell you what doesn\'t get boring... Tricking people and eating candy!$b$bBut I only want one kind of candy, Candy Coins!  They are the best.  They look like real gold coins!  Also, if you have too many coins, you can eat them!  It\'s like being rich and eating your money!  It\'s crazy!$b$bSo... Do you have some coins you want to trade?',26124),
(51300,'enUS','Nagala will have her famous grilled zhevra chops waiting for us, no doubt. She says I need to cut back and eat more vegetables, but I don\'t think I\'ve gained that much weight...do you?','',26124),
(51301,'enUS','I have some Candy Coins I would like to exchange.','I have some Candy Coins I would like to exchange.',26124),
(51302,'enUS','Show me the sugar!','',26124),
(51303,'enUS','Help! Let me go!','',26124),
(51304,'enUS','This is the best!','This is the best!',26124),
(51305,'enUS','Yes, Anachronos. I am ready to witness your vision of the future.','Yes, Anachronos. I am ready to witness your vision of the future.',26124),
(51306,'enUS','','Aww Ruby, you\'re the best pet ever!',26124),
(51307,'enUS','Greetings, $c. My name is Thork--I lead the defenses here in the name of the Warchief.$B$BI see you have had a chance to help out here at the Crossroads. Carry on for the Horde!','',26124),
(51308,'enUS','You can\'t catch me!','You can\'t catch me!',26124),
(51309,'enUS','','',26124),
(51310,'enUS','Look at me, I\'m Uther Lightbringer!','Look at me, I\'m Uther Lightbringer!',26124),
(51311,'enUS','This is the biggest sword ever!','This is the biggest sword ever!',26124),
(51312,'enUS','Eject! Eject! Auuuuugghhh!','',26124),
(51313,'enUS','You overstepped your bounds, Jin\'do. You toy with powers that are beyond you. Have you forgotten who I am? Have you forgotten what I can do?!','',26124),
(51314,'enUS','Ye want Deepmountain Mining and Jewelcrafting, over on the northern side of The Great Forge.','Ye want Deepmountain Mining and Jewelcrafting, over on the northern side of The Great Forge.',26124),
(51315,'enUS','You\'ll find a jewelcrafting trainer and supplies on the inner ring of the War Quarter.','You\'ll find a jewelcrafting trainer and supplies on the inner ring of the War Quarter.',26124),
(51316,'enUS','Go to inner ring of War Quarter.  You find jewel-making people there.','Go to inner ring of War Quarter.  You find jewel-making people there.',26124),
(51317,'enUS','Thank you for your help.','Thank you for your help.',26124),
(51318,'enUS','You saved my life!','You saved my life!',26124),
(51319,'enUS','Wha... What is going on?  The last thing I remember was sitting down to eat...','Wha... What is going on?  The last thing I remember was sitting down to eat...',26124),
(51320,'enUS','Zombies... They are everywhere!','Zombies... They are everywhere!',26124),
(51321,'enUS','We were just trying to eat and suddenly zombies started to appear!','We were just trying to eat and suddenly zombies started to appear!',26124),
(51322,'enUS','The food, there is something wrong with the food!','The food, there is something wrong with the food!',26124),
(51323,'enUS','I had just about given up hope.','I had just about given up hope.',26124),
(51324,'enUS','Oh, my stomach... That food really was awful.','Oh, my stomach... That food really was awful.',26124),
(51325,'enUS','Listen well, mortal.','',26124),
(51326,'enUS','Countless threads are woven to create the fabric of our timeline.','',26124),
(51327,'enUS','As the wardens of time, we of the bronze dragonflight observe their infinite combinations.','',26124),
(51328,'enUS','When disruptions are detected by our watchers, we are charged with their repair.','',26124),
(51329,'enUS','A recent event, obscured by powerful magics, remains masked even to me...','',26124),
(51330,'enUS','But the unavoidable outcome is plain:','',26124),
(51331,'enUS','Azeroth will burn!','',26124),
(51332,'enUS','While the details remain shrouded from our view, one thing we have gleaned...','',26124),
(51333,'enUS','The fate of Azeroth hinges on the deeds of a mortal druid.','The fate of Azeroth hinges on the deeds of a mortal druid.',26124),
(51334,'enUS','The fate of Azeroth hinges on the deeds of a mortal mage.','The fate of Azeroth hinges on the deeds of a mortal mage.',26124),
(51335,'enUS','The fate of Azeroth hinges on the deeds of a mortal priest.','The fate of Azeroth hinges on the deeds of a mortal priest.',26124),
(51336,'enUS','The fate of Azeroth hinges on the deeds of a mortal shaman.','The fate of Azeroth hinges on the deeds of a mortal shaman.',26124),
(51337,'enUS','The fate of Azeroth hinges on the deeds of a mortal warlock.','The fate of Azeroth hinges on the deeds of a mortal warlock.',26124),
(51338,'enUS','Are you the mortal on which so much depends?','',26124),
(51339,'enUS','The cub bats one paw at a tiny insect, only taking note of your attention when the plaything flies away.','',26124),
(51340,'enUS','The cub nuzzles your hand and purrs.','',26124),
(51341,'enUS','A blacksmith and his assistant can be found working in the Warrior\'s Terrace, near the armor and weapon vendors there.','A blacksmith and his assistant can be found working in the Warrior\'s Terrace, near the armor and weapon vendors there.',26124),
(51342,'enUS','Your little cub nips and paws at the air, eager to try out his hunting skills.','',26124),
(51343,'enUS','The cub sniffs your hand and decides you\'re not a threat... this time.','',26124),
(51344,'enUS','At least one Gilnean engineer works out of the Craftsmen\'s Terrace. She should be able to help you.','At least one Gilnean engineer works out of the Craftsmen\'s Terrace. She should be able to help you.',26124),
(51345,'enUS','Ah, you seek the Silverdews in the Craftmen\'s Terrace. They\'ve only recently set up shop, near the enchanter\'s.','Ah, you seek the Silverdews in the Craftmen\'s Terrace. They\'ve only recently set up shop, near the enchanter\'s.',26124),
(51346,'enUS','Blacksmithing','Blacksmithing',26124),
(51347,'enUS','Engineering','Engineering',26124),
(51348,'enUS','Mining','Mining',26124),
(51349,'enUS','A pair of skilled miners fled plague-ridden Gilneas and made their way here. You\'ll find them in the Craftsmen\'s Terrace.','A pair of skilled miners fled plague-ridden Gilneas and made their way here. You\'ll find them in the Craftsmen\'s Terrace.',26124),
(51350,'enUS','Millagazor begins to escape!','',26124),
(51351,'enUS','You pests are not worth my time!','',26124),
(51352,'enUS','Who summons Millagazor?','',26124),
(51353,'enUS','You must be looking for Palehoof, who keeps our elevators and windmills in good working order. Find him upon the lower rise.','You must be looking for Palehoof, who keeps our elevators and windmills in good working order. Find him upon the lower rise.',26124),
(51354,'enUS','Seek the Cloudchasers upon the lower rise. They should be able to help you in all matters of jewelcrafting.','Seek the Cloudchasers upon the lower rise. They should be able to help you in all matters of jewelcrafting.',26124),
(51355,'enUS','I\'ve seen goblins riding these things. I know they can go faster!','',26124),
(51356,'enUS','I wonder what this button does...','',26124),
(51357,'enUS','Now THAT\'s more like it!','',26124),
(51358,'enUS','I\'ve figured out how this works. I\'m taking control!','',26124),
(51359,'enUS','Hang onto your, um... helmet!','',26124),
(51360,'enUS','No, rocket! Don\'t go that way!','',26124),
(51361,'enUS','I\'m losing control!','',26124),
(51362,'enUS','This is the only button I haven\'t pushed yet. Let\'s give it a try!','',26124),
(51363,'enUS','Something unnatural is going on, Bwemba.  Can you help?','Something unnatural is going on, Bwemba.  Can you help?',26124),
(51364,'enUS','','You wanna be talkin\' to da spirits?  Well let\'s see what we can do... ',26124),
(51365,'enUS','I think I found the emergency button. Rockets have those, don\'t they?','',26124),
(51366,'enUS','','You gotta be Bwemba\'s hands on dis one... I need ya to toss some sticks into da bonfire in da center of dis camp.  Den Bwemba can handle da rest.',26124),
(51367,'enUS','','Mauri\'s death removes the protections from a nearby cauldron!',26124),
(51368,'enUS','T\'kulu\'s death removes the protections from a nearby cauldron!','',26124),
(51369,'enUS','This is gonna be fun!','',26124),
(51370,'enUS','I did it! I got us back on track!','',26124),
(51371,'enUS','Jump to shake off the Cinderlings!','',26124),
(51372,'enUS','Wow, so you\'re the Banshee Queen? I kind of expected you to be taller!','',26124),
(51373,'enUS','Everyone says you had a fight with the warchief and you\'re going to abandon the Horde. Is that true?','',26124),
(51374,'enUS','','I do not require defending, ambassador. Young one, as I have told the warchief, my loyalties have never been in doubt.',26124),
(51375,'enUS','','The Horde embraced my people when we stood alone and we Forsaken never forget a debt...',26124),
(51376,'enUS','','Garrosh and I will always do what is best for our people.',26124),
(51377,'enUS','So it\'s not true? Thank the ancestors! I wouldn\'t want you to be my enemy, Lady Sylvanas.','',26124),
(51378,'enUS','You forget yourself, child! Do you know who stands before you?','',26124),
(51379,'enUS','Your grip is loosening! Climb down the tree quickly!','Your grip is loosening! Climb down the tree quickly!',26124),
(51380,'enUS','The mortal coil unwindsss...','',26124),
(51381,'enUS','Your sssacrifice pleases him.','',26124),
(51382,'enUS','Let the coils of death unfurl!','',26124),
(51383,'enUS','My death means...nothing...','',26124),
(51384,'enUS','Ahaha, get a load \'a me, mon!$b$bGriftah be back again! New stall, and brand new wares, and ready to pass on the deals to ya!$b$bWant to be better, stronger, faster? Each one of these amulets be guaranteed to do just what I say they be doin\'. Step up and buy one of these miraculous baubles! Cheap at twice the price!','',26124),
(51385,'enUS','There is no end to these trolls, $c.','',26124),
(51386,'enUS','Can one of your gryphons get me to the Digsite?','Can one of your gryphons get me to the Digsite?',26124),
(51387,'enUS','You have my thanks, friend.','You have my thanks, friend.',26124),
(51388,'enUS','Thank you. I\'ll be sure to slay a few spiders on my way back to camp.','Thank you. I\'ll be sure to slay a few spiders on my way back to camp.',26124),
(51389,'enUS','You don\'t want to know what it was like in there.','You don\'t want to know what it was like in there.',26124),
(51390,'enUS','Thank you for freeing me. I thought I was done for.','Thank you for freeing me. I thought I was done for.',26124),
(51391,'enUS','Thanks for getting me out of there! That was awful.','Thanks for getting me out of there! That was awful.',26124),
(51392,'enUS','S-s-s-st-sticky....','S-s-s-st-sticky....',26124),
(51393,'enUS','Thank you! Now to see about this burning sensation...','Thank you! Now to see about this burning sensation...',26124),
(51394,'enUS','','Ahh, dere you are!  We been searching da entire jungle for ya!',26124),
(51395,'enUS','','Da help\'s been good.  Da Zandalar plan has set da Gurubashi on da warpath.',26124),
(51396,'enUS','','Not all da places held together so well.  We try to help as much as we can.  But da source, it be Zul\'Gurub.',26124),
(51397,'enUS','If you can keep my town safe,  I\'ll definitely make it worth your while.','',26124),
(51398,'enUS','Good work Bwemba.  It be good to see dat dere be Alliance willin\' to help stop da Zandalar.','',26124),
(51399,'enUS','','Da Gurubashi be usin\' all sorts of voodoo to reclaim dere land.',26124),
(51400,'enUS','','Zanzil!',26124),
(51401,'enUS','I see you were able to get some help.','',26124),
(51402,'enUS','I know.  It be why I went around, to warn everyone.   When da leader of da Darkspear speak, everyone listen, Horde an\' Alliance.','',26124),
(51403,'enUS','Den dat be where we go next.  We gonna stop dis uprising at da source.','',26124),
(51404,'enUS','Good work Bwemba, you an\' your friend, make da Darkspear proud.','',26124),
(51405,'enUS','I got a few more tings to discuss here.  Den I\'ll head to Zul\'Gurub.  I will see you dere.','',26124),
(51406,'enUS','','Now let\'s see what Bwemba\'s conjured up...',26124),
(51407,'enUS','','Dis is serious business.  Venoxis ain\'t one to trifle wit\'.',26124),
(51408,'enUS','','Ah... It be Kilnara.  I shoulda known she be involved here.',26124),
(51409,'enUS','','I don\'t believe my eyes... Is dat Bloodlord Mandokir?  Dis gonna be bad...',26124),
(51410,'enUS','','Dese Gurubashi mean business.  We gotta help dese people.',26124),
(51411,'enUS','%s surges toward the most distant player!','',26124),
(51412,'enUS','Elders of Thunder Bluff, I have called you together in the sight of the ancestors to honor my father, Cairne Bloodhoof.','',26124),
(51413,'enUS','Father, you were a man who led wisely, who battled skillfully, and who always sought the best for your people.','',26124),
(51414,'enUS','May your spirit continue to guide us, father, as you did in life.','',26124),
(51415,'enUS','When my druids and I were ambushed by renegade orcs, you challenged Warchief Garrosh to trial by combat to answer for their deaths, chieftain.','',26124),
(51416,'enUS','You fought bravely, chieftain, but Grimtotem treachery poisoned Garrosh\'s weapon and denied you fair combat.','',26124),
(51417,'enUS','May your spirit know peace. Magatha and her kin were driven from the city and your worthy son carries on your legacy.','',26124),
(51418,'enUS','','We know you, Cairne Bloodhoof, and your people have told us of your deeds. You are welcome at the hearth of the ancestors.',26124),
(51419,'enUS','So this is how a chieftain is honored!','',26124),
(51420,'enUS','Landro\'s Lichling','Landro\'s Lichling',26124),
(51421,'enUS','Fool\'s Gold','Fool\'s Gold',26124),
(51422,'enUS','','Not bad, champion! What they say about you is true. However, we part ways here. I must go deal with this prisoner...personally.',26124),
(51423,'enUS','Savage Raptor Mount','Savage Raptor Mount',26124),
(51424,'enUS','Nightsaber Cub','Nightsaber Cub',26124),
(51425,'enUS','War Party Hitching Post','War Party Hitching Post',26124),
(51426,'enUS','Amani Dragonhawk','Amani Dragonhawk',26124),
(51427,'enUS','','Quickly! Lure the enemy onto my trap!',26124),
(51428,'enUS','War of the Elements','War of the Elements',26124),
(51429,'enUS','Twilight of the Dragons','Twilight of the Dragons',26124),
(51430,'enUS','Only time will tell.','',26124),
(51431,'enUS','What about... putting soap on an axe? Then it would have a handle and everything!','',26124),
(51432,'enUS','And when the soap\'s gone, you\'d have a new axe!','',26124),
(51433,'enUS','','Children, $n has brought a surprise for you! Come and take a look at your gift!',26124),
(51434,'enUS','Look at me, I\'m High Overlord Saurfang!','Look at me, I\'m High Overlord Saurfang!',26124),
(51435,'enUS','If the snakes don\'t kill us, the panther will!','',26124),
(51436,'enUS','The eyes... I can\'t stop thinking about it\'s eyes!','',26124),
(51437,'enUS','The hissing never stops.  The serpents keep coming!','',26124),
(51438,'enUS','There is no safe place to hide!','',26124),
(51439,'enUS','The panther is hunting us, it can\'t be a good idea to stay in one spot.  We\'ve got to leave!','',26124),
(51440,'enUS','We\'re doomed...','',26124),
(51441,'enUS','So many hunters have been taken by that beast... ','',26124),
(51442,'enUS','This jungle is going to be the end of us all.','',26124),
(51443,'enUS','I can\'t get those eyes out of my head...','I can\'t get those eyes out of my head...',26124),
(51444,'enUS','With Mauti still out there, it may be better to die from this poison.','With Mauti still out there, it may be better to die from this poison.',26124),
(51445,'enUS','Don\'t let that panther drag me off... Put me down if it comes to that.','Don\'t let that panther drag me off... Put me down if it comes to that.',26124),
(51446,'enUS','If anyone can track Mauti, Grent can.  Once the panther is taken care of, then all we have to do is worry about the serpents.','If anyone can track Mauti, Grent can.  Once the panther is taken care of, then all we have to do is worry about the serpents.',26124),
(51447,'enUS','Did you hear that?  I thought I just heard Mauti over there...','Did you hear that?  I thought I just heard Mauti over there...',26124),
(51448,'enUS','Endless serpents and a giant panther... It can\'t get much worse than this.','Endless serpents and a giant panther... It can\'t get much worse than this.',26124),
(51449,'enUS','I can feel Mauti watching us... Waiting for another chance to pounce.','I can feel Mauti watching us... Waiting for another chance to pounce.',26124),
(51450,'enUS','So many dead serpents... If only I had kept up with my skinning...','So many dead serpents... If only I had kept up with my skinning...',26124),
(51451,'enUS','Whooooooooooa!','',26124),
(51452,'enUS','','$n, it is good to see you. Have you come to help push the front for us?',26124),
(51453,'enUS','','You needn\'t worry, child. The warchief\'s \"observers\" are here to make certain of that.',26124),
(51454,'enUS','','The elemental forces are relentless. I fear we\'ll not be able to hold this breach forever. Not without more help.',26124),
(51455,'enUS','Lylagar is offended by your inferior howl.','',26124),
(51456,'enUS','Lylagar lets out a pitiful whimper.','',26124),
(51457,'enUS','Use the Emerald of Aessina to cleanse yourself of Pyrachnis\' poison!','',26124),
(51458,'enUS','','I could be convinced to part with one... IF you\'ll promise to give the cub a good home.',26124),
(51459,'enUS','','What foolishness is this?',26124),
(51460,'enUS','','You there! Have your senses abandoned you?',26124),
(51461,'enUS','','Coldarra is no place for mortals now.',26124),
(51462,'enUS','','You must flee at once, if you value your life.',26124),
(51463,'enUS','','Access to Coldarra has been forbidden to the lesser races, $c.$b$bYour life is in grave danger here.',26124),
(51464,'enUS','%s begins to erupt, spewing Lava Parasites onto the ground!','',26124),
(51465,'enUS','','Speak quickly, mortal, before you are discovered by one less discriminating than I.',26124),
(51466,'enUS','It\'s a difficult job keeping the steam tanks up and running by yourself, but someone has to do it.','',26124),
(51467,'enUS','Chopper rentals are free in honor of Children\'s Week. Just hop onto one and cruise beautiful Westfall!','',26124),
(51468,'enUS','I need another Wolvar Orphan Whistle.','I need another Wolvar Orphan Whistle.',26124),
(51469,'enUS','Ye shoulda seen it, $n! Moira comes down here ta talk ta the stone, as she\'s wont ta do in tryin\' times. I left \'em alone, least I could do fer a daughter and her pa.\n\nThen there\'s a crack and a crash like ye\'ve never heard, an\' I rushed back in to see what happened. An\' there\'s Magni, walkin\' and talkin\', made o\' crystal from head ta toe! \n\nHis voice rumbled like a mountainslide, tellin\' us he speaks fer the land now, that he\'s a PART o\' Azeroth. Didn\'t take him but a moment ta give the clan leaders a dire warning o\' the Legion\'s return, then he up an\' left fer a walkabout!$b$bHe muttered somethin\' \'bout Ulduar. I sent word to his brother Brann. Hope he kin find Magni an\' get to the bottom o\' this!','',26124),
(51470,'enUS','I should\'ve broken those damn tablets the day you brought them to me, $n, but I didn\'t. We might still have our king\'s wisdom to guide us through these perilous times.','',26124),
(51471,'enUS','Ragnaros, I call upon your power to aid me!','Ragnaros, I call upon your power to aid me!',26124),
(51472,'enUS','Master, fill me with your glorious radiance!','Master, fill me with your glorious radiance!',26124),
(51473,'enUS','Lord Ragnaros, grant me your everlasting fire!','Lord Ragnaros, grant me your everlasting fire!\n',26124),
(51474,'enUS','','It\'s no use! Their shield is too strong!',26124),
(51475,'enUS','','Da Zandalari, dey gone mad.  We gotta make sure dey be stopped.',26124),
(51476,'enUS','','Da Darkspear don\'t want any ting to do wit da plans of da Zandalari.',26124),
(51477,'enUS','','Venoxis, he be controllin\' da serpents.  He be a wily one.',26124),
(51478,'enUS','','Venoxis be a master of poisons, he be a deadly foe.',26124),
(51479,'enUS','','Kilnara, she be crazy about panthers.  ',26124),
(51480,'enUS','','Did you see da eyes of Mauti?  Dey were glowing bright!  I shoulda know den dat Kilnara be behind da panther attacks.',26124),
(51481,'enUS','','Good work, champion. I will take this foul creature back with me. This druid has much to answer to.',26124),
(51482,'enUS','','Minions of the Firelord, lay waste to these invaders! The Guardians of Hyjal shall burn for their arrogance!',26124),
(51483,'enUS','','You will all suffer the wrath of Ragnaros!',26124),
(51484,'enUS','','DIE!!!',26124),
(51485,'enUS','','No matter. I shall watch Hyjal burn from afar.',26124),
(51486,'enUS','Zanzil mutters to himself.','',26124),
(51487,'enUS','A pinch of dis... A dash of dat... Heh, heh!','',26124),
(51488,'enUS','Oh Zanzil, Zanzil. I jes\' love dat voodoo dat you do. ','',26124),
(51489,'enUS','Slaves... Zombies... It don\'t matter to Zanzil. Dey all serve Gurubashi, one way or de other...','',26124),
(51490,'enUS','Druids, hold your fire! She is unarmed!','',26124),
(51491,'enUS','Wait a moment... I know that girl. Leyara, is that you?','',26124),
(51492,'enUS','','Your skills in combat are admirable, hero. Keep yourself useful on the battlefield. I will take this criminal back for...questioning.',26124),
(51493,'enUS','','I am impressed, hero. Thank you for helping me subdue this...druid. I can take this heretic back on my own.',26124),
(51494,'enUS','A flame druid... she is dangerous, Malfurion. You know her?','',26124),
(51495,'enUS','Yes, Hamuul. And she\'s more dangerous than you know.','',26124),
(51498,'enUS','This is a child of Beth\'tilac, the Red Widow. Her spawn will seek vengeance for their slain brethren.','',26124),
(51499,'enUS','The young raptor looks up at you. You can\'t be certain, but you think you see a flicker of recognition in her eye.','',26124),
(51500,'enUS','Da Zandalari must be stopped. Wit\' all da trolls of Azeroth at their command, dey would be a threat to all of us.','',26124),
(51501,'enUS','Da Zandalari be a threat to both our peoples, $r. It will take da stength o\' both our forces to break them.','',26124),
(51502,'enUS','Lord Ragnaros! Shield me!','Lord Ragnaros! Shield me!',26124),
(51503,'enUS','We\'re ready to open the gates.','We\'re ready to open the gates.',26124),
(51504,'enUS','Follow me, $c. It be takin\' da both of us to open these gates.','',26124),
(51505,'enUS','','Hey $n, you\'re here!  These guys came out of nowhere!  Help me out while I catch my breath.',26124),
(51506,'enUS','Da ritual to open da gates be requirin\' both of us to hit da gong together.','',26124),
(51507,'enUS','','',26124),
(51508,'enUS','Perhaps we\'re not ready yet. Speak to me again when you be wantin\' to open da gates.','',26124),
(51509,'enUS','I have agreed to this meeting, worldbreaker, but at great risk. If this is discovered...','',26124),
(51510,'enUS','And once the new order is established? My place will be secure, yes?','',26124),
(51512,'enUS','Calm yourself, Arygos. Your barrier will buy you all the time you need.','',26124),
(51513,'enUS','With Kalecgos dead, your destiny as the Blue aspect shall be realized. ','',26124),
(51514,'enUS','Your reign over the realm of magic will be absolute, even after the Hour of Twilight.','',26124),
(51515,'enUS','But be warned, Arygos, son of Malygos. Do not make the mistakes of your father.','',26124),
(51516,'enUS','Cross me, and your punishment shall be far greater than the madness he suffered.','',26124),
(51517,'enUS','Hear me, Zandalari schemers... Da Darkspears and our allies will deny you rulership of da Amani!','',26124),
(51518,'enUS','Protect Thisalee from the fire elementals!','Protect Thisalee from the fire elementals!',26124),
(51519,'enUS','Da Amani know we\'re here. Now is da time to attack! ','',26124),
(51520,'enUS','','Greetings, $c. The Fire Lord has twisted our former brothers and sisters into avatars of molten fury. Even now, the Druids of the Flame carry out his insane plan to destroy the World Tree. We will not let that happen.',26124),
(51521,'enUS','Look, Anren! $n has come to help us!','',26124),
(51522,'enUS','Protect Tholo and Anren from the fire elementals!','Protect Tholo and Anren from the fire elementals!',26124),
(51523,'enUS','Your arrival is timely, $r.  I tire of fighting these wretched things.','',26124),
(51524,'enUS','Protect Elderlimb from the fire elementals!','Protect Elderlimb from the fire elementals!',26124),
(51525,'enUS','','My blade is yours, champion.',26124),
(51526,'enUS','','Elune greet you, champion. I will watch your back.',26124),
(51527,'enUS','','Call for aid and the Shadow Wardens will answer. I am ready for anything.',26124),
(51528,'enUS','','Reporting for duty. There is no time to lose.',26124),
(51529,'enUS','','My blade thirsts for battle. Do not keep me waiting.',26124),
(51530,'enUS','','I can handle things from here. I\'ll meet you back at the Sanctuary, $n.',26124),
(51531,'enUS','Thank you, $n. As long as we stay together, Anren and I will be fine. Go check on the others!','',26124),
(51532,'enUS','I can hold them off from here, $r. We will meet again at the Sanctuary of Malorne.','',26124),
(51533,'enUS','','Justice will be served, heathen!',26124),
(51534,'enUS','','I will show no mercy to the defiled!',26124),
(51535,'enUS','','I promise this won\'t hurt...too much.',26124),
(51536,'enUS','','Ask not for mercy. My blade will not grant it.',26124),
(51537,'enUS','','I will deliver my enemies to their ancestors!',26124),
(51538,'enUS','','Fire burns many things, but it cannot touch a shadow.',26124),
(51539,'enUS','','I will cleanse your sins with the edge of my dagger.',26124),
(51540,'enUS','','Where dere be zombies, dere be Zanzil.  Da Zandalar trolls be makin\' da Gurubashi work all of dere mojo to take back Stranglethorn.',26124),
(51541,'enUS','My heart is heavy with the burden of this war. I lead my people to their deaths. But if we cannot stand against Ragnaros now, how will we withstand Neltharion?$B$BWe must fight with everything we have, or witness the destruction of our world.','',26124),
(51542,'enUS','I am with you, Tholo!','',26124),
(51543,'enUS','Stay on my back, Tholo!','',26124),
(51544,'enUS','We must stay together, Tholo!','',26124),
(51545,'enUS','You are a good friend, Tholo!','',26124),
(51546,'enUS','I have your back, Tholo!','',26124),
(51547,'enUS','I will stay with you, Anren!','',26124),
(51548,'enUS','You are a good friend, Anren!','',26124),
(51549,'enUS','I will protect you, Anren!','',26124),
(51550,'enUS','Together we can do anything, Anren!','',26124),
(51551,'enUS','I am here, Anren!','',26124),
(51552,'enUS','You must stay by Thisalee\'s side!','You must stay by Thisalee\'s side!',26124),
(51553,'enUS','You must stay by Tholo and Anren\'s side!','You must stay by Tholo and Anren\'s side!',26124),
(51554,'enUS','You must stay by Elderlimb\'s side!','You must stay by Elderlimb\'s side!',26124),
(51555,'enUS','Once da high priest is dead and da coast is clear, let me know and I be returnin\' to the blood guard wit\' my report.','',26124),
(51556,'enUS','You kill the trollbear, mon? It be safe for me to make my way back now?','',26124),
(51557,'enUS','Hello out there. Anybody be hearin\' Hazlek?','',26124),
(51558,'enUS','Hey! Don\'t ya be forgettin\' about Hazlek over here.','',26124),
(51559,'enUS','I could be pickin\' this lock in my sleep. Just come an\' say when it be safe to make my escape.','',26124),
(51560,'enUS','At last, I be free!','',26124),
(51561,'enUS','Here be some of my things....','',26124),
(51562,'enUS','There now. It be a gift to you, to help wit\' defeatin\' da Amani!','',26124),
(51563,'enUS','It\'s good to be outta dat cage. Dey were goin\' to sacrifice me...','',26124),
(51564,'enUS','You don\'t have to worry about that anymore. What\'s going on here?','You don\'t have to worry about that anymore. What\'s going on here?',26124),
(51565,'enUS','Ok mon, this be what I saw....$b$bAll was quiet, til we be hearin\' a rustlin\' sound, like the wind through the trees. Before we know it, we be surrounded by these Amani and their pets! Next think I knew, I be wakin\' up here, stuck in a cage.$b$bDay an\' night, one by one, da captured scouts be gettin\' killed. Every time one be dyin\', that bear-troll be lookin\' stronger.$b$bThat be all I could learn from my place in dat cage.','',26124),
(51566,'enUS','','Are you here to aid da Darkspear, $c?',26124),
(51567,'enUS','Ya have my tanks, $c. I thought I\'d be endin\' up just another sacrifice...','',26124),
(51568,'enUS','Don\'t be forgettin\' about me!','',26124),
(51569,'enUS','How about comin\' over here an\' helpin\' me outta here?','',26124),
(51570,'enUS','I got information dat Vol\'jin needs. Help me outta here!','',26124),
(51571,'enUS','Don\'t go leavin\' the job half done. Come an\' tell me if it be safe to make my report!','',26124),
(51572,'enUS','It be good to be free again!','',26124),
(51573,'enUS','','I be an emissary from da Darkspear trolls.  Da threat we face, also be a threat to da Alliance.  You willin\' to help out da Darkspear, $r?',26124),
(51574,'enUS','Allow me ta show you something I discovered. Now where\'d I see dat satchel?','',26124),
(51575,'enUS','','Dis is Fort Livingston?  It look like we already too late.  Da Zandalar attack, it begun.',26124),
(51576,'enUS','','Oh no... Bambala...  It look like we already too late.  Da Zandalar attack, it begun.',26124),
(51577,'enUS','Help yourselves. It be suicide for a scout to walk around wit\' so much weighing me down.','',26124),
(51578,'enUS','','Da hunters seem to be holdin\' da serpents off.  But sometin\' else feel wrong... Like we bein\' watched.',26124),
(51579,'enUS','Ya be havin\' me gratitude, $c.$b$bIf there be anythin\' I can be doin\' for ya, just say so.','',26124),
(51580,'enUS','','Da Digsite, it be overrun with zombies...',26124),
(51581,'enUS','','Da Hideaway, it be overrun with zombies...',26124),
(51582,'enUS','Dis place not be so bad if only dere weren\'t so many Amani \'ere.','',26124),
(51583,'enUS','Da Amani and da Zandalari will never try somethin\' like this again.','',26124),
(51584,'enUS','Vol\'jin will show dose Zandalari not to mess wit\' da Darkspears.','',26124),
(51585,'enUS','Dis be a grisly business. I be happy when it be over and we go home again.','',26124),
(51586,'enUS','','This place be reekin\' of death and sacrifice.$b$bBest you leave before you become da next prisoner.\n',26124),
(51587,'enUS','','My liberators! Come down and have a word wit\' Norkani.',26124),
(51588,'enUS','','Norkani still be needin\' your help!\n',26124),
(51589,'enUS','','I must be returnin\' to Vol\'jin wit\' my report! Help me outta here!',26124),
(51590,'enUS','','At last, Norkani is free!\n',26124),
(51591,'enUS','','Now, where have dey put Norkani\'s things?',26124),
(51592,'enUS','','Stand clear....',26124),
(51593,'enUS','','Please take dis. Norkani be havin\' no use for it.',26124),
(51594,'enUS','','It be good to be outta dat cage. Norkani will have her revenge...',26124),
(51595,'enUS','','Where am I? You be here to help?',26124),
(51596,'enUS','They must\'ve drugged you. It\'s safe now.','They must\'ve drugged you. It\'s safe now.',26124),
(51597,'enUS','','Dey\'ve done something to me! I be needin\' help!',26124),
(51598,'enUS','','I be hearin\' ya an\' I think ya not be my captors. Come closer so I be seein\' ya.',26124),
(51599,'enUS','','My head be swimmin\'. Please, I be beggin\' ya!',26124),
(51600,'enUS','','Things be comin\' back. I be here for... a mission... Help me outta here. Dere\'s things to be done.',26124),
(51601,'enUS','','Voodoo be gone!',26124),
(51602,'enUS','','Be free from da voodoo!',26124),
(51603,'enUS','','You be free from da voodoo now!',26124),
(51604,'enUS','','Spirits let dis one return to us.',26124),
(51605,'enUS','','Weeee! I\'m alive, I\'m alive, I\'m alive! Oh, I hope it\'s not too forward of me to tell you that I think I love you all and I hope I can find my bag because you certainly deserve a little something extra, you know, for the effort and all that you must have went through to save me...',26124),
(51606,'enUS','Come brothers and sisters. It is time to take this foul tower from the hands of our enemies.','',26124),
(51607,'enUS','Press on!  Push towards the tower!','',26124),
(51608,'enUS','Their leader is here! Strike him down!','',26124),
(51609,'enUS','','It is time, $c.$b$bLet us see what has been so carefully hidden...',26124),
(51610,'enUS','','Dere was a shrine to serpents just to da east of Bambala, I need ya to toss some sticks into da bonfire in front of dat shrine.  Den Bwemba can handle da rest.',26124),
(51611,'enUS','Ancients of Zandalar, grant dis one da power ta\' mock death itself!','',26124),
(51612,'enUS','What brings you to me, mortal?','',26124),
(51613,'enUS','Speak freely, friend.','',26124),
(51614,'enUS','Something about you seems... familiar.','',26124),
(51615,'enUS','My vision in the Eye of Eternity haunts me, Kalecgos. What do you make of it?','My vision in the Eye of Eternity haunts me, Kalecgos. What do you make of it?',26124),
(51616,'enUS','There is a great deal at stake within the blue dragonflight, $c.$b$bSoon, a new aspect must be chosen to take the place of Malygos.$b$bArygos aspires to follow in the footsteps of his father, renewing the misguided aggression against all who wield magic. This path, I feel, would lead to the end of our kind.$b$bThe remnants of our flight are divided on this fateful issue, and I fear that Arygos will stop at nothing to meet his ends...','',26124),
(51617,'enUS','Who is Tarecgosa? I could not have made it through the Nexus without her.','Who is Tarecgosa? I could not have made it through the Nexus without her.',26124),
(51618,'enUS','<Wistfully, Kalecgos looks off to the horizon.>$b$bTarecgosa is... special to me.$b$bWhen she was but a hatchling, I was charged with her protection and education. Over the millennia, we have forged a special bond, not unlike what you would call siblings.$b$bTarecgosa was born under a special sign that foretold of a great destiny. If the prophecies are true, then her survival is of vital importance to the blue dragonflight, and to Azeroth itself.$b$bOur affinity for one another is well known within the remnants of our flight. If your vision recounted an event that has actually taken place, she could be in grave danger.','',26124),
(51619,'enUS','','$n, our forces are pushing up the ramp. You should join them there.',26124),
(51620,'enUS','','$n, our forces are pushing up to the tower already. You should join them, quickly.',26124),
(51621,'enUS','','$n, our attack should be ready shortly. Wait here and push up the ramp with them.',26124),
(51622,'enUS','','Turak, Marin, lead these forces up the ramp and take the tower! Be swfit!',26124),
(51623,'enUS','','Deldren, Shalis, these men are yours to lead. Take the tower.',26124),
(51624,'enUS','','Keeper Taldros, I am sending Sira and the others with you to help you take the tower. Elune be with you.',26124),
(51625,'enUS','Ancestors be beside me, let \'dem hear yo\' voice!','',26124),
(51626,'enUS','','$n, our forces are about to push up the ramp. You should join them.',26124),
(51627,'enUS','','These trolls have made a grave mistake, $c.',26124),
(51628,'enUS','I need use of a wyvern to fly me to where the Darkspear emissary went.','I need use of a wyvern to fly me to where the Darkspear emissary went.',26124),
(51629,'enUS','Shower of Flame incoming! Don\'t stop moving!','',26124),
(51630,'enUS','Ancients of Zandalar, mark \'dem for de black road.','',26124),
(51631,'enUS','Ahh, it is good to see you again, $r.','',26124),
(51632,'enUS','Zul has seen tha\' future.  We gotta come together, or we all fall to de darkness.','',26124),
(51633,'enUS','\'Dis be de only way, bruddahs.','',26124),
(51634,'enUS','Dis land was taken from us in a tide of blood.','',26124),
(51635,'enUS','De green fist of de troll empire gonna crush dis land and make it our own again.','',26124),
(51636,'enUS','De Zandalari got powers you never seen.  Wisdom of de most ancient of trolls, wisdom dat\'s rightfully yours.','',26124),
(51637,'enUS','Dis shattered world not done breakin, mon.','',26124),
(51638,'enUS','De tides of darkness gonna take over.  All da trolls be in danger.','',26124),
(51639,'enUS','De Darkspear be foolish.  No one gonna stand in our way.','',26124),
(51640,'enUS','','It is already determined.  You have no hope... the flames shall consume all!',26124),
(51641,'enUS','You... you\'re the one from the portal... the druid of flame...','',26124),
(51642,'enUS','You killed dozens of my students.  You will pay for what you\'ve done.','',26124),
(51643,'enUS','','Enough of this!',26124),
(51644,'enUS','What is this?  I... can\'t move!  Someone, help!','',26124),
(51645,'enUS','','Burn, tauren!  BURN!!',26124),
(51646,'enUS','','Have you had enough yet? Have you felt enough pain?',26124),
(51647,'enUS','','Now, look before you! One of Azeroth\'s most powerful \"druids\", reduced to nothing but a charred husk. Such is the will of Fandral Staghelm. Such is the will of the flame!',26124),
(51648,'enUS','','Go on, then. Weep over the body of your precious tauren... though I assure you that your tears will not bring him back.',26124),
(51649,'enUS','','Dat be so much better. I be weak, but I remember hearin\' da Amani and da Zandalari talkin\' about treasure hidden in dis very room.',26124),
(51650,'enUS','','Maybe it be in dis urn over here. Stand back!',26124),
(51651,'enUS','','Hmm. Dat\'s not da one. Let\'s try one o\' da other vases.',26124),
(51652,'enUS','','Dere be somethin\' in dat one. Go take look.',26124),
(51653,'enUS','','Ya have my gratitude for gettin\' me outta dat cage. My wits are finally returnin\' an\' I\'ll be able to tell Vol\'jin what I learned.\n',26124),
(51654,'enUS','','Nevermind me, $r. $b$bNorkani as good as dead. Leave now, $r, before da Amani get you too.',26124),
(51655,'enUS','','Help me outta here, $r. First, you gotta kill da Amani priest who captured me. He be preparin\' to sacrifice me!\n',26124),
(51656,'enUS','I be one o\' da Darkspear scouts. Kill dat Amani priest so I can return wit\' my report!','',26124),
(51657,'enUS','Da warlord has fallen!','',26124),
(51658,'enUS','Hear me, Rastakhan! Wherever ya and your Zandalari be schemin\' to rule da troll people, ya be findin\' da Darkspear and our allies standin\' against ya!','',26124),
(51659,'enUS','I am prepared to accompany you, Kalecgos.','I am prepared to accompany you, Kalecgos.',26124),
(51660,'enUS','What... what has happened?','',26124),
(51661,'enUS','$n, I will attend to the Archdruid. Malfurion and Matoclaw have requested your presence immediately.','',26124),
(51662,'enUS','','Fool! Be bathed in the flames!',26124),
(51663,'enUS','Tarecgosa!','',26124),
(51664,'enUS','Well done, friends! The tower is ours! Now I shall see to the destruction of this foul monument.','',26124),
(51665,'enUS','','Well done, $n. It looks like we have them on the run.',26124),
(51666,'enUS','What is the meaning of this?!','',26124),
(51667,'enUS','Planting','Planting',26124),
(51668,'enUS','I bring word from the Regent Lord of Silvermoon.','',26124),
(51669,'enUS','Lord Lor\'themar demands an explanation for the presence of this... exile in our lands.','',26124),
(51670,'enUS','','Quel\'Thalas is as much my home as it is yours and I would not see it fall to our ancient enemy. Now, you tell your cowardly regent --',26124),
(51671,'enUS','Vereesa, please! ','',26124),
(51672,'enUS','She is here at my invitation, courier. Most of my Farstriders are away and cannot be recalled easily. Vereesa\'s rangers know the land and they are experienced combatants. ','',26124),
(51673,'enUS','Lord Lor\'themar does not concur with your reasoning, ranger-general. You have no authority to invite this --','',26124),
(51674,'enUS','I am the commander of Silvermoon\'s defenses and I will seek assistance as I deem necessary! ','',26124),
(51675,'enUS','Now, Chieftain Vol\'jin, before we were so rudely interrupted, you were telling us of the Zandalari plan. ','',26124),
(51676,'enUS','Dat I was. Da Zandalari called a meeting  o\' all da troll tribes includin\' da Darkspears. ','',26124),
(51677,'enUS','King Rastakhan, he be plannin\' to unite da troll tribes under his Zandalari.','',26124),
(51678,'enUS','','Including the Amani? ',26124),
(51679,'enUS','Da Amani, da Gurubashi, all o\' dem. He be dispatchin\' emissaries to every tribe. ','',26124),
(51680,'enUS','My scouts have reported nothing but quiet outside Zul\'Aman. ','',26124),
(51681,'enUS','Dey be holed up inside da ruined city, regroupin\'. ','',26124),
(51682,'enUS','Rastakhan be callin\' me his brother, but da Horde be our true brothers. We gotta stop him before he can sweet-talk da others into joinin\' his empire.','',26124),
(51683,'enUS','','So how are we going to deal with this alliance between the Amani and the Zandalari? ',26124),
(51684,'enUS','We must prevent it from occurring in the first place. ','',26124),
(51685,'enUS','Dat be da plan. My men be infiltratin\' da city and learnin\' what dey can about da new Zandalari warlord. ','',26124),
(51686,'enUS','','Halduron, we should combine our forces and make preparations to act on reports from the Darkspear scouts.',26124),
(51687,'enUS','Agreed. Messenger, you may carry word of our plans back to Lord Lor\'themar, but make it clear that I will not tolerate any further interference. ','',26124),
(51688,'enUS','I seem to have... misplaced my wisp. Are there any others available?','I seem to have... misplaced my wisp. Are there any others available?',26124),
(51689,'enUS','A new Aspect of Magic has already been selected, Kalecgos.','',26124),
(51690,'enUS','There is no longer a place for you.','',26124),
(51691,'enUS','You are... dismissed.','',26124),
(51693,'enUS','How about a little swim, $r?','',26124),
(51694,'enUS','Back into the lava with you...','',26124),
(51695,'enUS','Time for a dip in the magma, $c!','',26124),
(51696,'enUS','Let the lava fill your lungs!','',26124),
(51697,'enUS','The lava shall consume you, cold ones!','',26124),
(51698,'enUS','Waves of flame consume you!','',26124),
(51699,'enUS','Spirits of fire, destroy this vermin!','',26124),
(51700,'enUS','You will be washed away with flame...','',26124),
(51701,'enUS','The Gurubashi attackers just keep streaming in! We\'ve been pinned down here and haven\'t received word from the outlying outposts in days.','',26124),
(51702,'enUS','The Fire Lasher wriggles with glee. You found him!','',26124),
(51703,'enUS','Hiding in 1...','',26124),
(51704,'enUS','Hiding in 2...','',26124),
(51705,'enUS','Hiding in 3...','',26124),
(51706,'enUS','No peeking!','',26124),
(51707,'enUS','','My spirit be watchin\' over ya, $n.',26124),
(51708,'enUS','','Spirit walkin\' be taxin\' work.',26124),
(51709,'enUS','Noooo!','',26124),
(51710,'enUS','The worm is about to bite!  Place the bomb down now!','',26124),
(51711,'enUS','3...','',26124),
(51712,'enUS','2...','',26124),
(51713,'enUS','1...','',26124),
(51714,'enUS','The eclipse of Azeroths\' moons is an occurrence that we of the blue dragonflight hold most sacred.','',26124),
(51715,'enUS','','What interest this little Lasher might have in the dead tree, I don\'t know.',26124),
(51716,'enUS','','Why, I think he\'s trying to revive the tree!',26124),
(51717,'enUS','','Poor thing...it doesn\'t realize that the tree is beyond salvation.',26124),
(51718,'enUS','','Wait...something\'s happening!',26124),
(51719,'enUS','','Oh my...',26124),
(51720,'enUS','','Impossible...',26124),
(51721,'enUS','','Wait! I sense life in him still, but it is very faint. I will do my best to save him.',26124),
(51722,'enUS','','My spirit gonna be watchin\' over ya, $n.',26124),
(51723,'enUS','','My spirit gonna be watchin\' over ya, $n.',26124),
(51724,'enUS','I\'m here to make sure the job gets done on time.$b$bBooty Bay is still trying to recover from the tidal wave!$b$bThe last thing we need is a horde of rampaging trolls, zombie trolls, poisonous serpents or crazed panthers attacking us.','',26124),
(51725,'enUS','I\'m here to represent Booty Bay\'s interest in this expedition.$b$bIf things go bad, Booty Bay is in trouble.$b$bWe are still recovering from the events of the cataclysm.','',26124),
(51727,'enUS','','Oh dear! He wasn\'t able to do it after all. And it seems he\'s paid the ultimate price to try.',26124),
(51728,'enUS','','Come, little one. Let us return to camp and forget this fruitless task.',26124),
(51729,'enUS','It would be my honor, Kalecgos.','It would be my honor, Kalecgos.',26124),
(51730,'enUS','','Hello there! You\'re really growing on me.',26124),
(51731,'enUS','','In the nature of all things is the will to survive.',26124),
(51732,'enUS','Stay by Malfurion\'s side while he summons Malorne!','',26124),
(51733,'enUS','$n!  I know where the other emissary went.','',26124),
(51734,'enUS','Let me know when you are ready to go, $n.','',26124),
(51735,'enUS','','$n!  I know where the other troll went.',26124),
(51736,'enUS','','Speak to me when you are ready to go, $n.',26124),
(51739,'enUS','Ohgan\'aka, the young raptor, looks at you with pleading eyes.','',26124),
(51740,'enUS','Sampling','Sampling',26124),
(51741,'enUS','Tholo\'s Thermometer is ready to take a sample.','Tholo\'s Thermometer is ready to take a sample.',26124),
(51742,'enUS','It\'s hotter\'n a kiln down here! Ah could fry an egg on me forehead.','',26124),
(51743,'enUS','%s groans as a large piece of his body is broken loose!','',26124),
(51744,'enUS','I will go with you by foot and clear the path of flames.  It will take all my concentration to keep the fire at bay, so you need to make sure that I remain safe.','',26124),
(51745,'enUS','I am willing, Kalecgos. I shall cast Tarecgosa\'s vote on her behalf.','I am willing, Kalecgos. I shall cast Tarecgosa\'s vote on her behalf.',26124),
(51746,'enUS','Stay close. Stay vigilant.','',26124),
(51747,'enUS','We\'re almost through. Stay close!','',26124),
(51748,'enUS','Brothers! Strike now!','',26124),
(51749,'enUS','Obsidian Defender has cast Harden Shield! It is taking less damage!','',26124),
(51750,'enUS','While I already feel better, I am not yet ready for combat. I will need you to escort me.','',26124),
(51751,'enUS','I am worried about Tholo.','',26124),
(51752,'enUS','This first part is the toughest. Once we get to the thermal vents, the path will be much clearer.','',26124),
(51753,'enUS','Here is the first vent! Face the ledge, then jump! The heated air currents will do the rest.','',26124),
(51754,'enUS','Just face the ledge, and jump!','',26124),
(51755,'enUS','I\'m on my way, Tholo!','',26124),
(51756,'enUS','We\'re nearly there now.','',26124),
(51757,'enUS','Thank you. I must go find Tholo, my fellow druid and treasured friend.','',26124),
(51758,'enUS','If you find yourself in this cave again, do not forget about the thermal vents. They may help you escape some tight situations.','',26124),
(51759,'enUS','Tholo... is that you...?','',26124),
(51760,'enUS','Here\'s some water, Anren. Let\'s get you out of this cave.','Here\'s some water, Anren. Let\'s get you out of this cave.',26124),
(51761,'enUS','Obsidian Defender has overloaded itself and is now vulnerable to explosives!','',26124),
(51762,'enUS','','That Malfurion... fitting of him to send his $r underling to speak with me.$b$bHe has proven himself a coward, as always.',26124),
(51763,'enUS','Malfurion, a coward? How can you justify that?','Malfurion, a coward? How can you justify that?',26124),
(51764,'enUS','','Never you mind, $r. The details of my past were burned away when I joined the Druids of the Flame. They are of no concern to you.$b$bBesides, I am here to discuss the future of this realm. And I do not plan to discuss it with you.$b$bNow answer me... where is Malfurion!?',26124),
(51765,'enUS','Malfurion is not here. Only me.','Malfurion is not here. Only me.',26124),
(51766,'enUS','%s stumbles as his armor is shattered!','',26124),
(51767,'enUS','','Very well. Malfurion shall press into the Firelands, and we will deal with him there. His judgment can wait for a few more brief days.$b$b<Leyara\'s eyes light up.>$b$bThe tauren arch druid, however, will not be so lucky.',26124),
(51768,'enUS','Tauren archdruid? Do you mean Hamuul?','Tauren archdruid? Do you mean Hamuul?',26124),
(51769,'enUS','','The invaders are fast approaching, Malfurion. Give up this ritual, and join the fight!',26124),
(51770,'enUS','','With your help, we can repel them!',26124),
(51771,'enUS','No, Matoclaw.  Ragnaros will not be content to send mere foot soldiers to attack us.','',26124),
(51772,'enUS','I sense something larger is coming, and we will need the strength of Malorne if we are to survive.','',26124),
(51773,'enUS','Have patience, Matoclaw.  The ritual is nearly complete.','',26124),
(51774,'enUS','','Elune\'s light... what is that thing?',26124),
(51775,'enUS','Hold them back! We need to buy more time!','',26124),
(51776,'enUS','Buuurrnnnn!','',26124),
(51777,'enUS','Hold the line!  They must not break through!','',26124),
(51778,'enUS','Succumb to living flame!','',26124),
(51779,'enUS','Stand strong!  Only a bit longer!','',26124),
(51780,'enUS','We gather to determine the fate of our great flight.','',26124),
(51781,'enUS','Our history has been wrought with great challenges...','',26124),
(51782,'enUS','Our future promises even greater threats.','',26124),
(51783,'enUS','These circumstances demand a powerful leader.','',26124),
(51784,'enUS','I was raised at the feet of my father.','',26124),
(51785,'enUS','I watched as he steered us through adversity, never flinching from difficult decisions.','',26124),
(51786,'enUS','Some called my father mad. But even in his darkest hours, his vision was clear.','',26124),
(51787,'enUS','He put the needs of this flight first and foremost.','',26124),
(51788,'enUS','He sought to consolidate our rightful power, fortifying us for the cataclysm that he saw coming.','',26124),
(51789,'enUS','Brothers, we must take what is ours.','',26124),
(51790,'enUS','Under my leadership, this flight will rise again, beyond the glory of our past - onwards to an even greater destiny.','',26124),
(51791,'enUS','I will see to it!','',26124),
(51792,'enUS','Our assault on the Firelands cannot wait. We strike, at Ragnaros and at Fandral, as soon as we can.','',26124),
(51793,'enUS','How goes the ritual, Malfurion?','How goes the ritual, Malfurion?',26124),
(51794,'enUS','Thank you, $c. I might have died out here if not for you.','',26124),
(51795,'enUS','You have my thanks. Stay safe, $c.','',26124),
(51796,'enUS','These are harsher skies than any of us could have known.','',26124),
(51797,'enUS','Be careful out here. It\'s far more dangerous than it first seems.','',26124),
(51798,'enUS','I might have escaped if I hadn\'t got caught in one of the thermals...','',26124),
(51799,'enUS','The matriarch knocked me right out of the sky. I\'m lucky to be alive.','',26124),
(51800,'enUS','These thermals have made flying here nearly suicidal. Thank you for coming for us.','',26124),
(51801,'enUS','It will be some time before I can recover from these injures. Still, I\'m glad to be alive.','',26124),
(51802,'enUS','I\'m in your debt, $c.','I\'m in your debt, $c.',26124),
(51803,'enUS','Elune be praised! And you as well.','Elune be praised! And you as well.',26124),
(51804,'enUS','It was foolish of me to get caught away from the line. Thank you for the second chance.','It was foolish of me to get caught away from the line. Thank you for the second chance.',26124),
(51805,'enUS','I\'ll return immediately. Thank you, $c.','I\'ll return immediately. Thank you, $c.',26124),
(51806,'enUS','I should be able to make my way back. Thank you, friend.','I should be able to make my way back. Thank you, friend.',26124),
(51807,'enUS','Their attacks are relentless. Thank you for your help.','Their attacks are relentless. Thank you for your help.',26124),
(51808,'enUS','I owe you a very special thank you. Find me sometime when this fight is over.','I owe you a very special thank you. Find me sometime when this fight is over.',26124),
(51809,'enUS','I was surely done for. I owe you greatly, $r.','I was surely done for. I owe you greatly, $r.',26124),
(51810,'enUS','The Fire Hawk Matriarch screams in rage at your theft.','',26124),
(51811,'enUS','I see you.','',26124),
(51812,'enUS','Daily Wave:','',26124),
(51813,'enUS','Joust!','',26124),
(51814,'enUS','Have lance, will stab!','',26124),
(51815,'enUS','Get thee to a hatchery!','',26124),
(51816,'enUS','Here we flap again!','',26124),
(51817,'enUS','Lancer? I hardly knew her!','',26124),
(51818,'enUS','Lance in the pants!','',26124),
(51819,'enUS','Hyjal kids, Hyjal wives! They\'re lancing everyone in here!','',26124),
(51820,'enUS','Lance with the devil in the pale Twilight!','',26124),
(51821,'enUS','Brothers, sisters, Arygos speaks of our troubled past.','',26124),
(51822,'enUS','Indeed, we have suffered greatly.','',26124),
(51823,'enUS','But I would contend that we are at least partly to blame for the scars we bear.','',26124),
(51824,'enUS','Let us turn from our old ways.','',26124),
(51825,'enUS','Let us not seek to extinguish magic from the world...','',26124),
(51826,'enUS','...but to use it responsibly for the benefit of Azeroth and all its inhabitants.','',26124),
(51827,'enUS','It is true that our choice here today will affect the destiny of our flight. And likely, the destiny of the world.','',26124),
(51828,'enUS','May the Titans guide us. May we be inspired to choose with wisdom.','',26124),
(51829,'enUS','Stay still. I\'ll get you to safety.','',26124),
(51830,'enUS','Don\'t worry. I\'ve got you.','',26124),
(51831,'enUS','Not so fast. You\'re not dying on us just yet.','',26124),
(51832,'enUS','Touchy footing up there. Be careful.','',26124),
(51833,'enUS','I\'ll try to get you back on the island. We just have to get through these thermals...','',26124),
(51834,'enUS','Hold tight, the air currents here are deadly.','',26124),
(51835,'enUS','You\'re far too important to us to be lost that easily.','',26124),
(51836,'enUS','Going up.','',26124),
(51837,'enUS','The memories in this locket swirl in anguish. Such pain and suffering... let us see what it wants to show us.','',26124),
(51838,'enUS','Who is this? That looks like Valstann, Fandral Staghelm\'s only son. What is he doing? Is this a memory of the Qiraji War?','',26124),
(51839,'enUS','It is! The great war of Silithus raged over a thousand years ago. Valstann tried to save his people, but was captured...and killed.','',26124),
(51840,'enUS','Oh - this is terrible. Why would Leyara cling to this memory? Valstann must have been an important part of her life...','',26124),
(51841,'enUS','Time passes, yet the sting of his death will not fade.','',26124),
(51842,'enUS','','Valstann, my dear husband, you left us too soon.',26124),
(51843,'enUS','Leyara, the two of you are all I have left. I swear to you, on my life, you and my granddaughter will ALWAYS have my protection.','',26124),
(51844,'enUS','','I tried to save you Istaria, but I was too weak.',26124),
(51845,'enUS','','Fandral would never have allowed the Horde to attack our home! And who did Malfurion send to defend us? No one!',26124),
(51846,'enUS','Your anger is not misguided.','',26124),
(51847,'enUS','','Who\'s there?',26124),
(51848,'enUS','One who shares your pain. One who offers you the power to assuage it.','',26124),
(51849,'enUS','','Fandral! You escaped from prison?',26124),
(51850,'enUS','I was rescued by some new allies. I\'m sorry I was not here sooner.','',26124),
(51851,'enUS','','What is this power? What have you become?',26124),
(51852,'enUS','You will learn in due time, my daughter. Come with me. Together, we will bring vengeance to those who have wronged us...','',26124),
(51853,'enUS','','Our child has been born. It\'s a girl! A beautiful baby girl.',26124),
(51854,'enUS','','I named her Istaria. She has your eyes. ',26124),
(51855,'enUS','Fools! Neltharion take you all!','',26124),
(51856,'enUS','','Leyara nods.',26124),
(51857,'enUS','These trolls have just shown up demanding our help.','',26124),
(51858,'enUS','I can barely understand what these trolls are trying to say.','',26124),
(51859,'enUS','Why don\'t these trolls just deal with their problems on their own?','',26124),
(51861,'enUS','<The troll sings to himself as he observes the carnage around him.>','',26124),
(51862,'enUS','Tanks for da help.','Tanks for da help.',26124),
(51863,'enUS','Ya saved my life!','Ya saved my life!',26124),
(51864,'enUS','Bwemba, is dat you?  Tanks for da save.','Bwemba, is dat you?  Tanks for da save.',26124),
(51865,'enUS','Da serpents, dey be everywhere!','Da serpents, dey be everywhere!',26124),
(51866,'enUS','Da serpents overwhelmed us.','Da serpents overwhelmed us.',26124),
(51867,'enUS','I was tinkin\' dat I was gonna to die in dis jungle.','I was tinkin\' dat I was gonna to die in dis jungle.',26124),
(51868,'enUS','Da spirits be watchin\' over me today.','Da spirits be watchin\' over me today.',26124),
(51869,'enUS','Tank ya for savin\' my life.','Tank ya for savin\' my life.',26124),
(51870,'enUS','There is no time to waste, friend.$b$bMy flight is in disarray and is in desperate need of leadership.','',26124),
(51871,'enUS','','Glad you could make it, $n.',26124),
(51872,'enUS','','Welcome to the Molten Flow, $n.',26124),
(51873,'enUS','','The flamewakers up ahead mean business. Be careful in there.',26124),
(51874,'enUS','','There are plenty of thermal vents up ahead, $n. Feel free to use them if you get into a jam.',26124),
(51875,'enUS','','I fear there may be a lost druid in the back of the cave, $n. Be on the lookout.',26124),
(51876,'enUS','%s\'s armor is weakened by the active volcano.','',26124),
(51877,'enUS','','Da other emissary, he always be tryin\' to save da world!',26124),
(51878,'enUS','','What part of da jungle ain\'t da other emissary been in?',26124),
(51879,'enUS','','What kinda mess did we stumble into?',26124),
(51880,'enUS','','Mandokir sure do love his raptors.',26124),
(51881,'enUS','','Da Bloodlord, it look like he be overseein\' da Gurubashi warriors.',26124),
(51882,'enUS','','Your deeds shall live on forever in the memories of every blue dragon, $n.',26124),
(51883,'enUS','I am ready to take part in the ceremony, Hallegosa.','I am ready to take part in the ceremony, Hallegosa.',26124),
(51884,'enUS','','Follow me, $n. A ceremony has been prepared in your honor.',26124),
(51887,'enUS','Well done. We should be safe for the moment, but we haven\'t much time.','',26124),
(51888,'enUS','With this seed, we set root. With time and attention, we should be able to grow shelter from this charred, hostile realm.','',26124),
(51889,'enUS','Here we will hold firm against the onslaught of the elements.','',26124),
(51890,'enUS','Here we will draw the attention of Ragnaros\' army so that others might strike at the heart of his realm.','',26124),
(51891,'enUS','And now, the war begins.','',26124),
(51892,'enUS','','Stand upon this disc, $p. Kalecgos approaches!',26124),
(51893,'enUS','The grave is old, peaceful, and undisturbed.','',26124),
(51894,'enUS','Present the Smoke-Stained Locket.','Present the Smoke-Stained Locket.',26124),
(51895,'enUS','While this is certainly a grave marker, it is unclear who is buried here.','',26124),
(51896,'enUS','I can teach the art of cooking.\n\nAre you looking to learn?','I can teach the art of cooking.\n\nAre you looking to learn?',26124),
(51897,'enUS','Welcome, friend. We\'ve been expecting you.','',26124),
(51898,'enUS','You are to be congratulated for your success in the Firelands.','',26124),
(51899,'enUS','But praise alone will not suffice.','',26124),
(51900,'enUS','We owe you a great deal for the part you have played in the destiny of our flight.','',26124),
(51901,'enUS','Present me your staff, that we may endow it with great power.','',26124),
(51902,'enUS','This platform is about to crumble! Jump to another!','This platform is about to crumble! Jump to another!',26124),
(51903,'enUS','','My, it sure is hot down here. I didn\'t even need to bring my own forge.',26124),
(51904,'enUS','','That island over there is full of Obsidium creatures! I\'d go over there myself, but I can\'t get across the bridge.',26124),
(51905,'enUS','It is not the fighters I watch; that is the Combat Masters\' task.\n\nMy concern is for the two neophytes whose duty it is to heal them. So far, my students are doing well.','',26124),
(51906,'enUS','Oh, aye. I took the wee rotter\'s candle.\n\nNow, what did ye need?','',26124),
(51909,'enUS','You seek me? We fight now!','',26124),
(51910,'enUS','Crushed!','',26124),
(51911,'enUS','You are weak!','',26124),
(51912,'enUS','I COME FOR YOU, LITTLE MORTAL!','',26124),
(51913,'enUS','I will catch you, small one!','',26124),
(51914,'enUS','Coward! You cannot run!','',26124),
(51915,'enUS','No! You do not escape the rage of the Gurubashi!','',26124),
(51916,'enUS','Gri\'lek wanders... no more...','',26124),
(51917,'enUS','Today, you\'ll wish you never stirred from your bed!','',26124),
(51918,'enUS','Pity. In death, you no longer dream...','',26124),
(51919,'enUS','There there... close your eyes...','',26124),
(51920,'enUS','Let us see what horrors stir within your nightmares!','',26124),
(51921,'enUS','Let\'s see what\'s more horrifying... to dream unwaking, or to awaken in a living nightmare!','',26124),
(51922,'enUS','Slumber... another dream awaits you...','',26124),
(51923,'enUS','My spirit dreams no longer...','',26124),
(51924,'enUS','Finally, Tarecgosa, our beloved sister whose essence you have generously borne, has chosen this staff as her permanent home.','',26124),
(51925,'enUS','Ahhh... I shall add a new blade to my collection today...','',26124),
(51926,'enUS','A swift slice to the throat, and this one falls like any other.','',26124),
(51927,'enUS','Learn your place.','',26124),
(51928,'enUS','Perhaps a quick stab will let out all that tension in your shoulders...','',26124),
(51929,'enUS','Rogues do it from behind...','',26124),
(51930,'enUS','It only hurts this much the first time.  The second time, you\'re dead.','',26124),
(51931,'enUS','Feel the sting of a thousand cuts!','',26124),
(51932,'enUS','One thousand blades!','',26124),
(51933,'enUS','Not even a thousand deaths could put my soul to rest...','',26124),
(51934,'enUS','Return to the Hyjal invasion area, or you will be dropped!','',26124),
(51935,'enUS','What? You\'ve come to laugh at Zanzil, too? Not again! I\'ll make you pay!','What? You\'ve come to laugh at Zanzil, too? Not again! I\'ll make you pay!',26124),
(51936,'enUS','Don\'t worry. Zanzil won\'t leave you dead for long...','Don\'t worry. Zanzil won\'t leave you dead for long...',26124),
(51937,'enUS','How does that taste?','How does that taste?',26124),
(51938,'enUS','Oooh, pretty... Zanzil\'s got big plans for this one...','Oooh, pretty... Zanzil\'s got big plans for this one...',26124),
(51939,'enUS','Maybe you need someone bigger to play with!','Maybe you need someone bigger to play with!',26124),
(51940,'enUS','Go, little one! Fight them! KILL THEM!','Go, little one! Fight them! KILL THEM!',26124),
(51941,'enUS','Who needs friends? Zanzil just makes his own! ','Who needs friends? Zanzil just makes his own! ',26124),
(51942,'enUS','Rise up! Zanzil\'s elixir gives you life!','Rise up! Zanzil\'s elixir gives you life!',26124),
(51943,'enUS','Hahahaha!','Hahahaha!',26124),
(51944,'enUS','Breathe deep, friends! Breathe it all in!','Breathe deep, friends! Breathe it all in!',26124),
(51945,'enUS','You\'ll all suffer for this! Zul\'Gurub is NOTHING without Zan... Zan...','You\'ll all suffer for this! Zul\'Gurub is NOTHING without Zan... Zan...',26124),
(51946,'enUS','','I consider it a great honor to assist the Lady Proudmoore in her research. She\'s the most powerful human mage upon Azeroth, you know!\n\nNow, was there something I might help you with?',26124),
(51947,'enUS','You shall regret disturbing my homeland!','',26124),
(51948,'enUS','Were this tower to boast TWICE as many tomes, it would still not be enough for me. My collecting and copying shall never be done.\n\nSo. You have need of my assistance?','',26124),
(51949,'enUS','Can you feel that tingling sensation? It may be your last.','',26124),
(51950,'enUS','You\'re in for a stunning surprise...','',26124),
(51951,'enUS','Are you quicker than lightning?','',26124),
(51952,'enUS','The storm feeds my power!','',26124),
(51953,'enUS','The end of our empire... is only the beginning...','',26124),
(51954,'enUS','Shocking. I know.','',26124),
(51955,'enUS','','You mean to say there is a warlock? Here, in goodly Theramore?!\n\nOh, my. Someone must inform Lady Proudmoore immediately!\n\n...heh.',26124),
(51956,'enUS','Feel the might of my storm!','',26124),
(51957,'enUS','','Please, lower your voice. It isn\'t wise to remind Lady Proudmoore of the sorts of things we study.\n\nNow, shall we speak of TRUE power...?',26124),
(51958,'enUS','With all the Siege Engines nearly complete, I\'m getting a bit bored!\n\nYou\'re not an engineer, are you? Care to compare blueprints...?','',26124),
(51959,'enUS','Welcome to my kitchen!\n\nAre you here looking for food, or to do some cooking yourself?','',26124),
(51960,'enUS','I used ta be in the Explorers\' League, ye know.\n\nBut then I realized the only thing I really cared ta look for was GEMS.\n\nBig, sparklin\', colorful, valuable gems... oh, how I love ye!','',26124),
(51961,'enUS','May her presence be a source of comfort and companionship to you.','',26124),
(51962,'enUS','We thank you, friend of the blue dragonflight.','',26124),
(51963,'enUS','Are you looking at me? Yes, look at me. You should be looking at me. Are you? Looking at me? Good.','',26124),
(51964,'enUS','Twinkles! Why did it have to be Twinkles?','',26124),
(51966,'enUS','','He\'s gem-mad, he is, but I love him. Says I\'m his favorite gem of them all, hee!\n\nNow then, what can I help ye with? Archaeology, is it?',26124),
(51967,'enUS','In a flash, you\'ll be nothing more than dust...','',26124),
(51968,'enUS','<The staff pulsates with arcane energies.>','',26124),
(51969,'enUS','Good leather in the marshes, if you\'ve the guts for it. Lots of crocolisks. Thinkin\' my brother and I\'ll stay a while.\n\nSomethin\' I can help you with?','',26124),
(51970,'enUS','You nothing!','',26124),
(51971,'enUS','Ain\'t NO ONE gonna stop Jin\'do!','',26124),
(51972,'enUS','You nothing!','',26124),
(51973,'enUS','Meddlesome insects! Now you will feel my wrath!','',26124),
(51975,'enUS','Be freed, insects. I will deal with you another time.','',26124),
(51976,'enUS','Your deceit is unforgivable, Jin\'do. You spit in the face of a god!','',26124),
(51977,'enUS','','Nature\'s blessings upon you.',26124),
(51978,'enUS','','You need help with some fires? Very well, let\'s get down to business.',26124),
(51979,'enUS','Today, I fight by your side.','',26124),
(51980,'enUS','So you are to be my commander today. Very well.','',26124),
(51981,'enUS','Let\'s do this.','',26124),
(51982,'enUS','','The doctor is... IN!',26124),
(51983,'enUS','I\'d \'ave a cleaner shot \'round \'ere if someone hadn\'t all gone and done regrown up all them stupid trees.','',26124),
(51984,'enUS','Hallo!','',26124),
(51985,'enUS','','May you frolic through meadows of pain.',26124),
(51986,'enUS','','By Elune, I shall show you a quick death.',26124),
(51987,'enUS','','Never return to this place, elemental. This is a place of nature!',26124),
(51988,'enUS','','For Gilneas!',26124),
(51989,'enUS','','What\'s a little fire in the face of five heroes of the Alliance?',26124),
(51990,'enUS','','We of Gilneas show little patience for outsiders.',26124),
(51991,'enUS','You are nothing!','',26124),
(51992,'enUS','Your presence here is unwelcome, elemental!','',26124),
(51993,'enUS','Azeroth has no place for the likes of you.','',26124),
(51994,'enUS','Be gone, you soulless wretch!','',26124),
(51995,'enUS','Taste my steel!','',26124),
(51996,'enUS','I will show you no mercy.','',26124),
(51997,'enUS','AAAAAAAAAAAHHHHHHHHH!','',26124),
(51998,'enUS','Eat dirt and die, you spineless cowards!','',26124),
(51999,'enUS','I\'ll tear you to pieces! AAAAAHHHHHHHH!','',26124),
(52000,'enUS','','For Gnomeregan!',26124),
(52001,'enUS','','Behold, the potent power of Cogspin!',26124),
(52002,'enUS','','As resident doctor, I am compelled to warn the rest of you that fire can be hazardous to your health.',26124),
(52003,'enUS','Aim fer tha jimmies!','',26124),
(52004,'enUS','Oh aye, this\'ll teach yeh to stop doin\' whatever yeh done did.','',26124),
(52005,'enUS','Iffin\' yeh don\'t sumtimes shoot a small furry animal out yer gun, \'ow would yeh keep it clean? The druids don\'t \'ave an answer to THAT one!','',26124),
(52006,'enUS','I\'ll sing \'em ta death, I will I will.','',26124),
(52007,'enUS','Traaa la laaa...','',26124),
(52008,'enUS','Let me at \'em! I\'ll bash \'em ta bits with my lute!','',26124),
(52009,'enUS','','Back to Teldrassil for me. Farewell, everyone!',26124),
(52010,'enUS','','I wouldn\'t mind fighting with you again sometime.  Farewell!',26124),
(52011,'enUS','Our work is far from done. Fandral will pay for his deceit.','',26124),
(52012,'enUS','I admire your strength.','',26124),
(52013,'enUS','Never stop fighting.','',26124),
(52014,'enUS','','Stay healthy!',26124),
(52015,'enUS','Right. I\'m off. Time ta get blootered. ','',26124),
(52016,'enUS','Until next time, lads.','',26124),
(52017,'enUS','Put your weapons down, everyone.  Wait out the shield!','',26124),
(52018,'enUS','Stop!  Stop attacking!','',26124),
(52019,'enUS','Cease fire, men! Wait out the shield.','',26124),
(52020,'enUS','The rift can be reached through this hall. Follow me.','The rift can be reached through this hall. Follow me.',26124),
(52021,'enUS','Stay close, $n. If we are caught, it will be the end of both of us.','Stay close, $n. If we are caught, it will be the end of both of us.',26124),
(52022,'enUS','Security here is much stronger than I recall... what is Arygos protecting?','Security here is much stronger than I recall... what is Arygos protecting?',26124),
(52023,'enUS','Assist me! There are too many!','Assist me! There are too many!',26124),
(52024,'enUS','More sentries approach! There\'s no other way...','More sentries approach! There\'s no other way...',26124),
(52025,'enUS','Protect me while I break this barrier. ','Protect me while I break this barrier. ',26124),
(52026,'enUS','What!? Twilight dragons? Here??','What!? Twilight dragons? Here??\n',26124),
(52029,'enUS','Ha ha ha! Is that all you got?','',26124),
(52030,'enUS','Your broken body belongs to Hakkar.','',26124),
(52031,'enUS','Fall to my feet.  Fall to Mandokir, the bloodlord!','',26124),
(52032,'enUS','Ding!','',26124),
(52033,'enUS','Rise, Ohgan! Rise, and fight for your master!','',26124),
(52034,'enUS','Off with your head!','',26124),
(52035,'enUS','Heads gonna roll!','',26124),
(52036,'enUS','My blood feeds Hakkar! My soul... feeds... Jin\'do!','',26124),
(52040,'enUS','Guards, come to my defense!','Guards, come to my defense!',26124),
(52043,'enUS','Welcome to Theramore Isle. Something I can help you find?','Welcome to Theramore Isle. Something I can help you find?',26124),
(52044,'enUS','Speak to Paymaster Lendry on the second floor of the barracks.\n\nHe can arrange to store your goods with Theramore\'s treasury.','Speak to Paymaster Lendry on the second floor of the barracks.\n\nHe can arrange to store your goods with Theramore\'s treasury.',26124),
(52049,'enUS','','This way, $n. The ceremony is about to begin.',26124),
(52050,'enUS','Look for Jensen Farran near the archery range.','Look for Jensen Farran near the archery range.',26124),
(52051,'enUS','You\'ll find Horace Alder pacing about above the ground level of Lady Proudmoore\'s tower.','You\'ll find Horace Alder pacing about above the ground level of Lady Proudmoore\'s tower.',26124),
(52052,'enUS','Look for Brother Karman overseeing training at the combat dummies outside the barracks.','Look for Brother Karman overseeing training at the combat dummies outside the barracks.',26124),
(52053,'enUS','Look for Allen Bright at the sparring ring near the barracks.\n\nHe and Doctor Gustaf VanHowzen oversee the training of the isle\'s healers.','Look for Allen Bright at the sparring ring near the barracks.\n\nHe and Doctor Gustaf VanHowzen oversee the training of the isle\'s healers.',26124),
(52054,'enUS','I\'m not certain. Try asking Calia Hastings, by the docks. I\'m told she has connections to SI:7.','I\'m not certain. Try asking Calia Hastings, by the docks. I\'m told she has connections to SI:7.',26124),
(52055,'enUS','A shaman...?\n\nThere\'s a rather rough-looking dwarven lass staying in Theramore\'s inn; I believe she came to visit an old friend of hers here.\n\nShe might be able to help you.','A shaman...?\n\nThere\'s a rather rough-looking dwarven lass staying in Theramore\'s inn; I believe she came to visit an old friend of hers here.\n\nShe might be able to help you.',26124),
(52056,'enUS','Well... ah... don\'t tell her I sent you, but look for a red-robed woman above the ground level of the central tower.\n\nRedia Vaunt is her name. But do not mention me!','Well... ah... don\'t tell her I sent you, but look for a red-robed woman above the ground level of the central tower.\n\nRedia Vaunt is her name. But do not mention me!',26124),
(52057,'enUS','Report to Captain Evencane on the second level of the barracks. He can see to your training.','Report to Captain Evencane on the second level of the barracks. He can see to your training.',26124),
(52058,'enUS','Alchemy','Alchemy',26124),
(52059,'enUS','Alchemist Narett and Brant Jasperbloom teach Alchemy and Herbalism out of a small shop here; they\'ll be able to help you.','Alchemist Narett and Brant Jasperbloom teach Alchemy and Herbalism out of a small shop here; they\'ll be able to help you.',26124),
(52060,'enUS','I know that one of those visiting Woolybush dwarves is an archaeologist.\n\nI think it\'s the wife, Faena. They\'re both explorers of some sort. Look for them in the inn.','I know that one of those visiting Woolybush dwarves is an archaeologist.\n\nI think it\'s the wife, Faena. They\'re both explorers of some sort. Look for them in the inn.',26124),
(52061,'enUS','Ask for Marie Holdston at the smithy.','Ask for Marie Holdston at the smithy.',26124),
(52062,'enUS','Craig Nollward works the inn\'s kitchen. He\'ll be able to help you.','Craig Nollward works the inn\'s kitchen. He\'ll be able to help you.',26124),
(52063,'enUS','Enchanting','Enchanting',26124),
(52064,'enUS','Lissah Spellwick, at the top of mage tower, is the mistress of Lady Jaina\'s enchanters.','Lissah Spellwick, at the top of mage tower, is the mistress of Lady Jaina\'s enchanters.',26124),
(52065,'enUS','Look for Caz Twosprocket at the smithy.','Look for Caz Twosprocket at the smithy.',26124),
(52066,'enUS','First Aid','First Aid',26124),
(52067,'enUS','Doctor Gustaf VanHowzen works on the ground level of the barracks.','Doctor Gustaf VanHowzen works on the ground level of the barracks.',26124),
(52068,'enUS','Michael Crowe, down by the docks, can teach you anything you need to know about catching and gutting fish.','Michael Crowe, down by the docks, can teach you anything you need to know about catching and gutting fish.',26124),
(52069,'enUS','Look for Theoden Manners at the top of Lady Proudmoore\'s tower.','Look for Theoden Manners at the top of Lady Proudmoore\'s tower.',26124),
(52070,'enUS','I\'m certain that one of the visiting Woolybush dwarves is a jewelcrafter.\n\nI believe it\'s the husband, Ingo. They\'re both explorers of some sort. Look for them in the inn.','I\'m certain that one of the visiting Woolybush dwarves is a jewelcrafter.\n\nI believe it\'s the husband, Ingo. They\'re both explorers of some sort. Look for them in the inn.',26124),
(52071,'enUS','Leatherworking','Leatherworking',26124),
(52072,'enUS','Seek out the Tanwell brothers in Theramore\'s inn. One of them will be able to help you.','Seek out the Tanwell brothers in Theramore\'s inn. One of them will be able to help you.',26124),
(52073,'enUS','Hisss word, FILLS me, MY BLOOD IS VENOM, AND YOU WILL BATHE IN THE GLORY OF THE SNAKE GOD!!!','',26124),
(52074,'enUS','Look out for the dwarf, Kerik, outside Theramore\'s smithy.\n\nHe\'s a drunkard and a bit free with the explosives, but he\'s friendly enough and knows his way around a mine.','Look out for the dwarf, Kerik, outside Theramore\'s smithy.\n\nHe\'s a drunkard and a bit free with the explosives, but he\'s friendly enough and knows his way around a mine.',26124),
(52075,'enUS','You\'ll want to find Sansha MacVince, just outside Theramore\'s stables.','You\'ll want to find Sansha MacVince, just outside Theramore\'s stables.',26124),
(52076,'enUS','Skinning','Skinning',26124),
(52077,'enUS','Tailoring','Tailoring',26124),
(52078,'enUS','Timothy Worthington works out of the second floor of one of Theramore\'s larger buildings. He\'ll do you right.','Timothy Worthington works out of the second floor of one of Theramore\'s larger buildings. He\'ll do you right.',26124),
(52079,'enUS','Follow me, mortal. The rift is near.','Follow me, mortal. The rift is near.',26124),
(52080,'enUS','Which way should we go?','Which way should we go?',26124),
(52081,'enUS','A Sentry approaches! Hide yourself, quickly!!','A Sentry approaches! Hide yourself, quickly!!',26124),
(52082,'enUS','Well done, my lady. I will have the intruder disposed of at once.','Well done, my lady. I will have the intruder disposed of at once.',26124),
(52083,'enUS','As you wish.','As you wish.',26124),
(52084,'enUS','|TInterface\\Icons\\ability_mage_worldinflames.blp:20|t%s begins to cast |cFFFF6600|Hspell:99171|h[Engulfing Flames]|h|r!','',26124),
(52085,'enUS','Quickly! Make your way across the chasm.','Quickly! Make your way across the chasm.',26124),
(52086,'enUS','I\'ll handle this one. See if you can find any others. ','I\'ll handle this one. See if you can find any others. ',26124),
(52087,'enUS','I am an orc of medicine, $r. If you have come here to learn, I shall do my best to teach.','',26124),
(52088,'enUS','I require training, Krenk.','I require training, Krenk.',26124),
(52089,'enUS','Hostile behaviour detected. Activating security protocol 11-b.','Hostile behaviour detected. Activating security protocol 11-b.',26124),
(52090,'enUS','Aaugh! We cannot afford this delay!','Aaugh! We cannot afford this delay!',26124),
(52091,'enUS','I am ready.','I am ready.',26124),
(52093,'enUS','','Thank you!',26124),
(52094,'enUS','','These are delicious!',26124),
(52095,'enUS','','I was getting so hungry...',26124),
(52096,'enUS','','That meat smells so good.',26124),
(52097,'enUS','','Ribs, my favorite!',26124),
(52098,'enUS','','Where do I go for seconds?',26124),
(52099,'enUS','Clever fleshling... soaring in-between the winds of fate. Yes, I know the one you seek... the orc-father... Earthbinder...$b$bI sense him nearby - raging within a tempest of his own fear. You may go to him... at your peril.','',26124),
(52100,'enUS','','We\'ve found him! But this tempest he\'s become... I\'ll try to calm it - to reach him somehow. ',26124),
(52101,'enUS','FAILED. I have failed this world...$b$bThe elements... will not speak to me. The Earthen Ring... has lost faith in my leadership. My weakness... has delivered Azeroth... into oblivion....','',26124),
(52102,'enUS','','Go\'el, it\'s me - Aggra! Don\'t you know me?',26124),
(52103,'enUS','Oblivion... nothing... but oblivion...','',26124),
(52104,'enUS','','He\'s too far gone! We have to keep trying!',26124),
(52105,'enUS','I have... failed the Horde... as Warchief...$b$bGarrosh... will lead it to ruin...$b$bMy people... to ruin. Cairne, my brother... why did I not listen?','',26124),
(52106,'enUS','','You did what you thought best, Go\'el! Fight these doubts! They\'re devouring your heart!',26124),
(52107,'enUS','Why did I not listen?','',26124),
(52108,'enUS','','Brace yourself, $n!',26124),
(52109,'enUS','I know your face... Aggra! Oh, my heart - can\'t you see? I am... nothing. Selfish... all I\'ve done... accomplished... all for the sake of pride alone. I am... unworthy of you...','',26124),
(52110,'enUS','','You are Go\'el, Son of Durotan and Draka! Rightful Warchief of the Horde! You are the orc who won my heart. Remember WHO YOU ARE!',26124),
(52111,'enUS','Aggra... it IS you...','',26124),
(52112,'enUS','','Be still, my love. Calm your mind. You became a slave to your duty. But being true to your heart is how you\'ll fulfill that duty... to your people... and to me.',26124),
(52113,'enUS','Aggra, I... I can\'t hold on... AAH!','',26124),
(52114,'enUS','|TInterface\\Icons\\spell_fire_ragnaros_splittingblow.blp:20|t%s begins to cast |cFFFF0000|Hspell:98951|h[Splitting Blow]|h|r!','',26124),
(52115,'enUS','|TInterface\\Icons\\spell_fire_selfdestruct.blp:20|t%s casts |cFFFF6600|Hspell:98164|h[Magma Trap]|h|r!','',26124),
(52116,'enUS','I am sorry, traveler, I have nothing to offer you.','',26124),
(52117,'enUS','At last, we have arrived!','At last, we have arrived!',26124),
(52118,'enUS','Defend yourself, friend. Our attackers are formidable.','Defend yourself, friend. Our attackers are formidable.',26124),
(52119,'enUS','Aren\'t you tricky? I have a few tricks of my own...','',26124),
(52120,'enUS','You pose no threat, lesser beings! Give me your worst!','',26124),
(52121,'enUS','Careful! Avoid his breath at all costs!','Careful! Avoid his breath at all costs!',26124),
(52122,'enUS','I\'ve destroyed his shield, unleash your power now!','I\'ve destroyed his shield, unleash your power now!',26124),
(52123,'enUS','Be filled with my power!','Be filled with my power!',26124),
(52124,'enUS','Accept the blessing of the blue dragonflight!\n','Accept the blessing of the blue dragonflight!\n',26124),
(52125,'enUS','|TInterface\\Icons\\spell_shaman_lavasurge.blp:20|t%s begins to cast |cFFFF0000|Hspell:98710|h[Sulfuras Smash]|h|r!','',26124),
(52126,'enUS','The winds are strange today. Strange indeed.','',26124),
(52127,'enUS','I am ready, elemental. Take me to Thrall.','I am ready, elemental. Take me to Thrall.',26124),
(52128,'enUS','%s has fallen!','%s has fallen!',26124),
(52129,'enUS','You desert us, then have the gall to speak to me, $n?$b$bYou are either very foolish, or very brave.  Based on your past actions though, I would say foolish.  $b$bSpeak to me in a little while, I\'ve got a camp to defend.','',26124),
(52130,'enUS','The deserter...$b$bWhat do you want, $c?  We are busy defending our camp and don\'t have time for cowards.$b$bSpeak to me when my temper subsides.','',26124),
(52131,'enUS','The Gurubashi attackers just keep streaming in! We\'ve been pinned down here and haven\'t received word from the outlying outposts in days.','',26124),
(52133,'enUS','%s devours the fish.','',26124),
(52134,'enUS','Oh, look you... dead.','',26124),
(52135,'enUS','By th\' Light, it worked! Grimnur\'s brilliant... oh, I hope all the pinchin\' didn\'t hurt ye too much... But when ye taste the meat, ye\'ll know it\'s worth it!','',26124),
(52136,'enUS','Hmph... quitter.','Hmph... quitter.',26124),
(52137,'enUS','Beer an\' haggis, now that\'ll put hair on yer chest!','',26124),
(52138,'enUS','How did ye know me favorite meal?','',26124),
(52139,'enUS','Haggis fer breakfast, haggis fer lunch, and a sensible haggis dinner!','',26124),
(52140,'enUS','Keep bringing me food like this an\' ye\'ll be me new best friend!','',26124),
(52141,'enUS','Thank ye!','',26124),
(52142,'enUS','Give me thanks to Daryl, will ye?','',26124),
(52143,'enUS','','Twilight minions in the Nexus...$b$bThese are desperate times, $r.',26124),
(52144,'enUS','','No. NO! Get out! Leave me here with the memory of my sister!',26124),
(52145,'enUS','','I told you to leave!',26124),
(52146,'enUS','','I am sworn to protect this place!',26124),
(52147,'enUS','','Ha! You are nothing but a plaything!',26124),
(52148,'enUS','','Share in my pain!',26124),
(52149,'enUS','','Feel me agony!',26124),
(52150,'enUS','','This body is useless!',26124),
(52151,'enUS','A soul fragment merges souls with the Harbinger of Darkness!','A soul fragment merges souls with the Harbinger of Darkness!',26124),
(52152,'enUS','Die!','',26124),
(52153,'enUS','There ye are! I was startin\' to think ye\'d made off with the beer!','',26124),
(52154,'enUS','Yoo hoo!  I am here to slay Sylvanas!','Yoo hoo!  I am here to slay Sylvanas!',26124),
(52155,'enUS','Hey, look, there are people here.  Nothing at all like that tree city that I, a night elf, live in.','Hey, look, there are people here.  Nothing at all like that tree city that I, a night elf, live in.',26124),
(52156,'enUS','I\'m so angry that we lost Wintergrasp, again!  I will try to kill your leader, the all powerful, Sylvanas, instead.','I\'m so angry that we lost Wintergrasp, again!  I will try to kill your leader, the all powerful, Sylvanas, instead.',26124),
(52157,'enUS','Our loss in Tol Barad will be avenged!  I will try to bring death to this grand city.  Cower as I try to remember a battle cry!','Our loss in Tol Barad will be avenged!  I will try to bring death to this grand city.  Cower as I try to remember a battle cry!',26124),
(52158,'enUS','Tremble in fear you mighty members of the Horde, the Alliance is here!','Tremble in fear you mighty members of the Horde, the Alliance is here!',26124),
(52159,'enUS','Where am I?  I crashed with the Exodar and now stumbled into this imposing city...','Where am I?  I crashed with the Exodar and now stumbled into this imposing city...',26124),
(52160,'enUS','This city is so big, to me, a tiny, pathetic gnome.','This city is so big, to me, a tiny, pathetic gnome.',26124),
(52161,'enUS','I am drunk, like many of my fellow dwarves.  I\'ve dug a tunnel and wound up here.  Who wants to drink?','I am drunk, like many of my fellow dwarves.  I\'ve dug a tunnel and wound up here.  Who wants to drink?',26124),
(52162,'enUS','Can I have another Decoy Kit?','Can I have another Decoy Kit?',26124),
(52163,'enUS','Can I have more Bloated Frogs?','Can I have more Bloated Frogs?',26124),
(52164,'enUS','Aren\'t you worried about what\'s IN that?','Aren\'t you worried about what\'s IN that?',26124),
(52165,'enUS','Not at all! If my gut could take three years of the Razor Hill barrack\'s Stinky Cactus Grub Soup, a bowl of roaches isn\'t going to kill me.','Not at all! If my gut could take three years of the Razor Hill barrack\'s Stinky Cactus Grub Soup, a bowl of roaches isn\'t going to kill me.',26124),
(52166,'enUS','Roaches?! They wouldn\'t! Would they...? That\'s disgusting.','Roaches?! They wouldn\'t! Would they...? That\'s disgusting.',26124),
(52167,'enUS','HAH HAH HAH! Enjoy your stale rations, then. This slop\'s delicious.','HAH HAH HAH! Enjoy your stale rations, then. This slop\'s delicious.',26124),
(52168,'enUS','A wise choice. I\'d have selected that one myself.','A wise choice. I\'d have selected that one myself.',26124),
(52169,'enUS','You\'ve a good eye for ingredients.','You\'ve a good eye for ingredients.',26124),
(52170,'enUS','Picking that up for Aska? She\'ll be pleased with your choice.','Picking that up for Aska? She\'ll be pleased with your choice.',26124),
(52171,'enUS','That one? Well done. It\'s the best here.','That one? Well done. It\'s the best here.',26124),
(52172,'enUS','Well-picked. I\'m sure Aska will be satisfied.','Well-picked. I\'m sure Aska will be satisfied.',26124),
(52173,'enUS','Only the very best, hmmm?','Only the very best, hmmm?',26124),
(52174,'enUS','You\'re here for Aska\'s order, then? Please tell her I said hello.','You\'re here for Aska\'s order, then? Please tell her I said hello.',26124),
(52175,'enUS','Were you going to pay for that? Oh, it\'s for Aska! Take care, then.','Were you going to pay for that? Oh, it\'s for Aska! Take care, then.',26124),
(52176,'enUS','The Moat Monster submerges.','The Moat Monster submerges.',26124),
(52177,'enUS','You have been judged.','',26124),
(52178,'enUS','Behold your weakness.','',26124),
(52179,'enUS','None shall pass!','',26124),
(52180,'enUS','You are forbidden from my master\'s domain, mortals.','',26124),
(52181,'enUS','Burn beneath my molten fury!','',26124),
(52182,'enUS','By the Firelord\'s command, you, too, shall perish!','',26124),
(52183,'enUS','Your flesh is forfeit to the fires of this realm.','',26124),
(52184,'enUS','%s retreats and calls for the protection of his allies!','',26124),
(52185,'enUS','Fool mortals. Hurl yourselves into your own demise!','',26124),
(52186,'enUS','Its purgin time!','',26124),
(52189,'enUS','','Look there - a vision within the torrent! Is this what Go\'el longed for most? Peace with his enemies - an end to the constant warring of his world?',26124),
(52190,'enUS','','He... wished to lay down his weapon... and the burdens of leadership...',26124),
(52191,'enUS','','Another vision! I see Go\'el, but... it... it\'s me. Was I his deepest desire? A mate with which to share his life... his burdens and his joys?',26124),
(52192,'enUS','','A final vision! Ancestors... could those be... our children? This was his deepest desire... to be a father?',26124),
(52193,'enUS','','...to have a family of his own... with me? Go\'el never knew his parents... It was only a few years ago that he even found his people... I should have known this was what he wanted most.',26124),
(52194,'enUS','','Ancestors, give me strength! The vortex\'s pull is increasing! It\'s pulling me in! The power of his longing... it\'s overwhelming!',26124),
(52195,'enUS','Very well. Witness the raw power of my new Lord!','',26124),
(52196,'enUS','','Find and release Aggra before she gets pulled into the whirlpool!',26124),
(52197,'enUS','You\'ve done the impossible, shaman. You have stilled the vortex within him without losing yourself, in turn. Your love for him... must be very great. ','',26124),
(52198,'enUS','','I need... the world... needs him whole once again. But he\'s always placed the needs of others before his own. How long has he suppressed these feelings - these desires?',26124),
(52199,'enUS','His aspect shifts once again! You are losing him!','',26124),
(52200,'enUS','','Go\'el!',26124),
(52201,'enUS','','Hurry, mortal.$b$bMeet me inside the Nexus!',26124),
(52202,'enUS','%s begins to channel a massive Shadow Nova!','%s begins to channel a massive Shadow Nova!',26124),
(52203,'enUS','Mortal Insects! You dare trespass into MY domain?  Your arrogance will be purged in living flame.','',26124),
(52204,'enUS','Die, insect!','',26124),
(52205,'enUS','Pathetic.','',26124),
(52206,'enUS','This is MY realm!','',26124),
(52207,'enUS','Come forth, my servants! Defend your master!','',26124),
(52208,'enUS','Minions of fire! Purge the outsiders!','',26124),
(52209,'enUS','Denizens of flame, come to me!','',26124),
(52210,'enUS','Arise, servants of fire, consume their flesh!','',26124),
(52211,'enUS','By fire be purged!','',26124),
(52212,'enUS','You will be crushed!','',26124),
(52213,'enUS','Die!','',26124),
(52214,'enUS','Your judgment has come!','',26124),
(52215,'enUS','Enough! I will finish this.','',26124),
(52216,'enUS','Fall to your knees, mortals!  This ends now.','',26124),
(52217,'enUS','Sulfuras will be your end.','',26124),
(52218,'enUS','Too soon! ... You have come too soon...','',26124),
(52219,'enUS','Too soon...','',26124),
(52220,'enUS','Arrggh, outsiders - this is not your realm!','',26124),
(52221,'enUS','When I finish this, your pathetic mortal world will burn with my vengeance!','',26124),
(52222,'enUS','No, noooo- This was to be my hour of triumph...','',26124),
(52223,'enUS','','Do not worry. I will keep the Crimson Lasher safe with me. Until we learn more about its behavior, I\'m afraid it must stay here in the Firelands.',26124),
(52224,'enUS','','Such a unique specimen! So many possibilities! I must devote myself harder to the study of the local flora and fauna.',26124),
(52225,'enUS','','While I am buried in research, it will be up to you to teach the Lasher the ways of the world.',26124),
(52226,'enUS','','You shall not have him!',26124),
(52227,'enUS','%s is regenerating. Dispel his Twilight Restoration spell!','%s is regenerating. Dispel his Twilight Restoration spell!',26124),
(52228,'enUS','','Hurry! You must save Aggra before she is pulled into the vortex!',26124),
(52229,'enUS','Hah? Hruumph? Soft little fleshy-things? Here? Nuisances, nuisances!','',26124),
(52230,'enUS','Finished.','',26124),
(52231,'enUS','So soft!','',26124),
(52232,'enUS','Squeak, little pest.','',26124),
(52233,'enUS','Oww now hey.','',26124),
(52234,'enUS','Graaahh!','',26124),
(52235,'enUS','Augh - smooshy little pests, look what you\'ve done!','',26124),
(52236,'enUS','Uurrghh now you... you infuriate me!','',26124),
(52237,'enUS','Oh you little beasts...','',26124),
(52238,'enUS','Stomp now.','',26124),
(52239,'enUS','I\'ll crush you underfoot!','',26124),
(52240,'enUS','Eons I have slept undisturbed... Now this... Creatures of flesh, now you will BURN!','',26124),
(52241,'enUS','Buuurrrnn!','',26124),
(52242,'enUS','Succumb to living flame.','',26124),
(52243,'enUS','My inner fire can never die.','',26124),
(52244,'enUS','Consume...','',26124),
(52245,'enUS','Flesh... burns!','',26124),
(52246,'enUS','Broken. Mnngghhh... broken...','',26124),
(52247,'enUS','Crush, crush... crush.','',26124),
(52248,'enUS','Sear the flesh from their tiny frames.','',26124),
(52249,'enUS','Shatter the bones!','',26124),
(52250,'enUS','Stomp and burn, stomp and burn. ','',26124),
(52251,'enUS','Yes, mortal?','',26124),
(52252,'enUS','What occasion brings you to our home town, drake?','What occasion brings you to our home town, drake?',26124),
(52253,'enUS','Kalecgos has been chosen as the new aspect for the blue dragonflight.$b$bOne among you was instrumental in thwarting Arygos\'s betrayal to Deathwing, thereby averting a terrible crisis.$b$bWe are here to partake in the celebration of their heroic deeds.','',26124),
(52258,'enUS','You may go to him... at your peril.','',26124),
(52259,'enUS','','Do you think it will work, Go\'el? The druids and shaman uniting to restore the World Tree... Could it actually heal this broken world?',26124),
(52260,'enUS','','Lady Ysera.',26124),
(52261,'enUS','','Go\'el! NO!',26124),
(52262,'enUS','','But what of Go\'el?',26124),
(52263,'enUS','','No! Those mongrels have stolen my Go\'el, but I will NOT forsake him. Ancestors forgive me - my heart feels stolen away with him.',26124),
(52264,'enUS','The Aspects believe it will. And they should know...','',26124),
(52265,'enUS','...They grew it in the first place.','',26124),
(52266,'enUS','Master Stormrage. It\'s good to have you back in the waking world.','',26124),
(52267,'enUS','The Twilight\'s Hammer!','',26124),
(52268,'enUS','I do not fear death.','',26124),
(52269,'enUS','','Welcome, Son of Durotan. And to you, Aggralan of the Frostwolves.',26124),
(52270,'enUS','','Friends, we have gathered here today to heal this world that we\'ve sacrificed so much to save.',26124),
(52271,'enUS','','He was the Earthen Ring\'s most powerful shaman, and the ceremony cannot continue without him. But we must be prepared to accept that he may be lost forever...',26124),
(52272,'enUS','Greetings, friends.','',26124),
(52273,'enUS','I sense a vast power has grown within you, young Thrall. You\'ve achieved much, since last we met.','',26124),
(52274,'enUS','You\'ll regret this, stranger!','',26124),
(52275,'enUS','Fandral - what have they done to you?','',26124),
(52276,'enUS','Fandral is corrupting fellow druids into something sinister. He may have other followers already - I must warn Moonglade.','',26124),
(52277,'enUS','Time is precious, sister. Let us see to our ritual...','',26124),
(52278,'enUS','I\'m sorry, are we interrupting?','',26124),
(52279,'enUS','Not so fast, Son of Durotan! You and your allies have certainly set us back, but the Hour of Twilight CANNOT be averted!','',26124),
(52280,'enUS','Death? Who said anything about death?','',26124),
(52281,'enUS','You may be this world\'s greatest shaman, Thrall - but you are only mortal. This is my master\'s curse upon you - turning your great bond with the elements... into your undoing!\n','',26124),
(52282,'enUS','Will I?\n','',26124),
(52283,'enUS','Come, shan\'do - certainly you recognize your former pupil?','',26124),
(52284,'enUS','Naive as always, I see. Your pet orc cannot save you now, Malfurion.','',26124),
(52286,'enUS','','Hear me, Go\'el! You ARE NOT alone! I\'m here with you - I will NOT let you go! ',26124),
(52287,'enUS','','Oh, Go\'el, hold on! I WILL free you! And you\'ll HAVE this life, I swear it! ',26124),
(52288,'enUS','','He must embrace them and find balance... or this curse will never end. ',26124),
(52289,'enUS','','Fight this, Go\'el! You\'ve got to snap out of it!',26124),
(52290,'enUS','The Twilight Prophet knows that YOU - and you alone - are our final obstacle. He\'s sent ME to remove you from the game.','',26124),
(52291,'enUS','Even now, the elements are tearing you apart - and they shall feed upon your doubts and fears \'til the last spark of life on this wretched world has been snuffed out.','',26124),
(52292,'enUS','And the flame of our vengeance draws near. Be ready.','',26124),
(52293,'enUS','','For the first time, the Earthen Ring and the Cenarion Circle will unite - to restore this great Tree - thereby healing the whole of Azeroth.',26124),
(52298,'enUS','Can...can anyone help me?','Can...can anyone help me?',26124),
(52299,'enUS','I don\'t feel so good...','I don\'t feel so good...',26124),
(52300,'enUS','','There\'s too many of them! I don\'t know how long we can hold out! Go\'el, now would be a good time to wake up!',26124),
(52301,'enUS','We are patient.','',26124),
(52302,'enUS','','Did he just...? Go\'el, can you hear me? We need your help! Do something!',26124),
(52303,'enUS','','GO\'EL! Pull it together or we\'re all going to DIE!',26124),
(52304,'enUS','We are patient.','',26124),
(52305,'enUS','','He did NOT just say that!',26124),
(52306,'enUS','','Damn you, Go\'el - WAKE UP! Don\'t let it end like this! We\'ve come too far to fail now!',26124),
(52307,'enUS','We are patient.','',26124),
(52308,'enUS','','Oh, don\'t you tell ME to be patient, you green-skinned...',26124),
(52309,'enUS','NOW. AWAKEN.','',26124),
(52310,'enUS','Aggra... I heard your voice... calling me back...$b$bWhere are we?','',26124),
(52311,'enUS','','You\'re almost home, my love. Our time is so brief. You will change again, Go\'el - but I will find you! I\'ll NEVER give up on you!',26124),
(52312,'enUS','Aggra? Aggra! I can\'t hear-','',26124),
(52313,'enUS','The Molten Eggs begin to hatch!','',26124),
(52314,'enUS','','Alysrazor begins to fly in a rapid circle!  The harsh winds will remove Wings of Flame!',26124),
(52315,'enUS','|TInterface\\Icons\\ability_mage_firestarter.blp:20|t The harsh winds form a |cFFFF0000|Hspell:99794|h[Fiery Vortex]|h|r!','|TInterface\\Icons\\ability_mage_firestarter.blp:20|t The harsh winds form a |cFFFF0000|Hspell:99794|h[Fiery Vortex]|h|r!',26124),
(52316,'enUS','','|TInterface\\Icons\\spell_holiday_tow_spicecloud.blp:20|t Alysrazor\'s fire |cFFFF0000|Hspell:99432|h[Burns Out]|h|r!',26124),
(52317,'enUS','','|TInterface\\Icons\\inv_elemental_primal_fire.blp:20|t Alysrazor\'s firey core |cFFFF0000|Hspell:99922|h[Re-Ignites]|h|r!',26124),
(52318,'enUS','','|TInterface\\Icons\\spell_shaman_improvedfirenova.blp:20|t Alysrazor is at |cFFFF0000|Hspell:99925|h[Full Power]|h|r!',26124),
(52319,'enUS','','I serve a new master now, mortals!',26124),
(52320,'enUS','','BURN!',26124),
(52321,'enUS','','For his glory!',26124),
(52322,'enUS','','These skies are MINE!',26124),
(52323,'enUS','','I will burn you from the sky!',26124),
(52324,'enUS','','Fire...fire...',26124),
(52325,'enUS','','Reborn in flame!',26124),
(52326,'enUS','','The light...mustn\'t burn out...',26124),
(52327,'enUS','Together we call upon the lord of fire!','Together we call upon the lord of fire!',26124),
(52328,'enUS','We call upon you, Firelord!','',26124),
(52329,'enUS','Behold His power!','',26124),
(52330,'enUS','Witness the majesty of flame!','',26124),
(52331,'enUS','None escape the rage of the Firelands!','',26124),
(52332,'enUS','','We call upon you, Firelord!',26124),
(52333,'enUS','','Behold His power!',26124),
(52334,'enUS','','Let the unbelievers perish in fire!',26124),
(52335,'enUS','','<The Shadow Warden looks at you silently.>',26124),
(52336,'enUS','Have you ever seen anything like it? ','Have you ever seen anything like it?',26124),
(52337,'enUS','The earth beneath our feet groans and shudders. Fire rains down from the sky. The air chokes away all life. This is truly the realm of the Fire Lord.','',26124),
(52338,'enUS','','We cannot rest yet, my child. Hyjal still stands, but if we falter on the Fire Lord\'s doorstep, all may still be lost. Let the strength of the ancients be with us.',26124),
(52339,'enUS','','Our Storm Crows struggle to fly in this high density air, but the fire hawks on that ridge seem to soar with ease.$B$BThey are as wild as any of the creatures in the Plane of Fire, yet there is beauty in their form.',26124),
(52340,'enUS','With time, we may be able to restore this land.','',26124),
(52341,'enUS','We are just barely holding our ground. We need every able-bodied soldier to report for duty.','',26124),
(52342,'enUS','','What is war, but the preservation of life? Just as the seed struggles to push out of the soil, so do we fight for our own existence.',26124),
(52343,'enUS','','Uh-oh, you have something on your face!',26124),
(52344,'enUS','','Will we win this war? Only thyme will tell.',26124),
(52345,'enUS','','It\'s sweltering down here. Did someone tell them to turnip the heat?',26124),
(52346,'enUS','Alysrazor is unable to fully re-ignite!  Kill her quickly!','Alysrazor is unable to fully re-ignite!  Kill her quickly!',26124),
(52347,'enUS','','I like you! Weed make anise pear.',26124),
(52348,'enUS','','Some people say I\'m corny, but I think I\'m rather sage.',26124),
(52349,'enUS','','Oh, it\'s you again! Do you think we\'ll be able to mustard up the forces we need?',26124),
(52351,'enUS','Never have I seen such a barren wasteland.','',26124),
(52352,'enUS','We stand in the heart of Beth\'tilac\'s breeding ground. Beyond those pillars to the north, her brood awaits. They will defend her young relentlessly.','',26124),
(52353,'enUS','','Any questions you have about the Wardens can be answered on the field of battle.',26124),
(52354,'enUS','','What are the Wardens? We are the precision slice of a killing blow.',26124),
(52355,'enUS','','What are the Wardens? We are the hum of a spinning blade in the moment before death.',26124),
(52356,'enUS','','What are the Wardens? We are the silence in the shadows.',26124),
(52357,'enUS','How are we doing in the battle?','How are we doing in the battle?',26124),
(52359,'enUS','We gave up much to attain this foothold, and we must continue fighting to keep it. Although our defenses are weak, continued efforts to push forward will help us recruit stronger allies in the future.$B$BThe time for courage is now, champion.','',26124),
(52360,'enUS','We have managed to defend this point, and much of it is thanks to you.$B$BYou have managed to recruit a valuable ally to our ranks, however, the enemy continues to assail us without relent.$B$BWe must hold our ground or lose what we have fought so hard to gain.','',26124),
(52361,'enUS','Through your efforts, you have brought both the Shadow Wardens and the Druids of the Talon to our side.$B$BExcellent work, $c.$B$BWe are gaining ground, but much work still remains.$B$BAs the enemy assails us, we must continue to build up our defenses. We require three things, $n.$B$BElderlimb and the Ancient Protectors watch over Hyjal, but their strength would be invaluable here.$B$BAs stalwart as our courage, our armory needs additional military supplies.$B$BFinally, the strength of Elune\'s calming waters will heal and rejuvenate our tired soldiers.$B$BWe need these things before our work here is complete.$B$BGo, $n. Your efforts are crucial to our victory.','',26124),
(52362,'enUS','You have done well, $c. Our presence here can no longer be unnoticed by Ragnaros. We are an essential thorn in his side. As his rage grows, so must we continue to press forward.$B$BWe must stay ever vigilant here, but it is time to cast our eyes upon the final battle. It is time to face the Lord of Fire himself.','',26124),
(52363,'enUS','','Look with your eyes. What do you see? What do you feel?',26124),
(52364,'enUS','Winds of Aviana, grant me the strength to keep the flames at bay.','',26124),
(52366,'enUS','','While we prepare to invade the Firelands, the Firelord sends his minions to repel our attack. Our position here cannot fall. We are all that stands between them and the World Tree.',26124),
(52367,'enUS','','Welcome, $n. Have you come to join the invasion of the Firelands?',26124),
(52368,'enUS','','We do not yet have the strength to push forward into the Firelands. First, we must rebuild our forces and supplies. Will you lend yourself to our efforts?',26124),
(52369,'enUS','','What happens now will affect us all. Everyone\'s aid is needed. We must work together to fight against the invasion.',26124),
(52370,'enUS','','Are there any teeny tiny animals in need of my aid?$B$B<Mylune\'s eyes glisten at the thought.>$B$BI need to hug a bunny right now!',26124),
(52371,'enUS','','How are the preparations going?',26124),
(52372,'enUS','Yes? The Archdruid is resting.$B$BI am sure he appreciates your visit, but it is best not to disturb him.','',26124),
(52373,'enUS','How is Hamuul doing?','How is Hamuul doing?',26124),
(52374,'enUS','It is difficult to say. His injuries are grievous. Even though he is a powerful druid, it will take time and patience to restore him back to full health.','',26124),
(52376,'enUS','','Hello, $n. Are you helping with the invasion? A skilled $c such as yourself will be a valuable addition to our force.',26124),
(52377,'enUS','I need someone who can get the job done. Can I count on you, $c?','',26124),
(52378,'enUS','Greetings, mage.  Shall I provide you with further insight into the world of magic?','Greetings, mage.  Shall I provide you with further insight into the world of magic?',26124),
(52379,'enUS','Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.','Well met, $c.  My advice to you is this: As you travel the world, be wary of magic for it will burn the untrained.',26124),
(52380,'enUS','I have no time for a sermon now, $c. Seek your knowledge elsewhere.','I have no time for a sermon now, $c. Seek your knowledge elsewhere.',26124),
(52381,'enUS','The Light gives us the strength and magic to triumph.','The Light gives us the strength and magic to triumph.',26124),
(52382,'enUS','I can sense your desire for power, $c.','I can sense your desire for power, $c.',26124),
(52383,'enUS','I apologize, $c. I mistook you for someone with a spine. Begone; our secrets are not for untrained ears.','I apologize, $c. I mistook you for someone with a spine. Begone; our secrets are not for untrained ears.',26124),
(52384,'enUS','We can run no longer. It is time to stand and fight.','',26124),
(52385,'enUS','Do you prefer guns or bows?','Do you prefer guns or bows?',26124),
(52386,'enUS','I train only warriors, $c. You\'ll have to look elsewhere.','I train only warriors, $c. You\'ll have to look elsewhere.',26124),
(52387,'enUS','Are you ready to train, warrior?','Are you ready to train, warrior?',26124),
(52388,'enUS','Ours is a path for those with an iron will and unfaltering resolve. You seem to possess none of these traits, $c.','Ours is a path for those with an iron will and unfaltering resolve. You seem to possess none of these traits, $c.',26124),
(52389,'enUS','You seek further instruction, $n?','You seek further instruction, $n?',26124),
(52390,'enUS','$n, how may I further your training?','$n, how may I further your training?',26124),
(52391,'enUS','If you seek training, I cannot help you.','If you seek training, I cannot help you.',26124),
(52392,'enUS','It appears you took a wrong turn, $c.','It appears you took a wrong turn, $c.',26124),
(52393,'enUS','Greetings, $n. You were not followed here, I trust?','Greetings, $n. You were not followed here, I trust?',26124),
(52394,'enUS','','Nothing says \"Hallow\'s End is here\" more than a ride on a broomstick.',26124),
(52400,'enUS','','Hello there! Plants are my speciality. Do you have an inquiry about the local flora?',26124),
(52401,'enUS','','There\'s nothing more inspiring than a flower in bloom!',26124),
(52408,'enUS','Kneel before the burning flame!','',26124),
(52409,'enUS','','My Go\'el... consumed by the sea. Tormented by his own desires!',26124),
(52410,'enUS','','The cycle begins again! Go\'el has become living stone! We must pursue him within the caverns of Deepholm.$b$bSeeing as how the Earthen Ring just saved her kingdom, Therazane should be more than willing to help us in saving him. If not, the Stonemother will answer to me!',26124),
(52411,'enUS','Begone from my realm, insects.','',26124),
(52412,'enUS','I will see you all burn.','',26124),
(52413,'enUS','Be consumed by flame!','',26124),
(52414,'enUS','The realm of fire will consume you!','',26124),
(52415,'enUS','Well, well. I admire your tenacity. Baleroc stood guard over this keep for a thousand mortal lifetimes.','',26124),
(52416,'enUS','But none may enter the Firelord\'s abode!','',26124),
(52417,'enUS','Beg for mercy now, and I may yet allow you to live. Well, \"heroes?\" What is your answer?','',26124),
(52418,'enUS','Burn.','',26124),
(52419,'enUS','Soon ALL of Azeroth will burn!','',26124),
(52420,'enUS','So much power!','',26124),
(52421,'enUS','You stood in the fire!','',26124),
(52422,'enUS','Nothing but ash!','',26124),
(52423,'enUS','','Yes, mortals, your Thrall is here. He has fused with the stone of this place - heart and soul.',26124),
(52424,'enUS','','His spirit is strong for a creature of mortal flesh. He fascinates me... and I am loathe to give him up.',26124),
(52425,'enUS','','Still, I can hear the cry of a distant heart, echoing through the labyrinths between worlds. It\'s the cry of a lover\'s heart, I hear... and Great Therazane has not forgotten what it was to love...',26124),
(52426,'enUS','','Your world-shaman stands in the basalt-groves below. But take heed - he has become one with these Unending Halls of Stone.',26124),
(52427,'enUS','Blaze of Glory!','',26124),
(52428,'enUS','','He may not wish to leave, regardless of whose heart beckons him home.',26124),
(52429,'enUS','','You may seek him... with my blessing.',26124),
(52430,'enUS','The master\'s power takes on many forms...','',26124),
(52431,'enUS','Behold the rage of the Firelands!','',26124),
(52432,'enUS','My studies... had only just begun...','',26124),
(52433,'enUS','','Thank you, Stonemother.',26124),
(52434,'enUS','','Quickly, friend. Go\'el should be just below.',26124),
(52436,'enUS','','Ready yourselves, warriors. We ride into enemy territory.',26124),
(52437,'enUS','','Look sharp. These woods are crawling with lieutenants of fire.',26124),
(52438,'enUS','','Be vigilant, troops. A surprise attack could mean the difference between life and death.',26124),
(52439,'enUS','','These invaders must learn that our lands are not so easily taken. And I shall gladly administer the lesson.',26124),
(52440,'enUS','A-hah! The interlopers! Kill them. EAT THEM!','',26124),
(52441,'enUS','Ohh... the pain.  Lord of Fire, it hurts....','',26124),
(52442,'enUS','All right, troops. Look alive! Is everyone ready?','',26124),
(52443,'enUS','','Ready to go, captain.',26124),
(52444,'enUS','It\'s stomping time.','',26124),
(52445,'enUS','','On the prowl.',26124),
(52446,'enUS','','Yeah mon. Let\'s get dis show on da road.',26124),
(52447,'enUS','All right team, all systems are go! It\'s morphin\' time!','',26124),
(52448,'enUS','Now you stay dead!','',26124),
(52449,'enUS','The Firelord will be most pleased.','',26124),
(52450,'enUS','|TInterface\\Icons\\ability_mage_worldinflames.blp:20|t%s begins to cast |cFFFF6600|Hspell:100171|h[World In Flames]|h|r!','',26124),
(52451,'enUS','Dog food!','',26124),
(52452,'enUS','Fetch your supper!','',26124),
(52453,'enUS','Now you burn!','',26124),
(52454,'enUS','Riplimb! No... no! Oh, you terrible little beasts! How could you?!','',26124),
(52455,'enUS','Oh, you murderers! Why? Why would you kill such a noble animal?','',26124),
(52456,'enUS','Yes, I smell them too, Riplimb. Outsiders encroach on the Firelord\'s private grounds. Find their trail. Find them for me, that I may dispense punishment!','',26124),
(52457,'enUS','Twist in flames, interlopers!','',26124),
(52458,'enUS','Go for the throat!','',26124),
(52459,'enUS','','I be healin\', mon.  I don\'t have no special shape.',26124),
(52460,'enUS','','Can you feel the magic in the air, $c?',26124),
(52461,'enUS','Take your positions! We are ready to roll.','',26124),
(52462,'enUS','','Powerful magic fills the air this season, $c.',26124),
(52463,'enUS','I\'m ready to attack Stormwind!','I\'m ready to attack Stormwind!',26124),
(52464,'enUS','Good work, druids! This area looks secure. Let\'s head back to base.','',26124),
(52465,'enUS','Assume flight form in 3...','',26124),
(52466,'enUS','2...','',26124),
(52467,'enUS','1...','',26124),
(52468,'enUS','Storm crow, go!','',26124),
(52469,'enUS','Good work, team! Take a breather and report back soon.','',26124),
(52470,'enUS','','Fire. My love has become fire. I feared this. To find him again, we must enter Ragnaros\' burning domain.',26124),
(52471,'enUS','','Stay strong, friend. You know as well as I do - there\'ll be no help for us within the Firelands.',26124),
(52474,'enUS','The Alliance has assaulted the Draenei Ruins!','',26124),
(52475,'enUS','The Horde has assaulted the Draenei Ruins!','',26124),
(52476,'enUS','The Alliance has taken the Draenei Ruins!','',26124),
(52477,'enUS','The Horde has taken the Draenei Ruins!','',26124),
(52478,'enUS','The Alliance has defended the Draenei Ruins!','',26124),
(52479,'enUS','The Horde has defended the Draenei Ruins!','',26124),
(52480,'enUS','$n claims the Draenei Ruins!  If left unchallenged, the Alliance will control it in 1 minute!','',26124),
(52481,'enUS','$n claims the Draenei Ruins!  If left unchallenged, the Horde will control it in 1 minute!','',26124),
(52482,'enUS','$n has assaulted the Fel Reaver Ruins!','',26124),
(52483,'enUS','$n has assaulted the Fel Reaver Ruins!','',26124),
(52484,'enUS','|c00FF0000%s summons Burning Orbs!|r','',26124),
(52485,'enUS','The Alliance has taken the Fel Reaver Ruins!','',26124),
(52486,'enUS','The Horde has taken the Fel Reaver Ruins!','',26124),
(52487,'enUS','$n has defended the Fel Reaver Ruins!','',26124),
(52488,'enUS','$n has defended the Fel Reaver Ruins!','',26124),
(52489,'enUS','$n claims the Fel Reaver Ruins! If left unchallenged, the Alliance will control it in 1 minute!','',26124),
(52490,'enUS','$n claims the Fel Reaver Ruins! If left unchallenged, the Horde will control it in 1 minute!','',26124),
(52491,'enUS','|c00FF0000Searing Seeds begin to grow!|r','',26124),
(52492,'enUS','$n has assaulted the Mage Tower!','',26124),
(52493,'enUS','$n has assaulted the Mage Tower!','',26124),
(52494,'enUS','The Alliance has taken the Mage Tower!','',26124),
(52495,'enUS','The Horde has taken the Mage Tower!','',26124),
(52496,'enUS','$n has defended the Mage Tower!','',26124),
(52497,'enUS','$n has defended the Mage Tower!','',26124),
(52498,'enUS','$n claims the Mage Tower!  If left unchallenged, the Alliance will control it in 1 minute!','',26124),
(52499,'enUS','$n claims the Mage Tower! If left unchallenged, the Horde will control it in 1 minute!','',26124),
(52500,'enUS','$n has assaulted the Blood Elf Tower!','',26124),
(52501,'enUS','$n has assaulted the Blood Elf Tower!','',26124),
(52502,'enUS','The Alliance has taken the Blood Elf Tower!','',26124),
(52503,'enUS','The Horde has taken the Blood Elf Tower!','',26124),
(52504,'enUS','$n has defended the Blood Elf Tower!','',26124),
(52505,'enUS','$n has defended the Blood Elf Tower!','',26124),
(52506,'enUS','$n claims the Blood Elf Tower!  If left unchallenged, the Alliance will control it in 1 minute!','',26124),
(52507,'enUS','$n claims the Blood Elf Tower!  If left unchallenged, the Horde will control it in 1 minute!','',26124),
(52508,'enUS','Ready yourselves in 3...','',26124),
(52509,'enUS','Battle forms, go!','',26124),
(52511,'enUS','','Begone from these lands, invader!',26124),
(52512,'enUS','','I\'ve sharpened my claws just for this moment.',26124),
(52513,'enUS','','What big teeth I have? Why thank you.',26124),
(52514,'enUS','Taste the fury of my moonbeam!','',26124),
(52515,'enUS','Fire! Fire! Fire!','',26124),
(52516,'enUS','The very trees repel your presence!','',26124),
(52517,'enUS','','Return to da fire from whence ya came, ya ill one.',26124),
(52518,'enUS','','It don\'t mattah what you do heah, ravager. Da land will heal after you be dead.',26124),
(52519,'enUS','','Die! Let da fires consume ya once agin.',26124),
(52520,'enUS','I\'ll scare them off with my roar!','',26124),
(52521,'enUS','Charge!','',26124),
(52522,'enUS','Enemy sighting!','',26124),
(52523,'enUS','If you haven\'t run by now, it\'s too late!','',26124),
(52524,'enUS','Team druid, attack!','',26124),
(52525,'enUS','You come to join the fight, $c?','You come to join the fight, $c?',26124),
(52526,'enUS','','Ahhh $n, it be good to see ya once agin. Da threat to dese lands be grave, and I come to join da fight. I see ya grown in your own. Good. You mek me, an\' all your tribe, proud.',26124),
(52527,'enUS','The Branch of Nordrassil reacts violently to $n\'s touch!','The Branch of Nordrassil reacts violently to $n\'s touch!',26124),
(52528,'enUS','','$n, I am not surprised to see you here. I always thought you were my brightest pupil. I am honored to fight alongside you, my friend.',26124),
(52529,'enUS','$n, you look well. I heard the call to arms, which is why I\'ve left our home and come here to join the fight.$B$BI see you have grown much since we last met. I am honored to have taught you. You are a true hero of the Alliance.','',26124),
(52530,'enUS','Hello, $n. I heard the call to arms, so I\'ve temporarily taken up my fighting form. You have learned all that I have to teach, so I leave you one last lesson. Fight bravely, young one, as an honored member of the Horde.','',26124),
(52531,'enUS','','The Twilight Curse is shifting Go\'el between elemental states! Before he vanished, he took on the aspect of water. We must hurry to him...',26124),
(52532,'enUS','The fires consuming the Tormented Protector wink out!','The fires consuming the Tormented Protector wink out!',26124),
(52533,'enUS','','No matter how far it takes me - I refuse to give up on him.',26124),
(52534,'enUS','Enough...stop...','',26124),
(52535,'enUS','Aggra, I am ready to travel to the Abyssal Maw.','Aggra, I am ready to travel to the Abyssal Maw.',26124),
(52536,'enUS','The fires...torment me no longer.  But...I am consumed...','',26124),
(52537,'enUS','','I can only teleport us once. Make sure you are ready. Go\'el waits for us at the bottom of the ocean...',26124),
(52538,'enUS','','The children love this holiday.  Some children have gone out trick-or-treating, some have stayed behind, and some, like these, have decided to try to run a small business.$b$bTheir goal is to amass as much candy as possible, and they felt the best way was to offer treats for the hard work of others.  I laughed when I first heard of their plan, $c.  But now that I see how many adventurers are giving them candy for their wares, I am worried.$b$bThat is a lot of sugar.  I don\'t think the children will ever be able to fall asleep again.',26124),
(52539,'enUS','You...friend of Nordrassil...take what remains of my strength...and fight back the flames...','',26124),
(52540,'enUS','May the spirit of the Great Tree shelter you...','',26124),
(52541,'enUS','I will give you what power I can.  May the boughs of the Great Tree shade you from the flames in this infernal abyss.','',26124),
(52542,'enUS','I am sorry, dear Nordrassil.  I have failed...','',26124),
(52543,'enUS','%s collapses upon seeing his master die!','',26124),
(52544,'enUS','It is a time to celebrate new friends and the future we may forge together.','',26124),
(52545,'enUS','','The water here is disturbed... what is happening here?',26124),
(52546,'enUS','Greetings, travelers. The tides of destiny have brought you far from the bright world above. I know what it is you seek - and it lies there before you...','',26124),
(52547,'enUS','Your world-shaman has become a vortex of longing and desire. See how his heart devours everything within its proximity? Tread lightly, traveler, lest you too, be consumed.','',26124),
(52548,'enUS','','We arrived just in time! Go\'el\'s spirit has become so unstable, it could collapse upon itself if we don\'t act fast.',26124),
(52549,'enUS','Your world-shaman is already lost to the dark fathoms. He exists now only to consume - tortured by the currents of the life he longed for - but never knew.','',26124),
(52550,'enUS','','We will save him, $n. We MUST.',26124),
(52551,'enUS','We\'ve delayed long enough. Let us take the battle to this servant of Ragnaros immediately.','',26124),
(52552,'enUS','Wait no longer, I\'m ready to fight.','Wait no longer, I\'m ready to fight.',26124),
(52553,'enUS','Molten cracks appear along the Branch of Nordrassil! Something powerful is emerging from the staff!','Molten cracks appear along the Branch of Nordrassil! Something powerful is emerging from the staff!',26124),
(52554,'enUS','%s\'s smoldering body begins to flicker and combust!','%s\'s smoldering body begins to flicker and combust!',26124),
(52555,'enUS','','We paint our faces with the ash to send a message to new enemies - a declaration to those who fear and revile us as monsters.',26124),
(52556,'enUS','','We watched as our homes were razed to the ground.',26124),
(52557,'enUS','','To those who would question our place in this world...',26124),
(52558,'enUS','','No... we are a force even more terrifying...',26124),
(52559,'enUS','Aggra, I am ready to travel to Deepholm.','Aggra, I am ready to travel to Deepholm.',26124),
(52560,'enUS','','We cried out in agony as our families were cut down before our eyes.',26124),
(52561,'enUS','','The sooner we can get away from the Stonemother, the better. I do not trust her.',26124),
(52562,'enUS','For we have endured much... far beyond what any of us could have imagined.','',26124),
(52563,'enUS','As you stand before me, I pray you cast your burdens behind me.','',26124),
(52564,'enUS','It is an opportunity to mock the fearsome - to gaze boldly into the grim unknown and laugh!','',26124),
(52565,'enUS','With turmoil as tinder, let it blaze; may it temper us against what tomorrow may bring.','',26124),
(52566,'enUS','Spiderlings have been roused from their nest!','Spiderlings have been roused from their nest!',26124),
(52567,'enUS','Cinderweb Spinners dangle from above!','Cinderweb Spinners dangle from above!',26124),
(52568,'enUS','','The summoning runes were already drawn when we arrived. You\'ll need to destroy all of them.',26124),
(52569,'enUS','No, fiend. Your time is NOW.','',26124),
(52570,'enUS','Heroes! He is bound. Finish him!','',26124),
(52571,'enUS','It is finished then!','',26124),
(52572,'enUS','Perhaps...','',26124),
(52573,'enUS','Heroes, the world owes you a great debt.','',26124),
(52574,'enUS','Ragnaros has perished.  But the primal powers he represents can never be vanquished.  Another will rise to power, someday.','',26124),
(52575,'enUS','Yes Cenarius, we must maintain a constant vigil over this realm.  But let us celebrate this day and the great victory we have earned here.','',26124),
(52576,'enUS','Indeed.','',26124),
(52577,'enUS','','There! Look at him - frozen in stone, unmoving. Unfeeling. That look on his face... the resolve, the stubbornness. He gets it when he digs his heels in.',26124),
(52578,'enUS','','I\'ve seen it before - in Nagrand when he refused to lay down his mantle of Warchief, and again during his training.',26124),
(52579,'enUS','','I should have known! The Twilight\'s Hammer knew we\'d be here! Defend yourself!',26124),
(52580,'enUS','','Even now, while our enemies crash and surge all around us - he refuses to move - to act! Go\'el, my love... you can be infuriating sometimes.',26124),
(52581,'enUS','','Know this, friend: you have my deepest thanks. Your courage, your strength... you...$b$bYou remind me of him. ',26124),
(52583,'enUS','Aggra, I am ready. Let us go to Thrall.','Aggra, I am ready. Let us go to Thrall.',26124),
(52585,'enUS','%s begins to drink from the magma pools.','',26124),
(52586,'enUS','Fiery Lava Worms erupt from the ground!','Fiery Lava Worms erupt from the ground!',26124),
(52588,'enUS','|TInterface\\Icons\\inv_misc_horn_03.blp:20|tAs the creatures of the Firelands fall, a huntsman\'s horn sounds in the distance.','',26124),
(52589,'enUS','|TInterface\\Icons\\inv_misc_horn_03.blp:20|tThe hunting horn sounds again, nearer and more urgently.','',26124),
(52590,'enUS','A small moonwell arises from the droplets of the chalice.','',26124),
(52591,'enUS','The Molten Eggs begin to crack and splinter!','The Molten Eggs begin to crack and splinter!',26124),
(52592,'enUS','Jin\'do charges his weapon with the Shadows of Hakkar!','',26124),
(52593,'enUS','Burning Treants erupt from the ground to aid the Protector!','Burning Treants erupt from the ground to aid the Protector!',26124),
(52594,'enUS','%s is about to |cFFFF0000Emerge|r!','',26124),
(52597,'enUS','Kill elementals near Aggra\'s Air Totem, in the west!','Kill elementals near Aggra\'s Air Totem, in the west!',26124),
(52598,'enUS','Kill elementals near Aggra\'s Water Totem, in the north!','Kill elementals near Aggra\'s Water Totem, in the north!',26124),
(52599,'enUS','Kill elementals near Aggra\'s Earth Totem, in the east!','Kill elementals near Aggra\'s Earth Totem, in the east!',26124),
(52600,'enUS','Kill elementals near Aggra\'s Fire Totem, near Thrall!','Kill elementals near Aggra\'s Fire Totem, near Thrall!',26124),
(52601,'enUS','MY PARENTS... MURDERED BEFORE I COULD KNOW THEM... BETRAYED!','',26124),
(52602,'enUS','GUL\'DAN! IF I MUST BURN MY WAY ACROSS THE AFTERLIFE, I WILL FIND YOU IN WHATEVER HELL YOU\'VE HIDDEN!','',26124),
(52603,'enUS','I WILL HAVE MY REVENGE! DO YOU HEAR ME???','',26124),
(52604,'enUS','','He\'s absolutely raging!  So much anger, so much pain... and he had the strength to suppress it all these years...',26124),
(52605,'enUS','RAISED AS A SLAVE... TO KILL FOR HUMAN AMUSEMENT...','',26124),
(52606,'enUS','DEATH WAS TOO GOOD FOR BLACKMOORE. ANYONE WHO WOULD ENSLAVE ANOTHER... DESERVES WORSE THAN DEATH!','',26124),
(52607,'enUS','ALL ARE GUILTY! ALL MUST PAY!','',26124),
(52608,'enUS','KING VARIAN... YOU WISH TO MAKE WAR ON MY PEOPLE? YOU SHALL HAVE YOUR WAR, HUMAN!','',26124),
(52609,'enUS','YOU WILL SEE THE FURY OF THE HORDE RAGE THROUGH YOUR CITIES! YOU WILL SEE YOUR THRONE SPLIT IN TWO! THIS I SWEAR!!!','',26124),
(52610,'enUS','GARROSH... Garrosh...','',26124),
(52611,'enUS','','Go\'el! Go\'el, you must stop! Your anger is JUST - but it will only consume you! Fight it down, or we\'re ALL LOST!',26124),
(52612,'enUS','CAIRNE WAS MY BROTHER!!!!!!!!!','',26124),
(52613,'enUS','','Can you even hear me???',26124),
(52614,'enUS','It\'s so good seeing so many of you here to celebrate this time honored festivity.  We\'ve suffered many tragedies this year, so a celebration like Brewfest is a welcome and jubilous occasion.','It\'s so good seeing so many of you here to celebrate this time honored festivity.  We\'ve suffered many tragedies this year, so a celebration like Brewfest is a welcome and jubilous occasion.',26124),
(52615,'enUS','Years ago, when King Magni approached me about these festivities  I assured him that we gnomes could make Brewfest an event to remember.  But Magni, knew that we gnomes had other tasks that we should focus on.  He wanted to keep it simple and honor the past.','Years ago, when King Magni approached me about these festivities  I assured him that we gnomes could make Brewfest an event to remember.  But Magni, knew that we gnomes had other tasks that we should focus on.  He wanted to keep it simple and honor the past.',26124),
(52616,'enUS','King Magni must have sensed some disapointment as he did allow a slight change.  He allowed me a chance to tap the Brewfest Keg.  I remember spending nights trying to figure out how to efficiently and quickly open the keg and distribute its contents such that all participants will receive equal parts quickly and efficiently.','King Magni must have sensed some disapointment as he did allow a slight change.  He allowed me a chance to tap the Brewfest Keg.  I remember spending nights trying to figure out how to efficiently and quickly open the keg and distribute its contents such that all participants will receive equal parts quickly and efficiently.',26124),
(52617,'enUS','With plans drawn up, I had my top men and women begin work on a machine to do that exact task!  We had calculated down to the second how best to dist-','With plans drawn up, I had my top men and women begin work on a machine to do that exact task!  We had calculated down to the second how best to dist-',26124),
(52618,'enUS','Well... I guess that no one here is going to want to hear about the Keg Tapper prototypes 74205 and 75633...  Maybe if I spoke about prototype 1701-D, you would get excited...','Well... I guess that no one here is going to want to hear about the Keg Tapper prototypes 74205 and 75633...  Maybe if I spoke about prototype 1701-D, you would get excited...',26124),
(52619,'enUS','Right, right... So let\'s start the countdown from ten, ready?  TEN!','Right, right... So let\'s start the countdown from ten, ready?  TEN!',26124),
(52620,'enUS','Oh... okay, I\'ll just wait for zero then...','Oh... okay, I\'ll just wait for zero then...',26124),
(52621,'enUS','I am... alive...','',26124),
(52622,'enUS','','Go\'el, I thought I\'d lost you...',26124),
(52623,'enUS','Aggra, my heart... you never gave up on me. I owe you my life... everything that I am.','',26124),
(52624,'enUS','For I see now what I had become, so weighted down by doubt and anger. All my life, I had CHOSEN to be a slave to fear...','',26124),
(52625,'enUS','...a THRALL.','',26124),
(52626,'enUS','Fandral sought to use that weakness against me...','',26124),
(52627,'enUS','But what he and his Twilight Masters never understood is that the elements do not exist to rage and war... they exist to bring harmony. Within the world... and within us.','',26124),
(52628,'enUS','I have seen the TRUTH - and my chains have been broken.','',26124),
(52629,'enUS','Now, I am all that I once was... and more.','',26124),
(52630,'enUS','','Well, you\'re certainly more talkative...',26124),
(52631,'enUS','','But we must hurry back to the World Tree! The Dragon Aspects are waiting...',26124),
(52632,'enUS','Thank you, my friend. I can never repay your service or your friendship.','',26124),
(52633,'enUS','Meet us back at the World Tree. There\'s something... I want you to witness.','',26124),
(52634,'enUS','Please feel free to browse the items up for bid, or if you would like to list an item, I can help.','',26124),
(52635,'enUS','I\'d like to browse the items up for auction.','I\'d like to browse the items up for auction.',26124),
(52636,'enUS','Has anyone suspicious tried to list a crate of goods recently?','Has anyone suspicious tried to list a crate of goods recently?',26124),
(52637,'enUS','','I am but a humble herald of the Dark Lady Sylvanas, our Banshee Queen.',26124),
(52638,'enUS','Look, in my business, discretion is important. I shouldn\'t be talking about this at all.','',26124),
(52639,'enUS','The person you described was just here and he tried to persuade me to list a crateful of arcane objects.','',26124),
(52640,'enUS','Naturally, I told him that we don\'t deal in stolen goods. This is the Stormwind auction house, not some smoke-filled, back alley swapmeet!','',26124),
(52641,'enUS','','Did I hear right, Omnuron? We\'re going to join the fight?',26124),
(52642,'enUS','I need no more convincing, $n. The Druids of the Talon will lend you their aid.','',26124),
(52643,'enUS','Yes, Thisalee. Gather our forces. We leave for the Molten Front at once.','',26124),
(52644,'enUS','','I\'m going to enjoy this.',26124),
(52645,'enUS','|TInterface\\Icons\\ability_druid_tigersroar.blp:20|t%s transforms into a |c0087CEFA|Hspell:98374|h[Cat]|h|r!','',26124),
(52646,'enUS','|TInterface\\Icons\\inv_mount_hordescorpiong.blp:20|t%s transforms into a |c0087CEFA|Hspell:98379|h[Scorpion]|h|r!','',26124),
(52647,'enUS','','Our original duty binds us to defend this land, but if Fandral has indeed escaped to the Firelands, then we must bring him to justice.',26124),
(52648,'enUS','','Sisters, show yourselves. The time for subtlety is past. We will face our enemies in the Plane of Fire.',26124),
(52649,'enUS','','See you on the field of battle, $Gbrother:sister;.',26124),
(52650,'enUS','Mortal filth... the master\'s keep is forbidden....','',26124),
(52651,'enUS','','How can he just STAND there, while we fight off the attackers at his feet?',26124),
(52652,'enUS','','Brace yourself. The Firelands are a dangerous place... even for a formidable $r such as yourself.$b$bLet me know when you are ready.',26124),
(52653,'enUS','I am prepared. Let us go to the Firelands and finish this.','I am prepared. Let us go to the Firelands and finish this.',26124),
(52654,'enUS','','This realm is more terrible than I\'d imagined. Even now, I can feel the rage of this place pressing down on me.',26124),
(52655,'enUS','','We won\'t have much time before they\'re onto us. Let\'s begin.',26124),
(52656,'enUS','','There! I see him, wreathed in flame! I can feel waves of fury radiating from his core. Such rage... his anger alone could burn us to cinders!',26124),
(52657,'enUS','','Protect me and I\'ll place guardian totems all around us.',26124),
(52658,'enUS','What have we here - visitors to our kingdom in the Firelands?','',26124),
(52659,'enUS','You mortals may remember Alysra, who spirited me to freedom in Mount Hyjal. She, too has been reborn. Born of flame!','',26124),
(52660,'enUS','I wish I could watch her reduce your pitiful band to cinders, but I am needed elsewhere. Farewell!','',26124),
(52661,'enUS','Stop evading the question, Quincy! I know the thief was here with that crate.','',26124),
(52662,'enUS','The contents of that crate are very dangerous and they belong in a secure vault, not in the hands of some well-to-do, but ignorant collector!','',26124),
(52663,'enUS','Keep it down, will you? I\'m trying to run a business here...','',26124),
(52664,'enUS','If you\'re willing to forget this crate thing, I can give you a good price on some recent arrivals from Uldum.','',26124),
(52665,'enUS','Fine, fine. I might\'ve given him the name of a private collector interested in that crate\'s contents.','',26124),
(52666,'enUS','When the guards pay you a visit, I\'m sure you\'ll have no problem explaining how you got your hands on those Uldum artifacts or that lovely painting.','',26124),
(52667,'enUS','Yes $c. We foresaw this day long ago, and we are ready.','',26124),
(52668,'enUS','We cannot let Deathwing win. Should he triumph in this war, then all life will perish.','',26124),
(52669,'enUS','Come, protectors! We lend the strength of the ancients to this battle! And we shall not fall!','',26124),
(52670,'enUS','That\'s a start. And what about you, newcomer? You wouldn\'t be here if you weren\'t after the crate as well.','',26124),
(52673,'enUS','Aggra... $n...','',26124),
(52674,'enUS','','Good timing, Ricket. $n says they need your expertise on the Molten Front.',26124),
(52675,'enUS','','Ow! Well I guess that prototype didn\'t work, either.',26124),
(52676,'enUS','','Oh goody! Time to fight fire with...highly flammable weapons grade explosives!',26124),
(52677,'enUS','','I thought you might come. You\'ve proven very persistent. Annoyingly so.',26124),
(52678,'enUS','','It is time to be rid of you.',26124),
(52679,'enUS','','Fandral was a true leader. You are nothing more than a desperate dream.',26124),
(52680,'enUS','','You haven\'t the strength to lead anyone.',26124),
(52681,'enUS','','They will all see through to your weakness soon enough, \"Shan\'do.\"',26124),
(52682,'enUS','','I have power you\'ll never know, Malfurion.',26124),
(52683,'enUS','','I\'ll kill your companion just like I killed Hamuul. And there is nothing you can do about it.',26124),
(52684,'enUS','','Tenaron, old friend. Would you go collect a vial of moonwell water for this $c?',26124),
(52685,'enUS','','I don\'t believe it! I seared the life from your body!',26124),
(52686,'enUS','','Go now, $n. The moonwell will be filled by the time you return to the front.',26124),
(52687,'enUS','It would be my pleasure, Matoclaw.','',26124),
(52688,'enUS','And I have come for you, Leyara.','',26124),
(52689,'enUS','I release you from this fate Leyara. May you finally find your peace in death.','',26124),
(52690,'enUS','I\'m sorry that I did not arrive sooner, though you seem to have held your own quite well.','',26124),
(52691,'enUS','We\'ll meet you back in camp.','',26124),
(52692,'enUS','Leyara, you must see that Fandral is beyond redemption. The corruption within him runs deeper than you know.','',26124),
(52693,'enUS','You did not kill Hamuul, Leyara. He lives.','',26124),
(52694,'enUS','It is good to have you back, Hamuul. Let us leave this place.','',26124),
(52695,'enUS','Wahoo!','',26124),
(52696,'enUS','Thanks, $p! I\'ll tell my pa you helped me see the world!','',26124),
(52697,'enUS','This is great!','',26124),
(52698,'enUS','You\'re the best, $p!','',26124),
(52699,'enUS','','You\'ve come where you are not welcome.',26124),
(52700,'enUS','','Here there is only fire, brimstone, and death.',26124),
(52701,'enUS','','You cause is foolish and futile. You haven\'t the strength to hold on to those dearest to you.',26124),
(52702,'enUS','','You are weak. Pathetic.  Your life will be stripped from you, but only after everything you love has been burnt away.',26124),
(52703,'enUS','','All that awaits you is nothingness.  Emptiness.',26124),
(52704,'enUS','','They have all abandoned you. Left you to die.',26124),
(52705,'enUS','','They will abandon you when you need them most. They will leave you to burn.',26124),
(52706,'enUS','','You have nothing. No one.',26124),
(52707,'enUS','','You know nothing of power. You cling to your allies in desperation, but they cannot save you.',26124),
(52708,'enUS','','Your only hope is that you will all burn together. There is no victory for you.',26124),
(52709,'enUS','|TInterface\\Icons\\inv_mace_2h_sulfuras_d_01.blp:20|t%s begins to cast |cFFFF6600|Hspell:100604|h[Empower Sulfuras]|h|r!','',26124),
(52710,'enUS','Archmage Xylem does not bargain with the likes of you, ruffian. There shall be no payment!','',26124),
(52711,'enUS','What\'s this, an intruder? Let\'s see what the artifacts inside this box can do, shall we?','',26124),
(52712,'enUS','%s instantly kills all nearby allies!','%s instantly kills all nearby allies!',26124),
(52713,'enUS','%s collapses into a smouldering heap....','',26124),
(52714,'enUS','%s reanimates and surges into battle to protect his master!','',26124),
(52715,'enUS','','Of course, I will share my knowledge with you.',26124),
(52716,'enUS','','If only Malfurion hadn\'t dumped your grandfather in prison. He rots in a barrow den while the Horde assaults Ashenvale.',26124),
(52717,'enUS','This isn\'t supposed to happen!','',26124),
(52718,'enUS','It\'s good to see you again, Mr. Barnes. Do you have the crate?','',26124),
(52719,'enUS','I do. $n just returned with it, but how do I know you\'re going to keep your end of the bargain?','',26124),
(52720,'enUS','I have the charm with me and I will unlock its power once the crate is in my hands. You were wise to change your mind, Barnes.','',26124),
(52721,'enUS','With it, you will be able to enter Karazhan without fear of harm or detection. Not even Harrison Jones will know how you uncover the tower\'s history.','',26124),
(52722,'enUS','Please, take the crate. I\'m already thinking about what I\'ll find in the tower\'s library!','',26124),
(52723,'enUS','I\'ve been waiting for this day for years. Behold my transformation!','',26124),
(52724,'enUS','','Weee!',26124),
(52725,'enUS','','This is wonderful!',26124),
(52726,'enUS','','I can see everything from up here!',26124),
(52727,'enUS','','Good bye, $p! Thank you!',26124),
(52730,'enUS','I hope you weren\'t too put out, $n, but the contents of this crate have been very important to my family for generations.','',26124),
(52731,'enUS','I\'ve been preparing for this moment for years, $n, and you\'ve made it all possible. Witness my transformation!','',26124),
(52732,'enUS','','Question Auctioneer Fitch!',26124),
(52733,'enUS','<The Arcane Guardian gestures towards the Seer\'s Library.>','',26124),
(52734,'enUS','May you bathe in flames!','May you bathe in flames!',26124),
(52735,'enUS','My death will be avenged!','My death will be avenged!',26124),
(52736,'enUS','Death to you and your allies!','Death to you and your allies!',26124),
(52737,'enUS','My death means nothing!','My death means nothing!',26124),
(52738,'enUS','I serve you...Fire Lord.','I serve you...Fire Lord.',26124),
(52739,'enUS','Ashes...to ashes...','Ashes...to ashes...',26124),
(52740,'enUS','May you burn for eternity!','May you burn for eternity!',26124),
(52741,'enUS','This will not stop us...','This will not stop us...',26124),
(52742,'enUS','Invader! I will kill you with my bare claws!','Invader! I will kill you with my bare claws!',26124),
(52743,'enUS','You dare test us in the realm of fire?','You dare test us in the realm of fire?',26124),
(52744,'enUS','Enemies of the flame are not welcome here!','Enemies of the flame are not welcome here!',26124),
(52745,'enUS','Intruder! I will melt the flesh from your bones!','Intruder! I will melt the flesh from your bones!',26124),
(52746,'enUS','Trespassers will be incinerated.','Trespassers will be incinerated.',26124),
(52747,'enUS','You dare challenge the avatars of flame?','You dare challenge the avatars of flame?',26124),
(52748,'enUS','Play with fire and get burned, trespasser.','Play with fire and get burned, trespasser.',26124),
(52749,'enUS','Your world will burn, disbeliever!','Your world will burn, disbeliever!',26124),
(52750,'enUS','No, wait! You haven\'t told me how to use this charm yet!','',26124),
(52751,'enUS','What\'s happening to me? It burns!','',26124),
(52752,'enUS','','I would have it no other way.',26124),
(52753,'enUS','I know this will seem like betrayal, but Mr. Hastings has made an offer I simply cannot refuse. My apologies, $n.','',26124),
(52754,'enUS','','Aggra is nearly drowned! Save her!',26124),
(52755,'enUS','Question Auctioneer Drezmit!','',26124),
(52756,'enUS','Feel free to browse the items up for bid. I can help you place an item up for auction too.','',26124),
(52757,'enUS','Have you seen anyone suspicious trying to sell a crate of objects recently?','Have you seen anyone suspicious trying to sell a crate of objects recently?',26124),
(52758,'enUS','Let me see the items up for auction.','Let me see the items up for auction.',26124),
(52759,'enUS','We don\'t deal with those kinds of people here! This auction house only lists honestly-acquired merchandise.','',26124),
(52760,'enUS','Listen, if you can be discreet about it, there are a bunch of places in this town guys like me aren\'t supposed to know about.','',26124),
(52761,'enUS','I\'m willing to help you out, but you have to promise not to mention this to anyone else. Even talking about this kind of thing can hurt my reputation!','',26124),
(52762,'enUS','MY POWER WILL NOT BE CONTAINED!','',26124),
(52763,'enUS','TO THE GROUND!','',26124),
(52764,'enUS','BURN BEFORE ME!','',26124),
(52765,'enUS','BURNINATE!','',26124),
(52766,'enUS','Quicker or I\'ll turn you into cinder myself!','',26124),
(52767,'enUS','|TInterface\\Icons\\spell_shadow_rainoffire.blp:20|t Herald of the Burning End begins casting |cFFFF0000|Hspell:100761|h[Cataclysm]|h|r!','|TInterface\\Icons\\spell_shadow_rainoffire.blp:20|t Herald of the Burning End begins casting |cFFFF0000|Hspell:100761|h[Cataclysm]|h|r!',26124),
(52768,'enUS','Incompetent fools, summon faster!','',26124),
(52769,'enUS','Flame consume these mortals!','',26124),
(52770,'enUS','Nothing will remain but a pile of ash!','',26124),
(52771,'enUS','Cast faster!','',26124),
(52772,'enUS','If these mortals don\'t kill you, I will!','',26124),
(52773,'enUS','','...and you, my love, have a world to save.   ',26124),
(52774,'enUS','','A totem is failing! You must reactivate it!',26124),
(52775,'enUS','','Quickly, reactivate the totem!',26124),
(52776,'enUS','','Keep the totems alive! Hurry!',26124),
(52777,'enUS','There\'s no point in denying it, Dran! That thief knew exactly where to bring his stolen goods.','',26124),
(52778,'enUS','I don\'t know what you\'re talking about, elf, and I don\'t appreciate you pokin\' around in my business!','',26124),
(52779,'enUS','I do seem to have mistakenly come into possesion of some artifacts from Uldum. Perhaps the Reliquary is interested in those?','',26124),
(52780,'enUS','Fine, fine. I may have helped him contact an interested buyer. But keep your voice down! You\'ll scare away my customers.','',26124),
(52781,'enUS','Shall we see what the grunts have to say about your stolen antiquities?','',26124),
(52782,'enUS','Now we\'re getting somewhere...','',26124),
(52783,'enUS','And you, what\'s your interest in this? Let\'s have a word...','',26124),
(52784,'enUS','We must not fail the Firelord!','',26124),
(52785,'enUS','Animators, bring this magma to life!','',26124),
(52786,'enUS','My blade will char your flesh!','',26124),
(52787,'enUS','Keep casting! I will dispose of them.','',26124),
(52788,'enUS','','|TInterface\\Icons\\spell_shaman_stormearthfire.blp:20|t Alysrazor begins to charge up a |cFFFF0000|Hspell:100744|h[Firestorm]|h|r!',26124),
(52789,'enUS','','We will need the help of ALL the elements to save Thrall from this place. The lieutenants of Ragnaros will not be nearly as compromising as Cyclonas, Hydrius, or even Therazane.',26124),
(52790,'enUS','','I can\'t believe that it\'s... over...$b$bGo\'el is free, thanks in no small part to you, $n.',26124),
(52791,'enUS','Umm, Aggra... shouldn\'t you be following Thrall?','Umm, Aggra... shouldn\'t you be following Thrall?',26124),
(52792,'enUS','','You are right. I will see you in Mount Hyjal, friend.',26124),
(52793,'enUS','Don\'t forget your totems!','Don\'t forget your totems!',26124),
(52794,'enUS','Hold the line, soldiers! Do not give them quarter! Do not let them pass!','',26124),
(52795,'enUS','Rest? We can rest when we are buried in our graves. Today, we must fight!','',26124),
(52796,'enUS','Use your legs, soldiers!','',26124),
(52797,'enUS','We cannot let the deaths of our comrades go wasted! Do not let down your guard!','',26124),
(52798,'enUS','We must hold out a little longer, just until reinforcements arrive.','',26124),
(52799,'enUS','Our enemies think we are weak. Are we weak, soldiers? If not, then prove it to them!','',26124),
(52800,'enUS','Good work, defenders! We are gaining ground!','',26124),
(52801,'enUS','This fight is the true test of courage. Steel your hearts and drench your blades in the enemy\'s blood!','',26124),
(52802,'enUS','In the face of this cataclysm, I\'ve seen how truly fleeting our lives can be. And I, for one, will not waste another second of mine.','',26124),
(52803,'enUS','','What are you saying, Go\'el? What is in your heart?',26124),
(52804,'enUS','Aggra... though I was not born on Draenor, I have always tried to honor the traditions of our ancestors...','',26124),
(52805,'enUS','I stand before you - Go\'el, Son of Durotan, Son of Garad... and if you would have me, I would be your life-mate.','',26124),
(52806,'enUS','For so long as I live, I will stand at your side... as you have stood at mine.','',26124),
(52807,'enUS','','I stand before you - Aggralan, daughter of Ryal, daughter of Sarrak... and I will proudly be your mate, Go\'el... in this world or any other.',26124),
(52808,'enUS','The essence of Tarecgosa is with you.','The essence of Tarecgosa is with you.',26124),
(52809,'enUS','You must not think of this as betrayal, $n, but Mr. Goodwin has offered me the find of a lifetime in exchange for his belongings.','',26124),
(52810,'enUS','I do. $n has just returned with it. What of the grimoire?','',26124),
(52811,'enUS','It is yours, my dear Mister Goodwin. Master Belloc will be most pleased with our trade.','',26124),
(52812,'enUS','Perhaps Belloc and the Reliquary shall have both of these after all...','',26124),
(52813,'enUS','Direct and to the point! Good, I am eager to claim what is rightfully mine. Do you have it?','',26124),
(52814,'enUS','Indeed, I have Medivh\'s grimoire. I am fortunate that the Reliquary has seen the wisdom of this exchange.','',26124),
(52815,'enUS','You shall have it as soon as the crate is in my possession. I\'m sure your colleagues will find it most enlightening.','',26124),
(52816,'enUS','For years, I have longed to complete this spell and my transformation. Behold!','',26124),
(52817,'enUS','I have been dreaming of this day for years, $n, and you have made it all possible. Witness the culmination of a lifetime of work!','',26124),
(52818,'enUS','|TInterface\\Icons\\ability_vehicle_oiljets.blp:16|tYou are about to cast|cFFFF0000|Hspell:81831|h[Corruption: Sickness]|h|r! Face away from allies!','',26124),
(52819,'enUS','|TInterface\\Icons\\inv_elemental_mote_fire01.blp:16|tYou are about to burst into |cFFFF0000|Hspell:100460|h[Blazing Heat]|h|r!','',26124),
(52820,'enUS','|TInterface\\Icons\\ability_warlock_inferno.blp:20|t%s begins to cast |cFFFF6600|Hspell:100777|h[Magma Geyser]|h|r at the cluster of enemies!','',26124),
(52821,'enUS','Come, kindling!  Nordrassil\'s power WILL be mine!','Come, kindling!  Nordrassil\'s power WILL be mine!',26124),
(52822,'enUS','You feel a surge of power as Tarecgosa\'s essence manifests itself.','You feel a surge of power as Tarecgosa\'s essence manifests itself.',26124),
(52823,'enUS','Welcome to the Shady Lady, home of fine wines and exotic merchandise you won\'t find anywhere else!','',26124),
(52824,'enUS','Show me what\'s on the menu.','Show me what\'s on the menu.',26124),
(52825,'enUS','No, NO! I didn\'t \"betray\" the dragonflights. We were all betrayed. Ysera was lost in a dream while this whole world came undone.','',26124),
(52826,'enUS','I enact my master\'s will! I am he who bars the gate!','',26124),
(52827,'enUS','Fool mortals. Hurl yourselves into your own demise.','',26124),
(52828,'enUS','By the Firelord\'s command, you, too, shall perish!','',26124),
(52829,'enUS','The master will see you all consumed.','',26124),
(52830,'enUS','Be swallowed by a sea of flame!','',26124),
(52831,'enUS','Burn beneath my molten fury.','',26124),
(52832,'enUS','None may enter the master\'s domain!','',26124),
(52833,'enUS','I have come for you, Malfurion.','',26124),
(52834,'enUS','You are all weak. Frail.','',26124),
(52835,'enUS','There is one true path. The path of flame!','',26124),
(52836,'enUS','Yours is a path of doom.','',26124),
(52837,'enUS','Destroy their camp. Burn their tree to ash.','',26124),
(52838,'enUS','Burn everything. Leave no survivors.','',26124),
(52839,'enUS','Kill them all. Bring Malfurion to me.','',26124),
(52840,'enUS','Leave none alive, save Malfurion. He is mine.','',26124),
(52841,'enUS','Begone from my realm, insects.','',26124),
(52842,'enUS','I will see you all burn.','',26124),
(52843,'enUS','Be consumed by flame!','',26124),
(52844,'enUS','The realm of fire will consume you!','',26124),
(52845,'enUS','You are marked for death. Flee, little one!','',26124),
(52846,'enUS','You are being...hunted.','',26124),
(52847,'enUS','Time to run. Shannox comes.','',26124),
(52848,'enUS','The realm of fire will consume you!','',26124),
(52849,'enUS','|TInterface\\Icons\\ability_mage_firestarter.blp:20|t%s casts |cFFFF0000|Hspell:100675|h[Dreadflame]|h|r!','',26124),
(52850,'enUS','Magma swirls and eddies lazily inside the orb, but the translucent surface is solid and cool to the touch.','',26124),
(52851,'enUS','<Pick up the orb and shake it vigorously.>','<Pick up the orb and shake it vigorously.>',26124),
(52852,'enUS','Deathwing has prepared me to face the vessel of Tarecgosa, your fools journey ends here!','',26124),
(52853,'enUS','Fool! You dare enter the realm of fire?','',26124),
(52854,'enUS','You will find the inscription trainer, Recorder Lidio, in southern Aldor Rise.','You will find the inscription trainer, Recorder Lidio, in southern Aldor Rise.',26124),
(52855,'enUS','The Scryer\'s Tier has a library devoted to training professions.$b$bYou will find the knowledge you seek in the Seer\'s Library.','The Scryer\'s Tier has a library devoted to training professions.$b$bYou will find the knowledge you seek in the Seer\'s Library.',26124),
(52856,'enUS','You will find Technician Mihila on the Aldor Rise.','You will find Technician Mihila on the Aldor Rise.',26124),
(52857,'enUS','You will find the herbalism trainer, Jijia, in eastern Aldor Rise.','You will find the herbalism trainer, Jijia, in eastern Aldor Rise.',26124),
(52858,'enUS','You will find Recorder Lidio on the Aldor Rise.','You will find Recorder Lidio on the Aldor Rise.',26124),
(52859,'enUS','You will find Fono, the mining trainer, on the Aldor Rise.','You will find Fono, the mining trainer, on the Aldor Rise.',26124),
(52860,'enUS','You will find Weaver Aoa in northeastern Aldor Rise.','You will find Weaver Aoa in northeastern Aldor Rise.',26124),
(52861,'enUS','Ahhhhhhh! The sky is falling!','Ahhhhhhh! The sky is falling!',26124),
(52862,'enUS','Get out of the fire!','Get out of the fire!',26124),
(52863,'enUS','Fire! Fire!','Fire! Fire!',26124),
(52864,'enUS','Run! Ruuuuuuun!','Run! Ruuuuuuun!',26124),
(52865,'enUS','Does it leash?','Does it leash?',26124),
(52866,'enUS','It came from above!','It came from above!',26124),
(52867,'enUS','Why does that keep happening?','Why does that keep happening?',26124),
(52868,'enUS','Who keeps pulling?!?','Who keeps pulling?!?',26124),
(52869,'enUS','Can we pull yet? Can we? Can we?','Can we pull yet? Can we? Can we?',26124),
(52870,'enUS','Get your flasks! Get your buffs!','Get your flasks! Get your buffs!',26124),
(52871,'enUS','Ok, kick the boss on the third cast of the second phase. Always kick the first cast of the first phase but never the second on the first. Unless, you see lightning. If you see lightning - kick anyway. What\'s so hard about that?','Ok, kick the boss on the third cast of the second phase. Always kick the first cast of the first phase but never the second on the first. Unless, you see lightning. If you see lightning - kick anyway. What\'s so hard about that?',26124),
(52872,'enUS','Does anyone have a repair bot?','Does anyone have a repair bot?',26124),
(52873,'enUS','Hey guys, this is my first time here...anything I should know about?','Hey guys, this is my first time here...anything I should know about?',26124),
(52874,'enUS','Ahhhhhhh! The sky is falling!','Ahhhhhhh! The sky is falling!',26124),
(52875,'enUS','Get out of the fire!','Get out of the fire!',26124),
(52876,'enUS','Fire! Fire!','Fire! Fire!',26124),
(52877,'enUS','Run! Ruuuuuuun!','Run! Ruuuuuuun!',26124),
(52878,'enUS','Stop standing in the fire!','Stop standing in the fire!',26124),
(52879,'enUS','It came from above!','It came from above!',26124),
(52880,'enUS','Why does that keep happening?','Why does that keep happening?',26124),
(52881,'enUS','Who keeps pulling!?!','Who keeps pulling!?!',26124),
(52882,'enUS','Does anyone have a repair bot?','Does anyone have a repair bot?',26124),
(52883,'enUS','Hey guys, this is my first time here...anything I should know about?','Hey guys, this is my first time here...anything I should know about?',26124),
(52884,'enUS','Can we pull yet? Can we? Can we?','Can we pull yet? Can we? Can we?',26124),
(52885,'enUS','Get your flasks! Get your buffs!','Get your flasks! Get your buffs!',26124),
(52886,'enUS','Ok, kick the boss on the third cast of the second phase. Always kick the first cast of the first phase but never the second on the first. Unless, you see lightning. If you see lightning - kick anyway. What\'s so hard about that?','Ok, kick the boss on the third cast of the second phase. Always kick the first cast of the first phase but never the second on the first. Unless, you see lightning. If you see lightning - kick anyway. What\'s so hard about that?',26124),
(52887,'enUS','|TInterface\\Icons\\achievement_boss_ragnaros.blp:20|tYou are about to cast |cFFFF0000|Hspell:101109|h[Rage of Ragnaros]|h|r!','',26124),
(52888,'enUS','%s becomes enraged at seeing one of his companions fall!','',26124),
(52889,'enUS','|TInterface\\Icons\\spell_shadow_curse.blp:20|t%s readies his |cFF7A0080|Hspell:99352|h[Decimation Blade]|h|r!','',26124),
(52890,'enUS','|TInterface\\Icons\\inv_sword_09.blp:20|t%s readies his |cFFFF0000|Hspell:99350|h[Inferno Blade]|h|r!','',26124),
(52891,'enUS','','Leyara barks a cruel laugh.',26124),
(52892,'enUS','If there\'s one thing I know, it\'s that you can always count on a good friend. If you have such a person in your life, cherish them well.','',26124),
(52893,'enUS','Anren is my best friend. I don\'t know what I would do without him.','',26124),
(52894,'enUS','Tholo and I are joining the Firelands invasion effort. Live together, fight together, die together. That\'s what brothers are for!','',26124),
(52895,'enUS','Tholo and I have been through so much together. I always know he\'s watching out for me.','',26124),
(52896,'enUS','Placeholder Text!','Placeholder Text!',26124),
(52897,'enUS','Placeholder','Placeholder',26124),
(52898,'enUS','Placeholder','Placeholder',26124),
(52899,'enUS','Placeholder','Placeholder',26124),
(52900,'enUS','Placeholder','Placeholder',26124),
(52901,'enUS','Placeholder','Placeholder',26124),
(52902,'enUS','Placeholder','Placeholder',26124),
(52903,'enUS','Placeholder','Placeholder',26124),
(52904,'enUS','Placeholder','Placeholder',26124),
(52905,'enUS','Placeholder','Placeholder',26124),
(52906,'enUS','Placeholder','Placeholder',26124),
(52907,'enUS','Placeholder','Placeholder',26124),
(52908,'enUS','Placeholder','Placeholder',26124),
(52909,'enUS','Placeholder','Placeholder',26124),
(52910,'enUS','Placeholder','Placeholder',26124),
(52911,'enUS','Placeholder','Placeholder',26124),
(52912,'enUS','Do you know how many supplies it takes to support an army, $n? We need weapons, food, shelter, bandages...and that\'s just to start.$B$BThe supplies will not stock themselves. Ask Matoclaw if you\'re looking for ways to help. She will put you to use.','',26124),
(52913,'enUS','The warm embrace of Tarecgosa\'s presence encircles you.','The warm embrace of Tarecgosa\'s presence encircles you.',26124),
(52914,'enUS','','I am gathering my strength before I return to the battle. You would be wise to do the same.',26124),
(52915,'enUS','','The spiders here are as big as... me! Do you know how to get rid of a spider infestation?$B$BYeah, that\'s right. Dynamite. Lots and lots of dynamite.',26124),
(52916,'enUS','Uh...','Uh...',26124),
(52917,'enUS','Uh...','Uh...',26124),
(52918,'enUS','See you later! I\'m outta here!','See you later! I\'m outta here!',26124),
(52919,'enUS','See you later! I\'m outta here!','See you later! I\'m outta here!',26124),
(52920,'enUS','Don\'t stand in the fire!','Don\'t stand in the fire!',26124),
(52921,'enUS','Spread out! Spread out!','Spread out! Spread out!',26124),
(52922,'enUS','More dots! I need more dots!','More dots! I need more dots!',26124),
(52923,'enUS','Minus 50 DKP to the person that pulled!','Minus 50 DKP to the person that pulled!',26124),
(52924,'enUS','Don\'t stand in the fire!','Don\'t stand in the fire!',26124),
(52925,'enUS','Spread out! Spread out!','Spread out! Spread out!',26124),
(52926,'enUS','More dots! I need more dots!','More dots! I need more dots!',26124),
(52927,'enUS','Minus 50 DKP to the person that pulled!','Minus 50 DKP to the person that pulled!',26124),
(52928,'enUS','Tell me about the ancient, Malorne.','Tell me about the ancient, Malorne.',26124),
(52929,'enUS','','Legends of the great white stag have persisted in my culture for as long as we tauren can remember. Malorne likely stood guard over the primal forests at the very dawn of the world. He was an ancient spirit, the very embodiment of nature\'s power and purity!$B$BLong ago, the greatest tauren hunters would track the white stag when the moon was full. To catch even a glimpse of his shimmering hide through the trees was said to bring great fortune to the tribe for a generation.$B$BDid you know that Malorne was the consort of the moon goddess?',26124),
(52930,'enUS','No, tell me more!','No, tell me more!',26124),
(52931,'enUS','','Yes, Malorne was consort to the moon goddess herself, the one the night elves call \"Elune.\" From their union was born Cenarius, the patron god of all druids and one of the most powerful creatures ever to walk upon Azeroth.$B$BBut listen to me, I ramble on.$B$BMalorne is an incredible force of nature, but he only interacts with the mortal races in times of dire trouble. Have you heard about his deeds during the War of the Ancients? ',26124),
(52932,'enUS','Fight well, soldier. I need you to stay alive out there.','',26124),
(52933,'enUS','They are tokens of respect, purchased only with blood on the battlefield. Earning enough of these marks will be critical if we plan on winning this war.','',26124),
(52934,'enUS','To stand a chance in this battle against Ragnaros, we must gather allies who will gladly brave the scorched plains of the Firelands. And before we can recruit such allies to our cause - be they druid, soldier, or simple provisioner - we will need to give them reason to join us.$b$bCarrying even a handful of these marks signifies you as a hero of our cause. Gather them in the hundreds... and you will lead armies.$b$bAre you beginning to see the plan yet?','',26124),
(52935,'enUS','Commander Shadowsong, what are the Marks of the World Tree?','Commander Shadowsong, what are the Marks of the World Tree?',26124),
(52936,'enUS','And why is that, exactly?','And why is that, exactly?',26124),
(52937,'enUS','','Back behind me, where you first came in, there is a large thermal vent, blowing hot air up and out of this place. Stand on top of the vent, and then... jump! The momentum from your leap should be enough to propel you up to the top.$b$bOh, one more thing - based on some reports I\'m hearing from fellow druids, make sure you watch your head on the way out.',26124),
(52938,'enUS','','Of course. By the way: you\'ll find several smaller vents which behave the same way, deeper in the cavern. With time, you may learn to use them to travel more efficiently within the cavern - or simply as a way to torment those gutless flamewakers.',26124),
(52939,'enUS','How do I get out of here?','How do I get out of here?',26124),
(52940,'enUS','I think I understand. Thank you.','I think I understand. Thank you.',26124),
(52941,'enUS','','Well, my master Morthis is really the expert, but I can share with you what I know.$b$bThey are not birds. Certainly, they fly, their wings have the appearance of feathers, and we even call them hawks, but that is where the comparisons to birds stop. In fact, it would appear that they have more in common with dragons: an affinity for fire, a solitary nature, and - based on what we\'ve seen - some indications of intelligence.',26124),
(52942,'enUS','','Isn\'t it? However, they do differ from dragons when it comes to their lifespan. Whereas the dragons of our world can live for millennia on end, these fire hawks live brief lives, passing quickly from egg to adulthood to death.$b$bThough my master warns against making emotional connections to our studies, sometimes I can\'t help but feel sorry for them. They burn so brightly in life... but in death, they\'re quickly replaced and forgotten.',26124),
(52943,'enUS','What more can you tell me about these fire hawks?','What more can you tell me about these fire hawks?',26124),
(52944,'enUS','Fascinating.','Fascinating.',26124),
(52945,'enUS','What is there to tell? They\'re spiders. Just slightly more... flame-oriented than the spiders you and I are used to.$b$bThey bite, they spin webs, they spit burning venom, and they capture some of my best friends in cocoons of searing silk. Horrible little things.','',26124),
(52946,'enUS','No matter. These are not the spiders we need to worry about, however. Their queen, Beth\'tilac, is the true danger. Her webbed fortress lies to the east, beyond our reach. There, she is protected by an army of arachnids, all prepared to give their life for the queen.$b$bAnd they\'re huge, too! Believe it or not, the 12-foot-long spiders you see here are the small ones. That being said, while they may not be minions of Ragnaros in the literal sense, they are a danger to our cause and should be treated as such.','',26124),
(52947,'enUS','What can you tell me about these spiders?','What can you tell me about these spiders?',26124),
(52948,'enUS','I\'m sorry to hear that.','I\'m sorry to hear that.',26124),
(52949,'enUS','','Not much, I\'m afraid. I\'m no druid, I\'m here to lead troops. Seems odd to me that Malfurion tried to plant a tree in the middle of a warzone, but... like I said, I\'m no druid.$b$bHowever, I can tell you this. NOTHING makes those fire elementals angrier than the idea of a big, leafy tree growing right in the middle of their homeland. If nothing else, when this tree grows to its full size, it will be a beacon of hope for our forces... and a thorn in the side of our enemy.',26124),
(52950,'enUS','What can you tell me about the Sentinel Tree, general?','What can you tell me about the Sentinel Tree, general?',26124),
(52951,'enUS','What happened during the War of the Ancients?','What happened during the War of the Ancients?',26124),
(52952,'enUS','','Ten thousand years ago, when the demons of the Burning Legion invaded Azeroth, the ancients fought side-by-side with the mortal races. Many of the ancients met their end by the Legion\'s hand. Cenarius would\'ve been killed as well, were it not for the actions of his father, Malorne.$B$BThe mighty stag leapt into battle, his hooves crashing down on demon skulls and his antlers piercing their fiery flesh.$B$BThen Archimonde the Defiler took to the field of battle. After a fierce fight, he seized Malorne by his antlers and... and snapped the ancient\'s neck.$B$BBut as long as there\'s life in the world, can a force of nature like Malorne ever truly die?',26124),
(52953,'enUS','','Go\'el - the one you call Thrall - his spirit has been scattered across the elemental planes.$b$bThe Twilight\'s Hammer thinks to shake our will... but we shall not weaken. We will not forsake Go\'el.$b$bHe has risked everything to save this world, and we\'ll do no less for him!',26124),
(52954,'enUS','','Let me know when you are ready to travel to Uldum. We will ask Cyclonas what he knows.',26124),
(52955,'enUS','I am ready to travel to Uldum, Aggra.','I am ready to travel to Uldum, Aggra.',26124),
(52956,'enUS','','Fandral Staghelm has returned as a ... \"Druid of the Flame?\"$B$BI fear one of my own may be implicated in this betrayal!',26124),
(52957,'enUS','Yes, $c, things appear bleak. But know that even as things appear to unravel, they do so with a greater purpose.$B$B<Despite his comforting words, Nozdormu looks stricken, if not ill.>','',26124),
(52958,'enUS','I wish I could aid you in your plight, mortal. But the blue dragonflight is in disarray, and there are other urgent matters here at the World Tree that I\'ve been sent to investigate...','',26124),
(52959,'enUS','','The world-shaman - shattered by the hand of Fandral Staghelm?$B$BGreater powers are at work here. Ragnaros has pushed his strength farther into this realm than I would have imagined.$B$BThe Firelord must be stopped!',26124),
(52960,'enUS','It is you again, $c.$B$BIs something wrong?$B$B<Alysra\'s tail flinches, and her eyes dart back and forth under their lids.>','',26124),
(52961,'enUS','You turned Fandral Staghelm over to the Twilight\'s Hammer. Why have you betrayed the dragonflights?','You turned Fandral Staghelm over to the Twilight\'s Hammer. Why have you betrayed the dragonflights?',26124),
(52962,'enUS','We are too late! They killed her, as Fandral predicted.','We are too late! They killed her, as Fandral predicted.',26124),
(52963,'enUS','','No, the Firelord has already claimed this one for his own. Do you doubt his power?',26124),
(52964,'enUS','Has the Earthen Ring sent you?$B$BOur efforts to heal the land must begin here, at the World Tree. I\'m glad you are here to witness this.','',26124),
(52965,'enUS','I believe Aggra is almost here, and the other aspects have assembled.$B$BAre you ready to begin, $n?','',26124),
(52966,'enUS','I am ready.','I am ready.',26124),
(52969,'enUS','[  Cinematic Camera TBD  ]','',26124),
(52970,'enUS','The Darkmoon Faire is now open!$b$bFor a small fee, I can teleport you to the fairground staging area.$b$bWould you like to go?','The Darkmoon Faire is now open!$b$bFor a small fee, I can teleport you to the fairground staging area.$b$bWould you like to go?',26124),
(52971,'enUS','Take me to the faire staging area.','Take me to the faire staging area.',26124),
(52972,'enUS','Travel to the faire staging area will cost:','Travel to the faire staging area will cost:',26124),
(52973,'enUS','Return to Malfurion to protect the Sanctuary of Malorne.','Return to Malfurion to protect the Sanctuary of Malorne.',26124),
(52974,'enUS','%s grows impatient and becomes |cff7115ff|Hspell:101304|h[Superheated]|h|r.','',26124),
(52975,'enUS','$C!  No mounts on the game grounds!','$C!  No mounts on the game grounds!',26124),
(52976,'enUS','Leaving the faire so soon?$b$bFor a small fee, I can teleport you to a capital city.$b$bAre you sure you want to leave?','Leaving the faire so soon?$b$bFor a small fee, I can teleport you to a capital city.$b$bAre you sure you want to leave?',26124),
(52977,'enUS','Take me to Stormwind.','Take me to Stormwind.',26124),
(52978,'enUS','Travel from the faire will cost:','Travel from the faire will cost:',26124),
(52979,'enUS','Welcome to the Darkmoon Faire, $c!','Welcome to the Darkmoon Faire, $c!',26124),
(52980,'enUS','Alysra takes a deep breath. Get behind cover!','',26124),
(52982,'enUS','We are focus testing new encounters! I can open doors, build bridges, and slay lions to facilitate the testing.','',26124),
(52983,'enUS','I\'ll do it, Jebediah. Teleport me!','I\'ll do it, Jebediah. Teleport me!',26124),
(52984,'enUS','Take me to the Skyfire to fight Deathwing.','Take me to the Skyfire to fight Deathwing.',26124),
(52987,'enUS','','Beware, mortal.$b$bOnly the most experienced heroes should accompany me in the Nexus.',26124),
(52988,'enUS','I wish to test the Legendary Nexus instance.','I wish to test the Legendary Nexus instance.',26124),
(52991,'enUS','%s quickly avoids your attempt to tame!','',26124),
(52995,'enUS','Defend the Hyjal Wisp as it closes the attacker\'s portal!','',26124),
(52996,'enUS','Hyjal Wisp calls out for aid! Defend the Hyjal Wisp as it closes the attacker\'s portal!','',26124),
(52997,'enUS','Hyjal Wisp is weakened! Defend the Hyjal Wisp as it closes the attacker\'s portal!','',26124),
(52998,'enUS','Hyjal Wisp has been slain!','',26124),
(52999,'enUS','What are we building here?','What are we building here?',26124),
(53000,'enUS','We are building a permanent outpost here in the Firelands, $n. Even if Ragnaros is defeated, another may someday take his place. We cannot allow what happened in the Burning Steppes and Mount Hyjal to threaten our world again.$B$BTo that end, we will grow the \"Sentinel Tree.\" A tree with roots in Azeroth, but a protective canopy growing here in this terrible realm. Under its shelter, we will permanently station a group of druids to maintain an eternal vigil over this desolate world.','',26124),
(53003,'enUS','A piercing howl echoes through the hallways!','A piercing howl echoes through the hallways!',26124),
(53004,'enUS','Purple Puffer Pet','Purple Puffer Pet',26124),
(53005,'enUS','Throwing Starfish','Throwing Starfish',26124),
(53006,'enUS','Swift Shorestrider','Swift Shorestrider',26124),
(53007,'enUS','Throne of Tides','Throne of Tides',26124),
(53008,'enUS','Deth\'tilac asserts his Molten Will!','Deth\'tilac asserts his Molten Will!',26124),
(53009,'enUS','%s receives reinforcements!','%s receives reinforcements!',26124),
(53010,'enUS','Tholo\'s Thermometer shows no reading here.','Tholo\'s Thermometer shows no reading here.',26124),
(53011,'enUS','%s is nearing full strength!','',26124),
(53012,'enUS','%s signals for the Flamewaker Animators to cast faster!','',26124),
(53013,'enUS','%s orders Flamewaker Animator to cast faster!','',26124),
(53014,'enUS','%s breaks free from its bindings!','',26124),
(53015,'enUS','You seek the troll, Jabul. He can help you.','You seek the troll, Jabul. He can help you.',26124),
(53016,'enUS','The caravan has arrived. Good luck!','',26124),
(53017,'enUS','Defeat the Magic Hunters and find Tarecgosa!','Defeat the Magic Hunters and find Tarecgosa!',26124),
(53018,'enUS','Our ethereal technomancy has the ability to modify an item\'s arcane essence in ways previously unimaginable. We can also house items in a pocket dimension... for a small fee. See my associates for details.$B$BUnless you have something for me to examine?','Our ethereal technomancy has the ability to modify an item\'s arcane essence in ways previously unimaginable. We can also house items in a pocket dimension... for a small fee. See my associates for details.$B$BUnless you have something for me to examine?',26124),
(53019,'enUS','Unsatisfied with the appearance of an item?$B$BBehold the Transmogrifier, one of our most potent technomantic engines. With it, a skilled Warpweaver may shift the appearance of one object to that of another.$B$BWhat might this humble one transmogrify for you, goodly customer?','Unsatisfied with the appearance of an item?$B$BBehold the Transmogrifier, one of our most potent technomantic engines. With it, a skilled Warpweaver may shift the appearance of one object to that of another.$B$BWhat might this humble one transmogrify for you, goodly customer?',26124),
(53020,'enUS','Transmogrify an item.','Transmogrify an item.',26124),
(53021,'enUS','What is transmogrifying?','What is transmogrifying?',26124),
(53022,'enUS','DNT: Transmogrification rules go here!','DNT: Transmogrification rules go here!',26124),
(53023,'enUS','<DNT: Storage explanation.>','<DNT: Storage explanation.>',26124),
(53024,'enUS','Store an item.','Store an item.',26124),
(53027,'enUS','Hey, hey!$B$BI\'m sure you can land a ring on a slow-moving turtle.$b$bWhat do you say?','Hey, hey!$B$BI\'m sure you can land a ring on a slow-moving turtle.$b$bWhat do you say?',26124),
(53028,'enUS','Ready to play! |cFF0008E8(Darkmoon Game Token)|r','Ready to play! |cFF0008E8(Darkmoon Game Token)|r',26124),
(53029,'enUS','','MOVE FORWARD!',26124),
(53030,'enUS','','MOVE RIGHT!',26124),
(53031,'enUS','','MOVE LEFT!',26124),
(53032,'enUS','Thank you, $c.','Thank you, $c.',26124),
(53033,'enUS','Time to get back to work!','Time to get back to work!',26124),
(53034,'enUS','I\'m feeling better already.','I\'m feeling better already.',26124),
(53035,'enUS','It doesn\'t hurt so much anymore.','It doesn\'t hurt so much anymore.',26124),
(53036,'enUS','I can\'t thank you enough!','I can\'t thank you enough!',26124),
(53037,'enUS','You give me a game token, and I\'ll give you ten rings. $B$BThrow the rings onto Dubenko the Darkmoon Turtle over there... see the pole he\'s carrying on his shell?$b$bIf you don\'t land enough rings to win in one go, try again! Your points carry over into your next game.','You give me a game token, and I\'ll give you ten rings. $B$BThrow the rings onto Dubenko the Darkmoon Turtle over there... see the pole he\'s carrying on his shell?$b$bIf you don\'t land enough rings to win in one go, try again! Your points carry over into your next game.',26124),
(53038,'enUS','Launch me! |cFF0008E8(Darkmoon Game Token)|r','Launch me! |cFF0008E8(Darkmoon Game Token)|r',26124),
(53039,'enUS','|TInterface\\Icons\\ability_warstomp.blp:20|t%s casts |cFFFF0000|Hspell:101626|h[Pulverize]|h|r!','',26124),
(53040,'enUS','','You asked for it.',26124),
(53041,'enUS','Hello, and welcome!$B$BUp for a challenge?','',26124),
(53042,'enUS','Let\'s shoot! |cFF0008E8(Darkmoon Game Token)|r','Let\'s shoot! |cFF0008E8(Darkmoon Game Token)|r',26124),
(53043,'enUS','We have to reach the Aspects, are you ready?','',26124),
(53044,'enUS','Yes Thrall.','Yes Thrall.',26124),
(53046,'enUS','Heroes, we have the Dragon Soul. The Aspects await us within Wyrmrest. Hurry -  come with me!','',26124),
(53047,'enUS','You will not leave this canyon alive.','',26124),
(53048,'enUS','Hurry - we must keep moving.','',26124),
(53049,'enUS','Show yourself!','',26124),
(53050,'enUS','What magic is this?','',26124),
(53051,'enUS','Quick Shot!','Quick Shot!',26124),
(53052,'enUS','Setting up and maintaining the grounds is tough work...','Setting up and maintaining the grounds is tough work...',26124),
(53053,'enUS','It hurts when I move my arm.','It hurts when I move my arm.',26124),
(53054,'enUS','This gash just doesn\'t seem to be healing.','This gash just doesn\'t seem to be healing.',26124),
(53055,'enUS','That\'s the last time I try to set up the cannon alone...','That\'s the last time I try to set up the cannon alone...',26124),
(53056,'enUS','We\'ve got hammers, we\'ve got gnolls.$b$bIf you\'ve got a token, you can use the hammer to whack some gnolls.','We\'ve got hammers, we\'ve got gnolls.$b$bIf you\'ve got a token, you can use the hammer to whack some gnolls.',26124),
(53057,'enUS','Ready to whack! |cFF0008E8(Darkmoon Game Token)|r','Ready to whack! |cFF0008E8(Darkmoon Game Token)|r',26124),
(53058,'enUS','I\'ve found a bone, look!','',26124),
(53059,'enUS','Looking for the old steam tonks?$b$bWell, we\'ve got some new ones for you to enjoy.$b$bNormally, it would cost two tokens to use a tonk remote.  But because of your military service, you get a discounted rate of one token.$b$bWe at the Darkmoon Faire thank you for your service.','Looking for the old steam tonks?$b$bWell, we\'ve got some new ones for you to enjoy.$b$bNormally, it would cost two tokens to use a tonk remote.  But because of your military service, you get a discounted rate of one token.$b$bWe at the Darkmoon Faire thank you for your service.',26124),
(53060,'enUS','Ready to play! |cFF0008E8(Darkmoon Game Token)|r','Ready to play! |cFF0008E8(Darkmoon Game Token)|r',26124),
(53061,'enUS','D\'you think it\'s from a dragon? Or maybe a giant!','',26124),
(53062,'enUS','We\'re going to bring down the Hellfire Citadel, and it all starts with these ramparts.','',26124),
(53063,'enUS','','Silly, that\'s no dragon bone. It\'s probably from an elekk or something.',26124),
(53064,'enUS','The Warchief has ordered an invasion of the Hellfire Citadel, and we\'re starting with these exposed ramparts.','',26124),
(53065,'enUS','How d\'you know?','',26124),
(53066,'enUS','Whew that was close! Deathwing just blew us out of the sky!  We\'re almost there though, are you ready for the last leg of our journey to Wyrmrest Temple?','',26124),
(53067,'enUS','Yes Thrall, lets do this!','Yes Thrall, lets do this!',26124),
(53068,'enUS','The Blood Furnace is a testament to the dark past of my people.','',26124),
(53069,'enUS','If ye love killing orcs and ye don\'t talk much, glad to have ye!$B$BIf not, there\'s a lovely portal east of here that I heard is just lovely this time of year.','',26124),
(53070,'enUS','','I hope my friends are ok...',26124),
(53071,'enUS','','Maybe they already escaped? What if they\'re out there looking for me?',26124),
(53072,'enUS','','The naga are using slave labor? They\'ll pay for their transgressions!',26124),
(53073,'enUS','','We have to stop the naga and save Zangarmarsh while we still can!',26124),
(53074,'enUS','','The naga are pumping all of the water away for their own use, and entire species are dying out as a result.$B$BIf we don\'t do something soon, what life is left on this dying world will disappear forever.',26124),
(53075,'enUS','I joined this expedition for one reason, $r: revenge.','',26124),
(53076,'enUS','This place is still mostly free from the naga. But...it is deeply tormented. I don\'t know how long we have.','',26124),
(53077,'enUS','These mushrooms are unlike anything on the surface. They\'re said to bring great wisdom and clarity to those who eat them.$B$BI\'m going to bring some back with me to Sporeggar.','',26124),
(53078,'enUS','Being able to study and learn from the Underbog is a once in a lifetime opportunity.$B$BTo think I was practically dead not long ago sitting in a crate in the Slave Pens...','',26124),
(53079,'enUS','A trio of ethereal technomancers has set up shop in Stormwind, along the canal south of Cathedral Square.\n\n\"The Three Winds,\" it\'s called. Look for the weird machinery and purple lights... you can\'t miss it.\n\nThey offer just the sort of services you\'re looking for.','A trio of ethereal technomancers has set up shop in Stormwind, along the canal south of Cathedral Square.\n\n\"The Three Winds,\" it\'s called. Look for the weird machinery and purple lights... you can\'t miss it.\n\nThey offer just the sort of services you\'re looking for.',26124),
(53080,'enUS','Void Storage','Void Storage',26124),
(53081,'enUS','Nexus-Prince Haramad kept telling me that if we didn\'t find a way through Shaffar\'s ward soon that I\'d be the next test subject.$B$BHe wasn\'t bluffing.','',26124),
(53082,'enUS','What is an \"Ologist\", you ask? Why, it means I study everything! I\'m more knowledgable about any subject you can think of than anyone you know or anyone you\'ll ever know.$B$BGetting through Shaffar\'s ward was nothing. Morphalius wouldn\'t have a scratch on him if he had just listened to me. Always doing things his way, that one.','',26124),
(53083,'enUS','Look at me! You said I would be fine! Do I look fine?','',26124),
(53084,'enUS','I can only show you the door, Morphalius. You\'re the one that has to walk through it.','',26124),
(53085,'enUS','Spawn of the Old Gods materialize nearby!','Spawn of the Old Gods materialize nearby!',26124),
(53086,'enUS','','The dead do not belong in this realm.$B$BWhy, then, do we continually seek them out after putting them to rest?',26124),
(53087,'enUS','','Once, these crypts were sacred to my people. They held our loved ones\' spirits. A great many people traveled long distances here on pilgrimages.$B$BThose times are long gone. Something has taken a hold of the Auchenai that used to care so deeply for the deceased. Please, you must help before the spirits tear the crypt apart.',26124),
(53088,'enUS','','We should not peer into the spirit realm...',26124),
(53089,'enUS','','They do not know the doors they are opening...',26124),
(53091,'enUS','The crewman is choking!','The crewman is choking!',26124),
(53092,'enUS','Use your medic abilities to revive the crewman before it\'s too late!','Use your medic abilities to revive the crewman before it\'s too late!',26124),
(53093,'enUS','Look, mom! A spirit! See? See?','',26124),
(53094,'enUS','I saw one, I know I did...','',26124),
(53095,'enUS','','There\'s nothing there, Ha\'lei. Please, I just need a few more minutes of silence.',26124),
(53096,'enUS','The crewman is choking! Vitals are dropping!','The crewman is choking! Vitals are dropping!',26124),
(53097,'enUS','A pool of moonlight appears!','A pool of moonlight appears!',26124),
(53098,'enUS','A pool of moonlight appears to the west!','A pool of moonlight appears to the west!',26124),
(53099,'enUS','A pool of moonlight appears to the south!','A pool of moonlight appears to the south!',26124),
(53100,'enUS','A pool of moonlight appears to the north!','A pool of moonlight appears to the north!',26124),
(53101,'enUS','A pool of moonlight appears to the east!','A pool of moonlight appears to the east!',26124),
(53102,'enUS','The moonlight fades into darkness!','The moonlight fades into darkness!',26124),
(53103,'enUS','You don\'t have the slightest idea how to operate the various mechanisms on this device, yet you are filled with a feeling of familiarity that you can\'t seem to shake off.$B$BIt\'s probably best to just leave it alone.','',26124),
(53104,'enUS','A Tonk is taking aim at you!','',26124),
(53105,'enUS','Mortals! I cannot follow you any further - accept my blessing and use the Hourglass of Time to defeat Murozond!','',26124),
(53106,'enUS','','The spirits here have been tormented for a long time. We only want to rest.',26124),
(53107,'enUS','Every pandaren must search out and uncover their own fate. Whether a warrior or a farmer, we each have a place that suits us, and each place carries a unique importance.','',26124),
(53108,'enUS','','The way of the Tushui is one of gaining proper perspective. Through meditation and consideration, we find our way to the most effective solution to any problem. Through practice and discipline, we hone our bodies to be the perfect implements of our will.$B$BTo live the way of the Tushui is to be respected both for tempered mind and impeccable form.',26124),
(53109,'enUS','The only true crime is inaction.','',26124),
(53110,'enUS','A pool of dark moonlight appears nearby!','A pool of dark moonlight appears nearby!',26124),
(53111,'enUS','It\'s good to see you again.','',26124),
(53114,'enUS','Look Snowpuff, a $c\'s come ta save us!','',26124),
(53115,'enUS','','Hey, $c! Help a gal out, would ya?',26124),
(53116,'enUS','','We\'re too late, $n. Looks like those monkeys butchered the Foreman and his crew.',26124),
(53117,'enUS','Lower your voice, $r. I am no longer welcome in Sethekk.','',26124),
(53118,'enUS','Not to worry, $c. With this barrier in place, the arakkoa cannot see me.$B$BI\'m here on business.','',26124),
(53119,'enUS','My eyes! The goggles do nothing!','',26124),
(53121,'enUS','','Warlord Kalithresh will fall!',26124),
(53122,'enUS','There is an unnatural darkness to this place, a perpetual midnight. Take caution, heroes, and do not stray from the light.','',26124),
(53123,'enUS','We should strike now. I\'ll tear them apart!','',26124),
(53124,'enUS','','That\'s suicide, Claw! It\'s too dangerous.',26124),
(53125,'enUS','No more games for you.','No more games for you.',26124),
(53126,'enUS','Whaddya want now?','Whaddya want now?',26124),
(53127,'enUS','Step aside and let some others have a chance to play.','Step aside and let some others have a chance to play.',26124),
(53128,'enUS','The wilting lotus is the first sign of winter, a winter that has not come to Shen-zin Su in thousands of years.','',26124),
(53129,'enUS','Master Li Fei\'s voice echoes, \"The way of the Tushui... enlightenment through patience and meditation... the principled life.\"','',26124),
(53130,'enUS','Master Li Fei fades away.','',26124),
(53131,'enUS','Windcaller Claw growls.','',26124),
(53132,'enUS','We must contain the disease the naga have unleashed here before it is too late!','',26124),
(53133,'enUS','They came out of nowhere!','They came out of nowhere!',26124),
(53134,'enUS','You don\'t look like one of them... who are you?','You don\'t look like one of them... who are you?',26124),
(53135,'enUS','Get to Hanae\'s house. It\'s safe there.','Get to Hanae\'s house. It\'s safe there.',26124),
(53136,'enUS','We can\'t just sit here!','',26124),
(53137,'enUS','','There\'s too many of them. Kalithresh has an entire army down here.',26124),
(53138,'enUS','This is all that is left of the Blue Dragonshrine. A great battle shattered the timeways leading out of this forsaken place. You must reconstruct the fragments strewn across the ground and defeat the trapped spirit to proceed.','',26124),
(53139,'enUS','Bite\'s spell isn\'t going to last forever.','',26124),
(53140,'enUS','','How can I help you?',26124),
(53141,'enUS','I\'d like to travel by air.','I\'d like to travel by air.',26124),
(53142,'enUS','How may I help you?','',26124),
(53143,'enUS','Thank you, I\'ll go now.','Thank you, I\'ll go now.',26124),
(53144,'enUS','How may I help you?','',26124),
(53145,'enUS','I don\'t know who you are, but you have my gratitude.','I don\'t know who you are, but you have my gratitude.',26124),
(53146,'enUS','','How can I help you?',26124),
(53147,'enUS','','There is nothing left for you here, nothing but death and sorrow.',26124),
(53148,'enUS','','The darkness surrounds you, the light of Elune is your only salvation.',26124),
(53149,'enUS','','The moonlight can bring rest to your weary souls in this forgotten place.',26124),
(53150,'enUS','','Give yourselves to the night, Elune will guide you from this mortal prison.',26124),
(53151,'enUS','','You have chosen a path of darkness.  Mother moon, guide my hand; allow me to bring rest to these misbegotten souls.',26124),
(53152,'enUS','','Moon goddess, your light dims!  I am lost without your guidance!',26124),
(53153,'enUS','','The darkness closes in...my vision is clouded...',26124),
(53154,'enUS','','Mother moon, I can no longer see your light! Your daughter is alone in the darkness!',26124),
(53155,'enUS','','Let the peaceful light of Elune soothe your souls in this dark time.',26124),
(53156,'enUS','','Elune guide you through the night.',26124),
(53157,'enUS','','Eyes of night, pierce this darkness!',26124),
(53158,'enUS','','Spear of Elune, drive back the night!',26124),
(53159,'enUS','','I can...see the light of the moon...so clearly now.  It is...beautiful...',26124),
(53160,'enUS','|TInterface\\Icons\\ability_druid_starfall.blp:20|t |cFFFF0000|Hspell:102241|h[Tears of Elune]|h|r begin to rain from the sky!','|TInterface\\Icons\\ability_druid_starfall.blp:20|t |cFFFF0000|Hspell:102241|h[Tears of Elune]|h|r begin to rain from the sky!',26124),
(53161,'enUS','The Grimleer tribe owns this forest. We\'ll kill anyone who creeps on our turf.','',26124),
(53162,'enUS','Hey, over here!','',26124),
(53163,'enUS','Don\'t sleep easy, \'cause we\'ll be back. And next time, we\'ll destroy you for good!','',26124),
(53164,'enUS','If you\'re going to get to Warlord Kalithresh, you\'ll need to defeat Mekgineer Steamrigger and Hydromancer Thespia so that you can get to the Main Chambers Access Panels.$B$BYou mash a few buttons on those, and the door to the main chamber will open right up!','',26124),
(53165,'enUS','H-h-help! My men... we\'re under attack!','',26124),
(53166,'enUS','What? Do I see rescuers? Over here, $r! Help us!','',26124),
(53167,'enUS','|TInterface\\Icons\\ability_druid_lunarguidance.blp:20|t Tyrande gains |cFFFF0000|Hspell:102472|h[Lunar Guidance]|h|r!','|TInterface\\Icons\\ability_druid_lunarguidance.blp:20|t Tyrande gains |cFFFF0000|Hspell:102472|h[Lunar Guidance]|h|r!',26124),
(53168,'enUS','Uh oh! More eggmen come. Chief, we\'d better run for now!','',26124),
(53169,'enUS','Argh!! It stings!','',26124),
(53170,'enUS','...Thunder Bluff, two-thousand sixty-three in arrears.','',26124),
(53171,'enUS','Undercity, five thousand twenty-two in arrears.','',26124),
(53172,'enUS','Silvermoon, over nine thousand...','',26124),
(53173,'enUS','Enough! The realms will carry their weight or crumble beneath mine!','',26124),
(53174,'enUS','They have two moons to pay their debts. Make it known!','',26124),
(53175,'enUS','The Cabal will pay for their recklessness!','',26124),
(53176,'enUS','Blackheart! Vorpil! Your time has come!','',26124),
(53177,'enUS','We will stop the Shadow Council and put an end to their atrocities!','',26124),
(53178,'enUS','The Cabal have threatened the innocent for far too long! The time for retribution has come!','',26124),
(53179,'enUS','I\'ve lost my Tabard of Conquest.','I\'ve lost my Tabard of Conquest.',26124),
(53180,'enUS','Through the purity of the fire\'s spirit are we cleansed.  Through the passion of its being are we driven.','',26124),
(53181,'enUS','The braziers are prepared. I am ready to face you in combat.','The braziers are prepared. I am ready to face you in combat.',26124),
(53182,'enUS','Speak to me when you are ready for combat, young $c.','',26124),
(53183,'enUS','The powers of the Hourglass do nothing to me!','',26124),
(53184,'enUS','Nazgrim, lift my spirits with news of victory.','',26124),
(53185,'enUS','At once.','',26124),
(53186,'enUS','Snowpuff! Ye\'re saved! Oh thank ye, $c!','',26124),
(53187,'enUS','We kin make it back to camp on our own. Come talk to meh later if ya fancy borrowin\' a gryphon.','',26124),
(53188,'enUS','','We people of the Lower City had a rather extensive spy network set up in the Shadow Labyrinth until recently.$B$BNow they\'re all dead except me and To\'gun.',26124),
(53189,'enUS','','Thanks, $n! I should be able to get back on my own. Come see me later if you need any provisions for the road.',26124),
(53190,'enUS','','Sandra winks at you.',26124),
(53191,'enUS','The leadership of Shattrath is too slow to act, so the great people of the Lower City have taken matters in the Shadow Labyrinth into our own hands.','',26124),
(53192,'enUS','This is where she stood, heroes, and this is where she fell. The time-lost echo of Sylvanas Windrunner will reverberate through the rotting limbs of the Dragonshrine for all eternity.','',26124),
(53193,'enUS','Find all the Fragments of Jaina\'s Staff!','',26124),
(53194,'enUS','What lies before you is the aftermath of Deathwing\'s reign. What was once the Ruby Dragonshrine now lays in waste, its charred husk and scorched earth the only testament to its existence.\n$b It is said that, long ago, a single drop of Alexstrasza\'s blood melted away the snows and gave life to the great Crimson Oak that stands before you. Its branches raised triumphantly into the sky and radiated the warmth and life of the Red Dragonflight.\n$bBut now, its twisted, rotting limbs can no longer harness the power of life and vitality - instead only death and destruction. As flame and corruption extinguished the life force of these lands, the great tree captured an image...an echo of the warriors who fell on its hallowed grounds.','',26124),
(53195,'enUS','Thank you. Time to lick my wounds and get back to the fight!','Thank you. Time to lick my wounds and get back to the fight!',26124),
(53196,'enUS','Thanks for saving me. It was rough up there.','Thanks for saving me. It was rough up there.',26124),
(53197,'enUS','I\'m alive? Ha! That\'s more than I can say for those Horde at Garrosh\'ar Point. We tore them up good.','I\'m alive? Ha! That\'s more than I can say for those Horde at Garrosh\'ar Point. We tore them up good.',26124),
(53198,'enUS','I am pleased to report that the battle goes well, Warchief.','',26124),
(53199,'enUS','Zhi-Zhi can\'t believe they\'ve actually let me into the monastery training program!$b$bMe! Zhi-Zhi!','',26124),
(53200,'enUS','Stand back! Zhi-Zhi practicing here! Anybody who gets within 5 yards of here is probably going to get knocked out... maybe even killed.$b$bHai-yah!','',26124),
(53201,'enUS','Zhi-Zhi has always been good at hitting his friends, but Zhi-Zhi has gotten a lot better since studying here.','',26124),
(53202,'enUS','Wanna fight?','Wanna fight?',26124),
(53203,'enUS','About time someone challenged Zhi-Zhi!','About time someone challenged Zhi-Zhi!',26124),
(53204,'enUS','Alright, enough, enough! STOP HITTING ZHI-ZHI!','Alright, enough, enough! STOP HITTING ZHI-ZHI!',26124),
(53205,'enUS','We\'re one step closer my friends.  Have a rest and let me know when you are ready to continue.','',26124),
(53206,'enUS','Our forces report major victories off the coasts of Tanaris and Tol Barad...','',26124),
(53207,'enUS','Onward! We\'re almost there! Say the word and we shall continue to victory!','',26124),
(53208,'enUS','The pandaren elders were wise to allow the jinyu into their monastery.$b$bThey were unwise to allow the hozen the same privileges.','',26124),
(53209,'enUS','I like this place. Although it needs more water... I like it.','',26124),
(53210,'enUS','I have learned much from these monks, $r. You would do well to do the same.','',26124),
(53211,'enUS','I challenge you to a fight, Husshun!','I challenge you to a fight, Husshun!',26124),
(53212,'enUS','Very well!','',26124),
(53213,'enUS','I knew I would lose. The rivers told me so.','',26124),
(53214,'enUS','You must give peace to these lands if you are to face Murozond.','',26124),
(53215,'enUS','I can\'t say I mind the food here. Or the beer, for that matter.','',26124),
(53216,'enUS','Have you tried the rice? You really need to try the rice.','',26124),
(53217,'enUS','Eating is a form of training, too, you know.','',26124),
(53218,'enUS','Put down your fork, and pick up your fists! I challenge you!','Put down your fork, and pick up your fists! I challenge you!',26124),
(53219,'enUS','Fine, then. It\'s time for an open-faced $R sandwich!','',26124),
(53220,'enUS','You win... this time. I\'d better get back to my size training.','',26124),
(53221,'enUS','Be gentle - I\'m still a bit bruised from the last fight I lost... er... won.','Be gentle - I\'m still a bit bruised from the last fight I lost... er... won.',26124),
(53222,'enUS','It\'d be an honor to spar with you, $gsir:ma\'am;.','It\'d be an honor to spar with you, $gsir:ma\'am;.',26124),
(53223,'enUS','I know what you\'re thinking. I can see it in your little $r eyes.$b$b<The pupil smiles.>$b$bWell, are we doing this, or what?','I know what you\'re thinking. I can see it in your little $r eyes.$b$b<The pupil smiles.>$b$bWell, are we doing this, or what?',26124),
(53224,'enUS','I\'m ready if you are.','I\'m ready if you are.',26124),
(53225,'enUS','I\'ve been sparring all day. When do we eat?','I\'ve been sparring all day. When do we eat?',26124),
(53226,'enUS','You want to rumble?','You want to rumble?',26124),
(53227,'enUS','Alright, let\'s get this match started!','Alright, let\'s get this match started!',26124),
(53228,'enUS','Is it fighting time? I think it is!','Is it fighting time? I think it is!',26124),
(53229,'enUS','Let\'s fight!','Let\'s fight!',26124),
(53230,'enUS','Let\'s rumble!','Let\'s rumble!',26124),
(53231,'enUS','Get your paws up where I can see \'em!','Get your paws up where I can see \'em!',26124),
(53232,'enUS','You\'re about to get a mouthful of claws, $c. Ha HA!','You\'re about to get a mouthful of claws, $c. Ha HA!',26124),
(53233,'enUS','Go easy on the belly, alright?','Go easy on the belly, alright?',26124),
(53234,'enUS','Let\'s see how you hold up against my \"slow, weak punches\" technique!','Let\'s see how you hold up against my \"slow, weak punches\" technique!',26124),
(53235,'enUS','Yeah! Fightin\' time!','Yeah! Fightin\' time!',26124),
(53236,'enUS','Time for a few traditional \"Welcome to the Monastery\" punches!','Time for a few traditional \"Welcome to the Monastery\" punches!',26124),
(53237,'enUS','Here I come!','Here I come!',26124),
(53238,'enUS','Nice moves!','Nice moves!',26124),
(53239,'enUS','Man... I thought I had that one...','Man... I thought I had that one...',26124),
(53240,'enUS','Good fight. I\'ll get you next time.','Good fight. I\'ll get you next time.',26124),
(53241,'enUS','Master Stone Fist was right about you. You\'re good.','Master Stone Fist was right about you. You\'re good.',26124),
(53242,'enUS','Thank you for the opportunity of getting beaten up by you.','Thank you for the opportunity of getting beaten up by you.',26124),
(53243,'enUS','You take this pretty seriously, don\'t you?','You take this pretty seriously, don\'t you?',26124),
(53244,'enUS','Good fight.','Good fight.',26124),
(53245,'enUS','I came to ask the famous Aysa Cloudsinger for help, but I just can\'t bring myself to intrude on her exercises. She\'s so poised, so practiced... so beautiful.','',26124),
(53246,'enUS','I don\'t think I ever stood a chance. See you around, then!','I don\'t think I ever stood a chance. See you around, then!',26124),
(53247,'enUS','After intense fighting, our supply route to Booty Bay has been reestablished.','',26124),
(53248,'enUS','','Come, $n. Let us move swiftly.',26124),
(53249,'enUS','We came here for war.$B$BThey gave it to us.','',26124),
(53250,'enUS','We were here to scout for an invasion, but they already knew we were coming.','',26124),
(53254,'enUS','Get inside, quickly! I\'ll hold them off!','',26124),
(53255,'enUS','And now, Shaman, you will give the Dragon Soul to ME.','',26124),
(53257,'enUS','Time to learn your place, pandaren!','',26124),
(53258,'enUS','Sabotaging','',26124),
(53259,'enUS','This one, over here! He\'s trying to protect the others!','',26124),
(53260,'enUS','Into that house! Take anyone who can still walk!','',26124),
(53261,'enUS','In an ancient time, the spirits of the people dimmed and the land grew cold.','In an ancient time, the spirits of the people dimmed and the land grew cold.',26124),
(53262,'enUS','And then came Huo, the spirit of fire, to the land of Shen-zin Su.','And then came Huo, the spirit of fire, to the land of Shen-zin Su.',26124),
(53263,'enUS','Huo warmed the land and ignited the passions of the people.','Huo warmed the land and ignited the passions of the people.',26124),
(53264,'enUS','And in times since, the people have cared for Huo, knowing that they and he were intimately tied.','And in times since, the people have cared for Huo, knowing that they and he were intimately tied.',26124),
(53265,'enUS','Master Shang has trained you well. Thank you, friend!','',26124),
(53266,'enUS','Alliance bloods spills. This pleases me, General.','',26124),
(53267,'enUS','What of [Operation Seafire (PH)]? How fares my precious cargo?','',26124),
(53268,'enUS','','Let\'s get to work, shall we?',26124),
(53270,'enUS','There is news, Warchief.','',26124),
(53271,'enUS','Speak, goblin...','',26124),
(53275,'enUS','I will NOT, Archbishop. It will never be yours.','',26124),
(53276,'enUS','Y-yes sir... right away, sir.','',26124),
(53277,'enUS','Things all started out pretty well.','',26124),
(53278,'enUS','There is no good. No evil. No Light. There is only POWER!','',26124),
(53279,'enUS','You were a figurehead of the Light, Benedictus. How could you betray your own people?','',26124),
(53280,'enUS','','Enough! As much as I adore playing hostess, I have more pressing matters to attend to.',26124),
(53281,'enUS','','Riders, to me!',26124),
(53282,'enUS','We made it past enemy lines - looked like it was gunna be smooth sailin\' all the way.','',26124),
(53283,'enUS','I suppose it has to be this way, then. If only you\'d seen what I\'ve seen. THEN you\'d understand.','',26124),
(53284,'enUS','Then it happened... all at once! A whole mess of fighters came outta nowhere, sir...','',26124),
(53285,'enUS','I pray that the Light of a Thousand Moons will grant me this honor.','I pray that the Light of a Thousand Moons will grant me this honor.',26124),
(53286,'enUS','Yes, Light of Lights! My life is yours!','Yes, Light of Lights! My life is yours!',26124),
(53287,'enUS','The Flower of Life calls upon me. I WILL NOT fail you, my Queen.','The Flower of Life calls upon me. I WILL NOT fail you, my Queen.',26124),
(53288,'enUS','Hey... HEY! What are you doing?','',26124),
(53289,'enUS','You\'re stealing my inventory, aren\'t you?','',26124),
(53290,'enUS','Alexstrasza\'s Drakes will pick us up on the other side of this abandoned excavation site. Check your weapons, this place stinks of an ambush.\n\nLet me know when you\'re ready to move out.','',26124),
(53294,'enUS','','I am unimpressed.',26124),
(53295,'enUS','Don\'t make me stand up!','',26124),
(53296,'enUS','I\'ll do it, I swear! I\'m about to stand up!','',26124),
(53297,'enUS','Here I go!','',26124),
(53298,'enUS','Oh, who am I kidding? You are a wily one, thief.','',26124),
(53299,'enUS','','I beseech of you, my beloved subjects: Put an end to these miscreants.',26124),
(53300,'enUS','','I have no time for such diversions. Keepers of Eternity, will you stand for your queen?',26124),
(53301,'enUS','','Still these strangers would oppose your queen\'s will. Who will stop them?',26124),
(53302,'enUS','','Your conduct was inexcusable.',26124),
(53303,'enUS','','Unfortunate, but deserved.',26124),
(53304,'enUS','','To prepare for a world of perfection, the imperfect must be swept away.',26124),
(53305,'enUS','','Bold of you, to strike a queen. A lesser monarch might be enraged.',26124),
(53306,'enUS','','Dance for the Eternal Court.',26124),
(53307,'enUS','Before we knew it they was everywhere!','',26124),
(53308,'enUS','We stuck with the cargo \'til the end, which came, well, right after the start...','',26124),
(53309,'enUS','I floated for days \'til one of our ships spotted me...','',26124),
(53311,'enUS','What do I need to play?','What do I need to play?',26124),
(53312,'enUS','You need Darkmoon Game Tokens to play.$b$bBuy them from any of the faire\'s Game Token vendors.$b$bI\'ll mark one on your map for you.','You need Darkmoon Game Tokens to play.$b$bBuy them from any of the faire\'s Game Token vendors.$b$bI\'ll mark one on your map for you.',26124),
(53313,'enUS','There are no freebies here, move on.','There are no freebies here, move on.',26124),
(53314,'enUS','You gotta pay to play.','You gotta pay to play.',26124),
(53315,'enUS','Sorry pal, can\'t let you play for free.','Sorry pal, can\'t let you play for free.',26124),
(53316,'enUS','Shot down by a group of alliance cowards?! PATHETIC!','',26124),
(53317,'enUS','How do I play the Ring Toss?','How do I play the Ring Toss?',26124),
(53318,'enUS','I understand.','I understand.',26124),
(53319,'enUS','First, you give me a game token.  Next, I give you a mallet.  Then you\'ll see gnolls pop from the barrels in the play area.$B$BHit the gnolls with your mallet to score points.$b$BHere\'s where it gets tricky.  There are three different targets: regular gnolls, Hogger gnolls, and BABIES.$b$bRegular gnolls grant one point, while Hoggers count for three.  But babies?  Hitting a baby will knock you down and stun you... SO DON\'T HIT THE BABIES!$b$bIf you don\'t whack enough gnolls in one go, just spend another token!  The points you\'ve earned will carry over into your next game.','First, you give me a game token.  Next, I give you a mallet.  Then you\'ll see gnolls pop from the barrels in the play area.$B$BHit the gnolls with your mallet to score points.$b$BHere\'s where it gets tricky.  There are three different targets: regular gnolls, Hogger gnolls, and BABIES.$b$bRegular gnolls grant one point, while Hoggers count for three.  But babies?  Hitting a baby will knock you down and stun you... SO DON\'T HIT THE BABIES!$b$bIf you don\'t whack enough gnolls in one go, just spend another token!  The points you\'ve earned will carry over into your next game.',26124),
(53320,'enUS','How do I play Whack-a-Gnoll?','How do I play Whack-a-Gnoll?',26124),
(53321,'enUS','How do I play the Tonk Challenge?','How do I play the Tonk Challenge?',26124),
(53322,'enUS','The mogu empire was overthrown centuries ago. These ruins have been here - and abandoned - for as long as anyone can remember. $B$BWhy would they come back now?','',26124),
(53323,'enUS','First, you give me one game token.  Then you find yourself in control of a steam tonk!$b$bYou have a limited amount of time to blast targets in the battlefield.  Each target you destroy earns you one point.$b$bBut watch out: The battlefield is also home to enemy tonks and zeppelins.  Getting hit by one of their shots damages your tonk.$b$bYour score will carry over from one tonk to the next, so don\'t worry if you explode.','First, you give me one game token.  Then you find yourself in control of a steam tonk!$b$bYou have a limited amount of time to blast targets in the battlefield.  Each target you destroy earns you one point.$b$bBut watch out: The battlefield is also home to enemy tonks and zeppelins.  Getting hit by one of their shots damages your tonk.$b$bYour score will carry over from one tonk to the next, so don\'t worry if you explode.',26124),
(53324,'enUS','They\'ve killed the Greench!','',26124),
(53325,'enUS','Run!','',26124),
(53326,'enUS','Where... is... my... SHIP!?','',26124),
(53327,'enUS','S-sailing into a fog bank, last I saw, Alliance in chase... n-no tellin\' what became of \'em, sir...','',26124),
(53328,'enUS','First, I give you a pellet rifle in exchange for one Darkmoon Game Token.$B$BThen you shoot the targets that light up.$b$bIf you\'re fast enough to hit a target just after it\'s lit up, you get an extra point.$b$bIf you don\'t reach the score limit before your time\'s up, or you move away from the booth, don\'t worry: Your score carries over to the next game.','First, I give you a pellet rifle in exchange for one Darkmoon Game Token.$B$BThen you shoot the targets that light up.$b$bIf you\'re fast enough to hit a target just after it\'s lit up, you get an extra point.$b$bIf you don\'t reach the score limit before your time\'s up, or you move away from the booth, don\'t worry: Your score carries over to the next game.',26124),
(53329,'enUS','How does the Shooting Gallery work?','How does the Shooting Gallery work?',26124),
(53330,'enUS','With all respect, Warchief, what\'s done is done. We must now focus our efforts on how to proceed...','',26124),
(53331,'enUS','I\'ll TELL you how we\'ll proceed, general.','',26124),
(53332,'enUS','You\'re going to round up your best men and FIND MY SHIP!','',26124),
(53333,'enUS','It is done, but we should not linger here. Meet me back on the eastern edge of the camp.','',26124),
(53334,'enUS','Keep your wits about you. There are demons nearby.','',26124),
(53335,'enUS','Well done, heroes! Let us all hope that this is the last the world will ever see of Kael\'thas Sunstrider.','',26124),
(53336,'enUS','Now, friends. Attack!','',26124),
(53337,'enUS','Subjugate THIS!','Subjugate THIS!',26124),
(53338,'enUS','Another volunteer for the Thunder King\'s labor force!','',26124),
(53339,'enUS','We do not fear you!','We do not fear you!',26124),
(53340,'enUS','Your goons smashed my keg of Stormstout Special Reserve... I was saving that!!','Your goons smashed my keg of Stormstout Special Reserve... I was saving that!!',26124),
(53341,'enUS','Over here, ugly!','Over here, ugly!',26124),
(53342,'enUS','Let us start with the three who sit behind me.','',26124),
(53343,'enUS','Before you sits Instructor Myang. She will be responsible for teaching you the most practical fighting techniques.','',26124),
(53344,'enUS','It is said that, before she joined our monastery, Myang defeated one hundred ravaging hozen in a single melee.','',26124),
(53345,'enUS','','You flatter me, High Elder. Those hozen were weak, young, and unskilled. Any other pandaren would have done the same.',26124),
(53346,'enUS','Flatter you? You were eight years old.','',26124),
(53347,'enUS','','...and a half. Sir.',26124),
(53348,'enUS','Next, we have Master Stone Fist. He will be leading your sparring exercises.','',26124),
(53349,'enUS','Master Stone Fist is nearly unmatched in single combat. He once defeated nine hundred and ninety-nine challengers in a row.','',26124),
(53350,'enUS','The thousandth challenger cheated.','',26124),
(53351,'enUS','What? Cheated!?','',26124),
(53352,'enUS','I never cheat!','',26124),
(53353,'enUS','Finally, Instructor Xann. His mastery of the very basics of combat has given him a nearly perfect fighting form.','',26124),
(53354,'enUS','Xann, how many practice strikes do your students perform daily?','',26124),
(53355,'enUS','Ten thousand strikes, every day.','',26124),
(53356,'enUS','And how many do YOU perform?','',26124),
(53357,'enUS','Ten thousand and one.','',26124),
(53358,'enUS','Luckily, High Elders no longer have to perform basic training. I find that I am happier when I am not exercising.','',26124),
(53359,'enUS','Walk and drink with me, $n.','',26124),
(53360,'enUS','Ah! Upon this table, you see Spirit-Sage Gaoquan, the oldest member of our monastery.','',26124),
(53361,'enUS','He has seen many high elders come and go. He also tends to take these celebrations very seriously.','',26124),
(53362,'enUS','You may have noticed the hozen and jinyu among us. All are welcome here at the monastery, as long as they have the desire to learn.','',26124),
(53363,'enUS','Finally, this is Groundskeeper Wu.','',26124),
(53364,'enUS','WU!','',26124),
(53365,'enUS','Ye... yes, high <hic> elder?','',26124),
(53366,'enUS','Wu, this is $n. $GHe:She; will be joining the other trainees.','',26124),
(53367,'enUS','Oh...<hic>... hello... $nsszzhhhh...','',26124),
(53368,'enUS','Wu will be asking you to perform a few chores. Nothing complex, just some tasks relating to the maintenance of our monastery.','',26124),
(53369,'enUS','We are all responsible for maintaining our home. Even the High Elder must occasionally lend a hand.','',26124),
(53370,'enUS','Now you are caught up. And would you look at that? My cup is full again! It is good to be the High Elder.','',26124),
(53371,'enUS','Welcome, $n. We are honored to have you as our guest. Today, we celebrate not only your arrival, but the initiation of a new class of trainees within our monastery.$b$bPlease, enjoy the food and drink that we have prepared. When you are ready, I would like to introduce you to some of the monastery\'s instructors.','',26124),
(53372,'enUS','Very well, $n. Return to me when your thirst and hunger are sated.','',26124),
(53373,'enUS','Are you certain? The trainers would love to meet an experienced $r $c like you.','',26124),
(53374,'enUS','As you wish. A toast, to our honored guest, $n!','',26124),
(53375,'enUS','I\'m ready to be introduced to the instructors, High Elder.','I\'m ready to be introduced to the instructors, High Elder.',26124),
(53376,'enUS','Hold on a moment, I\'m not ready yet.','Hold on a moment, I\'m not ready yet.',26124),
(53377,'enUS','I don\'t need any introductions, old man. Let\'s skip ahead to the good part.','I don\'t need any introductions, old man. Let\'s skip ahead to the good part.',26124),
(53378,'enUS','Fine. Let\'s proceed with the introductions.','Fine. Let\'s proceed with the introductions.',26124),
(53379,'enUS','I am certain. Let\'s move on to the fighting.','I am certain. Let\'s move on to the fighting.',26124),
(53380,'enUS','Submit or die, you fool!','',26124),
(53381,'enUS','Don\'t just attack him one at a time, you idiots! Surround him now!','',26124),
(53385,'enUS','%s smiles.','',26124),
(53386,'enUS','You\'re obviously no farmer...','',26124),
(53387,'enUS','Another mug of ale for $n!','',26124),
(53388,'enUS','Welcome to the Great Banquet. High Elder Cloudfall awaits you at the back table.','',26124),
(53390,'enUS','Free at last! I need a drink...','Free at last! I need a drink...',26124),
(53391,'enUS','','Just a moment, $n.',26124),
(53392,'enUS','','%s mixes the cider and a handful of crushed herbs into a flask, then shakes the concoction vigorously.',26124),
(53393,'enUS','','That should do it!',26124),
(53394,'enUS','Mogu ambushers descend from the trees. Look out!','Mogu ambushers descend from the trees. Look out!',26124),
(53395,'enUS','Look at what we have here! Another straggler from the orchard...','',26124),
(53396,'enUS','If you are interested in training with us, speak with me again at the banquet tables, later this evening.','',26124),
(53397,'enUS','Ban should have arrived by now... Look for him at the edge of the camp.','Ban should have arrived by now... Look for him at the edge of the camp.',26124),
(53398,'enUS','Hello and welcome to the Darkmoon Faire Staging Area.$b$bThe portal here will take you to the Darkmoon Faire.$b$bBut if you have any questions before you go, I can answer them.','Hello and welcome to the Darkmoon Faire Staging Area.$b$bThe portal here will take you to the Darkmoon Faire.$b$bBut if you have any questions before you go, I can answer them.',26124),
(53399,'enUS','The Darkmoon Faire is filled with all sorts of amazing attractions.  We have a fortune teller, a concert, a fishing contest and a lot of games.$b$bWe are constantly expanding the faire with all manner of new attractions!$b$bAre there any attractions you\'d like more information on?','The Darkmoon Faire is filled with all sorts of amazing attractions.  We have a fortune teller, a concert, a fishing contest and a lot of games.$b$bWe are constantly expanding the faire with all manner of new attractions!$b$bAre there any attractions you\'d like more information on?',26124),
(53400,'enUS','Are there tonks?','Are there tonks?',26124),
(53401,'enUS','Miniature tanks, or Tonks as we\'ve cleverly named them, have been a faire favorite for as long as I can remember.$b$bWe have two arenas dedicated for tonk battles.$b$bOne arena pits you against the clock as you race to destroy targets, and avoid the enemy tonks.  You just need a game token to play!$b$bThe other arena is a place where you can use your own tonks or MiniZeps to battle your friends.','Miniature tanks, or Tonks as we\'ve cleverly named them, have been a faire favorite for as long as I can remember.$b$bWe have two arenas dedicated for tonk battles.$b$bOne arena pits you against the clock as you race to destroy targets, and avoid the enemy tonks.  You just need a game token to play!$b$bThe other arena is a place where you can use your own tonks or MiniZeps to battle your friends.',26124),
(53402,'enUS','The Blastenheimer 5000 Ultra Cannon is a state-of-the-art single person projectile device.$b$bDelivering its payload at near the speed of a dragon, the cannon is the pride and joy of the Blastenheimer family, world renowned for their aeronautical and combustible feats!$B$BIf you\'d like to be launched through the skies to fly free as a bird, seek out Maxima Blastenheimer.','The Blastenheimer 5000 Ultra Cannon is a state-of-the-art single person projectile device.$b$bDelivering its payload at near the speed of a dragon, the cannon is the pride and joy of the Blastenheimer family, world renowned for their aeronautical and combustible feats!$B$BIf you\'d like to be launched through the skies to fly free as a bird, seek out Maxima Blastenheimer.',26124),
(53403,'enUS','Whack-a-Gnoll?','Whack-a-Gnoll?',26124),
(53404,'enUS','Whack-a-Gnoll is a fun-filled game of whacking... gnolls.$b$bIt\'s a new attraction, and quite popular among us... Well, Sayge isn\'t too fond of it.','Whack-a-Gnoll is a fun-filled game of whacking... gnolls.$b$bIt\'s a new attraction, and quite popular among us... Well, Sayge isn\'t too fond of it.',26124),
(53405,'enUS','There! Go! GO!!!','',26124),
(53406,'enUS','The portal is closing! Hurry!','',26124),
(53407,'enUS','Officer: Looks like we\'ve made it through enemy lines, General.','',26124),
(53408,'enUS','Officer: Still no sign of the missing transport.','',26124),
(53409,'enUS','Nazgrim: We\'re not returning until we discover its fate - even if we have to scour the sea floor!','',26124),
(53410,'enUS','Nazgrim: ...and you know how I feel about that idea...','',26124),
(53411,'enUS','Goblin: Land ho!','',26124),
(53412,'enUS','Nazgrim: Land? Here? Impossible!','',26124),
(53413,'enUS','$n, you have no idea how glad I am to see you. Supervising is hungry work.','',26124),
(53414,'enUS','We like to make sure that faire goers of all ages can enjoy the games.$b$bRing Toss is a simple game where you try to land a ring on the back of a moving turtle.$b$bIt\'s one of my favorite games to play.','We like to make sure that faire goers of all ages can enjoy the games.$b$bRing Toss is a simple game where you try to land a ring on the back of a moving turtle.$b$bIt\'s one of my favorite games to play.',26124),
(53415,'enUS','Ring Toss?','Ring Toss?',26124),
(53416,'enUS','Rinling runs the shooting gallery.$b$bThere are only three targets to hit, and the faster you are, the better you do.$b$bPersonally, it\'s one of my favorite games.','Rinling runs the shooting gallery.$b$bThere are only three targets to hit, and the faster you are, the better you do.$b$bPersonally, it\'s one of my favorite games.',26124),
(53417,'enUS','Shooting Gallery?','Shooting Gallery?',26124),
(53418,'enUS','I highly recommend that you visit Sayge to get your fortune told.$b$bI know, I know... he\'s a gnoll.  But he\'s a very special gnoll with the power to divine your future!','I highly recommend that you visit Sayge to get your fortune told.$b$bI know, I know... he\'s a gnoll.  But he\'s a very special gnoll with the power to divine your future!',26124),
(53419,'enUS','Fortune teller?','Fortune teller?',26124),
(53420,'enUS','','Did my son send you? There\'s plenty of stew to go around. Please, help yourself.',26124),
(53421,'enUS','Hello $c, and welcome to the Darkmoon Faire.$b$bThere is so much to do here at the faire that it can be a little overwhelming for our first time visitors. That\'s why I\'m here to help.$b$bDo you have any questions?','Hello $c, and welcome to the Darkmoon Faire.$b$bThere is so much to do here at the faire that it can be a little overwhelming for our first time visitors. That\'s why I\'m here to help.$b$bDo you have any questions?',26124),
(53422,'enUS','They came from nowhere! There was nothing we could do...','',26124),
(53423,'enUS','Such fragile creatures. Worthless!','',26124),
(53424,'enUS','','I wouldn\'t expect a recruit to perform well in this situation, but try your best.',26124),
(53425,'enUS','','We can save this one, but we must be quick.',26124),
(53426,'enUS','','If the crewman is choking, we can deliver Air to temporarily stabilize their falling vitals.',26124),
(53427,'enUS','','Compress the patient\'s chest to steadily improve their vitals.',26124),
(53428,'enUS','','Electric Shock can be used to increase the patient\'s vitals a great deal. However, we cannot use this frequently.',26124),
(53429,'enUS','','You actually saved one! I must admit, I had some doubts.',26124),
(53430,'enUS','','Oh no, we\'ve lost a patient. Do not despair, $n. They were too far gone already.',26124),
(53431,'enUS','','We cannot save them all, $n. Let us move on to someone who may yet respond to our treatment.',26124),
(53432,'enUS','','$n! CAN YOU HEAR ME? Just checking to see if you\'re paying attention.',26124),
(53433,'enUS','','I never had any talent with healing powers, but I found my calling in the medic\'s craft. Potions, bandages, and other triage methods can go a long way!',26124),
(53434,'enUS','','I do hope that the other agents made it. Otherwise, I\'ll have more work to do.',26124),
(53435,'enUS','','It is good of us to help the survivors here, but we must not lose sight of our original mission.',26124),
(53436,'enUS','','Let us hope that the Horde have not yet found this place. They will wish to seize it for their own.',26124),
(53437,'enUS','','It is a shame we lost our own planes during our arrival. It will make our extraction mission a bit more...challenging.',26124),
(53438,'enUS','Never stop fighting. Never stop practicing. You are never perfect.','',26124),
(53439,'enUS','Never forget those that came before you. Never forget where you came from.','',26124),
(53440,'enUS','Never put yourself ahead of others. Never forget that this land is shared by many.','',26124),
(53441,'enUS','Never forget those that you love. Never forget what you\'re fighting for.','',26124),
(53442,'enUS','Kargath Bladefist has fallen! For the Horde!','',26124),
(53443,'enUS','Caza\'rez was not as lucky as I was, $n. He rests with the spirits now.','',26124),
(53444,'enUS','Ugh... My head still swims, friend. Come, show me the wreckage.','',26124),
(53445,'enUS','My men. All dead? No...','',26124),
(53446,'enUS','I\'m afraid Gunny didn\'t make it, $n.','',26124),
(53447,'enUS','Kargath Bladefist has been slain! Long live the Alliance!','',26124),
(53448,'enUS','Hey, hey $c! Think you can land a ring on a slow moving turtle?','Hey, hey $c! Think you can land a ring on a slow moving turtle?',26124),
(53449,'enUS','You look like you\'ve got quite the arm there. Care to give this game a try?','You look like you\'ve got quite the arm there. Care to give this game a try?',26124),
(53450,'enUS','Simple game, for simple folk. Think you can manage it?','Simple game, for simple folk. Think you can manage it?',26124),
(53451,'enUS','Toss a ring, win a prize!','Toss a ring, win a prize!',26124),
(53452,'enUS','Test your aim! Test your aim!','Test your aim! Test your aim!',26124),
(53453,'enUS','Come play a game so simple that even a $c can do it!','Come play a game so simple that even a $c can do it!',26124),
(53454,'enUS','Shoot for loot! Who wants to shoot for some loot?','Shoot for loot! Who wants to shoot for some loot?',26124),
(53455,'enUS','Guns, guns, guns! C\'mon, pal!','Guns, guns, guns! C\'mon, pal!',26124),
(53456,'enUS','Step right up and take your best shot!','Step right up and take your best shot!',26124),
(53457,'enUS','Folks, I\'m handing out epics over here! Don\'t miss out!','Folks, I\'m handing out epics over here! Don\'t miss out!',26124),
(53458,'enUS','Test your skill, win a prize!','Test your skill, win a prize!',26124),
(53459,'enUS','If you can shoot, you can score some sweet prizes!','If you can shoot, you can score some sweet prizes!',26124),
(53460,'enUS','Find any survivors, $n. We\'re sure to need them...','',26124),
(53461,'enUS','Tonks! We got tonks here!','Tonks! We got tonks here!',26124),
(53462,'enUS','Step right up and try a tonk!','Step right up and try a tonk!',26124),
(53463,'enUS','We\'re under attack! Step up and do your part, $c!','We\'re under attack! Step up and do your part, $c!',26124),
(53464,'enUS','Hey, hey! Command a tonk in glorious battle!','Hey, hey! Command a tonk in glorious battle!',26124),
(53465,'enUS','Transportation to the other end of the faire!','Transportation to the other end of the faire!',26124),
(53466,'enUS','Cannon blast!  Who wants to get shot out of a cannon?','Cannon blast!  Who wants to get shot out of a cannon?',26124),
(53467,'enUS','Step up to get blown up!','Step up to get blown up!',26124),
(53468,'enUS','Don\'t worry about your weight, this cannon can handle any payload!','Don\'t worry about your weight, this cannon can handle any payload!',26124),
(53469,'enUS','Hammer time!','Hammer time!',26124),
(53470,'enUS','Whack some gnolls! Step right up and whack some gnolls!','Whack some gnolls! Step right up and whack some gnolls!',26124),
(53471,'enUS','Hammer swingin\' fun! Who wants to swing a hammer?','Hammer swingin\' fun! Who wants to swing a hammer?',26124),
(53472,'enUS','Swing a hammer, win a prize!','Swing a hammer, win a prize!',26124),
(53473,'enUS','','I... I barely made it off the ship before it went down!',26124),
(53474,'enUS','Snap out of it! You\'re alive! Nazgrim has ordered us to report to the nearby village.','Snap out of it! You\'re alive! Nazgrim has ordered us to report to the nearby village.',26124),
(53475,'enUS','','Thank you. I\'ll make my way to the village. Stay safe...',26124),
(53476,'enUS','','Now entering the arena: $n!',26124),
(53477,'enUS','','And now... let the Rumpus start!',26124),
(53478,'enUS','','Halfway there, $n. Keep it up!',26124),
(53479,'enUS','','You\'re nearly done, $n!',26124),
(53480,'enUS','','Congratulations to $n, victor of the Rumpus!',26124),
(53481,'enUS','Gregarious Grell Pet','Gregarious Grell Pet',26124),
(53482,'enUS','Ogre Mage Costume','Ogre Mage Costume',26124),
(53483,'enUS','Corrupted Hippogryph','Corrupted Hippogryph',26124),
(53484,'enUS','Get me outta here, $n! This lady is going to kill me!','',26124),
(53485,'enUS','Quit messing around and use your knife! Nazgrim wants you to report to the village immediately.','Quit messing around and use your knife! Nazgrim wants you to report to the village immediately.',26124),
(53487,'enUS','Oh alright! Don\'t get your trousers in a bunch!','',26124),
(53488,'enUS','','Better luck next time, $n. Try using some abilities that hit more than one enemy at a time!',26124),
(53489,'enUS','The King\'s royal banner. Someone of royal blood certainly slept in this chamber.','The King\'s royal banner. Someone of royal blood certainly slept in this chamber.',26124),
(53490,'enUS','This soldier is not like the others. He looks like a personal bodyguard.','This soldier is not like the others. He looks like a personal bodyguard.',26124),
(53491,'enUS','Monogrammed on the leather cover are the initials, \"A.L.W.\" \n\nYou take the few intact pages that remain.','Monogrammed on the leather cover are the initials, \"A.L.W.\" \n\nYou take the few intact pages that remain.',26124),
(53492,'enUS','Sand Scarab Pet','Sand Scarab Pet',26124),
(53493,'enUS','I shouldn\'t be alive, $r.$b$bI should have died with the rest of my brothers.','',26124),
(53494,'enUS','We need to regroup, Sergeant! Go to the nearby village.','We need to regroup, Sergeant! Go to the nearby village.',26124),
(53495,'enUS','Spurious Sarcophagus','Spurious Sarcophagus',26124),
(53496,'enUS','White Riding Camel','White Riding Camel',26124),
(53497,'enUS','Crown of Heaven','Crown of Heaven',26124),
(53498,'enUS','Tomb of the Forgotten','Tomb of the Forgotten',26124),
(53499,'enUS','Yes, $c, no time for mourning. Let us avenge our fallen brethren and claim this land for the Horde!','',26124),
(53500,'enUS','You find a stack of partially soaked pages, written in the Prince\'s hand. You\'d better take them back to Nodd.','You find a stack of partially soaked pages, written in the Prince\'s hand. You\'d better take them back to Nodd.',26124),
(53501,'enUS','This set up sure is hard work.','This set up sure is hard work.',26124),
(53503,'enUS','','What happened?$b$bWh-where are we?',26124),
(53504,'enUS','On your feet! Nazgrim is organizing a counter-attack. We\'re regrouping in the village.','On your feet! Nazgrim is organizing a counter-attack. We\'re regrouping in the village.',26124),
(53505,'enUS','','Regrouping... In the village... I think I can make it.',26124),
(53506,'enUS','The map shows a naval strategy for defeating the Horde fleet.','The map shows a naval strategy for defeating the Horde fleet.',26124),
(53507,'enUS','The cannon is dented and streaked with gunpowder.','The cannon is dented and streaked with gunpowder.',26124),
(53508,'enUS','Looks like the deck swabbing assignments from the day of the battle.','Looks like the deck swabbing assignments from the day of the battle.',26124),
(53509,'enUS','','The General is determined to set up camp here.$b$bI hope he knows what he\'s doing...',26124),
(53510,'enUS','This Horde sailor likely met his end during the battle.','This Horde sailor likely met his end during the battle.',26124),
(53511,'enUS','LEFT!','',26124),
(53512,'enUS','RIGHT!','',26124),
(53513,'enUS','You will burn!','',26124),
(53514,'enUS','Die!','',26124),
(53515,'enUS','Your end has come!','',26124),
(53516,'enUS','Unstable solenoids are unstable! RUN!','',26124),
(53522,'enUS','Thank you, stranger.','',26124),
(53523,'enUS','May the sacred pools bless you.','',26124),
(53524,'enUS','The elders will hear of your kindness.','',26124),
(53525,'enUS','I am in your debt, stranger.','',26124),
(53526,'enUS','I...I\'m free? Thank you, $gbrother:sister;.','',26124),
(53527,'enUS','See? I\'m helping by picking up this full mug of ale that someone left on the ground.','',26124),
(53529,'enUS','%s mumbles incoherently to himself.','',26124),
(53531,'enUS','%s rests his head in his hands and weeps.','',26124),
(53532,'enUS','%s rocks back and forth gently.','',26124),
(53533,'enUS','I heard everything, $n. Go ahead to the camp and I\'ll meet you there.','',26124),
(53534,'enUS','Blood for the Thunder King!','',26124),
(53535,'enUS','The lesser races will learn to once again fear the mogu!','',26124),
(53536,'enUS','YEEAARRGHH!!!','',26124),
(53537,'enUS','GRAAAAHHH!!','',26124),
(53541,'enUS','Why would they do something like this?','Why would they do something like this?',26124),
(53542,'enUS','Are the others okay?','Are the others okay?',26124),
(53543,'enUS','You don\'t have to tell me twice!','You don\'t have to tell me twice!',26124),
(53544,'enUS','They\'re dragging people away!','They\'re dragging people away!',26124),
(53546,'enUS','I thought I was done for!','I thought I was done for!',26124),
(53547,'enUS','Give \'em hell for me!','Give \'em hell for me!',26124),
(53548,'enUS','Please tell me Hanae is safe!','Please tell me Hanae is safe!',26124),
(53549,'enUS','Are you Shao\'s friend? Is he still alive?','Are you Shao\'s friend? Is he still alive?',26124),
(53553,'enUS','Beware. Enemies approach!','',26124),
(53554,'enUS','Thank you so much!','Thank you so much!',26124),
(53555,'enUS','I hope the orchard is still intact...','I hope the orchard is still intact...',26124),
(53556,'enUS','Free at last! I need a drink...','Free at last! I need a drink...',26124),
(53557,'enUS','I never thought something like this could happen to our little orchard.','I never thought something like this could happen to our little orchard.',26124),
(53558,'enUS','Ah, much better. Those bindings were so tight.','Ah, much better. Those bindings were so tight.',26124),
(53559,'enUS','I\'m moving back to the capital after this.','I\'m moving back to the capital after this.',26124),
(53560,'enUS','I\'ll be fine, please help the others!','I\'ll be fine, please help the others!',26124),
(53561,'enUS','Thank you, I don\'t even want to know what they were planning to do with us.','Thank you, I don\'t even want to know what they were planning to do with us.',26124),
(53563,'enUS','For Pandaria!','For Pandaria!',26124),
(53564,'enUS','You\'ve underestimated us!','You\'ve underestimated us!',26124),
(53565,'enUS','You won\'t make slaves out of us!','You won\'t make slaves out of us!',26124),
(53566,'enUS','We\'ll never yield to the mogu!','We\'ll never yield to the mogu!',26124),
(53569,'enUS','Fair and honest combat is the only true test of one\'s strength. Any other test is tainted.','',26124),
(53570,'enUS','Age has caught up with me it seems.  I cannot move as I once could, and so I\'ve little left to offer my once friend...','',26124),
(53571,'enUS','If you are strong, then I give you respect.$b$bIf you are weak, then I give you encouragement.$b$bIf you are my enemy, then I give you my fist. Several times over, if necessary.','',26124),
(53572,'enUS','Achieve clarity through combat. Enlightenment through engagement. Peace through punching.$b$bSuch is the Tian way.','',26124),
(53573,'enUS','Discipline is the key to perfection. Defeat your sloth! Master your laziness!','',26124),
(53574,'enUS','My father was High Elder before Cloudfall. He taught me everything that I know.','',26124),
(53575,'enUS','There is nothing that cannot be mastered through repetition.','',26124),
(53576,'enUS','I am ready to practice again, Instructor.','I am ready to practice again, Instructor.',26124),
(53577,'enUS','It\'s a good thing you came along - I could not resolve this alone.','',26124),
(53578,'enUS','Three cheers for $n! Three cheers, and three beers!','',26124),
(53579,'enUS','','Enter the Rumpus Pit, then set off the firework. Be prepared to fight several enemies at once! Anything can happen in the Rumpus.',26124),
(53581,'enUS','Join the students in the block formation below. Then follow the leader, as they do.','',26124),
(53582,'enUS','I will yell out commands for \"Left\" and \"Right\". Pay close attention, $c.','',26124),
(53584,'enUS','MALORNE MALORNE MALORNE','',26124),
(53591,'enUS','This faire is great!','This faire is great!',26124),
(53592,'enUS','We are supposed to play here, but I bet we could wander around and not get in too much trouble.','We are supposed to play here, but I bet we could wander around and not get in too much trouble.',26124),
(53593,'enUS','I wonder how often the sandbox gets cleaned.','I wonder how often the sandbox gets cleaned.',26124),
(53594,'enUS','This sandbox is pretty boring.','This sandbox is pretty boring.',26124),
(53595,'enUS','The sandbox is crowded...','The sandbox is crowded...',26124),
(53596,'enUS','Only babies play in the sandbox.','Only babies play in the sandbox.',26124),
(53597,'enUS','I wonder what those bones are from.','I wonder what those bones are from.',26124),
(53598,'enUS','We should go explore the rest of the faire!','We should go explore the rest of the faire!',26124),
(53599,'enUS','Whoa!','Whoa!',26124),
(53600,'enUS','Look at all the explosions!','Look at all the explosions!',26124),
(53601,'enUS','I had a tonk, but my sister broke it...','I had a tonk, but my sister broke it...',26124),
(53602,'enUS','BOOM!','BOOM!',26124),
(53603,'enUS','KABOOM!','KABOOM!',26124),
(53604,'enUS','Those tonks are dangerous!','Those tonks are dangerous!',26124),
(53605,'enUS','We should run around and stomp on all the houses!','We should run around and stomp on all the houses!',26124),
(53606,'enUS','I could beat all those tonks.','I could beat all those tonks.',26124),
(53607,'enUS','That cannon is huge!','That cannon is huge!',26124),
(53608,'enUS','I bet I could land exactly in the target.','I bet I could land exactly in the target.',26124),
(53609,'enUS','After all the punching, and the kicking, and the eating, and the drinking... someone\'s got to clean up.$b$bThat\'s where the groundskeeper comes in.','',26124),
(53610,'enUS','Why don\'t people get shot out of cannons all the time?','Why don\'t people get shot out of cannons all the time?',26124),
(53611,'enUS','You can keep your stick-fighting and your mist-weaving to yourselves. I\'m perfectly happy standing here and watching.','',26124),
(53612,'enUS','What are the cannon balls for?  Do they let you carry one?','What are the cannon balls for?  Do they let you carry one?',26124),
(53613,'enUS','Whoosh!  Flying must be fun!','Whoosh!  Flying must be fun!',26124),
(53614,'enUS','They should aim the cannon straight up.','They should aim the cannon straight up.',26124),
(53615,'enUS','Do you know what happens if you slack off in all of your monastery classes? You become a groundskeeper, that\'s what happens.$b$bIt\'s not all bad though. I get my own broom.$b$b<Wu sighs.>','',26124),
(53616,'enUS','What if a bird flew into you while you were flying?','What if a bird flew into you while you were flying?',26124),
(53617,'enUS','I wonder if we could all get launched out together...','I wonder if we could all get launched out together...',26124),
(53618,'enUS','Juggling fire has got to be scary!','Juggling fire has got to be scary!',26124),
(53619,'enUS','I wonder if they ever burn themselves.','I wonder if they ever burn themselves.',26124),
(53620,'enUS','Mmm... stew...','',26124),
(53621,'enUS','MINE!','',26124),
(53622,'enUS','Gimme gimme gimme...','',26124),
(53623,'enUS','I heard that if you can breathe fire, then you are part dragon!','I heard that if you can breathe fire, then you are part dragon!',26124),
(53624,'enUS','I want to eat it.','',26124),
(53625,'enUS','Smell good!','',26124),
(53626,'enUS','Stew, stew, stew, stew...','',26124),
(53627,'enUS','Want to eat the stew! Want to eat the stew!','',26124),
(53628,'enUS','Fire juggling looks pretty hard.','Fire juggling looks pretty hard.',26124),
(53629,'enUS','What I smell?','',26124),
(53630,'enUS','Fire is scary, but fire flying through the air is even scarier.','Fire is scary, but fire flying through the air is even scarier.',26124),
(53631,'enUS','They are amazing!','They are amazing!',26124),
(53632,'enUS','When I grow up I want to be a fire juggler!','When I grow up I want to be a fire juggler!',26124),
(53633,'enUS','I think I could juggle fire if I tried.','I think I could juggle fire if I tried.',26124),
(53635,'enUS','','Until recently, the mogu in this region have been content to ambush travelers in the woods. This raid was different; they are organized... filled with purpose.',26124),
(53636,'enUS','','You\'re the first person to come through that door who isn\'t in shock, injured, or both.$B$BI\'m hoping that means you can help.',26124),
(53637,'enUS','Go! Get to safety!','Go! Get to safety!',26124),
(53638,'enUS','Leave that behind, it\'s not worth it!','Leave that behind, it\'s not worth it!',26124),
(53644,'enUS','','It\'s a monastery, of course!$b$bThe monks here at Tian Monastery specialize in teaching young pandaren - like me - how to fight. All the great fighters started here: Yu Ming the Blade, Liang the Unbreakable... even the great emperor Shaohao studied at this very temple.$b$bOr so the legends say.',26124),
(53645,'enUS','','Welcome to our home in the hills, $r.',26124),
(53646,'enUS','','Hello! And welcome!',26124),
(53647,'enUS','What is this place?','What is this place?',26124),
(53652,'enUS','What the-?! Why did you-?! I have TOYS to make!','What the-?! Why did you-?! I have TOYS to make!',26124),
(53653,'enUS','It\'s not Winter Veil yet, you know. I have WORK to do!','It\'s not Winter Veil yet, you know. I have WORK to do!',26124),
(53654,'enUS','We\'ll need twenty thousand more cog wheels, and another... hey! You can\'t just summon me away like that!','We\'ll need twenty thousand more cog wheels, and another... hey! You can\'t just summon me away like that!',26124),
(53655,'enUS','So, did you hear about Helper 432-A? I heard that... what the-? HEY! We Helpers have WORK to do, you know!','So, did you hear about Helper 432-A? I heard that... what the-? HEY! We Helpers have WORK to do, you know!',26124),
(53656,'enUS','Does it LOOK like the Feast of Winter Veil to you? Colored lights, decorations? No? Well, you know who has to MAKE all of that stuff, right?!','Does it LOOK like the Feast of Winter Veil to you? Colored lights, decorations? No? Well, you know who has to MAKE all of that stuff, right?!',26124),
(53657,'enUS','Look, $c. Here\'s the thing. Toys and lights and bundles of holiday herbs don\'t make THEMSELVES, you know. So ENOUGH with the Helper summoning, PLEASE.','Look, $c. Here\'s the thing. Toys and lights and bundles of holiday herbs don\'t make THEMSELVES, you know. So ENOUGH with the Helper summoning, PLEASE.',26124),
(53658,'enUS','What the-? AGAIN?! Look, $c. As much as I\'d like to watch you punch monsters or mouthbreathe at the auction house or WHATEVER it is you do all year, I\'ve got WORK to do.','What the-? AGAIN?! Look, $c. As much as I\'d like to watch you punch monsters or mouthbreathe at the auction house or WHATEVER it is you do all year, I\'ve got WORK to do.',26124),
(53659,'enUS','Whoah! Where\'s the workshop?! Summon me up a little later in the year, all right?','Whoah! Where\'s the workshop?! Summon me up a little later in the year, all right?',26124),
(53660,'enUS','Step right up and get your game tokens!','Step right up and get your game tokens!',26124),
(53661,'enUS','Tokens! Tokens! Tokens!','Tokens! Tokens! Tokens!',26124),
(53662,'enUS','Tokens! Get your tokens!','Tokens! Get your tokens!',26124),
(53663,'enUS','You gotta pay to play, folks! Come and get your game tokens!','You gotta pay to play, folks! Come and get your game tokens!',26124),
(53664,'enUS','Game tokens for sale! Come get your game tokens!','Game tokens for sale! Come get your game tokens!',26124),
(53665,'enUS','You\'ll need game tokens to play the games. Come and get your game tokens!','You\'ll need game tokens to play the games. Come and get your game tokens!',26124),
(53666,'enUS','Hurry, hurry, hurry! Step right up and purchase your game tokens!','Hurry, hurry, hurry! Step right up and purchase your game tokens!',26124),
(53667,'enUS','Hey, hey, I ain\'t jokin\', step on up and buy a game token!','Hey, hey, I ain\'t jokin\', step on up and buy a game token!',26124),
(53675,'enUS','It\'s safe now.  You can come down.','It\'s safe now.  You can come down.',26124),
(53677,'enUS','Eep!  Save me from the monsters!','',26124),
(53679,'enUS','The Tauren Chieftains concert will begin in thirty minutes!','',26124),
(53680,'enUS','The Tauren Chieftains concert will begin in fifteen minutes!','',26124),
(53681,'enUS','The Tauren Chieftains concert will begin in five minutes!','',26124),
(53682,'enUS','Fairegoers, are you ready to rock?! The Tauren Chieftain concert now begins!','',26124),
(53683,'enUS','That Jade Witch is super spooky.','',26124),
(53684,'enUS','','Eep! It\'s the Jade Witch! I need to hide!',26124),
(53685,'enUS','I heard this game is pretty easy.','I heard this game is pretty easy.',26124),
(53686,'enUS','I hope the rings don\'t hurt the turtle.','I hope the rings don\'t hurt the turtle.',26124),
(53687,'enUS','I wish I had a pet turtle.','I wish I had a pet turtle.',26124),
(53688,'enUS','My friend had a pet turtle, but he gave it away as a gift.','My friend had a pet turtle, but he gave it away as a gift.',26124),
(53689,'enUS','Ring toss is outrageous.','Ring toss is outrageous.',26124),
(53691,'enUS','I wish I could play ring toss.','I wish I could play ring toss.',26124),
(53692,'enUS','This is my favorite game, because of the turtle.','This is my favorite game, because of the turtle.',26124),
(53693,'enUS','I bet the turtle likes being close to the other animals.','I bet the turtle likes being close to the other animals.',26124),
(53694,'enUS','Yum!','Yum!',26124),
(53695,'enUS','I love cake!','I love cake!',26124),
(53696,'enUS','The pink hearts are pretty!','The pink hearts are pretty!',26124),
(53697,'enUS','I\'m sorry, but Lorna\'d be real mad if I let you take a horse.\n\nThey\'re only for friends of Gilneas!','I\'m sorry, but Lorna\'d be real mad if I let you take a horse.\n\nThey\'re only for friends of Gilneas!',26124),
(53698,'enUS','The cupcakes look delicious!','The cupcakes look delicious!',26124),
(53699,'enUS','Some of those cake designs are outrageous!','Some of those cake designs are outrageous!',26124),
(53700,'enUS','I\'m sorry, but Lorna\'d be real mad if I let you take a horse.\n\nThey\'re only for those who are exalted with Gilneas!','I\'m sorry, but Lorna\'d be real mad if I let you take a horse.\n\nThey\'re only for those who are exalted with Gilneas!',26124),
(53701,'enUS','I like cake more than pie.','I like cake more than pie.',26124),
(53702,'enUS','Everything looks so good.','Everything looks so good.',26124),
(53703,'enUS','Aimee is very nice.','Aimee is very nice.',26124),
(53704,'enUS','Lorna said a truly brave adventurer helped rescue many of the horses near her family\'s orchard.\n\nI offered to take care of those that made it across the sea with us. I learned how from my mother and father, Light bless them!\n\nWere you interested in a fine Gilnean steed...?','Lorna said a truly brave adventurer helped rescue many of the horses near her family\'s orchard.\n\nI offered to take care of those that made it across the sea with us. I learned how from my mother and father, Light bless them!\n\nWere you interested in a fine Gilnean steed...?',26124),
(53705,'enUS','Wow!','Wow!',26124),
(53706,'enUS','There are so many things to buy.','There are so many things to buy.',26124),
(53707,'enUS','Oooh, look at that!','Oooh, look at that!',26124),
(53708,'enUS','Shiny!','Shiny!',26124),
(53709,'enUS','Some of the things here are so glamourous.','Some of the things here are so glamourous.',26124),
(53710,'enUS','Needs more glitter...','Needs more glitter...',26124),
(53711,'enUS','I wonder how long it would take to get all of this?','I wonder how long it would take to get all of this?',26124),
(53712,'enUS','Everything is so nice!','Everything is so nice!',26124),
(53713,'enUS','She\'s sooo strong!','She\'s sooo strong!',26124),
(53714,'enUS','I heard she\'s the strongest woman in the world!','I heard she\'s the strongest woman in the world!',26124),
(53715,'enUS','I think the boys are afraid of her!','I think the boys are afraid of her!',26124),
(53716,'enUS','I want to be like Kerri when I grow up!','I want to be like Kerri when I grow up!',26124),
(53717,'enUS','I wonder what it\'s like to have so much fame?','I wonder what it\'s like to have so much fame?',26124),
(53718,'enUS','She\'s tall!','She\'s tall!',26124),
(53719,'enUS','Her strength is truly outrageous!','Her strength is truly outrageous!',26124),
(53720,'enUS','I bet no one gets in her way.','I bet no one gets in her way.',26124),
(53721,'enUS','Awww...','Awww...',26124),
(53722,'enUS','Awww...  They are hurt.','Awww...  They are hurt.',26124),
(53723,'enUS','Poor workers...','Poor workers...',26124),
(53724,'enUS','I hope they get better.','I hope they get better.',26124),
(53725,'enUS','So many are hurt, that can\'t be good.','So many are hurt, that can\'t be good.',26124),
(53726,'enUS','I wonder how they got hurt.','I wonder how they got hurt.',26124),
(53727,'enUS','I hope they\'ll be okay.','I hope they\'ll be okay.',26124),
(53728,'enUS','It\'s truly outrageous that so many workers are hurt.','It\'s truly outrageous that so many workers are hurt.',26124),
(53731,'enUS','Spooky...','Spooky...',26124),
(53732,'enUS','Mysterious...','Mysterious...',26124),
(53733,'enUS','The boys are afraid of Sayge, that\'s why they stay away.','The boys are afraid of Sayge, that\'s why they stay away.',26124),
(53734,'enUS','I wonder if the fortunes are real...','I wonder if the fortunes are real...',26124),
(53735,'enUS','I wonder if Sayge plays Whack-a-Gnoll?','I wonder if Sayge plays Whack-a-Gnoll?',26124),
(53737,'enUS','Sayge seems pretty nice...','Sayge seems pretty nice...',26124),
(53738,'enUS','I\'ve heard some people got outrageous fortunes.','I\'ve heard some people got outrageous fortunes.',26124),
(53739,'enUS','It\'s kind of scary looking...','It\'s kind of scary looking...',26124),
(53743,'enUS','You picked a nice time to show up, friend. We need every Alliance soldier to pitch in.','',26124),
(53744,'enUS','I don\'t know how we did it, but we managed to fend off those hozen.$B$BThanks to you, mate.','',26124),
(53745,'enUS','Brace yourself!','',26124),
(53746,'enUS','Things are looking up for us, $n. Now that the attacks are over, we can finally work on repairing our ships to find a way home.','',26124),
(53748,'enUS','<He looks like he was knocked unconscious in all the fighting.>$B$B<He clutches tightly to a leather bag.>','',26124),
(53749,'enUS','My skull feels like it was hit by a hammer, but otherwise I\'m all right. That\'s more than I can say for most of the crew.','',26124),
(53750,'enUS','Rifle through his bag.','Rifle through his bag.',26124),
(53751,'enUS','','...and with that out of the way, you and your flock of fumbling friends are next on my list. Mmm, I thought you\'d never get here!',26124),
(53754,'enUS','Mysteries and wonders surround us every day, not just at the faire.  We\'ve compiled a list of some of the wonders you may encounter in your every day business.  The Darkmoon Adventurer\'s Guide will help you navigate the wonders of the world.$b$bWith the guide in your possession, you may come across items you never knew existed.  Items you may have taken for granted in the past are now treasures that others long for.$b$bKeep the guide with you, and keep your eyes open for mystery.$b$bIf you happen to lose your guide, seek us out and we will replace it for free.','Mysteries and wonders surround us every day, not just at the faire.  We\'ve compiled a list of some of the wonders you may encounter in your every day business.  The Darkmoon Adventurer\'s Guide will help you navigate the wonders of the world.$b$bWith the guide in your possession, you may come across items you never knew existed.  Items you may have taken for granted in the past are now treasures that others long for.$b$bKeep the guide with you, and keep your eyes open for mystery.$b$bIf you happen to lose your guide, seek us out and we will replace it for free.',26124),
(53755,'enUS','Darkmoon Adventurer\'s Guide?','Darkmoon Adventurer\'s Guide?',26124),
(53756,'enUS','May I have another Darkmoon Adventurer\'s Guide?','May I have another Darkmoon Adventurer\'s Guide?',26124),
(53757,'enUS','Death to all who oppose us!','Death to all who oppose us!',26124),
(53758,'enUS','What do you have for sale?','What do you have for sale?',26124),
(53760,'enUS','','We\'ve been stranded here for days. We are stretched to the breaking point, but trying our best to keep spirits high.',26124),
(53764,'enUS','','The... the monkeys... they attacked...$b$bI fought them off, but... they\'ll be back... with more...',26124),
(53765,'enUS','You did well, Agent Kearnen. Now save your energy... we\'ll fend them off.','You did well, Agent Kearnen. Now save your energy... we\'ll fend them off.',26124),
(53769,'enUS','<Rell does not look up to address you.>$b$b<Judging by his state, you\'re not certain he even has the energy to move his head.>','',26124),
(53770,'enUS','Please, continue your report.','Please, continue your report.',26124),
(53772,'enUS','You need something built or broken? Stripped or soldered? Cracked or cobbled? You\'ve come to the right engineer.','',26124),
(53773,'enUS','At the dawn of the year, we elders visit briefly to offer counsel to the living and welcome those who have joined the ancestors.','',26124),
(53775,'enUS','Aw shoot, aw shoot, aw shoot...','',26124),
(53777,'enUS','Keep telling your story, Sully.','Keep telling your story, Sully.',26124),
(53783,'enUS','The features of this jade statue are incredibly lifelike.  The expression on the face is one locked in horror.$b$BIt does not resemble Shin however.','The features of this jade statue are incredibly lifelike.  The expression on the face is one locked in horror.$b$BIt does not resemble Shin however.',26124),
(53784,'enUS','Examine the statue','Examine the statue',26124),
(53786,'enUS','','Stop!  You will NOT turn my friends into stupid statues!',26124),
(53787,'enUS','|TInterface\\Icons\\ability_shaman_cleansespirit.blp:16|tThrall casts |cFF00FFFF|Hspell:103550|h[Cleanse Spirit]|h|r on you!','',26124),
(53788,'enUS','I\'m glad that these \"SI:7\" people decided to take me with.$b$bWe do not leave the comforts of our lake very often at all. This was the farthest I\'ve ever been from home.','',26124),
(53789,'enUS','What happened next, Little Lu?','What happened next, Little Lu?',26124),
(53790,'enUS','What? Is that...is that a $r I see? Thank you for rescuing me.','',26124),
(53791,'enUS','Fortunately, you can still make out enough detail to sketch what looks to be a creature\'s torso.','',26124),
(53792,'enUS','<Create a sketch of the statue piece.>','<Create a sketch of the statue piece.>',26124),
(53793,'enUS','This portion of the statue tells you little, other than the subject actually had arms...','',26124),
(53794,'enUS','The Darkmoon Faire is now open!$b$bFor a small fee, I can teleport you to the fairground staging area.$b$bWould you like to go?','The Darkmoon Faire is now open!$b$bFor a small fee, I can teleport you to the fairground staging area.$b$bWould you like to go?',26124),
(53795,'enUS','The statue\'s shoulder looks quite imposing in relation to the rest of its features. The subject was clearly a mighty creature!$b$bPerhaps it\'s a good natured sort. Or if not, then maybe it\'s extinct!$b$bOne can hope...','',26124),
(53796,'enUS','My people do not like strangers, but I owe you this much. May the elders not punish me for this deed.','',26124),
(53797,'enUS','Shaman! The Dragon Soul is not yours. Give it up, and you may yet walk away with your life.','',26124),
(53798,'enUS','Destroy them all, but bring the Shaman to me!','',26124),
(53799,'enUS','','Yes, little children?',26124),
(53800,'enUS','Can you help us? Our friend is injured.','Can you help us? Our friend is injured.',26124),
(53801,'enUS','The features of this jade statue are incredibly lifelike. The expression is locked in horror.','The features of this jade statue are incredibly lifelike. The expression is locked in horror.',26124),
(53802,'enUS','This statue does not match the description of Shin that An Windfur gave you.','This statue does not match the description of Shin that An Windfur gave you.',26124),
(53803,'enUS','You will go nowhere, Shaman.','',26124),
(53804,'enUS','Welcome to the Darkmoon Faire, $c!','Welcome to the Darkmoon Faire, $c!',26124),
(53805,'enUS','Welcome to the Darkmoon Faire!','Welcome to the Darkmoon Faire!',26124),
(53806,'enUS','Welcome!','Welcome!',26124),
(53807,'enUS','Maybe that\'s just a big scary mask on its face...','',26124),
(53808,'enUS','Greetings!','Greetings!',26124),
(53809,'enUS','Prepare for adventure!','Prepare for adventure!',26124),
(53810,'enUS','Behold, Master Greenpaw, known throughout the lands as the Jade Fist Monk.$b$bThrough skill, determination, and chi, he mastered the form now known as the dreaded Jade Strike, a blow that would transmute foes into statues of jade.$b$bIt was his heroism and sacrifice that saved the Jade Forest in a time of great need, and his like is not to be seen in this world again.$b$bMay this statue forever stand as a reminder of the price of peace, and may his sacrifice never be forgotten.','',26124),
(53811,'enUS','When the land ails, the spirits are first to feel the ill tiding. When the spirits leave the temple and fall to their baser instincts, the wise Pandaren takes heed.','',26124),
(53812,'enUS','In caring for the spirits and bringing them back among us, we can heal the land, and we can find understanding of the greater threats at hand.','',26124),
(53813,'enUS','Attention, fairegoers! The Darkmoon Deathmatch is about to begin! In mere moments the prize chest will appear at the center of the fighting pit!','',26124),
(53814,'enUS','Let the Darkmoon Deathmatch BEGIN!','',26124),
(53815,'enUS','Very recently, all four spirits left the temple and scattered to the corners of Shen-zin Su. The land suffers.','',26124),
(53816,'enUS','Your training will be put to use very soon, young $c. Go now, continue your lessons.','',26124),
(53818,'enUS','You\'re a fool if you think to take your place as the Aspect of Earth, Shaman!','',26124),
(53819,'enUS','','No matter what happens - we must stay focused on our objectives here.',26124),
(53820,'enUS','Let me hear the rest of your report, Agent Kearnen.','Let me hear the rest of your report, Agent Kearnen.',26124),
(53821,'enUS','Let none stand in our way.','',26124),
(53822,'enUS','The Twilight\'s Hammer returns.','',26124),
(53823,'enUS','Let them come!','',26124),
(53824,'enUS','Here you see the Darkmoon Deathmatch pit.  Do you possess the power and will to best all comers and take the pit fighter\'s prize?\n\nBouts begin at midnight and every three hours thereafter.','',26124),
(53825,'enUS','','Where do you think you\'re going, little lizard?',26124),
(53826,'enUS','How did they find us? Ready your weapons - we\'ve got to get out of this canyon!','',26124),
(53827,'enUS','We must seek out the elemental spirits and reunite them in the temple. Through this we will heal the land and find understanding of what truly ails it.','',26124),
(53828,'enUS','The closest spirit is Huo, the spirit of flame. You will meet with some of my most talented students and learn what they know of Huo.','',26124),
(53829,'enUS','Off with you, $c. You have much to do.','',26124),
(53831,'enUS','What do you suppose happened to this tree, Sully?','',26124),
(53832,'enUS','Somethin\' hit it, sir. Wasn\'t cut down, didn\'t fall on its own.','',26124),
(53833,'enUS','What\'s that, over there? Some kind of bird?','',26124),
(53834,'enUS','Naw, that\'s a plane. Wait... A PLANE!?','',26124),
(53835,'enUS','That\'s Amber an\' Nimm\'s plane! They might be alive after all!','',26124),
(53836,'enUS','Who are Amber and Nimm? Should we follow him?','',26124),
(53837,'enUS','She\'s still breathin\', sir! Get over here! Talk to \'er!','',26124),
(53838,'enUS','Listen up, men! Prepare for a hozen ambush!','',26124),
(53839,'enUS','Little Lu, keep Amber alive! Sully, try and keep this plane from exploding on us!','',26124),
(53840,'enUS','I\'ll hold them off as long as I can!','',26124),
(53841,'enUS','Master Li Fei\'s voice echoes, \"Huo, the spirit of fire, is known for his hunger. He wants for tinder to eat. He needs the caress of the wind to rouse him.\"','',26124),
(53842,'enUS','Master Li Fei\'s voice echoes, \"If you find these things and bring them to his cave, on the far side of Wu-Song Village, you will face a challenge within.\"','',26124),
(53843,'enUS','Master Li Fei\'s voice echoes, \"Overcome that challenge, and you shall be graced by Huo\'s presence. Rekindle his flame, and if your spirit is pure, he shall follow you.\"','',26124),
(53844,'enUS','Master Li Fei\'s voice echoes, \"Go, children. We shall meet again very soon.\"','',26124),
(53845,'enUS','Master Li Fei\'s voice echoes, \"It is good to see you again, Aysa. You\'ve come with respect, and so I shall give you the answers you seek.\"','',26124),
(53847,'enUS','Who owns this forest?','',26124),
(53848,'enUS','Who is our greatest enemy?','',26124),
(53849,'enUS','No, idiots! The ones down by the beach!','',26124),
(53850,'enUS','Are we going to let those soft-skinned, tail-less cowards cut down our forest and kill our clan brothers?','',26124),
(53851,'enUS','Then I remind you...WE are the strongest in this forest. We are the kings of the trees! We are death to our enemies!','',26124),
(53852,'enUS','No one messes with the Grimleer Tribe. It is time for our clan to taste blood and victory!','',26124),
(53853,'enUS','Ravage! Ravage! Ravage!','',26124),
(53854,'enUS','Aaahaahahaha!','',26124),
(53855,'enUS','You, Chief!','',26124),
(53856,'enUS','Personal hygiene?','',26124),
(53857,'enUS','Alexstrasza\'s drakes should meet us here...','',26124),
(53858,'enUS','The pale skins!','',26124),
(53859,'enUS','Us! Grimleer!','',26124),
(53860,'enUS','Water?','',26124),
(53861,'enUS','The blue banners!','',26124),
(53862,'enUS','Kill! Kill! Kill!','',26124),
(53863,'enUS','Monkeys!','',26124),
(53864,'enUS','Hmmmm...','',26124),
(53865,'enUS','The sea riders!','',26124),
(53866,'enUS','Yeeeaaaahhh!','',26124),
(53867,'enUS','Grim! Grim! Grimleer!','',26124),
(53868,'enUS','Oh, oh, I know! The eggheads!','',26124),
(53869,'enUS','Blood! Blood! Blood!','',26124),
(53870,'enUS','Ugly fish men!','',26124),
(53871,'enUS','The washed ones!','',26124),
(53872,'enUS','Grind them to dust!','',26124),
(53873,'enUS','Crocodiles?','',26124),
(53874,'enUS','Rip them apart!','',26124),
(53875,'enUS','Up there, above us!','',26124),
(53876,'enUS','No way!','',26124),
(53877,'enUS','|TInterface\\Icons\\ability_vehicle_sonicshockwave.blp:20|t%s summons a |cFFFF0000|Hspell:103678|h[Wave of Virtue]|h|r!','',26124),
(53878,'enUS','No!','',26124),
(53879,'enUS','Thank you for saving me!','',26124),
(53880,'enUS','An was being a meanie when she double hozen dared me. But I wasn\'t about to run away from a dare.','',26124),
(53881,'enUS','Are you okay?','Are you okay?',26124),
(53882,'enUS','Sully, Little Lu, our plans have changed. We need to transport Amber back to the main camp.','',26124),
(53883,'enUS','','That\'s not necessary. I\'ll be coming with you.',26124),
(53884,'enUS','Ye\'ve gotta be kiddin\' me! Yer nearly dead! Look at ye!','',26124),
(53885,'enUS','','No, Sully. My injuries will heal. Right now, we need to find the White Pawn.',26124),
(53886,'enUS','What\'s the White Pawn? I thought we were attacking the hozen.','',26124),
(53887,'enUS','TEST - P1. Starting Wave 1 now!','',26124),
(53888,'enUS','TEST - P1. Starting Wave 2 now!','',26124),
(53889,'enUS','TEST - P1. hozen are fleeing now!','',26124),
(53890,'enUS','TEST - P2. Wave 3 arrives now!','',26124),
(53891,'enUS','TEST - P2. Jinyu arrive now!','',26124),
(53892,'enUS','[TEMP] Save me dude','',26124),
(53893,'enUS','[TEMP] you got it bud','[TEMP] you got it bud',26124),
(53894,'enUS','It\'s us or them, $r. This day won\'t end without bloodshed.','',26124),
(53895,'enUS','Ahh, good to finally see a friendly face, mon.$b$bWould be good, dat is, if I could, you know, see...','',26124),
(53896,'enUS','|TInterface\\Icons\\spell_fire_twilightfire.blp:20|t%s summons a |cFFFF0000|Hspell:103780|h[Wave of Twilight]|h|r!','',26124),
(53897,'enUS','','Rell\'s condition is worsening. We must stop to rest again.',26124),
(53898,'enUS','If only Mishka were here. She\'d fix him up in no time.','',26124),
(53899,'enUS','Fellow agents! This is a pandaren hut. The pandaren are allies.','',26124),
(53900,'enUS','','Good thinking, Little Lu. Go find out who lives here. Take Sully with you.',26124),
(53901,'enUS','And Socks!','',26124),
(53902,'enUS','','Yes... and the raccoon. I will watch over our commander.',26124),
(53903,'enUS','<Continue reading...>','<Continue reading...>',26124),
(53904,'enUS','|TInterface\\Icons\\spell_shadow_twilight.blp:20|t%s begins to cast |cFF006EFD|Hspell:103754|h[Twilight Epiphany]|h|r!','',26124),
(53905,'enUS','','Shin tried to back out of the hozen dare but then we double hozen dared him and he couldn\'t back out of that.',26124),
(53906,'enUS','','So the other kids, not me, dared Shin to knock on the Jade Witch\'s front door.  He wouldn\'t do it though but then someone, not me, hozen dared him.$b$bShin backed out of that but then someone, not me I swear, double hozen dared him.  And not even Shin can get out of a double hozen dare.$b$bHe went and knocked on the door but we didn\'t see what happened.  Jade Monsters came at us and we ran away. $b$bI never should have dared Shin...',26124),
(53907,'enUS','','Well well, a young visitor.$B$bHave you come to pay your respects at the shrine of my husband?  He was a hero you know.  A master of Jade crafting and fighting. He was to be remembered forever they said.$B$bDo you like my statues?  I craft them with special care saving only the best to  provide my husband company and protection.',26124),
(53908,'enUS','Where is Shin?','Where is Shin?',26124),
(53909,'enUS','','It is nice to see some concerned individuals travelling on the roads these days.  My husband would have liked you.  We always wanted children.',26124),
(53911,'enUS','When we start tour?','When we start tour?',26124),
(53912,'enUS','When we start tour?','When we start tour?',26124),
(53913,'enUS','An assassin! Quickly, ready yourselves for battle!','',26124),
(53914,'enUS','When will we start this tour?','When will we start this tour?',26124),
(53915,'enUS','When will this tour start?','When will this tour start?',26124),
(53916,'enUS','When will the tour start?','When will the tour start?',26124),
(53917,'enUS','Where is our tour guide?','Where is our tour guide?',26124),
(53918,'enUS','Where is my tour guide?','Where is my tour guide?',26124),
(53919,'enUS','Where is tour guide?','Where is tour guide?',26124),
(53920,'enUS','Where is this tour guide who is meant to guide me?','Where is this tour guide who is meant to guide me?',26124),
(53921,'enUS','Where tour guide at?','Where tour guide at?',26124),
(53922,'enUS','Your tour guide will be along any minute now...','Your tour guide will be along any minute now...',26124),
(53923,'enUS','Your tour guide will be here shortly...','Your tour guide will be here shortly...',26124),
(53924,'enUS','I just saw the guide a moment ago...','I just saw the guide a moment ago...',26124),
(53925,'enUS','Just a few more minutes...','Just a few more minutes...',26124),
(53926,'enUS','I think I see him heading over here now...','I think I see him heading over here now...',26124),
(53927,'enUS','The tour guide will be along soon...','The tour guide will be along soon...',26124),
(53928,'enUS','Please be patient, the tour guide should be here any moment now...','Please be patient, the tour guide should be here any moment now...',26124),
(53929,'enUS','The battle against Deathwing\'s minions is your top priority, $n. But if you can help our flight with this small task, so much the better.','',26124),
(53930,'enUS','My jade!','',26124),
(53931,'enUS','You have jade?','',26124),
(53932,'enUS','The jade sings to us. Give! Give!','',26124),
(53933,'enUS','Very well.','Very well.',26124),
(53934,'enUS','Great!','Great!',26124),
(53935,'enUS','Shinies!','Shinies!',26124),
(53936,'enUS','Very well.','Very well.',26124),
(53937,'enUS','We is good.','We is good.',26124),
(53938,'enUS','Our patience is growing thin...','Our patience is growing thin...',26124),
(53939,'enUS','Good thing I don\'t mind waiting.','Good thing I don\'t mind waiting.',26124),
(53940,'enUS','We keep waiting then...','We keep waiting then...',26124),
(53941,'enUS','This is becoming unbearable.','This is becoming unbearable.',26124),
(53942,'enUS','We keep waiting.','We keep waiting.',26124),
(53943,'enUS','Those sneaky monkeys ambushed me out of nowhere.','',26124),
(53944,'enUS','The Darkmoon Deathmatch is over!  $n is the victor!','',26124),
(53945,'enUS','','I don\'t know that cub.',26124),
(53946,'enUS','','That isn\'t Shin.  It looks super lifelike though.',26124),
(53947,'enUS','','Eww.  That cub has a funny face.',26124),
(53948,'enUS','Are you friends with Admiral Taylor? If so, then I must test your strength in battle later.','',26124),
(53949,'enUS','The water spirits have answered my prayers. Thank you.','',26124),
(53950,'enUS','I had given up hope, friend. Thank you.','',26124),
(53951,'enUS','Do my eyes deceive me? Am I truly free?','',26124),
(53952,'enUS','I live another day, thanks to you.','',26124),
(53953,'enUS','Are you part of the rescue team? Are we saved?','',26124),
(53954,'enUS','I knew someone would come for us. Thank you, $c!','',26124),
(53955,'enUS','Thank you, $c. I can get back to camp on my own.','',26124),
(53956,'enUS','They\'ve got the Admiral locked up like an animal. Please save him too.','',26124),
(53957,'enUS','The hozen revel in torturing their prisoners. Thank you, $c, for saving me from a dire fate.','',26124),
(53958,'enUS','The undying flames are all that remain of this sacred place. I sense much anger here...a seething rage, barely held in check. Be on your guard.','',26124),
(53959,'enUS','','And you, with your heroic features. My husband\'s shrine needs guardians of your... stature.',26124),
(53960,'enUS','Come on now, mon!$b$bI be leakin\' like a sieve, here! I don\' be havin\' much time...','',26124),
(53961,'enUS','Come with me, Zin\'Jun, let\'s find your missing... belongings.','Come with me, Zin\'Jun, let\'s find your missing... belongings.',26124),
(53962,'enUS','Be right with ya, mon...','',26124),
(53963,'enUS','You\'ve almost got him! Og\'nor ka Lok\'tar - Now we finish this!','',26124),
(53964,'enUS','Aww, no... what have dey gone an\' done to me rifle, mon!?','',26124),
(53965,'enUS','Well lookie dere! Dat be my bad eye, but it be a good start!','',26124),
(53966,'enUS','Dere it be, mon. My huntin\' eye! I\'ll be able ta rest in peace wit\' my ancestors...','',26124),
(53967,'enUS','Wassat, mon? Dey kill ol\' Snuff?! Nooo!','',26124),
(53968,'enUS','I haven\'t come to be stopped by the likes of you.','',26124),
(53969,'enUS','Dere we go, mon. Now I be goin\' off ta be wit Snuff...','',26124),
(53970,'enUS','You have our thanks, $p. We\'ll be watchin\' over ya.','',26124),
(53971,'enUS','','What a waste.',26124),
(53972,'enUS','What is it you seek?','What is it you seek?',26124),
(53973,'enUS','Fight me!','Fight me!',26124),
(53977,'enUS','Very well...','Very well...',26124),
(53978,'enUS','Let us celebrate!','Let us celebrate!',26124),
(53979,'enUS','The time for celebration is done.','The time for celebration is done.',26124),
(53980,'enUS','Enough!','Enough!',26124),
(53984,'enUS','<Rell\'s forehead is pale and beaded with sweat. He does not look good.>','',26124),
(53985,'enUS','<Rell continues to stare blankly at the mat. His breathing is shallow and labored.>','',26124),
(53986,'enUS','Well done, Let us see to our friend...','',26124),
(53987,'enUS','The rest of the drakes should be here shortly. I\'ll fly on ahead; catch up when you can.','',26124),
(53989,'enUS','','Rell, please... save your energy. Sully can tell $n what happened next.',26124),
(53990,'enUS','We had traveled north through the forest for several hours.','',26124),
(53994,'enUS','We stopped when we found a strange fallen tree.','',26124),
(53995,'enUS','It wasn\'t supposed to go this way. We were supposed to find the White Pawn. I should be back in Ironforge by now.','',26124),
(53996,'enUS','Everything\'s gone to crap, $n. This was supposed to be a simple recon mission.','',26124),
(53997,'enUS','I... <sniff>... I don\'t think I can handle the next part! Little Lu, tell $n what happened next.','',26124),
(53998,'enUS','Alright, agents. Listen up.','',26124),
(53999,'enUS','Mmm... he considers me an agent.','',26124),
(54000,'enUS','It grows late. We should set up camp for the night. Sully, do you have an axe?','',26124),
(54001,'enUS','Naw, but I can put one together in a pinch. Let\'s see... you need a wood-cuttin\' axe, or a people-killin\' axe?','',26124),
(54002,'enUS','Wood-cutting. Little Lu, use this axe to gather firewood.','',26124),
(54003,'enUS','Yes sir!','',26124),
(54004,'enUS','Sully. Investigate those shrines to the west. Look for signs of the White Pawn.','',26124),
(54005,'enUS','Amber, find a good perch and give Sully some covering fire. We\'ll rendezvous back here.','',26124),
(54006,'enUS','Aye-aye, sir!','',26124),
(54007,'enUS','','Yes, sir.',26124),
(54008,'enUS','','This way, Sully! I see the perfect spot.',26124),
(54009,'enUS','','I\'ll hide up here in the shadows. If you run into any trouble, just shine a light on the target and I\'ll take care of them.',26124),
(54010,'enUS','Nice shot, Amber!','',26124),
(54011,'enUS','Didn\'t know I had a sniper on my side, did ya?','',26124),
(54012,'enUS','I swear, that woman never misses.','',26124),
(54013,'enUS','Note to self: Don\'t get on Amber\'s bad side.','',26124),
(54014,'enUS','Boom! Nice one!','',26124),
(54015,'enUS','Tryin\' ta sneak up on ol\' Sully, huh?','',26124),
(54016,'enUS','She hits \'em between the eyes, every time.','',26124),
(54017,'enUS','Yuck... splatter.','',26124),
(54018,'enUS','I\'m in bad shape, $n. My injuries...I...I\'ll try to hang on a bit longer. Get me out of here, please.','',26124),
(54019,'enUS','We were still goin\' north when we stopped near this big ol\' clearing.','',26124),
(54020,'enUS','We set up camp for the night. Rell split up responsibilities.','',26124),
(54021,'enUS','I found an old rifle scope in my pockets. It\'d have to do.$b|TInterface\\Icons\\inv_misc_scopeb.blp:32|t$b','',26124),
(54022,'enUS','I readied my swords for battle.','',26124),
(54023,'enUS','If I saw anything dangerous, I\'d hit it with the light, and Amber\'s sniper rifle would take care of the rest.','',26124),
(54024,'enUS','<Shu looks at you expectantly.>','',26124),
(54025,'enUS','Shu, can you wake up Wuguo for me?','Shu, can you wake up Wuguo for me?',26124),
(54026,'enUS','I found no sign of Anduin at the southwestern shrine.','',26124),
(54027,'enUS','However, I did find a friendly raccoon, who began to follow me.','',26124),
(54028,'enUS','I decided to name him Gizmo.','',26124),
(54029,'enUS','NO! GIZMO!','',26124),
(54030,'enUS','Food and drink taste even sweeter after a well fought battle.','Food and drink taste even sweeter after a well fought battle.',26124),
(54031,'enUS','Hey there, little buddy! I\'m gonna name you Gizmo.','',26124),
(54032,'enUS','AMBER, WHY!? I DIDN\'T EVEN SHINE MY DAMN LIGHT!','',26124),
(54033,'enUS','Shortly afterward, another raccoon befriended me.','',26124),
(54034,'enUS','I named him Socks, and quickly moved on.','',26124),
(54035,'enUS','Come on, Socks. Let\'s get out of here before you get sniped.','',26124),
(54036,'enUS','Look there!  It looks as though the Twilight Cultists have brought the Old Gods and their corruption to Wyrmrest.  Hold on tight!','',26124),
(54037,'enUS','Grrrrr...*hic*...rrr...','',26124),
(54038,'enUS','I found nothin\' at the northern shrine - no Anduin, no hozen... nothin\'.','',26124),
(54039,'enUS','After scoutin\' the three shrines, I headed back over to camp.','',26124),
(54040,'enUS','Socks followed along, faithfully.','',26124),
(54041,'enUS','Pollen punch!','',26124),
(54042,'enUS','My orchids!','',26124),
(54043,'enUS','Weeeeee!','',26124),
(54044,'enUS','No... Rell...','',26124),
(54045,'enUS','Nnn... nn nnnn... n-nl nnnr nnn... nn n nnnt...\n\n<I\'ll... be fine... it\'ll wear off... in a bit...>','',26124),
(54046,'enUS','No. Your perversion of the dead ends here.','',26124),
(54047,'enUS','All these poor souls... here, this will lead you home.','',26124),
(54049,'enUS','I WILL have you, spirit-sage!','',26124),
(54050,'enUS','Augh! Too... much... It\'s too much!','',26124),
(54051,'enUS','I cannot fall here. Not with so much work left to be done...','',26124),
(54052,'enUS','Northrend\'s depths belong to the nerubians, $r.$B$BI have devoted myself to restoring that great truth.','',26124),
(54055,'enUS','','Sir, we can have the entirety of the seventh fleet on the scene within the month--',26124),
(54056,'enUS','Your Majesty! We\'ve finally restored Taylor\'s last transmission.','',26124),
(54057,'enUS','Nightwind, have you pieced together that last transmission yet? Play me whatever you have!','',26124),
(54058,'enUS','No time! We\'ll send a small team immediately. An elite force. Rescue the survivors, AND their precious cargo!','',26124),
(54059,'enUS','Did you hear? They\'re safe somewhere!','',26124),
(54060,'enUS','...west of the planned rendezvous...Horde airfleet...[gunfire]...casualties!','',26124),
(54061,'enUS','Victory is ours today!','',26124),
(54062,'enUS','...Thick fog bank to provide cover...retreat...uncharted land...','',26124),
(54063,'enUS','...hostile creatures. But the White Pawn is accounted for. Repeat: the White Pawn is safe.','',26124),
(54064,'enUS','...[Sound of swords clashing]...immediate danger! Requesting rescue, requesting --','',26124),
(54065,'enUS','...encountered -- tribe -- extremely hostile creatures...we -- in immediate danger...Requesting rescue, I repeat--','',26124),
(54066,'enUS','Once the White Pawn is recovered, the full might of our navy can engage the Horde. On OUR terms.','',26124),
(54067,'enUS','I returned to find Rell bein\' attacked by hozen! Again!','',26124),
(54068,'enUS','AMBER! AIM YER SIGHTS OVER HERE!','',26124),
(54069,'enUS','Things have changed rapidly since you arrived here, $n. The hozen are more of a threat now than ever before.$b$bBut we, jinyu... we are stronger now, too.','',26124),
(54070,'enUS','We don\'t stand a chance if we face the hozen alone. We will need the help of the Alliance if our tribe is to survive.','',26124),
(54071,'enUS','Rell survived the attack, but he wasn\'t doing very well.','',26124),
(54072,'enUS','','This is a very unusual place.$B$BThe magic I\'m channeling to try to repair the ley lines should be tearing my body apart, but I feel incredible!',26124),
(54073,'enUS','Don\'t throw banana peel where going to walk.','Don\'t throw banana peel where going to walk.',26124),
(54074,'enUS','Peel banana first, eat second.','Peel banana first, eat second.',26124),
(54075,'enUS','Steal a banana from a hozen, expect a angry hozen.','Steal a banana from a hozen, expect a angry hozen.',26124),
(54076,'enUS','Firecracker for throwing, banana for eating.','Firecracker for throwing, banana for eating.',26124),
(54077,'enUS','Wet fur not fun to sleep on.','Wet fur not fun to sleep on.',26124),
(54078,'enUS','Don\'t roll in own poo unless want to smell like poo all day.','Don\'t roll in own poo unless want to smell like poo all day.',26124),
(54079,'enUS','Don\'t pull own tail when there are other tails to pull.','Don\'t pull own tail when there are other tails to pull.',26124),
(54080,'enUS','Poo not good to eat, but very good to throw.','Poo not good to eat, but very good to throw.',26124),
(54081,'enUS','Thank you, friend. I\'d be bound to that wretched construct right now if it weren\'t for your intervention.$B$BStill, I shouldn\'t be here at all. We must put a stop to the spiritbinders.','',26124),
(54082,'enUS','I envy you in a way, little $r.$B$BYou are so fortunate as to bear witness to the first steps of the rebirth of the mighty Empire of Azjol-Nerub.','',26124),
(54083,'enUS','The sign out front was not very... welcoming.','',26124),
(54084,'enUS','The lawn was littered with small jade statues. They seemed almost... lifelike.','',26124),
(54085,'enUS','One statue in particular stood out. I had never seen a creature like this.','',26124),
(54086,'enUS','Pshh! No sign is gonna stop me an\' my best pal Socks!','',26124),
(54087,'enUS','This person sure has lots o\' statues...','',26124),
(54088,'enUS','Now wait a darn minute. Is that an orc? Is... is the HORDE here too!?','',26124),
(54089,'enUS','','Now look at this... a jinyu and... what is that? Some sort of Beard-Sprite?',26124),
(54090,'enUS','I\'m a dwarf, ma\'am. Can we borrow some food?','',26124),
(54091,'enUS','','The Beard-Sprite will make an excellent addition to my family!',26124),
(54092,'enUS','What in blazes are you talkin\' about...','',26124),
(54093,'enUS','Sully... those aren\'t statues on her lawn! She wants to turn you into jade!','',26124),
(54094,'enUS','I finally understood what was going on... but I was a second too late.','',26124),
(54095,'enUS','','AHHH HA HA HAAAAA!',26124),
(54096,'enUS','SOCKS! NOOOOOOOOOOO!','',26124),
(54097,'enUS','The Hour of Twilight falls - the end of all things - you cannot stop it. You are nothing. NOTHING!','',26124),
(54098,'enUS','Grook them florkin\' wikkets!','',26124),
(54099,'enUS','Grook \'em in the kroogs, boys!','',26124),
(54100,'enUS','Grook \'em \'til they ook in their dookers!','',26124),
(54101,'enUS','Horg \'em off their jeeks and blikker \'em til their wik falls off!','',26124),
(54102,'enUS','Grook \'em in the nook, then gork \'em clean!','',26124),
(54103,'enUS','Can you close the portal, brother?','',26124),
(54104,'enUS','Very well, we shall break it for you.','',26124),
(54105,'enUS','Let them come.','',26124),
(54106,'enUS','It is being maintained by the will of a powerful demon...Mannoroth.','',26124),
(54107,'enUS','I cannot break his will alone...','',26124),
(54108,'enUS','','He knows what we attempt. We have not much time, the forest crawls with his demons.',26124),
(54109,'enUS','There are so MANY of them...','',26124),
(54110,'enUS','','Mother moon, guide us through this darkness.',26124),
(54111,'enUS','Weak, pitiful creatures. Hardly worthy of being called a legion.','',26124),
(54112,'enUS','Oh this will be fun...','',26124),
(54113,'enUS','Wait, I have an idea.','',26124),
(54114,'enUS','','Illidan, what is in that vial? What are you doing?',26124),
(54115,'enUS','After inspecting the statues, we saw a female pandaren emerge from the house.','',26124),
(54116,'enUS','What our people could not.','',26124),
(54117,'enUS','Yes...YES. I can feel the raw power of the Well of Eternity! It is time to end this charade!','',26124),
(54118,'enUS','Varo\'then, see that I am not disrupted by this rabble!','',26124),
(54119,'enUS','Highguard, to arms! For your queen! For Azshara!','',26124),
(54120,'enUS','','I cannot strike them!  What is this demon magic?',26124),
(54121,'enUS','They are not where they appear to be!  Strike in an area, it is the only way to uncover the real one!','',26124),
(54122,'enUS','I see you\'ve arrived. \n$bThis is the eve of the sundering, when the collapse of the Well of Eternity fractured the continents of the world.\n$bHere, we will snatch up the Dragon Soul before it is lost to the mists of time.\n$bBut first, you must bring down the protective wards of Azshara\'s lackeys. You will find them within the palace. I will scout on ahead.\n$bGood luck, heroes!','',26124),
(54123,'enUS','Send me to portal 1.','Send me to portal 1.',26124),
(54124,'enUS','Send me to portal 2.','Send me to portal 2.',26124),
(54125,'enUS','Send me to portal 3.','Send me to portal 3.',26124),
(54126,'enUS','Send me to the boss.','Send me to the boss.',26124),
(54127,'enUS','Run, Little Lu! Run away!! Before she gets you too!','',26124),
(54128,'enUS','Squeak!','',26124),
(54129,'enUS','','The loss of the raccoon is the least of our worries. Our biggest concern is that petrified orc... and what its presence means. I can tell you the rest of the story.',26124),
(54130,'enUS','','Rell is... he is hurt badly.$b$b<Agent Kearnen slams her fist on the ground.>$b$bHe\'s dying, $n! And there\'s not a damn thing we can do about it!',26124),
(54131,'enUS','','No, we didn\'t find the White Pawn.$b$bNo, I can\'t tell you what the White Pawn is.',26124),
(54132,'enUS','','We made camp in the mountains. Little Lu watched over Rell.',26124),
(54133,'enUS','','I walked up to the top of the mountain and took a hold of my sniper rifle.',26124),
(54134,'enUS','Kill some hozen today, Amber.','',26124),
(54135,'enUS','','As you wish, commander.',26124),
(54136,'enUS','','I found Sully waiting outside the village\'s entrance.',26124),
(54137,'enUS','','Straining my eyes, I could just barely read his lips, as he said:',26124),
(54138,'enUS','Shoot all the guards, so I can move ahead!','',26124),
(54139,'enUS','Nice work back there! One more time!','',26124),
(54140,'enUS','','Sully planted some explosive barrels for me to shoot.',26124),
(54141,'enUS','I brought these monkeys some presents! Try not to blow me up, Amber!','',26124),
(54142,'enUS','Nothing to see here! Let\'s keep going!','',26124),
(54143,'enUS','Bingo... I see a Horde crate! Cover me, I\'m going out in the open!','',26124),
(54144,'enUS','','Just as I suspected... the Horde is here, in Pandaria. And they\'ve allied with the hozen.',26124),
(54145,'enUS','','We\'d need to bring this information back to Pearlfin Village... but not before shooting a few orcs in the head.',26124),
(54146,'enUS','I see an opening! Here I come, Amber!','',26124),
(54147,'enUS','Ouch! Hey!','',26124),
(54148,'enUS','This one\'s for beatin\' up Amber!','',26124),
(54149,'enUS','This one\'s for beatin\' up Rell!','',26124),
(54150,'enUS','An\' this one\'s for Gizmo and Socks, you bastards!!','',26124),
(54151,'enUS','Anub\'Arak has fallen, my brothers! Rise from the depths and reclaim our birthright!','',26124),
(54152,'enUS','The sting of your defeat will fade with time.','The sting of your defeat will fade with time.',26124),
(54153,'enUS','|TInterface\\Icons\\spell_nature_moonglow.blp:20|t Tyrande gains the |cFFFF0000|Hspell:103917|h[Blessing of Elune]|h|r!','|TInterface\\Icons\\spell_nature_moonglow.blp:20|t Tyrande gains the |cFFFF0000|Hspell:103917|h[Blessing of Elune]|h|r!',26124),
(54154,'enUS','Ancestors, hear me! I call you back from the beyond, to bind this spirit to my will!','',26124),
(54155,'enUS','|TInterface\\Icons\\ability_mage_conjurewater11.blp:20|t Illidan douses himself with the |cFFFF0000|Hspell:103952|h[Waters of Eternity]|h|r!','|TInterface\\Icons\\ability_mage_conjurewater11.blp:20|t Illidan douses himself with the |cFFFF0000|Hspell:103952|h[Waters of Eternity]|h|r!',26124),
(54156,'enUS','Enough of your interference, $r! Spiritclaws! Deal with this pest!','',26124),
(54157,'enUS','More spirits! MORE! Quickly now!','',26124),
(54158,'enUS','I am NEVER drinking again!','I am NEVER drinking again!',26124),
(54159,'enUS','Spirits of old, I release you from my staff! Seek your vengeance on this beast!','',26124),
(54160,'enUS','Oooh! I\'m gunna gork ya til ya ook your dookers, wikket!','',26124),
(54161,'enUS','Florkun wikket! I\'ll shove your nibs into your horker!','',26124),
(54162,'enUS','I\'ll blikker yer nook, then hork ya clean, wikket!','',26124),
(54163,'enUS','Our enemies believe us vanquished from the frozen wastes.$B$BWe will show them the consequence of their ignorance.','',26124),
(54164,'enUS','Work faster! We must hatch the cocoon!','',26124),
(54165,'enUS','The rebirth of the Empire of Azjol-Nerub is upon us! Hear my call, brothers, and rise to reclaim what is rightfully ours!','',26124),
(54166,'enUS','Make haste and secure the area! Much work remains to be done.','',26124),
(54167,'enUS','What happened out here?','What happened out here?',26124),
(54168,'enUS','Thank you for saving me!','Thank you for saving me!',26124),
(54169,'enUS','Please don\'t tell my parents I was here.','Please don\'t tell my parents I was here.',26124),
(54170,'enUS','Do not rest until those wards are functional. We must not be disturbed.','',26124),
(54171,'enUS','I tried to boot a jade monster in the head but hurt my paw.','I tried to boot a jade monster in the head but hurt my paw.',26124),
(54172,'enUS','Next time I see a jade monster I\'m gonna punch it in the naughty bits.','Next time I see a jade monster I\'m gonna punch it in the naughty bits.',26124),
(54173,'enUS','','I hope the Jade Witch didn\'t get all of my friends.  She is super spooky.',26124),
(54174,'enUS','','I\'m sticking with you.  You can be my bodyguard!',26124),
(54175,'enUS','','You are super brave.  Can you teach me to be as brave?',26124),
(54176,'enUS','Twilight forces begin to appear around the canyon\'s edges.','',26124),
(54177,'enUS','We\'re surrounded - dispatch the ascendant while I keep the ambushers at bay.','',26124),
(54178,'enUS','Yeah?','',26124),
(54179,'enUS','','This is no small island, $n. It\'s a landmass that would likely rival Northrend!$b$bHow it has gone undiscovered is still a mystery.',26124),
(54180,'enUS','','Taking a hozen guide with us might not have been the best idea.',26124),
(54181,'enUS','Go on, Riko.','Go on, Riko.',26124),
(54182,'enUS','What happened next, Kiryn?','What happened next, Kiryn?',26124),
(54183,'enUS','Let\'s hear the rest of your report, Shokia.','Let\'s hear the rest of your report, Shokia.',26124),
(54184,'enUS','Handle Varo\'then. Mannoroth is mine.','',26124),
(54186,'enUS','','What manner of creature are you?$b$b<The pandaren pauses, her eyes growing wide.>$b$bMy... look at that gorgeous green skin!',26124),
(54187,'enUS','I am an orc, ma\'am. Would you mind if I asked you a few questions?','I am an orc, ma\'am. Would you mind if I asked you a few questions?',26124),
(54189,'enUS','It tasted soooo good going down.','It tasted soooo good going down.',26124),
(54190,'enUS','I am so sorry for getting that on you.','I am so sorry for getting that on you.',26124),
(54191,'enUS','Ugh...','Ugh...',26124),
(54192,'enUS','I lost my cloth. Can you rip me off another piece?','I lost my cloth. Can you rip me off another piece?',26124),
(54193,'enUS','','No.',26124),
(54194,'enUS','Do not take the practice of spirit-binding lightly. If the mogu are creating simulacra, you can be certain they\'re preparing for war.','',26124),
(54195,'enUS','Return to the Fox Grove before your Stag becomes angry!','Return to the Fox Grove before your Stag becomes angry!',26124),
(54196,'enUS','Hey $p! This way to Morning Breeze Village.','',26124),
(54197,'enUS','It is crucial that we bring all of the three remaining spirits back safely. I am too old to do this myself, and for all their strengths, both Aysa and Ji are single-minded in their ideals.$B$BYou possess all the qualities of a hero, and a balance that they do not. It is you that must do this.','',26124),
(54198,'enUS','I need to reach the top of the temple to leave for the Air Plateau.','I need to reach the top of the temple to leave for the Air Plateau.',26124),
(54199,'enUS','Arcurion begins to freeze Thrall in a block of ice.','',26124),
(54200,'enUS','','Well this is certainly a nice change of scenery.',26124),
(54201,'enUS','','No need to lug water around here.',26124),
(54202,'enUS','','It\'s nice to relax for a day.',26124),
(54203,'enUS','Can you charge my Cryptomancer\'s Decoder Ring?','Can you charge my Cryptomancer\'s Decoder Ring?',26124),
(54204,'enUS','','What a festive event.',26124),
(54205,'enUS','','Greetings!  I am apprentice to Brewmaster Shadowpour, a pandaren we now call the Mad Brewer.$b$BHis reckless pursuit of flavor at the risk of safety has resulted in countless injuries, illnesses, and now even the wildlife of the area feels his mad brewing.  He is a villain, and I could use your help in stopping him.',26124),
(54206,'enUS','','This is nothing at all like the Shimmering Flats.',26124),
(54207,'enUS','','This is much more relaxing than being on the speedbarge.',26124),
(54208,'enUS','','I don\'t have to wory about getting sunburned out here.',26124),
(54209,'enUS','','Oh, that looks like fun!',26124),
(54210,'enUS','Look at this place!','Look at this place!',26124),
(54211,'enUS','This place is huge!','This place is huge!',26124),
(54212,'enUS','This faire is a sweet surprise!','This faire is a sweet surprise!',26124),
(54213,'enUS','That Aimee has some sweet pies.','That Aimee has some sweet pies.',26124),
(54214,'enUS','So much activity... It reminds me of the Trade District.','So much activity... It reminds me of the Trade District.',26124),
(54215,'enUS','They\'re good at hawking their goods...','They\'re good at hawking their goods...',26124),
(54216,'enUS','Hmm... No one here specializes in fresh bread...','Hmm... No one here specializes in fresh bread...',26124),
(54217,'enUS','Lots of junk food here, but is it ever delicious.','Lots of junk food here, but is it ever delicious.',26124),
(54218,'enUS','Hmm...','Hmm...',26124),
(54219,'enUS','Everything seems to be in order here.','Everything seems to be in order here.',26124),
(54220,'enUS','Sloppy, but adequate.  You seem capable in a fight and in need of direction.\n$bThere are hundreds of demons ahead, it would be suicide to go it alone:','',26124),
(54221,'enUS','Looks good so far.','Looks good so far.',26124),
(54222,'enUS','Interesting...  Very interesting.','Interesting...  Very interesting.',26124),
(54223,'enUS','Come Stormrage, and I will show you what happens to those that betray the lord of the Legion!','',26124),
(54224,'enUS','The shadows will hide us well.\n$bI am concealed by this shadowcloak, and can imbue its magics onto you.\n$bIt will not make us invisible, but as long as we keep our distance from our foes we will remain hidden.','',26124),
(54225,'enUS','For you, Azshara.','',26124),
(54226,'enUS','Anything outside of that circle around you will not be able to see you, but the illusion will fade if you attack or take damage.\n$bI suggest you remain hidden until I say otherwise, these demons are too powerful to face head on and in full force.','',26124),
(54227,'enUS','','I will handle the demons. Elune, guide my arrows!',26124),
(54228,'enUS','Look at all these adorable animals!','Look at all these adorable animals!',26124),
(54229,'enUS','','Light of Elune, save me!',26124),
(54230,'enUS','Oh... So cute!','Oh... So cute!',26124),
(54231,'enUS','','I will hold them back for now!',26124),
(54232,'enUS','','<Corastrasza steps between you and the nearby corpse, her face wrinkled with concern.>$B$BI\'m sorry, $n. This is a private matter for the red flight to resolve.$B$BPlease see if you can help the others outside.',26124),
(54233,'enUS','Tyrande is overwhelmed! Use the Blessing of Elune to drive the demons back!','Tyrande is overwhelmed! Use the Blessing of Elune to drive the demons back!',26124),
(54234,'enUS','If only I had more room in my store, I\'d take you all with me to Dalaran.','If only I had more room in my store, I\'d take you all with me to Dalaran.',26124),
(54235,'enUS','Wonderful!','Wonderful!',26124),
(54236,'enUS','Tyrande can hold her own once again!','Tyrande can hold her own once again!',26124),
(54237,'enUS','','Lost. Stolen! This is a terrible blow. Terrible!',26124),
(54238,'enUS','','We\'ve had no luck tracking down the missing black dragon egg.$B$BHave you discovered anything, $n?',26124),
(54239,'enUS','Hmm...','Hmm...',26124),
(54240,'enUS','What happened here? What was stolen?','What happened here? What was stolen?',26124),
(54241,'enUS','I wonder how many kegs these animals can hold?','I wonder how many kegs these animals can hold?',26124),
(54242,'enUS','I wonder how fast these guys can move?','I wonder how fast these guys can move?',26124),
(54243,'enUS','These are some mighty fine animals...','These are some mighty fine animals...',26124),
(54244,'enUS','','Are you familiar with the late dragon Rheastrasza? A little off, that one. She often lurked about the Badlands in the form of a mortal goblin.$B$BRheastrasza came up with a scheme to steal and purify a black dragon egg, severing its tie with the black dragonflight and the corrupted Earth Warder, Deathwing.',26124),
(54245,'enUS','How do we deal with the demons?','How do we deal with the demons?',26124),
(54246,'enUS','I am ready to be hidden by your shadowcloak.','I am ready to be hidden by your shadowcloak.',26124),
(54247,'enUS','Let\'s go!','Let\'s go!',26124),
(54248,'enUS','I...will not...be defeated...','',26124),
(54249,'enUS','Mwahahahaha. Had enough, Stormrage?','',26124),
(54250,'enUS','How DARE you turn your back on me?','',26124),
(54251,'enUS','Illidan has been knocked to the ground!  Mannoroth is looking for a new target!','Illidan has been knocked to the ground!  Mannoroth is looking for a new target!',26124),
(54252,'enUS','Illidan has recovered!','Illidan has recovered!',26124),
(54253,'enUS','Light of lights...I have failed you. I am sorry...my Azshara...','',26124),
(54254,'enUS','The sword has pierced his infernal armor! Strike him down!','',26124),
(54255,'enUS','Varo\'then\'s magical sword falls to the ground!','Varo\'then\'s magical sword falls to the ground!',26124),
(54256,'enUS','Lord Sargeras, I will not fail you! Sweep your molten fist through this world, so that it may be reborn in flames and darkness!','',26124),
(54257,'enUS','He is still connected to the Well somehow! Focus your attacks on Mannoroth, we must disrupt his concentration!','',26124),
(54258,'enUS','','Illidan, I am out of arrows! Moon goddess, protect us from the darkness, that we may see your light again another night!',26124),
(54259,'enUS','Yes...yes! I can feel his burning eyes upon me, he is close...so close! And then your world will be unmade, your lives as nothing!','',26124),
(54260,'enUS','A massive demonic portal opens nearby!','A massive demonic portal opens nearby!',26124),
(54261,'enUS','You are not the sole wielder of Sargeras\' power, Mannoroth! Behold!','',26124),
(54262,'enUS','','Illidan...you musn\'t!',26124),
(54263,'enUS','Tyrande collapses!  The Light of Elune winks out!','Tyrande collapses!  The Light of Elune winks out!',26124),
(54264,'enUS','I will be the savior of our people! I WILL FULFILL MY DESTINY!','',26124),
(54265,'enUS','','No! Illidan!',26124),
(54266,'enUS','[Demonic] Revos ill ok mordanas archim maz naztheros! Archim xi ante maz-re mishun te nagas!','',26124),
(54267,'enUS','We have to keep moving; are you ready?','',26124),
(54268,'enUS','Tyrande is imbued with the shining light of the Moon Goddess!','Tyrande is imbued with the shining light of the Moon Goddess!',26124),
(54269,'enUS','Lead the way.','Lead the way.',26124),
(54270,'enUS','','Malfurion, he has done it! The portal is collapsing!',26124),
(54271,'enUS','No...no! This victory will not be ripped from my grasp! I will not return to him in failure! I will not be torn from this pitiful world! No...NOOOOOOOO!!!','',26124),
(54272,'enUS','The Dragon Soul is safe once again. Quickly, into the time portal, before this world sunders!','',26124),
(54273,'enUS','The Dragon Soul\'s link to the portal has been broken!  The Soul plummets downwards towards the Well!','The Dragon Soul\'s link to the portal has been broken!  The Soul plummets downwards towards the Well!',26124),
(54274,'enUS','Over here, in the shadows.','',26124),
(54275,'enUS','The faire seems to bring out all the lookers!','The faire seems to bring out all the lookers!',26124),
(54276,'enUS','So many choices, so little time...','So many choices, so little time...',26124),
(54277,'enUS','I think we stand a better chance fighting alongside one another.','',26124),
(54278,'enUS','Ooo, walk by again, cutie! Your posterior muscles are very finely toned!','Ooo, walk by again, cutie! Your posterior muscles are very finely toned!',26124),
(54279,'enUS','You! The cute one! Would you like to go over to my place and look over my tool collection?','You! The cute one! Would you like to go over to my place and look over my tool collection?',26124),
(54280,'enUS','Sweetie! Hey, $c! Are you interested in a woman able to hold intelligent discourse and look attractive while doing so?','Sweetie! Hey, $c! Are you interested in a woman able to hold intelligent discourse and look attractive while doing so?',26124),
(54281,'enUS','Yoooohoo, you well-proportioned charmer, you!','Yoooohoo, you well-proportioned charmer, you!',26124),
(54282,'enUS','Spare some copper?','Spare some copper?',26124),
(54283,'enUS','Spare a copper, $G sir:madam;?','Spare a copper, $G sir:madam;?',26124),
(54284,'enUS','Come with me if you\'d like to live long enough to see me save this world!','',26124),
(54285,'enUS','Could ye spare some coin?','Could ye spare some coin?',26124),
(54286,'enUS','Alms for the poor?','Alms for the poor?',26124),
(54287,'enUS','Help a poor bloke out?','Help a poor bloke out?',26124),
(54288,'enUS','So many demons, not enough time.','',26124),
(54289,'enUS','I will gladly pay you Tuesday for a hamburger today.','I will gladly pay you Tuesday for a hamburger today.',26124),
(54290,'enUS','It\'s all their fault, stupid Alliance army. Just had to build their towers right behind my farm.','It\'s all their fault, stupid Alliance army. Just had to build their towers right behind my farm.',26124),
(54291,'enUS','It\'s all their fault, stupid orcs. Had to burn my farm to the ground.','It\'s all their fault, stupid orcs. Had to burn my farm to the ground.',26124),
(54292,'enUS','They will get what they deserve, in due time.','',26124),
(54294,'enUS','We\'ve been discovered. I know you\'re tired, but we cannot keep the Aspects waiting!','',26124),
(54295,'enUS','Da faire be easy times for ol\' Griftah...','',26124),
(54296,'enUS','I\'ve seen a single Guardian Demon slaughter a hundred elves.  Tread lightly.','',26124),
(54297,'enUS','I will hold them back so we can get past. Be ready.','',26124),
(54298,'enUS','We was travelin\' east, looking for those horkin\' human guys.','',26124),
(54299,'enUS','My magic is fading. I\'m going through!','',26124),
(54300,'enUS','Things was goin\' good, so we decided to split up for a bit.','',26124),
(54301,'enUS','Shokia an\' Kiryn went off to do some girl stuff.','',26124),
(54302,'enUS','Waiting to attack...','',26124),
(54303,'enUS','Time for a drink...','Time for a drink...',26124),
(54304,'enUS','Attack. I don\'t like to be kept waiting.','',26124),
(54305,'enUS','Drink time!','Drink time!',26124),
(54306,'enUS','Drink up!','Drink up!',26124),
(54307,'enUS','Drinking is tiring work... Time to fish!  Wait, that\'s not right... Fishing is boring work, time to drink!','Drinking is tiring work... Time to fish!  Wait, that\'s not right... Fishing is boring work, time to drink!',26124),
(54308,'enUS','I\'ll let you have the first kill.  Don\'t make me regret that.','',26124),
(54309,'enUS','Patience is not one of my virtues.','',26124),
(54310,'enUS','It was just me and Gorrok. I let him take the lead... him bein\' all big and all.','',26124),
(54311,'enUS','After inspecting the statues, we saw this old lady pandaren come out of the house.','',26124),
(54312,'enUS','Be on the lookout for Alliance.','',26124),
(54313,'enUS','','Come on, Kiryn. Let\'s go do girl stuff.',26124),
(54314,'enUS','We will investigate this hut. Perhaps they have seen Alliance survivors.','',26124),
(54315,'enUS','Yeah, the hut! Good idea. You go first.','',26124),
(54316,'enUS','\"Stay out - no visitors.\" Hah!','',26124),
(54317,'enUS','Hey Gorrok, which girl do you like? Shokia or Kiryn?','',26124),
(54318,'enUS','These statues... they\'re almost lifelike. Something\'s wrong here, Riko.','',26124),
(54319,'enUS','You wanna know who I like? I like Kiryn. She\'s got pretty eyes.','',26124),
(54320,'enUS','','Questions? Hah! AHHH HA HA HAAAAA!',26124),
(54321,'enUS','','You, \"orc\", will make an excellent addition to my family!',26124),
(54322,'enUS','So, Gorrok, do you think I have a chance with Kiryn?','',26124),
(54323,'enUS','What the ookin\' hork...?','',26124),
(54324,'enUS','We waiting for tour guide.','We waiting for tour guide.',26124),
(54325,'enUS','Tour guide taking forever...','Tour guide taking forever...',26124),
(54326,'enUS','We just wait for guide.','We just wait for guide.',26124),
(54327,'enUS','We hope guide gets here soon.','We hope guide gets here soon.',26124),
(54328,'enUS','I\'ve been waiting a long time to be on this tour.','I\'ve been waiting a long time to be on this tour.',26124),
(54329,'enUS','I\'m beginning to doubt this tour guide will ever arrive.','I\'m beginning to doubt this tour guide will ever arrive.',26124),
(54330,'enUS','Are you here to lead the tour?','Are you here to lead the tour?',26124),
(54331,'enUS','Are you my tour guide?','Are you my tour guide?',26124),
(54332,'enUS','If you are not here to lead a tour, leave us.','If you are not here to lead a tour, leave us.',26124),
(54333,'enUS','Are you here to lead a tour or gawk at us?  Be gone.','Are you here to lead a tour or gawk at us?  Be gone.',26124),
(54334,'enUS','','The Horde is up to something. They\'ve never attacked our transports directly before.',26124),
(54335,'enUS','Did it work?','Did it work?',26124),
(54336,'enUS','','Believe it or not, her plan DID work. She acquired an egg - I\'m still not certain by what means - and claimed to have severed its link to the tainted flight.$B$BThen Deathwing found out about it.$B$BHe cornered Rheastrasza in a cave in the Badlands, destroying her and all of her work. Or so he thought. Rheastrasza had sacrificed her own eggs to fool the Aspect of Death.$B$BThe single, purified black dragon egg was secreted away and hidden!',26124),
(54337,'enUS','Of course! I helped her back when I was in the Badlands.','Of course! I helped her back when I was in the Badlands.',26124),
(54338,'enUS','','<Corastrasza does a double-take.>$B$BYou!? YOU helped Rheastrasza? And lived to tell about it?$B$BI underestimate you, $r. No wonder Lord Afrasastrasz sent you to me.$B$BNo doubt you remember what happened next: Rheastrasza was killed by Deathwing, but thanks to her sacrifice a single purified black dragon egg was secreted away and hidden.',26124),
(54339,'enUS','What happened to the egg?','What happened to the egg?',26124),
(54340,'enUS','','That\'s why you\'re here, $n. The egg was hidden here at the Vermillion Redoubt. Days ago, it disappeared.$B$BWhoever did it was able to elude our sharpest guards. One of the thieves was killed during the abduction, although now I believe he may have been a diversion - the egg is simply GONE.$B$BOn his corpse we found this note. It remains our only clue, but it is written in a dense code and it MUST be deciphered.',26124),
(54341,'enUS','Everything was goin\' great! I felt like we was really bonding.','',26124),
(54342,'enUS','They... they just attacked a ship full of passengers!','',26124),
(54343,'enUS','The Horde seems determined to escalate this war even further and that warchief has his eyes on my homeland!','',26124),
(54344,'enUS','Five hundred ships at my disposal, yet the one that holds the key to the kingdom is missing. How can this be?','',26124),
(54345,'enUS','','We have swept the wreckage for days, Your Majesty. There is no sign of Admiral Taylor or his ships.',26124),
(54346,'enUS','I\'m your man! Give me the coded message.','I\'m your woman! Give me the coded message.',26124),
(54347,'enUS','Lord Afrasastrasz sent me. He said you have a message to decode?','Lord Afrasastrasz sent me. He said you have a message to decode?',26124),
(54348,'enUS','Why does it hurt?!','Why does it hurt?!',26124),
(54349,'enUS','','Here\'s what\'s left of the message we found, $n. Can you make any sense of it?',26124),
(54350,'enUS','What are you?! Who are you?! Where am I?!','What are you?! Who are you?! Where am I?!',26124),
(54351,'enUS','What happened to my clothes?!','What happened to my clothes?!',26124),
(54352,'enUS','All I wanted was to visit some friends in the city. I never wanted this! Why is the Horde doing this to us?','',26124),
(54353,'enUS','%s summons a Resonating Crystal!','',26124),
(54354,'enUS','Freeze!','',26124),
(54355,'enUS','','Wait!',26124),
(54356,'enUS','','We need to wait for the winds to settle, then make a break for the cover of the far hallway.',26124),
(54357,'enUS','','Wait for another opening. I\'ll meet you on the far side.',26124),
(54358,'enUS','What happened on the Bravery?','What happened on the Bravery?',26124),
(54359,'enUS','','All right Riko, I think $n has heard enough. Kiryn can tell the next part.',26124),
(54360,'enUS','','Horde warships stopped us and their warriors swarmed over the deck of the Bravery. They took what they wanted and killed those who wouldn\'t cooperate. We were outnumbered...',26124),
(54361,'enUS','Those orcs took my wife and tossed her into the water when she tried to protect the goods we were bringing to Stormwind! You can\'t let them get away with this!','',26124),
(54362,'enUS','','Dafeng! What\'s wrong? Why are you hiding back here?',26124),
(54363,'enUS','I managed to take one of the attackers\' weapons and fight back, but there were too many of them. See? I still have the axe...','',26124),
(54364,'enUS','After they boarded the ship, I closed my eyes and hid. Please don\'t make me talk about it...','',26124),
(54365,'enUS','','We traveled south until night fell. Shokia spoke:',26124),
(54366,'enUS','','I found a stack of smoke bombs in my pockets. They\'d have to do.$b|TInterface\\Icons\\ability_rogue_smoke.blp:32|t$b',26124),
(54367,'enUS','','If I encountered enemies, I\'d hit them with the smoke. Shokia\'s sniper rifle would take care of the rest.',26124),
(54368,'enUS','I saw signs of a campfire up ahead, on the eastern side of the statue.','',26124),
(54369,'enUS','','UNUSED',26124),
(54370,'enUS','','At the northern shrine, I found him: a scrawny-looking human soldier.',26124),
(54371,'enUS','','I returned back to camp with my quarry. Shokia would be pleased.',26124),
(54372,'enUS','I can\'t afford to miss another shipment!','I can\'t afford to miss another shipment!',26124),
(54373,'enUS','If I can\'t move goods to and from Kalimdor, I\'ll be ruined!','If I can\'t move goods to and from Kalimdor, I\'ll be ruined!',26124),
(54374,'enUS','Does King Wrynn even care our plight?','Does King Wrynn even care our plight?',26124),
(54375,'enUS','How am I supposed to run my business with an empty warehouse?','How am I supposed to run my business with an empty warehouse?',26124),
(54376,'enUS','','All right, Kiryn.',26124),
(54377,'enUS','','Riko.',26124),
(54378,'enUS','','We\'ll set up camp soon. First, we\'ll take advantage of this darkness to do some reconnaissance.',26124),
(54379,'enUS','','Good idea. I\'ll scout that area up ahead.',26124),
(54380,'enUS','And... and I will protect Kiryn from danger.','',26124),
(54381,'enUS','','No, Riko. You stay here. Try not to get anyone killed this time.',26124),
(54382,'enUS','Aww, dooker...','',26124),
(54383,'enUS','','This way, Kiryn.',26124),
(54384,'enUS','','I\'ll cover you from here. It\'s dark, so you\'ll have to mark my targets for me.',26124),
(54385,'enUS','','Rendezvous back here when you\'re done.',26124),
(54386,'enUS','','Don\'t move, human. I\'ve got you cornered.',26124),
(54387,'enUS','How, exactly, do you have me cornered, undead?','',26124),
(54388,'enUS','I see.','',26124),
(54389,'enUS','','You\'re lucky I don\'t kill you right now... you look delicious.',26124),
(54390,'enUS','I see... involved in some shady business, $r? Oh no need to worry - the confidentiality of all transactions is assured.$B$BThis ring you have is a superb piece of work. We can begin the charging process... for a modest fee. Charging the ring will take roughly one half of your world\'s cycles to complete. In other words, twelve hours.$B$BShall we say 10,000 gold? That\'s fair.','',26124),
(54391,'enUS','<Pay the 10,000 gold.>','<Pay the 10,000 gold.>',26124),
(54392,'enUS','<The Lorewalker\'s kind eyes rest upon you attentively.>','',26124),
(54393,'enUS','<Lorewalker Cho watches you with a curious anticipation.>','',26124),
(54394,'enUS','I wonder what brings you to our lands, stranger.$b$bThe mists of Pandaria will reveal the answer in time...','',26124),
(54395,'enUS','Ten thousand!? Outrageous! I\'ll kill you while you sleep!','Ten thousand!? Outrageous! I\'ll kill you while you sleep!',26124),
(54396,'enUS','The more eagerly you seek after a thing, the more it eludes you.','',26124),
(54397,'enUS','One cannot break Pandaria.$b$bOne can only break one\'s self upon Pandaria.','',26124),
(54398,'enUS','Well then.$B$BIt is good that I no longer sleep.','Well then.$B$BIt is good that I no longer sleep.',26124),
(54399,'enUS','Who are you... WHAT are you?','Who are you... WHAT are you?',26124),
(54400,'enUS','Deep truths may only be learned through deep questioning.','',26124),
(54401,'enUS','Very good, $r! Remember, your ring will not reach its full charge for many hours.','Very good, $r! Remember, your ring will not reach its full charge for many hours.',26124),
(54402,'enUS','To merely provide an answer teaches nothing.$b$bPandaria is a land of teaching and learning.','',26124),
(54403,'enUS','If you truly desire to know such things, the answer shall come to you when you are prepared to receive it.','',26124),
(54404,'enUS','To ask a thing only begins to prepare the mind to receive the answer.','',26124),
(54405,'enUS','There is yet much which stands between you and your question\'s answer.','',26124),
(54406,'enUS','Listen carefully to the silence, $c. What does it say?','',26124),
(54407,'enUS','You must learn to ponder, stranger. Your impetuous questions betray a lazy mind.','',26124),
(54408,'enUS','If I were to answer you now, I would deny you the enlightenment that should be yours.','',26124),
(54409,'enUS','These savage primates want to kill us! Tell me... how can we overcome them?','These savage primates want to kill us! Tell me... how can we overcome them?',26124),
(54410,'enUS','Where did this land come from? It seems to have appeared from nowhere!','Where did this land come from? It seems to have appeared from nowhere!',26124),
(54411,'enUS','Never... submit!','',26124),
(54412,'enUS','Away! Leave us to suffer!','',26124),
(54413,'enUS','Darkness...','',26124),
(54414,'enUS','No peace here... no rest...','',26124),
(54415,'enUS','Please... release!','',26124),
(54416,'enUS','Riko time! I know what happened next! Pick me! Over here, $n!','',26124),
(54417,'enUS','Word is that I\'m not the only one who can\'t get goods into or out of Kalimdor.','Word is that I\'m not the only one who can\'t get goods into or out of Kalimdor.',26124),
(54418,'enUS','How am I supposed to feed my family if I can\'t move my goods?','How am I supposed to feed my family if I can\'t move my goods?',26124),
(54419,'enUS','If the king can\'t keep our shipments safe, he has no business on that throne!','If the king can\'t keep our shipments safe, he has no business on that throne!',26124),
(54420,'enUS','The Horde means to strangle us to death this time. I hope to the Light that the king acts before it\'s too late...','The Horde means to strangle us to death this time. I hope to the Light that the king acts before it\'s too late...',26124),
(54421,'enUS','How long will it be before the Horde does to us what it did to Theramore? The king must understand...','How long will it be before the Horde does to us what it did to Theramore? The king must understand...',26124),
(54422,'enUS','King Wrynn will listen to you, you\'re a hero to the Alliance!','King Wrynn will listen to you, you\'re a hero to the Alliance!',26124),
(54423,'enUS','Don\'t think this\'ll help much, but here\'s my petition.','Don\'t think this\'ll help much, but here\'s my petition.',26124),
(54424,'enUS','The Horde has us by the purse, and if the king doesn\'t send his fleet to teach them a lesson, we\'re doomed.','The Horde has us by the purse, and if the king doesn\'t send his fleet to teach them a lesson, we\'re doomed.',26124),
(54425,'enUS','','That coded message is the only clue we have.',26124),
(54428,'enUS','We kept goin\' south, until Shokia started whinin\' about somethin\'.','',26124),
(54429,'enUS','Shokia watched the prisoner while Kiryn went ahead.','',26124),
(54430,'enUS','Maybe Riko lost temper a little bit.','',26124),
(54431,'enUS','Yelling at Shokia wasn\'t doing nothin\'. Riko decided to follow Kiryn.','',26124),
(54432,'enUS','I cracked knuckles and got ready for fight.$b|TInterface\\Icons\\inv_gauntlets_05.blp:32|t  |TInterface\\Icons\\inv_inscription_pigment_emerald.blp:32|t$b','',26124),
(54433,'enUS','','Look, up ahead - an Alliance bomber!',26124),
(54434,'enUS','','I see it, Shokia. I\'ll go take a look.',26124),
(54435,'enUS','','Don\'t you dare follow her, Riko. I don\'t want you messing things up again.',26124),
(54436,'enUS','No, you tik-jooglin\' orc! Riko done following you stupid orders!','',26124),
(54437,'enUS','You nothin\' but a blikk-jeekin\', dikkety dook-manker with an ook for a head!','',26124),
(54438,'enUS','','Wha- Help! Help, Shokia! Riko!',26124),
(54439,'enUS','I save you, Kiryn!','',26124),
(54440,'enUS','','Riko, you... you saved my life.',26124),
(54441,'enUS','So... uh... can Riko get a kiss?','',26124),
(54442,'enUS','','Of course. Let me just take off my mask...',26124),
(54443,'enUS','WHAT THE OOK IS WRONG WITH YOUR FACE? YOU\'RE... YOU\'RE JEEKIN\' DEAD?','',26124),
(54444,'enUS','Death to the Legion!','',26124),
(54445,'enUS','Shadowcloak Vanish! PH','',26124),
(54446,'enUS','Follow me.','',26124),
(54447,'enUS','','If the jinyu set this trap, they\'ll be back soon.$b$b<Kiryn looks up at the horizon in shock.>$b$bDark Lady watch over us... they\'re here. Save yourself, Riko!',26124),
(54448,'enUS','Never! Riko protect you to death!','Never! Riko protect you to death!',26124),
(54449,'enUS','All of a sudden, I heard a noise. Kiryn was trapped! In jinyu nets!','',26124),
(54450,'enUS','COME AT ME, BROKKERS!','',26124),
(54451,'enUS','Are you ready?','',26124),
(54452,'enUS','Alright! It\'s time to kill some skreekin\' jinyu!','',26124),
(54453,'enUS','Alliance and jinyu... fight side by side?','',26124),
(54454,'enUS','Get away from our plane, hozen scum!','',26124),
(54455,'enUS','AHHHHHH!','',26124),
(54456,'enUS','When I done fightin\', went up to Kiryn to ask for my... reward.','',26124),
(54457,'enUS','','The important thing is that these jinyu and Alliance have joined forces. Come speak with me, $n. I can give you the final part of our report.',26124),
(54458,'enUS','Are you ready to continue?','',26124),
(54459,'enUS','Move out!','Move out!',26124),
(54460,'enUS','','Your Highness, with $n\'s help, I have completed my investigation into what happened aboard the Bravery.',26124),
(54461,'enUS','','The Horde did attack the ship, preventing it from reaching Teldrassil. But that\'s only the beginning of it...',26124),
(54462,'enUS','','Orc ships have begun a blockade of the Kalimdor coastline. No passengers can reach the continent and our merchants cannot move their goods!',26124),
(54463,'enUS','Oh Syra, Syra. She is the most beautiful person I have ever met and the kindest soul to ever walk Pandaria.$b$bWe want to get married but she is a Goldendraft, and I\'m a Wanderbrew.','',26124),
(54464,'enUS','So Garrosh hopes to isolate Kalimdor completely?','',26124),
(54465,'enUS','Stormwind and the Alliance cannot allow them to succeed, but our options are limited. Most of the fleet is being refitted.','',26124),
(54466,'enUS','Admiral, send the remnants of Theramore\'s fleet to assist the night elves and issue letters of marque to any captains willing to take up our cause.','',26124),
(54467,'enUS','','I will make the arrangements right away, my king. I know several captains that we might persuade to help us in dealing with this blockade...',26124),
(54468,'enUS','Destroy the crystal so we can move on.','',26124),
(54469,'enUS','','We set up a small camp in the hills above the jinyu village.',26124),
(54470,'enUS','','With nobody to watch over our prisoner, I had to make sure he was... incapable of escaping.',26124),
(54471,'enUS','Wha-?','',26124),
(54472,'enUS','','I approached my sniper rifle and took aim at the jinyu village.',26124),
(54473,'enUS','','Kiryn had made it to the jinyu village. I spotted her lurking in some bushes on the village\'s edge.',26124),
(54474,'enUS','','Straining my eyes, I could just barely read her lips, as she said:',26124),
(54475,'enUS','','Shoot all the guards, so I can move ahead!',26124),
(54476,'enUS','','Nice work back there! One more time!',26124),
(54477,'enUS','','Let\'s see if my hozen poison works on jinyu! Try not to blow me up, Shokia!',26124),
(54478,'enUS','','The center of the jinyu village was clear. Just to be safe, Kiryn planted some explosive barrels for me to shoot.',26124),
(54479,'enUS','','That\'ll teach the jinyu and the Alliance to mess with us! Let\'s get out of here!',26124),
(54480,'enUS','','Shokia, they\'ve spotted me! Give me cover!',26124),
(54481,'enUS','','The coast was clear. Kiryn began to make her escape.',26124),
(54482,'enUS','','Damn, another jinyu net! We were so close, too...',26124),
(54483,'enUS','','I sensed a commotion in the village\'s eastern island.',26124),
(54484,'enUS','I\'M BACK, YOU DOOKERS!','',26124),
(54485,'enUS','I on way, Kiryn! And I don\'t care about you weird dead face!','',26124),
(54486,'enUS','','Riko...',26124),
(54487,'enUS','Come on, Kiryn! Let\'s get the ook outta here!','',26124),
(54488,'enUS','','Gah!',26124),
(54489,'enUS','Look out!','',26124),
(54490,'enUS','Another ambush. Watch your backs!','',26124),
(54491,'enUS','Take a moment to catch your breath before we move on.','',26124),
(54492,'enUS','Show yourself!','',26124),
(54493,'enUS','My friend, today we will face one of the greatest and most diabolical of brewmasters the pandaren have ever known.$b$bThere are few who have not heard of the dangers of his brews and yet despite that he is able to dupe people and animals alike into tasting his beverages.$b$bHe must be stopped!  Are you with us?','',26124),
(54494,'enUS','I am with you!','I am with you!',26124),
(54495,'enUS','You\'re a mere mortal. It is time you died like one.','',26124),
(54496,'enUS','Enough, Shaman!','',26124),
(54497,'enUS','None will survive!','',26124),
(54498,'enUS','The Shaman is mine, focus on his companions!','',26124),
(54499,'enUS','Mere mortals.','',26124),
(54500,'enUS','Your Shaman can\'t protect you.','',26124),
(54501,'enUS','The Aspects misplaced their trust.','',26124),
(54502,'enUS','Nothing! Nothing....','',26124),
(54503,'enUS','My blades hunger.','',26124),
(54504,'enUS','','Sure, we found an Alliance prisoner of war... but at what price?',26124),
(54505,'enUS','','Lok\'tar, $n.',26124),
(54506,'enUS','Riko\'s got a lot to think about.','',26124),
(54507,'enUS','What the jeek are you lookin\' at?','',26124),
(54508,'enUS','','Our prisoner is strange. He carries no weapon, and his garb is... untraditional.$b$bPerhaps he\'s a lord of some kind. With any luck, we might have captured someone valuable!',26124),
(54509,'enUS','','Riko is... well, he\'s the most mature hozen I\'ve met so far, which isn\'t saying much.$b$bHe\'s really not as bad as Shokia makes him out to be. I actually think he\'s kind of sweet... in a hozen sort of way.',26124),
(54510,'enUS','They come endlessly from the palace.','',26124),
(54511,'enUS','We\'re leaving. Stay close.','',26124),
(54512,'enUS','The stench of sulfur and brimstone... These portals are as foul as the demons themselves.','',26124),
(54513,'enUS','Attack the demon soon, or I will.','',26124),
(54514,'enUS','Cut this one down from the shadows.','',26124),
(54515,'enUS','Hi I\'m Jian!  Did we meet before?  You have one of those faces.  Like things with faces have...','',26124),
(54516,'enUS','<Na Lek smiles at you, and you feel young as though you have not felt in years.>','',26124),
(54517,'enUS','I\'m thirsty!','',26124),
(54518,'enUS','Hold this rope and don\'t be heavy.','',26124),
(54519,'enUS','Who is that? What do you want? Don\'t look at me!','',26124),
(54520,'enUS','Can you help me clense the lake?','Can you help me clense the lake?',26124),
(54521,'enUS','Can\'t you see I want to be alone? What\'s the meaning of this disturbance?','',26124),
(54522,'enUS','The grand admiral asked me to give you these bottles and to ask you to consider joining our efforts against the Horde.','The grand admiral asked me to give you these bottles and to ask you to consider joining our efforts against the Horde.',26124),
(54523,'enUS','So the grand admiral knows about my... affliction, does she? I didn\'t know she cared!','',26124),
(54524,'enUS','Enough hiding. It\'s time to take the fight to the iron dwarves.','',26124),
(54525,'enUS','%s scratches himself furiously.','',26124),
(54526,'enUS','Wait, these... these are the remedies I need. How did she know?','',26124),
(54527,'enUS','Tell your admiral that if this works, my ship and crew will be at her command.','',26124),
(54528,'enUS','I can\'t wait for all this infernal itching to be gone and to have my lustrous coat back! You have what you wanted. Begone!','',26124),
(54529,'enUS','This won\'t hurt a bit.','',26124),
(54530,'enUS','Can I get another parachute?','Can I get another parachute?',26124),
(54531,'enUS','','Thank you for coming so quickly, $n.',26124),
(54532,'enUS','\'Tis a brave $r who comes between ol\' Ardan and his drink. What can I do fer you?','\'Tis a brave $r who comes between ol\' Ardan and his drink. What can I do fer you?',26124),
(54533,'enUS','Yea?','',26124),
(54534,'enUS','Can I get another parachute?','Can I get another parachute?',26124),
(54535,'enUS','Grand Admiral Jes-Tereth sent me to ask you to join the fleet in breaking the Horde blockade of Kalimdor.','Grand Admiral Jes-Tereth sent me to ask you to join the fleet in breaking the Horde blockade of Kalimdor.',26124),
(54536,'enUS','Challenge accepted! Hit for hit, drink for drink.','',26124),
(54537,'enUS','Now, I haven\'t had a reason to train me guns on a Horde vessel in a long time...','',26124),
(54538,'enUS','Sounds like the battle will be fierce and the plunder good!','',26124),
(54539,'enUS','Tell ya what, me crewmen are drinkin\' wherever ale can be found in this city. If ya can convince \'em to give up their ales and take up their guns, count me in!','',26124),
(54540,'enUS','You buyin\' the next round?','You buyin\' the next round?',26124),
(54541,'enUS','Do I know you?','Do I know you?',26124),
(54542,'enUS','What\'s this about?','What\'s this about?',26124),
(54543,'enUS','You don\'t look like the barmaid...','You don\'t look like the barmaid...',26124),
(54544,'enUS','Too... *hic* much flavor.  Must...rest.','',26124),
(54545,'enUS','Put down that ale and take up your gun. Your captain\'s shipping out.','Put down that ale and take up your gun. Your captain\'s shipping out.',26124),
(54546,'enUS','Your essence... is MINE.','',26124),
(54547,'enUS','Aye, I\'m ready to smash some Horde ships to splinters!','Aye, I\'m ready to smash some Horde ships to splinters!',26124),
(54548,'enUS','Aye, I\'ll go, but I\'ll go when I\'m good an\' ready...','Aye, I\'ll go, but I\'ll go when I\'m good an\' ready...',26124),
(54549,'enUS','Oh, I\'ll get me gun, and I\'ll shoot ye wit\' it if ye ever interrupt me when I\'m drinkin\' again!','Oh, I\'ll get me gun, and I\'ll shoot ye wit\' it if ye ever interrupt me when I\'m drinkin\' again!',26124),
(54550,'enUS','We\'ll made the Horde pay, we will!','We\'ll made the Horde pay, we will!',26124),
(54551,'enUS','No more shootin\' straw orcs fer me!','No more shootin\' straw orcs fer me!',26124),
(54552,'enUS','Wooah... Not so fast next time!','Wooah... Not so fast next time!',26124),
(54553,'enUS','Slow down you big fool!','Slow down you big fool!',26124),
(54554,'enUS','Give me a warning before you do that!','Give me a warning before you do that!',26124),
(54555,'enUS','Rrraaaghhh!!','',26124),
(54556,'enUS','If you\'re here to conduct business, say your piece.','',26124),
(54557,'enUS','So angry.  We should calm you down with a nice lager... of pain!','',26124),
(54558,'enUS','Obviously we got off to a bad start.  How about an ale... of more pain?!','',26124),
(54559,'enUS','Alright, time for the good stuff.  This is my special stout... of suffering!','',26124),
(54560,'enUS','Grand Admiral Jes-Tereth is launching a fleet to break the Horde blockade of Kalimdor. Will you join her?','Grand Admiral Jes-Tereth is launching a fleet to break the Horde blockade of Kalimdor. Will you join her?',26124),
(54561,'enUS','I\'d love the opportunity to punish the Horde for this outrage...','',26124),
(54562,'enUS','I\'ll join your fleet if you can best my first officer in battle.','',26124),
(54563,'enUS','Williams, we have a challenger. Show this $c what we\'ll do to the orcs!','',26124),
(54564,'enUS','Enough! I yield to your superior skills.','',26124),
(54565,'enUS','We should join this fleet, captain. The admiral\'s allies are worthy.','',26124),
(54566,'enUS','Welcome child to my humble valley.  It is my goal in life to build a beverage so delicious it will humble any other experience your taste buds have encountered.$b$bMy research is on the verge of something phenominal, that no pandaren can claim to be even close to achieving.','',26124),
(54567,'enUS','<You watch in fascination as the creature gracefully carves lines through the air in this cozy cavern. The respite from the violence and turmoil of your last hours is most welcome.$b$bThe being offers no visible acknowledgement of your presence, but a feeling grows within you that he is aware of your every breath.$b$bThinking back to Nazgrim and the others, you consider how best to engage the stranger in conversation.>','',26124),
(54568,'enUS','Challenge to a tasters\' duel.','Challenge to a tasters\' duel.',26124),
(54572,'enUS','The demons are no longer pouring from the palace. We can move ahead.','',26124),
(54573,'enUS','Too easy.','',26124),
(54574,'enUS','Another demon, ready to be slaughtered.','',26124),
(54575,'enUS','They stand unaware that their deaths are moments away.','',26124),
(54576,'enUS','','The herbs from the fire seem to already be healing this animal.  Thank you!',26124),
(54577,'enUS','','$n, you should know that the last sixteen recruits...',26124),
(54578,'enUS','All right everyone, listen up. We\'re entering hostile uncharted territory, far from the Alliance chain of command.','',26124),
(54579,'enUS','But sir, there ain\'t any record of land in that region. Where are they?','',26124),
(54580,'enUS','Trad! Renstadt! Nooooooooooooooooooo!','',26124),
(54581,'enUS','You kidding me, Commander? I ain\'t here to babysit some untried newcomer.','',26124),
(54582,'enUS','How are we supposed to find anything in this mist, anyway?','',26124),
(54583,'enUS','','Commander, we\'re picking up an Alliance distress signal ahead.',26124),
(54584,'enUS','','They\'re firing on us, sir!',26124),
(54585,'enUS','','Pull up!',26124),
(54586,'enUS','Looks like the crew here is in trouble.','',26124),
(54587,'enUS','We\'d better help them out and worry about the others later. Let\'s go!','',26124),
(54588,'enUS','My pappy helped build this harbor, you know. Ain\'t she a beauty?','',26124),
(54589,'enUS','','You can count on us, sir. We won\'t return without that boy.',26124),
(54590,'enUS','Well I wouldn\'t be surprised if he did. He were a great dwarf!','',26124),
(54591,'enUS','','Tell ya what Sully, tell me all about him over a mug of ale when we get back.',26124),
(54592,'enUS','Deal!','',26124),
(54593,'enUS','What? A Horde ship? HERE?','',26124),
(54594,'enUS','Things that are done, it is needless to speak about... things that are past, it is needless to blame.','',26124),
(54595,'enUS','Your blood is MINE, elf!','',26124),
(54596,'enUS','Wake up, stranger! Your snoring is interrupting my studies.','',26124),
(54597,'enUS','We may have to improvise. Make friends with the locals - whatever it takes to secure a beach-head.','',26124),
(54598,'enUS','I wonder. Did my master send you as a distraction from my studies?$b$b...or perhaps you were sent to test my patience.','',26124),
(54599,'enUS','Ready to cleanse the lake.','Ready to cleanse the lake.',26124),
(54600,'enUS','What did that Brewmaster do to my water?','',26124),
(54601,'enUS','This tastes funny...','',26124),
(54602,'enUS','I\'m ready. Go ahead with your ritual.','I\'m ready. Go ahead with your ritual.',26124),
(54603,'enUS','There\'s an altar nearby where I can conduct the ritual. Let\'s go!','',26124),
(54604,'enUS','Here we are... Keep them off me while I open the tan-chao, $p!','',26124),
(54605,'enUS','Felhounds pour forth from the demon portal!','Felhounds pour forth from the demon portal!',26124),
(54606,'enUS','Felguard pour forth from the demon portal!','Felguard pour forth from the demon portal!',26124),
(54607,'enUS','Doomguard pour forth from the demon portal!','Doomguard pour forth from the demon portal!',26124),
(54608,'enUS','Infernals rain from the sky!','Infernals rain from the sky!',26124),
(54609,'enUS','','There are too many of them!',26124),
(54610,'enUS','Hey, my stomach\'s grumbling back here. We\'ve been flying for hours!','',26124),
(54611,'enUS','All right, look sharp. We\'re There should be a land mass nearby where the survivors landed.','',26124),
(54612,'enUS','','Our systems are jammed, Commander! I can\'t control this plane!',26124),
(54613,'enUS','I don\'t believe it! Alliance colors!','',26124),
(54614,'enUS','Over here, $n!','',26124),
(54615,'enUS','Taylor must be close by.','',26124),
(54616,'enUS','','Ugh! We\'ve been hit!',26124),
(54617,'enUS','You must learn to become one with this land, stranger.$b$bOnly then will its secrets be revealed to you.','',26124),
(54618,'enUS','I am ready for my meditation lesson.','I am ready for my meditation lesson.',26124),
(54619,'enUS','','$p!  I am setting up a sobering fire.  If you need a fresh breath come toward me.',26124),
(54620,'enUS','The amount of time Aysa spends practicing seems excessive... but you can\'t deny the results.  Her form is beautiful.','',26124),
(54621,'enUS','Breathe deeply, stranger...','',26124),
(54622,'enUS','Clear your mind.','',26124),
(54623,'enUS','','With Shadowpour defeated, his title of Brewmaster falls to me.  Now I have to continue to undo the damage he has done to this valley.',26124),
(54624,'enUS','I remember when my shop saw this much traffic...','',26124),
(54625,'enUS','It is good to get out of Shattrath every now and then.','',26124),
(54626,'enUS','Not an apple cart to be seen...','',26124),
(54627,'enUS','So much junk food... But not a single apple.','',26124),
(54628,'enUS','And you are certain that Granny Smith has left her apples in our stall all this time?','',26124),
(54629,'enUS','So the fruit vendor was never going to wage war against us?  I find it hard to believe...','',26124),
(54630,'enUS','If what you say is true about the fruit vendor being an old lady... Bah!  It cannot be true!','',26124),
(54631,'enUS','So my shouting, my rally cries... All for nothing... Everyone must think me a fool...','',26124),
(54632,'enUS','','$n sighs.',26124),
(54633,'enUS','','$n shakes her head and sighs.',26124),
(54634,'enUS','','$n puts her hand to her face and lets out a long sigh.',26124),
(54635,'enUS','Can\'t you see I\'m trying to build ships here? Between you and those night elves, we\'ll never get this project done!','',26124),
(54636,'enUS','The warchief wants to know why his ships are delayed.','The warchief wants to know why his ships are delayed.',26124),
(54637,'enUS','The warchief? Big guy, giant spikey shoulderpads, short temper, and a morbid attachment to axes? THAT warchief?','',26124),
(54638,'enUS','Well, uh, the truth is, there were ships. There WERE!','',26124),
(54639,'enUS','Somehow the night elves found out we were going to launch the fleet and they struck! Most of the new ships were burned at anchor in the harbor!','',26124),
(54640,'enUS','I know it\'s too late to save them, but m-maybe you can take out the rest of the attackers...','',26124),
(54641,'enUS','Tell the warchief it isn\'t my fault! My guys fought back with mallets or whatever they had at hand, I swear!','',26124),
(54642,'enUS','My people will stand idle no longer. The halls of Ulduar shall be cleansed!','',26124),
(54643,'enUS','I am son of Rik-Rik the Great who fought the evil sky nubs and took their nibs.  He died.  Now I am General.  This is my skything.  Fear the mighty General Rik-Rik Junior.','',26124),
(54644,'enUS','I can\'t open the tan-chao while I\'m under attack!','',26124),
(54645,'enUS','You must strive to maintain a balance, no matter your surroundings...','',26124),
(54646,'enUS','Did you hear? They\'re safe somewhere!','',26124),
(54647,'enUS','','You, meet up with Commander Nightwind at the harbor, immediately.',26124),
(54648,'enUS','Mind your own business.','Mind your own business.',26124),
(54649,'enUS','You have failed yet again, stranger.','',26124),
(54650,'enUS','What do you want?','What do you want?',26124),
(54651,'enUS','Why are you bothering me?','Why are you bothering me?',26124),
(54652,'enUS','Do you want me to get the grunts?','Do you want me to get the grunts?',26124),
(54653,'enUS','What is the meaning of this?','What is the meaning of this?',26124),
(54654,'enUS','You\'d better leave if you don\'t want an axe through your skull!','You\'d better leave if you don\'t want an axe through your skull!',26124),
(54655,'enUS','Is this some kind of new $r mating ritual or something? Leave me alone!','Is this some kind of new $r mating ritual or something? Leave me alone!',26124),
(54656,'enUS','Don\'t you have business elsewhere?','Don\'t you have business elsewhere?',26124),
(54657,'enUS','Get away from me before I get angry!','Get away from me before I get angry!',26124),
(54658,'enUS','Go play under a wagon, peon!','Go play under a wagon, peon!',26124),
(54659,'enUS','$Cs have no respect these days, I tell you.','$Cs have no respect these days, I tell you.',26124),
(54660,'enUS','Stop staring at me and go make yourself useful!','Stop staring at me and go make yourself useful!',26124),
(54661,'enUS','H-how did you find me?','H-how did you find me?',26124),
(54662,'enUS','Help, $p! I\'m under attack!','',26124),
(54663,'enUS','Get them off me! I need total concentration to open the tan-chao!','',26124),
(54664,'enUS','','Oh, a visitor.  I don\'t get many visitors out here.$B$BHungry? I\'ve cooked MANY delightful things, my dear.$B$BNo, no, not the fish. Those are for when I can\'t catch anything tastier, sweetling.',26124),
(54665,'enUS','Hmmm, perhaps I was wrong about you, stranger.','',26124),
(54666,'enUS','In the dancing glow, we see an empty bowl. We fill the bowl - it becomes our body. We rest.','',26124),
(54667,'enUS','Most of my debt was repaid... I think...','Most of my debt was repaid... I think...',26124),
(54668,'enUS','I didn\'t think anyone would mind if I didn\'t stay to help run the faire.','I didn\'t think anyone would mind if I didn\'t stay to help run the faire.',26124),
(54669,'enUS','My debt was almost repaid.  No one was going to miss those last gold coins...','My debt was almost repaid.  No one was going to miss those last gold coins...',26124),
(54670,'enUS','Evade, evade!','',26124),
(54671,'enUS','We fear not the darkness of this world - we know it is but shadow, cast by the glorious world beyond.','',26124),
(54672,'enUS','What in blazes is this?','',26124),
(54673,'enUS','Get us out of here! Lose them in the fog!','',26124),
(54675,'enUS','We\'ll have to make an emergency water landing!','',26124),
(54676,'enUS','','What? Is that....LAND?',26124),
(54677,'enUS','Eject! The engines are going to blow!','',26124),
(54678,'enUS','We\'re not gonna make it! I\'m coming ta see you soon, pappy!','',26124),
(54679,'enUS','Let us begin.','',26124),
(54680,'enUS','We fear not the brilliance of the tan-chao - we know it is a path home. The bridge between earth and sky.','',26124),
(54681,'enUS','We are the lost. We know not who we are, or where we belong. We wander in darkness.','',26124),
(54682,'enUS','We see a flicker of flame. It seems far, but we know it to be close.','',26124),
(54683,'enUS','He is near, lurking in the shadows... I can sense it.','',26124),
(54684,'enUS','Be on alert.  The portals must not be sealed.','',26124),
(54685,'enUS','You, Felguard.  Hold this area.','',26124),
(54686,'enUS','It is done!','',26124),
(54687,'enUS','The rest of you, secure the courtyard.','',26124),
(54688,'enUS','No thank you.','No thank you.',26124),
(54689,'enUS','What business do ya have wit\' Shadow Hunter Urko\'jin?','',26124),
(54690,'enUS','','Da spirits have blessed this Totem o\' Seafarin\' for Urko\'jin. Dey go with him to battle our enemies.',26124),
(54691,'enUS','Spiritsage!!','',26124),
(54692,'enUS','Finally... we\'ll see an end to this torture.','',26124),
(54693,'enUS','With this totem, the spirits will bless your participation in the blockade.','With this totem, the spirits will bless your participation in the blockade.',26124),
(54694,'enUS','Da spirits have given me a sign of their favor! My men will join dis blockade.','',26124),
(54695,'enUS','Ya have the thanks of my men, $n. This totem be a powerful omen for war.','',26124),
(54696,'enUS','We will show da warchief da valor and skill of da Darkspears!','',26124),
(54697,'enUS','I\'ll follow them soon, but first let me express my grati-','',26124),
(54698,'enUS','I told you I\'d have you, Pei-Zhi. You\'ve set us back thousands of spirits today, but I\'d gladly trade them all to see you bound.','',26124),
(54699,'enUS','As for YOU, little $c.','',26124),
(54700,'enUS','%s surveys the corpses littering the ground.','',26124),
(54701,'enUS','It\'s no use sending more claws to die at your feet. Instead, I\'ll leave you this warning...','',26124),
(54702,'enUS','Run away and don\'t look back. Even you cannot hope to face the product of my next spirit-binding.','',26124),
(54703,'enUS','%s looks at Pei-Zhi with a smirk.','',26124),
(54704,'enUS','Do I know you?','',26124),
(54705,'enUS','We now hide in shadows, hidden from our enemies.','',26124),
(54706,'enUS','You a slicky little wicket? Hmm?','',26124),
(54707,'enUS','Wikket gunna swim with the slickies!','',26124),
(54708,'enUS','Thieving wikket not gunna take hozen slickies!','',26124),
(54709,'enUS','Smash the crystal. We need to move.','',26124),
(54710,'enUS','Destroy the portal energy focus!','',26124),
(54711,'enUS','No. General Nazgrim sent me to hire you and your crew for the Kalimdor blockade fleet.','No. General Nazgrim sent me to hire you and your crew for the Kalimdor blockade fleet.',26124),
(54712,'enUS','So many people to tend to...','So many people to tend to...',26124),
(54713,'enUS','I could never leave an injured friend alone...','I could never leave an injured friend alone...',26124),
(54714,'enUS','The faire is my family.  I would never leave my family.','The faire is my family.  I would never leave my family.',26124),
(54715,'enUS','So many are in need of help...','So many are in need of help...',26124),
(54716,'enUS','Shut down the portal and we will continue.','',26124),
(54717,'enUS','Maybe wikket taste like a slicky...','',26124),
(54718,'enUS','The war against the orcs, there seems to be no respite.','The war against the orcs, there seems to be no respite.',26124),
(54719,'enUS','So many have died at my hands.  I just wanted to escape those horrors.','So many have died at my hands.  I just wanted to escape those horrors.',26124),
(54720,'enUS','I was promised I would never have to encounter the horrors of war at the faire.','I was promised I would never have to encounter the horrors of war at the faire.',26124),
(54721,'enUS','For the right price, my crew and I will serve.$B$BBecause General Nazgrim is an honorable orc, I will only ask 100 gold initially, with generous hazard pay for myself and my men.','',26124),
(54722,'enUS','Very well. You\'ll have your gold.','Very well. You\'ll have your gold.',26124),
(54723,'enUS','Then we have a deal. I\'ll see you in battle, $n.','',26124),
(54724,'enUS','I joined the faire as a child...','I joined the faire as a child...',26124),
(54725,'enUS','For most of my life the faire has been my home.','For most of my life the faire has been my home.',26124),
(54726,'enUS','I ran away from my home in Strom after my father tried to kill me.','I ran away from my home in Strom after my father tried to kill me.',26124),
(54727,'enUS','My life before the faire was hard.  I never missed it, or my family.','My life before the faire was hard.  I never missed it, or my family.',26124),
(54728,'enUS','I joined the faire to escape my family.','I joined the faire to escape my family.',26124),
(54729,'enUS','I remember telling Silas, \"I never want to see my family again.\"','I remember telling Silas, \"I never want to see my family again.\"',26124),
(54730,'enUS','...gunna cook up the slicky wikket and feed \'em to King Ka Ka!','',26124),
(54731,'enUS','I was supposed to get firewood for the campsite...','I was supposed to get firewood for the campsite...',26124),
(54732,'enUS','I have such a hard time gathering firewood...','I have such a hard time gathering firewood...',26124),
(54733,'enUS','I thought I saw something in the bushes nearby... Then I suppose I blacked out.','I thought I saw something in the bushes nearby... Then I suppose I blacked out.',26124),
(54734,'enUS','When I woke up, I couldn\'t find my way back to the campsite...','When I woke up, I couldn\'t find my way back to the campsite...',26124),
(54735,'enUS','I\'m with you, $n.','',26124),
(54736,'enUS','Let us shut down this final portal and finish this.','',26124),
(54737,'enUS','Even death will not keep me from my duty to watch over the camp...','Even death will not keep me from my duty to watch over the camp...',26124),
(54738,'enUS','These woods are dangerous.  A lesson I learned the hard way.','These woods are dangerous.  A lesson I learned the hard way.',26124),
(54739,'enUS','I am to keep a close watch over the camp.','I am to keep a close watch over the camp.',26124),
(54740,'enUS','I don\'t know how long I\'ve been watching over the camp...','I don\'t know how long I\'ve been watching over the camp...',26124),
(54741,'enUS','I barely survived the shipwreck...','I barely survived the shipwreck...',26124),
(54742,'enUS','Silas kept me safe from my previous captors...','Silas kept me safe from my previous captors...',26124),
(54743,'enUS','I saw my captors die horrible deaths.$b$bAnd I laughed.','I saw my captors die horrible deaths.$b$bAnd I laughed.',26124),
(54744,'enUS','The faire kept me from an execution.  It saved my life.','The faire kept me from an execution.  It saved my life.',26124),
(54745,'enUS','Silas was able to repay most of my debt as long as I worked at the faire.','Silas was able to repay most of my debt as long as I worked at the faire.',26124),
(54746,'enUS','Aaaugh!','',26124),
(54747,'enUS','*hic*... grrrr...*hic*','',26124),
(54748,'enUS','*hic*','',26124),
(54749,'enUS','*hic*...Rawr?','',26124),
(54750,'enUS','The demons should all be leaving. We will be at the palace in no time.','',26124),
(54751,'enUS','Hang in there, Lieutenant!','',26124),
(54752,'enUS','Beware of Wolpertingers!  They like to bite when you least expect it.','',26124),
(54753,'enUS','Hurray for $p!  They let me turn them into a tea bag to fix my lake!','',26124),
(54754,'enUS','Where is my Potato?','',26124),
(54755,'enUS','We serve the world\'s TRUE masters! When their rule begins, we will share in their glory!','',26124),
(54756,'enUS','','There was something interesting about those red pandas.  I think I might have an idea on how to fix Brewmaster Shadowpour\'s drinks so they are non-lethally tasty.',26124),
(54757,'enUS','','Between the orchids and the cleaner waters I might have constructed a recipe for the ultimate brew.  I may need to get at Brewmaster Shadowpour\'s still in order to make it work.  To do that, we\'ll need to beat him at his own game.',26124),
(54758,'enUS','','We can use the orchids you gathered to purify the lake in the Valley of the Mad Brewer.  We\'ll need help though.$b$bMy friend Jian is a water sprite that has helped with some of my own brews and is very useful for getting just the right density of water.  He would know how best to distribute these herbs.',26124),
(54759,'enUS','Did Ji send you?  I like Ji!  She is happy face.  The Mad Brewer though, he is a big fat dry face meany!$b$bCan you help make my water friends better?  The dry faced meany put a bunch of nasty stuff in there.','',26124),
(54760,'enUS','Wikket grook the croc? Nice wikket?','',26124),
(54761,'enUS','Wikket savin\' hozen?','',26124),
(54762,'enUS','Hozen live to fish another day!','',26124),
(54763,'enUS','Wikket grookin\' crocs and savin\' hozen?','',26124),
(54764,'enUS','Hozen tellin\' Tooki Tooki wikket grookin\' crocs!','',26124),
(54765,'enUS','Who are you exactly?','Who are you exactly?',26124),
(54766,'enUS','You hide well, worms.  But how long you can delay your doom?','',26124),
(54767,'enUS','Color.  It gives us contrast, depth, value, and tone.  The simple shift of a hue can move a person to laughter or tears.','',26124),
(54768,'enUS','Every line, every stroke, helps define an image. It separates thought from parchment and seizes the attention of a viewer.','',26124),
(54769,'enUS','','Another band of Deathwing\'s converts? I\'ll be sure your death is especially painful.',26124),
(54770,'enUS','','Cry havoc!',26124),
(54772,'enUS','','And so ends your story.',26124),
(54773,'enUS','','Watch, heathens, as death surrounds you!',26124),
(54774,'enUS','','This... isn\'t how it\'s supposed to... end.',26124),
(54775,'enUS','Your magic is pathetic. Let me show you mine.','',26124),
(54776,'enUS','Let\'s make a game of this, hmmm? Hide well, worms, and you may yet live a little longer...','',26124),
(54777,'enUS','You dare deny me?!','',26124),
(54778,'enUS','No mortal may stand before me and live!','',26124),
(54779,'enUS','In life I had many cubs, and many grand cubs.  But none of my great grand cubs visit anymore.  Few remember with honor the great Windfur family lineage.','',26124),
(54780,'enUS','A conducting crystal overloads!','A conducting crystal overloads!',26124),
(54781,'enUS','You would champion the cause of such a lowly street rat? Very well, best me in combat and I shall consider giving you my blessing.','',26124),
(54782,'enUS','Enough!  You win... champion.  Tell that upstart that he has my blessing.','',26124),
(54783,'enUS','Challenge the Pandriarch.','Challenge the Pandriarch.',26124),
(54784,'enUS','Unworthy.','',26124),
(54785,'enUS','That was a fine battle!  The likes of which I have not enjoyed in many decades.  Go and give the boy my blessing.','',26124),
(54786,'enUS','Disappointing.','',26124),
(54787,'enUS','Strength!  That is the lifeblood of the Bramblestaff family.  My lineage lives today as a testament of physical greatness willing to take on any challenger.','',26124),
(54788,'enUS','A Wanderbrew wants to marry an Goldendraft?! Preposterous.','',26124),
(54789,'enUS','I yield!  The boy chose his champion well. Give him my blessing and make sure he does not squander it.','',26124),
(54790,'enUS','I can see you.','',26124),
(54791,'enUS','Some champion.','',26124),
(54792,'enUS','I watch as my lineage is reduced to a faded memory around me.  Once the greatest of all brewmasters we now stand backstage to the Stormstouts.  Bah!','',26124),
(54793,'enUS','I hear on the wind that you have helped my great great grand-daughter Ji achieve her dream of becoming a brewmaster.$b$bI am quite proud of her and very thankful to you for your aid.  You have helped put my family name back on the right track.','',26124),
(54794,'enUS','I hear you are responsible for saving one of my youngest descendants from the clutches of the Jade Witch.  I thank you for your heroism.','',26124),
(54795,'enUS','You are leaving?','You are leaving?',26124),
(54796,'enUS','I wish to speak with your chief.','I wish to speak with your chief.',26124),
(54797,'enUS','May your waters never run dry.','',26124),
(54798,'enUS','Behold the Gong of Hope!  Though really we replaced the gong with a bell many centuries ago.  The old gong was quite small and did not provide the proper level of hope infusion to our people.','',26124),
(54799,'enUS','Are you interested in bell and gong lore?  Not as many young ones are willing to take such a fascinating intellectual journey these days.','',26124),
(54800,'enUS','Pardon me traveller, but did you happen to bring any bamboo up from the forest below?  I spend all day staring at it, drooling, hungry to no avail.  Yet all I have to eat up here is what I can conjour from my limited magics.','',26124),
(54801,'enUS','<Miss Fanny stares forward resolutely. She is dedicated to her job.>','',26124),
(54802,'enUS','<Miss Fanny looks at you expectantly.>','',26124),
(54803,'enUS','Hit it with average power.','Hit it with average power.',26124),
(54804,'enUS','Hit it very softly.','Hit it very softly.',26124),
(54805,'enUS','Hit it as hard as possible.','Hit it as hard as possible.',26124),
(54806,'enUS','Hit it with average power.','Hit it with average power.',26124),
(54807,'enUS','Hit it very softly.','Hit it very softly.',26124),
(54808,'enUS','Hit it as hard as possible.','Hit it as hard as possible.',26124),
(54809,'enUS','Hit it with average power.','Hit it with average power.',26124),
(54810,'enUS','Hit it very softly.','Hit it very softly.',26124),
(54811,'enUS','Hit it as hard as possible.','Hit it as hard as possible.',26124),
(54812,'enUS','ENOUGH! It is time to end this game!','',26124),
(54813,'enUS','Hit me with average power!','Hit me with average power!',26124),
(54814,'enUS','Hit me softly!','Hit me softly!',26124),
(54815,'enUS','Hit me as hard as you possibly can!','Hit me as hard as you possibly can!',26124),
(54816,'enUS','The shadows serve ME, now...','',26124),
(54817,'enUS','I will find you!','',26124),
(54818,'enUS','The shadows will not save you.','',26124),
(54819,'enUS','Cower in hiding, heh.','',26124),
(54820,'enUS','','Ah. Well. That was even easier than I thought!',26124),
(54821,'enUS','','You\'re much... better... than I thought...',26124),
(54822,'enUS','','Tch!  So soon?',26124),
(54823,'enUS','','I hope your friends can do better.',26124),
(54824,'enUS','','Mmm, too much fun!',26124),
(54825,'enUS','','Good night...',26124),
(54826,'enUS','','Bye-bye.',26124),
(54827,'enUS','','Surprise.',26124),
(54828,'enUS','','Now you see me...',26124),
(54829,'enUS','Nothing will stop me. Not even you, demon.','',26124),
(54831,'enUS','Return to the shadows!','',26124),
(54832,'enUS','My strength returns.','',26124),
(54833,'enUS','Who shut down the portals? Clever little worms.','',26124),
(54834,'enUS','None will reach the palace without besting Peroth\'arn, first of fel-touched!','',26124),
(54835,'enUS','Explain your presence.','',26124),
(54836,'enUS','Talk with me now.','',26124),
(54837,'enUS','Are you here to help?','',26124),
(54838,'enUS','The hunter became the prey.','',26124),
(54839,'enUS','You did well, but for now I must continue alone.  Good hunting.','',26124),
(54840,'enUS','Whoa! I feel great!','',26124),
(54841,'enUS','I\'ve got to get back to work!','',26124),
(54842,'enUS','I\'ve never felt better! Thank you!','',26124),
(54843,'enUS','I feel as good as new! My thanks, stranger.','',26124),
(54844,'enUS','Work, work, work! I love to work!','',26124),
(54845,'enUS','%s begins to transform everybody into puppets! You must interrupt her!','%s begins to transform everybody into puppets! You must interrupt her!',26124),
(54846,'enUS','|TInterface\\Icons\\ability_warrior_bloodnova.blp:20|tThe %s is injured and sprouts |cFFFE9A2EBlistering Tentacles|r!','',26124),
(54847,'enUS','|TInterface\\Icons\\ability_vehicle_sonicshockwave.blp:20|t%s begins to cast |cFFFF0000|Hspell:103678|h[Cauterize]|h|r!','',26124),
(54848,'enUS','Slickies?','',26124),
(54849,'enUS','You should only see this once.','',26124),
(54850,'enUS','Saw slicky with three eyes.  Bad sign.','',26124),
(54851,'enUS','No tanks.  Watching figure.','',26124),
(54852,'enUS','Had a slicky that tasted like jangos.','',26124),
(54853,'enUS','Slicky not so slick now eh?','',26124),
(54854,'enUS','Hozenball!','',26124),
(54855,'enUS','Wake up, stranger! What are you doing in my house?','',26124),
(54856,'enUS','Who stole my slicky?','',26124),
(54857,'enUS','Dook if I know.','',26124),
(54858,'enUS','Ask Super Dooker Rik-Rik.','',26124),
(54859,'enUS','Who are you... WHAT are you?','Who are you... WHAT are you?',26124),
(54860,'enUS','What is this land? Why has its presence been hidden for centuries?','What is this land? Why has its presence been hidden for centuries?',26124),
(54861,'enUS','How can I help the jinyu win against those monkey savages?','How can I help the jinyu win against those monkey savages?',26124),
(54862,'enUS','Can you help me find the White Pawn?','Can you help me find the White Pawn?',26124),
(54863,'enUS','Examines a steaming pile of smelly stuff on the ground.','',26124),
(54864,'enUS','Someone lost their derk?','',26124),
(54865,'enUS','I cannot fill a cup that is already overflowing.','',26124),
(54866,'enUS','First, you must become an empty vessel.','',26124),
(54867,'enUS','Get back onto the plainshawk\'s back!','Get back onto the plainshawk\'s back!',26124),
(54868,'enUS','Ookin\' slicky? Nookanookanooka!','',26124),
(54869,'enUS','Ookin\' wikket gronkin\' hozen? Grookie wikket!','',26124),
(54870,'enUS','Their fate is sealed.','',26124),
(54871,'enUS','Leave nothing but smoldering husks.','',26124),
(54872,'enUS','I cannot fill a cup that is already overflowing. Before you can gain wisdom, you must become an empty vessel.','',26124),
(54873,'enUS','Gimme all your vegetables!','',26124),
(54874,'enUS','AIIIIEEEEEEE!','',26124),
(54875,'enUS','%s feels players on his left side. He\'s about to roll left!','',26124),
(54876,'enUS','This virmen land!','',26124),
(54877,'enUS','You no take carrot! You take turnip instead!','',26124),
(54878,'enUS','%s feels players on his right side. He\'s about to roll right!','',26124),
(54879,'enUS','%s rolls left!','',26124),
(54880,'enUS','%s rolls right!','',26124),
(54881,'enUS','Hello, friend. Care to purchase anything while you\'re here?','',26124),
(54882,'enUS','I\'ve put my son, Ang, in charge of my vegetable farm, just down the hill. My nephew Liang runs the pig farm down to the west, and his father - my brother - maintains a small sheep ranch to the south of that.$b$bMy farming days are over. These days, I just gather the harvested crops and sell them to folks headed down this road. Less time on my feet, more money in my pocket.','',26124),
(54883,'enUS','Take their slickies!','',26124),
(54884,'enUS','Not gonna jorb my jangos!','',26124),
(54885,'enUS','Hozen and wikket... friends?','',26124),
(54886,'enUS','You been savin\' hozen, wikket?$b$bWikket loves hozen?','',26124),
(54887,'enUS','Hozen startin\' to like wikket.$b$bWikket maybe not so bad...','',26124),
(54888,'enUS','The mist senses your presence!','The mist senses your presence!',26124),
(54889,'enUS','Mist gathers around you.','Mist gathers around you.',26124),
(54890,'enUS','All around you, the mist grows denser.','All around you, the mist grows denser.',26124),
(54891,'enUS','The mist envelops you in its grip!','The mist envelops you in its grip!',26124),
(54892,'enUS','Out of the mist, a creature emerges!','Out of the mist, a creature emerges!',26124),
(54893,'enUS','The mist dissipates...','The mist dissipates...',26124),
(54894,'enUS','%s levels out.','',26124),
(54897,'enUS','I destroyed twenty hozen before my capture!','',26124),
(54898,'enUS','Lucky for you I\'m in this cage.','',26124),
(54899,'enUS','My people and their new allies will burn this village to the ground.','',26124),
(54900,'enUS','Hozen! Your time is short. We have new allies!','',26124),
(54901,'enUS','You\'re a funny lookin\' jabber.','',26124),
(54902,'enUS','Let\'s move out, friend! There\'s no time to lose.','',26124),
(54903,'enUS','Corastrasza is understandably upset. Under her care was the one black dragon egg that we believe was free of the taint of Deathwing\'s corruption...','',26124),
(54904,'enUS','...and it was stolen away from us by thieves in the night!','',26124),
(54905,'enUS','You\'ve found for us our only lead. The rogues from Ravenholdt are behind this.','',26124),
(54906,'enUS','Ravenholdt? It just doesn\'t make sense! A mongrel band of petty thieves. How did they even KNOW about the egg?','',26124),
(54907,'enUS','We\'ll get to the bottom of this. Someone with your skills is exactly what we need.','',26124),
(54908,'enUS','What\'s the expression? \"To catch a thief,\" they say?','',26124),
(54909,'enUS','Look at this devastation. These foothills have never recovered from the campaigns of the second and third wars.','',26124),
(54910,'enUS','Ruins and debris litter the landscape... and I consider the thieves and assassins of Ravenholdt to be part of that debris.','',26124),
(54911,'enUS','Without a state... without a cause... what drives them, do you wonder?','',26124),
(54912,'enUS','And what possessed them to strike out against the red dragonflight? Madness. We must learn more!','',26124),
(54913,'enUS','We\'re almost to Ravenholdt Manor.','',26124),
(54914,'enUS','If they have the egg, it\'s too dangerous to risk an all-out assault. You\'ll need to sneak in there, find out what they\'re up to... And retrieve the egg at any cost.','',26124),
(54915,'enUS','Quiet now! We\'ll form up a plan within this cave...','',26124),
(54916,'enUS','Hide, worms! The hunt is on...','',26124),
(54917,'enUS','Hear from Yoggtard? He owes me nibs.','',26124),
(54918,'enUS','This place is GREAT! Have you seen how much FOOD they have here?','',26124),
(54919,'enUS','Sure, the others might have gone off on exciting adventures, but I don\'t mind. I\'m perfectly happy right here.','',26124),
(54920,'enUS','The long walk from the monastery was murder on my feet - and on my appetite. I think I\'ll spend a while here loading up on energy before I think about standing up again.','',26124),
(54921,'enUS','This is a family farm, in case you haven\'t noticed yet. We Thunderfoots don\'t fight, don\'t explore... we don\'t even drink that much.$b$bWe do enjoy our food, however.','',26124),
(54922,'enUS','Running a pig farm is more work than you\'d think... though most of it can be boiled down to \"find more food for the pigs.\"','',26124),
(54923,'enUS','Ahh! Hawks!$b$bAHHHH! WOLVES!','',26124),
(54924,'enUS','I can\'t take much more of this! Am I really supposed to go fight those wolves?','',26124),
(54925,'enUS','My sheep! Someone, do something!','',26124),
(54926,'enUS','','Come ON, Uncle Chen! What are we waiting for?',26124),
(54927,'enUS','Relax, Li Li. We have all the time in the world to explore Pandaria. Take some time to enjoy the trip.','',26124),
(54928,'enUS','','I would enjoy the trip more if we were actually GOING somewhere!',26124),
(54929,'enUS','','Can we go yet? Are you done with your beer?',26124),
(54930,'enUS','Almost.','',26124),
(54931,'enUS','','How about now?',26124),
(54932,'enUS','','Let\'s get going! There\'s a whole big valley waiting for us, but you\'re too focused on the bottom of that mug to see it.',26124),
(54933,'enUS','Yes, Li Li, but the bottom of this mug is very interesting to me.','',26124),
(54934,'enUS','','I\'ll leave without you. Don\'t think I\'m bluffing. I don\'t need some smelly old uncle to hold my hand.',26124),
(54935,'enUS','Why are you so impatient? Are you worried that the mists are going to come back before I finish my drink?','',26124),
(54936,'enUS','','Well, NOW I am!',26124),
(54937,'enUS','','Here we are, FINALLY setting foot in our ancestral home, for the first time in our lives, and you want to stop and rest by a PIG FARM?',26124),
(54938,'enUS','Be patient, Li Li. If we explore Pandaria too quickly, we will quickly run out of Pandaria to explore.','',26124),
(54939,'enUS','','That... barely even makes sense! You\'re just saying that because you\'re lazy and old!',26124),
(54940,'enUS','[TEMP] CAN I STAY HERE OK THANKS','',26124),
(54941,'enUS','I have but helped you begin your journey. Great rewards await you, but whether you finish it is up to you.','',26124),
(54942,'enUS','You have a strong presence about you, stranger. I am not yet certain whether you will bring light or shadow to this land, but I do know that you are strong of heart.','',26124),
(54943,'enUS','I am not fond of strangers, but I see great potential within you. Yes...you may be a most interesting student.','',26124),
(54944,'enUS','I need another Dream Brew, Master.','I need another Dream Brew, Master.',26124),
(54945,'enUS','No! My sheep!','',26124),
(54946,'enUS','H-h-hey! Bring that back!','',26124),
(54947,'enUS','Oh no...','',26124),
(54948,'enUS','I\'m sorry, little sheep!','',26124),
(54949,'enUS','G-g-go away! Bring my sheep back!','',26124),
(54950,'enUS','C-c-come back here! That\'s my sheep!','',26124),
(54951,'enUS','Oh my, this is bad...','',26124),
(54952,'enUS','Francis! We need to talk!','',26124),
(54953,'enUS','Come see me when you are finished, $n. I live in the small farmhouse, just down the road.','',26124),
(54954,'enUS','Uh-oh... here comes the master now...','',26124),
(54955,'enUS','|TInterface\\Icons\\inv_gizmo_supersappercharge.blp:20|t%s is casting |c0087CEFA|Hspell:105845|h[Nuclear Blast]|h|r!','',26124),
(54956,'enUS','Wei, are these friends of yours?','',26124),
(54957,'enUS','The Vermillion Redoubt is our base of operations here in the Twilight Highlands.$B$BFrom this perch we can supervise the assault on Grim Batol and the cleansing of the river valley below.','',26124),
(54958,'enUS','Hail, $r! If you\'re looking for Corastrasza, she\'s just inside.$B$B<Mostrasz shifts his weight uncomfortably.>$B$BShe\'s not in a very good mood.','',26124),
(54959,'enUS','$n! Great work decoding the message. Let\'s get to the bottom of this.$B$BAre you ready to fly?','',26124),
(54960,'enUS','I\'m ready! Let\'s go to Ravenholdt.','I\'m ready! Let\'s go to Ravenholdt.',26124),
(54961,'enUS','I... I can\'t believe you did that! You could have died up there! The way you were wrestling with that eagle, and how you used its wings to land safely... it was amazing!$b$bIf you can do something like that, then... then I can handle some measly wolves and plainshawks! This is the dawn of a new Francis.$b$bAnd it\'s all thanks to you, $n.','',26124),
(54962,'enUS','Did... did he just say I was like a son to him?','',26124),
(54963,'enUS','Wow, you\'re not like anything I\'ve seen before!','',26124),
(54964,'enUS','You look really scary! Good thing my brother said you are friendly.','',26124),
(54965,'enUS','Did you really save my brother? That idiot got himself captured by the hozen. He\'s lucky he met you.','',26124),
(54966,'enUS','How do you swim in all those clothes?','',26124),
(54967,'enUS','(Awesome completion event here where Huo gets re-ignited and flares up, then expresses appretiation in some non text-based form)','',26124),
(54968,'enUS','(Fancy completion event where temple braziers are re-ignited and the accomplishments are recognized)','',26124),
(54969,'enUS','%s calls upon the |cFF9932CD|Hspell:104896|h[Purple]|h|r, |cFF088A08|Hspell:104898|h[Green]|h|r, and |cFF0080FF|Hspell:104900|h[Blue]|h|r Bloods of Shu\'ma!','',26124),
(54971,'enUS','It is time. Sully and I are leaving to scout the interior of the island.','',26124),
(54972,'enUS','If there\'s any sign of Anduin, we\'ll find it.','',26124),
(54973,'enUS','I swear I will keep him safe. We will return as soon as we can.','',26124),
(54975,'enUS','$n, stay here and help Taylor recover.','',26124),
(54976,'enUS','Make friends with the jinyu. We may need them before this mission is over, and that\'s an order.','',26124),
(54977,'enUS','Wait! Even though we are not friends, you should not go into unfamiliar territory alone.','',26124),
(54978,'enUS','%s calls upon the |cFF088A08|Hspell:104898|h[Green]|h|r, |cFFFF0404|Hspell:104897|h[Red]|h|r, and |cFF424242|Hspell:104894|h[Black]|h|r Bloods of Shu\'ma!','',26124),
(54979,'enUS','I will send my brother to go with you.','',26124),
(54980,'enUS','%s calls upon the |cFF088A08|Hspell:104898|h[Green]|h|r, |cFFFFA901|Hspell:104901|h[Yellow]|h|r, and |cFFFF0404|Hspell:104897|h[Red]|h|r Bloods of Shu\'ma!','',26124),
(54981,'enUS','Please bring him back safely. He is young, but clever. He can help you find your way.','',26124),
(54982,'enUS','%s calls upon the |cFF9932CD|Hspell:104896|h[Purple]|h|r, |cFF0080FF|Hspell:104900|h[Blue]|h|r, and |cFFFFA901|Hspell:104901|h[Yellow]|h|r Bloods of Shu\'ma!','',26124),
(54983,'enUS','%s calls upon the |cFF0080FF|Hspell:104900|h[Blue]|h|r, |cFF424242|Hspell:104894|h[Black]|h|r, and |cFFFFA901|Hspell:104901|h[Yellow]|h|r Bloods of Shu\'ma!','',26124),
(54984,'enUS','%s calls upon the |cFF9932CD|Hspell:104896|h[Purple]|h|r, |cFFFF0404|Hspell:104897|h[Red]|h|r, and |cFF424242|Hspell:104894|h[Black]|h|r Bloods of Shu\'ma!','',26124),
(54985,'enUS','Hmm, you want... me?','',26124),
(54986,'enUS','Rell lowers his voice to a whisper.','',26124),
(54987,'enUS','<The body has been very badly burned and nearly bitten in half.>$B$B<The red dragonflight may be the guardians of all life on Azeroth, but clearly they are not to be crossed.>','',26124),
(54988,'enUS','Shortly after you disappeared into the jungle, rescued soldiers began returning to us at Paw\'don. It wasn\'t difficult to track you here.','',26124),
(54989,'enUS','You were the one that rescued Admiral Taylor? So the jinyu was telling the truth...','',26124),
(54990,'enUS','(Completion event where Ox cart tries to roll Wugou over, ropes snap, Wugou snores loudly and doesn\'t wake)','',26124),
(54991,'enUS','%s snorts loudly, and continues sleeping.','',26124),
(54992,'enUS','(Event where Shu splashes Wugou with a giant ball of water, Wugou wakes, then starts chasing Shu around town)','',26124),
(54993,'enUS','','It feels like we were in that forest forever. Let\'s go! We\'ve got to explore the valley!',26124),
(54994,'enUS','Do not be too hasty, Li Li. This is how I traveled Kalimdor: one stop at a time.','',26124),
(54995,'enUS','','No wonder it took you so long, then. You can\'t explore anything sitting on your butt.',26124),
(54996,'enUS','','Chen, I think I know why you like it here so much.',26124),
(54997,'enUS','Why is that, Li Li?','',26124),
(54998,'enUS','','Because those two guys make you feel skinny.',26124),
(54999,'enUS','Why would I want to feel skinny? Size is strength.','',26124),
(55000,'enUS','Look at Xiao over there. He understands the value of a big belly.','',26124),
(55001,'enUS','(Event where Shang speaks of Shen-zin Su and how you\'re going to talk to him, then plants his staff and passes on)','',26124),
(55002,'enUS','','You are our first turn of good fortune in several days. We\'re glad to have the help.',26124),
(55003,'enUS','Very well. Let us proceed.','',26124),
(55004,'enUS','My father? What good is it to speak to him?','',26124),
(55005,'enUS','While the hozen pillage our supplies and kill our warriors, what does he do? Nothing!','',26124),
(55006,'enUS','He sits idly on his chieftain\'s chair, content to mask his cowardice with dreams of peace!','',26124),
(55007,'enUS','The hozen do not understand peace! They will slaughter our village until none of us remain!','',26124),
(55008,'enUS','I...I am sorry for my outburst, $n. My father and I disagree on many things.','',26124),
(55009,'enUS','I owe you a great debt for saving my life. Of course I will help you gain audience with the Elder.','',26124),
(55010,'enUS','Feedin\' time for da furries.','',26124),
(55011,'enUS','Finds one!','',26124),
(55012,'enUS','Shiny!','',26124),
(55013,'enUS','Hee hee!','',26124),
(55014,'enUS','Catch!','',26124),
(55015,'enUS','Wheee!','',26124),
(55016,'enUS','Alley-OOP!','',26124),
(55017,'enUS','Gots it!','',26124),
(55018,'enUS','Yay!!','',26124),
(55020,'enUS','Munchy munchy!','',26124),
(55021,'enUS','Look! Here comes Miss Fanny right now!','',26124),
(55022,'enUS','','I believe I heard some young whipper snapper in my garden out back.  Let\'s go look for him.',26124),
(55023,'enUS','|TInterface\\Icons\\spell_fire_moltenblood.blp:20|t%s begins to |cFFFF0000|Hspell:105863|h[Hemorrhage]|h|r!','',26124),
(55024,'enUS','I doubt that we will ever win against the hozen.','',26124),
(55025,'enUS','Look around you. See how the waters bring life.$B$BWe are grateful for our blessings, and we rejoice in our people.','',26124),
(55026,'enUS','It has been a long time since we welcomed visitors to our village.','',26124),
(55027,'enUS','Once, when I was young, I dreamt of ending this war against the hozen. Now, I fear I will not see such a day before my death.','',26124),
(55028,'enUS','It is rude to speak to jinyu of a higher rank than yourself.','',26124),
(55029,'enUS','Only those of the highest esteem may speak to the elder.','',26124),
(55030,'enUS','The elder is very busy with important matters. Please come back at another time.','',26124),
(55031,'enUS','I have brought the items for the ceremony.','I have brought the items for the ceremony.',26124),
(55032,'enUS','Brother, I see great darkness looming before you.','',26124),
(55033,'enUS','Everywhere I look, the rivers have dried.','',26124),
(55034,'enUS','But there is yet one path, one river, that may carry you through these difficult times.','',26124),
(55035,'enUS','Powerful strangers come from across the sea. Seek their strength. Add it to our own.','',26124),
(55036,'enUS','Or else great darkness looms in the days ahead...','',26124),
(55037,'enUS','I see great darkness looming in the days ahead.','',26124),
(55038,'enUS','We jinyu do not cower in fear of defeat. Neither do we fight simply for victory.','',26124),
(55039,'enUS','We fight because we believe in what we fight for.','',26124),
(55040,'enUS','You must decide, young Lu. What is worth fighting for?','',26124),
(55041,'enUS','What is worth dying for?','',26124),
(55042,'enUS','We fight so that our children can live better lives than ours!','',26124),
(55043,'enUS','We fight so that sacrifices of our ancestors were not in vain!','',26124),
(55044,'enUS','There are a thousand reasons, but you must decide what is worth fighting for.','',26124),
(55045,'enUS','Ancient spirits of water.','',26124),
(55046,'enUS','Hear my echo through the silent deeps.','',26124),
(55047,'enUS','Awaken from the great waters beyond.','',26124),
(55048,'enUS','Aid your children in this time of need!','',26124),
(55049,'enUS','A great darkness? Could he mean that we must trust these strangers... these... Alliance... after all?','',26124),
(55050,'enUS','Perhaps I have been too shrouded in my own doubts and fears.','',26124),
(55051,'enUS','I must become a better leader for our tribe.','',26124),
(55052,'enUS','Thank you for your counsel. I will meditate on it deeply.','',26124),
(55053,'enUS','Ancient spirits of water!','',26124),
(55054,'enUS','Stay on the ground, and stay hidden. I\'ll port you back here if you get into any trouble!','',26124),
(55055,'enUS','Da slickies win.','',26124),
(55056,'enUS','Ooked my dookin\' slickies.','',26124),
(55057,'enUS','|TInterface\\Icons\\INV_Misc_Food_Vendor_PinkTurnip.blp:64:64:100:0|t$b$b<What would you like Miss Fanny to do to the turnip?>','',26124),
(55058,'enUS','|TInterface\\Icons\\INV_MISC_FOOD_VENDOR_STRIPEDMELON.BLP:64:64:100:0|t$b$b<What would you like Miss Fanny to do to the watermelon?>','',26124),
(55059,'enUS','|TInterface\\Icons\\inv_guild_cauldron_b.blp:64:64:100:0|t$b$b<What would you like Miss Fanny to do to the extra-spicy tofu?>','',26124),
(55060,'enUS','Whoah there, Miss Fanny. Maybe that was too hard.','',26124),
(55061,'enUS','Miss Fanny, you stronger than that! Try and put a little more ook in it next time!','',26124),
(55062,'enUS','Easy, Miss Fanny. You hit watermelons too hard... they go boom!','',26124),
(55063,'enUS','Ahhhh ha ha ha ha! It barely even go halfway down the hill!','',26124),
(55064,'enUS','Whoah. Nice shootin\', Miss Fanny!','',26124),
(55065,'enUS','Good bonk, Miss Fanny! You got nice control!','',26124),
(55066,'enUS','Nice, Miss Fanny! You hit it strong!','',26124),
(55067,'enUS','Hey, $gmister:lady;, what you doing? You gonna get yourself killed!','',26124),
(55068,'enUS','<Miss Fanny looks you in the eye and subtly turns her head. Does... does she want to launch YOU?>$b$b<Assuming that you have correctly interpreted her intentions, how hard should Miss Fanny hit you?>','',26124),
(55069,'enUS','Over here!','',26124),
(55070,'enUS','','Can we go yet? Are you done with your beer?',26124),
(55071,'enUS','Almost.','',26124),
(55072,'enUS','','How about now?',26124),
(55073,'enUS','','Come ON, Uncle Chen! What are we waiting for?',26124),
(55074,'enUS','Relax, Li Li. We have all the time in the world to explore Pandaria. Take some time to enjoy the trip.','',26124),
(55075,'enUS','','I would ENJOY the trip more if we were actually GOING somewhere!',26124),
(55076,'enUS','You and all your friends are welcome to stay here for as long as you like.','',26124),
(55077,'enUS','Does all of this farmland belong to you?','Does all of this farmland belong to you?',26124),
(55078,'enUS','Hey! Got out of here!','',26124),
(55079,'enUS','Stay away from my sheep!','',26124),
(55080,'enUS','Come back here, you coward!','',26124),
(55081,'enUS','Bring back my sheep!','',26124),
(55082,'enUS','Get back over here, thief!','',26124),
(55083,'enUS','Despair...','',26124),
(55084,'enUS','You will not take our waters!','',26124),
(55085,'enUS','A worthy sacrifice for our master.','',26124),
(55086,'enUS','Darkness awaits...','',26124),
(55087,'enUS','The corruption will consume you, as it consumed us...','',26124),
(55088,'enUS','The waters are forbidden to all!','',26124),
(55089,'enUS','In the end, only silence remains.','',26124),
(55090,'enUS','The living are not welcome here!','',26124),
(55091,'enUS','Recovering','Recovering',26124),
(55092,'enUS','Time to die, turnip!','',26124),
(55093,'enUS','Attack turnips!','',26124),
(55094,'enUS','Kill ALL the turnips!','',26124),
(55095,'enUS','First kill turnips! Then kill pandaren that grows them!','',26124),
(55096,'enUS','We murder every turnip!','',26124),
(55097,'enUS','Turnips! Why you so bad?','',26124),
(55098,'enUS','Turnips must be punished!','',26124),
(55099,'enUS','Pandaren pay for growing disgusting turnips!','',26124),
(55100,'enUS','Be at peace.','',26124),
(55101,'enUS','Be cleansed, spirit.','',26124),
(55102,'enUS','Shadows, begone!','',26124),
(55103,'enUS','Be at peace, spirit.','',26124),
(55104,'enUS','I am finally...free...','',26124),
(55105,'enUS','My boat winning!','',26124),
(55106,'enUS','The light...returns...','',26124),
(55107,'enUS','I think my boat stuck.','',26124),
(55108,'enUS','Watermelon boats float really easy.','',26124),
(55109,'enUS','Use the waters well. They are priceless beyond compare...','',26124),
(55110,'enUS','Thank you, stranger...','',26124),
(55111,'enUS','Look how slow your boat go.','',26124),
(55112,'enUS','The shadows are gone...the corruption is lifted.','',26124),
(55113,'enUS','Time to steal more watermelon soon.','',26124),
(55114,'enUS','We protect the waters. From greed, from darkness.','',26124),
(55115,'enUS','Gonna need more boats soon.','',26124),
(55116,'enUS','Boats go faster if take leafs off.','',26124),
(55117,'enUS','Go, go, go!','',26124),
(55118,'enUS','You dare to disturb these waters? You will drown!','',26124),
(55121,'enUS','','Shoo!',26124),
(55122,'enUS','','Go away, marmots!',26124),
(55123,'enUS','','Stay out of our crops!',26124),
(55124,'enUS','','Shoo, shoo!',26124),
(55125,'enUS','Defeat the Great White Plainshawk!','',26124),
(55126,'enUS','$n, we meet again! You looking for Shang? I think he\'s in back, polishing his melon.','',26124),
(55127,'enUS','Finally! To be free from the grip of that darkness. The light! The blessed, beautiful light!','',26124),
(55128,'enUS','A thousand lifetimes ago, I brought the waters here. A gift to the Pearlfin for ancient deeds.','',26124),
(55129,'enUS','We guarded the waters. Too dangerous, too powerful, to fall into the wrong hands.','',26124),
(55130,'enUS','Then the darkness came. It seeped from the ground. Slowly, it infected us...suffocated us!','',26124),
(55131,'enUS','Even after our mortal flesh had rotted away, it leeched hope from our souls. It was unending!','',26124),
(55132,'enUS','I shudder at the thought. An ancient evil. An enemy of Pandaria. I will not speak their name.','',26124),
(55133,'enUS','What happened to you, master?','',26124),
(55134,'enUS','What was the darkness that corrupted you?','',26124),
(55135,'enUS','Perhaps this one will know something about the poem. Be cleansed, spirit!','',26124),
(55136,'enUS','It looks like our paths have crossed again, $n. At a pig farm, of all places.$b$bI enjoy this valley. It almost feels like... home. The green fields, the big sky... I have even heard mention that there\'s a big brewery down the road. Maybe it is time I settled down once and for all.$b$b<Chen looks off into the distance for a few long seconds, then shrugs his shoulders.>$b$bOr maybe not.','',26124),
(55137,'enUS','Little hand says it\'s time to rock and roll. Everyone into the hold: We\'ve got a dragon to kill.','',26124),
(55138,'enUS','FOR THE HORDE!','FOR THE HORDE!',26124),
(55139,'enUS','I... I am in your debt.','I... I am in your debt.',26124),
(55140,'enUS','','Ji may kill Shen-zin Su if we let him go through with this! Come with me, $p, quickly!',26124),
(55141,'enUS','Woah... get away from me, crazy... spider-thing!','Woah... get away from me, crazy... spider-thing!',26124),
(55142,'enUS','Ah! It\'s comin\' right for me!','Ah! It\'s comin\' right for me!',26124),
(55143,'enUS','Why did it have to be spiders?!','Why did it have to be spiders?!',26124),
(55144,'enUS','Ahh, get these things away from me!','Ahh, get these things away from me!',26124),
(55145,'enUS','No! I don\'t want to be nibbled!','No! I don\'t want to be nibbled!',26124),
(55146,'enUS','Grr... get a little closer, critter. I\'ll bite yer legs off!','Grr... get a little closer, critter. I\'ll bite yer legs off!',26124),
(55147,'enUS','%s huffs and puffs, trying to blow at the $n.','%s huffs and puffs, trying to blow at the $n.',26124),
(55148,'enUS','%s struggles to turn his face away from the $n.','%s struggles to turn her face away from the $n.',26124),
(55149,'enUS','I have never seen a place like this. Have you, $n?','',26124),
(55150,'enUS','The pandaren are full of ancient knowledge. Lina has been teaching me the medicinal uses of the local herbs.','',26124),
(55151,'enUS','Where do you think the pandaren came from? Why have they been hidden for so long?','',26124),
(55152,'enUS','Someday, Ren is going to show me his family\'s village.','',26124),
(55153,'enUS','How is my father? I hope he is not too worried. He worries too much about me.','',26124),
(55154,'enUS','My father doesn\'t think so, but I can take care of myself.','',26124),
(55155,'enUS','I don\'t want to go home quite yet. There\'s still so much to see and learn.','',26124),
(55156,'enUS','It is time to go home, Prince Anduin.','It is time to go home, Prince Anduin.',26124),
(55157,'enUS','<Ren tosses about deliriously. His brow is hot with fever.>$B$BWa....water...','',26124),
(55158,'enUS','','Any friend of Anduin\'s is a friend of ours, $c. My father would not be here without him.',26124),
(55159,'enUS','I am sorry, but I cannot go back just yet.','',26124),
(55160,'enUS','I\'ve decided to search for the Vale. I must find the Sacred Pools and study their healing powers.','',26124),
(55161,'enUS','Prince Anduin, we\'ve come to take ye home.','',26124),
(55162,'enUS','Come quietly, now.','',26124),
(55163,'enUS','I\'m sorry, but I won\'t. I\'m sure you understand my reasons.','',26124),
(55164,'enUS','Eh? Oh...uh...you\'re absolutely right, Prince Anduin. You are free to go as you please.','',26124),
(55165,'enUS','Come on, let\'s go.','',26124),
(55166,'enUS','','Sully! How could you just let him go?',26124),
(55167,'enUS','Eh? What happened?','',26124),
(55168,'enUS','','You silly dwarf, he mind controlled you! Now he\'s gone!',26124),
(55169,'enUS','','I hope you\'re ready to explain this to Admiral Taylor!',26124),
(55170,'enUS','Whaaa? I can\'t believe he did that ta me!','',26124),
(55171,'enUS','Find your soul to break the curse!','Find your soul to break the curse!',26124),
(55172,'enUS','','Who would have thought these creatures could be reasoned with?',26124),
(55173,'enUS','Nazgrim has assigned you to scout the region, Shokia. You are to depart shortly.','Nazgrim has assigned you to scout the region, Shokia. You are to depart shortly.',26124),
(55174,'enUS','','I\'ll make ready.$b$bIt will be good to get away from these savages for a time.',26124),
(55175,'enUS','This will take some getting used to.$b$bI struggle to resist the urge to rip the heads from these creatures.','',26124),
(55176,'enUS','Nazgrim has assigned you to help scout the region, Gorrok. You are to depart shortly.','Nazgrim has assigned you to help scout the region, Gorrok. You are to depart shortly.',26124),
(55177,'enUS','A shame. I could use a bit of rest.$b$bNo matter. Tell Nazgrim that I will accompany the party.','',26124),
(55178,'enUS','','You know, these little guys aren\'t so bad once you get to know them...',26124),
(55179,'enUS','Nazgrim has assigned you to the scouting party, Kiryn. You are to depart shortly.','Nazgrim has assigned you to the scouting party, Kiryn. You are to depart shortly.',26124),
(55180,'enUS','','Well of course he did. He\'d be a fool not to.$b$bThank you, $r. I\'ll prepare to depart at once.',26124),
(55181,'enUS','Much obliged, stranger.','Well thankee, friend!',26124),
(55182,'enUS','I weren\'t scurred...','Oof, that\'s better... How\'s my hair?',26124),
(55183,'enUS','I gotta tell my cubs about this! Of course, I\'ll change the part where their paw-paw got stuck...','That\'s it: I\'m demanding hazard pay after this.',26124),
(55184,'enUS','Never thought I\'d need a $c to save me from nibblers. Thank you!','My favorite kind of $c: the brave, rescue-y type!',26124),
(55185,'enUS','The stench of Alliance scum is in the air.','',26124),
(55186,'enUS','Oh, I was just resting... I rest sometimes... under rocks...','I was JUST about to wiggle myself free... I think.',26124),
(55187,'enUS','I\'ll check in with Hao. Thank you!','Foreman\'s gotta be fumin\' right now. Glad yer dealin\' with her and not me.',26124),
(55188,'enUS','Wikket smart to be friend to hozen.$b$bNow, one less wikket hozen have to smash.','',26124),
(55189,'enUS','Big Chief Kah Kah, we will be exploring your lands and could use a good guide. Will you help us?','Big Chief Kah Kah, we will be exploring your lands and could use a good guide. Will you help us?',26124),
(55190,'enUS','Today it\'s cave-ins and nibblers, tomorrow it\'ll be floods and jinyu. Just another day at the quarry.','I ain\'t settin\' foot in this place ever again!',26124),
(55191,'enUS','I better be getting overtime for this.','I better be getting overtime for this.',26124),
(55192,'enUS','Hmm.$b$b<You wait patiently for Chief Kah Kah to think, then wait some more for him to speak.>$b$bKah Kah have many nephews. They all have earned their name name.$b$bGrookin home to one who has not yet earned his name name....$b$bRiko been a little too frisky - even for a hozen. Maybe long walk do him some good.','',26124),
(55193,'enUS','I\'ve got you. That was close!','',26124),
(55194,'enUS','You need to be careful - they\'re on full alert!','',26124),
(55195,'enUS','Well... That got ugly. You\'re lucky I\'m here.','',26124),
(55196,'enUS','You weren\'t trying to pick their pockets, were you?','',26124),
(55197,'enUS','Gotcha! Let\'s try that again...','',26124),
(55198,'enUS','Thank you for bringing my driver back, friend.','',26124),
(55199,'enUS','Thief. Thief!','',26124),
(55200,'enUS','Over here - get $ghim:her;!','',26124),
(55201,'enUS','Intruder!','',26124),
(55202,'enUS','I see you, fool!','',26124),
(55203,'enUS','You cannot...escape!','',26124),
(55204,'enUS','Hurry, $p! We have to start the smelling... I mean, the shelling!','',26124),
(55205,'enUS','You\'ve been trained well.','',26124),
(55206,'enUS','Well fought. Master Shang will be pleased.','',26124),
(55207,'enUS','Amazing! You\'re much stronger than you look.','',26124),
(55208,'enUS','It seems I have more training to do. Thank you for the lesson.','',26124),
(55209,'enUS','I bow to your skill. You bested me fairly.','',26124),
(55210,'enUS','It was an honor to be defeated by you.','',26124),
(55211,'enUS','HNNGGG!!!','',26124),
(55212,'enUS','Ahh, there we go. Told you I had it!','',26124),
(55213,'enUS','I\'m sure you can handle things in here. I\'ll be outside settling things down.','',26124),
(55214,'enUS','','Is there anyone in need of medical aid?',26124),
(55215,'enUS','','The jinyu may not seem welcoming, but I do believe we prove our good intentions.',26124),
(55216,'enUS','','A medic\'s work is never done.',26124),
(55217,'enUS','','The longer I stay here, the more I am charmed by this strange land.',26124),
(55218,'enUS','','Do you think we will ever find a way home?',26124),
(55219,'enUS','','I have never failed a mission in many years, $n. I am not about to do so now.',26124),
(55220,'enUS','','The Admiral is gravely wounded, $n.',26124),
(55221,'enUS','','The Admiral is very, very fortunate that you arrived when you did.',26124),
(55222,'enUS','','Judging from his injuries, the Admiral was cruelly tortured.',26124),
(55223,'enUS','','The Admiral is very hurt, but not entirely broken. I can fix him, but I\'ll need time.',26124),
(55224,'enUS','','I can only describe the Admiral\'s attackers as...savages.',26124),
(55225,'enUS','','Shhh, $n. I will need total concentration to attend these wounds.',26124),
(55226,'enUS','','Thank you, $n. Without you, the Admiral would have perished in that filthy pit.',26124),
(55227,'enUS','','$n, you are becoming quite a skilled medic. You should continue your first aid training.',26124),
(55228,'enUS','','I am afraid the Commander\'s injuries are beyond my aid.',26124),
(55229,'enUS','','It would take a miracle to save the Commander, now.',26124),
(55230,'enUS','','I have done all that I can for the Commander. I am afraid it will not be long, now.',26124),
(55231,'enUS','I feel fine, $n. Thank you for asking, but there are more important matters at hand.','',26124),
(55232,'enUS','I have delivered word to Wayward Landing. They should be sending more soldiers shortly.','',26124),
(55233,'enUS','We must focus on creating a base of operations. Once we have secured our position, then we can spare resources to find a way back home.','',26124),
(55234,'enUS','This land is rich in resources, $n. I am preparing a detailed report for our return.','',26124),
(55235,'enUS','The natives here are quite friendly. Well, except for those monkeys.','',26124),
(55236,'enUS','The jinyu seem to be an ancient race. We will learn their secrets, in time.','',26124),
(55237,'enUS','I have tried to speak to their chief, but he does not want to see me. It appears I am not \"high status\" enough. Apparently he\'s never seen an Admiral.','',26124),
(55238,'enUS','I\'ve been unable to befriend the Glassfin Elder. $C, I\'m counting on you to succeed where I failed.','',26124),
(55239,'enUS','<Taylor is very sick. It is best not to speak to him now.>','',26124),
(55240,'enUS','Picking','Picking',26124),
(55241,'enUS','The first step to learning is to admit that you have much to learn.','',26124),
(55242,'enUS','True wisdom comes from the understanding that you have much to master.','',26124),
(55243,'enUS','Come on, come on, come on! They\'ll be here any moment!','',26124),
(55244,'enUS','Wooohwee! Smells like Dalaran Sharp!','',26124),
(55245,'enUS','I\'m not about to let this Alliance scum steal back my prize.','',26124),
(55246,'enUS','So if i just substitute the powder with compressed...fuel, we should be in business! So to speak.','',26124),
(55247,'enUS','Have any more grog?','Have any more grog?',26124),
(55248,'enUS','Assuming this works, I\'ll need a name for my invention. How \'bout... Grookin Grenade?','',26124),
(55249,'enUS','Careful, $p! Methane labs like these can be extremely volatile.','',26124),
(55250,'enUS','Okay, Rivett. I\'m ready!','Okay, Rivett. I\'m ready!',26124),
(55251,'enUS','You have earned the right to proceed.  Huo lies beyond.','',26124),
(55252,'enUS','Carrot appeared!','',26124),
(55253,'enUS','Ooh, carrot!','',26124),
(55254,'enUS','Your training has paid off, young $c. You have found Huo and brought him safely to the temple.','',26124),
(55255,'enUS','Mmm... carrot!','',26124),
(55256,'enUS','Behold as Huo brings warmth back to the temple, and passion to its people.','',26124),
(55257,'enUS','I am proud of what you have accomplished this day.','',26124),
(55258,'enUS','It so fat!','',26124),
(55259,'enUS','The next spirit that awaits you is Shu, the spirit of water. When you are ready, meet Aysa at the Singing Pools to the east.','',26124),
(55260,'enUS','It so juicy!','',26124),
(55261,'enUS','Seems legit.','',26124),
(55262,'enUS','I love it. I love this carrot.','',26124),
(55263,'enUS','I think we should eat it.','',26124),
(55264,'enUS','Let\'s all eat it!','',26124),
(55265,'enUS','NO! It\'s TURNIP!','',26124),
(55266,'enUS','Nooooo!','',26124),
(55267,'enUS','NO! Not turnip!!','',26124),
(55268,'enUS','Who would do this?!','',26124),
(55269,'enUS','Ahh, turnip! Get out of here!','',26124),
(55270,'enUS','Carrot was turnip! Run!','',26124),
(55271,'enUS','I see you\'ve arrived. This is the eve of the sundering, when the collapse of the Well of Eternity fractured the continents of the world.','',26124),
(55272,'enUS','','Someone\'s here!',26124),
(55273,'enUS','','Ah - hah! Busted!',26124),
(55274,'enUS','','There\'s a thief over here!',26124),
(55275,'enUS','','I got one!',26124),
(55276,'enUS','Don\'t forget to use your stealth!','',26124),
(55277,'enUS','Are you crazy? They\'ll see you if you go flying around in there!','',26124),
(55278,'enUS','You can\'t fly here. We\'ll be spotted for sure!','',26124),
(55279,'enUS','You are less than dust, fit only to be brushed from my back.','',26124),
(55280,'enUS','What\'s the matter? Alliance can\'t hold their grog? Ha ha ha!','',26124),
(55281,'enUS','That\'s it... you\'ve got this... keep it up...','',26124),
(55282,'enUS','Careful! The front door is too heavily guarded. Hmmm - Circle around the back of the manor and maybe we can find another way in.','',26124),
(55283,'enUS','Where are you going? The manor is in the other direction!','',26124),
(55284,'enUS','Hmmmm... it doesn\'t look like there\'s anything over here. Try circling around to the back of the manor.','',26124),
(55285,'enUS','Ah-hah! There are no guards back here. Maybe you can find a way up onto the roof?','',26124),
(55286,'enUS','Nice work! Is there a window open up there? Look around!','',26124),
(55287,'enUS','You did it! You\'re in! Now... where would they be keeping the egg? Someplace dark, I would imagine. Be careful!','',26124),
(55288,'enUS','I\'m not afraid of you! Wait - who - who are you?','',26124),
(55289,'enUS','But... But Deathwing\'s minions may have you killed...','',26124),
(55290,'enUS','Noble $r, I am sure there is some agreement we can come to for my release.','',26124),
(55291,'enUS','We stand in an undiscovered paradise as ancient as the titans themselves and you want to go to war?','',26124),
(55292,'enUS','Involving these races in our war? Tarnishing this land with the horrors of warfare?$b$bIs that what you really want?','',26124),
(55293,'enUS','So, you\'ve managed to train an army...$b$bAn impressive achievement, but is war really the right course of action?','',26124),
(55294,'enUS','Exploiting the hostility between these races is unwise, $r.$b$bYou are going to have to accept responsibility for the consequences.','',26124),
(55295,'enUS','You\'ve returned with the spirits of water and earth. You make an old master proud.','',26124),
(55296,'enUS','Wugou and Shu are welcome here. We will care for them well.','',26124),
(55297,'enUS','The only remaining spirit is Dafeng, who hides somewhere across the Dawning Span to the west.','',26124),
(55298,'enUS','I can carry you to the top of the temple. Ji awaits you there to lead the way.','',26124),
(55299,'enUS','Ugh... I think I mighta ooked my dookers.','',26124),
(55300,'enUS','Ook! Dookin\' prarie-doggin\'!','',26124),
(55301,'enUS','Oogh... grooked me bad slickies...','',26124),
(55302,'enUS','Ookin\'s what hozen do best!','',26124),
(55303,'enUS','Mudmug\'s vial will slowly spill water while you are moving. Plan your path carefully!','Mudmug\'s vial will slowly spill water while you are moving. Plan your path carefully!',26124),
(55304,'enUS','Here, we will snatch up the Dragon Soul before it is lost to the mists of time.','',26124),
(55305,'enUS','But first, you must bring down the protective wards of Azshara\'s Highborne lackeys. You will find them within the palace. I will scout on ahead.','',26124),
(55306,'enUS','Good luck, heroes!','',26124),
(55307,'enUS','You!  You have allowed the Sha to reawaken after all these years!','',26124),
(55308,'enUS','If you truly wish to undo what your kind have wrought upon our land you must first prove yourselves here in our school.','',26124),
(55309,'enUS','First, you will face our initiates...','',26124),
(55310,'enUS','Where one falls, another will rise to take their place.','',26124),
(55311,'enUS','You have much to learn if you wish to defend your people from the Sha initiate.  Stand aside for your fellow students!','',26124),
(55312,'enUS','You have bested our most junior of students.  Now you will face two of my most senior.','',26124),
(55313,'enUS','Flying Snow!  Fragrant Lotus!  Step forward!','',26124),
(55314,'enUS','You have bested my prize students. Perhaps you can be of use to us after all...','',26124),
(55315,'enUS','As my master once said, \"You cannot truly know someone until you fight them.\"','',26124),
(55316,'enUS','Even the smoke of their burning camp wreaks of futility and shame.','',26124),
(55317,'enUS','Well done $p. Meet me back at Grookin and we\'ll discuss our next plan of action.','',26124),
(55318,'enUS','Greetings, $n. Are you as thirsty as I am?','',26124),
(55319,'enUS','I\'m ready. Let\'s hit the road.','I\'m ready. Let\'s hit the road.',26124),
(55320,'enUS','I am the beginning of the end...the shadow which blots out the sun...the bell which tolls your doom...','',26124),
(55321,'enUS','','I sense a great disturbance in the balance approaching. The chaos of it burns my mind!',26124),
(55322,'enUS','Mere whelps, experiments, a means to a greater end. You will see what the research of my clutch has yielded.','',26124),
(55323,'enUS','For this moment ALONE was I made. Look upon your death, mortals, and despair!','',26124),
(55324,'enUS','Strength of the Earth, hear my call! Shield them in this dark hour, the last defenders of Azeroth!','',26124),
(55325,'enUS','','Take heart, heroes, life will always blossom from the darkest soil!',26124),
(55326,'enUS','','In dreams, we may overcome any obstacle!',26124),
(55327,'enUS','Winds of the arcane be at their backs, and refresh them in this hour of darkness!','',26124),
(55328,'enUS','The cycle of time brings an end to all things.','',26124),
(55329,'enUS','Now is the hour of twilight!','',26124),
(55330,'enUS','But...but...I am...Ul...trax...ionnnnnn...','',26124),
(55331,'enUS','Fall before Ultraxion!','',26124),
(55332,'enUS','You have no hope!','',26124),
(55333,'enUS','Hahahahaha!','',26124),
(55334,'enUS','The final shred of light fades, and with it, your pitiful mortal existence!','',26124),
(55335,'enUS','Lord Deathwing, your gift...it is too much! I am...rrrraaaaagghhh!!','',26124),
(55336,'enUS','Through the pain and fire my hatred burns!','',26124),
(55337,'enUS','I WILL DRAG YOU WITH ME INTO FLAME AND DARKNESS!','',26124),
(55338,'enUS','','|TInterface\\Icons\\inv_misc_head_dragon_01.blp:20|t Alexstrasza summons forth the |cFFFF0000|Hspell:105896|h[Gift of Life]|h|r!',26124),
(55339,'enUS','','|TInterface\\Icons\\inv_misc_head_dragon_green.blp:20|t Ysera summons forth the |cFF00CC00|Hspell:105900|h[Essence of Dreams]|h|r!',26124),
(55340,'enUS','|TInterface\\Icons\\inv_misc_head_dragon_blue.blp:20|t Kalecgos summons forth the |cFF0000FF|Hspell:105903|h[Source of Magic]|h|r!','',26124),
(55341,'enUS','|TInterface\\Icons\\inv_misc_head_dragon_bronze.blp:20|t Nozdormu imbues you with a |cFFFFFF00|Hspell:105984|h[Timeloop]|h|r!','',26124),
(55342,'enUS','|TInterface\\Icons\\inv_misc_head_dragon_black.blp:20|t Thrall imbues the tanks with the strength of the earth! You are the |cFF9900CC|Hspell:106218|h[Last Defender of Azeroth]|h|r!','',26124),
(55343,'enUS','|TInterface\\Icons\\spell_fire_twilightimmolation.blp:20|t Ultraxion becomes |cFF9900CC|Hspell:106373|h[More Unstable]|h|r!','',26124),
(55344,'enUS','|TInterface\\Icons\\spell_fire_twilightcano.blp:20|t Ultraxion\'s instability is causing a massive |cFF9900CC|Hspell:106388|h[Twilight Eruption]|h|r!','',26124),
(55345,'enUS','|TInterface\\Icons\\spell_fire_twilightimmolation.blp:20|t Ultraxion reaches |cFF9900CC|Hspell:106395|h[Maximum Instability]|h|r!','',26124),
(55346,'enUS','My duty is to protect my people. If I must be on the frontlines, then I would gladly do so.','',26124),
(55347,'enUS','I am a strong jinyu! I can take the brunt of many attacks without fear!','',26124),
(55348,'enUS','While the enemies are focused on me, my allies can sneak up from behind!','',26124),
(55349,'enUS','My sword is quick and my feet steady. Enemies must deal with me first before attacking my allies.','',26124),
(55350,'enUS','From a young age, I have been drawn to the healing arts.','',26124),
(55351,'enUS','There are too few who care for the wounded from battle. If I had the skill, I would certainly join them.','',26124),
(55352,'enUS','I bring bandages and food to the sick and injured. If only I could do more...','',26124),
(55353,'enUS','In your land, is it true that healers accompany warriors onto the battlefield? If only I had better tools, perhaps I could do the same.','',26124),
(55354,'enUS','Alright boys! Come get some slickies fresh off the grill!','',26124),
(55355,'enUS','I prefer to shape the properties of water, and unleash them against my enemies.','',26124),
(55356,'enUS','I have some skill in the magical arts, but I wish I had more formal training.','',26124),
(55357,'enUS','I have had basic warrior training, but no one knows that I have more skill with spellcasting.','',26124),
(55358,'enUS','I am terrible with a spear. I much prefer ranged combat.','',26124),
(55359,'enUS','I\'m quick and fast. Put me behind an enemy, and they won\'t even see me coming.','',26124),
(55360,'enUS','Being small has its advantages. I can sneak just about anywhere.','',26124),
(55361,'enUS','Everyone here gets the standard warrior training, but I think I\'m more suited to stealth missions.','',26124),
(55362,'enUS','I never meet an enemy head on. I prefer to use my wits...and any number of stealthy tricks.','',26124),
(55363,'enUS','Wait, I know your face, human. You are the son of Varian Wrynn!','',26124),
(55364,'enUS','Okay, $p. I can only make these so fast... you gotta make every shot count!','',26124),
(55365,'enUS','Hah! Make another demand, princeling, and I\'ll release your head from your shoulders!','',26124),
(55366,'enUS','Sir, I demand to be released to my father\'s custody!','',26124),
(55367,'enUS','Alright. I suppose we have stayed here long enough.','',26124),
(55368,'enUS','These Thunderfoots are good people, but they do not have enough ale between them to fill a cask.','',26124),
(55369,'enUS','Let\'s go find something to drink. Shall we, Li Li?','',26124),
(55370,'enUS','','If beer gets you off your butt, then... sure. Let\'s go find you some beer.',26124),
(55371,'enUS','Farewell, Shang!','',26124),
(55372,'enUS','You kids have fun at Mudmug\'s! And thanks again, $n!','',26124),
(55373,'enUS','','Uncle, look. There\'s somebody up ahead. He looks... weird.',26124),
(55374,'enUS','We are the outsiders here, Li Li. We probably look even weirder to him.','',26124),
(55375,'enUS','','Pshh... only because we\'re traveling with this $r!',26124),
(55376,'enUS','','Sorry, $n, but you do kind of stand out.',26124),
(55377,'enUS','What\'s this? An Alliance boy? Here?','',26124),
(55378,'enUS','','What? We\'re all pandaren here! Just because we came from the turtle doesn\'t mean we look weird.',26124),
(55379,'enUS','','Well, $n looks a little weird. Sorry, $n.',26124),
(55380,'enUS','Hallloooo stranger!','',26124),
(55381,'enUS','We are looking for a brewer named Mudmug. Do you know of him?','',26124),
(55382,'enUS','I\'m Mudmug. Who\'s asking?','',26124),
(55383,'enUS','I am called Chen, and this is my niece Li Li.','',26124),
(55384,'enUS','Anduin Wrynn... a fitting reward for the trials we\'ve endured! $p, come, speak with me.','',26124),
(55385,'enUS','Hmph. Y\'all any good at fightin\' virmen?','',26124),
(55386,'enUS','','Heck yeah we are! I\'ve probably beaten up about a million virmen back on the Wandering Isle!',26124),
(55387,'enUS','You have a virmen problem? We will be glad to help you, Mudmug.','',26124),
(55388,'enUS','Awright then! My place is just around the corner.','',26124),
(55389,'enUS','Come on! Let\'s get to that critter-whompin\'!','',26124),
(55390,'enUS','','I TOLD you he was weird.',26124),
(55391,'enUS','The girl got it right. Follow me.','',26124),
(55392,'enUS','','I TOLD you he was weird.',26124),
(55393,'enUS','We\'re catching up to the dragon! I think I can make him out through the cloud cover!','',26124),
(55394,'enUS','Bring us in closer!','Bring us in closer!',26124),
(55395,'enUS','The shields surrounding the Aspects shatter! The Aspects are vulnerable!','',26124),
(55396,'enUS','Outsider, what brings you to our village?','',26124),
(55397,'enUS','You must be the outsider that everyone speaks of.','',26124),
(55398,'enUS','The hozen came to us once as you do now.$B$BWe felt sorry for them, and taught them how to survive in this land.$B$BOver time, they grew strong and bold, and began to take this land for their own.','',26124),
(55399,'enUS','We have been taught not to trust strangers, $c.','',26124),
(55400,'enUS','$n, is it? I have heard your name spoken in the village.','',26124),
(55401,'enUS','You are the $c, aren\'t you? Thank you for recovering my brother\'s heirloom. It has become my most precious possession.','',26124),
(55402,'enUS','Perhaps I was wrong about you, $r. You have already done much to help our village.','',26124),
(55403,'enUS','Your people are very interesting, $r. I wish to know more about you and your kind.','',26124),
(55404,'enUS','Perhaps someday I can visit your village too, $n.','',26124),
(55405,'enUS','You have done many good things for our village, $n. Perhaps we can be friends after all.','',26124),
(55406,'enUS','The shield surrounding the Aspects is destroyed by Ultraxion\'s attack!','',26124),
(55407,'enUS','We have lived on this lake for thousands of years. The waters here flow down from the ancient pools of Pandaria.','',26124),
(55408,'enUS','The tribe thanks you for your deeds, $n.','',26124),
(55409,'enUS','It is foolish to trust a stranger\'s every word, but it is also foolish to deny those who might be friends.','',26124),
(55410,'enUS','A monstrous force pulls you into the twilight realm!','',26124),
(55411,'enUS','You did it, $p! I\'m free!','',26124),
(55412,'enUS','You might need this shield.','You might need this shield.',26124),
(55413,'enUS','Take this book of healing prayers.','Take this book of healing prayers.',26124),
(55414,'enUS','Li Li. A stranger in need is a future friend. That is the wanderer\'s way!','',26124),
(55415,'enUS','This spellcaster\'s staff is for you.','This spellcaster\'s staff is for you.',26124),
(55416,'enUS','Will these daggers help?','Will these daggers help?',26124),
(55417,'enUS','Use it or lose it, $gmister:sister;!','',26124),
(55418,'enUS','Incoming!','',26124),
(55419,'enUS','Let\'s hope the wind ain\'t blowin this way...','',26124),
(55420,'enUS','Oh, the things I do for the Horde...','',26124),
(55421,'enUS','Here, $p, catch!','',26124),
(55422,'enUS','This shield is just what I need! Thank you!','',26124),
(55423,'enUS','This shield will block many mighty blows. Thank you, $n.','',26124),
(55424,'enUS','This is just what I needed.','',26124),
(55425,'enUS','I should begin training immediately.','',26124),
(55426,'enUS','That would be better for a healer, not me.','',26124),
(55427,'enUS','I need something for protection, not this.','',26124),
(55428,'enUS','I would prefer sturdier equipment than this.','',26124),
(55429,'enUS','How do I swing this thing? Ouch!','',26124),
(55430,'enUS','All ahead full. Everything depends on our speed! We can\'t let the Destroyer get away.','',26124),
(55431,'enUS','All hands to battle stations; get those monsters away from the ship!','',26124),
(55432,'enUS','This...this is a weakling\'s weapon! I want something bigger.','',26124),
(55433,'enUS','Concentrate everything on the armored drake!','',26124),
(55434,'enUS','An enemy sapper\'s breached the engine room!','',26124),
(55435,'enUS','The Skyfire can\'t take much more of this!','',26124),
(55436,'enUS','We\'re going down. Abandon the ship!','',26124),
(55437,'enUS','So much knowledge! I must study this immediately.','',26124),
(55438,'enUS','Such a sacred text will not be wasted on me. Thank you!','',26124),
(55439,'enUS','How will this weapon heal the injured?','',26124),
(55440,'enUS','I can\'t use that. I am looking to expand my healing knowledge.','',26124),
(55441,'enUS','The engines are back online! Full speed ahead! We can\'t let Deathwing escape!','',26124),
(55442,'enUS','Hah! I was hoping you\'d make it this far. You\'d best be ready for a real fight.','',26124),
(55443,'enUS','You won\'t get near the Master. Dragonriders, attack!','',26124),
(55444,'enUS','Well... done, heh. But I wonder if you\'re good enough... to best him.','',26124),
(55445,'enUS','I don\'t think this shield is for me.','',26124),
(55446,'enUS','Mess with the bull....','',26124),
(55447,'enUS','Down you go!','',26124),
(55448,'enUS','I know we all look alike to you, but I\'m a healer, not a mage.','',26124),
(55449,'enUS','Get up! Oh... weakling!','',26124),
(55450,'enUS','Ouch! Those blades are sharp!','',26124),
(55451,'enUS','If we make it outta here, let\'s keep this part outta the story...','',26124),
(55452,'enUS','Ow...that was an eye. Yes, definitely an eye.','',26124),
(55453,'enUS','Goriona! Give them hell!','',26124),
(55454,'enUS','How\'s THIS?','',26124),
(55455,'enUS','COME ON!','',26124),
(55456,'enUS','Looks like I\'m doing this myself. Good!','',26124),
(55457,'enUS','We\'re flying a little too close. It\'s been a good fight, but I\'m ending it, now.','',26124),
(55458,'enUS','Release the doubt from your soul!','Release the doubt from your soul!',26124),
(55459,'enUS','Finally! An upgrade!','',26124),
(55460,'enUS','Yes! This weapon is perfect.','',26124),
(55461,'enUS','This object is useless to me.','',26124),
(55462,'enUS','I cannot use this, $r.','',26124),
(55463,'enUS','I\'m sorry, but I do not heal.','',26124),
(55464,'enUS','My skills are better for offense, not defense.','',26124),
(55465,'enUS','These daggers are of little use to me.','',26124),
(55466,'enUS','These daggers are perfect for stabbing.','',26124),
(55467,'enUS','Yes! Those hozen won\'t know what hit them.','',26124),
(55468,'enUS','How will I stab my enemies with this?','',26124),
(55469,'enUS','No no, not nearly sharp enough.','',26124),
(55470,'enUS','This isn\'t a weapon! It\'s just a book!','',26124),
(55471,'enUS','How can I stealth around carrying this giant shield?','',26124),
(55472,'enUS','Too big. Not pointy enough. I need something small and sharp.','',26124),
(55473,'enUS','Mudmug! This is fantastic! Strong, too!','',26124),
(55474,'enUS','Thanks! Most folk \'round here prefer it over anything from that \"Stormstout Brewery\".','',26124),
(55475,'enUS','','Wait... did you say Stormstout Brewery?',26124),
(55476,'enUS','You know of more Stormstouts? Here, in Pandaria?','',26124),
(55477,'enUS','Well shoot, of course! They\'re the biggest brewin\' family in the whole valley!','',26124),
(55478,'enUS','A brewery... my family... my ancestral home!','',26124),
(55479,'enUS','Wait a dang minute - you\'re a Stormstout?','',26124),
(55480,'enUS','Yes I am. Tell me - where is this \"Stormstout Brewery?\" I must see it for myself!','',26124),
(55481,'enUS','You just keep goin\' down this same road, but...','',26124),
(55482,'enUS','I am going. Li Li... you stay here. I will come back for you.','',26124),
(55483,'enUS','Promise me you will keep out of trouble while I am away?','',26124),
(55484,'enUS','','I... yeah, sure. Whatever.',26124),
(55485,'enUS','','I can\'t believe he left me with the weird mud guy.',26124),
(55486,'enUS','<UNUSED> <DO NOT TRANSLATE>','',26124),
(55487,'enUS','<UNUSED> <DO NOT TRANSLATE>','',26124),
(55488,'enUS','<UNUSED> <DO NOT TRANSLATE>','',26124),
(55489,'enUS','<UNUSED> <DO NOT TRANSLATE>','',26124),
(55490,'enUS','<UNUSED> <DO NOT TRANSLATE>','',26124),
(55491,'enUS','<UNUSED> <DO NOT TRANSLATE>','',26124),
(55492,'enUS','','<UNUSED> <DO NOT TRANSLATE>',26124),
(55493,'enUS','<UNUSED> <DO NOT TRANSLATE>','',26124),
(55494,'enUS','<UNUSED> <DO NOT TRANSLATE>','',26124),
(55495,'enUS','<UNUSED> <DO NOT TRANSLATE>','',26124),
(55496,'enUS','','<UNUSED> <DO NOT TRANSLATE>',26124),
(55497,'enUS','<UNUSED> <DO NOT TRANSLATE>','',26124),
(55498,'enUS','','<UNUSED> <DO NOT TRANSLATE>',26124),
(55499,'enUS','','Make a run for Dawn\'s Blossom. We\'ll meet you there!',26124),
(55500,'enUS','','How did you get up that high?',26124),
(55501,'enUS','','I found us a cool bodyguard didn\'t I?',26124),
(55502,'enUS','Step in close. Engage into his space. Don\'t give him the initiative!','',26124),
(55503,'enUS','Vary your blows. Show your opponent no pattern. Prove his instincts wrong.','',26124),
(55504,'enUS','Don\'t just use the blade. Use the butt of your weapon. Break his nose!','',26124),
(55505,'enUS','Let me see your scowls. Scowl. Scowl harder! You call that a scowl?','',26124),
(55506,'enUS','Your goal is a silent kill. Screamy, angry kills will do in a pinch.','',26124),
(55507,'enUS','The shins. The face. The crotch. Kick them all, indiscriminately.','',26124),
(55508,'enUS','What are you doing, dancing? We\'re studying murder, people! BAH - send in two more.','',26124),
(55509,'enUS','You movements are light, free, flowing ... you would be killed in an instant. Get out of the ring!','',26124),
(55510,'enUS','I like what I\'m seeing here. Did everyone see that? Who is next?','',26124),
(55511,'enUS','Very good. Is that blood? On your teeth? Excellent! Bring on two more!','',26124),
(55512,'enUS','Ugh, you fight like two gnolls in heat. Distracted. Sloppy. Gibbering. Get out. OUT! Next?','',26124),
(55513,'enUS','','Oh wow! It was like \"Rawwr!\" and you were like \"Kahpowww!\"',26124),
(55514,'enUS','','How did you get to be so brave?',26124),
(55515,'enUS','','I really hope it didn\'t eat any of my friends before you beat it up.',26124),
(55516,'enUS','Have a drink and rest, traveler.','',26124),
(55517,'enUS','Are you finding everything well, $n?','',26124),
(55519,'enUS','','I\'ve got your back, $p.',26124),
(55520,'enUS','Come child. We have one final journey to take together before your training is complete.','',26124),
(55521,'enUS','Beyond the Elders\' Path lies the Wood of Staves, a sacred place that only the worthy may enter.','',26124),
(55522,'enUS','Of the many ways to prove your worth, I require the simplest of you now. I must know that you will fight for our people. I must know that you can keep them safe.','',26124),
(55523,'enUS','Defeat the Guardian of the Elders, and we may pass.','',26124),
(55524,'enUS','','Hey! Stop stealing my kills, $p!',26124),
(55525,'enUS','','That was my kill, $p!',26124),
(55526,'enUS','','That one was already in my sights!',26124),
(55527,'enUS','','There are plenty of targets out there for both of us...',26124),
(55528,'enUS','For 3,000 years, we have passed the knowledge of our people down. Elder to youth. Master to student.','',26124),
(55529,'enUS','Every elder reaches the day where he must pass on and plant his stave with the staves of his ancestors. Today is the day when my staff joins these woods.','',26124),
(55530,'enUS','$p, our people have lived the wholes of their lives on this great turtle, Shen-zin Su, but not in hundreds of years has anyone spoken to him.','',26124),
(55531,'enUS','Now Shen-zin Su is ill, and we are all in danger. With the help of the elements, you will break the silence. You will speak to him.','',26124),
(55532,'enUS','Aysa and Ji have retrieved the spirits and brought them here. You are to go with them, speak to the great Shen-zin Su, and do what must be done to save our people.','',26124),
(55533,'enUS','You\'ve come far, my young student. I see within you a great hero. I leave the fate of this land to you.','',26124),
(55534,'enUS','What?! Impossible!','',26124),
(55535,'enUS','|TInterface\\Icons\\ability_deathwing_cataclysm.blp:20|t%s begins to cast |cFFFF0000|Hspell:106523|h[Cataclysm]|h|r! Stop Him!','',26124),
(55536,'enUS','Little spirit, you cannot hide from me in that body!','',26124),
(55537,'enUS','You will not interfere again!','',26124),
(55538,'enUS','My legs feel stiff.','',26124),
(55539,'enUS','Wahoo! We did it!','',26124),
(55540,'enUS','','Well done, $p!',26124),
(55541,'enUS','','Here kitty kitty.',26124),
(55542,'enUS','','You should join our family, preserved forever in jade.',26124),
(55543,'enUS','','Yay! Shin! You\'re alive!',26124),
(55544,'enUS','As I expected...','',26124),
(55545,'enUS','Yes! Now I am ready for battle.','',26124),
(55546,'enUS','','Thank you so much $p! If you find me in Dawn\'s Blossom later I\'ll give you one of the things we stashed from our adventures.',26124),
(55547,'enUS','Sure, let\'s go have a drink.','Sure, let\'s go have a drink.',26124),
(55548,'enUS','$p! Check this thing out!','',26124),
(55549,'enUS','','We\'re ready to go whenever you are, $n.',26124),
(55550,'enUS','I am in pain, but it warms my heart that Liu Lang\'s grandchildren have not forgotten me.','',26124),
(55551,'enUS','','Hop in.',26124),
(55552,'enUS','Or if you want to wander the woods a while, Aysa and I can hang out here.  You know... just the two of us.','',26124),
(55553,'enUS','','Don\'t listen to him.  We\'ve got work to do.',26124),
(55554,'enUS','$p, where\'s Master Shang?','',26124),
(55555,'enUS','','...Ji, they were in the Wood of Staves.  You know where Master Shang is now.',26124),
(55556,'enUS','Bah, let a pandaren hope, would you?  I\'m going to miss the old man.','',26124),
(55557,'enUS','','Hey! Look at that waterfall!',26124),
(55558,'enUS','','I wonder if there\'s a cave behind it.',26124),
(55559,'enUS','','You should always check behind waterfalls for caves.',26124),
(55560,'enUS','','Ji, be respectful when we speak to Shen-zin Su.',26124),
(55561,'enUS','When am I not respectful?  You hurt me, Aysa.','',26124),
(55562,'enUS','','I might if you embarrass us.',26124),
(55563,'enUS','','Shen-zin Su, we are the descendants of Liu Lang.  We\'ve sensed your pain, and we want to help.',26124),
(55564,'enUS','','What ails you Shen-zin Su?  What can we do?',26124),
(55565,'enUS','','Check out all the cool silk!',26124),
(55566,'enUS','','Do you think that they really get this stuff from the silkworms\' rear end?',26124),
(55567,'enUS','','Eww... they look like maggots.',26124),
(55568,'enUS','There is a thorn in my side.  I cannot remove it.','',26124),
(55569,'enUS','The pain is unbearable, and I can no longer swim straight.','',26124),
(55570,'enUS','Please grandchildren, can you remove this thorn?  I cannot do so on my own.','',26124),
(55571,'enUS','','Of course, Shen-zin Su!  But your shell is large, and I do not know where this thorn could be.',26124),
(55572,'enUS','It is in the forest where your feet do not walk.  Continue along the mountains and you will find it.','',26124),
(55573,'enUS','','We will find it, and we will remove it.  You have our word!',26124),
(55574,'enUS','A thorn?  And I left my tweezers at home.','',26124),
(55575,'enUS','How could such a thing cause pain to something so large?','',26124),
(55576,'enUS','','We\'ll know soon enough.',26124),
(55577,'enUS','Are you seeing what I\'m seeing?!  Is that a boat?!','',26124),
(55578,'enUS','','It is a boat... a whole airship!  That\'s a bigger thorn than I was expecting.',26124),
(55579,'enUS','And those aren\'t pandaren down there.  They\'ve got no fur.','',26124),
(55580,'enUS','It looks like they crashed.  I don\'t think they\'re here for trouble.','',26124),
(55581,'enUS','','Someone has crashed into our island.  Removing this thorn may be more complicated than we thought.',26124),
(55582,'enUS','','We should let Elder Shaopai know and then plan our next move.',26124),
(55583,'enUS','','Look at this!',26124),
(55584,'enUS','','There\'s a village up here... and a big fish statue, too.',26124),
(55585,'enUS','','You think the jinyu built this place?',26124),
(55586,'enUS','Hozen watchin\' wikket... someday hozen learn to grook like wikket!','',26124),
(55587,'enUS','Grook all the jinyu, wikket!','',26124),
(55588,'enUS','Shiney jab-jab, wikket.','',26124),
(55589,'enUS','Wikket got slickies?','',26124),
(55590,'enUS','Grookin Jinyu make for happy Kah Kah.','',26124),
(55591,'enUS','Slinger eat slicky. Slicky make dooker. Slingin\' dooker grook the Jinyu!','',26124),
(55592,'enUS','Furries chompin\' the Jinyu!','',26124),
(55593,'enUS','','I suppose that\'s enough for today. Let\'s wait for Uncle Chen to return.',26124),
(55594,'enUS','','Look, here he comes now! How was the brewery, Uncle?',26124),
(55595,'enUS','Bah! I do not want to talk about it.','',26124),
(55596,'enUS','What happened, Chen?','What happened, Chen?',26124),
(55597,'enUS','I am a fighter. Why will the elder not let me fight?','',26124),
(55598,'enUS','Each day we send off only enough warriors to hold the hozen at bay. Never enough to actually push them back.','',26124),
(55599,'enUS','Why won\'t Elder Lu let us fight the hozen back properly.','',26124),
(55600,'enUS','Can\'t you see I\'m a little busy here?','',26124),
(55601,'enUS','Damned hozen move through the trees like ghosts!','',26124),
(55602,'enUS','It\'s just a matter of time before we retake Moonwater Retreat.','',26124),
(55603,'enUS','We should be taking the fight to the hozen, not stalling out of fear.','',26124),
(55604,'enUS','The elder is right, we should find a diplomatic solution with the hozen.','',26124),
(55605,'enUS','Behold the power of torrential waters!','',26124),
(55606,'enUS','Spring to life!','',26124),
(55607,'enUS','%s rises from the fountain!','',26124),
(55608,'enUS','What, were you sent to check up on me? Everything\'s fine! It\'s all under control!','',26124),
(55609,'enUS','STRIKE!','',26124),
(55610,'enUS','Your spirit has been ripped from your body! Get back to your body!','Your spirit has been ripped from your body! Get back to your body!',26124),
(55611,'enUS','Hey, I think I\'m getting the hang of this.','',26124),
(55612,'enUS','I think I learned something new!','',26124),
(55613,'enUS','I think I understand it now.','',26124),
(55614,'enUS','This training is really helping.','',26124),
(55616,'enUS','Breaking and Entering','Breaking and Entering',26124),
(55618,'enUS','Can we start with something easier?','',26124),
(55619,'enUS','This is really hard!','',26124),
(55620,'enUS','Why do I keep missing?','',26124),
(55621,'enUS','How do I use this thing?','',26124),
(55622,'enUS','Huh? Where is the enemy?','',26124),
(55623,'enUS','When should I open my eyes?','',26124),
(55624,'enUS','Which way is the enemy?','',26124),
(55625,'enUS','These opponents are tough.','',26124),
(55626,'enUS','Hey, this isn\'t so bad.','',26124),
(55627,'enUS','They aren\'t so tough after all.','',26124),
(55628,'enUS','Hey, we\'re not doing so bad.','',26124),
(55629,'enUS','The fight isn\'t over yet!','',26124),
(55630,'enUS','We might be able to win this.','',26124),
(55631,'enUS','The tribe will prevail!','',26124),
(55632,'enUS','I\'m not going to run away!','',26124),
(55633,'enUS','We\'ll fight this to the very end!','',26124),
(55634,'enUS','Onward! For the Pearlfin tribe!','',26124),
(55635,'enUS','I\'m ready for anything!','',26124),
(55636,'enUS','Never give up, friends!','',26124),
(55637,'enUS','For honor! For justice!','',26124),
(55638,'enUS','For our brothers and sisters!','',26124),
(55639,'enUS','I will send you to a watery grave!','',26124),
(55640,'enUS','Strike true, friends!','',26124),
(55641,'enUS','Fight hard! Press onward!','',26124),
(55642,'enUS','I feel stronger than before.','',26124),
(55643,'enUS','Time to fight your own battles, you monster! No more spirits to hide behind!','',26124),
(55644,'enUS','I hear that with fire and force you shape metals for war. I can achieve this through the pressures of water and a mastery of their densities.','',26124),
(55645,'enUS','Agh! My wards!','',26124),
(55646,'enUS','','Swagger all you like; you pups don\'t stand a chance. Flee now, while you can.',26124),
(55647,'enUS','','You cross the Stormbinder! I\'ll slaughter you all.',26124),
(55648,'enUS','','You should have run, dog.',26124),
(55649,'enUS','','Feh!',26124),
(55650,'enUS','','Down, pup.',26124),
(55651,'enUS','','A waste of my time.',26124),
(55652,'enUS','','Stay, pup.',26124),
(55653,'enUS','','Hold still.',26124),
(55654,'enUS','','You can\'t outrun the storm.',26124),
(55655,'enUS','','Die beneath the ice.',26124),
(55656,'enUS','','Suffer the storm\'s wrath!',26124),
(55657,'enUS','','Thunder and lightning dance at my call!',26124),
(55658,'enUS','','You face more than my axes, this close.',26124),
(55659,'enUS','','See what becomes of those who stand before me!',26124),
(55660,'enUS','','Feel a chill up your spine...?',26124),
(55661,'enUS','','The time I spent binding that, WASTED!',26124),
(55662,'enUS','','Enough!',26124),
(55663,'enUS','','You\'ll PAY for that.',26124),
(55664,'enUS','','Aughhhh!',26124),
(55665,'enUS','','Again?!',26124),
(55666,'enUS','','Impudent pup!',26124),
(55667,'enUS','','The one remaining is still enough to finish you.',26124),
(55668,'enUS','','What are you doing?',26124),
(55669,'enUS','','You\'re toying with death.',26124),
(55670,'enUS','','You think you can play with my lightning?',26124),
(55671,'enUS','','Impossible!',26124),
(55672,'enUS','','No! More... lightning...',26124),
(55673,'enUS','','Enough of your games! You won\'t live to do it again.',26124),
(55674,'enUS','','I\'ll finish you now, pups!',26124),
(55675,'enUS','I would recommend releasing me. My father is not as forgiving as I am.','',26124),
(55676,'enUS','Perhaps you could speak to Nazgrim on my behalf? He seems unwilling to negotiate with me.','',26124),
(55677,'enUS','Look at this land. Now is the time to be talking about peace and exploration.','',26124),
(55678,'enUS','I am sure that if you let me contact my companions we can begin negotiations for my release.','',26124),
(55679,'enUS','Blood and Thunder!','',26124),
(55680,'enUS','Another notch for my axe.','',26124),
(55681,'enUS','Send me a real challenge!','',26124),
(55682,'enUS','For the Horde!','',26124),
(55683,'enUS','Sorry, we aren\'t accepting visitors right now.','',26124),
(55684,'enUS','I am no visitor, I am Chen Storm-','',26124),
(55685,'enUS','You should leave.','',26124),
(55686,'enUS','But we are family. I am a Stormstout! From the Wandering Isle...','',26124),
(55687,'enUS','Are you deaf? We aren\'t allowing anybody in the brewery right now.','',26124),
(55688,'enUS','There is no need to speak to me that way.','',26124),
(55689,'enUS','Wait - what is going on behind you!?','',26124),
(55690,'enUS','Huh?! That\'s... that\'s nothing! Now GO AWAY!','',26124),
(55691,'enUS','Come, speak with me! Let\'s sit down and talk. Have a beer together...','',26124),
(55692,'enUS','There will be no sitting. No talking. And none of your horrible beer!','',26124),
(55693,'enUS','[This line has been cut]','',26124),
(55694,'enUS','Hey, what\'s that behind you?!','',26124),
(55695,'enUS','How many times must I tell you... GO AWAY!','',26124),
(55696,'enUS','I don\'t understand, old man. What have I done to upset you?','',26124),
(55697,'enUS','It\'s not what you\'ve done, it\'s who you are. You are not welcome here, \"Chen Stormstout.\"','',26124),
(55698,'enUS','I found the brewery and made my way inside.','',26124),
(55699,'enUS','I decided to look around for someone else from the Stormstout family.','',26124),
(55700,'enUS','I was shaken, but I did not give up. I pursued the strange old brewer to ask him some more questions.','',26124),
(55701,'enUS','First beer elementals, and now a hozen attack? Something was very wrong.','',26124),
(55702,'enUS','I decided to give him one more chance. I was not about to give up on family.','',26124),
(55703,'enUS','That was all I needed to hear. Shunned... by my own blood! I turned and left.','',26124),
(55704,'enUS','[This line has been cut]','',26124),
(55705,'enUS','I had no choice but to defend myself.','',26124),
(55706,'enUS','*hic* Gimme more of that ook-dooglin\' BEER! *hic*','',26124),
(55707,'enUS','When I was young I wanted to be a brewmaster. Mixing various chemicals to get the perfect drink and flavor.$b$bDuring my training though they kept telling me my drinks were too hearty.$b$bSo I went into smelting. Seemed like a logical transition at the time.','',26124),
(55708,'enUS','Welcome to my noodle shack. We\'ve got every type of noodle that should be eaten. If we don\'t have it, you shouldn\'t be eating it.','',26124),
(55709,'enUS','I am the mighty Tzu the Ironbelly Monk, so named for my infamous belly barrage. Perhaps you have heard of me.','',26124),
(55710,'enUS','I once did battle with the dreaded fang toothed beast that shall not be named for fear of darkening the day.','',26124),
(55711,'enUS','Chin did not earn his title lightly. There was a fierce championship of noodle makers gathered from all four corners of the village.$b$bIt was here they battled with great ferocity over barrels of boiling water to forge only the finest noodles ever made within a days travel.$b$bGlorious I tell you!$b$bOnly Flourfury emerged victorious, crafting a noodle so astounding it shook the very foundation of my taster\'s bowl.','',26124),
(55712,'enUS','','Another stranger? Where are all of you coming from?$b$BSomeone was through here a few days ago claiming to be from the turtle. Said his name was Stormstout.',26124),
(55713,'enUS','','You\'re not here to start a fight in my brewery are you? Those two strangers over there started quite a brawl when they arrived last week.',26124),
(55714,'enUS','','Lorewalker Cho spoke highly of you. You are welcome as long as you don\'t go all hozen on us.',26124),
(55715,'enUS','','Cowards! You pack of weakling... dogs...',26124),
(55716,'enUS','You had something important to tell me, master?','You had something important to tell me, master?',26124),
(55717,'enUS','I\'m Toya! You need it? I can get it! Don\'t go to nobody else in Dawn\'s Blossom!','',26124),
(55718,'enUS','I\'m ready to see Lorewalker Cho.','I\'m ready to see Lorewalker Cho.',26124),
(55719,'enUS','The darkness clears...','',26124),
(55720,'enUS','I peer into these waters and my reflection is empty...','',26124),
(55721,'enUS','Waters... claim me...','',26124),
(55722,'enUS','Thank you again for your help, stranger. I have already begun to think of ideas on the ring I shall craft for Syra\'s hand.','',26124),
(55723,'enUS','The waters whisper to me... enemies approach.','',26124),
(55724,'enUS','','Wow stranger! You really showed that mean old witch who was boss.',26124),
(55725,'enUS','','It was so neat how you beat up those cats! They went and were like \"Grrrrr!\" and then you went and \"Wabang!\" and then you took their stuff.',26124),
(55726,'enUS','','The grown ups always told us the Jade Witch was just some old lady in the woods who was sad her husband died. But you showed them!$b$bOnly... I didn\'t tell any of the grown ups \'cause I didn\'t want to get in trouble.',26124),
(55727,'enUS','Me gonna ook you in the dooker!','',26124),
(55728,'enUS','|TInterface\\Icons\\inv_misc_food_23.blp:20|t Ook-Ook is |cFFFF0000|Hspell:106651|h[Going Bananas]|h|r! More barrels are coming!','',26124),
(55729,'enUS','Have you seen Lo Wanderbrew?','Have you seen Lo Wanderbrew?',26124),
(55730,'enUS','','Do you seek enlightenment?',26124),
(55731,'enUS','Oook!  Ooooooook!!','',26124),
(55732,'enUS','','Do you wish to expand your mind and body beyond the boundaries it is currently confined to?',26124),
(55733,'enUS','','The Tian Monastery taught me how to focus my energies so tightly that I could tap a keg using only my pinky finger.',26124),
(55734,'enUS','','I have not seen Lo since he made off with my student, Syra. They were heading east toward the Arboretum.$b$bIt will not go well if their parents learn of this. The Wanderbrews and the Goldendrafts have had a long standing feud.',26124),
(55735,'enUS','Welcome to the Arboretum. May you find inspiration amongst the trees.','',26124),
(55736,'enUS','Our lives are but a blink of reality\'s eye.','',26124),
(55737,'enUS','Ours is an ancient and long lived culture.$b$bThanks to our craft, some of the memory of that culture can be preserved for future generations.','',26124),
(55738,'enUS','Have you seen Lo Wanderbrew?','Have you seen Lo Wanderbrew?',26124),
(55739,'enUS','You seek two lovers blind to the ambitions of their family names. They were here, seeking a way to hold to their path.$b$bSadly they did not find their answers among the trees or art.','',26124),
(55741,'enUS','Blessings of the Pandriarchs.','Blessings of the Pandriarchs.',26124),
(55742,'enUS','','Jade Serpent, grant me strength!',26124),
(55743,'enUS','Lo? Oh. I haven\'t seen him today. I thought it was very odd. He usually walks me to work in the morning.$b$bHe has a kind heart. It\'s a shame he looks down on his apprenticeship with Singegruff. He is a very talented smelter.$b$bIf you see him, tell him I missed our walk this morning.','',26124),
(55744,'enUS','So be it.','',26124),
(55745,'enUS','You know not what you have done. Aman\'Thul... What I... have... seen...','',26124),
(55746,'enUS','','Hey mister Ironbelly! The witch in the woods turned my friends into jade. Can you help?',26124),
(55747,'enUS','Your time has come.','',26124),
(55748,'enUS','The sand has run out.','',26124),
(55749,'enUS','Time ends.','',26124),
(55750,'enUS','To repeat the same action and expect different results is madness.','',26124),
(55751,'enUS','Another chance will make no difference. You will fail.','',26124),
(55752,'enUS','Again...? Is this your plot, your scheme?','',26124),
(55753,'enUS','The Hourglass\' power is exhausted. No more games, mortals. Relent, or perish.','',26124),
(55754,'enUS','The Widow Greenpaw is NOT a witch. She just makes very lifelike jade statues.','',26124),
(55755,'enUS','We\'ve got to light that signal fire. Without reinforcements, they\'ll destroy the gate!','',26124),
(55756,'enUS','But the mantid have overrun the area. There\'s no clear path!','',26124),
(55757,'enUS','Don\'t worry! I can make it!','',26124),
(55758,'enUS','What are you doing?! There\'s no way you\'ll reach it!','',26124),
(55759,'enUS','You\'ll get yourself killed!','',26124),
(55760,'enUS','Why didn\'t he listen?','',26124),
(55761,'enUS','We\'ve gotta stop giving the recruits those red shirts. They\'re just moving targets in them.','',26124),
(55762,'enUS','','|TInterface\\Icons\\ability_vehicle_sonicshockwave.blp:20|t%s begins to cast |cFFFF0000|Hspell:106886|h[Cauterize]|h|r!',26124),
(55763,'enUS','Sometimes the only way to find something is to stop looking.','',26124),
(55764,'enUS','Go ahead and speak with the water, Ashyo.','Go ahead and speak with the water, Ashyo.',26124),
(55765,'enUS','Meet me up in the pools whenever you\'re ready!','',26124),
(55766,'enUS','You have done it!','',26124),
(55767,'enUS','We defeated the Destroyer!','We defeated the Destroyer!',26124),
(55768,'enUS','It is done; at last the Destroyer has met his end. Now, we can begin to heal our world.','',26124),
(55769,'enUS','You have accomplished the impossible, succeeded where all Azeroth feared you would fail.','You have accomplished the impossible, succeeded where all Azeroth feared you would fail.',26124),
(55770,'enUS','...although, you may want to hurry.','',26124),
(55771,'enUS','Do you hear that?  What is that noise!','',26124),
(55772,'enUS','Inconceivable! He couldn\'t possibly be alive!','Inconceivable! He couldn\'t possibly be alive!',26124),
(55773,'enUS','No! Such power! Deathwing\'s summoning of the final Cataclysm will destroy all life on Azeroth. Quickly, we must interrupt him!','No! Such power! Deathwing\'s summoning of the final Cataclysm will destroy all life on Azeroth. Quickly, we must interrupt him!',26124),
(55774,'enUS','Hurry, heroes. In mere moments Deathwing\'s Cataclysm will complete what he begun and end the world. Join me in the attack, now!','',26124),
(55776,'enUS','The Destroyer is gathering all his might for a blow that will split the world. Attack him, now! We must stop the final Cataclysm!','',26124),
(55778,'enUS','I will cleanse whatever corruption I can; my fire will not harm you.','I will cleanse whatever corruption I can; my fire will not harm you.',26124),
(55779,'enUS','There is no shelter from my fury.','',26124),
(55780,'enUS','Your armor means nothing, your faith even less.','',26124),
(55781,'enUS','The sea will swallow your smoldering remains.','',26124),
(55782,'enUS','I shall tear this world apart.','',26124),
(55783,'enUS','I shall show you a true cataclysm.','',26124),
(55784,'enUS','Watch as your world comes to an end.','',26124),
(55785,'enUS','I AM DEATHWING, THE DESTROYER, THE END OF ALL THINGS, INEVITABLE, INDOMITABLE; I AM THE CATACLYSM!','',26124),
(55786,'enUS','I will slow the Destroyer\'s attacks when I can.','',26124),
(55787,'enUS','Your accent is strange. Are you from the Valley of the Four Winds?','Your accent is strange. Are you from the Valley of the Four Winds?',26124),
(55788,'enUS','Are you an adventurer? We don\'t hear about many adventures around here except the stories Tzu tells us.','Are you an adventurer? We don\'t hear about many adventures around here except the stories Tzu tells us.',26124),
(55789,'enUS','New to town? You should try Chin\'s noodles. They are the stuff of local legend.','New to town? You should try Chin\'s noodles. They are the stuff of local legend.',26124),
(55790,'enUS','I hear the hozen and jinyu have been increasing their skirmishes. Those poor little creatures will destroy each other if they aren\'t careful. It is quite a vicious cycle they are trapped in.','I hear the hozen and jinyu have been increasing their skirmishes. Those poor little creatures will destroy each other if they aren\'t careful. It is quite a vicious cycle they are trapped in.',26124),
(55791,'enUS','And what are you? I\'ve seen many things in my day but you are certainly a first. Has the turtle returned? I always thought that was a myth.','And what are you? I\'ve seen many things in my day but you are certainly a first. Has the turtle returned? I always thought that was a myth.',26124),
(55792,'enUS','I need to make sure to get in my sixth and seventh nap today if I expect to be ready for my big snooze.','I need to make sure to get in my sixth and seventh nap today if I expect to be ready for my big snooze.',26124),
(55793,'enUS','The Jade Serpent is nearly complete. You know what that means? Several months of cheering, celebrating, sleeping, and brewing! I can\'t wait!','The Jade Serpent is nearly complete. You know what that means? Several months of cheering, celebrating, sleeping, and brewing! I can\'t wait!',26124),
(55794,'enUS','%s hums a tune while unloading his basket.','%s hums a tune while unloading her basket.',26124),
(55795,'enUS','Sorry, Yue, but that\'s all the full blossoms I could find. Most of the flowers in this pool just aren\'t ready yet.','Sorry, Yue, but that\'s all the full blossoms I could find. Most of the flowers in this pool just aren\'t ready yet.',26124),
(55796,'enUS','You\'re the boss.','You\'re the boss.',26124),
(55797,'enUS','Gather \'round cubs and hear the tale of \"$p and the dreaded Silken Shadows\"...','',26124),
(55798,'enUS','There they were, marching through the depths of the Silkwood on an errand of peace.','',26124),
(55799,'enUS','But then, the dark evil spiders rose from their evil layers with eyes full of evil and legs full of evil.','',26124),
(55800,'enUS','They stabbed and bit and chomped but nothing they could do would defeat our hero, $p!','',26124),
(55801,'enUS','HUNDREDS OF DECAPITATIONS!','',26124),
(55802,'enUS','With weapons of power and a magnificent regalia our hero unleashed their fury on the beasts. It was glorious!','',26124),
(55804,'enUS','Oooooooo!','Aaaaaahhhh!',26124),
(55805,'enUS','And then what happened?','And then what happened?',26124),
(55808,'enUS','','Tapping is an art form passed down through the generations. No need to ask anyone else if that is true or not. Just take my word for it.',26124),
(55809,'enUS','\"Something profound.\"$b$BThere. Now whenever someone asks you what Lee Mugfinder said to you at your first meeting, it will always be something profound.','',26124),
(55810,'enUS','I make kegs. Sounds simple to the un-enlightened but you would be surprised how much the type of materials used in a keg will affect the flavor of the beverage held within.','',26124),
(55811,'enUS','','Hello there, $c!$B$BWe cultivate and harvest the finest lotus flowers in all of Pandaria. From here they are sent down to the village of New Cifera where they are sorted and shipped all over the land.$B$BThe lotus has countless culinary, medicinal, and decorative applications - as you can imagine, demand is quite high.',26124),
(55812,'enUS','You! Are you the ones responsible for what has happened here...?','',26124),
(55813,'enUS','What dark horrors have you wrought in this place? By my ancestors\' honor, I shall take you to task!','',26124),
(55814,'enUS','Where... is this place? What... have I done? Forgive me, my father...','',26124),
(55815,'enUS','This is the price you pay!','',26124),
(55816,'enUS','A just punishment!','',26124),
(55817,'enUS','Suffer for your arrogance!','',26124),
(55818,'enUS','There will be no escape!','',26124),
(55819,'enUS','My wrath knows no bounds!','',26124),
(55820,'enUS','You wish to train? YOU!?','',26124),
(55821,'enUS','I\'m ready for the trial of bamboo.','I\'m ready for the trial of bamboo.',26124),
(55822,'enUS','My fists are ready. Bring on the trial of wood.','My fists are ready. Bring on the trial of wood.',26124),
(55823,'enUS','I\'ve done all that you\'ve asked of me. I\'m ready for the trial of stone.','I\'ve done all that you\'ve asked of me. I\'m ready for the trial of stone.',26124),
(55826,'enUS','|TInterface\\Icons\\spell_fire_meteorstorm.blp:20|t%s begins to cast |cFFFF0000|Hspell:105651|h[Elementium Bolt]|h|r!','',26124),
(55827,'enUS','','Hey there!$B$B<The little girl squints at you.>$B$BI overheard you talking to the Elder Sage. He\'s pretty serious, isn\'t he?$B$BWell you\'re in luck, because I hear just about everything that happens around here.',26124),
(55828,'enUS','Very well then, outsiders. Let us see your true strength.','',26124),
(55829,'enUS','Skill with a weapon is but a physical manifestation of one\'s martial strength. Let me show you what spiritual power is!','',26124),
(55830,'enUS','When I was but a cub I could scarcely throw a punch, but after years of training I can do so much more!','',26124),
(55831,'enUS','','Hey, stranger! Pssst! Come over here!',26124),
(55832,'enUS','I am bested.  Give me a moment and we will venture forth together to face the Sha.','',26124),
(55833,'enUS','The waters are wild and chaotic. Something agitates them.','',26124),
(55834,'enUS','I must speak to the waters to understand their turmoil.','',26124),
(55835,'enUS','Thanks to you, my work can now continue.','',26124),
(55836,'enUS','Elder, I found your staff.','Elder, I found your staff.',26124),
(55837,'enUS','This staff holds powers passed down through my ancestors. Thank you for returning it to me.','',26124),
(55838,'enUS','SIT!','',26124),
(55839,'enUS','Welcome to the Temple of the Jade Serpent, traveler.$B$BWe welcome all within our doors, and offer knowledge freely to any who seek it.','',26124),
(55840,'enUS','Alright, let\'s get a move on!','',26124),
(55843,'enUS','I will bring you closer to the Emerald Dream. Seek safety there when the fight becomes too intense.','',26124),
(55844,'enUS','Only you can give us our opening!','',26124),
(55845,'enUS','These champions are our only hope for exposing Deathwing\'s weakness. Together, we can prevail.','',26124),
(55846,'enUS','Don\'t give up! We are counting on you to push Deathwing back.','',26124),
(55847,'enUS','My thanks, $p, for saving me from that vile jade witch.$b$bEven now my legs still feel stiff. I can command soldiers, if we can call these creatures that. But I think I will be of little use in any battle.','',26124),
(55848,'enUS','|TInterface\\Icons\\ability_deathwing_assualtaspects.blp:20|t%s assaults |cFFFF0000|Hspell:107018|h[Alexstrasza]|h|r!','',26124),
(55849,'enUS','|TInterface\\Icons\\ability_deathwing_assualtaspects.blp:20|t%s assaults |cFFFFFF00|Hspell:107018|h[Nozdormu]|h|r!','',26124),
(55850,'enUS','|TInterface\\Icons\\ability_deathwing_assualtaspects.blp:20|t%s assaults |cFF04FC32|Hspell:107018|h[Ysera]|h|r!','',26124),
(55851,'enUS','|TInterface\\Icons\\ability_deathwing_assualtaspects.blp:20|t%s assaults |cFF5858FA|Hspell:107018|h[Kalecgos]|h|r!','',26124),
(55852,'enUS','Ready!','',26124),
(55853,'enUS','|TInterface\\Icons\\ability_deathwing_assualtaspects.blp:20|t%s begins to cast |cFFFF0000|Hspell:107018|h[Assault Aspects]|h|r!','',26124),
(55854,'enUS','Aim!','',26124),
(55855,'enUS','FLING!','',26124),
(55856,'enUS','You ookin nugs missed the wikket! AGAIN!','',26124),
(55857,'enUS','You through like a land walker!','',26124),
(55858,'enUS','Does it hurt being as dumb as you are?','',26124),
(55859,'enUS','At this rate I would die faster of natural causes.','',26124),
(55860,'enUS','You have done NOTHING. I will tear your world APART.','',26124),
(55875,'enUS','I\'ve lost my lashtail hatchling.','I\'ve lost my lashtail hatchling.',26124),
(55879,'enUS','I\'ve lost my panther cub.','I\'ve lost my panther cub.',26124),
(55880,'enUS','I\'ve lost my balloon.','I\'ve lost my balloon.',26124),
(55881,'enUS','What you want?','',26124),
(55882,'enUS','','The kodos are waiting on the road. Safe journey, $Gbrother:sister;.',26124),
(55887,'enUS','','I never would have thought that these grunts could be trained.',26124),
(55888,'enUS','Boom boom too small! Wikket being sticky with the boom booms.','',26124),
(55889,'enUS','','Be glad I only gave you a bomb. Ingrate.',26124),
(55890,'enUS','','Obviously you have mistaken me for someone who cares.',26124),
(55891,'enUS','','Should have had more fiber in your diet then.',26124),
(55892,'enUS','My boom boom is too small! Can I have another?','',26124),
(55893,'enUS','More please?','',26124),
(55894,'enUS','This is a flawlessly etched jade statue of An Windfur\'s friend Shin, eyes wide with terror.','',26124),
(55895,'enUS','Ookin\' flapper dropped a dooker!','',26124),
(55896,'enUS','Gate?! I\'m going to bring this whole wall down!','',26124),
(55897,'enUS','This will be the bomb.','',26124),
(55898,'enUS','I need to follow this map to Dawn\'s Blossom.','I need to follow this map to Dawn\'s Blossom.',26124),
(55899,'enUS','You\'re the bomb!','',26124),
(55900,'enUS','Things that make you go... BOOM!','',26124),
(55901,'enUS','BOOM! Explosion! Overpowering!','',26124),
(55902,'enUS','BOOM shakalaka!','',26124),
(55903,'enUS','Who crashing Ook party!?','',26124),
(55904,'enUS','','The heart of the Great Serpent will not fall into your hands!',26124),
(55905,'enUS','','The cycle must continue, the Jade Serpent must be reborn!',26124),
(55906,'enUS','','The heart is MINE!',26124),
(55907,'enUS','','Leave this place.',26124),
(55908,'enUS','','The haze has been lifted from my eyes... forgive me for doubting you...',26124),
(55909,'enUS','Be free of doubt, priestess...','Be free of doubt, priestess...',26124),
(55910,'enUS','','My noble Varo\'then, do return and dispose of this murderous band.',26124),
(55912,'enUS','At your side, my queen!','',26124),
(55913,'enUS','','It is them!',26124),
(55914,'enUS','','Heroes! We have been sent by Nozdormu! Quickly, on our backs, we must get you to the Dragon Soul!',26124),
(55915,'enUS','','Sister, look! The artifact is surrounded by an aura of darkness!',26124),
(55916,'enUS','','The aspects!',26124),
(55917,'enUS','','The Old Gods protect the Soul!',26124),
(55918,'enUS','','The link to the portal must be broken! Quickly, to Stormrage!',26124),
(55919,'enUS','','Ah, welcome. You are here to join us in the coming celebration? No? A pity.',26124),
(55920,'enUS','','Serve Azshara, puppets, and rejoice.',26124),
(55921,'enUS','Yes?','',26124),
(55922,'enUS','','Such insolence. My temper grows short.',26124),
(55923,'enUS','Loon Mai has issued evacuation orders.','Loon Mai has issued evacuation orders.',26124),
(55924,'enUS','Oh, I don\'t know. I am old, and I have always...','',26124),
(55925,'enUS','Look out! Mantid!','',26124),
(55926,'enUS','I feared that this day would come. I will pack up my things.','',26124),
(55927,'enUS','What, another one? Did Commander Mai send you?$b$bHow many times do I have to tell that bonehead - we\'re not evacuating!','',26124),
(55928,'enUS','Yes, Commander Mai sent me, and I carry his evacuation orders.','Yes, Commander Mai sent me, and I carry his evacuation orders.',26124),
(55929,'enUS','','Pshh... outsiders. You know nothing about the Stoneplow way.',26124),
(55930,'enUS','','We\'re proud. We\'re strong. We are descended from the blood of the Tiller himself... and we don\'t run from trouble.',26124),
(55931,'enUS','That\'s right. Now please, $r, leave and let us defend our property.','',26124),
(55932,'enUS','Stay back!$b$bWait... you\'re not one of them. We\'re not accustomed to outsiders, and with the mantid breaking through the wall, I...$b$bAnyhow, what can we do to help you?','',26124),
(55933,'enUS','Loon Mai has issued evacuation orders.','Loon Mai has issued evacuation orders.',26124),
(55934,'enUS','I see. I\'d hoped that we could wait out this invasion, but if the authorities want us to leave, we will leave.','',26124),
(55935,'enUS','Ying, Huizhong... gather your things. We\'re leaving the farm until it\'s safe.','',26124),
(55936,'enUS','','Oh, honey...',26124),
(55937,'enUS','','Daddy, is this nice person going to kill all the bad mantid soldiers?',26124),
(55938,'enUS','I don\'t know, dear.','',26124),
(55939,'enUS','Are you?','',26124),
(55940,'enUS','How can I help you, $c?','',26124),
(55941,'enUS','Loon Mai has issued evacuation orders.','Loon Mai has issued evacuation orders.',26124),
(55942,'enUS','%s sighs.','',26124),
(55943,'enUS','I am a farmer, $c. It\'s all I know.','',26124),
(55944,'enUS','All we have is our land. And that commander wants us to give it up to the mantid?','',26124),
(55945,'enUS','I will not do it. My grandfather knew what he was getting into when he first planted seed in the shadow of the Serpent\'s Spine.','',26124),
(55946,'enUS','I have my wife, two strong daughters, and two strong sons. Thank you, but we can protect this farm ourselves.','',26124),
(55947,'enUS','','Those had better not be evacuation papers I see.',26124),
(55948,'enUS','','Welcome to Stoneplow. What can we do for you?',26124),
(55949,'enUS','','I apologize for the mess. Things are a little hectic right now.$b$bHow can I be of service to you?',26124),
(55950,'enUS','Do you have those evacuation papers?','',26124),
(55951,'enUS','Yes, they\'re right here. Let\'s go.','Yes, they\'re right here. Let\'s go.',26124),
(55952,'enUS','I\'ve reconsidered... it\'s too dangerous to stay here. No piece of land is worth losing your life over. Let me see those evacuation orders.','',26124),
(55953,'enUS','','Is there anyone in need of medical aid?',26124),
(55954,'enUS','','HEY ROOKIE! DID YOU SAY SOMETHING TO ME? SORRY, MY EARS ARE STILL RINGING FROM THE EXPLOSION!',26124),
(55955,'enUS','Loudly explain how to get back to camp.','Loudly explain how to get back to camp.',26124),
(55956,'enUS','Wake him up.','Wake him up.',26124),
(55957,'enUS','<The gnome\'s face is streaked with smoke and burns, but he\'s alive.>','',26124),
(55958,'enUS','What\'s yer mission? I got the tools that you need.','',26124),
(55959,'enUS','<The dwarf is unconscious, but otherwise unharmed.>','',26124),
(55960,'enUS','They\'ll take this camp over my dead body!','',26124),
(55961,'enUS','Keep your eyes open and your head in the mission, recruit.','',26124),
(55962,'enUS','Woohoo, that was some crash! All my parts seem accounted for. Thanks, rookie.','',26124),
(55963,'enUS','Oof! I reckon we fared better\'n Amber and Nimm. Saw their plane burn up further inland. Thanks, $c.','',26124),
(55964,'enUS','','I\'ll stick with you a little longer, $n. I saw many injured crewmen who may be in need of my aid.',26124),
(55965,'enUS','This seems like a good spot to consult the water!','',26124),
(55966,'enUS','','Come sister, it is time to end this. We will cleanse the Dragon Soul of the Old Gods\' dark influence!',26124),
(55967,'enUS','','It is too powerful!',26124),
(55968,'enUS','How DARE you touch my creation?! It is mine...mine...MINE!','',26124),
(55969,'enUS','','Neltharion! What have you done? You have doomed us all to the madness of the Old Gods!',26124),
(55970,'enUS','IT IS MINE!!','',26124),
(55971,'enUS','','He is lost to us, sister. He is Neltharion no longer.',26124),
(55972,'enUS','','The power of the Soul is tearing him apart!',26124),
(55973,'enUS','Nooooo...away...','',26124),
(55974,'enUS','I WILL NOT BE DENIED!','',26124),
(55975,'enUS','AWAY!','',26124),
(55976,'enUS','','WHAT? FOLLOW YOU? OKAY!',26124),
(55977,'enUS','At last it has come to pass. The moment of my demise. The loop is closed. My future self will cause no more harm.','',26124),
(55978,'enUS','Still, in time, I will... fall to madness. And you, heroes... will vanquish me. The cycle will repeat. So it goes.','',26124),
(55979,'enUS','What matters is that Azeroth did not fall; that we survived to fight another day.','',26124),
(55980,'enUS','All that matters... is this moment.','',26124),
(55981,'enUS','The \"End Time,\" I once called this place. I had not seen, by then; I did not know. You hope to... what? Stop me, here? Change the fate I worked so tirelessly to weave?','',26124),
(55982,'enUS','You crawl unwitting, like a blind, writhing worm, towards endless madness and despair. I have witnessed the true End Time. This? This is a blessing you simply cannot comprehend.','',26124),
(55983,'enUS','%s vanishes into the shadows!','',26124),
(55984,'enUS','The Eyes of Peroth\'arn are looking for you.','',26124),
(55985,'enUS','Select your destination.','Select your destination.',26124),
(55986,'enUS','Entryway of Time','Entryway of Time',26124),
(55987,'enUS','Ruby Dragonshrine','Ruby Dragonshrine',26124),
(55988,'enUS','Emerald Dragonshrine','Emerald Dragonshrine',26124),
(55989,'enUS','Azure Dragonshrine','Azure Dragonshrine',26124),
(55990,'enUS','Obsidian Dragonshrine','Obsidian Dragonshrine',26124),
(55991,'enUS','Bronze Dragonshrine','Bronze Dragonshrine',26124),
(55992,'enUS','','Did you hear that!? The Hidden Master, to the north of here!?',26124),
(55993,'enUS','','Watch Commander, I will be leaving now. I\'m finally going to go continue my training!',26124),
(55994,'enUS','','Maybe I\'ll see you up there, $n!',26124),
(55995,'enUS','','$n, you did well. I\'m going back to camp to take care of the wounded. Check in with the Commander when you\'re done out here.',26124),
(55998,'enUS','','Oh, and $r! Come back with the goods, okay? I\'ve got to make sure they\'re up to snuff.',26124),
(55999,'enUS','Snowpuff and I\'ll be waitin\'! Please hurry!','',26124),
(56000,'enUS','We have a situation on our hands. Help defend our allies!','',26124),
(56001,'enUS','A dark force from within the Dragon Soul reacts violently to the cleansing!','A dark force from within the Dragon Soul reacts violently to the cleansing!',26124),
(56003,'enUS','Ahhh... this test is simple. All you need to do is strike the bamboo, until it breaks.','',26124),
(56004,'enUS','\"But it\'s too thick around!\", you might say.','',26124),
(56005,'enUS','That is part of the test. Yes... to succeed, you must focus all your energy into one fist...','',26124),
(56006,'enUS','..then, STRIKE!','',26124),
(56007,'enUS','Strike the stack of bamboo when the meter is full!','',26124),
(56008,'enUS','This test is simple. All you need to do is strike the wood, until it breaks.','',26124),
(56009,'enUS','\"But it\'s too hard!\", you might say.','',26124),
(56010,'enUS','But it is not too hard. You are ready for this, $n.','',26124),
(56011,'enUS','This test is simple. All you need to do is strike the stone, until it breaks.','',26124),
(56012,'enUS','\"But that\'s impossible!\", you might say.','',26124),
(56013,'enUS','You would be wrong. With clarity and focus, nothing is impossible.','',26124),
(56014,'enUS','Yes, just like that!','',26124),
(56015,'enUS','An excellent strike.','',26124),
(56016,'enUS','Excellent focus, $n.','',26124),
(56017,'enUS','You learn quickly.','',26124),
(56018,'enUS','I could not have done better myself.','',26124),
(56019,'enUS','Well done.','',26124),
(56020,'enUS','No, you must focus!','',26124),
(56021,'enUS','We must not waste time, traveler.','',26124),
(56022,'enUS','Wait until the moment is right... THEN you strike!','',26124),
(56023,'enUS','Patience is the key.','',26124),
(56024,'enUS','Clear your mind, $n.','',26124),
(56025,'enUS','Your fists are strong, but your mind is still weak.','',26124),
(56026,'enUS','Try again.','',26124),
(56027,'enUS','Mind over matter, $n.','',26124),
(56028,'enUS','Do not let the stone intimidate you. It is stone, you are $r.','',26124),
(56029,'enUS','Strike the stack of wood when the meter is full!','',26124),
(56030,'enUS','Strike the stack of stone when the meter is full!','',26124),
(56031,'enUS','I\'ve only done this once before... Hopefully this works.','',26124),
(56032,'enUS','%s plunges the bottom end of his staff into the pool before resting his head on the top.','',26124),
(56033,'enUS','Welcome, $n.','',26124),
(56034,'enUS','Are you here for more training, $n?','',26124),
(56035,'enUS','How can I serve, $n?','',26124),
(56036,'enUS','There is nothing more that I can do for you, $n. Take what I have taught you, and use it elsewhere.','',26124),
(56037,'enUS','What... what is this place? It is beautiful... But... something is not right.','',26124),
(56038,'enUS','I must speak to the waters to understand their turmoil.','',26124),
(56039,'enUS','Little waters, if you would just stop moving so quickly, perhaps I could help you!','',26124),
(56040,'enUS','Darkness comes. I can feel it within my bones.','',26124),
(56041,'enUS','Do not fear, little ones. Come shadow or light, the waters will always flow.','',26124),
(56042,'enUS','Water is life. When the waters feel torment, then so shall we.','',26124),
(56043,'enUS','Jinyu and their crazy rituals...','Jinyu and their crazy rituals...',26124),
(56044,'enUS','','I know what your friend has seen, $n - he will need to rest for now. Come speak with me.',26124),
(56045,'enUS','Something has disturbed the waters. They are normally so well-behaved.','',26124),
(56046,'enUS','I can\'t even begin to describe it... you have to see this, $n.','',26124),
(56047,'enUS','%s ambushes his helpless prey!','',26124),
(56048,'enUS','','Could it be? Can the jinyu really tap into the water\'s power that easily?',26124),
(56049,'enUS','','I\'ve never seen anyone get a vision from these waters so easily.$B$BThen again, I can\'t remember the last time a jinyu came to visit us and then stuck his face in the water...',26124),
(56050,'enUS','Playful Gold Serpent licks you.','',26124),
(56051,'enUS','Playful Gold Serpent makes a fancy flip.','',26124),
(56052,'enUS','Playful Gold Serpent nips at you playfully.','',26124),
(56053,'enUS','Playful Gold Serpent wants to be petted.','',26124),
(56054,'enUS','Playful Gold Serpent rubs affectionately against your arm.','',26124),
(56055,'enUS','Playful Gold Serpent chases its own tail.','',26124),
(56056,'enUS','Playful Crimson Serpent licks you.','',26124),
(56057,'enUS','Playful Crimson Serpent makes a fearsome face.','',26124),
(56058,'enUS','Playful Crimson Serpent roars with vigor.','',26124),
(56059,'enUS','Playful Gold Serpent pounces at the air.','',26124),
(56060,'enUS','Playful Crimson Serpent nips at you experimentally.','',26124),
(56061,'enUS','Playful Crimson Serpent is bored.','',26124),
(56062,'enUS','Playful Emerald Serpent looks around curiously.','',26124),
(56063,'enUS','Playful Emerald Serpent sniffs you.','',26124),
(56064,'enUS','Playful Emerald Serpent tries to eat your hair, and then spits it out. Yuck!','',26124),
(56067,'enUS','Playful Emerald Serpent tumbles through the air.','',26124),
(56068,'enUS','Playful Emerald Serpent is sleepy.','',26124),
(56069,'enUS','Playful Emerald Serpent wants to play a game!','',26124),
(56070,'enUS','Playful Azure Serpent plays with its own shadow.','',26124),
(56071,'enUS','Playful Azure Serpent is hungry!','',26124),
(56072,'enUS','Playful Azure Serpent wants a snack.','',26124),
(56073,'enUS','Playful Azure Serpent wonders if you have a treat.','',26124),
(56074,'enUS','Playful Azure Serpent licks itself.','',26124),
(56075,'enUS','Playful Azure Serpent needs some love!','',26124),
(56076,'enUS','Choose a pet to fight for you in battle!','Choose a pet to fight for you in battle!',26124),
(56077,'enUS','Heroes, we must place this burden on your shoulders once again.  You must protect us from Deathwing\'s forces while we imbue the Soul with the powers of the great Aspects of Azeroth.','',26124),
(56078,'enUS','You may begin your ritual, we will defend you.','You may begin your ritual, we will defend you.',26124),
(56079,'enUS','Our engines are damaged!  We\'re sitting ducks up here!','',26124),
(56080,'enUS','It is good to see you again, Alexstrasza. I have been busy in my absence.','',26124),
(56081,'enUS','','They... are my clutch no longer.  Bring them down.',26124),
(56082,'enUS','This library holds thousands of years of history and lore. The greatest knowledge in all of Pandaria is kept here.$B$BThat is why we must keep this great treasure safe.','',26124),
(56083,'enUS','The scrolls! I must save the scrolls!','',26124),
(56084,'enUS','It is no use, the power of the Soul is too great. I cannot wield it safely; the raging forces within it may be the doom of us all.','',26124),
(56085,'enUS','Investigating','Investigating',26124),
(56086,'enUS','Hee hee hee hee hee!','',26124),
(56087,'enUS','More power!','',26124),
(56088,'enUS','So delicious!','',26124),
(56089,'enUS','Careful with that there vial. She\'s a bit leaky.','',26124),
(56090,'enUS','','Welcome to the Temple of the Jade Serpent. How may I help you?',26124),
(56091,'enUS','I\'d like to go inside the Temple of the Jade Serpent.','I\'d like to go inside the Temple of the Jade Serpent.',26124),
(56092,'enUS','I have a message for the Jade Serpent.','I have a message for the Jade Serpent.',26124),
(56093,'enUS','Are you finding everything you need at the Temple?','',26124),
(56094,'enUS','I would like to return to the temple grounds.','I would like to return to the temple grounds.',26124),
(56095,'enUS','','You\'ve been a really big help here at the Temple!$B$BI heard the Elder Sage say that he\'s glad you arrived when you did.',26124),
(56096,'enUS','','Welcome to the Temple of the Jade Serpent, stranger. Our doors are open to all who seek knowledge.',26124),
(56097,'enUS','Teleport to the garden entrance.','Teleport to the garden entrance.',26124),
(56098,'enUS','','Why is all of your grain so bland?',26124),
(56099,'enUS','','They have failed us sister.',26124),
(56100,'enUS','','I have awakened only to sleep once again.',26124),
(56101,'enUS','The grain we gather needs to be in large quantities for the brewery. But I may know of a grain that would suit your needs.','',26124),
(56102,'enUS','It was a short time, for our part...','',26124),
(56103,'enUS','... indeed it was.','',26124),
(56104,'enUS','There is perhaps a way...','',26124),
(56105,'enUS','Li Li... let\'s go. Your uncle has got something to prove.','',26124),
(56106,'enUS','','%s smiles.',26124),
(56107,'enUS','','Finally! THERE\'S the Uncle Chen I\'ve been waiting for.',26124),
(56108,'enUS','Teleport to rejoin Illidan.','Teleport to rejoin Illidan.',26124),
(56109,'enUS','Teleport to Azshara\'s Palace.','Teleport to Azshara\'s Palace.',26124),
(56110,'enUS','Teleport to Azshara\'s Overlook.','Teleport to Azshara\'s Overlook.',26124),
(56111,'enUS','Teleport to The Well of Eternity.','Teleport to The Well of Eternity.',26124),
(56114,'enUS','First things first. We\'re going to need some sweet malts.','',26124),
(56118,'enUS','Hm... don\'t get many $cs up this way...','Hm... don\'t get many $cs up this way...',26124),
(56119,'enUS','Oh hello! Haven\'t seen you around before...','',26124),
(56120,'enUS','%s snaps its tether with a mighty effort, breaking free!','',26124),
(56121,'enUS','You can find your malts at the granary, I reckon.','',26124),
(56122,'enUS','','Mudmug!',26124),
(56123,'enUS','Mudmug!','',26124),
(56124,'enUS','I\'m here to help with that fancy beer you was talkin\' about.','',26124),
(56125,'enUS','Glad to have you. We will be making a stout. Can you get a few barrels of water?','',26124),
(56126,'enUS','Git \'er done.','',26124),
(56127,'enUS','Li Li, you get the malts. I will... research the local brews. We\'ll meet back here.','',26124),
(56128,'enUS','','\"Research?\" Sure.',26124),
(56129,'enUS','I apologize for the deception, but it was necessary.','',26124),
(56130,'enUS','In thousands of years, we have never seen one of your kind.','',26124),
(56131,'enUS','It was imperative that I first measure the bearing of your heart.','',26124),
(56132,'enUS','','Yet, I have witnessed that your actions speak of no evil.',26124),
(56133,'enUS','','Alas, I have grown too weak to see the strands of fate.',26124),
(56134,'enUS','','Which thread are you, I wonder? The one that unravels the pattern, or the one that holds it together?',26124),
(56135,'enUS','','I grow old, little one. My time on this world is nearly done.',26124),
(56136,'enUS','','Do you see the great statue in the distance?',26124),
(56137,'enUS','','The builders have toiled for many years, and it is nearly complete.',26124),
(56138,'enUS','','A little more jade - the jade you helped to acquire - and it will be finished.',26124),
(56139,'enUS','','With my last breath, I will transfer my life essence into the statue, and a new guardian will be born.',26124),
(56140,'enUS','','Someday, you may also be called upon to defend all that is dear to you.',26124),
(56141,'enUS','','Do not be saddened. The cycle is clear - it neither begins nor ends with me.',26124),
(56142,'enUS','','Revere those who have gone the way of dust.',26124),
(56143,'enUS','','Celebrate the life you are given on this earth.',26124),
(56144,'enUS','','For everything that you take, give double in kind.',26124),
(56145,'enUS','','Only in this way will our wisdom be passed forward through time.',26124),
(56146,'enUS','','This is how we live on, for all eternity.',26124),
(56147,'enUS','','I grow weary. I must rest now.',26124),
(56148,'enUS','','Choose wisely, young one.',26124),
(56149,'enUS','This grain tastes too old, bitter, and angry.','This grain tastes too old, bitter, and angry.',26124),
(56150,'enUS','This grain tastes too light and bouncy.','This grain tastes too light and bouncy.',26124),
(56151,'enUS','This grain has too much zing.','This grain has too much zing.',26124),
(56152,'enUS','No, there won\'t be any taste tests today. Not until someone helps me get my stolen grain back!','No, there won\'t be any taste tests today. Not until someone helps me get my stolen grain back!',26124),
(56153,'enUS','This grain tastes too earthy and natural.','This grain tastes too earthy and natural.',26124),
(56154,'enUS','Come ride with me, little one. There is something I wish you to see.','',26124),
(56155,'enUS','Transmogrification','Transmogrification',26124),
(56156,'enUS','','%s screeches in pain and retreats into the swirling clouds.',26124),
(56157,'enUS','','The Temple Priests are too frightened to face the truth...',26124),
(56158,'enUS','5...','5...',26124),
(56159,'enUS','4...','4...',26124),
(56160,'enUS','3...','3...',26124),
(56161,'enUS','2...','2...',26124),
(56162,'enUS','1...','1...',26124),
(56163,'enUS','First, go water my Bright Green Spinach!','First, go water my Bright Green Spinach!',26124),
(56164,'enUS','Good enough! Now go water my Giant Carrots!','Good enough! Now go water my Giant Carrots!',26124),
(56165,'enUS','Keep going! Water my Cabbages!','Keep going! Water my Cabbages!',26124),
(56166,'enUS','Don\'t stop moving! Water those Sugar Beets!','Don\'t stop moving! Water those Sugar Beets!',26124),
(56167,'enUS','Go water my Huge Melons, further down the path!','Go water my Huge Melons, further down the path!',26124),
(56168,'enUS','Keep it up! Now water my Red-Leaf Lettuce!','Keep it up! Now water my Red-Leaf Lettuce!',26124),
(56169,'enUS','Looks like my Sugar Beets still need more water! Turn back!','Looks like my Sugar Beets still need more water! Turn back!',26124),
(56171,'enUS','Water my Bright Green Spinach!','Water my Bright Green Spinach!',26124),
(56172,'enUS','Water my Giant Carrots!','Water my Giant Carrots!',26124),
(56173,'enUS','Water my Cabbages!','Water my Cabbages!',26124),
(56174,'enUS','Water my Sugar Beets!','Water my Sugar Beets!',26124),
(56175,'enUS','Water my Huge Melons!','Water my Huge Melons!',26124),
(56176,'enUS','Water my Red-Leaf Lettuce!','Water my Red-Leaf Lettuce!',26124),
(56177,'enUS','Water my Elephant Garlic!','Water my Elephant Garlic!',26124),
(56178,'enUS','Were you looking to Reforge an item? I no longer provide such services.\n\nThe ethereals of \"Three Winds\" in Stormwind\'s Cathedral District will help you, though.\n\nAny of the city\'s guards can provide directions.','Were you looking to Reforge an item? I no longer provide such services.\n\nThe ethereals of \"Three Winds\" in Stormwind\'s Cathedral District will help you, though.\n\nAny of the city\'s guards can provide directions.',26124),
(56179,'enUS','Were you looking to Reforge an item? I no longer provide such services.\n\nThe ethereals of Orgrimmar\'s Drag will help you, though.\n\nAny of the city\'s guards can provide directions.','Were you looking to Reforge an item? I no longer provide such services.\n\nThe ethereals of Orgrimmar\'s Drag will help you, though.\n\nAny of the city\'s guards can provide directions.',26124),
(56180,'enUS','No no no! Return to me, and we\'ll try again!','No no no! Return to me, and we\'ll try again!',26124),
(56181,'enUS','','To be a serpent rider, one must not fear pain.',26124),
(56182,'enUS','','Be aware of your serpent\'s movements. Focus, then strike as one!',26124),
(56183,'enUS','','Yesterday, today, tomorrow...you and your serpent act as one.',26124),
(56184,'enUS','','When you chose this path, you bound your life to that of your serpent. Do not fail them now!',26124),
(56185,'enUS','','Weakness will not be tolerated. Only strength prevails!',26124),
(56186,'enUS','','Train your serpents well. A bond of trust is your strongest weapon.',26124),
(56187,'enUS','','The serpent rider\'s path is drenched in blood and tears. Your journey has just begun!',26124),
(56188,'enUS','You looking for something, $r? You look like you\'re looking for something.','',26124),
(56189,'enUS','I\'m ready to go!','I\'m ready to go!',26124),
(56190,'enUS','The watering can is empty. Return to Gardener Fran.','The watering can is empty. Return to Gardener Fran.',26124),
(56191,'enUS','You just watered that spot! Don\'t get lazy on me!','You just watered that spot! Don\'t get lazy on me!',26124),
(56192,'enUS','Oh, hello stranger. Very sorry for the mess here. Normally this granary is in tip top super efficient status.','',26124),
(56193,'enUS','Welcome to the Imperial Granary.$b$BThough not so \"imperious\" today with this sprite infestation. Oh, um, you didn\'t hear that. Or see, for that matter.$b$BIn fact, can you not tell anyone you ever came here and especially not say anything about this sprite fiasco?','',26124),
(56194,'enUS','You buy one wrong grain and suddenly the world falls apart. Now we have a sprite infestation and migrating birds to boot.$b$BI was just trying to help us hit our quota to the Stormstout Brewery!','',26124),
(56195,'enUS','There was a time when my father would spend days in the jungle hunting for the perfect cave barley.$b$BIt was very dangerous, and something I can\'t bring myself to do.$b$BNot worth it. Stormstout only pays for quantity, not quality.','',26124),
(56196,'enUS','Well, we may still be crawling with sprites, but I certainly appreciate the help you gave us. You really are quite the travelling hero.','',26124),
(56197,'enUS','Even with this fiasco I am once again starting to hit my quota. Something is up with the Stormstout brewery lately in that they haven\'t been demanding quite as much grain as usual.','',26124),
(56198,'enUS','If you ever find yourself travelling to the west off the beaten path keep a weather eye out for my eccentric father. He never enjoyed the increased business from the Stormstouts.$b$BI grew up listening to how we were \"brewing out originallity.\" He is quite the beer snob.$b$BStill, he might have a trinket or story you might find interesting.','',26124),
(56201,'enUS','Look, there\'s a weed now! Go pull it!','',26124),
(56202,'enUS','Some more weeds, over here!','',26124),
(56203,'enUS','Keep it up, you\'re doing great!','',26124),
(56204,'enUS','Just go stomp on those little weeds. No need to waste your time picking them.','',26124),
(56205,'enUS','Here, I\'ve got some spare Weed-B-Gone. This should help.','',26124),
(56206,'enUS','Look out!','',26124),
(56207,'enUS','Here\'s some more Weed-B-Gone!','',26124),
(56208,'enUS','Looks like things are finally starting to calm down.','',26124),
(56209,'enUS','Click on weeds to pull them!','Click on weeds to pull them!',26124),
(56210,'enUS','Walk over small weeds!','Walk over small weeds!',26124),
(56211,'enUS','Pick up the Weed-B-Gone!','Pick up the Weed-B-Gone!',26124),
(56212,'enUS','Oof! What are you doing?!','',26124),
(56213,'enUS','Ow! Stop it! I\'m waiting for the thunderbirds to take me!','',26124),
(56214,'enUS','Here they come...','',26124),
(56215,'enUS','Why?!','',26124),
(56216,'enUS','Just leave me here or they\'ll take you too!','',26124),
(56217,'enUS','Ugh... I\'m getting dizzy.','',26124),
(56218,'enUS','You\'re crazy, you know that? Here comes another!','',26124),
(56219,'enUS','I\'m keeping my fields fallow this season. A wise farmer knows when the land needs to rest.','',26124),
(56220,'enUS','Well, aren\'t you going to pick the weeds?','',26124),
(56221,'enUS','What weeds?','What weeds?',26124),
(56222,'enUS','Take a look around, $n!$b$bWe\'ve turned these monkeys into a bonifide army while you were away!','',26124),
(56223,'enUS','I was tasked with finding more productive ways to make silk. In my hubris, I created monsters! This is a shame I will carry to the end of my days.','',26124),
(56224,'enUS','Panda lady! Do a dance on top of the carrot!','',26124),
(56225,'enUS','Yes, good! Move those furry feets!','',26124),
(56226,'enUS','Now blow me a kiss while you stand on the big carrot!','',26124),
(56227,'enUS','Panda lady! Sit down on the carrot!','',26124),
(56228,'enUS','Now stand up!','',26124),
(56229,'enUS','Now sit down and stand up lots of times in a row!','',26124),
(56230,'enUS','Aww yeah...','',26124),
(56231,'enUS','Panda lady! I have an idea!','',26124),
(56232,'enUS','Here, you hold little carrot while you stand on big carrot!','',26124),
(56233,'enUS','Yeah, you hold that carrot. That\'s right.','',26124),
(56234,'enUS','Panda lady! Catch this carrot!','',26124),
(56235,'enUS','Now throw it at me!','',26124),
(56236,'enUS','Throw it really hard at my face!','',26124),
(56237,'enUS','Ahhh...','',26124),
(56238,'enUS','Panda lady! Catch!','',26124),
(56239,'enUS','Now eat the carrot!','',26124),
(56240,'enUS','NO! Eat it slower!','',26124),
(56241,'enUS','Mm-hmm. That\'s nice, panda lady.','',26124),
(56242,'enUS','I\'m helping a friend brew some beer, and we need hops. Do you have any to spare?','I\'m helping a friend brew some beer, and we need hops. Do you have any to spare?',26124),
(56243,'enUS','Can I buy some hops from you?','Can I buy some hops from you?',26124),
(56244,'enUS','Do you have any hops you can spare?','Do you have any hops you can spare?',26124),
(56245,'enUS','','I suppose you did help me water my plants. Very well... I\'ll have the hops sent to your friend Chen, in Halfhill.',26124),
(56246,'enUS','','Nothing is free, $r. You want hops, you need to work.',26124),
(56247,'enUS','Of course! After helping me with those weeds, sharing some hops is the least I can do. I\'ll have the hops delivered to Master Stormstout, in Halfhill.','',26124),
(56248,'enUS','Would that I could, $c, but I have a bit of a weed problem. Say... you wouldn\'t be willing to help out, would you?','',26124),
(56249,'enUS','Certainly. Kill a few virmen, earn a few bushels of hops. I\'ll have Mung-Mung send them to Halfhill.','',26124),
(56250,'enUS','You\'ll have to ask Mung-Mung about that. He maintains our foodstores.','',26124),
(56251,'enUS','','You said you needed hops? Very well. I\'ll send some to Halfhill.',26124),
(56252,'enUS','You are a lifesaver, $c. I will have your hops delivered to Halfhill right away.','',26124),
(56253,'enUS','Riko got this bitch on lockdown!$b$bPlenty of slickies for hozen army!','',26124),
(56254,'enUS','You say you want hops? No problem. You kill virmen for me, Mung-Mung send some hops to Halfhill for you.','',26124),
(56255,'enUS','Virmen! Gah! Their numbers are endless!','',26124),
(56256,'enUS','Mina! You\'re home!','',26124),
(56257,'enUS','','Dad... I never want to see another carrot again.',26124),
(56258,'enUS','Take me to the Maelstrom.','Take me to the Maelstrom.',26124),
(56259,'enUS','Take me to the deck of The Skyfire to fight Blackhorn.','Take me to the deck of The Skyfire to fight Blackhorn.',26124),
(56260,'enUS','Take me to the summit of Wyrmrest Temple to fight Hagara.','Take me to the summit of Wyrmrest Temple to fight Hagara.',26124),
(56261,'enUS','Take me to the base of Wyrmrest Temple to fight Yor\'sahj and Zon\'ozz.','Take me to the base of Wyrmrest Temple to fight Yor\'sahj and Zon\'ozz.',26124),
(56262,'enUS','','So... many... carrots...',26124),
(56263,'enUS','Come on, Mina. Let\'s get you out of here.','Come on, Mina. Let\'s get you out of here.',26124),
(56264,'enUS','A drake swoops down to drop a Twilight Sapper onto the deck!','',26124),
(56265,'enUS','The Sha have broken out of the temple. We must beat them back...or die trying.','',26124),
(56266,'enUS','Greetings, $r.','',26124),
(56267,'enUS','','Let\'s go home.',26124),
(56268,'enUS','','Sure, you can ride on a mount while you water the plants. Why should I care?',26124),
(56269,'enUS','Wyrmrest Accord, Attack!','',26124),
(56270,'enUS','Tyrygosa yet lives! We must press on, to the Temple!','',26124),
(56271,'enUS','Left... Left! LEEEFFFFTTTT!','',26124),
(56272,'enUS','No! Right! Go Right!','',26124),
(56273,'enUS','Aaaaaaahhh! We\'re all doomed!','',26124),
(56274,'enUS','Buuurrrnn!','',26124),
(56275,'enUS','Stomp now.','',26124),
(56276,'enUS','Advance to the front!','',26124),
(56277,'enUS','The siege must be broken. Wyrmrest Accord, defend the line!','',26124),
(56278,'enUS','My journeyman often forgets that one must expect to fail many times in the pursuit of perfection.','',26124),
(56279,'enUS','You seem to me to be one who has had many experiences.','',26124),
(56280,'enUS','What interesting garb you wear. By whose hand was it threaded, if I may ask?','',26124),
(56281,'enUS','I remember a time when the venerable Silkmaster Tsai created a strand of silk so fine it sliced through the earth when he dropped it. We never saw it again.','',26124),
(56282,'enUS','I remember my first experiment gone awry. These fields were crawling with super grubs the likes of which had not been seen in this age of the world.','',26124),
(56283,'enUS','Loommaster Jeng once spun a weave of silk so thin and smooth that it slipped through a crack in time. It hasn\'t re-appeared yet but we expect it one of these days.','',26124),
(56284,'enUS','Greetings stranger. I am Silkmaster Tsai. Welcome to the ancient Imperial Silk Farm.$b$bThis farm dates back to some of the earliest dynasties of Pandaria, and each generation exceeds the last in quality of silk.','',26124),
(56285,'enUS','Your clothing appears as one well travelled. Quite an interesting look. I might use it in one of my future clothing lines. I shall call it:$b$b$pique.','',26124),
(56286,'enUS','The boots, no. The belt, oh very much no. The shirt, stunning, but not on you. We should get you a real cape. And perhaps a vest with a proper hero\'s cut.','',26124),
(56287,'enUS','You remind me of a young Master Goh, minus the girth.$b$BHe first came to me a farm boy dressed in rags but with a stylish stride to him that owned the look.$B$bTogether we made a clothing line that was all the rage in the east for at least two years.','',26124),
(56288,'enUS','Go away.','Go away.',26124),
(56289,'enUS','Leave me alone.','Leave me alone.',26124),
(56290,'enUS','What\'s the point anymore?','What\'s the point anymore?',26124),
(56291,'enUS','What do you want?','What do you want?',26124),
(56292,'enUS','Let me be.','Let me be.',26124),
(56293,'enUS','...','...',26124),
(56294,'enUS','Stop crowding me, everybody\'s always crowding around in this village. There\'s no space.','Stop crowding me, everybody\'s always crowding around in this village. There\'s no space.',26124),
(56295,'enUS','It\'s raining still. And freezing. At least we haven\'t had a typhoon lately.','It\'s raining still. And freezing. At least we haven\'t had a typhoon lately.',26124),
(56296,'enUS','Oh, bother.','Oh, bother.',26124),
(56297,'enUS','A banana in hand is worth than two in bush.','A banana in hand is worth than two in bush.',26124),
(56298,'enUS','Oh, great. An adventurer. Just what I needed.','Oh, great. An adventurer. Just what I needed.',26124),
(56299,'enUS','Not much of a day. Just right for not much of a life.','Not much of a day. Just right for not much of a life.',26124),
(56300,'enUS','A little rain never hurt anybody... yet.','A little rain never hurt anybody... yet.',26124),
(56301,'enUS','What day is it? Nobody tells me anything.','What day is it? Nobody tells me anything.',26124),
(56302,'enUS','Don\'t bother me.','Don\'t bother me.',26124),
(56303,'enUS','How could this happen to me? I\'m sick of this life.','How could this happen to me? I\'m sick of this life.',26124),
(56304,'enUS','Welcome aboard the Skyfire. You ready to chase down the end of the world?','',26124),
(56305,'enUS','We are the Alliance. We are always ready.','We are the Alliance. We are always ready.',26124),
(56306,'enUS','JUSTICE AND GLORY!','JUSTICE AND GLORY!',26124),
(56307,'enUS','OW!','',26124),
(56308,'enUS','OW! MY FACE!','',26124),
(56309,'enUS','BAD WORM! THAT\'S A BAD BAD BAD WORM!','',26124),
(56310,'enUS','Eat up big fella.','',26124),
(56311,'enUS','We are the Horde. We are always ready.','We are the Horde. We are always ready.',26124),
(56312,'enUS','The Twilight\'s Hammer is retreating! The temple is ours; fortify your positions within!','',26124),
(56313,'enUS','Ah, good to see you, my friend!$B$BHungry?','',26124),
(56314,'enUS','Hey, sorry about that bottle, by the way. It\'s actually better to keep all the old slime in there - it ages like a fine brew.','',26124),
(56315,'enUS','You can tell a lot about a designer in how they weave their fabric together. Yours has the look of function over pride.$b$bTightly sealed with mana infused right into the fabric. Impressive, though it could benefit from an artistic hand.','',26124),
(56316,'enUS','Master, I lost my torch.','Master, I lost my torch.',26124),
(56317,'enUS','','I hate incompetent raiders.',26124),
(56318,'enUS','','I still hate you.',26124),
(56319,'enUS','','Do you hate me? Good.',26124),
(56320,'enUS','','I hate mercy.',26124),
(56321,'enUS','','I didn\'t hate that.',26124),
(56322,'enUS','','I hate adventurers.',26124),
(56323,'enUS','','I hate... every one of you...',26124),
(56324,'enUS','','I hate you all!',26124),
(56325,'enUS','','I hate standing still.',26124),
(56326,'enUS','','Feel my hatred!',26124),
(56327,'enUS','','My hatred burns!',26124),
(56328,'enUS','','My hate will consume you!',26124),
(56329,'enUS','','I hate armor.',26124),
(56330,'enUS','','I hate martyrs.',26124),
(56331,'enUS','','How I HATE this place. My captors may be long-dead, but don\'t think I won\'t take it all out on you miserable treasure-hunters.',26124),
(56333,'enUS','The reeds of the Singing Pools are the hardest in all of the land, but they are as air before my mighty brow.','',26124),
(56334,'enUS','Many have tested my claim, and I yet stand proven.','',26124),
(56335,'enUS','Anybody out there?','',26124),
(56336,'enUS','Help!','',26124),
(56337,'enUS','A little help here?','',26124),
(56338,'enUS','It\'s dark in here!','',26124),
(56339,'enUS','Someone get me outta here!','',26124),
(56340,'enUS','Heeelllp!','',26124),
(56341,'enUS','Get me out of this barrel!','',26124),
(56342,'enUS','Can anybody hear me?','',26124),
(56343,'enUS','Our crafters build the finest wooden planks.  They would weather the most brutal of storms.  But they are as water before the storm of my crushing skull.','',26124),
(56344,'enUS','Nothing made by pandaren hands can withstand me.','',26124),
(56345,'enUS','Mothallus is defeated! Hurray for $p!','',26124),
(56346,'enUS','The beast has been defeated! Hurray!','',26124),
(56347,'enUS','Thanks!','',26124),
(56348,'enUS','I need a beer.','',26124),
(56349,'enUS','You have no idea how long I was in there.','',26124),
(56350,'enUS','Ach! The light... it hurts our eyes...','',26124),
(56351,'enUS','Better get out of here before he comes by again!','',26124),
(56352,'enUS','Finally!','',26124),
(56353,'enUS','Thank you, kind... OH NO, HERE HE COMES AGAIN!','',26124),
(56354,'enUS','I suppose there are worse fates than being stuck forever inside a beer barrel.','',26124),
(56355,'enUS','These are the densest stones across all of Shen-zin Su, yet they are as nothing before my mighty head.','',26124),
(56356,'enUS','Any who yet doubt my strength are simply foolish.','',26124),
(56357,'enUS','Surprise!','',26124),
(56358,'enUS','Thank you! I will try to break some of that silk shield off.','',26124),
(56359,'enUS','So sticky! I\'ll try to bring that moth down for you.','',26124),
(56360,'enUS','Thank you stranger!','',26124),
(56361,'enUS','There is only one thing to do.  I must smash it!  Once and for all, all shall know the power of my mighty brow.','',26124),
(56362,'enUS','Oh... my head... it hurts so badly!  I\'ve... the pillar must contain enormous power... perhaps stronger even than my brow...','',26124),
(56363,'enUS','This is magnificent!  I\'ve never seen craftsmanship so fine.','',26124),
(56364,'enUS','I\'m... I\'m just going to lie down a while... until this headache goes away.','',26124),
(56365,'enUS','%s gets absorbed into the Maw of Go\'rath','%s gets absorbed into the Maw of Go\'rath',26124),
(56366,'enUS','','They have broken our defenses... the very earth turns against us in Deathwing\'s name.',26124),
(56367,'enUS','','Alizabal skewers $n to the ground.',26124),
(56368,'enUS','See you on the other side, $n.','',26124),
(56369,'enUS','Mudmug, Li Li... follow me!','',26124),
(56370,'enUS','Li Li, Mudmug, wait up!','',26124),
(56371,'enUS','Li Li, wait up!','',26124),
(56372,'enUS','I\'d better catch up Mudmug.','',26124),
(56373,'enUS','','I\'m going ahead to see if there\'s anything I can do to help.',26124),
(56374,'enUS','','Uncle Chen, Mudmug! Race you there!',26124),
(56375,'enUS','','Hey, you old jerks! You left me behind!',26124),
(56376,'enUS','','Hey, you dumb old uncle! You left me behind!',26124),
(56377,'enUS','','See you there, Uncle Chen!',26124),
(56378,'enUS','The brewery\'s got a second entrance, over yonder.','',26124),
(56379,'enUS','I reckon I\'ll see you over there.','',26124),
(56380,'enUS','Where\'d those other two go? Did they leave me behind? Don\'t nobody care about Mudmug?','',26124),
(56381,'enUS','I suppose I\'ll be off then. You a-comin\', Li Li?','',26124),
(56382,'enUS','I suppose I\'ll be off then. You a-comin\', Chen?','',26124),
(56383,'enUS','','So... do any of you know where the hidden master lives?',26124),
(56384,'enUS','I\'m pretty sure that\'s why he\'s called the hidden master, Lin.','',26124),
(56385,'enUS','','Oh. Sorry.',26124),
(56386,'enUS','','So, where should we search first?',26124),
(56387,'enUS','I can try asking the streams for guidance...','',26124),
(56388,'enUS','Ask the streams? You\'re no elder, Ashyo. You\'re not even a jinyu grown yet. It would be a waste of your time.','',26124),
(56389,'enUS','Ken-Ken thinks we split up. Follow the four winds.','',26124),
(56390,'enUS','That\'s a much better idea, Ken-Ken. I volunteer to travel south, into the jungle.','',26124),
(56391,'enUS','I will follow the north wind.','',26124),
(56392,'enUS','Ken-Ken go chase east wind. Shortest walk.','',26124),
(56393,'enUS','','I... I suppose I\'ll go west, then.',26124),
(56394,'enUS','Very well. As the oldest and fattest among us, I will wait here for each of you to return.','',26124),
(56395,'enUS','Good luck, friends. Once we find the Hidden Master, we can continue our training.','',26124),
(56396,'enUS','Firelands on the Test Realm has been reserved for a special event.','',26124),
(56397,'enUS','Teleport to Shannox','Teleport to Shannox',26124),
(56398,'enUS','Teleport to Lord Rhyolith','Teleport to Lord Rhyolith',26124),
(56399,'enUS','Teleport to Beth\'tilac','Teleport to Beth\'tilac',26124),
(56400,'enUS','Teleport to Alysrazor','Teleport to Alysrazor',26124),
(56401,'enUS','Teleport to Baleroc','Teleport to Baleroc',26124),
(56402,'enUS','Teleport to Fandral','Teleport to Fandral',26124),
(56403,'enUS','Teleport to Ragnaros','Teleport to Ragnaros',26124),
(56404,'enUS','I am able to teleport you near any of the boss encounters here in Firelands.','',26124),
(56405,'enUS','The race to defeat the Firelands has begun!','',26124),
(56406,'enUS','Hello friend!  You\'re welcome to use my cart if you like.  It will take you to the Dai-Lo Farmstead.','',26124),
(56407,'enUS','Very well, $n. I will need your help making this beer.','',26124),
(56408,'enUS','When I yell out the names of ingredients, you throw them in the pot...','',26124),
(56409,'enUS','I am kidding!','',26124),
(56410,'enUS','I am the best brewer across three continents! I think I can handle this part.','',26124),
(56411,'enUS','Damn straight ya can!','',26124),
(56412,'enUS','If you wouldn\'t mind waiting, $n... this might take a long time.','',26124),
(56413,'enUS','','That DID take a long time!',26124),
(56414,'enUS','Mothallus approaches!','Mothallus approaches!',26124),
(56415,'enUS','Hello friend!  You\'re welcome to use my cart if you like.  It will take you to the Temple of Five Dawns.','',26124),
(56416,'enUS','You just won a kickin\' rad poster! Raise your hand in the air like you just don\'t care!','',26124),
(56417,'enUS','Shouldn\'t you be training, young $c?$B$BDiscipline your mind and body, and there is little that you cannot achieve.','',26124),
(56420,'enUS','My money\'s on Lam. Did you see him take down Chu during training last week?','',26124),
(56421,'enUS','That\'s where you\'re mistaken, friend. Zhou is as sturdy as an oak.','',26124),
(56422,'enUS','Zhou has the stamina of three men, so he can out-stay most opponents.','',26124),
(56423,'enUS','His stamina is nothing against Lam\'s strength.','',26124),
(56424,'enUS','He has the legs of an ox! Have you ever been kicked by him in training?','',26124),
(56427,'enUS','Four coppers on Zhou.','',26124),
(56428,'enUS','Raise you a keg of Stormstout Gold. It\'ll be your loss.','',26124),
(56429,'enUS','Silk farming is a dangerous business.','',26124),
(56430,'enUS','Your form is impeccable.','Your form is impeccable.',26124),
(56431,'enUS','Such skill for a new trainee.','Such skill for a new trainee.',26124),
(56432,'enUS','One day you will have to teach me your secrets.','One day you will have to teach me your secrets.',26124),
(56433,'enUS','That target didn\'t stand a chance.','That target didn\'t stand a chance.',26124),
(56434,'enUS','I hope the instructors saw that!','I hope the instructors saw that!',26124),
(56435,'enUS','You are bound for a great things, trainee.','You are bound for a great things, trainee.',26124),
(56436,'enUS','I must work as hard as you.','I must work as hard as you.',26124),
(56437,'enUS','I must train harder so I can be like you.','I must train harder so I can be like you.',26124),
(56438,'enUS','You are an honorable opponent.','You are an honorable opponent.',26124),
(56439,'enUS','Thank you for reminding me that I must train more diligently.','Thank you for reminding me that I must train more diligently.',26124),
(56440,'enUS','You fight honorably, friend.','You fight honorably, friend.',26124),
(56441,'enUS','My skills are no match for yours. I admit defeat.','My skills are no match for yours. I admit defeat.',26124),
(56442,'enUS','Your skills are too great. I yield.','Your skills are too great. I yield.',26124),
(56443,'enUS','You fought well. I must learn more from you in the future.','You fought well. I must learn more from you in the future.',26124),
(56444,'enUS','That was a good match. Thank you.','That was a good match. Thank you.',26124),
(56445,'enUS','I have never seen a trainee with skills such as yours. I must tell the others.','I have never seen a trainee with skills such as yours. I must tell the others.',26124),
(56446,'enUS','< PLACEHOLDER : You discover that the egg has hatched into Black Prince Wrathion! >','',26124),
(56447,'enUS','As you know, Black Dragons frequently disguise themselves as humanoids in order to tamper with mortal affairs.','',26124),
(56448,'enUS','While the house of my mad father collapses around him, the few remaining Black Dragons have gone into hiding.','',26124),
(56449,'enUS','But I can still sense them. My cowardly brothers and sisters will cause untold suffering if we allow them to stay in the shadows.','',26124),
(56450,'enUS','Moreover, they are a threat to me.','',26124),
(56451,'enUS','That\'s where you come in. Help us to slay them all, and I will reward you handsomely.','',26124),
(56452,'enUS','I couldn\'t have fought them off alone. Now, if you\'ll excuse me, I should go find my cart.','',26124),
(56453,'enUS','Cart!','',26124),
(56454,'enUS','Hello, cart. Still upside-downed, I see.','',26124),
(56455,'enUS','No mortal shall turn me from my task.','',26124),
(56456,'enUS','You seek to halt an avalanche. I will bury you.','',26124),
(56457,'enUS','You thought to fight me alone? The earth splits to swallow and crush you.','',26124),
(56458,'enUS','Impossible. This cannot be. The tower... must... fall...','',26124),
(56459,'enUS','I am unstoppable.','',26124),
(56460,'enUS','It was inevitable.','',26124),
(56461,'enUS','Ground to dust.','',26124),
(56462,'enUS','The stone calls...','',26124),
(56463,'enUS','The ground shakes...','',26124),
(56464,'enUS','A-ha ha! You are hopelessly outmatched!','',26124),
(56465,'enUS','The rocks tremble...','',26124),
(56466,'enUS','The surface quakes...','',26124),
(56467,'enUS','...and the black blood of the earth consumes you.','',26124),
(56468,'enUS','...and there is no escape from the Old Gods.','',26124),
(56469,'enUS','...and the rage of the true gods follows.','',26124),
(56470,'enUS','...and you drown in the hate of The Master.','',26124),
(56471,'enUS','Flee, and die.','',26124),
(56472,'enUS','Run, and perish.','',26124),
(56473,'enUS','Look out! Its friendses are coming!','',26124),
(56474,'enUS','Run away!','',26124),
(56475,'enUS','Cowards. Weaklings. Come down and fight, or I will bring you down.','',26124),
(56476,'enUS','You cannot hide in this temple forever, Shaman.','',26124),
(56477,'enUS','I will turn this tower to rubble, and scatter it across the wastes.','',26124),
(56478,'enUS','Wyrmrest will fall. All will be dust.','',26124),
(56479,'enUS','Your first target is here, in the ruins of Gilneas. I\'ve lost some of my best men already: let\'s see if you can fare any better.','',26124),
(56480,'enUS','If he succeeds in looting the whole of Gilneas, there\'s no telling where he\'ll hide next. Now is the time to strike.','',26124),
(56481,'enUS','The dragon you\'re looking for goes by the name \"Creed.\"','',26124),
(56482,'enUS','He\'s deluded a group of diseased humans into thinking they can take their land back. He\'s poisoned their blood with his own draconic essence.','',26124),
(56483,'enUS','The trainees will be quite disappointed if I don\'t get all of these kegs back together for them. What a mess...','',26124),
(56484,'enUS','You\'ve become strong indeed, child. This is good. You will need that strength soon.','',26124),
(56485,'enUS','And here we are. Help me with a couple small tasks while I prepare, if you would.','',26124),
(56486,'enUS','[Pending Cinematic] Aysa rushes towards the ship, only to find Ji running out to escape the coming explosion.','',26124),
(56487,'enUS','[Pending Cinematic] Ji holds Aysa back, not wanting her to get hurt.  She struggles and yells, fearful that Shen-zin Su will be irreparably healed, and angry that Ji would do something so rash without consulting her.','',26124),
(56488,'enUS','[Pending Cinematic] The ship explodes GLORIOUSLY.  Ji and Aysa are sent flying to the ground farther away, but are largely unhurt.','',26124),
(56489,'enUS','[Pending Cinematic] Both rise to look back at the hole where the ship had been.  A river of blood pours from the wound in Shen-zin Su.','',26124),
(56490,'enUS','Watch out! That\'s how our other 12 assassins got killed.','',26124),
(56491,'enUS','You see? They\'re wild animals in there!','',26124),
(56492,'enUS','Zazzo to the rescue! Keep trying...','',26124),
(56493,'enUS','It\'s okay, $n. I\'ve got you... this time.','',26124),
(56494,'enUS','Watch where you\'re going! They\'re everywhere in that city...','',26124),
(56495,'enUS','You call that sneaking?','',26124),
(56496,'enUS','One cannot simply FLY into Gilneas City!','',26124),
(56497,'enUS','Whoa whoa whoa - they\'ve got snipers on all the rooftops. You\'ll have to go in by foot!','',26124),
(56498,'enUS','You can\'t just fly in there - you\'ll be spotted for sure. Don\'t you think we\'ve already tried that?','',26124),
(56499,'enUS','Over here - an assassin!','Show yourself!',26124),
(56500,'enUS','Intruder!','Protect Lord Creed!',26124),
(56501,'enUS','Get $ghim:her;!','Take $ghim:her; out!',26124),
(56502,'enUS','What have we here?','I see you...',26124),
(56503,'enUS','Destroy $ghim:her;!','',26124),
(56504,'enUS','I can smell you, thief!','',26124),
(56505,'enUS','Die, assassin!','',26124),
(56506,'enUS','Mothallus ascends, free the Mothfighters from their cocoons so they can bring her down.','Mothallus ascends, free the Mothfighters from their cocoons so they can bring her down.',26124),
(56507,'enUS','Mothallus is down. Attack!','Mothallus is down. Attack!',26124),
(56508,'enUS','We will reclaim this world.','',26124),
(56509,'enUS','You will fail!','',26124),
(56510,'enUS','Your fragile minds are your greatest weakness.','',26124),
(56511,'enUS','Your world will end in darkness!','',26124),
(56512,'enUS','No...it cannot be...','',26124),
(56513,'enUS','I will return...','',26124),
(56514,'enUS','You cannot destroy us...','',26124),
(56515,'enUS','You cannot hope to stop us...','',26124),
(56516,'enUS','The light blinds me!','',26124),
(56517,'enUS','I cannot stand...this sound!','',26124),
(56518,'enUS','What have you done to me?','',26124),
(56519,'enUS','My powers are drained!','',26124),
(56520,'enUS','Assassin, eh? Who sent you? Speak, or I will carve the answer from your skull!','',26124),
(56521,'enUS','I will never forget the help you gave us or the shame you spared me, hero. Thank you!','',26124),
(56522,'enUS','You may continue your ritual, we will defend you.','You may continue your ritual, we will defend you.',26124),
(56523,'enUS','Heroes, we must place this burden on your shoulders once again.  You must protect us from Deathwing\'s forces while we imbue the Soul with the powers of the great Aspects of Azeroth.','',26124),
(56524,'enUS','Enjoy your tour of Pandaria\'s most ancient and respected silk farm.','',26124),
(56525,'enUS','When the silkworm makes its cocoon, we use this device to extract the silk.','',26124),
(56526,'enUS','We have spent generations perfecting just the right leaves for silkworm food.','',26124),
(56527,'enUS','Here we feed new silkworm larvae until they are ready to cocoon themselves.','',26124),
(56528,'enUS','Take me to the summit of Wyrmrest Temple to fight Ultraxion.','Take me to the summit of Wyrmrest Temple to fight Ultraxion.',26124),
(56529,'enUS','You made it! Creed\'s dark magic is disrupting my vision - you\'re on your own from here. Good luck!','',26124),
(56530,'enUS','','It is done! Our power now resides within the Dragon Soul! Our fate lies with you, Earth-Warder!',26124),
(56531,'enUS','Taretha...  Cairne...  Aggra...  I will not fail you.  I will not fail this world!','',26124),
(56532,'enUS','We toil day in and day out, and for what?$B$BThere\'s no point to any of it...','',26124),
(56533,'enUS','Huh? Wha?$B$BOh, I\'m awake again.$B$B<Sunni lets out a deep sigh.>$B$BEver since this rain started, I just don\'t feel like doing anything...','Huh? Wha?$B$BOh, I\'m awake again.$B$B<Sunni lets out a deep sigh.>$B$BEver since this rain started, I just don\'t feel like doing anything...',26124),
(56534,'enUS','I tire of this disguise. Now we finish this!','',26124),
(56535,'enUS','I don\'t know what\'s going on around here - it\'s like everyone has gone crazy!$B$BPlease, can you help?','I don\'t know what\'s going on around here - it\'s like everyone has gone crazy!$B$BPlease, can you help?',26124),
(56536,'enUS','Who... ordered... this?','',26124),
(56537,'enUS','You did it!! You\'re my hero, $n! Prince Wrathion will be delighted.','',26124),
(56538,'enUS','I looked into the eyes of The Dragon, and despaired...','',26124),
(56539,'enUS','Light be with you.','',26124),
(56540,'enUS','Let your faith guide you.','',26124),
(56541,'enUS','Witness my POWER!','',26124),
(56542,'enUS','The Light will consume you!','',26124),
(56543,'enUS','Drown in Shadow!','',26124),
(56544,'enUS','And YOU! We will FEAST on your ashes! Now, DIE!','',26124),
(56545,'enUS','|TInterface\\Icons\\spell_shadow_twilight.blp:20|t Ultraxion begins casting |cFF9900CC|Hspell:106371|h[Hour of Twilight]|h|r!','',26124),
(56546,'enUS','Hi there! Say, you weren\'t looking for a quick teleport to the big cannon, were you?$B$BBecause I can do that!$B$BFor a small fee, of course...','',26124),
(56547,'enUS','Say, nice shot!$B$BScared the fish, though.$B$BNeed a quick teleport back to the cannon?$B$BFor a small fee, of course...','',26124),
(56548,'enUS','Teleport me to the cannon.','Teleport me to the cannon.',26124),
(56549,'enUS','You feel hungry eyes upon you.','',26124),
(56550,'enUS','Aren\'t the thunderbirds beautiful? Majestic. Terrifying.$B$BThey are more worthy of this land than any of us.$B$BThis is where I shall wait. When they are ready, they will take me.','',26124),
(56551,'enUS','You\'re wasting your time.$B$BI\'m not going anywhere.','',26124),
(56552,'enUS','Please, Yi-Mo: your aunt\'s worried sick about you.','Please, Yi-Mo: your aunt\'s worried sick about you.',26124),
(56553,'enUS','I don\'t have time for this. Move your ass or I\'ll move it for you.','I don\'t have time for this. Move your ass or I\'ll move it for you.',26124),
(56554,'enUS','Excellent work, friend. You\'ve proven that a single skilled assassin can strike a decisive blow where a whole army may fail.','',26124),
(56555,'enUS','If you wish to continue our work, we will need some additional supplies...','',26124),
(56556,'enUS','Hmph! A lucky blow against an unprepared opponent.','',26124),
(56557,'enUS','You have your whole life ahead of you.','You have your whole life ahead of you.',26124),
(56558,'enUS','Is she REALLY worried about me? I doubt it...','',26124),
(56559,'enUS','What is life, anyway? A series of disappointments, one after another.','',26124),
(56560,'enUS','%s calls upon the |cFF9932CD|Hspell:104896|h[Purple]|h|r, |cFFFF0404|Hspell:104897|h[Red]|h|r, |cFFFFA901|Hspell:104901|h[Yellow]|h|r, and |cFF424242|Hspell:104894|h[Black]|h|r Bloods of Shu\'ma!','',26124),
(56561,'enUS','%s calls upon the |cFF9932CD|Hspell:104896|h[Purple]|h|r, |cFF088A08|Hspell:104898|h[Green]|h|r, |cFF424242|Hspell:104894|h[Black]|h|r, and |cFF0080FF|Hspell:104900|h[Blue]|h|r Bloods of Shu\'ma!','',26124),
(56562,'enUS','%s calls upon the |cFF088A08|Hspell:104898|h[Green]|h|r, |cFFFF0404|Hspell:104897|h[Red]|h|r, |cFF0080FF|Hspell:104900|h[Blue]|h|r, and |cFF424242|Hspell:104894|h[Black]|h|r Bloods of Shu\'ma!','',26124),
(56563,'enUS','%s calls upon the |cFF088A08|Hspell:104898|h[Green]|h|r, |cFFFFA901|Hspell:104901|h[Yellow]|h|r, |cFF424242|Hspell:104894|h[Black]|h|r, and |cFFFF0404|Hspell:104897|h[Red]|h|r Bloods of Shu\'ma!','',26124),
(56564,'enUS','%s calls upon the |cFF0080FF|Hspell:104900|h[Blue]|h|r, |cFF9932CD|Hspell:104896|h[Purple]|h|r, |cFF088A08|Hspell:104898|h[Green]|h|r, and |cFFFFA901|Hspell:104901|h[Yellow]|h|r Bloods of Shu\'ma!','',26124),
(56565,'enUS','%s calls upon the |cFF0080FF|Hspell:104900|h[Blue]|h|r, |cFF424242|Hspell:104894|h[Black]|h|r, |cFF9932CD|Hspell:104896|h[Purple]|h|r, and |cFFFFA901|Hspell:104901|h[Yellow]|h|r Bloods of Shu\'ma!','',26124),
(56566,'enUS','We\'ve just located her here, in the caverns beneath Karazhan. Fearful for her life, she is researching arcane secrets buried beneath the foundation.','',26124),
(56567,'enUS','She\'s surrounded herself with a small army of deranged dragon cultists. They may not by right in the head, but they\'re well-armed. And dangerous.','',26124),
(56568,'enUS','The gems you collected will be able to augment the power of the weapons I gave you, but I require another ingredient.  It will come from your next target.','',26124),
(56569,'enUS','Her name is \"Nalice.\" And until recently she stood at Wyrmrest Temple as the representative of the black dragonflight. Now? She\'s on the run.','',26124),
(56570,'enUS','I hope to see you back from this mission alive. But if I do not, I want to say I\'ve enjoyed seeing you work. You\'re a credit to your race. Good luck.','',26124),
(56571,'enUS','Ready to survey the land.','Ready to survey the land.',26124),
(56572,'enUS','','I hate resorting to violence.',26124),
(56573,'enUS','','I don\'t know who you are, but I\'ll defend this shrine with my life. Leave, now, before we come to blows.',26124),
(56574,'enUS','','I understand, now. Farewell, and good luck.',26124),
(56575,'enUS','','You forced my hand.',26124),
(56576,'enUS','','I didn\'t want to do that.',26124),
(56577,'enUS','','I wish you\'d surrendered.',26124),
(56578,'enUS','','Perhaps this will cool your heads...',26124),
(56579,'enUS','','A little ice ought to quench the fire in your hearts...',26124),
(56580,'enUS','','Why won\'t you give up?!',26124),
(56581,'enUS','We need to move quickly! Tyrygosa and her guard have fallen, leaving the temple defenseless. Deathwing\'s forces must never reach the Dragon Soul or all is lost. The Wyrmrest Accord will aid you in the assault; the siege must be broken!','',26124),
(56582,'enUS','I humbly request that the Dragon Aspects provide no aid to myself and my fellow adventurers. They should worry about their own problems, and we will worry about ours.','I humbly request that the Dragon Aspects provide no aid to myself and my fellow adventurers. They should worry about their own problems, and we will worry about ours.',26124),
(56583,'enUS','Fool!','You\'re not so clever, assassin.',26124),
(56584,'enUS','Terminate $ghim:her;.','Dirty sneak. You will be destroyed!',26124),
(56585,'enUS','You are either mad, foolhardy, or a hero worthy of being called legend. Which one are you?','',26124),
(56586,'enUS','We will become legend.','We will become legend.',26124),
(56587,'enUS','We shall see, $C.','',26124),
(56588,'enUS','Say what you want. I\'m not moving an inch.','',26124),
(56589,'enUS','I know, right?','',26124),
(56590,'enUS','You\'re going to have to pull out every trick you know in order to get in there.','',26124),
(56591,'enUS','Maybe it\'s your gear?','',26124),
(56592,'enUS','Wrathion believes in you. I know you can do this!','',26124),
(56593,'enUS','You can\'t fly and be stealthy at the same time.... I tried.','',26124),
(56594,'enUS','Success! Another corrupt dragon obliterated! Soon, none will stand but Deathwing himself...','',26124),
(56595,'enUS','You\'re in! Nalice has wards that negate my magic, so I won\'t be able to help you from here on out. Go get her!','',26124),
(56596,'enUS','','|TInterface\\Icons\\spell_fire_twilightflamebreath.blp:20|t%s prepares to unleash a |cFF9900CC|Hspell:106401|h[Twilight Onslaught]|h|r!',26124),
(56597,'enUS','Farewell, and good luck.','Farewell, and good luck.',26124),
(56598,'enUS','Such a foolish creature, trying to challenge us.  His rancid corpse will serve as a reminder to the Legion of the power of Illidan Stormrage.\n$bThe shadowcloak\'s magic is fading, concealing us no longer.  It was fun while it lasted, but I prefer a more direct approach to bringing death to my enemy.\n$bYou fought well, but where I\'m heading I need to go alone.','',26124),
(56599,'enUS','','Did I miss anything? Oh WOW!',26124),
(56600,'enUS','','Hey! Over here! No, down here! I can take you back to the present time, if you want.',26124),
(56601,'enUS','What you see now, $n, is your distant future. A future where Deathwing, the Twilight\'s Hammer, and the Old Gods that they serve have won. A barren, unchanging wasteland, inhabited only by the echoes of the past.','',26124),
(56602,'enUS','Yes, $n?','',26124),
(56603,'enUS','I\'m ready to travel back in time - to the Well of Eternity.','I\'m ready to travel back in time - to the Well of Eternity.',26124),
(56604,'enUS','','Greetings, $n.',26124),
(56605,'enUS','I am ready to help Thrall, back in my present time.','I am ready to help Thrall, back in my present time.',26124),
(56606,'enUS','I am ready to meet Nozdormu at the End Time.','I am ready to meet Nozdormu at the End Time.',26124),
(56607,'enUS','I am ready to meet Nozdormu at the End Time.','I am ready to meet Nozdormu at the End Time.',26124),
(56608,'enUS','','How can I be of aid, stranger?',26124),
(56609,'enUS','Stay by my side, $n. We may have need of one another.','',26124),
(56610,'enUS','It is done. The Dragon Soul is safely within the clutch of the dragonflights.','',26124),
(56613,'enUS','I\'m looking for a lost companion.','I\'m looking for a lost companion.',26124),
(56614,'enUS','','Even with the Aspect of Time on your side, you stumble foolishly into a trap?',26124),
(56615,'enUS','','Don\'t preen just yet, little pups. We\'ll cleanse this world of your kind.',26124),
(56616,'enUS','','You\'ll not leave this place alive!',26124),
(56617,'enUS','','Not one of you will live to see the final cataclysm! Finish them!',26124),
(56618,'enUS','The plates! He\'s coming apart! Tear up the plates and we\'ve got a shot at bringing him down!','',26124),
(56619,'enUS','Don\'t worry about me. Stop the Destroyer! Enshu-falah-nah, dorini.','',26124),
(56620,'enUS','','Malfurion...',26124),
(56621,'enUS','','By the very edge...',26124),
(56622,'enUS','','I do not know who you are, but I thank you. Without your aid, our world would be...I do not wish to think about it. Moon goddess light your path.',26124),
(56623,'enUS','Ha! I had not realized you fools were still there.','',26124),
(56624,'enUS','Your efforts are insignificant. I carry you to your deaths.','',26124),
(56625,'enUS','Cling while you can, \"heroes.\" You and your world are doomed.','',26124),
(56626,'enUS','Your tenacity is admirable, but pointless. You ride into the jaws of the apocalypse.','',26124),
(56627,'enUS','The War Serpent will not travel beyond the Jade Temple Grounds! Return before you are tossed off!','The War Serpent will not travel beyond the Jade Temple Grounds! Return before you are tossed off!',26124),
(56628,'enUS','He is heading to the maelstrom!  We must stop him NOW, we may never get another chance if he escapes into Deepholm.','',26124),
(56629,'enUS','Welcome aboard the Skyfire.  You ready to chase down the end of the world?','',26124),
(56630,'enUS','The artifact!','',26124),
(56631,'enUS','Brother. A timely arrival...','',26124),
(56632,'enUS','Aye. It\'s been twisted and turned by too many spells. The fuss we - especially you - made with the portal was too much! The same spell that sent the Burning Legion back into their foul realm now works on the well! It\'s devouring itself and taking its surroundings with it! Fascinating, isn\'t it?','',26124),
(56633,'enUS','If you\'ve a way out of here, we should probably use it! I\'ve tried casting myself and Tyrande out of here, but the well is too much in flux!','',26124),
(56634,'enUS','None may cross the Queen!','',26124),
(56635,'enUS','A deserved death!','',26124),
(56636,'enUS','In Azshara\'s name!','',26124),
(56637,'enUS','Hush, Tyrande. Where is Illidan?','',26124),
(56638,'enUS','Illidan! The well is out of control!','',26124),
(56639,'enUS','Not if we\'re caught up in it! Why weren\'t you running? What have you been doing with your hand in the Well?','',26124),
(56640,'enUS','This way!','',26124),
(56641,'enUS','Fall and DIE before me!','',26124),
(56642,'enUS','SQUIRM! SCREAM!','',26124),
(56643,'enUS','Useless!','',26124),
(56644,'enUS','[Demonic] Amanare maev il azgalada zila ashj ashj zila enkil!','',26124),
(56645,'enUS','','We\'ve gathered up some items from this time period. I hope this helps!',26124),
(56646,'enUS','Twisting your pitiful whelps into mindless abominations, bent only to my will. It was a very... painful process.','',26124),
(56647,'enUS','Nefarian, Onyxia, Sinestra... they were nothing. Now you face my ultimate creation.','',26124),
(56648,'enUS','The Hour of Twilight is nigh; the sun sets on your pitiful mortal existence.','',26124),
(56649,'enUS','Let\'s load these barrels up into the cart, shall we?','',26124),
(56650,'enUS','Onward to the Stormstout Brewery!','',26124),
(56651,'enUS','','So long, Halfhill!',26124),
(56652,'enUS','Mudmug, are you coming?','',26124),
(56653,'enUS','Oh, I dunno. This kinda seems like a family thing you\'re doin\'...','',26124),
(56654,'enUS','It IS a family thing, Mudmug. And I want you to join us.','',26124),
(56655,'enUS','No foolin\'?','',26124),
(56656,'enUS','Of course not! We brewed beer together. That practically makes us brothers.','',26124),
(56657,'enUS','Y-yeah! Beer brothers!','',26124),
(56658,'enUS','','Ugh! You guys are gonna make me throw up.',26124),
(56659,'enUS','Come on, help me pull this cart.','',26124),
(56660,'enUS','','Is this the fastest you can go? Come on, fatsos! Move those legs!',26124),
(56661,'enUS','Very well, I will put my belly into it...','',26124),
(56662,'enUS','See you there, $n!','',26124),
(56663,'enUS','','Seriously though, Mudmug. Don\'t be dumb.',26124),
(56664,'enUS','Not necessarily. I believe...yes...it just might work.','',26124),
(56665,'enUS','Then I will open the way into the Eye of Eternity. You must not fail, heroes. The future of Azeroth hinges on your actions.','',26124),
(56666,'enUS','It is no use, the power of the Dragon Soul is too great. I cannot wield it safely; the raging forces contained within it may be the doom of us all.','',26124),
(56667,'enUS','Yes, I see.  We can finally turn Deathwing\'s own power back against him.','',26124),
(56668,'enUS','','Then truly, we are lost.',26124),
(56669,'enUS','','I sense danger...it is a trap...carefully laid for us at this crucial moment.',26124),
(56670,'enUS','We have no choice.  We must have faith in our allies.','',26124),
(56671,'enUS','At last! A challenge! Let us test your mettle, \"champion\".','',26124),
(56672,'enUS','Have you come to supplicate yourself before the Light? Or perhaps you have come here to train in the holy arts?$b$bIf you are here to speak with Archbishop Benedictus, I am sorry to inform you that he has left on a mission.','',26124),
(56673,'enUS','Yes. He has been called upon to help the aspects with their efforts at Wyrmrest. He wishes to aid them in cleansing Azeroth of Deathwing\'s menace.$b$bMay the Light guide his path.','',26124),
(56674,'enUS','Ha hah hah! Benedictus, the Twilight Prophet!$b$bBwa ha ha ha!$b$bOh, that\'s a good one. Hoo-ee.','',26124),
(56675,'enUS','Rumors, child. Rumors have a way of attaching themselves to people of power. In fact, I recently heard a particularly nasty one about the late lord Bolvar.$b$bI will ask you to spread your lies elsewhere. Return when you are ready to confess your wrongs before the Light.','',26124),
(56676,'enUS','A mission?','A mission?',26124),
(56677,'enUS','Actually, I saw Benedictus at Wyrmrest. He was the Twilight Prophet.','Actually, I saw Benedictus at Wyrmrest. He was the Twilight Prophet.',26124),
(56678,'enUS','I\'m serious. Benedictus tried to kill Thrall and deliver Azeroth to Deathwing. I saw it with my own eyes.','I\'m serious. Benedictus tried to kill Thrall and deliver Azeroth to Deathwing. I saw it with my own eyes.',26124),
(56679,'enUS','Our serpents are working hard to save the temple.$B$BThey will gladly lend their strength if you require it.','',26124),
(56680,'enUS','Never have I seen an enemy such as this.','',26124),
(56681,'enUS','This is our land. Our home.$B$BI will not see it fall to the sha.','',26124),
(56682,'enUS','Despite our efforts to become enlightened beings, we have repeated the mistakes of our past.$B$BThe sha threaten this land once again.','',26124),
(56683,'enUS','We cannot dwell on the mistakes of the past, $r.$B$BThe only path is forward.','',26124),
(56684,'enUS','','Gather your courage, $r. Together, we can resist the sha.',26124),
(56685,'enUS','','When the sha attack began, every one of my students ran to battle without hesitation.$B$BI have taught them much, but yet they continue to surpass my expectations.',26124),
(56686,'enUS','','Much of our knowledge of the sha has been lost through time.$B$BWhile the battle continues, I must study their nature.$B$BOnly then can we prevent this from happening again in the future.',26124),
(56688,'enUS','','Have you come to observe my class?',26124),
(56690,'enUS','','Welcome, traveler. Please stay a while and rest.',26124),
(56691,'enUS','','As long as the sha stay outside, I\'ll be fine.',26124),
(56692,'enUS','Our fighters need nutritious food to keep our enemies at bay!$B$BHurry up and tell me what I can get for you.','',26124),
(56693,'enUS','You look like you could use a hot meal.$B$BWhat can I get for you?','',26124),
(56694,'enUS','','Praise the Titans, they have returned!',26124),
(56695,'enUS','Not entirely unexpected.','',26124),
(56696,'enUS','Excellent! We will begin the ritual at once!','',26124),
(56697,'enUS','','Huh! Looks like they\'re closed.',26124),
(56698,'enUS','Yes, strange. This door was not here before.','',26124),
(56699,'enUS','','The ritual will take much from us, as it requires a very piece of our being. We will be weakened greatly.',26124),
(56700,'enUS','Y\'all think they\'re hidin\' something inside?','',26124),
(56701,'enUS','We will find out.','',26124),
(56702,'enUS','I don\'t think breweries are supposed to make that sound...','',26124),
(56703,'enUS','Heroes, this burden falls to you once again.','',26124),
(56704,'enUS','','Umm... guys...',26124),
(56705,'enUS','Settle down, Li Li. You know that I hate to be interrupted while I\'m knocking on doors.','',26124),
(56706,'enUS','Chen! It\'s a giant dang ol\' hozen!','',26124),
(56707,'enUS','Who crashing Ook party!? Ook ook ook...','',26124),
(56708,'enUS','Hozen attack!','',26124),
(56709,'enUS','Heroes, have you succeeded in acquiring the Focusing Iris?','',26124),
(56710,'enUS','Hold on, I will break you out of those barrels.','',26124),
(56711,'enUS','We were successful, Kalecgos.','We were successful, Kalecgos.',26124),
(56712,'enUS','','Stand your ground, defenders! Do not let them pass!',26124),
(56713,'enUS','','Steel yourselves! More of them approach!',26124),
(56714,'enUS','','Send them back to the wastelands of their world, champions!',26124),
(56715,'enUS','','If we surrender now, the entire temple will fall!',26124),
(56716,'enUS','','Push forward, defenders!',26124),
(56717,'enUS','','Hold steady, everyone. One step forward is all we need.',26124),
(56718,'enUS','','Do not give up hope, friends!',26124),
(56719,'enUS','','Tomorrow, they will sing our praises, but only if we are victorious today.',26124),
(56720,'enUS','|TInterface\\Icons\\inv_stave_2h_deathwingraiddw_d_01.blp:20|t%s falls forward, get to |cFF04FC32Ysera\'s|r platform!','',26124),
(56721,'enUS','Stormstouts, open up! I have returned. And I brought beer!','',26124),
(56722,'enUS','%s begins to impale the Aspect! Stop it!','',26124),
(56723,'enUS','You must protect us from Deathwing\'s forces while we imbue the Dragon Soul with the power of the Aspects.','',26124),
(56724,'enUS','Speak to me when you are ready to begin.','',26124),
(56725,'enUS','','Be at peace, child.',26124),
(56726,'enUS','','Your sacrifice will not be forgotten.',26124),
(56727,'enUS','','Deathwing will pay for this.',26124),
(56728,'enUS','Incredible! Few assassins would be clever enough to infiltrate Nalice\'s wards and use her own magic against her.','',26124),
(56729,'enUS','Perhaps. For that reason, we will need to gather more supplies...','',26124),
(56730,'enUS','She allowed herself to be defeated. The others will not be so weak.','',26124),
(56731,'enUS','Teleportation to the cannon will cost:','Teleportation to the cannon will cost:',26124),
(56732,'enUS','I don\'t need a teleport.','I don\'t need a teleport.',26124),
(56733,'enUS','The Focusing Iris within the Eye of Eternity may allow us to converge the magical matrix contained within the Dragon Soul.','',26124),
(56734,'enUS','Succeed here, and our work is nearly done. Good luck, hero!','',26124),
(56735,'enUS','There\'s no need to worry, Fahrad. This next mission is ... quite likely ... suicide.','',26124),
(56736,'enUS','Don\'t trust this one, your highness - no one is that good.','',26124),
(56737,'enUS','Aspects! Aid the heroes as best you can!','',26124),
(56738,'enUS','Avenge the fallen! Continue the fight!','',26124),
(56739,'enUS','That apprentice of yours ran off with my daughter again.','',26124),
(56740,'enUS','','You must hurry... Wyrmrest falls as we speak... all... is lost...',26124),
(56741,'enUS','','Thank you, sisters, I am renewed.',26124),
(56742,'enUS','','The Old Gods have shown themselves - a tide of darkness sweeps from their gaping maws towards the temple. We MUST buy the aspects more time.',26124),
(56743,'enUS','','The faceless generals, Zon\'ozz and Yor\'sahj, command the enemy legions from within the monstrosities you see on the horizon.',26124),
(56744,'enUS','','You must strike them down if we are to survive long enough to end this. Take flight on the wings of my sisters, they will transport you as close as they dare!',26124),
(56745,'enUS','','A single general remains. You must make haste!',26124),
(56746,'enUS','','The flow of darkness abates. It seems you truly are the heroes of legend.',26124),
(56747,'enUS','','The Aspects have already gathered and await your arrival. Go now!',26124),
(56748,'enUS','Roll Yi-Mo towards Zhu\'s Watch!','Roll Yi-Mo towards Zhu\'s Watch!',26124),
(56749,'enUS','Lovers do what lovers will. He\'s a good boy.','',26124),
(56750,'enUS','I\'ll not hear it! He\'s a Wanderbrew and she\'s a Goldendraft. Return my daughter or I\'ll make sure no one gives you work for a month.','',26124),
(56751,'enUS','Well done! I will realign the flow of mana and fill the Dragon Soul with all my arcane might.','',26124),
(56752,'enUS','I will charge you with arcane energy to blast your foes.','',26124),
(56753,'enUS','Is he... coming apart?','',26124),
(56754,'enUS','Vwyq agth sshoq\'meg N\'Zoth vra zz shfk qwor ga\'halahs agthu. Uulg\'ma, ag qam.','',26124),
(56755,'enUS','Once more shall the twisted flesh-banners of N\'Zoth chitter and howl above the fly-blown corpse of this world. After millennia, we have returned.','',26124),
(56756,'enUS','Zzof Shuul\'wah. Thoq fssh N\'Zoth!','',26124),
(56757,'enUS','Victory for Deathwing. For the glory of N\'Zoth!','',26124),
(56758,'enUS','Everyone around me only pretends to like me.','Everyone around me only pretends to like me.',26124),
(56759,'enUS','Does this armor look a little tight on me?','Does this armor look a little tight on me?',26124),
(56760,'enUS','Of course my worst fears are going to come true.','Of course my worst fears are going to come true.',26124),
(56761,'enUS','What are people saying about me?','What are people saying about me?',26124),
(56762,'enUS','I keep hearing voices in my head. Should I be worried?','I keep hearing voices in my head. Should I be worried?',26124),
(56763,'enUS','Nothing is ever going to change.','Nothing is ever going to change.',26124),
(56764,'enUS','Uovssh thyzz... qwaz...','',26124),
(56765,'enUS','To have waited so long... for this...','',26124),
(56766,'enUS','Why do I try so hard? It\'s all meaningless in the end...','Why do I try so hard? It\'s all meaningless in the end...',26124),
(56767,'enUS','Why do I always feel so alone? Is it because...I\'m alone?','Why do I always feel so alone? Is it because...I\'m alone?',26124),
(56768,'enUS','My family has stood as the greatest brewmasters of the Jade Forest for generations.$b$bUnlike those filthy travelling Wanderbrews. Peasant brews, that\'s what they make.','',26124),
(56769,'enUS','It is time. I will expend everything to bind every thread here, now, around the Dragon Soul. What comes to pass will NEVER be undone.','',26124),
(56770,'enUS','Press the attack, heroes.','',26124),
(56771,'enUS','Before you is the Cache of the Aspects: Take from it what you will, for you have more than earned the right.','Before you is the Cache of the Aspects: Take from it what you will, for you have more than earned the right.',26124),
(56772,'enUS','I will cleanse whatever corruption I can; my fire will not harm you.','I will cleanse whatever corruption I can; my fire will not harm you.',26124),
(56773,'enUS','Excellent work. The fire of my heart glows with a brilliant purity unmatched; every spark of it I will channel into the Dragon Soul.','Excellent work. The fire of my heart glows with a brilliant purity unmatched; every spark of it I will channel into the Dragon Soul.',26124),
(56774,'enUS','He\'s completely mad!','He\'s completely mad!',26124),
(56775,'enUS','We are one step closer. The unknowable, transcendent power of the Emerald Dream I now give unto the Dragon Soul.','',26124),
(56776,'enUS','I will bring you closer to the Emerald Dream. Seek safety there when the fight becomes too intense.','',26124),
(56777,'enUS','Such rage I have never seen...','',26124),
(56778,'enUS','Sk\'tek agth nuq N\'Zoth yyqzz.','',26124),
(56779,'enUS','Your skulls shall adorn N\'Zoth\'s writhing throne.','',26124),
(56780,'enUS','Sk\'yahf agth huqth N\'Zoth qornaus.','',26124),
(56781,'enUS','Deathwing is conjuring the final Cataclysm; even the Emerald Dream trembles. If we are to stop the spell, we must attack him together.','',26124),
(56782,'enUS','Your souls shall sate N\'Zoth\'s endless hunger.','',26124),
(56783,'enUS','Sk\'shuul agth vorzz N\'Zoth naggwa\'fssh.','',26124),
(56784,'enUS','Your deaths shall sing of N\'Zoth\'s unending glory.','',26124),
(56785,'enUS','Gul\'kafh an\'qov N\'Zoth.','',26124),
(56786,'enUS','Gaze into the heart of N\'Zoth.','',26124),
(56787,'enUS','N\'Zoth ga zyqtahg iilth.','',26124),
(56788,'enUS','The will of N\'Zoth corrupts you.','',26124),
(56789,'enUS','Sk\'magg yawifk hoq.','',26124),
(56790,'enUS','Your suffering strengthens me.','',26124),
(56791,'enUS','','Thank you for the masks, $n. Be at peace and take this blessing as a token of our thanks.',26124),
(56792,'enUS','','My poor Lo. He tried so hard to earn the respect of the pandriarchs. It was the only honorable solution we could think of to bypass our family feuds.',26124),
(56793,'enUS','Nice fightin\'... real hero-like. Y\'all should check in with Li Li, up ahead.','',26124),
(56794,'enUS','That\'s all the fightin\' there is to be done, I reckon. Let\'s get up out of here, and meet up with Chen and Li Li.','',26124),
(56795,'enUS','Sk\'uuyat guulphg hoq.','',26124),
(56796,'enUS','','Uncle Chen\'s waiting up ahead. You go find him... I\'ll stay here and mock this unconscious monkey.',26124),
(56797,'enUS','','I think we\'re all done! Let\'s meet up with those two oafs at the brewery\'s back entrance.',26124),
(56798,'enUS','Your agony sustains me.','',26124),
(56799,'enUS','Sk\'shgn eqnizz hoq.','',26124),
(56800,'enUS','Your fear drives me.','',26124),
(56801,'enUS','','Not so tough now, are you? That\'s right. You look so dumb there laying on the ground. Don\'t make me make $p throw more barrels at you.',26124),
(56802,'enUS','Ak\'agthshi ma uhnish, ak\'uq shg\'cul vwahuhn! H\'iwn iggksh Phquathi gag OOU KAAXTH SHUUL!','',26124),
(56803,'enUS','Our numbers are endless, our power beyond reckoning! All who oppose the Destroyer will DIE A THOUSAND DEATHS!','',26124),
(56804,'enUS','Iilth qi\'uothk shn\'ma yeh\'glu Shath\'Yar! H\'IWN IILTH!','',26124),
(56805,'enUS','You will drown in the blood of the Old Gods! ALL OF YOU!','',26124),
(56806,'enUS','Ez, Shuul\'wah! Sk\'woth\'gl yu\'gaz yoh\'ghyl iilth!','',26124),
(56807,'enUS','I\'m going to wring some of this beer out of my clothes. You go on ahead, find Mudmug.','',26124),
(56808,'enUS','O, Deathwing! Your faithful servant has failed you!','',26124),
(56809,'enUS','Sk\'yahf qi\'plahf PH\'MAGG!','',26124),
(56810,'enUS','Your soul will know ENDLESS TORMENT!','',26124),
(56811,'enUS','H\'iwn zaix Shuul\'wah, PHQUATHI!','',26124),
(56812,'enUS','All praise Deathwing, THE DESTROYER!','',26124),
(56813,'enUS','I think we\'ve done enough damage for one day. Let\'s meet up with the other two, at the brewery\'s rear entrance.','',26124),
(56814,'enUS','Shkul an\'zig qvsakf KSSH\'GA, ag\'THYZAK agthu!','',26124),
(56815,'enUS','From its BLEAKEST DEPTHS, we RECLAIM this world!','',26124),
(56816,'enUS','KYTH ag\'xig yyg\'far IIQAATH ONGG!','',26124),
(56817,'enUS','SEE how we pour from the CURSED EARTH!','',26124),
(56818,'enUS','UULL lwhuk H\'IWN!','',26124),
(56819,'enUS','The DARKNESS devours ALL!','',26124),
(56820,'enUS','Awtgsshu LWHUK iilth!','',26124),
(56821,'enUS','Corruption CONSUMES you!','',26124),
(56822,'enUS','They... they agreed?! Fantastic! Thank you so much! With their blessing we can be the happiest pandaren in all the land!','',26124),
(56823,'enUS','','Oh thank you hero! You have given us a great gift!',26124),
(56824,'enUS','Be careful! They may be dead, but the pandriarchs are still dangerous.','',26124),
(56825,'enUS','','One thing I have learned from the sha. They know how to prey on our weaknesses.',26124),
(56826,'enUS','','The sha are right about one thing.$B$BOur greatest enemies are often ourselves.$B$BI just wish I weren\'t such a formidable opponent.',26124),
(56829,'enUS','Your eyes do not deceive you. The treacherous red dragonflight sought to kill me off. I hope now you see the truth about them.','',26124),
(56830,'enUS','I smell something....','',26124),
(56831,'enUS','','Yes, hero?',26124),
(56832,'enUS','You\'re of the bronze flight, you know what happens next! Can you just skip us ahead to all the real action?','You\'re of the bronze flight, you know what happens next! Can you just skip us ahead to all the real action?',26124),
(56833,'enUS','','Do not ask for mercy, after such an act.',26124),
(56834,'enUS','','If you intend to play the fool, you may as well look the part.',26124),
(56835,'enUS','If you live through this... I assure you it will be worth it.','',26124),
(56836,'enUS','That\'s right, mortal. The prize you seek no longer sleeps within a shell. Here I am: in the flesh.','',26124),
(56837,'enUS','I\'m not some trophy for a red dragon\'s mantle-piece, and I\'m never going back.','',26124),
(56838,'enUS','Don\'t look so surprised! We dragons are conscious, even within our shells. As I grew, I could hear the plotting and scheming. I was to be born a prisoner.','',26124),
(56839,'enUS','But I\'m one-of-a-kind! A black dragon raised free from the taint of my father\'s corruption. And that\'s how I intend to stay: free.','',26124),
(56840,'enUS','Somehow, you managed to elude all of my guards. You slipped in here like a ghost. That makes you... valuable to me. Let\'s talk.','',26124),
(56841,'enUS','You don\'t recognize your former prisoner?','',26124),
(56842,'enUS','No. I want him to deliver a message to the red dragonflight.','',26124),
(56843,'enUS','Tell them that I am free of my father\'s madness, and I will be free of them as well. I am to be left alone: this will be my first and only warning.','',26124),
(56844,'enUS','Deathwing\'s minions should be afraid of ME. Get him out of here.','',26124),
(56845,'enUS','And Fahrad?','',26124),
(56846,'enUS','Break his legs.','',26124),
(56847,'enUS','Now then, my new friend. We have much to talk about.','',26124),
(56848,'enUS','Your highness, we caught this beast snooping around the caves just outside the compound.','',26124),
(56849,'enUS','Shall we execute him, my prince?','',26124),
(56850,'enUS','Yes sir?','',26124),
(56853,'enUS','Don\'t give up, thunderbirds! Come back for me!','',26124),
(56854,'enUS','I can feel it... As if a dark shadow has been lifted from the land. Dead! My father is dead!','',26124),
(56855,'enUS','Champion, you have your reward. But there is one final dragon we need to slay.','',26124),
(56856,'enUS','Fahrad! I was just talking about you. The final Black Dragon. The one who\'s been more hidden than any of them.','',26124),
(56857,'enUS','Curious weapons you wield... such power.','',26124),
(56858,'enUS','Yes. You rescued me while I was still within my egg, and I owe you my life.','',26124),
(56859,'enUS','But you are a Black Dragon. And you share the corruption of all my brothers and sisters.','',26124),
(56860,'enUS','Do you deny it? The dark visions? The voices in your head?','',26124),
(56861,'enUS','And what are they telling you now, Fahrad? What do your dark masters whisper?','',26124),
(56862,'enUS','I will NEVER be controlled! The Red Dragonflight has no idea what they unleashed when they experimented on my egg.','',26124),
(56863,'enUS','Hero... strike now! Use your newfound power to FINISH HIM.','',26124),
(56864,'enUS','It is done, friend. To my knowledge, I am the only black dragon who remains.','',26124),
(56865,'enUS','A new age for mortals has dawned, and heroes like you are among the vanguard.','',26124),
(56866,'enUS','I must go now - disappear.','',26124),
(56867,'enUS','Perhaps we will meet again. I hope we find ourselves on the same side...','',26124),
(56868,'enUS','Nooooo!','',26124),
(56869,'enUS','You seem prepared.','',26124),
(56870,'enUS','','Stand upon this disc, $p. Kalecgos approaches!',26124),
(56871,'enUS','My Prince, we should leave this place, in case they come back to finish the job.','',26124),
(56872,'enUS','Your highness. I have never tried to conceal what I am from you.','',26124),
(56873,'enUS','That\'s - not true!','',26124),
(56874,'enUS','No, No! I\'m in control of the voices. They\'re here to help me.','',26124),
(56875,'enUS','Kill... they want me to kill you now... oh, why did you have to go and anger them?','',26124),
(56876,'enUS','You have proven too difficult to control!','',26124),
(56878,'enUS','','|TInterface\\Icons\\inv_weapon_shortblade_45.blp:20|t%s begins to cast |cFF9900CC|Hspell:109887|h[Arcane Infused Weapon]|h|r! Avoid her attacks!',26124),
(56879,'enUS','','|TInterface\\Icons\\ability_warrior_riposte:20|t%s begins to cast |cFF9900CC|Hspell:109893|h[Arcane Infused Armor]|h|r! Expose her armor!',26124),
(56880,'enUS','','|TInterface\\Icons\\spell_arcane_arcaneresilience.blp:20|t%s begins to cast |cFFFF0000|Hspell:109807|h[Arcane Destruction]|h|r! Activate the pillars to stop her!',26124),
(56881,'enUS','You ready to do this? I\'m ready to do this. I\'m fixin\' to make a puddle out of that critter.$b$bIt\'s just... well, I ain\'t much of a bruiser, and I get skeered real easy. You\'re the $c here. You gonna... you gonna protect me, right?','',26124),
(56882,'enUS','Alright! Let\'s go smush that water varmint!','',26124),
(56883,'enUS','','This guy\'s a little bigger than I thought he\'d be.$b$bYou think it\'s from drinking beer? I know too much beer makes you fat, like Uncle Chen, but I didn\'t think it\'d make you any taller.$b$bEither way, I don\'t think I can take this guy on alone.',26124),
(56884,'enUS','','Good! Maybe this time, WE can be the barrel-throwing jerks!',26124),
(56885,'enUS','What is going on inside this brewery!? Has nobody maintained this place? Where are the brewers?$b$bWhere is my family...?$b$bThey must have gone somewhere. If they were here, then they\'d be cleaning up this mess! For now, looks like it\'s up to you and me, $n. You ready?','',26124),
(56886,'enUS','Stormstout!','',26124),
(56887,'enUS','Don\'t stop now.$B$BYou still have time left to play!','Don\'t stop now.$B$BYou still have time left to play!',26124),
(56888,'enUS','Calm down, Mudmug. Let\'s go.','Calm down, Mudmug. Let\'s go.',26124),
(56889,'enUS','I\'ll help.','I\'ll help.',26124),
(56890,'enUS','Let\'s do this, Chen.','Let\'s do this, Chen.',26124),
(56891,'enUS','Please stay out of the gaming area.','Please stay out of the gaming area.',26124),
(56892,'enUS','Hold them off! Protect the archers!','',26124),
(56893,'enUS','With the loss of my power, the Dragon Soul has returned to its original place in time.','',26124),
(56894,'enUS','There goes the BOOM!','',26124),
(56895,'enUS','','An assassin! Did the little whelpling send you after me? Come, rogue. Let\'s dance.',26124),
(56896,'enUS','','I\'ve got some secrets of my own, rogue.',26124),
(56897,'enUS','','I... I need more time!',26124),
(56898,'enUS','','This isn\'t how it ends. Not for me. I\'m a survivor.',26124),
(56899,'enUS','','You cling to a shattered world... Your time comes... soon enough...',26124),
(56900,'enUS','Lady luck is on my side tonight!','Lady luck is on my side tonight!',26124),
(56901,'enUS','Ken-Ken met a few pandaren in his time. He tell you something: they NOT sads.$B$BNow, look at this place! Sad, mopey-dopeys sulking around everywhere.$B$BWhere\'s song and dance? Where\'s piles of food?$B$BWhere\'s BOOZE, man?!','',26124),
(56902,'enUS','Double or nothing!','Double or nothing!',26124),
(56903,'enUS','Snake eyes...','Snake eyes...',26124),
(56904,'enUS','You should help Mei.$B$BKen-Ken trying to think of way to cheer up these super-sads.','',26124),
(56905,'enUS','All these sad pandas making Ken-Ken a sad hozen.','',26124),
(56906,'enUS','Lazy mutts!','',26124),
(56907,'enUS','Get on with it!','Get on with it!',26124),
(56908,'enUS','I\'ve seen cats that are better guards than you!','',26124),
(56909,'enUS','You would make better rugs!','',26124),
(56910,'enUS','You\'ve sniffed every inch of this city.','You\'ve sniffed every inch of this city.',26124),
(56911,'enUS','Anytime now...','Anytime now...',26124),
(56912,'enUS','Just pick a spot already!','Just pick a spot already!',26124),
(56913,'enUS','Sniff \'em out!','Sniff \'em out!',26124),
(56914,'enUS','The Arcane Storage Unit begins to overload. Step back!','',26124),
(56915,'enUS','The bell is recharged! Strike it to weaken nearby enemies!','The bell is recharged! Strike it to weaken nearby enemies!',26124),
(56916,'enUS','%s has buffed $t!','%s has buffed $n!',26124),
(56917,'enUS','Greetings, traveller. I had not thought to see a friendly Horde face on these shores.','',26124),
(56918,'enUS','I feel the call of the Light, far to the north of here. But this place...$b$bIt has not known the light for many, many generations.','',26124),
(56919,'enUS','Ah, $p! These \"sunwalkers\" may not be the Hidden Master, but their fighting style is unlike anything I have ever seen.$b$bI intend to learn from them.','',26124),
(56920,'enUS','Be Gone.','',26124),
(56921,'enUS','We followed Leza\'s visions of the light to this place like moths to a flame.','',26124),
(56922,'enUS','Alliance to our south, mogu to our east and west, and cliffs to the north. We are hemmed in on all sides.','',26124),
(56923,'enUS','I almost prefer the cold bite of Northrend to this appalling soggy heat. It\'s as if the trees themselves are trying to suffocate us.','',26124),
(56924,'enUS','Dezco is a great chieftan, though I\'m beginning to doubt how well we can survive in this land he led us to.','Dezco is a great chieftan, though I\'m beginning to doubt how well we can survive in this land he led us to.',26124),
(56925,'enUS','This is a strange land. So beautiful. And yet so deadly.','This is a strange land. So beautiful. And yet so deadly.',26124),
(56926,'enUS','I thought I saw eyes in the underbrush...','I thought I saw eyes in the underbrush...',26124),
(56927,'enUS','','When that day comes, seek all the light and wonder of this world, and fight.',26124),
(56928,'enUS','','We live together, or we die together. All of Pandaria is connected.',26124),
(56929,'enUS','','Welcome to the jungle, $r! Nesingwary dispatched me to gather info on the wildlife down here.$b$bFeel like lending a hand?',26124),
(56930,'enUS','Un... provoked. The mogu attacked and... everything going dark...','',26124),
(56931,'enUS','','For the Alliance!',26124),
(56932,'enUS','','The horde is here?!',26124),
(56933,'enUS','','The horde shall not defile this land!',26124),
(56934,'enUS','','Thanks for the help friend. If you see Nesingwary and his boy to the west tell them how many things we killed. They like hearing that.',26124),
(56935,'enUS','','Citizens of Stormwind, rejoice! Deathwing is no more! The Cataclysm is over! A band of valiant heroes lashed out at the Destroyer with deadly precision and overwhelming might, granting the Dragon Aspects the opportunity to sacrifice their powers into one final strike. The last remains of Deathwing now reside here in Stormwind to serve as a beacon of hope for the future!',26124),
(56936,'enUS','Citizens of Orgrimmar, rejoice! Deathwing is no more! The Cataclysm is over! A band of valiant heroes lashed out at the Destroyer with deadly precision and overwhelming might, granting the Dragon Aspects the opportunity to sacrifice their powers into one final strike. The last remains of Deathwing now reside here in Orgrimmar to serve as a beacon of hope for the future!','',26124),
(56937,'enUS','The Dojani Dynasty is remembered for their cruelty. Use caution.','',26124),
(56941,'enUS','I can feel the elements awakening... rejoicing... the Cataclysm... is over.','',26124),
(56942,'enUS','','I can show you the aftermath of Deathwing\'s destruction at the Maelstrom, if you wish.',26124),
(56943,'enUS','Please show me, Chromie.','Please show me, Chromie.',26124),
(56944,'enUS','I can\'t stay in town anymore. I must find a fight!','',26124),
(56945,'enUS','I would look upon these lands with my own eyes.','',26124),
(56946,'enUS','You could learn much by watching me in action.','',26124),
(56947,'enUS','Come, my apprentice! You ARE my apprentice, right...?','',26124),
(56948,'enUS','I can show you the aftermath of Deathwing\'s destruction at the Maelstrom, if you wish.','',26124),
(56949,'enUS','Show me, dragon.','Show me, dragon.',26124),
(56950,'enUS','I will see you at back at camp.','',26124),
(56951,'enUS','This cannot be, is it finally over?  I must be dreaming again.','This cannot be, is it finally over?  I must be dreaming again.',26124),
(56952,'enUS','Together we have achieved the impossible.','',26124),
(56953,'enUS','Now you must usher in a new age... The age of mortals.','Now you must usher in a new age... The age of mortals.',26124),
(56954,'enUS','Join me!','Join me!',26124),
(56955,'enUS','Old legends tell of the Dojani Dynasty and their Pools of Youth. Let us see if the legend is true.','',26124),
(56956,'enUS','Attempt to free Na Lek from his prison.','Attempt to free Na Lek from his prison.',26124),
(56957,'enUS','This wall of shadow will hold back the demons long enough for us to cross.\n$bWhen you and the other elves have crossed I will follow.','',26124),
(56958,'enUS','Halt, supplicant! These waters belong to the Thunder King. Your presence is unwelcome.','',26124),
(56959,'enUS','Guardians! Kill these intruders.','',26124),
(56960,'enUS','Shhhh! They don\'t know that I\'m hiding here.','',26124),
(56961,'enUS','I am only one pandaren, but I must stay here and help the serpents.','',26124),
(56962,'enUS','We must be very quiet. The Slitherscale will not hesitate to eat us for dinner.','',26124),
(56963,'enUS','I haven\'t bathed in sixteen days. It\'s easier to blend in this way.','',26124),
(56964,'enUS','I\'ve collected so much data on serpents in the wild!','',26124),
(56965,'enUS','This is their natural breeding ground. We must tread carefully.','',26124),
(56966,'enUS','The little spirit is helping us! Fight near him, hero!','',26124),
(56967,'enUS','Na Lek imbues $p with gratitude and returns to the waters of the pool.','',26124),
(56968,'enUS','Have you had a chance to visit the Temple of the Jade Serpent? Many of our students are sent to further their training within its walls, under the watchful gaze of Yu\'lon herself.','',26124),
(56969,'enUS','Unfortunately, our efforts to breed the serpents have been unsuccessful. We carefully take a few eggs from the wild serpents to raise as our own.','',26124),
(56970,'enUS','Take me to the summit of Wyrmrest Temple to fight Ultraxion and his minions.','Take me to the summit of Wyrmrest Temple to fight Ultraxion and his minions.',26124),
(56971,'enUS','Look at that. The little guy left you some purified water.','',26124),
(56972,'enUS','Brother, we must look to our defenses. The Alliance are encroaching on us from the east.','',26124),
(56973,'enUS','You are a subject of the Horde. Remember your obligations and oaths. By the Warchief\'s command we must slay these night elves.','',26124),
(56974,'enUS','You can only hide behind Leza\'s pain for so long. Sooner or later you must stand as the Sunwalker you claim to be and lead us against the enemies of the horde.','',26124),
(56975,'enUS','I must stay by Leza\'s side until she has given birth. Death can wait for life.','',26124),
(56976,'enUS','My orders from Baine were to secure new holdings in this land and investigate the light our sunwalkers felt. The Alliance is of little concern.','',26124),
(56977,'enUS','Hate will blind you, brother, if you let it.','',26124),
(56978,'enUS','The mogu have a way about them that implies leadership. Use caution.','',26124),
(56979,'enUS','I wouldn\'t mind settling down in a place like this. Great views, plenty of beer... and lots of stuff to fight.','',26124),
(56980,'enUS','<Crack your knuckles and nod your head.>','<Crack your knuckles and nod your head.>',26124),
(56981,'enUS','You ready for a brawl, $n?','',26124),
(56982,'enUS','We must regroup before the Sha attack again!','We must regroup before the Sha attack again!',26124),
(56983,'enUS','Priestess Flameheart has betrayed us! The temple is lost!','Priestess Flameheart has betrayed us! The temple is lost!',26124),
(56984,'enUS','The Sha are too many, we must flee while we still have the chance!','The Sha are too many, we must flee while we still have the chance!',26124),
(56985,'enUS','','Umm... he\'s coming right at me.',26124),
(56986,'enUS','Mei, do you have any idea where I can find salt around here?','Mei, do you have any idea where I can find salt around here?',26124),
(56987,'enUS','','Should I run?',26124),
(56988,'enUS','','I\'m gonna run.',26124),
(56989,'enUS','Thank you for bringing back Yi-Mo.$B$BIt\'s clear to me now that we can no longer ignore our duties in the province.','Thank you for bringing back Yi-Mo.$B$BIt\'s clear to me now that we can no longer ignore our duties in the province.',26124),
(56990,'enUS','Normally we\'d have plenty on hand, but most of our supplies have been left out to ruin in the rain.$B$BHowever, I\'m certain the creatures in the dried up ponds are a mixture of rainwater and salt from the earth. You may be able to get what you need from them.','Normally we\'d have plenty on hand, but most of our supplies have been left out to ruin in the rain.$B$BHowever, I\'m certain the creatures in the dried up ponds are a mixture of rainwater and salt from the earth. You may be able to get what you need from them.',26124),
(56991,'enUS','Nooooo... how can this be?','',26124),
(56992,'enUS','','',26124),
(56993,'enUS','Ahhh, here\'s a nice one. Yes, this egg will do. Not this one. Too small! Perhaps this one could pass the bill...','',26124),
(56994,'enUS','Where am Jooga?','',26124),
(56995,'enUS','What happen?','',26124),
(56996,'enUS','What the ook?','',26124),
(56997,'enUS','Jooga no can see!','',26124),
(56998,'enUS','Where is me?','',26124),
(56999,'enUS','Ookin\' barrels!','',26124),
(57000,'enUS','Eat bananas!','',26124),
(57001,'enUS','Bananas for everyone!','',26124),
(57002,'enUS','Jooga not happy about barrel on head!','',26124),
(57003,'enUS','Jooga feels angry about what you did!','',26124),
(57004,'enUS','Jooga throwing his fruit! Because he feels mad!','',26124),
(57005,'enUS','You throw barrel? Jooga throw banana! Taste better!','',26124),
(57006,'enUS','Now, Jooga chase panda girl!','',26124),
(57007,'enUS','Panda girl, why you so fast?','',26124),
(57008,'enUS','You sneaky panda girl! Come back to Jooga!','',26124),
(57009,'enUS','Jooga feel happy to see cute panda girl!','',26124),
(57010,'enUS','Jooga just want give hug to panda girl.','',26124),
(57011,'enUS','Oh panda girl... Jooga want feed you banana!','',26124),
(57012,'enUS','','Eww!',26124),
(57013,'enUS','','Gross!',26124),
(57014,'enUS','','That\'s disgusting!',26124),
(57015,'enUS','','Jooga is |cFFFF0000|Hspell:110182|h[Slippery]|h|r! Kick a barrel at him to make him stand still!',26124),
(57016,'enUS','Help! I lost my egg!','Help! I lost my egg!',26124),
(57017,'enUS','Wait, I\'ve changed my mind about my egg.','Wait, I\'ve changed my mind about my egg.',26124),
(57018,'enUS','I\'m sorry. I promise to be more careful.','I\'m sorry. I promise to be more careful.',26124),
(57019,'enUS','I would like a blue serpent egg.','I would like a blue serpent egg.',26124),
(57020,'enUS','I would like a green serpent egg.','I would like a green serpent egg.',26124),
(57021,'enUS','I would like a yellow serpent egg.','I would like a yellow serpent egg.',26124),
(57022,'enUS','Your lives are meaningless.','',26124),
(57023,'enUS','Yes, I know you lost your egg.$B$BHow do I know this? Because I have your egg RIGHT HERE.$B$BI will entrust this egg to you once more, but please, I deplore you, take better care of it this time.','',26124),
(57024,'enUS','Give up your hope.','',26124),
(57025,'enUS','Our forces will fall.','',26124),
(57026,'enUS','We will fail to defend Pandaria.','',26124),
(57027,'enUS','What? You changed your mind after all? I told you to pick carefully!$B$BAh well, I will forgive you this time. Tell me, which egg do you really want?','',26124),
(57030,'enUS','|Tinterface\\icons\\spell_fire_ragnaros_lavabolt.blp:0|tStructural damage to the Skyfire triggers a sudden |cFFFF0000|Hspell:110095|h[Deck Fire]|h|r!','',26124),
(57031,'enUS','I... I can\'t hit him! That there bubble is too durn thick!','',26124),
(57032,'enUS','I can\'t punch through this dang ol\' bubble!','',26124),
(57033,'enUS','Let\'s kick them little bubbles back at him!','',26124),
(57034,'enUS','Let\'s kick the little bubbles! At his FACE!','',26124),
(57035,'enUS','Quick, $p! Come pop that bubble!','',26124),
(57036,'enUS','Come here, $p! Give that bubble a good poke!','',26124),
(57037,'enUS','Now get over here and pop his bubble, $p!','',26124),
(57038,'enUS','$p! Come in close and help me pop this big ol\' bubble!','',26124),
(57039,'enUS','Alright! Now I\'m gonna whup yer butt!','',26124),
(57040,'enUS','I\'mma turn you into a stout!','',26124),
(57041,'enUS','Look out! Here comes Mudmug!','',26124),
(57042,'enUS','Back to the fightin\'!','',26124),
(57043,'enUS','Run over the small bubbles to weaken Eddy\'s |cFFFF0000|Hspell:110189|h[Watery Shield]|h|r!','',26124),
(57044,'enUS','Click on Eddy\'s weakened |cFFFF0000|Hspell:110198|h[Watery Shield]|h|r to pop it!','',26124),
(57045,'enUS','Teeeeee hee hee heeeee!','',26124),
(57046,'enUS','Hoooo hoo hooooo!','',26124),
(57047,'enUS','Kekekekeke!','',26124),
(57048,'enUS','Saurok take any opportunity to plunder, and with our Wardens out of commission they\'ve been running nightly raids on our supplies.$B$BThey take anything they can carry and sort through it back at their lair.$B$BCrafting supplies and pigments are just some of the things they\'re sure to be sitting on.','Saurok take any opportunity to plunder, and with our Wardens out of commission they\'ve been running nightly raids on our supplies.$B$BThey take anything they can carry and sort through it back at their lair.$B$BCrafting supplies and pigments are just some of the things they\'re sure to be sitting on.',26124),
(57049,'enUS','This may be a strange request, but... do you have any ink or paint?','This may be a strange request, but... do you have any ink or paint?',26124),
(57050,'enUS','','|Tinterface\\icons\\spell_fire_twilightrainoffire.blp:0|t%s fires a |cFF9900CC|Hspell:110153|h[Broadside]|h|r at the Skyfire!',26124),
(57051,'enUS','Centuries ago, this land was still part of the wilds. Reaching the coast was a perilous journey, and many pandaren were lost to the beasts which roam Krasarang, nest of the great crane.$B$BThat is, until the famous hunter Zhu Longbrow came along. Tired of the needless loss of life, Zhu, along with his wife Rin and their son Po - both formidable hunters in their own right - carved out and settled a corner of the wilds.$B$BZhu did not want to settle the wilds entirely, though many begged him to do so. In his wisdom, he understood that they, too, served a purpose: protecting the great crane.$B$BThus Zhu Province was born, and Zhu\'s Watch to protect it.','Centuries ago, this land was still part of the wilds. Reaching the coast was a perilous journey, and many pandaren were lost to the beasts which roam Krasarang, nest of the great crane.$B$BThat is, until the famous hunter Zhu Longbrow came along. Tired of the needless loss of life, Zhu, along with his wife Rin and their son Po - both formidable hunters in their own right - carved out and settled a corner of the wilds.$B$BZhu did not want to settle the wilds entirely, though many begged him to do so. In his wisdom, he understood that they, too, served a purpose: protecting the great crane.$B$BThus Zhu Province was born, and Zhu\'s Watch to protect it.',26124),
(57052,'enUS','We will make this province safe again. Zhu\'s legacy will not end with this.','We will make this province safe again. Zhu\'s legacy will not end with this.',26124),
(57053,'enUS','Please tell me about Zhu\'s legacy.','Please tell me about Zhu\'s legacy.',26124),
(57054,'enUS','Longbrow? Does that mean Yi-Mo is a descendant of Zhu?!','Longbrow? Does that mean Yi-Mo is a descendant of Zhu?!',26124),
(57055,'enUS','That\'s correct. He is the last remaining member of the Longbrow line.$B$BSadly, he doesn\'t seem to be made of the same stuff as old Zhu. As I\'m sure you noticed, he\'s... dramatic.$B$BPlease do not take this as a sign of weakness: his name and the responsibilities that come along with it weigh on him heavily. I know Yi-Mo only wants what is best for the province.$B$BSome day he will come to understand that, at times, you must fight for what you love.','That\'s correct. He is the last remaining member of the Longbrow line.$B$BSadly, he doesn\'t seem to be made of the same stuff as old Zhu. As I\'m sure you noticed, he\'s... dramatic.$B$BPlease do not take this as a sign of weakness: his name and the responsibilities that come along with it weigh on him heavily. I know Yi-Mo only wants what is best for the province.$B$BSome day he will come to understand that, at times, you must fight for what you love.',26124),
(57056,'enUS','Give me a hand, $p!','',26124),
(57057,'enUS','Once we get rid of these spirits, we can move on.','',26124),
(57058,'enUS','That sure was nice of those spirits to hop into this pot.','',26124),
(57059,'enUS','Whaaaa?','',26124),
(57060,'enUS','Looks like we\'re not done yet, $p.','',26124),
(57061,'enUS','Aspects! Aid the heroes as best you can.','',26124),
(57062,'enUS','%s siphons vitality from Goriona and attacks with renewed vigor!','',26124),
(57063,'enUS','(You cannot begin this encounter on Heroic Difficulty unless all prior encounters have been defeated on Heroic Difficulty.)','(You cannot begin this encounter on Heroic Difficulty unless all prior encounters have been defeated on Heroic Difficulty.)',26124),
(57064,'enUS','(You cannot begin this encounter on Heroic Difficulty unless all prior encounters have been defeated on Heroic Difficulty.)','(You cannot begin this encounter on Heroic Difficulty unless all prior encounters have been defeated on Heroic Difficulty.)',26124),
(57065,'enUS','','Finally!',26124),
(57066,'enUS','I am called Chen, and this is my niece, Li Li.','',26124),
(57067,'enUS','May we stay here at your farmhouse for a while? We do not have much in the way of money, but I will gladly share some of my famous ale with you.','',26124),
(57068,'enUS','Greetings, Chen, Li Li. You may stay, but I do not need any of your ale.','',26124),
(57069,'enUS','Thank you! We will not trouble you for long.','',26124),
(57070,'enUS','Interesting. He does not like beer? A very strange land, indeed.','',26124),
(57071,'enUS','','Really, Uncle? We\'re stopping already? We only moved, like, ten feet.',26124),
(57072,'enUS','Alright, alright already! Enough with the shoving!','',26124),
(57073,'enUS','I have a pretty good idea what ol\' Great-father Winter\'s gonna be doing when this shift is over.  I got a bottle of Winter Veil cheer right here in my bag, and I intend to get to the bottom of it.','',26124),
(57074,'enUS','Yeah, sure, go ahead and tell ol\' Great-father Winter what you\'d like for this Winter Veil.$B$BHo ho hurry up.','',26124),
(57075,'enUS','Mm-hmm.','',26124),
(57076,'enUS','Normally, new trainees have a little more time to prepare.','',26124),
(57077,'enUS','Unfortunately, your hatchling does not want to wait!','',26124),
(57078,'enUS','I hope you work hard, $n. To raise a cloud serpent is an honor bestowed upon a rare few.','',26124),
(57079,'enUS','It\'s starting!','',26124),
(57080,'enUS','I\'m going to my room. Feel free to tell my aunt about how you \"heroically\" saved me from myself or whatever.','',26124),
(57081,'enUS','Here you go, girls! Courtesy of $p!','',26124),
(57082,'enUS','Ugh... where am I?','Ugh... where am I?',26124),
(57083,'enUS','','Alright! Back to Uncle Chen at Halfhill! Race you there, $n!',26124),
(57084,'enUS','','Get away from that, mongrel!',26124),
(57085,'enUS','You sure we\'re goin\' the right way, neighbor?','',26124),
(57086,'enUS','I\'m trustin\' you not to walk me off that big ol\' cliff.','',26124),
(57087,'enUS','I thought I could carry a lot... until I saw all the crud you carry around in those bags o\' yers.','',26124),
(57088,'enUS','I reckon we\'re almost there now.','',26124),
(57089,'enUS','Sure could go for a drink of water right now.','',26124),
(57090,'enUS','Yup.','',26124),
(57091,'enUS','Mmm-hmmm.','',26124),
(57092,'enUS','Still carryin\' these barrels back here.','',26124),
(57093,'enUS','Can\'t wait to try this beer that Chen\'s thinkin\' about.$b$bHe talks a big game, that one.','',26124),
(57094,'enUS','Let\'s head back to Halfhill, Mudmug.','Let\'s head back to Halfhill, Mudmug.',26124),
(57095,'enUS','I\'m trustin\' you not to lead me into any rivers, or animal mouths. Nothin\' like that.','',26124),
(57096,'enUS','Wait... which way did you go?','',26124),
(57097,'enUS','Told you I was strong. Didn\'t drop one barrel.','',26124),
(57098,'enUS','I can\'t believe this. How much do they feed this thing?','',26124),
(57099,'enUS','You missed some.','You missed some.',26124),
(57100,'enUS','I know, I know.','',26124),
(57101,'enUS','Focus all of your attacks onto one single slime!','',26124),
(57102,'enUS','Don\'t underestimate my father. Even if you were to crush his body, the core of his madness and rage will still struggle to destroy you.','',26124),
(57103,'enUS','He will not be defeated until he is utterly annhilated.','',26124),
(57104,'enUS','I wish I could help but... my father is the one dragon I fear.','',26124),
(57105,'enUS','Best of luck, rogue. Whatever the outcome, you are truly a champion.','',26124),
(57106,'enUS','You were in a raid. Still, my hat\'s off to you, I don\'t even know where Kharazan is. How did you get there?','You were in a raid. Still, my hat\'s off to you, I don\'t even know where Kharazan is. How did you get there?',26124),
(57107,'enUS','Intercept |cFF9900CC|Hspell:107439|h[Twilight Barrage]|h|r to prevent damage to the Skyfire!','Intercept |cFF9900CC|Hspell:107439|h[Twilight Barrage]|h|r to prevent damage to the Skyfire!',26124),
(57108,'enUS','Why don\'t you get a job somewhere else?','Why don\'t you get a job somewhere else?',26124),
(57109,'enUS','|c0087CEFA|Hspell:105845|h[Nuclear Blast]|h|r wasn\'t close enough to pry up the plate!','',26124),
(57110,'enUS','I deserve better than this! I am an actor, a performer- not a common dungsweep! For Light\'s sake, I\'ve performed in the opera at Kharazan!','',26124),
(57111,'enUS','%s didn\'t absorb enough Corrupted Blood residue to trigger a Nuclear Blast.','',26124),
(57112,'enUS','Practice, practice, practice!','',26124),
(57113,'enUS','Now look at me. Sweeping up after this dumb beast.','',26124),
(57114,'enUS','What, and give up showbusiness?!','',26124),
(57115,'enUS','Use the Heroic Will ability to avoid Hour of Twilight and Fading Light!','Use the Heroic Will ability to avoid Hour of Twilight and Fading Light!',26124),
(57116,'enUS','Everything suddenly seems... brighter.','Everything suddenly seems... brighter.',26124),
(57117,'enUS','I feel... happy!!','I feel... happy!!',26124),
(57118,'enUS','Destroy the Mana Void to regain lost mana!','',26124),
(57119,'enUS','Oh, my head hurts...','Oh, my head hurts...',26124),
(57120,'enUS','What am I doing out here? I\'ve got work to do!','What am I doing out here? I\'ve got work to do!',26124),
(57121,'enUS','You come to fight my brood? You come to steal my treasures?','',26124),
(57122,'enUS','Time for Chufa\'s surprise!','',26124),
(57123,'enUS','You\'re in for it now!','',26124),
(57124,'enUS','Did I miss anything?','',26124),
(57125,'enUS','What!?','',26124),
(57126,'enUS','Looks like I made it just in time!','',26124),
(57127,'enUS','Run to the orb if you are connected to it!','',26124),
(57128,'enUS','$n! Get out of the black ooze on the ground!','',26124),
(57129,'enUS','$n, you were slain by a Resonating Crystal. Standing closer to the Resonating Crystal reduces the damage.','',26124),
(57130,'enUS','Let\'s do this!','Let\'s do this!',26124),
(57131,'enUS','$n, you were slain by Hagara\'s Ice Wave. $BStart running early to avoid the ice!','$n, you were slain by Hagara\'s Ice Wave. $BStart running early to avoid the ice!',26124),
(57132,'enUS','Uh oh... my battle armor... weakening...','',26124),
(57133,'enUS','I\'ll let you clean up in here, $p. See you back at Mudmug\'s!','',26124),
(57134,'enUS','Another soul lost to the Destroyer...','',26124),
(57135,'enUS','Today, $n, we celebrate your graduation. You have learned all that there is to know within the walls of Tian.','',26124),
(57136,'enUS','Welcome back, $n! How goes your training?$b$bOur trainees have missed you dearly... though I must say that they appreciate not having to spar with you anymore.','',26124),
(57137,'enUS','There is no hope, no future. All life is doomed.','',26124),
(57138,'enUS','Like you, all of Azeroth shall burn.','',26124),
(57139,'enUS','Know that your world will soon follow.','',26124),
(57141,'enUS','','Be one with your serpent, $n. Perceive your serpent\'s experiences as your own and strengthen your bond.',26124),
(57142,'enUS','Hozen can learn martial arts too, you know.$b$bKen-Ken better than all these other guys put together. ESPECIALLY better than Clever Ashyo the Dumb Jinyu, over there.','',26124),
(57143,'enUS','','We\'ve just graduated from the Tian Monastery, in the Jade Forest. Have you been there before?$b$bWe\'re not students anymore. We\'re on our first quest - the quest to find the Hidden Master.',26124),
(57144,'enUS','','$n! It\'s me! Remember? From the Tian Monastery?$b$bIt took me a while, but I\'ve finally graduated! Xiao, too, and... well, everybody else that you see here.$b$bWe\'re not students anymore. We\'re on our first quest - the quest to find the Hidden Master.',26124),
(57145,'enUS','Beggars and usurpers, we will burn you and your pandaren allies to ash.','',26124),
(57146,'enUS','The elders of my village taught me that wisdom flows through every river, and collects in every pond. I can\'t wait to learn what the waters of this place have to offer.$b$bThe elders of my village also taught me that one should never trust a hozen.$b$b<Ashyo shoots a wary glance over at Ken-Ken.>','',26124),
(57147,'enUS','Finally, a chance to use the skills we\'ve been training for. Who knows what adventure we\'ll find here in the Valley of the Four Winds?','',26124),
(57148,'enUS','I lost my serpent! Could you perform the spirit link once again?','I lost my serpent! Could you perform the spirit link once again?',26124),
(57149,'enUS','Alright, now we need someone to test this on...','',26124),
(57150,'enUS','You! Get over here, mopesy. Ken-Ken got just the thing for you!','',26124),
(57151,'enUS','Who, me?','',26124),
(57152,'enUS','Sure, it\'s not like things could get any worse...','',26124),
(57153,'enUS','%s\'s gut churns violently.','',26124),
(57154,'enUS','Are you sure you want to pay?','Are you sure you want to pay?',26124),
(57155,'enUS','Chezin lay dead with grievous wounds both physical and magical.','',26124),
(57156,'enUS','Oh... ughh... what have you done to me?!','',26124),
(57157,'enUS','Here, drink this.','',26124),
(57158,'enUS','Hahaha! It worked! Ken-Ken KNEW it would work! You feelin\' better now?','',26124),
(57159,'enUS','Ughh... urrrggg....','',26124),
(57160,'enUS','NO!','',26124),
(57161,'enUS','Faster, you fools. We need all of these artifacts soon or it\'s the cane for your hides.','',26124),
(57162,'enUS','Nobody can be sad when they wearin\' a mask like this! Now, who can we test it on?','',26124),
(57163,'enUS','Perfect! C\'mere, buddy. Sorry about last time! Put this on.','',26124),
(57164,'enUS','Ugh... what was that stuff? It went through me like bad tea.','Ugh... what was that stuff? It went through me like bad tea.',26124),
(57165,'enUS','%s sighs deeply.','%s sighs deeply.',26124),
(57166,'enUS','Fine... whatever. Hand it over.','Fine... whatever. Hand it over.',26124),
(57167,'enUS','I... I feel... happy!','I... I feel... happy!',26124),
(57168,'enUS','Thank you so much, brave heroes! I will tell stories of you! Of $p the Mighty! And Ken-Ken the Fearless!','Thank you so much, brave heroes! I will tell stories of you! Of $p the Mighty! And Ken-Ken the Fearless!',26124),
(57169,'enUS','What the ook is that?!','',26124),
(57170,'enUS','Oh, the hozenity! Get it out of here! Ken-Ken too smart to die!','',26124),
(57171,'enUS','Is it... is it gone?','',26124),
(57172,'enUS','Yeah... The Fearless... sounds good.','',26124),
(57173,'enUS','No, we been tricked!','',26124),
(57174,'enUS','We been duped!','',26124),
(57175,'enUS','I confused!','',26124),
(57176,'enUS','Yuck!','',26124),
(57177,'enUS','Gross!','',26124),
(57178,'enUS','Get away from it!','',26124),
(57179,'enUS','Run away! Run away!','',26124),
(57180,'enUS','It horrible!','',26124),
(57181,'enUS','False carrot alert! False carrot alert!','',26124),
(57182,'enUS','Stay away! We no know what it can do!','',26124),
(57183,'enUS','Watch the skies for Alliance eyes. I will see you back at Thunder Cleft. Hellscream\'s eyes are upon you.','',26124),
(57184,'enUS','This jungle is filled with an unnatural sense of dispair.','',26124),
(57185,'enUS','The sadness in the earth is quelling the gifts granted me by the light.$b$bMy wife, she is suffering, and none of my abilities are able to help her.','',26124),
(57186,'enUS','Your hatchling chases after the ball!','',26124),
(57187,'enUS','Your hatchling wants to catch this one!','',26124),
(57188,'enUS','Don\'t worry, your hatchling\'s got it!','',26124),
(57189,'enUS','Kneel supplicant!','',26124),
(57190,'enUS','We will rise again, and your kind will be made to serve!','',26124),
(57191,'enUS','Your kind is no match for the return of our Thunder King!','',26124),
(57192,'enUS','For the Thunder King!','',26124),
(57193,'enUS','Avert your eyes, peasant!','',26124),
(57194,'enUS','Your kind were made to be ruled.','',26124),
(57195,'enUS','Bow before our might!','',26124),
(57196,'enUS','Well done, $p!','',26124),
(57197,'enUS','Victory is mine!','',26124),
(57198,'enUS','Face the wrath of the Bramblestaff!','',26124),
(57199,'enUS','I think I punched him so hard his ancestors felt it.','',26124),
(57200,'enUS','','The rest of Nesingwary\'s Safari is up in the western side of the Valley of Four Winds. If you find yourself heading west, you should join us. Good hunting!',26124),
(57201,'enUS','How did you get here?','How did you get here?',26124),
(57202,'enUS','','I\'m part of the Nesingwary Safari. We were riding along in our hot air balloon through some mists when we came across this land.$b$bNesingwary and his boy wanted to hunt some of the hoofed animals and what not up north.$b$bI decided to get a headstart on them in the jungle where the real beasts are.$b$bA rocket ride later I\'m neck deep in tigers.',26124),
(57205,'enUS','A $c? Here? And a Horde no less.$b$bWe could make good use of you if you are willing to help.$b$bWe followed visions and dreams to get here only to find a nightmare waiting for us.','',26124),
(57206,'enUS','What the... Sha nasties are poppin\' out everywhere! We gotta take care of them first!','',26124),
(57207,'enUS','Okay, no more time. Yi-Mo needs help now! Let\'s get a mask on him!','',26124),
(57208,'enUS','Me pop n\' I are on a genuine safari. This is a strange, new land filled with dangers around every turn, monsters pokin\' out of every hole, and beasts as ol\' as the dirt itself livin\' life without fear.$b$bIt\'s huntin\' season!','',26124),
(57209,'enUS','Hey there, $p! It\'s been a while since we shared a proper hunt, now hasn\'t it. Let\'s see if time has softened yer aim.','',26124),
(57210,'enUS','|cFFFF0000|Hspell:106794|h[Shrapnel]|h|r killed you! Use |cFF04FC32|Hspell:106466|h[Dream]|h|r to prevent damage.','',26124),
(57211,'enUS','|cFFFF0000|Hspell:105723|h[Elementium Bolt]|h|r killed you.  Move away from the impact point to decrease the bolt\'s damage.','',26124),
(57212,'enUS','ALL IS LOST! LAY DOWN AND SUBMIT TO YOUR DESPAIR!','',26124),
(57213,'enUS','','Your serpent will arrive in just a moment. Good luck!',26124),
(57214,'enUS','Instructor Windblade, could you call my serpent again?','Instructor Windblade, could you call my serpent again?',26124),
(57215,'enUS','','Your serpent is arriving now. Please mount when you are ready.',26124),
(57216,'enUS','','The journey to becoming a Serpent Master is a difficult one. Are you up for the challenge?',26124),
(57217,'enUS','','Great dedication is necessary to ascend the ranks of the Order of the Cloud Serpent. I wish you luck.',26124),
(57218,'enUS','Thrall was killed! Attack Corrupted Slimes to prevent damage to him.','Thrall was killed! Attack Corrupted Slimes to prevent damage to him.',26124),
(57219,'enUS','Stand solo against a yeti with nothing but a bowie knife while wearing a loincloth and you\'ll earn yourself the title of \"lucky\" as well.','',26124),
(57220,'enUS','Yi-Mo will be fine for right now, we gotta take care of these nasties first!','',26124),
(57221,'enUS','$GHe\'s:She\'s; coming to!','',26124),
(57222,'enUS','','Students of our Order test their speed in an aerial competition known as the Sky Race.',26124),
(57223,'enUS','','I will teach you the rules of this race. Follow me!',26124),
(57224,'enUS','Alright, let\'s see if this ol\' ritual will work.','',26124),
(57225,'enUS','You\'ll see, Pop. I\'m gonna bag me a big one.','',26124),
(57226,'enUS','Step one: dance.','',26124),
(57227,'enUS','Step two: say the words. \"Heed my call, waters of pain, and bring forth, Torjari\'s Bane!\"','',26124),
(57228,'enUS','The master calls.','',26124),
(57229,'enUS','Oh, resorting to hocus pocus now are ya?','',26124),
(57230,'enUS','Junior! Nooooo!','',26124),
(57231,'enUS','Come on! We need to save my boy!','',26124),
(57232,'enUS','$p! Are you okay? Wake up!','',26124),
(57233,'enUS','','I will gain speed as the exercise continues. Try to keep up.',26124),
(57234,'enUS','','If you start to get too far, I will warn you. If you continue to stray, I will not hesitate to fail you.',26124),
(57235,'enUS','','I will guide you with this rope. If you get too far away from me, it will break and I will be forced to restart the exercise.',26124),
(57236,'enUS','','Do you see the hanging pennants above our heads? These flags mark the race course. If you ever get lost, you can use these flags as a guide.',26124),
(57237,'enUS','','As you undergo these trials, you and your serpent will strengthen your bond.',26124),
(57238,'enUS','','Stay with me, $n.',26124),
(57239,'enUS','','When you are on your own, your enemies will not be as kind as I.',26124),
(57240,'enUS','','PH Random 4',26124),
(57241,'enUS','','PH Random 5',26124),
(57242,'enUS','','PH Random 6',26124),
(57243,'enUS','','PH Random 7',26124),
(57244,'enUS','','PH Random 8',26124),
(57245,'enUS','','We\'re almost done. Just the homestretch now!',26124),
(57246,'enUS','','Well done, $n.',26124),
(57247,'enUS','','You fell too far behind!',26124),
(57248,'enUS','','You must keep up with me, $n. Venture too far and you will fail the exercise.',26124),
(57249,'enUS','','Speak to me when you are ready to try again.',26124),
(57250,'enUS','','You must fly through all 10 checkpoints before you can finish the race.',26124),
(57251,'enUS','','In a real race, you will need to fly through each checkered flag to get credit for passing the checkpoint.',26124),
(57252,'enUS','','You are too far! Get closer to your Instructor!',26124),
(57253,'enUS','Oh... what... who? How did I get here?','',26124),
(57254,'enUS','Sorry I made such a mess o\' things.','',26124),
(57255,'enUS','I love ya pop.','',26124),
(57256,'enUS','Junior! Junior! Snap out of it.','',26124),
(57257,'enUS','Junior! Junior! Snap out of it.','',26124),
(57258,'enUS','Come on boy, you\'re stronger \'an this thing.','',26124),
(57259,'enUS','$p is coming. They can help us get you out of here.','',26124),
(57260,'enUS','The master comes.','',26124),
(57262,'enUS','<Try shaking Hemet.>','<Try shaking Hemet.>',26124),
(57263,'enUS','$p, watch the corners. I hear something comin\'.','',26124),
(57264,'enUS','You chose the wrong hunter to hunt! $p, kite that thing a little further away so I can get a better shot.','',26124),
(57265,'enUS','We did it, $p! That was some good butt-punchin\' back there!','',26124),
(57266,'enUS','$p... To think you\'d risked your life to save me - twice now - and I\'d only treated you with disdain.','',26124),
(57267,'enUS','I am shamed beyond comprehension. Please forgive me - my mind was not my own.','',26124),
(57268,'enUS','Should you ever need aid of any kind, from a handful of turnip seeds to a volley of arrows, know that Zhu\'s Watch will provide it.','',26124),
(57269,'enUS','For now, I must direct my attention to rebuilding the village. There is much to be done. You may rest here if you like, but we\'ll not accept any more help.','',26124),
(57270,'enUS','Something tells Ken-Ken that\'s not the last of the sads, though...','',26124),
(57271,'enUS','Where are we? Smells like... like carrots and turds.','',26124),
(57272,'enUS','Who\'s that guy? The guy you were talkin\' to? Can someone tell me what\'s goin\' on?','',26124),
(57273,'enUS','Where you takin\' me, $p?','',26124),
(57274,'enUS','Was that a hozen I heared? Are we in Halfhill yet?','',26124),
(57275,'enUS','Li Li? Is that you? Hello? Anybody gonna pay attention to ol\' Mudmug?','',26124),
(57276,'enUS','Junior! You\'re okay!','',26124),
(57277,'enUS','No, you were right. You did put \"BIG\" into \"big game hunting\". You done me proud son!','',26124),
(57278,'enUS','I love ya too, son. Now let\'s go get us a pint!','',26124),
(57279,'enUS','He is coming...','',26124),
(57280,'enUS','You got any other errands you need to run? Don\'t you worry about ol\' Mudmug... just poke me when we get there.','',26124),
(57281,'enUS','','Spread among the spires are 10 hot air balloons, or checkpoints. We are passing one just now.',26124),
(57282,'enUS','Welcome, $p! I\'ll never forget the help ya gave me savin\' my boy. Now that was a proper hunt!','',26124),
(57283,'enUS','I canna\' believe I made myself the bait for a trap. Lucky for me you an\' me Pop were there.','',26124),
(57284,'enUS','A new land, and you want to hunt boring old wolves?','',26124),
(57285,'enUS','Quality over quantity my boy.','',26124),
(57286,'enUS','Now... THAT is a trophy.','',26124),
(57287,'enUS','Are your trophies shrinking, Pop? Or are you hunting smaller game?','',26124),
(57288,'enUS','','Your serpent is arriving now. You can find the flags hanging from the red hot air balloons in the sky.',26124),
(57289,'enUS','','Contestants to the starting line! The Sky Race is about to begin!',26124),
(57290,'enUS','','The rules are simple. Pass through all 10 checkpoints and cross the finish line.',26124),
(57291,'enUS','','3...',26124),
(57292,'enUS','','2...',26124),
(57293,'enUS','','1...',26124),
(57294,'enUS','','GO! To the skies!',26124),
(57295,'enUS','GO!!!!','GO!!!!',26124),
(57296,'enUS','You finished in...\n...\n1ST PLACE!','You finished in...\n...\n1ST PLACE!',26124),
(57297,'enUS','You finished in...\n...\n2ND PLACE!','You finished in...\n...\n2ND PLACE!',26124),
(57298,'enUS','You finished in...\n...\n3RD PLACE!','You finished in...\n...\n3RD PLACE!',26124),
(57299,'enUS','You finished in...\n...\n4TH PLACE!','You finished in...\n...\n4TH PLACE!',26124),
(57300,'enUS','You finished in...\n...\n5TH PLACE!','You finished in...\n...\n5TH PLACE!',26124),
(57301,'enUS','You finished in...\n...\n6TH PLACE!','You finished in...\n...\n6TH PLACE!',26124),
(57302,'enUS','You need to pass through all 10 checkpoints before completing the racecourse!','You need to pass through all 10 checkpoints before completing the racecourse!',26124),
(57303,'enUS','Do you want to start the encounter?','Do you want to start the encounter?',26124),
(57304,'enUS','How did you get here?','How did you get here?',26124),
(57305,'enUS','We were called.$b$bWe sailed deep into uncharted waters, at first on orders from High Chieftan Baine Bloodhoof.$b$bIt was my wife Leza whose visions gave us a course to sail by.$b$BBut when we saw the wall of mists, we all began to feel the call like a voice on the wind. North. The voice calls for us to travel north.$b$bWe came ashore, dismantled our ship, and sailed up river by canoe until we hit the cliff you see before us.','',26124),
(57306,'enUS','What is happening inside the tent?','What is happening inside the tent?',26124),
(57307,'enUS','It was Leza\'s visions that led us here. Each of us have had dreams of a valley, golden with blossoms, filled with the hope of peace.$b$bEven our chieftan Baine Bloodhoof had these dreams.$b$bOnly Leza\'s visions gave us a path to follow, though. And now, here we are, for better or worse.','',26124),
(57308,'enUS','','To the fastest riders go the prizes of victory! Mount your cloud serpents!',26124),
(57309,'enUS','Meet me at the Torjari Pit once you have the carcasses, $p.','',26124),
(57310,'enUS','$p! Nesingwary and Nesingwary are waiting for you at the Torjari Pit.','',26124),
(57311,'enUS','Your serpent gobbles up the food hungrily.','Your serpent gobbles up the food hungrily.',26124),
(57312,'enUS','Your serpent gulps down the food. Yum!','Your serpent gulps down the food. Yum!',26124),
(57313,'enUS','Your serpent eats the food and looks around for more.','Your serpent eats the food and looks around for more.',26124),
(57314,'enUS','Oh, another one eh? $p, kite him toward the back o\' the cave so I can snipe him.','',26124),
(57315,'enUS','Your serpent licks its lips. That was delicious!','Your serpent licks its lips. That was delicious!',26124),
(57316,'enUS','Your serpent looks at you imploringly. Is there more?','Your serpent looks at you imploringly. Is there more?',26124),
(57317,'enUS','Your serpent\'s belly looks a little rounder.','Your serpent\'s belly looks a little rounder.',26124),
(57318,'enUS','Your serpent nudges you affectionately before digging in.','Your serpent nudges you affectionately before digging in.',26124),
(57319,'enUS','Your serpent thought that the food was delicious.','Your serpent thought that the food was delicious.',26124),
(57320,'enUS','','You show much promise, $n, but you must nurture your talent with discipline.',26124),
(57321,'enUS','Thank ye for saving me, $p! I owe ya a big one.','',26124),
(57322,'enUS','','A young serpent is a delicate thing. This is the time when bad habits form. Good training makes a difference.',26124),
(57323,'enUS','','Young serpents are much more playful than their adult counterparts.',26124),
(57324,'enUS','','The path of the cloud serpent rider is long and arduous, but you will travel it together with your cloud serpent companion.$B$BIf you reach the end of the road together, you will have a loyal friend who will carry you to the end of your days.',26124),
(57327,'enUS','','Alright, Leza, I need you to push. Are you ready?',26124),
(57328,'enUS','','%s nods.',26124),
(57329,'enUS','','Push!',26124),
(57330,'enUS','','AAAHHH! HNNNH!',26124),
(57331,'enUS','','GAAAAAAHHH!',26124),
(57332,'enUS','','Good, that was good. You can rest now. I will get you some more hot water.',26124),
(57333,'enUS','Instructor Windblade, could you call my serpent again?','Instructor Windblade, could you call my serpent again?',26124),
(57335,'enUS','See you at Thunder Cleft, $p. May the sun\'s light protect you.','',26124),
(57336,'enUS','$p, meet me back at Thunder Cleft. I must bring my brother\'s body back to our people.','',26124),
(57337,'enUS','Instructor Windblade, how is my serpent doing?','Instructor Windblade, how is my serpent doing?',26124),
(57338,'enUS','','You have given much of your time, patience, and love, $n. Behold your serpent now.',26124),
(57339,'enUS','You are right, $p. I should be there for Leza. Thank you.','',26124),
(57340,'enUS','','Dezco... it hurts... it... AAAHHH!',26124),
(57341,'enUS','','Something\'s wrong. The baby\'s turned the wrong way.',26124),
(57342,'enUS','','Dezco, where are you?!',26124),
(57343,'enUS','I\'m here, Leza.','',26124),
(57344,'enUS','','My love... whatever happens... you must protect our... our child....',26124),
(57345,'enUS','Leza!','',26124),
(57346,'enUS','LEZA!!','',26124),
(57347,'enUS','','GAAAHHH!',26124),
(57348,'enUS','','Today, your journey toward the Order of the Cloud Serpent ends. Today, a new rider joins our ranks.',26124),
(57349,'enUS','','Today, you forge an eternal bond with your cloud serpent.',26124),
(57350,'enUS','Through thunder and storm, we fly together.','',26124),
(57351,'enUS','','Through sea and sky, we fly together.',26124),
(57352,'enUS','','Through wind and tide, we fly together.',26124),
(57353,'enUS','','Never again will you fly alone.',26124),
(57354,'enUS','With the Riders behind me, and my serpent beside me.','With the Riders behind me, and my serpent beside me.',26124),
(57355,'enUS','','Fly together with honor and courage. Now... rise as a serpent rider!',26124),
(57356,'enUS','Go, stand by your wife\'s side. I will protect the tent from invaders.','Go, stand by your wife\'s side. I will protect the tent from invaders.',26124),
(57357,'enUS','My child is nearly here... everything changes today...','',26124),
(57358,'enUS','My fur, doesn\'t it look good today?','',26124),
(57359,'enUS','Agara makes me look good, just like I make her look good.','',26124),
(57360,'enUS','I\'ve been told that I\'m the best-looking rider in the skies. I wouldn\'t believe that if I were you. I\'m also the best-looking rider on land, under the sea...well, just about anywhere!','',26124),
(57361,'enUS','I see you\'re here to admire my serpent. Oh, and Agara is quite impressive too.','',26124),
(57362,'enUS','Hey, how youuu doing?','',26124),
(57363,'enUS','After this, me and some of the boys are going to visit The Dancing Serpent Inn for some brew.','',26124),
(57364,'enUS','Hey rookie, when you\'re at Windward Isle, keep your eyes open for onyx eggs. The Serpent Masters\'ll go nuts if you bring one to them.','',26124),
(57365,'enUS','Oh, are you here from my fan club? I\'m sorry, I\'m not giving autographs right now.','',26124),
(57366,'enUS','Sorry, I can\'t talk right now. After we\'re done training here, it\'s time for lunch!','',26124),
(57367,'enUS','I may not be the best rider, but I have the best inventions!','',26124),
(57368,'enUS','When I get sad about losing, I eat...','',26124),
(57369,'enUS','I have an idea for a new invention. It\'s called a pooper hooper. I\'ll never have to pick up poop again!','',26124),
(57370,'enUS','Did you know that you can sometimes find rare onyx eggs on Windward Isle? If you bring one to a Serpent Master, you will gain great respect within the Order.','',26124),
(57371,'enUS','You gotta eat well to keep up your strength! That\'s what my mama always told me, anyway...','',26124),
(57372,'enUS','','I can\'t talk right now. I\'m very busy.',26124),
(57373,'enUS','','Could you come back later? I am busy training my cloud serpent right now. I must work harder if I wish to beat the others.',26124),
(57374,'enUS','','I\'m not worried about my competition. Because I know I will win.',26124),
(57375,'enUS','','The only one I\'m worried about is Qua-Ro. He always has some trick up his sleeve.',26124),
(57376,'enUS','','You wish to race against me? Ha! You\'ll be seeing the back of my serpent\'s tail.',26124),
(57377,'enUS','','I won\'t beat the others by standing around talking to you.',26124),
(57378,'enUS','','Oh yeah, I\'ve brought plenty of onyx eggs to Elder Anli. Whenever I give her one, I rise higher in the ranks of the Order.',26124),
(57379,'enUS','','If I don\'t work hard, I will fall behind.',26124),
(57380,'enUS','A studious rider is a successful rider.','',26124),
(57381,'enUS','Shouldn\'t you be practicing?','',26124),
(57382,'enUS','The best experience is one\'s own.','',26124),
(57383,'enUS','I can tell you my tricks for riding, but they are nothing compared to your own practice and experience.','',26124),
(57384,'enUS','Why am I so fast? If I tell you, I would only be disadvantaging myself.','',26124),
(57385,'enUS','Learn from the masters. I have nothing to teach you, for I am but a student.','',26124),
(57386,'enUS','The other trainees have their skills and talents. I am honored to ride with them.','',26124),
(57387,'enUS','It is an honor to ride with you.','',26124),
(57388,'enUS','','Hi! How are you?',26124),
(57389,'enUS','','If you need any help, just ask me!',26124),
(57390,'enUS','','Try to remember where the checkpoints are located. Once you know where to pick up the flags, you can chart the shortest course.',26124),
(57391,'enUS','','Flying through cloud rings is the best way to pick up speed. Sometimes it\'s worth going out of the way for that boost of speed!',26124),
(57392,'enUS','','Look around for new paths. Sometimes the fastest way is not the most obvious!',26124),
(57393,'enUS','','I\'ve heard from the other trainees that you can find rare onyx eggs at Windward Isle. I\'ve looked and looked, but I haven\'t found any yet!',26124),
(57394,'enUS','','Skill is important, but sometimes it comes down to luck.',26124),
(57395,'enUS','','Don\'t worry, I\'ll be rooting for you even if you come in last!',26124),
(57396,'enUS','I may not be the best rider, but I have the best inventions!','',26124),
(57397,'enUS','All the other trainees are such good riders. I hope to be as good as them someday. In the meantime, I just have to keep practicing!','',26124),
(57398,'enUS','','The care of a young serpent is a delicate thing.',26124),
(57399,'enUS','','Unless you want to help me clean the nests, you had best let me get back to work.',26124),
(57400,'enUS','','I spend half my time in the libraries and the other half caring for the hatchlings.',26124),
(57401,'enUS','','Do you know the history of the Serpent Riders? It is quite an interesting study.',26124),
(57402,'enUS','','Someday I hope to improve on our ancient knowledge. Much of it has been lost through the ages.',26124),
(57403,'enUS','','Someday when you have seen more of the world, you should come back and speak to me. I can tell you all about the Serpent Riders.',26124),
(57404,'enUS','','Speak to Elder Anli if you are interested in joining our ranks.',26124),
(57405,'enUS','We welcome all who wish to join our ranks, but you need some more experience before you can begin. Please come speak to me later.','',26124),
(57406,'enUS','A new student?$B$BYes, of course.$B$BYou come to me all bright-eyed and bob-tailed, thinking to take home a the great cloud serpent of the east.$B$BWell, you should consider the journey carefully.$B$BIt is not an easy path to take.$B$BThe Order only accepts students who have the potential to see their training through to the end.','',26124),
(57407,'enUS','','Welcome to The Arboretum, traveler.$B$BThis is the home of the Order of the Cloud Serpent. Together with our cloud serpents, we are sworn to defend The Jade Forest.$B$BYou, too, can join our ranks. However, you need more experience before you can begin the journey.$B$BGo and travel the land, then return to me when you are stronger.',26124),
(57408,'enUS','','There is no experience quite like riding on the back of a war serpent.',26124),
(57409,'enUS','','You are rough, untested, unranked. You fly alone.$B$BIf you wish to change this, speak to Elder Anli to the west.',26124),
(57410,'enUS','Ah, another admirer! My reputation precedes me, I\'m sure.$B$BDon\'t worry, someday perhaps you and I will ride together.','',26124),
(57411,'enUS','Don\'t worry, kid. Riding\'s not as hard as it looks.$B$BYou should get a few more notches on your belt before attempting this, though.','',26124),
(57412,'enUS','','I\'m sorry, I am too busy to speak to strangers.',26124),
(57413,'enUS','Someday, perhaps you too can aspire to become a serpent rider.','',26124),
(57414,'enUS','','Hi there!$B$BYou\'ll need a few more seasons behind you before joining us. Hope to see you soon!',26124),
(57415,'enUS','What is the Sky Race? Why, only the greatest test of a Serpent Rider\'s skill!','',26124),
(57416,'enUS','You want to race? An unseasoned pup like you?$B$BHa! Hahahahahaha!$B$BThe little ant wants to race against giants!','',26124),
(57417,'enUS','Help $p!','Help $p!',26124),
(57418,'enUS','$p! Over here!','$p! Over here!',26124),
(57419,'enUS','$p! There are mogu near! Watch out!','$p! There are mogu near! Watch out!',26124),
(57420,'enUS','','First place? Wow!$B$BPretty good for a young trainee.',26124),
(57421,'enUS','','Hey, 2nd place is darn good. You\'ll get \'em next time.',26124),
(57422,'enUS','','Top three is still quite impressive. Top half is better than the bottom half, am I right?',26124),
(57423,'enUS','','Fourth place. Well, it\'s not very remarkable. That\'s all right. You can always try again.',26124),
(57424,'enUS','','Fifth place? At least you weren\'t last.',26124),
(57425,'enUS','','Well you came in last.$B$BNowhere to go but up, right?',26124),
(57426,'enUS','Thank you so much $p!','Thank you so much $p!',26124),
(57427,'enUS','Thank you! They were saying we were going to be slaves.','Thank you! They were saying we were going to be slaves.',26124),
(57428,'enUS','I will never forget this, hero.','I will never forget this, hero.',26124),
(57429,'enUS','They said they were looking for slaves and weapons.','They said they were looking for slaves and weapons.',26124),
(57430,'enUS','%s is snoring peacefully.','%s is snoring peacefully.',26124),
(57431,'enUS','Oh great! Someone else has come to bother me.','',26124),
(57432,'enUS','Guess I\'ll just sleep for another day...','Guess I\'ll just sleep for another day...',26124),
(57433,'enUS','Just go away! Zhu\'s Watch takes care of itself. We don\'t need any help from so-called \"adventurers!\"','',26124),
(57434,'enUS','Master, I wish to review my basic training.','Master, I wish to review my basic training.',26124),
(57435,'enUS','Guardian! Awaken and defend your master!','',26124),
(57436,'enUS','Groundbreaker Brojai is reviving a Ruined Guardian.','',26124),
(57437,'enUS','You fail to bend the knee to our power? Then die like the vermin you are.','',26124),
(57438,'enUS','These... mogu... are tougher than I gave them credit for. And clever. You shouldn\'t have come, this is a trap.','',26124),
(57439,'enUS','<Try to free Kor Bloodtusk from his bonds.>','<Try to free Kor Bloodtusk from his bonds.>',26124),
(57440,'enUS','KOR! NOOOOOOOO!','',26124),
(57441,'enUS','Hey, $p, come over here! Ken-Ken thinks he knows how to fix sad pandas!','',26124),
(57442,'enUS','Prepare to bask in my victory, ladies and gentlemen!','',26124),
(57443,'enUS','Let\'s go to The Dancing Serpent Inn after the race to toast my victory. The first round\'s on you!','',26124),
(57444,'enUS','I won\'t be getting any dirt on this beautiful face.','',26124),
(57445,'enUS','I\'m going to beat you all with my latest invention. It\'s a cloud magnet!','',26124),
(57446,'enUS','I\'m going to beat you all with my latest invention. It\'s a remote control rider unseater!','',26124),
(57447,'enUS','Uh uh! Wait till you guys get a whiff of my latest invention! I\'ll give you a hint. It\'s a pumpkin soaker!','',26124),
(57448,'enUS','Uh uh! Wait till you guys get a whiff of my latest invention! I\'ll give you a hint. It\'s a squash rocket!','',26124),
(57449,'enUS','I\'m going to beat you all with my latest invention. It\'s a quick flag extractor!','',26124),
(57450,'enUS','I\'m going to beat you all with my latest invention! It\'s a checkpoint position finder!','',26124),
(57451,'enUS','I\'m going to beat you all with my latest invention! It\'s a wind funneler!','',26124),
(57452,'enUS','I\'m going to beat you all with my latest invention! It\'s a carrot on a stick!','',26124),
(57453,'enUS','','I\'ve been practicing all week for this!',26124),
(57454,'enUS','','I\'ll wait for you all on the other side of the finish line!',26124),
(57455,'enUS','','After the race, I\'ll be sure to show you all my first place prize!',26124),
(57456,'enUS','Retreat!','',26124),
(57457,'enUS','Too... worthy... a foe...','',26124),
(57458,'enUS','Master, I wish to review my advanced training.','Master, I wish to review my advanced training.',26124),
(57459,'enUS','Yes, the one with the eggs.','Yes, the one with the eggs.',26124),
(57460,'enUS','Advanced training? Do you mean the one with the eggs?','',26124),
(57461,'enUS','Out of the scroll, demon!','',26124),
(57462,'enUS','I grant you eternal peace!','',26124),
(57463,'enUS','I free you from existence!','',26124),
(57464,'enUS','You there! In the rafters! My sacred library has become possessed by the Sha!','',26124),
(57465,'enUS','See how they pour from every letter of these sacred scrolls... corrupting them! Defiling them!','',26124),
(57466,'enUS','You will taint these scrolls no longer!','',26124),
(57467,'enUS','You must destroy the source of the corruption! Quickly, before our cherished history is erased forever!','',26124),
(57468,'enUS','The mogu are usually thugs and brigands. They never struck me as having the patience for arcane magics.','',26124),
(57469,'enUS','The ruins of Korja were where something important happened sometime, I guess. I may have snoozed through that history lesson.','',26124),
(57470,'enUS','Did you hear? Dezco named one of the twins \"$p\".','',26124),
(57471,'enUS','The first rule of roll club: you don\'t talk about roll club.$B$BThe second rule of roll club: if it\'s your first time, you roll.','',26124),
(57475,'enUS','Let\'s roll.','Let\'s roll.',26124),
(57476,'enUS','Thank you, stranger.','Thank you, stranger.',26124),
(57477,'enUS','My watch continues.','',26124),
(57478,'enUS','We serve until death, and sometimes after that.','',26124),
(57479,'enUS','I will return my fists to the battle.','',26124),
(57480,'enUS','Just a flesh wound.','',26124),
(57481,'enUS','I fought on the frontlines of the Qiraji war and charged the depths of Azjol-Nerub. I know first hand the threat that an insect legion can have on the world when left unchecked.','',26124),
(57482,'enUS','We were heading west when we received word of the mantid attack and redirected here.','',26124),
(57483,'enUS','I miss Leza.','',26124),
(57484,'enUS','These pandaren are skilled warriors despite being civilians.','',26124),
(57485,'enUS','Between mantid, soren, mogu, fever, and countless beasts of this jungle, I refuse to let my children out of my sight.','',26124),
(57486,'enUS','The mantid?! I always thought they were a spooky legend pandaren tell their children.','',26124),
(57487,'enUS','The Shado-Pan are legendary. Their force is unmatched in Pandaria.','',26124),
(57488,'enUS','Since meeting you I have fought legends and seen countless wonders.','',26124),
(57489,'enUS','Thank you, hero.','Thank you, hero.',26124),
(57490,'enUS','I must get to Stoneplow! The mantid will attack soon.','I must get to Stoneplow! The mantid will attack soon.',26124),
(57491,'enUS','The mogu ambushed us while we were trying to retreat from the mantid.','The mogu ambushed us while we were trying to retreat from the mantid.',26124),
(57492,'enUS','My thanks, stranger.','My thanks, stranger.',26124),
(57493,'enUS','Our envoy was making for the Crane Temple when the mogu ambushed us.','',26124),
(57494,'enUS','Face these \"mantid\" $p and we\'ll continue our assault on the Mogu. With luck, we should join you shortly.','',26124),
(57495,'enUS','I\'m confused as to how these raiders are constantly able to assail us no matter how many of them we kill.','',26124),
(57496,'enUS','These raiders stole the cloths off our dead, the trinkets out of our homes, and the ingots out of our forge. What sort of behavior is that?','',26124),
(57497,'enUS','The Crane Temple usually comes to our defense and keeps the raiders at bay. But lately they have been quiet.','',26124),
(57498,'enUS','Greetings $p. The waters foretold of your arrival. Unfortunately they didn\'t foretell of the raiders hitting us so hard.$b$bI am Waterspeaker Tired Shushen. Welcome to Fallsong.','',26124),
(57499,'enUS','<Farmer Yoon wipes his brow wearily.>$B$BThis is hopeless! I\'ll never move these rocks!','',26124),
(57500,'enUS','Kor, why did you do this? Vengeance is not worth dying over.','',26124),
(57501,'enUS','$p, meet me at Dawnchaser Retreat. I must see to my brother\'s remains, and then we must deal with this mantid threat.','',26124),
(57502,'enUS','Take over for me... uh... what\'s your name? $n? Thank you, $n. I need a break.','',26124),
(57503,'enUS','You can find me in my house if you need me.','',26124),
(57504,'enUS','We live, we fight, we die. The tricky part is finding a reason to do each of those.','',26124),
(57505,'enUS','The pandaren are a noble race, and one that I am willing to fight alongside.','',26124),
(57506,'enUS','Have you named the twins?','Have you named the twins?',26124),
(57507,'enUS','Indeed! The young one on my chest is named \"Kor\", for my oldest friend.$b$bAnd this young champion on my back is named \"$p\", for his savior.','',26124),
(57508,'enUS','Thanks, but I have a girl\'s name.','Thanks, but I have a girl\'s name.',26124),
(57509,'enUS','Well then perhaps his deeds will be so great that history will remember it as a bull\'s name.','',26124),
(57510,'enUS','Farming is much harder than it looks.','',26124),
(57511,'enUS','Hey, Yoon! Come out here!','',26124),
(57512,'enUS','So, you\'ve taken over the ranch for good, eh?','',26124),
(57513,'enUS','Let\'s get one thing straight. You may be Old Yoon\'s cub, but you\'re still a citypaw.','',26124),
(57514,'enUS','You even know how to run a farm? Know what, I\'ll save you the trouble. Sell me this here piece of land and go back where you came from.','',26124),
(57515,'enUS','Do as you please, city boy, but I wager you won\'t last a week. I mean, just look at this dump!','',26124),
(57516,'enUS','Pshaw, sell me your land and I\'ll save you the trouble.','',26124),
(57517,'enUS','I wager you won\'t last a week.','',26124),
(57518,'enUS','Come on boys, let\'s leave him to his \"farming.\"  Ho ho ho!','',26124),
(57519,'enUS','Oh, oh my! Mr. Mudclaw! I didn\'t expect such an important visitor.','',26124),
(57520,'enUS','You? Join the Tillers? Ha! You\'d have to prove your farming skills to all five members of our Council. They would never vote for you!','',26124),
(57521,'enUS','You are THE Haohan Mudclaw, right? Head of the Tiller\'s Union? They are the master farmers in all of Pandaria!','',26124),
(57522,'enUS','Yessir! My grandfather left me this farm. Just moved in the other day. Nice to meet you, neighbor!','',26124),
(57523,'enUS','Besides, once I\'ve gotten the hang of this, I want to be a Tiller like the rest of you!','',26124),
(57524,'enUS','B-but it\'s my family farm. I can\'t just sell it.','',26124),
(57525,'enUS','Never say never, my grandpa always said. I\'m going to give it my best shot.','',26124),
(57526,'enUS','Hey, do I hear someone outside?','',26124),
(57527,'enUS','I give \'im five days.','',26124),
(57528,'enUS','Two days, tops!','',26124),
(57529,'enUS','I\'ll help you, Farmer Yoon.','I\'ll help you, Farmer Yoon.',26124),
(57530,'enUS','No thanks, I\'ll be on my way.','No thanks, I\'ll be on my way.',26124),
(57531,'enUS','Yes! Together, we\'ll work until we join the Tiller\'s Union!','',26124),
(57532,'enUS','Awww shucks. At this rate, I\'ll never get to join the Tiller\'s Union. Well, let me know if you ever change your mind.','',26124),
(57533,'enUS','%s lets out a pitiful wail.','',26124),
(57535,'enUS','I suppose I\'ll just add this to the stew. We were short on meat anyways.','',26124),
(57537,'enUS','The Pools of Youth were an ancient fable my grandsires told me long ago. Now this old man intends to find them!','',26124),
(57538,'enUS','I used to live only for the pursuit of knowledge.$b$bNow I spend every waking hour searching for a way for our people to rekindle our lost immortality.','',26124),
(57539,'enUS','My daughter Lyalia would have me spend the rest of my days cleaning a temple.$b$bBah! I have never felt so alive as when I chose to step through the portal to this strange and beautiful land.','',26124),
(57540,'enUS','Greetings, $r! Well timed indeed.$b$bWe had not expected to find anyone from the Alliance in this land.','',26124),
(57541,'enUS','Look for the shackles around the edges of the oubliette. There should be three.','',26124),
(57542,'enUS','Gone to the market. For official Tiller\'s Union business, please find me at Halfhill Market. Otherwise, Mung-Mung can take care of any needs.\n\n- Haohan Mudclaw','',26124),
(57543,'enUS','','Snuck out while my dad wasn\'t looking. Find me at Halfhill Market!\n\n- Tina Mudclaw',26124),
(57544,'enUS','','Took the fish to market. See you at Halfhill!\n\n- Fish',26124),
(57545,'enUS','','If you find this note, then I am either dead or at Halfhill Market.$B$BHopefully I have temporarily left my post to enjoy a hot mug of ale in town. Perhaps you should go check, just in case.$B$BIf indeed I have failed my mission, please send my love and effects to my family in Zhu\'s Watch.\n\n- Sho',26124),
(57546,'enUS','M A r c K e T.\n\n- Chee Chee','',26124),
(57547,'enUS','<<Event: Lorekeeper Vaeldrin drinks the potion and transfers his life essence to all npcs around him>>','',26124),
(57548,'enUS','Went to Halfhill Market. Please show yourselves out.\n\n- Old Hillpaw','',26124),
(57549,'enUS','','Out for the day at Halfhill Market.\n\n- Ella',26124),
(57552,'enUS','','My father is here for the Pools of Youth. I\'m here at Tyrande Whisperwind\'s command.',26124),
(57553,'enUS','','My sentinels have faced far worse than this jungle has to offer.',26124),
(57554,'enUS','','Something about this land seems to be affecting our squad\'s morale.',26124),
(57555,'enUS','','This jungle is nice and humid compared to the arid deserts of Uldum.',26124),
(57556,'enUS','','Tyrande hand picked me for this mission.$b$BShe said it was because of her visions but I am guessing it was because my father was the one who talked her in to approving the mission.',26124),
(57557,'enUS','','For all of its dangers, this land is a hunter\'s paradise.',26124),
(57558,'enUS','','You saved the lives of my sentinels, hero. You have my everlasting gratitude. Now we can continue with our mission.',26124),
(57559,'enUS','Ah, $p! I was searching for the Hidden Master when I came across this big purple thing with a bunch of little purple things inside.$b$bLooks like an old mogu magic trap. Thankfully they don\'t know how to build these anymore.','',26124),
(57560,'enUS','These creatures are fascinating. Great fighters. Though so thin...','',26124),
(57562,'enUS','','Father, we need to deal with the Horde scout first.',26124),
(57563,'enUS','5...','',26124),
(57564,'enUS','4...','',26124),
(57565,'enUS','3...','',26124),
(57566,'enUS','2...','',26124),
(57567,'enUS','1...','',26124),
(57568,'enUS','Get away from the sabotaged tank before it blows!','',26124),
(57572,'enUS','Nothing like a fresh harvest of vegetables for your soup.','',26124),
(57573,'enUS','Hey Chef! I gotta ask you...are we friends?','Hey Chef! I gotta ask you...are we friends?',26124),
(57575,'enUS','','Of course, $n! We\'re really good friends.$B$BDon\'t you remember the time that you saved me from that mountain hozen? And then afterward we got drunk and lost our pants?',26124),
(57576,'enUS','Ah, it\'s about time. Will you free me, or did you have... other ideas?','',26124),
(57577,'enUS','|cFF0008E8Rogue:|r <Pick the shackle locks.>','|cFF0008E8Rogue:|r <Pick the shackle locks.>',26124),
(57578,'enUS','<Unlock the shackles.>','<Unlock the shackles.>',26124),
(57579,'enUS','I don\'t have the shackles key.','I don\'t have the shackles key.',26124),
(57580,'enUS','<Leave him shackled.>','<Leave him shackled.>',26124),
(57581,'enUS','The Captain of the Guard upstairs, Hedric Evencane, should posses a key. Please, make haste. We do not have all night, you know!','',26124),
(57582,'enUS','This water looks pretty good over here.','',26124),
(57583,'enUS','Somethin\'s a little funny about this here water...','',26124),
(57584,'enUS','Boy howdy! Look at this pretty little pool!','',26124),
(57585,'enUS','Let\'s see here...','',26124),
(57586,'enUS','This water seems a little too... what\'s that word? Oh yeah, clean.','',26124),
(57587,'enUS','Now this is what I\'m talkin\' about! Ain\'t no spiders or crabs in this water.','',26124),
(57588,'enUS','This should be the last of it.','',26124),
(57589,'enUS','Ouch!','',26124),
(57590,'enUS','Hot damn!','',26124),
(57591,'enUS','Crap!','',26124),
(57592,'enUS','Looks like he\'s got a little bit o\' that water stuck in his gills. I\'ll just scoop some of this up...','',26124),
(57593,'enUS','I\'ll just scrape some of this water from his little spider mouth-parts. A little bit o\' poison never hurt no one, right?','',26124),
(57594,'enUS','Holy smokes, this fella swallowed a lot of water. I oughta pick some up.','',26124),
(57595,'enUS','I\'ll bet that Chen never made no croc-belly-water beer.','',26124),
(57596,'enUS','The Sunreavers will not be pleased. Mark my words, we\'re not an organization to be taken lightly.','',26124),
(57597,'enUS','My thanks! Shall we make our way off this miserable little island?','',26124),
(57598,'enUS','Let\'s head out into that glade. Look for dark, swirling pools of water... that\'ll be the good stuff.','',26124),
(57599,'enUS','I\'m ready to go, Mudmug.','I\'m ready to go, Mudmug.',26124),
(57600,'enUS','You ready to go water-huntin\'?','',26124),
(57601,'enUS','The |cFFFE9A2EKrik\'thik Protectorate|r reinforcements appear!','',26124),
(57602,'enUS','The |cFFFE9A2EKrik\'thik Engulfer|r reinforcements appear above!','',26124),
(57603,'enUS','The |cFFFE9A2EKrik\'thik Swarm Bringer|r reinforcements join the battle!','',26124),
(57604,'enUS','I beseech you, kind strangers. Cleanse this place of their foul presence! Lay our stories to rest!','',26124),
(57605,'enUS','Oh, my. If I am not mistaken, it appears that the tale of Zao Sunseeker has come to life before us.','',26124),
(57606,'enUS','Thank you, heroes. I...','',26124),
(57607,'enUS','According to the legend, long ago, there were five suns that burned brightly in the sky. When the winds blew, their intense heat caused great wildfires.','',26124),
(57608,'enUS','Crops wilted, villages burned, and families wandered endlessly to seek refuge from the flames...','',26124),
(57609,'enUS','I reckon we got enough.','',26124),
(57610,'enUS','The fires, they are burning the library! Please, heroes! Purge this evil before the temple crumbles to ash!','',26124),
(57611,'enUS','Zao was a true champion of our people, how sad it is to see his story tainted by the sha. I am relieved to see justice served to his memory.','',26124),
(57612,'enUS','You have my thanks, heroes. You have given peace to this sacred temple.','',26124),
(57613,'enUS','Now, off with you! I require meditation before I begin the restoration ritual.','',26124),
(57614,'enUS','Ah, it is not yet over. From what I see, we face the trial of the yaungol. Let me shed some light...','',26124),
(57623,'enUS','The blistering heat must have dulled my senses... mirages! All of you!','',26124),
(57624,'enUS','As the tale goes, Zao battled furiously... shooting his arrows high into the sky, until only one sun remained.','',26124),
(57625,'enUS','Somethin\' pinched me! Get it, $p!','',26124),
(57626,'enUS','Water spider! Smush him, $p!','',26124),
(57627,'enUS','Dang ol\' croc nearly took off my hand!','',26124),
(57628,'enUS','%s\'s |cFFFF0000Weak Spot|r is exposed! Attack it to break his Impervious Carapace!','',26124),
(57629,'enUS','','It... it\'s a trap...',26124),
(57630,'enUS','<Try to untie Lyalia.>','<Try to untie Lyalia.>',26124),
(57631,'enUS','Lyalia! I am so sorry, my child.','',26124),
(57632,'enUS','$p, meet me at the Sentinel Basecamp. I must bring my daughter\'s body there. We still have the Water of Youth.','',26124),
(57633,'enUS','','Now that we\'re acquaintances, $n, let me give you a tip. Folks \'round here can help spruce up your farm, but you gotta become friends with them first. Make friends by helping them out with daily tasks, or by giving them gifts like the one you just gave me.',26124),
(57634,'enUS','Retreat!','',26124),
(57635,'enUS','LYALIA! NOOOOOOOO!','',26124),
(57636,'enUS','<Drool dangles down the side of Jogu\'s mouth.>','',26124),
(57637,'enUS','Um, hello?','Um, hello?',26124),
(57638,'enUS','Hi! I work with Farmer Yoon down the road. How are you?','Hi! I work with Farmer Yoon down the road. How are you?',26124),
(57639,'enUS','Hey, how\'s it going? I\'m new around here.','Hey, how\'s it going? I\'m new around here.',26124),
(57640,'enUS','Why hello. I\'m from out of town.','Why hello. I\'m from out of town.',26124),
(57641,'enUS','Hello sir. Do you live around here?','Hello sir. Do you live around here?',26124),
(57642,'enUS','Hello. Nice to meet you.','Hello. Nice to meet you.',26124),
(57643,'enUS','Hello Mr. Mudclaw. I don\'t know if you saw me earlier, but I\'m helping Farmer Yoon out on his farm.','Hello Mr. Mudclaw. I don\'t know if you saw me earlier, but I\'m helping Farmer Yoon out on his farm.',26124),
(57644,'enUS','I couldn\'t help but notice you from over there. I\'m new in town.','I couldn\'t help but notice you from over there. I\'m new in town.',26124),
(57645,'enUS','Are you really called Fish? That\'s an unusual name.','Are you really called Fish? That\'s an unusual name.',26124),
(57646,'enUS','Buuuuuuuuuurrrppp!','',26124),
(57647,'enUS','You need a lift?','',26124),
(57648,'enUS','I need to meet up with Chen Stormstout.','I need to meet up with Chen Stormstout.',26124),
(57649,'enUS','I need to meet up with Ken-Ken, the hozen.','I need to meet up with Ken-Ken, the hozen.',26124),
(57650,'enUS','I need to meet up with Kang Bramblestaff.','I need to meet up with Kang Bramblestaff.',26124),
(57651,'enUS','Ah yes, I\'ve heard about him. He\'s visiting Pang\'s Stead, over in Thunderfoot Fields.$b$bYou ready to go?','',26124),
(57652,'enUS','Ah yes, I\'ve heard about him. He\'s visiting Mudmug\'s Place, right?$b$bI can take you when you\'re ready.','',26124),
(57653,'enUS','Ah yes, I\'ve heard about him. He\'s visiting Halfhill with Mudmug, right?$b$bI can take you there when you\'re ready.','',26124),
(57654,'enUS','Ah yes, I\'ve heard about him. He\'s down at the brewery, right?$b$bI can take you there when you\'re ready.','',26124),
(57655,'enUS','Let\'s go.','Let\'s go.',26124),
(57656,'enUS','Ken-Ken... I think I heard a rumor that he was staying in Zhu\'s Watch.$b$bShall I take you there?','',26124),
(57657,'enUS','Ken-Ken... I think I heard a rumor that he was staying somewhere near the Temple of the Red Crane.$b$bShall I take you there?','',26124),
(57658,'enUS','The \"failed\" siege was merely a feint, of course. You didn\'t realize?','',26124),
(57659,'enUS','Do you like gifts?','Do you like gifts?',26124),
(57660,'enUS','Mrhmhmm...do I likesh giftsh? Well yesh, of coursh! Who doesn\'t like giftsh?','',26124),
(57661,'enUS','This Ruby Shard is for you.','This Ruby Shard is for you.',26124),
(57662,'enUS','This Blue Feather is for you.','This Blue Feather is for you.',26124),
(57663,'enUS','This Marsh Lily is for you.','This Marsh Lily is for you.',26124),
(57664,'enUS','This Jade Cat is for you.','This Jade Cat is for you.',26124),
(57665,'enUS','This Lovely Apple is for you.','This Lovely Apple is for you.',26124),
(57666,'enUS','I think you\'re mistaken, friend. You don\'t have anything that I want.','',26124),
(57667,'enUS','That Bramblestaff boy is down in the wilds, fraternizing with those \"tauren\" at Thunder Cleft. He\'s looking for trouble, if you ask me.$b$bYou want to join him?','',26124),
(57668,'enUS','That Bramblestaff boy is down in the wilds, fraternizing with those \"tauren\" at Dawnchaser Retreat. He\'s looking for trouble, if you ask me.$b$bYou want to join him?','',26124),
(57669,'enUS','That Bramblestaff boy is down in the wilds, fraternizing with those \"night elves\" at the place they call \"the Incursion\". He\'s looking for trouble, if you ask me.$b$bYou want to join him?','',26124),
(57670,'enUS','That Bramblestaff boy is down in the wilds, fraternizing with those night elves at their base camp. He\'s looking for trouble, if you ask me.$b$bYou want to join him?','',26124),
(57671,'enUS','Drinking ain\'t so nice on an empty stomach. Give a jinyu something to eat, eh?','',26124),
(57672,'enUS','Giftsh? Well here\'s an idea.$B$BYou know what goesh great wid a tasty drink? A tasty shnack.','',26124),
(57673,'enUS','I\'ve changed my mind.','I\'ve changed my mind.',26124),
(57674,'enUS','This Jade Forest Fried Rice is for you.','This Jade Forest Fried Rice is for you.',26124),
(57675,'enUS','This Swirling Mist Soup is for you.','This Swirling Mist Soup is for you.',26124),
(57676,'enUS','These Shrimp Dumplings are for you.','These Shrimp Dumplings are for you.',26124),
(57677,'enUS','This Forest Pheasant Roast is for you.','This Forest Pheasant Roast is for you.',26124),
(57678,'enUS','This Charbroiled Tiger Steak is for you.','This Charbroiled Tiger Steak is for you.',26124),
(57679,'enUS','This Hozen Stir Fry is for you.','This Hozen Stir Fry is for you.',26124),
(57680,'enUS','This Braised Wolf is for you.','This Braised Wolf is for you.',26124),
(57681,'enUS','This Fire Spirit Salmon is for you.','This Fire Spirit Salmon is for you.',26124),
(57682,'enUS','This Twin Fish Platter is for you.','This Twin Fish Platter is for you.',26124),
(57683,'enUS','This Eternal Blossom Fish is for you.','This Eternal Blossom Fish is for you.',26124),
(57684,'enUS','You ever heard of Sauteed Carrots? It\'sh my favorite food. I wish I had some right now...hic!','',26124),
(57685,'enUS','I ate a Lovely Apple once. It was delishioush.$B$B<Jogu stares blankly into the distance, as if he\'s lost his train of thought.>','',26124),
(57686,'enUS','Ohhhh, pretty! I like it!','',26124),
(57687,'enUS','Oh, a Lovely Apple! Thish must me by lucky day!','',26124),
(57688,'enUS','It\'sh a nice kitty, just like in my lasht brew dream...hic!','',26124),
(57689,'enUS','It\'sh a feather. Sho bootiful. Thank you...hic!','',26124),
(57690,'enUS','Oh...these flowersh remind me of home.','',26124),
(57691,'enUS','Oh, Sauteed Carrots! My favorite!','',26124),
(57692,'enUS','Mmmm, did you make thish yourself? It\'sh just what I wanted, thank you!','',26124),
(57693,'enUS','Ash nuzzles Sentinel Commander Lyalia.','',26124),
(57694,'enUS','','They... came out of nowhere. Ambush.',26124),
(57695,'enUS','You have been an asset to Stoneplow, $n. We may call upon you again in the future. Until then, you should speak with our flight master. He will take you wherever you need to go... free of charge.','',26124),
(57696,'enUS','','Ash can get me back to the Incursion. Please, $p, bring those poisoned blades.',26124),
(57697,'enUS','','Well, what\'s it gonna be, stranger? I\'ve got a market to run.',26124),
(57698,'enUS','','You\'ve come to the right place, stranger! Halfhill Market\'s got everything you need.',26124),
(57699,'enUS','','Looking for food and brew, stranger? We\'ve got it right here at Halfhill Market.',26124),
(57700,'enUS','','Well don\'t just stand there, stranger! You got any gossip for me?',26124),
(57701,'enUS','','You here to buy or sell, stranger? Feel free to look around.',26124),
(57702,'enUS','Do you need something? I\'m a little... busy.$B$B<Koro tightens his grip on the wriggling saurok\'s neck.>','',26124),
(57703,'enUS','What can you tell me about gifts?','What can you tell me about gifts?',26124),
(57704,'enUS','','What\'s there to know? You like somebody, you give them something they like.',26124),
(57705,'enUS','','Who doesn\'t like receiving a gift?$B$BMe - I love flowers.',26124),
(57706,'enUS','','You should give beautiful flowers to beautiful ladies. Like me.',26124),
(57707,'enUS','','Many beautiful flowers grow around here, but my favorite is the Marsh Lily. Unfortunately, those gorgeous blooms are rare to find.',26124),
(57708,'enUS','','You know what I have a craving for? A good bowl of Swirling Mist Soup. That would sure taste good right now.',26124),
(57709,'enUS','','You know what they say - help your neighbors and your neighbors will help you.$B$BSure, you can help \'em out with chores now and then, but gifts make faster friends, don\'tcha think?',26124),
(57710,'enUS','','Where can you find gifts? Have you tried looking around the fields?$B$BYou never know what you can run across around these farms.$B$BMaybe you\'ll even dig something up on your own land!',26124),
(57711,'enUS','','Working all day in the fields works up a big appetite.$B$BYou didn\'t hear it from me, but most o\' the folk here can eat a woman out of a market stall.$B$BMost everyone has a favorite dish. If you\'ve got any cooking skill, they\'ll be hankering to try your dishes.',26124),
(57712,'enUS','Welcome. We\'ll hold just a few seconds to see if anyone else is coming along.','',26124),
(57713,'enUS','','<Blanche shouts over the commotion of the storm.>$B$BYou made it! The boiler and the brewkegs are in place... now all we need is Mother Nature to work her magic.$B$BWhat do you say? Are you ready for some fireworks?',26124),
(57714,'enUS','Show me what you got, Blanche!','Show me what you got, Blanche!',26124),
(57715,'enUS','We\'re gonna turn this place into a sinkhole, heh.','',26124),
(57716,'enUS','We\'ve rigged the powder barrels in every ship.','We\'ve rigged the powder barrels in every ship.',26124),
(57717,'enUS','','I can tell you where everyone in this town lives. Who are you looking for?',26124),
(57718,'enUS','Where does Ella live?','Where does Ella live?',26124),
(57719,'enUS','Where does Old Hillpaw live?','Where does Old Hillpaw live?',26124),
(57720,'enUS','Where does Sho live?','Where does Sho live?',26124),
(57721,'enUS','Where does Chee Chee live?','Where does Chee Chee live?',26124),
(57722,'enUS','Where does Haohan Mudclaw live?','Where does Haohan Mudclaw live?',26124),
(57723,'enUS','Where does Tina Mudclaw live?','Where does Tina Mudclaw live?',26124),
(57724,'enUS','Where does Gina Mudclaw live?','Where does Gina Mudclaw live?',26124),
(57725,'enUS','Where does Farmer Fung live?','Where does Farmer Fung live?',26124),
(57726,'enUS','Where does Jogu live?','Where does Jogu live?',26124),
(57727,'enUS','I can\'t find someone. Help!','I can\'t find someone. Help!',26124),
(57728,'enUS','','Ella lives at the very western end of the farmlands, just north of the Stormstout Brewery.$B$BShe\'s been living alone since her parents died, poor thing.',26124),
(57729,'enUS','','Old Hillpaw lives up on the rise to the northwest. His farm is just south of the mountain.$B$BPoor old man\'s shut everyone out since his son died.',26124),
(57730,'enUS','','Chee Chee\'s got his own farm to the northwest, just up the mountain some.$B$BThat poor fella\'s been plagued by one ill turn after another.',26124),
(57731,'enUS','','That strange girl Sho\'s been hanging around up the mountain.$B$BNo one knows where she comes from, but she\'s trained in the assassin\'s arts.$B$BJust showed up one day to help us with our hozen problem. Nice girl, but she don\'t talk much.',26124),
(57732,'enUS','','Oh Fish? That sweet girl lives up at the docks to the north.$B$BI\'ve known that girl since she was a little\'un.$B$BShe\'s always digging in mud or swimmng in the lake or jumping off trees. Her parents sure named her right, cuz she\'s as slippery as a fish.',26124),
(57734,'enUS','','My father lives in his farmhouse in the middle of the farmlands. He\'s just east of the big ol\' crane statue.$B$BHe owns almost all the fertile land in the valley, and he never lets anyone forget it.$B$BThat\'s why I left home, you know. He thinks he owns everything...and everyone.',26124),
(57735,'enUS','','My sister lives with my father in his farmhouse in the middle of the farmlands, just east of the big ol\' crane statue.$B$BI like to see my sister now and then, but she\'s usually too busy making herself look pretty for the next farmboy to pass through these parts.',26124),
(57736,'enUS','','Ahh Jogu...he\'s probably passed out behind the still. Just go a few yards to the south to the watering hole and you can\'t miss him.$B$BHe came wandering through town a while back and hasn\'t ever left.$B$BThe locals love him. He\'s got quite the knack for predicting the harvest.',26124),
(57737,'enUS','','You can\'t find someone? Well only three possible places a person can be.$B$BEither they\'re here at the market, or they\'re at their own house for the day, or they\'re at Sunsong Ranch.$B$BIf you don\'t see them at any of those places, you might need your eyes checked!',26124),
(57738,'enUS','Where does Fish Fellreed live?','Where does Fish Fellreed live?',26124),
(57739,'enUS','Where does everyone live?','Where does everyone live?',26124),
(57740,'enUS','','See you at the ruins of the Lost Dynasty, $p.',26124),
(57741,'enUS','','Farmer Fung lives just north of town, right near the water tower.$B$BI know him well, unfortunately.',26124),
(57742,'enUS','','Who are you looking for? Give me your map there and I\'ll mark it for you.',26124),
(57743,'enUS','','You addled goose, that\'s me! Who do you think you\'re talking to!?',26124),
(57744,'enUS','','The trees here are more beautiful than any I have seen in my travels.',26124),
(57745,'enUS','','Lorekeeper Vaeldrin insists he can find the Pools of Youth.$b$bShould we succeed, imagine what that would do for our people. To be immortal again...',26124),
(57746,'enUS','Zao has become corrupted too! Please, fight him with dignity...','',26124),
(57747,'enUS','','High Priestess Tyrande was hesitant to approve this mission.$b$bShe seemed to believe the source of Vaeldrin\'s research to be a double edged sword.$b$bAfter spending days in that arcanic oubliette, I am beginning to think she might not have been wrong.',26124),
(57748,'enUS','I can allow this no longer!','',26124),
(57749,'enUS','','Kang says the mogu are ruffians and bandits.$b$bFrom what we\'ve seen so far, I think they might be becoming a larger threat than any of the pandaren suspect.',26124),
(57750,'enUS','','Oh! Hello...$B$B<Ella\'s face turns pink and she looks down shyly.>',26124),
(57751,'enUS','','Thankfully our allies on the other side of the portal can send supplies through now that the oubliette is disabled.$b$bUnfortunately we still haven\'t disabled the trap preventing us from returning through it.',26124),
(57752,'enUS','','Aly... Alynna is in command.',26124),
(57753,'enUS','','My... blood burns.',26124),
(57754,'enUS','','Tyrande warned... she... she said there would be great dark... before light.',26124),
(57755,'enUS','Mama Bramblestaff often told me if I didn\'t stop breaking her vases she would ship me off to the Dungeons of Dojan.','',26124),
(57756,'enUS','I\'ve never heard of mogu gathering in such large numbers before.','',26124),
(57757,'enUS','These mogu may be clunky in their movements but their faces are hard on the knuckles.','',26124),
(57758,'enUS','I think I saw some mogu digging up artifacts.$b$bThat can\'t be good.$b$bWe still tell tales of all the evil stuff the mogu did when they knew how to use artifacts and arcane powers.','',26124),
(57759,'enUS','My marines are already on shore, holding the harbor entrance.$B$BYou have your orders. Do your jobs, and return safely.$B$BThe eyes of Hellscream are upon you!','',26124),
(57760,'enUS','I spent so long trying to find a way to extend my life that I forgot to live it.','',26124),
(57761,'enUS','I thought I would have more time. I always thought...','',26124),
(57762,'enUS','And now this... folly... would cost my daughter her life.','',26124),
(57763,'enUS','I love you, my little Lyalia.','',26124),
(57764,'enUS','The water may not create life, but at least it will let me transfer it.','',26124),
(57765,'enUS','','Thank you so much for the lovely gift, $n. Cats are my favorite!',26124),
(57766,'enUS','','I was getting real sick of eating turnips.',26124),
(57767,'enUS','','These dumplings look delicious!',26124),
(57768,'enUS','','I can\'t wait to try these.',26124),
(57769,'enUS','','Did you cook these yourself?',26124),
(57770,'enUS','Honoring','Honoring',26124),
(57771,'enUS','The battle is ours. Finally, peace...','',26124),
(57772,'enUS','It\'s done. The Fist of Garrosh is dropping the bomb.','It\'s done. The Fist of Garrosh is dropping the bomb.',26124),
(57773,'enUS','Sounds like you\'ve really stirred up a hornet\'s nest, $c.$B$BReady to set sail?','',26124),
(57774,'enUS','','Sentinels, saddle up and prepare to move out! Xintar, carve us a portal to the next location. We are leaving a small garrison here and pressing northwestward.',26124),
(57775,'enUS','','Tyrande sent us here as a vanguard for the Light.',26124),
(57776,'enUS','','Even the very air is ripe with sadness.',26124),
(57777,'enUS','','Us meeting on these shores is more than just random chance.',26124),
(57778,'enUS','Sentinel Commander Lyalia needs your report.','Sentinel Commander Lyalia needs your report.',26124),
(57779,'enUS','It\'s alright, girl. Relax.','',26124),
(57780,'enUS','There, there.','',26124),
(57781,'enUS','Take it easy, girl. You\'ll be up and running again in no time.','',26124),
(57782,'enUS','Stay calm. I\'m here, you\'re safe.','',26124),
(57783,'enUS','','Here you go. Keep the report safe, $p. The sunwalkers are moving west as well.$b$bI\'m going to stay here and help these people. We would stand a better chance if you stay and help us out.',26124),
(57784,'enUS','Where did all of these mogu come from?','Where did all of these mogu come from?',26124),
(57785,'enUS','Thank you for rescuing us, $c. Hopefully now our mission will not be lost.','Thank you for rescuing us, $c. Hopefully now our mission will not be lost.',26124),
(57786,'enUS','These \"elf\" creatures. Can they be trusted?','These \"elf\" creatures. Can they be trusted?',26124),
(57787,'enUS','First mantid, then mogu. These are dark days indeed.','First mantid, then mogu. These are dark days indeed.',26124),
(57788,'enUS','I don\'t know what brought you into the Forbidden Jungle, but I am glad it did. You saved us from slavery... or worse.','I don\'t know what brought you into the Forbidden Jungle, but I am glad it did. You saved us from slavery... or worse.',26124),
(57789,'enUS','When did the mogu learn to wield magic portals?','When did the mogu learn to wield magic portals?',26124),
(57790,'enUS','The mogu chose the worst time to attack. The mantid are on the move, and not even the great wall will hold them back.','The mogu chose the worst time to attack. The mantid are on the move, and not even the great wall will hold them back.',26124),
(57791,'enUS','Our dreams have been haunted by mantid. We hoped the Crane Temple would give us some insight to these visions.','Our dreams have been haunted by mantid. We hoped the Crane Temple would give us some insight to these visions.',26124),
(57792,'enUS','Why were you travelling to the Crane Temple?','Why were you travelling to the Crane Temple?',26124),
(57793,'enUS','We seek the wisdom of the Crane to explain the visions we have been having.$b$bMantid! Mantid assaulting our homes, flying over the wall and attacking in force.$b$bSuch dreams are expected, living so close to the wall.$b$BBut lately, they have been most insistent.','',26124),
(57794,'enUS','Mantid?','Mantid?',26124),
(57795,'enUS','You are indeed a stranger to Pandaria.$b$BThe mantid are the monsters beyond the wall. The scourge of the west. The evil that haunts our lands.$b$BEvery one hundred years the mantid launch an assault on our lands to ravage them of their wealth and food.$b$bOur greatest scholars tell us we are still many years from the next ravage, but our dreams say otherwise.','',26124),
(57796,'enUS','$p, we could use a champion like you in Stoneplow.','',26124),
(57797,'enUS','','An arcanic oubliette. Thankfully the walls of this ruin have collapsed away otherwise we would have been trapped in this one spot without food or water.$b$bSeems whoever built these ruins designed them to be a prison for anyone attempting to portal to the coordinates we were travelling to.$b$bIt also is lethal to any mages that pass through it. Look what it did to our poor arcanist.$b$bThe good news is we can still communicate with the other side and were able to warn them not to send anyone else through. The bad news is we are stuck on the wrong side of what is now a one way portal.',26124),
(57798,'enUS','What is wrong with the portal?','What is wrong with the portal?',26124),
(57799,'enUS','I was barely inside their outer patrols when they caught me. I didn\'t find anything.','I was barely inside their outer patrols when they caught me. I didn\'t find anything.',26124),
(57800,'enUS','I saw their leader. He was heading further up the wall. I\'ll mark it on your map.','I saw their leader. He was heading further up the wall. I\'ll mark it on your map.',26124),
(57801,'enUS','Thank you, friend. I didn\'t uncover anything before they caught me.','Thank you, friend. I didn\'t uncover anything before they caught me.',26124),
(57802,'enUS','I... I failed. Thank you for coming for me.','I... I failed. Thank you for coming for me.',26124),
(57803,'enUS','What are you doing here?','What are you doing here?',26124),
(57804,'enUS','We are on a quest to find the Pools of Youth!$b$bThe fabled waters were a boon of a mysterious lost civilization that predated Queen Azshara.$b$bWith these waters, we will be able to restore the glory of immortality to the kal\'dorei.','',26124),
(57805,'enUS','The Alliance will not be allowed to scar this land!','The Alliance will not be allowed to scar this land!',26124),
(57806,'enUS','Light grant me strength!','Light grant me strength!',26124),
(57807,'enUS','Mogu sympathizers!','Mogu sympathizers!',26124),
(57808,'enUS','You will not learn the secrets of the mogu!','You will not learn the secrets of the mogu!',26124),
(57809,'enUS','For the Horde!','For the Horde!',26124),
(57810,'enUS','I think I will just sit this one out.','',26124),
(57811,'enUS','','You did it! Let\'s get this brew to the Monastery...',26124),
(57812,'enUS','I... I don\'t know what came over me.','I... I don\'t know what came over me.',26124),
(57813,'enUS','Of course. We must not lose hope.','Of course. We must not lose hope.',26124),
(57814,'enUS','So they CAN die... I have to stay focused.','So they CAN die... I have to stay focused.',26124),
(57815,'enUS','Thank you, I had lost sight of the Way.','Thank you, I had lost sight of the Way.',26124),
(57816,'enUS','No, I cannot let it end like this. I have to keep fighting!','No, I cannot let it end like this. I have to keep fighting!',26124),
(57817,'enUS','How can I give up when heroes still fight at my side?','How can I give up when heroes still fight at my side?',26124),
(57818,'enUS','It seems we haven\'t lost yet.','It seems we haven\'t lost yet.',26124),
(57819,'enUS','It was... so dark...','It was... so dark...',26124),
(57820,'enUS','','I miss my father.',26124),
(57821,'enUS','','My father\'s sacrifice will not have been in vain. We need to press the attack against the mantid.',26124),
(57822,'enUS','','My father thought we would not encounter resistance. But then, he often spends his time obsessing over immortality instead of thinking things through.',26124),
(57823,'enUS','','Groundbreaker Brojai has made it clear the mogu have no intention of negotiating with us.',26124),
(57824,'enUS','The battle begins in 2 minutes!','',26124),
(57825,'enUS','The battle begins in 1 minute!','',26124),
(57826,'enUS','The battle begins in 30 seconds!','',26124),
(57827,'enUS','The battle has begun!','',26124),
(57828,'enUS','','What, so we gather a couple of bugs, and a few bird feathers? No problem!',26124),
(57829,'enUS','','This is fun, $p. Way more fun than hanging out with a boring uncle.',26124),
(57830,'enUS','','Holy smokes, it had a mom. Look out, $p!',26124),
(57831,'enUS','','Sounds good to me! And maybe next time, you could warn us about the GIANT MURDEROUS CROCODILE.',26124),
(57832,'enUS','','Neat! A jinyu!',26124),
(57833,'enUS','','I\'m glad to see that there\'s still some left, after what happened in the Jade Forest.',26124),
(57834,'enUS','','Say, you think they\'re related to murlocs?',26124),
(57835,'enUS','','Back off, flower-head. That\'s MY $c you\'re talking about!',26124),
(57836,'enUS','','What\'s happening?',26124),
(57837,'enUS','','Wait a minute, now we need to go pick a flower for these guys?',26124),
(57838,'enUS','','Seems kind of girly to me.',26124),
(57839,'enUS','','Besides... isn\'t it THEIR job to pick the flowers?',26124),
(57840,'enUS','','$p... you picked that flower like a champion! You\'re like a... a professional flower-picker! Have you done this before?',26124),
(57841,'enUS','','Yuck.',26124),
(57842,'enUS','','Look how big and ugly he is!',26124),
(57843,'enUS','','It\'s a good thing my Uncle Chen told me not to get into any fights, otherwise you\'d be dead meat, turtle!',26124),
(57844,'enUS','','Are you listening to me, turtle?',26124),
(57845,'enUS','','Hey $p? I don\'t think I want to try Bottletoads.',26124),
(57846,'enUS','','This is kind of cool. A day in the life of a... a silk-getting guy.',26124),
(57847,'enUS','','What are they called, anyways? Silkers? Silksters? Worm-butt squeezers?',26124),
(57848,'enUS','','I think I\'ll just stick with \"silk-getting guy\".',26124),
(57849,'enUS','','Did he say \"horrible monster\"?',26124),
(57850,'enUS','','See... THIS is the type of adventure I can get behind.',26124),
(57851,'enUS','','Come on, let\'s go kill some of those little guys first.',26124),
(57852,'enUS','','Alright, done with the little guys! Let\'s move on to this \"horrible silk monster\"!',26124),
(57853,'enUS','','Hurry up, $p!',26124),
(57854,'enUS','','That was kind of cool.',26124),
(57855,'enUS','','THAT... WAS... AWESOME!',26124),
(57856,'enUS','','Are you seeing this, $p?',26124),
(57857,'enUS','','This place is like... ALL puddles.',26124),
(57858,'enUS','','I love puddles! No wonder all these birds like to hang out here.',26124),
(57859,'enUS','','Huh! This must be where all those farmers sell their fruits, and vegetables, and grains, and beer.',26124),
(57860,'enUS','','I wonder if Uncle came through here on his way to the brewery.',26124),
(57861,'enUS','','Can we buy something? I\'m hungry.',26124),
(57862,'enUS','','%s burps.',26124),
(57863,'enUS','','OK! Not hungry anymore. Let\'s keep exploring.',26124),
(57864,'enUS','','Look at this! A little farm, right in the middle of a town.',26124),
(57865,'enUS','','Who would think to start a farm in the middle of a town? Hah!',26124),
(57866,'enUS','','I\'ll bet they grow enough food here to feed pretty much everybody on Pandaria.',26124),
(57867,'enUS','','It\'s just too bad that it\'s all vegetables. Why no giant meat?',26124),
(57868,'enUS','','Oh, cool! This must be where they store the grain for all the beer they make at that brewery.',26124),
(57869,'enUS','','I can\'t wait until I\'m older, so I can finally find out what beer tastes like.',26124),
(57870,'enUS','','%s smiles and glances about nervously.',26124),
(57871,'enUS','','Here it is: the Stormstout Brewery.',26124),
(57872,'enUS','','I\'ll bet Uncle Chen is inside, meeting our distant relatives, as we speak.',26124),
(57873,'enUS','','That\'s exactly what I need... even MORE boring old uncles.',26124),
(57874,'enUS','','Check this place out!',26124),
(57875,'enUS','','You know what, $p?',26124),
(57876,'enUS','','You\'re way cooler than Uncle Chen.',26124),
(57877,'enUS','','Uncle Chen and I spent weeks wandering around that Jade Forest, and all we saw were trees... and ONE cool serpent thing.',26124),
(57878,'enUS','','I\'ve only spent a day with you, and we\'ve already seen this entire valley.',26124),
(57879,'enUS','','Hey, where did this weird jungle come from?',26124),
(57880,'enUS','','It\'s just like, all of a sudden, out of nowhere... BOOM. Super-thick jungle.',26124),
(57881,'enUS','','And it\'s kind of scary, too.',26124),
(57882,'enUS','','Well? Are we going in, or what?',26124),
(57883,'enUS','','Someone LIVES back here?',26124),
(57884,'enUS','','This is all pretty cool, and scary, and all that stuff, but shouldn\'t we be getting back to Mudmug\'s place now?',26124),
(57885,'enUS','','So... umm... $p? I\'m still here, you know.',26124),
(57886,'enUS','','Following you all over the place. Have been for a while now.',26124),
(57887,'enUS','','Yikes, $p, don\'t manhandle the thing. Have you never picked an herb before?',26124),
(57888,'enUS','','Don\'t forget to talk to that jinyu, down there by the river.',26124),
(57889,'enUS','','I guess what I\'m saying is... thanks.',26124),
(57890,'enUS','','My father would tell you we are here for the Pools of Youth.$b$bThe real story is that our lady Tyrande Whisperwind has had visions of a great light we would... will... find on this journey. A light that will need to be found and defended.$b$bMy father insists it is the Pools of Youth.$b$bI think he is blinded by a decade of obsession.',26124),
(57891,'enUS','What are you doing here?','What are you doing here?',26124),
(57892,'enUS','You\'re the last one. Hop on that sea plane and we\'ll get going. The King has placed a lot of trust in you.','',26124),
(57893,'enUS','And now for the moment of truth.','',26124),
(57894,'enUS','Aaaaaaaaahhh!','',26124),
(57895,'enUS','That... hurt...','',26124),
(57896,'enUS','','Father! Are you okay?',26124),
(57897,'enUS','I almost hit my goal of ten mage portals without incident. Those thrice damned mogu ruined that with their trap.$b$bThe trap sundered most of my abilities but I should be able to manage some more local portals.','',26124),
(57898,'enUS','PLACEHOLDER CINEMATIC','PLACEHOLDER CINEMATIC',26124),
(57899,'enUS','[NOTE: Many placeholder visuals in this cinematic. Expecting Observatory WMO & charge up visuals.]','',26124),
(57900,'enUS','Um, this may take a while.','',26124),
(57901,'enUS','$p, a word before you venture forth.','',26124),
(57902,'enUS','These mogu fight very differently than the ones I\'ve faced in the past. They have confidence.','',26124),
(57903,'enUS','If Mama Bramblestaff could see me now...','',26124),
(57904,'enUS','I should have known about the Pools of Youth. I had visions before the trip but I was blinded by the dream of perpetual youth.','',26124),
(57905,'enUS','Twenty years of research, hoping and dreaming, all crashing to a halt. All that remains now is the mission, and my daughter Lyalia.','',26124),
(57906,'enUS','These mantid, they remind me too much of the day the gates of Ahn\'Qiraj opened and swallowed my wife.$b$bThese creatures are the real threat in this land.','',26124),
(57907,'enUS','The orb has been dropped!','',26124),
(57911,'enUS','$n has taken the orb!','',26124),
(57913,'enUS','I\'m ready, Koro.','I\'m ready, Koro.',26124),
(57914,'enUS','Alright, lizard lips, one more chance: where are your patrols?!','',26124),
(57915,'enUS','Wrong answer.','',26124),
(57916,'enUS','It looks like we are going in blind. I\'m glad you are with us, $p.','',26124),
(57917,'enUS','Stay close and keep your eyes peeled.','',26124),
(57918,'enUS','','F... father? No! Not for me! Not for this!',26124),
(57919,'enUS','I refuse to outlive my daughter.','',26124),
(57920,'enUS','','Press on to Stoneplow and help them against the Mantid threat.',26124),
(57923,'enUS','$n, over here. He\'s hurt.','',26124),
(57924,'enUS','','So, I really appreciate you taking with me into this scary jungle and all...',26124),
(57925,'enUS','','...letting me watch you while you dispatch of an ancient evil, and all that other stuff we did, too...',26124),
(57926,'enUS','','...but don\'t you think that maybe we\'ve done enough exploring for today?',26124),
(57927,'enUS','','No? Okay, you\'re the boss! Let\'s keep going, $n!',26124),
(57928,'enUS','','That was really cool, how you helped those people out.',26124),
(57929,'enUS','','I hope they find what they\'re looking for, here in Pandaria.',26124),
(57930,'enUS','','That guy sure had a lot of guns.',26124),
(57931,'enUS','','Like... a LOT of guns.',26124),
(57932,'enUS','You have already created an acceptable sketch of this piece.','',26124),
(57933,'enUS','Our mission priority has changed.$B$BWe need to defend this camp. Now!','',26124),
(57934,'enUS','You wikkets belong in the pits!','',26124),
(57935,'enUS','Ookin\' dooker!','',26124),
(57936,'enUS','Chief Gukgut say you gotta go!','',26124),
(57937,'enUS','You dookers don\'t know when to quit!','',26124),
(57938,'enUS','Ook off, you big dookers!','',26124),
(57939,'enUS','Dookers die quick!','',26124),
(57940,'enUS','Never seen a dooker like you before!','',26124),
(57941,'enUS','Icky slicky! Go away!','',26124),
(57942,'enUS','Pick their corpses clean!','',26124),
(57943,'enUS','Hold up... I don\'t like the looks of this...','',26124),
(57944,'enUS','Have you seen my twin sister, Nimm? She\'s probably lost, as usual.','',26124),
(57945,'enUS','What if I don\'t want to kill Alliance?','What if I don\'t want to kill Alliance?',26124),
(57946,'enUS','I didn\'t ask what you want. I asked you to fulfill your oaths sworn to the horde.$b$bWe are at war, $p, in case you forgot.$b$bIn such times, personal interests must take second place to duty.','',26124),
(57947,'enUS','My wife, Leza, is in labor and fighting a fever.$b$bThis cursed jungle is sapping all of our strength. It could be something in the water.','',26124),
(57948,'enUS','Why would you bring a pregnant woman with you?','Why would you bring a pregnant woman with you?',26124),
(57949,'enUS','Dezco, we must strike at the mogu now while they think us weak. Let us unleash this $c on them.','',26124),
(57950,'enUS','Your friend put up quite the fight. He nearly escaped, but now he is a prisoner, just like the rest of us.','',26124),
(57951,'enUS','My people are wary of strangers. However, it seems I have no choice but to trust you.','',26124),
(57952,'enUS','Do not mistake me for your friend. Over time, my people have learned that trust is too easily broken.','',26124),
(57953,'enUS','Only fools trust strangers, but I would rather trust a stranger than a hozen.','',26124),
(57954,'enUS','This land once belonged to the great jinyu empire. As our kingdom has fallen into disrepair, we have lost more and more land to the relentless hozen tribes.','',26124),
(57955,'enUS','My people fight to defend our last village. If we lose now, it will be the end of a lineage of once great emperors and philosophers.','',26124),
(57956,'enUS','I will escape from here, and when I return, it will be with an army of jinyu warriors.','',26124),
(57957,'enUS','The visions we had failed to mention this event.','',26124),
(57958,'enUS','Taylor fought against the hozen like a wild beast. He is a great credit to your people!$B$BBut in the end, he was overcome.','',26124),
(57959,'enUS','<The Admiral\'s body is covered with wounds, scratches, bruises, blood, and sweat. He looks feverish.>','',26124),
(57960,'enUS','Do you have a report for Kor and Dezco?','Do you have a report for Kor and Dezco?',26124),
(57961,'enUS','Watch your step, it\'s a mine field out here!','',26124),
(57962,'enUS','Yes, stranger?','',26124),
(57963,'enUS','I have no business with you, stranger. What do you want?','',26124),
(57964,'enUS','','Here is what I have. As you can see, things are not what we were expecting.$b$bThese people need help, and I intend to stay and help them.$b$bWe would stand a much better chance with your help if you are willing to stay as well.',26124),
(57965,'enUS','','This jungle is making me depressed.',26124),
(57966,'enUS','','Not now. Leza needs all of my attention. She is three weeks early and something is very wrong.',26124),
(57969,'enUS','You wikkets belong in the pits!','',26124),
(57970,'enUS','Uh-oh... Chief ain\'t gonna be happy...','',26124),
(57971,'enUS','You don\'t steal big slickies!','',26124),
(57972,'enUS','Gukgut say you gotta die!','',26124),
(57973,'enUS','What are you doing here?! Don\'t you know the Yaungol are invading Kun-Lai Summit?','What are you doing here?! Don\'t you know the Yaungol are invading Kun-Lai Summit?',26124),
(57974,'enUS','Dookers is doin\' ookin\' things!','',26124),
(57975,'enUS','Ook\'em in the jerb!','',26124),
(57976,'enUS','Ookin\' dooker!','',26124),
(57977,'enUS','Icky slickies is escaping!','',26124),
(57978,'enUS','Ook!','',26124),
(57979,'enUS','Takk!','',26124),
(57980,'enUS','Dookin\'...','',26124),
(57981,'enUS','Bad slickies...','',26124),
(57982,'enUS','I lose slapslap...?','',26124),
(57983,'enUS','Frack!','',26124),
(57986,'enUS','As the tale goes, the yaungol was traveling across the Kun\'lai plains when suddenly he was ambushed by two strange creatures!','',26124),
(57987,'enUS','FOR THE ANCIENTS!','',26124),
(57988,'enUS','The yaungol attacked the beasts with great determination and ferocity. Yet, the more he attacked, the more fearsome the beasts grew!','',26124),
(57989,'enUS','However, when he let it alone, the beast shrank to near nothingness.','',26124),
(57990,'enUS','For you see, strife feeds on conflict. When you have peace in your heart, strife will find somewhere else to roam.','',26124),
(58002,'enUS','Look out!','',26124),
(58003,'enUS','Argh, I\'m pinned! Watch yourselves!','',26124),
(58004,'enUS','Look at these ruins, $p! What sort of empire built them I wonder.','',26124),
(58005,'enUS','What strange and fascinating creatures. Tall, burly, with almost metallic skin. I must research these creatures.','',26124),
(58006,'enUS','The waters. They only transfer life. My translations are starting to make sense now.$b$bI surmise the mogu used to extend their lives with the water by sacrificing prisoners, rebels, and slaves.$b$bIt is also my guess that all of the ancient scrolls I was researching were written by mogu originally, and they neglected to mention that fact.','',26124),
(58007,'enUS','N-n-nice doggies...','',26124),
(58008,'enUS','This is bad.','',26124),
(58009,'enUS','Not the face!','',26124),
(58010,'enUS','Who throws a bucket? Honestly!','',26124),
(58011,'enUS','Argghhhh!','',26124),
(58012,'enUS','Maybe $ghe:she; is a hero from beyond the mists, here to save us?','Maybe $ghe:she; is a hero from beyond the mists, here to save us?',26124),
(58013,'enUS','Wait, I sense the presence of intruders. Is it hozen? Show yourselves!','',26124),
(58014,'enUS','I have done nothing. This is the work of the Slingtail chief, Gukgut.','',26124),
(58015,'enUS','We are not in the habit of welcoming outsiders into our village.','',26124),
(58016,'enUS','You may stay only until Taylor is well. But then, you must leave.','',26124),
(58017,'enUS','We have no other choice. Put down your weapon, warrior, and we will put down ours.','',26124),
(58018,'enUS','$n? What is going on here?','',26124),
(58019,'enUS','','You think we can believe him, Commander?',26124),
(58020,'enUS','What have you done to our Admiral?','',26124),
(58021,'enUS','Eye of the Legion','Eye of the Legion',26124),
(58022,'enUS','Demon Hunter\'s Aspect','Demon Hunter\'s Aspect',26124),
(58023,'enUS','Feldrake Mount','Feldrake Mount',26124),
(58024,'enUS','Timewalkers: War of the Ancients','Timewalkers: War of the Ancients',26124),
(58025,'enUS','We are going to pass through a fierce battle. You must engage the hozen while I run through. If all goes well, I will meet you at my village.','',26124),
(58026,'enUS','Yeah, I tried to hop through that thing too.','',26124),
(58027,'enUS','Once the trap is sprung no one gets in or out until the people trapped are completely drained of life. Mogu are evil.','',26124),
(58028,'enUS','Careful. Get stuck in that and it will drain your life to power itself.','',26124),
(58029,'enUS','Old mogu traps are as dangerous now as they were back in the scary story times.','',26124),
(58030,'enUS','I\'ve punched it, kicked it, smacked it, thwacked it. Nothing seems to break this oubliette.','',26124),
(58031,'enUS','Bold Karasshi has returned!','',26124),
(58032,'enUS','Look, a stranger.','',26124),
(58033,'enUS','It\'s no use! The hozen are pushing us back!','',26124),
(58034,'enUS','Be strong, warriors! Keep the hozen at bay!','',26124),
(58035,'enUS','Who is the stranger who walks among us?','',26124),
(58036,'enUS','Is that the stranger?','',26124),
(58037,'enUS','Courage, brothers! Press on!','',26124),
(58038,'enUS','For the Pearlfin!','',26124),
(58039,'enUS','Help me up, $p. I... I took an arrow in the knee...','',26124),
(58040,'enUS','Thank you. I\'ll be okay, but we\'d better keep moving.','',26124),
(58041,'enUS','More saurok incoming!','',26124),
(58042,'enUS','Gah! My knee! I\'m sorry, $p, I cannot fight like this.','',26124),
(58043,'enUS','The camp is just ahead, we should be able to make it from here.','',26124),
(58044,'enUS','','Ah, here is the boy. Doesn\'t he look special? My late husband and I always wanted children.',26124),
(58045,'enUS','It was An! She dared Shin to go knock on the Jade Witch\'s door.','It was An! She dared Shin to go knock on the Jade Witch\'s door.',26124),
(58046,'enUS','I want my mommy.','I want my mommy.',26124),
(58047,'enUS','Oh thank you! Thank you! Thank you!','Oh thank you! Thank you! Thank you!',26124),
(58048,'enUS','Please allow us a chance to prove our friendship. We wish you no harm.','Please allow us a chance to prove our friendship. We wish you no harm.',26124),
(58049,'enUS','What are you doing?','What are you doing?',26124),
(58050,'enUS','My friends and I come with peaceful intentions.','My friends and I come with peaceful intentions.',26124),
(58051,'enUS','I come from the Alliance. We wish to be allies, not enemies.','I come from the Alliance. We wish to be allies, not enemies.',26124),
(58052,'enUS','To find clarity and purpose, immerse yourself in inner reflection.','',26124),
(58053,'enUS','Make your mind as calm as still water. Breathe deeply. And be at peace.','',26124),
(58054,'enUS','I like to consider myself a historian of my people. I believe that in order to understand the present, we should examine the events of the past.','',26124),
(58055,'enUS','No harm? Pah! Many thousand years ago, the Pearlfin Tribe stood on the throne of all Pandaria. Now, this village is all that is left of our people, all because we trusted a tribe of outsiders... the hozen.','',26124),
(58056,'enUS','Oh! $c! Over here. I could use some assistance if you have a moment.','',26124),
(58057,'enUS','Ah, you must be the outsider. Sadly, I am making weapons for war. Once, not long ago, I made instruments for prayer and celebration. It is this war that makes everyone stand on edge.','',26124),
(58058,'enUS','The stronger our defenders, the greater our chance of survival. But that should be obvious, even to someone like you.','',26124),
(58059,'enUS','We must train harder.','',26124),
(58060,'enUS','I am teaching our warriors everything I know. Unfortunately, it doesn\'t seem to be enough.','',26124),
(58061,'enUS','The hozen rely on dirty guerilla tactics. Ambushes and traps. It is sad to say, but they seem to outwit us at every turn.','',26124),
(58062,'enUS','We are masters of the water, which is why we have been able to defend this village for so long. But on land, especially with thick tree cover, the hozen are vastly superior.','',26124),
(58063,'enUS','Action speaks louder than intent, stranger. My warriors intend to seek retribution, but only practice will make it so. Now go away. We are busy.','',26124),
(58064,'enUS','Have you seen our lake, so calm and still? That is how we like it. Constant. Unmoving. We do not bear change.','',26124),
(58065,'enUS','The great river flows through us all. Some prefer to surrender themselves to the water\'s path. Others swim toward certain shores.$B$BWhich are you, stranger? Where will your river take you?','',26124),
(58066,'enUS','Stranger, have you ever seen a stone fall into a calm lake? Every action creates a ripple, even accepting a pledge of friendship. I shall think upon your request.','',26124),
(58067,'enUS','Don\'t forget your helmet, $n. Rookies...','',26124),
(58068,'enUS','Commander, I lost my diving helmet.','Commander, I lost my diving helmet.',26124),
(58069,'enUS','Kthh! You will die in the mud like your friend over there...','',26124),
(58070,'enUS','I will crush you!','',26124),
(58071,'enUS','','Even in their own time of need, the pandaren have graciously offered to share food and a place by the fire.$B$BThe rest of us could learn a lot from them.',26124),
(58072,'enUS','','Even in their own time of need, the pandaren have graciously offered to share food and a place by the fire.$B$BThe rest of us could learn a lot from them.',26124),
(58073,'enUS','Ah! $p! My daughter! I... a vision, she... she\'s in trouble!','',26124),
(58074,'enUS','Way back in the old times the mogu would put little traps like this around the world to stop people from portalling this way and that. It\'s powered by the people who get stuck in it and won\'t turn off until they are dead.$b$bIt\'s like mama Bramblestaff always used to say: \"Don\'t put your hand in a stranger\'s portal.\"','',26124),
(58075,'enUS','What is this thing?','What is this thing?',26124),
(58076,'enUS','','Hey! Is anybody out there? Hellooooooo!',26124),
(58077,'enUS','I never imagined we\'d run into this much trouble out here.$B$BMaybe we shouldn\'t have left the temple...','',26124),
(58078,'enUS','','Someone help me!',26124),
(58079,'enUS','','Hey monkey, don\'t look at me like that. I\'m not for eating, got that?',26124),
(58080,'enUS','','Stop looking at me with your beady little eyes!',26124),
(58081,'enUS','','Don\'t come any closer, monkey! I\'m a trained SI:7 agent.',26124),
(58082,'enUS','','Oh...where is everyone? Gnome in a cage here! Help!',26124),
(58086,'enUS','I am in your debt.','',26124),
(58087,'enUS','That is powerful healing!','',26124),
(58088,'enUS','Join us, $c. We could use you in the fight.','',26124),
(58089,'enUS','Thank you. You have saved my life.','',26124),
(58090,'enUS','I must rejoin the battle to save Binan Village.','',26124),
(58091,'enUS','We must drive the yaungol back to the Townlong Steppes.','',26124),
(58092,'enUS','You have great honor, stranger. Please join us.','',26124),
(58093,'enUS','Shaohao must have sent you.','',26124),
(58095,'enUS','What now, Sunwalker?','',26124),
(58096,'enUS','Agreed.','',26124),
(58097,'enUS','I think we have both lost enough today, old elf. See to your dead.','',26124),
(58098,'enUS','','Have you seen an SI:7 agent by the name of Amber?$B$BThe last I heard, her bomber took heavy damage and disappeared into the trees to the northeast.',26124),
(58099,'enUS','School is in session!','',26124),
(58100,'enUS','Dunce.','',26124),
(58101,'enUS','Yes, I feel much better.$B$BMishka and Bold Karasshi have brought me up to speed. Your arrival, your search for the White Pawn, my rescue from the hozen.$B$BThe situation is not ideal, and we have much work to do. Finding Anduin is our top priority.','',26124),
(58102,'enUS','Class... dismissed.','',26124),
(58103,'enUS','|TInterface\\Icons\\inv_misc_book_01.blp:20|t%s assigns $n a |cFFFF0000|Hspell:113395|h[Harsh Lesson]|h|r!','',26124),
(58104,'enUS','You brought back the instruments just in time, $n. The Elder is ready to perform the waterspeaking ceremony.','',26124),
(58105,'enUS','The courier must have died of his wounds after what looks to have been a brutal struggle.$B$BHis supply satchel appears to be unharmed.','',26124),
(58106,'enUS','This courier must have died of his wounds after what looks to have been a brutal struggle.','',26124),
(58107,'enUS','Take the supplies.','Take the supplies.',26124),
(58108,'enUS','Greetings stranger. Would you like to visit the mystical Pandaria?','',26124),
(58109,'enUS','Send me to Pandaria!','Send me to Pandaria!',26124),
(58119,'enUS','That Wanderbrew? Why would a Goldendraft ever know where a Wanderbrew is? Their family has always been a scar on our beautiful town\'s reputation.$b$bTo make things worse, that filthy creaton is probably making eyes at my daughter. That I will not have!$b$bIf you see either him or my daughter you tell them as much for me.','',26124),
(58120,'enUS','Lo? Sure. I\'ve been sent to hunt him down lots of times. Well, him and Syra Goldendraft.$b$bBest places to look for them are either the inn or the Arboretum.','',26124),
(58123,'enUS','Are you ready to go? I think we\'re just about done here...','',26124),
(58124,'enUS','The pandriarchs blessed my future son-in-law thanks to you. I guess this means the Wanderbrew and Goldendraft feud will have to go on hold.$b$bDon\'t tell anyone this, but I\'m sort of grateful to you for that. So many years of hate is just exhausting.$b$bWe were too set in our ways though, and it took something, or someone, new to help us see passed our differences.','',26124),
(58125,'enUS','','Thank you, $p! I am so happy that you helped us. My Lo is with me now, and even my father seems to have relaxed.$b$bHe won\'t admit it to me, but I think my father likes Lo.',26124),
(58126,'enUS','Brewmaster Wanderbrew, at your service.$b$bI travel the Jade Forest in search of only the finest of ingredients for my brews.$b$bUnlike the high and mighty Goldendrafts of Dawn\'s Blossom.$b$bThey have their big brewhouse for mass producing. Which is fine, you know, if you enjoy drinking swill.','',26124),
(58127,'enUS','A Wanderbrew marrying a Goldendraft? I would be offended but there is a certain amusement to how offended old Peiji is going to be when he hears this.$b$bAt the least you seem to have made my boy happy. Thank you, $p.','',26124),
(58128,'enUS','I need to find Syra!','',26124),
(58129,'enUS','Thank you. Let us begin.','',26124),
(58130,'enUS','Lo! We are leaving. Where did you get off to?','',26124),
(58131,'enUS','The spirits have spoken. I have much to ponder.','',26124),
(58132,'enUS','To find your White Pawn, we must call upon the ancient magic of my people. To do so, we must first create a Dream Brew.','',26124),
(58133,'enUS','|TInterface\\Icons\\ability_warlock_inferno.blp:20|t%s begins to cast |cFFFF0000|Hspell:113364|h[Book Burner]|h|r!','',26124),
(58134,'enUS','The stronger the ingredients, the stronger the magic of the brew.','',26124),
(58135,'enUS','The Dream Brew will put you into a deep state of meditation. Your mind\'s eye will find the answers to your greatest questions.','',26124),
(58136,'enUS','The mind has untold powers that we have not yet discovered. With balance and wisdom, it may be possible to unlock these powers of the mind.$B$BThe Dream Brew is only a tool that produces a temporary period of this all-seeing state.','',26124),
(58137,'enUS','Certainly.','',26124),
(58138,'enUS','The Dream Brew is an ancient recipe passed down through the ages.','',26124),
(58139,'enUS','Archers, attack!','',26124),
(58141,'enUS','Please wait a moment.','',26124),
(58142,'enUS','','The storm is starting! Get ready.',26124),
(58143,'enUS','','If the brewkegs catch fire, I need you to help put them out.',26124),
(58144,'enUS','','Watch out for lightning strikes!',26124),
(58145,'enUS','','...Saurok? What are they doing here? Keep them away!',26124),
(58146,'enUS','','Yow, the storm is more intense than I thought! Be careful!',26124),
(58148,'enUS','','You there!  Make yourselves useful and deal with these summoners!',26124),
(58150,'enUS','','It\'s all about the brewkegs - keep them from burning!',26124),
(58151,'enUS','','Put out those brewkegs!',26124),
(58152,'enUS','','This storm is raging out of control! Keep the brewkegs safe...',26124),
(58154,'enUS','There should be plenty of anti-venom, thanks to $p.','',26124),
(58155,'enUS','Think no more on despair, Koro. We have a saying where I\'m from: It is darkest just before the dawn.','',26124),
(58156,'enUS','Anduin, will you join me? With the saurok threat at bay for now, it is time we discuss our next move.','',26124),
(58157,'enUS','Use focus and relaxation to maintain your balance.','',26124),
(58158,'enUS','Thank you - both of you. The Red Crane has always symbolized hope to our people, but in his absence I fear that even my thoughts began to darken.','',26124),
(58159,'enUS','That it is. You speak with a wisdom beyond your years. If we get through this, I think I\'d like to know more about where you are from.','',26124),
(58160,'enUS','%s chuckles.','',26124),
(58161,'enUS','Extreme sewing!','',26124),
(58163,'enUS','Not now!','',26124),
(58165,'enUS','Look at the size of that thing! That easily has to be the biggest moth I\'ve seen all week.','',26124),
(58167,'enUS','A $c of your caliber is exactly what we need to turn the battle in our favor.','',26124),
(58168,'enUS','|TInterface\\Icons\\inv_misc_head_dragon_01.blp:20|t%s begins to cast |cFFFF0000|Hspell:113653|h[Greater Dragon\'s Breath]|h|r!','',26124),
(58169,'enUS','The books burst into flame from being hit by Book Burner.','',26124),
(58170,'enUS','Run, slicky! I dook up your like fer breakfast!','',26124),
(58171,'enUS','I am Anduin Wrynn, Prince of Stormwind. I won\'t die here. Not like this!','',26124),
(58172,'enUS','If you\'ve come to return to me to my father, I must ask that you look around us first - can we truly walk away from these people in their time of need and still claim to represent the Alliance?','',26124),
(58173,'enUS','Our people have their differences, $c, but we are all guests in this place.$B$BThe pandaren have shown me great hospitality and respect, as I\'m sure you\'ve also received, and now they need our help.$B$BThe Horde is not without honor. If you know honor, you will know to save our quarrel for another time.','',26124),
(58174,'enUS','Keep firing! Let none escape!','',26124),
(58175,'enUS','Another down.  Do not relent!','',26124),
(58177,'enUS','Hello.$b$bMy name is Shai.$b$bThey tell me to watch the cliff.$b$bSometimes cubs come because of a dare. Sometimes grown ups come because they are curious.$b$bI tell you what I tell them. The cliffs are sad, and the jungle is even more sad.$b$bYou may descend using the rope, but know it is a very sad place.','',26124),
(58178,'enUS','Defeat all the Expired Test Subjects to escape!','Defeat all the Expired Test Subjects to escape!',26124),
(58180,'enUS','My time with the Red Crane was short, but I learned a great deal under his tutelage.$B$BThis foe--this \"sha\" energy--is unlike anything we\'ve ever faced. It is the physical manifestation of emotional turmoil, bottled in the land for centuries$B$BThis emotional energy has now burst forth to find living, feeling hosts in which to reside.$B$BThe sha threatens to wash over the whole continent, possibly the world, if we do not aid the pandaren in facing it down!','',26124),
(58181,'enUS','Blades at the ready men!','',26124),
(58182,'enUS','It\'s on!','',26124),
(58183,'enUS','Mister Goldendraft, I humbly ask permission to marry your daughter Syra.','',26124),
(58184,'enUS','It is not her name I am interested in. It is her. She is the kindest, nicest, prettiest person I have ever met.','',26124),
(58185,'enUS','Yes. And now, with your permission, I would like to ask for your daughter\'s hand.','',26124),
(58186,'enUS','The waters of the Vale are now yours to protect...','',26124),
(58187,'enUS','The darkness came from deep within the earth. Still, it hungers...','',26124),
(58188,'enUS','Son! What are you doing! She\'s a Goldendraft.','',26124),
(58189,'enUS','Here they are. See, told you I could find anyone or anything.','',26124),
(58190,'enUS','Wow! That was amazing. What next, $p? Think you can get the hozen and jinyu to get along?','',26124),
(58191,'enUS','The Song of the Vale hangs on the wall. Take it. I hear the celestials calling. Thank you...','',26124),
(58192,'enUS','This Vale of Eternal Blossoms is getting more and more intriguing. I may just have to see it for myself.','',26124),
(58193,'enUS','My dear, it appears we have visitors!  Friends of yours, Voss?','',26124),
(58194,'enUS','Their deaths only serve to empower my summoners further! Behold!','',26124),
(58195,'enUS','What\'s the matter, Voss, getting tired?','',26124),
(58196,'enUS','Isn\'t it beautiful? The weaving of flesh and bone and soul.','',26124),
(58197,'enUS','You, too, are beautiful, Voss. Have you looked in a mirror recently?','',26124),
(58198,'enUS','My dear, you should embrace this gift that has been bestowed upon you.','',26124),
(58199,'enUS','Come, Voss, your fate awaits you.','',26124),
(58200,'enUS','','You feed their souls to their brethren?  You are sick.',26124),
(58201,'enUS','','I\'ll never stop hunting your kind, necromancer.  NEVER.',26124),
(58202,'enUS','','We\'ll see if you revel so much in death once I\'ve ripped out your throat!',26124),
(58203,'enUS','They agreed?!','',26124),
(58204,'enUS','Come on Peiji. I don\'t like it any better than you do but there is honor in the Pandriarchs\' blessings.','',26124),
(58205,'enUS','Same. Now lets get these kids back to Dawn\'s Blossom.','',26124),
(58206,'enUS','What?! This is preposterous.','',26124),
(58207,'enUS','My Syra will NOT be seen with the likes of a Wanderbrew.','',26124),
(58208,'enUS','Well... um... I...','',26124),
(58209,'enUS','Fine. What\'s done is done. But don\'t assume I will ever like this. Or you, Kai.','',26124),
(58210,'enUS','','No, father, I will. Lo was willing to fight the Pandriarchs for me. It took $p to champion us but they consented.',26124),
(58211,'enUS','','You\'ll pay for your tongue.',26124),
(58212,'enUS','','I will not let you curse another soul with this nightmare.',26124),
(58213,'enUS','','Run...necromancer...your life ends once I catch my breath.',26124),
(58214,'enUS','Cheeky little bugger! Didn\'t think he had it in him!','',26124),
(58215,'enUS','Sliiickeeey!','',26124),
(58216,'enUS','Ookin\' slicky make a good dook!','',26124),
(58217,'enUS','Wikket no grookin\' hozen?','',26124),
(58218,'enUS','Hozen grookin\' slicky wikket!','',26124),
(58219,'enUS','Ookin\' wikket no whakkin\' hozen!','',26124),
(58220,'enUS','Hozen grookin\' slicky wikket dookers.','',26124),
(58221,'enUS','He was a good man, but terrible with a sword! PH','',26124),
(58222,'enUS','He died fighting! PH','',26124),
(58223,'enUS','I\'m surprised he lasted as long as he did. PH','',26124),
(58224,'enUS','I never liked that guy. PH','',26124),
(58225,'enUS','Pain is temporary! PH','',26124),
(58226,'enUS','I\'m hurt! PH','',26124),
(58227,'enUS','Ouch! PH','',26124),
(58228,'enUS','Follow and use the shield as cover!','',26124),
(58231,'enUS','Today, our friendship is cemented with the Alliance! Today, we go forth as brothers and sisters. To our new future!','',26124),
(58232,'enUS','Where would you like to travel today?','',26124),
(58233,'enUS','I would like to travel to Dawn\'s Blossom.','I would like to travel to Dawn\'s Blossom.',26124),
(58234,'enUS','Hurray! We made it!','',26124),
(58235,'enUS','Lyalia wants me to create a new portal? That woman is crazy. Did she already forget what happened the last time?$b$bWell, Vaeldrin\'s research did suggest some possible ways around traps like that. And I may have taken a short cut or two to get us here.$b$bGive me enough time and I might be able to summon another portal for the encampment.','',26124),
(58236,'enUS','Oh my... we made it to the other side somehow. I am so relieved.$b$bIt is not an easy thing to create a portal to a place you have never been before.$b$bBut then, if it were easy, everybody would be doing it.','',26124),
(58237,'enUS','You must place the fireworks near a pile of stolen goods.','',26124),
(58238,'enUS','','Rest up for a second while I prep the keg.',26124),
(58239,'enUS','','Everyone ready? Let\'s roll!',26124),
(58240,'enUS','','Ho boy, more saurok. They always seek high ground when the rains hit!',26124),
(58241,'enUS','You went an\' made it so these savages like us?$b$bYou gotta be some kinda freak $r genius!$b$bWho\'da thought...','',26124),
(58242,'enUS','You get away from fire!','',26124),
(58243,'enUS','I kill you, dooker!','',26124),
(58244,'enUS','You in hot water now!','',26124),
(58245,'enUS','Get lost, tik-nooker!','',26124),
(58246,'enUS','Get the ook away from there!','',26124),
(58247,'enUS','You tik-digglin\' jook-manker!','',26124),
(58248,'enUS','Ookin\' $r!','',26124),
(58249,'enUS','I\'ll cook you into my soup, you dook-wikket!','',26124),
(58250,'enUS','','They\'re scaling the cliff walls! This is going to get dirty.',26124),
(58251,'enUS','Impressive, $r.$b$bThanks to you, these creatures may turn out to be valuable allies.','',26124),
(58252,'enUS','','Watch your footing! The stones are still slick from rain.',26124),
(58253,'enUS','','Keep an eye on the rear! No - not MY rear. Behind us!',26124),
(58254,'enUS','','%s stops along the road, panting heavily.',26124),
(58255,'enUS','The tauren are the most majestic of hunters.','',26124),
(58256,'enUS','Have you ever seen a tauren hunt? You never do until it\'s too late.','',26124),
(58257,'enUS','YOU\'LL NEVER GET THE MASK FROM ME, $P!','',26124),
(58258,'enUS','Give in to your anger!','',26124),
(58260,'enUS','Soon Kun-Lai Summit and all of Pandaria will be consumed with anger. And then, the world!','',26124),
(58261,'enUS','The jinyu are ours and Binan Village is next!','',26124),
(58262,'enUS','I can sense the anger building inside of you.','',26124),
(58263,'enUS','Fu Mo Shi is a doddering old fool. He\'s a master of nothing!','',26124),
(58264,'enUS','Feed my anger!','',26124),
(58265,'enUS','I once hunted alongside the famous Ohlorn Farstrider. He was a tauren who could hunt with nothing but a totem and his skivvies.','',26124),
(58266,'enUS','Nesingwary is a brilliant hunter, but I wish there was a druid here to teach us some proper animal hunting tactics.','',26124),
(58269,'enUS','Alright, I think I know what our next move\'s gotta be.','',26124),
(58271,'enUS','Wikkets is furry food!','',26124),
(58272,'enUS','Wikket grookin stinky slickies!','',26124),
(58273,'enUS','Hozen whakkin\' stinky wikket!','',26124),
(58274,'enUS','Grookie wikket!','',26124),
(58275,'enUS','Ookin\' dooker!','',26124),
(58276,'enUS','That\'s the worst marching I\'ve ever seen!','',26124),
(58277,'enUS','No, no, no... Left foot then right foot!','',26124),
(58278,'enUS','Oh come on! We\'ve been doin\' this all day!','',26124),
(58279,'enUS','Hey! Hey you in the back! I\'m watchin\' you mister!','',26124),
(58280,'enUS','Ack! It\'s the Horde!','',26124),
(58281,'enUS','The Horde! Run away!','',26124),
(58282,'enUS','The Horde is invading!','',26124),
(58283,'enUS','Hide your kids! Hide your wife!','',26124),
(58284,'enUS','Eek! Everybody run!','',26124),
(58285,'enUS','You saved me? But, you\'re Horde!','',26124),
(58286,'enUS','First anger sha, now the Horde!','',26124),
(58287,'enUS','Go back where you came from, Horde!','',26124),
(58288,'enUS','Thank you for saving my life!','',26124),
(58289,'enUS','When I spoke to the waters, they showed me a vision of you, $n. Perhaps you are more than a passing traveler. Perhaps you were sent to us for a reason.','',26124),
(58290,'enUS','One thing is clear. Our future will be affected by you and your people.','',26124),
(58291,'enUS','The waterspeaking ceremony has tired me. Please, give me time to rest, and think.','',26124),
(58292,'enUS','We are hard at work, training with your soldiers.','',26124),
(58293,'enUS','Thanks to you, the hozen are no longer a threat. Our village can now work on rebuilding and growing.','',26124),
(58294,'enUS','Tomorrow holds untold possibilities, and it is all thanks to you and the Alliance.','',26124),
(58295,'enUS','Someday, perhaps you can tell me more about this strange land from where you came.','',26124),
(58296,'enUS','The spirit has spoken. We should take up arms and attack the hozen!','',26124),
(58297,'enUS','You have gazed upon one of the ancient jinyu emperors of Pandaria, $n.','',26124),
(58298,'enUS','The spirit\'s voice echoed through me like thunder. Did you hear it?','',26124),
(58299,'enUS','I believe the vision means for us to join together, $n.','',26124),
(58300,'enUS','The Elder has much to consider, but I think it\'s clear. You are meant to lead us to victory against the hozen.','',26124),
(58301,'enUS','We are friends now, $n. You are welcome to our village any time you wish to return.','',26124),
(58302,'enUS','Your name will be spoken in our village for many years to come.','',26124),
(58303,'enUS','Someday, perhaps you will show me your home. It must be very different than ours.','',26124),
(58304,'enUS','We owe you a great debt, $r.','',26124),
(58305,'enUS','The jinyu are proving to be capable soldiers.','',26124),
(58306,'enUS','With the right training, the jinyu will make a strong addition to our land force.','',26124),
(58307,'enUS','When the Horde finally show their ugly faces, we\'ll be ready.','',26124),
(58308,'enUS','You have done well here, $n. I will put in a good word with your superiors when we return to Stormwind.','',26124),
(58309,'enUS','How may I help you?','',26124),
(58310,'enUS','How do your waters flow today, traveler?','',26124),
(58311,'enUS','We have lost so many brothers in battle, I no longer wish to keep count.','',26124),
(58312,'enUS','The hozen are slippery and cunning. Worse yet, they feel no shame or remorse.$B$BThey kill out of base instinct, for pleasure and for greed.','',26124),
(58313,'enUS','I can\'t believe it! I saw the spirit of of an emperor!','',26124),
(58314,'enUS','The spirit showed us the path to our future. And somehow, it has something to do with you.','',26124),
(58315,'enUS','Finally, for the first time in many moons, I feel hopeful for our future.','',26124),
(58316,'enUS','Someday, I will tell my children about you, $n.','',26124),
(58317,'enUS','I have spoken to some of your... Alliance... friends. Your people are quite interesting.','',26124),
(58318,'enUS','Our soldiers speak of nothing but their new training.','',26124),
(58319,'enUS','Are you the $c, $n? I\'ve heard so many stories about you, but never expected to meet you in person.','',26124),
(58320,'enUS','Your coming was a blessing to our tribe.','',26124),
(58321,'enUS','I must admit I had my doubts about you at first, $n, but you have proven yourself with our tribe.','',26124),
(58322,'enUS','We will need Anduin\'s help to move on the temple. When he\'s ready, we\'ll begin.','',26124),
(58323,'enUS','RATTLEGORE!','RATTLEGORE!',26124),
(58324,'enUS','Once we defeat the Alliance and their allies, claiming this land will be a fitting testimony to the tenacity of the Horde.','',26124),
(58325,'enUS','I\'d be dead or worse if not for you!','',26124),
(58326,'enUS','The Alliance comes to the rescue again!','',26124),
(58327,'enUS','Thank you, Outlander!','',26124),
(58328,'enUS','The jinyu are indebted to you and your Alliance!','',26124),
(58329,'enUS','I\'m free! Long live the Alliance!','',26124),
(58330,'enUS','I wish the jinyu could join the Alliance.  Thank you!','',26124),
(58331,'enUS','I am in your debt. Please save the rest of my people.','',26124),
(58332,'enUS','General Nazgrim needs your training report.','General Nazgrim needs your training report.',26124),
(58333,'enUS','The doctor is in!','',26124),
(58334,'enUS','General Nazgrim wants an update on your progress.','General Nazgrim wants an update on your progress.',26124),
(58335,'enUS','General Nazgrim needs an update on your progress.','General Nazgrim needs an update on your progress.',26124),
(58336,'enUS','That\'s great, $p. We\'ll take it from here.','',26124),
(58337,'enUS','Wow. That\'s a filthy one. Sure you don\'t want to go through the wash too?','',26124),
(58338,'enUS','Whew... that one was ripe.','',26124),
(58339,'enUS','Oh, I\'ve been looking all over for that one. He\'s a handful.','',26124),
(58340,'enUS','Hmm. I think that one is going to need some extra perfuming.','',26124),
(58341,'enUS','Oh, the grummle are going to love that one.','',26124),
(58342,'enUS','What did the yaungol do to that poor thing?','',26124),
(58343,'enUS','I hope that one doesn\'t have to go through twice.','',26124),
(58344,'enUS','You\'re not gonna run me off my land!','',26124),
(58345,'enUS','Hey! Those are my yaks! Bring them back here this instant!','',26124),
(58346,'enUS','If you think I\'m going to be intimidated by a bunch of filthy yaungol, you\'ve got another thing coming!','',26124),
(58347,'enUS','Help! These yaungol are trying to steal my yaks!','',26124),
(58348,'enUS','You better be happy I threw my back out or I\'d come over there and kick you off my land.','',26124),
(58349,'enUS','Filthy yaungol infestation!','',26124),
(58350,'enUS','I hope the mantid come and drag you yaungols back over the wall.','',26124),
(58351,'enUS','I am just glad my wife, spirits guide her, is not around to see our business overrun by these ruffians and hoodlums!','',26124),
(58352,'enUS','It is an absolute travesty of our time I tell you. That a rancher and his son can\'t just run a yak wash in peace without fear of yaungol raiding...','',26124),
(58353,'enUS','If this keeps up, I don\'t know how we are ever going to continue our supply of yaks to the grummle.','',26124),
(58354,'enUS','Have you met the Lucky Eightcoins? He is our biggest customer and the shrewdest of grummle negotiators.','',26124),
(58355,'enUS','Our business has stood for twelve generations and supplied many hundreds of fresh, clean, and smelly yaks to the grummles.$b$bWe\'ve faced floods, famine, and mogu. I\'ll be a hozen\'s uncle if I let these yaungol run us off.','',26124),
(58356,'enUS','You here to steal my yaks?!$b$bIf so, be ready for me to slap that look off your face.','',26124),
(58357,'enUS','Get away from him!','',26124),
(58358,'enUS','Stay out of his range!','',26124),
(58359,'enUS','You saved my son and my ranch. I am forever in your debt, stranger. If you ever find yourself in need of a clean yak, you know where to go.','',26124),
(58360,'enUS','Get away from his attack!','',26124),
(58361,'enUS','Yes! Yes! More blood!','Yes! Yes! More blood!',26124),
(58362,'enUS','Blood blood blood BLOOD BLOOD!!','Blood blood blood BLOOD BLOOD!!',26124),
(58363,'enUS','Dripping and pouring and clotting!','Dripping and pouring and clotting!',26124),
(58364,'enUS','More blood!','More blood!',26124),
(58365,'enUS','The scent of blood...so delicious!','The scent of blood...so delicious!',26124),
(58366,'enUS','Spurts of crimson!','Spurts of crimson!',26124),
(58367,'enUS','Always pumping, always pumping!','Always pumping, always pumping!',26124),
(58368,'enUS','So warm, so red!','So warm, so red!',26124),
(58369,'enUS','I honestly don\'t know how I am going to round up so many yaks on my own. Those yaungol are dangerous.','',26124),
(58370,'enUS','I hope the yaungol arriving wasn\'t a sign of worse things to come. They are bad enough.','',26124),
(58371,'enUS','Pa says we\'ve faced worse. But when he says \"we\" he means people like his great great grandfather.$b$bThe worst thing I\'ve ever had to face was a grummle angry that his yak wasn\'t smelly enough.','',26124),
(58372,'enUS','Mountain sprites are mean creatures. Their pranks can really hurt people.','',26124),
(58373,'enUS','Pa keeps telling me I need to be more like my grandpa. But he died before I was born in a yak stampede.','',26124),
(58374,'enUS','Please! Can you help me! These sprites grabbed me when I was searching for some of our missing yaks.','',26124),
(58375,'enUS','You have no idea how much your help has saved our family business.$b$bI should be able take it from here as long as the yaungol slow down their assault.','',26124),
(58376,'enUS','General Nazgrim wants to know the status of the supplies.','General Nazgrim wants to know the status of the supplies.',26124),
(58377,'enUS','Thank you for rescuing me stranger! I will see you at the Yakwash.','',26124),
(58378,'enUS','That was an impressive number of sprites you just mowed through.','',26124),
(58379,'enUS','The principle is absolute, follow it and you will be accepted.','',26124),
(58380,'enUS','There is nothing but the Crusade! Anyone that is not with us, will fall!','',26124),
(58381,'enUS','Ooo, I can smell the luck of your yaks from here. Come $pc, and I will give you much fortune in return.','',26124),
(58382,'enUS','I lost my yaks.','I lost my yaks.',26124),
(58383,'enUS','Not to worry. These little fellas seem to have found their way back here.','',26124),
(58385,'enUS','Not to worry. The little fellas seem to have found their way back here. Here you go.','',26124),
(58386,'enUS','The answer I seek eludes me...$b$bSometimes $c, one must step back from the trees in order to see the forest.','',26124),
(58389,'enUS','My sight may be gone, but I am fortunate to live in a land which rewards all of the senses.','',26124),
(58390,'enUS','This is no business of yours, $p! I will allow you to leave.','',26124),
(58391,'enUS','Let loose your rage. Kill me and in so doing, validate my existence.','',26124),
(58392,'enUS','I not afraid of little thing like you.','',26124),
(58393,'enUS','I break you!','',26124),
(58394,'enUS','Die!','',26124),
(58395,'enUS','You give yaks now!','',26124),
(58396,'enUS','Challenge accepted!','',26124),
(58397,'enUS','I squish you!','',26124),
(58398,'enUS','','Who\'s out there, Shao? Is it safe?',26124),
(58399,'enUS','I am ready to leave.','I am ready to leave.',26124),
(58400,'enUS','Your yak is beginning to buck. Return to Lao & Son\'s Yakwash.','Your yak is beginning to buck. Return to Lao & Son\'s Yakwash.',26124),
(58401,'enUS','Make it fast, buddy. We\'ve got deadlines to meet.','',26124),
(58402,'enUS','Sometimes it is good to take a step back and reflect upon our larger goals.','',26124),
(58403,'enUS','','Our work here has been steady and tedious, but the statue is almost complete.',26124),
(58404,'enUS','','Take a moment and look at the statue. This marvel is the culmination of a hundred years of labor.',26124),
(58405,'enUS','Need a lift?','',26124),
(58406,'enUS','My father and my father\'s father spent their lives toiling on this statue. I am proud to be the one who will finish it.','',26124),
(58407,'enUS','The work is hard, but necessary. This statue represents all that we believe.','',26124),
(58408,'enUS','Just a few more shipments of jade, and the dragon will be complete.','',26124),
(58409,'enUS','It will feel good to rest after the statue is done.','',26124),
(58410,'enUS','It will not be long, now before our work is finished.','',26124),
(58411,'enUS','My family is planning a great banquet to celebrate the statue\'s completion.','',26124),
(58412,'enUS','Is the work day over yet? The Drunken Hozen in Dawn\'s Blossom is calling my name.','',26124),
(58413,'enUS','$P, YOU DARE?!','',26124),
(58414,'enUS','Useless...','Useless...',26124),
(58415,'enUS','','Class dismissed.',26124),
(58416,'enUS','I need a ride to the top of the statue.','I need a ride to the top of the statue.',26124),
(58417,'enUS','','Going down?',26124),
(58418,'enUS','','Whatever you do, don\'t look down.',26124),
(58419,'enUS','I need a ride to the bottom of the statue.','I need a ride to the bottom of the statue.',26124),
(58420,'enUS','WE\'LL MEET AGAIN, $P!','',26124),
(58421,'enUS','Did you forget, girl? I am the Darkmaster! I command the undead!','',26124),
(58422,'enUS','Now turn your lovely runeblades on our guests, and fetch me their bones!','',26124),
(58423,'enUS','','I...won\'t let you...',26124),
(58424,'enUS','','I can\'t...fight him...',26124),
(58425,'enUS','','END IT! NOW! Before he can...',26124),
(58426,'enUS','YOUR SOUL IS MINE!','',26124),
(58427,'enUS','Look. A stranger. I wonder if $g he\'s : she\'s; come to save us from the yaungol.','Look. A stranger. I wonder if $g he\'s : she\'s; come to save us from the yaungol.',26124),
(58428,'enUS','Shhh, an outlander.','Shhh, an outlander.',26124),
(58429,'enUS','$G He : She; looks pretty powerful. Maybe powerful enough to drive the yaungol back!','$G He : She; looks pretty powerful. Maybe powerful enough to drive the yaungol back!',26124),
(58430,'enUS','We may have to retreat into the Valley of the Four Winds. I don\'t want to give up my home here.','We may have to retreat into the Valley of the Four Winds. I don\'t want to give up my home here.',26124),
(58431,'enUS','A foreigner. $G He : She; looks very exotic. Don\'t stare!','A foreigner. $G He : She; looks very exotic. Don\'t stare!',26124),
(58432,'enUS','Are you here to save us, $c?','Are you here to save us, $c?',26124),
(58433,'enUS','Strange getup, even for a $r $c if you ask me.','Strange getup, even for a $r $c if you ask me.',26124),
(58434,'enUS','I don\'t care what you say. If that $c is here to help us, I say we welcome $g him : her; with arms wide open!','I don\'t care what you say. If that $c is here to help us, I say we welcome $g him : her; with arms wide open!',26124),
(58435,'enUS','Jade, it\'s all about the jade! We need it, and that\'s the bottom line!','',26124),
(58436,'enUS','This jade shortage is the worst thing to happen since the golden autumn crisis. Production is already months behind. The Serpent ain\'t getting any younger!','',26124),
(58437,'enUS','Show me your wares.','Show me your wares.',26124),
(58438,'enUS','A luckydo would be wise to buy my wares. Bad fortune to those who simply walk away.','',26124),
(58439,'enUS','Oh that\'s a fine piece o\' metal you have der. I am quite fond of a good piece of steel.','',26124),
(58440,'enUS','Welcome to Binan Village, $c. I beg you... please help us.','',26124),
(58441,'enUS','I\'ve got your jade right here.','I\'ve got your jade right here.',26124),
(58442,'enUS','Did someone say they needed jade?','Did someone say they needed jade?',26124),
(58443,'enUS','I\'ve got a jade delivery for you.','I\'ve got a jade delivery for you.',26124),
(58444,'enUS','I\'ve got a new jade shipment for you.','I\'ve got a new jade shipment for you.',26124),
(58445,'enUS','Lovely, beautiful! If you have time, you should also visit the East Temple. You may gain further insight into our great statue, and its importance to our way of life.','',26124),
(58446,'enUS','Lovely, beautiful! I see you have already visited the East Temple. Then you understand why this statue is so important to our way of life.','',26124),
(58447,'enUS','','Trick to drinking with grummles is not to stop. With any luck, they\'ll pass out before you do.',26124),
(58448,'enUS','Unbelievable! You\'ve just saved my neck, $n. Oh ho, and just look at this luster.','',26124),
(58449,'enUS','','Wonderful! Just look at it. A hundred years to produce this incredible monument for the Jade Serpent. And now, you too have contributed to this masterpiece.',26124),
(58450,'enUS','','Soon, very soon, it will all pay off.',26124),
(58451,'enUS','It\'s about time we got another shipment. I heard they were having trouble at the mines, but our work cannot wait.','',26124),
(58452,'enUS','Within every brush stroke are a thousand meanings.','',26124),
(58453,'enUS','I have written many powerful words in my time, but still, the most powerful is hidden to me.','',26124),
(58454,'enUS','I prefer to work in solitude.','',26124),
(58455,'enUS','What can I get for you?','',26124),
(58456,'enUS','Great day for a race, don\'t you think?','',26124),
(58457,'enUS','Hot food, fresh food, delicious food! Get your race snacks here!','',26124),
(58458,'enUS','You were magnificent out there, $n!','',26124),
(58459,'enUS','There\'s my $g boy : girl;!','',26124),
(58460,'enUS','All hail the savior of Binan Village!','',26124),
(58461,'enUS','Tell us again how you slew the yaungol war leader, $n.','',26124),
(58462,'enUS','Have you considered settling down, $n? Kun-Lai Summit could use a strong $c such as yourself as its protector.','',26124),
(58463,'enUS','I\'ve never witnessed such heroics and selflessness.','',26124),
(58464,'enUS','Welcome back! What news, $n?','',26124),
(58465,'enUS','It\'s good to see you, $n.','',26124),
(58466,'enUS','$n, I was wondering if you\'d be willing to endorse me come election time?','',26124),
(58467,'enUS','You have saved Binan Village, $n. Ring the gong so all shall know!','',26124),
(58468,'enUS','Is everything alright, $c? We\'re all counting on you to kill the yaungol war leader.','',26124),
(58469,'enUS','I won\'t let them take me!','I won\'t let them take me!',26124),
(58470,'enUS','My house! My things! It\'s all ablaze!','My house! My things! It\'s all ablaze!',26124),
(58471,'enUS','My dog?! Where\'s my dog?!','My dog?! Where\'s my dog?!',26124),
(58472,'enUS','Thank you... Now what?','Thank you... Now what?',26124),
(58473,'enUS','The whole town is gone!','The whole town is gone!',26124),
(58474,'enUS','What are we going to do?!','What are we going to do?!',26124),
(58475,'enUS','I never thought something like this could happen here...','I never thought something like this could happen here...',26124),
(58476,'enUS','Did you see what $n the $c did to the yaungol?','Did you see what $n the $c did to the yaungol?',26124),
(58477,'enUS','With $n here, we may be back in our homes soon!','With $n here, we may be back in our homes soon!',26124),
(58478,'enUS','I\'ve never seen a $c like $g him : her; before. $G He\'s : She\'s; already beaten the yaungol!','I\'ve never seen a $c like $g him : her; before. $G He\'s : She\'s; already beaten the yaungol!',26124),
(58479,'enUS','Look, it\'s $n, savior of Binan Village!','Look, it\'s $n, savior of Binan Village!',26124),
(58480,'enUS','I never doubted $n, not for one minute!','I never doubted $n, not for one minute!',26124),
(58481,'enUS','You just don\'t see $cs like $n anymore.','You just don\'t see $cs like $n anymore.',26124),
(58482,'enUS','I heard that $n comes from a far off land beyond the mists. $G He : She; must be their $g hero : heroine; to have come all this way to save us.','I heard that $n comes from a far off land beyond the mists. $G He : She; must be their $g hero : heroine; to have come all this way to save us.',26124),
(58483,'enUS','Look everyone, it\'s $n! Hurray for $n!','Look everyone, it\'s $n! Hurray for $n!',26124),
(58484,'enUS','Attack! Kill them all!','',26124),
(58485,'enUS','Release the hounds!','',26124),
(58489,'enUS','All attack now!','',26124),
(58490,'enUS','Don\'t just sit there! Kill them!','',26124),
(58491,'enUS','Stupid animals!  I\'ll put you down after I kill these weaklings.','',26124),
(58492,'enUS','','It burns...my soul...it burns!!!!',26124),
(58493,'enUS','','Greetings, $c. Your people are inside. But first, may I ask a favor?',26124),
(58494,'enUS','','Have you had a chance to test the efficacy of my family\'s dit da jow, $c?',26124),
(58495,'enUS','','The warriors are reporting that you saved their lives. Thank you, $n.',26124),
(58496,'enUS','','Always good to see you, $n. How have you been?',26124),
(58497,'enUS','','How are you feeling, $c? Need more dit da jow?',26124),
(58498,'enUS','','It amazes me how selfless and kind you have been to all of us.',26124),
(58499,'enUS','','How are your friends doing, $n?',26124),
(58500,'enUS','','There $g he : she; is. You\'re welcome here anytime, $n.',26124),
(58501,'enUS','','Going to be around long, $n? You\'ll have to tell me about your latest exploits.',26124),
(58502,'enUS','','With all of the adventuring you do, what you need is a good rest, young $g man : lady;.',26124),
(58503,'enUS','','I was just thinking about you, $n.',26124),
(58504,'enUS','It is a luckydo to have a clean yak. It is a bigger luckydo to feed it my special brew. This is how one makes Kobeyaks!','',26124),
(58505,'enUS','I can feel her will breaking! Her soul burns so brightly.','',26124),
(58506,'enUS','What am I missing...','What am I missing...',26124),
(58507,'enUS','Something isn\'t right...','Something isn\'t right...',26124),
(58508,'enUS','','A foreigner? And by the look of you, a seasoned $c. Good! Maybe you can get us out of this mess.',26124),
(58509,'enUS','','My plan hinges on you bringing us as many arrows as you can from the battlefield, $c.',26124),
(58510,'enUS','','Looks like you got more than enough. Quick, $n, I think I can see the yaungol reinforcements massing on the horizon.',26124),
(58511,'enUS','<The farmer stares at the floor with a distant look in his eyes.>$B$BThey... took them.$B$BTook them away...','',26124),
(58512,'enUS','Are you going to find them? Can you really?','',26124),
(58513,'enUS','Now, Lilian, it is time for your transformation.','',26124),
(58514,'enUS','','Hail the hero of Kun-Lai Pass, $n!',26124),
(58515,'enUS','','Good to see you again, $n. Feel like taking another swing at these yaungol pests?',26124),
(58516,'enUS','','Don\'t mind us. We\'re just mopping up the last of them now. Shouldn\'t be much longer.',26124),
(58517,'enUS','','Don\'t I owe you a drink, $g handsome : lady;?',26124),
(58518,'enUS','','You figure out yet what\'s driving all of these yaungol out of the Townlong Wastes?',26124),
(58519,'enUS','','Careful with those shots. Don\'t hit $n!',26124),
(58520,'enUS','','It\'s a real honor, $n. Maybe we can have a sitdown soon and you can regale me with your latest exploits?',26124),
(58521,'enUS','','Give \'em hell, $n!',26124),
(58522,'enUS','','...',26124),
(58523,'enUS','Why let a perfectly good corpse go to waste?','',26124),
(58524,'enUS','How does it feel, Voss?  To watch them hack your mortal body to pieces?','',26124),
(58525,'enUS','Stranger! A moment of your time if you please?','',26124),
(58526,'enUS','How intriguing, her spirit will not relinquish its grasp on this world.','',26124),
(58527,'enUS','','DIE, NECROMANCER!',26124),
(58528,'enUS','','Leave me...to die...alone...please...',26124),
(58529,'enUS','What?!','',26124),
(58530,'enUS','The bones! You wretch!','',26124),
(58531,'enUS','My house is just to the right as you enter the village. The mask should be upstairs.','',26124),
(58532,'enUS','The $c returns. Is that my mask I spy?','',26124),
(58533,'enUS','','$C, I would ask something of you.',26124),
(58534,'enUS','Over here, $n!','',26124),
(58535,'enUS','How fare your efforts to remove the taint of the sha from the jinyu, $c?','',26124),
(58536,'enUS','Thank you, $n. You just saved my hide!','',26124),
(58537,'enUS','I\'m still amazed that I ever joined the Shado-Pan to be honest. Not that they\'re not an amazing bunch and all, just the thought of the violence clashing with my impecible complection.$B$BI never have trouble remembering why I joined them though... let\'s just say Anji can be very convincing.','',26124),
(58538,'enUS','','Betrayed! We came here every week. They seemed to be simple traders. \n\nNow these... fish-men greet us with one webbed hand, all the while with the other behind their back, holding their knives, waiting for us to turn around so they can plunge them in!',26124),
(58539,'enUS','Take your time, $n. Better that you face the Fury Leviathan prepared and on your terms.','',26124),
(58540,'enUS','','I would DESTROY them. It is worthless to stay here!',26124),
(58541,'enUS','','$p, if the scouts give you any information on the mogu leader, you know what to do.',26124),
(58542,'enUS','Is it done, $n? We saw the explosion from all the way over here.','',26124),
(58543,'enUS','What\'s the mask for?','',26124),
(58544,'enUS','Woah!','',26124),
(58545,'enUS','Masterfully done, $n.','',26124),
(58546,'enUS','You did it! You really did it! Maybe you can show me some of your moves, $n?','',26124),
(58547,'enUS','','%s grunts her admiration.',26124),
(58548,'enUS','Look, it\'s $n!','',26124),
(58549,'enUS','$n, can I come and train with you after we\'re done here?','',26124),
(58550,'enUS','I think I want to be a $c, swordmistress.','',26124),
(58551,'enUS','Where do you come from, $n? When you go back, can I come?','',26124),
(58552,'enUS','Thanks again for handling my chores. See you back at the village soon?','',26124),
(58553,'enUS','Hey, $n, what do you think of this move?','',26124),
(58554,'enUS','$n!','',26124),
(58555,'enUS','$n could probably wipe out all of these tainted jinyu with one of $g his : her; signature $c moves.','',26124),
(58556,'enUS','Ah, you\'ll make a fine rock-breaker I think!','',26124),
(58557,'enUS','Insolent cubs! Submit or die!','',26124),
(58558,'enUS','I will teach you to obey!','',26124),
(58559,'enUS','How dare you speak to me like that! Know your place!','',26124),
(58560,'enUS','You\'re nothing but backwater peasants with sticks! Get back in line!','',26124),
(58561,'enUS','We are legion. We are everywhere. See you back at Jinyu Mere, $p.','',26124),
(58562,'enUS','OUR JINYU! YOU CANNOT HAVE THEM BACK, $P!','',26124),
(58563,'enUS','Give in to your anger.','',26124),
(58564,'enUS','We are honored that you have chosen to be tainted.','',26124),
(58565,'enUS','You will make an excellent addition, $p.','',26124),
(58566,'enUS','The Fury Leviathan will enjoy using your body as a puppet against these lands.','',26124),
(58567,'enUS','Why do you care what we do to these fish heads?','',26124),
(58568,'enUS','NO! I WILL POSSESS YOU AND ALL OF YOUR KIND!','',26124),
(58569,'enUS','How much of your time is spent inflicting your anger on others? How can you possibly hope to defeat us?','',26124),
(58570,'enUS','This will be the bomb.','',26124),
(58571,'enUS','Good to see you again, $p.$B$BThis place is ancient. There are answers here, for those who know the questions.','',26124),
(58572,'enUS','','Look, stranger, I\'ll tell you the same thing I told the honorable Lorewalker...$B$B<Mann leans in closer with each word, her eyes widening.>$B$BI. Have. No. Jade!',26124),
(58573,'enUS','This is fascinating... but what could it mean?!$B$BThe jade you gathered from those sprites will help us fill in the next panel, but we\'ll need more to finish the whole fresco.$B$BPlease help the foreman get her quarry back in operation.','',26124),
(58574,'enUS','Take a look, $p. This panel clearly depicts war.$B$BWhat could be next? What is it trying to say?','',26124),
(58575,'enUS','','Normally we\'d be more than capable of fulfilling Cho\'s request. Jade veins run through this land like...$B$B<Mann scratches her head for a moment in thought.>$B$BWell, like something that runs through something else in veins. $B$BLook, I ain\'t a poet.$B$BPoint is: we got problems.',26124),
(58576,'enUS','','The quarry will be fine thanks to you.$B$BThink I\'ll let some o\' the boys take a little vacation...$B$BHAH! Who am I kiddin\'? I almost said that with a straight face, too.$B$BWe got WORK to do!',26124),
(58577,'enUS','Don\'t worry about me none.$B$BHNNGGHHH!!$B$BI\'ll be fine, really.','',26124),
(58578,'enUS','You think that was bad? You shoulda been here, oh, thirty years ago, I\'d say.$B$BOne o\' the boys left his lunch out - some kind of fish stew, if mem\'ry serves.$B$BWell he leaves it out in the atrium - BIG ol\' pot o\' fish stew, I\'m sure of it now - and, cub\'s honor, every hozen within a hundred miles come a-runnin\'.$B$BAfter cleanin\' THAT up, I\'ll take some overgrown nibblers any day...','',26124),
(58579,'enUS','The yaungol are attacking!','The yaungol are attacking!',26124),
(58580,'enUS','We\'re going to die!','We\'re going to die!',26124),
(58581,'enUS','Somebody save us!','Somebody save us!',26124),
(58582,'enUS','Bramblestaff, do something!','Bramblestaff, do something!',26124),
(58583,'enUS','Our warriors are losing!','Our warriors are losing!',26124),
(58584,'enUS','What did we ever do to the yaungol?!','What did we ever do to the yaungol?!',26124),
(58585,'enUS','The yaungol must be attacking because of the stranger!','The yaungol must be attacking because of the stranger!',26124),
(58586,'enUS','Dang nibblers are tearin\' the place down in there!','Dang nibblers are tearin\' the place down in there!',26124),
(58587,'enUS','Hello there! I\'m Weng: pupil of nature!$B$BI\'ve been sent to investigate the recent wood sprite problems.$B$BI\'ve always been fascinated with wood sprites, even as a child. They\'re not normally violent, you know.$B$BPlayful, maybe, but rarely do they mean any real harm.','',26124),
(58588,'enUS','Help!','',26124),
(58589,'enUS','Over here!','',26124),
(58590,'enUS','Sully! Little Lu! Anyone!','',26124),
(58591,'enUS','AAAHH!!','',26124),
(58592,'enUS','I bleed... haha... but I won\'t die!','',26124),
(58596,'enUS','Weak slickies are good for nuthin\'!','',26124),
(58597,'enUS','Stay down, stupid slickies!','',26124),
(58598,'enUS','Let\'s see how strong you are without your slicky friends!','',26124),
(58599,'enUS','I will have your unruly spirit, like all the others!','',26124),
(58600,'enUS','You are MINE!','',26124),
(58601,'enUS','You... will not defeat... the thunder...','',26124),
(58602,'enUS','','Ain\'t much to it!$B$BThere are five rare treasures that you can find in the Dark Soil around Pandaria: Ruby Shards, Lovely Apples, Jade Cats, Blue Feathers, and Marsh Lilies.$B$BAs long as you have one of those items in your bags, you\'ll see who around here is willing to accept them.$B$BFind one of those and give them to someone you like, and chances are they\'ll like you a little back! Everyone has a favorite item out of the five, so talk to folks to learn what they prefer.$B$BAlso, the folks \'round here love food! I mean, who doesn\'t? If you know how to cook, you might just profit!$B$BThat\'s about all I know about gifts. Good luck!',26124),
(58603,'enUS','What kind of gifts do you like?','What kind of gifts do you like?',26124),
(58604,'enUS','Go get \'em, kid.','',26124),
(58605,'enUS','Hey, kid! You all right?\n\nI\'ve got you. Don\'t go into the light!','',26124),
(58608,'enUS','Ah, fresh meat for the dogs.','',26124),
(58609,'enUS','','I\'ve got backup. Watch this.',26124),
(58610,'enUS','$n, over here.','',26124),
(58611,'enUS','We must gain a foothold here.. away from these Horde dogs.','',26124),
(58612,'enUS','I grow weary of these Horde cowards. There must be someplace else in this village to rest.','',26124),
(58613,'enUS','These people shall not be enslaved by your cruel Horde. I will not allow it!','',26124),
(58614,'enUS','How many innocents have died at your hand, orc? Your Horde has no honor...','',26124),
(58615,'enUS','Only three Horde rats left. Shouldn\'t be a problem to finish you off once and for all.','',26124),
(58616,'enUS','Kun-Lai Summit is where you\'re going to die, orc. I\'m going to bury you.','',26124),
(58617,'enUS','I\'ll wait until you\'re healed to finish you, Nazgrim. Let it not be said that the Alliance has no honor.','',26124),
(58618,'enUS','Look at the peaceful, kind people of this land. They were born to belong to the Alliance.','',26124),
(58619,'enUS','$n, over here!','',26124),
(58620,'enUS','As soon as I... can get up, I\'m going to crush you!','',26124),
(58621,'enUS','Goblin, find my axe! I\'ll separate this fool human\'s head from his neck!','',26124),
(58622,'enUS','Soon, you and your Alliance will only be found in Azeroth\'s history books.','',26124),
(58623,'enUS','My axe will soon feast upon your blood, human.','',26124),
(58624,'enUS','Your kind shall never build a foothold here. This is destined to be Horde land.','',26124),
(58625,'enUS','You... you escaped me in Vashj\'ir. You won\'t be so lucky here.','',26124),
(58626,'enUS','These pandaren are a wise enough people. Sooner or later, they will side with the Horde.','',26124),
(58627,'enUS','I hope you have the courage to die bravely, human. I\'m in the mood for a good fight.','',26124),
(58628,'enUS','Mistakes are simply lessons we have yet to learn, $n. It is how you handle those mistakes that will ultimately define you.','',26124),
(58629,'enUS','You go on ahead. I\'ll gather my tools and meet you at Sunsong Ranch.','',26124),
(58630,'enUS','Defeating the Lingering Doubts will take a level head and steady emotions, $c. With them under control the rebuilding process can begin.','',26124),
(58631,'enUS','Fool! I will crush you!','',26124),
(58632,'enUS','Patience, now. It will be done soon.','',26124),
(58633,'enUS','The sooner I\'m left alone, the faster the work will be finished.','',26124),
(58634,'enUS','Weed whacking is hard work.','',26124),
(58635,'enUS','Just a little more, and it will be finished.','',26124),
(58636,'enUS','This field will look as good as new in no time!','',26124),
(58637,'enUS','Gone to Halfhill Market. Don\'t touch my vegetables!\n\n- Farmer Fung','',26124),
(58638,'enUS','Cinematic will happen here...','',26124),
(58639,'enUS','It\'s finally over...','',26124),
(58640,'enUS','I\'ll be waiting at the Tan-Chao. Come and speak to me there.','',26124),
(58641,'enUS','The spirits can finally rest, thanks to you. Soon I, too, will return to the other side.$B$BI leave you with this piece of advice: Pandaria is a land of history. If ever you are unsure about the future, you need only to seek answers from the past.$B$BRemember this, and you will thrive here.','',26124),
(58642,'enUS','Whoa! Uh... I gotta... go!','Whoa! Uh... I gotta... go!',26124),
(58643,'enUS','Great gourds! Sorry, but I need to leave!','Great gourds! Sorry, but I need to leave!',26124),
(58644,'enUS','Uh-oh...! I feel the call of nature!','Uh-oh...! I feel the call of nature!',26124),
(58645,'enUS','Oh! I feel something rumbling. Excuse me!','Oh! I feel something rumbling. Excuse me!',26124),
(58646,'enUS','Wow, that\'s some powerful stuff. I\'ve got the runs... er... got to run!','Wow, that\'s some powerful stuff. I\'ve got the runs... er... got to run!',26124),
(58647,'enUS','Put it out!','',26124),
(58648,'enUS','The banner\'s on fire!','',26124),
(58649,'enUS','Oh no!','',26124),
(58650,'enUS','The banner!','',26124),
(58651,'enUS','Ur-Bataar, help!','',26124),
(58652,'enUS','Fire bad!','',26124),
(58653,'enUS','Intruder!','',26124),
(58654,'enUS','Ur-bataar will kill you!','',26124),
(58655,'enUS','Do you have any gooseberries for sale?','Do you have any gooseberries for sale?',26124),
(58656,'enUS','No! Kun-Lai was ours....','',26124),
(58657,'enUS','Hello friend!  You\'re welcome to use my cart if you like.  It will take you to the Temple of Five Dawns.','',26124),
(58658,'enUS','This footprint is too muddy to be useful.','',26124),
(58659,'enUS','Next to this track, you see some bits of chewed up carrot.','',26124),
(58660,'enUS','The muddy track clearly shows a dexterous paw.','',26124),
(58661,'enUS','Stamped into the footprint is a clod of mud mixed with hay and yak hair.','',26124),
(58662,'enUS','Behind the print is the long impression of a prehensile tail.','',26124),
(58663,'enUS','Next to signs of a scuffle is a sharp, pointy spearhead and some colorful feathers.','',26124),
(58664,'enUS','Footprints lead toward the mountain to the north.','',26124),
(58665,'enUS','A startled hozen leaps out of a nearby bush!','',26124),
(58666,'enUS','It all makes sense! All the strange things that have been happening on our farms. The hozen must have been behind it all! I must admit, you figured it out pretty quickly, $n.','',26124),
(58667,'enUS','','Howdy, stranger!',26124),
(58668,'enUS','Tell me the story about Farmer Yoon\'s wagon.','Tell me the story about Farmer Yoon\'s wagon.',26124),
(58669,'enUS','','My pappy must\'ve told me the story a hunnert times!$B$BBack during the great drought, times sure were hard. Farmers were spitting on their crops to water \'em, it was so dry. The entire town was starvin\' o\' thirst!$B$BSo what does Farmer Yoon\'s grandpappy do but pack up his wagon in the middle o\' the night.$B$BThen he drives his mushan beast all the way to the lake at the base o\' Kun-Lai Summit. He loads up that wagon with a hunnert barrels o\' fresh water, then drives right on back.$B$BHe didn\'t stop fer nuthin\'! How could he? Our whole town was dyin\'! He drove that busted wagon up to his farm and his mushan died on the spot!$B$BBut we had enough water for the entire town and the spring harvest, too.$B$BSaved Halfhill, Yoon\'s grandpappy did!',26124),
(58670,'enUS','','I\'ll collect my tools and meet you at Farmer Yoon\'s. Bet I can beat you there!',26124),
(58671,'enUS','','Are all you citypaws this impatient?',26124),
(58672,'enUS','','Well this wagon ain\'t gonna fix itself.',26124),
(58673,'enUS','','Look, here\'s the deal. You keep yammerin\' and I stop hammerin\'.',26124),
(58674,'enUS','','I got a green thumb and a steel thumb. My pappy taught me how to fix just \'bout anything.',26124),
(58675,'enUS','It seems that after only a few days of study, Anduin already understands the Way of the Crane.$B$BPerhaps he always has?','',26124),
(58676,'enUS','<The dog\'s ribs are poking out of its sides. It looks at you with pitiful eyes.>','',26124),
(58677,'enUS','<The dog\'s fur is matted with dirt. Its breathing is shallow.>','',26124),
(58678,'enUS','<The dog raises its head to look at you, and wags its tail weakly.>','',26124),
(58679,'enUS','Good fortune to friend of grummles. Many thanks for aid!','',26124),
(58680,'enUS','Woof!','',26124),
(58681,'enUS','The dog wags its tail happily. It heads toward your farm!','',26124),
(58682,'enUS','Serpent, charge me with your power!','',26124),
(58683,'enUS','Their energy is strong!','',26124),
(58684,'enUS','No, no! Do not fail me!','',26124),
(58685,'enUS','Your dog smiles at you.','',26124),
(58686,'enUS','The dog wags its tail happily.','',26124),
(58687,'enUS','The dog tilts its head, as if wondering what you\'re thinking.','',26124),
(58688,'enUS','Your dog pushes its head under your hand.','',26124),
(58689,'enUS','Your dog loves you too!','',26124),
(58690,'enUS','Your dog gives your face a sloppy wet lick.','',26124),
(58691,'enUS','Wika-Wika just trying to start a farm. Didn\'t know it would be this hard.','',26124),
(58692,'enUS','You here to stomp on the mook-mooks?','',26124),
(58693,'enUS','Look! There\'s a mook-mook right there!','',26124),
(58694,'enUS','More mook-mooks! Look out!','',26124),
(58695,'enUS','Uh-oh, stingin\' bugs! Don\'t let them get near you! They bite!','',26124),
(58696,'enUS','Looks like the mook-mooks went away. For now. You should go talk to boss Mudclaw.','',26124),
(58697,'enUS','Mook-mooks?','Mook-mooks?',26124),
(58698,'enUS','Click on marmots to stomp them!','Click on marmots to stomp them!',26124),
(58699,'enUS','Avoid insect swarms!','Avoid insect swarms!',26124),
(58700,'enUS','These ballistas are just the advantage we needed! Now if we can just get the other one up and runnin\' we\'ll really be in business.','',26124),
(58701,'enUS','Take it all, stingy bugs!','',26124),
(58702,'enUS','Stay away from my crops!','',26124),
(58703,'enUS','You gonna get a mouth full of pesticide!','',26124),
(58704,'enUS','Stay back, you ookin\' bugs!','',26124),
(58705,'enUS','Get out of here, dookers!','',26124),
(58706,'enUS','Yeah! Get sprayed!','',26124),
(58707,'enUS','A vicious guard dog appears!','A vicious guard dog appears!',26124),
(58708,'enUS','Need healing!','',26124),
(58709,'enUS','I\'ll get \'em with my pesticide!','',26124),
(58710,'enUS','The convoy to Neverest Basecamp is leaving now! Gather around!','',26124),
(58711,'enUS','I\'ll start gettin\' her prepped for ye to return.','',26124),
(58712,'enUS','','%s licks her finger and holds it up. She sniffs the air, her eyes scanning the sky.',26124),
(58713,'enUS','%s tinkers with her weather instrumentation, a gleam in her eyes.','',26124),
(58714,'enUS','','The barometer is falling fast. Time to start hauling gear!',26124),
(58715,'enUS','%s scans the sky pensively, clicking her tongue. She sniffs the air and furrows her brow.','',26124),
(58716,'enUS','Stomp on marmots! Avoid insect swarms!','Stomp on marmots! Avoid insect swarms!',26124),
(58717,'enUS','','Happy travels, $r!$B$BThe weather may look nice now, but the skies over the Jade Forest can darken quickly with squalls. Can you feel the air changing? Perhaps you\'d like to help me brew some of my legendary Boomer Brew?',26124),
(58718,'enUS','It has been an honor to train with you.','',26124),
(58719,'enUS','You have shown me I must remain diligent in my training.','',26124),
(58720,'enUS','One can only grow from their defeats.','',26124),
(58721,'enUS','I will be better prepared next time we meet!','',26124),
(58722,'enUS','Will you test my skills?','',26124),
(58723,'enUS','I must be in top fighting condition when we face the Hozen in battle.','',26124),
(58724,'enUS','Training is an ongoing process. There is always something to learn.','',26124),
(58725,'enUS','Let\'s see what you\'ve got.','Let\'s see what you\'ve got.',26124),
(58726,'enUS','Oooh, delicious juju!','',26124),
(58727,'enUS','[PLACEHOLDER] Teleport me to the Scenario','[PLACEHOLDER] Teleport me to the Scenario',26124),
(58728,'enUS','Chief Yip-Yip is about to charge forward! Throw a melon now!','',26124),
(58729,'enUS','Grummles en route for Neverrest Basecamp gather round for the lighting of the traditional travel incense.','',26124),
(58730,'enUS','What\'s that? A sweet juju?','',26124),
(58731,'enUS','Pretty juju? Me want to eat!','',26124),
(58732,'enUS','Fresh fruit for me?','',26124),
(58733,'enUS','Ughhhh...boss don\'t feel so good...','',26124),
(58734,'enUS','Something bad in that juju...','',26124),
(58735,'enUS','Ughhh...bad juju make me sick!','',26124),
(58736,'enUS','What you put in that juju?','',26124),
(58737,'enUS','This may be a bit unsettling...','',26124),
(58738,'enUS','Ho, Yoon! Is it true? Did your plan work?','',26124),
(58739,'enUS','Hey!','',26124),
(58740,'enUS','Is that nasty Chief Yip Yip dead?','',26124),
(58741,'enUS','Nice job, Yoonie!','',26124),
(58742,'enUS','Well I\'ll be a hozen\'s uncle...','',26124),
(58743,'enUS','You know Yoon, maybe I was wrong about you.','',26124),
(58744,'enUS','I know I\'m a stubborn old paw of the earth, but even I have to admit you\'ve done me a great deed.','',26124),
(58745,'enUS','My farm was in real trouble because of those hozen, but it\'s saved thanks to you.','',26124),
(58746,'enUS','You\'ve more\'n earned my vote.','',26124),
(58747,'enUS','$n, this last spot\'s for you and Farmer Yoon. Why don\'t you do the honors?','',26124),
(58748,'enUS','Yoon, $n, it\'s an honor to have you join us.','',26124),
(58749,'enUS','Yes, it\'s true! Thanks to $n, the Kunzen\'s leader is dead. Those monkeys shouldn\'t bother Mr. Mudclaw any more.','',26124),
(58750,'enUS','Oh, finally! This is my absolute dream! Yes, Mr. Mudclaw! Of course I\'ll join you!','',26124),
(58751,'enUS','Work faster!','',26124),
(58752,'enUS','Ah, welcome. Are you here to buy spices? Strange, rare, exotic spices?$b$bYou\'ve come to the right place... neighbor.','',26124),
(58753,'enUS','Can I help you, $c?','',26124),
(58754,'enUS','Step inside, step inside! Is there anything I can get for you today?','',26124),
(58755,'enUS','Hello! I\'m here on behalf of Gina Mudclaw, regarding your debt.','Hello! I\'m here on behalf of Gina Mudclaw, regarding your debt.',26124),
(58756,'enUS','Stop slacking off!','',26124),
(58757,'enUS','Absolutely. I have her payment right here. And send her my... regards.','',26124),
(58758,'enUS','Gina? That girl down in the marketplace? Hah!$b$bTell that pretty little thing to come collect the money personally. I\'m sure she and I can come to some sort of... agreement.','',26124),
(58759,'enUS','Next time I hit harder!','',26124),
(58760,'enUS','My debt? I owe that girl nothing.$b$bI\'m pretty sure she... GAVE me those spices. I saw her wink at me. This sort of thing happens often when you\'re as handsome as I am.$b$bAre you still here? Scurry off, little $r.','',26124),
(58761,'enUS','You pandaren are weak.','',26124),
(58762,'enUS','We took your land and now we take your food.','',26124),
(58763,'enUS','<Threaten him with violence.> Do you want to get punched in the mouth?','<Threaten him with violence.> Do you want to get punched in the mouth?',26124),
(58764,'enUS','Hey, hey! No need to get physical! Fine, I\'ll pay... but don\'t expect me to be happy about it.','',26124),
(58765,'enUS','This is fun!','',26124),
(58766,'enUS','<Offer to pay his debt for him.> Don\'t worry about it. I will pay your share today.','<Offer to pay his debt for him.> Don\'t worry about it. I will pay your share today.',26124),
(58767,'enUS','No breaks, just work!','',26124),
(58768,'enUS','That\'s more like it. Now off you go. Shoo! You\'re scaring off the real customers!','',26124),
(58769,'enUS','This land is soft like you.','',26124),
(58770,'enUS','Many things to sell, yes. Yak-hair amulets. Very popular. Very lucky.','',26124),
(58771,'enUS','I bring treasures. Treasures from far away. Treasures from beyond the mountains... treasures from beyond the wall, even.','',26124),
(58772,'enUS','It is a most auspicious day today, is it not?','',26124),
(58773,'enUS','Oh yes! The market girl! Here you are! A wise man pays his debts when an imposing-looking $c is involved.','',26124),
(58774,'enUS','A wise man pays his debts off immediately. A wiser man knows when he is being swindled.$b$bGina sits in the market and counts money all day. I walk the lonely roads and am lucky to make enough to scrape by. Why should I have to pay?','',26124),
(58775,'enUS','Gina\'s father is very, very rich. If she wants money, she can always speak with him.$b$bWhy must she bother poor old Jambeezi?','',26124),
(58776,'enUS','<Threaten him with violence.>\nA debt is a debt. Let\'s see the money.','<Threaten him with violence.>\nA debt is a debt. Let\'s see the money.',26124),
(58777,'enUS','Now, now! Bad luck to raise your fists in the middle of town. I was just... just testing you. Here is the money I owe.','',26124),
(58778,'enUS','<Offer to pay off his debt.>\nDon\'t worry, Jambeezi. I will pay your share today.','<Offer to pay off his debt.>\nDon\'t worry, Jambeezi. I will pay your share today.',26124),
(58779,'enUS','You are as kind as you are intelligent. It is very lucky to help a stranger.','',26124),
(58780,'enUS','','Come inside, and have a seat. Get off your feet... I\'m sure you\'ve been running around all day.$b$bNow, what can I do for you?',26124),
(58781,'enUS','','Pretty warm out today, isn\'t it?',26124),
(58782,'enUS','','Welcome to Halfhill, neighbor.',26124),
(58783,'enUS','','Of course you are! Thanks for coming by. Here\'s my payment.',26124),
(58784,'enUS','','I wish I could pay today... but business has been so bad lately. I just don\'t have the money.$b$bThe few pieces of gold I have were going to buy dinner for my family. Please... there must be something you can do.',26124),
(58785,'enUS','','I understand, I owe money. I can pay you if I need to, but...$b$bI NEED this money. Our inn is falling apart. If I don\'t have money to pay for repairs, I\'ll be out of a job... and a home.',26124),
(58786,'enUS','<Threaten her with violence.> Not my problem. Pay up or face the consequences.','<Threaten her with violence.> Not my problem. Pay up or face the consequences.',26124),
(58787,'enUS','','I understand. Here\'s the payment. I\'m sorry to have taken so much of your time, $gsir:ma\'am;.',26124),
(58788,'enUS','<Offer to pay off her debt.> I\'ll pay your debt today. It\'s the least I can do.','<Offer to pay off her debt.> I\'ll pay your debt today. It\'s the least I can do.',26124),
(58789,'enUS','','You are a good $gman:woman;, $n. This act of kindness won\'t be forgotten.',26124),
(58790,'enUS','All these folks comin\' and goin\' these days. It really gets you thinkin\' about life.$b$bLike, maybe... I should be comin\' and goin\' somewhere, too.','',26124),
(58791,'enUS','What d\'you suppose is out there? Outside of Pandaria, I mean?','',26124),
(58792,'enUS','You ever just go walkin\', for no reason at all? Just to see what\'s on the other side of the hill?$b$bMa says I got busy feet and an upside-down brain to boot. But I think maybe she\'s the one that\'s got it all backwards.','',26124),
(58793,'enUS','I remember Gina! I bought some supplies from her, a few days back. Here\'s the money. Tell her I said hello.','',26124),
(58794,'enUS','Uh-oh...$b$bI probably shouldn\'t tell you, but I\'m saving up my money to leave this town. I just can\'t stand staying in one place anymore.$b$bYou\'re an adventurer... you understand. Could you help me out?','',26124),
(58795,'enUS','%s draws his sword and shield.','',26124),
(58796,'enUS','Oh... oh no. I\'m gonna be in big trouble when ma finds out about this.$b$bCould you pay my debt for me?','',26124),
(58797,'enUS','%s drops his shield and draws a dagger.','',26124),
(58798,'enUS','<Threaten him with violence.> You need to be taught a lesson, kid. Pay up.','<Threaten him with violence.> You need to be taught a lesson, kid. Pay up.',26124),
(58799,'enUS','Whoah! You... you\'re serious about this! OK, fine... here\'s everything I\'ve got.','',26124),
(58800,'enUS','<Offer to pay off his debt.> I\'ll pay your debt today. Next time, try to be more responsible.','<Offer to pay off his debt.> I\'ll pay your debt today. Next time, try to be more responsible.',26124),
(58801,'enUS','R-really? I won\'t forget this, $gsir:ma\'am;!','',26124),
(58802,'enUS','We\'re free!','We\'re free!',26124),
(58803,'enUS','You go on ahead. I just need to get Thunder ready and I\'ll meet you at Sunsong Ranch in a jiffy.','',26124),
(58804,'enUS','It will take just a moment longer.','',26124),
(58805,'enUS','Let\'s see who\'s stronger - my Thunder or that rock! My money\'s on Thunder.','',26124),
(58806,'enUS','Never underestimate the worth of a good mushan beast.','',26124),
(58807,'enUS','One word: Incense!','',26124),
(58808,'enUS','Do you have healing incense?','Do you have healing incense?',26124),
(58809,'enUS','Do you have enraging incense?','Do you have enraging incense?',26124),
(58810,'enUS','Don\'t get caught in Big Bessa\'s sights.','',26124),
(58811,'enUS','Avoid or destroy Baldruc\'s Storm Totems.','',26124),
(58812,'enUS','','Winning any battle is just as much about understanding your opponent, as it is knowing how to fight.',26124),
(58813,'enUS','What can I do to help?','What can I do to help?',26124),
(58814,'enUS','%s is dismounted from his gryphon.','',26124),
(58815,'enUS','<Jogu squints at you.>$B$BHey, do I know you?','',26124),
(58816,'enUS','Heeey buddy! Nice to see you again!$B$BBuuuuuuuuuuuuuuurrrrpppp!','',26124),
(58817,'enUS','My friend come to visit Jogu again? What can I do for you today?','',26124),
(58818,'enUS','You are a good friend, $n. Maybe my only friend.','',26124),
(58819,'enUS','Hey $Gbrother:sister;! You come to ask Jogu for wishdom?','',26124),
(58820,'enUS','','Hey there. Back to the market, I see.',26124),
(58821,'enUS','','Well, what\'s it gonna be? I\'ve got a market to run.',26124),
(58822,'enUS','','You\'ve come to the right place! Halfhill Market\'s got everything you need.',26124),
(58823,'enUS','','Hey you, you\'re new in town. Got any good gossip from faraway?',26124),
(58824,'enUS','','You here to buy or sell? Feel free to look around.',26124),
(58825,'enUS','','Hey, $r. Welcome back.',26124),
(58826,'enUS','','Well, what\'s it gonna be, buddy? I\'ve got a market to run.',26124),
(58827,'enUS','','You\'ve come to the right place, buddy! Halfhill Market\'s got everything you need.',26124),
(58828,'enUS','','Hey buddy! You got any good gossip for me?',26124),
(58829,'enUS','','Hey buddy, you here to buy or sell? Feel free to look around.',26124),
(58830,'enUS','','Hey, $n. Halfhill Market welcomes you.',26124),
(58831,'enUS','','Well, what\'s it gonna be, friend? I\'ve got a market to run.',26124),
(58832,'enUS','','You\'ve come to the right place, friend! Halfhill Market\'s got everything you need.',26124),
(58833,'enUS','','Hey friend! You got any good gossip for me?',26124),
(58834,'enUS','','Hey friend, you here to buy or sell? Feel free to look around.',26124),
(58835,'enUS','','Hey, $n. Any friend of mine is always welcome here at Halfhill Market.',26124),
(58836,'enUS','','Well, what\'s it gonna be, my good friend? I\'ve got a market to run.',26124),
(58837,'enUS','','You\'ve come to the right place, my good friend! Halfhill Market\'s got everything you need.',26124),
(58838,'enUS','','Well lookee here, it\'s my good friend $n. You know what I want? Uh-huh, that\'s right. Got any gossip?',26124),
(58839,'enUS','','My good friend $n! Are you here to buy or sell? Feel free to look around.',26124),
(58840,'enUS','','Hey, $n. Welcome, neighbor!',26124),
(58841,'enUS','','Well, what\'s it gonna be, neighbor? I\'ve got a market to run.',26124),
(58842,'enUS','','You\'ve come to the right place, neighbor! Halfhill Market\'s got everything you need.',26124),
(58843,'enUS','','Hey there, neighbor $n. Give me some gossip, already!',26124),
(58844,'enUS','','Howdy, neighbor! Are you here to buy or sell? Feel free to look around.',26124),
(58845,'enUS','','Hey stranger, do I know you?',26124),
(58846,'enUS','','I don\'t recognize your face. You must be new in town.',26124),
(58847,'enUS','','I know just about everyone in these parts. I\'ll let them know there\'s a new face in town.',26124),
(58848,'enUS','','Oh, you\'re not from around here. Are you a citypaw? Tell me, how do you like my dress?',26124),
(58849,'enUS','','Hi there. We\'ve met before, haven\'t we?',26124),
(58850,'enUS','','Oh, what a nice outfit you have there. I hadn\'t noticed before.',26124),
(58851,'enUS','','Folks \'round here have been talking about you. Don\'t worry, I put in a good word now and then.',26124),
(58852,'enUS','','Do you like this color on me?',26124),
(58853,'enUS','','Hi buddy! Fancy seeing you again.',26124),
(58854,'enUS','','Those shoes match your eyes real nice.',26124),
(58855,'enUS','','Folks \'round here have been talking about you, buddy. Don\'t worry, I put in a good word now and then.',26124),
(58856,'enUS','','Hi buddy! Please tell me... do you like my earrings?',26124),
(58857,'enUS','','Hello, friend. Are you getting on all right at your farm?',26124),
(58858,'enUS','','Now that we are friends, I must tell you that your outfit is... hideous.',26124),
(58859,'enUS','','Folks \'round here have been talking about you, friend! They do seem to fancy you quite a lot.',26124),
(58860,'enUS','','Please, as a favor to a friend... tell me the truth about my outfit. Is it... awful?',26124),
(58861,'enUS','','Now that we\'re friends, I have a confession to make. I... I think I quite fancy Farmer Fung.',26124),
(58862,'enUS','','Don\'t you think that Farmer Fung is just... dreamy?',26124),
(58863,'enUS','','$n, my good friend! I hope everything is going well for you and Mr. Yoon at the farm.',26124),
(58864,'enUS','','Now that we are good friends, I must tell you that your outfit is... atrocious.',26124),
(58865,'enUS','','Folks \'round here have been talking about you, $n! You\'re making quite a stir around here.',26124),
(58866,'enUS','','Please, as a favor to a good friend... tell me the truth about my outfit. Is it... horrible?',26124),
(58867,'enUS','','Now that we\'re good friends, I have a confession to make. I... I think I quite fancy Farmer Fung. But then again, Farmer Yoon has nice eyes, don\'t you think?',26124),
(58868,'enUS','','Howdy, neighbor! I hope everything is going well for you and Mr. Yoon at the farm.',26124),
(58869,'enUS','','Now that we are besties, I must tell you that your outfit is... just to die for!',26124),
(58870,'enUS','','Folks \'round here have been talking about you, $n! I\'ve been telling everyone that you\'re my neighbor.',26124),
(58871,'enUS','','Please, as a favor to your best friend... tell me the truth about my outfit. How is it?$B$BOh? Wonderful you say? Why thank you! This is why you\'re my friend for life!',26124),
(58872,'enUS','','Now that we\'re best friends, I have a confession to make. I... I think I quite fancy Farmer Fung. But then again, Farmer Yoon has nice eyes, don\'t you think?$B$BOh, I just can\'t decide!',26124),
(58873,'enUS','Thank you!','Thank you!',26124),
(58874,'enUS','Quick, let\'s get out of here.','Quick, let\'s get out of here.',26124),
(58875,'enUS','Death to the yaungol!','Death to the yaungol!',26124),
(58876,'enUS','Our hero!','Our hero!',26124),
(58877,'enUS','We\'re saved!','We\'re saved!',26124),
(58878,'enUS','Let\'s go to Binan Village.','Let\'s go to Binan Village.',26124),
(58879,'enUS','Good riddance.','Good riddance.',26124),
(58880,'enUS','Hey lookee, it\'s the new $Gguy:gal; in town.','',26124),
(58881,'enUS','You know anything \'bout yaks, rookie? Well I know a lot about \'em.','',26124),
(58882,'enUS','You know who\'s got the biggest vegetables in the Valley? You\'re lookin\' at him!','',26124),
(58883,'enUS','Hey buddy, what\'s happening?','',26124),
(58884,'enUS','Hey buddy, feel free to come admire my yaks anytime.','',26124),
(58885,'enUS','Hey $r, buddy to buddy, I\'ll let you in on a secret. You want big vegetables? You gotta use fertilizer.$B$BAnd you know who\'s got the best fertilizer in the Valley? Me!','',26124),
(58886,'enUS','Hey friend, what\'s happening?','',26124),
(58887,'enUS','Hey friend, feel free to come admire my yaks anytime.','',26124),
(58888,'enUS','Hey friend, here\'s a tip. You want big vegetables? You gotta use fertilizer.$B$BAnd you know who\'s got the best fertilizer in the Valley? Me!','',26124),
(58889,'enUS','My good friend! How are things at the farm?','',26124),
(58890,'enUS','My good friend, how are you today?$B$BListen, I don\'t say this to just anyone, but if you ever need a yak, you let Fung know.','',26124),
(58891,'enUS','My good friend, here\'s a tip. You want big vegetables?$B$BYou gotta tend them. Give them some water, some fertilizer, and some love.','',26124),
(58892,'enUS','Hey neighbor! Things going well at the farm?','',26124),
(58893,'enUS','Hey neighbor, how are you today?$B$BHow\'s Shaggy doing?','',26124),
(58894,'enUS','Hey neighbor! Those vegetables are looking good.','',26124),
(58895,'enUS','','Hey there! Have I seen yer face before?',26124),
(58896,'enUS','','Hey there! Ain\'t seen a face like yours \'round here before.',26124),
(58897,'enUS','','Hey there, citypaw! You heard o\' any good stories that you can share? I love tellin\' stories!',26124),
(58898,'enUS','','Hey, have you heard the story \'bout Old Man Thistle? That\'s a good story if I ever heard \'un.',26124),
(58899,'enUS','','Hey, why\'s your name $n? Isn\'t that a weird name?',26124),
(58900,'enUS','','Folk \'round here are mighty good... if you stick \'round long enough to find out.',26124),
(58901,'enUS','','My papa always told me that fish swim \'n birds fly. Now if I can swim AND fly, what does that make me?',26124),
(58902,'enUS','','Hey buddy! Mighty nice seein\' you again.',26124),
(58903,'enUS','','Hey there, buddy! I loved that story \'bout that boy Arthas. You got any others to share?',26124),
(58904,'enUS','','Hey there, buddy! I loved that story \'bout that orc Thrall. You got any others to share?',26124),
(58905,'enUS','','Old Man Thistle owned a little plot o\' land just o\'er there on that hill.$B$BNow one day he was diggin\' and diggin\', and he dug so far down he didn\'t do but found a whole cave underneath these them hills!$B$BAnd what do you suppose he found in that cave?',26124),
(58906,'enUS','','Whaddaya mean Fish is a weird name, too? It ain\'t weird at all, buddy! I was named after dem fishes in the lake!$B$BNow just now what\'s a \"$n,\" eh? I ask ya that!',26124),
(58907,'enUS','','My papa always told me to make friends \'stead o\' enemies. That\'s why ye\'re my buddy!',26124),
(58908,'enUS','','Hey friend! Mighty nice seein\' you again.',26124),
(58909,'enUS','','Hey there, friend! Tell me again that story \'bout the world tree and the... whatcha callit... the sunderin\'!',26124),
(58910,'enUS','You found...','You found...',26124),
(58911,'enUS','','Old Man Thistle found a cave full o\' TREASURE!!!!$B$BThere was gold \'n diamonds \'n jade \'n statues \'n a whole room full o\' books!$B$BWell he wandered \'round that cave \'n before long a whole day had passed \'n he was gettin\' mighty hungry.$B$BSo he heads back toward the way he came and what happened but he couldn\'t find no way back out agin\'!',26124),
(58912,'enUS','A Lost Hen! Bring her back to a chicken coop.','A Lost Hen! Bring her back to a chicken coop.',26124),
(58913,'enUS','An Amorous Rooster! Dip him in the water to cool his passions.','An Amorous Rooster! Dip him in the water to cool his passions.',26124),
(58914,'enUS','A Wild Prairie Chicken! Kick him out of here!','A Wild Prairie Chicken! Kick him out of here!',26124),
(58915,'enUS','A Marmot Disguised in Chicken Feathers! Expose him for the sham he really is!','A Marmot Disguised in Chicken Feathers! Expose him for the sham he really is!',26124),
(58916,'enUS','Old Hillpaw\'s prize-winning chicken, Mother Clucks!','Old Hillpaw\'s prize-winning chicken, Mother Clucks!',26124),
(58917,'enUS','','Now that we\'re friends, you can call me Fish.$B$BHa ha! I\'m so funny!$B$BI\'m jus\' kidding... everyone calls me Fish! That\'s cuz everyone\'s my friend!',26124),
(58918,'enUS','Old Hillpaw\'s prize-winning chicken, Madam Specklybottom!','Old Hillpaw\'s prize-winning chicken, Madam Specklybottom!',26124),
(58919,'enUS','Old Hillpaw\'s prize-winning chicken, Thunderpeck!','Old Hillpaw\'s prize-winning chicken, Thunderpeck!',26124),
(58920,'enUS','Old Hillpaw\'s prize-winning chicken, Mantidsbane!','Old Hillpaw\'s prize-winning chicken, Mantidsbane!',26124),
(58921,'enUS','','My papa always told me that friends are worth more than sweet turnips. That\'s why yer my friend, $n!',26124),
(58922,'enUS','Old Hillpaw\'s prize-winning chicken, Rumblefeather!','Old Hillpaw\'s prize-winning chicken, Rumblefeather!',26124),
(58923,'enUS','Old Hillpaw\'s prize-winning chicken, Egga!','Old Hillpaw\'s prize-winning chicken, Egga!',26124),
(58924,'enUS','','Howdy, $n!',26124),
(58925,'enUS','Old Hillpaw\'s prize-winning chicken, Stumbleflutter!','Old Hillpaw\'s prize-winning chicken, Stumbleflutter!',26124),
(58926,'enUS','Old Hillpaw\'s prize-winning chicken, Buck-Bucka Betty!','Old Hillpaw\'s prize-winning chicken, Buck-Bucka Betty!',26124),
(58927,'enUS','','Hey there, my good friend! Tell me again that story \'bout that scary dragon, Deathwing!',26124),
(58928,'enUS','','So Old Man Thistle\'s stuck down the cave, so what does he do but whistle fer his trusty mushan, Bobo!$B$BAnd right fore long, he hears a boomin\' noise, and Bobo busts a hole right in that cave!$B$BThat mushan done hear his master and come fer him!$B$BAnd then, what happens but the whole cave starts a shakin\' and the ceiling starts crashing down.$B$BSo Old Man Thistle jumps on Bobo\'s back and you know what happened\' then?',26124),
(58929,'enUS','','Yeh know my good friend, I seen a lot o\' funny names in my time. Fish really ain\'t that strange. No, it\'s downright normal!',26124),
(58930,'enUS','','My papa always told me that good friends are worth more than a chipper carrot. That\'s why yer my good friend, $n!',26124),
(58931,'enUS','','Howdy, neighbor! Whatcha doin\' today?',26124),
(58932,'enUS','','Hey there, neighbor! I love stories so much, I just wanna hear \'em all!$B$BBut ya know, I think we\'ve made some good stories together too, dontcha think?',26124),
(58933,'enUS','','So the cave\'s a crashing down, and Old Man Thistle and Bobo run as fast as they can! They twist and turn through the caves, til they burst outta the ground right up that hill!$B$BAnd what happened then but the cave closed up right behind \'em, like it got swallowed by the earth.$B$BOld Man Thistle\'s shaking, but first thing he does when he gets home is make a map to that cave full o\' treasure. Cuz maybe it\'s still there, true?$B$BGood thing he did, cuz the next day, he couldn\'t remember as well, and the day after that he remembered even less, till he plumb forgot \'bout that cave altogether.',26124),
(58934,'enUS','','Hey neighbor, what\'re we talkin\' bout anyway? Ain\'t nothing in a name!$B$BLike my papa always said, ye\'d still eat a pink melon if it were called an onion, right?',26124),
(58935,'enUS','','My papa always told me that neighbors are worth more than earth. Now that\'s sayin\' something!$B$BThat\'s why yer my neighbor, $n!',26124),
(58936,'enUS','','I take care o\' the pigs \'round here.',26124),
(58937,'enUS','','Hey buddy! The pigs are doin\' jus\' fine today!',26124),
(58938,'enUS','','Howdy, friend! You gone down and seen my pigs yet?',26124),
(58939,'enUS','','Howdy, my good friend! Now why my mama and papa didn\'t name me Pig, I jus\' don\'t know.',26124),
(58940,'enUS','','Hey neighbor! How\'re those pigs doin\' at yer farm? I bet they\'re mighty happy!',26124),
(58941,'enUS','You new here?','',26124),
(58942,'enUS','Hey, Chee Chee real busy. You got some-ting you want?','',26124),
(58943,'enUS','Chee Chee\'s sheep sheep are so scared... bad monkeys on hill! Bad monkey!','',26124),
(58944,'enUS','Yo, I know you before. You help me, yes?','',26124),
(58945,'enUS','Chee Chee got big problem. Big, big problems.','',26124),
(58946,'enUS','Chee Chee work hard for farm. Now bad monkeys come take away!','',26124),
(58947,'enUS','Hey. You are Chee Chee\'s buddy, yes?','',26124),
(58948,'enUS','Chee Chee got big problem. Big, big problems. Buddy help Chee Chee?','',26124),
(58949,'enUS','Chee Chee work hard for farm. Buddy understand, right?','',26124),
(58950,'enUS','Hey friend. I got problems, but no need to be your problems, too.','',26124),
(58951,'enUS','Hey friend, how is things going on your farm?','',26124),
(58952,'enUS','Chee Chee is only hozen with own farm!$B$B<Chee Chee thumps his chest proudly.>$B$BYou, friend, come visit me at my farm sometime, okay?','',26124),
(58953,'enUS','My good friend! You drink with Chee Chee sometime, yes?','',26124),
(58954,'enUS','Good friend, is things going good for you?','',26124),
(58955,'enUS','Chee Chee raise only sheep in the fields!$B$BAnyone want sheep, they come to Chee Chee.','',26124),
(58956,'enUS','Hey neighbor! You like the sheep?','',26124),
(58957,'enUS','Neighbor, because of you, my problems is less somewhat.','',26124),
(58958,'enUS','I give only nice sheep for you, neighbor! What do you think?','',26124),
(58959,'enUS','','Oh! Hi! Um... I should probably... go...$B$B<Ella blushes as her voice lowers to a whisper.>',26124),
(58960,'enUS','','Do you like... turnips?$B$B<Ella turns pink and shakes her head.>',26124),
(58961,'enUS','','Do you like kitties? I love them!$B$B<Ella looks surprised at her sudden outburst and smiles shyly.>',26124),
(58962,'enUS','','Hey there, $n. How are you today?',26124),
(58963,'enUS','','I grow turnips at my family farm. Oh... I don\'t know if you wanted to know that...',26124),
(58964,'enUS','','I don\'t have that many cats, right? I mean, it\'s quite reasonable when you think about it.',26124),
(58965,'enUS','','Hey there, friend! Isn\'t it a lovely day?',26124),
(58966,'enUS','','Did you know that turnips make quite a tasty brew?',26124),
(58967,'enUS','','The cats keep me company. It\'s been quite lonesome on the farm since my parents passed...$B$BOh no, I didn\'t mean to tell you so much.',26124),
(58968,'enUS','','Hello, good friend. Oh, is it okay if I call you my good friend?',26124),
(58969,'enUS','','I\'ve been experimenting with all sorts of brews in my spare time.$B$BWith the Stormstout brewery right across the way, I can\'t help but get inspired sometimes.$B$BOh, but these aren\'t anywhere as good as what they make over there.',26124),
(58970,'enUS','','How many cats do I have?$B$BOh, ummm... I think I may have lost track...',26124),
(58971,'enUS','','Howdy, neighbor! The turnips are looking mighty fine this morning.',26124),
(58972,'enUS','','So I\'ve been sharing some of my brews around town, and everyone is raving! I can hardly believe it!',26124),
(58973,'enUS','','How is Luna doing? She\'s such a sweet cat!',26124),
(58974,'enUS','The convoy to Kota Basecamp is leaving now! Gather around!','',26124),
(58975,'enUS','Got trouble in the fields. Whether it\'s virmen or hozen, I tell ya, it ain\'t good.','',26124),
(58976,'enUS','Yeah, I am the head of the Tiller\'s Union. Why do you ask?','',26124),
(58977,'enUS','Sure the fields here are prosperous, but that\'s on account of hard, back-breaking work!','',26124),
(58978,'enUS','Hey buddy, you got any experience dealing with hozen or virmen?','',26124),
(58979,'enUS','Buddy, did you know that every farmer worth his dirt is a member of the Tiller\'s Union?','',26124),
(58980,'enUS','Hey, if it isn\'t my buddy $n! I\'ve just come from a long day in the fields.','',26124),
(58981,'enUS','Hey friend, you got any experience dealing with hozen or virmen?','',26124),
(58982,'enUS','Hey friend, how\'s the soil looking today?','',26124),
(58983,'enUS','My friend, $n! Let us share a drink together.','',26124),
(58984,'enUS','My good friend, you must know a thing or two about exterminating virmen.','',26124),
(58985,'enUS','You know, good friends always share their farming secrets. Now tell me, how do you get your vegetables looking like that?','',26124),
(58986,'enUS','A long day in the fields makes a man thirsty, you know what I mean, good friend?','',26124),
(58987,'enUS','Hey neighbor, how is that mushan beast working out for you? She\'s quite a beauty, ain\'t she?','',26124),
(58988,'enUS','Now that we\'re neighbors, you have to tell me your farming secrets. Do you use fertilizer? Growth spray? Weedkiller? Tell me, already!','',26124),
(58989,'enUS','Howdy, neighbor. Would you like a cold brew?','',26124),
(58990,'enUS','Thank you, traveler. I think I can make it now.','',26124),
(58991,'enUS','I ain\'t got time for no strangers. Now please leave me be.','',26124),
(58992,'enUS','Can\'t you see I\'m busy? Got things I\'m working at, stranger.','',26124),
(58993,'enUS','YOU HAVE WON THE SCENARIO. HOORAY!','',26124),
(58994,'enUS','Bah! Leave an old man be!','',26124),
(58995,'enUS','You have my gratitude. I should return back to training now.','',26124),
(58996,'enUS','Humph. I\'m busy, can\'t you see?','',26124),
(58997,'enUS','Do ye pester everyone this much? Sheesh.','',26124),
(58998,'enUS','Pah! I know I seen you around, but that don\'t make us friends. Go away!','',26124),
(58999,'enUS','A simple flesh wound won\'t keep me from the battle.','',26124),
(59000,'enUS','Hey buddy, I\'m busy here. Can\'t ye come back later?','',26124),
(59001,'enUS','Buddy, ye sure got a big mouth. Does it ever stop yappin\'?','',26124),
(59002,'enUS','Buddy, ye know... sometimes it\'s nice to see you around.','',26124),
(59003,'enUS','Hey friend, I\'m a little busy here. Ye got something ya need?','',26124),
(59004,'enUS','Friend, you sure do run your mouth when you get a chance. But it\'s kinda nice to hear somethin\' other than silence now and again.','',26124),
(59005,'enUS','I got three sick chickens and another two hens not layin\'. I got too many problems to listen to yours, citypaw.','',26124),
(59006,'enUS','Hey buddy. I got two chickens gone missin\' last night. Bet it was them hozen that\'re behind it.','',26124),
(59007,'enUS','Howdy, friend. You ever tried a fresh egg from one o\' my chickens? Dee-licious, I tell ya.','',26124),
(59008,'enUS','Hey friend, thanks for visiting today.','',26124),
(59009,'enUS','Hey, it\'s my good friend $n! Anything I can do fer ya?','',26124),
(59010,'enUS','My good friend, you got any news for me today?','',26124),
(59011,'enUS','Ye know, $n, I gotta admit I look forward to your visits now and again.','',26124),
(59012,'enUS','Hey $n, I been thinkin\' that your farm needs some chickens. What do you think?','',26124),
(59013,'enUS','Howdy, neighbor. Nice day today.','',26124),
(59014,'enUS','Hey, neighbor! Fields are lookin\' like a shiny new copper today.','',26124),
(59015,'enUS','Howdy, neighbor! Good to see ya! You come visit me any time, you hear?','',26124),
(59016,'enUS','Well, $n? How are those chickens doing?$B$BMake sure to look around for their eggs. Those darned things hide them in the weirdest places!','',26124),
(59017,'enUS','','Quiet, stranger. I need complete focus for the task at hand.',26124),
(59018,'enUS','','I have no quarrel with you, stranger.',26124),
(59019,'enUS','','Only in silence will we hear the trees speaking.',26124),
(59020,'enUS','','Quiet, $r. Please do not break my concentration.',26124),
(59021,'enUS','','I have seen you in these parts before. I can see that you are a $c, from the look of you.',26124),
(59022,'enUS','','One gains little wisdom from speaking. One gains much wisdom from listening.',26124),
(59023,'enUS','','Hey buddy, you are making enough noise to scare off a pack of mushan beasts.',26124),
(59024,'enUS','','Do not tell me what it is like to be a $c. Show me.',26124),
(59025,'enUS','','I am studying the hozen\'s movements. When I find their weakness, I will strike.',26124),
(59026,'enUS','','My friend, you are making enough noise to scare off a pack of mushan beasts.',26124),
(59027,'enUS','','My friend, one of these days we should see who is stronger in battle - you, or me.',26124),
(59028,'enUS','','A wise man does not rush into war. A wise man wins a war.',26124),
(59029,'enUS','','My good friend, you are making enough noise to scare off a pack of mushan beasts.',26124),
(59030,'enUS','','My good friend, one of these days we should see who is stronger in battle - you, or me.',26124),
(59031,'enUS','','In my home town, the greatest gift one could give to a good friend was a tree.$B$BDo you know why?$B$BA tree represents peace, growth, and life. It is a blessing of friendship.',26124),
(59032,'enUS','','Neighbor, you move quietly today.',26124),
(59033,'enUS','','Neighbor, I would gladly fight alongside you any day.',26124),
(59034,'enUS','','Do you like your tree? I picked the sapling myself.',26124),
(59035,'enUS','','Hey friend, you know the secret to a good market? Distribution. You need a way to move your goods to the people who want \'em.',26124),
(59036,'enUS','','You know what I been thinking, my good friend? You need a way to keep up with all your friends at home.$B$BI know a carpenter who can come by an install your own mailbox. How\'s that for an idea?',26124),
(59037,'enUS','','How\'s that mailbox workin\' for ya? Good idea, right?',26124),
(59038,'enUS','','Hey friend, don\'t you think that Farmer Yoon\'s house is looking mighty empty?',26124),
(59039,'enUS','','I know a thing or two about decorating, my good friend. I know just what Farmer Yoon needs for his house!',26124),
(59040,'enUS','','Hey neighbor! How do you like the new furnishings in Farmer Yoon\'s house? Yes, I picked them out myself!',26124),
(59041,'enUS','Chee Chee love to eat Valley Stir Fry. You find any, you bring to me!','',26124),
(59042,'enUS','','Any assistance getting the wounded back on their feet would be appreciated.',26124),
(59043,'enUS','Chee Chee like to look at sky. So pretty... so blue...','',26124),
(59044,'enUS','','Oh, gifts? I hope you\'re not thinking of getting me anything!',26124),
(59045,'enUS','','Well you know me... I like cats!',26124),
(59046,'enUS','','Now that you mention it... my mother used to make the best Shrimp Dumplings.$B$BSigh... I miss her...',26124),
(59047,'enUS','Well you know the only thing that I admire as much as my own looks is a rare white flower that grows around these parts.$B$BIt\'s terribly hard to find, though.','',26124),
(59048,'enUS','You ever tried Wildfowl Roast?$B$BMmm! What would I give for a taste of that right now!','',26124),
(59049,'enUS','','Well I jus\' about like everythin\', but I do like animals the best!',26124),
(59050,'enUS','','Being resourceful can often sway a battle in your favor.$b$bI\'ve put together this remedy using plants from the forest around us. Hopefully it will be enough. We need every available fighter in the field.',26124),
(59051,'enUS','','You know, I\'ve always like the color of jade. So green, just like the forest.',26124),
(59052,'enUS','','What a silly question! I\'ll give you a hint. My favorite food has my name in it! Maybe more than once!',26124),
(59053,'enUS','','Oh you shouldn\'t! Oh, but I do love gifts, so maybe you should.',26124),
(59054,'enUS','','I like anything pretty or shiny.',26124),
(59055,'enUS','','Oh you know me. I\'m a humble girl, so I\'d only ask for rubies.$B$BWhat? It\'s not like I\'m asking for diamonds!',26124),
(59056,'enUS','','Well, recently I\'ve had quite the craving for Fire Spirit Salmon.',26124),
(59057,'enUS','Well I won\'t lie to you, $n. I\'m one of the most powerful men in the Valley. Most people send me gifts of great value.','',26124),
(59058,'enUS','I\'ll tell you one thing, $n. I like jade, but it\'s not my favorite. Everyone gives it to me, all the time!','',26124),
(59059,'enUS','Now that you mention it, I\'ve been craving Charbroiled Tiger Steak for a while! We don\'t get many tigers down in the valley, so the dish is hard to find.','',26124),
(59060,'enUS','No, an old man like me doesn\'t need anything. But my son... now he loved collecting blue feathers...','',26124),
(59061,'enUS','When my son found a blue feather, he used to say that it was a kiss from his mother, up in the sky.$B$B<Old Hillpaw pauses, too choked up to continue.>','',26124),
(59062,'enUS','My wife used to make a mean dish of braised turtle. The taste of that dish sure would bring back memories.','',26124),
(59063,'enUS','','I like things that come from nature.',26124),
(59064,'enUS','','A girl in my line of work gets hungry, you know? I wish I had something delicious to eat.',26124),
(59065,'enUS','','Flowers are nice, but they aren\'t  my favorite.',26124),
(59066,'enUS','','I\'m scared of birds! Their feathers can be quite pretty, but they aren\'t my favorite.',26124),
(59067,'enUS','','Have you ever tried Eternal Blossom Fish? It\'s my favorite food.',26124),
(59068,'enUS','','This is just lovely, thank you!',26124),
(59069,'enUS','See if the new recruits are up to a challenge. They could use a lesson in advanced combat.','',26124),
(59070,'enUS','','Oh, why... thank you... you shouldn\'t have...!',26124),
(59071,'enUS','Stir fry! Thanks boss!','',26124),
(59072,'enUS','Ooh, Chee Chee is hungry. Thanks!','',26124),
(59073,'enUS','Ooh, pretty pretty! So blue... so soft... thanks!','',26124),
(59074,'enUS','Very nice, yes yes... a good gift for Chee Chee. Thank you!','',26124),
(59075,'enUS','Hey, this is a real nice gift. Thanks, $n!','',26124),
(59076,'enUS','You must be my secret admirer! Well, not so secret anymore. Thanks!','',26124),
(59077,'enUS','You found a Marsh Lily? These are my favorite. Thanks!','',26124),
(59078,'enUS','Is this roast for me? Wow, thanks!','',26124),
(59079,'enUS','Nice timing. I was just getting hungry.','',26124),
(59080,'enUS','','Did you make this Twin Fish Platter yourself?',26124),
(59081,'enUS','','Oh my, this Twin Fish Platter smells delicious. Thank you!',26124),
(59082,'enUS','','Let\'s see what the Hozen have in store for us in combat.',26124),
(59083,'enUS','','Oh yes, this is my favorite food - fish!',26124),
(59084,'enUS','','This is a very pretty cat, $n. Thanks fer givin\' it to me.',26124),
(59085,'enUS','','Oh wow, yer givin\' that to me? I don\'t know how to thank ya!',26124),
(59086,'enUS','','You givin\' me a gift? Aw shucks, you shouldn\'t have!',26124),
(59087,'enUS','What\'sh this? Oh, whatever it ish, it\'sh nice... hic!','',26124),
(59088,'enUS','','Why $n! Did you bring me some Swirling Mist Soup? Did you know that I love this stuff?',26124),
(59089,'enUS','','Oh, what a breathtaking flower. You know these are supposed to be lucky?',26124),
(59090,'enUS','','Oh my, you got me something? Why how can I ever thank you?',26124),
(59091,'enUS','','Oh look at you, giving little old Gina such a lovely gift. Thank you!',26124),
(59092,'enUS','','This Fire Spirit Salmon looks delicious. I do hope you made it yourself.',26124),
(59093,'enUS','','Oooh, I can\'t wait to try this Fire Spirit Salmon.',26124),
(59094,'enUS','','Why you sure know how to impress a lady! Ain\'t no diamond, but I love it anyway!',26124),
(59095,'enUS','','This ruby will look wonderful with this dress, don\'t you think?',26124),
(59096,'enUS','','How lovely of you to think of me.',26124),
(59097,'enUS','','You are such a nice $Gguy:gal; $n. Thank you for this lovely present.',26124),
(59098,'enUS','Oh yes, this ruby looks quite valuable. Thanks, $n!','',26124),
(59099,'enUS','It\'s been too long since I last tasted Charbroiled Tiger Steak.','',26124),
(59100,'enUS','I could eat twenty plates of Charbroiled Tiger Steak and still be looking for more. Thanks, $n.','',26124),
(59101,'enUS','Well, isn\'t this the nicest gift I\'ve gotten today!','',26124),
(59102,'enUS','For me? That\'s mighty nice of you, $n.','',26124),
(59103,'enUS','This feather... brings back so many memories. Thank you, $n.','',26124),
(59104,'enUS','It\'s just like the way my wife used to make it. Thanks!','',26124),
(59105,'enUS','Just what an hungry old man needs. Thanks.','',26124),
(59106,'enUS','Fer me? Thanks.','',26124),
(59107,'enUS','That\'s... nice o\' ya. Thanks.','',26124),
(59108,'enUS','','Thanks for the apple, $r.',26124),
(59109,'enUS','','Hey, just what I needed. Thanks a lot.',26124),
(59110,'enUS','','Been a while since I had a taste of this dish. This\'ll hit the spot.',26124),
(59111,'enUS','','Feels good to look forward to a hot meal.',26124),
(59112,'enUS','','Huh. I suppose now I have to say thank you.',26124),
(59113,'enUS','','Focus on the fires. No - wait - get the saurok! Just ... do something!',26124),
(59114,'enUS','','I\'m not leaving until those brewkegs finish their work.',26124),
(59115,'enUS','','Stupid lizards.',26124),
(59116,'enUS','','Maybe this will help...',26124),
(59117,'enUS','','Stay on your toes!',26124),
(59118,'enUS','','I\'ve got you...',26124),
(59119,'enUS','','Don\'t you die on me!',26124),
(59120,'enUS','Together we can reclaim the temple and restore hope for the people here. It\'s my honor to accompany you in this task.','',26124),
(59121,'enUS','ALL THE 7TH FLEET SHIPS BLOW UP. KABOOOM! THE GUNSHIP COMES IN OVER THE HARBOR.','',26124),
(59122,'enUS','We cannot escape!','',26124),
(59123,'enUS','Slurp. YUM!','',26124),
(59124,'enUS','Cooking all of the things.','',26124),
(59125,'enUS','Hmm... maybe a pinch of pandaren?','',26124),
(59127,'enUS','This stew needs salt. And people meatballs!','',26124),
(59129,'enUS','Bork, bork, bork!','',26124),
(59130,'enUS','Furdy furdy fur.','',26124),
(59131,'enUS','Too much roots! Not enough meats!','',26124),
(59132,'enUS','Kill that wascally wirmen and bring it for the stew!','',26124),
(59133,'enUS','Hmm, did you hear something lads?','',26124),
(59134,'enUS','Mmm! Some $r for the stew!','',26124),
(59135,'enUS','What? No, no! Stop!  Obey your master!','',26124),
(59136,'enUS','Arrggghhhhh!','',26124),
(59137,'enUS','%s obeys its master and attacks.','',26124),
(59138,'enUS','Chef, could you grill this plainshawk leg for me?','Chef, could you grill this plainshawk leg for me?',26124),
(59139,'enUS','Chef... if I brought you a plainshawk leg, could you grill it for me?','Chef... if I brought you a plainshawk leg, could you grill it for me?',26124),
(59140,'enUS','Sure thing, $n! Enjoy!','',26124),
(59141,'enUS','Certainly. If you brought me some meat - which you have not - then I would be able to grill it for you.','',26124),
(59142,'enUS','I\'ve got all this fruit here. Could you brew up some hooch for me?','I\'ve got all this fruit here. Could you brew up some hooch for me?',26124),
(59143,'enUS','What ingredients do you need to make Apple-Berry hooch?','What ingredients do you need to make Apple-Berry hooch?',26124),
(59144,'enUS','Any time, neighbor. Any time.','',26124),
(59145,'enUS','We\'ll need at least 8 apples. And a few handfuls of craneberries - 50 should do it.','',26124),
(59146,'enUS','Brew here!','',26124),
(59147,'enUS','','Meet me up in the cave if you would, friend.',26124),
(59148,'enUS','Hey Jogu, what\'s the word on tomorrow\'s crops?','Hey Jogu, what\'s the word on tomorrow\'s crops?',26124),
(59149,'enUS','Ughhhh... my head is hazy... try again later.','',26124),
(59150,'enUS','Oooh... ooooh! My shenses are tingling! I see... huge Green Cabbages in your future.','',26124),
(59151,'enUS','You ever heard of a juishycrunch carrot? They\'ll never be juisher than tomorrow.','',26124),
(59152,'enUS','Have I ever told you that I hate Scallions? Hate \'em!$B$B<Jogu lets out a loud belch.>$B$BUnfortunately for me, they\'re going to be in high season tomorrow.','',26124),
(59153,'enUS','Pumpkins! It\'sh gonna be huge, gigantic pumpkins!','',26124),
(59154,'enUS','Shpring for a leek, and you might get two.','',26124),
(59155,'enUS','I\'m seeing Pink Turnipsh in your future.','',26124),
(59156,'enUS','Fields of white turnips. Raw and shpicy!','',26124),
(59157,'enUS','Which berries should you plant? Witchberries, of course!','',26124),
(59158,'enUS','Jade Squash grow the color of milky jade. Conditionsh will be perfect tomorrow for growing thish vegetable... I think.','',26124),
(59159,'enUS','Striped melons are quite juishy this time of year! Put some sheeds in the ground, and you will reap the harvest on the morrow.','',26124),
(59160,'enUS','Looking for meat? I\'ve got plenty right here.$b$bOn my grill, I mean.','',26124),
(59161,'enUS','','Keep those creatures at bay while I meditate. We\'ll soon have the answers we seek.',26124),
(59162,'enUS','<The crane does not speak, but his words fill your mind.>$B$BGo... while you can...$B$BAll is... lost.','',26124),
(59163,'enUS','<Reach out to touch Chi-Ji.>','<Reach out to touch Chi-Ji.>',26124),
(59166,'enUS','You pull the bell on the shrine. Ask it a question or make a wish!','',26124),
(59167,'enUS','Chee Chee is a hozen sheep-herder who works on the terrace to the west.','',26124),
(59168,'enUS','You and Ella are acquaintances.','You and Ella are acquaintances.',26124),
(59169,'enUS','Somehow, you and Farmer Fung have become acquaintances.','',26124),
(59170,'enUS','You are acquaintances with Fish.','',26124),
(59171,'enUS','You and Gina are acquaintances.','',26124),
(59172,'enUS','You and Haohan are acquaintances.','',26124),
(59173,'enUS','You and Old Hillpaw are acquaintances.','',26124),
(59174,'enUS','You and Sho are acquaintances.','',26124),
(59175,'enUS','You and Tina are acquaintances.','',26124),
(59176,'enUS','You and Jogu the Drunk are acquaintances.','',26124),
(59177,'enUS','How is my relationship with Chee Chee?','How is my relationship with Chee Chee?',26124),
(59178,'enUS','How is my relationship with Ella?','How is my relationship with Ella?',26124),
(59179,'enUS','How is my relationship with Fish Fellreed?','How is my relationship with Fish Fellreed?',26124),
(59180,'enUS','How is my relationship with Farmer Fung?','How is my relationship with Farmer Fung?',26124),
(59181,'enUS','How is my relationship with Gina Mudclaw?','How is my relationship with Gina Mudclaw?',26124),
(59182,'enUS','How is my relationship with Jogu the Drunk?','How is my relationship with Jogu the Drunk?',26124),
(59183,'enUS','How is my relationship with Haohan Mudclaw?','How is my relationship with Haohan Mudclaw?',26124),
(59184,'enUS','How is my relationship with Old Hillpaw?','How is my relationship with Old Hillpaw?',26124),
(59185,'enUS','How is my relationship with Sho?','How is my relationship with Sho?',26124),
(59186,'enUS','How is my relationship with Tina Mudclaw?','How is my relationship with Tina Mudclaw?',26124),
(59187,'enUS','When man asks favor of a fish...','',26124),
(59188,'enUS','\'Tis hard to decipher his true wish...','',26124),
(59189,'enUS','He often seeks a lordly dish...','',26124),
(59190,'enUS','To serve upon his table.','',26124),
(59192,'enUS','Hey Chee Chee, would you like to be my farm hand?','Hey Chee Chee, would you like to be my farm hand?',26124),
(59193,'enUS','Hi Ella, would you like to join me and Farmer Yoon at his farm?','Hi Ella, would you like to join me and Farmer Yoon at his farm?',26124),
(59194,'enUS','Hey Fish, how\'d you like to be my partner at the farm?','Hey Fish, how\'d you like to be my partner at the farm?',26124),
(59195,'enUS','Howdy, Farmer Fung. Farmer Yoon and I really need you at our farm.','Howdy, Farmer Fung. Farmer Yoon and I really need you at our farm.',26124),
(59196,'enUS','Gina, how\'d you like to help us run the farm?','Gina, how\'d you like to help us run the farm?',26124),
(59197,'enUS','Mr. Mudclaw, would you lend us a hand at Sunsong Ranch?','Mr. Mudclaw, would you lend us a hand at Sunsong Ranch?',26124),
(59198,'enUS','Hey Jogu, how\'d you like to move into the pond at Sunsong Ranch?','Hey Jogu, how\'d you like to move into the pond at Sunsong Ranch?',26124),
(59199,'enUS','Howdy Old Hillpaw. How\'d you like to keep me company at my farm?','Howdy Old Hillpaw. How\'d you like to keep me company at my farm?',26124),
(59200,'enUS','Hey Sho, take a break and come watch my farm for a while.','Hey Sho, take a break and come watch my farm for a while.',26124),
(59201,'enUS','Hey Tina, I hear Farmer Yoon needs some help at his farm. Would you... ?','Hey Tina, I hear Farmer Yoon needs some help at his farm. Would you... ?',26124),
(59202,'enUS','Okay, boss! Chee Chee got stuff to do, then he be there soon.','',26124),
(59203,'enUS','','Sure, I suppose I could help out for a bit! I\'ll meet you there in a bit.',26124),
(59204,'enUS','','My papa always did say to help out a neighbor in need! I\'ve just gotta take care of some stuff, then I\'ll be there in a jiffy!',26124),
(59205,'enUS','I was wonderin\' when you would ask. Sure thing. Let me take care of some things and I\'ll be right on over.','',26124),
(59206,'enUS','','Well all right, I s\'pose I could hop on over to the farm now and again. I\'m only doing this for you, y\'hear? And well... I s\'pose I have taken quite a shine to Mr. Yoon...',26124),
(59207,'enUS','Really? That whole pond, just for me? I\'ll be right there!','',26124),
(59208,'enUS','I suppose I could leave things to Mung-Mung for a while and take a gander at Yoon\'s. He does have the best soil in the entire valley! Let me just get my things in order, first.','',26124),
(59209,'enUS','Well I s\'pose the chickens won\'t mind if I visit fer a bit. I\'ll meet ya there later.','',26124),
(59210,'enUS','','Sunsong Ranch needs my help? Let me gather my equipment, and I\'ll meet you there.',26124),
(59211,'enUS','','It\'s about time you asked! I was wondering when Farmer Yoon would ever notice me. You go ahead, and I\'ll be there soon.',26124),
(59212,'enUS','Hey boss, me been thinkin\'. You been real good to Chee Chee, so I wanted to give you a sheep for your farm. It should be waiting already. You take good care of Chee Chee\'s sheeps, okay?','',26124),
(59213,'enUS','','Hey, wait just a minute... I... well... you\'ve been such a good friend and... I want to give you my favorite kitty, Luna! I don\'t want you to be lonely at your farm and...<sob>... just take good care of her, okay? I\'ll bring her by later.',26124),
(59214,'enUS','','Well now that you and me are neighbors, I can tell you the truth. It\'s just downright wrong not ta have a proper pig or two on your farm! I\'ll bring some by when yer not lookin\' and then blammo! You\'ll have pigs.',26124),
(59215,'enUS','Now that we\'re neighbors, I\'ve decided to give you the best gift a neighbor can just about give to anybody! I\'m going to give you one of my prized yaks! I\'ll swing on by later and leave \'er in your pen.','',26124),
(59216,'enUS','','You and me, we\'re proper neighbors now, not just in the geographical sense. You done so much for me, I think it\'s time I helped you out a bit. I called in a few favors and had them install your own postbox right on your farm. Now you can keep in touch with all your friends!',26124),
(59217,'enUS','I wasn\'t too sure \'bout you when you first came to the valley, but now I can proudly call you my neighbor. As a token of my friendship, I\'d like to give ye a big something for yer farm. She should be there already. Name\'s Miss Fifi, and she likes to eat turnips!','',26124),
(59218,'enUS','You know, you\'ve been a real nice friend to me for a while now. Now that we\'re neighbors, I\'m going to give you some of my chickens. Ain\'t too much, but they should liven up yer farm a bit. I\'ll send \'em over.','',26124),
(59219,'enUS','','Wait a minute. I\'ve been thinking... you\'ve done so much for me, it\'s about time I gave you a little something in return. Where I\'m from, we grow beautiful orange trees. I planted one on your farm. From the way things grow around here, I wouldn\'t be surprised if it had already bloomed by the time you got back to your farm.',26124),
(59220,'enUS','','Oh $n, as your best friend, I\'d really like to give you something. I thought your farm could use a little sprucing up, so I had some folks install some new furniture in your house. I hope you like it!',26124),
(59221,'enUS','Can I hire someone to help me on my farm?','Can I hire someone to help me on my farm?',26124),
(59223,'enUS','Only the best of friends will do.','',26124),
(59224,'enUS','Hey boss, your sheeps is lookin\' pretty good.','',26124),
(59225,'enUS','','Oh... why, hello $n! Your farm is looking very pretty today.',26124),
(59226,'enUS','','Howdy, neighbor! Your pigs be lookin\' mighty fine!',26124),
(59227,'enUS','I have to say, $n, your garden looks great! Of course, I have been weeding all day...','',26124),
(59228,'enUS','','Farmer Yoon is just a dear! I keep telling him what to do, and he goes on and does it!',26124),
(59229,'enUS','This pond sure is nice, neighbor.','',26124),
(59230,'enUS','Not bad, not bad! If I do say so myself, your farm is running smoothly. Maybe one day you\'ll be as successful as Haohan Mudclaw!','',26124),
(59231,'enUS','Howdy, neighbor. Your chickens seem very happy.','',26124),
(59232,'enUS','','All\'s clear, $n. Don\'t let down your guard, though. Those virmen can tunnel faster than you can say \"Virmen a hole!\"',26124),
(59233,'enUS','','Oh, Farmer Yoon is such a gentleman! He even said he liked the new furniture!',26124),
(59234,'enUS','','Welcome Traveler! Help yourself to some ale.',26124),
(59235,'enUS','','We don\'t see very many new faces here anymore.',26124),
(59236,'enUS','','There aren\'t many willing to brave the mountain pass anymore, friend. Nowadays, some would say you\'d have to be crazy to try.',26124),
(59237,'enUS','','Come in out of the cold friend and make yourself comfortable!',26124),
(59238,'enUS','','Oh! A new customer! You are most welcome, friend!',26124),
(59239,'enUS','Hey neighbor, since you\'ve been such a good friend to me, from now on I\'m going to give you crop predictions for free. Absolutely no charge! Just come drink with me now and again, eh?','',26124),
(59240,'enUS','Alchemy is a bit like magic, don\'t you think? With the change of a single ingredient a simple drought can either heal you, or kill you.','',26124),
(59241,'enUS','My shop is filled with many wonderous and hard to come by things. It would be wise to look, but not to touch.','',26124),
(59242,'enUS','Supplies are limited, but I accept only the best from the traders.','',26124),
(59243,'enUS','Who dares disturb my eternal slumber?!','Who dares disturb my eternal slumber?!',26124),
(59244,'enUS','The mountain is angry, stranger. Not good for travel now.','',26124),
(59245,'enUS','Very lucky day to travel friend! East wind brings much good fortune.','',26124),
(59246,'enUS','I am not Zan - I am Chen Stormstout!','',26124),
(59247,'enUS','Tell me, what has happened here?','',26124),
(59248,'enUS','Where are the other Stormstouts? Why are hozen all over the brewery?','',26124),
(59249,'enUS','Auntie Stormstout...why is the brewery abandoned?','',26124),
(59250,'enUS','You take down Ook-Ook...','',26124),
(59251,'enUS','You know what dat mean...','',26124),
(59252,'enUS','You da new Ook!','',26124),
(59253,'enUS','Ook! Oooook!!','',26124),
(59254,'enUS','In the dooker!','',26124),
(59255,'enUS','There he is!','',26124),
(59256,'enUS','Master Crane! Are you okay?','',26124),
(59257,'enUS','Get Ooking party started!','',26124),
(59258,'enUS','Come on and get your Ook on!','',26124),
(59259,'enUS','We gonna Ook all night!','',26124),
(59260,'enUS','$p... he\'s succumbing to the sha...','',26124),
(59261,'enUS','You are moving out of the Verdant Belt. Your yak is about to break loose!','You are moving out of the Verdant Belt. Your yak is about to break loose!',26124),
(59262,'enUS','Let\'s get this lightning party started, Blanche.','Let\'s get this lightning party started, Blanche.',26124),
(59263,'enUS','What? What\'s happening...','',26124),
(59264,'enUS','It\'s calling out more sha! Focus them down first, $p!','',26124),
(59265,'enUS','We did it!','',26124),
(59266,'enUS','It seems hope has triumphed after all...','',26124),
(59267,'enUS','There is no time for celebration - many followers of the Way still battle outside.','',26124),
(59268,'enUS','Meet me near the statue at the center of the temple grounds. We will speak there.','',26124),
(59269,'enUS','We must never give in to despair.','',26124),
(59270,'enUS','Look, Uyen, it\'s a $c. You here to help, $g mister : miss; $c?','',26124),
(59271,'enUS','How\'s it goin\' out there? You\'re gonna rescue my people, right?','',26124),
(59272,'enUS','I haven\'t seen fightin\' like that since, well, I guess I haven\'t ever seen fightin\' like that. You sure are a firecracker, $n.','',26124),
(59273,'enUS','Well now, look Ma. $n\'s back. Why ain\'t you got any of my yaks?','',26124),
(59274,'enUS','You got \'em, $n! Here. Let\'s just get \'em over there into the pen nice as you please.','',26124),
(59275,'enUS','Lookie here, ma, it\'s $n. We was just talkin\' \'bout you.','',26124),
(59276,'enUS','Doesn\'t feel like it\'s been that long since last we talked.','',26124),
(59277,'enUS','I know, I know. We got the upper hand here now thanks to you, so we\'ll get them dang yaungol out of here soon. Just the same, if you feel like crackin\' a skull or two, you won\'t hear me complainin\'.','',26124),
(59278,'enUS','$n! You got any humdingers to tell us? I bet you just got all kinds of new stories \'bout your adventures and whatnot.','',26124),
(59279,'enUS','Uyen, $n\'s back. We got any chow for $g him : her;. Heh, get it? Chow?','',26124),
(59280,'enUS','This here\'s a might embarrassing with them yaungol still infestin\' the farm. You gotta understand though... I ain\'t no fancy $c like you. These things take time for ordinary folk like us. Well, I could just let Uyen go beat \'em \'bout their heads. But I wouldn\'t want to get her started if you know what I mean.','',26124),
(59281,'enUS','[DEBUG ONLY] Attacking $n!','[DEBUG ONLY] Attacking $n!',26124),
(59282,'enUS','$n, the most famous $r $c in all of Pandaria! Get over here and give ol\' Chow a hug!','',26124),
(59283,'enUS','Go on now. You got more important things to do than to be visitin\' the likes of us. Still, while you\'re here, you see that wascally wirmen runnin\' wild out in the fields?','',26124),
(59284,'enUS','','Good work! Dealing with the Hozen will be easier than I had anticipated.',26124),
(59285,'enUS','','%s grunts noncommittally.',26124),
(59286,'enUS','','%s doesn\'t seem impressed.',26124),
(59287,'enUS','','Shooting you a glance, %s frowns and spits.',26124),
(59288,'enUS','','%s sighs, clearly exasperated by the whole situation.',26124),
(59289,'enUS','Weaklings... let me make room for our guests.','',26124),
(59290,'enUS','Approach... your death awaits.','',26124),
(59291,'enUS','','%s waves off her husband as she glares at the continuing unwelcome presence on the farmstead.',26124),
(59292,'enUS','','%s cries softly thinking no one has noticed before drying her tears and standing resolute once more.',26124),
(59293,'enUS','','%s just looks at you.',26124),
(59294,'enUS','','%s seems not to hear what her husband has said while her eyes attempt to keep up with the crazed movements of the wascally wirmen destroying her fields.',26124),
(59295,'enUS','','A deadly wave of ice begins to sweep across the room!',26124),
(59296,'enUS','','Instructor Chillheart\'s soul escapes to her phylactery. Destroy it!',26124),
(59297,'enUS','Let me show you my power.','',26124),
(59298,'enUS','Come to me, serpent!  Together we will destroy these intruders.','',26124),
(59299,'enUS','The Azure Serpent moves in to attack!','',26124),
(59300,'enUS','The Azure Serpent stirs in the distance!','',26124),
(59301,'enUS','Ahh! Help! What is that thing!? It doesn\'t matter, nothing will stop me now, not when I\'m so close! Maybe if I don\'t look at it...?','',26124),
(59302,'enUS','Yes yes yes! So close! Just a pinch of...oops...','',26124),
(59303,'enUS','Too bitter! Just a drop of honey, and a cane of sugar, and maybe some corn? Yes, more corn!','',26124),
(59304,'enUS','Yes, yes, yes...no, no, no no no! Yes! No! Peppers!','',26124),
(59305,'enUS','Is it...can it be???','',26124),
(59306,'enUS','Such harmony of flavor, such heady aroma! It is...the perfect brew!','',26124),
(59307,'enUS','The name of Stormstout will be sung once again throughout the hills!','',26124),
(59308,'enUS','You again! Don\'t you see? I have made a name for myself at last: I have brewed perfection!','',26124),
(59309,'enUS','Next, we ferment the brew! Look out!','',26124),
(59310,'enUS','The final step, we add heat! Smell that aroma!','',26124),
(59311,'enUS','The elements of the brew are too chaotic! I do not know what will happen if they combine now!','',26124),
(59312,'enUS','','Phew! I need a breather. Let\'s rest here a momen- wha?',26124),
(59313,'enUS','','Up ahead! The refuge is under attack!',26124),
(59314,'enUS','','No time to catch our breath. Quickly! We\'ve got to help them!',26124),
(59315,'enUS','Battle Goats GO!','',26124),
(59316,'enUS','Wikkets gonna get Goated!','',26124),
(59317,'enUS','Goat goat gonna crush wikkets!','',26124),
(59318,'enUS','Battle Goats! Jib-it!','',26124),
(59319,'enUS','Battle Goats! Hooooooooozen!','',26124),
(59320,'enUS','Knucklethump gonna jib the wikkets!','',26124),
(59321,'enUS','Na naa na naaa naana! Battle Goats!','',26124),
(59322,'enUS','Take there nibs!','',26124),
(59323,'enUS','Wikkets be trailin!','',26124),
(59324,'enUS','Wikkets got munchpacks! Get munchpacks!','',26124),
(59325,'enUS','Munchy munchy!','',26124),
(59326,'enUS','RAVAGE!','',26124),
(59327,'enUS','Ravage! Ravage! Ravage!','',26124),
(59328,'enUS','More grummles leaving here shortly for Kota Basecamp. Wait here if wish to help!','',26124),
(59329,'enUS','Brothers! Dispose of these insolent outsiders!','',26124),
(59330,'enUS','Shado-Pan Fire Archers appear on the rooftops!','',26124),
(59331,'enUS','The Shado-Pan Archers disappear!','',26124),
(59332,'enUS','I show you on your map where grummles are now. Find them or wait here for next wave of grummles.','',26124),
(59333,'enUS','My seeds grow the best veggies in the valley. Guaranteed!','',26124),
(59334,'enUS','I\'m here to pick up seeds for Farmer Yoon.','I\'m here to pick up seeds for Farmer Yoon.',26124),
(59335,'enUS','Yoon, eh? Never heard of him...','',26124),
(59336,'enUS','He just inherited Sunsong Ranch. You can literally see him from where you are standing.','He just inherited Sunsong Ranch. You can literally see him from where you are standing.',26124),
(59337,'enUS','Ohh, of course! The Sunsong place, just over yonder. Was wondering who might be movin\' in on that.$B$B<Greenfield squints over your shoulder and waves at Yoon.>$B$BWhen you come back to market with the biggest, juiciest vegetables anyone\'s ever seen, you tell \'em where you got the seeds!','',26124),
(59338,'enUS','Such harmony of flavor, such heady aroma! It is...the perfect brew!','',26124),
(59339,'enUS','Striker Ga\'dok prepares to make a strafing run!','',26124),
(59340,'enUS','The gates are about to fall. Quickly! Slaughter these meddlers!','',26124),
(59341,'enUS','By the power of Zandalar, I command that ya rise!','',26124),
(59342,'enUS','Klatu, Barada, Nikto!','',26124),
(59343,'enUS','Piertotum Locomotor!','',26124),
(59344,'enUS','Cong siwang shangsheng, mogu!','',26124),
(59345,'enUS','Nam daed, no em nrut.','',26124),
(59346,'enUS','Vita, Mortis, Careo!','',26124),
(59347,'enUS','Awaken from ya slumber, my mogu friends. Together, we crush these lands.','',26124),
(59348,'enUS','Destroy those who seek to stop us from retakin\' these lands.','',26124),
(59349,'enUS','You?! I hear all \'bout you. My juju be strong. You not gonna stop the Zandalari!','',26124),
(59350,'enUS','','It\'s all or nothing, $n. Thunderpaw Refuge needs us. Are you ready to finish this thing?',26124),
(59351,'enUS','Let\'s kill some lizards, Blanche!','Let\'s kill some lizards, Blanche!',26124),
(59352,'enUS','','Let me know when you\'re ready to go inside...',26124),
(59353,'enUS','','Let\'s go be heroes!',26124),
(59354,'enUS','','Last call, you fork-tongued dip-slithers!',26124),
(59355,'enUS','','You don\'t have to go home, but you can\'t stay here.',26124),
(59356,'enUS','Lurching Blossom begins to breath a foul gas in front of it.','',26124),
(59357,'enUS','A clean weapon is a sign of one that has never seen combat.','',26124),
(59358,'enUS','Hello, friend! Can I interest you in the deal of a lifetime?','',26124),
(59359,'enUS','A weapon should be an extension of the fighter. Take care of it as you would yourself and it will never let you down.','',26124),
(59360,'enUS','How goes the relic retrieval, $n? I hope those mogu statues aren\'t giving you too much trouble.','',26124),
(59361,'enUS','That\'s a lot of mogu relics. We\'re going to be rich!','',26124),
(59362,'enUS','Great to see you again, $n.','',26124),
(59363,'enUS','I\'m working up the courage to go in after more of the relics. What do you think, $n?','',26124),
(59364,'enUS','Those relics are going to fetch a lot of gold just as soon as I can find the time to get back to town and find a buyer.','',26124),
(59365,'enUS','I bet if I stuck to the outskirts, I could zip in and out of the ruins, grab some relics, and dodge those statues.','',26124),
(59366,'enUS','Oh gods, $n, these mogu heads are staring at me!','',26124),
(59367,'enUS','$n, fun fact: the mogu here at Mogujia weren\'t always terracotta. They were buried alive with their lord after he died in glorious battle.','',26124),
(59368,'enUS','Here\'s a fun fact: Mogujia translates roughly as \'Home of the Mogu\'. Don\'t let that fool you, though. It\'s not their only home. It\'s just the name people have given this place. I did some research and found out that the original name for this area was Chow Keep. That\'s weird. Must just be a coincidence that farmer Chow also has the same name.','',26124),
(59369,'enUS','Have you figured out yet why that Zandalari troll was animating the statues here?','',26124),
(59370,'enUS','Those cabbages should be ready any minute now... wait for it...','',26124),
(59371,'enUS','There we go! Ripe for the pickin\'s!','',26124),
(59372,'enUS','Got anymore of that lotus incense?','',26124),
(59373,'enUS','Haven\'t seen any. I\'m starting to wonder if we will be able to make it up the mountain.','',26124),
(59374,'enUS','Brother Brokendice is taking all of my hard earned gold and goods! I should have known not to trust a grummle. Never trust something half your size...','',26124),
(59375,'enUS','The convoy to the Burlap Waystation is leaving now! Gather around!','',26124),
(59376,'enUS','For fortune!','',26124),
(59377,'enUS','Grummles! Come and breathe deep of travel incense. Go with good fortune to Burlap Waystation!','',26124),
(59378,'enUS','Grummles! Gather round and breathe deep of travel incense. Go with good fortune to Kota Basecamp!','',26124),
(59379,'enUS','Defeat the Boneweavers to aid Lilian Voss!','',26124),
(59380,'enUS','Grummle power!','',26124),
(59381,'enUS','No! Don\'t take my luckydo!','',26124),
(59382,'enUS','You stink of bad fortune.','',26124),
(59383,'enUS','No grummlepacks for you!','',26124),
(59384,'enUS','Bad fortune for you!','',26124),
(59385,'enUS','Fortune with me today!','',26124),
(59386,'enUS','No grummlepacks for you!','',26124),
(59387,'enUS','THIS IS WHERE A MOVIE WILL BE$B$BWE LOVE YOU, BETA TESTERS','THIS IS WHERE A MOVIE WILL BE$B$BWE LOVE YOU, BETA TESTERS',26124),
(59388,'enUS','Thank you for rescue! Meet me at Burlap Waystation.','',26124),
(59389,'enUS','','It might be wisest if you and your companions were not seen here for a time, traveler.',26124),
(59390,'enUS','I am ready to leave.','I am ready to leave.',26124),
(59391,'enUS','Report\'s all ready to go, $n! I don\'t mean to brag, but General Nazgrim should be pretty pleased with my work.','',26124),
(59392,'enUS','','Here\'s the report, $n. Oh! Make sure you mention my idea with the bombs. I have it lined out in the report.',26124),
(59393,'enUS','This is absolutely barbaric!','',26124),
(59394,'enUS','Bringing our war to these natives is wrong. We should be teaching them the best of ourselves not the worst...','',26124),
(59395,'enUS','There is still time to stop this madness. You don\'t have to do this Shokia...','',26124),
(59396,'enUS','There is so much we can learn from this land, and yet you are content to watch it burn around you.','',26124),
(59397,'enUS','','Report?! I have my hands full down here, $n! Oh alright, here you go.',26124),
(59398,'enUS','Nazgrim gonna be real happy with Riko! Here! Report is done!','',26124),
(59399,'enUS','%s calls out for reinforcements!','',26124),
(59400,'enUS','Use the Boomer Brew to zap saurok minions!','',26124),
(59401,'enUS','While one player is zapping a saurok, another can instantly destroy it.','',26124),
(59402,'enUS','','You did it! Thunderpaw Refuge is saved!',26124),
(59403,'enUS','','And I\'ve got just the brew to celebrate with. First round is on me. Thank you, friends!',26124),
(59404,'enUS','Come forward, so that we may be properly introduced.','',26124),
(59405,'enUS','Let\'s keep moving! I see another big one, down there!','',26124),
(59406,'enUS','No time, brothers! We\'ve got to keep fighting!','',26124),
(59408,'enUS','For Pandaria!!','',26124),
(59409,'enUS','Then, we maybe take a rest? Sit down for a while?','',26124),
(59410,'enUS','That made me hungry.','',26124),
(59411,'enUS','For Pandaria!','',26124),
(59413,'enUS','These mankers messed with the wrong hozen!','',26124),
(59414,'enUS','For the hozen!','',26124),
(59415,'enUS','Yeah! Get back over your wall, you jikkety-dooks!','',26124),
(59416,'enUS','Not eating.','',26124),
(59417,'enUS','For the jinyu!','',26124),
(59418,'enUS','Mankers?','',26124),
(59419,'enUS','Return from where you came, mantid.','',26124),
(59420,'enUS','Everything makes you hungry, Xiao.','',26124),
(59421,'enUS','','For Pandaria!!!',26124),
(59422,'enUS','','Woo hoooooo!',26124),
(59423,'enUS','Many thanks for rescue of most good fortune.','',26124),
(59424,'enUS','','Stay away from those claws - they look sharp!',26124),
(59425,'enUS','$p, take care of those eggs! We\'ll focus on the big mama!','',26124),
(59426,'enUS','Destroy the eggs before they hatch!','',26124),
(59427,'enUS','Which way did he go?','',26124),
(59428,'enUS','What the ook? Look out! Scary circle!','',26124),
(59429,'enUS','I\'m gonna come at you like an avalanche!','',26124),
(59430,'enUS','I call this move \"The Snowplow!\"','',26124),
(59431,'enUS','You have incurred the wrath!','',26124),
(59432,'enUS','Got somethin\' in my pack for ya! Here, let me find it. Nope, not there, not there either. Oh here it is, in my DEATH POUCH!','',26124),
(59433,'enUS','Right in the snowballs!','',26124),
(59434,'enUS','You won\'t like me when I\'m mildly influenced by incense!','',26124),
(59435,'enUS','I\'ll meet you at the Golden Pagoda.','',26124),
(59436,'enUS','We have no time to rest, $r.','',26124),
(59437,'enUS','The turmoil in Kun-Lai Summit has uprooted many innocents. They will find shelter within our gates.','',26124),
(59438,'enUS','For as long as we are able, we shall provide safe haven for those who seek it.','',26124),
(59439,'enUS','We will do our best to protect the refugees, but with the mogu pushing into the Vale, it may not remain safe for long.','',26124),
(59440,'enUS','There is so much work to do!','',26124),
(59441,'enUS','I will drain the red blood from your bodies!','',26124),
(59442,'enUS','You and your companions are my guests in the Vale. Please let me know if there is anything I can provide for you.','',26124),
(59443,'enUS','Her Majesty\'s brood will sweep over this valley!','',26124),
(59444,'enUS','For the pride of the mantid!','',26124),
(59445,'enUS','I will show you the face of fear.','',26124),
(59446,'enUS','%s is chasing you. Run!','',26124),
(59447,'enUS','I will hunt you down, soft-skin...','',26124),
(59448,'enUS','You cannot stop Her Majesty\'s brood! Our numbers are endless!','',26124),
(59449,'enUS','Click on a Bone Pile to protect yourself from Bone Spike!','Click on a Bone Pile to protect yourself from Bone Spike!',26124),
(59450,'enUS','Do you think pandaren are dark with white spots, or white with dark spots?','',26124),
(59451,'enUS','Do you know why the pandaren love philosophy? Because for them, things are not just black and white.','',26124),
(59452,'enUS','What happened to the pandaren whose kitchen was robbed? He got bamboozled!','',26124),
(59453,'enUS','What\'s the most valuable fish in all of Pandaria? The goldfish!','',26124),
(59454,'enUS','Do you know how to pick up a female jinyu in a tavern? Just drop your line!','',26124),
(59455,'enUS','What do you call a jinyu who has trained at Tian Monastery? A monkfish!','',26124),
(59456,'enUS','%s draws from the surrounding water!','',26124),
(59457,'enUS','How are the refugees settling in?','How are the refugees settling in?',26124),
(59458,'enUS','Reinforcements have arrived to the Vale.','Reinforcements have arrived to the Vale.',26124),
(59459,'enUS','What\'s happening here in the Vale?','What\'s happening here in the Vale?',26124),
(59460,'enUS','Keep the body strong, and the mind will follow.','',26124),
(59461,'enUS','','When the mind grows hungry for inspiration, feed it with beautiful things.',26124),
(59462,'enUS','Oh my, a visitor. Your presence makes me very happy.','',26124),
(59463,'enUS','Many have come from all corners of the land to see the gates opened at last. Indeed, many of your people have already found their way inside. Seek your own solace and refuge within.','',26124),
(59464,'enUS','Many have come from all corners of the land to see the gates opened at last. Indeed, many of your people have already found their way inside. Seek your own solace and refuge within.','',26124),
(59465,'enUS','','I am glad to hear it. The mogu\'s recent actions trouble me greatly. They have not behaved in such organized fashion for nearly ten thousand years.',26124),
(59466,'enUS','The Sacred Pools have been corrupted by dark energy, thanks to Garrosh Hellscream. Remnants of the sha still linger.','',26124),
(59467,'enUS','','Lilian\'s Soul fixates on $n!',26124),
(59470,'enUS','The water reacts violently to your touch!','',26124),
(59471,'enUS','Stay close to me. I will keep us camouflaged from the enemy.','',26124),
(59472,'enUS','Master Snowdrift vanishes to the shadows and creates duplicate illusions of himself! Strike the illusions to dispel them!','',26124),
(59473,'enUS','Master Snowdrift attacks you with his hand to hand techniques!','',26124),
(59474,'enUS','Do not run, it only delays the inevitable.','',26124),
(59475,'enUS','Come in, the water\'s fine!','',26124),
(59476,'enUS','Let death wash over you!','',26124),
(59477,'enUS','Come quickly. There is a gap in their defenses.','',26124),
(59478,'enUS','Let\'s go while the way is clear. The cave is just ahead.','',26124),
(59479,'enUS','Wait for a safe moment, then plant the explosives at the mouth of the cave.','',26124),
(59480,'enUS','Shado-Pan Stormbringers react to your presence and begin to |cFFFF0000|Hspell:115009|h[Focus Energy]|h|r!','',26124),
(59481,'enUS','','$n\'s here. Let\'s go.',26124),
(59482,'enUS','Ready... aim...','',26124),
(59483,'enUS','Ready your arrows, men!','',26124),
(59484,'enUS','Firing another round in 3... 2... 1...','',26124),
(59485,'enUS','Notch your arrows, men...','',26124),
(59486,'enUS','Bows ready...','',26124),
(59487,'enUS','Prepare your weapons, men!','',26124),
(59488,'enUS','Take aim!','',26124),
(59489,'enUS','Ready another round!','',26124),
(59490,'enUS','FIRE!!','',26124),
(59491,'enUS','|TInterface\\Icons\\ability_warlock_jinx.blp:20|t%s begins to cast |cFFFF0000|Hspell:115147|h[Empowering Spirits]|h|r!','',26124),
(59492,'enUS','Tread softly. Danger lurks ahead.','',26124),
(59493,'enUS','I\'m ready to infiltrate the cave.','I\'m ready to infiltrate the cave.',26124),
(59494,'enUS','Let\'s get this caravan on the road!','Let\'s get this caravan on the road!',26124),
(59495,'enUS','','Wha...',26124),
(59496,'enUS','Hey there, $p!$B$BHow\'s it feel to be a full-fledged farmer?','',26124),
(59497,'enUS','I never imagined farming would involve so many... exotic odors.','',26124),
(59498,'enUS','Are your thumbs turning green yet?$B$BMine look pretty much the same.','',26124),
(59499,'enUS','Ahem.$B$B\"I reckon there just ain\'t enough hours in the day!\"$B$BHow did that sound? Too forced? You think it would fly at the market?','',26124),
(59500,'enUS','I never thought about where the food on my table came from before we started this farming business.$B$BThis experience has been enlightening, to say the least!','',26124),
(59501,'enUS','Yoon, I need some farming advice.','Yoon, I need some farming advice.',26124),
(59502,'enUS','Of course!$B$BWhat seems to be the problem?','',26124),
(59503,'enUS','How do I care for Parched crops?','How do I care for Parched crops?',26124),
(59504,'enUS','How do I care for Infested crops?','How do I care for Infested crops?',26124),
(59505,'enUS','How do I care for Wiggling crops?','How do I care for Wiggling crops?',26124),
(59506,'enUS','How do I care for Alluring crops?','How do I care for Alluring crops?',26124),
(59507,'enUS','How do I care for Smothered crops?','How do I care for Smothered crops?',26124),
(59508,'enUS','How do I care for Wild crops?','How do I care for Wild crops?',26124),
(59509,'enUS','How do I care for Runty crops?','How do I care for Runty crops?',26124),
(59510,'enUS','How do I care for Tangled crops?','How do I care for Tangled crops?',26124),
(59511,'enUS','','The gate is jammed.',26124),
(59512,'enUS','Parched crops just need water!$B$BYou can use the old rusty watering can my grandpa left here. I keep it right over there by that tree stump, just next to the field.','',26124),
(59513,'enUS','Let me try.','',26124),
(59514,'enUS','Parched crops just need water!$B$BThey should be easy to take care of now that we\'ve got that sprinkler! It should be on the ground just at the edge of the field.','',26124),
(59515,'enUS','Did they prop this door up against a boulder?  It won\'t budge!','',26124),
(59516,'enUS','Step aside. I\'ve got the key right here.','',26124),
(59517,'enUS','The beer\'s here! Drink up, boys!','',26124),
(59518,'enUS','Ahh... beer. Just what my men needed. Thank you, $p.','',26124),
(59519,'enUS','First we get into a fight, and then someone brings us beer! Can today get any better?','',26124),
(59521,'enUS','Well done, Jojo!','',26124),
(59522,'enUS','','Beer delivery, in the middle of a battlefield? Perhaps Pandaria will make a good home after all...',26124),
(59523,'enUS','I have another question...','I have another question...',26124),
(59524,'enUS','Beer delivery, in the middle of a battlefield? Maybe Pandaria will make a good home after all...','',26124),
(59525,'enUS','How do I deal with Occupied soil?','How do I deal with Occupied soil?',26124),
(59526,'enUS','How do I deal with Stubborn weeds?','How do I deal with Stubborn weeds?',26124),
(59527,'enUS','Infested crops are covered in bugs. Yech!$B$BGrandpa\'s bug sprayer is on the ground near the field - use it to give those critters a blast of what-for!','',26124),
(59528,'enUS','Grrr-r-r-RRAHHH!','',26124),
(59529,'enUS','Infested crops are covered in bugs. Yech!$B$BNow that we have that Pulse Wave Emitter, though, it should be easy to get rid of them. Flip it on to shoo all those pests away in a humane fashion, without any pesticide!$B$BHey, does that mean our veggies count as organic?','',26124),
(59530,'enUS','Let\'s go deliver some dang BEER!','',26124),
(59531,'enUS','Wiggling, eh? Well, as Grandpa used to say: carrots don\'t dance!$B$BSomething is trying to pull the veggies right out from under us!$B$BI\'m afraid you\'ll have to kill whatever varmit\'s down there if you want the crop to have any peace. Heartbreaking, I know, but it\'s part of the job.','',26124),
(59532,'enUS','That\'s it for me! No more beer to deliver.','',26124),
(59533,'enUS','I reckon I\'ll head back to Stoneplow and rest my dang arms.','',26124),
(59534,'enUS','Well, sometimes veggies get to sprouting SO beautifully, they practically beg to be pilfered.$B$BGrandpa said a keen plainshawk could spot a prize pumpkin better than anyone at the market, and it\'d make for it quicker than a... err....$B$B\"Quicker than a hozen in heat.\"$B$BI guess you could say stuff like that back then?$B$BThe point is, you\'ll just have to defend alluring crops from critters!','',26124),
(59535,'enUS','Smothered  crops have a weed budging in on them!$B$BYou deal with them just like you deal with a stubborn weed in a plot of soil - elbow grease! Grab that sucker and pull for all you\'re worth. It\'ll give eventually.','',26124),
(59536,'enUS','Wild?! Now that\'s a surprise! Grandpa used to tell stories about having to wrestle his wild crops into submission.$B$B\"Yoonie,\" he used to say, \"don\'t be afraid to slap your scallions around.\"$B$BI always thought he was just being gross.','',26124),
(59537,'enUS','Runty! Hah! Now that\'s a term I haven\'t heard in awhile!$B$BGrandpa used to call me that when I refused to get up and go somewhere. He\'d grab the nape of my neck and hoist me up \"like a runty turnip\" he would say.$B$BThese crops just need a helping hand getting vertical. Get a firm grip on them and lift.','',26124),
(59538,'enUS','Tangleweeds, eh? Nasty little devils. They run deep into the ground some fifteen yards or so - you gotta pull the entire length out if you wanna get rid of it.$B$BGrab the exposed end of the weed and just keep moving away until you see the other end come out. Nothin\' more to it than that.','',26124),
(59539,'enUS','Sometimes virmen try to burrow up into the soil plots and live there, hoping vegetables will just rain down on them - I think they figure we just put \'em in the ground whole for some reason.$B$BSquatters, that\'s what Grandpa called them. You gotta put your foot down. Literally. Stomp the ground and root \'em out!','',26124),
(59540,'enUS','Stubborn weeds! They\'re a constant nuisance, creeping up in the soil and threatening to take over your land.$B$BBefore you can till that plot, you need to rip the weed out. There\'s no trick to it, really - just grab it and pull!$B$BIn the words of my grandpa, \"you just gotta be more ornery than the weed!\"','',26124),
(59541,'enUS','|TInterface\\Icons\\spell_warlock_demonsoul.blp:20|t%s casts |cFFFF0000|Hspell:115297|h[Evict Soul]|h|r on |cFF006EFD$n|r!','',26124),
(59542,'enUS','Many thanks for rescue!','',26124),
(59543,'enUS','This your fault!','',26124),
(59544,'enUS','My fault? I wasn\'t one who bought unclean yak.','',26124),
(59545,'enUS','Help! Grummle in trouble.','',26124),
(59546,'enUS','Help a grummle?','',26124),
(59547,'enUS','Give back my luckydo!','',26124),
(59548,'enUS','Changed your mind? I\'ll wait for you at the entrance to Ruins Rise when you\'re ready.','',26124),
(59549,'enUS','I\'ll wait for you at the base of Ruins Rise.','',26124),
(59550,'enUS','Stop. Let them pass.','',26124),
(59551,'enUS','Let\'s wait for the next wave.','',26124),
(59552,'enUS','I\'m not one for fightin\' much. Pickin\' up heavy stuff, sure... but my muscles get all weak an\' wobbly when it comes to hittin\' somethin\'.','',26124),
(59553,'enUS','Let\'s head out to the battlefield, Mudmug.','Let\'s head out to the battlefield, Mudmug.',26124),
(59554,'enUS','Never met them before in my life. Pandaren don\'t really come in any bad flavors though.','',26124),
(59555,'enUS','Korga Strongmane, once prisoner of the Alliance, now free and woefully unarmed tauren. Good to meet you, pandaren.','',26124),
(59565,'enUS','Somebody help!','Somebody help!',26124),
(59566,'enUS','Who dares disturb me? Show your cowardly faces and kneel before me!','',26124),
(59567,'enUS','Ahahaha! Such a pitiful creature!','',26124),
(59568,'enUS','Please, would you get me out of here?','Please, would you get me out of here?',26124),
(59569,'enUS','If I don\'t get away from these beasts, they\'re going to kill me!','If I don\'t get away from these beasts, they\'re going to kill me!',26124),
(59570,'enUS','Wikkets gonna be munch munch food for Old Poot Poot.','',26124),
(59571,'enUS','Ookin wikkets gonna give up their nibs. One way or another.','',26124),
(59572,'enUS','Silly wikkets. Walking for goat goats.','',26124),
(59573,'enUS','Hey you. Would you let me loose?','Hey you. Would you let me loose?',26124),
(59574,'enUS','Over here!','Over here!',26124),
(59575,'enUS','What did we ever do to you?','What did we ever do to you?',26124),
(59576,'enUS','I just want to go home.','I just want to go home.',26124),
(59577,'enUS','Please, I beg you.','Please, I beg you.',26124),
(59578,'enUS','Bad fortune for you.','',26124),
(59580,'enUS','Friends of grummles come soon. You will see!','',26124),
(59581,'enUS','Why so angry?','',26124),
(59582,'enUS','What did grummles ever do to you?','',26124),
(59583,'enUS','','The Alliance? If the crashed ship is theirs, we need to contact them. Jojo, would you come with me?',26124),
(59584,'enUS','We need to dislodge that ship, Korga.  If we help your crewmates, can you help us?','',26124),
(59585,'enUS','Gladly, my new friend. Our engineer is still in the wilds though - we\'ll need to rescue him first.','',26124),
(59586,'enUS','Well, we\'ve got a master person-finder here, eh $p?  We\'re on it.','',26124),
(59587,'enUS','Thank you, $c.  Thank you!','Thank you, $c.  Thank you!',26124),
(59588,'enUS','The Ragemesa leader is in the caves!','The Ragemesa leader is in the caves!',26124),
(59589,'enUS','I\'m going to try to get out of here now.  Thank you!','I\'m going to try to get out of here now.  Thank you!',26124),
(59590,'enUS','There\'s a whole bunch of them still in the caves.  They\'re getting ready to attack your people!','There\'s a whole bunch of them still in the caves.  They\'re getting ready to attack your people!',26124),
(59591,'enUS','I need to find my family!','I need to find my family!',26124),
(59592,'enUS','Please, $c, drive them out of Kun-Lai for good.','Please, $c, drive them out of Kun-Lai for good.',26124),
(59593,'enUS','Blessings of the four winds upon you, stranger.','Blessings of the four winds upon you, stranger.',26124),
(59594,'enUS','You\'ve saved us!  Now we need to get out of here.','You\'ve saved us!  Now we need to get out of here.',26124),
(59595,'enUS','We cannot fight like this forever.','',26124),
(59596,'enUS','$p, go speak to Guard Captain Oakenshield. Tell him we need reinforcements!','',26124),
(59597,'enUS','You are not worthy of me. You! Come crush this insignificant flea!','',26124),
(59598,'enUS','Removing the spirit\'s illusion damages the hozen\'s fragile mind!','Removing the spirit\'s illusion damages the hozen\'s fragile mind!',26124),
(59599,'enUS','$p! Over here!','',26124),
(59600,'enUS','Put me down!','',26124),
(59601,'enUS','Don\'t throw me in the fire, hozen!','',26124),
(59602,'enUS','What did I ever do to you? Why so angry?','',26124),
(59603,'enUS','I still have a luckydo. This is your last chance to surrender before bad fortune finds you.','',26124),
(59604,'enUS','Everyone to arms! The mogu are attacking!','',26124),
(59605,'enUS','Their main army has breached the north gate!','',26124),
(59606,'enUS','You are needed back at the Golden Pagoda immediately!','',26124),
(59607,'enUS','','Well done, $n. Wait... I see a scout approaching.',26124),
(59608,'enUS','<Miss Fanny shuffles uncomfortably. Either she\'s nervous about the nearby combat, or anxious to get into the fray herself.>','',26124),
(59609,'enUS','<Miss Fanny looks at you expectantly. Her eye twinkles with anticipation.>$b$b<Miss Fanny\'s moment for glory has arrived.>','',26124),
(59610,'enUS','Let\'s go, Miss Fanny.','Let\'s go, Miss Fanny.',26124),
(59611,'enUS','All hope is not lost, $p.','',26124),
(59612,'enUS','You\'ve been swallowed by the Ik\'thik Colossus!','',26124),
(59613,'enUS','Use your martial arts training. Focus your energy... then STRIKE!','',26124),
(59614,'enUS','Keep striking!','',26124),
(59616,'enUS','You can do this, $p... but you cannot do this alone. You will need help from that mushan beast. Yes, I believe her name was Miss Fanny.','',26124),
(59617,'enUS','Keep fighting, pandaren! Cancel all retreat orders! Stoneplow hasn\'t fallen yet!','',26124),
(59618,'enUS','Three...','',26124),
(59619,'enUS','Two...','',26124),
(59620,'enUS','One...','',26124),
(59621,'enUS','BOOM!','',26124),
(59622,'enUS','Hmph. Those mogu will have to try harder than that!$B$BThe Golden Lotus will defend the Vale... no matter the cost.$B$BThe secrets that we guard are much too precious... much too powerful... to allow into the hands of the Shao-Tien!','',26124),
(59623,'enUS','How dare they attack a caretaker of the Vale, so far behind our defensive lines!$B$BDo you see now why we need your help?$B$BThe Shao-Tien mogu have found a way to enter the Vale. Unchecked, they will bring unspeakable devastation to our tranquil home.','',26124),
(59624,'enUS','When times are dark, it is best to turn on a light.','',26124),
(59625,'enUS','','What\'s your report?',26124),
(59626,'enUS','The Vale is peaceful. Too peaceful.','',26124),
(59627,'enUS','Sometimes the most beautiful things are also the most deadly. Just look at me!','',26124),
(59628,'enUS','Well, that should put a damper on their plans. Good work, $n. I trust you can get back on your own.','',26124),
(59629,'enUS','If you\'re looking to infiltrate the ruins, speak to Kun Autumnlight at the Guo Lai Ruin first.','',26124),
(59630,'enUS','Defend the Cart!','',26124),
(59631,'enUS','What the ook?!','',26124),
(59632,'enUS','OW! OW! OW!','',26124),
(59633,'enUS','Nob nob nibble.','',26124),
(59634,'enUS','If only I had figured out the fresco sooner. So much could have been avoided, $n.','',26124),
(59635,'enUS','Our homes... destroyed... We did what we had to....','',26124),
(59636,'enUS','I\'ve been expecting you, $p!','',26124),
(59637,'enUS','Spirits and elements of Pandaria, I call upon you! Destroy $p!','',26124),
(59638,'enUS','What?! I will finish you myself!','',26124),
(59639,'enUS','Those who steal from the mogu will be punished.','',26124),
(59640,'enUS','Your people are lost. Even as we speak, we mogu are overtaking your precious Vale.','',26124),
(59641,'enUS','The Thunder King will rise again!','',26124),
(59642,'enUS','Do you really think we are going to make it out of here alive?','',26124),
(59643,'enUS','I cleared the way. You should be good to go.','I cleared the way. You should be good to go.',26124),
(59644,'enUS','I can\'t believe we made it. Thank you stranger!','',26124),
(59645,'enUS','My boy! Just in time. We have more yaks to clean.','',26124),
(59646,'enUS','','$n, $g you handsome devil : you sexy thing;, get over here.  We need to talk about some statues....',26124),
(59647,'enUS','','What\'s the hold up?  You busy with something else?  Did that little creep, Rivett, ask you to do something for him?!',26124),
(59648,'enUS','','So... why isn\'t that troll dead yet?  He is the one reanimating all of those mogu, yes?',26124),
(59649,'enUS','I always hate the days that I have to go in to that cave looking for sprite needles.','',26124),
(59650,'enUS','','Why do I have the feeling that you\'ve got good news for me, $n?',26124),
(59651,'enUS','','I don\'t hear that crazy troll yelling any longer.  Music to my ears!',26124),
(59652,'enUS','','We need those pandaren rescued.  If that doesn\'t happen soon, we\'re going to have a slew of defectors here going after their loved ones and getting themselves killed!',26124),
(59653,'enUS','','News of your success has preceeded you.  Our ranks have swelled!  We\'re in better shape now than I\'d dared to hope for thanks to you, $n.',26124),
(59654,'enUS','','Well, well, well, look who\'s back!  Slumming, $n?',26124),
(59655,'enUS','Not in the face!','',26124),
(59656,'enUS','','All hail $n, the mighty conqueror of the yaungol and champion of Easterly Rest!',26124),
(59657,'enUS','It\'s heading right for us!','',26124),
(59658,'enUS','Don\'t make them angry!','',26124),
(59659,'enUS','Play dead! They\'ll get bored and go away.','',26124),
(59660,'enUS','','Going to be around for a while, $n?',26124),
(59661,'enUS','','I wonder how long we\'ll be here before the general gives us our marching orders.',26124),
(59662,'enUS','','$n, have you been back to Orgrimmar?  What news?',26124),
(59663,'enUS','','Talk around camp is that on the other side of the wall to the west, Townlong Steppes is crawling with bugs.  What do you think, $n?',26124),
(59664,'enUS','','What I wouldn\'t give for a fresh corpse to cannibalize.  Oops, did I say that out loud?',26124),
(59665,'enUS','','I give up.  I can\'t get through to you cuddly bears.  $n, would you come over here and show these newbs how it\'s done?',26124),
(59666,'enUS','Did they leave yet?','',26124),
(59667,'enUS','','YOU TOLD HER WHAT?!',26124),
(59668,'enUS','$n, I lend you the cold vengeance of the northern winds!','',26124),
(59669,'enUS','Hmm. What to make first? Incense? Campfire logs? Everburning candle?','',26124),
(59670,'enUS','Ah! A luckydo comes to the great Grummle Bazaar eh? I smell good fortune in our meeting.$b$bI am called the Lucky Eightcoins. I am named for my best luckydo, the one that gives most pungent smelling fortune.','',26124),
(59671,'enUS','We are the grummles. We know all of the paths through the mountains.$b$bMost of all we bring supplies to the great wall in the east. The bastion of the Shado-Pan.$b$bThese are dark times though, and grummles face great dangers on our road.','',26124),
(59672,'enUS','On your first try! Now, take the flame to the top of the temple and burn the scroll that you find there.','',26124),
(59674,'enUS','Shen-zin Su, the very land on which we stand, is in deep pain. Though I don\'t know the source, I can feel his ache within my own body.','',26124),
(59675,'enUS','Ancient wisdoms tell of speaking to Shen-zin Su through the voice of the four elemental spirits, but the spirits have fled our great temple and their powers are fading.','',26124),
(59676,'enUS','$n, you are the champion I\'ve long been awaiting. You will be the one to find and reunite the elemental spirits so that we might speak to Shen-zin Su and heal our land.','',26124),
(59677,'enUS','The closest spirit is Huo, the spirit of flame. I would ask you to meet with some of my most talented students and learn what they know of Huo.','',26124),
(59678,'enUS','Time is not on our side. Go as soon as you are able.','',26124),
(59679,'enUS','','You do not fight alone! Unleash my storm upon these invaders!',26124),
(59680,'enUS','The fire spirit is upset. It\'s dangerous to enter the shrine now...','',26124),
(59681,'enUS','Did you hear what those Tillers said about me being a citypaw?$B$BSure I grew up in Dawn\'s Blossom, but I visited my grandpa a few times. I know the difference between a carrot and a turnip! One\'s orange and one\'s white, after all!$B$BAfter Grandpa passed, he left the farm to me, so I\'m going to do my best for him! But how can I prove that to those Tillers?','',26124),
(59682,'enUS','Good. Channel the flames, feel them course through you.','Good. Channel the flames, feel them course through you.',26124),
(59683,'enUS','Learn this spell well for it will burn the taint from all those who oppose us.','Learn this spell well for it will burn the taint from all those who oppose us.',26124),
(59684,'enUS','The battle begins in 2 minutes!','',26124),
(59685,'enUS','The battle begins in 1 minute!','',26124),
(59686,'enUS','The battle begins in 30 seconds!','',26124),
(59687,'enUS','The battle has begun!','',26124),
(59688,'enUS','My crop is Growing... now what?','My crop is Growing... now what?',26124),
(59689,'enUS','The Alliance has captured a Mine Cart!','',26124),
(59690,'enUS','The Horde has captured a Mine Cart!','',26124),
(59691,'enUS','Now all you have to do is wait! Most crops are ready the day after they start growing.$B$BAren\'t we lucky to have land in such a fruitful valley?','',26124),
(59692,'enUS','A challenger approaches.','',26124),
(59693,'enUS','Hoptallus lets out a loud screech! The virmen are coming!','Hoptallus lets out a loud screech! The virmen are coming!',26124),
(59694,'enUS','Strike at these barbarians with the full force of my rage!','',26124),
(59695,'enUS','Good fortune to you!','',26124),
(59696,'enUS','We\'ll meet you at Kota Basecamp!','',26124),
(59697,'enUS','Tassle sniffs the air.','',26124),
(59698,'enUS','|TInterface\\Icons\\inv_misc_qirajicrystal_04.blp:20|t |c0091D0F8%s|r begins to petrify all players!','',26124),
(59699,'enUS','|TInterface\\Icons\\inv_misc_qirajicrystal_03.blp:20|t |c0093F8D1%s|r begins to petrify all players!','',26124),
(59700,'enUS','|TInterface\\Icons\\inv_misc_qirajicrystal_02.blp:20|t |c00F19C88%s|r begins to petrify all players!','',26124),
(59701,'enUS','|TInterface\\Icons\\inv_misc_qirajicrystal_05.blp:20|t |c00C3B7EA%s|r begins to petrify all players!','',26124),
(59702,'enUS','Xuen, might of the north, answers the call of battle!','',26124),
(59703,'enUS','Yu\'Lon, guardian of the east, appears on the field of battle!','Yu\'Lon, guardian of the east, appears on the field of battle!',26124),
(59704,'enUS','Niuzao, strength of the west, charges into battle!','',26124),
(59705,'enUS','Thank the heavens... I thought the secrets of Firebough Stout would die with me. Help me out of here, friend!','',26124),
(59706,'enUS','Let\'s get out of here.','Let\'s get out of here.',26124),
(59707,'enUS','You have a firm grip - now JUMP!','You have a firm grip - now JUMP!',26124),
(59708,'enUS','Smelly wikkets!','',26124),
(59709,'enUS','','The mogu broke through our defenses...$B$BTheir army of jade soldiers was too much for us to hold back.$B$BI stayed behind to take care of Che, but the others retreated to the city to make their last stand.',26124),
(59710,'enUS','I hope you\'re ready, $p. Jaomin Ro awaits you just over the bridge.','',26124),
(59711,'enUS','You\'re departing so soon?  I am envious of your prowess, $c. Good luck to you.','',26124),
(59712,'enUS','Shhhh! Come quietly. She\'s practicing.','',26124),
(59714,'enUS','%s begins to channel a violent |cFFFF0404|Hspell:116040|h[Epicenter]|h|r!','',26124),
(59715,'enUS','Hah! Way to go! You are a natural at this.','',26124),
(59716,'enUS','Come, friend! The fighting\'s this way!','',26124),
(59717,'enUS','Come quickly!  Wouldn\'t want to miss out on the fun, would ya?','',26124),
(59718,'enUS','I like the way you think! Let\'s go!','',26124),
(59719,'enUS','We stand by your side, friend.  This battle is not yours alone.','',26124),
(59720,'enUS','','We\'ll cover this front. You keep my priests safe.',26124),
(59721,'enUS','','Hold the line, sailors! Your brothers depend on you!',26124),
(59722,'enUS','','Tend to the wounded! This isn\'t over yet.',26124),
(59723,'enUS','Honey Badger doesn\'t give a sh*t!','Honey Badger doesn\'t give a sh*t!',26124),
(59726,'enUS','I\'m not leaving these behind. This is my family\'s legacy!','',26124),
(59727,'enUS','Allow me to introduce myself - I am Ya Firebough, illustrious leader of this formerly maginificent hamlet.$B$BClearly, you are an upstanding citizen of the world.$B$BI wonder if I could trouble you to help me out of this rather sticky situation? I\'m certain that the Shado-Pan at the nearby retreat will be more than happy to recompense you for any inconvenience.','',26124),
(59728,'enUS','...That\'s enough. Let\'s go.','...That\'s enough. Let\'s go.',26124),
(59729,'enUS','','This is no place for a bright, young $g man : lady; such as yourself.$B$BPerhaps you would like for me to escort you to safety, hmm?',26124),
(59730,'enUS','Yes... why don\'t you \"escort\" me out of here.','Yes... why don\'t you \"escort\" me out of here.',26124),
(59731,'enUS','','Please, $g mister : ma\'am;..$B$BWill you get me out of here?',26124),
(59732,'enUS','$n, was it? There\'ll be a few extra gold for you if you can personally guarantee my safety.','',26124),
(59733,'enUS','','You\'re... working for the Shado-Pan? I can\'t believe it!',26124),
(59734,'enUS','','When these monsters came, the Shado-Pan got so serious... they kept saying, \"Sha\". What\'s that?',26124),
(59735,'enUS','These aren\'t as light as they look. Could we make haste?','',26124),
(59736,'enUS','How far must we go?','',26124),
(59737,'enUS','When we make it back to the Retreat, we can tap these and toast to life!','',26124),
(59738,'enUS','I hear that the yaungol busted through the gates up north. Wonder what happened to the Shado-Pan there?','',26124),
(59739,'enUS','My father brewed Firebough Stout. His father did before him. I can\'t let the legacy die out.','',26124),
(59740,'enUS','There\'s really nothing quite like a warm brew. Warms your bones and hits the spot. You can keep that cold stuff to yourself.','',26124),
(59741,'enUS','Well, yeah, sure... who hasn\'t heard of Chen Stormstout? Though, I hear his keg\'s empty, if you know what I mean.','',26124),
(59742,'enUS','Uh oh. Looks like I\'ve sprung a leak! The brew!!!','',26124),
(59743,'enUS','Are you working with the Shado-Pan? I can\'t believe they\'d let an outsider help them!','',26124),
(59744,'enUS','These yaungol never even bothered to say hello. They simply attacked! Serves them right being infested by those sha things!','',26124),
(59745,'enUS','All of my people, dead. Maybe I should build a new manor in Binan Village?','',26124),
(59746,'enUS','Kobai used to threaten us, that was all. Now... whatever mind he had, he\'s clearly lost.','',26124),
(59747,'enUS','I\'m going to give Shado-Master Chong a piece of my mind when I see him. The nerve of the Shado-Pan not coming to our aid!','',26124),
(59748,'enUS','I think I can speak for everyone when I say that you\'re a true hero of Kun-Lai Summit, not to mention Firebough Nook, $p!','',26124),
(59749,'enUS','I really wasn\'t built for this. I\'m a master orator and diplomat of the people. Are we quite done here yet?','',26124),
(59750,'enUS','I trust that you\'re planning to do something about that giant surge of anger that\'s erupting from the middle of the lake?!','',26124),
(59751,'enUS','Is that... is that Huo?','',26124),
(59752,'enUS','It is! Well done, $p!','',26124),
(59753,'enUS','','Hi-Ya!',26124),
(59754,'enUS','','Fus Ro Dah!',26124),
(59755,'enUS','','I see your Way of the White Tiger, Jade Serpent, Monkey Crane technique is as good as mine.',26124),
(59756,'enUS','','Cry in the dojo. Laugh on the battlefield. Ahahahahahaha!',26124),
(59757,'enUS','Take that monkeybutt!','',26124),
(59758,'enUS','','Sweep the leg!',26124),
(59759,'enUS','','GET... OUT... OF... MY... TOWN!',26124),
(59760,'enUS','','Flow like the water, bend like the reed... blah, blah, blah. Just kick some butt!',26124),
(59761,'enUS','','Judge me by my age, would you?',26124),
(59762,'enUS','We\'ve already lost the town... why have no reinforcements arrived from the Monastery?','',26124),
(59763,'enUS','Knucklethumps thump! Thump! Thump!','',26124),
(59764,'enUS','Wikkets no take packers back!','',26124),
(59765,'enUS','Hozen steal munchpacks fair and square. No take backs!','',26124),
(59766,'enUS','No wikkets allowed!','',26124),
(59767,'enUS','For big King!','',26124),
(59768,'enUS','Chief say ravage, so hozen ravage!','',26124),
(59769,'enUS','Ookin wikket! Get back here!','',26124),
(59770,'enUS','The Golden Lotus has overseen the Vale for thousands of years.$B$BThe heavens have sent us their sign, and we stand united in our belief that it is time to open the gates once more.$B$BAre you ready?','',26124),
(59771,'enUS','I am ready to open the gates.','I am ready to open the gates.',26124),
(59772,'enUS','AWESOME AMAZING GATE OPENING CINEMATIC GOES HERE!!!','AWESOME AMAZING GATE OPENING CINEMATIC GOES HERE!!!',26124),
(59773,'enUS','Firing','Firing',26124),
(59774,'enUS','Rampaging yeti?! Hmm. This gives me a most big idea.','',26124),
(59775,'enUS','Ookin wikkets gonna try to keep munchpacks from Broketooth!','',26124),
(59776,'enUS','Of course. Don\'t worry.','Of course. Don\'t worry.',26124),
(59777,'enUS','You made it through! Come, we must speak.','',26124),
(59778,'enUS','As trying as these times are, we must control our emotions, lest they be used by the Sha.','',26124),
(59781,'enUS','I felt Fury\'s demise. You have done well.','',26124),
(59782,'enUS','The eyes of the angry hozen are upon you, ooker.','',26124),
(59783,'enUS','Grummles have good noses. Can tell the difference between good and bad fortune by the smell. You have the smell of good fortune about you.','',26124),
(59784,'enUS','The Shado-Pan are not here because the wall needs them. Grummles owe much fortune to the Shado-Pan. If the Shado-Pan cannot defend grummles that means they are in danger, and need grummlepacks now more than ever.','',26124),
(59785,'enUS','The Jib of Dook was a friend of grummles. He lasted a whole three seasons. Now the Ook of Dook is in charge and most angry. He thinks food from grummles will stop soon, so he ravages.','',26124),
(59786,'enUS','Many good fortunes to you. I am Brother Rabbitsfoot. I am a merchant, a traveller, and a big luckydo for grummles.$b$bIn times of peace, $p would do well to buy of my wares. But fortune has us meet this day.$b$bWe have much work to do together.','',26124),
(59787,'enUS','The hozen fed my yaks to their pet yeti. This is most bad fortune.','',26124),
(59788,'enUS','Brother Rabbitsfoot may be smart and tall, and smells of luck and good fortune. But he snores and makes bad jokes about my luckydo yakshoe.','',26124),
(59789,'enUS','Want to see my luckydo? This is the shoe of the yak that carried me when I was most small. Many years this shoe has given me much fortune.','',26124),
(59790,'enUS','What\'s your luckydo? All travellers of great roads need their luckydos.','',26124),
(59791,'enUS','You reek of fortune! Many thanks for saving me, Luckydo! You can call me Brother Yakshoe.','',26124),
(59792,'enUS','Ah, $rs are most useful. Should have more $rs for rainy day.','',26124),
(59793,'enUS','Grummle up!','',26124),
(59794,'enUS','Bad fortune to be here.','',26124),
(59795,'enUS','This a most not good place.','',26124),
(59796,'enUS','Hozen stink of bad fortune.','',26124),
(59797,'enUS','Ah! A grummlepack. Most good.','',26124),
(59798,'enUS','I know these luckydos.','',26124),
(59799,'enUS','You have done well. We will keep these weapons under close guard, hidden away here in this hall. The mogu shall never see these treasures again.','',26124),
(59800,'enUS','Ah, a good stash of things.','',26124),
(59801,'enUS','Well done! The Thunder King\'s axe is ours.','',26124),
(59803,'enUS','$n, I implore you to go to the Gate of Winter\'s Blossom and seek out Shado-Master Maikee as soon as you can.','',26124),
(59805,'enUS','I heard the crocs are attacking because of an ancient mogu curse.','',26124),
(59806,'enUS','Ookin wikkets not gonna stop the ravage!','',26124),
(59807,'enUS','I say just let the crocolisks come. They\'ll stop attacking eventually. Why interfere?','',26124),
(59808,'enUS','Wikkets gonna burn!','',26124),
(59809,'enUS','Broketooth need food. Wikkets have food. Ravage!','',26124),
(59810,'enUS','New king, new rules. Sorry, but wikkets gonna get ravaged!','',26124),
(59811,'enUS','This raft is all yours, neighbor. You ever want to go rafting, just come back here. It\'ll be waiting for you.','',26124),
(59812,'enUS','Time for the feedings.','',26124),
(59813,'enUS','Learning','',26124),
(59814,'enUS','Kung Din pounced on you! Fight for your life! |TInterface\\Icons\\ability_warrior_secondwind.blp:20|t','',26124),
(59815,'enUS','','Welcome friend!',26124),
(59816,'enUS','','Have a seat at the bar, friend. I\'ll get you some food.',26124),
(59817,'enUS','','Hello $c!',26124),
(59818,'enUS','','Oh, Hello! Can I interest you in a piping hot cup of tea before you leave?',26124),
(59819,'enUS','','My grandmother used to tell me it was bad for a fighter\'s balance to enter battle on an empty stomach!',26124),
(59820,'enUS','','Hello, $n! You\'re making quite a name for yourself here!',26124),
(59822,'enUS','','Welcome back, $n! I see you found our missing guides!',26124),
(59823,'enUS','','Welcome Back, $n!',26124),
(59824,'enUS','','Now that Ji-Lu has his trinkets back maybe I\'ll get some peace in the inn!',26124),
(59825,'enUS','','Hello again, $c!',26124),
(59826,'enUS','','What a pleasure it is to have the great $n in my establishment!',26124),
(59827,'enUS','','Greetings, $n!',26124),
(59828,'enUS','','You are always welcome at the inn, $n!',26124),
(59829,'enUS','','The hero of One Keg returns!',26124),
(59830,'enUS','','Ok you two, play nice!',26124),
(59831,'enUS','Welcome to my humble shop, $c.','',26124),
(59832,'enUS','Feel free to browse my wares.','',26124),
(59833,'enUS','Greetings, $c! you look like you might be interested in some fresh spices! Perhaps some books for your journey.','',26124),
(59834,'enUS','Welcome! You won\'t find a better selection east of the camp!','',26124),
(59835,'enUS','Be sure to stop by and see me again, $c!','',26124),
(59836,'enUS','The Vale is my home. It is my duty and my desire to protect it from harm.','',26124),
(59837,'enUS','The winds are good today.','',26124),
(59838,'enUS','Fortune smiles on grummle mounts.','',26124),
(59839,'enUS','Come back soon!','',26124),
(59840,'enUS','The mountain will forgive the bird, but not always the rider.','',26124),
(59841,'enUS','You here to fish?','',26124),
(59842,'enUS','I can\'t imagine what caused these crocolisks to start attacking. What changed?','',26124),
(59843,'enUS','Thanks again for all your help, $n. The crocolisks aren\'t attacking nearly as much as they were before.$b$bWe\'re also doing our part here. We haven\'t caught any more fish than we need to eat.','',26124),
(59844,'enUS','','Hello, $r.',26124),
(59845,'enUS','Nothin\' to see here... move along!','',26124),
(59846,'enUS','I\'m a little basket filled with grain...','',26124),
(59847,'enUS','I won\'t go back!','',26124),
(59848,'enUS','I\'m just a little grummle in a scary world.','',26124),
(59849,'enUS','Are you sure you don\'t want to come with me?','Are you sure you don\'t want to come with me?',26124),
(59850,'enUS','Nope! Grummle is safe here.','',26124),
(59851,'enUS','','Allow me to make your underwater experience a little more... pleasant.',26124),
(59852,'enUS','Can you increase my swim speed again?','Can you increase my swim speed again?',26124),
(59853,'enUS','Aaaaaaaah!','',26124),
(59854,'enUS','Wikkets be crazy!','',26124),
(59855,'enUS','Poot Poot is loose! Run!','',26124),
(59856,'enUS','Mad yeti! Mad yeti!','',26124),
(59857,'enUS','Ook me!','',26124),
(59858,'enUS','Pootacalypse!','',26124),
(59859,'enUS','Woops!','',26124),
(59860,'enUS','','This is the tale of the Hungry Crocolisk.',26124),
(59861,'enUS','','The crocolisks of Narsong Trench ate fish. They were fat and happy.',26124),
(59862,'enUS','','Then the sharks came.',26124),
(59863,'enUS','','The sharks competed for the fish, but the crocolisks survived.',26124),
(59864,'enUS','','Soon after, the pandaren arrived.',26124),
(59865,'enUS','','The pandaren fished in the trench\'s waters, but the crocolisks survived.',26124),
(59866,'enUS','','Finally, the hozen came to Narsong Trench.',26124),
(59867,'enUS','','The hozen overfished the area, catching more fish than they could eat.',26124),
(59868,'enUS','','With no fish to eat, the crocolisks became hungry and desperate. They attacked the pandaren out of sheer hunger.',26124),
(59869,'enUS','','The pandaren, in fear and defense, killed all the crocolisks of Narsong Trench.',26124),
(59870,'enUS','A pair of Zandalari Trolls burst through the doors ahead of you!','',26124),
(59871,'enUS','No matter! We don\'t be needin\' what\'s back dat way anyhow!','',26124),
(59872,'enUS','Now you done made me angry!','',26124),
(59873,'enUS','Fine, den! Time ta play, friends.','',26124),
(59874,'enUS','','The Narsong crocolisk is no more... simply because the pandaren didn\'t see the whole story.',26124),
(59875,'enUS','Hey there! Are you the one that brought back the fire spirit?','',26124),
(59876,'enUS','Was he hot?  I bet he was hot!','',26124),
(59877,'enUS','Of course he was hot! Don\'t be dumb, Deng.','',26124),
(59878,'enUS','Okay bye.','',26124),
(59879,'enUS','I bet you\'re really strong, huh?  You could probably kick that bridge right in half if you wanted to!','',26124),
(59880,'enUS','Nuh uh. Bet they could for sure kick you over that hill, though! Hah!','',26124),
(59881,'enUS','Not again!','',26124),
(59882,'enUS','None of you saw that!','',26124),
(59883,'enUS','My braids!','',26124),
(59884,'enUS','Bye!','',26124),
(59885,'enUS','She is trying to throw you off, hold on tight!$b$b|TInterface\\Icons\\inv_misc_desecrated_leatherglove.blp:32|t Hold On','',26124),
(59886,'enUS','%s begins to |cFFFF0404|Hspell:116711|h[Draw Flame]|h|r to his weapon!','',26124),
(59887,'enUS','My spirit is lifted with the sight of you, $c. We fight on two fronts.$B$BWe\'re trying to push back the yaungol horde at the gate. And up on the mountain to the north, we\'ve lost the Shado-Pan Monastery to unknown forces.','',26124),
(59888,'enUS','You attack me like this, $p? What a puny plan!','',26124),
(59889,'enUS','Time for big BA BAM!!','',26124),
(59893,'enUS','Ungh... the banner is yours.','',26124),
(59894,'enUS','What the? Who?!','',26124),
(59895,'enUS','I took your dead master\'s banner. Come at me, $r!','',26124),
(59896,'enUS','Ya can\'t let anyone through, mon. Or it\'s ya\' head.','Ya can\'t let anyone through, mon. Or it\'s ya\' head.',26124),
(59897,'enUS','How \'da preparations comin\', mon?','How \'da preparations comin\', mon?',26124),
(59898,'enUS','Grook \'em!','',26124),
(59899,'enUS','We gork big dooker!','',26124),
(59900,'enUS','We grooked!','',26124),
(59901,'enUS','AHHHHHHH!','',26124),
(59902,'enUS','Run wikket!','',26124),
(59903,'enUS','Save wikket!','',26124),
(59904,'enUS','Dey comin, dey comin!','Dey comin, dey comin!',26124),
(59905,'enUS','... dey bettah be.','... dey bettah be.',26124),
(59906,'enUS','My spear will finish you!','',26124),
(59907,'enUS','Cower at the sight of your own doom!','',26124),
(59908,'enUS','','Hey, $n, over here. We need your help.',26124),
(59909,'enUS','This bad. This real bad.','',26124),
(59910,'enUS','There\'s nothing like a good cup of kafa! When the seeds are roasted just right, ground fresh, and brewed in pure water.$B$BPerfect for the weary traveler or studious monk.','',26124),
(59911,'enUS','What was I thinking! Such a luckydont!','',26124),
(59912,'enUS','Nope... nope... not good.','',26124),
(59913,'enUS','Shoulda never fed them goots.','',26124),
(59914,'enUS','','Hey! You here to challenge me to a fight?',26124),
(59915,'enUS','Let\'s fight!','Let\'s fight!',26124),
(59916,'enUS','I look forward to our melee. Of course, I plan to win.','',26124),
(59917,'enUS','','I\'ve been training really hard! There\'s no way you can defeat me now, $n.',26124),
(59918,'enUS','I\'m very interested in seeing your fighting style, $c.','',26124),
(59919,'enUS','','Hey there, sweetie. You\'re lookin\' pretty good in all that fancy armor.$b$bSo you\'ve found the way of the Red Crane, too? Interested in a duel?',26124),
(59920,'enUS','You will not find many jinyu here in the Cradle of Chi-Ji. In fact, I believe I may be the only one.$b$bIn general, my people shun Chi-Ji and his teachings. The crane dines on carp, after all.','',26124),
(59921,'enUS','','Thelonius has told me much about your skill in battle. I look forward to seeing it firsthand.',26124),
(59922,'enUS','','Hello, rival.$b$bI\'ve been busy training.$b$bI hope you\'ve done the same.',26124),
(59923,'enUS','Tukka-Tuk gonna punch you and pound you and kick you and scratch you and bite you and poke you and ook you and dook you and...','',26124),
(59924,'enUS','Howdy, neighbor.$b$bI heard a lot about you. You been winnin\' duels all over this here island. I suppose I\'m ready to give you a shot.','',26124),
(59925,'enUS','Nobody can defeat me.$b$bI\'ve been on this island for weeks, fighting duels every day, and nobody\'s come close to winning.$b$bIs this the best Pandaria has to offer?','',26124),
(59926,'enUS','You\'ve faced the best of our trainees, and defeated them all. Now let\'s see what you\'re really made of...','',26124),
(59927,'enUS','It is me again. It is good to see you, $n.$b$bShall we begin?','',26124),
(59928,'enUS','It is a rare and auspicious day when I get to test my abilities.$b$bI think you are ready to fight me, $n. Let us find out if I am correct.','',26124),
(59929,'enUS','','The path of the Red Crane is a path of failure. I have seen the truth!$b$bAll paths lead to despair! You have no hope! NONE OF YOU!!',26124),
(59930,'enUS','Are you here for a fight?','Are you here for a fight?',26124),
(59931,'enUS','','Alright, my first fight!',26124),
(59932,'enUS','Prepare for the beating of your life, weakling!','',26124),
(59933,'enUS','','Today is the day I defeat my rival!',26124),
(59934,'enUS','I apologize in advance for the beating you are about to suffer.','',26124),
(59935,'enUS','','YAAAAAAAAHHHH!!!',26124),
(59936,'enUS','Your winning streak ends here, $n. Today, you fall by my spear.','',26124),
(59937,'enUS','','I will not hold back on you, $n. Please, do me the same favor.',26124),
(59938,'enUS','','Just give up! It\'s hopeless! You\'ll never beat me!',26124),
(59939,'enUS','Good idea! Let\'s ookin\' get it on!','',26124),
(59940,'enUS','Don\'t rule me out be just \'cause I\'m a country boy! I got freakish strong arms, you know.','',26124),
(59941,'enUS','<sigh>...Let\'s get this over with.','',26124),
(59942,'enUS','By the name of Chi-Ji, I smite you down!','',26124),
(59943,'enUS','Give me everything you have, $n.','',26124),
(59944,'enUS','Ha ha! Don\'t pull any punches!','',26124),
(59945,'enUS','','My hated rival... so glad you came.',26124),
(59946,'enUS','You stand no chance.','You stand no chance.',26124),
(59947,'enUS','','Alright, $p... we are now RIVALS. You haven\'t seen the last of me.',26124),
(59948,'enUS','I am... humbled.','',26124),
(59949,'enUS','','I lost to $p, twice in a row? I can\'t believe it.',26124),
(59950,'enUS','Very interesting...','',26124),
(59951,'enUS','','Nice moves, sweetie. Maybe I\'ll see you again...',26124),
(59952,'enUS','My father foresaw this day in the waters. He told me that I would be defeated, but I refused to believe it.','',26124),
(59953,'enUS','','It\'s been a while since I lost to a trainee. Thank you for the match.',26124),
(59954,'enUS','','How did... I don\'t... no, no NO! NOT AGAIN!',26124),
(59955,'enUS','Tukka-Tuk pretty sad about losing to wimpy $p. Tukka-Tuk gonna go look at horizon and think about life.','',26124),
(59956,'enUS','Nice moves. You keep reapin\' in those wins like grain, neighbor. I\'ll be rootin\' for you.','',26124),
(59957,'enUS','Now THAT\'S what I was looking for! You\'ve given me a reason to train again.','',26124),
(59958,'enUS','Impossible...','',26124),
(59959,'enUS','Yes... yes, I believe you will do. I will see you again shortly, $p.','',26124),
(59960,'enUS','The taste of defeat... so strange and unfamiliar. Thank you for keeping me humble.','',26124),
(59961,'enUS','','N-no...',26124),
(59962,'enUS','Well fought. Until next time...','Well fought. Until next time...',26124),
(59963,'enUS','Trolls... I thought they were but legend!','',26124),
(59964,'enUS','Steer!','',26124),
(59965,'enUS','$n, with the crane\'s powers, you can jump over the flames!','',26124),
(59966,'enUS','Stop! Turn back and speak to Sinan at the bottom of the stairs. You should not face the Warlord\'s wrath alone!','',26124),
(59967,'enUS','Wait. I got here as quickly as I could. I\'m not too late, I hope.','',26124),
(59968,'enUS','It is not much, but I will lend you what little I have. May it help you in this final hour.','',26124),
(59973,'enUS','Video of leaving the turtle and traveling to Stormwind via hot air balloon.','Video of leaving the turtle and traveling to Stormwind via hot air balloon.',26124),
(59974,'enUS','Video of leaving the turtle and traveling to Orgrimmar via hot air balloon.','Video of leaving the turtle and traveling to Orgrimmar via hot air balloon.',26124),
(59975,'enUS','Watch my weapon: TIGER WIND!','',26124),
(59976,'enUS','Here it comes: TIGER WIND!','',26124),
(59977,'enUS','Are you ready?! TIGER WIND!','',26124),
(59978,'enUS','Whirling death: TIGER WIND!','',26124),
(59979,'enUS','Pick up those spears before they overload! Throw them back at him!','',26124),
(59980,'enUS','Give in to your anger!','',26124),
(59981,'enUS','The Vale was once the seat of power of the great mogu empire. The time of the mogu reign was terrible, cruel, and bloody.','',26124),
(59982,'enUS','Please rest while you are here, $n. I hope the Vale brings you much peace and happiness.','',26124),
(59983,'enUS','Oh good, a $g hero : heroine; of the land. Come, let us speak, $c.','',26124),
(59984,'enUS','You must seek out Shado-Master Zhen if you\'re to aid us here, $c.','',26124),
(59985,'enUS','Our hearts are heavy with grief at the passing of master Zhen. Will you face Humongous to regain his honor, $n?','',26124),
(59986,'enUS','The keg bombs are ready. $n, are you going to stop the yaungol?','',26124),
(59987,'enUS','The $g hero : heroine; returns triumphant. How are you, $n?','',26124),
(59988,'enUS','You\'re lucky I haven\'t fought in a while, $p.','',26124),
(59989,'enUS','%s goes into a |cFFFF0000|Hspell:116982|h[Protective Frenzy]|h|r!','',26124),
(59990,'enUS','','Hey, $c, over here!',26124),
(59991,'enUS','','Those spearthrowers are still firing. Don\'t you like destroying stuff, $c?',26124),
(59992,'enUS','','Go get \'em, tiger!',26124),
(59993,'enUS','','See you there, $n!',26124),
(59994,'enUS','Hope you\'re ready for a bruising, $n.','',26124),
(59995,'enUS','','Hi, $n! Going to join me?',26124),
(59996,'enUS','','These yaungol thought the sha were scary until they met me!',26124),
(59997,'enUS','','There\'s nothing better than working up a sweat with a good fight!',26124),
(59998,'enUS','','Once, I brained an opponent who was stunned to see that my pants had fallen down during battle. He wasn\'t looking where he should have been.',26124),
(59999,'enUS','','Bouncy, bouncy!',26124),
(60000,'enUS','','I\'ve lost count of the yaungol I\'ve killed. How many have you gotten, $n?',26124),
(60001,'enUS','','Don\'t let Maikee know, but I kinda love him even if he is a grump.',26124),
(60002,'enUS','You there! Be you friend or foe?','',26124),
(60003,'enUS','What? Are you too good to help us out here?','',26124),
(60004,'enUS','The Alliance has lost control of the Diamond Depot!','',26124),
(60005,'enUS','The Horde has lost control of the Diamond Depot!','',26124),
(60006,'enUS','The Alliance has taken control of the Diamond Depot!','',26124),
(60007,'enUS','I thought you were going to hit them. You roll that keg like you\'re new, or something.','',26124),
(60008,'enUS','The |cFFFF0000Horde|r has taken control of the Diamond Depot!','',26124),
(60009,'enUS','The Alliance has lost control of the Lava Depot!','',26124),
(60010,'enUS','The |cFFFF0000Horde|r has lost control of the Lava Depot!','',26124),
(60011,'enUS','The Alliance has taken control of the Lava Depot!','',26124),
(60012,'enUS','The |cFFFF0000Horde|r has taken control of the Lava Depot!','',26124),
(60013,'enUS','The Alliance has lost control of the Troll Depot!','',26124),
(60014,'enUS','The |cFFFF0000Horde|r has lost control of the Troll Depot!','',26124),
(60015,'enUS','The Alliance has taken control of the Troll Depot!','',26124),
(60016,'enUS','About time. We\'re starting to run out of kegs here.','',26124),
(60017,'enUS','The |cFFFF0000Horde|r has taken control of the Troll Depot!','',26124),
(60018,'enUS','The Alliance has lost control of the Waterfall Depot!','',26124),
(60019,'enUS','The |cFFFF0000Horde|r has lost control of the Waterfall Depot!','',26124),
(60020,'enUS','The Alliance has taken control of the Waterfall Depot!','',26124),
(60021,'enUS','The |cFFFF0000Horde|r has taken control of the Waterfall Depot!','',26124),
(60022,'enUS','Hrmph.','',26124),
(60023,'enUS','What are you doing back here? Slumming?','',26124),
(60024,'enUS','What\'s that Leesa Li going on about? Love?!','',26124),
(60025,'enUS','Oh, it\'s you.','',26124),
(60026,'enUS','Meh.','',26124),
(60027,'enUS','Someone should finish these yaungol off. I\'ve got better things to do than stand around here all day!','',26124),
(60028,'enUS','Just the other day I saw a much more powerful $c flying overhead.','',26124),
(60029,'enUS','Hey, Leesa. You\'re $g boyfriend\'s : girlfriend\'s; here!','',26124),
(60030,'enUS','The Eastern Crossroads changed tracks!','',26124),
(60031,'enUS','The Eastern Crossroads changed tracks!','',26124),
(60032,'enUS','The Northern Crossroads changed tracks!','',26124),
(60033,'enUS','The Northern Crossroads changed tracks!','',26124),
(60035,'enUS','Your rage sustains me!','',26124),
(60036,'enUS','My wrath flows freely!','',26124),
(60037,'enUS','Your rage gives you strength!','',26124),
(60038,'enUS','You will not bury me again!','',26124),
(60039,'enUS','','Still clinging to the tailfeathers of Chi-Ji, and his idiotic notions of \"hope\"?',26124),
(60040,'enUS','','I will show you the meaning of despair... and I will drag this whole island down with me!',26124),
(60041,'enUS','I\'m such a luckydont! I ruined Uncle Keenbean\'s kafa trade!','',26124),
(60042,'enUS','You never shoulda fed dem goots, Cousin.','',26124),
(60043,'enUS','This is what happen when you get lazy.','',26124),
(60044,'enUS','Kafa good for grummles and pandaren - not good for goots and yetis and hozen. You should know that!','',26124),
(60045,'enUS','Hold on! This is gonna be a bumpy ride!','',26124),
(60046,'enUS','','And so our path lays before us. Speak to Master Shang Xi, he will tell you what comes next.',26124),
(60047,'enUS','The... village... dead...','',26124),
(60049,'enUS','I smell my luckydo! Oh please bring to me.','',26124),
(60050,'enUS','Help! They took my luckydo!','',26124),
(60051,'enUS','Heya, $n. Nice work here, chief.','',26124),
(60052,'enUS','What gives? You gotta get to that farm. Did Kiryn send you to do her work? She\'s so lazy!','',26124),
(60053,'enUS','You\'re helpin\' those farmers out, right, ace? We\'re countin\' on you to get us some grub.','',26124),
(60054,'enUS','Good to hear you got those farmers all squared away, chief. Now we gotta take care of some new business.','',26124),
(60055,'enUS','You gotta blow those oil rigs, $n. We don\'t want them stinky yaungol raining exploding fire kegs down on our heads!','',26124),
(60056,'enUS','The sound of those explosions was like music to my ears. Come here, $n. Give me a hug!','',26124),
(60057,'enUS','There $g he : she; is!','',26124),
(60058,'enUS','Hey, lookie here. It\'s $n!','',26124),
(60059,'enUS','What\'s next, $n? Gonna take on the whole yaungol army by yourself? You could do it, too!','',26124),
(60060,'enUS','Me and $n go way back. Ain\'t that right, $n?','',26124),
(60061,'enUS','Yeah. I taught $n everything $g he : she; knows.','',26124),
(60062,'enUS','Between you and me, $n, these Kun-Lai guys are kinda slow. Nothin\' like us!','',26124),
(60063,'enUS','Hey you! Faster! Chop chop! Oh hey, hiya, $n. What\'s cookin\'?','',26124),
(60064,'enUS','Pay your respects. $n is in the house!','',26124),
(60065,'enUS','I cannot emphasize enough how important it is that you kill those channelers and bring that shield down, $n.','',26124),
(60066,'enUS','Good work, friend. Speak with Kiryn and Rivett while I assess our new surroundings.','',26124),
(60067,'enUS','Good. The shield is down. But what are you doing back here?','',26124),
(60068,'enUS','$n, please listen closely. You MUST go back to Ordo Ragemesa and kill their chief.','',26124),
(60069,'enUS','Is that a smile on your face? Are you about to tell me that the Ordo Warbringer is dead?','',26124),
(60070,'enUS','Good to see you, $n.','',26124),
(60071,'enUS','What word do you bring from the rest of Kun-Lai Summit?','',26124),
(60072,'enUS','If there were one thing that you could tell me that would make today better, $n, it would be that Taylor is dead.','',26124),
(60073,'enUS','One of these days we\'re going to have to talk about you joining my group, $n.','',26124),
(60074,'enUS','You sticking around for a while? We should drink.','',26124),
(60075,'enUS','You know, you could just head over to Westerly Rest and kill all of those Alliance fools.','',26124),
(60076,'enUS','I heard that the Shado-Pan were having trouble to the southwest. Know anything about that, $n?','',26124),
(60077,'enUS','I\'m getting fat and lazy just standing around here. I need some action!','',26124),
(60078,'enUS','Can you survive? TIGER BOMB!','',26124),
(60079,'enUS','Deadly attack: TIGER BOMB!','',26124),
(60080,'enUS','Death from above: TIGER BOMB!','',26124),
(60081,'enUS','Special attack: TIGER BOMB!','',26124),
(60082,'enUS','Couldn\'t have done better myself, my $g boy : girl;! Now, let\'s get down to business.','',26124),
(60083,'enUS','You already head o\'er to that farmstead? We\'re gonna run out of food here real quick, $g boyo : girlie;.','',26124),
(60084,'enUS','Word is yer doin\' a fine job, $g lad : lass;. A fine job. I only ask that you finish up down there at the farm as soon as you can. We\'ve got some pretty hungry folks \'round here.','',26124),
(60085,'enUS','Excellent work down there. Top notch. Now I\'ve got some other matters for ya if\'n your thinkin\' your up to some more skullbashin\'?','',26124),
(60086,'enUS','You \'n me both know that those oil rigs ain\'t gonna blow themselves to smithereens. Well... they might, but it\'d be more fun if you did the deed, $n.','',26124),
(60087,'enUS','Get o\'er here and give Sully a big ol\' hug, you scrapper! Them oil rigs went boom, one, two three! Ahahahahahaha!','',26124),
(60088,'enUS','Here we go!','Here we go!',26124),
(60089,'enUS','Here I come!','Here I come!',26124),
(60090,'enUS','There $g he : she; is! Oh, yer my favorite $g lad : lass;, yes you are, $n!','',26124),
(60091,'enUS','Raise your weapon, $r! Let\'s fight!','Raise your weapon, $r! Let\'s fight!',26124),
(60092,'enUS','I\'ve never seen a finer $c than $n, and neither have you!','',26124),
(60093,'enUS','%s cries softly to himself.','',26124),
(60094,'enUS','Glory to Chi-Ji!','Glory to Chi-Ji!',26124),
(60095,'enUS','You\'ve got yourself a duel, $c.','You\'ve got yourself a duel, $c.',26124),
(60096,'enUS','Now look who\'s here. Heya, $n, bring us a pint and get o\'er here!','',26124),
(60097,'enUS','Come on! Let\'s brawl!','Come on! Let\'s brawl!',26124),
(60098,'enUS','I tell ya, ten years from now everyone will be talkin\' about the time that ol\' Sully the Pickle and $n lit a fire right under those stinkin\' yaungol\'s noses and blew their oil rigs to kingdom come!','',26124),
(60099,'enUS','I get all teary eyed just thinkin\' about all we been through together, $g boyo : lass;.','',26124),
(60100,'enUS','These Kun-Lai pandaren are comin\' along just fine. Now if they\'d only show a little more of that scrappiness that you seem to be full of.','',26124),
(60101,'enUS','What\'s this I hear \'bout trouble to the west at Firebough Nook?','',26124),
(60102,'enUS','Oh sure, bein\' a nurse is fine and all for fixin\' folk up after all the hard work\'s been done.  Don\'t let that Mishka fool ya.','',26124),
(60103,'enUS','','$n, a moment of your time, please? There\'s trouble that we need your help with.',26124),
(60104,'enUS','','Have you been able to investigate Mogujia? Please don\'t tell me that little pickle dwarf has you running off somewhere else. Can\'t he do his own dirty work?',26124),
(60105,'enUS','','Good news about Mogujia, $n?',26124),
(60106,'enUS','|TInterface\\Icons\\spell_frost_summonwaterelemental.blp:20|t|cFF00AEEF $n has assaulted the Waterfall Depot!|r','',26124),
(60107,'enUS','|TInterface\\Icons\\spell_frost_summonwaterelemental.blp:20|t|cFFFF0000$n has assaulted the Waterfall Depot!|r','',26124),
(60108,'enUS','','You do plan on taking care of that troll, yes?  He is the one reanimating all of those mogu, no?',26124),
(60109,'enUS','','It\'s so nice to no longer be hearing that troll go on and on! Thank you, $n!',26124),
(60110,'enUS','|TInterface\\Icons\\spell_frost_summonwaterelemental.blp:20|t|r|cFF00AEEF$n has defended the Waterfall Depot!|r','',26124),
(60111,'enUS','','I\'m so worried about those poor captured pandaren. Have you had a chance yet to see what condition they\'re in, $n?',26124),
(60112,'enUS','|TInterface\\Icons\\spell_frost_summonwaterelemental.blp:20|t|cFFFF0000$n has defended the Waterfall Depot!|r','',26124),
(60113,'enUS','','Oh, $n, you did it! It warms my heart to see the pandaren families reuniting.',26124),
(60114,'enUS','','It is good to see you again, $n. How have you fared?',26124),
(60115,'enUS','|TInterface\\Icons\\inv_waepon_bow_zulgrub_d_01.blp:20|t|cFF00AEEF$n has assaulted the Troll Depot!|r','',26124),
(60116,'enUS','|TInterface\\Icons\\inv_waepon_bow_zulgrub_d_01.blp:20|t|cFF00AEEF$n has Defended the Troll Depot!|r','',26124),
(60117,'enUS','|TInterface\\Icons\\inv_waepon_bow_zulgrub_d_01.blp:20|t|cFFFF0000$n has assaulted the Troll Depot!|r','',26124),
(60118,'enUS','|TInterface\\Icons\\inv_waepon_bow_zulgrub_d_01.blp:20|t|cFFFF0000$n has defended the Troll Depot!|r','',26124),
(60119,'enUS','','Your prowess as a $c is unquestionable.',26124),
(60120,'enUS','','Do you have any news from afar, $n? Has the war against the yaungol finally been won?',26124),
(60121,'enUS','','Admiral Taylor and I were just speaking about you. How are you, $n?',26124),
(60122,'enUS','','$n, if you have the time later, perhaps you and I could sit and talk over tea?',26124),
(60123,'enUS','|TInterface\\Icons\\inv_misc_gem_diamond_04.blp:20|t|cFF00AEEF$n has assaulted the Diamond Depot!|r','',26124),
(60124,'enUS','','You look remarkably well, $n. I\'m exhausted. A healer\'s work is never done.',26124),
(60125,'enUS','|TInterface\\Icons\\inv_misc_gem_diamond_04.blp:20|t|cFFFF0000$n has assaulted the Diamond Depot!|r','',26124),
(60126,'enUS','','We hear so many conflicting stories about what\'s happening just out of sight. Tell me, $n, is it as bad as it sounds?',26124),
(60127,'enUS','|TInterface\\Icons\\inv_misc_gem_diamond_04.blp:20|t|cFF00AEEF$n has Defended the Diamond Depot!|r','',26124),
(60128,'enUS','','I feel much safer with a $c like you around.',26124),
(60129,'enUS','|TInterface\\Icons\\inv_misc_gem_diamond_04.blp:20|t|cFFFF0000$n has defended the Diamond Depot!|r','',26124),
(60130,'enUS','|TInterface\\Icons\\spell_shaman_lavaflow:20|t|cFF00AEEF$n has assaulted the Lava Depot!|r','',26124),
(60131,'enUS','|TInterface\\Icons\\spell_shaman_lavaflow:20|t|cFFFF0000$n has assaulted the Lava Depot!|r','',26124),
(60132,'enUS','|TInterface\\Icons\\spell_shaman_lavaflow:20|t|cFF00AEEF$n has Defended the Lava Depot!|r','',26124),
(60133,'enUS','|TInterface\\Icons\\spell_shaman_lavaflow:20|t|cFFFF0000$n has defended the Lava Depot!|r','',26124),
(60134,'enUS','Another job well done, friend. You should see if Mishka and Sully need you?','',26124),
(60135,'enUS','Ordo Ragemesa is right on our border, $n. I need you to bring that shield down now or we\'re lost.','',26124),
(60136,'enUS','My scouts tell me that you brought the shield down. I\'m confused as to why you\'re back here instead of up there killing their leader.','',26124),
(60137,'enUS','There\'s no time to waste, $n. My intel tells me that the yaungol are about to launch an all-out last ditch assault. We\'re all counting on you to kill Chief Ragemesa.','',26124),
(60138,'enUS','You have no idea how happy I am right now. If you were one of my officers, you\'d be getting a promotion!','',26124),
(60139,'enUS','$n! How are you? I hear things from here and there about your heroics.','',26124),
(60140,'enUS','Pull up a chair, $n. I could use the company.','',26124),
(60141,'enUS','$n, what\'s this I hear about trouble at the Gate of Winter\'s Blossom? Are we looking at a second yaungol invasion even bigger than the first?','',26124),
(60142,'enUS','You know what would be the cherry on top today? Nazgrim dead.','',26124),
(60143,'enUS','If you ask me, you should round up a bunch of your friends and burn Easterly Rest to the ground, $n.','',26124),
(60144,'enUS','Have you been to Shado-Pan Retreat or Firebough Nook yet, $n? I heard about trouble brewing there with the sha.','',26124),
(60145,'enUS','$n! What else have you been up to out there? Let me give you a word of advice; don\'t accept a promotion that\'ll take you out of the action.','',26124),
(60146,'enUS','So, $n, you have a near perfect track record. Tell me, how do you feel about the Navy?','',26124),
(60147,'enUS','Welcome to the Cradle of Chi-Ji, friend.','',26124),
(60148,'enUS','Welcome back to the Cradle of Chi-Ji, friend! I am glad to see that you\'ve returned.','',26124),
(60149,'enUS','Our new challenger returns! Welcome, $n.','',26124),
(60150,'enUS','Welcome back, $n. I\'ve been eagerly anticipating your return.','',26124),
(60151,'enUS','It\'s an honor, $n. Welcome back to the Cradle of Chi-Ji.','',26124),
(60152,'enUS','Hail, Champion of Chi-Ji! Your presence honors us, $n.','',26124),
(60153,'enUS','Are you ready to face your next challenger?','',26124),
(60154,'enUS','I have no more trials for you today, $n. Return to us again soon.','',26124),
(60155,'enUS','This is the hallowed birthplace of Chi-Ji, the Red Crane, the Southern Celestial. Followers and acolytes of Chi-Ji gather in this place to train their bodies, to hone their minds, to duel one another, and to better themselves in the eyes of the Red Crane.$b$bYou are welcome to join us in our training, $c. Bring with you a stout heart and a stout staff.','',26124),
(60156,'enUS','I see.','I see.',26124),
(60157,'enUS','What is this place?','What is this place?',26124),
(60158,'enUS','Entering defensive mode.  Disabling output failsafes.','',26124),
(60159,'enUS','Yes, YES! Bring your rage to bear! Try to strike me down!','',26124),
(60160,'enUS','Wikkets did this!','',26124),
(60161,'enUS','All your fault!','',26124),
(60162,'enUS','Jib them in the nib!','',26124),
(60163,'enUS','Oooooooook you!','',26124),
(60164,'enUS','Jib in snibbets!','',26124),
(60165,'enUS','Take all of the nibs!','',26124),
(60166,'enUS','Wikkets gonna hurt!','',26124),
(60167,'enUS','[PH] Troll Boss unleashes a |cffcc00ffCursed Voodoo Hex!|r [PH]','',26124),
(60168,'enUS','[PH] Troll Boss unleashes a |cff996300Diseased Voodoo Hex!|r [PH]','',26124),
(60169,'enUS','[PH] Troll Boss unleashes a |cff0033ffMagical Voodoo Hex!|r [PH]','',26124),
(60170,'enUS','[PH] Troll Boss unleashes a |cff00b300Poisonous Voodoo Hex!|r [PH]','',26124),
(60171,'enUS','[PH] Troll Boss unleashes a |cffcc00ffCursed,|r |cff996300Diseased Voodoo|r |cffcc00ffHex!|r [PH]','',26124),
(60172,'enUS','[PH] Troll Boss unleashes a |cff0033ffMagical,|r |cff00b300Poisonous Voodoo|r |cff0033ffHex!|r [PH]','',26124),
(60173,'enUS','What the-?','',26124),
(60174,'enUS','Impossible!','',26124),
(60175,'enUS','UNF!','',26124),
(60176,'enUS','Excellent move!','',26124),
(60177,'enUS','Look, pretty girl, look! The nice $r brought some kafa treats for you!','',26124),
(60178,'enUS','I think it\'s working...','',26124),
(60179,'enUS','AAAAGHHHHH!!!!','',26124),
(60180,'enUS','No! I\'ve lost focus on the torch!','',26124),
(60181,'enUS','Must... regain... control...','',26124),
(60182,'enUS','Welcome to Anglers Wharf $r.  Feel free to take a look around, there is much an angler can learn here.','Welcome to Anglers Wharf $r.  Feel free to take a look around, there is much an angler can learn here.',26124),
(60183,'enUS','This spell will speed you up in the water.  Just in case you run into a shark!','This spell will speed you up in the water.  Just in case you run into a shark!',26124),
(60184,'enUS','They seem to be biting pretty good today.','They seem to be biting pretty good today.',26124),
(60185,'enUS','Here fishy, fishy fishy...','Here fishy, fishy fishy...',26124),
(60186,'enUS','An orb of |cFFF00000|Hspell:117227|h[Corrupted Water]|h|r forms!','',26124),
(60187,'enUS','Yea, sure. There\'s supposed\'ta be big forest here. Druids, all that. Big whoop, it\'s time for my break.','Yea, sure. There\'s supposed\'ta be big forest here. Druids, all that. Big whoop, it\'s time for my break.',26124),
(60188,'enUS','','Ji, stop! This is reckless and stupid.',26124),
(60189,'enUS','Aysa, this is our only option. We blow the ship free, then we heal his wound. We have no other solution.','',26124),
(60190,'enUS','','If you stop this, then maybe we can come up with one.',26124),
(60191,'enUS','So we just wait until we think of something? Shen-zin Su is dying! Doing nothing risks everything!','',26124),
(60192,'enUS','','Doing THIS risks everything!',26124),
(60193,'enUS','I\'d rather die knowing that at least we tried.','',26124),
(60194,'enUS','','Ji... if this is what you must do, I will not stop you, but we could lose everything. I hope you\'re right.',26124),
(60196,'enUS','We\'re... we\'re alive!','',26124),
(60197,'enUS','<The massive yeti looks at you expectantly.>','',26124),
(60198,'enUS','<Unscrew the flask and offer it to her.>','<Unscrew the flask and offer it to her.>',26124),
(60199,'enUS','A brew sure would be nice right now.','A brew sure would be nice right now.',26124),
(60200,'enUS','Got one!','Got one!',26124),
(60201,'enUS','I had it!  Must have been a huge one to take all my bait!','I had it!  Must have been a huge one to take all my bait!',26124),
(60202,'enUS','Lots of nibbles today, but not many bites.','Lots of nibbles today, but not many bites.',26124),
(60203,'enUS','','This is reckless, even for Ji. I need to stop him. Are you coming?',26124),
(60204,'enUS','Let\'s go.','Let\'s go.',26124),
(60205,'enUS','Okay... I think... I can stand...','',26124),
(60206,'enUS','I... is the ground shaking?','',26124),
(60207,'enUS','The first group that came - the Trolls... they cared nothing for us - walked right past us, pushing our families out of the way.\n\nThe next, though - the mercenaries. They took us prisoner, stole from our homes, and threatened us with death if we resisted.','',26124),
(60209,'enUS','Perhaps we should have resisted - because, despite the fact that we... I... allowed them to take what they wanted, they killed us anyways.','',26124),
(60210,'enUS','Or, they killed most of us. I was the village\'s healer - after they ran me through, I was able to apply enough of my medical skills to keep me alive... but barely.','',26124),
(60211,'enUS','','Aysa sighs.',26124),
(60212,'enUS','We should return... I am sure my skills will be needed at my cousin\'s village. And... we must prepare a funeral for those we have lost.','',26124),
(60213,'enUS','All right. Let us make haste to the village!','',26124),
(60214,'enUS','Cousin! You are well?','',26124),
(60215,'enUS','Yes, cousin. But... the village.','',26124),
(60216,'enUS','I... understand. Come, we must talk.','',26124),
(60217,'enUS','Thank you, $r. It would be my honor to fight at your side.','',26124),
(60218,'enUS','Just what I was waiting for! Time to introduce those yaungol to my fists!','',26124),
(60219,'enUS','I\'m in your debt, stranger. Please let me help you.','',26124),
(60220,'enUS','Thank you for freeing me, $Gbrother:sister;. I cannot let you fight alone.','',26124),
(60221,'enUS','Any luck today?','Any luck today?',26124),
(60222,'enUS','Nope.  How about you?','Nope.  How about you?',26124),
(60224,'enUS','Just a few nibbles.  Hoping for a bite soon!','Just a few nibbles.  Hoping for a bite soon!',26124),
(60225,'enUS','I knew someone would come for us! Let me help you fight the yaungol.','',26124),
(60226,'enUS','$n caused the Darkness.','',26124),
(60227,'enUS','Ha! Let\'s see if you can figure this out!','',26124),
(60228,'enUS','Mirror... IMAGE!','',26124),
(60229,'enUS','Thank you, $r. I can find my way back on my own.','',26124),
(60230,'enUS','I\'m in your debt, stranger. Thank you.','',26124),
(60231,'enUS','Thank you for freeing me, $Gbrother:sister;. I could not have survived another day of the yaungol\'s cruelty.','',26124),
(60232,'enUS','I was prepared for death. Now... you have given me another chance.','',26124),
(60233,'enUS','Have you seen the yaungol fighting each other? It seems their troubles run deeper than we thought.','',26124),
(60234,'enUS','Have you seen the yaungol fighting each other? It seems their troubles run deeper than we thought.','',26124),
(60235,'enUS','What do you stare at, stranger?','',26124),
(60236,'enUS','I will not die like this. Not like this!','',26124),
(60237,'enUS','Go away and leave me be. Let me suffer in peace.','',26124),
(60238,'enUS','They did not have to die...$B$BThe village to the south... my home, my family! They killed them all!$B$BIf only I had been stronger. I could have saved them!','',26124),
(60239,'enUS','I should have won. I was stronger. Wiser. I would have won against him!','',26124),
(60240,'enUS','Outsider! Ally of the Shado-Pan.$B$B<The old yaungol spits out the strange words bitterly.>$B$BCome closer if you wish me to break your neck!','',26124),
(60241,'enUS','<The old yaungol stares at you with hatred in his eyes.>','',26124),
(60242,'enUS','You! You killed my brothers! You spilled their blood on the sacred ground of my ancestors!$B$BIf I were not chained, I would kill you now!$B$B<The old yaungol collapses from his outburst, breathing heavily.>','',26124),
(60243,'enUS','The Energy Vortex is active!','',26124),
(60244,'enUS','Can you figure out which is real?!','',26124),
(60245,'enUS','How did you... figure... it out...','',26124),
(60246,'enUS','Ha! Fooled you!','',26124),
(60247,'enUS','The Energy Vortex is powering up!','',26124),
(60248,'enUS','Thank you for the help. I\'ll go help with the wound.','Thank you for the help. I\'ll go help with the wound.',26124),
(60249,'enUS','Help! Sprites swarm!','',26124),
(60250,'enUS','The mogu are preparing for something big. We\'ve got to stop them from getting ahold of any more ancient weapons.','',26124),
(60251,'enUS','<Mishi looks at you inquisitively.>','',26124),
(60252,'enUS','I\'m ready to leave.','I\'m ready to leave.',26124),
(60253,'enUS','Who dares to challenge me?','',26124),
(60254,'enUS','Welcome, friend, to the Grummle Bazaar!','',26124),
(60255,'enUS','Most grummles keep a few luckydos about.$b$bLook, lint in pocket. Big luckydo. Oh, and smelly incense. Very big luckydo.$b$bNever trust unsmellible luck. Sometimes that is luck for someone else.','',26124),
(60256,'enUS','Some argue Brother Rabbitsfoot has more good fortune than I, the Lucky Eightcoins.$b$bAt this I laugh.$b$bIt is simple: he is called \"brother\", I am called \"Lucky\". Obviously I am of more luck.','',26124),
(60257,'enUS','Never set a yeti on fire. They just get mad.','',26124),
(60258,'enUS','','I hear you are the reason my cousin Syra is sending me wedding invitations.$b$bThanks a lot. Now I have to be the unmarried black yak of the family.',26124),
(60259,'enUS','Not running this time, Jung Duk?','',26124),
(60260,'enUS','Where are your lackeys, great chief? They cannot help you this time!','',26124),
(60261,'enUS','Deceit is no match for true strength! This one is more powerful than you!','',26124),
(60262,'enUS','Ahahahaha! More than filth like you deserved.','',26124),
(60263,'enUS','$C... you must be the one that\'s been helping these pitiful mistlurkers.','',26124),
(60264,'enUS','That\'s enough!','',26124),
(60265,'enUS','I have enough torches to erase all three of you!','',26124),
(60266,'enUS','If you refuse to bend to the torch, you will die to the torch!','',26124),
(60267,'enUS','No...','',26124),
(60268,'enUS','You\'re next, small one!','',26124),
(60269,'enUS','Too... strong...','',26124),
(60270,'enUS','There\'s another mistlurker here... I can smell his stink.','',26124),
(60271,'enUS','Don\'t think I can\'t see you back there, hiding in the shadows...','',26124),
(60272,'enUS','You resist the power of the torch... why won\'t you die, beast?','',26124),
(60273,'enUS','Because my will...','',26124),
(60274,'enUS','...the will of my people...','',26124),
(60275,'enUS','...is stronger than yours.','',26124),
(60276,'enUS','No... NO!','',26124),
(60277,'enUS','The elements shield me!','',26124),
(60278,'enUS','There\'s a broken world that could use your help, my student. Have you decided who you would like to accompany in your journey?','',26124),
(60279,'enUS','I\'m ready to decide.','I\'m ready to decide.',26124),
(60280,'enUS','I know a secret trail through Neverrest. Add three days to any journey, but you see very neat waterfall along way. Most fortunate path.','',26124),
(60281,'enUS','Good fortune to drink coffee before a hike. Bad fortune to drink after.','',26124),
(60282,'enUS','Rabbitsfoot and Eightcoins argue over who has more luck. Those silly grummles forget that nothing is more lucky than finding lint in your pocket.','',26124),
(60283,'enUS','A clean yak is a lucky yak. A dirty yak is a yeti attack.','',26124),
(60284,'enUS','Luck is like lady grummle: hard to find but worth the search.','',26124),
(60285,'enUS','When counting past 3, continue to 5. Never stop at 4. Most bad fortune for those who stop on four.','',26124),
(60286,'enUS','Grummles know all roads through mountains. But some grummles know better roads than others.','',26124),
(60287,'enUS','Most bad fortune with big hozen ravage. Makes for bad travels.','',26124),
(60288,'enUS','You are on the wrong side of this battle, $r. You side with savage beasts!','',26124),
(60289,'enUS','Gol... goss...','',26124),
(60290,'enUS','Must fight Osul now. Must stop hatred.','',26124),
(60291,'enUS','So hungry...  Mmm! YOU!','',26124),
(60292,'enUS','|TInterface\\Icons\\ability_warrior_stalwartprotector.blp:20|t%s casts |cFFFF0000|Hspell:117910|h[Flanking Orders]|h|r!','',26124),
(60293,'enUS','%s lets out a long, drawn out sigh.','',26124),
(60294,'enUS','It was not always like this.$b$bThe Osul were not our enemies. They lived beside us. We assisted one another.','',26124),
(60295,'enUS','If I am going to die, I will die with my friends by my side.$b$bI will die knowing I did everything I could to avenge my people.$b$bI will die staring directly into the shamed face of my enemy.','',26124),
(60296,'enUS','There is much to be done.','',26124),
(60297,'enUS','As soon as all of our reinforcements arrive, we will begin pushing further south.','',26124),
(60298,'enUS','I would never ask a stranger to take on the duties of a Shado-Pan, but neither will I refuse help from a skilled $c.$B$BThis place is dangerous, $r. If you insist on staying, then I will gladly accept your help.','',26124),
(60299,'enUS','','We should take action! While our leaders waggle their tongues, I could have slain ten yaungol.',26124),
(60300,'enUS','','Ban is a great strategist, but he fails to see the most obvious solution.',26124),
(60301,'enUS','','Finally we are taking action! Something we should have done days ago.',26124),
(60302,'enUS','','Do you see Lin down there? There are so many prisoners, but I cannot spot my husband.',26124),
(60303,'enUS','Welcome, $r.','',26124),
(60304,'enUS','Suna\'s thoughts are colored by worry for her husband.','',26124),
(60305,'enUS','Suna and I do not always agree, but I always respect her opinion.','',26124),
(60306,'enUS','The mantle of a commander is a heavier burden than I had expected.','',26124),
(60307,'enUS','Sigh... she has always been this way. Proud, decisive, and always right.$B$BIn twenty years, I have not yet won an argument.$B$BWhy have I not yet learned my lesson?','',26124),
(60308,'enUS','','Lord Taran, our foothold here is secure. We should take the first opportunity to attack.',26124),
(60309,'enUS','','We already have them on the defensive. Even as we speak, their numbers weaken.',26124),
(60310,'enUS','','I do not! YOU are the one who forgets my husband is one of the captives.',26124),
(60311,'enUS','','Of course we need a sound strategy. But why cut off an arm when you can strike at the heart?',26124),
(60312,'enUS','I disagree. We cannot underestimate the yaungol\'s strength.','',26124),
(60313,'enUS','As do ours. Do you not see the number of our injured? Do you forget how many have been taken prisoner?','',26124),
(60314,'enUS','But how much blood must be shed? There are both clever ways and foolish ways.','',26124),
(60315,'enUS','Settle down, you two. We have much to do, and getting Lin out alive is one of our top priorities.','',26124),
(60316,'enUS','Go on, $n. Pull it out. You will not be held accountable for my death, when it comes.','',26124),
(60317,'enUS','The yaungol have shamed my people.$b$bThey will soon know the true meaning of shame.','',26124),
(60318,'enUS','<Remove the spear from Orbiss\' side.>','<Remove the spear from Orbiss\' side.>',26124),
(60319,'enUS','There is a situation to the south that requires my immediate attention.','',26124),
(60320,'enUS','When you are finished with your duties, report to Ban Bearheart. I am leaving him in command for the duration of the mission here.','',26124),
(60321,'enUS','I will see you again, soon.','',26124),
(60322,'enUS','Come, friends. Glory awaits us.','',26124),
(60323,'enUS','Protect Golgoss!','',26124),
(60324,'enUS','Protect Arconiss!','',26124),
(60325,'enUS','The mists are now leaving my body. I will remain in this world as long as I can. As long as it takes.','',26124),
(60326,'enUS','We... did it...','',26124),
(60327,'enUS','','We should attack them now, Ban, while their eyes are set upon the gates of Kun-Lai.',26124),
(60328,'enUS','','Have you forgotten that they are holding my husband prisoner? Time is running out!',26124),
(60329,'enUS','','But Lin is down there!',26124),
(60330,'enUS','','He should have chosen me. Those who take the greatest risks achieve the greatest victories.',26124),
(60331,'enUS','','We would not lose.',26124),
(60332,'enUS','','And you cling to caution as if it will save you. Did your caution save your brother?',26124),
(60333,'enUS','','Why did he have to die, Ban? I never told him how I felt.',26124),
(60334,'enUS','Lord Taran Zhu just departed with the majority of our soldiers. Attacking now would be foolish.','',26124),
(60335,'enUS','Patience, Suna. I share your desire to stop the yaungol. But I must consider every soldier, not just your husband.','',26124),
(60336,'enUS','Lower your voice. It\'s no wonder Taran did not pick you for command. You take too many risks.','',26124),
(60337,'enUS','We will save him, Suna. I promise.','',26124),
(60338,'enUS','And the greatest losses.','',26124),
(60339,'enUS','You throw caution to the wind.','',26124),
(60340,'enUS','What happened to Lin, it was no one\'s fault.','',26124),
(60341,'enUS','He is gone. We must all move on.','',26124),
(60342,'enUS','I\'m heading to the wound. Try to keep these beasts off of me.','I\'m heading to the wound. Try to keep these beasts off of me.',26124),
(60343,'enUS','You\'re a life-saver. I\'ll do everything I can to heal the wound.','You\'re a life-saver. I\'ll do everything I can to heal the wound.',26124),
(60344,'enUS','I thought I was done for. Thank you!','I thought I was done for. Thank you!',26124),
(60345,'enUS','If all pandaren are like you, I think you may have made some new allies!','If all pandaren are like you, I think you may have made some new allies!',26124),
(60346,'enUS','You handle the beasts, we\'ll handle the wound.','You handle the beasts, we\'ll handle the wound.',26124),
(60347,'enUS','Keep these creatures off of us while we perform our healing.','Keep these creatures off of us while we perform our healing.',26124),
(60348,'enUS','I\'d stand with you any day.','I\'d stand with you any day.',26124),
(60349,'enUS','','Tcha! Why did Taran leave you in charge? You would have us cower in our bedsheets until the yaungol break down our very doors!',26124),
(60350,'enUS','|TInterface\\Icons\\ability_warrior_bloodbath.blp:20|t%s begins to cast |cFFFF0000|Hspell:117948|h[Annihilate]|h|r!','',26124),
(60351,'enUS','The ground rumbles underneath you...','',26124),
(60352,'enUS','It\'s an ambush! Defend yourself!','',26124),
(60353,'enUS','About time you showed up, $r!','About time you showed up, $r!',26124),
(60354,'enUS','Reinforcements have arrived! Come $r, lend us a hand!','Reinforcements have arrived! Come $r, lend us a hand!',26124),
(60355,'enUS','Oh good, a $c who looks like $Ghe:she; knows $Ghis:her; way around a battlefield.','Oh good, a $c who looks like $Ghe:she; knows $Ghis:her; way around a battlefield.',26124),
(60356,'enUS','Help us drive the yaungol back, $r!','Help us drive the yaungol back, $r!',26124),
(60357,'enUS','Don\'t be shy, $c. Plenty of yaungol to go around!','Don\'t be shy, $c. Plenty of yaungol to go around!',26124),
(60358,'enUS','<Mishi surveys the valley apprehensively.>','',26124),
(60359,'enUS','I bear your presence only as a kindness to our new allies. Don\'t push me, human.','',26124),
(60360,'enUS','What is Kota Kon doing here?!$B$B...And why she wearing an adorable little bow?','',26124),
(60361,'enUS','You know, I think that yeti appreciates good kafa more than most people. And she has\'t eaten a single grummle since you brought her down from the peak!','',26124),
(60362,'enUS','WHAT HAVE I DONE?! WE\'RE ALL DEAD!!','',26124),
(60363,'enUS','I don\'t know... still got a bad feeling about this yeti being here...$B$BSometimes I catch her just... staring at me.','',26124),
(60364,'enUS','<The pandaren was recently stripped, beaten, and broken. His body is still growing cold.>','',26124),
(60365,'enUS','','It\'s working! The wound is closing!',26124),
(60366,'enUS','Elegon begins to reactivate the Engine of Nalak\'sha.','',26124),
(60367,'enUS','Examine the body.','Examine the body.',26124),
(60368,'enUS','Look for idols south of here at the Deeper and Camp Broketooth.','',26124),
(60369,'enUS','Good, you have lit the incense.','',26124),
(60370,'enUS','Can you not feel it? Your sprits lifting?','',26124),
(60371,'enUS','You see, what you have done is a tribute to a truth we Pandaren hold most dear.','',26124),
(60372,'enUS','Like Shaohao, we know our ultimate destiny is to become one with the land. Nothing truly meets an end.','',26124),
(60373,'enUS','None of us approaches death with joy - but neither should we feel fear, nor anger, nor doubt.','',26124),
(60374,'enUS','Though these Pandarens - my friends - have died, we know that through their sacrifice, and your noble works, Pandaria lives on.','',26124),
(60375,'enUS','Though we may die, from our passing blossoms new life. This is the truth that we live, work, and die for.','',26124),
(60376,'enUS','Do you see? From their graves, trees grow. May these trees always stand for the sacrifice they made, and the honor you have done them.','',26124),
(60377,'enUS','Thank you, friend. You are truly a hero.','',26124),
(60378,'enUS','Ha ha! Here comes the luckydo! I saw the idols explode from here.','',26124),
(60379,'enUS','Let\'s go find this engineer.  Maybe getting this thorn removed won\'t be as hard as we thought.','',26124),
(60380,'enUS','Hurry north! Find my Brother Yakshoe before the hozen do something bad to him.','',26124),
(60381,'enUS','','NOOO!',26124),
(60382,'enUS','','Lin, heart of my heart! No, please, NO! It cannot be!',26124),
(60383,'enUS','','If only I had come sooner! If only Ban had listened to me!',26124),
(60384,'enUS','','Shhhhhh, my sweet darling, sleep now and be at peace.',26124),
(60385,'enUS','','Your killers will not go unpunished.',26124),
(60386,'enUS','','I will see to that.',26124),
(60387,'enUS','Woohoo! And they say the Yakshoe is not a luckydo! Many thanks for the rescue.','',26124),
(60388,'enUS','If you have a ranged weapon, use it to shoot down ropes that hold grummles up.','',26124),
(60389,'enUS','They told me that this would be a training mission. I feel like it is turning into something more.','',26124),
(60390,'enUS','Did you see Lord Taran Zhu earlier? His prowess is legendary.','',26124),
(60391,'enUS','Ready to smash some hozens, girl?','Ready to smash some hozens, girl?',26124),
(60392,'enUS','Lord Taran spoke to me earlier! I hope I won\'t let him down.','',26124),
(60393,'enUS','Ah! Good fortune to one who times a rescue well.','',26124),
(60394,'enUS','Good fortune to friend of grummles!','',26124),
(60395,'enUS','Cage stink of bad fortune. Hozen stink of more bad fortune.','',26124),
(60396,'enUS','I need a better luckydo to make sure this not happen again.','',26124),
(60397,'enUS','Must... find... incense....','',26124),
(60398,'enUS','Many thanks!','',26124),
(60399,'enUS','Maybe I call myself $psfoot from now on.','',26124),
(60400,'enUS','It Kota Kon!!','',26124),
(60401,'enUS','We gonna put you in the Dooker Dome!','',26124),
(60402,'enUS','','My husband was taken prisoner by the yaungol several days ago.$B$BHe is in danger as we speak.',26124),
(60403,'enUS','What the ooks a Kota Kon doin\' here?!','',26124),
(60404,'enUS','','I\'m afraid I\'m of little use right now, $n.$B$BI am sick with worry for my husband.',26124),
(60405,'enUS','','I cannot stand by idly while Lin is in danger.',26124),
(60406,'enUS','','No, no, no. Lin, my dear husband. You can\'t be gone.',26124),
(60407,'enUS','Ookin wikket! Get back here!','',26124),
(60408,'enUS','','He was so cold. So limp and lifeless.',26124),
(60409,'enUS','','I told him! I told Ban we needed to strike! This is all his fault!',26124),
(60410,'enUS','','He said goodbye just a few days ago. I can still see his face! How can he be dead?',26124),
(60411,'enUS','I feel am deeply sorry for Lin\'s loss, but I must think of every soldier in my army.$B$BEach life is precious, and must be valued equally.$B$BI could not gamble the lives of many to save that of one.','',26124),
(60412,'enUS','Kota wikkets gettin\' ravaged next!','',26124),
(60413,'enUS','We did well here.','',26124),
(60414,'enUS','Kota Kon bigger than me thought she\'d be...','',26124),
(60415,'enUS','I am happy with our success at Osul Peak. I consider this a successful campaign.','',26124),
(60416,'enUS','We will have much good news to report to Lord Taran.$B$BNews of our victory here at Osul Peak will ring gladly in his ears.','',26124),
(60417,'enUS','I would say that my first command here was quite the success.','',26124),
(60418,'enUS','Can\'t smash us all!','',26124),
(60419,'enUS','Our victory here was much thanks to you, $n.','',26124),
(60420,'enUS','Meet us at Dooker Dome. We need to find some incense and a dirty yak.','',26124),
(60421,'enUS','For the Chief!','',26124),
(60422,'enUS','<He clutches a handkerchief with the initials, S.S.>','',26124),
(60423,'enUS','We have only sustained a few minor casualties. Otherwise, I would say that things are going quite well.','',26124),
(60424,'enUS','We will make sure to honor Lin\'s courage.','',26124),
(60425,'enUS','My first command has been more difficult than I anticipated. Did I make the right decision?','',26124),
(60426,'enUS','Wikkets think hozen weak!','',26124),
(60427,'enUS','We got a yeti, ookers! You hear me! We got a yeti!','',26124),
(60428,'enUS','Ookin wikkets gonna get fed to Chomp Chomp!','',26124),
(60429,'enUS','Wikkets don\'t want hozen to take their munchpacks! But hozen are gonna take! Ravage!','',26124),
(60430,'enUS','','<Suna rocks back and forth, staring into space. She does not answer.>',26124),
(60431,'enUS','Take all of the things!','',26124),
(60432,'enUS','Ravage! Ravage! Ravage!','',26124),
(60433,'enUS','War is a word that has not been spoken in Pandaria for a long time.$B$BNow, we must all fight... to restore peace.','',26124),
(60434,'enUS','Knucklethumps gonna rule the Kun-Lai!','',26124),
(60435,'enUS','Oh boy. Luckydo don\'t fail me now.','',26124),
(60436,'enUS','FEAR THE MONKEY!','',26124),
(60437,'enUS','Perhaps... I was a bit too... optimitistic about my condition...','',26124),
(60438,'enUS','Good, another $c has come to join the fight!','Good, another $c has come to join the fight!',26124),
(60439,'enUS','Hey, we\'ve got our hands full here, $r! Come lend a hand!','Hey, we\'ve got our hands full here, $r! Come lend a hand!',26124),
(60440,'enUS','This isn\'t the last of them! $C, help us drive them back!','This isn\'t the last of them! $C, help us drive them back!',26124),
(60441,'enUS','The Alliance has taken control of a Mine Cart!','',26124),
(60442,'enUS','The Horde has taken control of a Mine Cart!','',26124),
(60443,'enUS','','Ban is to blame for this. That old, blind fool.',26124),
(60444,'enUS','A %s has arrived from the center depot.','',26124),
(60445,'enUS','I feel... at peace.','',26124),
(60446,'enUS','Shut up, Katak!','',26124),
(60447,'enUS','Wake... up... DANGIT!','',26124),
(60448,'enUS','This is ridiculous...','',26124),
(60449,'enUS','You sleep like a rock!','',26124),
(60450,'enUS','There\'s no way you\'ll sleep through THIS.','',26124),
(60451,'enUS','Seriously?','',26124),
(60452,'enUS','Why...','',26124),
(60453,'enUS','won\'t...','',26124),
(60454,'enUS','you...','',26124),
(60455,'enUS','just...','',26124),
(60456,'enUS','WAKE UP?!','',26124),
(60457,'enUS','I will break you, little rock man!','',26124),
(60458,'enUS','Hah! Waking this guy is no easy feat! I\'ve hit him, I\'ve tried to pull him over with a rope, I\'ve thrown my body into this gong, and nothing! $B$BAh well, I\'ve got more ideas to get started on.','',26124),
(60459,'enUS','I always figure we should be taught not to wait for inspiration to start a thing. Action always generates inspiration. Inspiration rarely generates action.$B$BSuch is the way of the Huojin.','',26124),
(60460,'enUS','And there we have it, just add water! Wish I would have thought of that one a little sooner.','',26124),
(60461,'enUS','Much of the cover of this book has been destroyed. What is still visible appears to be in Trollish...','',26124),
(60462,'enUS','This page must have been dropped by one of the looters. Lorewalker Cho will know what it says.','',26124),
(60463,'enUS','The altar is still warm from a recent ritual...','',26124),
(60464,'enUS','No! Wikkets stole my Chomp Chomp!','',26124),
(60465,'enUS','[PH] This is a placeholder visual, don\'t bug me.','',26124),
(60466,'enUS','Slip-an-die! Dooker!','',26124),
(60467,'enUS','You... bunch... of... dookers!','',26124),
(60468,'enUS','OW! OW! OW! OW!','',26124),
(60469,'enUS','Keenbean Kafa Co. is in real trouble!','',26124),
(60470,'enUS','The air crackles as a |cFFF00000|Hspell:118077|h[Lightning Storm]|h|r forms!','',26124),
(60471,'enUS','|TInterface\\Icons\\ability_rogue_dismantle.blp:20|t%s casts |cFFFF0000|Hspell:118047|h[Pillage]|h|r!','',26124),
(60472,'enUS','Are you ready to fight, $c?','',26124),
(60473,'enUS','As soon as you stop yapping...','As soon as you stop yapping...',26124),
(60474,'enUS','They fought over their food supplies. It looks like rather than sharing their food, someone destroyed it all. Why would they do that?','',26124),
(60475,'enUS','From what I can tell, there were no sides in this fight. Why would the yaungol kill each other in a free-for-all?','',26124),
(60476,'enUS','It\'s the yaungol chief, slain just like the rest. Seems that he could not keep order in the final fight.','',26124),
(60477,'enUS','Can you defeat my Double Claw Xuen Style?','',26124),
(60478,'enUS','','I do not like this place, $r. There is something strange about it.',26124),
(60479,'enUS','','Something about this village makes my fur stand on end.',26124),
(60480,'enUS','','We will not rest until our duties here are done.',26124),
(60481,'enUS','I show you on your map where grummles are now. Find them or wait here for next wave of grummles.','',26124),
(60482,'enUS','Thank you, $n. I have much to report to Ban. I think I can find my way back from here.','',26124),
(60483,'enUS','So, friends... how are we going to find the hidden master?','',26124),
(60484,'enUS','','The marmots get mad if they see you ruining their holes. Just nudge them out of the way first, and they\'ll leave you alone.',26124),
(60485,'enUS','Such little things you are. May this challenge fortify your strength!','',26124),
(60486,'enUS','Why we not eating carrot?','',26124),
(60487,'enUS','I just notice funny-looking carrot!','',26124),
(60488,'enUS','Carrot grow right in front of us!','',26124),
(60489,'enUS','Carrot? For US?!?!','',26124),
(60490,'enUS','Look, look! Weird, bumpy carrot!','',26124),
(60491,'enUS','We so lucky.','',26124),
(60492,'enUS','Good things happen to us today.','',26124),
(60493,'enUS','Carrots never bad!','',26124),
(60494,'enUS','It... perfect.','',26124),
(60495,'enUS','I trust it.','',26124),
(60496,'enUS','Stop talk, start eat!','',26124),
(60497,'enUS','Something funny about carrot...','',26124),
(60498,'enUS','Wait, wait. You smell... turnip...?','',26124),
(60499,'enUS','Something fishy here...','',26124),
(60500,'enUS','I just going to bite without even looking!','',26124),
(60501,'enUS','[PH]Troll Boss unleashes a Voodoo Hex![PH]','',26124),
(60503,'enUS','','Hey! Watch where you\'re splashing that $g thing, big guy!:thing!;',26124),
(60504,'enUS','','What, we\'re done already!?',26124),
(60505,'enUS','','Are you sure you don\'t want to keep wading in this gross water?',26124),
(60506,'enUS','','Maybe we can find some more weird, splashy bottles to fill with mud.',26124),
(60507,'enUS','','My favorite part was when you splashed muddy water in my eyes.',26124),
(60508,'enUS','','I\'m being sarcastic, by the way.',26124),
(60509,'enUS','The orbs have appeared!','',26124),
(60510,'enUS','The orb has been returned!','',26124),
(60511,'enUS','Infinite energy, unbound!','',26124),
(60512,'enUS','Nothing shall stop the engine of creation!','',26124),
(60513,'enUS','The Energy Vortex is powering down! Get off the platform!','',26124),
(60514,'enUS','The Energy Vortex is inactive!','',26124),
(60515,'enUS','The Energy Vortex begins to shut down.','',26124),
(60516,'enUS','The Engine of Nalak\'sha begins to self destruct!','',26124),
(60517,'enUS','So, you\'re a homebrewer?','So, you\'re a homebrewer?',26124),
(60518,'enUS','Yup. Been brewin\' beer since I could drink it.$b$bSome folks say I\'m wastin\' my time, that I could just buy the beer that comes out o\' that big ol\' brewery down yonder, but... I dunno. There\'s somethin\' right nice about brewin\' your own mug of ale.','',26124),
(60519,'enUS','Is Mudmug your real name?','Is Mudmug your real name?',26124),
(60520,'enUS','Aw, heck no. That\'s just how I make my beer.$b$bMuddy water, you see... it\'s got little bugs in it, that ferment your ale for you. Some folks use real yeast, grown in a fancy brewery under controlled conditions and what have you. I use muddy water.$b$bIt\'s kind of my thing.$b$bI guess I\'m just not what you\'d call \"cultured\".','',26124),
(60521,'enUS','Ha ha.','Ha ha.',26124),
(60522,'enUS','Greetin\'s! And, ah... salutations, I suppose.$b$bSorry. Not quite sure what to say. I\'m not used to havin\' much in the way of company around here.$b$bThat is, not unless they\'re here to buy some o\' my brew, of course.','',26124),
(60523,'enUS','[PH] Are you ready to fight?','[PH] Are you ready to fight?',26124),
(60524,'enUS','[PH] I\'m ready to fight!','[PH] I\'m ready to fight!',26124),
(60525,'enUS','I... think I will be safe, for now, thanks to you.','',26124),
(60526,'enUS','','Now! Let us see what darkness corrupts this place!',26124),
(60527,'enUS','','$n, help me by activating the three large totems.',26124),
(60528,'enUS','','Good luck!',26124),
(60529,'enUS','','Follow me. We will use these totems to purify the earth.',26124),
(60530,'enUS','','I win? Yay!',26124),
(60531,'enUS','','I guess he\'s somewhere in this forest?',26124),
(60532,'enUS','','It doesn\'t look very friendly in there. Maybe I should just...',26124),
(60533,'enUS','','No! I\'ve come too far to give up!',26124),
(60534,'enUS','','Whaa.... What\'s happening?!?',26124),
(60535,'enUS','I have a rule: anybody who calls me handsome gets free beer.','',26124),
(60536,'enUS','The machine hums to life!  Get to the lower level!','',26124),
(60537,'enUS','|TInterface\\Icons\\ability_rogue_envelopingshadows.blp:20|t%s casts |cFFFF0000|Hspell:117506|h[Undying Shadows]|h|r!','',26124),
(60538,'enUS','|TInterface\\Icons\\warrior_talent_icon_furyintheblood:20|t%s casts |cFFFF0000|Hspell:117708|h[Maddening Shout]|h|r!','',26124),
(60539,'enUS','The Ancient Mogu Machine breaks down! |cFFFF0000|Hspell:116779|h[Titan Gas]|h|r floods the room!','The Ancient Mogu Machine breaks down! |cFFFF0000|Hspell:116779|h[Titan Gas]|h|r floods the room!',26124),
(60540,'enUS','The Ancient Mogu Machine goes into overdrive! |cFFFF0000|Hspell:116779|h[Titan Gas]|h|r floods the room!','The Ancient Mogu Machine goes into overdrive! |cFFFF0000|Hspell:116779|h[Titan Gas]|h|r floods the room!',26124),
(60541,'enUS','The defense of Stoneplow is more important than you may know.$b$bIf the mantid take Stoneplow, they may as well take this entire valley. Beyond this wall, there is nothing to stop them from sweeping through the entirety of Pandaria.','',26124),
(60542,'enUS','The mantid are attacking, and we are shamefully unprepared.$b$bUnder normal circumstances, our enemy is quite predictable. We anticipated that the next full-scale mantid attack would hit in about ten years, as they do so regularly every hundred.$b$bThis current invasion is hardly \"full-scale\", but it\'s still strong enough to catch a farming village unawares. Had my Shado-Pan not been keeping such a watchful vigil on the wall, Stoneplow might have already fallen.','',26124),
(60543,'enUS','Yes. The defense of Stoneplow currently rests on me, Guard-Captain Oakenshield, and three others of our order. As we speak, those three Shado-Pan are standing at the foot of the wall, waiting to defend against the next wave of attackers. This is our charge - to protect Pandaria from the enemies that the common people have all but forgotten about.$b$bWhile our numbers here in Stoneplow are few, we do not expect reinforcements from Kun Lai... unless this situation gets worse. Say, for example, if that weak spot in the wall crumbled.','',26124),
(60544,'enUS','A few days past, I saw a bolt of dark energy crackling through the ground from my tower vigil. It came from the west, fracturing the wall, and very nearly breaking through it entirely.$b$bYou can still see the scars it left. It ruined these farmers\' land.$b$bThe mantid scouts followed shortly after. Whether they\'ve had this attack planned or they\'re just capitalizing on an opportunity, I couldn\'t say. Maybe they\'re running away from whatever caused the crack in the first place.','',26124),
(60545,'enUS','What is happening here?','What is happening here?',26124),
(60546,'enUS','Shado-Pan?','Shado-Pan?',26124),
(60547,'enUS','What happened to the wall, anyway?','What happened to the wall, anyway?',26124),
(60548,'enUS','I understand.','I understand.',26124),
(60549,'enUS','I spent my life on that wall, $n. I gave up everything I had to become Shado-Pan, to prevent something like this from happening.$b$bI have failed.','',26124),
(60550,'enUS','For everything you have done, $n... you have our gratitude.','',26124),
(60551,'enUS','Hello.','',26124),
(60552,'enUS','','Are you seeing all this stuff? This place is great!',26124),
(60553,'enUS','','Thanks for taking me out exploring with you, $n.',26124),
(60554,'enUS','','I can\'t believe Uncle Chen would rather sit down and drink beer than walk around and explore this place!',26124),
(60555,'enUS','','Because Uncle Chen made me promise not to!$b$bListen. Chen may be a stupid, boring, lazy, fat old uncle, but that doesn\'t mean that I don\'t respect him. He told me not to get into any trouble, and I\'m not about to ignore him.$b$bBesides, you seem to be doing just fine on your own. You don\'t need a little girl to help you kill things.',26124),
(60556,'enUS','Why aren\'t you helping me fight things?','Why aren\'t you helping me fight things?',26124),
(60557,'enUS','Wind is my ally!','',26124),
(60558,'enUS','I await a challenger.','',26124),
(60559,'enUS','Ah... a challenge.','',26124),
(60560,'enUS','Fight well, and with honor.','',26124),
(60561,'enUS','A $c? Most engaging.','',26124),
(60562,'enUS','Friend, I come to help. We will show Shai Hu to his grave!','',26124),
(60563,'enUS','I am here to help you defeat the poisoner of my people!','',26124),
(60564,'enUS','We shall crush Shai Hu, together!','',26124),
(60565,'enUS','When these creatures die, they explode... I know, kill them near Shai Hu!','',26124),
(60567,'enUS','Augh! Their deaths hurt us, but they will hurt him, too! Bring them close to him!','',26124),
(60568,'enUS','I need another Totem of Harmony.','I need another Totem of Harmony.',26124),
(60569,'enUS','Wh-what came over me?','Wh-what came over me?',26124),
(60570,'enUS','I felt... so much hatred...','I felt... so much hatred...',26124),
(60571,'enUS','Thank you for freeing me of that horrible burden.','Thank you for freeing me of that horrible burden.',26124),
(60572,'enUS','What? Suddenly, I feel at peace...','What? Suddenly, I feel at peace...',26124),
(60573,'enUS','Thank you, friend. I could not escape the sha\'s grip on my own.','Thank you, friend. I could not escape the sha\'s grip on my own.',26124),
(60574,'enUS','Was that... the sha? I wanted to rip everyone to shreds!','Was that... the sha? I wanted to rip everyone to shreds!',26124),
(60575,'enUS','I... what happened? I feel much calmer now.','I... what happened? I feel much calmer now.',26124),
(60576,'enUS','The sha had me in its grasp? I had not even realized it until now...','The sha had me in its grasp? I had not even realized it until now...',26124),
(60577,'enUS','...and that is what happened in the brewery.','',26124),
(60578,'enUS','I am ready to begin the ritual.','I am ready to begin the ritual.',26124),
(60579,'enUS','Your hatred overwhelms you!','Your hatred overwhelms you!',26124),
(60580,'enUS','Destroying the pipes leaks |cFFFF0000|Hspell:116779|h[Titan Gas]|h|r into the room!','Destroying the pipes leaks |cFFFF0000|Hspell:116779|h[Titan Gas]|h|r into the room!',26124),
(60581,'enUS','YOUR RAGE! I FEED ON YOUR RAGE!','',26124),
(60582,'enUS','WHAT IS THIS?! THEIR RAGE... IT BURNS ME...','',26124),
(60583,'enUS','NO! IT CANNOT BE! YOU CAN NOT STOP ME!','',26124),
(60584,'enUS','I... feel something. Is it... peace?','',26124),
(60585,'enUS','You feel hatred boiling up inside you.','You feel hatred boiling up inside you.',26124),
(60586,'enUS','Your hatred intensifies! Control it now!','Your hatred intensifies! Control it now!',26124),
(60587,'enUS','Gonna set wikkets up the boom boom!','',26124),
(60588,'enUS','Wikkets gonna face the Boom Boom!','',26124),
(60589,'enUS','Wikkets gonna fail. I got a box full of boom booms!','',26124),
(60590,'enUS','Doom doom from the boom boom!','',26124),
(60591,'enUS','Time for the Boom Boom Boogaloo!','',26124),
(60592,'enUS','Boogaloo of the boom boom!','',26124),
(60593,'enUS','Boom boom for you!','',26124),
(60594,'enUS','Wikkets can\'t survive the Boom Boom Boogaloo!','',26124),
(60595,'enUS','Time for the Boom Box!','',26124),
(60596,'enUS','Master Boom Boom ready to boom up some wikkets!','',26124),
(60597,'enUS','Munchies and crunchies for most happy sale. You buy?','',26124),
(60598,'enUS','Enough! Off to de spirit world wit\' ya!','',26124),
(60599,'enUS','','A challenge in compassion and humility. By helping Merchant Lorvo, it would seem you\'ve passed, $c. Master Shang would be pleased.',26124),
(60600,'enUS','You have conquered every challenge I put before you, $n. You have found Huo and brought him safely to the temple.','',26124),
(60601,'enUS','There is a much larger problem we face now, my students. Shen-zin Su is in pain. If we do not act, the very land on which we stand could die, and all of us with it.','',26124),
(60602,'enUS','We need to speak to Shen-zin Su and discover how to heal it. And to do that, we need the four elemental spirits returned. Huo was the first.','',26124),
(60603,'enUS','Ji, I\'d like you to go to the Dai-Lo Farmstead in search of Wugou, the spirit of earth.','',26124),
(60604,'enUS','Aysa, I want you to go to the Singing Pools to find Shu, the spirit of water.','',26124),
(60605,'enUS','And $n, you shall be the hand that guides us all. Speak with me for a moment before you join Aysa at the Singing Pools to the east.','',26124),
(60606,'enUS','On it!','',26124),
(60607,'enUS','','Yes master.',26124),
(60608,'enUS','Welcome, Huo. The people have missed your warmth.','',26124),
(60609,'enUS','Let\'s tackle this one together!','',26124),
(60610,'enUS','I like the way you fight!','',26124),
(60611,'enUS','He had that one coming.','',26124),
(60612,'enUS','Ouch! That one looked painful!','',26124),
(60613,'enUS','You make this look easy.','',26124),
(60614,'enUS','They never stood a chance.','',26124),
(60615,'enUS','You\'ve got this handled.','',26124),
(60616,'enUS','I need to fight by you more often.','',26124),
(60617,'enUS','All done! Let\'s get back and see if Aysa\'s come up with anything during her meditation. [Removed?]','',26124),
(60618,'enUS','See you at the dock!','',26124),
(60619,'enUS','Let\'s do this, monkeyface!','',26124),
(60620,'enUS','That all you\'ve got?!','',26124),
(60621,'enUS','This monkey\'s about to get slapped!','',26124),
(60622,'enUS','And he\'s down for the count! Good going.','',26124),
(60623,'enUS','','Stand down, tauren, before I put you back in chains.',26124),
(60624,'enUS','','We have men in that wreckage! Get more men out there recovering the wounded.',26124),
(60625,'enUS','','We need more healers at the tents. Recall the priests from the west.',26124),
(60626,'enUS','Over here, $p! We need help!','',26124),
(60627,'enUS','','We risked everything, but we did it. Shen-zin Su will be okay.',26124),
(60628,'enUS','','Master Shang Xi, I would like to accompany the Alliance back to their home.',26124),
(60629,'enUS','What of you, Ji? Will you join the Horde in their journey back?','',26124),
(60630,'enUS','Yes... perhaps that is for the best. I like what I\'ve seen of them, and it sounds as though their world could use my help.','',26124),
(60631,'enUS','And you, my young student? Where will you go?','',26124),
(60632,'enUS','You\'ve all accomplished a great thing in saving Shen-zin Su. You do us all proud.','',26124),
(60633,'enUS','It seems your journeys are not done. These new allies of ours come from a broken world that could use our help.','',26124),
(60634,'enUS','Time to face the wrath of the family staff!','',26124),
(60635,'enUS','Turo von Kuros!','',26124),
(60636,'enUS','Kalimaste!','',26124),
(60637,'enUS','Gokku-lai!','',26124),
(60638,'enUS','Lo-kal...','',26124),
(60639,'enUS','At last, $p, we get to face each other in battle!','',26124),
(60640,'enUS','Wow that hurt! Well fought, friend.','',26124),
(60641,'enUS','Who among you is ready to lose to the Bramblestaff?','',26124),
(60643,'enUS','','Has Ban sent you to kill me, then? Just like he killed my husband?',26124),
(60644,'enUS','','Your pitiful rituals are meaningless! I will not be saved!',26124),
(60645,'enUS','','Hatred gives me the strength to destroy you!',26124),
(60646,'enUS','','I see now... my hatred... consumed me. Tell Ban... all is... forgiven.',26124),
(60647,'enUS','Ahahaha... you pitiful weaklings!','',26124),
(60648,'enUS','Even your strongest warriors succumb like lambs to the slaughter.','',26124),
(60649,'enUS','Your turn will come. Hate, will turn you all against one another until this whole world burns.','',26124),
(60650,'enUS','','I surrender! You win.',26124),
(60651,'enUS','','This is going to be easier than a drinking contest with a grummle.',26124),
(60652,'enUS','','Choose your champion.',26124),
(60653,'enUS','Bah! Bested by de likes of you! What a shame for a Zandalari Priest ta endure.','',26124),
(60654,'enUS','But it ain\'t no ting. Take your trinkets; you\'ll be needin\' dem.','',26124),
(60655,'enUS','I be goin\' now; time ta find a new home for me soul.','',26124),
(60656,'enUS','Death be a doorway, an\' time a window; I\'ll be back! AH-HAHAHAHAHAH!','',26124),
(60657,'enUS','','Test your might!',26124),
(60658,'enUS','','Ready... FIGHT!',26124),
(60659,'enUS','','Round one... FIGHT!',26124),
(60660,'enUS','You go away!','',26124),
(60661,'enUS','This virmen land now, you go!','',26124),
(60662,'enUS','Go away!','',26124),
(60663,'enUS','','Defeated!',26124),
(60664,'enUS','','Victory!',26124),
(60665,'enUS','Need... better... healer....','',26124),
(60666,'enUS','Lousy... tank...','',26124),
(60667,'enUS','But... but... I needed that gear...','',26124),
(60668,'enUS','Ken-Ken... surrenders!','',26124),
(60669,'enUS','Well... done... champions.','',26124),
(60670,'enUS','The ancient machine goes haywire! All constructs become |cffFF0000|Hspell:118041|h[Overcharged]|h|r!','The ancient machine goes haywire! All constructs become |cffFF0000|Hspell:118041|h[Overcharged]|h|r!',26124),
(60671,'enUS','Elegon has arrived! PH','',26124),
(60672,'enUS','You know not what you have unleashed!','',26124),
(60673,'enUS','This machine will be your undoing. PH','',26124),
(60674,'enUS','Ah, you\'re here already? I\'m not quite finished with my preparations... and neither are you.$B$BHonor the shrines and come back to me - we mustn\'t disrespect the mountain in our haste.','',26124),
(60675,'enUS','Alright, we\'re ready to get started.','',26124),
(60676,'enUS','Just about done here...','',26124),
(60677,'enUS','Thank you, brave $c.','Thank you, brave $c.',26124),
(60678,'enUS','[PH] You are saved!','[PH] You are saved!',26124),
(60679,'enUS','Yes, well... it\'s not like Suna to run off by herself.','',26124),
(60680,'enUS','','Ban, you look worried.',26124),
(60681,'enUS','','She must be torn by grief over her husband\'s death.',26124),
(60682,'enUS','','That may be, but it was no one\'s fault.',26124),
(60683,'enUS','','You did what you thought was best. No commander has the foresight to see the future.',26124),
(60684,'enUS','Many thanks!','Many thanks!',26124),
(60685,'enUS','','You swore the Shado-Pan blood oath together, did you not? You are bound together by powers far stronger than hatred.',26124),
(60686,'enUS','','No, she cannot hate you. At least not forever. Hahahaha!',26124),
(60687,'enUS','','Ugh, what is that stench?',26124),
(60688,'enUS','','But this place reeks of death!',26124),
(60689,'enUS','She blames me, you know.','',26124),
(60690,'enUS','I should have taken the risk and sent the order to attack.','',26124),
(60691,'enUS','But now... she hates me.','',26124),
(60692,'enUS','I hope so, Yalia.','',26124),
(60693,'enUS','It\'s too quiet. We should check this out.','',26124),
(60694,'enUS','We stop here. Everyone out!','',26124),
(60695,'enUS','Yes. Suna\'s tracks stop here. We won\'t leave until we find her.','',26124),
(60696,'enUS','Look! Suna\'s tracks lead into the village ahead.','',26124),
(60697,'enUS','It looks like the site of... a massacre.','',26124),
(60698,'enUS','In this place? Are... are you sure?','',26124),
(60699,'enUS','Aaaack! Wikkets win! Just don\'t take my boom booms!','',26124),
(60700,'enUS','Look, I see some of Suna\'s things! She must have made camp here. But where is she?','',26124),
(60701,'enUS','I don\'t like the look of this place.','',26124),
(60702,'enUS','You don\'t think this place is... haunted... do you?','',26124),
(60703,'enUS','I don\'t want to know what happened here. It\'s too horrible to imagine.','',26124),
(60704,'enUS','Augh! Don\'t sneak up on a pandaren like that!','',26124),
(60705,'enUS','Is Suna really out there somewhere?','',26124),
(60706,'enUS','Hey $r, what do you make of this place?','',26124),
(60707,'enUS','I have never seen anything like this. Have you, $n?','',26124),
(60708,'enUS','Don\'t be frightened, $r. We will keep everyone safe.','',26124),
(60709,'enUS','The Wrestler is going to destroy the competition today.','',26124),
(60710,'enUS','Apparently a hozen found himself a crate of bombs and thinks he\'s a monk now.','',26124),
(60711,'enUS','I wonder who talked Xuen in to letting the sauroks compete. I like a good test of strength, but those creatures are just... so... angry.','',26124),
(60712,'enUS','You know, I saw the Wrestler\'s real face once. True story.','',26124),
(60713,'enUS','The binding should only take a moment, but I\'ll be completely entranced.','',26124),
(60714,'enUS','Watch my back - I trust you can handle any interruptions.','',26124),
(60715,'enUS','LOREWALKER! You have something of mine.','',26124),
(60716,'enUS','Clever, hiding out up here - using the elements to shield your tracks. But my quilen hounds could sense the Tongue even here.','',26124),
(60717,'enUS','Were you counting on this whelp to stop us? Hah!','',26124),
(60718,'enUS','All done. Did I miss anything?','',26124),
(60719,'enUS','Very well. Today... is your day...','',26124),
(60720,'enUS','|TInterface\\Icons\\spell_shaman_staticshock.blp:20|t%s begins to cast |cFFF00000|Hspell:117436|h[Lightning Prison]|h|r!','|TInterface\\Icons\\spell_shaman_staticshock.blp:20|t%s begins to cast |cFFF00000|Hspell:117436|h[Lightning Prison]|h|r!',26124),
(60721,'enUS','Go ahead with the binding, Cho.','Go ahead with the binding, Cho.',26124),
(60722,'enUS','','$n, it is dangerous out there. For your own safety, make use of the totem I gave you!',26124),
(60723,'enUS','Take me to Hellscream\'s Hope!','Take me to Hellscream\'s Hope!',26124),
(60724,'enUS','Unbelievable! This is the fabled Mogu\'shan Library!  Can you even imagine what we could learn from these vaults?','',26124),
(60725,'enUS','My precious $n! You\'ll pay for that!','',26124),
(60726,'enUS','What are you waiting for? Let\'s go investigate!','What are you waiting for? Let\'s go investigate!',26124),
(60727,'enUS','Take me to Wayward Landing, please.','Take me to Wayward Landing, please.',26124),
(60728,'enUS','Look here! It\'s the history of Zian of the Endless Shadow, a powerful sorcerer who kept the kingdoms in check through terror and darkness.','',26124),
(60729,'enUS','Bring me their heads!','',26124),
(60730,'enUS','Death to the Shado-Pan! Death to all Pandaren!','',26124),
(60731,'enUS','Forward, march, yaungol! Cowards will be executed!','',26124),
(60732,'enUS','Wikkets got boomed!','',26124),
(60733,'enUS','Yachi! Yao! Rip these fools to shreds!','',26124),
(60734,'enUS','Now Ken-Ken! Like we planned!','',26124),
(60735,'enUS','Remember, Xuen told us to work together.','',26124),
(60736,'enUS','We can do this!','',26124),
(60737,'enUS','We can win if we work together.','',26124),
(60738,'enUS','HO...ZEN...FU!','',26124),
(60739,'enUS','Ken-Ken\'s got this!','',26124),
(60740,'enUS','Pha! Ken-Ken doesn\'t need a jinyu to win.','',26124),
(60741,'enUS','Flee, craven villagers! This land belongs to nature alone once more!','',26124),
(60742,'enUS','Vengeful Hui has appeared in the Mason\'s Quarter, north of Greenstone Village. Challenge him!','',26124),
(60743,'enUS','Come on champ! Give Rok Rok a roar!','',26124),
(60744,'enUS','No! No no no! No more muffins for you! Muffins for closers!','',26124),
(60745,'enUS','[PH] CONGRATULATION - YOU ARE WINNER','',26124),
(60746,'enUS','Welcome, Challengers, to my Tournament of Strength!','',26124),
(60747,'enUS','Quest Objective Complete. *Click!*','',26124),
(60748,'enUS','','Be alert, $n! We are surrounded!',26124),
(60749,'enUS','','Finally, the sha has shown its face. Be careful!',26124),
(60750,'enUS','','If you are not careful, your own hatred could consume you.',26124),
(60751,'enUS','','We are not out of the woods yet.',26124),
(60752,'enUS','','It looks like we\'ve managed to quell the sha... for now.',26124),
(60753,'enUS','','I can hardly believe it. You were able to suppress your hatred.',26124),
(60754,'enUS','Go kid! Make with the punch!','',26124),
(60755,'enUS','Punch the luck out of that Wrestler!','',26124),
(60756,'enUS','Give him the chair!','',26124),
(60757,'enUS','My training has led to this point. I must not fail my brothers and sisters!','',26124),
(60758,'enUS','Is this the presence of the sha? It is far worse than my instructors ever described.','',26124),
(60759,'enUS','Don\'t let it grab you!','',26124),
(60760,'enUS','Make with more left right punch and runs!','',26124),
(60761,'enUS','The other rangers simply turned on one another.$B$BWe would have turned as well, but thanks to Yalia\'s quick thinking, we are safe.','',26124),
(60762,'enUS','We were all trained to strengthen our minds against the sha\'s influence, but it is stronger than we imagined.','',26124),
(60763,'enUS','Well, I survived my first encounter with the sha. It was more frightening than I had anticipated.','',26124),
(60764,'enUS','Next time I face the sha, I will be prepared.','',26124),
(60765,'enUS','Go go $pc luckydo!','',26124),
(60766,'enUS','The sha took us by surprise. Luckily, we had no casualties.','',26124),
(60767,'enUS','Wikket gonna eat lightning and derk thunder!','',26124),
(60768,'enUS','You can beat that $pr wikket!','',26124),
(60769,'enUS','Beat that wikket like it owes you money!','',26124),
(60770,'enUS','Jib that $pr in the dooker!','',26124),
(60771,'enUS','No no no! Jib! Then Jab!','',26124),
(60772,'enUS','','Taran and Ban are masters of strategy and logistics. I prefer fighting to planning.',26124),
(60773,'enUS','','Why do we continue to wait? They should make the order to attack!',26124),
(60774,'enUS','','My husband was captured by the yaungol several days ago. I cannot not rest until I see him safely returned.',26124),
(60775,'enUS','My death will not stop da storm that is coming! Da Thunder King will rise!','',26124),
(60776,'enUS','Can you help me find my amulet Mishi?','Can you help me find my amulet Mishi?',26124),
(60777,'enUS','Old Hat is the most good coach. $p would be a luckydo to listen to my advice.','',26124),
(60778,'enUS','<Mishi appears ready to leave.>','',26124),
(60779,'enUS','','Welcome, $c! Be sure to take a moment and enjoy the view!',26124),
(60780,'enUS','Have you noticed anything strange happening around Zouchin Village?','Have you noticed anything strange happening around Zouchin Village?',26124),
(60781,'enUS','Seeing scenery that beautiful really puts things into perspective.','',26124),
(60782,'enUS','I will not leave until we have located Suna.','',26124),
(60783,'enUS','It is not in our nature to shirk from danger. We will dive gladly into darkness if it means protecting our loved ones.','',26124),
(60784,'enUS','An unseen enemy is perhaps the most dangerous of all.','',26124),
(60785,'enUS','I will not leave until we have located Suna.','',26124),
(60786,'enUS','Stand your ground! We will drive the sha from this place!','',26124),
(60787,'enUS','The spirits are gone. The nightmare is over.','',26124),
(60788,'enUS','The color has just... left its body.','',26124),
(60789,'enUS','There\'s no doubt about it. These creatures have been affected by sha.','',26124),
(60790,'enUS','Look at the size of these! This one is definitely a breeding male.','',26124),
(60791,'enUS','That means the mantid queen is involved in this... somehow.','',26124),
(60792,'enUS','His body - it\'s covered with scars. Old scars.','',26124),
(60793,'enUS','Not just any scars, either. These were created by pandaren weapons.','',26124),
(60794,'enUS','Here it is! This is what we\'ve been looking for!','',26124),
(60795,'enUS','Yak hair.','',26124),
(60796,'enUS','This place makes me uneasy, but we Shado-Pan do not run from danger.','',26124),
(60797,'enUS','I heard the reclaimer\'s threat, but it was faint... Fleeting, like trying to recall the details of a dream.$B$BIt seems I\'m in your debt once again.','',26124),
(60798,'enUS','Mo Mo now has the grummle luck!','',26124),
(60799,'enUS','Stinky wikkets gonna get ravaged.','',26124),
(60800,'enUS','Mo Mo gonna be the luckiest of all hozen!','',26124),
(60801,'enUS','Nothing here. Keep moving.','',26124),
(60802,'enUS','Nothing on this one.','',26124),
(60803,'enUS','There\'s nothing here. Let\'s keep looking.','',26124),
(60804,'enUS','No... nothing of note here. Keep looking.','',26124),
(60805,'enUS','Poot Poot belongs to Cho Cho!','',26124),
(60806,'enUS','Here\'s something you might find interesting.','',26124),
(60807,'enUS','I have no need for this. Do you want it?','',26124),
(60808,'enUS','No clues here... but I did find this.','',26124),
(60809,'enUS','What\'s this?','',26124),
(60810,'enUS','The Glintrok Scout shouts a warning!','',26124),
(60811,'enUS','I hate to keep you here so distracted...','I hate to keep you here so distracted...',26124),
(60812,'enUS','','Who you supposed to be? Some kind of $c or something?',26124),
(60813,'enUS','','Fizzy yellow beer is for wussies and grummles.',26124),
(60814,'enUS','','Think you got what it takes to face my brews?',26124),
(60815,'enUS','','One sip of my brews and you will see how unworthy you really are.',26124),
(60816,'enUS','','I\'m fighting you? Wow this competition is going to be easier than I thought.',26124),
(60817,'enUS','','Don\'t think I\'m letting you off the hook next time.',26124),
(60818,'enUS','','You won this round but I\'ll have a better brew by our next encounter.',26124),
(60819,'enUS','','I could have beat you today you know. All I needed to do was to switch to my \"Ale Stance\" sooner.',26124),
(60820,'enUS','','Enjoy the taste of victory, for now. Next time we fight, you will taste the bitterness of defeat.$b$bIn fact, I think I\'ll name my next brew that. \"The Bitterness of Defeat.\" Doesn\'t roll of the tongue but it takes a special kind of failure to make one drink a brew named that.',26124),
(60821,'enUS','Welcome, traveller. It is good to see variety included in this tournament.','',26124),
(60822,'enUS','Pay no attention to the hozen behind my back. His discipline training is... in progress.','',26124),
(60823,'enUS','We have travelled a long way from the Jade Forest to be here today. It is my hope I will grow my skills in this tournament.','',26124),
(60824,'enUS','I look forward to our coming challenge.','',26124),
(60825,'enUS','It is great to see you again, my friend. It seems like only yesturday we saved the city of Stoneplow from the mantid swarms.','',26124),
(60826,'enUS','It is always an honor to share words with the Savior of Stoneplow.','',26124),
(60827,'enUS','You should hear the stories they tell of you in Stoneplow.','',26124),
(60828,'enUS','$P! It is very good to see a friendly face here.','',26124),
(60829,'enUS','It is very good to see you here my friend. It has been a while since our endevours in the Valley of the Four Winds.','',26124),
(60830,'enUS','Ken-Ken continues to be a nuissance and a destraction for everything he comes in to contact with. I look forward to the day when I no longer have to travel with him.','',26124),
(60831,'enUS','','Test your might!',26124),
(60832,'enUS','','There is no knowledge that is not power.',26124),
(60833,'enUS','Ah, the ancient Vaults of the Kings of Mogu\'shan. What might this button do...?','',26124),
(60834,'enUS','Xuen insists Ken-Ken and I could have beat you had we learned to work together. Perhaps next time we will provide a better challenge.','',26124),
(60835,'enUS','Well fought earlier. It was quite surprising to see how strong you\'ve become.','',26124),
(60836,'enUS','Hopefully next time Xuen will let me face you directly rather than being hampered by a hozen.','',26124),
(60837,'enUS','Wrestler gonna punch wikket so hard in the face it gonna improve $pr looks.','',26124),
(60838,'enUS','Huh? Who you? Go away. Wrestler need more time with Coach Rok Rok!','',26124),
(60839,'enUS','Wikket got lucky today. Wrestler gonna beat on rematch!','',26124),
(60840,'enUS','Mmmphpmmmph!','',26124),
(60841,'enUS','Ken-Ken has travelled far and now is super strong monk.','',26124),
(60842,'enUS','Sorry for slicky smell. Clever Ashyo not clean jinyu.','',26124),
(60843,'enUS','Ken-Ken would have won if Ashyo had not been a dooker.','',26124),
(60844,'enUS','Next time Ken-Ken gonna win! With or without Ashyo.','',26124),
(60845,'enUS','The hero of Stoneplow! Hi hi.','',26124),
(60846,'enUS','Here is the Super $R that saved Stoneplow!','',26124),
(60847,'enUS','Oh, $p! How you get here? Are we fighting today?','',26124),
(60848,'enUS','Oh good to see you again! Clever Ashyo is derk for company.','',26124),
(60849,'enUS','You smell of a defeat in your near future.','',26124),
(60850,'enUS','My team will crush you.','',26124),
(60851,'enUS','Do you know who I am? Do you know who I am?!','',26124),
(60852,'enUS','Next time you may find I\'m harder to defeat! I\'ve made sure my healer remembers his place.','',26124),
(60853,'enUS','Ah! Don\'t talk to me! Tank! Tank! Taunt it off me you filthy thing!','',26124),
(60854,'enUS','We are going to crush you next time! Our tank should be able to remember to generate enough threat on you!','',26124),
(60855,'enUS','You smell of loot.','',26124),
(60856,'enUS','We wiped and I didn\'t get my gear.','',26124),
(60857,'enUS','This looks to be the record of Qiang the Merciless, a great conqueror who ruled his vassals with an iron fist!','',26124),
(60858,'enUS','I\'ve dreamed of being here today. This is it! This is going to be the day I win the tournament!','',26124),
(60859,'enUS','See this staff? It has been in my family for generations and won hundreds of tournaments at this very spot.$b$bCan you feel the power in it? It is much stronger here than anywhere else I\'ve travelled.','',26124),
(60860,'enUS','Well, you won today, but that doesn\'t mean I can\'t win tomorrow. Papa Bramblestaff always said if at first you don\'t succeed, wipe the blood off and get back in there until you do.','',26124),
(60861,'enUS','I\'ve heard tales of this one: Subetai the Swift, well known as a masterful archer and genius thief. He stole from the rich, and kept everything for himself.','',26124),
(60862,'enUS','Ah! The \"hero\" who stole my spotlight at Stoneplow.$b$bI kid, I kid. That was a great battle. I am honored to have fought by your side.','',26124),
(60863,'enUS','$P! Welcome to the Temple of the White Tiger! Xuen runs an amazing tournament that my family has a habit of winning.','',26124),
(60864,'enUS','Well, look what the virmen dragged in. $P, how have you been? Are you hear to compete?','',26124),
(60865,'enUS','What is this? I\'ve heard nothing of this emperor. Meng the Demented? According to these texts, Meng was the most foul and maniacal ruler to ever abuse the imperial throne.','',26124),
(60866,'enUS','You are here? Does this mean we will finally get a chance to compete against each other for the tournament title?','',26124),
(60867,'enUS','Ooo. Does this mean I get to face the champion of Stoneplow? Fantastic!','',26124),
(60868,'enUS','Hackiss tries to pick your pocket.','',26124),
(60869,'enUS','I look forward to our match.','',26124),
(60870,'enUS','Xuen\'s challenge road the winds to my home in the Jade Forest. I could not refuse such an invitation.','',26124),
(60871,'enUS','You have the look of a champion. But do you have the fortitude.','',26124),
(60872,'enUS','No one can question the strength of your abilities, champion.','',26124),
(60873,'enUS','Wikkets think they can take the Boom Boom Boogaloo?','',26124),
(60874,'enUS','Master Boom Boom\'s got some super boom sticks.','',26124),
(60875,'enUS','Wikket thinks it won? Ha! Master Boom Boom never say \"surrender\"! Stalemate!','',26124),
(60876,'enUS','Strength comes in many forms. For some it is a weapon. For others a burden. For myself, I see it as a way of being.','',26124),
(60877,'enUS','Welcome, $p, to my Tournament of Strength!','',26124),
(60878,'enUS','Xuen teaches us that strength is a tool that requires practice.','',26124),
(60879,'enUS','Every few days Xuen hosts a tournament of strength. Only the strongest and most brave challengers from across Pandaria dare compete.','',26124),
(60880,'enUS','Watch out for Xuen\'s cubs. What they lack in size they make up for in pure strength.','',26124),
(60881,'enUS','Legend has it that Xuen hasn\'t fought in one of his own tournaments in centuries.$b$bHe says it is because he wants us to have a fighting chance. I think he\'s just getting old. Or... at least... old for a... well... whatever he is.','',26124),
(60882,'enUS','You call those strong arms? Ha! I have bruises that have more muscle in them.','',26124),
(60883,'enUS','Do you have the eye of a tiger?','',26124),
(60884,'enUS','|TInterface\\Icons\\ability_warrior_charge.blp:20|tAdarogg sets his eyes on |cFFFF0000$n|r and begins to cast |cFFFF0000|Hspell:119299|h[Inferno Charge]|h|r!','',26124),
(60885,'enUS','Congratulations on your victory, Champion!','',26124),
(60886,'enUS','You honor us with your presence, Champion.','',26124),
(60887,'enUS','Those were some impressive feats of strength you displayed today. Well done!','',26124),
(60888,'enUS','I haven\'t seen a match like that in days!','',26124),
(60889,'enUS','Well fought, Champion!','',26124),
(60890,'enUS','I saw your fighting today. Less refined than some of the masters who enter the tournament, but certainly effective. I will watch you in the future, and learn.','',26124),
(60891,'enUS','Oh, a $c? Entering in the tournament? This should be interesting indeed.','Oh, a $c? Entering in the tournament? This should be interesting indeed.',26124),
(60892,'enUS','Hmm. A $c is interesting, but let us see how well you do against the Wrestler or Master Boom Boom.','Hmm. A $c is interesting, but let us see how well you do against the Wrestler or Master Boom Boom.',26124),
(60893,'enUS','A wonderful day for a tournament, wouldn\'t you say?','A wonderful day for a tournament, wouldn\'t you say?',26124),
(60894,'enUS','My money is on one of those kids that came up from the Valley of the Four Winds.$b$bI heard they trained at the monastery in the Jade Forest.','My money is on one of those kids that came up from the Valley of the Four Winds.$b$bI heard they trained at the monastery in the Jade Forest.',26124),
(60895,'enUS','I watched Master Windfur fight a dozen mogu once without any of them successfully landing a blow.','I watched Master Windfur fight a dozen mogu once without any of them successfully landing a blow.',26124),
(60896,'enUS','I heard the Wrestler never ever takes his mask off. I wonder what he does if his nose gets itchy.','I heard the Wrestler never ever takes his mask off. I wonder what he does if his nose gets itchy.',26124),
(60897,'enUS','Wow! You have no idea how much money you just won me. Thanks you, Champion!','Wow! You have no idea how much money you just won me. Thanks you, Champion!',26124),
(60898,'enUS','Ah, Champion! You should return every tournament. I will make a fortune.','Ah, Champion! You should return every tournament. I will make a fortune.',26124),
(60899,'enUS','Those were some amazing fights!','Those were some amazing fights!',26124),
(60900,'enUS','Such a tragedy...','',26124),
(60901,'enUS','I\'ve never seen anyone fight like that before! You were incredible.','I\'ve never seen anyone fight like that before! You were incredible.',26124),
(60902,'enUS','Your fighting made the trip up to the temple worth it!','Your fighting made the trip up to the temple worth it!',26124),
(60903,'enUS','The Wrestler took out my old apprentice. Now you shall be my apprentice. You smell of luck... and sweat. Most good fortune indeed!$b$bThe Wrestler is slow but strong. Do not let him grab you.$b$bAlso, his mind is weak. Use the chairs in the arena to stun him.$b$bIf you get weak, use the bucket next to me for refreshings.$b$bGood fortune to you, apprentice of grummle!','',26124),
(60904,'enUS','','Oh, don\'t worry about him.$B$BMy oaf of a husband is just sleeping off a nasty blow to his thick skull.',26124),
(60905,'enUS','Hold your sword, Mei. There are too many of them - and if you die, what of my son?','',26124),
(60906,'enUS','No! No no no no no! Wrestler get up! Get up wikket!','',26124),
(60907,'enUS','Where are my heals you scrub-chinned-lizard-nub?!','',26124),
(60908,'enUS','Aaah! It\'s hitting me! Tank it off! Tank it off!','',26124),
(60909,'enUS','I could use a campfire and some warm food right about now. Are you here with good news?','',26124),
(60910,'enUS','I have orders for you to return to the battlefront.','I have orders for you to return to the battlefront.',26124),
(60911,'enUS','','A friendly face is welcome around here. Happen to bring some rations?',26124),
(60912,'enUS','','We\'ve been at this post for days with no sleep. You\'ve no idea how badly I want to just lie down.',26124),
(60913,'enUS','I\'ve never seen them in such numbers...','',26124),
(60914,'enUS','','Whatever you do, stranger, do not ask my husband about his egg noodle recipe. It will be the longest conversation you have ever heard.',26124),
(60915,'enUS','You\'ve received Volatile Greenstone Brew! Use it in combat to help defeat multiple enemies.','',26124),
(60916,'enUS','[PH] Vengeful Hui\'s anger has been beaten out of him! He has grown calm.','',26124),
(60917,'enUS','[PH] Hey guys, I\'m really sorry about all that. Friends...?','',26124),
(60918,'enUS','I got you in my sights, monkey!','',26124),
(60919,'enUS','So, Alliance finally decided to drop in some reinforcements, eh? Get to the front, $c!','',26124),
(60920,'enUS','I knew they\'d send reinforcements! Never doubted it!','',26124),
(60921,'enUS','They\'re coming over our barricades! Push them back!','',26124),
(60922,'enUS','It\'s do or die, men! Don\'t shoot till you see the crazy in their eyes!','',26124),
(60923,'enUS','What are you standing there for, $r? We need everyone at the frontlines!','',26124),
(60924,'enUS','Bout time they sent some heroes from HQ. Get out there and fight, $c!','',26124),
(60925,'enUS','Let\'s show those long-tailed gingers what the Alliance is made of! Charge!','',26124),
(60926,'enUS','Their numbers are endless, $c! Help us hold them back!','Their numbers are endless, $c! Help us hold them back!',26124),
(60927,'enUS','$R, over here! Drive them back!','$R, over here! Drive them back!',26124),
(60928,'enUS','Ho, did they send more reinforcements from Stormwind? $C on the field!','Ho, did they send more reinforcements from Stormwind? $C on the field!',26124),
(60929,'enUS','For the Alliance!','For the Alliance!',26124),
(60930,'enUS','Many thanks... I couldn\'t have held out much longer.','',26124),
(60931,'enUS','Ah, you have returned! One thousand thanks. Please, take this, our most potent creation: Volatile Greenstone Brew.','',26124),
(60932,'enUS','Clan Gurthan will show our King and the rest of you power-hungry imposters why we are the rightful ones at his side!','',26124),
(60933,'enUS','Clan Kargesh will demonstrate why only the strong deserve to stand at our King\'s side!','',26124),
(60934,'enUS','Clan Harthak will show all why they are the truest of Mogu!','',26124),
(60935,'enUS','Yeeee-haw, we drove them back!! That\'s right, monkeys, run your little tails off!','',26124),
(60936,'enUS','Looks like they couldn\'t handle the taste of Alliance steel. Good work, $n.','',26124),
(60937,'enUS','My people, corrupted...\n\nShai Hu, a local warrior, was the first to drink of the tainted waters.\n\nHe was strengthed, emboldened, and urged the others to do the same.\n\nI warned them against it. I sensed danger, corruption...','',26124),
(60938,'enUS','Woah... My hooves are huuuuge...','',26124),
(60939,'enUS','These grummle charms are starting to kick in...','',26124),
(60940,'enUS','These grummles make a strange grog.','',26124),
(60941,'enUS','It... its like I can smell the grummle luck...','',26124),
(60942,'enUS','I think I can hear myself getting luckier...','',26124),
(60943,'enUS','We will never surrender our right to rule the destiny of our people!','',26124),
(60944,'enUS','Our clan is the true clan! No interloper can change that!','',26124),
(60945,'enUS','Impossible! Our might is the greatest in all the empire!','',26124),
(60946,'enUS','Go away. My team can handle ourselves.','',26124),
(60947,'enUS','We wouldn\'t be in this mess if Tankiss would learn to keep the heat off his healer.','',26124),
(60948,'enUS','I found a grummle cake in a corner of my cage. So delicious! Best day ever!','',26124),
(60949,'enUS','Stay inside, Hanae! Adventurer, please see if there\'s anything the Gentle Mother needs. She is working tirelessly to tend to the survivors inside.','',26124),
(60950,'enUS','','Danger? Ha! I scoff at danger!$B$BDon\'t you know that the most delicious foods are also the most dangerous to acquire?',26124),
(60951,'enUS','I knew it was within their power to defy the mogu - they just needed someone like you to show them how.','',26124),
(60952,'enUS','I don\'t know where you came from, but if you\'ll continue to stand up for justice as you have done today, you\'ll be welcome in Pandaria.$B$BThank you.','',26124),
(60953,'enUS','Faster, smith! Shai Hu hungers for blood!','',26124),
(60954,'enUS','Will you ever finish your work, smith? Perhaps you require additional encouragement?','',26124),
(60955,'enUS','Orachi shall have my head if you do not work faster, smith! And I shall have yours.','',26124),
(60956,'enUS','Silence, priest! You know nothing of my work!','',26124),
(60957,'enUS','Your impudent patter does not intimidate me, fool.','',26124),
(60958,'enUS','','You want something? Mine is the bitterest of the brews. Are you worthy?',26124),
(60959,'enUS','You have my gratitude.','You have my gratitude.',26124),
(60960,'enUS','Yes. I do.','Yes. I do.',26124),
(60961,'enUS','Yes. I do.','Yes. I do.',26124),
(60962,'enUS','I wish to reset my Class Specialization.','I wish to reset my Class Specialization.',26124),
(60963,'enUS','I wish to remove my glyphs.','I wish to remove my glyphs.',26124),
(60964,'enUS','You have my gratitude!','You have my gratitude!',26124),
(60965,'enUS','There\'s hope for Greenstone! Thank you!','There\'s hope for Greenstone! Thank you!',26124),
(60966,'enUS','I thought I was doomed. Thank you so much!','I thought I was doomed. Thank you so much!',26124),
(60967,'enUS','I\'ll defend this place to my death, you monster!','',26124),
(60968,'enUS','I once found a feather from big green bird on Neverrest. No green birds fly on Neverrest. This is a very good luckydo.','',26124),
(60969,'enUS','Someone! Please help!','Someone! Please help!',26124),
(60970,'enUS','Find a copper, pick it up, all day long I\'ll have good luck.','',26124),
(60971,'enUS','Stay here tonight, buy my wares, and fortune will shine on you for certain.','',26124),
(60972,'enUS','You are skilled in the healing arts, $c.','You are skilled in the healing arts, $c.',26124),
(60973,'enUS','Your healing skills are impressive, $n.','Your healing skills are impressive, $n.',26124),
(60974,'enUS','Where did you learn to do that? You must have had a lot of practice.','Where did you learn to do that? You must have had a lot of practice.',26124),
(60975,'enUS','Well done, $c. You have been taught well.','Well done, $c. You have been taught well.',26124),
(60976,'enUS','You have studied your craft well, $c.','You have studied your craft well, $c.',26124),
(60977,'enUS','*hic*','',26124),
(60978,'enUS','Help! Help!','Help! Help!',26124),
(60979,'enUS','Away, you fiends! Help!','Away, you fiends! Help!',26124),
(60980,'enUS','They\'ve overrun the village! HELP!','They\'ve overrun the village! HELP!',26124),
(60981,'enUS','More hired thugs?! It will take more than these three to best me!','',26124),
(60982,'enUS','You\'ll learn to serve!','',26124),
(60983,'enUS','Bow down!','',26124),
(60984,'enUS','The weak have no place in this world!','',26124),
(60985,'enUS','I will teach you some respect!','',26124),
(60986,'enUS','Know your place!','',26124),
(60987,'enUS','Insolent little $r!','',26124),
(60988,'enUS','You dare to defy the mogu? Then you will die!','',26124),
(60989,'enUS','Our empire will be glorious! And you won\'t be there to see it!','',26124),
(60990,'enUS','I will not tolerate this disobedience!','',26124),
(60991,'enUS','I\'ve never performed this ritual. I don\'t know what will happen, exactly.','',26124),
(60992,'enUS','It\'s been passed down from ancient times, but none of our people have needed to use it since then.','',26124),
(60993,'enUS','Let us see if this is sufficient to cleanse the corruption from my people\'s souls.','',26124),
(60994,'enUS','Gormal takes additional damage while taunted by a farmer!','',26124),
(60995,'enUS','That swarm is what we have to look forward to. Ancestors help us if they decide to turn on the battlefront.','',26124),
(60996,'enUS','','Let my replacement know that a lot of mantid have been trying to sneak through the main channel. This is no easy post.',26124),
(60997,'enUS','Even better news than I was hoping. I look forward to a warm bed.','',26124),
(60998,'enUS','','Even better than rations. Rest. I thought I\'d be out here a while yet.',26124),
(60999,'enUS','It worked! It wo-','',26124),
(61000,'enUS','Wh... what is happening? Why is the ritual affecting her?','',26124),
(61001,'enUS','Dat\'s betta. Now let\'s get to huntin\' dem monkeys, mon.','',26124),
(61002,'enUS','First rule of the Tiger Temple Tournament: We don\'t talk about Tiger Temple Tournament.','',26124),
(61003,'enUS','I thought I was a goner. I owe you my life.','I thought I was a goner. I owe you my life.',26124),
(61004,'enUS','Thank you for rescuing me. For the Alliance!','Thank you for rescuing me. For the Alliance!',26124),
(61005,'enUS','Thanks, friend. That was some firefight, but I knew that blue would pull through!','Thanks, friend. That was some firefight, but I knew that blue would pull through!',26124),
(61006,'enUS','Thank you, friend. Don\'t worry, it was just a scratch. Now I feel good as new!','Thank you, friend. Don\'t worry, it was just a scratch. Now I feel good as new!',26124),
(61007,'enUS','Nice seeing another Alliance face! I thought I was going to die out here.','Nice seeing another Alliance face! I thought I was going to die out here.',26124),
(61008,'enUS','That... thing must be what was controlling the villagers! I now know what we must do.','',26124),
(61009,'enUS','','I feel so much calmer. What happened?',26124),
(61010,'enUS','What is that?!','',26124),
(61011,'enUS','A beast emerged from you when I began the ritual. $p slew it!','',26124),
(61012,'enUS','','I felt a presence, a burning pain and rage in my mind...',26124),
(61013,'enUS','Point out the pools of corruption, and I will use my staff to cleanse them. You\'ll need to defeat the creatures that emerge!','',26124),
(61014,'enUS','Hey rookie, take this diving helmet. You might need it out there.','',26124),
(61015,'enUS','Defeat the Shadow of the Golden Lotus to escape!','Defeat the Shadow of the Golden Lotus to escape!',26124),
(61016,'enUS','Are you coming?','Are you coming?',26124),
(61017,'enUS','I will begin the ritual. Prepare yourself!','',26124),
(61018,'enUS','Now, friend. Prepare yourself to defeat whatever emerges!','',26124),
(61019,'enUS','Hopefully this one will not be worse than the last...','',26124),
(61020,'enUS','General Pa\'valak calls for Reinforcements!','',26124),
(61021,'enUS','Come on, Zin\'Jun, there\'s vengeance to be had!','Come on, Zin\'Jun, there\'s vengeance to be had!',26124),
(61022,'enUS','I have nothing to teach you, $c.','I have nothing to teach you, $c.',26124),
(61023,'enUS','How may I help you?','How may I help you?',26124),
(61024,'enUS','This land must be made ready for the fleet.$b$bNo excuses!','',26124),
(61025,'enUS','Mine!','',26124),
(61026,'enUS','','This old bear... I can\'t stay mad at him.$B$BThank you, stranger.',26124),
(61027,'enUS','','One fewer of these pests behind the blockade.',26124),
(61028,'enUS','','I would love to help you, Lorewalker, but understand - I am in a real bind here.',26124),
(61029,'enUS','','Gah! You\'re as stubborn as my dang husband!',26124),
(61030,'enUS','But look who has arrived! Mrs. Mann, there\'s someone I would like you to meet.','',26124),
(61031,'enUS','Lifting','Lifting',26124),
(61032,'enUS','Don\'t get too comfortable here, pal.$b$bThe general says these digs is only temporary.','',26124),
(61033,'enUS','Please, accept the ancestors blessing. It is not much, but it is all I can give without my staff, and will help you traverse the Mere.','',26124),
(61034,'enUS','','Ooh, it takes some real stones to challenge the Mistress of Illusion. Well? Show me what you\'ve got!',26124),
(61035,'enUS','','Ashes, ashes, we all fall down!',26124),
(61036,'enUS','','Aw. Careful not to bleed on the rug please, dear.',26124),
(61037,'enUS','','Better luck next time!',26124),
(61039,'enUS','','Ugh... death... hurts? Unreal...',26124),
(61041,'enUS','','Come, try your luck! Ha ha haaa...',26124),
(61042,'enUS','The lawspeaker was right... they\'ve gone insane!','',26124),
(61043,'enUS','You... you\'re not one of them, are you? You\'ve got to help me!','',26124),
(61044,'enUS','There\'s no hope... our people have lost their minds!','',26124),
(61045,'enUS','There\'s still hope - Gorai is still alive, to the south. Go!','There\'s still hope - Gorai is still alive, to the south. Go!',26124),
(61046,'enUS','','Feeling a bit... dizzy?',26124),
(61047,'enUS','You are not the first to challenge me, peons. You will not be the last.','',26124),
(61048,'enUS','What is this, more have come to claim my crown? They are small and weak.','',26124),
(61049,'enUS','I know you. If the reports I\'ve been receiving are true, I could use a $gman:woman; like you.','',26124),
(61050,'enUS','Taoshi speaks highly of you. Her respect for you says a great deal.','',26124),
(61051,'enUS','We\'re on the trail of the Sha of Hatred. I want you with us for the hunt.','',26124),
(61052,'enUS','MY MIGHT IS ENDLESS!','',26124),
(61053,'enUS','Thank you, friend... I\'ll make my way to the south!','',26124),
(61054,'enUS','Gorai lives? I will go find him. Thank you, friend!','',26124),
(61055,'enUS','Face the might of my arsenal, weaklings!','',26124),
(61056,'enUS','You are very brave... thank you!','',26124),
(61057,'enUS','Fools, I possess the power of the elements!','',26124),
(61058,'enUS','ENOUGH OF THIS FARCE! You will feel PAIN, cowards!','',26124),
(61059,'enUS','%s spits blood in your face.','',26124),
(61060,'enUS','We will need the strongest the Shado-Pan has to offer for the confrontation with the Sha of Hatred. And it\'s likely that even then, not all of us will make it out alive.','',26124),
(61061,'enUS','We\'re close. I can feel the unnatural hatred broiling inside of me.','',26124),
(61062,'enUS','This ancient fresco was once inlaid with jade, but it has fallen into ruin and now its wisdom is lost to us.','',26124),
(61063,'enUS','We will all be tested this day, but we shall prevail.','',26124),
(61064,'enUS','With the sudden arrival of strangers on Pandaria, I believe we\'ll need the lessons our history can teach us.','',26124),
(61065,'enUS','You call that... a fight...?','',26124),
(61066,'enUS','','I understand, Lorewalker. But the Serpent\'s Heart project is behind schedule and we\'ve not a stone to spare!',26124),
(61067,'enUS','Who allowed these outsiders inside our halls? Only Clan Harthak or Clan Kargesh would stoop to such treachery!','',26124),
(61068,'enUS','Tender your souls, mortals! These are the halls of the dead!','',26124),
(61069,'enUS','See how effortlessly I CRUSH your bones!','',26124),
(61070,'enUS','Fall to your knees, coward!','',26124),
(61071,'enUS','Have patience, Mrs. Mann. These strangers from beyond the mist continually surprise me.','',26124),
(61072,'enUS','Only the dogs of Clan Gurthan would point fingers at others for their own failures! Your clan is the most desperate. It must\'ve been you!','',26124),
(61073,'enUS','','You expect this dumpling to clean up the mason\'s quarter? They barely even got a belly on them!',26124),
(61074,'enUS','Clan Gurthan is right! Only the honorless Clan Harthak could bring in a lesser race to do their bidding. You must be traitors!','',26124),
(61075,'enUS','|TInterface\\Icons\\spell_arcane_blast.blp:20|t %s begins to cast |cFFFF0000|Hspell:117914|h[Total Annihilation]|h|r!','',26124),
(61076,'enUS','Silence, you motherless mu\'shan herders! I\'d blame your clan, but your skulls are too thick to figure out a child\'s puzzle box, let alone how to usurp power.','',26124),
(61077,'enUS','A well-scripted exchange; but we are not fooled. Your clans are clearly in league with one another. For the glory of our king, our empire, we will put you all down!','',26124),
(61078,'enUS','Clan Kargesh will not suffer these insults! We will have your heads to offer to the king as proof of our might soon enough!','',26124),
(61079,'enUS','You must be the $r that freed Bold Karasshi and our other brothers! We owe you our thanks.','',26124),
(61080,'enUS','Bold Karasshi mentioned a $r would pass through. That person must be you.','',26124),
(61081,'enUS','You must be the one who helped our brothers. Thank you.','',26124),
(61082,'enUS','$R, you are welcome here. Bold Karasshi has already told us of your deeds.','',26124),
(61083,'enUS','$C, is it not? Thank you for returning our brothers to us.','',26124),
(61084,'enUS','Good day, $r.','',26124),
(61085,'enUS','May the waters bless you, $r.','',26124),
(61086,'enUS','How do you fare today, $n?','',26124),
(61087,'enUS','Hold on tight!','',26124),
(61088,'enUS','Crazy nibblers! Give them a whoopin\' , $p!','',26124),
(61089,'enUS','Daggone critters don\'t know when to give up, do they?!','',26124),
(61090,'enUS','We\'re almost to the fresco. Keep it up back there!','',26124),
(61091,'enUS','','Good work.  Meet me at the eastern entrance to the blockade.  We need to find the hole in the defenses and plug it.',26124),
(61092,'enUS','I\'m ready. Begin the ritual.','I\'m ready. Begin the ritual.',26124),
(61093,'enUS','Flesh from bone.... Tsss.... their spirits are broken!','',26124),
(61094,'enUS','They crumble so easily.','',26124),
(61095,'enUS','Ripe for the picking.','',26124),
(61096,'enUS','Oh great spirit! Grant me the power of the earth!','',26124),
(61097,'enUS','Oh exalted one! Through me you shall melt flesh from bone!','',26124),
(61098,'enUS','Oh sage of the ages! Instill to me your arcane wisdom!','',26124),
(61099,'enUS','Great soul of champions past! Bear to me your shield!','',26124),
(61100,'enUS','If they only knew... what horrors await...','',26124),
(61101,'enUS','Well done! I name you the Champion of Strength! May your enemies tremble before your title.','',26124),
(61102,'enUS','Well you can\'t just stay in here! You leave me no choice!\n<Use the Fire Lotus Incense.>','Well you can\'t just stay in here! You leave me no choice!\n<Use the Fire Lotus Incense.>',26124),
(61103,'enUS','He is dead! You have done it!','',26124),
(61104,'enUS','Friend, I will return to the refugees. Meet us there, so we can thank you properly.','',26124),
(61105,'enUS','My people, here $ghe:she; is! The one who gave the Inkgill new life. $n!','',26124),
(61106,'enUS','Thank you again, friend. We will remember your name in our people\'s history.','',26124),
(61107,'enUS','All hail, $n!','',26124),
(61108,'enUS','As you can see, this is a defective yak. Go ahead, $r. Try to pet it.','',26124),
(61109,'enUS','I wouldn\'t do that if I were you...','',26124),
(61110,'enUS','You see? Bad yak. Now go on, $r. Try to feed it.','',26124),
(61111,'enUS','','I think you don\'t understand how the yak temple works.',26124),
(61112,'enUS','See!? Very bitey. And he doesn\'t follow orders, either. Try to move him, $r.','',26124),
(61113,'enUS','','Try to understand, grummle. This is a temple to Niuzao, the great Black Ox. We are servants to him, and keepers of this temple. We do not \"replace yaks\".',26124),
(61114,'enUS','I see. Can I at least get mine serviced? He won\'t even take a rider.','',26124),
(61115,'enUS','Cousin Bluesaddle... you are too persistent. And you are being mean to the $r.','',26124),
(61116,'enUS','My case is made. This yak is very bad. We will not leave this yak temple until you fix him or replace him.','',26124),
(61117,'enUS','','Fine. There are plenty of wild yaks near the lake to the north. You can \"replace\" your yak with one of those.',26124),
(61118,'enUS','See, Cousin Bag-of-Rocks? Persistence pays off.','',26124),
(61119,'enUS','But... we could have found wild yaks back in Kun-Lai...','',26124),
(61120,'enUS','Where... were... my heals?!','',26124),
(61121,'enUS','Healiss... you failed!','',26124),
(61122,'enUS','Ah! My cooldowns!','',26124),
(61123,'enUS','Why did it have to be a $pc?','',26124),
(61124,'enUS','Healiss, heal me you son of a basilisk!','',26124),
(61125,'enUS','Start healing you filthy snakehead!','',26124),
(61126,'enUS','Healiss, heal me, you mogu loving pond drinker!','',26124),
(61127,'enUS','Healiss, keep up on the heals you mushan lips!','',26124),
(61128,'enUS','Tankiss! Help!','',26124),
(61129,'enUS','Ah! Facefull of $c!','',26124),
(61130,'enUS','Help! It\'s on my face!','',26124),
(61131,'enUS','Tankiss... too... squishy...','',26124),
(61132,'enUS','Tankiss... get a shield!','',26124),
(61133,'enUS','Out of mana...','',26124),
(61134,'enUS','I\'m starting to make bombs! PH','',26124),
(61135,'enUS','Alright, $n. I\'m ready to go.','',26124),
(61136,'enUS','Father!','',26124),
(61137,'enUS','Yes! Our friend here brought me back!','',26124),
(61138,'enUS','Son! Are you well?','',26124),
(61139,'enUS','|TInterface\\Icons\\spell_shadow_shadowfury:20|tDark Shaman Koranthal summons a |r|cFF9E09DE|Hspell:119971|h[Shadow Storm]|h|r!','',26124),
(61140,'enUS','Your luck just ran out!','',26124),
(61141,'enUS','How many years of bad luck is breaking your face?!','',26124),
(61142,'enUS','We are discussing where we shall go next. Perhaps join the Pearlfin in Jade Forest?\n\nSpeaking of which - how does the $ngill Tribe sound to you?','',26124),
(61143,'enUS','They took my son... They took my goods, I have lost everything. What could possibly have changed these Jinyu?','',26124),
(61144,'enUS','My son... though I have recovered my goods, what will come of him?','',26124),
(61145,'enUS','How does fortune smile on me so? My son, my livelihood returned to me... \n\nTo have thought that one day I was simply content with all this. How truly lucky I was!','',26124),
(61146,'enUS','It is funny, I think my father is happier now that I have returned than he ever was before!$b$bIt seems that trying times have reminded him to appreciate simplicity.','',26124),
(61147,'enUS','','I hope you made them hurt, $n.',26124),
(61148,'enUS','','I can\'t believe how I felt before.\n\nTo think that I could have become posessed by the same thing that controlled these Jinyu, it\'s... disturbing, to say the least.',26124),
(61149,'enUS','We made it to the top!','',26124),
(61150,'enUS','Are you ready to begin the trials?','',26124),
(61151,'enUS','Start Basic Damage (Bronze)','Start Basic Damage (Bronze)',26124),
(61152,'enUS','','Toya\'s been looking for you. He\'s been collecting all our extra jade.',26124),
(61153,'enUS','We will be watching you.','',26124),
(61154,'enUS','Artists need to be reminded to eat once and a while.','',26124),
(61155,'enUS','What do you think, $n? Should we trust these natives?','',26124),
(61156,'enUS','The Pearlfin do not trust us. We must show them that we mean no harm.','',26124),
(61157,'enUS','It may be wise to befriend these people.','',26124),
(61158,'enUS','Bless the waters for bringing you to my shore, weary traveler. Please rest yourself in the calming mists of my inn.','',26124),
(61159,'enUS','Thank you for your hospitality.','Thank you for your hospitality.',26124),
(61160,'enUS','Well, you have done what you could through diplomacy. Now, we can only prove ourselves to the Pearlfin through our deeds.','',26124),
(61161,'enUS','You survive the mountain pass only to die here!','',26124),
(61162,'enUS','As Waterspeaker, I performed many rituals. There is one, though, that I have never performed - to purify mental corruption.\n\nIt is an ancient ritual, one which we have not needed since days of legend, when Shaohao walked Pandaria.\n\nI fear we need it now...','',26124),
(61163,'enUS','Fight harder, weaklings!','',26124),
(61164,'enUS','Feel the rage!  Put it into your strikes!','',26124),
(61165,'enUS','A pathetic hit. More brutality!','',26124),
(61166,'enUS','Too weak!','',26124),
(61167,'enUS','While I would love to purify all of my corrupted brethren, I cannot allow those of us who have not fallen to corruption to go leaderless.\n\nWe must stop the spread of this vile influence, and then I will lead those of us who remain pure to freedom.','',26124),
(61168,'enUS','Reset the event. [PH]','Reset the event. [PH]',26124),
(61169,'enUS','Why would they not listen?','',26124),
(61170,'enUS','How will I save them?','',26124),
(61171,'enUS','I\'ve never seen anything like this.','',26124),
(61172,'enUS','Die, interloper!','',26124),
(61173,'enUS','I will DESTROY you!','',26124),
(61174,'enUS','Raaaaaghh!','',26124),
(61175,'enUS','You\'re not one of us!','',26124),
(61176,'enUS','Die, worthless $pr!','',26124),
(61177,'enUS','Can\'t... control... the RAGE!','',26124),
(61178,'enUS','I. Am. UNDEFEATED!','',26124),
(61179,'enUS','I\'m a fierce predator!','',26124),
(61180,'enUS','%s howls triumphantly.','',26124),
(61181,'enUS','Hello. I am Groundskeeper Ponch. Have we met before? My memory is not too good.','',26124),
(61182,'enUS','|cFFFE9A2ESap Globules|r begin to sprout from the tree!','',26124),
(61183,'enUS','|TInterface\\Icons\\spell_nature_wrathv2.blp:20|t%s begins to cast |cFFFF0000|Hspell:120001|h[Detonate]|h|r!','',26124),
(61184,'enUS','Nooo! I was playing!','',26124),
(61185,'enUS','Hey! Put me back! I was gonna judge a match!','',26124),
(61186,'enUS','Not fair! I wanna watch the fights!','',26124),
(61187,'enUS','Aw! But the Wrestler was gonna fight soon.','',26124),
(61188,'enUS','Noo! If I don\'t get in another nap I won\'t be ready for my big snooze.','',26124),
(61189,'enUS','Don\'t you know what I am? I\'m a fierce predator! I\'ll cut you!','',26124),
(61190,'enUS','Hissssssss!','',26124),
(61191,'enUS','You can\'t catch me!','',26124),
(61192,'enUS','Yes I can!','',26124),
(61193,'enUS','Ready... FIGHT!','',26124),
(61194,'enUS','Point!','',26124),
(61195,'enUS','You call that fighting?','',26124),
(61196,'enUS','Come on Mister Flabbypants! Punch like you mean it!','',26124),
(61197,'enUS','Do something cool!','',26124),
(61198,'enUS','Victory!','',26124),
(61199,'enUS','Oh come on. What was that? Was that a punch? That didn\'t look like a punch. That looked like a cry for help.','',26124),
(61200,'enUS','I am Ponch. I clean the grounds and watch the kittens. They tell me I was a champion once. That must have been neat.','',26124),
(61201,'enUS','I... I feel like I was looking for something. But I can\'t remember what.','',26124),
(61202,'enUS','I like to clean the leaves away from the trails. Too many leaves brings sprites. Temple monks do not like sprites.','',26124),
(61203,'enUS','He\'s cornered!','He\'s cornered!',26124),
(61204,'enUS','We\'ve got him now!','We\'ve got him now!',26124),
(61205,'enUS','At least we know that Anduin is alive. Well done, $n. Now go speak to Elder Lusshan. He has been asking for you.','',26124),
(61206,'enUS','So long, Ruthers! We won\'t miss you!','',26124),
(61207,'enUS','Why have you come here? What are your intentions?','',26124),
(61208,'enUS','You say you come in peace, yet you wear strong armor and wield many weapons.$B$BHow do you explain that?','',26124),
(61209,'enUS','The safety of the tribe is my foremost concern. Do you blame me for being cautious?','',26124),
(61210,'enUS','How do I change my Primary Specialization?','How do I change my Primary Specialization?',26124),
(61211,'enUS','How do I reset my Glyphs?','How do I reset my Glyphs?',26124),
(61212,'enUS','Fresh meat!','',26124),
(61213,'enUS','What business do you have here, stranger?','',26124),
(61214,'enUS','$R, do not try anything funny. We are watching you.','',26124),
(61215,'enUS','Why have you come here, outsider?','',26124),
(61216,'enUS','We are not unfriendly, stranger. Just wary.','',26124),
(61217,'enUS','Trust is earned, stranger.','',26124),
(61218,'enUS','Why should we trust you, stranger?','',26124),
(61219,'enUS','Hoh-hohhh! What a rush! I like you, $c. You keep things interesting.','',26124),
(61220,'enUS','Snow lily! We\'re back from the quarry! Got a special delivery just for you, my sweetness.','',26124),
(61221,'enUS','','Honey-Bear! I mean... it is about time.',26124),
(61222,'enUS','','Don\'t you \"snow lily\" me! I was- WE- were worried sick about you.',26124),
(61223,'enUS','Sorry to keep you waiting, sugarfur. I know how you worry. Truth is, this stranger here saved my old hide. Go figure.','',26124),
(61224,'enUS','%s gives you a sly wink.','',26124),
(61225,'enUS','','And the delivery is not for ME, Hao! The honorable Lorewalker has been waitin- oh...',26124),
(61226,'enUS','The %s retreats to the Dread Expanse!','',26124),
(61227,'enUS','A Mogu\'s feet should always be on the ground.','',26124),
(61228,'enUS','It burns!','',26124),
(61229,'enUS','You can\'t stop what has begun!','',26124),
(61230,'enUS','These guardians are just da beginning!','',26124),
(61231,'enUS','Da Thunder King\'s army will take dis land back for us!','',26124),
(61232,'enUS','Da Thunder King will return!','',26124),
(61233,'enUS','Can you feel it? Da Thunder is getting closer...','',26124),
(61234,'enUS','Thank you, $n. I have had enough training.','',26124),
(61235,'enUS','Thank you for your help, $n. My daggers will cut through many enemies.','',26124),
(61236,'enUS','With this shield and sword, I will protect my friends and family.','',26124),
(61237,'enUS','The secrets of the waters are now known to me. I will use these gifts to help the village.','',26124),
(61238,'enUS','Greetings, $n! Before I join my brothers in battle, I must practice the healing arts.','',26124),
(61239,'enUS','My blades are sharp, but my skill is unhoned. I am ready to learn, $n.','',26124),
(61240,'enUS','Let me lend you my shield, $n. Allow me to protect you, so that I may better protect my village!','',26124),
(61241,'enUS','Teach me, $n! I will bend the forces of water to destroy our foes!','',26124),
(61242,'enUS','','Want some grub? I made it all by myself!',26124),
(61243,'enUS','Obey me, beast!','',26124),
(61244,'enUS','Heel! Or I will cook and eat you on the spot.','',26124),
(61245,'enUS','Mine is an idiot.','',26124),
(61246,'enUS','Why is this creature defying me?!','',26124),
(61247,'enUS','Surrender, creature!','',26124),
(61248,'enUS','Now... sit!','',26124),
(61249,'enUS','Good boy!','',26124),
(61250,'enUS','Horde say you gotta die!','',26124),
(61251,'enUS','For the Horde!','',26124),
(61252,'enUS','Alliance dookers! We part of Horde now!','',26124),
(61253,'enUS','Ookin\' Alliance!','',26124),
(61254,'enUS','Ready for duty.','',26124),
(61255,'enUS','Let\'s get them, $n.','',26124),
(61256,'enUS','It\'s now or never, $r.','',26124),
(61257,'enUS','Lead us onward, $c.','',26124),
(61258,'enUS','No no no! This land is mine, all mine!','',26124),
(61259,'enUS','I hate slickies! Yucky yucky slickies!','',26124),
(61260,'enUS','Stupid, stupid, stupid ookin\' dookers!','',26124),
(61261,'enUS','We must stop the Dark Shaman now.','',26124),
(61262,'enUS','Did Garrosh send you?','',26124),
(61263,'enUS','I\'m just a rock. Nothing to see here.','',26124),
(61264,'enUS','It\'s safe to come out now.','It\'s safe to come out now.',26124),
(61265,'enUS','|TInterface\\Icons\\sha_ability_rogue_envelopingshadows.blp:20|t%s is unleashing |cFFFF0000|Hspell:120215|h[Deathforce]|h|r! RUN AWAY!','',26124),
(61266,'enUS','Yessssssss!  Kill them!  Kill them all!','',26124),
(61267,'enUS','Our highest priority is to evacuate The White Pawn, Prince Anduin Wrynn.','',26124),
(61268,'enUS','Your guess is as good as mine. We have to be ready for anything.','',26124),
(61269,'enUS','Enough! I\'ll handle you myself!','',26124),
(61270,'enUS','Thank you, $p. You fight well for one not of our order. I can handle the rest from here.','',26124),
(61271,'enUS','Return to the Lair of the Jade Witch.','',26124),
(61272,'enUS','','Return to the Serpent\'s Heart.',26124),
(61273,'enUS','Return to the Fox Grove.','',26124),
(61274,'enUS','Return to the Bamboo Wilds and Pearlfin Village.','',26124),
(61275,'enUS','Return to the Fox Grove.','',26124),
(61276,'enUS','Return to the Serpent\'s Heart.','',26124),
(61277,'enUS','Return to the Lair of the Jade Witch.','',26124),
(61278,'enUS','','Return to the Scenic Overlook.',26124),
(61279,'enUS','Just an ordinary crate. Definitely no one hiding here.','',26124),
(61280,'enUS','Kobai leads the yaungol attacking us... but I do not think he is the source of our problems.','',26124),
(61281,'enUS','And now, we spring the trap on our attackers...','',26124),
(61282,'enUS','The Monastery... it worries me that we have heard nothing from them...','',26124),
(61283,'enUS','We need to stop the Dark Shaman before they become a real threat to Orgrimmar.','',26124),
(61284,'enUS','My best scouts still haven\'t returned.','',26124),
(61285,'enUS','I thought I was going to die down here!','',26124),
(61286,'enUS','Thanks!','',26124),
(61287,'enUS','I didn\'t think anyone was coming for us.','',26124),
(61288,'enUS','I owe you an ale!','',26124),
(61289,'enUS','Slowly then.','',26124),
(61290,'enUS','RUN!!','',26124),
(61291,'enUS','Your mother\'s so old she saw the rise of the first kingdom!','',26124),
(61292,'enUS','Your father\'s so weak that a pandaren took pity on him and invited him to dinner!','',26124),
(61293,'enUS','Your clan is so low that hozen tell \"stupid\" jokes about them!','',26124),
(61294,'enUS','Where\'d you get that weapon from, your sister?','',26124),
(61295,'enUS','','Psst! $c! Over here by the stairs! No don\'t look at me! Just come here.',26124),
(61296,'enUS','Fools! Attacking the might of the mantid head on?  Your deaths will be swift.','',26124),
(61297,'enUS','Swarmers, attack!  Tear the flesh from their bones!','',26124),
(61298,'enUS','The Sha Abomination breathes pure death!  Move away from him!','',26124),
(61299,'enUS','Carpet bomb the platform! Send in the Amberwing!','',26124),
(61300,'enUS','Hold back! You\'re just mindlessly walking to your deaths!  I must think...','',26124),
(61301,'enUS','Faster! We must attack faster!  They cannot hold all of us back!','',26124),
(61302,'enUS','Get in there berserkers!  Destroy them all!','',26124),
(61303,'enUS','Everyone! Send everything! Slaughter these cowards, they are making us look like fools!','',26124),
(61304,'enUS','Your defenses are nothing!  I will cut you down and keep your heads as trophies!','',26124),
(61305,'enUS','The power of the Dark Shaman will overwhelm you!','',26124),
(61306,'enUS','My death... means... nothing...','',26124),
(61307,'enUS','Are you sure you\'re ready to join the Alliance?','',26124),
(61308,'enUS','I\'m dry! Gotta get some more!','',26124),
(61309,'enUS','Here comes the pain!','',26124),
(61310,'enUS','I have no time for small talk, $n.','',26124),
(61311,'enUS','This better be important.','',26124),
(61312,'enUS','','I\'m worried about the others, $n.',26124),
(61313,'enUS','','What is the horde trying to do down here?',26124),
(61314,'enUS','','That poor village was ambushed when the Zandalari arrived. They don\'t even have any skilled fighters to defend themselves! You have to help them. Shin will make sure you get to the village safely.',26124),
(61315,'enUS','Who do you think the King will pick?','',26124),
(61316,'enUS','Our clan is the greatest in all the land, he must choose us!','',26124),
(61317,'enUS','I bet the other clans can\'t even use magic anymore. What good could they be to the King!','',26124),
(61318,'enUS','I heard the King is going to force us to fight each other. Not that it will take much for that to happen.','',26124),
(61319,'enUS','With all these clans here I bet a fight\'s going to break out.','',26124),
(61320,'enUS','I heard the King is going to force us to fight each other. Not that it will take much for that to happen.','',26124),
(61321,'enUS','That Saurok\'s making off with our loot, get him!','',26124),
(61322,'enUS','Get that Saurok!','',26124),
(61323,'enUS','The %s submerges beneath the Dread Expanse!','',26124),
(61324,'enUS','The %s emerges from the Dread Expanse!','',26124),
(61326,'enUS','I was starting to wonder how long I would be out here.','You do us a great service friend.',26124),
(61327,'enUS','My poor old bones were starting to get stiff out here.','Thanks to you I\'ll be rested when those barbarians return.',26124),
(61328,'enUS','Those Zandalari will regret attacking Zouchin!','So... sore...',26124),
(61330,'enUS','I\'m grateful to you, friend.','You\'re my hero!',26124),
(61331,'enUS','Sometimes the roads we travel teach us more about ourselves than we would expect.','',26124),
(61332,'enUS','With the villagers help we will surely track down the Zandalari.','',26124),
(61333,'enUS','I hope our paths cross again, $n! Until then, may your journey be safe and meaningful.','',26124),
(61334,'enUS','I found it!  It\'s mine!','',26124),
(61335,'enUS','Why you try to take my sword?  It\'s MY sword!','',26124),
(61336,'enUS','Leave me and sword alone!  No retakes allowed!','',26124),
(61337,'enUS','If dumb man lose sword, it not dumb man\'s sword no more!','',26124),
(61338,'enUS','Mean sword-takers. Go away!','',26124),
(61339,'enUS','Stop it meanies!  Maybe I take your sword too!','',26124),
(61340,'enUS','Takers keepers!  Don\'t be dumb.','',26124),
(61341,'enUS','MINE!','',26124),
(61342,'enUS','Take me to the Temple of the Jade Serpent.','Take me to the Temple of the Jade Serpent.',26124),
(61343,'enUS','I require the flame, master.','I require the flame, master.',26124),
(61344,'enUS','Noodles here, get your delicious noodle soup!','',26124),
(61345,'enUS','Steamed buns, delicious steamed pork buns! Come and get them!','',26124),
(61346,'enUS','Steaming hot noodle soup, come and get your hot noodle soup!','',26124),
(61347,'enUS','Tasty, fresh, wholesome and delicious! Come get some of Tao\'s noodle soup!','',26124),
(61348,'enUS','Try the hottest spices from here to the great wall! Delicious, spicy soup!','',26124),
(61349,'enUS','Stinky tofu, come and get your stinky tofu! I\'ve got the stinkiest tofu in all of Pandaria!','',26124),
(61350,'enUS','%s sighs.','',26124),
(61351,'enUS','','Ho, $c, welcome to the eastern temple! Make yourself at home.',26124),
(61352,'enUS','','You look weary, traveler. Come share our warm fire and good brew.',26124),
(61353,'enUS','','Welcome, $r. Have a look around.',26124),
(61354,'enUS','','Welcome to my inn, traveler. We have hot meals and soft beds.',26124),
(61355,'enUS','','Look what the winds blew to my door! Take a break from your adventures and rest, $c.',26124),
(61356,'enUS','Face me. Show me your full potential.','',26124),
(61357,'enUS','Your presence here is unwelcome.','',26124),
(61358,'enUS','This is a sacred place. Strangers are unwelcome.','',26124),
(61359,'enUS','What matter of \'thing\' are you?','',26124),
(61360,'enUS','You smell of the low lands. You should go back to them. There is no peace in these mountains for travelers.','',26124),
(61361,'enUS','You will find no peace here.','',26124),
(61362,'enUS','You come as the carrion bird before a battle.','',26124),
(61363,'enUS','Ours is the way of highest service. I have no time for petty conversation or challenges from a low lander.','',26124),
(61364,'enUS','You look as one who has seen much fighting. But tell me, was it in service to yourself, or others?','',26124),
(61365,'enUS','We are the watchers of the wall, the keepers of darkness, the masters of shadows. We know what evil lurks in the heart of Pandaria. We... are the Shado-Pan.','',26124),
(61366,'enUS','Have you been to the Jade Forest? To the Valley of the Four Winds? To the low lands of Kun-Lai?$b$bTell me, do they enjoy their peace? Are they still ignorant of the price it costs for that peace? How much Shado-Pan blood must be spilled to maintain their peace?$b$bI suppose it is best they do not. Peace is a thing best enjoyed by the ignorant so they may savor their lives without worry.','',26124),
(61367,'enUS','Silly lizards. Did you think you could defeat the mighty yaungol?','',26124),
(61368,'enUS','How many more of you are there?','',26124),
(61369,'enUS','I hear saurok taste like chicken. Let\'s find out.','',26124),
(61370,'enUS','Why have you come so far north? And why are you trespassing in our lands?','',26124),
(61371,'enUS','There are three of us, which is two more than I need to eat your head.','',26124),
(61372,'enUS','We were on our way to the Tiger Temple when you caught us. Lucky for you our healer was napping... apparently.','',26124),
(61373,'enUS','Oh I got something for you to \'taste\'! Come a little closer...','',26124),
(61374,'enUS','','I did not expect to see $rs in this land. You are certainly welcome here.$b$bPlease, do you have supplies for trade? We are low on an assortment of things.',26124),
(61375,'enUS','Intruder!','',26124),
(61376,'enUS','Fear me!','',26124),
(61377,'enUS','I am your death!','',26124),
(61378,'enUS','A challenge!','',26124),
(61379,'enUS','This land is ours now!','',26124),
(61380,'enUS','The sha will take you all.','',26124),
(61381,'enUS','Die well!','',26124),
(61382,'enUS','Tremble before me!','',26124),
(61383,'enUS','Think you can get the drop on me?','',26124),
(61384,'enUS','I will crush you with my own two fists.','',26124),
(61385,'enUS','I was sleeping!','',26124),
(61386,'enUS','I will not die in bed like a coward.','',26124),
(61387,'enUS','I will smoke your ashes.','',26124),
(61388,'enUS','I have sores older than you.','',26124),
(61389,'enUS','Upstart pup! Think you can best me?','',26124),
(61390,'enUS','You will die today.','',26124),
(61391,'enUS','We have a right to this land, same as you!','',26124),
(61392,'enUS','If I die, it will be in battle!','',26124),
(61393,'enUS','Cleansing','Cleansing',26124),
(61394,'enUS','Useless, all of you! Even the guards you give me in tribute can\'t keep these lesser beings from my palace.','',26124),
(61395,'enUS','Redeem, nay, PROVE yourselves now. Deal with these intruders. The clan who brings me their heads will have my favor!','',26124),
(61396,'enUS','$n has cleansed the Pool of Life!','$n has cleansed the Pool of Life!',26124),
(61397,'enUS','Pandaren? What business do you have in Stormwind?','',26124),
(61398,'enUS','Emperor? You\'ll find KING Anduin inside Stormwind Keep.','',26124),
(61399,'enUS','<%s eyes Jojo\'s pillar.>','',26124),
(61400,'enUS','Behave yourselves inside Stormwind, pandaren. You\'re in Alliance territory now.','',26124),
(61401,'enUS','Hey, look! Gnolls!','',26124),
(61402,'enUS','','Those aren\'t gnolls, silly. Use your eyes.',26124),
(61403,'enUS','','Those are FURBOLGS.',26124),
(61404,'enUS','','Teacher... look!',26124),
(61405,'enUS','Yes. Those are pandaren, Moni.','',26124),
(61406,'enUS','','Pandaren? Here, in Stormwind?',26124),
(61407,'enUS','Heh... pandaren. You must be here to join the Alliance.','',26124),
(61408,'enUS','Good move. It worked out well for me.','',26124),
(61409,'enUS','Let\'s... just keep moving.','',26124),
(61410,'enUS','','Welcome to Stormwind!',26124),
(61411,'enUS','Pandaren? I mussht be seein\' thingssh...','',26124),
(61412,'enUS','Quiet, Naanae. Outsiders approach.','',26124),
(61413,'enUS','','Outsiders, yes - but their intentions are good.',26124),
(61414,'enUS','','Look carefully, Lucas. The Light is strong with them. Particularly that one.',26124),
(61415,'enUS','','Let\'s keep moving.',26124),
(61416,'enUS','What\'s the Light?','',26124),
(61417,'enUS','','We\'re here to join the Alliance. We seek audience with your Emperor.',26124),
(61418,'enUS','Never thought I\'d see one of your kind walk through here.','Never thought I\'d see one of your kind walk through here.',26124),
(61419,'enUS','There are dozens of the pesky little brats. Can\'t grab the orbs with them tormenting us. Can\'t catch them to kill them.$B$BAt least I haven\'t lost my weapon, unlike some people...','',26124),
(61420,'enUS','I... uh... look, I\'m doing the best I can, okay?! The sprites keep knocking the orbs out of my hands, or stealing them back when I\'m not looking!$B$BI hate these things!','',26124),
(61421,'enUS','','Let\'s get going, $p. If we are going to be of any use out here, we are going to need allies.',26124),
(61422,'enUS','','Look at this!',26124),
(61423,'enUS','','Well, that\'s good news. Once we join the Alliance, we certainly won\'t run out of things to do.',26124),
(61424,'enUS','Walk with me. All three of you.','',26124),
(61425,'enUS','I understand you want to join the Alliance.','',26124),
(61426,'enUS','We always have need of allies. I\'d be a fool to turn you away, especially at a time of war.','',26124),
(61427,'enUS','But there are a number of things I need to make clear to you.','',26124),
(61428,'enUS','','Yes. Go on.',26124),
(61429,'enUS','First: the races of the Alliance look out for one another.','',26124),
(61430,'enUS','You are expected to provide aid to Alliance members in need, whether they be human, gnome, draenei... or pandaren like yourselves.','',26124),
(61431,'enUS','','The gap in the defenses is in this path. Mantid are sneaking past the scouts and getting around the barricade.$B$BWe need to cut them off before we find ourselves surrounded.',26124),
(61432,'enUS','It is a simple guideline, but a meaningful one. Do you understand?','',26124),
(61433,'enUS','','Certainly.',26124),
(61434,'enUS','Good. Because that brings me to my second point.','',26124),
(61435,'enUS','Not all pandaren have chosen the same path as you three.','',26124),
(61436,'enUS','Some have sided with the Horde.','',26124),
(61437,'enUS','They, along with the other barbarian clans of the Horde, are your new enemies.','',26124),
(61438,'enUS','Those who you once considered friends, or even those you might have loved, are now your sworn adversaries.','',26124),
(61439,'enUS','I am deeply sorry, but the battle lines have been drawn. I will not tolerate any fraternizing with the enemy, as you could expose our Alliance to danger.','',26124),
(61440,'enUS','Do I make myself clear?','',26124),
(61441,'enUS','','Yes... of course.',26124),
(61442,'enUS','Very well. We are nearly finished, $p.','',26124),
(61443,'enUS','','Deadly efficiency.',26124),
(61444,'enUS','','It wasn\'t ready to face the Shado-Pan.',26124),
(61445,'enUS','','You would have had a better chance at the blockade, mantid.',26124),
(61446,'enUS','','What desperation makes them think they stand a chance past our lines...',26124),
(61447,'enUS','','You will learn to fear our blades, mantid.',26124),
(61448,'enUS','','Take that message back to your queen, mantid.',26124),
(61449,'enUS','','You should never have left the Dread Wastes, mantid.',26124),
(61450,'enUS','About that sparring match you suggested...','About that sparring match you suggested...',26124),
(61451,'enUS','I think I\'m ready to take that walk now.','I think I\'m ready to take that walk now.',26124),
(61452,'enUS','','For every ill or evil that rises in Pandaria, there is always a perfectly complementary cure. I find it to be a good analogy to all problems.',26124),
(61453,'enUS','Let me know when you\'re ready.','',26124),
(61454,'enUS','Now, pandaren... let me see what you\'ve got!','',26124),
(61455,'enUS','Don\'t hold back now! Let\'s have it!','',26124),
(61456,'enUS','What\'s the matter? You\'ll have to do better than that.','',26124),
(61457,'enUS','','Careful, $p! You do not want to hurt your new king...',26124),
(61458,'enUS','Come on, pandaren! HIT ME!','',26124),
(61459,'enUS','Ha ha ha haaa! I haven\'t felt like this in YEARS! Don\'t worry, $p... I\'ve been in worse scraps than this. A fighting spirit like yours is welcome in the Alliance.  Now, let\'s get back to business.','',26124),
(61460,'enUS','Who would ever guess how much knowledge was hidden behind these walls. Between the wealth of information here and the lore you have uncovered in your travels, I believe I can weave together a few tales of our forgotten past.$b$bWhich one would you like to hear?','',26124),
(61461,'enUS','Between a Saurok and a Hard Place.','Between a Saurok and a Hard Place.',26124),
(61462,'enUS','Our story begins long ago in the days of the monstrous Emperor Tian.','',26124),
(61463,'enUS','The Emperor was in need of trusted messengers and deliverymen.','',26124),
(61464,'enUS','So he took a strange, diminutive cave creature he found and warped it with the powers of the Vale.','',26124),
(61465,'enUS','What he created, was the \"grummle.\"','',26124),
(61466,'enUS','|TInterface\\Icons\\inv_misc_blackironbomb.blp:20|t The |cFFdd7400Sik\'thik Amberwing|r moves into position to |cFFFF0000|Hspell:120559|h[Bombard]|h|r the platform!','',26124),
(61467,'enUS','I\'d like to take a kite somewhere.','I\'d like to take a kite somewhere.',26124),
(61468,'enUS','I need a kite to get up to the wall!','I need a kite to get up to the wall!',26124),
(61469,'enUS','I heard from the others... you need a kite to the wall?','',26124),
(61470,'enUS','Let us talk about the nature of power. In my hands I hold a sword. I ask you: Who wields the power?','',26124),
(61471,'enUS','I do, for I wield the sword!','',26124),
(61472,'enUS','Details, details.','',26124),
(61473,'enUS','Look, \"Chen Stormstout,\" we all can\'t be heroes, running from our responsibilities, tromping around the Dread Wastes, saving the world. Some of us are \"Artists.\"','',26124),
(61474,'enUS','Yes, yes. That happens.','',26124),
(61475,'enUS','I see - and where is Uncle Gao?','',26124),
(61476,'enUS','There is no time for cookies! Well, one cookie. Just one.','',26124),
(61477,'enUS','Wait - these are ghost cookies. These aren\'t filling at all!','',26124),
(61478,'enUS','Uncle Gao, this brewery was left in your care! What have you done?','',26124),
(61479,'enUS','At what cost? The Brewery is trashed! Infested!','',26124),
(61480,'enUS','','Oh, hello Zan, it is good of you to visit ol\' Auntie Stormstout.',26124),
(61481,'enUS','','Oh Zan! You remind me so much of your father.',26124),
(61482,'enUS','','It is certainly a nice day outside!',26124),
(61483,'enUS','','Have you seen the size of Esme\'s turnips?',26124),
(61484,'enUS','','Abandoned? Oh heavens no! Uncle Gao is in charge while the others are beyond the wall. Isn\'t that exciting?',26124),
(61485,'enUS','','I have some cookies for you!',26124),
(61486,'enUS','The Endless Army will crush the Emperor\'s foes.','',26124),
(61487,'enUS','The Emperor\'s Rage echoes through the hills.','',26124),
(61488,'enUS','The Emperor\'s Strength grips this land with fists of iron.','',26124),
(61489,'enUS','The Emperor\'s Courage burns everlasting.','',26124),
(61490,'enUS','The Emperor\'s Breath abates.','',26124),
(61491,'enUS','The Emperor\'s Breath is regained.','',26124),
(61492,'enUS','The Emperor\'s Will dominates all it beholds.','',26124),
(61493,'enUS','Every Shado-Pan makes three eternal oaths:\n\nTo defend this land, to protect its people, and to train their pupil.\n\nWhen a Shado-Pan dies, they must be released from these bonds.','',26124),
(61494,'enUS','Ah, it was a difficult battle. So sad to have lost friends.\n\nThough, I am glad I had them build the battlefield refreshment device.\n\nWithout it, and without the power of my stout brew, who knows how many more would have been lost...','',26124),
(61495,'enUS','A grummle can carry five times their own weight. They never sweat. They have an outstanding sense of smell.','',26124),
(61496,'enUS','And their skulls are harder than granite. Curiously, they all appear to be related.','',26124),
(61497,'enUS','Ancient Pandaren heroes freed the grummles from slavery.','',26124),
(61498,'enUS','The prisoners are escaping!','',26124),
(61499,'enUS','Niuzao\'s forces attack from the rear!','',26124),
(61500,'enUS','','Crush these invaders, and hurl them from the wall!',26124),
(61501,'enUS','','We could use a $c. Glad to see my husband sent you along.\n\nI\'m a scout, not much for face-to-face combat. And Lao-chen here... well, normally he\'s a fighter, but he\'s still exhausted from the last battle.\n\nAnd, he\'s too busy cooking up some scheme.',26124),
(61502,'enUS','Alright, I\'m ready to get back to the front.','Alright, I\'m ready to get back to the front.',26124),
(61503,'enUS','Two parts oil to one part brew... no, it will need more oil...','',26124),
(61504,'enUS','','You ready?',26124),
(61505,'enUS','The temple will fall! You cannot stop my forces!','',26124),
(61506,'enUS','My army will crush you!','',26124),
(61507,'enUS','Stop them! Mantid attack!','',26124),
(61508,'enUS','Flank! To the flank!','',26124),
(61509,'enUS','Put down your weapons or die!','',26124),
(61510,'enUS','I have failed you, empress...','',26124),
(61511,'enUS','The empress demands it!','',26124),
(61512,'enUS','The forces of Niuzao are weak!','',26124),
(61513,'enUS','','Class is now in session.',26124),
(61514,'enUS','','Your soul cannot withstand my power!',26124),
(61515,'enUS','','I can never die!',26124),
(61516,'enUS','','You\'ve learned nothing.',26124),
(61517,'enUS','','THIS CANNOT BE!',26124),
(61518,'enUS','','Perhaps you should have studied more.',26124),
(61519,'enUS','','I\'ll see you after class.',26124),
(61520,'enUS','The terrace was not meant for your kind!','',26124),
(61521,'enUS','My strength grows!','',26124),
(61522,'enUS','I will not be controlled!','',26124),
(61523,'enUS','None can match my strength!','',26124),
(61524,'enUS','We... are... endless...','',26124),
(61525,'enUS','Weakling!','',26124),
(61526,'enUS','Begone!','',26124),
(61527,'enUS','A storm approaches.','',26124),
(61528,'enUS','Your fear will consume you!','',26124),
(61529,'enUS','I command the elements to destroy you!','',26124),
(61530,'enUS','You cannot escape the storm!','',26124),
(61531,'enUS','The terrace... must not... fall...','',26124),
(61532,'enUS','How dare you trespass here!','',26124),
(61533,'enUS','Shocking.','',26124),
(61534,'enUS','The endless waters will cleanse you from this place!','',26124),
(61535,'enUS','The waters will consume you!','',26124),
(61536,'enUS','The tide cannot be stopped!','',26124),
(61537,'enUS','Drown in fear!','',26124),
(61538,'enUS','The Sha... must be... stopped...','',26124),
(61539,'enUS','You are unfit to stand before me.','',26124),
(61540,'enUS','Flee, child.','',26124),
(61541,'enUS','%s spins around in a |cFFFF0000|Hspell:119888|h[Death Blossom]|h|r!','',26124),
(61542,'enUS','Watch that last step.','',26124),
(61543,'enUS','Be careful!','',26124),
(61544,'enUS','Don\'t jump! Life is worth living!','',26124),
(61545,'enUS','Watch out.','',26124),
(61546,'enUS','Don\'t drop off!','',26124),
(61547,'enUS','Please be careful.','',26124),
(61548,'enUS','Don\'t jump! I am sure there are people who love you. Or at least tolerate you...','',26124),
(61549,'enUS','There goes another one...','',26124),
(61550,'enUS','I hope the rope holds.','',26124),
(61551,'enUS','Hmm. Some say the rope is a crutch...','',26124),
(61552,'enUS','I hope you don\'t get rope burn.','',26124),
(61553,'enUS','Good luck!','',26124),
(61554,'enUS','You are a braver $r than I.','',26124),
(61555,'enUS','%s is chasing you! Run away!','',26124),
(61556,'enUS','','Nothing\'s getting over this wall.$B$BThis is MY wall.',26124),
(61557,'enUS','Safe journeys!','',26124),
(61558,'enUS','','The Shado-Pan have held this wall for centuries, but I won\'t turn down help from outsiders for the sake of pride.',26124),
(61559,'enUS','We are the greatest!','',26124),
(61560,'enUS','These other clans are nothing!','',26124),
(61561,'enUS','These other clans aren\'t worthy of your time, great king!','',26124),
(61562,'enUS','Our clan holds true to the ways set forth by the ancients. We deserve the king\'s favor above all others!','',26124),
(61563,'enUS','The Mogu cannot reclaim our rightful glory without our clan\'s strength!','',26124),
(61564,'enUS','These pathetic clans are beneath you, my king. They sully the great legacy of our people!','',26124),
(61565,'enUS','','Your forces are weak!',26124),
(61566,'enUS','Your presence disturbs a lingering spirit!','Your presence disturbs a lingering spirit!',26124),
(61567,'enUS','The Yaungol warlord shows his face! Come, let\'s finish this!','',26124),
(61568,'enUS','All those barrels... some of my finest brew. At least it went out in a blaze of glory!','',26124),
(61570,'enUS','Taran Zhu won\'t send us reinforcements. We\'ve got a massive army we\'re dealing with here. As tough as we Shado-Pan may be, we\'re going to need to take a different approach.','',26124),
(61571,'enUS','Fools! You cannot defeat me! You cannot defeat the yaungol!','',26124),
(61572,'enUS','','Wait - where is Lin?',26124),
(61573,'enUS','... but first, I\'m going to deal with these cursed yaungol. Have at you!','',26124),
(61574,'enUS','','Where is my husband!?',26124),
(61575,'enUS','Gong Da, deal with these flies while I take this - Lin, was it? - back to Osul Mesa.','',26124),
(61576,'enUS','Yes, my lord!','',26124),
(61577,'enUS','They sent someone after me?!$B$BThank the winds.','',26124),
(61578,'enUS','Hey, easy with that thing!','',26124),
(61579,'enUS','Careful! Don\'t burn the chops...','',26124),
(61580,'enUS','Woah, point that somewhere else!','',26124),
(61581,'enUS','Hey! Live, FLAMMABLE pandaren here!','',26124),
(61582,'enUS','Run while you still can!','Run while you still can!',26124),
(61583,'enUS','They are too strong!','They are too strong!',26124),
(61584,'enUS','Thanks for the save, but we\'re still stuck in the middle of the entire mantid army.','',26124),
(61585,'enUS','Come with me. We need to talk.','',26124),
(61586,'enUS','You\'ve made a wise decision to join my Horde.','',26124),
(61587,'enUS','There are some that would call us barbarians... the \"mongrel races\" of Azeroth.','',26124),
(61588,'enUS','They are ignorant, and blind to reality. Look around you, pandaren.','',26124),
(61589,'enUS','You will find no better partner in battle than an orc.','',26124),
(61590,'enUS','The tauren have made themselves useful. Look - this one is a shaman.','',26124),
(61591,'enUS','Look out there. Too many for us to take head on.','',26124),
(61592,'enUS','Even a blood elf can hold a sword.','',26124),
(61593,'enUS','Do you see it? Everyone in my Horde earns their keep. You and your friends will be no exception.','',26124),
(61594,'enUS','Do you understand this, pandaren?','',26124),
(61595,'enUS','Yes, warchief.','',26124),
(61596,'enUS','Hm. Good.','',26124),
(61597,'enUS','Moving on. I know that you are not the only pandaren to escape from that island.','',26124),
(61598,'enUS','Some of your kind chose to join the Alliance.','',26124),
(61599,'enUS','They are now your enemies.','',26124),
(61600,'enUS','You may have had friends and kin who chose to cast their lot with the enemies of the Horde. They are no longer your friends... no longer your family.','',26124),
(61601,'enUS','The minute they put on that Alliance tabard, they died. I will NOT tolerate any lingering ties across enemy lines. Traitors to the Horde will die a traitor\'s death!','',26124),
(61602,'enUS','Do I make myself clear?','',26124),
(61603,'enUS','I... I believe so. Yes.','',26124),
(61604,'enUS','Good.','',26124),
(61605,'enUS','Meet me in the Valley of Honor. I have a gift for you.','',26124),
(61606,'enUS','Welcome to the Ring of Valor, pandaren. Make yourself comfortable while I finish preparing.','',26124),
(61607,'enUS','Hah! It looks like we\'re ready. Now, newcomers... prepare to fight!','',26124),
(61608,'enUS','What is that thing?','',26124),
(61609,'enUS','This is my gift to you: a gift, and a trial.','',26124),
(61610,'enUS','I\'ve heard stories about the legendary pandaren and their exotic fighting styles. Now I want to see them.','',26124),
(61611,'enUS','This is a rare opportunity, pandaren. Prove your might to the Warchief of the Horde!','',26124),
(61612,'enUS','Lok\'tar ogar! Victory, or death!','',26124),
(61613,'enUS','Well fought. I don\'t think I could have survived that battle without you at my back.','',26124),
(61614,'enUS','Throm-ka, pandaren. Welcome to the Horde.','',26124),
(61615,'enUS','You are covered in yaungol tar, and can\'t see anything!','',26124),
(61617,'enUS','Foolish trespasser!','',26124),
(61618,'enUS','We will give you a swift death!','',26124),
(61619,'enUS','Fresh meat!','',26124),
(61620,'enUS','Flesh for the Scale-Lord!','',26124),
(61621,'enUS','Gut it!','',26124),
(61622,'enUS','Blood for my blade!','',26124),
(61623,'enUS','New tasty creature!','',26124),
(61624,'enUS','Rip it apart!','',26124),
(61625,'enUS','','Good-bye, little one. I will see you soon enough.',26124),
(61626,'enUS','Never thought I\'d see one of your kind walk through here.','Never thought I\'d see one of your kind walk through here.',26124),
(61627,'enUS','Come on through. The Warchief\'s expecting you.','Come on through. The Warchief\'s expecting you.',26124),
(61628,'enUS','Look! It\'s Ji Firepaw and $p!','',26124),
(61629,'enUS','They\'re the ones who helped Korga Strongmane escape from the Alliance!','',26124),
(61630,'enUS','Look at this!','',26124),
(61631,'enUS','Well, that\'s good news. Once we join the Horde, we certainly won\'t run out of things to do.','',26124),
(61632,'enUS','Pandaren! Approach.','',26124),
(61633,'enUS','Emperor Hellscream, I am Ji...','',26124),
(61634,'enUS','That\'s WARCHIEF Hellscream!','',26124),
(61635,'enUS','Now, rise.','',26124),
(61636,'enUS','We should talk, pandaren.','',26124),
(61637,'enUS','','Welcome to Orgrimmar!',26124),
(61638,'enUS','Have you come to serve the Horde?','Have you come to serve the Horde?',26124),
(61639,'enUS','Best move quickly through this area, stranger.','',26124),
(61640,'enUS','The warchief doesn\'t take kindly to non-orcs loitering in this part of Orgrimmar.','',26124),
(61641,'enUS','He... he segregates the city?','',26124),
(61642,'enUS','Move along, then. Hellscream\'s eyes are upon you.','',26124),
(61643,'enUS','Today they still act as traders, messengers, guides, and pack bearers for expeditions high up in Kun-Lai summit.','',26124),
(61644,'enUS','Whoah.','',26124),
(61645,'enUS','','Whoah.',26124),
(61646,'enUS','Cool!','',26124),
(61647,'enUS','They are a very superstitious people, who often take on the names of their favorite charms, or \"Luckydos.\"','',26124),
(61648,'enUS','','Cool!',26124),
(61649,'enUS','The grummle suspicious of any luck they cannot smell, so it behooves one to meet new grummles with a pocketful of dung.','',26124),
(61650,'enUS','A very strange race, indeed.','',26124),
(61651,'enUS','Hey Zazzle! Look at these goofballs comin\' through.','',26124),
(61652,'enUS','','Pretty funny-lookin\', if you ask me.',26124),
(61653,'enUS','Yeah... pretty funny-lookin\' alright.','',26124),
(61654,'enUS','Zug zug.','',26124),
(61655,'enUS','Me like fish.','',26124),
(61656,'enUS','That\'s great! I like fish too!','',26124),
(61657,'enUS','','Lin is upset - Zhiya was his good friend and we lost him in the battle. \n\nI don\'t want Lin to do something thoughtless. I don\'t know what I\'d do if I lost him...',26124),
(61658,'enUS','Zhiyao dead. Shiya dead. Liu dead.\n\nSuna councils me to calm, but honor demands otherwise.\n\nTaran Zhu sits safe in the monastery while we defend the pass alone? Why shut us out? Why not send reinforcements?\n\nThese questions trouble me.','',26124),
(61659,'enUS','Why should I bloody my blades when I have you to do the dirty work for me?','',26124),
(61660,'enUS','Do not ask needless questions, wallwalker. Focus on the task at hand.','',26124),
(61661,'enUS','I thought he was with you?','',26124),
(61662,'enUS','I\'m fine... but it looks like our friend $p here is completely covered. Let me go get help...','',26124),
(61663,'enUS','Augh! Suna...','',26124),
(61664,'enUS','THREE!','THREE!',26124),
(61665,'enUS','TWO!','TWO!',26124),
(61666,'enUS','ONE!','ONE!',26124),
(61667,'enUS','The Challenge begins!','The Challenge begins!',26124),
(61668,'enUS','The Challenge has been completed!','The Challenge has been completed!',26124),
(61669,'enUS','I think I\'m ready to take that walk now.','I think I\'m ready to take that walk now.',26124),
(61670,'enUS','<Tai Ho is completely silent.>','',26124),
(61671,'enUS','A provisioner\'s work is never done. The Shado-Pan marches on its stomach.$b$bAnd, to some extent, its liver.','',26124),
(61672,'enUS','You take them out. I\'ll hide in the shadows and search their bodies.','',26124),
(61673,'enUS','','Then he\'s out there alone! We\'ve got to find him!',26124),
(61674,'enUS','At first, my deference and respect for Taran Zhu prohibited me from questioning his decision to close the monastery to outsiders.\n\nThen, when the yaungol first attacked, my focus on the battle at hand prevented me from leaving the front lines to question his inability to send reinforcements.\n\nNow, three Shado-Pan lie dead, one is captured, and my patience is beyond worn thin - it is gone. I plan to go to the monastery and demand an audience with Taran Zhu.','',26124),
(61675,'enUS','Here we are. Climb aboard, friend.','',26124),
(61676,'enUS','By the order of lord Taran Zhu, none shall pass.','',26124),
(61677,'enUS','I am here with Ban Bearheart, and we demand an audience with Taran Zhu!','I am here with Ban Bearheart, and we demand an audience with Taran Zhu!',26124),
(61678,'enUS','Demand?! You DEMAND?!','',26124),
(61682,'enUS','I will see you inside the Monastery!','',26124),
(61684,'enUS','From beneath the dark roots of the nearby tree, an ancient terror awakens...','',26124),
(61687,'enUS','I\'m sorry, outsider. Unless you are here on official business, I\'m afraid I can\'t be of any assistance to you.','',26124),
(61688,'enUS','An ill wind blows here in Kun-Lai. I fear a presence unseen for many years may be returning, and these yaungol are just a symptom of it.','',26124),
(61689,'enUS','Something feels... different up here. I don\'t know what, but I expect we shall find out soon enough.','',26124),
(61690,'enUS','I can\'t believe we had to kill one of my order... where has the world gone?','',26124),
(61691,'enUS','','Well, you really sent them flying. I could hear their... bleating from here. \n\nBleating? Is that what you call the sound of a yaungol flying off a wall?',26124),
(61692,'enUS','','Wow. I could hear the explosions from up on the wall.\n\nI guess not ALL of Lao-Chen\'s ideas are terrible.',26124),
(61693,'enUS','','I will give anything, to my last dying breath, to save Lin.',26124),
(61694,'enUS','It won\'t bring our brothers and sisters back, but knowing that we are better than the yaungol helps us sleep better at night.','',26124),
(61695,'enUS','Look, $n. The beast stirs from its lair!','',26124),
(61696,'enUS','Another attack?!\n\nThese yaungol will not relent until we push them back into Townlong. Or, even better, into the sea.','',26124),
(61697,'enUS','You are standing in a lethal cloud!','',26124),
(61698,'enUS','Finally, peace and quiet. Perhaps enough to allow me to contemplate the passing of our brothers and sisters.','',26124),
(61699,'enUS','I have to tell you, I love it when a plan comes together.','',26124),
(61700,'enUS','After all this... our brothers and sisters passing, Lin captured by yaungol, my beer gone, I think it\'s time to move along.\n\nPerhaps I\'ll take the fight to the mantid...','',26124),
(61702,'enUS','As a stranger to these lands, you may not be familiar with the Shado-Pan.','',26124),
(61703,'enUS','Our charge is an ancient one, dating back to the time of Shaohao, our founder and the last emperor of Pandaria.','',26124),
(61704,'enUS','Dark energies embrace this land. Anger, Hatred, Fear, Doubt...','',26124),
(61705,'enUS','These negative emotions can manifest in physical form. We call this dark energy \"Sha.\"','',26124),
(61706,'enUS','It is our sacred duty to monitor and imprison the Sha. To defeat it wherever it darkens the hearts of our people.','',26124),
(61707,'enUS','In all my years, I have never seen the Sha so active as when your soldiers landed on our shores.','',26124),
(61708,'enUS','Pandaria does not have a standing army. We, the Shado-Pan, are its first - and only - line of defense.','',26124),
(61709,'enUS','Taran Zhu leads the Shado-Pan, as his father did before him. But he has elected to close our Monastery gates - why?','',26124),
(61710,'enUS','We must find out. Without the Shado-Pan, Pandaria will surely be engulfed in darkness...','',26124),
(61711,'enUS','Taran Zhu leads the Shado-Pan, as his father did before him. But he has elected to close our Monastery gates - why?','',26124),
(61712,'enUS','We must find out. Without the Shado-Pan, Pandaria will surely be engulfed in darkness...','',26124),
(61713,'enUS','Lao-Chin! We have won the day. Why are you weeping?','',26124),
(61714,'enUS','He must have pursued the fleeing yaungol while we intercepted their leader.','',26124),
(61715,'enUS','Patience, Suna! If we march into Townlong alone, we compound our problems. We must focus on the Monastery and get reinforcements.','',26124),
(61716,'enUS','By closing the monastery - for whatever reason - Taran Zhu has jeopardized that eternal charge.','',26124),
(61717,'enUS','We must not sit idly by in our mountain-top fortress as Pandaria falls apart. And that is why you and I must demand an audience with Taran Zhu.','',26124),
(61718,'enUS','Just point me in the right direction. I\'ll carry the load.','',26124),
(61719,'enUS','Let\'s get going then!','',26124),
(61720,'enUS','You lead the way. I\'ll carry the food.','',26124),
(61721,'enUS','There should be plenty of food stored around this temple.','',26124),
(61722,'enUS','Who are YOU to make demands of the SHADO-PAN?','',26124),
(61723,'enUS','Finish him! Boot him off the wall!','',26124),
(61724,'enUS','World state variables have been reset.','World state variables have been reset.',26124),
(61725,'enUS','Who dares disturb this crypt?','',26124),
(61726,'enUS','%s is about to Overload!','',26124),
(61727,'enUS','<This is more than just a chunk of amber - there\'s a mantid inside!>','',26124),
(61728,'enUS','You have been affected by |cFFFF0404|Hspell:116784|h[Wildfire Spark]|h|r !','You have been affected by |cFFFF4809|Hspell:116784|h[Wildfire Spark]|h|r !',26124),
(61729,'enUS','The Klaxxi have betrayed her majesty. Your corpses will be strung from the palace walls for this.','',26124),
(61730,'enUS','It is... the empress who has betrayed... our people...','',26124),
(61731,'enUS','How DARE you question her will!','',26124),
(61732,'enUS','What\'s this?! Now they come over the wall to oppose us? The fools!','',26124),
(61733,'enUS','$C... approach me...','',26124),
(61734,'enUS','Destroy the Piles of Corpses to stop the Zombified Corpses!','',26124),
(61735,'enUS','Play with fire, and you might just get burned.','Play with fire, and you might just get burned.',26124),
(61736,'enUS','Would you accompany me?','Would you accompany me?',26124),
(61737,'enUS','Join me.','Join me.',26124),
(61738,'enUS','To become a Shado-Pan, one must dedicate $Ghimself:herself; in body, mind, and soul.','',26124),
(61739,'enUS','The Shado-Pan are few in number, but we make up for it in strength.','',26124),
(61740,'enUS','From the west, the mantid stir.$B$BFrom the northwest, the mogu practice their dark arts.$B$BFrom the north, the yaungol press us.$B$BThere is too much to do, and too little time.','',26124),
(61741,'enUS','Every Shado-Pan knows one another by name. We have trained together, fought together, and survived together.$B$BWhen you can say the same, then perhaps you are ready to join our brotherhood.','',26124),
(61742,'enUS','I\'m ready to light this place up!','I\'m ready to light this place up!',26124),
(61743,'enUS','HURGHHH!!','',26124),
(61744,'enUS','Ah! Help! Sprites!','',26124),
(61745,'enUS','Get them off me! Get them off me!','',26124),
(61746,'enUS','Sooo spikey! Ouch! Ouch!','',26124),
(61747,'enUS','Help!','',26124),
(61748,'enUS','Ah! Needles on my face!','',26124),
(61749,'enUS','Oh the pain!','',26124),
(61750,'enUS','Get off me!','',26124),
(61751,'enUS','I just wanted my yaks back...','',26124),
(61752,'enUS','','Wait for it...',26124),
(61753,'enUS','','Now!',26124),
(61754,'enUS','Where are the northern sentries? I didn\'t spot a single one of your men before reaching the camp. You grow lax, Gao-Ran.','',26124),
(61755,'enUS','With all due respect, Lord, we have not grown lax. We are stretched thin. We are beset on all fronts, my men are worked to the bone, and I have not a single warrior to spare.','',26124),
(61756,'enUS','No, we will not be pulling back. It\'s many years yet before the mantid birth their next swarm. I will not see the Townlong Steppes given to them freely.','',26124),
(61757,'enUS','Lord Zhu, the mantid have not been seen in these numbers since the swarm more than 90 years ago. My men are going days without sleep just to hold this line.','',26124),
(61758,'enUS','Perhaps we should pull back to the wall?  If the full force of the mantid come, we can confidently hold them there.','',26124),
(61759,'enUS','I had come to seek strong pandaren to hunt the Sha of Hatred, but we will step in here and help you fortify the barricade first.','',26124),
(61760,'enUS','Taoshi, go north and make sure there are no mantid on our flank. I will see to the defenses.','',26124),
(61761,'enUS','The men will be glad to have you with us, Lord Zhu.','',26124),
(61762,'enUS','I\'ve gone too long without visiting the front, Gao-Ran. Your long efforts are appreciated.','',26124),
(61763,'enUS','It is time for us to continue westward $p, after the Sha of Hatred.','',26124),
(61764,'enUS','Come. Let us go.','',26124),
(61765,'enUS','We will need more veteran Shado-Pan among us before we can confront it.  We\'ll stop at the encampments along the way.','',26124),
(61766,'enUS','<Sticky orange fluid oozes from Kil\'ruk\'s mandibles.>','',26124),
(61767,'enUS','My head swims... I am... not myself yet.','',26124),
(61768,'enUS','','At once, Lord Zhu.',26124),
(61769,'enUS','','May the road rise to meet you, traveler.$b$bWhat brings you here?',26124),
(61770,'enUS','We\'ve done all we can here. Farewell Gao-Ran. I will send more men as soon as I am able.','',26124),
(61771,'enUS','Appreciated, Lord Zhu.  Good luck in your hunt.','',26124),
(61772,'enUS','Yes. The Sha of Hatred has been through here.','',26124),
(61773,'enUS','','Do you feel that...?',26124),
(61774,'enUS','','Their camp is in shambles. What happened?',26124),
(61775,'enUS','You, initiate. Where are the troops?','',26124),
(61776,'enUS','Lord Zhu! They are down at the bridge, holding off a mantid attack force, sir.','',26124),
(61777,'enUS','$p, Taoshi, help these men get their camp in order.  I\'ll assess the state of the bridge.','',26124),
(61778,'enUS','','I\'ll handle the rest of this. You take those arrows and get down to the action at the bridge.',26124),
(61779,'enUS','What is a \"luckydo\"?','What is a \"luckydo\"?',26124),
(61780,'enUS','A Luckydo? Why it is a person, place or thing of good luck and fortune.$b$bIt is a most high compliment from grummles to be called a luckydo.$b$bUsually a luckydo has special smell to it. Grummle noses are keen for finding luck by its scent.','',26124),
(61781,'enUS','I want to ask something else.','I want to ask something else.',26124),
(61782,'enUS','What is a grummle?','What is a grummle?',26124),
(61783,'enUS','Why we are the grummles! The mountain ferries. The packers of the trails. The guides through the mountains. and the deliverers of supplies.$b$bWe are the people who keep the defenders of the wall fed, and we are the people who travel the Burlap Trail since the time of the mogu dynasties.$b$bWe also have the most best noses for smelling luck!','',26124),
(61784,'enUS','I am returned to serve the council. But you are no Klaxxi\'va...','',26124),
(61785,'enUS','Take me to the Wreck of the Sky Shark!','Take me to the Wreck of the Sky Shark!',26124),
(61786,'enUS','%s barks loudly, calling nearby allies to its aid!','%s barks loudly, calling nearby allies to its aid!',26124),
(61787,'enUS','','I will say, the Forsaken have... strange taste when it comes to brew. I get the feeling they\'re not exactly preparing it for friends, though.',26124),
(61788,'enUS','Take me to the Wreck of the Sky Shark!','Take me to the Wreck of the Sky Shark!',26124),
(61789,'enUS','','Yes?',26124),
(61790,'enUS','If you are so curious about the mantid, I will tell you more on the way to Klaxxi\'vess.$B$BOtherwise, leave me to my work.','',26124),
(61791,'enUS','','These Forsaken are quick students. I guess you can teach an old... and, well, formerly living dog new tricks.',26124),
(61792,'enUS','What is she saying?','',26124),
(61793,'enUS','Monk','Monk',26124),
(61794,'enUS','In War Quarter inner ring. She drunk lots.','In War Quarter inner ring. She drunk lots.',26124),
(61795,'enUS','She scare me, she mean and say we smell bad. She in War Quarter, inner ring.','She scare me, she mean and say we smell bad. She in War Quarter, inner ring.',26124),
(61796,'enUS','The monk trainer is in the inner ring of the War Quarter. She\'s training some of our Deathguards in her people\'s fighting style.','The monk trainer is in the inner ring of the War Quarter. She\'s training some of our Deathguards in her people\'s fighting style.',26124),
(61797,'enUS','You\'ll find her in the inner ring of the War Quarter.','You\'ll find her in the inner ring of the War Quarter.',26124),
(61798,'enUS','Many thousands of years ago, the mogu held all the power. They ruled this land with fists of iron. But as their empire grew, they needed a way to police and control it.','',26124),
(61799,'enUS','They used the powers of the Vale, and their own flesh-warping magics, to twist and shape a race of ferocious lizards into a living weapon. They created an army. An army of Saurok. Bloodthirsty savages created to enforce the will of the emperor.','',26124),
(61800,'enUS','Ah, but there is a problem with creating a living weapon. Do you see?','',26124),
(61801,'enUS','Who, now, wields the power?','',26124),
(61802,'enUS','The heartless saurok, even with their tiny lizard brains, soon realized the truth of their position. They killed the enemies of the mogu.','',26124),
(61803,'enUS','Then they killed the subjects of the mogu.','',26124),
(61804,'enUS','Soon, they started killing the mogu themselves.','',26124),
(61805,'enUS','The mogu emperor then ordered all of the saurok to be purged. He tried to wipe out their entire race, to no avail. They still plague Pandaria to this day.','',26124),
(61806,'enUS','So you see - power is easily taken, but should not be lightly given.','',26124),
(61807,'enUS','Monk','Monk',26124),
(61808,'enUS','Oh, Aysa? I think I saw her training other pandaren near the lake, northwest of Stormwind Keep.','Oh, Aysa? I think I saw her training other pandaren near the lake, northwest of Stormwind Keep.',26124),
(61809,'enUS','','This city is so unlike anything from home...\n\nAh, friend, how may I help you?',26124),
(61810,'enUS','','There are so many strange and interesting things in this land. It is different, but I am impressed.',26124),
(61811,'enUS','Patience... let them come to us!','',26124),
(61812,'enUS','ATTACK!!!','',26124),
(61813,'enUS','','Of course, Lord Zhu.',26124),
(61814,'enUS','The fight is THAT way, $R.','',26124),
(61815,'enUS','You\'re supposed to hit the big guy, not me.','',26124),
(61816,'enUS','Get back out there and fight!','',26124),
(61817,'enUS','You\'re lucky our clan leader is holding me back.','',26124),
(61818,'enUS','You\'re messing with the wrong Mogu, $R.','',26124),
(61819,'enUS','Monk','Monk',26124),
(61820,'enUS','Oh, Liu of the Bottomless Tankard? He\'s been in a drinking contest for the longest time at the Stonefire Tavern, just north of the gates of Ironforge.','Oh, Liu of the Bottomless Tankard? He\'s been in a drinking contest for the longest time at the Stonefire Tavern, just north of the gates of Ironforge.',26124),
(61821,'enUS','Ah, a brawler are ye\'? You\'ll find your pandaren friend at the Stonefire Tavern.','Ah, a brawler are ye\'? You\'ll find your pandaren friend at the Stonefire Tavern.',26124),
(61822,'enUS','','I may not know how to fight yet, but I do know what\'s worth fighting for!',26124),
(61823,'enUS','','My father thinks he can tell me what to do still! I\'m not a child anymore and he needs to see that.',26124),
(61824,'enUS','','I have as much a right as any in the village to fight for my home. If I only knew a hero that could train me...',26124),
(61825,'enUS','These are my kind of people. You can really feel like they\'re going somewhere!\n\nAnyways, what can I show you about being a monk, friend?','',26124),
(61826,'enUS','People here really see the world the way I do. You\'ve got to make a place for yourself, you know?','',26124),
(61827,'enUS','','Looks like we have our work cut out for us...',26124),
(61828,'enUS','','Ready when you are, $p.',26124),
(61829,'enUS','','Good work. Let\'s meet back up with Lord Zhu. There\'s nothing more we can do here.',26124),
(61830,'enUS','','Take cover behind the barricades!',26124),
(61831,'enUS','','Get behind the barricades!',26124),
(61832,'enUS','Monk','Monk',26124),
(61833,'enUS','Oh, Ji? He\'s at the Pandaren Pavillion in the Valley of Honor, checking out the fights and talking with the warriors.','Oh, Ji? He\'s at the Pandaren Pavillion in the Valley of Honor, checking out the fights and talking with the warriors.',26124),
(61834,'enUS','Ji usually stays at the Pandaren Pavillion. It\'s close to the arena, and he loves to watch the fights. I hear he even participates once in a while.','Ji usually stays at the Pandaren Pavillion. It\'s close to the arena, and he loves to watch the fights. I hear he even participates once in a while.',26124),
(61835,'enUS','Let\'s get this training started!','Let\'s get this training started!',26124),
(61836,'enUS','','Alright! Let\'s get down to business!',26124),
(61838,'enUS','%s runs out of ammunition and flies away!','',26124),
(61839,'enUS','How may I help you?','How may I help you?',26124),
(61840,'enUS','I have nothing to teach you, $c.','I have nothing to teach you, $c.',26124),
(61841,'enUS','Monk','Monk',26124),
(61842,'enUS','Lanfen can be found meditating over the lake in the Temple Gardens. I hear she makes quite marvelous teas.','Lanfen can be found meditating over the lake in the Temple Gardens. I hear she makes quite marvelous teas.',26124),
(61843,'enUS','','Thank you for your time. I hope you will reconsider training me in the future.',26124),
(61844,'enUS','Monk','Monk',26124),
(61845,'enUS','You will find Tseh Rah on the Spirit Rise. She has been meeting with the Shaman Trainers there.','You will find Tseh Rah on the Spirit Rise. She has been meeting with the Shaman Trainers there.',26124),
(61846,'enUS','Monk','Monk',26124),
(61847,'enUS','Old Sho can be found in the Farstrider\'s Square, practicing his moves.','Old Sho can be found in the Farstrider\'s Square, practicing his moves.',26124),
(61848,'enUS','Pan of the Martial Spirit trains with the warriors on the Warriors\' Terrace, overlooking the rest of the Trader\'s Tier.','Pan of the Martial Spirit trains with the warriors on the Warriors\' Terrace, overlooking the rest of the Trader\'s Tier.',26124),
(61849,'enUS','Monk','Monk',26124),
(61850,'enUS','The trick to dealing with pirate hozen is to have the element of surprise.','',26124),
(61851,'enUS','Okay... so... the new trick to dealing with pirate hozen is to do what you just did right there.','',26124),
(61852,'enUS','Wait! Do you hear that? It sounds like tiny wings flapping...','',26124),
(61853,'enUS','Watch out!','',26124),
(61854,'enUS','We\'d better keep moving before this whole island finds out we\'re here.','',26124),
(61855,'enUS','Hozen gladiators? Where did they get all of these weapons?','',26124),
(61856,'enUS','Well! This looks like as good a place to brew as any.','',26124),
(61857,'enUS','Know the only thing worse than a pirate? Hozen pirates! They raid our shores and steal our fish, our boats, and our brew. No one steals our brew... no one.','',26124),
(61858,'enUS','Let\'s get going!','Let\'s get going!',26124),
(61859,'enUS','Captain Ook is comin\' down with the scurvy! Keep the orange away from him!','',26124),
(61860,'enUS','Readying Zip Line','Readying Zip Line',26124),
(61861,'enUS','Ouch! Ouch! Ouch!','',26124),
(61862,'enUS','Birds too?! How\'d they even learn to tame the birds?!','',26124),
(61863,'enUS','Say hello to my little friend!','',26124),
(61864,'enUS','I\'ll cut you in two!','',26124),
(61865,'enUS','You\'re what\'s for dinner!','',26124),
(61866,'enUS','Dinner\'s ready!','',26124),
(61867,'enUS','You look a little pale!','',26124),
(61868,'enUS','You don\'t look so good!','',26124),
(61869,'enUS','Ookie\'s hungry!','',26124),
(61870,'enUS','Ookie want fish! Fish give me strength to finish you dookers!','',26124),
(61871,'enUS','Get out of my kitchen!','',26124),
(61872,'enUS','This cauldron will be perfect for brewing our... brew.','',26124),
(61873,'enUS','DELICIOUS!','',26124),
(61874,'enUS','Is that my belly rumbling, or is something BIG coming?','',26124),
(61876,'enUS','Run away!','',26124),
(61877,'enUS','YOU BETTER BE READY TO GET SOME OOK IN YER DOOKER!','',26124),
(61878,'enUS','Bam ba-ba-BAM!','',26124),
(61879,'enUS','$n has got the orange!','',26124),
(61880,'enUS','Captain Ook\'s got the full blown scurvy!','',26124),
(61881,'enUS','$n tossed the orange!','',26124),
(61882,'enUS','You makin me \'ookin ANGRY!','',26124),
(61883,'enUS','You dookers! Give me \'dat orange!','',26124),
(61884,'enUS','No fair! Three of you wikkets against one o\' me?!','',26124),
(61885,'enUS','You take my orange?! What a slap in face!','',26124),
(61886,'enUS','I need dat orange! Gimme!','',26124),
(61887,'enUS','Ha! Much better! Now you dookers gonna get it!','',26124),
(61888,'enUS','','I heard the mines are infested with spiders again. I really hope no one gets hurt.',26124),
(61889,'enUS','','They say strangers from beyond the mists have started showing up across the Jade Forest. Strange times.',26124),
(61890,'enUS','','I heard some of the earth spirits are unhappy with the Greenstone Quarry. I hope they don\'t take it out on us.',26124),
(61891,'enUS','','How are the noodles today?',26124),
(61892,'enUS','I am Kil\'ruk, a warrior from an era long passed.','',26124),
(61893,'enUS','In my time, this was a mogu stronghold. It was my honor to paint the walls with their blood.','',26124),
(61894,'enUS','For my deeds, I was named a Paragon. A hero to be preserved in amber for a time when the empire would need... correcting.','',26124),
(61895,'enUS','Wakener, what power is this that burns our land and corrupts our trees?','',26124),
(61896,'enUS','The palace! This is... not our way.  I see why the Klaxxi have been forced to act.','',26124),
(61897,'enUS','They are a council of our wisest cultural leaders. They serve to check the power of the Empress.','',26124),
(61898,'enUS','One of you, stay with me to keep the cauldron safe. The others, go find some Unga Jungle Brew and bring it back!','',26124),
(61899,'enUS','Should the Empress ever fall to corruption or endanger our civilization, the Klaxxi are sworn to unseat her.','',26124),
(61900,'enUS','There are others like me. Paragons of each era, frozen in time and buried safely beyond the whispers of the Empress.','',26124),
(61901,'enUS','We answer only to the council. And we rest only when their will is done.','',26124),
(61902,'enUS','Ah, here\'s the $c I was telling you about.','',26124),
(61903,'enUS','Would you like to start the Challenge?','Would you like to start the Challenge?',26124),
(61904,'enUS','Good! Let\'s clear out some of these mantid, then we can retake that bridge.','',26124),
(61905,'enUS','Lord Zhu, we\'ll return shortly.','',26124),
(61906,'enUS','Yes, start the Challenge.','Yes, start the Challenge.',26124),
(61907,'enUS','With pleasure. Return to me when you two are finished.','',26124),
(61908,'enUS','Come, $p, let\'s push these insects back!','',26124),
(61909,'enUS','This is where we make our stand!','',26124),
(61910,'enUS','Drink this. It has a bit of a kick.','',26124),
(61911,'enUS','Have a sip of this!','',26124),
(61912,'enUS','Pour this one back!','',26124),
(61913,'enUS','Kick the keg at them!','',26124),
(61915,'enUS','Get clear!','',26124),
(61916,'enUS','You\'ve got him, keep it up!','',26124),
(61917,'enUS','He\'s almost down!','',26124),
(61918,'enUS','Nice work, $p! You were the right choice for the task.','',26124),
(61919,'enUS','Make your way back to Taran Zhu. I\'ll catch up with you shortly.','',26124),
(61920,'enUS','The crossroads are not far. Let us seek out our last member there.','',26124),
(61921,'enUS','My men speak highly of this Nurong, it will be good to finally meet him.','',26124),
(61922,'enUS','','Is it to be Hawkmaster Nurong then?',26124),
(61923,'enUS','Ooooh, you have lots of pretty things to steal!  Gimme!','',26124),
(61924,'enUS','Meanie...','',26124),
(61925,'enUS','You are to join us in our hunt of the Sha of Hatred then, Lao-Chin. The men here should be able to hold the bridge and repair the camp on their own.','',26124),
(61926,'enUS','Of course.  My staff is yours, Lord Zhu.','',26124),
(61927,'enUS','I take it you were successful at the bridge?','',26124),
(61928,'enUS','We were.  My new friend here performed stunningly!','',26124),
(61929,'enUS','Yes.  We\'ll need his expertise with a crossbow when the final battle comes.','',26124),
(61931,'enUS','Good to see you well, Rensai. We\'re here for Hawkmaster Nurong. Where can we find him?','',26124),
(61932,'enUS','Well met, Lord Zhu. He\'s with the rest of my men, holding the line at Farwatch Overlook.','',26124),
(61933,'enUS','Farwatch Overlook?  I\'ve heard no reports of mantid in the chasm below.','',26124),
(61935,'enUS','No, not the chasm. Fliers.  In numbers like we\'ve never seen.','',26124),
(61936,'enUS','Taoshi, the Sha of Hatred is close. Find it and report back to me.','',26124),
(61938,'enUS','Strange... this one carries a few pieces of polished stone.','',26124),
(61939,'enUS','Hopefully they came from Niuzao\'s statuette. We can only hope.','',26124),
(61940,'enUS','Another stone... and it matches the markings on the others we found.','',26124),
(61941,'enUS','I think we\'re getting somewhere, $p. Let\'s keep looking around.','',26124),
(61942,'enUS','If I didn\'t know any better, I\'d say this was a stone ox tail.','',26124),
(61943,'enUS','All that\'s left now is the head. And it can\'t have gotten far.','',26124),
(61944,'enUS','Here\'s the head. A perfect fit, too.','',26124),
(61945,'enUS','We\'ve performed Niuzao\'s errand. Now it\'s time to get back to some real investigation.','',26124),
(61946,'enUS','Stand in Blanche\'s Elixir of Replenishment to restore health and mana!','Stand in Blanche\'s Elixir of Replenishment to restore health and mana!',26124),
(61947,'enUS','$p, help at Farwatch Overlook and then bring Nurong back to us here. Our final confrontation approaches swiftly.','',26124),
(61948,'enUS','Arm the cannons! Ready...aim...fire!','',26124),
(61949,'enUS','They are soft, weak!','',26124),
(61950,'enUS','Retreat to the hills!','',26124),
(61951,'enUS','Bring me their corpses!','',26124),
(61952,'enUS','$C, up here! I could use a hand!','',26124),
(61953,'enUS','Loot and pillage, bwahahaha!','',26124),
(61954,'enUS','A large wave of fliers approaches! Take my cannon, $c, quickly!','',26124),
(61955,'enUS','What... what is that thing?  Is it really trying to fly across?','',26124),
(61956,'enUS','It\'s getting closer!  Shoot it down!','',26124),
(61957,'enUS','Nice work!  Let\'s get down there and finish it off.','',26124),
(61958,'enUS','Its shell is cracked in the back. Hit it where it hurts!','',26124),
(61959,'enUS','Attacks from the back will be more effective.','',26124),
(61960,'enUS','I\'ve got its attention! Give it everything you\'ve got!','',26124),
(61961,'enUS','It\'s after me now, get behind it and do all the damage you can!','',26124),
(61962,'enUS','Warmongers leap from Galleon\'s back to join the battle!','',26124),
(61963,'enUS','Whatever you do, don\'t let it hit you!','',26124),
(61964,'enUS','|TInterface\\Icons\\ability_warstomp.blp:20|t Galleon is about to |cFFFF0000|Hspell:121787|h[Stomp]|h|r!','',26124),
(61965,'enUS','It\'s after you!  Don\'t let it get close.','',26124),
(61966,'enUS','|TInterface\\Icons\\ability_vehicle_siegeenginecannon.blp:20|t Galleon prepares to unleash a |cFFFF0000|Hspell:121600|h[Cannon Barrage]|h|r!','',26124),
(61967,'enUS','It\'s stunned. Now\'s our chance to finish it off!','',26124),
(61968,'enUS','Masterful.','',26124),
(61969,'enUS','I\'m proud to fight by your side.','',26124),
(61970,'enUS','If Lord Zhu was asking for us, we better not keep him waiting.  Let us go.','',26124),
(61971,'enUS','This place doesn\'t look good.','',26124),
(61972,'enUS','We\'ve found the hiding place of the Sha of Hatred.','',26124),
(61973,'enUS','Welcome, Nurong. Good to have you with us.','',26124),
(61974,'enUS','Yes... this must be it. We\'re headed the right way.','',26124),
(61975,'enUS','Which way to go? Up, or down?','',26124),
(61976,'enUS','Can you sense it, $p? This is where the Sha of Fear was held.','',26124),
(61977,'enUS','Stay calm, $p. Focus on your goal, not on your fears.','',26124),
(61978,'enUS','As you wish. We will find your artifact. $p - I will meet you at the Sra\'thik Incursion.','',26124),
(61979,'enUS','','Come $p, let me show you.',26124),
(61980,'enUS','','Look through the spyglass.',26124),
(61981,'enUS','','The Sha of Hatred is inside that mantid structure... I suspect it was drawn to a powerful host there.',26124),
(61982,'enUS','','To get in, we will need specially tuned crystals from some of the mantid leaders in the area.',26124),
(61983,'enUS','','I located these leaders here...',26124),
(61984,'enUS','','here...',26124),
(61985,'enUS','','and here.',26124),
(61986,'enUS','','Kill them.  Take the crystals.  Should be simple enough.',26124),
(61987,'enUS','Come here, $r. I wish to speak with you. Our secret can remain hidden no longer.','',26124),
(61988,'enUS','As I suspected. Thank you, Ogos. $p - I will meet you in the catacombs.','',26124),
(61989,'enUS','Taoshi, Lao-Chin, Nurong, you all have your assignments.  Set up at each location and wait for our signal.','',26124),
(61990,'enUS','Taoshi, did you bring the shackles and rings?','',26124),
(61991,'enUS','Remember your training.  As long as you do not give in to hatred, you will make it out alive.','',26124),
(61993,'enUS','Same drill as before. You do the killing, I\'ll do the searching.','',26124),
(61994,'enUS','This place doesn\'t look pretty. Come on, $n. Let\'s go inside.','',26124),
(61995,'enUS','$p, my men have been instructed to wait for your arrival before they attack. Do not delay.','',26124),
(61997,'enUS','Do you each have the crystals?','',26124),
(61998,'enUS','','Yes.',26124),
(61999,'enUS','Yes.','',26124),
(62000,'enUS','Yes.','',26124),
(62001,'enUS','','...yes, Lord Zhu.',26124),
(62002,'enUS','Let\'s go.','',26124),
(62004,'enUS','Come, lambs... come and face your demise!','',26124),
(62005,'enUS','The hatred inside you drives your hunt for me.  You are already mine.','',26124),
(62006,'enUS','Give in.  The more you fight, the more your hatred broils within you.','',26124),
(62007,'enUS','Blanche senses there are no longer allies nearby and retreats!','Blanche senses there are no longer allies nearby and retreats!',26124),
(62008,'enUS','You are nearly dead!','You are nearly dead!',26124),
(62009,'enUS','Wind-Reaver. You have awakened. What of Klaxxi\'va Tik?','',26124),
(62010,'enUS','And what is this filth you\'ve brought to our sanctuary?','',26124),
(62011,'enUS','The Klaxxi\'va you sent has fallen to an adjunct of Her majesty.','',26124),
(62012,'enUS','This... \"filth\" defeated the adjunct and saw to my Wakening.','',26124),
(62013,'enUS','We do not need help from the lesser races! Dispose of it!','',26124),
(62014,'enUS','Right away, Klaxxi\'va.','',26124),
(62015,'enUS','Let\'s give it another shot!','Let\'s give it another shot!',26124),
(62016,'enUS','No.','',26124),
(62017,'enUS','The Wakener may prove useful. One way or another.','',26124),
(62018,'enUS','You are dying!','You are dying!',26124),
(62019,'enUS','You are near death!','You are near death!',26124),
(62020,'enUS','You\'re almost dead!','You\'re almost dead!',26124),
(62021,'enUS','Don\'t die!','Don\'t die!',26124),
(62022,'enUS','Everything that you are is MINE to destroy!','',26124),
(62023,'enUS','The Amberwing is flying in, watch out!','',26124),
(62024,'enUS','That mantid is its host.  Chain it down.  We will rip the hatred from its body!','',26124),
(62025,'enUS','Demolishers are carrying explosives! Any direct hit will blow them up!','',26124),
(62026,'enUS','Hold off the mantid!  This will not take long.','',26124),
(62027,'enUS','Keep the mantid back!  We are almost done.','',26124),
(62028,'enUS','Hatred, come out and face your defeat!','',26124),
(62029,'enUS','This is your moment, Shado-Pan!  This is everything that you\'ve trained for!','',26124),
(62030,'enUS','Taran Zhu, you are a fool.  You escaped me only to return with your hatred broiling inside you.  You... are... MINE!','',26124),
(62031,'enUS','','Shackles, NOW!',26124),
(62032,'enUS','As fodder for the swarm, perhaps!','',26124),
(62033,'enUS','What brings you to our temple, $r?','',26124),
(62034,'enUS','I take pride in the fact that I am continuing my father\'s legacy here.$b$bA still-growing legacy, I might add.','',26124),
(62035,'enUS','What is this?!  A trap?','',26124),
(62036,'enUS','We are the protectors - immovable and unflappable.$b$bWhen we are moving, nothing can stop us from moving. When we are standing still, nothing can budge us.','',26124),
(62037,'enUS','Clever Shado-Pan... I underestimated you.  But your leader is mine now.  You cannot free him without freeing me as well.','',26124),
(62038,'enUS','','As is his will.  It is our sworn duty to see you confined, and he sees it done.',26124),
(62039,'enUS','','Some consider these yaks to be lowly beasts, suitable only for grazing and menial labor. Few recognize the innate beauty that these creatures - the scions of the Black Ox - truly possess.',26124),
(62041,'enUS','His sacrifice inspires us all.','',26124),
(62042,'enUS','','We couldn\'t have done this without you, $p.  Thank you.',26124),
(62043,'enUS','','Your move.  I\'ll follow you in.',26124),
(62044,'enUS','','Good work.',26124),
(62045,'enUS','I\'ll cover you.  Go whenever you\'re ready.','',26124),
(62046,'enUS','Very impressive!','',26124),
(62047,'enUS','I\'ll be with you.','',26124),
(62048,'enUS','Not bad... not bad.','',26124),
(62049,'enUS','Something is happening with the mantid... and I suspect it has to do with that temple across the bridge.','',26124),
(62050,'enUS','I will rendezvous with you at Niuzao temple, $p. Our investigation isn\'t nearly over yet...','',26124),
(62051,'enUS','','You are welcome among the Shado-Pan.',26124),
(62052,'enUS','','Stay light on your feet.',26124),
(62053,'enUS','','I would recommend against such actions...',26124),
(62054,'enUS','Good to see you, friend.','',26124),
(62055,'enUS','Find me for a drink sometime.','',26124),
(62056,'enUS','Alright, you can stop now.','',26124),
(62057,'enUS','Hey there.','',26124),
(62058,'enUS','Bye for now.','',26124),
(62059,'enUS','Ooh, we\'re going to play the poking game?  I like the poking game!','',26124),
(62060,'enUS','Ouch!','',26124),
(62062,'enUS','Hahah, good work!','',26124),
(62063,'enUS','Welcome!','',26124),
(62064,'enUS','Any friend of the Shado-Pan is a friend of mine.','',26124),
(62065,'enUS','Glad to have you.','',26124),
(62066,'enUS','How can I help?','',26124),
(62067,'enUS','Farewell for now, friend.','',26124),
(62068,'enUS','Travel safely.','',26124),
(62069,'enUS','May the hawks watch over you.','',26124),
(62070,'enUS','See you again soon.','',26124),
(62071,'enUS','My kindness only extends so far, friend.','',26124),
(62072,'enUS','You.  Me.  We\'re done.','',26124),
(62073,'enUS','','Good to see you.',26124),
(62074,'enUS','','Ready for some action?',26124),
(62075,'enUS','','You have my attention.',26124),
(62076,'enUS','','Are you here to fight?',26124),
(62077,'enUS','','Be wary beyond the wall.',26124),
(62078,'enUS','','Keep your eyes keen, adventurer.',26124),
(62079,'enUS','','The Shado-Pan will be here if you need us.',26124),
(62080,'enUS','','May fortune follow you.',26124),
(62081,'enUS','','You overestimate my patience.',26124),
(62082,'enUS','','Keep it up... they\'ll never find your body.',26124),
(62083,'enUS','Well look who it is!','',26124),
(62084,'enUS','Come to share in some of Tenwu\'s fine company?','',26124),
(62085,'enUS','Welcome.','',26124),
(62086,'enUS','You kind of like me, don\'t you?','',26124),
(62087,'enUS','You\'ll be back.','',26124),
(62088,'enUS','Always good talking to you.','',26124),
(62089,'enUS','Talk to you soon.','',26124),
(62090,'enUS','Goodbye.','',26124),
(62091,'enUS','Such attention!  You flatter me, love.','',26124),
(62092,'enUS','Care to take this somewhere private?','',26124),
(62093,'enUS','Take me to Klaxxi\'vess.','Take me to Klaxxi\'vess.',26124),
(62094,'enUS','You picked me!  I\'m flattered!','',26124),
(62095,'enUS','I\'ll gladly spend the day with you.','',26124),
(62096,'enUS','There\'s some adventuring in store for us today, then?','',26124),
(62097,'enUS','I like the way you think.','',26124),
(62098,'enUS','Ready when you are.','',26124),
(62099,'enUS','I won\'t leave your side.','',26124),
(62100,'enUS','','Let\'s get down to business.',26124),
(62101,'enUS','','Where to, $p?',26124),
(62102,'enUS','','I\'m with you.',26124),
(62103,'enUS','','We\'ll have this whole island cleared out soon.',26124),
(62104,'enUS','','You and I work well together.',26124),
(62105,'enUS','','There\'s no escape for you, insects.  You face the Shado-Pan this day.',26124),
(62106,'enUS','','You should have stayed in the Dread Wastes.',26124),
(62107,'enUS','','Your queen sends you to your deaths.',26124),
(62108,'enUS','','Silent and deadly.',26124),
(62109,'enUS','','Hahahah... nice one.',26124),
(62110,'enUS','Off-landers bringin\' shinies to hozen?!','',26124),
(62111,'enUS','','Impressive.',26124),
(62112,'enUS','Ookin\' treasure fallin\' from the sky!','',26124),
(62113,'enUS','Got any ookin\' treasure, off-lander?','',26124),
(62114,'enUS','Ookin\' wikkets wreckin\' hozen homeland!','',26124),
(62115,'enUS','This hozen land! No wikkets!','',26124),
(62116,'enUS','Very well fought.','',26124),
(62117,'enUS','I softened you up. My cousins will finish you off!','',26124),
(62118,'enUS','Too many hozen. You die soon, offlander.','',26124),
(62119,'enUS','Reekin\' off-lander!','',26124),
(62120,'enUS','Hozen have all you treasure now, off-lander.','',26124),
(62121,'enUS','Off-lander smell like rotton dooker!','',26124),
(62122,'enUS','I\'m right behind you.','',26124),
(62123,'enUS','Skillfully done.','',26124),
(62124,'enUS','You\'d think by now they\'d learn to just run away.','',26124),
(62125,'enUS','Suicidal bugs, aren\'t they?','',26124),
(62126,'enUS','Quite the thrill.','',26124),
(62127,'enUS','You\'re impressive.','',26124),
(62128,'enUS','You fight with flare.  I like that.','',26124),
(62129,'enUS','Where\'d you learn to do that?','',26124),
(62130,'enUS','My compliments.','',26124),
(62131,'enUS','It\'s a wonder these mantid keep coming back for more.','',26124),
(62132,'enUS','You\'d think we\'d have killed all of them by now.','',26124),
(62133,'enUS','I don\'t think they\'re getting the message.','',26124),
(62134,'enUS','Quite the welcome for our good mantid friends.','',26124),
(62135,'enUS','Come back to camp when you are finished. We have much to discuss.','',26124),
(62136,'enUS','A flare has been spotted. The Boom Boom Brew Defender can now be fired.','',26124),
(62138,'enUS','|TInterface\\Icons\\inv_misc_uncutgemnormal.blp:20|tMove away from your allies! A Sra\'thik Amber-Trapper is casting |cFFF00000|Hspell:121881|h[Amber Prison]|h|r on you!','|TInterface\\Icons\\inv_misc_uncutgemnormal.blp:20|tMove away from your allies! A Sra\'thik Amber-Trapper is casting |cFFF00000|Hspell:121881|h[Amber Prison]|h|r on you!',26124),
(62139,'enUS','Everyone has left you.','Everyone has left you.',26124),
(62140,'enUS','You are alone in the world.','You are alone in the world.',26124),
(62141,'enUS','Everybody left. Nobody likes you.','Everybody left. Nobody likes you.',26124),
(62142,'enUS','You have been abandoned.','You have been abandoned.',26124),
(62143,'enUS','Nobody notices you.','Nobody notices you.',26124),
(62144,'enUS','You\'re going to fall!','You\'re going to fall!',26124),
(62145,'enUS','Your feet have left the ground!','Your feet have left the ground!',26124),
(62146,'enUS','Don\'t fall!','Don\'t fall!',26124),
(62147,'enUS','Cloudrider Hatchling is very glad to see you!','',26124),
(62148,'enUS','Cloudrider Hatchling licks you affectionately.','',26124),
(62149,'enUS','Cloudrider Hatchling flies in a loop.','',26124),
(62150,'enUS','Cloudrider Hatchling is very happy!','',26124),
(62151,'enUS','Cloudrider Hatchling wants to play!','',26124),
(62152,'enUS','Cloudrider Hatchling nuzzles your hand.','',26124),
(62153,'enUS','|TInterface\\Icons\\spell_yorsahj_bloodboil_yellow.blp:20|tRun! You are covered in |cFFF00000|Hspell:122064|h[Corrosive Resin]|h|r!','|TInterface\\Icons\\spell_yorsahj_bloodboil_yellow.blp:20|tRun! You are covered in |cFFF00000|Hspell:122064|h[Corrosive Resin]|h|r!',26124),
(62154,'enUS','%s lifts off and flies to the other end of the bridge!','',26124),
(62155,'enUS','The Wild Cloudrider senses its freedom!','',26124),
(62156,'enUS','Living flesh!','',26124),
(62157,'enUS','Devour them!','',26124),
(62158,'enUS','Foolish mortal!','',26124),
(62159,'enUS','We will tear out your eyes!','',26124),
(62160,'enUS','Curse you!','',26124),
(62161,'enUS','Join us...','',26124),
(62162,'enUS','Only death is eternal.','',26124),
(62163,'enUS','We will send you to your grave!','',26124),
(62164,'enUS','The Shan\'ze Stormclaw comes to its senses!','',26124),
(62165,'enUS','So few Klaxxi\'va are even left.$B$BWhat has happened to my people while I slept?','',26124),
(62166,'enUS','I trust in the will of the Klaxxi. They know what is best for our people.','',26124),
(62167,'enUS','I must finish this myself, then. So be it!','',26124),
(62168,'enUS','Warrior coming in!  Focus your fire!','',26124),
(62172,'enUS','<The mantid councilor narrows his enormous eyes on you briefly.>','',26124),
(62173,'enUS','The Empress would force this swarm and raze our own lands in the process.$B$BThe cost is too high.','',26124),
(62174,'enUS','','I see... your eyes never leave the target. Total focus!',26124),
(62175,'enUS','','AHHH! It looked at me!',26124),
(62176,'enUS','','I can do this, I know I can do this...',26124),
(62177,'enUS','','That\'ll teach you to mess with my village!',26124),
(62178,'enUS','','I must be swift as a rushing... stream!',26124),
(62179,'enUS','','The fighter spirit is about to hit you in the face!',26124),
(62180,'enUS','','Revenge is a dish best served by ME!',26124),
(62181,'enUS','','My father is so overly protective. I never get to do anything!',26124),
(62182,'enUS','','An adventurer like you has probably won many battles!',26124),
(62183,'enUS','','I\'ll show my father I have what it takes to be a great fighter.',26124),
(62184,'enUS','','This is a lot more work than I thought it would be...',26124),
(62185,'enUS','','If fighting is like dancing I may be in trouble. I\'m a terrible dancer...',26124),
(62186,'enUS','','I can\'t help but wonder if I could be doing more damage if my gear was better...',26124),
(62187,'enUS','','I always thought the Zandalari were just made up to make me behave when I was younger.',26124),
(62188,'enUS','','I think I was born to be an adventurer. Like those Pandaren from the Wandering Isle...',26124),
(62189,'enUS','','These ruins are supposedly haunted. I don\'t believe in ghosts though. Then again, I didn\'t believe in Zandalari either.',26124),
(62190,'enUS','','This beach used to be such a peaceful place. Now it\'s polluted with these barbarians!',26124),
(62191,'enUS','','So much destruction... so much death... will this ever stop?',26124),
(62192,'enUS','','...Now, charge!',26124),
(62193,'enUS','','Look at all the flowers blooming. Aren\'t they lovely?',26124),
(62194,'enUS','','Spring lives eternally in the heart.',26124),
(62195,'enUS','','Look at all the children! They bring such joy to my heart.',26124),
(62196,'enUS','','Would you like to take a walk with us?',26124),
(62197,'enUS','','The flowers are blooming at this time of year. They smell so fragrant!',26124),
(62198,'enUS','','I hope you are having a wonderful day, $r.',26124),
(62199,'enUS','','Spring is my favorite season of the year. What is your favorite season?',26124),
(62200,'enUS','','The days pass quickly when I am busy.$B$BI must remind myself to stop and enjoy the moment.',26124),
(62201,'enUS','','Are the sha approaching?',26124),
(62202,'enUS','','Don\'t worry, $r. They will not get past me.',26124),
(62203,'enUS','','The children are frightened, but they will be all right. We will keep them safe!',26124),
(62204,'enUS','','Thank you for your training, $n. I hope to one day be as good a fighter as you!',26124),
(62205,'enUS','More ale... hic!','More ale... hic!',26124),
(62206,'enUS','It is the wanderer\'s way.','',26124),
(62207,'enUS','%s shakes off the |cFFFF0000|Hspell:120778|h[Caustic Tar]|h|r!','',26124),
(62210,'enUS','Hozen ships appear in the distance!','',26124),
(62211,'enUS','','Freeze!$B$BHa! I love saying that.',26124),
(62212,'enUS','','You\'re lucky you were near me, eh?!',26124),
(62213,'enUS','','I told you! These rocks are slippery!',26124),
(62214,'enUS','','You have GOT to be more careful!',26124),
(62215,'enUS','','Everybody gets one...',26124),
(62216,'enUS','','Maybe next time I won\'t be around to save you!',26124),
(62217,'enUS','Eee! Monsters are attacking Greenstone Village! RUN AWAY!','Eee! Monsters are attacking Greenstone Village! RUN AWAY!',26124),
(62218,'enUS','','Good form is the key to defeating your enemies. Don\'t swing wildly with your weapon. Be disciplined with your attacks.',26124),
(62219,'enUS','','Your enemy will not show you mercy. Give him the same courtesy.',26124),
(62220,'enUS','','Do not expose your weaknesses.',26124),
(62221,'enUS','','Confidence in your abilities will go a long way. Overconfidence will quickly get you killed.',26124),
(62222,'enUS','','Go ahead and start pulling some of the younger flowers. Just not too many.',26124),
(62223,'enUS','It is quiet here today. Good.','',26124),
(62224,'enUS','I would like you to come with me today.','I would like you to come with me today.',26124),
(62225,'enUS','This path leads to Kun-Lai Summit. Good fortune to those who travel it to shop at grummle shops.','',26124),
(62226,'enUS','You must be powerful, to have come this far. Yes, yes... you will make worthy test subjects.','',26124),
(62227,'enUS','Ah, I see you have found a few of my experiments.  Step closer, and you may witness the full glory of my work here.','',26124),
(62228,'enUS','Forgive me, Empress....','',26124),
(62229,'enUS','You must think yourselves mighty. How little you know. Behold now, my greatest creation!','',26124),
(62230,'enUS','What have you done? No, this will not be how my work ends. I will not allow it!','',26124),
(62231,'enUS','Is that all?','',26124),
(62232,'enUS','Excellent!','',26124),
(62233,'enUS','Feel fortunate to receive this gift.','',26124),
(62234,'enUS','From death comes life, and from life, death....','',26124),
(62235,'enUS','Watch your step!','',26124),
(62237,'enUS','What? Someone steal junglebrew?','',26124),
(62238,'enUS','Wake up! Wake up! They stealing junglebrew!','',26124),
(62239,'enUS','What happening? What day is it?','',26124),
(62240,'enUS','BLECCHH!!','',26124),
(62241,'enUS','Hold off the swarm while Malik the Unscathed awakens!','',26124),
(62242,'enUS','I am returned. I heed the call of the Klaxxi.','',26124),
(62243,'enUS','Malik the Unscathed.','',26124),
(62244,'enUS','Never a glancing blow laid upon you, but countless foes cut down by your halberd.','',26124),
(62245,'enUS','And countless more to come, Klaxxi\'va. It is my honor to serve in our time of need.','',26124),
(62246,'enUS','And serve you shall. Arm yourself at the quartermaster. The drones here are at your disposal.','',26124),
(62247,'enUS','','Are you really as strong as the others say?',26124),
(62248,'enUS','I challenge you!','I challenge you!',26124),
(62249,'enUS','That\'s the last of the ingredients! Good work, $p! Now the festival can begin!','',26124),
(62250,'enUS','Now comes the hard part. Everyone stand back, precision is the key to the perfect Kun-Lai Kicker!','',26124),
(62251,'enUS','Thanks for saving us!  Are you ready to get this party started?','',26124),
(62252,'enUS','We\'re ready to defend!','We\'re ready to defend!',26124),
(62253,'enUS','Mantid are born with little on their mind but a lust for battle. Participation in a swarm is not only a cultural rite of passage - it is the catalyst for our physical maturation.$B$BOnly those who return from battle can develop from a swarmborn into a fully-aware, individual citizen.','',26124),
(62254,'enUS','Thanks for the backup, friends.','',26124),
(62255,'enUS','','$n, I need your help!',26124),
(62257,'enUS','Woooo, $n!','Woooo, $n!',26124),
(62258,'enUS','Welcome to the party, $n!','Welcome to the party, $n!',26124),
(62259,'enUS','This is going to be the best Brewmoon yet with $n here!','This is going to be the best Brewmoon yet with $n here!',26124),
(62260,'enUS','I was wondering when you would get here, $n!','I was wondering when you would get here, $n!',26124),
(62261,'enUS','Hey, $n!','Hey, $n!',26124),
(62262,'enUS','It\'s been awhile, $n.','It\'s been awhile, $n.',26124),
(62263,'enUS','Hey, it\'s $n!','Hey, it\'s $n!',26124),
(62264,'enUS','Have a brew with us, $n!','Have a brew with us, $n!',26124),
(62265,'enUS','Good to see you, $n! Do you have a minute?','',26124),
(62266,'enUS','I\'m so glad you\'re here, $n! Tonight is the night of the Brewmoon Festival and none of the ingredients for my famous Kun-Lai Kicker have been delivered. I sent my assistants out to gather them but none of them have returned. Could you find out what is keeping them?','',26124),
(62267,'enUS','Where can I find Assistant Kieu?','Where can I find Assistant Kieu?',26124),
(62268,'enUS','On the night of the Brewmoon, water spirits can be found on Inkgill Mere performing a ritual. Over the years we have made offerings to them in return for a vial of pure water used in crafting the Kun-Lai Kicker. I sent Assistant Tart out to the lake but she hasn\'t come back yet. Can you head to the north and find out what\'s keeping her, $n?','',26124),
(62269,'enUS','','YAUNGOL!',26124),
(62270,'enUS','Where can I find Assistant Tart?','Where can I find Assistant Tart?',26124),
(62271,'enUS','','Come on, Poppers. Let\'s go!',26124),
(62272,'enUS','','Good work, $p! Now I can collect the pure water!',26124),
(62273,'enUS','Kieu, Tart, Buzaki toss the ingredients in!','',26124),
(62274,'enUS','','$n! Brewmast Boof sent me to fetch a vial of pure water from the water spirits but Poppers ate the offering. Now I have no way to convince them to give me one and they don\'t look very friendly. Do you think you could persuade them for me?',26124),
(62275,'enUS','I sent Assistant Kieu to the silos to collect a sack of grain but she still hasn\'t come back. Could you go check on her for me? You can find the silos on the western edge of town.','',26124),
(62276,'enUS','Welcome to Kota Peak. Home of super famous Kota Kafa. A luckydo would be wise to sniff and savor exotic brews.','',26124),
(62277,'enUS','Welcome to our most humble camp.','',26124),
(62278,'enUS','What is your Luckydo?','',26124),
(62279,'enUS','$n has taken the |cFF01DFD7Blue|r orb!','',26124),
(62280,'enUS','$n has taken the |cFFFF8000Orange|r orb!','',26124),
(62281,'enUS','$n has taken the |cFF01DF01Green|r orb!','',26124),
(62282,'enUS','$n has taken the |cFFBF00FFPurple|r orb!','',26124),
(62283,'enUS','The |cFF01DFD7Blue|r orb has been returned!','',26124),
(62284,'enUS','The |cFFBF00FFPurple|r orb has been returned!','',26124),
(62285,'enUS','The |cFFFF8000Orange|r orb has been returned!','',26124),
(62286,'enUS','The |cFF01DF01Green|r orb has been returned!','',26124),
(62287,'enUS','We must tread carefully. The Shan\'ze tribe practices dark magic that we still do not fully understand.','',26124),
(62288,'enUS','We are working to open a portal from here to Shado-Pan Garrison.','',26124),
(62289,'enUS','Once we open this portal, we will be able to travel much more quickly between here and the garrison.','',26124),
(62290,'enUS','The Wind-Reaver will not accompany you on this task, Wakener. His talents are needed elsewhere.','',26124),
(62291,'enUS','We shall see how you fare against the Vor\'thik without the wind at your back...','',26124),
(62292,'enUS','You may change your Primary Specialization for a price.\n\nThis will become more expensive each additional time you do so.','You may change your Primary Specialization for a price.\n\nThis will become more expensive each additional time you do so',26124),
(62293,'enUS','How do you like the portal? We couldn\'t have done it without your help!','',26124),
(62294,'enUS','You may unlearn all of your current Talents for a price, so that you may select new ones.\n\nThis will become more expensive each additonal time you do so.','You may unlearn all of your current Talents for a price, so that you may select new ones.\n\nThis will become more expensive each additonal time you do so.',26124),
(62295,'enUS','I wish to unlearn my Talents.','I wish to unlearn my Talents.',26124),
(62296,'enUS','You may empty all of your current Glyph slots for a price, so that you may select new ones.\n\nThis will become more expensive each additonal time you do so.','You may empty all of your current Glyph slots for a price, so that you may select new ones.\n\nThis will become more expensive each additonal time you do so.',26124),
(62297,'enUS','I wish to clear all of my Glyphs.','I wish to clear all of my Glyphs.',26124),
(62298,'enUS','','I accept your challenge!',26124),
(62299,'enUS','','I promise this won\'t hurt... too much.',26124),
(62300,'enUS','','What!?!? I lost!?!?!',26124),
(62301,'enUS','','You are as strong as they say, especially considering you defeated ME. Well fought.',26124),
(62302,'enUS','','I need no further convincing. If you need me, I will be waiting on the hill behind the tents.',26124),
(62303,'enUS','How may I help you?','How may I help you?',26124),
(62304,'enUS','|TInterface\\Icons\\spell_shaman_staticshock.blp:20|t %s begins to cast |cFFFF0000|Hspell:117958|h[Materialize Protector]|h|r!','',26124),
(62305,'enUS','At level 10 you will choose a Class Specialization.\n\nIf you later decide to choose a different Class Specialization, you may reset your previous choice here for a price.\n\nThis will become more expensive each additonal time you do so.','At level 10 you will choose a Class Specialization.\n\nIf you later decide to choose a different Class Specialization, you may reset your previous choice here for a price.\n\nThis will become more expensive each additonal time you do so.',26124),
(62306,'enUS','Shall we meet in the Challenger\'s Ring?','Shall we meet in the Challenger\'s Ring?',26124),
(62307,'enUS','At level 15 you will choose your first Talent.\n\nIf you later decide to choose different Talents, you may reset your previous choices here for a price.\n\nThis will become more expensive each additonal time you do so.','At level 15 you will choose your first Talent.\n\nIf you later decide to choose different Talents, you may reset your previous choices here for a price.\n\nThis will become more expensive each additonal time you do so.',26124),
(62308,'enUS','At level 25 you will begin to use Glyphs.\n\nIf you later decide to replace your chosen Glyphs, you may reset them here for a price.\n\nThis will become more expensive each additonal time you do so.','At level 25 you will begin to use Glyphs.\n\nIf you later decide to replace your chosen Glyphs, you may reset them here for a price.\n\nThis will become more expensive each additonal time you do so.',26124),
(62309,'enUS','At level 30 you can learn Dual Specialization, which allows you to keep two active Class Specialization, Talent, and Glyph sets and easily switch between them.\n\nYou also will have separate glyph panes and action bars for each set.\n\nSwitching between the two sets cannot be done while in combat and will consume your available resources.','At level 30 you can learn Dual Specialization, which allows you to keep two active Class Specialization, Talent, and Glyph sets and easily switch between them.\n\nYou also will have separate glyph panes and action bars for each set.\n\nSwitching between the two sets cannot be done while in combat and will consume your available resources.',26124),
(62310,'enUS','I have another question.','I have another question.',26124),
(62311,'enUS','Hozen law number two... Tresspassers get ooked in the dooker!','',26124),
(62312,'enUS','Pound wikket off-landers into the ground!','',26124),
(62313,'enUS','No wikket off-landers allowed!','',26124),
(62314,'enUS','Wikket invasion! Fire from the sky!','',26124),
(62315,'enUS','Ugh... ooked by a wikket...','',26124),
(62316,'enUS','Grooook!','',26124),
(62317,'enUS','No fair! Wikket step on hozen tail!','',26124),
(62318,'enUS','A wave of |cFF00dc29Sik\'thik Swarmers|r joins the battle.','',26124),
(62320,'enUS','','I have waited a long time for this day. Let us face one another in the Challenger\'s Ring.',26124),
(62321,'enUS','Are you ready?','Are you ready?',26124),
(62322,'enUS','Let us both do our best.','Let us both do our best.',26124),
(62323,'enUS','You fought excellently, just as I knew you could.','You fought excellently, just as I knew you could.',26124),
(62324,'enUS','You have grown much since we first met.','You have grown much since we first met.',26124),
(62325,'enUS','It would be my honor to join you in battle. Speak to me on the hill if you have need of me.','It would be my honor to join you in battle. Speak to me on the hill if you have need of me.',26124),
(62326,'enUS','[PH] How would you train a Fury Warrior?','[PH] How would you train a Fury Warrior?',26124),
(62328,'enUS','I will rip apart every last slave in this valley. Your little uprising will be the death of you all!','',26124),
(62329,'enUS','Thank you, friend.','Thank you, friend.',26124),
(62330,'enUS','We didn\'t see it coming...','We didn\'t see it coming...',26124),
(62331,'enUS','I owe you my life.','I owe you my life.',26124),
(62332,'enUS','You have my thanks.','You have my thanks.',26124),
(62333,'enUS','I am eternally grateful.','I am eternally grateful.',26124),
(62334,'enUS','I\'m going to make a break for safety. Thank you.','I\'m going to make a break for safety. Thank you.',26124),
(62335,'enUS','I... thank you.','I... thank you.',26124),
(62336,'enUS','I will see you back at the pagoda. Thank you so much.','I will see you back at the pagoda. Thank you so much.',26124),
(62337,'enUS','What... where am I?','',26124),
(62338,'enUS','What has happened here? The land has changed...','',26124),
(62339,'enUS','How long have I been asleep?','',26124),
(62340,'enUS','|TInterface\\Icons\\ability_shaman_fortifyingwaters.blp:20|t%s is about to be healed by |cFFF00000|Hspell:117283|h[Cleansing Waters]|h|r! Move him!','|TInterface\\Icons\\ability_shaman_fortifyingwaters.blp:20|t%s is about to be healed by |cFFF00000|Hspell:117283|h[Cleansing Waters]|h|r! Move him!',26124),
(62341,'enUS','|TInterface\\Icons\\ability_shaman_fortifyingwaters.blp:20|t%s is being healed by |cFFF00000|Hspell:117283|h[Cleansing Waters]|h|r! Dispel him!','|TInterface\\Icons\\ability_shaman_fortifyingwaters.blp:20|t%s is being healed by |cFFF00000|Hspell:117283|h[Cleansing Waters]|h|r! Dispel him!',26124),
(62342,'enUS','I have seen many battles, healed many allies, cleansed many souls, and many enemies have fallen victim to my command.\n\nYou may feel safe inside these city walls but make no mistake, war plagues these lands like a pandemic and only the chosen few live to tell the tale.','',26124),
(62343,'enUS','I have much to ponder, $n. Get out there and make yourself useful.','',26124),
(62344,'enUS','I\'m bored! Let\'s go hunt down some evildoers.','I\'m bored! Let\'s go hunt down some evildoers.',26124),
(62345,'enUS','I wanna set something on fire, already!','I wanna set something on fire, already!',26124),
(62346,'enUS','I\'m training hard, can\'t you see?','I\'m training hard, can\'t you see?',26124),
(62347,'enUS','Just say the word, and I\'ll be there to help.','Just say the word, and I\'ll be there to help.',26124),
(62348,'enUS','','Few can survive against the cold fingers of ice.',26124),
(62349,'enUS','','Have you heard of the shadow dance? It is the dance you perform while in battle.$B$BIt is a dance with death.',26124),
(62350,'enUS','','Some dance with great passion and enthusiasm, like Fei Li.$B$BOthers do not dance unless they are provoked, such as Yalia.',26124),
(62351,'enUS','','The secret to the shadow dance is control.$B$BPrecision.$B$BAgility.$B$BGrace.$B$BNever a movement too many, and never too few.',26124),
(62352,'enUS','','Every strike should deliver your final intent.',26124),
(62353,'enUS','','I seek wisdom through meditation.',26124),
(62354,'enUS','','Only through inner balance can we find peace within ourselves.',26124),
(62355,'enUS','','With peaceful hearts, we feel no anger, no hatred, no doubt, and no fear.',26124),
(62356,'enUS','','Our greatest enemies are ourselves.',26124),
(62357,'enUS','','If you play the game, play to win.',26124),
(62358,'enUS','My thanks, brave one.','My thanks, brave one.',26124),
(62359,'enUS','I thought I would fall before help came.\n\nThank you.','I thought I would fall before help came.\n\nThank you.',26124),
(62360,'enUS','Your prowess in battle humbles me. Thank you, stranger.','Your prowess in battle humbles me. Thank you, stranger.',26124),
(62361,'enUS','Greenstone Dojo owes you its gratitude.\n\nLet\'s drink when this is done!','Greenstone Dojo owes you its gratitude.\n\nLet\'s drink when this is done!',26124),
(62362,'enUS','Many thanks... I couldn\'t have held out much longer.\n\nAlas, I\'m in no condition to go on.\n\nIf only our entire supply of Greenstone Brew hadn\'t been stolen!  I would\'ve concocted a draft of marvelous power for you...','',26124),
(62363,'enUS','Fishing poles are a crutch! A real fisher uses their hands.','',26124),
(62364,'enUS','I once caught a fish the size of three of your ancestors. Granted, it got away, but I caught it for all of a good minute.','',26124),
(62365,'enUS','Ever make a shark so mad it got out of the water and chased you on land?','',26124),
(62366,'enUS','Best bait for the biggest fish? Put a wedding ring on your hook.','',26124),
(62367,'enUS','No one knows what\'s on the bottom of the lagoon, except the folks who\'ve been down there. And the folks them folks talked to afterwards.','',26124),
(62368,'enUS','Ever tried boiled butter battered kracken legs? Best thing ever.','',26124),
(62369,'enUS','<He\'s sound asleep.>','',26124),
(62370,'enUS','Greetings, friend. Can I get you a mug of anything?','',26124),
(62371,'enUS','','Have you been drinking well?',26124),
(62372,'enUS','I guess you can stay here.','',26124),
(62373,'enUS','Do you have to be so chippery?','',26124),
(62374,'enUS','Is your name really Stormstout?','Is your name really Stormstout?',26124),
(62375,'enUS','What outbreak?  I am always like this.','',26124),
(62376,'enUS','Do you have to stay here?','',26124),
(62377,'enUS','Just leave your money in the coffer.','',26124),
(62378,'enUS','Oh, it\'s just you.','',26124),
(62379,'enUS','I bet you aren\'t even going to buy anything. Just like all the others.','',26124),
(62380,'enUS','I never should have opened this inn. It is just so depressing here.','',26124),
(62381,'enUS','<Big Dan makes a combination of sleepy, fitful grunts and snorts.>$b$bYeah... Stormstout alright...','',26124),
(62382,'enUS','Have you seen anybody named Stormstout come through here?','Have you seen anybody named Stormstout come through here?',26124),
(62383,'enUS','Yes, a few of them. The biggest one, Han, last went out to fight at Kor\'vess.$b$bHaven\'t seen him in a few days, actually. I hope everything\'s alright...','',26124),
(62384,'enUS','Have you seen any Stormstouts here in the Brewgarden?','Have you seen any Stormstouts here in the Brewgarden?',26124),
(62385,'enUS','','You mean other than Lazy Dan over there? Sure!$b$bI spent some time with Evie before she went hunting up north. Such a sweet girl.$b$bAnd of course, who could forget Mama Stormstout?',26124),
(62386,'enUS','It is good to meet you, $n.','',26124),
(62387,'enUS','It is great to see you again, $n.','',26124),
(62388,'enUS','I would stay longer, but I need to go find out what has happened to the rest of the Stormstouts.','',26124),
(62389,'enUS','I sincerely hope our paths cross again.','',26124),
(62390,'enUS','Against your will, you begin to unleash an |cFFFF0000|Hspell:122398|h[Amber Explosion]|h|r!','Against your will, you begin to unleash an |cFFFF0000|Hspell:122398|h[Amber Explosion]|h|r!',26124),
(62391,'enUS','The Amber Monstrosity readies an |cFFFF0000|Hspell:122398|h[Amber Explosion]|h|r!','',26124),
(62392,'enUS','They say your name was Evie.','',26124),
(62393,'enUS','They say you were a sweet girl.','',26124),
(62394,'enUS','I never knew you... but you were family.','',26124),
(62395,'enUS','May your journey in the next world be filled with joy and beauty.','',26124),
(62396,'enUS','Farewell, Evie Stormstout.','',26124),
(62397,'enUS','She looked like Li Li.','',26124),
(62398,'enUS','The nearby pools of amber begin to bubble violently!','',26124),
(62399,'enUS','Enough! You have wasted too much of my time already. I will not be distracted by such insignificant creatures.','',26124),
(62400,'enUS','My work will continue... elsewhere.','',26124),
(62401,'enUS','Alas, I\'m in no condition to go on. If only our entire supply of Greenstone Brew hadn\'t been stolen!','',26124),
(62402,'enUS','Feel the burn!','Feel the burn!',26124),
(62403,'enUS','Yes, finally! Time for some action.','Yes, finally! Time for some action.',26124),
(62404,'enUS','I won\'t let you down!','I won\'t let you down!',26124),
(62405,'enUS','Reporting for duty!','Reporting for duty!',26124),
(62407,'enUS','Let\'s light them up!','Let\'s light them up!',26124),
(62408,'enUS','Can\'t take the heat? Then get out of my way!','Can\'t take the heat? Then get out of my way!',26124),
(62409,'enUS','You won\'t get away with this!','You won\'t get away with this!',26124),
(62410,'enUS','Burn, baby, burn!','Burn, baby, burn!',26124),
(62411,'enUS','Now that is hot.','Now that is hot.',26124),
(62412,'enUS','We make a great team!','We make a great team!',26124),
(62413,'enUS','Is this hot enough for you?','Is this hot enough for you?',26124),
(62414,'enUS','Where shall we strike today?','Where shall we strike today?',26124),
(62415,'enUS','Another one... lost.','',26124),
(62416,'enUS','He may never know the peace of returning to the earth... but at least he went out fighting.','',26124),
(62417,'enUS','Come on.  There is nothing more to be done here.','',26124),
(62418,'enUS','Together, we shall overcome our enemies.','Together, we shall overcome our enemies.',26124),
(62419,'enUS','Let me put my training to the test on the battlefield.','Let me put my training to the test on the battlefield.',26124),
(62420,'enUS','You chose well.','You chose well.',26124),
(62421,'enUS','Freeze!','Freeze!',26124),
(62422,'enUS','That should slow you down.','That should slow you down.',26124),
(62423,'enUS','I feel a little chill coming.','I feel a little chill coming.',26124),
(62424,'enUS','I am going on ahead.  They say Mama Stormstout is still out there somewhere.','',26124),
(62425,'enUS','Revenge is a dish best served cold.','Revenge is a dish best served cold.',26124),
(62426,'enUS','You have been iced!','You have been iced!',26124),
(62427,'enUS','Keep your head cool.','Keep your head cool.',26124),
(62428,'enUS','Ready for a cold spell?','Ready for a cold spell?',26124),
(62429,'enUS','Don\'t get cold feet, now.','Don\'t get cold feet, now.',26124),
(62430,'enUS','Our enemies shall fall before us.','Our enemies shall fall before us.',26124),
(62431,'enUS','You lead, I will follow.','You lead, I will follow.',26124),
(62432,'enUS','Our duties await.','Our duties await.',26124),
(62433,'enUS','Our enemies underestimate the power of the light.','Our enemies underestimate the power of the light.',26124),
(62434,'enUS','I will protect you!','I will protect you!',26124),
(62435,'enUS','They\'ll have to get past me, first.','They\'ll have to get past me, first.',26124),
(62436,'enUS','Let the light protect us!','Let the light protect us!',26124),
(62437,'enUS','I will shield you from harm!','I will shield you from harm!',26124),
(62438,'enUS','Shadows, begone!','Shadows, begone!',26124),
(62439,'enUS','The light will prevail.','The light will prevail.',26124),
(62440,'enUS','We must endure.','We must endure.',26124),
(62441,'enUS','I will light the way.','I will light the way.',26124),
(62442,'enUS','','One order at a time please.',26124),
(62443,'enUS','','I\'m brewing as fast as I can.',26124),
(62444,'enUS','','You\'re in luck! We got a great new shipment in.',26124),
(62445,'enUS','','Should try the special.',26124),
(62446,'enUS','Fly with me, Wakener, and I will show you the way of the Wind-Reaver.','',26124),
(62447,'enUS','You think you can take me down in a pet battle?  Step right up and let\'s find out!','You think you can take me down in a pet battle?  Step right up and let\'s find out!',26124),
(62448,'enUS','Grant me your assistance, Wind-Reaver. [Klaxxi Enhancement]','Grant me your assistance, Wind-Reaver. [Klaxxi Enhancement]',26124),
(62449,'enUS','Please fly me to the Clutches of Shek\'zeer','Please fly me to the Clutches of Shek\'zeer',26124),
(62450,'enUS','Gather enough enemies, and I will strike from the sky.','',26124),
(62451,'enUS','I will drop you with force enough to decimate anyone nearby. Choose your landing carefully.','',26124),
(62452,'enUS','We are the extension of our Empress\'s will.','',26124),
(62453,'enUS','Ours is but to serve in Her divine name.','',26124),
(62454,'enUS','Never to question, nor to contemplate; we simply act.','',26124),
(62455,'enUS','We fight, toil, and serve so that Her vision for us is made reality.','',26124),
(62456,'enUS','Her happiness is our reward, her sorrow our failure.','',26124),
(62457,'enUS','We will give our lives for the Empress without hesitation. She is the light, and without Her our lives will be lost to darkness.','',26124),
(62458,'enUS','The chaff of the world tumbles across our doorstep, driven by fear; Her royal storm will whisk them away.','',26124),
(62459,'enUS','They are but the waves crashing upon the mountain of Her divine will. They may rise again and again; but will accomplish nothing.','',26124),
(62460,'enUS','The Divine challenges us to face these intruders.','',26124),
(62461,'enUS','They were clearly unworthy of Her divine embrace.','',26124),
(62462,'enUS','We are unfazed. We will stand firm.','',26124),
(62463,'enUS','And so it falls to us, Her chosen voice.','',26124),
(62464,'enUS','Stand close to the keg to catch the beer!','',26124),
(62465,'enUS','The Divine chose us to give mortal voice to Her divine will. We are but the vessel that enacts Her will.','',26124),
(62466,'enUS','The Divine will not suffer your taint here, outsider.','',26124),
(62467,'enUS','Ours is but to serve; yours is but to die.','',26124),
(62468,'enUS','Through the air we breathe, She strengthens our voice.','',26124),
(62469,'enUS','Behold the voice of Her divine wrath.','',26124),
(62470,'enUS','Our voice gives form to Her will.','',26124),
(62471,'enUS','Her will is greater than us all. You will join us or you will perish.','',26124),
(62472,'enUS','Her gifts are many, our gratitude immeasurable.','',26124),
(62473,'enUS','She tests us. We will not disappoint Her.','',26124),
(62474,'enUS','We are as unwavering as the amber that shapes our halls. With Her might we will vanquish all who dare intrude upon Her divine home.','',26124),
(62475,'enUS','We will not give in to the despair of the dark void. If Her will for us is to perish, then it shall be so.','',26124),
(62476,'enUS','Maybe you should talk to her.','Maybe you should talk to her.',26124),
(62477,'enUS','Aysa? I don\'t know what to say to her. Should I tell her she\'s gorgeous, or would she find that creepy? Maybe I could tell her I admire her poise - but then she might think I don\'t have any personality!','',26124),
(62478,'enUS','You know, they say these mountains are full of yeti.','',26124),
(62479,'enUS','Oh... well.. you know... \"they\".','',26124),
(62480,'enUS','Hozen are on the ravage again. I can feel it in my knees.','',26124),
(62481,'enUS','That\'s my right knee. My left knee feels hozen ravages.','',26124),
(62482,'enUS','Has there been any word from Kota Basecamp?','',26124),
(62483,'enUS','I heard the Burlap Outpost got destroyed by hozen.','',26124),
(62484,'enUS','I heard the yaungol have taken over most of the farmlands in the south.','',26124),
(62485,'enUS','Sounds like the Muskpaw Ranch was hit.','',26124),
(62486,'enUS','Yaungol.','',26124),
(62487,'enUS','I haven\'t seen any Shado-Pan lately.','',26124),
(62488,'enUS','Uhh...','',26124),
(62489,'enUS','I heard the yaungol made it through the Pandaren Wall.','',26124),
(62490,'enUS','Tell that to the farmer that told me. Poor guy lost all his crops to the invaders.','',26124),
(62491,'enUS','You hear, some of the grummles are refusing to go up Mount Neverest?','',26124),
(62492,'enUS','I still remember when I used to guard the Burlap Trail.','',26124),
(62493,'enUS','Hey! I was a Shado-Pan once.','',26124),
(62494,'enUS','...before.','',26124),
(62495,'enUS','I thought you only felt weather in your knees.','',26124),
(62496,'enUS','No Kota Kafa? How am I going to wake up in the morning?','',26124),
(62497,'enUS','You are heartless. What about the grummles?','',26124),
(62498,'enUS','Know what a yak is?','',26124),
(62499,'enUS','Imagine one of those walking around on two feet, only angrier.','',26124),
(62500,'enUS','I hope they made it out all right. Ol\' Muskpaw might be rough around the edges but he was always the decent sort.','',26124),
(62501,'enUS','They got recalled to Serpent\'s Spine.','',26124),
(62502,'enUS','That\'s impossible. Nothing gets through the wall.','',26124),
(62503,'enUS','Superstitious or not, you won\'t find me exploring some place a grummle is afraid to travel.','',26124),
(62504,'enUS','Was that before or after you built the wall with your own two paws?','',26124),
(62505,'enUS','','Who says that?',26124),
(62506,'enUS','','No. And no kafa either. Dark days are coming.',26124),
(62507,'enUS','','Hmm. I never really liked that place. The outhouses were always dirty.',26124),
(62508,'enUS','','Heartless? Is it too much to ask for a clean outhouse?',26124),
(62509,'enUS','','What?! Don\'t give me that look!',26124),
(62510,'enUS','','What\'s a yaungol?',26124),
(62511,'enUS','','Of course.',26124),
(62512,'enUS','','Hit by what? Sprites?',26124),
(62513,'enUS','','So who is protecting the Burlap Trail?',26124),
(62514,'enUS','','I\'m sure they are just being overly superstitious.',26124),
(62515,'enUS','','Drinking is not guarding.',26124),
(62516,'enUS','...','',26124),
(62517,'enUS','<Han is encased in a tomb of amber.>','',26124),
(62518,'enUS','<Pour some of the Dreadbrew onto Han\'s amber. Just to see what happens.>','<Pour some of the Dreadbrew onto Han\'s amber. Just to see what happens.>',26124),
(62519,'enUS','AAAAAHHHHH!','',26124),
(62520,'enUS','What happened? Last I remember I was...','',26124),
(62521,'enUS','Ugh, what did you pour on me? It\'s disgusting!','',26124),
(62522,'enUS','Gotta calm down now... a little confused... just need to focus.','',26124),
(62523,'enUS','W-whoah... what\'s that thing? Do you want to fight!? Why am I so dizzy? I\'m going to... going to...','',26124),
(62524,'enUS','','Sapmaster... look at this scroll!',26124),
(62525,'enUS','','It describes a way to stop the mantid. A way to stop the sha!',26124),
(62526,'enUS','Let me see that!','',26124),
(62527,'enUS','No, my student, look at these words here: \"vessel\", \"quench\", \"recipe\"...','',26124),
(62528,'enUS','This is a beer recipe!','',26124),
(62529,'enUS','Yeah!! BEER!','',26124),
(62530,'enUS','','You are wrong, teacher.',26124),
(62531,'enUS','','$p! You\'ll help me stop the mantid?',26124),
(62532,'enUS','Ignore her, $p. Help us brew this beer.','',26124),
(62533,'enUS','Yeah!! BEEEEEER!','',26124),
(62534,'enUS','|TInterface\\Icons\\spell_shaman_earthquake.blp:20|t Garalon detects $n under him and begins to cast |cFFFF0000|Hspell:122774|h[Crush]|h|r!','|TInterface\\Icons\\spell_shaman_earthquake.blp:20|t Garalon detects $n under him and begins to cast |cFFFF0000|Hspell:122774|h[Crush]|h|r!',26124),
(62535,'enUS','|TInterface\\Icons\\spell_shaman_earthquake.blp:20|t Garalon senses the passage of Pheromones and begins to cast |cFFFF0000|Hspell:122774|h[Crush]|h|r!','|TInterface\\Icons\\spell_shaman_earthquake.blp:20|t Garalon senses the passage of Pheromones and begins to cast |cFFFF0000|Hspell:122774|h[Crush]|h|r!',26124),
(62536,'enUS','Come on, Olon! Brew-ty calls!','',26124),
(62537,'enUS','YEAH! BEEEEER!!','',26124),
(62538,'enUS','','Where are you two going?',26124),
(62539,'enUS','Nowhere.','',26124),
(62540,'enUS','Rikkitun Village!','',26124),
(62541,'enUS','','Rikkitun... that\'s IT!',26124),
(62542,'enUS','','\"Incantations fae and primal\"... that must refer to the Rikkitun sprites.',26124),
(62543,'enUS','','I\'m going too! See you there, $p.',26124),
(62544,'enUS','You seek to challenge the infamous Tenwu of the Red Smoke? Come friend, let us see what you have got!','',26124),
(62545,'enUS','Hahahah, I do not think you know what you are getting into...','',26124),
(62546,'enUS','Do not worry, I will go easy on you.','',26124),
(62547,'enUS','Not bad, not bad... but we are not done yet!','',26124),
(62548,'enUS','Well then! It seems all those muscles are not just for show!','',26124),
(62549,'enUS','You have certainly earned my respect. No easy feat, my friend!','',26124),
(62550,'enUS','Oh ho ho, you and I are going to have a LOT of fun together!','',26124),
(62551,'enUS','Well, that was fun, wasn\'t it?','',26124),
(62552,'enUS','Tearing Page','',26124),
(62553,'enUS','Collecting Supplies','',26124),
(62554,'enUS','So much emotion has been realeased from the tombs. So much anger and fear...','',26124),
(62555,'enUS','Theses tombs hold many secrets, $n.','',26124),
(62556,'enUS','Many of the Mogu emperors buried their servants with them trapping their spirits in servitude for eternity.','',26124),
(62557,'enUS','This places chills me to my core, $c.','',26124),
(62558,'enUS','Spiritbinding is a brutal practice. Depriving the dead of their eternal peace is an unspeakable cruelty.','',26124),
(62559,'enUS','This valley is proof that our nightmares can become reality.','',26124),
(62560,'enUS','Create Rubbing','',26124),
(62561,'enUS','The amber sustained me as I slept, but I felt its powers drain over time.$B$BIf you had not awakened me when you did, I fear I would have soon slipped into eternal sleep.','',26124),
(62562,'enUS','Grant me your assistance, Prime. [Klaxxi Augmentation]','Grant me your assistance, Prime. [Klaxxi Augmentation]',26124),
(62563,'enUS','Grant me your assistance, Xaril.  [Klaxxi Enhancement]','Grant me your assistance, Xaril.  [Klaxxi Enhancement]',26124),
(62564,'enUS','Grant me your assistance, Dissector. [Klaxxi Enhancement]','Grant me your assistance, Dissector. [Klaxxi Enhancement]',26124),
(62565,'enUS','Grant me your assistance, Bloodseeker. [Klaxxi Augmentation]','Grant me your assistance, Bloodseeker. [Klaxxi Augmentation]',26124),
(62566,'enUS','PH','',26124),
(62567,'enUS','','I... wah... where? What is going on?',26124),
(62568,'enUS','You were being mind-controlled by some sort of malevolent ancient insect creature.','',26124),
(62569,'enUS','','Oh that. Bah, I\'ve been through worse. And who exactly are you?',26124),
(62570,'enUS','I am Chen Stormstout. From the Wandering Isle.','',26124),
(62571,'enUS','','STORMSTOUT? No. You\'re foolin\'. Really? A Wandering Isle Stormstout, here, on Pandaria! Where\'s the rest of the family?',26124),
(62572,'enUS','I\'ll explain on the way back to the Sapmasters.','',26124),
(62573,'enUS','There! The Klaxxi! Hold that crystal together... don\'t let it escape!','',26124),
(62574,'enUS','Freedom...','',26124),
(62575,'enUS','For eight hundred and seventy-seven years, I waited in that crystal... watching shadows pass through the cracks, counting decades.','',26124),
(62576,'enUS','Now, I am needed elsewhere.','',26124),
(62577,'enUS','Wait till you see what I have for you...','',26124),
(62578,'enUS','A wave of |cFFB600B8Sik\'thik Demolishers|r joins the battle.','',26124),
(62579,'enUS','%s begins to approach the platform!','',26124),
(62580,'enUS','Hmmm... I have a crazy idea that just might work, but we\'ll need your help heroes!','',26124),
(62581,'enUS','Let\'s give these mantid a taste of their own medicine!','',26124),
(62582,'enUS','Li and Lo, get the sap into position!','',26124),
(62583,'enUS','Let\'s get this party started, shall we?','',26124),
(62584,'enUS','Bring it, uglies!','',26124),
(62585,'enUS','|TInterface\\Icons\\spell_holy_surgeoflight.blp:20|t%s casts |cFFFF0000|Hspell:122789|h[Sunbeam]|h|r!','',26124),
(62586,'enUS','Swarmers are coming up the ramp -- use the sap to slow them down!','',26124),
(62587,'enUS','Demolishers, get in there!  Leave nothing but a pile of ash!','',26124),
(62588,'enUS','Warriors, trample these weaklings!  Crush them!','',26124),
(62589,'enUS','Everyone! Send everything! Slaughter these cowards, they are making us look like fools!','',26124),
(62590,'enUS','Come.','',26124),
(62591,'enUS','%s summons an |cFFFFFFFFEmbodied Terror|r!','',26124),
(62592,'enUS','You are truly welcomed to Rikkitun Village, outsider.','',26124),
(62593,'enUS','The forked blade is ready, and we have given our gift. Please perform your incantation.','The forked blade is ready, and we have given our gift. Please perform your incantation.',26124),
(62594,'enUS','It is done.','',26124),
(62595,'enUS','Hmm...','',26124),
(62596,'enUS','Yeah. This is pretty horrible.','',26124),
(62597,'enUS','I think I\'ll call it... Dreadbrew. You want to try some, Lya?','',26124),
(62598,'enUS','','No thank you! I think we\'ve already proven that this wasn\'t a beer recipe.',26124),
(62599,'enUS','Very well. How about you, Olon?','',26124),
(62600,'enUS','YEAH! BEEEEEER!!!','',26124),
(62601,'enUS','Thank you for your help, $p. We may not have made the best brew, but we had quite an adventure.','',26124),
(62602,'enUS','Feel free to take some brew from this keg whenever you\'re feeling adventurous.','',26124),
(62603,'enUS','Ha! You think you\'re ready to take me on?','Ha! You think you\'re ready to take me on?',26124),
(62604,'enUS','Let\'s see if you\'re still standing after this.','Let\'s see if you\'re still standing after this.',26124),
(62605,'enUS','','Yeah? What\'s up?',26124),
(62606,'enUS','I would like you to come with me today.','I would like you to come with me today.',26124),
(62607,'enUS','I\'m here to challenge you!','I\'m here to challenge you!',26124),
(62608,'enUS','','What, you change your mind? I understand. I wouldn\'t want to fight me, either.',26124),
(62609,'enUS','Let\'s do this.','Let\'s do this.',26124),
(62610,'enUS','Come at me!','Come at me!',26124),
(62611,'enUS','Come on, is that all you\'ve got?','Come on, is that all you\'ve got?',26124),
(62612,'enUS','You can do better than that!','You can do better than that!',26124),
(62613,'enUS','You\'re tougher than you look.','You\'re tougher than you look.',26124),
(62614,'enUS','I admit... that was some impressive fighting.','I admit... that was some impressive fighting.',26124),
(62615,'enUS','Well, now that we\'ve fought, it\'s settled. We\'re friends!','Well, now that we\'ve fought, it\'s settled. We\'re friends!',26124),
(62616,'enUS','I\'d love to fight with you again whenever you need me.','I\'d love to fight with you again whenever you need me.',26124),
(62617,'enUS','Hmm... If I mix some pale with a stou...\n\nOh, yes. Hello!','',26124),
(62618,'enUS','I would like you to come with me today.','I would like you to come with me today.',26124),
(62619,'enUS','I\'m here to challenge you!','I\'m here to challenge you!',26124),
(62620,'enUS','I have a different question.','I have a different question.',26124),
(62621,'enUS','Ah, a visitor! This is an incredible time for Pandaria - the mists have parted, and we rejoin the world. You come in peace, I hope?','',26124),
(62622,'enUS','A wave of |cFF00dc29Sik\'thik Swarmers|r and a |cFF815d18Sik\'thik Warrior|r joins the battle.','',26124),
(62623,'enUS','A wave of |cFFB600B8Sik\'thik Demolishers|r and a |cFF815d18Sik\'thik Warrior|r joins the battle.','',26124),
(62624,'enUS','My, my. Hello, stranger! Sampled my dream brew, have we? Its visions are hard to interpret - half truth, half illusion. Who\'s to say which is which?','',26124),
(62625,'enUS','Walk with me, and let us learn from one another. Are your people fond of gardening?','',26124),
(62626,'enUS','They are holding us off, bring in the air support!','',26124),
(62627,'enUS','Amberwing, get in there! Lay siege to the holdouts!','',26124),
(62628,'enUS','%s hands you a pair of shears and motions toward a large, unkempt tree.','',26124),
(62629,'enUS','Feel the darkness within!','',26124),
(62630,'enUS','That\'s it, delicate cuts. Let the tree decide.','',26124),
(62631,'enUS','Some take their knives and lop away anything that displeases them, but this would kill the entire tree. That is not the Pandaren way.','',26124),
(62632,'enUS','Well now! Who knew such a beautiful thing was hiding here? I can see that this \"Alliance\" of yours cuts with precision in order to change the world around you. Interesting.','',26124),
(62633,'enUS','I am a \"Lorewalker\" - a historian of sorts for my people. My instrument is the spoken word.','',26124),
(62634,'enUS','Sadly, my - ah - artistic talents are somewhat lacking. What would YOU do to decorate my wall here?','',26124),
(62635,'enUS','Oh, yeah. I remember you. Let\'s see what you\'ve learned.','',26124),
(62636,'enUS','A challenge, huh? Let\'s see what you\'ve got.','',26124),
(62637,'enUS','I hope your moves aren\'t too predictable.','',26124),
(62638,'enUS','Oh, you\'re gonna try that one? Come on!','',26124),
(62639,'enUS','What\'s wrong, did you forget how to fight?','',26124),
(62640,'enUS','Okay... that was pretty good.','',26124),
(62641,'enUS','Wow! I haven\'t seen that one before. I guess you\'re pretty good after all.','',26124),
(62642,'enUS','Sure, I\'ll go with you. Gotta study up on your moves!','',26124),
(62643,'enUS','Whenever you need me, I\'ll be here.','',26124),
(62644,'enUS','Well? Let\'s go! I\'m eager to see what you\'ve got.','',26124),
(62645,'enUS','All right, let\'s do this!','All right, let\'s do this!',26124),
(62646,'enUS','Don\'t say a word. Allow your image to speak. We pandaren prize beauty, and we find it all around us:','',26124),
(62647,'enUS','In the curves of a tree, the colors of a sunrise, even in the perfect physical form of a warrior\'s exquisite swordwork.','',26124),
(62648,'enUS','The Lorewalker\'s art lacks both subtlety and technical expertise. Perhaps you can do better?','',26124),
(62649,'enUS','<Paint a Portrait of Prince Anduin.>','<Paint a Portrait of Prince Anduin.>',26124),
(62650,'enUS','Awaken my pets! Feast on their flesh!','',26124),
(62651,'enUS','I will see to your demise myself!','',26124),
(62652,'enUS','Who is this? A prince, you say? A child. Ah, but he has had no childhood - you can see it in his eyes.','',26124),
(62653,'enUS','I can see your people expect great things, even from your young.','',26124),
(62654,'enUS','My errands are almost complete. Come, visit my collection of exotic birds. You may have the honor of feeding them.','',26124),
(62655,'enUS','This amber is ours, trespasser! Amber not for the mantid!','',26124),
(62656,'enUS','This paragon is for the Empress! You shall not have it!','',26124),
(62657,'enUS','I am known as a Lorewalker - a kind of historian for my people.','',26124),
(62658,'enUS','The Klaxxi sent you to oppose the Swarm? Ah, how the mighty have fallen. Come, little fly. Take the paragon, if you can!','',26124),
(62659,'enUS','Follow me, traveler. Let us get to know one another better.','',26124),
(62660,'enUS','Think you can take me in a pet battle?  Let\'s fight!','Think you can take me in a pet battle?  Let\'s fight!',26124),
(62661,'enUS','Let\'s rumble!','Let\'s rumble!',26124),
(62662,'enUS','As such, knowledge is my armor, and I carry a quill in place of a sword.','',26124),
(62663,'enUS','Much of Pandaria\'s past is shrouded in mystery, even to us.','',26124),
(62664,'enUS','This demands a tireless search for ancient clues, and the wisdom to interpret them.','',26124),
(62665,'enUS','Ahh, here we are. Be careful - I\'ve had trouble in this area before.','',26124),
(62666,'enUS','You have bested me. Seek Master Snowdrift in the Dojo atop the mountain if you wish to proceed.','You have bested me. Seek Master Snowdrift in the Dojo atop the mountain if you wish to proceed.',26124),
(62667,'enUS','%s casts |cFFFF0000|Hspell:123244|h[Hide]|h|r!','',26124),
(62668,'enUS','At... last... my time has come.','',26124),
(62669,'enUS','There is much to do. But first, Wakener... help me recover my strength.','',26124),
(62670,'enUS','A Lorewalker\'s sworn duty is to rediscover our history - to rend that shroud, piece by piece.','',26124),
(62671,'enUS','%s casts |cFFFF0000|Hspell:123461|h[Get Away!]|h|r','',26124),
(62672,'enUS','It has been many years since I have seen this place, Wakener. Much has changed.','',26124),
(62673,'enUS','We must work quickly to get the beacon operational.','',26124),
(62674,'enUS','Ah yes. One does not forget the taste of amber.','',26124),
(62675,'enUS','Do my eyes deceive me? What is that wall in the distance?','',26124),
(62676,'enUS','Back when the world was still young, the first kypari trees bloomed.','',26124),
(62677,'enUS','From the trees, the amber flowed and nurtured us. Kyparite, we called it, the lifeblood of the earth.','',26124),
(62678,'enUS','It healed our wounds and made us bold. It tasted like sweetness and fire, and gave us the strength to conquer all the lesser races.','',26124),
(62679,'enUS','Hurry, Wakener. It is taking all my strength not to rip you to pieces.','',26124),
(62680,'enUS','Kalimdor is much changed. I do not recognize this place.','',26124),
(62681,'enUS','Have the ancient towers fallen? I can hear nothing from my brethren.','',26124),
(62682,'enUS','Why were you sent to awaken me? Why did the Klaxxi not send one of their own?','',26124),
(62683,'enUS','I will now peform the sacred ritual of my people.','',26124),
(62684,'enUS','Nearby sha creatures have the shade I\'m looking for... though you might find a little bit on the nearby wildlife. Good luck!','',26124),
(62685,'enUS','%s animates several elementals to |cFFFF0000|Hspell:123250|h[Protect]|h|r her!','',26124),
(62686,'enUS','Keep your eyes open, friend.','',26124),
(62687,'enUS','Are you hurt? Do you need something?','',26124),
(62688,'enUS','Stay cautious. The enemy can attack at any time.','',26124),
(62689,'enUS','More fighting, less talking.','More fighting, less talking.',26124),
(62690,'enUS','Yeah? What do you want?','Yeah? What do you want?',26124),
(62691,'enUS','Let\'s go!','Let\'s go!',26124),
(62692,'enUS','You should have seen the mantid empire in my day, Wakener. Our vesses stretched as far as the eye could see.','',26124),
(62693,'enUS','When we heard call of the ravage, we darkened the very skies with our numbers.','',26124),
(62694,'enUS','Before they laid me to sleep in amber, I heard a million voices of the swarm shouting my name. Now, I hear only silence.','',26124),
(62695,'enUS','What are these strange creatures?','',26124),
(62696,'enUS','Where do they take the amber? where are the forges? Where are the ambersmiths?','',26124),
(62697,'enUS','It seems that there are others who see the value of amber.','',26124),
(62698,'enUS','WHHARRGLBLRRGLBRGL','',26124),
(62699,'enUS','A Lorewalker\'s work is ponderous, traveler.$b$bOne must draw upon a wealth of knowledge to see things as they truly are.','',26124),
(62700,'enUS','Eh? Where am I? What\'s happening?$B$BI\'m sorry, I must have drifted off.','',26124),
(62701,'enUS','About... face!','',26124),
(62702,'enUS','Healing brew incoming! Come and get it!','',26124),
(62703,'enUS','This stone tells of a great hozen warlord who lived here twenty-five hundred years ago. What are your leaders like? Poets? Warriors? I should like to meet them someday.','',26124),
(62704,'enUS','Die, softskin!','',26124),
(62705,'enUS','Prepare yourself! Saurok raiders approach!','',26124),
(62706,'enUS','Many were the threats to our race after the usurpers remade the world. Narrow was the path ahead.','',26124),
(62707,'enUS','Our ancestors looked far into the future to witness his rebirth, but instead, we saw our race troubled by many dangers. Dangers that, left unchecked, could destroy us.','',26124),
(62708,'enUS','It was I who suggested our greatest warriors be cast in amber to sleep, to be awakened at the swarm\'s greatest times of need.','',26124),
(62709,'enUS','It was the sleep from which one could never awake. A great risk. A great sacrifice. But necessary.','',26124),
(62710,'enUS','Thus, I was the first Paragon. This is why, I am the Prime.','',26124),
(62711,'enUS','And now, the Klaxxi call us to battle. Now, I am awakened.','',26124),
(62712,'enUS','The saurok have plagued this land since the time of the mogu. They are impossible to negotiate with. But we never stop trying! We fight them only as a last resort.','',26124),
(62713,'enUS','Lei Shi\'s reflection ripples ominously.','',26124),
(62714,'enUS','Her reflection ripples a second time.','',26124),
(62715,'enUS','%s appears!','',26124),
(62716,'enUS','Thank you for your help - these notes are important to my studies. Your people value knowledge too, yes? I assume so, only because you arrived on a great airship.','',26124),
(62717,'enUS','I have everything I need. Quickly, let\'s move on before they return!','',26124),
(62718,'enUS','Enough about pandaren history. Let\'s talk about your people, traveler.','',26124),
(62719,'enUS','I\'ve learned a great deal already just by watching you in action. You fight with the fervor of youth but the experience of an old veteran. You\'ve seen a lifetime of warfare, haven\'t you?','',26124),
(62720,'enUS','Yes, it is true! This IS Kypari Zar!','',26124),
(62721,'enUS','But why do I sense no life emanating from within? Why do I sense no amber sap running through its veins?','',26124),
(62722,'enUS','I must examine the tree. Guard me while I perform this task, Wakener!','',26124),
(62723,'enUS','It is done. Kypari Zar... cries out in unbearable agony.','',26124),
(62724,'enUS','','Interested in renting a kite?',26124),
(62725,'enUS','I\'d like to borrow one of Farmer Fung\'s kites.','I\'d like to borrow one of Farmer Fung\'s kites.',26124),
(62726,'enUS','','Oh, sure!$b$bFarmer Fung said that, if you want, you can use one of his FANCY kites. Apparently he\'s taken a liking to you.',26124),
(62727,'enUS','I\'ll take the standard red kite.','I\'ll take the standard red kite.',26124),
(62728,'enUS','I\'ll take the high-altitude blue kite.','I\'ll take the high-altitude blue kite.',26124),
(62729,'enUS','I\'ll take the swift yellow kite.','I\'ll take the swift yellow kite.',26124),
(62730,'enUS','I\'ll take the dancing green kite.','I\'ll take the dancing green kite.',26124),
(62731,'enUS','Ah, this is a special place. My great grandparents called this part of the forest their home. Come, this will take only a moment.','',26124),
(62732,'enUS','Another ancient place, this one made even more special in recent years.','',26124),
(62733,'enUS','Harvesting Amber','',26124),
(62734,'enUS','Li and Lo, go look after our friends down below.','',26124),
(62735,'enUS','Ah, this gate is locked, but I think I have something that\'ll open it.','',26124),
(62736,'enUS','Let me see here... thirty second fuse...','',26124),
(62737,'enUS','Whoops, did I say thirty? I meant three.','',26124),
(62738,'enUS','Go, hurry! You must stop the siege!','',26124),
(62739,'enUS','I feel strong enough to continue on my own, $n. I must report this... sha... presence to the Council immediately. If we meet again, it shall be at Klaxxi\'vess.','',26124),
(62740,'enUS','%s emerges from her protective bubble.','',26124),
(62741,'enUS','I... need... sustenance.','',26124),
(62742,'enUS','I have been asleep far longer than I thought possible. So much has changed.','',26124),
(62743,'enUS','When I awoke, the Klaxxi told me of you. It seems you are not without your uses.','',26124),
(62744,'enUS','As soon as I awakened, the Klaxxi sensed my presence and relayed as much as they dared.$B$BThey confirmed my own suspicions. The Empress is no longer fit to rule the empire. She must be... cleansed.','',26124),
(62745,'enUS','My duty is to the Klaxxi Council. Whatever they ask of me, I must obey.','',26124),
(62746,'enUS','I no longer recognize this world. Everything is unfamiliar, yet I have a great duty to fulfill.','',26124),
(62747,'enUS','It worked, just as I knew it would!$B$BBut even so, the effects of the stasis have surpassed even my original calculations.','',26124),
(62748,'enUS','All across the wastes, the kypari are dying.$B$BI fear that this... sha... is the cause.','',26124),
(62749,'enUS','One healthy kypari remains, far to the southwest, but the Empress\'s slaves are destroying it as we speak.','',26124),
(62750,'enUS','If we let the kypari die out, then we will have lost a great treasure.$B$BThe amber is life.','',26124),
(62751,'enUS','Not while Leza is in labor. We must wait.','',26124),
(62752,'enUS','What part of our journey gave you the impression of choice?','',26124),
(62753,'enUS','This was not supposed to be a combat mission.','',26124),
(62754,'enUS','Dezco, this is a weapon of the horde. You should unleash it on the Alliance.','',26124),
(62755,'enUS','And the Alliance wasn\'t supposed follow the same visions your wife was having.','',26124),
(62756,'enUS','Dezco, we should keep pressing westward. We are vulnerable here.','',26124),
(62757,'enUS','I appreciate that your wife led us here, old friend, but she chose a poor time to have a child.','',26124),
(62758,'enUS','I feel better.$B$BIt will take me some time to regain my full strength, but I am strong enough to fight, at least.','',26124),
(62759,'enUS','You are lucky you were able to find amber and flesh nearby, Wakener.$B$BIf there was none to be found, you would have been my sustenance.','',26124),
(62760,'enUS','We Pandaren do not worship our ancestors, but we revere their memory and the wisdom that they have passed on to us.','',26124),
(62761,'enUS','It was my Great Grandfather who first told me the tale of the mogu that I recently shared with you.','',26124),
(62762,'enUS','Despite your obvious weaknesses, I have grown fond of you, Wakener. I was made a paragon because of my prowess on the battlefield. It was said that I could cheat death itself. I shall lend you this very ability, Painkiller, to protect you during the task ahead.','',26124),
(62763,'enUS','Interested in catching some rare pets?','Interested in catching some rare pets?',26124),
(62764,'enUS','You look like someone that might be interested in some rare pets?','You look like someone that might be interested in some rare pets?',26124),
(62765,'enUS','Have you ever seen such a beautiful rabbit?  I can help you catch your own!','Have you ever seen such a beautiful rabbit?  I can help you catch your own!',26124),
(62766,'enUS','This is the old Imperial Road. They say the mogu empire used to bring their prisoners here for torture.','',26124),
(62767,'enUS','What are they digging up? I\'ve never seen mogu use tools and weapons like those before.','',26124),
(62768,'enUS','I don\'t think these mogu are from here. They seem to be scavenging old relics, not digging in or pillaging.','',26124),
(62769,'enUS','What is it? I am busy.','',26124),
(62770,'enUS','Will this suffice?','',26124),
(62771,'enUS','Put it with the others for the Lord Reclaimer\'s inspection.','',26124),
(62772,'enUS','But, I am a master fighter, with extensive knowledge of this world\'s flora and fauna. Surely I can help?','',26124),
(62773,'enUS','No - this is our problem, we must deal with it ourselves.','',26124),
(62774,'enUS','But, here comes another survivor. Seems good with their hands... maybe you can teach them your fighting skills?','',26124),
(62775,'enUS','Of course! It would be an honor.','',26124),
(62776,'enUS','What the...?','',26124),
(62777,'enUS','What was that noise?','',26124),
(62778,'enUS','It came from the wall, sir.','',26124),
(62779,'enUS','I know where it CAME from, what was it?','',26124),
(62780,'enUS','You will make fine slaves for the empire.','',26124),
(62781,'enUS','No... no...','',26124),
(62782,'enUS','Men! To arms!','',26124),
(62783,'enUS','You three! $n! Assist Captain Oakenshield in the front!','',26124),
(62784,'enUS','Greentill! Blacksoil! Cover our left flank! I don\'t want any surprises!','',26124),
(62785,'enUS','Leven, take the right side! You\'re on your own!','',26124),
(62786,'enUS','Everyone else! If you can hold a weapon, protect the village! Don\'t let them past this line! You...','',26124),
(62787,'enUS','Your kind will soon learn who their real masters are.','',26124),
(62788,'enUS','You will learn your place.','',26124),
(62789,'enUS','We don\'t stand a chance...','',26124),
(62790,'enUS','Everyone, fall back! FALL BA-','',26124),
(62791,'enUS','Rrrraaaa!!!','',26124),
(62792,'enUS','Who are you?','',26124),
(62793,'enUS','Did you think you could challenge the might of the mogu?','',26124),
(62794,'enUS','Does it matter who we are? We are here to help you.','',26124),
(62795,'enUS','Hey! Gimme one o\' them pitchforks!','',26124),
(62796,'enUS','You were surrendering? Why? Because these invaders can break down a wall?','',26124),
(62797,'enUS','You have got another wall... and it\'s made up of the people who call this place HOME.','',26124),
(62798,'enUS','Any one of us would lay down our life to protect this land.','',26124),
(62799,'enUS','This land, it belongs to us...','',26124),
(62800,'enUS','It belongs to our ancestors...','',26124),
(62801,'enUS','It belongs to our children.','',26124),
(62802,'enUS','And we are not about to let that change.','',26124),
(62803,'enUS','I\'m just walking along, cataloging the local wildlife here in Azuremist, when suddenly...\n\nBAM! <Mojo mimicks an explosion with his hands.>\n\nI don\'t think I\'ve ever heard an explosion that loud in my life!','',26124),
(62804,'enUS','The Empire rises again!','',26124),
(62805,'enUS','For the Empire!','',26124),
(62806,'enUS','Trespasser!','',26124),
(62807,'enUS','These lands belong to the Thunder King.','',26124),
(62808,'enUS','You dare challenge the Empire?','',26124),
(62809,'enUS','We return!','',26124),
(62810,'enUS','The pandaren are not hear to save you now.','',26124),
(62811,'enUS','Your age of this world has passed.','',26124),
(62812,'enUS','For the Lord Reclaimer!','',26124),
(62813,'enUS','Cower before me, supplicant!','',26124),
(62814,'enUS','Beg for mercy.','',26124),
(62815,'enUS','Your life is forfeit.','',26124),
(62816,'enUS','You dare stand in our way?','',26124),
(62817,'enUS','Your kind will be made to serve.','',26124),
(62818,'enUS','Behold the wrath of the new Empire!','',26124),
(62819,'enUS','Kzzsst! Paragon! Klaxxi infiltrator!','',26124),
(62820,'enUS','Guard the tower!','',26124),
(62821,'enUS','You seek your own death, trespasser!','',26124),
(62822,'enUS','Stealer of signals! This is the Empress\'s tower!','',26124),
(62823,'enUS','I would very much like to hear about your ancestors, stranger. Light the incense and let\'s reflect on where you came from, hm?','',26124),
(62824,'enUS','Astounding! A lineage of great warriors... From a different world, no less! It is rare for a Pandaren to leave his or her homeland. You are rightfully proud of who you are.','',26124),
(62825,'enUS','How fascinating. I thought you looked sickly - but now I see the truth. Your people suffer under the weight of a terrible darkness. What strength you must have, simply to press onward!','',26124),
(62826,'enUS','Look at that. Your people revere their ancestors as well. And you cherish the land. We have much in common! Ah, but I see that your ancestors were nomads, whereas we Pandaren prefer the comforts of hearth and home. You\'ll find few travellers among us.','',26124),
(62827,'enUS','Oh my - as I suspected. Your ancestry dates back to the dawn of the world. Great were the ancient empires of the trolls. I see a spark in your eyes, a powerful will - you wish to be great again, yes?','',26124),
(62828,'enUS','Ah, noble is your lineage! Your people possess GREAT power, and all the terrible burdens that come with it. Equally great has been your suffering. Now I see why you call yourself  \'Blood\' elves.','',26124),
(62829,'enUS','Well... that\'s interesting. Most of your ancestors died in a fire. Oh my. Your people put themselves at great personal risk in the name of progress! I wish more Pandaren had your initiative.','',26124),
(62830,'enUS','Ah, but you\'re no stranger to your past! A Pandaren from the Wandering Isle. I admit, I thought your homeland was just a legend. Pandaren from the Isle are far more adventurous than those on the mainland... it\'s in your blood!','',26124),
(62831,'enUS','No! What is... happening...','',26124),
(62832,'enUS','Skeer the Bloodseeker has returned! Unnngghhh...','',26124),
(62833,'enUS','Yes, Klaxxi\'va. What does the Council command? Skeer hears. Skeer obeys.','',26124),
(62834,'enUS','I... ah... oh! Did I...? Was I...? It was... so... cloudy.','',26124),
(62835,'enUS','I have to go now.','',26124),
(62836,'enUS','I have to make the water not cloudy anymore. Will... will you help?','',26124),
(62837,'enUS','|TInterface\\Icons\\spell_nature_healingwavelesser.blp:20|t Garalon |cFFFF0000|Hspell:123495|h[Mends]|h|r one of his legs!','|TInterface\\Icons\\spell_nature_healingwavelesser.blp:20|t Garalon |cFFFF0000|Hspell:123495|h[Mends]|h|r one of his legs!',26124),
(62838,'enUS','Fools! Fight harder! Do not let these puny pandaren defeat you!','',26124),
(62839,'enUS','|TInterface\\Icons\\spell_shaman_earthquake.blp:20|t Garalon prepares to |cFFFF0000|Hspell:122774|h[Crush]|h|r his opponents!','|TInterface\\Icons\\spell_shaman_earthquake.blp:20|t Garalon prepares to |cFFFF0000|Hspell:122774|h[Crush]|h|r his opponents!',26124),
(62840,'enUS','Rise little one! And destroy!','',26124),
(62841,'enUS','Garalon\'s massive armor plating begins to crack and split!','Garalon\'s massive armor plating begins to crack and split!',26124),
(62842,'enUS','Welcome to our first officially-sanctioned combat event, the Arena of Annihilation!','',26124),
(62843,'enUS','Ah yes... Wakener, doesn\'t the scent of blood fill you with new strength?','',26124),
(62844,'enUS','Weaklings! Fools! You cannot stand before the Bloodseeker!','',26124),
(62845,'enUS','Just a bit longer, Wakener! They are on their last legs!','',26124),
(62846,'enUS','Well done, Wakener. I will stay a while longer to quench my blade\'s thirst. You may tell the others of my return, but I believe my swift wings will bear me to Klaxxi\'vess before you.','',26124),
(62847,'enUS','Then HIT THAT GONG, and show these monks what you\'re made of! ...one way or another, heh.','',26124),
(62848,'enUS','Swarmborn! Filthy muckeaters! You defile our grotto. You will not escape!','',26124),
(62849,'enUS','My voice, gone?  How will my subjects hear me?  Will they still love their empress?  Will they turn on me as the Klaxxi have?','',26124),
(62850,'enUS','Did they send you?  They wouldn\'t dare!  Would they?','',26124),
(62851,'enUS','You! You will suffer for your insolence at the hands of my greatest champions.  Surely they will protect their empress!','',26124),
(62852,'enUS','Hear me subjects! Your empress is threatened by these outsiders. They wish to kill me... to kill us all!  Destroy them!','',26124),
(62853,'enUS','Your defiance of the Empress ends here!','',26124),
(62854,'enUS','All of Pandaria will fall beneath the Wings of the Empress!','',26124),
(62855,'enUS','Empress... I have... failed you...','',26124),
(62856,'enUS','The Empress commands it!','',26124),
(62857,'enUS','Pitiful.','',26124),
(62858,'enUS','My blade never misses its mark!','',26124),
(62859,'enUS','The skies belong to the Empress!','',26124),
(62860,'enUS','The Kor\'thik have no equal in combat!','',26124),
(62861,'enUS','The Sra\'thik command the elements of this land, leaving their foes imprisoned for all time!','',26124),
(62862,'enUS','The mighty Zar\'thik bend the wind to their will!','',26124),
(62863,'enUS','To die for the empress is an honor!','',26124),
(62864,'enUS','The wings of the empress cannot fail!','',26124),
(62865,'enUS','You will pay for your transgressions!','',26124),
(62866,'enUS','You fight like cowards!','',26124),
(62867,'enUS','Aid me brethren!','',26124),
(62868,'enUS','In order to survive, you must fight.','',26124),
(62869,'enUS','Peace is for the weak!','',26124),
(62870,'enUS','The only way I know is that of the warrior.','',26124),
(62871,'enUS','Only the strongest survive.','',26124),
(62872,'enUS','Impossible! Why does my strength fail me?','',26124),
(62873,'enUS','I will slay a hundred foes! As soon as I... can catch my breath.','',26124),
(62874,'enUS','They warned me of the wakening sickness, but I did not believe it would be this bad.','',26124),
(62875,'enUS','I will be fine.$B$BThis is nothing compared to the thousand scars of battle!','',26124),
(62876,'enUS','I say we need less talking and more fighting.','',26124),
(62877,'enUS','The rules of the trial are simple. These target dummies are equipped with powder bombs. If a single one of them explodes, your trial is over.','',26124),
(62878,'enUS','Ah, perhaps one of your skills can make our sparring sessions more interesting. Protect the temple healers from assailants for as long as you are able.','',26124),
(62879,'enUS','Joining you in this trial will be a few of our more... reckless... students. Prove yourself by keeping them all in the fight.','',26124),
(62880,'enUS','Let us make this a bit more interesting.','',26124),
(62881,'enUS','Hope you\'re quick on your feet!','',26124),
(62882,'enUS','Impressive. But can you handle this?','',26124),
(62883,'enUS','There will be no escaping me.','',26124),
(62884,'enUS','Empress... forgive me!','',26124),
(62885,'enUS','This wall is your grave!','',26124),
(62886,'enUS','None may stand against us!','',26124),
(62887,'enUS','*Mocking Laughter*','',26124),
(62888,'enUS','I\'ll hurl your corpses from this tower.','',26124),
(62889,'enUS','Our numbers... endless! You... cannot win...','',26124),
(62890,'enUS','','Seal the gates! Bar the exits! Destroy these intruders!',26124),
(62891,'enUS','','Death to all who dare challenge my empire!',26124),
(62892,'enUS','','Augh... ah ... I...  have failed.',26124),
(62893,'enUS','','Taste defeat, stranger!',26124),
(62894,'enUS','','Breathe no longer!',26124),
(62895,'enUS','','Sing... yes! Sing in agony!',26124),
(62896,'enUS','','You will serve ME now!',26124),
(62897,'enUS','','Such is the fate of those who question authority.',26124),
(62898,'enUS','','Power... I must have more power! Guards! Protect your empress!',26124),
(62899,'enUS','You joined a battle already lost.','',26124),
(62900,'enUS','','I will dispose of the outsiders.',26124),
(62901,'enUS','','More... more! I must have more!',26124),
(62902,'enUS','Air superiority.','',26124),
(62903,'enUS','As expected.','',26124),
(62904,'enUS','','Yes, master.',26124),
(62905,'enUS','You must destroy these outsiders, empress! They have come to conquer your people!','',26124),
(62906,'enUS','USELESS! Fall limp and die before me, wretched insect. Your kind are worthless to me!','',26124),
(62907,'enUS','As for the rest of you, seek me if you dare. Like the others, you will all die screaming.','',26124),
(62908,'enUS','Die or surrender. You cannot defeat me.','',26124),
(62909,'enUS','All is lost.','',26124),
(62910,'enUS','Abandon all hope.','',26124),
(62911,'enUS','Embrace your despair.','',26124),
(62912,'enUS','You cannot escape me. I am... in... every...  breath...','',26124),
(62913,'enUS','See how effortlessly you become unraveled.','',26124),
(62914,'enUS','Succumb to the darkness inside your soul.','',26124),
(62915,'enUS','For our first show of skill and power we bring you SCAR-SHELL, mightiest of dragon turtles!','',26124),
(62916,'enUS','Whew, what a mess! Someone inform the monastery kitchens: We\'re having turtle soup, tonight!','',26124),
(62917,'enUS','It\'s time for the grummle-grubbing goliath, fifteen feet of furry fury, Kun-Lai Summit\'s own snow-stalking horror, JOL\'GRUM!','',26124),
(62918,'enUS','OUCH! Safe to say that Jol\'Grum wasn\'t quite yet-i ready for his battle with these three killing machines! Speaking of ready...','',26124),
(62919,'enUS','She\'s here to make new friends... and then set them on fire! It\'s Pandaria\'s prettiest little playful pyromaniac, Liuyang!','',26124),
(62920,'enUS','Snuffed out like a candle! Is there anyone these three can\'t beat?!','',26124),
(62921,'enUS','Did someone say Yak Attack?! It\'s ax-master Chagan Firehoof, wandering warrior of the Townlong Steppes!','',26124),
(62922,'enUS','What a battle! Our fine combatants served up Chagan a heaping helping of Yaungolian barbeque...','',26124),
(62923,'enUS','So wild and vicious he was kicked off the Peak of Serenity, it\'s the froth-mouthed frenzy, always-bananas monkey monk master CLOUDBENDER KOBO!','',26124),
(62924,'enUS','What a gloriously bloody battle! Our three heroes showed Kobo that the Arena of Annihilation isn\'t just monkey business.','',26124),
(62925,'enUS','','I hope you don\'t mind sharing the balloon with me. My father always told me not to talk to strangers, but you seem friendly.',26124),
(62926,'enUS','','Isn\'t Zouchin Province beautiful? I\'ve lived here my whole life.',26124),
(62927,'enUS','','My father thinks it\'s too dangerous beyond Zouchin\'s walls for a lady. He only lets me leave when we need supplies from One Keg.',26124),
(62928,'enUS','','The way I see it is, I\'m not very good at being a lady, so maybe I\'d make a better adventurer like you.',26124),
(62929,'enUS','','Those ruins creep me out. They\'re so old...',26124),
(62930,'enUS','','Look at those boats! Where are they coming from?!',26124),
(62931,'enUS','','Oh no! Look at those huts! Why are they attacking defenseless villagers?',26124),
(62932,'enUS','','My village is under attack! I hope my family is alright.',26124),
(62933,'enUS','','It looks like my father was wrong. Even Zouchin can be dangerous!',26124),
(62934,'enUS','','I have to check on my family. Please help us!',26124),
(62935,'enUS','Archers! Shoot down the airborne mantid!','',26124),
(62936,'enUS','Ready your arrows and attack the flyers!','',26124),
(62937,'enUS','Ready the oil.. pour, now!','',26124),
(62938,'enUS','Cast down the oil!','',26124),
(62939,'enUS','Use the cannons to launch yourself onto him!','',26124),
(62940,'enUS','His armor is broken. Strike at him now!','',26124),
(62941,'enUS','On your guard, invaders. I, Ta\'yak, Lord of Blades, will be your opponent.','',26124),
(62942,'enUS','A perfect cut.','',26124),
(62943,'enUS','This is the technique of a Blade Lord.','',26124),
(62944,'enUS','I\'d always hoped to cut someone like that someday, to hear that sound. But to have it happen to my own prothorax is ridiculous.','',26124),
(62945,'enUS','His armor is broken. Strike at him now!','',26124),
(62946,'enUS','Who dares summon Emperor Meng, most majestic of mighty monarchs?!','',26124),
(62947,'enUS','You have angered the emperor! THE SENTENCE IS DEATH!','',26124),
(62948,'enUS','I... I don\'t want to die!','',26124),
(62949,'enUS','The sentence... was to be... yours..','',26124),
(62950,'enUS','Like rice stalks before the blade, all fall before me!','',26124),
(62951,'enUS','None may stand against the imperial majesty of MENG!','',26124),
(62952,'enUS','Don\'t bleed on me! Filthy! Disease!','',26124),
(62953,'enUS','You made me do it!','',26124),
(62954,'enUS','Slaughter yourselves for my amusement!','',26124),
(62955,'enUS','Enemies... everywhere! Kill! Kill them all!','',26124),
(62956,'enUS','My armies are endless, my power, unmatched.','',26124),
(62957,'enUS','Let death wash over you!','',26124),
(62958,'enUS','Rise!','',26124),
(62959,'enUS','I will crush you, in body AND spirit.','',26124),
(62960,'enUS','Living water, bring them death!','',26124),
(62961,'enUS','I... cannot be... defeated..','',26124),
(62962,'enUS','My tactics are unbeatable.','',26124),
(62963,'enUS','Another victory.','',26124),
(62964,'enUS','The emperor rules ALL!','',26124),
(62965,'enUS','Soldiers! Crush their flank!','',26124),
(62966,'enUS','Flanking attack! March into battle!','',26124),
(62967,'enUS','Bandits and emperors; we both take what we want!','',26124),
(62968,'enUS','You\'ll see your mistake soon enough!','',26124),
(62969,'enUS','I am... bested.','',26124),
(62970,'enUS','You were too slow!','',26124),
(62971,'enUS','I am too quick, too clever.','',26124),
(62972,'enUS','You stood no chance!','',26124),
(62973,'enUS','All that is yours? Mine!','',26124),
(62974,'enUS','There is nothing I cannot take!','',26124),
(62975,'enUS','I sense... courage. Willpower. Light. Hmph. That will not do.','',26124),
(62976,'enUS','Soon you will understand why my subjects fear the shadows!','',26124),
(62977,'enUS','The darkness... surrounds me!','',26124),
(62978,'enUS','Fall into darkness.','',26124),
(62979,'enUS','The shadows consume you.','',26124),
(62980,'enUS','THIS is what it means to face an emperor!','',26124),
(62981,'enUS','The darkness comes for you, and with it, death.','',26124),
(62982,'enUS','One minute until the Arena battle begins!','',26124),
(62983,'enUS','Fifteen seconds until the Arena battle begins!','',26124),
(62984,'enUS','The Arena battle has begun!','',26124),
(62985,'enUS','Green team scores a kill.','',26124),
(62986,'enUS','Yellow team scores a kill.','',26124),
(62987,'enUS','The Arena battle ends in sixty seconds.','',26124),
(62988,'enUS','As the waters foretold.','',26124),
(62989,'enUS','Your cause is hopeless.','',26124),
(62990,'enUS','Time has run out. The Arena battle is over!','',26124),
(62991,'enUS','Green team wins!','',26124),
(62992,'enUS','Yellow team wins!','',26124),
(62993,'enUS','Draw! No winner.','',26124),
(62994,'enUS','Yellow team wins!','',26124),
(62995,'enUS','Yellow team scores a kill.','',26124),
(62996,'enUS','Time has run out. The Arena battle is over!','',26124),
(62997,'enUS','The Arena battle has begun!','',26124),
(62998,'enUS','Green team wins!','',26124),
(62999,'enUS','Green team scores a kill.','',26124),
(63000,'enUS','The Arena battle ends in sixty seconds.','',26124),
(63001,'enUS','Draw! No winner.','',26124),
(63002,'enUS','Fifteen seconds until the Arena battle begins!','',26124),
(63003,'enUS','Yellow team wins!','',26124),
(63004,'enUS','Yellow team scores a kill.','',26124),
(63005,'enUS','Time has run out. The Arena battle is over!','',26124),
(63006,'enUS','','Wait... what\'s that?! Where did all of those huts come from?!',26124),
(63007,'enUS','The Arena battle has begun!','',26124),
(63008,'enUS','Green team wins!','',26124),
(63009,'enUS','Green team scores a kill.','',26124),
(63010,'enUS','The Arena battle ends in sixty seconds.','',26124),
(63011,'enUS','Draw! No winner.','',26124),
(63012,'enUS','Fifteen seconds until the Arena battle begins!','',26124),
(63013,'enUS','Yellow team wins!','',26124),
(63014,'enUS','Yellow team scores a kill.','',26124),
(63015,'enUS','Time has run out. The Arena battle is over!','',26124),
(63016,'enUS','The Arena battle has begun!','',26124),
(63017,'enUS','Green team wins!','',26124),
(63018,'enUS','Green team scores a kill.','',26124),
(63019,'enUS','The Arena battle ends in sixty seconds.','',26124),
(63020,'enUS','Draw! No winner.','',26124),
(63021,'enUS','Fifteen seconds until the Arena battle begins!','',26124),
(63022,'enUS','And there are Virmen in the main store!','',26124),
(63023,'enUS','I think the brewery might be on fire.','',26124),
(63024,'enUS','Yellow team wins!','',26124),
(63025,'enUS','Yellow team scores a kill.','',26124),
(63026,'enUS','Time has run out. The Arena battle is over!','',26124),
(63027,'enUS','The Arena battle has begun!','',26124),
(63028,'enUS','Green team wins!','',26124),
(63029,'enUS','Green team scores a kill.','',26124),
(63030,'enUS','The Arena battle ends in sixty seconds.','',26124),
(63031,'enUS','Draw! No winner.','',26124),
(63032,'enUS','Fifteen seconds until the Arena battle begins!','',26124),
(63033,'enUS','Yellow team wins!','',26124),
(63034,'enUS','Yellow team scores a kill.','',26124),
(63035,'enUS','Time has run out. The Arena battle is over!','',26124),
(63036,'enUS','The Arena battle has begun!','',26124),
(63037,'enUS','Green team wins!','',26124),
(63038,'enUS','Green team scores a kill.','',26124),
(63039,'enUS','The Arena battle ends in sixty seconds.','',26124),
(63040,'enUS','Draw! No winner.','',26124),
(63041,'enUS','Fifteen seconds until the Arena battle begins!','',26124),
(63042,'enUS','The battle has begun!','',26124),
(63043,'enUS','The Alliance is near victory!','',26124),
(63044,'enUS','The Horde is near victory!','',26124),
(63045,'enUS','The Alliance is victorious!','',26124),
(63046,'enUS','The Horde is victorious!','',26124),
(63047,'enUS','The front gate of the Alliance keep has been destroyed.','',26124),
(63048,'enUS','The east gate of the Alliance keep has been destroyed.','',26124),
(63049,'enUS','The west gate of the Alliance keep has been destroyed.','',26124),
(63050,'enUS','The front gate of the Horde keep has been destroyed.','',26124),
(63051,'enUS','The east gate of the Horde keep has been destroyed.','',26124),
(63052,'enUS','The west gate of the Horde keep has been destroyed.','',26124),
(63053,'enUS','The Gate of the Blue Sapphire was destroyed!','',26124),
(63054,'enUS','Oh yeah!','Oh yeah!',26124),
(63055,'enUS','The Gate of the Green Emerald was destroyed!','',26124),
(63056,'enUS','You die!','You die!',26124),
(63057,'enUS','The Gate of the Purple Amythest was destroyed!','',26124),
(63058,'enUS','You have...turnip...for a head...','You have...turnip...for a head...',26124),
(63059,'enUS','The Gate of the Red Sun was destroyed!','',26124),
(63060,'enUS','Urp...eats too many carrots...','Urp...eats too many carrots...',26124),
(63061,'enUS','The Gate of the Yellow Moon was destroyed!','',26124),
(63062,'enUS','Gonna spins around!','Gonna spins around!',26124),
(63064,'enUS','The battle for Arathi Basin is about to begin.','',26124),
(63065,'enUS','Get da party started for da new Ook!','',26124),
(63066,'enUS','The battle for Arathi Basin is about to begin.','',26124),
(63067,'enUS','Yeah!','',26124),
(63068,'enUS','The battle has begun!','',26124),
(63069,'enUS','Yeah!','',26124),
(63070,'enUS','Come on and get your Ook on!','',26124),
(63071,'enUS','Everybody do the Ook!','',26124),
(63072,'enUS','Ook it harder!','',26124),
(63073,'enUS','The Alliance is near victory!','',26124),
(63074,'enUS','The Horde is victorious!','',26124),
(63075,'enUS','The Horde is near victory!','',26124),
(63076,'enUS','The Alliance is near victory!','',26124),
(63077,'enUS','Ook it better!','',26124),
(63078,'enUS','Ook it faster!','',26124),
(63079,'enUS','Ook it stronger!','',26124),
(63080,'enUS','Shake dat shake dat!','',26124),
(63081,'enUS','Shake your dooker!','',26124),
(63082,'enUS','The battle for the Eye of the Storm is about to begin.','',26124),
(63083,'enUS','The battle for the Eye of the Storm is about to begin.','',26124),
(63084,'enUS','The Gate of the Blue Sapphire was destroyed!','',26124),
(63085,'enUS','The Gate of the Green Emerald was destroyed!','',26124),
(63086,'enUS','The Gate of the Purple Amythest was destroyed!','',26124),
(63087,'enUS','All the hozen gotta listen now...','',26124),
(63088,'enUS','The Gate of the Red Sun was destroyed!','',26124),
(63089,'enUS','The Gate of the Yellow Moon was destroyed!','',26124),
(63090,'enUS','Cuz there\'s a new Ook in town...','',26124),
(63091,'enUS','So gets a keg of Stormstout Brown...','',26124),
(63092,'enUS','The east gate of the Alliance keep has been destroyed.','',26124),
(63093,'enUS','And drop your dooker to the ground!','',26124),
(63094,'enUS','The front gate of the Alliance keep has been destroyed.','',26124),
(63095,'enUS','The west gate of the Alliance keep has been destroyed.','',26124),
(63096,'enUS','The east gate of the Horde keep has been destroyed.','',26124),
(63097,'enUS','We doins Hozen activities!','',26124),
(63098,'enUS','The front gate of the Horde keep has been destroyed.','',26124),
(63099,'enUS','We gots Hozen tendencies!','',26124),
(63100,'enUS','The west gate of the Horde keep has been destroyed.','',26124),
(63101,'enUS','We gots da Hozen friends!','',26124),
(63102,'enUS','We gots da Hozen enemies!','',26124),
(63103,'enUS','Ook!','',26124),
(63104,'enUS','You dids it again!','',26124),
(63105,'enUS','You dook\'d with my heart!','',26124),
(63106,'enUS','Gots lost in da ook!','',26124),
(63107,'enUS','The battle has begun!','',26124),
(63108,'enUS','Ook!','',26124),
(63109,'enUS','The battle has begun!','',26124),
(63110,'enUS','Ook!','',26124),
(63111,'enUS','The Alliance is near victory!','',26124),
(63112,'enUS','Ook!','',26124),
(63113,'enUS','The Alliance is near victory!','',26124),
(63114,'enUS','Ook!','',26124),
(63115,'enUS','The Horde is near victory!','',26124),
(63116,'enUS','The Horde is near victory!','',26124),
(63117,'enUS','The Alliance is victorious!','',26124),
(63118,'enUS','The Alliance is near victory!','',26124),
(63119,'enUS','The Horde is victorious!','',26124),
(63120,'enUS','The Horde is victorious!','',26124),
(63121,'enUS','Ook your dooker!','',26124),
(63122,'enUS','The Battle for Gilneas is about to begin.','',26124),
(63123,'enUS','The battle for Arathi Basin is about to begin.','',26124),
(63124,'enUS','The battle has begun!','',26124),
(63125,'enUS','The battle has begun!','',26124),
(63126,'enUS','The Alliance is near victory!','',26124),
(63127,'enUS','The Alliance is near victory!','',26124),
(63128,'enUS','The Horde is near victory!','',26124),
(63129,'enUS','The Horde is near victory!','',26124),
(63130,'enUS','The Alliance is victorious!','',26124),
(63131,'enUS','The Alliance is near victory!','',26124),
(63132,'enUS','The Horde is victorious!','',26124),
(63133,'enUS','The Horde is victorious!','',26124),
(63134,'enUS','The battle for Silvershard Mines is about to begin.','',26124),
(63135,'enUS','Whatzit...are they...what are they doin\' to our alementals?','',26124),
(63136,'enUS','The battle has begun!','',26124),
(63137,'enUS','Hey...hey YOU! Those are OUR flying...beer monsters?','',26124),
(63138,'enUS','This view is terrible!','',26124),
(63139,'enUS','The Alliance is near victory!','',26124),
(63140,'enUS','The Horde is near victory!','',26124),
(63141,'enUS','The Alliance is victorious!','',26124),
(63142,'enUS','What, are you having trouble seeing the fight?','',26124),
(63143,'enUS','The Horde is victorious!','',26124),
(63144,'enUS','No, I can see it perfectly!','',26124),
(63145,'enUS','This group is awful!','',26124),
(63146,'enUS','Terrible!','',26124),
(63147,'enUS','Disgusting!','',26124),
(63148,'enUS','See you here tomorrow?','',26124),
(63149,'enUS','Absolutely!','',26124),
(63150,'enUS','You fool, you\'re sleeping through the fight!','',26124),
(63151,'enUS','Who\'s the fool? You\'re watching it!','',26124),
(63152,'enUS','Finally, we\'ve seen a good group!','',26124),
(63153,'enUS','The battle for Arathi Basin is about to begin.','',26124),
(63154,'enUS','The battle has begun!','',26124),
(63155,'enUS','Does that mean we can stop coming here now?','',26124),
(63156,'enUS','Do you think all of this fighting is educational for this group?','',26124),
(63157,'enUS','Yes, it will drive them to read books!','',26124),
(63158,'enUS','The Alliance has captured the flag!','',26124),
(63159,'enUS','The Horde has captured the flag!','',26124),
(63160,'enUS','Pay up, they made it through those alementals!','',26124),
(63161,'enUS','Double or nothing on the next group?','',26124),
(63162,'enUS','The Alliance is near victory!','',26124),
(63163,'enUS','I liked that last group!','',26124),
(63164,'enUS','What did you like about it?','',26124),
(63165,'enUS','The Horde is near victory!','',26124),
(63166,'enUS','I thought it was the last group!','',26124),
(63167,'enUS','I think I\'m going to need another drink!','',26124),
(63168,'enUS','Why do you say that?','',26124),
(63169,'enUS','The Alliance is victorious!','',26124),
(63170,'enUS','I\'m beginning to like these guys!','',26124),
(63171,'enUS','The Horde is victorious!','',26124),
(63172,'enUS','Do you think that we can return to life after death?','',26124),
(63173,'enUS','Sure! That last group did about thirty times!','',26124),
(63174,'enUS','Well, see you here tomorrow!','',26124),
(63175,'enUS','Unless I get lucky and black out!','',26124),
(63176,'enUS','Wh-what are you doing here?! G-go away!','',26124),
(63177,'enUS','You know what\'s the best thing about this group?','',26124),
(63178,'enUS','What?','',26124),
(63179,'enUS','They opened the doors so we can escape!','',26124),
(63180,'enUS','Just when I think a group is the worst, something wonderful happens!','',26124),
(63181,'enUS','What\'s that?','',26124),
(63182,'enUS','The battle for Temple of Kotmogu is about to begin.','',26124),
(63183,'enUS','They leave!','',26124),
(63184,'enUS','Oooh this group takes me back.','',26124),
(63185,'enUS','If you can still see, it didn\'t go back far enough!','',26124),
(63186,'enUS','The battle has begun!','',26124),
(63187,'enUS','These guys aren\'t half bad!','',26124),
(63188,'enUS','The Alliance is near victory!','',26124),
(63189,'enUS','They\'re not half good either!','',26124),
(63190,'enUS','The Horde is near victory!','',26124),
(63192,'enUS','The Alliance is victorious!','',26124),
(63193,'enUS','The Horde is victorious!','',26124),
(63194,'enUS','S-sorry!','',26124),
(63195,'enUS','It\'s your fault it happened!','',26124),
(63196,'enUS','Get AWAY!','',26124),
(63197,'enUS','Stay away from me!','',26124),
(63198,'enUS','I\'m hiding until you leave!','',26124),
(63199,'enUS','I don\'t want to see you anymore!','',26124),
(63200,'enUS','The battle for Arathi Basin is about to begin.','',26124),
(63201,'enUS','The Alliance is near victory!','',26124),
(63202,'enUS','The Alliance is victorious!','',26124),
(63203,'enUS','The battle has begun!','',26124),
(63204,'enUS','The Horde has captured the flag!','',26124),
(63205,'enUS','The Horde is near victory!','',26124),
(63206,'enUS','The Horde is victorious!','',26124),
(63207,'enUS','I think this group will really improve with age!','',26124),
(63208,'enUS','You think they\'ll get better?','',26124),
(63209,'enUS','No, my eyesight will get worse!','',26124),
(63210,'enUS','I wonder if there\'s anything this healer isn\'t good at!','',26124),
(63211,'enUS','Sure! Choosing which group to be in!','',26124),
(63212,'enUS','There must be something wrong with those Hozen we saw earlier!','',26124),
(63213,'enUS','The battle for Arathi Basin is about to begin.','',26124),
(63214,'enUS','Why\'s that?','',26124),
(63215,'enUS','The battle for Arathi Basin is about to begin.','',26124),
(63216,'enUS','The Alliance is near victory!','',26124),
(63217,'enUS','Because these guys made it past them!','',26124),
(63218,'enUS','You know, I really envy these guys!','',26124),
(63219,'enUS','The Alliance is near victory!','',26124),
(63220,'enUS','Why\'s that?','',26124),
(63221,'enUS','Because they get to spend so much time with that foxy spirit healer!','',26124),
(63222,'enUS','You know, getting items must be hard for these guys!','',26124),
(63223,'enUS','Why\'s that?','',26124),
(63224,'enUS','Because pants never drop when they\'re around!','',26124),
(63225,'enUS','The Alliance is victorious!','',26124),
(63226,'enUS','Are these guys Alliance or Horde?','',26124),
(63227,'enUS','Why does it matter?','',26124),
(63228,'enUS','The Alliance is near victory!','',26124),
(63229,'enUS','I need to know which side to stop rooting for!','',26124),
(63230,'enUS','I think that druid had the hots for me!','',26124),
(63231,'enUS','The battle has begun!','',26124),
(63232,'enUS','That last priest had me smitten!','',26124),
(63233,'enUS','The battle has begun!','',26124),
(63234,'enUS','The Horde is near victory!','',26124),
(63235,'enUS','The Horde is near victory!','',26124),
(63236,'enUS','Why didn\'t that mage put intellect on his weapon?','',26124),
(63237,'enUS','The Horde is victorious!','',26124),
(63238,'enUS','Because he didn\'t want it to be smarter than he was!','',26124),
(63239,'enUS','The Horde is victorious!','',26124),
(63240,'enUS','How many of these outlanders does it take to paint a wall?','',26124),
(63241,'enUS','I don\'t know, how many?','',26124),
(63242,'enUS','It depends on how hard you throw them!','',26124),
(63243,'enUS','Do you think that undead party made it through in one piece?','',26124),
(63244,'enUS','No, I don\'t think they had the guts!','',26124),
(63245,'enUS','That last paladin offered me eternal salvation!','',26124),
(63246,'enUS','What\'d you say?','',26124),
(63247,'enUS','Kings, please.','',26124),
(63248,'enUS','That last shaman really knew his place!','',26124),
(63249,'enUS','And where is that?','',26124),
(63250,'enUS','Outland!','',26124),
(63251,'enUS','I\'ve got a great joke for you!','',26124),
(63252,'enUS','What\'s that?','',26124),
(63253,'enUS','These guys\' weapons!','',26124),
(63254,'enUS','I hear something...','',26124),
(63255,'enUS','Stop them!','',26124),
(63256,'enUS','Such a waste...','',26124),
(63257,'enUS','Search his corpse!','',26124),
(63258,'enUS','Slay them!','',26124),
(63259,'enUS','Everything must burn. None shall know of the Scarlet Crusade\'s shame!','',26124),
(63260,'enUS','You, too, shall be charred to ash!','',26124),
(63261,'enUS','My fire... has gone out..','',26124),
(63262,'enUS','Burn! BURN!','',26124),
(63263,'enUS','Die in a fire!','',26124),
(63264,'enUS','Breath of the Dragon!','',26124),
(63265,'enUS','My endless agony shall be yours, as well!','',26124),
(63266,'enUS','We hunger for vengeance.','',26124),
(63267,'enUS','Can this be... the end, at last...?','',26124),
(63268,'enUS','More... More souls!','',26124),
(63269,'enUS','Seek out a vessel... and return!','',26124),
(63270,'enUS','Claim a body, and wreak terrible vengeance!','',26124),
(63271,'enUS','No rest... for the angry dead!','',26124),
(63272,'enUS','No... the waters... I must... resist... I shall not... fear...','',26124),
(63273,'enUS','You do not belong here! The waters must be protected... I will cast you out, or slay you!','',26124),
(63274,'enUS','Protect... the waters...','',26124),
(63275,'enUS','I thank you, strangers. I have been freed.','',26124),
(63276,'enUS','Die in darkness.','',26124),
(63277,'enUS','The night surrounds you...','',26124),
(63278,'enUS','I assure you $p is the best fighter I\'ve ever seen. $GHe:She; will be able to help better prepare your village.','',26124),
(63279,'enUS','No...!','',26124),
(63280,'enUS','Forgive me!','',26124),
(63281,'enUS','For starters, your villagers need rest. We can offer you protection long enough to allow them a break.','',26124),
(63282,'enUS','$p can also teach your villagers to defend themselves.','',26124),
(63283,'enUS','All we ask is help in finding Prophet Khar\'zul. You know the surrounding islands better than we do. Your knowledge would be invaluable.','',26124),
(63284,'enUS','Overwhelming... fear!','',26124),
(63285,'enUS','Flee this place... or die!','',26124),
(63286,'enUS','Promises, promises! There is nothing you can do to save us. The Zandalari are ruthless!','',26124),
(63287,'enUS','Even if we could defend ourselves they outnumber us! There is no way we will win!','',26124),
(63288,'enUS','Day falls to night...','',26124),
(63289,'enUS','Darkness grows...','',26124),
(63290,'enUS','Light fades...','',26124),
(63291,'enUS','Night... becomes day!','',26124),
(63292,'enUS','The sun... shines through...','',26124),
(63293,'enUS','Once more... the dawn...','',26124),
(63294,'enUS','','So negative all the time Hou!',26124),
(63295,'enUS','','That may not be true Hou. The Lorewalker seems confident. What will your protection cost us?',26124),
(63296,'enUS','','Very well. If you help us fend off the Zandalari, we will help you find the Prophet.',26124),
(63297,'enUS','I will break you.','',26124),
(63298,'enUS','I cannot be defeated. I beat all man.','',26124),
(63299,'enUS','My fists are scarlet... with your blood!','',26124),
(63300,'enUS','If you die, you die.','',26124),
(63301,'enUS','My blade is peerless!','',26124),
(63302,'enUS','Perfect technique!','',26124),
(63303,'enUS','But... my legend!','',26124),
(63304,'enUS','My legend begins NOW!','',26124),
(63305,'enUS','To think you\'ve come so far, only to perish here. I\'ll honor you with clean deaths.','',26124),
(63306,'enUS','Your lights will go out. The darkness will envelop you. And you will fear the shadows that move within it.','',26124),
(63307,'enUS','You will know fear!','',26124),
(63308,'enUS','Drown in terror.','',26124),
(63309,'enUS','Fleeeee!','',26124),
(63310,'enUS','Huddle in terror!','',26124),
(63311,'enUS','You think it is so easy to vanquish your fears?','',26124),
(63312,'enUS','Dread rises! It seeks the light. It hungers.','',26124),
(63313,'enUS','','What is it you plan to do to help us Lorewalker?',26124),
(63314,'enUS','The glory of Gurthan!','',26124),
(63315,'enUS','This is the might of Harthak!','',26124),
(63316,'enUS','For Kargesh!','',26124),
(63317,'enUS','It be dyin\' time, now!','',26124),
(63318,'enUS','OH HO HO! Dat had ta hurt.','',26124),
(63319,'enUS','OUCH! Eh-heheheh.','',26124),
(63320,'enUS','Spirits be praised!','',26124),
(63321,'enUS','The fear clouds my mind. I... cannot resist.','',26124),
(63322,'enUS','You face your fear. A moment\'s... peace.','',26124),
(63323,'enUS','I brought enough bombs... for all of you!','',26124),
(63324,'enUS','Seek shelter, lest I strike you down as the Sha commands!','',26124),
(63325,'enUS','I... blew it...','',26124),
(63326,'enUS','Its power is so strong. It forces me to destroy you.','',26124),
(63327,'enUS','You face your fear. A moment\'s... peace.','',26124),
(63328,'enUS','Seek shelter, lest I strike you down as the Sha commands!','',26124),
(63329,'enUS','I\'m the bomber man...tid!','',26124),
(63330,'enUS','You blew it!','',26124),
(63331,'enUS','No one can stand against the fear. You will perish.','',26124),
(63332,'enUS','Seek shelter, lest I strike you down as the Sha commands!','',26124),
(63333,'enUS','You face your fear. A moment\'s... peace.','',26124),
(63334,'enUS','Hold nothing back, for I will not!','',26124),
(63335,'enUS','You need more training!','',26124),
(63336,'enUS','Your technique needs work.','',26124),
(63337,'enUS','I will not be caged again. These Shado-Pan could not stop me. Neither shall you!','',26124),
(63338,'enUS','So long as violence lurks in your hearts... I... will... return...','',26124),
(63339,'enUS','Another violent death...','',26124),
(63340,'enUS','The Sha of Hatred has fled my body... and the monastery, as well. I must thank you, strangers. The Shado-Pan are in your debt. Now, there is much work to be done...','',26124),
(63341,'enUS','Taran Zhu and the Shado-Pan are MINE. Come forward and die by my hand, as all who oppose me shall in the days to come!','',26124),
(63342,'enUS','Hatred will consume and conquer all!','',26124),
(63343,'enUS','No... NO!','',26124),
(63344,'enUS','Rage at your defeat.','',26124),
(63345,'enUS','Feed me your hatred!','',26124),
(63346,'enUS','If you haven\'t come to study, I\'ll use you to teach a lesson.','',26124),
(63347,'enUS','I will do what Pa\'valak could not!','',26124),
(63348,'enUS','You may have come this far. You may have carved a path through my army, but I... will kill you, and I will build the bridge.','',26124),
(63349,'enUS','The... bridge...','',26124),
(63350,'enUS','Out of my way.','',26124),
(63351,'enUS','Get back to work! I want this bridge finished by first light!','',26124),
(63352,'enUS','Screams and barking echo through the halls.','',26124),
(63353,'enUS','Search the island for brew to add to Bo\'s cauldron, but keep someone nearby to protect Bo!','',26124),
(63354,'enUS','Gork\'em big Dook!','',26124),
(63355,'enUS','Wikket ooked the big Dook!?','',26124),
(63356,'enUS','Wikket gunna get grooked!','',26124),
(63357,'enUS','Ook\'em!','',26124),
(63358,'enUS','AHHHHH!','',26124),
(63359,'enUS','Wikket big hozen grooker!','',26124),
(63360,'enUS','Hallo, stranger! You are making quite an impression with the local hozen. I daresay they\'re starting to fear you.','',26124),
(63361,'enUS','As I live and breathe - an actual troll! You look just as the stories describe. You\'ve taught the Hozen quite the lesson.','',26124),
(63362,'enUS','%s is angry!!','',26124),
(63363,'enUS','You must be one of those folk from that sky-ship that crashed. I have MANY questions for you, but this is a terrible place to chat.','',26124),
(63364,'enUS','Please, find me in the Cave of Words, just up the hill here, when you have time to speak!','',26124),
(63365,'enUS','<Paint something sexy.>','<Paint something sexy.>',26124),
(63366,'enUS','<Paint something abstract.>','<Paint something abstract.>',26124),
(63367,'enUS','<Paint something heroic.>','<Paint something heroic.>',26124),
(63368,'enUS','Ah! Haha - I can see now what your Alliance fights for.','',26124),
(63369,'enUS','I prefer a little more meat on my birds, of course, but I can see that your people and mine are not so different after all.','',26124),
(63370,'enUS','What have we here? Fields of red and blue, violently clashing in a green land.','',26124),
(63371,'enUS','What could it mean? I can see a lot of turmoil in your heart, my new friend.','',26124),
(63372,'enUS','I see - one of your great Alliance warriors, is it? You have chosen a lion as your crest.','',26124),
(63373,'enUS','Your people are both stout and ferocious. But always remember, the lion kills only when hungry.','',26124),
(63374,'enUS','Here they come, yes, yes. You see how easy it is to make friends here?','',26124),
(63375,'enUS','Please remember that not all of your allies in Pandaria will be won over by sword point.','',26124),
(63376,'enUS','Well, my birds have taken a liking to you. I will follow their lead.','',26124),
(63377,'enUS','Welcome, my new Alliance friend! How can I be of service?','',26124),
(63378,'enUS','You are too late! The Thunder King will rise and take dis land from you.','',26124),
(63379,'enUS','Where have the Thunder King\'s Remains been taken?!','Where have the Thunder King\'s Remains been taken?!',26124),
(63380,'enUS','$p! You\'ve saved us! We\'ll go somewhere safe.','$p! You\'ve saved us! We\'ll go somewhere safe.',26124),
(63381,'enUS','The yaungol are so powerful... maybe we need to look to your people for protection.','The yaungol are so powerful... maybe we need to look to your people for protection.',26124),
(63382,'enUS','My home... I wonder if it\'s still standing. I\'ll go back and find out!','My home... I wonder if it\'s still standing. I\'ll go back and find out!',26124),
(63383,'enUS','I... I saw my life flash before my eyes!','I... I saw my life flash before my eyes!',26124),
(63384,'enUS','An outsider... saved me?','An outsider... saved me?',26124),
(63385,'enUS','I\'m... alive? I\'m alive! I\'m alive!','I\'m... alive? I\'m alive! I\'m alive!',26124),
(63386,'enUS','Your serpent will not venture beyond The Arboretum! Return to the Arboretum now!','Your serpent will not venture beyond The Arboretum! Return to the Arboretum now!',26124),
(63387,'enUS','How did they find us? Ready your weapons - we\'ve got to get out of this canyon!','',26124),
(63388,'enUS','For the empress!','',26124),
(63389,'enUS','Niuzao will fall!','',26124),
(63390,'enUS','The temple will be ours!','',26124),
(63391,'enUS','You are a fool to oppose the empress!','',26124),
(63392,'enUS','All of pandaria will bow to the empress!','',26124),
(63393,'enUS','You are venturing beyond training space! Return to The Arboretum or The Jadespire Sea before you are thrown off!','You are venturing beyond training space! Return to The Arboretum or The Jadespire Sea before you are thrown off!',26124),
(63394,'enUS','Imperial Vizier Zor\'lok inhales the Pheromones of Zeal!','',26124),
(63395,'enUS','Are you ready to display your martial prowess here, in the eye of The Tiger?','',26124),
(63396,'enUS','Ready for the next fight? Ring that gong and GET! IT! ON!','',26124),
(63397,'enUS','Fire!','',26124),
(63398,'enUS','For the empress!','',26124),
(63399,'enUS','Destroy the temple!','',26124),
(63400,'enUS','Show them her strength!','',26124),
(63401,'enUS','Hozen-grooker! Run!','',26124),
(63402,'enUS','Run! It\'s the ookin\' hozen-grooker!','',26124),
(63403,'enUS','Can\'t let you back in.$B$BThey\'re still fighting in there.','',26124),
(63404,'enUS','Fight\'s over.$B$BReady to go back inside?','',26124),
(63405,'enUS','Enter the arena.','Enter the arena.',26124),
(63406,'enUS','DOOK OOKEM GROOKER!','',26124),
(63407,'enUS','Thank you, grandchildren.','',26124),
(63408,'enUS','Thank you, $r.','Thank you, $r.',26124),
(63409,'enUS','My mind is clear. Thank you, $r.','My mind is clear. Thank you, $r.',26124),
(63410,'enUS','You will not break us, sha!','You will not break us, sha!',26124),
(63411,'enUS','Begone, minions of doubt!','Begone, minions of doubt!',26124),
(63412,'enUS','We shall dispel you from this land!','We shall dispel you from this land!',26124),
(63413,'enUS','Good to see a $c on our side!','Good to see a $c on our side!',26124),
(63414,'enUS','Drive them back!','Drive them back!',26124),
(63415,'enUS','Return to the earth!','Return to the earth!',26124),
(63416,'enUS','','You wanna be part of Soggy\'s crew? Then you\'re gonna start at the bottom like everyone else.',26124),
(63417,'enUS','Jinyu lover!','',26124),
(63418,'enUS','Sssuch weapons. I must have them!','',26124),
(63419,'enUS','Sssurrender!','',26124),
(63420,'enUS','What ssshiny armor. Give it to me now!','',26124),
(63421,'enUS','Bleeeeeed...','',26124),
(63422,'enUS','Surrender, warm blood!','',26124),
(63423,'enUS','Your weapons are weak!','',26124),
(63424,'enUS','The Keg Bomb is becoming unstable!','',26124),
(63425,'enUS','|TInterface\\Icons\\warrior_talent_icon_thunderstruck.blp:20|t Garalon flies up high and prepares a |cFFFF0000|Hspell:128555|h[Massive Crush]|h|r!','|TInterface\\Icons\\warrior_talent_icon_thunderstruck.blp:20|t Garalon flies up high and prepares a |cFFFF0000|Hspell:128555|h[Massive Crush]|h|r!',26124),
(63426,'enUS','[PH - Pretend there is a totally awesome cutscene here.]BOOM! You just blew up a bunch of yaungol! Oh man, they\'re running away!','',26124),
(63427,'enUS','[PH]Lin\'s chasing after them. Oh no! Lin!','',26124),
(63428,'enUS','[PH]A wild yaungol boss appears (from beyond the gate) and roars at you. You best get ready for a boss fight!','',26124),
(63429,'enUS','Do you mind? We\'re trying to get a picture, here.','',26124),
(63430,'enUS','I can\'t wait to send this picture to my girl back home. She\'s gonna freak!','',26124),
(63431,'enUS','Let\'s see here...$B$B\"Finding the proper f-stop. The f-number is the focal length divided by the \'effective\' aperture diameter.\"$B$BThis is making my head hurt.','Let\'s see here...$B$B\"Finding the proper f-stop. The f-number is the focal length divided by the \'effective\' aperture diameter.\"$B$BThis is making my head hurt.',26124),
(63432,'enUS','Thanks to the small fortune we made last season I was able to mail-order this fancy new camera!','Thanks to the small fortune we made last season I was able to mail-order this fancy new camera!',26124),
(63433,'enUS','I\'m really focusing on my photography right now.','I\'m really focusing on my photography right now.',26124),
(63434,'enUS','Would you hurry up? My arms are getting tired!','Would you hurry up? My arms are getting tired!',26124),
(63435,'enUS','Just take the picture already!','Just take the picture already!',26124),
(63436,'enUS','Just a second! You can\'t rush art!','Just a second! You can\'t rush art!',26124),
(63437,'enUS','\"...focusing at the hyperfocal distance ensures maximum sharpness from half this distance all the way to infinity...\"','\"...focusing at the hyperfocal distance ensures maximum sharpness from half this distance all the way to infinity...\"',26124),
(63438,'enUS','Hey, what do you suppose your \"hyperfocal distance\" is right now?','Hey, what do you suppose your \"hyperfocal distance\" is right now?',26124),
(63439,'enUS','I\'m ready to leave. Let\'s go!','I\'m ready to leave. Let\'s go!',26124),
(63440,'enUS','Reload!','',26124),
(63441,'enUS','','Riders approach!',26124),
(63442,'enUS','Who is that?','Who is that?',26124),
(63443,'enUS','Oh my, what is that thing?','Oh my, what is that thing?',26124),
(63444,'enUS','I have never seen one of those before.','I have never seen one of those before.',26124),
(63445,'enUS','Are you here to see the Jade Serpent?','Are you here to see the Jade Serpent?',26124),
(63446,'enUS','Wow... so many weapons.','Wow... so many weapons.',26124),
(63447,'enUS','Is that a sort of grummle?','Is that a sort of grummle?',26124),
(63448,'enUS','Is... Is that a troll? Like from the story books?','Is... Is that a troll? Like from the story books?',26124),
(63449,'enUS','What strange clothes you have.','What strange clothes you have.',26124),
(63450,'enUS','You look... different.','You look... different.',26124),
(63451,'enUS','What strange clothes you have.','What strange clothes you have.',26124),
(63452,'enUS','Are you from Kun-Lai?','Are you from Kun-Lai?',26124),
(63453,'enUS','Did you come from the turtle?','Did you come from the turtle?',26124),
(63454,'enUS','Who is that?','Who is that?',26124),
(63455,'enUS','How many weapons do you need?','How many weapons do you need?',26124),
(63456,'enUS','Hurry $p! Use the barrels to defeat those monstrosities!','',26124),
(63457,'enUS','Alright, let\'s go up to the monastery.','Alright, let\'s go up to the monastery.',26124),
(63458,'enUS','What is he doing over there?','What is he doing over there?',26124),
(63459,'enUS','Don\'t mind those two idiots outside - they\'re caught up in some fad called \"sharking.\"$B$BI\'d wager they feel pretty dumb about that picture in a couple of months.','',26124),
(63460,'enUS','This is going to be so epic!','',26124),
(63461,'enUS','You came not a moment too soon, Wakener. The Adjuncts would have destroyed me as I slept.','',26124),
(63462,'enUS','Even in my dreams, I could hear their dark thoughts... HER dark thoughts.','',26124),
(63463,'enUS','You can use the shark in a minute, just wait your turn!','',26124),
(63464,'enUS','We can use the balloon. Follow me!','',26124),
(63465,'enUS','The Empress fears her own undoing, yet fear itself is her undoing. She is gone beyond the edge of madness.','',26124),
(63466,'enUS','There is much punishment to deliver for the empire\'s crimes. We have no time to waste, Wakener. Meet me outside.','',26124),
(63467,'enUS','Thank you Elders. We will not dissapoint you.','',26124),
(63468,'enUS','You look like you could make us some money.$B$BHow about a spin inside the Arena of Annihilation, pal?','',26124),
(63469,'enUS','Rip the flesh from their bones!','',26124),
(63470,'enUS','Leave nothin\' behind!','',26124),
(63471,'enUS','Make dem fear the Zandalari!','',26124),
(63472,'enUS','Feed on them my pets!','',26124),
(63473,'enUS','Will these invaders ever stop?!','Will these invaders ever stop?!',26124),
(63474,'enUS','Their cruelty seems to know no end.','Their cruelty seems to know no end.',26124),
(63475,'enUS','I feel as though I\'ve been out here for days...','I feel as though I\'ve been out here for days...',26124),
(63476,'enUS','I\'ll die before I see this village fall!','I\'ll die before I see this village fall!',26124),
(63477,'enUS','I\'ll cover your post. Go rest and be with your family.','You\'re exhausted. Go rest and prepare for the battle to come.',26124),
(63478,'enUS','I\'ll die before I see this village fall!','',26124),
(63479,'enUS','I feel as though I\'ve been out here for days...','',26124),
(63480,'enUS','Their cruelty seems to know no end.','Their cruelty seems to know no end.',26124),
(63481,'enUS','Hey there, $r. Lorewalker Cho told me aaaaallll about you. Or at least, the important stuff. Folks around here might be a little hesitant around you though so you may want to get on their good side first.','',26124),
(63482,'enUS','Another stranger? Does your kind enjoy a good brew? If so, try some Goldendraft Reserve!','',26124),
(63483,'enUS','So, stranger, are you the wild and crazy type like the hozen?$b$bOr the quiet and thoughtful type like the jinyu?','So, stranger, are you the wild and crazy type like the hozen?$b$bOr the quiet and thoughtful type like the jinyu?',26124),
(63484,'enUS','Are you from beyond the wall?','Are you from beyond the wall?',26124),
(63485,'enUS','Where did you come from?','Where did you come from?',26124),
(63486,'enUS','Wow. You look... um... well... different than I would have expected. Are there more like you?','Wow. You look... um... well... different than I would have expected. Are there more like you?',26124),
(63487,'enUS','What interesting colors you are wearing. Did you weave that yourself?','What interesting colors you are wearing. Did you weave that yourself?',26124),
(63488,'enUS','Are there more like you?','Are there more like you?',26124),
(63489,'enUS','Why, hello stranger. You look like a creature that has stories to tell.','Why, hello stranger. You look like a creature that has stories to tell.',26124),
(63490,'enUS','What a fascinating jawline you have. And such coloration. Where did you come from?','What a fascinating jawline you have. And such coloration. Where did you come from?',26124),
(63491,'enUS','Hmm. What armor...','',26124),
(63492,'enUS','A stranger? Well look at that. I wonder where it came from.','A stranger? Well look at that. I wonder where it came from.',26124),
(63493,'enUS','What a strange and curious creature. Do you come to my town with peaceful intentions?','',26124),
(63494,'enUS','Another stranger? And so... strange looking.','',26124),
(63495,'enUS','That poor creature. It\'s so thin... it must be starving.','',26124),
(63496,'enUS','It\'s that stranger Cho mentioned. I wonder if there are more of them.','',26124),
(63497,'enUS','Welcome stranger. It has been a long time since I\'ve seen someone new travel through here.','',26124),
(63498,'enUS','And where did you come from I wonder? Some place that lacks for quality beverages? Hmm?','',26124),
(63499,'enUS','What strange garb you wear.','',26124),
(63500,'enUS','A stranger? Here? Don\'t start any trouble in our town.','',26124),
(63501,'enUS','Are you from the Turtle?','Are you from the Turtle?',26124),
(63502,'enUS','How big is your family?','How big is your family?',26124),
(63503,'enUS','Did you ever see the big wall in the west?','Did you ever see the big wall in the west?',26124),
(63504,'enUS','Are you a fighter? Can you teach me how you fight?','I bet my dad could beat you up. He\'s the biggest monk ever.',26124),
(63505,'enUS','Why are you so thin?','Why are you so thin?',26124),
(63506,'enUS','You dress funny.','You dress funny.',26124),
(63507,'enUS','Who shaved off all your fur?','Who shaved off all your fur?',26124),
(63508,'enUS','Are you a grummle? Where\'s your backpack?','Are you a grummle? Where\'s your backpack?',26124),
(63509,'enUS','Are you a yaungol? I heard yaungol are bad.','Are you a yaungol? I heard yaungol are bad.',26124),
(63510,'enUS','Why are you so pink and hairless?','Why are you so pink and hairless?',26124),
(63511,'enUS','You have floppy ears!','Why are your ears flopping?',26124),
(63512,'enUS','You have floppy ears!','Why are your ears flopping?',26124),
(63513,'enUS','Your face looks angry.','Your face looks angry.',26124),
(63514,'enUS','What happned to your backpack, grummle?','You look green. Are you sick?',26124),
(63515,'enUS','Are you a mogu?','You walk like a mogu!',26124),
(63516,'enUS','Are you a troll?! I heard trolls are evil.','Are you a troll? Like from the storybooks?',26124),
(63517,'enUS','','I\'m going ahead. I will see you on the other side... I hope.',26124),
(63518,'enUS','|TInterface\\Icons\\ability_warlock_everlastingaffliction.blp:20|t%s is affected by |cFFFF0000|Hspell:123011|h[Terrorize]|h|r! Dispel %s!','',26124),
(63519,'enUS','Ha! What say you to master swordsman, Tenwu the Red Smoke?','',26124),
(63520,'enUS','','Shall we get a move on?',26124),
(63521,'enUS','It is a good day for a hunt.','',26124),
(63522,'enUS','Blade Lord Ta\'yak marks $n for |cFFFF0000|Hspell:122949|h[Unseen Strike]|h|r!','',26124),
(63523,'enUS','Does the agony ever stop?','',26124),
(63524,'enUS','What has the world come to when you can\'t even die without crabs picking at you?','',26124),
(63525,'enUS','I\'m not dead yet you scavenger!','',26124),
(63526,'enUS','How fitting. The fisherman eaten by the fish...','',26124),
(63527,'enUS','Hi!','Hi!',26124),
(63528,'enUS','The stranger is here!','The stranger is here!',26124),
(63529,'enUS','I saw it first!','I saw it first!',26124),
(63530,'enUS','Are you of beard-sprite?','Are you a sprite?',26124),
(63531,'enUS','I\'m almost as tall as you!','I\'m almost as tall as you!',26124),
(63532,'enUS','Thank you. Mind if I tag along and take some revenge?','Thank you. Mind if I tag along and take some revenge?',26124),
(63533,'enUS','Wow! I\'m taller than you!','Wow! I\'m taller than you!',26124),
(63534,'enUS','Are there other grummles coming?','Are there other grummles coming?',26124),
(63535,'enUS','Cho said you were a \"hooman\". Is that like a hozen?','Cho said you were a \"hooman\". Is that like a hozen?',26124),
(63536,'enUS','Why are you so thin?','Why are you so thin?',26124),
(63537,'enUS','Why are you so green?','Why are you so green?',26124),
(63538,'enUS','Why do you make so many angry sounds?','Why do you make so many angry sounds?',26124),
(63539,'enUS','Get those supplies moved!','',26124),
(63540,'enUS','Friend, this is Dawn\'s Blossom! The heart of Pandaren life here in the Jade Forest. If you wish to make an impression, I am certain many of these citizens could use your help.','',26124),
(63541,'enUS','For now I must leave you. Toya is gathering jade for my project. When he is finished I would like you to bring it to me at the Emperor\'s Omen so that we might look at what secrets history has hidden from us.','',26124),
(63542,'enUS','Your timing is flawless. I was just about to leave. But please, stay and enjoy the town while Toya gathers the jade we need.','',26124),
(63543,'enUS','See you later!','See you later!',26124),
(63544,'enUS','Bye!','Bye!',26124),
(63545,'enUS','I\'m gonna go play.','I\'m gonna go play.',26124),
(63546,'enUS','Careful with the scorpion, he may look friendly but he is a beast in battle!','Careful with the scorpion, he may look friendly but he is a beast in battle!',26124),
(63547,'enUS','Are you eyeing my cat?','Are you eyeing my cat?',26124),
(63548,'enUS','Hello fellow angler!  Have you been around these parts long?  Me and my buddy \"Big Hook\" here travel far and wide looking for the next big catch!$b$bWe ran into this place by accident and the locals were friendly with both their supplies and booze so we decided to stick around!','',26124),
(63549,'enUS','Been working for the anglers?  Check out these rewards!','',26124),
(63550,'enUS','Mogu\'Shan Palace, a level 87-89 dungeon in the Vale of Eternal Blossoms, is now available for testing. Please be in your full group before teleporting to the dungeon. Meeting Stones are not available for this dungeon yet.\n\nTo leave Mogu\'Shan Palace, simply exit through the normal exit inside the dungeon and you will be teleported to Dalaran. If you die and release, you should teleport back from this NPC.','',26124),
(63551,'enUS','%s activates his |cFFFF0404|Hspell:119311|h[Stream of Blades]|h|r trap!','',26124),
(63552,'enUS','I\'m in my group and ready to teleport to Mogu\'Shan Palace!','I\'m in my group and ready to teleport to Mogu\'Shan Palace!',26124),
(63553,'enUS','Take me back to Mogu\'Shan Palace!','Take me back to Mogu\'Shan Palace!',26124),
(63554,'enUS','%s activates his |cFFFF0404|Hspell:120142|h[Crossbow]|h|r trap!','',26124),
(63555,'enUS','%s activates his |cFFFF0404|Hspell:119374|h[Whirlwinding Axe]|h|r trap!','',26124),
(63556,'enUS','We shall rise again!','',26124),
(63557,'enUS','Please fly me to the Terrace of Gurthan.','Please fly me to the Terrace of Gurthan.',26124),
(63558,'enUS','Word of your travels has reached me. You ride on the winds of change.','',26124),
(63559,'enUS','I am curious, in your homeland, is there ever peace?','',26124),
(63560,'enUS','And how have you been enjoying our land? Have you been learning?','',26124),
(63561,'enUS','The art of the Windfur Punch has been handed down from generation to generation in my family since the dark days.$b$bIt is said this punch was first attempted during the dark days of the mogu empire, and aided in earning pandaren their freedom.','',26124),
(63562,'enUS','Your visit is like the gust of wind before the storm.','',26124),
(63563,'enUS','I am told you were a guest of the forest hozen and survived. I suspect we will see interesting things from you in the coming days.$b$bI welcome you, traveller, to our humble home.','',26124),
(63564,'enUS','Wind is better bent, than broken. ...get it? I made a funny.','',26124),
(63565,'enUS','So you are the creature who gave the jinyu the courage they needed to stand their ground against the hozen.$b$bSuch courage is something we have not seen in some time. I welcome you to our humble home.','',26124),
(63566,'enUS','You battled well today, $p. May you wear your title with honor.','',26124),
(63567,'enUS','%s casts |cFFFF0000|Hspell:107140|h[Magnetic Shroud]|h|r.  Group up to release the healing energy!','',26124),
(63568,'enUS','So... you\'re the stranger Cho was talking about.$b$bWelcome to Dawn\'s Blossom! I am Peiji Goldendraft and my family makes only the finest brews in Pandaria.$b$bUnlike those Wanderbrews who keep slinking around ruining the good name of Brewmasters everywhere. I think I even spied the young one eyeing my daughter. Can\'t have that! Goldendrafts and Wanderbrews do not mix.','',26124),
(63569,'enUS','I\'m going to keep looking for jade. May want to ask around and see if anyone could use a hand.','',26124),
(63570,'enUS','Hozen only give name name to good grookers.$b$bMaybe one day they call you $n $n.','',26124),
(63571,'enUS','We\'re doomed!','',26124),
(63572,'enUS','Hurry elders! You must hide!','',26124),
(63573,'enUS','I swear I saw that little Syra Goldendraft giving my boy \"the looks\". Can\'t have that.','',26124),
(63574,'enUS','Thank goodness you\'re here!  Toss that fishing pole and help us out!','Thank goodness you\'re here!  Toss that fishing pole and help us out!',26124),
(63575,'enUS','Kovok seems to have weathered the years in hibernation well.','',26124),
(63576,'enUS','Going to Kun-Lai? Hop in the boat and I\'ll give you a ride.','',26124),
(63577,'enUS','A fellow angler I see!  I have a variety of gear from these local fisherman, just let me know what you need!','',26124),
(63578,'enUS','My research must continue.','',26124),
(63579,'enUS','No, no, no! I cannot stop now. My mutations must live!','',26124),
(63580,'enUS','I have coated your hands with a special mixture, Wakener. Every time you defeat an enemy, their corpse will be injected with a special toxin. Observe the results, and use them to your advantage.','',26124),
(63581,'enUS','All creatures have their uses, Wakener, but you must kill them to find out!','',26124),
(63582,'enUS','May the amber protect and nourish you, Wakener.','',26124),
(63583,'enUS','Let my strength be your strength. For every damaging strike you make, you shall steal some of your opponent\'s life in return.','',26124),
(63584,'enUS','I have coated your weapons with a special serum. Use it to inject your enemies. Too many injections, and their systems will overload.','',26124),
(63585,'enUS','Come, Wakener. Let us meet our enemies.','',26124),
(63586,'enUS','How many years have passed since I first entered the slumber? This vess, the palace, my Empress. All have changed.','',26124),
(63587,'enUS','Is this white blight the work of the sha? I see now what disease spreads across our civilization. The infected must be purged!','',26124),
(63588,'enUS','Just look at those mantid below us. The Empress orders the Swarm much too early! Another sign of her chaotic delusions.','',26124),
(63589,'enUS','Why are they already swarming? The time has not yet come.','',26124),
(63590,'enUS','Travelling on Valley roads is strange. The ground is so flat here and it is too hot.$b$bI miss Kun-Lai.','',26124),
(63591,'enUS','Something drives them. They are frightened.','',26124),
(63592,'enUS','No matter. Even I can feel the evil that taints their minds. Let us end their madness.','',26124),
(63593,'enUS','I see that my slumber was brief. I recognize Mel\'jarak, lord of the skies. Once, my brother. Now, no longer.','',26124),
(63594,'enUS','I see that my slumber was brief. I recognize Ta\'yak there, just in front of the palace. The Empress\'s champion of blades. In my time, he stood undefeated.','',26124),
(63595,'enUS','I see that my slumber was brief. I recognize Un\'sok down there. I see he has renamed himself Ambershaper. Ha! His skills never did surpass my own.','',26124),
(63596,'enUS','I see that my slumber was brief. I recognize Zor\'lok, voice of the Empress. Her obedient little pet.','',26124),
(63597,'enUS','I am ready to fly, Xaril.','I am ready to fly, Xaril.',26124),
(63598,'enUS','Repairing the damage Kor\'ik did will take time, but it can be done.','',26124),
(63599,'enUS','You hear a faint clicking noise coming from the west...','',26124),
(63600,'enUS','A high pitch humming noise emanates in the distance...','',26124),
(63601,'enUS','The gem shatters!','',26124),
(63603,'enUS','You see a brief glimmer along the east wall...','',26124),
(63604,'enUS','Where can I find Assistant Buzaki?','Where can I find Assistant Buzaki?',26124),
(63605,'enUS','Anything else I can do?','Anything else I can do?',26124),
(63606,'enUS','Wikket whacked!','',26124),
(63607,'enUS','Dooker OOKED!','',26124),
(63608,'enUS','Get grooked, dooker!','',26124),
(63609,'enUS','The final ingredient, a secret passed down through generations of my family, comes all the way from the Krasarang Wilds. I sent Assistant Buzaki to pick it up for me a few days ago, and received word that he reached the Tavern in the Mists last night. Can you head into the Ancient Passage and find out what\'s keeping him? He better not still be asleep at the tavern!','',26124),
(63610,'enUS','Look lively, mates!','',26124),
(63611,'enUS','There\'s Horde to kill, lads! I can smell \'em!','',26124),
(63612,'enUS','It\'s do or die, chaps! No turnin\' back!','',26124),
(63613,'enUS','A few monkeys are no match for the Alliance!','',26124),
(63614,'enUS','Stand down, savages! I claim this land in the name of the Alliance!','',26124),
(63615,'enUS','Hang on, men! Reinforcements are inbound!','',26124),
(63616,'enUS','Get grooked, wik-','',26124),
(63617,'enUS','Grant me your assistance, Malik. [Klaxxi Enhancement]','Grant me your assistance, Malik. [Klaxxi Enhancement]',26124),
(63618,'enUS','The trick, Wakener, is to be like water. Do not resist your enemy\'s force - simply flow with it. Let his blows drift past you. Then IMPALE HIM.','',26124),
(63619,'enUS','Need a flapper?','',26124),
(63620,'enUS','Send me to Dawn\'s Blossom.','Send me to Dawn\'s Blossom.',26124),
(63621,'enUS','Thanks, $p! I thought I was done for.','',26124),
(63622,'enUS','I panicked when I saw all those saurok and wrecked my boat.','',26124),
(63623,'enUS','I need to get this to Brewmaster Boof before the festival starts. Thanks again for saving me, $p!','',26124),
(63624,'enUS','Ah! Good! You made it. It is time to teach these \"pirate\" hozen why they should not raid our villages.','',26124),
(63625,'enUS','Are you sure you\'re ready to head out?','Are you sure you\'re ready to head out?',26124),
(63626,'enUS','The amber offers a paragon\'s respite, Wakener. Should you fall near death, it will activate on its own.','',26124),
(63627,'enUS','Show no mercy! Thrive on the scent of blood! The more you attack, the more health you will regain.','',26124),
(63628,'enUS','','It looks like he\'s just unconscious. I should be able to wake him up.',26124),
(63629,'enUS','','Let\'s get back to the festival, $p. Stop by my house later, I\'m making something special!',26124),
(63630,'enUS','','Brewmaster! Bataari scouting parties have been sighted outside the village!',26124),
(63631,'enUS','Is that... HEY! You brought \'em back!','',26124),
(63632,'enUS','You saved me! What a hero!','You saved me! What a hero!',26124),
(63633,'enUS','I always knew a $pc could beat up a yaungol!','I always knew a $pc could beat up a yaungol!',26124),
(63634,'enUS','Where... where did you come from? Thank you!','Where... where did you come from? Thank you!',26124),
(63635,'enUS','','The air is so clean here.',26124),
(63636,'enUS','','I grew up on the Wandering Isle. Space was so limited there. Never room to hunt and never really any predators worth mentioning.$b$bBut here... here there are the great mushan and wolves and all sorts of predators. This is this hunter\'s dream come true.',26124),
(63637,'enUS','','First time in Pandaria? Mine too. I remember the stories they would tell us of this place. So exciting!',26124),
(63638,'enUS','','I first met the Nesingwarys in Stranglethorn. I\'ve been bumping in to them off and on ever since. I finally earned a place in their safari!',26124),
(63639,'enUS','','Oh! I think I recognize you. You\'re from the Wandering Isle right?$b$bIsn\'t it so strange to be in Pandaria?$b$bI always thought this place was nothing more than a legend. I can\'t believe it actually exists!',26124),
(63640,'enUS','','There is so much life here. And so much space.$b$bBack on the Wandering Isle there was never enough space for predators to grow large enough to hunt.',26124),
(63641,'enUS','','Ah good! You found the safari. That jungle is a little rough to navigate without some travel sense.$b$bThose mogu kept getting in the way of my hunting.',26124),
(63642,'enUS','|TInterface\\Icons\\creatureportrait_bubble.blp:20|t%s casts |cFFFF0000|Hspell:124653|h[Water Shell]|h|r! Use the Water Spouts to pop it!','',26124),
(63643,'enUS','A hunter hunts. An artist... arts.$b$bI am here to capture the ferocity of the hunt through my art.$b$bWe are in strange lands, and few in the known world are familiar with the strange creatures of our hunt.$b$bThrough my art, I prove your success, and the success of the Nesingwarys.','',26124),
(63644,'enUS','','Drink up, $p. I wanna see that vial empty before you so much as dip a toe into the sea.',26124),
(63645,'enUS','','There you go. Tastes like seaweed and hot garbage, doesn\'t it?',26124),
(63646,'enUS','','Welcome to the North Wind Tavern.',26124),
(63647,'enUS','','Greetings friend! Will you require a room for the night?',26124),
(63648,'enUS','Can you help me get out on the water, Tart?','Can you help me get out on the water, Tart?',26124),
(63649,'enUS','I never thought I would have to pick up a weapon to use it again...','',26124),
(63650,'enUS','I had almost fooled myself into believing Zouchin was protected from the darkness in the world.','',26124),
(63651,'enUS','I retired from battle to live in peace with my family. It seems battle will not let me retire so easily.','',26124),
(63652,'enUS','I was once a great fighter. Let us hope old age has not taken too much of my skill from me.','',26124),
(63653,'enUS','Preparing this village is not just about putting weapons in their hands. We must teach them to use them with confidence.','',26124),
(63654,'enUS','','Thanks again, $p! I\'ll get this to Brewmaster Boof right away.',26124),
(63655,'enUS','Anduin... run...','',26124),
(63656,'enUS','','We meet again, stranger from beyond the mists.',26124),
(63657,'enUS','','This battle has extracted a heavy toll. My own rebirth will have to wait for several years.',26124),
(63658,'enUS','','Learn from this, stranger!',26124),
(63659,'enUS','','I do not know why the mists have opened. But I know that it is for a reason.',26124),
(63660,'enUS','','It is clear that you are not here to bring your war to these lands. There is a darkness hidden here in Pandaria - this you have seen for yourself!',26124),
(63661,'enUS','','But I am certain that the mists parted for a reason. YOU are that reason. Find your purpose here.',26124),
(63662,'enUS','','You can learn a great deal about this land from the Valley of the Four Winds.',26124),
(63663,'enUS','','There is another visitor from beyond the mists here. \"Chen Stormstout\" he is called. He is Pandaren, but from a different homeland.',26124),
(63664,'enUS','','Walk this land with Chen at your side. Make friends among the people here. You will find answers in time.',26124),
(63665,'enUS','','Farewell, stranger. When next we meet, I hope to call you \'friend.\'',26124),
(63666,'enUS','Use the cannons! Shoot down the mantid!','',26124),
(63667,'enUS','<The beacon hums softly.>','',26124),
(63668,'enUS','','Help!',26124),
(63669,'enUS','','They are going to eat me!',26124),
(63670,'enUS','','Get them away from me!',26124),
(63671,'enUS','','I\'m too young to die!',26124),
(63672,'enUS','','I\'m not food!',26124),
(63673,'enUS','','Someone save me!',26124),
(63674,'enUS','','Help! Help!',26124),
(63675,'enUS','','Ahhhhhhhh!',26124),
(63676,'enUS','I need another shark!','I need another shark!',26124),
(63677,'enUS','Interested in catching a shark?','Interested in catching a shark?',26124),
(63678,'enUS','','Thanks, $p! They were going to eat me!',26124),
(63679,'enUS','','The virmen are eating all of the grain!',26124),
(63680,'enUS','','$n, can you help me get rid of these virmen?',26124),
(63681,'enUS','','Get those virmen!',26124),
(63682,'enUS','','Shoo!',26124),
(63683,'enUS','','Get away from there!',26124),
(63684,'enUS','','Save the grain, $p!',26124),
(63685,'enUS','','Get those virmen, $p!',26124),
(63686,'enUS','','It\'s the Den Mother! Look out, $p!',26124),
(63687,'enUS','The Shado-Pan sends a lackey to do their work? Perhaps Shan\'bu was wrong about them...','',26124),
(63688,'enUS','Hah! You have... already... failed...','',26124),
(63689,'enUS','','There\'s still more virmen in the silos! Can you scare them off for me, $p?',26124),
(63690,'enUS','Need a break from your enemies? You have come to the right place, and the right person.','',26124),
(63691,'enUS','Oh... I seem to have lost my sword.','',26124),
(63692,'enUS','When the Sundering ripped apart the continents of Azeroth, we pandaren thought that the rest of the world had been utterly destroyed.','',26124),
(63693,'enUS','But as the centuries passed, one young explorer decided to see what was out there. His name was Liu Lang. And he set out to discover the world... on the back of a turtle!','',26124),
(63694,'enUS','We celebrate his bravery with statue and song, but if you were actually there on the beach that very day - well, I\'m sure he looked quite silly, indeed.','',26124),
(63695,'enUS','Oh, how the pandaren laughed at him. But Liu Lang was more clever than anyone thought. Sea turtles always return to the beach where they were born. And so, despite the mists that envelop our land, he always had a way home.','',26124),
(63696,'enUS','Every few years, he returned - with tales of mysterious cities in the sand, nomadic people living on endless grassy plains, a great empire under the ice, and a magical kingdom gilded in gold.','',26124),
(63697,'enUS','Each time he returned, more and more pandaren answered Liu Lang\'s call, and joined him on his growing turtle. They were the bravest among us: The explorers. The adventurers.','',26124),
(63698,'enUS','And that is the lesson of Liu Lang, my friend. Everyone always laughs at the explorer. They always laugh... until he returns.','',26124),
(63699,'enUS','Great events often have humble beginnings. Consider: a quiet pond. Still. The water is like a sheet of glass.','',26124),
(63700,'enUS','Until I throw a stone. Such a small thing - but soon, ripples engulf the whole of the lake!','',26124),
(63701,'enUS','The jinyu also have humble origins. Once primitive creatures, they were fortunate enough to live near the enchanted pools within the Vale.','',26124),
(63702,'enUS','The magic of the pools expanded their minds and grew their bodies, until they became one of the great ancient cultures of Pandaria.','',26124),
(63703,'enUS','The wisest of the jinyu are very wise indeed - they can speak to the rivers the way you and I would consult our elders.','',26124),
(63704,'enUS','In the whispering waters, they can hear the future.','',26124),
(63705,'enUS','The jinyu and their waterspeakers stand at the very heart of the greatest events in Pandaria\'s history.','',26124),
(63706,'enUS','Their visions built empires, freed slaves, and warned our Last Emperor of the Sundering that shattered Azeroth ten thousand years ago.','',26124),
(63707,'enUS','Think about it: the smallest voice can change the world. Consider that, friend, the next time you decide to start throwing stones!','',26124),
(63708,'enUS','Oh, my student - you wish to study the mantid? Be warned: the pandaren frontier is littered with the graves of former pupils.','',26124),
(63709,'enUS','The mantid are harsh teachers.','',26124),
(63710,'enUS','Every generation, the mantid swarm the Serpent\'s Spine wall in great numbers. They murder many pandaren, so we kill many times their number in return. Yet each generation, they attack once more. Why do they do this?','',26124),
(63711,'enUS','We pandaren do not know.','',26124),
(63712,'enUS','Our ancient writings indicate that the mantid have always been here. They predate even the mogu. Where did they come from?','',26124),
(63713,'enUS','We pandaren do not know.','',26124),
(63714,'enUS','Perhaps, if you were to befriend the mantid, and earn a reputation among them, they would teach you their secrets. But I warn you:','',26124),
(63715,'enUS','Nobody has ever befriended the mantid.','',26124),
(63716,'enUS','Here is what the pandaren do know: By massacring our people, by slaughtering tens of thousands of pandaren, generation after generation, they have taught us the value of life. A precious but fleeting gift. Easily snuffed out... in an instant.','',26124),
(63717,'enUS','This is what the mantid have taught us.','',26124),
(63718,'enUS','What do you fear most in this world? Have you conquered your fear... or has your fear conquered you?','',26124),
(63719,'enUS','In the ancient days before the sundering of the world, the mogu emperors ruled over Pandaria. My people were made slaves, and they were afraid.','',26124),
(63720,'enUS','The mogu were masters of pain and torture, of dark magics and brutal weapons. No pandaren, hozen, or jinyu could resist the power they held. And my people were afraid.','',26124),
(63721,'enUS','It was the mogu who built the Serpent\'s Spine. The most unlucky of slaves were sent to aid in its construction and defense, to be fodder for the mantid. And my people were afraid.','',26124),
(63722,'enUS','As the empire grew, the mogu began to experiment with the secrets of the Vale. They crafted terrible weapons of living flesh and stone. And my people were afraid.','',26124),
(63723,'enUS','In their hubris, the mogu never foresaw that their downfall lay in wait, not among their enemies, but among the oppressed. The day that one slave stood...','',26124),
(63724,'enUS','...and was no longer afraid.','',26124),
(63725,'enUS','Fire! It is the most magical of elements. It warms us, it cooks our food. It is the hearthfire that makes a house a home. In the right hands, fire can shape iron into swords or plowshares. Left uncontrolled, fire could destroy a city.','',26124),
(63726,'enUS','Fire is the instrument of change.','',26124),
(63727,'enUS','Long ago, a group of sturdy nomad hunters wandered the world. By a stroke of fate, they were here in Pandaria when the Sundering split apart the continents of Azeroth. The wanderers found themselves trapped in the Townlong Steppes, a harsh and dangerous land.','',26124),
(63728,'enUS','Those noble hunters found a way to survive on their own. Fire was the key. They drew up oil from the ground. They used it to heat their homes, cook their food, and burn their enemies. They grew STRONG.','',26124),
(63729,'enUS','From the flames of fate, the yaungol were born. They survive beyond the wall, for they refuse to submit to any law but their own.','',26124),
(63730,'enUS','Has fate been cruel to the yaungol? You may as well ask if fire is good or bad.','',26124),
(63731,'enUS','Fate is like fire; it can shape or destroy us.','',26124),
(63732,'enUS','All that matters is what you do with it.','',26124),
(63733,'enUS','Ah! You wish to learn of our last and greatest emperor, Shaohao? My friend, I do not have the time here to recount all of his adventures, but his actions ten thousand years ago resonate to this very day.','',26124),
(63734,'enUS','We know that he purged his doubts in the Jade Forest. That he cleansed himself of despair in the Krasarang Wilds. That he overcame his fear in Townlong Steppes. And that he defeated anger, hatred, and violence high in the mountains of Kun-Lai.','',26124),
(63735,'enUS','This is known; and there are temples to mark these most sacred of places.','',26124),
(63736,'enUS','But I want you to imagine standing in this very valley on the day he returned from his journey. Imagine being here when the gates opened for him. By then our emperor was a creature of pure light: No doubts, no fears, no hatred...','',26124),
(63737,'enUS','It is said that all the trees in the vale blossomed as he entered, and continue to blossom to this day.','',26124),
(63738,'enUS','Would that we could all live like our most sacred emperor. That we could put aside all our burdens and exist in harmony with the cosmos. THAT, I believe, was his message to us... before he became one with the land, and hid Pandaria away from the terror of the Sundering.','',26124),
(63739,'enUS','Thank you, dear emperor.','',26124),
(63740,'enUS','One day, a father grew tired of his young cub\'s misbehavior.  \"You act just like a hozen!\" the father scolded. Still, his son misbehaved.','',26124),
(63741,'enUS','To teach him a lesson, the father dragged the cub out to the forest, to watch how the hozen live. \"Do you see what the hozen are like?\" he asked. \"Do you want to live like that?\"','',26124),
(63742,'enUS','The hozen are quite lively indeed. A short-lived race, few hozen survive past their 20th birthday. Their leaders are all 14 or 15. How mature were you at 14 years old? Meditate on that!','',26124),
(63743,'enUS','Afterwards, the father asked his cub what he had learned.','',26124),
(63744,'enUS','\"I learned that we work and toil on our little farm, but that the hozen have the whole world as their garden,\" the cub said. \"I learned that we squint by the light of a single candle, but that the hozen enjoy the light of the stars. I learned that I go to school every day, but that the hozen learn by doing.\"','',26124),
(63745,'enUS','And the cub concluded, \"I should very much like to live like a hozen!\"','',26124),
(63746,'enUS','Who then, was the wiser? The father or the cub?','',26124),
(63747,'enUS','That, my friend, is for you to decide.','',26124),
(63748,'enUS','It\'s been quite some time since someone was brave enough to challenge me.','',26124),
(63749,'enUS','I\'ll see you in the ring.','',26124),
(63750,'enUS','Don\'t hold back.','',26124),
(63751,'enUS','You give a good fight!  Don\'t stop now.','',26124),
(63752,'enUS','WHITEFEATHER?!  Nooooo!','',26124),
(63753,'enUS','You... have... bested me...','',26124),
(63754,'enUS','You are impressive indeed.  It would be my honor to fight beside you.','',26124),
(63755,'enUS','My compliments, friend.  I can\'t remember the last time someone bested me so handily.','',26124),
(63756,'enUS','Niuzao... we must save him!','',26124),
(63757,'enUS','Alright. Let\'s go.','Alright. Let\'s go.',26124),
(63758,'enUS','Ahahaha, the great Niuzao, strength of the west, divine celestial, protector of the weak...','',26124),
(63759,'enUS','Your charge, the sha of fear, has escaped.','',26124),
(63760,'enUS','You wield the powers of a god, but you are beaten!','',26124),
(63761,'enUS','The mantle of a god must be heavy to bear.','',26124),
(63762,'enUS','Lay your duties aside and rest.','',26124),
(63763,'enUS','You bear the burden of an entire people upon your shoulders. And how have they repaid you?','',26124),
(63764,'enUS','You suffer in silence for a people who give little thanks.','',26124),
(63765,'enUS','I\'ve won the Brew Toss competition six years running! If you\'d like, I can toss this brew all the way across the village and cause a brew strike! All you have to do is point.  Would you like that?','I\'ve won the Brew Toss competition six years running! If you\'d like, I can toss this brew all the way across the village and cause a brew strike! All you have to do is point.  Would you like that?',26124),
(63766,'enUS','Absolutely! I\'d love to see that!','Absolutely! I\'d love to see that!',26124),
(63767,'enUS','No thanks...','No thanks...',26124),
(63768,'enUS','I will NEVER yield!','',26124),
(63769,'enUS','Coldbite Matriarch begins to summon Coldbite Hatchlings.','Coldbite Matriarch begins to summon Coldbite Hatchlings.',26124),
(63770,'enUS','Imperial Vizier Zor\'lok flies to one of his platforms!','',26124),
(63771,'enUS','|TInterface\\Icons\\ability_warrior_battleshout.blp:20|tImperial Vizier Zor\'lok sends |cFFFF0000|Hspell:122336|h[Sonic Rings]|h|r across the room!','',26124),
(63772,'enUS','|TInterface\\Icons\\spell_druid_stamedingroar.blp:20|tImperial Vizier Zor\'lok |cFFFF0000|Hspell:122852|h[Inhales]|h|r a large breath!','',26124),
(63773,'enUS','|TInterface\\Icons\\spell_shadow_psychicscream.blp:20|tImperial Vizier Zor\'lok |cFFFF0000|Hspell:122761|h[Exhales]|h|r with great force at |cFFFF0000$n|r!','',26124),
(63774,'enUS','|TInterface\\Icons\\warrior_disruptingshout.blp:20|tImperial Vizier Zor\'lok shouts with |cFFFF0000|Hspell:122713|h[Force and Verve]|h|r!','',26124),
(63775,'enUS','|TInterface\\Icons\\trade_archaeology_delicatemusicbox.blp:20|tImperial Vizier Zor\'lok sings the |cFFFF0000|Hspell:123791|h[Song of the Empress]|h|r, damaging all players until they engage in combat with him!','',26124),
(63776,'enUS','|TInterface\\Icons\\spell_arcane_mindmastery.blp:20|tImperial Vizier Zor\'lok uses his voice to |cFFFF0000|Hspell:122740|h[Convert]|h|r members of the raid to fight on his side!','',26124),
(63779,'enUS','|TInterface\\Icons\\ability_warrior_bladestorm.blp:20|tWind Lord Mel\'jarak begins to cast |cFFF00000|Hspell:121896|h[Whirling Blade]|h|r!','|TInterface\\Icons\\ability_warrior_bladestorm.blp:20|tWind Lord Mel\'jarak begins to cast |cFFF00000|Hspell:121896|h[Whirling Blade]|h|r!',26124),
(63780,'enUS','What the...?! This ain\'t the charter! It\'s a letter. In Arie\'s handwriting?','',26124),
(63781,'enUS','\"Dear Soggy, if you are reading this it means you finally worked up the guts to send someone after the old charter. Well, you\'re too late.\"','',26124),
(63782,'enUS','\"We know the Mist-Hopper wasn\'t hired to venture this far beyond the wall. We know it was supposed to be a routine job off the coast of Jade Forest.\"','',26124),
(63783,'enUS','\"What should have been a week of easy fishing turned into a wild misadventure that ran us aground in the most dangerous place on the continent and nearly got us all killed, because you couldn\'t stop chasing your hunches.\"','',26124),
(63784,'enUS','\"We just wanted to say: Thank you.\"','',26124),
(63785,'enUS','\"Thank you for chasing fortune on the distant horizon. Thank you for dreaming. And most of all, thank you for bringing us along.\"','',26124),
(63786,'enUS','\"We\'ll always be your crew, Soggy. Ship or no ship. We\'d follow you anywhere.\"','',26124),
(63787,'enUS','\"Sincerely, all of us. Even Dog.\"','',26124),
(63788,'enUS','Wow...','',26124),
(63789,'enUS','Would you excuse me for a moment, $p? I\'ve, uh... I\'ve got somethin\' in both my eyes.','',26124),
(63790,'enUS','Commander, we\'re picking up an Alliance distress signal ahead.','Commander, we\'re picking up an Alliance distress signal ahead.',26124),
(63791,'enUS','Pull up!','Pull up!',26124),
(63792,'enUS','They\'re firing on us, sir!','They\'re firing on us, sir!',26124),
(63793,'enUS','Ugh! We\'ve been hit!','Ugh! We\'ve been hit!',26124),
(63794,'enUS','Our systems are jammed, Commander! I can\'t control this plane!','Our systems are jammed, Commander! I can\'t control this plane!',26124),
(63795,'enUS','What? Is that....LAND?','What? Is that....LAND?',26124),
(63796,'enUS','','That\'ll teach those virmen to try and eat me!',26124),
(63797,'enUS','','I need to get this grain to Brewmaster Boof so we can start the festival. See you there, $p!',26124),
(63798,'enUS','Call me crazy, but I love this warm weather!  I always felt like an outcast back in Borean but I think this new climate is going to work out great for me!','Call me crazy, but I love this warm weather!  I always felt like an outcast back in Borean but I think this new climate is going to work out great for me!',26124),
(63799,'enUS','What are you doing so far from home?','What are you doing so far from home?',26124),
(63800,'enUS','Well, times were getting tough up north.  While the scourge problem has been dealt with, we are constantly on the move and looking for food.  I decided it was time to head out and find some new fishing grounds!$b$bAfter almost a month at sea, I ended up here.  Good thing I packed a few crates of pickled herring for the trip!','Well, times were getting tough up north.  While the scourge problem has been dealt with, we are constantly on the move and looking for food.  I decided it was time to head out and find some new fishing grounds!$b$bAfter almost a month at sea, I ended up here.  Good thing I packed a few crates of pickled herring for the trip!',26124),
(63801,'enUS','I have studied for years to master the art of the chi blast and would be honored to fight by your side. Would you like my assistance?','',26124),
(63802,'enUS','The honor is mine, to your post!','The honor is mine, to your post!',26124),
(63803,'enUS','No thanks...','No thanks...',26124),
(63804,'enUS','You have been selected by the |cFFFF4809|Hspell:116784|h[Heart of Fear]|h|r !','You have been selected by the |cFFFF4809|Hspell:116784|h[Heart of Fear]|h|r !',26124),
(63805,'enUS','The amber congeals to form an |cFFFF0404|Hspell:125803|h[Amber Trap]|h|r !','The amber congeals to form an |cFFFF0404|Hspell:125803|h[Amber Trap]|h|r !',26124),
(63806,'enUS','<Dog looks at you quizzically.>','',26124),
(63807,'enUS','ZzzZZzzzz','ZzzZZzzzz',26124),
(63808,'enUS','WAKE UP! We have to defend the village, get to your mortar and help us!','WAKE UP! We have to defend the village, get to your mortar and help us!',26124),
(63809,'enUS','They don\'t look very helpful, we should let them sleep.','They don\'t look very helpful, we should let them sleep.',26124),
(63810,'enUS','%s swims excitedly through the vents of warm water.','',26124),
(63811,'enUS','%s rubs against the prow of the Mist-Hopper and whimpers.','',26124),
(63812,'enUS','%s looks around cautiously before leaving his mark on the whale corpse.','',26124),
(63813,'enUS','','There are four August Celestials who rule over this land.$B$BYu\'lon the Jade Serpent, lifegiver of the east.$B$BChi-Ji the Red Crane, hope of the south.$B$BXuen the White Tiger, whose strength upholds the north.$B$BAnd Niuzao the Black Ox, who stands tall in the west.$B$BRecently, with the advent of the sha, turmoil has engulfed each of their temples. They need our help, $r.',26124),
(63814,'enUS','The Shado-Pan hold the eternal vigil, keeping watch over the dark sha energies that were sealed away into the earth long ago.$B$BUnfortunately, the sha have escaped their prisons, and now we must defeat them once again.','',26124),
(63815,'enUS','Beautiful day for fishing, don\'t you think?  You a fisherman, $n?  I\'ve got this old fishing lure if you\'d like it, works wonders in the waters here.','',26124),
(63816,'enUS','I\'d love it, thank you.','I\'d love it, thank you.',26124),
(63817,'enUS','The Golden Lotus is charged with defending the Vale of Eternal Blossoms.$B$BIf you wish to help us, defeat enemies of the Golden Lotus who currently occupy the Vale.$B$BYou may also speak to Anji Autumnlight at the Setting Sun Garrison training camp for further tasks.','',26124),
(63818,'enUS','The fish are biting like crazy down in Krasarang!$B$BI\'d still be out on the sea, reeling in the big one, but I came here to sell this morning\'s catch. Got lots of hungry mouths to feed here!','',26124),
(63819,'enUS','You ever been to the Valley of the Four Winds?$B$BWe farmhands hear about the crisis here in the Vale, and the Tillers are hard at work growing food for refugees.$B$BIf you want some time out in the country, visit us at Halfhill!','',26124),
(63820,'enUS','Hey there. I don\'t think you want to go down that tunnel on foot. The saurok are out in force today and they are mighty territorial.','',26124),
(63821,'enUS','The spark of life fades.','',26124),
(63822,'enUS','What was is no longer.','',26124),
(63823,'enUS','Countermeasures successful.','',26124),
(63824,'enUS','Approach! Feel the power of the titans!','',26124),
(63825,'enUS','Drawing from reserve power.','',26124),
(63826,'enUS','Yaungol!? Now!?','',26124),
(63827,'enUS','Let the energies consume you!','',26124),
(63828,'enUS','Conduits offline.','',26124),
(63829,'enUS','They must be after the Kun-Lai Kicker! $p, investigate these sightings and setup the village defenses! They won\'t get my brew without a fight!','',26124),
(63830,'enUS','I\'ll defend the brew until it\'s ready. Then we can use it against these Bataari raiders! Everyone else, get to safety!','',26124),
(63831,'enUS','Energy Vortex ramping down.','',26124),
(63832,'enUS','Redirecting power.','',26124),
(63833,'enUS','Energy Conduits active, draw stable.','',26124),
(63834,'enUS','Hei Feng prepares to land!','',26124),
(63835,'enUS','Existence ends... I become nothing...','',26124),
(63836,'enUS','','Since the dark days of the old kingdom, we pandaren have turned to the mystical art of brewing to keep our spirits and strength high.$B$BEven as we speak, brewmasters wander the world, seeking rare and powerful ingredients to craft the finest of brews.$B$BThose who seek out these elusive brewmasters and lend them aid may earn flavorful items. At the very least, you will drink plenty of brew!',26124),
(63837,'enUS','I got this from some goblin, he said it can stop anything in their tracks, want to give it a try?','I got this from some goblin, he said it can stop anything in their tracks, want to give it a try?',26124),
(63838,'enUS','Sure! I\'ll give it a whirl.','Sure! I\'ll give it a whirl.',26124),
(63839,'enUS','Not a chance, you can keep that Mr. Derpa.','Not a chance, you can keep that Mr. Derpa.',26124),
(63840,'enUS','I\'m... alive?  Thank you... thank you so much!','I\'m... alive?  Thank you... thank you so much!',26124),
(63841,'enUS','The Shado-Pan hold the eternal vigil, keeping watch over the dark sha energies that were sealed away into the earth long ago.$B$BUnfortunately, the sha have escaped their prisons, and now we must defeat them once again.','',26124),
(63842,'enUS','','The Golden Lotus is charged with defending the Vale of Eternal Blossoms.$B$BIf you wish to help us, defeat enemies of the Golden Lotus who currently occupy the Vale.$B$BYou may also speak to Anji Autumnlight at the Setting Sun Garrison training camp for further tasks.',26124),
(63843,'enUS','There are four August Celestials who rule over this land.$B$BYu\'lon the Jade Serpent, lifegiver of the east.$B$BChi-Ji the Red Crane, hope of the south.$B$BXuen the White Tiger, whose strength upholds the north.$B$BAnd Niuzao the Black Ox, who stands tall in the west.$B$BRecently, with the advent of the sha, turmoil has engulfed each of their temples. They need our help, $r.','',26124),
(63844,'enUS','','Tell me, $r, have you ever had a hankering to fish?$B$BIf so, you might want to visit the Anglers down in the Krasarang Wilds.',26124),
(63845,'enUS','I am a member of the Tillers, the hardworking farmers of Pandaria. If you wish to learn more about us, we are located at Halfhill in the Valley of the Four Winds.','',26124),
(63846,'enUS','Since the dark days of the old kingdom, we pandaren have turned to the mystical art of brewing to keep our spirits and strength high.$B$BEven as we speak, brewmasters wander the world, seeking rare and powerful ingredients to craft the finest of brews.$B$BThose who seek out these elusive brewmasters and lend them aid may earn flavorful items. At the very least, you will drink plenty of brew!','',26124),
(63847,'enUS','Hopefully this time we won\'t run into any hiccups.','',26124),
(63848,'enUS','Ever been to Kun-Lai before? It\'s great. Long flowing farmlands. Beautiful mountains. And absolutely nothing dangerous whatsoever.','',26124),
(63849,'enUS','Well... yes. There are problems with the hozen.','',26124),
(63850,'enUS','The spears are just for show. As long as we don\'t get out of the boat or make eye contact or get hit by a spear then we should be fine.','',26124),
(63851,'enUS','It\'s safe. I brought Lorewalker Cho and his strange companions up this way not long back.','',26124),
(63852,'enUS','You had that coming. Waving your incense about in his face... wait a minute. Something doesn\'t feel right about this.','',26124),
(63853,'enUS','Are those refugees? What\'s going on over there? Do I hear fighting?','',26124),
(63854,'enUS','These people are farmers, not fighters! They may need our help!','',26124),
(63855,'enUS','Yes, and the tigers.','',26124),
(63856,'enUS','Hozen attack grummles.','',26124),
(63857,'enUS','Tigers.','',26124),
(63858,'enUS','Saurok are very dangerous.','',26124),
(63859,'enUS','Lots of saurok live in the Ancient Passage.','',26124),
(63860,'enUS','The \"orc\" tried to punch me.','',26124),
(63861,'enUS','I can\'t find my shield, I\'ve looked all over the village! I wish I could help, but without my shield I\'m good for nothing!','I can\'t find my shield, I\'ve looked all over the village! I wish I could help, but without my shield I\'m good for nothing!',26124),
(63862,'enUS','... Your shield is on your back.  Now get up and HELP US!','... Your shield is on your back.  Now get up and HELP US!',26124),
(63863,'enUS','Sorry I haven\'t seen it either.  Maybe it\'s for the best...','Sorry I haven\'t seen it either.  Maybe it\'s for the best...',26124),
(63864,'enUS','HAH! You found it! Now time to fight back those yaungol.','HAH! You found it! Now time to fight back those yaungol.',26124),
(63865,'enUS','Well that\'s embarrassing. To battle!','Well that\'s embarrassing. To battle!',26124),
(63866,'enUS','What an unlikely spot for my shield to be, irregardless, now we fight!','What an unlikely spot for my shield to be, irregardless, now we fight!',26124),
(63867,'enUS','The Veiled Stair is under Madam Goya\'s protection.','The Veiled Stair is under Madam Goya\'s protection.',26124),
(63868,'enUS','There is much and more that can be found at the Tavern in the Mists.','There is much and more that can be found at the Tavern in the Mists.',26124),
(63869,'enUS','The Tavern serves to those who do not ask too many questions.','The Tavern serves to those who do not ask too many questions.',26124),
(63870,'enUS','Hei Feng takes a Deep Breath! Move behind him!','',26124),
(63871,'enUS','Welcome, $p. We have been watching you for some time.$b$bYou are the gust of wind that heralds the storm of change.','',26124),
(63872,'enUS','Word reaches me you served with my brother in Townlong Steppes. How is the young fellow? Did he ever tell you how he lost his eye?','',26124),
(63873,'enUS','Welcome, $p. We have been watching your accomplishments since your arrival in our land.','Welcome, $p. We have been watching your accomplishments since your arrival in our land.',26124),
(63874,'enUS','The saurok make it difficult for anyone to visit here other than by flying.$b$bOf course, that makes slipping off to the Tavern in the Mists very difficult.','The saurok make it difficult for anyone to visit here other than by flying.$b$bOf course, that makes slipping off to the Tavern in the Mists very difficult.',26124),
(63875,'enUS','Be careful around my hawk. She\'s a biter.','Be careful around my hawk. She\'s a biter.',26124),
(63876,'enUS','The mountain roads can be a dangerous place.','The mountain roads can be a dangerous place.',26124),
(63877,'enUS','Never ask Hawkmaster Norung about his eye patch. You will never hear the end of it.','Never ask Hawkmaster Norung about his eye patch. You will never hear the end of it.',26124),
(63878,'enUS','We will have to work quickly Wakener. This area is not safe.','',26124),
(63879,'enUS','Your mind is strong Wakener. Even now I struggle to communicate with you. Controlling you would be near impossible...','',26124),
(63880,'enUS','Your thoughts intrigue me. There is purpose to your actions. Your complexity is impressive.','',26124),
(63881,'enUS','Your intelligence will come in handy almost as much as your skill for battle. I see much potential in a mind like yours Wakener.','',26124),
(63882,'enUS','We\'re here. With this weapon we will lay waste to the Empresses\' army!','',26124),
(63883,'enUS','I\'m pretty handy with nets, I could trap those nasty yaungol in them.','',26124),
(63884,'enUS','Alright then, lets go tie them up!','Alright then, lets go tie them up!',26124),
(63885,'enUS','That\'s okay, you hang onto those nets.','That\'s okay, you hang onto those nets.',26124),
(63886,'enUS','Hei Feng is landing!','',26124),
(63887,'enUS','I\'ve mastered catching fish, now on to catching yaungol!','',26124),
(63888,'enUS','Me and my trusty nets will not fail this village!','',26124),
(63889,'enUS','Welcome to the Seat of Knowledge. And never was there a greater repository of information and wisdom to be found about the ancient days of Pandaria.','',26124),
(63890,'enUS','','You must be $n.$b$bI\'ve been expecting you.',26124),
(63891,'enUS','I could use a kite to Grookin\' Hill.','I could use a kite to Grookin\' Hill.',26124),
(63892,'enUS','So be it. I shall do this myself!','',26124),
(63893,'enUS','I am one with the mists and heal those in need.','I am one with the mists and heal those in need.',26124),
(63894,'enUS','We require your aid.','We require your aid.',26124),
(63895,'enUS','We don\'t need your healing skills.','We don\'t need your healing skills.',26124),
(63896,'enUS','Thank you, $p. You have saved us all.','',26124),
(63897,'enUS','We have what we need from the meddlesome Loremaster.','',26124),
(63898,'enUS','Remember, it is at the darkest moment that light shines the brightest.','',26124),
(63899,'enUS','Well done, heroes.','',26124),
(63900,'enUS','Intruders have breached the temple!','',26124),
(63901,'enUS','WEAKLING LIZARD! Your hide will adorn the Thunder King\'s throne!','',26124),
(63902,'enUS','TUNG! I\'ll feed your corpse to your useless beasts!','',26124),
(63903,'enUS','Worthless wizard! How DARE you fail the Thunder King!','',26124),
(63904,'enUS','CAPTAIN RO-GU?! Impossible! To think that you would falter now...','',26124),
(63905,'enUS','I, General Zhun, Herald of the glorious Thunder King Lei Shen, hereby challenge you!','',26124),
(63906,'enUS','Ro-Gu, Tung, Fon, Hithiss: Guard the artifacts... with your LIVES!','',26124),
(63907,'enUS','I always knew I was a lumberjack at heart!','I always knew I was a lumberjack at heart!',26124),
(63908,'enUS','You seem like a craftsman, $pc.  Do you think you can cut it as a woodcrafter?  If so, I have something that may help you.','',26124),
(63909,'enUS','I could use a kite to Pearlfin Village.','I could use a kite to Pearlfin Village.',26124),
(63910,'enUS','Hello again, $n.  How\'s my lure treating you?','',26124),
(63911,'enUS','Hello again, $n.  How is my axe treating you?','',26124),
(63912,'enUS','Until we meet again, $n.','',26124),
(63913,'enUS','My eternal gratitude; I had thought myself doomed.','',26124),
(63914,'enUS','','There are so many great stories to uncover. So much history. Isn\'t it fascinating?',26124),
(63915,'enUS','Juro: EXECUTE HIM!','',26124),
(63916,'enUS','My thanks! None of us expected to survive... I will aid you as best as I can!','',26124),
(63917,'enUS','They\'ve already dragged off and murdered the others. I\'m sorry... I\'m too weak to continue...','',26124),
(63918,'enUS','Thank you! Please, save... Lorewalker Fu if you can... I... have failed...','',26124),
(63919,'enUS','We have entered a dangerous place my luckydo. In this the saurok have grown very angry and attack all boats that pass through. We must be on our guard.','',26124),
(63920,'enUS','General Zhun intends to deliver Kotmogu Temple\'s ancient artifacts to his wicked liege, the Thunder King. We cannot allow this to happen!','',26124),
(63921,'enUS','Please, you MUST keep them out of the general\'s hands! I will return to the Vale of Eternal Blossoms and report to the Golden Lotus. Again, many thanks!','',26124),
(63922,'enUS','<Mishi looks expectantly at you.>','',26124),
(63923,'enUS','Today, we welcome you into the Shado-Pan.','',26124),
(63924,'enUS','Your perseverance strengthens us. Your courage leads us. Your honor inspires us.','',26124),
(63925,'enUS','From this day forth, you walk as one of our brotherhood.','',26124),
(63926,'enUS','Welcome $p, as a member of the Shado-Pan!','',26124),
(63927,'enUS','I will not fail you, or this village.','I will not fail you, or this village.',26124),
(63928,'enUS','I\'m supposed to guard the well. It\'s an important job!','',26124),
(63929,'enUS','My friends say I\'m a little slow, but I run faster than all of them!','',26124),
(63930,'enUS','The well is very important. It\'s good that they asked me to watch it.','',26124),
(63931,'enUS','\"Koa,\" they said, \"Go guard the well.\" That\'s what they said.','',26124),
(63932,'enUS','Why is everyone so afraid? I won\'t let those trolls get to our well! I\'m a good guard!','',26124),
(63933,'enUS','Hi! I\'m Koa! Will you be my friend?','',26124),
(63934,'enUS','I can allow you to bring life, from death.','',26124),
(63935,'enUS','I like the sound of that.','I like the sound of that.',26124),
(63936,'enUS','I prefer not to meddle with death.','I prefer not to meddle with death.',26124),
(63937,'enUS','We\'re all going to die!','Why are they attacking us?!',26124),
(63938,'enUS','How will we survive?!','Who will save us?!',26124),
(63939,'enUS','Sumthin Happenin Here. The exact nature of it lacks clarity.','Sumthin Happenin Here. The exact nature of it lacks clarity.',26124),
(63940,'enUS','This helmet is like magic, you want to give it a try? We have extras!','This helmet is like magic, you want to give it a try? We have extras!',26124),
(63941,'enUS','Ab-so-lutely!','Ab-so-lutely!',26124),
(63942,'enUS','No thanks, I need to stay sharp for the invasion.','No thanks, I need to stay sharp for the invasion.',26124),
(63943,'enUS','This is usually a calm stop. Now look at it. Where did all of these yaungol come from?','',26124),
(63944,'enUS','If you head northwest, look for the Grummle Bazaar. Many good trinkets and luckydos for sell there. Good fortune to be found for those who seek it.','',26124),
(63945,'enUS','A Bataari War Yeti approaches from the Ancient Passage!','',26124),
(63946,'enUS','A Bataari War Yeti approaches from the Bridge!','',26124),
(63947,'enUS','A Bataari War Yeti approaches from the west!','',26124),
(63948,'enUS','Got some rye?','',26124),
(63949,'enUS','Shine and rise.','',26124),
(63950,'enUS','I love the Brewmoon Festival, I look forward to it every year.','I love the Brewmoon Festival, I look forward to it every year.',26124),
(63951,'enUS','Yak. Yak never changes.','',26124),
(63952,'enUS','Your yak is in another stable.','',26124),
(63953,'enUS','Is it dangerous to go alone?','',26124),
(63954,'enUS','Would you kindly show me the way back to Kunlai?','',26124),
(63955,'enUS','Maybe you could roll a barrel.','',26124),
(63956,'enUS','You could die of dysentery out here.','',26124),
(63957,'enUS','I\'m just a pathetic creature of meat and brew.','',26124),
(63958,'enUS','A beautiful day, a beautiful Brew, and a beautiful fish, what more could you ask for?','',26124),
(63959,'enUS','Put more stuff in the thing more stuff goes in.','',26124),
(63960,'enUS','I don\'t often interact with the Pandaren, but when I do... Its for Brew!','',26124),
(63961,'enUS','Shame to sit on something so pretty.','',26124),
(63962,'enUS','I\'ve won the Brew Toss competition six years running! I am the strongest in all of Pandaria.','I\'ve won the Brew Toss competition six years running! I am the strongest in all of Pandaria.',26124),
(63963,'enUS','Is this what a dream feels like?','',26124),
(63964,'enUS','I find the Brewmoon Festival an excellent break from my studies.','',26124),
(63965,'enUS','Ten years. I have faithfully brushed yak for ten years.','',26124),
(63966,'enUS','Two theories when arguing with yak. Neither one works.','',26124),
(63967,'enUS','I just came here to find some turnips, I swear!','',26124),
(63968,'enUS','','It\'s good to see the world outside the monastery.',26124),
(63969,'enUS','I was going to have a party and invite Mystic Birdhat, but you dismissed him.','',26124),
(63970,'enUS','I think yak has started to move.','',26124),
(63971,'enUS','Those yaungol have straight swords. Straight. Swords.','',26124),
(63972,'enUS','Oh woe. Low. Low.','',26124),
(63973,'enUS','I am yak rider. And this is my yak.','',26124),
(63974,'enUS','There is nothing in all Pandaria that can stay the rampage of the Grand Expedition Yak. Pray you never see it.','',26124),
(63975,'enUS','It is not my intention to initiate legislation against you.','',26124),
(63976,'enUS','Does yak tail assist in maintaining balance?','',26124),
(63977,'enUS','I will roll, roll through the gates of Mogu\'shan.','',26124),
(63978,'enUS','A minute is all I need. Wait, that came out all wrong.','',26124),
(63979,'enUS','Only the best brew for Derpa Derpa.','Only the best brew for Derpa Derpa.',26124),
(63980,'enUS','I lost my shield in my travels, all I wanted was a Brew, now all I want is my shield back!','I lost my shield in my travels, all I wanted was a Brew, now all I want is my shield back!',26124),
(63981,'enUS','You keep pointing me in the right direction and I\'ll keep tossing these kegs!','You keep pointing me in the right direction and I\'ll keep tossing these kegs!',26124),
(63982,'enUS','How may I help you today?','How may I help you today?',26124),
(63983,'enUS','I need supplies for cooking lessons.','I need supplies for cooking lessons.',26124),
(63984,'enUS','Hello, friend. Hungry?','Hello, friend. Hungry?',26124),
(63985,'enUS','The sherpen has clearly been frozen here for some time, but you see a glint of light from something in his pack.','',26124),
(63986,'enUS','Take the item from his pack.','Take the item from his pack.',26124),
(63987,'enUS','I\'ll update my journal.','',26124),
(63988,'enUS','I feel like a blood sausage.','',26124),
(63989,'enUS','I feel like I lost an eighth of something.','',26124),
(63990,'enUS','Bow Hit!','Bow Hit!',26124),
(63991,'enUS','I\'m burning your village down [PH].','',26124),
(63992,'enUS','','',26124),
(63993,'enUS','','We knew you could do it!',26124),
(63994,'enUS','Good job. Guess you learned a little something from me.','',26124),
(63995,'enUS','','Let\'s go for a drink!',26124),
(63996,'enUS','This poor sherpen has been frozen here for a while.','',26124),
(63997,'enUS','Drinks!','Drinks!',26124),
(63998,'enUS','Let\'s do this, Mishi!','Let\'s do this, Mishi!',26124),
(63999,'enUS','You will bleed!','',26124),
(64000,'enUS','What shiny weapons. Give them to me!','',26124),
(64001,'enUS','Face me, warm blood!','',26124),
(64002,'enUS','Yessssss... a challenge.','',26124),
(64003,'enUS','We are stronger now! You will die!','',26124),
(64005,'enUS','We are masters of the Stair now!','',26124),
(64006,'enUS','I am going to eat your head!','',26124),
(64007,'enUS','No place for warm bloods on our Stair!','',26124),
(64008,'enUS','','I don\'t think so.',26124),
(64009,'enUS','You will not defeat us.','',26124),
(64010,'enUS','I was sent to sabotage the Sik\'thik bridge reconstruction, but you\'ve fought your way through them like a true $c. You have an opportunity to eliminate their leader!','',26124),
(64011,'enUS','And who are you to stop us?','',26124),
(64012,'enUS','Perhaps... we attacked... too soon.','',26124),
(64013,'enUS','Send me back in Tenwu!','Send me back in Tenwu!',26124),
(64014,'enUS','Port Side Hit!','Port Side Hit!',26124),
(64015,'enUS','Starboard Side Hit!','Starboard Side Hit!',26124),
(64016,'enUS','The Veiled Stair will soon be ours again!','',26124),
(64017,'enUS','The sha has made the pandaren weak! Now is the time to push them from the Veiled Stair forever!','',26124),
(64018,'enUS','These travellers are ripe for the robbing! Take their things! Take all of their things!!!','',26124),
(64019,'enUS','Steal everything! Ssteal all of their thingsss!','',26124),
(64020,'enUS','I am the \"retrieval expert\" for her ladyship, Madam Goya. It is her will that guides the ebb and flow of travel on this road.$b$bIt is my role to ensure certain less scrupulous types do not take advantage of her ladyship\'s hospitality.','',26124),
(64021,'enUS','Be on your guard. The Unga Ingoo Pirates are a fearsome lot. But they make a fine brew!','',26124),
(64022,'enUS','We need more brew. A good place to look might be the pirate ship to the southwest.','',26124),
(64023,'enUS','We need more brew. You should search the island to the northwest. I think I saw a beach party over there.','',26124),
(64024,'enUS','We need more brew. The cave west of here along the beach might have some stashed there.','',26124),
(64025,'enUS','We need more brew. I think I saw brew guzzling hozen on the mountain peak to the southeast.','',26124),
(64026,'enUS','Who would leave a pile of bombs and a cannon next to their brew? Ah well. One hozen\'s trash is a brewmaster\'s beach defense.','',26124),
(64027,'enUS','Oh no! Captain Ook? I thought he was only a legend.','',26124),
(64028,'enUS','It looks like the hozen scattered their brew in mugs and kegs across the island.','',26124),
(64029,'enUS','They are coming in from the ocean! Use the cannon!','',26124),
(64030,'enUS','The hozen are stealing our brew!','',26124),
(64031,'enUS','The... dookers... took my brew...','',26124),
(64032,'enUS','Stern Hit!','Stern Hit!',26124),
(64033,'enUS','You can take our lives... but you\'ll... never... take... our brew...','',26124),
(64034,'enUS','Wikkets... gonna... pay.','',26124),
(64035,'enUS','I die doin\' what I love!','',26124),
(64036,'enUS','Wikkets... out-bammed... Ba-Bam...','',26124),
(64037,'enUS','The mantid are under MY command, fools. See how she succumbs to me.','',26124),
(64038,'enUS','What is that?!','',26124),
(64039,'enUS','Just keep tossing! I think they are starting to run away.','',26124),
(64040,'enUS','WHAT?! What will come out no more?!','',26124),
(64041,'enUS','Quick! Grab a keg and start tossing like your life depended on it!','',26124),
(64042,'enUS','You will come out no more!','',26124),
(64043,'enUS','Watch out!','',26124),
(64044,'enUS','Sauroken sorcery.','',26124),
(64045,'enUS','Most bad fortune.','',26124),
(64046,'enUS','A luckydo would be wise to throw kegs about now.','',26124),
(64047,'enUS','It is bad fortune to travel in boat without exploding barrels aboard.','',26124),
(64048,'enUS','Darkhatched saurok are very dangerous, and very powerful.','',26124),
(64049,'enUS','Back off! Dip-slithers!','',26124),
(64050,'enUS','Hah! Didn\'t see that coming now did you, Lizard Lips!','',26124),
(64051,'enUS','Take that, Dip-slithers!','',26124),
(64052,'enUS','Ah! Saurok on-board! Saurok on-board!','',26124),
(64053,'enUS','','$p, let me know if you need any help with the village defenses!',26124),
(64054,'enUS','','We have a lot of visitors from all over Pandaria, surely they can help us with these raiders.',26124),
(64055,'enUS','Tell me about the Krasarang Wild Brew.','Tell me about the Krasarang Wild Brew.',26124),
(64056,'enUS','Tell me about Briaw Shan.','Tell me about Briaw Shan.',26124),
(64057,'enUS','Tell me about the festival fireworks.','Tell me about the festival fireworks.',26124),
(64058,'enUS','Tell me about the Tian disciples.','Tell me about the Tian disciples.',26124),
(64059,'enUS','Tell me about the damaged cannons.','Tell me about the damaged cannons.',26124),
(64060,'enUS','Tell me about the Vale marksmen.','Tell me about the Vale marksmen.',26124),
(64061,'enUS','Tell me about the Tian mistweavers.','Tell me about the Tian mistweavers.',26124),
(64062,'enUS','Tell me about the jovial villagers.','Tell me about the jovial villagers.',26124),
(64063,'enUS','Tell me about Cianz.','Tell me about Cianz.',26124),
(64064,'enUS','Tell me about the Xuen shield bearers.','Tell me about the Xuen shield bearers.',26124),
(64065,'enUS','Tell me about Derpa Derpa.','Tell me about Derpa Derpa.',26124),
(64066,'enUS','Tell me about the Binan fishermen.','Tell me about the Binan fishermen.',26124),
(64067,'enUS','','The Krasarang Wild Brew is extremely volatile, $n! We could set the barrels near where the yaungol will approach and then blow them up. Grab one and I\'ll put a marker where we should place them.',26124),
(64068,'enUS','','Briaw Shan is a champion brew tosser, $n. He could toss a barrel into the air and then have it come crashing down on these yaungol! I saw him over by the inn earlier today. Go see if he can help!',26124),
(64069,'enUS','','We have barrels of fireworks all over the town for the festival celebrations, $n. Place a few of them in the right locations and give them a good wack and they would cause all kinds of destruction. Grab a barrel and I\'ll mark the locations we should place them.',26124),
(64070,'enUS','','There are Tian disciples in town celebrating the Brewmoon, $n! Surely they could use their training to help us. Talk to them and see if they can stop these yaungol!',26124),
(64071,'enUS','','There are some damaged cannons inside the storehouses and behind the inn, $n. If you could repair them, the villagers could use them to blast the yaungol!',26124),
(64072,'enUS','','There are some Vale marksmen in town that stopped to rest for the night, $n. They have defended the Gate of the Setting Sun against the mantid for many years with their mortars. See if you can wake them up!',26124),
(64073,'enUS','','There are Tian mistweavers here from the Tian monastery, $n. Their skills with mistweaving would allow us to fight even longer! Ask them to aid us in this fight.',26124),
(64074,'enUS','','There are some jovial villagers in town that claim they created a helmet that makes them better at everything. While I\'m skeptical, having a helmet on couldn\'t hurt, right? Talk to them and see if they\'ll lend you one.',26124),
(64075,'enUS','','Cianz comes to bless our festival each year, $n. He will not fight in battle but maybe there is something he can do to help us. Ask if there is anything he can do.',26124),
(64076,'enUS','','The Xuen shield bearers come down from the Temple of the White Tiger each year, $n. They could block the yaungol advance and prevent them from getting into the village. Talk to them and see if they can aid us.',26124),
(64077,'enUS','','Derpa Derpa wanders into town every now and then and tries to sell us strange gadgets that he\'s found rummaging around Kun-Lai Summit. Talk to him and see if he has anything that we could use as a weapon.',26124),
(64078,'enUS','','The Binan fishermen could catch a greased hozen in their nets while blindfolded, $n. Surely they could snare a few yaungol for us. Talk to them about helping us defend the village!',26124),
(64079,'enUS','Are there any other defenses?','Are there any other defenses?',26124),
(64080,'enUS','The Kun-Lai Kicker is finished, $n! Are you ready for the best brew in all of Pandaria? I\'ll warn you now, after drinking this brew you may want to kick things. Which is good because we have a lot of yaungol that need a good kicking!','',26124),
(64081,'enUS','Give me some quick! Before the yaungol get it all!','Give me some quick! Before the yaungol get it all!',26124),
(64082,'enUS','The Kun-Lai Kicker is finished, $p! Now we can use it to kick some yaungol butt!','',26124),
(64083,'enUS','Go and see Brewmaster Boof for some Kun-Lai Kicker!','',26124),
(64084,'enUS','You will pay for this disturbance!','',26124),
(64085,'enUS','How dare you set foot in the valley!','',26124),
(64086,'enUS','You will regret this intrusion!','',26124),
(64087,'enUS','Your death will be neither swift nor painless!','',26124),
(64088,'enUS','Your kind should not be allowed in the valley!','',26124),
(64089,'enUS','You are not welcome here!','',26124),
(64090,'enUS','You will be the first of many to die!','',26124),
(64091,'enUS','Your life will be a fitting sacrifice to our emperor!','',26124),
(64092,'enUS','We will rebuild our empire on the corpses of our enemies!','',26124),
(64093,'enUS','You will serve, or you will die!','',26124),
(64094,'enUS','Your weakness offends!','',26124),
(64095,'enUS','My death will not save you from what is coming...','',26124),
(64096,'enUS','Your victory will be short lived...','',26124),
(64097,'enUS','When two great empires reunite, the world will crumble around them...','',26124),
(64098,'enUS','You are too late...','',26124),
(64099,'enUS','My death has gained you nothing!','',26124),
(64100,'enUS','What will the sea bring us today?','',26124),
(64101,'enUS','Creepy, aren\'t they? Never seen \'em before, but I\'ve been pulling \'em in all day.','',26124),
(64102,'enUS','You will not take dis land from us!','You will not take dis land from us!',26124),
(64103,'enUS','You be interferin\' with de wrong empire!','You be interferin\' with de wrong empire!',26124),
(64104,'enUS','Da Zandalari were meant to have this land!','Da Zandalari were meant to have this land!',26124),
(64105,'enUS','Our empires will take what is ours!','Our empires will take what is ours!',26124),
(64106,'enUS','|TInterface\\Icons\\spell_fire_volcano.blp:20|t%s begins to cast |cFFFF0000|Hspell:125391|h[Fire Lines]|h|r!','',26124),
(64107,'enUS','An Amber Growth seeps into %s\'s wounds, replenishing its vitality.','',26124),
(64108,'enUS','%s collapses in a heap and expires suddenly.','',26124),
(64109,'enUS','The statue appears to be holding something...','',26124),
(64110,'enUS','Take the item from his hand.','Take the item from his hand.',26124),
(64111,'enUS','No more excuses, Empress! Eliminate these cretins or I will kill you myself!','',26124),
(64112,'enUS','Warbring Qobi dropped his axes. Grab one!','',26124),
(64113,'enUS','|TInterface\\Icons\\inv_misc_dust.blp:20|t%s begins to |cFFFF0000|Hspell:124359|h[Burrow]|h|r!','',26124),
(64114,'enUS','WHEEEEEEE!','',26124),
(64115,'enUS','I\'d like to heal and revive my battle pets.','I\'d like to heal and revive my battle pets.',26124),
(64116,'enUS','What do you think of my pet?','What do you think of my pet?',26124),
(64117,'enUS','I have a task for you.','I have a task for you.',26124),
(64118,'enUS','You barbarians will think twice before attacking our village again!','',26124),
(64119,'enUS','','You WILL tell us where the remains have been hidden!',26124),
(64120,'enUS','Pick any of these fabulous rods and CAREFULLY tug the line. That should help set the hook into whatever\'s flailin\' around at the other end.','',26124),
(64121,'enUS','Well that\'s unusual...Take care of it, then tug another line when you can.','',26124),
(64122,'enUS','Grrr... whatever I\'ve got here is big. Keep up the good work on those lines while I land this baby!','',26124),
(64123,'enUS','What... in... Mazu\'s... name... HRRGHHH!!','',26124),
(64124,'enUS','The dream brew that you sampled earlier can expand your consciousness and show you events transpiring around the land. I will teach you how to use it properly, and we will find your prince!$b$bBut first, help me to create a fresh batch.','',26124),
(64125,'enUS','Deck Boss said you needed some help.','Deck Boss said you needed some help.',26124),
(64126,'enUS','A good dream brew is VERY powerful. It will require a focused mind to gain any kind of clarity from the visions!','',26124),
(64127,'enUS','Now, you must STAY CENTERED. You can focus or relax, but above all else, remain in the center.','',26124),
(64128,'enUS','Ah, good, I see you are not easily distracted. We Pandaren are extremely focused on the moment, sometimes to our detriment.','',26124),
(64129,'enUS','I\'m so sorry, that did not alarm you did it, hmm? We Pandaren value calm under any circumstance.','',26124),
(64130,'enUS','How about ... THIS?','',26124),
(64131,'enUS','Look at you! The picture of serenity. I knew I liked you.','',26124),
(64132,'enUS','Mung-Mung in big, stinky dook without you! Mung-Mung is in your debt. Maybe you and Yoon aren\'t such jibnibbers after all.','',26124),
(64133,'enUS','You know what? I\'m going to show them that I can also become a master farmer!$B$BI\'m going to turn this farm into one of the most prosperous in the Valley!$B$BIt\'s too much work for one pandaren, though. Whaddaya say? Want to help me?','',26124),
(64134,'enUS','What are you going to do, Farmer Yoon?','What are you going to do, Farmer Yoon?',26124),
(64135,'enUS','It was mighty kind of you to help me, $r. I\'m in your debt.','',26124),
(64136,'enUS','Hey shtranger... you got some coin for a thirsty traveler?','',26124),
(64137,'enUS','Buy a fish a drink?','',26124),
(64138,'enUS','What brings you to my well today, $Gbrother:sister;?','',26124),
(64139,'enUS','The watersh tell of good fortune today, $n.','',26124),
(64140,'enUS','Hey buddy, got shome coin to shpare a poor jinyu?','',26124),
(64141,'enUS','I\'m awful thirsty, buddy.','',26124),
(64142,'enUS','Friend of jinyu, come sit with me a while.','',26124),
(64143,'enUS','Hey friend, care to sit with me and share a drink?','',26124),
(64144,'enUS','Hey, it\'s my good friend, $n. I\'m feeling more lucid today. Maybe because I\'ve cut back a little on the sauce.','',26124),
(64145,'enUS','You know, I\'ve decided I like having you as a friend. Makes me think that maybe I can have other friends, too.','',26124),
(64146,'enUS','Negative emotions, like anger or doubt, they take on a strange power here on Pandaria. But this you will discover in time.','',26124),
(64147,'enUS','','I really owe you one, so I\'ll tell ya what. I\'ll talk to my father about letting you guys join the Tillers Union.',26124),
(64148,'enUS','There - do you feel it? A perfect stillness of the soul! Feel the dream brew take effect.','',26124),
(64149,'enUS','Uh-oh! You stirred up some angry crabs!','Uh-oh! You stirred up some angry crabs!',26124),
(64150,'enUS','Uh-oh! You stirred up some spiders!','Uh-oh! You stirred up some spiders!',26124),
(64151,'enUS','','We travel where the winds take us, good $r. Would you like to listen for a while?',26124),
(64152,'enUS','','In our travels, we have sung many songs, but there are many more songs to sing.',26124),
(64153,'enUS','I call upon the watersss of my homelands... DELIVER MY ENEMIES UNTO ME!','',26124),
(64154,'enUS','My people and I are studying the nearby rivers and ponds. Never before have we seen such revitalizing water.','',26124),
(64155,'enUS','We think that the unique qualities of the water in the Valley is the main reason for the abundance in the region.','',26124),
(64156,'enUS','The water in this pond is... quite awful.','',26124),
(64157,'enUS','Unfortunately, our brother Jogu has not fared well since his family died.','',26124),
(64158,'enUS','Jogu is from a different tribe than us. He came far from the north, and will not speak much of what led him here.','',26124),
(64159,'enUS','Our brother over there drowns his sorrows in apathy and wine, instead of work and toil.','',26124),
(64160,'enUS','Whew! That is some strong brew!','',26124),
(64161,'enUS','This food is delicious. I never want to leave.','',26124),
(64162,'enUS','Master Jiying says we have to continue our research, but it\'s nice to come here and relax every once in a while.','',26124),
(64163,'enUS','<The great cat barely bats an ear at you, even when you run your fingers through her thick fur.>','',26124),
(64164,'enUS','<The enormous bird shies away from you.>','',26124),
(64165,'enUS','We were lucky to meet up with these other Horde survivors. I did not realize that our brethren had washed up elsewhere on this new land.','',26124),
(64166,'enUS','I don\' know, $r. Dis big vegetables don\' seem right, mon. How can dey just eat dem like it\'s nuddin\'? Where is all dey MEAT?','',26124),
(64167,'enUS','','Dezco sent us ahead to scout this region. We may have found a path to the great healing in Leza\'s vision.',26124),
(64168,'enUS','','The locals here insist that the great healing waters we seek are no further than a certain... Stormstout Brewery. We may have to investigate their claims.',26124),
(64169,'enUS','','This troll complains about the food, but he eats more than any of us.',26124),
(64170,'enUS','','Have you seen the wall over to the west? I wonder what lies beyond it?',26124),
(64171,'enUS','','All the stuff here... It\'s so... so... different!',26124),
(64172,'enUS','Admiral Taylor sent us here to look fer the young Prince. Did ya know that they brew BEER here?','',26124),
(64173,'enUS','We\'re hard at work, searching for Prince Anduin. We\'re just stoppin\' fer a bite and a drink.','',26124),
(64174,'enUS','They say that there are over five thousand brews in Pandaria. I ain\'t leavin\' until I try them all!','',26124),
(64175,'enUS','Grab a drink and join us, $r!','',26124),
(64176,'enUS','','I just love listening to Kol talk about his delicious recipes. I never knew there were so many ways to grill meat.',26124),
(64177,'enUS','','Have you tried Kol\'s cooking? I can\'t seem to get enough of it.',26124),
(64178,'enUS','','He keeps telling me that he likes my accent, and I just keep asking, what accent?',26124),
(64179,'enUS','Hey $c, fancy meeting you here! Were you sent to seek the young Prince, too?','',26124),
(64180,'enUS','The locals here certainly have an idyllic lifestyle. It makes me wonder if I should lay down my wand and pick up a hoe.','',26124),
(64181,'enUS','I\'m a wand peddler by trade. Luckily for you and me both, most of my wands survived through the shipwreck!','',26124),
(64182,'enUS','A wise man rests when he is weary.','',26124),
(64183,'enUS','The best brew in all of Pandaria is made right here in the Valley, at the Stormstout Brewery.$B$BWell, at least I think so.','',26124),
(64184,'enUS','Fill your cup with joy, and you will drink joy. Fill your cup with sorrow, and you will drink sorrow.$B$BChoose your brew wisely, my friend.','',26124),
(64185,'enUS','Aaaah, I believe that happiness is a full belly.$B$BFill your stomach with good food, and you fill your soul with warmth.','',26124),
(64186,'enUS','It is good to enjoy the fruits of the earth, but not to excess.','',26124),
(64187,'enUS','Most good fortune to you, $r! My brother and I come from far away to share our luckydos.','',26124),
(64188,'enUS','Most good fortune to you, $r! My brother and I come from far away to share our luckydos.','',26124),
(64189,'enUS','Grummles have good noses. Can tell the difference between good and bad fortune by the smell. You have the smell of good fortune about you.','',26124),
(64190,'enUS','Please, let us remain civil while we are guests in this town. I suspect our hosts will not react kindly to bloodshed.','',26124),
(64191,'enUS','I don\' know, $r. Dis big vegetables don\' seem right, mon. How can dey just eat dem like it\'s nuddin\'? Where is all dey MEAT?','',26124),
(64192,'enUS','','Let us not bring bloodshed to this peaceful place, $brother:sister;.',26124),
(64193,'enUS','','Our search has taken us across vast oceans and deep jungles, and yet we encounter one another here, of all places. It truly seems that our conflict is inevitable, wherever we go.',26124),
(64194,'enUS','','I\'m watching you, $r.',26124),
(64195,'enUS','Hey ugly, I would punch you right now... if I thought I could hit ya! Anyway, did ya know that they brew BEER here?','',26124),
(64196,'enUS','Instead of bloodshed, how about we settle our differences... in a battle of the DANCE?','',26124),
(64197,'enUS','','Hey now, this is no place to start a fight. Otherwise, no one will get to enjoy this food.',26124),
(64198,'enUS','Hey $r, don\'t try anything funny! I\'ve got several wands up my sleeves and I\'m not afraid to use them!','',26124),
(64199,'enUS','','Music is good for the mind, body, and soul!',26124),
(64200,'enUS','Are you here to enjoy the view?','Are you here to enjoy the view?',26124),
(64201,'enUS','Can you smell the winds, stranger? They bring change.','Can you smell the winds, stranger? They bring change.',26124),
(64202,'enUS','From here we meditate on the wonders of Pandaria.','From here we meditate on the wonders of Pandaria.',26124),
(64203,'enUS','When standing on the precipice, do not forget to breathe.','When standing on the precipice, do not forget to breathe.',26124),
(64204,'enUS','Welcome to the Serpent\'s Overlook. Did you happen to bring a kite with you?','Welcome to the Serpent\'s Overlook. Did you happen to bring a kite with you?',26124),
(64205,'enUS','The farmers from the nearby fields bring their wheat, and we mill and sort the grains here.$B$BSome of the grain will be made into food, some of it is traded, but most of it is sent to the Stormstout Brewery for... you guessed it... beer!','',26124),
(64206,'enUS','This is a place of peace. We watch, we meditate, we work on our crafts, and we are content.','This is a place of peace. We watch, we meditate, we work on our crafts, and we are content.',26124),
(64207,'enUS','Have you been to Dawn\'s Blossom? Did you happen to pick up an extra cask of Goldendraft while there?$b$bIt is not the easiest thing to have them deliver here.','Have you been to Dawn\'s Blossom? Did you happen to pick up an extra cask of Goldendraft while there?$b$bIt is not the easiest thing to have them deliver here.',26124),
(64208,'enUS','The Jade Serpent! It... it broke.','The Jade Serpent! It... it broke.',26124),
(64209,'enUS','','I told my son, I told Dion, don\'t take the yaks to the field when it\'s raining. And what does he do? He takes out the yaks when it is raining.$B$BIt is no surprise that we now have sick yaks!$B$BAi-ya! How did I raise such a foolish son?',26124),
(64210,'enUS','','My son does not eat enough. Look at him! So scrawny and skinny! I must feed him more.',26124),
(64211,'enUS','','Why my son must be so short? I wanted tall, strong young son.$B$BI told him not to open umbrellas indoors when he was little. You will grow up short, I say!$B$BWhat does he do? He play with umbrellas all the time! Inside! Tcha!',26124),
(64212,'enUS','','My son Dion say Mama make the best dumplings in all of Valley!$B$BOoohoohoohooo. That\'s my boy.',26124),
(64213,'enUS','','Mama loves oranges, but oranges are so hard to find in the Valley.$B$BI tell my son to buy some oranges at the market, so I give him some copper.$B$BWhat does he do? He buys some beans!$B$BWe are not farmers! We are yak-herders! What do I do with stupid beans, I ask you?',26124),
(64214,'enUS','The hozen and the jinyu have always fought, but never like this...','The hozen and the jinyu have always fought, but never like this...',26124),
(64215,'enUS','','My son Dion is out in fields all day. He works so hard. Makes Mama so proud.',26124),
(64216,'enUS','The Jade Serpent... what will it do now?','The Jade Serpent... what will it do now?',26124),
(64217,'enUS','What does this mean? The end of peace in Pandaria? Are we doomed?','What does this mean? The end of peace in Pandaria? Are we doomed?',26124),
(64218,'enUS','','Do you come to see Mama? Oh, sit for a while!$B$BLet me tell you, I hear some gossip the other day.$B$BI heard that Gina Mudclaw and her father, Haohan Mudclaw, don\'t get along!$B$BHe wanted to marry her to Farmer Fung up by the Belt, but she wouldn\'t have it! Wanted to run her market, she said.$B$BAi-ya! What has become of the young girls these days? Don\'t want to marry handsome young man and raise a family?$B$BEspecially that Fung... he\'s such a catch! So good-looking, and grows such big vegetables too.$B$BWhy I not have handsome young son like that?!',26124),
(64219,'enUS','','Oh, when is my son going to meet a nice young lady? All he does is hang around yaks all day!$B$BWhat girl is going to want a stinky yakherd, huh? Ai-ya, Mama worry so much...',26124),
(64220,'enUS','','Ah, hello there, $r!$B$BThis is where we keep all our farming history and knowledge.$B$BWe have records of the local weather and resulting harvest, detailed notes on every seed and every plant that grows in the Valley, and even a bank of seeds for all the plants that we may ever need to grow.$B$BThis knowledge is sacred to us. If disaster should ever strike this land, our seeds must be saved.',26124),
(64221,'enUS','Hello there, traveler. I\'m hard at work making my next masterpiece!','',26124),
(64222,'enUS','The Jade Serpent statue was destroyed? How could this have happened?','The Jade Serpent statue was destroyed? How could this have happened?',26124),
(64223,'enUS','','Don\'t you just love watching the birds? I wish I could fly, too.',26124),
(64224,'enUS','','The farmers pray for rain, but I don\'t! It\'s terrible for business. Just look at my market! Sopping wet!',26124),
(64225,'enUS','','It\'s raining yaks and mushan today! Well, I\'ve got a market to run, rain or shine!',26124),
(64226,'enUS','Look at the sky, $n! It\'s raining! Should be good for the crops, eh?','',26124),
(64227,'enUS','Wow, just look at this storm! Well, crops like water, right?','',26124),
(64228,'enUS','The Jade Serpent statue was destroyed? How could this have happened?','The Jade Serpent statue was destroyed? How could this have happened?',26124),
(64229,'enUS','What is this \"sha\"? Where did it come from?','What is this \"sha\"? Where did it come from?',26124),
(64230,'enUS','Will you help us heal the land?','Will you help us heal the land?',26124),
(64231,'enUS','The poor hozen and jinyu! We knew they didn\'t like each other but to go this far...','The poor hozen and jinyu! We knew they didn\'t like each other but to go this far...',26124),
(64232,'enUS','Did all of the jinyu and the hozen perish in that battle? Were there survivors?','Did all of the jinyu and the hozen perish in that battle? Were there survivors?',26124),
(64233,'enUS','Will you help us against the sha?','Will you help us against the sha?',26124),
(64234,'enUS','So much... lost.$b$bAnd I fear, $n, that this is only the beginning.','',26124),
(64235,'enUS','I got nothin\' to say to you! I will only be talkin\' to $p.','',26124),
(64236,'enUS','Eh? What did you say?','',26124),
(64237,'enUS','','Are we gonna see a shark?',26124),
(64238,'enUS','If there\'s time.','',26124),
(64239,'enUS','The ancient chest is covered in dust...','',26124),
(64240,'enUS','','Where are we going?',26124),
(64241,'enUS','','It is time to get the fish from the market.',26124),
(64242,'enUS','','Are we there yet?',26124),
(64243,'enUS','We\'re almost there. Just a bit more to go.','',26124),
(64244,'enUS','','Can you carry me, daddy?',26124),
(64245,'enUS','No honey bear. I need you to get those legs nice and strong. You want to be as strong as me one day, right?','',26124),
(64246,'enUS','','Wow! I never knew this was back here.',26124),
(64247,'enUS','','Oooooh, isn\'t this scary? Do you think there are ghosts in there?',26124),
(64248,'enUS','','Eeewwww! What is THAT THING?',26124),
(64249,'enUS','','There it is! Old Man Thistle\'s treasure!',26124),
(64250,'enUS','','Wooooowwwww!',26124),
(64251,'enUS','','Jumping jackhoppers! We found it! We really found it! It\'s Old Man Thistle\'s hidden treasure! Oh boy oh boy oh boy!!!',26124),
(64252,'enUS','','The maiden, eh? Hmm, I remember that\'s what my father used to call that river to the north. Other than that, I wouldn\'t have the slightest clue.',26124),
(64253,'enUS','What echoes and what\'s dark? It\'s simple! A cave!','',26124),
(64254,'enUS','Hmmm, I reckon I don\'t know, $r. All I can understand is the part about the valley - that\'s right here! The Valley of the Four Winds!','',26124),
(64255,'enUS','Oh, I HAVE heard of the ancestors\' stair. That\'s what some folks call those mountains to the north.','',26124),
(64256,'enUS','Can you make anything of these clues?','Can you make anything of these clues?',26124),
(64257,'enUS','Have you ever heard of a maiden laughing behind a fan?','Have you ever heard of a maiden laughing behind a fan?',26124),
(64258,'enUS','Where can I find the ancestors\' stair?','Where can I find the ancestors\' stair?',26124),
(64259,'enUS','Where can someone whisper secrets into the echoing dark?','Where can someone whisper secrets into the echoing dark?',26124),
(64260,'enUS','Think you can take me in battle?  Most girls hate snakes, but I think they\'re cute!','Think you can take me in battle?  Most girls hate snakes, but I think they\'re cute!',26124),
(64261,'enUS','My family and I are bringing fresh fish from the Anglers to town. Would you like to buy some?','',26124),
(64262,'enUS','','It is a long walk from town to Sri-La, but good for the spirit. And it certainly helps get little Aerial here outdoors.',26124),
(64263,'enUS','','I\'m not supposed to talk to strangers.',26124),
(64264,'enUS','5.0 Cooking - Cooking Student Default 1','',26124),
(64265,'enUS','','Do you see that big fish down there, $n?',26124),
(64266,'enUS','','Don\'t you try to sneak up on me! My pappy always said I got eyes in the back o\' my head!',26124),
(64267,'enUS','','What ken I do fer ya, $n?',26124),
(64268,'enUS','','Woowhee! I still can\'t believe we found Old Man Thistle\'s treasure. I guess all those folk stories weren\'t so true after all, but I still like tellin\' them!',26124),
(64269,'enUS','Tell me the story of Old Man Thistle.','Tell me the story of Old Man Thistle.',26124),
(64270,'enUS','','Now they say that whoever can git their hands on that map, can find that lost treasure...',26124),
(64271,'enUS','Oh yeah? Tell me more.','Oh yeah? Tell me more.',26124),
(64272,'enUS','Now go, impart my techniques to the initiates.','',26124),
(64273,'enUS','We will not tolerate those who unleashed the sha upon our land.','',26124),
(64274,'enUS','We drove back the sha, your kind will fall before us as well.','',26124),
(64275,'enUS','I once saw a fish so big you\'d swear it was a shark. Come to think of it...','',26124),
(64276,'enUS','You a fisher? With them flabby arms and that heavy armor?','',26124),
(64277,'enUS','Welcome to the coast of Pandaria! Where everything that can wash ashore has, or will, wash ashore.','',26124),
(64278,'enUS','What kind of bait you use? I knew a pandaren once, would use his own arm to bait the fish.$b$bWe called him the Noodler.$b$bRumor has it he\'s retired and went south.','',26124),
(64279,'enUS','Ever see a kracken before? Old Jin claims to have caught one, once upon a time, but let it go on acount of it looked too \"gamey.\"$b$bWe have a betting pool going to see if he ever finds it again.','',26124),
(64280,'enUS','So, what are the fish like where you come from?','',26124),
(64281,'enUS','Usually these shores are covered in mists. It looks like they cleared out for some reason.','',26124),
(64282,'enUS','','I knew a monk once who specialized in a fish-fighting style. It was pretty limiting but he could make an amazing fish stew.',26124),
(64283,'enUS','','New here? It is like we tell the children, do not go into the water without a handful of distracting bait and an exit strategy.',26124),
(64284,'enUS','','One of the children swears up and down they saw a cross between a shark and an octopus the other day.$b$bI know there are a lot of strange things in the ocean but that seems extra silly to me.',26124),
(64285,'enUS','','You probably have seen the ships crashed off our shores. Would any of those happen to be yours?$b$bThe mists often bring us a number of \"gifts\" like that.',26124),
(64286,'enUS','','Did the Serpent Riders send you? Their serpents keep stealing our best catches.',26124),
(64287,'enUS','','Fish here long enough and you will see everything. I once saw a walrus with legs and arms. Not only that, but it talked!',26124),
(64288,'enUS','','What are the seas like where you come from?',26124),
(64289,'enUS','','I often wonder about the jinyu here. But they know how to fish and better than the rest of us so who am I to judge.',26124),
(64290,'enUS','You are my favorite teacher ever!','You are my favorite teacher ever!',26124),
(64291,'enUS','When I grow up, I want to be the best chef in Pandaria.','When I grow up, I want to be the best chef in Pandaria.',26124),
(64292,'enUS','','Oooh, this is so exciting! A real life treasure hunt!',26124),
(64293,'enUS','Do you think I\'ll make a good cook eventually?','Do you think I\'ll make a good cook eventually?',26124),
(64294,'enUS','What will we be learning next?','What will we be learning next?',26124),
(64295,'enUS','I\'ll try my best to be a good student.','I\'ll try my best to be a good student.',26124),
(64296,'enUS','','That thing is seriously scary-looking! You saved our lives, $n!',26124),
(64297,'enUS','Gossip - Option 1 - Test - HW','Gossip - Option 1 - Test - HW',26124),
(64298,'enUS','Gossip - Option 2 - Test - HW','Gossip - Option 2 - Test - HW',26124),
(64299,'enUS','','So... want to talk about it?',26124),
(64300,'enUS','Nope.','',26124),
(64301,'enUS','','You sure? I hear it happens to everyone at some point.',26124),
(64302,'enUS','Mere initiates.','',26124),
(64303,'enUS','They should have studied harder.','',26124),
(64304,'enUS','One technique alone is not enough.','',26124),
(64305,'enUS','They failed their test. Will you?','',26124),
(64306,'enUS','They approach? Good. Now, if only my students were here to see and learn from the coming display of martial prowess...','',26124),
(64307,'enUS','','We made it out alive! Boy oh boy, wait until my friends hear all about this. They\'ll never believe it! See you later, $n!',26124),
(64308,'enUS','','This is... remarkable, $n! These notes provide invaluable knowledge to our farmers. We are truly in Old Man Thistle\'s debt for keeping such records, and in your debt for recovering them. Thank you!',26124),
(64309,'enUS','You have been affected by |cFFFF0404|Hspell:116417|h[Arcane Resonance]|h|r !','You have been affected by |cFFFF4809|Hspell:116417|h[Arcane Resonance]|h|r !',26124),
(64310,'enUS','The Mist-Hopper Jr. is on the dock just southeast of here. Let\'s go!','',26124),
(64311,'enUS','Man the harpoon cannon!','',26124),
(64312,'enUS','Aim for the bow, the port and starboard buoyancy sacs, and the stern...','',26124),
(64313,'enUS','Err, sorry... Let me put that another way.','',26124),
(64314,'enUS','Shoot it in the face! And the sides! And the pooper! You know, the soft bits.','',26124),
(64315,'enUS','Nice shooting!','',26124),
(64316,'enUS','Ha ha! What do you think of that, you old squid?!','',26124),
(64317,'enUS','Mazu, guide my arm...','',26124),
(64318,'enUS','HURGHH!!!','',26124),
(64319,'enUS','Keep it up!','',26124),
(64320,'enUS','That\'s right! Back to the depths with ya!','',26124),
(64321,'enUS','Looks like he sprung a leak!','',26124),
(64322,'enUS','That is some first-rate harpoonery!','',26124),
(64323,'enUS','More visitors? Bah!','',26124),
(64324,'enUS','Not sure how I got here. But... good fortune often finds the open minded.','',26124),
(64325,'enUS','','Never underestimate the importance of healing.',26124),
(64326,'enUS','','Healing has turned the tide of many battles.',26124),
(64327,'enUS','','Welcome to the Thunderpaw Refuge. Here we practice our craft of focusing our chi into healing.',26124),
(64328,'enUS','','If there is one thing in life you can learn, it is that there is always more to learn.',26124),
(64329,'enUS','Welcome to the Thunderpaw Refuge. Do not let the armor deceive you. We train in healing practices here.','Welcome to the Thunderpaw Refuge. Do not let the armor deceive you. We train in healing practices here.',26124),
(64330,'enUS','Things are quite calm here usually. We only have problems with the occassional saurok hunting party. And the saurok tend to only come out during a heavy storm.','Things are quite calm here usually. We only have problems with the occassional saurok hunting party. And the saurok tend to only come out during a heavy storm.',26124),
(64331,'enUS','Have you met Brewmaster Blanche? She wanders the roads to the south and east of here. She has been known to visit us with some of her more astounding brews.','Have you met Brewmaster Blanche? She wanders the roads to the south and east of here. She has been known to visit us with some of her more astounding brews.',26124),
(64332,'enUS','I am trying to learn how to heal. The problem is you have to get hurt before you can be healed.','I am trying to learn how to heal. The problem is you have to get hurt before you can be healed.',26124),
(64333,'enUS','Someone was saying I was \"overhealing\" the other day. I am so confused.','Someone was saying I was \"overhealing\" the other day. I am so confused.',26124),
(64334,'enUS','I am learning how to slap the pain out of someone. How neat is that?','I am learning how to slap the pain out of someone. How neat is that?',26124),
(64335,'enUS','Can\'t talk now. Must... focus.','Can\'t talk now. Must... focus.',26124),
(64336,'enUS','I never knew how much variety there was to brewing tea.','I never knew how much variety there was to brewing tea.',26124),
(64337,'enUS','I can... I can barely breathe.  I\'m alive thanks to you.','I can... I can barely breathe.  I\'m alive thanks to you.',26124),
(64338,'enUS','Poor Sheepie... his restless wandering finally did him in.','',26124),
(64339,'enUS','They came without warning.  There\'s nothing the guards could have done.','They came without warning.  There\'s nothing the guards could have done.',26124),
(64340,'enUS','It seems there are hazards to living in a place so beautiful...','It seems there are hazards to living in a place so beautiful...',26124),
(64341,'enUS','These mogu won\'t scare us away.  This is our home now.','These mogu won\'t scare us away.  This is our home now.',26124),
(64342,'enUS','I\'m alive thanks only to you... I won\'t forget this.','I\'m alive thanks only to you... I won\'t forget this.',26124),
(64343,'enUS','I know you!  You saved my brother not even a week ago.  You\'re a true hero!','I know you!  You saved my brother not even a week ago.  You\'re a true hero!',26124),
(64344,'enUS','I thought that was it... I thought I was going to die.  Thank you, stranger.','I thought that was it... I thought I was going to die.  Thank you, stranger.',26124),
(64345,'enUS','Wait! Something hostile approaches!','',26124),
(64346,'enUS','One of the initiates pulled a prank on me the other day. He said I was supposed to sniff his \"healing mists\". There was nothing healing about that mist.','One of the initiates pulled a prank on me the other day. He said I was supposed to sniff his \"healing mists\". There was nothing healing about that mist.',26124),
(64347,'enUS','Attackers approach!','',26124),
(64348,'enUS','I owe you my life.','I owe you my life.',26124),
(64349,'enUS','I\'m at your side, friend.','I\'m at your side, friend.',26124),
(64350,'enUS','You\'ve earned my aid.  Where to?','You\'ve earned my aid.  Where to?',26124),
(64351,'enUS','Prepare for battle Wakener!','',26124),
(64352,'enUS','Thank you.','Thank you.',26124),
(64353,'enUS','I am grateful, friend.  Let me fight by your side.','I am grateful, friend.  Let me fight by your side.',26124),
(64354,'enUS','Too long in that cage.  I\'ll show these mogu what I think of their captivity...','Too long in that cage.  I\'ll show these mogu what I think of their captivity...',26124),
(64355,'enUS','Thank you for the timely rescue, hero.','Thank you for the timely rescue, hero.',26124),
(64356,'enUS','We will never yield our defense of the Vale!','We will never yield our defense of the Vale!',26124),
(64357,'enUS','Mmmmm! I smell a delicious sheep!','',26124),
(64358,'enUS','Long live the Golden Lotus!','Long live the Golden Lotus!',26124),
(64359,'enUS','By the will of the Celestials!','By the will of the Celestials!',26124),
(64360,'enUS','Time to munch on some mutton!','',26124),
(64361,'enUS','We stand together.  We will never fall!','We stand together.  We will never fall!',26124),
(64362,'enUS','The Golden Lotus will never yield.','The Golden Lotus will never yield.',26124),
(64363,'enUS','The Vale will never fall into mogu hands!','The Vale will never fall into mogu hands!',26124),
(64364,'enUS','The Shao-Tien march to their deaths!','The Shao-Tien march to their deaths!',26124),
(64365,'enUS','Yield or fall!','Yield or fall!',26124),
(64366,'enUS','Your stance is wrong. Your footing is totally off balance. Your head is too soft.$b$bReturn here when you have learned that you are ready to learn.','',26124),
(64367,'enUS','You will burn under the might of the Shao-Tien!','You will burn under the might of the Shao-Tien!',26124),
(64368,'enUS','We will blanket the Vale in your bloody bodies!','We will blanket the Vale in your bloody bodies!',26124),
(64369,'enUS','Your eyes fail to see what is before you. No doubt this is a result of your flawed eating habits.','',26124),
(64370,'enUS','Your soul will be mine to torture!','Your soul will be mine to torture!',26124),
(64371,'enUS','The return of the Emperor will doom your entire race!','The return of the Emperor will doom your entire race!',26124),
(64372,'enUS','I will crush the life from your skull!','I will crush the life from your skull!',26124),
(64373,'enUS','I will have your head on a pike, $r!','I will have your head on a pike, $r!',26124),
(64374,'enUS','Even death will not free you from my grasp!','Even death will not free you from my grasp!',26124),
(64375,'enUS','Your struggle is pitiful and weak!','Your struggle is pitiful and weak!',26124),
(64376,'enUS','You move like a pregnant yak. You are not ready to be trained here.','',26124),
(64377,'enUS','To run on water, one must run very fast.','',26124),
(64378,'enUS','','The Shao-Tien have taken a great interest in these ruins.  They intend to recover power from its depths.  I intend to leave their corpses littering them.',26124),
(64379,'enUS','','These trainees are weak.  They are not ready to walk the wall, much less face the mantid or the mogu head-on.  It will be some time before we can depend on them in any real sense.',26124),
(64380,'enUS','','We all served under Leven in excursions past the wall.  We honed our blades against countless mantid and yaungol.  These mogu think us weak, but that mistake in judgment will cost them dearly.',26124),
(64381,'enUS','Setting foot in the Dread Wastes taught me the value of knowing the terrain and understanding the enemies\' movements.  Whether the goal is victory or simply survival, the best route is always to be two steps ahead of your opponent.','',26124),
(64382,'enUS','It can be difficult for a hardened veteran to grow accustomed to a peaceful setting, but that is our duty.  These villagers do not long for war, let us not bring it to their doorstep if we do not have to.','',26124),
(64383,'enUS','Isn\'t he magnificent?!','',26124),
(64384,'enUS','So many mouths to feed, and never enough ingredients to feed them!','',26124),
(64385,'enUS','Come to me Kovok.','',26124),
(64386,'enUS','One of my ancestors took part in the uprising at Tu Shen, and now lies among the graves.  I would pay my respects if only I could, but the spirits there know no peace.','',26124),
(64387,'enUS','It is important for the trainees to learn the sting of defeat, that they might appreciate the value of victory.','',26124),
(64388,'enUS','<He looks to you grimly.>','',26124),
(64389,'enUS','<He\'s eyes light up as you approach.>','',26124),
(64390,'enUS','<He stares at you blankly.>','',26124),
(64391,'enUS','I like to think of myself as the brains and the beauty of this operation. Anji\'s the brawn. And the second beauty.$B$BWe\'ve got a lot of beauty.','',26124),
(64392,'enUS','I don\'t love spiders. Or statues that move. Or sprites that steal your things.  There are a lot of things I don\'t love about these ruins.  Fortunately for me, Anji\'s here to keep my good-looks intact!','',26124),
(64393,'enUS','There is no corner of this vale that the Shao-Tien can hide from us in. They underestimate the tenacity of the Shado-Pan.','',26124),
(64394,'enUS','The rising threats of the mogu\'s return and the mantid swarms in the west have brought far more trainees to bare than usual. This is good. They will be needed.','',26124),
(64395,'enUS','The mogu are a mighty threat, but they\'re nothing compared to the horrors my men and I have faced in the Dread Wastes. I have no doubts that we can hold the Vale.','',26124),
(64396,'enUS','','We are as new to this vale as you. We came when the gates opened, having lost our homes in Kun-Lai. There is much to build, much to mend.',26124),
(64397,'enUS','','I wonder if our fates are somehow cursed. The horrors inflicted on us never seem to cease.$B$BSometimes all you can do is try to maintain good spirits, and perhaps a mild appreciation for fickle twists of fortune, whichever way they turn.',26124),
(64398,'enUS','This is the most bountiful land in all of Pandaria! A smart man could grow rich here!','',26124),
(64399,'enUS','A budding village is a wonderful place to make a living!  So many goods needed, so many goods to be traded.  I think I could grow fat and happy here indeed!','',26124),
(64400,'enUS','I\'ve heard nothing but tales of how peaceful and beautiful this vale was, far before any of us were ever allowed in. Now that we\'re here, there\'s all manner of beasty trying to smash our head or bite off our feet.$B$BSo are the tales a lie, or are we just horrid company? I humbly exclude myself from the latter possibility, because to consider such would be silly.','',26124),
(64401,'enUS','Well this all is all manner of spooky, is it not?  And these traps, quite unwelcoming.  These mogu could desperately use some decoration advice.','',26124),
(64402,'enUS','I often worry, if the blossoms in this vale are truly eternal, it would be quite dangerous for new ones to sprout, no?  We\'d be swimming in sea of choking flowers, fragrant and soft as they might be.$B$BI like to play it safe and squash the small ones under my boot, just to keep things in balance, you know?','',26124),
(64403,'enUS','Rook treats friends good.','',26124),
(64404,'enUS','Rook want to smash mogu, but villagers not safe!  If Rook keep villagers safe, can you help smash mogu?','',26124),
(64405,'enUS','Why old mogu build broken pillars and walls here?  Why not build full buildings like everyone else?  Mogu dumb.','',26124),
(64406,'enUS','','Within these ruins rest many ancient mogu secrets.  This entire vale was theirs once, and some corners of it have yet to be tread by pandaren feet.',26124),
(64407,'enUS','','The mogu are cruel captors. We should not risk any time if any of our brave warriors have fallen into their hands.',26124),
(64408,'enUS','','In the darkest of times, it is often a patient spirit and a reassuring hand that carry the most value.',26124),
(64409,'enUS','','I weep for the fortune of this village. Their hard times seem to be without end, and with the mogu in the vale, it will likely be some time before they ever will.',26124),
(64410,'enUS','The reflexes built in the survival ring are what keep these trainees alive beyond the wall.  There, the threats are much less forgiving.','',26124),
(64411,'enUS','','It\'s about time you asked! I was wondering when Farmer Yoon would ever notice me. You go ahead, and I\'ll be there after I\'m done at the market today.',26124),
(64412,'enUS','','Sunsong Ranch needs my help? I\'ll meet you there after I\'m done here at the market today.',26124),
(64413,'enUS','Well I s\'pose the chickens won\'t mind if I visit fer a bit. I\'ll meet ya there after I\'ve done my business here at the market today.','',26124),
(64414,'enUS','I suppose I could leave things to Mung-Mung for a while and take a gander at Yoon\'s. Let me finish up my business here at the market, first.','',26124),
(64415,'enUS','Really? That whole pond, just for me? I\'ll be right there... right after I finish this drink... hic!','',26124),
(64416,'enUS','','Well all right, I s\'pose I could hop on over to the farm now and again. I can\'t do it right away though. I have some business to finish at the market, first.',26124),
(64417,'enUS','I was wonderin\' when you would ask. Sure thing, but I can\'t today. Once I finish my business at the market, I\'ll be right over!','',26124),
(64418,'enUS','','My papa always did say to help out a neighbor in need! I\'ve just gotta take care of some stuff here at the market, first. I\'ll be there soon as I can!',26124),
(64419,'enUS','','Sure, I suppose I could help out for a bit! I can\'t leave the market today, but I\'ll be there as soon as I can.',26124),
(64420,'enUS','Okay, boss! Chee Chee got stuff to do at the market today, then he be there soon.','',26124),
(64421,'enUS','A Saurok runs down a hidden set of stairs with some of the treasure!','',26124),
(64422,'enUS','Not all of the paragons were choosen for the physical skills, Wakener.','',26124),
(64423,'enUS','Such a beautiful creature, wouldn\'t you agree? Do not let his small size deceive you. Even at a young age the Kunchong are lethal.$b$bBefore my discovery, the Kunchong were used as weapons with little regard for their intelligence. We struggled to control them until it occurred to me that we didn\'t fully understand them.$b$bBy forming a bond with the creatures we no longer needed to exert control forcefully. Instead, a partnership occurred.$b$bKovok was the next step in my experiment.','',26124),
(64424,'enUS','$n is trapped in an Amber Prison! Free them!','$n is trapped in an Amber Prison! Free them!',26124),
(64425,'enUS','|TInterface\\Icons\\inv_sword_2h_mantid_01.blp:20|tWind Lord Mel\'jarak begins to cast |cFFF00000|Hspell:122407|h[Rain of Blades]|h|r!','',26124),
(64426,'enUS','Wind Lord Mel\'jarak senses more than 4 of his allies are incapacitated and frees them!','',26124),
(64427,'enUS','What the...','',26124),
(64428,'enUS','LEVIATHAN!!','',26124),
(64429,'enUS','We gotta warn the others!','',26124),
(64430,'enUS','Aaaagghhhh!!','',26124),
(64431,'enUS','Guarding grummles is not what I would call my dream role in life, but they pay well. Plus you see many strange things on the mountain roads.','Guarding grummles is not what I would call my dream role in life, but they pay well. Plus you see many strange things on the mountain roads.',26124),
(64432,'enUS','You from the low lands? We tend to not see low landers up this way very often.','You from the low lands? We tend to not see low landers up this way very often.',26124),
(64433,'enUS','What brings you up the mountain?','What brings you up the mountain?',26124),
(64434,'enUS','Grummles usually have Shado-Pan guarding them. I guess there must be danger on the Serpent\'s Spine.','Grummles usually have Shado-Pan guarding them. I guess there must be danger on the Serpent\'s Spine.',26124),
(64435,'enUS','Have you heard the sha? We keep hearing its voice on the wind. Not good. Not good at all.','Have you heard the sha? We keep hearing its voice on the wind. Not good. Not good at all.',26124),
(64436,'enUS','The mountain hozen are on the ravage. Be careful when you travel the roads.$b$bProbably only a matter of time before they figure out the Shado-Pan are not here and decide to march down on us.','The mountain hozen are on the ravage. Be careful when you travel the roads.$b$bProbably only a matter of time before they figure out the Shado-Pan are not here and decide to march down on us.',26124),
(64437,'enUS','I once saw a strange creature in the Grummle Bazaar. It looked like a haunched over jinyu but was mean and said something like \"Mrggmrmrgmgmgl\".$b$bI guess one of the grummles brought it up from the coastline.','I once saw a strange creature in the Grummle Bazaar. It looked like a haunched over jinyu but was mean and said something like \"Mrggmrmrgmgmgl\".$b$bI guess one of the grummles brought it up from the coastline.',26124),
(64438,'enUS','There have been no Shado-Pan down this way recently. That cannot be good.$b$bWe were supposed to still have a few years before the next mantid swarm.','There have been no Shado-Pan down this way recently. That cannot be good.$b$bWe were supposed to still have a few years before the next mantid swarm.',26124),
(64439,'enUS','','You are sweet as sugar, $n.',26124),
(64440,'enUS','','Honey, you are so kind to me!',26124),
(64441,'enUS','','It is so nice of you think of me, darlin\'.',26124),
(64442,'enUS','','It\'s so red! Don\'t you know that\'s my favorite color?',26124),
(64443,'enUS','','Oh my, this is beautiful. How did you know that I like jewels?',26124),
(64444,'enUS','','Thank you, $n. A girl can never have enough rubies.',26124),
(64445,'enUS','','You shouldn\'t have! But I\'m glad you did.',26124),
(64446,'enUS','','Aren\'t you just a sugar $Gdaddy:pie;?',26124),
(64447,'enUS','','Aw shucks, you are going to spoil me rotten!',26124),
(64448,'enUS','|TInterface\\Icons\\inv_misc_uncutgemnormal.blp:20|t$n is trapped in an |cFFF00000|Hspell:121881|h[Amber Prison]|h|r!','',26124),
(64449,'enUS','','I\'m not good with all this emotional feeling stuff, but thank you.',26124),
(64450,'enUS','','Thank you, $c. You honor me.',26124),
(64451,'enUS','','Thank you, $n. I am in your debt.',26124),
(64452,'enUS','','You are too kind, $c. How can I ever repay you?',26124),
(64453,'enUS','','You shouldn\'t have, $c. I thank you.',26124),
(64454,'enUS','','A girl does get hungry after hunting down all those enemies. Thank you.',26124),
(64455,'enUS','','Oh, this looks delicious. Thank you, $c.',26124),
(64456,'enUS','','Mmmm... a warrior does need to keep up her strength. Thank you.',26124),
(64457,'enUS','','The vigil is never finished, but I can always take a break for a hot meal!',26124),
(64458,'enUS','Can I eat it? I guessh only one way to find out...','',26124),
(64459,'enUS','Your consciousness is expanding. Concentrate on who you are looking for. The boy prince - the young lion. He is here, isn\'t he? Journey through time and space... open the eye of your soul. Do you see him?','',26124),
(64460,'enUS','Hmm, this will give me shomething to focush on for my next predikshun.','',26124),
(64461,'enUS','Thish ish really neat $n. Thanksh, buddy.','',26124),
(64462,'enUS','I like thish a lot, $n. Thanksh.','',26124),
(64463,'enUS','Thanksh for thinkin\' of me, buddy. No one elshe doesh.','',26124),
(64464,'enUS','You are so kind $Gmish:mishter;... hic!','',26124),
(64465,'enUS','Thish apple looks delishush. Thanksh!','',26124),
(64466,'enUS','An apple for me? Thanksh!','',26124),
(64467,'enUS','What ish that? A tomato? A pomegranate? Oh! An apple!','',26124),
(64468,'enUS','Burn!','',26124),
(64469,'enUS','Ish that an apple? You must be glad to shee me... hic!','',26124),
(64470,'enUS','Oh that looksh delishush. It will go great with my cold drink here.','',26124),
(64471,'enUS','An oracle needsh food to foreshee the future. Thanksh!','',26124),
(64472,'enUS','My family used to make this... They\'re gone now, but I shtill love thish dish.','',26124),
(64473,'enUS','Oh, you shouldn\'t have. Thanks.','',26124),
(64474,'enUS','But I didn\'t get you anything. Aww shucks, thanks anyway.','',26124),
(64475,'enUS','That\'s mighty kind of you, $r.','',26124),
(64476,'enUS','I suppose I could use one of those. Thank you.','',26124),
(64477,'enUS','I don\'t deserve something as nice as that. I suppose you\'re going to insist.','',26124),
(64478,'enUS','I can\'t say no, but you didn\'t have to. Thanks, $r.','',26124),
(64479,'enUS','My son used to love finding these feathers.','',26124),
(64480,'enUS','These feathers bring back memories of my son. Thank you, $r.','',26124),
(64481,'enUS','My son loved these feathers because they are blue as the sky. He always said he was going to fly someday.','',26124),
(64482,'enUS','Thank you, $n. My son would have liked to see this.','',26124),
(64483,'enUS','It\'s very nice, $n. Thank you.','',26124),
(64484,'enUS','You must be quite the cook, $n. This looks very nice.','',26124),
(64485,'enUS','Thank you for thinking of a lonely old man, $n.','',26124),
(64486,'enUS','You shouldn\'t have!','',26124),
(64487,'enUS','Oh ho ho, this is for me? Thank you.','',26124),
(64488,'enUS','You sure know how to make a pandaren happy. Thanks.','',26124),
(64489,'enUS','How generous of you. Thanks!','',26124),
(64490,'enUS','I suppose this gift is acceptable. Thanks, $n.','',26124),
(64491,'enUS','I wouldn\'t expect anything less, $r. Thanks.','',26124),
(64492,'enUS','This is pretty nice gift, $n! Thanks a lot.','',26124),
(64493,'enUS','Run away or be scorched!','',26124),
(64494,'enUS','Tiger Steak? That\'s my favorite! How did you know?','',26124),
(64495,'enUS','They say that the way to the Tiller\'s Union is through the leader\'s stomach. Eh?','',26124),
(64496,'enUS','We will burn your lands!','',26124),
(64497,'enUS','You dare face the fire of the yaungol?!','',26124),
(64498,'enUS','','You sure know how to season a gal\'s pan! Thanks!',26124),
(64499,'enUS','','You lookin\' to get on my good side, eh $r? Well good for you!',26124),
(64500,'enUS','Die! And embrace your fate!','',26124),
(64501,'enUS','','You do that again and I might just have to take a likin\' to ya!',26124),
(64502,'enUS','You cannot escape your fate!','',26124),
(64503,'enUS','','A gift for little old Gina? You are so sweet.',26124),
(64504,'enUS','','Well, just for that, you can come to my market any time.',26124),
(64505,'enUS','','That\'s a mighty fine gift you just gave me. Thank you.',26124),
(64506,'enUS','','A pretty flower for me? Oh stop.',26124),
(64507,'enUS','','That\'s a lovely flower. Thanks, $n.',26124),
(64508,'enUS','','How did you know that I like flowers?',26124),
(64509,'enUS','You cannot stand against the fire of the yaungol!','',26124),
(64510,'enUS','','Did you make that Swirling Mist Soup yourself? It smells delicious.',26124),
(64511,'enUS','You will burn with your lands!','',26124),
(64512,'enUS','','Did you know that there are two ways into Gina\'s heart? One is being a good customer at my market, and the other is Swirling Mist Soup!',26124),
(64513,'enUS','','Oh, that looks delicious. Thank you, $n.',26124),
(64514,'enUS','That\'s a mighty nice gift, $r. Thank you.','',26124),
(64515,'enUS','How can I ever repay your kindness?','',26124),
(64516,'enUS','Hey, you ain\'t so bad after all, $r.','',26124),
(64517,'enUS','I\'m starting to take a liking to you, $r.','',26124),
(64518,'enUS','You keep this up, and I might just have to share my secret to growing so many vegetables.','',26124),
(64519,'enUS','This roast looks delicious. I hope you made it yourself.','',26124),
(64520,'enUS','Nothing like a homemade roast! Delicious!','',26124),
(64521,'enUS','This is our land now!','',26124),
(64522,'enUS','My momma always told me these flowers were lucky.','',26124),
(64523,'enUS','These are yaungol lands!','',26124),
(64524,'enUS','That\'s mighty nice of you, sharing such a lucky flower with me.','',26124),
(64525,'enUS','We claim your lands for our own!','',26124),
(64526,'enUS','Some folks might ask why I like flowers so much. That\'s just me appreciatin\' the beauty of this land.','',26124),
(64527,'enUS','','You sure \'bout that, $n? Wow, thank you!',26124),
(64528,'enUS','Ahh, it feels good to get salt in the old fur again.','',26124),
(64529,'enUS','','Oh no, I didn\'t get you anything in return! Boo...',26124),
(64530,'enUS','','Yer so nice, $n. I\'m so glad to know someone like you.',26124),
(64531,'enUS','','Oh, my pappy always said these little cat figures were lucky!',26124),
(64532,'enUS','','Jade is so very lucky, didn\'t you know? Thanks for giving this to me.',26124),
(64533,'enUS','','Owning a little piece o\' jade is like having a charm to ward off evil spirits. Thanks so much for this little cat! It\'ll keep me safe, I just know it.',26124),
(64534,'enUS','','Oh, you are so very kind, $n.',26124),
(64535,'enUS','','That\'s so nice of you, to think of me.',26124),
(64536,'enUS','Our home was stolen! So we will take yours!','',26124),
(64537,'enUS','','Out of all the people in the heartland, you gave this to me? I don\'t even know what to say, except I\'m mighty honored.',26124),
(64538,'enUS','Die!','',26124),
(64539,'enUS','','How did you know that I like cats?',26124),
(64540,'enUS','You dare challenge me?!','',26124),
(64541,'enUS','Ooh, nice gift for Chee Chee! Thank you!','',26124),
(64542,'enUS','For Chee Chee? You shouldn\'t have!','',26124),
(64543,'enUS','Chee Chee loves gifts! Thank you!','',26124),
(64544,'enUS','Feather for Chee Chee? Thank you.','',26124),
(64545,'enUS','Boss... this is real nice. Thank you.','',26124),
(64546,'enUS','You pretty cool, boss. Thank you!','',26124),
(64547,'enUS','Challenge accepted!','',26124),
(64548,'enUS','You cannot stop us!','',26124),
(64549,'enUS','Another slave for our new fields!','',26124),
(64550,'enUS','You dare challenge the yaungol?','',26124),
(64551,'enUS','I saw her, you know.$B$BMazu. The goddess of the sea.$B$BWorst storm of my life. I was young and inexperienced. I went overboard. Everything went dark - I was done for.$B$BThen she appeared before me, clear as a summer afternoon. Beautiful like you couldn\'t imagine - shells around her neck and strings of pearls on her hips. She smiled and held out her slender arm.$B$BNext thing I remember, Dog had me on his back at the surface and the crew was pulling me aboard. Never saw him before - crew said he came out of nowhere. But I know where he came from.','',26124),
(64552,'enUS','These are our fields now.','',26124),
(64553,'enUS','Die!','',26124),
(64554,'enUS','Surrender!','',26124),
(64555,'enUS','Nooooooooo! SHEEEEEEEEEEEEEEEPIEE!','',26124),
(64556,'enUS','Face your fate!','',26124),
(64557,'enUS','Good luck to you friend!','',26124),
(64558,'enUS','You dare challenge me?','',26124),
(64559,'enUS','Raaaaaaar!','',26124),
(64560,'enUS','Ah! A challenge!','',26124),
(64561,'enUS','Die!','',26124),
(64562,'enUS','Fear the wrath of the yaungol!','',26124),
(64563,'enUS','Chee Chee is your acquaintance.','',26124),
(64564,'enUS','Chee Chee is your buddy.','',26124),
(64565,'enUS','Chee Chee is your friend.','',26124),
(64566,'enUS','Chee Chee is your good friend.','',26124),
(64567,'enUS','Chee Chee is your best friend. Perhaps you could speak to him and see if he\'d help out on the farm.','',26124),
(64568,'enUS','You and Ella are acquaintances.','',26124),
(64569,'enUS','You and Ella are buddies.','',26124),
(64570,'enUS','You and Ella are friends.','',26124),
(64571,'enUS','You and Ella are good friends.','',26124),
(64572,'enUS','You and Ella are best friends. Perhaps she would be willing to help Farmer Yoon for a while.','',26124),
(64573,'enUS','You are buddies with Fish.','',26124),
(64574,'enUS','You are friends with Fish.','',26124),
(64575,'enUS','You are good friends with Fish.','',26124),
(64576,'enUS','You are best friends with Fish. With her knowledge of animals, she would probably help out quite a bit on the farm.','',26124),
(64577,'enUS','Somehow, you and Farmer Fung have become buddies.','',26124),
(64578,'enUS','Somehow, you and Farmer Fung have become friends.','',26124),
(64579,'enUS','Somehow, you and Farmer Fung have become good friends.','',26124),
(64580,'enUS','Somehow, you and Farmer Fung have become best friends. He would probably love to help on Sunsong Ranch.','',26124),
(64581,'enUS','You and Gina are buddies.','',26124),
(64582,'enUS','You and Gina are friends.','',26124),
(64583,'enUS','You and Gina are good friends.','',26124),
(64584,'enUS','You and Gina are best friends. She loves to get into everyone\'s business, so there\'s no doubt she\'d come spend some time on the farm.','',26124),
(64585,'enUS','You and Haohan are buddies.','',26124),
(64586,'enUS','You and Haohan are friends.','',26124),
(64587,'enUS','You and Haohan are good friends.','',26124),
(64588,'enUS','When you and Haohan have a friendship like yours, there\'s no doubt the head of the Tillers Union himself would drop by to lend a hand.','',26124),
(64589,'enUS','You and Jogu the Drunk are buddies.','',26124),
(64590,'enUS','You and Jogu the Drunk are friends.','',26124),
(64591,'enUS','You and Jogu the Drunk are good friends.','',26124),
(64592,'enUS','You and Jogu the Drunk have been through so many crop cycles together. Who else but he would be an asset to your farm?','',26124),
(64593,'enUS','You and Old Hillpaw are buddies.','',26124),
(64594,'enUS','You and Old Hillpaw are friends.','',26124),
(64595,'enUS','You and Old Hillpaw are good friends.','',26124),
(64596,'enUS','You\'ve done so much for Old Hillpaw, that old geezer is probably missing your company right now. You should ask him to help on the farm.','',26124),
(64597,'enUS','You and Sho are buddies.','',26124),
(64598,'enUS','You and Sho are friends.','',26124),
(64599,'enUS','You and Sho are good friends.','',26124),
(64600,'enUS','You\'ve proven yourself to Sho. She did say she would watch your back if you ever needed it. You can just ask her to watch your crops instead.','',26124),
(64601,'enUS','You and Tina are buddies.','',26124),
(64602,'enUS','You and Tina are friends.','',26124),
(64603,'enUS','You and Tina are good friends.','',26124),
(64604,'enUS','In Tina\'s words, you are her bestie. She\'d probably love a visit to your farm.','',26124),
(64605,'enUS','The Windblades rush to aid their trapped ally!','The Windblades rush to aid their trapped ally!',26124),
(64606,'enUS','Welcome, my young friend.','',26124),
(64607,'enUS','How did a tuskarr get to Pandaria?','How did a tuskarr get to Pandaria?',26124),
(64608,'enUS','The time has come, my $c friend, to talk of other things. Of crabs and seas and turtles with trees...','',26124),
(64609,'enUS','The time has come, my $r friend, to talk of other things. Of hozen and grummles and how my tummy rumbles...','',26124),
(64610,'enUS','The time has come, my little friend, to talk of other things. Of mogu and trolls and jinyu river tolls...','',26124),
(64611,'enUS','The time has come, my silly friend, to talk of other things. Of yetis and yaks and random shark attacks...','',26124),
(64612,'enUS','','Do not be alarmed, $n.$B$BI am projecting my dream self here in order to aid your efforts against the mogu.',26124),
(64613,'enUS','Beautiful, isn\'t she? Fished it up a few years go - it looks just like her... Ask me about it some time.','',26124),
(64614,'enUS','Nevermind.','Nevermind.',26124),
(64615,'enUS','','Hello, $r! What musical selection would you like to hear today?',26124),
(64616,'enUS','Tell me about the statue, Soggy.','Tell me about the statue, Soggy.',26124),
(64617,'enUS','Can you play me a song?','Can you play me a song?',26124),
(64618,'enUS','I\'d like to hear A Toast To You.','I\'d like to hear A Toast To You.',26124),
(64619,'enUS','I\'d like to hear Joyful Celebration.','I\'d like to hear Joyful Celebration.',26124),
(64620,'enUS','I\'d like to hear The Bamboo Wilds.','I\'d like to hear The Bamboo Wilds.',26124),
(64621,'enUS','I\'d like to hear The Song of Liu Lang.','I\'d like to hear The Song of Liu Lang.',26124),
(64622,'enUS','I\'d like to hear Liu Lang\'s Homecoming.','I\'d like to hear Liu Lang\'s Homecoming.',26124),
(64623,'enUS','I\'d like to hear The Temple of the Five Dawns.','I\'d like to hear The Temple of the Five Dawns.',26124),
(64624,'enUS','','I\'d like to hear PH The Rains of Castamere.',26124),
(64625,'enUS','Wind Lord Mel\'jarak senses that an ally is incapacitated and frees them!','',26124),
(64626,'enUS','Wind Lord Mel\'jarak senses more than 2 of his allies are incapacitated and frees them!','',26124),
(64627,'enUS','Got another one for ya!','',26124),
(64628,'enUS','Thanks, just put that anywhere.','',26124),
(64629,'enUS','You cleansed Gu Cloudstrike\'s soul, the Shado-Pan thank you.','',26124),
(64630,'enUS','Master Snowdrift speaks highly of how you can hold your own in a fight.','',26124),
(64631,'enUS','Lord Taran Tzu has travelled westward beyond the wall to hunt the Sha of Hatred. I hope the hunt goes well.','',26124),
(64632,'enUS','The Sha\'s hold over our people has been broken thanks to you. You have our thanks.','',26124),
(64633,'enUS','You have done the Shado-Pan a great service, $p.','You have done the Shado-Pan a great service, $p.',26124),
(64634,'enUS','','Greetings again, $c.  I\'ve been watching you.',26124),
(64635,'enUS','You showed great courage, $p. The Shado-Pan thanks you.','You showed great courage, $p. The Shado-Pan thanks you.',26124),
(64636,'enUS','Your martial skills are unparallelled. There is much I wish to learn from you.','Your martial skills are unparallelled. There is much I wish to learn from you.',26124),
(64637,'enUS','You truly are a master of martial fighting. You honor me with your presense.','You truly are a master of martial fighting. You honor me with your presense.',26124),
(64638,'enUS','','Shu is precious to us.  We need to find him, but he has the tendencies of a young child, so we must not scare him in our approach.$B$BI will meditate on where he might be, and how best to reach out to him.  Be patient, my friend.',26124),
(64639,'enUS','','Be patient with Shu. He acts as if a child, but he is quite ancient, and quite powerful.',26124),
(64640,'enUS','Apples, get yer fresh apples!','',26124),
(64641,'enUS','The biggest, juiciest, loveliest apples in the Valley! Get \'em right here!','',26124),
(64642,'enUS','Buy some apples! An apple a day keeps the priests away!','',26124),
(64643,'enUS','So, do you just want to... I don\'t know... Roll it away or something?','',26124),
(64644,'enUS','Wait... is it moving?','',26124),
(64645,'enUS','Well then.','',26124),
(64646,'enUS','I\'m guessing you know something about what just happened?','',26124),
(64647,'enUS','Actually, forget it - I don\'t want to know. I\'m going back to my lines.','',26124),
(64648,'enUS','Ya gonna bleed, mon.','',26124),
(64649,'enUS','Ya not be stoppin\' de Zandalari, mon.','',26124),
(64650,'enUS','Good. Ma raptor be hungry.','',26124),
(64651,'enUS','Ya be facin\' tha\' Zandalari now. Not some Darkspear traitor.','',26124),
(64652,'enUS','Ya messed with de wrong trolls.','',26124),
(64653,'enUS','Be careful de side you choose, bruddah.','',26124),
(64654,'enUS','We gonna burry ya here.','',26124),
(64655,'enUS','Zandalar gonna rise again.','',26124),
(64656,'enUS','Ya not be stoppin\' us, mon.','',26124),
(64657,'enUS','Have a taste of Zandalari magic!','',26124),
(64658,'enUS','Tremble, fools! The locust has awakened!','',26124),
(64659,'enUS','WHARRGARBL!!!','',26124),
(64660,'enUS','Ya gonna\' be my next trophy.','',26124),
(64661,'enUS','Zandalar gonna bring back de old ways.','',26124),
(64662,'enUS','Ya can\'t beat both de Zandalar an\' de mogu!','',26124),
(64663,'enUS','Ughh... <cough> The locust is fine! <cough> <cough>','',26124),
(64664,'enUS','The Klaxxi beckon...','',26124),
(64665,'enUS','','Fresh bread!',26124),
(64666,'enUS','','Looks like you can handle yourself in the water. Keep up the good work.',26124),
(64667,'enUS','','It\'s all about those Emperor Crabs. Sweet, blue gold is what they are.',26124),
(64668,'enUS','Wind Lord Mel\'jarak calls for reinforcements!','',26124),
(64669,'enUS','','We wrecked out here after Soggy took us way off course from our original charter. Thought he could pull a fast one on us. Hah!$B$BTruthfully, we\'re all glad he tried. Not one of us is an \"easy day\'s work\" kinda person.',26124),
(64670,'enUS','','Welcome to Halfhill Market, $r.',26124),
(64671,'enUS','','Welcome to Halfhill Market, where the prices are always fair!',26124),
(64672,'enUS','','Long time no see, $n. Welcome back.',26124),
(64673,'enUS','Can I get you something to drink, $r?','',26124),
(64674,'enUS','What would you like to drink today, $n?','',26124),
(64675,'enUS','Farming must build up a powerful thirst, eh $n?','',26124),
(64676,'enUS','I challenge you.','I challenge you.',26124),
(64677,'enUS','3... 2... 1... FIGHT!','',26124),
(64678,'enUS','The unthinkable has happened: Our siege on Theramore has failed.','',26124),
(64679,'enUS','','Noodles! I told you not to go heavy on the seasoning!',26124),
(64680,'enUS','','Whoa Noodles, what are you putting in the soup?',26124),
(64681,'enUS','','Mmmm, the soup tastes delicious. Good job, Noodles!',26124),
(64682,'enUS','So, are you ready to start? Let\'s see what you\'ve got.','',26124),
(64683,'enUS','Let\'s go!','Let\'s go!',26124),
(64684,'enUS','You\'re the contingency plan. Your mission is to infiltrate Theramore Isle.','',26124),
(64685,'enUS','','Welcome to my wall, $c.$B$BNow, let\'s kick some mantid butt!',26124),
(64686,'enUS','Ah, so very close. But you must remain CENTERED. Inner harmony is crucial to your survival on this land. Come, let us try again!','',26124),
(64687,'enUS','Keep the spark centered!','',26124),
(64688,'enUS','Don\'t get caught in the demolisher\'s sights.','',26124),
(64689,'enUS','There is a hozen on your face! Jump to shake it off!','',26124),
(64690,'enUS','Oh my! A new urgency has hardened your resolve. I suppose my work here is done.','',26124),
(64691,'enUS','Those who participate in the Brewmaster scenarios will earn valor. And if you find any rare items as you adventure with a Brewmaster, they are yours to keep!','',26124),
(64692,'enUS','The largest brewery in Pandaria is the Stormstout Brewery in the Valley of the Four Winds. You might start there if you\'re looking for adventure.$B$BBrewmasters are also wanderers by nature, and can be found roaming all over the land searching for rare ingredients or concocting new brews.$B$BSuch brewmasters are often found in unique scenarios.$B$BBrewmaster Tzu defends against enemies in the Greenstone Village scenario.$B$BBrewmaster Bo seeks tropical flavors in the Unga Ingoo scenario.$B$BBrewmaster Boof celebrates the season at The Brewmoon Festival scenario, and Brewmaster Blanche is cooking up something shocking in A Brewing Storm.','',26124),
(64693,'enUS','Are there rewards for helping brewmasters?','Are there rewards for helping brewmasters?',26124),
(64694,'enUS','Where can I find brewmasters that might need aid?','Where can I find brewmasters that might need aid?',26124),
(64695,'enUS','Which brewmaster would you like to aid today?','',26124),
(64696,'enUS','Queue for A Brewing Storm.','Queue for A Brewing Storm.',26124),
(64697,'enUS','Do you have everything? Very good! Come with me.','',26124),
(64698,'enUS','Queue for the Brewmoon Festival.','Queue for the Brewmoon Festival.',26124),
(64699,'enUS','In order for this dream brew to show you what you seek, you must reach a place of inner harmony. I can show you how.','',26124),
(64700,'enUS','Queue for Unga Ingoo.','Queue for Unga Ingoo.',26124),
(64701,'enUS','Queue for Greenstone Village.','Queue for Greenstone Village.',26124),
(64702,'enUS','Drink up to begin, friend.','',26124),
(64703,'enUS','Tell me more about Scenario: A Brewing Storm.','Tell me more about Scenario: A Brewing Storm.',26124),
(64704,'enUS','Tell me more about Scenario: Unga Ingoo.','Tell me more about Scenario: Unga Ingoo.',26124),
(64705,'enUS','Tell me more about Scenario: Brewmoon Festival.','Tell me more about Scenario: Brewmoon Festival.',26124),
(64706,'enUS','Tell me more about Scenario: Greenstone Village.','Tell me more about Scenario: Greenstone Village.',26124),
(64707,'enUS','Brewmaster Blanche is trying to make Boomer Brew in the middle of a storm, but some formidable enemies are getting in her way.','',26124),
(64708,'enUS','I will return to Klaxxi\'vess to meet with the council. Please take good care of Kovok.','',26124),
(64709,'enUS','Rescue Jungle Brew from the clutches of the evil hozen pirates of Unga Ingoo.','',26124),
(64710,'enUS','Let\'s see if you can back that talk up.','Let\'s see if you can back that talk up.',26124),
(64711,'enUS','Rescue the villagers of Greenstone from mischievious (and dangerous) forest denizens.','',26124),
(64712,'enUS','Brew something delicious and defend from yaungol attackers.','',26124),
(64713,'enUS','<Tenwu yawns.>\n\nI\'m waiting...','',26124),
(64714,'enUS','Get off me, insolent crabs!','',26124),
(64715,'enUS','Feed you to da crows!','Feed you to da crows!',26124),
(64716,'enUS','If I help the Anglers, what\'s in it for me?','If I help the Anglers, what\'s in it for me?',26124),
(64717,'enUS','Where can I find the Anglers?','Where can I find the Anglers?',26124),
(64718,'enUS','','The best fishing can be found down at the Anglers Wharf in southeastern Krasarang Wilds. Anyone is welcome to visit us and take up a fishing rod!',26124),
(64719,'enUS','','Whaddaya mean, what\'s in it for you? What kind of question is that?$B$BIsn\'t the joy of fishing The Big One out of the sea enough? What about feeling the sun on your neck and the saltwater spray of the ocean on your face? What about opening a cold brew while sitting back with your friends?$B$BThat ain\'t enough?!?$B$BLet me tell you, your future life as a $Gfisherman:fisherwoman; will be rewarding beyond compare!$B$BYou can improve your fishing skill for starters. Gain enough skill, and you can purchase powerful fishing rods.$B$BWell-respected fishermen can get access to a special fish pet, a water strider mount, and even your own personal fishing raft!',26124),
(64720,'enUS','VICTORY!','',26124),
(64721,'enUS','Greetings, $r.$B$BI can see from a glance that you are a great adventurer.$B$BAll across the land, there are dark crypts and vast palaces, all full of terrible and mighty enemies. They guard many secrets, but also... harbor great rewards.$B$BThe bravest of heroes may venture to attempt these encounters, but beware! You would be racing against time, as well as testing your skill against other heroes!$B$BAre you up for the challenge?','',26124),
(64722,'enUS','Oh, where should I begin!?$B$BFirst, the life of a farmer involves sowing seeds and harvesting crops. The crops that you sell can be used in cooking, sold on the auction house, traded to other buyers, or traded for meat and fish. I\'ve even heard of rare seeds that can be planted for unique items... perhaps even a little pet!$B$BThen there\'s all of Halfhill to explore! The best way to make friends with the locals is to give them gifts, and if you become friends, they might just give you some nice gifts in return.$B$BThere\'s always plenty to do around the fields, and an extra pair of hands would sure be appreciated.','',26124),
(64723,'enUS','Well, the Tillers won\'t be crowning you in jewels or building you up for war.$B$BNah, the life of a farmer is about somethin\' a little different.$B$BIf you stick with it, you might meet some real interesting folks. You\'ll be able to build up your own farm, plant your own crops, and enjoy the fruits of your own labor.$B$BSo if all that sounds interesting, then you should go to Halfhill and see for yourself!','',26124),
(64724,'enUS','Why should I help the Tillers?','Why should I help the Tillers?',26124),
(64725,'enUS','What kind of stuff can I do with the Tillers?','What kind of stuff can I do with the Tillers?',26124),
(64726,'enUS','The Order of the Cloud Serpent is sworn to defend the Jade Forest. We train at the Arboretum, just to the north of the Temple of the Jade Serpent in the Jade Forest.','',26124),
(64727,'enUS','There is no greater honor than rising through the ranks of the Order of the Cloud Serpent.$B$BOnce you have proven yourself, you will be free to wander the land with your serpent as your flying mount.$B$BYou will also earn the Cloud Serpent Riding skill, which will allow you to ride any cloud serpent mount from Pandaria.','',26124),
(64728,'enUS','Once you enter the Order of the Cloud Serpent, you will begin the journey of a serpent rider.$B$BYou will raise a baby serpent from the egg, train with it every day, and watch it grow to adulthood.','',26124),
(64729,'enUS','What does it mean to join the Order of the Cloud Serpent?','What does it mean to join the Order of the Cloud Serpent?',26124),
(64730,'enUS','What is the reward for rising through the Order of the Cloud Serpent?','What is the reward for rising through the Order of the Cloud Serpent?',26124),
(64731,'enUS','Fighting off that leviathan was fun, but I think I\'ve had enough adventure for a lifetime. Safe travels to you, $p. Stop by any time!','',26124),
(64732,'enUS','Mazu\'s been good to me. Her waters have sustained me and her winds have carried me to far off places. What better life could I have asked for?','',26124),
(64733,'enUS','','Need a little fortune in your favor, $r? Everyone needs a little luck to spruce things up!$B$BDon\'t worry, I can help tweak the odds in your favor!',26124),
(64734,'enUS','Yu\'lon, the Jade Serpent, keeps vigil over the east. Unfortunately, her temple has fallen to the sha of doubt.$B$BEven now, the temple needs our help. We must do everything we can to keep the sha at bay!','',26124),
(64735,'enUS','','Now THAT was a fine display of harpoonery!',26124),
(64736,'enUS','Xuen, the White Tiger, guards against the cold winds of the north.$B$BToday, he seeks to test the greatest champions of the land in a series of trials.$B$BIf you believe yourself worthy, travel north to the Temple of the White Tiger, and make your challenge!','',26124),
(64737,'enUS','Chi-Ji watches over the Temple of the Red Crane to the south.$B$BShe is trying to regain order after the sha eruption created chaos across the land.$B$BIf you wish to help her, travel to the Cradle of Chi-Ji in the Krasarang Wilds.','',26124),
(64738,'enUS','Niuzao, the Black Ox, stands firm against the enemies beyond the wall.$B$BHe desperately needs aid to fight off the encroaching mantid.$B$BIf you wish to help, travel west to the temple in the Townlong Steppes.','',26124),
(64739,'enUS','By defending the four temples, you will earn great standing with the August Celestials. You will be granted the ability to purchase items of great power.$B$BIn addition, you will help defend this land against some of our greatest enemies.','',26124),
(64740,'enUS','Why should I help the August Celestials?','Why should I help the August Celestials?',26124),
(64741,'enUS','How can I help the August Celestials today?','How can I help the August Celestials today?',26124),
(64742,'enUS','','The Vale of Eternal Blossoms is in great danger, $r.$B$BGarrosh Hellscream has tainted the waters of our sacred Vale with the Heart of Y\'Shaarj, a dark relic from an ancient evil. The effects of his act... well... you can see them for yourself here in the Vale.$B$BNow, remnants of the sha threaten our very existence. We have no choice but to fight.',26124),
(64743,'enUS','','The Vale of Eternal Blossoms is in great danger, $r.$B$BGarrosh Hellscream has tainted the waters of our sacred Vale with the Heart of Y\'Shaarj, a dark relic from an ancient evil. The effects of his act... well... you can see them for yourself here in the Vale.$B$BNow, remnants of the sha threaten our very existence. We have no choice but to fight.',26124),
(64744,'enUS','','Of course. It is only fair that we reward those who risk their lives for our cause.$B$BBy helping to defend the Vale, you will not only keep our borders safe, but you will also gain access to our vast stores of powerful treasures.',26124),
(64745,'enUS','Will I be rewarded for helping to defend the Vale?','Will I be rewarded for helping to defend the Vale?',26124),
(64746,'enUS','How can I help The Golden Lotus?','How can I help The Golden Lotus?',26124),
(64747,'enUS','Please fly me to Zan\'vess.','Please fly me to Zan\'vess.',26124),
(64748,'enUS','Please fly me to Kypari Zar.','Please fly me to Kypari Zar.',26124),
(64749,'enUS','There are a few ways to earn our esteem.$B$BWe are busy dealing with sha eruptions at Firebough Nook in Kun-Lai Summit. Help us there, and you will gain a foothold into our brotherhood.$B$BThe Shado-Pan Monastery is also in trouble. You may be able to assist our brothers and sisters there.$B$BThe Sha of Anger roams the fields of Kun-Lai to the north. Defeat it, and you will gain great respect from our order.$B$BA Shado-Pan contigent chases the Sha of Hatred in the Townlong Steppes. They may need help.$B$BIf you wish to earn our highest esteem, you must first prove yourself by earning revered standing with the Golden Lotus. Only then, speak to my brothers and sisters at Shado-Pan Garrison in the Townlong Steppes.','',26124),
(64750,'enUS','The Shado-Pan is an ancient order that accepts and trains only the most elite and worthy.$B$BShould you manage to make yourself useful, you may find many powerful items available to you.','',26124),
(64751,'enUS','Why should I help the Shado-Pan?','Why should I help the Shado-Pan?',26124),
(64752,'enUS','How can I help the Shado-Pan?','How can I help the Shado-Pan?',26124),
(64753,'enUS','The Lorewalkers travel the world, discovering new tales and retelling old ones.$B$BWe explore the rich history of the places and people in Pandaria.$B$BIf you would like to hear some of these stories for yourself, speak to Lorewalker Cho at the Seat of Knowledge, above the entrance to Mogu\'shan Palace here in the Vale of Eternal Blossoms.','',26124),
(64754,'enUS','The Lorewalkers will send you to explore significant areas of Pandaria to recover cultural artifacts.$B$BOnce you find all the artifacts that belong to a collection, you will be able to hear the entire story from start to finish.$B$BFind all the artifacts and collect all the books to become a Lorewalker!$B$BIf you would like to become a researcher, then you should speak to Lorewalker Cho at the Seat of Knowledge.','',26124),
(64755,'enUS','The journey is its own reward, young one. Seek pleasure in a story\'s telling, and you will come away with riches beyond compare.$B$BAh yes, and one more thing. Those who rise in the ranks of the Lorewalkers are granted a very special gift - the ability to ride upon the clouds.','The journey is its own reward, young one. Seek pleasure in a story\'s telling, and you will come away with riches beyond compare.$B$BAh yes, and one more thing. Those who rise in the ranks of the Lorewalkers are granted a very special gift - the ability to ride upon the clouds.',26124),
(64756,'enUS','Why should I help the Lorewalkers?','Why should I help the Lorewalkers?',26124),
(64757,'enUS','How can I help the Lorewalkers?','How can I help the Lorewalkers?',26124),
(64758,'enUS','','I have just returned from the wall.$B$BThere, I heard rumors of a faction called The Klaxxi from beyond the Serpent\'s Spine. Supposedly, they are a council of mantid elders who have split off from the Mantid Empire, and now work in direct defiance of the mantid queen.$B$BI have seen with my own eyes the power that these mantid wield.$B$BIf these rumors are true, then perhaps there is a way to ally with these... Klaxxi... and work with them to stop the mantid swarm.',26124),
(64759,'enUS','','It is a mystery to me, $r. If you want to find out, you are both crazy and foolish!$B$BBut I suppose there is no other way to meet the Klaxxi than to venture beyond the wall into the Dread Wastes.',26124),
(64760,'enUS','','I do not know, $r.$B$BWe know so little about the Klaxxi. They seem to be quite ruthless, so perhaps your only reward would be a swift death.$B$BThen again, their civilization is quite vast and advanced. If you play your cards right, perhaps they will grant you untold power.$B$BThere is only one way to find out.',26124),
(64761,'enUS','How will I be rewarded by helping the Klaxxi?','How will I be rewarded by helping the Klaxxi?',26124),
(64762,'enUS','How can I help the Klaxxi?','How can I help the Klaxxi?',26124),
(64763,'enUS','','The serpent is here!',26124),
(64764,'enUS','','Ji finished setting up the fireworks.  Use them to get it out of the sky.',26124),
(64765,'enUS','','You\'re quick on your feet.  Keep it up!',26124),
(64766,'enUS','','That\'s the way to do it!',26124),
(64767,'enUS','','You\'ve done it!  Now quickly, lets attack it while it\'s grounded.',26124),
(64768,'enUS','','It\'s down!  Let\'s finish it off.',26124),
(64769,'enUS','','Simply amazing!  You can fight by my side any day.',26124),
(64772,'enUS','I come with the yak. If a luckydo is wise enough to buy, I will be wise enough to sell my wares to them.','',26124),
(64773,'enUS','I make the luckydos luckier. Bring me an item and I will change its fortune to better serve your own... for a price.','',26124),
(64774,'enUS','We are sieging Niuzao Temple.$B$BYou are known to us, $n. Your help is necessary once more.','',26124),
(64775,'enUS','Have I got a yak for you!','',26124),
(64776,'enUS','Greetings, traveler.','',26124),
(64777,'enUS','What is the Vale of Eternal Blossoms?','What is the Vale of Eternal Blossoms?',26124),
(64778,'enUS','','We fight the mantid, yaungol, and mogu. Enemies face us from all sides.\n\nI\'m here to make sure there are no surprises.',26124),
(64779,'enUS','Arrrrrrrrrrrr... wikkets!','',26124),
(64780,'enUS','Avast... dookers!','',26124),
(64781,'enUS','Oh - of course you haven\'t heard of the Vale.$b$bTwelve thousand years ago, it was the seat of Mogu power, the heart of an empire. Legend tells of sacred pools in there, the source of Mogu magic that allowed them to twist and shape flesh. But they could also be used for healing miracles. That is, if you believe in the legends.$b$bAfter the pandaren revolution, the Celestials agreed to seal away the Vale, so that the power of the pools could never be used for mischief.','',26124),
(64782,'enUS','Heyarrrrrr!','',26124),
(64783,'enUS','I\'m gonna shiver your timbers!','',26124),
(64784,'enUS','You are what\'s on the menu!','',26124),
(64785,'enUS','Cooking time with Ookie!','',26124),
(64786,'enUS','Wikket stew, coming up!','',26124),
(64787,'enUS','Time to hozango!','',26124),
(64788,'enUS','Wikkets gonna get served!','',26124),
(64789,'enUS','Dance, wikkets! Dance!','',26124),
(64790,'enUS','Bam bam BOOM!','',26124),
(64791,'enUS','Ba-ba-ba-ba BAM!','',26124),
(64792,'enUS','Wikkets gonna get Ba-Bammed!','',26124),
(64793,'enUS','Got a present for you.','',26124),
(64794,'enUS','Say \"hello\" to \"goodbye\"!','',26124),
(64795,'enUS','Who is in the Vale now?','Who is in the Vale now?',26124),
(64796,'enUS','Your mind is plagued with |cFFFF0404|Hspell:124862|h[Visions of Demise]|h|r !','Your mind is plagued with |cFFFF0404|Hspell:124862|h[Visions of Demise]|h|r !',26124),
(64797,'enUS','Hardly anyone. It\'s guarded by a group called \"The Golden Lotus.\" Members of the Golden Lotus are hand-picked by the Celestials to maintain a vigil over the Vale, but few are chosen.$b$bI\'ve heard stories about the Vale since I was a cub. Can you believe such a place actually exists?$b$bDo you think the legends of the pools are true? I wish I could see for myself!','',26124),
(64798,'enUS','What in the world is that?','',26124),
(64799,'enUS','Oh! You\'re not gonna get my boy that easily.','',26124),
(64800,'enUS','Did you forget who you\'re messing with?!','',26124),
(64801,'enUS','Let me show you how a Nesingwary hunts!','',26124),
(64802,'enUS','Good, bad, I\'m the guy with the gun.','',26124),
(64803,'enUS','No one messes with MY boy!','',26124),
(64804,'enUS','Get that filthy thing out of my boy\'s head!','',26124),
(64805,'enUS','Watch out for those mists! That stuff looks poisonous.','',26124),
(64806,'enUS','That\'s a dark gloom to be sure. Be careful!','',26124),
(64807,'enUS','Do you know what that thing is?','',26124),
(64808,'enUS','Next time ya go hunting, cover that glowing eye of yours. It gives ya away.','',26124),
(64809,'enUS','Aim for the eye!','',26124),
(64810,'enUS','Don\'t stand in the fire ya git.','',26124),
(64811,'enUS','$p, over here near the end of the bridge.','',26124),
(64812,'enUS','Masterfully done.$B$BWe wouldn\'t have succeeded without you.','',26124),
(64813,'enUS','','By defending the four temples, you will earn great standing with the August Celestials. You will be granted the ability to purchase items of great power.$B$BIn addition, you will help defend this land against some of our greatest enemies.',26124),
(64814,'enUS','','Yu\'lon, the Jade Serpent, keeps vigil over the east. Unfortunately, her temple has fallen to the sha of doubt.$B$BEven now, the temple needs our help. We must do everything we can to keep the sha at bay!',26124),
(64815,'enUS','','Xuen, the White Tiger, guards against the cold winds of the north.$B$BToday, he seeks to test the greatest champions of the land in a series of trials.$B$BIf you believe yourself worthy, travel north to the Temple of the White Tiger, and make your challenge!',26124),
(64816,'enUS','','Chi-Ji watches over the Temple of the Red Crane to the south.$B$BShe is trying to regain order after the sha eruption created chaos across the land.$B$BIf you wish to help her, travel to the Cradle of Chi-Ji in the Krasarang Wilds.',26124),
(64817,'enUS','','Niuzao, the Black Ox, stands firm against the enemies beyond the wall.$B$BHe desperately needs aid to fight off the encroaching mantid.$B$BIf you wish to help, travel west to the temple in the Townlong Steppes.',26124),
(64818,'enUS','Of course. It is only fair that we reward those who risk their lives for our cause.$B$BBy helping to defend the Vale, you will not only keep our borders safe, but you will also gain access to our vast stores of powerful treasures.','',26124),
(64819,'enUS','The Vale of Eternal Blossoms is in great danger, $r.$B$BGarrosh Hellscream has tainted the waters of our sacred Vale with the Heart of Y\'Shaarj, a dark relic from an ancient evil. The effects of his act... well... you can see them for yourself here in the Vale.$B$BNow, remnants of the sha threaten our very existence. We have no choice but to fight.','',26124),
(64820,'enUS','There is nothing left to be done for the Vale at this time, $n. The mogu disappeared shortly after you killed their leader. We are safe, thanks to you.','',26124),
(64821,'enUS','','The Lorewalkers travel the world, discovering new tales and retelling old ones.$B$BWe explore the rich history of the places and people in Pandaria.$B$BIf you would like to hear some of these stories for yourself, speak to Lorewalker Cho at the Seat of Knowledge, above the entrance to Mogu\'shan Palace here in the Vale of Eternal Blossoms.',26124),
(64822,'enUS','','The Lorewalkers will send you to explore significant areas of Pandaria to recover cultural artifacts.$B$BOnce you find all the artifacts that belong to a collection, you will be able to hear the entire story from start to finish.$B$BFind all the artifacts and collect all the books to become a Lorewalker!$B$BIf you would like to become a researcher, then you should speak to Lorewalker Cho at the Seat of Knowledge.',26124),
(64823,'enUS','','The journey is its own reward, young one. Seek pleasure in a story\'s telling, and you will come away with riches beyond compare.$B$BAh yes, and one more thing. Those who rise in the ranks of the Lorewalkers are granted a very special gift - the ability to ride upon the clouds.',26124),
(64824,'enUS','The Shado-Pan is an ancient order that accepts and trains only the most elite and worthy.$B$BShould you manage to make yourself useful, you may find many powerful items available to you.','',26124),
(64825,'enUS','There are a few ways to earn our esteem.$B$BWe are busy dealing with sha eruptions at Firebough Nook in Kun-Lai Summit. Help us there, and you will gain a foothold into our brotherhood.$B$BThe Shado-Pan Monastery is also in trouble. You may be able to assist our brothers and sisters there.$B$BThe Sha of Anger roams the fields of Kun-Lai to the north. Defeat it, and you will gain great respect from our order.$B$BA Shado-Pan contigent chases the Sha of Hatred in the Townlong Steppes. They may need help.$B$BIf you wish to earn our highest esteem, you must first prove yourself by earning revered standing with the Golden Lotus. Only then, speak to my brothers and sisters at Shado-Pan Garrison in the Townlong Steppes.','',26124),
(64826,'enUS','Burn their ships. Butcher their flight master. Sabotage their war machines. And rescue our spy!','',26124),
(64827,'enUS','I have just returned from the wall.$B$BThere, I heard rumors of a faction called The Klaxxi from beyond the Serpent\'s Spine. Supposedly, they are a council of mantid elders who have split off from the Mantid Empire, and now work in direct defiance of the mantid queen.$B$BI have seen with my own eyes the power that these mantid wield.$B$BIf these rumors are true, then perhaps there is a way to ally with these... Klaxxi... and work with them to stop the mantid swarm.','',26124),
(64828,'enUS','It is a mystery to me, $r. If you want to find out, you are both crazy and foolish!$B$BBut I suppose there is no other way to meet the Klaxxi than to venture beyond the wall into the Dread Wastes.','',26124),
(64829,'enUS','I do not know, $r.$B$BWe know so little about the Klaxxi. They seem to be quite ruthless, so perhaps your only reward would be a swift death.$B$BThen again, their civilization is quite vast and advanced. If you play your cards right, perhaps they will grant you untold power.$B$BThere is only one way to find out.','',26124),
(64830,'enUS','Throw them into chaos while we regroup. The eyes of Hellscream are upon you!','',26124),
(64831,'enUS','Ji Firepaw warmly hugs you back.','',26124),
(64832,'enUS','','The Order of the Cloud Serpent is sworn to defend the Jade Forest. We train at the Arboretum, just to the north of the Temple of the Jade Serpent in the Jade Forest.',26124),
(64833,'enUS','','There is no greater honor than rising through the ranks of the Order of the Cloud Serpent.$B$BOnce you have proven yourself, you will be free to wander the land with your serpent as your flying mount.$B$BYou will also earn the Cloud Serpent Riding skill, which will allow you to ride any cloud serpent mount from Pandaria.',26124),
(64834,'enUS','','Once you enter the Order of the Cloud Serpent, you will begin the journey of a serpent rider.$B$BYou will raise a baby serpent from the egg, train with it every day, and watch it grow to adulthood.',26124),
(64835,'enUS','The keg bursts, dousing %s\'s flames!','',26124),
(64836,'enUS','Well, the Tillers won\'t be crowning you in jewels or building you for war.$B$BFarming is a little different.$B$BIt\'s a slower life, but a good one. You ask Dooka, Dooka knows!$B$BYou can build up your own farm, plant your own crops, and enjoy eating all the food you grow! That\'s Dooka\'s favorite part!$B$BSo if that sounds interesting, then you should go to Halfhill and see for yourself!','',26124),
(64837,'enUS','Oh, where does Dooka begin!?$B$BFirst, farmer sows seeds and harvests crops. Vegetables can be used in cooking, sold at market, traded to other buyers, and lots of other stuff. I\'ve even heard of rare seeds that can be planted for special items... like a little pet!$B$BThen there\'s everyone in Halfhill to meet! The people who live there are real interesting, even to a monkey like me. You give them gifts, make nice friends, and they might give you some nice gifts, too!$B$BAlways plenty to do around the fields!','',26124),
(64838,'enUS','The mantid artillery is here, you must hurry heroes!','',26124),
(64839,'enUS','The best fishing can be found down at the Anglers Wharf in southeastern Krasarang Wilds. Anyone is welcome to visit us and take up a fishing rod!','',26124),
(64840,'enUS','Whaddaya mean, what\'s in it for you? What kind of question is that?$B$BIsn\'t the joy of fishing The Big One out of the sea enough? What about feeling the sun on your neck and the saltwater spray of the ocean on your face? What about opening a cold brew while sitting back with your friends?$B$BThat ain\'t enough?!?$B$BLet me tell you, the life of a $Gfisherman:fisherwoman; is rewarding beyond compare!$B$BYou can improve your fishing skill for starters. There are Craftsmen Tokens to be earned for helping out the locals. Gain enough skill, and you can purchase powerful fishing rods.$B$BWell-respected fishermen can get access to a special fish pet and a water strider mount. There\'s even a fishing raft, for crying out loud!','',26124),
(64841,'enUS','','Those who participate in the Brewmaster scenarios will earn valor. And if you find any rare items as you adventure with a Brewmaster, they are yours to keep!',26124),
(64842,'enUS','','The largest brewery in Pandaria is the Stormstout Brewery in the Valley of the Four Winds. You might start there if you\'re looking for adventure.$B$BBrewmasters are also wanderers by nature, and can be found roaming all over the land searching for rare ingredients or concocting new brews.$B$BSuch brewmasters are often found in unique scenarios.$B$BBrewmaster Tzu defends against enemies in the Greenstone Village scenario.$B$BBrewmaster Bo seeks tropical flavors in the Unga Ingoo scenario.$B$BBrewmaster Boof celebrates the season at The Brewmoon Festival scenario, and Brewmaster Blanche is cooking up something shocking in A Brewing Storm.',26124),
(64843,'enUS','','Brewmaster Blanche is trying to make Boomer Brew in the middle of a storm, but some formidable enemies are getting in her way.',26124),
(64844,'enUS','','Rescue Jungle Brew from the clutches of the evil hozen pirates of Unga Ingoo.',26124),
(64845,'enUS','','Brew something delicious and defend from yaungol attackers.',26124),
(64846,'enUS','','Rescue the villagers of Greenstone from mischievious (and dangerous) forest denizens.',26124),
(64847,'enUS','','Which brewmaster would you like to aid today?',26124),
(64848,'enUS','','Thank Shen-zin Su that you\'re here.  I could use your help!',26124),
(64849,'enUS','','Get clear when it when it raises its weapon, it\'s even stronger than it looks.',26124),
(64850,'enUS','','It\'s calling allies!  I\'ll keep him busy while you handle them.',26124),
(64852,'enUS','','We\'re wearing him down.  Keep it up!',26124),
(64853,'enUS','','I don\'t know what I would have done without you.  It\'s good that you came.',26124),
(64855,'enUS','Shado-Pan Ice Archers appear on the rooftops!','',26124),
(64856,'enUS','We were fortunate enough to find the Vale after it opened its gates. We sought refuge, and have found safe haven.$B$BAre you lost? May I help you find something?','We were fortunate enough to find the Vale after it opened its gates. We sought refuge, and have found safe haven.$B$BAre you lost? May I help you find something?',26124),
(64857,'enUS','We were fortunate enough to find the Vale after it opened its gates. We sought refuge, and have found safe haven.$B$BAre you lost? May I help you find something?','We were fortunate enough to find the Vale after it opened its gates. We sought refuge, and have found safe haven.$B$BAre you lost? May I help you find something?',26124),
(64858,'enUS','','Couldn\'t have done that better myself.$B$BWell, probably not.',26124),
(64859,'enUS','The ships are aflame! Troops, to the harbor!','',26124),
(64860,'enUS','','$p, over here at the exit.',26124),
(64861,'enUS','The auction house is located on the second floor, on the left side of the building as you enter.$B$BI will mark the location on your map.','The auction house is located on the second floor, on the left side of the building as you enter.$B$BI will mark the location on your map.',26124),
(64862,'enUS','The bank is located on the second floor, on the right side of the building as you enter.$B$BI will mark the location on your map.','The bank is located on the second floor, on the right side of the building as you enter.$B$BI will mark the location on your map.',26124),
(64863,'enUS','The flight master is located out on the main terrace, at the top of the twin stairs and before you enter the main building.$B$BI will mark the location on your map.','The flight master is located out on the main terrace, at the top of the twin stairs and before you enter the main building.$B$BI will mark the location on your map.',26124),
(64864,'enUS','The inn is located on the main floor, to the right as you enter the building.$B$BI will mark the location on your map.','The inn is located on the main floor, to the right as you enter the building.$B$BI will mark the location on your map.',26124),
(64865,'enUS','Jaul Hsu, the stable master, can be found on the main terrace before you enter the main building. He stands next to the flight master.$B$BI will mark the location on your map.','Jaul Hsu, the stable master, can be found on the main terrace before you enter the main building. He stands next to the flight master.$B$BI will mark the location on your map.',26124),
(64866,'enUS','The ethereals set up shop in the upstairs corridor to the right as you enter the main building.$B$BI will mark the location on your map.','The ethereals set up shop in the upstairs corridor to the right as you enter the main building.$B$BI will mark the location on your map.',26124),
(64867,'enUS','Yanyra Moonfell peddles reagents and can be found in the crafter\'s hall, to the left as you enter the building.$B$BI will mark the location on your map.','Yanyra Moonfell peddles reagents and can be found in the crafter\'s hall, to the left as you enter the building.$B$BI will mark the location on your map.',26124),
(64868,'enUS','Raishen the Needle is well-known for her beautiful clothes.$B$BShe works in the crafter\'s hall, to the left as you enter the building.$B$BI will mark the location on your map.','Raishen the Needle is well-known for her beautiful clothes.$B$BShe works in the crafter\'s hall, to the left as you enter the building.$B$BI will mark the location on your map.',26124),
(64869,'enUS','Clara Henry carries enchanting supplies. She can be found in the crafter\'s hall, to the left as you enter the building.$B$BI will mark the location on your map.','Clara Henry carries enchanting supplies. She can be found in the crafter\'s hall, to the left as you enter the building.$B$BI will mark the location on your map.',26124),
(64870,'enUS','Ah, a scrollmaker! You\'ll be looking for inks and vellum, I suppose? They can be found in the crafter\'s hall, to the left as you enter the building.$B$BI will mark the location on your map.','Ah, a scrollmaker! You\'ll be looking for inks and vellum, I suppose? They can be found in the crafter\'s hall, to the left as you enter the building.$B$BI will mark the location on your map.',26124),
(64871,'enUS','Yes, there is a vendor of herbs in the city. Tommy Tinkerspade can be found in the crafter\'s hall, to the left as you enter the building.$B$BI will mark the location on your map.','Yes, there is a vendor of herbs in the city. Tommy Tinkerspade can be found in the crafter\'s hall, to the left as you enter the building.$B$BI will mark the location on your map.',26124),
(64872,'enUS','You are looking for the apothecary. He makes some truly wonderful potions and tinctures. Got rid of my rash in no time!$B$BAhem... Apothecary Greenmoss sells his wares in the crafter\'s hall. I will mark the location on your map.','You are looking for the apothecary. He makes some truly wonderful potions and tinctures. Got rid of my rash in no time!$B$BAhem... Apothecary Greenmoss sells his wares in the crafter\'s hall. I will mark the location on your map.',26124),
(64873,'enUS','Ready to cook up a hot meal? You can find everything you need from Jojo. She sells her wares in the crafter\'s hall.$B$BI will mark the location on your map.','Ready to cook up a hot meal? You can find everything you need from Jojo. She sells her wares in the crafter\'s hall.$B$BI will mark the location on your map.',26124),
(64874,'enUS','The blacksmiths all work in the crafter\'s hall, to the left as you enter the main building.$B$BI will mark the location on your map.','The blacksmiths all work in the crafter\'s hall, to the left as you enter the main building.$B$BI will mark the location on your map.',26124),
(64875,'enUS','You can purchase mining supplies in the crafter\'s hall, to the left as you enter the main building.$B$BI will mark the location on your map.','You can purchase mining supplies in the crafter\'s hall, to the left as you enter the main building.$B$BI will mark the location on your map.',26124),
(64876,'enUS','I seem to recall there is an engineer in the crafter\'s hall, to the left as you enter the main building.$B$BI will mark the location on your map.','I seem to recall there is an engineer in the crafter\'s hall, to the left as you enter the main building.$B$BI will mark the location on your map.',26124),
(64877,'enUS','Leatherworking and skins? You must be looking for a tanner. There\'s on in the crafter\'s hall, if I recall.$B$BI will mark the location on your map.','Leatherworking and skins? You must be looking for a tanner. There\'s on in the crafter\'s hall, if I recall.$B$BI will mark the location on your map.',26124),
(64878,'enUS','Oh, I hope the injury is not serious! The healers can be found inside the main hall, just to the left of the central stairs.$B$BI will mark the location on your map.','Oh, I hope the injury is not serious! The healers can be found inside the main hall, just to the left of the central stairs.$B$BI will mark the location on your map.',26124),
(64879,'enUS','Jewelcrafting? That\'s fine work, indeed. You can purchase supplies from Bero in the crafter\'s hall.$B$BI will mark the location on your map.','Jewelcrafting? That\'s fine work, indeed. You can purchase supplies from Bero in the crafter\'s hall.$B$BI will mark the location on your map.',26124),
(64880,'enUS','Are you looking for some food and drink? If so, then the Sway Dish Chef in the inn has exactly what you\'re looking for.$B$BI will mark the location on your map.','Are you looking for some food and drink? If so, then the Sway Dish Chef in the inn has exactly what you\'re looking for.$B$BI will mark the location on your map.',26124),
(64881,'enUS','Looking for some brew, eh? Well, there are two brewmasters who wander around the city selling their excellent ales.$B$BIf you don\'t run into them, then Hara Alebelly up at the Nightingale Lounge or Sarya Teaflower in the inn can fix you right up.','Looking for some brew, eh? Well, there are two brewmasters who wander around the city selling their excellent ales.$B$BIf you don\'t run into them, then Hara Alebelly up at the Nightingale Lounge or Sarya Teaflower in the inn can fix you right up.',26124),
(64882,'enUS','Itching for something sweet? You need to find Pink Peony.$B$BShe\'s usually wandering around the front terrace or the main hall of the shrine.','Itching for something sweet? You need to find Pink Peony.$B$BShe\'s usually wandering around the front terrace or the main hall of the shrine.',26124),
(64883,'enUS','The baker is usually wandering all around the shrine. He around the main hall or out on the terrace.','The baker is usually wandering all around the shrine. He around the main hall or out on the terrace.',26124),
(64884,'enUS','You need to speak to Michael Bedernik. He has an ample supply of meats.$B$BI\'ll mark his location on your map. Good luck!','You need to speak to Michael Bedernik. He has an ample supply of meats.$B$BI\'ll mark his location on your map. Good luck!',26124),
(64885,'enUS','Thinking about setting off a spark or two? I should go buy some fireworks myself! The vendor can be found out on the main terrace.$B$BI\'ll mark the location on your map.','Thinking about setting off a spark or two? I should go buy some fireworks myself! The vendor can be found out on the main terrace.$B$BI\'ll mark the location on your map.',26124),
(64886,'enUS','Great Tiger, the strangers from beyond the mists, they cannot be trusted. The wreckage in the Jade Forest can attest to this.','',26124),
(64887,'enUS','Even now an airship draws near; its arcane payload will flatten Theramore Isle and everyone still standing upon it.','',26124),
(64888,'enUS','...I\'ve seen them with my own eyes: Mogu legions, storming the Vale in force. We are not trained for mass combat!','',26124),
(64889,'enUS','Give us a chance to put things right.','',26124),
(64890,'enUS','There we go. Should you pass through Silvermoon City, come and say hello, hmmm? Al diel shala...','',26124),
(64892,'enUS','','Greetings, traveler. Welcome to The Golden Lantern!',26124),
(64893,'enUS','','Rest your weary feet, $r. Fine food and drink await you within.',26124),
(64894,'enUS','','Oh, you are looking too thin, $r. You must have something to eat. Sit and I will get you something.',26124),
(64895,'enUS','','Here at The Golden Lantern, the taps never empty and the barrels never stop rolling! What can I get for you?',26124),
(64896,'enUS','','Welcome to the Golden Lantern, the finest inn in the Vale. If anyone wants to argue with me, I will show them my fists.',26124),
(64897,'enUS','','I have the softest featherbeds you can find for a thousand miles. Would you like to try one?',26124),
(64898,'enUS','','Are you eating enough, $r? Please remember to take care of yourself.',26124),
(64899,'enUS','','My inn has all the comforts of home, and more. Please make yourself comfortable here.',26124),
(64900,'enUS','Tinctures, potions, draughts, and tonics!','',26124),
(64901,'enUS','Vials, get your vials here!','',26124),
(64902,'enUS','Hot, freshly baked bread!','',26124),
(64903,'enUS','You have been affected by |cFFFF0404|Hspell:123788|h[Cry of Terror]|h|r !','You have been affected by |cFFFF0404|Hspell:123788|h[Cry of Terror]|h|r !',26124),
(64904,'enUS','Hot from the oven, baked fresh! Get your bread!','',26124),
(64905,'enUS','','Flowers for sale, get your beautiful flowers!',26124),
(64906,'enUS','%s retreats to her chrysalis!','%s retreats to her chrysalis!',26124),
(64907,'enUS','%s emerges from her chrysalis!','%s emerges from her chrysalis!',26124),
(64908,'enUS','','Freshly picked flowers for sale!',26124),
(64909,'enUS','','Beautiful flowers for your loved ones! Get your flowers!',26124),
(64910,'enUS','','Get these rare blooms before they wilt! Flowers for sale!',26124),
(64911,'enUS','The Sha of Fear |cFFFF0404|Hspell:126121|h[Corrupts]|h|r a dissonance field!','The Sha of Fear |cFFFF0404|Hspell:126121|h[Corrupts]|h|r a dissonance field!',26124),
(64912,'enUS','That\'s a good girl, Saari.','',26124),
(64913,'enUS','What a good kitty you are.','',26124),
(64914,'enUS','Well, time for a stretch.','',26124),
(64915,'enUS','Saari! Go fetch!','',26124),
(64916,'enUS','Hehe, that\'s what I get for trying to get a cat to fetch.','',26124),
(64917,'enUS','I love my mommy and daddy.','',26124),
(64918,'enUS','Look at him! He\'s always a little crabby in the morning.','',26124),
(64919,'enUS','Woah, look at that! It\'s huge!','',26124),
(64920,'enUS','It\'s bigger than two houses!','',26124),
(64921,'enUS','Don\'t get too close, Maia! It\'s going to bite your head off!','',26124),
(64922,'enUS','','No it\'s not! Don\'t be stupid!',26124),
(64923,'enUS','','I want some candy!',26124),
(64924,'enUS','Don\'t touch the big tiger, Maia! It\'s going to eat you for dinner!','',26124),
(64925,'enUS','','Whoaaa.... big kitty!',26124),
(64926,'enUS','','Eeeeeeeeek!',26124),
(64927,'enUS','Aaaauuuuggghhhhh!','',26124),
(64928,'enUS','Don\'t worry, Maia, I\'ll protect you.','',26124),
(64929,'enUS','','It looks scaaaary.',26124),
(64930,'enUS','','Someday I\'m going to fly on one of those.',26124),
(64931,'enUS','Hey ma\'am, can you show us some fireworks?','',26124),
(64932,'enUS','','What does that lady do?',26124),
(64933,'enUS','','Does she really make fireworks?',26124),
(64934,'enUS','','Would you like to see some fireworks, little girl?',26124),
(64935,'enUS','','Wow! That\'s LOUD!',26124),
(64936,'enUS','Whooaaa! That looks cool!','',26124),
(64937,'enUS','','Connor, I\'m hungry.',26124),
(64938,'enUS','You just ate, silly. How can you be hungry again?','',26124),
(64939,'enUS','','I don\'t know... I just am!',26124),
(64940,'enUS','','Look at that one! He looks... weird.',26124),
(64941,'enUS','That\'s not nice Maia. Even if he does look weird, you shouldn\'t say it to his face.','',26124),
(64942,'enUS','','Oops... sorry.',26124),
(64943,'enUS','Let\'s play a game.','',26124),
(64944,'enUS','','I\'m bored!',26124),
(64945,'enUS','','Who is that?',26124),
(64946,'enUS','That\'s a jinyu.','',26124),
(64947,'enUS','','It looks like a big fish!',26124),
(64948,'enUS','','If he\'s a fish, how come he\'s not swimming in water?',26124),
(64949,'enUS','That\'s because jinyu are fish. Sort of.','',26124),
(64951,'enUS','I dunno. Maybe he\'s magical.','',26124),
(64953,'enUS','','Can we ride some kites, Connor?',26124),
(64954,'enUS','I guess so.','',26124),
(64955,'enUS','','This aberration destroyed... everything.  Everyone.',26124),
(64956,'enUS','','The Horde cannot be allowed to recover the Focusing Iris.  Eliminate what remains of their forces, and I will secure the artifact.',26124),
(64957,'enUS','','I must attune to the Focusing Iris before transport. Protect me!',26124),
(64958,'enUS','','Your people are despicable cowards, orc. You are nothing more than rabid dogs, and you will be put down!',26124),
(64959,'enUS','','You spit on mercy?  Then you will have NONE.  You want carnage?!  Garrosh will get more blood than EVER he bargained for!',26124),
(64960,'enUS','NO ONE CAN PROTECT YOU!  Kill the Proudmoore wench, and bring me that bomb.','',26124),
(64961,'enUS','Isn\'t she beautiful? Sigh...','',26124),
(64962,'enUS','Brave words, mage.  I\'ll SPIT in your FACE when you beg for mercy.','',26124),
(64963,'enUS','NRAAAH! I\'ll bring the Warchief your HEAD!','',26124),
(64964,'enUS','She\'s so smart and funny! I\'m head over heels for her.','',26124),
(64965,'enUS','How do I tell her how I really feel? Oh, I\'m not good with words!','',26124),
(64966,'enUS','Do you think she could ever have feelings for someone like me? I\'m so... unfurry!','',26124),
(64967,'enUS','I bet she likes her men hairy-chested. What am I supposed to do?','',26124),
(64968,'enUS','Do you think I should go to one of those monasteries and train to become a monk? You know, to impress her?','',26124),
(64969,'enUS','I don\'t have the big beer belly. I need a big beer belly. All right. I\'m workin\' on it!','',26124),
(64970,'enUS','I know she likes a man who can hold his liquor, so I\'ve been building up my tolerance by getting sloshed every night.','',26124),
(64971,'enUS','','Are all men this slow at asking women out?',26124),
(64972,'enUS','','I think he likes me, but I can\'t be sure. What do you think, $r?',26124),
(64973,'enUS','','Oh no, what if he thinks I\'m too furry? What if he doesn\'t like black and white women?',26124),
(64974,'enUS','','I\'m flirting as hard as I can, but I don\'t think he\'s getting the message!',26124),
(64975,'enUS','','He keeps talking about arclight spanners and overcharged capacitors. He sure knows to lead a girl on. Rawr!',26124),
(64976,'enUS','','I sure do like his pretty face.',26124),
(64977,'enUS','There are Alliance survivors!  Send... reinforcements...','',26124),
(64978,'enUS','[%s] confesses: I once took a bow that a hunter wanted.','[%s] confesses: I once took a bow that a hunter wanted.',26124),
(64979,'enUS','','See some armor you like, $r? These rare armor sets can only be obtained by proving your worth in the most challenging dungeons in Pandaria.$B$BYou must seek out these dungeons and enter them by foot. Those who pass the challenges with enough speed shall earn the regard of our master armorers, and may find a gift of rare armor awaiting them in the mail.',26124),
(64980,'enUS','Light be with you, $r.','',26124),
(64981,'enUS','The Prince of Stormwind is unguarded! Why don\'t we capture him for the Horde?','The Prince of Stormwind is unguarded! Why don\'t we capture him for the Horde?',26124),
(64982,'enUS','See some armor you like, $r? These rare armor sets can only be obtained by proving your worth in the most challenging dungeons in Pandaria.$B$BYou must seek out these dungeons and enter them by foot. Those who pass the challenges with enough speed shall earn the regard of our master armorers, and may find a gift of rare armor awaiting them in the mail.','',26124),
(64983,'enUS','Hah! Spoken like a true disciple of Garrosh Hellscream. Our \"Warchief\" would be proud.$b$bBut MY horde does not fight unarmed children. Nor would I dare bring our war to this sacred chamber, in the presence of an August Celestial himself.$b$bBesides, this little one has earned the friendship and trust of High Chieftain Baine Bloodhoof. For that reason, consider him under my protection.$b$bFor now.','',26124),
(64984,'enUS','I and my family fell victim to this place what seems like ages ago.$B$BLet our fate serve as a warning to those who would meddle in necromancy.$B$BHelp me to lift the curse, $c. Destroy Darkmaster Gandling.','',26124),
(64985,'enUS','The Vale of Eternal Blossoms.$b$bWho could have imagined the warchief was capable of destroying such a beautiful place.$b$bThe Golden Lotus feared that one day the mogu would retake this land, but it would seem they underestimated the depths of Garrosh\'s pride.','',26124),
(64986,'enUS','Oh, hello, $n.$b$bYour timing couldn\'t be better.','',26124),
(64987,'enUS','Our home is lost, but as long as we are still alive, there is still a home to be made... somewhere.','',26124),
(64988,'enUS','We live to fight another day, $r.','',26124),
(64989,'enUS','When we first arrived, we found a resplendent Vale. The water of its pools were like none other that we had ever seen.$B$BBut then came the one named Garrosh Hellscream, and he left only destruction in his wake. By the time he left, the waters of the Vale were no more.','',26124),
(64990,'enUS','What happened in the Jade Forest was a terrible tragedy. It is my firm belief that the only way to avoid repeating our mistakes, is by learning from them.$B$BThere is much knowledge in this library. Already I have learned much about the sha.','',26124),
(64991,'enUS','[%s] confesses: I have \"borrowed\" things from my guild bank.','[%s] confesses: I have \"borrowed\" things from my guild bank.',26124),
(64992,'enUS','Once, jinyu ruled all of Pandaria from this place, from this seat of power.$B$BWe must learn all that we can from the histories, so that we may once again regain our ancient wisdom.','',26124),
(64993,'enUS','Ever since I crash landed on this shore, I been wanderin\' all over, $r!$B$BI\'ve been all the way from the Temple o\' the Jade Serpent to the Krasarang coast to the top o\' Mount Neverest herself!$B$BThis land is quite remarkable, and I been cataloging all o\' my findings.$B$BI can\'t wait to tell my fellow colleagues at the Explorer\'s League about everything I\'ve seen!','',26124),
(64994,'enUS','You never know who can actually be trusted. Unless you\'re me; then you know.','',26124),
(64995,'enUS','The empress has spies everywhere.','',26124),
(64996,'enUS','Those who seek power through force will often find themselves alone in it.','',26124),
(64997,'enUS','The empress I served was also frightened and paranoid. Ultimately it was her fear that lead to her demise.','',26124),
(64998,'enUS','','I\'ve always had a good head for numbers!$B$BOnce the natives saw how fast I could add, subtract, and do differential equations in my head, they hired me on the spot!',26124),
(64999,'enUS','You must keep your mind strong to withstand the ever present whispers from the empress. Weaker minds will fall to her will without even noticing.','',26124),
(65000,'enUS','Now that I\'ve had my peek into the Vale, I gotta say, some o\' this place feels a bit... familiar.$B$BI know it don\'t look like it, but I can\'t shake that feeling. What do you think that means!?','',26124),
(65001,'enUS','Aren\'t they great? I\'m their number one fan!','',26124),
(65002,'enUS','','Welcome, $r! Stay and listen for a while.',26124),
(65003,'enUS','','Welcome to the Nightingale Lounge, $c. What can we play for you today?',26124),
(65004,'enUS','The knowledge in this library is astounding.','',26124),
(65005,'enUS','[%s] confesses: I always forget to gem my gear.','[%s] confesses: I always forget to gem my gear.',26124),
(65006,'enUS','[%s] confesses: I spent six months chasing the Time-Lost Proto-Drake.','[%s] confesses: I spent six months chasing the Time-Lost Proto-Drake.',26124),
(65007,'enUS','[%s] confesses: I went into Alterac Valley and didn\'t help my team at all.','[%s] confesses: I went into Alterac Valley and didn\'t help my team at all.',26124),
(65008,'enUS','[%s] confesses: I died to an elevator once. Maybe more than once.','[%s] confesses: I died to an elevator once. Maybe more than once.',26124),
(65009,'enUS','[%s] confesses: I never use the Lightwell.','[%s] confesses: I never use the Lightwell.',26124),
(65010,'enUS','[%s] confesses: I always wanted to be a paladin.','[%s] confesses: I always wanted to be a paladin.',26124),
(65011,'enUS','[%s] confesses: Troll toes sort of creep me out.','[%s] confesses: Troll toes sort of creep me out.',26124),
(65012,'enUS','[%s] confesses: I have stood in the fire.','[%s] confesses: I have stood in the fire.',26124),
(65013,'enUS','[%s] confesses: I told my raid leader that I was ready, but I wasn\'t really ready.','[%s] confesses: I told my raid leader that I was ready, but I wasn\'t really ready.',26124),
(65014,'enUS','[%s] confesses: I fell off of Dalaran.','[%s] confesses: I fell off of Dalaran.',26124),
(65015,'enUS','There is a battle trainer by the name of Sara Finkleswitch who trains her pets out on the main terrace.$B$BI will mark the location on your map.','There is a battle trainer by the name of Sara Finkleswitch who trains her pets out on the main terrace.$B$BI will mark the location on your map.',26124),
(65016,'enUS','[%s] confesses: I asked a friend for gold to buy my first mount.','[%s] confesses: I asked a friend for gold to buy my first mount.',26124),
(65017,'enUS','Yes, there is a fishing supplies vendor downstairs, on the first level of The Summer Terrace.$B$BI will mark the location on your map.','Yes, there is a fishing supplies vendor downstairs, on the first level of The Summer Terrace.$B$BI will mark the location on your map.',26124),
(65018,'enUS','[%s] confesses: I said I had been in the dungeon before, but I had no idea what I was doing. It was embarassing.','[%s] confesses: I said I had been in the dungeon before, but I had no idea what I was doing. It was embarassing.',26124),
(65019,'enUS','[%s] confesses: I once punched a gnome. No reason. I was just having a bad day.','[%s] confesses: I once punched a gnome. No reason. I was just having a bad day.',26124),
(65020,'enUS','[%s] confesses: I outbid a friend on an auction for something I didn\'t really want.','[%s] confesses: I outbid a friend on an auction for something I didn\'t really want.',26124),
(65021,'enUS','[%s] confesses: I go into dungeons not to make Azeroth a better place, but just for loot.','[%s] confesses: I go into dungeons not to make Azeroth a better place, but just for loot.',26124),
(65022,'enUS','[%s] confesses: I wasn\'t really at the opening of Ahn\'Qiraj. I just read about it.','[%s] confesses: I wasn\'t really at the opening of Ahn\'Qiraj. I just read about it.',26124),
(65023,'enUS','[%s] confesses: I don\'t really have a clue who the Sin\'dorei are.','[%s] confesses: I don\'t really have a clue who the Sin\'dorei are.',26124),
(65024,'enUS','[%s] confesses: I don\'t treat all of my mounts equally.','[%s] confesses: I don\'t treat all of my mounts equally.',26124),
(65025,'enUS','[%s] confesses: I dabble in archaeology, but I\'m just not that interested in history.','[%s] confesses: I dabble in archaeology, but I\'m just not that interested in history.',26124),
(65026,'enUS','[%s] confesses: The draenei laugh really annoys me.','[%s] confesses: The draenei laugh really annoys me.',26124),
(65027,'enUS','[%s] confesses: I haven\'t been in a barber shop in months. Goblins with scissors. Shudder.','[%s] confesses: I haven\'t been in a barber shop in months. Goblins with scissors. Shudder.',26124),
(65028,'enUS','[%s] confesses: I thought pandaren were a type of furbolg.','[%s] confesses: I thought pandaren were a type of furbolg.',26124),
(65029,'enUS','[%s] confesses: Oh, I took the candle.','[%s] confesses: Oh, I took the candle.',26124),
(65030,'enUS','[%s] confesses: This is just a setback.','[%s] confesses: This is just a setback.',26124),
(65031,'enUS','[%s] confesses: I light things on fire and yell BY FIRE BE PURGED when nobody is looking.','[%s] confesses: I light things on fire and yell BY FIRE BE PURGED when nobody is looking.',26124),
(65032,'enUS','[%s] confesses: I don\'t really remember you in the mountains.','[%s] confesses: I don\'t really remember you in the mountains.',26124),
(65033,'enUS','[%s] confesses: I sometimes forget if Northrend is north or south of here.','[%s] confesses: I sometimes forget if Northrend is north or south of here.',26124),
(65034,'enUS','[%s] confesses: I find all these names with so many apostrophes so confusing.','[%s] confesses: I find all these names with so many apostrophes so confusing.',26124),
(65035,'enUS','[%s] confesses: I forgot the Sunwell.','[%s] confesses: I forgot the Sunwell.',26124),
(65036,'enUS','[%s] confesses: I really wasn\'t prepared. Who knew?','[%s] confesses: I really wasn\'t prepared. Who knew?',26124),
(65037,'enUS','[%s] confesses: I sometimes wonder if tauren taste like... you know.','[%s] confesses: I sometimes wonder if tauren taste like... you know.',26124),
(65038,'enUS','[%s] confesses: I ask for the Light to give me strength, but I\'m not sure if it really does.','[%s] confesses: I ask for the Light to give me strength, but I\'m not sure if it really does.',26124),
(65039,'enUS','[%s] confesses: I sometimes use my mount to travel really short distances. I mean REALLY short.','[%s] confesses: I sometimes use my mount to travel really short distances. I mean REALLY short.',26124),
(65040,'enUS','[%s] confesses: I don\'t know if Milhouse is a good guy or not.','[%s] confesses: I don\'t know if Milhouse is a good guy or not.',26124),
(65041,'enUS','[%s] confesses: I know he\'s a jerk, but there\'s something about Garrosh....','[%s] confesses: I know he\'s a jerk, but there\'s something about Garrosh....',26124),
(65042,'enUS','[%s] confesses: I saw a mage cast a spell once and my jaw really did drop at the damage.','[%s] confesses: I saw a mage cast a spell once and my jaw really did drop at the damage.',26124),
(65043,'enUS','','We were drawn here by visions of this place. But even the visions pale in comparison to the Vale\'s beauty.',26124),
(65044,'enUS','[%s] confesses: For a long time, I thought the plural of anecdote WAS data.','[%s] confesses: For a long time, I thought the plural of anecdote WAS data.',26124),
(65045,'enUS','[%s] confesses: Sometimes I ask for a warlock to summon me when I\'m really not that far away.','[%s] confesses: Sometimes I ask for a warlock to summon me when I\'m really not that far away.',26124),
(65046,'enUS','[%s] confesses: Sometimes when I\'m questing, I want to be alone, so I pretend I can\'t hear my friends.','[%s] confesses: Sometimes when I\'m questing, I want to be alone, so I pretend I can\'t hear my friends.',26124),
(65047,'enUS','It was a long journey to get here. And we lost so many along the way.$b$bYet... look at this place. Astounding!','It was a long journey to get here. And we lost so many along the way.$b$bYet... look at this place. Astounding!',26124),
(65048,'enUS','','Care for a bite to eat, traveler?',26124),
(65049,'enUS','','Food and drink for sale!',26124),
(65050,'enUS','','Fixing for a snack, $r?',26124),
(65051,'enUS','Thank you for opening the gates for us, $p. You honor us with your presence.','Thank you for opening the gates for us, $p. You honor us with your presence.',26124),
(65052,'enUS','The Alliance followed us here. Even in this serene place, I smell war on the wind.','The Alliance followed us here. Even in this serene place, I smell war on the wind.',26124),
(65053,'enUS','The mogu, the mantid, and the Alliance all threaten the safety of this ancient place. We must protect it, at all costs.','The mogu, the mantid, and the Alliance all threaten the safety of this ancient place. We must protect it, at all costs.',26124),
(65054,'enUS','','We lost our home to the yaungol. But this place... this place offers us a new beginning.',26124),
(65055,'enUS','I thought all was lost when the yaungol attacked our home. It is cliche, but the old monks are right when they say: \"When one door shuts, another opens.\"$b$bOr something like that. Wasn\'t too big on their teachings.','',26124),
(65056,'enUS','Can we go see the serpents?','',26124),
(65057,'enUS','Not today, little one. We have errands to run.','',26124),
(65058,'enUS','Can we see the tauren? They look like yaungols.','',26124),
(65059,'enUS','Can we go see the undead lady? She looks funny.','',26124),
(65060,'enUS','Can we go play with the goblins? I\'m taller than them!','',26124),
(65061,'enUS','When can we go home?','',26124),
(65062,'enUS','I miss my toys. Can we go home?','',26124),
(65063,'enUS','Can we go back to Kun-Lai? The air smells funny here.','',26124),
(65064,'enUS','','I\'m sorry, but we need to stay here for a little while. The Horde is keeping us safe.',26124),
(65065,'enUS','','Hi! Would you like to battle my pets?',26124),
(65066,'enUS','','Greetings, $r. I may be small, but size doesn\'t matter in a pet battle!',26124),
(65067,'enUS','','Hi $c! Don\'t you think my pets are adorable?',26124),
(65068,'enUS','','Hello, my dear. Have you been out in the fields?',26124),
(65069,'enUS','','Is there anything I can get you?',26124),
(65070,'enUS','','A hoe is an honest $Gman\'s:woman\'s; weapon.',26124),
(65071,'enUS','','Why hello, $n. I know everything that happens around The Heartland, my dear. You don\'t get to be my age without making a few loose-lipped friends.',26124),
(65072,'enUS','Here we go. Do try to keep yourselves alive until the end.','',26124),
(65073,'enUS','|TInterface\\Icons\\spell_shadow_corpseexplode.blp:20|t %s ate too much and begins to |cFFFF0000|Hspell:126126|h[Upchuck]|h|r!','',26124),
(65074,'enUS','We\'re coming for you, Chillheart! Time for payback!','',26124),
(65075,'enUS','|TInterface\\Icons\\inv_misc_monsterfang_02.blp:20|t %s traps his prey in his |cFFFF0000|Hspell:126187|h[Vice Jaws]|h|r! Kill him!','',26124),
(65076,'enUS','A man must honor his family.','',26124),
(65077,'enUS','The Talking Skull cackles gleefully as the instructor\'s soul is destroyed.','',26124),
(65078,'enUS','The Talking Skull seems hesitant to enter the hall, but proceeds with you nonetheless.','',26124),
(65079,'enUS','What does an out-numbered army eat for a snack?$B$B...$B$BRetreats!','',26124),
(65080,'enUS','I\'m no healer, but I\'m priest to meet you!','',26124),
(65081,'enUS','Don\'t ask me how to fight a warlock. I a-VOID them. Hahahaha!','',26124),
(65082,'enUS','Why was the tank nervous before the fight?$B$B...$B$BBecause he was a worrier!','',26124),
(65083,'enUS','What would happen if King Varian became corrupted?$B$B...$B$BI don\'t know, but it would be pretty SHA-king!','',26124),
(65084,'enUS','...hic...!$B$B...what is a... what is a \"gus\"...?','',26124),
(65085,'enUS','I can\'t bear to watch.','',26124),
(65086,'enUS','The Talking Skull proceeds into the next chamber without saying a word.','',26124),
(65087,'enUS','Ah, if it isn\'t my favorite master assassin! I was hoping I would find you here in Pandaria.','',26124),
(65088,'enUS','Very good. Let\'s talk.','',26124),
(65089,'enUS','Tong! Drinks, please.','',26124),
(65090,'enUS','My father, Deathwing, tried to destroy the whole of Azeroth.','',26124),
(65091,'enUS','He was misguided, of course, but he was right about one thing: Our world is... so fragile.','',26124),
(65092,'enUS','We are a point of light in a universe of shadow. A candle in a tempest.','',26124),
(65093,'enUS','Sometimes I think it was the very precariousness of our world that drove my father to madness.','',26124),
(65094,'enUS','Ah, thank you Tong.','',26124),
(65095,'enUS','Now, to my point: I believe we are headed towards a reckoning. And no, I am not talking about the current conflict between the Alliance and the Horde.','',26124),
(65096,'enUS','Believe me - what Garrosh Hellscream achieved in Theramore is nothing compared to the horrors that are even now bearing down on our fragile home.','',26124),
(65097,'enUS','But the war deeply troubles me. Do you see my concern?','',26124),
(65098,'enUS','A divided Azeroth cannot possibly stand against the darkness.','',26124),
(65099,'enUS','This war has to end. Soon. Before it consumes our strength!','',26124),
(65100,'enUS','I want you to know that your Alliance has my full and unwavering support in this campaign.','',26124),
(65101,'enUS','You can rest assured that my loyalties lie with your Horde.','',26124),
(65102,'enUS','How do we bring a swift and decisive end to the conflict? I believe the answer lies with heroes like you.','',26124),
(65103,'enUS','We must ensure that you are up to the task... and then equip you accordingly.','',26124),
(65104,'enUS','Try to stay alive! We are only just beginning our legendary journey.','',26124),
(65105,'enUS','Ahh! So returns my conquering hero.','',26124),
(65106,'enUS','The Terrace is just up the hill here. Stay on your guard; few visitors have returned.','',26124),
(65107,'enUS','You are looking pale, my friend! I trust you have not allowed fear to get the better of you?','',26124),
(65108,'enUS','Allow me to gather up my things, and I will meet you there.','',26124),
(65109,'enUS','I often venture out here to think. The view is breathtaking, would you agree?','',26124),
(65110,'enUS','Pandaria is indeed a jewel. Such beauty. It makes you want to protect her, yes?','',26124),
(65111,'enUS','I feel the same way about Azeroth herself.','',26124),
(65112,'enUS','You have done great things, friend. I can assure you this is but the beginning of our work together.','',26124),
(65113,'enUS','Behold: The power of the foes you\'ve vanquished.','',26124),
(65114,'enUS','And the wisdom of those you\'ve outsmarted.','',26124),
(65115,'enUS','Here! The embodiment of the fear that you\'ve conquered. May it now strike terror into the hearts of your enemies!','',26124),
(65116,'enUS','Finally, a gift from me. Make no mistake: the Black Dragonflight lives on!','',26124),
(65117,'enUS','There. My work is done. You can now greatly augment the power of any sha-touched weapon.','',26124),
(65118,'enUS','We are just getting started, friend! Our greatest challenges lie ahead.','',26124),
(65119,'enUS','But when war comes to these shores, you and I will be ready for it!','',26124),
(65120,'enUS','It is very good to see you again, $n! I trust the weapons I gave you at Ravenholdt have served you well?$b$bI have another \"assignment\" for you here in Pandaria. This will again require all of your skills, and again I assure you... it will be worth it!$b$bBefore we begin, it\'s important that you familiarize yourself with the lay of the land. Come visit me once you have earned more experience here.','',26124),
(65121,'enUS','Hello again. $n, was it? Yes yes... I believe we left behind some unfinished business back in the Eastern Kingdoms. How have you been finding Pandaria?$b$bI have another assignment for you, if you are up to the challenge this time. I assure you the rewards will be worth it.$b$bBefore we begin, it\'s important that you familiarize yourself with the lay of the land. Come visit me once you have earned more experience here.','',26124),
(65122,'enUS','<The Black Prince looks you up and down.>$b$bIt is very good to meet you, $c. You are one of the vanguard, it would seem - an explorer in a strange new land. And how have you been finding the mysterious continent of Pandaria?$b$bYou have the look of someone who gets things done. I want you to return to me once you\'ve gotten the lay of the land.$b$bI will be right here.','',26124),
(65123,'enUS','I have chosen the name \"Wrathion.\" To my knowledge, I am the last of the black dragons.$b$bMy father was Deathwing, the Worldbreaker, the Aspect of Death, the Destroyer... But I hope you will not hold that against me.$b$bI have no love for my father, whose corruption destroyed my race, or for the red dragonflight, who stole away and experimented on my egg to create me.$b$bLet\'s just say, I am... unaffiliated. And I am always on the lookout for like-minded heroes.','',26124),
(65124,'enUS','Who are you?','Who are you?',26124),
(65125,'enUS','What are you doing in Pandaria?','What are you doing in Pandaria?',26124),
(65126,'enUS','Certainly I\'m allowed to have SOME secrets. Wouldn\'t you agree, $n?$b$bI arrived shortly after the mists collapsed - I was able to fly here after my Ravenholdt colleagues learned of a naval battle off of these shores.$b$bThis land has been hidden for ten thousand years. I\'ve only just begun to plumb its depths!','',26124),
(65127,'enUS','I am glad you have returned, $n! I trust you are now acclimated to this strange new continent of Pandaria?$b$bYou have already proven yourself to me in the past, so we can dispense with any sort of tests or trials. Let\'s get right to it.$b$bAre you ready to change the world?','',26124),
(65128,'enUS','Welcome, $c! My contacts throughout Pandaria tell me that you have been quite busy here. I admire mortals with your... \'initiative.\'$b$bHistory finds us at a turning point. If you are prepared to meet destiny with me head on, I will ensure that you are richly rewarded for your efforts.','',26124),
(65129,'enUS','We are just beginning our pandaren campaign, $n.','',26124),
(65130,'enUS','','I believe we may have finally found my father\'s Pools of Youth. We must gather as much information as we can for Tyrande.',26124),
(65131,'enUS','','My sentinels have faced many dangers since we came to this new land. We are ready for whatever the future has to offer.',26124),
(65132,'enUS','','My squad\'s morale has improved since we entered the Vale.',26124),
(65133,'enUS','','This Vale is truly a paradise.',26124),
(65134,'enUS','','It was my father\'s dream to see this place. I must carry out his wishes in his place.',26124),
(65135,'enUS','An ill-wind blows from the southern shores. Are you ready?','',26124),
(65136,'enUS','','We will rest here in the Vale until we have gathered our research. Then, we must find a way home.',26124),
(65137,'enUS','There is some kind of barrier that shields this Vale, preventing my use of portal magic.','',26124),
(65138,'enUS','','Us meeting in this Vale is more than just random chance.',26124),
(65139,'enUS','','Garrosh\'s pride has destroyed the Vale. What was will never be restored.',26124),
(65140,'enUS','','Tyrande sent us here as a vanguard for the Light.',26124),
(65141,'enUS','','The trees here are more beautiful than even the ones in the southern jungle.',26124),
(65142,'enUS','','Never in my ranging have I seen a place like this.',26124),
(65143,'enUS','','Could the waters of this vale be the fabled \"Pools of Youth?\" Perhaps immortality is within our grasp once again...',26124),
(65144,'enUS','','We have heard reports of mogu infiltrating this valley. They will not get beyond us.',26124),
(65145,'enUS','','While we research the pools, we will patrol the city\'s borders and protect these people.',26124),
(65146,'enUS','','To be honest, I did not believe the truth of Vaeldrin\'s visions at first. But this place radiates an unusual magic - could these be the fabled \"Pools of Youth?\"',26124),
(65147,'enUS','If you have the time, you should visit Binan\'s famous Brewmoon Festival. I will be brewing some of my famous Kun-Lai Kicker Brew.','',26124),
(65148,'enUS','Legends tell of a great battle that took place in this very vale, turning the golden fields to crimson with the blood of many brave monks. The armies of Lei Shen the Thunder King, emperor of the mogu, fought brutally, but were eventually overcome.','',26124),
(65149,'enUS','Die, Gandling! Kill him!','',26124),
(65150,'enUS','Two hundred ships at my disposal, yet the one carrying my SON goes missing!','',26124),
(65151,'enUS','I am sorry, but I cannot go back just yet.','',26124),
(65152,'enUS','I\'ve decided to search for the Vale... Vale... Vale...','',26124),
(65153,'enUS','STORM the shores, and PAINT THIS NEW CONTINENT RED!!','',26124),
(65154,'enUS','|TInterface\\Icons\\ability_warlock_improvedsoulleech:20|tYou are afflicted by |cFFFF0000|Hspell:126228|h[Severed Soul]|h|r! Kill it!','',26124),
(65155,'enUS','For days following the fall of Lei Shen, the vale was shrouded in a cloud of the deepest black. Summoned by Lei Shen in his final moments, the otherworldly storm blanketed the vale with rainfall and struck jagged spears of lightning into the hills.','',26124),
(65156,'enUS','The blood of the fallen was washed away by the storm and carried to Whitepetal Lake, turning the waters a deep red. With its final breath, the storm struck the center of the lake, igniting the very water itself.  The lake burned with a crimson hue for many days.','',26124),
(65157,'enUS','When the blaze subsided, a cloud serpent hatching could be seen flying around the center of the lake. Its scales sparked with storm and fire, and where it flew, great clouds formed in the sky. My people named it Alani, the Stormborn.','',26124),
(65158,'enUS','They say that Alani can only see the flash of the greatest lightning, and may only hear the echo of the greatest thunder. Should you wish to get her attention, you will need to harness the very essence of the sky that spawned her.','',26124),
(65159,'enUS','And THEN what happened?','And THEN what happened?',26124),
(65160,'enUS','Greetings, friend! I do not get many visitors up here, do you wish to hear a tale of the Vale of Eternal Blossoms?','',26124),
(65161,'enUS','I do!','I do!',26124),
(65162,'enUS','That makes sense!','That makes sense!',26124),
(65164,'enUS','Silly wikket! Brew is for hozen!','',26124),
(65165,'enUS','Brew run!','',26124),
(65166,'enUS','No brew for you!','',26124),
(65167,'enUS','Heyarrrrrrrr!','',26124),
(65168,'enUS','The ancient vaults of the mogu, untouched by time for thousands of years, who knows what secrets await?','',26124),
(65169,'enUS','All for one! And one for Ook!','',26124),
(65170,'enUS','Many young Pandaren warriors have vanished into this...tomb. Have your wits about you.','',26124),
(65171,'enUS','The mogu held considerable power over the stones of the earth. Their magic lingers on, even centuries later.','',26124),
(65172,'enUS','The large Quilen seem to be guarding that door. Tread carefully, lest you wake them.','',26124),
(65173,'enUS','That was close!','',26124),
(65174,'enUS','The door mechanism seems to have activated with the demise of the guardians. I fear what we may find within.','',26124),
(65175,'enUS','We seem to have awakened a spirit of some kind.','',26124),
(65176,'enUS','So the stories were true...','',26124),
(65177,'enUS','We have disturbed what should not have been disturbed. He cannot be free to escape this prison! You must destroy him!','',26124),
(65178,'enUS','Feng the Accursed was betrayed by four emperors of the mogu, his body destroyed each time, only to rise again.','',26124),
(65179,'enUS','Hozekateers! Assemble!','',26124),
(65180,'enUS','This is not the last we have seen of Feng...','',26124),
(65181,'enUS','The Zandalari, ancient allies of the mogu! They must seek the legendary weapon within the depths of the Vaults!','',26124),
(65182,'enUS','Wikkets!','',26124),
(65183,'enUS','Party crashers!','',26124),
(65184,'enUS','Heyarrrr!','',26124),
(65185,'enUS','You no take brew!','',26124),
(65186,'enUS','Take their nibs!','',26124),
(65187,'enUS','For Captain Ook!','',26124),
(65188,'enUS','I am sorry I did not tell you earlier! These vaults house a weapon of unimaginable power! Stop them!','',26124),
(65189,'enUS','I will stay behind and investigate this dais further...','',26124),
(65190,'enUS','A secret passage has opened beneath the platform, this way!','',26124),
(65191,'enUS','Look at the dust along the floor, these dark halls have not seen footfalls for many centuries.','',26124),
(65192,'enUS','Once, the mogu enslaved all of the races of Pandaria, and bent them to their nefarious will.','',26124),
(65193,'enUS','These Jinyu have been locked in an eternity of servitude.','',26124),
(65194,'enUS','I hear a faint humming. It is coming from this direction!','',26124),
(65195,'enUS','It is done, then. Yet...how many of these machines are hidden beneath the earth? How much do we not know about the dark secrets of the mogu?','',26124),
(65196,'enUS','I fear that our war against our ancient enemies is still far from over.','',26124),
(65197,'enUS','Astounding! An actual, functional Mogu construct machine.','',26124),
(65198,'enUS','We cannot allow this to fall into the wrong hands.','',26124),
(65199,'enUS','An endless army of soulless abominations...I shudder to think of the violence that would erupt from such a machine.','',26124),
(65200,'enUS','You must destroy it. Here, now, before any harm can come to Pandaria.','',26124),
(65201,'enUS','Turn the machine on, I will lock the door behind you.','',26124),
(65202,'enUS','May the great crane guide your steps.','',26124),
(65203,'enUS','NO! Get back here coward!','',26124),
(65204,'enUS','There are many wonderful poisons, Wakener. Some can boil you alive. Some will eat your flesh. Some burst you open from the inside.$B$BSo many wonderful varieties.','',26124),
(65205,'enUS','Quickly, destroy that thing. We have to catch Gandling!','',26124),
(65206,'enUS','Have you ever tried drinking poison, Wakener? You must start with something very mild, only a few drops at first.$B$BYou will likely become violently ill. Perhaps you will even lose an antennae or two.$B$BBut do it long enough, and you will become quite used to it.','',26124),
(65207,'enUS','Let\'s go!','',26124),
(65208,'enUS','I was once the Empress Shek\'zeer\'s most prized royal alchemist, peerless, and above all others.','',26124),
(65209,'enUS','Pah! I remember when Un\'sok was still a drone, afraid to mix his first toxin. I dare him to face me alone. Then we shall see whose alchemy is supreme.','',26124),
(65210,'enUS','Bow to the Shao-Tien!','',26124),
(65211,'enUS','You are weak!','',26124),
(65212,'enUS','Foolish child.','',26124),
(65213,'enUS','There he is! Kill him now, $p!','',26124),
(65214,'enUS','Ah, another stranger from beyond the mists.','',26124),
(65215,'enUS','Ten thousand years ago, the last Pandaren Emperor came seeking my advice. He, too, was filled with conflict. Let us see if you are correct, Taran. Let us see how this stranger deals with turmoil of the soul.','',26124),
(65216,'enUS','Soon they will overwhelm this continent! Where do we draw the line?','',26124),
(65217,'enUS','We have witnessed your \"help\" in the Jade Forest. This \"Horde,\" this \"Alliance\" of yours - you have no control over your own nature. You leave misery in your wake.','',26124),
(65218,'enUS','Kneel, worm.','',26124),
(65219,'enUS','Pitiful.','',26124),
(65220,'enUS','We\'re here to lend our aid. We can help protect the Vale.','',26124),
(65221,'enUS','Stop him! Forget about her!','',26124),
(65222,'enUS','<He looks down the hall intently.>','',26124),
(65223,'enUS','|TInterface\\Icons\\ability_warlock_baneofhavoc:20|t%s begins to cast |cFFFF0000|Hspell:126299|h[Unleash Souls]|h|r! Move quickly!','',26124),
(65224,'enUS','Finally.','',26124),
(65225,'enUS','It\'s over. The curse is lifted. Thank you, $p. Thank you!','',26124),
(65226,'enUS','I hunger!','',26124),
(65227,'enUS','I must feed!','',26124),
(65228,'enUS','And so the Golden Lotus arrive...','',26124),
(65229,'enUS','You are far too late.  The Jade Armies are mine.','',26124),
(65230,'enUS','And with them, I will crush the Golden Lotus and retake the vale in the name of the Thunder King!','',26124),
(65231,'enUS','Die weaklings!','',26124),
(65232,'enUS','The endless might of the Jade Armies is mine to control!','',26124),
(65233,'enUS','Your rogue friend is not as nimble as he thinks he is.','',26124),
(65234,'enUS','My statue will crush the life from him, leaving nothing but a shattered corpse.','',26124),
(65235,'enUS','You leave your friend to die...','',26124),
(65236,'enUS','How noble, rescuing your friend from certain death...','',26124),
(65237,'enUS','...and all for nothing.  Take them!','',26124),
(65238,'enUS','Your struggle is pointless.','',26124),
(65239,'enUS','You are ignorant to the powerful secrets contained within this vale.  I will take them, and then I will destroy all of your kind.','',26124),
(65240,'enUS','Throw these prisoners in the cages.  Let the men have their way with them.','',26124),
(65241,'enUS','My next great adventure is about to begin.$B$BIs that a Light I see?','',26124),
(65242,'enUS','The Battle Helm of the Thunder King...','',26124),
(65243,'enUS','It would seem my guards are useless.  I will have to take care of you myself.','',26124),
(65244,'enUS','There will be no cages this time, I will tear your limbs from your bodies!','',26124),
(65245,'enUS','Cower before my might!','',26124),
(65246,'enUS','I will extinguish the life from your body!','',26124),
(65247,'enUS','I will rip out your soul!','',26124),
(65248,'enUS','Violence. See? They are filled with it.','',26124),
(65249,'enUS','You are not as weak as I thought, but the helm is still mine...','',26124),
(65250,'enUS','Aaaarrrghhh!  Mage, when we next meet, I will separate your head from your body.','',26124),
(65251,'enUS','Yes... we are fighters. But we come from a violent land. We fought off demons, we fought off death, we even fought against the very end of the world!','',26124),
(65252,'enUS','Who dares disturb me? Show your cowardly faces and kneel before me!','',26124),
(65253,'enUS','PREPARE TO DIE, VILLAIN!','',26124),
(65254,'enUS','Ahahaha! Such a pitiful creature!','',26124),
(65255,'enUS','You are not worthy of me. Dago! Come crush this insignificant flea!','',26124),
(65256,'enUS','My spear will finish you!','',26124),
(65257,'enUS','Cower at the sight of your own doom!','',26124),
(65258,'enUS','It is true. They are strong. There is much they can teach us.','',26124),
(65259,'enUS','I will show you the strength of a true warlord!','',26124),
(65260,'enUS','You have nowhere to go, weakling!','',26124),
(65261,'enUS','Fool. Do you think to stop the full might of the mogu empire?','',26124),
(65262,'enUS','I will not grant you a swift death, weakling.','',26124),
(65263,'enUS','You are weak!','',26124),
(65264,'enUS','I will crush you!','',26124),
(65265,'enUS','We will reclaim what is rightfully ours!','',26124),
(65266,'enUS','Cower at your own folly!','',26124),
(65267,'enUS','I am made anew!','',26124),
(65268,'enUS','The blood in my veins is now thick with toxins. I shall fear no poison ever again. Truly, I am my own masterpiece!','',26124),
(65269,'enUS','Won\'t you try a taste of poison, Wakener? Not even just a drop?','',26124),
(65270,'enUS','I am no longer a mantid. I am something... more.','',26124),
(65271,'enUS','I seek training in the Way of the Wok.','I seek training in the Way of the Wok.',26124),
(65272,'enUS','I seek training in the Way of the Brew.','I seek training in the Way of the Brew.',26124),
(65273,'enUS','We can agree it is noble to fight for a righteous cause: to defend home or family. But what of vengeance? What of anger? I sense these emotions run deep in this one.','',26124),
(65274,'enUS','','Every day I archive something new, and something old. Sometimes it is an ancient scroll of wisdom. Sometimes it is a painting of the Vale an Inkmaster made.$b$bWe preserve the lore so that future generations will learn from our successes... and our failures.',26124),
(65275,'enUS','Stand on an elevated surface to avoid the Shadow Fog!','Stand on an elevated surface to avoid the Shadow Fog!',26124),
(65276,'enUS','|TInterface\\Icons\\inv_misc_gem_bloodstone_03:20|t%s transforms into |cFFFF0000|Hspell:126384|h[Red Granite]|h|r!','',26124),
(65277,'enUS','|TInterface\\Icons\\inv_misc_gem_stone_01:20|t%s transforms into |cFFFF0000|Hspell:126401|h[Green Granite]|h|r!','',26124),
(65278,'enUS','|TInterface\\Icons\\inv_ore_cobalt:20|t%s transforms into |cFFFF0000|Hspell:126405|h[Blue Granite]|h|r!','',26124),
(65279,'enUS','I seek training in the Way of the Grill.','I seek training in the Way of the Grill.',26124),
(65280,'enUS','I seek training in the Way of the Pot.','I seek training in the Way of the Pot.',26124),
(65281,'enUS','I seek training in the Way of the Steamer.','I seek training in the Way of the Steamer.',26124),
(65282,'enUS','I seek training in the Way of the Oven.','I seek training in the Way of the Oven.',26124),
(65283,'enUS','Yes?','Yes?',26124),
(65284,'enUS','It smells delicious, doesn\'t it?','It smells delicious, doesn\'t it?',26124),
(65285,'enUS','Did you need something?','Did you need something?',26124),
(65286,'enUS','Would you like to learn how to cook?','Would you like to learn how to cook?',26124),
(65287,'enUS','I seek training in Pandaren cooking.','I seek training in Pandaren cooking.',26124),
(65288,'enUS','I need ingredients and equipment for my kitchen.','I need ingredients and equipment for my kitchen.',26124),
(65289,'enUS','When dawn rises, the hammer shall fall.','',26124),
(65290,'enUS','What is best in life?\n\nBrothers, ballads and beer!','',26124),
(65291,'enUS','I like my women like I like my beer: full-bodied.','',26124),
(65292,'enUS','I would do anything for love. But I won\'t do that. At least, not right away.','',26124),
(65293,'enUS','','These boys are a handful.',26124),
(65294,'enUS','','I promised the boys a picnic up here but it is a dangerous place. Just the other day I hear there was an actual fight between strangers like yourself.$b$bAnd someone from... the turtle.$b$bI always thought the turtle was a legend.',26124),
(65295,'enUS','','We do not often have troubles with predators up here. Sometimes when it rains the saurok come out. But that is only when there is a lightning storm.',26124),
(65296,'enUS','Mooooom! Liu keeps poking me!','',26124),
(65297,'enUS','Liu took my jinyu trinket!','',26124),
(65298,'enUS','Liu stepped on my foot!','',26124),
(65299,'enUS','Mom! Liu keeps acting like a hozen!','',26124),
(65300,'enUS','Mommm! Liu punched me!','',26124),
(65301,'enUS','No I didn\'t!','',26124),
(65302,'enUS','He started it!','',26124),
(65303,'enUS','You told me to!','',26124),
(65304,'enUS','Nuh uuuh!','',26124),
(65305,'enUS','','Stop it. You both are behaving like a pair of hozen!',26124),
(65306,'enUS','','If you do not behave I will turn this picnic right around and we will go home. Is that what you want?',26124),
(65307,'enUS','','Ty, stop tattling on your brother. Liu, do not give your brother a reason to tattle.',26124),
(65308,'enUS','','Stop it, both of you. You are smarter than this. Can you be clever like a jinyu and get along? Or are you just going to keep misbehaving like a hozen?',26124),
(65309,'enUS','Present your challenge.','',26124),
(65310,'enUS','This may disorient you momentarily, Wakener. It is always difficult the first time your eyes truly see.','',26124),
(65311,'enUS','Very well... Metal Brewmaster.','',26124),
(65312,'enUS','We are all sons and daughters of the storm!','',26124),
(65313,'enUS','','I always thought trolls were stuff from old stories.',26124),
(65314,'enUS','','Thank you, $p! Your courage saw us through the battle.',26124),
(65315,'enUS','','That was a tough fight. The most we ever have to worry about are saurok raiders or the occassional hungry hozen.$b$bThose trolls... they fight differently.',26124),
(65316,'enUS','','What were the trolls after?',26124),
(65317,'enUS','Now you will see. Traitors hide within our ranks.','',26124),
(65318,'enUS','That was a fearsome battle.','',26124),
(65319,'enUS','Now I wish I had stayed awake during those defense lessons at the monastery when I was a cub.','',26124),
(65320,'enUS','What were those trolls after? We are just a simple fishing village.','',26124),
(65321,'enUS','Trolls. Those were actual trolls! We have heard of them in stories. But to see them in person. And every bit as ferocious as the tales tell.','',26124),
(65322,'enUS','Anger is a part of us all, yes. But we value control. The orcs were once driven solely by anger - they lived in a state of bloodlust - but they conquered it.','',26124),
(65323,'enUS','All you seek to conquer is each other!','',26124),
(65324,'enUS','To live without anger is not to live at all. It is ours to overcome. In defeating our anger, we draw great strength.','',26124),
(65325,'enUS','|TInterface\\Icons\\ability_warrior_battleshout.blp:20|tThe Spirit of Lao-Fe casts |cFFFF0000|Hspell:126471|h[Oppress the Weak!]|h|r!','',26124),
(65326,'enUS','Well spoken, Zhi. The strangers from beyond the mists have no shortage of passions, but let us see if they indeed control them. Beyond anger lies hatred, the wellspring of all misery. What is this? Your hatred has a face!','',26124),
(65327,'enUS','See? See how these outsiders hate one another! They wear their hatred to battle and carry it to their graves!','',26124),
(65328,'enUS','No, that\'s not true - there is so much more to us than this!','',26124),
(65329,'enUS','How interesting. They bring much to our land, but they also bring the shadow of war.','',26124),
(65330,'enUS','Peace will come. I swear it. And old hatreds will go away. You have to believe me.','',26124),
(65331,'enUS','|TInterface\\Icons\\ability_searingarrow.blp:20|tHuo-Shuang casts |cFFFF0000|Hspell:126304|h[Flaming Arrow]|h|r!','',26124),
(65332,'enUS','|TInterface\\Icons\\spell_frost_iceshard.blp:20|tHuo-Shuang casts |cFFFF0000|Hspell:126321|h[Frozen Arrow]|h|r!','',26124),
(65333,'enUS','Kor\'ik! How long have you worked for the empress?!','',26124),
(65334,'enUS','I see the paragon has been awakened.','',26124),
(65335,'enUS','The paragon does not speak truth, Wakener. His mind did not survive encasement.','',26124),
(65336,'enUS','He cannot allow him to live in this madness. The Klaxxi will want him put down.','',26124),
(65337,'enUS','You and the Klaxxi are fools! Your arrogance will be your end!','',26124),
(65338,'enUS','The only madness here is your own, Kor\'ik! Did you really think you would go unnoticed forever?','',26124),
(65339,'enUS','You will not deceive us. We see you for who you truly are!','',26124),
(65340,'enUS','That looks like... my father!','',26124),
(65341,'enUS','That... that looks just like Garrosh Hellscream!','',26124),
(65342,'enUS','','Well met, $c. I mean you no harm.$B$BI\'m here posing as one of the Scarlet Crusade because they have become irredeemably corrupt and evil.$B$BI need your help to put an end to them once and for all.',26124),
(65343,'enUS','Oh... Oh no... I\'m going to die here...','',26124),
(65344,'enUS','No you\'re not! Here, take this!','No you\'re not! Here, take this!',26124),
(65345,'enUS','|TInterface\\Icons\\spell_fire_soulburn.blp:20|t %s is casting |cFFFF0000|Hspell:126288|h[Decimate]|h|r!','',26124),
(65346,'enUS','The beast is covered in oil, light him up!','',26124),
(65347,'enUS','Archers, attack! Make him burn!','',26124),
(65348,'enUS','Light up the oil!','',26124),
(65349,'enUS','Jump to free yourself from the webs!','Jump to free yourself from the webs!',26124),
(65350,'enUS','This one has indeed proven mastery over anger. Between the young cub\'s words and the actions of this hero, I think I understand. Those from beyond the mists are hardened by battle. They are scarred, yes, but they have learned much. I trust them.','',26124),
(65351,'enUS','You are making a terrible mistake!','',26124),
(65352,'enUS','It is decided. The Vale of Eternal Blossoms shall remain open. The transgressions of the outsiders have been great... but I see in them the capability to right what has been wronged.','',26124),
(65353,'enUS','Thank you, Master White Tiger. You will see. I believe that my people - and the Horde - are essentially good.','',26124),
(65354,'enUS','I will consult the others. Meet me at the gates.','',26124),
(65355,'enUS','Empress Shek\'zeer will destroy you!','',26124),
(65356,'enUS','I find your faith inspiring, little one. But I wonder if you have ever met our warchief?','',26124),
(65357,'enUS','Empress Shek\'zeer knows your plans. Your treachery will be punished...','',26124),
(65358,'enUS','$n fend off the yaungol while I finish the brew!','',26124),
(65359,'enUS','I would like to upgarde another sha-touched weapon. Can you help?','I would like to upgarde another sha-touched weapon. Can you help?',26124),
(65360,'enUS','You have certainly proven that you are worthy of it, but the materials do not come without cost.$b$bI\'m sure I can arrange something with Madam Goya, but it won\'t come cheap.$b$bPlease keep in mind that only one Crystal of Fear can be equipped at any time.','',26124),
(65361,'enUS','It is worth it. I wish to augment my agility.<Pay 10,000 gold.>','It is worth it. I wish to augment my agility.<Pay 10,000 gold.>',26124),
(65362,'enUS','','I grew up hearing legends of the White Tiger. He is a hero to the pandaren people. It is a real honor to be here training.',26124),
(65363,'enUS','I will remain here to examine Kor\'ik\'s remains. I will meet you back in Klaxxi\'vess when you have completed these tasks.','',26124),
(65364,'enUS','|TInterface\\Icons\\ability_hunter_pet_spider.blp:20|t %s casts |cFFFF0000|Hspell:126652|h[Call Swarmers]|h|r!','',26124),
(65365,'enUS','I need another torch.','I need another torch.',26124),
(65366,'enUS','Minions! Bring me a brew worthy of Ook!','',26124),
(65367,'enUS','Storm the shores! Steal their brew!','',26124),
(65369,'enUS','','Here, take these supplies. You\'ll need them for your missions.',26124),
(65370,'enUS','|TInterface\\Icons\\inv_misc_idol_02.blp:20|tGara\'jal selects random players to become |cFFFF0000|Hspell:122151|h[Voodoo Dolls]|h|r!','',26124),
(65371,'enUS','You are a |cFFFF0000|Hspell:122151|h[Voodoo Doll]|h|r! Damage you take is copied to the other Voodoo Dolls in your raid!','You are a |cFFFF0000|Hspell:122151|h[Voodoo Doll]|h|r! Damage you take is copied to the other Voodoo Dolls in your raid!',26124),
(65373,'enUS','|TInterface\\Icons\\inv_enchant_voidsphere.blp:20|tGara\'jal has |cFFFF0000|Hspell:116727|h[Banished]|h|r you to the Spirit World completely! You and your allies must defeat all Severers of Souls to return to the real world.','',26124),
(65374,'enUS','The beacons sing to each other, outsider. Important messages are sent.$b$bYour ears will not hear the messages. Only those that the Klaxxi trust hear the words they speak.','',26124),
(65375,'enUS','It would be my honor to sacrifice myself for what I believe.','',26124),
(65376,'enUS','|TInterface\\Icons\\ability_shaman_astralshift.blp:20|tYour spirit has been healed sufficiently to return to its body in the real world! Use your |cFFFF0000|Hspell:120715|h[Revitalized Spirit]|h|r action button to save your spirit!','',26124),
(65377,'enUS','I am busy, outsider.','',26124),
(65378,'enUS','You have |cFFFF0000|Hspell:116161|h[Crossed Over]|h|r to the Spirit World! You or an ally must heal your spirit to 90% health within 30 seconds or else you will perish!','',26124),
(65379,'enUS','Someday the Klaxxi will elevate my rank. I will be allowed to consume amber.','',26124),
(65380,'enUS','The Klaxxi do not give their trust easily, outsider. It has taken me many years to even be seen by them.','',26124),
(65381,'enUS','We all have talents, outsider. Some are just not as easy to see as others.','',26124),
(65382,'enUS','|TInterface\\Icons\\ability_druid_challangingroar.blp:20|tGara\'jal casts |cFFFF0000|Hspell:117752|h[Frenzy]|h|r!','',26124),
(65383,'enUS','','I\'d say that we\'re about halfway done, wouldn\'t you? Scarlet Halls down, Scarlet Monastery yet to go.$B$BDon\'t be surprised if I disappear -- I have to get over there quickly.',26124),
(65384,'enUS','','There are a lot of corpses out there.  Nicely done, $p.',26124),
(65385,'enUS','','Did you get the codex?',26124),
(65386,'enUS','','Kneeling down, the Hooded Crusader examines the Flameweaver\'s corpse, looking for something.',26124),
(65387,'enUS','Now, back to the brewing!','',26124),
(65388,'enUS','The shiny isss mine!','',26124),
(65389,'enUS','You cannot have it!','',26124),
(65390,'enUS','It\'sss mine!','',26124),
(65391,'enUS','My shiny...','',26124),
(65392,'enUS','Riders approach!','',26124),
(65393,'enUS','','I am proud to have defended our village.',26124),
(65394,'enUS','','Father, I am no longer the helpless child you feared for.',26124),
(65395,'enUS','','I would like to continue my training so that I may always defend our home.',26124),
(65396,'enUS','','I will keep this village safe so that you may retire your weapons.',26124),
(65397,'enUS','Never before has a father felt such pride for their child, Shomi.','',26124),
(65398,'enUS','Your words honor me, daughter. This is a proud moment.','',26124),
(65399,'enUS','You will always be my little girl and I will always fear for you, but I know now you can take care of yourself.','',26124),
(65400,'enUS','Excellent news. Our studies of this site\'s energies and artifacts have begun to pay off.$B$BWe have unraveled some understanding of the mogu devices found here, and even better, a way to turn them in our favor. The very walls of this structure will siphon and sap the might of any enemies within.','',26124),
(65401,'enUS','It may be best not to dabble in mysteries not yet fully understood. Perhaps you should disable the dampening devices. My companions and I can handle ourselves. I\'m sure we will be fine.','It may be best not to dabble in mysteries not yet fully understood. Perhaps you should disable the dampening devices. My companions and I can handle ourselves. I\'m sure we will be fine.',26124),
(65402,'enUS','Yes, please disable the devices.','Yes, please disable the devices.',26124),
(65403,'enUS','Are you certain? This is a dangerous place, and our initial researchers have not yet returned from their expedition. If we disable the dampening field, we will leave until the ruins are safely secured, and cannot reactivate the devices.$B$BI ask again: Are you certain?','',26124),
(65404,'enUS','You are too late.','',26124),
(65405,'enUS','Da remains of da Thunder King were taken to da Isle of Reckoning.','',26124),
(65406,'enUS','We performed da ancient rites...','',26124),
(65407,'enUS','Even now, da true emperor of Pandaria lives and breathes once more.','',26124),
(65408,'enUS','I really hope you know what you are doing.','',26124),
(65409,'enUS','Woe to da pandaren usurpers! The mogu will rule dis land again, and we Zandalari will have a new homeland...','',26124),
(65410,'enUS','Secure da remains, bruddahs!','',26124),
(65411,'enUS','Da Thunder King shall live again...','',26124),
(65412,'enUS','Da Thunder King lives! Our empires be united once more...','',26124),
(65413,'enUS','We need dis land! Da cataclysm destroyed our home!','',26124),
(65414,'enUS','Dis only just begun... we ain\'t gonna jes\' roll over and die...','',26124),
(65415,'enUS','So you have come here, to the heart of the pollution. We will aid you. Our song will resonate through the walls of this twisted place, weakening the resolve of those who have forsaken our race.','',26124),
(65416,'enUS','We are more than capable of handling this without assistance. Withdraw. When you return, you will find the Empress slain and your problems solved.','We are more than capable of handling this without assistance. Withdraw. When you return, you will find the Empress slain and your problems solved.',26124),
(65417,'enUS','Yes, we will handle this our own way.','Yes, we will handle this our own way.',26124),
(65418,'enUS','Is this arrogance or merely folly? Your death awaits within these walls. If we leave you shall have no aid. Do you realize what you are saying?','',26124),
(65419,'enUS','So be it.','',26124),
(65420,'enUS','$n is |cFFFF0000|Hspell:121970|h[Trapped]|h|r! Free $Ghim:her; by clicking on the barrel!','',26124),
(65421,'enUS','Under Kun-Lai Thunder sleeps...','',26124),
(65422,'enUS','The storm long spent there rests...','',26124),
(65423,'enUS','But blood of brother kingdom keeps...','',26124),
(65424,'enUS','Alive the dispossessed...','',26124),
(65425,'enUS','By Zandalari blood he will be taken...','',26124),
(65426,'enUS','To Zandalari voice he will awaken...','',26124),
(65427,'enUS','The battlefield is no place for a girl!','',26124),
(65428,'enUS','If I hadn\'t gotten a splinter I would be out there defending our village too!','',26124),
(65429,'enUS','Shomi should not want to fight. That is a man\'s job!','',26124),
(65430,'enUS','Shomi is such a child!','',26124),
(65431,'enUS','<Kovok\'s eyes widen as he looks at you.>','',26124),
(65432,'enUS','<Kovok look at you with concern.>','',26124),
(65433,'enUS','<Kovok chitters happily... you think.>','',26124),
(65434,'enUS','In all my years I never expected to see the Zandalari.','',26124),
(65435,'enUS','This village has been peaceful for longer than I can remember. Our weapons are surely as rusty as our fighters.','',26124),
(65436,'enUS','Surviving this attack will take a miracle.','',26124),
(65437,'enUS','Those Zandalari won\'t know what hit them when I\'m done!','',26124),
(65438,'enUS','At last peace can be restored!','',26124),
(65439,'enUS','You are a true hero!','',26124),
(65440,'enUS','I can finally return to my knitting! Those winter scarves won\'t make themselves!','',26124),
(65441,'enUS','You have our respect and our thanks.','',26124),
(65442,'enUS','These events have shown me so much.','',26124),
(65443,'enUS','Thank you for opening my eyes to who my daughter really is.','',26124),
(65444,'enUS','You have not only saved our village; you have also repaired my family.','',26124),
(65445,'enUS','','I have grown so much thanks to you!',26124),
(65446,'enUS','','I look forward to when our paths cross again!',26124),
(65447,'enUS','','Maybe next time it will be me saving you!',26124),
(65448,'enUS','','I\'m ready for the world, but I\'m not sure it\'s ready for me!',26124),
(65449,'enUS','We will have to work quickly if we want to find the remains.','',26124),
(65450,'enUS','Every villager counts. Without each grain of sand we would have no beach to enjoy the ocean from.','',26124),
(65451,'enUS','There is a lesson to be learned in every challenge we face.','',26124),
(65452,'enUS','This village has you to thank for their victory.','',26124),
(65453,'enUS','To see only the defeat of losing the remains would be foolish. This village is the first of many that will rise against the Thunder King. This is a great victory!','',26124),
(65454,'enUS','When we face the Thunder King we will be prepared.','',26124),
(65455,'enUS','','We must not only see the negative when there is much to be positive about.',26124),
(65456,'enUS','','These hardships will pass and we will grow stronger because of them.',26124),
(65457,'enUS','','I\'m confident you will be able to help us.',26124),
(65458,'enUS','','It is because of you this village has found its strength again!',26124),
(65459,'enUS','','We will not be the only village to rise against the Thunder King!',26124),
(65460,'enUS','','It is always a good idea to make friends with fisherman. You will never go hungry!',26124),
(65461,'enUS','This is terrible! How will we ever defeat the Zandalari?','',26124),
(65462,'enUS','We are but one tiny village... What could we possibly do to defeat the Thunder King\'s forces?','',26124),
(65463,'enUS','They outnumber us! This is madness!','',26124),
(65464,'enUS','I knew we would defeat the invaders!','',26124),
(65465,'enUS','Despite what I may have said in the past, I never doubted your abilities!','',26124),
(65466,'enUS','The Zandalari should never have underestimated us!','',26124),
(65467,'enUS','','This village is normally so peaceful.',26124),
(65468,'enUS','','Change is inevitable, even for those as stubborn as Doshu.',26124),
(65469,'enUS','','My daughter has spirit and persistence! I worry less about her than I do my husband.',26124),
(65470,'enUS','','It is done. You did it, $p!',26124),
(65471,'enUS','','And now enough of this deception.',26124),
(65472,'enUS','','Hello, my name\'s Lilian. You don\'t mind if I take those blades, do you?',26124),
(65473,'enUS','','The Hooded Crusader gazes down upon the high inquisitor\'s blade-skewered corpse.',26124),
(65474,'enUS','...ouch?','',26124),
(65475,'enUS','Yes... pop. Sorry I got me head all snared by that thing.','',26124),
(65476,'enUS','Get... out... of my boy\'s... head!','',26124),
(65477,'enUS','Well that\'s a start at least. Do ya remember who you are?','',26124),
(65478,'enUS','It was mind control boy. There\'s a difference. And don\'t worry. If big game huntin\' were easy, everybody\'d be doing it.','',26124),
(65479,'enUS','Hozen in the Mist.','Hozen in the Mist.',26124),
(65480,'enUS','Fish Tales.','Fish Tales.',26124),
(65481,'enUS','Dark Heart of the Mogu.','Dark Heart of the Mogu.',26124),
(65482,'enUS','','Good to see you again, $n. For a moment, I was worried that you wouldn\'t come.$B$BLet\'s finish this, shall we? The Scarlet Crusade has proven that it\'s not going to put an end to itself.',26124),
(65483,'enUS','Heart of the Mantid Swarm.','Heart of the Mantid Swarm.',26124),
(65484,'enUS','What is Worth Fighting For.','What is Worth Fighting For.',26124),
(65485,'enUS','Song of the Yaungol.','Song of the Yaungol.',26124),
(65486,'enUS','Seven Burdens of Shaohao.','Seven Burdens of Shaohao.',26124),
(65487,'enUS','Ballad of Liu Lang.','Ballad of Liu Lang.',26124),
(65488,'enUS','Who would ever guess how much knowledge was hidden behind these walls. And there is so much more we can add to it.$b$bAs you explore our land, keep an eye out for objects of interest that might help us learn more of our past. Piece together enough of our history, and I may be able to share a story or two with you.','',26124),
(65489,'enUS','It is good to see another explorer! When some people discover a new land, they immediately seek out the fortresses and temples.$b$bNot me.$b$bTo get the measure of a people, you need to get your feet dirty. Come, walk the land with me! Let us see what these mainland pandaren truly value.$b$bIt is the Wanderer\'s Way.','',26124),
(65490,'enUS','My niece Li Li is so impatient to explore Pandaria. But one never learns a new land by rushing headlong from place to place. It is important to talk to everyone you meet, to experience a place until it becomes a part of your soul.$b$bIt is the Wanderer\'s Way!','',26124),
(65491,'enUS','Li Li does not understand why I always stop to sample the local brews. But in my experience, you can learn a lot about a people by what they drink!$b$bHave you tried mainland pandaren ales? Very crisp, very dark. One sip and you know that they are brewed to be savored slowly. It is the drink of a people that are in no hurry, who enjoy time with their friends.$b$bWhat do YOU drink, $c? And what would it tell me about you, hm?','',26124),
(65492,'enUS','These pandaren farmers are entertaining folk! A very tight-knit community. Everyone knows one another.$b$bIt is very different from the big cities in Kalimdor or the Eastern Kingdoms.','',26124),
(65493,'enUS','Why are you always in such a rush, $n? It is like you dash madly from one stranger in need to another, bent on gaining new experiences.$b$bLife is not simply a glass you fill up! Stay a while, and enjoy the places you discover!','',26124),
(65494,'enUS','My family left mainland Pandaria to explore the world on the back of the Wandering Isle. That was many generations ago.$b$bBut I have learned that there are other Stormstouts, here, on Pandaria! My long-lost family. What are they like? Do they still brew, as I do? Are they adventurers, like you and I?','',26124),
(65495,'enUS','If you spent enough time here in the valley, perhaps you could make friends with all the locals. Maybe even some day settle down with a farm plot of your own.$b$bImagine that - YOU, the world-weary $c, settling down to manage a farm!$b$b<Chen closes his eyes and laughs a deep belly-laugh.>','',26124),
(65496,'enUS','Embrace the Wanderer\'s Way! It is not so much a course of action as it is an attitude.$b$bEvery one you meet is a story. Every place you go is an adventure. Every drink you have is the best you\'ve ever tasted.$b$bThis is not such a bad life, is it?','',26124),
(65497,'enUS','<Chen acknowledges you with a nod but looks uncharacteristically sullen.>','',26124),
(65498,'enUS','Travel through the Spirit World has left you with a |cFFFF0000|Hspell:117723|h[Frail Soul]|h|r temporarily! If you attempt to travel to the Spirit World again before Frail Soul expires you will perish instantly!','',26124),
(65499,'enUS','These sacred waters are befouled, but hope is not lost. Our ancient rituals endure and cleanse, even in the face of this great corruption. And as the waters recover, the strength of those who taint them wanes.','',26124),
(65500,'enUS','This being may feed on Fear, but we have none to offer it. Cease your ritual, for we require no assistance to cleanse this place.','This being may feed on Fear, but we have none to offer it. Cease your ritual, for we require no assistance to cleanse this place.',26124),
(65501,'enUS','Once this ritual ceases, we will not be able to resume it, and the corruption will remain at full strength. Your courage is admirable, but if you fail, we are all doomed. Do you understand what you ask? Do you understand the consequences?','',26124),
(65502,'enUS','This is a historic moment, $n. What do you think lies beyond the gates?','',26124),
(65503,'enUS','When I say: \"Who\'s the Master?\" You say: \"Shonuf!\"','',26124),
(65504,'enUS','I got the glow!','',26124),
(65505,'enUS','Come, face your death.','',26124),
(65506,'enUS','I will have your armor as a trophy!','',26124),
(65507,'enUS','|TInterface\\Icons\\inv_misc_bomb_05.blp:20|tSaboteur Kip\'tilak casts |cFFFF0000|Hspell:107268|h[Sabotage]|h|r on |cFFFF0000$n|r!','',26124),
(65508,'enUS','You stand before your death.','',26124),
(65509,'enUS','You\'ve been |cFFFF0000|Hspell:107268|h[Sabotaged]|h|r!','You\'ve been |cFFFF0000|Hspell:107268|h[Sabotaged]|h|r!',26124),
(65510,'enUS','Saboteur Kip\'tilak sets off a series of explosions!','',26124),
(65511,'enUS','It is good to see you here, child.','',26124),
(65512,'enUS','I do. The way to defeat Fear is to look it straight in the eye, unblinking, unwavering.','I do. The way to defeat Fear is to look it straight in the eye, unblinking, unwavering.',26124),
(65513,'enUS','|TInterface\\Icons\\ability_parry.blp:20|tMaster Snowdrift enables his |cFFFF0000|Hspell:106454|h[Parry Stance]|h|r!','',26124),
(65514,'enUS','May the spirits be with you, brave one.','',26124),
(65515,'enUS','|TInterface\\Icons\\spell_nature_earthbind.blp:20|tMaster Snowdrift uses his |cFFFF0000|Hspell:106434|h[Tornado Kick]|h|r!','',26124),
(65516,'enUS','|TInterface\\Icons\\ability_hunter_sickem.blp:20|tMaster Snowdrift sets his sights on |cFFFF0000$n|r to |cFFFF0000|Hspell:118961|h[Chase Down]|h|r!','',26124),
(65517,'enUS','Let\'s find out!','Let\'s find out!',26124),
(65518,'enUS','','Yes, these will do quite nicely. They feel almost as if they were meant for me all along.',26124),
(65519,'enUS','Master Snowdrift is |cFFFF0000|Hspell:118961|h[Chasing]|h|r you! If he catches you he will use his |cFFFF0000|Hspell:106352|h[Tornado Slam]|h|r technique on you! Run away from Master Snowdrift until Chase Down expires!','Master Snowdrift is |cFFFF0000|Hspell:118961|h[Chasing]|h|r you! If he catches you he will use his |cFFFF0000|Hspell:106352|h[Tornado Slam]|h|r technique on you! Run away from Master Snowdrift until Chase Down expires!',26124),
(65520,'enUS','|TInterface\\Icons\\inv_weapon_hand_30.blp:20|tMaster Snowdrift uses his |cFFFF0000|Hspell:106853|h[Fists of Fury]|h|r technique!','',26124),
(65522,'enUS','','Flying Snow chooses |cFFFF0000$n|r to chase down with her |cFFFF0000|Hspell:106706|h[Whirling Steel]|h|r!',26124),
(65523,'enUS','','Flying Snow is chasing you with her |cFFFF0000|Hspell:|h[Whirling Steel]|h|r technique! Run away from her until she chooses someone else!',26124),
(65524,'enUS','','|TInterface\\Icons\\inv_sword_24.blp:20|tFlying Snow uses her |cFFFF0000|Hspell:106706|h[Whirling Steel]|h|r technique!',26124),
(65525,'enUS','A Shado-Pan Novice has chosen you for |cFFFF0000|Hspell:106774|h[Honorable Combat]|h|r! They will attack you until they are defeated!','A Shado-Pan Novice has chosen you for |cFFFF0000|Hspell:106774|h[Honorable Combat]|h|r! They will attack you until they are defeated!',26124),
(65526,'enUS','|TInterface\\Icons\\ability_warrior_battleshout.blp:20|tArmsmaster Harlan calls on two of his allies to join the fight!','',26124),
(65527,'enUS','|TInterface\\Icons\\inv_weapon_halberd_05.blp:20|tArmsmaster Harlan casts |cFFFF0000|Hspell:111216|h[Blades of Light]|h|r!','',26124),
(65528,'enUS','You died to Armsmaster Harlan\'s |cFFFF0000|Hspell:|h[Blades of Light]|h|r ability. Armsmaster Harlan chooses one of two directions to travel when he uses this ability, so try to react to which way he goes so that you can dodge out of his path!','You died to Armsmaster Harlan\'s |cFFFF0000|Hspell:|h[Blades of Light]|h|r ability. Armsmaster Harlan chooses one of two directions to travel when he uses this ability, so try to react to which way he goes so that you can dodge out of his path!',26124),
(65529,'enUS','|TInterface\\Icons\\spell_shadow_psychicscream.blp:20|tImperial Vizier Zor\'lok has targeted you with his |cFFFF0000|Hspell:122761|h[Exhale]|h|r ability! Use your survival abilities or have an ally with high survivability stand in between you and Imperial Vizier Zor\'lok!','|TInterface\\Icons\\spell_shadow_psychicscream.blp:20|tImperial Vizier Zor\'lok has targeted you with his |cFFFF0000|Hspell:122761|h[Exhale]|h|r ability! Use your survival abilities or have an ally with high survivability stand in between you and Imperial Vizier Zor\'lok!',26124),
(65530,'enUS','You died to Imperial Vizier Zor\'lok\'s |cFFFF0000|Hspell:122713|h[Force and Verve]|h|r. Try and enter one of the |cFFFF0000|Hspell:122706|h[Noise Cancelling]|h|r zones to minimize the damage from Force and Verve and have you or an ally use their healing abilities to keep you alive.','You died to Imperial Vizier Zor\'lok\'s |cFFFF0000|Hspell:122713|h[Force and Verve]|h|r. Try and enter one of the |cFFFF0000|Hspell:122706|h[Noise Cancelling]|h|r zones to minimize the damage from Force and Verve and have you or an ally use their healing abilities to keep you alive.',26124),
(65531,'enUS','You perished to Imperial Vizier Zor\'lok\'s |cFFFF0000|Hspell:123791|h[Song of the Empress]|h|r. Be sure you or one of your allies moves to the platform Imperial Vizier Zor\'lok is on and engages Imperial Vizier Zor\'lok in combat.','You perished to Imperial Vizier Zor\'lok\'s |cFFFF0000|Hspell:123791|h[Song of the Empress]|h|r. Be sure you or one of your allies moves to the platform Imperial Vizier Zor\'lok is on and engages Imperial Vizier Zor\'lok in combat.',26124),
(65532,'enUS','Imperial Vizier Zor\'lok has |cFFFF0000|Hspell:122740|h[Converted]|h|r you to fight for the Mantid Empire! Your former allies must bring your health down to 50% to free you of the Empress\'s hold over you!','Imperial Vizier Zor\'lok has |cFFFF0000|Hspell:122740|h[Converted]|h|r you to fight for the Mantid Empire! Your former allies must bring your health down to 50% to free you of the Empress\'s hold over you!',26124),
(65533,'enUS','You perished to Imperial Vizier Zor\'lok |cFFFF0000|Hspell:122336|h[Sonic Rings]|h|r ability. When Imperial Vizier Zor\'lok begins casting |cFFFF0000|Hspell:122496|h[Attenuation]|h|r be sure to move away from him and dodge the Sonic Rings that he emits.','You perished to Imperial Vizier Zor\'lok |cFFFF0000|Hspell:122336|h[Sonic Rings]|h|r ability. When Imperial Vizier Zor\'lok begins casting |cFFFF0000|Hspell:122496|h[Attenuation]|h|r be sure to move away from him and dodge the Sonic Rings that he emits.',26124),
(65534,'enUS','|TInterface\\Icons\\spell_shaman_earthquake.blp:20|tKuai the Brute uses his |cFFFF0000|Hspell:119922|h[Shockwave]|h|r ability!','',26124),
(65536,'enUS','|TInterface\\Icons\\ability_druid_supriseattack.blp:20|tMu\'Shiba casts |cFFFF0000|Hspell:119946|h[Ravage]|h|r on |cFFFF0000$n|r!','',26124),
(65537,'enUS','|TInterface\\Icons\\inv_elemental_primal_air.blp:20|tMing the Cunning summons a |cFFFF0000|Hspell:119981|h[Whirling Dervish]|h|r!','',26124),
(65538,'enUS','|TInterface\\Icons\\spell_druid_ursolsvortex.blp:20|tMing the Cunning creates a |cFFFF0000|Hspell:120099|h[Magnetic Field]|h|r!','',26124),
(65539,'enUS','|TInterface\\Icons\\ability_warrior_savageblow.blp:20|tHaiyan the Unstoppable strikes |cFFFF0000$n|r with a |cFFFF0000|Hspell:123655|h[Traumatic Blow]|h|r!','',26124),
(65540,'enUS','We are all here. This is a historic moment, $n. My dying wife envisioned a city of light beyond these gates. What do you think we will find?','',26124),
(65541,'enUS','Haiyan the Unstoppable struck you with a |cFFFF0000|Hspell:123655|h[Traumatic Blow]|h|r! Healing abilities used on you will be less efficient while the effect persists!','',26124),
(65542,'enUS','There\'s only one way to find out...','There\'s only one way to find out...',26124),
(65543,'enUS','|TInterface\\Icons\\spell_fire_meteorstorm.blp:20|tHaiyan the Unstoppable targets |cFFFF0000$n|r with a |cFFFF0000|Hspell:120195|h[Meteor]|h|r!','',26124),
(65544,'enUS','You perished to Haiyan the Unstoppable\'s |cFFFF0000|Hspell:120195|h[Meteor]|h|r! Be sure to group up with your allies when Haiyan the Unstoppable uses this ability so that you all split the damage.','',26124),
(65545,'enUS','|TInterface\\Icons\\spell_fire_fireball.blp:20|tHaiyan the Unstoppable begins casting |cFFFF0000|Hspell:120167|h[Conflagrate]|h|r!','',26124),
(65546,'enUS','I will defend the vale with my life!','I will defend the vale with my life!',26124),
(65547,'enUS','We must maintain the balance!','We must maintain the balance!',26124),
(65548,'enUS','For honor!','For honor!',26124),
(65549,'enUS','The golden lotus must protect the vale!','The golden lotus must protect the vale!',26124),
(65550,'enUS','The summer fields will remain safe as long as I live!','The summer fields will remain safe as long as I live!',26124),
(65551,'enUS','We fight together brethren!','We fight together brethren!',26124),
(65552,'enUS','Drive these brutes from the vale!','Drive these brutes from the vale!',26124),
(65553,'enUS','Remain vigilant!','Remain vigilant!',26124),
(65554,'enUS','To defend the vale with my life is an honor!','To defend the vale with my life is an honor!',26124),
(65555,'enUS','The battle is ours!','The battle is ours!',26124),
(65556,'enUS','We are victorious!','We are victorious!',26124),
(65557,'enUS','Ah-hah! Another chance to test my might.','',26124),
(65558,'enUS','They are falling back!','They are falling back!',26124),
(65559,'enUS','On your guard!','',26124),
(65560,'enUS','Bested... by the likes of...','',26124),
(65561,'enUS','Hah-HAH!','',26124),
(65562,'enUS','Tsk! You need more training.','',26124),
(65563,'enUS','May they find peace.','May they find peace.',26124),
(65564,'enUS','Xeun has taught us courage.','Xeun has taught us courage.',26124),
(65565,'enUS','The vale is safer now.','The vale is safer now.',26124),
(65567,'enUS','','The blades transform as she pulls them from Whitemane\'s corpse.',26124),
(65568,'enUS','','Can you believe the nerve of this little grummle? This shrewd little negotiator will have me bankrupt with his prices in no time.',26124),
(65569,'enUS','FUMMM!','',26124),
(65570,'enUS','He gestures towards the incoming statues, requesting your aid.','',26124),
(65571,'enUS','Keep your guard up!','Keep your guard up!',26124),
(65572,'enUS','A hozen bandit is stealing the brew! Stop him!','A hozen bandit is stealing the brew! Stop him!',26124),
(65573,'enUS','Hello $n! The Lorewalker is beginning her lesson just down these stairs if you want to listen in.','',26124),
(65574,'enUS','Pitiful creatures.','',26124),
(65575,'enUS','I shall teach you the meaning of strength.','',26124),
(65576,'enUS','Lei Shen returns, weakling.','',26124),
(65577,'enUS','The vale belongs to the Shao-Tien!','',26124),
(65578,'enUS','We shall reign over Pandaria once more!','',26124),
(65579,'enUS','There is no escape from our might!','',26124),
(65580,'enUS','Foolish child.','',26124),
(65581,'enUS','Give up now.','',26124),
(65582,'enUS','He\'ll slice and dice in ways that aren\'t nice! Please bow respectfully for Maki Waterblade, saurok samurai!','',26124),
(65583,'enUS','','This is the Song of Liu Lang, the first pandaren explorer.',26124),
(65584,'enUS','','The song is written in the old tongue, the language of emperors and scholars. Hardly anyone speaks it anymore.',26124),
(65585,'enUS','','It is all about his adventures.',26124),
(65586,'enUS','','Brave Liu Lang set out to explore the world on the back of a sea turtle.',26124),
(65587,'enUS','','Does anyone remember the turtle\'s name? Yin?',26124),
(65588,'enUS','','That\'s right, the turtle was called Shen-zin Su. At first, he was only big enough for Liu Lang to sit on.',26124),
(65589,'enUS','','He grew and grew and grew, SO big, that now some people call him \"The Wandering Isle.\"',26124),
(65590,'enUS','','Question, Hao?',26124),
(65591,'enUS','','Yes, Hao - our home is on Shen-zin Su\'s back.',26124),
(65592,'enUS','','Liu Lang discovered many things as he explored the world - oh - yes, Hao?',26124),
(65593,'enUS','','That\'s a good question. Nobody has spoken to Shen-zin Su for many generations. He only ever spoke to Liu Lang.',26124),
(65594,'enUS','','But I am certain that Shen-zin Su knows we are here. And he cares for every one of us!',26124),
(65595,'enUS','','Especially Hao! Liu Lang once said, \"Noble is he who always asks questions.\"',26124),
(65596,'enUS','','\"We should all be like children, for the world is our elder, and has many things to teach us.\"',26124),
(65597,'enUS','','Students! Students! Pay attention now.',26124),
(65598,'enUS','','Does anyone know how often Liu Lang went back to Pandaria?',26124),
(65599,'enUS','','Haha, no Yin. Liu Lang would eat wherever he explored.',26124),
(65600,'enUS','','He returned to the main continent of Pandaria once every five years.',26124),
(65601,'enUS','','You are right, Yin. It IS hidden away, behind a cloak of mists.',26124),
(65602,'enUS','','Does anyone remember how Liu Lang was always able to find it? Nan?',26124),
(65603,'enUS','','That\'s right! Liu Lang always had a way back home. Every five years, he would return, to pick up more explorers.',26124),
(65604,'enUS','','Yes Hao! Only the BRAVEST pandaren joined Liu Lang on his turtle to explore the world.',26124),
(65605,'enUS','','Shen-zin Su hasn\'t made landfall for a long time. But that hasn\'t stopped some pandaren from exploring, anyway.',26124),
(65606,'enUS','','Yes, like Chen and Li Li! They\'re out, exploring the world. Maybe someday you will, too.',26124),
(65607,'enUS','','I\'m glad you asked, Yin. Liu Lang explored the world his entire life, and raised many children here on the Wandering Isle.',26124),
(65608,'enUS','','Eventually he grew very old, and visited Pandaria one final time.',26124),
(65609,'enUS','','But nobody else wanted to go exploring with him. So he left.',26124),
(65610,'enUS','','Shen-zin Su has never returned to Pandaria.',26124),
(65611,'enUS','','Tired now, Liu Lang said goodbye to Shen-zin Su, his oldest friend.',26124),
(65612,'enUS','','Then, Liu Lang went up to the Wood of Staves, carrying with him a bamboo umbrella that he always took on his adventures.',26124),
(65613,'enUS','','He opened his umbrella, planted it in the ground, and sat underneath its cool shade.',26124),
(65614,'enUS','','He closed his eyes, and became one with the land. And then - do you know what happened?',26124),
(65615,'enUS','','His umbrella... sprouted! It grew roots, flowered, and became a tree!',26124),
(65616,'enUS','','Well, it\'s true. If you ever go to the Wood of Staves, you can see it.',26124),
(65617,'enUS','','Along with the budding staves of all the elders who came before us, growing now into giant trees.',26124),
(65618,'enUS','','It\'s not a sad story! Liu Lang himself said, \"Never mourn a life well-lived.\"',26124),
(65619,'enUS','','And I think he lived a very very good life. We owe everything we have to Liu Lang, the first pandaren explorer.',26124),
(65620,'enUS','','We tell his story, so that he will always be remembered.',26124),
(65621,'enUS','','Thank you, Ruolin! That was beautiful.',26124),
(65622,'enUS','','Could you sing it once more, for the students who just arrived?',26124),
(65623,'enUS','An honorable end to the noble Maki... I\'m sure his clan would be proud, if he hadn\'t been the last of them!','',26124),
(65624,'enUS','The Shado-Pan always friend of the grummles. Why are they not letting us in to trade?','',26124),
(65625,'enUS','We travel long long way. Now Shado-Pan say they do not want our goods. This is most strange.','',26124),
(65626,'enUS','We travelled through angry hozen, rampaging yeti, and unclean yaks to get here. Now the Shado-Pan act like we are strangers.$b$bThis very bad fortune indeed.','',26124),
(65627,'enUS','My nose is cold. That is a very bad sign.','',26124),
(65628,'enUS','I lost my yak on the road here. This is most not good.','',26124),
(65629,'enUS','If this Shado-Pan not let us in soon, I will make him smell MY luckydo.','',26124),
(65630,'enUS','This is most strange. Shado-Pan are our best customers. We sell them supplies, and they keep us safe.$b$bWhy are they turning us away? This I do not understand.','',26124),
(65631,'enUS','Why can\'t I understand any of the words?','',26124),
(65632,'enUS','Flitting through the mists with death upon his fists comes the sinister and serene jinyu assassin: Satay Byu!','',26124),
(65633,'enUS','Ooo, that\'s one killer carp whose slaying days have come to a fishy end.','',26124),
(65634,'enUS','','What is the song about?',26124),
(65635,'enUS','','Shen-zin Su!',26124),
(65636,'enUS','Everyone, please cheer for the NEW CHAMPIONS of the Arena of Annihilation!','',26124),
(65637,'enUS','We live on the back of a big turtle?!','',26124),
(65638,'enUS','','Sheesh, Hao. Haven\'t you ever paid attention?',26124),
(65639,'enUS','I just thought it was weird that the mountains had flippers!','',26124),
(65640,'enUS','Does the turtle know we\'re here?','',26124),
(65641,'enUS','','Even Hao?',26124),
(65642,'enUS','Hey!','',26124),
(65643,'enUS','Yeah, you should all be more like me.','',26124),
(65644,'enUS','','Blerch! I\'d rather jump off this bridge.',26124),
(65645,'enUS','','...Whenever he got hungry?',26124),
(65646,'enUS','','But isn\'t Pandaria hidden somewhere? Nobody can find it!',26124),
(65647,'enUS','','Because sea turtles always return to the beach where they were born!',26124),
(65648,'enUS','Does that mean our moms and dads and grandparents were all explorers, too?','',26124),
(65649,'enUS','','But we don\'t explore very much anymore, do we?',26124),
(65650,'enUS','','Like Chen and Li Li Stormstout!',26124),
(65651,'enUS','I want to explore the world!','',26124),
(65652,'enUS','','No you don\'t. It\'s full of trolls.',26124),
(65653,'enUS','Oh. Well, forget it then.','',26124),
(65654,'enUS','','Lorewalker! What ever happened to Liu Lang?',26124),
(65655,'enUS','What?','',26124),
(65656,'enUS','','What? What?',26124),
(65657,'enUS','That\'s un-possible!','',26124),
(65658,'enUS','','That\'s a sad story!',26124),
(65659,'enUS','He tampers with the lock on your cage.','',26124),
(65660,'enUS','He gestures towards the eastern vale, then disappears in the shadows.','',26124),
(65661,'enUS','He struggles to free himself.','',26124),
(65662,'enUS','He collapses to the floor in exhaustion.','',26124),
(65663,'enUS','He points down the hall ahead.','',26124),
(65664,'enUS','He motions for you to wait.','',26124),
(65665,'enUS','He continues cautiously.','',26124),
(65666,'enUS','You can use the bombs and cannons nearby to blast the hozen away!','You can use the bombs and cannons nearby to blast the hozen away!',26124),
(65667,'enUS','I thought this was a tournament of \"strength.\" Yet I see only weakness.','',26124),
(65668,'enUS','I am the weapon of kings! What makes you think you have a chance?','',26124),
(65669,'enUS','You will fail.','',26124),
(65670,'enUS','Err... What was that?','',26124),
(65671,'enUS','Whoa!  Careful over there!  These tiles have violent tendencies...','',26124),
(65672,'enUS','Cloud tile good.  Other tiles bad.  There was a tile at the bottom of the entrance stairs that tipped me off.  My sharp eyes have saved my delicate features yet again!','',26124),
(65673,'enUS','Oh dear! It looks like we\'ve got company... You take care of those mongrels, and I\'ll get the brew going.','',26124),
(65674,'enUS','Phew! That was close. Ok, here\'s the deal...','',26124),
(65675,'enUS','The mogu, they seem not so good at this game, if their dead bodies are any indication.','',26124),
(65676,'enUS','I see, I see.','',26124),
(65677,'enUS','Mmmm, shall we?','',26124),
(65678,'enUS','I think I would quite enjoy skipping stones down that hallway.  It would be quite the display!','',26124),
(65679,'enUS','Now where\'s that big mogu baddy that came tramping through here a short bit ago?','',26124),
(65680,'enUS','He\'s... so...','',26124),
(65681,'enUS','...ugly!','',26124),
(65682,'enUS','What are you doing here anyway?  Come all the way down here to bask in my marvelous company?','',26124),
(65683,'enUS','Zhi sent me.','Zhi sent me.',26124),
(65684,'enUS','WIKKETS!!!','',26124),
(65685,'enUS','Fools, you will die with me!','',26124),
(65686,'enUS','I have failed, but you will not live to tell anyone of this victory!','',26124),
(65687,'enUS','Artillery will scorch the ground, leaving nothing!','',26124),
(65688,'enUS','Reinforcements, get over here and kill these weaklings!','',26124),
(65689,'enUS','Haha, flightless fools!','',26124),
(65690,'enUS','Oh no...','Oh no...',26124),
(65691,'enUS','What are we going to do?!','What are we going to do?!',26124),
(65692,'enUS','The yaungol ruin everything!','The yaungol ruin everything!',26124),
(65693,'enUS','Again?!','Again?!',26124),
(65694,'enUS','Can\'t we get one night of peace?','Can\'t we get one night of peace?',26124),
(65695,'enUS','Everyone quiet down, let Hsieh speak.','',26124),
(65696,'enUS','You saved us, $p!','You saved us, $p!',26124),
(65697,'enUS','What would we do without you, $p?','What would we do without you, $p?',26124),
(65698,'enUS','The festival is saved!','The festival is saved!',26124),
(65699,'enUS','You\'re the greatest, $p!','You\'re the greatest, $p!',26124),
(65700,'enUS','Marry me, $p!','Marry me, $p!',26124),
(65701,'enUS','With $p around the yaungol didn\'t stand a chance!','With $p around the yaungol didn\'t stand a chance!',26124),
(65702,'enUS','You really kicked some yaungol butt, $p!','You really kicked some yaungol butt, $p!',26124),
(65703,'enUS','Let\'s rename the village to $p town!','Let\'s rename the village to $p town!',26124),
(65704,'enUS','Good work, $p, you saved the village. We are forever in your debt.','',26124),
(65705,'enUS','','Hey, $n! I\'m brewing up something special for the festival. Come back later and I\'ll share some with you.',26124),
(65706,'enUS','','It\'s ready! I put it over on the table.',26124),
(65707,'enUS','','What\'s all that noise outside?',26124),
(65708,'enUS','','It didn\'t come out very good, $n. You wouldn\'t want any.',26124),
(65709,'enUS','I need a minute to recover.','I need a minute to recover.',26124),
(65710,'enUS','I must recover my strength.','I must recover my strength.',26124),
(65711,'enUS','Protect me!','Protect me!',26124),
(65712,'enUS','Not like this...','Not like this...',26124),
(65713,'enUS','Your minds is weak.','',26124),
(65714,'enUS','Such a weak creature.','',26124),
(65715,'enUS','Another weakling.','',26124),
(65716,'enUS','You will serve me well.','',26124),
(65717,'enUS','You have come to your grave.','',26124),
(65718,'enUS','You will make an excellent pet.','',26124),
(65719,'enUS','Quickly, everyone to arms!','',26124),
(65720,'enUS','The temple will not fall!','',26124),
(65721,'enUS','We will not allow this to come to pass.','',26124),
(65722,'enUS','We owe you a great debt.','',26124),
(65723,'enUS','Today, we welcome you into the Shado-Pan.','',26124),
(65724,'enUS','Your perseverance strengthens us. Your courage leads us. Your honor inspires us.','',26124),
(65725,'enUS','From this day forth, you walk as one of us.','',26124),
(65726,'enUS','Go forth, as a member of the Shado-Pan!','',26124),
(65727,'enUS','About time!','',26124),
(65728,'enUS','Let\'s go for a drink!','',26124),
(65729,'enUS','We knew you could do it!','',26124),
(65730,'enUS','These guys have no taste.','',26124),
(65731,'enUS','I\'ve got a special mix for you!','',26124),
(65732,'enUS','So predictable.','',26124),
(65733,'enUS','I\'ve fought Virmen more clever than you.','',26124),
(65734,'enUS','You\'d fight better if you\'d loosen up.','',26124),
(65735,'enUS','Nice moves. I\'ll have to study those.','',26124),
(65736,'enUS','If fighting like that works for you, I guess it\'s fine...','',26124),
(65737,'enUS','Huh? Oh, hey, enemies.','',26124),
(65738,'enUS','During that fight, I thought of a great new brew.','',26124),
(65739,'enUS','We\'re way out of these guys league.','',26124),
(65740,'enUS','Beer before liquor, never fought quicker.','',26124),
(65741,'enUS','Very creative fighting, there.','',26124),
(65742,'enUS','What? No!','',26124),
(65743,'enUS','We\'ve got to stop them!','',26124),
(65744,'enUS','There\'s no way you\'re getting past us.','',26124),
(65745,'enUS','Crossing the Shado-Pan was a bad idea.','',26124),
(65746,'enUS','Good job. Guess you learned a little something from me.','',26124),
(65747,'enUS','%s becomes enraged at being separated from his Ambercaller!','',26124),
(65748,'enUS','The mogu are attacking the temple!','',26124),
(65749,'enUS','The mogu are attacking Niuzao Temple. We need your help.','',26124),
(65750,'enUS','Quickly, everyone to arms!','',26124),
(65751,'enUS','Believe in your own strength.','',26124),
(65752,'enUS','Drive them back!','',26124),
(65753,'enUS','Do not give up!','',26124),
(65754,'enUS','As long as I stand, this temple will never fall.','',26124),
(65755,'enUS','Charge!','',26124),
(65756,'enUS','Drive them back!','',26124),
(65757,'enUS','Believe in your strength!','',26124),
(65758,'enUS','Your power is mine!','',26124),
(65759,'enUS','Break yourselves upon me!','',26124),
(65760,'enUS','I shall show you TRUE strength!','',26124),
(65761,'enUS','I will break you!','',26124),
(65762,'enUS','You will never prevail!','',26124),
(65763,'enUS','I will show you the heart of fear!','',26124),
(65764,'enUS','Your weakness betrays you.','',26124),
(65765,'enUS','Scatter like leaves upon the wind!','',26124),
(65766,'enUS','You are nothing.','',26124),
(65767,'enUS','No. NO!','',26124),
(65768,'enUS','I cannot be defeated!','',26124),
(65769,'enUS','This is not what was promised!','',26124),
(65770,'enUS','My power wanes!','',26124),
(65771,'enUS','Master, command me!','',26124),
(65772,'enUS','The storm will consume you!','',26124),
(65773,'enUS','You cannot escape the storm.','',26124),
(65774,'enUS','Strike!','',26124),
(65775,'enUS','Master, I have failed you...','',26124),
(65776,'enUS','The mantid besiege you from all sides.','',26124),
(65777,'enUS','Your temple is broken.','',26124),
(65778,'enUS','Your defenders are slain.','',26124),
(65779,'enUS','You are forgotten. This is what you fear, is it not?','',26124),
(65780,'enUS','So far away, here on the dark side of the wall.','',26124),
(65781,'enUS','You stand alone against the might of the swarm, a single light in a sea of darkness.','',26124),
(65782,'enUS','Do your celestial brothers and sisters lend you their aid? No, they do not.','',26124),
(65783,'enUS','If you fall, who would notice?','',26124),
(65784,'enUS','Grant your celestial mantle to my pet, and let a new celestial take your place!','',26124),
(65785,'enUS','Then I have no other choice than to kill you.','',26124),
(65786,'enUS','Shan-ze! Hei Feng! Kill him!','',26124),
(65787,'enUS','Ha! Too easy!','Ha! Too easy!',26124),
(65788,'enUS','Ha! Good fun!','Ha! Good fun!',26124),
(65789,'enUS','Time to crush our enemies.','Time to crush our enemies.',26124),
(65790,'enUS','Good fighting, friend!','Good fighting, friend!',26124),
(65791,'enUS','Let\'s see what you\'ve got!','Let\'s see what you\'ve got!',26124),
(65792,'enUS','Rraaaagh!','Rraaaagh!',26124),
(65793,'enUS','So easy. What a disappointment!','So easy. What a disappointment!',26124),
(65794,'enUS','The smell of victory!','The smell of victory!',26124),
(65795,'enUS','Maybe you\'ll be a challenge?','Maybe you\'ll be a challenge?',26124),
(65796,'enUS','What a waste of time.','What a waste of time.',26124),
(65797,'enUS','Let\'s do this!','Let\'s do this!',26124),
(65798,'enUS','Honor in victory!','Honor in victory!',26124),
(65799,'enUS','','What? No!',26124),
(65800,'enUS','','That\'s NOT going to happen.',26124),
(65801,'enUS','','Destroy them!',26124),
(65802,'enUS','','They are falling! Don\'t stop now!',26124),
(65803,'enUS','','Good work! You\'re quite a fighter.',26124),
(65804,'enUS','','I love the feeling after a good fight.',26124),
(65805,'enUS','','Let\'s celebrate!',26124),
(65806,'enUS','Keep them back!  They will not delve into our secrets!','',26124),
(65807,'enUS','This fight is favorable to us.','',26124),
(65808,'enUS','Take care - do not lower your guard.','',26124),
(65809,'enUS','So, we live to fight another day.','',26124),
(65810,'enUS','We will not falter.','',26124),
(65811,'enUS','We fought well, but we should not push our luck.','',26124),
(65812,'enUS','Strike at the enemy - I shall be your shield.','',26124),
(65813,'enUS','We fight, that others may live in peace.','',26124),
(65814,'enUS','You fight well. Beware overconfidence.','',26124),
(65815,'enUS','For the fallen!','',26124),
(65816,'enUS','Your kind shall spill innocent blood no longer!','',26124),
(65817,'enUS','The battle is won.','',26124),
(65818,'enUS','I will breathe easier knowing this one is gone.','',26124),
(65819,'enUS','No!','',26124),
(65820,'enUS','This cannot stand.','',26124),
(65821,'enUS','For the Shado-Pan!','',26124),
(65822,'enUS','Perseverance! Victory is in our grasp.','',26124),
(65823,'enUS','Well fought. I am glad you survived the battle.','',26124),
(65824,'enUS','I am honored to fight alongside you.','',26124),
(65825,'enUS','I go to contemplate those who could not share this victory with us.','',26124),
(65826,'enUS','I need some training.','I need some training.',26124),
(65827,'enUS','A new continent full of forgotten secrets!  Share what you learn with the Lorewalkers here and me, and I\'ll let you in on some of my other projects.','A new continent full of forgotten secrets!  Share what you learn with the Lorewalkers here and me, and I\'ll let you in on some of my other projects.',26124),
(65828,'enUS','Let me in on your other projects.','Let me in on your other projects.',26124),
(65829,'enUS','Alright, recruits! Thanks to $p, we\'re going to reclaim Kun-Lai summit from the Yaungol and make it safe again. For the Horde!','',26124),
(65830,'enUS','You\'ve done great work here, friend. We should have a strong base of operations here going forward - see if anyone else needs your help.','',26124),
(65831,'enUS','For the Horde!','For the Horde!',26124),
(65832,'enUS','Recruits, I want you to remember that it was $p who saved you, and the Alliance who are going to save Kun-Lai!','',26124),
(65833,'enUS','You\'ve done great work. We should be able to maintain our base of operations here now without too much trouble.','',26124),
(65834,'enUS','For the Alliance!','For the Alliance!',26124),
(65835,'enUS','','I hate you all!',26124),
(65836,'enUS','','Why? Why did it have to be him?',26124),
(65837,'enUS','','I will have justice!',26124),
(65838,'enUS','','Death for death!',26124),
(65839,'enUS','','Do not forget to speak to Fei Li before you depart. You will find her skills useful against our enemies.',26124),
(65840,'enUS','You have grown stronger than I ever expected.','You have grown stronger than I ever expected.',26124),
(65841,'enUS','If you ever have need of a healer in battle, speak to me.','If you ever have need of a healer in battle, speak to me.',26124),
(65842,'enUS','It would be my honor to join you in battle.','It would be my honor to join you in battle.',26124),
(65843,'enUS','Trust in the might of your Empress. She shall lead us to glory!','',26124),
(65844,'enUS','Together, the swarm will rise higher than any empire this land has ever known!','',26124),
(65845,'enUS','The will of the Empress is our own. Her greatness is our greatness. Her victory is a victory for the swarm!','',26124),
(65846,'enUS','You dare challenge the voice of the Empress? What the voice speaks, the swarm hears!','',26124),
(65847,'enUS','Blasphemy! You are not one of the swarm!','',26124),
(65848,'enUS','You are but one against the Empress\'s divine wrath! You, too, will fall!','',26124),
(65849,'enUS','The swarm is the blade that will cut through our enemies!','',26124),
(65850,'enUS','A single cut should do.','',26124),
(65851,'enUS','Our enemies will fall beneath our blades!','',26124),
(65852,'enUS','Do you wish to test the edge of my blade?','',26124),
(65853,'enUS','I smell the stench of Klaxxi disobedience! Stop running and face the Lord of Blades!','',26124),
(65854,'enUS','Ahahhhaahaa... was that supposed to hurt?','',26124),
(65855,'enUS','The cold wind blows. The time of the swarm has begun!','',26124),
(65856,'enUS','Do they think a wall can stop us? Do they believe that stone can stand against those who ride upon the wind?','',26124),
(65857,'enUS','The swarm shall darken the skies with our numbers! We shall cast eternal night upon this land!','',26124),
(65858,'enUS','Infiltrator! You cannot hope to stop the swarm!','',26124),
(65859,'enUS','Flying away, little rider? A true champion would face me in the heart of fear!','',26124),
(65860,'enUS','A pitiful attempt.','',26124),
(65861,'enUS','Yes, my little monsters! Go! Unleash yourselves upon our enemies!','',26124),
(65862,'enUS','The next stage of my experiment begins!','',26124),
(65863,'enUS','Ahh, if I could just get my hands on you! You would make a very nice experiment!','',26124),
(65864,'enUS','Auuugghhh! That hurt!','',26124),
(65865,'enUS','Are you... afraid?','',26124),
(65866,'enUS','The island swarms with the Empress\'s minions.','',26124),
(65867,'enUS','This will not be an easy fight to win.','',26124),
(65868,'enUS','The Empress must be brought to justice.','',26124),
(65869,'enUS','Do not fear.','',26124),
(65870,'enUS','Fear is an illusion.','',26124),
(65871,'enUS','Onward, warrior!','',26124),
(65872,'enUS','Attack!','',26124),
(65873,'enUS','For the swarm!','',26124),
(65874,'enUS','Justice will prevail.','',26124),
(65875,'enUS','She must answer for her crimes.','',26124),
(65876,'enUS','You have done well, wallwalker.','',26124),
(65877,'enUS','You are braver than you look, stranger.','',26124),
(65878,'enUS','Do not let the fear consume you!','',26124),
(65879,'enUS','We cannot let them destroy this tree.','',26124),
(65880,'enUS','We cannot let them destroy this tree. It is the last of its kind.','',26124),
(65881,'enUS','The war is not over, but we have dealt them a bitter blow.','',26124),
(65882,'enUS','Do not cross a Klaxxi.','',26124),
(65883,'enUS','Ahhh, look who has joined us.','',26124),
(65884,'enUS','I see the paragons have finally arrived to save the day.','',26124),
(65885,'enUS','You are ancient relics of a bygone age!','',26124),
(65886,'enUS','What can you hope to do against the might of the swarm?','',26124),
(65887,'enUS','So few. So weak.','',26124),
(65888,'enUS','The swarm will consume you!','',26124),
(65889,'enUS','Fear me!','',26124),
(65890,'enUS','Frightening, isn\'t it?','',26124),
(65891,'enUS','Are you... frightened?','',26124),
(65892,'enUS','Behold the might of the swarm!','',26124),
(65893,'enUS','Join us!','',26124),
(65894,'enUS','I am... alone.','',26124),
(65895,'enUS','No. NO!','',26124),
(65896,'enUS','It was not... enough.','',26124),
(65897,'enUS','I have failed you, Empress.','',26124),
(65898,'enUS','I will be avenged!','',26124),
(65901,'enUS','Whoever said they\'d rather light a candle than curse the darkness...$b$bWell, they probably haven\'t lit as many candles as me.','',26124),
(65902,'enUS','Can I have a Red Radish?','Can I have a Red Radish?',26124),
(65903,'enUS','Do you have a spare Sweet Lakemelon?','Do you have a spare Sweet Lakemelon?',26124),
(65904,'enUS','Could I have a Fuzzy Peach for Ella?','Could I have a Fuzzy Peach for Ella?',26124),
(65905,'enUS','Do you have any Black Cherries?','Do you have any Black Cherries?',26124),
(65906,'enUS','','Awww shucks, I was gonna eat these! Well, if Ella needs \'em, I ain\'t gonna no more. Here, take \'em!',26124),
(65907,'enUS','A radish for sweet little Ella? Well, I sure can spare one. Here you go.','',26124),
(65908,'enUS','Little Ella\'s trying her hand at brewing? Well, I\'ll be! I wish her luck. Brewing isn\'t something a novice can just take up, you know. Anyhow, I can spare a Lakemelon for her.','',26124),
(65909,'enUS','','I was going to charge you a pretty penny for that peach, but Ella is such a good customer at my market, this one\'s on the house. Just this once, ya hear!',26124),
(65910,'enUS','','It is said, \"Turn your face towards the sun, and the shadows will fall behind you.\"$b$bI hope you find many bright days ahead of you, $n!',26124),
(65911,'enUS','Wow! Thish ish shome amazing shtuff! Where can I get shome more?','',26124),
(65912,'enUS','Hmmm, this is excellent! EXCELLENT! This is the best stuff I\'ve tasted in a long time. Who brewed it?','',26124),
(65913,'enUS','Mmm, that\'s mighty tasty, $n. I wouldn\'t mind another round of that... or two... hic!','',26124),
(65914,'enUS','','Mmmmm, I haven\'t tasted a brew of this complexity and clarity since... well... since the golden age of the Stormstout Brewery! Whoever made this has a real talent.',26124),
(65915,'enUS','Your skill in cooking is only as great as your most advanced Way.','Your skill in cooking is only as great as your most advanced Way.',26124),
(65916,'enUS','Mmmmm. Mmmmmm...... This is... simply put... amazing. Your friend Ella has real talent! Tell her to speak to my Uncle Gao at the Brewery. I think she has found a new home with us Stormstouts.','',26124),
(65917,'enUS','<Mishi looks at you with concern.>','',26124),
(65918,'enUS','<Mishi is puzzled by your actions.>','',26124),
(65919,'enUS','<Mishi wonders what you are doing.>','',26124),
(65920,'enUS','<Mishi tilts his head curiously at you.>','',26124),
(65921,'enUS','<Mishi watches you.>','',26124),
(65922,'enUS','<Mishi is very happy with you!>','',26124),
(65923,'enUS','<Mishi bobs up and down excitedly.>','',26124),
(65924,'enUS','<Mishi smiles at you.>','',26124),
(65925,'enUS','<Mishi bobs up and down with glee.>','',26124),
(65926,'enUS','<Mishi is happy!>','',26124),
(65927,'enUS','Throw a Spiced Punch to knock hozen off the cart!','Throw a Spiced Punch to knock hozen off the cart!',26124),
(65928,'enUS','Throw a Spiced Punch on hozen who jump on the cart!','Throw a Spiced Punch on hozen who jump on the cart!',26124),
(65929,'enUS','Whew! Everything should be smooth sailing from here on out!','Whew! Everything should be smooth sailing from here on out!',26124),
(65930,'enUS','This is the closest any outsider has come to the Engine of Nalak\'sha.','',26124),
(65931,'enUS','Looks like we did it! We\'re in the clear!','Looks like we did it! We\'re in the clear!',26124),
(65932,'enUS','They\'re gone! Whew! Looks like the trail is clear.','They\'re gone! Whew! Looks like the trail is clear.',26124),
(65933,'enUS','We did it! The trail should be clear from here on.','We did it! The trail should be clear from here on.',26124),
(65934,'enUS','Oh great luckydos! What is THAT!?','Oh great luckydos! What is THAT!?',26124),
(65935,'enUS','Oh most unluckiest of days! What is THAT!?','Oh most unluckiest of days! What is THAT!?',26124),
(65936,'enUS','We shou-- oh most unluckiest of days! What is THAT!?','We shou-- oh most unluckiest of days! What is THAT!?',26124),
(65937,'enUS','Auuughh! Yeti on the trail!','Auuughh! Yeti on the trail!',26124),
(65938,'enUS','Auuughh! Yeti on the trail! Go yak! Faster, faster!','Auuughh! Yeti on the trail! Go yaks! Faster, faster!',26124),
(65939,'enUS','Auuughh! Yeti on the trail! Looks like we aren\'t in the clear yet!','Auuughh! Yeti on the trail! Looks like we aren\'t in the clear yet!',26124),
(65940,'enUS','These secrets will die with you.','',26124),
(65941,'enUS','We are on our way to the Wanderer\'s Festival. You should join us!','We are on our way to the Wanderer\'s Festival. You should join us!',26124),
(65942,'enUS','The Wanderer\'s Festival is tonight. Are you coming?','The Wanderer\'s Festival is tonight. Are you coming?',26124),
(65943,'enUS','What is the Wanderer\'s Festival?','What is the Wanderer\'s Festival?',26124),
(65944,'enUS','Legend has it that Liu Lang once set out to explore the seas beyond Pandaria on the back of a giant turtle. Every few years, he would come back, always seeking new explorers to travel with him. To this day, whenever a pandaren is daydreaming or staring off into space, we ask if they\'re \"waiting for the turtle.\"$b$bMost pandaren aren\'t very adventurous - they like to stay close to hearth and home. But some of us are still dreamers... Tonight we gather at Turtle Beach on the southern coast to gaze out at the sea and celebrate Liu Lang\'s spirit of adventure.$b$bIt\'s called the Wanderer\'s Festival.','Legend has it that Liu Lang once set out to explore the seas beyond Pandaria on the back of a giant turtle. Every few years, he would come back, always seeking new explorers to travel with him. To this day, whenever a pandaren is daydreaming or staring off into space, we ask if they\'re \"waiting for the turtle.\"$b$bMost pandaren aren\'t very adventurous - they like to stay close to hearth and home. But some of us are still dreamers... Tonight we gather at Turtle Beach on the southern coast to gaze out at the sea and celebrate Liu Lang\'s spirit of adventure.$b$bIt\'s called the Wanderer\'s Festival.',26124),
(65945,'enUS','This is the Wanderer\'s Festival, $n! Where pandaren with the spirit of adventure gather to celebrate the first explorer to venture beyond the mists.$b$bIt\'s a time of contemplation and song. Thank you for joining us!','This is the Wanderer\'s Festival, $n! Where pandaren with the spirit of adventure gather to celebrate the first explorer to venture beyond the mists.$b$bIt\'s a time of contemplation and song. Thank you for joining us!',26124),
(65946,'enUS','What is going on here?','What is going on here?',26124),
(65947,'enUS','','Welcome, $n!$b$bThis is the \"Wanderer\'s Festival,\" where we celebrate the deeds of the first pandaren explorer and gather on the beach to gaze out across the sea.$b$bThere was a time when the mists that cloaked Pandaria were so thick, sometimes you couldn\'t even see that large rock just off the shore there. Now look at it - what a glorious night! I\'m glad you are here for this.',26124),
(65948,'enUS','','Lorewalker Cho! I\'m so glad you\'re joining us this week.',26124),
(65949,'enUS','','Can you sing for us the song of Liu Lang?',26124),
(65950,'enUS','','Your voice is so beautiful. Sometimes I swear I could hear a whole orchestra when you sing!',26124),
(65951,'enUS','','Thank you, Lorewalker!',26124),
(65952,'enUS','$n! I am delighted to see that you are celebrating the Wanderer\'s Festival with us!$b$bIt is often said that pandaren are not the adventurous sort. But look around at these faces - ah, you see? The starry eyes of dreamers!$b$bI should think that someday soon, there will be many more pandaren adventurers to speak of, making a difference all over the world. Don\'t you think?','',26124),
(65953,'enUS','Here\'s a real surprise for you. What do you suppose they\'re celebrating? And what do you think would be the proper drink to mark the occasion?','',26124),
(65954,'enUS','','Wow, incredible! Look at all the lights!$b$BWhat\'s going on do you think? Who\'s the guy on the turtle?$b$bWaaaaaiitt - is that Liu Lang?$b$bThat turtle must be Shen-zin Su. It IS! That statue is of a tiny baby Wandering Isle!$b$BWe\'re home, Uncle Chen!$b$bWell, sorta.',26124),
(65955,'enUS','Avoid or destroy Gash\'nul\'s Storm Totems.','',26124),
(65956,'enUS','%s is dismounted from his wind rider.','',26124),
(65957,'enUS','Ba-Bam still up and Bammin\' Brews!','',26124),
(65958,'enUS','Dancin\' like a monkey!','',26124),
(65959,'enUS','Heyarrr! I has me brew.','',26124),
(65960,'enUS','Ookie\'s still cookin\' and brewin\'!','',26124),
(65961,'enUS','Grooka Grooka gonna light this party up!','',26124),
(65962,'enUS','I would like to practice catch with a baby serpent.','I would like to practice catch with a baby serpent.',26124),
(65963,'enUS','','It looks like you are already playing catch with your serpent, $n. You can only play catch with one serpent at a time.$B$BPlease finish your current training session before practicing with another serpent.',26124),
(65964,'enUS','I am done practicing. Please take your hatchling back.','I am done practicing. Please take your hatchling back.',26124),
(65965,'enUS','This place is all shiny. Not sure I like it. Seems like it is missing that \"lived in\" smell.','',26124),
(65966,'enUS','Search the island to collect brew for Bo\'s cauldron! But be sure to leave one person nearby to defend Bo!','Search the island to collect brew for Bo\'s cauldron! But be sure to leave one person nearby to defend Bo!',26124),
(65967,'enUS','Throw the Bouncy Ball to your serpent and see how long you can keep it in the air! When you are done playing, speak to me and I will take your serpent. Good luck!','Throw the Bouncy Ball to your serpent and see how long you can keep it in the air! When you are done playing, speak to me and I will take your serpent. Good luck!',26124),
(65968,'enUS','Well, how did it go? Well, I hope?','Well, how did it go? Well, I hope?',26124),
(65969,'enUS','Fixing','Fixing',26124),
(65970,'enUS','','Children of Pandaria. The mists have fallen. For good or for ill, our land is open to all.',26124),
(65971,'enUS','','Let us draw ourselves together to rebuild this sacred place, the first step toward healing a war-torn world.',26124),
(65972,'enUS','I have faith in our friends from beyond the mists.','',26124),
(65973,'enUS','Their strength is an inspiration... and sorely needed. We must trust that their hearts are pure.','',26124),
(65974,'enUS','Just one... more... catch!','',26124),
(65975,'enUS','Alliance... near...','',26124),
(65976,'enUS','Let my strength be your strength. Go and destroy our enemies!','',26124),
(65977,'enUS','My pheromones should be useful when dealing with multiple enemies.','',26124),
(65978,'enUS','Go ahead and turn this thing on.','Go ahead and turn this thing on.',26124),
(65979,'enUS','','No no, don\'t try to get up. Your war isn\'t here, soldier - you need your rest',26124),
(65980,'enUS','|TInterface\\Icons\\ability_warlock_soulsiphon:20|t%s begins to cast |cFFFF0000|Hspell:126299|h[Unleash Souls]|h|r! Get in the water!','',26124),
(65981,'enUS','The architecture in here is strange, differing in many ways from traditional mogu design. This room seems to be a device of some sort, but I see nothing of its purpose in my notes.  \n$bThe only way for us to figure out what this is for is to activate it and observe.\n$bWhat\'s the worst that could happen?','',26124),
(65982,'enUS','We\'ve been flying in this mist for hours, General. The crew grows... uneasy.','',26124),
(65983,'enUS','Back to your post, soldier! We\'ll find this land, or die trying.','',26124),
(65984,'enUS','Alliance ship! Portside!','',26124),
(65985,'enUS','Attack!','',26124),
(65986,'enUS','Enemy ship, starboard! Ready the guns! Fire at will!','',26124),
(65987,'enUS','|TInterface\\Icons\\ability_warrior_charge.blp:20|t%s sets his eyes on |cFFFF0000$n|r and begins to cast |cFFFF0000|Hspell:127245|h[Fatal Blow]|h|r! Move!','',26124),
(65988,'enUS','Horde... here...','',26124),
(65989,'enUS','Direct hit! She\'s goin\' down!','',26124),
(65990,'enUS','Land ho!','',26124),
(65991,'enUS','This room pulses with energy, but feels unlike any we have seen so far.','',26124),
(65992,'enUS','Fascinating, I have never heard tales of anything like this. The mogu hide their secrets well.','',26124),
(65993,'enUS','This seems to be a terminal controlling the device. Let\'s see here...','',26124),
(65994,'enUS','More strangers seem to wash up on our beaches every day.$b$bThis bunch was still trying to shoot at each other until yesterday evening. I hope this isn\'t a sign of what\'s to come.','More strangers seem to wash up on our beaches every day.$b$bThis bunch was still trying to shoot at each other until yesterday evening. I hope this isn\'t a sign of what\'s to come.',26124),
(65995,'enUS','Uhh, somethin\' ain\'t right, General... We\'re losin\' altitude! Fast!','',26124),
(65996,'enUS','Sensors online. All cores operating at peak efficiency.','',26124),
(65997,'enUS','Enabling','Enabling',26124),
(65998,'enUS','Identification matrix mismatch. Unknown entities detected.','',26124),
(65999,'enUS','%s casts |cFFFF0000|Hspell:116529|h[Power Down]|h|r!','',26124),
(66000,'enUS','Magnificent! It talks! This seems beyond what we thought the mogu were capable of.','',26124),
(66001,'enUS','Oh dear...this could get messy. I will observe from a safer distance!','',26124),
(66002,'enUS','Do you require anything?','',26124),
(66003,'enUS','We shall hunt our foes.','',26124),
(66004,'enUS','','I will be the blade at the throat of our enemies.',26124),
(66005,'enUS','The machine has been destroyed, and so the mogu\'s power weakens.','',26124),
(66006,'enUS','','None will stand against the Shado-Pan.',26124),
(66007,'enUS','These discs look familiar, but I cannot place their origin.','',26124),
(66008,'enUS','They call to me, the discs...I must...','',26124),
(66009,'enUS','I...I see everything clearly now.','',26124),
(66010,'enUS','The Titans! It would seem the mogu salvaged and repurposed ancient Titan technology to advance their empire!','',26124),
(66011,'enUS','We must go, we are not done yet.','',26124),
(66012,'enUS','Tenwu the Red Smoke greets you.','',26124),
(66013,'enUS','All enemies of the Shado-Pan will fall before Tenwu the Red Smoke!','',26124),
(66014,'enUS','Keep those archers off the wall. Raigonn must reach the gate.','',26124),
(66015,'enUS','Here... try this.','',26124),
(66016,'enUS','Oh, yes. Hrm. I\'m... sorry it wasn\'t to your liking...','',26124),
(66017,'enUS','She should be a pile of bones and slime! Strong of stomach, indeed...','',26124),
(66018,'enUS','There exist two great disciplines among our people. The Tushui are patient, pensive, and deliberate. The Huojin are fierce, forward, and active. Both disciplines serve us in their own way, and neither could exist effectively without the other.','',26124),
(66019,'enUS','I seek more than anything to help young pandaren explore their potential within these grounds. True mastery comes with much time and much practice, but there is value even in finding the first beginnings of a fitting path.','',26124),
(66020,'enUS','Fa... ther....','',26124),
(66021,'enUS','','Ah, sure.',26124),
(66022,'enUS','','Find strength in patience.',26124),
(66023,'enUS','','Wow! Uh, it\'s... interesting!',26124),
(66024,'enUS','Who holds this swarm? Show yourself! Answer to the Klaxxi.','',26124),
(66025,'enUS','Speak your name puppet, that our annals will be complete.','',26124),
(66026,'enUS','Your \"Empress\" has fallen. The Klaxxi have pronounced judgment. Stand aside or be brushed away.','',26124),
(66027,'enUS','Blaspheme!','',26124),
(66028,'enUS','','Only the gathered mind is truly prepared to face any trial.',26124),
(66029,'enUS','','Only a mind at peace can fully ready a body for battle.',26124),
(66030,'enUS','','Are you fascinated by the wonders of metallurgy? The artistry of smelting? The beauty of mixing metals and alloys?',26124),
(66031,'enUS','<cough> <hack> I have... returned.','',26124),
(66032,'enUS','Keep your seatbelts fastened... Just kidding, we don\'t have seatbelts!','Keep your seatbelts fastened... Just kidding, we don\'t have seatbelts!',26124),
(66033,'enUS','Are we there, yeti?','Are we there, yeti?',26124),
(66034,'enUS','Wakener, you deeds have earned you the trust of the Klaxxi.','',26124),
(66035,'enUS','I hope this yak knows the way up the mountain because I sure don\'t!','I hope this yak knows the way up the mountain because I sure don\'t!',26124),
(66036,'enUS','This is your first trip up Neverest? It\'s mine too!','This is your first trip up Neverest? It\'s mine too!',26124),
(66037,'enUS','','I understand that the mind of the Tushui is not the only path to wisdom, but there are yet choices that should not be accepted.  Risks that are too dangerous to ever be taken.  Decisions that I cannot forgive...$B$BIt is time for me to leave Shen-zin Su.  I have found respect for Delora Lionheart for her confidence and valor, and her tales of the Alliance speak well of her people.  I do not yet know if I will find a home there, but wherever my path may lead, I will find a way to help the world beyond this isle.$B$BDespite everything, I\'ve enjoyed what little time we\'ve had together, $n.  I hope that you might join me, but I understand that this decision is not an easy one.',26124),
(66038,'enUS','You are to be rewarded. Walk with me.','',26124),
(66039,'enUS','We can never rest until we get to the top! Heh? Get it?','We can never rest until we get to the top! Heh? Get it?',26124),
(66040,'enUS','We mantid are an elder race. The pandaren you associate with - they are but children. They have their role to play.','',26124),
(66041,'enUS','Each cycle, our young swarm their walls. The pandaren slay the weak. The strong return.','',26124),
(66042,'enUS','With each generation, we grow ever stronger.','',26124),
(66043,'enUS','Hmmm, maybe I should have taken the cart in for its tune-up after all.','Hmmm, maybe I should have taken the cart in for its tune-up after all.',26124),
(66044,'enUS','Before your history began, our empire was vast. We shared this world with our sister kingdoms, Ahn\'Qiraj and Azjol-Nerub.','',26124),
(66045,'enUS','Our Gods were many, and powerful. We mantid worshipped the seven heads of Y\'shaarj.','',26124),
(66046,'enUS','Great was the Old One, and terrible was His wrath. He consumed hope and begat despair; He inhaled courage and breathed fear.','',26124),
(66047,'enUS','When the usurpers came - the ones you call \"Titans\" - Y\'shaarj was destroyed.','',26124),
(66048,'enUS','His last terrible breath has haunted this land ever since, but the shadows he left behind are mere whispers of his former glory.','',26124),
(66049,'enUS','I tell you now, because you have earned this warning.','',26124),
(66050,'enUS','Your gods are not our gods, outsider.','',26124),
(66051,'enUS','If the Old Ones ever return, we mantid will once again stand by their side.','',26124),
(66052,'enUS','The wisest among you will do the same.','',26124),
(66053,'enUS','That is all that is to be said. Come, take your reward. And remember what you have learned today.','',26124),
(66054,'enUS','This day seems to be one full of hard decisions.  Having the courage to make them is gravely important, for the sake of us all.  I did what I had to do, and we may have all been doomed if I had not... but sadly, not all see it that way.$B$BIt is time for me to leave Shen-zin Su, that those here might be free from the burden of my difficult choice, and that I might fight on for the sake of a much larger world.$B$BI\'ve only known Korga a short time, but he and I could be brothers if he were born in different skin - he possesses bravery and honor that I would gladly stand beside.  You too could be my $gbrother:sister;, after all we\'ve been through together.  I\'m hoping you might join us, but I understand that there is much to consider.','',26124),
(66055,'enUS','','My family has crafted jade and gems for nearly ten generations. You may be surprised at what I can teach you.',26124),
(66056,'enUS','','I have to admit, that looked pretty fun!',26124),
(66057,'enUS','','And it looks to me like you made a new friend.',26124),
(66058,'enUS','','He was a tough one...',26124),
(66059,'enUS','Hammer and tongs. Hammer and tongs. All day long its hammer and tongs.','',26124),
(66060,'enUS','There are healers under some of the wreckage!  Get them free.','',26124),
(66061,'enUS','Find the healers and get them free of the fight.  We need them here at the wound!','',26124),
(66062,'enUS','Stay close and keep these healers safe.  Our lives depend on it.','',26124),
(66063,'enUS','If we lose the healers, Shen-zin Su dies, and all of us with him!  Keep them safe.','',26124),
(66064,'enUS','Come friend, the Horde awaits.','',26124),
(66065,'enUS','Lets find out what this warchief of theirs is made of.','',26124),
(66066,'enUS','Together we can use the Horde\'s might to make a better world.','',26124),
(66067,'enUS','|TInterface\\Icons\\warrior_talent_icon_lambstotheslaughter.blp:20|tYou are |cFFFF0000|Hspell:127275|h[Marked for Execution]|h|r!','',26124),
(66068,'enUS','','<Aysa appears to be deeply lost in her excercises.>',26124),
(66069,'enUS','Ah! A luckydo comes to learn? I have many skills to teach.','',26124),
(66070,'enUS','|TInterface\\Icons\\spell_shaman_staticshock.blp:20|t %s begins to cast |cFFFF0000|Hspell:124967|h[Draw Power]|h|r!','',26124),
(66071,'enUS','|TInterface\\Icons\\spell_shaman_staticshock.blp:20|t %s begins to cast |cFFFF0000|Hspell:119360|h[Draw Power]|h|r!','',26124),
(66072,'enUS','','Ah! A fan of potions? The brewmasters work their concoctions but often miss some of the finer notes to a potion or remedy.',26124),
(66073,'enUS','You want Wikky?','You want Wikky?',26124),
(66074,'enUS','You gots munchins?','You gots munchins?',26124),
(66075,'enUS','Why you call Wikky?','Why you call Wikky?',26124),
(66076,'enUS','What you want?','What you want?',26124),
(66077,'enUS','Wikky hear whistle!','Wikky hear whistle!',26124),
(66078,'enUS','Why you wake Wikky?','Why you wake Wikky?',26124),
(66079,'enUS','Wikky is here!','Wikky is here!',26124),
(66080,'enUS','Da Ook you want?','Da Ook you want?',26124),
(66081,'enUS','Wikky is helpful!','Wikky is helpful!',26124),
(66082,'enUS','What you want from Wikky?','What you want from Wikky?',26124),
(66083,'enUS','Forage for me, Wikky!','Forage for me, Wikky!',26124),
(66084,'enUS','Wikky be back soon!','Wikky be back soon!',26124),
(66085,'enUS','You the Ook!','You the Ook!',26124),
(66086,'enUS','Wikky find presents!','Wikky find presents!',26124),
(66087,'enUS','','Just because you put magic in to an artifact does not mean it has to stay there.',26124),
(66088,'enUS','Wikky is back!','Wikky is back!',26124),
(66089,'enUS','Yeah, you better run!','',26124),
(66090,'enUS','Wikky brings you presents!','Wikky brings you presents!',26124),
(66091,'enUS','Wikky dids what you asks!','Wikky dids what you asks!',26124),
(66092,'enUS','I\'m going to choke the life out of you, you little brats!','',26124),
(66093,'enUS','Wikky is helpful! See??','Wikky is helpful! See??',26124),
(66094,'enUS','Gonna bash you into pretty flower food!','Gonna bash you into pretty flower food!',26124),
(66095,'enUS','Blackhoof will pound you into dust!','Blackhoof will pound you into dust!',26124),
(66096,'enUS','Feel the strength of the Yaungol!','Feel the strength of the Yaungol!',26124),
(66097,'enUS','I am seeing red!','I am seeing red!',26124),
(66098,'enUS','You have woken the bull, now face the horns!','You have woken the bull, now face the horns!',26124),
(66099,'enUS','DAK WILL BREAK YOU!','DAK WILL BREAK YOU!',26124),
(66100,'enUS','My time with the Shado-Pan has taught me many secrets. Perhaps you have earned the right to learn some as well.','',26124),
(66101,'enUS','You! What are you doing here?','You! What are you doing here?',26124),
(66102,'enUS','The night is dark and savage.','The night is dark and savage.',26124),
(66103,'enUS','I will flay the flesh from your bones!','I will flay the flesh from your bones!',26124),
(66104,'enUS','I will banish you to the land of wind and ghosts!','I will banish you to the land of wind and ghosts!',26124),
(66105,'enUS','Feel the fist of darkness!','Feel the fist of darkness!',26124),
(66106,'enUS','Your end is near.','Your end is near.',26124),
(66107,'enUS','The darkness comes.','The darkness comes.',26124),
(66108,'enUS','Your souls will be MINE!','Your souls will be MINE!',26124),
(66109,'enUS','Break them.','Break them.',26124),
(66110,'enUS','You will feel pain.','You will feel pain.',26124),
(66111,'enUS','I will crush your skull with my bare hands.','I will crush your skull with my bare hands.',26124),
(66112,'enUS','Death! Doom! Destruction!','Death! Doom! Destruction!',26124),
(66113,'enUS','The torture of a thousand screaming deaths awaits...','The torture of a thousand screaming deaths awaits...',26124),
(66114,'enUS','More skulls for the pile...','More skulls for the pile...',26124),
(66115,'enUS','Come, fodder, and meet your end.','Come, fodder, and meet your end.',26124),
(66116,'enUS','No! I must report back to Her!','No! I must report back to Her!',26124),
(66117,'enUS','Far from home, aren\'t you?','Far from home, aren\'t you?',26124),
(66118,'enUS','She will protect me!','She will protect me!',26124),
(66119,'enUS','I can sense your fear...','I can sense your fear...',26124),
(66120,'enUS','My brethren are endless in number.','My brethren are endless in number.',26124),
(66121,'enUS','The hatchlings will dine on your corpse!','The hatchlings will dine on your corpse!',26124),
(66122,'enUS','The Mantid will cover this land, and devour all who oppose use!','The Mantid will cover this land, and devour all who oppose use!',26124),
(66123,'enUS','The pool stirs...','The pool stirs...',26124),
(66124,'enUS','The waters are restless...','The waters are restless...',26124),
(66125,'enUS','You disrupt my meditations? You will pay...','You disrupt my meditations? You will pay...',26124),
(66126,'enUS','I can see your end...','I can see your end...',26124),
(66127,'enUS','The waters speak of your demise...','The waters speak of your demise...',26124),
(66128,'enUS','If yer\' itchin\' ta learn a bit about smeltin\', I\'m yer dwarf!','',26124),
(66129,'enUS','The waves tremble at your approach...','The waves tremble at your approach...',26124),
(66130,'enUS','The thundering depths call to you...','The thundering depths call to you...',26124),
(66131,'enUS','You die!','You die!',26124),
(66132,'enUS','Stab stab stab stab stab!','Stab stab stab stab stab!',26124),
(66133,'enUS','We take what we wish!','We take what we wish!',26124),
(66134,'enUS','I will wear your skin as a hat!','I will wear your skin as a hat!',26124),
(66135,'enUS','You should not have come here!','You should not have come here!',26124),
(66136,'enUS','No! My gold!!','No! My gold!!',26124),
(66137,'enUS','Who\'s there?','Who\'s there?',26124),
(66138,'enUS','You brought strife to our lands! I will bring strife to you now!','You brought strife to our lands! I will bring strife to you now!',26124),
(66139,'enUS','This darkness in my heart, it is your doing!','This darkness in my heart, it is your doing!',26124),
(66140,'enUS','My vision is clouded, why have you done this to us?','My vision is clouded, why have you done this to us?',26124),
(66141,'enUS','The death of this land ends with your life!','The death of this land ends with your life!',26124),
(66142,'enUS','I must give in to the anger! It is the only way!','I must give in to the anger! It is the only way!',26124),
(66143,'enUS','My training was for nothing, because of you!','My training was for nothing, because of you!',26124),
(66144,'enUS','The darkness in my soul screams for release!','The darkness in my soul screams for release!',26124),
(66145,'enUS','Gonna ook you!','Gonna ook you!',26124),
(66146,'enUS','In the dooker!','In the dooker!',26124),
(66147,'enUS','Gimme dem munchins!!','Gimme dem munchins!!',26124),
(66148,'enUS','Gonna hit you in the wikket!','Gonna hit you in the wikket!',26124),
(66149,'enUS','You has ook for brains!','You has ook for brains!',26124),
(66150,'enUS','Ha ha, you no touch Ik-Ik!','Ha ha, you no touch Ik-Ik!',26124),
(66151,'enUS','Gonna blasts you to chunkies!','Gonna blasts you to chunkies!',26124),
(66152,'enUS','Please, delicious animal, you come with Martar?','Please, delicious animal, you come with Martar?',26124),
(66153,'enUS','Hey hey hey hey hey!','Hey hey hey hey hey!',26124),
(66154,'enUS','Martar wants a furry buddy!!','Martar wants a furry buddy!!',26124),
(66155,'enUS','No! Martar\'s treasure is Martar\'s!','No! Martar\'s treasure is Martar\'s!',26124),
(66156,'enUS','','This strange new land has much to offer in the form of herbs and remedies, if you know what to look for.',26124),
(66157,'enUS','Lilian\'s Soul fades into the spirit realm! It can no longer be harmed!','Lilian\'s Soul fades into the spirit realm! It can no longer be harmed!',26124),
(66158,'enUS','The Emperor\'s Strength appears in the alcoves!','The Emperor\'s Strength appears in the alcoves!',26124),
(66159,'enUS','Let no one pass!','',26124),
(66160,'enUS','The Emperor\'s Courage appears in the alcoves!','The Emperor\'s Courage appears in the alcoves!',26124),
(66161,'enUS','Don\'t let up. No mercy!','',26124),
(66162,'enUS','Stand fast and slay the rest!','',26124),
(66163,'enUS','So many hounds... we can\'t hold them back!','',26124),
(66164,'enUS','I have failed... our sacred brotherhood...','',26124),
(66165,'enUS','You come to see ol\' Tapin, eh? Hear \'bout my nickname? There was a time they called me \"the barber\" on account of my skill with skinnin\'.','',26124),
(66166,'enUS','Take this stone. It will help.','',26124),
(66167,'enUS','Ready in 3...','Ready in 3...',26124),
(66168,'enUS','2...','2...',26124),
(66169,'enUS','1...','1...',26124),
(66170,'enUS','Roll!','Roll!',26124),
(66171,'enUS','You have left the roll course!','You have left the roll course!',26124),
(66172,'enUS','Course complete!','Course complete!',26124),
(66173,'enUS','Congratulations!','Congratulations!',26124),
(66174,'enUS','You came in first!','You came in first!',26124),
(66175,'enUS','You came in second!','You came in second!',26124),
(66176,'enUS','You came in third!','You came in third!',26124),
(66177,'enUS','Zach Chow grumbles.','',26124),
(66178,'enUS','<The mantid emerges from hiding.>$b$bStay back, $r.$b$bThe Empress is not of her right mind. We Klaxxi are gathering our numbers for an assault on her throne, but we are not yet prepared. And neither are you.$b$bThe time to strike is soon... but not yet.','',26124),
(66179,'enUS','Thanks to your actions, the Hozen fear your people. Indulge me a moment...','',26124),
(66180,'enUS','Ah! Here we are. Over 14,000 years ago, this entire land was ruled by a terrible race of warlords called \"the mogu.\"','',26124),
(66181,'enUS','The mogu ruled through fear. And fear kept them in power... until the first Pandaren monks taught my people courage.','',26124),
(66182,'enUS','Then the mogu were overthrown.','',26124),
(66183,'enUS','You see, those who lead through fear only stay in power while those they govern lack courage.','',26124),
(66184,'enUS','The hozen are many things, but they are not cowards - not for long. If you don\'t wish to fight them, you must... inspire them!','',26124),
(66185,'enUS','I will help you, but first I would like to learn a little more about your people. Will you journey with me for a little while?','',26124),
(66186,'enUS','Grant me your assistance, Iyyokuk. [Klaxxi Enhancement]','Grant me your assistance, Iyyokuk. [Klaxxi Enhancement]',26124),
(66187,'enUS','Grant me your assistance, Swarmkeeper. [Klaxxi Augmentation]','Grant me your assistance, Swarmkeeper. [Klaxxi Augmentation]',26124),
(66188,'enUS','Grant me your assistance, Locust. [Klaxxi Augmentation]','Grant me your assistance, Locust. [Klaxxi Augmentation]',26124),
(66189,'enUS','Grant me your assistance, Manipulator. [Klaxxi Augmentation]','Grant me your assistance, Manipulator. [Klaxxi Augmentation]',26124),
(66190,'enUS','Upon killing an enemy, you shall gain the usage of my Bladeturning ability. Let your foes try to strike you, and you shall strike them, instead.','',26124),
(66191,'enUS','I serve his majesty, the last of his kind.$b$bIf you have a problem with me, take it up with the Prince.','I am just keeping my eyes open, $c. No harm in that.$b$bIf you have any news for me, I will pass it along. If not, you\'d best keep moving.',26124),
(66192,'enUS','Keep the mind open, aware. See opportunities. Exploit them!','',26124),
(66193,'enUS','I have coated your weapons with my special mixture, Wakener. You will infect every corpse with a mutagen that... well... you must see the results for yourself.','',26124),
(66194,'enUS','This tracking pheromone will reveal to you targets of great value.','',26124),
(66195,'enUS','Run them down!','',26124),
(66196,'enUS','The key to victory is control, Wakener. Use my skills to dominate the mind of an enemy, and turn it into an ally.','',26124),
(66197,'enUS','I find it, you buy it.','',26124),
(66198,'enUS','Move Closer to avoid |cFFFF0000|Hspell:127404|h[Golden Spear]|h|r!','',26124),
(66199,'enUS','|TInterface\\Icons\\ability_hunter_pet_devilsaur.blp:20|tSlavemaster Hithiss increases the power of his allies with a |cFFFF0000|Hspell:127414|h[Primal Call]|h|r!','',26124),
(66200,'enUS','Where... where is it? Worthless, useless... damn you!','',26124),
(66201,'enUS','It was... a trap...','',26124),
(66202,'enUS','Too easy!','',26124),
(66203,'enUS','Were you even trying?!','',26124),
(66204,'enUS','Haha, you die so easily!','',26124),
(66205,'enUS','Pah! Those who failed deserved to die; you have merely culled the weak!','',26124),
(66206,'enUS','I must finish this myself, then.  So be it!','',26124),
(66207,'enUS','|TInterface\\Icons\\spell_nature_lightningoverload.blp:20|tGeneral Zhun unleashes a |cFFFF0000|Hspell:127334|h[Wave of Pain]|h|r on his foes!','',26124),
(66208,'enUS','Hold still, this won\'t hurt a bit!','',26124),
(66209,'enUS','Ah, fresh meat for the dogs!','',26124),
(66210,'enUS','Pierce the flesh!','',26124),
(66211,'enUS','Blades, cut them to pieces!','',26124),
(66212,'enUS','Blood flow around me!','',26124),
(66213,'enUS','Don\'t just sit there! Attack!','',26124),
(66214,'enUS','Stupid animals! I\'ll put you down after I kill these weaklings!','',26124),
(66215,'enUS','Meat for the pack.','',26124),
(66218,'enUS','Release the hounds!','',26124),
(66219,'enUS','I let the dogs out!','',26124),
(66220,'enUS','No!','',26124),
(66221,'enUS','My hound!','',26124),
(66222,'enUS','How dare you!','',26124),
(66223,'enUS','Ah, reinforcements!','',26124),
(66224,'enUS','We\'ll squish you like bugs!','',26124),
(66225,'enUS','We\'ve got your sap -- come and get it!','',26124),
(66226,'enUS','Even together... we failed...','',26124),
(66227,'enUS','Weakling!','',26124),
(66228,'enUS','Lightning has no mercy!','',26124),
(66229,'enUS','None may defy the Shado-Pan!','',26124),
(66230,'enUS','Archers, attack!','',26124),
(66231,'enUS','Keep firing! Let none escape!','',26124),
(66232,'enUS','Another down, do not relent!','',26124),
(66233,'enUS','Thanks for saving the festival, $n!','',26124),
(66234,'enUS','','Good work, $n. We couldn\'t have done it without you.',26124),
(66235,'enUS','','The yaungol are coming from every direction, $n! Quickly, defend the village before they burn it down!',26124),
(66236,'enUS','The Shado-Pan need no outside aid! Remove these interlopers!','',26124),
(66237,'enUS','|TInterface\\Icons\\ability_warstomp.blp:20|t %s begins to cast |cFFFF0000|Hspell:127480|h[Crushing Slam]|h|r! Get away!','',26124),
(66238,'enUS','%s picks up a fallen weapon.','',26124),
(66239,'enUS','Come! We cannot allow them to harm the Lorewalker!','',26124),
(66240,'enUS','The Shado-Pan has many secrets. High among those is how to craft weapons and armor of surpassing quality.','',26124),
(66241,'enUS','Oh... my. That brew is a bit stronger than I had expected...','',26124),
(66242,'enUS','Oh... my. That brew is a bit stronger than I had expected... I...','',26124),
(66243,'enUS','Just need to rest my eyes a bit...','',26124),
(66244,'enUS','I serve only the Klaxxi\'va.','',26124),
(66248,'enUS','You have our thanks! I will see the Lorewalker safely to the Vale from here.','',26124),
(66249,'enUS','A keg is returned! My humble thanks...','',26124),
(66250,'enUS','A precious barrel of Greenstone brew! Hurrah!','',26124),
(66251,'enUS','That\'ll teach those pests to pilfer our dojo\'s prized product!','',26124),
(66252,'enUS','Ah, back where it belongs. Thank you!','',26124),
(66253,'enUS','An adventurer saves the village, but a HERO returns the brew!','',26124),
(66254,'enUS','Our brilliant brew is back! You\'ve all our gratitude.','',26124),
(66255,'enUS','If you can venture into the surrounding forest and return any stolen barrels you find, I\'ll concoct a concentrated draft of marvelous power for you...','',26124),
(66256,'enUS','Good!  These pathetic initiates were boring me!','',26124),
(66257,'enUS','Water Strider','Water Strider',26124),
(66258,'enUS','Quilen','Quilen',26124),
(66259,'enUS','Basilisk','Basilisk',26124),
(66260,'enUS','Crane','Crane',26124),
(66261,'enUS','Goat','Goat',26124),
(66262,'enUS','Porcupine','Porcupine',26124),
(66263,'enUS','Mighty fine hat!  I take it this is what you were looking for?','',26124),
(66264,'enUS','Ta ta for now, friend!','',26124),
(66266,'enUS','1...','',26124),
(66267,'enUS','3...','',26124),
(66268,'enUS','Defenders of the Vale, we require your return to the Golden Pagoda in 30 minutes!','Defenders of the Vale, we require your return to the Golden Pagoda in 30 minutes!',26124),
(66269,'enUS','Mogu forces surge at the main gate!  All defenders are to return to the Golden Pagoda in 15 minutes!','Mogu forces surge at the main gate!  All defenders are to return to the Golden Pagoda in 15 minutes!',26124),
(66271,'enUS','Defenders, you have 5 minutes before you are recalled to the Golden Pagoda!','Defenders, you have 5 minutes before you are recalled to the Golden Pagoda!',26124),
(66272,'enUS','Good, you\'ve returned.','Good, you\'ve returned.',26124),
(66273,'enUS','Scouts report a mogu offensive in 30 minutes!  Clear the western vale!','Scouts report a mogu offensive in 30 minutes!  Clear the western vale!',26124),
(66274,'enUS','Defenders, you have 15 minutes to clear the western vale!  Mogu raiding parties are leaving their camps!','Defenders, you have 15 minutes to clear the western vale!  Mogu raiding parties are leaving their camps!',26124),
(66275,'enUS','Mogu are raiding the western vale in 5 minutes!  Defenders, this is your last chance to get clear!','Mogu are raiding the western vale in 5 minutes!  Defenders, this is your last chance to get clear!',26124),
(66276,'enUS','I be jammon wit\' you, $n!','I be jammon wit\' you, $n!',26124),
(66277,'enUS','|TInterface\\Icons\\spell_nature_agitatingtotem.blp:20|tGara\'jal summons a Spirit Totem. Use it to |cFFFF0000|Hspell:116161|h[Cross Over]|h|r to the Spirit World!','',26124),
(66278,'enUS','|TInterface\\Icons\\spell_nature_agitatingtotem.blp:20|tGara\'jal summons a Spirit Totem. Use it to |cFFFF0000|Hspell:116260|h[Cross Over]|h|r to the Spirit World!','',26124),
(66279,'enUS','$n prepares a Banquet of the Brew!','$n prepares a Banquet of the Brew!',26124),
(66280,'enUS','$n prepares a Banquet of the Grill!','$n prepares a Banquet of the Grill!',26124),
(66281,'enUS','$n prepares a Banquet of the Oven!','$n prepares a Banquet of the Oven!',26124),
(66282,'enUS','$n prepares a Banquet of the Pot!','$n prepares a Banquet of the Pot!',26124),
(66283,'enUS','$n prepares a Banquet of the Steamer!','$n prepares a Banquet of the Steamer!',26124),
(66284,'enUS','$n prepares a Banquet of the Wok!','$n prepares a Banquet of the Wok!',26124),
(66285,'enUS','$n prepares a Great Banquet of the Brew!','$n prepares a Great Banquet of the Brew!',26124),
(66286,'enUS','$n prepares a Great Banquet of the Grill!','$n prepares a Great Banquet of the Grill!',26124),
(66287,'enUS','$n prepares a Great Banquet of the Oven!','$n prepares a Great Banquet of the Oven!',26124),
(66288,'enUS','$n prepares a Great Banquet of the Pot!','$n prepares a Great Banquet of the Pot!',26124),
(66289,'enUS','$n prepares a Great Banquet of the Wok!','$n prepares a Great Banquet of the Wok!',26124),
(66290,'enUS','$n prepares a Great Banquet of the Steamer!','$n prepares a Great Banquet of the Steamer!',26124),
(66291,'enUS','$n prepares a Pandaren Banquet!','$n prepares a Pandaren Banquet!',26124),
(66292,'enUS','$n prepares a Great Pandaren Banquet!','$n prepares a Great Pandaren Banquet!',26124),
(66293,'enUS','I have heard of your \"heroism,\" Locust. They say your raids on mogu labor camps and farmlands delayed the completion of the wall by decades.','',26124),
(66294,'enUS','I cannot argue with your results, but how can a proud warrior of the swarm make his name chasing down fleeing peasants and farmhands?','',26124),
(66295,'enUS','Easily: You don\'t have to leap as far between kills.','',26124),
(66296,'enUS','Bloodseeker, your regenerative powers fascinate me. I wonder if you would consent to a few tests.','',26124),
(66297,'enUS','What kind of tests?','',26124),
(66298,'enUS','Just a little cellular trauma induction, maybe a few tissue samples, a session of micro-sonic deep gene-probing. Nothing terribly invasive!','',26124),
(66299,'enUS','What was that last part?','',26124),
(66300,'enUS','Tissue samples?','',26124),
(66301,'enUS','After that.','',26124),
(66302,'enUS','Nothing terribly invasive?','',26124),
(66303,'enUS','We are done talking.','',26124),
(66304,'enUS','How does it feel to go rogue a second time, Swarmkeeper? Your empress was also gripped by paranoia, was she not?','',26124),
(66305,'enUS','Grand Empress Zek\'hara masked her true intentions behind the guise of matronly worry. She claimed her overbearing ways were necessary to protect us.','',26124),
(66306,'enUS','In reality, she was obsessed with control. She aspired to stay in power long past her time, and was willing to sacrifice our eternal cycle to achieve that. We had no choice but to end her.','',26124),
(66307,'enUS','Of course.','',26124),
(66308,'enUS','And having seen what Grand Empress Shek\'zeer is doing to our land... I need no convincing.','',26124),
(66309,'enUS','I served Shek\'zeer for a time, you know. Before I was preserved. Her madness is nothing so rational as ambition.','',26124),
(66310,'enUS','When she tried to forbid the swarm, it was to prevent, as she put it, \"a senseless loss of life.\"','',26124),
(66311,'enUS','She trusts no one. Paranoia gnaws at her mind. She is driven by fear unrelenting.','',26124),
(66312,'enUS','How does it feel? I have no regrets, if that is what you are asking. I am honored to serve the will of the Klaxxi.','',26124),
(66313,'enUS','It is an honor to serve alongside you, Prime. I have studied your work extensively.','',26124),
(66314,'enUS','Thanks to the careful notes you kept while developing the preservation chamber, I was able to create a modified version that could preserve Kovok here as well.','',26124),
(66315,'enUS','Yes, he certainly looks... healthy.','',26124),
(66316,'enUS','I never imagined my work would go so far. It is a testament to the great power of the kypari. Our civilization would never have recovered if it weren\'t for them. Remember that.','',26124),
(66317,'enUS','That is quite an impressive beast you have there, Manipulator. Very intriguing.','',26124),
(66318,'enUS','No.','',26124),
(66319,'enUS','All those years in stasis followed by sudden, rapid growth.','',26124),
(66320,'enUS','Do not even ask.','',26124),
(66321,'enUS','I am just saying... I bet his genes tell quite a story...','',26124),
(66322,'enUS','And I am just saying, Dissector, that you do not appear to possess any resistance to sonic manipulation.','',26124),
(66323,'enUS','How would you like to suddenly become \"intrigued\" by your own thorax? I bet your skilled hands could perform a self-vivisection in mere seconds if they were properly compelled.','',26124),
(66324,'enUS','Point taken.','',26124),
(66325,'enUS','Grrr... I need to kill something. All this waiting around is driving me crazy.','',26124),
(66326,'enUS','Quiet, you.','',26124),
(66327,'enUS','Monks, doesn\'t all that rolling make you dizzy?','',26124),
(66328,'enUS','Hozen are not always the best brewers, but the ones on Unga Ingoo somehow steal the best ingredients.','',26124),
(66329,'enUS','','Welcome to Tian Monastery.',26124),
(66330,'enUS','Ow! Ow! Ow!','',26124),
(66331,'enUS','','Good to see you, $n! My students and I came to try Brewmaster Boof\'s famous brew and to celebrate the brewmoon!',26124),
(66332,'enUS','','As mistweavers, we must always protect those in need.',26124),
(66333,'enUS','','Mistweaver Nian is a strict teacher but has a kind heart.',26124),
(66334,'enUS','','Sisters, the village need our help. Head to the front lines and heal the wounded!',26124),
(66335,'enUS','','Yes, ma\'am!',26124),
(66336,'enUS','They intend to execute Lorewalker Fu! Please, you must help me stop them...','',26124),
(66337,'enUS','If the Lorewalker is slain, many of us will have died for nothing...\n\nWill you accompany me to stop the execution?','',26124),
(66338,'enUS','Let\'s go save him.','Let\'s go save him.',26124),
(66339,'enUS','Xuen has taught us the meaning of strength.','',26124),
(66340,'enUS','It is good to see everyone in such high spirits.','',26124),
(66341,'enUS','The festival reminds me of how beautiful Kun-Lai is.','',26124),
(66342,'enUS','Greetings, $n. Are you enjoying the festival?','',26124),
(66343,'enUS','We must defend the villagers! I will take the front gates, the rest of you spread out and don\'t let any yaungol get past you!','',26124),
(66345,'enUS','Are these serpent hatchlings suitable for pet battles?','Are these serpent hatchlings suitable for pet battles?',26124),
(66346,'enUS','','I see we have a pet battler here in our training grounds.  Cloud serpents are cut out to do almost anything, including fighting other pets!  The key to finding the hatchlings is building a friendship with an adult.  Once you are exalted with the order, you will find them scattered across the arboretum.',26124),
(66347,'enUS','Two titanic constructs appear in the large alcoves!','Two titanic constructs appear in the large alcoves!',26124),
(66348,'enUS','For the glory of General Zhun!','',26124),
(66349,'enUS','In the name of the Thunder King!','',26124),
(66350,'enUS','I\'ll have your head!','',26124),
(66351,'enUS','My blade is peerless!','',26124),
(66352,'enUS','You DARE stand before a student of Scrollmaster Fon?!','',26124),
(66353,'enUS','Your agony will be BOUNDLESS!','',26124),
(66354,'enUS','I\'ll crush your skull!','',26124),
(66355,'enUS','I\'m going to break every bone in your body!','',26124),
(66356,'enUS','Thanks for the assist, friend. I\'d better report back to Bowmistress Li.','',26124),
(66357,'enUS','Hrgghh!!','',26124),
(66358,'enUS','You think me to be mad, do you? Yes... yes, perhaps a little.$b$bYou see, even after eight hundred and seventy-seven years of quietude, the desire to breathe does not go away.$b$bPerhaps something went wrong with my encasement. Perhaps it was my... preternaturally keen intellect. Whatever the cause, I was fully aware of the passage of time during my years in the amber.$b$bAfter seventy-eight years, I stopped trying to escape. I kept my mind sharp by creating and solving puzzles. The amber took care of the rest of my body.$b$bBut my sanity? No, I cannot say with good confidence that it survived intact.','',26124),
(66359,'enUS','Intruders! The prisoner cages are under attack... send reinforcements!','',26124),
(66360,'enUS','The Klaxxi said they needed someone to continue punishing fools in a future generation.$B$BI told them, \"I\'m your mantid.\"','',26124),
(66361,'enUS','There are intruders within the temple!','',26124),
(66362,'enUS','Alarm! Trespassers have entered the temple!','',26124),
(66363,'enUS','The temple walls have been breached!','',26124),
(66364,'enUS','The temple has been infiltrated! Alarm! ALARM!','',26124),
(66365,'enUS','MASTERS! Intruders in the temple!','',26124),
(66366,'enUS','Alarm, my masters! INTRUDERS!','',26124),
(66367,'enUS','The temple is breached, masters! ALARM!','',26124),
(66368,'enUS','Alarm, oh great masters! ALARM!','',26124),
(66369,'enUS','A small fee for supplies is required.','A small fee for supplies is required.',26124),
(66370,'enUS','The shield is engraved: Sentinel Ku-Yao. It belongs to the boy\'s father.','The shield is engraved: Sentinel Ku-Yao. It belongs to the boy\'s father.',26124),
(66371,'enUS','Ku-Yao\'s bedroll is empty. He\'s not here.','Ku-Yao\'s bedroll is empty. He\'s not here.',26124),
(66372,'enUS','This is Ha-Cha, Sentinel Ku-Yao\'s yak.','This is Ha-Cha, Sentinel Ku-Yao\'s yak.',26124),
(66373,'enUS','You\'re looking for Ku-Yao? I haven\'t seen him in days. You don\'t think he\'s in trouble, do you?','You\'re looking for Ku-Yao? I haven\'t seen him in days. You don\'t think he\'s in trouble, do you?',26124),
(66374,'enUS','Thanks for your help, $gmister:ma\'am;. I\'m going to keep looking for my dad now.','',26124),
(66375,'enUS','I hope I find him.','',26124),
(66376,'enUS','You... Shado-Pan. You\'re here to help me?','',26124),
(66377,'enUS','My son... he\'s here? Alive!?','',26124),
(66378,'enUS','Yes. Your son, Ku-Mo, has been looking for you.','Yes. Your son, Ku-Mo, has been looking for you.',26124),
(66379,'enUS','He\'s at the Shado-Pan Garrison right now. Here\'s a kite. Go see him!','He\'s at the Shado-Pan Garrison right now. Here\'s a kite. Go see him!',26124),
(66380,'enUS','Return to the Burlap Trail!','',26124),
(66381,'enUS','Three players are needed to cleanse the Pool of Life!','Three players are needed to cleanse the Pool of Life!',26124),
(66382,'enUS','Dad!','',26124),
(66383,'enUS','I brought you your crossbow, Dad!','',26124),
(66384,'enUS','Now you can shoot the mantid!','',26124),
(66385,'enUS','This chunk of amber may be exactly what the Klaxxi are looking for.','',26124),
(66386,'enUS','I think I\'m done fighting for a while, Ku-Mo.','',26124),
(66387,'enUS','Really?','',26124),
(66388,'enUS','Come on. I think it\'s time to go home.','',26124),
(66389,'enUS','You should keep that crossbow, Ku-Mo.','',26124),
(66390,'enUS','Whoah...','',26124),
(66391,'enUS','Even in my sleep, I hear her terror.','',26124),
(66392,'enUS','Fear grips her mind and body. The Empress is no longer fit to rule the empire.','',26124),
(66393,'enUS','The time of awakening must be near, but they have not yet come for me. Why do the Klaxxi wait?','',26124),
(66394,'enUS','A presence approaches! Someone out there can hear me! But... it is no Klaxxi.','',26124),
(66395,'enUS','Yes! Break it! Free me from this amber sleep!','',26124),
(66397,'enUS','Abandon Fel Imp','Abandon Fel Imp',26124),
(66398,'enUS','Abandon Voidlord','Abandon Voidlord',26124),
(66399,'enUS','Abandon Shivarra','Abandon Shivarra',26124),
(66400,'enUS','Abandon Observer','Abandon Observer',26124),
(66401,'enUS','Abandon Wrathguard','Abandon Wrathguard',26124),
(66402,'enUS','Speak to me when you are ready to try again.','Speak to me when you are ready to try again.',26124),
(66403,'enUS','Extinguished!','',26124),
(66404,'enUS','Does that make you angry?','',26124),
(66405,'enUS','Feel your rage!','',26124),
(66406,'enUS','Let your rage consume you!','',26124),
(66407,'enUS','Feed me with your ANGER!','',26124),
(66408,'enUS','My fury is UNLEASHED!','',26124),
(66409,'enUS','I will drop you near the tower. Do not get used to this.','',26124),
(66410,'enUS','The tower is just there. I will cover you from the sky. Be quick.','',26124),
(66411,'enUS','You hear a grinding noise coming from the elevator shaft!','You hear a grinding noise coming from the elevator shaft!',26124),
(66412,'enUS','Time for a little open-heart surgery!','',26124),
(66413,'enUS','Donate...my body...to science...','',26124),
(66414,'enUS','Another successful operation!','',26124),
(66415,'enUS','I think it\'s time to go for a Randall P. walk.','',26124),
(66416,'enUS','Hmm... no path. Guess I\'ll have to Randall P. swim.','',26124),
(66417,'enUS','That was enjoyable. Now it\'s time for a Randall P. rest.','',26124),
(66418,'enUS','|TInterface\\Icons\\item_earthenmight.blp:20|t %s begins to cast |cFFFF0000|Hspell:128107|h[Raise Earth]|h|r!  Watch out!','',26124),
(66419,'enUS','Looks like it\'s time to Randall P. jump.','',26124),
(66420,'enUS','Yes, Klaxxi\'va. How long I have waited to hear the Council\'s command!','',26124),
(66421,'enUS','I see. Much has transpired since I first entered my long sleep.','',26124),
(66422,'enUS','You will not disrupt the tuning!','',26124),
(66423,'enUS','What is the source of YOUR power? Think carefully before you answer. Many adventurers point to their weapons, or their equipment, or to tomes of arcane might.','',26124),
(66424,'enUS','Long ago, when my people were slaves of the mogu empire, we were forbidden from carrying any weapon at all. We were not fighters. And no one believed we could fight the mogu without magic and steel.','',26124),
(66425,'enUS','Until Kang, the First of First Dawn, opened our eyes.','',26124),
(66426,'enUS','One day, the beloved monk issued a challenge to his fellow slaves. \"Hit me!\" he called out.','',26124),
(66427,'enUS','Surprised, the beleaguered Pandaren slaves tried to strike Kang. One by one they failed, for he intercepted their blows like a dancer and sidestepped their attacks like a reed in the wind.','',26124),
(66428,'enUS','\"Our backs are hardened by the whips of the mogu,\" he told them. \"Our arms are powerful from building their fortresses. Our minds are sharp from working alongside our enemy. You think the mogu are stronger? I say we are their strength!\"','',26124),
(66429,'enUS','The farmers, the bricklayers, the shepherds and the smiths... they all bowed before Kang. \"Teach us,\" they said. \"Teach us to fight.\"','',26124),
(66430,'enUS','And when they rose... they rose as warriors.','',26124),
(66431,'enUS','Your voice. Your hands. THESE are the tools of true heroes. Use them well... and you can change the world.','',26124),
(66432,'enUS','Jump to prevent the resin from hardening!','Jump to prevent the resin from hardening!',26124),
(66433,'enUS','Pitiful, wingless grubs. You step out into my domain, and I will hear your death screams as you plummet from this terrace!','',26124),
(66434,'enUS','Set\'thik, in formation! Show them who controls the winds of Pandaria!','',26124),
(66435,'enUS','Breath of the empress, bring mighty Garalon to us!','',26124),
(66436,'enUS','Garalon, grind their bones to dust!','',26124),
(66437,'enUS','Impossible! Sri\'thik, Zar\'thik, Kor\'thik, to the top of the terrace! We must defend the Empress!','',26124),
(66438,'enUS','I assume you are here about the dragon turtles, child?  I am sorry.  I cannot help you until you prove yourself a loyal ally of my people.','I assume you are here about the dragon turtles, child?  I am sorry.  I cannot help you until you prove yourself a loyal ally of my people.',26124),
(66439,'enUS','I assume you are here about the dragon turtles, child?','I assume you are here about the dragon turtles, child?',26124),
(66440,'enUS','What dragon turtles are for sale?','What dragon turtles are for sale?',26124),
(66441,'enUS','The Horde wins!','',26124),
(66442,'enUS','The Alliance wins!','',26124),
(66443,'enUS','I hope they make it this far. Then my strength and skill will be clear to all!','',26124),
(66444,'enUS','Ah-hah! The lot of you will soon wish you hadn\'t come this way...','',26124),
(66445,'enUS','But... I was... who will...?!','',26124),
(66446,'enUS','Your carved bones will decorate the weapons of our warriors!','',26124),
(66447,'enUS','Did you think you stood a chance?!','',26124),
(66448,'enUS','Allow me to show you the power of amber alchemy...','',26124),
(66449,'enUS','Welcome, outsiders. Master Snowdrift is waiting for you inside the school. Please remember to show proper respect to the Master.','Welcome, outsiders. Master Snowdrift is waiting for you inside the school. Please remember to show proper respect to the Master.',26124),
(66451,'enUS','It appears that Empress Shek\'zeer has let our empire fall into chaos. This we must address. But first, I must regain my strength.','',26124),
(66452,'enUS','Did I not say that my wings were swift? You move most slowly, Wakener.','',26124),
(66453,'enUS','The nearby forces of the Scarlet Crusade stand ready to assist their Commander if he is attacked.','',26124),
(66454,'enUS','2...','',26124),
(66455,'enUS','Sure is a nice day today.','',26124),
(66456,'enUS','You like walking? I like walking.','',26124),
(66457,'enUS','I\'ve lost track of how long we\'ve been walking now.','',26124),
(66458,'enUS','Oh! When did you get here?','',26124),
(66459,'enUS','Nothing gets your blood flowing quite like a long, slow walk.','',26124),
(66460,'enUS','Before you ask: no, we are not there yet.','',26124),
(66461,'enUS','I hope you\'re enjoying this as much as I am.','',26124),
(66462,'enUS','A walk always goes faster when you have a friendly $r $c by your side.','',26124),
(66463,'enUS','I think I\'ve stayed here long enough. Would you like to go on a walk with me?','',26124),
(66464,'enUS','A walk? Sure!','A walk? Sure!',26124),
(66465,'enUS','Welcome to my shop, traveler!','',26124),
(66466,'enUS','Ah! So you seek items of wonder? Well you have come to the right place!','',26124),
(66467,'enUS','Feel free to browse, but do not feel free to touch!','',26124),
(66468,'enUS','Perhaps I can interest you in a magic map? Oh nevermind, we\'re all sold out.','',26124),
(66469,'enUS','May the winds guide your journey!','',26124),
(66471,'enUS','Good luck to you, friend!','',26124),
(66472,'enUS','Purged by fire!','',26124),
(66473,'enUS','Where\'d you get that weapon from, your sister?','',26124),
(66474,'enUS','Where\'d you get that weapon from, your sister?','',26124),
(66475,'enUS','What makes you think I would sell to you, outsider?','',26124),
(66476,'enUS','Wait. The Klaxxi speak to me. Yes, Council, I have heard the Empress\'s intentions. Her reign must end.','',26124),
(66477,'enUS','Tell me no more, Council. I will see my old home with my own eyes. I would gaze upon the ruin that Shek\'zeer has wrought.','',26124),
(66478,'enUS','Right away, Klaxxi\'va.','',26124),
(66479,'enUS','Before I was cast in amber, I made a great gamble.$B$BI realized the amber could perform a miracle that I would never achieve, not even with a thousand years of careful experimentation.$B$BBefore I became a paragon, I injected myself with a dozen lethal poisons. The life-giving properties of amber protected me as I guessed, and time did the rest.$B$BAnd now, I can handle any poison I desire without fear.','',26124),
(66480,'enUS','This soft one should serve well. Come, Wakener.','',26124),
(66481,'enUS','That\'s a good question. We\'re a strange lot... not many pandaren choose to live on this side of the wall.$b$bIn short, we\'re making beer. Not just any beer, though... beer brewed with the sap of the great kypari trees.','',26124),
(66482,'enUS','...disgusting, I know. But it\'s not.$b$bThe amber that these trees produce has amazing healing properties. The mantid can\'t get enough of it. They consume it, they use it in their weapons and architecture... I\'ve even heard legends that they embalm their great heroes in the stuff.','',26124),
(66483,'enUS','Exactly. The traditions of the sapmasters reach back through countless generations. I am but one link in a chain of sap-thirsty pandaren.$b$bSometimes, however, I fear that I may be the final link.','',26124),
(66484,'enUS','The trees are dying. Kypari Vor is already dead... a victim of the sha. It will never again produce amber. It barely even looks like a tree anymore.$b$bThe few amber-producing trees that remain are either being overharvested by the mantid, or in danger of succumbing to sha. Either way, no more sap means no more sapmasters. At which point, I\'d have to return to my old job.','',26124),
(66485,'enUS','Dumpling presser.$b$b<Vu sighs.>','',26124),
(66486,'enUS','What are you doing here?','What are you doing here?',26124),
(66487,'enUS','Beer made with sap? That sounds...','Beer made with sap? That sounds...',26124),
(66488,'enUS','And you make beer out of it.','And you make beer out of it.',26124),
(66489,'enUS','Why is that?','Why is that?',26124),
(66490,'enUS','What was your old job?','What was your old job?',26124),
(66491,'enUS','The %s is |cFFFF0000|Hspell:128419|h[Gathering Speed]|h|r!','',26124),
(66492,'enUS','Don\'t let up! No mercy!','',26124),
(66493,'enUS','Stand fast and slay the rest!','',26124),
(66496,'enUS','Pah! Those who failed deserved to die; you have merely culled the weak!','',26124),
(66497,'enUS','%s is woken from its slumber by the sound of combat!','',26124),
(66498,'enUS','Om nom nom nom...','',26124),
(66499,'enUS','So... SWEET!','',26124),
(66500,'enUS','So many SEEDS!','',26124),
(66501,'enUS','So... SPICY!!!','',26124),
(66502,'enUS','Please insert vegetation......','',26124),
(66503,'enUS','Insert a stack of Ginseng.','Insert a stack of Ginseng.',26124),
(66504,'enUS','Insert a stack of Juicycrunch Carrots.','Insert a stack of Juicycrunch Carrots.',26124),
(66505,'enUS','Insert a stack of Green Cabbage.','Insert a stack of Green Cabbage.',26124),
(66506,'enUS','Insert a stack of Jade Squash.','Insert a stack of Jade Squash.',26124),
(66507,'enUS','Insert a stack of Mogu Pumpkins.','Insert a stack of Mogu Pumpkins.',26124),
(66508,'enUS','Insert a stack of Pink Turnips.','Insert a stack of Pink Turnips.',26124),
(66509,'enUS','Insert a stack of Red Blossom Leeks.','Insert a stack of Red Blossom Leeks.',26124),
(66510,'enUS','Insert a stack of Scallions.','Insert a stack of Scallions.',26124),
(66511,'enUS','Insert a stack of Striped Melons.','Insert a stack of Striped Melons.',26124),
(66512,'enUS','Insert a stack of White Turnips.','Insert a stack of White Turnips.',26124),
(66513,'enUS','Insert a stack of Witchberries.','Insert a stack of Witchberries.',26124),
(66514,'enUS','The Vegetron 4000 is recharging, try again later.','',26124),
(66515,'enUS','Fighting make me... HUNGRY!','',26124),
(66516,'enUS','Intruders by the pool of life!  Don\'t let them escape!','',26124),
(66517,'enUS','Ggrgll!','',26124),
(66518,'enUS','Wait what...?!','',26124),
(66519,'enUS','Mmmphhh','',26124),
(66520,'enUS','Help!','',26124),
(66521,'enUS','The mantid are coming over the wall!','',26124),
(66522,'enUS','%s sees the opportunity to splash Toxic Hivebomb in the whirlwind!','',26124),
(66523,'enUS','Powerful Throw incoming! Don\'t get knocked off the mountain!','',26124),
(66524,'enUS','Give me the resonating crystal you puny little bark eater!','',26124),
(66525,'enUS','I should have known you would not come alone Kor\'ik.','',26124),
(66526,'enUS','|TInterface\\Icons\\ability_druid_ravage.blp:20|t Garalon fails to hit at least two players and gains |cFFFF0000|Hspell:122754|h[Fury]|h|r!','|TInterface\\Icons\\ability_druid_ravage.blp:20|t Garalon fails to hit at least two players and gains |cFFFF0000|Hspell:122754|h[Fury]|h|r!',26124),
(66527,'enUS','It is fitting that I be the one to destroy the pet of the Klaxxi!','',26124),
(66528,'enUS','Come outsider! Fight me if you dare!','',26124),
(66529,'enUS','Fire the cannons to kill the bombardiers!','',26124),
(66530,'enUS','It was foolish of you to interrupt, outsider.','',26124),
(66531,'enUS','Is he gone? Is it over?','',26124),
(66532,'enUS','The colossus is injured! Don\'t stop striking!','',26124),
(66533,'enUS','It\'s nearly defeated! Keep punching!','',26124),
(66534,'enUS','This is not over...','',26124),
(66535,'enUS','What does a servant of the Klaxxi require?','',26124),
(66536,'enUS','Take me to the Briny Wastes.','Take me to the Briny Wastes.',26124),
(66537,'enUS','You wish to pay me tribute? Then pay it in blood!','',26124),
(66538,'enUS','I need to travel somewhere.','I need to travel somewhere.',26124),
(66539,'enUS','Take me to the Lake of Stars.','Take me to the Lake of Stars.',26124),
(66540,'enUS','[Right Click] on the trainee\'s weapon in your inventory to equip it.\nThe default key to open your bags is [B]','[Right Click] on the trainee\'s weapon in your inventory to equip it.\nThe default key to open your bags is [B]',26124),
(66541,'enUS','Our work here is finished for now. Let us deliver news of our victory to the Klaxxi Council. They await our return.','',26124),
(66542,'enUS','You impress me, my young student. You have great strength in you.','',26124),
(66543,'enUS','What is happening? Why do we swarm so soon?','',26124),
(66544,'enUS','No, no... this swarm is too early. I must speak with the Adjunct!','',26124),
(66545,'enUS','Why am I... here...?','',26124),
(66546,'enUS','Where are we? We were... swarming?!','',26124),
(66547,'enUS','The pandaren were prepared. This attack was folly.','',26124),
(66548,'enUS','This is wrong. It is not yet time to swarm.','',26124),
(66549,'enUS','This wall cannot stop the might of the mantid!','',26124),
(66550,'enUS','I carry out her will! We shall crumble this wall and devour the lands beyond!','',26124),
(66551,'enUS','You wouldn\'t happen to have another bundle of that incense would you?','You wouldn\'t happen to have another bundle of that incense would you?',26124),
(66552,'enUS','I\'ll keep the ship here as long as I can.$B$BBe safe!','',26124),
(66553,'enUS','We\'ll defend the ship and crew for as long as we\'re able.$B$BDon\'t worry about us!','We\'ll defend the ship and crew for as long as we\'re able.$B$BDon\'t worry about us!',26124),
(66554,'enUS','What happened here?!$B$BLady Proudmoore\'s tower is just... gone!','What happened here?!$B$BLady Proudmoore\'s tower is just... gone!',26124),
(66555,'enUS','What a disaster!$B$BWhat could have done this?!','What a disaster!$B$BWhat could have done this?!',26124),
(66556,'enUS','I wonder if anyone survived...','I wonder if anyone survived...',26124),
(66557,'enUS','Did the Horde do this?!$B$BLight save us all...','Did the Horde do this?!$B$BLight save us all...',26124),
(66558,'enUS','By the Light... Theramore! What has happened here?!','',26124),
(66559,'enUS','Abe, get below deck and hide. Everyone else, keep watch and be ready for an attack.','',26124),
(66560,'enUS','If someone\'s bold enough to investigate, we\'ll keep the ship here as long as we can.','',26124),
(66561,'enUS','Y-yes sir!','',26124),
(66562,'enUS','','Captain! Please keep your crew safely on board. We\'ll defend the ship if it\'s attacked.',26124),
(66563,'enUS','That\'s a ship! An ALLIANCE ship!','',26124),
(66564,'enUS','I don\'t care! I\'M KILLING EVERYTHING ON BOARD! Move it, grunts!','',26124),
(66565,'enUS','','Merely a transport, Grud. Not a warship.',26124),
(66566,'enUS','I\'ve always wondered what lay behind these gates.','I\'ve always wondered what lay behind these gates.',26124),
(66567,'enUS','Just look at this place! It\'s amazing!','Just look at this place! It\'s amazing!',26124),
(66568,'enUS','I heard some hero from a far away land convinced Xuen, the tiger god, to open the Vale. Maybe I\'ll see them someday.','I heard some hero from a far away land convinced Xuen, the tiger god, to open the Vale. Maybe I\'ll see them someday.',26124),
(66569,'enUS','The Shado-Pan told us this would be a safe haven for all the refugees from Kun-Lai. Perhaps here, we shall finally find peace.','The Shado-Pan told us this would be a safe haven for all the refugees from Kun-Lai. Perhaps here, we shall finally find peace.',26124),
(66570,'enUS','I heard all kinds of stories about what lay behind the gate. I never imagined it would be something like this.','I heard all kinds of stories about what lay behind the gate. I never imagined it would be something like this.',26124),
(66571,'enUS','Perhaps we can find a new home here in the Vale.','Perhaps we can find a new home here in the Vale.',26124),
(66572,'enUS','','Here they come, Halters! Get ready!',26124),
(66573,'enUS','Was this really the home of the ancient emperors of Pandaria? It is beautiful.','Was this really the home of the ancient emperors of Pandaria? It is beautiful.',26124),
(66574,'enUS','To have witnessed the opening of the gates... it is a tale I will pass down to my children\'s children.','To have witnessed the opening of the gates... it is a tale I will pass down to my children\'s children.',26124),
(66575,'enUS','FOR THERAMORE!','',26124),
(66576,'enUS','There is a glint of light coming from something on the creature\'s back.','',26124),
(66577,'enUS','Take the object.','Take the object.',26124),
(66578,'enUS','There is much damage to repair.','',26124),
(66579,'enUS','Kor\'ik was just the first to betray us. No one can be trusted.','',26124),
(66580,'enUS','War has come, Wakener.','',26124),
(66581,'enUS','The creature\'s shell is glinting with light.','',26124),
(66582,'enUS','What can Jaluu do you for today?','',26124),
(66583,'enUS','Always strive to achieve the impossible.','',26124),
(66584,'enUS','May you seek honor and courage in all your days, $r.','',26124),
(66585,'enUS','Only to the most trusted allies do we reveal the Golden Lotus\'s deepest secrets.','',26124),
(66586,'enUS','You are like... piece of iron...','',26124),
(66587,'enUS','Welcome to the Vale, friend. Stay and be at peace.','',26124),
(66588,'enUS','AID ME!','',26124),
(66589,'enUS','','Good fortune to you, $r. Here you will find representatives from all the factions of Pandaria. When you have had a little more experience under your belt, come back and speak to us. Great adventures and great rewards await.',26124),
(66590,'enUS','','May a lucky star shine upon you, $c. Here you will find representatives from all the factions of Pandaria. Speak to them to find out if you are the brave adventurer that they seek.',26124),
(66591,'enUS','What is this place?','What is this place?',26124),
(66592,'enUS','ALARM! Alliance approach from the harbor!','',26124),
(66593,'enUS','Move it, you dogs!','Move it, you dogs!',26124),
(66594,'enUS','Hurry it up, peons!','Hurry it up, peons!',26124),
(66595,'enUS','Faster, dogs, or you\'ll get THE BOOT!','Faster, dogs, or you\'ll get THE BOOT!',26124),
(66596,'enUS','Go! GO, you lazy worms!','Go! GO, you lazy worms!',26124),
(66597,'enUS','','Welcome, traveler. Make your home here if you wish. Upstairs you will find the bank vaults and the city portals. Vendors of all trades have set up shop around the building. Please explore at your own leisure.',26124),
(66598,'enUS','What can I find here in the city?','What can I find here in the city?',26124),
(66599,'enUS','Need a little fortune in your favor, $r? Everyone needs a little luck to spruce things up!$B$BDon\'t worry, I can help tweak the odds in your favor!','',26124),
(66600,'enUS','Welcome, $r. Here you will find representatives from all the factions of Pandaria. When you have had a little more experience under your belt, come back and speak to us. Great adventures and great rewards await.','',26124),
(66601,'enUS','Welcome, $r. Here you will find representatives from all the factions of Pandaria. Speak to them to find out if you are the brave adventurer that they seek.','',26124),
(66602,'enUS','Oh, ho! Oh ho ho.$B$BYo ho ho, even.$B$BI just come back from the land of Pandaria, with its rolling hills and harsh mountains, and the strangest rum I ever tasted.  I crashed me ship into the Jade Forest and me cargo made the land uninhabitable, but in the meantime I can take ye to the Valley of the Four Winds, lickey-split.$B$BDo yeh trust me, $c?','',26124),
(66603,'enUS','Yarrrr, yeh don\'t want none of what I be dealin\', $gSonny:missy;.$B$BBegone wit\' yeh!','',26124),
(66604,'enUS','Good work. Keep it up.','',26124),
(66605,'enUS','Well done. Not much more!','',26124),
(66606,'enUS','Finish here first, and there\'ll be rum for all of you!','',26124),
(66607,'enUS','Such energy. Excellent!','',26124),
(66608,'enUS','You\'re from that ship? Bad move. Theramore is HORDE land, now!','',26124),
(66609,'enUS','Yarr, the Adm\'rl sent me here to sell ya some of the booty we plundered from the Jade Forest.  He thought it might \'elp you on yer journey.$B$BIf ye want I can also take ye back to the mainland.','',26124),
(66613,'enUS','Valley of the Four Winds','Valley of the Four Winds',26124),
(66614,'enUS','What do you have for sale?','What do you have for sale?',26124),
(66615,'enUS','Your end is near!','',26124),
(66616,'enUS','When you are dying, beast, remember that I gave you a choice.','',26124),
(66617,'enUS','Vendors from all over the land have found their way into the city. What are you looking for?','Vendors from all over the land have found their way into the city. What are you looking for?',26124),
(66618,'enUS','Don\'t see what you need in the city?$B$BWhat are you looking for? Maybe I can help you find it.','Don\'t see what you need in the city?$B$BWhat are you looking for? Maybe I can help you find it.',26124),
(66619,'enUS','Oh, looking for your class trainer? Unfortunately none of them have made it here to the Vale of Eternal Blossoms.$B$BYou can return to your home city to find those.','Oh, looking for your class trainer? Unfortunately none of them have made it here to the Vale of Eternal Blossoms.$B$BYou can return to your home city to find those.',26124),
(66620,'enUS','Looking for a professions trainer?$B$BThe zen master trainers can be found all across Pandaria. Tell me who you are looking for.$B$BIf you cannot find the person you seek here in Pandaria, you may also seek professions masters in your home city. They should also be able to improve your skill in your craft.','Looking for a professions trainer?$B$BThe zen master trainers can be found all across Pandaria. Tell me who you are looking for.$B$BIf you cannot find the person you seek here in Pandaria, you may also seek professions masters in your home city. They should also be able to improve your skill in your craft.',26124),
(66621,'enUS','You seek Silkmaster Tsai at the Silken Fields in the Valley of the Four Winds. I will mark his location on your map for you.','You seek Silkmaster Tsai at the Silken Fields in the Valley of the Four Winds. I will mark his location on your map for you.',26124),
(66622,'enUS','You can improve your fishing skill by visiting Nat Pagle at the Anglers Wharf in the Krasarang Wilds. Let me mark the location for you.','You can improve your fishing skill by visiting Nat Pagle at the Anglers Wharf in the Krasarang Wilds. Let me mark the location for you.',26124),
(66623,'enUS','There are master miners located at the Greenstone Quarry in the Jade Forest. They can probably help you improve your skill. I will mark the location on your map.','There are master miners located at the Greenstone Quarry in the Jade Forest. They can probably help you improve your skill. I will mark the location on your map.',26124),
(66624,'enUS','You can find a leatherworking trainer at the Grummle Bazaar in Kun-Lai Summit. I will mark the location on your map.','You can find a leatherworking trainer at the Grummle Bazaar in Kun-Lai Summit. I will mark the location on your map.',26124),
(66625,'enUS','I have heard there are master alchemists among the Klaxxi, far over the wall in the Dread Wastes. I will mark the location on your map for you.','I have heard there are master alchemists among the Klaxxi, far over the wall in the Dread Wastes. I will mark the location on your map for you.',26124),
(66626,'enUS','There is a skinning trainer at Nesingwary\'s Safari in the Valley of the Four Winds.$B$BI will mark their location on your map.','There is a skinning trainer at Nesingwary\'s Safari in the Valley of the Four Winds.$B$BI will mark their location on your map.',26124),
(66627,'enUS','For your enchanting needs, you must speak to Lai the Spellpaw at Dawn\'s Blossom in The Jade Forest.$B$BI will mark the location on your map.','For your enchanting needs, you must speak to Lai the Spellpaw at Dawn\'s Blossom in The Jade Forest.$B$BI will mark the location on your map.',26124),
(66628,'enUS','You can find the person you seek at Nesingwary\'s Safari in the Valley of the Four Winds.$B$BI will mark their location on your map.','You can find the person you seek at Nesingwary\'s Safari in the Valley of the Four Winds.$B$BI will mark their location on your map.',26124),
(66629,'enUS','You must be seeking Zen Master Lao! He is working at the Setting Sun Garrison in the Vale of Eternal Blossoms.$B$BI will mark his location on your map.','You must be seeking Zen Master Lao! He is working at the Setting Sun Garrison in the Vale of Eternal Blossoms.$B$BI will mark his location on your map.',26124),
(66630,'enUS','There is a master of archaeology in the Seat of Knowledge, above Mogu\'shan Palace here in the Vale of Eternal Blossoms.$B$BI will mark their location on your map for you.','There is a master of archaeology in the Seat of Knowledge, above Mogu\'shan Palace here in the Vale of Eternal Blossoms.$B$BI will mark their location on your map for you.',26124),
(66631,'enUS','Oh yes, you are looking for Healer Nan. You can find her inside the Shrine of Seven Stars.$B$BI will mark her location on your map.','Oh yes, you are looking for Healer Nan. You can find her inside the Shrine of Seven Stars.$B$BI will mark her location on your map.',26124),
(66632,'enUS','Interested in developing your cooking skills, are you?$B$BYou need to speak to the Ironpaw family. They can be found at the Halfhill Market in the Valley of the Four Winds.$B$BI will mark the location on your map for you.','Interested in developing your cooking skills, are you?$B$BYou need to speak to the Ironpaw family. They can be found at the Halfhill Market in the Valley of the Four Winds.$B$BI will mark the location on your map for you.',26124),
(66633,'enUS','If you seek to learn more of the herbalism arts, I suggest you speak to the trainer in The Jade Forest.$B$BI will mark their position for you.','If you seek to learn more of the herbalism arts, I suggest you speak to the trainer in The Jade Forest.$B$BI will mark their position for you.',26124),
(66634,'enUS','Yes, I know of an inscription trainer in the Seat of Knowledge, in the Vale of Eternal Blossoms.$B$BLet me mark their location on your map.','Yes, I know of an inscription trainer in the Seat of Knowledge, in the Vale of Eternal Blossoms.$B$BLet me mark their location on your map.',26124),
(66635,'enUS','You seek Mai the Jade Shaper. You can find her at Greenstone Village in The Jade Forest.$B$BI will mark her location on your map.','You seek Mai the Jade Shaper. You can find her at Greenstone Village in The Jade Forest.$B$BI will mark her location on your map.',26124),
(66636,'enUS','','Can we have some of your pets, Miss Finkleswitch? Please?',26124),
(66637,'enUS','','No, no, little ones. You aren\'t big enough yet!',26124),
(66638,'enUS','Aww, man...','',26124),
(66639,'enUS','Cloudrunner Leng can teach you how to fly in Pandaria. He rides his cloud serpent on the main terrace. I will mark his location on your map.','Cloudrunner Leng can teach you how to fly in Pandaria. He rides his cloud serpent on the main terrace. I will mark his location on your map.',26124),
(66640,'enUS','$p AGGROED','',26124),
(66641,'enUS','','Hrmph. I\'m probably taller than her.',26124),
(66642,'enUS','There are no battlemasters here in the Vale.$B$BYou must return to your home city to queue for battlegrounds or arenas of war.','There are no battlemasters here in the Vale.$B$BYou must return to your home city to queue for battlegrounds or arenas of war.',26124),
(66643,'enUS','Transmogrification and Void Storage services can be found in your home city.','Transmogrification and Void Storage services can be found in your home city.',26124),
(66644,'enUS','Flying Trainer','Flying Trainer',26124),
(66645,'enUS','Pet Battle Trainer','Pet Battle Trainer',26124),
(66646,'enUS','Other','Other',26124),
(66647,'enUS','Temple of the Jade Serpent, a level 85-87 dungeon in the Jade Forest, is now available for testing. Please be in your full group before teleporting to the dungeon. Meeting Stones are not available for this dungeon yet.\n\nTo leave Temple of the Jade Serpent, simply exit through the normal exit inside the dungeon and you will be teleported out. If you die and release, you should teleport back from this NPC.','',26124),
(66648,'enUS','I\'m in my group and ready to teleport to Temple of the Jade Serpent!','I\'m in my group and ready to teleport to Temple of the Jade Serpent!',26124),
(66649,'enUS','Take me back to Temple of the Jade Serpent!','Take me back to Temple of the Jade Serpent!',26124),
(66650,'enUS','','Sara Finkleswitch commands The Fiddler to perform a jump!',26124),
(66651,'enUS','Transmogrification & Void Storage','Transmogrification & Void Storage',26124),
(66652,'enUS','Priest Whitebrow moans in pain.','',26124),
(66653,'enUS','Alchemy Goods','Alchemy Goods',26124),
(66654,'enUS','Blacksmithing Supplies','Blacksmithing Supplies',26124),
(66655,'enUS','Bread','Bread',26124),
(66656,'enUS','Brews','Brews',26124),
(66657,'enUS','Cooking Supplies','Cooking Supplies',26124),
(66658,'enUS','Enchanting Supplies','Enchanting Supplies',26124),
(66659,'enUS','Engineering Supplies','Engineering Supplies',26124),
(66660,'enUS','','There, there, Priest. You\'re in no condition to help anyone right now. Both of your arms are broken! I\'ll get you some medicine.',26124),
(66661,'enUS','Fireworks','Fireworks',26124),
(66662,'enUS','First Aid Supplies','First Aid Supplies',26124),
(66663,'enUS','Fishing Supplies','Fishing Supplies',26124),
(66664,'enUS','Food & Drink','Food & Drink',26124),
(66665,'enUS','Herbs','Herbs',26124),
(66666,'enUS','','We need a cold pint over here! Stat!',26124),
(66667,'enUS','Inscription Supplies','Inscription Supplies',26124),
(66668,'enUS','Jewelcrafting Supplies','Jewelcrafting Supplies',26124),
(66669,'enUS','Leatherworking & Skinning Supplies','Leatherworking & Skinning Supplies',26124),
(66670,'enUS','Meat','Meat',26124),
(66671,'enUS','Mining Supplies','Mining Supplies',26124),
(66672,'enUS','Sweet Treats','Sweet Treats',26124),
(66673,'enUS','Tailoring Supplies','Tailoring Supplies',26124),
(66674,'enUS','Looking for general goods? Bonni will have what you need. She sells her wares at the Golden Lantern. I will mark the location on your map.','Looking for general goods? Bonni will have what you need. She sells her wares at the Golden Lantern. I will mark the location on your map.',26124),
(66675,'enUS','I saw a peddler setting up his trade goods in the Golden Lantern. I will mark the location on your map.','I saw a peddler setting up his trade goods in the Golden Lantern. I will mark the location on your map.',26124),
(66676,'enUS','I guess you could say...','',26124),
(66677,'enUS','I guess you could say she has a bun in the oven!','',26124),
(66678,'enUS','Why is your wife still using the oven? My meat needs cooking!','',26124),
(66679,'enUS','Michael Bedernik growls.','',26124),
(66680,'enUS','','Stop it, both of you!',26124),
(66681,'enUS','Well fought, student. You\'ve proven that you truly embody my way... the Way of the Crane.','',26124),
(66682,'enUS','Hope can blossom anywhere... even in this dark corner of a forgotten jungle.','',26124),
(66683,'enUS','All it needs is a hero like you to plant the seed.','',26124),
(66684,'enUS','Stop this nightmare!','',26124),
(66685,'enUS','I will not be controlled!','',26124),
(66686,'enUS','Ah, what quartermaster are you searching for? Perhaps I can help you find them.','Ah, what quartermaster are you searching for? Perhaps I can help you find them.',26124),
(66687,'enUS','Looking to find the Anglers Quartermaster? That would be Nat Pagle. You can find him at the Anglers Wharf in Krasarang Wilds.$B$BLet me mark the location on your map for you.','Looking to find the Anglers Quartermaster? That would be Nat Pagle. You can find him at the Anglers Wharf in Krasarang Wilds.$B$BLet me mark the location on your map for you.',26124),
(66688,'enUS','You need to talk to Teng Thundermalt! He can be found at the Stormstout Brewery in the Valley of the Four Winds.$B$BLet me mark the location on your map for you.','You need to talk to Teng Thundermalt! He can be found at the Stormstout Brewery in the Valley of the Four Winds.$B$BLet me mark the location on your map for you.',26124),
(66689,'enUS','If you\'re looking for the Tillers quartermaster, Gina Mudclaw\'s your girl. She\'ll be running the market at Halfhill.$B$BLet me mark her location on your map.','If you\'re looking for the Tillers quartermaster, Gina Mudclaw\'s your girl. She\'ll be running the market at Halfhill.$B$BLet me mark her location on your map.',26124),
(66690,'enUS','San Redscale is the quartermaster for the Order of the Cloud Serpent.$B$BYou can find him at The Arboretum in The Jade Forest.$B$BI will mark his location on your map.','San Redscale is the quartermaster for the Order of the Cloud Serpent.$B$BYou can find him at The Arboretum in The Jade Forest.$B$BI will mark his location on your map.',26124),
(66691,'enUS','Hmmm, I\'m afraid I know little of the Klaxxi, but I have heard whispers of their city, Klaxxi\'vess, far to the west in the Dread Wastes. Perhaps you can find the Klaxxi Quartermaster there.$B$BI will mark the location on your map.','Hmmm, I\'m afraid I know little of the Klaxxi, but I have heard whispers of their city, Klaxxi\'vess, far to the west in the Dread Wastes. Perhaps you can find the Klaxxi Quartermaster there.$B$BI will mark the location on your map.',26124),
(66692,'enUS','The Shado-Pan quartermaster can be found at the Shado-Pan Garrison in the Townlong Steppes.$B$BI will mark their location on your map.','The Shado-Pan quartermaster can be found at the Shado-Pan Garrison in the Townlong Steppes.$B$BI will mark their location on your map.',26124),
(66693,'enUS','Ah, you seek Jaluu the Generous! He is right next to me.','Ah, you seek Jaluu the Generous! He is right next to me.',26124),
(66694,'enUS','The August Celestials quartermaster can be found here in the Vale. Sage Whiteheart stands with the other faction representatives, in the lower section of The Summer  Terrace.$B$BI will mark his location on your map.','The August Celestials quartermaster can be found here in the Vale. Sage Lotusbloom stands with the other faction representatives, in the lower section of The Golden Terrace.$B$BI will mark his location on your map.',26124),
(66695,'enUS','The August Celestials quartermaster can be found here in the Vale. Sage Lotusbloom stands with the other faction representatives, in the lower section of The Summer Terrace.$B$BI will mark her location on your map.','The August Celestials quartermaster can be found here in the Vale. Sage Lotusbloom stands with the other faction representatives, in the lower section of The Summer Terrace.$B$BI will mark her location on your map.',26124),
(66696,'enUS','You seek Tan Shin Tiao. She can be found in the Seat of Knowledge, above Mogu\'shan Palace here in the Vale of Eternal Blossoms.$B$BI will mark her location on your map.','You seek Tan Shin Tiao. She can be found in the Seat of Knowledge, above Mogu\'shan Palace here in the Vale of Eternal Blossoms.$B$BI will mark her location on your map.',26124),
(66697,'enUS','The valor quartermaster, Commander Oxheart, can be found at Niuzao Temple in the Townlong Steppes.$B$BI will mark her location on your map.','The valor quartermaster, Commander Oxheart, can be found at Niuzao Temple in the Townlong Steppes.$B$BI will mark her location on your map.',26124),
(66698,'enUS','You can trade your marks of justice with Commander Lo Ping, who can be found at Niuzao Temple in the Townlong Steppes.$B$BI will mark his location on your map.','You can trade your marks of justice with Commander Lo Ping, who can be found at Niuzao Temple in the Townlong Steppes.$B$BI will mark his location on your map.',26124),
(66699,'enUS','The Honor Quartermaster can be found on the Serpent\'s Spine, the great wall to the west.$B$BI will mark their location on your map for you.','The Honor Quartermaster can be found on the Serpent\'s Spine, the great wall to the west.$B$BI will mark their location on your map for you.',26124),
(66700,'enUS','Quartermasters','Quartermasters',26124),
(66701,'enUS','Conquest Quartermaster','Conquest Quartermaster',26124),
(66702,'enUS','Valor Quartermaster','Valor Quartermaster',26124),
(66703,'enUS','Honor Quartermaster','Honor Quartermaster',26124),
(66704,'enUS','Anglers','Anglers',26124),
(66705,'enUS','Brewmasters','Brewmasters',26124),
(66706,'enUS','Tillers','Tillers',26124),
(66707,'enUS','Order of the Cloud Serpent','Order of the Cloud Serpent',26124),
(66708,'enUS','Klaxxi','Klaxxi',26124),
(66709,'enUS','Shado-Pan','Shado-Pan',26124),
(66710,'enUS','Golden Lotus','Golden Lotus',26124),
(66711,'enUS','You are dismissed. Return to the Shado-Pan Garrison.','You are dismissed. Return to the Shado-Pan Garrison.',26124),
(66712,'enUS','August Celestials','August Celestials',26124),
(66713,'enUS','Lorewalkers','Lorewalkers',26124),
(66714,'enUS','You can return to the Shado-Pan Garrison to select a new Shado-Pan Companion.\n\nAre you sure you want to dismiss your Shado-Pan Companion?','You can return to the Shado-Pan Garrison to select a new Shado-Pan Companion.\n\nAre you sure you want to dismiss your Shado-Pan Companion?',26124),
(66715,'enUS','You can find the Conquest Quartermaster and the Glorious Conquest Quartermaster on the Serpent\'s Spine to the west.$B$BI will mark their location on your map.','You can find the Conquest Quartermaster and the Glorious Conquest Quartermaster on the Serpent\'s Spine to the west.$B$BI will mark their location on your map.',26124),
(66716,'enUS','Where can I find the Anglers Quartermaster?','Where can I find the Anglers Quartermaster?',26124),
(66717,'enUS','Where can I find the Brewmasters Quartermaster?','Where can I find the Brewmasters Quartermaster?',26124),
(66718,'enUS','Where can I find the Golden Lotus Quartermaster?','Where can I find the Golden Lotus Quartermaster?',26124),
(66719,'enUS','Where can I find the Klaxxi Quartermaster?','Where can I find the Klaxxi Quartermaster?',26124),
(66720,'enUS','Where can I find the Lorewalkers Quartermaster?','Where can I find the Lorewalkers Quartermaster?',26124),
(66721,'enUS','Where can I find the Order of the Cloud Serpent Quartermaster?','Where can I find the Order of the Cloud Serpent Quartermaster?',26124),
(66722,'enUS','Where can I find the Shado-Pan Quartermaster?','Where can I find the Shado-Pan Quartermaster?',26124),
(66723,'enUS','Where can I find the Tillers Quartermaster?','Where can I find the Tillers Quartermaster?',26124),
(66724,'enUS','Gaze into the inevitable!','',26124),
(66725,'enUS','Face your demise!','',26124),
(66726,'enUS','Silence... at last.','',26124),
(66727,'enUS','Tremble!','',26124),
(66728,'enUS','','Mister Pleeb is teaching me how to be a taxidermist. Personally I think he is a little too dated and could benefit from a little gnomish \"engi-nuity.\"',26124),
(66729,'enUS','Oy, lad! Have ye gotten that Thundertank XT 9000 workin\' yet?','',26124),
(66730,'enUS','No, sir. I don\'t believe so.','',26124),
(66731,'enUS','Friend, have your journeys brought you to Krasarang recently?$B$BIt would be wise to venture there. The fish are as bountiful as the most fortunate harvest.$B$BAs my father said, the early fisherman gets the catch!','',26124),
(66732,'enUS','The Anglers Wharf in southeastern Krasarang Wilds is home to the most avid of all fisherman this side of Pandaria.$B$BIf you love the reward of a day spent with the great sea, I urge you to honor us with your presence.','',26124),
(66733,'enUS','You seek...a reward?$B$BSurely the joy of a successful catch is reward enough? The thrill of the open sea? The comraderie that only a fishing pole can grant?$B$BYou have much to learn, $r.$B$BMy opinion aside, there is much to be gained from the art of fishing.$B$BYou may improve your fishing skill.  One day, you may purchase powerful fishing rods.$B$BThe most revered fishermen may receive access to a special fish pet, a water stride mount, and a fishing raft.','',26124),
(66734,'enUS','Thank you. I owe you greatly.','',26124),
(66735,'enUS','I overheard a great deal through the cage. Rensai will be pleased with what I have to tell him.','',26124),
(66736,'enUS','I hope we meet again soon, my new friend.','',26124),
(66737,'enUS','Intruders in the crypt!  Don\'t let them leave alive!','',26124),
(66738,'enUS','You will soon join the corpses buried here, little $c!','',26124),
(66739,'enUS','The tireless efforts of the Shado-Pan are the only thing keeping this land from being ravaged by the mantid swarm. We do not ask thanks for this, but now we are faced with a time when we can no longer accomplish this task alone.','',26124),
(66740,'enUS','$n stepped on a lightning trap!','$n stepped on a lightning trap!',26124),
(66741,'enUS','Get off the ship before fire engulfs it!','',26124),
(66742,'enUS','Tread lightly, $r. The rage of this land has yet to be quenched. Your very presence here causes it anguish the likes of which it has never endured.','',26124),
(66743,'enUS','Why do we continue to fight in a war we have nothing to gain from? Do the dying screams of thousands not haunt your very dreams?','',26124),
(66744,'enUS','What happens when our wars are over? Do you expect to return to civilian life without incident despite the horrors you\'ve witnessed?','',26124),
(66745,'enUS','We openly deal with the ethereal, ignorant of their true intentions. Could we be aiding in the preparation of our own demise?','',26124),
(66746,'enUS','The north still reeks of undeath. Our homelands lay in ruin. Pandaria oozes our hatred and doubt. What hope is there for this world when the Burning Legion again lands upon our shores?','',26124),
(66747,'enUS','At what point are our hearts as full of darkness as the great evil we so tirelessly try to subdue?','',26124),
(66748,'enUS','I can smell your hatred, your violence, your doubt. Your soul bears the weight of a lifetime of hardship. Why do you continue onward down a path that can only lead to ruin?','',26124),
(66749,'enUS','Come take a seat and eat! It\'s never a bad time for a hearty meal!','',26124),
(66750,'enUS','Come and get it!','',26124),
(66751,'enUS','Surely a hot bite and a fresh pint will help those battle wounds heal a bit faster, eh?','',26124),
(66752,'enUS','I will give you a free meal if you can get this dwarf off of my new chair!','',26124),
(66753,'enUS','Li, I need another dragon gun.','Li, I need another dragon gun.',26124),
(66754,'enUS','','You think these grow on trees?',26124),
(66755,'enUS','','Do you have any fizzy energy drinks?',26124),
(66756,'enUS','','Sarya Teaflower washes her hands.',26124),
(66757,'enUS','','Sarya Teaflower sighs.',26124),
(66758,'enUS','','Can I get any of you another drink?',26124),
(66759,'enUS','','There are so many wounded...',26124),
(66760,'enUS','','Whew, time to take a break!',26124),
(66761,'enUS','Train me in First Aid.','Train me in First Aid.',26124),
(66762,'enUS','','Look at this astounding dirt! It\'s so dirt-like!',26124),
(66763,'enUS','Why don\'t you come dance with me instead good lookin\'?','',26124),
(66764,'enUS','','I wonder if my shoes are too fancy for exploring?',26124),
(66765,'enUS','','These trees are AMAZING!',26124),
(66766,'enUS','','Eek! I\'m outta here! Gyrochromatic Invisibility Engine engage!',26124),
(66767,'enUS','','I\'ve never seen roots like this before!',26124),
(66768,'enUS','','These rocks are so lifelike!',26124),
(66769,'enUS','','I wonder if I\'m too cute for the jungle?',26124),
(66770,'enUS','','I have to take some of these flowers back home!',26124),
(66771,'enUS','','Being a legendary explorer is hard work!',26124),
(66772,'enUS','Hello, $n.  My services as an auctioneer are available to those with skill in engineering.  Sadly, you have none.  Please leave.','',26124),
(66773,'enUS','A falcon\'s talon is only as useful as the grace of his flight.','',26124),
(66774,'enUS','Fear not if your weapon leaves your grasp. Your body is an ample tool against any foe.','',26124),
(66775,'enUS','Your armor is your skin in combat. Protect it and honor it, and it shall do the same for you.','',26124),
(66776,'enUS','Flames of passion serve only to ignite the kindle of others.','',26124),
(66777,'enUS','Sometimes, the fragile wasp is far more effective than the mighty bull.','',26124),
(66778,'enUS','Can you believe that they won\'t let me in? Me, of all people?','',26124),
(66779,'enUS','Can\'t you see I\'m partaking in a staring contest right now?','',26124),
(66780,'enUS','I\'m not falling for your tricks, $r. Victory shall be mine!','',26124),
(66781,'enUS','Lao-Chin\'s Healing Spheres heal him as they fade away!','',26124),
(66782,'enUS','This fool does not understand. He carries negative emotion with reckless abandon. We will all suffer the consequences if such action continues.','',26124),
(66783,'enUS','This old pandaren is a fool. How are we supposed to fight without emotion? It\'s impossible!','',26124),
(66784,'enUS','He knows more about this land than we do. Perhaps you should heed his warnings.','He knows more about this land than we do. Perhaps you should heed his warnings.',26124),
(66785,'enUS','What do you know? You act like you\'re the savior of Azeroth!','',26124),
(66786,'enUS','Fire!','Fire!',26124),
(66787,'enUS','Fire! FIRE!','Fire! FIRE!',26124),
(66788,'enUS','The ship\'s aflame!','The ship\'s aflame!',26124),
(66789,'enUS','Hey there beautiful, I\'d like to make a withdrawal.','',26124),
(66790,'enUS','What happened to the ship?!','What happened to the ship?!',26124),
(66791,'enUS','Thank you very, very much.','',26124),
(66792,'enUS','Our ship... NO! Did everyone escape? Gather here!','',26124),
(66793,'enUS','What?! MY SHIP! Who did this?!','What?! MY SHIP! Who did this?!',26124),
(66794,'enUS','Come, friends! Let us all enjoy a fine brew.','',26124),
(66795,'enUS','Young Dustback Mushan cries for help!','',26124),
(66796,'enUS','Until next time, my friends.','',26124),
(66797,'enUS','The doctor is in!','The doctor is in!',26124),
(66798,'enUS','','41,812...',26124),
(66799,'enUS','','41,813...',26124),
(66800,'enUS','','41,814...',26124),
(66801,'enUS','','Uh...uh...',26124),
(66802,'enUS','','1...',26124),
(66803,'enUS','','2...',26124),
(66804,'enUS','Shh, jinyu. It\'s hard enough to fish here as it is!','',26124),
(66805,'enUS','','I\'m going to ask Tina to come with me next time, she\'d LOVE these plants!',26124),
(66806,'enUS','','I could really go for one of Uncle Gus\' jokes about now, this place is scary!',26124),
(66808,'enUS','','Someday, I want to be an explorer!',26124),
(66809,'enUS','','I haven\'t seen Tweets in a while, I hope she\'s ok!',26124),
(66810,'enUS','','Hey! Shoes off of the table! AND FEET!',26124),
(66811,'enUS','','It would be nice to leave the Vale some day, but it\'s so pretty here!',26124),
(66812,'enUS','','Can I get you a refreshment?',26124),
(66813,'enUS','If you can find a way into our sleep chambers, you may use them.','',26124),
(66814,'enUS','You may stay while you are still useful, outsider.','',26124),
(66815,'enUS','I am surprised the Klaxxi\'va allowed you to live, but it is not for me to question.','',26124),
(66816,'enUS','I will offer you accomodations for as long as you are of use to us.','',26124),
(66817,'enUS','You! Away from our crops!','',26124),
(66818,'enUS','Hahahahaha!','',26124),
(66819,'enUS','Rake in face!','',26124),
(66820,'enUS','AYEEEEEE!','',26124),
(66821,'enUS','We grow better!  You bad!','',26124),
(66822,'enUS','We rowdy!','',26124),
(66823,'enUS','\"And that is how the shining blade came to, and left, Pandaria, its final destination unknown.\"$B$BOur people\'s lore is a woven quilt of rich stories. It is my job to bind the tomes so that they may last a thousand lifetimes.','',26124),
(66824,'enUS','There\'s so much knowledge of the ancient world stored here that we\'re only just now discovering!','',26124),
(66826,'enUS','You\'ll never leave Theramore alive!','',26124),
(66827,'enUS','','Double fortune to you, $r.$B$BIf you are looking for a lucky charm, I can help set you right up.',26124),
(66828,'enUS','Double fortune to you, $r.$B$BIf you are looking for a lucky charm, I can help set you right up.','',26124),
(66829,'enUS','','Who needs friends when you have cats?',26124),
(66830,'enUS','Thank the sea, stranger! I can get back to Sri-La village on my own.','Thank the sea, stranger! I can get back to Sri-La village on my own.',26124),
(66831,'enUS','I was fishing along the coast when the spiders got me! Thank you for saving me.','I was fishing along the coast when the spiders got me! Thank you for saving me.',26124),
(66832,'enUS','Did the Order of the Cloud Serpent send you? Bless them. Please help the others!','Did the Order of the Cloud Serpent send you? Bless them. Please help the others!',26124),
(66833,'enUS','The other victims... they made such awful sounds. Thank you for coming to my rescue!','The other victims... they made such awful sounds. Thank you for coming to my rescue!',26124),
(66834,'enUS','I thought I was finished. Thank you, and thank the Order. I can get out of here on my own.','I thought I was finished. Thank you, and thank the Order. I can get out of here on my own.',26124),
(66835,'enUS','I had a farm once, but that was a long time ago. I prefer a good battle, don\'t you?','',26124),
(66836,'enUS','','I only caught two rabbits. Now I have lots!',26124),
(66837,'enUS','Take me to Stormwind.','Take me to Stormwind.',26124),
(66838,'enUS','Take me to Orgrimmar.','Take me to Orgrimmar.',26124),
(66839,'enUS','I did not think that help would come. You have given me new hope, stranger.','I did not think that help would come. You have given me new hope, stranger.',26124),
(66840,'enUS','While I was trapped in that web, I had such feelings of doubt and despair. You have freed me from my own fears.','While I was trapped in that web, I had such feelings of doubt and despair. You have freed me from my own fears.',26124),
(66841,'enUS','I began to fear that no help would come. That everyone had forgotten me. Thank the Order that they sent you!','I began to fear that no help would come. That everyone had forgotten me. Thank the Order that they sent you!',26124),
(66842,'enUS','Are you afraid of spiders? Some feel them crawling on their skin as they wander through the endless woods.','',26124),
(66843,'enUS','Have you sheen the rum? ...hic! I can\'t sheem to find it anywhere!','',26124),
(66844,'enUS','','The Horde will pay for what they\'ve wrought here.$B$BOnce I reclaim the Focusing Iris from this... abomination... Garrosh will know the true meaning of destruction.$B$BOrgrimmar... will DROWN.',26124),
(66845,'enUS','I had a farm once, but that was a long time ago. I prefer a good battle, don\'t you?','',26124),
(66846,'enUS','We\'ll clear the ruins of Horde while you work.','We\'ll clear the ruins of Horde while you work.',26124),
(66847,'enUS','Are you afraid of spiders? Some feel them crawling on their skin as they wander through the endless woods.','',26124),
(66848,'enUS','','All of you have my deepest thanks. With the Focusing Iris removed, this lifeless bomb is merely a sickening testament to Garrosh\'s brutality. The winds of change blow fiercely; Azeroth is on the brink of war. My apologies, but you must excuse me... I have much to consider. Farewell.',26124),
(66849,'enUS','','Goodbye...',26124),
(66850,'enUS','','A historian\'s work is never done, you see. There\'s always something important happening that we will need to remember.$B$BI\'m beginning to collect the history of your people\'s coming here. What is your name, so that future generations may read your story and know your tale?',26124),
(66851,'enUS','My name is...','My name is...',26124),
(66852,'enUS','','Ah, so that\'s who you are. I\'ve already heard stories of your deeds, $N. I will write stories about you so that you will be remembered, you have my word.',26124),
(66853,'enUS','Jenji! This is $n, of course. Have you not heard of $ghis:her; deeds as of late? $GHe:She; has done much for our people.','',26124),
(66854,'enUS','','My apologies, Advisor. I did not recognize $Ghim:her;!',26124),
(66855,'enUS','','I will write of your adventures right now!',26124),
(66856,'enUS','Engaging total destruction sequence. Good bye.','',26124),
(66857,'enUS','Oftentimes, the silent grasshopper knows how to best avoid the boot.','',26124),
(66858,'enUS','If you judge a fish by its ability to climb a tree, it will live its life believing it is inadequate.','',26124),
(66859,'enUS','The early bird gets the worm, but the patient pandaren receives a hearty brew.','',26124),
(66860,'enUS','Violence may appear to do good for a time, but the evil it does will remain forever.','',26124),
(66861,'enUS','Only love can drive out hatred.','',26124),
(66862,'enUS','Instill me with your wisdom, Advisor.','Instill me with your wisdom, Advisor.',26124),
(66863,'enUS','Cleaning','Cleaning',26124),
(66865,'enUS','Few people know this, but I was once a pit fighter myself. A gladiator for the Horde\'s amusement. So I know a thing or two about martial combat.','',26124),
(66866,'enUS','Nooooo! Precious shoes!','',26124),
(66867,'enUS','Go away, shoe stealer!','',26124),
(66868,'enUS','What are you doing!? Don\'t touch those!','',26124),
(66869,'enUS','Noooo! That\'s my favorite pair!','',26124),
(66870,'enUS','No! Our precious collection!','',26124),
(66871,'enUS','I just wanted... one more... pair...','',26124),
(66872,'enUS','You can never have enough... shoes...','',26124),
(66873,'enUS','Almost.','',26124),
(66874,'enUS','Almost.','',26124),
(66875,'enUS','','I cannot join you this day, friends. I must prepare my fish for the coming feast!',26124),
(66876,'enUS','','Mograine...',26124),
(66877,'enUS','','Please, partake in the buffet laid out by the Golden Lotus as a thanks to your people for their aid in protecting the Vale of Eternal Blossoms.',26124),
(66878,'enUS','Greetings, $r.$B$BI am but a young sapling, grown here in Pandaria to become one with the land so that Tyrande may benefit from the stories it holds.The Strongbows have volunteered to protect me in my infancy so that our mistress\' wishes are fulfilled.','',26124),
(66879,'enUS','Don\'t worry, the hatchlings are quite safe here.','',26124),
(66880,'enUS','I have seen many students over the years, but there is something different about you.','',26124),
(66881,'enUS','A new student? Ah yes, very good. Have you spoken to Elder Anli?','',26124),
(66882,'enUS','Treat your cloud serpent with kindness and respect, and it will grow to trust you.','',26124),
(66883,'enUS','','A long journey is best traveled one step at a time.',26124),
(66884,'enUS','','I like to keep an eye on all of my students. I will watch your progress eagerly.',26124),
(66885,'enUS','','The wild cloud serpents breed very rarely, and as such, each egg is extremely precious.$B$BIf we do not work to help and protect the wild cloud serpents, they may one day disappear.',26124),
(66886,'enUS','','Of all the wild serpents, the onyx serpent is the rarest. These elusive black cloud serpents are known to lay their eggs on Windward Isle to the northeast.$B$BIf you come across any Onyx Eggs, please bring them to me. I shall reward you handsomely.',26124),
(66887,'enUS','Can you follow my blade?','',26124),
(66888,'enUS','You won\'t need that body where you\'re going!','',26124),
(66889,'enUS','You dare to cross the Shan\'ze?!','',26124),
(66890,'enUS','Another restless spirit...','',26124),
(66891,'enUS','I will free you from that pitiful form and reforge you in our service!','',26124),
(66892,'enUS','The body fails... but the spirit... can endure...','',26124),
(66893,'enUS','You cannot stop us! Our army will lead the coming storm!','',26124),
(66894,'enUS','Such insolence!','',26124),
(66895,'enUS','Surrender your spirit to a stone body!','',26124),
(66896,'enUS','The Shan... will take you...','',26124),
(66897,'enUS','Impossible...','',26124),
(66898,'enUS','A lively spirit for the taking...','',26124),
(66899,'enUS','I have a jar waiting just for you!','',26124),
(66900,'enUS','You will join the others in eternal servitude!','',26124),
(66901,'enUS','Fool! Your fate is sealed!','',26124),
(66902,'enUS','I will cleave the soul from between your bones!','',26124),
(66903,'enUS','Hold still, it will be over soon...','',26124),
(66904,'enUS','Death is only the beginning of your punishment!','',26124),
(66905,'enUS','Nice spirit - I think I\'ll take it.','',26124),
(66906,'enUS','A furious Orchard Needler appears above you!','',26124),
(66907,'enUS','','Careful! If they see you, they\'ll raise the alarm.$B$BDid the Golden Lotus send you to rescue us? I\'m the only one not dead or captured...',26124),
(66908,'enUS','What happened to the expedition?','What happened to the expedition?',26124),
(66909,'enUS','Can you lead us to the prisoners?','Can you lead us to the prisoners?',26124),
(66910,'enUS','','We were investigating the temple when a mogu warlord and his retinue arrived.$B$BThose of us not slain immediately were taken prisoner.$B$BI was left for dead and have been hiding here since.$B$BI don\'t know what the mogu are here for, though it can\'t be anything good!',26124),
(66911,'enUS','','They were taken towards a waterfall to the southeast. I\'ll lead you there.',26124),
(66912,'enUS','','We must take care. The temple grounds are patrolled by mogu and their saurok slaves, and their beasts lurk in the grass off the roads.',26124),
(66913,'enUS','','The central courtyard is heavily guarded. We\'ll go around.',26124),
(66914,'enUS','Slay Ancient Spirits to empower the Staff of Pei-Zhi!','Slay Ancient Spirits to empower the Staff of Pei-Zhi!',26124),
(66915,'enUS','What do you think you\'re doing?! No matter - I no longer need the staff.','',26124),
(66916,'enUS','Do you like my snakes? I get the feeling they don\'t like you!','Do you like my snakes? I get the feeling they don\'t like you!',26124),
(66917,'enUS','<Your hatchling looks at you inquisitively.>','',26124),
(66918,'enUS','<Your hatchling smiles at you.>','',26124),
(66919,'enUS','<Your hatchling chirps at you.>','',26124),
(66920,'enUS','<Your hatchling watches you.>','',26124),
(66921,'enUS','<Your hatchling looks at you with a bored expression.>','',26124),
(66922,'enUS','<Your hatchling flies around playfully.>','',26124),
(66923,'enUS','<Your hatchling rubs its scales against your arm.>','',26124),
(66924,'enUS','<Your hatchling licks you.>','',26124),
(66925,'enUS','<The hatchling looks at you inquisitively.>','',26124),
(66926,'enUS','<The hatchling smiles at you.>','',26124),
(66927,'enUS','<The hatchling chirps at you.>','',26124),
(66928,'enUS','<The hatchling watches you.>','',26124),
(66929,'enUS','<The hatchling looks at you with a bored expression.>','',26124),
(66930,'enUS','<The hatchling flies around playfully.>','',26124),
(66931,'enUS','<The hatchling rubs its scales against your arm.>','',26124),
(66932,'enUS','<The hatchling licks you.>','',26124),
(66933,'enUS','<Your hatchling glares at you with a disappointed frown. It sees that you are playing with another hatchling.>$B$B<You can only play with one hatchling at a time. Speak to Elder Anli to return your current hatchling before playing Catch! with this one.>','',26124),
(66934,'enUS','<The hatchling glares at you with a disappointed frown. It sees that you are playing with another hatchling.>$B$B<You can only play with one hatchling at a time. Speak to Elder Anli to return your current hatchling before playing Catch! with this one.>','',26124),
(66935,'enUS','','',26124),
(66936,'enUS','Your deeds of valor will be remembered.','',26124),
(66937,'enUS','','',26124),
(66938,'enUS','Your serpent flies back home!','Your serpent flies back home!',26124),
(66939,'enUS','|TInterface\\Icons\\spell_shadow_sacrificialshield.blp:20|t%s begins to cast |cFFFF0000|Hspell:117697|h[Shield of Darkness]|h|r!','',26124),
(66941,'enUS','Each bodily injury endured, is a lesson learned. Each defeat, an opportunity to grow.','',26124),
(66942,'enUS','For Pandaria!!','',26124),
(66943,'enUS','For Pandaria!!','',26124),
(66944,'enUS','$p! I am... not in control... Get away!','',26124),
(66945,'enUS','Justice Quartermaster','Justice Quartermaster',26124),
(66946,'enUS','Finding peace within will allow you to see obstacles with reason.','',26124),
(66948,'enUS','Wisdom can only penetrate a heart that is truly open to it.','',26124),
(66949,'enUS','Those are mine! I stole them first!','',26124),
(66950,'enUS','It hurts... so much...','It hurts... so much...',26124),
(66951,'enUS','Offer them no mercy, not after what they\'ve done.','Offer them no mercy, not after what they\'ve done.',26124),
(66952,'enUS','Nightmares!  Horrible nightmares!','Nightmares!  Horrible nightmares!',26124),
(66953,'enUS','So much pain...','So much pain...',26124),
(66954,'enUS','The agony...','The agony...',26124),
(66955,'enUS','Save the others!  Please!','Save the others!  Please!',26124),
(66956,'enUS','I owe you my life!','I owe you my life!',26124),
(66957,'enUS','Kill them!  Kill them all!','Kill them!  Kill them all!',26124),
(66958,'enUS','We were fortunate enough to find the Vale after it opened its gates. We sought refuge, and have found safe haven.$B$BAre you lost? May I help you find something?','We were fortunate enough to find the Vale after it opened its gates. We sought refuge, and have found safe haven.$B$BAre you lost? May I help you find something?',26124),
(66959,'enUS','The auction house is located on the second floor, on the right side of the building as you enter.$B$BI will mark the location on your map.','The auction house is located on the second floor, on the right side of the building as you enter.$B$BI will mark the location on your map.',26124),
(66960,'enUS','The bank is located on the second floor, on the left side of the building as you enter.$B$BI will mark the location on your map.','The bank is located on the second floor, on the left side of the building as you enter.$B$BI will mark the location on your map.',26124),
(66961,'enUS','The flight master is located out on the main terrace, at the top of the twin stairs and before you enter the main building.$B$BI will mark the location on your map.','The flight master is located out on the main terrace, at the top of the twin stairs and before you enter the main building.$B$BI will mark the location on your map.',26124),
(66962,'enUS','Skydancer Shun can teach you how to fly in Pandaria. He rides his cloud serpent on the main terrace. I will mark his location on your map.','Skydancer Shun can teach you how to fly in Pandaria. He rides his cloud serpent on the main terrace. I will mark his location on your map.',26124),
(66963,'enUS','The inn is located on the main floor, to the right as you enter the building.$B$BI will mark the location on your map.','The inn is located on the main floor, to the right as you enter the building.$B$BI will mark the location on your map.',26124),
(66964,'enUS','There is a battle trainer by the name of Gentle San who trains her pets out on the main terrace.$B$BI will mark the location on your map.','There is a battle trainer by the name of Gentle San who trains her pets out on the main terrace.$B$BI will mark the location on your map.',26124),
(66965,'enUS','The ethereals set up shop in the upstairs corridor to the right as you enter the main building.$B$BI will mark the location on your map.','The ethereals set up shop in the upstairs corridor to the right as you enter the main building.$B$BI will mark the location on your map.',26124),
(66966,'enUS','Tracker Lang, the stable master, can be found on the main terrace before you enter the main building. He stands next to the pet battle trainer.$B$BI will mark the location on your map.','Tracker Lang, the stable master, can be found on the main terrace before you enter the main building. He stands next to the pet battle trainer.$B$BI will mark the location on your map.',26124),
(66967,'enUS','Vendors from all over the land have found their way into the city. What are you looking for?','Vendors from all over the land have found their way into the city. What are you looking for?',26124),
(66968,'enUS','You are looking for the apothecary. He makes some truly wonderful potions and tinctures. Got rid of my rash in no time!$B$BAhem... Apothecary Greenmoss sells his wares in the crafter\'s hall. I will mark the location on your map.','You are looking for the apothecary. He makes some truly wonderful potions and tinctures. Got rid of my rash in no time!$B$BAhem... Apothecary Greenmoss sells his wares in the crafter\'s hall. I will mark the location on your map.',26124),
(66969,'enUS','The Tomb of Conquerors is directly below you. Follow the dirt path to the entrance. You must hurry!','',26124),
(66970,'enUS','The blacksmiths all work in the crafter\'s hall, to the left as you enter the main building.$B$BI will mark the location on your map.','The blacksmiths all work in the crafter\'s hall, to the left as you enter the main building.$B$BI will mark the location on your map.',26124),
(66971,'enUS','Looking for some brew, eh? The Keggary is the place to go for fine ales! I\'ll mark it on your map.','Looking for some brew, eh? The Keggary is the place to go for fine ales! I\'ll mark it on your map.',26124),
(66972,'enUS','We need to get those arrows and get out of here.','',26124),
(66973,'enUS','Initiate, may I have another quiver please?','Initiate, may I have another quiver please?',26124),
(66974,'enUS','Ah, so you\'re an up and coming chef, are you? You can find everything you need from Barleyflower. She sells her wares in the keggery.$B$BI will mark the location on your map.','Ah, so you\'re an up and coming chef, are you? You can find everything you need from Barleyflower. She sells her wares in the keggery.$B$BI will mark the location on your map.',26124),
(66975,'enUS','Derenda Enkleshin carries enchanting supplies. She can be found in the chamber of masters, to the left as you enter the building.$B$BI will mark the location on your map.','Derenda Enkleshin carries enchanting supplies. She can be found in the chamber of masters, to the left as you enter the building.$B$BI will mark the location on your map.',26124),
(66976,'enUS','I seem to recall there is an engineer in the chamber of masters, to the left as you enter the main building.$B$BI will mark the location on your map.','I seem to recall there is an engineer in the chamber of masters, to the left as you enter the main building.$B$BI will mark the location on your map.',26124),
(66977,'enUS','Thinking about setting off a spark or two? I should go buy some fireworks myself! The vendor can be found in the chamber of masters.$B$BI\'ll mark the location on your map.','Thinking about setting off a spark or two? I should go buy some fireworks myself! The vendor can be found in the chamber of masters.$B$BI\'ll mark the location on your map.',26124),
(66978,'enUS','First aid is not far from here, do not worry. The healers can be found just inside the chamber of masters.$B$BI will mark the location on your map.','First aid is not far from here, do not worry. The healers can be found just inside the chamber of masters.$B$BI will mark the location on your map.',26124),
(66979,'enUS','The... the yaungol!\n\nThey attacked my farm, and the nearby village, Eastwind Rest... killed some of us, and the ones they didn\'t kill they chased off!\n\nI managed to gather some of us here. Any word on help coming from Binan?','',26124),
(66980,'enUS','I\'m from the Horde. We\'re here to save you and rebuild your village.','I\'m from the Horde. We\'re here to save you and rebuild your village.',26124),
(66981,'enUS','Ban, would you please give me more explosives?','Ban, would you please give me more explosives?',26124),
(66982,'enUS','Yes, there is a fishing supplies vendor inside the hall of tranquility. Please be quiet so as to not ruin a catch!$B$BI will mark the location on your map.','Yes, there is a fishing supplies vendor inside the hall of tranquility. Please be quiet so as to not ruin a catch!$B$BI will mark the location on your map.',26124),
(66983,'enUS','Are you looking for some food and drink? If so, then Mifan in summer\'s rest has a fantastic selection.$B$BI will mark the location on your map.','Are you looking for some food and drink? If so, then Mifan in summer\'s rest has a fantastic selection.$B$BI will mark the location on your map.',26124),
(66984,'enUS','You know, things are really starting to look up ever since you came around!\n\nCan\'t help thinking about what happened to my friends back on the farm, though...','',26124),
(66985,'enUS','Looking for general goods? Marli Two-Toes will have what you need. He is located inside summer\'s rest. I will mark the location on your map.','Looking for general goods? Marli Two-Toes will have what you need. He is located inside summer\'s rest. I will mark the location on your map.',26124),
(66986,'enUS','Yes, there is a vendor of herbs in the city. Hafuna Landwalker can be found in the chamber of masters, to the left as you enter the building.$B$BI will mark the location on your map.','Yes, there is a vendor of herbs in the city. Hafuna Landwalker can be found in the chamber of masters, to the left as you enter the building.$B$BI will mark the location on your map.',26124),
(66987,'enUS','Ah, a scrollmaker! You\'ll be looking for inks and vellum, I suppose? They can be found in the chamber of masters, to the left as you enter the building.$B$BI will mark the location on your map.','Ah, a scrollmaker! You\'ll be looking for inks and vellum, I suppose? They can be found in the chamber of masters, to the left as you enter the building.$B$BI will mark the location on your map.',26124),
(66988,'enUS','Jewelcrafting? That\'s fine work, indeed. You can purchase supplies from Vanaris Whitesong in the chamber of masters.$B$BI will mark the location on your map.','Jewelcrafting? That\'s fine work, indeed. You can purchase supplies from Vanaris Whitesong in the chamber of masters.$B$BI will mark the location on your map.',26124),
(66989,'enUS','You can find a leatherworking trainer at the Grummle Bazaar in Kun-Lai Summit. I will mark the location on your map.','You can find a leatherworking trainer at the Grummle Bazaar in Kun-Lai Summit. I will mark the location on your map.',26124),
(66990,'enUS','Leatherworking and skins? You must be looking for a tanner. There\'s one in the chamber of masters, if I recall.$B$BI will mark the location on your map.','Leatherworking and skins? You must be looking for a tanner. There\'s one in the chamber of masters, if I recall.$B$BI will mark the location on your map.',26124),
(66991,'enUS','You can purchase mining supplies in the back of the chamber of masters, from Razzie Coalwrench.$B$BI will mark the location on your map.','You can purchase mining supplies in the back of the chamber of masters, from Razzie Coalwrench.$B$BI will mark the location on your map.',26124),
(66992,'enUS','Sheena Sunweaver is known for her sales of reagents and can be found in the chamber of masters, to the left as you enter the building.$B$BI will mark the location on your map.','Sheena Sunweaver is known for her sales of reagents and can be found in the chamber of masters, to the left as you enter the building.$B$BI will mark the location on your map.',26124),
(66993,'enUS','As dark as things seem, I must not give up hope. We must not be cowed by the violence of the Yaungol.\n\nYou... have you come to help us?','',26124),
(66994,'enUS','I\'m from the Horde. We\'re here to save you and rebuild your village.','I\'m from the Horde. We\'re here to save you and rebuild your village.',26124),
(66995,'enUS','I must admit, when times were darkest, I did not believe that we would survive. Thanks to you and your people, I am glad to have been proven wrong.','',26124),
(66996,'enUS','Esha the Loommaiden is renowned for her cloth skills.$B$BShe works in the chamber of masters, to the left as you enter the building.$B$BI will mark the location on your map.','Esha the Loommaiden is renowned for her cloth skills.$B$BShe works in the chamber of masters, to the left as you enter the building.$B$BI will mark the location on your map.',26124),
(66997,'enUS','I know of a saleswoman of trade goods in Summer\'s Rest. I will mark the location on your map.','I know of a saleswoman of trade goods in Summer\'s Rest. I will mark the location on your map.',26124),
(66998,'enUS','Where did all of these mogu come from?','Where did all of these mogu come from?',26124),
(66999,'enUS','Thank you for rescuing us, $c. Hopefully now our mission will not be lost.','Thank you for rescuing us, $c. Hopefully now our mission will not be lost.',26124),
(67000,'enUS','These \"elf\" creatures. Can they be trusted?','These \"elf\" creatures. Can they be trusted?',26124),
(67001,'enUS','First mantid, then mogu. These are dark days indeed.','First mantid, then mogu. These are dark days indeed.',26124),
(67002,'enUS','I don\'t know what brought you into the Forbidden Jungle, but I am glad it did. You saved us from slavery... or worse.','I don\'t know what brought you into the Forbidden Jungle, but I am glad it did. You saved us from slavery... or worse.',26124),
(67003,'enUS','When did the mogu learn to wield magic portals?','When did the mogu learn to wield magic portals?',26124),
(67004,'enUS','The mogu chose the worst time to attack. The mantid are on the move, and not even the great wall will hold them back.','The mogu chose the worst time to attack. The mantid are on the move, and not even the great wall will hold them back.',26124),
(67005,'enUS','Our dreams have been haunted by mantid. We hoped the Crane Temple would give us some insight to these visions.','Our dreams have been haunted by mantid. We hoped the Crane Temple would give us some insight to these visions.',26124),
(67006,'enUS','You need to speak to Ba\'kon. He has an ample supply of meats. I heard he makes it all fresh$B$BI\'ll mark his location on your map. Good luck!','You need to speak to Ba\'kon. He has an ample supply of meats. I heard he makes it all fresh$B$BI\'ll mark his location on your map. Good luck!',26124),
(67007,'enUS','Itching for something sweet? You need to find Beige Sugar.$B$BHe\'s usually wandering around the bottom floor, though he\'s been known to step into the keggery for a treat every now and then.','Itching for something sweet? You need to find Beige Sugar.$B$BHe\'s usually wandering around the bottom floor, though he\'s been known to step into the keggery for a treat every now and then.',26124),
(67008,'enUS','The... the yaungol!\n\nThey attacked my farm, and the nearby village, Westwind Rest... killed some of us, and the ones they didn\'t kill they chased off!\n\nI managed to gather some of us here. Any word on help coming from Binan?','',26124),
(67009,'enUS','I\'m from the Alliance. We\'re here to save you and rebuild your village.','I\'m from the Alliance. We\'re here to save you and rebuild your village.',26124),
(67010,'enUS','Looking for a professions trainer?$B$BThe zen master trainers can be found all across Pandaria. Tell me who you are looking for.$B$BIf you cannot find the person you seek here in Pandaria, you may also seek professions masters in your home city. They should also be able to improve your skill in your craft.','Looking for a professions trainer?$B$BThe zen master trainers can be found all across Pandaria. Tell me who you are looking for.$B$BIf you cannot find the person you seek here in Pandaria, you may also seek professions masters in your home city. They should also be able to improve your skill in your craft.',26124),
(67011,'enUS','I\'m from the Alliance. We\'re here to save you and rebuild your village.','I\'m from the Alliance. We\'re here to save you and rebuild your village.',26124),
(67012,'enUS','I have heard there are master alchemists among the Klaxxi, far over the wall in the Dread Wastes. I will mark the location on your map for you.','I have heard there are master alchemists among the Klaxxi, far over the wall in the Dread Wastes. I will mark the location on your map for you.',26124),
(67013,'enUS','There is a master of archaeology in the Seat of Knowledge, above Mogu\'shan Palace here in the Vale of Eternal Blossoms.$B$BI will mark their location on your map for you.','There is a master of archaeology in the Seat of Knowledge, above Mogu\'shan Palace here in the Vale of Eternal Blossoms.$B$BI will mark their location on your map for you.',26124),
(67014,'enUS','You must be seeking Zen Master Lao! He is working at the Setting Sun Garrison in the Vale of Eternal Blossoms.$B$BI will mark his location on your map.','You must be seeking Zen Master Lao! He is working at the Setting Sun Garrison in the Vale of Eternal Blossoms.$B$BI will mark his location on your map.',26124),
(67015,'enUS','Interested in developing your cooking skills, are you?$B$BYou need to speak to the Ironpaw family. They can be found at the Halfhill Market in the Valley of the Four Winds.$B$BI will mark the location on your map for you.','Interested in developing your cooking skills, are you?$B$BYou need to speak to the Ironpaw family. They can be found at the Halfhill Market in the Valley of the Four Winds.$B$BI will mark the location on your map for you.',26124),
(67016,'enUS','For your enchanting needs, you must speak to Lai the Spellpaw at Dawn\'s Blossom in The Jade Forest.$B$BI will mark the location on your map.','For your enchanting needs, you must speak to Lai the Spellpaw at Dawn\'s Blossom in The Jade Forest.$B$BI will mark the location on your map.',26124),
(67017,'enUS','You can find the person you seek at Nesingwary\'s Safari in the Valley of the Four Winds.$B$BI will mark their location on your map.','You can find the person you seek at Nesingwary\'s Safari in the Valley of the Four Winds.$B$BI will mark their location on your map.',26124),
(67018,'enUS','It\'s a wonderful day to be alive, isn\'t it?','',26124),
(67019,'enUS','Always look forward, never back.','',26124),
(67020,'enUS','','Have you seen the onyx serpents? They are known to lay their eggs on Windward Isle. If you find such an egg and bring it to Elder Anli, you will be justly rewarded.',26124),
(67021,'enUS','','Have you flown in the Sky Race? I wish you luck, if you do.',26124),
(67022,'enUS','Oh yes, you are looking for Ala\'thinel. You can find her inside the Shrine of Two Moons.$B$BI will mark her location on your map.','Oh yes, you are looking for Ala\'thinel. You can find her inside the Shrine of Two Moons.$B$BI will mark her location on your map.',26124),
(67023,'enUS','You can improve your fishing skill by visiting Nat Pagle at the Anglers Wharf in the Krasarang Wilds. Let me mark the location for you.','You can improve your fishing skill by visiting Nat Pagle at the Anglers Wharf in the Krasarang Wilds. Let me mark the location for you.',26124),
(67024,'enUS','Yes, I know of an inscription trainer in the Seat of Knowledge, in the Vale of Eternal Blossoms.$B$BLet me mark their location on your map.','Yes, I know of an inscription trainer in the Seat of Knowledge, in the Vale of Eternal Blossoms.$B$BLet me mark their location on your map.',26124),
(67025,'enUS','You seek Mai the Jade Shaper. You can find her at Greenstone Village in The Jade Forest.$B$BI will mark her location on your map.','You seek Mai the Jade Shaper. You can find her at Greenstone Village in The Jade Forest.$B$BI will mark her location on your map.',26124),
(67026,'enUS','Things are always better than they seem.','',26124),
(67027,'enUS','There are master miners located at the Greenstone Quarry in the Jade Forest. They can probably help you improve your skill. I will mark the location on your map.','There are master miners located at the Greenstone Quarry in the Jade Forest. They can probably help you improve your skill. I will mark the location on your map.',26124),
(67028,'enUS','There is a skinning trainer at Nesingwary\'s Safari in the Valley of the Four Winds.$B$BI will mark their location on your map.','There is a skinning trainer at Nesingwary\'s Safari in the Valley of the Four Winds.$B$BI will mark their location on your map.',26124),
(67029,'enUS','You seek Silkmaster Tsai at the Silken Fields in the Valley of the Four Winds. I will mark his location on your map for you.','You seek Silkmaster Tsai at the Silken Fields in the Valley of the Four Winds. I will mark his location on your map for you.',26124),
(67030,'enUS','','Your cloud serpent approaches, $n. When you are ready, hop on and we will begin.',26124),
(67031,'enUS','I guess I was wrong about Shomi...','',26124),
(67032,'enUS','The elders were right; you really can\'t judge a book by it\'s cover.','',26124),
(67033,'enUS','Do you think Shomi will show me her fighting skills?','',26124),
(67034,'enUS','Don\'t tell her I said this, but I think Shomi did a great job defending the village.','',26124),
(67035,'enUS','I\'m gonna catch you!','',26124),
(67036,'enUS','Slow down Mei, I\'m getting tired!','',26124),
(67037,'enUS','I\'m just letting you win.','',26124),
(67038,'enUS','Ow, I got a pebble in my shoe.','',26124),
(67039,'enUS','','Nyah! You can\'t catch me!',26124),
(67040,'enUS','','Come on, you slow poke!',26124),
(67041,'enUS','','I\'m barely even trying!',26124),
(67042,'enUS','','You can\'t catch me Lo!',26124),
(67043,'enUS','Die like the rest, slave!','',26124),
(67044,'enUS','Get these slaves to Kun-La Summit! Open the portal!','',26124),
(67045,'enUS','The master cannot wait any longer for these artifacts.','',26124),
(67046,'enUS','Open the portal to Kun-Lai Summit, you fools! Quickly!','',26124),
(67047,'enUS','Quiet, slave! You\'re worth just as much dead as alive.','',26124),
(67048,'enUS','I\'m getting rusty... and my lockpicks are too apparently.  Do me a favor, don\'t let Ren know you found me here, kay?','',26124),
(67049,'enUS','','So I take it you aren\'t having any luck?',26124),
(67050,'enUS','','Any luck today?  You haven\'t brought any back yet.',26124),
(67051,'enUS','','I see you\'re fishing... again.  Are you doing better than yesterday?',26124),
(67052,'enUS','','Here\'s a kiss for good luck, I think you\'re going to need it.',26124),
(67053,'enUS','','I wouldn\'t mind that you wasted each day if you caught a few more fish.',26124),
(67054,'enUS','','Be glad I didn\'t marry you for your fishing skills...',26124),
(67055,'enUS','You know, I\'ve been stuck in these cages watching the mogu a lot, but I\'m pretty sure I\'ve never seen a girl mogu.  What\'s with that?','',26124),
(67056,'enUS','I was relieving myself into one of the golden pools when they caught me.  I guess you could call it a karma capture.','',26124),
(67057,'enUS','Ren bet me that I couldn\'t steal one of the mogu cannons.  I didn\'t think they\'d be so heavy!','',26124),
(67058,'enUS','That\'s the last time I\'ll let them catch me, promise.','',26124),
(67059,'enUS','What took you so long?  I almost thought they weren\'t going to send someone for me this time... my heart frowned a little.','',26124),
(67060,'enUS','I\'ve made a mental note, mogu are light sleepers.  Pass the word.','',26124),
(67061,'enUS','It feels so good to stretch my limbs!  It was cramped in there.  They really should invest in more roomy cages!','',26124),
(67062,'enUS','Thanks!','',26124),
(67063,'enUS','','Ah, these kids never run out of energy!',26124),
(67064,'enUS','','Don\'t come crying to me when you fall and scuff your knees!',26124),
(67065,'enUS','','They do that all day.  I get exhausted just looking at them.',26124),
(67066,'enUS','Not much so far, but the day is young.','',26124),
(67067,'enUS','I see them wiggling around in the water, but they aren\'t biting!','',26124),
(67068,'enUS','Haven\'t had much luck. I think it\'s my bait.','',26124),
(67069,'enUS','I could use another emergency buoy, Arie.','I could use another emergency buoy, Arie.',26124),
(67070,'enUS','','Remember - fly through 10 checkpoint flags, then fly under the finish line.',26124),
(67071,'enUS','','The pennants mark the race course, but you will not be penalized for finding other routes.',26124),
(67072,'enUS','','You may find that other paths are faster.',26124),
(67073,'enUS','','I have shown you part of the course. Now, let us see the finish line. Follow me!',26124),
(67074,'enUS','','Remember, in a real race, you will compete against the other trainees in the Order.',26124),
(67075,'enUS','','This is the finish line. After you have flown through all 10 checkpoints, fly under the finish line to lock in your place.',26124),
(67076,'enUS','','Remember, fly UNDER the finish line!',26124),
(67077,'enUS','','That concludes our lesson.',26124),
(67078,'enUS','If you seek to learn more of the herbalism arts, I suggest you speak to Han Flowerbloom at the Halfhill Market in the Valley of the Four Winds.$B$BI will mark his  position for you.','If you seek to learn more of the herbalism arts, I suggest you speak to Han Flowerbloom at the Halfhill Market in the Valley of the Four Winds.$B$BI will mark his  position for you.',26124),
(67079,'enUS','You are looking for the apothecary. He makes some truly wonderful potions and tinctures. Got rid of my rash in no time!$B$BAhem... Victor Pearce sells his wares in the chamber of masters. I will mark the location on your map.','You are looking for the apothecary. He makes some truly wonderful potions and tinctures. Got rid of my rash in no time!$B$BAhem... Victor Pearce sells his wares in the chamber of masters. I will mark the location on your map.',26124),
(67080,'enUS','','The stakes will be high.',26124),
(67081,'enUS','','The faster you race, the better your prize.',26124),
(67082,'enUS','Don\'t see what you need in the city?$B$BWhat are you looking for? Maybe I can help you find it.','Don\'t see what you need in the city?$B$BWhat are you looking for? Maybe I can help you find it.',26124),
(67083,'enUS','There are no battlemasters here in the Vale.$B$BYou must return to your home city to queue for battlegrounds or arenas of war.','There are no battlemasters here in the Vale.$B$BYou must return to your home city to queue for battlegrounds or arenas of war.',26124),
(67084,'enUS','Oh, looking for your class trainer? Unfortunately none of them have made it here to the Vale of Eternal Blossoms.$B$BYou can return to your home city to find those.','Oh, looking for your class trainer? Unfortunately none of them have made it here to the Vale of Eternal Blossoms.$B$BYou can return to your home city to find those.',26124),
(67085,'enUS','Ogo, I need another Pot of Fire.','Ogo, I need another Pot of Fire.',26124),
(67086,'enUS','Transmogrification and Void Storage services can be found in your home city.','Transmogrification and Void Storage services can be found in your home city.',26124),
(67087,'enUS','Ah, what quartermaster are you searching for? Perhaps I can help you find them.','Ah, what quartermaster are you searching for? Perhaps I can help you find them.',26124),
(67088,'enUS','','Take care, friend!',26124),
(67089,'enUS','','May the winds be kind to you!',26124),
(67090,'enUS','','Be sure to stop by again soon!',26124),
(67091,'enUS','','Safe journey, traveler!',26124),
(67092,'enUS','You can find the Conquest Quartermaster and the Glorious Conquest Quartermaster on the Serpent\'s Spine to the west.$B$BI will mark their location on your map.','You can find the Conquest Quartermaster and the Glorious Conquest Quartermaster on the Serpent\'s Spine to the west.$B$BI will mark their location on your map.',26124),
(67093,'enUS','The Honor Quartermaster can be found on the Serpent\'s Spine, the great wall to the west.$B$BI will mark their location on your map for you.','The Honor Quartermaster can be found on the Serpent\'s Spine, the great wall to the west.$B$BI will mark their location on your map for you.',26124),
(67094,'enUS','You can trade your marks of justice with Commander Lo Ping, who can be found at Niuzao Temple in the Townlong Steppes.$B$BI will mark his location on your map.','You can trade your marks of justice with Commander Lo Ping, who can be found at Niuzao Temple in the Townlong Steppes.$B$BI will mark his location on your map.',26124),
(67095,'enUS','The valor quartermaster, Commander Oxheart, can be found at Niuzao Temple in the Townlong Steppes.$B$BI will mark her location on your map.','The valor quartermaster, Commander Oxheart, can be found at Niuzao Temple in the Townlong Steppes.$B$BI will mark her location on your map.',26124),
(67096,'enUS','Uncle Deming got me a goldfish for my birthday. He calls it Su-Shi.','',26124),
(67097,'enUS','But papa said I fed him too much, so he got fat.','',26124),
(67098,'enUS','He outgrew his bowl, so now we keep him in this pond!','',26124),
(67099,'enUS','It\'s okay. I think he likes it there.','',26124),
(67100,'enUS','You like it here, don\'t you Su-Shi?','',26124),
(67101,'enUS','Looking to find the Anglers Quartermaster? That would be Nat Pagle. You can find him at the Anglers Wharf in Krasarang Wilds.$B$BLet me mark the location on your map for you.','Looking to find the Anglers Quartermaster? That would be Nat Pagle. You can find him at the Anglers Wharf in Krasarang Wilds.$B$BLet me mark the location on your map for you.',26124),
(67102,'enUS','Here you go, Su-Shi. You\'re my best friend!','',26124),
(67103,'enUS','The August Celestials quartermaster can be found here in the Vale. Sage Lotusbloom stands with the other faction representatives, in the lower section of The Golden Terrace.$B$BI will mark her location on your map.','The August Celestials quartermaster can be found here in the Vale. Sage Lotusbloom stands with the other faction representatives, in the lower section of The Golden Terrace.$B$BI will mark her location on your map.',26124),
(67104,'enUS','You need to talk to Teng Thundermalt! He can be found at the Stormstout Brewery in the Valley of the Four Winds.$B$BLet me mark the location on your map for you.','You need to talk to Teng Thundermalt! He can be found at the Stormstout Brewery in the Valley of the Four Winds.$B$BLet me mark the location on your map for you.',26124),
(67105,'enUS','Ah, you seek Jaluu the Generous! He can be found walking around the steps of Mogu\'shan Palace, here in the Vale of Eternal Blossoms.$B$BI will mark his location on your map for you.','Ah, you seek Jaluu the Generous! He can be found walking around the steps of Mogu\'shan Palace, here in the Vale of Eternal Blossoms.$B$BI will mark his location on your map for you.',26124),
(67106,'enUS','Hmmm, I\'m afraid I know little of the Klaxxi, but I have heard whispers of their city, Klaxxi\'vess, far to the west in the Dread Wastes. Perhaps you can find the Klaxxi Quartermaster there.$B$BI will mark the location on your map.','Hmmm, I\'m afraid I know little of the Klaxxi, but I have heard whispers of their city, Klaxxi\'vess, far to the west in the Dread Wastes. Perhaps you can find the Klaxxi Quartermaster there.$B$BI will mark the location on your map.',26124),
(67107,'enUS','You seek Tan Shin Tiao. She can be found in the Seat of Knowledge, above Mogu\'shan Palace here in the Vale of Eternal Blossoms.$B$BI will mark her location on your map.','You seek Tan Shin Tiao. She can be found in the Seat of Knowledge, above Mogu\'shan Palace here in the Vale of Eternal Blossoms.$B$BI will mark her location on your map.',26124),
(67108,'enUS','San Redscale is the quartermaster for the Order of the Cloud Serpent.$B$BYou can find him at The Arboretum in The Jade Forest.$B$BI will mark his location on your map.','San Redscale is the quartermaster for the Order of the Cloud Serpent.$B$BYou can find him at The Arboretum in The Jade Forest.$B$BI will mark his location on your map.',26124),
(67109,'enUS','The Shado-Pan quartermaster can be found at the Shado-Pan Garrison in the Townlong Steppes.$B$BI will mark their location on your map.','The Shado-Pan quartermaster can be found at the Shado-Pan Garrison in the Townlong Steppes.$B$BI will mark their location on your map.',26124),
(67110,'enUS','If you\'re looking for the Tillers quartermaster, Gina Mudclaw\'s your girl. She\'ll be running the market at Halfhill.$B$BLet me mark her location on your map.','If you\'re looking for the Tillers quartermaster, Gina Mudclaw\'s your girl. She\'ll be running the market at Halfhill.$B$BLet me mark her location on your map.',26124),
(67111,'enUS','','Death to all who dare challenge my empire!',26124),
(67112,'enUS','','Gyrocopter Attack!',26124),
(67113,'enUS','I challenge you!','I challenge you!',26124),
(67114,'enUS','','Let\'s just try the Gyrocopter Attack again!',26124),
(67115,'enUS','','I\'m out of ideas. Gyrocopter Attack?',26124),
(67116,'enUS','','Why...why him? We are simple farmers...what did we do to deserve this?',26124),
(67117,'enUS','','Gy... ro... cop...',26124),
(67118,'enUS','What\'s wrong?','What\'s wrong?',26124),
(67119,'enUS','','My husband wanted to see what was happening down by the water. That\'s when...when...$B$B<Elder Yoon Su begins to sob uncontrollably.>',26124),
(67120,'enUS','','...ter...',26124),
(67121,'enUS','Please, don\'t cry. What happened next?','Please, don\'t cry. What happened next?',26124),
(67122,'enUS','','A rogue bomb from the battle flew towards us. I survived, but...my husband...',26124),
(67123,'enUS','Imma runnin away.','',26124),
(67124,'enUS','Um, Fran, it looks like I somehow lost your watering can.  May I have another, please?','Um, Fran, it looks like I somehow lost your watering can.  May I have another, please?',26124),
(67125,'enUS','I found this jar of bugs in a shack in the middle of Kun-Lai. I didn\'t think anything of it until I saw the letters...','',26124),
(67126,'enUS','It has to be a message! Maybe even a clue to something important!','',26124),
(67127,'enUS','You just don\'t get it! This could be a herald to the end times!','',26124),
(67128,'enUS','','What letters? Oh, the ones on the lid? It\'s probably just someone\'s intials. It doesn\'t mean anything.',26124),
(67129,'enUS','','Waaaaauughh!!',26124),
(67130,'enUS','','Don\'t be ridiculous. It\'s just a jar full of bugs. It\'s gross if you ask me.',26124),
(67131,'enUS','','That\'s crazy talk! See, this is why we shouldn\'t leave the village!',26124),
(67132,'enUS','Good idea!','',26124),
(67133,'enUS','','You do that. I bet it\'s just going to lead you in a giant circle and you\'ll never find the answer!',26124),
(67134,'enUS','Well, I\'m going to follow the clue and see where it leads me!','',26124),
(67135,'enUS','','Be careful with that thing, Jun-Jun! One strong gust of wind could carry you into the sea!',26124),
(67137,'enUS','','My goodness, Duyi. What have you been feeding that thing?',26124),
(67138,'enUS','','Maybe we should feed YOU to that fish!',26124),
(67139,'enUS','','Duyi the Fish Snack! Hah!',26124),
(67141,'enUS','','That is an awfully impressive weapon for someone that comes in peace, stranger.',26124),
(67142,'enUS','Imma healin.','',26124),
(67143,'enUS','Wow, Duyi. What have you got there?','Wow, Duyi. What have you got there?',26124),
(67144,'enUS','Bow to me and we shall begin.','',26124),
(67145,'enUS','<Duyi looks at you, beaming with pride.>','',26124),
(67146,'enUS','','You are welcome here, $r. Please, make yourself at home. There is plenty of food and ale, and there\'s a bed upstairs if you need to rest.\n\n<Maolin smiles warmly at you.>',26124),
(67147,'enUS','Thank you, Maolin.','Thank you, Maolin.',26124),
(67149,'enUS','All right, ladies! Watch this!','',26124),
(67150,'enUS','Impressive! I\'m going to have to watch out for you.','',26124),
(67151,'enUS','I win this round, rookie!','',26124),
(67152,'enUS','','Your power is impressive.  I admit defeat.',26124),
(67153,'enUS','Why should we trade with you? How are you any different than your Horde friends save the color of your banner?','',26124),
(67154,'enUS','I am the sole protector of this village. My name is Chut Sri Nu.$B$BI bid you welcome, but know that my meditation has shown me that your travels here will bring great change to this land. Let us both hope that you leave Pandaria better off than you found it.','',26124),
(67155,'enUS','What of Jor Jor? He seems to protect the mayor.','What of Jor Jor? He seems to protect the mayor.',26124),
(67156,'enUS','Jor Jor hails from the Valley of the Four Winds. Born a farmer\'s child, he left his home to come here when he heard of your arrival. He believes himself a warrior, but I can assure you he is but an arrogant youth, longing for the thrill of combat without ever having endured its horrors.','',26124),
(67157,'enUS','Ah, the winds spoke of newcomers to our village. I feel that we will learn much from each other, so long as our minds are open and our spirits pure.$B$BPerhaps your people will be more respectful of mine than the Horde was.','',26124),
(67158,'enUS','Explore Pandaria, but be cautious. This land holds great bounty and danger alike to the unwary.','',26124),
(67159,'enUS','The ground beneath your feet lives and breathes. It may hold you steadily right now, but bring war and suffering here and it will respond in kind. Such is the way of nature.','',26124),
(67160,'enUS','Awww, I knew you\'d win! I\'d better practice some more...','',26124),
(67161,'enUS','Let\'s both do our best!','',26124),
(67162,'enUS','<Roars.>','',26124),
(67163,'enUS','Let\'s see which one of us is the better student. I challenge you to a duel!','Let\'s see which one of us is the better student. I challenge you to a duel!',26124),
(67164,'enUS','','Our village is small, but my family has been producing Pandaria\'s finest cider atop these hills for generations.$B$BI want nothing more than for peace to return so that we may collect our harvest and reunite with our children.',26124),
(67165,'enUS','Hey buddy! I\'m a little busy at the moment. Talk to me when I\'m done creaming this rookie!','',26124),
(67166,'enUS','','Your attacks are strong, but my defenses are stronger!',26124),
(67167,'enUS','','You need more focus.  Try again!',26124),
(67168,'enUS','Fishing is good for the soul, but crabbing is good for the belly!','',26124),
(67169,'enUS','','Isn\'t it beautiful? Such grace it has, as it dances in the sky. One day, I hope to be as graceful as the crane.',26124),
(67170,'enUS','$n caused Retaliation.','',26124),
(67171,'enUS','Sorry, I\'m a little pre-occupied at the moment. This is my chance to show off for the ladies. Talk to me after I\'ve won this fight!','',26124),
(67172,'enUS','Bowing out so soon? I knew you weren\'t up to the challenge!','',26124),
(67173,'enUS','','Master Kistane is about to get healing from a Jade Serpent Statue.  Use Spear Hand Strike on her and defeat her before she can heal herself again!',26124),
(67174,'enUS','I lost again! I\'d better keep training.','',26124),
(67175,'enUS','I win this time. It seems that you are the one who needs more training.','',26124),
(67176,'enUS','There\'s no running away from a challenge.','',26124),
(67177,'enUS','','May our ancestors protect us from these outsiders and their violent ways.',26124),
(67178,'enUS','What matter of creature are you? So strange...','',26124),
(67179,'enUS','The last newcomers stole our children. What are you here for? Our wives? Our ale?','',26124),
(67180,'enUS','Master Hsu has inflicted you with a deadly poison! Use Detox to remove it.','',26124),
(67181,'enUS','This used to be a peaceful brewing village. Now, the horrors of war have already robbed our children of their innocence.$B$BTake your war elsewhere, $r.','',26124),
(67182,'enUS','','Hey $n, I\'m in the middle of something right now. I need to concentrate!',26124),
(67183,'enUS','','I feel a rush of energy coming on. Let\'s do this!',26124),
(67184,'enUS','','Darnit, I lost! Oof... I feel tired...',26124),
(67185,'enUS','','Running away? I guess I\'m pretty scary after all!',26124),
(67186,'enUS','','Ha! Suchi wins this round.',26124),
(67187,'enUS','','I\'m busying showing this rookie the back of my fist!',26124),
(67188,'enUS','','Let\'s see who is stronger serpent rider.',26124),
(67189,'enUS','','Running away? Come face me again when you have found your courage.',26124),
(67190,'enUS','','What? I... I lost? Auuugh! I\'ll have to work harder to beat you!',26124),
(67191,'enUS','','Just as I expected. You are too weak to defeat me!',26124),
(67192,'enUS','PH - My attention is elsewhere. Please speak to me in a moment.','',26124),
(67193,'enUS','Let us begin. Good luck.','',26124),
(67194,'enUS','It is better to face your challenges, than to run from them.','',26124),
(67195,'enUS','You have bested me fairly. Well done.','',26124),
(67196,'enUS','I win this round. Better luck next time.','',26124),
(67197,'enUS','I\'m hesitant to ask an outsider for help. Still, if you\'re offering...','',26124),
(67198,'enUS','Thank you again for your aid, $n. Our children have returned safe, and your enemies have turned tail.$b$bAs far as I\'m concerned, you and your Horde are always welcome here in Pandaria.','',26124),
(67199,'enUS','Outsiders are rare here. Rarer still are outsiders who arrive on a floating ship of death.','',26124),
(67200,'enUS','Greetings, outsider.$b$b<Zin eyes you warily.>','',26124),
(67201,'enUS','Thanks, $g mister:lady;! That guy smelled.','Thanks, $g mister:lady;! That guy smelled.',26124),
(67202,'enUS','I can leave now?','I can leave now?',26124),
(67203,'enUS','Can... can I go home?','Can... can I go home?',26124),
(67204,'enUS','Using the hammer was fun, but I think I\'m ready to go home now.','Using the hammer was fun, but I think I\'m ready to go home now.',26124),
(67205,'enUS','Get me out of here!','Get me out of here!',26124),
(67206,'enUS','Mama! I\'m coming home, Mama!','Mama! I\'m coming home, Mama!',26124),
(67207,'enUS','I miss my home!','I miss my home!',26124),
(67208,'enUS','Thanks! I don\'t like the Alliance.','Thanks! I don\'t like the Alliance.',26124),
(67209,'enUS','','Look at you, you\'re so skinny! You need to eat more!',26124),
(67210,'enUS','','It is not my decision whether you are to be trusted by my people. Until our mayor decides otherwise, I consider you a friend.',26124),
(67211,'enUS','','Not long ago, we knew nothing but the simple life of brewing fine cider. So much has changed in so little time.',26124),
(67212,'enUS','I am ready to start the Sky Race.','I am ready to start the Sky Race.',26124),
(67213,'enUS','I need another mount for the Sky Race.','I need another mount for the Sky Race.',26124),
(67214,'enUS','','The winds of change can bring anything, from a terrible storm to a bountiful harvest. It seems this time they have brought you.$B$BNow, I wonder, are you a storm or a harvest?',26124),
(67215,'enUS','','Sister, we must act! If we do nothing, we will lose our entire harvest to a war we have no part in!',26124),
(67216,'enUS','','We will do what we can, dear sister. We are not warriors, we cannot simply drive the outsiders away.',26124),
(67217,'enUS','','What of Chut? Why does he continue to train in his dojo? He should be protecting us!',26124),
(67218,'enUS','','Chut will protect us if we are further endangered. He always has.',26124),
(67219,'enUS','','I hope you\'re right. I really do.',26124),
(67220,'enUS','','Welcome to Paw\'don Village, outsider. I do not know why you have come, but you certainly look like you could use a rest.$B$BWhy not sit back with a fine cup of cider and let your worries fall away?',26124),
(67221,'enUS','Why have you come to our village, outsiders?','',26124),
(67222,'enUS','We are here on a rescue mission.','',26124),
(67224,'enUS','They come here for war! Did you not see how they massacred the other outsiders?','',26124),
(67225,'enUS','','You do not understand. The Horde are monsters! We are nothing like them.',26124),
(67226,'enUS','Enough, all of you! You have combated those who stole our children. That is reason enough for me to give you a chance to further prove yourself worthy of our trust.','',26124),
(67227,'enUS','Nevermore!','',26124),
(67228,'enUS','Your control over Kovok weakens as you leave Dread Wastes! Return now!','Your control over Kovok weakens as you leave Dread Wastes! Return now!',26124),
(67229,'enUS','Congratulations!','',26124),
(67230,'enUS','I\'ll drink to that!','',26124),
(67231,'enUS','','I always knew you could do it!',26124),
(67232,'enUS','Someone has come to save us? Perhaps all is not lost...','',26124),
(67233,'enUS','<Your serpent looks at you with a curious expression.>','',26124),
(67234,'enUS','I don\'t know about this \"Alliance\", but you look trustworthy. I\'ll gather everyone up and meet you when we\'re ready to rebuild!','',26124),
(67235,'enUS','<Your serpent smiles at you.>','',26124),
(67236,'enUS','I don\'t know about this \"Horde\", but you look trustworthy. I\'ll gather everyone up and meet you when we\'re ready to rebuild!','',26124),
(67237,'enUS','<Your serpent grunts at you.>','',26124),
(67238,'enUS','<Your serpent watches you.>','',26124),
(67239,'enUS','<Your serpent looks at you with a bored expression.>','',26124),
(67240,'enUS','<Your serpent flies around gracefully.>','',26124),
(67241,'enUS','<Your serpent rubs its scales against your arm.>','',26124),
(67242,'enUS','<Your serpent nudges you, almost knocking you over.>','',26124),
(67243,'enUS','<The hatchling looks at you with a curious expression.>','',26124),
(67244,'enUS','<The hatchling smiles at you.>','',26124),
(67245,'enUS','<The hatchling grunts at you.>','',26124),
(67246,'enUS','<The hatchling watches you.>','',26124),
(67247,'enUS','<The hatchling looks at you with a bored expression.>','',26124),
(67248,'enUS','<The hatchling flies around gracefully.>','',26124),
(67249,'enUS','<The hatchling rubs its scales against your arm.>','',26124),
(67250,'enUS','<The hatchling nudges you, almost knocking you over.>','',26124),
(67251,'enUS','Don\'t you beasts know when to give up?','',26124),
(67252,'enUS','Filthy animals! Keep your stink away from this land!','',26124),
(67253,'enUS','NO... I\'ve let my king down. I... I...','',26124),
(67254,'enUS','Your Horde has no power here.','',26124),
(67256,'enUS','','Don\'t be sour when you lose to me!',26124),
(67257,'enUS','','Don\'t worry. You can cry on my shoulder if you lose.',26124),
(67258,'enUS','','I may look sweet, but I\'m still aiming for first prize!',26124),
(67259,'enUS','','My victory will be sweet.',26124),
(67260,'enUS','','I will be a gracious winner, I promise!',26124),
(67261,'enUS','I have been training hard all week. My hard work will pay off with a victory.','',26124),
(67262,'enUS','Don\'t worry. I will be honorable in victory.','',26124),
(67263,'enUS','I will concentrate on a first place finish.','',26124),
(67264,'enUS','With my winning strategy, I cannot lose.','',26124),
(67265,'enUS','Master Yoon is healing, interrupt him!','',26124),
(67266,'enUS','AAAHHHHH!!','',26124),
(67267,'enUS','Welcome to the Order of the Cloud Serpent. Only those exalted with our Order may acquire our cloud serpents.','',26124),
(67268,'enUS','Welcome, serpent rider! I have beautiful cloud serpents for you to browse at your leisure.','',26124),
(67269,'enUS','','Well done, $n. The cloud serpent that you have raised is now yours. Your journey together... is just beginning.',26124),
(67270,'enUS','Decided to go for a swim, did you?  Well, you\'re still in one piece, so no harm done I suppose.','',26124),
(67271,'enUS','','Just... need a second.',26124),
(67272,'enUS','We must take caution in reacting against the recent events on our shores. Paw\'don is a small brewing town, not a fortress of war.$B$BYou would do well to urge your leaders to take similar caution in their judgment of my people. We do not seek combat, but we will provide it if necessary.$B$BI must meditate on this affair.','',26124),
(67273,'enUS','','My people have faced many trials...but never have we encountered anything like this.',26124),
(67274,'enUS','','Your war has brought unprecedented destruction here. Even the mantid are less of a threat than your flying machines and bombs.',26124),
(67275,'enUS','','I\'ve already alerted the Shado-Pan of what\'s happened here. Hopefully they can do something.$B$BI feel as though we are all woefully unprepared for the coming trials we are to face.',26124),
(67276,'enUS','The hatchling loves you, too!','',26124),
(67277,'enUS','The hatchling nudges your arm affectionately.','',26124),
(67278,'enUS','The hatchling likes being petted!','',26124),
(67279,'enUS','The hatchling thinks you should excuse yourself.','',26124),
(67280,'enUS','The hatchling thinks you are very funny.','',26124),
(67281,'enUS','Rifling the bait','Rifling the bait',26124),
(67282,'enUS','The hatchling is happy to see you!','',26124),
(67283,'enUS','','',26124),
(67284,'enUS','In the sky! It approaches!','',26124),
(67285,'enUS','There it is! Get ready!','',26124),
(67286,'enUS','You may fish here, but please keep it short. I like my privacy.','',26124),
(67287,'enUS','','Good luck, Ace!',26124),
(67288,'enUS','','You can do it, Ace!',26124),
(67289,'enUS','','Eeeee! I love you Ace!',26124),
(67290,'enUS','','I\'ll be cheering for you, Ace!',26124),
(67291,'enUS','','That wasn\'t much of a fight.',26124),
(67292,'enUS','','I knew you could do it, Ace!',26124),
(67293,'enUS','','You\'re the best trainer here!',26124),
(67294,'enUS','','Ace, you\'re the best!',26124),
(67295,'enUS','','Did you see his feet?',26124),
(67296,'enUS','','Go Ace!',26124),
(67299,'enUS','','You are so cool, Ace!',26124),
(67300,'enUS','','Awww, you should have won that one, Ace!',26124),
(67301,'enUS','','Nooo! How could he lose?',26124),
(67302,'enUS','','I still love you, Ace!',26124),
(67303,'enUS','','Rematch!',26124),
(67304,'enUS','','You\'ll win the next one, Ace!',26124),
(67305,'enUS','','You did it, Ace!',26124),
(67306,'enUS','','Beat them to a pulp, Ace!',26124),
(67308,'enUS','','Oooh, look at his muscles!',26124),
(67309,'enUS','','Take off your shirt, Ace!',26124),
(67310,'enUS','','You have plenty of time before the next Sky Race to meditate on what you have learned. On race days, speak to me to enter the competition.',26124),
(67311,'enUS','Master Cheng is burning you alive!  Move!','',26124),
(67312,'enUS','You smelly hozun!','',26124),
(67313,'enUS','Your face is dumb Muno!','',26124),
(67314,'enUS','Eat turnip Muno!','',26124),
(67315,'enUS','No stupid hozun on our farm! Go!','',26124),
(67316,'enUS','You gonna get shovel upside head!','',26124),
(67317,'enUS','You virmen smell like rotten turnip and yak dooker!','',26124),
(67318,'enUS','','I am defeated.',26124),
(67319,'enUS','You have done much today, $n. Rest and return tomorrow.','You have done much today, $n. Rest and return tomorrow.',26124),
(67320,'enUS','You have done much today, $n. Rest and return tomorrow.','You have done much today, $n. Rest and return tomorrow.',26124),
(67321,'enUS','You scared of da creepy crawlies, $r?','',26124),
(67322,'enUS','You have done all you can for the serpents on the island today. Come back tomorrow to resume your training.','You have done all you can for the serpents on the island today. Come back tomorrow to resume your training.',26124),
(67323,'enUS','You have done all you can for the serpents on the island today. Come back tomorrow to resume your training.','You have done all you can for the serpents on the island today. Come back tomorrow to resume your training.',26124),
(67324,'enUS','You have done all that you can for your hatchling today. I will keep it safe, but remember to return tomorrow to check on its progress.','You have done all that you can for your hatchling today. I will keep it safe, but remember to return tomorrow to check on its progress.',26124),
(67326,'enUS','Our fight against the sha can continue tomorrow. For now, rest.','Our fight against the sha can continue tomorrow. For now, rest.',26124),
(67327,'enUS','You\'ve done much work today, $n. We will resume your training tomorrow.','You\'ve done much work today, $n. We will resume your training tomorrow.',26124),
(67328,'enUS','I thought I sensed a disturbance.  I see you have defeated my assistants.  Now you may face me.','',26124),
(67329,'enUS','Well done, $n! You must be tired after participating in the race. Go and get some rest. There will be plenty of tasks waiting for you here tomorrow.','Well done, $n! You must be tired after participating in the race. Go and get some rest. There will be plenty of tasks waiting for you here tomorrow.',26124),
(67330,'enUS','You want some more of Zunta, eh?','',26124),
(67331,'enUS','Ho, $n! That was some big mess you cleaned up! Well, I\'d say you did your \"duty\" for the day. Go and get some rest. Plenty to do here tomorrow!','Ho, $n! That was some big mess you cleaned up! Well, I\'d say you did your \"duty\" for the day. Go and get some rest. Plenty to do here tomorrow!',26124),
(67332,'enUS','Thank goodness you recovered the brew, $n! Since our work is done for the day, I\'d say it\'s time to start drinking!','Thank goodness you recovered the brew, $n! Since our work is done for the day, I\'d say it\'s time to start drinking!',26124),
(67333,'enUS','You are caring for your serpent well, $n. You have done all that you can for today. Make sure you come check on the serpent again tomorrow.','You are caring for your serpent well, $n. You have done all that you can for today. Make sure you come check on the serpent again tomorrow.',26124),
(67334,'enUS','','You will be just another nameless victim of these barren lands.',26124),
(67335,'enUS','Bring it on!','Bring it on!',26124),
(67336,'enUS','Come at me!','Come at me!',26124),
(67337,'enUS','Let\'s do it!','Let\'s do it!',26124),
(67338,'enUS','Prepare yourself!','Prepare yourself!',26124),
(67339,'enUS','','Speak to me when you are ready to race, $n.',26124),
(67340,'enUS','My mantid stuffs! Go away!','',26124),
(67341,'enUS','Look for Audrey Burnhep just outside the city, north of the Dwarven District, near the lakeside cabin.','Look for Audrey Burnhep just outside the city, north of the Dwarven District, near the lakeside cabin.',26124),
(67342,'enUS','Battle Pet Trainer','Battle Pet Trainer',26124),
(67343,'enUS','Look for the orc Varzok atop the city\'s central mesa, just east of the Flight Master.','Look for the orc Varzok atop the city\'s central mesa, just east of the Flight Master.',26124),
(67344,'enUS','','Master Cheng is spinning!  Paralyze her!',26124),
(67345,'enUS','Thanks, Wikky!','Thanks, Wikky!',26124),
(67346,'enUS','Look what Wikky found!','Look what Wikky found!',26124),
(67347,'enUS','','Such is the fate of those who question authority.',26124),
(67348,'enUS','%s goes into a desperate rage!','%s goes into a desperate rage!',26124),
(67349,'enUS','Do you know how to say \'Crackling Jade Lightning\' in Taur-ahe? How about Thalassian? Nazja?','',26124),
(67350,'enUS','I wish to challenge you.','I wish to challenge you.',26124),
(67351,'enUS','Yes, that\'s the stuff! Our cider is prized throughout the Jade Forest. I hope I can carry them all.','',26124),
(67352,'enUS','Pandaria has not seen a full-scale war since the mists closed in. The Shado-Pan usually handle any trouble that crops up on the continent.','',26124),
(67353,'enUS','Oof... I do not know what to make of your kind. Why have you brought your war to our shores? Why do you fight against this... Horde?','',26124),
(67354,'enUS','Mayor Khang is so worried, he called the Shado-Pan to deal with your arrival. I still cannot believe Lord Taran Zhu is here!','',26124),
(67355,'enUS','We do not wish to enter your conflict. But I fear that when war is on the horizon, peace is not a choice.','',26124),
(67356,'enUS','Ah, such troubling thoughts. Our last emperor advised us not to live in the shadow of fear. Do you see now why we love to drink and celebrate?','',26124),
(67357,'enUS','Invaders, all of you! Out!','',26124),
(67358,'enUS','I am no warrior, but I, too, will help defend Paw\'don Village!','',26124),
(67359,'enUS','Begone from here, trespassers!','',26124),
(67360,'enUS','Yeaaaarrrghhh!','',26124),
(67361,'enUS','Get... out... of... my... orchard!','',26124),
(67362,'enUS','We must protect the brew!','',26124),
(67363,'enUS','I may not be a warrior, but I will protect my home and family!','',26124),
(67364,'enUS','Courage, Teng! The Applebloom family cider is at stake!','',26124),
(67365,'enUS','Let us go! The barrels are out in the orchard.','',26124),
(67366,'enUS','It is a very fancy ritual.','',26124),
(67367,'enUS','You would do well to not disrupt this fancy fancy ritual.','',26124),
(67368,'enUS','A Mischievous Snow Sprite emerges from the Suspicious Snow Pile.','',26124),
(67369,'enUS','Stay still and I don\'t think it\'ll attack us!','',26124),
(67370,'enUS','Whatever you do, don\'t look like a carrot!','',26124),
(67371,'enUS','Attack if it tries to cross this bridge!','',26124),
(67372,'enUS','I\'m used to fighting off the small ones...','',26124),
(67373,'enUS','Well look what we have here. Our first keg of recovered brew! I\'ll take this one, folks.','',26124),
(67374,'enUS','I\'ve dabbled in various forms of restorative magic, from the power of the tides to the might of the divine, but my true calling will always be to the grace of the mists.','',26124),
(67375,'enUS','','We will continue to monitor the mogu\'s activity, $n. However, I am afraid that what lies ahead will require greater strength than you currently possess. Return to us when you have gained more experience.',26124),
(67376,'enUS','','I like to offer my competitors something nice to eat. Before I crush them.',26124),
(67377,'enUS','I used to think it was priests that were overpowered. Now I think it\'s rogues.','',26124),
(67378,'enUS','I don\'t like to see fellow monks in pain. But I\'ll get over it.','',26124),
(67379,'enUS','I wish to challenge you.','I wish to challenge you.',26124),
(67380,'enUS','Hight is always going on about the \'sheep tons\' of work we have to do. See if you can get him to say it. It\'s like a drinking game.','',26124),
(67381,'enUS','I wish to challenge you.','I wish to challenge you.',26124),
(67382,'enUS','No, I\'m the other Cheng. No relation. \n\nYes, I am a monk, though I always dreamed of being a demon hunter.','',26124),
(67383,'enUS','I wish to challenge you.','I wish to challenge you.',26124),
(67384,'enUS','I wish to challenge you.','I wish to challenge you.',26124),
(67385,'enUS','I wish to challenge you.','I wish to challenge you.',26124),
(67386,'enUS','Well done.  Remember that swiftness of mind and body can keep you alive.','',26124),
(67387,'enUS','','Your power is impressive.  I admit defeat.',26124),
(67388,'enUS','I am defeated.','',26124),
(67389,'enUS','Your power is impressive.  I admit defeat.','',26124),
(67390,'enUS','Your power is impressive.  I admit defeat.','',26124),
(67391,'enUS','The final wave of hozen ships has come to attack!','',26124),
(67392,'enUS','Once you have defeated them, help your allies collect Jungle Brew for Bo!','',26124),
(67395,'enUS','Surround them! Let none escape!','',26124),
(67396,'enUS','Rip the flesh from their bones!','',26124),
(67397,'enUS','Show them the might of the Trolls!','',26124),
(67398,'enUS','Make their deaths quick! We have much to do!','',26124),
(67399,'enUS','Sinan, may I please have the Wings of Hope again?','Sinan, may I please have the Wings of Hope again?',26124),
(67400,'enUS','','Perhaps we could arrange the sale of some of our remaining goods for your gold? We\'ll need to purchase food and water from other villages now if we\'re to survive.',26124),
(67401,'enUS','','You look as though you have endured much. Please, let me know if there\'s anything you\'d like to purchase to aid you in your travels.',26124),
(67402,'enUS','I\'ll defend my home with my life!','',26124),
(67403,'enUS','My children will not know war if I have anything say about it!','',26124),
(67404,'enUS','Take one step closer and I\'ll...I\'ll...attack! I swear!','',26124),
(67405,'enUS','','We have no quarrel with your people. Would you like to sample our wares?',26124),
(67406,'enUS','','We are known for trade, not war. Would you like to see what I have for sale?',26124),
(67407,'enUS','A stray bomb from the firefight destroyed my farm. How am I supposed to survive like this?','',26124),
(67408,'enUS','Why not regrow your farm somewhere else? I\'m sure the other villagers would help you.','Why not regrow your farm somewhere else? I\'m sure the other villagers would help you.',26124),
(67409,'enUS','There is a bluff south of here that would make a fine farm. It overlooks a gorge. You may be right, stranger.','',26124),
(67410,'enUS','','I grow tired of this village. I wish I could travel and see the world. Maybe when I\'ve saved up enough gold, I\'ll go on my own epic adventure!',26124),
(67411,'enUS','We are not warriors. I produce only tools and light weaponry for hunting.','',26124),
(67412,'enUS','Honeydew Village is ill-prepared for battle. I hope this fighting ends soon!','',26124),
(67413,'enUS','','Oh my...that is an impressive weapon.',26124),
(67414,'enUS','','Care to lay down and rest for a time? Surely that sounds better than fighting.',26124),
(67415,'enUS','','Where did you obtain such exquisite armor? Can I...touch it?',26124),
(67416,'enUS','Food is essential to life. Even a brave $c such as yourself can take the time to sit down and enjoy the essence of life!','',26124),
(67417,'enUS','Many people forget that a fine brew has equal application in cooking as it does for drinking! There\'s nothing in all of Pandaria quite like my famous Honeydew glazed fish!','',26124),
(67418,'enUS','Even in times of great strife like these, food is always needed and appreciated. It makes the hours I spend cooking well worth it.','',26124),
(67419,'enUS','We\'ve got to get the brew to safety. My brews are the lifeblood of this entire town!','',26124),
(67420,'enUS','Clear the roads, the brew runner is coming!','',26124),
(67421,'enUS','Let him through! That strapping young pandaren is saving a keg of Honeybrew!','',26124),
(67422,'enUS','Brew coming through!','',26124),
(67423,'enUS','','It isn\'t ready to fly yet, sister!',26124),
(67424,'enUS','','We don\'t have a choice! We need to alert the other villages of what\'s going on here!',26124),
(67425,'enUS','','Please hurry. I want to get going.',26124),
(67426,'enUS','','Bow to me and we shall begin.',26124),
(67427,'enUS','','Just give me a little more time, I can fix it. I know it.',26124),
(67428,'enUS','','The Skyfire has had a complete overhaul since our encounter with Deathwing! We now carry a full complement of both fixed-wing and gyro aircraft as well as a battery of 18-inch smoothbore shore bombardment cannons.$b$bThe Horde won\'t be able to hide from her reach. Not on land, not at sea, not in the air.',26124),
(67429,'enUS','I am ready to depart.','I am ready to depart.',26124),
(67430,'enUS','Feh! You\'re not welcome here!','',26124),
(67431,'enUS','','A well-timed application of force to a pressure point will stop an opponent in their tracks, regardless of what they are doing.  Use this to your advantage to avoid dangerous attacks.',26124),
(67432,'enUS','Not all problems can be solved with your fists.  Sometimes you must center yourself and channel your energy towards a distant target.','',26124),
(67433,'enUS','Bow to me and we shall begin.','',26124),
(67434,'enUS','As a monk, your reflexes are among your greatest resources.  Often, the ability to think and move quickly can save your life.','',26124),
(67435,'enUS','Sometimes the best defense is to prevent your opponent from acting against you.','',26124),
(67436,'enUS','Some enemies gain most of their power from the weapon that they wield.  Me? I prefer both a large weapon and inflicting deadly poisons on my enemies.','',26124),
(67437,'enUS','','Sometimes a well timed precision strike is all you need to take down even the toughest of foes.',26124),
(67438,'enUS','','Once you have learned to control your own actions, you must learn to control your opponent to gain the upper hand.  An opponent may expose a weakness when trying to heal themselves, allowing you an opportunity to interrupt them.  This can mean the difference between a victory and defeat.',26124),
(67439,'enUS','You are a very intriguing sort, $c. What longing in your heart has brought you to Pandaria? Is it the thirst for adventure? The thrill of battle? Or perhaps something more?','',26124),
(67440,'enUS','These are not the first dark times we have endured. There is always a light at the edge of the shadows.','',26124),
(67441,'enUS','We have not known war here for a very long time. I hope for the good of us all that we may find peace soon.','',26124),
(67442,'enUS','','Bow to me and we shall begin.',26124),
(67443,'enUS','What do we do? We\'re losing everything!','What do we do? We\'re losing everything!',26124),
(67444,'enUS','If we lose our crops we\'ll lose our brew!','If we lose our crops we\'ll lose our brew!',26124),
(67445,'enUS','Please, don\'t bring your battle here. We have no part in it!','Please, don\'t bring your battle here. We have no part in it!',26124),
(67446,'enUS','Fire! Fire!','Fire! Fire!',26124),
(67447,'enUS','My family has guarded this town for generations. I pray that I will be able to uphold their legacy.','',26124),
(67448,'enUS','I would gladly give my life to ensure the safety of Honeydew Village. Its legacy is my own.','',26124),
(67449,'enUS','A monk\'s training never ceases. There is always a higher step to reach with both body and mind.','',26124),
(67450,'enUS','Why do you bring war and bloodshed to our land? Pandaria is a place of peace.','Why do you bring war and bloodshed to our land? Pandaria is a place of peace.',26124),
(67451,'enUS','We may not be warriors by trade, but we will do anything to save our home and our land.','We may not be warriors by trade, but we will do anything to save our home and our land.',26124),
(67452,'enUS','I fear that your arrival here will upset the land\'s delicate balance.','I fear that your arrival here will upset the land\'s delicate balance.',26124),
(67453,'enUS','Gah, this thing\'s a death trap!','',26124),
(67454,'enUS','','Your flying death machine is a sign of the end times.',26124),
(67455,'enUS','','Why do your people hate the other outsiders so? I do not understand it.',26124),
(67456,'enUS','Let\'s see... if I just uncrank the fuel-chugger here...','',26124),
(67457,'enUS','Why have you come here?','',26124),
(67458,'enUS','I\'m pretty sure this \"valve\" is a toenail. Goblins...','',26124),
(67459,'enUS','%s mumbles to himself while tinkering with the shredder.','',26124),
(67460,'enUS','We have known nothing but peace for so long, I don\'t know how anyone is going to handle the arrival of war on our shores.','',26124),
(67461,'enUS','Why do you come here with armaments of war? What goal could you possibly have in your coming here involving war and bloodshed?','',26124),
(67462,'enUS','I\'ve always wondered when outsiders would breach out shores, and so now you have come.','',26124),
(67463,'enUS','Look at this - total amateur hour! Doesn\'t even have a second-stage turbine blade.','',26124),
(67464,'enUS','Yeesh! Me great nan could build a more reliable manifold than this. An\' she has!','',26124),
(67465,'enUS','Wait and see, lads. We\'ll have ourselves a fine killin\' machine in no time.','',26124),
(67466,'enUS','Is that... a cherrywood drive-shaft? Who does that?!','',26124),
(67467,'enUS','Level two grappling is done. Now to tighten up level three...','',26124),
(67468,'enUS','This was a simple town to oversee for my father. We spent some days growing crops, others brewing. Once a year we would travel to other villages to trade. It was a life that we all enjoyed.$B$BNow, the echoes of war bounce all around us, and we must navigate these troublesome times with care. I only hope we may find a resolution quickly.','',26124),
(67469,'enUS','I do not trust you, $r.','',26124),
(67470,'enUS','I have seen many things in my life, but never have I encountered a creature as strange as you.','',26124),
(67471,'enUS','Your people have an interesting practice of arrival to someone\'s home.','',26124),
(67472,'enUS','First you must prove yourself against my assistants.  Defeat them, and then you may face me.','',26124),
(67473,'enUS','','We\'re clear. Let\'s keep moving.',26124),
(67474,'enUS','','This is as close as we can get. See what you can find out!',26124),
(67475,'enUS','I don\'t like how it\'s looking at the pumpkins...','',26124),
(67476,'enUS','It\'s just like an angry rabbit... except bigger... and toothier.','',26124),
(67477,'enUS','I\'m on important business for his majesty.$b$b\"Need to know\" buisness. And you don\'t need to know!','',26124),
(67478,'enUS','','My pets speak to me. They tell me stories late at night.',26124),
(67479,'enUS','','That doesn\'t make any sense. Doublecheck your work.',26124),
(67480,'enUS','','You be feelin\' dis fight for a long time.',26124),
(67481,'enUS','How very strange. I wouldn\'t call these waters enchanted, but there\'s a faint residual energy.','',26124),
(67482,'enUS','It\'s similar to a pattern I once noted in Sholazar Basin.','',26124),
(67483,'enUS','...There\'s definitely something going on here. Before we return, perhaps we should collect some of the enlarged vegetables they grow in this region?','',26124),
(67484,'enUS','FOR THE HORDE!!','FOR THE HORDE!!',26124),
(67485,'enUS','Victory or death!','Victory or death!',26124),
(67486,'enUS','For the warchief!','For the warchief!',26124),
(67487,'enUS','OW!','',26124),
(67488,'enUS','You crazy! Girl, YOU CRAZY!','',26124),
(67489,'enUS','','He is creating a new world for us. He is not... making a salad!',26124),
(67490,'enUS','','You must focus on your training!  Try again!',26124),
(67491,'enUS','Watched you investigating the ship and dealing with those creatures down there. Good work. You find anything?','',26124),
(67492,'enUS','No.','No.',26124),
(67493,'enUS','Are you two going to order anything?','Are you two going to order anything?',26124),
(67494,'enUS','Alliance \"hero.\" Let\'s see how you fight without a flying warship to cover your back!','',26124),
(67495,'enUS','There\'s something about this land - you don\'t understand...','',26124),
(67496,'enUS','They defied us - they defied Hellscream\'s Horde - I should\'ve executed the whole town!','',26124),
(67497,'enUS','Burn, Alliance scum! BURN!','',26124),
(67498,'enUS','This land will be your grave.','',26124),
(67499,'enUS','No! Smash! I said smash!','',26124),
(67500,'enUS','You are my favorite teacher ever!','You are my favorite teacher ever!',26124),
(67501,'enUS','What brews do you have available?','What brews do you have available?',26124),
(67502,'enUS','Greetings, $n.  I have a fine selection of brews available for you.  If you are interested, I can also teach you to make your own.','',26124),
(67503,'enUS','','Admiral! It\'s good to see that you are okay.',26124),
(67504,'enUS','','I\'m afraid you\'ll have to push forward without us.',26124),
(67505,'enUS','','I\'ve been ordered back to the main battlegroup to provide carrier escort. The full might of the Alliance navy will arrive in two months\' time.',26124),
(67506,'enUS','','Put on your big-boy pants, Taylor. I will leave the SI:7 officers with you. I suggest a scouting mission.',26124),
(67507,'enUS','','Maybe you can recruit some of the locals. I\'ll leave the situation here in your capable hands.',26124),
(67508,'enUS','Thank you, Catherine. It\'s good that you\'re here: With full carrier support we can push north-','',26124),
(67509,'enUS','What?','',26124),
(67510,'enUS','What am I supposed to do until then? I\'ve got no men! We don\'t know where the Horde are, or how many we\'re dealing with!','',26124),
(67511,'enUS','Yes, Admiral.','',26124),
(67512,'enUS','Godspeed.','',26124),
(67513,'enUS','\"Improvise.\" Humph.','',26124),
(67514,'enUS','Nightwind! Take your men and scout the interior. Look for a Horde presence. And find Prince Anduin!','',26124),
(67515,'enUS','Stupid snake. I said shoot fire!','',26124),
(67516,'enUS','','This land has endured much, and yet it thrives in the wake of the worldbreaker. You will find that my pets possess similar fortitude.',26124),
(67517,'enUS','Prepare yourself, $n.$b$bWe\'ll be entering a target-rich environment!','',26124),
(67518,'enUS','I\'m ready to go, General.','I\'m ready to go, General.',26124),
(67519,'enUS','Ow.  That really hurts.  Not.','Ow.  That really hurts.  Not.',26124),
(67520,'enUS','Oooh.  Mr. Big Mean Mogu.  I\'m so scared.','Oooh.  Mr. Big Mean Mogu.  I\'m so scared.',26124),
(67521,'enUS','Bring it on, jerk.','Bring it on, jerk.',26124),
(67522,'enUS','You want a piece of me?','You want a piece of me?',26124),
(67523,'enUS','','Thank the Light you\'re here, $n.  Something has gone horribly wrong and our leader is killing everyone!',26124),
(67524,'enUS','','Please hurry!  I must stay and tend to the wounded.',26124),
(67526,'enUS','','Many thanks! $B$BThe local earth spirit, Hui, is angry that we hired adventurers to drive off his mischievous sprites. $B$BI can understand he\'s upset, but this attack is simply going too far!',26124),
(67527,'enUS','','Many thanks!',26124),
(67528,'enUS','','The local earth spirit, Hui, is angry that we hired adventurers to drive off his mischievous sprites.',26124),
(67529,'enUS','','I can understand he\'s upset, but this attack is simply going too far!',26124),
(67530,'enUS','That\'s all you got?','That\'s all you got?',26124),
(67531,'enUS','That doesn\'t even tickle.','That doesn\'t even tickle.',26124),
(67532,'enUS','You\'re not very good at this torture thing.','You\'re not very good at this torture thing.',26124),
(67533,'enUS','Is that supposed to hurt?','Is that supposed to hurt?',26124),
(67534,'enUS','*Yawn*','*Yawn*',26124),
(67535,'enUS','Sometimes these goons make it too easy.','',26124),
(67536,'enUS','This is not what he was expecting at all.','',26124),
(67537,'enUS','Get ready to die, $r.','',26124),
(67538,'enUS','I\'ll put a bolt through that thick skull of yours!','',26124),
(67539,'enUS','Yes, that\'s it... stand right there...','',26124),
(67540,'enUS','Don\'t move, $r!','',26124),
(67541,'enUS','Hold still, beast!','',26124),
(67542,'enUS','Finally... something worth fighting.','',26124),
(67543,'enUS','','Let\'s keep moving.',26124),
(67544,'enUS','Get me OUT OF HERE!','Get me OUT OF HERE!',26124),
(67545,'enUS','I... I thought I\'d be here forever...','I... I thought I\'d be here forever...',26124),
(67546,'enUS','Can... can I go home?','Can... can I go home?',26124),
(67547,'enUS','I thought those eyes would NEVER leave me alone!','I thought those eyes would NEVER leave me alone!',26124),
(67548,'enUS','I know the way home. Thanks, $gmister:lady;!','I know the way home. Thanks, $gmister:lady;!',26124),
(67549,'enUS','Papa! I\'m coming home, Papa!','Mama! I\'m coming home, Mama!',26124),
(67550,'enUS','I miss my family. I miss my home!','I miss my family. I miss my home!',26124),
(67551,'enUS','Thanks! I don\'t like the Horde.','Thanks! I don\'t like the Horde.',26124),
(67552,'enUS','Horde invaders! Men, to arms!','Horde invaders! Men, to arms!',26124),
(67553,'enUS','Victory to the Alliance!','Victory to the Alliance!',26124),
(67554,'enUS','Pandaria will be ours, mongrel!','Pandaria will be ours, mongrel!',26124),
(67555,'enUS','Keep your filthy hide out of our base!','Keep your filthy hide out of our base!',26124),
(67556,'enUS','Death to the Horde!','Death to the Horde!',26124),
(67557,'enUS','Die, Horde scum!','Die, Horde scum!',26124),
(67558,'enUS','Hey!','Hey!',26124),
(67559,'enUS','I thought I smelled something...','I thought I smelled something...',26124),
(67560,'enUS','You won\'t escape alive, $r!','You won\'t escape alive, $r!',26124),
(67561,'enUS','For the Horde!','For the Horde!',26124),
(67562,'enUS','Pandaria will be ours!','Pandaria will be ours!',26124),
(67563,'enUS','Finally, an enemy worth fighting.','Finally, an enemy worth fighting.',26124),
(67564,'enUS','Death to the Alliance!','Death to the Alliance!',26124),
(67565,'enUS','I\'m going to enjoy this...','I\'m going to enjoy this...',26124),
(67566,'enUS','For Hellscream!','For Hellscream!',26124),
(67567,'enUS','Puny $r...','Puny $r...',26124),
(67568,'enUS','','%s examines the waters of the Vale closely.',26124),
(67569,'enUS','You look delicious...','You look delicious...',26124),
(67570,'enUS','For the glory of the Dark Lady!','For the glory of the Dark Lady!',26124),
(67571,'enUS','You\'ll make a fine corpse, $c.','You\'ll make a fine corpse, $c.',26124),
(67572,'enUS','Greetins $n.  You want to learn the art of workin with leather?  I also got a fine selection of crafted goods if that\'s whatcha need.','',26124),
(67573,'enUS','Let me browse your wares.','Let me browse your wares.',26124),
(67574,'enUS','Hellscream\'s armies will paint this land red!','',26124),
(67575,'enUS','Greetings $n.  Are you interested in the mystical art of Inscription, or perhaps the intricacies of Herbalism?','',26124),
(67576,'enUS','','I do not fear you, $r. You would be wise to fear me...',26124),
(67577,'enUS','I\'ve spent enough time with clumsy XX here that I\'ve picked up a thing or two about treating injuries.  Perhaps I can pass some of that along to you?','',26124),
(67578,'enUS','No hozen num nums for you!','',26124),
(67579,'enUS','Steal jab-jab from wikket!','',26124),
(67580,'enUS','Kill the wikket!','',26124),
(67581,'enUS','Do you think the pandaren realized what they were sitting on here?','',26124),
(67582,'enUS','Maybe they\'ve known all along. Maybe that\'s why they\'ve stayed hidden.','',26124),
(67583,'enUS','','Just gather what we need and let him figure it out. Are you ready? Let\'s move.',26124),
(67584,'enUS','Wrathion\'s agents whisper quietly to one another.','',26124),
(67585,'enUS','The horrors I witnessed...','The horrors I witnessed...',26124),
(67586,'enUS','Never again.','Never again.',26124),
(67587,'enUS','The %s smirks at $n.','',26124),
(67588,'enUS','I will make these beasts pay...','I will make these beasts pay...',26124),
(67589,'enUS','I owe you greatly, friend.','I owe you greatly, friend.',26124),
(67590,'enUS','','What are you waiting for?  The initiates need your help!',26124),
(67591,'enUS','No, I don\'t know what\'s inside, either.','',26124),
(67592,'enUS','By our sweat and your blood, this land WILL be ours!','',26124),
(67593,'enUS','A warlock! He couldn\'t have ported far - there must be another base.','',26124),
(67594,'enUS','What came over me?','',26124),
(67595,'enUS','You are carrying too much brew. Return to the Brewing Cauldron to turn in what you have.','You are carrying too much brew. Return to the Brewing Cauldron to turn in what you have.',26124),
(67596,'enUS','OW! Not again.','',26124),
(67597,'enUS','You should really be more careful...','',26124),
(67598,'enUS','Let me see if I can fix you up...','',26124),
(67599,'enUS','Thanks!','',26124),
(67600,'enUS','Whoa, I think I\'ve got a big one...','',26124),
(67601,'enUS','Ouch!  I guess that one was a little bigger than I thought...','',26124),
(67602,'enUS','Do you have a few moments to spare?','',26124),
(67603,'enUS','I\'m ready for that drink now.','I\'m ready for that drink now.',26124),
(67604,'enUS','I accompany the Shado-Pan to chronicle their many deeds beyond the wall. It is not easy - I do not wish to lose any of my journals in the chaos of battle!$b$bIt has happened before. The Lorewalkers have been cataloging pandaren history for many ages. Their notes are scattered throughout Pandaria. I am certain that if you were to assemble them, the Lorewalkers would be most appreciative!','',26124),
(67605,'enUS','Wow, that was a big one, that loooked like it hurt!','',26124),
(67606,'enUS','The roads of Kun-Lai are cold, dangerous, and unforgiving. But there is little satisfaction - or profit! - for deals easily concluded.','',26124),
(67608,'enUS','','Wings give us the freedom to soar.',26124),
(67609,'enUS','','Who ever said machines aren\'t natural? My pets are at least 50% natural!',26124),
(67610,'enUS','I\'m concentrating... can you bother someone else?','',26124),
(67611,'enUS','Can ya believe Onyxia just left these sitting around in her egg pit? I\'m going to make a fortune!','',26124),
(67612,'enUS','You haven\'t had a real adventure until you\'ve skipped through Onyxia\'s whelp pits!','',26124),
(67613,'enUS','The marsh out here smells almost as bad as Onyxia\'s breath!','',26124),
(67614,'enUS','I\'m going to beat you very, very slowly.','',26124),
(67615,'enUS','The Master shall rain hellfire upon Azeroth, and then we will at last cleanse the Light from this wretched world!','',26124),
(67616,'enUS','All of you must work to aid in the great revival of our Master. Only through Him may we usher in eternal peace for all!','',26124),
(67617,'enUS','Our Master, protector of all life, will soon blind all of the heretics and grants us immeasurable power!','',26124),
(67618,'enUS','Are you ready to accept the Master\'s gift? Will you be blessed by his loving wrath, or consumed by it like all of the others?','',26124),
(67619,'enUS','Sargeras will live once more!','',26124),
(67620,'enUS','Demons are the future of this world. The sooner you embrace that, the sooner you join the winning team.','',26124),
(67621,'enUS','Kalimdor belongs to the Grimtotem. Nobody can stand in our way.$B$BWe are supreme in all things, as you will now see as I crush your pathetic team.','',26124),
(67622,'enUS','','I see you\'re a battle pet trainer, $r. How about you test your skills against the might of a Grimtotem?',26124),
(67623,'enUS','','My snakes are pretty right? ...RIGHT?',26124),
(67624,'enUS','','You never stood a chance against me and my lovely snakes!',26124),
(67625,'enUS','','No way! I will get you next time!',26124),
(67626,'enUS','','Try this guy on for size!',26124),
(67627,'enUS','','Take that!',26124),
(67628,'enUS','','Nooooo! My precious snakes!',26124),
(67630,'enUS','I am defeated.','I am defeated.',26124),
(67631,'enUS','','I\'m going to knock you out cold!',26124),
(67632,'enUS','','I told you, sugar. You aren\'t hot enough to handle me!',26124),
(67633,'enUS','','Ouch! I just got burned!',26124),
(67634,'enUS','','Take a break and chill, sweetie. You\'ll get your turn again soon.',26124),
(67635,'enUS','','We\'re snowballing out of control! You don\'t stand a chance now!',26124),
(67636,'enUS','','Shattered!',26124),
(67637,'enUS','','You handle the cold better than I thought.',26124),
(67638,'enUS','','Your pet is a cold, ruthless killer!',26124),
(67639,'enUS','','I won\'t let you get away with that!',26124),
(67640,'enUS','','You aren\'t hot enough to handle me!',26124),
(67641,'enUS','','How you doin\', sugar?',26124),
(67642,'enUS','<Chi-Ji\'s voice fills your mind.>$b$bDo you need help getting to the top of the pedestal, $n?','',26124),
(67643,'enUS','Yes, please, Chi-Ji.','Yes, please, Chi-Ji.',26124),
(67644,'enUS','To the skies!','',26124),
(67645,'enUS','<You can hear Chi-Ji\'s voice echoing in your mind.>$b$bI sense that you need my help to get to the top of the dome.','',26124),
(67646,'enUS','I do, Chi-Ji.','I do, Chi-Ji.',26124),
(67647,'enUS','<You hear Chi-Ji speaking in your mind.>$b$bLet me assist you to get to the top of the pavilion, my friend.','',26124),
(67648,'enUS','I would like that very much, Chi-Ji.','I would like that very much, Chi-Ji.',26124),
(67649,'enUS','A Warbringer approaches! Fall back!','',26124),
(67650,'enUS','I am studying the life of this area for...research purposes.','',26124),
(67651,'enUS','Give \'em hell for us, $n! Whatever those things are...','Give \'em hell for us, $n! Whatever those things are...',26124),
(67652,'enUS','','Life is but a path to undeath. My pets understand that.',26124),
(67653,'enUS','You don\'t stand a chance!','You don\'t stand a chance!',26124),
(67654,'enUS','Ah, dragon rearing.$B$BOnce these beauties grow up, my fool brother will have nothing on me!','',26124),
(67655,'enUS','I told you lads to trust ol\' Sully! Ha haaaa!','',26124),
(67656,'enUS','Suck it down, freaks!!','',26124),
(67657,'enUS','Yech! What are these things?!','',26124),
(67658,'enUS','Feh, get off me new ride!','',26124),
(67659,'enUS','Let\'s see what this lever does... oh, right! IT CARVES YOU A NEW ARSE!','',26124),
(67660,'enUS','I even had time to install an I.W.I.N. Button!','',26124),
(67661,'enUS','Good work in there, $n! Get on to the village over the bridge. I\'m covering extraction for the marines.','',26124),
(67662,'enUS','I kinda like this thing. What ye think, lads? Can we keep it?','',26124),
(67663,'enUS','We just couldn\'t do it the quiet way!','',26124),
(67664,'enUS','...you\'re nothing but farmer\'s children.','',26124),
(67665,'enUS','You have done much and more for us today, $n. Our work will continue, but we have gained a small victory.','',26124),
(67666,'enUS','Thank you, $r! I feel the tide of battle turning in our favor. You have gained us a moment\'s respite, $n.','',26124),
(67667,'enUS','','Do not fear, Tai-Feng. Yu\'lon is strong. She will break free of the sha\'s corruption, I know it.',26124),
(67668,'enUS','','It matters not how the sha broke free of their ancient prisons. We must plan a course of action forward. How can we dispel them again from our land?',26124),
(67669,'enUS','','Even as we speak, Taran Zhu and the Shado-Pan march west. When they find the sha, justice will be done.',26124),
(67670,'enUS','','The guardians of the temple are few, but their spirits remain strong. I believe we can defeat the sha and expel them from our temple, but it will be a long and difficult battle.',26124),
(67671,'enUS','','Many great conflicts have occurred in these swamps. I can still feel the lingering energy.',26124),
(67672,'enUS','','Our battle is most difficult, Tai-Feng. The sha of doubt is subtle and insidious. Once the dark seed of doubt is planted, only one of strong mind and heart can remove it.',26124),
(67673,'enUS','','The defenders of the temple are hold strong on the ground, while the Order of the Cloud Serpent fights from above. Working together, we will dispel the sha from our home.',26124),
(67674,'enUS','Can I go out and fight the sha, too?','',26124),
(67675,'enUS','','Don\'t be stupid! The sha are dangerous!',26124),
(67676,'enUS','I\'m scared!','',26124),
(67677,'enUS','','Are the sha going to come in here?',26124),
(67678,'enUS','','Now, now. Don\'t be scared. Brave heroes are fighting the sha right now. And as long as I\'m here, nothing will hurt you.',26124),
(67679,'enUS','','Most people hate swamps, but I know that they hold great secrets just beneath the murky surface.',26124),
(67680,'enUS','Spend a few years of yer life with Sulfuras over yer head, and you\'ll learn tae appreciate the lava beetle\'s resilience.','',26124),
(67681,'enUS','','You will only find defeat here.',26124),
(67682,'enUS','','You have no chance of defeating my team. I am eternal!',26124),
(67683,'enUS','Korven, let\'s continue.','Korven, let\'s continue.',26124),
(67684,'enUS','|TInterface\\Icons\\ability_warrior_shieldmastery.blp:20|t%s casts |cFFFF0000|Hspell:117961|h[Impervious Shield]|h|r!','',26124),
(67685,'enUS','','If these miniatures are built anything like their originals, you don\'t stand a chance!',26124),
(67686,'enUS','I want to travel the world someday. Have you ever seen Stormwind?','',26124),
(67687,'enUS','The winds of Outland speak of calm and peace.','',26124),
(67688,'enUS','','Target acquired. Light it up.',26124),
(67689,'enUS','We must work together to preserve what nativel life remains in Nagrand.','',26124),
(67690,'enUS','','Burn it to the ground!',26124),
(67691,'enUS','','Roger that. Give \'em the business.',26124),
(67692,'enUS','Do you mind?','',26124),
(67693,'enUS','','We read you. Comin\' in hot.',26124),
(67694,'enUS','','Carrier has arrived.',26124),
(67695,'enUS','Blood Elves are the masters of the universe. There is no questioning it.','',26124),
(67696,'enUS','How about a deal? If I win, you give me ten thousand gold?','',26124),
(67697,'enUS','13 gyromantic destabilizers? Check. 10 gnumatic flangegrips? Check. Now where did I put my favorite wrench?','',26124),
(67698,'enUS','Hmm. Only 2 tons of explosives for this mission? Seems a bit light to me. This seems like the kind of mission we are going to need way more explosives for. Like... goblin pyromaniac explosives.','',26124),
(67699,'enUS','Only thirty gyrocopters? We are going to need way more than that before this is over.','',26124),
(67700,'enUS','I don\'t care how short you are or how proportionally large and heavy these crates are, get them below decks.','',26124),
(67701,'enUS','CLUCK!','',26124),
(67702,'enUS','Mayor Khang, we must act quickly! Rally the city guards, at least!','',26124),
(67703,'enUS','Just a moment, Teng. We have... a visitor.','',26124),
(67704,'enUS','Excellent work! We\'ve secured the rest of the base.','',26124),
(67705,'enUS','King\'s mercy - what happened here? What WAS that thing?','',26124),
(67706,'enUS','Your foe was overwhelmed by a dark energy we call the\"Sha.\" It thrives on negative emotions, such as doubt.','',26124),
(67707,'enUS','I am not surprised. The Horde are monsters!','',26124),
(67708,'enUS','I have seen your sky-fortress. Your people have an interesting notion of \"peace.\"','',26124),
(67709,'enUS','Left to their own devices, the Horde will overwhelm your land. Will you not help us fight them?','',26124),
(67710,'enUS','We are not afraid to fight. Our warriors, while few in number, are extremely skilled.','',26124),
(67711,'enUS','','Thank you for your hospitality, Mayor. I assure you: you\'re doing the right thing.',26124),
(67712,'enUS','You may give these soldiers quarter at your discretion, but we are not choosing sides.','',26124),
(67713,'enUS','This conflict is little more than a race-war. Their hatreds would engulf this land - we will have no part in this!','',26124),
(67714,'enUS','I must go - there are others who have landed on our northern shores.','',26124),
(67715,'enUS','','Coming through!',26124),
(67716,'enUS','','There, by the fountain! Set them down gently now.',26124),
(67717,'enUS','','Daniel, that patient is in shock. Stay with him and monitor his heart rate, let me know if anything changes.',26124),
(67718,'enUS','Understood.','',26124),
(67719,'enUS','','Stanton, keep some ice on that man\'s head. We need to get the swelling down.',26124),
(67720,'enUS','','On it.',26124),
(67721,'enUS','What are we going to do about the glade?','',26124),
(67722,'enUS','The guards are needed here. If you seek vengeance at the glade, Teng, I suggest you speak with our guest here.','',26124),
(67723,'enUS','Grow giant carrots, they said. It\'ll be fun, they said.','',26124),
(67724,'enUS','Carrots this big just ain\'t practical.','',26124),
(67725,'enUS','Bah, another splinter from my hoe!','',26124),
(67726,'enUS','It doesn\'t even feel like I\'m making any progress...','',26124),
(67727,'enUS','Why would we ever need carrots this big?','',26124),
(67728,'enUS','','Nightwind, report! What\'s going on down there?',26124),
(67729,'enUS','','Horde troops are swimming toward your position. Open fire at once.',26124),
(67730,'enUS','','You don\'t think they\'ll hesitate to strangle you with their bare hands? GUN THEM DOWN!',26124),
(67731,'enUS','','This devastation could have been avoided, $c. There was a time when Theramore was a symbol of peace...',26124),
(67732,'enUS','Show me Theramore before the destruction.','Show me Theramore before the destruction.',26124),
(67733,'enUS','No sign of the flagship, and no sign of Admiral Taylor or Prince Anduin.','',26124),
(67734,'enUS','Admiral - I think they mean to surrender. They\'re not armed - They\'re just trying not to drown!','',26124),
(67735,'enUS','That\'s not right... this is a massacre... they were unarmed - ugh! I don\'t... I don\'t feel well...','',26124),
(67736,'enUS','Maybe they deserved to die.','',26124),
(67737,'enUS','','Such a waste...',26124),
(67738,'enUS','','Some decisions have dire consequences.',26124),
(67739,'enUS','You beasts! What sort of madness is this?','',26124),
(67740,'enUS','Men, stand down - this is one of the natives.','',26124),
(67741,'enUS','We are from the Alliance, and mean you no harm. Tell me, what was that shadow you drew out of me?','',26124),
(67742,'enUS','This is not the place to explain. In short, your own doubts have been made manifest, as a consequence of your actions.','',26124),
(67743,'enUS','You don\'t understand - we\'re fighting a war here-','',26124),
(67744,'enUS','Oh, I understand perfectly. I have eyes. But Pandaria is not like whatever land you came from; it lives and breathes. You should be careful what kind of energy you bring here. Now put those weapons away!','',26124),
(67745,'enUS','I seem to have misplaced Dog\'s Whistle.','I seem to have misplaced Dog\'s Whistle.',26124),
(67746,'enUS','You seem willing to clean up your mess, outsider. Maybe we can help each other.','',26124),
(67747,'enUS','BEHOLD MY POWER!','',26124),
(67748,'enUS','Apothecary, may I have some more of your Dit Da Jow?','Apothecary, may I have some more of your Dit Da Jow?',26124),
(67749,'enUS','Caw!','Caw!',26124),
(67750,'enUS','Their leader is still in hiding. Find him!','',26124),
(67751,'enUS','You finished him - well done!','',26124),
(67752,'enUS','What is this... shadow? What is the Alliance playing at?','',26124),
(67753,'enUS','Your foe was overwhelmed by a dark energy we call the\"Sha.\" It thrives on negative emotions, such as doubt.','',26124),
(67754,'enUS','You again. Do you see it now? Alliance arrogance!','',26124),
(67755,'enUS','My people have stood tall without you for thousands of years.','',26124),
(67756,'enUS','Are you afraid to fight?','',26124),
(67757,'enUS','We are not afraid to fight. Our warriors, while few in number, are extremely skilled.','',26124),
(67758,'enUS','This is a hostile land, and we have no reinforcements. We\'re going to have to improvise, champion.','',26124),
(67759,'enUS','But our orders stand - Hellscream will have his foothold here. We will NOT allow the Alliance to lay claim to this new world!','',26124),
(67760,'enUS','I haven\'t earned my wings yet, but neither have my pets!','',26124),
(67761,'enUS','It\'s unsafe to wander through the forest alone, don\'t you think?','',26124),
(67762,'enUS','Ribbit','Ribbit',26124),
(67763,'enUS','Do not let others fool you. Dragons are weapons of war; nothing more.','',26124),
(67764,'enUS','Those Alliance scum will learn what it is to anger the Horde!','',26124),
(67765,'enUS','We will claim this land in the name of the Horde, or die trying!','',26124),
(67766,'enUS','They have not even begun to see the fury of the Horde!','',26124),
(67767,'enUS','By the time we are done here, the Alliance will wish they had never set foot on this land.','',26124),
(67768,'enUS','For the Horde!','',26124),
(67769,'enUS','Clever tricks, but do you really assume I only have one set of weapons to fight you with? I have been waiting for a worthy opponent to use my poison coated swords against.','',26124),
(67770,'enUS','Me find these crawling inside me.','',26124),
(67771,'enUS','We will attack from the opposite side, $c. The alliance won\'t expect a ground assault this quickly. Find me when the slaughter is over.','',26124),
(67772,'enUS','C\'mon, you guys. We can do this. Fly!','',26124),
(67773,'enUS','One day I\'m going to explore the whole world, and my pets are coming with me!','',26124),
(67774,'enUS','One approaches Morulu...','',26124),
(67775,'enUS','Hang in there, bud. You\'re going to be okay.','',26124),
(67776,'enUS','His pulse is stable, Mishka. But it\'s weak.','',26124),
(67777,'enUS','','These bandages are filthy. Let\'s get you cleaned up.',26124),
(67778,'enUS','We need to do right by these people if we want a chance at understanding this land.','',26124),
(67779,'enUS','Mishka\'s gonna take good care of you, you hear me?','',26124),
(67780,'enUS','The next ten orcs I kill are gonna be for you, friend.','',26124),
(67781,'enUS','Your actions will have grave consequences if you do not move from your path of war.','',26124),
(67782,'enUS','Every action creates a reaction. Do you see what your actions have created?','',26124),
(67783,'enUS','I fear that this is just the beginning.','',26124),
(67784,'enUS','Are you so blind that you would continue this war?','',26124),
(67785,'enUS','All the brew... gone...','',26124),
(67786,'enUS','Cool stuff will happen here! Explosions!','',26124),
(67787,'enUS','You\'re on!','You\'re on!',26124),
(67788,'enUS','I will fight with honor and valor for the glory of the Alliance!','',26124),
(67789,'enUS','Bask in the glory of the Alliance, $r. Know today that you stand no chance of defeating me!','',26124),
(67790,'enUS','You have pets, too. We fight?','',26124),
(67791,'enUS','Collecting Honeybrew Barrel','',26124),
(67792,'enUS','','Well isn\'t this just a fine mess?',26124),
(67793,'enUS','The Horde is in need of your assistance.','The Horde is in need of your assistance.',26124),
(67794,'enUS','','My assistance?! You want my assistance?! I will not be part of your petty fighting.',26124),
(67795,'enUS','','You want my help? I\'m a little busy trying to restore the peace that you disrupted.',26124),
(67796,'enUS','','All I wanted to do today was harvest my crops. Instead, I\'m wrangling prowlers!',26124),
(67797,'enUS','','My sister and I haven\'t seen this much activity in Honeydew since, well ever!',26124),
(67798,'enUS','','Your airship just about took out our balloon!',26124),
(67799,'enUS','','We are not interested in your war, outsider. This is a peaceful village.',26124),
(67800,'enUS','','Well it was peaceful until you arrived.',26124),
(67801,'enUS','','We will not be caught in the middle of your war for any longer than we can help it. You may stay here and tend to your wounded, but that is the end of our involvment.',26124),
(67802,'enUS','','The temple must not fall!',26124),
(67803,'enUS','It is said that \"Wisdom lights the path.\"$b$b...But wisdom never kept me from stubbing my toe at night.','',26124),
(67804,'enUS','He was weak, but I am stronger!','',26124),
(67805,'enUS','He was but a trainee.  The will of a master is stronger!','',26124),
(67806,'enUS','Well done, you are one step closer to the real challenge.','',26124),
(67807,'enUS','Strike them down, and I become more powerful than you can ever imagine.','',26124),
(67808,'enUS','Hello, $n, would you like to learn how to acquire and work with the various metals found around our land?','',26124),
(67809,'enUS','Get those ropes tied down, team! We need this drake secured immediately.','',26124),
(67810,'enUS','Work harder you lazy mongrels, or I\'ll roast you alive!','',26124),
(67811,'enUS','Break any of these supplies, and I\'ll break your skull!','',26124),
(67812,'enUS','Guard these supplies with your lives, you filthy mutts!','',26124),
(67813,'enUS','Keep your flea ridden paws out of the food, you mangy beasts!','',26124),
(67814,'enUS','Watch these mercenaries closely, brothers!','',26124),
(67815,'enUS','The gong peals a taunting note to the mantid armies below, accelerating the pace of their assault.','',26124),
(67816,'enUS','Your training is complete for today.  Return tomorrow and we will continue.','',26124),
(67817,'enUS','But we will not participate in this... genocidal... bloodbath of yours.','',26124),
(67818,'enUS','Your conflict will have immense consequences here. Do NOT bring your war to these shores!','',26124),
(67819,'enUS','But we will not participate in this... race war... bloodbath of yours.','',26124),
(67820,'enUS','Your conflict will have immense consequences here. Do NOT bring your war to these shores!','',26124),
(67821,'enUS','Hidden power lies here, and we must reveal it!','',26124),
(67822,'enUS','I can feel them, the spirits of long dead Mogu!','',26124),
(67823,'enUS','Keep these ruins secure at all costs!','',26124),
(67824,'enUS','Leave no stone unturned in our search!','',26124),
(67825,'enUS','Do not falter! We will soon unite with our ancient mogu allies!','',26124),
(67826,'enUS','First packet of seeds is on the house! Come back to me anytime you want to buy more seeds, ya hear?','',26124),
(67827,'enUS','Just remember, real crops will take a day to grow, so after you\'ve tilled and cared for your plants, come back the next day to harvest your bounty!','',26124),
(67828,'enUS','Well partner, looks like you\'re ready to work this farm on your own. Come back every day to plant and harvest vegetables if you like. If we work hard, we might even be able to upgrade this place!','',26124),
(67829,'enUS','Well partner, I got some bad news for you. You can come back every day to plant and harvest your vegetables, but you\'ll need more experience before helping me join the Tillers Union. But don\'t forget - you\'re welcome here on the farm any time!','',26124),
(67830,'enUS','','We must do everything we can to protect the shrines and temples of my people.',26124),
(67831,'enUS','Mo\'ruk gonna beat ya!','',26124),
(67832,'enUS','','This year\'s harvest yielded more than just crops!',26124),
(67833,'enUS','I have spent countless hours preparing for this battle.','',26124),
(67834,'enUS','Braving these wastes has made my pets undefeatable.','',26124),
(67835,'enUS','','It is within the most sacred realm of Pandaria that you will now face your most difficult challenge.',26124),
(67836,'enUS','You\'re going down!','You\'re going down!',26124),
(67837,'enUS','Who holds this swarm? Show yourself! Answer to the Klaxxi.','',26124),
(67838,'enUS','Treasonous Klaxxi... her magnificence was right about you.','',26124),
(67839,'enUS','Speak your name puppet, that our annals will be complete.','',26124),
(67840,'enUS','Grand Vizier Zor\'lok, voice of the Empress.','',26124),
(67841,'enUS','Your \"Empress\" has fallen. The Klaxxi have pronounced judgment. Stand aside or be brushed away.','',26124),
(67842,'enUS','The Klaxxi are to be disbanded, by the will of the Empress.','',26124),
(67843,'enUS','Blaspheme!','',26124),
(67844,'enUS','The desperate Klaxxi have resorted to digging up fossils. Very well: let us finish this.','',26124),
(67845,'enUS','Kl-kl-kl-kl-klagh!','',26124),
(67846,'enUS','\"Unscathed,\" indeed.','',26124),
(67847,'enUS','Forward! The Klaxxi reveal themselves as traitors. Decimate them, and leave nothing behind.','',26124),
(67848,'enUS','Wakener, your deeds have earned you the trust of the Klaxxi.','',26124),
(67849,'enUS','You are to be rewarded. Walk with me.','',26124),
(67850,'enUS','We mantid are an elder race. The pandaren you associate with - they are but children. They have their role to play.','',26124),
(67851,'enUS','Each cycle, our young swarm their walls. The pandaren slay the weak. The strong return.','',26124),
(67852,'enUS','With each generation, we grow ever stronger.','',26124),
(67853,'enUS','Before your history began, our empire was vast. We shared this world with our sister kingdoms, Ahn\'Qiraj and Azjol-Nerub.','',26124),
(67854,'enUS','Our Gods were many, and powerful. We mantid worshipped the seven heads of Y\'shaarj.','',26124),
(67855,'enUS','Great was the Old One, and terrible was His wrath. He consumed hope and begat despair; He inhaled courage and breathed fear.','',26124),
(67856,'enUS','When the usurpers came - the ones you call \"Titans\" - Y\'shaarj was destroyed.','',26124),
(67857,'enUS','His last terrible breath has haunted this land ever since, but the shadows he left behind are mere whispers of his former glory.','',26124),
(67858,'enUS','I tell you now, because you have earned this warning.','',26124),
(67859,'enUS','Your gods are not our gods, outsider.','',26124),
(67860,'enUS','If the Old Ones ever return, we mantid will once again stand by their side.','',26124),
(67861,'enUS','The wisest among you will do the same.','',26124),
(67862,'enUS','That is all that is to be said. Come, take your reward. And remember what you have learned today.','',26124),
(67863,'enUS','I see you, too, have braved the perils of Kota Peak. You have proven yourself worthy to do battle with me.','',26124),
(67864,'enUS','Hey lady! Watch it would ya!','',26124),
(67865,'enUS','Enough with the stick already!','',26124),
(67866,'enUS','Watch it!','',26124),
(67867,'enUS','Ouch! What\'s with the stick?!','',26124),
(67868,'enUS','Watch it lady! I\'m very fragile!','',26124),
(67869,'enUS','Quit pokin\' me with that thing!','',26124),
(67870,'enUS','Well done.  Your training is now complete.  Come see me in the Shrine of the Ox for your reward.','',26124),
(67871,'enUS','What is - no - NO! They had an airbase, a hidden airbase... my ship - my - Hellscream will have my head!','',26124),
(67872,'enUS','They all must die.','',26124),
(67873,'enUS','You! Bear-creature. What kind of sorcery was this?','',26124),
(67874,'enUS','We bring only our honor and the desire to crush our enemies. Have your kind been aiding the Alliance?','',26124),
(67875,'enUS','Stranger - your own doubts have been made manifest. Pandaria is not like whatever land you come from; it lives and breathes. You should be careful what kind of energy you bring here.','',26124),
(67876,'enUS','It is not our desire to get wrapped up in your bloodshed. Now have your men lower their weapons, or you will face TWO enemies on this continent.','',26124),
(67877,'enUS','Your doubts and hatreds have wrought havoc all throughout these ruins. Clean up after yourselves and meet me in the village below - I will do my best to explain.','',26124),
(67878,'enUS','Akkolon has entered the battlefield!','',26124),
(67879,'enUS','Shox\'tik has entered the battlefield!','',26124),
(67880,'enUS','The Manifestation of Terror has appeared on the battlefield!','',26124),
(67881,'enUS','','Now that we\'re acquaintances, $n, let me give you a tip. Folks \'round here can help spruce up your farm, but you gotta become friends. Unfortunately, you\'re too green to help them out or give gifts yet, so get stronger first!',26124),
(67882,'enUS','Oh hey $n... Gina\'s a voting member of the Tillers, so... try and make a good impression, okay?','',26124),
(67883,'enUS','You\'ve beel afflicted with Master Hsu\'s Deadly Poison.  Detox yourself to remove it!','',26124),
(67884,'enUS','Mung-Mung impressed, $n. You help me without asking for anything in return. That\'s what being a Tiller is all about. I\'ll meet you back on your farm. Mung-Mung will give you his vote.','',26124),
(67885,'enUS','You scum will NOT destroy this land as you defiled Kalimdor!','',26124),
(67886,'enUS','These cabbages have convinced me, $n. Anyone who can grow produce like this belongs in the Tillers. I\'m casting my vote for you and Farmer Yoon. See you back at your farm in a bit.','',26124),
(67887,'enUS','','Oh stop complaining and grab the stick!',26124),
(67888,'enUS','','So much whining! You would think I was trying to kill you!',26124),
(67889,'enUS','','You are in no position to complain about the help you are receiving!',26124),
(67890,'enUS','','Do you want to stay stuck in the tree?!',26124),
(67891,'enUS','','Hey you got yourself stuck there! I\'m just trying to help!',26124),
(67892,'enUS','','You know, I could just leave you up there!',26124),
(67893,'enUS','If there\'s anyone that\'s an expert on rocks and stones, it\'s a dwarf!','',26124),
(67894,'enUS','If we understand how Ragnaros has affected the lesser denizens of Hyjal, we may better understand how to repair it.','',26124),
(67895,'enUS','Your world...all worlds...will burn!','',26124),
(67896,'enUS','','Anyone with such a talented green thumb needs to be a Tiller. I don\'t care what that hare-brained grandson of mine says! Haohan is wrong about Farmer Yoon. You have my vote, $n.',26124),
(67897,'enUS','Generations of your people have passed as I\'ve prepared for this day.','',26124),
(67898,'enUS','','Even the forest\'s lovely flowers were turned against us...',26124),
(67899,'enUS','Did you see?\n\nHui cursed Greenstone Quarry\'s jade and transformed it into those monsters.','',26124),
(67900,'enUS','','This village was built with Hui\'s approval, but that was many generations ago.',26124),
(67901,'enUS','','Hui\'s curse even turned some of our famous Greenstone Brew against us!\n\nHis minions stole what little wasn\'t affected.',26124),
(67902,'enUS','','I don\'t think I could have held them off much longer.\n\nYou have my gratitude!',26124),
(67903,'enUS','Hui\'s earth magic even brought Kiri\'s jade lion statue to life!\n\nIt ran off to who knows where...','',26124),
(67904,'enUS','Hmmm, it sounds like the Kunzen hozen are causing quite a lot of trouble for Mr. Mudclaw. Maybe we can help.','',26124),
(67905,'enUS','%s summons |cFF298A08Sra\'thik Workers|r to his aid!','',26124),
(67906,'enUS','I\'ll meet you back in the village.','',26124),
(67907,'enUS','I need more time to prepare the mixture, $n. I\'ll let you know when it\'s ready.','',26124),
(67908,'enUS','You need to seriously rethink your definition of help lady! You\'re dangerous with that stick!','',26124),
(67909,'enUS','What do you want to show me, Kil\'ruk?','What do you want to show me, Kil\'ruk?',26124),
(67910,'enUS','Can you show me the chamber beneath Klaxxi\'vess again?','Can you show me the chamber beneath Klaxxi\'vess again?',26124),
(67911,'enUS','Are you sure you want to walk with Kil\'ruk?','Are you sure you want to walk with Kil\'ruk?',26124),
(67912,'enUS','Though the peak is safe, the areas around it are not.  Be more careful!','',26124),
(67913,'enUS','|TInterface\\Icons\\ability_druid_tigersroar.blp:20|t %s hides and prepares to |cFFFF0000|Hspell:131271|h[Leap from Shadows]|h|r!','',26124),
(67914,'enUS','%s could not see his prey!','',26124),
(67915,'enUS','Remember to take your Bag of Wu Kao Supplies!','Remember to take your Bag of Wu Kao Supplies!',26124),
(67916,'enUS','Hey Gina! Didn\'t expect a visit from you.','',26124),
(67917,'enUS','','Come walk with me, $n. I would like to pay Farmer Yoon a visit.',26124),
(67918,'enUS','','You know, you sure saved my hide with those scallions.',26124),
(67919,'enUS','','Cooks are always looking for fresh vegetables. Anything you grow on your farm, you can use for cooking or sell to other cooks.',26124),
(67920,'enUS','','Hey Farmer Yoon!',26124),
(67921,'enUS','','Listen, since you two did such a good turn by helping me out, I\'m casting the first vote to help you join the Tillers.',26124),
(67922,'enUS','','There are four other votes you\'ll need to get, but that\'ll come in time.',26124),
(67923,'enUS','','Settle yourselves in and come by the market any day if you are looking for work.',26124),
(67924,'enUS','','Settle yourselves in first. You\'ll be able to farm your fields, but I\'m afraid you\'re too inexperienced to continue further. Once you\'ve seen more of Pandaria, be sure to stop by.',26124),
(67925,'enUS','','Welcome to The Heartland!',26124),
(67926,'enUS','Coward!','',26124),
(67927,'enUS','You must be the trainer I\'ve heard about. Tell me, do you fear defeat?','',26124),
(67928,'enUS','A valiant effort, but not enough.  Speak to me when you are ready to try again.','',26124),
(67929,'enUS','The Klaxxi have spoken. The Empress must fall.','',26124),
(67930,'enUS','Let\'s get started.','Let\'s get started.',26124),
(67931,'enUS','','All manner of strange creatures are just ... falling from the sky!',26124),
(67932,'enUS','Hello Mung-Mung. How\'s everything at Mr. Mudclaw\'s farm?','',26124),
(67933,'enUS','Hey Yoonie! It\'s me, Mung-Mung!','',26124),
(67934,'enUS','Hey, isn\'t that Mung-Mung coming up the road?','',26124),
(67935,'enUS','Terrible, but don\'t tell him I said so. Vermins is running everywhere. Crops ain\'t growing. And something keeps eating the harvest.','',26124),
(67936,'enUS','But your farm is lookin\' pretty good. You know if you make friends with the folks around here, they might give you stuff to fancy it up even more.','',26124),
(67937,'enUS','Ookin\' dookers, just look at this place! You got a real nice farm. Looks like you\'ve been making friends around here!','',26124),
(67938,'enUS','Anyway, I just came by to thank you for those carrots.','',26124),
(67939,'enUS','They was real crunchy, and Haohan thought they were his best crop yet! Haha!','',26124),
(67940,'enUS','You ain\'t so bad, Yoonie. Here\'s my vote.','',26124),
(67941,'enUS','See ya later!','',26124),
(67942,'enUS','','Thank you for coming, everyone!',26124),
(67943,'enUS','','Into every generation are born the dreamers - dreamers like Liu Lang.',26124),
(67944,'enUS','','What\'s YOUR dream? Don\'t let ANYONE take it away!',26124),
(67945,'enUS','','Hold it in your heart, and make it happen. Dreamers change the world.',26124),
(67946,'enUS','','Red Crane bless you all. Goodnight!',26124),
(67947,'enUS','Hey look, someone\'s coming up the road. Hellooooo Farmer Fung! Nice to see you!','',26124),
(67948,'enUS','Well met, Farmer Yoon. I had to come by and see your farm for myself.','',26124),
(67949,'enUS','|TInterface\\Icons\\inv_polearm_2h_mantid_01.blp:20|t%s casts |cFFFF0000|Hspell:131320|h[Empower Blades]|h|r Run!','',26124),
(67950,'enUS','Not too shabby. Looks like you\'ve got room for more fields there, too.','',26124),
(67951,'enUS','Here\'s a tip from one farmer to another. There are lots of upgrades to buy at Halfhill Market. Gina Mudclaw sells tools, and Merchant Greenfield sells seeds.','',26124),
(67952,'enUS','Anyway, I just came by to thank you for those cabbages. Couldn\'t have grown better myself!','',26124),
(67953,'enUS','In fact, anyone who can grow such a perfect vegetable needs to be a Tiller, which is why I\'m voting you in.','',26124),
(67954,'enUS','Hey, looks like you\'ve only got two more votes to go!','',26124),
(67955,'enUS','You\'ll have to prove yourself to Nana and Haohan Mudclaw. Those two Mudclaws will be tough to sway, but I think you can do it.','',26124),
(67956,'enUS','See you around.','',26124),
(67957,'enUS','Don\'t forget to take it all in while you\'re here.  The Peak of Serenity has a wonderful view of beautiful Kun-Lai summit.','',26124),
(67958,'enUS','Here, you\'ll find several of us who have mastered the art of various crafts.  If you need any supplies along your journey, they can probably help.','',26124),
(67959,'enUS','We will have to regroup quickly if we hope to destroy the alliance.','',26124),
(67960,'enUS','This is the Training Ground, where most of your training will take place.  Come, I will introduce you to the masters who will be teaching you.','',26124),
(67961,'enUS','This is Master Kistane, she is a master in the art of channeling the mists to assist her and her allies.','',26124),
(67962,'enUS','This is Master Woo.  She specializes in defense against persistent attacks.','',26124),
(67963,'enUS','This is Master Yoon.  He is practiced in using powerful, focused healing to maintain himself in battle.','',26124),
(67964,'enUS','This is Master Cheng.  She has mastered the art of fighting on the move.','',26124),
(67965,'enUS','Y-y-you\'re N-N-Nana Mudclaw! I n-never thought I\'d get a visit from the m-m-matron herself!','',26124),
(67966,'enUS','This is Master Tsang.  He is a master of meditation and the ability to sense what is happening around him.','',26124),
(67967,'enUS','','I had to come and see Old Yoon\'s cub with my own eyes.',26124),
(67968,'enUS','','I knew your grandfather well. I was very sorry when he passed.',26124),
(67969,'enUS','','You know, the two of you remind me of him.',26124),
(67970,'enUS','','You were stubborn enough to keep tilling this soil even though you didn\'t have much experience.',26124),
(67971,'enUS','','You were brave enough to stand up to my grandson, Haohan.',26124),
(67972,'enUS','','And you two have shown quite the knack for growing delicious fruits and vegetables.',26124),
(67973,'enUS','This is Master Hsu.  He specializes in using all kinds of weaponry and is masterfully proficient with nearly any weapon under the sun.','',26124),
(67974,'enUS','','For that, you have earned my respect, my gratitude, and my vote. Well done.',26124),
(67975,'enUS','','Oh, and Farmer Yoon.',26124),
(67976,'enUS','','I do believe your grandpa would be very proud of you.',26124),
(67977,'enUS','And finally, this is Master Cheng.  Master Cheng focuses on reflex and swift motion and will help you begin your training.','',26124),
(67978,'enUS','And with that, I must depart.  Good luck with your training.','',26124),
(67979,'enUS','','We should stay here for only as long as it is necessary, $c.',26124),
(67980,'enUS','','Well, at least there will always be more honeybrew!',26124),
(67981,'enUS','Welcome aboard... Tillers!','',26124),
(67985,'enUS','I look forward to working with you.','I look forward to working with you.',26124),
(67986,'enUS','Welcome to the Peak of Serenity.  Good luck in your training.','Welcome to the Peak of Serenity.  Good luck in your training.',26124),
(67987,'enUS','Greetings.','Greetings.',26124),
(67988,'enUS','','I look forward to working with you.',26124),
(67989,'enUS','','Welcome to the Peak of Serenity.  Good luck in your training.',26124),
(67990,'enUS','','Greetings.',26124),
(67991,'enUS','Welcome.  Speak with me when you are ready to begin.','',26124),
(67992,'enUS','','She took a pretty nasty spill. the damage is horrific! I haven\'t been able to wake her.',26124),
(67993,'enUS','','Oh! You mean she looked like this before the crash?!',26124),
(67994,'enUS','Welcome to the Peak of Serenity $n.  How can I help you?','',26124),
(67995,'enUS','Could you show me around?','Could you show me around?',26124),
(67996,'enUS','There ya go!','',26124),
(67997,'enUS','','There we go! Good as new... I guess...',26124),
(67998,'enUS','','What... What happened?!',26124),
(67999,'enUS','','Hmm, I have an idea. An old brewmaster trick...',26124),
(68000,'enUS','Wait! Not the brew! That might be all we have left!','',26124),
(68001,'enUS','My assistant will show you to Master Cheng.  Good Luck!','',26124),
(68002,'enUS','Follow me and I will show you around the Peak of Serenity.','',26124),
(68003,'enUS','','Congratulations!',26124),
(68004,'enUS','','<Kiryn stares blankly up at the sky and doesn\'t respond.>',26124),
(68005,'enUS','What in blazes is this?','',26124),
(68006,'enUS','Admiral, we\'re seeing a significant native presence here. Ornate structures-','',26124),
(68007,'enUS','Cut the chatter, people. Eyes on the target!','Cut the chatter, people. Eyes on the target!',26124),
(68008,'enUS','You heard the admiral. Concentrate fire on the Horde base. Begin your attack runs.','',26124),
(68009,'enUS','They\'re firing on us sir!','They\'re firing on us sir!',26124),
(68010,'enUS','Use your torpedo rockets on those ships.','',26124),
(68011,'enUS','Confirmed kill. Nice shooting.','',26124),
(68012,'enUS','Well done. No mercy!','Well done. No mercy!',26124),
(68013,'enUS','That one\'s for Theramore!','That one\'s for Theramore!',26124),
(68014,'enUS','Any sign of the flagship down there?','Any sign of the flagship down there?',26124),
(68015,'enUS','Negative, Admiral. No sign of Captain Taylor OR his flagship.','',26124),
(68016,'enUS','Ugh! We\'ve been hit!','Ugh! We\'ve been hit!',26124),
(68017,'enUS','Heavy enemy fire... Sully, pull up!','',26124),
(68018,'enUS','We\'re not gonna make it! I\'m comin\' ta see you soon, pappy!','',26124),
(68019,'enUS','Pay \'em back! Hit them with everything you\'ve got!','Pay \'em back! Hit them with everything you\'ve got!',26124),
(68020,'enUS','That\'s enough - all wings, report back. Prepare for ground assault.','That\'s enough - all wings, report back. Prepare for ground assault.',26124),
(68021,'enUS','I will help you carry the barrels. Or did you think they were going to magically fit in your bag?','',26124),
(68022,'enUS','','The flagship\'s last reported position was below. Can you see anything?',26124),
(68023,'enUS','Fog... nothing but dense fog... wait! Land - starboard! I see ships.','',26124),
(68024,'enUS','Heroes never die, $n.','',26124),
(68025,'enUS','After you, my good sir.','',26124),
(68026,'enUS','I say, it looks like I\'ve racked up another win!','',26124),
(68027,'enUS','That is most unfortunate.','',26124),
(68028,'enUS','Ah, but were you expecting this?','',26124),
(68029,'enUS','It seems I\'ll be enjoying an expedient win this fine day!','',26124),
(68030,'enUS','Oh dear, I\'m losing!','',26124),
(68031,'enUS','Now\'s as good a time as any, I suppose.','',26124),
(68032,'enUS','I knew I made the right choice when I took this up!','',26124),
(68033,'enUS','Maybe I can still get my old farm back...','',26124),
(68034,'enUS','I\'ve found it sometimes helps to change things up a bit.','',26124),
(68035,'enUS','If only my wife were here to see this. I\'m going to win!','',26124),
(68036,'enUS','There\'s plenty more where that came from!','',26124),
(68037,'enUS','','I won\'t go easy on you!',26124),
(68038,'enUS','','In your face!',26124),
(68039,'enUS','','Mommy! Mommy! The mean tamer didn\'t let me win!',26124),
(68040,'enUS','','Oh no you don\'t!',26124),
(68041,'enUS','','Take that!',26124),
(68042,'enUS','','W-why did you k-kill my bunny...',26124),
(68043,'enUS','I do hope you\'re prepared to feed your pets to mine as a treat.','',26124),
(68044,'enUS','I did warn you of the dangers of these woods.','',26124),
(68045,'enUS','Your courage is impressive.','',26124),
(68046,'enUS','Do you feel something?','',26124),
(68047,'enUS','What a show!','',26124),
(68048,'enUS','No matter. A single life for a victory is well worth the sacrifice.','',26124),
(68049,'enUS','Avast, land lubbers be attackin\'! Man the harpoons!','',26124),
(68050,'enUS','All the booty ish mine!','',26124),
(68051,'enUS','Why\'d you go and have to do that? ...hic!','',26124),
(68052,'enUS','Give \'em hell!','',26124),
(68053,'enUS','Now that...that is fightin\'! Whoever\'s controllin\' these pets sure ish somethin\'! ...hic!','',26124),
(68054,'enUS','Man down!','',26124),
(68055,'enUS','We be killin\' you now.','',26124),
(68056,'enUS','Now that is what Zunta be talkin\' about!','',26124),
(68057,'enUS','You be da victor today. Enjoy it.','',26124),
(68058,'enUS','How about you try dis one on for size?','',26124),
(68059,'enUS','Good, good. Zunta give you a treat later.','',26124),
(68060,'enUS','Why you so mean to Zunta, eh?','',26124),
(68061,'enUS','','Battle is upon us. Crush them!',26124),
(68062,'enUS','','The day is ours.',26124),
(68063,'enUS','','I\'ll beat you soon enough.',26124),
(68064,'enUS','','I won\'t give you the pleasure.',26124),
(68065,'enUS','','Keep going! Kill!',26124),
(68066,'enUS','','Not important. I will stop at nothing to win!',26124),
(68067,'enUS','','Do not be fooled by my calmness. I will defeat you.',26124),
(68068,'enUS','','Victory is ours, children!',26124),
(68069,'enUS','','Well done. You\'ve beaten me when few have had the luxury.',26124),
(68070,'enUS','','A surprising twist!',26124),
(68071,'enUS','','Success!',26124),
(68072,'enUS','','How could you?',26124),
(68073,'enUS','','You\'re gonna hurt like you never hurt before when I\'m through with ya.',26124),
(68074,'enUS','','You feelin\' da hurt, mon?',26124),
(68075,'enUS','','I never see nobody fight like you be fightin\'.',26124),
(68076,'enUS','','I bet you never saw dis one comin\'.',26124),
(68077,'enUS','','Look at da little one hurtin\'!',26124),
(68078,'enUS','','Looks like dis one has a bit of a sting!',26124),
(68079,'enUS','','I\'m warning you, I will not falter under your assault.',26124),
(68080,'enUS','','Fighting the strength of the land is inevitably futile.',26124),
(68081,'enUS','','You fight well.',26124),
(68082,'enUS','','The earth will never falter!',26124),
(68083,'enUS','','The cycle continues.',26124),
(68084,'enUS','I was really hoping to find more Honeybrew. I guess I\'ll just try and find more on my own. Let me know if you need anymore help!','',26124),
(68085,'enUS','','You fight against the unstoppable.',26124),
(68086,'enUS','We fight!','',26124),
(68087,'enUS','Me win!','',26124),
(68088,'enUS','NO! ME WIN!','',26124),
(68089,'enUS','No! No kill! Fight this one instead!','',26124),
(68090,'enUS','Good tiny thing! You kill other tiny thing!','',26124),
(68091,'enUS','Why you no fight? I said fight!','',26124),
(68092,'enUS','','Let us begin.',26124),
(68093,'enUS','','Looks like I left you earthbound!',26124),
(68094,'enUS','','We\'ve been shot out of the sky!',26124),
(68095,'enUS','','Great job. Take a break!',26124),
(68096,'enUS','','We just might win this!',26124),
(68097,'enUS','','A beautiful creature has fallen.',26124),
(68098,'enUS','','Activating aggression modules!',26124),
(68099,'enUS','','You never stood a chance against my augmented team!',26124),
(68100,'enUS','','Total system failure!',26124),
(68101,'enUS','','Engaging self-preservation chip.',26124),
(68102,'enUS','','No letting up. Full speed ahead!',26124),
(68103,'enUS','','That\'s nothing a good spit shine won\'t fix.',26124),
(68104,'enUS','You think I\'m scared of you? I faced Onyxia!','',26124),
(68105,'enUS','Who\'s great? I am!','',26124),
(68106,'enUS','I hope a dragon eats you!','',26124),
(68107,'enUS','Alright, that\'s enough. Switch!','',26124),
(68108,'enUS','That\'s what happens when you go into the whelp pits!','',26124),
(68109,'enUS','One keg?! I was carrying one keg with ease when I was a young cub, barely higher than your knee!','',26124),
(68110,'enUS','Heavy, but I can hold more! Keep going!','',26124),
(68111,'enUS','I may have overestimated my own strength...','',26124),
(68112,'enUS','That\'s it, I\'ve reached my limit! This is quite the haul!','',26124),
(68113,'enUS','I\'ve been wiped out!','',26124),
(68114,'enUS','All this fighting is such a waste. How do your people do it all the time? When do you find time to celebrate and enjoy the simple things?','',26124),
(68115,'enUS','Horde, Alliance... what\'s the difference?! Do you not both love a good brew? Do you both not value your friends and families the same?','',26124),
(68116,'enUS','Why is it you can\'t just talk out your differences? I have never encountered a problem that a good long talk couldn\'t fix!','',26124),
(68117,'enUS','You cannot possibly comprehend the forces stacked against you.','',26124),
(68118,'enUS','Perhaps now you\'re ready to see things my way?','',26124),
(68119,'enUS','Honeydew Village is run by the Honeydews, but the real heart of the village is the brewery! The brewery belongs to my family, the Honeypaws. Best Honeybrew you\'ll find anywhere!','',26124),
(68120,'enUS','You only delay us. We cannot be stopped.','',26124),
(68121,'enUS','We were on our way to Dawn\'s Blossom for a festival before you arrived! When I imagined fireworks tonight, I didn\'t expect it to be like this!','',26124),
(68122,'enUS','Have you ever seen such a magnificent being?','',26124),
(68123,'enUS','','Those are Horde vessels... General quarters! Get our birds in the air. Clear the decks. Stations, people. Let\'s go to war!',26124),
(68124,'enUS','Give up now while you still have the chance!','',26124),
(68125,'enUS','A minor inconvenience.','',26124),
(68126,'enUS','Why have you brought your war to our land? What of your homes? Was there nothing worth fighting for there?','',26124),
(68127,'enUS','Your actions will no doubt attract the attention of the Shado-Pan. I may even get to meet one!','',26124),
(68128,'enUS','My village will not enter your conflict. Though, I fear your arrival has changed our peaceful existence forever.','',26124),
(68129,'enUS','This Honeybrew is the lifeblood of this village. Now THAT is something worth fighting for!','',26124),
(68130,'enUS','Quickly, this way! The cannon fire has opened a passage to the courtyard!','',26124),
(68131,'enUS','We should get moving. That Honeybrew isn\'t going to find itself!','',26124),
(68132,'enUS','','I\'m very sorry, but I no longer have relics to sell you. Their magic seems to have extinguished! Perhaps I\'ll go into dancing full time now, it would be a nice change of pace.',26124),
(68133,'enUS','Thank you for your help. I\'ll make sure this Honeybrew gets back to the village. Try not to blow anything else up!','',26124),
(68134,'enUS','Thank you for your help. Try not to blow anything else up!','',26124),
(68135,'enUS','Should we allow them to stay here? They have wounded to tend to.','',26124),
(68136,'enUS','','Well what about the bombs that landed in our farms from your warship!',26124),
(68137,'enUS','','They will bring more destruction to our village!',26124),
(68138,'enUS','','A war we did not have until you arrived!',26124),
(68139,'enUS','How can you remain neutral after watching them blow us out of the sky?!','',26124),
(68140,'enUS','Those are the casualties of war!','',26124),
(68141,'enUS','Enough! We will relocate shortly. These creatures have destroyed most of what was left from the ship.','',26124),
(68142,'enUS','Gather what the villagers are willing to sell us and prepare the others to leave.','',26124),
(68143,'enUS','I can\'t wait to grow up!','',26124),
(68144,'enUS','Has anyone seen my brother?','',26124),
(68145,'enUS','I wish I had a cookie.  I love cookies!','',26124),
(68146,'enUS','','It seems that my defenses have prevailed.  Speak with me when you are ready to try again.',26124),
(68147,'enUS','HUGGALON LOVE YOU!','',26124),
(68148,'enUS','','Well fought, but you still have work to do.  Speak with me when you are ready to try again.',26124),
(68149,'enUS','','It seems you were unable to keep me at bay.  Speak with me when you are ready to try again.',26124),
(68150,'enUS','It seems my strength proved too much for you.  Speak with me when you are ready to try again.','',26124),
(68151,'enUS','It seems your efforts to defeat me have failed.  Speak with me when you are ready to try again.','',26124),
(68152,'enUS','If it is war you mean to bring to our shores, the very land itself will respond to your passions and your violence.','',26124),
(68153,'enUS','I do not know what the ultimate consequences will be. Nobody does.','',26124),
(68154,'enUS','Your will is strong, but it seems mine was stronger.  Speak with me when you are ready to try again.','',26124),
(68155,'enUS','It seems my assistants proved too much for you.  Speak with me when you are ready to try again.','',26124),
(68156,'enUS','Are you ready for your final test, $n?','',26124),
(68157,'enUS','I am ready.','I am ready.',26124),
(68158,'enUS','Bow to me and we shall begin.','',26124),
(68159,'enUS','To defeat me, you will need to use all that you have learned from the other masters.  If you can do that, your training will be complete.','',26124),
(68160,'enUS','It seems you have not quite mastered all that we have taught you.  Speak to me when you are ready to try again.','',26124),
(68161,'enUS','Master Hight is burning you alive.  Move!','',26124),
(68162,'enUS','Master Hight is healing.  Interrupt him!','',26124),
(68163,'enUS','Master Hight is spinning.  Paralyze him!','',26124),
(68164,'enUS','Master Hight is preparing a massive strike with his polearm.  Disarm him!','',26124),
(68165,'enUS','Are you thinkin\' what I\'m thinkin\', $n?','',26124),
(68166,'enUS','You comfy down there?','',26124),
(68167,'enUS','I\'m pretty sure I tied the knots right. Let me know if you fall off.','',26124),
(68168,'enUS','','This won\'t take long.',26124),
(68170,'enUS','None can stop the Grimtotem!','',26124),
(68171,'enUS','','Your impudence will be your undoing. Mark my words!',26124),
(68172,'enUS','','This isn\'t over!',26124),
(68173,'enUS','','So weak.',26124),
(68174,'enUS','','You\'ll pay for that.',26124),
(68175,'enUS','Everyone loves Martar!','Everyone loves Martar!',26124),
(68176,'enUS','Come chat with Martar!','Come chat with Martar!',26124),
(68177,'enUS','Not to worry, I\'ll make this quick.','',26124),
(68178,'enUS','That wasn\'t so bad, was it?','',26124),
(68179,'enUS','Perhaps I need to increase the dosage to prevent such quick deaths.','',26124),
(68180,'enUS','Don\'t be so sure of yourself.','',26124),
(68181,'enUS','It won\'t be long now.','',26124),
(68182,'enUS','How unfortunate.','',26124),
(68183,'enUS','','I\'ll show you firsthand the strength of undeath.',26124),
(68184,'enUS','','I knew I was stronger!',26124),
(68185,'enUS','','No...no...',26124),
(68186,'enUS','','Rest, my precious.',26124),
(68187,'enUS','','Yes...join us!',26124),
(68188,'enUS','','No! We will not be defeated!',26124),
(68189,'enUS','Are ye sure that ye want to face the might of dragons?','',26124),
(68190,'enUS','Now it\'s time to show my brother who the real master tamer is!','',26124),
(68191,'enUS','You got lucky. That\'s all.','',26124),
(68192,'enUS','That\'s enough!','',26124),
(68193,'enUS','Now that\'s what I\'m talkin\' about!','',26124),
(68194,'enUS','No! I just finished raising that one!','',26124),
(68195,'enUS','','I hope you like losing!',26124),
(68196,'enUS','','I knew the swamp was the right choice!',26124),
(68197,'enUS','','Perhaps it was wrong of me to venture here.',26124),
(68198,'enUS','','The swamp conceals many things.',26124),
(68199,'enUS','','Victory shall be mine!',26124),
(68200,'enUS','','This is looking bleak for me.',26124),
(68201,'enUS','By the hammer of me father, I shall defeat ye!','',26124),
(68202,'enUS','That\'s the stuff, boys. We did it!','',26124),
(68203,'enUS','You won\'t be deterrin\' me. Not today. I\'ll keep trainin\'!','',26124),
(68204,'enUS','Try this\'n on fer size!','',26124),
(68205,'enUS','Great job!','',26124),
(68206,'enUS','How dare ye...','',26124),
(68207,'enUS','','I will show you no mercy.',26124),
(68208,'enUS','','Just as I thought. You never stood a chance.',26124),
(68209,'enUS','Make sure to tend those scallions. After that, nothing to do but wait until tomorrow when they\'ll be nice and ripe.','',26124),
(68210,'enUS','','Curse you!',26124),
(68211,'enUS','','I am far from finished.',26124),
(68212,'enUS','Hey $n, didya know that all kinds of things can happen to your plants? If you don\'t know how to deal with something, just ask me!','',26124),
(68213,'enUS','','That was too easy.',26124),
(68214,'enUS','','You\'ll suffer for your transgression.',26124),
(68215,'enUS','Uh-oh, looks like today, our plants are parched. Let\'s water them.','',26124),
(68216,'enUS','','I\'m going to wreck you!',26124),
(68217,'enUS','','Now that\'s what I\'m talking about! Woohoo!',26124),
(68218,'enUS','','Talk to any of the Ironpaws at the market if you want to improve your own cooking skill.',26124),
(68219,'enUS','','Maybe I should\'ve gone with more weapons...',26124),
(68220,'enUS','','Oh no you don\'t!',26124),
(68221,'enUS','','Bam!',26124),
(68222,'enUS','','Hey! I spent some serious gold on that!',26124),
(68223,'enUS','Don\'t go easy on me!','',26124),
(68224,'enUS','I bet if I keep winning, I\'ll get invited to fight in Stormwind one day!','',26124),
(68225,'enUS','Wow, you\'re really good!','',26124),
(68226,'enUS','Let\'s keep going!','',26124),
(68227,'enUS','Good job!','',26124),
(68228,'enUS','Oh no...','',26124),
(68229,'enUS','Orcs rule!','Orcs rule!',26124),
(68230,'enUS','The water never lies.','',26124),
(68231,'enUS','I\'ll destroy every last one of you!','',26124),
(68232,'enUS','Is that all you\'ve got?!','',26124),
(68233,'enUS','Get away from my ship!','',26124),
(68234,'enUS','I\'ll have all of your heads!','',26124),
(68235,'enUS','Where do you keep coming from?!','',26124),
(68236,'enUS','These creatures have suffered enough. I will not let you defeat them!','',26124),
(68237,'enUS','The spirits smile upon my victory!','',26124),
(68238,'enUS','Ancestors forgive me. I have failed...','',26124),
(68239,'enUS','Come rest. You will need your strength later in the battle.','',26124),
(68240,'enUS','Lok\'tar!','',26124),
(68241,'enUS','Your spirit reunites with your ancestors, little one.','',26124),
(68242,'enUS','These old bones have much knowledge to impart.','',26124),
(68243,'enUS','You will do better, next time.','',26124),
(68244,'enUS','It has been an honor, outlander.','',26124),
(68245,'enUS','Perhaps this will test your skills.','',26124),
(68246,'enUS','You must focus.','',26124),
(68247,'enUS','A deft maneuver, outlander.','',26124),
(68248,'enUS','Who are you again?','',26124),
(68249,'enUS','My memory isn\'t what it used to be.','',26124),
(68250,'enUS','What day is it?','',26124),
(68251,'enUS','I will crush you beneath the onslaught of my team!','',26124),
(68252,'enUS','I hope you now understand that there is no defeating me.','',26124),
(68253,'enUS','No matter. Nobody can stop me in the end.','',26124),
(68254,'enUS','Not so fast!','',26124),
(68255,'enUS','My victory draws near.','',26124),
(68256,'enUS','That simply will not suffice.','',26124),
(68257,'enUS','(A boss has been defeated in Heroic difficulty with the dampening field enabled. It may no longer be disabled.)','',26124),
(68258,'enUS','No... That\'s not right...','',26124),
(68259,'enUS','It should be beautiful. It should be pristine!','',26124),
(68260,'enUS','Perhaps I brewed the tea wrong? Yes, that must be it. I brewed the tea wrong. My apologies.','',26124),
(68261,'enUS','How did you end up here?','How did you end up here?',26124),
(68262,'enUS','When the SI:7 found me, they wanted to take me home. I ran away.$B$BIt wasn\'t long before the Horde found me.$B$BDuring the battle at Serpent\'s Heart, I managed to slip away in the chaos. A merchant allowed me to ride with his family as they fled west, to Zhu\'s Watch.$B$BIt was there that I met Mei Barrelbottom.$B$BShe told me of the Crane Wing order, and on her advice I accompanied a courier to the temple to seek an audience with Chi-Ji, the Red Crane.$B$BI was studying with the disciples there when the sha arrived.','',26124),
(68263,'enUS','I could not bear to sit in Stormwind Keep while my people\'s blood spills here!$B$BPandaria has so much to teach us. There is great power here. Power that could save thousands of lives.$B$BAnd I aim to find it.','',26124),
(68264,'enUS','Why didn\'t you return to Stormwind with the SI:7?','Why didn\'t you return to Stormwind with the SI:7?',26124),
(68265,'enUS','Shiny tools mine! Tasty carrots mine! All for Kunzen. All for Chief Yip-Yip!','',26124),
(68266,'enUS','','Hey there, stranger. You getting along all right at the farm?',26124),
(68267,'enUS','','You look a bit weak, $r. You\'ll need to travel more of the land before you\'re strong enough to help the folks out here.',26124),
(68268,'enUS','','Folks \'round here are a little wary of strangers, but they warm right up once you get to know them.$B$BOnce you\'re more experienced, you can get to know them by helping them out.',26124),
(68269,'enUS','','Folks \'round here are always in need of a hand, but you\'re not strong enough yet. Once you\'ve walked more o\' this land, you come back and they\'ll be begging you for aid.',26124),
(68270,'enUS','','Have you seen Merchant Greenfield\'s supply of seeds? There are all sorts of strange and wonderful things you can grow on your farm.',26124),
(68271,'enUS','','Have you ever thought about adding some animals to your farm?',26124),
(68272,'enUS','','You know, that house that Farmer Yoon lives in is a dump! He should talk to Tina. I hear she\'s real good at redecorating.',26124),
(68273,'enUS','','Have you seen all the goods that I sell? You\'ll have to earn favor with the Tillers to buy them from me, but in order to do that, you\'ll need to gain more experience by traveling this land.',26124),
(68274,'enUS','Me and Gunny, we wash up wid a few of our crew near Sri-La Village in da Jade Forest. Our feet was itchin\' to walk da land after months on da churnin\' sea. We came here an\' found paradise.','',26124),
(68275,'enUS','','Raj\'ku and I, we\'ve been traveling for days and days. Just when we think we\'ve seen it all, we\'re surprised again.',26124),
(68276,'enUS','','I want to keep going until we see what\'s over that big wall to the west, but Raj\'ku just keeps staring at all the giant vegetables around here. Maybe deep down, he\'s itching to be a farmer!',26124),
(68278,'enUS','Who c-c-c-calls?','',26124),
(68279,'enUS','C-c-c-cowards...','',26124),
(68280,'enUS','What do you currently have for sale?','What do you currently have for sale?',26124),
(68281,'enUS','Can you tell me anything about your village?','Can you tell me anything about your village?',26124),
(68282,'enUS','We are a town of brewers and farmers. We hunt on occasion when we need to.$B$BThat\'s where I come in. It\'s awfully hard to hunt without a quality bow!','',26124),
(68283,'enUS','','You chose a good day to come to the market, neighbor.',26124),
(68284,'enUS','','Welcome to Halfhill Market!',26124),
(68285,'enUS','What goods do you have available?','What goods do you have available?',26124),
(68286,'enUS','','You here to buy or sell? Feel free to look around.',26124),
(68287,'enUS','','You\'ve come to the right place! Halfhill Market\'s got everything you need.',26124),
(68288,'enUS','','Hey there traveler, you looking to learn how to cook?',26124),
(68289,'enUS','','Do you like to cook? Well you\'re in luck, because I like to help aspiring chefs.',26124),
(68290,'enUS','$p! You\'re here! Assault their leader and we will back you up.','',26124),
(68291,'enUS','If you\'re known for trade, where are the pandaren from other towns?','If you\'re known for trade, where are the pandaren from other towns?',26124),
(68292,'enUS','','Set aside your weapon and take up a carving knife, traveler. The Ironpaws can teach you all manner of roasting, brewing, stewing, steaming, and grilling!',26124),
(68293,'enUS','','If you seek to improve your cooking skill, I have knowledge to share with you.',26124),
(68294,'enUS','','My best guess is that the enormous floating fortress deterred any would-be travelers as of late.',26124),
(68295,'enUS','I\'d like to see what goods you have for sale.','I\'d like to see what goods you have for sale.',26124),
(68296,'enUS','The journey was long, but I finally found the Vale. Now I am working with the Sentinels to understand the pools\' mysteries.','',26124),
(68297,'enUS','We managed to earn the Celestials\' trust and open the Vale, but we must continue to show them that we are on a mission of peace.','',26124),
(68298,'enUS','It pained me to see so many displaced from their homes in Kun-Lai. I am very happy we found a safe haven for those in need of protection.','',26124),
(68299,'enUS','The Sentinels and I exchanged stories of our time in the Krasarang Wilds. I told them all about my adventures at the Temple of Chi-Ji.','',26124),
(68300,'enUS','The more that I travel this land, the fonder I grow of the pandaren people. Such delicious food and drink does not hurt, either.','',26124),
(68301,'enUS','I have seen so much during my journey through this land. I feel older and perhaps a bit... wiser.','',26124),
(68302,'enUS','I believe that the Alliance\'s future is tied to that of Pandaria.$B$BAfter we landed here, we set certain paths into motion. We were there when the Serpent\'s Heart fell. In a way, we helped fulfill Lorewalker Cho\'s vision of the future.$B$BBecause of this, I cannot return to Stormwind until I have helped to set things right.','',26124),
(68303,'enUS','','Men, you\'ve trained for this. You\'re among the elite.  You are Skyfire men!',26124),
(68304,'enUS','','This is the ship that took down Deathwing. You think some raggedy little Horde outpost stands a chance against the pride of the Alliance fleet? NO!',26124),
(68305,'enUS','The Sentinels and I exchanged stories of our time in the Krasarang Wilds. I told them all about our adventures together at the Temple of Chi-Ji.','',26124),
(68306,'enUS','','Those green dirtbags down there plagued your homes in Southshore, laid siege to your children in Redridge, and massacred every man, woman and child in Theramore.',26124),
(68307,'enUS','','It. Is. PAYBACK TIME!',26124),
(68308,'enUS','We should not fight here. Not like this!','',26124),
(68312,'enUS','The earth has much to offer us, so long as we learn to take from it properly. I can teach you how, if you so wish.','',26124),
(68314,'enUS','','You aren\'t from around here. Are you interested in learning about the native plant life of Pandaria?',26124),
(68315,'enUS','The beasts of this land aren\'t like whatever it is you have in your home. Train with me so that you may know how to properly skin them.','',26124),
(68316,'enUS','','Zhao-Jin the Bloodletter storms the gates! We must stop him from entering the palace vaults!',26124),
(68318,'enUS','','If we do not defeat the Shao-Tien now, all is lost!',26124),
(68320,'enUS','I am holding the other mogu from entering the palace steps. Hurry!','',26124),
(68321,'enUS','I... must... hold on!','',26124),
(68322,'enUS','I cannot hold this barrier forever. Quickly, you must deal with the warlord on the palace steps!','',26124),
(68323,'enUS','Hurry, $r! Our factions may be at war, but we have greater worries at the moment!','',26124),
(68324,'enUS','I came to lend my aid to the fight. Is there anything I can do to help?','',26124),
(68325,'enUS','%s begins to summon |cFFFE9A2EFlamecoaxing Spirits|r! Defeat them to stop the Flame Wall!','',26124),
(68326,'enUS','$n? What are you doing here? We need you up on the Skyfire! Quick, take the portal!','',26124),
(68327,'enUS','Doren just needs a little more time. Hold the line!','Don\'t let the horde scum through!',26124),
(68328,'enUS','They\'ve blown through the second barricade! Fight them back!','They\'ve blown through the second barricade! Fight them back!',26124),
(68329,'enUS','There\'s a $c incoming! Don\'t let $Ghim:her; through!','Stop $Ghim:her;! $GHe:She; must not get to Doren!',26124),
(68330,'enUS','Let the spectacle begin!','',26124),
(68331,'enUS','I\'ll take that gold now, if you would be so kind.','',26124),
(68332,'enUS','So...how about we forget about our little wager and carry on with our busy lives?','',26124),
(68333,'enUS','Trying to pull a fast one on me, are you? I think not!','',26124),
(68334,'enUS','Help us rout them from your land, and your kind can stand tall and proud with the Horde!','',26124),
(68335,'enUS','It has been many years since I have seen it manifest so dramatically.','',26124),
(68336,'enUS','You can forfeit if you\'d like.','',26124),
(68337,'enUS','An unfortunate business expense.','',26124),
(68338,'enUS','','Remember your training, Helena...you\'ve got this.',26124),
(68339,'enUS','','I did it!',26124),
(68340,'enUS','','Well, practice makes perfect I suppose.',26124),
(68341,'enUS','','Come back before you get hurt!',26124),
(68342,'enUS','','Nice! I\'m on my way to victory!',26124),
(68343,'enUS','Oh no! That wasn\'t good...','',26124),
(68344,'enUS','Let\'s take flight!','',26124),
(68345,'enUS','We\'re flying high!','',26124),
(68346,'enUS','Yes, thanks to $n. Zhao-Jin, leader of the Shao-Tien, is slain!','',26124),
(68347,'enUS','','With the Celestials\' aid, we tore through the mogu advance. Our soldiers were able to clean up the rest, and drive them from the valley.',26124),
(68348,'enUS','Leven! You\'re alive! That must mean...','',26124),
(68349,'enUS','Our war against the mogu is not yet over. But today we can rest, and proclaim our victory.','',26124),
(68350,'enUS','All hail $n, savior of the Vale! Conqueror of the Shao-Tien, and defender of the people! May the stars sing your name!','',26124),
(68351,'enUS','Pull the Mist-Shaman\'s torch out from the ground!','',26124),
(68352,'enUS','Shot out of the sky!','',26124),
(68353,'enUS','$n, you\'ve done it!','',26124),
(68354,'enUS','Take it easy, will ya?','',26124),
(68355,'enUS','Now we\'re talkin\'!','',26124),
(68356,'enUS','Cut down in its prime...','',26124),
(68357,'enUS','You\'re going to regret this, I assure you.','',26124),
(68358,'enUS','I did warn you. Pity.','',26124),
(68359,'enUS','This is a most...unfortunate turn of events.','',26124),
(68360,'enUS','An unexpected twist.','',26124),
(68361,'enUS','Don\'t worry, it\'ll all be over soon.','',26124),
(68362,'enUS','I was using that.','',26124),
(68363,'enUS','You dare challenge me? I\'ll show you the true power of the Horde!','',26124),
(68364,'enUS','Consider yourself fortunate that I was so merciful.','',26124),
(68365,'enUS','NO! You miserable wretch! I do not lose!','',26124),
(68366,'enUS','I will not rest until I defeat you!','',26124),
(68367,'enUS','Pathetic.','',26124),
(68368,'enUS','You\'ll pay for that.','',26124),
(68369,'enUS','Me go first or you?','',26124),
(68370,'enUS','Me win! Me win!','',26124),
(68371,'enUS','You good at battling!','',26124),
(68372,'enUS','Me save this one for later.','',26124),
(68373,'enUS','Me win?','',26124),
(68374,'enUS','Why it no move?','',26124),
(68375,'enUS','By the might of King Varian\'s throne, I shall defeat you!','',26124),
(68376,'enUS','Another victory for the Alliance military!','',26124),
(68377,'enUS','I was warned about you. I should have heeded that warning.','',26124),
(68378,'enUS','I\'m not through with you yet!','',26124),
(68379,'enUS','By the grace of Prince Anduin I shall achieve victory this day.','',26124),
(68380,'enUS','We shall persevere.','',26124),
(68381,'enUS','','I wish you the best of luck.',26124),
(68382,'enUS','','Do not lament. Continue your training, and you shall achieve greatness.',26124),
(68383,'enUS','I must go - there are others who have landed on our southern shores.','',26124),
(68384,'enUS','','Well done. I applaud your skills as a tactician.',26124),
(68385,'enUS','','Live to fight another day, and prosper.',26124),
(68386,'enUS','','All is as it should be.',26124),
(68387,'enUS','','You are quite powerful indeed.',26124),
(68388,'enUS','Time to lay down da beatdown!','',26124),
(68389,'enUS','Mo\'ruk\'s the best!','',26124),
(68390,'enUS','Mo\'ruk...got beaten?','',26124),
(68391,'enUS','Mo\'ruk not done yet!','',26124),
(68392,'enUS','That\'s the stuff!','',26124),
(68393,'enUS','No!','',26124),
(68394,'enUS','','My pets are all hand-grown! You don\'t stand a chance!',26124),
(68395,'enUS','','I knew I could count on my team to win!',26124),
(68396,'enUS','','My entire team\'s been razed!',26124),
(68397,'enUS','','If you think I\'m out for the count, think again!',26124),
(68398,'enUS','','We\'re really plowing through your team now!',26124),
(68399,'enUS','','This is going south quick!',26124),
(68400,'enUS','Let us see who is the greater tamer.','',26124),
(68401,'enUS','The day is mine. Well fought.','',26124),
(68402,'enUS','You are a worthy foe. The day is yours.','',26124),
(68403,'enUS','A smart fighter knows when retreat is the best option.','',26124),
(68404,'enUS','Capitalizing on your enemy\'s weaknesses is key.','',26124),
(68405,'enUS','Sometimes even the finest make mistakes.','',26124),
(68406,'enUS','You have not earned the right to defeat me, tamer.','',26124),
(68407,'enUS','I hope you learn from your defeat.','',26124),
(68408,'enUS','Clearly, I was wrong about you.','',26124),
(68409,'enUS','You ought to rejoice that you even came close to defeating one of my pets.','',26124),
(68410,'enUS','Only a matter of time, now.','',26124),
(68411,'enUS','Impossible!','',26124),
(68412,'enUS','','Do not expect to defeat me.',26124),
(68413,'enUS','','Perhaps another day, tamer.',26124),
(68414,'enUS','','Well done! Congratulations on your victory.',26124),
(68415,'enUS','','Do not underestimate me.',26124),
(68416,'enUS','','Do not expect mercy, tamer. I will show none.',26124),
(68417,'enUS','','Impressive. I hadn\'t anticipated that.',26124),
(68418,'enUS','Let\'s get this show on the road!','',26124),
(68419,'enUS','Nobody can beat a dwarf in his element!','',26124),
(68420,'enUS','Woah! Woah! Take it easy! You win!','',26124),
(68421,'enUS','I\'ve still got plenty of tricks up my sleeve!','',26124),
(68422,'enUS','That\'s more like it!','',26124),
(68423,'enUS','He was just a wee pebble...','',26124),
(68424,'enUS','Very well. Let us fight.','',26124),
(68425,'enUS','Thank you. My pets are stronger than ever now.','',26124),
(68426,'enUS','Such death...','',26124),
(68427,'enUS','Rest, so that you may do battle again soon.','',26124),
(68428,'enUS','Ah. The taste of victory is sweet.','',26124),
(68429,'enUS','At least my pet died fighting valorously.','',26124),
(68430,'enUS','Show them the true meaning of pain.','',26124),
(68431,'enUS','You never stood a chance, whelp.','',26124),
(68432,'enUS','How? I cannot lose! I am imbued with the power of twilight!','',26124),
(68433,'enUS','Not even close.','',26124),
(68434,'enUS','Continue the slaughter.','',26124),
(68435,'enUS','You fool!','',26124),
(68436,'enUS','The time of your reckoning is upon us.','',26124),
(68437,'enUS','Do not fear defeat. It is a catalyst for later triumph.','',26124),
(68438,'enUS','I had thought my victory was certain. Clearly the Makers had other plans.','',26124),
(68439,'enUS','Your time has not yet come.','',26124),
(68440,'enUS','A mere blip in the eyes of the Makers.','',26124),
(68441,'enUS','You\'re stronger than I thought.','',26124),
(68442,'enUS','I\'ve been wondering when I would be fighting you.','',26124),
(68443,'enUS','The lake told me it would be so!','',26124),
(68444,'enUS','I must have misunderstood the water\'s wisdom.','',26124),
(68445,'enUS','Much hides just beneath the surface.','',26124),
(68446,'enUS','Another victim claimed by the unending tide.','',26124),
(68447,'enUS','Another grave in the depths.','',26124),
(68448,'enUS','How can I help the August Celestials?','How can I help the August Celestials?',26124),
(68449,'enUS','','Once you are of revered standing with the Golden Lotus, you will be able to help the August Celestials.$B$BTo the east, Yu\'lon\'s temple is under attack by the Sha of Doubt.$B$BTo the south, Chi-Ji\'s trainees are rebuilding and retraining after the attack on their temple.$B$BTo the north, Xuen tests the might of worthy combatants who enter his rings.$B$BAnd to the west, Niuzao stands vigilantly against some of the most dangerous enemies in Pandaria.',26124),
(68450,'enUS','Once you are of revered standing with the Golden Lotus, you will be able to help the August Celestials.$B$BTo the east, Yu\'lon\'s temple is under attack by the Sha of Doubt.$B$BTo the south, Chi-Ji\'s trainees are rebuilding and retraining after the attack on their temple.$B$BTo the north, Xuen tests the might of worthy combatants who enter his rings.$B$BAnd to the west, Niuzao stands vigilantly against some of the most dangerous enemies in Pandaria.','',26124),
(68451,'enUS','Auction House services can be found in your home city.','Auction House services can be found in your home city.',26124),
(68452,'enUS','','Of course! Help yourselves.',26124),
(68453,'enUS','Wheeeeeee!','',26124),
(68454,'enUS','Whoa.... dizzy!','',26124),
(68455,'enUS','Thanks Miss Kite Lady!','',26124),
(68456,'enUS','Their leader is hold up behind this barracade. The coward. Let me know when you are ready to move in.','',26124),
(68457,'enUS','Yeah! I love this song!','',26124),
(68458,'enUS','','That\'s a pretty cool grasshopper right?  Want one of your own?',26124),
(68459,'enUS','How do I become a battle pet trainer?','How do I become a battle pet trainer?',26124),
(68460,'enUS','','You need to talk to Audrey Burnhep in Stormwind City!  Any guard there should be able to give you directions to find her.$b$bYou will find a portal to Stormwind inside the temple.  Good luck!',26124),
(68461,'enUS','','Have you ever seen so many unique pets?  Interested in catching some of your own?',26124),
(68462,'enUS','','Master Woo\'s defenses are nearing their maximum potential.  Use Touch of Death to finish her off!',26124),
(68463,'enUS','','What do you think of my pet monkey?  Pretty cool right?',26124),
(68464,'enUS','','You look like someone that might be interested in some rare pets?',26124),
(68465,'enUS','What brews do you have for sale?','What brews do you have for sale?',26124),
(68466,'enUS','I will not stand for needless violence!','',26124),
(68467,'enUS','','I\'ve been waiting to unleash this gunship against a worthy target. Let\'s spend some ammunition!',26124),
(68468,'enUS','','You need to speak with Varzok in Orgrimmar!  Any guard there should be able to give you directions to find him.$b$bYou will find a portal to Orgrimmar inside the temple.  Good luck!',26124),
(68469,'enUS','You really have it in for the Horde, don\'t you?','You really have it in for the Horde, don\'t you?',26124),
(68470,'enUS','Let me browse your wares.','Let me browse your wares.',26124),
(68471,'enUS','','<The Sky Admiral\'s face grows hard.>$b$bI grew up in Southshore. My parents are buried there - what\'s left of them.',26124),
(68472,'enUS','','These pandaren seem like good people.$b$bThey\'re reluctant to get embroiled in our war, but after a few weeks of dealing with the Horde, I have no doubt they\'ll all come around to our side.',26124),
(68473,'enUS','I\'m ready for battle! Help me focus Kaz\'tik.','I\'m ready for battle! Help me focus Kaz\'tik.',26124),
(68474,'enUS','Wh... what is that?!','',26124),
(68475,'enUS','It is so much larger than any of the Pandaren balloons... Does it belong to the outsiders?','',26124),
(68476,'enUS','Is... is it some sort of giant flying whale?','',26124),
(68477,'enUS','Cannon loaded!','Cannon loaded!',26124),
(68478,'enUS','It is worth it. I wish to augment my strength.<Pay 10,000 gold.>','It is worth it. I wish to augment my strength.<Pay 10,000 gold.>',26124),
(68479,'enUS','It is worth it. I wish to augment my intelligence.<Pay 10,000 gold.>','It is worth it. I wish to augment my intelligence.<Pay 10,000 gold.>',26124),
(68480,'enUS','Wind Lord Mel\'jarak senses more than 3 of his allies are incapacitated and frees them!','',26124),
(68481,'enUS','You may stay in our village as long as you need, stranger. Just... please try to keep your weapons sheathed.','',26124),
(68482,'enUS','So many new visitors... what is becoming of our village?','',26124),
(68483,'enUS','You, and your Alliance, are welcome in Paw\'don.','',26124),
(68484,'enUS','How can I serve?','',26124),
(68485,'enUS','We are here on a peaceful rescue mission - will you help us?','',26124),
(68486,'enUS','It has been many years since I have seen it manifest so dramatically.','',26124),
(68487,'enUS','Who? ...What? Oh! The Ook is dooked? That is fantastic! Well done heroes.','',26124),
(68488,'enUS','This one\'s on the house!','',26124),
(68489,'enUS','Ow! Ow! Ow!','',26124),
(68490,'enUS','Keep working! The general won\'t tolerate failure.','',26124),
(68491,'enUS','Get those engines running! Now!','',26124),
(68492,'enUS','Put your backs into it! You\'re the most pathetic group of goblins I\'ve ever seen!','',26124),
(68493,'enUS','','Wow - are you a $r from beyond the mists? What a crazy age we\'re living in!$b$bI just needed a moment to rest here. These steps can really take it out of you - going up OR down.',26124),
(68494,'enUS','Faster! The warchief\'s eyes are upon you.','',26124),
(68495,'enUS','Oh, nasty.','',26124),
(68496,'enUS','You okay up there?','',26124),
(68497,'enUS','Keep polishing those cannonballs. I want to see my face in them!','',26124),
(68498,'enUS','Almost there!$b$bThere\'s a cold mug of relief waiting for me at the Tavern in the Mist. I can almost taste it already...','Keep going, you\'re almost there!$b$bThis is my third trip through the pass. I wish I could say it was getting easier!$b$bWhen you get to the top, there\'s a wonderful inn called the \"Tavern in the Mist.\" Keep your weapons close, though. You\'ll run across all kinds of characters.',26124),
(68499,'enUS','I want this deck so clean I could eat off of it!','',26124),
(68500,'enUS','Careful with that! If I see a single scratch on my new ship, it\'ll be your head!','',26124),
(68501,'enUS','Pick up the pace, men. We\'re about ready to set off!','',26124),
(68502,'enUS','Over here, $n! Your gyrocopter\'s ready to go!','',26124),
(68503,'enUS','Over here, $n!','Over here, $n!',26124),
(68504,'enUS','Alright, let\'s get back to shore.','',26124),
(68505,'enUS','%s bleats at $n.','',26124),
(68506,'enUS','','Huh! Don\'t get many visitors around here. Would you like to purchase some stew, neighbor?',26124),
(68507,'enUS','That was some firefight! Now it\'s time to clean up.','',26124),
(68508,'enUS','Those that came on the Skyfire are the Alliance\'s finest. Still, there\'re some things that only the SI:7 can pull off.','',26124),
(68509,'enUS','Dozens of pilots were shot down further to the north, including one of our own SI:7 agents.$B$BWe\'ve got to help all of \'em, but we\'ve got to deal with the Horde, first.','',26124),
(68510,'enUS','Quite a lively event!\n\nI suspect our own brewmasters will attend and compete, next year.','Quite a lively event!\n\nI suspect our own brewmasters will attend and compete, next year.',26124),
(68511,'enUS','','I heard that Commander Rell and the others found Amber! That is good news.',26124),
(68512,'enUS','Knock Master Tsang\'s Assistants down with Crackling Jade Lightning.','',26124),
(68513,'enUS','','Hey there $Ghot stuff:toots;, I\'m all revved up and ready to battle!',26124),
(68514,'enUS','Refugees are flooding into Binan from all throughout the steppes. I fear the yaungol have breeched the wall!','',26124),
(68515,'enUS','','Is Sploder\'s fuse supposed to be lit? There\'s a smudge on page 7...',26124),
(68516,'enUS','Da Thunder King lives! Our empires be united once more...','',26124),
(68517,'enUS','We NEED dis land! Da cataclysm destroyed our home!','',26124),
(68518,'enUS','DESTROY...','',26124),
(68519,'enUS','Ever been to the Brewmoon Festival? It\'s a real treat. I\'m preparing a big batch of my Kun-Lai Kicker for the celebration.$b$bWant to join me in Binan Village?','',26124),
(68520,'enUS','YOUR FEEBLE ATTACKS MEAN NOTHING!','',26124),
(68521,'enUS','ARGH! THE HATRED OVERWHELMS ME!','',26124),
(68522,'enUS','Tamer ho! Prepare for battle!','',26124),
(68523,'enUS','Yer gonna be swimmin\' with the murlocs when we\'re through!','',26124),
(68524,'enUS','The burden of a king is great, as is the burden of a father. I will stop at nothing to find my son.','',26124),
(68525,'enUS','If the Horde will push us over the brink into war, then so be it.$B$BLight help me, I will fight for my kingdom and my people.$B$BGlory to the Alliance!','',26124),
(68526,'enUS','Better luck next time, landlubber!','',26124),
(68527,'enUS','Another victory for me captain\'s log!','',26124),
(68528,'enUS','Not bad for a landlubber.','',26124),
(68529,'enUS','What a fight! If ye ever decide that yer done with the battlin\' game, maybe you could join me crew!','',26124),
(68530,'enUS','Show \'em what we\'re made of! ...hic!','',26124),
(68531,'enUS','Not so fast, matey. Yer on my turf!','',26124),
(68532,'enUS','Ready to walk the plank?','',26124),
(68533,'enUS','Keep on \'em, mateys. We\'ve got \'em on the run!','',26124),
(68534,'enUS','All hands on deck! We\'re losin\' men fast!','',26124),
(68535,'enUS','Why is me pet gone?','',26124),
(68536,'enUS','Me crush you like bug!','',26124),
(68537,'enUS','Me become powerful tamer, then me become da Gordok King!','',26124),
(68538,'enUS','Me da king!','',26124),
(68539,'enUS','Gluk is da best!','',26124),
(68540,'enUS','Wow! You amazing!','',26124),
(68541,'enUS','You no ogre! How you win?','',26124),
(68542,'enUS','Nobody messes with Gluk!','',26124),
(68543,'enUS','Surprise!','',26124),
(68544,'enUS','Pet smash! You die!','',26124),
(68545,'enUS','We crush you!','',26124),
(68546,'enUS','Me angry now!','',26124),
(68547,'enUS','Stupid tiny thing kill my tiny thing. RAAAAAAAAR!','',26124),
(68548,'enUS','','You ready to go or what?',26124),
(68549,'enUS','','I don\'t have all day, pal!',26124),
(68550,'enUS','','Fight\'s over, hot stuff. Better luck next time.',26124),
(68551,'enUS','','Wait until the guys back in Everlook hear about this!',26124),
(68552,'enUS','','You\'re pretty good...for a rookie.',26124),
(68553,'enUS','','Yeah, yeah, you won. Big deal.',26124),
(68554,'enUS','','Hey, look over there!',26124),
(68555,'enUS','','Any tamer worth their weight in gold comes prepared!',26124),
(68556,'enUS','','Don\'t worry, I\'m sure the next one will do great!',26124),
(68557,'enUS','The pandaren may be strangers now, but in time, I believe they will prove to be valuable allies.','',26124),
(68558,'enUS','The death of an Explosive Hatred should destroy his shield! Quickly!','',26124),
(68559,'enUS','<All that remains of Malik the Unscathed, his polearm rests unceremoniously on a weapon rack.>','',26124),
(68560,'enUS','<Ponder the lessons of Malik.> [Klaxxi Enhancement]','<Ponder the lessons of Malik.> [Klaxxi Enhancement]',26124),
(68561,'enUS','Another stranger comes to our village... a $c by the look of it. Enter, but do not draw your weapons against us as the Horde did.','Another stranger comes to our village... a $c by the look of it. Enter, but do not draw your weapons against us as the Horde did.',26124),
(68562,'enUS','<The words of Malik echo through your mind.>$B$B\"Heroes never die.\"','',26124),
(68563,'enUS','I shiver with power! I am the lone locust of the apocalypse!','',26124),
(68564,'enUS','','Prepare for your end.',26124),
(68565,'enUS','','You will find no solace here.',26124),
(68566,'enUS','Wow... these Alliance sure do have us working hard...','Wow... these Alliance sure do have us working hard...',26124),
(68567,'enUS','These working conditions are horrible! We haven\'t had a beer break in HOURS!','These working conditions are horrible! We haven\'t had a beer break in HOURS!',26124),
(68568,'enUS','','The damned demonstrate their superiority once more.',26124),
(68569,'enUS','<He wipes the sweat from his brow.>$b$bHello there, $c. You here to help?','<She wipes the sweat from her brow.>$b$bHello there, $c. You here to help?',26124),
(68570,'enUS','So... thirsty...','So... thirsty...',26124),
(68571,'enUS','','The Master will be pleased.',26124),
(68572,'enUS','Are you here to give me my break? It feels like I\'ve been working forever!','Are you here to give me my break? It feels like I\'ve been working forever!',26124),
(68573,'enUS','I thought we were just building houses, not a fortress.','I thought we were just building houses, not a fortress.',26124),
(68574,'enUS','','My torment continues.',26124),
(68575,'enUS','I\'ve never worked this hard before in my life! I don\'t like it!','I\'ve never worked this hard before in my life! I don\'t like it!',26124),
(68576,'enUS','','No! You cannot defeat me!',26124),
(68577,'enUS','Why do these guys have so many weapons?','Why do these guys have so many weapons?',26124),
(68578,'enUS','','The dead shall have their day yet.',26124),
(68579,'enUS','','Not to worry. I\'m far from finished with you.',26124),
(68580,'enUS','You can go home now. I\'ll cover your back.','You can go home now. I\'ll cover your back.',26124),
(68581,'enUS','','Dust to dust.',26124),
(68582,'enUS','','Ashes to ashes.',26124),
(68583,'enUS','','I\'m not done yet.',26124),
(68584,'enUS','','Do you honestly think death can stop me? I am death itself!',26124),
(68585,'enUS','Come, and face the impeccable tactics of a blood knight!','',26124),
(68586,'enUS','Challenging me was a mistake.','',26124),
(68587,'enUS','None can withstand the onslaught of a blood knight.','',26124),
(68588,'enUS','Victory is mine!','',26124),
(68589,'enUS','You are a worthy opponent.','',26124),
(68590,'enUS','Curses!','',26124),
(68591,'enUS','Clearly a different approach is required.','',26124),
(68592,'enUS','A true fighter never enters a battle unprepared.','',26124),
(68593,'enUS','Let us continue the slaughter.','',26124),
(68594,'enUS','You will fall!','',26124),
(68595,'enUS','The balance swings in your favor, tamer.','',26124),
(68596,'enUS','You will not defeat me!','',26124),
(68597,'enUS','For the Alliance!','',26124),
(68598,'enUS','By the Light, I will defeat you!','',26124),
(68599,'enUS','Praise the Light!','',26124),
(68600,'enUS','It was an honor fighting you.','',26124),
(68601,'enUS','The other tamers were right about you.','',26124),
(68602,'enUS','Well done, tamer.','',26124),
(68603,'enUS','Switch out!','',26124),
(68604,'enUS','Every soldier matters.','',26124),
(68605,'enUS','My victory is close at hand.','',26124),
(68606,'enUS','Hold off the Zan\'thik while Rik\'kal the Dissector gathers his strength!','',26124),
(68608,'enUS','For the glory of the Alliance!','',26124),
(68609,'enUS','We will fight to the last!','',26124),
(68610,'enUS','I will not fail!','',26124),
(68611,'enUS','My strength returns. Speak to me, Wakener, before I report to the Klaxxi.','',26124),
(68612,'enUS','','May our battle be glorious.',26124),
(68613,'enUS','','May your pets be ready for this battle.',26124),
(68614,'enUS','','I have triumphed this day.',26124),
(68615,'enUS','','Thank you for the opportunity to demonstrate my skills.',26124),
(68617,'enUS','','Congratulations, tamer!',26124),
(68618,'enUS','','Well done, tamer!',26124),
(68619,'enUS','','Another pet joins the fray.',26124),
(68620,'enUS','','I will not let you defeat me.',26124),
(68621,'enUS','','The battle sways in my favor.',26124),
(68622,'enUS','','Victory may be mine this day.',26124),
(68623,'enUS','','I will mourn your falling.',26124),
(68625,'enUS','','This is most unfortunate.',26124),
(68626,'enUS','Here I come!','',26124),
(68627,'enUS','You ready for this?','',26124),
(68628,'enUS','Mo\'ruk wins!','',26124),
(68629,'enUS','Nobody can beat me!','',26124),
(68630,'enUS','You\'re tough!','',26124),
(68631,'enUS','OW!','',26124),
(68632,'enUS','Nuh uh!','',26124),
(68633,'enUS','Tricked ya!','',26124),
(68634,'enUS','Mo\'ruk beatin\' ya!','',26124),
(68635,'enUS','Take that!','',26124),
(68636,'enUS','Don\'t do that! That makes me lose!','',26124),
(68637,'enUS','Uh-oh...','',26124),
(68638,'enUS','','You think you stand a chance? I think not!',26124),
(68639,'enUS','Help! Help! The Horde is here!','',26124),
(68640,'enUS','Guards! The Horde is here!','',26124),
(68641,'enUS','The Horde is here! In our base!','',26124),
(68642,'enUS','Guards! Over here!','',26124),
(68643,'enUS','','You\'re going to wish you never fought me, I promise!',26124),
(68644,'enUS','Help!','',26124),
(68645,'enUS','','A bountiful victory!',26124),
(68646,'enUS','','Were my pets too much for you to handle, tamer?',26124),
(68647,'enUS','','Wow, you\'re really strong!',26124),
(68648,'enUS','','That sure turned sour quick...',26124),
(68649,'enUS','','A diligent farmer never loses hope when her crop\'s in danger.',26124),
(68650,'enUS','','Nice try, but you\'re going to need more than that!',26124),
(68651,'enUS','','What\'s the problem, can\'t handle a simple farmer\'s pets?',26124),
(68652,'enUS','','You\'re going to have to do better than that to beat me.',26124),
(68653,'enUS','I suppose it is time I headed home.','I suppose it is time I headed home.',26124),
(68654,'enUS','You\'re right. I didn\'t sign up to build a war base.','You\'re right. I didn\'t sign up to build a war base.',26124),
(68655,'enUS','Thank you, $r.','Thank you, $r.',26124),
(68656,'enUS','','Take it easy, will ya?',26124),
(68657,'enUS','Thank goodness!','Thank goodness!',26124),
(68658,'enUS','Thanks! I\'m outta here!','Thanks! I\'m outta here!',26124),
(68659,'enUS','You... you\'re not one of the Alliance? Good.','You... you\'re not one of the Alliance? Good.',26124),
(68660,'enUS','Can\'t wait to get back home.','Can\'t wait to get back home.',26124),
(68661,'enUS','Many thanks.','Many thanks.',26124),
(68662,'enUS','','You\'re really playing to win, huh?',26124),
(68663,'enUS','','We were investigating the crypt for sha corruption... and everything went horribly wrong.  Our leader, Jin Ironfist, was possessed and began killing everyone.  Even now he is in there looking for more victims.',26124),
(68664,'enUS','Prepare yourself, tamer. I come for victory.','',26124),
(68665,'enUS','You do not intimidate me, tamer.','',26124),
(68666,'enUS','','Jin\'s life was stolen by the sha - do not blame yourself for his death.  You did what I could not.',26124),
(68667,'enUS','Come back when you\'re better prepared.','',26124),
(68668,'enUS','Perhaps you will have better luck in our next encounter.','',26124),
(68669,'enUS','You fight with the grace of a master tamer. Well done.','',26124),
(68670,'enUS','You can go home to your family now.','You can go home to your family now.',26124),
(68671,'enUS','Very impressive, tamer.','',26124),
(68672,'enUS','I will not allow you the pleasure.','',26124),
(68673,'enUS','You will not defeat me so easily.','',26124),
(68674,'enUS','To defeat an opponent in battle is to validate your strategy.','',26124),
(68675,'enUS','It seems my strategy is superior.','',26124),
(68676,'enUS','Do not be afraid to lose one battle if the war is won.','',26124),
(68677,'enUS','I see. You are more formidable than I had thought.','',26124),
(68678,'enUS','I\'ve endured horrors you cannot possibly comprehend. Defeating you will be simple.','',26124),
(68679,'enUS','I\'ll make this quick.','',26124),
(68680,'enUS','I did not doubt my victory for a moment.','',26124),
(68681,'enUS','Is that all you\'ve got?','',26124),
(68682,'enUS','I will not stand for this!','',26124),
(68683,'enUS','I\'ve seriously underestimated your prowess.','',26124),
(68684,'enUS','You will have to try harder than that to defeat me.','',26124),
(68685,'enUS','You do not stand a chance. I will defeat you!','',26124),
(68686,'enUS','Had enough?','',26124),
(68687,'enUS','You are no match for me.','',26124),
(68688,'enUS','You got lucky.','',26124),
(68689,'enUS','No more playing around. I will crush you!','',26124),
(68690,'enUS','','Your victories cease here, tamer.',26124),
(68691,'enUS','','Few are able to keep their balance in battle against me. Let us see if you are any different.',26124),
(68692,'enUS','','As I expected. You are not yet skilled enough to defeat me.',26124),
(68693,'enUS','','Do not fret. You are one of many I\'ve defeated.',26124),
(68694,'enUS','','What a wonderful display of technique!',26124),
(68695,'enUS','','Your victory is well-deserved, tamer.',26124),
(68696,'enUS','','We are far from finished.',26124),
(68697,'enUS','','The Vale empowers me.',26124),
(68698,'enUS','','You may flee the battle if you so wish.',26124),
(68699,'enUS','','Fantastic!',26124),
(68700,'enUS','','Perhaps you do stand a chance against me.',26124),
(68701,'enUS','','Well done. But do you have the determination to carry through?',26124),
(68702,'enUS','So we finally meet to do battle.','',26124),
(68703,'enUS','I already know of my coming victory.','',26124),
(68704,'enUS','As the waters foretold.','',26124),
(68705,'enUS','Victory is mine!','',26124),
(68706,'enUS','Caught like a fish out of water!','',26124),
(68707,'enUS','You are quite the tamer!','',26124),
(68708,'enUS','You cannot defeat me with such brute force.','',26124),
(68709,'enUS','May the waters guide me.','',26124),
(68710,'enUS','We will overwhelm you before you can react.','',26124),
(68711,'enUS','My pets claim yet another victim.','',26124),
(68712,'enUS','There are plenty more where that came from!','',26124),
(68713,'enUS','This is not going well...','',26124),
(68714,'enUS','You have already lost.','',26124),
(68715,'enUS','I will defeat you.','',26124),
(68716,'enUS','The true master has emerged victorious.','',26124),
(68718,'enUS','All a part of my plan.','',26124),
(68719,'enUS','I have lost to your mastery.','',26124),
(68720,'enUS','I do not understand. How could I lose?','',26124),
(68721,'enUS','Rest, so that the battle may continue to flow in our favor.','',26124),
(68722,'enUS','You cannot defeat the shifting sands of this land.','',26124),
(68723,'enUS','Another death hidden under the desert sand.','',26124),
(68724,'enUS','The battle shifts in my favor once more.','',26124),
(68725,'enUS','A most frustrating occurence.','',26124),
(68726,'enUS','Perhaps this battle will not be as easy as I thought...','',26124),
(68727,'enUS','Go Emeralda! Show them the folly of their ways!','',26124),
(68728,'enUS','','Go get \'em, Fangs!',26124),
(68729,'enUS','Clean them up, Foe Reaper 800!','',26124),
(68730,'enUS','','You can do it, Flulfftail!',26124),
(68731,'enUS','Finish them, Blackfang.','',26124),
(68732,'enUS','Give \'em hell, Burgle!','',26124),
(68733,'enUS','Spike, show dem what you can do!','',26124),
(68734,'enUS','','Tear them apart, Ripper!',26124),
(68735,'enUS','','It\'s your turn, Mr. Pinch!',26124),
(68736,'enUS','Brewmaster Blanche is probably up on Thunderpaw Overlook. She\'s convinced a storm is on the way, so I\'d better make sure her equipment is ready.$b$bI can\'t imagine I\'ll ever be half the Brewmaster she is - she once casked a Spring breeze. When they uncorked it a year later at the Jade Temple, you could still smell the blossoms!','',26124),
(68737,'enUS','','Show dem pain, Constrictor.',26124),
(68738,'enUS','','Rockhide, show them your strength!',26124),
(68739,'enUS','Rasp, shoot fire!','',26124),
(68740,'enUS','','Willow, it\'s your turn to soar!',26124),
(68741,'enUS','','Nobody can beat Cluckatron!',26124),
(68742,'enUS','Alright, Blaze, let\'s roast \'em!','',26124),
(68743,'enUS','Face the fury of Ultramus!','',26124),
(68744,'enUS','','Cho\'guana, teach them a lesson.',26124),
(68745,'enUS','','Blizzy, knock \'em out cold!',26124),
(68746,'enUS','Perhaps Subject 142 will be more successful than Subject 141.','',26124),
(68747,'enUS','','Plaguebringer, show them the power of the plague!',26124),
(68748,'enUS','Face the wrath of Obsidiion!','',26124),
(68749,'enUS','Come on out, Croaker!','',26124),
(68750,'enUS','Ignious, burn \'em up for me, won\'t you?','',26124),
(68751,'enUS','','Hunt them down, Nightstalker.',26124),
(68752,'enUS','','Goliath online.',26124),
(68753,'enUS','You can do it, Fungor!','',26124),
(68754,'enUS','Stompy, show this tamer what you can do!','',26124),
(68755,'enUS','Chomps, it is your turn to demonstrate your power.','',26124),
(68756,'enUS','Arcanus, show them our endless power!','',26124),
(68757,'enUS','I believe in you, Gobbles!','',26124),
(68758,'enUS','Stitch, would you please show our upcoming tamer how we like to battle?','',26124),
(68759,'enUS','Drogar, destroy them!','',26124),
(68760,'enUS','Fleshrender kill you now.','',26124),
(68761,'enUS','Grizzle, the pride of Ironforge, come onto the field!','',26124),
(68762,'enUS','','Dor the Wall, please join us on the battlefield.',26124),
(68763,'enUS','Needleback gonna beatcha!','',26124),
(68764,'enUS','','Nobody can beat you, Toothbreaker!',26124),
(68765,'enUS','Bleat, come face this foe.','',26124),
(68766,'enUS','Come fight, Crusher.','',26124),
(68767,'enUS','','Stormlash, vanquish these foes.',26124),
(68768,'enUS','Tear em ta pieces, Fracture!','',26124),
(68769,'enUS','I call upon you, Kali.','',26124),
(68770,'enUS','Leave no trace of them, Amythel. Destroy them!','',26124),
(68771,'enUS','You stand no chance against the might of Pyth.','',26124),
(68772,'enUS','Skimmer, old friend, it is your turn to battle.','',26124),
(68773,'enUS','','Farewell stranger. When next we meet, I hope to call you friend.',26124),
(68774,'enUS','%s fades.','',26124),
(68775,'enUS','%s is depleted.','',26124),
(68777,'enUS','','Come, try again!',26124),
(68779,'enUS','<The blade hovers in the air in front of you.>','',26124),
(68780,'enUS','You a hunter? I can fix up your beast-beasts quick!','',26124),
(68781,'enUS','You have pets that need watching? I promise I will consider not eat them.','',26124),
(68783,'enUS','Yo boss, how\'s it goin\'?','',26124),
(68784,'enUS','Dis only just begun... we ain\'t gonna jes... roll over and die...','',26124),
(68785,'enUS','','SET ME FREE... THE KLAXXI CALL...',26124),
(68786,'enUS','','THE HATCHING HOUR IS NIGH... I MUST ANSWER TO THE SWARM...',26124),
(68787,'enUS','','NO... YOU WILL NOT KEEP ME INSIDE THIS ABHORRENT PRISON...',26124),
(68788,'enUS','','MAMA STORMSTOUT IS NOT HERE ANYMORE...',26124),
(68789,'enUS','|TInterface\\Icons\\inv_weapon_shortblade_37.blp:32|t  Strong Attack$b$b|TInterface\\Icons\\inv_weapon_shortblade_92.blp:32|t  Stronger Attack$b$b|TInterface\\Icons\\ability_rogue_shadowstrikes.blp:32|t  Strongest Attack','',26124),
(68790,'enUS','If it is war you mean to bring to our shores, the very land itself will respond to your passions and your violence. I do not know what the ultimate consequences will be - nobody does.','',26124),
(68791,'enUS','Get those cannons loaded!','Get those cannons loaded!',26124),
(68792,'enUS','Give \'em hell!','Give \'em hell!',26124),
(68793,'enUS','Blow that abomination out of the sky!','Blow that abomination out of the sky!',26124),
(68794,'enUS','Get those fires under control!','Get those fires under control!',26124),
(68795,'enUS','$n sets down some leftovers for hungry people.','$n sets down some leftovers for hungry people.',26124),
(68797,'enUS','|TInterface\\Icons\\trade_archaeology_delicatemusicbox.blp:20|tImperial Vizier Zor\'lok sings the |cFFFF0000|Hspell:123791|h[Song of the Empress]|h|r!','',26124),
(68798,'enUS','Enough! Survey the damage. What\'s this - an Alliance stronghold? They think to lay claim to this land already? NOT ON MY WATCH!','',26124),
(68799,'enUS','Get those engines repaired or we\'re dead in the sky. And hit that base with everything we\'ve got!','',26124),
(68800,'enUS','Haha! That\'s right. Show them Hellscream\'s fury!','',26124),
(68801,'enUS','THAT was payback for Taurajo!','',26124),
(68802,'enUS','Hah! KILL ANYTHING THAT MOVES!','',26124),
(68803,'enUS','Alliance dogs will find no refuge in this land!','',26124),
(68804,'enUS','Aim true! Send them limping back to Stormwind!','',26124),
(68805,'enUS','We\'ve softened them up. They run and hide like rats from the might of the Horde. NO QUARTER!','',26124),
(68806,'enUS','Their cowardly leader hides behind this barricade. Where are my sappers?','',26124),
(68807,'enUS','For the Horde!','',26124),
(68808,'enUS','Coward!','',26124),
(68809,'enUS','','Click on monks to knock them back.',26124),
(68810,'enUS','I need another mask, Ken-Ken.','I need another mask, Ken-Ken.',26124),
(68811,'enUS','I lost \"Scrutiny.\"','I lost \"Scrutiny.\"',26124),
(68812,'enUS','Thank you, stranger. I... have never felt like that before.','',26124),
(68813,'enUS','Life suddenly seems so much brighter.$B$BI still love sleeping, though.','Life suddenly seems so much brighter.$B$BI still love sleeping, though.',26124),
(68814,'enUS','Thank you again for your help. I will remain here briefly, to help tend the wounded.$B$BThen I will be making my way north...','',26124),
(68815,'enUS','Take me back to the present.','Take me back to the present.',26124),
(68816,'enUS','','You need only ask when you are ready to return to the present.',26124),
(68817,'enUS','I\'m ready to help you find your weapon.','I\'m ready to help you find your weapon.',26124),
(68818,'enUS','Something happening?','',26124),
(68819,'enUS','I... lost my mask. I need a new one.','I... lost my mask. I need a new one.',26124),
(68820,'enUS','$n detonated a Wind Bomb!','',26124),
(68821,'enUS','Did you know that Lin found the Hidden Master? He\'s in Paoquan Hollow.','Did you know that Lin found the Hidden Master? He\'s in Paoquan Hollow.',26124),
(68822,'enUS','She did? He is?$b$bI suppose I\'ll have to head over there then. Maybe... after a few more bites of food...','',26124),
(68823,'enUS','Lin finds the Hidden Master? Then our training can continue!$b$bOnly one thing. Ken-Ken must finish helping the sads first. Too many sads here.','',26124),
(68824,'enUS','I can\'t believe it! I was certain that he\'d be here in the Wilds.$b$bPaoquan Hollow, you say? I\'ll join her soon, and we can continue our training. For the time being, I\'ve already found an adventure of my own.','',26124),
(68825,'enUS','Yes. I knew that she could do it. She is shy, but she is strong.$b$bI shall finish my business here. Then I shall join her.','',26124),
(68832,'enUS','(A boss has been defeated in Heroic difficulty with Klaxxi Resonance enabled. It may no longer be disabled.)','',26124),
(68833,'enUS','(A boss has been defeated in Heroic difficulty with the Ritual of Purification active. It may no longer be disabled.)','',26124),
(68834,'enUS','I\'m ready to tackle those chores with you.','I\'m ready to tackle those chores with you.',26124),
(68835,'enUS','','The events that take place here will forever change this land.',26124),
(68836,'enUS','I could get used to livin\' like this.','',26124),
(68837,'enUS','','I get the feeling the negotations aren\'t going well...',26124),
(68838,'enUS','Hey, newbie! You interested in a fight?','Hey, newbie! You interested in a fight?',26124),
(68839,'enUS','Yes, sign me up for a fight!','Yes, sign me up for a fight!',26124),
(68840,'enUS','$n is our victor!','$n is our victor!',26124),
(68841,'enUS','Ouch... sorry, $n. Get back in line and try again.','Ouch... sorry, $n. Get back in line and try again.',26124),
(68842,'enUS','Now entering the arena: a Rank 1 $r $c, $n! $n is pretty new around here, so go easy!','Now entering the arena: a Rank 1 $r $c, $n! $n is pretty new around here, so go easy!',26124),
(68843,'enUS','You here to fight?','You here to fight?',26124),
(68844,'enUS','Well well well! $n wins! Looks like I owe someone some money.','Well well well! $n wins! Looks like I owe someone some money.',26124),
(68845,'enUS','Congratulations, $n! Try not to leave any bloody footprints outside of the arena.','Congratulations, $n! Try not to leave any bloody footprints outside of the arena.',26124),
(68846,'enUS','It\'s official! $n managed not to die. Great job not dying, $n!','It\'s official! $n managed not to die. Great job not dying, $n!',26124),
(68847,'enUS','Yechhh... what a mess. Can we get a priest or something over here?!','Yechhh... what a mess. Can we get a priest or something over here?!',26124),
(68848,'enUS','That... did not end well.','That... did not end well.',26124),
(68849,'enUS','$n, $n, $n. Next time, try not to die so much.','$n, $n, $n. Next time, try not to die so much.',26124),
(68850,'enUS','Can I replace something I\'ve already planted?','Can I replace something I\'ve already planted?',26124),
(68851,'enUS','Sure can! I left grandpa\'s shovel out with the rest of the tools.$B$BYou can use it to dig up a Growing crop, clearing the land to make room for something else.','',26124),
(68852,'enUS','','$n is representing Orgrimmar!',26124),
(68853,'enUS','','$n is representing the Darkspear Trolls!',26124),
(68854,'enUS','','$n is representing Thunder Bluff!',26124),
(68855,'enUS','','$n is representing Undercity!',26124),
(68856,'enUS','','$n is representing Silvermoon City!',26124),
(68857,'enUS','','$n is representing the Bilgewater Cartel!',26124),
(68858,'enUS','','$n is representing the Huojin Pandaren!',26124),
(68859,'enUS','This is $n\'s first fight ever!','This is $n\'s first fight ever!',26124),
(68860,'enUS','This is $n\'s first fight today!','This is $n\'s first fight today!',26124),
(68861,'enUS','','Also entering the arena: Bruce, a crocolisk that we found!',26124),
(68862,'enUS','','From deep within the bowels of Blackrock Mountain, it\'s Sanoriak, master of flame!',26124),
(68863,'enUS','','Also entering the arena: Kirrawk, wind-wielding arakkoa of the Terokkar Forest!',26124),
(68864,'enUS','Protect and serve.','',26124),
(68865,'enUS','Intruder alert.','',26124),
(68866,'enUS','Halt. Your presence here is not authorized.','',26124),
(68867,'enUS','Intruders detected. Engaging.','',26124),
(68868,'enUS','Activating extermination protocol.','',26124),
(68869,'enUS','Weapons systems primed.','',26124),
(68870,'enUS','You\'re next up! Unless someone cuts in front of you, that is.','You\'re next up! Unless someone cuts in front of you, that is.',26124),
(68871,'enUS','Let\'s see... you\'re second in line. Won\'t be long now.','Let\'s see... you\'re second in line. Won\'t be long now.',26124),
(68872,'enUS','Looks like you\'re third in line, $c.','Looks like you\'re third in line, $c.',26124),
(68873,'enUS','You\'re fourth in line, $r.','You\'re fourth in line, $r.',26124),
(68874,'enUS','You are the fifth person in line. Shouldn\'t be too much longer.','You are the fifth person in line. Shouldn\'t be too much longer.',26124),
(68875,'enUS','You\'re sixth in line.','You\'re sixth in line.',26124),
(68876,'enUS','You\'re seventh in the queue.','You\'re seventh in the queue.',26124),
(68877,'enUS','You\'re eighth in line, $r.','You\'re eighth in line, $r.',26124),
(68878,'enUS','You\'re ninth in line.','You\'re ninth in line.',26124),
(68879,'enUS','You are tenth in line.','You are tenth in line.',26124),
(68880,'enUS','Busy day today. There\'s at least ten people in line in front of you. Not too many more than that, though.','Busy day today. There\'s at least ten people in line in front of you. Not too many more than that, though.',26124),
(68881,'enUS','There\'s at least fifteen people waiting in line ahead of you. Hard to tell - it\'s a little busy in here right now.','There\'s at least fifteen people waiting in line ahead of you. Hard to tell - it\'s a little busy in here right now.',26124),
(68882,'enUS','Keep waiting - there\'s at least twenty people who got here before you did. Maybe more.','Keep waiting - there\'s at least twenty people who got here before you did. Maybe more.',26124),
(68883,'enUS','I think you\'re number thirty in line? Maybe forty? I lost count a while back.','I think you\'re number thirty in line? Maybe forty? I lost count a while back.',26124),
(68884,'enUS','There\'s at least fifty people in line in front of you. It\'s packed in here. I\'d wait for things to calm down a bit if you want to fight anytime in the next hour or two.','There\'s at least fifty people in line in front of you. It\'s packed in here. I\'d wait for things to calm down a bit if you want to fight anytime in the next hour or two.',26124),
(68887,'enUS','How many people are waiting in line in front of me?','How many people are waiting in line in front of me?',26124),
(68888,'enUS','Now entering the arena: an up-and-coming Rank 2 $c, $n!','Now entering the arena: an up-and-coming Rank 2 $c, $n!',26124),
(68889,'enUS','Put your hands together for $n! $n is a Rank 3 $c.','Put your hands together for $n! $n is a Rank 3 $c.',26124),
(68890,'enUS','Here\'s our challenger. Today, we welcome a Rank 4 $r $c, $n!','Here\'s our challenger. Today, we welcome a Rank 4 $r $c, $n!',26124),
(68891,'enUS','Now entering the arena, we have a very talented $c. Say hello to $n, a Rank 5 brawler!','Now entering the arena, we have a very talented $c. Say hello to $n, a Rank 5 brawler!',26124),
(68892,'enUS','Look out... here comes the deadly Rank 6 $r, $n!','Look out... here comes the deadly Rank 6 $r, $n!',26124),
(68893,'enUS','Now entering the arena: a returning champion. Our Rank 7 $c, $n!','Now entering the arena: a returning champion. Our Rank 7 $c, $n!',26124),
(68894,'enUS','Now entering the arena: You know $ghim:her;. You love $ghim:her;. Give it up for our Rank 8 Brawler, $N!!','Now entering the arena: You know $ghim:her;. You love $ghim:her;. Give it up for our Rank 8 Brawler, $N!!',26124),
(68897,'enUS','Pet battles! Here, in the Ring of Glory!','',26124),
(68898,'enUS','Tamers! Can YOUR pets best a team of the Faire\'s Finest?','',26124),
(68899,'enUS','A challenge to tamers, big and small! Can you battle my pets, and best them all?','',26124),
(68900,'enUS','Put your pets to the test, and challenge the best!','',26124),
(68901,'enUS','Will you challenge the best?$B$BWill you lose like the rest?$B$BOnly one way to find out. Dare you attempt it, $gsir:madame;?$B$BOnly a token for a try...','',26124),
(68902,'enUS','And so it begins.','',26124),
(68903,'enUS','Please enjoy the rest of your time at the Faire. Or did you want another round...?','',26124),
(68904,'enUS','Well done, well done.','',26124),
(68905,'enUS','Shall we try another...?','',26124),
(68906,'enUS','They ARE the Faire\'s finest, after all.','',26124),
(68907,'enUS','Alas! Too soon.','',26124),
(68908,'enUS','I challenge you to a pet battle! |cFF0008E8(Darkmoon Game Token)|r','I challenge you to a pet battle! |cFF0008E8(Darkmoon Game Token)|r',26124),
(68909,'enUS','The ship is about to explode.  Run to the top deck and swing away!','',26124),
(68910,'enUS','10','',26124),
(68911,'enUS','9','',26124),
(68912,'enUS','8','',26124),
(68913,'enUS','7','',26124),
(68914,'enUS','6','',26124),
(68915,'enUS','5','',26124),
(68916,'enUS','4','',26124),
(68917,'enUS','3','',26124),
(68918,'enUS','2','',26124),
(68919,'enUS','1','',26124),
(68920,'enUS','Life thrives in this jungle, $c. Birds call down from the canopy. Beasts roar out from the dark, hidden places below.$b$bAnd we, the hunters, keep them in check. It is our place - our obligation - to do so.','',26124),
(68921,'enUS','We would like to fight the Ancient Bloodcrown Crane.','We would like to fight the Ancient Bloodcrown Crane.',26124),
(68922,'enUS','We would like to fight the Krasari Elder.','We would like to fight the Krasari Elder.',26124),
(68923,'enUS','We would like to fight the Colossal Viseclaw.','We would like to fight the Colossal Viseclaw.',26124),
(68924,'enUS','Can I purchase one of your traps?','Can I purchase one of your traps?',26124),
(68925,'enUS','$n has captured an Ancient Bloodcrown Crane!','$n has captured an Ancient Bloodcrown Crane!',26124),
(68926,'enUS','$n has captured a Krasari Elder!','$n has captured a Krasari Elder!',26124),
(68927,'enUS','$n has captured a Colossal Viseclaw!','$n has captured a Colossal Viseclaw!',26124),
(68928,'enUS','$n has captured an Ancient Bloodcrown Crane!','$n has captured an Ancient Bloodcrown Crane!',26124),
(68929,'enUS','$n has captured a Krasari Elder!','$n has captured a Krasari Elder!',26124),
(68930,'enUS','$n has captured a Colossal Viseclaw!','$n has captured a Colossal Viseclaw!',26124),
(68931,'enUS','Disruptron Mk. 3R-Alpha ready for combat testing.','',26124),
(68932,'enUS','Disruptron Mk. 3R-Alpha initiating perpendicular disruptor beams.','',26124),
(68933,'enUS','Operational status: nominal.','',26124),
(68934,'enUS','Activating Tri-Phasic Disruptor Alpha.','',26124),
(68935,'enUS','Activating Tri-Phasic Disruptor Beta.','',26124),
(68936,'enUS','Activating Dual-Phasic Disruptor Alpha.','',26124),
(68937,'enUS','Activating Dual-Phasic Disruptor Beta.','',26124),
(68938,'enUS','Activating Penta-Phasic Disruptor Omega!','',26124),
(68939,'enUS','No, No, No! Turn them all on! Turn them all on!','',26124),
(68940,'enUS','Disruptron Mk. 3R-Alpha shutting down, reccommend recalibration of combat test.','',26124),
(68941,'enUS','Disruptron Mk. 3R-Alpha shutting down, combat test: successful.','',26124),
(68942,'enUS','Very well. Beware the crane\'s song... or you may find yourself too distracted to fight.','',26124),
(68943,'enUS','A word of advice: Stay close to her.','',26124),
(68944,'enUS','Disruptor Field calibration success, subject terminated.','',26124),
(68945,'enUS','Do not let the crab stand still. Its shell has hardened with age, but its joints are weak.','',26124),
(68946,'enUS','What\'s going on out there?','',26124),
(68947,'enUS','Eyes of Warding protect Zen\'shar from all damage!','',26124),
(68948,'enUS','Zen\'shar is vulnerable to damage!','',26124),
(68949,'enUS','This is not a beast you will wish to fight alone, $n. Gather allies. I will open the beast\'s cage when you believe that you are ready.','',26124),
(68950,'enUS','Turret non-functional, updating test parameters.','',26124),
(68951,'enUS','','For the glory of Hellscream!',26124),
(68952,'enUS','','You dare challenge the Kor\'kron!',26124),
(68953,'enUS','','Alliance scum!',26124),
(68954,'enUS','A $c?! I hate $cs! <Tasty though.>','',26124),
(68955,'enUS','At last! A warm-up! <Tiny Alliance person!>','',26124),
(68956,'enUS','Avenge me... Dac! <No, you avenge me... Or!>','',26124),
(68957,'enUS','I... really... hate... $rs! <Should have run... we should have run!>','',26124),
(68958,'enUS','Collecting \"distilled\" fuel.','Collecting \"distilled\" fuel.',26124),
(68959,'enUS','Gathering lumber.','Gathering lumber.',26124),
(68960,'enUS','Mining iron.','Mining iron.',26124),
(68961,'enUS','Dook...','',26124),
(68962,'enUS','MANKER!','',26124),
(68963,'enUS','The hunting is good here. Birds call down from the canopy. Beasts roar out from the dark, hidden places below.$b$bAnd we keep them in check.$b$bIt\'s our obligation as hunters - and it\'s bloody good sport, too.','',26124),
(68964,'enUS','Bo, your death ray doesn\'t work as advertised!','',26124),
(68965,'enUS','If we survive this, remind me to find a competent partner!','',26124),
(68966,'enUS','I\'m going to cover, you blow them up!','',26124),
(68967,'enUS','Pick up the slack Max, I\'m carrying you!','',26124),
(68968,'enUS','Welcome to the jungle, $n.','',26124),
(68969,'enUS','Timer start setup.... initiate!','Timer start setup.... initiate!',26124),
(68970,'enUS','GG Engineering is gonna mop the floor with your sorry mug!','',26124),
(68971,'enUS','My teammate is to blame for everything...','',26124),
(68973,'enUS','GG.','',26124),
(68974,'enUS','Beware the crane\'s song, mate. You just might find yourself too distracted to fight.','',26124),
(68975,'enUS','You want my advice? Stay close to her.','',26124),
(68976,'enUS','Keep that crab on his toes, mate. His shell might \'ave hardened with age, but his joints are weak.','',26124),
(68977,'enUS','You don\'t want to fight this beast alone, $n. Gather allies. I\'ll open the beast\'s cage when you think you\'re good and ready.','',26124),
(68978,'enUS','Sometimes I get so tense, but I can\'t speed up the time...','',26124),
(68979,'enUS','All we need is just a little patience.','',26124),
(68980,'enUS','I aint got time for the game \'cause I need you.','',26124),
(68981,'enUS','I sit here by the falls, cuz I\'d rather be alone.','',26124),
(68982,'enUS','Said woman take it slow, it\'ll come together fine...','',26124),
(68983,'enUS','You and I\'ve got what it takes to make it.','',26124),
(68984,'enUS','Was a time when I wasn\'t sure, but you set my mind at ease.','',26124),
(68985,'enUS','ATTACK!','',26124),
(68986,'enUS','Almost time to attack!','',26124),
(68987,'enUS','Can you believe these people just set out free food? This place is amazing!','',26124),
(68988,'enUS','Yes, $r?','',26124),
(68989,'enUS','My squad stands ready, $r.$b$bWe have a traditional defense that should prove effective against your Horde enemies.','',26124),
(68990,'enUS','By order of King Varian Wrynn we must prepare your defenses, Jinyu.','By order of King Varian Wrynn we must prepare your defenses, Jinyu.',26124),
(68991,'enUS','Alrighty! I think we are going to need to call in some air support for this one.','',26124),
(68992,'enUS','Demolishers? Nothing a little gnomish enginuity can\'t overcome. Send in the copters!','',26124),
(68993,'enUS','Hmm. These Demolishers seem to have a serious weakness to rockets. Send in the copters!','',26124),
(68994,'enUS','Orcs are dangerous but mounted orcs are more so. Release the hounds!','',26124),
(68995,'enUS','Wolves in captivity? We should \"rescue\" these poor animals.','',26124),
(68996,'enUS','You know, I have often thought of making a mechano-pup. We should study these wolves more closely.','',26124),
(68997,'enUS','Ah! This will give me a chance to test out my Tunnel-Tron Mk V! Hold on tight!','',26124),
(68998,'enUS','Time to get you inside the fortress. Hold on tight!','',26124),
(68999,'enUS','Time to test my new \"Fly-Diggy Wing\" upgrade! Hang on!','',26124),
(69000,'enUS','Mount up! There\'s work to be done!','',26124),
(69001,'enUS','Woops! Sorry about that.','',26124),
(69002,'enUS','Hmm. Telemetry seems to be off.','',26124),
(69003,'enUS','Note to self: Build parascope.','',26124),
(69004,'enUS','Was that a wall? That sounded like a wall.','',26124),
(69005,'enUS','This would be a lot easier if I could see.','',26124),
(69007,'enUS','I yield.  It was a worthy battle. Thank you, friend.','',26124),
(69008,'enUS','I must keep my blades sharp - the threat of the Legion is ever-present.','',26124),
(69009,'enUS','What\'s wrong, minnows? You break a scale? let\'s get moving!','',26124),
(69010,'enUS','You minnows finish early and you can go for a nice swim. How\'s that sound?','',26124),
(69011,'enUS','%s becomes enraged from the death of Fran.','',26124),
(69012,'enUS','Easy now. We don\'t want you setting one of these off prematurely...','',26124),
(69013,'enUS','Swing those hammers, squishies!','',26124),
(69014,'enUS','Better hurry it up! We don\'t wanna be here when the fighting starts.','',26124),
(69015,'enUS','Discovering the power in these shards gave me the will to drag myself out of the gutter and get my life together.$B$BOh, and also I was kicked out.','',26124),
(69016,'enUS','Four months magic-free and it feels great.$B$BWho needs the infinite mystery of the arcane when you\'ve got fresh fruit and hot tea like this?','',26124),
(69017,'enUS','These pandaren make some pretty good hooch, but none of them have heard of my favorite drink.$B$BMaybe I\'ll teach it to them some time...','',26124),
(69018,'enUS','-sniff- Woo! The old robe\'s getting a bit ripe.$B$BMaybe I can sneak a bath in that pond tonight...','',26124),
(69019,'enUS','What kind of portals will the shards allow me to open?','What kind of portals will the shards allow me to open?',26124),
(69020,'enUS','Testing, testing, 1, 2, 7. Can you hear me $p? I have deployed Scout-o-meters in the field to gather data for the Siege-o-Matic here. This should help with a proper and mostly non-lethal test of my Siege-o-Matic.','',26124),
(69021,'enUS','Goblin bombs. They have one major weakness: Other Bombs. I\'ll be right back.','',26124),
(69022,'enUS','More Goblin Bombs? It seems like only yesturday I was getting rid of a pile of goblin bombs. Wait here a moment.','',26124),
(69023,'enUS','Goblins sure do love their bombs. Let\'s go ahead and show them how a gnome makes a bomb. I\'ll be right back.','',26124),
(69024,'enUS','Small, one-time portals to a major Horde or Alliance city.$B$BThe shards all washed down the drain together, so there\'s no way for me to know which shard will end up going where. The best I can do is figure out whether they came from Sunreaver portals or Silver Covenant portals. Both sides like to put a little signature in their portal magic - typical elvish flair.$B$BI\'ll sell you shards appropriate for your faction, and you\'ll find out where they go once they\'re stabilized.','',26124),
(69025,'enUS','Sounds good.','Sounds good.',26124),
(69027,'enUS','Fire!','',26124),
(69028,'enUS','I want to buy some portal shards.','I want to buy some portal shards.',26124),
(69029,'enUS','Thank you, hero. You have granted me another chance at life.','Thank you, hero. You have granted me another chance at life.',26124),
(69030,'enUS','The mogu\'s strength is astonishing.','The mogu\'s strength is astonishing.',26124),
(69031,'enUS','If our reinforcements had arrived, we may have had a chance.','If our reinforcements had arrived, we may have had a chance.',26124),
(69032,'enUS','The mogu\'s sorcery is unlike any we have encountered before.','The mogu\'s sorcery is unlike any we have encountered before.',26124),
(69033,'enUS','I watched the mogu torture my friends. Thanks to you, I have been spared.','I watched the mogu torture my friends. Thanks to you, I have been spared.',26124),
(69034,'enUS','They crushed us as if we were ants. What monstrous power these mogu have!','They crushed us as if we were ants. What monstrous power these mogu have!',26124),
(69035,'enUS','Greetings! I am Tinkmaster Overspark, the chief architect of modern Gnomish Engineering.$b$bOur assembly bay is hard at work fashioning all sorts of great mechanical wonders to aid you in not getting stabbed, slashed, blowed up, or otherwise banished from this realm of existence.$b$bOr at least, not by our enemies.','',26124),
(69036,'enUS','','This fortress will be harder to take than Garrosh\'ar was. But sooner or later, they will break. The Horde always breaks.',26124),
(69038,'enUS','Help! Help!','',26124),
(69039,'enUS','It\'s the Horde!','',26124),
(69040,'enUS','The Horde is coming! The Horde is coming!','',26124),
(69041,'enUS','I don\'t wanna die!','',26124),
(69042,'enUS','Heeeeeelp!','',26124),
(69043,'enUS','Aaaaaahhhhhhh!','',26124),
(69044,'enUS','I never even got to meet Lady Jaina...','',26124),
(69045,'enUS','Why did I ever leave Goldshire?!','',26124),
(69046,'enUS','Wait \'till ya see me in action!','',26124),
(69047,'enUS','To arms!','',26124),
(69048,'enUS','What\'s this?!','',26124),
(69049,'enUS','Death comes for ye!','',26124),
(69050,'enUS','For Khaz Modan!','',26124),
(69051,'enUS','It\'s a traaaap!','',26124),
(69052,'enUS','Well done, squad. Dismissed!','',26124),
(69054,'enUS','Taste my blade!','',26124),
(69055,'enUS','[PH] As the Warchief commands...','',26124),
(69056,'enUS','[PH] Know what... it be time to be mountin\' up, mon.','',26124),
(69057,'enUS','[PH] It seems dere be some Saurok guardin da cave.  Let\'s take care of \'em.','',26124),
(69058,'enUS','[PH] Dat Saurok be their commander. Take him out, now!','',26124),
(69059,'enUS','Ready to get dis thing started?','',26124),
(69060,'enUS','I\'m ready. Let\'s go.','I\'m ready. Let\'s go.',26124),
(69061,'enUS','Good. You\'ve arrived. Now I can get out of here before I throw this goblin into the ocean.','',26124),
(69062,'enUS','Here\'s your escape device.','Here\'s your escape device.',26124),
(69063,'enUS','','I would have died in the Jade Forest had it not been for a pandaren mistweaver who healed my wounds after the battle.$b$bThese pandaren are good people and deserve our protection from the domination of the Alliance.',26124),
(69064,'enUS','Welcome to the war, kid.','',26124),
(69071,'enUS','','Don\'t worry, I\'ll fix you right up!',26124),
(69072,'enUS','','It\'s just a few broken bones and some internal bleeding. Nothing an icepack can\'t fix!',26124),
(69073,'enUS','','Shhh, this patient needs to rest.',26124),
(69074,'enUS','','This one is in pretty bad shape.',26124),
(69075,'enUS','','Now where did I put my Windwool Bandages?',26124),
(69076,'enUS','Do you see the size of this beast? It took nearly six of us to overpower him.','',26124),
(69077,'enUS','These mogu brutes have incredible raw strength.','',26124),
(69078,'enUS','Under the Warchief\'s orders, we will reveal all of the mogu\'s secrets.','',26124),
(69079,'enUS','I will use all the resources at my disposal to expose the source of the mogu\'s power.','',26124),
(69080,'enUS','I brought my people here at Garrosh\'s request. Little did I realize we were to be sacrificed like pawns in a game.','',26124),
(69081,'enUS','There is a difference between testing one\'s strength and blindly walking into harm\'s way. Garrosh sent us to do the latter, and this I cannot accept.','',26124),
(69082,'enUS','Has our loyalty not been tested and proven, time and again? All I hear from our Warchief\'s mouth are falsehoods and excuses.','',26124),
(69083,'enUS','Garrosh spouts on about honor and strength, but in truth our leader sees only two outcomes - either fight and survive, or be defeated and forgotten.','',26124),
(69084,'enUS','I have no use for cowards in my army. Lately, I have been questioning the blood elves\' courage, and loyalty.','',26124),
(69085,'enUS','Here on Pandaria, I see a land that the Horde deserves. We will take it for our own, and if anyone stands in our way, mogu or Alliance, we will raze them to the ground.','',26124),
(69086,'enUS','Was I wrong to assume your Blood Elves could handle themselves?','',26124),
(69087,'enUS','Your weakness is not my failing, Regent. My Horde has room only for those strong enough to stand within it.','',26124),
(69088,'enUS','Yes, and with your help, we will pry the secrets from this land. For the glory of the Horde!','',26124),
(69089,'enUS','If I must pay with some elven blood, then so be it.','',26124),
(69090,'enUS','You are too timid, Regent. Blood is the price we pay to carve our place in this world.','',26124),
(69091,'enUS','You gave us no warning about the mogu, Warchief. These statues came to life!','',26124),
(69092,'enUS','We could have, had we been given any warning. You threw my people to the wolves.','',26124),
(69093,'enUS','Do not question my loyalty, Warchief. We came across an ocean to fight for you.','',26124),
(69094,'enUS','Take care, Garrosh. You would destroy the Horde to create your perfect future.','',26124),
(69095,'enUS','I will see no more of my people\'s blood shed meaninglessly. Waste your men if you wish, Warchief, but you will waste none of mine.','',26124),
(69096,'enUS','You all head up the hill, we\'ll check for another entrance.','',26124),
(69098,'enUS','I am Destructobyte, the great usurper! And as you can see, I have found your secret plans!','',26124),
(69099,'enUS','Fools! You thought they were hidden, deep in the sands of Uldum...','',26124),
(69100,'enUS','Now, choke on your own hubris!','',26124),
(69101,'enUS','Ah- hah hah hah hah haaa!','',26124),
(69102,'enUS','My... grand creation! How DARE you?','',26124),
(69105,'enUS','Tightening the valve.','Tightening the valve.',26124),
(69107,'enUS','Show youselves, Alliance scum!','',26124),
(69108,'enUS','I can smell you, $pr. Come and fight!','',26124),
(69109,'enUS','Get out here, or we start beating these laborers!','',26124),
(69110,'enUS','We\'ll run every last one of you fools from this land!','',26124),
(69111,'enUS','This jungle will soon be cleansed of Alliance filth!','',26124),
(69112,'enUS','It\'s your turn to die!','',26124),
(69113,'enUS','Come, children, feast on their flesh!','',26124),
(69114,'enUS','You dare disturb the Saurok brood? That is punishable by death.','',26124),
(69115,'enUS','Arrrrggggghhh!','',26124),
(69116,'enUS','Ugh, my back! You\'ll pay for that!','',26124),
(69117,'enUS','[PH] Water. I hate water, mon. CALL IN DA BOAT!','',26124),
(69118,'enUS','[PH] Boat Ride Over!','',26124),
(69119,'enUS','[PH] Get in da boat, mon!','',26124),
(69120,'enUS','Jinyu Construction Site Under Attack!','Jinyu Construction Site Under Attack!',26124),
(69121,'enUS','','Use the Guardian\'s Light to stop the Dark Summoner\'s minions!',26124),
(69122,'enUS','','Hero, you must defeat the Dark Summoner\'s minions in order to weaken his protective magic.  Until then he will be invulnerable.',26124),
(69123,'enUS','The Dark Summoner is vulnerable for a short time, now\'s your chance!','',26124),
(69124,'enUS','The Dark Summoner\'s protective magics are active once again.','',26124),
(69125,'enUS','The Darkhatched Lizard-Lord calls for help!','',26124),
(69126,'enUS','[PH] Kite him through da statis trap, mon!','',26124),
(69127,'enUS','The Darkhatched Lizard-Lord prepares to unleash a group of Water Jets!','',26124),
(69128,'enUS','[PH] It\'s protectin\' dem eggs! Crack its skull, mon.','',26124),
(69129,'enUS','We\'ll never finish in time! Can\'t we make them go faster?','We\'ll never finish in time! Can\'t we make them go faster?',26124),
(69130,'enUS','You have some spare commissions you\'d like to spend? I\'ll take them off your hands.$b$bWhat would you like to buy?','',26124),
(69131,'enUS','%s has hired a mage!','%s has hired a mage!',26124),
(69132,'enUS','%s has hired a paladin!','%s has hired a paladin!',26124),
(69133,'enUS','%s has hired a priest!','%s has hired a priest!',26124),
(69134,'enUS','%s has hired a druid!','%s has hired a druid!',26124),
(69135,'enUS','%s has hired a warrior!','%s has hired a warrior!',26124),
(69136,'enUS','%s has hired a rogue!','%s has hired a rogue!',26124),
(69137,'enUS','%s has hired a shaman!','%s has hired a shaman!',26124),
(69138,'enUS','%s has fueled a portal from Domination Point to Sparkrocket Outpost!','%s has fueled a portal from Domination Point to Sparkrocket Outpost!',26124),
(69139,'enUS','Hmm, perhaps there is something...$b$bWe were just about to dine when you delivered the king\'s command. I imagine a little sustenance might provide some extra energy.$b$bAlso, come to think of it, we could use a little more wood for our spikes. Perhaps you could collect some?$b$bThen... well there\'s... oh, nevermind.','',26124),
(69140,'enUS','%s has fueled a portal to the Shrine of Two Moons!','%s has fueled a portal to the Shrine of Two Moons!',26124),
(69141,'enUS','%s has fueled a portal to Orgrimmar!','%s has fueled a portal to Orgrimmar!',26124),
(69142,'enUS','%s has purchased a banquet!','%s has purchased a banquet!',26124),
(69143,'enUS','Time is running out! Tell me!','Time is running out! Tell me!',26124),
(69144,'enUS','%s has hired guards to protect the graveyard!','%s has hired guards to protect the graveyard!',26124),
(69145,'enUS','%s has hired guards to protect the tower!','%s has hired guards to protect the tower!',26124),
(69146,'enUS','Hire a shaman for a spell haste bonus.','Hire a shaman for a spell haste bonus.',26124),
(69147,'enUS','Extend our mage\'s contract.','Extend our mage\'s contract.',26124),
(69148,'enUS','Extend our paladin\'s contract.','Extend our paladin\'s contract.',26124),
(69149,'enUS','Extend our priest\'s contract.','Extend our priest\'s contract.',26124),
(69150,'enUS','Extend our druid\'s contract.','Extend our druid\'s contract.',26124),
(69151,'enUS','Extend our warrior\'s contract.','Extend our warrior\'s contract.',26124),
(69152,'enUS','Extend our rogue\'s contract.','Extend our rogue\'s contract.',26124),
(69153,'enUS','Extend our shaman\'s contract.','Extend our shaman\'s contract.',26124),
(69154,'enUS','Oh, alright. If you insist.$b$bYou see, $r, legends tell of an ancient mogu artifact in this region - a richly ornamented sceptre. It is said that the one who wields this treasure will have the love and devotion of those who serve him. That or fear and respect, I forget which.$b$bEither way, it couldn\'t hurt. Hmm?','',26124),
(69155,'enUS','I\'ve found your precious sceptre. Hurry, take it!','I\'ve found your precious sceptre. Hurry, take it!',26124),
(69156,'enUS','We can maintain a two-way portal to Sparkrocket Outpost, as well as one-way portals to the Orgrimmar and the Shrine of Two Moons.$b$bWhat kind of mercenary would you like to fuel?','',26124),
(69157,'enUS','The portal to Sparkrocket Outpost.','The portal to Sparkrocket Outpost.',26124),
(69158,'enUS','The portal to Orgrimmar.','The portal to Orgrimmar.',26124),
(69159,'enUS','The portal to the Shrine of Two Moons.','The portal to the Shrine of Two Moons.',26124),
(69161,'enUS','Who dares disturb the Korune? You shall pay for your insolence!','',26124),
(69162,'enUS','I would love to walk on the water.','I would love to walk on the water.',26124),
(69163,'enUS','The statue appears to be of an ancient Mogu emperor.','',26124),
(69164,'enUS','It seems as though this cave used to contain powerful Mogu magic.','',26124),
(69165,'enUS','','Look at you! HAH!',26124),
(69166,'enUS','','Ah... you\'re smarter than you appear, I see.',26124),
(69167,'enUS','[PH] This is da place, mon. Look around, tell me what chu find...','',26124),
(69168,'enUS','[PH] Ohh... this be black magic, mon... this kind of abuse... tis not da way of the Horde. Let\'s leave, quickly.','',26124),
(69169,'enUS','[PH] *weakly* Hurry, flee from here. Tell da Warchief that ol\' Vol\'jin is... dead.','',26124),
(69170,'enUS','[PH] It looks like we\'ve found the source!  Look around and see if you can find what we came here for.','',26124),
(69171,'enUS','[PH] Garrosh told us you couldn\'t be trusted.','',26124),
(69172,'enUS','Don\'t.... move...','',26124),
(69173,'enUS','Don\'t look up!','',26124),
(69174,'enUS','[PH] You may have slain my men, but you won\'t stop me, old troll!','',26124),
(69175,'enUS','%s stabs Vol\'jin in the neck.','',26124),
(69176,'enUS','[PH] We can\'t abuse this power.  A Horde dat would use this isn\'t da Horde I signed up for.','',26124),
(69177,'enUS','','Oh! Brann, jus\' look at this claw! I have a creepin\' suspicion that these mogu are meddlin\' with some dark magic.',26124),
(69178,'enUS','Hmm... according to this codex, the Korune mogu are attempting to harness the very power of the sha. This map shows us their very location! Well done, $n. You have helped us enough for today.','',26124),
(69179,'enUS','I hear you, Hilda. Mogu mixin\' up with sha? I don\'t like that one bit! We\'d better bring this evidence back to the King. $n, thanks fer yer help today, but we\'ll take it from here!','',26124),
(69180,'enUS','Pandaria. Land of opportunity. Time to get rich or get bent.','',26124),
(69181,'enUS','Well, well, well. $p. I figured I best not be here in person. Don\'t want to give your ambition any ideas.','',26124),
(69183,'enUS','We\'re here on a research and excavation mission. No gettin\' into trouble, I promise!','',26124),
(69184,'enUS','Can you believe those Reliquary blood elves beat us here? We can\'t let them go on excavatin\' our artifacts!','',26124),
(69185,'enUS','','The mogu are an ancient civilization spanning back thousands of years. Perhaps we can learn somethin\' from \'em!',26124),
(69186,'enUS','','Oh, are ye one o\' Brann\'s friends? Betcha didn\'t know that back in archaeology school, he used to copy MY notes!',26124),
(69187,'enUS','','There are many o\' us in the Explorer\'s League who stay in the library, cataloguing and analyzing all of our findings.$B$BI spent the last five years doin\' just that while Brann went out into the world, caperin\' from one inneresting site to another.$B$BWell Hilda\'s finally back in the field, and it\'s about time I find somethin\' BIG!',26124),
(69188,'enUS','','Any report from Lion\'s Landing, $c?',26124),
(69189,'enUS','','I didn\'t think this mission would amount to much, but the blood elves\' presence has us all on high alert.',26124),
(69190,'enUS','','I\'ve never been fascinated by ancient artifacts, but this mission has proven more dangerous than I thought.',26124),
(69191,'enUS','','I have a bad feeling about the mogu\'s presence.$B$BThere can only be one reason why they\'re excavating these mogu artifacts, and it\'s not for knowledge.$B$BThey\'re looking for clues to the mogu\'s power.',26124),
(69192,'enUS','','Back at the barracks, I heard murmurings of this \"sha.\"$B$BYou should have heard the crazy stories - sha possessing our strongest troops? Simply tales to scare children.$B$BThe sha are nothing that I and my sisters cannot handle.',26124),
(69193,'enUS','So far, so quiet. We\'re lying low around those blood elves.','',26124),
(69194,'enUS','I scouted the ruins. The blood elves are here in full force.','',26124),
(69195,'enUS','I have fought by Sarannha\'s side for as long as I can remember. She is fierce in battle, and I watch her back.','',26124),
(69196,'enUS','What?','',26124),
(69197,'enUS','[PH] It looks like you all could use some help getting through this cave.  I\'ve been working on some modifications to my boat here...','',26124),
(69198,'enUS','A little help over here! Somethin\' is wrapped around the propeller!','',26124),
(69199,'enUS','You must be purged from this land.','You must be purged from this land.',26124),
(69200,'enUS','Your Alliance is not welcome here.','Your Alliance is not welcome here.',26124),
(69201,'enUS','For the Horde!','For the Horde!',26124),
(69202,'enUS','You will be crushed!','You will be crushed!',26124),
(69203,'enUS','Pandaria is ours!','Pandaria is ours!',26124),
(69204,'enUS','','Get... off... my... SHIP!',26124),
(69205,'enUS','','I will NOT have Horde on my ship!',26124),
(69206,'enUS','','The Defiant is mine! Stand down or die!',26124),
(69207,'enUS','[PH] Dis cave be lookin dangerous. You three split up, one of you man dis cannon here and de rest of you split up in de caves.','',26124),
(69208,'enUS','At last! An up close fight!','',26124),
(69209,'enUS','Face your death!','',26124),
(69210,'enUS','You think you know savagry?!','',26124),
(69211,'enUS','Die, Alliance scum!','Die, Alliance scum!',26124),
(69212,'enUS','You will not interfere with our research!','You will not interfere with our research!',26124),
(69213,'enUS','I will end you swiftly, $r!','I will end you swiftly, $r!',26124),
(69214,'enUS','[PH] Use dese to heal yourself, mon!','',26124),
(69215,'enUS','[PH] Use dis to heal yourself, mon!','',26124),
(69217,'enUS','','Not bad, $c. Our work here is finished for today, but stay sharp. I wouldn\'t be surprised if your next orders came from Lion\'s Landing in a few days\' time.',26124),
(69218,'enUS','','Good work, $c. These blood elves are actively researching the mogu. It\'s clear that Garrosh is searching for artifacts of power, but we won\'t let him succeed.',26124),
(69219,'enUS','Hmm... according to this codex, the Korune mogu are attempting to harness the very power of the sha. And now we know exactly where they are doing so. Well done, $n.','',26124),
(69220,'enUS','It is clear to me that these mogu deserve more investigation. Our work here is done for today, $n. If we have need of you, we will contact you at Domination Point.','',26124),
(69221,'enUS','Thank you for your assistance, $n. You have helped me enough for today. I shall seek you at Domination Point if I have further need of you.','',26124),
(69222,'enUS','Thank you for your assistance, $n. As the leader of the blood elves, it is my duty to protect my people. It is not a responsibility to be taken lightly.','',26124),
(69223,'enUS','','$p, report for duty immediately!',26124),
(69224,'enUS','GG, Alliance wins!','',26124),
(69225,'enUS','GG, Horde wins!','',26124),
(69228,'enUS','Just look at this place, Malkorok. THIS is the prosperity that our people deserve!','',26124),
(69229,'enUS','Tell me again the names of those who built this kingdom.','',26124),
(69230,'enUS','Indeed? It appears I have much to learn from these \"mogu.\"','',26124),
(69231,'enUS','The mogu, Warchief. In the tome of pandaren history, they are written as cruel, relentless leaders. They were feared, not loved.','',26124),
(69232,'enUS','What is it, $c?','',26124),
(69234,'enUS','This place is to warm and sticky and smells of bad fortune.','',26124),
(69235,'enUS','The Mercurial Guardian comes to life!','',26124),
(69236,'enUS','W-What\'s happening? It\'s coming alive!','W-What\'s happening? It\'s coming alive!',26124),
(69237,'enUS','We got work to do, $c. This forest isn\'t going to chop itself down!','',26124),
(69238,'enUS','Deforestation is such a nasty word. I prefer to think of it as clearing the view!$b$bHow could anyone see the ocean through all those trees?!','',26124),
(69239,'enUS','I\'m thinkin\' of opening a lumber depot here.$b$bAll these trees just sittin\' around waiting to get chopped down. I would be a fool to pass up this opportunity!','',26124),
(69240,'enUS','Don\'t worry about the trees. It\'s the circle of life! They grow, we chop \'em down, and then we use \'em to build things!$b$bI guess that\'s less of a circle, and more of a line...','',26124),
(69242,'enUS','My first field test of this technology went better than expected!  Take this with you, it should be useful against any more swarms you run into.','',26124),
(69243,'enUS','The nice thing about trees is they always grow back. This is what you would call sustained income!','',26124),
(69244,'enUS','','They break it and I fix it! It\'s a very symbiotic relationship.',26124),
(69245,'enUS','','My theory is there isn\'t anything that can\'t be fixed with fire!',26124),
(69246,'enUS','','Can\'t you see I\'m busy over here!',26124),
(69247,'enUS','','We all have a job to do, $c. Just, some do it better than others!',26124),
(69248,'enUS','','This rig is a fine piece of machinary. I\'ve actually formed quite the bond with it. I even nicknamed it Bruce!$b$bIt just doesn\'t work right all the time, it\'s a little leaky, and it\'s probably a hazard to anyone within 10 miles of it.',26124),
(69249,'enUS','','These bots are what I will go down in history for inventing.$b$bSure there are a few side effects, but this is at least a better sollution than how we used to handle spiders.$b$bAfter awhile burning down your home just doesn\'t seem practical!',26124),
(69250,'enUS','','Shredders used to be so simple to work on. They have this new operating system now though. Darn thing crashes every five minutes!',26124),
(69251,'enUS','','It aint easy bein\' this classy, but someone\'s gotta do it!',26124),
(69252,'enUS','','I should start chargin\' people to be in my presence.',26124),
(69253,'enUS','','Not just anyone can be the boss ya know! It takes skill, brains, and of course looks!',26124),
(69254,'enUS','','People are always accusin\' me of using my family connections to get promoted. I choose to see it as using my resources wisely.$b$bBesides, what else would I use my family for?',26124),
(69255,'enUS','You have some spare commissions you\'d like to spend? I\'ll take them off your hands.$b$bWhat would you like to buy?','',26124),
(69256,'enUS','A swarm of Mantid appear from nearby and attack!','',26124),
(69257,'enUS','You should consider yourself lucky to be doin\' the Boss-Lady\'s chores!','',26124),
(69258,'enUS','','What can I do for ya, $g handsome:missie;?',26124),
(69259,'enUS','We must let no Horde escape this place. Any ideas?','We must let no Horde escape this place. Any ideas?',26124),
(69260,'enUS','The Mercurial Guardian\'s skin becomes as hard as silver!','',26124),
(69261,'enUS','','Oh, we know just the thing....',26124),
(69262,'enUS','','Squad! Initiate Operation: Cackleberry!',26124),
(69263,'enUS','Enough! Time to meet your end, invaders!','',26124),
(69264,'enUS','If I am correct, $n, then this... Divine Bell... is exactly the type of weapon that Garrosh is looking for. Return to your other duties for now. I will bring this information to the Warchief myself.','',26124),
(69265,'enUS','','Seems we\'re a little low on oil. Just keep your eyes peeled for snakes and we should be fine.',26124),
(69266,'enUS','','The crew\'s lookin\' a touch low on fuel. There anything safe to eat in these parts?',26124),
(69267,'enUS','','Things would go faster with more iron... maybe there are some deposits around here.',26124),
(69268,'enUS','','I documented some special schematics in my journal, but it\'s gone missin\'. We\'ll just hafta make do.',26124),
(69269,'enUS','','Come on, you lollygaggers! Let\'s pick up the pace!',26124),
(69270,'enUS','','If pappy could see me now... runnin\' my own crew in service to the king. He\'d be gushin\' with pride.',26124),
(69271,'enUS','%s has conjured a portal from Lion\'s Landing to the Skyfire!','%s has conjured a portal from Lion\'s Landing to the Skyfire!',26124),
(69272,'enUS','%s has conjured a portal to the Shrine of Seven Stars!','%s has conjured a portal to the Shrine of Seven Stars!',26124),
(69273,'enUS','%s has conjured a portal to Stormwind!','%s has conjured a portal to Stormwind!',26124),
(69274,'enUS','... what do you want?','',26124),
(69275,'enUS','What can you tell me about this tome?','What can you tell me about this tome?',26124),
(69276,'enUS','Hmm... I recall seeing such script on the Nathrezim homeworld. I cannot read it and I doubt any of your kind could either.','',26124),
(69277,'enUS','','Hello Master... what kind of service can I provide you today... ?',26124),
(69278,'enUS','','What? You just want me to look at some dirty old tome? Ugh, how disappointing. $B$BThis is the script of the Nathrezim, what you call Dreadlords. They rarely use it outside of their home.',26124),
(69279,'enUS','','What do YOU want, you miserable excuse for a $r?',26124),
(69280,'enUS','','No. I won\'t help your kind read an ancient Nathrezim text. Now, release me!!',26124),
(69281,'enUS','... yeah? Sup, boss?','',26124),
(69282,'enUS','Hmm... I have no idea.','',26124),
(69283,'enUS','Dismiss me... I wish to return to the void.','',26124),
(69284,'enUS','Words are not the way of the void. I do not know... it appears to connect two... stars together...','',26124),
(69285,'enUS','You wish to speak with me...? Unusual...','',26124),
(69286,'enUS','I cannot read the words... but the magic points to a world that exists no longer. It was destroyed by the Legion.','',26124),
(69287,'enUS','It looks at you blankly.','',26124),
(69288,'enUS','The felhunter just tilts its head and stares at you strangely.','',26124),
(69289,'enUS','Ah, $gMaster:Mistress; $n, how might I be of assistance?','',26124),
(69290,'enUS','Of course! This codex is written in the ancient Nathrezim tongue. Nathrezim, or the Dreadlords, as you call them, were once an enlightened and powerful race. Their skill in summoning and gateway magics was unsurpassed by any in the Great Dark Beyond. $B$BThis particular tome contains instructions to open a gateway to another world. Sadly, I fear that world no longer exists. It was destroyed as a show of power during the enslavement of Xoroth.$B$BThe tome is useless, I\'m afraid. No $r $c could open such a gateway alone.','',26124),
(69291,'enUS','I had no idea you were so well-informed.','I had no idea you were so well-informed.',26124),
(69292,'enUS','It is the way of the Observer to bear witness to all things that come to pass. So many delicious magics have I tasted at your side, $gmaster:mistress;.','',26124),
(69293,'enUS','Fascinating...','Fascinating...',26124),
(69294,'enUS','Goob help!','',26124),
(69295,'enUS','','\'Sweet child\', pappy\'d always call me. Well, what we\'re plannin\' for these Horde vermin ain\'t so sweet!',26124),
(69296,'enUS','Don\'t need Goob\'s help?','',26124),
(69297,'enUS','Ok. Goob go back to Zino.','',26124),
(69298,'enUS','Goob and friend did good!','',26124),
(69299,'enUS','My life for the Horde.','',26124),
(69300,'enUS','We\'ll never finish in time! Can\'t we make them go faster?','We\'ll never finish in time! Can\'t we make them go faster?',26124),
(69301,'enUS','[PH] De Saurok been created by da Mogu?','',26124),
(69302,'enUS','','I was startin\' to think you\'d never ask!$b$bWe\'ll get \'er done eventually, but there\'s plenty you can do to help.$b$bWe gnomes have a high metabolism - and it only gets higher when we\'re hard at work. Food will always be welcome.$b$bThen there\'s oil. These traps are tricky enough without having to worry about gears jamming. Bring us any oil ya find out there.$b$bOutside\'a that, just keep us safe!$b$b<Rosey looks aways for a moment, then whispers.>$b$bTh-there might be one other thing...',26124),
(69303,'enUS','[PH] Get them!','',26124),
(69304,'enUS','Well? What is it?','Well? What is it?',26124),
(69305,'enUS','[PH] Get into da big bad voodoo zones mon\'! It\'ll shield you from his powa!','',26124),
(69306,'enUS','','<Rosey fights back tears as she speaks.>$b$bMy... my journal. It\'s gone missin\'.$b$bIt\'s mostly full of memories of my pappy, and his endless search for the perfect place to build his paradise city. It was to be the pinnacle of gnomish engineering!$b$bAnyway, one of his old schematics might actually be useful here. Please let me know if ya find it somewhere in all this thick green grass.',26124),
(69307,'enUS','Is this your journal, Rosey?','Is this your journal, Rosey?',26124),
(69308,'enUS','[PH] Are they gone?','',26124),
(69309,'enUS','','What? Ya found it! Wahoo! I\'ll get right to work!',26124),
(69310,'enUS','','Well whaddya know? It worked!',26124),
(69311,'enUS','Gnome Construction Site Under Attack!','Gnome Construction Site Under Attack!',26124),
(69312,'enUS','That doesn\'t sound good!','',26124),
(69313,'enUS','Ah! I forgot to reverse the bipolar collaboration inverter.','',26124),
(69314,'enUS','|TInterface\\Icons\\inv_misc_bomb_01.blp:20|tYou are the target of |cFFFF0000|Hspell:133925|h[Bombs]|h|r! Run!','',26124),
(69315,'enUS','Interpreting program \"Hello World\". Line 1: Blow up in enemy\'s face.','',26124),
(69316,'enUS','Error: Attempt to write to protected memory. Resolution: Move at enemy and self-destruct.','',26124),
(69317,'enUS','Null Pointer Exception. Self-destruct protocol initiated.','',26124),
(69318,'enUS','Error: Divide by zero. Resolution: SELF DESTRUCT INITIATED.','',26124),
(69319,'enUS','Hash table collision detected. Resolution: SELF-DESTRUCT.','',26124),
(69320,'enUS','Oh! Orders! Let\'s see here... Self Destruct?!','',26124),
(69321,'enUS','Hmm, looks like I\'ve been programmed to... <sigh> Self-Destruct.','',26124),
(69322,'enUS','Oh boy! A new program! Let\'s see here... BLOW MYSELF UP?!','',26124),
(69323,'enUS','Alright, let\'s check the ol\' programming... SELF DESTRUCT?!','',26124),
(69324,'enUS','Well, it was nice knowing you.','',26124),
(69325,'enUS','Uh... later!','',26124),
(69326,'enUS','I wonder what exploding feels like?','',26124),
(69327,'enUS','And... I\'m OUTTA HERE!','',26124),
(69328,'enUS','Self Destructing is SO COOL.','',26124),
(69329,'enUS','What? Here? Now? We\'re in a battle!$b$bAs much as I love your enthusiasm to learn the wonders of Gnomish Engineering this really is a conversation best saved for when we are back under the protection of Tinkertown\'s walls in Ironforge.','',26124),
(69330,'enUS','Very well. I wish to talk about something else.','Very well. I wish to talk about something else.',26124),
(69331,'enUS','Free! Free at last after ten thousand years! This a happy day! Very happy happy day! Gonna need biggest party ever! With nibs! And dibs! And brews! And jungle hozen! And mountain hozen! And sky hozen!','',26124),
(69332,'enUS','No! Stay... away!','No! Stay... away!',26124),
(69333,'enUS','D-don\'t come any closer!','D-don\'t come any closer!',26124),
(69334,'enUS','I don\'t feel so good...','I don\'t feel so good...',26124),
(69335,'enUS','Unngh... my head... it hurts!','Unngh... my head... it hurts!',26124),
(69336,'enUS','W-what happened? I couldn\'t control my own body.','W-what happened? I couldn\'t control my own body.',26124),
(69337,'enUS','I dreamt that I turned into a monster. Good thing you woke me.','I dreamt that I turned into a monster. Good thing you woke me.',26124),
(69338,'enUS','Thank you for saving me from that nightmare. I wanted to rip everything apart!','Thank you for saving me from that nightmare. I wanted to rip everything apart!',26124),
(69339,'enUS','I don\'t know what came over me. Thank you for clearing my head.','I don\'t know what came over me. Thank you for clearing my head.',26124),
(69340,'enUS','Thank you for saving me, soldier. You too, young prince.','Thank you for saving me, soldier. You too, young prince.',26124),
(69341,'enUS','I fought against the anger, but it overwhelmed me. You have my thanks.','I fought against the anger, but it overwhelmed me. You have my thanks.',26124),
(69342,'enUS','Goremaw has arrived!','Goremaw has arrived!',26124),
(69343,'enUS','Researcher Morian has arrived!','Researcher Morian has arrived!',26124),
(69344,'enUS','|TInterface\\Icons\\inv_sword_2h_mantid_01.blp:20|t%s equips his |cFFFF0000Sword|r!','',26124),
(69345,'enUS','|TInterface\\Icons\\inv_misc_bomb_01.blp:20|t%s equips his |cFFFF0000Bombs|r!','',26124),
(69346,'enUS','|TInterface\\Icons\\inv_knife_1h_mantid_02.blp:20|t%s equips his |cFFFF0000Daggers|r!','',26124),
(69347,'enUS','','Can\'t you see I\'m busy?',26124),
(69348,'enUS','We have... more important matters to attend to than you. Go away, scum.','',26124),
(69349,'enUS','Be ready for anything, $n. We may have to use force against our own men.','',26124),
(69350,'enUS','We struck liquid gold with this place, $c! All we had to do was tear down some useless trees and clear out some pesky animals!','',26124),
(69351,'enUS','... I\'ve seen the fear in your eyes, Jubeka.','',26124),
(69352,'enUS','','What is it you wished to show me...?',26124),
(69353,'enUS','Gul\'dan destroyed this world in his bid for power... you\'re concerned I will do the same to Azeroth.','',26124),
(69354,'enUS','','What...? No! I.. I have... no idea...',26124),
(69355,'enUS','','No! Stay back...! You... you\'re dangerous. I remain content summoning demons, but you...',26124),
(69356,'enUS','','...you toy with becoming one yourself!',26124),
(69357,'enUS','...','',26124),
(69358,'enUS','There are two sides to the blade of demonology...','',26124),
(69359,'enUS','... the threats that besiege us from the outside...','',26124),
(69360,'enUS','... and those that threaten us from within.','',26124),
(69361,'enUS','I chose you as my companion for a reason.','',26124),
(69362,'enUS','... If I fail, I need you to banish me forever.','',26124),
(69363,'enUS','','And what depraved reason is that...?',26124),
(69364,'enUS','I tire of your evasive babble, doomguard. Explain to me why you and your kind are drawn to sacrificial magics.','',26124),
(69365,'enUS','My contract is to fight for you, not to reveal the Legion\'s secrets, mortal.','',26124),
(69366,'enUS','Do not attempt to deceive me, demon!','',26124),
(69367,'enUS','Your kind far predates Sargeras\'s betrayal. What WERE you?','',26124),
(69368,'enUS','','This knowledge is useless... what are you trying to achieve, Kanrethad?',26124),
(69369,'enUS','STAY OUT OF THIS! The demon will answer, NOW!','',26124),
(69370,'enUS','What an odd demand. Not even my own kind care about our origins. Why should you?','',26124),
(69371,'enUS','If you do not care then there is no harm telling me.','',26124),
(69372,'enUS','... before Sargeras freed us, we were the Titan\'s hounds. Forever enslaved to police the use of arcane magics.','',26124),
(69373,'enUS','Sacrificial magic was considered the greatest violation of life and we were attuned to instantly punish those who delved into such... delicious sorcery.','',26124),
(69374,'enUS','You have your petty secret, Kanrethad. Now, I demand knowledge from you... why do you care?','',26124),
(69375,'enUS','I don\'t believe that is part of our contract. We are done here.','',26124),
(69376,'enUS','Jubeka, complete the ritual.','',26124),
(69377,'enUS','Orders, your majesty?','Orders, your majesty?',26124),
(69378,'enUS','Good to see you again, $n.$b$bTake the laborers from camp here, and any others you can find in the region. Assist them in building defenses to ensure no Horde can escape our vengeance.$b$bOne more thing. These troops are not trained for battle and must be protected from harm if they are to succeed.$b$bNow go, and be quick about it. Time is running out!','',26124),
(69379,'enUS','','Such strange creatures. Why do they remain so long after the Legion has left?',26124),
(69380,'enUS','...there\'s a slight flaw in that supposition.','',26124),
(69381,'enUS','The observers were in the service of Illidan... not the Legion.','',26124),
(69382,'enUS','','Oh?',26124),
(69383,'enUS','','Well, he\'s gone too... so why are they still around?',26124),
(69384,'enUS','How should I know?','',26124),
(69385,'enUS','','Well, I\'ve spent weeks trying to understand how to summon one of these things. If you know something I don\'t, I\'d appreciate it if you\'d share it with us \"lesser\" mortals.',26124),
(69386,'enUS','What\'s the problem? You handled the binding of the fel imps and voidlords effortlessly.','',26124),
(69387,'enUS','','They were trivial by comparison! These things are never in the same place.',26124),
(69388,'enUS','','There\'s something... strange about them... something out of place...',26124),
(69389,'enUS','','Oh dear...',26124),
(69390,'enUS','More elves to slaughter!','',26124),
(69391,'enUS','My life for the Horde!','',26124),
(69392,'enUS','Heads up, boys. More tin-men comin\' our way!','',26124),
(69393,'enUS','There\'s oil here alright, and we\'re gonna need it!','',26124),
(69394,'enUS','Aggra, I should not be long. The Darkspear are a strong people and I doubt they have much need of my assistance.','',26124),
(69396,'enUS','Very well my beloved. Come friend, let us ride to the home of the Darkspear.','',26124),
(69397,'enUS','Aye, $g lad:lass;. What can we be doin\' fer yeh?','',26124),
(69398,'enUS','Lead on, friend. It\'s time to set up your defenses!','Lead on, friend. It\'s time to set up your defenses!',26124),
(69399,'enUS','Mount up, lads! Time ta go an\' earn our ale.','',26124),
(69400,'enUS','A pitiful skirmish! The Alliance fights without conviction.','',26124),
(69401,'enUS','Hold this ground, Blood Guard. Here is where we will build our keep. Expect peons within the hour, and be ready to motivate them.','',26124),
(69402,'enUS','I didn\'t come to save your sorry hide, goblin. Did you find fuel or not?','',26124),
(69403,'enUS','Kor\'kron? Here? What has Garrosh been up to?','',26124),
(69404,'enUS','Have I been away so long that you have forgotten who I am?','',26124),
(69405,'enUS','I know you will. I\'m sending in grunts to make sure of it.','',26124),
(69406,'enUS','I never thought the Warchief himself would come to bail me out!','',26124),
(69407,'enUS','Y-yes sir! We struck it big. There\'s crude all along the coast. We\'ll get an operation going right away, your hugeness!','',26124),
(69408,'enUS','These are our Allies! You watch over them like they\'re a threat. Why? You WILL answer to me!','',26124),
(69409,'enUS','And, we\'re off!','',26124),
(69410,'enUS','<Vol\'jin lays on the floor unconscious and barely breathing.>','',26124),
(69411,'enUS','We\'ll have to tread carefully with all this teleporting in and out. We CANNOT risk Jaina finding out about this.$b$bAre you ready to go in?','',26124),
(69412,'enUS','Yes.','Yes.',26124),
(69413,'enUS','Stay away from the guards! This spell should shield you from the night elves\' vision, but you\'ll still need to keep your distance.  If you get into trouble, return to safety here.','',26124),
(69414,'enUS','Back so soon?','',26124),
(69415,'enUS','Be careful, $n. We can\'t risk being caught.','',26124),
(69416,'enUS','Keep your distance from the Alliance, $n. We can\'t have you getting captured this deep in enemy territory.','',26124),
(69417,'enUS','If you keep teleporting all over the place, Jaina will catch onto us. Please, be more careful next time.','',26124),
(69418,'enUS','The Divine Bell! I knew I could count on you, $n.','',26124),
(69419,'enUS','','What was that noise?',26124),
(69420,'enUS','','Is somebody out there?',26124),
(69421,'enUS','','Show yourself!',26124),
(69422,'enUS','','Hmm? What was that?',26124),
(69423,'enUS','Vol\'jin was a friend of mine, once upon a time. It has been many years since our paths crossed.','',26124),
(69424,'enUS','What happened to Vol\'jin?','What happened to Vol\'jin?',26124),
(69425,'enUS','Vol\'jin\'s body was found in a well a few days ago.$b$bA poison flows through his veins that is halting his regeneration. This was designed to kill a troll.$b$bIf I had to guess, I would say this wound was made by an assassin\'s hand. And one who is not from Pandaria.','',26124),
(69426,'enUS','Halt! This city is under Martial Law. Declare yourselves.','',26124),
(69427,'enUS','Here! Stop the boats here.','',26124),
(69428,'enUS','This island will make a perfect coastal stronghold. Rokla! When the peons arrive, clear these trees and begin construction of the docks.','',26124),
(69429,'enUS','Champion, you have been here for many weeks, and know this land well. Come with me.','',26124),
(69430,'enUS','%s calls for the help of a nearby guard!','',26124),
(69431,'enUS','What did you see, brother?','',26124),
(69432,'enUS','Your kind are not welcome here, warlock.','',26124),
(69433,'enUS','This temple is the domain of the Ashtongue Brotherhood. I must ask you to leave - now.','',26124),
(69434,'enUS','Another warlock? After what happened last time, you should be glad we don\'t kill you on sight.','',26124),
(69435,'enUS','Dwarf Construction Site Under Attack!','Dwarf Construction Site Under Attack!',26124),
(69436,'enUS','Champion, may I have a word with you? In private... ?','',26124),
(69437,'enUS','You are a hero of the Horde. Your deeds in Northrend and during the Cataclysm are the stuff of legend. For this reason, I trust in your discretion.','',26124),
(69438,'enUS','I am a ranger, not a politician. But like it or not, the mantle of leadership has fallen on my shoulders.','',26124),
(69439,'enUS','My people, who have suffered through so many challenges and betrayals, look to me to secure their future.','',26124),
(69440,'enUS','We Sin\'dorei were driven to the Horde by the bigotry and distrust of the Alliance.','',26124),
(69441,'enUS','Now, I look at our Warchief, and I begin to see the very same racism. He is willing to throw away our lives for his agenda.','',26124),
(69442,'enUS','Know this: I won\'t stand idle if the Horde interests conflict with those of my people. I may reconsider old Alliances.','',26124),
(69443,'enUS','Keep your eyes open, champion. We are all in this together... for now.','',26124),
(69444,'enUS','My father isn\'t asking you to pledge the Kirin-Tor to the Alliance-','',26124),
(69445,'enUS','','Anduin, I know exactly what he\'s asking. Oh - look who\'s arrived.',26124),
(69446,'enUS','','Nobody dislikes Garrosh more than me. I wrestle with my anger every day.',26124),
(69447,'enUS','','Come with me - look around you a moment.',26124),
(69448,'enUS','','In the aftermath of Theramore, my first instinct was to decimate Orgrimmar - to kill every man woman and child in the city.',26124),
(69449,'enUS','','I\'m not proud.  Since then, Kalecgos and I have talked at length about power, and how it should be used.',26124),
(69450,'enUS','...Jaina!','',26124),
(69451,'enUS','','The Kirin-Tor has a legacy of abuse. Kel\'thuzad turned his knowledge of the arcane arts toward Necromancy.',26124),
(69452,'enUS','','Kael\'thas Sunstrider was also a student here, another of our fold who betrayed us.',26124),
(69453,'enUS','','Anduin, you know more than anyone, it\'s important to separate the Horde from its people.',26124),
(69454,'enUS','','Every day I ask myself: \"What\'s the right thing to do?\"',26124),
(69455,'enUS','','The Sunreavers still operate within this city. Alliance and Horde work together.',26124),
(69456,'enUS','','As long as we stay above the war, then there\'s hope for the world as a whole.',26124),
(69457,'enUS','','I see our city as a beacon of light, showing the way.',26124),
(69458,'enUS','','If we can trust one another here, then there\'s hope for the rest of the world.',26124),
(69459,'enUS','','I see our city as a beacon of light, showing the way.',26124),
(69460,'enUS','','If we can trust one another here, then there\'s hope for the rest of the world.',26124),
(69461,'enUS','','Thank you, Anduin.',26124),
(69462,'enUS','I understand. I\'ll talk to my father.','',26124),
(69463,'enUS','%s senses its destiny!','',26124),
(69464,'enUS','%s clatters and whirrs happily.','',26124),
(69465,'enUS','%s clunks gleefully onto the ground.','',26124),
(69466,'enUS','%s marvels at its surroundings in robotic awe.','',26124),
(69467,'enUS','%s clanks lustily.','',26124),
(69468,'enUS','%s has purchased a box of banners!','%s has purchased a box of banners!',26124),
(69469,'enUS','%s has purchased a Rodent Crate!','%s has purchased a Rodent Crate!',26124),
(69470,'enUS','%s has purchased an Obelisk of Deception!','%s has purchased an Obelisk of Deception!',26124),
(69471,'enUS','%s has purchased a Mind Vision Altar!','%s has purchased a Mind Vision Altar!',26124),
(69472,'enUS','%s has purchased a box of Overridden Excavationbots!','%s has purchased a box of Overridden Excavationbots!',26124),
(69473,'enUS','','You\'re late, $n.\n\nLet\'s get right to the point. Our latest recon shows the last of Shek\'zeer\'s forces are holed up at the heart of the island. They\'re protecting a large weapons cache that Garrosh has ordered us to retrieve. Problem is they\'ve activated the island\'s defenses, a massive impenetrable shield that enshrouds all of Zan\'vess.\n\nThis is where you come in. I need you to take one of these gunships and shoot down the shield generators. As long as they\'re active none of our forces can reach the weapons cache.',26124),
(69474,'enUS','Well done, hero! I yield to your might.','',26124),
(69475,'enUS','Enjoy this well earned brew. The recipe has been in my family for over ten thousand years. Once enjoyed by the Monkey King himself, they say.','',26124),
(69476,'enUS','Help! I am being attacked!','',26124),
(69477,'enUS','We\'ve got our work cut out for us, $p.','We\'ve got our work cut out for us, $p.',26124),
(69478,'enUS','Shield generators all over the island are protecting the Heart of Zan\'vess, preventing us from reaching the weapons cache.','Shield generators all over the island are protecting the Heart of Zan\'vess, preventing us from reaching the weapons cache.',26124),
(69479,'enUS','If we don\'t get this shield down soon we\'re going to be overrun.','If we don\'t get this shield down soon we\'re going to be overrun.',26124),
(69480,'enUS','Admiral they\'ve activated some sort of force field, the control towers all over the island just lit up.','Admiral they\'ve activated some sort of force field, the control towers all over the island just lit up',26124),
(69481,'enUS','Curse these mantid! All remaining air units, get to those towers and take them out!','Curse these mantid! All remaining air units, get to those towers and take them out!',26124),
(69482,'enUS','We\'re going in! Take out those towers!','We\'re going in! Take out those towers!',26124),
(69483,'enUS','Aim for those amber bombs, they\'ll cause a huge explosion if we manage to set one off!','Aim for those amber bombs, they\'ll cause a huge explosion if we manage to set one off!',26124),
(69484,'enUS','Good shot, $p! Keep aiming for those bombs.','Good shot, $p! Keep aiming for those bombs.',26124),
(69485,'enUS','Nice work! The shield looks like it\'s weakening.','Nice work! The shield looks like it\'s weakening.',26124),
(69486,'enUS','Those Mantid are protecting the towers, $p. Take them out or we won\'t be able to land any shots.','Those Mantid are protecting the towers, $p. Take them out or we won\'t be able to land any shots.',26124),
(69487,'enUS','Foolish warlocks. I knew you would try again to ransack our temple...!','',26124),
(69488,'enUS','Wait... you\'re not one of the warlocks that snuck in here before. Why then are you here?','',26124),
(69489,'enUS','Hmm... your name sounds familiar to me, $n. $B$BWhat do you want from the Black Temple? Stay a moment and speak with me, rather than skulk about like a rogue.','',26124),
(69490,'enUS','Warchief Garrosh seeks the Black Harvest members who trespassed here recently.','Warchief Garrosh seeks the Black Harvest members who trespassed here recently.',26124),
(69491,'enUS','King Wrynn seeks the Black Harvest council members who trespassed here recently.','King Wrynn seeks the Black Harvest council members who trespassed here recently.',26124),
(69492,'enUS','The Alliance did much to aid my people in freeing the Black Temple of Illidan\'s grasp.$B$BI will help you as a show of mutual trust.','',26124),
(69493,'enUS','$n, you and your Alliance did much to aid my people in freeing the Black Temple of Illidan\'s grasp. $B$BI will help you as a show of mutual trust and repayment of the debt I owe you.','',26124),
(69494,'enUS','Show me where they went.','Show me where they went.',26124),
(69495,'enUS','Akama, lead the way!','Akama, lead the way!',26124),
(69496,'enUS','The Horde did much to aid my people in freeing the Black Temple of Illidan\'s grasp. $B$BI will help you as a show of mutual trust.','',26124),
(69497,'enUS','$n, you and your Horde  did much to aid my people in freeing the Black Temple of Illidan\'s grasp. $B$BI will help you as a show of mutual trust and repayment of the debt I owe you.','',26124),
(69498,'enUS','It has been many months since those two warlocks broke into the temple... but I\'m still not sure what they were after.','',26124),
(69499,'enUS','Follow me. They visited both the Shrine of Lost Souls and the Temple Summit.','',26124),
(69500,'enUS','I have decided to trust this warlock for now. Let $ghim:her; move about the temple freely.','',26124),
(69501,'enUS','It will take many years for us to undo the damage that Magtheridon, Illidan and the fel orcs did to this holy place.','',26124),
(69502,'enUS','Within lies the Shrine of Lost Souls. The souls of thousands of my fallen brethren remain within this area.','',26124),
(69503,'enUS','Use caution, there are many traps still active within. Perhaps one of your demon spells will grant you the ability to scout ahead before advancing forward.','',26124),
(69504,'enUS','For years it has languished, slowly growing in strength...','',26124),
(69505,'enUS','','This... is amazing... an untapped store of raw arcane energy.',26124),
(69506,'enUS','','Imagine what we could summon with just a fraction of this power!',26124),
(69507,'enUS','Summon... ha, imagine what we could become if fused with power of this magnitude...','',26124),
(69508,'enUS','The powers of this room are not unlike the original Well of Eternity in Azeroth.','',26124),
(69509,'enUS','','So this is how Illidan bound so many demons to his will...',26124),
(69510,'enUS','Yes. The payment for the demons\' service was to drink from the energy of this place.','',26124),
(69511,'enUS','By feeding upon this place\'s power, they were broken free from their addiction to the Legion\'s magic.','',26124),
(69512,'enUS','I believe this is the original power source he intended to offer the blood elves to free them from their addiction to the Sunwell... but for some reason he didn\'t let them near it...','',26124),
(69513,'enUS','','What?? You have no proof of such a claim.',26124),
(69514,'enUS','Didn\'t you notice? The demons under Illidan\'s command were free of the entropic, fel-green corruption that pervades the Legion.','',26124),
(69515,'enUS','','... why do you talk so much, Kanrethad?',26124),
(69516,'enUS','I was there... at the end...','',26124),
(69519,'enUS','','... oh dear, are you going to regale me with yet another of your horrible stories?',26124),
(69520,'enUS','... shut up.','',26124),
(69521,'enUS','','...',26124),
(69522,'enUS','I think I liked you better when your jaw was missing.','',26124),
(69523,'enUS','','Did you hear that?! Those Ashtongue dogs are coming. Let\'s hurry up and start the ritual!',26124),
(69524,'enUS','Very well. We\'ll return later after the crystal is fully charged.','',26124),
(69525,'enUS','According to my research, the pandaren long ago made a special mallet that was intended for the Divine Bell.','',26124),
(69526,'enUS','When using the mallet on the Divine Bell, the pandaren monks were able to create pure harmony.','',26124),
(69527,'enUS','But then the Monkey King one day decided to steal the mallet and hide it as a prank. There is no record of the mallet after that.','',26124),
(69528,'enUS','What I did find, however, was the final resting place of the infamous \"Monkey King.\"','',26124),
(69529,'enUS','The powers of this place are NOT for your kind, warlock!','',26124),
(69530,'enUS','The tricky part is, he was frozen in jade while dueling a mogu that history names \"The Jade Warlord.\"','',26124),
(69531,'enUS','DIE!','',26124),
(69532,'enUS','I found an incantation to release these two from their prison. But it will release both of them. Once I cast this, defeat the Jade Warlord before he can get his bearings.','',26124),
(69533,'enUS','Garrosh is going to try to use the Divine Bell to wreak havoc on the land. We must find a way to stop him.','',26124),
(69534,'enUS','Anduin, why are we here?','Anduin, why are we here?',26124),
(69535,'enUS','Face the souls of those your kind doomed to perish, Warlock!','',26124),
(69536,'enUS','','%s begins to cast |cFFFF0000|Hspell:113134|h[Mass Resurrection]|h|r!',26124),
(69537,'enUS','If you love demons so much... then you shall have them!','',26124),
(69538,'enUS','$n! Some of my men are trapped in the basement - there is little time, help me save them!!','',26124),
(69539,'enUS','Ah, so there is one who wishes to taste the might of the Metal Brew?','',26124),
(69540,'enUS','Be warned, this recipe has been handed down from generation to generation, tought to my family by the great Monkey King himself.','',26124),
(69541,'enUS','It\'s flavor is intended for friends to share after a battle. Come... friend... and battle me if you dare.','',26124),
(69542,'enUS','Eek! Quick, strong, dangerous. You know how to stick it. I no longer afraid you just some filthy wikket.','',26124),
(69543,'enUS','Solve the other riddles, I am demanding! And then meet me down south at Lion\'s Landing.','',26124),
(69544,'enUS','Looting','Looting',26124),
(69547,'enUS','... yo, $n! Remember me? Good, good... hey, listen... we don\'t have to help this guy...','',26124),
(69548,'enUS','There\'s gotta be some riches around this place... c\'mon boss, you know you want to...','',26124),
(69553,'enUS','Dwarf Construction Complete!','Dwarf Construction Complete!',26124),
(69558,'enUS','Your interference has cost me a great warrior, young prince. You\'ll pay with your life.','',26124),
(69559,'enUS','That is where you are wrong, Garrosh.','',26124),
(69560,'enUS','Die, whelp!!','',26124),
(69561,'enUS','The mogu made the Divine Bell to create chaos, but the pandaren created a special mallet to turn the echoes of that chaos into perfect harmony. That mallet was hidden for thousands of years, until now.','',26124),
(69562,'enUS','I will not let you do this, Garrosh.','',26124),
(69563,'enUS','Your Alliance must be at its end if you\'re sending your children against me.','',26124),
(69564,'enUS','I will let you live so that you can tell your King of the price for his continued defiance!','',26124),
(69565,'enUS','We are the HORDE. We are slaves to nothing and no one!','',26124),
(69566,'enUS','With the Divine Bell, I will burn away any remnants of weakness within us. Fear... despair... hatred... doubt. The lesser races are buried beneath their weight. But WE will control their power.','',26124),
(69567,'enUS','Together, we will destroy the Alliance and claim what is rightfully ours. Let our song of victory begin.','',26124),
(69568,'enUS','Our victory is all but assured. With the power of the bell on our side, we will be unstoppable.','',26124),
(69569,'enUS','If our enemies should choose to push us, we will drive them into the ground!','',26124),
(69570,'enUS','Yes! Feel the power within you. Fight your fears. Conquer your hatred!','',26124),
(69571,'enUS','This is but a test of our strength. We will pass this trial, just as we have passed others!','',26124),
(69572,'enUS','Stop, Garrosh! You do not know what that bell is capable of!','',26124),
(69573,'enUS','Ahahahaha... so in the end, it is not Varian, but his whelp who comes to face me. You run bravely to your death, young one.','',26124),
(69574,'enUS','I will not let you do this. I swear to it.','',26124),
(69575,'enUS','Stop me then, human.','',26124),
(69576,'enUS','Auuugh... Auuuuuugggghhhhh! This pain! I cannot control it!','',26124),
(69577,'enUS','Fight the sha - master it! Use it!','',26124),
(69578,'enUS','Do you speak the truth, Garrosh? Can the Horde truly survive another war?','',26124),
(69579,'enUS','Doubt is for the weak! Do not question your strength, Ishi. We will survive because we must! The Horde will prevail!','',26124),
(69580,'enUS','We have lost so much, Warchief. Our families, dead. Our friends, lost. Our homeland, gone. How much more must our people suffer?','',26124),
(69581,'enUS','Our suffering is at an end. When this war is won, our people will see prosperity at last.','',26124),
(69582,'enUS','Why should we be slaves to honor, when we could slaughter the children of our enemies while they sleep? My blade thirsts for Alliance blood!','',26124),
(69583,'enUS','Control your hatred, Ishi. There is killing, and then there is murder. Direct your rage to our enemies.','',26124),
(69584,'enUS','At night, I see the faces of all those I have slain. Where do our spirits go after our bodies lay cold? I fear... death.','',26124),
(69585,'enUS','Use your fear, Ishi! Turn it on your foes. When death arrives, will you stand and face it or kneel in defeat?','',26124),
(69586,'enUS','Warchief! I... I have failed you.','',26124),
(69587,'enUS','Yes, Ishi. You have.','',26124),
(69589,'enUS','There is much I do not know about this artifact. The weak-willed cannot control this sha energy, but I WILL master it.','',26124),
(69590,'enUS','At least the human prince is dead. King Wrynn now knows the price of his continued defiance.','',26124),
(69591,'enUS','Leave me. I have much to think about.','',26124),
(69592,'enUS','The landing site is secure. We\'re ready for work to commence.','',26124),
(69593,'enUS','Champion, you have earned the honor. Signal our fleet.','',26124),
(69594,'enUS','%s has hired guards to protect the outpost!','%s has hired guards to protect the outpost!',26124),
(69595,'enUS','Watch the might of the Horde in action as we turn this slab of land into DOMINATION POINT.','',26124),
(69596,'enUS','Do you see, champion? There is little my Horde cannot accomplish. What is this?','',26124),
(69597,'enUS','Vol\'jin. What are you doing here? Shouldn\'t you be on your island kissing frogs?','',26124),
(69598,'enUS','Your lack of vision is why your people are still primitives, and your lack of loyalty is why I did not summon the Darkspear for this campaign.','',26124),
(69599,'enUS','The question is, what are WE doin\' here? Yeh bring \'dis war to anudder corner of Azeroth, and I wanna know why.','',26124),
(69600,'enUS','Look around you, Vol\'jin. This land is rich in resources: wood, stone, iron, fuel. And people.','',26124),
(69601,'enUS','A show of might on these shores will make the pandaren think twice about joining the Alliance.','',26124),
(69602,'enUS','All dis bloodshed make everyone tink twice \'bout joinin\' da Horde.','',26124),
(69603,'enUS','This is the difference between me and you, Vol\'jin. I won\'t let MY people starve to death in the desert. I will stop at nothing - NOTHING - to ensure a proud and glorious future for the orcs and anyone with the courage to stand with us. Wait here.','',26124),
(69604,'enUS','There is something you can do, troll, to demonstrate your value to the Horde. A mission in the heart of this continent.','',26124),
(69605,'enUS','','No, no, no! The Bell!',26124),
(69606,'enUS','','I had Darnassus LOCKED DOWN! Every fumbling rogue that tried to sneak into the city, I CAUGHT them! I snatched every two-bit charlatan that attempted to teleport through my traps!',26124),
(69607,'enUS','','They couldn\'t possibly have gotten through... this was an inside job. Somebody inside the city has the Bell, unless... no...',26124),
(69608,'enUS','','UNUSED',26124),
(69609,'enUS','','Come with me.',26124),
(69610,'enUS','','These portals connect to Dalaran. That means the Kirin Tor... MY OWN Kirin Tor... helped the Horde commit this atrocity.',26124),
(69611,'enUS','','I will NOT be betrayed again! Those responsible for this will be punished!',26124),
(69612,'enUS','','Aethas Sunreaver!',26124),
(69613,'enUS','','You\'ve betrayed the Kirin Tor, Sunreaver. You\'ve allowed Garrosh to move his forces through MY city.',26124),
(69614,'enUS','','You looked the other way. You and your insubordinate kind are no longer welcome here.',26124),
(69615,'enUS','You have it all wrong, Jaina. I did nothing.','',26124),
(69616,'enUS','This is OUR city too, Proudmoore.','',26124),
(69617,'enUS','','Hah! I see. I will remove the Sunreavers by force, then.',26124),
(69618,'enUS','','You, Aethas, will be coming with me.',26124),
(69619,'enUS','Jaina! What\'s happening in Dalaran? Has there been an attack?','',26124),
(69620,'enUS','','The Kirin Tor was betrayed from within. I\'ve handled the situation.',26124),
(69621,'enUS','How?','',26124),
(69622,'enUS','','I\'ve purged the Horde from Dalaran. You have what you wanted, Your Majesty: The Kirin Tor belongs to the Alliance.',26124),
(69623,'enUS','','I know what I said. My trust was misplaced.',26124),
(69624,'enUS','But you said-','',26124),
(69625,'enUS','What of the Sin\'dorei - the Sunreavers?','',26124),
(69626,'enUS','','Those that surrendered are being taken to the Violet Hold. I make no guarantees about those who chose to fight.',26124),
(69627,'enUS','Jaina, you need to talk to me before you act-','',26124),
(69628,'enUS','','How I run the Kirin Tor is my business.',26124),
(69629,'enUS','I was trying to negotiate with the Sin\'dorei. I was opening discussions to bring them into the Alliance! By attacking their people, you\'ve forced their hand-','',26124),
(69630,'enUS','','They chose their own path.',26124),
(69631,'enUS','You\'ve driven them back to the Horde.','',26124),
(69632,'enUS','','You\'re fooling yourself. Once Horde, always Horde. I see that now. I\'m mobilizing the Kirin Tor.',26124),
(69633,'enUS','Jaina. We\'ve got to work together on this. The Alliance must act as one.','',26124),
(69634,'enUS','','Don\'t get soft on me, Varian.',26124),
(69635,'enUS','The game has changed.','',26124),
(69636,'enUS','Champion, please don\'t go - we need to talk!','',26124),
(69637,'enUS','Garrosh attacked my son...? Where is he?','',26124),
(69638,'enUS','','Anduin!',26124),
(69639,'enUS','Anduin, what were you thinking? I should\'ve sent you back to Stormwind!','',26124),
(69640,'enUS','He\'s alive, but his bones are shattered.','',26124),
(69641,'enUS','Send for Velen. Bring him here at once!','',26124),
(69642,'enUS','Aethas! You\'re alive.','',26124),
(69643,'enUS','Thanks to this hero, a few of us made it out of there. Many more have been sent to the Violet Hold.','',26124),
(69644,'enUS','Anar\'alash denal! Will someone tell me WHAT is going on in Dalaran?','',26124),
(69645,'enUS','Proudmoore! She\'s gone and expelled the Sunreavers from the city. She\'s purging the Horde from the Kirin Tor!','',26124),
(69646,'enUS','She\'s gone too far. I\'m certain the Alliance can move their war mages through the city at will. That human ... witch!','',26124),
(69647,'enUS','When will they learn? When will they see that the Horde exists BECAUSE of the Alliance? Because of their prejudice and their bigotry!? They force us ever closer to Hellscream\'s Horde.','',26124),
(69648,'enUS','My Lord...','',26124),
(69649,'enUS','Hal\'duron, summon the rangers. Rommath, assemble the Blood Magi, and add the Sunreavers\' strength to your own.','',26124),
(69650,'enUS','We Sin\'dorei will take our future into our own hands.','',26124),
(69651,'enUS','And get this damn thing out of my sight! Hellscream bought his treasure with the blood of my people. I hope it destroys him.','',26124),
(69652,'enUS','My Lord. YOU would make a fine Warchief.','',26124),
(69653,'enUS','My Lord. YOU would make a fine Warchief.','',26124),
(69654,'enUS','It may come to that. Bring me my blades. The next move is mine.','',26124),
(69655,'enUS','Are you going to try a sip of the water of youth?','Are you going to try a sip of the water of youth?',26124),
(69656,'enUS','Jaina\'s gone over the edge. She\'s imprisoning the Sunreavers and attacking those who resist. What\'s worse, the Silver Covenant has seized the opportunity to join the bloodshed.','',26124),
(69657,'enUS','It\'s chaos up there. We need to save whoever we can, and we\'ll need to move quickly.','',26124),
(69658,'enUS','Wait for my command...','',26124),
(69659,'enUS','Go go go go! To the center of the city! This way!','',26124),
(69660,'enUS','Aethas isn\'t here... they must have moved him. We can continue without him.','',26124),
(69661,'enUS','Stay your hand and step aside. Very well.','',26124),
(69662,'enUS','Aethas, this way! Into the portal!','',26124),
(69663,'enUS','Stay by me! We\'re going out the tunnel!','',26124),
(69664,'enUS','Stay by my side!','',26124),
(69665,'enUS','Everyone be here now. Let\'s get dis done wit.','',26124),
(69666,'enUS','Proceed by foot. We\'ll circle around and look for another entrance.','',26124),
(69667,'enUS','As da Warchief commands...','',26124),
(69668,'enUS','I\'m glad you here to watch me back. I don\'t like da look of Garrosh\'s goons.','',26124),
(69669,'enUS','Let\'s mount up and move out!','',26124),
(69670,'enUS','Hey - wait for me! I don\'t like goons, either.','',26124),
(69671,'enUS','Scouts say dere\'s ancient magics in dese caves. Warchief wants \'em checked out.','',26124),
(69672,'enUS','One a dem lizard-beasts. Fight on, me bruddahs!','',26124),
(69673,'enUS','Have you fought dese \'tings before?','',26124),
(69674,'enUS','It\'s like dey got weapons, but no brains.','',26124),
(69675,'enUS','We can take this boat inside. Just let me make a few modifications...','',26124),
(69676,'enUS','And... done! A self-propelled saurok-slaying machine.','',26124),
(69677,'enUS','One of you man da guns, the rest on foot.','',26124),
(69678,'enUS','Kill anyting dat squirms!','',26124),
(69679,'enUS','Ack, get that thing off us!','',26124),
(69680,'enUS','They\'re busting up our boat!','',26124),
(69681,'enUS','Here! Stop da boat here.','',26124),
(69682,'enUS','Griz, you guard da boat. Da rest of ya wit\' me.','',26124),
(69684,'enUS','Here, take this! It\'ll help you against any swarms.','',26124),
(69685,'enUS','I\'ll just... be right here. Don\'t forget about me!','',26124),
(69686,'enUS','Are the preparations complete?','',26124),
(69687,'enUS','Yes, Warlord. The traps are set. The Divine Bell will be safe within this crypt, ready for the day that the Thunder King returns.','',26124),
(69688,'enUS','We have but to evacuate the workers and the rest of our warriors.','',26124),
(69689,'enUS','Very well, then. May the ghosts of our brothers guard this place for all eternity.','',26124),
(69690,'enUS','There is no time. The Shado-Pan trackers are too close. They cannot learn the location of the Bell.','',26124),
(69691,'enUS','Their sacrifice will not be in vain.','',26124),
(69692,'enUS','And neither, Avartu, will yours.','',26124),
(69693,'enUS','Light... I see... light. Finally, after centuries of silence, someone comes at last.','',26124),
(69694,'enUS','I have kept the Bell safe as promised, Master.','',26124),
(69695,'enUS','Wait... you are not mogu! Intruders!','',26124),
(69696,'enUS','Guardians, awaken! Destroy those who would steal the Thunder King\'s treasure!','',26124),
(69697,'enUS','Be cast into darkness!','',26124),
(69698,'enUS','This crypt will be your grave!','',26124),
(69699,'enUS','You, too, shall know the silence!','',26124),
(69700,'enUS','Such horror... Such emptiness...','',26124),
(69701,'enUS','Only death awaits you!','',26124),
(69702,'enUS','No! The Bell....','',26124),
(69703,'enUS','You will go no further! Now face me. I will give you a swift death!','',26124),
(69704,'enUS','There\'s my survey team. Bring us in.','',26124),
(69705,'enUS','What\'s the situation?','',26124),
(69706,'enUS','','Yer Highness! This site has everything we need. Lumber, stone and-',26124),
(69707,'enUS','The Horde?','',26124),
(69708,'enUS','','Marshal Troteman and a handful o\' scouts pursued a Horde warband up the beach. They haven\'t come back.',26124),
(69709,'enUS','Hmm... Troteman may have gotten himself in over his head. We\'ll split up.','',26124),
(69710,'enUS','Lynna, stay here and establish a camp. Your first priority should be medical tents and shelters. When the peasants arrive, see that they begin construction of the docks.','',26124),
(69711,'enUS','Hornswaggle, notify the rest of the survey team. Quarry and mining operations will begin as soon as the fleet arrives.','',26124),
(69712,'enUS','','Yes, Yer Majesty!',26124),
(69713,'enUS','Champion, you know this land better than anyone. You\'re with me. Let\'s go find Troteman.','',26124),
(69714,'enUS','Troteman, you old dog, I knew I\'d find you stirring up trouble.','',26124),
(69715,'enUS','The survey team has done well. This is an ideal deep-water port.','',26124),
(69716,'enUS','I want to see a tower built right here.','',26124),
(69717,'enUS','Marshal, see to it that you hold this position until construction is complete.','',26124),
(69718,'enUS','Now, let\'s see to our supplies...','',26124),
(69719,'enUS','','Explorer\'s League reporting in, sir!',26124),
(69720,'enUS','I\'m glad to see you contribute to the war effort. But I need supplies. What have you got?','',26124),
(69721,'enUS','','Plenty of stone, aye. But no sign of major ore veins in this whole area.',26124),
(69722,'enUS','I\'ll take it. Anything else?','',26124),
(69723,'enUS','','Somethun\' even BETTER. History! Artifacts from an ancient an\' powerful race!',26124),
(69724,'enUS','I\'ll make a deal with you, Hornswaggle. Help my men get a stone quarry operation running, and we\'ll protect your dig site.','',26124),
(69725,'enUS','','You mean it? Oh, I cannae WAIT to see the look on Brann\'s face when he finds out I got an excavation green-lit by the King himself! You\'ll have your quarry by next sundown!',26124),
(69726,'enUS','Hm. I used to think leadership was all about strength. I see things more clearly now - it\'s a little bit of give, a little bit of take. It\'s about binding people together. A bundle of sticks is not easily broken.','',26124),
(69727,'enUS','Everything is in place. We\'ll construct a town center on this peninsula, using resources from along the coast.','',26124),
(69728,'enUS','From here we can reach out to the natives and keep Horde aggression in check.','',26124),
(69729,'enUS','Champion! Without your pioneering efforts on Pandaria, this foothold wouldn\'t have been possible.','',26124),
(69730,'enUS','The honor is yours. Signal the fleet.','',26124),
(69731,'enUS','Marshal, excellent work fortifying the harbor. Our next priority is -','',26124),
(69732,'enUS','Father!','',26124),
(69733,'enUS','What-?','',26124),
(69734,'enUS','Father!','',26124),
(69735,'enUS','Anduin... you\'re safe...','',26124),
(69736,'enUS','Father, you can\'t do this. All the hatred and anger our war brings here - it poisons this place.','',26124),
(69737,'enUS','Easy, son. We\'re fighting a different war now. This isn\'t about hatred of the Horde. This is about a love of what\'s right. About doing what needs to be done.','',26124),
(69738,'enUS','This land is - different than ours. It\'s a treasure.','',26124),
(69739,'enUS','Then we\'ll protect it with our lives. Son, I need you with me on this. We in this together?','',26124),
(69740,'enUS','Together...','',26124),
(69741,'enUS','','Yer Majesty! The Horde, they\'ve holed up in a temple west of here. Night elf rangers have surrounded it and locked it down...',26124),
(69742,'enUS','Rangers? ...Tyrande.','',26124),
(69743,'enUS','Father! You can\'t let them turn the Crane Temple into a war zone! That place is still recovering from a sha infestation...','',26124),
(69744,'enUS','','AND it\'s a historical treasure trove.',26124),
(69745,'enUS','Everyone, calm down. This sounds like one of Garrosh\'s traps. He\'s trying to lure us from the beach. Troteman? Round me up some peasants and a mortar team, and don\'t let down your guard.','',26124),
(69746,'enUS','But father-','',26124),
(69747,'enUS','I\'ll bring a small group of champions with me and talk to Tyrande myself. Anduin, I can handle this. I need you to trust that I\'m going to do the right thing here.','',26124),
(69748,'enUS','... I trust you, father.','',26124),
(69749,'enUS','All hail the King of Gilneas, Genn Greymane!','All hail the King of Gilneas, Genn Greymane!',26124),
(69750,'enUS','From the faraway boughs of tranquil Darnassus, High Priestess Tyrande Whisperwind arrives!','From the faraway boughs of tranquil Darnassus, High Priestess Tyrande Whisperwind arrives!',26124),
(69751,'enUS','Representing the draenei, the wise and noble Farseer Nobundo from the Exodar!','Representing the draenei, the wise and noble Farseer Nobundo from the Exodar!',26124),
(69752,'enUS','I see. So it was this... sha... that caused such violent behavior in our troops?','',26124),
(69753,'enUS','Yes, father. I encountered sha energy in my travels. At its full power it is terrible to behold.','',26124),
(69754,'enUS','We Alliance have rallied to defeat many enemies, my son. The sha will fall to us, just like any other.','',26124),
(69755,'enUS','This isn\'t the same, father. The sha cannot simply be defeated. It feeds on our inner-most weaknesses. It twists our thoughts. Don\'t underestimate it!','',26124),
(69756,'enUS','Yer Majesty! Look!','',26124),
(69757,'enUS','By the light, is that a sha?','',26124),
(69758,'enUS','Yes. Don\'t go near it!','',26124),
(69759,'enUS','','I sense great darkness emanating from this... thing. Destroy it, now!',26124),
(69760,'enUS','I agree. Only suffering can come of such a creature.','',26124),
(69761,'enUS','I saw first-hand what the sha did to my soldiers in the Jade Forest. My strongest men were rendered helpless by crippling doubt.','',26124),
(69762,'enUS','','Your Highness, we should study it. Weaponize it! The Horde already outnumber us here on Pandaria. We need to gain every possible advantage.',26124),
(69763,'enUS','It couldn\'t hurt to study it. \'Tho I don\'t much care for the way it\'s lookin\' at me.','',26124),
(69764,'enUS','Yes, yes! Very interesting! Perhaps I could distill it into a new power source?','',26124),
(69766,'enUS','','Garrosh is using every weapon he can lay his hands on. Shouldn\'t we level the playing field?',26124),
(69767,'enUS','What do you think, Anduin?','',26124),
(69768,'enUS','Garrosh\'s example is not one that I care to follow. The Alliance should make its own decisions. The RIGHT decisions.','',26124),
(69769,'enUS','Well said, my son.','',26124),
(69770,'enUS','This power is too dangerous. I will have none of it!','',26124),
(69771,'enUS','$n, thank you for helping me today. I knew we could convince my father of the right course. Please, go back to your other duties for now.','',26124),
(69772,'enUS','From the flying city of Dalaran, the leader of the Kirin Tor, Lady Jaina Proudmoore!','From the flying city of Dalaran, the leader of the Kirin Tor, Lady Jaina Proudmoore!',26124),
(69773,'enUS','I\'m ready. Release the Monkey King.','I\'m ready. Release the Monkey King.',26124),
(69774,'enUS','It is true, it may be possible to someday harness the sha into a weapon. But we risk destroying our own people in the process. That is not a price I am willing to pay.','',26124),
(69775,'enUS','<The pandaren snores deeply.>','',26124),
(69776,'enUS','Wake up! The Horde is near - we must prepare defenses!','Wake up! The Horde is near - we must prepare defenses!',26124),
(69777,'enUS','Oooh. I\'m afraid you\'ve chosen a bad time for building defenses, friend.','',26124),
(69778,'enUS','Yesterday\'s sundown celebration went a little long, you see. We may have... overmeditated.','',26124),
(69779,'enUS','I knew you were the right one for this task, $c. Meet me back upstairs when you are finished here.','',26124),
(69780,'enUS','Jubeka\'s mark clearly indicates she entered the Black Temple here.','Jubeka\'s mark clearly indicates she entered the Black Temple here.',26124),
(69781,'enUS','Enter the Temple.','Enter the Temple.',26124),
(69782,'enUS','Shake it off, brothers. It\'s brewin\' time.','',26124),
(69783,'enUS','Rotating','Rotating',26124),
(69784,'enUS','We\'ve got to secure this beach stronghold. We let the Horde have a foothold here, all of Pandaria is going to look like Theramore.','',26124),
(69785,'enUS','','We must prevent the Horde from taking Pandaria... but we must also work to minimize suffering as we do.',26124),
(69786,'enUS','Why do they call me \"toasty\"? \n\nYou really gonna ask me that? Look, it\'s not MY fault that the chemicals reacted that way! Blame SCIENCE!','',26124),
(69787,'enUS','Of course the Explorer\'s League stumbled into a foolish situation and are in over their heads.\n\nAnd of COURSE we are going to take advantage of it.','',26124),
(69788,'enUS','','Och!\n\nWe\'ve got ghosts AND the Reliquary to contend with here?! I dunno what\'s worse!',26124),
(69789,'enUS','Ugh, I Biebered...','',26124),
(69790,'enUS','Watch yourselves. The seals are breaking.','',26124),
(69791,'enUS','Garrosh, you do truly believe the sha can be controlled? Have you seen what it\'s done to our men?','',26124),
(69792,'enUS','Guards! Destroy that abomination.','',26124),
(69793,'enUS','The sha can be a powerful tool. The mogu may have once harnessed its power into the Divine Bell, and look at the glorious empire they built in its wake.','',26124),
(69794,'enUS','But their empire fell. Perhaps to the sha, perhaps to the pandaren, or perhaps... to their own pride.','',26124),
(69795,'enUS','What madness is this?','',26124),
(69796,'enUS','Did the Scourge beat all the courage from your people, blood elf? We are the HORDE. Where there is power, we SEIZE it. My Horde has no place for the weak!','',26124),
(69797,'enUS','As you say... Warchief.','',26124),
(69798,'enUS','What is up, my primary $gmale:female; sibling?  Are you ready to appear visually attractive to your species?','',26124),
(69799,'enUS','Let\'s party!','Let\'s party!',26124),
(69800,'enUS','The device indicates you are very close to the anomaly.','The device indicates you are very close to the anomaly.',26124),
(69801,'enUS','You continue to bow to the Kirin Tor as if they were our saviors. Do not forget their treachery, Aethas.','',26124),
(69802,'enUS','We are the Sin\'dorai! We should not have to bow to anyone. Not the Kirin Tor, not the Alliance, and certainly not the Horde.','',26124),
(69803,'enUS','Always so impatient, young one. There is no knowledge that is not power. This artifact dates back to the same era as the Divine Bell. To know its secrets is to bring us closer to Garrosh\'s prize.','',26124),
(69804,'enUS','But of course it is dangerous. This artifact\'s secrets would be useless to us otherwise.','',26124),
(69805,'enUS','And bowing to the Warchief is any better? Garrosh\'s obsession with these mogu artifacts is such that I haven\'t seen since Kael\'thas walked amongst us.','',26124),
(69806,'enUS','Rommath, without allies we will be crushed by the tides of this war. There is no middle ground with Garrosh. We either have to be with him, or against him.','',26124),
(69807,'enUS','We already know the mogu mastered imprisoning living energy in devices. This is not a magic we need know more about.','',26124),
(69808,'enUS','Garrosh\'s prize, not ours. Mark my words, this construct is dangerous.','',26124),
(69809,'enUS','Seeker of Chaos... Summoner of Demons... Wielder of Shadows...','',26124),
(69810,'enUS','By any chance do you have another one of those super rare, hard to find, amulets?','By any chance do you have another one of those super rare, hard to find, amulets?',26124),
(69811,'enUS','The existence of your kind has not escaped our notice, $c.','',26124),
(69812,'enUS','Like Illidan, you constantly struggle to bend the all consuming chaos to your will.','',26124),
(69813,'enUS','You walk the line between absolute power and total corruption.','',26124),
(69814,'enUS','Silvermoon has been allies with Dalaran for over 2000 years. It is not a friendship we should idly toss aside at the whim of our \'esteemed\' Warchief Garrosh.$b$bOh... are you here about the artifact?','',26124),
(69815,'enUS','As Azeroth has fought the legion and survived, you have faced the darkness within yourself and controlled it.','',26124),
(69816,'enUS','Perhaps you can succeed where Illidan failed... perhaps you can accept the disorder of this universe.','',26124),
(69817,'enUS','Jaina Proudmoore now sits as head of the Kirin Tor and rules Dalaran.$b$bThat puts the citadel square in the hands of the Alliance no matter how much Aethas brags about neutrality.$b$bThis young upstart may have forgotten, but the Alliance tried to imprison and massacre our people during the third war.$b$bForgive me if I do not share his faith in their... \"neutrality\".','',26124),
(69818,'enUS','Your kind can tread where we cannot. Your kind can survive where others might perish.','',26124),
(69819,'enUS','The artifact that Kanrethad attempted to create is incomplete.','',26124),
(69820,'enUS','It grants the ability to perform magic on a grand scale... but they quickly lose the ability to control that power.','',26124),
(69821,'enUS','The Warchief demands results on your research.','The Warchief demands results on your research.',26124),
(69822,'enUS','I will unlock the crystal\'s power, but only you can decide how it is to be used.','',26124),
(69823,'enUS','Choose wisely, $n.','',26124),
(69824,'enUS','This is not the place to discuss such matters. Join me in the chambers beneath the Farstrider Square.$b$bOh, and come armed. I believe we will have need of your skills.','',26124),
(69825,'enUS','The demons are no longer attacking... what happened here?!','',26124),
(69826,'enUS','The Eye of the Storm... countless battles have been fought just to find that artifact. I know not why Xi\'ri entrusted it to your care, $c... but be warned... no one has wielded its power without paying a greater price.','',26124),
(69828,'enUS','An honorable meeting, $c. I have heard rumblings from my brothers here on Pandaria. Dark rumblings of dissent, and worry.$B$BI have come myself to support the Horde\'s efforts, but also... to make sure that things don\'t get too out of hand.','',26124),
(69829,'enUS','','And did the good King Varian send you as well to bid for our aid?',26124),
(69830,'enUS','I would commit our order to an Alliance victory!','I would commit our order to an Alliance victory!',26124),
(69831,'enUS','$p, we should discuss matters back in Krasarang. For now, thank you for your help. There is a portal that can return you to Lion\'s Landing whenever you choose.','',26124),
(69832,'enUS','Hold your tongue, blood elf! You dare question our Warchief\'s judgment?','',26124),
(69833,'enUS','Calm yourself, Ishi. The Lord Regent may speak his mind.','',26124),
(69834,'enUS','Here we are in the land down under.$b$bIt is just as beautiful as the stories I was told as a cub on the Wandering Isle. Though the fish could be larger.','',26124),
(69835,'enUS','SMASH MY GOOD LUCK? I SMASH YOU!','',26124),
(69836,'enUS','GOBLIN WAS NOT LUCKY AT ALL!','',26124),
(69837,'enUS','I GO GET ANOTHER AFTER I STOMP YOU!','',26124),
(69838,'enUS','GOBLIN DID NOTHING TO YOU.  YOU ARE JERK!','',26124),
(69839,'enUS','THESE SHOULDERS... SO HEAVY...','',26124),
(69840,'enUS','I SMASH. YOU DIE. DEAL WITH IT!','',26124),
(69841,'enUS','YOU GOT SMASHED!','',26124),
(69842,'enUS','Are you sure you can\'t choose a side?','Are you sure you can\'t choose a side?',26124),
(69843,'enUS','It is a good thing to spend time in a place like this. We must always remember what it is we struggle so hard to protect.','',26124),
(69844,'enUS','Ready.','Ready.',26124),
(69845,'enUS','','Take as long as you need, Go\'el. If Vol\'jin believes his people are in danger then you had best aid them as you can.',26124),
(69846,'enUS','Thrall, we no longer answer to you. We have a new Warchief now. And he has reminded us that we are STRONG!','',26124),
(69847,'enUS','This is worse than I suspected.','',26124),
(69848,'enUS','','In the other corner, we have Vian, the flame-flinging follower of the Thunder King!',26124),
(69849,'enUS','','Also entering the arena: Goredome! So-named because he will gore you. With his dome.',26124),
(69850,'enUS','','We also welcome our pain-packing crowd favorite: Dungeon Master Vishas!',26124),
(69851,'enUS','','Hey hey! Look what we\'ve scooped up for you today... it\'s Blat!',26124),
(69852,'enUS','','Five on one hardly seems fair, but come on... they\'re half-dead gnomes. It\'s the leper gnome quintet!',26124),
(69853,'enUS','','Also entering the arena: Battletron! Sure, it\'s not goblin-engineered... but it still might kill you!',26124),
(69854,'enUS','','In the other corner... hey look! It\'s my buddy, Fran! And he brought his mount with him!',26124),
(69855,'enUS','','We also welcome everybody\'s favorite frosty feathered friend: Dippy!',26124),
(69856,'enUS','','We found this one scuttling in circles in Silithus. Looks like somebody mostly killed him already. It\'s Ixx!',26124),
(69857,'enUS','','Also entering the arena: Destructobyte... and his ridiculous gnomish holographic machinery!',26124),
(69858,'enUS','','And in this corner! He\'s angry. He\'s deadly. He\'s a little bit adorable. Straight out of Neverest, it\'s Crush!',26124),
(69859,'enUS','','Sure, she\'s wearing a dress, and her knees bend the wrong way, but that doesn\'t mean she can\'t walk all over you. It\'s Dominika!',26124),
(69860,'enUS','','Up next, probably the weakest, ugliest, and least genius combatant I\'ve ever seen. It\'s the stupid, smelly gnome, Millie Watt! Everybody boo!',26124),
(69861,'enUS','','We spent days trying to find this one in Sholazar Basin. Welcome to the jungle! It\'s Mazhareen!',26124),
(69862,'enUS','','Some of you veterans might remember this fella\'. Sure, he\'s broken, but he means to break you! It\'s Akama!',26124),
(69863,'enUS','','Also entering the arena: Everybody\'s favorite magical 12-foot-tall corpse, Fjoll! Am I pronouncing that right?',26124),
(69864,'enUS','','Ugh! Another gnome? Apparently this one calls himself Millhouse Manastorm. Get out there and kill him!',26124),
(69865,'enUS','','We found this one cawing up a storm in Auchindoun. Give it up for Yikkan Izu!',26124),
(69866,'enUS','','Get ready to dance! Deeken\'s in the house!',26124),
(69867,'enUS','','We also welcome Smash Hoofstomp, the terrible tauren from Thunder Bluff!',26124),
(69868,'enUS','','And in the other corner, we have the many eyes of Zen\'shar! What\'s next, a fighting nose?',26124),
(69869,'enUS','','Their partnership was never meant to be. It actually makes me sick a little bit. Here comes GG Engineering!',26124),
(69870,'enUS','','Also entering the arena: The Dark Summoner. Wow, he doesn\'t even have a real name. Spooky!',26124),
(69871,'enUS','','Now this is what I\'m talking about! More dinosaurs, please! It\'s King Kulaka!!',26124),
(69872,'enUS','','Hmm. That\'s actually some pretty good engineering down there. It\'s Disruptron time!',26124),
(69873,'enUS','','Ha ha ha! What bad luck you have! It\'s Proboskus! Ahhh ha ha ha! I\'ve got twenty five gold that says you die in the fire!',26124),
(69874,'enUS','','Quiet down, everyone... we don\'t want to make it angry. Just gaze in silent awe at Unguloxx, the murderaffe!',26124),
(69875,'enUS','$n is representing Stormwind!','',26124),
(69876,'enUS','$n is representing Ironforge!','',26124),
(69877,'enUS','$n is representing Gnomeregan!','',26124),
(69878,'enUS','$n is representing Darnassus!','',26124),
(69879,'enUS','$n is representing the Exodar!','',26124),
(69880,'enUS','$n is representing Gilneas!','',26124),
(69881,'enUS','$n is representing the Tushui Pandaren!','',26124),
(69882,'enUS','Hey, scrub! You interested in a fight?','',26124),
(69883,'enUS','Give me a minute, I want to finish watching this fight.','Give me a minute, I want to finish watching this fight.',26124),
(69884,'enUS','','What\'s wrong, $n? Afraid to fight? Come on, let\'s keep this arena moving!',26124),
(69889,'enUS','$gHis:Her; name was $n.','$gHis:Her; name was $n.',26124),
(69890,'enUS','Brilliant victory, $n! Now get back in line.','Brilliant victory, $n! Now get back in line.',26124),
(69891,'enUS','Sorry, $n. Now would you kindly remove your corpse so that the others can have a go?','Sorry, $n. Now would you kindly remove your corpse so that the others can have a go?',26124),
(69892,'enUS','Honestly, $n... were you even trying?','Honestly, $n... were you even trying?',26124),
(69893,'enUS','You wanna make an omelet, you\'re gonna have to break a few eggs.','You wanna make an omelet, you\'re gonna have to break a few eggs.',26124),
(69894,'enUS','Ahhh ha ha ha! So much blood! Nice.','Ahhh ha ha ha! So much blood! Nice.',26124),
(69895,'enUS','Keep \'em comin\', $n.','Keep \'em comin\', $n.',26124),
(69896,'enUS','$n wins! $n wins!','$n wins! $n wins!',26124),
(69897,'enUS','No! Never again!','',26124),
(69898,'enUS','You dare defy the Warchief?!','You dare defy the Warchief?!',26124),
(69899,'enUS','We\'re routing out the traitors. Looks like we\'ve found another...','We\'re routing out the traitors. Looks like we\'ve found another...',26124),
(69900,'enUS','Traitor!','Traitor!',26124),
(69901,'enUS','These trolls need to learn their place.','These trolls need to learn their place.',26124),
(69902,'enUS','The Horde has no room for such weakness.','',26124),
(69903,'enUS','You shall not stand in our way!','',26124),
(69904,'enUS','This is OUR Horde!','',26124),
(69905,'enUS','','Nothing lasts forever, $p',26124),
(69906,'enUS','The Horde are attacking, Nove!','The Horde are attacking, Nove!',26124),
(69907,'enUS','','This is not my fight, $p.',26124),
(69908,'enUS','You have to help us, Nove!','You have to help us, Nove!',26124),
(69909,'enUS','','Very well, $p. Prove yourself to me and I will aid you in your fight.',26124),
(69911,'enUS','','Now is not the time for this, $p. Leave me in peace.',26124),
(69912,'enUS','','Come and face me, $p!',26124),
(69913,'enUS','Wha? Huh? Oh, yes. The defenses...','',26124),
(69914,'enUS','Ahh, many thanks, friend. I needed that.','',26124),
(69915,'enUS','Oof, I was... just listening to the ground - you know, for signs of enemies approaching. We seem to be safe... for the moment.','',26124),
(69916,'enUS','This yak was male! The angry yak turns on you!','This yak was male! The angry yak turns on you!',26124),
(69917,'enUS','Ooh, just a power-nap. All ready to go now!','',26124),
(69918,'enUS','Ugh! Look at what you\'ve done to my fur!','',26124),
(69919,'enUS','Oh, why? You interrupted the most pleasant dream...','',26124),
(69920,'enUS','Success! The female yak bleats at you peacefully.','Success! The female yak bleats at you peacefully.',26124),
(69921,'enUS','Well done. Now I will just add a hair from our prisoner, Shan Kien, and combine the ingredients.','',26124),
(69922,'enUS','Master Brownstone and his crew have fallen asleep!','Master Brownstone and his crew have fallen asleep!',26124),
(69923,'enUS','I am losing patience, Shan Kien. Tell me where I can find the Divine Bell!','',26124),
(69924,'enUS','Kill me if you must, but I owe no allegiance to you or your Horde. The only master I serve is the Thunder King.','',26124),
(69925,'enUS','Ishi, draw your blade. A few carefully delivered cuts will change his mind.','',26124),
(69926,'enUS','Garrosh, please. There may be another way. One that requires no bloodshed.','',26124),
(69927,'enUS','Speak, then!','',26124),
(69928,'enUS','I have learned how to make an ancient pandaren tincture that will allow us to see into Shan Kien\'s past. We have but to gather the elements for this brew.','',26124),
(69929,'enUS','Stonecore was merely a setback!','',26124),
(69930,'enUS','I have heard the rumors and the jokes...','',26124),
(69931,'enUS','No one laughs behind the great Millhouse Manastorm\'s back and lives to tell the tale!','',26124),
(69932,'enUS','Here\'s a little something something you\'re gonna love...','',26124),
(69933,'enUS','Nice try, sweet cheeks.','',26124),
(69934,'enUS','Better luck next time! BWAHAHAHAH!','',26124),
(69935,'enUS','You\'ll be hearing from my lawyer!','',26124),
(69936,'enUS','Also entering the arena: Bruce, a crocolisk that we found!','',26124),
(69937,'enUS','In the other corner, we have Vian, the flame-flinging follower of the Thunder King!','',26124),
(69938,'enUS','Also entering the arena: Goredome! He WILL attempt to gore you. With his dome.','',26124),
(69939,'enUS','Well, wrap me in leather and tug my leash: it\'s Dungeon Master Vishas!','',26124),
(69940,'enUS','Hey hey! Look what we\'ve scooped up for you today... it\'s Blat!','',26124),
(69941,'enUS','The opposition includes some of Gnomeregan\'s finest... although they\'ve all seen better days. It\'s the leper gnome quintet!','',26124),
(69942,'enUS','Also entering the arena: Battletron! This hunk o\' junk is just waiting to explode all over you!','',26124),
(69943,'enUS','In the other corner... a disgusting green pile of goblin idiocy, riding on a lumbering chariot of shame. It\'s Fran and Riddoh! Everybody boo!','',26124),
(69944,'enUS','He\'ll peck your eyes out if you give him a chance. It\'s Dippy!','',26124),
(69945,'enUS','From deep within the bowels of Blackrock Mountain, it\'s Sanoriak, master of flame!','',26124),
(69946,'enUS','We found this one scuttling in circles in Silithus. From the looks of him, somebody mostly killed him already. It\'s Ixx!','',26124),
(69947,'enUS','Also entering the arena: Destructobyte... and his special surprise!','',26124),
(69948,'enUS','And in this corner! He\'s angry. He\'s deadly. He\'s a little bit adorable. Straight out of Neverest, it\'s Crush!','',26124),
(69949,'enUS','Also entering the arena: Kirrawk, wind-wielding arakkoa of the Terokkar Forest!','',26124),
(69950,'enUS','When I see her smile, it makes me smile. When she casts a spell, it puts a spell on me. When I see her horns, it makes me feel... intrigued. It\'s Dominika!','',26124),
(69951,'enUS','Up next, it\'s Millie Watt! I used to date her in engineering school!','',26124),
(69952,'enUS','We spent days trying to find this one in Sholazar Basin. Welcome to the jungle! It\'s Mazhareen!','',26124),
(69953,'enUS','Some of you veterans might remember this guy. He may be Broken, but today, he means to break you! It\'s Akama!','',26124),
(69954,'enUS','Also entering the arena: Everybody\'s favorite magical 12-foot-tall corpse, Fjoll! Am I pronouncing that right?','',26124),
(69955,'enUS','We have a special guest today: the always-endearing, ever-resilient, Millhouse Manastorm! Good luck, MillMan!','',26124),
(69956,'enUS','We found this one cawing up a storm in Auchindoun. Give it up for Yikkan Izu!','',26124),
(69957,'enUS','Get ready to dance! Deeken\'s in the house!','',26124),
(69958,'enUS','We also welcome Smash Hoofstomp, the terrible tauren from Thunder Bluff! Look at those GREAT shoulderpads!','',26124),
(69959,'enUS','And in the other corner, we have... a big cloud of scary floating eyes? This doesn\'t look good.','',26124),
(69960,'enUS','Their partnership was never meant to be. It actually makes me sick a little bit. Here comes GG Engineering!','',26124),
(69961,'enUS','Also entering the arena: The Dark Summoner. Wow, he doesn\'t even have a real name. Spooky!','',26124),
(69962,'enUS','Now this is what I\'m talking about! More dinosaurs, please! It\'s King Kulaka!!','',26124),
(69963,'enUS','Hmm. That\'s actually some pretty good engineering down there. It\'s Disruptron time!','',26124),
(69964,'enUS','Oh dear... I\'m sorry, but it looks like you\'re going to have to fight Proboskus.','',26124),
(69965,'enUS','Quiet down, everyone... we don\'t want to make it angry. Just gaze in silent awe at Unguloxx, the murderaffe!','',26124),
(69966,'enUS','I will now accept your guesses and wagers on the victor of the match.','',26124),
(69967,'enUS','That\'s it! No more wagers! Let\'s see what happens!','',26124),
(69968,'enUS','Who are you?\n\nI can assure you that everything here is perfectly legitimate, good $gsir:ma\'am;. We are just a pair of wealthy entrepreneurs enjoying a little friendly bloodsport, without ANY gold changing hands.','',26124),
(69969,'enUS','|TInterface\\Icons\\INV_SWORD_04.BLP:32:32:0:0|tThe hero.','|TInterface\\Icons\\INV_SWORD_04.BLP:32:32:0:0|tThe hero.',26124),
(69970,'enUS','|TInterface\\Icons\\INV_MISC_MONSTERCLAW_04.BLP:32:32:0:0|tThe monster.','|TInterface\\Icons\\INV_MISC_MONSTERCLAW_04.BLP:32:32:0:0|tThe monster.',26124),
(69971,'enUS','I refuse to take your guesses if you aren\'t participating in the brawl yourself. You need \"skin in the game\", if you will.\n\nGo talk to one of the guards and queue for the brawl. Then we can play.','',26124),
(69972,'enUS','Quickly, my good $gsir:lady;. Who do you predict will win the next fight?','',26124),
(69973,'enUS','Mogu are imperious, arrogant, and powerful - all characteristics that will send Garrosh into a rage when he arrives. \n\nThis is why it is critical that we capture and interrogate the leader of these mogu before that happens.','',26124),
(69974,'enUS','Ya be lettin\' us outta here now!','Ya be lettin\' us outta here now!',26124),
(69975,'enUS','Dis\' be our home, mon. If ya be tinkin\' we goin\' quietly ya mistaken.','Dis\' be our home, mon. If ya be tinkin\' we goin\' quietly ya mistaken.',26124),
(69976,'enUS','Why ya be doin\' this? We be loyal to da Horde!','Why ya be doin\' this? We be loyal to da Horde!',26124),
(69977,'enUS','Alright, you in?$b$bQuick quick, who d\'ya think\'s gonna win this one, bucko?','',26124),
(69978,'enUS','Who are you?\n\nAin\'t nothin\' shady going on here, no $gsir:ma\'am;. Just enjoying a little friendly bloodsport, without ANY gold changing hands. Everything here\'s on the up-and-up!','',26124),
(69979,'enUS','I ain\'t gonna support you if you ain\'t brawlin\' yourself. You need \"skin in the game\", chief.\n\nGo talk to one of them guards and tell \'em you wanna fight. Then we can play.','',26124),
(69980,'enUS','Alright, who\'s in?','',26124),
(69981,'enUS','That\'s it! The fight\'s goin\', no more guesses!','',26124),
(69982,'enUS','By order of the Warchief this \"city\" is now under Martial Law. Any who refuse the will of the Warchief shall be branded as traitors!','',26124),
(69983,'enUS','You ain\'t got dah right to keep us captive!','You ain\'t got dah right to keep us captive!',26124),
(69984,'enUS','Dis be our home! You ain\'t welcome here, Kor\'kron.','Dis be our home! You ain\'t welcome here, Kor\'kron.',26124),
(69985,'enUS','Why ya be doin\' dis? We all part o\' dah Horde.','Why ya be doin\' dis? We all part o\' dah Horde.',26124),
(69986,'enUS','Where be Vol\'jin?','Where be Vol\'jin?',26124),
(69987,'enUS','Ya not be welcome here!','Ya not be welcome here!',26124),
(69988,'enUS','Da Warchief not be in his right mind.','Da Warchief not be in his right mind.',26124),
(69989,'enUS','Who you be to challenge our loyalty?','Who you be to challenge our loyalty?',26124),
(69990,'enUS','Ya not the only ones who bleed for dah Horde ya orcs!','Ya not the only ones who bleed for dah Horde ya orcs!',26124),
(69991,'enUS','Let us use persuasion, not force. I have here a cask of pandaren Memory Wine. It will allow us to see into Shan Kien\'s past.','',26124),
(69994,'enUS','How... many... of your own people must you kill... so you can have \"your\" Horde back?','',26124),
(69995,'enUS','The Horde is changing! Vol\'jin refused to change with it, and he\'s poisoned his people.','',26124),
(69997,'enUS','You will harm no more sons or daughters of the Horde. Your purpose has been corrupted.','',26124),
(70001,'enUS','The things I do for the Alliance...','',26124),
(70002,'enUS','Interested in trading up your pet battle-stones?','Interested in trading up your pet battle-stones?',26124),
(70003,'enUS','Orestes! Aenea! You are to accompany $p on his mission.','',26124),
(70004,'enUS','Another mission with Aenea? If I must.','',26124),
(70005,'enUS','','Yes, my lord.',26124),
(70006,'enUS','Ya not be needin\' dis weapon again now are ya?','Ya not be needin\' dis weapon again now are ya?',26124),
(70007,'enUS','Let me show ya how to use your own weapon, mon.','Let me show ya how to use your own weapon, mon.',26124),
(70008,'enUS','Ya not be so tough from the dead now are ya?','Ya not be so tough from the dead now are ya?',26124),
(70009,'enUS','Shoulda\' left when ya had the chance.','Shoulda\' left when ya had the chance.',26124),
(70010,'enUS','You be wantin\' our land? We gonna bury you here.','You be wantin\' our land? We gonna bury you here.',26124),
(70011,'enUS','Do me this courtesy, $p, and do not share with Garrosh what has transpired here today. I could confront him directly, but I see now not all orcs share my view of the Horde.$b$bWho am I to command their allegiance if I must become another dictator to do so?$b$bWhat I can do is aid the Darkspear in fortifying their home while their heroes are abroad for the war. When Vol\'jin returns, we will plan our next move.','',26124),
(70012,'enUS','A Darkhatched Sorcerer has put the boat into Stasis!  Kill it to interrupt the spell.','',26124),
(70013,'enUS','A nearby group of Darkhatched Eggs begins to hatch!','',26124),
(70014,'enUS','Grizzle has given you a portable flamethrower!  Use it on the saurok eggs nearby.','',26124),
(70015,'enUS','You need a Darkmoon Ride Ticket to use the carousel.','You need a Darkmoon Ride Ticket to use the carousel.',26124),
(70016,'enUS','Traitor. You are a disgrace to your race.','Traitor. You are a disgrace to your race.',26124),
(70017,'enUS','These trolls cannot continue to defy the Warchief! They must be dealt with.','These trolls cannot continue to defy the Warchief! They must be dealt with.',26124),
(70019,'enUS','Have you forgotten what it means to be an orc?! We are the blood of the Horde! Not these island beggars.','Have you forgotten what it means to be an orc?! We are the blood of the Horde! Not these island beggars.',26124),
(70022,'enUS','Hellscream will find out about this!','Hellscream will find out about this!',26124),
(70023,'enUS','We are not some mind controlled savages you are dealing with. To defy Hellscream is to defy the greatest orcs of the Horde!','',26124),
(70024,'enUS','Yeah, you\'re next. Unless someone cuts in front of you, that is.','',26124),
(70025,'enUS','Hmm... you\'re second in line. Won\'t be long now.','',26124),
(70026,'enUS','List says like you\'re third in line, $c.','',26124),
(70027,'enUS','You\'re fourth on the list, $r.','',26124),
(70028,'enUS','You are the fifth person in line. Shouldn\'t be too much longer.','',26124),
(70029,'enUS','You\'re... sixth in line.','',26124),
(70030,'enUS','You\'re seventh on my list.','',26124),
(70031,'enUS','You\'re eighth in line, $r.','',26124),
(70032,'enUS','You\'re ninth in line.','',26124),
(70033,'enUS','You are tenth in line, kid.','',26124),
(70034,'enUS','','Well fought, $p, you have proven your strength.',26124),
(70035,'enUS','Busy day today. I show at least ten people in line in front of you. Not too many more than that, though.','',26124),
(70036,'enUS','I\'ve got at least fifteen people waiting in line ahead of you. Hard to tell - it\'s a little busy in here right now.','',26124),
(70037,'enUS','Keep waiting. I count at least twenty people who got here before you did. Maybe more.','',26124),
(70038,'enUS','Tough to tell. I think you\'re number thirty in line? Maybe forty? I lost count a while back.','',26124),
(70039,'enUS','Boss says there\'s at least fifty people in line in front of you.$b$bIt\'s packed in here.','',26124),
(70040,'enUS','Be with you in a moment, $gsir:ma\'am;.','',26124),
(70041,'enUS','','Master Brownstone and his lackeys are notorious for sleeping on the job.',26124),
(70042,'enUS','','I\'ll make make sure those slumps stay on task and get those defenses built.',26124),
(70043,'enUS','Run into the Big Bad Voodoo!','',26124),
(70045,'enUS','We aren\'t giving those savages an inch of ground. Not while I\'m still alive.','',26124),
(70046,'enUS','','The plants are hungry...',26124),
(70047,'enUS','','Now THIS is a discovery!',26124),
(70048,'enUS','You may only choose one quest.','',26124),
(70049,'enUS','Goodbye nearby living beings!  My unique presence is requested in another dimension.','',26124),
(70050,'enUS','','My body returns to the earth...',26124),
(70051,'enUS','','Spread the word that this mighty bush has thorns!',26124),
(70052,'enUS','','Help me feed them.',26124),
(70053,'enUS','Nothing heals like a fistful of needles.','',26124),
(70054,'enUS','Brace yourselves, they\'re coming back around!','',26124),
(70055,'enUS','','Heads up, more Horde!',26124),
(70056,'enUS','','I never thought I\'d see the day! The damsel of Darnassus! Put your big, beefy hands together for Leona Earthwind!',26124),
(70057,'enUS','','And... Meatball.',26124),
(70058,'enUS','I never thought I\'d see the day! Our former champion, out of retirement! Put your big, beefy hands together for Leona Earthwind!','',26124),
(70059,'enUS','And... Meatball.','',26124),
(70060,'enUS','Sons and daughters of the Horde! Today you stand free due to the strength of your heroes and the actions of this champion, $p! The Kor\'kron arrival heralds dark times for the Horde.','',26124),
(70061,'enUS','--ATTENTION $P. YOUR PRESENCE IS REQUESTED IN THE CHAMBER BEHIND THIS UNIT.--','',26124),
(70062,'enUS','','Alright Brownstone, time to get to work!',26124),
(70063,'enUS','Lor\'themar wants a status update on the experiment.','Lor\'themar wants a status update on the experiment.',26124),
(70064,'enUS','This Korune device is similar to the fel crystals we once used to enslave demonic energies. Demon or angry spirit or elemental manifestation of an emotion, the principle is relatively the same.$b$bWe need to see how intact the entity stored within this artifact is, however. Since you have experience with the mogu and the other dangers of Pandaria, would you be so kind as to do the honors?$b$bWe have already disabled most of the protective wards. Simply adjust the intensifier disc on the artifact and be ready for anything that comes out.','',26124),
(70065,'enUS','Lor\'themar wants a status update? Or is it his master Garrosh?$b$bYou should tell them both that this experiment is a waste of time. The mogu drew power by enslaving the living essence of other creatures. Is this something our Warchief should be dabbling in?$b$bThis is the same road Kael\'thas Sunstrider once walked, and it nearly destroyed our people. Why are we taking orders from someone who would have us walk down this road again?','',26124),
(70067,'enUS','You have seen where this Divine Bell is hidden? Very good. Garrosh will be pleased. We will try to locate the site you describe, and will contact you as soon as we find it.','',26124),
(70069,'enUS','You fighting today, $c?','',26124),
(70070,'enUS','Come on in, $r.','',26124),
(70071,'enUS','Let me know if you want to fight, $r.','',26124),
(70072,'enUS','If you want to join the brawl, just let me know.','',26124),
(70073,'enUS','Have a merry time on the merry-go-round!','Have a merry time on the merry-go-round!',26124),
(70074,'enUS','Ride the Darkmoon carousel!','Ride the Darkmoon carousel!',26124),
(70075,'enUS','Ride tickets! Get your carousel ride tickets!','Ride tickets! Get your carousel ride tickets!',26124),
(70076,'enUS','You must pay to ride, friends! Come and get your ride tickets!','You must pay to ride, friends! Come and get your ride tickets!',26124),
(70077,'enUS','Ride tickets for sale! Come get your ride tickets!','Ride tickets for sale! Come get your ride tickets!',26124),
(70078,'enUS','You\'ll need a ride ticket to ride the carousel. Come and get your ride tickets!','You\'ll need a ride ticket to ride the carousel. Come and get your ride tickets!',26124),
(70079,'enUS','Hurry, hurry, hurry! Step right up and purchase your ride tickets!','Hurry, hurry, hurry! Step right up and purchase your ride tickets!',26124),
(70080,'enUS','Ride tickets! Purchase a book of ride tickets here!','Ride tickets! Purchase a book of ride tickets here!',26124),
(70081,'enUS','Enough Rommath! The Sin\'dorei must be free from the yoke of the Horde!','',26124),
(70082,'enUS','Use the Kor\'kron Disguise, then search for intel in the middle of Garrosh\'ar Advance.','Use the Kor\'kron Disguise, then search for intel in the middle of Garrosh\'ar Advance.',26124),
(70083,'enUS','WHAT?! You saw where the mogu hid the Divine Bell? I\'ll alert Lion\'s Landing immediately. We gotta get this thing before Garrosh. We\'ll contact you as soon as we find it!','',26124),
(70084,'enUS','INTERLOPER! Insect! Flea! I shall brush you away!','',26124),
(70085,'enUS','A Darkmoon Ride Ticket has been consumed.','A Darkmoon Ride Ticket has been consumed.',26124),
(70086,'enUS','You fighting today, $c?','You fighting today, $c?',26124),
(70087,'enUS','Let me know if you want to brawl, $r.','Let me know if you want to brawl, $r.',26124),
(70088,'enUS','Blood and honor, $c.','Blood and honor, $c.',26124),
(70089,'enUS','Speak with a guard if you wish to fight, $c.','Speak with a guard if you wish to fight, $c.',26124),
(70090,'enUS','MEATBALL HUNGRY!','',26124),
(70091,'enUS','MEATBALL EAT WHAT MEATBALL WANT!','',26124),
(70092,'enUS','MEATBALL FEEL FUNNY!','',26124),
(70093,'enUS','MEATBALL BELLY GURGLE!','',26124),
(70094,'enUS','MEATBALL BELLY HURTS!','',26124),
(70095,'enUS','You\'ve gained Mogu Power!  Pick up more runes and your power will grow.','',26124),
(70096,'enUS','MEATBALL EAT SMELLY THING NOW!','',26124),
(70097,'enUS','BLLAAAGGGGHHHHH!','',26124),
(70098,'enUS','Thanks for getting me out of there. Not pleasant in the slightest.','',26124),
(70099,'enUS','I need a shower.','',26124),
(70100,'enUS','Stop hiding behind your traps and face me cowards!','',26124),
(70101,'enUS','','Hey, I know you! You\'re that $gguy:lady; that was fightin\' in the arena! You back for more?',26124),
(70102,'enUS','','Welcome back, bruiser. You up for a go?',26124),
(70103,'enUS','','Hey there, $gchief:sweetie;. You up for a fight?',26124),
(70104,'enUS','','Couldn\'t get enough, could ya?',26124),
(70105,'enUS','','Well, well, well... look who\'s back for more!',26124),
(70106,'enUS','','$n! What can I do for ya?',26124),
(70107,'enUS','','The Brawler $ghimself:herself;: $n!$b$bYou here to beat up my monsters some more?',26124),
(70108,'enUS','Won a few fights, I see! Keep it up.','',26124),
(70109,'enUS','You want to get in there and fight some more? I\'ll put you on the list.','',26124),
(70110,'enUS','Oh, welcome back, $n. You here to break a few more faces, or what?','',26124),
(70111,'enUS','Back for more? Fights are only going to get tougher from here on out.','',26124),
(70112,'enUS','You\'re becoming quite the crowd favorite around here, $n.$b$bYou\'re good for business.','',26124),
(70113,'enUS','Oh hey! $n! You want to fight today?','',26124),
(70114,'enUS','Hey, $n. You here to watch the scrubs duke it out in the pit? Or did you come to fight?','',26124),
(70115,'enUS','Feel the flames\' embrace!','',26124),
(70116,'enUS','There is no escape...','',26124),
(70117,'enUS','Your time has come.','',26124),
(70118,'enUS','Burn!!','',26124),
(70119,'enUS','You can\'t run forever!','',26124),
(70120,'enUS','Is it cold in here...?','',26124),
(70121,'enUS','Prepare to be blown away! Kirrawk!!','',26124),
(70122,'enUS','How does it feel to fly?','',26124),
(70123,'enUS','Kir..rawk....','',26124),
(70124,'enUS','You stand no chance. You are but an insect to Fjoll.','',26124),
(70125,'enUS','I see nothing but purple before me...','',26124),
(70126,'enUS','Alright $n!','Alright $n!',26124),
(70127,'enUS','Congratulations!','Congratulations!',26124),
(70128,'enUS','$n! $n! $n!','$n! $n! $n!',26124),
(70129,'enUS','That\'s my $n!','That\'s my $n!',26124),
(70130,'enUS','','Is it gettin\' hot in here?',26124),
(70131,'enUS','','Sheesh, guys! Hurry it up already!',26124),
(70132,'enUS','','Let\'s keep it movin\' in there!',26124),
(70133,'enUS','','Time\'s almost up!',26124),
(70134,'enUS','','Uh oh... I smell smoke...',26124),
(70135,'enUS','','Fire\'s comin\'!',26124),
(70136,'enUS','','Alright, alright. We\'ve got a line going out here, you know.',26124),
(70137,'enUS','','I think we\'ve seen just about enough of this. Am I right?',26124),
(70138,'enUS','Is it getting hot in here? Or is it just me?','',26124),
(70139,'enUS','We don\'t have all night. Hurry it up already!','',26124),
(70140,'enUS','I think it\'s about time to call this fight.','',26124),
(70141,'enUS','Time\'s nearly up!','',26124),
(70142,'enUS','Do you smell smoke?','',26124),
(70143,'enUS','The fire\'s coming!','',26124),
(70144,'enUS','We\'ve got a whole list of people who want to fight, you know.','',26124),
(70145,'enUS','I think we\'ve seen just about enough of this. Am I right?','',26124),
(70146,'enUS','Hey there! Need a ride? Hop on a tallstrider!','',26124),
(70147,'enUS','If you need a ride down, take one of these babies!','',26124),
(70148,'enUS','Welcome to Darkmoon Island! Feel free to ride one of these lovely beasts down to the Faire.','',26124),
(70149,'enUS','Majestic forest striders! Free rides down to the Darkmoon Faire!','',26124),
(70150,'enUS','Fools! I control what makes you fight... Fear, anger, doubt... these are MY weapons!','',26124),
(70151,'enUS','Fear... anger... doubt... these are weapons. MY weapons. And they will unmake you!','',26124),
(70152,'enUS','Get those mangy beasts under control!','',26124),
(70153,'enUS','I thought I smelled a filthy Alliance spy!','',26124),
(70154,'enUS','AUGH!','',26124),
(70155,'enUS','(Placeholder) The \"Harbingers\" movie plays.','(Placeholder) The \"Harbingers\" movie plays.',26124),
(70156,'enUS','A bell cast from the makers\' flesh, shaped by stars\' fire, and bound by the breath of darkest shadow.','',26124),
(70157,'enUS','This bell, when rung, could shake the world and call to the heavens.','',26124),
(70158,'enUS','Taken to war, the bell\'s cacophonous tones stirred the hearts of Lei Shen\'s warriors.','',26124),
(70159,'enUS','It fueled their hatred and anger, lending them strength on the field of battle.','',26124),
(70160,'enUS','The bell\'s screaming voice struck fear and doubt into the hearts of the Emperor\'s enemies, sending them fleeing in his path.','',26124),
(70161,'enUS','Awed by its power, the Thunder King described the instrument as \"the voice of the gods,\" and named it the Divine Bell.','',26124),
(70162,'enUS','Eventually, the Thunder King fell, and the Bell changed hands. Many tried to use its power. Some tried to silence its sound. All failed.','',26124),
(70163,'enUS','Finally, the Korune spellweavers laid claim to their instrument and hid it away. Since then, the Bell has been lost to history.','',26124),
(70164,'enUS','Pathetic! You and your mogu are nothing to the might of the Horde!','',26124),
(70165,'enUS','Now... if you value your life, scum, you\'ll tell me what I need to know.','',26124),
(70166,'enUS','Commander Scargash is filled with rage! Avoid his melee attacks!','',26124),
(70167,'enUS','I will bathe in your blood!','',26124),
(70168,'enUS','Where is the Divine Bell?!','',26124),
(70169,'enUS','','Varian sent you as well? I\'m outnumbered in my own city!$b$b<Jaina\'s eyes flash mischievously.>$b$bLet\'s go about this a different way. Put yourself in my shoes. Imagine that YOU are the leader of the Kirin Tor. $p! The most influential archmage in all of Azeroth!$b$bWhat would YOU do?',26124),
(70170,'enUS','Ha... <cough>... you young races... so impatient, petulant. Orc... you cannot even control yourself... your own rage, your own fear.','',26124),
(70171,'enUS','I... will tell you... nothing.','',26124),
(70172,'enUS','','Spoken like a stalwart Alliance $c! Believe me, I understand the sentiment.$b$bNow then, as leader of the Kirin Tor and a faithful part of the Alliance, what would you do about the Sunreavers? True, they are advocates of the Horde. But they have been allies and productive members of the Kirin Tor for over 2000 years. This city is their home.$b$BWould you expel them?',26124),
(70173,'enUS','Yes. Horde is Horde.','Yes. Horde is Horde.',26124),
(70174,'enUS','','<Jaina\'s eyes grow sad.>$b$bSo... you would purge the city? Cast the Sunreavers from their homes? The very same Sunreavers who helped humans discover magic in the first place?$b$bYou and I are obviously very different. I suppose I see my role - and the mission of the Kirin Tor - a little differently. My mind is set. Would you like to hear what I think?',26124),
(70175,'enUS','Are you sure?','Are you sure?',26124),
(70176,'enUS','You WILL, or I will shove my boot down your throat!','',26124),
(70177,'enUS','Not if they renounced the Horde.','Not if they renounced the Horde.',26124),
(70178,'enUS','','<Jaina brushes her hair from her eyes, deep in thought.>$b$bYou\'re so passionate for your cause and clear in your convictions. Believe me when I say that the Sunreavers are the same. The Horde is their family.$b$bNot all of them support Garrosh. But they\'re not about to abandon their own people... I couldn\'t ask them to do so without tearing the Kirin Tor apart.$b$bThe Kirin Tor is sacred to me. We need to stay united.',26124),
(70179,'enUS','I would struggle to maintain our neutrality.','I would struggle to maintain our neutrality.',26124),
(70180,'enUS','','<Jaina smiles.>$b$bIf only we all shared your strength and conviction! To be honest, I struggle. Every. Day.$b$bBut you are right. The Kirin Tor is bigger than you, me, Alliance or Horde. I have a responsibility to preserve it, and to use its powers wisely.$b$bYou and I seem to agree. I doubt the King sees it that way. But... do you think we can convince Anduin?',26124),
(70181,'enUS','','Ah! A very bold decision in times like these. Your honesty is refreshing!$b$bTell me, leader of the Kirin Tor, what if the Horde killed your friends? Your family? Destroyed everything you had. Could you maintain your convictions even then, Archmage $p?',26124),
(70182,'enUS','','<Jaina warms to you immediately.>$b$bA kindred soul! Thank you, $p, for your honesty. You seem to understand my struggle. Every day, the hard decisions. Every night... the nightmares.$b$bBut I have a responsibility to preserve the Kirin Tor. I\'m glad you\'re with me on this. The King would never see it this way. Do you think we can explain it to Anduin?',26124),
(70183,'enUS','*Ahem* Many greetings to you, traveler!','',26124),
(70184,'enUS','Iiiiiiiiii\'m back Wikkets!','',26124),
(70185,'enUS','Ha... <cough>... the Divine Bell... what could you hope to do with it?','',26124),
(70186,'enUS','The Bell... speaks with the voice of the gods...','',26124),
(70187,'enUS','<cough>... you are impudent, impatient, childish. You cannot even... control yourself, your own fear... your own rage.','',26124),
(70188,'enUS','How could you hope... <cough>... to control the Bell?','',26124),
(70189,'enUS','Graaagh!','',26124),
(70190,'enUS','Fine. You\'ve made your choice, mogu. Now, you die...','',26124),
(70191,'enUS','Garrosh! Stay your hand!','',26124),
(70192,'enUS','Elf! What is this treachery?!','',26124),
(70193,'enUS','I didn\'t see my people die at Mogujia to have you snuff out our only remaining avenue to the Bell.','',26124),
(70194,'enUS','...Very well. He is yours, Blood Elf.','',26124),
(70195,'enUS','Whether he talks or not, I\'ll tear this continent to pieces if it means I find what I seek... if it means glory for the Horde.','',26124),
(70196,'enUS','But, elf...','',26124),
(70197,'enUS','Disrespect me again, and I\'ll have your head on a pike outside the gates of Orgrimmar.','',26124),
(70198,'enUS','Good luck with your interrogation.','',26124),
(70199,'enUS','','Shhhhh! You\'ll blow my cover!',26124),
(70200,'enUS','Are you the agent that is following Connelly?','Are you the agent that is following Connelly?',26124),
(70201,'enUS','He is our only way to find the bell. We WILL make him talk. Give us time.','',26124),
(70202,'enUS','Well... that was interesting. Let\'s go meet with Lor\'themar back outside.','',26124),
(70203,'enUS','He\'s impulsive, but we\'ll get results. He\'ll see our way is right.','',26124),
(70204,'enUS','Debug Error: Spell Failed. Bug This!','',26124),
(70205,'enUS','Alright everyone. Make preparations to take the prisoner back to the Vale. We\'ll be handing him over to Hellscream once he\'s had some time to cool off.','',26124),
(70206,'enUS','We\'ll be handing him over to Hellscream once he\'s had some time to cool off. Can\'t have him destroying our prize, can we?','',26124),
(70207,'enUS','$p - good work. Without your assistance, I\'m afraid this whole business would have ended quite nastily.','',26124),
(70208,'enUS','Ha! Didn\'t expect to see me here did you? The Monkey King does not delegate duelery! Now, are you hero? Or are you wikket?','',26124),
(70210,'enUS','Okee dokee! Let\'s see what you got.','',26124),
(70211,'enUS','In pieces three the mallet be. Handle, head and ointment. You ring the bell without the mallet? You going to get an ear and face full of evil.','',26124),
(70212,'enUS','No! Silly wikket cannot take the hozen mighty rod!','',26124),
(70213,'enUS','No! No no no! No more party! This still Ingoo Ingoo\'s village!','',26124),
(70214,'enUS','Stop! Stop partying! This not the real Monkey King! Monkey King die long long long long long long long time ago!','',26124),
(70215,'enUS','No! No singing!','',26124),
(70216,'enUS','Monkey King is not in charge! Chief Ingoo Ingoo in charge! Listen to the Chief!','',26124),
(70217,'enUS','No more brew! Remember last time with Captain Ook? Want that to happen again?','',26124),
(70218,'enUS','No! Stop playing! Stop! Stop! Stop!','',26124),
(70219,'enUS','You no king! Chief Ingoo Ingoo not vote for you!','',26124),
(70220,'enUS','Monkey King is a big big wikket!','',26124),
(70221,'enUS','My sparkly!','',26124),
(70222,'enUS','','It\'s best not to get on the bad side of those that prepare your food. However, I\'m not sure this patron has anything but a bad side...',26124),
(70223,'enUS','','They say the eyes are the window to the soul. If that\'s the case, I\'m guessing this guest and their soul have something to hide.',26124),
(70224,'enUS','','This guest wears a memento of a love lost. I guess it\'s true what they say; every love story has its thorns, just like every night has its dawn.',26124),
(70225,'enUS','I\'m ready for the first clue.','I\'m ready for the first clue.',26124),
(70226,'enUS','Ok, hit me with another clue!','Ok, hit me with another clue!',26124),
(70227,'enUS','This is easy! I\'m ready for the next clue.','This is easy! I\'m ready for the next clue.',26124),
(70228,'enUS','I got this! Give me the last clue.','I got this! Give me the last clue.',26124),
(70230,'enUS','Assemble the Mallet.','Assemble the Mallet.',26124),
(70231,'enUS','Is this your drink order?','Is this your drink order?',26124),
(70232,'enUS','You didn\'t happen to order a Rusty Dagger did you?','You didn\'t happen to order a Rusty Dagger did you?',26124),
(70233,'enUS','Does this drink belong to you?','Does this drink belong to you?',26124),
(70234,'enUS','','Why in the world would I order that?!',26124),
(70235,'enUS','','How dare you!',26124),
(70236,'enUS','','Who do you think you are?! The nerve!',26124),
(70237,'enUS','','Finally! I thought I was never going to get my drink!',26124),
(70238,'enUS','','Of course it\'s my drink! I invented this ya know!',26124),
(70239,'enUS','','Who else would this belong to? What\'s that funny look for? You look like I was about to hit you!',26124),
(70240,'enUS','It\'s about time! I\'m parched over here!','',26124),
(70241,'enUS','Now that is a sight for sore eyes!','',26124),
(70242,'enUS','Now I can really get this party started!','',26124),
(70243,'enUS','Yuck! That looks disgusting!','',26124),
(70244,'enUS','I am offended that you would think that belongs to me!','',26124),
(70245,'enUS','You know the service down here just keeps getting worse and worse!','',26124),
(70246,'enUS','','Get that out of here before you spill it on me!',26124),
(70247,'enUS','','The audacity!',26124),
(70248,'enUS','','Look at me! Do I look like I would order that?!',26124),
(70249,'enUS','','Don\'t be ridiculous. Of course it\'s my drink!',26124),
(70250,'enUS','','It\'s about time you showed up with this!',26124),
(70251,'enUS','','Took you long enough!',26124),
(70252,'enUS','','Can\'t a girl just get a drink without being hassled?',26124),
(70253,'enUS','','Something about watching people fight to the death really warms my heart!',26124),
(70254,'enUS','There is not nearly enough dancing in this club!','',26124),
(70255,'enUS','','Can I get you something to drink?',26124),
(70256,'enUS','So ye want me to go join the Alliance front in this... Pandaria... eh?','',26124),
(70257,'enUS','Fluffy wikkets stole the mallet head! Kunzen hozen lost it many years ago. Now the fluffy wikkets hide inside their lair and worship the head like it some kind of fancy shmancy carrot.$b$bBe careful, those fluffy wikkets bite hard.','',26124),
(70258,'enUS','','The Kirin-Tor has a legacy of abuse. Kel\'thuzad turned his knowledge of the arcane arts toward Necromancy.',26124),
(70261,'enUS','Things are rarely what they seem, Tyrande. And my son tells me this is a sacred place.','',26124),
(70262,'enUS','They\'re defending a fixed position. I\'m not going to play their game. We\'ll draw them out.','',26124),
(70263,'enUS','You three are my eyes and ears. Fan out! Prepare a defense!','',26124),
(70264,'enUS','Stay back! Don\'t let them lure you in.','',26124),
(70265,'enUS','Stay away from the temple doors, you\'re playing into their hands.','',26124),
(70266,'enUS','Ready our defenses. They have to come out eventually.','',26124),
(70267,'enUS','Stand your ground! Wait \'em out.','',26124),
(70268,'enUS','Get those defenses ready.','',26124),
(70269,'enUS','Use the terrain to our advantage.','',26124),
(70270,'enUS','We need to support one another. They\'ll target any weakness.','',26124),
(70271,'enUS','We\'re almost ready. Keep on working!','',26124),
(70272,'enUS','Force them into bottlenecks. Let them think they can win...','',26124),
(70273,'enUS','Don\'t charge in. Let them make the first mistake.','',26124),
(70274,'enUS','This terrain is ours. Make them pay for every inch.','',26124),
(70275,'enUS','Keep working! We\'ll win on our terms.','',26124),
(70276,'enUS','Make use of every resource! Leave them nowhere to run!','',26124),
(70277,'enUS','Patience, Tyrande.','',26124),
(70278,'enUS','Patience, Tyrande. We\'ll have our victory, but we\'re not going in unprepared.','',26124),
(70279,'enUS','I won\'t throw away Alliance lives. I will accept nothing less than total victory.','',26124),
(70280,'enUS','Good. That means they\'re about to break.','',26124),
(70281,'enUS','Good. The plan is coming together.','',26124),
(70282,'enUS','Good sturdy dwarven construction. That oughta do some damage.','',26124),
(70283,'enUS','I see our jinyu allies are prepared. How go the rest of the preparations?','',26124),
(70284,'enUS','Ahh, gnomish ingenuity! The Horde won\'t know what hit \'em.','',26124),
(70285,'enUS','Excellent work! Let\'s see what these pandaren homesteaders are capable of.','',26124),
(70286,'enUS','They\'re coming. Get behind the defenses!','',26124),
(70287,'enUS','Come out and count them, coward!','',26124),
(70288,'enUS','There is no army here. Only a handful of heroes stand between you and the King of Stormwind. Are you afraid?','',26124),
(70289,'enUS','Predictable. Fall back behind the lines - let them come!','',26124),
(70290,'enUS','It was a costly victory, but it could have been much worse. You have earned this reward.','',26124),
(70291,'enUS','While we mourn the fallen, many more would be lost if not for your efforts. Please accept this gift of gratitude from the Alliance.','',26124),
(70292,'enUS','Very good work! Our defenses held with minimal casualties. Please accept this reward for your outstanding effort.','',26124),
(70293,'enUS','A total victory! Thanks to your resourcefulness and efficiency, we didn\'t lose a single soul. Accept this reward, along with my sincere gratitude.','',26124),
(70294,'enUS','The day is ours! And not a drop of blood was shed on holy ground.','',26124),
(70295,'enUS','There was a time where I would have done the same. But I\'ve learned a lot over the years. I\'ve fallen for too many of Garrosh\'s tricks.','',26124),
(70296,'enUS','From now on, we define the terms of the engagement.','',26124),
(70297,'enUS','Tyrande, I may not be a politician. But I am a fighter. I know we can win this war.','',26124),
(70298,'enUS','We just need to stand together. You have to trust me. Know that I will do the right thing. If we act as one, we cannot fail.','',26124),
(70299,'enUS','','We have them cornered inside the temple. We should strike now!',26124),
(70300,'enUS','','All the more reason to purify it.',26124),
(70301,'enUS','','You are wasting precious time.',26124),
(70302,'enUS','','We are wasting time. We should move in for the kill!',26124),
(70303,'enUS','','You are being tentative, Varian. You must be decisive if you wish to lead the Alliance.',26124),
(70304,'enUS','','Why do we not attack them outright?',26124),
(70305,'enUS','','They mock us from within the temple.',26124),
(70306,'enUS','','Our fortifications are ready.',26124),
(70307,'enUS','','I would have charged right in. Many more lives would have been lost in my rush for victory.',26124),
(70308,'enUS','','I see that now. Our strength is yours to command, High King. May this be the first of many victories.',26124),
(70309,'enUS','A test! A trial of patience. Will the wolf behave as a warrior... or a King?','',26124),
(70310,'enUS','A sword is the weapon of a warrior, but patience is the weapon of kings.','',26124),
(70311,'enUS','This day brings victory, but more difficult trials lie ahead...','',26124),
(70312,'enUS','Alliance dogs! Where are your teeth?','',26124),
(70313,'enUS','Bring up the grunts. Attack!','',26124),
(70314,'enUS','For the warchief!','',26124),
(70315,'enUS','Is this how you fight your battles?','',26124),
(70316,'enUS','Your Alliance is WEAK!','',26124),
(70317,'enUS','I am done with you!','',26124),
(70318,'enUS','Cowards!','',26124),
(70319,'enUS','Pathetic.','',26124),
(70320,'enUS','Is this your best?','',26124),
(70321,'enUS','I... could only see darkness... Thank you.','',26124),
(70322,'enUS','Light... what is this light? Bless you...','',26124),
(70323,'enUS','Finally, an end to the suffering...','',26124),
(70324,'enUS','Trapped here... forever... am I... free at last?','',26124),
(70325,'enUS','My spirit leaves this cursed place at last...','',26124),
(70326,'enUS','At last, an end to the horror...','',26124),
(70327,'enUS','The Divine Bell means a great deal to the Horde.$b$bThe Warchief is counting on us.','',26124),
(70328,'enUS','|TInterface\\Icons\\ability_thunderking_thunderstruck.blp:20|t%s begins to cast |cFFFF0000|Hspell:135096|h[Thunderstruck]|h|r! Run!','',26124),
(70329,'enUS','Tong! Something to eat, please.','',26124),
(70330,'enUS','The High King. Varian Wrynn - Leader of the Alliance.','',26124),
(70331,'enUS','Did you know, he was once a gladiator? Oh yes, I\'ve been doing my research.','',26124),
(70332,'enUS','Suffering from amnesia, he fought for his life in Horde arenas.','',26124),
(70333,'enUS','There, he earned the name \"Lo\'Gosh,\" or \"Ghost Wolf.\"','',26124),
(70334,'enUS','He IS a fighter. But... is he a leader?','',26124),
(70335,'enUS','Think about it! His enemies took advantage of my father\'s Cataclysm.','',26124),
(70336,'enUS','Horde soldiers thundered across the realm in the wake of the devastation.','',26124),
(70337,'enUS','Varian Wrynn didn\'t use the disaster to gain a military advantage.','',26124),
(70338,'enUS','Is this because he is weak...? Or because he is principled?','',26124),
(70339,'enUS','Here\'s the bigger question: Can principles win a war?','',26124),
(70340,'enUS','Make no mistake. Pandaria will challenge your King.','',26124),
(70341,'enUS','Let us see what he is truly made of.','',26124),
(70342,'enUS','Let us see if your Alliance has what it takes to rule Azeroth.','',26124),
(70343,'enUS','Garrosh Hellscream! Warchief of the Horde.','',26124),
(70344,'enUS','He did not always command such power.','',26124),
(70345,'enUS','On Draenor, he was a miserable wretch. The actions of his father hung heavy on his heart.','',26124),
(70346,'enUS','I understand you, Garrosh. I know what it is like to bear the weight of your father\'s deeds.','',26124),
(70347,'enUS','A warrior like Garrosh comes to power with something to prove.','',26124),
(70348,'enUS','Your Horde finds itself at a turning point. This war will define you.','',26124),
(70349,'enUS','What IS the Horde?','',26124),
(70350,'enUS','Is it an instrument of vengeance, hellbent to carve out a future for its people?','',26124),
(70351,'enUS','Is it a refuge for those who need shelter, a commonwealth of the downtrodden, built for mutual support?','',26124),
(70352,'enUS','Or is it an alliance of convenience, a confederacy of unlikely partners free to pursue their own agendas?','',26124),
(70353,'enUS','This is my question to you: What is the SOUL of the Horde?','',26124),
(70354,'enUS','We will find the answers here in Pandaria.','',26124),
(70355,'enUS','Show me what your Horde is made of, Champion!','',26124),
(70356,'enUS','Prove to me that your Horde is worthy of ruling over Azeroth.','',26124),
(70357,'enUS','You have proven to be an exemplary hero. A champion for your cause.','',26124),
(70358,'enUS','Do you recall our earlier conversation?','',26124),
(70359,'enUS','We discussed the merits of your High King. I have been observing him closely.','',26124),
(70360,'enUS','It is true: he has the spirit of the wolf. And he fights like a wolf.','',26124),
(70361,'enUS','Having seen him in action, I now know what that means.','',26124),
(70362,'enUS','Wolves are pack animals.','',26124),
(70363,'enUS','Your King is calling his pack to him, assembling an Alliance in the truest sense of the word.','',26124),
(70364,'enUS','His journey is long. He has only taken the first steps.','',26124),
(70365,'enUS','But with heroes like you in his pack, there is little your Alliance cannot accomplish.','',26124),
(70366,'enUS','Tong: fetch my things!','',26124),
(70367,'enUS','Your dedication to your cause deserves to be rewarded.','',26124),
(70368,'enUS','Like you, I continue to refine my skills here in Pandaria. I think you will appreciate the outcome.','',26124),
(70369,'enUS','Choose your reward!','',26124),
(70370,'enUS','Stay vigilant, hero. The return of the Thunder King is both a threat... and an opportunity!','',26124),
(70371,'enUS','You have proven to be an exemplary hero. A champion for your cause.','',26124),
(70372,'enUS','Do you recall our earlier conversation?','',26124),
(70373,'enUS','We spoke of your Warchief. His inner conflicts and his outer conquests.','',26124),
(70374,'enUS','I asked you: Who is the soul of the Horde?','',26124),
(70375,'enUS','Your efforts on Pandaria\'s southern shores and elsewhere have given me my answer.','',26124),
(70376,'enUS','YOU are the soul of the Horde.','',26124),
(70377,'enUS','Your actions in the coming weeks will come to define your people.','',26124),
(70378,'enUS','I want to make sure that you are properly equipped for the trials ahead.','',26124),
(70379,'enUS','Welcome back, hero of the Alliance! How fares the battle along the coast?','',26124),
(70380,'enUS','Have you killed him? Bloodhilt served the Horde in Southern Barrens. You\'ve avenged a great many lives today, champion.','',26124),
(70381,'enUS','Welcome back, champion of the Horde! How fares the battle along the coast?','',26124),
(70382,'enUS','So, General Twinbraid is dead? He was a pivotal figure in the Alliance push through Southern Barrens. Impressive work.','',26124),
(70383,'enUS','','Stay vigilant, hero. This place has been sealed for centuries. Who knows what we will encounter within.',26124),
(70384,'enUS','','There it is, hero! The Divine Bell!',26124),
(70385,'enUS','','What was that thing? No matter. We will strike down any who stand in our way.',26124),
(70386,'enUS','','We must take it somewhere safe. Sentinels! Let\'s get to work.',26124),
(70387,'enUS','','Horde. It\'s a shame you were so slow to get here. The Divine Bell is already ours. Rangers! STRIKE!',26124),
(70388,'enUS','','Arg! My archers should have stopped you! Sentinels! Now!',26124),
(70389,'enUS','','Very well. I will face you myself. This is for the Alliance!',26124),
(70390,'enUS','','My death... means... nothing. The Divine Bell is already in Darnassus. You filthy Horde... will never... have it!',26124),
(70391,'enUS','','Denizens of the sky, attack!',26124),
(70392,'enUS','','You will die here, by my blade!',26124),
(70393,'enUS','','I strike from the shadows!',26124),
(70394,'enUS','How did that story go again?','How did that story go again?',26124),
(70395,'enUS','LOUD NOISES!','',26124),
(70396,'enUS','No! Monkey King no take rod! You no take rod! This not even real Monkey King.$b$bChief Ingoo Ingoo have rod from father Ingoo Ingoo, and his father before him, and his father before him.$b$bMonkey King give rod to my family in long long ago time. My family becomes chiefs.$b$bNo hozen live that long! None!','',26124),
(70397,'enUS','But that is the real Monkey King.','But that is the real Monkey King.',26124),
(70398,'enUS','Time is of the essence, $n. Proveditor Grantley may be able to help you get back to Stormwind. Of course, everything has a price.','',26124),
(70399,'enUS','Poor Chief Ingoo Ingoo. His family forget what rod was for. He so mad.$b$bIf he keeps, he will corrupt his people. Very sad.','',26124),
(70400,'enUS','','Be silenced, Sunreaver!',26124),
(70401,'enUS','','The Kirin Tor will not tolerate insurrection.',26124),
(70402,'enUS','','You brought this on yourselves, Sunreavers.',26124),
(70403,'enUS','','You had your chance to run.',26124),
(70404,'enUS','','Dalaran is a better place without your kind.',26124),
(70405,'enUS','','Did you think your actions would have no consequence?',26124),
(70406,'enUS','','You chose your warchief over the Kirin-Tor.',26124),
(70407,'enUS','Now... YOU must die!','',26124),
(70408,'enUS','Enter the portal!','',26124),
(70409,'enUS','There once was a jibby nib mallet all shiny and divine.','',26124),
(70410,'enUS','But the ookin\' bell it was meant for could never be mine.','',26124),
(70411,'enUS','The mogu had stolen the bell, what is a hozen to do?','',26124),
(70412,'enUS','Think of the horror if those dookers stole the mallet too.','',26124),
(70413,'enUS','Mogu are not bright, they fail to see things for what they are.','',26124),
(70414,'enUS','The Monkey King broke the mallet and sent the pieces afar.','',26124),
(70415,'enUS','My Hozen took the pieces and scattered them across the lands,','',26124),
(70416,'enUS','Disguised as \"nifty nibs\", never to fall into mogu hands.','',26124),
(70417,'enUS','The head, the handle, these two must be made as one.','',26124),
(70418,'enUS','Combined with evil\'s ointment, the bell\'s evil can be undone.','',26124),
(70419,'enUS','If \"Garrosh\" has the bell than there is only one thing to do,','',26124),
(70420,'enUS','I\'ll send for my hozen friends, the mallet must be made anew.','',26124),
(70421,'enUS','[PH] Some insult about how the Alliance is weak and boast about how Garrosh is awesome.','',26124),
(70422,'enUS','Do not incite violence on my temple grounds, $p. Be patient.','Do not incite violence on my temple grounds, $p. Be patient.',26124),
(70423,'enUS','','Varian sent me to keep an eye on the temple while you finish building the defense.\n\nHave a little patience and don\'t approach the temple until Varian gives the word.',26124),
(70424,'enUS','','Greetings, friend.',26124),
(70425,'enUS','We are to surround the temple with defenses. Can your druids help?','We are to surround the temple with defenses. Can your druids help?',26124),
(70427,'enUS','','Come children. May Elune guide our deeds this day.',26124),
(70428,'enUS','This smells like a trap, but we have no time to lose. Let\'s go!','',26124),
(70429,'enUS','','Meet us west of the temple, $rt. We shall require your aid.',26124),
(70431,'enUS','It just so happens that Mishi returned it to me. You should be more careful! This artifact is a rare one of a kind piece.','',26124),
(70432,'enUS','Do you honestly believe you can defeat me?','Do you honestly believe you can defeat me?',26124),
(70433,'enUS','Another challenge?','Another challenge?',26124),
(70435,'enUS','We have a winner!  $n has won SECOND PLACE in the tournament!','',26124),
(70436,'enUS','We have a winner!  $n has won THIRD PLACE in the tournament!','',26124),
(70437,'enUS','|TInterface\\Icons\\spell_arcane_massdispel.blp:20|t |cFFFF0000|Hspell:132275|h[Obliteration]|h|r killed you. Move out of the energy vortex before it deactivates.','|TInterface\\Icons\\spell_arcane_massdispel.blp:20|t |cFFFF0000|Hspell:132275|h[Obliteration]|h|r killed you. Move out of the energy vortex before it deactivates.',26124),
(70439,'enUS','Some day we\'re havin\', eh?\n\nMe poor gryphons...','',26124),
(70440,'enUS','Fight with us. |cFF0008E8(Daggin will follow you.)|r','Fight with us. |cFF0008E8(Daggin will follow you.)|r',26124),
(70441,'enUS','Let\'s do this!','',26124),
(70448,'enUS','Move along. This doesn\'t concern you.','Move along. This doesn\'t concern you.',26124),
(70449,'enUS','You\'ll stay out of this if you know what\'s good for you.','You\'ll stay out of this if you know what\'s good for you.',26124),
(70450,'enUS','Can you believe this? These Silver Covenant goons are trying to shake us down.','Can you believe this? These Silver Covenant goons are trying to shake us down.',26124),
(70451,'enUS','I heard shouting through the pipes - what\'s happening?','I heard shouting through the pipes - what\'s happening?',26124),
(70452,'enUS','What is all this nonsense about a\"purge?\"','What is all this nonsense about a\"purge?\"',26124),
(70453,'enUS','Heya! I\'m Tak-Tak. I\'ll take you to the Vale now, just like the big green guy over there told me to.','',26124),
(70454,'enUS','Wait an ookin\' jibbet! Are you the wikket dat cleared the beach of jerb-derkin\' Alliance slicky-siders?','',26124),
(70455,'enUS','There I was, minding my own business, enjoying a nice game of cards when these Silver Covenant... slugs came around telling us to hand over our belongings. What gives?','There I was, minding my own business, enjoying a nice game of cards when these Silver Covenant... slugs came around telling us to hand over our belongings. What gives?',26124),
(70456,'enUS','Have the Silver Covenant lost their mind? Surely the Kirin Tor won\'t stand for this!','Have the Silver Covenant lost their mind? Surely the Kirin Tor won\'t stand for this!',26124),
(70457,'enUS','They said Lady Proudmoore wanted us out. I... I don\'t understand.','They said Lady Proudmoore wanted us out. I... I don\'t understand.',26124),
(70458,'enUS','It\'s not safe here anymore. You need to evacuate Dalaran.','It\'s not safe here anymore. You need to evacuate Dalaran.',26124),
(70459,'enUS','You did all of that? You bammin\'!','',26124),
(70460,'enUS','You know, big brown guy was lookin\' for a trip up north earlier. Some Garrod... err... Ganosh... err... anyway, I didn\'t get his name.','',26124),
(70461,'enUS','He looked real important. Tak-Tak try to chitchatter with \'im, but he jus\' stared at me so I shut my jabber real quick.','',26124),
(70462,'enUS','Well, if you say so.','As long as you\'ve got my back...',26124),
(70463,'enUS','Oh, looks like we\'re here!','',26124),
(70464,'enUS','Good luck out there.','',26124),
(70465,'enUS','We meet again. You havin\' a good day now?','',26124),
(70466,'enUS','Anyway, Tak-Tak hear a lot of stuff goin\' on at the camp. I heard that your Warchief Garrosh was lookin\' around the Vale o\' Eternal Blossoms.','',26124),
(70467,'enUS','Did you and the pretty elves find somethin\' while you was there?','',26124),
(70468,'enUS','I heard somethin\' about a bell, made by those crazy mogu... thousands of years ago. Jimeny wikkets!','',26124),
(70469,'enUS','I guess I can head back to Silvermoon...','Leave Dalaran? Where will I even go...',26124),
(70470,'enUS','Is yer Warchief gonna look fer that bell now? Anything mogu is dangerous... an\' powerful.','',26124),
(70471,'enUS','Anyway, we\'re almost to Binan Village. You mus\' be doin\' somethin\' real ookin\' important.','',26124),
(70472,'enUS','A big pandaren came and asked me to take you there.','',26124),
(70473,'enUS','Don\'t tell anyone where you\'re goin\', he said!','',26124),
(70474,'enUS','Tak-Tak good on his word. Tak-Tak been real quiet. Me helpful!','',26124),
(70475,'enUS','Ok, we\'re here. Get out!','',26124),
(70476,'enUS','Headin\' back up to Kun-Lai Summit, wikket?','',26124),
(70477,'enUS','Last time we met, you were headin\' to Binan Village to see your pandaren friend.','',26124),
(70478,'enUS','Did you get your business done?','',26124),
(70479,'enUS','Anyway, I saw some more pretty elves headin\' north earlier. Lots of elves.','',26124),
(70480,'enUS','They\'re lookin\' for that bell. Big, powerful bell! You lookin\' for it too, wikket?','',26124),
(70481,'enUS','This is an outrage! Aethas will hear about this!','Fine, but I\'m taking this straight to the Archmage.',26124),
(70482,'enUS','Here we are. See ya!','',26124),
(70483,'enUS','Ooh, big stuff\'s shakin\'.','',26124),
(70484,'enUS','I heard some pretty elfs got slap-slapped up at Mogujia.','',26124),
(70485,'enUS','Say, wasn\'t you there? Did you see it?','',26124),
(70486,'enUS','Anyway, big elf leader, Lor\'them-somethin\'... he\'s real mad!','',26124),
(70487,'enUS','The blood elves weren\'t prepared to fight the Korune mogu. Lotta blood elves died, but I heard you saved many survivors.','',26124),
(70488,'enUS','Sure. I was getting tired of this sewer anyway.','Don\'t have to tell me twice - I\'ve got debts in this city I\'d like to leave behind.',26124),
(70489,'enUS','You probably askin\', then what happen?','',26124),
(70490,'enUS','Well then what happen is ranger elf\'s people got jerbed in the nerb! Ouch!','',26124),
(70491,'enUS','He mad, bro, real mad!','',26124),
(70492,'enUS','He\'s still loyal to your Warchief, but he wants to do things differently.','',26124),
(70493,'enUS','Garrosh all about strength! Lor\'themar all about strategy.','',26124),
(70494,'enUS','Even a simple hozen like Tak-Tak can see that!','',26124),
(70495,'enUS','Oh look, we are here. Later!','',26124),
(70496,'enUS','So how did your trip to the Valley of Emperors go, wikket?','',26124),
(70497,'enUS','It\'s cold up there. And dangerous!','',26124),
(70498,'enUS','Too many mogu. Only our foolish mountain hozen cousins live up there.','',26124),
(70499,'enUS','They so ookin\' stupid!','',26124),
(70500,'enUS','I heard you found somethin\'... or someone. You caught one o\' those mogu, didn\'t you?','',26124),
(70501,'enUS','Maybe nasty mogu tell you where to find that bell.','',26124),
(70502,'enUS','Thank you for the warning. Be safe.','I will go. Shorel\'aran.',26124),
(70503,'enUS','Tak-Tak also hear mogu using dark magic.','',26124),
(70504,'enUS','Hozen call it... ikk! You call it sha, but ikk is SO much better name!','',26124),
(70505,'enUS','Anyways, those crazy mogu using ikk juju.','',26124),
(70506,'enUS','Even foolish hozen know ikk is worse than anything. Don\'t eat dook, don\'t touch ikk!','',26124),
(70507,'enUS','You think ookin\' is nasty word? You ain\'t ikkin\' know anything.','',26124),
(70508,'enUS','I ain\'t flyin\' a kite to Silvermoon City! You crazy?','',26124),
(70509,'enUS','Yo.','',26124),
(70510,'enUS','I ain\'t seen you in a lick, wikket. How you been?','',26124),
(70511,'enUS','Tak-Tak been listenin\'. Everybody think oh, Tak-Tak is a stupid hozen, he don\'t know anything.','',26124),
(70512,'enUS','But Tak-Tak know a lot about things!','',26124),
(70513,'enUS','Even big orc general, Nazgrim! He talk so loud! Tak-Tak hear everything!','',26124),
(70514,'enUS','Tak-Tak know this...','',26124),
(70515,'enUS','Lor\'themar elf ranger thinkin\' about leavin\' the Horde!','',26124),
(70516,'enUS','Baine wonderin\' if Garrosh might not be fit for chief.','',26124),
(70517,'enUS','And Garrosh is losin\' patience over findin\' that ookin\' bell. Those mogu hide it good!','',26124),
(70518,'enUS','I hear, Garrosh is goin\' to torture that mogu prisoner until he talks.','',26124),
(70519,'enUS','Anyway, you goin\' that way.','',26124),
(70520,'enUS','You should not have interfered!','You don\'t belong here!',26124),
(70521,'enUS','Tell me if you find anything out, buddy!','',26124),
(70522,'enUS','You know, they sayin\' your name all over camp!','',26124),
(70523,'enUS','And me, Tak-Tak, me is your friend! Bam!','',26124),
(70524,'enUS','Horde at camp buzzin\'. Everybody workin\'.','',26124),
(70525,'enUS','Since you saw Shan Kien\'s memory, they been sendin\' scouting parties out.','',26124),
(70526,'enUS','And now, it looks like they found where the mogu hid that bell.','',26124),
(70527,'enUS','Good luck. I hope you find that bell.','',26124),
(70528,'enUS','I\'m not flying a kite to Darnassus, wikket. I don\'t even know where that is! Take that portal over there.','',26124),
(70529,'enUS','You think I know where Dalaran is, $Gbuddy:lady;? I can\'t even find my own tail! Sometimes it\'s there, sometimes it isn\'t.$B$BYou know what I heard though, $n?$B$BDook\'s got real since last time.$B$BI heard you went to Darnassus and got the Divine Bell.$B$BBut some human lady... Jana or somethin\'... she got real mad!$B$BShe says the Horde betrayed her trust or something\'... and she\'s kickin\' all your people out of her city!$B$BOrc general Nazgrim say we need to help them vacuum... vacuate... err... evocate... err... get the ook out!','',26124),
(70530,'enUS','Dook\'s got real since last time.','',26124),
(70531,'enUS','I heard you went to Darnassus and got the Divine Bell.','',26124),
(70532,'enUS','But some human lady... Jana or somethin\'... she got real mad!','',26124),
(70533,'enUS','But some human lady... Jana or somethin\'... she got real mad!','',26124),
(70534,'enUS','Orc general Nazgrim say we need to help them vacuum... vacuate... err... evocate... err... get the ook out!','',26124),
(70535,'enUS','I got a bad feelin\' about this.','',26124),
(70536,'enUS','Your Warchief has got that bell, and he\'s goin\' to use it to make the Horde stronger.','',26124),
(70537,'enUS','But I think that bell has got some power... and it\'s bad.','',26124),
(70538,'enUS','It jerbs the nib right outta my derb!','',26124),
(70539,'enUS','Nobody, not hozen, not human, not orc... should use the sha.','',26124),
(70540,'enUS','Ikk\'s gonna hit da land.','',26124),
(70541,'enUS','Be careful.','',26124),
(70542,'enUS','I hope I see you again, friend.','',26124),
(70543,'enUS','They attacked our ships from below, and will advance on the keep at any moment!\n\nWe don\'t have the numbers to stop them...','',26124),
(70544,'enUS','Fight with us. |cFF0008E8(Admiral Taylor will follow you.)|r','Fight with us. |cFF0008E8(Admiral Taylor will follow you.)|r',26124),
(70545,'enUS','We\'ll hold Lion\'s Landing or die trying!','',26124),
(70546,'enUS','What do you think you\'re doing?','Stop right there!',26124),
(70547,'enUS','Halt!','That\'s enough of your meddling!',26124),
(70548,'enUS','Silence!','Stay out of this!',26124),
(70549,'enUS','Just who do you think YOU are?','Very sweet of you - now DIE!',26124),
(70550,'enUS','The Sunreavers are scum!','For the Silver Covenant!',26124),
(70551,'enUS','Interference will not be tolerated!','You want some, too? Very well!',26124),
(70552,'enUS','Can the Kirin Tor really kick us out like this?','How could this happen?',26124),
(70553,'enUS','I think it may be time to bring my swords out of retirement...','They\'ll pay for this.',26124),
(70554,'enUS','I need to get to Dalaran.','I need to get to Dalaran.',26124),
(70555,'enUS','Move quickly, but carefully, $n. We don\'t have much time, but this mission dies if you do.','',26124),
(70556,'enUS','I would like to go to Krasarang Wilds.','I would like to go to Krasarang Wilds.',26124),
(70559,'enUS','','Come on, girls. You\'ve had your share of meat for the day.',26124),
(70560,'enUS','So long, Dalaran...','',26124),
(70561,'enUS','Thank you, $n. See you in Silvermoon...','',26124),
(70562,'enUS','I hope the Horde has a place for another mage...','',26124),
(70563,'enUS','','Jaina is taking away my home by force? I\'ll remember this...',26124),
(70564,'enUS','What\'re ye lookin\' at? Is it m\'shoes?','',26124),
(70565,'enUS','I need a portal to Darnassus.','I need a portal to Darnassus.',26124),
(70566,'enUS','','Hello, $n.',26124),
(70567,'enUS','Let\'s go get the bell.','Let\'s go get the bell.',26124),
(70568,'enUS','Take me to the Shrine of Two Moons.','Take me to the Shrine of Two Moons.',26124),
(70569,'enUS','Take me to Binan Village.','Take me to Binan Village.',26124),
(70570,'enUS','Take me to Mogujia.','Take me to Mogujia.',26124),
(70571,'enUS','Take me to the Valley of Emperors.','Take me to the Valley of Emperors.',26124),
(70572,'enUS','Take me to Garrosh\'ar Advance.','Take me to Garrosh\'ar Advance.',26124),
(70573,'enUS','Take me to the Ruins of Korune.','Take me to the Ruins of Korune.',26124),
(70574,'enUS','Take me to Emperor\'s Reach.','Take me to Emperor\'s Reach.',26124),
(70575,'enUS','','Ooof! Well I sure am in a tizzy today. Got eighty irons in tha fire just abouts!',26124),
(70576,'enUS','','Hilda\'s left all the documentin\' to me. Ye know that fer every artifact we find, I\'ve got six forms ta fill out? Whaddaya we need all these forms fer, I ask!?',26124),
(70577,'enUS','','As if I ain\'t got enough on me hands, those dwarves at the mines\'ve gotten all crazy recently about some new drink called kafa.$B$BThey\'re insistin\' I bring \'em fresh cups o\' kafa every mornin\'!$B$BDo they know wot I \'ave ta do to get those kafa beans? Honestly!',26124),
(70578,'enUS','','I\'m up ta me pretty knickers in ad-mino-strative duties, but wot else is new?',26124),
(70579,'enUS','','Oh my. Ye must be the hero that everyone\'s been tellin\' me about.',26124),
(70580,'enUS','','Oops, how do ye fly one o\' these things? Fer light\'s sake! Ye crummy piece o\' whackery, WORK!',26124),
(70581,'enUS','','Sorry, I\'m still gettin\' the hang o\' things \'round here.',26124),
(70582,'enUS','','My older sister, Hilda, told me to expect ye.',26124),
(70583,'enUS','','She won\'t let me go down to the excavation, so I\'ve become somethin\' o\' a personal assistant and chauffeur.',26124),
(70584,'enUS','','Anyway, I met that SI:7 agent that you brought back outta retirement.',26124),
(70585,'enUS','','Agent Connelly, ain\'t it? That man\'s got some charm... and some nerve! His sweet words made me blush ten ways out of Ironforge!',26124),
(70586,'enUS','','He\'s out in the field now, and waitin\' fer ya special.',26124),
(70587,'enUS','','I\'m takin\' you close ta a Horde encampment though, so you\'d best be on yer guard.',26124),
(70588,'enUS','','Let Connelly know that Fennie\'s askin\' about him!',26124),
(70589,'enUS','','You lookin\' ta go to Dalaran? Heard the Lady Jaina Proudmoore herself\'s expectin\' ye! Go on through the mage portal down the path.',26124),
(70590,'enUS','','Well, we meet again.',26124),
(70591,'enUS','','I trust that ye\'re well and good?',26124),
(70592,'enUS','','Have ye heard all the buzz that\'s been going \'round Lion\'s Landing?',26124),
(70593,'enUS','','I heard that the Horde\'s learned of an ancient mogu artifact... somethin\' called the Divine Bell.',26124),
(70594,'enUS','','That bell\'s capable of turning a normal army into killin\' machines!',26124),
(70595,'enUS','','No one knows where the artifact was hidden, but the Horde\'s doing anything they can ta get their hands on it first.',26124),
(70596,'enUS','','The Reliquary is hot on the trail o\' that bell at Mogujia.',26124),
(70597,'enUS','','I\'ll be a snot-nosed ninny if we don\'t beat \'em to the punch!',26124),
(70598,'enUS','','I can\'t do much since I\'m just Hilda\'s assistant, but ye can. I hope ye can find out what they\'re up to.',26124),
(70599,'enUS','','Here we are.',26124),
(70600,'enUS','','Go wreck those Horde!',26124),
(70601,'enUS','','I\'m supposed to get ye to the Shrine o\' Seven Stars.',26124),
(70602,'enUS','','The young Prince Anduin\'s been askin\' after ya.',26124),
(70603,'enUS','','After the excavation trip to Mogujia, the Explorer\'s League brought their findings back to our city in the Vale o\' Eternal Blossoms.',26124),
(70604,'enUS','','They\'ve been studying the relics that the blood elves were stealin\'.',26124),
(70605,'enUS','','I\'m not supposed ta say anything \'bout this, but ye\'ve got a face that says ye like a good Dwarven stout, so I trust ye!',26124),
(70606,'enUS','','Those mogu belong to a tribe called the Korune.',26124),
(70607,'enUS','','From the looks o\' it, the Korune were loyal to the Thunder King, thousands o\' years ago... before even the pandaren came to rule this land.',26124),
(70608,'enUS','','They worked from the shadows, and get this... somehow, they managed to master the sha.',26124),
(70609,'enUS','','If the Korune were capable of such a feat, ain\'t no wonder Garrosh is after their knowledge!',26124),
(70610,'enUS','','Imagine what would happen if that knotty-pated axe-bludgeoner Garrosh could manipulate the sha to his bidding.',26124),
(70611,'enUS','','Makes me shudder even ta think.',26124),
(70612,'enUS','','Here you go. Good luck!',26124),
(70613,'enUS','','Howdy. How are ye today?',26124),
(70614,'enUS','','After I dropped ye off last time, I heard there was some kind of sha infectin\' our soldiers at the Shrine of Seven Stars.',26124),
(70615,'enUS','','If ye and Prince Anduin hadn\'t been there, we could all be turnin\' on each other, lettin\' our anger get the best o\' us!',26124),
(70616,'enUS','','I also heard that King Varian swore he would never use the sha to no good.',26124),
(70617,'enUS','','Maybe Varian ain\'t such a sour grape after all! Good ta see our King show some heart.',26124),
(70618,'enUS','','Anyway, Agent Connelly sent me word to bring ya to him in Kun-Lai Summit.',26124),
(70619,'enUS','','Sounds like the Horde are close to finding the location o\' that Divine Bell, and that ain\'t no good.',26124),
(70620,'enUS','','You\'d better meet up with him in the field and see what Garrosh is up to.',26124),
(70621,'enUS','','Good luck!',26124),
(70622,'enUS','','Get on the kite, quick!',26124),
(70623,'enUS','','We ain\'t got no time ta lose.',26124),
(70624,'enUS','','We\'ve been lookin\' all over Kun-Lai Summit fer a place that matches what ye saw in that mogu\'s memory, and we finally found the Korune\'s hidin\' place.',26124),
(70625,'enUS','','If we don\'t get to that Divine Bell first, that lizard-livered nut-brain Garrosh will. I don\'t much fancy fightin\' a Horde that commands the power o\' the bleepin\' sha.',26124),
(70626,'enUS','','Commander Skyglaive is already workin\' with a team of Explorer\'s League archaeologists at the dig site.',26124),
(70627,'enUS','','We\'re sendin\' out our best, and that means you.',26124),
(70628,'enUS','','Here we are. There\'s no time to waste.',26124),
(70629,'enUS','','Good luck!',26124),
(70630,'enUS','','I ain\'t flyin\' no kite to Dalaran! I don\'t even know where Jaina moved the city! Ye\'d best take the portal over there.',26124),
(70631,'enUS','','I ain\'t flyin\' no kite to Darnassus! I can barely navigate that thing in the mountains. Ye think we\'d last over an entire ocean? Ye\'d best talk to Seamus Goldenkicks over there.',26124),
(70632,'enUS','','Hey, Admiral Taylor asked me to hitch you a ride up to the Valley o\' Emperors.',26124),
(70633,'enUS','','Lucky fer you, I\'m Prince Anduin\'s best gal. We\'re friends, but don\'t go tellin\' Agent Connelly.',26124),
(70634,'enUS','','That man\'s bound ta get all jealous, an\' I don\'t want him poppin\' a cap inta the royal son.',26124),
(70635,'enUS','','Anyway, I know right where the Prince is hidin\', so I\'ll take ye right to \'im.',26124),
(70636,'enUS','','Can\'t say I approve o\' the boy roamin\' round by himself, but I can understand his thinkin\'.',26124),
(70637,'enUS','','I still cannae believe the Horde stole the Divine Bell, after everything we did to keep it safe in Darnassus.',26124),
(70638,'enUS','','I heard that Lady Jaina\'s still in shock about what happened.',26124),
(70639,'enUS','','She was ready ta forgive the Horde fer the destruction o\' Theramore.',26124),
(70640,'enUS','','She was ready ta forge a new future for the Kirin Tor, one where the Horde-allied Sunreavers and the Alliance-sided Silver Covenant could work together in peace.',26124),
(70641,'enUS','','I heard her say it meself - that Dalaran would be a shining example of peace \'tween Alliance an\' Horde fer the rest o\' the world.',26124),
(70642,'enUS','','Then the Sunreavers betray her trust and open portals straight ta the Bell from her own city!',26124),
(70643,'enUS','','Course she\'s goin\' ta feel upset. Course she\'s got a right to throw those nasty Sunreavers out o\' Dalaran.',26124),
(70644,'enUS','','Still, I can\'t help but get an uneasy feelin\' that the Horde ain\'t goin\' to take that quietly.',26124),
(70645,'enUS','','And now, Garrosh has the Divine Bell. He could attack us any day!',26124),
(70646,'enUS','','I hope Anduin\'s got some plan up his sleeve.',26124),
(70647,'enUS','','Good luck.',26124),
(70648,'enUS','','It\'s about time ye showed up. Doomsday is a comin\'.',26124),
(70649,'enUS','','Garrosh is amassing his troops on the northern side of Kun-Lai Summit.',26124),
(70650,'enUS','','He\'s going to use the Divine Bell, and Light help us if we can\'t stop \'im in time.',26124),
(70651,'enUS','','Anduin went on ahead. That cheeky, light-spoutin\', clod-brained fool!',26124),
(70652,'enUS','','Boy\'s naive enough ta think he can change the Horde \'an save the world... but... he\'s still just a child.',26124),
(70653,'enUS','','Ye\'ve either got to stop the boy or help him... one o\' the two!',26124),
(70654,'enUS','','We\'re amassin\' an army to head Garrosh off, but that will take time, and the Prince may already be in danger.',26124),
(70655,'enUS','','Oh, why can\'t this dang kite go faster?',26124),
(70656,'enUS','','Quick - they haven\'t spotted us yet.',26124),
(70657,'enUS','','I\'ll go back fer reinforcements.',26124),
(70658,'enUS','','Whatever ye do today, hero, ye\'re doin\' fer all the Alliance.',26124),
(70659,'enUS','Bah! I had my whole paycheck riding on that one!','Bah! I had my whole paycheck riding on that one!',26124),
(70660,'enUS','No! NO NO NO!','No! NO NO NO!',26124),
(70661,'enUS','I LOSE? NO YOU LOSE!','I LOSE? NO YOU LOSE!',26124),
(70662,'enUS','It was supposed to be a sure thing! I BET EVERYTHING!','It was supposed to be a sure thing! I BET EVERYTHING!',26124),
(70663,'enUS','HOW THE... WHAT THE...  DAMMIT!','HOW THE... WHAT THE...  DAMMIT!',26124),
(70664,'enUS','','Let\'s take this show on the road and go wreck up Stormwind!',26124),
(70665,'enUS','','This place is packed! We should all team up and go kick Varian in his pretty little face!',26124),
(70666,'enUS','','If you\'re so thirsty for blood, why not group up and go tear apart Stormwind?',26124),
(70667,'enUS','','Portal\'s up! Get in there and show \'em how the Horde do it!',26124),
(70668,'enUS','','I\'ve opened a portal to Stormwind.  Get in there and kick some butt!',26124),
(70669,'enUS','','The portal to Stormwind is good to go!  Get in!',26124),
(70670,'enUS','This place is packed to the rafters with Alliance all-stars!  Let\'s go tear apart Orgrimmar!','',26124),
(70671,'enUS','You folks want violence and bloodshed? Let\'s go take it to the Horde!','',26124),
(70672,'enUS','This practice is all fine and dandy, but Orgrimmar won\'t smash itself!','',26124),
(70673,'enUS','I\'ve made a portal to Orgrimmar. Who wants to kick some Horde butt?','',26124),
(70674,'enUS','Orgrimmar portal open, Brawl fans!  Tell \'em Bubbles sent ya.','',26124),
(70675,'enUS','Did someone order a portal to Orgrimmar? No? TOO BAD!','',26124),
(70676,'enUS','%s can now be put to sleep.','',26124),
(70677,'enUS','Take me to Fire Camp Bataar.','Take me to Fire Camp Bataar.',26124),
(70678,'enUS','Take me to Dalaran.','Take me to Dalaran.',26124),
(70679,'enUS','Take me to Mogujia.','Take me to Mogujia.',26124),
(70680,'enUS','Take me to the Shrine of Seven Stars.','Take me to the Shrine of Seven Stars.',26124),
(70681,'enUS','Take me to Garrosh\'ar Advance.','Take me to Garrosh\'ar Advance.',26124),
(70682,'enUS','Take me to the Ruins of Korune.','Take me to the Ruins of Korune.',26124),
(70683,'enUS','Take me to Darnassus.','Take me to Darnassus.',26124),
(70684,'enUS','Take me to the Valley of Emperors.','Take me to the Valley of Emperors.',26124),
(70685,'enUS','Take me to Emperor\'s Reach.','Take me to Emperor\'s Reach.',26124),
(70686,'enUS','|cff0000ffRank 1:|r\n  Goredome: $7367w-$7368w\n  Sanoriak: $7381w-$7382w\n  Smash Hoofstomp: $7407w-$7408w\n  Akama: $7397w-$7398w\n\n|cff0000ffRank 2:|r\n  Dippy: $7379w-$7380w\n  Kirrawk: $7389w-$7390w\n  King Kulaka: $7415w-$7416w\n  Fran & Riddoh: $7377w-$7378w','',26124),
(70687,'enUS','|cff0000ffRank 3:|r\n  Blat: $7371w-$7372w\n  Vian the Volatile: $7365w-$7366w\n  Ixx: $7383w-$7384w\n  Mazhareen: $7395w-$7396w\n\n|cff0000ffRank 4:|r\n  Tyson Sanders: $7873w-$7874w\n  Nibbleh: $8034w-$8033w\n  Dominika the Illusionist: $7391w-$7392w\n  Meatball: $7425w-$7426w','',26124),
(70688,'enUS','|cff0000ffRank 5:|r\n  Big Badda Boom: $8032w-$8031w\n  Millie Watt: $7393w-$7394w\n  Bruce: $7363w-$7364w\n  Leper Gnome Quintet: $7373w-$7374w\n\n|cff0000ffRank 6:|r\n  Proboskus: $7421w-$7422w\n  Doctor FIST: $8036w-$8035w\n  Unguloxx: $7419w-$7420w\n  Yikkan Izu: $7403w-$7404w','',26124),
(70689,'enUS','|cff0000ffRank 7:|r \n  GG Engineering: $7411w-$7412w\n  Dark Summoner: $7413w-$7414w\n  Battletron: $7375w-$7376w\n  Ahoo\'ru: $8038w-$8037w','',26124),
(70690,'enUS','Hey there, lucky. You like numbers?$b$bI keep track of all the fights around here. I can tell you how many fights each of the challengers won.$b$bMight come in handy, especially if you wanna... I dunno... predict the winner of one of these fights, for some... monetary benefit. You catch my drift?','',26124),
(70691,'enUS','View records for Rank 1-2 bosses.','View records for Rank 1-2 bosses.',26124),
(70692,'enUS','View records for Rank 3-4 bosses.','View records for Rank 3-4  bosses.',26124),
(70693,'enUS','View records for Rank 5-6 bosses.','View records for Rank 5-6 bosses.',26124),
(70694,'enUS','View records for Rank 7 bosses.','View records for Rank 7 bosses.',26124),
(70695,'enUS','Go back.','Go back.',26124),
(70696,'enUS','|cff0000ffRank 1:|r\n  Goredome: $7431w-$7432w\n  Sanoriak: $7445w-$7446w\n  Smash Hoofstomp: $7471w-$7472w\n  Akama: $7461w-$7462w\n\n|cff0000ffRank 2:|r\n  Dippy: $7443w-$7444w\n  Kirrawk: $7453w-$7454w\n  King Kulaka: $7479w-$7480w\n  Fran & Riddoh: $7441w-$7442w','',26124),
(70697,'enUS','|cff0000ffRank 3:|r\n  Blat: $7435w-$7436w\n  Vian the Volatile: $7429w-$7430w\n  Ixx: $7447w-$7448w\n  Mazhareen: $7459w-$7460w\n\n|cff0000ffRank 4:|r\n  Tyson Sanders: $8066w-$8065w\n  Nibbleh: $8074w-$8073w\n  Dominika the Illusionist: $7455w-$7456w\n  Meatball: $7489w-$7490w','',26124),
(70698,'enUS','|cff0000ffRank 5:|r\n  Big Badda Boom: $8072w-$8071w\n  Millie Watt: $7457w-$7458w\n  Bruce: $7427w-$7428w\n  Leper Gnome Quintet: $7437w-$7438w\n\n|cff0000ffRank 6:|r\n  Proboskus: $7485w-$7486w\n  Doctor FIST: $8076w-$8075w\n  Unguloxx: $7483w-$7484w\n  Yikkan Izu: $7467w-$7468w','',26124),
(70699,'enUS','|cff0000ffRank 7:|r\n  GG Engineering: $7475w-$7476w\n  Dark Summoner: $7477w-$7478w\n  Battletron: $7439w-$7440w\n  Ahoo\'ru: $8078w-$8077w','',26124),
(70700,'enUS','Warlord Bloodhilt prepares a Bloodthirsty Strike!','',26124),
(70701,'enUS','Hey $c, you looking to go to Stormwind? Travel fast with one of my portals! If you ain\'t got the commissions, you\'ll have to get there on your own.','',26124),
(70702,'enUS','Take me to Silvermoon City.','Take me to Silvermoon City.',26124),
(70703,'enUS','Take me to Darnassus.','Take me to Darnassus.',26124),
(70704,'enUS','','I have long waited for an opportunity to deal with the Sunreavers. I asked my late husband to remove them from the city, but he believed too firmly in the neutrality of the Kirin Tor.$b$bHe was wise, but he was short-sighted. This has always been the destiny of the Kirin Tor: to serve the Alliance.',26124),
(70705,'enUS','I\'m ready to return to Pandaria.','I\'m ready to return to Pandaria.',26124),
(70706,'enUS','Night Elf Construction Site Under Attack!','Night Elf Construction Site Under Attack!',26124),
(70707,'enUS','Our ships! What in the name o\' me beard happened?!','',26124),
(70708,'enUS','Free at last! And now to be rid of you filthy hozen rebels.','',26124),
(70709,'enUS','You are next in line!','You are next in line!',26124),
(70710,'enUS','The... Empire... will rise again.','',26124),
(70711,'enUS','I\'ll scribble you out of existence!','',26124),
(70712,'enUS','You\'ll have to wrench me out of here!','',26124),
(70713,'enUS','','For the Sunreavers!',26124),
(70714,'enUS','','So it\'s come to this, eh?',26124),
(70715,'enUS','Blast... the Silver Covenant\'s here.','',26124),
(70716,'enUS','Here goes nothing. My research did not have nice things to say about this Jade Warlord. Be ready for battle.','',26124),
(70717,'enUS','Is thish room is shpinning?','',26124),
(70718,'enUS','... *burp*','',26124),
(70719,'enUS','I shpilled me drink!','',26124),
(70720,'enUS','','Buy me a drinksh will ya?',26124),
(70721,'enUS','','Yesh, Brom here\'s the love of my life.  We\'re two peash in a pod, even if he\'s a lightweight!',26124),
(70722,'enUS','','You gotsh somethin\' to say to me? You do the talkin\' and I\'ll do the drinkin\'!',26124),
(70723,'enUS','','You\'re better off not trusting anything I say.  In fact, disregard this.',26124),
(70724,'enUS','','Oh yeah, there are plenty of false rumors going around about me.  That I grew up as an attraction in the Darkmoon Faire, that I killed six demons on my fifth birthday using only a spoon, or even -- and this is my favorite -- that I\'m actually a natural blonde.  Folks will believe anything.',26124),
(70725,'enUS','','This place is great.  Anywhere else I\'d be called a violent sociopath.  Well, they call me that here too, but at least they say it to my face with a smile.',26124),
(70726,'enUS','Do I smell bacon?','',26124),
(70727,'enUS','I need to get some medication for my allergies.','',26124),
(70728,'enUS','A few nights back some guy threw a ball and told me to fetch. In response, I did the same, but with his head.  Needless to say, he didn\'t have a witty comeback.','',26124),
(70729,'enUS','','I always cheer for Goredome anytime he\'s up.  That angry little shoveltusk makes quick work of the slow chubby ones.',26124),
(70730,'enUS','','City life changes a druid.  I used a flight path for the first time last week... and it was great.',26124),
(70731,'enUS','','Druids can sometimes be so serious, but I\'m a real party animal.  Yes, that was a joke.  You should laugh.  Now.',26124),
(70732,'enUS','I could break through four hardened pine boards using just your forehead.  Want me to demonstrate?','',26124),
(70733,'enUS','I don\'t get why so many other monks throw kegs around.  So wasteful.','',26124),
(70734,'enUS','Sure, I\'ll get into the ring.  Let me finish these two kegs first.','',26124),
(70735,'enUS','','Oh, sorry, I can\'t buy you a drink.  I\'m a bit broke right now, but that\'ll turn around.',26124),
(70736,'enUS','','This place looks rough and tumble, but everyone around here is a softie on the inside.',26124),
(70737,'enUS','','Oh, yes I am new to Orgrimmar.  Is it that obvious?',26124),
(70738,'enUS','','You should queue up for a brawl.  I could use a good laugh.',26124),
(70739,'enUS','','Keep staring.  I enjoy awkward silence.',26124),
(70740,'enUS','','Shoes are for the weak.',26124),
(70741,'enUS','','Last time I went into a brawl my opponent ran away crying.  Not surprising that they fled, but it was the first time I\'ve seen a crocolisk shed tears.',26124),
(70742,'enUS','','\"Nairi, lift this thing!\", they always shout.  Why not \"Nairi, show us your dance moves!\"?  I\'m a great dancer.',26124),
(70743,'enUS','','That Duke Studlington\'s a jerk.  He talks a big game, but can barely lift his own sword.  Oh, and yeah that\'s not his real name, as I\'m sure you guessed.',26124),
(70744,'enUS','You want a knuckle sandwich, chump?','',26124),
(70745,'enUS','I beat up three orcs and a tauren last night, all without breaking a nail.','',26124),
(70746,'enUS','Do you even lift, bro?','',26124),
(70747,'enUS','No, that is my femur, but I am happy to see you.','',26124),
(70748,'enUS','Chicks dig scars, so you can see why I\'m such a hit with the ladies.','',26124),
(70749,'enUS','You like what you see? Of course you do.','',26124),
(70750,'enUS','Why does everyone know my name?','',26124),
(70751,'enUS','I could use a hug.','',26124),
(70752,'enUS','Watch me back, mon.','',26124),
(70753,'enUS','Keep ya eyes wide open.','',26124),
(70754,'enUS','Stay close.','',26124),
(70755,'enUS','Hold up - there\'s somethin\' dere.','',26124),
(70756,'enUS','Good-bye.','',26124),
(70757,'enUS','Ah... your grace?','',26124),
(70758,'enUS','One a dem lizard-beasts. Fight on me bruddahs!','',26124),
(70759,'enUS','My apologies. My name is Anduin Wrynn. This champion and I need your help.','',26124),
(70760,'enUS','Thank you, but this is hardly the time for a party. A dangerous war leader named Garrosh has found the Divine Bell. We need the Harmonic Mallet to counter it.','',26124),
(70761,'enUS','Well, my research said you were the last one to-','',26124),
(70762,'enUS','Dis will help.','',26124),
(70763,'enUS','Stay in da fight!','',26124),
(70764,'enUS','Spirits be wit\' ya.','',26124),
(70765,'enUS','Use \'dis to heal yourself!','',26124),
(70766,'enUS','Pull \'im through da trap!','',26124),
(70767,'enUS','Lure him into da trap!','',26124),
(70768,'enUS','I set up a trap.','',26124),
(70769,'enUS','Lead him inta dis trap!','',26124),
(70770,'enUS','Get \'dese beasts offa me!','',26124),
(70771,'enUS','Dere be others.','',26124),
(70772,'enUS','Have you fought dese \'tings before?','',26124),
(70773,'enUS','It\'s like dey got weapons, but no brains.','',26124),
(70774,'enUS','We can take this boat inside.  Just let me make a few modifications...','',26124),
(70775,'enUS','And...done! A self-propelled saurok slaying machine.','',26124),
(70776,'enUS','One of you man da guns, the rest on foot.','',26124),
(70777,'enUS','Kill anyting dat squirms!','',26124),
(70778,'enUS','Ack, get that thing off us!','',26124),
(70779,'enUS','They\'re busting up our boat!','',26124),
(70780,'enUS','Gat da Sorceror!','',26124),
(70781,'enUS','Get dese beasts off da boat!','',26124),
(70782,'enUS','Here! Stop da boat here.','',26124),
(70783,'enUS','Griz, you guard da boat. Da rest of ya wit\' me.','',26124),
(70784,'enUS','Here, take this! It\'ll help you against any swarms.','',26124),
(70785,'enUS','I\'ll just ... be right here. Don\'t forget about me!','',26124),
(70786,'enUS','Wooo hoo! Son of an Ook! Pins and needles, pins and needles. Legs are asleep. Hand is asleep. Nibs are asleep.','',26124),
(70787,'enUS','Dis be some kinda spawnin chamber.','',26124),
(70788,'enUS','Be careful! Da roof be comin\' down!','',26124),
(70789,'enUS','Ooo? Grace? I not an emperor, little thing. You stand before the Monkey King!','',26124),
(70790,'enUS','Somethin unnatural about \'dese creatures.','',26124),
(70791,'enUS','Help? You saved me from eternity trapped in jade! I\'m gonna throw you the biggest party ever made!','',26124),
(70792,'enUS','This is the chamber we\'re looking for.','',26124),
(70793,'enUS','The Warchief has learned there\'s a connection between the Mogu and these creatures.','',26124),
(70794,'enUS','Troll! You know all about this... voodoo.  What can you find?','',26124),
(70795,'enUS','Oh... the missing Harmonic Mallet, eh? Such a silly name. So you come find the King because he is to blame?','',26124),
(70796,'enUS','\"Voodoo\"','',26124),
(70797,'enUS','Ah ya ta ta! Don\'t worry, you in the right place. But let\'s first see if I like what comes out of your face.','',26124),
(70798,'enUS','Watch me back while I investigate...','',26124),
(70799,'enUS','\'Dese \"Mogu,\" dey workin\' wicked dark magic here.','',26124),
(70800,'enUS','Da Saurok, \'dey not born - \'dey was created. Flesh shaped an\' bent.','',26124),
(70801,'enUS','Dis be the blackest of magics, mon!','',26124),
(70802,'enUS','Yes! The power to shape flesh, to build warriors.  This is what the Warchief wants!','',26124),
(70803,'enUS','Garrosh playing god? Making monsters? Dis ain\'t what da Horde is about!','',26124),
(70804,'enUS','He knew you were a traitor!','',26124),
(70805,'enUS','H-help-','',26124),
(70806,'enUS','The Warchief will annihilate his enemies!','',26124),
(70807,'enUS','Da... Warchief shows... his hand.','',26124),
(70808,'enUS','Breaking the valve.','Breaking the valve.',26124),
(70809,'enUS','Dis be what da Horde come to? Killin\' its own? We can\'t let dis happen.','',26124),
(70810,'enUS','Champions, I need ya.','',26124),
(70811,'enUS','Go back to da Warchief.  Tell \'im I\'m dead. Stay close to \'im. Watch \'im.','',26124),
(70812,'enUS','You an\' me, we move to take \'im out when da time is right.','',26124),
(70813,'enUS','Others are like me. You gotta find \'em.','',26124),
(70814,'enUS','Swear da blood oath wit me.','',26124),
(70815,'enUS','It be done. We bruddahs in dis. Until da end.','',26124),
(70816,'enUS','I gonna disappear for a while. [Gasps] Don\'t forget about me.','',26124),
(70817,'enUS','I will try to lead the \"King\" back to Lion\'s Landing and see if I can\'t persuade him to volunteer the information we need. In the meantime, I would say try to solve his riddles and meet us there.','',26124),
(70818,'enUS','Horde pigs! Yeh killed me only son!!','',26124),
(70819,'enUS','For Theramore!','',26124),
(70820,'enUS','For Bael Modan!','',26124),
(70821,'enUS','That\'s right, yeh manks! Yer Horde\'s a heap o\' sheep dung, an\' I jes\' proved it!','',26124),
(70822,'enUS','CANNONBALL!!','',26124),
(70823,'enUS','Monsters... all of yeh... *sputter*','',26124),
(70824,'enUS','Let us begin.','',26124),
(70825,'enUS','You never stood a chance.','',26124),
(70826,'enUS','What?  How is this possible!','',26124),
(70827,'enUS','Let\'s give someone else a chance to do some damage!','',26124),
(70828,'enUS','Did you really think all of your pets would survive?','',26124),
(70829,'enUS','No!  That was my favorite pet!','',26124),
(70830,'enUS','So Garrosh is looking for something called the Divine Bell? Whatever that is, it can\'t be good. I\'ll get this information back to headquarters.','',26124),
(70831,'enUS','Excellent work! I\'ll be in touch soon.','',26124),
(70832,'enUS','Pssssst! Hey, over here, it\'s me, Agent Connelly! Don\'t blow our disguise!','',26124),
(70833,'enUS','Rod is power! Rod is MY power!','',26124),
(70834,'enUS','Unga Ingoo is mine!','',26124),
(70835,'enUS','Monkey King died long ago! This can\'t be him.','',26124),
(70836,'enUS','Ingoo, I gave your people the rod for protection. Not to be ookin\' used for hooliganation!','',26124),
(70837,'enUS','Ingoo, rod is not for you. Give it up before it destroys you too.','',26124),
(70838,'enUS','We will return to Lion\'s Landing. Meet us there when you have everything.','',26124),
(70839,'enUS','<Klaxxi\'va Ik regards you with a judging eye.>','',26124),
(70840,'enUS','Are you ready to witness history, wakener?','',26124),
(70841,'enUS','We\'re hit!','We\'re hit!',26124),
(70842,'enUS','Missile incoming! Shields! SHIELDS!','Missile incoming! Shields! SHIELDS!',26124),
(70843,'enUS','Nice one, $p! That was close.','Nice one, $p! That was close.',26124),
(70844,'enUS','Use Force Shield to block Guided Missiles.','Use Force Shield to block Guided Missiles.',26124),
(70845,'enUS','You\'re hit! We\'re losing your signal!','You\'re hit! We\'re losing your signal!',26124),
(70846,'enUS','They\'ve got a lock on you! Shields! SHIELDS!','They\'ve got a lock on you! Shields! SHIELDS!',26124),
(70847,'enUS','Like shootin\' fish in a barrel!','',26124),
(70848,'enUS','That was easy!','',26124),
(70849,'enUS','Locked and loaded!','',26124),
(70850,'enUS','','Get down from there Sully!',26124),
(70851,'enUS','','I hope you fall into the muck again, Sully!',26124),
(70852,'enUS','','Just in time, $p! We need your help!',26124),
(70853,'enUS','','The situation is dire, $p.\n\nThe Horde are after a cache of mantid weapons near the Heart of Zan\'vess. I don\'t know what they intend to do with them but I\'m not about to wait around and find out.\n\nI need you to get through the shield that enshrouds the island and secure those weapons before the horde does. Take a gyrocopter and head out to the island. I\'ll send further orders while you are en route.',26124),
(70854,'enUS','...And dat be one ugly mudder!','',26124),
(70855,'enUS','Is THIS where your loyalties lie?','',26124),
(70856,'enUS','Hellscream\'s Horde demands absolute obedience!','',26124),
(70857,'enUS','The Warchief will hear of this betrayal!','',26124),
(70858,'enUS','Hellscream... will find out...','',26124),
(70859,'enUS','Ha-HAH!','',26124),
(70860,'enUS','Strength!','',26124),
(70861,'enUS','Fury!','',26124),
(70862,'enUS','...die!','',26124),
(70863,'enUS','Hide the bodies!','',26124),
(70864,'enUS','Leave no witnesses!','',26124),
(70865,'enUS','Alright, I\'ll go. But this is the last time I\'m going to infiltrate the Horde! And I mean it.','',26124),
(70866,'enUS','I\'m off to gather supplies and reconnect with old contacts. If I need backup in Pandaria, I\'ll send for ya!','',26124),
(70867,'enUS','Whatcha need?','',26124),
(70868,'enUS','We got this.','',26124),
(70869,'enUS','Let\'s do some damage.','',26124),
(70870,'enUS','Honor and loyalty.','',26124),
(70871,'enUS','Hellscream\'s eyes are upon you.','',26124),
(70872,'enUS','The Warchief rewards the loyal.','',26124),
(70874,'enUS','A nearby group of Darkhatched Swarmlings has hatched!','',26124),
(70875,'enUS','Grizzle has given you a portable death ray!  Use it on the saurok eggs nearby.','',26124),
(70876,'enUS','Grizzle has given you a set of landmines!  Use them on the saurok eggs nearby.','',26124),
(70877,'enUS','Grizzle has given you a portable cluster rocket!  Use it on the saurok eggs nearby.','',26124),
(70878,'enUS','','I strike from the shadows!',26124),
(70879,'enUS','','You will die here, by my blade!',26124),
(70880,'enUS','','Denizens of the sky, attack!',26124),
(70881,'enUS','Use the boat\'s abilities to defeat packs of saurok as you make your way through the cave.','',26124),
(70882,'enUS','The Darkhatched Lizard-Lord begins to spin violently.','',26124),
(70883,'enUS','Broodmaster Noshi begins to cast a massive Death Nova.  Get inside the Big Bad Voodoo!','',26124),
(70884,'enUS','Broodmaster Noshi is stunned by the stalactite!','',26124),
(70885,'enUS','Aim for those amber bombs, they\'ll cause a huge explosion if you manage to set one off!','Aim for those amber bombs, they\'ll cause a huge explosion if you manage to set one off!',26124),
(70886,'enUS','Broodmaster Noshi begins to hatch a group of Darkhatched Swarmlings!','',26124),
(70887,'enUS','Those scorpid are moving the towers! Take them out!','Those scorpid are moving the towers! Take them out!',26124),
(70888,'enUS','Broodmaster Noshi begins to drain power from everything around him!','',26124),
(70889,'enUS','Stalactites begin to fall from the ceiling!','',26124),
(70890,'enUS','Only a few more towers and that whole thing is coming down!','Only a few more towers and that whole thing is coming down!',26124),
(70891,'enUS','The shield is down! Nice work, $p! I\'ll take us to the beachhead.','The shield is down! Nice work, $p! I\'ll take us to the beachhead.',26124),
(70892,'enUS','','The whole island is protected by a sonic shield, $p.',26124),
(70893,'enUS','','My scouts report that the shield is maintained by several generators around the island.',26124),
(70894,'enUS','','I need you to take them out before the horde overrun us.',26124),
(70895,'enUS','','You\'re approaching the first towers now! Take them out!',26124),
(70896,'enUS','','Nice shooting, $p! The shield is weakening!',26124),
(70897,'enUS','','I\'m sending you the coordinates of the next towers now.',26124),
(70898,'enUS','','The shield is down! Quickly get to the beachhead!',26124),
(70899,'enUS','','Stop those horde! They\'re storming the island!',26124),
(70900,'enUS','Aid in the construction of at least two of the five defenses.','Aid in the construction of at least two of the five defenses.',26124),
(70901,'enUS','Horde scum!','',26124),
(70902,'enUS','For the Alliance!','',26124),
(70903,'enUS','Cowardly dogs!','',26124),
(70904,'enUS','Varian... I have... failed... you','',26124),
(70905,'enUS','Varian will honor me for this victory!','',26124),
(70906,'enUS','Alliance scum!','',26124),
(70907,'enUS','For the Horde!','',26124),
(70908,'enUS','Blood and thunder!','',26124),
(70909,'enUS','You are powerless before Garrosh!','',26124),
(70910,'enUS','I... have... failed...','',26124),
(70911,'enUS','Zan\'vess will never fall!','',26124),
(70912,'enUS','Is this what you came for?','',26124),
(70913,'enUS','Your blood will paint Zan\'vess red!','',26124),
(70914,'enUS','Empress...','',26124),
(70915,'enUS','Fool!','',26124),
(70916,'enUS','The horde cannot be stopped!','',26124),
(70917,'enUS','Good work, $p! We\'ll take these bombs back to the admiral immediately.','Good work, $p! We\'ll take these bombs back to the admiral immediately.',26124),
(70918,'enUS','You are a true hero of the Alliance!','You are a true hero of the Alliance!',26124),
(70919,'enUS','You are a true hero of the Horde!','You are a true hero of the Horde!',26124),
(70920,'enUS','Rak\'gor has dropped a gas bomb.  Stand in a Healing Ward to heal yourself!','',26124),
(70921,'enUS','Your attire is UNNACCEPTABLE!','Your attire is UNNACCEPTABLE!',26124),
(70922,'enUS','I\'m just going to say it: you\'re fat.','I\'m just going to say it: you\'re fat.',26124),
(70923,'enUS','I woudn\'t serve that to a Worg!','I woudn\'t serve that to a Worg!',26124),
(70924,'enUS','Maybe you could cook more and eat less, no?','Maybe you could cook more and eat less, no?',26124),
(70925,'enUS','I think the meat has gone bad.  Oh wait, that\'s you!','I think the meat has gone bad.  Oh wait, that\'s you!',26124),
(70926,'enUS','You\'re going to cook in that?','You\'re going to cook in that?',26124),
(70927,'enUS','Do you have reservations?','Do you have reservations?',26124),
(70928,'enUS','No tunic, no boots, no service!','No tunic, no boots, no service!',26124),
(70929,'enUS','Ready to cook with fire?','Ready to cook with fire?',26124),
(70930,'enUS','','There\'s too much smoke in the air to see very far.\n\nI can\'t make out much of anything on the beach, and sniping\'s useless.',26124),
(70931,'enUS','Fight with us. |cFF0008E8(Amber will follow you.)|r','Fight with us. |cFF0008E8(Amber will follow you.)|r',26124),
(70932,'enUS','','I\'ll keep you covered.',26124),
(70933,'enUS','','I\'ve done all I can for the wounded here. Twinbraid has all the bodies he\'ll get.\n\nI\'m defending the injured... unless you have a better plan?',26124),
(70934,'enUS','Fight with us. |cFF0008E8(Mishka will follow you.)|r','Fight with us. |cFF0008E8(Mishka will follow you.)|r',26124),
(70935,'enUS','If Bloodhilt thinks a few reinforcements are going to be enough to take Lion\'s Landing, he\'s got another thing coming!','',26124),
(70936,'enUS','We\'re here to help.','We\'re here to help.',26124),
(70937,'enUS','Good timing, too. Here comes the assault\'s commander!','',26124),
(70938,'enUS','Ready up, lads!','',26124),
(70939,'enUS','Nodd and Nimm were out in the submersible when the Horde attacked.\n\nStill, I\'ve put all their gear and explosives to good use.\n\nWe can set up a defensive position at the front.','',26124),
(70940,'enUS','Fight with us. |cFF0008E8(Sully will follow you.)|r','Fight with us. |cFF0008E8(Sully will follow you.)|r',26124),
(70941,'enUS','Let\'s get to work!','',26124),
(70942,'enUS','','Time to operate.',26124),
(70943,'enUS','We\'re all ready.','We\'re all ready.',26124),
(70944,'enUS','My commanding officers are all dead or missing.','',26124),
(70945,'enUS','Get me reports from that SI:7 team - how many Horde are left, and how many men we still have - and help Sully set up some defenses.','',26124),
(70946,'enUS','Be ready! They\'ll charge any moment now.','',26124),
(70947,'enUS','Here they come! HOLD FAST!','',26124),
(70948,'enUS','That\'s how we do it, lads! Here comes more!','',26124),
(70949,'enUS','Keep on fighting, lads! DON\'T GIVE UP!','',26124),
(70950,'enUS','This is it! Their final assault! FOR LION\'S LANDING!','',26124),
(70951,'enUS','We\'ve done it! WE\'VE DONE IT!','',26124),
(70952,'enUS','Carry on!$b$bThe attack will commence once two defenses are constructed.','Carry on!$b$bThe attack will commence once two defenses are constructed.',26124),
(70953,'enUS','|cFF00ff00+25 Construction Progress|r','|cFF00ff00+25 Construction Progress|r',26124),
(70954,'enUS','Where do you want to go?','',26124),
(70955,'enUS','So many places, so little time. Where to, $Gbrother:sister;?','',26124),
(70956,'enUS','Somethin\' smell funny.','',26124),
(70957,'enUS','|cFF00ff00Construction Progress: Rate increased!|r','|cFF00ff00Construction Progress: Rate increased!|r',26124),
(70958,'enUS','','It\'s about time you got here, $n. This battle isn\'t going to win itself!',26124),
(70959,'enUS','|cFF00ff00+5 Construction Progress|r','|cFF00ff00+5 Construction Progress|r',26124),
(70960,'enUS','We shall rout all traitors to the Horde!','We shall rout all traitors to the Horde!',26124),
(70961,'enUS','We will rout out dissention among these mongrels!','We will rout out dissention among these mongrels!',26124),
(70962,'enUS','This is Kor\'kron business! Nothing to see here.','This is Kor\'kron business! Nothing to see here.',26124),
(70963,'enUS','Use the Laborer\'s Tool at any construction site for a progress boost! $B$B|TInterface\\Icons\\INV_HAMMER_17.blp:64|t','Use the Laborer\'s Tool at any construction site for a progress boost! $B$B|TInterface\\Icons\\INV_HAMMER_17.blp:64|t',26124),
(70964,'enUS','Sometimes things just need doin\' even if it does mean breakin\' a few things along the way!','',26124),
(70965,'enUS','Use the Battle Rations at any construction site to boost its rate of progress! $B$B|TInterface\\Icons\\INV_MISC_FOOD_WHEAT_02.blp:64|t','Use the Battle Rations at any construction site to boost its rate of progress! $B$B|TInterface\\Icons\\INV_MISC_FOOD_WHEAT_02.blp:64|t',26124),
(70966,'enUS','I remember when Vol\'jin and I first came to this land. The Horde was just an idea then. A hope. We needed one another.','',26124),
(70967,'enUS','We made our home in this desert, and named it after my father Durotan, Chieftain of the Frostwolf Clan.','',26124),
(70968,'enUS','The land was harsh. Time and again it was Vol\'jin and his people who ensured the Horde\'s survival, saving us from starvation, or taking up arms when we were attacked.','',26124),
(70969,'enUS','Trolls and orcs have fought together. Died together. We are family. And family looks after its own.','',26124),
(70970,'enUS','Use the Brittle Roots at select construction sites to boost their rate of progress! $B$B|TInterface\\Icons\\INV_WEAPON_SHORTBLADE_09.blp:64|t','Use the Brittle Roots at select construction sites to boost their rate of progress! $B$B|TInterface\\Icons\\INV_WEAPON_SHORTBLADE_09.blp:64|t',26124),
(70971,'enUS','Use the Jungle Hops on the Blast-brew Cauldron at the pandaren construction site for a progress boost! $B$B|TInterface\\Icons\\INV_MISC_HERB_08.blp:64|t','Use the Jungle Hops on the Blast-brew Cauldron at the pandaren construction site for a progress boost! $B$B|TInterface\\Icons\\INV_MISC_HERB_08.blp:64|t',26124),
(70972,'enUS','Use the Krasari Iron at the dwarven or gnome construction sites to boost their rate of progress! $B$B|TInterface\\Icons\\INV_ORE_PLATINUM_01.blp:64|t','Use the Krasari Iron at the dwarven or gnome construction sites to boost their rate of progress! $B$B|TInterface\\Icons\\INV_ORE_PLATINUM_01.blp:64|t',26124),
(70973,'enUS','Use the Liquid Fire on the Blast-brew Cauldron at the pandaren construction site for a progress boost! $B$B|TInterface\\Icons\\ABILITY_WARLOCK_BURNINGEMBERS.blp:64|t','Use the Liquid Fire on the Blast-brew Cauldron at the pandaren construction site for a progress boost! $B$B|TInterface\\Icons\\ABILITY_WARLOCK_BURNINGEMBERS.blp:64|t',26124),
(70974,'enUS','Use the Meaty Haunch at any construction site to boost its rate of progress! $B$B|TInterface\\Icons\\INV_MISC_FOOD_50.blp:64|t','Use the Meaty Haunch at any construction site to boost its rate of progress! $B$B|TInterface\\Icons\\INV_MISC_FOOD_50.blp:64|t',26124),
(70975,'enUS','Use the Misplaced Keg at the pandaren construction site to permanently boost its rate of progress! $B$B|TInterface\\Icons\\INV_CASK_04.blp:64|t','Use the Misplaced Keg at the pandaren construction site to permanently boost its rate of progress! $B$B|TInterface\\Icons\\INV_CASK_04.blp:64|t',26124),
(70976,'enUS','But know this, the Horde IS family, even if some of its leaders have forgotten that fact. To prove this, I shall remain with you and lend what strength I can to your chosen leaders until Vol\'jin returns.','',26124),
(70977,'enUS','Use the Snake Oil at the night elf or gnome construction sites to boost their rate of progress! $B$B|TInterface\\Icons\\ABILITY_VEHICLE_OILJETS.blp:64|t','Use the Snake Oil at the night elf or gnome construction sites to boost their rate of progress! $B$B|TInterface\\Icons\\ABILITY_VEHICLE_OILJETS.blp:64|t',26124),
(70978,'enUS','Please, $p, do not tell Garrosh what we have done here today. I must make some weighty decisions before confronting him directly.','',26124),
(70979,'enUS','Spirit-Kissed Water will awaken Master Brownstone, boost progress at pandaren construction site, or increase progress rate at night elf site! $B$B|TInterface\\Icons\\INV_MISC_VOLATILEWATER.blp:64|t','Spirit-Kissed Water will awaken Master Brownstone, boost progress at pandaren construction site, or increase progress rate at night elf site! $B$B|TInterface\\Icons\\INV_MISC_VOLATILEWATER.blp:64|t',26124),
(70980,'enUS','Use the Unexploded Cannonball at the dwarven construction site to permanently boost its rate of progress! $B$B|TInterface\\Icons\\ABILITY_VEHICLE_SIEGEENGINECANNON.blp:64|t','Use the Unexploded Cannonball at the dwarven construction site to permanently boost its rate of progress! $B$B|TInterface\\Icons\\ABILITY_VEHICLE_SIEGEENGINECANNON.blp:64|t',26124),
(70981,'enUS','Speak to the jinyu foreman, Elder Adler, who will use the Adorned Sceptre to permanently grant a significant increase to the jinyu rate of progress! $B$B|TInterface\\Icons\\INV_STAFF_2H_PANDARIATRADESKILL_C_05.blp:64|t','Speak to the jinyu foreman, Elder Adler, who will use the Adorned Sceptre to permanently grant a significant increase to the jinyu rate of progress! $B$B|TInterface\\Icons\\INV_STAFF_2H_PANDARIATRADESKILL_C_05.blp:64|t',26124),
(70982,'enUS','Speak to the gnome foreman, Rosey Axlerod, who will use the Soggy Journal to permanently grant a significant increase to the gnome rate of progress! $B$B|TInterface\\Icons\\INV_MISC_BOOK_11.blp:64|t','Speak to the gnome foreman, Rosey Axlerod, who will use the Soggy Journal to permanently grant a significant increase to the gnome rate of progress! $B$B|TInterface\\Icons\\INV_MISC_BOOK_11.blp:64|t',26124),
(70983,'enUS','Shan Kien\'s hand twists into a Sha Claw!','',26124),
(70984,'enUS','Shan Kien\'s eyes glow with Sha Magic!','',26124),
(70985,'enUS','Ya mon! A hero done freed our raptors!','Ya mon! A hero done freed our raptors!',26124),
(70986,'enUS','Ah not a traitor mon! Ya not gonna be shacklin\' me again.','Ah not a traitor mon! Ya not gonna be shacklin\' me again.',26124),
(70987,'enUS','Us Darkspear not the type to wear chains well, mon. Ya be learnin\' this the hard way... soon.','Us Darkspear not the type to wear chains well, mon. Ya be learnin\' this the hard way... soon.',26124),
(70988,'enUS','Vol\'jin not be givin\' ya permission to question us like this.','Vol\'jin not be givin\' ya permission to question us like this.',26124),
(70989,'enUS','Ya not be gettin\' the drop on us again ya half wit Kor\'kron!','Ya not be gettin\' the drop on us again ya half wit Kor\'kron!',26124),
(70990,'enUS','--GREETINGS, $P. PLEASE PROCEED DOWN THE TUNNEL BEHIND THIS UNIT. HIS HIGH AND POWERFULNESS THE GRAND MAGISTER ROMMATH AWAITS YOUR ARRIVAL.--','',26124),
(70991,'enUS','You have no idea what\'s waiting for you!','You have no idea what\'s waiting for you!',26124),
(70992,'enUS','Scargash won\'t allow any alliance to escape the jungle!','Scargash won\'t allow any alliance to escape the jungle!',26124),
(70993,'enUS','The Commander will have the Alliance king\'s head on a spike!','The Commander will have the Alliance king\'s head on a spike!',26124),
(70994,'enUS','Call for your king, $rt! Draw him in!','Call for your king, $rt! Draw him in!',26124),
(70995,'enUS','','May the light of the eternal sun heal you, $p!',26124),
(70996,'enUS','','Do not worry, $p, I will heal you!',26124),
(70997,'enUS','','I will not let you fall, $p!',26124),
(70998,'enUS','','May your wounds be mended, $p.',26124),
(70999,'enUS','Your beloved king has taken the bait! He\'ll die in this jungle!','Your beloved king has taken the bait! He\'ll die in this jungle!',26124),
(71000,'enUS','It has been an age of the world or more since I felt any emotion at even a fraction of that.','',26124),
(71001,'enUS','Your blood will not be the last my blades taste today, $c!','Your blood will not be the last my blades taste today, $c!',26124),
(71002,'enUS','Welcome to the jungle, $rt. You\'re gunna die!','Welcome to the jungle, $rt. You\'re gunna die!',26124),
(71003,'enUS','It would seem this \"sha\" energy is far more powerful than I previously thought.','',26124),
(71004,'enUS','What... what was that?','',26124),
(71005,'enUS','Rommath... I... I don\'t know what came over me.','',26124),
(71006,'enUS','This one\'ll be dead before long, $p.','',26124),
(71007,'enUS','Focus your fire, $p!','',26124),
(71008,'enUS','Ha! I like our chances, $p.','',26124),
(71009,'enUS','Right between the eyes...','',26124),
(71010,'enUS','Alright, $p, let\'s take this one out!','',26124),
(71011,'enUS','Let\'s see how this one\'s bleeds...','',26124),
(71012,'enUS','Death to all who oppose the Blood Elves!','',26124),
(71016,'enUS','','My King, I promise you. The Kirin-Tor will come down on Garrosh so hard his ancestors will reel. Blood will pay for blood!',26124),
(71017,'enUS','Jaina -','',26124),
(71018,'enUS','I will end Garrosh for this. His Horde already crumbles beneath him. We will deliver the final blow.','',26124),
(71019,'enUS','Champion, you and Anduin thwarted the Warchief today and won the Alliance a critical victory.','',26124),
(71020,'enUS','But please, leave me now. I must tend to my son... and prepare for our next battle.','',26124),
(71021,'enUS','The boy\'s face is ashen and pale. He barely breathes.','',26124),
(71022,'enUS','%s casts |cFFFF0000|Hspell:135759|h[Salvation of the Protector]|h|r to assist you!','',26124),
(71023,'enUS','What do you think?','What do you think?',26124),
(71024,'enUS','Let\'s talk to him.','Let\'s talk to him.',26124),
(71025,'enUS','Yes - The Kirin Tor must remain above faction squabbles.','Yes - The Kirin Tor must remain above faction squabbles.',26124),
(71026,'enUS','I\'m not sure I could.','I\'m not sure I could.',26124),
(71027,'enUS','Ah. The smell of a proper battlefield. We have been on our own for far too long. Now, the full might of the Horde is unleashed! And we are the ones who direct where the next blow will land.','',26124),
(71028,'enUS','THIS is the best your pathetic Alliance can muster? PAH!','',26124),
(71029,'enUS','We crushed your Alliance in Southern Barrens. We will crush you here. And Pandaria will tremble!','',26124),
(71030,'enUS','We will drive you from the beach. The Pandaren will tremble before our might!','',26124),
(71031,'enUS','Go ahead. Make me bleed. A true orc lives for combat!','',26124),
(71032,'enUS','Warchief... I have failed you...','',26124),
(71033,'enUS','An engraving reads: \"Spill No Evil!\"','An engraving reads: \"Spill No Evil!\"',26124),
(71034,'enUS','Bah! Pain don\'t hurt!','',26124),
(71035,'enUS','Glory to the brave!','',26124),
(71036,'enUS','Here comes the THUNDER!','',26124),
(71037,'enUS','What is this that stands before me?','',26124),
(71043,'enUS','Alright, we have the handle, the head, and the ointment like you asked for. Can you re-assemble the mallet?','',26124),
(71044,'enUS','Ayup! Silly youngin, just put rod in hole. And the mallet shall again be whole.','',26124),
(71045,'enUS','Good as nibby new! But listen to the Monkey King. You only have enough ointment for one true swing.','',26124),
(71046,'enUS','Only one swing? Are we sure this will work? Is there any way to get more ointment?','',26124),
(71047,'enUS','The Monkey King was there, the last time this mallet struck true. Tears came to eyes, and harmony was felt through and through. But no more ointment was ever made, for the mogu came with their raid. Use what you have, be grateful it is there. For the bell is a dangerous weapon, so handle with care.','',26124),
(71048,'enUS','What is this dark magic?','What is this dark magic?',26124),
(71049,'enUS','Don\'t let it touch you!','Don\'t let it touch you!',26124),
(71050,'enUS','Her locomotives won\'t locomote, but her weapons are fresh off the assembly line.','',26124),
(71051,'enUS','Rise and shine, beautiful!','',26124),
(71052,'enUS','Can\'t we work in peace?','',26124),
(71053,'enUS','I have a bad feeling about this place.','I have a bad feeling about this place.',26124),
(71054,'enUS','Where are our reinforcements?','Where are our reinforcements?',26124),
(71055,'enUS','How long can we hold out on our own?','How long can we hold out on our own?',26124),
(71056,'enUS','I do not like the taste of this magic.','I do not like the taste of this magic.',26124),
(71057,'enUS','What kind of magic is this?','What kind of magic is this?',26124),
(71060,'enUS','Friend! Breath my incense if you need healing!','',26124),
(71061,'enUS','Thank you, friend of the grummles!','',26124),
(71062,'enUS','COGWRENCH, YOU WERE SMALL AND I MISS YOU.','',26124),
(71063,'enUS','Wanderer! Inhale this if you wish to fight faster!','',26124),
(71064,'enUS','Many thanks! This is the last time we travel west of the wall.','',26124),
(71065,'enUS','Keep up the good work, $p. With your help, we\'ll be done in no time!','',26124),
(71066,'enUS','Your help is appreciated, friend. At this rate, we\'ll be able to get some rest soon!','',26124),
(71067,'enUS','Your efforts are really accelerating our progress, $p. Perhaps you\'d like a permanent spot on our crew?','',26124),
(71068,'enUS','We pandaren work best on a full stomach, $p. Be sure to keep our table full!','',26124),
(71069,'enUS','Remember $p, meat from wildlife or rations from your enemies will keep my crew well fed!','',26124),
(71070,'enUS','Some of our kegs went missing recently. They were last seen just east of here...','',26124),
(71071,'enUS','The saurok here are scavengers. There\'s no telling what they might be carrying.','',26124),
(71072,'enUS','Keep an eye out for brittle roots, $p. We can use their wood in the construction of our defenses.','',26124),
(71073,'enUS','Spirit-Kissed Water is very unstable. Only one can be carried at any given time.','',26124),
(71074,'enUS','Seek out the Volatile Fireflies, $p! They are instrumental in the creation of this special brew.','',26124),
(71075,'enUS','Place the Jungle Hops directly into the cauldron, $p. No such thing as too much hops!','',26124),
(71076,'enUS','You should always carry a Spirit-Kissed Water, friend. Without it, we tend to... nod off.','',26124),
(71077,'enUS','Those gorillas look angry, friend, but challenging them may well be worth the risk!','',26124),
(71078,'enUS','Please, $p, keep me awake! If we fall asleep, all productivity comes to a halt.','',26124),
(71079,'enUS','It is wise to replenish our resources before they run out!','',26124),
(71080,'enUS','I love overnight trips. Camping is my favorite thing!','',26124),
(71081,'enUS','I\'m a good dancer. Wanna see?','',26124),
(71082,'enUS','I don\'t know why people treat me like a little kid!','',26124),
(71083,'enUS','Stop bothering me! I normally get up late in the afternoon.','',26124),
(71084,'enUS','I want to be a singer when I grow up!','',26124),
(71085,'enUS','A ha a ha a ha uh- uh! A ha a ha yeah yeah yeah yeah!$B$BDo you like my song?','',26124),
(71087,'enUS','WIPING MEMORY OF UNBEARABLY SAD MEMORIES...','',26124),
(71088,'enUS','FACTORY SETTINGS LOADED...','',26124),
(71089,'enUS','AFFIRMATIVE, CUPCAKE.','',26124),
(71090,'enUS','Perhaps it could be harnessed. My people are well-versed in controlling the rage within...','',26124),
(71091,'enUS','Aye, $gladdie:lass;, that be some fine gatherin\' ye been doin. Keep it up!','',26124),
(71092,'enUS','You\'ve got us workin\' up a sweat here, $p. We\'ll have our defenses in place in no time!','',26124),
(71093,'enUS','We\'re runnin\' at full steam, $p. Just focus on keepin\' us topped off.','',26124),
(71094,'enUS','Listen, $p, that grill\'s not gunna put food on itself. Don\'t let the fellas get hungry now!','',26124),
(71095,'enUS','Focus, $p! The meat from wildlife or rations from orc troops will keep my crew well fed!','',26124),
(71096,'enUS','Mebbe there be some unexploded cannonballs \'round these parts. Plenty of fightin\' offshore recently...','',26124),
(71097,'enUS','Them lizard-folk could be carryin\' anything. Keep an eye out for \'em!','',26124),
(71098,'enUS','Look fer brittle roots stickin\' out of the soil. There\'s good wood in \'em!','',26124),
(71099,'enUS','There\'s a type of iron unique to these parts. Bring back any ya find, $p. Ain\'t no iron in Azeroth us dwarves can\'t forge.','',26124),
(71100,'enUS','C\'mon, $p! We need resources if we\'re gunna get this job done! Food, wood, iron... whatever you can find!','',26124),
(71101,'enUS','Them crocs drop some tasty meat, $p, but tiger haunch is my personal favorite!','',26124),
(71102,'enUS','There\'s orcs out there, $p. I can smell \'em. And they\'re bound to have supplies we can make use of.','',26124),
(71103,'enUS','Don\'t go wanderin\' off too far, $p. We\'re darn near defenseless without the likes of you.','',26124),
(71104,'enUS','Productivity stops if we\'re attacked. Keep an eye on us!','',26124),
(71105,'enUS','Take my advice, $p. It\'s best to keep our resources stocked up!','',26124),
(71106,'enUS','','Saw yer flare \'n came quick as I could!',26124),
(71107,'enUS','','Oh no! Prince Anduin!',26124),
(71108,'enUS','','Don\'t worry. I\'ll get Anduin back to Lion\'s Landing safely. We\'ll meet ye there.',26124),
(71109,'enUS','Dem Saurok be guardin de cave.  Let\'s take care of \'em.','',26124),
(71110,'enUS','I didn\'t get to be the Shredmaster by putting up with chumps like you!','',26124),
(71111,'enUS','I was rusty...','',26124),
(71112,'enUS','You have done well, $rt. My workers are making efficient progress.','',26124),
(71113,'enUS','Can I get you something?','',26124),
(71114,'enUS','You have us working very efficiently, $rt. Our task will be complete soon at this pace.','',26124),
(71115,'enUS','Progress is going swimmingly, friend. You should focus on maintaining what you\'ve done.','',26124),
(71116,'enUS','The beasts in the region all yield edible meat, $rt. Do what you can to keep the workers fed.','',26124),
(71117,'enUS','Just deposit any food you gather on the table here. We can take it from there.','',26124),
(71118,'enUS','Food and wood are our primary needs. Speak with me if you seek to aid us further.','',26124),
(71119,'enUS','There is usable wood, even in these swamps. Look for brittle roots protruding from the soil.','',26124),
(71120,'enUS','Here she comes!','Here she comes!',26124),
(71121,'enUS','My workers are highly skilled, but they are ineffective when it comes to combat. Do not wander too far off.','',26124),
(71122,'enUS','Once you have delivered supplies, your work is not done. Do your best to keep our resources topped off.','',26124),
(71123,'enUS','If your enemies harass the worker, productivity will cease until the threat is dealt with.','',26124),
(71124,'enUS','Jaina! Stop!','Jaina! Stop!',26124),
(71125,'enUS','I will not bow to th-','I will not bow to th-',26124),
(71126,'enUS','We didn\'t know th-','We didn\'t know th-',26124),
(71127,'enUS','','Woohoo! You\'ve got us running at peak efficiency, $p!',26124),
(71128,'enUS','','This is as fast as I\'ve ever seen this team work! Keep it up, $p!',26124),
(71129,'enUS','','You\'re doing great, $p! At this rate, our defenses will be complete in no time!',26124),
(71130,'enUS','','We gnomes have a high metabolism, $p. Make sure we don\'t run outta food!',26124),
(71131,'enUS','','Collect meat from the local wildlife or rations from the orcs. We\'re not picky eaters.',26124),
(71132,'enUS','','Hey $p, we\'ll work faster if we have plenty of metal to work with. The local Krasari Iron Ore will do fine.',26124),
(71133,'enUS','','Keep an eye out for oily serpents, $p. They\'re easy enough to catch. Put their oil in the cauldron and we\'ll work even faster.',26124),
(71134,'enUS','','The lizard folk around here are likely to carry anything. Watch for \'em!',26124),
(71135,'enUS','','Keep us well supplied for the greatest production benefit.',26124),
(71136,'enUS','','Keep an eye on us, $p! We\'re builders, not fighters. We\'ll need your protection if any beasties come around!',26124),
(71137,'enUS','','Snake Oil, Krasari Iron, Food... keep an eye out for anything that might benefit our crew!',26124),
(71138,'enUS','','You can often supply us with multiples of an item for extra effect. Just try to keep the benefits from wearing off.',26124),
(71139,'enUS','','Keep us well supplied, $p. Don\'t let the effects expire or you\'ll have to start from scratch!',26124),
(71140,'enUS','','Practice being as efficient as you can, $p! One day, time might be a factor...',26124),
(71141,'enUS','','<Static> Come in, $p, this is Sky Admiral Rogers.',26124),
(71142,'enUS','','Things could not be going better, friend. Thank you for your aid.',26124),
(71143,'enUS','','You have served us well, $p. Please continue as we draw near completion.',26124),
(71144,'enUS','','Our resources are well stocked, thanks to you. Please strive to keep them so.',26124),
(71145,'enUS','This is our home too! You can\'t do this!','This is our home too! You can\'t do this!',26124),
(71146,'enUS','','We are accustomed to wisps carrying out our labors. Please bring food to keep us sustained.',26124),
(71147,'enUS','','We typically shy away from eating the flesh of beasts, but our predicament requires that we make exception.',26124),
(71148,'enUS','','Bring us wood to graft into our saplings, $p. We shall make do with the roots in the region.',26124),
(71149,'enUS','Alliance witch!','Alliance witch!',26124),
(71150,'enUS','','The Spirit-Kissed Water from the local sprites will nourish our saplings well. And once the bucket is filled, you will not need to replenish it.',26124),
(71151,'enUS','','Do not shirk, friend. Keep us well supplied and our work will be completed sooner.',26124),
(71152,'enUS','This is my home too!','This is my home too!',26124),
(71153,'enUS','I will NOT submit!','I will NOT submit!',26124),
(71154,'enUS','','Watch over us, $p. We are not accustomed to fighting. We will require your protection if we are attacked.',26124),
(71155,'enUS','No surrender!','No surrender!',26124),
(71156,'enUS','','Wood, snake oil, food and water will speed our progress, $p. Please, do what you can to keep us supplied.',26124),
(71157,'enUS','','As you supply our camp, strive to keep the benefits from wearing off.',26124),
(71158,'enUS','','Learn well from your experience here, $p. In the future, your efficient efforts may be well rewarded.',26124),
(71159,'enUS','So the Alliance sent... you?','',26124),
(71160,'enUS','Not bad for a newbie.','',26124),
(71161,'enUS','Your fighting skills are bad and you should feel bad.','',26124),
(71162,'enUS','You call that a hit?  My grandma could hit harder and she\'s dead!','',26124),
(71163,'enUS','Just keep standing there looking dumb, it suits you.','',26124),
(71164,'enUS','You smell worse than a sulfur mine filled with unwashed yaks.','',26124),
(71165,'enUS','Surprise us both and do something smart, like running away.','',26124),
(71166,'enUS','I need a portal to Dalaran.','I need a portal to Dalaran.',26124),
(71167,'enUS','Like our people, the Horde is always in motion, always changing. But make no mistake. We will endure.','',26124),
(71168,'enUS','Let\'s go track down those thieves!','Let\'s go track down those thieves!',26124),
(71169,'enUS','Keep looking, Reliquary. We will find it. The bell is meant to ensure Horde victory. I feel it in my bones.','',26124),
(71170,'enUS','I will concern myself with how it works once I have it in my possessions, Blood Elf.','',26124),
(71171,'enUS','The Divine Bell is a weapon of unquestionable power. It belongs in horde hands. It belongs to me!','',26124),
(71172,'enUS','We\'re close! These documents all mention the bell and Kun-Lai Summit. It must be here.','',26124),
(71173,'enUS','','We\'ve been searching for days. All we have found are dusty scrolls and broken statues.',26124),
(71174,'enUS','What if the Divine Bell is in disrepair too? Are you certain you can use it even if we do find it?','What if the Divine Bell is in disrepair too? Are you certain you can use it even if we do find it?',26124),
(71175,'enUS','','Perhaps the mogu hid the bell for a reason, Warchief.',26124),
(71176,'enUS','Hey!','Get your hands off that!',26124),
(71177,'enUS','I thought I smelled something!','Hey!',26124),
(71178,'enUS','For the Horde!','Death to the Alliance!',26124),
(71179,'enUS','Pandaria is ours!','You\'re trespassing!',26124),
(71180,'enUS','You\'ll never take this land from us!','Garrosh will have your head!',26124),
(71181,'enUS','Get your hands off that!','Hey you there!',26124),
(71182,'enUS','Get outta here!','I thought I smelled something!',26124),
(71183,'enUS','Silence, coward. You\'d better ask where your loyalties lie: With the Kirin Tor? Or with the Horde?','',26124),
(71184,'enUS','Death to the Alliance!','For the Horde',26124),
(71185,'enUS','Trespassin\' huh?!','Thief!',26124),
(71186,'enUS','Enough! Do you want me to report to Garrosh that you asked us to bow to that Kirin Tor wench?!','',26124),
(71187,'enUS','You don\'t belong here!','For the Alliance!',26124),
(71188,'enUS','Hugs... we want hugs...','',26124),
(71189,'enUS','Fanlyr, what is going on here? I didn\'t authorize this.','',26124),
(71190,'enUS','I\'d give you a thumbs down, but I can\'t find it.','',26124),
(71191,'enUS','Heigh-ho... heigh-ho... OH NO!','',26124),
(71192,'enUS','I thought I smelled something!','Death to the Horde!',26124),
(71193,'enUS','You\'re routing this attack through Dalaran? Proudmoore will suspect the Sunreavers! Stop this immediately!','',26124),
(71194,'enUS','You\'ll never leave this jungle alive!','So, you\'ve come to die?!',26124),
(71195,'enUS','The night elves didn\'t properly secure their portals in Dalaran. It was a simple matter to exploit the ley lines...','',26124),
(71196,'enUS','Engaging hostile entity.  Removing protective failsafes.','',26124),
(71197,'enUS','Challenger defeated. Uploading report for analysis and verbal harassment.','',26124),
(71198,'enUS','Warranty voided.  I hope you are happy.','',26124),
(71199,'enUS','This is for Theramore!','You\'ll burn for your crimes!',26124),
(71200,'enUS','','Do not let your eyes deceive you.',26124),
(71201,'enUS','','Everyone gather \'round for a group hug.',26124),
(71202,'enUS','Die Horde scum!','You will pay for your crimes!',26124),
(71203,'enUS','','I wish I had someone other to blame than myself.',26124),
(71204,'enUS','Death to the Alliance!','I thought I smelled something!',26124),
(71205,'enUS','I had your back to the end...','',26124),
(71206,'enUS','Nice job big guy.  Brains and brawn -- together we overcome any obstacle!','',26124),
(71207,'enUS','Together we are unstoppable!','',26124),
(71208,'enUS','So, you\'ve come to die?!','You\'ll never leave this jungle alive!',26124),
(71209,'enUS','You\'ll burn for your crimes!','This is for Theramore!',26124),
(71210,'enUS','DIE QUICKLY -- I HAVE LUNCH PLANS!','',26124),
(71211,'enUS','YOU ARE BAD AND SHOULD FEEL BAD!','',26124),
(71212,'enUS','NOT COOL.','',26124),
(71213,'enUS','You will not destroy this land too!','Die Horde scum!',26124),
(71214,'enUS','So you want to play?!','',26124),
(71215,'enUS','Go get it, Sunny!','',26124),
(71216,'enUS','You won\'t survive this game of fetch, $c!','',26124),
(71217,'enUS','You know nothing of loyalty!','',26124),
(71219,'enUS','Fetch!','',26124),
(71220,'enUS','NO! Noooooo!','',26124),
(71221,'enUS','RIDDOH!','',26124),
(71222,'enUS','You will not defeat us!','',26124),
(71223,'enUS','Very well. I saw nothing. But in the future, you are NOT to exploit our relationship with the Kirin Tor.','',26124),
(71224,'enUS','Ri... Ri... Riddoh.','',26124),
(71225,'enUS','','We pandaren are such a peaceful race, but we do appreciate a good brawl every now and again!',26124),
(71226,'enUS','These Pandaren are sittin\' on a treasure trove. They even got books in here about vrykul. I mean the vrykul! Come on! How could they possibly have encountered them?','',26124),
(71227,'enUS','Time to pay the toll!','',26124),
(71228,'enUS','Relax, Aethas. This attack cannot be traced. I am certain.','',26124),
(71229,'enUS','Are you sure you want to take the portal to Stormwind?','Are you sure you want to take the portal to Stormwind?',26124),
(71230,'enUS','Are you sure you want to take the portal to Orgrimmar?','Are you sure you want to take the portal to Orgrimmar?',26124),
(71231,'enUS','And stay out!','And stay out!',26124),
(71232,'enUS','We don\'t let just any riffraff off the street in here!','We don\'t let just any riffraff off the street in here!',26124),
(71233,'enUS','Come back when you actually deserve to go up to the Boom Room!','Come back when you actually deserve to go up to the Boom Room!',26124),
(71234,'enUS','Look at this wise guy!','Look at this wise guy!',26124),
(71235,'enUS','Boss Bizmo said no nobodies allowed!','Boss Bizmo said no nobodies allowed!',26124),
(71236,'enUS','Right this way!','Right this way!',26124),
(71237,'enUS','','Oh, yes I am new to Stormwind.  Is it that obvious?',26124),
(71238,'enUS','I\'M CHARGING MY LASER!','',26124),
(71239,'enUS','I\'M FIRING MY LASER!','',26124),
(71240,'enUS','SHOOP DA WHOOP!','',26124),
(71241,'enUS','','There\'s too much smoke in the air to see very far.\n\nI can\'t make out much of anything on the beach, and sniping\'s useless.',26124),
(71242,'enUS','','I\'ll keep you covered.',26124),
(71243,'enUS','Fight with us. |cFF0008E8(Shokia will follow you.)|r','Fight with us. |cFF0008E8(Shokia will follow you.)|r',26124),
(71244,'enUS','','Alliance dogs!\n\nLook at my poor wyverns...',26124),
(71245,'enUS','','Let\'s slaughter them all.',26124),
(71246,'enUS','Fight with us. |cFF0008E8(Kromthar will follow you.)|r','Fight with us. |cFF0008E8(Kromthar will follow you.)|r',26124),
(71247,'enUS','','Anyone not already standing is dead. Bloodhilt has all the fighters he\'ll get.\n\nSo... I\'m ravenous. Shall we go find something to eat?',26124),
(71248,'enUS','','They\'ll never see me coming.',26124),
(71249,'enUS','Fight with us. |cFF0008E8(Kiryn will follow you.)|r','Fight with us. |cFF0008E8(Kiryn will follow you.)|r',26124),
(71250,'enUS','It\'s a good thing I spend all my spare time tinkering on my greatest passion: High-power directed explosives!\n\nLet\'s use some to set up defensive positions at the gates.','',26124),
(71251,'enUS','Fight with us. |cFF0008E8(Rivett will follow you.)|r','Fight with us. |cFF0008E8(Rivett will follow you.)|r',26124),
(71252,'enUS','Let\'s start explodinatin\'!','',26124),
(71253,'enUS','Miserable gnomes! They dropped out of the sky and set fire to EVERYTHING.\n\nNow the whole refinery\'s alight, and the main Alliance forces will advance on the keep at any moment!\n\nWe don\'t have the numbers to stop them...','',26124),
(71254,'enUS','We\'ll hold Domination Point or die trying!','',26124),
(71255,'enUS','Fight with us. |cFF0008E8(General Nazgrim will follow you.)|r','Fight with us. |cFF0008E8(General Nazgrim will follow you.)|r',26124),
(71256,'enUS','If the Alliance thinks a few reinforcements are all it takes to conquer MY fortress, they\'ve got another thing coming!','',26124),
(71257,'enUS','My commanding officers are all dead or missing.','',26124),
(71258,'enUS','I need information, NOW. How many Alliance are left, and how many orcs we still have - and help that mad goblin Clutchpop set up some defenses.','',26124),
(71259,'enUS','Good timing. Here they come again!','',26124),
(71260,'enUS','Ready up, you mangy grunts!','',26124),
(71261,'enUS','We\'re here to help.','We\'re here to help.',26124),
(71262,'enUS','We\'re all ready.','We\'re all ready.',26124),
(71263,'enUS','Victory! VICTORY FOR THE HORDE!','',26124),
(71264,'enUS','Here they come! HOLD FAST!','',26124),
(71265,'enUS','HAH! Hellscream would be proud! Here comes some more meat for the grinder...','',26124),
(71266,'enUS','Keep on fighting, grunts! THE EYES OF HELLSCREAM ARE UPON US!','',26124),
(71267,'enUS','Here comes the final assault. For Domination Point! BUTCHER THEM ALL!','',26124),
(71268,'enUS','Weapons up, you magnificent monsters! They\'re about to charge.','',26124),
(71271,'enUS','Don\'t forget to set your worldstate area!','Don\'t forget to set your worldstate area!',26124),
(71272,'enUS','This is the Thunder King Raid!','This is the Thunder King Raid!',26124),
(71273,'enUS','Thunder begins with a shock wave in the air due to the sudden thermal expansion of the plasma in the lightning channel!','Thunder begins with a shock wave in the air due to the sudden thermal expansion of the plasma in the lightning channel!',26124),
(71274,'enUS','The speed of sound in dry air is approximately 343 m/s!','The speed of sound in dry air is approximately 343 m/s!',26124),
(71275,'enUS','I will go, but only as a witness for my people. Someone gotta keep you in check, Garrosh.','',26124),
(71276,'enUS','$n, over here.','',26124),
(71278,'enUS','%s and Rak\'gor Bloodrazor exchange hushed words.','',26124),
(71280,'enUS','Those Mantid are protecting the towers, $p. Take them out or we won\'t be able to land any shots.','Those Mantid are protecting the towers, $p. Take them out or we won\'t be able to land any shots.',26124),
(71281,'enUS','Those scorpid are moving the towers! Take them out!','Those scorpid are moving the towers! Take them out!',26124),
(71282,'enUS','Good work, $p! We\'ll take these bombs back to the admiral immediately.','Good work, $p! We\'ll take these bombs back to the admiral immediately.',26124),
(71283,'enUS','Oh, yuck! This food is terrible!','Why don\'t buffets ever have anything good?',26124),
(71284,'enUS','Who eats this stuff anyway?','Sezik calls this food?!',26124),
(71285,'enUS','Boss-Lady is nuts if she thinks I\'ll just eat this grub!','My sensibilities are offended by this mess!',26124),
(71290,'enUS','Good shot, $p! Keep aiming for those bombs.','Good shot, $p! Keep aiming for those bombs.',26124),
(71291,'enUS','Stealing','Stealing',26124),
(71292,'enUS','Ro\'shak! Grant me wings of flame!','',26124),
(71293,'enUS','Let\'s talk!','Let\'s talk!',26124),
(71294,'enUS','Nice one, $p! That was close.','Nice one, $p! That was close.',26124),
(71295,'enUS','You were hit! Weapons temporarily disabled!','You were hit! Weapons temporarily disabled!',26124),
(71296,'enUS','The Void Binder can be found in the Hall of Secrets, just upstairs and to the right as you enter the building.','The Void Binder can be found in the Hall of Secrets, just upstairs and to the right as you enter the building.',26124),
(71297,'enUS','The Void Binder can be found in the Ethereal Corridor, just upstairs and to the right as you enter the building.','The Void Binder can be found in the Ethereal Corridor, just upstairs and to the right as you enter the building.',26124),
(71299,'enUS','Void Binder','Void Binder',26124),
(71301,'enUS','I will show no mercy!','',26124),
(71302,'enUS','Vol\'jin holds his hand out to you.','',26124),
(71303,'enUS','Swear the blood oath with Vol\'jin','Swear the blood oath with Vol\'jin',26124),
(71304,'enUS','','Without these throwing axes, their axe throwers will certainly be less effective.',26124),
(71305,'enUS','You want to fight?  Come back when you\'re a bit stronger.$b$bYou\'re welcome to watch, though.','You want to fight?  Come back when you\'re a bit stronger.$b$bYou\'re welcome to watch, though.',26124),
(71306,'enUS','You want to fight?  You\'re gonna need an invite.$b$bYou\'re welcome to watch, though.','You want to fight?  You\'re gonna need an invite.$b$bYou\'re welcome to watch, though.',26124),
(71307,'enUS','Ah, $n, ya heart be a worthy sacrifice!','Ah, $n, ya heart be a worthy sacrifice!',26124),
(71314,'enUS','','That\'s fewer accursed Zandalari Priests we have to deal with.',26124),
(71315,'enUS','','Those innocent pterodactyl hatchlings now have a chance at a real life.',26124),
(71316,'enUS','','Hopefully taking these offerings will slow their sacrificial rituals down.',26124),
(71317,'enUS','','These Zandalari are proving to be a greater threat than I expected.',26124),
(71318,'enUS','','I can\'t believe the Zandalari actually make living sacrifices!',26124),
(71319,'enUS','When did you arrive on this island?','When did you arrive on this island?',26124),
(71320,'enUS','','Not long ago, but I\'ve already seen terrible suffering in this place!',26124),
(71339,'enUS','','An enormous thundering cloud serpent bars our entrance into Lei Shen\'s domain.',26124),
(71340,'enUS','','There are few thundering cloud serpents left in our world.',26124),
(71341,'enUS','','We are investigating the sewer system - perhaps there is another way in to the citadel.',26124),
(71342,'enUS','','Me? I practice the art of the Jade Lightning. My fists are so fast, you won\'t even be able to see them!',26124),
(71343,'enUS','','Ah, $p! Just the $c I\'ve been looking for.$B$BDo you remember how the Alliance came to Pandaria? You were there, weren\'t you? But your presence in that part of Pandaria\'s timeline is... incomplete. You saw only a portion of the events which transpired that day.$B$BMaybe you fled the chaos of war to walk the peaceful valleys of this land. Or perhaps the call of treasure from dungeons exotic and ancient was louder than the call of your king to find his White Pawn.$B$BRegardless, I am not here to judge. I merely offer a second chance.$B$BSay the word, and I will transport you back to that day. Lion\'s Landing will not yet have been built, and the Skyfire will loom over Jade Forest.',26124),
(71344,'enUS','I want to see the Skyfire in Jade Forest. Take me back.','I want to see the Skyfire in Jade Forest. Take me back.',26124),
(71345,'enUS','Are you sure you want to change your phase?','Are you sure you want to change your phase?',26124),
(71346,'enUS','%s lets out a booming call, attracting nearby turtles.','',26124),
(71347,'enUS','','Ah, $p! Just the $c I\'ve been looking for.$B$BDo you remember how the Alliance came to Pandaria? You were there, weren\'t you? But your presence in that part of Pandaria\'s timeline is... incomplete. You saw only a portion of the events which transpired that day.$B$BMaybe you fled the chaos of war to walk the peaceful valleys of this land. Or perhaps the call of treasure from dungeons exotic and ancient was louder than the call of your king to find his White Pawn.$B$BRegardless, I am not here to judge. I merely offer a second chance.$B$BSay the word, and I will transport you back to that day. Lion\'s Landing will not yet have been built, and the Skyfire will loom over Jade Forest.',26124),
(71348,'enUS','Look for Old Man Barlo out by Silmyr Lake, northeast of Shattrath City.','Look for Old Man Barlo out by Silmyr Lake, northeast of Shattrath City.',26124),
(71349,'enUS','','Hello again, $p! Enjoying your second chance?$B$BIf you continue along the adventure here until the Skyfire leaves, you\'ll automatically re-join the normal timeline and find Lion\'s Landing established again.$B$BOr, if you\'d rather go back, er... forward to Lion\'s Landing now, let me know!',26124),
(71350,'enUS','I want to return to Lion\'s Landing.','I want to return to Lion\'s Landing.',26124),
(71355,'enUS','I am born of thunder!','I am born of thunder!',26124),
(71356,'enUS','Can you feel a chill wind blow? The storm is coming...','Can you feel a chill wind blow? The storm is coming...',26124),
(71357,'enUS','The clouds arc with vengeance!','The clouds arc with vengeance!',26124),
(71358,'enUS','The air crackles with anger!','The air crackles with anger!',26124),
(71359,'enUS','The sky weeps for your demise!','The sky weeps for your demise!',26124),
(71360,'enUS','I am but...the darkness...before the storm...','I am but...the darkness...before the storm...',26124),
(71361,'enUS','Let me share dis gift with ya!','',26124),
(71362,'enUS','More are coming aboard.  Hold them off!','',26124),
(71363,'enUS','They\'re sending boarding parties from the sea.  One of you man the aft cannon and take \'em down!','',26124),
(71364,'enUS','Gusting Grimoire','Gusting Grimoire',26124),
(71365,'enUS','Dark Portal Heartstone','Dark Portal Heartstone',26124),
(71366,'enUS','Ghastly Charger','Ghastly Charger',26124),
(71367,'enUS','Betrayal of the Guardian','Betrayal of the Guardian',26124),
(71368,'enUS','We\'ve held them off for now.  Hop in the port-side cannon and help out our other ships!','',26124),
(71369,'enUS','We\'ve pushed them back to their ship.  Swing over and use some of their explosives to blow it to smithereens!','',26124),
(71371,'enUS','|TInterface\\Icons\\inv_misc_dust.blp:20|tDurumu begins charging up his eye to cast |cFFFF0000|Hspell:134169|h[Disintegration]|h|r!','',26124),
(71372,'enUS','','',26124),
(71373,'enUS','Your Capacitor will Discharge in 10 Seconds! Get to a Drill!','Your Capacitor will Discharge in 10 Seconds! Get to a Drill!',26124),
(71374,'enUS','On this island I must ask you to face great dangers. Your loyalty and trust are appreciated, $n.','',26124),
(71375,'enUS','We blood elves have weathered many a storm. Whatever the Thunder King unleashes against us, we shall strike him an even greater blow!','',26124),
(71376,'enUS','While our goals call for the eradication of the mogu, we can\'t ignore our flanks.$b$bWhile both the Alliance and the saurok attack the mogu alongside us, either could turn on us at any moment.','',26124),
(71377,'enUS','We must find a way to strip our enemies of their power. Without their strength, we can easily overcome them with our will.','',26124),
(71378,'enUS','Stealing artifact','Stealing artifact',26124),
(71379,'enUS','Removing','Removing',26124),
(71380,'enUS','Don\'t be makin\' da big one mad, mon!','',26124),
(71381,'enUS','We gonna\' feed ya to the big one!','',26124),
(71382,'enUS','Too late for ya to be runnin\' away now, mon!','',26124),
(71383,'enUS','Ya barely be fit tah\' feed to de big one.','',26124),
(71384,'enUS','Came to the wrong place, ya did.','',26124),
(71385,'enUS','Good! Mah pet be gettin\' hungry, mon.','',26124),
(71386,'enUS','Ah, the food be arrivin\'.','',26124),
(71387,'enUS','Ya came to the right place... to be eaten!','',26124),
(71388,'enUS','Bow before the Zandalari!','',26124),
(71389,'enUS','It be feedin\' time!','',26124),
(71390,'enUS','Ya come to the right place to die.','',26124),
(71391,'enUS','I gonna\' feed ya soul to dah beasts.','',26124),
(71392,'enUS','Ya be nothin\' but fuel to me.','',26124),
(71393,'enUS','The Loa gonna\' eat you up.','',26124),
(71394,'enUS','Die ya trespassah.','',26124),
(71395,'enUS','Have a taste of Zandalari magic!','',26124),
(71396,'enUS','Ya soul be weak.','',26124),
(71397,'enUS','Come closer. Just a little cut, I promise!','',26124),
(71398,'enUS','Once the incision is made, the blood flows quickly.','',26124),
(71399,'enUS','The more you struggle, the more it will hurt!','',26124),
(71400,'enUS','Your death will not come swiftly. I can guarantee that!','',26124),
(71401,'enUS','Ah, a new subject? I will take you apart... piece by piece!','',26124),
(71402,'enUS','Yes, come closer, little one. My scalpel thirsts for your blood!','',26124),
(71403,'enUS','Horridon sets his eyes on $n and stamps his tail!','Horridon sets his eyes on $n and stamps his tail!',26124),
(71404,'enUS','Ah, the lair of the beasts. While I admire the Zandalari skill with beasts I am more impressed with their ability to endure this foul odor.$b$bKeep a devilsaur upwind of you and it will never catch you off guard.','',26124),
(71405,'enUS','|TInterface\\Icons\\ability_warrior_focusedrage.blp:20|t Horridon goes on a |cFFFF0000|Hspell:136821|h[Rampage]|h|r after seeing War-God Jalak fall!','|TInterface\\Icons\\ability_warrior_focusedrage.blp:20|t Horridon goes on a |cFFFF0000|Hspell:136821|h[Rampage]|h|r after seeing War-God Jalak fall!',26124),
(71406,'enUS','You be gettin\' back!','',26124),
(71407,'enUS','Come back, stupid vermin!','',26124),
(71408,'enUS','Not anotha!','',26124),
(71409,'enUS','Die by the fury of the storm!','',26124),
(71412,'enUS','|TInterface\\Icons\\ability_thunderking_lightningwhip.blp:20|t%s begins to cast |cFFFF0000|Hspell:136850|h[Lightning Whip]|h|r!','',26124),
(71413,'enUS','I was not always a shortfang. I was strong.','',26124),
(71414,'enUS','My father was a brute. My mother was a saur-priest. I am nothing.$b$bI am a disgrace to the Skumblade. I will die in the filth, and they will not eat my meat.','',26124),
(71415,'enUS','I will never know the strength of Kros. I will never hunt in his fields.$b$bI am not the predator. I am the prey.','',26124),
(71416,'enUS','They tell me that I can shed my shame. I only need to do one thing, and then I will not be a shortfang.$b$bBut I cannot do that. I cannot take Farros\' strength for myself. Not after what he has done for me...','',26124),
(71417,'enUS','As a shortfang, I must wait until the stronger saurok have had their share of meat.','',26124),
(71418,'enUS','I smell you, outsider. I know you are not one of us.$b$bWhy do you sneak into our village? Why do you wear the skin of our people? I do not understand.','',26124),
(71419,'enUS','I know you are not one of us. You are one of them.$b$bI follow you. I watch you. You kill our people, but you also kill mogu. You kill straight-back trolls.$b$bI do not care who you kill. I pick up the meat afterward. So very, very much meat.','',26124),
(71420,'enUS','I have seen your magic. I know that you are not saurok. You are other.$b$bYour magic makes you weak. You are not brave. You are coward who hides in enemy\'s skin. YOU ARE NOT STRONG!$b$b<Gokkar spits at your feet.>','',26124),
(71421,'enUS','I know your secret, outsider. I know you are an enemy. I smell through your false skin.$b$bI am not scared of you. Fear is for the weak. I am not weak.','',26124),
(71422,'enUS','I smell through your disguise, stranger. You are bold to come to such a sacred ritual.$b$bWhat do you intend here? Will you eat the flesh of Kroshik?','',26124),
(71423,'enUS','We are born from the flesh of Kros. We were fashioned from his meat, his bones. He is our creator.$b$bKroshik is the blood of Kros. He watches over us. He is our connection to Kros. He has the strength of Kros, yet he walks on our world.$b$bWhen the time comes, Kroshik will die, and we will take his strength. Then, the cycle will start again.','',26124),
(71424,'enUS','Kroshik has a body of meat and bone, but he carries with him the spirit of Kros.$b$bOne day, Kroshik\'s hunt will end. But Kros\'s hunt goes on forever.','',26124),
(71425,'enUS','The mogu lie to our people. They tell us that we are their creation, that they twisted our flesh into its current form. They claim that we owe our existence to them.$b$bI DEFY the mogu! They have no power over us! They do not know what we see, how we live, what we feel! They cannot see into our souls!$b$bOnly Kros, the great creator, knows what is in your soul. Kros knows, and Kros understands. Kros gave you your strength, saurok. No mogu owns you.','',26124),
(71426,'enUS','Kros, our creator, will not save the weak. The souls of the weak will exist in eternal fear, always fleeing from the teeth and claws of Kros and his followers.$b$bIf you are strong, Kros will allow you to hunt. Your eternity will be spent chasing the weak, eating their flesh, and becoming ever stronger.$b$bBe strong, saurok.$b$bStrength always to the Skumblade. Strength always to you, saurok.','',26124),
(71427,'enUS','Eat the flesh of Kroshik, and be cleansed of weakness! Let the spirit of Kros pass through your body!','',26124),
(71428,'enUS','You know what I think? <Tomma glances quickly behind him.>$b$bThe saur-priests are as filled with filth as the village itself.$b$bTheir Kroshik-worship makes them weak. They preach strength, but do they hunt? Do they kill? Do they roll in the decaying remains of their fallen brothers?$b$bNo. They hide in their caves and talk. If they were truly strong, they would be out here fighting with us.','',26124),
(71429,'enUS','The saur-priests will tell you that our strength comes from Kroshik. Don\'t listen to their religious talk.$b$bOur strength comes from our claws, from our teeth, from our weapons. It comes from the filth that the filth-mongers gather and cultivate.$b$bIt comes from us.$b$bI don\'t care whether we descended from some devilsaur in the sky or we were created by the mogu. All I care about is protecting this land from our enemies.','',26124),
(71430,'enUS','We were created by the mogu. There is no reason not to believe it. Anybody who denies it is ignorant, or living in fantasy.$b$bI refuse to pretend I am a devilsaur. I know what I am. I know where my strength comes from.','',26124),
(71431,'enUS','Saurok who worship Kroshik only do so because they are scared.$b$bThey pretend that we are all just little walking devilsaurs, proving our \"strength\" to gain the favor of an invisible, all-powerful devilsaur that lives in the sky.$b$bThat is truly what they believe.$b$bWe are not devilsaurs. We are saurok. And when we die, there will be no eternal hunt, no promised paradise, no punishment for the weak, and no Kros. We will be eaten, and our remains thrown into the filth-pool. And that is all. I have seen it.','',26124),
(71432,'enUS','I will not participate in their false ritual. There is nothing special about Kroshik, or his meat. Meat is meat.','',26124),
(71433,'enUS','Found any good meat lately?$b$bI ate a gnome the other day. Hardly worth the effort of pulling all those pink hairs out of my teeth.','',26124),
(71434,'enUS','You have roach on your foot, $gbrother:sister;.$b$bWatch your step.  The roaches help us spread disease.','',26124),
(71435,'enUS','I found a good bit of filth out in the swamps today. The filth-mongers will be proud of me.','',26124),
(71436,'enUS','Do not eat clean meat. The Skumblade are just as strong on the inside as they are on the outside.','',26124),
(71437,'enUS','I watch our new enemies.$b$bThe straight-back trolls ally with the mogu, but the other invaders fight against them.$b$bPfah! I do not care. Their battles have given us many new corpses to scavenge. The Skumblade have never been stronger.','',26124),
(71438,'enUS','Found any good meat lately?$b$bI ate a blood elf the other day. He tasted like he\'d been rolling in flowers.','',26124),
(71439,'enUS','Do me a favor: deposit your extra filth into the filth-pool.','',26124),
(71440,'enUS','Change is coming to Ihgaluk. The saurok are turning on one another. Some think that there are intruders among us.','',26124),
(71441,'enUS','Made any good kills lately?$b$bI killed a tauren yesterday. It took three scavengers to bring his parts back to the filth-pool!','',26124),
(71442,'enUS','The mogu seek to destroy us. The mogu are our enemy. I will slay every last mogu that comes close to our home.$b$bWill you help?','',26124),
(71443,'enUS','Made any good kills lately?$b$bI killed a draenei yesterday. You can still find her near the filth-pool... just look for the blue entrails.','',26124),
(71444,'enUS','Keep your claws sharp. You never know when another piece of meat will walk by.','',26124),
(71445,'enUS','Fight, kill, eat, live another day.$b$bIf you die, die where your brothers and sisters can eat you. No point in feeding your enemies.','',26124),
(71446,'enUS','Kill the mogu.$b$bKill the mogu.$b$bKill the mogu.','',26124),
(71447,'enUS','Strength always to the Skumblade. Death and dismemberment to our enemies.','',26124),
(71448,'enUS','How do you prefer to kill? With tooth? With blade? From behind? From darkness?','',26124),
(71449,'enUS','Look at you, clean-scale. Do you want the mogu to attack you? Do you want to be their pet?$b$bProtect yourself, $gbrother:sister;. Get your filth on.','',26124),
(71450,'enUS','It is our responsibility to keep the muck fresh. The filth keeps us safe. It keeps our enemies away.','',26124),
(71451,'enUS','Keep your hunger in check, $gbrother:sister;. Always leave some meat behind to rot.$b$bOverly-ravenous saurok will bring doom to us all.','',26124),
(71452,'enUS','Ah! You have a clean spot, $gbrother:sister;. Let me just get that for you...','',26124),
(71453,'enUS','Let me know if you catch anybody interfering with our filth-pool. I\'ve heard stories about intruders.','',26124),
(71454,'enUS','Try not to step on my roaches, $gbrother:sister;.','',26124),
(71455,'enUS','If you ever need any filth, come talk to me. I can help.','',26124),
(71456,'enUS','Stay away from the sea. Too clean.$b$bThe saur-priests can tell you: Filthiness is next to godliness.','',26124),
(71457,'enUS','The mogu claim to have created us... to have twisted us into our current forms. Do not believe their lies.$b$bWe are our own people, evolved from the great creator, Kros himself!','',26124),
(71458,'enUS','Kroshik is a gift from our creator, Kros. He reminds us of our strength, of our heritage, of our legacy. He gives us a glimpse at our glorious future.','',26124),
(71459,'enUS','The mogu are our enemy. They seek to eliminate us from this world. Why should we believe the creation myths that they feed us?','',26124),
(71460,'enUS','Be strong.$b$bBe vicious.$b$bKill more than you can eat.$b$bMake no friends, and take no pets.$b$bDie fighting.$b$bThese, and many more, are lessons we can learn from Kroshik.','',26124),
(71461,'enUS','Humble yourself before Kroshik, saurok. In this world, he is the closest to Kros that you will ever get.$b$bSavor in his presence. He will not live forever.','',26124),
(71462,'enUS','Kroshik gives us his body, his bones, his strength, and his spirit. We owe our existence to him.','',26124),
(71463,'enUS','Kroshik is the blood of Kros, our creator. We are Kros\' chosen people.$b$bWith his strength behind us, we can never die.','',26124),
(71464,'enUS','Live a life devoted to the ideals of Kros. Never stop fighting, never stop growing. Each day, stronger than before.$b$bFight through pain. Suffer through filth. Everyone is your enemy.$b$bDie with your weapon in your hand. Give your body to Ihgaluk.','',26124),
(71465,'enUS','Kill mogu.','',26124),
(71466,'enUS','Enemy is walking meat.','',26124),
(71467,'enUS','Death to mogu.','',26124),
(71468,'enUS','Kill. Eat. Kill.','',26124),
(71469,'enUS','Sharp teeth, sharp claws.','',26124),
(71470,'enUS','No fear. No remorse. Kill invader.','',26124),
(71471,'enUS','No mercy for weak.','',26124),
(71472,'enUS','Never weak. Always strong.','',26124),
(71473,'enUS','Keep an eye to the sea, $gbrother:sister;. The mogu can attack from anywhere.','',26124),
(71474,'enUS','Seadragons rank high in the eyes of Kros. The sea is home to good food and filth.','',26124),
(71475,'enUS','The Altar of Kros is sacred ground, $gbrother:sister;. Watch where you tread when you\'re on my beach.','',26124),
(71476,'enUS','We see strange ships. These are not mogu ships.$b$bWho are the invaders? What do they want? What do they taste like?','',26124),
(71477,'enUS','Lots of corpses in the sea. More than usual.$b$bThere is war nearby.$b$bThis is good for the saurok. More corpses means more food, more filth.','',26124),
(71478,'enUS','I smell intruders. They are near.$b$b<The seadragon eyes you suspiciously.>','',26124),
(71479,'enUS','Some saur-priests call me traitor. \"Kroshik does not hunt in the sea,\" they say.$b$bI follow the path of Kros, but I do not agree with these priests. Kroshik hunts WHEREVER HE CAN, and so do I.$b$bThese priests and their stubborn, closed-mind idea of Kroshik have no place in today\'s Skumblades.','',26124),
(71480,'enUS','Filth protects us. Our enemies cannot stand the smell of Ihgaluk.$b$bBut it is hard to keep filth on the beach. The ocean drinks our filth faster than we can create it. There must be other ways to protect our shores.$b$b<The seadragon flashes a razor-toothed smile.> That\'s where I come in, $gbrother:sister;.','',26124),
(71481,'enUS','<The saurok cowers behind its pet.>','',26124),
(71482,'enUS','Please, stay back, stronger. I want no fight.','',26124),
(71483,'enUS','The saur-priests have seen my weakness. The brutes beat me, and call me shortfang. If I did not have my basilisk to protect me, I would be all alone.$b$bLikely dead.','',26124),
(71484,'enUS','You bend down to speak with me? A pet-keeper? A shortfang?$b$bI know my place in this world, stronger. I am not strong enough to fight on my own, so I keep a pet. I am called weak, and pushed to the edge of the village.$b$bYou should stay away from me, before they see you.','',26124),
(71485,'enUS','Yes, stronger?','',26124),
(71486,'enUS','I am nothing, I am no one, I am weak.$b$bI am nothing, I am no one, I am weak.$b$bI am nothing...','',26124),
(71487,'enUS','There are ways for a shortfang to become stronger. If I wanted, I could escape the scorn of my tribe.$b$bThere are ways... but I am afraid. I am too scared, too weak.$b$bThey do not understand me. I will be a shortfang all my life.','',26124),
(71488,'enUS','<The shortfang recoils in fear.>','',26124),
(71489,'enUS','Silence, fool! Kroshik approaches!','',26124),
(71490,'enUS','<The saurok kneels in silent reverence.>','',26124),
(71491,'enUS','Show some respect, saurok. Do you not see Kroshik?','',26124),
(71492,'enUS','Close your mouth and take a knee, fool. Kroshik is near.','',26124),
(71493,'enUS','Eat the flesh of Kroshik, and be cleansed of your weakness.','',26124),
(71494,'enUS','His flesh will feed us, and give us strength. His rotting insides will be thrown into the filth-pool, protecting us from intruders. His bones will build our homes. His seed will continue the cycle indefinitely.$b$bStrength always to Kroshik. Strength always to the Skumblade.','',26124),
(71495,'enUS','Kroshik!','',26124),
(71496,'enUS','Strength always to the Skumblade!','',26124),
(71497,'enUS','|TInterface\\Icons\\spell_nature_lightningoverload.blp:20|t The |cFFFF0000Northwest|r doors begin to open, causing |cFFFF0000|Hspell:136889|h[Violent Gale Winds]|h|r!','',26124),
(71498,'enUS','Metal Lord Mono-Han prepares a whirling attack!','Metal Lord Mono-Han prepares a whirling attack!',26124),
(71500,'enUS','Lord Gura commanded the very power of the storm at his fingertips. With a single word, he could blanket the earth in crackling electricity. Those caught in his storm died a terrible, scorching death.','Lord Gura commanded the very power of the storm at his fingertips. With a single word, he could blanket the earth in crackling electricity. Those caught in his storm died a terrible, scorching death.',26124),
(71501,'enUS','Stupid ting!','',26124),
(71502,'enUS','','Death, danger, the return of the Zandalari and their magic. Exciting!',26124),
(71504,'enUS','','The Kirin Tor can keep Dalaran for all I care. This is where I feel most at home, behind enemy lines, right in the thick of things!',26124),
(71506,'enUS','The Quicksilver falls off his blades! Kill the blobs to absorb their power!','The Quicksilver falls off his blades! Kill the blobs to absorb their power!',26124),
(71507,'enUS','Thank you, friend. You have rescued me from a terrible fate.','Thank you, friend. You have rescued me from a terrible fate.',26124),
(71508,'enUS','Did the Sunreavers send you? Thank you for the well-timed rescue.','Did the Sunreavers send you? Thank you for the well-timed rescue.',26124),
(71509,'enUS','Thank you. I can find my way back to camp from here.','Thank you. I can find my way back to camp from here.',26124),
(71510,'enUS','Thank you, champion. Please, free the others as well!','Thank you, champion. Please, free the others as well!',26124),
(71511,'enUS','How could the mogu be capable of such atrocity? Thank goodness you arrived when you did.','How could the mogu be capable of such atrocity? Thank goodness you arrived when you did.',26124),
(71512,'enUS','You have my eternal gratitude, hero.','You have my eternal gratitude, hero.',26124),
(71513,'enUS','You have saved my life, champion. For that, I am in your debt.','You have saved my life, champion. For that, I am in your debt.',26124),
(71514,'enUS','Did the Silver Covenant send you? Thank you for the well-timed rescue.','Did the Silver Covenant send you? Thank you for the well-timed rescue.',26124),
(71515,'enUS','I knew the Silver Covenant would not desert me. Thank you, champion.','I knew the Silver Covenant would not desert me. Thank you, champion.',26124),
(71516,'enUS','I knew the Sunreavers would not desert me. Thank you, champion.','I knew the Sunreavers would not desert me. Thank you, champion.',26124),
(71517,'enUS','I should tear you apart, Alliance scum! I will restrain myself this once.','I should tear you apart, Alliance scum! I will restrain myself this once.',26124),
(71518,'enUS','I will stay my hand this time, Alliance hero. Let it not be said that the Sunreavers do not show gratitude.','I will stay my hand this time, Alliance hero. Let it not be said that the Sunreavers do not show gratitude.',26124),
(71519,'enUS','If you had not just rescued me from certain death, I would kill you where you stand. Next time we meet, I will not hold back.','If you had not just rescued me from certain death, I would kill you where you stand. Next time we meet, I will not hold back.',26124),
(71520,'enUS','Although we are enemies, I will thank you. Just this once.','Although we are enemies, I will thank you. Just this once.',26124),
(71521,'enUS','Thank you, Alliance hero, but next time we meet, I will show no mercy.','Thank you, Alliance hero, but next time we meet, I will show no mercy.',26124),
(71522,'enUS','Thank you, Horde hero, but next time we meet, I will show no mercy.','Thank you, Horde hero, but next time we meet, I will show no mercy.',26124),
(71523,'enUS','I will stay my hand this time, Horde hero. Let it not be said that the Silver Covenant does not show gratitude.','I will stay my hand this time, Horde hero. Let it not be said that the Silver Covenant does not show gratitude.',26124),
(71524,'enUS','I should tear you apart, Horde scum! I will restrain myself this once.','I should tear you apart, Horde scum! I will restrain myself this once.',26124),
(71525,'enUS','If you had not just rescued me from certain death, I would kill you where you stand. Next time we meet, I will not hold back.','If you had not just rescued me from certain death, I would kill you where you stand. Next time we meet, I will not hold back.',26124),
(71526,'enUS','Although we are enemies, I will thank you. Just this once.','Although we are enemies, I will thank you. Just this once.',26124),
(71527,'enUS','Thank you. I can find my way back to camp from here.','Thank you. I can find my way back to camp from here.',26124),
(71528,'enUS','Thank you, champion. Please, free the others as well!','Thank you, champion. Please, free the others as well!',26124),
(71529,'enUS','How could the mogu be capable of such atrocity? Thank goodness you arrived when you did.','How could the mogu be capable of such atrocity? Thank goodness you arrived when you did.',26124),
(71530,'enUS','You have my eternal gratitude, hero.','You have my eternal gratitude, hero.',26124),
(71531,'enUS','Thank you, friend. You have rescued me from a terrible fate.','Thank you, friend. You have rescued me from a terrible fate.',26124),
(71532,'enUS','You have saved my life, champion. For that, I am in your debt.','You have saved my life, champion. For that, I am in your debt.',26124),
(71533,'enUS','What is this magic?','',26124),
(71534,'enUS','Strength always to the Skumblade!','',26124),
(71535,'enUS','Aggh!','',26124),
(71536,'enUS','Intruders!','',26124),
(71537,'enUS','I\'ll rip you apart!','',26124),
(71538,'enUS','Gah!','',26124),
(71539,'enUS','You come to steal our filth?','',26124),
(71540,'enUS','I\'ll throw your corpse in the filth-pool!','',26124),
(71541,'enUS','Blech!','',26124),
(71542,'enUS','Stay back!','',26124),
(71543,'enUS','What do you want from me?','',26124),
(71544,'enUS','N-no!','',26124),
(71545,'enUS','You die now.','',26124),
(71546,'enUS','Strength.','',26124),
(71547,'enUS','Time to kill.','',26124),
(71548,'enUS','By Kroshik\'s teeth, how did you get here?!','',26124),
(71549,'enUS','What is this magic?','',26124),
(71550,'enUS','Kros, give me strength...','',26124),
(71551,'enUS','Curse you, coward...','',26124),
(71552,'enUS','I knew I smelled something...','',26124),
(71553,'enUS','You\'ll regret this...','',26124),
(71554,'enUS','I\'ve been busy. A few of the Saur-Priests have been calling for Horde and Alliance blood.$b$bNaturally, I killed them in their sleep.','',26124),
(71555,'enUS','The filth pool is more rancid than I\'ve ever seen it. We need to get somebody in here to clean up before it gets any worse and starts spreading outside the crag.','',26124),
(71556,'enUS','They\'ve been chanting: \"Kill the mogu\" all day. Whatever Aethas has you doing, it\'s working.','',26124),
(71557,'enUS','They\'ve been talking all day about the mogu weapons they found within Ihgaluk Crag.$b$bThey don\'t suspect us at all. Keep up the good work.','',26124),
(71558,'enUS','From what I\'ve gathered, they\'re preparing for an attack on the mogu at dawn.','',26124),
(71559,'enUS','These saurok just returned from an attack on the mogu. I will continue to observe them.','',26124),
(71560,'enUS','The saurok leadership has called off their attacks on the mogu. They plan on attacking the Horde and Alliance instead.$b$bIt may be time to intervene.','',26124),
(71561,'enUS','The saurok have been quiet lately, and are becoming restless. The time is ripe to turn them against the mogu.','',26124),
(71562,'enUS','','Tell Aethas that the saurok have been quiet today. No impending attacks.',26124),
(71563,'enUS','','The saurok are restless. They\'re planning something. Aethas will want to know.',26124),
(71564,'enUS','','Let the archmage know that everything is under control here at Ihgaluk. I\'ll have another report in a few days.',26124),
(71565,'enUS','','It looks like the scavengers may be sending a large party out into the swamp soon. Tell the archmage to be ready.',26124),
(71566,'enUS','REBOOTING...','',26124),
(71567,'enUS','SYSTEM ONLINE. FEELING MUCH BETTER NOW.','',26124),
(71568,'enUS','ATTEMPTING TO RECOVER FROM EMBARRASSING MALFUNCTION...','',26124),
(71569,'enUS','RECOVERY FAILED. INCREMENTING SHAME PARAMETER. RETURNING TO BASE.','',26124),
(71570,'enUS','LEG FAILURE LOOP BROKEN. RETURNING TO BASE.','',26124),
(71571,'enUS','EXECUTING SAND EXTRACTION PROTOCOL.','',26124),
(71572,'enUS','WARNING: MANA FLOW RATE STILL ELEVATED.','',26124),
(71573,'enUS','ATTEMPTING MANA FLOW RATE REDUCTION OVERRIDE PROTOCOL.','',26124),
(71574,'enUS','\"EVERYTHING IS OK\"','',26124),
(71575,'enUS','\"EVERYTHING IS ALRIGHT\"','',26124),
(71576,'enUS','\"$N WILL MAKE IT ALL BETTER\"','',26124),
(71577,'enUS','MANA FLOW RATE NOMINAL. RETURNING TO BASE.','',26124),
(71578,'enUS','ATTEMPTING TO DESTROY MEMORY RECORDS OF PREVIOUS 6 HOURS.','',26124),
(71579,'enUS','MEMORY RECORDS DESTROYED. WHO ARE YOU. RETURNING TO BASE.','',26124),
(71580,'enUS','POWERING ON...','',26124),
(71581,'enUS','LOCATION UNRECOGNIZED. RETURNING TO LAST KNOWN BASE LOCATION.','',26124),
(71582,'enUS','EXECUTING GRATITUDE PROTOCOL.','',26124),
(71583,'enUS','\"THANK YOU\"','',26124),
(71584,'enUS','Have you seen our magnificent riding turtles? They only appear slow at a glance - an experienced rider may keep pace with the swiftest wolves on all of Kalimdor. Alas, they are reserved only for our most trusted allies.','Have you seen our magnificent riding turtles? They only appear slow at a glance - an experienced rider may keep pace with the swiftest wolves on all of Kalimdor. Alas, they are reserved only for our most trusted allies.',26124),
(71585,'enUS','You will find no better riding companion than our dragon turtles. Their low stance means the rider experiences no bounce or jostle, even when cornering sharply. If you are interested in purchasing one, you must prove your trust to the Tushui.','You will find no better riding companion than our dragon turtles. Their low stance means the rider experiences no bounce or jostle, even when cornering sharply. If you are interested in purchasing one, you must prove your trust to the Tushui.',26124),
(71586,'enUS','So cold, so dark...','So cold, so dark...',26124),
(71587,'enUS','We will not be forgotten, no, no, no...','We will not be forgotten, no, no, no...',26124),
(71588,'enUS','We are the perfect one, yes, yes, not a failure, no no, not a failure...','We are the perfect one, yes, yes, not a failure, no no, not a failure...',26124),
(71589,'enUS','What is this? What do they want? To punish us? No, no...','What is this? What do they want? To punish us? No, no...',26124),
(71590,'enUS','Your flesh, yes yes, so perfect, GIVE IT TO US!','Your flesh, yes yes, so perfect, GIVE IT TO US!',26124),
(71591,'enUS','No no no, the pain returns!','No no no, the pain returns!',26124),
(71592,'enUS','It tears at us from the inside!','It tears at us from the inside!',26124),
(71593,'enUS','Who is perfect now? Yes, yes...','Who is perfect now? Yes, yes...',26124),
(71594,'enUS','Again...we are torn apart...again...to the cold darkness...','Again...we are torn apart...again...to the cold darkness...',26124),
(71595,'enUS','I want to use my challenge card!','I want to use my challenge card!',26124),
(71596,'enUS','I want to fight to increase my rank!','I want to fight to increase my rank!',26124),
(71597,'enUS','Your soul is mine, trespasser!','',26124),
(71598,'enUS','Ahhh, another soul for the taking.','',26124),
(71599,'enUS','I will make good use of you, intruder.','',26124),
(71600,'enUS','I will savor your death, interloper!','',26124),
(71601,'enUS','For the Thunder King!','',26124),
(71602,'enUS','Living Fluids begin to form in a nearby pool!','Living Fluids begin to form in a nearby pool!',26124),
(71603,'enUS','Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136210|h[Ventral Sacs]|h|r!','Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136210|h[Ventral Sacs]|h|r!',26124),
(71604,'enUS','Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136215|h[Gas Bladder]|h|r!','Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136215|h[Gas Bladder]|h|r!',26124),
(71605,'enUS','Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136218|h[Acidic Spines]|h|r!','Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136218|h[Acidic Spines]|h|r!',26124),
(71606,'enUS','Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136225|h[Pathogen Glands]|h|r!','Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136225|h[Pathogen Glands]|h|r!',26124),
(71607,'enUS','Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136245|h[Metabolic Boost]|h|r!','Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136245|h[Metabolic Boost]|h|r!',26124),
(71608,'enUS','Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136246|h[Erupting Pustules]|h|r!','Primordius |cFFFF0000|Hspell:136209|h[Evolves]|h|r and gains |cFFFF0000|Hspell:136246|h[Erupting Pustules]|h|r!',26124),
(71609,'enUS','Dis is gonna hurt!','',26124),
(71610,'enUS','Primordius mutates out of control!','Primordius mutates out of control!',26124),
(71611,'enUS','Hoku begins to corrupt your blood...','Hoku begins to corrupt your blood...',26124),
(71612,'enUS','I am ready! [Queue for solo instance.]','I am ready! [Queue for solo instance.]',26124),
(71613,'enUS','Welcome, weaklings, to the rebirth of the Zandalari Empire!','Welcome, weaklings, to the rebirth of the Zandalari Empire!',26124),
(71614,'enUS','The tribes have assembled - ye face not one force, but the combined might of all of the troll empire! The hand of Zul will span all the continents of Azeroth once again! An ye lesser races will know pain!','The tribes have assembled - ye face not one force, but the combined might of all of the troll empire! The hand of Zul will span all the continents of Azeroth once again! An ye lesser races will know pain!',26124),
(71615,'enUS','Now, witness the true might of the Beast Ward. D\'akala di\'chuka HORRIDON! Kalimaste!','Now, witness the true might of the Beast Ward. D\'akala di\'chuka HORRIDON! Kalimaste!',26124),
(71616,'enUS','Drakkari tribe, show them the might of the frozen North!','Drakkari tribe, show them the might of the frozen North!',26124),
(71617,'enUS','Gurubashi tribe, send their bloated corpses down the river with ya jungle poisons.','Gurubashi tribe, send their bloated corpses down the river with ya jungle poisons.',26124),
(71618,'enUS','Farraki tribe, flay their flesh wit the fury of the sands!','Farraki tribe, flay their flesh wit the fury of the sands!',26124),
(71619,'enUS','Amani tribe, avenge ye fallen warlords, in the name of Zul\'jin!','Amani tribe, avenge ye fallen warlords, in the name of Zul\'jin!',26124),
(71620,'enUS','Hahaha! Now it be my turn! Ye gonna see what it means to be a War-God!','Hahaha! Now it be my turn! Ye gonna see what it means to be a War-God!',26124),
(71621,'enUS','Ya skull gonna make a fine ornament for my tusks.','Ya skull gonna make a fine ornament for my tusks.',26124),
(71622,'enUS','Da\'kala koraste...Horridon...destroy them...','Da\'kala koraste...Horridon...destroy them...',26124),
(71623,'enUS','Hallo.','',26124),
(71624,'enUS','Did you just say \"hello\"?','Did you just say \"hello\"?',26124),
(71625,'enUS','Nah. I said \"Hallo.\" But that\'s close enough.$b$bBye now.','',26124),
(71626,'enUS','You have time to kill hapless island folk but no time to assemble my glorious body?','',26124),
(71627,'enUS','Enough dilly dallying supplicant! I demand you assemble my body.','',26124),
(71628,'enUS','You call that slaying an opponent? I expected more... fire. Or maybe some lightning.','',26124),
(71629,'enUS','I have seen saurok with more fighting panache than what you have just displayed.','',26124),
(71630,'enUS','Ah! Now that was a proper smiting. There is hope for you yet.','',26124),
(71631,'enUS','Your skills are somewhat impressive. You shall make an excellent slave one day.','',26124),
(71632,'enUS','I survived for hundreds of years during the Thunder King\'s reign. Do you know how? By not keeping my masters waiting!','',26124),
(71633,'enUS','What a pitiful creature. And the thing you just killed.','',26124),
(71634,'enUS','I am ready. Wake the guardians!','I am ready. Wake the guardians!',26124),
(71635,'enUS','Shan Bu shall fall! Are you ready to proceed?','',26124),
(71636,'enUS','I\'m ready to take on Shan Bu!','I\'m ready to take on Shan Bu!',26124),
(71637,'enUS','We are too late! Shan Bu is nearly done resurrecting Nalak, the Storm Lord. That is only incidental, however. Our true objective is to defeat Shan Bu!','',26124),
(71638,'enUS','','It is chaos out there, $p! The siege has begun but our heavy explosives never made it to the wall.',26124),
(71639,'enUS','','I will cover the flanks. Gather up our explosives and get them to the wall. Hurry!',26124),
(71640,'enUS','Zeb\'tula Beastcaller summons raptors to his aid!','Zeb\'tula Beastcaller summons raptors to his aid!',26124),
(71641,'enUS','I have selected a landing site for our forces: a small peninsula to our east that is easily defended.','',26124),
(71642,'enUS','Alas, the Zandalari trolls have already claimed and fortified it.','',26124),
(71643,'enUS','They\'re protecting it with a powerful spirit barrier. We will need to disable it before our ships can land.','',26124),
(71644,'enUS','Champion, I need you to lead a ground assault and take down that barrier from within!','',26124),
(71645,'enUS','Mount up and rendezvous with Scout Captain Elsia. She is organizing an elite group of rangers to accompany you. May the light of the sun shine upon you.','',26124),
(71646,'enUS','','Up here, champion!',26124),
(71647,'enUS','','The Sunreavers have devised a way to ward our flying mounts against the lightning. But fly in loose formation, just in case.',26124),
(71648,'enUS','','Look below! Our continued assaults on the town and crypts have thrown the enemy into disarray. The mogu and the Zandalari already fear the might of the Horde.',26124),
(71649,'enUS','','Do you see the central tower? Lightning strikes it continuously. Aethas suspects that the storms originate from the heart of the palace itself.',26124),
(71650,'enUS','','The other rangers are waiting for us just ahead. Our first priority is - Look out!',26124),
(71651,'enUS','','By the sunwell! The skies betray us - we are not safe up here!',26124),
(71652,'enUS','','Down! Everyone, down!',26124),
(71653,'enUS','','Champion, are you all right?',26124),
(71654,'enUS','','We were not safe at all. They were waiting for us. Our forces are scattered throughout the swamp, and we are alone behind enemy lines!',26124),
(71655,'enUS','','No. Not good.',26124),
(71656,'enUS','','They are pulling back, but we cannot let up now.',26124),
(71657,'enUS','','Our only hope of getting out of here alive is to take the town.',26124),
(71658,'enUS','','The entrance is barricaded. Break it down!',26124),
(71659,'enUS','','I do not like the look of that troll. Be careful!',26124),
(71660,'enUS','','Defeat that creature so we can free our own!',26124),
(71661,'enUS','','They are protecting that mask. It must be the source of the barrier. Destroy it!',26124),
(71662,'enUS','','Destroy the spirit mask to bring down the barrier!',26124),
(71663,'enUS','','He is protecting the mask. Kill him!',26124),
(71664,'enUS','','Do not back down. We are winning this!',26124),
(71665,'enUS','','The shield - it is down! We did it!',26124),
(71666,'enUS','','Champion, without your help I would\'ve died in that swamp. I owe you my very life.',26124),
(71667,'enUS','','Good work, hero. Let\'s move on.',26124),
(71668,'enUS','','You\'re an inspiration.',26124),
(71669,'enUS','','You make this look easy.',26124),
(71670,'enUS','','I like your style, hero.',26124),
(71671,'enUS','','Impressive!',26124),
(71672,'enUS','Victory to the Sin\'dorei! And another triumph for the Horde.','',26124),
(71673,'enUS','Rommath, establish a perimeter. Aethas, begin placing the sentry wards. Kethiel, unload the shelters and supplies.','',26124),
(71674,'enUS','Brothers and sisters of the Horde! Enemies surround us on all sides! Your courage in weeks to come will be the difference between victory and defeat.','',26124),
(71675,'enUS','Champion, you have brought glory to the Horde. Your unshakable will has secured our position here. Now, the true work begins.','',26124),
(71676,'enUS','They come! To arms me brothers - hurl them back to the sea!','',26124),
(71677,'enUS','Hold the ruins. Slay them where they stand!','',26124),
(71678,'enUS','Crush the intruders. The barrier must not fall.','',26124),
(71679,'enUS','Face me now! My will is iron. My people, unbreakable!','',26124),
(71680,'enUS','You are nothing! You are food for my beasts!','',26124),
(71681,'enUS','The spirits will feast on your blood!','',26124),
(71682,'enUS','Spirits give me strength. Break their will...','',26124),
(71683,'enUS','Zandalar...','',26124),
(71684,'enUS','Wake up, kitties. It\'s time to play...','',26124),
(71685,'enUS','Take down the gatekeepers! It will unlock the gates!','',26124),
(71686,'enUS','That takes care of them. Are you ready for me to open the gates?','',26124),
(71687,'enUS','We were too late to stop the resurrection of Nalak, but not to defeat Shan Bu and his forces! Attack!','',26124),
(71688,'enUS','Shan Bu, it is time! Stop hiding behind that magic of yours and fight!','',26124),
(71689,'enUS','Look out! Zandalari are jumping over the walls! Knock those Beastcallers off their mounts!','',26124),
(71690,'enUS','You underestimated us, Shan Bu. We have rid this place of you, and Pandaria is better for it.','',26124),
(71691,'enUS','Hefting','Hefting',26124),
(71692,'enUS','Rise, Nalak. Bring forth your wrath upon those who would sully our master\'s palace!','',26124),
(71693,'enUS','','The explosives!$b$bGood work, $n. Not a moment too soon.',26124),
(71694,'enUS','Here are the explosives, Elsia.','Here are the explosives, Elsia.',26124),
(71695,'enUS','','Hurry, $n!$b$bThere\'s no way we\'ll breach this wall without those explosives!',26124),
(71696,'enUS','','Ugh! Hold on!',26124),
(71697,'enUS','','I\'ve selected a landing site on the island: high ground that\'s easily defended.',26124),
(71698,'enUS','','Unfortunately, the Zandalari trolls have already claimed and fortified it.',26124),
(71699,'enUS','','They\'re protecting it with a powerful spirit barrier. We\'ll need to take it down before we can portal our troops in.',26124),
(71700,'enUS','','Champion, I need you to lead a ground assault and shatter that barrier from within!',26124),
(71701,'enUS','','Mount up and rendezvous with Vereesa Windrunner. She is organizing the forces that will accompany you.',26124),
(71702,'enUS','','Up here, champion!',26124),
(71703,'enUS','','I think we have figured out a way to ward our flying mounts against the lightning. But fly in loose formation, just in case.',26124),
(71704,'enUS','','Our continued incursions into the graveyard and town below are already paying off. Neither the mogu nor the Zandalari should be able to mount a counter-attack.',26124),
(71705,'enUS','','Do you see the central tower? Lightning strikes it continuously. We suspect the storms originate from the heart of the palace itself.',26124),
(71706,'enUS','','The rendezvous is just up ahead. We\'ve gathered an elite strike force - What?',26124),
(71707,'enUS','','Anar\'alah! The skies betray us - we are not safe up here!',26124),
(71708,'enUS','','Down! Everybody down!',26124),
(71709,'enUS','','Champion, are you all right?',26124),
(71710,'enUS','','They were ready for us all along. Our forces are scattered, and we are on our own.',26124),
(71711,'enUS','','So much for the element of surprise.',26124),
(71712,'enUS','','They are falling back! We need to press the assault before they can regroup. Follow me!',26124),
(71713,'enUS','','As I always say - Victory to the bold!',26124),
(71714,'enUS','','The entrance is barricaded. Break it down!',26124),
(71715,'enUS','','Be quick on your feet - that is no ordinary Zandalari!',26124),
(71716,'enUS','','They are protecting that mask. It must be the source of the barrier. Destroy it!',26124),
(71717,'enUS','','Destroy the spirit mask to bring down the barrier!',26124),
(71718,'enUS','','He\'s protecting the mask. Kill him!',26124),
(71719,'enUS','','Keep it up, they are beginning to rout!',26124),
(71720,'enUS','','The shield - it is down! We did it!',26124),
(71721,'enUS','','Jaina was right to recommend you. You saved this mission from disaster... and saved my life.',26124),
(71722,'enUS','','That\'s the Alliance spirit for you - unstoppable!',26124),
(71723,'enUS','','Vereesa, establish a perimeter. Modera, place the sentry wards. Narasi, begin porting in tents and supplies.',26124),
(71724,'enUS','','Everyone take up positions! Enemies surround us on all sides! There is no time to waste.',26124),
(71725,'enUS','','Champion, you have exceeded my expectations. Our position on the isle is secured, thanks to your courage and your will. Now, the true work begins.',26124),
(71726,'enUS','','Good work, hero. Let\'s move on.',26124),
(71727,'enUS','','As much as I expected from a troll.',26124),
(71728,'enUS','','In the name of the Kirin Tor!',26124),
(71729,'enUS','','I like your style, hero.',26124),
(71730,'enUS','','Impressive!',26124),
(71731,'enUS','You have not seen the full might o\' the Zandalari!','',26124),
(71732,'enUS','$n forces Horridon to charge the Farraki door!','$n forces Horridon to charge the Farraki door!',26124),
(71733,'enUS','$n forces Horridon to charge the Gurubashi door!','$n forces Horridon to charge the Gurubashi door!',26124),
(71734,'enUS','$n forces Horridon to charge the Drakkari door!','$n forces Horridon to charge the Drakkari door!',26124),
(71735,'enUS','$n forces Horridon to charge the Amani door!','$n forces Horridon to charge the Amani door!',26124),
(71736,'enUS','The Zandalari Dinomancer drops an Orb of Control!','The Zandalari Dinomancer drops an Orb of Control!',26124),
(71737,'enUS','','The charges are placed. Hero - you may have the honor.',26124),
(71738,'enUS','Did ya think ya could just fly ova\' hea\' unnoticed?!','',26124),
(71739,'enUS','Well, ya got where you were goin\'. Too bad you\'re not gonna live long enough to see it!','',26124),
(71740,'enUS','Prepare to die, intrudah!','',26124),
(71741,'enUS','Horaki readies a Frost Shot!','Horaki readies a Frost Shot!',26124),
(71742,'enUS','Horaki launches a Hail of Arrows into the sky!','Horaki launches a Hail of Arrows into the sky!',26124),
(71743,'enUS','$n calls for food!','',26124),
(71744,'enUS','|TInterface\\Icons\\achievement_moguraid_03:20|t%s is |cFFF00000|Hspell:136442|h[Possessed]|h|r by the spirit of Gara\'jal!','|TInterface\\Icons\\achievement_moguraid_03:20|t%s is |cFFF00000|Hspell:136442|h[Possessed]|h|r by the spirit of Gara\'jal!',26124),
(71745,'enUS','How is a locksmith supposed to make a living in a world with no locked doors?','How is a locksmith supposed to make a living in a world with no locked doors?',26124),
(71746,'enUS','|TInterface\\Icons\\spell_priest_divinestar:20|t%s summons a |cFFF00000|Hspell:137203|h[Blessed Loa Spirit]|h|r!','|TInterface\\Icons\\spell_priest_divinestar:20|t%s summons a |cFFF00000|Hspell:137203|h[Blessed Loa Spirit]|h|r!',26124),
(71747,'enUS','|TInterface\\Icons\\spell_priest_divinestar_shadow2:20|t%s summons a |cFFF00000|Hspell:137350|h[Shadowed Loa Spirit]|h|r!','|TInterface\\Icons\\spell_priest_divinestar_shadow2:20|t%s summons a |cFFF00000|Hspell:137350|h[Shadowed Loa Spirit]|h|r!',26124),
(71748,'enUS','|TInterface\\Icons\\spell_monk_envelopingmist:20|t%s summons a deadly |cFFF00000|Hspell:136894|h[Sandstorm]|h|r!','|TInterface\\Icons\\spell_monk_envelopingmist:20|t%s summons a deadly |cFFF00000|Hspell:136894|h[Sandstorm]|h|r!',26124),
(71749,'enUS','|TInterface\\Icons\\spell_shaman_staticshock:20|t%s |cFFF00000|Hspell:137149|h[Overloads]|h|r!','|TInterface\\Icons\\spell_shaman_staticshock:20|t%s |cFFF00000|Hspell:137149|h[Overload]|h|r!',26124),
(71750,'enUS','|TInterface\\Icons\\spell_shaman_staticshock:20|t%s begins to |cFFF00000|Hspell:137166|h[Discharge]|h|r!','|TInterface\\Icons\\spell_shaman_staticshock:20|t%s begins to |cFFF00000|Hspell:137166|h[Discharge]|h|r!',26124),
(71751,'enUS','|TInterface\\Icons\\ability_deathknight_remorselesswinters2:20|tMove away from your allies! You are afflicted with |cFFF00000|Hspell:136991|h[Biting Cold]|h|r!','|TInterface\\Icons\\ability_deathknight_remorselesswinters2:20|tMove away from your allies! You are afflicted with |cFFF00000|Hspell:136991|h[Biting Cold]|h|r!',26124),
(71752,'enUS','|TInterface\\Icons\\spell_mage_frostbomb:20|t$n is afflicted with |cFFF00000|Hspell:136922|h[Frostbite]|h|r!','|TInterface\\Icons\\spell_mage_frostbomb:20|t$n is afflicted with |cFFF00000|Hspell:136922|h[Frostbite]|h|r!',26124),
(71753,'enUS','I am ready to launch the assault [Queue for solo instance.]','I am ready to launch the assault [Queue for solo instance.]',26124),
(71754,'enUS','','Good, you are here.',26124),
(71755,'enUS','','Regent Lord! Everyone is in position, and the Shado-Pan are inside, but...',26124),
(71756,'enUS','','The Alliance is waiting for us just across the courtyard.',26124),
(71757,'enUS','Yes?','',26124),
(71758,'enUS','Ahhh, so the grand lady of the Kirin Tor wants a fight, does she?','',26124),
(71759,'enUS','Rangers! Advance!','',26124),
(71760,'enUS','I will deal with Proudmoore.','',26124),
(71761,'enUS','|TInterface\\Icons\\spell_nature_unrelentingstorm.blp:20|t The |cFFFF0000|Hspell:135680|h[North Conduit]|h|r has burned out and caused |cFFFF0000|Hspell:137176|h[Overloaded Circuits]|h|r!','',26124),
(71762,'enUS','|TInterface\\Icons\\spell_nature_unrelentingstorm.blp:20|t The |cFFFF0000|Hspell:135681|h[East Conduit]|h|r has burned out and caused |cFFFF0000|Hspell:137176|h[Overloaded Circuits]|h|r!','',26124),
(71763,'enUS','|TInterface\\Icons\\spell_nature_unrelentingstorm.blp:20|t The |cFFFF0000|Hspell:135682|h[South Conduit]|h|r has burned out and caused |cFFFF0000|Hspell:137176|h[Overloaded Circuits]|h|r!','',26124),
(71764,'enUS','|TInterface\\Icons\\spell_nature_unrelentingstorm.blp:20|t The |cFFFF0000|Hspell:135683|h[West Conduit]|h|r has burned out and caused |cFFFF0000|Hspell:137176|h[Overloaded Circuits]|h|r!','',26124),
(71765,'enUS','One problem at a time, people. Focus on the Zandalari!','',26124),
(71766,'enUS','YOU will kneel when you beg for my mercy, monster.','',26124),
(71767,'enUS','Taran Zhu! It does not matter how many you array against the Thunder King. Soon all will kneel before him.','',26124),
(71768,'enUS','Those statues wield the power of the first emperor. Destroy them!','',26124),
(71769,'enUS','Taoshi, get those doors open.','',26124),
(71770,'enUS','Champion, with me. We must press forward while your comrades cover the rear.','',26124),
(71771,'enUS','','The Thunder King\'s palace lies ahead. We must secure a foothold on the island before we can assault his fortress.',26124),
(71772,'enUS','','Regent Lord - more Zandalari approach from the mines!',26124),
(71773,'enUS','Damn their hides. Rangers! Hold this position!','',26124),
(71774,'enUS','Who needs a God? We have the Thunder King!','',26124),
(71775,'enUS','Trolls - make yourselves useful. I am almost finished here.','',26124),
(71776,'enUS','Shan Bu! Again you try to create a God. When will you learn?','',26124),
(71777,'enUS','Zandalari reinforcements are coming.','',26124),
(71778,'enUS','Yalia - we need more healing! Taoshi - cover the rear!','',26124),
(71779,'enUS','Face me, Shan Bu! Or is the court of the Thunder King a den of cowards?','',26124),
(71780,'enUS','Arise, Nalak! Protect our beloved emperor.','',26124),
(71781,'enUS','The emperor will be most pleased when I present him with your head, Shado-Pan.','',26124),
(71782,'enUS','The unworthy have not yet learned of my power.','',26124),
(71783,'enUS','War-God Al\'chukla, add my strength to your own.','',26124),
(71784,'enUS','','The priests imbue the guardian with their Loas! They must be stopped!',26124),
(71785,'enUS','','You must hurry!',26124),
(71786,'enUS','','The guardian\'s power grows! Kill them before it\'s too late!',26124),
(71787,'enUS','','The guardian has awoken! Destroy it!',26124),
(71788,'enUS','','You have robbed it of its strength. Now rob it of its life!',26124),
(71789,'enUS','The battle begins in 2 minutes!','',26124),
(71790,'enUS','The battle begins in 1 minute!','',26124),
(71791,'enUS','The battle begins in 30 seconds!','',26124),
(71792,'enUS','The battle has begun!','',26124),
(71793,'enUS','','The priests imbue the guardian with their Loas! They must be stopped!',26124),
(71794,'enUS','','The guardian\'s power grows! Kill them before it\'s too late!',26124),
(71795,'enUS','','You must hurry!',26124),
(71796,'enUS','','The guardian has awoken! Destroy it!',26124),
(71797,'enUS','','You have robbed it of its strength. Now rob it of its life!',26124),
(71798,'enUS','Make a demonstration of these invaders, such that all nations tremble before me.','',26124),
(71799,'enUS','All will fall before us!!','',26124),
(71800,'enUS','Shan Bu, secure the inner courtyard. None should look upon my works and live.','',26124),
(71801,'enUS','As my emperor wills!','',26124),
(71802,'enUS','This island is home to a very powerful magic. If we can harness it, no one will be able to stand in our way.','',26124),
(71803,'enUS','The Zandalari here practice a dark magic I am unfamiliar with. They mix arcane powers with shadow; a frightening and dangerous combination.','',26124),
(71804,'enUS','The magic emanating from this area is fascinating, $c. I\'m anxious to study their artifacts. There is so much we can learn.','',26124),
(71805,'enUS','Have you seen the golems that wander these paths, $c? Spirits bound to servitude of the Zandalari for all of eternity.$b$bPerhaps, the Mogu and the Zandalari are more alike than we ever anticipated.','',26124),
(71806,'enUS','A Restless Spirit is after your soul.  Don\'t let it reach you!','',26124),
(71807,'enUS','A Draining Spirit is draining your soul. Hide from it to break the spell!','',26124),
(71808,'enUS','','Ah! Hero, we were just talking about you.',26124),
(71809,'enUS','It does not matter. Taoshi\'s proposal is too dangerous.','',26124),
(71810,'enUS','','If we are to bring down the Thunder King, we must breech the shipyard. Now is the time for bold ideas!',26124),
(71811,'enUS','','Champion, hear me out: We strike the shipyard at night, using this magnificent beast you have tamed.',26124),
(71812,'enUS','','Once inside, we sabotage the Zandalari ship. In the chaos, we will slip into the courtyard and open the gates from within.',26124),
(71813,'enUS','','I love it! Brains over brute force.',26124),
(71814,'enUS','Very well, Taoshi. If our champion here agrees, the mission may proceed.','',26124),
(71815,'enUS','','Thank you, Lord Zhu. I will not let you down.',26124),
(71816,'enUS','','Speak with me when you are ready.',26124),
(71817,'enUS','Ah! Champion, we were just talking about you.','',26124),
(71818,'enUS','The sheer audacity of the plan is exactly what intrigues me. If we breech the shipyard, we will deprive the mogu of further Zandalari reinforcements.','',26124),
(71819,'enUS','You\'ve been afflicted by Spirit\'s Wrath.  Run away!','',26124),
(71820,'enUS','Surely you agree that decisive action wins wars, Lord Zhu.','',26124),
(71821,'enUS','','I count six... no, seven guards on patrol in the sky.',26124),
(71822,'enUS','','One of them flies higher than the others... He loops far out over the water - alone. He is over-extending. That is our in.',26124),
(71823,'enUS','','We will neutralize him and take his route. Let\'s go!',26124),
(71824,'enUS','','Just a little closer...',26124),
(71825,'enUS','','Hyah!',26124),
(71826,'enUS','','The Zandalari are more cautious than I thought. Look down there - swarming with patrols.',26124),
(71827,'enUS','','Those archers are keeping a close watch over the shipping area.',26124),
(71828,'enUS','','And their shamans have laid out a network of sentry totems.',26124),
(71829,'enUS','','Here: Use these darts to take down as many archers as you can.',26124),
(71830,'enUS','','One of these smoke bombs will blind a sentry totem.',26124),
(71831,'enUS','','We cannot circle up here for long. Do what you can while I plan our next move.',26124),
(71832,'enUS','','We have got to disable more of their defenses or we will never be able to get in! Loop around again.',26124),
(71833,'enUS','Awaken, Hu\'seng! The docks are your responsibility. See that none pass his majesty\'s gates.','',26124),
(71834,'enUS','The Thunder King wills it; it shall be done.','',26124),
(71835,'enUS','','Our time is up. We need to get aboard that ship.',26124),
(71836,'enUS','','We should sabotage the siege weapons toward the bow. Then we will go below decks and find the captain.',26124),
(71837,'enUS','','Easy now... Get in close and incapacitate them.',26124),
(71838,'enUS','','I will take the ugly one.',26124),
(71839,'enUS','','Not as quiet as I would prefer, but it works.',26124),
(71840,'enUS','','There will be a very unpleasant surprise waiting for the next troll who disturbs these. Let\'s keep moving.',26124),
(71841,'enUS','%s snores peacefully.','',26124),
(71842,'enUS','Hm-wha? Stowaways!','',26124),
(71843,'enUS','If this be the caliber of pandaren to resist us, this land be ours in no time!','',26124),
(71844,'enUS','Oh hoh, you tickle me. But I be done playin\' with you.','',26124),
(71845,'enUS','I am UNSINKABLE!','',26124),
(71846,'enUS','You... never get outta here... alive.','',26124),
(71847,'enUS','','The courtyard gate is directly up that hill.',26124),
(71848,'enUS','','Remember to stay clear of those sentry totems.',26124),
(71849,'enUS','','Let\'s move.',26124),
(71850,'enUS','','Wait for it...',26124),
(71851,'enUS','','Go!',26124),
(71852,'enUS','','Sounds like they found our little present.',26124),
(71853,'enUS','','Here! Into the smoke!',26124),
(71854,'enUS','Enough hiding, little ones!','',26124),
(71855,'enUS','There is no escape now. The only way out is through me!','',26124),
(71856,'enUS','','Through you, is it? I think we can manage that.',26124),
(71857,'enUS','','Would you prefer we go through the belly, or the ribcage?',26124),
(71858,'enUS','These gates are sealed by imperial decree.','',26124),
(71859,'enUS','You, pandaren! You will be back in chains where you belong.','',26124),
(71860,'enUS','Your little friend is disposable.','',26124),
(71861,'enUS','Trespassers will be executed!','',26124),
(71862,'enUS','Keep. OUT!','',26124),
(71863,'enUS','You are finished!','',26124),
(71864,'enUS','To strike me is to strike his Majesty! He will not suffer this insult!','',26124),
(71865,'enUS','None... shall...','',26124),
(71866,'enUS','','Well fought! Now - the gates. Before the thunder king\'s entire army comes down on us!',26124),
(71867,'enUS','','Rangers - shatter the hinges. Wedge the doors open!',26124),
(71868,'enUS','','Your plan worked! The two of you accomplished the work of an army.',26124),
(71869,'enUS','','The fighting skills of my companion are quickly becoming legendary among the Shado-Pan.',26124),
(71870,'enUS','','Indeed. We must get you two back to safety. Thanks to you, the Thunder King is now completely under siege.',26124),
(71871,'enUS','','Rangers - shatter the hinges. Wedge the doors open!',26124),
(71872,'enUS','','Your plan worked! The two of you accomplished the work of an army.',26124),
(71873,'enUS','','The Regent Lord will want a full report. Let\'s get you back to camp - you have earned a rest.',26124),
(71874,'enUS','','Would you believe I was laughed at when I began researching magic that would mask one\'s scent? It was deemed as impractical and a waste of time by the Arch-magi.$b$bWell, who is standing upwind of a devilsaur and laughing now? Ha!',26124),
(71875,'enUS','','It is a shame I am only able to mask our own smells and not the foul odors pouring out of the Zandalari and their beasts.',26124),
(71876,'enUS','','I never was very fond of field work. Especially when it involves vast quantities of trolls.',26124),
(71877,'enUS','Keep moving! Avoid the Storm-Lord\'s lightning!','',26124),
(71878,'enUS','Stay close to Yalia\'s healing, champion!','',26124),
(71879,'enUS','Dance around Shan Bu\'s attacks. We are faster! We are smarter!','',26124),
(71880,'enUS','Stay near Yalia so that she may heal you!','',26124),
(71881,'enUS','Your cries of pain delight his majesty!','',26124),
(71882,'enUS','Ours is to rule. Yours is to serve!','',26124),
(71883,'enUS','You are weak. You Shado-Pan scurry through shadows like roaches.','',26124),
(71884,'enUS','','%s begins to heal her sister!',26124),
(71885,'enUS','I tire of your insolence! I will choke the life from you, impudent slave!','',26124),
(71886,'enUS','Auugh - kill him. Quickly!','',26124),
(71887,'enUS','Finish him!','',26124),
(71888,'enUS','An Essence of Storms erupts from the embedded spear and fixates on you!','An Essence of Storms erupts from the embedded spear and fixates on you!',26124),
(71889,'enUS','I ... no... My emperor! My emperor, I have failed you!','',26124),
(71890,'enUS','The storm will consume you!','',26124),
(71891,'enUS','Lord of thunder... protect me!','',26124),
(71892,'enUS','|TInterface\\Icons\\ability_warlock_jinx:20|t%s begins to cast |cFFF00000|Hspell:137891|h[Twisted Fate]|h|r!','|TInterface\\Icons\\ability_warlock_jinx:20|t%s begins to cast |cFFF00000|Hspell:137891|h[Twisted Fate]|h|r!',26124),
(71893,'enUS','','The shadows will be our allies.',26124),
(71894,'enUS','Queue for A Dagger in the Dark.','Queue for A Dagger in the Dark.',26124),
(71895,'enUS','The Zandalari are a proud race. Their pride will ultimately be their undoing.$b$bEven the most powerful of foes have a weakness; we need only to find it.','',26124),
(71896,'enUS','And thus... the spark of life... fades...','',26124),
(71897,'enUS','BLOOD! DELICIOUS! You shall feed me!','',26124),
(71898,'enUS','Even your own blood can be made to serve!','',26124),
(71899,'enUS','No! My blood, it... spills...','',26124),
(71900,'enUS','Champion! Our campaign is reaching a climax: We are at the very threshold of the Thunder King\'s palace. It is time to knock down his front door.','',26124),
(71901,'enUS','Speak to me when you are ready to launch the assault!','',26124),
(71902,'enUS','','Your timing is perfect as always, hero. It is time to kick down the Thunder King\'s front door.',26124),
(71903,'enUS','','Speak to me when you are ready to launch the assault!',26124),
(71904,'enUS','','Good, you are here.',26124),
(71905,'enUS','','Lady Proudmoore! Everyone is in position, and the Shado-Pan are inside, but...',26124),
(71906,'enUS','','But what?',26124),
(71907,'enUS','','The Horde is just across the courtyard.',26124),
(71908,'enUS','','Of course they are. One problem at a time, Vereesa.',26124),
(71909,'enUS','','Everyone! Advance!',26124),
(71910,'enUS','','... and if anyone sees that traitor, Aethas Sunreaver, save that one for me...',26124),
(71911,'enUS','','Ignore the Horde - focus on the Zandalari guarding the door!',26124),
(71912,'enUS','','Lady Proudmoore - more Zandalari are approaching from the docks.',26124),
(71913,'enUS','','They\'re trying to flank us. Hold this position!',26124),
(71914,'enUS','Look out, he is coming your way!','',26124),
(71915,'enUS','Don\'t let him get close to you!','',26124),
(71916,'enUS','Be careful - he is coming for you!','',26124),
(71917,'enUS','Your \"Alliance\" is all flash, no strength whatsoever.','',26124),
(71918,'enUS','Your \"Horde\" is a disgusting pack of animals, hardly worth enslaving.','',26124),
(71919,'enUS','You see? No power of this world can trample the pure of spirit.','',26124),
(71920,'enUS','','Lord Zhu! The Alliance - the Horde - all chaos is about to erupt out here!',26124),
(71921,'enUS','Like children.','',26124),
(71922,'enUS','Taoshi! Hand me my weapon.','',26124),
(71923,'enUS','','My Lord... you are gravely wounded!',26124),
(71924,'enUS','My weapon! Champion, with me. I want you to see this.','',26124),
(71925,'enUS','','Hand over the Archmage and I may yet allow you to walk out of here, Lor\'themar.',26124),
(71926,'enUS','Proudmoore! You will release my people from the Violet Hold, or I will cut you down myself!','',26124),
(71927,'enUS','','Your people are legitimate prisoners of war. They orchestrated an attack on Darnassus from MY city-',26124),
(71928,'enUS','The Sunreavers knew NOTHING of Garrosh\'s raid on Darnassus!','',26124),
(71929,'enUS','Aethas Sunreaver shifts uncomfortably.','',26124),
(71930,'enUS','ENOUGH!! There will be no more bloodshed today.','',26124),
(71931,'enUS','I see now why your Alliance and your Horde cannot stop fighting.','',26124),
(71932,'enUS','Every reprisal is itself an act of aggression, and every act of aggression triggers immediate reprisal.','',26124),
(71933,'enUS','','They have undermined EVERY attempt at peace!',26124),
(71934,'enUS','I must protect my sovereign people.','',26124),
(71935,'enUS','SILENCE! YOU must break the cycle.','',26124),
(71936,'enUS','It ends TODAY. Here. The cycle ends when you, Regent Lord, and you, Lady Proudmoore, turn from one another. And walk. Away.','',26124),
(71937,'enUS','','Jaina takes a deep breath.',26124),
(71938,'enUS','Lor\'themar narrows his eyes.','',26124),
(71939,'enUS','Rangers. Lower your weapons.','',26124),
(71940,'enUS','','My Lord!',26124),
(71941,'enUS','Do it.','',26124),
(71942,'enUS','','Very well. We will stand down.',26124),
(71943,'enUS','','They killed my husband!',26124),
(71944,'enUS','','This won\'t bring him back.',26124),
(71945,'enUS','','But know this, \"Blood\" Elf: There can be no peace while Hellscream is Warchief of the Horde.',26124),
(71946,'enUS','That is precisely why I wish to conserve our strength today.','',26124),
(71947,'enUS','','Jaina\'s expression softens.',26124),
(71948,'enUS','','Lord.',26124),
(71949,'enUS','Lady.','',26124),
(71950,'enUS','Gather the wounded. Withdraw to the harbor.','',26124),
(71951,'enUS','','Everyone, regroup back at the camp. Our work here is done.',26124),
(71952,'enUS','','Lord Zhu!',26124),
(71953,'enUS','Champion, this cease-fire may not last, but remember what you have seen today.','',26124),
(71954,'enUS','','We must get you back to the monastery.',26124),
(71955,'enUS','Shan Bu\'s monstrosity remains at the foot of the palace. It must be stopped before it wreaks havoc across Pandaria.','',26124),
(71956,'enUS','','Yalia, take Lord Zhu to safety.',26124),
(71957,'enUS','','Hero, it will be up to you to defeat the Storm Lord Nalak. You will have to marshal a small army!',26124),
(71958,'enUS','','But after what I have seen today, I have faith in you.',26124),
(71959,'enUS','','It has been a great honor to fight by your side. Thank you.',26124),
(71960,'enUS','','You\'ve earned my trust hero. Simply place my staff on the Thunder King\'s dais and it will do the rest. You are very brave to take this mission on; good luck!',26124),
(71961,'enUS','','You did it! Incredible! Pandaren Lorewalkers will be telling your story for generations!',26124),
(71962,'enUS','','I can feel it ... the Thunder King\'s power courses through my staff.',26124),
(71963,'enUS','','Best of all, you\'ve forever disabled his infernal machine, leaving nothing for the Horde to claim as their own.',26124),
(71964,'enUS','','When the time is right, I\'ll use this staff to bring the walls of Orgrimmar crashing down around Garrosh Hellscream\'s head.',26124),
(71965,'enUS','','Thank you, friend. The Alliance is lucky to have you.',26124),
(71966,'enUS','You have earned my trust hero. This will be your most dangerous task yet: To steal the secrets of the Thunder King from the very heart of his lair. I wish you the best of luck.','',26124),
(71967,'enUS','What have you brought back? Ah! Fascinating.','',26124),
(71968,'enUS','Blood as a power source - a very powerful form of life magic. The work of the titans, perhaps? How does it work?','',26124),
(71969,'enUS','Aethas, I want our best archmages studying this device at once. We have so much to learn.','',26124),
(71970,'enUS','Thank you, champion! The Horde may be on the verge of crisis, but your actions on these shores have ensured our continued survival and prosperity no matter what comes next.','',26124),
(71971,'enUS','You have our deepest gratitude. Al diel shala, hero.','',26124),
(71972,'enUS','Weak.','',26124),
(71973,'enUS','So easy to break.','',26124),
(71974,'enUS','How you beat me?','',26124),
(71975,'enUS','Bored.  You die now.','',26124),
(71976,'enUS','Da Thunder King give me power! Come, I show you!','',26124),
(71977,'enUS','I must break you.','',26124),
(71978,'enUS','Smash!','',26124),
(71979,'enUS','Crush your bones!','',26124),
(71980,'enUS','I call da storm!','',26124),
(71981,'enUS','Zap!','',26124),
(71982,'enUS','|TInterface\\Icons\\ability_vehicle_electrocharge:20|t%s\'s |cFFFF0000|Hspell:137422|h[Focused Lightning]|h|r fixates on you. Run!','',26124),
(71983,'enUS','The eggs in one of the lower nests begin to hatch!','',26124),
(71984,'enUS','Use Displacement Pad.','Use Displacement Pad.',26124),
(71985,'enUS','%s prepares to unleash a |cFFFF0000|Hspell:133939|h[Furious Stone Breath]|h|r!','',26124),
(71988,'enUS','The eggs in one of the lower nests begin to hatch!','',26124),
(71989,'enUS','The eggs in one of the lower nests begin to hatch!','',26124),
(71990,'enUS','The eggs in one of the lower nests begin to hatch!','',26124),
(71991,'enUS','The eggs in one of the lower nests begin to hatch!','',26124),
(71992,'enUS','The eggs in one of the upper nests begin to hatch!','',26124),
(71993,'enUS','The eggs in one of the upper nests begin to hatch!','',26124),
(71994,'enUS','The eggs in one of the upper nests begin to hatch!','',26124),
(71995,'enUS','The eggs in one of the upper nests begin to hatch!','',26124),
(71996,'enUS','The eggs in one of the upper nests begin to hatch!','',26124),
(71999,'enUS','Use the Cloud Tiles to dispel Mantle of the Thunder King!','',26124),
(72000,'enUS','','A new land overrun by evil horrors of this world. A new place for us to save.',26124),
(72001,'enUS','Some laugh at my concern for beasts. I scoff at their lack of compassion.','',26124),
(72002,'enUS','There is much we can learn from these Zandalari, largely by doing what they do not.','',26124),
(72003,'enUS','Da Amani empire cannot be stopped!','',26124),
(72004,'enUS','Da thunder king... promised...','',26124),
(72005,'enUS','Ya shouldn\'t be messin\' wit da Zandalari!','',26124),
(72006,'enUS','On ya knees!','',26124),
(72007,'enUS','Out da way!','',26124),
(72008,'enUS','Incoming!','',26124),
(72009,'enUS','Lei Shen give us strength!','',26124),
(72010,'enUS','Da Thunder King shows us da way!','',26124),
(72011,'enUS','Shocking!','',26124),
(72012,'enUS','Ya spirit is mine!','',26124),
(72013,'enUS','De Thunder King will reward us for stoppin\' ya!','',26124),
(72014,'enUS','Witness de power of de spiritbinder!','',26124),
(72015,'enUS','Time ta die!','',26124),
(72016,'enUS','Da Zandalari cannot be stopped!','',26124),
(72017,'enUS','Wit de Thunder King\'s power de Zandalari will be reborn!','',26124),
(72018,'enUS','Lei Shen\'s power makes us stronger!','',26124),
(72019,'enUS','Yer soul will pay da price!','',26124),
(72020,'enUS','Des fools thought they beat me once before. Dey only make me stronger. Now we show dem da true power of the Zandalari!','',26124),
(72021,'enUS','Lei Shen let us prove ta ya the might of the Zandalari. We will crush des intruders where dey stand!','',26124),
(72022,'enUS','We will never fail ya!','',26124),
(72023,'enUS','Da\' Drakkari will never fall to de\' likes of you!','',26124),
(72024,'enUS','Ya have met your match, fools!','',26124),
(72025,'enUS','Da... empire... can\'t... fall...','',26124),
(72026,'enUS','Death\'s cold embrace.','',26124),
(72027,'enUS','Witness da Drakkari\'s might.','',26124),
(72028,'enUS','Getting cold?','',26124),
(72029,'enUS','Freeze!','',26124),
(72030,'enUS','Winter is coming...','',26124),
(72031,'enUS','','Shadra\'s rage will destroy you!',26124),
(72032,'enUS','','Death ta all who appose da empire!',26124),
(72033,'enUS','','Shadra... save... me...',26124),
(72034,'enUS','','Another offering to da loa!',26124),
(72035,'enUS','','She will feast on yer soul!',26124),
(72036,'enUS','','Succumb ta her venom!',26124),
(72037,'enUS','','Yer soul belongs ta me!',26124),
(72038,'enUS','','Da spiritbinder reveals yer soul ta me!',26124),
(72039,'enUS','','Embrace yer demise!',26124),
(72040,'enUS','Dey tink dey can stop da Farraki?','',26124),
(72041,'enUS','Da sands will consume everyting!','',26124),
(72042,'enUS','I return... to... da... sands...','',26124),
(72043,'enUS','Da sands are endless.','',26124),
(72044,'enUS','Da first of many!','',26124),
(72045,'enUS','Watch yer step!','',26124),
(72046,'enUS','Da storm approaches!','',26124),
(72047,'enUS','Lei Shen gives life!','',26124),
(72048,'enUS','I will bury ya all!','',26124),
(72049,'enUS','These insects do not know their place, Gara\'jal. If you wish to prove your \"might\" on such weaklings, it matters not to me.','',26124),
(72050,'enUS','The orb swirls malevolently...','',26124),
(72051,'enUS','The orb explodes!','',26124),
(72052,'enUS','My Lord.','',26124),
(72053,'enUS','Recovering','Recovering',26124),
(72054,'enUS','','Well now. You sure know how to arrive in style.',26124),
(72055,'enUS','','This way. The doors can only be opened from within.',26124),
(72056,'enUS','','We can slip through here quietly, or fight our way through. It is your decision.',26124),
(72057,'enUS','','The mogu forge weapons of both blood and steel. Their blades feast on death.',26124),
(72058,'enUS','','Slaves - everywhere slaves. You can see what we fight against.',26124),
(72059,'enUS','','The Shado-Pan strike from the shadows, so that our enemies fear the dark.',26124),
(72060,'enUS','','I have seen many things. But the cruelty of the mogu still curdles my blood.',26124),
(72061,'enUS','','We are in the heart of the mogu war machine.',26124),
(72062,'enUS','','I have trained my entire life for this.',26124),
(72063,'enUS','','They will learn that no place is safe from the Shado-Pan.',26124),
(72064,'enUS','','I prefer a swift, silent kill. But your methods have their advantages.',26124),
(72065,'enUS','','Your skills in combat are most impressive.',26124),
(72066,'enUS','','The Shado-Pan will never rest.',26124),
(72067,'enUS','','Step lightly! We are almost to the gate.',26124),
(72068,'enUS','','There - the slave master! Hold his attention while I undo the lock.',26124),
(72069,'enUS','','This lock... it is more complicated than I thought...',26124),
(72070,'enUS','','Keep him busy! I am almost finished!',26124),
(72071,'enUS','','I have it! The gates are undone!',26124),
(72072,'enUS','Farraki forces pour from the Farraki Tribal Door!','Farraki forces pour from the Farraki Tribal Door!',26124),
(72073,'enUS','Gurubashi forces pour from the Gurubashi Tribal Door!','Gurubashi forces pour from the Gurubashi Tribal Door!',26124),
(72074,'enUS','Drakkari forces pour from the Drakkari Tribal Door!','Drakkari forces pour from the Drakkari Tribal Door!',26124),
(72075,'enUS','Amani forces pour from the Amani Tribal Door!','Amani forces pour from the Amani Tribal Door!',26124),
(72076,'enUS','The ghost fades away into the mist...','',26124),
(72077,'enUS','Return as my master.','',26124),
(72078,'enUS','I am your master.','I am your master.',26124),
(72079,'enUS','Close... enough.','',26124),
(72080,'enUS','You look nothing like him.','',26124),
(72081,'enUS','No! No no no! Put those down.','',26124),
(72082,'enUS','Why are you still standing there? Deliver those boxes!','',26124),
(72083,'enUS','This is not a construct break. Get back to work.','',26124),
(72084,'enUS','Do you even know how to walk? Move those legs of yours you worthless golden scrap heap!','',26124),
(72085,'enUS','Where are the barrels? Did you lose the barrels? We need more barrels!','',26124),
(72086,'enUS','If you drop one more crate I swear I am sending you off to be disenchanted.','',26124),
(72087,'enUS','How could you lose another one? I swear, there are gems in my shoes that have more intelligence than you.','',26124),
(72088,'enUS','CARRIER HAS ARRIVED.','',26124),
(72089,'enUS','In theory, these crystals are natural insulators. They should absorb most of the lightning strikes in the area.','In theory, these crystals are natural insulators. They should absorb most of the lightning strikes in the area.',26124),
(72090,'enUS','Do the instructions clarify how much mana these crystals will require? I do not want to get converted to a wretched by using this thing.','Do the instructions clarify how much mana these crystals will require? I do not want to get converted to a wretched by using this thing.',26124),
(72091,'enUS','I think the crystal on the left is defective. We should never have rushed their construction. This is how accidents happen.','I think the crystal on the left is defective. We should never have rushed their construction. This is how accidents happen.',26124),
(72092,'enUS','Why is it everywhere on this island I go my hair always feels like it is standing on end?','Why is it everywhere on this island I go my hair always feels like it is standing on end?',26124),
(72093,'enUS','It is days like this I miss using fel magic. Sure it was evil, but it got the job done.','It is days like this I miss using fel magic. Sure it was evil, but it got the job done.',26124),
(72094,'enUS','Are these going to be enough to take out those pterrorwings?','Are these going to be enough to take out those pterrorwings?',26124),
(72095,'enUS','Someone told me these crystals are blue in their natural state. I am so glad someone took the time to apply some proper aesthetics.','Someone told me these crystals are blue in their natural state. I am so glad someone took the time to apply some proper aesthetics.',26124),
(72096,'enUS','It is said the God King Rastakhan, ruler of the Zandalari, lords over his mighty kingdom from a throne carved of solid gold.','',26124),
(72097,'enUS','Years ago, as he sat on this opulent seat of power, he was visited by his most trusted prophet: Zul.','',26124),
(72098,'enUS','Zul warned King Rastakhan of a terrible Cataclysm. For Zul had seen a vision of a great armored dragon clenching the world in his ferocious jaws.','',26124),
(72099,'enUS','King Rastakhan did nothing.','',26124),
(72100,'enUS','Months later Zul returned, bearing more grim news from his visions. He saw a legion of serpents pouring forth from a gaping fissure that tore open the floor of the ocean.','',26124),
(72101,'enUS','Still, King Rastakhan did nothing.','',26124),
(72102,'enUS','Finally, mere months before the Cataclysm, Zul returned. Tearing his clothes and throwing his staff to the ground, Zul spoke of earthquakes and tidal waves.','',26124),
(72103,'enUS','He described the golden capital of Zandalar slowly sinking beneath the waves in the aftermath of the Cataclysm, its once-great people drowning as their mighty works slipped forever beneath the sea.','',26124),
(72104,'enUS','King Rastakhan tired of Zul and his troubling nightmares. To be rid of the prophet, he granted Zul the use of his largest ships, so that he and his followers could seek a new land if his visions came to pass.','',26124),
(72105,'enUS','And his visions DID come to pass.','',26124),
(72106,'enUS','When Deathwing rose from the Maelstrom, dark, angry waves crashed into the Zandalari capital. The spine of the land broke in two, and soon, the city and all its riches began to slide into the hungry sea.','',26124),
(72107,'enUS','The Zandalari people turned to their King for help, but there was only one Zandalari equipped to help them: The prophet Zul. The prophet, and the mighty warfleet he had assembled while his King sat idle.','',26124),
(72108,'enUS','You see, the TRUE power of kings and emperors stems from the power to aid their people.','',26124),
(72109,'enUS','The moment they fail, they cede their power to the one who can.','',26124),
(72110,'enUS','The mogu tell a legend about Lei Shen, the Thunder King.','',26124),
(72111,'enUS','His followers fell to their knees before him. \"We will call you \'The Lightning King,\'\" they said.','',26124),
(72112,'enUS','It is said that he tore out the very heart of the mogu God. And from that hateful act he gained power over wind and storm.','',26124),
(72113,'enUS','But Lei Shen did not agree.','',26124),
(72114,'enUS','\"Lightning strikes in an instant and is over in a flash,\" he said.','',26124),
(72115,'enUS','\"But thunder. Thunder! Thunder proclaims the coming of the storm.\"','',26124),
(72116,'enUS','\"Thunder quakes the skies long before the lightning strikes, and thunder echoes in the hills long after lightning\'s power is spent.\"','',26124),
(72117,'enUS','\"It is thunder that sends animals cowering and fills the hearts of peasants with dread. Let thunder be my herald, so that my power is felt throughout the land.\"','',26124),
(72118,'enUS','\"I will be... The Thunder King.\"','',26124),
(72119,'enUS','Oh my friend - that awful sound. For a hundred hundred generations the crash of thunder filled the hearts of pandaren with terror.','',26124),
(72120,'enUS','It is said that after the revolution, the Red Crane of Hope placed the rainbow in the sky, so that pandaren would know not to fear the storms any longer.','',26124),
(72121,'enUS','I do not see any rainbows today. Do you?','',26124),
(72122,'enUS','Fathers and sons. Mothers and daughters. As parents, we pass our legacy on to our children.','',26124),
(72123,'enUS','What values do we choose to instill in our progeny?','',26124),
(72124,'enUS','What will our children learn from our mistakes?','',26124),
(72125,'enUS','What sort of world will we create and leave behind for our daughters and sons?','',26124),
(72126,'enUS','Parents place their children on a path, but they do not always know where the road will take them.','',26124),
(72127,'enUS','The mogu were children as well. Children of the titans. They were once a legion of stone, heartless and obedient.','',26124),
(72128,'enUS','By the titans\' command, they fought the terrible servants of the old gods. They shaped the mountains and carved the rivers of the land.','',26124),
(72129,'enUS','And they created a magical cradle of life in a hidden valley that we now call the Vale of Eternal Blossoms.','',26124),
(72130,'enUS','But eventually the titans fell silent. And their creations were cursed with flesh.','',26124),
(72131,'enUS','The mogu grew restless. Many generations later, when Thunder King united them, they seized upon their legacy!','',26124),
(72132,'enUS','I truly believe now that the mogu thought they were doing the work of the titans. They fought against the mantid and used the powers of the Vale to create new life.','',26124),
(72133,'enUS','Ah, but such terrible works!','',26124),
(72134,'enUS','Parents cannot always be assured of the legacy they will leave behind.','',26124),
(72135,'enUS','How especially true this is, when the parents are gods. And their children - monsters.','',26124),
(72136,'enUS','All I be needin\' is your heart.','',26124),
(72137,'enUS','Give in, I make it quick.','',26124),
(72138,'enUS','Anotha sacrifice, bruddas!','',26124),
(72139,'enUS','I love to spill dis one\'s blood.','',26124),
(72140,'enUS','I hear ya blood flow.','',26124),
(72141,'enUS','Come to me aid, pets.','',26124),
(72142,'enUS','Dinner be here!','',26124),
(72143,'enUS','You be good eatin\' for me pets.','',26124),
(72144,'enUS','Sometimes dey start eatin\' before you dead.','',26124),
(72145,'enUS','Me pets have a big feast, brudda.','',26124),
(72146,'enUS','You weak, friend.','',26124),
(72147,'enUS','Dis was a mistake fo\' you.','',26124),
(72148,'enUS','Anotha fool come to die.','',26124),
(72149,'enUS','Dis one too brave.','',26124),
(72150,'enUS','Dis one\'s death be fun.','',26124),
(72151,'enUS','De ritual don\'t stop.','De ritual don\'t stop.',26124),
(72152,'enUS','You never be stoppin\' us!','You never be stoppin\' us!',26124),
(72153,'enUS','You should fear de loa.','You should fear de loa.',26124),
(72154,'enUS','De power of loa comes.','De power of loa comes.',26124),
(72155,'enUS','Stop interruptin\'.','Stop interruptin\'.',26124),
(72156,'enUS','What?! What was that?','',26124),
(72157,'enUS','I see no one. Ha. Stupid trolls can\'t even collapse a tunnel properly.','',26124),
(72158,'enUS','No... perhaps someone is in hiding. Fetch the Saurok slaves! They will sniff them out...','',26124),
(72159,'enUS','The Dark Animus goes berserk!','',26124),
(72160,'enUS','Yes, master! I will fight with my life!','',26124),
(72161,'enUS','THEY ARE NO MATCH FOR MANCHU!','',26124),
(72162,'enUS','Stare into the face of true power!','',26124),
(72163,'enUS','What a pathetic display.','',26124),
(72164,'enUS','I run you through!','',26124),
(72165,'enUS','Fall at my feet!','',26124),
(72166,'enUS','More... training...','',26124),
(72167,'enUS','Quet\'zal! Unleash the storm upon my enemies!!!','',26124),
(72168,'enUS','Dam\'ren!  Freeze them to oblivion!','',26124),
(72169,'enUS','Strike quickly, Manchu. Show them no mercy!','',26124),
(72170,'enUS','All brawn. No brains. A recoverable loss.','',26124),
(72171,'enUS','Focus, Weisheng. Show your enemy the meaning of pain!','',26124),
(72172,'enUS','He fought with honor. His first and last mistake.','',26124),
(72173,'enUS','ARGH! Worthless mongrels! I will kill you myself!','',26124),
(72174,'enUS','Enough of this! Come now, weaklings. You have earned your reward. You may now face the Iron Qon.','',26124),
(72175,'enUS','Turn back now, strangers! You face the army of Iron Qon!','',26124),
(72176,'enUS','How can this be?!','',26124),
(72177,'enUS','Gaaaahh!','',26124),
(72178,'enUS','USELESS!','',26124),
(72179,'enUS','','If I must...',26124),
(72180,'enUS','','Was that really necessary...?',26124),
(72181,'enUS','','You shouldn\'t have come here.',26124),
(72182,'enUS','','It is warm.',26124),
(72183,'enUS','','Just... leave me alone!',26124),
(72184,'enUS','','Please, just go! You are making her angry.',26124),
(72185,'enUS','','Just this once...',26124),
(72186,'enUS','','So... lonely.',26124),
(72187,'enUS','','Are they gone yet?',26124),
(72188,'enUS','','More kindling for the flame! Come, Lu\'lin... let us burn them to ash!',26124),
(72189,'enUS','','Hahahahaha!',26124),
(72190,'enUS','','Die in agony!',26124),
(72191,'enUS','','I can see the light.',26124),
(72192,'enUS','','INTRUDERS! GUARDIANS OF THE THRONE, AWAKEN!',26124),
(72193,'enUS','','BLAZE OF DEATH!',26124),
(72194,'enUS','','Lu\'lin! Lend me your strength!',26124),
(72195,'enUS','','Witness the true meaning of pain!',26124),
(72196,'enUS','','Time to deal with these mogu once and for all.',26124),
(72197,'enUS','','I will destroy this cave in, and then we can sneak in from behind. Let me know when you are ready.',26124),
(72198,'enUS','|TInterface\\Icons\\ability_monk_forcesphere.blp:20|tDurumu begins charging up his Mind\'s Eye to cast |cFFFF0000|Hspell:136932|h[Force of Will]|h|r on |cFFFF0000$n|r!','',26124),
(72199,'enUS','|TInterface\\Icons\\inv_misc_eye_02.blp:20|tDurumu begins charging up his Appraising Eye to cast |cFFFF0000|Hspell:133792|h[Lingering Gaze]|h|r!','',26124),
(72200,'enUS','|TInterface\\Icons\\spell_shadow_lifedrain02.blp:20|tDurumu begins charging up his Hungry Eye to cast |cFFFF0000|Hspell:133795|h[Life Drain]|h|r on |cFFFF0000$n|r!','',26124),
(72201,'enUS','|TInterface\\Icons\\spell_shadow_curseofmannoroth.blp:20|tDurumu begins charging up his Evil Eye to cast |cFFFF0000|Hspell:133597|h[Dark Parasite]|h|r on |cFFFF0000$n|r!','',26124),
(72202,'enUS','|TInterface\\Icons\\priest_icon_chakra_blue.blp:20|tDurumu begins charging up his Blue Eye to cast |cFFFF0000|Hspell:134122|h[Blue Rays]|h|r on |cFFFF0000$n|r!','',26124),
(72203,'enUS','|TInterface\\Icons\\priest_icon_chakra_red.blp:20|tDurumu begins charging up his Red Eye to cast |cFFFF0000|Hspell:134123|h[Infrared Light]|h|r on |cFFFF0000$n|r!','',26124),
(72204,'enUS','|TInterface\\Icons\\priest_icon_chakra.blp:20|tDurumu begins charging up his Yellow Eye to cast |cFFFF0000|Hspell:134124|h[Bright Light]|h|r on |cFFFF0000$n|r!','',26124),
(72205,'enUS','The Infrared Light reveals a Crimson Fog!','',26124),
(72206,'enUS','The Bright  Light reveals an Amber Fog!','',26124),
(72207,'enUS','The Blue Rays reveal an Azure Fog!','',26124),
(72208,'enUS','The Harsh Light reveals a Pale Fog!','',26124),
(72212,'enUS','Alright. Let\'s go.','Alright. Let\'s go.',26124),
(72213,'enUS','More work?','',26124),
(72214,'enUS','','It is imperative that we understand the mogu\'s history. Our best chance at a successful offensive will come from knowledge of our enemy.',26124),
(72215,'enUS','','The mogu\'s history is fraught with savage conquest and tests of strength. After thousands of years, only the strongest members of their race have survived.',26124),
(72216,'enUS','The beast ward has fallen! Defend the council with ya lives, brothas!','',26124),
(72217,'enUS','<The blood elf is visibly shaken.>$B$BIt was horrible, just horrible! After we were caught, a mogu took me by the throat. I expected to die then and there, but instead, the mogu made a clutching motion and PULLED. All of a sudden, it was as if all the air were gone from my lungs.$B$BI felt a terrible twisting and ripping. My skin and bones felt as if on fire. Suddenly I was floating out of my own body.$B$BThe mogu laughed in my face, and I knew that my soul would suffer for the rest of eternity.$B$BHave you ever felt complete and utter terror, $c? I have.$B$B<The blood elf shudders and grows quiet.>','',26124),
(72218,'enUS','The peasant contemplates what life means without work.','',26124),
(72219,'enUS','Stay strong, $c. The mogu will not lay down their arms quietly. We will have to fight for every inch of land on this forsaken island.','',26124),
(72220,'enUS','','I\'ve grown quite interested in mogu culture and history. I would call it a bit more than a passing hobby.',26124),
(72221,'enUS','','Archmage Modera is taking a straightforward strategy - defeat the mogu by force. I believe that with further research, we may be able to discover the mogu\'s weaknesses.',26124),
(72222,'enUS','','I\'ve decided to write a book. \"The Mysteries of Mogu Magic.\" Has a nice ring to it, don\'t you think?',26124),
(72223,'enUS','What is it?','',26124),
(72224,'enUS','What?','',26124),
(72225,'enUS','The peasant wishes there was more work to do.','',26124),
(72226,'enUS','','We are vastly outnumbered here, but with a well-executed strategy, I believe we can succeed.',26124),
(72227,'enUS','','Our strategy is sound. We must not falter now, when we have so much still to gain.',26124),
(72228,'enUS','|TInterface\\Icons\\spell_nature_lightningoverload.blp:20|t The |cFFFF0000Northeast|r doors begin to open, causing |cFFFF0000|Hspell:136889|h[Violent Gale Winds]|h|r!','',26124),
(72229,'enUS','|TInterface\\Icons\\spell_nature_lightningoverload.blp:20|t The |cFFFF0000Southeast|r doors begin to open, causing |cFFFF0000|Hspell:136889|h[Violent Gale Winds]|h|r!','',26124),
(72230,'enUS','|TInterface\\Icons\\spell_nature_lightningoverload.blp:20|t The |cFFFF0000Southwest|r doors begin to open, causing |cFFFF0000|Hspell:136889|h[Violent Gale Winds]|h|r!','',26124),
(72232,'enUS','Ready to work.','',26124),
(72233,'enUS','This is but a taste of my power.','',26124),
(72234,'enUS','Why do the peasants seem depressed?','Why do the peasants seem depressed?',26124),
(72235,'enUS','Ah, the familiar embrace of the storms....','',26124),
(72236,'enUS','The touch of creation... and destruction.','',26124),
(72237,'enUS','For millennia I have waited in darkness, in silence pierced only by the shrieks of the tormented, my dreams a waking nightmare.','',26124),
(72238,'enUS','I see the naive hope in your eyes. You... think you are my saviors? Wring that mocking pity from your hearts and focus it inwards, for you shall soon know my agony.','',26124),
(72239,'enUS','This twisted world is beyond redemption, beyond the reach of deluded heroes. The only answer to corruption is destruction. And that begins... now.','',26124),
(72240,'enUS','When I am finished with you, I shall not rest until this world is cleansed. Now perish!','',26124),
(72241,'enUS','Feel your own life essence betray you.','',26124),
(72242,'enUS','Accept the inevitable.','',26124),
(72243,'enUS','Amusing. You really thought you could win.','',26124),
(72244,'enUS','You still think victory possible? Fools!','',26124),
(72245,'enUS','You are the best this world has to offer? Ha, no wonder it has fallen to ruin.','',26124),
(72246,'enUS','Wait! I am... I am not your enemy. You are powerful. More powerful than he was, even.... Perhaps you are right. Perhaps there is still hope.','',26124),
(72247,'enUS','They are depressed because they have no work to do?','They are depressed because they have no work to do?',26124),
(72248,'enUS','Righto.','',26124),
(72249,'enUS','Hello.','',26124),
(72250,'enUS','But there is a yawning chasm of darkness beneath you, mortals. Vast, endless, and all-consuming. I do not believe that you can correct this doomed course.','',26124),
(72251,'enUS','But... you have earned the right to try. Farewell.','',26124),
(72252,'enUS','','The siege is underway but our heavy explosives never made it to the wall!',26124),
(72253,'enUS','','Gather up the explosives and get them to the wall while I rally the reinforcements.',26124),
(72254,'enUS','|TInterface\\Icons\\ability_warrior_throwdown:20|t%s grabs $n and readies his |cFFFF0000|Hspell:137175|h[Thundering Throw]|h|r!','',26124),
(72255,'enUS','|TInterface\\Icons\\spell_shaman_thunderstorm:20|t%s begins to channel an intense |cFFFF0000|Hspell:137313|h[Lightning Storm]|h|r!','',26124),
(72256,'enUS','%s dies, sending arcing lightning to a nearby ally!','%s dies, sending arcing lightning to a nearby ally!',26124),
(72257,'enUS','Go now, to Ihgaluk Crag. I will apply the second half of your illusion once you have arrived.','Go now, to Ihgaluk Crag. I will apply the second half of your illusion once you have arrived.',26124),
(72258,'enUS','%s is pursuing you!','',26124),
(72259,'enUS','$n is affected by |cFFF00000|Hspell:136192|h[Lightning Storm]|h|r !','$n is affected by |cFFF00000|Hspell:136192|h[Lightning Storm]|h|r !',26124),
(72260,'enUS','Guardian Tak\'u is casting Fire of the Serpent! Interrupt now!','',26124),
(72261,'enUS','Guardian Tak\'u has gained Waves of the Hydra! Dispel now!','',26124),
(72263,'enUS','','Are you prepared, $n?',26124),
(72264,'enUS','I am ready.','I am ready.',26124),
(72265,'enUS','','Taoshi motions at Captain Halu\'kal, then draws a finger across her neck.',26124),
(72266,'enUS','%s drains power from the other golems with |cFFFF0000|Hspell:138644|h[Siphon Anima]|h|r!','',26124),
(72267,'enUS','Hey, we should jump off the side of the Black Temple, and see what\'s down there!','',26124),
(72268,'enUS','More DoTs! More DoTs! Throw more DoTs!','',26124),
(72269,'enUS','...okay, stop DoTs.','',26124),
(72270,'enUS','It doesn\'t seem like you\'re casting enough Shadowbolts.','',26124),
(72271,'enUS','The last warlock who tried this failed as well.','',26124),
(72272,'enUS','Has anyone ever told you that you slouch? Good posture is important to proper spell casting!','',26124),
(72273,'enUS','How did you manage to make it this far? Props to your healers!','',26124),
(72274,'enUS','Run to the center!','',26124),
(72275,'enUS','You didn\'t think he was just going to GIVE you green fire, did you?','',26124),
(72276,'enUS','Healthstone! Use your Healthstone!','',26124),
(72277,'enUS','That Curse of Ultimate Doom looks pretty dangerous! Dispel it, quick!','',26124),
(72278,'enUS','I want BLUE fire!','',26124),
(72279,'enUS','Have you tried NOT standing in that? It might work better.','',26124),
(72280,'enUS','You should use your wand when you get low on mana! You DO have a wand, right?','',26124),
(72281,'enUS','We should drink some tiger blood. Then we\'d surely be winning!','',26124),
(72282,'enUS','%s is about to end |cFFFF0000Supercharge Conduits|r!','',26124),
(72283,'enUS','','Be careful, Agrant!',26124),
(72284,'enUS','','We can make it if we run!',26124),
(72285,'enUS','','At least there are no electrified fences. Or trolls.',26124),
(72286,'enUS','','I told you that you weren\'t machine compatible!',26124),
(72287,'enUS','','How could we know anything about an extinct ecosystem? Even the plants are poisonous!',26124),
(72288,'enUS','','You only brought enough food for seven days! Seven! That\'s just great.',26124),
(72289,'enUS','When we have control of the expedition again, everything will be fine...','',26124),
(72290,'enUS','For some odd reason, I love to stare at this cane. Hmmm...','',26124),
(72291,'enUS','What we need is some sort of protein-based population control. Perhaps we should have thought of that before coming here.','',26124),
(72292,'enUS','How could the expedition be a failure? I spared no expense!','',26124),
(72293,'enUS','Agrant? Nellie? Isn\'t it a bit dangerous to be outside of the zeppelin?','',26124),
(72294,'enUS','Anyone, ah, hear that? It\'s ah, it\'s ah, an impact tremor.','',26124),
(72295,'enUS','I\'m fairly alarmed here.','',26124),
(72296,'enUS','Remind me to thank Hamlock for a lovely weekend.','',26124),
(72297,'enUS','It\'s, ah, the cycle of life, mm. The Light creates troll, troll creates dinosaur, dinosaur eats human, trolls inherit Azeroth.','',26124),
(72298,'enUS','Do you think they\'ll have this on the, ah, tour? Hm?','',26124),
(72299,'enUS','I really do hate being right all the time.','',26124),
(72300,'enUS','Am I, mm, talking to myself? I am? See there, I\'m right again.','',26124),
(72301,'enUS','Cover one another! Stand your ground!','',26124),
(72302,'enUS','THIS is who I am. No paperwork, no politics - just the hot fury of magic and steel!','',26124),
(72303,'enUS','Press forward! We shape our own destiny today!','',26124),
(72304,'enUS','We are the Horde. We do NOT back down.','',26124),
(72305,'enUS','Cut them down. Show them our might!','',26124),
(72306,'enUS','Destroy them, me brothers!','',26124),
(72307,'enUS','The spirits give us strength!','',26124),
(72308,'enUS','Eviscerate them! Our gods will drink their blood!','',26124),
(72309,'enUS','Crush them! Bleed them!','',26124),
(72310,'enUS','Break them!','',26124),
(72311,'enUS','The Thunder King! What a magnificent individual.','',26124),
(72312,'enUS','Could you imagine what his empire would be like today if it had not been overthrown and hidden by the pandaren?','',26124),
(72313,'enUS','I couldn\'t imagine a crueler tyrant. He enslaved this entire continent.','',26124),
(72314,'enUS','Benevolence is a luxury for the strong, young prince. No great empire was ever built with kindness.','',26124),
(72315,'enUS','...I\'m not so sure about that. But I can tell you: no great empire has ever stood the test of time by crushing its own citizens.','',26124),
(72316,'enUS','Remember, the mogu were overthrown! THAT should be the lesson of the Thunder King. It\'s your move, by the way.','',26124),
(72317,'enUS','I worry you may be too soft to wear your kingdom\'s crown, Prince Anduin. You would do well to learn some of your father\'s hardness.','',26124),
(72318,'enUS','Are you lecturing me? You\'re what - two years old?','',26124),
(72319,'enUS','Two in DRAGON years. It is your move.','',26124),
(72320,'enUS','Hmmm.','',26124),
(72321,'enUS','...Why did you play that piece just now?','',26124),
(72322,'enUS','It\'s a Pandaren board game. The object is for both players to win.','',26124),
(72323,'enUS','That\'s ridiculous! Why would you even play!?','',26124),
(72324,'enUS','Champion, return now to the Isle of the Thunder King. I will meet you at the forge, where together we will create an instrument of legendary power.','',26124),
(72325,'enUS','To what end? What are you two working towards?','',26124),
(72326,'enUS','...world peace!','',26124),
(72327,'enUS','Using a mogu weapon forge whose powers you barely understand?','',26124),
(72328,'enUS','My dear prince, you and I share the same goals. We only differ in our level of commitment.','',26124),
(72329,'enUS','Come, hero! Let us shape a new Azeroth together!','',26124),
(72330,'enUS','Champion, I know that our people are at war, but if you blindly trust this black dragon in the pursuit of power, are you any better than your warchief? Please - just be careful.','',26124),
(72331,'enUS','My friend, if you blindly trust a black dragon in the search for greater power, are you any better than Garrosh Hellscream? Please - just be careful.','',26124),
(72332,'enUS','Tong, is that our friend?','',26124),
(72333,'enUS','I can\'t believe you\'re still alive.','',26124),
(72334,'enUS','Remind me to tell you the story about my friend here and what we accomplished together at Ravenholdt. Good times!','',26124),
(72335,'enUS','What did I tell you? Few mortals possess such courage and tenacity.','',26124),
(72336,'enUS','Meet me atop Mason\'s Folly, where we met before!','',26124),
(72337,'enUS','What are you two plotting?','',26124),
(72338,'enUS','I keep no secrets! You are welcome to accompany us, Anduin Wrynn. If your injury permits.','',26124),
(72339,'enUS','I implore my Horde friend here not to push you off of the cliff.','',26124),
(72340,'enUS','Truly a splendor! Have you ever seen such a view, Prince Anduin?','',26124),
(72341,'enUS','It\'s breathtaking.','',26124),
(72342,'enUS','It\'s about to get even more awe-inspiring.','',26124),
(72343,'enUS','Champion! Behold the fruits of your labors!','',26124),
(72344,'enUS','At the dawn of the world, when the mortal races were young, they did not yet possess the secrets of fire.','',26124),
(72345,'enUS','They shivered in the cold and the rain until - in one instant - lightning tore the sky!','',26124),
(72346,'enUS','It rent a tree asunder and set it aflame.','',26124),
(72347,'enUS','The mortals gathered around the fire in awe and wonder. It could cook their food and warm their homes. They seized it! And protected it!','',26124),
(72348,'enUS','They fed the fire every hour of every day. Hot coals were carried from one primitive camp to the next. Do you see? In a single flash of light, civilization was born.','',26124),
(72349,'enUS','Truly, lightning is a gift of the Gods.','',26124),
(72350,'enUS','The mogu, ah! The mogu! Their minds were so small! They were built to serve, and when they lost their masters, they served themselves.','',26124),
(72351,'enUS','But they could have been so much more.','',26124),
(72352,'enUS','They built an empire, when they could have built a new world.','',26124),
(72353,'enUS','We will do better, champion. Behold! The Crown of Heaven! My gift to you.','',26124),
(72354,'enUS','You are the ember. You are the spark! You are the fire that will spread across the world. You will awaken Azeroth\'s potential!','',26124),
(72355,'enUS','Come to me.','',26124),
(72356,'enUS','We know now that the mogu share their roots with the Titans. But many mysteries remain. Why were they here? Why Pandaria?','',26124),
(72357,'enUS','What were the mogu sent here to guard? Or destroy? We are missing the final puzzle pieces, and YOU will help me find them!','',26124),
(72358,'enUS','The crown I have given you will be as your third eye. It will tie us together. I will see what you see. Together we will lay the secrets of the Titans bare.','',26124),
(72359,'enUS','I will be watching you closely, hero!','',26124),
(72360,'enUS','Champion... I would think twice before putting that thing on your head.','',26124),
(72361,'enUS','According to this runestone, the mogu were Titan constructs, soulless creatures built of stone. We suspected as much.','',26124),
(72362,'enUS','You\'ve found another stone! What have we learned? The \"curse of flesh\" made the mogu mortal. Ah - but later, they found a way to reverse the process. A clever race.','',26124),
(72363,'enUS','The mogu served a Titan keeper. His name was \"Ra.\" In the mogu tongue, \"Ra-den\" means \"Master Ra.\" Fascinating! I must know more!','',26124),
(72364,'enUS','According to this, the mogu and their master were sent to Pandaria. They were pursuing a great darkness - ah, the fragment is incomplete. We must find others.','',26124),
(72365,'enUS','Here, there is mention of an Old God. \"Y\'Shaarj.\" A beast with seven heads, who breathed darkness. I suspect that thing was the source of the sha that haunts Pandaria to this day.','',26124),
(72366,'enUS','This runestone speaks of a \"Cradle of Life.\" A place where the Titans could create new creatures. Oh - of course - the Vale of Eternal Blossoms! It was a living laboratory, much like Un\'goro Crater or Sholazar Basin.','',26124),
(72367,'enUS','We\'re beginning to put the pieces together, champion. The mogu were created and sent here to guard the Vale for their Titan masters. Guard it from what? Were the Old Gods still a threat?','',26124),
(72368,'enUS','Here, this fragment speaks of \"The Winged Legions of Y\'Shaarj.\" Servants of an Old God? Could this mean the mantid?','',26124),
(72369,'enUS','This runestone is more recent than the others. Something about \"The sleeping keeper.\" I think it\'s referring to Ra-Den. But why was he asleep?','',26124),
(72370,'enUS','You\'ve found another piece of the puzzle! This was carved by the mogu. They were frustrated - a thousand years with no orders from their master, and their bodies had turned to flesh. The mogu began to argue among themselves.','',26124),
(72371,'enUS','Hmmm. This runestone speaks of mogu savagery. They fell apart into warrior clans. But one King was more ambitious than the others - Lei Shen. The Thunder King. When the Titan Keeper fell silent, Lei Shen decided to speak for him.','',26124),
(72372,'enUS','Ah! The final piece of the puzzle. The Thunder King took on the powers of Ra-Den, the very essence of a Titan. He united the mogu into an empire and tried to continue the Titans\' work. Of course he saw himself as a God!','',26124),
(72373,'enUS','Quickly, return to me at the Veiled Stair. We should talk face-to-face.','',26124),
(72374,'enUS','I have been looking forward to your return, champion.','',26124),
(72375,'enUS','The Thunder King took within himself the powers of a Titan keeper. We must take them back!','',26124),
(72376,'enUS','Bring me his cruel, black heart. We will be doing the Pandaren a favor, and the powers that we liberate will once again be put to the service of Azeroth.','',26124),
(72377,'enUS','A chill just went up my spine!','',26124),
(72378,'enUS','Something tells me our friend has returned triumphant.','',26124),
(72379,'enUS','Ahhh - the heart of a King. The powers of a God.','',26124),
(72380,'enUS','What are you doing? You\'re not seriously going to eat that-','',26124),
(72381,'enUS','It is filled with Titan magic, the very language of creation...','',26124),
(72382,'enUS','Oh - I see them - a million, million worlds - glittering in their perfection - but one above all others - oh -','',26124),
(72383,'enUS','WE HAVE FALLEN. WE MUST REBUILD THE FINAL TITAN. DO NOT FORGET.','',26124),
(72384,'enUS','What are you trying to pull?','',26124),
(72385,'enUS','It is gone. I don\'t remember any of it. Oh! None of them remember. The irony!','',26124),
(72386,'enUS','What are you talking about? I don\'t trust you.','',26124),
(72387,'enUS','You are wise not to.','',26124),
(72388,'enUS','Champion, I need time to... \"digest\" what I have learned.  But soon, we will take action.','',26124),
(72389,'enUS','Stop casting! %s is generating an |cFFFF0000|Hspell:138763|h[Interrupting Jolt]|h|r.','',26124),
(72390,'enUS','For the Light!','',26124),
(72391,'enUS','Your class cooldowns have been reset!','Your class cooldowns have been reset!',26124),
(72392,'enUS','How dare you interrupt our preparations! The Zandalari will not be stopped, not this time!','How dare you interrupt our preparations! The Zandalari will not be stopped, not this time!',26124),
(72393,'enUS','Destroy them, I command you! No, stop, stop!','Destroy them, I command you! No, stop, stop!',26124),
(72394,'enUS','Who dares disturb me?','',26124),
(72395,'enUS','The spirits shall consume you!','',26124),
(72396,'enUS','','Don\'t fall back. Don\'t give them an inch!',26124),
(72397,'enUS','','The Zandalari are nothing but lap-dogs. Do you hear me? You are pets for the mogu!',26124),
(72398,'enUS','','Everyone, stay together. Stay focused.',26124),
(72399,'enUS','','Press the attack! We\'re smarter than they are strong!',26124),
(72400,'enUS','','Press the attack!',26124),
(72401,'enUS','Thank you for that. Now let\'s take down that wall!','Thank you for that. Now let\'s take down that wall!',26124),
(72402,'enUS','You have my gratitude.','You have my gratitude.',26124),
(72403,'enUS','Let\'s take this fight to the Thunder King!','Let\'s take this fight to the Thunder King!',26124),
(72404,'enUS','Come on! Let\'s keep going!','Come on! Let\'s keep going!',26124),
(72405,'enUS','Death to the Zandalari!','Death to the Zandalari!',26124),
(72406,'enUS','','Clear a path from the ship to the gate at the upper level - we will need to cross on foot.',26124),
(72407,'enUS','Sinu a\'manore, champion.','',26124),
(72408,'enUS','With the help of the Shado-Pan and this beast you recovered, I believe we can infiltrate and disable the Thunder King\'s armory.','',26124),
(72409,'enUS','Speak to me when you are ready to begin.','',26124),
(72410,'enUS','Elsia is waiting for you, champion.','',26124),
(72411,'enUS','Rangers! Secure the forge. Smash the gate, so it cannot be closed!','',26124),
(72412,'enUS','Incredible work. I knew the Shado-Pan would make excellent allies.','',26124),
(72413,'enUS','Regardless, we have delivered a terrible blow to the Thunder King today. Horde metalsmiths can begin studying mogu fabrication techniques immediately.','',26124),
(72414,'enUS','In good time, my pandaren friend. In good time.','',26124),
(72415,'enUS','','We share a common enemy, Regent Lord, nothing more.',26124),
(72416,'enUS','','With all respect - these abominable tools should be destroyed!',26124),
(72417,'enUS','Good to see you again adventurer.  Are you ready to begin?','',26124),
(72418,'enUS','Let\'s go!','Let\'s go!',26124),
(72419,'enUS','Thank you for your help, adventurer.  We will assist you as best we can in fending off the mogu.','',26124),
(72420,'enUS','I\'m ready to begin my mission.','I\'m ready to begin my mission.',26124),
(72422,'enUS','My wares are reserved for those who have proven themselves on the field of battle. Come see me after you\'ve swept the fields clean of Alliance filth.','My wares are reserved for those who have proven themselves on the field of battle. Come see me after you\'ve swept the fields clean of Alliance filth.',26124),
(72423,'enUS','My wares are reserved for those who have proven themselves on the field of battle. You\'ll need to prove your dominance over the Horde scum before I\'ll entrust them to you.','My wares are reserved for those who have proven themselves on the field of battle. You\'ll need to prove your dominance over the Horde scum before I\'ll entrust them to you.',26124),
(72424,'enUS','Kill the Skumblade Ritualist before the Echo of Kros eats it!','',26124),
(72425,'enUS','','This creature you\'ve recovered is immune to the lightning strikes that protect the island.',26124),
(72426,'enUS','','Do you think you can ride it?',26124),
(72427,'enUS','','Very good!  Once you take to the skies, the Zandalari will try to stop you.',26124),
(72428,'enUS','','Be ready to dogfight in the air. Jump from mount to mount if you have to!',26124),
(72429,'enUS','','A Shado-Pan contact will be waiting to meet you behind the mines. Good luck!!',26124),
(72430,'enUS','What is this? Another uprising?','',26124),
(72431,'enUS','I will soon put you in your place.','',26124),
(72432,'enUS','You are not a slave. How did you get here?','',26124),
(72433,'enUS','You will be in chains before I am done! You will beg for death!!','',26124),
(72434,'enUS','Bend before me!','',26124),
(72435,'enUS','Kneel before your master!','',26124),
(72436,'enUS','You will be... punished...','',26124),
(72437,'enUS','Tinzo the Emberkeeper is nearing full health!','',26124),
(72438,'enUS','Tinzo the Emberkeeper is stealing all of your heals!','',26124),
(72439,'enUS','Kor\'dok winds up a powerful shield slam.','',26124),
(72440,'enUS','YES! Finally! I won a Brawler\'s Guild invite! Nobody can stop me now!','',26124),
(72441,'enUS','I guess I wasn\'t ready to be a brawler.','',26124),
(72442,'enUS','Everyone look! I won a Brawler\'s Guild invite! I can\'t wait to try it out!','',26124),
(72443,'enUS','I won a Brawler\'s Guild invitation just now! I\'ll surely be rank 8 by tonight!  I sure hope I don\'t lose my ticket before I get there.','',26124),
(72444,'enUS','Da view from above is... breathtaking!','',26124),
(72445,'enUS','Grab them ma pets!','',26124),
(72446,'enUS','','',26124),
(72447,'enUS','Have a safe fall, Rogue.','',26124),
(72448,'enUS','Going... up?','',26124),
(72449,'enUS','Hope you packed some feathers, Priest.','',26124),
(72450,'enUS','No coppa? This flights on me.','',26124),
(72451,'enUS','','NO!',26124),
(72452,'enUS','BEHOLD! I have truly mastered the fel energies of this world! The demonic power I now command... It is indescribable, unlimited, OMNIPOTENT!','',26124),
(72453,'enUS','You think I\'ve gone too far? There is no such thing. The Black Harvest will enslave the most powerful demons, draw on their power, and destroy all who oppose us, in this world, and on Azeroth! Do YOU mean to stop me, little one?','',26124),
(72455,'enUS','My power is unimaginable!','',26124),
(72456,'enUS','Hah. Your feeble attacks are entertaining. Would you like to see one of my new pets?','',26124),
(72457,'enUS','I\'d like to see you try.','',26124),
(72458,'enUS','The Annihilan are incredibly destructive creatures. Their sheer strength and power is absolutely unrivaled.','',26124),
(72459,'enUS','WHAT?! Now you\'ve angered me.','',26124),
(72460,'enUS','I\'ll shatter your soul!','',26124),
(72461,'enUS','You are nothing!','',26124),
(72462,'enUS','Deathwing had unstoppable power. And now, it is MINE.','',26124),
(72463,'enUS','You cannot stop your final Cataclysm!','',26124),
(72464,'enUS','This will be your END.','',26124),
(72465,'enUS','CATACLYSMIC POWER!','',26124),
(72466,'enUS','Burn.','',26124),
(72467,'enUS','Pure... CHAOS.','',26124),
(72468,'enUS','Chaos will reign.','',26124),
(72469,'enUS','Chaotic energy will destroy you.','',26124),
(72470,'enUS','The clock is ticking...','',26124),
(72471,'enUS','NOOOOO!','',26124),
(72472,'enUS','AUGHHHH!','',26124),
(72473,'enUS','UNFATHOMABLE!','',26124),
(72474,'enUS','How can it be?!','',26124),
(72475,'enUS','You\'ll burn for that.','',26124),
(72476,'enUS','Hold still...','',26124),
(72477,'enUS','This may seem meager at first, but give it a moment. Soon, the pain will be unbearable.','',26124),
(72478,'enUS','Twist in agony.','',26124),
(72479,'enUS','Rising pain.','',26124),
(72480,'enUS','The anguish will creep up on you.','',26124),
(72481,'enUS','Away from me, mongrel!','',26124),
(72482,'enUS','I am untouchable!','',26124),
(72483,'enUS','Run in fear, coward.','',26124),
(72484,'enUS','Destructive forces corrupt you from the inside.','',26124),
(72485,'enUS','Plant a seed and watch it grow...','',26124),
(72486,'enUS','I wonder what this seed will grow into?','',26124),
(72487,'enUS','I give you the gift of destruction!','',26124),
(72488,'enUS','Terrible destruction awaits you when this seed erupts.','',26124),
(72489,'enUS','Chaotic magic always has the potential for unexpected results.','',26124),
(72490,'enUS','Archimonde\'s use of the ered\'ruin was brilliant. Their command of the dark energies is unparalleled.','',26124),
(72491,'enUS','The ered\'ruin have had no master since Archimonde\'s death. Now I shall be that master.','',26124),
(72492,'enUS','While not the most powerful combatants, a pack of felhounds still has many uses.','',26124),
(72493,'enUS','The felhounds are always hungry for magic to devour.','',26124),
(72494,'enUS','If two imps are better than one imp, what\'s better than two imps? SIXTY IMPS.','',26124),
(72495,'enUS','Even the smallest demon can be valuable, in large enough numbers.','',26124),
(72496,'enUS','','This is only what you once asked me to do if it came to this, Kanrethad. You brought this on yourself.',26124),
(72497,'enUS','','$n, thank you for your help. While the world will not know, you\'ve saved them more than they\'re aware. Kanrethad had to be stopped. I\'ll see to it that he stays banished.',26124),
(72498,'enUS','','Kanrethad enveloped himself with so much fel energy that it corrupted him totally. But a small taste of his power should not be harmful. Go ahead.',26124),
(72499,'enUS','','Now go, and use what you\'ve learned. If you ever wish to have the fel energy purged from you, or reabsorb some of Kanrethad\'s, talk to me. I\'ll be at the Altar of Damnation in Shadowmoon Valley, keeping him banished.',26124),
(72500,'enUS','Hah ha ha... You thought you could defeat me? NOTHING can kill me now, puny mortal!','',26124),
(72501,'enUS','And now, your sad tale comes to an end.','',26124),
(72502,'enUS','Jubeka?! What are you...?!','',26124),
(72503,'enUS','...AUGHHHHHH!!!','',26124),
(72504,'enUS','Many imps! Handle it!','',26124),
(72505,'enUS','%s devours your Enslave Demon!','',26124),
(72506,'enUS','These insects have not yet learned their place, Gara\'jal. If you wish to prove your \"might\" on such weaklings it matters not to me.','',26124),
(72507,'enUS','You have swept the filth from my doorstep. Perhaps you are worthy of my attention.','',26124),
(72508,'enUS','But your trespass ends here. None may enter my forbidden stronghold. I shall rebuild this bridge with your bones for bricks.','',26124),
(72509,'enUS','You! You have earned my ire. I will make an example of you, such that all who look upon my might will tremble and submit.','',26124),
(72510,'enUS','I am Lei Shen, slayer of kings and gods. You have made a grave mistake.','',26124),
(72511,'enUS','Kneel!','',26124),
(72512,'enUS','Die!','',26124),
(72513,'enUS','Submit!','',26124),
(72514,'enUS','Lightning, seek my foes!','',26124),
(72515,'enUS','Wind, heed my call!','',26124),
(72516,'enUS','My power cannot be contained!','',26124),
(72517,'enUS','You have sealed your doom!','',26124),
(72518,'enUS','You would challenge me in my own sanctum? Witness your folly!','',26124),
(72519,'enUS','Bah! I will crush you myself. Let us see how you fare against Lightning.','',26124),
(72520,'enUS','You are NOTHING! I wield the power of the heavens!','',26124),
(72521,'enUS','NO! You are UNWORTHY! I... AM... THE THUNDER KING!','',26124),
(72522,'enUS','I sought only to finish... the work of the Gods...','',26124),
(72523,'enUS','Enough of this!','',26124),
(72524,'enUS','Minuscule.','',26124),
(72525,'enUS','Unworthy.','',26124),
(72526,'enUS','My judgment is final.','',26124),
(72527,'enUS','Lightning strikes.','',26124),
(72528,'enUS','Kneel before me!','',26124),
(72529,'enUS','|cFFFF0000|Hspell:135096|h[Thunderstruck]|h|r killed you.  Move away from the impact point to decrease damage taken.','',26124),
(72530,'enUS','Such an exotic land. I am sure there is quite a menagerie of animals and beasts to be found here. And all with that delightful electrical discharge popping off their bodies.','',26124),
(72531,'enUS','What a delightful specimen you have captured. I have been teaching it to not electrocute our servants. Though it is still a hatchling, and you have to expect such behavior when it is this young.$b$bThankfully the sunwalker over there has been quite helpful in healing those injured by such mischief.$b$bOh, and I took the liberty of giving your tiny creature a name.','',26124),
(72532,'enUS','I am astounded by how quickly this creature grows. At first the diet of cheeses was simply irritating the beast.$b$bBut then we fed it some of the local goats and it started booming in size.$b$bA voracious creature to be sure.','',26124),
(72533,'enUS','We found a saddle and harness from one of the carcasses of the various beasts being shot out of the sky.$b$bA little polish and a little magic and presto... good as new!','',26124),
(72534,'enUS','The Celestial Blacksmith is near death!','',26124),
(72535,'enUS','The Celestial Defender is near death!','',26124),
(72536,'enUS','The Celestial Defender manifests an area of |cFFFF2222|Hspell:140068|h[healing energy]|h|r!','',26124),
(72537,'enUS','Ahaha, get a load \'a me, mon!$b$bGriftah be back again! New stall, and brand new wares, and ready to pass on the deals to ya!$b$bWant more luck for deh mountains? Want tah buy the best \"luckydo\" ya ever smelled? Well step right up and don\' be talkin\' to grummles. Just let your good ol\' friend Griftah lead ya right.$b$bThese miraculous baubles be cheap at tripple the price!','',26124),
(72538,'enUS','Ya tink these herbs and fancy incense be givin\' ya luck in dah mountains? Ha ha! Ya not be tradin\' with dah right mon, mon. Come be gettin\' you a genuine Lucky Lock!','',26124),
(72539,'enUS','Griftah, you think those are luckydos? They smell more like luckydon\'ts.','',26124),
(72540,'enUS','Griftah, your nose is too pointy to smell good fortune. And you smell like unwashed yak.','',26124),
(72541,'enUS','The pandaren have many legends about trolls like you, Griftah. Many legends indeed.','',26124),
(72542,'enUS','Hey! Griftah! That is one of my luckydos! Where did you get that?','',26124),
(72543,'enUS','And to think, my friends say I \"troll\" too much. I must show them you, Griftah.','',26124),
(72544,'enUS','What is that smell? What is that smell?! Is that you Griftah? How can you have that smell? This is most offensive. Most offensive, yes.','',26124),
(72545,'enUS','Ya grummles be good sports. I be likin\' the cut of your jib.$b$bFor dat reason, I be willing to part with this \"Luckydo Kazoo\" which be makin\' only deh most luckiest of music.','',26124),
(72546,'enUS','Ya can\'t be riding yaks into the mountains without a bonified \"Lucktug\"! That be madness! Lemme sell ya some for cheap.','',26124),
(72547,'enUS','So ya be smellin\' fortune eh? What say ya come with me to Bilgewater and we make a fortune at the gamblin\' tables.','',26124),
(72548,'enUS','Ah, come on! Dis\' deal be a good one and ya know it ya snuffler.','',26124),
(72549,'enUS','Dunna\' be judgin\' too quickly, ya? Dis lil\' trinket be exactly what ya looking for, smeller man.','',26124),
(72550,'enUS','Good! You\'re here.  Speak to me when you\'re ready to begin.','',26124),
(72551,'enUS','The trillium you brought me must be refined for our purposes.','',26124),
(72552,'enUS','This foundry should be sufficient.  Help me manipulate the molds.','',26124),
(72553,'enUS','Be ready to fight if we draw too much attention.','',26124),
(72554,'enUS','Clear out the rabble, would you?','',26124),
(72555,'enUS','I need to concentrate. Keep the foundry clear!','',26124),
(72556,'enUS','Excellent! The materials are prepared.  Follow me.','',26124),
(72557,'enUS','How interesting! This forge is built atop of ancient Titan machinery. Lei Shen, you clever, clever tyrant, you!','',26124),
(72558,'enUS','Now if I were a dwarf I would just start randomly pushing buttons. But you and I are here for a purpose.','',26124),
(72559,'enUS','Watch my back while I activate the forge. Did you know that all dragons innately understand the language of the Titans? No doubt a part of their \"grand design.\"','',26124),
(72560,'enUS','Look at that. How easy it must have been for Lei Shen to build an empire, for he wielded the power to create worlds.','',26124),
(72561,'enUS','Please, keep away the distractions.  I need to concentrate on this.','',26124),
(72562,'enUS','Protect the forge!','',26124),
(72563,'enUS','\"Security Protocols?\" Ridiculous. Why were the Titans so obsessed with hiding all of their wonderful toys?','',26124),
(72564,'enUS','You titans infuriate me. I am acting on behalf of the greater good.','',26124),
(72565,'enUS','Do me a favor and silence those things. I am otherwise engaged.','',26124),
(72566,'enUS','Fortunately I can just disable the security. What would you do without me, hm?','',26124),
(72567,'enUS','Certainly there\'s an easier way - oh. Ah! There we go!','',26124),
(72568,'enUS','Ohh, look at that!','',26124),
(72569,'enUS','The mogu were using only a fraction of the resources available to them. Few among them possessed the cunning of the Thunder King.','',26124),
(72570,'enUS','What\'s this - \"Anomaly detected.\" Anomaly?','',26124),
(72571,'enUS','Look at that. This old Titan technology is acting like a magnet for the sha.','',26124),
(72572,'enUS','You\'re an expert at destroying sha by now. Clean up this mess!','',26124),
(72573,'enUS','The forge draws power from the surrounding land. Amazing! I suspect at one time this whole island looked like the Vale of Eternal Blossoms.','',26124),
(72574,'enUS','Keep it up. I am working miracles here!','',26124),
(72575,'enUS','Excellent work! Protect the forge - I am almost finished.','',26124),
(72576,'enUS','This is no good - too dangerous. We\'ll try again later!','',26124),
(72577,'enUS','The forge is overwhelmed! We\'ve got to leave!','',26124),
(72578,'enUS','No no no - this isn\'t right at all. Let\'s get out of here.','',26124),
(72579,'enUS','There! Our work is complete - we have forged a masterpiece!','',26124),
(72580,'enUS','We are done here, but the weapon is not yet tempered.','',26124),
(72581,'enUS','You must thrust the spear into the heart of the Storm Lord while he still lives.','',26124),
(72582,'enUS','Be careful! The moment it pierces his hide, you will be assaulted by his power.','',26124),
(72583,'enUS','It is important to throw the spear just before slaying the beast. Not a moment too soon! Not a moment too late!','',26124),
(72584,'enUS','I must make preparations back on the mainland. Return to me at the Veiled Stair when you have what I need.','',26124),
(72585,'enUS','Oh, and don\'t die.','',26124),
(72586,'enUS','','Got a work related complaint to register? Great! That\'ll be five hundred macaroons for investigation fees and three hundred macaroons for assorted palm greasing.',26124),
(72587,'enUS','|cFFF00000Megaera|r rises from the mists!','|cFFF00000Megaera|r rises from the mists!',26124),
(72588,'enUS','My order has long wandered these lands, lending aid where we can. Ever since the days of Lei Shen there have been five of our order, passing the secrets of our order from generation to generation.','',26124),
(72589,'enUS','What secrets?','What secrets?',26124),
(72590,'enUS','If I told you... it would not be called a secret, now would it?','',26124),
(72591,'enUS','Five sorcerers?','Five sorcerers?',26124),
(72592,'enUS','I no longer remember where the others are. Indeed it has been so long since we last saw each other the others may very well be dead, or replaced by their pupils. I can only have faith that there are still five of us left.','',26124),
(72593,'enUS','FOOLS! I will show you how it is done!','',26124),
(72594,'enUS','The cavern trembles violently!','The cavern trembles violently!',26124),
(72595,'enUS','An ancient beast stirs within the mists!','An ancient beast stirs within the mists!',26124),
(72596,'enUS','My parents once spoke of a strange, furry folk that lived far to the south of our homeland before the Sundering. I always assumed they spoke of smarter furbolgs.$b$bI know now just how wrong I was. Would that they still walked this world and could see this.','',26124),
(72597,'enUS','|cFFFF0000|Hspell:134916|h[Decapitate]|h|r killed you.  The further you are from Lei Shen, the lower the damage from Decapitate. Have the off-tank taunt!','',26124),
(72598,'enUS','You said you would ring the gong first.','',26124),
(72599,'enUS','Nuh uh! And besides, that\'s not a gong! It\'s a bell. I didn\'t say I would hit a bell.','',26124),
(72600,'enUS','I dare you!','',26124),
(72601,'enUS','No way. That bell is bigger than my daddy\'s belly!','',26124),
(72602,'enUS','I double dare you!','',26124),
(72603,'enUS','The Bellmaster is right over there. I heard he turns kids into bells!','',26124),
(72604,'enUS','You heard that from your sister and she doesn\'t count. She\'s a big meanie. I double hozen dare you to ring the bell!','',26124),
(72605,'enUS','*gulp* Dou... dou... double hozen dare?','',26124),
(72606,'enUS','Yep! You don\'t do this and I\'ll tell everyone in Dawn\'s Blossom you are a big chicken who likes wine instead of beer!','',26124),
(72607,'enUS','But my dad says I\'m too little to drink.','',26124),
(72608,'enUS','Yeah! And you\'ll get in trouble for that too! Now ring the bell you big baby.','',26124),
(72609,'enUS','Hah ha ha... You thought you could defeat me? NOTHING can kill me now, puny mortal!','',26124),
(72610,'enUS','','I swore an oath to the Kirin Tor. That bond was one of trust and mutual understanding. And then they betrayed that bond. It is time to remind them the blood elves do not suffer betrayal lightly.',26124),
(72611,'enUS','Stop them! The Animus must not be disturbed!','',26124),
(72612,'enUS','The power... It cannot be wielded this way! You tempt forces you do not understand!','',26124),
(72613,'enUS','You have doomed yourselves. It... is... unleashed.','',26124),
(72614,'enUS','$C, if you are looking for the Black Prince, you will find him upstairs.','',26124),
(72615,'enUS','This continent does not give up its secrets easily.','',26124),
(72616,'enUS','We still have so much to learn.','',26124),
(72617,'enUS','The pandaren embrace life. With so much fighting all around us, it is refreshing to know what we\'re fighting for.','',26124),
(72618,'enUS','Come, have a drink. The prince here is showing me how to play one of the local games.','',26124),
(72619,'enUS','The mogu, the mantid, the saurok... they are not just enemies to defeat. They are mysteries to solve!','',26124),
(72620,'enUS','','Hail, friend!',26124),
(72621,'enUS','','I think I have a plan to infiltrate the Thunder King\'s armory. We\'ll use that creature you recovered, with a little help from the Shado-Pan.',26124),
(72622,'enUS','','Speak to me when you are ready to begin.',26124),
(72623,'enUS','','Vereesa is waiting for you, champion.',26124),
(72624,'enUS','Enter the Fall of Shan Bu scenario.','Enter the Fall of Shan Bu scenario.',26124),
(72625,'enUS','','This beautiful creature you rescued is immune to the lightning strikes that protect the island.',26124),
(72626,'enUS','','Do you think you can ride it?',26124),
(72627,'enUS','','Wonderful!  Once you take to the skies, the Zandalari may come after you.',26124),
(72628,'enUS','','Be ready to dogfight in the air. Jump from mount to mount if you have to!',26124),
(72629,'enUS','','A Shado-Pan agent will meet you behind the mines. Good luck!!',26124),
(72630,'enUS','Once you have met the various factions in Pandaria, work orders will pour in.','',26124),
(72631,'enUS','Thousands of years ... without new playthings ... I will enjoy this.','',26124),
(72632,'enUS','Behold the power of the void.','',26124),
(72633,'enUS','I expected so much more. How ... disappointing.','',26124),
(72634,'enUS','I ... welcome ... the void\'s ... embrace.','',26124),
(72635,'enUS','Do you see what I did there?','',26124),
(72636,'enUS','Looks like you couldn\'t keep up ... pity.','',26124),
(72637,'enUS','Watch your footing ... muhahaha!','',26124),
(72638,'enUS','The mists hide many secrets ... if you know where to look.','',26124),
(72639,'enUS','I\'m keeping an eye on you.','',26124),
(72640,'enUS','Observe your demise.','',26124),
(72641,'enUS','This is the tale of the Dagger in the Dark!$B$BIt was here that three bold adventurers saved Vol\'jin, leader of the Horde\'s Darkspear trolls, from certain assassination.','',26124),
(72642,'enUS','Why do I look like a troll?','Why do I look like a troll?',26124),
(72643,'enUS','Ah, because you are an actor in this tale!$B$BMuch better than simply reading history from some musty old scroll, wouldn\'t you agree?$B$BNow go forward, and learn!','',26124),
(72644,'enUS','This is the tale of A Little Patience!$B$BIt was here that the king of men, Varian Wrynn, counseled patience to Tyrande Whisperwind, high priestess of the night elf\'s moon goddess and leader of their people.$B$BKing Varian\'s plan -- and the work of three bold adventurers! -- saw to an Alliance victory at the temple of the Red Crane, despite being vastly outnumbered by Commander Scargash\'s Horde forces.','',26124),
(72645,'enUS','Why do I look like a human?','Why do I look like a human?',26124),
(72646,'enUS','','Lady Proudmoore, it is safe for you to enter.',26124),
(72647,'enUS','','Rangers! Secure the forge. Smash the gate, so it cannot be closed!',26124),
(72648,'enUS','','You two did it! I knew the Shado-Pan would make excellent allies.',26124),
(72649,'enUS','','We share a common enemy, Lady Proudmoore. Nothing more.',26124),
(72650,'enUS','','My lady. Weapons of the Thunder King are an abomination. They should be destroyed.',26124),
(72651,'enUS','','But together we have delivered a terrible blow to the Thunder King!',26124),
(72652,'enUS','','Vereesa, gather up everything we can find before the mogu return. Leave nothing for the Horde to claim.',26124),
(72653,'enUS','','Oh, they will be. But knowledge is power, and I will never turn down an opportunity to study something new. Thank you, Taoshi.',26124),
(72654,'enUS','','And thank YOU, hero. It will be difficult to hold the forge, but think of what we can learn here!',26124),
(72655,'enUS','|TInterface\\Icons\\trade_archaeology_whitehydrafigurine:20|tMegaera begins to |cFFF00000|Hspell:139458|h[Rampage]|h|r!','|TInterface\\Icons\\trade_archaeology_whitehydrafigurine:20|tMegaera begins to |cFFF00000|Hspell:139458|h[Rampage]|h|r!',26124),
(72656,'enUS','The Shado-Pan are here! They may be of use to us. We should help.','',26124),
(72657,'enUS','This foundry should be sufficient.  We will empower the metal with an electrical charge.','',26124),
(72658,'enUS','Perhaps if I overcharge the forge, it will destabilize this sha nuisance? Let\'s try it.','',26124),
(72659,'enUS','There. Problem solved.','',26124),
(72660,'enUS','Oh - I may have spoken too soon. The sha grows in strength! Destroy it!','',26124),
(72661,'enUS','You aren\'t harboring any bad thoughts, are you?','',26124),
(72662,'enUS','I\'ve overcharged the anvils. They will be VERY effective against the sha, but each one can only be used once more!','',26124),
(72663,'enUS','The lance is finished. Quickly, hurl it at the sha!','',26124),
(72664,'enUS','','Taoshi nods toward the crewman on the right. Sneak up behind him to knock him out!',26124),
(72665,'enUS','','Are you prepared, $n?',26124),
(72666,'enUS','You will be exterminated!','',26124),
(72667,'enUS','An empty crate waits to be filled and prepared for delivery.','',26124),
(72668,'enUS','You are being chased by lightning!','',26124),
(72669,'enUS','','Hello, $n. \n\nKanrethad\'s power is too great to allow him to be free. I\'ll ensure he stays banished, for as long as I exist.\n\nStill, a taste of the fel energies he is saturated with should cause no ill. Feel free to drain some for your own use. Should you ever grow tired of its effects, I can purge the fel energy from you, for a price.',26124),
(72670,'enUS','Jubeka, I no longer wish to be tainted by this fel energy.','Jubeka, I no longer wish to be tainted by this fel energy.',26124),
(72671,'enUS','Are you sure that you no longer want the Codex of Xerrath?','Are you sure that you no longer want the Codex of Xerrath?',26124),
(72672,'enUS','The Zandalari Prophecy.','The Zandalari Prophecy.',26124),
(72673,'enUS','Rumbles of Thunder.','Rumbles of Thunder.',26124),
(72674,'enUS','Gods and Monsters.','Gods and Monsters.',26124),
(72675,'enUS','I\'m ready to tear down the wall! [Queue for solo instance.]','I\'m ready to tear down the wall! [Queue for solo instance.]',26124),
(72676,'enUS','The Sha Amalgamation begins casting |cFFFF2222|Hspell:139382|h[Insanity]|h|r!  Discharge one of the anvils to stop it!','',26124),
(72677,'enUS','Spectacular! Move up - press onward. Show them no quarter!','',26124),
(72678,'enUS','','This way - the Zandalari are falling back!',26124),
(72679,'enUS','','Through the breech! Target the wounded!',26124),
(72680,'enUS','','What... what did they DO to that troll!?',26124),
(72681,'enUS','','My Lord Regent - you should not be so close to the front lines.',26124),
(72682,'enUS','Rangers - to me! We have broken their lines!','',26124),
(72683,'enUS','Nonsense. This is where I belong.','',26124),
(72684,'enUS','Champion! Again you are at the forefront of a Horde triumph. And once more I am in your debt.','',26124),
(72685,'enUS','Regroup behind the wards, everyone. They will counter-attack... but we will be ready.','',26124),
(72686,'enUS','','This way - the Zandalari are falling back!',26124),
(72687,'enUS','','Through the breech! Focus on their priests - they\'re empowering the others!',26124),
(72688,'enUS','','By the Light - what did they DO to that thing?',26124),
(72689,'enUS','','I\'m hurt - do not back down.',26124),
(72690,'enUS','','Kill that thing!',26124),
(72691,'enUS','','It is nothing. I am fine.',26124),
(72692,'enUS','','Well done! We\'re through - pull together, everyone. Press the advantage!',26124),
(72693,'enUS','','Vereesa, are you hurt?',26124),
(72694,'enUS','','You need to get back to camp. I can\'t lose you.',26124),
(72695,'enUS','','Gather up the wounded! We\'ve struck a mighty blow today - the next part of our campaign begins.',26124),
(72696,'enUS','Step forward! Witness the gift of the Thunder King!','',26124),
(72697,'enUS','I was chosen. My blood burns with his power!','',26124),
(72698,'enUS','Too much... the spirits cannot contain his might...','',26124),
(72699,'enUS','You will be punished! Your life a lesson in futility!','',26124),
(72700,'enUS','For Zandalar!!','',26124),
(72701,'enUS','Bar the gates. The Zandalari have failed to hold the wall.','',26124),
(72705,'enUS','Lei Shen must not be allowed to marshal his full strength.$b$bA direct assault on the front gates will take time, and the aid of your Alliance and Horde. But if there is one thing we Shado-pan know it is that where there is a wall, there is a way around.$b$bThe sewers at the back of this tunnel lead all the way to the fortress entrance. We must hold this entrance.','',26124),
(72706,'enUS','','I believe Thunderwing here is our opportunity to score a devastating blow against Lei Shen.',26124),
(72707,'enUS','I\'m with you. Let\'s break into that shipyard! [Queue for solo instance.]','I\'m with you. Let\'s break into that shipyard! [Queue for solo instance.]',26124),
(72708,'enUS','Shaol\'mara Beastcaller summons raptors to his aid!','Shaol\'mara Beastcaller summons raptors to his aid!',26124),
(72709,'enUS','Greetings, $p!$b$bWe have a chance to stop the Thunder King himself before he can reclaim his former power.$b$bEven on the Wandering Isle, his hateful name is remembered, and the sound of thunder feared by pandaren children.','',26124),
(72710,'enUS','','$p, it is good to see you. It will be an honor to face Lei Shen.$b$bThe lorewalkers of the Wandering Isle told us many stories of the dreaded Thunder King. We must proceed with caution here. If legends are to be believed, he was as clever as he was brutal.',26124),
(72711,'enUS','$C! Come to my aid!','$C! Come to my aid!',26124),
(72712,'enUS','','The mogu and Zandalari cower behind the Thunder King\'s walls. Lady Jaina has a plan to blast our way through. Speak to me when you\'re ready!',26124),
(72713,'enUS','Turn away, weaklings. This be the realm of the Thunder King!','',26124),
(72714,'enUS','','Hurry up with the explosives!',26124),
(72715,'enUS','','We must break through - where are my explosives?',26124),
(72716,'enUS','','The wall is wired up and ready to go - the honor is all yours!',26124),
(72717,'enUS','','Well done! We\'re through - pull together, everyone. Press the advantage!',26124),
(72718,'enUS','','This way - the Zandalari are falling back!',26124),
(72719,'enUS','','Through the breech! Focus on their priests - they\'re empowering the others!',26124),
(72720,'enUS','','By the light - what did they DO to that thing?',26124),
(72721,'enUS','','I\'m hurt - don\'t back down.',26124),
(72722,'enUS','','Kill that thing!',26124),
(72723,'enUS','Step forward! Witness the gift of the Thunder King!','',26124),
(72724,'enUS','I was chosen. My blood burns with his power!','',26124),
(72725,'enUS','Too much... the spirits cannot contain his might...','',26124),
(72726,'enUS','You will be punished! Your life a lesson in futility!','',26124),
(72727,'enUS','For Zandalar!!','',26124),
(72728,'enUS','Bar the gates. The Zandalari have failed to hold the wall.','',26124),
(72729,'enUS','','It\'s dead! You\'re an inspiration to the Kirin Tor!',26124),
(72732,'enUS','','It\'s nothing. I\'m fine.',26124),
(72733,'enUS','Hurry - bring me those explosives!','',26124),
(72734,'enUS','Gather up those explosives!','',26124),
(72735,'enUS','','For the Horde!!',26124),
(72736,'enUS','','I\'m hit! Leave me - finish that thing off!',26124),
(72737,'enUS','Rangers - to me! We have broken their lines!','',26124),
(72738,'enUS','Nonsense. This is where I belong.','',26124),
(72739,'enUS','Champion! Again you are at the forefront of a Horde triumph. And once more I am in your debt.','',26124),
(72740,'enUS','Regroup behind the wards, everyone. They will counter-attack... but we will be ready.','',26124),
(72741,'enUS','The Thunder Forge has begun to charge an area nearby.  Run into it to |cFFFF2222|Hspell:139397|h[Overcharge]|h|r yourself!','',26124),
(72742,'enUS','Removing the tome.','Removing the tome.',26124),
(72743,'enUS','Death to the mogu!','',26124),
(72744,'enUS','For Ihgaluk!','',26124),
(72745,'enUS','Die in pain, mogu!','',26124),
(72746,'enUS','Tear the mogu to pieces!','',26124),
(72747,'enUS','I\'ll drag your corpse to the filth pit!','',26124),
(72748,'enUS','Megaera\'s rage subsides.','Megaera\'s rage subsides.',26124),
(72749,'enUS','|TInterface\\Icons\\spell_shadow_curseofmannoroth.blp:20|tDurumu infects his enemies with |cFFFF0000|Hspell:133597|h[Dark Parasites]|h|r!','',26124),
(72750,'enUS','The saurok are despicable, but they may end up useful.$b$bIf we can incite them against the mogu, they can draw attention away from our men.','',26124),
(72751,'enUS','','The saurok intrigue me.$b$bHow is it that they\'ve survived so long in the shadow of their clearly superior enemy?',26124),
(72752,'enUS','','I\'m here to deal with the disease and plague that stems from the Skumblade saurok.$b$bWhile theirs is a different type of plague than I\'m accustomed to, there are certainly several similarities.',26124),
(72753,'enUS','Use the color cones to reveal and slay the three hidden fog beasts.','',26124),
(72754,'enUS','Take care not to forget the true price of war.','',26124),
(72755,'enUS','May the Light be with you, brave $r.','',26124),
(72756,'enUS','','While our goals call for the eradication of the mogu, we can\'t ignore our flanks.$b$bWhile both the Horde and the saurok attack the mogu alongside us, either could turn on us at any moment.',26124),
(72758,'enUS','','The saurok are despicable, but they may end up useful.$b$bIf we can incite them against the mogu, they can draw attention away from our men.',26124),
(72759,'enUS','The saurok intrigue me.$b$bSo much so, in fact, that some have started calling me \"Skumblade Steve\".','',26124),
(72760,'enUS','I\'m here to clean up the mess that stems from the Skumblade saurok.$b$bWhile theirs is a different type of mess than I\'m accustomed to, there are certainly several similarities.','',26124),
(72761,'enUS','','Let us be done with this, so we can all return to our homes.',26124),
(72762,'enUS','','Fight well, $r.',26124),
(72763,'enUS','','I\'m glad you\'re here! Proudmoore needs all the reinforcements she can get. Are you ready to go?',26124),
(72764,'enUS','','The Pandaren are deeply concerned about the return of this \"Thunder King.\" But I\'m more concerned about the Horde. We can talk during the flight.',26124),
(72765,'enUS','','Over 12,000 years ago, the Mogu empire was founded by Lei Shen, \"The Thunder King.\"',26124),
(72766,'enUS','','He united the mogu, conquered the other pandaren races, and built an empire that would last for thousands of years.',26124),
(72767,'enUS','','Legend has it that the Thunder King possessed enormous power, and built himself a palatial fortress. We should be able to see it soon...',26124),
(72768,'enUS','','There it is! The Isle of the Thunder King. Already, the Horde is circling it like hungry birds of prey.',26124),
(72769,'enUS','','If the Thunder King is not defeated, Pandaria will suffer. But worse: if the Horde lays their hands on the source of his power, the whole WORLD will pay the price.',26124),
(72770,'enUS','','Whoa - look out! We have to land. It is almost impossible to fly here!',26124),
(72771,'enUS','','Lady Jaina Proudmoore would like to see you as soon as possible.',26124),
(72772,'enUS','','This has been the worst year of my life: Theramore, destroyed. And a betrayal from within the Kirin-Tor.',26124),
(72773,'enUS','','The lesson is clear. From here on out, I\'m taking the initiative.',26124),
(72774,'enUS','','Just down the coast, the Horde is searching for a place to land their troops.',26124),
(72775,'enUS','','They seek to defeat the Thunder King, not to protect Pandaria, but to claim his power for themselves.',26124),
(72776,'enUS','','But this time, we\'re a step ahead.',26124),
(72777,'enUS','','The Horde will find no purchase on these shores. And when the Thunder King lies beaten, the Pandaren will see that it was Alliance heroes who stood by them in their hour of need.',26124),
(72778,'enUS','','This fight will take everything we have. I hope you are ready.',26124),
(72779,'enUS','I am ready! [Queue for solo instance.]','I am ready! [Queue for solo instance.]',26124),
(72780,'enUS','','You\'re here! The Regent Lord had asked about you specifically. Are you ready to go?',26124),
(72781,'enUS','','Pandaren legends tell of Lei Shen, \"The Thunder King.\" He was the brutal founder of the Mogu empire over 12,000 years ago.',26124),
(72782,'enUS','','He united the mogu, defeated the other pandaren races, and founded a glorious nation with the slave labor of those he conquered.',26124),
(72783,'enUS','','The Thunder King built a palatial fortress on the borders of his empire. We should see it soon...',26124),
(72784,'enUS','Excellent! Can you feel the power of this crystal? I can almost feel my hair standing on end.','',26124),
(72785,'enUS','','There! Just ahead: The Isle of the Thunder King.',26124),
(72786,'enUS','','The Pandaren are terrified that the former Emperor will try to reclaim his empire, and enslave them once again.',26124),
(72787,'enUS','','But we have our own reasons for assisting them. I will allow Lor\'themar to explain.',26124),
(72788,'enUS','','Whoa! Careful - it is nearly impossible to fly anywhere near the island!',26124),
(72789,'enUS','','Be sure to speak with the Lord Regent. He\'s waiting for you at the prow.',26124),
(72790,'enUS','Aethas, leave us for a moment.','',26124),
(72791,'enUS','Hero, you have served the Horde nobly across many campaigns. I feel I can take you into confidence.','',26124),
(72792,'enUS','Our Warchief\'s campaign across Kalimdor and Pandaria is pulling the Horde apart at the seams.','',26124),
(72793,'enUS','We are here to fight the Thunder King. Justice demands it, and Hellscream is too preoccupied at Domination Point to pay attention here.','',26124),
(72794,'enUS','But, in defeating him, we must seek out the source of his great power. We must claim it for ourselves, as leverage against our \"Warchief.\"','',26124),
(72795,'enUS','In the event of an uprising, we must be prepared.','',26124),
(72796,'enUS','Heads up!','',26124),
(72797,'enUS','Ha-hah! It will feel good to bloody my blade again. Against Alliance or mogu, does not matter to me.','',26124),
(72798,'enUS','Enough talk. You know how precarious our position is. Between the Alliance and the Thunder King, only with the help of heroes like you can we hope to succeed here.','',26124),
(72799,'enUS','Anar\'alah belore, hero. Good luck.','',26124),
(72800,'enUS','The forge is safe, and we must take our leave.  Good luck on your quest, adventurer.','',26124),
(72801,'enUS','Make your way through the maze of Eye Sores while avoiding Durumu\'s Disintegration Beam.','',26124),
(72802,'enUS','Step out of the illuminated area before Force of Will finishes casting to avoid being knocked down.','',26124),
(72803,'enUS','Clearly the Kirin Tor has no clue about the power of this island. They are just here to stop us out of spite. Those ignorant amateur mages must be taught a lesson.','',26124),
(72804,'enUS','Mmm. This is a good crystal. You have done well, $p.','',26124),
(72805,'enUS','Kill the Hatchlings before they get a chance to eat and mature.','',26124),
(72806,'enUS','Slain Hatchlings will drop feathers, use the feather to fly for short periods of time.','',26124),
(72807,'enUS','A powerful gem.','',26124),
(72808,'enUS','Well done, $p. The crystals of this island are better in our hands than the Kirin Tor\'s.','',26124),
(72809,'enUS','Fly up to the nests above to stop Juveniles from hatching.','',26124),
(72810,'enUS','|TInterface\\Icons\\ability_druid_galewinds.blp:20|tJi-Kun uses her wings to create a massive |cFFFF0000|Hspell:134370|h[Down Draft]|h|r!','',26124),
(72811,'enUS','|TInterface\\Icons\\ability_hunter_pet_dragonhawk.blp:20|tJi-Kun sends her |cFFFF0000|Hspell:134380|h[Quills]|h|r flying in all directions!','',26124),
(72812,'enUS','|TInterface\\Icons\\ability_hunter_animalhandler.blp:20|tJi-Kun |cFFFF0000|Hspell:138923|h[Caws]|h|r, sending powerful sound waves at her enemies!','',26124),
(72813,'enUS','Ji-Kun goes into a berserk rage!','',26124),
(72814,'enUS','|TInterface\\Icons\\spell_nature_removecurse.blp:20|tThe Dark Parasites morph into a |cFFFF0000|Hspell:133598|h[Dark Plague]|h|r!','',26124),
(72815,'enUS','The Gastropod starts chasing |cFFFF0000$n|r!','',26124),
(72816,'enUS','A Corpse Spider stirs from its sleep in the webs above!','',26124),
(72817,'enUS','The nearby activity of living flesh drives some Bore Worms to action!','',26124),
(72818,'enUS','Upon dying, the Hidden Fog\'s Burst of Light reveals all Pale Fogs in the area.','',26124),
(72819,'enUS','The Eye Sentry pulls nearby enemies into its field of misery, defeat it to get free!','',26124),
(72820,'enUS','|TInterface\\Icons\\ability_creature_disease_02.blp:20|tThe Eye Servant picks up |cFFFF0000$n|r and |cFFFF0000|Hspell:134668|h[Gnaws]|h|r on them!','',26124),
(72821,'enUS','$n makes the catch!','$n makes the catch!',26124),
(72822,'enUS','All this electricity in the air is wreaking havoc on my hair.','',26124),
(72823,'enUS','Ah, good, a $c. We could use more of your kind for some of these tasks.','',26124),
(72824,'enUS','Activation Sequence: Matrixing protocols','',26124),
(72825,'enUS','Activation Sequence: Rerouting auxiliary power','',26124),
(72826,'enUS','Activation Sequence: Deciphering command parse','',26124),
(72827,'enUS','Activation Sequence: Starting micro suppressors','',26124),
(72828,'enUS','Activation Sequence: Repressing urge to activate early','',26124),
(72829,'enUS','Activation Sequence: COMPLETE','',26124),
(72830,'enUS','Activation Sequence: Successfully dividing by zero','',26124),
(72831,'enUS','Activation Sequence: Setting doom level to 15,000 milli-dooms','',26124),
(72832,'enUS','','There is no time to waste. The Alliance move on the Isle of Thunder as we speak!',26124),
(72833,'enUS','Activation Sequence: Plotting your demise','',26124),
(72834,'enUS','','There is no time to waste. The Horde move on the Isle of Thunder as we speak!',26124),
(72835,'enUS','Who wishes to test my spears?','',26124),
(72836,'enUS','My hammer always strikes true! Let the fires rage once again!','',26124),
(72838,'enUS','Sparkmaster Vu stares at you mutely. With a powerful swing of his halberd, he attacks!','',26124),
(72839,'enUS','Activation Sequence: INITIATED','',26124),
(72840,'enUS','Just think of all the knowledge I could share. Think of all the food we could grow!','',26124),
(72841,'enUS','Nana Mudclaw asked ME to join the Tillers council?','',26124),
(72842,'enUS','But... I don\'t think I\'ll have time to work for the council, AND run Sunsong Ranch.','',26124),
(72843,'enUS','This farm has been in my family for generations. How can I give it up? Yet, a greater responsibility has fallen upon me.','',26124),
(72844,'enUS','$n, I\'m gifting Sunsong Ranch to you. You\'re in charge, now!','',26124),
(72846,'enUS','I\'d better head up and talk to Nana. The farm is yours now, $n. I know you\'ll take great care of it.','',26124),
(72847,'enUS','I never knew that helping the Tillers Union would be so much work.','',26124),
(72848,'enUS','How is Sunsong Ranch doing, $n?','',26124),
(72849,'enUS','I\'ve got my hands full around here, but The Heartland is prospering.','',26124),
(72850,'enUS','Ever since the Vale opened up its gates, we\'ve been sending shipment after shipment of vegetables north.','',26124),
(72851,'enUS','Your friends down in the Krasarang Wilds have quite the appetites. There\'s an endless demand for fresh produce.','',26124),
(72852,'enUS','I hear that the Shado-Pan are preparing to assault the Isle of Thunder to the northwest. They will need plenty of food, and we\'re the ones to supply it!','',26124),
(72853,'enUS','I am working with Seedkeeper Shing Sing to develop more efficient methods of farming, harvesting, and storage. Delicious, fresh, high-quality produce is what the Tillers aim to deliver!','',26124),
(72854,'enUS','Farmer Yoon, will you join the council of the Tillers Union?','Farmer Yoon, will you join the council of the Tillers Union?',26124),
(72855,'enUS','I\'m here for the order of red blossom leeks.','I\'m here for the order of red blossom leeks.',26124),
(72856,'enUS','Domination Point thanks you!','Domination Point thanks you!',26124),
(72857,'enUS','Do you have the witchberries?','',26124),
(72858,'enUS','Oh, here they are! Lion\'s Landing thanks you!','',26124),
(72860,'enUS','We\'re in desperate need of those turnips!','We\'re in desperate need of those turnips!',26124),
(72861,'enUS','Thank you so much! The Golden Lotus is in your debt.','Thank you so much! The Golden Lotus is in your debt.',26124),
(72862,'enUS','We could use some more of those beautiful striped melons!','We could use some more of those beautiful striped melons!',26124),
(72863,'enUS','I just love the sound they make when they explode!','I just love the sound they make when they explode!',26124),
(72864,'enUS','Is our order of green cabbages ready to go?','',26124),
(72865,'enUS','Mmmmm! I just love green cabbage soup!','',26124),
(72866,'enUS','Do you have the required pumpkins?','',26124),
(72867,'enUS','I\'m ready for my mission.','I\'m ready for my mission.',26124),
(72868,'enUS','Well, these will have to do. The Klaxxi\'va send their thanks, though I don\'t know why.','',26124),
(72869,'enUS','The essence of Chi-Ji dissipates, leaving a scattered trail of stardust.','',26124),
(72870,'enUS','The essence of Yu\'lon smiles warmly at you as it fades into the sky.','',26124),
(72871,'enUS','The essence of Niuzao rumbles in acceptance of your aid.','',26124),
(72872,'enUS','Dust falls from the guardian as it begins to crack.','',26124),
(72873,'enUS','The guardian begins to move with a rumble.','',26124),
(72874,'enUS','The stone begins to fall away from the guardian. The ritual is almost complete!','',26124),
(72875,'enUS','Guardian Tak\'u has awakened!','',26124),
(72876,'enUS','The essence of Xuen roars triumphantly and disperses into celestial dust.','',26124),
(72877,'enUS','','The mogu and Zandalari are in the process of moving another shipment of treasures from Lei Shen\'s tomb to his throne room.  We will strike quickly and take as much as we can before his forces arrive.  You will only have a limited time before we pull you out, so be efficient $n.\n\nWe\'re only getting one shot at this, so make it count.\n\nWhen you\'re ready to begin, hand me the key and I\'ll open the door.',26124),
(72878,'enUS','Here\'s the key.  Let\'s go.','Here\'s the key.  Let\'s go.',26124),
(72879,'enUS','Make every second count.\n\nWhen you\'re ready to go, let me know and I\'ll get you out of here.','',26124),
(72880,'enUS','I\'m ready to leave.  Let\'s get out of here.','I\'m ready to leave.  Let\'s get out of here.',26124),
(72881,'enUS','','Make it out of there with anything good?',26124),
(72882,'enUS','I\'ll be happy to help you empty that pack of yours.','',26124),
(72883,'enUS','','It is discouraging that Lei Shen has found so many allies to flock to his throne so soon after his return. We should have done a better job to eliminate them during his absence.',26124),
(72884,'enUS','','Enemies litter this isle, both old and new. We will not gain a foot of ground here without spilling blood for it.',26124),
(72885,'enUS','','My ship took a beating to make landing on these shores. I will see to it that they pay for every single nick on her hull.',26124),
(72886,'enUS','There is great arcane power on this island. I cannot yet tell if it lies in the hands of the Thunder King, or in the hands of our old Sunreaver allies.$B$BWe will find out in time.','',26124),
(72887,'enUS','Wanna get in on a little secret? It\'s about where to fish today...','',26124),
(72888,'enUS','Are you lookin\' to hear a secret about where to fish?','',26124),
(72889,'enUS','After a high tide in the Gokk\'lokk Shallows in Dread Wastes, sometimes the increased fish activity loosens the kelp along the shore. $b $b Shrimp, octopus, and all manner\'o\'things get tangled up in there. I bet you could get you a small fortune o\' Mantis Shrimp if you fished out there a while.$b $b  Let me know if you need help finding it.','',26124),
(72890,'enUS','Sure thing, friend. I\'ll mark where you can find Mantis Shrimp map. Take a look at the Northwest corner of Dread Wastes, it\'s a place called Gokk\'lok Shallows.','',26124),
(72891,'enUS','The Anglers over at Sri-La village are reporting an unusually high number of Reef Octopi at their village. I\'d wager that it\'s spawning season, but who knows? $b $b The problem is, that the increased octopus influx is damaging the shellfish population... and everyone knows the real money is in shellfish. $b $b Dangle your bobber there for a minute or two, I bet you\'d walk away with swarms of those octopi.','',26124),
(72892,'enUS','I\'m thinkin\' the Reef Octopi are hereabouts this area in Sri-La village of Jade Forest. $b$b<Ben stuffs a pin along the Northeast shore of Jade Forest on your map.>$b$b','',26124),
(72893,'enUS','During a full moon, the sprite darters in The Woods of The Lost in Jade forest are known to shed their scales. They do it late at night and it\'s actually beautiful to see. $b $b Their scales glow with a bright jade light and fleck off into the water. This attracts Jade Lungfish like you wouldn\'t believe! Like moths to the light! $b $b Careful not to disturb those mogu, though... they ain\'t exactly the friendly type.','',26124),
(72894,'enUS','Yeah, sure. The Jade Lungfish are found about here, in the Enchanted Woods of the Lost in Jade Forest on your map. It\'s not the biggest pool in Pandaria, but it\'s majestic all its own.','',26124),
(72895,'enUS','So today as I was gathering supplies, I found a wandering sherpa who sold exotic potions and oils. One of the more strange oils he had was known as a \"love potion\" for fish.  $b $b Nevermind how he created it, just know that the stuff REALLY works! It DOUBLED the Redbelly Mandarin population in his pond! $b $b I found him at the lake north of Niuzao Temple. You\'d probably do some good if you helped even out the population there.','',26124),
(72896,'enUS','<Ben scratches his head.>$b$b I\'m not the greatest with directions, but I reckon the Redbelly Mandarin are about\'s here, in the Fields of Niuzao in Townlong Steppes. $b$b<Ben circles a general area on your map.>$b$b','',26124),
(72897,'enUS','Here in Valley of the Four Winds, we have our famous Stormstout Brewery. You may have noticed that a rather destructive bunch of Hozu have decided to make that place their own. Their drunken debauchery is known to get a little out of hand. $b $b Sometimes, after a new batch of brew is made, they are known to have beer fights. That\'s right, gallons upon gallons of brew are wasted and wash away into the Yan-Zhe river. $b $b The beer attracts Emperor Salmon, and they swarm like nothin\' I\'ve ever seen. They\'re a bit easier to catch, too... seein\' as they\'ve had a few.','',26124),
(72898,'enUS','The best place to go for Emperor Salmon would probably be right outside the brewery here in the Valley of Four Winds. I\'ll mark it on your map.','',26124),
(72899,'enUS','Do I look angry? Well it\'s because I AM! $b $b My arch nemesis, Wizak Blastbait, is encroaching pretty close onto my turf. He\'s a nasty little goblin, who uses... non-conventional means of fishing.  $b $b Last I saw him, he was at Krasari Falls. You should fish there today if you want Krasarang Paddlefish, I bet he\'s scaring them up left and right. Maybe if he sees other people fishing there, he\'ll deem the area overcrowded and leave. $b $b Oh, and if you can,  make a rude gesture at him. Tell\'m old Ben sent\'ya.$b$b<Ben smirks to himself.>$b$b','',26124),
(72900,'enUS','You\'ll find the Krasarang Paddlefish AND that no-good goblin in the biggest pool of the Krasari River. Right in the heart of Krasarang Wilds. Right here. $b$b<Ben pokes a hole in your map with his claw.>$b$b','',26124),
(72901,'enUS','The Jin\'yu of Binan Village in Kun-Lai Summit spoke to the water today, and it is TEEMING with Sha. $b $b You may already know this, but the Spinefish is a rather aggressive fish. Now, you mix that with a little bit\'o that Sha mojo, and you\'ve got a proper frenzy in the make!  $b $b If you can catch those angry beasties, you may help restore balance to their fragile ecosystem... not to mention gettin\' yourself a dream catch of Spinefish.','',26124),
(72902,'enUS','The Spinefish are right here on your map. Off the shores of Bin\'an Village in Kun-Lai Summit. Anywhere the sky is dark and heavy.','',26124),
(72903,'enUS','Last night, Master Snowdrift was giving some lessons at the Shado-Pan monastery in Kun-Lai Summit. He was teaching his students how to cast fists of frost. $b $b The good news is, the students did great. The bad news is, hundreds of icy fist balls were cast into the water. This froze the Tiger Gourami living in the surrounding lake!$b $b If you\'re looking to catch some Tiger Gourami today, that\'s probably your best bet.','',26124),
(72904,'enUS','The Tiger Gourami will be found near the pagoda of Shado-pan Monastery... here, in Kun-Lai Summit. $b$b<Ben marks a spot on your map.>$b$b','',26124),
(72905,'enUS','Mad Qao-Pao doesn\'t mean any harm. Truly, he doesn\'t. He heard that the pond in front of the Mogu\'shan Palace granted wishes, you see... like a wishing well. $b $b And... well... the poor guy has more gold than wit. Last I heard, he\'s been dumping gold into the water... hoping to become king of the world! $b $b Sadly, Jewel Danio\'s favorite treats are fireflies that fly low on the water. The glimmer of the coins lures them out in droves. $b $b Hopefully the poor things aren\'t swallowing too many coins. Today\'s the day to get Jewel Danio if you want, though. You may even find a couple of coins yourself.','',26124),
(72906,'enUS','Mad Qao Pao and his Jewel Danio were last found  in the Summer Fields in Vale of Eternal Blossoms. Probably around this area. $b$b<Ben marks a spot on your map.>$b$b','',26124),
(72907,'enUS','Sure, I\'d love to hear a secret.','Sure, I\'d love to hear a secret.',26124),
(72908,'enUS','Even better, can you just show me on my map?','Even better, can you just show me on my map?',26124),
(72909,'enUS','These fish jump up and down like a bouncing luckydo!','',26124),
(72910,'enUS','I don\'t even know how to fish! Can you teach me?','I don\'t even know how to fish! Can you teach me?',26124),
(72911,'enUS','Do you happen to have any fishing supplies?','Do you happen to have any fishing supplies?',26124),
(72912,'enUS','The smell of good fortune is upon this lake...  or is that just Fishbreath?','',26124),
(72913,'enUS','It is very sad that fish have no trails or mountains to climb.  If I bring them more fish friends will they be happy?','',26124),
(72914,'enUS','Lightning is better than thunder right?  Well, then I wish to be crowned the Lightning King of Pandaria!','',26124),
(72915,'enUS','I wish for a million gold, wait a second  I already have a million gold...  I wish for a million million gold!','',26124),
(72916,'enUS','Ooh I know!  I wish for all the beer in Stormstout Brewery!','',26124),
(72917,'enUS','I want a panther encrusted in the world\'s finest jewels!  Wait, doesn\'t one of my friends already have one of those?','',26124),
(72918,'enUS','No no no, that\'s not what I want.','',26124),
(72919,'enUS','Hmm, well on second thought...','',26124),
(72920,'enUS','Oh wait, I have a better one!','',26124),
(72921,'enUS','Haha!  Take that you unsuspecting water dwellers!','',26124),
(72922,'enUS','I was never that good with a fishing pole...  No matter!','',26124),
(72923,'enUS','Taste hot TNT you fishy fiends!','',26124),
(72924,'enUS','Bow before your terrestrial overlord as fire rains down upon you!','',26124),
(72925,'enUS','You can tell that booming voice that he\'s nothing but hot air!','',26124),
(72926,'enUS','Now I\'m really angry!','',26124),
(72927,'enUS','That\'s the rudest thing anyone\'s ever done to me!','',26124),
(72928,'enUS','First the fish!...  Now you?','',26124),
(72929,'enUS','Nibbin\' these slickies gonna grook you in the jerb.','',26124),
(72930,'enUS','So many slickies...  Hozen grookin\' love slickies!','',26124),
(72931,'enUS','Ookin\' slicky just ooked me in the nib tickler!','',26124),
(72932,'enUS','Slickies love wikket slerp...  Hozen grookin\' love wikket slerp!','',26124),
(72933,'enUS','This unfortunate Zandalari has been gored and trampled. The expression on his face is not one of fear, but one of steely determination, even in death.$b$bHis open eyes appear to burn with intense passion, even as they stare unblinking into the sky. A fly crawls along their still-moist surface.','',26124),
(72934,'enUS','The king wanted Prince Anduin to stay in the vale until he recovered. But the prince insists on wandering around talking to people. What are we to do when a prince wants to disobey his king?$b$bBest to stay close and keep him out of trouble.','',26124),
(72935,'enUS','<The bodyguard glowers at you, his fist tightly clenching his sword.>$b$bThe prince wants to have a quiet chat, $c. If you start any trouble, we\'ll respond in kind.','',26124),
(72936,'enUS','<The tauren paladin looks you up and down, as if sizing up your intentions.>$b$bI mean you no hostility, $c. The human prince and I met at the Temple of the White Tiger, and he often seeks me out to talk about my Chieftain, Baine, and to discuss matters of war and peace.$b$b<The paladin and the Prince\'s bodyguards periodically exchange distrustful glances at one another.>','',26124),
(72937,'enUS','Greetings, $c!$b$bChieftain Baine Bloodhoof was distressed to learn of Garrosh\'s savage attack on the human prince. Our causes for grievance against the Alliance are many, but none are the responsibility of this little one.$b$bThe prince and I met at the Temple of the White Tiger. On my honor I have pledged that I will do what I can to keep him safe.$b$b<Despite his words and the warmth the prince directs his way, the tauren paladin suffers distrustful glances from the royal bodyguards in the corner of the room.>','',26124),
(72938,'enUS','No - stop. Stop this at once!','',26124),
(72939,'enUS','Stay your hand! Not here - not now!','',26124),
(72940,'enUS','Wrathion claims to be the last living black dragon. Do you think that\'s true?$b$bHe\'s got the most curious outlook on the world. I can\'t decide if he thinks human life is precious or expendable! I do enjoy talking with him, however.','',26124),
(72941,'enUS','<Anduin\'s bodyguards edge closer the moment you address the prince.>$b$bIt\'s okay. I\'d just like to have a chat with my friend. We\'re far from any battlefronts here. Can some part of the world still be safe for civilized conversation?$b$bCome, sit down! Join us!','',26124),
(72942,'enUS','Oh, this? <Anduin indicates his crutch.>$b$bGarrosh Hellscream tried to use an ancient mogu artifact to summon and control sha energy. I found a way to stop him, but probably shouldn\'t have confronted him on my own. He thought I was dead when he left me buried under the wreckage of his failed plan. I swear he shattered every bone in my body.$b$bThe pandaren mistweavers got me back on my feet again, but it may be some time before I can walk without assistance.','',26124),
(72943,'enUS','You know of our history with the black dragonflight, do you? I won\'t soon forget what Lady Prestor - Onyxia - did to my family. Maybe that\'s why I sought Wrathion out.$b$b<Anduin peers across the table at his unusual companion.>$b$bBut... he\'s not like the other black dragons, is he? He\'s completely honest and yet always hiding something. Not at all what I expected.','',26124),
(72944,'enUS','Wrathion claims to be the last living black dragon. Do you think that\'s true? Weren\'t there others still in Outland somewhere?$b$bRegardless, I find him fascinating. He\'s not like any other dragon I\'ve ever met. He is honest, almost painfully so. I can\'t decide if he thinks mortal lives are absolutely precious or completely expendable.','',26124),
(72945,'enUS','What happened to your leg? Are you wounded?','What happened to your leg? Are you wounded?',26124),
(72946,'enUS','How can you trust a black dragon, after what they put your family through?','How can you trust a black dragon, after what they put your family through?',26124),
(72947,'enUS','What do you make of Wrathion?','What do you make of Wrathion?',26124),
(72948,'enUS','Once you have earned the respect of his majesty, the Black Prince, then you will have earned mine. Complete more of his tasks.$b$bUntil then, begone. I have nothing to sell to you.','',26124),
(72949,'enUS','Welcome. I can replace any any rewards you may have gotten from the Black Prince... for a price.','',26124),
(72950,'enUS','How can I replace items you have awarded me in the past?','How can I replace items you have awarded me in the past?',26124),
(72951,'enUS','Look for my Blacktalon Quartermaster here in the tavern. He can resupply you with any rewards I have given you previously... for a price of course. As you no doubt have noticed, the materials I work with are not at all cheap.','',26124),
(72952,'enUS','You made it! Excellent. Now we can begin.','',26124),
(72953,'enUS','I am ready!','I am ready!',26124),
(72954,'enUS','%s sweeps the area with its |cFFFF0000|Hspell:136898|h[Flamethrower]|h|r!','',26124),
(72955,'enUS','%s is unable to find a target to melee, so resorts to its |cFFFF0000|Hspell:136854|h[Death Stare]|h|r!','',26124),
(72956,'enUS','%s prepares to pound nearby targets with |cFFFF0000|Hspell:137074|h[Ground Slam]|h|r!','',26124),
(72957,'enUS','%s winds up a massive |cFFFF0000|Hspell:136847|h[Shockwave]|h|r!','',26124),
(72958,'enUS','%s uses |cFFFF0000|Hspell:138019|h[Lightning Prod]|h|r! Get away from the Saurok!','',26124),
(72959,'enUS','Kor\'dok resurrects a fallen ally to aid him in battle!','',26124),
(72960,'enUS','The discharged electricity has manifested itself as an elemental!','The discharged electricity has manifested itself as an elemental!',26124),
(72961,'enUS','|cFFFF2222[Electrified]|r  You can discharge the electricity at a nearby Lightning Rod.','|cFFFF2222[Electrified]|r  You can discharge the electricity at a nearby Lightning Rod.',26124),
(72962,'enUS','Where the Warchief commands, my blade shall follow.','',26124),
(72963,'enUS','There\'s only one solution. I have to join the council. As for the farm...','',26124),
(72964,'enUS','We stirred up a great deal of trouble, $n. But it was worth it.','',26124),
(72965,'enUS','|TInterface\\Icons\\spell_frost_piercing chill:20|tYou are being targeted by |cFFF00000|Hspell:139866|h[Torrent of Ice]|h|r!','|TInterface\\Icons\\spell_frost_piercing chill:20|tYou are being targeted by |cFFF00000|Hspell:139866|h[Torrent of Ice]|h|r!',26124),
(72966,'enUS','|TInterface\\Icons\\inv_misc_volatilefire:20|tYou are afflicted with |cFFF00000|Hspell:139822|h[Cinders]|h|r!','|TInterface\\Icons\\inv_misc_volatilefire:20|tYou are afflicted with |cFFF00000|Hspell:139822|h[Cinders]|h|r!',26124),
(72967,'enUS','Transmogrification and Void Storage','Transmogrification and Void Storage',26124),
(72968,'enUS','I have the key, let\'s start the raid. [Queue for solo instance.]','I have the key, let\'s start the raid. [Queue for solo instance.]',26124),
(72969,'enUS','','I\'m helping!',26124),
(72970,'enUS','','Paw-paw says I\'m not s\'posed to talk to strangers.',26124),
(72971,'enUS','','I can count alllll the way to \"nine-ten.\" Listen!$B$B<Milly counts on her fingers and toes.>$B$BOne, two, three, five, six, umm... seven, eight, nine-ten!$B$BWait, I missed one...',26124),
(72972,'enUS','','Don\'t put seeds in your nose. That makes paw-paw real mad!',26124),
(72973,'enUS','','I like turtles.',26124),
(72974,'enUS','','Counting is fun!',26124),
(72975,'enUS','Milly, I need you to bag some seeds for me.','Milly, I need you to bag some seeds for me.',26124),
(72976,'enUS','We are ready to launch the raid at a moment\'s notice. All we need is the key. Have you found one?','We are ready to launch the raid at a moment\'s notice. All we need is the key. Have you found one?',26124),
(72977,'enUS','|TInterface\\Icons\\spell_nature_callstorm:20|t%s afflicts his enemies with |cFFFF0000|Hspell:138732|h[Ionization]|h|r!','',26124),
(72978,'enUS','Persistence in training shall always achieve results.','',26124),
(72979,'enUS','Let\'s head outside to the island.','Let\'s head outside to the island.',26124),
(72980,'enUS','Are you ready to try again?','',26124),
(72981,'enUS','Yes, let\'s charge that Trillium!','Yes, let\'s charge that Trillium!',26124),
(72982,'enUS','','Good job making it out in time.  We recovered a key that should work on one of these troves.  It\'s all yours.',26124),
(72983,'enUS','','We barely pulled you out of there.  You\'re lucky to be alive.',26124),
(72984,'enUS','I\'m ready to go.','I\'m ready to go.',26124),
(72985,'enUS','I\'m ready to go.','I\'m ready to go.',26124),
(72986,'enUS','Bring on the sha!','Bring on the sha!',26124),
(72987,'enUS','I just need a quart, I promise.','',26124),
(72988,'enUS','You\'re O negative, right?','',26124),
(72989,'enUS','Ah yes, I can smell it from here!','',26124),
(72990,'enUS','You are abandoning your mission! You must return before you are teleported to the nearest graveyard.','You are abandoning your mission! You must return before you are teleported to the nearest graveyard.',26124),
(72991,'enUS','|TInterface\\Icons\\achievement_zone_cataclysm.blp:20|t%s begins channeling a massive |cFFFF0000|Hspell:138564|h[Cataclysm]|h|r!','',26124),
(72992,'enUS','|TInterface\\Icons\\ability_warlock_chaosbolt.blp:20|t%s begins casting a massive |cFFFF0000|Hspell:138559|h[Chaos Bolt]|h|r!','',26124),
(72993,'enUS','','The Thunder King\'s palace lies ahead. We must secure a foothold on the island before we can assault his fortress.',26124),
(72994,'enUS','','Ugh! Hold on!',26124),
(72995,'enUS','Forgemaster Vul\'kon equips his Staff and begins to channel the powers of lightning!','',26124),
(72996,'enUS','Forgemaster Vul\'kon equips his Hammer and begins to swing with great force!','',26124),
(72997,'enUS','The Sha Amalgamation is casting |cFFFF2222|Hspell:139375|h[Shadow Burst]|h|r! Run Away!','',26124),
(72998,'enUS','The Sha Amalgamation is vulnerable!  Throw the |cFFFF2222[Lightning Lance]|r at it!','',26124),
(72999,'enUS','The Sha Amalgamation casts |cFFFF2222|Hspell:139443|h[Meteor Storm]|h|r!','',26124),
(73000,'enUS','The Sha Amalgamation banishes the Celestial Defender.  Defend yourself!','',26124),
(73001,'enUS','The Celestial Defender is critically injured and is no longer able to fight!','',26124),
(73002,'enUS','You are out of time.','You are out of time.',26124),
(73003,'enUS','A |cFFFF2222[Thundering Anvil]|r has become overcharged! Click it to cause a |cFFFF2222|Hspell:138834|h[Thunder Surge]|h|r!','',26124),
(73004,'enUS','Dis ship is unda new management! Anybody not pullin\' dey weight is gonna have dey spirit re-assigned to a golem.','',26124),
(73005,'enUS','Unda my command, dis ship gonna be feared by all! Isn\'t dat right, Ripi?','',26124),
(73006,'enUS','These Zandalari are not to be underestimated. They are quite unlike any troll I have yet encountered.','',26124),
(73007,'enUS','My rangers have sent back disturbing reports from Za\'Tual. I believe it is time to take this fight to their doorstep.','',26124),
(73008,'enUS','The bones side with the spirits!','',26124),
(73009,'enUS','The bones side with death!','',26124),
(73010,'enUS','The bones side with me!','',26124),
(73011,'enUS','The bones side with you, mon!','',26124),
(73012,'enUS','Rollin the bones...','',26124),
(73013,'enUS','Zur\'chaka Rolls the Bones!','',26124),
(73014,'enUS','Here are the explosives, Vereesa.','Here are the explosives, Vereesa.',26124),
(73015,'enUS','The Shado-pan Defender has placed a |cFFFF2222|Hspell:132744|h[Healing Orb]|h|r!','',26124),
(73016,'enUS','Are you ready for me to start up the Thunder Forge?  Things could get a bit hairy.','',26124),
(73017,'enUS','Start it up!','Start it up!',26124),
(73018,'enUS','Death to the Alliance!','Death to the Alliance!',26124),
(73019,'enUS','For the Horde!','For the Horde!',26124),
(73020,'enUS','You won\'t escape alive, $r!','You won\'t escape alive, $r!',26124),
(73021,'enUS','I\'m going to enjoy this...','I\'m going to enjoy this...',26124),
(73022,'enUS','You don\'t belong here!','For the Alliance!',26124),
(73023,'enUS','I thought I smelled something!','Death to the Horde!',26124),
(73024,'enUS','This is for Theramore!','You\'ll burn for your crimes!',26124),
(73025,'enUS','Die Horde scum!','You will pay for your crimes!',26124),
(73026,'enUS','A |cFFFF2222[Thundering Anvil]|r has become overcharged! Activate it to |cFFFF2222|Hspell:138834|h[Discharge]|h|r its energy.','',26124),
(73027,'enUS','The |cFFFF2222[Lightning Lance]|r is charged.  Use it to finish off the Sha Amalgamation!','',26124),
(73028,'enUS','|TInterface\\Icons\\spell_arcane_mindmastery.blp:20|t %s wakes up with a terrible |cFFFF0000|Hspell:140432|h[Hangover]|h|r!','',26124),
(73029,'enUS','Dat came from da ship! Let\'s go!','',26124),
(73032,'enUS','A storm is brewing near the Lightning Pillar.  Beware!','',26124),
(73033,'enUS','Move away from the shackles to break the chains!','Move away from the shackles to break the chains!',26124),
(73034,'enUS','|TInterface\\Icons\\ability_thunderking_thunderstruck.blp:20|tLei Shen has become angered and calls down a |cFFFF0000|Hspell:140549|h[Lightning Storm]|h|r!','',26124),
(73035,'enUS','|TInterface\\Icons\\spell_shadow_destructivesoul.blp:20|t%s casts |cFFFF0000|Hspell:140543|h[Empower Axe]|h|r! Run Away!','',26124),
(73036,'enUS','|TInterface\\Icons\\warrior_talent_icon_bloodandthunder.blp:20|t%s begins to cast |cFFFF0000|Hspell:140531|h[Desist]|h|r! Kill the  |cFFFF0000Chains|r to free yourself!','',26124),
(73037,'enUS','Set','Set',26124),
(73038,'enUS','Make Sunsong Ranch your home.','Make Sunsong Ranch your home.',26124),
(73039,'enUS','<A hefty tome with a well-worn cover and bits of earth stuck in the bindings. It looks like Yoon has been carrying on tradition and recording the history of Sunsong Ranch in this journal. It lies open to his last entry: a note addressed to you!>$B$B\"Thank you for restoring my family\'s land to its former glory. I am on to bigger things; It is your turn to fill in these pages now.\"','',26124),
(73040,'enUS','Cavern Burrower begins to call nearby Shale Stalkers to aid it.','',26124),
(73041,'enUS','Cavern Burrower alerted nearby Shale Stalkers to your presence with |cFFF00000|Hspell:140600|h[Sonic Call]|h|r!','',26124),
(73044,'enUS','The %s begins to cast Hymn of Silence! Hide inside a barrier!','The %s begins to cast Hymn of Silence! Hide inside a barrier!',26124),
(73045,'enUS','Stop casting! %s is generating an |cFFFF0000|Hspell:139869|h[Interrupting Jolt]|h|r.','',26124),
(73046,'enUS','Stop casting! %s is generating an |cFFFF0000|Hspell:139867|h[Interrupting Jolt]|h|r.','',26124),
(73062,'enUS','The |cFFFF0000Horde|r has lost control of the Pandaren Mine!','',26124),
(73063,'enUS','The Alliance has taken control of the Pandaren Mine!','',26124),
(73064,'enUS','The |cFFFF0000Horde|r has taken control of the Pandaren Mine!','',26124),
(73065,'enUS','The Alliance has lost control of the Pandaren Mine!','',26124),
(73066,'enUS','The Alliance has taken control of the Goblin Mine!','',26124),
(73067,'enUS','The |cFFFF0000Horde|r has taken control of the Goblin Mine!','',26124),
(73068,'enUS','The |cFFFF0000Horde|r has lost control of the Goblin Mine!','',26124),
(73069,'enUS','The Alliance has lost control of the Goblin Mine!','',26124),
(73071,'enUS','I lend you the cold vengeance of the northern winds!','',26124),
(73075,'enUS','','He represents everything that is just, and righteous, and a bunch of other boring crap too. It\'s the draenei paladin, Ahoo\'ru!',26124),
(73076,'enUS','','Get out your shovels, everyone! Mingus Diggs is about to teach us a lesson in archaeology!',26124),
(73077,'enUS','','Well, well, well... look who came waddling back. It\'s the bruised-beaked bouncing bird, Dippy! And this time, he\'s not alone!',26124),
(73078,'enUS','He represents everything that is just, and righteous, and several other virtues which are of no interest to most of you. It\'s the draenei paladin, Ahoo\'ru!','',26124),
(73079,'enUS','Get out your shovels, everyone! Mingus Diggs is about to teach us a lesson in archaeology!','',26124),
(73080,'enUS','It seems we have a returning challenger! Welcome back to the arena, Dippy!','',26124),
(73081,'enUS','Newt, get that door open.','',26124),
(73082,'enUS','Recruit $p, you\'re with me.','',26124),
(73083,'enUS','We\'ve tracked the recent disappearances in Durotar to this abandoned section of Ragefire.','',26124),
(73084,'enUS','','Yes, sir!',26124),
(73085,'enUS','Good day, sir!','',26124),
(73086,'enUS','It\'s our job to find out who\'s behind these abductions and put a stop to them.','',26124),
(73087,'enUS','Grit, Ticker and Volt, you three back her up.','',26124),
(73088,'enUS','Stay close.','',26124),
(73089,'enUS','Newt, we need this door open now.','',26124),
(73090,'enUS','','I\'m setting the last charge now, sir!',26124),
(73091,'enUS','','The charges are all set; hit the detonator as soon as you\'re ready!',26124),
(73092,'enUS','Move! Move! Move!','',26124),
(73093,'enUS','EXTREME HOZEN-FU!','',26124),
(73094,'enUS','The Horde have dropped the Alliance gold cart!','',26124),
(73095,'enUS','The Horde have stolen gold from the Alliance!','',26124),
(73096,'enUS','Gonna set wikkets up the boom boom! AGAIN!','',26124),
(73097,'enUS','Now with more BOOM in every BOOM BOOM!','',26124),
(73098,'enUS','Kaboom!','',26124),
(73099,'enUS','Gonna boom wikkets up the boom boom!','',26124),
(73100,'enUS','What the...','',26124),
(73101,'enUS','Use the cones of light to find and defeat the hidden Crimson Fogs!','',26124),
(73102,'enUS','Use the cones of light to find and defeat the one fog beast of each color!','',26124),
(73103,'enUS','Two fog beasts remain.','',26124),
(73104,'enUS','One fog beast remains.','',26124),
(73105,'enUS','You are the target of the Infrared Light! Move around the arena with your teammates to find and defeat a Crimson Fog.','You are the target of the Infrared Light! Move around the arena with your teammates to find and defeat a Crimson Fog.',26124),
(73106,'enUS','You are the target of the Blue Rays! Move around the arena with your teammates to find and defeat an Azure Fog.','You are the target of the Blue Rays! Move around the arena with your teammates to find and defeat an Azure Fog.',26124),
(73107,'enUS','Intruders! Stop them!','',26124),
(73108,'enUS','Weaklings!','',26124),
(73109,'enUS','There aren\'t any more challengers who want to fight you, $n. You\'re just too damned good.\n\nYou still want a fight? Go pick up a challenge card and talk to me again.','There aren\'t any more challengers who want to fight you, $n. You\'re just too damned good.\n\nYou still want a fight? Go pick up a challenge card and talk to me again.',26124),
(73110,'enUS','Luckydo floot!','',26124),
(73111,'enUS','','Also entering the arena: the magnanimous Master Boom Boom, the dynamite throwing monkey monk!',26124),
(73112,'enUS','Also entering the arena: the hozen with the box of bombs! It\'s Master Boom Boom, the dynamite throwing monkey monk!','',26124),
(73113,'enUS','Many bad fortunes to you!','',26124),
(73114,'enUS','You must have good luckydo.','',26124),
(73115,'enUS','Stupid grummlepack!','',26124),
(73118,'enUS','We found somethin\' down there, somethin\' HUGE, and all of a sudden the rocks started fightin\' back and everyone went crazy. Bad business!','',26124),
(73119,'enUS','Please, just make it all stop!','',26124),
(73120,'enUS','','Whatcha lookin\' at kid?  There\'s work to be done!',26124),
(73121,'enUS','Hostile target acquired.','',26124),
(73122,'enUS','Vertical stabilizers offline. Powering down.','',26124),
(73123,'enUS','Target nonfunctional. Ending combat actions.','',26124),
(73124,'enUS','','Ye ain\'t cookin\' ME, ye long-eared snow-huffer!',26124),
(73125,'enUS','','Take THIS, ye blue-skinned hag!',26124),
(73126,'enUS','','Tryin\' ta roast ME, ye snaggle-toothed bone-biter?! I\'ll show ye!',26124),
(73127,'enUS','Egg sensor offline. Shutting down.','',26124),
(73128,'enUS','Armor unit malfunction. System offloading.','',26124),
(73129,'enUS','Beak device overloaded. Unit deactivating.','',26124),
(73130,'enUS','Ye\'ve got my attention.  OK, now ye\'ve lost it.','',26124),
(73131,'enUS','Punchin\' faces bought this suit.','',26124),
(73132,'enUS','Aye, my brawlin\' days are over.  Nowadays, I fill my time with fancy ale and not-so-fancy lasses.','',26124),
(73133,'enUS','','The view really is much better from up here.  Not to mention the distinct lack of blood-spatter.',26124),
(73134,'enUS','','I always cheer for the robots.',26124),
(73135,'enUS','','Did you say something?  I\'m sorry, I tend to not pay attention to conversation when things are being killed for my amusement.',26124),
(73136,'enUS','No, no, I\'m not brawling. I\'m mainly here to cheer for Bruce.','',26124),
(73137,'enUS','Ahh yes, I remember the first time I fought against the Dark Summoner.  And the second time... and the third...','',26124),
(73138,'enUS','A piece of advice?  Never underestimate your foe, no matter how short, waddly, and heart-meltingly cute they might be.','',26124),
(73139,'enUS','','What? Can\'t a death knight get a little dressed up every once in a while?',26124),
(73140,'enUS','','I can\'t BELIEVE she wore the same dress as me.  How embarrassing.',26124),
(73141,'enUS','','Stare at me like that one more time and I will push you off the side of the boat.',26124),
(73142,'enUS','Googa not actually supposed to be here.  Googa just not sure how to get down.','',26124),
(73143,'enUS','Googa fight one time, but then get a little bit eaten by crocolisk.$b$bEverybody root against Googa.$b$bGooga feel sad because of this.','',26124),
(73144,'enUS','You know Riko?  He good party.','',26124),
(73145,'enUS','','$gHey there, handsome.  You want to go somewhere after this?  Just you and me?:Back off, skank.  I\'m trying to put out a vibe here, and you\'re ruining it.;',26124),
(73146,'enUS','','I\'m done with the brawling ring.  These days, I am looking for a different kind of ring.',26124),
(73147,'enUS','','$gHey there, stranger. I\'d brawl with you any day of the week.  And I promise you, it\'ll last longer than 2 minutes.\n\n<Helga winks disarmingly.>:I saw you making eyes at Harr back there. That tauren is MINE.\n\nWhy don\'t you drag your ugly, gold-digging face to another blimp?;',26124),
(73148,'enUS','Yes! Yes! Yes!','',26124),
(73149,'enUS','My chickens... ATTACK!','',26124),
(73150,'enUS','More chickens! Many more chickens!','',26124),
(73151,'enUS','BRUCE!','BRUCE!',26124),
(73152,'enUS','BRUUUUUUUUCE!','BRUUUUUUUUCE!',26124),
(73153,'enUS','BRUUUUUUUUUUUUCE!','BRUUUUUUUUUUUUCE!',26124),
(73154,'enUS','Come on, Bruce!','Come on, Bruce!',26124),
(73155,'enUS','You got Bruced!','You got Bruced!',26124),
(73156,'enUS','Chomp chomp chomp!','Chomp chomp chomp!',26124),
(73157,'enUS','That\'s my Bruce!','That\'s my Bruce!',26124),
(73158,'enUS','Woo hoo!','Woo hoo!',26124),
(73159,'enUS','Come on Bruce, get it together!','Come on Bruce, get it together!',26124),
(73160,'enUS','You had one job, Bruce. One job!','You had one job, Bruce. One job!',26124),
(73161,'enUS','Noooo!','Noooo!',26124),
(73162,'enUS','Bruce! Why!?!','Bruce! Why!?!',26124),
(73163,'enUS','On it.','',26124),
(73168,'enUS','Doctor FIST!','',26124),
(73169,'enUS','Give em\' the FIST!','',26124),
(73170,'enUS','What did the five fingers say to the face?','',26124),
(73171,'enUS','Drop the hammer!','',26124),
(73172,'enUS','Feel the Iron Grip!','',26124),
(73173,'enUS','Doctor FIST!!','',26124),
(73174,'enUS','Take a dose of pain!','',26124),
(73175,'enUS','Ka-boosh!','',26124),
(73176,'enUS','Boosh!','',26124),
(73177,'enUS','Ka-kow!','',26124),
(73178,'enUS','Ha ha!','',26124),
(73179,'enUS','Boss Bazzelflange wants more people fighting, and she wants \'em fighting better.\n\n\"Incentives!\", she says.  \"We need to give \'em a better reason to brawl!\"\n\nSo she has us build this zeppelin, see. Glorious views of the fight, all the fancy alcohol you can buy, and the satisfaction of bragging to your mates that you can go to a place that they can\'t go to. Y\'see - she only lets you up if you\'re Rank 8 or higher.\n\nYou want to get up on the zep? Keep winning your fights, bucko.','',26124),
(73180,'enUS','Hop onto the teleporter, $n! It probably won\'t kill you!\n\nIt might kill you, though.','',26124),
(73181,'enUS','Sir, these Kor\'kron don\'t seem very friendly!','',26124),
(73182,'enUS','+15 Artifact Bonus!','+15 Artifact Bonus!',26124),
(73183,'enUS','+30 Artifact Bonus!','+30 Artifact Bonus!',26124),
(73184,'enUS','The Alliance have dropped the Horde gold cart!','',26124),
(73185,'enUS','The Alliance have stolen gold from the Horde!','',26124),
(73186,'enUS','Ah, so it\'s a duel you want?  Then a duel you shall have!','',26124),
(73187,'enUS','|TInterface\\Icons\\inv_stone_10.blp:20|t %s Chooses |cFFFF0000Rock|r! You |cFF00FF00Win|r!','',26124),
(73188,'enUS','|TInterface\\Icons\\inv_stone_10.blp:20|t %s Chooses |cFFFF0000Rock|r! You |cFFFF0000Lose|r!','',26124),
(73189,'enUS','|TInterface\\Icons\\inv_stone_10.blp:20|t %s Chooses |cFFFF0000Rock|r! You Tie!','',26124),
(73190,'enUS','','hello $p race $pr class $pc',26124),
(73191,'enUS','Lost... to a CHICKEN!','',26124),
(73192,'enUS','[PH] This fallen orc is dressed in the fashion of the Frostwolf Clan. Perhaps there are more nearby.','',26124),
(73193,'enUS','This is where my agents tracked the Zandalari.','',26124),
(73194,'enUS','I can only imagine what foul business the Zandalari have with them...','',26124),
(73195,'enUS','Yes. This weather is not natural.','',26124),
(73196,'enUS','My champions will go. They will see what can be done, and rescue who they can.','',26124),
(73197,'enUS','It is heartening to see you here, Moira. You have my thanks.','',26124),
(73198,'enUS','...and so you marshaled your personal guard, even without the support of the other clans?','',26124),
(73199,'enUS','Hrmmm. Fare well, Queen Regent.','',26124),
(73200,'enUS','','Shimmer Ridge. I know it well. The Frostmane trolls breed and plot atop that snow-blown mesa.',26124),
(73201,'enUS','','We\'ve lost many mountaineers to this freakish storm, or the trolls slithering about in it.',26124),
(73202,'enUS','','Aye. I am loath to send my men into that. It reeks of ambush and bloody disaster.',26124),
(73203,'enUS','','If they can stop that storm, I\'ll lead the Forgeguard to the top myself.',26124),
(73204,'enUS','','And you have mine, Varian. Your words rang true in the throne room...',26124),
(73205,'enUS','','Indeed. With the aid of your champions, the Dark Irons will put an end to the Zandalari threat in Dun Morogh.',26124),
(73206,'enUS','','I\'ll see you when it\'s done, King of Stormwind.',26124),
(73207,'enUS','Here we are - the ancient seat of pandaren wisdom.$b$bShall we begin?','',26124),
(73208,'enUS','To Yu\'lon, then.','',26124),
(73209,'enUS','Yu\'lon awaits!','Yu\'lon awaits!',26124),
(73210,'enUS','We could smell you tracking us from a league away. If you had not peaked our curiosity you would be dead now.$b$bAs it stands, the way you slew this creature, you have gained our attention.$b$bWhat do you want of us?','',26124),
(73211,'enUS','','We will prove our loyalty - to the Council, Ironforge, and the Alliance - here, today, and with our own blood.',26124),
(73212,'enUS','','The dissension within the Council of Three Hammers must come to an end.',26124),
(73213,'enUS','','Stop whatever wickedness is conjuring up that storm, and the Forgeguard will assault the ridge and wipe out the Frostmane and Zandalari both.$B$BUse my mountaineers and whatever prisoners the trolls have taken to guide your way.',26124),
(73214,'enUS','Find a way to stop that conjured storm, champion, and rescue whatever prisoners you can.$B$BFare you well.','',26124),
(73215,'enUS','What is this that trespasses in my new lair? A pet of the Frostwolves perhaps?','',26124),
(73216,'enUS','Wait, this isn\'t a Frostwolf.','',26124),
(73217,'enUS','Kill it anyway! Let us see how it tastes.','',26124),
(73218,'enUS','There ye are. Here\'s the lay of it: The king\'s spies are dead to a man. Only a handful o\' dwarven scouts are left.','',26124),
(73219,'enUS','The nearest is just ahead. If ye can save him, he may know a thing or two.','',26124),
(73220,'enUS','Once upon a time - moments ago, in fact - a great king sought the help from a trio of powerful dwarves: The Council of Three Hammers.','',26124),
(73221,'enUS','The king\'s scouts had discovered that Zandalari trolls threatened the dwarven capital.','',26124),
(73222,'enUS','Surely, the king thought, if he helped them with their troll problem, they would give him more troops for his campaign against the Horde.','',26124),
(73223,'enUS','But what the king did not realize is that the dwarves did not trust one another!','',26124),
(73224,'enUS','\"We cannot help you,\" said the Bronzebeard dwarf, \"For if we turn our back on the Dark Irons, they will defeat the Wildhammer and take over Ironforge!\"','',26124),
(73225,'enUS','\"We cannot help you,\" said the Wildhammer dwarf. \"For if we turn our back on the Dark Irons, they will defeat the Bronzebeard and take over Ironforge!\"','',26124),
(73226,'enUS','The king was furious. \"If none of you help, then Ironforge will fall under siege!\"','',26124),
(73227,'enUS','Only one dwarf offered to help the king. \"We will lend you our strength,\" said Moira, of the Dark Iron. \"We will trust our dwarven brothers, and we will show them what loyalty means!\"','',26124),
(73228,'enUS','And so Moira and the High King set out into the snow to save the city, leaving the others to think about their actions.','',26124),
(73229,'enUS','What happens next? I must know!','',26124),
(73230,'enUS','The High King, his champions, and the Dark Iron dwarves worked together to save Ironforge.','',26124),
(73231,'enUS','The other dwarven leaders were ashamed of their behavior, and vowed never again to allow fear or distrust to cloud their judgment.','',26124),
(73232,'enUS','And so it was a human king who helped to unite the dwarven clans so long divided.','',26124),
(73233,'enUS','Free to trust one another, all three dwarven leaders pledged their full strength to the Alliance cause.','',26124),
(73234,'enUS','Meanwhile, in the city of Orgrimmar, Warchief Garrosh Hellscream sent goblin dig teams all across the continent of Pandaria.','',26124),
(73235,'enUS','He promised gold and riches to any who could discover for him the hidden secrets of this land that fill Pandaria with such a dark and powerful energy.','',26124),
(73236,'enUS','To my surprise, his people have found something! Right here, in the sacred vale! What will happen now?','',26124),
(73237,'enUS','The story is still being written...','',26124),
(73238,'enUS','So! Even as the Alliance binds itself ever closer together, the Horde is ripping itself apart.','',26124),
(73239,'enUS','My friend, something is about to give. I wish I could experience the next chapter of the story, but alas, I am just the storyteller.','',26124),
(73240,'enUS','You, brave hero - you are strong enough to leap into the center of events as they transpire.','',26124),
(73241,'enUS','Go now! Go to Durotar! Make your mark as history unfurls around you!','',26124),
(73242,'enUS','Thank the laws of physics you\'re here!','',26124),
(73243,'enUS','|TInterface\\Icons\\inv_inscription_scroll.blp:20|t %s Chooses |cFFFF0000Paper|r! You |cFFFF0000Lose|r!','',26124),
(73244,'enUS','|TInterface\\Icons\\inv_inscription_scroll.blp:20|t %s Chooses |cFFFF0000Paper|r! You Tie!','',26124),
(73245,'enUS','|TInterface\\Icons\\inv_inscription_scroll.blp:20|t %s Chooses |cFFFF0000Paper|r! You |cFF00FF00Win|r!','',26124),
(73246,'enUS','|TInterface\\Icons\\inv_sword_102.blp:20|t %s Chooses |cFFFF0000Scissors|r! You |cFFFF0000Lose|r!','',26124),
(73247,'enUS','|TInterface\\Icons\\inv_sword_102.blp:20|t %s Chooses |cFFFF0000Scissors|r! You Tie!','',26124),
(73248,'enUS','|TInterface\\Icons\\inv_sword_102.blp:20|t %s Chooses |cFFFF0000Scissors|r! You |cFF00FF00Win|r!','',26124),
(73249,'enUS','Oh ho ho ho ho! By my beard, I thought I was done for! Oh, thank ye. Thank ye!','',26124),
(73250,'enUS','Oh... right. Now: Did the human king send ye? Oh, his spies are all dead... and most of us are, too.','',26124),
(73251,'enUS','I saw \'em draggin\' Boldbrew, kickin\' and bitin\', towards some hut south o\' here. Now if ye hurry, ye can help her, and she might know more.','',26124),
(73252,'enUS','BUT STAY AWAY FROM THE  BIG VILLAGE! There\'s dozens o\' mad ice trolls in there! Oh, that Zandalari priest has \'em whipped up into a great frenzy.','',26124),
(73253,'enUS','This mouthwatering brew has an almost hypnotic aroma coming from it.','',26124),
(73254,'enUS','','Oh, that was a CLOSE one, thank ye!',26124),
(73255,'enUS','','There\'s only a few of us left; the ones they don\'t eat, they butcher at some big altar.',26124),
(73256,'enUS','','It\'s just northwest o\' here; if ye hurry, ye might be able ta save some! Sorry I don\'t know anythin\' more...',26124),
(73257,'enUS','Not now, $c. I cannot train you today.$b$b<Your trainer\'s voice lowers to a whisper.>$b$bThe Kor\'kron watches our every move. Garrosh has the Valley of Spirits under his thumb.$b$bYou want to help? Find Vol\'jin. He will know what to do.','Not now, $c. I cannot train you today.$b$b<Your trainer\'s voice lowers to a whisper.>$b$bThe Kor\'kron watches our every move. Garrosh has the Valley of Spirits under his thumb.$b$bYou want to help? Find Vol\'jin. He will know what to do.',26124),
(73258,'enUS','Ya need trainin\'?  You picked a real inconvenient time to come pokin\' through the Valley of Spirits.$b$b<Your trainer\'s voice lowers to a whisper.>$b$bThe Kor\'kron watches our every move. Garrosh has the Valley of Spirits under his thumb. I could be killed if they saw me talkin\' to you.$b$bLucky for you, they don\'t ever see me. Lean in close, $n. We gotta keep this on the down low.','',26124),
(73259,'enUS','','Trainin\' services are on temporary hiatus. You wanna learn how to cook? You\'ll have to look somewhere else.',26124),
(73260,'enUS','','No. Not now.',26124),
(73261,'enUS','Sorry, $c. De ink\'s run dry \'round here.','',26124),
(73262,'enUS','There be no fishin\' today. Kor\'kron orders.','',26124),
(73263,'enUS','Not now, $n. The bank\'s been taken over for the time being.$b$bThe Kor\'kron leader said that they won\'t be makin\' any \"unauthorized withdrawals\", but... you might wanna check an\' make sure.','',26124),
(73264,'enUS','','I have no room for you here, $n. The Kor\'kron have taken over my inn as a temporary barracks.',26124),
(73265,'enUS','<Xon\'cha looks nervously over his shoulder.> You\'ll have to go elsewhere if you want to get at your pets, $c. The Kor\'kron be watchin\'.','',26124),
(73266,'enUS','','No auctions today, $r. No auctions for a while, by the look o\' things.',26124),
(73267,'enUS','','Best be takin\' your business elsewhere, $r. Don\'t wanna be causin\' suspicion.',26124),
(73268,'enUS','','No sale today. Too dangerous.',26124),
(73269,'enUS','My snakes, mon. They took my snakes!','',26124),
(73270,'enUS','','I got nothin\' to sell ya today.',26124),
(73271,'enUS','<Huju glances warily over his shoulder.> Not now. Things be gettin\' pretty hot in here lately.','',26124),
(73272,'enUS','You might wanna keep your distance, $c. We on pretty strict Kor\'kron lockdown around here. No knowin\' what might happen.','',26124),
(73273,'enUS','','Sorry, $c. I got nothin\' for ya.',26124),
(73274,'enUS','Filthy monsters! I owe ye me life.','',26124),
(73275,'enUS','Listen: The storm. We figured out what\'s makin\' it. That sneaky Zandalari has these ice trolls makin\' blood sacrifices ta elemental spirits.','',26124),
(73276,'enUS','There\'s a cave, north o\' here, across a bridge. If ye can slay the elemental within, the storm ought ta stop.','',26124),
(73277,'enUS','Queue for A Little Patience.','Queue for A Little Patience.',26124),
(73278,'enUS','Queue for Battle on the High Seas.','Queue for Battle on the High Seas.',26124),
(73279,'enUS','Queue for Blood in the Snow.','Queue for Blood in the Snow.',26124),
(73280,'enUS','Queue for the Secrets of Ragefire.','Queue for the Secrets of Ragefire.',26124),
(73281,'enUS','Queue for Dark Heart of Pandaria.','Queue for Dark Heart of Pandaria.',26124),
(73283,'enUS','','The portals are shut down. I hear the orcs still have a portal to the Blasted Lands open, down in the Cleft o\' Shadow.',26124),
(73284,'enUS','VOL\'JIN LIVES!','',26124),
(73285,'enUS','Vol\'jin lives, me bruddas!','',26124),
(73286,'enUS','Fight de oppression!','',26124),
(73287,'enUS','Rise up against Garrosh Hellscream! Today is de new dawn of de Horde!','',26124),
(73288,'enUS','Argh!','',26124),
(73289,'enUS','$n has been |cFFFF0000|Hspell:141407|h[Frozen Solid]|h|r. Break $ghim:her; free!','',26124),
(73290,'enUS','Hex dem good.','',26124),
(73291,'enUS','Dis\'ll help Bom\'bay\'s Witch Doctorin.','',26124),
(73292,'enUS','Bom\'bay found a volunteer!','',26124),
(73293,'enUS','Dat\'ll fix dem.','',26124),
(73294,'enUS','Troll! What are you still doing in my town?','',26124),
(73295,'enUS','Trainin\' de mages.','',26124),
(73296,'enUS','Hellscream\'s Horde has no need for your voodoo tricks, troll. Now get out of my sight!','',26124),
(73297,'enUS','Ring the gong to accept Yu\'lon\'s Challenge. You need only to overcome one of the four celestial\'s challenges.','',26124),
(73298,'enUS','Ring the Gong [Ranged DPS Challenge]','Ring the Gong [Ranged DPS Challenge]',26124),
(73299,'enUS','Ah, here we are. Oh - oh, these old bones are tired. More than you can imagine.','',26124),
(73300,'enUS','You surprised me. I expected a hero such as yourself to balk at the task of carrying an old man up a mountain. Most are too proud.','',26124),
(73301,'enUS','I was going to teach you a lesson but instead, it is you who have taught me. You see, when I was young... when I was young... when I was young...','',26124),
(73302,'enUS','I was EMPEROR.','',26124),
(73303,'enUS','The realm you see all around you was mine to command.','',26124),
(73304,'enUS','I conquered my doubts, my fears, my anger... I buried all of it within the land.','',26124),
(73305,'enUS','But I held on to one vice. The one sha I never conquered. PRIDE.','',26124),
(73306,'enUS','My pride cloaked this land in mists! I thought we were better than the rest of the world.','',26124),
(73307,'enUS','I thought we could solve our own problems. But for ten thousand years, we stagnated, our doubts and fears buried in the land, rising up to fester whenever we allowed them.','',26124),
(73308,'enUS','Pride. It is the most insidious of sha. It is good until it is bad. And then it is more dangerous than all the others combined.','',26124),
(73309,'enUS','Beware of pride! Be humble! The world is plunging into chaos. Old enemies must work together. Proud races must admit they need help.','',26124),
(73310,'enUS','Things are going to get worse before they get better. Only by working together can we overcome the darkness.','',26124),
(73311,'enUS','All that stands in our way... is pride.','',26124),
(73312,'enUS','Packed up with lumber? Good. Send it up to Orgrimmar.','',26124),
(73313,'enUS','Orgrimmar\'s walls need to be taller! Thicker!','',26124),
(73314,'enUS','No one will question the might of Hellscream\'s Horde!','',26124),
(73315,'enUS','What do we have here? Oil?','',26124),
(73316,'enUS','Send it to Orgrimmar.','',26124),
(73317,'enUS','Fresh meat! Straight from the slaughterhouse. Good.','',26124),
(73318,'enUS','Move it south, to the Valley of Trials. We have hungry young orcs to feed.','',26124),
(73319,'enUS','Excellent, a shipment of stone. Send it to Orgrimmar!','',26124),
(73320,'enUS','Fiery Anger is about to |cFFFF2222|Hspell:141456|h[Detonate]|h|r!','Fiery Anger is about to |cFFFF2222|Hspell:141456|h[Detonate]|h|r!',26124),
(73321,'enUS','Make sure your blades are sharp. We\'ve got enemies to cleave today!','Make sure your blades are sharp. We\'ve got enemies to cleave today!',26124),
(73322,'enUS','Get those blades clean. There\'s troll blood to be spilled today!','Get those blades clean. There\'s troll blood to be spilled today!',26124),
(73323,'enUS','No one disobeys Hellscream!','No one disobeys Hellscream!',26124),
(73324,'enUS','The warchief will hear of our success!','The warchief will hear of our success!',26124),
(73325,'enUS','The warchief will hear of your failure!','The warchief will hear of your failure!',26124),
(73326,'enUS','The Darkspear will know the true price of defiance!','The Darkspear will know the true price of defiance!',26124),
(73327,'enUS','Wipe the Darkspear from the face of Azeroth!','Wipe the Darkspear from the face of Azeroth!',26124),
(73328,'enUS','This village is ours! Death to the trolls!','This village is ours! Death to the trolls!',26124),
(73329,'enUS','I have an ale for every scalp you bring!','I have an ale for every scalp you bring!',26124),
(73330,'enUS','I will cut down anyone I see fleeing from battle. For Garrosh!','I will cut down anyone I see fleeing from battle. For Garrosh!',26124),
(73331,'enUS','Ya want a present?! WELL, MY LEGS DON\'T EVEN WORK!!!','',26124),
(73332,'enUS','ELEC... TRICITY... GREATEST... WEAKNESS...','',26124),
(73333,'enUS','Prepare yourself, hero. Your challenge will begin soon.','',26124),
(73334,'enUS','Dis the kind of trainin Bom\'bay needs.','',26124),
(73335,'enUS','Heya mon.','',26124),
(73336,'enUS','Maybe dey make Bom\'bay full Witch Doctor after dis!','',26124),
(73337,'enUS','Stay away from da voodoo.','',26124),
(73338,'enUS','The spirits have abandoned you.','',26124),
(73339,'enUS','At last! A proper challenge for my power.','',26124),
(73340,'enUS','For the Horde!','',26124),
(73341,'enUS','Ah, a $r. I haven\'t killed one of your kind in a while.','',26124),
(73342,'enUS','Intruders!','Intruders!',26124),
(73343,'enUS','More blood for my axe!','More blood for my axe!',26124),
(73344,'enUS','The Alliance are here!','The Alliance are here!',26124),
(73345,'enUS','We\'re under attack!','We\'re under attack!',26124),
(73346,'enUS','Mok-thora ka!','Mok-thora ka!',26124),
(73347,'enUS','The Alliance are here!','The Alliance are here!',26124),
(73348,'enUS','You can\'t hide from me!','You can\'t hide from me!',26124),
(73349,'enUS','I will feed you to my wolf.','I will feed you to my wolf.',26124),
(73350,'enUS','For the Warchief!','For the Warchief!',26124),
(73351,'enUS','I see you!','I see you!',26124),
(73352,'enUS','Tauren! What have your people done? You have dredged open a scar within our sacred Vale!','',26124),
(73353,'enUS','Lord Zhu, please understand - the orc \"Warchief\" who ordered the deed no longer speaks for the whole of the Horde. Many voices are rising up against him.','',26124),
(73354,'enUS','Your politics are no concern of mine. Your Horde has disrespected the sanctity of this place. You are no longer welcome here - leave at once!','',26124),
(73355,'enUS','Give us time, Lord Zhu. Give us the opportunity to bring Hellscream to justice.','',26124),
(73356,'enUS','Sunwalker, I respect your people. You have aided us in our campaign against the Sha and the Thunder King. Otherwise, I would\'ve already ordered the Shado-Pan to purge this entire shrine. But my patience is at an end. The Horde must leave.','',26124),
(73357,'enUS','Please. Give us time to make this right.','',26124),
(73358,'enUS','Taran Zhu stares grimly into the distance.','',26124),
(73359,'enUS','Very well. You have until season\'s end. No longer.','',26124),
(73360,'enUS','We pandaren are no strangers to dealing with tyrants. The coming battle will try your souls. May the celestials guide your actions.','',26124),
(73361,'enUS','The Warchief demands that this shore is secured! When the Alliance makes its move, the tides will run red with their blood!','',26124),
(73362,'enUS','Have you heard? The traitorous trolls have launched an attack on Razor Hill.','',26124),
(73363,'enUS','Riko got dis beach on lockdown!','',26124),
(73365,'enUS','We may not trust the Alliance, but we need their help if we are to take back the Horde.','',26124),
(73366,'enUS','Very well. Ya earned me trust. I will put me faith in tha Alliance to do tha right ting.','',26124),
(73367,'enUS','The Darkspear and her allies will attack Orgrimmar by land, so that you can attack her by sea. It be the only way.','',26124),
(73368,'enUS','If we survive dis, maybe someday I call you... \"Friend.\"','',26124),
(73369,'enUS','Look at us three. Back to da sands of old Durotar! It be just like old times.','',26124),
(73370,'enUS','Not quite, old friend. Times have changed. The line between friend and foe is not so clear.','',26124),
(73371,'enUS','Dey come! Hellscream tink his own people gonna roll right over.','',26124),
(73372,'enUS','Time ta show dis Warchief da fury of da Darkspear!','',26124),
(73373,'enUS','Hold! Let dem run away. Hellscream will execute dem as cowards if they go back. Sen\'jin Village is safe!','',26124),
(73374,'enUS','Regroup! We press da advantage. Before the Warchief fortifies Razor Hill, we take it for da revolution, an\' close off da road to da Barrens.','',26124),
(73375,'enUS','Anyone who can still fight, come wit\' me!','',26124),
(73376,'enUS','Wait Vol\'jin. Horde is spilling Horde blood. It is tearing me apart.','',26124),
(73377,'enUS','We need ya, mon.','',26124),
(73378,'enUS','I know. I trust you to lead the siege. I am needed elsewhere.','',26124),
(73379,'enUS','I refuse to believe that all of my brethren support Garrosh.','',26124),
(73380,'enUS','You set one foot in Orgrimmar, Hellscream gonna bury a knife in ya neck!','',26124),
(73381,'enUS','I am going to Orgrimmar, alone. Eitrigg, Saurfang, surely they are standing against Garrosh. I must find others.','',26124),
(73382,'enUS','I won\'t hear ya say such tings.','',26124),
(73383,'enUS','It has to be said, Vol\'jin. If we do not make it through this - I want you to know. You have always been my friend. My brother.','',26124),
(73384,'enUS','For da Horde.','',26124),
(73385,'enUS','For the Horde.','',26124),
(73386,'enUS','Darkspear, with me! We ride! No sleep \'til Orgrimmar!','',26124),
(73387,'enUS','The Warchief should\'ve never crossed the Darkspear. He tore the Horde apart.','',26124),
(73388,'enUS','I have trained hundreds of young warriors. The Warchief sheds their blood recklessly. He is no longer MY Warchief.','',26124),
(73389,'enUS','Please - don\'t hurt us! Vol\'jin is welcome to quarter his revolutionaries here.','',26124),
(73390,'enUS','You can turn my steel against the \"Warchief,\" but only against his corrupt soldiers - leave the civilians out of your bloodshed!','',26124),
(73391,'enUS','Ours is the true Horde!','',26124),
(73392,'enUS','YOU are the traitors, here!','',26124),
(73393,'enUS','Vol\'jin and his animals will be put down like the filth they are!','',26124),
(73394,'enUS','It be done! Razor Hill is ours! Da Warchief probably see da fires all the way from Grommash Hold...','',26124),
(73395,'enUS','My floot is good luckydo! You can\'t have it!','',26124),
(73396,'enUS','Vol\'jin - you\'re alive! It is true then - an open rebellion against the Warchief.','',26124),
(73397,'enUS','Baine. We be needin\' ya support. Razor Hill be but an outpost - the walls of Orgrimmar be fortified since da Cataclysm.','',26124),
(73398,'enUS','I must tread carefully. Many of my people are still within Orgrimmar.','',26124),
(73399,'enUS','You should dance for my floot toot!','',26124),
(73400,'enUS','Flooting isn\'t for stoopids.','',26124),
(73401,'enUS','Luckydo, or Luckydon\'t?','',26124),
(73402,'enUS','Only stoopid wants to meet Bad Luckydo.','',26124),
(73403,'enUS','Lor\'themar be ready to strike once he finish wit da Isle of Thunder, and da Banshee Queen need no excuse, but they both across da sea. Without ya strength, we can\'t breech the city. I need tauren arms.','',26124),
(73404,'enUS','We are preparing. I just need time to ensure the safety of my people. But Vol\'jin...','',26124),
(73405,'enUS','Hmm?','',26124),
(73406,'enUS','Garrosh has turned Orgrimmar into a fortress. You may need to seek out allies... beyond the Horde.','',26124),
(73407,'enUS','My, you are strong! When I was young, I might have doubted that we could do this. But now, I have no doubts at all.','',26124),
(73408,'enUS','Such wind! Such cold! Once, it would have filled these old bones with despair. But on this day, I am filled with hope.','',26124),
(73409,'enUS','Heh, do not get angry with the elements. Violence is their nature. I conquered my own anger long, long ago.','',26124),
(73410,'enUS','Such a patient one! When I was young, I would have hated this task. Nowadays, I am filled with love.','',26124),
(73411,'enUS','Do not fear the heights, as I did when I was young. Fear can drive us to terrible deeds. Ah, but I see that like me, you have learned the lessons of courage!','',26124),
(73425,'enUS','Hey there! I\'m a Hydrolizer model two, dash zero or, H2-0 for short.','',26124),
(73426,'enUS','I\'ve been sent here to help you keep Anthracite under control.','',26124),
(73427,'enUS','I come stocked with a complimentary charge of water, you\'ll have to find more if you wish to take advantage of my Hydrolizing feature multiple times.','',26124),
(73428,'enUS','The |cFFFF0000Horde|r has taken control of the Center Mine!','',26124),
(73429,'enUS','Seal the gate, and inform the overseer immediately.','',26124),
(73430,'enUS','All lesser races are enemies of the true Horde!','',26124),
(73431,'enUS','The Alliance has taken control of the Center Mine!','',26124),
(73432,'enUS','The |cFFFF0000Horde|r has lost control of the Center Mine!','',26124),
(73433,'enUS','The Alliance has lost control of the Center Mine!','',26124),
(73434,'enUS','Lei Shi\'s reflection ripples playfully.','',26124),
(73435,'enUS','Lei Shi\'s reflection smiles happily.','',26124),
(73436,'enUS','Lei Shi\'s reflection burbles quietly.','',26124),
(73437,'enUS','This ain\'t in my contract!','This ain\'t in my contract!',26124),
(73438,'enUS','I aint\' gettin\' paid enough for this.','I aint\' gettin\' paid enough for this.',26124),
(73439,'enUS','Sabatoger, eh? Not on my watch!','Sabatoger, eh? Not on my watch!',26124),
(73440,'enUS','Sir, these are Garrosh\'s men.','',26124),
(73441,'enUS','You tryin\' to make me look bad?!','You tryin\' to make me look bad?!',26124),
(73442,'enUS','Alliance are here!','Alliance are here!',26124),
(73443,'enUS','Hey! How\'d you get here?!','Hey! How\'d you get here?!',26124),
(73444,'enUS','Guards! Alliance over here!','Guards! Alliance over here!',26124),
(73445,'enUS','This is bad.','',26124),
(73446,'enUS','All of you fan out and search the chamber. If Garrosh is behind this, we\'re going to need proof.','',26124),
(73447,'enUS','We aren\'t your enemy, Xorenth!','',26124),
(73448,'enUS','These supply crates came from Orgrimmar. What is Garrosh planning to do with so many war supplies?','',26124),
(73449,'enUS','Proto-drake eggs... is Garrosh working with the Dragonmaw? Orcs on proto-drakes sounds bad to me, $p. Very bad.','',26124),
(73450,'enUS','','These are from the dig site in the Vale of Eternal Blossoms. What is Garrosh trying to find there?',26124),
(73451,'enUS','Quickly, $p! We need you over here!','',26124),
(73452,'enUS','You may have stopped the storm, but you cannot stop the will of Zandalar! You will DIE, here... ALL OF YOU!','',26124),
(73453,'enUS','Bleed, in the snow!','',26124),
(73454,'enUS','Trolls of the world will unite against you!','',26124),
(73455,'enUS','We control the sand, the seas, the winds...','',26124),
(73456,'enUS','We will bury you in your mountain!','',26124),
(73457,'enUS','There... will be more! Zandalar... will never fall...','',26124),
(73458,'enUS','','The king\'s champions have done it: The storm has ended! Forward, Dark Irons! TO BATTLE WE MARCH!',26124),
(73459,'enUS','','For Ironforge! FOR THE ALLIANCE!',26124),
(73460,'enUS','','Hearts of fire, wills of iron! Back on your feet! GRIND THEM TO DUST!',26124),
(73461,'enUS','Well fought. I see the Dark Irons are as formidable as ever.','',26124),
(73462,'enUS','Hah! For that, I\'m glad. The Bronzebeards and Wildhammers will regret not having been here to share in your glory.','',26124),
(73463,'enUS','Well, you\'ve done just that. Come; let us return to Ironforge, and announce your victory to the Council.','',26124),
(73464,'enUS','','That they are, King Varian. And at the service of the Alliance, I might add.',26124),
(73465,'enUS','','Better they\'re grateful for the clansmen spared death on this miserable hillock. We sought to protect and impress, not to shame.',26124),
(73466,'enUS','Your eyes fail you yet!','',26124),
(73467,'enUS','Well done!','',26124),
(73468,'enUS','%s cackles ominously.','',26124),
(73469,'enUS','But can you find me again?','',26124),
(73470,'enUS','I am looking forward to this: The White Tiger is the embodiment of strength in Pandaria!','',26124),
(73471,'enUS','$n has assaulted the Pandaren Mine!','',26124),
(73472,'enUS','$n has assaulted the Goblin Mine!','',26124),
(73473,'enUS','$n has defended the Goblin Mine!','',26124),
(73474,'enUS','$n has assaulted the Center Mine!','',26124),
(73475,'enUS','$n has defended the Center Mine!','',26124),
(73476,'enUS','$n has defended the Pandaren Mine!','',26124),
(73477,'enUS','Great White Tiger! Hear our plea.','',26124),
(73478,'enUS','Ah, the young black dragon graces my temple. The deeds of you and your champion are quickly becoming Pandaren legend.','',26124),
(73479,'enUS','My champion and I seek the blessing of your strength.','',26124),
(73480,'enUS','I take great pride in the company I keep.','',26124),
(73481,'enUS','Tell me, young prince: What is the nature of strength?','',26124),
(73482,'enUS','The power to crush one\'s foes. That is strength.','',26124),
(73483,'enUS','You speak only in terms of one\'s enemies.','',26124),
(73484,'enUS','Certainly, strength can benefit one\'s allies.','',26124),
(73485,'enUS','How so?','',26124),
(73486,'enUS','...by using it to crush their enemies!','',26124),
(73487,'enUS','A black dragon, through and through. Very well, I will give you my blessing, but also some advice:','',26124),
(73488,'enUS','Strength used in the service of others is twice as powerful as strength spent on our foes.','',26124),
(73489,'enUS','Now. My challenge, should you accept it, will test your ability to stand right in the face of danger and persevere.','',26124),
(73490,'enUS','|cFFFE1CF7|Hspell:139267|h[Reliquary Pick]|h|r Double artifacts for 15 seconds!','|cFFFE1CF7|Hspell:139267|h[Reliquary Pick]|h|r Double artifacts for 15 seconds!',26124),
(73491,'enUS','Use the [Rapier Parry] ability to avoid Vertical Slash!','',26124),
(73492,'enUS','%s begins to drink a |cFFFF2222|Hspell:141327|h[Volatile Concoction]|h|r.','',26124),
(73493,'enUS','Ring the gong to accept Xuen\'s Challenge. You need only to overcome one of the four celestial\'s challenges.','',26124),
(73494,'enUS','Ring the Gong [Melee DPS Challenge]','Ring the Gong [Melee DPS Challenge]',26124),
(73495,'enUS','Can you open this, Ticker?','',26124),
(73496,'enUS','I\'ve been saving this for a special occasion.','',26124),
(73497,'enUS','I\'ve got just the thing!','',26124),
(73498,'enUS','A mantid bomb?! Are you sure that won\'t bring down the whole cavern?','',26124),
(73499,'enUS','We\'ll need to make a few modifications, but it will get the job done.','',26124),
(73500,'enUS','Recruit, bring me that pool pony, three cannon balls, two batteries, and some of that proto-drake egg yolk.','',26124),
(73501,'enUS','You heard the goblin, $p. Get to work!','',26124),
(73504,'enUS','Wait? They put this here? Who would put this here? Whoever it is should feel bad about themselves.','Wait? They put this here? Who would put this here? Whoever it is should feel bad about themselves.',26124),
(73505,'enUS','\"Put the real bolts in,\" he says. \"The kind that won\'t get us killed,\" he says. Bah.','\"Put the real bolts in,\" he says. \"The kind that won\'t get us killed,\" he says. Bah.',26124),
(73506,'enUS','Huh, I hope someone figured out how to make this thing move.','Huh, I hope someone figured out how to make this thing move.',26124),
(73507,'enUS','These orc designs are okay. They just need more bombs.','These orc designs are okay. They just need more bombs.',26124),
(73508,'enUS','Let the challenge begin! Hero, you must defeat the Black Prince in close-quarters combat.','',26124),
(73509,'enUS','You, Wrathion, will be blindfolded.','',26124),
(73510,'enUS','Black Prince, you are very strong. But what good is strength without the vision to guide it?','',26124),
(73511,'enUS','Begin!','',26124),
(73512,'enUS','Wait - that\'s absurd. I would annihilate my own champion!','',26124),
(73513,'enUS','... interesting. But the outcome is unlikely to change.','',26124),
(73514,'enUS','Very well. I am sorry, champion - But I will not be the one learning a lesson today.','',26124),
(73515,'enUS','We need more oil! How many times do I have to tell you peons!','We need more oil! How many times do I have to tell you peons!',26124),
(73516,'enUS','%s mutters to himself as he ties the blindfold.','',26124),
(73517,'enUS','A blind dragon. Ridiculous!','',26124),
(73518,'enUS','Seek out your true enemy! Do not be fooled by his false images!','',26124),
(73519,'enUS','The dragon is stronger than you, hero! Do not let him finish his attacks!','',26124),
(73520,'enUS','Come on! You people are laborers! You are supposed to be laboring!','Come on! You people are laborers! You are supposed to be laboring!',26124),
(73521,'enUS','Is this all the explosives we got? I\'ve made boots with more explosives than this.','Is this all the explosives we got? I\'ve made boots with more explosives than this.',26124),
(73522,'enUS','Disarm him if you can. Use every advantage.','',26124),
(73523,'enUS','Stay behind your foe. He cannot see you! Move quickly!','',26124),
(73524,'enUS','Here we are, the home of Niuzao, the Black Ox. He is the patron spirit of Pandaren fortitude, the only celestial who chooses to live beyond the wall.','',26124),
(73525,'enUS','Mighty Black Ox! Hear our plea.','',26124),
(73526,'enUS','My champion and I seek your blessing of fortitude.','',26124),
(73527,'enUS','The strength to overcome any hardship! This is fortitude.','',26124),
(73528,'enUS','You mean to say - physical strength is developed without, but fortitude comes from within?','',26124),
(73529,'enUS','...Sure. I knew that.','',26124),
(73530,'enUS','So enters the dragon, and his mortal champion. You are welcome here.','',26124),
(73531,'enUS','Tell me, Black Prince: What is the nature of fortitude?','',26124),
(73532,'enUS','You confuse strength with fortitude, young dragon. But power is worthless without spirit!','',26124),
(73533,'enUS','I have seen humble slaves endure unimaginable torture, only to rise up and overthrow their masters.','',26124),
(73534,'enUS','And I have seen the mightiest of emperors laid low by the perseverance of the smallest of enemies.','',26124),
(73535,'enUS','Precisely!','',26124),
(73536,'enUS','Of course you did. We will put your understanding to the test.','',26124),
(73537,'enUS','My challenge, if you accept it, will test your champion\'s ability to defend and protect while enduring terrible hardship.','',26124),
(73538,'enUS','Dodge his attacks. Use his strength against him!','',26124),
(73539,'enUS','The elements will not die! Make use of your time before they rise again!','',26124),
(73540,'enUS','The Alliance gold cart is now full and can be stolen from their base!','',26124),
(73541,'enUS','The Horde gold cart is now full and can be stolen from their base!','',26124),
(73542,'enUS','What was that?','What was that?',26124),
(73543,'enUS','We\'re under attack!','We\'re under attack!',26124),
(73544,'enUS','Ring the gong to accept Niuzao\'s Challenge. You need only to overcome one of the four celestial\'s challenges.','',26124),
(73545,'enUS','Ring the Gong [Defense Challenge]','Ring the Gong [Defense Challenge]',26124),
(73546,'enUS','We may not trust the Alliance, but we need their help if we are to take back the Horde.','',26124),
(73547,'enUS','%s runs to reload his |cFFFF2222|Hspell:141381|h[Shotgun]|h|r.','',26124),
(73548,'enUS','$n has taken the Alliance gold cart!','',26124),
(73549,'enUS','$n has taken the Horde gold cart!','',26124),
(73550,'enUS','The Red Crane of Hope has inspired the citizens of Pandaria from the very dawn of history. I very much want to speak with him.','',26124),
(73551,'enUS','Great Red Crane! Hear our plea.','',26124),
(73552,'enUS','My champion and I seek your blessing of hope.','',26124),
(73553,'enUS','Hope is... a belief in a better tomorrow.','',26124),
(73554,'enUS','...Great Crane. You have not seen what I have seen.','',26124),
(73555,'enUS','... the fires that once burned the sky will return. It is inevitable. The Burning Legion WILL find Azeroth.','',26124),
(73556,'enUS','Seas of blood, cities in ruin! Who are we - one divided world - to stand against a legion?','',26124),
(73557,'enUS','You speak of hope. Believe me, the thinnest sliver of belief that we might somehow survive the coming devastation is all that sustains me.','',26124),
(73558,'enUS','... thank you, Great Crane.','',26124),
(73559,'enUS','My my, the child of the Worldbreaker, proof that none are beyond redemption. I am honored by your visit.','',26124),
(73560,'enUS','Tell me, son of the Earth-Warder: What is the nature of hope?','',26124),
(73561,'enUS','You speak, but doubt your own words.','',26124),
(73562,'enUS','You underestimate me.','',26124),
(73563,'enUS','Rise, son of Deathwing. I will give you my blessing, for you need it more than any I have ever met.','',26124),
(73564,'enUS','I challenge you not to think of hope as a vague and unimaginable future.','',26124),
(73565,'enUS','Live EVERY day with hope in your heart. In doing so, you CREATE the future you dream of.','',26124),
(73566,'enUS','My challenge, if you accept it, tasks you with healing the most grievous of wounds.','',26124),
(73567,'enUS','Ring the gong to accept Chi-Ji\'s  Challenge. You need only to overcome one of the four celestial\'s challenges.','',26124),
(73568,'enUS','Ring the Gong [Healing Challenge]','Ring the Gong [Healing Challenge]',26124),
(73569,'enUS','A Horde caravan needs to be escorted from the Grol\'dom Farm to Far Watch Post.','',26124),
(73570,'enUS','A Horde caravan needs to be escorted from Southern Barrens to the Crossroads.','',26124),
(73571,'enUS','A Horde caravan needs to be escorted from Ratchet to the Crossroads.','',26124),
(73572,'enUS','A Horde caravan needs to be escorted from the Sludge Fen to Durotar.','',26124),
(73573,'enUS','A Horde caravan needs to be escorted from Stonetalon Mountains to the Crossroads.','',26124),
(73574,'enUS','A Horde caravan needs to be escorted out of the Dry Hills.','',26124),
(73575,'enUS','A Horde caravan needs to be escorted out of Wailing Caverns.','',26124),
(73576,'enUS','A Horde caravan needs to be escorted out of the Stagnant Oasis.','',26124),
(73577,'enUS','A Horde caravan has been destroyed.','',26124),
(73579,'enUS','Time\'s runnin\' out!','',26124),
(73580,'enUS','Hurry up with those artifacts!','',26124),
(73581,'enUS','Get moving - something ain\'t right about this place.','',26124),
(73582,'enUS','Hands off - you don\'t what that thing is!','',26124),
(73583,'enUS','Just what in the name of all that is unholy was that thing?','',26124),
(73584,'enUS','Oh don\'t you worry none, I don\'t think anyone wants to touch that thing again.  I\'ll collect our money and we are outta here.','',26124),
(73585,'enUS','Hey hey, what is this, huh?  This is barely a fifth of the promised payment!','',26124),
(73586,'enUS','Naw naw naw, see there\'s a contract.  Payment in full is req-','',26124),
(73587,'enUS','Yeah, we\'ll see who\'s got Garrosh\'s back when it counts.','',26124),
(73588,'enUS','Oh yeah, hey no nothing your, uh, your hugeness.  Uh, for the Horde, and all that...  Bye!','',26124),
(73589,'enUS','Containment failure.  Active defense matrix enabled.','',26124),
(73590,'enUS','Security breach.  All safety protocols disabled.','',26124),
(73591,'enUS','Power units activated.','',26124),
(73592,'enUS','Maximum power achieved.','',26124),
(73593,'enUS','A mere toy left by the usurper... you, too, are dust.','',26124),
(73594,'enUS','My blood hungers.','',26124),
(73595,'enUS','I feast on your suffering.','',26124),
(73596,'enUS','Your agony rejuvenates me.','',26124),
(73597,'enUS','Release... me...','',26124),
(73598,'enUS','Your hatred strengthens me!','',26124),
(73599,'enUS','Oh, such... exquisite... pain!','',26124),
(73600,'enUS','I only sleep.','',26124),
(73601,'enUS','Step aside goblin.  This artifact is exactly what the warchief hoped to find here.  I am taking it under Kor\'kron protection.','',26124),
(73602,'enUS','You are paid for all workers present, foreman.  The warchief does not compensate the dead.','',26124),
(73603,'enUS','THIS.  This is what has diluted the vitality of our precious Horde!','',26124),
(73604,'enUS','The warchief graciously permits the families of the dead to live in his city.  To die in the service of the Horde should be a great honor, but you see it as another opportunity to line your filthy pockets!','',26124),
(73605,'enUS','Your kind DISGUSTS me.  Small.  Weak.  Honorless as thieves.  Be thankful the warchief still tolerates your presence at all.','',26124),
(73606,'enUS','What was that, goblin?','',26124),
(73607,'enUS','%s prepares a massive |cFFFF2222|Hspell:141187|h[Vertical Strike]|h|r.','',26124),
(73608,'enUS','Ours is the true Horde!','Ours is the true Horde!',26124),
(73609,'enUS','YOU are the traitors here!','YOU are the traitors here!',26124),
(73610,'enUS','Darkspear animals will be put down like the filth they are!','Darkspear animals will be put down like the filth they are!',26124),
(73611,'enUS','For Hellscream!','For Hellscream!',26124),
(73612,'enUS','The Darkspear never deserved to be part of the Horde!','The Darkspear never deserved to be part of the Horde!',26124),
(73613,'enUS','I\'ll bring Garrosh your head!','I\'ll bring Garrosh your head!',26124),
(73614,'enUS','You betrayed the Warchief!','You betrayed the Warchief!',26124),
(73615,'enUS','All who conspire with the Darkspear face punishment by death!','All who conspire with the Darkspear face punishment by death!',26124),
(73616,'enUS','The Rapier has fallen to the ground.  Pick it up to engage Admiral Hagman!','The Rapier has fallen to the ground.  Pick it up to engage Admiral Hagman!',26124),
(73617,'enUS','The Warchief should\'ve never crossed the Darkspear. He tore the Horde apart.','',26124),
(73618,'enUS','Please - don\'t hurt us! Vol\'jin is welcome to quarter his revolutionaries here.','',26124),
(73619,'enUS','You gonna pay for what ya done to me raptors!','',26124),
(73620,'enUS','I have trained hundreds of young warriors. The Warchief sheds their blood recklessly. He is no longer MY Warchief.','',26124),
(73621,'enUS','You can turn my steel against the \"Warchief,\" but only against his corrupt soldiers - leave the civilians out of your bloodshed!','',26124),
(73622,'enUS','Follow ol\' Bom\'bay! He know de way!','',26124),
(73623,'enUS','A Kor\'kron shipment of lumber has been overturned!','',26124),
(73624,'enUS','A Kor\'kron shipment of oil has been overturned!','',26124),
(73625,'enUS','A Kor\'kron shipment of meat has been overturned!','',26124),
(73626,'enUS','A Kor\'kron shipment of stone has been overturned!','',26124),
(73627,'enUS','That\'s exactly what we needed!','',26124),
(73628,'enUS','Careful! This isn\'t a toy!','',26124),
(73629,'enUS','This may be my greatest work yet!','',26124),
(73630,'enUS','You carried that with your hands?! Uh... you should probably see a medic when we get back...','',26124),
(73631,'enUS','Ah, this is exactly the $r I was hoping for.','',26124),
(73632,'enUS','I think you misunderstand my brother, Go\'el.  He is not the type to be convinced by a stranger. Especially one so small.','',26124),
(73633,'enUS','Don\'t worry, this $c is far more than $ghe:she; first seems. Your brother values strength, and $p possesses that in abundance.','',26124),
(73634,'enUS','$p, I was hoping you might aid me yet again. The Frostwolf clan is divided. Many are here, under Durotan\'s command, but many of their strongest warriors traveled into the desert months ago, lead by Durotan\'s brother, Ga\'nar.','',26124),
(73635,'enUS','The Frostwolf clan needs to be reunited if it is going to stand strong against the Iron Horde. We need Ga\'nar and his warriors to return.','',26124),
(73636,'enUS','We\'ve had no contact with Ga\'nar or his exiles for sometime, but I suspect they are in the north.','',26124),
(73637,'enUS','I must warn you though, Ga\'nar and his warriors did not leave on good terms, and are not likely to welcome you with open arms. I think what Go\'el is asking of you may not even be possible.','',26124),
(73638,'enUS','I leave that for you to decide.  Go now and prove me wrong.','',26124),
(73639,'enUS','The most important ingredient!','',26124),
(73640,'enUS','This should give us enough power to disable the stabilization matrix.','',26124),
(73641,'enUS','Just a little more power...','',26124),
(73642,'enUS','','Disable?!',26124),
(73643,'enUS','My masterpiece is finished!','',26124),
(73644,'enUS','It\'s... it\'s beautiful!','',26124),
(73645,'enUS','','What the heck is the pool pony for?',26124),
(73646,'enUS','Don\'t question my genius!','',26124),
(73647,'enUS','I don\'t care what it\'s for! Is it going to get this door open?','',26124),
(73648,'enUS','The longer we spend standing here the sooner Garrosh\'s men are going to find us.','',26124),
(73649,'enUS','This thing could open Gallywix\'s personal safe!','',26124),
(73650,'enUS','Once the detonator goes off in... err... NOW!','',26124),
(73651,'enUS','If you do not engage in combat soon, you will forfeit!','',26124),
(73652,'enUS','','The Warchief won\'t be pleased. He is wasting valuable troops fending off their pathetic rebellion.',26124),
(73653,'enUS','','I was not expecting this many troops...',26124),
(73654,'enUS','','I\'ve been in the middle of a few messes in my day, but this is ridiculous!',26124),
(73655,'enUS','','We just need to stay focused on our mission so we can get out of here in one piece.',26124),
(73656,'enUS','Can you re-stealth me?','Can you re-stealth me?',26124),
(73657,'enUS','Very good - lay down your weapons!','',26124),
(73658,'enUS','I hope now you understand the limits of strength without vision. It is one thing to change the world, but quite another to do what is right.','',26124),
(73659,'enUS','Young prince, I hope you take this lesson to heart.','',26124),
(73660,'enUS','PAH! A lopsided challenge.','',26124),
(73661,'enUS','I am pleased that our hero is still alive. Thank you for your blessing, mighty tiger.','',26124),
(73662,'enUS','Just as I expected. Do you want to give it another go?','',26124),
(73663,'enUS','That is enough.','',26124),
(73664,'enUS','Champion, turn your foe\'s strength and confidence against him. I believe in you.','',26124),
(73665,'enUS','cautiously rolls the old pirate dice. The dice tumble resulting in |cFFFF2222|Hspell:141967|h[Snake eyes]|h|r.','cautiously rolls the old pirate dice. The dice tumble resulting in |cFFFF2222|Hspell:141967|h[Snake eyes]|h|r.',26124),
(73666,'enUS','Urtharges calls on the aid of an elemental!','',26124),
(73667,'enUS','','Ticker?! Wake up!',26124),
(73668,'enUS','That door didn\'t even budge...','',26124),
(73669,'enUS','Warn us a little sooner next time!','',26124),
(73670,'enUS','%s begins to cast |cFFFF2222|Hspell:136473|h[Counter Shot]|h|r at $n.','',26124),
(73671,'enUS','Help!','',26124),
(73672,'enUS','I\'m on fire!','',26124),
(73673,'enUS','Calm down! I\'d hardly call that a fire!','',26124),
(73674,'enUS','Is he still alive, Newt?','',26124),
(73675,'enUS','','Barely. He needs a medic and soon!',26124),
(73676,'enUS','Grit quit goofing around!','',26124),
(73677,'enUS','Grit, setup the emergency teleporter! We need to report this to Vol\'jin immediately.','',26124),
(73678,'enUS','Right away, Sir!','',26124),
(73679,'enUS','You will never escape these caverns!','',26124),
(73680,'enUS','The true Horde, the pure Horde, cannot be stopped!','',26124),
(73681,'enUS','All of Azeroth will run red with the blood of the lesser races.','',26124),
(73682,'enUS','Destroy them! FOR THE HORDE!','',26124),
(73683,'enUS','Recruits, you\'re the only ones left that can fight!','',26124),
(73684,'enUS','Defend us until the teleporter is ready!','',26124),
(73685,'enUS','|cFFFF0000|Hspell:141387|h[Urtharges\' Shield]|h|r has been broken!','',26124),
(73686,'enUS','These crates bear the mark of the Kor\'kron. Various weapons and other war supplies lay strewn about the cavern. From the looks of things, Garrosh is planning an invasion.','',26124),
(73687,'enUS','%s has put a |cFFFF2222|Hspell:132998|h[Sticky Bomb]|h|r on you!','',26124),
(73688,'enUS','Young proto-drake eggs line the cavern floor. Many recently hatched eggs fill the surrounding area. With this many proto-drakes, no place would be safe from Garrosh\'s invasion.','',26124),
(73689,'enUS','Many artifacts lay here, seemingly discarded. Most appear to have come from Garrosh\'s dig site in the Vale of Eternal Blossoms. Whatever he is trying to find, it does not appear to be among these forgotten relics.','',26124),
(73690,'enUS','Vol\'jin jabs his spear into the ground, saying nothing.','',26124),
(73691,'enUS','You will pay for this!','You will pay for this!',26124),
(73692,'enUS','The Warchief will have your blood!','The Warchief will have your blood!',26124),
(73693,'enUS','I curse the Darkspear!','I curse the Darkspear!',26124),
(73694,'enUS','Not like this...','Not like this...',26124),
(73695,'enUS','Traitor!','Traitor!',26124),
(73696,'enUS','I die for Hellscream!','I die for Hellscream!',26124),
(73697,'enUS','You will never defeat the Kor\'kron!','You will never defeat the Kor\'kron!',26124),
(73698,'enUS','I regret nothing!','I regret nothing!',26124),
(73699,'enUS','Da people have spoken!','Da people have spoken!',26124),
(73700,'enUS','Ya won\'t take de Horde from us!','Ya won\'t take de Horde from us!',26124),
(73701,'enUS','Vol\'jin lives!','Vol\'jin lives!',26124),
(73702,'enUS','Down wit de Kor\'kron!','Down wit de Kor\'kron!',26124),
(73703,'enUS','Hellscream will fall!','Hellscream will fall!',26124),
(73704,'enUS','We be takin\' out de trash!','We be takin\' out de trash!',26124),
(73705,'enUS','For Vol\'jin!','For Vol\'jin!',26124),
(73706,'enUS','We been idle too long!','We been idle too long!',26124),
(73707,'enUS','Gob Squad, defend yourselves!','',26124),
(73708,'enUS','The Crazy Sapper activates the bomb strapped to its chest!','',26124),
(73709,'enUS','Start Basic Damage (Silver)','Start Basic Damage (Silver)',26124),
(73710,'enUS','Start Basic Damage (Gold)','Start Basic Damage (Gold)',26124),
(73711,'enUS','Start Basic Damage (Endless)','Start Basic Damage (Endless)',26124),
(73712,'enUS','Lesser? We\'ll show you who\'s lesser!','',26124),
(73713,'enUS','','Found any rare cards lately? Bring them to me, and I\'ll add them to the collection.',26124),
(73714,'enUS','I\'d like to purchase a challenge card.','I\'d like to purchase a challenge card.',26124),
(73715,'enUS','','He doesn\'t need blades or magic to defeat his enemies. Our next challenger, Hexos, fights his foes with the powers of GEOMETRY!',26124),
(73716,'enUS','','He may be a huge chicken, but he\'ll still put up a fight. It\'s Tyson Sanders!',26124),
(73717,'enUS','','He\'s got two modes. Both modes are labeled \"KILL\". Let\'s hear it for T440!',26124),
(73718,'enUS','','Hope you all like your brawlers extra-crispy! Here comes Anthracite!!',26124),
(73719,'enUS','','What\'s better than an explosion? Lots and lots of explosions! In this corner, we have Big Badda Boom!!',26124),
(73720,'enUS','','Aww... look at the cute little snake, Nibbleh! Go ahead, let him nibble on your toes. Let\'s see what happens.',26124),
(73721,'enUS','','He\'s not a real doctor, but he\'s going to attempt some facial reconstruction surgery. On his next opponent. Welcome, Doctor FIST!',26124),
(73722,'enUS','','Dust off that luckydo, because you\'re gonna need it. It\'s Grandpa Grumplefloot!',26124),
(73723,'enUS','','No introduction could possibly do our challengers justice. Feast your eyes on the Bear and the Lady Fair!',26124),
(73724,'enUS','','Throw down your weapon and pick up your gloves. It\'s time for a good old-fashioned boxing match. Prepare to be floored by Ty\'thar!',26124),
(73725,'enUS','','He\'s probably the most deadly brawler we\'ve ever had here at the Brawl\'gar Arena. Unfortunately, he\'s a little out of his element. Everybody raise your glass for Razorgrin!',26124),
(73726,'enUS','','Brawl\'gar veterans may remember Blat, the self-replicating ooze. Today, we meet his meaner, uglier, older sister: Splat!',26124),
(73727,'enUS','','What\'s this? Bruce is back! A better, faster, stronger Bruce! It\'s MECHA-BRUCE!!!',26124),
(73728,'enUS','','He\'s a strategic mastermind, and he doesn\'t even have a head. Or an elbow, even. It\'s Ro-Shambo! Let\'s give him a hand!',26124),
(73729,'enUS','','Ever wonder what we do with all our obsolete robots? We send them to their deaths in bloody gladiatorial arenas, of course! Here comes Blingtron 3000!',26124),
(73730,'enUS','','He\'s never seen an opponent that he wouldn\'t fight. Ah, small correction: he\'s never seen an opponent. He\'s the Blind Hero!',26124),
(73731,'enUS','It is good to see you, my friend. So much is transpiring it is hard for a Lorewalker like myself to keep up. I have seen many things through my dream brew, but we will need a hero such as yourself to help write this next chapter of our history.','',26124),
(73732,'enUS','This mouthwatering brew has an almost hypnotic aroma coming from it.$b$b(Scenarios require item level 425 or greater.)','',26124),
(73733,'enUS','Great Jade Serpent! Hear our plea.','',26124),
(73734,'enUS','My champion and I seek the blessing of your wisdom.','',26124),
(73735,'enUS','|cff6600aaLegacy Challengers:|r\n  Dungeon Master Vishas: $7369w-$7370w\n  Crush: $7387w-$7388w\n  Deeken: $7405w-$7406w\n  Fjoll: $7399w-$7400w\n  Leona Earthwind: $7423w-$7424w\n  T440 Dual-Mode Robot: $8028w-$8027w\n  Hexos: $7871w-$7872w\n  Anthracite: $8030w-$8029w\n  Epicus Maximus: $7385w-$7386w\n  Disruptron: $7417w-$7418w\n  Millhouse Manastorm: $7401w-$7402w\n  Zen\'shar: $7409w-$7410w','',26124),
(73736,'enUS','|cff6600aaSpecial Challengers:|r\n  Grandpa Grumplefloot: $8040w-$8039w\n  Master Boom Boom: $8044w-$8043w\n  Ty\'thar: $8046w-$8045w\n  Razorgrin: $8048w-$8047w\n  Splat: $8050w-$8049w\n  Dippy & Doopy: $8054w-$8053w\n  Mecha-Bruce: $8052w-$8051w\n  Blingtron 3000: $8058w-$8057w\n  Ro-Shambo: $8056w-$8055w\n  The Bear and the Lady Fair: $8042w-$8041w\n  Mingus Diggs: $8060w-$8059w\n  Blind Hero: $8062w-$8061w','',26124),
(73737,'enUS','','',26124),
(73738,'enUS','|cff6600aaLegacy Challengers:|r\n  Dungeon Master Vishas: $7433w-$7434w\n  Crush: $7451w-$7452w\n  Leona Earthwind: $7487w-$7488w\n  Deeken: $7469w-$7470w\n  Fjoll: $7463w-$7464w\n  T440 Dual-Mode Robot: $8068w-$8067w\n  Hexos: $8064w-$8063w\n  Anthracite: $8070w-$8069w\n  Epicus Maximus: $7385w-$7386w\n  Disruptron: $7417w-$7418w\n  Millhouse Manastorm: $7401w-$7402w\n  Zen\'shar: $7409w-$7410w','',26124),
(73739,'enUS','|cff6600aaSpecial Challengers:|r\n  Grandpa Grumplefloot: $8080w-$8079w\n  Master Boom Boom: $8084w-$8083w\n  Ty\'thar: $8086w-$8085w\n  Razorgrin: $8088w-$8087w\n  Splat: $8090w-$8089w\n  Dippy & Doopy: $8094w-$8093w\n  The Bear and the Lady Fair: $8082w-$8081w\n  Blingtron 3000: $8098w-$8097w\n  Ro-Shambo: $8096w-$8095w\n  Mecha-Bruce: $8092w-$8091w\n  Mingus Diggs: $8100w-$8099w\n  Blind Hero: $8102w-$8101w','',26124),
(73740,'enUS','','',26124),
(73741,'enUS','View records for legacy challengers.','View records for legacy challengers.',26124),
(73742,'enUS','View records for special challengers.','View records for special challengers.',26124),
(73743,'enUS','View records for Special Challengers (Page 2).','View records for Special Challengers (Page 2).',26124),
(73744,'enUS','$gHe\'s:She\'s; one of our veteran Rank 9 brawlers here in the Brawlpub. It\'s $n!','$gHe\'s:She\'s; one of our veteran Rank 9 brawlers here in Brawl\'gar. It\'s $n!',26124),
(73745,'enUS','Nothing can stop our Rank 10 champion brawler, $N!','Nothing can stop our Rank 10 champion brawler, $N!',26124),
(73746,'enUS','To do what is right, no matter the cost. That is wisdom.','',26124),
(73747,'enUS','When is it ever wise not to act for the greater good?','',26124),
(73748,'enUS','','Ah, the dragon child and the hero. Together you will achieve great things.',26124),
(73749,'enUS','','Tell me, dragon child: What is the nature of wisdom?',26124),
(73750,'enUS','','Spoken like a true child of the Aspects. Always seeking to change the world.',26124),
(73751,'enUS','','But true wisdom comes from KNOWING what is right. And sometimes, DOING nothing at all.',26124),
(73752,'enUS','','To learn THAT is to learn true wisdom.',26124),
(73753,'enUS','','Come forward! I will give you my blessing.',26124),
(73754,'enUS','','My challenge, if you accept it, will test your cunning and footwork even in the midst of life-threatening danger.',26124),
(73755,'enUS','cautiously rolls the old pirate dice. The dice tumble resulting in a 3, afflicting him with |cFFFF2222|Hspell:141962|h[Scurvy]|h|r.','cautiously rolls the old pirate dice. The dice tumble resulting in a 3, afflicting her with |cFFFF2222|Hspell:141962|h[Scurvy]|h|r.',26124),
(73756,'enUS','cautiously rolls the old pirate dice. The dice tumble resulting in a 4, and a group of skeleton pirates ambush him!','cautiously rolls the old pirate dice. The dice tumble resulting in a 4, and a group of skeleton pirates ambush her!',26124),
(73757,'enUS','cautiously rolls the old pirate dice. The dice tumble resulting in a 5, afflicting him with |cFFFF2222|Hspell:142037|h[Black Mark]|h|r.','cautiously rolls the old pirate dice. The dice tumble resulting in a 5, afflicting her with |cFFFF2222|Hspell:142037|h[Black Mark]|h|r.',26124),
(73758,'enUS','cautiously rolls the old pirate dice. The dice tumble resulting in a 6, causing a |cFFFF2222|Hspell:142058|h[Cannon Barrage]|h|r.','cautiously rolls the old pirate dice. The dice tumble resulting in a 6, causing a |cFFFF2222|Hspell:142058|h[Cannon Barrage]|h|r.',26124),
(73759,'enUS','cautiously rolls the old pirate dice. The dice tumble resulting in a 7. Nothing happens.','cautiously rolls the old pirate dice. The dice tumble resulting in a 7. Nothing happens.',26124),
(73760,'enUS','cautiously rolls the old pirate dice. The dice tumble resulting in an 8, granting him |cFF3366FF|Hspell:141968|h[Pirate\'s Boon]|h|r.','cautiously rolls the old pirate dice. The dice tumble resulting in an 8, granting her |cFF3366FF|Hspell:141968|h[Pirate\'s Boon]|h|r.',26124),
(73761,'enUS','cautiously rolls the old pirate dice. The dice tumble resulting in a 9, granting him |cFF3366FF|Hspell:142107|h[Thick Skin]|h|r.','cautiously rolls the old pirate dice. The dice tumble resulting in a 9, granting her |cFF3366FF|Hspell:142107|h[Thick Skin]|h|r.',26124),
(73762,'enUS','cautiously rolls the old pirate dice. The dice tumble resulting in a 10, and a skeleton pirate comes to aid him in battle!','cautiously rolls the old pirate dice. The dice tumble resulting in a 10, and a skeleton pirate comes to aid her in battle!',26124),
(73763,'enUS','cautiously rolls the old pirate dice. The dice tumble resulting in an 11, granting him |cFF3366FF|Hspell:142061|h[Cursed Pirate Dice]|h|r.','cautiously rolls the old pirate dice. The dice tumble resulting in an 11, granting her |cFF3366FF|Hspell:142061|h[Cursed Pirate Dice]|h|r.',26124),
(73764,'enUS','cautiously rolls the old pirate dice. The dice tumble resulting in a 12, granting his whole crew |cFF3366FF|Hspell:142140|h[Pirate\'s Life]|h|r.','cautiously rolls the old pirate dice. The dice tumble resulting in a 12, granting her whole crew |cFF3366FF|Hspell:142140|h[Pirate\'s Life]|h|r.',26124),
(73765,'enUS','','Let the challenge begin! Hero, you must defeat the Black Prince in combat.',26124),
(73766,'enUS','','You, my dark prince, will be blindfolded.',26124),
(73767,'enUS','','We will demonstrate the limits of power without vision to guide it.',26124),
(73768,'enUS','','Begin!',26124),
(73770,'enUS','','Use movement to your advantage. Do not allow the dragon child to get close.',26124),
(73771,'enUS','','Be aware of your surroundings.',26124),
(73772,'enUS','','Do not allow the elements to engage you!',26124),
(73773,'enUS','The legendary power of the Titans is mine to command!','',26124),
(73774,'enUS','Stand still! I am trying to kill you here!','',26124),
(73775,'enUS','Where did you go? Come back.','',26124),
(73776,'enUS','Ahhh.... Hah!','',26124),
(73777,'enUS','You\'re lucky I\'m not one of those green dragons that can see with their eyes closed.','',26124),
(73778,'enUS','Just as I expected. Did you want to give it another go?','',26124),
(73779,'enUS','','That is enough!',26124),
(73780,'enUS','','Champion, predict your foe\'s movements, and always stay a step ahead. Victory is within you!',26124),
(73781,'enUS','','Very good - that is enough!',26124),
(73782,'enUS','PAH! A lopsided challenge.','',26124),
(73783,'enUS','','Do you see? Power without vision causes only random chaos and destruction.',26124),
(73784,'enUS','I am pleased that our hero is still alive. Thank you for your blessing, great serpent.','',26124),
(73785,'enUS','Let the challenge begin! Hero, you must keep the Black Prince alive with your skills as a healer.','',26124),
(73786,'enUS','Are you certain? You are filled with doubts and fears, young Prince.','',26124),
(73787,'enUS','You have not fully reconciled with your past. Now is the time.','',26124),
(73788,'enUS','Your champion will keep you alive. Begin!','',26124),
(73789,'enUS','I\'m a black dragon. I won\'t need any help.','',26124),
(73790,'enUS','What - wait - father!?','',26124),
(73791,'enUS','Please - don\'t make me do this.','',26124),
(73792,'enUS','I shall tear this world apart!','',26124),
(73793,'enUS','Heal the prince, but do not forget to keep yourself alive!','',26124),
(73794,'enUS','Do not miss any opportunity to heal the Black Prince.','',26124),
(73795,'enUS','The veil of shadows has lifted!','',26124),
(73796,'enUS','Keep moving. Your foe is dangerous, but you are smarter.','',26124),
(73797,'enUS','Use the blood of the world to regenerate yourself. You can do this.','',26124),
(73798,'enUS','The elements are undying! Make use of your time before they rise again!','',26124),
(73799,'enUS','Be not afraid of his traps, champion. Your healing is more powerful than his magic!','',26124),
(73800,'enUS','Your tenacity is admirable, but pointless!','',26124),
(73801,'enUS','Your efforts are insignificant!','',26124),
(73802,'enUS','There is no shelter from my fury!','',26124),
(73803,'enUS','Your armor means nothing. Your faith, even less!','',26124),
(73804,'enUS','Enough! Make it stop!','',26124),
(73805,'enUS','Very well. The test is over.','',26124),
(73806,'enUS','But, do not give into despair. You have the spirit to overcome this. Try again - I believe in you!','',26124),
(73807,'enUS','Very good! You have done it!','',26124),
(73808,'enUS','Do not despair, young prince. You are not your father.','',26124),
(73809,'enUS','More importantly, your champion would not let you fall. Do you see? With the support of friends, nothing is impossible.','',26124),
(73810,'enUS','Such... madness...','',26124),
(73811,'enUS','I understand. Thank you, great Crane.','',26124),
(73812,'enUS','Let the challenge begin! Hero, you must defend the Black Prince while he faces his inner turmoil.','',26124),
(73813,'enUS','Is that so? You are filled with doubts and fears, young Prince.','',26124),
(73814,'enUS','Face your inner demons. Now is the time.','',26124),
(73815,'enUS','Your champion will defend you. Begin!','',26124),
(73816,'enUS','I\'m a black dragon. I won\'t need any help.','',26124),
(73817,'enUS','What - wait - father!?','',26124),
(73818,'enUS','Please - don\'t make me do this.','',26124),
(73819,'enUS','The elements will not die! Make use of your time before they rise again!','',26124),
(73820,'enUS','Control the combat. Pay attention to ALL of your foes.','',26124),
(73821,'enUS','Use the battlefield to regenerate yourself.','',26124),
(73822,'enUS','Protect the Black Prince! Distract his enemies!','',26124),
(73823,'enUS','Do not allow your foe to complete his attack.','',26124),
(73824,'enUS','You must sacrifice yourself to keep the dragon child from falling!','',26124),
(73825,'enUS','So be it. The test is over.','',26124),
(73826,'enUS','Remember: You are never defeated until you decide to remain so. Those with true fortitude always rise whenever they fall.','',26124),
(73827,'enUS','Try again - I know you can defeat this challenge!','',26124),
(73828,'enUS','You have friends. Your champion did not allow you to fall. Take this lesson to heart.','',26124),
(73829,'enUS','You are stronger than your father, young prince.','',26124),
(73830,'enUS','Well done! You have triumphed!','',26124),
(73831,'enUS','I understand. Thank you, mighty Ox.','',26124),
(73832,'enUS','The Alliance gold cart was returned to its base by $n!','',26124),
(73833,'enUS','The Alliance gold cart has been returned to their base!','',26124),
(73834,'enUS','The Horde gold cart was returned to its base by $n!','',26124),
(73835,'enUS','%s readies a |cFFFF0000|Hspell:142111|h[Disrupting Bellow]|h|r!','%s readies a |cFFFF0000|Hspell:142111|h[Disrupting Bellow]|h|r!',26124),
(73836,'enUS','The Alliance gold cart was returned to its base!','',26124),
(73837,'enUS','The Horde gold cart was returned to its base!','',26124),
(73838,'enUS','Fools! The true Horde cannot be stopped by the likes of you.','',26124),
(73839,'enUS','The teleporter is ready! Let\'s get out of here!','',26124),
(73840,'enUS','Dem Kor\'kron be gatherin\'.','Dem Kor\'kron be gatherin\'.',26124),
(73841,'enUS','Soon we gonna\' be seein\' dem Kor\'kron rollin\' up over da hills.','Soon we gonna\' be seein\' dem Kor\'kron rollin\' up over da hills.',26124),
(73842,'enUS','Ya gonna\' be helpin\' us, $c?','Ya gonna\' be helpin\' us, $c?',26124),
(73843,'enUS','Ya here to join da revolution, mon?','Ya here to join da revolution, mon?',26124),
(73844,'enUS','Welcome to da\' revolution.','Welcome to da\' revolution.',26124),
(73845,'enUS','Dem Kor\'kron not be catchin\' us off guard dis time.','Dem Kor\'kron not be catchin\' us off guard dis time.',26124),
(73846,'enUS','Some of me best friends be orcs. Dis\' be a bad time.','Some of me best friends be orcs. Dis\' be a bad time.',26124),
(73847,'enUS','We Darkspear gonna\' be ready.','We Darkspear gonna\' be ready.',26124),
(73848,'enUS','Ya been invaluable to the revolution, mon. We be armin\' up now.','Ya been invaluable to the revolution, mon. We be armin\' up now.',26124),
(73849,'enUS','I was certain we would find you impaled on its stinger...','',26124),
(73850,'enUS','I know why you\'ve come to the northern wastes, curr.  I should gut you and leave you here for the scavengers as a message to my feeble brother.','',26124),
(73851,'enUS','But I have a more important message that you will deliver for me.','',26124),
(73852,'enUS','My men and I prepare to ride to gron grotto, to unleash our fury upon the gron there.','',26124),
(73853,'enUS','If you can prove your strength by subduing a frost wolf, you will be allowed to ride with us, and bear witness.','',26124),
(73854,'enUS','We can speak about my fledgling brother\'s request once this task is done.','',26124),
(73855,'enUS','Durotan claims himself a leader.  He wears the title, and fools the clan into following him.','',26124),
(73856,'enUS','But Durotan is weak and impotent. He lacks the strength to lead the Frostwolves.','',26124),
(73857,'enUS','He led us to this northern home of ours early in the season, fleeing the new orc clans in Nagrand.  He inflicts cowardice upon our people.','',26124),
(73858,'enUS','He wastes the food of our people on his sickly wife, Drakka, rather than sending her out into the cold, as is custom for the weak.','',26124),
(73859,'enUS','He refuses to lead our warriors against the gron and avenge our father\'s death, saying we can\'t spare the men.','',26124),
(73860,'enUS','At every turn, Durotan shows his weakness, and spits on the strength of our ancestors.','',26124),
(73861,'enUS','We ride now to avenge my father, and remind the entire Frostwolf clan how a true warchief behaves.','',26124),
(73862,'enUS','You will witness these acts, and should you somehow live, you will tell my brother and his clan what I have done this day.','',26124),
(73863,'enUS','The Thunderlord clan.  My scouts informed me of their presence here in the oasis, blocking our way to the grotto.','',26124),
(73864,'enUS','We will call out their leader and put his head on a pike, and then we will slaughter any that remain in our way.','',26124),
(73865,'enUS','Show yourself, Graktul!  I am challenge you here, in front of your men.  I will show them the color of your innards!','',26124),
(73866,'enUS','I spit on your corpse, orc.  You are weak!','',26124),
(73867,'enUS','Slaughter them all, men!  Leave no Thunderlord alive!','',26124),
(73868,'enUS','The strongest of the Frostwolf clan come here when they wish to prove themselves as leaders.  They bring warriors of their choosing, and return to the clan with the head of a freshly slain gron.','',26124),
(73869,'enUS','My father lead such a group here to kill the ancient gron, Kolloc, but none of them returned.','',26124),
(73870,'enUS','I will finish what my father started this day, and I will heft his spear and shield in his memory.  I will remind the clan how a true Frostwolf warchief behaves.','',26124),
(73871,'enUS','Ya be callin\' dat a grip on your weapon? Any Kor\'kron worth \'is hide will have dat ting disarmed in a pinch.','',26124),
(73872,'enUS','You\'re alive.  I\'ll take that as a good sign.','',26124),
(73873,'enUS','We be facin\' da Kor\'kron. Deh be da meanest, baddest orcs deh\' Horde have ever seen. Ya betta\' not be sleepin\' through \'dis trainin\'.','',26124),
(73874,'enUS','Remembah! Kor\'kron axes gotta\' hit you wit\' their blade. Ya maces ain\'t got dat kinda limitation.','',26124),
(73875,'enUS','SPAWN ACTION','',26124),
(73876,'enUS','Meet me at the coliseum.  You\'ve played an important role in this.  You deserve to see the results.','',26124),
(73877,'enUS','You call \'dat a battlecry? We be startin\' a revolution. Roar like ya already won and deh\' other side just not figured it out yet.','',26124),
(73878,'enUS','Everyone out before more of them show up!','',26124),
(73879,'enUS','I\'ll defend until the last goblin is out! See you all at the rendezvous!','',26124),
(73880,'enUS','','Seek out your true enemy! Do not be fooled by his false images!',26124),
(73881,'enUS','','The elements are undying! Make use of your time before they rise again!',26124),
(73882,'enUS','','Please, young prince. Take this lesson to heart.',26124),
(73883,'enUS','Avast, these Alliance scallywags have made their way onto our ship.  Take care of them!','',26124),
(73884,'enUS','%s hands you a climbing rope.','',26124),
(73885,'enUS','Walk wit\' me, $c. Vol\'jin be seein\' ya in just a moment.','',26124),
(73886,'enUS','De \"Warchief\" still believes Vol\'jin be dead, slain by his Kor\'kron assassin in Kun-Lai Summit.','',26124),
(73887,'enUS','Vol\'jin survived, but he still remember da sting a\' Hellscream\'s betrayal. Darkspear never die.','',26124),
(73888,'enUS','When Vol\'jin come back ta us, I saw he was changed. Da light a\' revolution be burnin\' in his eyes!','',26124),
(73889,'enUS','Now, look around you. De Darkspear rebellion begins. Hellscream\'s worst nightmare.','',26124),
(73890,'enUS','De spark becomes a flame, de flame becomes a fire, de fire... an inferno. We gonna burn our way ta da gates a\' Orgrimmar.','',26124),
(73891,'enUS','But we gotta feed dis war machine. Stone, wood, oil, meat - we be needin\' \'em in large supply.','',26124),
(73892,'enUS','Dat\'s where we need you, $Gbruddah:sistah;.','',26124),
(73893,'enUS','Go, speak to Vol\'jin. Prepare yourself. From here on out, we be askin\' more of you den ever before.','',26124),
(73894,'enUS','The Horde are coming aboard!  Get up to the deck and help fend them off!','',26124),
(73895,'enUS','It is a risk I have to take. But if I am killed, please watch over Aggra and my boy.','',26124),
(73896,'enUS','','You did good, $n. Looks like trouble is brewing within the Horde. Garrosh has a full-scale troll rebellion on his hands.',26124),
(73897,'enUS','So the rumors are true? Vol\'jin is alive and out for Garrosh\'s blood?','',26124),
(73898,'enUS','','Yes. This is just the opportunity the Alliance needs. We\'ll use the trolls as a diversion while the main Alliance fleet assembles. You get what I\'m saying, Sully?',26124),
(73899,'enUS','Wait a minute! Are you suggestin\' that we help Vol\'jin?','',26124),
(73900,'enUS','','Vol\'jin is backed into a corner. With our aid, he\'ll be the spear that breaks open Hellscream\'s fortress. Let our enemies weaken one another, while we wait in the wings for our chance to strike.',26124),
(73901,'enUS','That\'s my girl, fanning the flames! I like it. Now, which one o\' us is brave enough ta pay a little visit to tha Darkspear?','',26124),
(73902,'enUS','Not it!','',26124),
(73903,'enUS','Look mon, Alliance filth washed up from Theramore. Kill it!','',26124),
(73904,'enUS','','Wait! Lower ya weapons. I know of dis one.',26124),
(73905,'enUS','','Tell Vol\'jin I bring an ambassador from de Alliance.',26124),
(73906,'enUS','','Walk wit\' me, $r.',26124),
(73907,'enUS','','Keep ya hands where we can see \'em. Everybody be jumpy. We be in a war here, a war against de Warchief hisself.',26124),
(73908,'enUS','','Hellscream already try ta have Vol\'jin killed. Heh. Ain\'t so easy ta kill a troll.',26124),
(73909,'enUS','','What he did? He woke de fury a\' de Darkspear tribe.',26124),
(73910,'enUS','','Hellscream thought Vol\'jin dead, \'til Vol\'jin show up at Sen\'jin Village. Den de Warchief try to crush de rebellion, but we was waitin\' for \'im. We fought back de Kor\'kron at Sen\'jin, and den we took Razor Hill, hah, right under de Warchief\'s nose!',26124),
(73911,'enUS','','We turn eyes now ta de final prize - Orgrimmar.',26124),
(73912,'enUS','','De Alliance want a second front on Orgrimmar? We can do dat. You can help. We be needin\' resources: Stone. Wood. Oil. Meat. Only den can we move on da city.',26124),
(73913,'enUS','','Dis ain\'t a task for da weak-hearted, stranger. But if ya help us, maybe Vol\'jin begin ta trust ya. Either way ya weaken de Warchief\'s grasp on his own lands. Tink a soft-skinned Alliance can do it? Ahahahahaaa!',26124),
(73914,'enUS','|TInterface\\Icons\\ability_deathknight_remorselesswinters:20|t%s summons a |cFFF00000|Hspell:142320|h[Glacial Freeze Totem]|h|r!','',26124),
(73915,'enUS','|TInterface\\Icons\\spell_fire_windsofwoe:20|t%s begins to cast |cFFF00000|Hspell:142306|h[Ruined Earth]|h|r!','',26124),
(73916,'enUS','We have done it, hero! We have the blessings of the celestials, and we have completed their challenge.','',26124),
(73917,'enUS','I know our next step. Meet me back atop Mason\'s Folly - you\'ll be pleasantly surprised at what I have in store for you!','',26124),
(73918,'enUS','Hey hey hey! You lookin\' fer some fast travel to the Barrens?','',26124),
(73919,'enUS','You need ta go somewhere? As long as that somewhere is Ratchet, I\'ve got yer fast track right here!','',26124),
(73920,'enUS','Never had an unsatisfied customer! Try Chatterswitch Travels today!','',26124),
(73921,'enUS','My state of the art teleporter will take you straight to the Northern Barrens. Whaddaya say?','',26124),
(73922,'enUS','I\'d like to travel to Ratchet.','I\'d like to travel to Ratchet.',26124),
(73923,'enUS','All right, step right up, $r. Right up there on the teleporter.','',26124),
(73924,'enUS','Go, go, go! Get on that teleporter. Got lotsa customers today, so hurry it up!','',26124),
(73925,'enUS','Step onto that teleporter. Ratchet, comin\' right up!','',26124),
(73926,'enUS','Garrosh\'s goons didn\'t like that I kept working with trolls.','Garrosh\'s goons didn\'t like that I kept working with trolls.',26124),
(73927,'enUS','The Warchief is caging all the dissidents. Even us orcs!','The Warchief is caging all the dissidents. Even us orcs!',26124),
(73928,'enUS','I never thought Garrosh would turn against orcs!','I never thought Garrosh would turn against orcs!',26124),
(73929,'enUS','Now I see why the Darkspear are fighting back!','Now I see why the Darkspear are fighting back!',26124),
(73930,'enUS','Use your body to shield Wrathion from the incoming attacks!','',26124),
(73931,'enUS','The Jade Serpent is the incarnation of wisdom in Pandaria. Let\'s see what she has to say.','',26124),
(73932,'enUS','Taunt the Vision of Deathwing when he fixates on Wrathion!','',26124),
(73933,'enUS','Minions, destroy these insects!','',26124),
(73934,'enUS','You already had that artifact!  Combo chain restarted...','You already had that artifact!  Combo chain restarted...',26124),
(73935,'enUS','11','',26124),
(73936,'enUS','12','',26124),
(73937,'enUS','13','',26124),
(73938,'enUS','14','',26124),
(73939,'enUS','15','',26124),
(73940,'enUS','These Horde dogs are swinging aboard.  Fend them off!','',26124),
(73941,'enUS','These Alliance pigs are swinging aboard.  Fend them off!','',26124),
(73942,'enUS','These ruffians are swinging aboard to steal our treasure.  Fend them off!','',26124),
(73943,'enUS','More are coming aboard.  Hold \'em off!','',26124),
(73944,'enUS','Enemy Lieutenant coming aboard, fend him off!','',26124),
(73945,'enUS','Not so fast...','',26124),
(73946,'enUS','En Garde!','',26124),
(73947,'enUS','FIRE!','',26124),
(73948,'enUS','We\'ve pushed them back to their ship.  Swing over and steal their explosives to blow it to smithereens!','',26124),
(73949,'enUS','That\'ll teach \'em!  Now hop in that cannon and converge on their lead ship!','',26124),
(73950,'enUS','Watch out!','',26124),
(73951,'enUS','Fire in the hole!','',26124),
(73952,'enUS','I\'m out!','',26124),
(73953,'enUS','Let\'s see how this works!','',26124),
(73954,'enUS','Avast, these Horde scallywags have made their way onto our ship.  Take care of them!','',26124),
(73955,'enUS','Avast, these scallywags have made their way onto our ship.  Take care of them!','',26124),
(73956,'enUS','We were working on this wall here and... well, I don\'t even remember.  Who are you, anyhow?  Where\'s Gearslip?','',26124),
(73957,'enUS','Everything is fine.  Look, there\'s too much to explain...','Everything is fine.  Look, there\'s too much to explain...',26124),
(73958,'enUS','It\'s all clear then?','',26124),
(73959,'enUS','That was some explosion!  Let\'s check it out.','',26124),
(73960,'enUS','It looks like some sort of gigantic chest... probably full of gold.  And it\'s all ours!','',26124),
(73961,'enUS','What... what\'s going on?  Somethin\'... in... my head...','',26124),
(73962,'enUS','Ahhhhhhhhhhhh!','',26124),
(73963,'enUS','I\'ll be destitute if I don\'t recover my losses from this disaster.','',26124),
(73964,'enUS','Help a goblin out and grab some of them fancy artifacts.  Meanwhile, my guys will clear the entrance to the mine.','',26124),
(73965,'enUS','No time to waste... let\'s blow this wall to pieces!','',26124),
(73966,'enUS','','Ya not gonna be foolin\' ol\' Zen\'tabra with dat cat disguise. I be rememberin\' dis, $r.',26124),
(73967,'enUS','Now\'s your chance to escape. Make a run for it!','Now\'s your chance to escape. Make a run for it!',26124),
(73968,'enUS','','De Alliance willing to help da Darkspear? Never thought I would live to see de day.',26124),
(73969,'enUS','','My thanks, $r. I won\'t be forgettin\' dis.',26124),
(73970,'enUS','Wrathion falls breathlessly to the ground in defeat!','',26124),
(73971,'enUS','An Alliance caravan needs to be escorted out of the Dry Hills.','',26124),
(73972,'enUS','Intruders have been spotted! Defend the Thunder Forge!','',26124),
(73973,'enUS','The Thunder Forge is ours!  We will defend it with our lives!','',26124),
(73974,'enUS','Laz Madwire calls in Crazy Sappers!','',26124),
(73975,'enUS','An Alliance caravan needs to be escorted out of the Forgotten Pools.','',26124),
(73976,'enUS','An Alliance caravan needs to be escorted off of Dreadmist Peak.','',26124),
(73977,'enUS','An Alliance caravan needs to be escorted out of the Sludge Fen.','',26124),
(73978,'enUS','An Alliance caravan needs to be escorted out of the Forgotten Pools.','',26124),
(73979,'enUS','An Alliance caravan needs to be escorted out of the Wailing Caverns.','',26124),
(73980,'enUS','An Alliance caravan needs to be escorted out of the Stagnant Oasis.','',26124),
(73981,'enUS','An Alliance caravan needs to be escorted out of Thorn Hill.','',26124),
(73982,'enUS','An Alliance caravan has been destroyed.','',26124),
(73983,'enUS','De Darkspear will never give up!','De Darkspear will never give up!',26124),
(73984,'enUS','Vol\'jin lives!','Vol\'jin lives!',26124),
(73985,'enUS','De Darkspear will be your end!','De Darkspear will be your end!',26124),
(73986,'enUS','Garrosh will pay!','Garrosh will pay!',26124),
(73987,'enUS','Dis is only da beginning!','Dis is only da beginning!',26124),
(73988,'enUS','De Darkspear is gonna destroy Garrosh!','De Darkspear is gonna destroy Garrosh!',26124),
(73989,'enUS','The Vision of Deathwing fixates on Wrathion, heal him!','',26124),
(73990,'enUS','A Kor\'kron commander has appeared on the battlefield.','A Kor\'kron commander has appeared on the battlefield.',26124),
(73991,'enUS','De spirits be restless.','',26124),
(73992,'enUS','<The stench around Vol\'jin\'s makeshift revolutionary camp is intolerable. The troll leader allows you to speak first, while his guards eye you warily.>','',26124),
(73993,'enUS','Why are the Darkspear in rebellion against Garrosh?','Why are the Darkspear in rebellion against Garrosh?',26124),
(73994,'enUS','What about Hellscream? What does the Horde mean to him?','What about Hellscream? What does the Horde mean to him?',26124),
(73995,'enUS','Why should we help you? What if we kept the Barrens supplies for ourselves?','Why should we help you? What if we kept the Barrens supplies for ourselves?',26124),
(73996,'enUS','<Vol\'jin twists his face into a scowl.>$b$bYa wouldn\'t understand. What\'s de Horde ta ya, $r? Hm? Diseased? Alien? Betrayers? Demon-blooded? Beasts? I know what ya say \'bout us.$b$bI\'ll tell ya what de Horde is. De Horde dat me an\' Thrall built. It be a family. When de whole world try ta put us down, de family come an\' pick us back up.$b$bHellscream, he don\'t see family. Ain\'t never had one.','',26124),
(73997,'enUS','For him, Horde be about orcs, an\' buildin\' up orc power. Like he just come through de portal. Anyone stand in his way, anyone tink any diff\'rent, he shut \'em up.$b$b<Vol\'jin runs his three-fingered hand across his scar.>$b$bHe like an angry dog. Oh, I fight next to Hellscream in battle, sure. But put him in charge? Ya askin\' for trouble. He pick his favorites, start his war, shove me bruddahs aside... He don\'t tink he need nobody else. Well, he wrong.$b$bHe gonna learn: ya never cross family.','',26124),
(73998,'enUS','<Vol\'jin cackles, the stench of his hot breath reeking in your nostrils.>$b$bOh, ya got anudda plan? I got anudda plan, too. I let ya siege Orgrimmar on ya own. See how far ya get. An\' once da city be filled wit\' corpses, den me shadow hunters come in, we mop up what left, kill Kor\'kron an\' Alliance alike. Give ya dead ta Sylvanas. Hmm! I save a lot a Darkspear lives wit\' dis plan!$B$BMmnn? You don\'t like? Then, we stay wit\' da first plan. We work together.$b$bWe don\'t even have ta like each other.','',26124),
(73999,'enUS','What happened to you in Pandaria?','What happened to you in Pandaria?',26124),
(74000,'enUS','Does Garrosh know you\'re alive?','Does Garrosh know you\'re alive?',26124),
(74001,'enUS','Why are you fighting against our own Warchief?','Why are you fighting against our own Warchief?',26124),
(74002,'enUS','How do you see the Horde?','How do you see the Horde?',26124),
(74003,'enUS','<Vol\'jin runs his three-fingered hand over his scar.>$b$bIt been a long road, friend. Garrosh tried ta take me life wit\' a knife in de throat. Left me for dead. I crawl out dat cave, couldn\'t even speak. It was Chen Stormstout who found me, nursed me back from de brink.$b$bWe travelled to de Shado-Pan monastery, an\' dey help me do some soul-searching. Figure out who I was. Who de Horde was. Me father...$b$bI made up me mind. I\'m takin\' de Horde back. No matter de cost.$b$bDarkspear never die.','',26124),
(74004,'enUS','<Vol\'jin allows a grim smile to creep across his scowling features.>$b$bNot yet he don\'t. Maybe he hearin\' rumors. Maybe he thinkin\', dey ghost stories. Maybe ol\' Vol\'jin comin\' back ta haunt him. Hah.$b$bHe find out soon enough. Too bad I\'m not gonna be there ta see da look on his fat, beady-eyed face when he hears ol\' Vol\'jin is back, an\' gonna make good on me promise. Ta end his sad little reign. Ta fire de arrow dat pierces his black heart.','',26124),
(74005,'enUS','Ya still call him \"Warchief,\" $c? Is he still YOUR Warchief? What of de spoils of his war? I don\'t see you fat an\' happy like his Kor\'kron. His Horde be an orc Horde. Do ya still feel welcome here, $r? Are ya a part of his plan? Or are ya trash he gonna do away wit\' once he has his way? He promise glory, but bathes our Horde in blood, an\' steps on anyone who see it diff\'rent.$b$bYa wanna know how I see de Horde? De Horde dat me an\' Thrall built?','',26124),
(74006,'enUS','Horde be a family. When de whole world try ta put us down, de family come an\' pick us back up. We all each other got, see?$b$bHellscream, he don\'t see family. Ain\'t never had one. All he see is power, like he just come through the portal.$b$b<Vol\'jin stares off into the distance.>$b$bWe stand against him - together, here, now - or he stomp us out. One. By. One. I got de scars ta prove it.$b$bWho do ya trust, $n? Where be your loyalty now? Hellscream? Or family?','',26124),
(74007,'enUS','Ya still call him \"Warchief,\" $c? Is he still YOUR Warchief? What of de spoils of his war? I don\'t see you fat an\' happy like his Kor\'kron.$b$bLook, ya be an orc, maybe ya don\'t see it. Da ghettos in Orgrimmar. De way he talk \'bout de other races. De way he use \'em like cannon fodder. Are ya one of de chosen few, $n? Or are ya disposable, like de rest of us? De trash he throw away once he get his monstrous way. He promise glory but bathes our Horde in blood.$b$bMe an\' Thrall, we see a diff\'rent Horde.','',26124),
(74008,'enUS','Years ago, I helped put the Horde together on these very sands. My... how times have changed.','',26124),
(74009,'enUS','What are you doing here, Chen Stormstout?','What are you doing here, Chen Stormstout?',26124),
(74010,'enUS','$n! So strange to see you here, far from the green forests of Pandaria.$b$bWhen I first sailed away from the Wandering Isle, years ago, this ragged shore was one of the first places I visited. Ahh! The air still smells the same!$b$bBut times have changed. Back then I helped Thrall, Vol\'jin, Rexxar and Rokhan to lay the foundation of Orgrimmar. Today, I hardly recognize the place.$b$b<Chen\'s face falls.>$b$BSo much needless bloodshed. I just don\'t understand. Has Pandaria taught us nothing?','',26124),
(74011,'enUS','Wrathion is blindfolded, so attack from behind for bonus damage!','',26124),
(74012,'enUS','Ya\' better stay away, chumps. No one hassles the Hoff!','',26124),
(74013,'enUS','MUGG! Get over here! The Hoff\'s under attack!','',26124),
(74014,'enUS','Hoff... out...','',26124),
(74015,'enUS','You aren\'t gonna off the Hoff!','',26124),
(74016,'enUS','It\'s ROCKET TIME, ladies! Come and get it!','',26124),
(74017,'enUS','Oh, that was a bad move, buddy. A baaaaad move.','',26124),
(74018,'enUS','I will meet you at each of the four shrines, champion.','',26124),
(74019,'enUS','Remember, we must visit all four, but we only need to complete ONE of the four challenges.','',26124),
(74020,'enUS','Choose the challenge most appropriate for your unique talents.','',26124),
(74021,'enUS','Good luck!','',26124),
(74022,'enUS','BAM! BOOM! A-hahahahaha!','',26124),
(74023,'enUS','$n picked up the Alliance gold cart!','',26124),
(74024,'enUS','$n picked up the Horde gold cart!','',26124),
(74025,'enUS','Stand still! I am trying to kill you here!','',26124),
(74026,'enUS','Ahhh... Hah!','',26124),
(74027,'enUS','Where did you go? Come back!','',26124),
(74028,'enUS','Proto-Drake Whelps hatch from the nearby eggs!','',26124),
(74029,'enUS','Ashes! Smoking craters! AHAHAHAHA!','',26124),
(74030,'enUS','Looks like my fuse... went out...','',26124),
(74031,'enUS','My boys may not be the brightest, but we can take all of you on!','',26124),
(74032,'enUS','Bombs away!','',26124),
(74033,'enUS','Couldn\'t deal with our explosive tempers, huh?!','',26124),
(74034,'enUS','DEATH FROM ABOVE!','',26124),
(74035,'enUS','Blown... to... bits...','',26124),
(74036,'enUS','Blood and thunder! Challengers, your death comes for you!','',26124),
(74037,'enUS','Ha! A challenge?!','',26124),
(74038,'enUS','Dodge this!','',26124),
(74039,'enUS','How sad. I expected more.','',26124),
(74040,'enUS','At last, a worthy opponent.','',26124),
(74041,'enUS','Smell blood. Puny fleas afraid to fight.','',26124),
(74042,'enUS','This one. Should be fun kill.','',26124),
(74043,'enUS','Heart will stop!','',26124),
(74044,'enUS','Dead. Happy.','',26124),
(74045,'enUS','Sleep... finally...','',26124),
(74046,'enUS','Back to work, you pathetic grunts! A bunch of rebels and Alliance weaklings aren\'t going to stop us!','',26124),
(74047,'enUS','You might have gotten past the weaklings. You aren\'t gonna get past me.','',26124),
(74048,'enUS','Let it rain!','',26124),
(74049,'enUS','Weak. How predictable.','',26124),
(74050,'enUS','How could you... have beaten me?','',26124),
(74051,'enUS','I will crush any who oppose the Warchief!','',26124),
(74052,'enUS','Enemies! SMASH!','',26124),
(74053,'enUS','I will flatten you!','',26124),
(74054,'enUS','Nothing stands against me.','',26124),
(74055,'enUS','I failed...','',26124),
(74056,'enUS','','Watch your back...',26124),
(74057,'enUS','','How foolish.',26124),
(74058,'enUS','','Hope you like pain.',26124),
(74059,'enUS','','Hmph. Too easy.',26124),
(74060,'enUS','','No!',26124),
(74061,'enUS','Aheh... heh... heh...','',26124),
(74062,'enUS','Mwahahaha!','',26124),
(74063,'enUS','Eee ya ha ha ha!','',26124),
(74064,'enUS','Mmmmmmm...','',26124),
(74065,'enUS','Ha... ha...','',26124),
(74066,'enUS','','This world will burn before the might of the Warchief!',26124),
(74067,'enUS','','More kindling for the fire.',26124),
(74068,'enUS','','Don\'t get burned...',26124),
(74069,'enUS','','Mmm, the smell of charred flesh...',26124),
(74070,'enUS','','Ash... to ash...',26124),
(74071,'enUS','','I speak, and the oceans tremble. Fear me, enemies of Hellscream.',26124),
(74072,'enUS','','I will wash you to sea.',26124),
(74073,'enUS','','The currents bow to me!',26124),
(74074,'enUS','','Drown in your own failure.',26124),
(74075,'enUS','','I wash away...',26124),
(74076,'enUS','The earth shall swallow you!','',26124),
(74077,'enUS','These ones wish to return to the earth...','',26124),
(74078,'enUS','RISE!','',26124),
(74079,'enUS','Return to the earth, weaklings.','',26124),
(74080,'enUS','I... am no longer...','',26124),
(74081,'enUS','We\'ll cover ye from the brush: Point out a target, and we\'ll open fire.','',26124),
(74082,'enUS','Core Spiders appear from the lava!','',26124),
(74083,'enUS','|cFF0000FFQueue for Blood in the Snow.|r','|cFF0000FFQueue for Blood in the Snow.|r',26124),
(74084,'enUS','|cFF0000FFQueue for Dark Heart of Pandaria.|r','|cFF0000FFQueue for Dark Heart of Pandaria.|r',26124),
(74085,'enUS','Deadeye Kail sticks to his guns.','',26124),
(74086,'enUS','Why are you and Sully out here?','Why are you and Sully out here?',26124),
(74087,'enUS','','The High King has no intention of letting Garrosh continue his mad campaign. It is costing too many innocent lives.$b$bWe are here to look for vulnerabilities in Orgrimmar\'s defenses. The sort of vulnerabilities that an Alliance army could take advantage of.$b$bUnfortunately, it looks like Garrosh has not been idle. He has stepped up recruitment of Kor\'kron and turned them into a full-fledged war machine.',26124),
(74088,'enUS','','They used to be an elite band of orcs created to serve the Warchief as protectors and enforcers of his command.$b$bNow they are an army of incredibly well trained destroyers. Garrosh\'s personal legion.',26124),
(74089,'enUS','What are the Kor\'kron?','What are the Kor\'kron?',26124),
(74090,'enUS','This ol\' cloaking chicken better not fail. She\'s been actin\' up lately.','',26124),
(74091,'enUS','Tell me again about the King and the Council...','Tell me again about the King and the Council...',26124),
(74092,'enUS','I think I saw trolls being carted off in chains. Why would orcs be cartin\' trolls off in chains?','',26124),
(74093,'enUS','Sittin\' in the middle of enemy forces with not much more than this cloaking chicken protectin\' us. This has become my new normal!','',26124),
(74094,'enUS','Tell me again about the Warchief and the Darkness...','Tell me again about the Warchief and the Darkness...',26124),
(74095,'enUS','The Horde brought back a hozen?! Dinna\' they had enough of those back in Pandaria?','',26124),
(74096,'enUS','I never seen this many Kor\'kron in one place before!$b$bThose orcs are as fierce as fierce gets and angry to boot. They must have upped their recruiting program.','',26124),
(74097,'enUS','Where did Project C4T come from?','Where did Project C4T come from?',26124),
(74098,'enUS','Ol\' Boots?! He\'s a creation all my own. After Socks, may he rest in peace, I needed a more durable companion.$b$bIt was Amber that decided to use him for our mission, so try not to blow him up!','',26124),
(74099,'enUS','','Good riddance!',26124),
(74100,'enUS','Narali deserved worse!','',26124),
(74101,'enUS','Welcome back, champion!','',26124),
(74102,'enUS','Excellent work with the celestials. Can you believe how chatty they were?','',26124),
(74103,'enUS','I just wanted them to hand us our reward, but they were just, \"talk talk talk talk talk.\"','',26124),
(74104,'enUS','I\'m sorry - where were we? Oh yes! I have something for you:','',26124),
(74105,'enUS','The very spirits of Pandaria are supporting us in our grand crusade! Behold:','',26124),
(74106,'enUS','The strength of the White Tiger.','',26124),
(74107,'enUS','The wisdom of the Jade Serpent.','',26124),
(74108,'enUS','The fortitude of the Black Ox.','',26124),
(74109,'enUS','And from the Red Crane, a shining beacon of hope for a better world!','',26124),
(74110,'enUS','Our world.','',26124),
(74111,'enUS','There! It is ready.','',26124),
(74113,'enUS','Escort caravans to earn bonus Kor\'kron supplies!','',26124),
(74114,'enUS','Defeat enemy commanders to earn bonus Kor\'kron supplies!','',26124),
(74115,'enUS','The Alliance are coming aboard!  Get up to the deck and fight for your honor!','',26124),
(74116,'enUS','Ring the gong if you wish to accept this challenge. Otherwise, we are done here for now.','',26124),
(74117,'enUS','Tap Keg','Tap Keg',26124),
(74118,'enUS','Embercores wake from the lava!','',26124),
(74119,'enUS','Hey, you\'re not that stinking goat! What do you want with Kil\'rek?','',26124),
(74120,'enUS','The Menagerie is for guests only.','',26124),
(74121,'enUS','Do not touch the displays.','',26124),
(74122,'enUS','You are not a guest.','',26124),
(74123,'enUS','Gallery rules will be strictly enforced.','',26124),
(74124,'enUS','Kill these Alliance scum! For the Horde!','',26124),
(74125,'enUS','Out of the way, peasant!','',26124),
(74126,'enUS','The warchief calls.','',26124),
(74127,'enUS','The true horde will rule all of Azeroth.','',26124),
(74128,'enUS','Tito begins to yip annoyingly!','',26124),
(74129,'enUS','Victory is ours!  Get in the cannon and press the attack!','',26124),
(74130,'enUS','My work is not quite finished. This cloak will grant you the power of the celestials.','',26124),
(74131,'enUS','Very soon we will be able to augment your cloak with my own formidable draconic powers.','',26124),
(74132,'enUS','Continue to aid your allies in the war effort. I will contact you shortly!','',26124),
(74133,'enUS','Seer Hao Pham Roo hands you the end of his climbing rope. Tie it to the next Rope Anchor and help him up the mountain!','',26124),
(74134,'enUS','$C! This area\'s swarming with Kor\'kron. Give us a hand?','$C! This area\'s swarming with Kor\'kron. Give us a hand?',26124),
(74135,'enUS','That\'s the last of them!  Get to the bottom of the ship and plant those explosives!','',26124),
(74136,'enUS','He doesn\'t need blades or magic to defeat his enemies. Our next challenger, Hexos, fights his foes with the awesome powers of GEOMETRY!','',26124),
(74137,'enUS','He may be a huge chicken, but he\'ll still put up a fight. It\'s Tyson Sanders!','',26124),
(74138,'enUS','He\'s got two modes. Both modes are labeled \"KILL\". Let\'s hear it for T440!','',26124),
(74139,'enUS','Hope you all like your brawlers extra-crispy! Here comes Anthracite!!','',26124),
(74140,'enUS','What\'s better than an explosion? Lots and lots of explosions, of course! In this corner, we have Big Badda Boom!!','',26124),
(74141,'enUS','Aww... look at the cute little snake, Nibbleh! Go ahead, let him nibble on your toes. Let\'s see what happens.','',26124),
(74142,'enUS','He\'s not a real doctor, but he\'s going to attempt some facial reconstruction surgery. On his next opponent. Welcome, Doctor FIST!','',26124),
(74143,'enUS','Dust off that luckydo, because you\'re gonna need it. It\'s Grandpa Grumplefloot!','',26124),
(74144,'enUS','No introduction could possibly do our challengers justice. Feast your eyes on the Bear and the Lady Fair!','',26124),
(74145,'enUS','Throw down your weapon and pick up your gloves. It\'s time for a good old-fashioned boxing match. Prepare to be floored by Ty\'thar!','',26124),
(74146,'enUS','He\'s probably the most deadly brawler we\'ve ever had here at the Brawlpub. Unfortunately, he\'s a little out of his element. Everybody raise your glass for Razorgrin!','',26124),
(74147,'enUS','Brawl\'gar veterans may remember Blat, the self-replicating ooze. Today, we meet his meaner, uglier, older sister: Splat!','',26124),
(74148,'enUS','What\'s this? Bruce is back! A better, faster, stronger Bruce! It\'s MECHA-BRUCE!! YAYYYY!!','',26124),
(74149,'enUS','He\'s a strategic mastermind, and he doesn\'t even have a head. Or an elbow, even. It\'s Ro-Shambo! Let\'s give him a hand!','',26124),
(74150,'enUS','Ever wonder what we do with all our obsolete robots? We send them to their deaths in bloody gladiatorial arenas, of course! Here comes Blingtron 3000!','',26124),
(74151,'enUS','He\'s never seen an opponent that he wouldn\'t fight. Ah, small correction: he\'s never seen an opponent. He\'s the Blind Hero!','',26124),
(74152,'enUS','Float like a dragonhawk, sting like a scorpid!','',26124),
(74153,'enUS','Ya, mon! I\'m da best there ever was!','',26124),
(74154,'enUS','Everyone got a plan until dey get punched in da tusks...','',26124),
(74155,'enUS','An\' stay down dis time!','',26124),
(74156,'enUS','Dis is Ty\'thar\'s house!','',26124),
(74157,'enUS','I never seen such speed before...','',26124),
(74158,'enUS','My bling is blung...','',26124),
(74159,'enUS','I\'ll archeologize yer skull, $glad:lassie;!','',26124),
(74160,'enUS','Will you help an old man retrace the steps of the last emperor?','',26124),
(74161,'enUS','I am ready to help you walk the path.','I am ready to help you walk the path.',26124),
(74162,'enUS','Bury me with me shovel...\nLiterally...','',26124),
(74163,'enUS','CAN YOU DIG IT?!?','',26124),
(74164,'enUS','Who\'s the obsolete one now?','',26124),
(74165,'enUS','%s appears to be weeping.','',26124),
(74166,'enUS','I will find you...','',26124),
(74167,'enUS','The sound of death... so sweet to my ears...','',26124),
(74168,'enUS','What is this sensation? Is that... a light...?','',26124),
(74169,'enUS','%s appears unstable.','',26124),
(74170,'enUS','The doctor is out...','',26124),
(74171,'enUS','When all you have is your fists, everything looks like a face.','',26124),
(74172,'enUS','You are now being judged.','',26124),
(74173,'enUS','I wield... the LIGHT!','',26124),
(74174,'enUS','You test my faith.','',26124),
(74175,'enUS','The Light is my shield.','',26124),
(74176,'enUS','You fought... with... valor...','',26124),
(74177,'enUS','You now face your doom.','',26124),
(74178,'enUS','Too slow, mortal.','',26124),
(74179,'enUS','Grkkk!','',26124),
(74180,'enUS','Cock-a-doodle-DIE!','',26124),
(74181,'enUS','B-gawkk!!','',26124),
(74182,'enUS','Help us fend off these Alliance dogs!','',26124),
(74183,'enUS','More are swinging over.  It looks like this is the last of \'em!','',26124),
(74184,'enUS','Zephyr increases your movement speed - share this effect with Seer Hao Pham Roo by walking beside him.','Zephyr increases your movement speed - share this effect with Seer Hao Pham Roo by walking beside him.',26124),
(74185,'enUS','Please, keep your voice low, $r. I was sent here by Baine Bloodhoof to keep an eye on events in the Vale.','',26124),
(74186,'enUS','I am a simple tauren. Baine and I have been friends for a long time.','',26124),
(74187,'enUS','Come with us, fool. You don\'t want this to get bloody.','Come with us, fool. You don\'t want this to get bloody.',26124),
(74188,'enUS','You are asking for an axe in your back. Drop the weapon, now.','You are asking for an axe in your back. Drop the weapon, now.',26124),
(74189,'enUS','Where do you think you\'ll run to? The Kor\'kron control this city.','Where do you think you\'ll run to? The Kor\'kron control this city.',26124),
(74190,'enUS','You don\'t want to force the hand of the warchief.','You don\'t want to force the hand of the warchief.',26124),
(74191,'enUS','Look at this dishonorable creature. You smell of straw.','Look at this dishonorable creature. You smell of straw.',26124),
(74192,'enUS','I am going to enjoy crushing your spirit.','I am going to enjoy crushing your spirit.',26124),
(74193,'enUS','|TInterface\\Icons\\inv_misc_pocketwatch_01:20|t Bonus Objective Started: Defeat all enemies before time runs out!','',26124),
(74194,'enUS','|TInterface\\Icons\\inv_misc_pocketwatch_01:20|t Bonus timer started!','|TInterface\\Icons\\inv_misc_pocketwatch_01:20|t Bonus timer started!',26124),
(74195,'enUS','I got to practice.\n \n<Points at you tool in hand.>\n \nIf you\'re not practicing, you should be practicing. So keep practicing. \n \nThat\'s the only way you are going to get better, to get better at anything. \n \nPractice. Practice. Practice.','',26124),
(74196,'enUS','When I grow up, I want to be the bestest Shaman in the world!','',26124),
(74197,'enUS','The two paths of sha corruption in Dread Wastes both seem to be in very straight lines.  I wonder where they are heading?  Curious.','',26124),
(74198,'enUS','Sometimes things happen because someone said a thing had to happen.  It makes keeping history straight a little difficult... but we make do.','',26124),
(74199,'enUS','Do not dwell on lost friends and companions for too long.  Perhaps it is best to feel honored that you had the privilege of sharing an experience with them.','',26124),
(74200,'enUS','Have you heard of the Isle of Thunder? Dark portents reach us even here.','',26124),
(74201,'enUS','It is said that the Thunder King\'s armies are vast and powerful. Do you think that the battle will ever reach us here?','',26124),
(74202,'enUS','We are a peaceful people, but awaken the warriors within us, and we will fight.','',26124),
(74203,'enUS','I have heard tell of many dangerous enemies and creatures on the Isle of Thunder. It seems that every day, the threat changes.','',26124),
(74204,'enUS','Help us fend off these Horde pigs!','',26124),
(74205,'enUS','More are swinging over.  It looks like this is the last of \'em!','',26124),
(74206,'enUS','I live by the ways of the new travelers to Pandaria. \"Keep yer powder dry and yer ale cold!!\"','',26124),
(74207,'enUS','This rocket will take you all the way to Badlands, which is very far away.  Are you sure?','This rocket will take you all the way to Badlands, which is very far away.  Are you sure?',26124),
(74208,'enUS','|TInterface\\Icons\\inv_misc_pocketwatch_01:20|t Bonus Objective: Rescue all scouts and stop the summoned storm!','|TInterface\\Icons\\inv_misc_pocketwatch_01:20|t Bonus Objective: Rescue all scouts and stop the summoned storm!',26124),
(74209,'enUS','|TInterface\\Icons\\inv_misc_pocketwatch_01:20|t Bonus Objective: Defeat Borokhula the Destroyer!','|TInterface\\Icons\\inv_misc_pocketwatch_01:20|t Bonus Objective: Defeat Borokhula the Destroyer!',26124),
(74210,'enUS','|TInterface\\Icons\\inv_misc_pocketwatch_01:20|t Bonus Objective: Defeat the Abomination of Anger!','|TInterface\\Icons\\inv_misc_pocketwatch_01:20|t Bonus Objective: Defeat the Abomination of Anger!',26124),
(74211,'enUS','Enjoy de rock, mon!','',26124),
(74212,'enUS','Hello friend.','',26124),
(74213,'enUS','I\'ve never worked a day in my life. That\'s just one of the many benefits of being nocturnal!','',26124),
(74214,'enUS','','I\'d rather be reading!',26124),
(74215,'enUS','I\'m learning how to speak Hozen, ookin\' Wikkets! Jae-Sun Di Fo eated all my slickies. For that, I\'ll grook him in the dookers.','',26124),
(74216,'enUS','For Hellscream!','For Hellscream!',26124),
(74217,'enUS','Death to the enemies of the true Horde!','Death to the enemies of the true Horde!',26124),
(74218,'enUS','No one shall withstand our might!','No one shall withstand our might!',26124),
(74219,'enUS','We will purge this land!','We will purge this land!',26124),
(74220,'enUS','The eyes of Hellscream are upon us!','The eyes of Hellscream are upon us!',26124),
(74221,'enUS','Victory or death!','Victory or death!',26124),
(74222,'enUS','We will grind you under our heels!','We will grind you under our heels!',26124),
(74223,'enUS','You do not deserve to live, weakling.','You do not deserve to live, weakling.',26124),
(74224,'enUS','Death to Vol\'jin and all of his allies!','Death to Vol\'jin and all of his allies!',26124),
(74225,'enUS','For the true Horde!','For the true Horde!',26124),
(74226,'enUS','','What an interesting door.',26124),
(74227,'enUS','','I never imagined such a world.',26124),
(74228,'enUS','','Good to see you again. Have we met?',26124),
(74229,'enUS','','What an odd outcome.',26124),
(74230,'enUS','','This world is so different.',26124),
(74231,'enUS','','I must be going, there is so much to see.',26124),
(74232,'enUS','','The possibilities are infinite.',26124),
(74233,'enUS','','Me? Oh, I\'m not from around here.',26124),
(74234,'enUS','|TInterface\\Icons\\ability_creature_poison_04:20|t%s coats his daggers with |cFFFF0000|Hspell:143224|h[Instant Poison]|h|r!','',26124),
(74235,'enUS','|TInterface\\Icons\\ability_rogue_deviouspoisons:20|t%s coats his daggers with |cFFFF0000|Hspell:143239|h[Noxious Poison]|h|r!','',26124),
(74238,'enUS','The Conduit is at full energy and Lei Shen disconnects!','',26124),
(74239,'enUS','A strange creature. What precious things will I find on your corpse?','',26124),
(74240,'enUS','This seems urgent, Kadrak. There must be another way!','This seems urgent, Kadrak. There must be another way!',26124),
(74241,'enUS','Very well, $n. I\'ll meet you there.','',26124),
(74242,'enUS','The Alliance is near victory!','',26124),
(74243,'enUS','The Horde is near victory!','',26124),
(74244,'enUS','The Alliance is victorious!','',26124),
(74245,'enUS','The Horde is victorious!','',26124),
(74246,'enUS','Foolish creature. Taste the true sting of the desert.','',26124),
(74247,'enUS','You will die like the other Frostwolf filth.','',26124),
(74248,'enUS','Thought I was dead, eh?','',26124),
(74249,'enUS','I defy death and you!','',26124),
(74250,'enUS','Your blades are no match for our cunning.','',26124),
(74251,'enUS','You may not be a Frostwolf, but you WILL bleed like them.','',26124),
(74253,'enUS','[Call his bluff] Why don\'t WE wait until YOU attack Orgrimmar, and then mop up YOUR dead?','[Call his bluff] Why don\'t WE wait until YOU attack Orgrimmar, and then mop up YOUR dead?',26124),
(74254,'enUS','<Vol\'jin sees his opportunity slipping away. He holds up his hands.>$b$bWait now, $r! Orgrimmar be a fortress. My people, we ain\'t gonna crack dat nut on our own. How long we gonna last out here? Days? Weeks? Vol\'jin can\'t say.$b$bYou keep da supplies comin\', an\' I promise, more Kor\'kron gonna die. Before ya troops even land! The blood bein\' spilt ain\'t even ya own! Surely dat be worth a few crates of meat?','',26124),
(74256,'enUS','Good, $r. Many Kor\'kron gonna die thanks to ya help.','',26124),
(74257,'enUS','This\'ll keep da rebellion around a little longer. Orgrimmar will fall!','',26124),
(74258,'enUS','Dese be strange times... Thanks, $r. We gonna spill a lot of Kor\'kron blood wit\' dis.','',26124),
(74259,'enUS','More supplies! De Alliance be like a machine. Soon we cut our way through Garrosh\'s goons... A lotta orcs done picked the wrong side.','',26124),
(74260,'enUS','You good, $r! We gonna crush Garrosh\'s army wit\' dis!','',26124),
(74261,'enUS','Hatock, son of the Iron Wolf! I come for your head.','',26124),
(74262,'enUS','Frostwolves! Kill the gronn! Find the coward!','',26124),
(74263,'enUS','I WILL HAVE MY REVENGE!','',26124),
(74264,'enUS','Seek out Lien Farner. He\'ll be able to train you in any profession.','Seek out Lien Farner. He\'ll be able to train you in any profession.',26124),
(74265,'enUS','|cFFFE1CF7|Hspell:139267|h[Reliquary Pick]|h|r Special artifacts revealed!','|cFFFE1CF7|Hspell:139267|h[Reliquary Pick]|h|r Special artifacts revealed!',26124),
(74266,'enUS','+5 Artifact Bonus!','+5 Artifact Bonus!',26124),
(74267,'enUS','+10 Artifact Bonus!','+10 Artifact Bonus!',26124),
(74268,'enUS','Urtharges\' death severely wounds the remaining elementals!','Urtharges\' death severely wounds the remaining elementals!',26124),
(74269,'enUS','%s detects a cluster of injured enemies and goes into a  |cFFFF0404|Hspell:143440|h[Blood Frenzy]|h|r!','',26124),
(74270,'enUS','%s begins to heal himself with |cFFFF0000|Hspell:141423|h[Hekima\'s Wisdom]|h|r.','',26124),
(74271,'enUS','','My thanks for your assistance, champions. I will tend to the slain and wounded here before returning to Ironforge.',26124),
(74272,'enUS','Hold still pup. At this range it wouldn\'t take much to pierce that armor.','',26124),
(74273,'enUS','Ga\'nar, we caught Durotan\'s tracker.','',26124),
(74274,'enUS','More vermin come to infest our sacred grounds.','',26124),
(74275,'enUS','Durotan must have sent $Ghim:her; for a reason.','',26124),
(74276,'enUS','Bah. Let me show you what I think of my brother\'s \"message\".','',26124),
(74277,'enUS','Hold still demon. At this range it wouldn\'t take much to pierce that armor.','',26124),
(74278,'enUS','Ga\'nar, we caught Durotan\'s green orc tracker that has been tracking us.','',26124),
(74279,'enUS','More corrupted filth. As if this scorpar infestation were not enough.','',26124),
(74280,'enUS','That green skin of yours marks you as the aberration you are. You are no more orc than the filth at the bottom of this pit.','',26124),
(74281,'enUS','Do you hear the howling winds? It is a lonely sound. Make no mistake - if you are not careful, the land will claim you for its own.','',26124),
(74282,'enUS','Ye\'ll want ta seek out Wembil Taskwidget, just along the south road.\n\nHe can help ye with any profession ye\'re interested in!','Ye\'ll want ta seek out Wembil Taskwidget, just along the south road.\n\nHe can help ye with any profession ye\'re interested in!',26124),
(74283,'enUS','You want Nedric Sallow, in the inn.\n\nHe\'s just to the right of the stairs down.','You want Nedric Sallow, in the inn.\n\nHe\'s just to the right of the stairs down.',26124),
(74284,'enUS','Look for Runda.\n\nShe\'s usually just north of the barracks entrance.','Look for Runda.\n\nShe\'s usually just north of the barracks entrance.',26124),
(74285,'enUS','Seek out Iranis Shadebloom.\n\nYou\'ll find him inside the inn, on the main floor.','Seek out Iranis Shadebloom.\n\nYou\'ll find him inside the inn, on the main floor.',26124),
(74286,'enUS','Look for Saren, in the Falconwing Square inn.\n\nYou\'ll find him upstairs, near the kitchens.','Look for Saren, in the Falconwing Square inn.\n\nYou\'ll find him upstairs, near the kitchens.',26124),
(74287,'enUS','Valn can aid you.\n\nSeek him out on the south side of Azure Watch.','Valn can aid you.\n\nSeek him out on the south side of Azure Watch.',26124),
(74288,'enUS','Ga\'nar\'s impatience could tear the Frostwolves apart. It is just like my brother to put his own needs above the clan.','',26124),
(74289,'enUS','[Line Deleted] Help him, $p. You will not be able to turn him from his path of vengeance, and it is dangerous to try.','',26124),
(74290,'enUS','Don\'t worry. This hero will convince Ga\'nar to return. Your brother values strength, and my friend possesses that in abundance.','',26124),
(74291,'enUS','I fear the cost of Ga\'nar\'s impatience will be Frostwolf blood.','',26124),
(74292,'enUS','But then, Ga\'nar has always put his own needs before the clan.','',26124),
(74293,'enUS','The bones of the Ancient Clefthoof stir to life!','',26124),
(74294,'enUS','May I have another racing ram?','May I have another racing ram?',26124),
(74295,'enUS','Noooo! You fool! The ritual grows... out of... control...','',26124),
(74296,'enUS','Who dares to interrupt my magiks?','',26124),
(74297,'enUS','You need to be on a racing ram to receive a keg! Return to Neill Ramstein and ask for another.','',26124),
(74298,'enUS','You need to be on a racing ram to receive a keg! Return to Ram Master Ray and ask for another.','',26124),
(74299,'enUS','What do you want?','',26124),
(74300,'enUS','[%s] confesses: When my allies get mind controlled, I try really hard to kill them.','[%s] confesses: When my allies get mind controlled, I try really hard to kill them.',26124),
(74301,'enUS','[%s] confesses: I don\'t use the strongest battle pets. Just the cutest ones.','[%s] confesses: I don\'t use the strongest battle pets. Just the cutest ones.',26124),
(74302,'enUS','[%s] confesses: I get heart of the wild and the other heart of the wild confused.','[%s] confesses: I get heart of the wild and the other heart of the wild confused.',26124),
(74303,'enUS','[%s] confesses: I always ask someone else how to reforge my gear.','[%s] confesses: I always ask someone else how to reforge my gear.',26124),
(74304,'enUS','[%s] confesses: I inspect others to see if they are inspecting me.','[%s] confesses: I inspect others to see if they are inspecting me.',26124),
(74305,'enUS','[%s] confesses: When pandaren tell me to slooow doooown, I just want to punch them.','[%s] confesses: When pandaren tell me to slooow doooown, I just want to punch them.',26124),
(74306,'enUS','[%s] confesses: I always sell all of my old gear to the same vendor. Dude\'s rich or something.','[%s] confesses: I always sell all of my old gear to the same vendor. Dude\'s rich or something.',26124),
(74307,'enUS','[%s] confesses: I care more about transmogrification gear than upgrade gear.','[%s] confesses: I care more about transmogrification gear than upgrade gear.',26124),
(74308,'enUS','[%s] confesses: I can\'t decide between Horde and Alliance. Horde has goblin mages with quad-pigtails but Alliance has dwarf priests with twirly braids.','[%s] confesses: I can\'t decide between Horde and Alliance. Horde has goblin mages with quad-pigtails but Alliance has dwarf priests with twirly braids.',26124),
(74311,'enUS','|TInterface\\Icons\\spell_frost_summonwaterelemental.blp:20|t%s begins to cast |cFFFF0000|Hspell:143309|h[Swirl]|h|r!','',26124),
(74312,'enUS','|TInterface\\Icons\\ability_shawaterelemental_split.blp:20|t%s |cFFFF0000|Hspell:143020|h[Splits]|h|r!','',26124),
(74313,'enUS','A frostwolf pup excitedly nips at your ankles before falling in step with your stride.','',26124),
(74314,'enUS','','|TInterface\\Icons\\sha_spell_fire_blueflamestrike:20|t%s focuses her |cFFFF0000|Hspell:143602|h[Meditation Spikes]|h|r at $n!',26124),
(74315,'enUS','|TInterface\\Icons\\ability_shawaterelemental_reform.blp:20|t%s |cFFFF0000|Hspell:143469|h[Reforms]|h|r!','',26124),
(74316,'enUS','Ga\'nar! It is about time you returned. What grisly trophies are these?','',26124),
(74317,'enUS','I have slain the sons of the Iron Wolf. He drowns in the blood of his own.','',26124),
(74318,'enUS','Your fool crusade left us exposed to attack. Many died.','',26124),
(74319,'enUS','You are no Chieftain of mine, brother. By my rights as second son, by the justice I have dealt today, I declare mak\'gora.','',26124),
(74320,'enUS','It has come to this.','',26124),
(74321,'enUS','AWESOME IN-GAME EVENT','AWESOME IN-GAME EVENT',26124),
(74322,'enUS','','You must not do this! You are family!',26124),
(74323,'enUS','Family looks to its own! Only I cared to avenge our father\'s death!','',26124),
(74324,'enUS','Vengeance neither feeds nor protects our clan. Do you not see why father chose me as his heir when our eldest brother went missing?','',26124),
(74325,'enUS','Father chose wrong. This clan needs strength!','',26124),
(74326,'enUS','End it.','',26124),
(74327,'enUS','Chieftain.','',26124),
(74328,'enUS','Her presence defiles Frostwolf honor. The other clans will spit upon us.','',26124),
(74329,'enUS','Those who cannot stand... deserve... to... die! [PH - Targets Draka and is about to charge.]','',26124),
(74330,'enUS','Vengeance does not make our clan strong.','',26124),
(74331,'enUS','Rise up, brother. I need you. This clan needs you.','',26124),
(74332,'enUS','The strength that comes from protecting the ones you love.','',26124),
(74333,'enUS','We are a family, Ga\'nar. Family stands together.','',26124),
(74334,'enUS','THAT is what makes the Frostwolves strong.','',26124),
(74335,'enUS','Come stand with us, brother. Join your forces with us. There is much work to be done.','',26124),
(74336,'enUS','Enough! I yield.','',26124),
(74337,'enUS','I guess you aren\'t a pushover.','',26124),
(74338,'enUS','Lok\'tar!','',26124),
(74339,'enUS','You don\'t belong here! Urtok is going to teach you a lesson about strength!','',26124),
(74340,'enUS','I lost? How could this be?','',26124),
(74341,'enUS','Yes, brother. I would welcome you with open arms.','',26124),
(74342,'enUS','Still alive, pup? I guess I won\'t have to save you after all. Come, we should talk.','',26124),
(74343,'enUS','Oh, and try not to die. Scorpar are unkind to corpses.','',26124),
(74344,'enUS','Your corpse will be of great use to me. Hair, flesh, and bone. So many concoctions I could make.','',26124),
(74345,'enUS','Why have you come? Was it for your precious wolf pups? Their flesh is mine!','',26124),
(74346,'enUS','I am proud, but I admit you bested me, brother. I wish to learn more of your strength. We shall rejoin you.','',26124),
(74347,'enUS','Such... power...','',26124),
(74348,'enUS','|TInterface\\Icons\\ability_warrior_offensivestance.blp:20|t General Nazgrim assumes a |cFFFF0000|Hspell:143589|h[Battle Stance]|h|r!','',26124),
(74349,'enUS','|TInterface\\Icons\\ability_warrior_defensivestance.blp:20|t General Nazgrim assumes a |cFFFF0000|Hspell:143593|h[Defensive Stance]|h|r!','',26124),
(74350,'enUS','|TInterface\\Icons\\ability_racial_avatar.blp:20|t General Nazgrim assumes a |cFFFF0000|Hspell:143594|h[Berserker Stance]|h|r!','',26124),
(74351,'enUS','Give me money for cool things','',26124),
(74352,'enUS','Rifleman','Rifleman',26124),
(74353,'enUS','The carcass looks fresh and largely un-carved, with the exception of six careful incisions on the belly.$B$BBehind each incision you find a large cavity where some critical organ may once have been housed.','',26124),
(74354,'enUS','|TInterface\\Icons\\ability_priest_pathofthedevout:20|t%s begins to cast |cFFFF0000|Hspell:143497|h[Bond of the Golden Lotus]|h|r.','|TInterface\\Icons\\ability_priest_pathofthedevout:20|t%s begins to cast |cFFFF0000|Hspell:143497|h[Bond of the Golden Lotus]|h|r.',26124),
(74355,'enUS','Xaril hurls blue catalyst around the room!','',26124),
(74356,'enUS','Xaril hurls red catalyst around the room!','',26124),
(74357,'enUS','Xaril hurls yellow catalyst around the room!','',26124),
(74358,'enUS','Xaril hurls orange catalyst around the room!','',26124),
(74359,'enUS','Xaril hurls purple catalyst around the room!','',26124),
(74360,'enUS','Xaril hurls green catalyst around the room!','',26124),
(74361,'enUS','Hold!','',26124),
(74362,'enUS','Ga\'nar? Is that you? I thought we killed you already.','',26124),
(74363,'enUS','Or did you like it so much the first time you decided to come back for more?','',26124),
(74364,'enUS','Have you come sniffing for a place among the Thunderlords? Hrah hah hah!','',26124),
(74365,'enUS','If you beg like a good dog, my father may-','',26124),
(74366,'enUS','Your father MAY be able to identify what\'s left of your tiny skull.','',26124),
(74367,'enUS','Hrgh... K-... KILL THEM!!','',26124),
(74368,'enUS','Brothers! Today, we do what Durotan will not!','',26124),
(74369,'enUS','The scorpar are at bay and our mounts are ready, old friend.','',26124),
(74370,'enUS','Today, we take vengeance on the beast who killed Garad!','',26124),
(74371,'enUS','Let\'s ride!','',26124),
(74377,'enUS','Ga\'nar, the Thunderlord clan trains their hunters in the canyon this time year.','',26124),
(74378,'enUS','Pah! Thunderlord filth. Not enough room for all of them in that carcass they call home?','',26124),
(74379,'enUS','We\'ll carve right through them if we have to.','',26124),
(74380,'enUS','This warrior died from several puncture marks across his body. He was positioned in a ceremonious and caring fashion before set ablaze.','',26124),
(74381,'enUS','Please... KILL ME...','',26124),
(74382,'enUS','The magic... it burns ... AUUUUGGGHHHHHH!','',26124),
(74383,'enUS','Stop, my brothers! Do you not see the beast of burden before you?','',26124),
(74385,'enUS','We must consume his flesh, for he is weak! The cycle must continue!','',26124),
(74386,'enUS','Yes! Consume him! Meat and bone!','',26124),
(74387,'enUS','By the blood of Kros!','',26124),
(74388,'enUS','Taste his flesh! Drink his blood!','',26124),
(74389,'enUS','Strength to the Skumblade!','',26124),
(74390,'enUS','Do you not see the light of Kros? He has been defiled!','',26124),
(74391,'enUS','The Door is under attack!','',26124),
(74392,'enUS','Durok? What foul sorcery is this?','',26124),
(74393,'enUS','My brother is gone, and only this creature remains. It must be destroyed!','',26124),
(74394,'enUS','I will destroy this foul altar while you deal with Kurak\'akan.','',26124),
(74395,'enUS','Welcome to Frostwind.','',26124),
(74396,'enUS','Hear me, Thunderlords! I am Ga\'nar of the Frostwolves! Son of Garad!','',26124),
(74397,'enUS','Your chief slew my father. So I have come to claim the heads of his sons. Who among you has the spine to stop me?','',26124),
(74398,'enUS','Ready yourselves...','',26124),
(74399,'enUS','Ga\'nar, there is no denying the worth of the outsider.','',26124),
(74400,'enUS','Ha! Urtok, go lick your wounds. You, pup, are taking his place. Soon we will ride to avenge my father. When we succeed, I shall go to Durotan myself.','',26124),
(74401,'enUS','You may ride with us, but you\'ll ride as we do, or not at all--on a beast from these very hills.','',26124),
(74402,'enUS','Exiles! It is time for us to ride! Behold our new friend\'s... mount!','',26124),
(74403,'enUS','To the canyon! To glory!','',26124),
(74404,'enUS','Magic Dude','Magic Dude',26124),
(74405,'enUS','AoE Dude','AoE Dude',26124),
(74406,'enUS','Snare Dude','Snare Dude',26124),
(74407,'enUS','Come $r, I ride for the exile camp immediately.','',26124),
(74408,'enUS','I must tell Ga\'nar what we have witnessed.','',26124),
(74409,'enUS','We knew the scorpar were a vile infestation, but we never knew how they were able to grow their numbers.','',26124),
(74410,'enUS','No matter. Kurak\'akan is slain, thanks to you. The threat of the Kuraki scorpar lay in ruin.','',26124),
(74411,'enUS','Ga\'nar must hear of your deeds.','',26124),
(74412,'enUS','Brothers, look. An outsider.','',26124),
(74413,'enUS','Vragor! Who\'s the runt?','',26124),
(74414,'enUS','No mutt, Chieftain. I vouch for this stranger.','',26124),
(74415,'enUS','What\'s this mutt you\'ve dragged to my doorstep, Vragor?','',26124),
(74416,'enUS','Forward, brothers and sisters! Cut through the camp and rally at the Savage Crag!','',26124),
(74417,'enUS','Lok\'tar ogar!','',26124),
(74418,'enUS','Lok\'tar ogar!','',26124),
(74419,'enUS','Lok\'tar ogar!','',26124),
(74420,'enUS','Bet I can kill more gronn than you, brother.','',26124),
(74421,'enUS','Eat up, boys! We\'ve got gronn to kill.','',26124),
(74422,'enUS','Sharpen the blades, sharpen the blades...','',26124),
(74423,'enUS','Nice and pointy. Perfect for stabbing a gronn in the eye or a Thunderlord in the chest.','',26124),
(74424,'enUS','Stop $Ghim:her;!','',26124),
(74425,'enUS','Don\'t let $Ghim:her; through!','',26124),
(74426,'enUS','Don\'t let $Ghim:her; escape!','',26124),
(74427,'enUS','Psssst! Meatbag, over here!','',26124),
(74428,'enUS','I can smell them. They stink of fear.','',26124),
(74429,'enUS','Such hunger...','',26124),
(74430,'enUS','You! Come over here, give us just a taste...','',26124),
(74431,'enUS','Stop, my brothers! Do you not see the beast of burden before you?','',26124),
(74432,'enUS','What\'s going on in here? Get that thing back in its cage!','',26124),
(74433,'enUS','Intruders! I will lock you in a cell with the rest of the filth.','',26124),
(74434,'enUS','Stop this madness! You have no idea what you\'re dealing with!','',26124),
(74435,'enUS','<Ga\'nar is mustering his strength to challenge the enormous gronn.>','',26124),
(74436,'enUS','<Assist Ga\'nar in battle.>','<Assist Ga\'nar in battle.>',26124),
(74437,'enUS','Great beast of burden, heed my call!','',26124),
(74438,'enUS','I have come to return you to Kros! Surrender your flesh to me!','',26124),
(74439,'enUS','Bro, my pet is going to incinerate you!','',26124),
(74440,'enUS','My menagerie will eat the flesh from your bones.','',26124),
(74441,'enUS','Burn them all! Burn them to ash!','',26124),
(74442,'enUS','Then it is time.','',26124),
(74443,'enUS','As for you, outsider...','',26124),
(74446,'enUS','You\'ll ride the loaner. Hrah hah hah!','',26124),
(74447,'enUS','You have earned a place in this raid. And since you haven\'t yet bonded with a frostwolf of your own...','',26124),
(74448,'enUS','Thank you, friends. I will lend what aid I can.','',26124),
(74449,'enUS','%s reels in pain and leers angrily at $n.','',26124),
(74450,'enUS','%s |cFFFF0404|Hspell:143445|h[Fixates]|h|r on you!','%s |cFFFF0404|Hspell:143445|h[Fixates]|h|r on you!',26124),
(74451,'enUS','My death means nothing. You cannot quell the storm!','',26124),
(74452,'enUS','You cannot stop us... as long as Kurak\'akan lives!','',26124),
(74453,'enUS','Fool, you have achieved nothing! Our true power lies in the valley to the north.','',26124),
(74454,'enUS','Their hunting camp stands directly between us and the gronn caves.','',26124),
(74455,'enUS','%s bolts at the first sign of trouble!','',26124),
(74456,'enUS','Ga\'nar can be a bit... brash. Especially now while he is so at ends with his brother.$b$bIt would be best not to take his kicking you down this hole personally.','',26124),
(74457,'enUS','Tell Vragor why Durotan sent you.','Tell Vragor why Durotan sent you.',26124),
(74458,'enUS','<The spider peers at you menacingly.>','',26124),
(74459,'enUS','Begin pet battle.','Begin pet battle.',26124),
(74460,'enUS','You are trying to unite the Frostwolves? Well then we share a common goal. I have known Ga\'nar and Durotan since they were born, and I can tell you it will take more than words to get them to come together again.$b$bGa\'nar must finish what he started. He intends to avenge his father\'s death, and there is not a voice in this world or the next that will convince him to stray from this goal.$b$bSo, instead of fighting him, I choose to help him and increase his chances of success.','',26124),
(74461,'enUS','Many of our riders are still crossing the dunes behind us.','',26124),
(74462,'enUS','Hold here until reinforcements arrive. In the meantime, let us draw out as many as we can...','',26124),
(74463,'enUS','Wraaugh!','',26124),
(74464,'enUS','I\'m not THAT snarky, am I?','',26124),
(74465,'enUS','I got a bone to pick wit\' you!','',26124),
(74466,'enUS','Why don\'t I dance at parties? I have no body to dance wit\'!','',26124),
(74467,'enUS','What kind of spirit haunts a chicken coop? A poultry geist!','',26124),
(74468,'enUS','I know my jokes ain\'t so good... I lost my funny bone!','',26124),
(74469,'enUS','You ain\'t foolin\' nobody, ghosty! I can see right through you!','',26124),
(74470,'enUS','I was bone to be wild!','',26124),
(74471,'enUS','Who just called me a numbskull?','',26124),
(74472,'enUS','Maybe I\'m a bit of a bonehead...','',26124),
(74473,'enUS','Sorry for ribbin\' ya so much.','',26124),
(74474,'enUS','Sometimes you gotta be sternum with unruly ghosts.','',26124),
(74475,'enUS','I used to be more humerus.','',26124),
(74476,'enUS','Want to hear somethin\' funny? Coccyx.','',26124),
(74477,'enUS','Who needs a body when your jokes got legs?','',26124),
(74478,'enUS','Ya know... my heart really ain\'t in it.','',26124),
(74479,'enUS','They didn\'t leave me with a leg to stand on!','',26124),
(74480,'enUS','Ghosts must get cold. The wind goes straight through \'em!','',26124),
(74481,'enUS','I always wanted to play the organ.','',26124),
(74482,'enUS','I love you wit\' every bone in my body!','',26124),
(74483,'enUS','I\'m bonin\' up on my spirit lore.','',26124),
(74484,'enUS','Say anythin\', it won\'t get under my skin!','',26124),
(74485,'enUS','Sticks and stones may break my bones...','',26124),
(74486,'enUS','I thought about askin\' her out but I didn\'t have the guts.','',26124),
(74487,'enUS','I\'m not sure I have the stomach for this...','',26124),
(74488,'enUS','Hey, meat sack! If you got five minutes, come talk to me! I got no body!','',26124),
(74489,'enUS','Good deal. Welcome to the spirit world. Kinda. Let\'s check out the chests for any goodies, and see if you can find my body somewhere!','',26124),
(74490,'enUS','In the meantime, let us draw out as many as we can...','',26124),
(74491,'enUS','You fought well against Urtok. Let\'s see if those tricks work against a gronn.','',26124),
(74492,'enUS','Durotan sent you? He should have come himself. We are avenging HIS father after all.','',26124),
(74493,'enUS','I remember the first time I had to feed the wolves. Nearly lost my hand in the process.','',26124),
(74494,'enUS','The scouts found Kolloc on the other side of the Bladespire Oasis. Be ready to head out soon.','',26124),
(74495,'enUS','They say the Thunderlord are between us and the gronn. They should be a nice warm up. Ha!','',26124),
(74496,'enUS','A $c hmm? How are you in a real fight?','',26124),
(74497,'enUS','I remember my first ride with Ga\'nar. Nearly lost my eye. A good day!','',26124),
(74498,'enUS','It will take more than a pittance of meat to win over the heart of a true Frostwolf. Though it doesn\'t hurt.','',26124),
(74502,'enUS','Still alive, pup? Come, we must reach Ga\'nar before he finishes marshaling his forces.','',26124),
(74503,'enUS','I have no time for this. Urtok, get this filth out of my sight.','',26124),
(74504,'enUS','Iyyokuk begins choosing criteria from $n!','',26124),
(74505,'enUS','Kor\'kron, at my side!','',26124),
(74506,'enUS','Warriors, on the double!','',26124),
(74507,'enUS','Next squad, to the front!','',26124),
(74508,'enUS','Defend the gate!','',26124),
(74509,'enUS','Rally the forces!','',26124),
(74510,'enUS','All Kor\'kron... under my command... kill them... NOW!','',26124),
(74511,'enUS','Save your breath, pup. I have no time for Durotan\'s whining. We are here to do the job he was unwilling to do.','',26124),
(74512,'enUS','Iyyokuk selects: Sword |TInterface\\Icons\\ABILITY_IYYOKUK_SWORD_white.BLP:20|t!','',26124),
(74513,'enUS','Iyyokuk selects: Drum |TInterface\\Icons\\ABILITY_IYYOKUK_DRUM_white.BLP:20|t!','',26124),
(74514,'enUS','Iyyokuk selects: Bomb |TInterface\\Icons\\ABILITY_IYYOKUK_BOMB_white.BLP:20|t!','',26124),
(74515,'enUS','Iyyokuk selects: Mantid  |TInterface\\Icons\\ABILITY_IYYOKUK_MANTID_white.BLP:20|t!','',26124),
(74516,'enUS','Iyyokuk selects: Staff  |TInterface\\Icons\\ABILITY_IYYOKUK_STAFF_white.BLP:20|t!','',26124),
(74517,'enUS','Iyyokuk selects: |cFFFF0000Red|r!','',26124),
(74518,'enUS','Iyyokuk selects: |cFFFF00FFPurple|r!','',26124),
(74519,'enUS','Iyyokuk selects: |cFF0000FFBlue|r!','',26124),
(74520,'enUS','Iyyokuk selects: |cFF00FF00Green|r!','',26124),
(74521,'enUS','Iyyokuk selects: |cFFFFFF00Yellow|r!','',26124),
(74522,'enUS','Iyyokuk selects: One!','',26124),
(74523,'enUS','Iyyokuk selects: Two!','',26124),
(74524,'enUS','Iyyokuk selects: Three!','',26124),
(74525,'enUS','Iyyokuk selects: Four!','',26124),
(74526,'enUS','Iyyokuk selects: Five!','',26124),
(74527,'enUS','|TInterface\\Icons\\spell_nature_diseasecleansingtotem.blp:20|t The Dark Shaman drop |cFFFF0000|Hspell:144288|h[Poisonmist Totems]|h|r!','',26124),
(74528,'enUS','|TInterface\\Icons\\spell_nature_natureresistancetotem.blp:20|t The Dark Shaman drop |cFFFF0000|Hspell:144289|h[Foulstream Totems]|h|r!','',26124),
(74529,'enUS','|TInterface\\Icons\\spell_frost_fireresistancetotem.blp:20|t The Dark Shaman drop |cFFFF0000|Hspell:144290|h[Ashflare Totems]|h|r!','',26124),
(74530,'enUS','|TInterface\\Icons\\spell_shaman_totemrecall.blp:20|t The Dark Shaman drop |cFFFF0000|Hspell:144291|h[Rusted Iron Totems]|h|r!','',26124),
(74531,'enUS','|TInterface\\Icons\\spell_nature_bloodlust.blp:20|t The Dark Shaman gain |cFFFF0000|Hspell:144302|h[Bloodlust]|h|r!','',26124),
(74532,'enUS','The Dark Shaman go into a berserker rage!','',26124),
(74538,'enUS','Lunk loves to play on seesaw!','',26124),
(74539,'enUS','Please let someone else have a turn, Lunk.','Please let someone else have a turn, Lunk.',26124),
(74540,'enUS','The statue softly hums as you approach.','The statue softly hums as you approach.',26124),
(74541,'enUS','The statue lies dormant.','The statue lies dormant.',26124),
(74542,'enUS','Touch the statue.','Touch the statue.',26124),
(74544,'enUS','','Is our shipment of juicycrunch carrots ready to be picked up?',26124),
(74545,'enUS','','Here they are! These are beautiful, $n. The Kirin Tor Offensive is in your debt.',26124),
(74546,'enUS','','I\'ve come for our order of Scallions.',26124),
(74547,'enUS','','This is more than I expected, $c. The Sunreaver Onslaught thanks you.',26124),
(74548,'enUS','Xaril the Poisoned-Mind prepares several white catalyst potions to throw at his enemies!','',26124),
(74549,'enUS','Start Basic Tank (Bronze)','Start Basic Tank (Bronze)',26124),
(74550,'enUS','Start Basic Tank (Endless)','Start Basic Tank (Endless)',26124),
(74551,'enUS','Start Basic Tank (Gold)','Start Basic Tank (Gold)',26124),
(74552,'enUS','Start Basic Tank (Silver)','Start Basic Tank (Silver)',26124),
(74553,'enUS','|TInterface\\Icons\\inv_misc_sawblade_01.blp:20|t Siegecrafter Blackfuse faces you and readies |cFFFF0000|Hspell:143266|h[Launch Sawblade]|h|r!','',26124),
(74554,'enUS','As you approach the crystal, you can feel its potent energy. Some nearby sprites glare dubiously in your direction.','As you approach the crystal, you can feel its potent energy. Some nearby sprites glare dubiously in your direction.',26124),
(74555,'enUS','Destroy the crystal.','Destroy the crystal.',26124),
(74556,'enUS','Ooo oOOo ooOoO','Ooo oOOo ooOoO',26124),
(74557,'enUS','ooOo Ooo oO OooO','ooOo Ooo oO OooO',26124),
(74558,'enUS','OOoO','OOoO',26124),
(74559,'enUS','ooo OoOooO oo','ooo OoOooO oo',26124),
(74560,'enUS','o OOooO OoooO','o OOooO OoooO',26124),
(74561,'enUS','O OoO OOoO','O OoO OOoO',26124),
(74562,'enUS','oOO OOooO','oOO OOooO',26124),
(74563,'enUS','oOooO OoOo','oOooO OoOo',26124),
(74564,'enUS','Like you, I could not resist the opportunity to take part of this ancient Pandaren tradition.  When you are ready, let us see how well you can lead your pets in battle.','',26124),
(74565,'enUS','','Hello, $n.  My name is Oriana, and I attend the tournament to make sure no pets are grievously injured, and to explain the rules.\n\nYou cannot heal or revive your pets during the tournament.  If you run out of pets to use in battle, you can leave and enter the tournament again.\n\nIf you lose to a challenger, you may fight them again.',26124),
(74566,'enUS','Healing your pets will disqualify your current progress in the scenario, and you\'ll have to battle your opponents again.  Are you sure?','Healing your pets will disqualify your current progress in the scenario, and you\'ll have to battle your opponents again.  Are you sure?',26124),
(74567,'enUS','Pay 5 Timeless Coins for 1 Kukuru\'s Kache Key.','Pay 5 Timeless Coins for 1 Kukuru\'s Kache Key.',26124),
(74568,'enUS','Pay 5 Timeless Coins?','Pay 5 Timeless Coins?',26124),
(74569,'enUS','Wise hozen say: All that glitters is not gold. Unless it is gold. Then it glitters.','',26124),
(74571,'enUS','Wise hozen say: To seek riches, look within yourself. Or in one of these chests.','',26124),
(74572,'enUS','Wise hozen say: Appearances can be deceiving, especially if you have bad eyesight.','',26124),
(74573,'enUS','Wise hozen say: Don\'t bite off more than you can chew, unless there are other hungry hozen nearby.','',26124),
(74574,'enUS','Wise hozen say: Actions speak louder than words, unless the person is yelling.','',26124),
(74575,'enUS','Wise hozen say: If at first you don\'t succeed, get someone else to do it for you.','',26124),
(74576,'enUS','Wise hozen say: Don\'t put off until tomorrow what you can do... oh nevermind, I\'ll tell you the rest later.','',26124),
(74577,'enUS','Welcome, traveler! I have treasure from all across the world.$B$BYou want to test your luck? Only a few timeless coins for a key.','',26124),
(74578,'enUS','','Hi there, $n!  It\'s great to see you again.  Everyone is still talking about the last time you won the tournament... I didn\'t get to see all of it, but I had to heal a lot of burns and bruises.  But don\'t worry, they\'re fine now!',26124),
(74580,'enUS','','%s begins to cast |cFFFF0000|Hspell:144590|h[Moonfang\'s Curse]|h|r.',26124),
(74584,'enUS','%s shifts back into Assault Mode!','',26124),
(74585,'enUS','%s shifts into Siege Mode!','',26124),
(74586,'enUS','|TInterface\\Icons\\ability_mage_firestarter.blp:20|t|cFFFF0000Siege Engineers|r appear in the wings and begin to cast |cFFFF0000|Hspell:144616|h[Power Iron Star]|h|r!','',26124),
(74587,'enUS','Steel yourselves, men! We\'re bein\' boarded!','',26124),
(74588,'enUS','Look out! Another wave comes!','',26124),
(74589,'enUS','Fight fer yer lives, mateys! If The Barnacle\'s going down, we\'re going down with her!','',26124),
(74590,'enUS','The hammer is warm to the touch.','The hammer is warm to the touch.',26124),
(74591,'enUS','Pick up the hammer.','Pick up the hammer.',26124),
(74592,'enUS','By Firallon\'s beard, what is that thing? Kill it!','',26124),
(74593,'enUS','We did it men, we saved The Barnacle! Finally, a moment of rest since we entered this forsaken mist. Turn the sails, men. We\'re goin\' home!','',26124),
(74594,'enUS','','|cFFFF0000BEWARE:|r Moonfang Dreadhowls now prowl the woods!',26124),
(74595,'enUS','','|cFFFF0000BEWARE:|r Den Mother Moonfang has appeared in the woods!',26124),
(74596,'enUS','','Moonfang, Den Mother of Darkmoon Island, has been slain!',26124),
(74599,'enUS','You hear a mournful howl in the distance.','',26124),
(74600,'enUS','An anguished howl echoes in the twilight.','',26124),
(74601,'enUS','A sorrowful howling floats through the forest.','',26124),
(74602,'enUS','There is a pained howl from deep within the woods.','',26124),
(74603,'enUS','Almost... got... it...','',26124),
(74604,'enUS','Well that was unexpected!','',26124),
(74605,'enUS','Uhhh.. you can handle this right?','',26124),
(74606,'enUS','Oh hello! I was just about to reel in this catch. I have a hunch it\'s going to be a doozy!','',26124),
(74607,'enUS','Well what are you waiting for?! Let\'s see!','Well what are you waiting for?! Let\'s see!',26124),
(74608,'enUS','Good! I\'ll just leave you to it!','',26124),
(74610,'enUS','Anger. Hatred. Fear!! They are weapons of war - the tools of a Warchief!','',26124),
(74616,'enUS','Yes... yes I can see now...I can see the future of this world...a world ruled by the horde...MY horde.','',26124),
(74617,'enUS','Enter my realm.','',26124),
(74619,'enUS','Chelon has been engaged by $n the $r $c.','',26124),
(74621,'enUS','|cFFFF0000|Hspell:144985|h[Whirling Corruption]|h|r killed you.  Move away from Garrosh to decrease damage taken.','',26124),
(74622,'enUS','My eternal vigil has kept the corruption of pride at bay. To face this corruption yourself you must purify yourselves in the burning light.  This process will not go easily for you.\n\nAre you ready?','',26124),
(74623,'enUS','We are ready, Keeper.','We are ready, Keeper.',26124),
(74624,'enUS','Do you wish to begin the Norushen Encounter?','Do you wish to begin the Norushen Encounter?',26124),
(74625,'enUS','Let\'s see how you like the newest addition to the Warchief\'s arsenal... the Iron Star!','',26124),
(74626,'enUS','Oh, look. You\'re the ones that smashed up my Juggernaut.','',26124),
(74627,'enUS','Time to mix business with pleasure.','',26124),
(74628,'enUS','You there, $r! I beg of you, set us free.','',26124),
(74629,'enUS','The strength of my clan will be with you. I swear it.','',26124),
(74630,'enUS','Just open this door.','',26124),
(74631,'enUS','Our prayers have been answered!','',26124),
(74632,'enUS','','We must redeem the Vale.',26124),
(74633,'enUS','','You will suffer from our failure.',26124),
(74634,'enUS','','Protectors, come to my aid!',26124),
(74635,'enUS','','Will you succeed where we have failed?',26124),
(74636,'enUS','','We have not fulfilled our oath!',26124),
(74637,'enUS','','We return to when we lost our way. You... are very kind.',26124),
(74638,'enUS','Feeling... better now... Thank you... little friend.','',26124),
(74639,'enUS','Start Basic Healer (Bronze)','Start Basic Healer (Bronze)',26124),
(74640,'enUS','Start Basic Healer (Endless)','Start Basic Healer (Endless)',26124),
(74641,'enUS','Start Basic Healer (Gold)','Start Basic Healer (Gold)',26124),
(74642,'enUS','Start Basic Healer (Silver)','Start Basic Healer (Silver)',26124),
(74643,'enUS','Rook... not safe...','',26124),
(74644,'enUS','Rook... needs help!','',26124),
(74645,'enUS','Brawl... with Rook.','',26124),
(74646,'enUS','Rook fight!','',26124),
(74647,'enUS','Sun... He... aid me.','',26124),
(74648,'enUS','%s signals for help.','',26124),
(74649,'enUS','I\'m sorry, $n, but I\'m not really up for talking.  Leave me in peace.','',26124),
(74650,'enUS','','We\'ve made so many sacrifices, and our fight lingers on. These battles have a way of wearing away at my spirit...',26124),
(74651,'enUS','Stay strong, $c.  Hold on tightly to those you love.  We never know how long any of us will have for this world.','',26124),
(74652,'enUS','%s enters a meditative pose to heal his wounds.','',26124),
(74653,'enUS','|TInterface\\Icons\\ability_druid_typhoon:20|t%s enters a |cFFFF0000|Hspell:143559|h[Dark Meditation]|h|r!','|TInterface\\Icons\\ability_druid_typhoon:20|t%s enters a |cFFFF0000|Hspell:143559|h[Dark Meditation]|h|r!',26124),
(74654,'enUS','Goro\'dan! You\'re on deck!','',26124),
(74655,'enUS','|TInterface\\Icons\\ability_rogue_deadliness:20|t%s creates a |cFFFF0000|Hspell:143840|h[Mark of Anguish]|h|r!','',26124),
(74656,'enUS','Aggron! Show \'em who\'s boss!','',26124),
(74657,'enUS','Alright, Shanna. You\'re up.','',26124),
(74658,'enUS','|TInterface\\Icons\\spell_monk_ringofpeace:20|t%s calls upon |cFFFF0000|Hspell:143955|h[Misery, Sorrow, and Gloom]|h|r!','',26124),
(74659,'enUS','Looks like I\'m in the market for a new assistant.','',26124),
(74660,'enUS','That\'s for the Juggernaut.','',26124),
(74661,'enUS','Another satisfied customer.','',26124),
(74663,'enUS','Presenting... the beautiful new ST-03 Shockwave missile turret!','',26124),
(74664,'enUS','What\'s better than a bomb, huh?! I\'ll tell ya - a bomb with two bombs inside!','',26124),
(74665,'enUS','Meet the LT-403 Evaporation laser. A personal point of pride.','',26124),
(74666,'enUS','Ya\' ever wonder how magnets work?','',26124),
(74668,'enUS','Start the assembly line!','',26124),
(74669,'enUS','The SD-5 Automated Shredder defense unit. A labor of love.','',26124),
(74670,'enUS','Don\'t... think you\'ve won...','',26124),
(74671,'enUS','You are not... my friend...','',26124),
(74672,'enUS','','You too have failed.',26124),
(74673,'enUS','%s nods at his foes.','',26124),
(74674,'enUS','Hey, I heard you like mines, so... enjoy!','',26124),
(74675,'enUS','Another round!','',26124),
(74676,'enUS','More! More!','',26124),
(74677,'enUS','Unfinished weapons begin to roll out on the assembly line.','Unfinished weapons begin to roll out on the assembly line.',26124),
(74689,'enUS','','Drek\'Thar! I don\'t know what you are doing up there but it is angering the goren to no end.',26124),
(74690,'enUS','Copying','Copying',26124),
(74691,'enUS','$n has set up a Noodle Cart!','$n has set up a Noodle Cart!',26124),
(74692,'enUS','$n has set up a Noodle Cart!','$n has set up a Noodle Cart!',26124),
(74693,'enUS','$n has set up a Deluxe Noodle Cart!','$n has set up a Deluxe Noodle Cart!',26124),
(74694,'enUS','$n has set up a Deluxe Noodle Cart!','$n has set up a Deluxe Noodle Cart!',26124),
(74695,'enUS','$n has set up a Pandaren Treasure Noodle Cart!','$n has set up a Pandaren Treasure Noodle Cart!',26124),
(74696,'enUS','$n has set up a Pandaren Treasure Noodle Cart!','$n has set up a Pandaren Treasure Noodle Cart!',26124),
(74697,'enUS','TIME TO DRINK ALL THE  KOOL-AID!','',26124),
(74698,'enUS','It is not too late, Garrosh. Lay down the mantle of Warchief. We can end this here, now, with no more bloodshed.','',26124),
(74699,'enUS','Then you have forced my hand.  I will correct the mistake I made long ago.  Spirits of the wind, the earth, the water, hear my call!  Come to my aid!','',26124),
(74700,'enUS','Never powerless Garrosh. And never alone.','',26124),
(74701,'enUS','Ha! Do you remember nothing of Honor? Of glory on the battlefield?  You who would parlay with the humans, who allowed warlocks to practice their dark magics right under our feet.  You are weak.','',26124),
(74702,'enUS','We are the Orcish Horde, the True Horde.  We die, bloody and thrashing on the field of battle, like true orcs SHOULD.','',26124),
(74703,'enUS','You are an Orc no longer, and speak for none but yourself. You betrayed our people to forge your fragile alliances, and I will take great pleasure in tearing them apart.','',26124),
(74704,'enUS','Fool. My Dark Shaman have twisted and tortured the elements for miles around. They cannot hear you now. Once again you prove too weak and powerless to do anything.','',26124),
(74705,'enUS','So, you wish to face off against a real Orc Warchief.  So be it.','',26124),
(74706,'enUS','My people should have taken this world long ago, during the First War. But they fell to corruption.  In their weakness, they allowed the pitiful races of Azeroth to join the horde.  I will succeed where they have failed, and no power in this world can stop me!','',26124),
(74707,'enUS','Witness the power of the True Horde\'s arsenal!','',26124),
(74708,'enUS','We will cleanse this world in steel and fire!','',26124),
(74709,'enUS','Warbringers, bloody your blades!  Lok\'tar Ogar!','',26124),
(74710,'enUS','Farseers, mend our wounds!','',26124),
(74711,'enUS','Die with honor!','',26124),
(74712,'enUS','Blood and Thunder!','',26124),
(74713,'enUS','For the True Horde!','',26124),
(74714,'enUS','The power flows through me!','',26124),
(74715,'enUS','The power to crush your world, and everything on it!','',26124),
(74716,'enUS','All will fall in the name of Hellscream!','',26124),
(74717,'enUS','Weak.','',26124),
(74718,'enUS','Pitiful.','',26124),
(74719,'enUS','Now you know your place in my new world.','',26124),
(74720,'enUS','The Old One calls to you!','',26124),
(74721,'enUS','The Heart will be your end!','',26124),
(74722,'enUS','See the visions of fear, despair, and doubt, as I have!','',26124),
(74723,'enUS','You will be trapped for eternity!','',26124),
(74724,'enUS','The True Horde WILL come to pass.  I have SEEN it.  IT HAS SHOWN ME. I HAVE SEEN MOUNTAINS OF SKULLS AND RIVERS OF BLOOD.  AND I WILL...HAVE...MY...WORLD!','',26124),
(74728,'enUS','Rodoh.','',26124),
(74729,'enUS','I wish to enter the tournament.','I wish to enter the tournament.',26124),
(74730,'enUS','Can I enter the tournament?','Can I enter the tournament?',26124),
(74731,'enUS','You\'ve done well for yourself, I can see that.  But to enter the Celestial Tournament, you must prove yourself as a leader.  When you have taken fifteen battle pets to their maximum level, you may attempt the trials that await you there.','',26124),
(74735,'enUS','Karg? Yeah, I saw him. He saved my life - took on five of those filthy Thunderlords by himself.','Karg? Yeah, I saw him. He saved my life - took on five of those filthy Thunderlords by himself.',26124),
(74736,'enUS','He had \'em, too. Until the Iron Wolf showed up riding the biggest, meanest rylak I\'ve ever seen. Snatched him up and carried him away.','He had \'em, too. Until the Iron Wolf showed up riding the biggest, meanest rylak I\'ve ever seen. Snatched him up and carried him away.',26124),
(74737,'enUS','They took others, too. Dragged \'em down into the canyon. Ask around, find out who\'s gone missing.','They took others, too. Dragged \'em down into the canyon. Ask around, find out who\'s gone missing.',26124),
(74738,'enUS','','Be careful. This place is sacred, not safe. What I am about to do could get a lot of unwanted attention.',26124),
(74739,'enUS','','Great spirits of the wind, heed my call! Share with me the source of your pain.',26124),
(74740,'enUS','','I will try to use my totems to assist you if the need arises.',26124),
(74741,'enUS','I came to ask the elements for aid in the coming battle.','',26124),
(74742,'enUS','But among the burning, biting winds of the mountains I heard the cry of the fury, Exurotus.','',26124),
(74743,'enUS','Beaten, half consumed, and shattered by ancient magics, the fury is the prisoner of the magnaron Kron.','',26124),
(74744,'enUS','The fury has been fragmented, its pieces scattered on the wind or consumed by scavengers.','',26124),
(74745,'enUS','My stable hand, Roknor tried to fight off one of those rylaks with a pitchfork and got himself dragged down into the Boneslag!','',26124),
(74746,'enUS','','I haven\'t seen Makar in some time. His healing skills are desperately needed!',26124),
(74747,'enUS','','One of those things grabbed my daughter Gana! Dragged her away in chains like an animal!',26124),
(74750,'enUS','','How unusual for Akama to send a stranger...',26124),
(74751,'enUS','','...but I trust you. Thank you, outsider.',26124),
(74752,'enUS','Hm. About time we showed these filthy orcs some vengeance.','',26124),
(74753,'enUS','WHAT? HUH? GO TO AKAMA? OKAY!!!','',26124),
(74754,'enUS','You\'re not with the revolutionaries are you?','You\'re not with the revolutionaries are you?',26124),
(74755,'enUS','Make it quick $r, your kind make me sick.','Make it quick $r, your kind make me sick.',26124),
(74756,'enUS','','I\'m going into the boneslag.',26124),
(74757,'enUS','Enter the Proving Grounds','Enter the Proving Grounds',26124),
(74758,'enUS','We have them on their heels. Now is the time to press them back!','',26124),
(74759,'enUS','','I will follow you wherever you lead, Akama.',26124),
(74760,'enUS','We must drive these orcish rats out of our temple! They will feel the full weight of draenei justice.','',26124),
(74761,'enUS','I LIKE TO HEAL MYSELF!','',26124),
(74762,'enUS','By the Light... we\'ll need someone to take care of that orcish artillery.','',26124),
(74763,'enUS','ALREADY ON IT!','',26124),
(74764,'enUS','So I see.','',26124),
(74765,'enUS','Ahura! Hogo! $n! Continue to press the offensive!','',26124),
(74766,'enUS','','Commander, I cannot leave these men stranded here. You three go on without me.',26124),
(74767,'enUS','Very well. Stay alive, Ahura.','',26124),
(74768,'enUS','Hogo, $n. These orcs aren\'t going to slay themselves.','',26124),
(74769,'enUS','Hogo, you go ahead - make sure they don\'t counterattack. I will stay behind and establish defenses.','',26124),
(74770,'enUS','As you wish, commander.','',26124),
(74771,'enUS','$n! Follow me, into the jaws of the enemy! BY THE LIGHT OF KARABOR!!','',26124),
(74772,'enUS','Interested in trading your battle-stones?','Interested in trading your battle-stones?',26124),
(74773,'enUS','','Drek\'Thar may have doubts about his capabilities but I do not.$b$bI am not about to let that blind fool turn his back on the elements. Not after all they have done for our people.',26124),
(74774,'enUS','This way.','This way.',26124),
(74775,'enUS','My methods never fail!','',26124),
(74776,'enUS','Some may question my methods, but there\'s no denying my results.','',26124),
(74777,'enUS','Suffering loosens the tongue. Take my word for it, $r.','',26124),
(74778,'enUS','Not everyone is cut out for the work I do.$b$b<Tormentor Sipe sharpens his blade.>$b$bCut out, get it? Oh, I slay me.','',26124),
(74779,'enUS','That troll doesn\'t seem to want to tell me what he knows. You want to take a stab at him, $c?','',26124),
(74780,'enUS','Once all this strife is behind us, I think I\'ll retire to Durotar.$b$bA nice little shack on a hill. Maybe a little garden.$b$bYeah, that sounds nice.','',26124),
(74781,'enUS','Just wait, I\'ll have that troll singin\' by day\'s end.','',26124),
(74782,'enUS','Seek out Lalum Darkmane, within the village\'s main tipi.','Seek out Lalum Darkmane, within the village\'s main tipi.',26124),
(74783,'enUS','','Wait $p! This way. Before the giant sees you.',26124),
(74784,'enUS','Akama! Why not raze their town? Why give them another chance?','',26124),
(74785,'enUS','The word of an orc is garbage. They\'re only buying time.','',26124),
(74786,'enUS','Enough talk of battle, Hogo. Finally, Shadowmoon enjoys peace.','',26124),
(74787,'enUS','Or not.','',26124),
(74788,'enUS','MY EARS HURT!','',26124),
(74789,'enUS','','Asha! Let\'s go, girl. Karg and Nerok are in trouble!',26124),
(74790,'enUS','','I\'m going after Karg. You look for the others!',26124),
(74791,'enUS','|TInterface\\Icons\\sha_ability_warrior_bloodnova.blp:20|t You have created a |cFFF00000|Hspell:145066|h[Projection]|h|r!','|TInterface\\Icons\\sha_ability_warrior_bloodnova.blp:20|t You have created a |cFFF00000|Hspell:145066|h[Projection]|h|r!',26124),
(74792,'enUS','|TInterface\\Icons\\sha_spell_warlock_demonsoul.blp:20|t The %s begins to cast |cFFF00000|Hspell:144400|h[Swelling Pride]|h|r!','|TInterface\\Icons\\spell_warlock_demonsoul.blp:20|t The %s begins to cast |cFFF00000|Hspell:144400|h[Swelling Pride]|h|r!',26124),
(74795,'enUS','Our enemies have finally arrived!  Demolishers, fire at will!','',26124),
(74798,'enUS','<The wolf watches you with wise eyes.>','',26124),
(74799,'enUS','','|TInterface\\Icons\\ability_priest_halo_shadow:20|t%s begins to cast |cFFFF0000|Hspell:143491|h[Calamity]|h|r!',26124),
(74800,'enUS','|TInterface\\Icons\\Ability_Siege_Engineer_Superheated.blp:20|t An Activated Laser turret has locked on to you!','',26124),
(74801,'enUS','|TInterface\\Icons\\Ability_Siege_Engineer_Detonate.blp:20|tA Crawler Mine has targeted you!','',26124),
(74802,'enUS','Thanks! I\'m getting out of here!','Thanks! I\'m getting out of here!',26124),
(74803,'enUS','Ahh! Ahhhhhhhhhhh!','Ahh! Ahhhhhhhhhhh!',26124),
(74804,'enUS','I\'m outta here! Stupid orcs, always hated the orcs!','I\'m outta here! Stupid orcs, always hated the orcs!',26124),
(74805,'enUS','I owe you my life!','I owe you my life!',26124),
(74806,'enUS','Thanks!','Thanks!',26124),
(74807,'enUS','You\'re the best!','You\'re the best!',26124),
(74808,'enUS','Screw this place!','Screw this place!',26124),
(74809,'enUS','Leave me alone!!','Leave me alone!!',26124),
(74812,'enUS','Spirits, heed my call! Aid this fallen warrior!','',26124),
(74813,'enUS','Be still.','',26124),
(74814,'enUS','Vol\'jin needs you on the front lines!','',26124),
(74815,'enUS','May the spirits aid you.','',26124),
(74816,'enUS','Hey thanks! While I\'m here, ya wanna browse my wares? Got this stuff new from Pandaria. Won\'t be cheap, war times you know.','',26124),
(74817,'enUS','I will NOT burn like the rest! Face the demons you fear, traitors!','',26124),
(74818,'enUS','What is that horrible smell?','I\'m going to puke...',26124),
(74819,'enUS','still sick!!!','still sick!!!',26124),
(74820,'enUS','Don\'t let them through!','',26124),
(74821,'enUS','Protect the temple!!','',26124),
(74822,'enUS','The Warchief ignored my council. I discovered he was building a compound beneath the caverns of Ragefire.','',26124),
(74823,'enUS','Thrall and Saurfang have already gone down below.','',26124),
(74824,'enUS','Go with caution.  Hellscream has been assembling an arsenal down there - goblin mercenaries, pandaren artifacts, and some sort of darkness I can feel in my very soul.','',26124),
(74825,'enUS','I\'m scared!','I\'m scared!',26124),
(74826,'enUS','','Stay behind us! Keep your heads down!',26124),
(74827,'enUS','An Automated Shredder draws near!','',26124),
(74828,'enUS','','I hear a spirit. A powerful one! Keep those goren at bay for just a little longer.',26124),
(74829,'enUS','','Buy me just a few more moments.',26124),
(74830,'enUS','The Kor\'kron are ready. Let them come and taste steel!','The Kor\'kron are ready. Let them come and taste steel!',26124),
(74831,'enUS','Almost all of da troops be here now.','',26124),
(74832,'enUS','I am uneasy, old friend.','',26124),
(74833,'enUS','An me as well. We dun know what Garrosh been plannin this whole time.  What he\'s got in store for us.','',26124),
(74834,'enUS','I fear for the safety of our people.','',26124),
(74835,'enUS','Not everyone gonna come out of this alive.','',26124),
(74836,'enUS','And for what? What did the Horde gain from such actions?  Garrosh is a fool, and a betrayer.  I should have killed him long ago, when he betrayed my father.','',26124),
(74837,'enUS','You gonna get your chance mon.  But first we gotta take da city.','',26124),
(74838,'enUS','Have you been communicating with the humans?','',26124),
(74839,'enUS','Both da alliance and da horde got ships sailin for da harbor.  We gonna split der forces an assault da front gate.','',26124),
(74840,'enUS','A bold plan.  Let us hope we do not run into any surprises.','',26124),
(74841,'enUS','I don\'t think we got a choice, mon.','',26124),
(74842,'enUS','','Stay down, shaman. Catch your breath. This champion can forge ahead and we will catch up when you are ready.',26124),
(74843,'enUS','','Elune-Adore, $c.',26124),
(74844,'enUS','We will defeat Garrosh and restore the Horde!','We will defeat Garrosh and restore the Horde!',26124),
(74845,'enUS','The spirits will guide us in the coming battle.','The spirits will guide us in the coming battle.',26124),
(74846,'enUS','I\'m honored to fight alongside of you, $n!','I\'m honored to fight alongside of you, $n!',26124),
(74847,'enUS','We be ready to take da fight to Garrosh.','We be ready to take da fight to Garrosh.',26124),
(74848,'enUS','Ready to fight, mon?','Ready to fight, mon?',26124),
(74849,'enUS','Vol\'jin be a true leader.','Vol\'jin be a true leader.',26124),
(74850,'enUS','These demolishers aren\'t gonna fix themselves!','',26124),
(74851,'enUS','Work, work.  Heh, had you there didn\'t I?','',26124),
(74852,'enUS','It\'s not safe in Orgrimmar for us now.','It\'s not safe in Orgrimmar for us now.',26124),
(74853,'enUS','I just want my family to be safe.','I just want my family to be safe.',26124),
(74854,'enUS','Garrosh is a tyrant for taking our home.','Garrosh is a tyrant for taking our home.',26124),
(74855,'enUS','I want this all to be over soon.','I want this all to be over soon.',26124),
(74856,'enUS','Mommy says daddy will be home soon.','Mommy says daddy will be home soon.',26124),
(74857,'enUS','I wanna go home.','I wanna go home.',26124),
(74858,'enUS','I hear the adults whispering all the time.','I hear the adults whispering all the time.',26124),
(74859,'enUS','I wanna fight too! I\'m ready!','I wanna fight too! I\'m ready!',26124),
(74860,'enUS','I live to fight again.','I live to fight again.',26124),
(74861,'enUS','These wounds won\'t prevent me from facing the Kor\'kron.','These wounds won\'t prevent me from facing the Kor\'kron.',26124),
(74862,'enUS','Orgrimmar will fall to our forces!','Orgrimmar will fall to our forces!',26124),
(74863,'enUS','I call and the spirits answer $r.','',26124),
(74864,'enUS','Wars make enemies into friends, and friends into enemies.','',26124),
(74865,'enUS','Garrosh be backed into a corner $r, and that\'s when he\'ll be most dangerous.','',26124),
(74866,'enUS','Thrall be me brother, I hope he be safe.','',26124),
(74867,'enUS','Da greater enemy be Garrosh, not da Alliance.','',26124),
(74868,'enUS','The true Horde will triumph.','The true Horde will triumph.',26124),
(74869,'enUS','These rebels are nothing.  Garrosh will stomp them beneath his heel.','These rebels are nothing.  Garrosh will stomp them beneath his heel.',26124),
(74870,'enUS','I\'m keeping my eye on you $r.','I\'m keeping my eye on you $r.',26124),
(74871,'enUS','You\'re not with the rebellion, are you?','You\'re not with the rebellion, are you?',26124),
(74872,'enUS','We\'ve finally captured this tauren.','We\'ve Finally captured this tauren.',26124),
(74873,'enUS','I\'m looking forward to gutting this one.','I\'m looking forward to gutting this one.',26124),
(74874,'enUS','Lash him to the tree!','Lash him to the tree!',26124),
(74875,'enUS','','These warlocks will suffer for their demonic pacts.',26124),
(74876,'enUS','','We will root out all corruption within Orgrimmar.',26124),
(74877,'enUS','','The stench that surrounds your kind is overwhelming.  You will pay with all the others who commune with demonkind.',26124),
(74878,'enUS','It\'s up to me to ensure these Kor\'kron are ready.','It\'s up to me to ensure these Kor\'kron are ready.',26124),
(74879,'enUS','They\'ll thank me for being hard on them when the battle starts.','They\'ll thank me for being hard on them when the battle starts.',26124),
(74880,'enUS','I know what you\'re planning, these Kor\'kron will be ready when you strike.','I know what you\'re planning, these Kor\'kron will be ready when you strike.',26124),
(74881,'enUS','Think twice before you fight the might of the Kor\'kron.','Think twice before you fight the might of the Kor\'kron.',26124),
(74883,'enUS','','Ishnu-alah, commander.',26124),
(74884,'enUS','Good! Again!','Good! Again!',26124),
(74885,'enUS','Garrosh will not tolerate failure.  AGAIN!','Garrosh will not tolerate failure.  AGAIN!',26124),
(74886,'enUS','Garrosh demands the wealth you\'ve accumulated.  You will give me access to your vaults!','',26124),
(74887,'enUS','We shall see if you are so defiant after we start breaking your bones.','',26124),
(74888,'enUS','I... I can\'t! I won\'t!','',26124),
(74889,'enUS','','Garrosh will not tolerate demon worship within the walls of Orgrimmar. You will submit and allow yourselves to be taken into custody or be destroyed.',26124),
(74890,'enUS','Ey mon, help us out! Find da key!','',26124),
(74891,'enUS','Tanks mon, we won\'t be forgettin dis!','',26124),
(74892,'enUS','Doyo\'da places a Resistance Totem to aid you!','',26124),
(74893,'enUS','Over here! Please let us out! They key is around here somewhere!','',26124),
(74894,'enUS','Thanks! We owe you one!','',26124),
(74895,'enUS','The Wildhammer Shaman places a Resistance Totem to aid you!','',26124),
(74896,'enUS','DIE $C!!','',26124),
(74897,'enUS','I am not your friend!!!!','',26124),
(74898,'enUS','Thank you for saving us from the Pale, $n. I shudder to think what horrors might have been in store for us.','Thank you for saving us from the Pale, $n. I shudder to think what horrors might have been in store for us.',26124),
(74899,'enUS','You are welcome. [Vignette Reward Here]','You are welcome. [Vignette Reward Here]',26124),
(74900,'enUS','Why are you out here?','Why are you out here?',26124),
(74901,'enUS','','I dropped my totem.',26124),
(74902,'enUS','Dropped your totem?','Dropped your totem?',26124),
(74903,'enUS','','I have not slept in weeks, and my mind is filled with a screaming that no one else seems to hear.$b$bWhat kind of shaman is unable to lift her own totem? How can I claim Ga\'nar is wrong if when I hoist my own axes my arms buckle? I am not fit for war, I am not fit as a shaman.$b$bI must find what the spirits purpose is for me. Only their guidance can set me on the right path now. They obviously have a plan or I would not have access to my powers as a shaman anymore.',26124),
(74904,'enUS','You\'ve walked into your own grave, pup.','',26124),
(74905,'enUS','Lighting Fuse...','Lighting Fuse...',26124),
(74906,'enUS','He\'s gone.','',26124),
(74907,'enUS','','Spirits of the wind, lend us your speed.',26124),
(74908,'enUS','','The Thunderlord are fools for the most part, but they understand combat with giants.',26124),
(74909,'enUS','','They are also notorious for etching down their favorite tactics on armbands. I assume they are either bragging or failing to remember.',26124),
(74910,'enUS','','Spirits save me but it is cold. My lungs feel like they are on fire.',26124),
(74911,'enUS','','There it is. The carcass. I... I don\'t think I can go with you in there. My arm will not stop shaking and it is as if the land itself is screaming in my mind.',26124),
(74912,'enUS','','I.. I can\'t... they took my children!',26124),
(74913,'enUS','','I\'m so sorry!',26124),
(74914,'enUS','','Please, find my babies!',26124),
(74915,'enUS','','Please, let us go!',26124),
(74916,'enUS','','We didn\'t want to do this!',26124),
(74917,'enUS','','I owe you my life!',26124),
(74918,'enUS','Shut up!','',26124),
(74919,'enUS','Attack them!','',26124),
(74920,'enUS','Get back in line!','',26124),
(74921,'enUS','Have anything to say for yourself, Pandaren?','',26124),
(74922,'enUS','Do you see this burning candle? You have until it burns out to tell us about the Pandaren artifacts! Now start talking!','',26124),
(74923,'enUS','Very well, if you won\'t talk, you won\'t need your head anymore.','',26124),
(74924,'enUS','','Ji must be in here somewhere, I have to find him!',26124),
(74925,'enUS','','Oh no, Ji! They are going to execute him!',26124),
(74926,'enUS','','They have practically beaten him unconscious! I have to do something!',26124),
(74927,'enUS','','Ji! No! I will kill you!',26124),
(74928,'enUS','','Ji... I am sorry...',26124),
(74929,'enUS','','Ji, I am so sorry, we can be together now, please, let us just go back to the turtle, please do not die.',26124),
(74930,'enUS','','I am getting him out of here.',26124),
(74931,'enUS','','I will see you on the inside, $p. Spirits guide you. Orgrock, lend me a hand if you will.',26124),
(74933,'enUS','Hngg... huh? I could hear Lokra... moments ago...','',26124),
(74934,'enUS','I could hear Lokra... moments ago...','',26124),
(74935,'enUS','Ah, but she is the hunter, not the quarry. And ahead of the pack as usual...','',26124),
(74936,'enUS','Go on ahead, friend. I will catch up. I just need a moment to regain my strength.','',26124),
(74937,'enUS','Hrnngg... thank you...','',26124),
(74938,'enUS','I may be bruised and beaten, but the hatred boils inside me.','',26124),
(74939,'enUS','Many times have I fallen at the hands of an Orc, and many times have I risen again.','',26124),
(74940,'enUS','But never again.','',26124),
(74941,'enUS','For every orc that struck me, I will cleave a thousand of their skulls!','',26124),
(74942,'enUS','This ends here!','This ends here!',26124),
(74943,'enUS','I, Gamon, will save us!','I, Gamon, will save us!',26124),
(74944,'enUS','Taste my axe!','Taste my axe!',26124),
(74945,'enUS','Pay for your crimes!','Pay for your crimes!',26124),
(74946,'enUS','I am a storm of pain!','I am a storm of pain!',26124),
(74949,'enUS','Some terrible things have happened in the Vale of Eternal Blossoms, but the real tragedy is that it\'s no longer a good place for fishing. All that Jewel Danio! Gone!  $b $bFortunately for you, I\'ve heard of an island off the eastern coast where you can still fish Jewel Danio. If the rumors are correct, you should be able to find a lake full of them there.','',26124),
(74950,'enUS','If the rumors are true, you should be able to find Jewel Danio here. $b$b<Ben marks a spot on your map.>$b$b','',26124),
(74953,'enUS','An old scroll covered in various pandaren pictograms. You suspect that unless the sha corruption in the temple is cleansed you won\'t be able to peruse the contents further.','',26124),
(74954,'enUS','Read the scroll.','Read the scroll.',26124),
(74956,'enUS','Rage is power!','',26124),
(74957,'enUS','SQEEEE!!','',26124),
(74958,'enUS','You have been judged, and proven yourselves worthy. But be warned, what lies beyond will try your souls to their utmost.  When you are fully prepared, you may enter the chamber.','',26124),
(74959,'enUS','','Shhh... not so loud!',26124),
(74960,'enUS','','Thank you. Mother must be worried sick about me!',26124),
(74961,'enUS','','I can get back to the outpost from here. Find me if you need leatherworking!',26124),
(74962,'enUS','The corruption is amplifying.  The fragments must be purged before it becomes too great.','',26124),
(74963,'enUS','It did not matter. It comes.  Steel your hearts and prepare your souls.','',26124),
(74964,'enUS','You... must... contain... it...','',26124),
(74965,'enUS','Be humble.','',26124),
(74966,'enUS','Free yourself of arrogance.','',26124),
(74968,'enUS','Ah, we adventure together again, except this time I am afraid that the circumstances are much more dire.','',26124),
(74969,'enUS','Oh, what has become of the Vale?','',26124),
(74970,'enUS','The land is scarred, the ever-blooming trees and plants wither and die as the water from the pools drains away.','',26124),
(74971,'enUS','Come, let us see what other horrors Garrosh has unleashed upon our land.','',26124),
(74972,'enUS','Once, the Titans used these life-giving waters to create and shape all life in Pandaria.','',26124),
(74973,'enUS','It is these waters that kept the Vale in bloom.  Their runoff into the Valley of the Four Winds created the most fertile farmland in the world!','',26124),
(74974,'enUS','And now, the malignance of the Old God has manifested itself within the waters.','',26124),
(74975,'enUS','Such a foul, foul thing - destroy it, before it seeps deep into the soil and corrupts all of Pandaria!','',26124),
(74976,'enUS','Ah, you have done it!  The waters are pure once more.','',26124),
(74977,'enUS','Can you feel their life-giving energies flow through you?','',26124),
(74978,'enUS','It will take much time for the Vale to heal, but you have given us hope!','',26124),
(74979,'enUS','Can it be...? Oh no, no no no no no.','',26124),
(74980,'enUS','The Golden Lotus... they pledged their lives to defend this place.','',26124),
(74981,'enUS','Yes!  Rook Stonetoe!  You remember me!  What has happened to you?','',26124),
(74982,'enUS','I see. This sha energy has trapped their spirits here, to endlessly relive their failure. It feeds on their despair.','',26124),
(74983,'enUS','NOOOOO!','',26124),
(74984,'enUS','This is a fate far worse than death - please, heroes!  Set their souls free!','',26124),
(74985,'enUS','Be at peace, dear friends.','',26124),
(74986,'enUS','May your souls become one with the land you gave your life to protect.','',26124),
(74987,'enUS','Astounding! Another chamber that looks to originate from these \"Titans.\"','',26124),
(74988,'enUS','It must have been hidden away long before recorded history.  And with good reason!','',26124),
(74989,'enUS','In the chamber ahead, under our peaceful land, slept the heart of an Old God.','',26124),
(74990,'enUS','Oh my!  What is this?  Hello!  I am Lorewalker Cho!','',26124),
(74991,'enUS','Further corruption?  No, we are here to stop the corruption, and save Pandaria!','',26124),
(74992,'enUS','Yes! Please let us pass!','',26124),
(74993,'enUS','Taran Zhu!','',26124),
(74994,'enUS','Don\'t speak, friend, I will take you to the healers.','',26124),
(74995,'enUS','I will find help!  Try to hold off the Sha for as long as you can!','',26124),
(74996,'enUS','Heroes! You\'re alive. I brought help.','',26124),
(74997,'enUS','*Cough cough* Nyyyunnngggg...','',26124),
(74998,'enUS','Cho... the outsiders... THEY did this... we should never have let them in...','',26124),
(74999,'enUS','I SEE YOU!','',26124),
(75000,'enUS','','<Gana strains to look around, then speaks in a hushed whisper.>$B$BAre... are they gone?',26124),
(75001,'enUS','Break the chains.','Break the chains.',26124),
(75002,'enUS','','It\'d be easier to guard you if you stayed out of sight, Khadgar.',26124),
(75003,'enUS','','I\'m going ahead to the demon\'s lair. We\'ll capture it together.',26124),
(75008,'enUS','','In here.',26124),
(75009,'enUS','I am not a child to cower beneath your cape, Cordana.','',26124),
(75010,'enUS','','We\'ll run them down. Catch up to us when you can!',26124),
(75011,'enUS','','Swiftly, Asha! After them!',26124),
(75012,'enUS','','Let\'s go, Sky! After them!',26124),
(75013,'enUS','Hold still. More help should arrive soon.','Hold still. More help should arrive soon.',26124),
(75014,'enUS','Our work is vital to the world.','',26124),
(75015,'enUS','','Well done. I\'ll take it back to the outpost and see that it\'s secured.',26124),
(75016,'enUS','Begin the ritual.','Begin the ritual.',26124),
(75017,'enUS','The Iron Horde continue to attack from the south.','The Iron Horde continue to attack from the south.',26124),
(75018,'enUS','What should we do?','What should we do?',26124),
(75019,'enUS','You there.','You there.',26124),
(75020,'enUS','Go tell Aklana Swifthoof the fight is getting out of control.','Go tell Aklana Swifthoof the fight is getting out of control.',26124),
(75021,'enUS','Right away sir.','Right away sir.',26124),
(75022,'enUS','NO! I will feed your bones to her pups!!!','',26124),
(75023,'enUS','The %s prepares a |cFFFF0404|Hspell:144485|h[Shock Pulse]|h|r!','',26124),
(75024,'enUS','Let\'s do battle!','Let\'s do battle!',26124),
(75025,'enUS','I cannot challenge the Celestials today, but I look forward to watching your progress.  Good luck, $n.','',26124),
(75026,'enUS','Halt!','',26124),
(75027,'enUS','No further corruption will enter the heart chamber!','',26124),
(75028,'enUS','You wish to purge the corruption?','',26124),
(75029,'enUS','Should you pass this door, at this time, you would fail!  You, all of you, are corrupted with the insiduous plague known as Pride.','',26124),
(75030,'enUS','Speak to me again when you are prepared to face your inner demons.','',26124),
(75031,'enUS','Very well, I will create a field to keep your corruption quarantined.','',26124),
(75032,'enUS','Prove yourselves worthy and I will let you pass.','',26124),
(75033,'enUS','|TInterface\\Icons\\spell_shadow_shadesofdarkness.blp:20|t%s begins to cast |cFFF00000|Hspell:142842|h[Breath of Y\'Shaarj]|h|r!','',26124),
(75034,'enUS','The light cleanses; but it is not gentle.  Gird yourselves and be purified!','',26124),
(75035,'enUS','Look inside yourself and cleanse the darkness within.','',26124),
(75036,'enUS','Face your inner demons!','',26124),
(75037,'enUS','Be purified in the light!','',26124),
(75038,'enUS','Unworthy.','',26124),
(75039,'enUS','Only the pure of heart may pass!','',26124),
(75040,'enUS','The light will not suffer your taint.','',26124),
(75041,'enUS','','',26124),
(75042,'enUS','','He was here... I let them slip away.',26124),
(75043,'enUS','','I\'m so sorry, Asha. If only I had trained more... if only I\'d been faster.',26124),
(75044,'enUS','You push yourself too hard, Little Paw.','',26124),
(75045,'enUS','Here! My champion arrives!','',26124),
(75046,'enUS','Ah, of course! My old friend from the Jade Forest!','',26124),
(75047,'enUS','Wait wait wait - let me make sure I get the story right.','',26124),
(75048,'enUS','You run fast, Little Paw, and kill for your love. But you must think also of the pack. And of your own safety.','',26124),
(75049,'enUS','','Makar! I told you not to call me that anymore...',26124),
(75050,'enUS','Pandaren will tell this tale for generations!','',26124),
(75051,'enUS','Asha. \"Open sky.\" She will be fine. She is strong, like you.','',26124),
(75052,'enUS','It starts with a hero.','',26124),
(75053,'enUS','','I am going to Thunderfall, shaman. I will free Karg or die trying.',26124),
(75054,'enUS','An outsider, from beyond the mists!','',26124),
(75055,'enUS','No, and I would not try.','',26124),
(75056,'enUS','Conquering a strange new land!','',26124),
(75057,'enUS','','',26124),
(75058,'enUS','Must we use the word, \"Conquer?\"','',26124),
(75059,'enUS','Venturing into forgotten vaults...','',26124),
(75060,'enUS','I will rally the strongest of our riders from Stonefang. Find us where the giant\'s shadow meets the mountain of fury.','',26124),
(75061,'enUS','Mantid and mogu alike were brought low by the hero\'s fury.','',26124),
(75062,'enUS','We will show Fenris the Hunter there are yet jaws he cannot muzzle.','',26124),
(75063,'enUS','','Thank you, Makar.',26124),
(75064,'enUS','Their power and wisdom seized for a greater glory!','',26124),
(75065,'enUS','You fight with spirit of the pack in your blood and the fire of love in your heart. Precious gifts. Do not waste them.','',26124),
(75066,'enUS','When war came to Pandaria\'s shores, our hero was ready.','',26124),
(75067,'enUS','A faction standard-bearer, beloved by the people and feared by their foes.','',26124),
(75068,'enUS','Even the mighty Thunder King fell before our champion\'s might.','',26124),
(75069,'enUS','One by one the secrets of an ancient empire were laid bare.','',26124),
(75070,'enUS','Yes, knowledge uncovered for the benefit of the world.','',26124),
(75071,'enUS','POWER acquired for WAR and CONQUEST!','',26124),
(75072,'enUS','And then the Old One will remake this world for the Mantid!','',26124),
(75073,'enUS','I will drink your blood!','',26124),
(75074,'enUS','Let us stop for a moment - what kind of hero are we talking about?','',26124),
(75075,'enUS','Feast on the blood of our enemies!','',26124),
(75076,'enUS','Another notch for my blade.','',26124),
(75077,'enUS','Avenge me, brothers!','',26124),
(75078,'enUS','An agent of destruction, forged by my will to forever change the face of Azeroth.','',26124),
(75079,'enUS','We will slay you all as easily as we slew the Pandaren of old.','',26124),
(75080,'enUS','You move too slowly, how does your kind catch any prey?','',26124),
(75081,'enUS','I ache with power!','',26124),
(75082,'enUS','Muahahahahaha!','',26124),
(75083,'enUS','My friend, please think carefully about the legacy you will leave behind.','',26124),
(75084,'enUS','See Kil\'ruk? Speed is king!','',26124),
(75085,'enUS','Behold! Latent titan power, imbued with my own draconic essence, tempered by the wisdom of the pandaren celestials.','',26124),
(75086,'enUS','Much too slow.','',26124),
(75087,'enUS','Look how they fall, like so many blades of grass in the wind.','',26124),
(75088,'enUS','Curse this chitinous shell, I was not fast enough!','',26124),
(75089,'enUS','Overwhleming power. Use it to heal or destroy! To protect or annihilate!','',26124),
(75090,'enUS','How illogical, did they not hear your warning Kil\'ruk?','',26124),
(75091,'enUS','Chaos is order unrecognized by a lesser mind!','',26124),
(75092,'enUS','How about a game?','',26124),
(75093,'enUS','Come to me, champion! Collect your well-earned reward!','',26124),
(75094,'enUS','An interesting commonality, now to exploit it!','',26124),
(75095,'enUS','I see many threes repeating...','',26124),
(75096,'enUS','I predicted that to be a likely outcome.','',26124),
(75097,'enUS','So easily solved, you are not so complicated after all!','',26124),
(75098,'enUS','My calculations, incorrect? Perhaps another 800 years...','',26124),
(75099,'enUS','We have endured the Usurpers, their children, the loss of the Old One, and soon... you.','',26124),
(75100,'enUS','You now face the Prime. Bow down to your superior!','',26124),
(75101,'enUS','The amber protects us.','',26124),
(75102,'enUS','The Old One grants us strength.','',26124),
(75103,'enUS','The Usurpers abandoned you.','',26124),
(75104,'enUS','We remain unscathed.','',26124),
(75105,'enUS','How will the story end?','',26124),
(75106,'enUS','Return me to the amber...','',26124),
(75107,'enUS','It matters not, the Old One will not suffer their intrusion.','',26124),
(75108,'enUS','Come little Kunchongs, it\'s feeding time!','',26124),
(75109,'enUS','Your mind has grown weak since we last met.','',26124),
(75110,'enUS','Zor\'lok wasn\'t the only one with a strong voice.','',26124),
(75111,'enUS','There is only one way to find out.','',26124),
(75112,'enUS','A fitting meal for my children.','',26124),
(75113,'enUS','Let the feast begin!','',26124),
(75114,'enUS','Kovok... come to me... I need...','',26124),
(75115,'enUS','A pandaren legend is born! Sing praises to our new hero, $n!','',26124),
(75116,'enUS','Come children of the Titans, you face the Paragons.','',26124),
(75117,'enUS','Time for a little target practice.','',26124),
(75118,'enUS','Yes... a target of great importance.','',26124),
(75119,'enUS','My intelligence suggests this one is a high-value target.','',26124),
(75120,'enUS','Another kill, another trophy!','',26124),
(75121,'enUS','Target practice has ended.','',26124),
(75122,'enUS','The hunter... becomes... the hunted....','',26124),
(75123,'enUS','We Mantid serve a power far greater than they or their gods.','',26124),
(75124,'enUS','Have you come to try my new concoctions, Wakener?  I assure you these are nothing like you\'ve tasted before.','',26124),
(75125,'enUS','So many wonderful varieties, which concoction shall I give you?','',26124),
(75126,'enUS','All reactions begin with the proper catalyst.','',26124),
(75127,'enUS','My alchemy is supreme!','',26124),
(75128,'enUS','There is nothing the proper mixture can\'t handle.','',26124),
(75129,'enUS','I never discovered... how to put a stopper... in death...','',26124),
(75130,'enUS','Look brothers, the Wakener is here!','',26124),
(75131,'enUS','I will carry you one last time Wakener... to your doom!','',26124),
(75132,'enUS','I am a leaf on the wind!','',26124),
(75133,'enUS','Watch how I soar!','',26124),
(75134,'enUS','I did warn you, Wakener.','',26124),
(75135,'enUS','Well fought Wakener.  We will meet again...','',26124),
(75136,'enUS','They made it this far? I told you the others needed some micro-sonic genetic alterations.','',26124),
(75137,'enUS','Yes... new test subjects!','',26124),
(75138,'enUS','Success! They are alive!','',26124),
(75139,'enUS','Natural evolution takes far too long. Here, let me help you along...','',26124),
(75140,'enUS','Curses!  More data lost to an untimely death.','',26124),
(75141,'enUS','Hmmm, dead already?  I wonder if a session of micro-sonic deep-gene probing can reanimate them...','',26124),
(75142,'enUS','Perhaps I could have used... some enhancements... of my own...','',26124),
(75143,'enUS','Just look at this place! An entire ecology secluded, cut off from all known timelines!$b$bIt is rare for one such as I to be surprised by, well, anything really. I shall relish every moment I spend here.','',26124),
(75144,'enUS','Remember when we compelled the All-Seeing Eye to spy upon the Shadow Council?','Remember when we compelled the All-Seeing Eye to spy upon the Shadow Council?',26124),
(75145,'enUS','This... is a good death.','',26124),
(75148,'enUS','Nonsense. I had that handled. Cool as a cucumber.','',26124),
(75149,'enUS','The Warsong will NEVER surrender!','',26124),
(75150,'enUS','','I knew it. You should\'ve stayed back at the garrison, Archmage.',26124),
(75151,'enUS','','Khadgar will join us on the way. Come, Throm\'var lies just over the ridge.',26124),
(75152,'enUS','','I\'ve been scouting the dunes. A demonic force has infected some of the beasts.',26124),
(75153,'enUS','','We\'re certain the Shadow Council is involved, but we\'ve yet to pinpoint them.',26124),
(75157,'enUS','Stay away from me with those things!','',26124),
(75158,'enUS','Hmmm... It looks like these bunnies are to blame for the sickness that is spreading around.','Hold still. More help should arrive soon.',26124),
(75159,'enUS','You stand tall and proud atop your accomplishments, and this will be your downfall.','',26124),
(75160,'enUS','Should you wish to defeat the corruption, you will first need to purify the corruption within yourselves.','',26124),
(75161,'enUS','Nazgrim has failed us. Kor\'kron, destroy these intruders!','',26124),
(75162,'enUS','I will never fail the warchief!','',26124),
(75163,'enUS','Garrosh gives me strength!','',26124),
(75164,'enUS','Weaklings!','',26124),
(75165,'enUS','You dare challenge the warchief?','',26124),
(75166,'enUS','Witness the might of the true Horde!','',26124),
(75167,'enUS','The power of the warchief will overwhelm you!','',26124),
(75168,'enUS','The true Horde cannot be STOPPED!','',26124),
(75169,'enUS','Stand and FACE ME!','',26124),
(75170,'enUS','To die... for the warchief... is... an... honor...','',26124),
(75171,'enUS','The overwhelming power!','',26124),
(75172,'enUS','The warchief demands it!','',26124),
(75173,'enUS','The Iron Juggernaut focuses a |cFFFF0404|Hspell:144918|h[Cutter Laser]|h|r on you!','',26124),
(75174,'enUS','Kairoz! I want you to meet one of my most accomplished of agents.','',26124),
(75175,'enUS','Tell us again why this island is so unique?','',26124),
(75176,'enUS','I would very much like to study such unique items.','',26124),
(75177,'enUS','Oh?','',26124),
(75178,'enUS','...I like the way you think!','',26124),
(75179,'enUS','A pleasure.','',26124),
(75180,'enUS','We do not know! That is precisely why I am here.','',26124),
(75181,'enUS','Time is frozen in this place. The island teems with life, yet somehow never changes.','',26124),
(75182,'enUS','Until recently this place was lost in the mists. Those few inhabitants who found themselves stranded here were forced to mint their own currency, immune to time distortion. It is the only way trade is possible.','',26124),
(75183,'enUS','As would I! The presence of the Timeless Isle is proof that many things are possible beyond the boundaries of linear thinking.','',26124),
(75184,'enUS','Indeed. After the Cataclysm, my flight\'s connection to the timeways forever changed.','',26124),
(75185,'enUS','What if it were possible to shape and mold time as you would a ball of clay? What possibilities await? What new worlds could we create?','',26124),
(75186,'enUS','|TInterface\\Icons\\racial_orc_berserkerstrength.blp:20|t%s enters a |cFFF00000|Hspell:142879|h[Blood Rage]|h|r!','',26124),
(75187,'enUS','I can see the emptiness in your soul, $n. In the end, it will be I who compels you!','',26124),
(75188,'enUS','Begin the compulsion of the All-Seeing Eye.','Begin the compulsion of the All-Seeing Eye.',26124),
(75189,'enUS','|TInterface\\Icons\\racial_orc_berserkerstrength.blp:20|t%s\'s |cFFF00000|Hspell:142879|h[Blood Rage]|h|r subsides!','',26124),
(75190,'enUS','','Fools! These docks are under Dragonmaw control! Your ships will burn, and you with them!',26124),
(75191,'enUS','','Reinforcements to the docks!  Lok\'tar Ogar!',26124),
(75192,'enUS','','You think you have won? We are orcs! Pure of blood, commanded by the greatest Warchief who ever lived! Your blood will fill this bay!',26124),
(75193,'enUS','','Dragonmaw clan, retake the docks and push them into the sea!  In the name of Hellscream and the True Horde!',26124),
(75194,'enUS','','Next squad, push forward!',26124),
(75195,'enUS','','Dragonmaw, advance!',26124),
(75196,'enUS','','For Hellscream!',26124),
(75197,'enUS','','For the True Horde!',26124),
(75198,'enUS','','They\'ve breached the tower, bring it down!',26124),
(75199,'enUS','','Then they will die an honorable death in combat!',26124),
(75200,'enUS','','Turn the siege weapons to attack that tower, and bury them alive!',26124),
(75201,'enUS','','Galakras, rain fire on them!',26124),
(75202,'enUS','','Ahhhhhhh!',26124),
(75203,'enUS','','High King! I\'ve brought reinforcements.',26124),
(75204,'enUS','','I can open a portal to the docks... large enough to get a strike team through.',26124),
(75205,'enUS','','The Dragonmaw are supporting the Warchief.',26124),
(75206,'enUS','','We\'re going to need some serious firepower.',26124),
(75207,'enUS','','Here they come!',26124),
(75208,'enUS','','Help me!',26124),
(75209,'enUS','','Oh... thank you!',26124),
(75210,'enUS','','Nice shot!',26124),
(75211,'enUS','','She\'s turning her siege weapons on her own towers!',26124),
(75212,'enUS','','One down, one to go!',26124),
(75213,'enUS','','It worked!  The Proto-drake is falling!',26124),
(75214,'enUS','','We\'ve done it!',26124),
(75215,'enUS','','We\'ll hold the docks for the remaining landing parties. Follow the path to the gates of Orgrimmar, and make contact with Vol\'jin and his revolutionaries.',26124),
(75216,'enUS','','I\'ve conjured a Blizzard, lead them into it!',26124),
(75217,'enUS','','I... can\'t... go on...',26124),
(75218,'enUS','','Varian!  No!  Varian!!',26124),
(75219,'enUS','','You\'re still alive! Good. There\'s chaos in the city streets.',26124),
(75220,'enUS','','The Kor\'kron are making a push for this compound. They\'re not giving up!',26124),
(75221,'enUS','You heroes are a sight for sore eyes. Vol\'jin\'s rebellion wasn\'t able to secure the bay. We\'re taking a pounding.','',26124),
(75222,'enUS','Do it! Once the area is clear we will make landfall. Champions, I\'m counting on you.','',26124),
(75223,'enUS','Well done! Landing parties, form up! Footmen to the front!','',26124),
(75224,'enUS','Yes. My scouts learned all about this one.\"Warlord Zaela.\" Bring her proto-drake down and the rest of the Dragonmaw will crumble.','',26124),
(75225,'enUS','Commandeer those towers! Turn the anti-air batteries around and blast her from the sky!','',26124),
(75226,'enUS','Some of you should stay behind to hold the landing zone.','',26124),
(75227,'enUS','I can\'t take much more of this!','',26124),
(75228,'enUS','Thank you!','',26124),
(75229,'enUS','A mighty blow!','',26124),
(75230,'enUS','She\'s called in more siege weapons!','',26124),
(75231,'enUS','That\'s both of them!  Fire the cannons!','',26124),
(75232,'enUS','It\'s also coming right at us.  Watch out for the mouth!','',26124),
(75233,'enUS','Ha!  The bigger they are...','',26124),
(75234,'enUS','We will see if he has managed to keep up his end of the bargain.','',26124),
(75235,'enUS','Bring them within reach of my blade!','',26124),
(75236,'enUS','Jaina!  You ORCISH SCUM!','',26124),
(75237,'enUS','Anduin...','',26124),
(75238,'enUS','Our lines are holding, but Vol\'jin\'s rebels are taking a beating.','',26124),
(75239,'enUS','We\'ll post up here with some troops. Scout on ahead and see if you can flush Garrosh out of hiding.','',26124),
(75240,'enUS','We still have forces in that tower!','We still have forces in that tower!',26124),
(75241,'enUS','Bladefist Bay is fortified -- by the Sunwell, we\'re getting slaughtered!','',26124),
(75242,'enUS','Heroes. Port over to the docks and take out their shore defenses. Put a stop to this bloodshed.','',26124),
(75243,'enUS','Sylvanas! You will leave our corpses alone or I will deal with you here and now.','',26124),
(75244,'enUS','... well, I suppose that\'s between you and the Alliance, isn\'t it?','',26124),
(75245,'enUS','Well done. The first brigade has made landfall.','',26124),
(75246,'enUS','Strategy, Dark Lady. We should repurpose the shore defenses.','',26124),
(75247,'enUS','Heroes, take the towers, turn the guns onto that proto-drake, and blast it from the sky!','',26124),
(75248,'enUS','Some of you will need to stay behind to hold the beachhead.','',26124),
(75249,'enUS','I require assistance!','',26124),
(75250,'enUS','Ah, much improved.','',26124),
(75251,'enUS','Impressive!','',26124),
(75252,'enUS','She seems to be assaulting her own towers!','',26124),
(75253,'enUS','We are halfway there!','',26124),
(75254,'enUS','Finally!  I will never get all of this dust out of my robes.','',26124),
(75255,'enUS','I will take that as a compliment.  We\'ll hold the docks for now and marshall the forces. Vol\'jin should await you at the gates of Orgrimmar.','',26124),
(75256,'enUS','I\'m summoning a Flamestrike, lead them into it!','',26124),
(75257,'enUS','W...where...is this blood coming from?','',26124),
(75258,'enUS','Oh my, what has overcome our Dark Lady?','',26124),
(75259,'enUS','','I can raise your dead, Regent Lord. Your rangers can fight again.',26124),
(75260,'enUS','','I\'m sorry to see your lack of commitment... What of the human corpses?',26124),
(75261,'enUS','','Rise, my angels! Let your screams fill the streets of Orgrimmar with TERROR!',26124),
(75262,'enUS','','Garrosh really has gone all-out this time, hasn\'t he?  I expected more spikes, honestly.',26124),
(75263,'enUS','','I see the Dragonmaw have thrown in their lot with Garrosh.',26124),
(75264,'enUS','','My arrows alone cannot bring that monstrosity down.',26124),
(75265,'enUS','','Bring her down quick so I can wrap my fingers around her neck.',26124),
(75266,'enUS','','I will not fall, not here, not now!',26124),
(75267,'enUS','','I feel better already.',26124),
(75268,'enUS','','A bold move.',26124),
(75269,'enUS','','She\'s attacking the towers again.',26124),
(75270,'enUS','','You do realize we are directly below it, right?',26124),
(75271,'enUS','','Oh, you\'re still here?  I had kind of hoped that you had perished.  You would make a very attractive corpse.',26124),
(75272,'enUS','','If he\'s not dead.',26124),
(75273,'enUS','','A hail of death approaches! Bring them to their fate!',26124),
(75274,'enUS','','I can\'t wait to see the look on his face when I animate his corpse.',26124),
(75275,'enUS','','I will... rise... again...',26124),
(75276,'enUS','','Light the fuses! They will not leave this tower alive!',26124),
(75277,'enUS','','Is that all you\'ve got?',26124),
(75278,'enUS','','At least... I die... with honor...',26124),
(75279,'enUS','You dare try to take my tower?  Hahaha...','',26124),
(75280,'enUS','I am Dragonmaw, I am the blood of the Dragon and the fist of the Horde!','',26124),
(75281,'enUS','You... cannot win... this war...','',26124),
(75282,'enUS','','Where did my father put his notes? Surely they must be around here somewhere...',26124),
(75283,'enUS','','How am I supposed to make secret ingredient soup without the secret ingredient?',26124),
(75284,'enUS','','Drat, how am I supposed to run the family noodle cart if I don\'t know our family recipe?',26124),
(75285,'enUS','Who wants soup!','',26124),
(75286,'enUS','Ah, new customers. Welcome!','',26124),
(75287,'enUS','The secret to good noodle soup begins with strong, thick noodles!','',26124),
(75288,'enUS','The soup must be piping hot to warm the soul!','',26124),
(75289,'enUS','Leaving so soon? Do come again!','',26124),
(75290,'enUS','Leaving so soon? Be sure to tell your friends to stop by the Lin family noodle cart for some secret ingredient noodle soup.','',26124),
(75291,'enUS','Time to close already? Well, I guess I should get home to Chao-Wei.','',26124),
(75292,'enUS','Godspeed, heroes. It will be an honor to fight alongside you in battle.','',26124),
(75293,'enUS','Welcome to the party, $n.  Would you like to receive a lesson in how to fight with minions?','',26124),
(75294,'enUS','I\'ve brewed up a real fight if you think you can handle it.','',26124),
(75295,'enUS','Pet battles are the most awesome force that Azeroth has ever seen, but I\'ve seen those that wield it like a kid that\'s found his father\'s crossbow.  What about you?','',26124),
(75296,'enUS','The Celestial Tournament is nearly as old as Pandaria itself.  Many have come to test their mettle.  Shall we test yours?','',26124),
(75297,'enUS','','Did you come to see my pretty face, or are you looking for a fight?',26124),
(75298,'enUS','Never thought I was any good with animals \'til these little fellas started showin\' up.  So what do ye say, wanna fight?','',26124),
(75299,'enUS','My monks were shrunken by a troll witch doctor, and thus meet the size requirements for battle.  Do you wish to face them in combat?','',26124),
(75300,'enUS','Can you face the living waters and evade defeat?','',26124),
(75301,'enUS','Congratulations on your lucky win.  May your gift packages be filled with dead moles.','',26124),
(75302,'enUS','Well done, $n.  You fight as well as I can drink!','',26124),
(75303,'enUS','Well I, uh, I need to rethink everything.  Everything!','',26124),
(75304,'enUS','You have beaten me today, but you will need all the virtues to take on the Celestials.','',26124),
(75305,'enUS','','The lone wolf dies but the pack survives.',26124),
(75306,'enUS','How do ye even HEAL an undead raccoon?','',26124),
(75307,'enUS','It appears we have more training to do.','',26124),
(75308,'enUS','You fight with the ferocity of a raging river.  Let us hope you do not run dry.','',26124),
(75309,'enUS','Welcome to a very special trial!  The wisdom of a leader is reflected in the greatness of his followers. Let us see if your training has truly inspired those you lead...','',26124),
(75310,'enUS','In this trial, you will not be allowed to heal your pets.  One of the marks of a great leader is the ability to lead many subjects from many backgrounds, united under one banner.','',26124),
(75311,'enUS','Today, you will face many trainers, who have honed their skills and proven themselves.  Will your pets tell the same story about you?  We shall see!  Good luck!','',26124),
(75312,'enUS','Ah, you have raised your pets well, and beaten some of Pandaria\'s most seasoned and charismatic trainers.  But the trial is not over, oh no!','',26124),
(75313,'enUS','You shall face off against the true visages of wisdom, strength, fortitude, and hope - the children of the Celestials themselves!  Be warned, they have power and abilities the likes of which have not been seen for generations.','',26124),
(75314,'enUS','Hurrah for our new champions!  You have shown your own inner strength, and it is reflected in those you have raised.  They are lucky to have such a strong leader.  May the lessons of the Celestials light your way in the most trying of times.','',26124),
(75315,'enUS','Here we are, at the precipice of war. Signal to me when your troops are in order and I will issue the command to attack.','',26124),
(75316,'enUS','How many have to die before Garrosh\'s bloodlust is sated? It is with both shame and honor that I storm the walls of Orgrimmar, but I am glad to have you heroes at my side.','',26124),
(75317,'enUS','This is where it matters, hero. You may signal to me when you are ready to press the attack. Oh, and, do try to keep Lady Sylvanas in line, would you?','',26124),
(75318,'enUS','I will do my best, Regent Lord. My troops are ready.','I will do my best, Regent Lord. My troops are ready.',26124),
(75319,'enUS','My troops are yours to command, my King.','My troops are yours to command, my King.',26124),
(75320,'enUS','Tell my story...','Tell my story...',26124),
(75321,'enUS','','Well met, $n.',26124),
(75322,'enUS','I\'m ready to discover the secret ingredient in the Lin family\'s secret ingredient noodle soup!','I\'m ready to discover the secret ingredient in the Lin family\'s secret ingredient noodle soup!',26124),
(75323,'enUS','This will begin a solo scenario. Are you sure you wish to proceed?','This will begin a solo scenario. Are you sure you wish to proceed?',26124),
(75324,'enUS','','Grom\'gar is to the southeast. Look for the gigantic skeleton - you can\'t miss it.',26124),
(75325,'enUS','','I don\'t think Karg is out this far.',26124),
(75326,'enUS','','Grom\'gar. Built in the corpse of a colossus. Look at the size of that thing...',26124),
(75327,'enUS','The door barring the South Tower has been breached!','The door barring the South Tower has been breached!',26124),
(75328,'enUS','','There he is! Karg!',26124),
(75329,'enUS','The door barring the North Tower has been breached!','The door barring the North Tower has been breached!',26124),
(75330,'enUS','','I\'m not sure I want to see this thing\'s rear end.',26124),
(75331,'enUS','In the name of Warchief Garrosh, hold the line!','',26124),
(75332,'enUS','Crush them with iron! Drown them in blood!','',26124),
(75333,'enUS','For the honor of our fallen, kill them all!','',26124),
(75334,'enUS','It burns!','',26124),
(75335,'enUS','No more!','',26124),
(75336,'enUS','I\'ll show you nothing!','',26124),
(75337,'enUS','Reffus lliw uoy!','',26124),
(75338,'enUS','Your ancestors will languish!','',26124),
(75339,'enUS','I will eat your soul!','',26124),
(75340,'enUS','Aaaaaghh!','',26124),
(75341,'enUS','Lovely day for a compulsion!','',26124),
(75342,'enUS','Galakras staggers, but recovers from the blast!','Galakras staggers, but recovers from the blast!',26124),
(75343,'enUS','%s is blasted off of her mount!','%s is blasted off of her mount!',26124),
(75344,'enUS','Run for it!!!','',26124),
(75345,'enUS','Elune\'s radiance grant me strength!','Elune\'s radiance grant me strength!',26124),
(75346,'enUS','Bask in... the light of Elune... and... reveal all, demon!','Bask in... the light of Elune... and... reveal all, demon!',26124),
(75347,'enUS','The power of Elune compels you!','The power of Elune compels you!',26124),
(75348,'enUS','Blarggggrgggrggrrr!','',26124),
(75349,'enUS','Ahahahahaha!','',26124),
(75350,'enUS','No more! I will turn my gaze upon Gul\'var for you...','',26124),
(75351,'enUS','I will crush it! (The Pale are the key.)','',26124),
(75352,'enUS','The sprites look angry! Kill them while you can!','',26124),
(75353,'enUS','Welcome $n. Come, have a seat.','Welcome $n. Come, have a seat.',26124),
(75354,'enUS','I heard that this place has great noodle soup.','I heard that this place has great noodle soup.',26124),
(75355,'enUS','I sure am hungry.','I sure am hungry.',26124),
(75356,'enUS','I heard they discovered the lost secret of the Lin family\'s secret ingredient noodle soup.','I heard they discovered the lost secret of the Lin family\'s secret ingredient noodle soup.',26124),
(75357,'enUS','Finally got a seat, now what to eat?','Finally got a seat, now what to eat?',26124),
(75358,'enUS','Which noodle soup should I have?','Which noodle soup should I have?',26124),
(75359,'enUS','There are so many choices, I can\'t decide!','There are so many choices, I can\'t decide!',26124),
(75360,'enUS','This is so delicious!','This is so delicious!',26124),
(75361,'enUS','Ah.. noodle soup always refreshes both my body and my soul.','Ah.. noodle soup always refreshes both my body and my soul.',26124),
(75362,'enUS','I\'ve never had such excellent noodle soup before. What\'s the secret?','I\'ve never had such excellent noodle soup before. What\'s the secret?',26124),
(75363,'enUS','The service here is really slow.','The service here is really slow.',26124),
(75364,'enUS','I can\'t wait anymore, I\'ll go to Stoneplough. I hear they\'re cooking some Chimaerok Chops over there.','I can\'t wait anymore, I\'ll go to Stoneplough. I hear they\'re cooking some Chimaerok Chops over there.',26124),
(75365,'enUS','This place won\'t stay in business long if they keep this up.','This place won\'t stay in business long if they keep this up.',26124),
(75366,'enUS','This is okay; but not really what I wanted, shouldn\'t the chef know what I want?','This is okay; but not really what I wanted, shouldn\'t the chef know what I want?',26124),
(75367,'enUS','I\'ve had better.','I\'ve had better.',26124),
(75368,'enUS','Mmm, not spicy enough for my liking.','Mmm, not spicy enough for my liking.',26124),
(75369,'enUS','No... It cannot end...like this...What I... What I have seen...','',26124),
(75370,'enUS','%s prepares a |cFFFF0404|Hspell:143343|h[Deafening Screech]|h|r!','',26124),
(75371,'enUS','The priestess of the moon also has something to ask of you.','',26124),
(75372,'enUS','','Be careful. It\'s likely the rock has attracted the creatures of the woods.',26124),
(75373,'enUS','%s is devoured by Thok the Bloodthirsty!','%s is devoured by Thok the Bloodthirsty!',26124),
(75374,'enUS','Unlike you, your minions are adorable.','',26124),
(75375,'enUS','I have been programmed to gloat.  Ha ha.  Ha ha.  Ha ha.','',26124),
(75376,'enUS','This is unfortunate.','',26124),
(75377,'enUS','Now for a real pet.','',26124),
(75378,'enUS','How does that feel, $r?','',26124),
(75379,'enUS','If I had emotions, I still wouldn\'t feel sad about that.','',26124),
(75380,'enUS','A large device of unknown origin hums in front of you. Several words are scratched into the side:\n\n|TInterface\\Icons\\inv_gizmo_02:20|t |cFFDD2222[Goblin-Titan control module]|r\n\nIt appears to be protected by a voice-recognition module.','',26124),
(75381,'enUS','Kick the machine.','Kick the machine.',26124),
(75382,'enUS','Xuen will not be defeated. He is grace in battle.','',26124),
(75383,'enUS','They stand no chance against Xuen.','',26124),
(75384,'enUS','I am glad that I am not the one down there.','',26124),
(75385,'enUS','','Welcome, $n. I\'ve had the market area cleared to make room for Halfhill\'s first noodle stand, run by you!',26124),
(75386,'enUS','This will be a battle to tell your friends about, Eli.','',26124),
(75387,'enUS','','Customers will line up and wait for you to tell them to sit down. They will only wait for a short while before leaving so be sure to get them to a seat before they leave.',26124),
(75388,'enUS','','Once seated, a customer will wait a short while for you to deliver their noodle soup. As with waiting in line, be sure to get the customer their food before they decide to leave.',26124),
(75389,'enUS','','Some tips: You can always tell what a customer wants by their outfit.',26124),
(75390,'enUS','','Some customers are hungry, they\'ll want a second bowl after they finish their first.',26124),
(75391,'enUS','Be careful. I would not want you to fall into the arena.','',26124),
(75392,'enUS','','Other customers are impatient, they won\'t wait as long; but are really happy when they are served quickly.',26124),
(75393,'enUS','','Now get out there and make some noodle soup!',26124),
(75394,'enUS','Wow, I have quite an appetite today!','Wow, I have quite an appetite today!',26124),
(75395,'enUS','Your minion has been terminated.','',26124),
(75396,'enUS','My olfactory sensors detect a burning odor.','',26124),
(75397,'enUS','Too bad.  Now for a real pet.','',26124),
(75398,'enUS','You\'ll pay for that.','',26124),
(75400,'enUS','|TInterface\\Icons\\sha_ability_rogue_sturdyrecuperate.blp:20|t The %s begins to cast |cFFF00000|Hspell:144563|h[Imprison]|h|r!','|TInterface\\Icons\\sha_ability_rogue_sturdyrecuperate.blp:20|t The %s begins to cast |cFFF00000|Hspell:144563|h[Imprison]|h|r!',26124),
(75401,'enUS','This place is remarkable, don\'t you think?','',26124),
(75402,'enUS','Hey there, $n. Won\'t you try some of my hot noodle soup?','Hey there, $n. Won\'t you try some of my hot noodle soup?',26124),
(75403,'enUS','The tower reinforcements will not abandon their post!','The tower reinforcements will not abandon their post!',26124),
(75404,'enUS','','Burn, baby, burn!',26124),
(75405,'enUS','','This place is really heating up!',26124),
(75406,'enUS','','Who ever said fire can\'t be beautiful?',26124),
(75407,'enUS','Nobody understands me...','',26124),
(75408,'enUS','Everybody has fun but me.','',26124),
(75409,'enUS','Why come they make me watch stupid dead wolves?...  no fair.','',26124),
(75410,'enUS','','My vigil never ends, but I cherish this short reprieve in my duty.',26124),
(75411,'enUS','','A good battle always makes my adrenaline rush.',26124),
(75412,'enUS','','There are many gathered here from many walks of life. Today, we are all equal as audience to these epic battles.',26124),
(75413,'enUS','Why so surprised, $n?$b$bIt is as I have always told you. Pandaria is a wondrous land full of secrets and mysteries.','',26124),
(75414,'enUS','','Facing the celestials will test your resolve, question your skills, and call forth your greatness.$B$BAre you prepared?',26124),
(75415,'enUS','','It is unfortunate that this is not a contest of brewing. Never have I seen so many brewmasters gathered at once!',26124),
(75416,'enUS','','Let us see this day who defeats a celestial, and who is themselves defeated.',26124),
(75417,'enUS','','After all the Alliance has done to the pandaren, they still allow them here!',26124),
(75418,'enUS','','Perhaps we will be fortunate enough to watch an Alliance dog get torn limb from limb.',26124),
(75419,'enUS','','May the warchief guide you to victory.',26124),
(75420,'enUS','You want to fight celestials. Eh, wikket?$B$BKah Kah glad to watch, but not help.','',26124),
(75421,'enUS','Ookin\' jinyu shouldn\'t be here!$B$B$n $n want help Kah Kah ook some jinyu?','',26124),
(75422,'enUS','Want to give Kah Kah some of your shinies?$B$BThink of all the grookin\' Kah Kah could do with a weapon like that!','',26124),
(75423,'enUS','Who would\'ve thought this sort of place existed when we first saw Pandaria from Hellscream\'s Fist?','',26124),
(75424,'enUS','Two words: Ka-boom!$B$BAll I\'m sayin\' is that this shindig could benefit from a powder keg or two.','',26124),
(75425,'enUS','I\'m workin\' on a new invention that\'s goin\' to blow your mind!$B$BAnd probably maim other body parts.','',26124),
(75426,'enUS','','Let\'s see a good fight!',26124),
(75427,'enUS','','This sure is exciting, isn\'t it?',26124),
(75428,'enUS','','It\'s so nice to have a break from fighting the sha.',26124),
(75429,'enUS','','Fei Li needs to chill with all the fireworks.',26124),
(75430,'enUS','Keep it down! Stupid dog.','',26124),
(75431,'enUS','','There is a serenity to this place. It is untainted by the wars that ravage the mainland.',26124),
(75432,'enUS','','Stay true to yourself always, and your resolve will be that of a mighty glacier.',26124),
(75433,'enUS','Players capture control of the North Tower Anti-Air Turret!','Players capture control of the North Tower Anti-Air Turret!',26124),
(75434,'enUS','A mantid tried to follow me here.$B$BIt didn\'t end well for him.','',26124),
(75435,'enUS','There is much adventure to be had on this isle!','',26124),
(75436,'enUS','Here to join in on the fun, I see!','',26124),
(75437,'enUS','Relax. You are among friends.','',26124),
(75438,'enUS','Remain vigilant, but do not forget to enjoy the finer things in life. Good food, good friends, and good drink!','',26124),
(75439,'enUS','We can learn much by watching others do battle.','',26124),
(75440,'enUS','','It is truly an honor to be in the presence of Xuen and the other celestials.',26124),
(75441,'enUS','','I don\'t think I could ever challenge one of the celestials.',26124),
(75442,'enUS','','They say time does not affect this island. There must be many amazing things to find here!',26124),
(75443,'enUS','I\'ve never seen anything like the water here. It speaks, but I know not what it says.','',26124),
(75444,'enUS','Fight well, and bring honor to your people!','',26124),
(75445,'enUS','You fight with great skill and purpose. I hope to one day follow your path.','',26124),
(75446,'enUS','|TInterface\\Icons\\achievement_dungeon_ulduarraid_titan_01.blp:20|t You have been blessed with |cFFF00000|Hspell:144359|h[Gift of the Titans]|h|r!','|TInterface\\Icons\\achievement_dungeon_ulduarraid_titan_01.blp:20|t You have been blessed with |cFFF00000|Hspell:144359|h[Gift of the Titans]|h|r!',26124),
(75447,'enUS','','Once a customer is done eating, the seat they were using will need to be cleaned. Just click on them and I\'ll go clean up.',26124),
(75448,'enUS','I\'m thinking about jumping in the ring myself... just not right now.','',26124),
(75449,'enUS','After fighting the mogu, how much stronger could any other foes really be?','',26124),
(75450,'enUS','Stand up straight!','',26124),
(75451,'enUS','The Celestial Tournament tests your leadership skills through pet battles with other contestants, and if you are successful enough, the children of the celestials.','',26124),
(75452,'enUS','Sorry boss...','',26124),
(75453,'enUS','I\'d like to enter the Celestial Tournament.','I\'d like to enter the Celestial Tournament.',26124),
(75454,'enUS','What can I buy with Celestial Coins?','What can I buy with Celestial Coins?',26124),
(75455,'enUS','I feel drawn to Chi-Ji. Maybe the Red Crane will impart some of its wisdom to me.','',26124),
(75456,'enUS','Everybody fighting in the good way. Everybody drinking. Everybody happy!','',26124),
(75457,'enUS','You need drink! Drink! Be happy!','',26124),
(75458,'enUS','It good thing that this place is timeless. Ken-Ken hopes this never ends!','',26124),
(75459,'enUS','It is good to see Niuzao healthy and strong.','',26124),
(75460,'enUS','We must enjoy this time together before yet more conflict arrives on our doorsteps.','',26124),
(75461,'enUS','It has been quite some time since I have been so at ease!','',26124),
(75462,'enUS','I\'m not a fighter. I grow vegetables and raise yaks.$B$BYou fight, I\'ll watch.','',26124),
(75463,'enUS','Champion... you\'ve done it...','',26124),
(75464,'enUS','How\'d you like to make yourself useful and top me off?','',26124),
(75465,'enUS','Few mortals possess such spirit, such power. Believe me - I have tested many!','',26124),
(75466,'enUS','I\'m thinking of trying to grow some crops here.$B$BCan you imagine what might happen if I planted an engima seed?','',26124),
(75467,'enUS','To complete our great work, we will need a sacred place.','',26124),
(75468,'enUS','Travel to the Vale of Eternal Blossoms, and meet me at the Seat of Knowledge.','',26124),
(75469,'enUS','A legend is born!','',26124),
(75470,'enUS','What are the requirements to enter the Celestial Tournament?','What are the requirements to enter the Celestial Tournament?',26124),
(75471,'enUS','Only those who have trained extensively can enter the tournament.\n\nWhen you have trained 15 pets to their maximum level, you will be deemed ready.','',26124),
(75472,'enUS','Tell me about the tournament again.','Tell me about the tournament again.',26124),
(75473,'enUS','Lokra! My love! What are you doing here?!','',26124),
(75474,'enUS','','What\'s it look like? Saving your hide!',26124),
(75475,'enUS','','Where is Nerok?',26124),
(75476,'enUS','We were separated. Where is Asha?','',26124),
(75477,'enUS','Hmph. I always knew Draka was stronger than she let on.','',26124),
(75478,'enUS','These here chicks might be small right now, but they grow up fast!','',26124),
(75479,'enUS','Less fightin\', more farmin\'. That\'s the life, I tell ya.$B$B\'Course, if yer doin\' the fightin\', I don\'t mind watchin\'.','',26124),
(75480,'enUS','Humph. Back in my day, we had to walk uphill both ways in the snow to see a celestial.','',26124),
(75481,'enUS','','I would gladly fight by your side, but you do not require my assistance.',26124),
(75482,'enUS','','I am excited to see the full potential from a true $c.',26124),
(75483,'enUS','','The arena is a bit loud for my tastes, but it is worth it to witness such a spectacle.',26124),
(75484,'enUS','','Do you like my outfit today?',26124),
(75485,'enUS','','I wish you the best of luck on your adventures here!',26124),
(75486,'enUS','','I can\'t believe both Farmer Yoon and Farmer Fung are here!$B$BWhat\'s a girl to do?',26124),
(75487,'enUS','How\'s about we sit down and chat over a nice cold brew?','',26124),
(75488,'enUS','A lot of the Tillers came here to watch the fights. Nothing like a good brawl and a cold brew!','',26124),
(75489,'enUS','Have a good fight, but don\'t forget to tend to your farm afterwards!','',26124),
(75490,'enUS','A good bout in the arena will keep you strong for future trials.','',26124),
(75491,'enUS','There are many hidden things on this island. You should seek them out.','',26124),
(75492,'enUS','It is always good to see a strong $r like yourself.','',26124),
(75493,'enUS','This is history in the making...','',26124),
(75494,'enUS','I sure am a long way from home!','',26124),
(75495,'enUS','...Interesting.','',26124),
(75496,'enUS','I\'ve never fought much, but this is exciting!','',26124),
(75497,'enUS','Wow, what a fight!','',26124),
(75498,'enUS','Hero, you are an inspiration!','',26124),
(75499,'enUS','','This will make for a good story, don\'tcha think?',26124),
(75500,'enUS','I knew you were destined for greatness.','',26124),
(75501,'enUS','','I\'ve been wrastlin\' celestials all mornin\'!',26124),
(75502,'enUS','An opportunity presents itself! I believe the Timeless Isle holds the key to unlocking the full potential of your cloak.','',26124),
(75503,'enUS','An island, lost in time, where the sun never sets. What could it mean?','',26124),
(75504,'enUS','Power! Glory! Loot!','',26124),
(75505,'enUS','...Ours for the taking! Hero, meet me at the Timeless Isle.','',26124),
(75506,'enUS','','There\'s so much going on! Isn\'t it exciting?',26124),
(75507,'enUS','I should very much like to see this island for myself. Perhaps I will see you there?','',26124),
(75508,'enUS','Woo! You ook \'em good!','',26124),
(75509,'enUS','How\'s it goin\', boss? Drink a brew for Mung-Mung!','',26124),
(75510,'enUS','Mung-Mung tried some of the beer at Pi\'jiu. Terrible!','',26124),
(75511,'enUS','You\'re going to die in horrible pain, $p!','',26124),
(75512,'enUS','Since I\'m not farming right now, this is a great way to pass the time!','',26124),
(75513,'enUS','Don\'t forget to take a break between battles. A good $c knows when not to fight.','',26124),
(75514,'enUS','Not bad.','',26124),
(75515,'enUS','The might of the Burning Legion will fall upon your worlds!','',26124),
(75516,'enUS','A succulent priestess of the moon. What a tasty morsel you\'ll make, delightful Delas.','',26124),
(75517,'enUS','I see all! Not one of you will escape my wrath!','',26124),
(75518,'enUS','Mung-Mung is too impatient to farm on his own.$B$BI am trying to help him take things more slowly.','',26124),
(75519,'enUS','Ah... the inestimable Khadgar. Your suffering will be legendary.','',26124),
(75520,'enUS','Draenor is nothing. It will fall, just as Argus fell. Just as your world will soon be consumed!','',26124),
(75521,'enUS','$p, set me free and I will reward you beyond your wildest dreams!','',26124),
(75522,'enUS','This pitiful trap cannot hold me. Better that you let me go now while I still might grant you a quick death.','',26124),
(75523,'enUS','','Oh! Hello there! I... um... didn\'t expect to see you here!$B$B<Ella looks back to the arena suddenly.>',26124),
(75524,'enUS','The pandaren will sing your praises for ages to come.','',26124),
(75525,'enUS','','The pink cranes are beautiful!$B$BI mean... if you wanted to know...',26124),
(75526,'enUS','','Oh, I really should go check on my cats. I hope they\'re okay!',26124),
(75527,'enUS','This place is quite strange. There is powerful magic everywhere around us.','',26124),
(75528,'enUS','I dare not create a portal here. The results could be... interesting.','',26124),
(75529,'enUS','I have heard that there are many hidden treasures on the island.','',26124),
(75530,'enUS','Face my axe!','',26124),
(75531,'enUS','','For the Frostwolf clan!',26124),
(75532,'enUS','What\'s this?! A couple of stray mutts, who need to be put down!','',26124),
(75533,'enUS','','I will never forget my father\'s sacrifice.',26124),
(75534,'enUS','URGH! Damn... unruly dogs...','',26124),
(75535,'enUS','You should have killed me when you had the chance. Now where is my wolf?!','',26124),
(75536,'enUS','I know. We\'d better find him before that happens.','',26124),
(75537,'enUS','','Being broken? Nerok would die before he obeyed them!',26124),
(75538,'enUS','','I would be lying if I said that I did not appreciate this opportunity to relax.',26124),
(75539,'enUS','','These matches remind me of my time training as a young recruit.',26124),
(75540,'enUS','There is no room for war here.','',26124),
(75541,'enUS','Fight with honor always.','',26124),
(75542,'enUS','A soldier\'s duty is never done.','',26124),
(75543,'enUS','','Stop, summoner. Spare my people, and you\'ll find what you seek below us, at The Arbitum.',26124),
(75544,'enUS','Deploy the gear! Establish a perimeter!','',26124),
(75545,'enUS','Oh, hello friends! We\'ve just about secured the surface. It looks like the real fight\'s going to be down here!','',26124),
(75546,'enUS','Don\'t worry, we\'ve got your back! Forge ahead, brave heroes!','',26124),
(75547,'enUS','Oh, look at her over there.  She\'s be beautiful.  A perfect 10!','',26124),
(75548,'enUS','A 10? Ha! Maybe in Razor Hill.  In Orgrimmar she\'d only be a 6.','',26124),
(75549,'enUS','','Did you hear that Tina Mudclaw is here?$B$BI wonder if Farmer Yoon or Farmer Fung have noticed...',26124),
(75550,'enUS','','It is so relaxing to not have to run the market for once.',26124),
(75551,'enUS','','I should have brought a cart with me. There\'s money to be made here!',26124),
(75552,'enUS','Power... drained...','Power... drained...',26124),
(75553,'enUS','Your strength has helped free this land of its long held darkness. It is my honor to witness your deeds with my own eyes, Champion.','',26124),
(75554,'enUS','So weak...','So weak...',26124),
(75555,'enUS','The dark star fails me...','The dark star fails me...',26124),
(75556,'enUS','No...','No...',26124),
(75557,'enUS','This tree stands as a symbol of hope. Hope that the land might in time be healed and made stronger by your deeds.','',26124),
(75558,'enUS','You continue to impress me, $n.','',26124),
(75559,'enUS','It is too late, Priestess. We know of your precious \"prophecy.\"','',26124),
(75560,'enUS','Now... tell me where the Iris crystals are guarded, or watch more of your companions die.','',26124),
(75562,'enUS','','There is much work ahead of us if we are to heal the land and mend our wounds. But thanks to your deeds we no longer must work in the shadow of the seven breaths of Y\'Shaarj.$b$bIn time, the sha will cease to be, and your name will be remembered with the reverence of the last emperor.',26124),
(75563,'enUS','How about a drink, $c?','',26124),
(75564,'enUS','Fight with purpose, friend.','',26124),
(75565,'enUS','','It is truly admirable to do combat with a celestial.',26124),
(75566,'enUS','','There is always value  in spending time with old friends.',26124),
(75567,'enUS','','This island holds many secrets that have yet to be uncovered.',26124),
(75568,'enUS','Fortune smiles on us this day. There are many people to deliver things to.','',26124),
(75569,'enUS','You have the stride of a champion, $r.','',26124),
(75570,'enUS','A good grummle is a busy grummle!','',26124),
(75571,'enUS','May your brews be strong, and your heart stronger.','',26124),
(75572,'enUS','Your story continues on, friend.$B$BIt is a story worth reading.','',26124),
(75573,'enUS','You fight like a true $r.','',26124),
(75574,'enUS','There is no greater joy than walking the world, writing your story.$B$BIt is the wanderer\'s way.','',26124),
(75575,'enUS','An occasion like this calls for a drink!','',26124),
(75576,'enUS','','Wanna go explore the island together?',26124),
(75577,'enUS','','Have you seen the fireworks? They\'re beautiful!',26124),
(75578,'enUS','','The celestials are so huge!',26124),
(75579,'enUS','','Wow, you must be a $c, huh?$B$B$Cs are the best!',26124),
(75580,'enUS','The Shadowmoon came without warning. Quickly, champion, help us defend the upper platform!','',26124),
(75581,'enUS','Fighting and beer. There is no greater place than this.','',26124),
(75582,'enUS','Next round\'s on me!','',26124),
(75583,'enUS','Today is a good day.','',26124),
(75584,'enUS','I\'ve got agents on every continent in the world and none of them can give me a clear picture of what happened in Orgrimmar!','',26124),
(75585,'enUS','Idiot king!','',26124),
(75586,'enUS','You can never leave this place. There is no way home.','',26124),
(75587,'enUS','You will die when you leave this place.  There is nothing left of your world.','',26124),
(75588,'enUS','You have already lost.','',26124),
(75589,'enUS','All of your friends are dead.','',26124),
(75590,'enUS','No one is coming to save you.','',26124),
(75591,'enUS','Your allies will leave you behind.','',26124),
(75592,'enUS','You cannot succeed. Your cause is hopeless.','',26124),
(75593,'enUS','Your allies think you are weak.','',26124),
(75594,'enUS','You do not have the strength to defeat him. You are too weak to carry on.','',26124),
(75595,'enUS','','|cFFFF8040Ki the Assassin |r|cFF71D5FF|Hspell:145427|h[Kick]|h|r|cFFFF8040s the $n.|r',26124),
(75596,'enUS','','|cFFFF8040Kavan the Arcanist |r|cFF71D5FF|Hspell:145530|h[Counterspell]|h|r|cFFFF8040s the $n.|r',26124),
(75597,'enUS','','The lights went out here at the Observatory shortly before the Shadowmoon attacked.',26124),
(75598,'enUS','','From Teluuna Observatory, we watch the movements of the stars.',26124),
(75599,'enUS','','The Prophet\'s work is very important.',26124),
(75600,'enUS','','I have studied the Light since I was a young girl.',26124),
(75601,'enUS','','The stars can tell us much about our past and future, if you only know how to read the signs.',26124),
(75602,'enUS','','Sometimes, on a cold dark night, I can hear a voice from the distant stars. <Sylene laughs nervously.> That\'s silly, isn\'t it?',26124),
(75603,'enUS','','The Shadowmoon orcs are powerful shaman.',26124),
(75604,'enUS','','Some say the moon is a seductress, luring wanderers with her silvery light. Those who drink in too much of her glow... can lose their minds.',26124),
(75605,'enUS','For Warchief Garrosh!!!','',26124),
(75606,'enUS','Please come down, Fish. It isn\'t safe up there.','',26124),
(75607,'enUS','If you fall off, I\'m not going in after you!','',26124),
(75608,'enUS','Please, come down. How am I ever going to explain this to the rest of the Tillers?','',26124),
(75609,'enUS','Fine, fall off. I don\'t care.','',26124),
(75618,'enUS','I\'ve learned so much about brewing. I haven\'t gotten my brew just right yet, but it\'s getting there!','',26124),
(75619,'enUS','What do you currently have in stock?','What do you currently have in stock?',26124),
(75620,'enUS','I give myself to you, dark star...','I give myself to you, dark star...',26124),
(75621,'enUS','Void, hear my call!','Void, hear my call!',26124),
(75622,'enUS','I give myself unto the void...','I give myself unto the void...',26124),
(75623,'enUS','Voidy voidy void void...','Voidy voidy void void...',26124),
(75624,'enUS','','How about a nice brew?',26124),
(75625,'enUS','','You look like you could use a drink.',26124),
(75626,'enUS','','Fighting isn\'t fighting without a fine ale!',26124),
(75627,'enUS','There\'s nothing better than a fine brew!','',26124),
(75628,'enUS','How about another round?','',26124),
(75629,'enUS','You are what you drink, $n -- I hope you have been drinking something strong.','',26124),
(75630,'enUS','You fought well, but your tactics are all wrong.  Have a drink and and rethink them.','',26124),
(75631,'enUS','Look at this, I have been beaten!  I\'m going to have to brew up some ideas for next time.','',26124),
(75632,'enUS','Why did he fight?  To die, apparently.','',26124),
(75633,'enUS','The wind blows in my favor.','',26124),
(75634,'enUS','A fortunate attack!','',26124),
(75635,'enUS','I knew that was coming.','',26124),
(75636,'enUS','Such a glorious defeat!','',26124),
(75637,'enUS','Rest for now, little friend.','',26124),
(75638,'enUS','Maybe, uh, maybe you\'re ready for a lesson in chaos?','',26124),
(75639,'enUS','You were so preoccupied with whether or not you could win, you didn\'t stop to think if you should.','',26124),
(75640,'enUS','Gee, the lack of humility before nature that\'s being displayed here, uh... staggers me.','',26124),
(75641,'enUS','What\'s so great about victory? It\'s a violent, penetrative act that scars what it explores. What you call victory... well, nevermind.','',26124),
(75642,'enUS','Dead?  Don\'t you mean extinct?','',26124),
(75643,'enUS','Your pet had its shot, and nature selected it for extinction.','',26124),
(75644,'enUS','I\'m, I\'m simply saying that life, uh... didn\'t find a way.','',26124),
(75645,'enUS','That\'s, that\'s chaos theory.','',26124),
(75646,'enUS','What have you got on that team of yours, King Mukla?','',26124),
(75647,'enUS','Dinos... dropping?  Dropping?','',26124),
(75648,'enUS','You now face Patience!  Wisdom!  Knowledge!  What virtues do you possess, $n?','',26124),
(75649,'enUS','Today you have lost -- but what have you learned?','',26124),
(75650,'enUS','You have taught me much, $r.  It seems the master has again become the student.','',26124),
(75651,'enUS','A worthy sacrifice.','',26124),
(75652,'enUS','The autumn leaves must fall to make room for spring blossoms.','',26124),
(75653,'enUS','Defeat is merely a lesson masked by disappointment.','',26124),
(75654,'enUS','Like the stream meeting the cliff, there is beauty in the fall, if you know where to look.','',26124),
(75655,'enUS','To die would be a wonderfully grand adventure.','',26124),
(75656,'enUS','When one virtue is lost, cling to those that remain.','',26124),
(75657,'enUS','A worthy sacrifice?','',26124),
(75658,'enUS','','Oh, I hope you like surprises.',26124),
(75659,'enUS','','You\'re lucky it was just your pets... this time.',26124),
(75660,'enUS','','In the Celestial Tournament, either you win or you die.',26124),
(75661,'enUS','','Take the right opponent out and it\'s all downhill from there.',26124),
(75662,'enUS','','Oh, was that one of your favorites?  My bad.',26124),
(75663,'enUS','','This is so easy it would be boring -- if it weren\'t so much fun.',26124),
(75664,'enUS','','You bastard, my pet may never walk again!',26124),
(75665,'enUS','','The things we love destroy us every time, $c, remember that.',26124),
(75666,'enUS','','Keep killing my pets and you may find a dash of poison in your drink tonight.',26124),
(75667,'enUS','','Fear cuts deeper than swords.',26124),
(75668,'enUS','Yer lucky Gizmo couldn\'t be here, but I\'ll still wipe the floor with ye, $c.','',26124),
(75669,'enUS','That one\'s for you, Gizmo!','',26124),
(75670,'enUS','Ach, so much for being good with animals. Now how do these bandages work?','',26124),
(75671,'enUS','Ha!  That worked better than I thought!','',26124),
(75672,'enUS','Oh, sorry, that fella\'s gunna need some tender lovin\' later.','',26124),
(75673,'enUS','Fer a moment there, I thought we were in trouble.','',26124),
(75674,'enUS','No! Not again!','',26124),
(75675,'enUS','Curse my dwarven luck!','',26124),
(75676,'enUS','Oi, you\'ll pay for that one you will!','',26124),
(75677,'enUS','Do not be fooled by their diminutive size, $n, they are disciplined and quick.','',26124),
(75678,'enUS','Impatience is the road to defeat, you must learn to master your timing.','',26124),
(75679,'enUS','It requires a cunning strategist indeed to defeat my monks.  Well done, $n.','',26124),
(75680,'enUS','Exactly as I had planned.','',26124),
(75681,'enUS','You lack the necessary discipline.','',26124),
(75682,'enUS','Can you survive with what remains?','',26124),
(75683,'enUS','He fought and died with honor.','',26124),
(75684,'enUS','Victory often requires sacrifice.','',26124),
(75685,'enUS','When one Shado-Pan falls, another steps forward to take his place.','',26124),
(75686,'enUS','As water cracks stone, so shall we be your undoing.','',26124),
(75687,'enUS','The rivers foretold of this triumph.','',26124),
(75688,'enUS','The rivers foretold of this defeat.','',26124),
(75689,'enUS','And so they are washed away with little trace of what once was.','',26124),
(75690,'enUS','The stone thinks itself unmovable until the ground is washed away beneath it.','',26124),
(75691,'enUS','Cleansed by the righteous waters!','',26124),
(75692,'enUS','My companion is dispersed.  She will flow back to me when the time is right.','',26124),
(75693,'enUS','The river does not stop from a single stone.','',26124),
(75694,'enUS','The ebbs and flows of battle are to be expected.','',26124),
(75695,'enUS','The eons have awakened me.','',26124),
(75696,'enUS','Dragons are dangerous at any size, as I\'m sure you\'ll find out.','',26124),
(75697,'enUS','If I can win a battle like that, I may have a chance against the Celestials.','',26124),
(75698,'enUS','Well done, $n.  You picked your friends wisely and led them with honor.','',26124),
(75699,'enUS','As I warned you before, dragons are known for their deadly attacks.','',26124),
(75700,'enUS','Even the strongest ally can fall to draconic magic.','',26124),
(75701,'enUS','A glass cannon sometimes breaks before it can fire.','',26124),
(75702,'enUS','You have strength I didn\'t see at first.','',26124),
(75703,'enUS','An unexpected move.','',26124),
(75704,'enUS','It will be difficult to recover from such a loss.','',26124),
(75705,'enUS','Zooooooooom!','',26124),
(75706,'enUS','Do not despair the damage that was done here.','',26124),
(75707,'enUS','A long time ago, this land was beset by the shadows of doubt, of fear, and hatred.','',26124),
(75708,'enUS','One by one, I overcame them - and buried them deep within the earth.','',26124),
(75709,'enUS','And there ... they remained.','',26124),
(75710,'enUS','For ten thousand years ... as the veil of mists kept Pandaria hidden from prying eyes.','',26124),
(75711,'enUS','When the Cataclysm struck, I decided the time had come to part the mists ... and help heal our broken world.','',26124),
(75712,'enUS','But as your war-fleets crashed upon our shores, all of my old doubts and fears rose up, to torment the land once again.','',26124),
(75713,'enUS','You triumphed over the darkness I had locked away.','',26124),
(75714,'enUS','You have shown Pandaria the power of a true hero.','',26124),
(75715,'enUS','But the question still remains... why do we fight?','',26124),
(75716,'enUS','Face your fears. Calm your hatreds.','',26124),
(75717,'enUS','Find peace within yourself, so that you may share it with the world around you.','',26124),
(75718,'enUS','These are the greatest treasures in life.','',26124),
(75719,'enUS','Surely they... are worth fighting for.','',26124),
(75720,'enUS','Heh, sounds like Malkorok just tore apart those intruders.','',26124),
(75721,'enUS','I don\'t know, I\'ve got a bad feeling. It\'s way too quiet in there.','',26124),
(75722,'enUS','It\'s busting out of the cage!  Arm the shock collar, get that thing under control!','',26124),
(75723,'enUS','Shock it until it can\'t move anymore!  It\'s causing a riot in here!','',26124),
(75724,'enUS','Deal with the devilsaur first, then we\'ll lock the rest up!','',26124),
(75725,'enUS','Fools! Imbeciles!','',26124),
(75726,'enUS','I have been apprising the lorewalker of your deeds, champion. Are you ready to hear your tale?','',26124),
(75727,'enUS','Tell my story.','Tell my story.',26124),
(75728,'enUS','Be wary... I suspect the stones will be heavily-guarded.','',26124),
(75729,'enUS','','Please be swift and merciful. Those creatures are the true victims here.',26124),
(75730,'enUS','','Khadgar. I was just explaining the situation.',26124),
(75731,'enUS','Greetings, farseer. We come on a matter of great urgency. $n, the savior of Wor\'gol, will vouch for us.','',26124),
(75732,'enUS','Greetings, commander. It is good to see you again.','',26124),
(75733,'enUS','Indeed. The Shadow Council is nearby and with them, Gul\'dan. I can feel it.','',26124),
(75734,'enUS','Honor our death $n!!','',26124),
(75735,'enUS','','Greetings, $n. You have freed me from this cave, and I wish to thank you. Please, accept my gift and my humble gratitude.',26124),
(75736,'enUS','I accept this gift.','I accept this gift.',26124),
(75737,'enUS','Come, face me. Give in to your pride. Show me your \"Greatness.\"','',26124),
(75738,'enUS','So foolish...','',26124),
(75739,'enUS','You are better than your companions!','',26124),
(75740,'enUS','Your arrogance compels you...','',26124),
(75741,'enUS','Succumb to your pride!','',26124),
(75742,'enUS','Your arrogance feeds me!','',26124),
(75743,'enUS','You should bow to no king or warchief.','',26124),
(75744,'enUS','You\'ve let your pride cloud your vision, Titan puppet! You can never contain ME!','',26124),
(75745,'enUS','That one is WEAK.','',26124),
(75746,'enUS','That one is unworthy of your group.','',26124),
(75747,'enUS','Blame your companions!','',26124),
(75748,'enUS','Half of the Vale lies in ruin! These outsiders have been more destructive than the mantid and mogu combined!','',26124),
(75749,'enUS','We\'re here to lend our aid. We can help you rebuild the Vale.','',26124),
(75750,'enUS','Hey, we recording?  Yeah?  Okay.  Goblin-Titan control module starting up, please stand back.','',26124),
(75751,'enUS','Checking out the datas, hold on a second will ya.','',26124),
(75752,'enUS','Oh, now you did it, that was really really really not the correct input code.','',26124),
(75753,'enUS','|TInterface\\Icons\\ability_garrosh_whirling_corruption.blp:20|t%s begins to cast |cFFFF0000|Hspell:144985|h[Whirling Corruption]|h|r!','',26124),
(75754,'enUS','Activating GB-11010 \"Armageddon\"-class defense systems. Hey, does anybody know if we\'re zoned for this?','',26124),
(75755,'enUS','Goblin-like typing detected, unlocking cache of riches and treasures.','',26124),
(75756,'enUS','Initiating system reset. Module 1 at 50%%. Hey, system reset requires two modules to complete.','',26124),
(75757,'enUS','Module 1\'s all prepared for system reset.','',26124),
(75758,'enUS','Initiating system reset. Module 2 at 50%%. Hey, system reset requires two modules to complete.','',26124),
(75759,'enUS','Module 2\'s all prepared for system reset.','',26124),
(75760,'enUS','System resetting. Don\'t turn the power off, or the whole thing will probably explode.','',26124),
(75761,'enUS','Security system deactivated.  Welcome back Siegecrafter Blackfuse.','',26124),
(75762,'enUS','|TInterface\\Icons\\ability_titankeeper_uncheckedcorruption.blp:20|t%s begins to cast |cFFFF0000|Hspell:147011|h[Manifest Rage]|h|r!','',26124),
(75763,'enUS','Have a great day and don\'t let the door hit you on the way out.','',26124),
(75764,'enUS','|TInterface\\Icons\\ability_garrosh_empowered_whirling_corruption.blp:20|t%s begins to cast |cFFFF0000|Hspell:144985|h[Empowered Whirling Corruption]|h|r!','',26124),
(75765,'enUS','System\'s shutting down.  HEY DOES ANYONE KNOW IF ITS SUPPOSED TO BE DOING THIS?','',26124),
(75766,'enUS','\"Armageddon\"-class defense systems fully on-line. Here comes the explosions!','',26124),
(75767,'enUS','Stop working and I\'ll sacrifice you to the dark!','Stop working and I\'ll sacrifice you to the dark!',26124),
(75768,'enUS','You think this is a game, runt? Work harder!','You think this is a game, runt? Work harder!',26124),
(75769,'enUS','Put your back into it!','Put your back into it!',26124),
(75770,'enUS','The Iron Horde needs these supplies. Faster!','The Iron Horde needs these supplies. Faster!',26124),
(75771,'enUS','Do you want the Iron Horde to crush us? Keep moving!','Do you want the Iron Horde to crush us? Keep moving!',26124),
(75772,'enUS','Dear Emperor. It is done. The darkness that you once struggled against has been purged from Pandaria - forever.','',26124),
(75773,'enUS','But the cost... such a terrible cost.','',26124),
(75774,'enUS','Be careful. The demon will try to trick you.','',26124),
(75775,'enUS','Look out. Invaders!','',26124),
(75776,'enUS','These outsiders have brought chaos to this land. Can we trust them to set it right?','',26124),
(75777,'enUS','Wicked! You found my body! Look at them old bones.','',26124),
(75778,'enUS','I really thought I\'d be more excited about this...','',26124),
(75779,'enUS','Know what? I don\'t even want \'em. I like being able to float around freely.','',26124),
(75780,'enUS','It appears that this fishgorged crane suffered a violent death.$B$BThere are bites and claw marks all over its body and most of its viscera have been consumed.$B$BThis must be a favorite meal of something ravenous.','It appears that this fishgorged crane suffered a violent death.$B$BThere are bites and claw marks all over its body and most of its viscera have been consumed.$B$BThis must be a favorite meal of something ravenous.',26124),
(75781,'enUS','You will fall before the true Horde!','You will fall before the true Horde!',26124),
(75782,'enUS','For Warchief Garrosh!','For Warchief Garrosh!',26124),
(75783,'enUS','Your skull will make a fine prize!','Your skull will make a fine prize!',26124),
(75784,'enUS','None can stand against Garrosh!','None can stand against Garrosh!',26124),
(75785,'enUS','','Come with me, $n.',26124),
(75786,'enUS','','We draenei have long held an uneasy peace with the Shadowmoon orc clan.',26124),
(75787,'enUS','','But their aggression has grown ever since the Iron Horde arrived in our valley.',26124),
(75788,'enUS','','Now, it seems they seek Iris crystals - special gems that contain incredible latent energy.',26124),
(75789,'enUS','','Anyway, could you check those telescopes for me?',26124),
(75790,'enUS','You are the chosen! The might of the true Horde!','',26124),
(75791,'enUS','','Gul\'dan sends his best.',26124),
(75792,'enUS','Our armies shall shake the pillars of the world!','',26124),
(75793,'enUS','Those who stand against us will receive no mercy!','',26124),
(75794,'enUS','We shall claim victory for Warchief Garrosh!','',26124),
(75795,'enUS','|TInterface\\Icons\\ability_vehicle_demolisherflamecatapult.blp:20|tThe Horde Fleet begins their |cFFFF0000|Hspell:147088|h[Bombardment]|h|r!','',26124),
(75796,'enUS','Those who meddle with the timeways for their own selfish ends are often dangerous.\n\nIt is for this reason I joined Wardens, staunch defenders of the Timewalkers.\n\nWe guard the Watchers and Weavers as they go about their tasks.','',26124),
(75797,'enUS','I trust you have learned: To fight out of fear or anger is to fight a war that never ends.','',26124),
(75798,'enUS','A complete waste!','',26124),
(75799,'enUS','|TInterface\\Icons\\ability_garrosh_siege_engine.blp:20|t The Fleet Captain detected a cluster! Firing |cFFFF0000|Hspell:147047|h[Unstable Iron Star]|h|r!','',26124),
(75800,'enUS','Another failure! Bring that beast down before he gets loose!','',26124),
(75801,'enUS','Once I\'ve perfected the infusing process, the power of Y\'Shaarj will make us unstoppable!','',26124),
(75802,'enUS','The Weavers are arcanists who specialize in chronomancy; the art of weaving time.\n\nAmongst the Timewalkers, we alone can repair damage to the timeways, open temporal portals, and other such tasks.\n\nThese things once came easily to the bronze dragonflight, but alas, no longer.','',26124),
(75803,'enUS','','The Watchers are the Timewalkers\' scholars and scouts, researchers and spies.\n\nWe watch the timeways and record, investigate, and report temporal tampering and unusual phenomena.\n\nIt was a Watcher, of course, that brought the Timewalkers\' attention to this bizarre, timeless isle.',26124),
(75804,'enUS','|TInterface\\Icons\\sha_ability_rogue_envelopingshadows.blp:20|t You are afflicted with |cFFF00000|Hspell:146817|h[Aura of Pride]|h|r!','|TInterface\\Icons\\sha_ability_rogue_envelopingshadows.blp:20|t You are afflicted with  |cFFF00000|Hspell:146817|h[Aura of Pride]|h|r!',26124),
(75805,'enUS','I hold some of the emperor\'s most prized possessions. Should you wish to curry favor with Shaohao, you may aid us by driving back the Ordon yaungol that seek to overtake the Celestial Court.','I hold some of the emperor\'s most prized possessions. Should you wish to curry favor with Shaohao, you may aid us by driving back the Ordon yaungol that seek to overtake the Celestial Court.',26124),
(75806,'enUS','Let the intruders come this way! I look forward to crushing their skulls.','',26124),
(75807,'enUS','Of course, those cowards will likely sneak by rather than face my wrath.','',26124),
(75808,'enUS','What else would you expect from those without valor?','',26124),
(75809,'enUS','Falling to me would probably be the greatest achievement they could hope to obtain.','',26124),
(75810,'enUS','What can I buy with timeless coins?','What can I buy with timeless coins?',26124),
(75811,'enUS','%s caused the Unstable Iron Star to explode.','',26124),
(75812,'enUS','Let\'s settle this.','',26124),
(75813,'enUS','Hehehehahahaha!','',26124),
(75814,'enUS','Alright, boys. Let\'s show \'em how Blackfuse Company fights.','',26124),
(75815,'enUS','Nobody beats Blackfuse. NOBODY!','',26124),
(75816,'enUS','Never interrupt an artist!','',26124),
(75817,'enUS','Hey! You\'re gonna pay for that!','',26124),
(75818,'enUS','You son of a...','',26124),
(75819,'enUS','My legacy... will live on...','',26124),
(75820,'enUS','You think you have WON?  You are BLIND.  I WILL FORCE YOUR EYES OPEN.','',26124),
(75821,'enUS','BEHOLD, MY GLORIOUS DESTINY!','',26124),
(75822,'enUS','THERE IS NO PLACE FOR YOU IN MY WORLD.','',26124),
(75823,'enUS','I WILL DESTROY EVERYTHING YOU HAVE EVER LOVED.','',26124),
(75824,'enUS','No... NO... This world... Is my destiny... My destiny...','',26124),
(75825,'enUS','I, Garrosh, son of Grom, will show you what it means to be called Hellscream!','',26124),
(75826,'enUS','Over here, hero!','',26124),
(75827,'enUS','My my - this is all that remains of the terrible being that haunted Pandaria all these years.','',26124),
(75828,'enUS','Whatever darkness it once exuded is silent at last.','',26124),
(75829,'enUS','Come with me, hero. Let us return to the Vale. There is someone I think who would be particularly interested in this turn of events, if we can get his attention.','',26124),
(75830,'enUS','Let\'s go.','Let\'s go.',26124),
(75831,'enUS','I\'m ready.','I\'m ready.',26124),
(75832,'enUS','','You\'re right, you\'re not going out there!',26124),
(75833,'enUS','We\'re under attack!','',26124),
(75834,'enUS','You were there! Is it true then? What happened in Orgrimmar?','',26124),
(75835,'enUS','','Kazdar said they knew of the prophecy... but how? This is disturbing news, indeed.',26124),
(75836,'enUS','That fool king!!','',26124),
(75837,'enUS','I did everything in my power. The whole world was his, he needed only seize it!','',26124),
(75838,'enUS','Oh sure, another year of fighting. Enormous casualties trying to take Thunder Bluff. But the rest of the Horde would\'ve caved, eventually.','',26124),
(75839,'enUS','TONG! DRINK! NOW!','',26124),
(75840,'enUS','What? Yes, I was backing the Alliance.','',26124),
(75841,'enUS','I thought Hellscream\'s victory was assured before he turned half of his Horde against him. So I changed my allegiance.','',26124),
(75842,'enUS','%s falls to his knees in defeat. Your army retreats.','%s falls to her knees in defeat. Your army retreats.',26124),
(75843,'enUS','|TInterface\\Icons\\ability_warlock_eradication.blp:20|t%s casts |cFFFF0000|Hspell:147209|h[Malice]|h|r on |cFFFF0000$n|r!','',26124),
(75844,'enUS','I yield!','I yield!',26124),
(75845,'enUS','Do you yield?','Do you yield?',26124),
(75846,'enUS','','',26124),
(75847,'enUS','Welcome to the Proving Grounds. Your first trial will now begin. Defeat each wave of illusions before time runs out.','',26124),
(75848,'enUS','As before, defeat each wave of illusions before time runs out. This time, you will encounter more difficult illusions.','',26124),
(75849,'enUS','Prepare yourself for the most difficult illusions. Defeat them before time expires, and success will be yours.','',26124),
(75850,'enUS','This trial will test how far your skill can take you. It will never end; it only gets more challenging.','',26124),
(75851,'enUS','Success! Hah, well done. See me for your next trial.','',26124),
(75852,'enUS','You have run out of time. Shall we try again?','',26124),
(75853,'enUS','Illusionary Varmints come in packs, and are harmless. Use attacks that affect multiple opponents to kill them quickly.','',26124),
(75854,'enUS','The Illusionary Amber-Weaver conjures globs of amber that float toward you and explode on any contact. Lead the amber globs into other illusions.','',26124),
(75855,'enUS','Ah, the Illusionary Banana-Tosser! It will rapidly toss bananas toward you. Move to avoid them. Prevent it from running away from you, if you can.','',26124),
(75856,'enUS','The Illusionary Mystic will heal any ally that is significantly wounded. Interrupt its healing spells.','',26124),
(75857,'enUS','A master of defense, the Illusionary Guardian deflects all attacks from the front. Stay behind it.','',26124),
(75858,'enUS','Oh, the Illusionary Sha! Save your strongest attacks for when its barrier falls, leaving it exposed.','',26124),
(75859,'enUS','This Illusionary Slayer will test your ability to damage your opponent. Do not worry; it cannot harm you.','',26124),
(75860,'enUS','An Illusionary Banshee! Kill it, quickly, before it explodes!','',26124),
(75861,'enUS','Hello. For this trial, you must keep us alive while we face the incoming illusions. I am Oto, and will protect you.','',26124),
(75862,'enUS','Hold tight! I am coming!','',26124),
(75863,'enUS','I am a wall of iron, but I cannot hold much longer!','',26124),
(75864,'enUS','Illusionary Hive-Singers! Their sonic waves will harm us all.','',26124),
(75865,'enUS','Ah, a new challenge, Illusionary Conquerors! When they become enraged, they strike with incredible power.','',26124),
(75866,'enUS','I have fallen. I am sorry, I shall train harder for next time.','',26124),
(75867,'enUS','','Oto! I cannot attack them while they are attacking me!',26124),
(75868,'enUS','','An Aqua Bomb has detonated! Dispel it faster, next time.',26124),
(75869,'enUS','','These Illusionary Aqualytes will affect us with dark magic. Dispel it quickly.',26124),
(75870,'enUS','','I am down! Quick healing spells would be best for emergencies like that!',26124),
(75871,'enUS','','Hello again. More illusions approach, and we will require your healing arts.',26124),
(75872,'enUS','','Sorry, vanishing!',26124),
(75873,'enUS','','I am sure they are trying, Kavan. Be nice.',26124),
(75874,'enUS','','Sooli, move!',26124),
(75875,'enUS','','Ah, our first enemy! Illusionary Rippers are but simple warriors. Now, let us do this!',26124),
(75876,'enUS','','Illusionary Flamecallers! Watch your feet, everyone. Do not stand in the lava.',26124),
(75877,'enUS','','I am down. Let us try again!',26124),
(75878,'enUS','','Oh no, did you forget to heal yourself?',26124),
(75879,'enUS','','The illusions will not hold back, this time. Their attacks will be relentless. Be prepared to use your strongest healing spells.',26124),
(75880,'enUS','Oh dear. Speedy, help!','',26124),
(75881,'enUS','Huh? Ohhhh, ohhh!','',26124),
(75882,'enUS','Ahh, Illusionary Tunnelers! Speedy and I have faced these foes before. Beware, they may burrow into the ground and then suddenly pop up under a new target, and CHOMP! Hah ha hah ha.','',26124),
(75883,'enUS','Argh... please... take care... of Speedy!','',26124),
(75884,'enUS','There is no end in sight to these illusions, but we shall hold out as long as we can.','',26124),
(75885,'enUS','Hah ha! Wonderful job, everyone! Friend, see Rotun about beginning the next trial.','',26124),
(75886,'enUS','I will not fall again!','',26124),
(75887,'enUS','You are an honorable Orc, Nazgrim. I regret what I must do.','',26124),
(75888,'enUS','You fought with honor. Gamon will ensure that your legacy lives on. For the Horde, my friend.','',26124),
(75889,'enUS','It cannot end... like... this...','',26124),
(75890,'enUS','Can you stand on the tallest peak, winds and sleet buffeting your skin, until the trees wither and the mountains fall into the sea?','',26124),
(75891,'enUS','We shall see.','',26124),
(75892,'enUS','The winds may be strong, and the sleet may sting.','',26124),
(75893,'enUS','You are the mountain, unmovable by all but time.','',26124),
(75894,'enUS','Be vigilant in your stand, or you will never achieve your goals.','',26124),
(75895,'enUS','You must persevere!','',26124),
(75896,'enUS','Though you will be surrounded by foes greater than you can imagine, your fortitude shall allow you to endure. Remember this in the times ahead.','',26124),
(75897,'enUS','When faced with challenges the like you have never seen, what do you hope for? What is the future you seek?','',26124),
(75898,'enUS','Then let us begin.','',26124),
(75899,'enUS','Believe in one another, and let others carry hope for you!','',26124),
(75900,'enUS','Without hope, there is no brightness in the future!','',26124),
(75901,'enUS','Create the destiny you seek!','',26124),
(75902,'enUS','Do not give up on yourself!','',26124),
(75903,'enUS','Your hope shines brightly, and even more brightly when you work together to overcome. It will ever light your way in even the darkest of places.','',26124),
(75904,'enUS','The lesson of true wisdom lies within you dear heroes, and in the choices you make. When faced with overwhelming darkness, will you make the right decisions?','',26124),
(75905,'enUS','The trial begins!','',26124),
(75906,'enUS','Listen to your inner voice, and seek out the truth!','',26124),
(75907,'enUS','Do not let your judgment be clouded in trying times!','',26124),
(75908,'enUS','Always consider the consequences of your actions!','',26124),
(75909,'enUS','Learn from your mistakes!','',26124),
(75910,'enUS','Your wisdom has seen you through this trial. May it ever light your way out of dark places.','',26124),
(75911,'enUS','Strength. It is far more than simple physical prowess. When you are truly tested, will you be able to tell the difference between strength and power?','',26124),
(75912,'enUS','Ha ha! The trial commences!','',26124),
(75913,'enUS','Believe in your strength!','',26124),
(75914,'enUS','You have the power to change your destiny!','',26124),
(75915,'enUS','Do not mistake the power that darkness offers for true strength!','',26124),
(75916,'enUS','Return twice as powerful!','',26124),
(75917,'enUS','You are strong, stronger even than you realize. Carry this thought with you into the darkness ahead, and let it shield you.','',26124),
(75918,'enUS','Ah, finally some action. Lok\'tar Ogar!','',26124),
(75919,'enUS','Ha... ha ha... well-struck...','',26124),
(75920,'enUS','Don\'t be foolish, Vol\'jin! You have no siege weapons left! You cannot win this battle!','',26124),
(75921,'enUS','You may have defeated my war machine, but the gate still stands. You will not take Orgrimmar today.','',26124),
(75922,'enUS','What? Kor\'kron, to the gates! Now!','',26124),
(75923,'enUS','No alliance hand has ever struck me down. Do you think you are seasoned enough?','',26124),
(75924,'enUS','I am Nazgrim, fist of the Warchief and General of the Horde Army. If I must die today, I will die with honor, in battle, for the horde!','',26124),
(75925,'enUS','You should have trained harder.','',26124),
(75926,'enUS','I die... with honor... Lok\'tar Ogar...','',26124),
(75927,'enUS','Ah... Gamon... you have finally learned... I am proud... to have died... at your hands...','',26124),
(75928,'enUS','Ah... you have learned much... and learned well... an honorable battle.','',26124),
(75929,'enUS','In the end, I stood by the warchief, because it was my duty, and I am glad that it was you who struck me down. May your strength... lead the horde... into a new era of prosperity...','',26124),
(75930,'enUS','For the horde...','',26124),
(75931,'enUS','So, it has come to this. Together, we have learned and grown over the years, and now we find ourselves face to face on the battlefield. Do not think I will go easy on you, nor do I expect any quarter. What we do now, we do for the horde, both of us.','',26124),
(75932,'enUS','It is an honor to finally face you in combat. Lok\'tar Ogar, for Honor, and for the Horde!','',26124),
(75933,'enUS','Long ago, the Jade Serpent instructed me to purify my spirit and become one with the land, my doubts were vanquished.','',26124),
(75934,'enUS','When my journey began, I was reckless in my strength. The White Tiger taught me control. My hatred, anger, and violence were vanquished.','',26124),
(75935,'enUS','The Red Crane saw hope in me, and instructed me to look inward. Despite my visage of despair, I found this hope, and the despair was vanquished.','',26124),
(75936,'enUS','In the face of great fear, the Black Ox taught me fortitude. Through terror and darkness it persevered. The fear was vanquished.','',26124),
(75937,'enUS','You have walked the trial of wisdom, and learned of the path of the Jade Serpent. May you learn from this lesson, as I did.','',26124),
(75938,'enUS','You have walked the trial of strength, and learned of the path of the White Tiger. May you remember this lesson, always.','',26124),
(75939,'enUS','You have walked the trial of hope, and learned of the path of the Red Crane. May it guide your footsteps through time.','',26124),
(75940,'enUS','You have walked the trial of fortitude, and learned of the path of the Black Ox. May it bless your passage.','',26124),
(75941,'enUS','I have tried everything to remove this cave-in!  Black Ox give me fortitude, I cannot move even a single rock. Perhaps if I were to borrow one of the great weapons of legend from the temple grounds...','',26124),
(75942,'enUS','My friend, please, meet me near the Big Blossom Mine in the center of the Vale. There is something I wish to show you there.','',26124),
(75943,'enUS','Riko Riko has a nice ring to it...','',26124),
(75944,'enUS','Oh, don\'t look so surprised! I\'m a black dragon. My loyalties are my own.','',26124),
(75945,'enUS','Riko like all the fireworks!','',26124),
(75947,'enUS','Riko had an idea. Grookin\' club!','',26124),
(75948,'enUS','When the river turns left or right, flow along it instead of fight.','',26124),
(75949,'enUS','Never forget your greatest friend, they stick with you until the end.','',26124),
(75950,'enUS','The emperor is very near; fought doubt, hate, rage, despair, and fear.','',26124),
(75951,'enUS','But that idiot, IDIOT Wrynn! \"High King\" indeed!','',26124),
(75952,'enUS','Why did he allow another warchief? He could\'ve united the world under the Alliance banner. What a fool I was to trust his ambition!','',26124),
(75953,'enUS','Should\'ve taken over the throne room myself. Like Auntie Onyxia. Get things DONE.','',26124),
(75954,'enUS','%s will not be pulled from his tower!','%s will not be pulled from her tower!',26124),
(75955,'enUS','Please take care, $n.\n\nThe August Celestials will not tolerate aggression between the Alliance and Horde here.','',26124),
(75956,'enUS','','Help! Get these things off of me!',26124),
(75957,'enUS','','What are you standing in?! Get out of the fire!',26124),
(75958,'enUS','','Illusionary Rippers approaching. They should pose little challenge; they are but mindless grunts.',26124),
(75959,'enUS','','Prepare your defenses. That is an Illusionary Conqueror! When they become enraged, they gain great strength, and nothing can stop them.',26124),
(75960,'enUS','','A new enemy, Illusionary Flamecallers. They cast fireballs and spew lava. Use the lava to your advantage; it will burn the other illusions.',26124),
(75961,'enUS','','Beware! Illusionary Wind-Guards can use their wings to knock you back. When they do, they will likely switch to attacking me instead.',26124),
(75962,'enUS','','Illusionary Ambushers! Get their attention, quick. And get them away from me, so they cannot hit me with their devastating bananas!',26124),
(75963,'enUS','','Illusionary Foragers are attacking. Do not let their cute faces fool you. They can work together to cause terrible devastation.',26124),
(75964,'enUS','','Ahh, I cannot heal through that much damage! Did you forget to equip your heaviest armor?!',26124),
(75965,'enUS','','I am down. Maybe I should bring more healing herbs for next time.',26124),
(75966,'enUS','','Greetings. I am Sikari, master of jade lightning, chi, and healing mists. For this trial, you must protect me from the incoming illusions, while I heal you and dispatch our foes.',26124),
(75967,'enUS','','Greetings, again. Our next trial will be more challenging. Prepare to defend me.',26124),
(75968,'enUS','','Once again, you must defend me. Rotun, give us a challenge this time.',26124),
(75969,'enUS','','While our end is inevitable, let us try to take as many of them down with us as we can. Be ready.',26124),
(75970,'enUS','With the Sha of Doubt defeated you are ready to read the scroll.','',26124),
(75971,'enUS','You have already done what you can for this lost knowledge.','',26124),
(75972,'enUS','Be careful out there.\n\nAside from all the gigantic beasts, there\'s an enemy camp on the other end of this beach.','',26124),
(75973,'enUS','%s squints menacingly.','',26124),
(75974,'enUS','Do give my regards to Khadgar. I\'ve a present coming for him.','',26124),
(75975,'enUS','The pain!','The pain!',26124),
(75976,'enUS','','Assassin!',26124),
(75977,'enUS','Enough!!','',26124),
(75978,'enUS','Talk! Talk! Talk!','',26124),
(75979,'enUS','Always you speak. Never do you listen! You ignore the lessons of Pandaria!','',26124),
(75980,'enUS','You see, there is balance in all things. Wisdom etched in our very fur: Black and white. Darkness and light.','',26124),
(75981,'enUS','When the last emperor hid our land from the rest of the world, he also preserved the homeland of our ancient enemy, the mantid. Why did he do this?','',26124),
(75982,'enUS','So it is with your Alliance and your Horde. They are not strong despite one another; they are strong BECAUSE of one another.','',26124),
(75983,'enUS','You mistake your greatest strength for weakness. Do you see this?','',26124),
(75984,'enUS','...He destroyed my inn. He left no tip. He is not nice.','',26124),
(75985,'enUS','Uhh... wha?','',26124),
(75986,'enUS','...you ...you\'re just a WAITER!','',26124),
(75987,'enUS','I promise you this: I will stop at nothing to prepare this world for the battle to come.','',26124),
(75988,'enUS','Next time, I will leave nothing to chance.','',26124),
(75989,'enUS','NOTHING!','',26124),
(75990,'enUS','He did so to keep the land whole. Living with the mantid for ten thousand years has made us both STRONG.','',26124),
(75991,'enUS','Have fun dealing with this.','',26124),
(75992,'enUS','\"Though blood floods the ground, the mountain is unmoved.\" - Niuzao','\"Though blood floods the ground, the mountain is unmoved.\" - Niuzao',26124),
(75993,'enUS','\"The truth shines brightest in clouded times.\" - Yu\'lon','\"The truth shines brightest in clouded times.\" - Yu\'lon',26124),
(75994,'enUS','\"Hope\'s fire grows when the flames come together.\" - Chi-Ji','\"Hope\'s fire grows when the flames come together.\" - Chi-Ji',26124),
(75995,'enUS','\"Strength and power are as different as sun and moon.\" - Xuen','\"Strength and power are as different as sun and moon.\" - Xuen',26124),
(75996,'enUS','The shrine was corrupted by Ordos!','The shrine was corrupted by Ordos!',26124),
(75997,'enUS','','Click on a patron who is waiting in line. You should see them wave to you when you have successfully interacted with them.',26124),
(75998,'enUS','|TInterface\\Icons\\ability_racial_timeismoney.blp:20|t|cFFFF0000|Hspell:146506|h[Waiting in Line]|h|r','|TInterface\\Icons\\ability_racial_timeismoney.blp:20|t|cFFFF0000|Hspell:146506|h[Waiting in Line]|h|r',26124),
(75999,'enUS','','When a customer has been selected, click on an open seat and the customer will go sit there.',26124),
(76000,'enUS','|TInterface\\Icons\\inv_misc_fork&knife.blp:20|t|cFFFF0000|Hspell:146448|h[Waiting for Food]|h|r','|TInterface\\Icons\\inv_misc_fork&knife.blp:20|t|cFFFF0000|Hspell:146448|h[Waiting for Food]|h|r',26124),
(76001,'enUS','Khadgar, let\'s go over what happened when Garona attacked.','Khadgar, let\'s go over what happened when Garona attacked.',26124),
(76002,'enUS','We must defend the pools from their corruption!','',26124),
(76003,'enUS','Our work is not yet complete! Stop them!','',26124),
(76004,'enUS','Defend the pools!','',26124),
(76005,'enUS','','Make some noodle soup for your customer. This is a scholar so they like the simplicity of a standard noodle soup. Try making one now.',26124),
(76006,'enUS','','Now that the soup is made, pick it up by clicking on it. Soups will go bad if left out too long so only make what you need for your customers.',26124),
(76007,'enUS','','Now click on the seated customer to deliver them their noodle soup.',26124),
(76008,'enUS','','Excellent! Now your customer will happily eat the noodle soup you\'ve made for them. When they\'re done they\'ll leave happy.',26124),
(76009,'enUS','Are you leaving the camp?\n\nThe August Celestials have requested that we not push our forces any further into the island, so we\'re staying here to secure this landing point.\n\nWatch yourself out there. The enemy has taken an interest in this place, too. Their camp is on the other end of the beach, and well-guarded.','',26124),
(76010,'enUS','My life for the flame!','',26124),
(76011,'enUS','Ordos guide my way!','',26124),
(76012,'enUS','The flames are truth!','',26124),
(76013,'enUS','My fate is written in flames!','',26124),
(76014,'enUS','You will perish in agony!','',26124),
(76015,'enUS','For Ordos!','',26124),
(76016,'enUS','I serve the fire gods!','',26124),
(76017,'enUS','For the ever-burning flame!','',26124),
(76022,'enUS','Stand in the light and be judged!','',26124),
(76023,'enUS','You... Rook knows you....','',26124),
(76024,'enUS','Rook... does not know... head... is cloudy....','',26124),
(76025,'enUS','','We know only despair now. A fitting punishment for our failure....',26124),
(76026,'enUS','Please... help....','',26124),
(76027,'enUS','No! We are not finished.','',26124),
(76028,'enUS','The waters have not been cleansed!','',26124),
(76029,'enUS','These interlopers must be stopped before our work is undone!','',26124),
(76030,'enUS','Defend me!','',26124),
(76031,'enUS','You must protect me.','',26124),
(76032,'enUS','It falls to you to defend your master.','',26124),
(76033,'enUS','You meddle in affairs beyond your comprehension.','',26124),
(76034,'enUS','|TInterface\\Icons\\INV_MISC_FOOD_COOKED_GREATPABANQUET_POT.BLP:20|t|cFFFF0000|Hspell:146498|h[Hungry]|h|r','|TInterface\\Icons\\INV_MISC_FOOD_COOKED_GREATPABANQUET_POT.BLP:20|t|cFFFF0000|Hspell:146498|h[Hungry]|h|r',26124),
(76035,'enUS','|TInterface\\Icons\\ability_hunter_posthaste.BLP:20|t|cFFFF0000|Hspell:146497|h[Impatient]|h|r','|TInterface\\Icons\\ability_hunter_posthaste.BLP:20|t|cFFFF0000|Hspell:146497|h[Impatient]|h|r',26124),
(76036,'enUS','It looks as if $n has decided to heal and revive his pets!  $gHis:Her; progress in the tournament has been reset, and they will be allowed to attempt each challenge again.','',26124),
(76037,'enUS','Someone warn the master!','',26124),
(76038,'enUS','Once you have the demon\'s heart, we\'ll forge the soul trap.','',26124),
(76039,'enUS','Quickly. Combine the shards to forge a soul trap for Gul\'dan.','',26124),
(76040,'enUS','Don\'t worry about me. They can\'t see this projection.$B$BEverything we do here is leading to one thing, $n: Gul\'dan\'s capture.','',26124),
(76041,'enUS','Be careful, my friend. Gul\'dan is not to be underestimated no matter how prepared you might be.','',26124),
(76042,'enUS','I am not that easy.','',26124),
(76043,'enUS','Razuun, your time has come.','',26124),
(76044,'enUS','What? No...','',26124),
(76045,'enUS','No matter. Soon there will be enough felblood to make thousands for the Burning Legion.','',26124),
(76046,'enUS','Honorless pup. His death is his greatest achievement.','',26124),
(76047,'enUS','Ahahahaha... you are too late. Even now, the crystal is on its way to Shaz\'gul.','',26124),
(76048,'enUS','/sigh','',26124),
(76049,'enUS','','You\'ve let too many customers get away. Perhaps you should try again?',26124),
(76050,'enUS','','Well done!',26124),
(76051,'enUS','Why not?','',26124),
(76052,'enUS','Isn\'t that the same spear you use to hunt rabbits?','',26124),
(76053,'enUS','Agreed, I don\'t even want my spear anymore...','',26124),
(76054,'enUS','Throm-Ka, warriors of the great Frostwolf clan.','',26124),
(76055,'enUS','Because it\'s tainted with this youngling\'s weak blood.','',26124),
(76056,'enUS','It\'s imperative we find the council\'s base of operations and deal with them.','',26124),
(76057,'enUS','So... what\'s your point?','',26124),
(76058,'enUS','Warden, let\'s go make your introduction to the farseer at Throm\'var.','Warden, let\'s go make your introduction to the farseer at Throm\'var.',26124),
(76059,'enUS','','To think: This place has been outside our time stream - and existence itself! - for millennia.\n\nOur most experienced Weavers assure us the island\'s temporal position is presently stable, but still, I wonder...\n\nWhat would happen if it vanished again while we were upon it?',26124),
(76060,'enUS','Commander, if you\'d be so kind as to make our introductions.','',26124),
(76061,'enUS','Champion of the Frostwolf clan, if they are friends of yours, then they are welcome here.','',26124),
(76062,'enUS','....','',26124),
(76063,'enUS','Thank you... emperor. Thank you.','',26124),
(76064,'enUS','The pain.','',26124),
(76065,'enUS','Fight, my brothers. Show them what it means to be Warsong.','',26124),
(76066,'enUS','Rabbits are pretty weak.','',26124),
(76067,'enUS','Please be swift and merciful. The Mother of Wolves is the true victim here.','',26124),
(76068,'enUS','Shut up.','',26124),
(76069,'enUS','The Spineclaw scuttles away in fear!','',26124),
(76070,'enUS','Galakras is hit! Nice shot!','Galakras is hit! Nice shot!',26124),
(76071,'enUS','I\'m ready for my next shift at the noodle stand!','I\'m ready for my next shift at the noodle stand!',26124),
(76072,'enUS','','We stand behind Dezco and his choices. We will stand against the mogu, the saurok, the sha, even the warchief of the Horde. We will protect this Vale to the last, if necessary.',26124),
(76073,'enUS','I will destroy you!','',26124),
(76074,'enUS','Well played.','',26124),
(76075,'enUS','You win this round...','',26124),
(76076,'enUS','I will burn your corpses to ash!','',26124),
(76077,'enUS','What IS this place?','',26124),
(76078,'enUS','I\'ve been here for hours and the sun hasn\'t moved...','',26124),
(76079,'enUS','What could create such a thing?','',26124),
(76080,'enUS','Is it dangerous?','',26124),
(76081,'enUS','I will.','',26124),
(76082,'enUS','A pandaren enigma, my young prince! A mystery in the mists.','',26124),
(76083,'enUS','Exactly. Time is frozen in perpetuity. Cause and effect - rendered all but meaningless.','',26124),
(76084,'enUS','I should like to find out! Perhaps it is related to the mists? Or the power that was unleashed in the sundering ten thousand years ago? We must investigate!','',26124),
(76085,'enUS','Indeed. This place overturns our very notion of time, and how it shapes the universe.','',26124),
(76086,'enUS','Stranded on this island you will find the most dangerous creatures in all of Pandaria. Explore if you must, Prince Anduin. But be cautious.','',26124),
(76087,'enUS','Hello, $c.  Have you come to learn the secrets of the Timeless Isle?','',26124),
(76088,'enUS','','Can you believe this place?  There\'s so much to learn and discover!  I\'m going to fill up books and books with all my findings here.$b$bBut it\'s just so much information, I don\'t know how anyone could possibly read through it all.  Chadrik thought we could write it up as a song, but that\'s silly... right?',26124),
(76089,'enUS','Your journey ends here cowards! These doors won\'t open as long as I live!','',26124),
(76090,'enUS','Lok-Narash!','',26124),
(76091,'enUS','...kill... me.','...kill... me.',26124),
(76092,'enUS','[%s] confesses: I haven\'t visited Sunsong Ranch in months. I can just imagine weeds and virmen everywhere.','[%s] confesses: I haven\'t visited Sunsong Ranch in months. I can just imagine weeds and virmen everywhere.',26124),
(76093,'enUS','[%s] confesses: I think one time I tried to kill Lei Shi instead of Lei Shen.','[%s] confesses: I think one time I tried to kill Lei Shi instead of Lei Shen.',26124),
(76094,'enUS','[%s] confesses: I used to think Medivh was a druid because of all the feathers.','[%s] confesses: I used to think Medivh was a druid because of all the feathers.',26124),
(76095,'enUS','[%s] confesses: I still carry around Argent Crusade Scourgestones. You never know when they\'ll be useful again.','[%s] confesses: I still carry around Argent Crusade Scourgestones. You never know when they\'ll be useful again.',26124),
(76096,'enUS','[%s] confesses: I feel bad for my ground mounts. I hardly ever use them anymore.','[%s] confesses: I feel bad for my ground mounts. I hardly ever use them anymore.',26124),
(76097,'enUS','[%s] confesses: I\'m going to totally ninja that hunter\'s loot.','[%s] confesses: I\'m going to totally ninja that hunter\'s loot.',26124),
(76098,'enUS','[%s] confesses: I am confused why female draenei like gnomes.','[%s] confesses: I am confused why female draenei like gnomes.',26124),
(76099,'enUS','The crystal vibrates at your touch!','The crystal vibrates at your touch!',26124),
(76100,'enUS','','Khadgar - someone\'s here!',26124),
(76101,'enUS','The Land of Winds belongs to the Warsong.','',26124),
(76102,'enUS','Dis harder den I finked.','',26124),
(76103,'enUS','One?','',26124),
(76104,'enUS','Umm...','',26124),
(76105,'enUS','Hrm...','',26124),
(76106,'enUS','What after one?','',26124),
(76107,'enUS','How many\'s tree?','',26124),
(76108,'enUS','Anudder one.','',26124),
(76109,'enUS','One lots.','',26124),
(76110,'enUS','Today, a bright fire exploded across the heavens.$B$BA great white crystal landed in the plains below our village.$B$BWe know not what it is. Is it a gift from our ancestors?','Today, a bright fire exploded across the heavens.$B$BA great white crystal landed in the plains below our village.$B$BWe know not what it is. Is it a gift from our ancestors?',26124),
(76111,'enUS','Shortly afterward, a shadow appeared in the sky beneath the pale moon. Some stare at it in fear, others in adoration.$B$BThe clan has given it many names: great father, dark mother.$B$BThe Chieftain calls it the \"Dark Star.\"','Shortly afterward, a shadow appeared in the sky beneath the pale moon. Some stare at it in fear, others in adoration.$B$BThe clan has given it many names: great father, dark mother.$B$BThe Chieftain calls it the \"Dark Star.\"',26124),
(76112,'enUS','Since the crystals fell, our power has grown in ways we do not fully understand.$B$BWe have always spoken the language of the stars and the earth. Now, we hear another - the voice of shadow.','Since the crystals fell, our power has grown in ways we do not fully understand.$B$BWe have always spoken the language of the stars and the earth. Now, we hear another - the voice of shadow.',26124),
(76113,'enUS','Yesterday, we found one of our clan defiling the spirits of our ancestors.$B$BThe Chieftain is livid. It is clear - this new magic is dangerous. It leads us down a path from which we cannot return.$B$BFrom this day forth, let it be known. The powers of shadow are forbidden to the clan.$B$BThe \"Dark Star\" is evil.','Yesterday, we found one of our clan defiling the spirits of our ancestors.$B$BThe Chieftain is livid. It is clear - this new magic is dangerous. It leads us down a path from which we cannot return.$B$BFrom this day forth, let it be known. The powers of shadow are forbidden to the clan.$B$BThe \"Dark Star\" is evil.',26124),
(76114,'enUS','<Wrathion sits alone, twirling a game piece in his fingers. He is staring intently at the game board but you get the impression that his mind is elsewhere.>','',26124),
(76115,'enUS','In ages long past, aspiring heroes and emperors came here to face the tests of the August Celestials.\n\nJust as our ancestors watched over the passage of those time-honored proceedings, so shall we.\n\nThe Celestial Guard will brook no faction squabbles in this sacred place.','',26124),
(76116,'enUS','I don\'t think I\'ve ever seen the boss so upset.$b$bYou\'d best not go looking for the Prince until he cools down a little.','',26124),
(76117,'enUS','It\'s all I can do to stop from staring at the sun. It never moves.$b$bJust what IS this place?','',26124),
(76118,'enUS','I\'ve got a hankerin\' to do some fishin\'!','',26124),
(76119,'enUS','Stop the intruder!','Stop the intruder!',26124),
(76120,'enUS','To arms!','To arms!',26124),
(76121,'enUS','Kill!','Kill!',26124),
(76122,'enUS','No prisoners!','No prisoners!',26124),
(76123,'enUS','Destroy the $pc!','Destroy the $pc!',26124),
(76124,'enUS','Get that $pc!','Get that $pc!',26124),
(76125,'enUS','You will die!','You will die!',26124),
(76126,'enUS','Lok-Narash!','Lok-Narash!',26124),
(76127,'enUS','You cannot stop us, $c! All orcs will one day drink of the felblood!','',26124),
(76128,'enUS','The darkness comes!','The darkness comes!',26124),
(76129,'enUS','The Council\'s will be done!','The Council\'s will be done!',26124),
(76130,'enUS','Time to die, $pc!','Time to die, $pc!',26124),
(76131,'enUS','Your soul will be consumed!','Your soul will be consumed!',26124),
(76132,'enUS','Quickly! Kill the intruders!','Quickly! Kill the intruders!',26124),
(76133,'enUS','Kill the outsider!','Kill the outsider!',26124),
(76134,'enUS','You will make a fine sacrifice!','You will make a fine sacrifice!',26124),
(76135,'enUS','You\'re too late!','You\'re too late!',26124),
(76136,'enUS','','You\'re too late, $c. The Shadow Council ascends!',26124),
(76137,'enUS','I will consume your soul!','',26124),
(76138,'enUS','','Watch yourself out there. Those things come out of nowhere.',26124),
(76139,'enUS','Rest well, honored mother. You will be avenged.','Rest well, honored mother. You will be avenged.',26124),
(76140,'enUS','What is making the ground shake?','What is making the ground shake?',26124),
(76141,'enUS','I don\'t see a gronn. What is that?','I don\'t see a gronn. What is that?',26124),
(76142,'enUS','The farseer says that Shui Halad has awakened.','The farseer says that Shui Halad has awakened.',26124),
(76143,'enUS','The great worm twists in its lair.','The great worm twists in its lair.',26124),
(76144,'enUS','Perhaps the Thunderlord have come to play.','Perhaps the Thunderlord have come to play.',26124),
(76145,'enUS','Why does the ground shake? Are we under attack?','Why does the ground shake? Are we under attack?',26124),
(76146,'enUS','Someone calm the wolves.','Someone calm the wolves.',26124),
(76147,'enUS','The human wizard and his pet elf are to blame. The land knows they don\'t belong.','The human wizard and his pet elf are to blame. The land knows they don\'t belong.',26124),
(76148,'enUS','It\'s all fun and games until...','',26124),
(76149,'enUS','Eye, what are you looking at?','',26124),
(76150,'enUS','Razuun, you stay here. I have other plans for... what is that?','',26124),
(76151,'enUS','All I require is its limitless power.','',26124),
(76152,'enUS','It will be done, Lord Gul\'dan.','',26124),
(76153,'enUS','Are you ready to change the world, $n?','',26124),
(76154,'enUS','You know what needs to be done, champion.','',26124),
(76155,'enUS','Meet me in the Veiled Stair when the deed is done - assuming you\'re still alive when this is over.','',26124),
(76156,'enUS','Rrrraaaaghhhh!!','',26124),
(76157,'enUS','My pain... is endless...','',26124),
(76158,'enUS','The flames... never cease...','',26124),
(76159,'enUS','I burn... for all time...','',26124),
(76160,'enUS','You will take my place on the eternal brazier.','',26124),
(76161,'enUS','Your flesh will melt.','',26124),
(76162,'enUS','Your pain will be endless.','',26124),
(76163,'enUS','You will feel but a fraction of my agony.','',26124),
(76164,'enUS','Burn!','',26124),
(76165,'enUS','Up in smoke.','',26124),
(76166,'enUS','The eternal fire will never be extinguished.','',26124),
(76167,'enUS','Steady hands..','',26124),
(76168,'enUS','Blue wire with the green stripe, or black wire with the yellow stripe? I can never remember.','',26124),
(76169,'enUS','','Hurry up!',26124),
(76170,'enUS','','Not the red wire, the blue one!',26124),
(76171,'enUS','','Wait for me!',26124),
(76172,'enUS','Knocking Down','Knocking Down',26124),
(76173,'enUS','I live again!','',26124),
(76174,'enUS','Hahahahaha!','',26124),
(76175,'enUS','The South Seas are mine to pillage for all eternity!','',26124),
(76176,'enUS','Come, Vazuvius, rise from the depths!','',26124),
(76177,'enUS','|TInterface\\Icons\\ability_gouge:20|t%s attempts to |cFFFF0000|Hspell:143330|h[Gouge]|h|r you, turn away!','',26124),
(76178,'enUS','','Oi! That was a fun ride!',26124),
(76179,'enUS','','Heroes, I salute you. There\'s something right foul in these chambers below the city.',26124),
(76180,'enUS','','Ooh, that looks dangerous. Get in there, boys, and show em\' what we\'re made of.',26124),
(76181,'enUS','','A right deadly machine, that is. Best watch yer step down here, heroes.',26124),
(76182,'enUS','Oh, ho ho... Hey now. What do we have here?','',26124),
(76183,'enUS','So Garrosh thinks he can cheat ol\' Grizzle out of a payday, huh?!','',26124),
(76184,'enUS','Go get it boys, that contraption\'s got nothin\' on real goblin engineering!','',26124),
(76185,'enUS','Ahhhh! Or maybe it does. I better, um, go check on the others.','',26124),
(76186,'enUS','','This island is equal parts fascinating and terrifying.',26124),
(76187,'enUS','Gorlocs.','Gorlocs.',26124),
(76188,'enUS','<Ku\'ma stares at you.>','',26124),
(76189,'enUS','','Let us test your knowledge of history, then! Tell me, hero, what are undead murlocs called?',26124),
(76190,'enUS','Mur\'ghouls.','Mur\'ghouls.',26124),
(76191,'enUS','Wolvar.','Wolvar.',26124),
(76192,'enUS','Mur\'liches.','Mur\'liches.',26124),
(76193,'enUS','','Incorrect!',26124),
(76194,'enUS','','That is correct!',26124),
(76195,'enUS','','Let us test your knowledge of history, then! White wolves were once the favored mounts of which orc clan?',26124),
(76196,'enUS','','Let us test your knowledge of history, then! What is the highest rank bestowed on a druid?',26124),
(76197,'enUS','','Let us test your knowledge of history, then! Who is the current leader of the gnomish people?',26124),
(76198,'enUS','','Let us test your knowledge of history, then! Malfurion Stormrage helped found this group, which is the primary druidic organization of Azeroth.',26124),
(76199,'enUS','','Let us test your knowledge of history, then! Brown-skinned orcs first began showing up on Azeroth several years after the Third War, when the Dark Portal was reactivated. What are these orcs called?',26124),
(76200,'enUS','','Let us test your knowledge of history, then! Before she was raised from the dead by Arthas to serve the Scourge, Sindragosa was a part of what dragonflight?',26124),
(76201,'enUS','','Let us test your knowledge of history, then! This structure, located in Zangarmarsh, was controlled by naga who sought to drain a precious and limited resource: the water of Outland.',26124),
(76202,'enUS','','Let us test your knowledge of history, then! What was the original name of the world connected to Azeroth via the Dark Portal?',26124),
(76203,'enUS','','Let us test your knowledge of history, then! What powerful sword could smite the undead with such force that only ashes remained?',26124),
(76204,'enUS','','Let us test your knowledge of history, then! How many dragonflights were bestowed with special powers in order to protect the world of Azeroth?',26124),
(76205,'enUS','','Let us test your knowledge of history, then! What night elf is widely known as \"the Betrayer\"?',26124),
(76206,'enUS','','Let us test your knowledge of history, then! Most forest trolls became hostile to the Horde after the Second War. Which tribe of forest trolls is on friendly terms with the Horde today?',26124),
(76207,'enUS','','Let us test your knowledge of history, then! What demon forced the blue dragon Kalecgos to fight a group of adventurers in the Sunwell Plateau?',26124),
(76208,'enUS','','Let us test your knowledge of history, then! One of Sylvanas Windrunner\'s sisters leads a militant faction of high elves and Kirin Tor. What is the name of this group?',26124),
(76209,'enUS','','Let us test your knowledge of history, then! What famous axe did Grom Hellscream wield in battle?',26124),
(76210,'enUS','','Let us test your knowledge of history, then! What did the Dragon Aspects give the night elves after the War of the Ancients?',26124),
(76211,'enUS','','Let us test your knowledge of history, then! What evidence drove Prince Arthas to slaughter the people of Stratholme during the Third War?',26124),
(76212,'enUS','','Let us test your knowledge of history, then! Arthas\'s death knights were trained in a floating citadel that was taken by force when many of them rebelled against the Lich King. What was the fortress\'s name?',26124),
(76213,'enUS','','Let us test your knowledge of history, then! Thane Kurdran Wildhammer recently suffered a tragic loss when his valiant gryphon was killed in a fire. What was this gryphon\'s name?',26124),
(76214,'enUS','','Let us test your knowledge of history, then! This queen oversaw the evacuation of her people after the Cataclysm struck and the Forsaken attacked her nation.',26124),
(76215,'enUS','','Let us test your knowledge of history, then! Before Ripsnarl became a worgen, he had a family. What was his wife\'s name?',26124),
(76216,'enUS','','Let us test your knowledge of history, then! Who was the first death knight to be created on Azeroth?',26124),
(76217,'enUS','','Let us test your knowledge of history, then! Formerly a healthy paladin, this draenei fell ill after fighting the Burning Legion and becoming one of the Broken. He later became a powerful shaman.',26124),
(76218,'enUS','','Let us test your knowledge of history, then! Who were the three young twilight drakes guarding twilight dragon eggs in the Obsidian Sanctum?',26124),
(76219,'enUS','','Let us test your knowledge of history, then! What is the name of Tirion Fordring\'s gray stallion?',26124),
(76220,'enUS','','Let us test your knowledge of history, then! This Horde ship was crafted by goblins. Originally intended to bring Thrall and Aggra to the Maelstrom, the ship was destroyed in a surprise attack by the Alliance.',26124),
(76221,'enUS','','Let us test your knowledge of history, then! Name the titan lore-keeper who was a member of the elite Pantheon.',26124),
(76222,'enUS','','Let us test your knowledge of history, then! Who was the mighty proto-dragon captured by Loken and transformed into Razorscale?',26124),
(76223,'enUS','','Let us test your knowledge of history, then! The draenei like to joke that in the language of the naaru, the word Exodar has this meaning.',26124),
(76224,'enUS','','Let us test your knowledge of history, then! Whose tomb includes the inscription \"May the bloodied crown stay lost and forgotten\"?',26124),
(76225,'enUS','','Let us test your knowledge of history, then! Who was the first satyr to be created?',26124),
(76226,'enUS','','Let us test your knowledge of history, then! Which of these is the correct name for King Varian Wrynn\'s first wife?',26124),
(76227,'enUS','','Let us test your knowledge of history, then! Name the homeworld of the ethereals.',26124),
(76228,'enUS','','Let us test your knowledge of history, then! Before the original Horde formed, a highly contagious sickness began spreading rapidly among the orcs. What did the orcs call it?',26124),
(76229,'enUS','','Let us test your knowledge of history, then! This defender of the Scarlet Crusade was killed while slaying the dreadlord Beltheris.',26124),
(76230,'enUS','','Let us test your knowledge of history, then! The Ironforge library features a replica of an unusually large ram\'s skeleton. What was the name of this legendary ram?',26124),
(76231,'enUS','','Let us test your knowledge of history, then! In the assault on Icecrown, Horde forces dishonorably attacked Alliance soldiers who were busy fighting the Scourge and trying to capture this gate.',26124),
(76232,'enUS','','Let us test your knowledge of history, then! What phrase means \"Thank you\" in Draconic, the language of dragons?',26124),
(76233,'enUS','','Let us test your knowledge of history, then! While working as a tutor, Stalvan Mistmantle became obsessed with one of his students, a young woman named Tilloa. What was the name of her younger brother?',26124),
(76234,'enUS','','Let us test your knowledge of history, then! Not long ago, this frail Zandalari troll sought to tame a direhorn. Although he journeyed to the Isle of Giants, he was slain in his quest. What was his name?',26124),
(76235,'enUS','','Let us test your knowledge of history, then! This emissary of the Horde felt that Silvermoon City was a little too bright and clean.',26124),
(76236,'enUS','','Let us test your knowledge of history, then! Succubus demons revel in causing anguish, and they serve the Legion by conducting nightmarish interrogations. What species is the succubus?',26124),
(76237,'enUS','','Let us test your knowledge of history, then! One name for this loa is \"Night\'s Friend\".',26124),
(76238,'enUS','','Let us test your knowledge of history, then! In Taur-ahe, the language of the tauren, what does lar\'korwi mean?',26124),
(76239,'enUS','Whiteclaw clan.','Whiteclaw clan.',26124),
(76240,'enUS','Warsong clan.','Warsong clan.',26124),
(76241,'enUS','Frostwolf clan.','Frostwolf clan.',26124),
(76242,'enUS','Icefang clan.','Icefang clan.',26124),
(76243,'enUS','Shaman.','Shaman.',26124),
(76244,'enUS','Stormcaller.','Stormcaller.',26124),
(76245,'enUS','Archdruid.','Archdruid.',26124),
(76246,'enUS','Far seer.','Far seer.',26124),
(76247,'enUS','Gelbin Mekkatorque.','Gelbin Mekkatorque.',26124),
(76248,'enUS','Millhouse Manastorm.','Millhouse Manastorm.',26124),
(76249,'enUS','Sicco Thermaplugg.','Sicco Thermaplugg.',26124),
(76250,'enUS','Fizzcrank Fullthrottle.','Fizzcrank Fullthrottle.',26124),
(76251,'enUS','Crimson Ring.','Crimson Ring.',26124),
(76252,'enUS','Emerald Circle.','Emerald Circle.',26124),
(76253,'enUS','Earthen Ring.','Earthen Ring.',26124),
(76254,'enUS','Cenarion Circle.','Cenarion Circle.',26124),
(76255,'enUS','Mag\'har.','Mag\'har.',26124),
(76256,'enUS','Felblood.','Felblood.',26124),
(76257,'enUS','Mok\'Nathal.','Mok\'Nathal.',26124),
(76258,'enUS','Fel orc.','Fel orc.',26124),
(76259,'enUS','Red dragonflight.','Red dragonflight.',26124),
(76260,'enUS','Blue dragonflight.','Blue dragonflight.',26124),
(76261,'enUS','Green dragonflight.','Green dragonflight.',26124),
(76262,'enUS','Bronze dragonflight.','Bronze dragonflight.',26124),
(76263,'enUS','Snakecoil Cavern.','Snakecoil Cavern.',26124),
(76264,'enUS','Serpentine Basin.','Serpentine Basin.',26124),
(76265,'enUS','Coilfang Reservoir.','Coilfang Reservoir.',26124),
(76266,'enUS','Spiralfang Cistern.','Spiralfang Cistern.',26124),
(76267,'enUS','Draenor.','Draenor.',26124),
(76268,'enUS','Argus.','Argus.',26124),
(76269,'enUS','Koltar.','Koltar.',26124),
(76270,'enUS','Kalimdor.','Kalimdor.',26124),
(76271,'enUS','Ashbringer.','Ashbringer.',26124),
(76272,'enUS','Lightbringer.','Lightbringer.',26124),
(76273,'enUS','Light\'s Vengeance.','Light\'s Vengeance.',26124),
(76274,'enUS','Soulfire.','Soulfire.',26124),
(76275,'enUS','Five.','Five.',26124),
(76276,'enUS','Four.','Four.',26124),
(76277,'enUS','Seven.','Seven.',26124),
(76278,'enUS','Three.','Three.',26124),
(76279,'enUS','Tyrande Whisperwind.','Tyrande Whisperwind.',26124),
(76280,'enUS','Tyranis Malem.','Tyranis Malem.',26124),
(76281,'enUS','Fandral Staghelm.','Fandral Staghelm.',26124),
(76282,'enUS','Illidan Stormrage.','Illidan Stormrage.',26124),
(76283,'enUS','Smolderthorn tribe.','Smolderthorn tribe.',26124),
(76284,'enUS','Amani tribe.','Amani tribe.',26124),
(76285,'enUS','Revantusk tribe.','Revantusk tribe.',26124),
(76286,'enUS','Shadowglen tribe.','Shadowglen tribe.',26124),
(76287,'enUS','Razelikh the Defiler.','Razelikh the Defiler.',26124),
(76288,'enUS','Archimonde the Defiler.','Archimonde the Defiler.',26124),
(76289,'enUS','Sathrovarr the Corruptor.','Sathrovarr the Corruptor.',26124),
(76290,'enUS','Talnivarr the Sleeper.','Talnivarr the Sleeper.',26124),
(76291,'enUS','Violet Eye.','Violet Eye.',26124),
(76292,'enUS','Silver Covenant.','Silver Covenant.',26124),
(76293,'enUS','Sunreavers.','Sunreavers.',26124),
(76294,'enUS','Bladedancers.','Bladedancers.',26124),
(76295,'enUS','Gorefang.','Gorefang.',26124),
(76296,'enUS','Bloodcleave.','Bloodcleave.',26124),
(76297,'enUS','Gorehowl.','Gorehowl.',26124),
(76298,'enUS','Shriekblade.','Shriekblade.',26124),
(76299,'enUS','Teldrassil.','Teldrassil.',26124),
(76300,'enUS','Well of Eternity.','Well of Eternity.',26124),
(76301,'enUS','Nordrassil.','Nordrassil.',26124),
(76302,'enUS','Moonwells.','Moonwells.',26124),
(76303,'enUS','Tainted soil.','Tainted soil.',26124),
(76304,'enUS','Tainted wildlife.','Tainted wildlife.',26124),
(76305,'enUS','Tainted water.','Tainted water.',26124),
(76306,'enUS','Tainted grain.','Tainted grain.',26124),
(76307,'enUS','Acherus.','Acherus.',26124),
(76308,'enUS','Naxxanar.','Naxxanar.',26124),
(76309,'enUS','Kolramas.','Kolramas.',26124),
(76310,'enUS','Naxxramas.','Naxxramas.',26124),
(76311,'enUS','Swiftwing.','Swiftwing.',26124),
(76315,'enUS','Sharpbeak.','Sharpbeak.',26124),
(76316,'enUS','Sky\'ree.','Sky\'ree.',26124),
(76317,'enUS','Stormbeak.','Stormbeak.',26124),
(76318,'enUS','Queen Lia Greymane.','Queen Lia Greymane.',26124),
(76319,'enUS','Queen Malia Greymane.','Queen Malia Greymane.',26124),
(76320,'enUS','Queen Liria Greymane.','Queen Liria Greymane.',26124),
(76321,'enUS','Queen Mia Greymane.','Queen Mia Greymane.',26124),
(76322,'enUS','Emma Harrington.','Emma Harrington.',26124),
(76323,'enUS','Calissa Harrington.','Calissa Harrington.',26124),
(76324,'enUS','Vanessa Whitehall.','Vanessa Whitehall.',26124),
(76325,'enUS','Katrina Whitehall.','Katrina Whitehall.',26124),
(76326,'enUS','Teron Gorefiend.','Teron Gorefiend.',26124),
(76327,'enUS','Arthas Menethil.','Arthas Menethil.',26124),
(76328,'enUS','Alexandros Mograine.','Alexandros Mograine.',26124),
(76329,'enUS','Koltira Deathweaver.','Koltira Deathweaver.',26124),
(76333,'enUS','Velen.','Velen.',26124),
(76334,'enUS','Akama.','Akama.',26124),
(76335,'enUS','Maraad.','Maraad.',26124),
(76336,'enUS','Nobundo.','Nobundo.',26124),
(76337,'enUS','Tenebron, Vesperon, and Shadron.','Tenebron, Vesperon, and Shadron.',26124),
(76338,'enUS','Tenebron, Vesperon, and Halion.','Tenebron, Vesperon, and Halion.',26124),
(76339,'enUS','Theralion, Shadron, and Abyssion.','Theralion, Shadron, and Abyssion.',26124),
(76340,'enUS','Theralion, Halion, and Abyssion.','Theralion, Halion, and Abyssion.',26124),
(76342,'enUS','Ashanor.','Ashanor.',26124),
(76343,'enUS','Mistsilver.','Mistsilver.',26124),
(76351,'enUS','Feonir.','Feonir.',26124),
(76352,'enUS','Mirador.','Mirador.',26124),
(76353,'enUS','Draka\'s Fury.','Draka\'s Fury.',26124),
(76354,'enUS','Hellscream\'s Fury.','Hellscream\'s Fury.',26124),
(76355,'enUS','Aggra\'s Fury.','Aggra\'s Fury.',26124),
(76356,'enUS','Durotan\'s Fury.','Durotan\'s Fury.',26124),
(76358,'enUS','Aman\'Thul.','Aman\'Thul.',26124),
(76359,'enUS','Norgannon.','Norgannon.',26124),
(76361,'enUS','Eonar.','Eonar.',26124),
(76362,'enUS','Khaz\'goroth.','Khaz\'goroth.',26124),
(76385,'enUS','Galakrond.','Galakrond.',26124),
(76386,'enUS','Veranus.','Veranus.',26124),
(76387,'enUS','Zeptek.','Zeptek.',26124),
(76388,'enUS','Kill them all! No survivors!','',26124),
(76389,'enUS','Vyletongue.','Vyletongue.',26124),
(76390,'enUS','Defective elekk turd.','Defective elekk turd.',26124),
(76391,'enUS','Crystal death trap.','Crystal death trap.',26124),
(76392,'enUS','Worthless elekk dung.','Worthless elekk dung.',26124),
(76393,'enUS','Radioactive biohazard.','Radioactive biohazard.',26124),
(76394,'enUS','Prince Arthas Menethil.','Prince Arthas Menethil.',26124),
(76395,'enUS','King Llane Wrynn.','King Llane Wrynn.',26124),
(76396,'enUS','Uther the Lightbringer.','Uther the Lightbringer.',26124),
(76397,'enUS','King Terenas Menethil II.','King Terenas Menethil II.',26124),
(76398,'enUS','Peroth\'arn.','Peroth\'arn.',26124),
(76399,'enUS','Garaxxas.','Garaxxas.',26124),
(76400,'enUS','Xavius.','Xavius.',26124),
(76401,'enUS','Vyletongue.','Vyletongue.',26124),
(76402,'enUS','Tiffin Windemere Wrynn.','Tiffin Windemere Wrynn.',26124),
(76403,'enUS','Therese Anne Wrynn.','Therese Anne Wrynn.',26124),
(76404,'enUS','Therese Angharad Wrynn.','Therese Angharad Wrynn.',26124),
(76405,'enUS','Tiffin Ellerian Wrynn.','Tiffin Ellerian Wrynn.',26124),
(76407,'enUS','K\'aresh.','K\'aresh.',26124),
(76409,'enUS','Xarodi.','Xarodi.',26124),
(76410,'enUS','Khu\'ral.','Khu\'ral.',26124),
(76412,'enUS','Xoroth.','Xoroth.',26124),
(76422,'enUS','Scarlet fever.','Scarlet fever.',26124),
(76423,'enUS','Blood pox.','Blood pox.',26124),
(76424,'enUS','Crimson fever.','Crimson fever.',26124),
(76425,'enUS','Red pox.','Red pox.',26124),
(76431,'enUS','Fellari Swiftarrow.','Fellari Swiftarrow.',26124),
(76432,'enUS','Holia Sunshield.','Holia Sunshield.',26124),
(76433,'enUS','Yana Bloodspear.','Yana Bloodspear.',26124),
(76434,'enUS','Valea Twinblades.','Valea Twinblades.',26124),
(76435,'enUS','Gorehoof.','Gorehoof.',26124),
(76436,'enUS','Toothgnasher.','Toothgnasher.',26124),
(76437,'enUS','Bloodhorn.','Bloodhorn.',26124),
(76438,'enUS','Steelmauler.','Steelmauler.',26124),
(76440,'enUS','Corp\'rethar.','Corp\'rethar.',26124),
(76441,'enUS','Aldur\'thar.','Aldur\'thar.',26124),
(76442,'enUS','Angrathar.','Angrathar.',26124),
(76443,'enUS','Mord\'rethar.','Mord\'rethar.',26124),
(76444,'enUS','Borela mir.','Borela mir.',26124),
(76445,'enUS','Belan shi.','Belan shi.',26124),
(76446,'enUS','Avral shi.','Avral shi.',26124),
(76447,'enUS','Alena mir.','Alena mir.',26124),
(76448,'enUS','Billy.','Billy.',26124),
(76449,'enUS','William.','William.',26124),
(76450,'enUS','Giles.','Giles.',26124),
(76451,'enUS','Tobias.','Tobias.',26124),
(76452,'enUS','Maaka.','Maaka.',26124),
(76453,'enUS','Grimath.','Grimath.',26124),
(76454,'enUS','Talak.','Talak.',26124),
(76456,'enUS','Ra\'wiri.','Ra\'wiri.',26124),
(76460,'enUS','Cheneta.','Cheneta.',26124),
(76462,'enUS','Kristine Denny.','Kristine Denny.',26124),
(76463,'enUS','Tatai.','Tatai.',26124),
(76465,'enUS','Dela Runetotem.','Dela Runetotem.',26124),
(76472,'enUS','Ered\'ruin.','Ered\'ruin.',26124),
(76473,'enUS','Sayaad.','Sayaad.',26124),
(76475,'enUS','Shivarra.','Shivarra.',26124),
(76476,'enUS','Eredar.','Eredar.',26124),
(76477,'enUS','Shirvallah.','Shirvallah.',26124),
(76478,'enUS','Kimbul.','Kimbul.',26124),
(76479,'enUS','Mueh\'zala.','Mueh\'zala.',26124),
(76480,'enUS','Shadra.','Shadra.',26124),
(76481,'enUS','Sharp claw.','Sharp claw.',26124),
(76483,'enUS','Razor tooth.','Razor tooth.',26124),
(76485,'enUS','Sharp tooth.','Sharp tooth.',26124),
(76487,'enUS','Razor claw.','Razor claw.',26124),
(76527,'enUS','Hello, traveler!$b$bAre you coming to the Wanderer\'s Festival tonight? Pandaren will gather right here on Turtle Beach shortly after sunset! It\'s quite the sight.$b$bSpeak to me as the event draws near and I will let you know how long you have to wait.','',26124),
(76528,'enUS','Hello, traveler!$b$bAre you coming to the Wanderer\'s Festival tonight? Pandaren will gather right here on Turtle Beach shortly after sunset! It\'s quite the sight.$b$bThe festival will begin under three hours from now. Check back at the top of the hour!','',26124),
(76529,'enUS','Hello, traveler!$b$bAre you coming to the Wanderer\'s Festival tonight? Pandaren will gather right here on Turtle Beach shortly after sunset! It\'s quite the sight.$b$bThe festival will begin under two hours from now. Check back at the top of the hour!','',26124),
(76530,'enUS','Hello, traveler!$b$bAre you coming to the Wanderer\'s Festival tonight? Pandaren will gather right here on Turtle Beach shortly after sunset! It\'s quite the sight.$b$bWithin the next hour, the festival will begin. Check back at the top of the hour!','',26124),
(76531,'enUS','The festival has begun! Invite your friends!$b$bBe sure not to miss the fireworks at the beginning or end of the festival. They\'re the most important part.','',26124),
(76532,'enUS','You heard the king, bolster the line! Give our heroes the time they need to reach Garrosh!','',26124),
(76533,'enUS','Requires Skeleton Key','Requires Skeleton Key',26124),
(76534,'enUS','You dare interrupt my dinner?!','',26124),
(76535,'enUS','Somethings smells funny... AHA! I see you $c!','',26124),
(76536,'enUS','So, soo... hungry... Ack!!','',26124),
(76537,'enUS','Hey, mon! I be Adjutant Historian Ju\'pa. Dey not add dat to me title yet, but I be sure that be temporary.','',26124),
(76538,'enUS','Greetings! I am Historian Llore! Everyone says I smile too much, but I don\'t think that\'s possible!','',26124),
(76539,'enUS','At last, the time for justice is at hand. This monster will answer for each and every Alliance life that we have lost in this war.','',26124),
(76540,'enUS','Garrosh will pay for his crimes.','Garrosh will pay for his crimes.',26124),
(76541,'enUS','Thank you for helping me end the great mistake I made long ago, that led our people into this dark place. I could not do it alone. Let me regain my honor, and end Garrosh\'s reign of terror once and for all.','',26124),
(76542,'enUS','End it, for the Horde.','End it, for the Horde.',26124),
(76543,'enUS','We\'ll hold the line, $n. You just worry about putting an end to Garrosh\'s madness.','',26124),
(76544,'enUS','The first lock of the Thrice-Locked cage clicks and falls to the ground. Two Remain.','The first lock of the Thrice-Locked cage clicks and falls to the ground. Two Remain.',26124),
(76545,'enUS','The second lock of the Thrice-Locked cage clicks and falls to the ground. One Remains.','The second lock of the Thrice-Locked cage clicks and falls to the ground. One Remains.',26124),
(76546,'enUS','The third lock of the Thrice-Locked cage clicks and falls to the ground. The cage opens!','The third lock of the Thrice-Locked cage clicks and falls to the ground. The cage opens!',26124),
(76547,'enUS','I like shorts! They\'re perfect for this weather!','I like shorts! They\'re perfect for this weather!',26124),
(76548,'enUS','I only have one pet! I hope that\'s ok!','',26124),
(76549,'enUS','Go easy on me!','',26124),
(76550,'enUS','Your pet fell down!','',26124),
(76551,'enUS','Awww! No fair!','',26124),
(76552,'enUS','Yay! I\'m the best!','',26124),
(76553,'enUS','You have parcel to pick up? You have mail to send?$B$BVery fast service, yes!','',26124),
(76554,'enUS','Use the mail service.','Use the mail service.',26124),
(76557,'enUS','<PH> REUSE','<PH> REUSE',26124),
(76558,'enUS','','Eee! Wh-what?! Oh...$B$BD-did you n-need something?$B$BWhy d-did I ever let my sister convince me to visit here... have you SEEN how b-big the animals get?!',26124),
(76559,'enUS','<The scruffy old pandaren snores peacefully. A pile of assorted bottles are strewn about next to him.>','',26124),
(76560,'enUS','Examine his goods.','Examine his goods.',26124),
(76561,'enUS','','Oh, hello!$B$BPlease, come in, come in! Rest for a while.$B$BWould you like something to eat? To drink?',26124),
(76562,'enUS','','Your face!',26124),
(76563,'enUS','Faster! Keep moving!','',26124),
(76564,'enUS','One more mistake and you\'re going in next!','',26124),
(76565,'enUS','You should be thankful you aren\'t on kitchen duty chopping wood!','',26124),
(76566,'enUS','Put your backs into it!','',26124),
(76567,'enUS','We need to complete the ritual now! Faster!','',26124),
(76568,'enUS','Show me what you\'re workin\' with!','',26124),
(76569,'enUS','Well met, $n.','',26124),
(76570,'enUS','Farewell my friends, for time grows short. I must depart.','',26124),
(76571,'enUS','POOF!','',26124),
(76572,'enUS','Do you know any good jokes, $r?','',26124),
(76573,'enUS','Ahahaha, that was a good one!','',26124),
(76574,'enUS','You know, you\'re pretty funny.','',26124),
(76575,'enUS','Nah, I don\'t much care for that one. Do you have any more?','',26124),
(76576,'enUS','Ahahahaha... hahahahahaha!','',26124),
(76577,'enUS','Ahahaha... Oh, I\'m holding my sides at that one!','',26124),
(76578,'enUS','Hohohoho, that\'s a funny one! Tell me another.','',26124),
(76579,'enUS','Beautiful day, isn\'t it?','',26124),
(76580,'enUS','For the Light.','',26124),
(76581,'enUS','Have you seen my comrades?','',26124),
(76582,'enUS','Your challenge has been answered, outsider. Ordon, claim this area in the name of the Burning God!','',26124),
(76583,'enUS','','A historian\'s work is never done, you see. There\'s always something important happening that we will need to remember.$B$BI\'ve written much of your legacy already, but there is still so much to learn! Surely your feats will be remembered for ages to come.',26124),
(76584,'enUS','My eyes are playing tricks on me! Are those... skeletons manning that ship?','',26124),
(76585,'enUS','That storm pushed us off course. We could be anywhere between Kul Tiras and Lordaeron, so stay sharp!','',26124),
(76586,'enUS','I ain\'t seen mist this thick before. We\'ll have to drop our sails and wait for it to pass. I don\'t much like the thought of beaching The Barnacle on a shallow reef today.','',26124),
(76587,'enUS','What\'s that in the distance? Sails? Ahoy! We\'ve been stranded fer nine days! Help us!','',26124),
(76588,'enUS','All hands on deck! The Barnacle\'s under attack!','',26124),
(76589,'enUS','Thank you. I don\'t know if I would have survived without your help.','',26124),
(76590,'enUS','Turgall was a cruel master. He tortured his slaves and let us starve to death!','',26124),
(76591,'enUS','I am sorry for such a short meeting. I must seek my rylak companion. She disappeared before I was captured. Again, you have my thanks.','',26124),
(76592,'enUS','Hey, watch it!','',26124),
(76593,'enUS','Ow! I hit you back for that!','',26124),
(76594,'enUS','Don\'t hit me, stupid!','',26124),
(76595,'enUS','Back off, dis one is mine!','',26124),
(76596,'enUS','Argh! I kill you first, den I smash little one!','',26124),
(76597,'enUS','Outta my way!','',26124),
(76598,'enUS','Urgh, I kill you for that!','',26124),
(76599,'enUS','Gah, my eye! Where you learn that?!','',26124),
(76600,'enUS','Had enough yet?!','',26124),
(76601,'enUS','Tough guy, huh? I show you tough!','',26124),
(76602,'enUS','You\'ve made your final mistake, foreigner. Feel the power of lava as your bones melt!','',26124),
(76603,'enUS','My body becomes one with the volcanoes.','',26124),
(76604,'enUS','Not so tough now!','',26124),
(76605,'enUS','Dats what I thought!','',26124),
(76606,'enUS','Shoulda stayed outta my way!','',26124),
(76607,'enUS','Rahh! I crush anyone who challenge me!','',26124),
(76608,'enUS','Now you stupid AND dead!','',26124),
(76609,'enUS','','Time can be both beautiful and cruel.',26124),
(76610,'enUS','Ain\'t no other way, mon. We gotta stop Garrosh here an\' now, else we be runnin\' the rest of our lives.','',26124),
(76611,'enUS','Dey must have taken da docks!  Ha ha!  Welcome to da\' fields of slaughter.','',26124),
(76612,'enUS','Dey be heroes, no doubt about dat.','',26124),
(76613,'enUS','Da beast be slain!','',26124),
(76614,'enUS','Tyrande...','',26124),
(76615,'enUS','Garrosh be concealin\' a whole hidden base. Where did his lust for power take him?','',26124),
(76616,'enUS','Baine, you and your warriors hold this junction. These heroes should forge ahead an\' flush the Warchief out of hiding.','',26124),
(76617,'enUS','People be dyin\' up above. Da city is in chaos. I\'m gonna finish it - stop da bloodshed. I\'ll come back for ya.','',26124),
(76618,'enUS','It\'s gonna be fine, Baine. We gonna find Thrall, gonna kill de Warchief, gonna avenge your father.','',26124),
(76619,'enUS','Hah. Darkspear never die.','',26124),
(76620,'enUS','','Anu\'dora!',26124),
(76621,'enUS','','At them, my sisters! For Kalimdor!',26124),
(76622,'enUS','','Don\'t think we\'re here to save you, troll. We\'re here for Kalimdor.  Get forces inside the gates while we distract the enemy!',26124),
(76623,'enUS','Our casualties are too heavy!','',26124),
(76624,'enUS','Perhaps our newfound reinforcements will aid us.','',26124),
(76625,'enUS','Perhaps there is hope after all.','',26124),
(76626,'enUS','Blessing of the Earthmother be upon them.','',26124),
(76627,'enUS','We will soon find out. He is cornered like a rat down one of these corridors.','',26124),
(76628,'enUS','What should we do next?','',26124),
(76629,'enUS','What about you?','',26124),
(76630,'enUS','...very well.','',26124),
(76631,'enUS','Earthmother protect you, Vol\'jin.','',26124),
(76632,'enUS','','Going so soon? What about the customers?',26124),
(76633,'enUS','Ha! We\'ve weathered storms worse than this, $n. Now hurry, you don\'t want to keep Garrosh waiting!','',26124),
(76634,'enUS','Garrosh\'s madness must be stopped, $n, our future depends on it. While the gravity of this task is immense, I would not entrust this deed to another.','',26124),
(76635,'enUS','|TInterface\\Icons\\ability_titankeeper_quarantine.blp:20|tNorushen activates the |cFFFF0000|Hspell:145779|h[Safety Measures]|h|r of the Quarantine Zone!','|TInterface\\Icons\\ability_titankeeper_quarantine.blp:20|tNorushen activates the |cFFFF0000|Hspell:145779|h[Safety Measures]|h|r of the Quarantine Zone!',26124),
(76636,'enUS','','Do you need an outfit, traveler? I can help.',26124),
(76637,'enUS','','I could see you from a mile away in THAT outfit, $r.',26124),
(76638,'enUS','','I know just the color that would suit your complexion.',26124),
(76639,'enUS','','Over here, $r. Gimme those scraps and I\'ll whip up some options.',26124),
(76640,'enUS','','I swear, none of these Kor\'kron animals will pass as long I draw breath. Just promise you will put Garrosh down like the rabid dog he is.',26124),
(76641,'enUS','','Right now, the best medical care I can provide is giving you the tools to avoid injury in the first place.',26124),
(76642,'enUS','','This is definitely more exciting than my usual intelligence gathering operations. Now hurry and take care of Garrosh, I don\'t want this to be my last mission for SI:7.',26124),
(76645,'enUS','I don\'t care how fancy your gear is, $n, if you don\'t take care of your feet then you\'re finished. So give those pups a break and use my portal to instantly travel back the entrance.','',26124),
(76648,'enUS','I win!','',26124),
(76649,'enUS','','I can help you pull off ANY look. What do you need?',26124),
(76650,'enUS','Show me my options.','Show me my options.',26124),
(76651,'enUS','This mission is far too vital to leave your repairs in the hands of someone other than myself.','',26124),
(76652,'enUS','','Ah! I was sent here to guide you to the Timeless Isle, but I see you have already made the voyage. I fear I have gotten tangled up in the timeways again.',26124),
(76653,'enUS','','%s pulls out a bronze timepiece, shakes it, and squints at the dial. She seems somewhat embarassed.',26124),
(76654,'enUS','Quit yer bickering!','',26124),
(76655,'enUS','Dat\'s enough brawlin\'!','',26124),
(76656,'enUS','Get over here and help me! You can kill each other later!','',26124),
(76657,'enUS','Get back in line!','',26124),
(76658,'enUS','Knock it off!','',26124),
(76659,'enUS','','Every life is a thread, and the tapestry we weave together is the story of our world. The pandaren lorewalkers know this more than any other. Just look at this library! So many stories...',26124),
(76661,'enUS','Aid me, essence of lava!','',26124),
(76662,'enUS','','Welcome to Woo\'s, where the sun is always shining and the food is always hot!',26124),
(76663,'enUS','What smells delicious?','What smells delicious?',26124),
(76664,'enUS','','It\'s nice to sit amongst friends both old and new.',26124),
(76665,'enUS','','Don\'t forget to take some time to just enjoy the scenery!',26124),
(76666,'enUS','','I have the best seat in the house, don\'t you think?',26124),
(76667,'enUS','Everybody nice here... Chee Chee like that.','',26124),
(76668,'enUS','You going to fight giant ox?','',26124),
(76669,'enUS','You strongest looking $c Chee Chee has ever seen!','',26124),
(76670,'enUS','Impressive.','',26124),
(76671,'enUS','Yes, $n?','',26124),
(76672,'enUS','I am prepared to fly into Karabor.','I am prepared to fly into Karabor.',26124),
(76673,'enUS','Well played.','',26124),
(76674,'enUS','You\'ve stumbled right into my trap.','',26124),
(76675,'enUS','Hmm.','',26124),
(76676,'enUS','One more, Kat.','',26124),
(76677,'enUS','Ah, more of Vol\'jin\'s revolutionaries. You\'ve made it.','',26124),
(76678,'enUS','Have you found Thrall? I am badly hurt, he insisted on going ahead alone.','',26124),
(76679,'enUS','Tell me, how goes the battle up above? What of Nazgrim? Speak to me!','',26124),
(76680,'enUS','Ah, Nazgrim. A great leader and a fine warrior. He valued his oath to the Warchief more than his life.','',26124),
(76681,'enUS','I tried to tell him... to tell him that Hellscream betrayed us, cast aside a Warchief\'s responsibility to his own people.  But Nazgrim... too loyal... too proud.','',26124),
(76682,'enUS','Damn Hellscream.  His ambition tore our Horde apart.','',26124),
(76683,'enUS','Go on, find Thrall.  Finish this.  I will live.','',26124),
(76684,'enUS','In the name of Warlord Garrosh, kill them all.','',26124),
(76685,'enUS','','Thank you for coming on such short notice, $n.',26124),
(76687,'enUS','Clear these invaders from Lok-rath. Then we will destroy their pitiful base.','',26124),
(76688,'enUS','Iron Horde, use your war machines to level the enemy base.','',26124),
(76689,'enUS','You\'re just in time, sacrifice!','',26124),
(76690,'enUS','Go quickly, $n, bring an end to Garrosh. And remember, the Earth Mother\'s eyes are upon you.','',26124),
(76691,'enUS','I swear by the power of An\'she, these Kor\'kron whelps will not pass.','',26124),
(76692,'enUS','','You\'re going down!',26124),
(76695,'enUS','Riko make sure Kor\'kron get ooked in their dooker. $n do favor for Riko in return? Tell Kiryn, Riko the one who bashy Garrosh.','',26124),
(76698,'enUS','','I...lost?',26124),
(76699,'enUS','','Now that\'s what I\'m talking about!',26124),
(76700,'enUS','','I swear by my ancestors, these Kor\'kron will not pass. Now go, $n, the honor of felling Garrosh is yours!',26124),
(76701,'enUS','','Let\'s see...',26124),
(76702,'enUS','','Nice move!',26124),
(76703,'enUS','','Let\'s do it!',26124),
(76704,'enUS','','I\'ve still got a few moves left up my sleeve!',26124),
(76705,'enUS','','I don\'t have enough mana! Oh no!',26124),
(76706,'enUS','','I need to rebuild my deck...',26124),
(76707,'enUS','','You aren\'t so tough!',26124),
(76712,'enUS','Well played, sir.','',26124),
(76713,'enUS','How\'s about another round?','',26124),
(76714,'enUS','How\'d you like that card?','',26124),
(76715,'enUS','Ten kegs of the strongest ale to whoever brings me $p\'s head!','',26124),
(76716,'enUS','Hrmph. Nice card.','',26124),
(76717,'enUS','Do you feel the power they\'re drawing on? (It\'s the naaru in Nagrand!)','',26124),
(76718,'enUS','Haven\'t seen that card before.','',26124),
(76719,'enUS','Best two out of three!','',26124),
(76720,'enUS','I\'m makin\' a comeback!','',26124),
(76721,'enUS','Come, $p. Meet your end, coward.','',26124),
(76722,'enUS','Now that\'s what I call a match!','',26124),
(76723,'enUS','This time, I\'m goin\' t\' kick yer rear!','',26124),
(76724,'enUS','Alright, alright, you win.','',26124),
(76725,'enUS','Yeah, yeah, I\'ll come join you on your adventure. Just let me play one more game first.','',26124),
(76726,'enUS','This is the best I\'ve felt in years!','',26124),
(76727,'enUS','See this card here? This one\'s going to really knock the dwarf off his chair!','',26124),
(76728,'enUS','How do ye figure he\'s so good at this game?','',26124),
(76729,'enUS','See this card? He won\'t see this one comin\'!','',26124),
(76730,'enUS','I can beat him, I swear!','',26124),
(76731,'enUS','Unleash Shagor. Let loose the Terror of Nagrand!','',26124),
(76732,'enUS','','I\'ll offer what aid I can, $n. Just promise you\'ll make lots of delicious Kor\'kron corpses on your way to Garrosh.',26124),
(76733,'enUS','I\'ve got the brains, you\'ve got the muscle. Together, we\'ll make beautiful carnage.','',26124),
(76734,'enUS','The harbor defenses have fallen! Kor\'kron, fall back and move to higher ground!','',26124),
(76735,'enUS','Players capture control of the South Tower Anti-Air Turret!','Players capture control of the South Tower Anti-Air Turret!',26124),
(76736,'enUS','Greetings, $r.  I am the sworn protector of Watcher Megana.  She has special gifts that I... uh, our leaders... greatly admire, and must be guarded closely.','',26124),
(76737,'enUS','','Merchants will spend that extra bit for something with more variety like the Dragon\'s Nest Noodle Soup.',26124),
(76738,'enUS','','Farmhands need the hearty goodness of the Pandaren Treasures Noodle Soup to restore their spirit after a hard day\'s work in the fields.',26124),
(76739,'enUS','Alright. I need some help... I\'m lookin\' for my body. It\'s somewhere in this cave, but you can only see it if you\'re in the spirit world. If you want to help me find it, let me know.\n\nBe warned, though. The timeless spirits can kick us out of the spirit world, and I don\'t think I\'m strong enough to get you back in there for a while if they do.','',26124),
(76740,'enUS','I\'m ready to enter the spirit world.','I\'m ready to enter the spirit world.',26124),
(76742,'enUS','We needed these weapons done hours ago. Move!','',26124),
(76743,'enUS','Yes, sir.','',26124),
(76744,'enUS','This isn\'t smashing...','',26124),
(76745,'enUS','I\'m on it, I\'m on it.','',26124),
(76746,'enUS','I\'m busy here! What do you want?','',26124),
(76748,'enUS','The Klaxxi Paragons go berserk!','The Klaxxi Paragons go berserk!',26124),
(76750,'enUS','Not today, little $pr!','',26124),
(76751,'enUS','$n has captured the Center Mine!','',26124),
(76752,'enUS','$n has captured the Pandaren Mine!','',26124),
(76753,'enUS','$n has captured the Goblin Mine!','',26124),
(76754,'enUS','','Come, foul creature.',26124),
(76755,'enUS','Together, we will defeat the Shadow Council.','',26124),
(76756,'enUS','No one can stop us! Onward to the open seas!','',26124),
(76757,'enUS','Select a phrase to carve into the sign.','Select a phrase to carve into the sign.',26124),
(76758,'enUS','Town ahead.','Town ahead.',26124),
(76759,'enUS','Danger ahead.','Danger ahead.',26124),
(76760,'enUS','Treasure ahead.','Treasure ahead.',26124),
(76761,'enUS','Difficult enemy ahead.','Difficult enemy ahead.',26124),
(76762,'enUS','Enemy faction ahead.','Enemy faction ahead.',26124),
(76763,'enUS','Secret nearby.','Secret nearby.',26124),
(76764,'enUS','Here!','Here!',26124),
(76765,'enUS','Dead end.','Dead end.',26124),
(76766,'enUS','Death trap.','Death trap.',26124),
(76767,'enUS','Horde nearby.','Horde nearby.',26124),
(76768,'enUS','Alliance nearby.','Alliance nearby.',26124),
(76769,'enUS','Need tank.','Need tank.',26124),
(76770,'enUS','Need healer.','Need healer.',26124),
(76771,'enUS','Need damage-dealer.','Need damage-dealer.',26124),
(76772,'enUS','Need special item.','Need special item.',26124),
(76773,'enUS','Need epic weapon.','Need epic weapon.',26124),
(76774,'enUS','Need friends.','Need friends.',26124),
(76775,'enUS','Rare creature.','Rare creature.',26124),
(76776,'enUS','Deadly fall.','Deadly fall.',26124),
(76777,'enUS','Tears.','Tears.',26124),
(76778,'enUS','This cannot be! The Vazuvius could never fall to the likes of you!','',26124),
(76779,'enUS','The Underhold has been breached! Get to the Shredders, and tear these interlopers to pieces!','',26124),
(76780,'enUS','','A hundred crates of meat, furs, and lumber are on their way to Tanaan Jungle, Arnokk.',26124),
(76781,'enUS','','Remember that the Shadowmoon takes good care of its allies, and brings pain upon its enemies.',26124),
(76782,'enUS','Well done. When the Iron Horde takes the draenei temple by sea, your clan shall be honored within our ranks.','',26124),
(76783,'enUS','What of the steel? Coal, oil, and black powder? That is only a fraction of what you promised!','',26124),
(76784,'enUS','','Please forgive us, Commander. We are hard at work delivering on our other promise. The Iron Horde shall receive a gift beyond compare...',26124),
(76785,'enUS','','A weapon capable of destroying worlds.',26124),
(76786,'enUS','So where is this weapon?','',26124),
(76787,'enUS','','Patience, Commander. We are faithful servants of the Iron Horde. It will be soon, now.',26124),
(76788,'enUS','Hurry up then! The draenei temple will fall... SOON.','',26124),
(76789,'enUS','','Courier! Go to the main lodge and deliver the Iris Crystals to Chieftain Ner\'zhul. We mustn\'t keep our Iron Horde friends waiting.',26124),
(76790,'enUS','For generations I protected my people with the mists, and yet with each and every champion I see before me, I realize more and more the error of my ways. May you learn from the lessons of Pandaria, as I have.','',26124),
(76791,'enUS','I am so happy to share this moment with my son. Thank you again for all that you have done for us.','',26124),
(76792,'enUS','I am so happy to share this moment with my son.','',26124),
(76793,'enUS','Magic sky lanterns for sale! Light the candle and watch it float, even without wind!','',26124),
(76794,'enUS','The sound of grinding metal reverberates through the halls as the lock on the Nexus doors releases.','',26124),
(76795,'enUS','I have a limitless supply of Kor\'kron at my command you fools! Surrender now and I will give you a quick death.','',26124),
(76796,'enUS','You must find Thrall and put a stop to Hellscream\'s reign.','',26124),
(76797,'enUS','Once we\'ve dealt with the ogres, the Burning Blade, and the orcs at Lok-rath, we\'ll be ready to move on Grommashar.','',26124),
(76798,'enUS','Without the protection of the Celestials you are forcibly ejected from Ordos\' temple!','Without the protection of the Celestials you are forcibly ejected from Ordos\' temple!',26124),
(76800,'enUS','Did you see that? He nearly took my head off!','Did you see that? He nearly took my head off!',26124),
(76801,'enUS','A Rangari spy? Here, in our village?','A Rangari spy? Here, in our village?',26124),
(76802,'enUS','Were you sleeping on duty AGAIN?','Were you sleeping on duty AGAIN?',26124),
(76803,'enUS','Uh... no...','Uh... no...',26124),
(76804,'enUS','Or fed to our wolves?','Or fed to our wolves?',26124),
(76805,'enUS','Ahahaha!','Ahahaha!',26124),
(76806,'enUS','Haha!','Haha!',26124),
(76822,'enUS','','We show these orcs mercy and how do they repay us?! Just look around!',26124),
(76823,'enUS','','They\'re building weapons, but why?',26124),
(76824,'enUS','','We\'ve won this battle, but the war is far from over, $n.',26124),
(76825,'enUS','','I will make sure the Iris Crystal gets back to the prophet. I sense you still have much to do.',26124),
(76826,'enUS','','The Prophet will be disappointed to hear of our failure.',26124),
(76827,'enUS','','Just look at all of these supplies being amassed!',26124),
(76828,'enUS','','What need would the Iron Horde have for weapons if they did not intend to attack again?',26124),
(76829,'enUS','','We should not have shown them mercy...',26124),
(76830,'enUS','','All we\'ve done is given them time to regroup.',26124),
(76831,'enUS','','We need to hurry. The Iron Horde will mobilize again soon by the looks of it.',26124),
(76832,'enUS','','I\'m itching to bury my mace in some orc skulls!',26124),
(76833,'enUS','','We should have never trusted the Iron Horde!',26124),
(76834,'enUS','','The only good orc is a dead orc...',26124),
(76835,'enUS','','Hellscream will pay for this dishonesty with his life!',26124),
(76836,'enUS','','It\'s about time we try a little hostile negotiations!',26124),
(76837,'enUS','','I will purge you from this land!',26124),
(76838,'enUS','','Your betrayal will not be forgotten, orc!',26124),
(76839,'enUS','','Let this be a message to Grommash!',26124),
(76840,'enUS','','You do not belong in Shadowmoon orc filth!',26124),
(76841,'enUS','','I\'ll handle this one!',26124),
(76842,'enUS','','This is terrible... Grommash Hellscream has ordered a second attack on Karabor. So much for a peaceful resolution.',26124),
(76843,'enUS','','This isn\'t so much a journal as it is an order form...',26124),
(76844,'enUS','','With the amount of weapons and ammunition they intend to build Karabor will be left in ruins!',26124),
(76845,'enUS','','Let me see that. Here we go! The Iris Crystal has been moved, but it\'s still in the area. We still have time to find it and return it to the Prophet.',26124),
(76846,'enUS','Th-thank you, stranger...','Th-thank you, stranger...',26124),
(76847,'enUS','Get me out of here!','Get me out of here!',26124),
(76848,'enUS','','We don\'t have time to waste here, $n.',26124),
(76849,'enUS','Look at that roast, Ufga! I bet our Iron Horde guests have never tasted anything like it.','',26124),
(76850,'enUS','We need to hurry. The sooner we start blowing stuff up, the sooner we can focus on activating the crystal.','',26124),
(76851,'enUS','I\'m going to need more than a couple props and a can of Kaja\'Cola to pull this off.','',26124),
(76852,'enUS','I\'ll show those smelly orcs a thing or two.','',26124),
(76853,'enUS','Why? Why do they attack us?','Why? Why do they attack us?',26124),
(76854,'enUS','I never wanted a fight...','I never wanted a fight...',26124),
(76855,'enUS','I thought I was going to die!','I thought I was going to die!',26124),
(76856,'enUS','Thank the naaru, I\'m saved!','Thank the naaru, I\'m saved!',26124),
(76857,'enUS','','Performing the same action multiple times in a row will get you a small bonus. Try seating many customers or delivering their orders in rapid succession to earn extra points!',26124),
(76858,'enUS','Do you like hammers?','',26124),
(76859,'enUS','Don\'t take dose hammers!','',26124),
(76860,'enUS','Don\'t need deez no more.','',26124),
(76861,'enUS','Dem hammers not workin\'.','',26124),
(76862,'enUS','Time for udder hammers.','',26124),
(76863,'enUS','Deez hammers is stupid.','',26124),
(76864,'enUS','Der\'s more where dose came from.','',26124),
(76865,'enUS','Tryin\' new hammers.','',26124),
(76866,'enUS','I t\'ink one of dose had a splinter.','',26124),
(76867,'enUS','I got more hammers den a fixer guy.','',26124),
(76868,'enUS','Here we are, $n. Time to stomp out these orcs once and for all.','',26124),
(76869,'enUS','Bet you didn\'t know I had a fif hammer!','',26124),
(76870,'enUS','You got anudder t\'ing comin\'!','',26124),
(76871,'enUS','I like to t\'row deez hammers at you!','',26124),
(76872,'enUS','Time for clang sound!','',26124),
(76873,'enUS','Da fif one is my favorite!','',26124),
(76874,'enUS','I\'ll try dis diff\'rent one!','',26124),
(76875,'enUS','Da more hammers da better!','',26124),
(76876,'enUS','Jus\' hold still!','',26124),
(76877,'enUS','Rise, old friends. The time has come for the next step of my plan.','',26124),
(76878,'enUS','Teron\'gor, infiltrate the Auchenai and take control of Auchindoun. Bleed them dry.','',26124),
(76879,'enUS','Cho\'gall, we\'ll finish your Frostfire business together.','',26124),
(76880,'enUS','I see beyond your guise, child. Do not be afraid.','',26124),
(76881,'enUS','I\'m sending you to Nagrand to subjugate the naaru in Oshu\'gun.','',26124),
(76885,'enUS','We should send her head to Karabor as a message!','',26124),
(76894,'enUS','Use the Vial of Moon Water to compel the All-Seeing Eye.$B$B|TInterface\\Icons\\INV_Potion_20.blp:64|t','',26124),
(76895,'enUS','When the demon is weakened, read from the Scripture of Elune.$B$B|TInterface\\Icons\\INV_Scroll_12.blp:64|t','',26124),
(76896,'enUS','A crawler mine detonated on $n!','',26124),
(76897,'enUS','Foul Stream is being cast on you!','',26124),
(76898,'enUS','','We should have dealt with the Iron Horde when we had the chance.',26124),
(76899,'enUS','Send in da reserves! Charge!','Send in da reserves! Charge!',26124),
(76900,'enUS','Warlord Zaela orders a |cFFFF0404|hKor\'kron Demolisher|h|r to assault the tower!','Warlord Zaela orders a |cFFFF0404|hKor\'kron Demolisher|h|r to assault the tower!',26124),
(76901,'enUS','Soldiers! Come to my aid!','',26124),
(76902,'enUS','I yield!','',26124),
(76903,'enUS','GRAHHH!!!','',26124),
(76904,'enUS','Hellscream!','',26124),
(76905,'enUS','Your attack on Karabor was cowardly and unwarranted.','',26124),
(76906,'enUS','What\'s more, we thoroughly outclassed your orcs on the battlefield.','',26124),
(76907,'enUS','I would be within my rights to behead you and raze this town...','',26124),
(76908,'enUS','...but not today.  Today, we show mercy.  Pack up your machines of war and leave this place.','',26124),
(76909,'enUS','Y... yes, sir. We will leave right away. You have my word.','',26124),
(76910,'enUS','I\'ll take you down with me, $c!','',26124),
(76911,'enUS','Retrieving the Iris Crystal','Retrieving the Iris Crystal',26124),
(76912,'enUS','Go away!','Go away!',26124),
(76913,'enUS','My moonstone! No follow me!','My moonstone! No follow me!',26124),
(76914,'enUS','You smell bad! You no friend at all!','You smell bad! You no friend at all!',26124),
(76915,'enUS','You should get no foods!','You should get no foods!',26124),
(76916,'enUS','RUNAWAY!!!','',26124),
(76917,'enUS','LEAF ME ALONE!!','',26124),
(76918,'enUS','This moonstone for friends!','This moonstone for friends!',26124),
(76919,'enUS','NOT GOOD!','',26124),
(76920,'enUS','NOBODY LIKES YOU! KEEP YOUR DISTANCE $C!','',26124),
(76921,'enUS','NOBODY LIKES YOU!','NOBODY LIKES YOU!',26124),
(76922,'enUS','','Brewly keeps drinking Uncle\'s brew.  Hope it makes him strong in the fight!',26124),
(76923,'enUS','','That dumb cricket keeps me up at night.  Don\'t tell Uncle, but I want you to squash it!',26124),
(76924,'enUS','','Sometimes Tonsa lets me ride on his back... but he\'s kinda stinky.',26124),
(76925,'enUS','','I don\'t know why he won\'t listen to me!  I\'m just trying to explain how to make his noodles even better.',26124),
(76926,'enUS','A song?','A song?',26124),
(76927,'enUS','','Yes!  A song about the lore and all the lessons we can learn from it all.  Sounds exciting, doesn\'t it?$b$bBut... we\'re still working on it.  Chadrik seems easily distracted lately.  Is there something on my tabard?',26124),
(76928,'enUS','No orc steps foot in Karabor and gets away with it.','',26124),
(76929,'enUS','Deploy the gear! Establish a perimeter!','',26124),
(76930,'enUS','Oh, hello friends! We\'ve just about secured the surface, it looks like the real fight\'s going to be down here.','',26124),
(76931,'enUS','Don\'t worry, we\'ve got your back!  Forge ahead, brave heroes!','',26124),
(76932,'enUS','My expertise is needed elsewhere, heroes! When you see Garrosh, tell him he should\'ve invested in gnomish technology!','',26124),
(76933,'enUS','','Earth!',26124),
(76934,'enUS','Bend to our will!','Bend to our will!',26124),
(76935,'enUS','','We do not ask the elements for aid...',26124),
(76936,'enUS','','Tortured wind, stale and toxic!',26124),
(76937,'enUS','','Long-dead fire, black and smouldering!',26124),
(76938,'enUS','The blood of the True Horde lusts for power!','The blood of the True Horde lusts for power!',26124),
(76939,'enUS','','I can hear them no longer...',26124),
(76940,'enUS','','My wolf will feast on your blood!',26124),
(76941,'enUS','Storm!','',26124),
(76942,'enUS','And fire!','',26124),
(76943,'enUS','The True Horde takes what it wants!','',26124),
(76944,'enUS','Anguished water, stagnant and poisonous!','',26124),
(76945,'enUS','Crumbling earth, plagued with rust!','',26124),
(76946,'enUS','The blood of the True Horde lusts for power!','The blood of the True Horde lusts for power!',26124),
(76947,'enUS','The elements... what have we done...','',26124),
(76948,'enUS','Your skull will adorn my necklace.','',26124),
(76949,'enUS','Glad you made it. Are we ready to proceed?','Glad you made it. Are we ready to proceed?',26124),
(76950,'enUS','Reporting for duty!','Reporting for duty!',26124),
(76951,'enUS','Glad you made it. Are we ready to proceed?','',26124),
(76952,'enUS','We should subjugate these Pale orcs and the... (An intruder! Let\'s leave.)','',26124),
(76953,'enUS','Foods!','',26124),
(76954,'enUS','More foods! Happy day!','More foods! Happy day!',26124),
(76955,'enUS','Yay foods!','Yay foods!',26124),
(76956,'enUS','I will be chief! You will be lunch.','',26124),
(76957,'enUS','We don\'t like you anymore!','',26124),
(76958,'enUS','Go tell chief I new boss in these woods!','',26124),
(76959,'enUS','With the warlock\'s magic device, you and I will spy upon the Shadow Council.','',26124),
(76960,'enUS','I\'m getting so hungry...','',26124),
(76961,'enUS','|TInterface\\Icons\\Ability_Siege_Engineer_Superheated.blp:20|t Shanna is firing her laser at you!','',26124),
(76962,'enUS','','It sounds like they\'ve conjured demonic eye sentries. Be careful down there.',26124),
(76963,'enUS','No creature should be subjected to what they\'re doing down there.','',26124),
(76964,'enUS','We must end the Shadow Council threat.','',26124),
(76965,'enUS','Get your Noodle Soup here!','Get your Noodle Soup here!',26124),
(76966,'enUS','I am ready, Khadgar. Let\'s use the All-Seeing Ring.','I am ready, Khadgar. Let\'s use the All-Seeing Ring.',26124),
(76967,'enUS','Let me know when you\'re ready.','',26124),
(76968,'enUS','','Isn\'t Pierre amazing?  My friend Jard made him for me!',26124),
(76969,'enUS','','I want to train him, but I really don\'t want him to get hurt.',26124),
(76970,'enUS','','He\'s really nice and he tries to cook things for me. Unfortunately, they aren\'t edible and I have to toss them out when he isn\'t looking.',26124),
(76971,'enUS','Come on orcs! Come and get your justice!','',26124),
(76972,'enUS','You fought your way into Karabor, now you\'ll have to fight your way through me!','',26124),
(76973,'enUS','Come! Come and fight me! Are you afraid?','',26124),
(76974,'enUS','You made a mistake attacking Karabor, orcs. You\'ve awoken a sleeping giant!','',26124),
(76975,'enUS','Teron\'gor, we\'ll finish your Shadowmoon business together.','',26124),
(76976,'enUS','I\'m sending you to Talador. Infiltrate the Auchenai. Take control of Auchindoun. Bleed it dry.','',26124),
(76977,'enUS','Yes, commander!','Yes, commander!',26124),
(76978,'enUS','As you wish, commander!','As you wish, commander!',26124),
(76979,'enUS','Cho\'gall, I\'m sending you to Nagrand.','',26124),
(76980,'enUS','For the Iron Horde!','For the Iron Horde!',26124),
(76981,'enUS','R-r-r-rahh!!','R-r-r-rahh!!',26124),
(76982,'enUS','You\'ll subjugate the fallen naaru inside Oshu\'gun.','',26124),
(76983,'enUS','Giselda, you stay here. I have other plans for... what is behind me?','',26124),
(76984,'enUS','Can I has a bite?','Can I has a bite?',26124),
(76985,'enUS','You smell like Foods!','You smell like Foods!',26124),
(76986,'enUS','Yummy!','Yummy!',26124),
(76987,'enUS','Nom Noms!','Nom Noms!',26124),
(76988,'enUS','','Now is my chance!',26124),
(76989,'enUS','You my best friend.','',26124),
(76990,'enUS','I help you find all the friends.','',26124),
(76991,'enUS','Hello best friend!','',26124),
(76992,'enUS','Let\'s find your friends!','',26124),
(76993,'enUS','You smell so good best friend.','',26124),
(76994,'enUS','I will help you best friend!','',26124),
(76995,'enUS','Mine! Go away!','',26124),
(76996,'enUS','Get your own foods!','',26124),
(76997,'enUS','I\'m cheif now! Go tell friends!','',26124),
(76998,'enUS','You no friend!','',26124),
(76999,'enUS','You smell bad! Stinky mud!','',26124),
(77000,'enUS','Go away! This my forest now!','',26124),
(77001,'enUS','Stay away from best friend!','',26124),
(77002,'enUS','','I\'ve never seen anything quite like this!  I think I\'ll be healing a lot of pets after the tournament is over.',26124),
(77003,'enUS','','Oh, no I\'m sorry but I can\'t!  It\'s against the rules to heal pets during the tournament.',26124),
(77004,'enUS','Sometimes I impress even myself. And down goes the dragon!','',26124),
(77005,'enUS','','And there goes the other one.',26124),
(77006,'enUS','For the True Horde!','For the True Horde!',26124),
(77007,'enUS','Lok\'tar Ogar!','Lok\'tar Ogar!',26124),
(77008,'enUS','Blood and Thunder!','Blood and Thunder!',26124),
(77009,'enUS','Garrosh Hellscream','Garrosh Hellscream',26124),
(77010,'enUS','General Nazgrim','General Nazgrim',26124),
(77011,'enUS','Helix Blackfuse','Helix Blackfuse',26124),
(77013,'enUS','By your command.','By your command.',26124),
(77014,'enUS','Great job taking out those cannons, hero. Are you ready to settle this for good?','Great job taking out those cannons, hero. Are you ready to settle this for good?',26124),
(77015,'enUS','Warchief Hellscream','Warchief Hellscream',26124),
(77016,'enUS','For Warchief Hellscream!','For Warchief Hellscream!',26124),
(77017,'enUS','Legionnaire Nazgrim','Legionnaire Nazgrim',26124),
(77018,'enUS','Siegecrafter Blackfuse','Siegecrafter Blackfuse',26124),
(77019,'enUS','Warlord Zaela','Warlord Zaela',26124),
(77020,'enUS','My life for the Horde!','My life for the Horde!',26124),
(77022,'enUS','','Come rest for a while in the shade!',26124),
(77023,'enUS','','Delicious food and drink at  reasonable prices!',26124),
(77024,'enUS','','Come rest your weary feet, adventurer!',26124),
(77025,'enUS','','Hungry? Thirsty? Tired? Let Graceful Swan take care of you!',26124),
(77026,'enUS','','Arms and armor repaired!',26124),
(77027,'enUS','','Blades sharpened! Armor mended!',26124),
(77028,'enUS','','Don\'t be caught unprepared! Let Crafter Kwon see to your gear!',26124),
(77029,'enUS','','Fine weapons and armor for sale!',26124),
(77030,'enUS','BUY NOODLES!','',26124),
(77031,'enUS','Best. Noodles! EVER!','',26124),
(77032,'enUS','I got good noodles here!','',26124),
(77033,'enUS','Victory or Death!','Victory or Death!',26124),
(77034,'enUS','Monmon study MANY weeks with master noodle chef.','',26124),
(77035,'enUS','Die with Honor!','Die with Honor!',26124),
(77036,'enUS','Please come enjoy my fine Golden Dragon Noodles.','',26124),
(77037,'enUS','You will find only the best noodles in all Pandaria here.','',26124),
(77038,'enUS','I would be honored by your patronage, adventurer.','',26124),
(77039,'enUS','Golden Dragon Noodles! The very BEST!','',26124),
(77040,'enUS','Look here! He left his weapon behind.','',26124),
(77041,'enUS','This means he\'s completely unhinged.','',26124),
(77042,'enUS','Likewise. Sylvanas and I have both sent ships to support Vol\'jin\'s revolution.','',26124),
(77043,'enUS','It is always a pleasure to see you, Lady Proudmoore.','',26124),
(77044,'enUS','Champions, come with me. It\'s time to settle grievances with our... \"Warchief.\"','',26124),
(77045,'enUS','','So Hellscream\'s arrogance unleashed the last of the sha. I am not surprised.',26124),
(77046,'enUS','','Gorehowl.',26124),
(77047,'enUS','','News to no one, Regent Lord. King Wrynn\'s fleet is converging on Orgrimmar as we speak.',26124),
(77048,'enUS','','I\'m warning you, Lor\'themar. The Alliance is besieging the city and we will destroy Hellscream. Your people had best stay out of our way.',26124),
(77049,'enUS','','Come heroes, through the portal! The siege of Orgrimmar begins!',26124),
(77050,'enUS','%s\'s projection explodes!','%s\'s projection explodes!',26124),
(77051,'enUS','FEAST LIKE A CHIEFTAIN! Yaungolian noodles!','',26124),
(77052,'enUS','Why settle for weak, flavorless noodles? Try them yaungolian style!','',26124),
(77053,'enUS','HOT AND HEARTY! Come try Yaungolian noodles!','',26124),
(77054,'enUS','Bold flavor, bold heat! No other noodles come close!','',26124),
(77055,'enUS','Exotic, aromatic, a brew good for both body and spirit!','',26124),
(77056,'enUS','Shimmering amber-brew! Come and try!','',26124),
(77057,'enUS','Exquisite amber-brew from beyond the Serpent\'s Spine!','',26124),
(77058,'enUS','Brave the brew that\'s truly unique! Invigorating, satisfying... amber-brew!','',26124),
(77059,'enUS','Sap is where it\'s at.','',26124),
(77060,'enUS','Steaming goat noodle: NUMBER ONE!','',26124),
(77061,'enUS','Come fill belly with noodle, yes! Very good!','',26124),
(77062,'enUS','STEAMING GOAT NOODLE! The best!','',26124),
(77063,'enUS','Noodle so tasty! You come try, yes?','',26124),
(77064,'enUS','Gul\'dan is with them!','',26124),
(77065,'enUS','Greetings, I am Shaohao. Are you hear to hear the wisdom of the Celestials?','',26124),
(77066,'enUS','','Tell me when you are ready, $n. And get ready to fight.',26124),
(77067,'enUS','Let\'s get out of here!','Let\'s get out of here!',26124),
(77068,'enUS','','For the finest food, look no further!',26124),
(77069,'enUS','','Come, sit down, enjoy a meal!',26124),
(77070,'enUS','[PLACEHOLDER] AWESOME HOLY VISUALS OF VELEN BREAKING FREE OF CHAINS!','',26124),
(77071,'enUS','','There is no dish I have not mastered! Come and eat!',26124),
(77072,'enUS','Now\'s our chance. Let\'s go!','Now\'s our chance. Let\'s go!',26124),
(77073,'enUS','','Delicious dishes and fresh-made island delicacies!',26124),
(77074,'enUS','Magic sky lanterns for sale!','',26124),
(77075,'enUS','Light the candle and watch one float, even without wind!','',26124),
(77076,'enUS','Do you wish to see the island from the sky? Glide upon a golden kite!','',26124),
(77077,'enUS','The perfect mix of northern and southern styles!','',26124),
(77078,'enUS','GRUB N\' GROG!','',26124),
(77079,'enUS','Ye won\'t find anythin\' like it elsewhere. Come and try!','',26124),
(77080,'enUS','Dare ta drink a Dragon P.I.E.! It\'ll put hair on yer chest, and then hair on THAT!','',26124),
(77081,'enUS','I will eat your face off!!!','',26124),
(77082,'enUS','Lucky-Lucky! Come have some noodles!','',26124),
(77083,'enUS','Yoo-hoo! Come try some Lucky Mushroom Noodles?','',26124),
(77084,'enUS','So tasty! So delicious! Double Lucky special noodles!','',26124),
(77085,'enUS','Hey hey! Come here, have some tasty noodles!','',26124),
(77086,'enUS','That cave is inside the Gloomspire. Those are the ruins of Ata\'gar to the west.','',26124),
(77087,'enUS','Remind me about the time we used the All-Seeing Ring to spy on Gul\'dan and the Shadow Council.','Remind me about the time we used the All-Seeing Ring to spy on Gul\'dan and the Shadow Council.',26124),
(77088,'enUS','River style noodles, made with only the freshest fish.','',26124),
(77089,'enUS','Please try my Harmonious River Noodles. They will not disappoint.','',26124),
(77090,'enUS','Fresh fish, caught within the hour! ...I think? Curse this island.','',26124),
(77091,'enUS','Harmonious River Noodles!','',26124),
(77092,'enUS','It\'s Stormstout time!','',26124),
(77093,'enUS','When you say Stormstout, you\'ve said it all.','',26124),
(77094,'enUS','Stormstout: The emperor of brews!','',26124),
(77095,'enUS','Stormstout: Delicious and light!','',26124),
(77096,'enUS','Stormstout: It\'s all about the brew.','',26124),
(77097,'enUS','If you\'ve got the time, we\'ve got the brew. Stormstout!','',26124),
(77098,'enUS','Stormstout. Pandaren for \"beer.\"','',26124),
(77099,'enUS','Stormstout. Probably the best brew in Azeroth.','',26124),
(77100,'enUS','Greenstone Brew! Straight from the heart of the Jade Forest.','',26124),
(77101,'enUS','Taste the jade! Greenstone Brew!','',26124),
(77102,'enUS','Nothing beats the bold bite of Greenstone Brew!','',26124),
(77103,'enUS','You there! Come and try some Greenstone Brew!','',26124),
(77104,'enUS','Send word to the rest of the pack: The sons of the Iron Wolf have been found. Lok\'tar ogar!','',26124),
(77105,'enUS','My... father... will... avenge... me.','',26124),
(77106,'enUS','<You find a journal laying in a pool of blood.$b$bYou attempt to read it, unfortunately the blood has fused the pages together.>','',26124),
(77107,'enUS','Your father will mourn, as I have mourned.','',26124),
(77108,'enUS','We are honored that you are here to help us, $n. Together, we\'ll destroy the foul things that are plaguing our land.','',26124),
(77109,'enUS','You\'ll find the Sleeper\'s lair to the southwest across the dunes.','',26124),
(77111,'enUS','I can make this into a cool hat!','',26124),
(77112,'enUS','I\'ll meet you there.','',26124),
(77113,'enUS','You\'re Screwed!','',26124),
(77114,'enUS','You\'re about to take a turn for the worse!','',26124),
(77115,'enUS','This is going to hurt a bit!','',26124),
(77116,'enUS','','Every Shadow Council member we kill now is one less headache later.',26124),
(77117,'enUS','The people of Pandaria came here millennia ago to watch aspiring emperors face the challenges of the August Celestials.\n\nSo! Are you here to watch would-be heroes brave the Celestials\' tests?\n\nOr to brave them yourself?','',26124),
(77118,'enUS','RATTLESKEW!','',26124),
(77119,'enUS','DESTROY!','',26124),
(77120,'enUS','I... remember... you...','',26124),
(77121,'enUS','','Ishnu-alah, commander.',26124),
(77122,'enUS','Place offering','',26124),
(77123,'enUS','The three crystals are strategically located about the ruins. Destroy them with the Heart of Fernus.','',26124),
(77124,'enUS','Khadgar, did I leave the Heart of Fernus here?','Khadgar, did I leave the Heart of Fernus here?',26124),
(77125,'enUS','','I\'m more beautiful than ever.',26124),
(77126,'enUS','WHAT?! I remember you.','',26124),
(77127,'enUS','I won\'t lower myself to fight you, but, I have an idea.','',26124),
(77128,'enUS','Would you like to leave this nightmare?','',26124),
(77129,'enUS','Take me back.','Take me back.',26124),
(77130,'enUS','Giselda, my beauty, your time has come.','',26124),
(77132,'enUS','','What? No...',26124),
(77134,'enUS','Half-breed.','',26124),
(77135,'enUS','I will not sit here waiting for Ligra and Korga while Gorr\'thog still breathes.','',26124),
(77136,'enUS','','Throm-Ka, $C. We got cut off from Ga\'nar during the initial attack.',26124),
(77137,'enUS','Lok\'tar. Gorr\'thog\'s chamber is just ahead.','',26124),
(77138,'enUS','','Uncle brought a keg to drink if he wins, and two to drink if he loses.  So in the end, I guess he still won!',26124),
(77139,'enUS','Much yet remains to be done, friend. I will hold this point until the keep is more secure. We cannot let Gorr\'thog escape.','',26124),
(77140,'enUS','','The Iron Horde approaches. No sudden movements.',26124),
(77141,'enUS','I\'ve fought my way to the ramp leading to Gorr\'thog\'s throne. It is time to strike!','',26124),
(77142,'enUS','<Niuzao nods approvingly at you.>','',26124),
(77143,'enUS','What you have achieved today will shape the face of Pandaria for thousands of years to come.$b$bThank you, hero. The Lorewalkers shall pass your story down from generation to generation.','',26124),
(77144,'enUS','A soft hum ceases as the corruption creating new Puddles ebbs away with the death of the final Aqueous Defender.','',26124),
(77145,'enUS','Now I will eat you!!','',26124),
(77146,'enUS','No! You supposed to be foods...','',26124),
(77147,'enUS','Sabotaging','Sabotaging',26124),
(77148,'enUS','','Throm-Ka, Commander Vorka. The Shadowmoon clan is honored by your presence.',26124),
(77149,'enUS','Shaman, women... <spits>. I have no time for seers and mystics.','',26124),
(77150,'enUS','Where are your true warriors? Or, is what they say about the Shadowmoon true?','',26124),
(77151,'enUS','That you\'re a mass of cravens hiding behind your magic?','',26124),
(77152,'enUS','Iron Sentinels! To me!','',26124),
(77153,'enUS','Step aside, brothers. We must speak with Hellscream.','',26124),
(77154,'enUS','No one may enter the city. Not even you, Shaman.','No one may enter the city. Not even you, Shaman.',26124),
(77155,'enUS','Thrall? Varok? What business do you have here?','',26124),
(77156,'enUS','Strength and Honor, General. We come to speak with Garrosh. There may yet be hope for peace.','',26124),
(77157,'enUS','But...','But...',26124),
(77158,'enUS','Kor\'kron! You are needed at the front!','',26124),
(77159,'enUS','NOW!','',26124),
(77160,'enUS','You know I can make no guarantee of your safety... or Garrosh\'s response.','',26124),
(77161,'enUS','Lok\'tar Ogar, brothers.','',26124),
(77162,'enUS','Who\'s next?','',26124),
(77163,'enUS','','Cravens? I\'ll show you craven!',26124),
(77164,'enUS','Hold. I would not spill your blood today, Hara.','',26124),
(77165,'enUS','You Shadowmoon are proud and still have the warriors\' spirit!','',26124),
(77166,'enUS','','<Narrows her eyes, but relaxes.>',26124),
(77167,'enUS','','Very well, Vorka, son of Vorash. The Shadowmoon clan will join this Iron Horde.',26124),
(77168,'enUS','','Lok-Regar. What orders?',26124),
(77169,'enUS','Gather your clan. Soon the Iron Horde will crush Karabor once and for all!','',26124),
(77170,'enUS','','Zug-zug.',26124),
(77171,'enUS','I\'m so hungry.$b$bChief kicks me out of village. Says that I\'m foods? I will be new chief. When I have all the foods, foreling friends all love me. When friends love me, they give me more foods! I need lots of friends.$b$bYou my best friend, $c.','',26124),
(77172,'enUS','Careful friend, these woods can be dangerous.','',26124),
(77173,'enUS','Beware the podlings, $c. They are not what they seem.','',26124),
(77174,'enUS','The Podlings will say they are your friends. They are not.','',26124),
(77175,'enUS','If we are not vigilant, the podlings\' hunger will consume us all.','',26124),
(77176,'enUS','I would be careful in this forest, $c.','',26124),
(77177,'enUS','Yeehaw!!!','',26124),
(77178,'enUS','What am I thinking?! I haven\'t trained on this piece of equipment! AAAAH!','',26124),
(77179,'enUS','HOT! HOT! HOT!','',26124),
(77180,'enUS','Alert. You are combusting. Please execute safety procedures.','',26124),
(77181,'enUS','Alright boys, lets go nuts.','',26124),
(77182,'enUS','Annihilator activated!','',26124),
(77183,'enUS','We\'re going to need a mop over here!','',26124),
(77184,'enUS','Wow! Now that is an incredible piece of shiny!','',26124),
(77185,'enUS','Let\'s see what sort of toys the Kor\'kron have been building.','',26124),
(77186,'enUS','Time to clean up! Activate the Annihilator!','',26124),
(77187,'enUS','Woof!','',26124),
(77188,'enUS','','These ogres have a painful lesson to learn.',26124),
(77189,'enUS','','Never leave a Frostwolf alive.',26124),
(77190,'enUS','','Thank you for freeing me. You fight with the skill of a Frostwolf.',26124),
(77192,'enUS','','Our paths diverge here. Good luck, champion.',26124),
(77193,'enUS','Hatock, son of the Iron Wolf! I come for your head.','',26124),
(77194,'enUS','Well look here boys, the mongrel son of Garad has returned from the grave.','',26124),
(77195,'enUS','Hrah hrah hrah! You should have stayed dead, Ga\'nar. You would have lived longer.','',26124),
(77196,'enUS','Had Garrad just joined the Iron Horde like he was told you would still have your precious daddy to save you today.','',26124),
(77197,'enUS','Chose your last words carefully Hatock. There is no Thunderlord that can stand against me.','',26124),
(77198,'enUS','Yes, your wolves are very formidable in battle when in the open. But let us see how you do in the shadow of a gronn.','',26124),
(77199,'enUS','Thunderlord...  RELEASE THE BEAST!','',26124),
(77200,'enUS','Keep a grip on those chains.','',26124),
(77201,'enUS','His arm is loosening! Tighten that slack before he puts you all against a wall.','',26124),
(77202,'enUS','Put your backs into it!','',26124),
(77203,'enUS','We have a schedule to keep.','',26124),
(77204,'enUS','Follow me.','',26124),
(77205,'enUS','Let me know when you are ready to move forward with our attack.','',26124),
(77206,'enUS','The Frostwolves will sing songs of this day.','',26124),
(77207,'enUS','I\'m ready to begin.','I\'m ready to begin.',26124),
(77208,'enUS','Speak to me when you are ready.','',26124),
(77209,'enUS','Let\'s go.','',26124),
(77210,'enUS','You feel the blessing of the Celestials as your cloak billows with jade mist.','You feel the blessing of the Celestials as your cloak billows with jade mist.',26124),
(77211,'enUS','Your attacks on my clan end here, ogre.','',26124),
(77212,'enUS','I have an empire at my back. What do you have, little orcs?','',26124),
(77213,'enUS','The strength of the Frostwolves. Lok\'tar ogar!','',26124),
(77214,'enUS','Enough! Enough!','',26124),
(77215,'enUS','Hatock, son of the Iron Wolf! I come for your head.','',26124),
(77216,'enUS','Let me live, and we won\'t attack your people again.','',26124),
(77217,'enUS','Like you let my clan\'s women and children live in your raids?','',26124),
(77218,'enUS','Some empire.','',26124),
(77220,'enUS','','The others, are they okay?',26124),
(77225,'enUS','','We were... also separated.',26124),
(77226,'enUS','','You ready to race?',26124),
(77227,'enUS','Yes!','Yes!',26124),
(77228,'enUS','','Ready... set... go!',26124),
(77229,'enUS','Why you here? What\'s this?','',26124),
(77230,'enUS','I do not know. But the orc who dragged us here is feasting nearby. We get him first.','',26124),
(77231,'enUS','','Come. Let\'s find your frost wolf.',26124),
(77232,'enUS','What is wrong Ga\'nar? Afraid of a bit of Gronn?','',26124),
(77233,'enUS','I thought you Frostwolves were supposed to be skilled?','',26124),
(77234,'enUS','Not so easy to fight a Thunderlord, is it?','',26124),
(77236,'enUS','You mongrels are no match for my blade!','',26124),
(77237,'enUS','If you had just joined the Iron Horde I wouldn\'t have to kill you now.','',26124),
(77238,'enUS','','Yes, that\'s it! The perfect disguise!',26124),
(77239,'enUS','','Now that\'s what I call a hat!',26124),
(77240,'enUS','Hatock! You cannot hide from me!','',26124),
(77241,'enUS','','Not bad, if you want to look like an orc with no fashion sense.',26124),
(77242,'enUS','','The embroidery on that shirt is just lovely if I say so myself.',26124),
(77243,'enUS','','The perfect accessory for pillaging, don\'t you think?',26124),
(77244,'enUS','','I can feel the fireballs already!',26124),
(77245,'enUS','','Wow! You look just like an orc with that mask.',26124),
(77246,'enUS','','Oooh yes, underwater is all the rage this season!',26124),
(77247,'enUS','You are tiny, useless insects!','',26124),
(77248,'enUS','Look chief! I bring all these goodies for you! And we can eat this guy!','',26124),
(77249,'enUS','','Looking sharp!',26124),
(77250,'enUS','I fight for the empire!','',26124),
(77251,'enUS','','Wowza! You look great, but that dress might be a bit... impractical.',26124),
(77252,'enUS','','Nice color, but the cut is too rustic if you ask me.',26124),
(77253,'enUS','','Very stylish, but it\'s just not ORC enough.',26124),
(77254,'enUS','','That skirt is soooo last year.',26124),
(77255,'enUS','','No no no, totally the wrong shade of red! I asked for crimson, not scarlet.',26124),
(77256,'enUS','Nobody is as strong as I am!','',26124),
(77257,'enUS','','That kilt goes well with your eyes.',26124),
(77258,'enUS','','It fits you well, but it just doesn\'t scream \"$n.\"',26124),
(77259,'enUS','You... will... regret this...','',26124),
(77260,'enUS','','We need to find the perfect outfit, so mix and match all three clothing options until we get the right Shadowmoon orc disguise!',26124),
(77261,'enUS','Ha ha hah hahh! We have you surrounded, whelp!','',26124),
(77262,'enUS','Throm-Ka, $C. Thrall has spoken highly of you.','',26124),
(77263,'enUS','The Bladespire ogres have plagued my people for too long. It is time to take action.','',26124),
(77264,'enUS','It is time to address this problem at its source.','',26124),
(77265,'enUS','Come, brother. You are free now.','',26124),
(77266,'enUS','%s sniffs Lokra and whines.','',26124),
(77267,'enUS','He must pay!!','',26124),
(77268,'enUS','','You smell Asha, don\'t you? I... am so sorry, Nerok. I failed to protect her.',26124),
(77269,'enUS','So many brothers and sisters lost...','',26124),
(77270,'enUS','','Oh, they will. Trust me.',26124),
(77271,'enUS','Unite the orc clans under a single banner! Join the Iron Horde today!','Unite the orc clans under a single banner! Join the Iron Horde today!',26124),
(77272,'enUS','Grommash Hellscream: legendary warrior, fearsome enemy. He will lead us to a better tomorrow!','Grommash Hellscream: legendary warrior, fearsome enemy. He will lead us to a better tomorrow!',26124),
(77273,'enUS','The might of the Iron Horde is unquestionable. Join today!','The might of the Iron Horde is unquestionable. Join today!',26124),
(77274,'enUS','Join the Iron Horde, or die beneath draenei rule!','Join the Iron Horde, or die beneath draenei rule!',26124),
(77275,'enUS','Are you orc enough for the challenge? Join Hellscream\'s forces today.','Are you orc enough for the challenge? Join Hellscream\'s forces today.',26124),
(77276,'enUS','Do not trust the draenei. They want you to fail!','Do not trust the draenei. They want you to fail!',26124),
(77277,'enUS','Trust only your own kind. Trust in the might of the Iron Horde!','Trust only your own kind. Trust in the might of the Iron Horde!',26124),
(77278,'enUS','Be a proud orc! Help the Iron Horde!','Be a proud orc! Help the Iron Horde!',26124),
(77279,'enUS','[PH] Stay tuned for a super epic fight scene between me and my brother, yo!','',26124),
(77280,'enUS','','Glad to see you made it through, $n!$B$BWelcome to Frostfire Ridge!',26124),
(77281,'enUS','I\'m ready to fly to Bladespire Citadel.','I\'m ready to fly to Bladespire Citadel.',26124),
(77282,'enUS','This metal is not like any you have worked with. It will fight back. Your will must be stronger!','',26124),
(77283,'enUS','Strike hard, and with purpose. As if you were crushing the skull of a hated foe!','',26124),
(77284,'enUS','Pay attention! This part is important.','',26124),
(77285,'enUS','See here? This is the reaction you are looking for.','',26124),
(77286,'enUS','Make every swing count! You aren\'t slamming out spearheads anymore.','',26124),
(77287,'enUS','FPOW!','',26124),
(77288,'enUS','Those sparks are weakness leaving the metal.','',26124),
(77289,'enUS','I am glad you have accompanied me on this journey, friend.','',26124),
(77290,'enUS','Come on you louts, put some muscle into it!','',26124),
(77291,'enUS','I want to hear that metal sing!','',26124),
(77292,'enUS','You want weapons like the Blackrock, you need to WORK like the Blackrock!','',26124),
(77293,'enUS','Keep up the momentum!','',26124),
(77294,'enUS','Every swing brings us closer to crushing our foes!','',26124),
(77295,'enUS','Good. Those are good strikes.','',26124),
(77296,'enUS','Do not let the material rest!','',26124),
(77297,'enUS','Use Naaru\'s Momentum to damage enemies, or to quickly escape danger.$B$B|TInterface\\Icons\\Spell_Holy_Heroism.blp:64|t','',26124),
(77298,'enUS','The darkness will overcome you! ATTACK!','',26124),
(77299,'enUS','The dark star... brightens...','',26124),
(77300,'enUS','Heh heh heh... you runts gonna die in here...','',26124),
(77301,'enUS','The flames will catch you, soon enough...','',26124),
(77302,'enUS','The Iron tide will wash over you, friend of the draenei...','',26124),
(77303,'enUS','The Iron Horde... comes...','',26124),
(77304,'enUS','AHHHHH!!!','',26124),
(77305,'enUS','IT BURNS!!!!','',26124),
(77306,'enUS','Run, brothers! Run away!','',26124),
(77307,'enUS','We don\'t stand a chance against them!','',26124),
(77308,'enUS','Back to the tower!','Back to the tower!',26124),
(77309,'enUS','To the tower!','To the tower!',26124),
(77310,'enUS','Fall back!','Fall back!',26124),
(77311,'enUS','Retreat!','Retreat!',26124),
(77312,'enUS','Retreat!','',26124),
(77313,'enUS','Run for your lives! They\'re in our walls!','',26124),
(77314,'enUS','Ga\'nar! We are with you! Lok\'tar ogar!','',26124),
(77315,'enUS','','You saved some for us? How thoughtful!',26124),
(77318,'enUS','Come, $n. Let us discuss how to best help Durotan and his clan.','',26124),
(77319,'enUS','<It looks like this shield belonged to the missing search party.$b$bUpon further inspection, you find what appears to be hundreds of little puncture marks covering the blood-stained armor.>','',26124),
(77320,'enUS','<You find thousands of tiny puncture marks covering the dead mule\'s body.>','',26124),
(77321,'enUS','The draenei are coming! Fall back!','',26124),
(77322,'enUS','Get back to the ships!','',26124),
(77323,'enUS','Back to the boats!','',26124),
(77324,'enUS','Run for your lives!','',26124),
(77325,'enUS','|TInterface\\Icons\\spell_holy_powerinfusion.blp:32|t\nK\'ara has blessed you. You can now track the remaining orcs on your minimap.','|TInterface\\Icons\\spell_holy_powerinfusion.blp:32|t\nK\'ara has blessed you. You can now track the remaining orcs on your minimap.',26124),
(77327,'enUS','Frostwolves! Fan out and harry the Thunderlord. For vengeance!','',26124),
(77334,'enUS','Destroy them! Destroy them in the name of the Shadowmoon clan!','',26124),
(77335,'enUS','Ahahahaaa... your defiance only fuels us, draenei.','',26124),
(77336,'enUS','Will mercy, truth, and goodness save you now?','',26124),
(77337,'enUS','Your ideals make you weak, draenei. Survival is the only truth in this world.','',26124),
(77338,'enUS','Enough of this! I will deal with you myself!','',26124),
(77339,'enUS','','I will gather my strength and we will meet you upstairs after you have found the others.',26124),
(77340,'enUS','You friends was here, now they gone.','',26124),
(77341,'enUS','The clues you seek, is by the pond.','',26124),
(77342,'enUS','You found the armor, no friend in reach.','',26124),
(77343,'enUS','You find more answers in the field.','',26124),
(77344,'enUS','Their mounts is dead, they must be saved.','',26124),
(77345,'enUS','Your final clue, is in the cave.','',26124),
(77346,'enUS','','Show Krag no mercy.',26124),
(77347,'enUS','I have nothing to say to you, $r.','I have nothing to say to you, $r.',26124),
(77348,'enUS','I have nothing to say to you, $r. Your people have a lot to answer for. But maybe this is a new beginning.','',26124),
(77349,'enUS','Thank you, hero. You and your companions were the tip of the Alliance spear: Your work exploring Pandaria, securing the Vale, and ultimately assaulting Garrosh\'s stronghold is what made this victory possible.$b$bOur triumph here will put a stop to the fighting in Kalimdor, but even in peace, there\'s much to be done - here, back home, and elsewhere.','',26124),
(77350,'enUS','What\'s next for the Alliance?','What\'s next for the Alliance?',26124),
(77351,'enUS','Why not keep fighting?','Why not keep fighting?',26124),
(77352,'enUS','We are unified like never before. We\'ve bought our people security in Kalimdor, an end to the blockade, and an end to the total war that\'s spilt so much blood on either side of the great sea.$b$bNow, to the work of winning the peace. I would like to station a garrison near Theramore. We need to investigate cleansing the plague from Gilnean lands so they can rebuild. We must contain Sylvanas.$b$bFrom here on forward, the Alliance will be proactive. Never again can there be another the likes of Hellscream.','',26124),
(77353,'enUS','I understand your desire to inflict more suffering on the Horde. But when do we stop? How many more Alliance will number among the dead if we invaded Thunder Bluff, Azshara, and the Echo Isles? And how would we govern the conquered people?$b$bThe Pandaren always question why we fight. Today, we\'ve won justice, and have given the Horde an opportunity to atone by supporting their rebellion. Further bloodshed would be for vengeance alone - and it would reap vengeance in return.','',26124),
(77354,'enUS','','King Wrynn will rue the day he allowed the Horde to name another Warchief.$b$bWe should\'ve kept fighting. Who\'s to say this new Warchief won\'t get any ideas in his troll head a few years from now?',26124),
(77355,'enUS','I think my father did the right thing. If we tried to occupy Orgrimmar, the fighting would never stop. And what about the rest of the Horde? Would we resort to internment camps? We\'ve been down that road before - it doesn\'t work!$b$bWe deposed of a warmonger and replaced him with a leader we can work with. It\'s our only chance for peace in the future.','',26124),
(77356,'enUS','Victory for the Alliance! Before we clear out of here, my people will grab as much of this crazy goblin technology as we can get our hands on.','',26124),
(77357,'enUS','','There\'s nothing like a common enemy to bring people together. The dwarven clans have never been so united. If the peace holds, our three kingdoms will be stronger than ever before...',26124),
(77358,'enUS','','Varian and I spoke at length about the price of peace before his decision here today. I am willing to allow the Horde the use of Azshara\'s lumber if they abandon Ashenvale for good. Knowing the way that goblins chew through resources, we will see how long that will sustain them.$b$bI support this peace, but I do not share the High King\'s confidence. If the Horde breaks treaty to engage us again... my people will be ready.',26124),
(77359,'enUS','A major victory, to be sure. We turn our attention now to our Gilnean homeland - ravaged by disease. Wrynn has pledged his help rebuilding my kingdom, but it is difficult to know where to begin.','',26124),
(77360,'enUS','Peace is all that is worth fighting for.','',26124),
(77361,'enUS','Stand tall, $c. Today ya saved de soul of de Horde.','',26124),
(77362,'enUS','I thought Garrosh was ready. I thought the mantle of Warchief would give him perspective. Of the many problems facing our people, he saw only one solution - his vision of the Horde brought us to the brink.$b$bIt is time for a new direction. Vol\'jin will take us there. In many ways he did not want this responsibility... but I think that will make him a better leader.','',26124),
(77363,'enUS','I find politics exhausting. I am confident Vol\'jin will take us where we need to go.$b$b<Lor\'themar glances over to Sylvanas.>$b$bAssuming he can hold this Horde together.','',26124),
(77364,'enUS','We are all in this together, $c.','',26124),
(77365,'enUS','','\"Warchief Vol\'jin.\" Does it sound absurd to you, $c? I, for one, certainly won\'t be taking orders from a troll.$b$b\nBut, he put this little coalition together, and won the day. He\'s also proven to be impossible to kill - I admire that.$b$b\nTime to test what he\'s made of...',26124),
(77366,'enUS','Vol\'jin\'s one tough nut. Stabbed in the neck, still he comes back to collect what\'s due. I like this guy!$b$bMy people need security and profit. Under Hellscream, we got a whole lot of neither.','',26124),
(77367,'enUS','He will regret crossing me.','',26124),
(77368,'enUS','Gorr\'thog! I, Ga\'nar, son of Garad, come for your head! Lok\'tar ogar!','',26124),
(77369,'enUS','|TInterface\\Icons\\inv_misc_bomb_05:20|tYou have |cFFFF0000|Hspell:145996|h[Set to Blow]|h|r! Use |cFFFF0000|Hspell:146364|h[Throw Bomb]|h|r to throw them!','',26124),
(77370,'enUS','Follow me. Maybe my brother Durotan will be brave enough to join us against Gorr\'thog.','',26124),
(77371,'enUS','Dat\'s de end of Hellscream.$b$b<Vol\'jin eyes you warily.>$b$bWhat next, $r?','',26124),
(77374,'enUS','Food!','Food!',26124),
(77375,'enUS','Honored brothers and sisters! Today we achieved what Durotan would not even dare to try.','',26124),
(77376,'enUS','Make no mistake. We are at war. And we need a Warchief!','',26124),
(77377,'enUS','Those of you bold enough to stand with me - come! We will show the world the might of the Frostwolves!','',26124),
(77378,'enUS','We... are... FROSTWOLVES!','',26124),
(77379,'enUS','Stay with us!','Stay with us!',26124),
(77381,'enUS','Don\'t let it get away!','Don\'t let it get away!',26124),
(77383,'enUS','You cannot defeat us all, weaklings.','',26124),
(77384,'enUS','Run $c, it\'s a trap!','Run $c, it\'s a trap!',26124),
(77385,'enUS','You be lookin\' lost, mon.','You be lookin\' lost, mon.',26124),
(77386,'enUS','Look for de orc Varzok up on de city\'s central mesa, just east of de Flight Master. Ya can\'t miss him mon.','Look for de orc Varzok up on de city\'s central mesa, just east of de Flight Master. Ya can\'t miss him mon.',26124),
(77387,'enUS','Three ethereal technomancers have set up shop in Orgrimmar, over in de Drag.\n\nLook for de weird machinery and purple lights... ya can\'t miss it.\n\nDey might be havin\' what cha lookin\' for.','Three ethereal technomancers have set up shop in Orgrimmar, over in de Drag.\n\nLook for de weird machinery and purple lights... ya can\'t miss it.\n\nDey might be havin\' what cha lookin\' for.',26124),
(77388,'enUS','It\'s in de Valley o\' Strength, east of Grommash Hold.','It\'s in de Valley o\' Strength, east of Grommash Hold.',26124),
(77389,'enUS','De goblins set up shop in de Valley of Honor, across the bridge.','De goblins set up shop in de Valley of Honor, across the bridge.',26124),
(77390,'enUS','De Valley of Strength\'s bank is south Grommash Hold, northwest of de main gate.','De Valley of Strength\'s bank is south Grommash Hold, northwest of de main gate.',26124),
(77391,'enUS','De Valley of Honor\'s bank is just before de gate to de Drag.','De Valley of Honor\'s bank is just before de gate to de Drag.',26124),
(77392,'enUS','De barber? Her shop be in de cliffs above the Valley of Strength.','De barber? Her shop be in de cliffs above the Valley of Strength.',26124),
(77393,'enUS','Battlemasters be at de Hall of the Brave in de Valley of Honor.','Battlemasters be at de Hall of the Brave in de Valley of Honor.',26124),
(77394,'enUS','What trainer you be lookin\' for?','What trainer you be lookin\' for?',26124),
(77395,'enUS','Sunwalker Atohmo be in de Valley of Wisdom.  He\'ll be able to help.','Sunwalker Atohmo be in de Valley of Wisdom.  He\'ll be able to help.',26124),
(77396,'enUS','Ji be near de Pandaren Pavilion in de Valley of Honor.','Ji be near de Pandaren Pavilion in de Valley of Honor.',26124),
(77397,'enUS','Doras be at de top of de Sky Tower in de Valley of Strength.','Doras be at de top of de Sky Tower in de Valley of Strength.',26124),
(77398,'enUS','','This is the Arbitum.',26124),
(77399,'enUS','','The Prophet foresaw a time in our future when our people would come into grave danger.',26124),
(77400,'enUS','','This shrine holds the power to save us from destruction.',26124),
(77401,'enUS','','I pray that the day of judgment shall never come. Power like this can only come at great cost.',26124),
(77402,'enUS','','Activation of The Arbitum requires an incredible amount of energy - energy of a kind that can\'t be found on this world.',26124),
(77403,'enUS','','Luckily, Iris Crystals do not originate from Draenor. We think three should be enough to supply the energy we need.',26124),
(77404,'enUS','','Five Iris Crystals have fallen from the skies around Shadowmoon Valley.',26124),
(77405,'enUS','','Unfortunately, it looks like the Shadowmoon are collecting them as well. We cannot allow them to succeed.',26124),
(77406,'enUS','','This is the Prophet\'s vision of what will come to pass.',26124),
(77407,'enUS','','Do you know the workings of our magic, traveler?',26124),
(77408,'enUS','','See this hammer? In my hands, it strikes with magical force against enemies. But used by an inexperienced trainee, it is no more than a blunt rock.',26124),
(77409,'enUS','','The Arbitum is only as powerful as the one who uses it.',26124),
(77410,'enUS','','In the right hands, it restores hope for this world. In the wrong ones, it is a weapon of absolute destruction.',26124),
(77411,'enUS','You be lookin\' for Urtrun Clanbringer?  He be around de west side of de Valley of Strength.','You be lookin\' for Urtrun Clanbringer?  He be around de west side of de Valley of Strength.',26124),
(77412,'enUS','De Horde Embassy be in de Valley of Strength.','De Horde Embassy be in de Valley of Strength.',26124),
(77413,'enUS','Second building on de right in de Valley of Strength as you enter de city be de inn mon.  Gryshka be running da place.','Second building on de right in de Valley of Strength as you enter de city be de inn mon.  Gryshka be running da place.',26124),
(77414,'enUS','Look for Innkeeper Grishka in de Valley of Strength.  Her inn be on de east side, north of de city\'s gates.','Look for Innkeeper Grishka in de Valley of Strength.  Her inn be on de east side, north of de city\'s gates.',26124),
(77415,'enUS','De Wyvern\'s Tail, just outside the Hall of the Brave, be a great spot to rest!','De Wyvern\'s Tail, just outside the Hall of the Brave, be a great spot to rest!',26124),
(77416,'enUS','De Hall of Legends be high up on de west side of de Valley of Strength.','De Hall of Legends be high up on de west side of de Valley of Strength.',26124),
(77417,'enUS','De shaman of de Earthen Ring set up portals to all over de world up on the cliffs north of de zeppelin towers.\n\nIf ya be lookin\' to go to Tol Barad der be a portal there too.','De shaman of de Earthen Ring set up portals to all over de world up on the cliffs north of de zeppelin towers.\n\nIf ya be lookin\' to go to Tol Barad der be a portal there too.',26124),
(77418,'enUS','Let me mark de location on your map.','Let me mark de location on your map.',26124),
(77419,'enUS','You be lookin\' to hone de art of Alchemy?  Den you better be off to Yelmak\'s.  He be holed up in his shop, Alchemy and Potions in de middle of de Drag.','You be lookin\' to hone de art of Alchemy?  Den you better be off to Yelmak\'s.  He be holed up in his shop, Alchemy and Potions in de middle of de Drag.',26124),
(77420,'enUS','Yelmak be an expert at Alchemy.  His shop be in de middle of de Drag.','Yelmak be an expert at Alchemy.  His shop be in de middle of de Drag.',26124),
(77421,'enUS','Der be a blood elf in Grommash Hold, his name be Belloc, who be interested in old relics.  Talk to him if you be needin\' training.','Der be a blood elf in Grommash Hold, his name be Belloc, who be interested in old relics.  Talk to him if you be needin\' training.',26124),
(77422,'enUS','Saru Steelfury be at de Burning Anvil in de Valley of Honor.  He loves teachin\' de art of blacksmithing.','Saru Steelfury be at de Burning Anvil in de Valley of Honor.  He loves teachin\' de art of blacksmithing.',26124),
(77423,'enUS','In de Valley of Honor there be an orc who is a master craftsman, Saru Steelfury.  He be at de far end of de Valley of Honor down de path past Red Canyon Mining.','In de Valley of Honor there be an orc who is a master craftsman, Saru Steelfury.  He be at de far end of de Valley of Honor down de path past Red Canyon Mining.',26124),
(77424,'enUS','Ahh, the brothers Frostwolf. I knew we would reunite on the battlefield someday.','',26124),
(77425,'enUS','Or don\'t you recognize your eldest brother?','',26124),
(77426,'enUS','Look for a shop in de Drag, right next to de Valley of Wisdom.  Godan\'s Runeworks is the name of de place.','Look for a shop in de Drag, right next to de Valley of Wisdom.  Godan\'s Runeworks is the name of de place.',26124),
(77427,'enUS','Brothers! Oblige our Frostwolf guests!','',26124),
(77428,'enUS','Lumark is de best fisherman around.  You can find him loungin\' around the dock in the Valley of Honor.','Lumark is de best fisherman around.  You can find him loungin\' around the dock in the Valley of Honor.',26124),
(77429,'enUS','Find Red Canyon Mining northeast of the lake in de Valley of Honor.  Speak to Makaru there.','Find Red Canyon Mining northeast of the lake in de Valley of Honor.  Speak to Makaru there.',26124),
(77430,'enUS','Makaru can teach you what you need to know mon.  He be in de Valley of Honor at Red Canyon Mining right by de lake.','Makaru can teach you what you need to know mon.  He be in de Valley of Honor at Red Canyon Mining right by de lake.',26124),
(77431,'enUS','Look for Kodohide Leatherworkers in de Drag, talk to Thuwd.  He can show you all you need to know.','Look for Kodohide Leatherworkers in de Drag, talk to Thuwd.  He can show you all you need to know.',26124),
(77432,'enUS','South of de huge tree, next to Kodohide Leatherworks in de Drag, is Magar\'s Cloth Goods.  I can show you on your map, mon.','South of de huge tree, next to Kodohide Leatherworks in de Drag, is Magar\'s Cloth Goods.  I can show you on your map, mon.',26124),
(77433,'enUS','Now, Lokra! You and $p get to Fenris!','',26124),
(77434,'enUS','','Karg and the others should be crashing the front entrance any minute now.',26124),
(77435,'enUS','','They\'ll hold off the bulk of the Thunderlord fighters while you and I go for Fenris.',26124),
(77436,'enUS','','FOR THE CLAN!',26124),
(77437,'enUS','You\'ll find Lumak out on his dock on the lake in the Valley of Honor.','You\'ll find Lumak out on his dock on the lake in the Valley of Honor.',26124),
(77438,'enUS','Seek out Seer Liwatha in the Valley of Wisdom.  Her healing powers are unmatched.','Seek out Seer Liwatha in the Valley of Wisdom.  Her healing powers are unmatched.',26124),
(77439,'enUS','Sunwalker Atohmo has touched the Light, seek him out for further training.','Sunwalker Atohmo has touched the Light, seek him out for further training.',26124),
(77440,'enUS','There is no one braver than Nahu.  He has protected our people for many years.  Seek him out in the Valley of Wisdom.','There is no one braver than Nahu.  He has protected our people for many years.  Seek him out in the Valley of Wisdom.',26124),
(77441,'enUS','Looking to learn a thing or two about your trade hunter?  Seek out Nohi in the Valley of Wisdom.','Looking to learn a thing or two about your trade hunter?  Seek out Nohi in the Valley of Wisdom.',26124),
(77442,'enUS','Within the Valley of Wisdom Shai Cloudsinger communes with the elements.  Speak with her.','Within the Valley of Wisdom Shai Cloudsinger communes with the elements.  Speak with her.',26124),
(77443,'enUS','Earth Mother watch over Shalla.  She can be found in the Valley of Wisdom near the other trainers.  Let me mark your map with her location.','Earth Mother watch over Shalla.  She can be found in the Valley of Wisdom near the other trainers.  Let me mark your map with her location.',26124),
(77444,'enUS','The pandaren have set up an encampment in the Valley of Honor.  Seek out Ji Firepaw to hone your skills further.','The pandaren have set up an encampment in the Valley of Honor.  Seek out Ji Firepaw to hone your skills further.',26124),
(77445,'enUS','Ormok is a slipery type who can be found within the Cleft of Shadows.  He can teach you how to survive on the streets of Orgrimmar.','Ormok is a slipery type who can be found within the Cleft of Shadows.  He can teach you how to survive on the streets of Orgrimmar.',26124),
(77446,'enUS','Within the Cleft of Shadow there is a conclave of warlocks.  Let me show you on your map.','Within the Cleft of Shadow there is a conclave of warlocks.  Let me show you on your map.',26124),
(77447,'enUS','Many arcane secrets can be learned within the Cleft of Shadow.  Seek out Marud, he can teach you.','Many arcane secrets can be learned within the Cleft of Shadow.  Seek out Marud, he can teach you.',26124),
(77455,'enUS','','The podlings seemed so innocent. I\'m still in shock... my husband. They killed my husband...',26124),
(77456,'enUS','','They lied to us about many things. Fortunately the crystal was not one of them.',26124),
(77457,'enUS','','Now that the crystal is activated I\'ll contact Velen.',26124),
(77458,'enUS','','Let\'s hope finding this crystal was worth the blood spilled in this forest.',26124),
(77459,'enUS','','I can\'t believe it was right here the whole time.',26124),
(77460,'enUS','Ga\'nar and the others went up to the second level.','',26124),
(77461,'enUS','Go outside and follow the ramp to the south. Korga should be up there. She\'ll know where Ga\'nar is.','',26124),
(77462,'enUS','We can handle this area. Go!','',26124),
(77464,'enUS','Welcome friend!','Welcome friend!',26124),
(77467,'enUS','I\'m so glad you are here!','I\'m so glad you are here!',26124),
(77468,'enUS','Peace and happiness friend!','Peace and happiness friend!',26124),
(77470,'enUS','Here they come. Ready yourselves!','',26124),
(77471,'enUS','Fool, I tricked you from the start. The time is now, I\'ll swallow your heart!','Fool, I tricked you from the start. The time is now, I\'ll swallow your heart!',26124),
(77472,'enUS','Enjoy your time in the forest!','Enjoy your time in the forest!',26124),
(77473,'enUS','','You\'ll need to destroy that barricade to get through!',26124),
(77474,'enUS','','Thank the light... I feared the worst.',26124),
(77475,'enUS','','Thank you again, $c. I can handle the rest from here.',26124),
(77476,'enUS','','Hold them at bay, $p! I need to catch my breath.',26124),
(77477,'enUS','','Lok\'tar!',26124),
(77478,'enUS','Spirits of the water, I seek your guidance. Spirits of the earth, I seek your strength.','',26124),
(77479,'enUS','I... I hear the voice of a Fury!','',26124),
(77480,'enUS','You be lookin\' for Sesebi, mon.$B$BShe most often be sleepin\' under de tree by old Umbehto, de fisherman, lookin\' like a big ol\' tiger in de Valley of Spirits.','You be lookin\' for Sesebi, mon.$B$BShe most often be sleepin\' under de tree by old Umbehto, de fisherman, lookin\' like a big ol\' tiger in de Valley of Spirits.',26124),
(77481,'enUS','Kuzari be trainin\' headhunters on one of de small islets towards de southeast end of de Valley of Spirits, mon.','Kuzari be trainin\' headhunters on one of de small islets towards de southeast end of de Valley of Spirits, mon.',26124),
(77482,'enUS','Zanga be trainin\' headhunters on one of de small islets towards de southeast end of de Valley of Spirits, mon.','Zanga be trainin\' headhunters on one of de small islets towards de southeast end of de Valley of Spirits, mon.',26124),
(77484,'enUS','Dey be on top of de tall building in de southeast end of de Valley of Spirits.','Dey be on top of de tall building in de southeast end of de Valley of Spirits.',26124),
(77485,'enUS','Shadow-Walker Zuru can help ya.$B$BYou\'ll find him on de lowest floor of de taller building in de southeast of de Valley of Spirits.','Shadow-Walker Zuru can help ya.$B$BYou\'ll find him on de lowest floor of de taller building in de southeast of de Valley of Spirits.',26124),
(77486,'enUS','Ku\'nanji, de Night-Stalker, is who yer lookin\' for.$B$BHe be just north of de Valley of Spirits\' central building.','Ku\'nanji, de Night-Stalker, is who yer lookin\' for.$B$BHe be just north of de Valley of Spirits\' central building.',26124),
(77487,'enUS','Witch Doctor Umbu spends his time walkin\' about de Valley of Spirits, tendin\' to de people and elemental spirits alike.$B$BLook for him around de central building.','Witch Doctor Umbu spends his time walkin\' about de Valley of Spirits, tendin\' to de people and elemental spirits alike.$B$BLook for him around de central building.',26124),
(77488,'enUS','You be crazy, mon, meddlin\' with dat bad mojo. But I ain\'t one ta stop ya.$B$BUnjari Feltongue is in de taller building in de southeast of de Valley of Spirits, past de shadow priest\'s shrine.','You be crazy, mon, meddlin\' with dat bad mojo. But I ain\'t one ta stop ya.$B$BUnjari Feltongue is in de taller building in de southeast of de Valley of Spirits, past de shadow priest\'s shrine.',26124),
(77489,'enUS','Fly with me, hero. We will assist them from above!','',26124),
(77490,'enUS','The purifying light of the naaru is both our hammer AND shield.','',26124),
(77491,'enUS','They are at the very temple gates - fly closer! Hurry!','',26124),
(77492,'enUS','Circle back. We must clear the steps.','',26124),
(77493,'enUS','Exarch Akama! Watch your flanks!','',26124),
(77494,'enUS','Thank you, old friend!','',26124),
(77495,'enUS','Never again will you orcish hordes darken the light of Karabor!','',26124),
(77496,'enUS','Press onward. By the light of the Naaru!','',26124),
(77497,'enUS','Use the sightstone to mark the catapults. The Timewalkers can take out those catapults, but they cannot do so safely without eyes on the ground.','',26124),
(77498,'enUS','','Watch out! Goren!',26124),
(77499,'enUS','It must not disturb the master.','',26124),
(77500,'enUS','The master demands silence!','',26124),
(77501,'enUS','The meat must be silenced!','',26124),
(77502,'enUS','Spirits of fire, I seek ferocity- aaaaaah!','',26124),
(77503,'enUS','Hold, $p! This is not our enemy.','',26124),
(77504,'enUS','','Drek\'Thar! $p, cover me.',26124),
(77505,'enUS','','Hear it faster! We are getting swarmed down here.',26124),
(77506,'enUS','','Drek\'Thar! $p, cover me. <WRONG RECORD>',26124),
(77507,'enUS','Rwaghh!','',26124),
(77508,'enUS','Smash!','',26124),
(77509,'enUS','Fresh meat!','',26124),
(77510,'enUS','You die!','',26124),
(77511,'enUS','Go away!','',26124),
(77512,'enUS','Wolves make tasty snack!','',26124),
(77513,'enUS','Wor\'gol!','Wor\'gol!',26124),
(77521,'enUS','Lok\'tar ogar! Victory or death!','Lok\'tar ogar! Victory or death!',26124),
(77522,'enUS','We know you\'re in there! Don\'t make us burn the hut down!','There is no use hiding! Come out and face your death!',26124),
(77523,'enUS','','Show Dorogg no mercy. Lok\'tar ogar.',26124),
(77524,'enUS','','You hear that, Asha? Karg is coming. That means you get to play with Nerok!',26124),
(77525,'enUS','More Thunderlord scum attacking from the east! We\'re holding at Karg\'s hut!','More Thunderlord scum attacking from the east! We\'re holding at Karg\'s hut!',26124),
(77528,'enUS','I will kill the Thunderlord!','I will kill the Thunderlord!',26124),
(77529,'enUS','This is my home!','This is my home!',26124),
(77530,'enUS','Thunderlord dogs!','Thunderlord dogs!',26124),
(77531,'enUS','Lok\'tar ogar!','Lok\'tar ogar!',26124),
(77532,'enUS','Come, $pc. Let\'s kill these Thunderlord weaklings!','Come, $pc. Let\'s kill these Thunderlord weaklings!',26124),
(77533,'enUS','','Well fought! Come here, it is time to take the fight into the heart of the fortress.',26124),
(77534,'enUS','','I\'ll meet you with Ga\'nar and the others at the ramp.',26124),
(77535,'enUS','|TInterface\\Icons\\spell_holy_heroism.blp:32|t\nK\'ara has blessed you. You will gain the |cff71d5ff|Hspell:147414|h[Naaru\'s Glory]|h|r ability when out of combat.','|TInterface\\Icons\\spell_holy_heroism.blp:32|t\nK\'ara has blessed you. You will gain the |cff71d5ff|Hspell:147414|h[Naaru\'s Glory]|h|r ability when out of combat.',26124),
(77536,'enUS','|TInterface\\Icons\\inv_boots_cloth_31v3.blp:32|t\nK\'ara has blessed you. Haste and run speed increased.','|TInterface\\Icons\\inv_boots_cloth_31v3.blp:32|t\nK\'ara has blessed you. Haste and run speed increased.',26124),
(77537,'enUS','|TInterface\\Icons\\spell_holy_aspiration.blp:32|t\nK\'ara has blessed you. Damage taken reduced and health restored.','|TInterface\\Icons\\spell_holy_aspiration.blp:32|t\nK\'ara has blessed you. Damage taken reduced and health restored.',26124),
(77538,'enUS','|TInterface\\Icons\\spell_fire_ragnaros_supernova.blp:32|t\nK\'ara has blessed you. Successful attacks will now build up holy energy that periodically explodes, damaging nearby enemies.','|TInterface\\Icons\\spell_fire_ragnaros_supernova.blp:32|t\nK\'ara has blessed you. Successful attacks will now build up holy energy that periodically explodes, damaging nearby enemies.',26124),
(77539,'enUS','|TInterface\\Icons\\spell_holy_aspiration.blp:32|t\nK\'ara has blessed you. Damage reduction and health restoration increased.','|TInterface\\Icons\\spell_holy_aspiration.blp:32|t\nK\'ara has blessed you. Damage reduction and health restoration increased..',26124),
(77540,'enUS','|TInterface\\Icons\\spell_fire_ragnaros_supernova.blp:32|t\nK\'ara has blessed you. Successful attacks will now build up more holy energy, dealing more damage to nearby enemies.','|TInterface\\Icons\\spell_fire_ragnaros_supernova.blp:32|t\nK\'ara has blessed you. Successful attacks will now build up more holy energy, dealing more damage to nearby enemies.',26124),
(77541,'enUS','$n, we are over here. Come quickly!','',26124),
(77542,'enUS','The Bladespire are weak. Their legions have fallen to our blades.','',26124),
(77543,'enUS','We have Gorr\'thog cornered. It is time to strike him down.','',26124),
(77544,'enUS','Ghostfur will take you to Gorr\'thog\'s chamber. He has taken a liking to you.','',26124),
(77545,'enUS','Ghostfur looks at you expectantly.','',26124),
(77546,'enUS','','That\'s enough, child. Try not to speak.',26124),
(77547,'enUS','','I\'m sorry... I\'m just a little overwhelmed. Quickly $c, this way.',26124),
(77548,'enUS','','Let your wolf guide you Drek\'Thar, and stay close to me if you can. $p, look for us in the Ice Forges when you are finished. Lok\'tar ogar!',26124),
(77549,'enUS','Ligra, Korga, hold this point. We\'ll deal with this filth.','',26124),
(77550,'enUS','$p is here, brother. Korga watched $Ghim:her; defeat Dorogg when our warriors could not. We wait no longer.','',26124),
(77551,'enUS','Coming, brother?','',26124),
(77552,'enUS','Very well. Let\'s finish this.','',26124),
(77553,'enUS','You\'re going to get yourself killed! As your chieftain, I say that we wait.','',26124),
(77555,'enUS','The deeds of the Iron Horde are contemptible. Their intentions are impure, and their leader is corrupt.','',26124),
(77556,'enUS','Bloodshed is the only answer here. Go with my blessing, champion.','',26124),
(77557,'enUS','You look lost, outsider! What is your business here?','You look lost, outsider! What is your business here?',26124),
(77558,'enUS','Find them you imbeciles! Lord Bathiel will not be denied his sacrifices!','',26124),
(77559,'enUS','You have done well, champion. Shadowmoon rests now... and so should you.','',26124),
(77560,'enUS','The road is secure, adventurer! And I see you have successfully cast our invaders back to the sea. Truly, you are a champion of the light.','',26124),
(77561,'enUS','','Hey mon, help us! Da Twilight\'s Hammer be fixin to sacrifice our green hides.',26124),
(77562,'enUS','','I have the chains and grapples you got from the Thunderlord. If you attack a forger I will use these to expose its weaknesses.',26124),
(77563,'enUS','','Quick $p! Hit it hard while I have it tied down!',26124),
(77564,'enUS','','I have it chained! Quick! Hit it hard!',26124),
(77565,'enUS','','Now! Bring it down!',26124),
(77566,'enUS','I remember you from the battle at Bladespire. You must have killed twenty ogres! Take whatever you need.','I remember you from the battle at Bladespire. You must have killed twenty ogres! Take whatever you need.',26124),
(77567,'enUS','','That should be enough motes. This totem can barely hold any more.',26124),
(77568,'enUS','','I got the primal! On to the next forger.',26124),
(77569,'enUS','','Rulkan was Ner\'zhul\'s most trusted advisor for many years. Ner\'zhul\'s strength and ambition guided our lives, but Rulkan\'s wisdom and vision inspired our spirits.',26124),
(77570,'enUS','','Ner\'zhul\'s methods are brutal and direct. He cuts his enemies down by force.$B$BRulkan is clever and wise. She will turn an enemy\'s own blade against them.',26124),
(77571,'enUS','','The Shadowmoon Clan is no longer. Even if physical remnants remain, its spirit is corrupted.',26124),
(77572,'enUS','','We are here in self-exile. We refused to tap the magic of Ner\'zhul\'s Dark Star.',26124),
(77573,'enUS','','It is unclear what will happen to us from here, but one thing is certain. My loyalty to Chieftess Rulkan is absolute.',26124),
(77574,'enUS','We\'ve broken through! Kill them all!','We\'ve broken through! Kill them all!',26124),
(77575,'enUS','It\'s frightening how quickly the orcs have adapted to their new technology, even if it is crude.','',26124),
(77576,'enUS','We under attack!','',26124),
(77577,'enUS','Me crush you!','',26124),
(77578,'enUS','Nobody tougher than me! Rwargh!','',26124),
(77579,'enUS','You make tasty snack!','',26124),
(77580,'enUS','This only hurt for a second.','',26124),
(77581,'enUS','You no supposed to be here! Smash!','',26124),
(77582,'enUS','I\'m fine sh...shaman. I need to fight.','I\'m fine sh...shaman. I need to fight.',26124),
(77583,'enUS','I refuse to die this way. Laying here...like a coward.','I refuse to die this way. Laying here...like a coward.',26124),
(77584,'enUS','Their catapults destroyed our forces...','Their catapults destroyed our forces...',26124),
(77585,'enUS','Gorr\'thog will pay for this...','Gorr\'thog will pay for this...',26124),
(77586,'enUS','Draka, help me up. We shou- hrraarh!','',26124),
(77587,'enUS','Do not forget, child, one of us is blind and unable to call upon the spirits like he used to.','',26124),
(77588,'enUS','','Bah! That should just come close to making it a fair fight. On your feet, old man.',26124),
(77589,'enUS','What hope is there against a foe that can consume the very elements?','',26124),
(77590,'enUS','','You taught me long ago that the elements have always been there for us. Now it is our turn to be there for them. Victory or death, we owe it to them to try.',26124),
(77592,'enUS','','Oh, he will. Trust me.',26124),
(77593,'enUS','%s rumbles in assent.','',26124),
(77594,'enUS','','I felt invincible once; I was wrong. We return to the pack. The Iron Wolf will answer to the full might of the Frostwolf clan.',26124),
(77595,'enUS','$C! You have freed my children and made me whole. Accept my boon and bring the full fury of Frostfire to your enemies.','',26124),
(77596,'enUS','Shaman, you alone were strong enough to hear my call. You were wise enough to know what needed to be done. Give me your totem.','',26124),
(77602,'enUS','Feel the flames of the fury!','',26124),
(77603,'enUS','Frost Wolf nuzzles its master\'s side, whining softly.','',26124),
(77604,'enUS','Exurotus was always believed to be a legend. A story told from shaman to shaman as a symbol of a true elemental spirit.$b$bTo see something so revered in shackles is an affront to orcs, to shamanism, and to me.','',26124),
(77605,'enUS','Begin your ritual.','Begin your ritual.',26124),
(77606,'enUS','It is good to see you again, $n. There isn\'t a moment to spare.','',26124),
(77607,'enUS','Climb on Brazen\'s back when you are ready to leave. I will explain everything on the way.','',26124),
(77608,'enUS','Let\'s ride.','',26124),
(77609,'enUS','The stench of tortured stone fills the air, Draka. What do you see?','',26124),
(77610,'enUS','I can feel hundreds of goren burrowing through the earth. This will not be easy.','',26124),
(77611,'enUS','So this is the pact of iron we have heard about. In truth, many clans working together to crush anyone who does not share their vision.$B$BDurotan was wise to refuse this so-called Iron Horde. I can only hope we are strong enough to withstand it.','',26124),
(77612,'enUS','','Goren... lots of goren. We will distract them in order to sneak you into the Ice Forge.',26124),
(77613,'enUS','What you suggest should be good enough to bring down a forger, but only for a few seconds at a time.','',26124),
(77614,'enUS','It was horrible. The podlings ate Ryan right in front of me...','',26124),
(77615,'enUS','Shelly and the others were captured by the podling king... we must find them. I... I will not let them die.','',26124),
(77616,'enUS','We must kill their king... they headed off to the west... save them. Save my wife!','',26124),
(77617,'enUS','This is Frostfire Ridge. The Frostwolf Clan journeys here each year so their newly aged warriors may bond with their own wolf.','',26124),
(77618,'enUS','The Horde is in a fragile state. We cannot afford to raise an army of our own.','',26124),
(77620,'enUS','I have already met with their chieftain to discuss an alliance. Durotan has been... resistant.','',26124),
(77621,'enUS','The Bladespire ogres have been attacking more frequently. He wants to launch an assault on their fortress soon.','',26124),
(77622,'enUS','Ogres! Brazen, freeze them!','',26124),
(77623,'enUS','We\'re nearing the fortress now.','',26124),
(77624,'enUS','Durotan\'s forces have already begun attacking! Hold on, we\'re going in.','',26124),
(77625,'enUS','We don\'t have much time. We have to help the Frostwolves.','',26124),
(77626,'enUS','Our entire existence depends on it.','',26124),
(77627,'enUS','I only hope that we are enough.','',26124),
(77628,'enUS','Durotan and Ga\'nar are just ahead. Let\'s go.','',26124),
(77630,'enUS','These animals have done nothing but leave chaos and death in their wake. Let\'s send them an unmistakable message.','',26124),
(77631,'enUS','You brutes! Attack!','',26124),
(77632,'enUS','Hurry it up! Tiny is getting anxious. Aren\'t you girl? Who\'s a good girl?','Hurry it up! Tiny is getting anxious. Aren\'t you girl? Who\'s a good girl?',26124),
(77633,'enUS','Just waiting on sticky fingers over there.','Just waiting on sticky fingers over there.',26124),
(77634,'enUS','Hold your talbuks, will you? There\'s loot in here.','Hold your talbuks, will you? There\'s loot in here.',26124),
(77635,'enUS','There will be plenty of time to loot the place after we come back with those cannons. Let\'s go!','There will be plenty of time to loot the place after we come back with those cannons. Let\'s go!',26124),
(77636,'enUS','Gorr\'thog! I, Ga\'nar, son of Garad, come for your head!','',26124),
(77637,'enUS','Come. I\'ll paint the walls with your blood, orc.','',26124),
(77638,'enUS','\"Fall back to the outpost!\" they said.$B$B\"The Thunderlords will overwhelm you!\" they said.$B$B<The old orc spits.>$B$BPah! This is my hut, and I\'m not moving. I\'ll stand my ground and die with honor!$B$BHow about you, pup? Will you run, too? Or stand and fight?!','\"Fall back to the outpost!\" they said.$B$B\"The Thunderlords will overwhelm you!\" they said.$B$B<The old orc spits.>$B$BPah! This is my hut, and I\'m not moving. I\'ll stand my ground and die with honor!$B$BHow about you, pup? Will you run, too? Or stand and fight?!',26124),
(77639,'enUS','Stand and fight! Victory or death!','Stand and fight! Victory or death!',26124),
(77640,'enUS','Nothing wrong with a little tactical retreat...','Nothing wrong with a little tactical retreat...',26124),
(77641,'enUS','You would have us sit idle while Gorr\'thog still breathes? I refuse!','',26124),
(77642,'enUS','<The old orc spits again. You\'re pretty sure a tooth came out this time.>$B$BPAH!!$B$BCome back when you grow a spine!','<The old orc spits again. You\'re pretty sure a tooth came out this time.>$B$BPAH!!$B$BCome back when you grow a spine!',26124),
(77643,'enUS','Spoken like a true orc! And here comes your chance to prove it. Thunderlords incoming!','Spoken like a true orc! And here comes your chance to prove it. Thunderlords incoming!',26124),
(77644,'enUS','Come, fools! Break yourselves upon us!!','Come, fools! Break yourselves upon us!!',26124),
(77645,'enUS','Ah, the thrill of battle! I feel young again!','Ah, the thrill of battle! I feel young again!',26124),
(77646,'enUS','Go on inside my hut - you\'ll find an old chest in the corner. I want you to have what\'s inside.','Go on inside my hut - you\'ll find an old chest in the corner. I want you to have what\'s inside.',26124),
(77647,'enUS','Go away! I will fix this!','',26124),
(77648,'enUS','Uh... stone!','',26124),
(77649,'enUS','FIRE!','',26124),
(77650,'enUS','Smash!','',26124),
(77651,'enUS','Pound to dust...','',26124),
(77652,'enUS','Next time, I get ta pick first, ya pasty blue blowhard!','',26124),
(77653,'enUS','You are but a pebble amongst boulders...','',26124),
(77655,'enUS','I am a rockslide!','',26124),
(77656,'enUS','Freedom!','',26124),
(77657,'enUS','Ha, rocks are dumb!','',26124),
(77658,'enUS','Hah hah! So weak.','',26124),
(77659,'enUS','I will defend this home to my last breath.$B$BI only hope death finds me in battle, and not in bed.','I will defend this home to my last breath.$B$BI only hope death finds me in battle, and not in bed.',26124),
(77660,'enUS','What are you waiting for? Go on inside and take your reward.$B$BDon\'t you have enough manners to accept a gift?','What are you waiting for? Go on inside and take your reward.$B$BDon\'t you have enough manners to accept a gift?',26124),
(77661,'enUS','Ghostfur will take you to Durotan and Ga\'nar.','',26124),
(77662,'enUS','Yes... the brute weakens...','',26124),
(77663,'enUS','Kill him! I will be free!','',26124),
(77664,'enUS','Lokra, wait! Gah... so impulsive, that one.','Lokra, wait! Gah... so impulsive, that one.',26124),
(77665,'enUS','I fight with my father\'s spirit watching over me. No ogre or orc can stand in my way.','',26124),
(77666,'enUS','I am ready to fight when you are.','I am ready to fight when you are.',26124),
(77667,'enUS','<The clefthoof chews what little grass he can find. Pickings are slim in Gorgrond.>','',26124),
(77668,'enUS','Another one! How many of these did they set loose in here?!','Another one! How many of these did they set loose in here?!',26124),
(77669,'enUS','Careful! Keep it away from the huts!','Careful! Keep it away from the huts!',26124),
(77670,'enUS','Wasted material.','',26124),
(77671,'enUS','I will expunge your existence.','',26124),
(77672,'enUS','Take the caravan to [LAUGHING SKULL RUINS].','Take the caravan to [LAUGHING SKULL RUINS].',26124),
(77673,'enUS','Take the caravan to [TANK TEST FACILITY].','Take the caravan to [TANK TEST FACILITY].',26124),
(77674,'enUS','Take the caravan to [OGRE SLAVE CAMP].','Take the caravan to [OGRE SLAVE CAMP].',26124),
(77675,'enUS','Take the caravan to [PIPEWORKS CAMP].','Take the caravan to [PIPEWORKS CAMP].',26124),
(77676,'enUS','Take the caravan to [STEAM CAPPING CAMP].','Take the caravan to [STEAM CAPPING CAMP].',26124),
(77677,'enUS','Take the caravan to [SHIPYARD CAMP].','Take the caravan to [SHIPYARD CAMP].',26124),
(77678,'enUS','You found a weapon a friend might wield.','',26124),
(77679,'enUS','You find more clues, at the beach.','',26124),
(77680,'enUS','<This weapon looks like it could have belonged to someone from the missing search party.>','',26124),
(77681,'enUS','Spirits of the wind! Heed my call! We have need of your wisdom.','',26124),
(77682,'enUS','These stones appear to retain the force and heat being hammered into them.','These stones appear to retain the force and heat being hammered into them.',26124),
(77683,'enUS','These thick plates are being tempered to withstand extreme heat.','These thick plates are being tempered to withstand extreme heat.',26124),
(77684,'enUS','','Tread lightly, stranger. There is fight in me yet.',26124),
(77685,'enUS','Is that... Gorr\'thog? Out here?','',26124),
(77686,'enUS','You are weak, tiny, frail creatures. I will enjoy watching you die.','',26124),
(77687,'enUS','Ga\'nar, you will spearhead the attack and take out their catapults.','',26124),
(77688,'enUS','The rest of us will follow in and we can secure...','',26124),
(77689,'enUS','Come, brother. We can\'t let him escape!','',26124),
(77690,'enUS','No, Ga\'nar. It\'s too dangerous. We need to follow the plan.','',26124),
(77691,'enUS','No. We end this now.','',26124),
(77692,'enUS','Lorgosh! Korga! We ride!','',26124),
(77693,'enUS','Lok\'tar ogar!','',26124),
(77694,'enUS','Lord of the Void, hear us. Let our blood herald your arrival into this world!','',26124),
(77695,'enUS','The void... HUNGERS!','',26124),
(77696,'enUS','','What is that monstrosity?',26124),
(77698,'enUS','Your blood only makes me stronger.','',26124),
(77699,'enUS','You cannot defeat the void!','',26124),
(77700,'enUS','Lok\'tar ogar!','',26124),
(77701,'enUS','','Lok\'tar ogar!',26124),
(77702,'enUS','Lok\'tar ogar!','Lok\'tar ogar!',26124),
(77703,'enUS','Ease off, Hansel. I assure you there\'s plenty of opportunity to kill more Iron Horde.','',26124),
(77704,'enUS','A Stonemaul ogre camp. They\'re slavers.','',26124),
(77705,'enUS','This is not a place Frostwolves tread. Be mindful of what shadows you step in.','',26124),
(77706,'enUS','Ahoy there! I\'ve got just the drink you need to get ye to yer destination.','',26124),
(77707,'enUS','I\'m ready to go, Adm\'rl.','I\'m ready to go, Adm\'rl.',26124),
(77713,'enUS','Seared by flames...','',26124),
(77714,'enUS','Burn unto nothingness!','',26124),
(77715,'enUS','My thanks, stranger.','My thanks, stranger.',26124),
(77716,'enUS','I am in your debt, whoever you are...','I am in your debt, whoever you are...',26124),
(77717,'enUS','Ahhh, I feel... better.','Ahhh, I feel... better.',26124),
(77718,'enUS','Freedom, at last.','Freedom, at last.',26124),
(77719,'enUS','These ogres shall pay dearly!','These ogres shall pay dearly!',26124),
(77720,'enUS','Durotan shall hear of your deeds, stranger.','Durotan shall hear of your deeds, stranger.',26124),
(77721,'enUS','My death feeds the Old Gods...','My death feeds the Old Gods...',26124),
(77722,'enUS','All things must end.','All things must end.',26124),
(77723,'enUS','You will be consumed as well.','You will be consumed as well.',26124),
(77724,'enUS','They come. Defend the road!','',26124),
(77725,'enUS','','We Frostwolves are wiser than we seem, outsider.$b$bAnd I am watching you...',26124),
(77726,'enUS','There are three sets of ogre tracks running off to the east after our mysterious female.','',26124),
(77727,'enUS','Careful around those tailthrashers. They hit hard.','',26124),
(77728,'enUS','','My wolf shall feast tonight, if she still lives.',26124),
(77729,'enUS','Gorr\'thog was a fool. No ogre can stand against a Frostwolf.','',26124),
(77730,'enUS','You fought well as always, brother. Now we need to secure our borders and clean out any remaining Bladespire. The Thunderlords could attack at any moment.','',26124),
(77731,'enUS','Look around you, Durotan. The Bladespire are dead. We should strike down the Thunderlords now while our warriors\' spirits are high.','',26124),
(77732,'enUS','Our riders and their wolves need to rest. It would be foolish to march again so soon. I will not sacrifice our safety for vengeance against the Thunderlords.','',26124),
(77733,'enUS','You are the fool, brother. We should kill Fenris wherever he\'s hiding. Instead, he attacks our villages and we sit idle.','',26124),
(77734,'enUS','If you will not avenge our father, I will.','',26124),
(77735,'enUS','Those of you who would ride with me, I will waste no time in a fortress made by ogres.','',26124),
(77736,'enUS','Victory or death!','',26124),
(77737,'enUS','Lok\'tar ogar!','Lok\'tar ogar!',26124),
(77738,'enUS','I\'ll come back when Fenris is dead.','',26124),
(77739,'enUS','Ner\'zhul must not be interrupted!','Ner\'zhul must not be interrupted!',26124),
(77740,'enUS','','Thank you, stranger! The Shadowmoon attacked the Observatory without warning.',26124),
(77741,'enUS','','Hurry - the Shadowmoon Chieftain has taken the Observatory!',26124),
(77742,'enUS','The researchers here at Arkaat Outpost have been gathering pieces of our ancestors\' original wreckage.','',26124),
(77743,'enUS','My scouts are swift and strong. They will give us ample warning at the first sign of enemy movement.','',26124),
(77744,'enUS','The scouts of Karabor move like the wind. When we strike, we are swift and true.','',26124),
(77745,'enUS','<The young draenei is intently focused on the battlefield.>','',26124),
(77746,'enUS','Velen summons us NOW? What task might be more important than protecting Karabor against this tide of orcs?','',26124),
(77747,'enUS','He has a plan to break the siege, but he needs the might of your vindicators.','He has a plan to break the siege, but he needs the might of your vindicators.',26124),
(77748,'enUS','<The draenei corpse appears to have been dispatched with an axe blow to the back of the head. The poor soul probably never saw it coming.>','',26124),
(77749,'enUS','He\'s a PROPHET. He probably has a good idea what\'s coming.','He\'s a PROPHET. He probably has a good idea what\'s coming.',26124),
(77750,'enUS','','I am sworn by duty. If we are needed, we will be there. Come, Vindicators!',26124),
(77751,'enUS','','Hmmm... yes, you make a compelling point. Come, vindicators!',26124),
(77752,'enUS','WHAT?!','',26124),
(77753,'enUS','','They\'ve scaled the cliffs! Find the Vindicators - anyone - help!',26124),
(77754,'enUS','Come, child. Find safe refuge in my totem.','',26124),
(77755,'enUS','Please, keep your voice down. I don\'t want to give away our position.','',26124),
(77756,'enUS','This is highly unusual. We are in perfect position! Why leave now?','',26124),
(77757,'enUS','So many? Very well. When the Prophet calls, the rangari answer. Follow me, men! Velen requests our aid!','',26124),
(77758,'enUS','I place my trust in Velen\'s wisdom. He is, after all, the Prophet of my people. Follow me, men!','',26124),
(77759,'enUS','I don\'t know the details of the plan, but he\'s asking for the rangari, the anchorites, the vindicators, AND the artificers.','I don\'t know the details of the plan, but he\'s asking for the rangari, the anchorites, the vindicators, AND the artificers.',26124),
(77760,'enUS','Velen\'s orders.','Velen\'s orders.',26124),
(77761,'enUS','I need to get this crystal repaired as soon as possible, but the nearby wolves are not making it easy.$B$BCan you defend me while I work on the repairs?','',26124),
(77762,'enUS','You - you are the hero from Tanaan, yes? I need your aid.$b$bIn the absence of Karabor\'s normal defensive shields, we\'ve been installing Aeluun defense crystals. That crystal down at the bottom of the stairs is malfunctioning, and I can\'t leave this post until it\'s repaired. Could you place this resonator on the crystal?','',26124),
(77763,'enUS','Excellent news. The malfunctioning crystal is just to the north, along the temple grounds\' outer wall.','',26124),
(77764,'enUS','It is done? Good. Once this battle is over, we will have to begin repairing Karabor\'s proper shield defenses.','',26124),
(77765,'enUS','Yes, Rommul. I will repair your crystal for you.','Yes, Rommul. I will repair your crystal for you.',26124),
(77766,'enUS','Visitor. What is it you wish?','',26124),
(77767,'enUS','The Prophet calls, and of course, I follow. But first, I have a request.$b$bMy anchorites are well-trained in the healing arts, but are less skilled in battle. I have many wounded defenders down beyond enemy lines, without any battle-hardened adventurers to rescue them...','',26124),
(77768,'enUS','I would be grateful, visitor. You may use this sigil to heal the wounded soldiers, if you need it.','',26124),
(77769,'enUS','You are a friend of the anchorites, visitor. I will see you back at the rallying point.','',26124),
(77770,'enUS','I will help you heal the wounded defenders.','I will help you heal the wounded defenders.',26124),
(77771,'enUS','Velen has requested your help.','Velen has requested your help.',26124),
(77772,'enUS','','',26124),
(77773,'enUS','','',26124),
(77774,'enUS','','',26124),
(77775,'enUS','','',26124),
(77776,'enUS','','',26124),
(77777,'enUS','','',26124),
(77778,'enUS','With Ga\'nar and his followers gone, we cannot hope to hold this fortress.','',26124),
(77779,'enUS','Ha! Your ranger friend can\'t shoot  me here. Let\'s see how you do without him.','',26124),
(77780,'enUS','We should form an alliance, Durotan. The Horde can help your clan.','',26124),
(77781,'enUS','You are right, Thrall. We will join your Horde. You have proved your worth and your honor.','',26124),
(77782,'enUS','Now that the fortress is ours, we need to liberate the mines below and the nearby arena.','',26124),
(77783,'enUS','It will be done. Focus on your people here. $p will deal with the remaining Bladespire.','',26124),
(77784,'enUS','We cannot leave so many wounded behind enemy lines.','',26124),
(77785,'enUS','I have done what you ask, Harbinger.','I have done what you ask, Harbinger.',26124),
(77786,'enUS','The crystal is functional again, Master Artificer.','The crystal is functional again, Master Artificer.',26124),
(77787,'enUS','With that crystal non-functional, the Iron Horde has a direct aerial access point into Karabor.','',26124),
(77788,'enUS','Kill da intruder!','',26124),
(77789,'enUS','Attack!','',26124),
(77790,'enUS','Rwargh! Smash $Ghim:her;*!','',26124),
(77791,'enUS','|cFFFF0000|Hspell:150381|h[Power Shot]|h|r hit you. Move before Fenris releases it!','',26124),
(77792,'enUS','Carry this symbol of my gratitude into battle, and its fire shall join with your own to burn your enemies to ash.','',26124),
(77793,'enUS','We are the only ones close enough to collect these pieces and unleash the fury.','',26124),
(77794,'enUS','Work harder, chump!','',26124),
(77795,'enUS','Get minin\'!','',26124),
(77796,'enUS','Need more throwin\' rocks!','',26124),
(77797,'enUS','Gimme more rocks or Turgall hear about dis.','',26124),
(77798,'enUS','You so weak!','',26124),
(77799,'enUS','Hurry up or me bonk you again!','',26124),
(77800,'enUS','Dis hard work.','',26124),
(77801,'enUS','You slackin\' off?','',26124),
(77802,'enUS','Thank you, stranger.','Thank you, stranger.',26124),
(77803,'enUS','If only I had the strength to fight...','If only I had the strength to fight...',26124),
(77804,'enUS','Curse these ogres!','Curse these ogres!',26124),
(77805,'enUS','You\'ve saved me from a sure death.','You\'ve saved me from a sure death.',26124),
(77806,'enUS','I had given up hope of rescue.','I had given up hope of rescue.',26124),
(77807,'enUS','Thank you for your bravery.','Thank you for your bravery.',26124),
(77808,'enUS','I thought I was doomed.','I thought I was doomed.',26124),
(77809,'enUS','You have my thanks.','You have my thanks.',26124),
(77810,'enUS','Aye.','',26124),
(77811,'enUS','Defend the village, $pc. I go to check on my family.','Defend the village, $pc. I go to check on my family.',26124),
(77812,'enUS','You fight well, $pc. For Wolf Home!','You fight well, $pc. For Wolf Home!',26124),
(77813,'enUS','You have the heart of a true warrior!','You have the heart of a true warrior!',26124),
(77814,'enUS','I\'m going to attack their flank!','I\'m going to attack their flank!',26124),
(77815,'enUS','Here I come Thunderlord cowards!','Here I come Thunderlord cowards!',26124),
(77816,'enUS','Aka\'Mogosh, $pc. A blessing on you and yours.','Aka\'Mogosh, $pc. A blessing on you and yours.',26124),
(77817,'enUS','Gol\'Kosh! Blood will be spilt!','Gol\'Kosh! Blood will be spilt!',26124),
(77818,'enUS','Spill the blood of the enemy!','Spill the blood of the enemy!',26124),
(77819,'enUS','Throm-Ka, $pr. I will fight by your side.','Throm-Ka, $pr. I will fight by your side.',26124),
(77820,'enUS','The wolf spirit be with you, $pc!','The wolf spirit be with you, $pc!',26124),
(77821,'enUS','Two sets of tracks lead off to the north. Looks like an ogre leading the woman. No doubt as a captive.','',26124),
(77822,'enUS','Och! Enough with the bickerin\', you two!','',26124),
(77823,'enUS','Nice of you to share your information, ranger.','',26124),
(77824,'enUS','No change. The snipers are on alert, but everyone else is behaving normally. $p approaches.','',26124),
(77825,'enUS','Very well, we will head out right away. The might of the Alliance stands behind your people.','',26124),
(77826,'enUS','Ah, $n! You\'re here!','',26124),
(77827,'enUS','','Nice shot! Let\'s get out of here before they launch a counter-attack. Hold on to something!',26124),
(77828,'enUS','','$p! Fire the main cannon. Destroy the train depot!',26124),
(77829,'enUS','','$p, incoming! Use those explosives to destroy their ground forces.',26124),
(77830,'enUS','You Frostwolves were fools to attack the ogres.','',26124),
(77831,'enUS','I\'ll make a trophy of your head, Drek\'Thar.','',26124),
(77832,'enUS','Accept your shame. Admit defeat. I will give you a quick death.','',26124),
(77833,'enUS','You haven\'t won yet, $pc dog! I\'ll salt the earth with your corpse!','',26124),
(77834,'enUS','','I\'m going to scout the depot and devise a plan to destroy it.',26124),
(77835,'enUS','I\'m ready to back you up from the safety of the tank.','',26124),
(77836,'enUS','I can see Iron Horde reinforcements on the way. Yrel\'s across the depot to the northeast. Best get to her quickly.','',26124),
(77837,'enUS','','Let\'s see if we can provide Goc with an incentive to aid us.',26124),
(77838,'enUS','','We have loosened your bonds and bring you gifts.',26124),
(77839,'enUS','YES, LITTLE ONES, WE WILL CRUSH THEM TOGETHER!','',26124),
(77840,'enUS','Your security is lax, Chieftain. I caught these Rangari spies within your gates.','',26124),
(77841,'enUS','They are too late. The prisoners are already on their way to Anguish Fortress.','',26124),
(77842,'enUS','Their blood will summon forth the Dark Star, and make me as a God among the Iron Horde!','',26124),
(77843,'enUS','The Warchief honors deeds, not words, shadowcaster.','',26124),
(77844,'enUS','Seal the exits! No draenei scum leaves this village alive!','',26124),
(77846,'enUS','','He\'s given his assent. Come, $n, let\'s ride with Goc.',26124),
(77847,'enUS','','We have a common enemy. I ask you, humbly, for your aid. Let us destroy them together.',26124),
(77848,'enUS','Thunderlord... I have failed you...','',26124),
(77849,'enUS','','Goc, son of Gruul, prince of gronn, I am Yrel. Hear me.',26124),
(77850,'enUS','I\'ve seen your future, Gargrak. It doesn\'t look good.','',26124),
(77851,'enUS','','Come, $n. Let\'s convince Goc to help us destroy this place.',26124),
(77852,'enUS','$p, Yrel\'s plan is crazy. It\'s also brilliant. The two of you are going to destroy the depot... with a little help.','',26124),
(77853,'enUS','Going down to liberate the mines? Mount up and follow me, there\'s a quick way down.','Going down to liberate the mines? Mount up and follow me, there\'s a quick way down.',26124),
(77854,'enUS','This will take you down to the mines and arena, champion.','This will take you down to the mines and arena, champion.',26124),
(77855,'enUS','','Husband...',26124),
(77856,'enUS','Enough! You scheming draenei can keep your precious temple... for now.','',26124),
(77857,'enUS','The Iron Horde will return!','',26124),
(77858,'enUS','I will move ahead and prepare a staging area for our counter-attack.','',26124),
(77859,'enUS','Show some respect to the Iron Horde and put your back into it, weaklings.','',26124),
(77860,'enUS','Imperfections.','',26124),
(77863,'enUS','Your blood will grant me the powers of the Dark Star. To Shaz\'gul with you!','',26124),
(77864,'enUS','Take the prisoners to Shaz\'gul.','',26124),
(77865,'enUS','|TInterface\\Icons\\achievement_arena_2v2_5:20|t$n has agreed to begin the encounter. Additional players required to begin: $8589w.','',26124),
(77866,'enUS','Let\'s stop Blackthorn!','Let\'s stop Blackthorn!',26124),
(77867,'enUS','','You\'ve done it!  The plague preventing my access has been disrupted and we can now begin our final push to disrupt Death Speaker Blackthorn\'s ritual.  Lead on if you are ready to begin.',26124),
(77868,'enUS','Crushed by earth!','',26124),
(77869,'enUS','Servants, to me!','',26124),
(77870,'enUS','You... are... too late.  Amnennar is reborn with my death...','',26124),
(77873,'enUS','','The Shadowmoon have scaled the cliffs! What are they doing!?',26124),
(77874,'enUS','','An attack from the Shadowmoon clan? I\'ve never seen them so aggressive. We must strike back!',26124),
(77876,'enUS','Hero, I know you have many questions, for you are not from this world.','',26124),
(77877,'enUS','Hero, I know you have many questions, for these events are not as you remember them.','',26124),
(77878,'enUS','Ner\'zhul has used this observatory to call down the \"Dark Star,\" a creature of shadow who darkens these skies.','',26124),
(77879,'enUS','We cannot stop it. But, we may be able to purify the darkness when it arrives.','',26124),
(77880,'enUS','Six ancient crystals lie dormant throughout this valley. If we can activate them before the star descends... there is hope.','',26124),
(77881,'enUS','These orcs have violated the sanctity of Karabor. Their attack ends NOW!','',26124),
(77882,'enUS','May the Light guide our path!','',26124),
(77883,'enUS','Karabor ki\'le!','',26124),
(77884,'enUS','Karabor ki\'le!','Karabor ki\'le!',26124),
(77885,'enUS','Arepheon! Provide us with cover fire!','',26124),
(77886,'enUS','Rangari! Arrows ready...','',26124),
(77887,'enUS','FIRE AT WILL!','',26124),
(77888,'enUS','Artificers, disable those tanks!','',26124),
(77889,'enUS','As you wish, Great Prophet.','',26124),
(77890,'enUS','Akama, Taalo! Show them the might of the draenei!','',26124),
(77891,'enUS','The legion is ENDLESS!','',26124),
(77892,'enUS','You stand no chance against the Legion!','',26124),
(77893,'enUS','You cannot run from the Legion!','',26124),
(77894,'enUS','|TInterface\\Icons\\spell_fire_elementaldevastation.blp:20|t |cFFF00000|Hspell:150678|h[Molten Core]|h|r causes %s to unleash a |cFFF00000|Hspell:150682|h[Molten Barrage]|h|r!','',26124),
(77895,'enUS','$n, you come with me.','',26124),
(77896,'enUS','','Forces of the earth... give me strength!',26124),
(77897,'enUS','','My body... returns... to the Kraul...',26124),
(77898,'enUS','I understand now why you have come to Draenor, visitor. You do not belong here - but you have a noble reason to be here.','',26124),
(77899,'enUS','Our paths start and end at very different places, visitor. But they will cross again. Go with the blessing of the naaru.','',26124),
(77900,'enUS','I need you to stay on the ground and keep these orcs distracted while I search for Romuul.','',26124),
(77901,'enUS','You ready?','',26124),
(77902,'enUS','Good luck, $n.','',26124),
(77903,'enUS','Are you sure this is safe?','',26124),
(77904,'enUS','Whoooa!','',26124),
(77905,'enUS','Okay... seems stable. Now, if just activate the-- there we go!','',26124),
(77906,'enUS','If you see any boombots that look like they might be duds give them a good kick.  That\'ll get them moving again.','',26124),
(77908,'enUS','We need to get moving. How much longer?','',26124),
(77909,'enUS','Just give me a second to think! I\'m working with scraps over here.','',26124),
(77910,'enUS','Blackrock leadership is easy to identify. Just look for the biggest, loudest, ugliest orcs on the field.','',26124),
(77911,'enUS','|TInterface\\Icons\\spell_fire_selfdestruct.blp:20|t %s\'s |cFFF00000|Hspell:150734|h[Unleashed Flames]|h|r reaches full strength!','',26124),
(77912,'enUS','I can\'t believe they actually shot me down. I swear, if Rommul wouldn\'t have been yelling in my ear the whole time we would have been back at the observatory hours ago.','',26124),
(77913,'enUS','We need to activate that crystal. But we can\'t just stand by and watch as these orcs build weapons to attack Karabor.','',26124),
(77914,'enUS','Gnomes, they seem more interested in their inventions than they do their own lives. Let us hope that ingenuity can actually benefit our efforts.','',26124),
(77915,'enUS','I\'m finding it difficult to put my trust in Zipfizzle.$b$bHe seems sincere, and his heart is full of light, but he is clearly using bubblegum to attach some of those wires together.','',26124),
(77916,'enUS','By Agamaggan, I will END you!','',26124),
(77917,'enUS','Great Boar, grant me strength!','',26124),
(77918,'enUS','The crystals speak to me. Today brings victory.','',26124),
(77919,'enUS','Shards of earth, blind them!','',26124),
(77920,'enUS','Blood of Agamaggan, burn them!','',26124),
(77921,'enUS','INFERNO!','',26124),
(77924,'enUS','You walk so willingly to your death?','',26124),
(77925,'enUS','Let us see how you fare against the searing winds of the Twisting Nether!','',26124),
(77926,'enUS','Your world will BURN!','',26124),
(77927,'enUS','You should be honored, fools! Your blood will feed Aku\'mai, the destroyer of Azeroth!','',26124),
(77928,'enUS','Invaders in the Kraul! Drive them back!','',26124),
(77929,'enUS','Keep looking. If there are any survivors from the crash I want them dealt with immediately.','',26124),
(77930,'enUS','Failure is not an option.','',26124),
(77931,'enUS','Fan out. I want to know who was on that plane.','',26124),
(77932,'enUS','','Pathetic, you call that welding? Do better.',26124),
(77933,'enUS','','Tighten that up. I don\'t want to see a wheel fall off of this as it moves into battle.',26124),
(77934,'enUS','','Put some muscle into it.',26124),
(77935,'enUS','','Pay attention! You are going to weld that right to the main axle.',26124),
(77936,'enUS','Dig faster.','',26124),
(77937,'enUS','Work harder.','',26124),
(77938,'enUS','Keep digging, worthless scum!','',26124),
(77939,'enUS','Thank you, heroes!','Thank you, heroes!',26124),
(77940,'enUS','They were going to feed us to the beast Aku\'mai. There are more prisoners deeper in the dungeon. Please, save them!','They were going to feed us to the beast Aku\'mai. There are more prisoners deeper in the dungeon. Please, save them!',26124),
(77941,'enUS','Intruders?! Move the prisoners! Their flesh belongs to Lord Bathiel.','',26124),
(77942,'enUS','Come along, heroes! The water is fine. HAHAHAHAHA!!!','',26124),
(77943,'enUS','%s flees in fear!','',26124),
(77944,'enUS','We are going to report back to Velen now.','',26124),
(77945,'enUS','Feel free to use the gyro Thaelin made to get back to the observatory.','',26124),
(77946,'enUS','I have to say, it is a bit terrifying utilizing some of his inventions at first, but ultimately very enjoyable.','',26124),
(77947,'enUS','Aww... I knew you would come around.','',26124),
(77948,'enUS','No! AAAAaaahhhhhhh...','No! AAAAaaahhhhhhh...',26124),
(77949,'enUS','','Heroes, step quickly into the redeemed soils and allow life to flow back into you!',26124),
(77950,'enUS','DIG, YOU MAGGOTS! DIG!','DIG, YOU MAGGOTS! DIG!',26124),
(77951,'enUS','This cargo is worth more than your lives!','This cargo is worth more than your lives!',26124),
(77952,'enUS','Come on, put your backs into it!','Come on, put your backs into it!',26124),
(77953,'enUS','The Iron Horde war machine has toppled nations, and you idiots can\'t get us over a PILE of SNOW?!','The Iron Horde war machine has toppled nations, and you idiots can\'t get us over a PILE of SNOW?!',26124),
(77954,'enUS','Dig like you mean it!','Dig like you mean it!',26124),
(77955,'enUS','You shovel like a Shadowmoon! Would you like to draw a little circle in the snow? Maybe light some candles and ask the wheel nicely to come out?!','You shovel like a Shadowmoon! Would you like to draw a little circle in the snow? Maybe light some candles and ask the wheel nicely to come out?!',26124),
(77956,'enUS','I thought they sent me ORCS!','I thought they sent me ORCS!',26124),
(77957,'enUS','Many shots, one kill!','',26124),
(77958,'enUS','My boars will overrun you!','',26124),
(77959,'enUS','Pin them!','',26124),
(77960,'enUS','Run them through!','',26124),
(77961,'enUS','Dorogg see how punies like hot rocks!','',26124),
(77962,'enUS','Deez rocks smash you!','',26124),
(77963,'enUS','I put duh rocks in lavas!','',26124),
(77964,'enUS','Deez rocks is hot!','',26124),
(77965,'enUS','Rocks so hot dey on fire!','',26124),
(77966,'enUS','How do you like dis rock?!','',26124),
(77967,'enUS','More fire rocks is better den less!','',26124),
(77968,'enUS','If puny scared of rocks, puny scared of Dorogg!','',26124),
(77969,'enUS','Get that one!','',26124),
(77970,'enUS','Run away, little ones! Ha ha!','',26124),
(77973,'enUS','%s inhales deeply.','',26124),
(77974,'enUS','%s\'s laugh echoes ominously in your mind.','',26124),
(77975,'enUS','','Resisting my magic is useless Ghamoo-Ra! Soon you will be under my power, then I shall unleash your fury on these meddling heroes!',26124),
(77977,'enUS','','Wait... wait! It\'s too soon! NOOOOOoooooo...',26124),
(77978,'enUS','Hold that barricade! I don\'t want to see a single orc past these lines.','',26124),
(77979,'enUS','Karabor cannot fall!','',26124),
(77980,'enUS','Hold strong against these hordes. We will outlast them!','',26124),
(77981,'enUS','Do not give them an inch! Hold your ground!','',26124),
(77982,'enUS','I am feeling much more healthy now.','I am feeling much more healthy now.',26124),
(77983,'enUS','Thank you.','Thank you.',26124),
(77984,'enUS','Back to the battle.','Back to the battle.',26124),
(77985,'enUS','Thank you, priest.','Thank you, priest.',26124),
(77986,'enUS','You have my gratitude.','You have my gratitude.',26124),
(77987,'enUS','I thought I was done for. Thank you, healer.','I thought I was done for. Thank you, healer.',26124),
(77988,'enUS','That will do. You have my thanks.','That will do. You have my thanks.',26124),
(77989,'enUS','Thank the Light you were here. You saved my life.','Thank the Light you were here. You saved my life.',26124),
(77990,'enUS','','No... Samaara!',26124),
(77991,'enUS','','Ner\'zhul, stop this! What do you want?',26124),
(77992,'enUS','Slaves! Fight or die!','',26124),
(77993,'enUS','We need to get our eyes onto the field. The Rangari can help us.','',26124),
(77998,'enUS','','The Light never falters. We WILL prevail!',26124),
(77999,'enUS','Yes... Very good. Around Shadowmoon Valley are four arkonite crystals, ancient wreckage from our vessel.','',26124),
(78000,'enUS','I thought we would never need their power, but the time has come. Take my staff, and gather their energy for me.','',26124),
(78001,'enUS','All right, give me one moment...','',26124),
(78003,'enUS','The twin crystals powering Karabor\'s shield took my artificers over a year to engineer.$B$BIts creation was an unrivalled accomplishment, and its destruction, an utter waste.$B$BThe four arkonite shards that lie dormant across Shadowmoon were created ages ago, but still, they may prove serviceable.','',26124),
(78005,'enUS','There are still enemies among us. EVERYONE TO ARMS!','',26124),
(78010,'enUS','Champion, locating our prisoners may slow Ner\'zhul\'s plans, but we will need the power of all four crystals if we are to triumph over his schemes.','',26124),
(78012,'enUS','%s sighs heavily.','',26124),
(78014,'enUS','There is no darkness that the light cannot pierce.','',26124),
(78015,'enUS','True sacrifice is willingly given. Ammi\'s sacrifice is a pact made in cold blood. It is capable only of the basest of magic. True sacrifice is made with one\'s soul, with no selfish intentions, with the purest of goodwill for one other than yourself. This type of sacrifice is capable of miraculous things.','',26124),
(78016,'enUS','Behold my power, Warchief Hellscream. With my clan at your side, you will be unstoppable.','',26124),
(78018,'enUS','','Yrel... my dearest sister...',26124),
(78021,'enUS','Come forth, Borrok!','',26124),
(78022,'enUS','Mighty Devourer, come and claim this offering from da Grimfrost!','',26124),
(78023,'enUS','HEY, COME OUT!','',26124),
(78024,'enUS','COME OUT WE GOTS FOOD!','',26124),
(78025,'enUS','Da Grimfrost ogres pay tribute to you! Show yourself!','',26124),
(78026,'enUS','BIG WORM!','',26124),
(78027,'enUS','We are always on the hunt.','',26124),
(78028,'enUS','Keep your eyes and senses sharp. Danger lurks in the marsh.','',26124),
(78029,'enUS','Greetings, $n. Prophet Velen has told me of your deeds.','',26124),
(78030,'enUS','','The Shadowmoon clan is of special interest to me. I believe that the more we know of their history, the more we can come to understand them.',26124),
(78031,'enUS','','The first step to fighting your enemy is understanding them.',26124),
(78032,'enUS','','Of all the orc clans, it seems the Shadowmoon have the strongest affinity with  mysticism and superstition.',26124),
(78033,'enUS','','The Shadowmoon clan lived in peaceful coexistence with us for many centuries. Only recently have we noticed more hostile behavior from the clan.',26124),
(78034,'enUS','','Such powerful casters the Shadowmoon are. Their magic is one I am not entirely familiar with, but that\'s why it is so fascinating.',26124),
(78035,'enUS','','I am very interested in the Shadowmoon\'s particular brand of magic. It seems their most powerful abilities involve some type of blood pact, and thus, sacrifice.',26124),
(78036,'enUS','What can I do for you?','',26124),
(78037,'enUS','I\'ll carry out any job, for the right price.','',26124),
(78038,'enUS','My team is the best out there. We get the job done.','',26124),
(78039,'enUS','Our scouts are positioned across the marshes and the forests. We keep a close eye on the Shadowmoon orcs.','',26124),
(78040,'enUS','','Champion! Focus your attacks on that... THING! I will protect the others.',26124),
(78041,'enUS','AHHHH!!!','',26124),
(78042,'enUS','Borrok the Devourer demands sustenance! Feed him Grimfrost Ogres!','',26124),
(78043,'enUS','Borrok snatches %s from the feeding area!','Borrok snatches %s from the feeding area!',26124),
(78044,'enUS','','Heroes! I require your aid!',26124),
(78045,'enUS','','You are too late!  The ritual has begun.',26124),
(78046,'enUS','','Amnennar will be reawakened!',26124),
(78047,'enUS','Mmm-hnng - yeah, come here! I\'ll put you in chains.','',26124),
(78048,'enUS','Fools! The more blood you spill, the easier it will be for Aku\'mai to rise!','',26124),
(78049,'enUS','','Let the power of the red dragonflight mend your wounds!',26124),
(78050,'enUS','','No darkness can hold back the powers of the Life-Binder.',26124),
(78051,'enUS','','We have done it.  I will take the phylactery into safekeeping. Amnennar will no longer control the Quilboar nor threaten Kalimdor.',26124),
(78058,'enUS','Karabor is as much a fortress as it is a temple.','',26124),
(78059,'enUS','We\'ve defended against orc raids before, but the size of this army is much greater than any I\'ve ever seen.','',26124),
(78060,'enUS','I will see to the defense of Karabor - even if it requires laying down my own life.','',26124),
(78061,'enUS','You must defeat Commander Vorka. There he is, at the very gates of Karabor.','',26124),
(78062,'enUS','With pleasure. Vindicators, follow me into the fray!','',26124),
(78063,'enUS','','Together we can put a stop to Death Speaker Blackthorn\'s plans.  We must be quick, the ritual is almost complete!',26124),
(78064,'enUS','<A lone orc traveler lies dead in the snow, apparently overwhelmed by ravenous tundra wolves. Judging by his gear, he was prepared for a long journey through harsh conditions.$B$BTucked into the front of his robe is a scroll bound in leather laces, with a furry trinket dangling from one end.>','',26124),
(78065,'enUS','Take the scroll.','Take the scroll.',26124),
(78066,'enUS','','You are good to have come so quickly.  I\'m afraid I must ask you to put your lives in danger again to save Kalimdor.$B$BAmnennar\'s apprentice, Death Speaker Blackthorn, hopes to return his master to the realm of the living!  We must quickly make our way atop the Spiral of Thorns and defeat him before the ritual can be completed.$B$BWe must strike together, only with our combined force can we hope to stop him!',26124),
(78067,'enUS','I thought Amnennar was destroyed.','I thought Amnennar was destroyed.',26124),
(78068,'enUS','','I too thought Amnennar the Coldbringer had been defeated; a grave mistake indeed. How clouded my judgment must have been to forget the true power of a lich lies in their phylactery.',26124),
(78069,'enUS','A phylactery?','A phylactery?',26124),
(78070,'enUS','','A powerful necromancer such as Amnennar can store his soul in a physical vessel, allowing himself to be reborn if the proper rituals can be completed.$B$BI should have searched across Kalimdor for Amnennar\'s Phylactery, but I was too prideful in our previous victory.$B$BNow, all of that work may come undone.',26124),
(78071,'enUS','Skeletons assault you constantly and plague roils out of the caves.  How can I help stop the ritual?','Skeletons assault you constantly and plague roils out of the caves.  How can I help stop the ritual?',26124),
(78072,'enUS','','I know Death Speaker Blackthorn\'s newest creation, Mushlump, spews forth plague from every pore and he has reenlisted Mordresh Fire Eye\'s help in rallying the undead.$B$BEven the Death\'s Head has been helping Blackthorn.  Their Arachnomancers have created a monstrosity of fang and plague, a spider of enormous size named Aarux.$B$BIf you could defeat these enemies and clear the plague blocking my path we could climb the Spiral of Thorns to defeat Death Speaker Blackthorn and recapture Amnennar\'s phylactery before it is too late.',26124),
(78073,'enUS','','<This orc appears to have been camping here for several days before succumbing to the bitter cold. Her face is frozen in a woeful stare, gazing southwest toward the icy flats.$B$BClutched to her breast is a neatly folded letter.>',26124),
(78074,'enUS','Take the letter.','Take the letter.',26124),
(78075,'enUS','You have to stop them! They\'re mad!','You have to stop them! They\'re mad!',26124),
(78076,'enUS','We mustn\'t let Auchindoun fall!','We mustn\'t let Auchindoun fall!',26124),
(78077,'enUS','Thank you, stranger. I owe you my life.','Thank you, stranger. I owe you my life.',26124),
(78078,'enUS','Thank you. I\'ll return to the gate.','Thank you. I\'ll return to the gate.',26124),
(78079,'enUS','I thought I was going to die! Thank you.','I thought I was going to die! Thank you.',26124),
(78080,'enUS','','<She waited for him until her breath froze.>',26124),
(78081,'enUS','<He was willing to lose everything to be with her.>','',26124),
(78082,'enUS','%s has calmed down, and looks ready to be ridden into battle.','',26124),
(78083,'enUS','Focus on the kill.','',26124),
(78084,'enUS','Don\'t let the beast out of your sights.','',26124),
(78085,'enUS','Watch your prey closely... and fire!','',26124),
(78086,'enUS','%s calls in reinforcements!','',26124),
(78087,'enUS','I join... the earth...','',26124),
(78088,'enUS','Destroy the void fragments before they merge with the %s!','',26124),
(78089,'enUS','You will never take my glory!','',26124),
(78090,'enUS','Furious little orcling!','',26124),
(78091,'enUS','In your blind rage you rush to face my ogres alone.','',26124),
(78092,'enUS','They will end you, little lone wolf.','',26124),
(78093,'enUS','Your conquered clan will fill my slave pens...','',26124),
(78094,'enUS','You are too late, fool. The Destroyer of Dreams\' plans are nearing fruition.','',26124),
(78095,'enUS','We will soon have portals surrounding Auchindoun. Pity you won\'t be around to see them unleashed.','',26124),
(78096,'enUS','Hellmaw, tear their souls asunder.','',26124),
(78097,'enUS','$p! I came as quickly as I could. Did you find their leader?','',26124),
(78098,'enUS','The wound is severe. If I can cauterize it, I might be able to stop the bleeding.','',26124),
(78099,'enUS','What\'s happening here?','What\'s happening here?',26124),
(78100,'enUS','The intruders are still alive?! Stop them! The ritual must not be disturbed!','',26124),
(78101,'enUS','The Razorfen never die.','',26124),
(78102,'enUS','Spirits... guide my blade.','',26124),
(78103,'enUS','This is not the last... of us...','',26124),
(78104,'enUS','Yrel never arrived. I fear the worst.$B$BI won\'t lose her again, $n.','',26124),
(78105,'enUS','The Iron Horde were merely testing us. They will come again, with a larger force.','',26124),
(78106,'enUS','The crystal is malfunctioning again. What we really need is a high-grade crystal shipment from Talador.$B$BThese old components just aren\'t holding together anymore.','',26124),
(78107,'enUS','A thousand and more were lost defending the temple, but our walls still stand.','',26124),
(78108,'enUS','What? Romuul, I need you to take care of this. I will send reinforcements after you.','',26124),
(78109,'enUS','Life is the Light, and the Light is Life itself. They may be exchanged, but nothing is ever lost.','',26124),
(78110,'enUS','Oh, hi. Do you need something?','',26124),
(78111,'enUS','You must be the $r Taalo said we were waiting for.','',26124),
(78112,'enUS','You must be the $c that snooty draenei, Taalo said was comin\' round.$B$BBy the looks o\' ye, we\'re gonna have some fun!','',26124),
(78113,'enUS','I\'ll drown you in the blood of your little army!','',26124),
(78114,'enUS','Kill Hellmaw\'s Felblood to stop him from regenerating!','',26124),
(78115,'enUS','There\'s nothin\' I hate more than orcs, \'cept fer Blackrock orcs!','',26124),
(78116,'enUS','IMPUDENT FLEA! Now you will see what power lies in this fortress.','',26124),
(78117,'enUS','Gorgrond is unforgiving. I\'m glad you\'re here, $n.','',26124),
(78118,'enUS','Yrel never showed and has gone missing.$B$BI worry for her, but also about how Maraad will react to bad news.$B$BRegardless, I think it\'d be wise for us to leave this place soon.','',26124),
(78119,'enUS','I\'m glad you\'re here. I don\'t want to go in alone.','',26124),
(78120,'enUS','They got \'emselves somethin\' big \'n nasty o\'er there.','',26124),
(78121,'enUS','There were three ogres and a draenei; a female by the look of the tracks. The survivors headed north. I\'ll tell Maraad when I know more.','',26124),
(78122,'enUS','She doesn\'t want me going with you. But, I can help by magically projecting myself.','',26124),
(78123,'enUS','Of all the things that could go wrong, it had to be Karabor\'s shield.$B$BNo, it couldn\'t be a malfunctioning resonancy code. It wasn\'t a bad shipment of agentite.$B$BIt just had to be the shield protecting the largest draenei city in Shadowmoon!','',26124),
(78124,'enUS','I\'ll be a talbuk\'s hind if I let that shield be the end of Karabor.$B$BWe must activate those arkonite crystals, now!','',26124),
(78125,'enUS','Any other master artificer wouldn\'t have a sporebat\'s cahoot how to fix the city\'s shield, that\'s what I\'d like to say.$B$BWhat would they do without me?','',26124),
(78126,'enUS','My wife always says I should relax more.','',26124),
(78127,'enUS','The arkonite crystals around Shadowmoon fell from the wreckage of our original descent to Draenor, nearly three hundred years ago.$B$BIt\'s a testament to draenei technology that they are still functional.','',26124),
(78128,'enUS','','I came as quickly as I could. Were you able to catch their leader?',26124),
(78129,'enUS','Ready the cannons!','',26124),
(78130,'enUS','Steady!','',26124),
(78131,'enUS','Hold, me boyos!','',26124),
(78132,'enUS','Wait fer it!','',26124),
(78133,'enUS','Almost there!','',26124),
(78134,'enUS','Fire!','',26124),
(78135,'enUS','Give \'em all ye got!','',26124),
(78136,'enUS','Now!','',26124),
(78137,'enUS','Pound \'em, lads!','',26124),
(78138,'enUS','Send \'em back ta Hell!','',26124),
(78139,'enUS','Ignaeus! Protect me!','',26124),
(78140,'enUS','|TInterface\\Icons\\spell_arcane_blast:20|t %s readies an |cFFFF0000|Hspell:151273|h[Arcane Shot]|h|r at $n!','|TInterface\\Icons\\spell_arcane_blast:20|t %s readies an |cFFFF0000|Hspell:151273|h[Arcane Shot]|h|r at $n!',26124),
(78141,'enUS','There are fewer ogres in our way with you around. I\'ll get these orcs to safety.','',26124),
(78142,'enUS','I will get these orcs to safety and meet with you outside.','',26124),
(78143,'enUS','Gol\'kosh headed southeast toward the supply room.','',26124),
(78144,'enUS','AAAHHHHHH!','',26124),
(78145,'enUS','Aaahhhhh!','',26124),
(78146,'enUS','Wha... AAAAHHHHHH!','',26124),
(78147,'enUS','Grrrr... RRRAAAHHHH!','',26124),
(78148,'enUS','Gahhhh!','',26124),
(78149,'enUS','I carry the satchel charges, you do the fighting. Deal?','',26124),
(78150,'enUS','This gruesome corpse has had its face forcibly shaped into that of a smile. Across the chest armor reads: \"We got them to laugh... eventually.\"','This gruesome corpse has had its face forcibly shaped into that of a smile. Across the chest armor reads: \"We got them to laugh... eventually.\"',26124),
(78151,'enUS','We will not be slaves again!','We will not be slaves again!',26124),
(78152,'enUS','I will be strong and stand with you!','I will be strong and stand with you!',26124),
(78153,'enUS','Here\'s to a less miserable future!','Here\'s to a less miserable future!',26124),
(78154,'enUS','I follow the beating of my heart!','I follow the beating of my heart!',26124),
(78155,'enUS','Work more better!','',26124),
(78156,'enUS','Faster pipsqueaks!','',26124),
(78157,'enUS','No one blows up MY village! Nobody! Except maybe Kaz. But nobody else!','',26124),
(78158,'enUS','Where is Kaz?','Where is Kaz?',26124),
(78159,'enUS','Get me lose and I will speak with your wolf chief.','',26124),
(78160,'enUS','Let\'s go.','Let\'s go.',26124),
(78161,'enUS','I... feel... better! You\'ve done the right thing! Now I shall go see what your wolf chief has to say.','',26124),
(78162,'enUS','What skulls that are still alive are going to be here. We need to get them out.','',26124),
(78163,'enUS','You break the wall, I\'ll break the guard!','',26124),
(78164,'enUS','Hi, I can start this race if you ask me.','',26124),
(78165,'enUS','Yes, please start.','Yes, please start.',26124),
(78166,'enUS','If we don\'t kill more of these goren soon they will forget who we are.','',26124),
(78167,'enUS','The world will burn!','',26124),
(78168,'enUS','','Exarch, we have to bring the shards to safety. Auchindoun\'s safety is at stake!',26124),
(78169,'enUS','Satisfied for now, Borrok spews forth a massive stone.','',26124),
(78170,'enUS','We cannot hold this point much longer. Make haste, $n!','',26124),
(78171,'enUS','The burning corpse of this Laughing Skull orc is beyond saving.','The burning corpse of this Laughing Skull orc is beyond saving.',26124),
(78172,'enUS','This orc seems to have been eating when the attack came.','This orc seems to have been eating when the attack came.',26124),
(78173,'enUS','You thought the eyes of this orc turned to look at you as you approached, but the orc is now clearly dead.','You thought the eyes of this orc turned to look at you as you approached, but the orc is now clearly dead.',26124),
(78174,'enUS','Pitiful soft-skins.','',26124),
(78175,'enUS','Jargba, break their will!','',26124),
(78176,'enUS','Aggem, aim for the eyes!','',26124),
(78177,'enUS','Exarch... I... saw one of them walk towards the Shadow Tomb.','Exarch... I... saw one of them walk towards the Shadow Tomb.',26124),
(78178,'enUS','Auchindoun is safe... for now. Unfortunately, I have a feeling our work is far from done.','',26124),
(78179,'enUS','Be careful, $n. If that portal is any indication, great evil may be waiting for you in the tomb.','',26124),
(78180,'enUS','The siege is broken! Come, brothers and sisters - drive these orcs from Karabor!','',26124),
(78181,'enUS','','You\'re going to have to trust me. We, too, have been chased across the nether by the Legion. We are here to put a stop to their efforts here before they gain any ground.',26124),
(78183,'enUS','And they say the same of us. We do not have time for clan rivalries.','',26124),
(78184,'enUS','The Laughing Skull are murderous and insane. Durotan, I would advise against this.','',26124),
(78186,'enUS','They may be mad, but they are the only orc clan familiar with this savage land. We may need to rely upon their knowledge.','',26124),
(78187,'enUS','','You should speak with Nyami as well before you head out.',26124),
(78188,'enUS','I hope you did not spill any of it on your clothes. Demon blood stains, you know.','',26124),
(78189,'enUS','How this even work?','',26124),
(78190,'enUS','Stupid wheel! Work!','',26124),
(78191,'enUS','Me hurt you if you don\'t spin!','',26124),
(78192,'enUS','FOODS TIME!','',26124),
(78193,'enUS','We offer dis orc to you, Borrok!','',26124),
(78194,'enUS','\'Bout time this got here! I was runnin\' outta ogres to kill...','',26124),
(78195,'enUS','It appears their leader is headed to the Shadow Tomb, Matriarch. Shall I execute this heathen now?','',26124),
(78196,'enUS','','No, Mehlar. That is no longer our way. He lives for now.',26124),
(78197,'enUS','My friends ought to keep you occupied.','',26124),
(78198,'enUS','A few moments more, keep my guests entertained.','',26124),
(78199,'enUS','Amnennar will be reborn!','',26124),
(78200,'enUS','','I have a special fire I am saving just for the genesaur. I am going to make him choke on it.',26124),
(78201,'enUS','','I am going to BURN all of those plant people to ash and then sprinkle that ash on a piece of meat and then feed that piece of meat to a boar and then set that boar ON FIRE!$b$bAnd THEN I\'ll get started on them.',26124),
(78202,'enUS','','Do you burn easily? You should probably keep more water on you. Things are going to get messy.',26124),
(78203,'enUS','','This is Gorgrond. Here the sky, the earth, and the water are all made to burn. Shall we light the first spark?',26124),
(78204,'enUS','Test of Gas','Test of Gas',26124),
(78205,'enUS','Pushing','Pushing',26124),
(78206,'enUS','Okay, that\'s enough.','',26124),
(78208,'enUS','Now\'s our chance to escape!','Now\'s our chance to escape!',26124),
(78209,'enUS','Run for it!','Run for it!',26124),
(78210,'enUS','From the dirt and cracks comes the blackest of waters, but do not drink it.','',26124),
(78211,'enUS','The land of Gorgrond gives much. From its earth comes gas but do not mistake it for steam. These apparitions do not respond well to flames.','',26124),
(78212,'enUS','Test of Oil.','Test of Oil.',26124),
(78213,'enUS','Test of Blackrock.','Test of Blackrock.',26124),
(78214,'enUS','The truest test of Gorgrond: the Blackrock. Behold fire made stone.','',26124),
(78215,'enUS','You must defeat all three tests. Chose which test you wish to face now.','',26124),
(78216,'enUS','And what have you learned?','',26124),
(78217,'enUS','To respect the elements.','To respect the elements.',26124),
(78218,'enUS','To be careful what weapon to use.','To be careful what weapon to use.',26124),
(78219,'enUS','Gorgrond is dangerous.','Gorgrond is dangerous.',26124),
(78220,'enUS','Wrong! You were supposed to learn that any problem in Gorgrond can be solved by blowing it up!','',26124),
(78221,'enUS','Karabor stands, for today.','',26124),
(78222,'enUS','Hrahahahaha! *cough* Hee hee. *cough* You... missed me. Filthy Iron Hordies!','',26124),
(78223,'enUS','Grant me one request. Grant me revenge!','',26124),
(78224,'enUS','I will crush my enemies and see them driven before me...','',26124),
(78225,'enUS','I miss the smell of fresh wind before a storm...','',26124),
(78226,'enUS','You will not die today, champion!','You will not die today, champion!',26124),
(78227,'enUS','Let the Light heal your wounds!','Let the Light heal your wounds!',26124),
(78228,'enUS','The Light protects its champions.','The Light protects its champions.',26124),
(78229,'enUS','Thank you, $n. I will meet you back at Twilight Glade.','Thank you, $n. I will meet you back at Twilight Glade.',26124),
(78230,'enUS','When the deed is done, leave the dead and bring the masks. Join us at the ruin of Laughing Skull.','',26124),
(78231,'enUS','<whispered> Hey, wait. I wouldn\'t go in there. I think our boys may all be dead.','<whispered> Hey, wait. I wouldn\'t go in there. I think our boys may all be dead.',26124),
(78232,'enUS','You\'re cannon is down. Soon your base will be gone, $pc!','',26124),
(78233,'enUS','Just enough time to kill you on the way out, $pc.','',26124),
(78234,'enUS','You weren\'t in the mission plan.','',26124),
(78235,'enUS','Too late. Your defenses are down.','',26124),
(78236,'enUS','Our cannon\'s bigger than yours, $pr.','',26124),
(78237,'enUS','Good. A challenge.','',26124),
(78238,'enUS','More collateral damage.','',26124),
(78239,'enUS','Intel didn\'t mention a $pc.','',26124),
(78240,'enUS','Your base\'s time has run out.','',26124),
(78241,'enUS','Nothing changes. Our next shot will...','',26124),
(78242,'enUS','Get moving you mangy beast!','',26124),
(78243,'enUS','I don\'t care if your mate is dead, beast! We have a war to finish!','',26124),
(78244,'enUS','Get up, beast! You are making me look bad in front of the Blackrock.','',26124),
(78245,'enUS','Get to |cFF00FF00|Hspell: 150665|h[Redeemed Soil]|h|r to break %s\'s |cFFFF0000|Hspell:150679|h[Soul Leech]|h|r','',26124),
(78247,'enUS','Defeat Ignaeus to remove Gorr\'thog\'s shield!','Defeat Ignaeus to remove Gorr\'thog\'s shield!',26124),
(78248,'enUS','Gorr\'thog is afflicted by |cFFFF0000|Hspell:151217|h[Elemental Overload]|h|r! Finish him!','Gorr\'thog is afflicted by |cFFFF0000|Hspell:151217|h[Elemental Overload]|h|r! Finish him!',26124),
(78249,'enUS','','Help! Someone help!',26124),
(78250,'enUS','','Thank the... Light... I found you.',26124),
(78251,'enUS','','Telmor... attacked...',26124),
(78252,'enUS','','They... demons...',26124),
(78253,'enUS','','Laughing Skull! Durotan, we must move on before we are discovered.',26124),
(78254,'enUS','What?! By who? Who did this?','',26124),
(78255,'enUS','Tell me, mongrel! Where is Vorpil?','',26124),
(78256,'enUS','You\'re wasting your time... we\'ve already won.','',26124),
(78257,'enUS','Here, $n, take some of the explosives. Just  place them on the front of a war machine... then run!','',26124),
(78258,'enUS','Not sure what I expected.','',26124),
(78259,'enUS','These peasants had nothing worth taking.','',26124),
(78260,'enUS','Who\'s laughing now?','',26124),
(78261,'enUS','That Goliath Cannon destroyed more than we thought it would.','',26124),
(78262,'enUS','Ugh. Why would they keep this?','',26124),
(78263,'enUS','*cough* Hee hee... *cough* *gasp*','',26124),
(78264,'enUS','Filthy... *cough* ... Iron Hordies!','',26124),
(78265,'enUS','What...*cough* what was that... *cough* it burns...*gasp*.','',26124),
(78266,'enUS','','Enough, Mehlar! I order you to stop.',26124),
(78267,'enUS','','Bring him some water and untie him. Followers of the Light do not act this way.',26124),
(78268,'enUS','Fine, Liadrin. I\'ll talk... in exchange for my freedom.','',26124),
(78269,'enUS','*cough* I... exploded! *cough*','',26124),
(78270,'enUS','Filthy Iron Hordies...*cough* cheated!','',26124),
(78271,'enUS','Witness the TRUE power of the Iron Horde!','',26124),
(78272,'enUS','The skies darken with iron!','',26124),
(78273,'enUS','Look! Fire!','Look! Fire!',26124),
(78274,'enUS','','Very well. Now, where is your base?',26124),
(78275,'enUS','Due west of Auchindoun, north of Telmor.','',26124),
(78276,'enUS','Not that it matters. Telmor\'s portal is shielded. You\'ll never make it to the Grandmaster.','',26124),
(78277,'enUS','I\'m strongest podling in Gorgrond. Stick with me. I keep you safe.','',26124),
(78278,'enUS','You\'re gonna DIE, Rocker!','',26124),
(78279,'enUS','I guess you can come along.','I guess you can come along.',26124),
(78280,'enUS','Wrahahahahahaha!','',26124),
(78281,'enUS','Hee hee! Hee HEE! HRAHAHA! HAHA! HAHA!','',26124),
(78282,'enUS','Invite Jagahari?','',26124),
(78283,'enUS','Stabbing time!','',26124),
(78285,'enUS','Soldiers - Come to my aid!','',26124),
(78286,'enUS','Hansel, D\'kaan... we\'re leaving now. It\'s time to defeat the Iron Horde. It\'s time to gain vengeance!','',26124),
(78287,'enUS','Ah! $p of the Not-Here, Not-Now Place. My rock said you would come. Where is your pack of wolves?','',26124),
(78288,'enUS','Bah. You are too cautious. I will gather our warriors and do it myself!','',26124),
(78289,'enUS','The citadel is ours! Come, brother - we press the attack!','',26124),
(78290,'enUS','Contact! I found a survivor!','',26124),
(78291,'enUS','There is something alive over here!','',26124),
(78292,'enUS','I got a live one over here!','',26124),
(78293,'enUS','Survivor found!','',26124),
(78294,'enUS','Help me. I feel so weak... need water.','',26124),
(78295,'enUS','Revive Jagahari by rubbing muddy water on his leaves.','Revive Jagahari by rubbing muddy water on his leaves.',26124),
(78296,'enUS','Revive Jagahari?','',26124),
(78297,'enUS','Aaauuughh!','Aaauuughh!',26124),
(78298,'enUS','No, Ga\'nar. We are surrounded and exposed. We must fortify.','',26124),
(78299,'enUS','Reckless brother!','',26124),
(78300,'enUS','Smart move, $n. I meet you back at caravan.','',26124),
(78301,'enUS','O\'re atal\'sha! For the Light!','O\'re atal\'sha! For the Light!',26124),
(78302,'enUS','We will not yield!','We will not yield!',26124),
(78303,'enUS','Forward! For Karabor!','Forward! For Karabor!',26124),
(78304,'enUS','','I see... the clan\'s ancestors forbade the use of void magic. So why has Ner\'zhul broken their ancient laws?',26124),
(78305,'enUS','Let\'s go.','',26124),
(78306,'enUS','Prepare to be burned alive!','',26124),
(78307,'enUS','Taste the flames!','',26124),
(78308,'enUS','I\'ll burn the ground beneath your feet.','',26124),
(78309,'enUS','The Iron Horde... will... take you all...','',26124),
(78310,'enUS','Guardians of Auchindoun, let this square be cleansed!','',26124),
(78311,'enUS','Spirits of our ancestors, rid this land of its torment!','',26124),
(78312,'enUS','By my oath, I will not let our spirits be tormented!','',26124),
(78313,'enUS','No please! I don\'t want to die like this!!!','',26124),
(78314,'enUS','','The sacrifice is complete! Grant me your power, Aku\'mai! AHAHAHAHA!!!',26124),
(78315,'enUS','I will see to matters here briefly. I\'ll meet you at the staging grounds.','',26124),
(78316,'enUS','Deathgonia family will be sorry they messed with Jagahari!','',26124),
(78317,'enUS','My shield! Give me!','',26124),
(78318,'enUS','Online.','',26124),
(78319,'enUS','Demonic energy detected. Cleansing.','',26124),
(78320,'enUS','Processing fel energies. Standby.','',26124),
(78321,'enUS','Purification module activated.','',26124),
(78322,'enUS','Objective complete. Instructions to user to meet at staging area. Over.','',26124),
(78323,'enUS','The blast was larger than anticipated. Blackhand will be pleased.','',26124),
(78324,'enUS','One shot, one clan killed. Hrah ha ha ha.','',26124),
(78325,'enUS','The Laughing Skull won\'t be laughing anymore after this.','',26124),
(78326,'enUS','A flawless test of the Goliath Cannon. It is finally ready for full production.','',26124),
(78327,'enUS','I told the commander we should have just fired the cannon first. We could have avoided this pitiful last stand from the Laughing Skull all together.','',26124),
(78328,'enUS','This proves it. Once the Goliath Cannon is ready to move we can hit those mangy Frostwolves with the full strength of the Iron Horde.','',26124),
(78329,'enUS','Get up, beast! Get up and fight!','',26124),
(78330,'enUS','I am not about to let you embarrass me in front of the Iron Horde!','',26124),
(78331,'enUS','Show some pride you mangy beast! Lets show them why the Thunderlords belong in the Iron Horde!','',26124),
(78332,'enUS','Ogre attack!','Ogre attack!',26124),
(78333,'enUS','Regroup!','Regroup!',26124),
(78334,'enUS','Fall back!','Fall back!',26124),
(78335,'enUS','They counterattack!','They counterattack!',26124),
(78336,'enUS','There is much to be done. Taalo, see that the troops are healed and rested.','',26124),
(78337,'enUS','Bah! Time to remind my beast how to kill.','',26124),
(78338,'enUS','Looks like my beast is going to be feeding well tonight!','',26124),
(78339,'enUS','|cff71d5ff|Hspell:149587|h[Race Complete]|h|r','',26124),
(78340,'enUS','Placing Resonator Crystal','Placing Resonator Crystal',26124),
(78341,'enUS','I use this club to smash Deathgonia face!','',26124),
(78342,'enUS','Jagahari? You leave now or I kill you!','',26124),
(78343,'enUS','He dead? Good!','',26124),
(78344,'enUS','Disengaging','Disengaging',26124),
(78345,'enUS','Guards! Stop yapping, start smashing!','',26124),
(78346,'enUS','Trial Complete!','Trial Complete!',26124),
(78347,'enUS','Trial Failed!','Trial Failed!',26124),
(78348,'enUS','You cheating cheater!','',26124),
(78349,'enUS','Me stop them!','',26124),
(78350,'enUS','We make them pay!','',26124),
(78351,'enUS','My slaves! Those were Bloodmaul property!','',26124),
(78352,'enUS','Jagahari? You banished. How dare you return!','',26124),
(78353,'enUS','Jagahari? You were banished. How dare you return to our land!','',26124),
(78354,'enUS','Don\'t be scared. I protect you.','Don\'t be scared. I protect you.',26124),
(78355,'enUS','Deathgonia family will die!!','Deathgonia family will die!!',26124),
(78356,'enUS','Follow me.','Follow me.',26124),
(78357,'enUS','It\'s good I\'m here. I protect you.','It\'s good I\'m here. I protect you.',26124),
(78358,'enUS','Banished? I show them banished.','Banished? I show them banished.',26124),
(78359,'enUS','Jagahari? You little peck. You think you can defeat me?','',26124),
(78360,'enUS','Whoa! I got him! Did you see that?!','',26124),
(78361,'enUS','You wreck Thruk\'s catch of legendary guardian crab! Thruk fillet you now!','',26124),
(78362,'enUS','Maraad\'s grumpier than ever. He\'s really worried about Yrel.','',26124),
(78363,'enUS','Did you see my Tank? It\'s the best thing I\'ve ever built.','',26124),
(78364,'enUS','What happened to Hansel\'s wife is horrible. It\'s why he hates the orcs so much.','',26124),
(78365,'enUS','D\'kaan\'s so mysterious. All those draenei rangers are.','',26124),
(78366,'enUS','I\'m glad you\'re here. If we don\'t destroy the Iron Horde\'s big war machine, we\'re all dead!','',26124),
(78367,'enUS','AHH! Don\'t hurt me!','',26124),
(78368,'enUS','Not in the face!','',26124),
(78369,'enUS','It\'s not my fault! $n made me do it!','',26124),
(78370,'enUS','Ever since our king die the Spinebloom tribe is broken.$b$bDeathgonia family and they goons banish or kill all podlings that challenge them.$b$bThey say they family new leaders? They say they new kings of Spinebloom? Guess again!','',26124),
(78371,'enUS','Is there no place left for us?','',26124),
(78372,'enUS','First they discard us, now they come to dispose of us.','',26124),
(78373,'enUS','A thousand curses upon Arak!','',26124),
(78374,'enUS','Hmm. Is that $g cologne : perfume; I smell?','',26124),
(78375,'enUS','Pin them down! Let none of them pass!','',26124),
(78376,'enUS','Fall back to the sanctum, Lord Bathiel\'s ritual must not be disturbed! Thruk, do not let them past!','',26124),
(78377,'enUS','Thruk want Guardian treasure!','',26124),
(78378,'enUS','Nooooooooooooooooooooooooooo!','Nooooooooooooooooooooooooooo!',26124),
(78379,'enUS','Iron Hordies win. Get this off me and we are outta here! Abandon village!','',26124),
(78380,'enUS','','Oh please, you must save the others before Domina sacrifices them!',26124),
(78381,'enUS','Follow me when you are ready.','',26124),
(78382,'enUS','Over hee hee here. Over hee hee here.','',26124),
(78383,'enUS','Hrahahhahahehehheeheheheee... This way.','',26124),
(78384,'enUS','Artifacts from the greatest age belong to us! You have no claim to them!','',26124),
(78385,'enUS','No... the prism...','',26124),
(78386,'enUS','Bah! I loathe caves; I can barely see a thing down here.','',26124),
(78387,'enUS','Agreed. And it reeks of the low races.','',26124),
(78388,'enUS','Slaves who try to escape go one place.','',26124),
(78389,'enUS','Please no! I won\'t try to escape again!','Please no! I won\'t try to escape again!',26124),
(78390,'enUS','I\'m your worst nightmare...','',26124),
(78391,'enUS','','Gah! He tried to stab me! I told you we couldn\'t trust the Laughing Skulls.',26124),
(78392,'enUS','Limbflayer forgot to be nice. I saw pretty orc. I wanted to see if she could dance. Sorry. Sorry.','',26124),
(78393,'enUS','I have come to hunt the Iron Horde. I could destroy what remains of your ruined village, or perhaps we could assist one another.','',26124),
(78394,'enUS','Yes, wolves and skulls need each other. You need to know where the big Iron Hordy weapon is at. We need your $p.','',26124),
(78395,'enUS','Defend the Kraul with your life!','',26124),
(78396,'enUS','You have proven yourself loyal to my clan. Capable of great things.','',26124),
(78397,'enUS','Our hold on Bladespire is tenuous, and some of my best warriors have raced off with my reckless brother.','',26124),
(78398,'enUS','I was impressed by your skill in our battle against Dorogg the Ruthless.','',26124),
(78399,'enUS','I would be honored if you continued to fight by our side.','',26124),
(78400,'enUS','','So, this is what they were after... Thank you for clearing the way.',26124),
(78401,'enUS','<The prism hums with energy. It could be salvaged, though the strange machine it once powered - perhaps a devastating weapon, or some kind of depraved torture device - looks to be completely ruined.>','',26124),
(78402,'enUS','Now just relax, $p. You and I are going to have a chat.','',26124),
(78403,'enUS','Destroy that wretched prism! We cannot risk it falling into their hands.','',26124),
(78404,'enUS','Aku\'mai, kill them all!','',26124),
(78405,'enUS','What precious treasures my murlocs have lured to me.','',26124),
(78406,'enUS','Arise, Aku\'mai, and feed!','',26124),
(78407,'enUS','Forgive my deception. I had to appeal to your sympathy in order to play you against Kairyx.','',26124),
(78408,'enUS','I half-expected him to vaporize you, but you dispatched him quite handily. An impressive display...','',26124),
(78409,'enUS','You did it. It\'s firing again!','',26124),
(78410,'enUS','I saw the blast. I SAW it. The scream of the elements as their combined essences were ripped asunder and turned into a weapon of destruction. Such a weapon must not exist!','',26124),
(78411,'enUS','The Laughing Skulls have agreed to help.','The Laughing Skulls have agreed to help.',26124),
(78412,'enUS','It has been a long time since I was in the presence of the Laughing Skull. I remember them being taller.','',26124),
(78413,'enUS','Everything is ready.','Everything is ready.',26124),
(78414,'enUS','Have you all of the things?','',26124),
(78415,'enUS','','The mighty Durotan descends from his mountain without an army. It would seem you have grown tired of living.',26124),
(78416,'enUS','Iron will, iron blood!','',26124),
(78417,'enUS','The Iron Horde will consume you.','',26124),
(78418,'enUS','Nothing can stop the Iron Horde!','',26124),
(78419,'enUS','I will CRUSH you!','',26124),
(78420,'enUS','Iron will, iron blood!','',26124),
(78421,'enUS','The Iron Horde will consume you.','',26124),
(78422,'enUS','Nothing can stop the Iron Horde!','',26124),
(78423,'enUS','Come, puny $r. Come and die!','',26124),
(78425,'enUS','Though... it was your decision to enter the mine that truly piqued my interest. Your desire to reveal the truth behind the attack.','',26124),
(78427,'enUS','<Cough> Need muddy water... up the hill... <Cough>','',26124),
(78428,'enUS','With dying breath... me hate you...','',26124),
(78429,'enUS','Wow... I still in shock.$b$bI was amazing.$b$bYou need my help or not? I\'m sure you do.','',26124),
(78430,'enUS','... wheel...','',26124),
(78431,'enUS','','Who dares interrupt my sacrifice?! Slay them!',26124),
(78432,'enUS','','My flesh will be claimed by the Old Gods...',26124),
(78433,'enUS','I was hoping you would make it to me. Now I get the pleasure of removing your heads!','',26124),
(78434,'enUS','I delayed you long enough... Aku\'mai will rise...','',26124),
(78435,'enUS','Thruk... want... Guardian... TREASURE!','',26124),
(78436,'enUS','Ahh, these will be worthy companions for the long journey home.','',26124),
(78437,'enUS','Perhaps we shall meet again, yes?','',26124),
(78438,'enUS','%s spits on the ground.','',26124),
(78439,'enUS','<ptah!> Good riddance.','',26124),
(78440,'enUS','Guess I\'d better find a way to make myself useful. Do you think a blind old warrior can still make a difference?','',26124),
(78441,'enUS','Remember, $p: the sun burns the flesh. Only in shadow will you find refuge.','',26124),
(78442,'enUS','You\'ve won nothing, fools. Aku\'mai arises!','',26124),
(78443,'enUS','You are too late, heroes, the summoning of Aku\'mai is complete.','',26124),
(78444,'enUS','Unfortunately, you will not live long enough to behold his glory. Finish them!','',26124),
(78445,'enUS','Before I kill you know this, heroes. Aku\'mai will devour this world!','',26124),
(78446,'enUS','You are unworthy of being devoured by Aku\'mai. Instead, our sacrifices shall tear the flesh from your bones.','',26124),
(78447,'enUS','Our herald, Aku\'mai, arises from the depths. You have earned the honor of being the first he devours.','',26124),
(78448,'enUS','Mushlump play with squishy-squishy!','',26124),
(78449,'enUS','You give Mushlump owie...','',26124),
(78450,'enUS','Splat!','',26124),
(78451,'enUS','Crunch!','',26124),
(78452,'enUS','Playtime over for you!','',26124),
(78455,'enUS','Ha! This catch be too puny.','',26124),
(78456,'enUS','Thruk is hooked on you!','',26124),
(78457,'enUS','This catch be too ugly to eat.','',26124),
(78458,'enUS','Ramtusk has fallen! We must protect the Crone!','',26124),
(78459,'enUS','The Prophet will kneel before us...','',26124),
(78460,'enUS','Commander Vorka will lead us to victory...','',26124),
(78461,'enUS','More of my kind await... in... Grommar....','',26124),
(78462,'enUS','We will unite the clans, and slay all who oppose us...','',26124),
(78463,'enUS','No more! Please, I beg you! Don\'t kill me! I surrender!','',26124),
(78464,'enUS','I will block the temple against any more damage.','',26124),
(78465,'enUS','Go, $n. I will hold the temple gates!','',26124),
(78466,'enUS','Mok\'luk smash!','',26124),
(78467,'enUS','Me flatten you punies!','',26124),
(78468,'enUS','SMASH SMASH SMASH!','',26124),
(78469,'enUS','Catch this you puny!','',26124),
(78470,'enUS','Haha puny got smashed!','',26124),
(78471,'enUS','Puny been smashed!','',26124),
(78472,'enUS','Smash everything!','',26124),
(78473,'enUS','Me... get... smashed?','',26124),
(78474,'enUS','Slaves no work, slaves get SMASHED!','',26124),
(78476,'enUS','Eek eeper eek!','',26124),
(78477,'enUS','Squeaken eep!','',26124),
(78478,'enUS','Squeakity squeak!','',26124),
(78479,'enUS','Squeaker eek squeak!','',26124),
(78480,'enUS','Eeper squeak!','',26124),
(78481,'enUS','Soon Amnennar will return!','',26124),
(78482,'enUS','Our conquest of Kalimdor begins and nothing will survive our wrath!','',26124),
(78484,'enUS','You make better firewood than miner!','',26124),
(78485,'enUS','AHHHHHHHHHHHHHHHHHHHHHHHHHH!','AHHHHHHHHHHHHHHHHHHHHHHHHHH!',26124),
(78486,'enUS','','Please, help! We barely escaped the Twilight\'s Hammer sacrificial altar.',26124),
(78487,'enUS','Look out!','',26124),
(78488,'enUS','Rooter stares at you thoughtfully-then sneezes up a piece of ham.','',26124),
(78489,'enUS','Rooter wiggles his tail and drools; this would probably be cute if he wasn\'t farting and burping at the same time.','',26124),
(78490,'enUS','Pet Rooter?','Pet Rooter?',26124),
(78491,'enUS','Pet Rooter?','',26124),
(78492,'enUS','Augh! Noooooo...','',26124),
(78493,'enUS','I will be your shield!','',26124),
(78494,'enUS','My life for the flame!','',26124),
(78495,'enUS','Torch it all! For the glory of Rukhmar!','',26124),
(78496,'enUS','Purge these heathens!','',26124),
(78497,'enUS','WHAT? You said this base was secure!','',26124),
(78498,'enUS','I have a wide selection of slaves for sale. In fact, I just acquired a particularly feisty draenei female you may be interested in.','',26124),
(78499,'enUS','I\'m given to understand you\'re having some trouble with the... what do you call them? Dwarves? Nasty, small creatures. We have a few for sale if you\'re interested.','',26124),
(78500,'enUS','Iron Horde, iron dwarves... a perfect match. Purchase some. If nothing else, you can load them into your war machines and fire them back at their Bastion Rise.','',26124),
(78501,'enUS','The Imperion Slavers\' Guild is always interested in cultivating relationships with our good friends the Iron Horde. For you, my deepest discounts and best slaves.','',26124),
(78502,'enUS','We could not help but notice your \"prototype\" war machine. No doubt, Bastion Rise will be no more very soon. We are happy to call the Iron Horde our friends.','',26124),
(78503,'enUS','So soon? What happened to the last batch of slaves we sold you just yesterday? No matter. There are more. There are always more.','',26124),
(78504,'enUS','First the Laughing Skull are wiped out and soon these tiny dwarves at Bastion Rise. The Iron Horde are truly gifted where the waging of war is concerned.','',26124),
(78505,'enUS','You are by far the best customers I have ever had the pleasure of dealing with. Would you like to open a line of credit, or do you prefer to pay in black rock again? Gold perhaps?','',26124),
(78506,'enUS','I have a wide selection of slaves for sale. In fact, I just acquired a particularly dangerous blademaster you may be interested in. He\'s very deadly and would make an excellent warrior.','',26124),
(78507,'enUS','I\'m given to understand your troubles with the Laughing Skull clan are at an end. We have a few survivors for sale if you\'re interested.','',26124),
(78508,'enUS','No doubt, the Iron Horde will want to purchase our remaining Laughing Skulls. If nothing else, you can load them into your war machines and fire them for target practice.','',26124),
(78509,'enUS','The Imperion Slavers\' Guild is always interested in cultivating relationships with our good friends the Iron Horde. For you, my deepest discounts and best slaves.','',26124),
(78510,'enUS','We could not help but notice your \"prototype\" war machine. The destruction of the Laughing Skull village was quite impressive. We are happy to call the Iron Horde our friends.','',26124),
(78511,'enUS','So soon? What happened to the last batch of slaves we sold you just yesterday? No matter. There are more. There are always more.','',26124),
(78512,'enUS','First the Laughing Skull are wiped out and soon these tiny dwarves at Bastion Rise. The Iron Horde are truly gifted where the waging of war is concerned.','',26124),
(78513,'enUS','You are by far the best customers I have ever had the pleasure of dealing with. Would you like to open a line of credit, or do you prefer to pay in black rock again? Gold perhaps?','',26124),
(78514,'enUS','More slaves!','',26124),
(78515,'enUS','We have much black rock to buy slaves with!','',26124),
(78516,'enUS','Your slaves die quickly. We want better slaves, ogre!','',26124),
(78517,'enUS','You talk too much. Less talk, more slaves!','',26124),
(78518,'enUS','Maybe we will fire the Goliath prototype at your slave pen?!','',26124),
(78519,'enUS','Your slaves cost too much already and die far too quickly!','',26124),
(78520,'enUS','All will feel the might of the Iron Horde. Even the ogres, if your slaves do not improve!','',26124),
(78521,'enUS','Your slaves are all dead! Why would I buy more?','',26124),
(78522,'enUS','I\'m certain we can come to a mutually beneficial arrangement.','',26124),
(78523,'enUS','Of course, of course, my friend. No worries.','',26124),
(78524,'enUS','No need to be upset, my friend. We will make sure you receive only the toughest slaves.','',26124),
(78525,'enUS','Of course, you are quite right, my capable orc friend. Quite right.','',26124),
(78526,'enUS','I shall redouble my efforts to address all of your concerns.','',26124),
(78527,'enUS','Iron will, iron blood!','Iron will, iron blood!',26124),
(78528,'enUS','The Iron Tide will consume you!','The Iron Tide will consume you!',26124),
(78529,'enUS','The slavers\' guild is only too happy to meet your needs.','',26124),
(78530,'enUS','Intruders!','Intruders!',26124),
(78531,'enUS','I couldn\'t agree more. Just let me know when you\'d like to come see our wares.','',26124),
(78532,'enUS','No need for ire. You and I are friends. We respect the might of the Iron Horde.','',26124),
(78533,'enUS','I lapped a clefthoof the other day. Hrah ha ha.','I lapped a clefthoof the other day. Hrah ha ha.',26124),
(78534,'enUS','You ever fix that lame wheel of yours?','You ever fix that lame wheel of yours?',26124),
(78535,'enUS','How fast you get that thing going? Outrun any farah yet?','How fast you get that thing going? Outrun any farah yet?',26124),
(78536,'enUS','That\'s because the beast was standing still.','That\'s because the beast was standing still.',26124),
(78537,'enUS','You ever fix that lame face of yours?','You ever fix that lame face of yours?',26124),
(78538,'enUS','At least I got it to start, which is more than you can claim.','At least I got it to start, which is more than you can claim.',26124),
(78539,'enUS','What is the meaning of this?! I am an official of the Imperion Slavers\' Guild!','',26124),
(78540,'enUS','','Thank you brave heroes.  Without your help Amnennar would have returned to Azeroth and brought untold horrors with him.$b$bI will return this dangerous artifact to my brothers and sisters of the red dragonflight.  Perhaps we can find a way to destroy it.$b$bI am in your debt.',26124),
(78541,'enUS','<This Iron Horde scouting party appears to have been incinerated in the arakkoa attack on Aruuna.>','',26124),
(78542,'enUS','Search the body.','Search the body.',26124),
(78543,'enUS','Hold steady, damned beast!','',26124),
(78544,'enUS','Subdue it already, you worthless excuses for orcs!','',26124),
(78545,'enUS','We need this thing to pull the cannon out. Faster!','',26124),
(78546,'enUS','Your bones will be added to this pile!  Burn!','',26124),
(78547,'enUS','Too hot for you?','',26124),
(78548,'enUS','Another soldier for Amnennar\'s army.','',26124),
(78549,'enUS','You\'ll dance with the rest!','',26124),
(78550,'enUS','Death is only the beginning!','Death is only the beginning!',26124),
(78551,'enUS','Savor your death, mortal. The Dark Star beckons!','Savor your death, mortal. The Dark Star beckons!',26124),
(78552,'enUS','My life for Ner\'zhul!','My life for Ner\'zhul!',26124),
(78553,'enUS','More souls for the taking!','More souls for the taking!',26124),
(78554,'enUS','','Maintain... focus...',26124),
(78555,'enUS','','Focus your power...',26124),
(78556,'enUS','','It is... too... strong...',26124),
(78557,'enUS','Hah! |5$pr from the other world? Throm-Ka, $pc! Ahahahahahahaha!','',26124),
(78558,'enUS','','The stones did not tell of this!',26124),
(78560,'enUS','Iron will, iron blood!','',26124),
(78561,'enUS','No one touches Bertha!','',26124),
(78562,'enUS','Get away from my girl!','',26124),
(78563,'enUS','No one looks at my roller like that! No one!','',26124),
(78564,'enUS','Burry me... with.. my Bertha...','',26124),
(78565,'enUS','I will still serve in death!','I will still serve in death!',26124),
(78566,'enUS','I have been chosen!','I have been chosen!',26124),
(78568,'enUS','I return to the earth...','',26124),
(78569,'enUS','Yes! My flesh is for Aku\'mai!','Yes! My flesh is for Aku\'mai!',26124),
(78570,'enUS','Ugg... we kill you all for this...','',26124),
(78572,'enUS','|cFFF00000Slagna|r rises from the lava!','',26124),
(78573,'enUS','%s spits blood.','',26124),
(78574,'enUS','','Fan out! Leave nothing alive!',26124),
(78575,'enUS','','Let\'s do this!',26124),
(78576,'enUS','','Woohoo! We did it! That was so cool!',26124),
(78577,'enUS','','I\'m going to go back to my father. I\'ll meet you there!',26124),
(78578,'enUS','','By the Light... they\'re slaughtering everything!',26124),
(78579,'enUS','A shadow is growing beneath the spires...','',26124),
(78580,'enUS','Iskar will guide us to freedom.','',26124),
(78581,'enUS','I shall not forget this.','',26124),
(78582,'enUS','We can hide from them no longer.','',26124),
(78583,'enUS','Live to fight another day? Don\'t mind if I do.','',26124),
(78584,'enUS','Bank','Bank',26124),
(78585,'enUS','','I think I can shut this thing off. Just give me a minute!',26124),
(78587,'enUS','You be lookin\' for de bank mon?  You be followin\' the road to de north all de way to Orgrimmar.  Speak to de guards there and they can help ya.','You be lookin\' for de bank mon?  You be followin\' the road to de north all de way to Orgrimmar.  Speak to de guards there and they can help ya.',26124),
(78588,'enUS','Ya be a long way off mon.  De bank be in Orgrmmar.  Follow de road to de north, ya can\'t miss de place.','Ya be a long way off mon.  De bank be in Orgrmmar.  Follow de road to de north, ya can\'t miss de place.',26124),
(78589,'enUS','Lookin\' for a ride eh?  Burok be at the southern end of town, next to de wind riders.','Lookin\' for a ride eh?  Burok be at the southern end of town, next to de wind riders.',26124),
(78590,'enUS','De inn be just north of de road leading to de Barrens.  Grosk be helpin\' ya out.','De inn be just north of de road leading to de Barrens.  Grosk be helpin\' ya out.',26124),
(78591,'enUS','Havin\' some furry friends needin\' a place to stay? Shoja\'my, outside of de inn, can help.','Havin\' some furry friends needin\' a place to stay? Shoja\'my, outside of de inn, can help.',26124),
(78592,'enUS','You be needin\' to see a trainer, mon?','You be needin\' to see a trainer, mon?',26124),
(78593,'enUS','Jabul, can help you.  He\'s been givin\' new druids trainin\' for years now.','Jabul, can help you.  He\'s been givin\' new druids trainin\' for years now.',26124),
(78594,'enUS','The Hunter Trainer\'s name is Thotar.  Seek him out inside the burrow on the southwest corner of Razor Hill.','The Hunter Trainer\'s name is Thotar.  Seek him out inside the burrow on the southwest corner of Razor Hill.',26124),
(78595,'enUS','Ah, ya be after de mojo, eh?  Un\'Thuwa can teach you.  Ya be findin\' him near the entrance to the barracks.','Ah, ya be after de mojo, eh?  Un\'Thuwa can teach you.  Ya be findin\' him near the entrance to the barracks.',26124),
(78596,'enUS','Ya be lookin\' for Tai\'jin then. She be spendin\' most of her time in de barracks.','Ya be lookin\' for Tai\'jin then. She be spendin\' most of her time in de barracks.',26124),
(78597,'enUS','Kaplak be da orc you be lookin\' for mon.  He be in de burrow south of da inn.','Kaplak be da orc you be lookin\' for mon.  He be in de burrow south of da inn.',26124),
(78598,'enUS','Swart be communin\' wit de elements inside of da barracks.  It be de large building in de center of town.','Swart be communin\' wit de elements inside of da barracks.  It be de large building in de center of town.',26124),
(78599,'enUS','Lookin\' for Dhugru Gorelust eh?  He be practicin\' his craft behind de barracks.','Lookin\' for Dhugru Gorelust eh?  He be practicin\' his craft behind de barracks.',26124),
(78600,'enUS','You be messin\' with some bad mojo mon, but Dhugru be behind de barracks.','You be messin\' with some bad mojo mon, but Dhugru be behind de barracks.',26124),
(78601,'enUS','De warrior trainer, Tarshaw Jaggedscar, be inside de barracks on de east side of town.','De warrior trainer, Tarshaw Jaggedscar, be inside de barracks on de east side of town.',26124),
(78602,'enUS','Runda be de one person you be needin\' to talk to.\n\nShe be just north of de barracks entrance.','Runda be de one person you be needin\' to talk to.\n\nShe be just north of de barracks entrance.',26124),
(78603,'enUS','Hammer and tongs, beat to this song...s, stoke the fire higher.','',26124),
(78604,'enUS','What cha be lookin\' for mon?','What cha be lookin\' for mon?',26124),
(78605,'enUS','Bring down, the hammer ...um... frown, and make the sparks fly higher.','',26124),
(78606,'enUS','Smelly smelting, smelly smelting, no air must be in the iron.','',26124),
(78607,'enUS','Hey! You are not supposed to be in here!','',26124),
(78608,'enUS','This is MY foundry!','',26124),
(78609,'enUS','Who dares interrupt my smelting!','',26124),
(78610,'enUS','Lookin\' for Kaplak eh?  Ya be keepin\' your eyes on your coin if ya visit with dat one.','Lookin\' for Kaplak eh?  Ya be keepin\' your eyes on your coin if ya visit with dat one.',26124),
(78612,'enUS','Your land will succumb to the Iron Tide.','',26124),
(78613,'enUS','The nearest bank is in Orgrimmar.  Follow the road north and you cannot miss the big gates leading to the city.','The nearest bank is in Orgrimmar.  Follow the road north and you cannot miss the big gates leading to the city.',26124),
(78614,'enUS','','We did it! Hopefully we can clean the water quickly so we can regrow the crops!',26124),
(78615,'enUS','Burok can be found near the wind riders on the southern end of town.  He can take you where you need to go.','Burok can be found near the wind riders on the southern end of town.  He can take you where you need to go.',26124),
(78616,'enUS','Grosk and his inn can be found in the northwest corner of Razor Hill.','Grosk and his inn can be found in the northwest corner of Razor Hill.',26124),
(78617,'enUS','Shoja\'my is the one you are looking for.  He is just outside of the inn.','Shoja\'my is the one you are looking for.  He is just outside of the inn.',26124),
(78618,'enUS','Which trainer do you seek?','Which trainer do you seek?',26124),
(78619,'enUS','Jabul has trained many, perhaps he can help you too.','Jabul has trained many, perhaps he can help you too.',26124),
(78620,'enUS','You seek bigger game?  Perhaps Thotar can teach you what you need to know.  He can be found inside the burrow on the southwest corner of Razor Hill.','You seek bigger game?  Perhaps Thotar can teach you what you need to know.  He can be found inside the burrow on the southwest corner of Razor Hill.',26124),
(78621,'enUS','You seek knowledge of the powers of magic.  There are many things Un\'Thuwa can teach you.  Find him just north of the entrance to Razor Hill\'s barracks.','You seek knowledge of the powers of magic.  There are many things Un\'Thuwa can teach you.  Find him just north of the entrance to Razor Hill\'s barracks.',26124),
(78622,'enUS','Tai\'jin can be found inside the barracks, the largest building in town.','Tai\'jin can be found inside the barracks, the largest building in town.',26124),
(78623,'enUS','You seek Kaplak.  He can be found in the burrow in the southwest area of Razor Hill.  Do not take your eyes off of that one for a second.','You seek Kaplak.  He can be found in the burrow in the southwest area of Razor Hill.  Do not take your eyes off of that one for a second.',26124),
(78624,'enUS','Swart is inside the barracks, on the east side of Razor Hill.','Swart is inside the barracks, on the east side of Razor Hill.',26124),
(78625,'enUS','Dhugru Gorelust hides behind the barraks on the east side of town practicing his craft.','Dhugru Gorelust hides behind the barraks on the east side of town practicing his craft.',26124),
(78626,'enUS','If it is sparring lessons you are looking for Tarshaw Jaggedscar can be found in the barracks on the east side of town.','If it is sparring lessons you are looking for Tarshaw Jaggedscar can be found in the barracks on the east side of town.',26124),
(78627,'enUS','Earth Mother watch over you traveler, what is it you seek?','Earth Mother watch over you traveler, what is it you seek?',26124),
(78628,'enUS','Look for Runda.\n\nShe\'s usually just north of the barracks entrance.','Look for Runda.\n\nShe\'s usually just north of the barracks entrance.',26124),
(78629,'enUS','','Almost done. Hold on!',26124),
(78630,'enUS','Stop them! Make them slaves!','',26124),
(78631,'enUS','Iron will, iron blood!','',26124),
(78632,'enUS','Death is your only option.','',26124),
(78633,'enUS','Oh yah! Come ta papa, ya scummy orc bastich!','',26124),
(78634,'enUS','Curse you, dwarf!','',26124),
(78635,'enUS','Somebody, come quickly! Please!','',26124),
(78636,'enUS','May the birds of Gorgrond feast on your bones!','',26124),
(78637,'enUS','The ogre will have chains and manacles you can secure him with. Poetic when you think about it.','',26124),
(78638,'enUS','','You\'ll die for those refugees, fool.',26124),
(78639,'enUS','Grrowl!','',26124),
(78640,'enUS','Seek the shadows -- someone approaches.','',26124),
(78641,'enUS','The plague mists barring Koristrasza\'s passage begin to dissipate.','',26124),
(78642,'enUS','It\'s not safe, Skreek! Get back in your cage before they see you!','',26124),
(78643,'enUS','Our reinforcements should be here soon. Get moving!','',26124),
(78644,'enUS','I want a report on the draenei movements every half hour.','',26124),
(78645,'enUS','We will slaughter every last one of them. Blood will run.','',26124),
(78646,'enUS','4...','',26124),
(78647,'enUS','3...','',26124),
(78648,'enUS','1...','',26124),
(78649,'enUS','GO!','',26124),
(78650,'enUS','Get ready to race!','',26124),
(78651,'enUS','First the iron horde destroyed Tuurem, now podlings are here. Will it ever end?','First the iron horde destroyed Tuurem, now podlings are here. Will it ever end?',26124),
(78652,'enUS','2...','',26124),
(78653,'enUS','We will have water soon, friends. I will not fail you again.','',26124),
(78654,'enUS','','Thank you, $p. Feeding all of these people is hard work!',26124),
(78655,'enUS','Please hurry. I don\'t know what I would do if something happened to her.','',26124),
(78656,'enUS','','blah blah blah',26124),
(78657,'enUS','There is a draenei female back at our slave pens. We captured her yesterday. Perhaps you would trade my life for hers?','',26124),
(78658,'enUS','You got the drop on me, $r. Next time, you won\'t be so lucky.','',26124),
(78659,'enUS','The iron horde followed us here! What do we do now?','The iron horde followed us here! What do we do now?',26124),
(78660,'enUS','I\'ll take care of him, $n. The others were asking after you.','',26124),
(78661,'enUS','An eternity in darkness... cannot... escape...','An eternity in darkness... cannot... escape...',26124),
(78662,'enUS','Ner\'zhul will not hear us, he hears only darkness now.','Ner\'zhul will not hear us, he hears only darkness now.',26124),
(78663,'enUS','You wade through a river of souls, stranger. It\'s best to turn back.','You wade through a river of souls, stranger. It\'s best to turn back.',26124),
(78664,'enUS','This was once a place of peace. A place for eternal rest...','This was once a place of peace. A place for eternal rest...',26124),
(78665,'enUS','Leave this place, outsider. It will be your final resting place.','Leave this place, outsider. It will be your final resting place.',26124),
(78666,'enUS','I know ya can understand me! I WANT MY WIFE BACK!','',26124),
(78667,'enUS','Thank ye fer the help, $p. I\'ll meet ya back at the camp.','',26124),
(78670,'enUS','I\'ll meet ya o\'er there. We\'ll make that orc sing!','',26124),
(78671,'enUS','I hope it\'s okay me asking you to do this. If you get me these things, we\'ll be able to destroy that monstrosity.','',26124),
(78672,'enUS','May the Naaru protect us from the terrors that follow us across the universe.','May the Naaru protect us from the terrors that follow us across the universe.',26124),
(78673,'enUS','Be careful, $r! The podlings are attacking!','Be careful, $r! The podlings are attacking!',26124),
(78674,'enUS','Where\'s Malkorok?!','',26124),
(78675,'enUS','Talk! Tell me where yer bosses are!','',26124),
(78676,'enUS','I know ye were part o\' it! Yer gonna pay fer what ye did to me Elsa, orc!','',26124),
(78677,'enUS','The Goliath Cannon will...','',26124),
(78678,'enUS','','Mother Kashur once told us the story of the great colossus: Gorgrond.$b$bIt was the largest beast to ever walk the world, and when it fell, its body became the land, its spine the mountains, its blood the ore, and its will the savagery that rules this place.$b$bIt may have only been a fireside tale, but I can see how this story was inspired.',26124),
(78679,'enUS','If we are to defeat the Iron Horde, we will need power beyond that which we possess. It is my hope that this land will reveal answers we had not thought of yet.','',26124),
(78680,'enUS','I know some of these orcs. We must proceed with caution. If they discover me we will have more Iron Horde on us than even we can handle.','',26124),
(78681,'enUS','Antur, I still remember the day you were born. May your spirit go with peace.','Antur, I still remember the day you were born. May your spirit go with peace.',26124),
(78682,'enUS','Sartuu loved this world so much. Old friend, walk with the spirits, now.','Sartuu loved this world so much. Old friend, walk with the spirits, now.',26124),
(78683,'enUS','Ralkura never knew his parents. He has led a hard life. Let his spirit find peace in the halls of Auchindoun.','Ralkura never knew his parents. He has led a hard life. Let his spirit find peace in the halls of Auchindoun.',26124),
(78684,'enUS','Zaanve was always a rascal. He loved to play jokes on his friends. You will be remembered, friend.','Zaanve was always a rascal. He loved to play jokes on his friends. You will be remembered, friend.',26124),
(78685,'enUS','Ah, Thamuun. For twenty years, he hid his love for a woman named Thalia. He never found the courage to tell her.','Ah, Thamuun. For twenty years, he hid his love for a woman named Thalia. He never found the courage to tell her.',26124),
(78686,'enUS','He\'s jus\' one in a long line o\' orcs I intend ta \"question\".','',26124),
(78687,'enUS','Okay, $n, I\'ve got it reprogrammed. All you have to do is push the plunger. EVERYONE BRACE YOURSELVES!','',26124),
(78688,'enUS','Racers ahead of you: 0. You\'re winning!','',26124),
(78689,'enUS','Racers ahead of you: 1','',26124),
(78690,'enUS','Racers ahead of you: 2','',26124),
(78691,'enUS','Racers ahead of you: 3','',26124),
(78692,'enUS','Racers ahead of you: 4','',26124),
(78693,'enUS','Racers ahead of you: 5','',26124),
(78694,'enUS','Racers ahead of you: more than 5','',26124),
(78695,'enUS','I will take care of the rest here, champion. Return to Akama and see what else needs to be done.','I will take care of the rest here, champion. Return to Akama and see what else needs to be done.',26124),
(78696,'enUS','Lady Giana, who took up the paladin\'s charge. May your spirit go with peace.','Lady Giana, who took up the paladin\'s charge. May your spirit go with peace.',26124),
(78697,'enUS','Cheerful Shalu. Her laugh could be heard echoing around the halls of the Temple. You bring joy to the spirits, now.','Cheerful Shalu. Her laugh could be heard echoing around the halls of the Temple. You bring joy to the spirits, now.',26124),
(78698,'enUS','Markeet\'s brothers once bet her that she couldn\'t lift an elekk. They did her chores for a week after. Walk with the Light, my child.','Markeet\'s brothers once bet her that she couldn\'t lift an elekk. They did her chores for a week after. Walk with the Light, my child.',26124),
(78699,'enUS','Many saw Enaka shield her comrades with her own body when the wall fell. Your deeds will be honored, sister.','Many saw Enaka shield her comrades with her own body when the wall fell. Your deeds will be honored, sister.',26124),
(78700,'enUS','Brave Kaati. It is said that she feared nothing. She leaves behind two young children.','Brave Kaati. It is said that she feared nothing. She leaves behind two young children.',26124),
(78701,'enUS','Aphuun, your parents will be proud of your courage. May your spirit go with peace.','Aphuun, your parents will be proud of your courage. May your spirit go with peace.',26124),
(78702,'enUS','Raknur was as skilled with a hammer as he was with a paintbrush. May your spirit go with peace.','Raknur was as skilled with a hammer as he was with a paintbrush. May your spirit go with peace.',26124),
(78703,'enUS','Maarkus, you always greeted me with a bright smile. May your spirit go with peace.','Maarkus, you always greeted me with a bright smile. May your spirit go with peace.',26124),
(78704,'enUS','Harvu, you earned your initiation into the vindicators only a moon ago. May your spirit go with peace.','Harvu, you earned your initiation into the vindicators only a moon ago. May your spirit go with peace.',26124),
(78705,'enUS','Rakmun, son of Arva. As a young child, you used to beg me for candy. May your spirit go with peace.','Rakmun, son of Arva. As a young child, you used to beg me for candy. May your spirit go with peace.',26124),
(78708,'enUS','Jarool was the only son of my former apprentice, Neerva. He inherited his mother\'s boldness. Walk with the spirits, child.','Jarool was the only son of my former apprentice, Neerva. He inherited his mother\'s boldness. Walk with the spirits, child.',26124),
(78709,'enUS','Umaat wished to someday become a teacher. We will remember you always. Walk with the spirits, now.','Umaat wished to someday become a teacher. We will remember you always. Walk with the spirits, now.',26124),
(78710,'enUS','Thakuur showed early signs of prophetic talent. Your passing is a great loss. Rest now, my brother.','Thakuur showed early signs of prophetic talent. Your passing is a great loss. Rest now, my brother.',26124),
(78711,'enUS','Kamuur joined the city\'s defenses against his mother\'s wishes. You served us proudly, brother. Now be at peace.','Kamuur joined the city\'s defenses against his mother\'s wishes. You served us proudly, brother. Now be at peace.',26124),
(78712,'enUS','Baruud helped build the walls of Karabor, which still stand today thanks to him. Walk with the spirits, now.','Baruud helped build the walls of Karabor, which still stand today thanks to him. Walk with the spirits, now.',26124),
(78715,'enUS','Sanduur held the forward gate until reinforcements could arrive. Walk with the Light now, brother.','Sanduur held the forward gate until reinforcements could arrive. Walk with the Light now, brother.',26124),
(78716,'enUS','Hemeer recently celebrated the arrival of his first son. They will know of your courage, brother. Walk with the Light.','Hemeer recently celebrated the arrival of his first son. They will know of your courage, brother. Walk with the Light.',26124),
(78717,'enUS','Gheeda joined the Vindicators to follow in his father\'s footsteps. Now, let your spirits be joined in Auchindoun.','Gheeda joined the Vindicators to follow in his father\'s footsteps. Now, let your spirits be joined in Auchindoun.',26124),
(78718,'enUS','The Temple will be too quiet now without the sound of your voice, Barada. Walk with the Light, brother.','The Temple will be too quiet now without the sound of your voice, Barada. Walk with the Light, brother.',26124),
(78719,'enUS','Armoot has six brothers, all of whom serve proudly in Karabor\'s guard. They will honor your deeds, brother.','Armoot has six brothers, all of whom serve proudly in Karabor\'s guard. They will honor your deeds, brother.',26124),
(78722,'enUS','Timoor, quiet and shy. You fought bravely. Your deeds shall be remembered, child.','Timoor, quiet and shy. You fought bravely. Your deeds shall be remembered, child.',26124),
(78723,'enUS','Anmet was born on a farm in Talador. He took up the paladin\'s hammer in his elder years to defend our city. Your courage shall be honored.','Anmet was born on a farm in Talador. He took up the paladin\'s hammer in his elder years to defend our city. Your courage shall be honored.',26124),
(78724,'enUS','Merool was the last of his bloodline. He never married nor had children. Your name will be remembered with honor, warrior.','Merool was the last of his bloodline. He never married nor had children. Your name will be remembered with honor, warrior.',26124),
(78725,'enUS','Veraan\'s spirit was gentle, but his hammer struck fiercely today. Walk with the Light, brother.','Veraan\'s spirit was gentle, but his hammer struck fiercely today. Walk with the Light, brother.',26124),
(78726,'enUS','Judging from his wounds, it took ten Iron Horde to take Inavu down. Your deeds shall be honored, friend.','Judging from his wounds, it took ten Iron Horde to take Inavu down. Your deeds shall be honored, friend.',26124),
(78727,'enUS','Maani, youngest of her family. She wished to someday travel across all of Draenor. Travel now with the Light, child.','Maani, youngest of her family. She wished to someday travel across all of Draenor. Travel now with the Light, child.',26124),
(78728,'enUS','Hareeni, I blessed you on the day that you were born. Brave in life, brave in death. Go in peace, now.','Hareeni, I blessed you on the day that you were born. Brave in life, brave in death. Go in peace, now.',26124),
(78729,'enUS','Amuura, twin of Faari. May your spirit go peacefully.','Amuura, twin of Faari. May your spirit go peacefully.',26124),
(78730,'enUS','Brea, youngest amongst the acolytes. Your courage cannot be denied. May your spirit go with peace.','Brea, youngest amongst the acolytes. Your courage cannot be denied. May your spirit go with peace.',26124),
(78731,'enUS','Farvi, favorite of the younger children. They will remember your stories. May your spirit go with peace.','Farvi, favorite of the younger children. They will remember your stories. May your spirit go with peace.',26124),
(78732,'enUS','Yrvaa, your sons shall know their mother\'s courage in her final hour. Walk with the spirits, now.','Yrvaa, your sons shall know their mother\'s courage in her final hour. Walk with the spirits, now.',26124),
(78733,'enUS','Kevana, artist of the written word. Your stories will live on in the great library at Shattrath. Walk with the spirits, now.','Kevana, artist of the written word. Your stories will live on in the great library at Shattrath. Walk with the spirits, now.',26124),
(78734,'enUS','Ruidan, skilled in the healing arts. Her passing is a great loss to us. Walk with the spirits, now.','Ruidan, skilled in the healing arts. Her passing is a great loss to us. Walk with the spirits, now.',26124),
(78735,'enUS','Feraan, lover of music. She used to sing me songs as a young child. Walk with the spirits, child.','Feraan, lover of music. She used to sing me songs as a young child. Walk with the spirits, child.',26124),
(78736,'enUS','Jeluuna, your passing is a great loss to us. Walk with the spirits, now.','Jeluuna, your passing is a great loss to us. Walk with the spirits, now.',26124),
(78737,'enUS','Unaa, swift of hoof. She could run from one end of the Valley to the other before sunset. Now, you run with the champions of Auchindoun.','Unaa, swift of hoof. She could run from one end of the Valley to the other before sunset. Now, you run with the champions of Auchindoun.',26124),
(78738,'enUS','Tavala, bright and talkative. Walk with the Light.','Tavala, bright and talkative. Walk with the Light.',26124),
(78739,'enUS','Safta and her husband both fought in the battle. Such courage in a pair so young. You walk with the Light now.','Safta and her husband both fought in the battle. Such courage in a pair so young. You walk with the Light now.',26124),
(78740,'enUS','Ranha, none could match your skill with the bow and arrow. Your aim was true to the end. Walk with the Light, brave one.','Ranha, none could match your skill with the bow and arrow. Your aim was true to the end. Walk with the Light, brave one.',26124),
(78741,'enUS','Navine is one of the many Anchorites who stayed near the frontlines. Her courage saved many lives today. Walk with the Light, brave one.','Navine is one of the many Anchorites who stayed near the frontlines. Her courage saved many lives today. Walk with the Light, brave one.',26124),
(78742,'enUS','Chuume, I will see that your sons grow into fine young men. Your deeds will be honored, sister.','Chuume, I will see that your sons grow into fine young men. Your deeds will be honored, sister.',26124),
(78743,'enUS','Olanna took up the hammer after her family was killed in an Iron Horde raid. Let your spirit be at peace now.','Olanna took up the hammer after her family was killed in an Iron Horde raid. Let your spirit be at peace now.',26124),
(78744,'enUS','Avette led teams to disable numerous Iron Horde siege weapons. Your deeds will be honored, sister.','Avette led teams to disable numerous Iron Horde siege weapons. Your deeds will be honored, sister.',26124),
(78745,'enUS','Sifting','Sifting',26124),
(78746,'enUS','Eluuvi joined the Vindicators with her two best friends from childhood. They will honor your deeds, child.','Eluuvi joined the Vindicators with her two best friends from childhood. They will honor your deeds, child.',26124),
(78747,'enUS','Help me, you savages!','',26124),
(78748,'enUS','To me, Iron Tide!','',26124),
(78749,'enUS','Help me!','',26124),
(78750,'enUS','Oh yeah! Burn \'em all!','',26124),
(78751,'enUS','','Help me!',26124),
(78752,'enUS','After Daami\'s husband died of fever, she developed cures for many diseases. Your deeds will be honored, sister.','After Daami\'s husband died of fever, she developed cures for many diseases. Your deeds will be honored, sister.',26124),
(78753,'enUS','Kinna was always one to speak her mind. I\'m sure she cursed the Iron Horde as fiercely as she fought them. Be one with the Light now.','Kinna was always one to speak her mind. I\'m sure she cursed the Iron Horde as fiercely as she fought them. Be one with the Light now.',26124),
(78754,'enUS','Vaanta, your valor was an example to us all. Be one with the Light now.','Vaanta, your valor was an example to us all. Be one with the Light now.',26124),
(78755,'enUS','Basha treated everyone as dearly as family. Be one with the Light now, gentle one.','Basha treated everyone as dearly as family. Be one with the Light now, gentle one.',26124),
(78756,'enUS','Kippa\'s family commands our naval fleet. Be one with the Light now, child.','Kippa\'s family commands our naval fleet. Be one with the Light now, child.',26124),
(78757,'enUS','Freita\'s squadron broke the Iron Horde siege on the northern courtyard. We are honored by your courage.','Freita\'s squadron broke the Iron Horde siege on the northern courtyard. We are honored by your courage.',26124),
(78758,'enUS','In the chaos after the initial attack, Amyta rallied the draenei at the front wall. We are honored by your courage.','In the chaos after the initial attack, Amyta rallied the draenei at the front wall. We are honored by your courage.',26124),
(78759,'enUS','Kaveen led the first charge when the battle began. His fearlessness inspired courage in his comrades. Rest now.','Kaveen led the first charge when the battle began. His fearlessness inspired courage in his comrades. Rest now.',26124),
(78760,'enUS','Rahsteel trained many of the Vindicators on this field. Today, he led his students by example. Rest now, brother.','Rahsteel trained many of the Vindicators on this field. Today, he led his students by example. Rest now, brother.',26124),
(78761,'enUS','Teruum died with great valor. Be one with the Light now.','Teruum died with great valor. Be one with the Light now.',26124),
(78762,'enUS','Umaat joined Karabor\'s guard to protect his family. Be one with the Light now, brother.','Umaat joined Karabor\'s guard to protect his family. Be one with the Light now, brother.',26124),
(78763,'enUS','Gerood led the elekk cavalry. Be one with the Light now, champion.','Gerood led the elekk cavalry. Be one with the Light now, champion.',26124),
(78764,'enUS','Kinta led the charge onto the Iron March. Be one with the Light now, champion.','Kinta led the charge onto the Iron March. Be one with the Light now, champion.',26124),
(78765,'enUS','Life is the Light ... and the Light is Life itself. They may be exchanged, but nothing is ever lost.','Life is the Light ... and the Light is Life itself. They may be exchanged, but nothing is ever lost.',26124),
(78766,'enUS','< Hold him steady!>','',26124),
(78767,'enUS','< You\'re not going anywhere. >','',26124),
(78768,'enUS','< It\'s too strong! >','',26124),
(78769,'enUS','AHHHH!!!!','',26124),
(78770,'enUS','I don\'t know how much longer we can go on like this.$B$BMost of our harvest has come alive and started attacking my farmhands, and the little food we are able to gather isn\'t nearly enough to feed all of the refugees that have showed up from Tuurem.','',26124),
(78771,'enUS','','We did nothing to th-threaten the podlings... w-we were just guiding the last of the refugees into the farm...',26124),
(78772,'enUS','When Tuurem fell to the Iron Horde, I was in charge of its defense. We were more volunteers than an army, but I was still sworn to protect my home.$B$BThese displaced souls you see here are lost because of my failure. I only hope I do not let them down again.','',26124),
(78773,'enUS','','We make quite the team, don\'t you think?$B$BThat oil machine was no match for the dynamic duo - Illona and $n!',26124),
(78774,'enUS','Hurry, $n. We have to get to Yrel!','',26124),
(78775,'enUS','Those things are so poorly built. Anything you do is going to mess them up.','',26124),
(78776,'enUS','Now it\'s time to free my beloved. I won\'t lose her again! COME, WE\'RE LEAVING!','',26124),
(78777,'enUS','We\'re under attack!','',26124),
(78778,'enUS','Function Disabled. See Operation Manual Vol. X pp.1014-1034','Function Disabled. See Operation Manual Vol. X pp.1014-1034',26124),
(78779,'enUS','Uh oh. Pipe making noise.','',26124),
(78780,'enUS','It not supposed to whistle that much.','',26124),
(78781,'enUS','Why they build pipe here?','',26124),
(78782,'enUS','Who put valve there? Why they do that?','',26124),
(78783,'enUS','Lok\'tar? Or sleep? Maybe sleep.','',26124),
(78784,'enUS','I\'m glad that you\'re here, $n. We\'ve been through a lot together.','',26124),
(78785,'enUS','Yrel is alive! The filthy ogres have her at their slave camp.$B$BWe need to destroy this place and get to her!','',26124),
(78786,'enUS','Please, somebody help!','',26124),
(78787,'enUS','Augh! It burn!','',26124),
(78788,'enUS','Ow ow ow!','',26124),
(78789,'enUS','Help or I fall!','',26124),
(78790,'enUS','Bunch of meanies...','',26124),
(78791,'enUS','Fire hot hot hot!','',26124),
(78792,'enUS','','My love... is it over?',26124),
(78793,'enUS','Yes, you are safe. I will not leave your side.','',26124),
(78794,'enUS','Get back here!','',26124),
(78795,'enUS','You, over there! Please, all of the talbuk have escaped!','',26124),
(78796,'enUS','There are podlings everywhere! I\'ll get killed if I try to rescue them!','',26124),
(78797,'enUS','','The mighty Goc, son of Gruul, know that you now bow before Gro\'naka, gronnstalker of the Thunderlords!',26124),
(78798,'enUS','','I am sorry, but could you say that a little louder? I couldn\'t hear you over the sound of your chains.',26124),
(78799,'enUS','Your name is as insignificant to me as the names of the thousands who have died under the might of Goc.  I will crush you!','',26124),
(78800,'enUS','I\'ll help you find your friend as long as you promise not to kill me.','',26124),
(78801,'enUS','','Quiet, you fool!',26124),
(78802,'enUS','','Stop laughing. Are you trying to get us caught?',26124),
(78803,'enUS','','Stop touching me or I will break every bone in your hand.',26124),
(78804,'enUS','','Silence! Patrols are near.',26124),
(78805,'enUS','','Be silent! Do you want someone to hear you?',26124),
(78806,'enUS','','Enough giggling. Be quiet!',26124),
(78807,'enUS','','Why are you making so much noise? Have you ever actually tried to sneak up on someone before?',26124),
(78808,'enUS','Pul, I need to quickly return to Bladespire Citadel.','Pul, I need to quickly return to Bladespire Citadel.',26124),
(78809,'enUS','Let\'s get movin\', then!','',26124),
(78810,'enUS','Lemme just get her warmed up...','',26124),
(78811,'enUS','Come on, baby girl...','',26124),
(78812,'enUS','There we go!','',26124),
(78813,'enUS','This way. There is a safe spot up ahead, just outside the Iron Horde\'s facilities.','',26124),
(78814,'enUS','I s\'pose priority number one is to take care o\' that nasty giant cannon.','',26124),
(78815,'enUS','Did somebody say \"giant cannon\"?','',26124),
(78816,'enUS','Soon enough. Our first priority is to find Yrel. She is out there somewhere.','',26124),
(78817,'enUS','D\'kaan, you and our champion did some scouting earlier. What did you find?','',26124),
(78818,'enUS','...nothing conclusive, Vindicator.','',26124),
(78819,'enUS','I see. Well then, we will just have to...','',26124),
(78820,'enUS','AAAAAHHH! SO MUCH FIRE!','',26124),
(78821,'enUS','Karmaan is at the back of the farm. Let\'s go.','',26124),
(78822,'enUS','He\'s just ahead.','',26124),
(78823,'enUS','Karmaan, this hero and I spotted iron horde in podling territory!','',26124),
(78824,'enUS','$p, time is running out. You need to find his daughter so he will listen to us. We need his knowledge of the land if we are to have any hope against the iron horde!','',26124),
(78825,'enUS','The podlings are ravaging the farm. My daughter is missing. Let the iron horde come.','',26124),
(78826,'enUS','This adventurer disposed of most of the podlings. We once fought alongside one another at Karabor, brother. We cannot give up now.','',26124),
(78827,'enUS','Ow! Hey! Why hurt me?!','',26124),
(78828,'enUS','No! I falling!','',26124),
(78829,'enUS','The tank rumbles, rattles, sputters, and spurts.','',26124),
(78831,'enUS','<Move out to Ulon Oasis.>','<Move out to Ulon Oasis.>',26124),
(78833,'enUS','Here it comes! Form ranks! Grapplers at the ready!','',26124),
(78834,'enUS','','We have incoming. Use some of those explosives to destroy their ground forces.',26124),
(78835,'enUS','Ah, old Shadowmoon! I never thought to set eyes on these woods again.','',26124),
(78836,'enUS','','Vindicator Akama! I\'ve just come from Teluuna Observatory. Our people there are under attack!',26124),
(78837,'enUS','','My sister Samaara is stationed at the Observatory. I will go as well.',26124),
(78838,'enUS','Tell your prophet that his era is over. Darkness dawns!','',26124),
(78839,'enUS','I\'ll dispatch artificers to secure the crystals to the north.','',26124),
(78840,'enUS','And what of Ner\'zhul? Will we let him take our people without retribution?','',26124),
(78841,'enUS','Patience, Maraad. A rescue will require planning - do not rush into danger until we know where our people are.','',26124),
(78842,'enUS','We made the wrong choice once before. I won\'t let it happen again. I can\'t leave our people to die.','',26124),
(78843,'enUS','','I will keep an eye on him, teacher.',26124),
(78844,'enUS','Now brother! Let us escape while we still can!','',26124),
(78850,'enUS','','When the Iron Horde came, they gave our clan a choice. Join them, or die.',26124),
(78851,'enUS','','My husband Ner\'zhul chose to save our people. He joined the Iron Horde, but they asked of him a heavy price.',26124),
(78852,'enUS','','They said:',26124),
(78853,'enUS','','So Ner\'zhul turned to the silent void. He broke the ancient laws, and drew upon the dark star.',26124),
(78854,'enUS','','I pleaded with him to stop, but he would not turn back.',26124),
(78855,'enUS','','By breaking this stone, he forswore all loyalty to our ancestors.',26124),
(78856,'enUS','','I can ask only one thing of you now, stranger.',26124),
(78857,'enUS','','You must do what I cannot. Stop Ner\'zhul. End his madness before it is too late.',26124),
(78858,'enUS','What\'s this? A little $r?$B$BWhat possible use would I have with |5$r slave?','',26124),
(78859,'enUS','Well done, Ner\'zhul. We attack Karabor soon. Summon forth the Dark Star.','',26124),
(78860,'enUS','','Hang on Samaara. I will call for Velen. He can save you, just hold on!',26124),
(78861,'enUS','','Yrel, do not be sad. I did not choose this fate, but you... you can still choose.',26124),
(78862,'enUS','','Be strong, little one. I... I will be watching over you.',26124),
(78863,'enUS','','No. No!!!!!',26124),
(78864,'enUS','','Samaara, I swear to you, I will become strong. I will protect our people. I. Will. Fight!',26124),
(78865,'enUS','','Come, champion. I will need your help to crush this \"Iron Horde.\"',26124),
(78866,'enUS','Run brother! Before it is too late!','',26124),
(78867,'enUS','Find Yrel. And, $n, if this filthy ogre gives you any problems, kill him!','',26124),
(78868,'enUS','Better hope Ripclaw is tired... no one I send against him ever survives.','',26124),
(78869,'enUS','$n is it? You\'ll sell quickly for the Nagrand fighting pits. In the meantime, Ok\'mok will find someplace to put you to work.','',26124),
(78870,'enUS','Up!','',26124),
(78871,'enUS','Gazlowe\'s Solution is ready to deploy!','Gazlowe\'s Solution is ready to deploy!',26124),
(78872,'enUS','Must be closer to Gazlowe\'s objectives to deploy!','Must be closer to Gazlowe\'s objectives to deploy!',26124),
(78873,'enUS','Front of the line, slave!','',26124),
(78874,'enUS','Flames assist me!','',26124),
(78875,'enUS','','That\'s quite enough of this illusion, I think.',26124),
(78876,'enUS','Ahhh, much better.','',26124),
(78877,'enUS','I will bring our new friend here back to the refuge.','',26124),
(78878,'enUS','Shadows engulf your mind as the illusion shatters!','Shadows engulf your mind as the illusion shatters!',26124),
(78880,'enUS','Why you no save me?','',26124),
(78881,'enUS','Me sorry...','',26124),
(78882,'enUS','This pay back!','',26124),
(78883,'enUS','Maybe me take your body!','',26124),
(78884,'enUS','Boo!  You scared?','',26124),
(78886,'enUS','< You find Skreek\'s lifeless body sprawled out on the ground. >','',26124),
(78887,'enUS','You search the bushes for hidden enemies.','',26124),
(78888,'enUS','Lookout!','',26124),
(78889,'enUS','We are not alone, $c. Check the bushes.','',26124),
(78890,'enUS','Did you kill them all?','',26124),
(78891,'enUS','The centipedes are no use to me dead. You will have to catch them by hand.','',26124),
(78892,'enUS','This potion will surely be useful. Now let us find Skreek.','',26124),
(78893,'enUS','This... this cannot be... my brother. My family. We are too late.','',26124),
(78894,'enUS','I will kill him. I\'ll tear Greatscar to pieces! I will avenge you brother!','',26124),
(78895,'enUS','','We... cannot... be stopped.',26124),
(78896,'enUS','','You struggle in vain.',26124),
(78897,'enUS','','I have bought you all the time that I can, Death Speaker.',26124),
(78898,'enUS','It\'s Swiftshadow! He\'s still alive!','',26124),
(78899,'enUS','You should have stayed in your cage. Now you will die like your brother!','',26124),
(78900,'enUS','','Papa, I\'m scared!',26124),
(78901,'enUS','I know, lightning bug. But Papa needs you to be brave right now.','',26124),
(78902,'enUS','Do you remember what you want to be when you grow up? Come now, you just told me this morning.','',26124),
(78903,'enUS','','<sniff> <sniff> ... a vindicator.',26124),
(78904,'enUS','And what are vindicators like?','',26124),
(78905,'enUS','','...they\'re brave.',26124),
(78906,'enUS','That\'s right! Can you be brave for me, Vindicator Melani?','',26124),
(78907,'enUS','','%s stands up straight and puffs out her chest.',26124),
(78908,'enUS','','I\'ll try!',26124),
(78909,'enUS','There\'s my girl. Now stay close to Papa. Let\'s go!','',26124),
(78910,'enUS','','You\'re going after it?! Suit yourself. I am getting out of here!',26124),
(78911,'enUS','Get in there you worthless $c and don\'t come out until either you or the raptor is dead!','',26124),
(78912,'enUS','','$p! Fire the main cannon and bring that tower down!',26124),
(78913,'enUS','','Nice shot! Easy shot. But nice one! Now let\'s get out of here before they can launch a counter attack. Hold on to something!',26124),
(78914,'enUS','You insignificant vermin cannot hold me forever.','',26124),
(78915,'enUS','I look forward to eating your precious pack beast.$b$bAnd you. Do not forget that I will eat you as well!$b$bBut mostly I am looking forward to eating your pack beast.','',26124),
(78916,'enUS','Release me and I shall consider not slaying all of you.$b$BMaybe just those chuckling orcs over in the corner.$b$bEspecially the one that keeps stabbing me.','',26124),
(78917,'enUS','I hunger. FEED ME!','',26124),
(78918,'enUS','There is no hope for you. You should just line up in the order of fattest so that I might consume you more efficiently.','',26124),
(78919,'enUS','Armies have quaked before my coming. You will learn this, soon enough.','',26124),
(78920,'enUS','Is the gronn safe?','Is the gronn safe?',26124),
(78921,'enUS','','Safe? No. But managable. Goc would eat us if he could but the Iron Horde succeeded in driving their devices into his brain in just the right way.$b$bHe can\'t move unless operated by a controller.$b$bJust hope none of those bolts loosen or we will have a giant problem on our hands.',26124),
(78922,'enUS','What will happen to the gronn?','What will happen to the gronn?',26124),
(78923,'enUS','','He is too large to bring with us. While the added firepower would be nice we still need to keep a low profile. He was not the only gronn in the Iron Horde arsenal.$b$bWe will probably leave him here for now. Those harnesses will keep him in place. Given how many orcs he has consumed, I have no problem leaving him here to starve for his crimes.',26124),
(78924,'enUS','The caravan I\'m traveling with could use some help. You seem like you would fit right in.','The caravan I\'m traveling with could use some help. You seem like you would fit right in.',26124),
(78925,'enUS','Invite Y\'kish?','',26124),
(78926,'enUS','Without Skreek and Swiftshadow I don\'t know how I will survive.$b$bMy brother has always taken care of me. If it wasn\'t for him I would have suffered a far worse fate than having my wings clipped.','',26124),
(78927,'enUS','My bond with Swiftshadow is almost as important to me as the bond I share with my brother.','',26124),
(78928,'enUS','Swiftshadow and I could not be more grateful for your actions today, $c.$b$bWe are in your debt.$b$bI\'ll meet up with you and the caravan after I am done burying my brother.','',26124),
(78929,'enUS','','They killed Bonetusk... we must hold them off!',26124),
(78930,'enUS','','Roogug has failed us!',26124),
(78931,'enUS','','Take refuge, my brethren. Ramtusk will protect the Kraul.',26124),
(78932,'enUS','Garrosh Hellscream has escaped.\n\nIf you have any information regarding the war criminal\'s whereabouts, please inform your local authorities and any agent of the Shado-Pan you see.','Garrosh Hellscream has escaped.\n\nIf you have any information regarding the war criminal\'s whereabouts, please inform your local authorities and any agent of the Shado-Pan you see.',26124),
(78933,'enUS','The murlocs flee in the face of Aku\'mai\'s wrath!','',26124),
(78934,'enUS','Hurry it up, slave!','',26124),
(78935,'enUS','','Good work, $p! Meet us at the rendezvous. Time to see how to drive this beast.',26124),
(78936,'enUS','No slacking off!','',26124),
(78937,'enUS','What? Is this |5$pr? Pathetic!','',26124),
(78938,'enUS','','Let\'s see how you do when you don\'t have a machine of MY design at your disposal...',26124),
(78939,'enUS','You\'re going to get a beating if you don\'t move it!','',26124),
(78940,'enUS','Work harder!','',26124),
(78941,'enUS','Faster, $pr, or it\'s the cooking pot for you!','',26124),
(78942,'enUS','Are you eyeballing me?!','',26124),
(78943,'enUS','You don\'t belong here, $pr. Get back to work!','',26124),
(78944,'enUS','What happened?','What happened?',26124),
(78945,'enUS','Allies of Garrosh attacked the Temple of the White Tiger during his trial.\n\nIn the confusion, Kairoz -- a bronze dragon assisting with the proceedings -- betrayed us all and opened a magical portal through which both he and Garrosh fled.','Allies of Garrosh attacked the Temple of the White Tiger during his trial.\n\nIn the confusion, Kairoz -- a bronze dragon assisting with the proceedings -- betrayed us all and opened a magical portal through which both he and Garrosh fled.',26124),
(78946,'enUS','Where did Garrosh go?','Where did Garrosh go?',26124),
(78947,'enUS','Pandaria\'s waterspeakers assure us that he has fled that land.\n\nBeyond that, we cannot say.','Pandaria\'s waterspeakers assure us that he has fled that land.\n\nBeyond that, we cannot say.',26124),
(78948,'enUS','Who is Kairoz?','Who is Kairoz?',26124),
(78949,'enUS','Kairozdormu is one of the bronze dragonflight.\n\nHe was assisting in the trial, conjuring images of Garrosh\'s past atrocities.\n\nThere is no known link between Kairoz and Garrosh, and neither we nor the bronze dragonflight know why he aided the orc.','Kairozdormu is one of the bronze dragonflight.\n\nHe was assisting in the trial, conjuring images of Garrosh\'s past atrocities.\n\nThere is no known link between Kairoz and Garrosh, and neither we nor the bronze dragonflight know why he aided the orc.',26124),
(78950,'enUS','Tell me about the attack.','Tell me about the attack.',26124),
(78951,'enUS','An orc known as Warlord Zaela led the attack; assisting her were her Dragonmaw clan, a number of dragons, and a band of hired pirates.\n\nOnce Garrosh escaped, Zaela and the surviving Dragonmaw fled on dragon-back.\n\nThe pirates were abandoned but know nothing of Garrosh\'s whereabouts.','An orc known as Warlord Zaela led the attack; assisting her were her Dragonmaw clan, a number of dragons, and a band of hired pirates.\n\nOnce Garrosh escaped, Zaela and the surviving Dragonmaw fled on dragon-back.\n\nThe pirates were abandoned but know nothing of Garrosh\'s whereabouts.',26124),
(78954,'enUS','You\'re pathetic!','',26124),
(78955,'enUS','Faster or it\'s the cooking pot for you!','',26124),
(78956,'enUS','Get back to work!','',26124),
(78959,'enUS','I\'ll hold the line. Go find the others!','',26124),
(78960,'enUS','Hurry it up, slave! Get to your assignment!','',26124),
(78961,'enUS','<whispers>The first slave you should talk to is on the way to the quarry. Keep your head down and we\'ll be fine. Just don\'t let your ranger friend kill me.','',26124),
(78962,'enUS','Muura and Illona are further out. You\'ll need to cut through the Iron Horde\'s forces to get to them.','',26124),
(78976,'enUS','Mining','Mining',26124),
(78977,'enUS','','You\'re a light in these dark times, $p.',26124),
(78978,'enUS','','Illona is on the other side of the farm. Hurry!',26124),
(78979,'enUS','ENOUGH! SOUND THE ALARM!','',26124),
(78980,'enUS','The two of you will never escape alive!','',26124),
(78981,'enUS','Killstripe might know. He\'s up the hill. Here, take this crate of rocks so you look like you\'re working.','',26124),
(78982,'enUS','Yrel? Is that the draenei woman they brought in yesterday?$B$BYeah, I don\'t know where she is, but Killstripe might.','',26124),
(78983,'enUS','<The saberon narrows his eyes, judging you.>','',26124),
(78984,'enUS','<Killstripe nods his approval.>','',26124),
(78985,'enUS','','These guys aren\'t so tough!',26124),
(78986,'enUS','Killstripe points at one of the ogres and makes a cutting motion in front of his throat.','',26124),
(78987,'enUS','Points to the mine and draws an image of a foreling in the dirt.','',26124),
(78988,'enUS','','Muura is on the other side of the farm. Hurry!',26124),
(78989,'enUS','Killstripe? He\'s a saberon. They don\'t talk. Give up now, $n. I\'ll be lenient.','',26124),
(78990,'enUS','I wouldn\'t if I were you!','',26124),
(78991,'enUS','What are you doing in Gorgrond?','What are you doing in Gorgrond?',26124),
(78992,'enUS','You\'ll pay for that, $n!','',26124),
(78993,'enUS','After being banished from the spires my older brother Skreek and I sought refuge.$b$bWe traveled a great distance on the back of Swiftshadow before the saberon shot us down not far from here. I can only assume they planned to eat us.','',26124),
(78994,'enUS','Why are you bothering me? Can\'t you see I\'m on my break?','',26124),
(78996,'enUS','You\'re alright for a $r. You can do my work for me anytime.','',26124),
(78997,'enUS','You want to know where your friend is? Mine these rocks for me.','',26124),
(78998,'enUS','Thank you, $r. You\'ll find her toiling away just down the hall.','',26124),
(78999,'enUS','Why would you or your brother need a mount like Swiftshadow to fly?','Why would you or your brother need a mount like Swiftshadow to fly?',26124),
(79000,'enUS','This one\'s lazy and should be beaten. You get back to work, foreling!','',26124),
(79001,'enUS','Last chance, $n. Let me go unharmed and surrender now, or else!','',26124),
(79015,'enUS','What are you doing back here?$B$BGet to your work assignment before I squash you!','',26124),
(79016,'enUS','Please, I beg you, don\'t kill me!','',26124),
(79017,'enUS','When we were banished from the spires our wings were clipped. It was Skreek who had the idea to tame a mount. To fly on the back of a beast would be humiliating for most arakkoa. To my brother and me -- it was a chance to reclaim the skies.$b$bSkreek found Swiftshadow just a few days after we had been banished. She had fallen from her nest.$b$bMy brother and I raised her. We gave her shelter and food.$b$bSkreek taught her how to fly and in return Swiftshadow gave us back the gift of flight.','',26124),
(79018,'enUS','','Do you need something fixed?',26124),
(79019,'enUS','Do you have an Optical Disc?','Do you have an Optical Disc?',26124),
(79020,'enUS','Do you have Romuul\'s Wrench?','Do you have Romuul\'s Wrench?',26124),
(79021,'enUS','This is some place al\'right.','',26124),
(79022,'enUS','These draenei are funny lookin\', dontcha think?','',26124),
(79023,'enUS','Do you have some brew for the Master Artificer?','Do you have some brew for the Master Artificer?',26124),
(79024,'enUS','Now I understand.','Now I understand.',26124),
(79025,'enUS','Fearlessly delving into the unknowable. Seeking answers in the dark...','',26124),
(79026,'enUS','I am Iskar. And now that you have become acquainted with the arakkoa, I wonder if you might aid me in subverting them.','',26124),
(79027,'enUS','You will collapse under the weight of your own madness...','',26124),
(79028,'enUS','You think I would idly wait while you stab pointlessly at me?','',26124),
(79029,'enUS','Spin in the maddening whorls of eternity!','',26124),
(79030,'enUS','','I will use your bones to sharpen my blade.',26124),
(79031,'enUS','','Your pitiful skills are no match for my talents.',26124),
(79032,'enUS','','Ah, a challenge.',26124),
(79033,'enUS','','But... my... training...',26124),
(79034,'enUS','Scour the room! Check every corner and shadow, and do not move the artifact until we can be certain it is safe.','',26124),
(79035,'enUS','You are not of the chosen.','',26124),
(79039,'enUS','','Quickly! Stop the ritual!',26124),
(79041,'enUS','We\'re gaining ground! Keep it up!','',26124),
(79042,'enUS','These mongrels will learn to never set foot in our home again!','',26124),
(79043,'enUS','Make sure we tend to the wounded! They could launch a new attack at any moment!','',26124),
(79044,'enUS','Fight to the last! We will not bow down to these brutes!','',26124),
(79045,'enUS','Warbringer Trosk and his siege weapon will fall this day!','',26124),
(79046,'enUS','If I die, so do you!','',26124),
(79047,'enUS','Mmmmmppphhhh!!!','',26124),
(79048,'enUS','Mmmph! Mmmmppphhhh!','',26124),
(79049,'enUS','Mmmph!','',26124),
(79050,'enUS','','Quickly! Stand within the healing soils to protect yourselves!',26124),
(79051,'enUS','','My weapon is in this tower.',26124),
(79052,'enUS','','Great timing, $n! I was just about to make my escape. Where\'s Maraad?',26124),
(79053,'enUS','','I think my armor\'s inside here.',26124),
(79054,'enUS','','Much better. Now I have something to fight with.',26124),
(79055,'enUS','','It\'s nice not being so naked. Let\'s find Ok\'mok and my pendant from Maraad.',26124),
(79056,'enUS','','Ok\'mok is at the top of this giant tower. Let\'s go.',26124),
(79057,'enUS','','The pendant Maraad gave me. The ogre took it when he captured me.',26124),
(79058,'enUS','','Thank you, $n. You have no idea how much this means. Let\'s get out of here.',26124),
(79059,'enUS','','MARAAD!',26124),
(79060,'enUS','Watch out, it\'s going to explode!','',26124),
(79061,'enUS','YREL, MY LOVE!','',26124),
(79062,'enUS','','Thank you for coming to get me, $n.$B$BI must get back to Maraad.',26124),
(79063,'enUS','','$n? Great timing! I was just about to make my escape.',26124),
(79064,'enUS','Thank you, stranger!','',26124),
(79065,'enUS','Savor this victory, mortal. Now that you\'ve heard our whispers, it is only a matter of time until you belong to us.','',26124),
(79066,'enUS','Finally! Let\'s get some revenge!','Finally! Let\'s get some revenge!',26124),
(79067,'enUS','Thank you, $c. I\'m in your debt.','Thank you, $c. I\'m in your debt.',26124),
(79068,'enUS','Death to the slavers!','Death to the slavers!',26124),
(79069,'enUS','For vengeance, my $g brother:sister;!','For vengeance, my $g brother:sister;!',26124),
(79070,'enUS','They\'ll pay for what they did to us!','They\'ll pay for what they did to us!',26124),
(79071,'enUS','It feels good to be free again. Thank you!','It feels good to be free again. Thank you!',26124),
(79072,'enUS','I\'ll help clear the way for your escape!','I\'ll help clear the way for your escape!',26124),
(79073,'enUS','I\'ll kill them with my bare hands!','I\'ll kill them with my bare hands!',26124),
(79074,'enUS','You\'ll get no fight from me, $n. Please, let me live.','',26124),
(79075,'enUS','It\'s Swiftshadow! He has returned!','',26124),
(79076,'enUS','I need some time alone to say goodbye to my brother. Thank you for all your help, $n.','',26124),
(79077,'enUS','Swiftshadow and I will meet you at the caravan when we are done here.','',26124),
(79078,'enUS','This cage was getting tiresome.','',26124),
(79079,'enUS','Who calls on the spirit of fire?','',26124),
(79080,'enUS','Let\'s calibrate the crystal.','Let\'s calibrate the crystal.',26124),
(79081,'enUS','','The spirits have been very restless, champion. Watch my back while I perform the calibration.',26124),
(79082,'enUS','Our work is almost complete...','',26124),
(79083,'enUS','The nearby spirits grow restless. Keep them away from the staff.','',26124),
(79084,'enUS','Defend the staff while it absorbs the energies of the crystal.','',26124),
(79085,'enUS','Farewell, Charlga. May the earth mother watch over you.','',26124),
(79086,'enUS','Thank you, heroes, for your valiant deeds. I hope that our paths may cross again.','',26124),
(79087,'enUS','Velen\'s Staff is under attack!','',26124),
(79088,'enUS','','Help me, hero! I\'m under attack!',26124),
(79089,'enUS','','Protect me champion! I\'m hurt!',26124),
(79090,'enUS','','Who dares defile our ancient lands?',26124),
(79091,'enUS','Maraad\'s dealing with some trouble back at camp. I\'ll cover you as best I can.','',26124),
(79092,'enUS','','Every crystal has base properties. From there, it is the artificer\'s skill at cutting that determines the quality of the final product.',26124),
(79093,'enUS','|TInterface\\Icons\\inv_misc_noose_01:20|t%s trips a |cFFFF0000|Hspell:150809|h[Rope Trap]|h|r!','|TInterface\\Icons\\inv_misc_noose_01:20|t%s trips a |cFFFF0000|Hspell:150809|h[Rope Trap]|h|r!',26124),
(79094,'enUS','I\'ll hang your head on Grommar\'s walls, runt.','',26124),
(79095,'enUS','Iron will, iron blood!','',26124),
(79096,'enUS','Who challenges da hammer of Frostfire?!','',26124),
(79097,'enUS','I refuse to die to the likes of you, orc.','',26124),
(79102,'enUS','Thank you for your help. May we meet again soon, friend.','',26124),
(79103,'enUS','We stand with Ga\'nar. He is eldest, and should have been our chieftain.','',26124),
(79104,'enUS','Hmrph. I have scars that look older than you.','',26124),
(79105,'enUS','Ga\'nar will rule the Frostwolves one day, mark my words.','',26124),
(79106,'enUS','What do you want, pup?','',26124),
(79107,'enUS','I remember fighting alongside Garad and Ga\'nar against the Laughing Skulls many seasons ago. It was glorious. Never was there a more fearsome force on the battlefield.','',26124),
(79108,'enUS','Garad was a great chieftain, but he took leave of his senses in the end and gave Durotan leadership of the clan even though it was Ga\'nar\'s by birthright.$b$bWe now hunt with the one we proudly call \"chieftain.\"','',26124),
(79109,'enUS','PH','',26124),
(79110,'enUS','','It is good to know that not all old alliances are broken. The draenei have welcomed me by their fire.',26124),
(79111,'enUS','','I am Rulkan, daughter of Neema. I was an elder of the Shadowmoon Clan, but am not of the clan any longer.$B$BNer\'zhul is my husband, but we have parted ways. He took his followers in one direction, and I took mine in another.',26124),
(79112,'enUS','I\'ll need more fuel to get rid of this pest...','',26124),
(79113,'enUS','Need more fuel!','',26124),
(79114,'enUS','Thought I was out of fuel? Think again, whelp!','',26124),
(79115,'enUS','More fuel!','',26124),
(79116,'enUS','More fuel to feed the flames!','',26124),
(79117,'enUS','More fuel!!','',26124),
(79118,'enUS','Time to refuel...','',26124),
(79119,'enUS','Time to feed the flames!','',26124),
(79120,'enUS','You little rat!','',26124),
(79121,'enUS','How dare you!','',26124),
(79122,'enUS','Owww!','',26124),
(79123,'enUS','AAAAHHH!','',26124),
(79124,'enUS','Frostwolves are here!','Frostwolves are here!',26124),
(79125,'enUS','Enemy incoming!','Enemy incoming!',26124),
(79126,'enUS','I\'ll string you up for my beasts to feed upon!','I\'ll string you up for my beasts to feed upon!',26124),
(79127,'enUS','Ah, some soft meat to hunt.','Ah, some soft meat to hunt.',26124),
(79128,'enUS','Easy prey!','Easy prey!',26124),
(79129,'enUS','For the Iron Wolf!','For the Iron Wolf!',26124),
(79130,'enUS','Ah, practice for my chains.','Ah, practice for my chains.',26124),
(79131,'enUS','Why would the botani be wandering outside of Blademoon Bloom in the first place?','',26124),
(79132,'enUS','Wolf Home is under attack. Stop the Thunderlord clan raid!','',26124),
(79133,'enUS','They came from the forest... why are they attacking us?','They came from the forest... why are they attacking us?',26124),
(79134,'enUS','We were fleeing from Tuurem seeking shelter when podlings came out of the forest and ambushed us!$B$BUsually if we don\'t go into their territory they leave us alone... why now?','We were fleeing from Tuurem seeking shelter when podlings came out of the forest and ambushed us!$B$BUsually if we don\'t go into their territory they leave us alone... why now?',26124),
(79135,'enUS','When you see Draka... tell her that I will be home soon.','',26124),
(79136,'enUS','Thrall grins at his father\'s words.','',26124),
(79137,'enUS','The whole place is overrun. Get out while you still can!','The whole place is overrun. Get out while you still can!',26124),
(79138,'enUS','Beldos! The Iron Horde have already begun attacking!','',26124),
(79139,'enUS','Thank you, champion! You have given me new hope today.','Thank you, champion! You have given me new hope today.',26124),
(79140,'enUS','The Shadowmoon - they\'ve changed. They pray to the Void now...','The Shadowmoon - they\'ve changed. They pray to the Void now...',26124),
(79141,'enUS','Thank you, champion. I will never forget... their screams...','Thank you, champion. I will never forget... their screams...',26124),
(79142,'enUS','Hurry - Ner\'zhul is dragging prisoners to the altar!','Hurry - Ner\'zhul is dragging prisoners to the altar!',26124),
(79143,'enUS','Thank you. Please save the others! Ner\'zhul is using them for some kind of ritual!','Thank you. Please save the others! Ner\'zhul is using them for some kind of ritual!',26124),
(79144,'enUS','Ner\'zhul is sacrificing prisoners. He\'s babbling about a \"Dark Star!\"','Ner\'zhul is sacrificing prisoners. He\'s babbling about a \"Dark Star!\"',26124),
(79145,'enUS','There were more prisoners... they took them somewhere... please help them!','There were more prisoners... they took them somewhere... please help them!',26124),
(79146,'enUS','Thank you for getting me out of here! You cannot imagine the horrors we saw...','Thank you for getting me out of here! You cannot imagine the horrors we saw...',26124),
(79147,'enUS','We need help out here!','',26124),
(79148,'enUS','Nearby Muck Crawlers are roused by the commotion!','Nearby Muck Crawlers are roused by the commotion!',26124),
(79149,'enUS','Uprooting','Uprooting',26124),
(79150,'enUS','Who have we here...?','',26124),
(79151,'enUS','','Thank you. I\'m not cut out for fighting.',26124),
(79152,'enUS','','Our people have always drawn their magic from the earth and the moon.$B$BNearly three centuries ago, the ancestors sensed a different magic. A dark source.$B$BThis was magic of shadows. It corrupted the mind, tainting those who used it, driving them mad.$B$BSince then, our clan was forbidden to use these shadows.',26124),
(79154,'enUS','','What are those Thunderlord fools doing with the gronn?',26124),
(79155,'enUS','What good are stars and visions against steel and powder? Make a worthy offering, or your people shall die.','',26124),
(79156,'enUS','For Karabor!','For Karabor!',26124),
(79157,'enUS','For Karabor!','For Karabor!',26124),
(79158,'enUS','Stand tall brothers and sisters! Today we fight for Karabor!','Stand tall brothers and sisters! Today we fight for Karabor!',26124),
(79159,'enUS','I am no slave!','I am no slave!',26124),
(79160,'enUS','Prepare to die!','Prepare to die!',26124),
(79161,'enUS','My life for Karabor!','My life for Karabor!',26124),
(79162,'enUS','My life for Karabor!','My life for Karabor!',26124),
(79163,'enUS','','Let\'s get cooking!',26124),
(79164,'enUS','','The Shadowmoon fortress is sealed to outsiders, but this keystone will allow entry. Good luck, hero.',26124),
(79165,'enUS','I should be at work.','I should be at work.',26124),
(79166,'enUS','','Okay, how about something that\'ll stir it up and wriggle around!',26124),
(79167,'enUS','','Let\'s add in something dangerous... maybe even toxic!',26124),
(79168,'enUS','','How about something that\'ll give it a nice glow!',26124),
(79169,'enUS','Wander.','Wander.',26124),
(79170,'enUS','working.','Working.',26124),
(79171,'enUS','Smash the Podlings before %s can bring them to maturity!','',26124),
(79172,'enUS','That\'s a load off.','That\'s a load off.',26124),
(79173,'enUS','Smack Boombot','',26124),
(79174,'enUS','%s\'s suction intensifies!','%s\'s suction intensifies!',26124),
(79175,'enUS','For the Frostwolf!','For the Frostwolf!',26124),
(79176,'enUS','Gathering Weapons','',26124),
(79177,'enUS','%s howls in excitement.','',26124),
(79178,'enUS','','Good job!',26124),
(79179,'enUS','','Throw in something meaty!',26124),
(79180,'enUS','These heads will make the perfect trophy for such a glorious battle!','These heads will make the perfect trophy for such a glorious battle!',26124),
(79181,'enUS','Throm-Ka, $c. Elements be with you.','',26124),
(79182,'enUS','I am ready for the ritual, farseer.','I am ready for the ritual, farseer.',26124),
(79183,'enUS','Damn Thunderlords and their cheap hunting spears. I\'ll be picking these things up for a week!','Damn Thunderlords and their cheap hunting spears. I\'ll be picking these things up for a week!',26124),
(79184,'enUS','Let me know when you\'re ready to begin the ritual, $n.','',26124),
(79185,'enUS','Farseer, I\'d like to witness the vision again.','Farseer, I\'d like to witness the vision again.',26124),
(79187,'enUS','You talk a great deal, Thunderlord.','',26124),
(79188,'enUS','The only shame here is in your cowardly attack on our home!','',26124),
(79189,'enUS','You are overconfident, Gargrak. $p is easily your match.','',26124),
(79190,'enUS','A waste of air. Come, friend, we have much to discuss.','',26124),
(79191,'enUS','The ritual is ready, $n. Let me know when you wish to begin.','',26124),
(79192,'enUS','The elements once spoke to me... now I hear only whispers. Is this our fate, or a warning?','',26124),
(79193,'enUS','','Follow the path northwest. Hurry, that monster will kill Drek\'Thar!',26124),
(79194,'enUS','','Well met, $c. Welcome to Wolf Home.',26124),
(79195,'enUS','','You have my thanks for returning in our time of need, $c.',26124),
(79196,'enUS','','You must get to Drek\'Thar before it is too late!',26124),
(79197,'enUS','','The savior of Wolf Home. It is good to see you again, $n.',26124),
(79198,'enUS','I will begin my preparations at once.','',26124),
(79199,'enUS','','Here, this herb\'s effects will let you get to the island more easily.',26124),
(79200,'enUS','','Oh no! That wasn\'t quite right. Let\'s just whip up a new batch.',26124),
(79201,'enUS','','That\'s the stuff!',26124),
(79202,'enUS','','Perfect!',26124),
(79203,'enUS','','Nicely done!',26124),
(79204,'enUS','','Samaara!',26124),
(79205,'enUS','','Let me know when you\'re ready!',26124),
(79206,'enUS','I\'m ready, Fiona.','I\'m ready, Fiona.',26124),
(79207,'enUS','','Herbalism was so much easier in the old days. Now we have to fight through hell and back to extract even a few herbs!',26124),
(79208,'enUS','Time for a change of scenery.','Time for a change of scenery.',26124),
(79209,'enUS','Another reason we shouldn\'t trust the shadowmoon. They can\'t even control their own magic.','',26124),
(79210,'enUS','There is no way I\'m going back in there.','',26124),
(79211,'enUS','Taste iron fury!','',26124),
(79212,'enUS','The bigger the target, the better the boom!','',26124),
(79213,'enUS','Just like bombing kobolds back home!','',26124),
(79214,'enUS','After I\'m through, it\'ll be rainin bits O\' gronn fer weeks!','',26124),
(79215,'enUS','There is some kind of demon at the back of the cave. He killed the fool that summoned him.','',26124),
(79216,'enUS','This is another reason it\'s better to wield an iron blade over dark magic.','',26124),
(79217,'enUS','We should be mining this cave for resources...','',26124),
(79218,'enUS','This is unacceptable. Why are we even considering letting these fools join us?','',26124),
(79219,'enUS','','We did it! This elixir should do the trick.',26124),
(79220,'enUS','','Here, give this to Gidwin. Hopefully this works.',26124),
(79221,'enUS','You\'ll find a majority of the plane wreckage just down the hill. Bring back whatever you find.','',26124),
(79222,'enUS','As soon I get this gyro running I can start my search for Romuul.','',26124),
(79223,'enUS','I would rather die than live my life as slave to the Iron Horde.','',26124),
(79224,'enUS','Find some weapons. It is time we stand up to our captors.','',26124),
(79225,'enUS','The crimes these orcs have committed against my people are unspeakable. Kill them all.','',26124),
(79226,'enUS','Battleships! Fire on my position!','',26124),
(79227,'enUS','Battleships! Fire on that platform over there!','',26124),
(79228,'enUS','Ruffling','Ruffling',26124),
(79229,'enUS','Ner\'zhul! Your army is scattered, your fortress in ruins.','',26124),
(79230,'enUS','Your \"dark star\" has fallen, and now serves the draenei. You are a disgrace!','',26124),
(79231,'enUS','We would still serve the Iron Horde, Hellscream. Our magic is-','',26124),
(79232,'enUS','YOU HAVE NO PLACE IN MY IRON HORDE! Go back to your little village, Ner\'zhul.  You can watch the stars while the Iron Tide washes over you.','',26124),
(79233,'enUS','Go back to your little village, Ner\'zhul.  You can watch the stars while the Iron Tide washes over you.','',26124),
(79234,'enUS','Korhol, Zhakta, Trokar... move in from all sides. Gargrak, hold for now.','',26124),
(79235,'enUS','ZHAKTA NO!... you will be avenged!','',26124),
(79236,'enUS','Bring me that $r $c\'s head!','',26124),
(79237,'enUS','Dammit all. Gargrak, go now... kill the blind shaman.','',26124),
(79238,'enUS','Call in all reinforcements. I want the She-Wolf taken alive.','',26124),
(79239,'enUS','RETREAT! WE\'LL BE BACK, FROSTWOLVES!','',26124),
(79240,'enUS','See what you can dig up. If the Shadowmoon clan joins forces with the Iron Horde, I worry our darkest days are yet to come.','',26124),
(79241,'enUS','Army! Grow!','',26124),
(79242,'enUS','No chance now!','',26124),
(79243,'enUS','Little ones! Grow! Kill!','',26124),
(79244,'enUS','Eat you friends! Then eat you!','',26124),
(79245,'enUS','It appears the Shadowmoon clan is having difficulty integrating with the Iron Horde. This could play out in our favor.','',26124),
(79246,'enUS','You ours now.','',26124),
(79247,'enUS','Healing.','Healing.',26124),
(79248,'enUS','I\'ve given you some smoke grenades. Use these to help Thaelin target the Arkonite Protector.','',26124),
(79249,'enUS','I\'ve got enough blasting powder to wipe that gronn right off the face of Draenor. Just show me where to drop it.','',26124),
(79250,'enUS','The spirits are restless, Durotan.','',26124),
(79251,'enUS','','This.. this is horrible. What are we going to do?',26124),
(79252,'enUS','','I ran as soon as I had a chance. Poor Laabru. I hope he is still alive.',26124),
(79253,'enUS','We have to break free of these bonds. Hurry!','',26124),
(79254,'enUS','We kill you soon.','',26124),
(79255,'enUS','This Iron Tide comes for us because Durotan is strong and the Frostwolf would not join them.','',26124),
(79256,'enUS','Wake up! We need to break free now! Look at that thing!','',26124),
(79257,'enUS','We need backup!','',26124),
(79258,'enUS','Help! We have intruders!','',26124),
(79259,'enUS','Iron Horde, we have unwanted visitors!','',26124),
(79260,'enUS','Did you hear that?','',26124),
(79261,'enUS','I am on the way!','',26124),
(79262,'enUS','The Iron Horde will crush you!','',26124),
(79263,'enUS','What was that noise?','',26124),
(79264,'enUS','It is time for death!','',26124),
(79265,'enUS','To arms!','',26124),
(79266,'enUS','','I hear the sounds of battle!',26124),
(79267,'enUS','','Hold on, we are on the way!',26124),
(79268,'enUS','','Blood and conquest!',26124),
(79269,'enUS','We are needed!','We are needed!',26124),
(79270,'enUS','Destroy the intruders!','Destroy the intruders!',26124),
(79271,'enUS','I hear a battle! Move it!','I hear a battle! Move it!',26124),
(79272,'enUS','Damn the Iron Horde!','',26124),
(79273,'enUS','Healing Loop.','Healing Loop.',26124),
(79278,'enUS','Arise my creation, slay these intruders!','',26124),
(79279,'enUS','Many Frostwolf have fallen here.','',26124),
(79280,'enUS','They\'re using the souls of my people to raise the Colossal as a weapon.','',26124),
(79281,'enUS','$n, destroy these Soul Shaman and stop the ritual.','',26124),
(79282,'enUS','My warriors and I will rescue our brethren that still live.','',26124),
(79283,'enUS','','Where\'s my daddy?',26124),
(79284,'enUS','You cannot defeat us all!','',26124),
(79285,'enUS','For the Iron Wolf!','',26124),
(79286,'enUS','','DADDY!!!',26124),
(79287,'enUS','Thunderlords, to arms!','',26124),
(79288,'enUS','Frostwolf scum!','',26124),
(79289,'enUS','You are no match for the Thunderlords!','',26124),
(79290,'enUS','<The gyro looks like it\'s held together with duct tape and bubble gum. Thaelin seems to know what he is doing though. It should be safe.>','<The gyro looks like it\'s held together with duct tape and bubble gum. Thaelin seems to know what he is doing though. It should be safe.>',26124),
(79291,'enUS','Return to the Observatory?','',26124),
(79292,'enUS','I\'ll make a trophy from your head.','',26124),
(79293,'enUS','Return to the Observatory?','Return to the Observatory?',26124),
(79294,'enUS','Lok\'tar Ogar, $n!','',26124),
(79295,'enUS','Wander, infirmary.','Wander, infirmary.',26124),
(79296,'enUS','Did you get separated from your precious pack?','',26124),
(79297,'enUS','Thank you, $n. With those brutes dead it will be easier to convince the others to rise up.','',26124),
(79298,'enUS','The Iron Horde will surely think twice before they hold a Draenei captive again.','',26124),
(79299,'enUS','It is good to see you again, $n. Without you and Thaelin I would surely be doomed.','',26124),
(79300,'enUS','The tip of the Thunderlord spear, no greater honor.','',26124),
(79301,'enUS','Me and Thunderhoof are going to crush all of you.','',26124),
(79302,'enUS','','Death to the puny Frostwolf clan.',26124),
(79303,'enUS','','Here, this herb\'s effects will put a spring in your step. Be careful, $n.',26124),
(79304,'enUS','','Let me know when you\'re ready!',26124),
(79305,'enUS','Hurry $p, Ga\'nar is beneath us in the lair of Grulloc. You should join him before he kills everyone without you.','',26124),
(79306,'enUS','Anvil.','Anvil.',26124),
(79307,'enUS','Anvil done.','Anvil done.',26124),
(79308,'enUS','The Shamanstone hums in the presence of powerful heroes.','The Shamanstone hums in the presence of powerful heroes.',26124),
(79309,'enUS','Blessing of the Wolf','Blessing of the Wolf',26124),
(79310,'enUS','Spirit of the Wolf','Spirit of the Wolf',26124),
(79315,'enUS','*Cough, Sputter*','',26124),
(79316,'enUS','Did you see THIS coming, you blind fool? Hah! Hah!','',26124),
(79317,'enUS','Kalandrios, I would like to witness the Ritual of Binding again.','Kalandrios, I would like to witness the Ritual of Binding again.',26124),
(79318,'enUS','Get out of my face, scum.$B$BWhen I break free, I\'m going to cut you in two.','',26124),
(79319,'enUS','','Sorcerous coward.',26124),
(79320,'enUS','','Reinforcements to the east.',26124),
(79321,'enUS','','Watch for Thunderlord from the ledge to the north.',26124),
(79322,'enUS','','To the south, now my brothers and sisters.',26124),
(79323,'enUS','','They can only attack us when most of our clan is away. Kill these Thunderlord cowards.',26124),
(79324,'enUS','','Watch for their warleader, Gargrak.',26124),
(79325,'enUS','','We will make Durotan proud this day!',26124),
(79326,'enUS','','Come down and face me, \"Iron Wolf\". I\'ll show you how a true wolf fights!',26124),
(79327,'enUS','','Protect the Pool of Visions. Do not let them get to the Farseer.',26124),
(79328,'enUS','Check Crate.','Check Crate.',26124),
(79329,'enUS','Lok\'tar Ogar!','Lok\'tar Ogar!',26124),
(79330,'enUS','Despicable. The Iron Wolf has no respect for beast or brother - they are all just weapons for the hunt.','',26124),
(79331,'enUS','Never enough...','Never enough...',26124),
(79332,'enUS','I need to look this up.','I need to look this up.',26124),
(79333,'enUS','We\'ve called every able-bodied soldier to defend the city.$B$BStay stalwart, hero. This is the hour for courage.','',26124),
(79334,'enUS','Reporting for duty.','Reporting for duty.',26124),
(79335,'enUS','The Iron Horde are moving toward the Temple of Karabor. The attack has beg--','',26124),
(79336,'enUS','Wait... what is that light?','',26124),
(79337,'enUS','It\'s too late for this one.','',26124),
(79338,'enUS','','How are you feeling, Hemma?',26124),
(79339,'enUS','Yes, Princess.','',26124),
(79340,'enUS','','Just a sip, be easy on her!',26124),
(79341,'enUS','','Thank you, Kadus. We have to try. There\'s too much at stake.',26124),
(79342,'enUS','I\'m ready whenever you are.','I\'m ready whenever you are.',26124),
(79343,'enUS','Docking.','Docking.',26124),
(79344,'enUS','','I refuse to remain in Darnassus any longer. There are people that need help.',26124),
(79345,'enUS','Hydrating.','Hydrating.',26124),
(79346,'enUS','','Here, $p. Give this potion to Hemma. It might help.',26124),
(79347,'enUS','Right away, Princess.','',26124),
(79348,'enUS','Hemma. Drink this. It\'ll help you feel better.','',26124),
(79349,'enUS','No effect, Princess. We tried.','',26124),
(79350,'enUS','You are fierce, pup, but your attachments make you weak!','',26124),
(79351,'enUS','Free yourself of weakness, or be swept away by the Iron Tide!','',26124),
(79352,'enUS','','I... I feel...',26124),
(79353,'enUS','','Asha?! Asha, NO!!',26124),
(79354,'enUS','','HnnGYAAHH!!',26124),
(79355,'enUS','','HUNGRY!!!',26124),
(79356,'enUS','','Hemma! Please, wait! Control yourself!',26124),
(79357,'enUS','','$p, you\'re the fastest one here. Track Hemma down and try to get her under control. We\'ll catch up!',26124),
(79358,'enUS','','I\'m losing control... please, help...',26124),
(79359,'enUS','Here, drink this. How are you feeling?','Here, drink this. How are you feeling?',26124),
(79360,'enUS','This talbuk has been ripped to pieces by Hemma. She must be close by.','',26124),
(79361,'enUS','Ah, that\'s the stuff...','Ah, that\'s the stuff...',26124),
(79362,'enUS','','Coward! Release Karg and face me!',26124),
(79363,'enUS','','Wh - where am I? Where is the spirit?',26124),
(79364,'enUS','You lost control. You\'re on a hilltop near camp.','You lost control. You\'re on a hilltop near camp.',26124),
(79365,'enUS','','Hemma, we\'re here. Are you alright?',26124),
(79366,'enUS','Go, $c. Wreak havoc. Impose justice on those who so thoroughly deserve it!','',26124),
(79367,'enUS','','I don\'t remember much. Just a spirit... of pure rage. It called to me.',26124),
(79368,'enUS','','I... I don\'t feel well.',26124),
(79369,'enUS','U\'luut thanks you for saving him and the forests of Shadowmoon Valley.','',26124),
(79370,'enUS','Hi, you!','Hi, you!',26124),
(79371,'enUS','Hi. See you later!','Hi. See you later!',26124),
(79372,'enUS','','Thank you. I hope Princess Greymane can find the cure soon. It has be out here somewhere.',26124),
(79373,'enUS','Lok\'tar, $p!','',26124),
(79374,'enUS','Lok\'tar!','Lok\'tar!',26124),
(79375,'enUS','Did you think me defeated so easily?','',26124),
(79376,'enUS','Who dares disturb my research!','',26124),
(79377,'enUS','Stand back!','',26124),
(79378,'enUS','We have driven the Iron Horde back, $p, but the inner chamber remains sealed.','',26124),
(79379,'enUS','It seems the elements of Draenor do not respond to me as they do on Azeroth...','',26124),
(79380,'enUS','Go on ahead. Durotan awaits. I must catch my breath.','',26124),
(79381,'enUS','I\'m crazy!','',26124),
(79382,'enUS','','Stay away from me! Stay away! I\'ll kill you! I\'ll kill you all!',26124),
(79383,'enUS','I can bring it down but I need time to harness the elements.','',26124),
(79384,'enUS','','The might of my ancestors flows through me!',26124),
(79385,'enUS','Kilrogg! I should have known you were behind this.','',26124),
(79386,'enUS','Heh... that mutt... <cough> is being broken... with the other beasts.','',26124),
(79387,'enUS','You were fools to come here. I will rip the souls from your bodies and raise the Colossal to crush your feeble clan!','',26124),
(79388,'enUS','To Bladespire! Attack!','',26124),
(79389,'enUS','There is no time to waste! We strike NOW!','',26124),
(79390,'enUS','We must breach the inner chamber. Kilrogg cannot get away with this!','',26124),
(79391,'enUS','$p, defend me while I destroy the barrier!','',26124),
(79392,'enUS','This one\'s lost blood.','This one\'s lost blood.',26124),
(79393,'enUS','','I... I can\'t believe he\'s gone...',26124),
(79394,'enUS','Yrel! The defense crystal is broken. The Iron Horde have overrun Karabor. We\'d need a miracle to break through.','',26124),
(79395,'enUS','','%s wipes away a tear.',26124),
(79396,'enUS','','Velen\'s sacrifice means nothing if the temple falls.',26124),
(79397,'enUS','Dorogg has fallen! Stay close, Frostwolves - the citadel is not yet ours.','',26124),
(79398,'enUS','<Dulcet chiming tones reverberate within your mind.>','',26124),
(79399,'enUS','I am ready to join the attack against the Iron Horde.','I am ready to join the attack against the Iron Horde.',26124),
(79400,'enUS','Press the attack!','',26124),
(79401,'enUS','The Frostwolves will triumph.','',26124),
(79402,'enUS','This fortress will fall.','',26124),
(79403,'enUS','Do not give up!','',26124),
(79404,'enUS','Gather your strength!','',26124),
(79405,'enUS','*Sniff*','*Sniff*',26124),
(79406,'enUS','Carry the light, brothers and sisters!','',26124),
(79407,'enUS','Curse him!','',26124),
(79408,'enUS','That was barely a scratch! I should recover quickly.','',26124),
(79409,'enUS','','Samaara is the only family that I have. As long as I can remember, she has taken care of me.$B$BShe is good and kind, whereas I am... not as convicted.',26124),
(79410,'enUS','','For many years, the Shadowmoon Clan and the draenei of Karabor have lived in relative peace.$B$BThings began to change after this... Iron Horde... arrived.',26124),
(79411,'enUS','','Maraad says his injury is not serious, but in truth, he was gravely wounded by Ner\'zhul. Though I am not sure which suffered greater ill - his body or his pride.$B$BNevertheless, he was very lucky you showed up when you did.',26124),
(79412,'enUS','Can you believe this?','Can you believe this?',26124),
(79413,'enUS','What do we have today?','What do we have today?',26124),
(79414,'enUS','Who are you?','Who are you?',26124),
(79415,'enUS','WEEE wee wee!','',26124),
(79416,'enUS','','I will coil your souls into darkness!',26124),
(79417,'enUS','Your blissful afterlife is over.','',26124),
(79418,'enUS','','Too late... my Master... comes...',26124),
(79419,'enUS','','Shadows envelop you!',26124),
(79420,'enUS','','Your oath is unfinished!',26124),
(79421,'enUS','','Return to this world!',26124),
(79422,'enUS','','The spirits are mine to command!',26124),
(79423,'enUS','','I will drown this world in shadows!',26124),
(79428,'enUS','Your undying souls will fuel my ascension from the darkness!','',26124),
(79429,'enUS','Cower before me!','',26124),
(79431,'enUS','','I\'m free!',26124),
(79432,'enUS','','Thank you!',26124),
(79433,'enUS','','My torment is over!',26124),
(79434,'enUS','Keep your wits about you. Some of the refugees reported seeing a plant hydra in the forest near the podling den to the west.','',26124),
(79435,'enUS','It is up to you, champion. I will stay here and help with the wounded slaves you rescued.','',26124),
(79436,'enUS','Please bring her back, $n. She\'s the only family I have left.','',26124),
(79437,'enUS','','Nothing worthwhile ever is.',26124),
(79438,'enUS','We were hunting a large pale orc when the spiders attacked.$b$bI lost my assistant Ganky in the chaos. I was bitten countless times as I ran.$b$bThe spider bites are affecting my ability to think straight. I need to create a cure quickly before my mind escapes me.','',26124),
(79439,'enUS','It looks like this is the bowl Helga was going to use to create a cure.','',26124),
(79440,'enUS','Mushroom show future.  Believe!','',26124),
(79441,'enUS','Wash in holy spores.  Feel might of mushroom!','',26124),
(79442,'enUS','Visions this mushroom has given.  Truth told!','',26124),
(79443,'enUS','Drek\'Thar, old friend, you\'re alive!','',26124),
(79444,'enUS','Who? These strangers you\'ve brought?','',26124),
(79445,'enUS','I know your eyes don\'t work, shaman, but this one has green skin.','',26124),
(79446,'enUS','Hmph. Yes. Ga\'nar is already causing trouble.','',26124),
(79447,'enUS','Very well, strangers. You have earned the trust of our shaman. I will not turn away the help.','',26124),
(79448,'enUS','I can barely stand. But for the actions of these heroes, I would be dead.','',26124),
(79449,'enUS','These are champions from a faraway realm, pledged to fight the Iron Horde.','',26124),
(79450,'enUS','I do not need eyes to see it; they are noble of heart. They saved our kin -- including your brother.','',26124),
(79451,'enUS','Come, friends. If you wish to fight with our clan, we welcome you to receive our blessings.','',26124),
(79452,'enUS','Reach out to the Shamanstone. Embrace the wisdom of this land and the ancestors that came before us.','',26124),
(79453,'enUS','I am still scarred by those infernal warlocks. The spirits are quiet.','',26124),
(79454,'enUS','I can feel it. This land speaks to me, but in a language I do not yet understand.','',26124),
(79455,'enUS','The spirits will never abandon you, Drek\'Thar. This I can promise.','',26124),
(79456,'enUS','','Come with me, shaman. Let me see your wounds.',26124),
(79457,'enUS','','Draka looks at Drek\'Thar, concerned.',26124),
(79458,'enUS','Warriors! Today the tide turns.','',26124),
(79459,'enUS','We will claim Bladespire Citadel as our own.','',26124),
(79460,'enUS','Fight as one. We win this - together!','',26124),
(79461,'enUS','Ga\'nar is a great fighter, but he is impatient. He has taken some of our best warriors with him.','',26124),
(79462,'enUS','He never listens. His ruthlessness may cost us.','',26124),
(79463,'enUS','Here - Gormaul Tower. This will be our foothold. Leave none alive! LOK\'TAR OGAR!','',26124),
(79464,'enUS','Durotan, your brother has already rushed ahead.','',26124),
(79465,'enUS','The Bladespire ogres threw me into that hellhole. I\'ll notch my axe with their skulls until vengeance is mine!','',26124),
(79466,'enUS','Bladespire Citadel! I will have my vengeance on those ogres, even if I have to tear it down stone by stone.','',26124),
(79467,'enUS','','Keep the Iron Horde at bay!',26124),
(79468,'enUS','My friends, you have earned a hero\'s welcome. Follow us to the Frostwolf Chieftain.','',26124),
(79469,'enUS','Wise-ear! You are alive!','',26124),
(79470,'enUS','My eyes may not work, but the familiar chill of the air is comforting.','',26124),
(79471,'enUS','I worry about Ga\'nar. Always quick to fight. His need for vengeance will make him more reckless than ever.','',26124),
(79472,'enUS','Ah yes. Garad\'s youngest: a noble soul named Durotan.','',26124),
(79473,'enUS','Wise beyond his years, but still young. I fear he has been thrust into the Gronn\'s jaws - our people are in great danger.','',26124),
(79474,'enUS','Here we are! Wor\'gol, home of the Frostwolves.','',26124),
(79475,'enUS','You mentioned the Frostwolf Chieftain...','',26124),
(79476,'enUS','Durotan!','',26124),
(79477,'enUS','Visions! No!  You pay for interfering!','',26124),
(79478,'enUS','You fight well, $p! With you here, the odds are stacked in our favor.','',26124),
(79479,'enUS','Lokra... with you at my side, I feel invincible! Let us challenge the Iron Wolf right now and end this!','',26124),
(79480,'enUS','','We leave now, and return to the pack. The Iron Wolf will answer to the full might of the Frostwolf clan.',26124),
(79481,'enUS','Lead us to Durotan, old friend!','',26124),
(79482,'enUS','','Fomic ore is tougher than hardened steel. You will need my goren-toothed pick axe to cut through the rock.',26124),
(79483,'enUS','','The spirits were kind to guide you to me at this moment.',26124),
(79484,'enUS','','It is done! The blade is forged.',26124),
(79486,'enUS','|TInterface\\Icons\\mocking_banner:20|t%s places a |cFFFF0000|Hspell:153799|h[Rallying Banner]|h|r to call nearby allies!','',26124),
(79487,'enUS','','You now stand before Na\'Shra! Weaponsmith of the Frostwolf Clan. For your service, I give you mine.',26124),
(79488,'enUS','','Oops! Wrong wire. Watch out!',26124),
(79491,'enUS','','You have done me a great service. This blade is as much yours as it is mine.$b$bI offer you this blood oath: I shall serve your cause and lend my knowledge of blades and mining to your forces.$b$BWill you accept it?',26124),
(79492,'enUS','Accept the Blood Oath of Blademaster Na\'Shra. (Garrison Follower)','Accept the  Blood Oath of Blademaster Na\'Shra. (Garrison Follower)',26124),
(79495,'enUS','You are hurt. Your flesh is pale.','',26124),
(79496,'enUS','Bandage up those who can still walk! No orc of able body will be denied this fight.','',26124),
(79497,'enUS','So hungry.','So Hungry.',26124),
(79498,'enUS','Mixing','',26124),
(79499,'enUS','Reading','',26124),
(79500,'enUS','The battle is joined. Lok-Narash!','',26124),
(79501,'enUS','Reinforcements approach. Attack!','',26124),
(79502,'enUS','The stench of a boar beast. Beware its tusks... Charge!','',26124),
(79503,'enUS','The tower is ours! Regroup and press on!','',26124),
(79504,'enUS','I will ride ahead. Frostwolves, hold the tower. Igrimar, with me!','',26124),
(79505,'enUS','I will forestall any counterattacks by the enemy. Lok\'tar ogar!','',26124),
(79506,'enUS','$p, I need you out there. There\'s no way we\'ll be able to fight them off without you.','',26124),
(79507,'enUS','Disrupt Rune Conduits to weaken Gor\'ashan\'s defenses.','',26124),
(79508,'enUS','Helga has been like this ever since she returned to camp.$b$bShe was babbling something about needing a cure -- then she started eating dirt.$b$bI am not getting paid enough for this.','',26124),
(79509,'enUS','Why can\'t I ever catch a break?$b$bI figured tagging along with a Nesingwary was a surefire way to make some moolah.$b$bI should have stayed in Azeroth.','',26124),
(79510,'enUS','','What about me? $p and I are a team!',26124),
(79511,'enUS','Absolutely not. I\'m not going to lose you again.','',26124),
(79512,'enUS','','You\'re going to be ok... I promise... just hang in there...',26124),
(79513,'enUS','The barrier is down! Let us put an end to this.','',26124),
(79514,'enUS','Invite Helga to join the caravan?','Invite Helga to join the caravan?',26124),
(79515,'enUS','','The Pale walk these lands at night. They have no morals. They attack children and the elderly without even a second thought.$b$bI will not let their horrible deeds go unpunished.',26124),
(79516,'enUS','','$GHe:She;\'s coming to! $n, talk to me!',26124),
(79517,'enUS','','Am I alive? Who am I? Who are we? So much pain!',26124),
(79518,'enUS','','So many spiders... So many bunnies...',26124),
(79519,'enUS','|TInterface\\Icons\\spell_shadow_chilltouch.blp:20|t%s casts |cFFFF0000|Hspell:154766|h[Summon Ancient Spirits]|h|r!','',26124),
(79520,'enUS','Helga was writing in her journal when she lost it. It\'s right over here.','',26124),
(79521,'enUS','Invisible bunnies? Sheesh... talk about crazy.','',26124),
(79522,'enUS','I would have read it myself, but it\'s not in my job description.','',26124),
(79523,'enUS','You have to do what with the eyeballs? That\'s just gross.','',26124),
(79524,'enUS','Darksting Queen huh? Good luck with that. I\'ll be back here taking care of Helga if you need me.','',26124),
(79525,'enUS','','I... I feel much better. Thank you, $c. Now listen carefully. We need your help.',26124),
(79526,'enUS','I hope this works. I\'m living paycheck to paycheck over here.','',26124),
(79529,'enUS','','Be careful, $n. I\'ll join you as soon as I can.',26124),
(79530,'enUS','Not for long.','',26124),
(79531,'enUS','\"Iron Wolf\" indeed! A coward, hiding behind his minions.','',26124),
(79532,'enUS','','That\'s the third assistant I\'ve lost this week.',26124),
(79533,'enUS','Stand down, Warlord. It is over.','',26124),
(79534,'enUS','','I can\'t thank you enough, $c. This could have been a real disaster.',26124),
(79535,'enUS','Could have been a disaster? I gotta find a new line of work.','',26124),
(79536,'enUS','...Fenris?','',26124),
(79537,'enUS','Helga has no respect for me or any of her other assistants for that matter.$b$bAnd honsetly... the pay ain\'t all that hot.$b$bI think it\'s time I find a new employer.','',26124),
(79538,'enUS','Fenris!','',26124),
(79539,'enUS','Invite Greblin to join the caravan?','Invite Greblin to join the caravan?',26124),
(79540,'enUS','This deal is getting worse all the time.','',26124),
(79541,'enUS','Sure I\'ll join you. As long as the money is good and you promise I won\'t get eaten by spiders.','',26124),
(79542,'enUS','','Great... now I\'ve lost four assistants this week. Thanks, $n.',26124),
(79543,'enUS','','I would be happy to join you and the caravan, $n. Start packing our stuff Greblin.',26124),
(79544,'enUS','','*Sigh* It\'s so hard to find good help these days',26124),
(79545,'enUS','Pack it yourself. I quit. I\'m going to find a job that doesn\'t involve being eaten by spiders.','',26124),
(79546,'enUS','Thought we were dead, eh? LAUGHING SKULL! LAUGHING SKULL! HAHAHAHAHA!','',26124),
(79547,'enUS','Laughing Skull scum!','',26124),
(79548,'enUS','What? No more fancy toys to hide behind? Getting a little scared are you?','',26124),
(79549,'enUS','I\'m gonna cut a smile into that pretty orc face of yours!','',26124),
(79550,'enUS','We are going to rip your little Iron Horde apart piece by piece!','',26124),
(79551,'enUS','My family! My friends! My home! You burned it all and I want it back!','',26124),
(79552,'enUS','And that is the first name on my list. So many more names to go.','',26124),
(79553,'enUS','Chilltongue - devour them!','',26124),
(79554,'enUS','It\'s cold out here.','It\'s cold out here.',26124),
(79555,'enUS','Sarge hears that, you\'ll be on ridge duty all winter.','Sarge hears that, you\'ll be on ridge duty all winter.',26124),
(79557,'enUS','Here you go. I borrowed the wrench from Romuul to fix my spyglass. Tell him I say thank you.','',26124),
(79558,'enUS','','I foresaw your arrival, $n, so here is the crystal that Romuul needs.',26124),
(79559,'enUS','I don\'t drink anymore, $Glad:lass;. Swore ne\'er ta down a cold one until tha day I can see me sweet Elsa once more.','',26124),
(79560,'enUS','Me on tha other hand, I brought plenty o\' stout ta share! Give this ta our wiggly-haired blue friend downstairs.','',26124),
(79561,'enUS','What are you doing?','What are you doing?',26124),
(79562,'enUS','','We are too few to stop the Iron Tide dead in its tracks.$B$BBut, we can fight smartly and take full advantage of their mistakes.',26124),
(79563,'enUS','%s begins to |cFFFF0404|Hspell:153804|h[Inhale]|h|r his enemies!','%s begins to |cFFFF0404|Hspell:153804|h[Inhale]|h|r his enemies!',26124),
(79564,'enUS','','Ah, right here. This disc should contain the information that Romuul is looking for.',26124),
(79565,'enUS','%s\'s piercing screech attracts nearby Carrion Worms!','%s\'s piercing screech attracts nearby Carrion Worms!',26124),
(79566,'enUS','Brother, wait. Let us talk. We are still family.','',26124),
(79567,'enUS','Champion - focus on Fenris.','',26124),
(79568,'enUS','We\'ll take care of Chilltongue!','',26124),
(79569,'enUS','$p, don\'t let Fenris escape!','',26124),
(79570,'enUS','Brother, wait. Let us talk. We are still family.','',26124),
(79571,'enUS','\"Family.\" You are soft - like our father!','',26124),
(79572,'enUS','You dare speak of our father! You gloated over his mangled corpse!','',26124),
(79573,'enUS','A small chieftain of an insignificant clan. I saw what father didn\'t - that we could be so much more.','',26124),
(79574,'enUS','Reinforcements! Slay the Frostwolf pups!','',26124),
(79575,'enUS','Ga\'nar, cover the rear.','',26124),
(79576,'enUS','Yes, brother!','',26124),
(79577,'enUS','Stinking animals, all of you! Sleeping with your dogs.','',26124),
(79578,'enUS','Orcs are meant to be masters of beasts! Masters of all!','',26124),
(79579,'enUS','No slave fights with the will of one who is free.','',26124),
(79580,'enUS','Finish this!','',26124),
(79581,'enUS','Careful, brother!','',26124),
(79582,'enUS','Animals... Your clan is finished... The Iron Horde already comes...','',26124),
(79583,'enUS','Let them come! Traitor!','',26124),
(79584,'enUS','The Thunderlords retreat! They are making their way through Thunder Pass to the Iron Horde.','',26124),
(79585,'enUS','They are going to retaliate. We must be ready.','',26124),
(79586,'enUS','How could he have done this to us?','',26124),
(79587,'enUS','Those were my own nephews I slaughtered in battle!','',26124),
(79588,'enUS','What is this...?','',26124),
(79589,'enUS','The \"Iron Wolf\" is our lost brother. Was... our brother. He was family.','',26124),
(79590,'enUS','No longer.','',26124),
(79591,'enUS','We will bury him as a Thunderlord. With the honors due a chieftain. It was his choice.','',26124),
(79592,'enUS','Come, Durotan. If the Iron Horde wants a fight, we will give it to them. They will NEVER take the pass!','',26124),
(79593,'enUS','Ga\'nar... it is an honor to fight with you at my side. Brother.','',26124),
(79594,'enUS','','Are you okay, husband?',26124),
(79595,'enUS','No, I will never be okay with this.','',26124),
(79596,'enUS','Come! To Thunder Pass. We are outnumbered 50 to 1. They don\'t stand a chance!','',26124),
(79597,'enUS','Thank you, child. I can always count on you.','',26124),
(79598,'enUS','There\'s nothing here.','There\'s nothing here.',26124),
(79599,'enUS','I will speak with this slaver and see if he knows where we might find Orgrim.','',26124),
(79600,'enUS','In the meantime, help Drek\'Thar find some method of destroying that cannon before they find a way to move it.','',26124),
(79601,'enUS','Bring me that ogre, $p. He will be the key to finding Orgrim in this wasteland.','',26124),
(79602,'enUS','Lay down your axe and warm your belly with a brew by the fire.','Lay down your axe and warm your belly with a brew by the fire.',26124),
(79603,'enUS','There! Is this what you seek, Prophet?','',26124),
(79604,'enUS','Grow! Grow!','',26124),
(79605,'enUS','Power in mushrooms.','',26124),
(79606,'enUS','More! More!','',26124),
(79607,'enUS','We draenei are not originally from this world. Our homeworld was named Argus, but it was taken over by the Burning Legion.','We draenei are not originally from this world. Our homeworld was named Argus, but it was taken over by the Burning Legion.',26124),
(79608,'enUS','A small group of survivors, led by Prophet Velen, were able to escape and flee.','A small group of survivors, led by Prophet Velen, were able to escape and flee.',26124),
(79609,'enUS','','Kron approaches! Champion, with me.',26124),
(79610,'enUS','Once, our people had three leaders. Their names were Velen, Archimonde, and Kil\'jaeden.','',26124),
(79611,'enUS','When the Burning Legion came to Argus, Velen was the only one who resisted their promise of immortality and power.','',26124),
(79612,'enUS','Kil\'jaeden leads the Burning Legion\'s demonic army. Once, he was a wise leader of our people, but he fell to the dark promises of the enemy.','Kil\'jaeden leads the Burning Legion\'s demonic army. Once, he was a wise leader of our people, but he fell to the dark promises of the enemy.',26124),
(79613,'enUS','He would chase us to the end of the universe to see our people destroyed.','He would chase us to the end of the universe to see our people destroyed.',26124),
(79614,'enUS','After our ancestors fled from Argus, they traveled across the stars seeking refuge from the Burning Legion.','After our ancestors fled from Argus, they traveled across the stars seeking refuge from the Burning Legion.',26124),
(79615,'enUS','One day, the ships\' energy source, powered by the brilliant light of the naaru, died out. They jettisoned the source from the ship, but it was too late.','One day, the ships\' energy source, powered by the brilliant light of the naaru, died out. They jettisoned the source from the ship, but it was too late.',26124),
(79616,'enUS','Naaru are wise and powerful beings of pure Light. It was a naaru who came to Prophet Velen and helped engineer our escape from the Burning Legion.','Naaru are wise and powerful beings of pure Light. It was a naaru who came to Prophet Velen and helped engineer our escape from the Burning Legion.',26124),
(79617,'enUS','Much about them is still unknown, but when a naaru\'s energy is depleted, it inverts into a darkened state.','Much about them is still unknown, but when a naaru\'s energy is depleted, it inverts into a darkened state.',26124),
(79618,'enUS','Dark naaru are beings of pure shadow, and fearsome to behold.','Dark naaru are beings of pure shadow, and fearsome to behold.',26124),
(79619,'enUS','If I try to release Exurotus it is sure to bring Kron down on us.','',26124),
(79620,'enUS','As pieces of the ship exploded around them, they navigated toward the closest world - a tranquil, untamed land we would later call Draenor.','As pieces of the ship exploded around them, they navigated toward the closest world - a tranquil, untamed land we would later call Draenor.',26124),
(79621,'enUS','We have company, Master.','',26124),
(79622,'enUS','Tagar, deal with the intruder.','',26124),
(79623,'enUS','Champion! I heard Drek\'Thar\'s call. I am with you!','',26124),
(79624,'enUS','Frostwolves! The Iron Horde is coming. As we speak, they march on Thunder Pass.','',26124),
(79625,'enUS','But the Frostwolf clan is reunited! Together, we can protect this land!','',26124),
(79626,'enUS','Lok-Narash, Frostwolves! Prepare for battle!','',26124),
(79627,'enUS','You know me, brother. I\'m always ready to fight.','',26124),
(79628,'enUS','We will hold the line here.','',26124),
(79629,'enUS','','Drek\'Thar, you can speak with the earth. Do you think you can collapse this canyon?',26124),
(79630,'enUS','Stop them! They can\'t be allowed to disturb the master from his trance!','Stop them! They can\'t be allowed to disturb the master from his trance!',26124),
(79631,'enUS','It would be a momentous task... I cannot make any promises.','',26124),
(79632,'enUS','I can. Shaman, if you bring that cliff wall down, I promise that our enemy will be waiting right underneath it.','',26124),
(79633,'enUS','Then I will do my best.','',26124),
(79634,'enUS','You\'d better hurry!  Here they come!','',26124),
(79636,'enUS','You mustn\'t awaken the master!','You mustn\'t awaken the master!',26124),
(79637,'enUS','Kill them!','Kill them!',26124),
(79638,'enUS','Hold your position, Frostwolves! Let them come to you!','',26124),
(79639,'enUS','Bring me more! Your Iron Horde can bleed on my axe!','',26124),
(79640,'enUS','Axes up! Here they come again!','',26124),
(79641,'enUS','We can\'t fight with this cannon fire coming down. Thrall! $p! Take care of that tank!','',26124),
(79642,'enUS','Dabu!','',26124),
(79643,'enUS','You fight like no shaman I have ever seen.','',26124),
(79644,'enUS','I was taught by the best... Drek\'thar.','',26124),
(79645,'enUS','You should tell your teacher to rely less on the hammer, and more on his brains.','',26124),
(79646,'enUS','He would be pleased to hear you say that.','',26124),
(79647,'enUS','...no, not really.','',26124),
(79648,'enUS','Get back here! They\'ll be rallying again soon!','',26124),
(79649,'enUS','Durotan, this isn\'t a choke point... it\'s a meat grinder!','',26124),
(79650,'enUS','','...and yet they still they keep coming.',26124),
(79651,'enUS','I know! That\'s the best part!','',26124),
(79652,'enUS','Durotan! I need help!','',26124),
(79653,'enUS','Drek\'Thar\'s in trouble. Ga\'nar, get out there and lend him a hand.','',26124),
(79654,'enUS','Thought you\'d never ask, brother.','',26124),
(79655,'enUS','You go too, $p.  Make sure my brother doesn\'t get himself killed.','',26124),
(79656,'enUS','I can still hear you!','',26124),
(79657,'enUS','Thank you. I owe you my life.','Thank you. I owe you my life.',26124),
(79658,'enUS','Save the embraces for later, shaman. I\'ve got a kill streak going.','',26124),
(79659,'enUS','Fall back! Prepare for the next attack!','',26124),
(79660,'enUS','','I smell Thunderlords...',26124),
(79661,'enUS','Spears incoming! Hold your ground!','',26124),
(79662,'enUS','Here comes another elekk!','',26124),
(79663,'enUS','','Another elekk on the way!',26124),
(79664,'enUS','Durotan! Tell your pups to come out of the kennel!','',26124),
(79665,'enUS','Hero, approach my totem for aid!','',26124),
(79666,'enUS','','This one\'s mine.',26124),
(79667,'enUS','I\'ll be waiting.','',26124),
(79668,'enUS','','Come back me up, $p.',26124),
(79669,'enUS','Look at this cute little puppy you\'ve sent me, Durotan! Does she know any tricks?','',26124),
(79670,'enUS','','Yeah. A few.',26124),
(79671,'enUS','Come here, puppy. I want to play FETCH.','',26124),
(79672,'enUS','','Well... if it\'ll make you happy, then LET\'S PLAY!',26124),
(79673,'enUS','Draka... come join me in the Iron Horde.  Lose that armor, and settle down with a REAL MAN.','',26124),
(79674,'enUS','','A real man treats his mate with respect!',26124),
(79675,'enUS','','...and he probably would have caught that axe.',26124),
(79676,'enUS','Frostwolves! Stand strong! The battle is nearly done!','',26124),
(79677,'enUS','Drek\'Thar! How much time do you need?','',26124),
(79678,'enUS','Only a bit longer!','',26124),
(79679,'enUS','We are counting on you, shaman!','',26124),
(79680,'enUS','Chieftain, do you hear that rumbling?','',26124),
(79681,'enUS','I do. Something big is coming.','',26124),
(79682,'enUS','Good. I\'ve been waiting for the big one.','',26124),
(79683,'enUS','GRONN!','',26124),
(79684,'enUS','All Frostwolves - charge ahead! Take that thing down!','',26124),
(79685,'enUS','Lok\'tar ogar!','',26124),
(79686,'enUS','For the Frostwolves!','',26124),
(79687,'enUS','','For our home! For our family!',26124),
(79688,'enUS','','I\'m alive!',26124),
(79689,'enUS','If the Thunderlords are to be believed, then the Iron Horde is on its way. It falls on us to prevent them from taking Frostfire Ridge by force.$b$bWe should move forward and defend our homeland at once!','',26124),
(79690,'enUS','Let\'s move forward.','Let\'s move forward.',26124),
(79691,'enUS','Draka, make your way to the cave the scout spotted. I will meet the commander at the coastal village.','',26124),
(79692,'enUS','Champion, we will meet you ahead when you are done with your mission.','',26124),
(79693,'enUS','','Great Prophet! Ner\'zhul is taking the captives to Shaz\'gul.',26124),
(79694,'enUS','BWAAAR! Work harder filthy slave things!','',26124),
(79695,'enUS','Puny workers make me so ANGRY! RARGH!','',26124),
(79696,'enUS','Work or me gonna bash yer skulls!','',26124),
(79697,'enUS','P-please... somebody... anybody...','',26124),
(79698,'enUS','','Lead it away from Drek\'Thar!',26124),
(79699,'enUS','Light p-protect you...','',26124),
(79700,'enUS','Returning to job, infirmary.','Returning to job, infirmary.',26124),
(79701,'enUS','Going on break.','Going on break.',26124),
(79702,'enUS','I will save my clan, even if I must forfeit the souls of my ancestors.','',26124),
(79703,'enUS','Without you, I would still be in that jungle, or worse.','',26124),
(79704,'enUS','Let\'s go meet Durotan.','Let\'s go meet Durotan.',26124),
(79705,'enUS','','We have to stop Teron\'gor and his Bonechewer allies from breaking into Auchindoun at all costs.',26124),
(79706,'enUS','Exurotus is too weak. The most I can do is free him of his bonds. Death will claim him shortly afterward.','',26124),
(79707,'enUS','If I were stronger...','',26124),
(79708,'enUS','','There must be something you can do.',26124),
(79709,'enUS','The fury is dying. We don\'t have much time.','',26124),
(79710,'enUS','There might be something. Exurotus, I offer my spirit as host to your own. Join with me, so that your fire may not be quenched.','',26124),
(79711,'enUS','','I\'m glad you\'re here, $n. Our forces are stretched thin. I need someone I can count on.',26124),
(79712,'enUS','MY SPIRIT... BURNS!','',26124),
(79713,'enUS','','Drek\'Thar, what has it done to you?',26124),
(79714,'enUS','He has become one with the fury. Their spirits are now merged.','',26124),
(79715,'enUS','','The Auchenai are not prepared to defend against an assault like this. Auchindoun is a mausoleum, not a fortress. They need our help.',26124),
(79716,'enUS','I... I can see. I can see the shift of the elements, the movement of the spirits through the land. It is glorious.','',26124),
(79717,'enUS','','If Teron\'gor devours the souls within, the results would be catastrophic.',26124),
(79718,'enUS','The ogres will suffer for what they\'ve done!','',26124),
(79719,'enUS','We are not prepared to defend against an assault like this. Auchindoun is a mausoleum, not a fortress.','',26124),
(79720,'enUS','$n, we must stop Teron\'gor and his Bonechewer allies from breaking into Auchindoun at all costs.','',26124),
(79721,'enUS','If Teron\'gor devours the souls within, the results would be catastrophic.','',26124),
(79722,'enUS','You are too late, hero. Your world will be cast into shadow!','',26124),
(79723,'enUS','I\'m ready to go, Exarch.','I\'m ready to go, Exarch.',26124),
(79724,'enUS','Light bless you.','',26124),
(79729,'enUS','Help me!','',26124),
(79730,'enUS','Coming, $n?','',26124),
(79731,'enUS','Is he dead? I think he was saving me for later. Come on Icepaw, let\'s get out of here.','',26124),
(79732,'enUS','The last time I saw Orac, he was chasing Icepaw out the southern gates of Wor\'gol.','',26124),
(79733,'enUS','You should have seen it uncle! I had that filthy Saberon right where I wanted him.','',26124),
(79734,'enUS','Is that right? Good job, Orac. You will make a fine hunter one day.','',26124),
(79735,'enUS','None escape the Void!','',26124),
(79736,'enUS','We will secure our borders!','We will secure our borders!',26124),
(79737,'enUS','Once Master Blackheart\'s portal is active, he will come to take the key to the Master.','',26124),
(79738,'enUS','The Master needs the key fragment. We will protect it until Lord Blackheart arrives!','',26124),
(79739,'enUS','This world will be ours, just as the Master foretold.','',26124),
(79740,'enUS','This wolf has been gutted and left to rot.','',26124),
(79741,'enUS','','Your pitiful weapons are useless against our Goliath Cannon!',26124),
(79742,'enUS','','How did you survive the Goliath Cannon?',26124),
(79743,'enUS','','Our Goliath Cannon will destroy all that you hold dear.',26124),
(79755,'enUS','Darkness is my strength! With this power, the Shadowmoon will be conquerors!','',26124),
(79756,'enUS','Huh? I must have passed out. I suppose a warm fire and hot meal with my family wouldn\'t be so bad.','',26124),
(79757,'enUS','Flowers?! Noooooo!','',26124),
(79758,'enUS','Please... no flowers...','',26124),
(79759,'enUS','Not me! Not now!','',26124),
(79760,'enUS','Not like this...','',26124),
(79761,'enUS','The legends are true!','',26124),
(79762,'enUS','Anything but flowers!','',26124),
(79763,'enUS','I hate cooking duty. I should be out there hunting.','',26124),
(79764,'enUS','Flowers?','',26124),
(79765,'enUS','No matter. You are too late!','',26124),
(79766,'enUS','Deal with these, insects!','',26124),
(79767,'enUS','Teron\'gor comes for you, mortal...','',26124),
(79768,'enUS','Kill it. It threatens the master!','',26124),
(79769,'enUS','Juicy innards, so fresh...','',26124),
(79770,'enUS','Kill it, eat it, burn it!','',26124),
(79771,'enUS','','Krunk sent you huh? I was just finishing up. I\'ll see you back at camp.',26124),
(79772,'enUS','I\'m not going back until I\'m finished here.','',26124),
(79773,'enUS','This will make a perfect gift for Raa\'la. Thank you, $n. I\'ll meet you back at camp when I\'m done here.','',26124),
(79775,'enUS','|TInterface\\Icons\\ability_druid_astralstorm.blp:20|t%s casts |cFFFF0000|Hspell:155105|h[Soul Storm]|h|r!','',26124),
(79776,'enUS','Your health is low!$b$bThe Frostwolf healers are located behind the choke point.','Your health is low!$b$bThe Frostwolf healers are located behind the choke point.',26124),
(79777,'enUS','','Hmm. And what are you supposed to be? Are you with the iron orcs? Shall we see if you burn as well as they do?',26124),
(79778,'enUS','Durotan wishes for an alliance.','Durotan wishes for an alliance.',26124),
(79779,'enUS','','On behalf of the Frostwolf clan, I greet you, $c.',26124),
(79780,'enUS','The pain of this stake is nothing compared to that of my failure...','',26124),
(79781,'enUS','My heart aches with grief for the loss of my kin...','',26124),
(79782,'enUS','','So the wolves have come to play with the skulls? I will speak with Durotan but I will not hold out hope. His wolves are soft and lack conviction.',26124),
(79783,'enUS','They were saving me for dessert!','Boy am I glad to see you!',26124),
(79784,'enUS','Thanks pal! I\'d offer you a reward but you don\'t seem like the type!','I never thought I would get out of here!',26124),
(79785,'enUS','Thanks, friend! I\'ll let you buy me a drink back at the arena!','They took my coin purse too...got any gold I can borrow?',26124),
(79786,'enUS','They were going to eat me!','I thought I was done for! Thanks pal!',26124),
(79787,'enUS','Those dirty bags of fur came out of nowhere!','How could this happen to me?!',26124),
(79788,'enUS','Ahhh!!!!! Finish it! Just let me die!','',26124),
(79789,'enUS','Emma was here recently. Follow her trail up the hill!','Emma was here recently. Follow her trail up the hill!',26124),
(79790,'enUS','1...','1...',26124),
(79791,'enUS','2...','2...',26124),
(79792,'enUS','3...','3...',26124),
(79793,'enUS','I\'m almost certain it\'s Yrel, but Maraad can\'t afford the distraction right now. If she\'s alive, we\'ll rescue her.','',26124),
(79794,'enUS','Discovered Shamanstone: Blessing of the Wolf','Discovered Shamanstone: Blessing of the Wolf',26124),
(79795,'enUS','Discovered Shamanstone: Spirit of the Wolf','Discovered Shamanstone: Spirit of the Wolf',26124),
(79796,'enUS','Discovered Shamanstone: Touched by Fire','Discovered Shamanstone: Touched by Fire',26124),
(79797,'enUS','Touched by Ice','Touched by Ice',26124),
(79798,'enUS','Discovered Shamanstone: Buffeting Galefury','Discovered Shamanstone: Buffeting Galefury',26124),
(79799,'enUS','Discovered Shamanstone: Ogrish Fortitude','Discovered Shamanstone: Ogrish Fortitude',26124),
(79800,'enUS','$p, speak with Kaz to see if she has some ideas on other ways in which to disrupt the Blackrock Outpost.','',26124),
(79801,'enUS','Buffeting Galefury','Buffeting Galefury',26124),
(79802,'enUS','Ogrish Fortitude','Ogrish Fortitude',26124),
(79803,'enUS','Touched by Fire','Touched by Fire',26124),
(79804,'enUS','Discovered Shamanstone: Touched by Ice','Discovered Shamanstone: Touched by Ice',26124),
(79805,'enUS','And here\'s where they caught up with her.','',26124),
(79806,'enUS','Duck!','Duck!',26124),
(79807,'enUS','Whoa!','Whoa!',26124),
(79808,'enUS','Ahhh!','Ahhh!',26124),
(79809,'enUS','What on Draenor?!','What on Draenor?!',26124),
(79810,'enUS','Curses!','Curses!',26124),
(79811,'enUS','Ack!','Ack!',26124),
(79812,'enUS','Oof!','Oof!',26124),
(79813,'enUS','Watch out!','Watch out!',26124),
(79814,'enUS','The intruders are here! Shadowmoon orcs, take your positions!','',26124),
(79815,'enUS','Gunners, roll out! Don\'t let them into the hold!','',26124),
(79816,'enUS','Oh, nelly, ain\'t she a big \'un? Ya need ta get back up there an\' tell Maraad.','',26124),
(79817,'enUS','Don\'t let them through! Release the wolves!','',26124),
(79818,'enUS','DIE!!!','',26124),
(79819,'enUS','','I am trying to divine Ner\'zhul\'s plans, but alas, I have nothing yet.',26124),
(79820,'enUS','No excuses, Kor\'gall. We are at WAR with another world. Motivate your people, get a mining pick yourself, I do not care. You WILL meet your quota or find your clan the target of our next weapon test.','',26124),
(79821,'enUS','Here, let me make some adjustments.','',26124),
(79822,'enUS','There ya go.','',26124),
(79823,'enUS','And while you\'re in there, get the main cannon firing again.','',26124),
(79824,'enUS','Dis gonna be bad...','',26124),
(79825,'enUS','But...me afraid of heights!','',26124),
(79826,'enUS','Me fly like birdy? Me no have wings!','',26124),
(79827,'enUS','I can feel my lord\'s power... coursing through my veins...','',26124),
(79828,'enUS','DIE IN THE NAME OF TERON\'GOR!','',26124),
(79829,'enUS','I will use Auch\'naaru to enact your will, my lord!','',26124),
(79830,'enUS','Teron\'gor said... we would have the bodies... and he would eat the souls...','',26124),
(79832,'enUS','There were too many of them.','There were too many of them.',26124),
(79833,'enUS','Is that the best you can do?','',26124),
(79834,'enUS','Filthy coward.','',26124),
(79835,'enUS','Hansel! What\'s going on down there?!','',26124),
(79836,'enUS','Find these Iron Horde cowards. Give them the Light\'s justice.','',26124),
(79837,'enUS','No mercy for the likes of you.','',26124),
(79838,'enUS','The Iron Horde\'s days are numbered.','',26124),
(79839,'enUS','Thaelin, I want the Tank ready to go. Now!','',26124),
(79840,'enUS','Is there no end to these orcs?','',26124),
(79841,'enUS','We\'re saved! Thank you, hero.','We\'re saved! Thank you, hero.',26124),
(79842,'enUS','Kor\'gall, your guards are worthless. Dispose of this invader.','',26124),
(79843,'enUS','Durotan? Draka? What are YOU doing here?','',26124),
(79844,'enUS','Agreed, Soulbinder. We cannot risk leaving Auchindoun vulnerable even for a moment. We will stand our ground with what forces we have left.','',26124),
(79845,'enUS','Orgrim Doomhammer! You will be made to answer for your attack on my people!','',26124),
(79846,'enUS','You will bow before me as you beg for death.','',26124),
(79847,'enUS','Did you mistake me for one of those weak creatures we have you fight in the arenas?','',26124),
(79848,'enUS','Your Iron Horde murdered my brother, threatened my people, and deal in slaves and blood. You would have us work with that?','',26124),
(79849,'enUS','Stay your hand, hero. I want him alive.','',26124),
(79850,'enUS','','Auchindoun is safe as long as it is kept sealed. We need to retrieve the fragments so my priests can protect them.',26124),
(79851,'enUS','I have not forgotten or forgiven that. But Orgrim was once an honorable orc, and my closest friend. I owe it to him to at least try to help him regain some of his honor.','',26124),
(79852,'enUS','Always sentimental, Durotan. I am as loyal to my people as you are to yours. Do not presume that I walk this path willingly. Some things are more important than honor.','',26124),
(79853,'enUS','','Husband? It was his forces that killed your brother.',26124),
(79854,'enUS','That\'s enough. We don\'t have the men to spare. We\'re staying here.','',26124),
(79855,'enUS','The Dark Emanation breaks free of its bonds!','',26124),
(79856,'enUS','','We have to get to the other shards before it\'s too late.',26124),
(79857,'enUS','','Wait, $n... I will come with you.',26124),
(79858,'enUS','INCOMING! TAKE COVER!','',26124),
(79859,'enUS','Friends, be ready to move out. This hero is going to secure us an entrance in to that slave camp!','',26124),
(79860,'enUS','For Doomhammer!','For Doomhammer!',26124),
(79861,'enUS','Another shot like that from the Iron Horde and we\'re done. We need to destroy whatever\'s firing those massive rounds.','',26124),
(79862,'enUS','Satchel charges are all over the place in there. But, we\'ll have to go all the way to the bottom to get the big cannon firing again.','',26124),
(79863,'enUS','Follow me, $n. I will perform last rites on my fallen brethren. You rid the temple of any Iron Horde stragglers.','Follow me, $n. I will perform last rites on my fallen brethren. You rid the temple of any Iron Horde stragglers.',26124),
(79864,'enUS','There\'s the button. Press it to restart the Big Cannon.','',26124),
(79865,'enUS','I am ready to go.','I am ready to go.',26124),
(79866,'enUS','See if Hansel needs anything on your way down.','',26124),
(79873,'enUS','So much for subtlety. Those Laughing Skull are going to get us all killed.','',26124),
(79874,'enUS','Hmph. I remember ogre architecture being more formidable.','',26124),
(79875,'enUS','I\'ll kill you like I killed the rest of them!','',26124),
(79876,'enUS','Thank the Light you came when you did.','Thank the Light you came when you did.',26124),
(79881,'enUS','','May the Light guide our blades into the hearts of our enemies.',26124),
(79882,'enUS','I\'m ready to go when you are.','I\'m ready to go when you are',26124),
(79883,'enUS','','Let\'s go, $p.',26124),
(79884,'enUS','You sack of useless worms for brains! Why isn\'t that wheel fixed yet?','',26124),
(79885,'enUS','A rock could fix that wheel faster than you!','',26124),
(79886,'enUS','Get that wheel repaired or I\'ll throw you to the Pale! Hurry up!','',26124),
(79887,'enUS','Are the repairs finished yet? The Shadowmoon are waiting for us.','',26124),
(79888,'enUS','Thank you for saving me, hero. They\'re taking more prisoners on top of the mountain!','Thank you for saving me, hero. They\'re taking more prisoners on top of the mountain!',26124),
(79889,'enUS','<Move out to Spineling Crevice.>','<Move out to Spineling Crevice.>',26124),
(79890,'enUS','Velen sent me. We seek information about Ner\'zhul.','Velen sent me. We seek information about Ner\'zhul.',26124),
(79891,'enUS','','Welcome to my fire, traveler. I know much of Ner\'zhul, and yet these days, I know him not at all.',26124),
(79892,'enUS','I issued no such order. I wanted your people to join us and protect this world from the threat of those beyond the portal.','',26124),
(79893,'enUS','Vehicle Control Overridden. Returning to Creator.','',26124),
(79895,'enUS','Hello traveler. Where would you like to fly today?','',26124),
(79897,'enUS','I am glad you see the wisdom in this course, Durotan. I hope Maraad and the Alliance do as well.','',26124),
(79898,'enUS','I have never held the prejudices against the Draenei that some of my people do, Khadgar.','',26124),
(79899,'enUS','There is reason in your plan, and I agree to take part. My clan will stay its hand when we enter the city.','',26124),
(79900,'enUS','You can trust in Khadgar\'s plan, Durotan. His cause is just and motivations are noble.','',26124),
(79901,'enUS','You are my vanguard.','',26124),
(79902,'enUS','These shores are ours!','',26124),
(79903,'enUS','Leave no enemy alive!','',26124),
(79904,'enUS','Iron will, iron blood.','',26124),
(79905,'enUS','Go forth to victory!','',26124),
(79907,'enUS','Commander.$B$BWe\'ve secured Lok-rath and the Warsong.$B$BI await your orders.','',26124),
(79908,'enUS','','We cannot allow the Warsong to continue to nip at our heels.$B$BWe cannot allow the ogres of Highmaul to regain the glory of their lost Gorian Empire.$B$BWe must protect our own and bring justice to Nagrand before it brings ruin upon us.',26124),
(79909,'enUS','Not long ago, we were orcs of many clans, quibbling over scraps in a world that was ours for the taking.','',26124),
(79910,'enUS','Now, as one clan, no enemy can hope to stand against the Iron Horde!','',26124),
(79911,'enUS','We will crush their bones beneath our boots.  We will burn their cities to ash!','',26124),
(79912,'enUS','The iron tide washes over them!','',26124),
(79913,'enUS','Closing','Closing',26124),
(79914,'enUS','The doom that is coming will destroy us all. These outsiders will bring a wave of fire and death down upon us if the orcs do not act as one to destroy them first.','',26124),
(79915,'enUS','Because I have witnessed it! Every night! Every night for many months now. My dreams become nightmares, and in those nightmares I watch helplessly as the land corrupts beneath our feet and the sky is turned to fire.','',26124),
(79916,'enUS','Say what you will, but this is the doom that is coming. And it is these creatures from beyond the portal that will bring it.','',26124),
(79917,'enUS','And how can you be so certain of such a fate?','',26124),
(79918,'enUS','','I have never known the great Doomhammer to be afraid of anything.',26124),
(79919,'enUS','Cho\'gall! I sent you here to enslave this thing.','',26124),
(79920,'enUS','','Be careful not to get overwhelmed! They pack a punch!',26124),
(79921,'enUS','Let\'s begin the assault!','Let\'s begin the assault!',26124),
(79922,'enUS','If we are able to repel the Iron Horde from Shattrath, it will be a great blow to their strategy. If we manage to take out their Superweapon as well...','',26124),
(79923,'enUS','Take these torches and cleanse our temple of the fallen Orcs.','Take these torches and cleanse our temple of the fallen Orcs.',26124),
(79924,'enUS','You will be forever missed, my dear friend.','You will be forever missed, my dear friend.',26124),
(79925,'enUS','Velen will seek justice for this travesty, of this I am certain.','Velen will seek justice for this travesty, of this I am certain.',26124),
(79926,'enUS','','Have you seen my parents?',26124),
(79927,'enUS','You there! Please... can\'t breathe...','',26124),
(79928,'enUS','I do not know who you are, but I will not forget your actions this day.','',26124),
(79929,'enUS','Lok\'tar... friend. Let us meet above here at my village.','',26124),
(79930,'enUS','','Yes! Let us free ALL of the skulls! Remind them how to laugh! Burn all of the slavers to ash and ruin!',26124),
(79931,'enUS','Hrah ha ha ha ha! It\'s stabbing time!','Hrah ha ha ha ha! It\'s stabbing time!',26124),
(79932,'enUS','Stab all of the things!','Stab all of the things!',26124),
(79933,'enUS','Burn the slavers! Whip their hides! Make them crawl!','Burn the slavers! Whip their hides! Make them crawl!',26124),
(79934,'enUS','Ogres are going to fear the Skulls again!','Ogres are going to fear the Skulls again!',26124),
(79935,'enUS','I\'m baaaack!','I\'m baaaack!',26124),
(79936,'enUS','It... is... ogre stabbing time!','It... is... ogre stabbing time!',26124),
(79937,'enUS','Thank you, $n. We are in your debt.','',26124),
(79938,'enUS','I heard ogres with one eye are smarter than those with two. Perhaps we should test this?','I heard ogres with one eye are smarter than those with two. Perhaps we should test this?',26124),
(79939,'enUS','Death awaits you, traitor...','',26124),
(79940,'enUS','Taking all bets. How many pokes with my poking stick until this slaver scum squeals?','Taking all bets. How many pokes with my poking stick until this slaver scum squeals?',26124),
(79941,'enUS','Oh, we will get you to laugh. They always laugh... before the end.','Oh, we will get you to laugh. They always laugh... before the end.',26124),
(79942,'enUS','I wonder. Will the wolves will let us keep you?','I wonder. Will the wolves will let us keep you?',26124),
(79943,'enUS','Ah, the great one who is neither a wolf or a skull.$b$bWill you chose a banner you will answer to? Or will the banners answer to you in the end, I wonder.','Ah, the great one who is neither a wolf or a skull.$b$bWill you chose a banner you will answer to? Or will the banners answer to you in the end, I wonder.',26124),
(79944,'enUS','Many thanks, great one, for reminding me of who and what I really am. May the Iron Horde dread the day they remember who and what I really am.','Many thanks, great one, for reminding me of who and what I really am. May the Iron Horde dread the day they remember who and what I really am.',26124),
(79945,'enUS','You have earned the aid of the skulls, hero. Try not to get as squeamish as one of your wolves when you learn what that truly means.','You have earned the aid of the skulls, hero. Try not to get as squeamish as one of your wolves when you learn what that truly means.',26124),
(79946,'enUS','I look forward to stabbing your enemies in the face.','I look forward to stabbing your enemies in the face.',26124),
(79947,'enUS','Limbflayer says you saved him from a burning building. Did you also save the money he owes me?','Limbflayer says you saved him from a burning building. Did you also save the money he owes me?',26124),
(79948,'enUS','','LAUGHING...',26124),
(79949,'enUS','SKULLS!','SKULLS!',26124),
(79950,'enUS','Witness our power! Iron will, iron blood!','',26124),
(79951,'enUS','Destroy the Heat Regulators to release the Heart of the Mountain inside the furnace.','Destroy the Heat Regulators to release the Heart of the Mountain inside the furnace.',26124),
(79952,'enUS','|TInterface\\Icons\\ability_foundryraid_bellows.blp:20|tThe Bellows Operators are increasing the heat of the furnace, defeat them quickly to stop the heat level from increasing.','|TInterface\\Icons\\ability_foundryraid_bellows.blp:20|tThe Bellows Operators are increasing the heat of the furnace, defeat them quickly to stop the heat level from increasing.',26124),
(79953,'enUS','One Pressure Regulator has been destroyed. One remains.','One Pressure Regulator has been destroyed. One remains.',26124),
(79954,'enUS','Both Heat Regulators have been destroyed. The Heart of the Mountain is unleashed!','Both Heat Regulators have been destroyed. The Heart of the Mountain is unleashed!',26124),
(79955,'enUS','Defeat the Primal Elementalists to release the Heart of the Mountain from its bindings.','Defeat the Primal Elementalists to release the Heart of the Mountain from its bindings.',26124),
(79956,'enUS','Three Primal Elementalists remain.','Three Primal Elementalists remain.',26124),
(79957,'enUS','Two Primal Elementalists remain.','Two Primal Elementalists remain.',26124),
(79958,'enUS','One Primal Elementalist remains.','One Primal Elementalist remains.',26124),
(79959,'enUS','All Primal Elementalists have been defeated. The Heart of the Mountain is free!','All Primal Elementalists have been defeated. The Heart of the Mountain is free!',26124),
(79960,'enUS','Protect the furnace at all costs!','',26124),
(79961,'enUS','Get those billows pumping!','',26124),
(79962,'enUS','Turn up the heat boys, we\'ll sweat \'em out!','',26124),
(79963,'enUS','Call in more security!','',26124),
(79964,'enUS','The Fury has broken free!','',26124),
(79965,'enUS','I will crush you!','',26124),
(79966,'enUS','Die scum!','',26124),
(79967,'enUS','RAWR!','',26124),
(79968,'enUS','Smash!','',26124),
(79969,'enUS','Weak!','',26124),
(79970,'enUS','Pathetic!','',26124),
(79971,'enUS','awww...aaaaggg...','',26124),
(79972,'enUS','','The Fury has broken free!',26124),
(79973,'enUS','','Quick, get it under control!',26124),
(79974,'enUS','Guards! Intruders are meddling with the Blast Furnace!','',26124),
(79975,'enUS','The machinery is damaged. Keep those scum from sabotaging the furnace!','',26124),
(79976,'enUS','The furnace is overheating! Fools, if the Fury breaks free, our work will be ruined!','',26124),
(79977,'enUS','Fury under control, sending in additional security personel to clear intruders from the area.','',26124),
(79978,'enUS','We\'re losing containment personnel. Get it together security teams!','',26124),
(79979,'enUS','A small victory, but now you will perish in the flame that burns at the heart of Blackrock!','',26124),
(79980,'enUS','Enjoy your victory while you can. The fires of the Blast Furnace are but a candle to the heart of the volcano where you\'ll face me!','',26124),
(79981,'enUS','|TInterface\\Icons\\ability_fixated_state_red.blp:20|t%s |cFFFF0404|Hspell:154952|h[Fixates]|h|r on you!','|TInterface\\Icons\\ability_fixated_state_red.blp:20|t%s |cFFFF0404|Hspell:154952|h[Fixates]|h|r on you!',26124),
(79983,'enUS','Stand strong, defenders of Karabor! Carry the light with you!','',26124),
(79984,'enUS','Together we can repel these orcs!','',26124),
(79985,'enUS','Let the Light carry you through this battle!','',26124),
(79986,'enUS','The Iron Tide will wash over our enemies!','',26124),
(79987,'enUS','Aaaaaaaaaaahhhhhhhh! Ha ha ha!','',26124),
(79988,'enUS','Fire! Fire! Waa-aaaaaa! Ha!','',26124),
(79989,'enUS','...TREMOR-TRACKER V.2.6 ONLINE...','',26124),
(79990,'enUS','...TRACKING...FAILED::REDUCING FOCAL DEPTH....TRACKING...FAILED::REDUCING FOCAL DEPTH...','',26124),
(79991,'enUS','Drogguk was a proud orc. Thank you for bringing honor to his death.','',26124),
(79992,'enUS','...HYPOCENTER DISPLACEMENT::TWENTY PERCENT...','',26124),
(79993,'enUS','...WARNING::INCOMING BODY WAVE...','',26124),
(79994,'enUS','...WARNING::GROUND FAILURE DETECTED...','',26124),
(79995,'enUS','See what I mean? We cannot pinpoint the source of the activity...','',26124),
(79996,'enUS','Huh... the source is moving? How is that even possible?!','',26124),
(79997,'enUS','Uh oh... Brace yerself!','',26124),
(79998,'enUS','\"Ground failure?\" Oh, ye think?! It\'s spittin\' out orcs!','',26124),
(79999,'enUS','...TRACKING...NEW HYPOCENTER DETECTED...TRACKING...DISPLACEMENT::FIFTY PERCENT...','',26124),
(80000,'enUS','Here comes another one!','',26124),
(80001,'enUS','...WARNING::GROUND FAILURE IMMINENT...','',26124),
(80002,'enUS','ALRIGHT, WE GET IT.','',26124),
(80003,'enUS','...TRACKING...NO ACTIVITY DETECTED...','',26124),
(80004,'enUS','...FINAL ANALYSIS::ACTIVITY SOURCE DETERMINED TO BE UNNATURAL...','',26124),
(80005,'enUS','...THANK YOU FOR USING TREMOR-TRACKER...HAVE A NICE DAY...','',26124),
(80006,'enUS','Oh, thank my boots it\'s over...','',26124),
(80007,'enUS','Aye, brilliant analysis. Thanks.','',26124),
(80008,'enUS','','I\'ll give you goren something to eat!',26124),
(80009,'enUS','','Yrel.... noooo!',26124),
(80010,'enUS','Champion, we will secure the road.','',26124),
(80011,'enUS','K\'ara has chosen you to break the siege - the naaru\'s power will enhance you.','',26124),
(80012,'enUS','Yrel, where is Prophet Velen?','',26124),
(80013,'enUS','','Prophet Velen is... no more.',26124),
(80014,'enUS','','But his light is within all of us now. Nothing can stop us.',26124),
(80015,'enUS','Champion, go! Cleanse that base!','',26124),
(80016,'enUS','Let us leave this place. Yrel has already returned to Karabor, and wishes to speak to us both. [NYI - Shadowmoon Playtest Complete!]','',26124),
(80022,'enUS','We have pushed them back to their bastion.$b$bNow it is time to drive them out of Shadowmoon once and for all.','',26124),
(80023,'enUS','Let\'s do it, then.','Let\'s do it, then.',26124),
(80024,'enUS','Hero, meet us at Twilight Glade. We must save the prisoners.','',26124),
(80025,'enUS','','The work of prophecy is difficult. Sight of the future is often clouded, and one must rely on instinct to discern what WILL come to pass, and what MIGHT come to pass.',26124),
(80026,'enUS','Freeeedommmmm!','',26124),
(80027,'enUS','I will reduce you all to ashes!','',26124),
(80028,'enUS','Inferno!','',26124),
(80029,'enUS','Drown in fire!','',26124),
(80030,'enUS','My flames will lick the flesh from your bones!','',26124),
(80031,'enUS','SUFFER!','',26124),
(80032,'enUS','I consume all!','',26124),
(80033,'enUS','Die!','',26124),
(80034,'enUS','Burn!','',26124),
(80035,'enUS','My fire is... Exting..uished.','',26124),
(80036,'enUS','I will burn this mountain unto ash!','',26124),
(80037,'enUS','Can\'t take the heat? Get out of the furnace!','',26124),
(80038,'enUS','Intruders at the Blast Furnace have been eliminated. Throw their bodies into the furnace and return to your posts!','',26124),
(80039,'enUS','','Burn burn burn burn torch and burn and cinder and burn and FIRE!',26124),
(80040,'enUS','Frostwolves and Laughing Skulls? Working together? You orcs are more desperate than I suspected.','',26124),
(80041,'enUS','Well done, $n. These crystals fell from our vessel centuries ago when we first arrived on this world.','',26124),
(80042,'enUS','Sadly, the \"Dark Star\" Ner\'zhul spoke of also came with us.','',26124),
(80043,'enUS','I fear our arrival here has forever altered the fate of the Shadowmoon orcs.','',26124),
(80044,'enUS','','I\'ll be okay. Thank you again for all of your help, $n.',26124),
(80045,'enUS','You\'ve done good work here, champion. Now we only have three more crystals to find.','',26124),
(80046,'enUS','Are you lost, stranger?','Are you lost, stranger?',26124),
(80047,'enUS','An outsider approaches.','An outsider approaches.',26124),
(80048,'enUS','Halt right there.','Halt right there.',26124),
(80049,'enUS','Tread carefully, stranger.','Tread carefully, stranger.',26124),
(80050,'enUS','','Stay your weapons. This must be the messenger the draenei prophet promised.',26124),
(80051,'enUS','','Please find the prisoners, hero. My sister is among them. Were I a fighter, I could help you...',26124),
(80052,'enUS','I have learned the hard way, Yrel. You must fight for what you love, with every fiber of your being.','',26124),
(80053,'enUS','Trust in the light to protect you - and if that fails, trust in yourself to do what must be done.','',26124),
(80054,'enUS','','Prophet - are you okay?',26124),
(80055,'enUS','I could not help but overhear. Maraad is right. Sometimes, we must give ourselves wholly to the cause.','',26124),
(80056,'enUS','But we must never, ever, forsake the light... Even should it consume us.','',26124),
(80057,'enUS','Excellent! This crystal has been lost to us for decades.','',26124),
(80058,'enUS','The energy you gather is our only hope if we are forced to encounter the shadow of the Dark Star...','',26124),
(80059,'enUS','This is the first of four crystals. We must find the others!','',26124),
(80060,'enUS','This was the final crystal. See me atop Mount Teluuna when your work is done, champion.','',26124),
(80061,'enUS','Ner\'zhul struggles to earn the trust of the Iron Horde.','',26124),
(80062,'enUS','To do so, he\'s dabbling with terrible shadow magic he cannot possibly control.','',26124),
(80063,'enUS','If he succeeds in bringing down the Dark Star, his clan - and his world - will suffer for his arrogance.','',26124),
(80064,'enUS','We have located two of the four crystals. We must find the others before Ner\'zhul completes his ritual.','',26124),
(80065,'enUS','Only one crystal remains. We need all of their power if we are to succeed.','',26124),
(80066,'enUS','This was the final crystal. See me atop Mount Teluuna - there is no time to lose!','',26124),
(80067,'enUS','Thanks for your help, $n. I\'ll report these findings back to Velen.','',26124),
(80068,'enUS','','Fenris Wolfbrother was once a Frostwolf, but his ambition and pride led him astray. He left the pack in search of personal glory, and fell in with our hated enemies.$B$BWho knows where my own reckless ways would have led me... where I\'d be now if you hadn\'t found me in Bladespire.$B$BAmbition and talent will grant you the power to take many lives. But the strength required to protect even one... that comes from somewhere else.$B$BThank you, $p.',26124),
(80069,'enUS','','The crystal that we came for is right over there, on the hill.',26124),
(80070,'enUS','','The podlings were saving these elekk to snack on later. If you wish, ride this one back to the outskirts of the forest.',26124),
(80071,'enUS','','I cannot sit back and watch Karabor burn, $n.  I am coming with you.',26124),
(80072,'enUS','','I am no fighter, but I will do my best.',26124),
(80073,'enUS','','I was trained in this temple. I expected to spend my whole life here.',26124),
(80074,'enUS','','I never expected to come back from the slave camps of Tanaan, only to see my home in flames.',26124),
(80075,'enUS','','You fight heroically, $n.  You are an inspiration.',26124),
(80076,'enUS','','I thought we would be safe here! Who would attack a temple?',26124),
(80077,'enUS','','Once this is over, I hope to return to my studies.',26124),
(80078,'enUS','','I\'m not trained for combat. I am no Vindicator!',26124),
(80079,'enUS','','They will turn our palace of light into some sort of... dark temple!',26124),
(80080,'enUS','','That must be their leader, up on the gardenhouse.',26124),
(80081,'enUS','','Watch your step, $n! He\'s burning everything in sight!',26124),
(80082,'enUS','','I will aid you as best I can.',26124),
(80083,'enUS','','These orcs are forged of steel and fire. They never used to act this way.',26124),
(80084,'enUS','','I suppose that works.',26124),
(80085,'enUS','','You are... brutal and direct. You have seen combat before.',26124),
(80086,'enUS','','I shudder to imagine the carnage outside of our walls.',26124),
(80087,'enUS','','Problem solved.',26124),
(80088,'enUS','','Will our temple ever recover from being a war zone?',26124),
(80089,'enUS','|TInterface\\Icons\\item_summon_cinderwolf.blp:20|t%s summons|cFFFF0000 Cinder Wolves|r!','|TInterface\\Icons\\item_summon_cinderwolf.blp:20|t%s summons|cFFFF0000 Cinder Wolves|r!',26124),
(80090,'enUS','','They are just throwing their lives away!',26124),
(80091,'enUS','','They are just throwing their lives away!',26124),
(80092,'enUS','','The prophet is just up ahead!',26124),
(80093,'enUS','','Hurry, $n!  I see Velen up ahead!',26124),
(80094,'enUS','','Prophet Velen will save us.',26124),
(80095,'enUS','|TInterface\\Icons\\spell_shaman_stormearthfire.blp:20|t%s begins to channel |cFFFF0404|Hspell:155493|h[Firestorm]|h|r!','|TInterface\\Icons\\spell_shaman_stormearthfire.blp:20|t%s begins to channel |cFFFF0404|Hspell:155493|h[Firestorm]|h|r!',26124),
(80096,'enUS','Ner\'zhul has shown us power in the darkness!','Ner\'zhul has shown us power in the darkness!',26124),
(80097,'enUS','The ritual will soon be complete. The Dark Star comes!','The ritual will soon be complete. The Dark Star comes!',26124),
(80098,'enUS','Your blood will feed the Dark Star...','Your blood will feed the Dark Star...',26124),
(80099,'enUS','The Void calls to us!','The Void calls to us!',26124),
(80100,'enUS','Strength through darkness.','',26124),
(80101,'enUS','Ner\'zhul peered into the void, and it answered...','',26124),
(80102,'enUS','Ner\'zhul has given us power over the void!','',26124),
(80103,'enUS','We\'re being attacked!','',26124),
(80104,'enUS','They\'re destroying our city!','',26124),
(80105,'enUS','The draenei will fall, and ALL will kneel before the void.','',26124),
(80106,'enUS','Thank you, champion. I have always felt my fate and that of the Dark Star are intertwined.','',26124),
(80107,'enUS','Light. Pure light. Hope in times of despair, brightness in our darkest hour!','',26124),
(80108,'enUS','Ner\'zhul\'s ritual... begins! We are out of time!','',26124),
(80109,'enUS','We must stop the Shadowmoon Chieftain.','',26124),
(80110,'enUS','What needs to be done, child.','',26124),
(80111,'enUS','Hurry, champion. I will get there as soon as I can.','',26124),
(80112,'enUS','Do whatever you can to delay Ner\'zhul...','',26124),
(80113,'enUS','','Prophet! What have you done to yourself!?',26124),
(80114,'enUS','MMmmff! Mmffmf!!','',26124),
(80115,'enUS','Come on, then! The prototype should be able to take us to Thaelin!','',26124),
(80118,'enUS','<Nightstalker keeps scratching at the rickety wooden barrier.>','',26124),
(80119,'enUS','You don\'t have to do this, Yrel. Take the survivors and flee.','',26124),
(80120,'enUS','LAUGHING SKULL! LAUGHING SKULL! HAHAHAHAHA!','',26124),
(80121,'enUS','','LAUGHING SKULL! LAUGHING SKULL! HAHAHAHAHA!',26124),
(80122,'enUS','Now it is time to drive them out of Shadowmoon once and for all.','',26124),
(80123,'enUS','','By the light - what IS that thing!?',26124),
(80124,'enUS','','There\'s got to be a weak spot - get behind it!',26124),
(80125,'enUS','','How did the orcs build such a monstrosity?',26124),
(80126,'enUS','','Is this kind of thing common on your world?',26124),
(80127,'enUS','I\'ve been workin\' on a little secret project whenever the guards are away.','',26124),
(80128,'enUS','Suit! Come to papa!','',26124),
(80129,'enUS','A beauty, isn\'t it? Now let\'s go cause some damage.','',26124),
(80130,'enUS','Guards! GUARDS!? Where are those worthless fools?','',26124),
(80131,'enUS','More Frostwolf scum to feed my pet! Gutgore, attack!','',26124),
(80132,'enUS','Ye gonna be hog food!','',26124),
(80133,'enUS','Intruder in the camp!','',26124),
(80134,'enUS','You just made the wrong choice!','',26124),
(80135,'enUS','Hostile in the camp!','',26124),
(80136,'enUS','Vul\'gath will reward me well when I bring him your head!','',26124),
(80137,'enUS','Your soul is mine!','',26124),
(80138,'enUS','Kill them all!','',26124),
(80139,'enUS','Your attempt to stop me ends now!','',26124),
(80140,'enUS','You struggle against the inevitable.','',26124),
(80141,'enUS','Lok\'tar ogar!','',26124),
(80142,'enUS','I have fallen before...','',26124),
(80143,'enUS','','The Iron Horde represents a clear and present danger to all that we hold dear on Draenor.',26124),
(80144,'enUS','','This data...is shocking. What kind of monster would mutate their own people like this?',26124),
(80145,'enUS','No! Our work cannot be interrupted!','No! Our work cannot be interrupted!',26124),
(80146,'enUS','The Dark Star\'s power flows through us! You will not stop us!','The Dark Star\'s power flows through us! You will not stop us!',26124),
(80147,'enUS','This forest is ours!','',26124),
(80148,'enUS','The Iron Horde were merely testing us...','',26124),
(80149,'enUS','Cindermaw submerges and tunnels southeast.','',26124),
(80150,'enUS','% is overcome with the energy from the crystal.','',26124),
(80151,'enUS','Defend me! I must maintain the portal!','',26124),
(80152,'enUS','Cindermaw submerges and tunnels north.','',26124),
(80161,'enUS','Master Blackheart! Intruders are in the tomb!','',26124),
(80163,'enUS','We do not need your precious key. We are... Legion...','',26124),
(80164,'enUS','Thaelin\'s Quick Fix is ready to deploy!','Thaelin\'s Quick Fix is ready to deploy!',26124),
(80165,'enUS','Yrel! We will spill some orcish blood...','',26124),
(80166,'enUS','I am your Chieftain; you and your warriors will fall back in line.','',26124),
(80167,'enUS','OUR - FATHER - would BE - ASHAMED - of WHAT - YOU\'VE - BECOME!','',26124),
(80168,'enUS','Our strength comes from working together.','',26124),
(80169,'enUS','[PH] Temporary cut-scene with my brother? Let\'s do it!','',26124),
(80170,'enUS','I will crush you!','',26124),
(80171,'enUS','I am FREE!','',26124),
(80172,'enUS','We will help you defeat your enemies. We will repay our debt to you, tiny one.','',26124),
(80173,'enUS','I am in your debt, little one. You have saved my people from an eternity of suffering.','',26124),
(80174,'enUS','','Few of the Frostwolves are willing to trade their goods this far east.',26124),
(80175,'enUS','You may find refuge here, traveler. A battle is always better after a good rest.','You may find refuge here, traveler. A battle is always better after a good rest.',26124),
(80176,'enUS','WHO SENT YOU HERE?! Deathbloom. Surely it was Deathbloom. CURSE YOU!','',26124),
(80177,'enUS','And you... yes! You! Bow to your traitor king and DIE FOR YOUR INSOLENCE!!!','',26124),
(80178,'enUS','','Though I cannot bear to see my only child destroyed, I also would not feel right sending you into the spirit world alone.',26124),
(80179,'enUS','','My spirit will cross over with you. Return to me when the deed is done.',26124),
(80180,'enUS','I am glad you see the wisdom in this course, Maraad. I trust Durotan and his clan will as well.','',26124),
(80181,'enUS','I concede that Durotan is indeed a wiser leader than most of his kind.','',26124),
(80182,'enUS','If you can convince him of this plan of yours, we will comply.','',26124),
(80183,'enUS','I am ready to begin the Battle for Shattrath! [Queue for solo instance.]','I am ready to begin the Battle for Shattrath! [Queue for solo instance.]',26124),
(80184,'enUS','FOOL! I will not be lured out so easily!','',26124),
(80185,'enUS','Orgrim spoke proudly of the might of the Iron Horde, but I never imagined that they would be THIS massive. The sheer size of this place...$b$bOur small party cannot hope to take this base down, but we can certainly try to keep those ships from leaving the harbor. Are you with me, $n?','',26124),
(80186,'enUS','I am with you, Warchief.','I am with you, Warchief.',26124),
(80187,'enUS','Rage unending... Face the fury of the wolf!','',26124),
(80188,'enUS','No! I will wield your strength...','',26124),
(80189,'enUS','Your heart... dreams of fire...','',26124),
(80190,'enUS','Faultline! I will avenge you! Yes... There. Will. Be. BLOOD!','',26124),
(80191,'enUS','Yrel, walk with us a moment...','',26124),
(80192,'enUS','Ner\'zhul summons $ns for the |cFFFF0000|Hspell:154733|h[Ritual of Destruction]|h|r!','',26124),
(80193,'enUS','Priming','Priming',26124),
(80194,'enUS','Ha ha! Smashed.','',26124),
(80195,'enUS','Not fit for capture!','',26124),
(80196,'enUS','Next! Ha ha!','',26124),
(80197,'enUS','I will NOT die here! Faultline, come aid your master!','',26124),
(80202,'enUS','Come! Your meat and bones will feed my animals!','',26124),
(80203,'enUS','Feel my fury!','',26124),
(80204,'enUS','Let us crush them!','',26124),
(80205,'enUS','Grant me your strength!','',26124),
(80206,'enUS','Animality!','',26124),
(80207,'enUS','Aid me!','',26124),
(80208,'enUS','That one shall not die alone.','',26124),
(80209,'enUS','Weak.','',26124),
(80210,'enUS','The others...  will avenge... me...','',26124),
(80211,'enUS','','One of those green spiders bit me, but it was just a scratch. No pain, no fame, am I right?',26124),
(80212,'enUS','I\'m a Vindicator in training, so I can handle a spider or two. But when night fell, a hundred glowing eyes lit up the darkness...','',26124),
(80213,'enUS','','\'Let\'s explore the old mine,\' she said. \'I need a sample for research,\' she said. Oh, why did I ever listen to Isaari?',26124),
(80214,'enUS','S-s-s-s-s-spiders... why did it have to be s-s-s-spiders?','',26124),
(80215,'enUS','Please find my other three friends! If you save them, I will gladly reward you when I return to Light\'s Rest.','Please find my other three friends! If you save them, I will gladly reward you when I return to Light\'s Rest.',26124),
(80216,'enUS','My other two friends are still out there... please find them, hero.','My other two friends are still out there... please find them, hero.',26124),
(80217,'enUS','Anyway, I can find my way back to Light\'s Rest, but one of my party is still missing. Please find them!','Anyway, I can find my way back to Light\'s Rest, but one of my party is still missing. Please find them!',26124),
(80218,'enUS','You found the others? Thank goodness! Come see us at Light\'s Rest. I\'m sure we can find some way to thank you.','You found the others? Thank goodness! Come see us at Light\'s Rest. I\'m sure we can find some way to thank you.',26124),
(80219,'enUS','Please find my other three friends! If you save them, I will gladly reward you when I return to Sunsworn Camp.','Please find my other three friends! If you save them, I will gladly reward you when I return to Sunsworn Camp.',26124),
(80220,'enUS','My other two friends are still out there... please find them, hero.','My other two friends are still out there... please find them, hero.',26124),
(80221,'enUS','Anyway, I can find my way back to Sunsworn Camp, but one of my party is still missing. Please find them!','Anyway, I can find my way back to Sunsworn Camp, but one of my party is still missing. Please find them!',26124),
(80222,'enUS','You found the others? Thank goodness! Come see us at Sunsworn Camp. I\'m sure we can find some way to thank you.','You found the others? Thank goodness! Come see us at Sunsworn Camp. I\'m sure we can find some way to thank you.',26124),
(80223,'enUS','','\'Let\'s explore the old mine,\' she said. \'I need a sample for research,\' she said. Oh, why did I ever listen to Norana?',26124),
(80224,'enUS','S-s-s-s-s-spiders... why did it have to be s-s-s-spiders?','',26124),
(80225,'enUS','I\'m a Blood Knight in training, so I can handle a spider or two. But when night fell, a hundred glowing eyes lit up the darkness...','',26124),
(80226,'enUS','','One of those green spiders bit me, but it was just a scratch. No pain, no fame, am I right?',26124),
(80227,'enUS','','Guys? I... I don\'t feel... so good...',26124),
(80228,'enUS','I will defend my lands and my people, whatever the cost.','',26124),
(80229,'enUS','I\'m with you! [Begin Scenario]','I\'m with you! [Begin Scenario]',26124),
(80230,'enUS','I... already told you... all that I know...','',26124),
(80231,'enUS','Do you even know how to wield a weapon!?','',26124),
(80232,'enUS','Easy as taking sweets from a draenei.','',26124),
(80233,'enUS','This belongs to me now!','',26124),
(80234,'enUS','','Guys? I... I don\'t feel... so good...',26124),
(80235,'enUS','','I\'ve known Isaari since she was a little girl. She\'s always getting me into trouble!',26124),
(80236,'enUS','I can still hear them... chittering and clacking to one another...$B$B<Doruun shudders.>','',26124),
(80237,'enUS','Well, I\'m glad we escaped in one piece.','',26124),
(80238,'enUS','Well, I\'m glad we escaped in one piece.','',26124),
(80239,'enUS','I can still hear them... chittering and clacking to one another...$B$B<Orian shudders.>','',26124),
(80240,'enUS','','That\'s it! I\'m never going on another one of Norana\'s stupid expeditions ever again!',26124),
(80241,'enUS','I see you are all safe.','I see you are all safe.',26124),
(80242,'enUS','Thanks to you, $n, we surviv-- Isaari? Are you all right?','',26124),
(80243,'enUS','Thanks to you, $n, we surviv-- Norana? Are you all right?','',26124),
(80244,'enUS','Bleed for me!','',26124),
(80245,'enUS','I\'ll roast your flesh!','',26124),
(80246,'enUS','We continue to gather more information on the frost wolf clan and their pathetic attempts at survival.','',26124),
(80247,'enUS','Anything?','',26124),
(80248,'enUS','Do you see anything?','',26124),
(80249,'enUS','Snow... I see lots of snow.','',26124),
(80250,'enUS','Bah... this is a waste of time. Goreseeker has no idea what he is doing.','',26124),
(80251,'enUS','Umm... Yeah. We are doing great. Tell Goreseeker we are really gathering some great intel out here.','',26124),
(80252,'enUS','Excellent. I\'ll let Goreseeker know.','',26124),
(80253,'enUS','It\'s happening just ahead, in the bottom of the tomb. I\'ve got to get out of here!','',26124),
(80254,'enUS','Igniting Barrel','Igniting Barrel',26124),
(80255,'enUS','$n, you are back! Please take the chest in this cart. It is only a small token of thanks for saving my life.','',26124),
(80256,'enUS','I\'m da best bestest beater der is! I\'m gonna beat ya till ya beaten.','',26124),
(80257,'enUS','Hey $n, remember me? You saved my life at the Court of Souls! Take this chest behind me as a token of my thanks.','',26124),
(80258,'enUS','What the? Shtop right there! I\'m going to kick your...','',26124),
(80259,'enUS','<BLAAAAARG!!!>','',26124),
(80260,'enUS','You think you can beat me!??? I\'ll shhlap you right in your shtupid face, $c!','',26124),
(80261,'enUS','He just slipped off the bridge?','',26124),
(80262,'enUS','','I\'ll keep the portal open as long as I can!',26124),
(80263,'enUS','Yup.','',26124),
(80264,'enUS','','Go now, while I can still hold it!',26124),
(80265,'enUS','What a fool... Well, let\'s pick up these supplies and head back to base.','',26124),
(80266,'enUS','You have done well, Soulbinder.','',26124),
(80267,'enUS','Come, Teron. Auchindoun awaits. Unthinkable power will soon be yours.','',26124),
(80268,'enUS','The Iron Horde will not hesitate to use that cannon on our base. We should find a more tactical location.','',26124),
(80269,'enUS','Is everyone alright?','',26124),
(80270,'enUS','I think I soiled m\'self...','',26124),
(80271,'enUS','My ALE was back there...','',26124),
(80272,'enUS','Yes, everyone appears to be alright.','',26124),
(80273,'enUS','Very well. We will set up camp ahead, and deal with this cannon.','',26124),
(80274,'enUS','Yrel will have to wait.','',26124),
(80275,'enUS','You are ready, Hurkan. Slay these mortals in my name!','',26124),
(80276,'enUS','I have souls to devour.','',26124),
(80277,'enUS','MY CLAN FOR GOREFIEND!','',26124),
(80278,'enUS','Nixxie is dead? Right on! She couldn\'t manage her way out of a paper bag. Let\'s get out of here boys!','',26124),
(80279,'enUS','','Get it together you bums! It\'s bad Kal\'rak ditched out on us. But that doesn\'t mean you can start slacking.',26124),
(80280,'enUS','','How many times have I told you! That keg is going to go bad if you keep it out  like that!',26124),
(80281,'enUS','','This Iron Horde is paying us good money to transport these goods on time. So put some elbow grease into it!',26124),
(80282,'enUS','You won\'t get away with this.','You won\'t get away with this.',26124),
(80283,'enUS','','Stupid Kal\'rak... I\'m going to report that idiot to the Iron Horde\'s HR department. Assuming they have a HR department.',26124),
(80284,'enUS','','I can\'t... hold it... much longer...',26124),
(80285,'enUS','','I should have kept my job at the Kaja\'Cola factory in Azeroth.',26124),
(80286,'enUS','','I don\'t care what you think! I\'m the lead here. Now get back to work!',26124),
(80287,'enUS','','The wagon gets attacked by a giant insect, and what does the big, strong, Iron Horde orc do?',26124),
(80288,'enUS','','He runs off with a keg of brew. Sheesh...',26124),
(80289,'enUS','','Hey! What are you doing here?! Don\'t even think about touching our cargo!',26124),
(80290,'enUS','I\'m outta here!','',26124),
(80291,'enUS','Ding-Dong! Nixxie is dead!','',26124),
(80292,'enUS','Finally we are free!','',26124),
(80293,'enUS','Great to see you $R, we could use your help right away!','Great to see you $R, we could use your help right away!',26124),
(80294,'enUS','Let\'s start construction!','Let\'s start construction!',26124),
(80295,'enUS','Ready to get this garrison started?','Ready to get this garrison started?',26124),
(80296,'enUS','Everybody in the Tank. Yrel is being held as a slave in the Stonemaul ogres\' slave camp.','',26124),
(80297,'enUS','Yrel might already be free if it weren\'t for the actions of one deceitful rangari.','',26124),
(80298,'enUS','I did what I thought was right, Vindicator. The missing girl seems to be distracting you from our mission.','',26124),
(80299,'enUS','Yeah, what\'s so special about this girl anyway?','',26124),
(80300,'enUS','I lost her once. I will not lose her again.','',26124),
(80301,'enUS','Now THAT\'S somethin\' I can get behind.','',26124),
(80302,'enUS','Besides, the ogres\'re sellin\' slaves to the Iron Horde. Stoppin\' ta beat \'em up fer a bit is well within the scope o\' our mission.','',26124),
(80303,'enUS','You all is gonna get smashed.','',26124),
(80304,'enUS','Oh no, ogre, that\'s where you have it wrong. You see, we are the ones that will be doing the smashing today. Thaelin?','',26124),
(80305,'enUS','Aye aye, cap\'n!','',26124),
(80306,'enUS','Now is our chance! Forward, Thaelin, with speed!','',26124),
(80307,'enUS','What da...?','',26124),
(80308,'enUS','Stay silent, all of you! Ogre, if you so much as GRUNT, I will personally beat the Light out of you.','',26124),
(80309,'enUS','We can set up over there.','',26124),
(80310,'enUS','Ok\'mokk didn\'t make no sounds at all. You don\' need ta smash Ok\'mokk.','',26124),
(80311,'enUS','Ach, I have a feelin\' yer gonna get smashed anyway.','',26124),
(80312,'enUS','A direct attack. A bold decision.','',26124),
(80313,'enUS','Gathering allies. Wise decision.','',26124),
(80314,'enUS','Form up, everyone. We are headed to Smokebelcher Depot.','',26124),
(80315,'enUS','Form up, everyone. We are headed to the Planteau. [TEMP NAME]','',26124),
(80316,'enUS','','Room for one more on that elekk?',26124),
(80317,'enUS','Always, my love.','',26124),
(80318,'enUS','Yrel, did you learn anything about the Goliath Cannon before your capture?','',26124),
(80319,'enUS','','A bit. The one you destroyed was merely a prototype. The actual cannons are built in the foundry, to the north.',26124),
(80320,'enUS','','I overheard one of the orcish leaders discussing a plan to use them on Shattrath.',26124),
(80321,'enUS','Shattrath? Ha! Even that big ol\' hunk o\' metal couldn\'t hit Shattrath from here.','',26124),
(80322,'enUS','They could if it was loaded onta\' a boat.','',26124),
(80323,'enUS','I suspected the same thing. They must plan to load the cannons onto barges at the Naval Base, in the northeast.','',26124),
(80324,'enUS','Our small group would never survive an attack on the Naval Base. Too fortified.','',26124),
(80325,'enUS','We will continue attacking their supply lines.','',26124),
(80326,'enUS','','D\'kaan, how long have you been scouting out here in Gorgrond?',26124),
(80327,'enUS','A very long time. Longer than you\'ve been alive, probably by two or threefold.','',26124),
(80328,'enUS','D\'ye get lonely?','',26124),
(80329,'enUS','A rangari who is not lonely is not doing his job.','',26124),
(80330,'enUS','Sounds like a crap job to me. Life ain\'t worth livin\' if y\'don\'t have lads and a lass t\'come home to.','',26124),
(80331,'enUS','','Do you have a wife, Hansel?',26124),
(80332,'enUS','Ach... the Blackrocks took \'er away.','',26124),
(80333,'enUS','That\'s half o\'why I\'m here: ta look after Thaelin, and ta get me wife back.','',26124),
(80334,'enUS','We will find your wife, Hansel. And we will leave a wake of bodies behind us. The orcs will pay with blood for what they did to our families.','',26124),
(80335,'enUS','Y\'know, that\'s the darkest, coldest, most inspirin\' thing I\'ve ever heard from the lips of a paladin.','',26124),
(80336,'enUS','Our work here is done. Next, we head to Smokebelcher Depot.','',26124),
(80337,'enUS','Our work here is done. Next, we head to the Planteau.','',26124),
(80338,'enUS','','Thaelin, are you doing alright in there?',26124),
(80339,'enUS','Quite fine, ma\'am. Just happy to be out o\' combat and back in me Tank.','',26124),
(80340,'enUS','','<sigh> This land is plagued by war. Do you think you\'ll return to the safety of home after our mission is done?',26124),
(80341,'enUS','I dunno how much you\'ve heard about Azeroth, ma\'am, but we\'ve got our fair share of war, too.','',26124),
(80342,'enUS','Once I\'ve found me Ellie, I know I\'ll be headed back ta Searin\' Gorge.','',26124),
(80343,'enUS','What about you, lassie? Will ye go home?','',26124),
(80344,'enUS','','With Velen gone, I feel like I don\'t have a home anymore.',26124),
(80345,'enUS','We are draenei, Yrel. Being without a home is in our nature.','',26124),
(80346,'enUS','','I was thinking I might go through the portal with you, my love.',26124),
(80347,'enUS','Yes, Yrel. You will have a home on Azeroth.','',26124),
(80348,'enUS','But first, we will make these orcs suffer for what they did to you. Their sins cannot be forgiven.','',26124),
(80349,'enUS','','Maraad, you\'re frightening me.',26124),
(80350,'enUS','The Iron Horde\'s supply lines are now cut, however temporarily. We have forged our alliance with the Shapers.','',26124),
(80351,'enUS','There will never be a better time than this. Let us head to the Naval Base and exact our vengeance on the Iron Horde!','',26124),
(80352,'enUS','','What is our plan, Maraad?',26124),
(80353,'enUS','We will slay as many of the vile things as we can. We will burn their homes and show them fear.','',26124),
(80354,'enUS','I will make them feel the pain I felt when I lost you, Yrel.','',26124),
(80355,'enUS','','Maraad... I am honored...',26124),
(80356,'enUS','','...but perhaps you are taking your vengeance too far. Have you forgotten what the Prophet taught us?',26124),
(80357,'enUS','The prophet is DEAD, Yrel. Look what his teachings did for him.','',26124),
(80358,'enUS','Ye\'ve gone too far, Maraad.','',26124),
(80359,'enUS','The Light\'s left ye. Even I can see that.','',26124),
(80360,'enUS','I carry no particular love for the Light, but I agree. You need to remember what you stand for, Vindicator.','',26124),
(80361,'enUS','Are any of you more holy than me? I am the LEADER of this expedition, and I will not be questioned any further!','',26124),
(80362,'enUS','The Light has not left me, Thaelin. No... the Light has finally shown me its true form.','',26124),
(80363,'enUS','Vengeance.','',26124),
(80364,'enUS','I saw the naaru\'s vengeance in the Purge of Grommar. I was there as K\'ara herself unleashed holy death upon the filthy hordes.','',26124),
(80365,'enUS','[UNUSED]','',26124),
(80366,'enUS','','Maraad, my love. That\'s enough.',26124),
(80367,'enUS','Yrel...','',26124),
(80368,'enUS','','You have been through too much, Maraad. Your thirst for vengeance will only lead to our death.',26124),
(80369,'enUS','','[UNUSED]',26124),
(80370,'enUS','','Rest now. I will lead our attack on the Naval Base.',26124),
(80371,'enUS','I\'m with you, Yrel.','',26124),
(80372,'enUS','I, too, will follow you.','',26124),
(80373,'enUS','And I.','',26124),
(80374,'enUS','Very well.','',26124),
(80375,'enUS','Thank you, Yrel. I don\'t know what\'s coming over me.','',26124),
(80376,'enUS','Shutting Down','Shutting Down',26124),
(80377,'enUS','Pull the first lever to increase combustion!','',26124),
(80378,'enUS','Pull the second lever to overdrive the engine!','',26124),
(80379,'enUS','Pull the third lever to destroy the Ultrabliterator!','',26124),
(80380,'enUS','Stay back! It\'s on a rampage!','Stay back! It\'s on a rampage!',26124),
(80381,'enUS','Well done, champion! We will do our best to repair this unit. Thank you.','Well done, champion! We will do our best to repair this unit. Thank you.',26124),
(80382,'enUS','','We are all entitled to our own opinion. Yours is just wrong. NOW GET BACK TO WORK!',26124),
(80383,'enUS','Sorry! I just work here!','',26124),
(80384,'enUS','Whoa! What did I do?!','',26124),
(80385,'enUS','Nixxie! Help!','',26124),
(80386,'enUS','I should have never left Azeroth!','',26124),
(80387,'enUS','Can\'t we talk this through?','',26124),
(80388,'enUS','Lok-Narash!','',26124),
(80389,'enUS','Gazlowe, buy us some time!','',26124),
(80390,'enUS','We will take the east!','',26124),
(80391,'enUS','Orgrim, you will answer for your betrayal!','',26124),
(80392,'enUS','Brother!','',26124),
(80393,'enUS','Auchindoun will soon be ours. Too bad you won\'t be around to see it, elf.','Auchindoun will soon be ours. Too bad you won\'t be around to see it, elf.',26124),
(80394,'enUS','Innocent?!','',26124),
(80395,'enUS','Yes, I will see Draenor burn. You, traitor, will not.','',26124),
(80396,'enUS','','Lok\'tar ogar!',26124),
(80397,'enUS','','I will hold off reinforcements at the docks!',26124),
(80398,'enUS','','I will get the children to safety!',26124),
(80399,'enUS','You got it, boss!','',26124),
(80400,'enUS','Together, we fight!','',26124),
(80401,'enUS','Prepare for a counter-attack!','',26124),
(80402,'enUS','They\'re retreating to the harbor!','',26124),
(80403,'enUS','The children are safe! Their lieutenants are exposed!','',26124),
(80404,'enUS','Only the harbor remains between us and the weapon!','',26124),
(80405,'enUS','Champion! Speak with me when you are ready to travel to the enemy battleship.','',26124),
(80406,'enUS','I will not slay so many innocent people!','',26124),
(80407,'enUS','It is YOU who would make Draenor burn. It is YOU who must be stopped!','',26124),
(80408,'enUS','For Shattrath!','',26124),
(80409,'enUS','','Thaelin, use your tank to save them! We will provide escort.',26124),
(80410,'enUS','','We will hold off Blackhand! Destroy that weapon!',26124),
(80411,'enUS','','They have children in those buildings!',26124),
(80412,'enUS','','We will take the west!',26124),
(80413,'enUS','Dismantling','Dismantling',26124),
(80414,'enUS','%s hisses, slinking back into the shadowy depths!','%s hisses, slinking back into the shadowy depths!',26124),
(80415,'enUS','A chill wind howls across the empty hills...','A chill wind howls across the empty hills...',26124),
(80416,'enUS','A chittering sound echoes across the trees, then fades...','A chittering sound echoes across the trees, then fades...',26124),
(80417,'enUS','Something flickers in the shadows, growing closer...','Something flickers in the shadows, growing closer...',26124),
(80418,'enUS','We don\'t want any trouble, $c. We stopped fighting a long time ago.','',26124),
(80419,'enUS','I could eat an orc.','I could eat an orc.',26124),
(80420,'enUS','When you live in a savage world like we do, sometimes you just want to get away.$b$bThat\'s why we left the war behind.','',26124),
(80421,'enUS','Feel free to take some fish. They are delicious.','',26124),
(80422,'enUS','|TInterface\\Icons\\ability_fixated_state_red:20|tA %s |cFFFF0000|Hspell:156653|h[Fixates]|h|r on you. Run!','',26124),
(80423,'enUS','Stop! Who goes there? Go away before I put an arrow in your eye!','',26124),
(80424,'enUS','Pardon my rudeness, traveler. I did not know you from the enemy.$B$BThe Shadow Council has tried to raid my home several times now.$B$BThe first time, they didn\'t expect much resistance from an old hermit like me. I put arrows into the throats of three.$B$BThe second time, I was prepared. Four orcs blundered right into my traps. Stupid mongrels.$B$BI made them angry, and now, I\'m waiting for them to come again.$B$BI hope they send more. It just means that many more will die.','',26124),
(80425,'enUS','Do you need help?','Do you need help?',26124),
(80426,'enUS','Stay if you want, traveler. I\'ll die before letting these dogs take my home. Watch out! They come!','',26124),
(80427,'enUS','Heh, you\'ve got some fight in you, traveler. Ready for more?','',26124),
(80428,'enUS','This is it, friend. Let\'s cut them off at the head!','',26124),
(80429,'enUS','We did it! I... I can\'t thank you enough, stranger. I don\'t have much, but I want you to have this.','',26124),
(80430,'enUS','','The hunt comes to an end. Quickly, drink this antidote! The spider\'s venom will no longer affect you!',26124),
(80431,'enUS','Are you sure this is a good idea?','',26124),
(80432,'enUS','If you want something done, you have to do it yourself!','',26124),
(80433,'enUS','','There is another I hunt within these caves. I leave this kill to you.',26124),
(80434,'enUS','Find a way to destroy the Supply Depot!','',26124),
(80435,'enUS','The Sky Rider\'s have noticed your presence!','The Sky Rider\'s have noticed your presence!',26124),
(80436,'enUS','','Rise and serve your master!',26124),
(80441,'enUS','Our clan grows stronger by the second.','',26124),
(80442,'enUS','Careful - we have a tough enemy cornered in there.','Careful - we have a tough enemy cornered in there.',26124),
(80443,'enUS','Grulk gonna pound you all!! Rargrh!!','',26124),
(80444,'enUS','Feel weak...Grulk need serum...','',26124),
(80445,'enUS','Grulk Smash!! Rarggah!!','',26124),
(80446,'enUS','Grulk so tired...just want nap.','',26124),
(80447,'enUS','Grulk is strongest one there is!! Rrrrgh!!','',26124),
(80448,'enUS','This place where Grulk change...where old self die...','',26124),
(80449,'enUS','NO MORE!! GRULK CRUSH!!','',26124),
(80450,'enUS','Are you sure this is a good idea?','',26124),
(80451,'enUS','Yeah, you\'ll be fine. I just forgot to adjust my sights last time.','',26124),
(80455,'enUS','','Keep your eyes open... The stones speak of trouble...',26124),
(80456,'enUS','Hunters, arm your traps. I smell something...','',26124),
(80457,'enUS','Another trophy for the pen.','',26124),
(80458,'enUS','The stones spoke of your demise.','',26124),
(80459,'enUS','Who dares wake me?','',26124),
(80460,'enUS','You are weak.','',26124),
(80461,'enUS','','I see you, interlopers. You tread on sacred ground...',26124),
(80462,'enUS','','Insignificant whelps, what makes you think you can challenge me?',26124),
(80463,'enUS','','I will turn you into ash!',26124),
(80464,'enUS','','Drown in venom!',26124),
(80465,'enUS','','The undertow will consume you!',26124),
(80466,'enUS','','Hah! My power rules here.',26124),
(80467,'enUS','','Agamaggan will rise again!',26124),
(80469,'enUS','Auchindoun... is... doomed...','',26124),
(80470,'enUS','None live who assault the holy Auchenai.','',26124),
(80471,'enUS','I will strike you down.','',26124),
(80472,'enUS','The Light guide my hand!','',26124),
(80473,'enUS','Light guide you.','',26124),
(80474,'enUS','Bathe in the glory of the Light!','',26124),
(80475,'enUS','I don\'t know... Roc\'tar doesn\'t look so good.','',26124),
(80476,'enUS','','It is my sworn duty to protect this tomb and its grounds.$B$BWe will fight to the last to prevent these orcs from taking the Shard of Souls!',26124),
(80477,'enUS','Soulbinder Nyami sent me to bring the Shard of Souls to safety.','Soulbinder Nyami sent me to bring the Shard of Souls to safety.',26124),
(80478,'enUS','','Protect that with your life! We need it to power Auchindoun\'s defenses!',26124),
(80479,'enUS','Put me down!','',26124),
(80480,'enUS','I will give you a swift death!','',26124),
(80481,'enUS','Drop me now you beast!','',26124),
(80482,'enUS','Pathetic creature! Unhand me!','',26124),
(80483,'enUS','Grulk done wit\' Iron Horde...Grulk go now.','',26124),
(80484,'enUS','You friend to Grulk...Grulk not forget what you done.','',26124),
(80485,'enUS','I\'m strongest! This food is mine! Stay away!','',26124),
(80486,'enUS','You no try and fight me! Now you food!','',26124),
(80487,'enUS','I kill you! I eat you!','',26124),
(80488,'enUS','See what I have?! No mess with me! Or you next.','',26124),
(80489,'enUS','','Hold your ground. We have to protect the wounded!',26124),
(80490,'enUS','%s calls in a distant |cFFFF0000Siegemaker|r!','',26124),
(80491,'enUS','Your head will be mine!','',26124),
(80492,'enUS','It is no matter. These souls are mine. My power grows.','',26124),
(80493,'enUS','Auchindoun will be mine! I will devour every last soul and bathe the ashes in hellfire!','',26124),
(80494,'enUS','To arms, anchorites! The arakkoa are coming! Hero, lend us your aid!','',26124),
(80495,'enUS','More birds on the horizon, my comrades. Send them back to the Spires of Arak, where they belong!','',26124),
(80496,'enUS','Will their numbers never cease? Muster your courage, friends. We will not be taken so easily!','',26124),
(80497,'enUS','Finally, we have drawn out their leader! Face us, you feathered tyrant!','',26124),
(80498,'enUS','Our town is safe thanks to all of you. Today we have given the arakkoa a taste of our steel. Steady hearts, anchorites! We will stay vigilant.','',26124),
(80500,'enUS','Welcome to Anchorite\'s Sojourn, traveler. It is here that the devout gather for pilgrimage to the Temple of Karabor.','',26124),
(80501,'enUS','','And why do you think we need your help, \'blood elf\'? We Auchenai are sworn to Auchindoun\'s protection.',26124),
(80502,'enUS','Explosions, sabotage, demolition...all in a day\'s work friend.','',26124),
(80503,'enUS','Defend the shard! It must reach Lord Teron\'gor!','',26124),
(80504,'enUS','Grommar is a perfect example of the Alliance not knowin\' how to get the job done right...','',26124),
(80505,'enUS','I have seen your kind before, flying among the mountains to the south. Why have you come here?','',26124),
(80506,'enUS','Auuugghhh! What have you done? The sun... it blinds me! It burns! IT BURNS!','',26124),
(80507,'enUS','The darkness closes in. I can no longer feel the Light. YOU! You did this!','',26124),
(80508,'enUS','I alone will stand against you. I will turn you back from these lands!','',26124),
(80509,'enUS','The old paladin suddenly gasps. A look of rapture crosses his face and he blinks, seeing you for the first time.','',26124),
(80510,'enUS','I... I can feel the Light again! I am freed of her curse. I... I see the way to Auchindoun.','',26124),
(80511,'enUS','An arakkoa sun priest has come, seeking dominion over our lands.','',26124),
(80512,'enUS','My village bled slowly. Many fell to his sorcery. I, too, fell under his abominable curse... the \"sun sickness.\"','',26124),
(80513,'enUS','We knew the sun priest would come one last time to claim his victory.','',26124),
(80514,'enUS','I alone remained to face him. My sight was nearly gone, and the Light no longer answered my prayers.','',26124),
(80515,'enUS','I prayed once last time, although where there had once been everlasting divinity, now, I felt only emptiness.','',26124),
(80516,'enUS','In that moment, I knew true terror.','',26124),
(80517,'enUS','I did not see the sun priest arrive, but I heard the flutter of his wings, and felt his gloating breath on my face, and then, moments later, felt him die on my blade.','',26124),
(80518,'enUS','Afterward, I wandered. Blind and alone, and severed from the Light. Even in my dying moment, I felt I had been forsaken.','',26124),
(80519,'enUS','You have delivered me from his curse. You have restored my faith, champion.','',26124),
(80520,'enUS','Take my sword, which rests upon the stone. May it guide you when your faith falters, hero.','',26124),
(80521,'enUS','NOTUSED','',26124),
(80522,'enUS','','Take one step closer and I\'ll gut you like a fish, orc!',26124),
(80523,'enUS','','Thank the stars you arrived, hero! We are all that is left of Telmor.',26124),
(80524,'enUS','','Thanks pal! I\'d hug yah, but we don\'t have much time...',26124),
(80525,'enUS','','Do me a favor and release Grulk from his cage...don\'t worry, he\'s cool.',26124),
(80526,'enUS','To smash? Or not to smash? Dis Grulk question.','',26124),
(80527,'enUS','Something need smashing?','',26124),
(80528,'enUS','','Grulk was mutated against his will by the Iron Horde and then locked up for being angry over it. Can you believe that?!',26124),
(80529,'enUS','SMASH!!!','',26124),
(80530,'enUS','Grulk rhyme now!$b$bSmash the baddies! Smash them up!$b$bSmash them till fit in soup cup!','',26124),
(80531,'enUS','','We gotta bust up this mutation laboratory before it\'s too late! Grulk will fill you in on the details.',26124),
(80532,'enUS','','I\'d better meet back up with the squad. Regroup with us once you\'ve destroyed the lab!',26124),
(80533,'enUS','','Yes, Tuulani. Now you see.',26124),
(80534,'enUS','','Your efforts were valiant. I did not think the anchorites could power the defenses with only one of the crystals.',26124),
(80535,'enUS','','But nothing will stop my plan, nor that of my masters. And the only things in our way...',26124),
(80536,'enUS','','Protector! Destroy these intruders!',26124),
(80537,'enUS','Run for your lives!','Run for your lives!',26124),
(80538,'enUS','They\'re eating us alive... literally!','They\'re eating us alive... literally!',26124),
(80539,'enUS','Where are the Auchenai? Why is no one saving us?','Where are the Auchenai? Why is no one saving us?',26124),
(80540,'enUS','There\'s no hope! Run!','There\'s no hope! Run!',26124),
(80541,'enUS','They killed my family!','They killed my family!',26124),
(80542,'enUS','I\'m glad you showed up. We were going to be killed next!','',26124),
(80543,'enUS','The creatures around here are a pain to deal with.$b$bI\'ve taken to placing some of my food and prized possessions up high to avoid any unwanted incidents.','',26124),
(80544,'enUS','Wow! Thanks! I can find my way out of here now. I\'m sure I won\'t get captured again. See ya!','',26124),
(80545,'enUS','Crush, crack, splinter! AHAHAHahahaha...','',26124),
(80546,'enUS','Whispers... slithering behind my EYES!','',26124),
(80547,'enUS','$ns drop from the ceiling!','',26124),
(80548,'enUS','No! The ritual is incomplete! Who dares to interrupt my arrival?','',26124),
(80549,'enUS','My power... it fades!','',26124),
(80550,'enUS','NO! Noooooooooooooooooooooooooooooooo!','',26124),
(80551,'enUS','Gazlowe, get rid of that barricade!','',26124),
(80552,'enUS','Gazlowe...','',26124),
(80553,'enUS','I fear that even with the Heart intact, Auchindoun\'s defenses may not be enough. The Shadow Council has eyes everywhere.','',26124),
(80554,'enUS','Barricade! On it!','',26124),
(80555,'enUS','','Thaelin, get that tank down here.',26124),
(80556,'enUS','It isn\'t safe to fire this thing near kids! But I bet the concussion from shooting blanks would blast open those doors...','',26124),
(80557,'enUS','Champion, take control of the cannon! If they get close, use the flames... hahahahaha!','',26124),
(80558,'enUS','Suit! Go home!','',26124),
(80559,'enUS','There ye go... easy on the turn now... easy...','',26124),
(80560,'enUS','GAH!!','',26124),
(80561,'enUS','Oh, ye poor thing. You\'ll not be forgotten!','',26124),
(80562,'enUS','','The key is in the chest by the wall, go grab it and let me out!',26124),
(80563,'enUS','','What are you staring at? Go grab the key from the chest and let me out!',26124),
(80564,'enUS','','Boy am I glad to see you! The key is in that chest over there, be a pal and let me out will yah?',26124),
(80565,'enUS','','I\'m locked in here, you\'ll need to get the key. It\'s in the chest by the wall!',26124),
(80566,'enUS','','Don\'t mind me, I\'ll just wait here in my cage while you continue NOT letting me out! The key is in that chest over there!',26124),
(80567,'enUS','','This isn\'t some romantic \"rescue the princess from the tower\" situation. This is a torture room and I\'m in a freakin\' cage! Get me outta here!',26124),
(80568,'enUS','Pledge yourself to the master and you will receive untold power!','Pledge yourself to the master and you will receive untold power!',26124),
(80569,'enUS','Witness the infinite power of the Legion!','Witness the infinite power of the Legion!',26124),
(80570,'enUS','The draenei will crumble under our combined might, brothers and sisters!','The draenei will crumble under our combined might, brothers and sisters!',26124),
(80571,'enUS','Nothing can stop our power! Not the Iron Horde, not the draenei, we are invincible!','Nothing can stop our power! Not the Iron Horde, not the draenei, we are invincible!',26124),
(80572,'enUS','Give your souls to Teron\'gor. Gorge yourselves in his power!','Give your souls to Teron\'gor. Gorge yourselves in his power!',26124),
(80573,'enUS','','Hurry up... we have work to do.',26124),
(80574,'enUS','','This is a waste of time.',26124),
(80575,'enUS','','Are you done yet?',26124),
(80576,'enUS','','*Sigh*',26124),
(80577,'enUS','','As for you beast, flee if you must, but my arrows will catch you!',26124),
(80578,'enUS','I\'m almost done! Just one more time.','',26124),
(80579,'enUS','You have got to try this!','',26124),
(80580,'enUS','Don\'t knock it till you try it.','',26124),
(80581,'enUS','Come on! You might like it.','',26124),
(80582,'enUS','','Die beast, and know that whatever hell you fall into will be more merciful than I!',26124),
(80583,'enUS','','Thank you for your aid, adventurer. Meet me back at camp and we will discuss matters further.',26124),
(80584,'enUS','','That Grulk guy sure is incredible, ain\'t he? Mutated against his will...out for revenge...HUGE rippling biceps...a girl can only dream.',26124),
(80585,'enUS','You need somethin\' done right? You\'re talkin\' to the right guy...but the right guy ain\'t cheap.','',26124),
(80586,'enUS','Lok-Narash!','',26124),
(80587,'enUS','No!!! I will tear you apart for that! You will be avenged, Gutgore!','',26124),
(80588,'enUS','The thunderlord... will rise...  again...','',26124),
(80589,'enUS','Mole machine, go home!','Mole machine, go home!',26124),
(80590,'enUS','Don\'t bite me! I will not harm you... Seriously, don\'t do it.','',26124),
(80591,'enUS','I should have stayed in Shadowmoon Valley.','',26124),
(80592,'enUS','Please! I have so much more to see before I die.','',26124),
(80593,'enUS','Thank you, friend! Till we meet again!','',26124),
(80594,'enUS','So much power! I am invincible!','',26124),
(80595,'enUS','But the power... it protects me...','',26124),
(80596,'enUS','You disappoint me, I thought you\'d be tougher.','',26124),
(80597,'enUS','The weak should know better than to test me!','',26124),
(80598,'enUS','%s begins to channel |cFFFF0404|Hspell:157059|h[Rune of Grasping Earth]|h|r!','',26124),
(80599,'enUS','The wormhole is spinning really fast.  You\'ll have to jump first and hope for the best.','',26124),
(80600,'enUS','A jagged landscape','A jagged landscape',26124),
(80601,'enUS','A reddish-orange forest','A reddish-orange forest',26124),
(80602,'enUS','Shadows...','Shadows...',26124),
(80603,'enUS','Pick your second location.','',26124),
(80604,'enUS','Too many Frostwolves have died in this war.','',26124),
(80605,'enUS','I will not rest till the Thunderlords are destroyed!','',26124),
(80606,'enUS','I once hunted Clefthooves for meat and skins, now I hunt Thunderlords for their heads. Not much of a difference really.','',26124),
(80607,'enUS','Grassy plains','Grassy plains',26124),
(80608,'enUS','Primal forest','Primal forest',26124),
(80609,'enUS','Lava and snow','Lava and snow',26124),
(80610,'enUS','Location 07','Location 07',26124),
(80611,'enUS','Location 08','Location 08',26124),
(80612,'enUS','Location 09','Location 09',26124),
(80613,'enUS','Location 10','Location 10',26124),
(80614,'enUS','Location 11','Location 11',26124),
(80615,'enUS','Location 12','Location 12',26124),
(80616,'enUS','Got anything important to say or are you just wasting my time?','',26124),
(80617,'enUS','Location 13','Location 13',26124),
(80618,'enUS','Location 14','Location 14',26124),
(80619,'enUS','Location 15','Location 15',26124),
(80620,'enUS','Location 16','Location 16',26124),
(80621,'enUS','Burying','Burying',26124),
(80623,'enUS','Start P3 Text!','',26124),
(80624,'enUS','Just before you kill them, let \'em scream. It\'ll make a better distraction.','',26124),
(80625,'enUS','Better not forget my good axe!','',26124),
(80626,'enUS','','You face your executioner, $r.',26124),
(80627,'enUS','Meet me in Grommar when you\'re done! Nobody sinks my battleship and gets away with it!','',26124),
(80628,'enUS','|TInterface\\Icons\\ability_blackhand_demolition.blp:20|t %s casts |cFFFF0000|Hspell:156425|h[Demolition]|h|r!','',26124),
(80629,'enUS','|TInterface\\Icons\\spell_fire_ragnaros_lavabolt.blp:20|t %s casts |cFFFF0000|Hspell:156928|h[Slag Eruption]|h|r!','',26124),
(80630,'enUS','What happened to my furnace? Where are my guards? Shut these intruders down!','',26124),
(80631,'enUS','I\'ll sneak into the camp. When you finish I\'ll meet you at the rendezvous point I marked on your map.','',26124),
(80632,'enUS','','Mother?',26124),
(80633,'enUS','Meat still looks too rare...','',26124),
(80634,'enUS','You want a burger, $p?','',26124),
(80635,'enUS','There\'s always time for BBQ!','',26124),
(80636,'enUS','Grillin\' and killin\'...it\'s what I do best!','',26124),
(80637,'enUS','','Confound these wards! No matter how much I call upon the light to purge them it is as if the wards themselves thwart my ability to unmake them.',26124),
(80638,'enUS','Looks like it still needs more heat...','',26124),
(80639,'enUS','The secret to good BBQ is to cook it slowly with extreme heat...','',26124),
(80640,'enUS','Extra crispy anyone?','',26124),
(80641,'enUS','The runes have been destroyed.','The runes have been destroyed.',26124),
(80642,'enUS','Ready to face Revaan?','Ready to face Revaan?',26124),
(80643,'enUS','Smells like it\'s burning...that means it\'s almost done!','',26124),
(80644,'enUS','','Has it been so long? Has she truly grown so much since I last saw her?',26124),
(80645,'enUS','','We shall see about that.',26124),
(80646,'enUS','Child! Leave now. Those wards were there for your protection. You should not be here.','',26124),
(80647,'enUS','Yes. And she will never be yours.','',26124),
(80648,'enUS','What? Where am I? I am so tired.','',26124),
(80649,'enUS','Wait a second. It is coming back to me. This is Blackrock Spire, and we are... we are here to vanquish evil and get me some much needed loot.','',26124),
(80650,'enUS','I remember it all, now. You are my pals, my pals for life. Weird, I thought there were more of you.','',26124),
(80651,'enUS','No matter. You are the brains, the creators of the perfect plan, and I am the one who will enact that plan with surgical accuracy.','',26124),
(80652,'enUS','But first, I am hungry. It is like I have not eaten in 8 years. I guess I will just cook this chicken that I have in my bag while you devise our plan of attack.','',26124),
(80653,'enUS','Yep, I will cook this completely not rotten chicken that I had in my bag. You all just go ahead and devise the perfect plan.','',26124),
(80654,'enUS','I like what I am hearing from your planning, pals. It is very well thought out and mathematically flawless.','',26124),
(80655,'enUS','Alright chums, I\'m back! Let\'s do this! Leeroooooy... Jenkins!','',26124),
(80656,'enUS','I\'m ready to detonate the explosives.','I\'m ready to detonate the explosives.',26124),
(80657,'enUS','','Hop on $p!',26124),
(80658,'enUS','The boundless power of the stones flows through me! Your destruction comes!','',26124),
(80659,'enUS','Deliciousss...','',26124),
(80660,'enUS','Look upon the tools of your demise! The ancient stones grant me unimaginable power!','',26124),
(80661,'enUS','You can never challenge my rule! I command the power of the stones and know no equal!','',26124),
(80662,'enUS','So thirsty... so much blood...','',26124),
(80663,'enUS','Juicy...','',26124),
(80664,'enUS','','By the light! Why won\'t you... just... break!',26124),
(80665,'enUS','','Who built this barrier?! It is as if it knows me.',26124),
(80666,'enUS','','I will break this barrier down if it is the last thing I ever do!',26124),
(80667,'enUS','','Give... me... back... my... FATHER!',26124),
(80668,'enUS','','Open! By the light, just open!',26124),
(80669,'enUS','','The barrier is down! Well done champion! I can sense my father is near. This way.',26124),
(80674,'enUS','','We\'re in range of the tower $p! Light \'em up!',26124),
(80675,'enUS','','The second tower is in range! Hit the detonator!',26124),
(80676,'enUS','','That fortress could use some remodeling...let\'s give them a hand!',26124),
(80677,'enUS','','Ticker?!',26124),
(80678,'enUS','','Great work, $p! Grommar\'s gonna be feelin\' the hurt from this operation for a while!',26124),
(80679,'enUS','','Ah! And what a lovely sacrifice you will make.',26124),
(80680,'enUS','Perfect! I needed a test target for my new powers.','',26124),
(80681,'enUS','Say hello to my little friends.','',26124),
(80682,'enUS','Enemies approach! Defend Xanatos at all costs!','Enemies approach! Defend Xanatos at all costs!',26124),
(80683,'enUS','Every living thing will be turned. You cannot stop it!','Every living thing will be turned. You cannot stop it!',26124),
(80684,'enUS','Ah, there you are. I thought I smelled $r.','',26124),
(80685,'enUS','What can I do for you?','What can I do for you?',26124),
(80686,'enUS','Ya can\'t beat Blook.','',26124),
(80687,'enUS','Blook likes to beat things. Want to be beaten?','',26124),
(80688,'enUS','What?','What?',26124),
(80689,'enUS','Ouch! No more hitting. Blook sorry. Blook beaten.','',26124),
(80690,'enUS','Blook never been beaten before. So Blook now follows tiny beater person.','',26124),
(80691,'enUS','Blook can be follower? Blook like to follow. Not as much as Blook like to beat. But Blook got beat, so Blook follows.','',26124),
(80692,'enUS','One day, Blook will beat all of the tiny people. Blook have many dreams for this.','',26124),
(80693,'enUS','Pulling','Pulling',26124),
(80694,'enUS','Alright! Now keep \'em busy while I work my magic.','',26124),
(80695,'enUS','We\'re all set! Re-engage the clutch!','',26124),
(80696,'enUS','Cha-CHING!!','',26124),
(80697,'enUS','Someone... please... it burns...','Someone... please... it burns...',26124),
(80698,'enUS','Revenge is a dish best served with explosions! Hit the button, $p!','',26124),
(80699,'enUS','Hurry up puny orc! Chief need slaves now!','',26124),
(80700,'enUS','Nobody sinks my battleship!','',26124),
(80701,'enUS','','Tuulani, go to Telmor and meet with Soulbinder Aedraa. She has retrieved the final fragment and brought it there.',26124),
(80702,'enUS','','Right away.',26124),
(80703,'enUS','','Master Dawnblade, here is the antivenin I prepared with $p\'s help. It should counter the deathweb venom\'s effects.',26124),
(80704,'enUS','Thank you, Soulbinder.','',26124),
(80709,'enUS','Let\'s just clamp the blowoff valve here...','',26124),
(80710,'enUS','Loosen this... tighten that... aaand....','',26124),
(80711,'enUS','Hey! Get away from that!','',26124),
(80712,'enUS','','We will return to Frostfire as conquerors!',26124),
(80713,'enUS','You work faster!','',26124),
(80714,'enUS','Puny thing work harder or I gives you to da boss!','',26124),
(80715,'enUS','Mine faster puny slave or da boss gonna drain you dead!','',26124),
(80716,'enUS','It hard work making you work hard!','',26124),
(80717,'enUS','Y-y-yes sir, whatever you say.','Y-y-yes sir, whatever you say.',26124),
(80718,'enUS','Ow!','Ow!',26124),
(80719,'enUS','Oww! Will the hurting ever stop?','Oww! Will the hurting ever stop?',26124),
(80720,'enUS','No more! Please stop!','No more! Please stop!',26124),
(80721,'enUS','RARGH! Puny slave things make me so ANGRY!','',26124),
(80722,'enUS','If they see you talking to me they will kill us both! Go away!','If they see you talking to me they will kill us both! Go away!',26124),
(80723,'enUS','The Taskmasters, they have a key to my shackles. Help me, please!','The Taskmasters, they have a key to my shackles. Help me, please!',26124),
(80724,'enUS','Help me, please!','Help me, please!',26124),
(80725,'enUS','I... can\'t go on... please just leave me alone.','I... can\'t go on... please just leave me alone.',26124),
(80726,'enUS','Please, no more! I just need a moment to rest!','Please, no more! I just need a moment to rest!',26124),
(80727,'enUS','Will this ever end?','Will this ever end?',26124),
(80728,'enUS','Who are you? Leave me be.','Who are you? Leave me be.',26124),
(80729,'enUS','Once I get my hands on an axe these ogres will pay for everything they\'ve done to me!','Once I get my hands on an axe these ogres will pay for everything they\'ve done to me!',26124),
(80730,'enUS','You\'re free! Get out of here and head to the nearest camp.','You\'re free! Get out of here and head to the nearest camp.',26124),
(80731,'enUS','You\'re free! Make a run for it!','You\'re free! Make a run for it!',26124),
(80732,'enUS','You\'ve saved me from certain death. Thank you!','You\'ve saved me from certain death. Thank you!',26124),
(80733,'enUS','Don\'t let a single one of those ogres live.','Don\'t let a single one of those ogres live.',26124),
(80734,'enUS','I owe you my life!','I owe you my life!',26124),
(80735,'enUS','I\'ve been waiting forever for this day!','I\'ve been waiting forever for this day!',26124),
(80736,'enUS','Too many of us have died here. Far too many.','Too many of us have died here. Far too many.',26124),
(80737,'enUS','This nightmare is finally over.','This nightmare is finally over.',26124),
(80738,'enUS','Be careful, I\'ve seen the bodies that come back after their \"boss\" has finished with them. They have no markings of torture on them but their faces are all frozen in a scream.','Be careful, I\'ve seen the bodies that come back after their \"boss\" has finished with them. They have no markings of torture on them but their faces are all frozen in a scream.',26124),
(80739,'enUS','A few nights ago there was a bunch of weird looking lights flashing from the cave across the lava flows. It sent a chill down my spine! The next day we were forced to haul the bodies of several prisoners out for the birds to eat. I.. still feel sick remembering it.','A few nights ago there was a bunch of weird looking lights flashing from the cave across the lava flows. It sent a chill down my spine! The next day we were forced to haul the bodies of several prisoners out for the birds to eat. I.. still feel sick remembering it.',26124),
(80740,'enUS','I was helping to move the bodies out of the western cave. One strange looking hair covered thing was still alive! They took it to their camp on the northeast hill.','I was helping to move the bodies out of the western cave. One strange looking hair covered thing was still alive! They took it to their camp on the northeast hill.',26124),
(80741,'enUS','I feel it!','I feel it!',26124),
(80742,'enUS','','Vindicator Namuun, here is the antivenin I prepared with $p\'s help. It should counter the deathweb venom\'s effects.',26124),
(80743,'enUS','Thank you, Soulbinder.','',26124),
(80749,'enUS','Fleshy creature! Come to the lava and speak with me.','',26124),
(80750,'enUS','You dare assault the seat of my power? Is this the work of that traitor Cho\'gall? Kneel and swear fealty to me, and I may yet spare your lives for my coliseum.','',26124),
(80751,'enUS','You will learn why I am king, and you are little more than peasants.','',26124),
(80752,'enUS','I will make sure Artaal gets to safety. Retribution Point is not far from here.','',26124),
(80753,'enUS','Scouts! Find that vermin!','',26124),
(80754,'enUS','We\'re ready to pick up our slaves for today. Uh... where are they?','',26124),
(80755,'enUS','The key to my cage is contained within the chest behind you. Would you mind obtaining it and letting me out?','',26124),
(80756,'enUS','While you ponder the current situation would it be possible to obtain the key from the chest and let me out?','',26124),
(80757,'enUS','Your presence in this dungeon is most fortuitous! At this very moment you represent the metaphorical key to my freedom! The literal key is in the chest behind you.','',26124),
(80758,'enUS','I would join you outside of this cage if it were not for the unfortunate fact that I am currently locked inside of it.','',26124),
(80759,'enUS','Slaves puny thing deliver be weak. Puny thing go get better slaves for Nub.','',26124),
(80760,'enUS','Although this prison cell is quite spacious, the accommodations are lacking. Would you mind letting me out?','',26124),
(80761,'enUS','Residing in this cage has made my skin rather itchy. Do you have any salve?','',26124),
(80762,'enUS','What?! We were told you would have a shipment ready when we got here!','',26124),
(80763,'enUS','Salutations! Please excuse the abruptness of my greeting but we are precariously short on time...','',26124),
(80764,'enUS','While residing in this dungeon I had the curious pleasure of meeting this fellow Grulk that you see in the cage before you...','',26124),
(80765,'enUS','Please grant Grulk his freedom, $n. Do not be alarmed, I have found him to be of an exceedingly gentle nature...','',26124),
(80766,'enUS','Grulk was mutated against his will by the Iron Horde and has valuable information regarding this malevolent operation in Grommar.','',26124),
(80767,'enUS','While you assist Grulk in addressing the mutation business, I will find my way back to the team and continue the operation. Good luck, $n!','',26124),
(80768,'enUS','Huh? Yer no ogre. Are me eyes playin\' tricks on me?','',26124),
(80769,'enUS','Everyone off! Let\'s get them!','',26124),
(80770,'enUS','Ye here to get me outta this?','',26124),
(80775,'enUS','The Gyrocopter crash was not definitively my fault. Though to be fair, it was not definitively not my fault either. Is somebody trying to find fault? If so, I maintain that definitive fault in the matter is definitively inconclusive.','',26124),
(80776,'enUS','Put your backs into it, you lazy mutts!','',26124),
(80777,'enUS','We need to send out these shipments by sundown!','',26124),
(80778,'enUS','We have work to do. Bladefury\'s orders!','',26124),
(80779,'enUS','Hurry it up, or you\'ll feel my boot in your hide!','',26124),
(80780,'enUS','All dis snow and ice and fire. Everyt\'ing here be tryin\' to burn ya one way or anotha.','',26124),
(80781,'enUS','Eh boss-mon! We gonna be needin\' a few t\'ings. And it ain\'t pretty how we get them.','',26124),
(80782,'enUS','Abandon Doomguard','Abandon Doomguard',26124),
(80783,'enUS','Abandon Terrorguard','Abandon Terrorguard',26124),
(80784,'enUS','Abandon Infernal','Abandon Infernal',26124),
(80785,'enUS','Abandon Abyssal','Abandon Abyssal',26124),
(80786,'enUS','Accept Shadow Hunter Rala\'s offer of service.','Accept Shadow Hunter Rala\'s offer of service.',26124),
(80787,'enUS','My sista have other duties, but I have leave of ol\' Vol\'jin to extend my services to you.$b$bYa proved your worth, and did a task that needed doing.$b$bI be followin\' ya, boss-mon, if ya be willing.','',26124),
(80788,'enUS','|TInterface\\Icons\\ability_blackhand_marked4death:20|tYou are |cFFFF0000|Hspell:156096|h[Marked for Death]|h|r!','',26124),
(80789,'enUS','No! I must ascend!','No! I must ascend!',26124),
(80790,'enUS','The Light! It burns!','The Light! It burns!',26124),
(80791,'enUS','You will pay for this, mortal!','You will pay for this, mortal!',26124),
(80792,'enUS','What are you doing? Stop!','What are you doing? Stop!',26124),
(80793,'enUS','Stop! I must give myself to Teron\'gor!','Stop! I must give myself to Teron\'gor!',26124),
(80794,'enUS','Too little, too late. Arise!','Too little, too late. Arise!',26124),
(80795,'enUS','Your blessings stop nothing!','Your blessings stop nothing!',26124),
(80796,'enUS','I... am... LEGION!','I... am... LEGION!',26124),
(80797,'enUS','DIE!','DIE!',26124),
(80798,'enUS','Our power is too great for the likes of you.','Our power is too great for the likes of you.',26124),
(80799,'enUS','','$n, speak to Choluna. Let\'s go investigate this... Cragplume Cauldron.',26124),
(80800,'enUS','','Hang on tight, $n.',26124),
(80801,'enUS','','Here we are. What is this place?',26124),
(80802,'enUS','','I\'ve always had a fascination for blending in with the locals, but the inside of this Iron Horde armor smells awful. Maybe they\'d be less angry if they took a bath once in a while...',26124),
(80803,'enUS','','The Iron Horde should never be underestimated, $n. Although they wield weaponry and sizeable forces that are worthy of respect, it is their unwavering persistence that must never go unchecked.',26124),
(80804,'enUS','My trusty wrist-mounted, gnomatic cloaking device allows me to repair my gyrocopter unseen. An ingenious device if I do say so myself!','',26124),
(80809,'enUS','Borgal! Get back here, you murdering son of a trogg!','',26124),
(80810,'enUS','Barrels are the operative\'s perfect disguise. Nobody ever suspects a barrel...','',26124),
(80811,'enUS','','The Iron Horde cannot hide from our sharp eyes.',26124),
(80812,'enUS','','I have never before seen such a large network of steam vents and craters. What a fascinating place to study!',26124),
(80813,'enUS','Take me to Cragplume Cauldron.','Take me to Cragplume Cauldron.',26124),
(80814,'enUS','Hop on $p!','',26124),
(80815,'enUS','The tower is within range, $p! Use the detonator!','',26124),
(80816,'enUS','The second tower is in range! Hit the detonator!','',26124),
(80817,'enUS','We\'re in range of the fortress, $p! Explode them!','',26124),
(80818,'enUS','Do you know what this battleship needs, $p? Explosions!','',26124),
(80819,'enUS','','The Cauldron is just up ahead.',26124),
(80820,'enUS','Superlative work, $p! The Iron Horde operation in Grommar has been sufficiently attenuated thanks to your efforts!','',26124),
(80821,'enUS','I guess it could be worse...I could be in an outhouse.','',26124),
(80822,'enUS','I\'d like to know who came up with the phrase \"barrel of fun\", because I think I picked the wrong one.','',26124),
(80823,'enUS','Wait...what is this...termites!?','',26124),
(80824,'enUS','I hope your disguise is as good as mine, Adele.','',26124),
(80825,'enUS','The key to avoiding detection is to never be detected.','',26124),
(80826,'enUS','I wish this was a beer barrel...','',26124),
(80827,'enUS','You have seen but a fraction of my power. Behold the ancient magics unearthed by my empire!','',26124),
(80828,'enUS','King\'s guard, to my side! I must focus my power and awaken the stone!','',26124),
(80829,'enUS','Such power! It takes form to destroy you!','',26124),
(80830,'enUS','Its energy overflows! Soon it will be unleashed!','',26124),
(80831,'enUS','My activator is $n.','My activator is $n.',26124),
(80832,'enUS','Enough! Long have the Sorcerer Kings guarded these chambers. Today you will see our secret power.','',26124),
(80833,'enUS','Guards, remove these peasants.','',26124),
(80834,'enUS','Its power grows beyond comprehension!','',26124),
(80835,'enUS','Cho\'gall?! Traitorous scum - I knew you were behind this!','',26124),
(80840,'enUS','I like to shop and you like to loiter','I like to shop and you like to loiter',26124),
(80841,'enUS','I like shopping. You like loitering.','I like shopping. You like loitering.',26124),
(80842,'enUS','Shopping\'s my thing. What\'s yours?','Shopping\'s my thing. What\'s yours?',26124),
(80843,'enUS','Nah... this is junk.','',26124),
(80844,'enUS','It\'s signed \"Uratok\" ...with a backwards \"r.\" Something tells me that\'s not who we\'re lookin\' for.','',26124),
(80845,'enUS','Hm, no mark on this one.','',26124),
(80846,'enUS','This was mass-produced at the foundry in Gorgrond. Looks like they ship some of the parts in and assemble them here.','',26124),
(80847,'enUS','Ah-HAH! This one\'s signed \"DA\" with an anvil-shaped box around the letters. Now THAT\'s a mark I recognize.','',26124),
(80848,'enUS','The threat on Draenor is one that impacts us all. I am glad that at least a few of you have agreed to work together against such great odds.','',26124),
(80849,'enUS','Please open a portal to Azeroth, Khadgar.','Please open a portal to Azeroth, Khadgar.',26124),
(80850,'enUS','De slaves are ready for ye boss.','',26124),
(80851,'enUS','Good, their wretched spirits will serve me better than their weak bodies ever could!','',26124),
(80852,'enUS','Hush, you idiot!','',26124),
(80853,'enUS','Ahhhh... Yes, now the Soulgrinder hums with power! With this, we shall be unstoppable!','',26124),
(80854,'enUS','Yo, Darkanvil! Nice digs you got here - I\'d prefer fewer bloodthirsty orcish warmongers, but whatever turns your crank I guess.','',26124),
(80855,'enUS','The drill ain\'t a problem no more. You ready to get outta here?','',26124),
(80856,'enUS','Gazlowe! Listen, they forced me to build a drill-','',26124),
(80857,'enUS','But you better use it to die in a blaze o\' glory!','',26124),
(80858,'enUS','I won\'t leave with my work still in the hands of the Iron Horde. I\'ve got a plan to make things right, if ye can spot me a can of yer famous rocket fuel...','',26124),
(80859,'enUS','You turned into some kinda hero, huh? Alright, suit yourself. Here.','',26124),
(80860,'enUS','','Good work, $n! This must be the chamber they were looking for.',26124),
(80861,'enUS','Hah! We dwarves prefer to blast the OTHER guy to smithereens - not ourselves. I\'ll leave that to the goblin engineers.','',26124),
(80862,'enUS','Hold a moment $Glad:lass;, keep quiet and come over here.','',26124),
(80863,'enUS','','What a fearsome creature. Well done, champion.',26124),
(80864,'enUS','','Wait... I feel a tremendous power. It\'s coming from the back of the cavern!',26124),
(80865,'enUS','','Is this what the Iron Horde were after?',26124),
(80866,'enUS','','Oh no! The cavern is unstable. Let\'s get out of here. Follow me!',26124),
(80867,'enUS','','Up this way, $n!',26124),
(80868,'enUS','','Over here!',26124),
(80869,'enUS','The others will follow. The Legion will rise!','The others will follow. The Legion will rise!',26124),
(80870,'enUS','','Looks like there\'s only one way out, hero. UP!',26124),
(80871,'enUS','You do not understand the Great Work.','',26124),
(80872,'enUS','You cannot defy the Great Work.','',26124),
(80873,'enUS','This is the way of things. You cannot stop it.','',26124),
(80874,'enUS','You do not understand... You cannot know...','',26124),
(80875,'enUS','I\'m a lumberjack. How\'s the guarding?','I\'m a lumberjack. How\'s the guarding?',26124),
(80876,'enUS','I\'m a lumberjack. you\'re the boss.','I\'m a lumberjack. you\'re the boss.',26124),
(80877,'enUS','we both like to loiter','we both like to loiter',26124),
(80878,'enUS','we both like to loiter2','we both like to loiter2',26124),
(80879,'enUS','I like to loiter. What do you like to do?','I like to loiter. What do you like to do?',26124),
(80880,'enUS','Yay! We unstoppable! We unstoppable!','',26124),
(80881,'enUS','I must return to the spirit world to continue my research. Guard this room and make sure that NO ONE touches the portal!','',26124),
(80883,'enUS','Thanks for the fuel, Gazlowe. After my great escape, maybe I\'ll pay you a visit and show you how I did it.','',26124),
(80884,'enUS','','I\'ve got birds in the air all over Gorgrond. If Blackhand so much as visits an outhouse, I want to know about it.',26124),
(80885,'enUS','','Stupid Beast! Your training is not done!',26124),
(80886,'enUS','','You will pay for this.',26124),
(80887,'enUS','','Foolish creature! Return to me!',26124),
(80888,'enUS','Come forth, Soulgrinder! Devour the souls that we have brought for you!','',26124),
(80889,'enUS','','Get back here! You are not free to go!',26124),
(80890,'enUS','Axes down, brothers! Don\'t you recognize your own clan?','',26124),
(80895,'enUS','','Got you!',26124),
(80896,'enUS','We are home.','',26124),
(80897,'enUS','We will burn your homes to the ground!','We will burn your homes to the ground!',26124),
(80898,'enUS','Please! Let us live!','Please! Let us live!',26124),
(80899,'enUS','We will take everything!','We will take everything!',26124),
(80900,'enUS','You will pay for this one day.','You will pay for this one day.',26124),
(80901,'enUS','I will not give up...','I will not give up...',26124),
(80902,'enUS','Your clan is no match for us!','Your clan is no match for us!',26124),
(80903,'enUS','The Thunderlord are the strongest!','The Thunderlord are the strongest!',26124),
(80904,'enUS','You won\'t get away with this!','You won\'t get away with this!',26124),
(80905,'enUS','Watch!','',26124),
(80906,'enUS','Your wolf cannot help you now!','',26124),
(80907,'enUS','The Frostwolf are weak!','',26124),
(80908,'enUS','Fill it with arrows.','',26124),
(80909,'enUS','Kill them!','Kill them!',26124),
(80910,'enUS','We will never bow to you!','We will never bow to you!',26124),
(80911,'enUS','Ha, not a chance. Light it up!','Ha, not a chance. Light it up!',26124),
(80912,'enUS','Connecting Rocket Chicken','Connecting Rocket Chicken',26124),
(80913,'enUS','','What do you make of it, Thrall?',26124),
(80914,'enUS','It reeks of hatred and dust, Choluna. I don\'t like having it here at the garrison.','',26124),
(80915,'enUS','I\'d like it even less in the hands of the Iron Horde.','',26124),
(80916,'enUS','We should destroy it.','',26124),
(80917,'enUS','Perhaps. First, we must find out what purpose it serves for Blackhand.','',26124),
(80918,'enUS','Choluna, step up our operation in Gorgrond. Whatever the Iron Horde are planning, I want to be ready.','',26124),
(80919,'enUS','Up ya go!','',26124),
(80920,'enUS','That stuff makes an awesome lubricant. You know, for engines.','',26124),
(80921,'enUS','Careful, now... that thing shatters and we\'re toast.','',26124),
(80922,'enUS','Ha! Just try and stop us!','Ha! Just try and stop us!',26124),
(80923,'enUS','Take from the weak!','Take from the weak!',26124),
(80924,'enUS','This belongs to the Thunderlord now!','This belongs to the Thunderlord now!',26124),
(80925,'enUS','Hold up, I sense we\'re not alone in here. Come out peacefully before I have to flush ye out! Show yourself!','',26124),
(80926,'enUS','You can\'t stop us!','You can\'t stop us!',26124),
(80927,'enUS','And what are you supposed to be?','',26124),
(80928,'enUS','Amazing.','',26124),
(80929,'enUS','I thought my life was over! My thanks to you.','I thought my life was over! My thanks to you.',26124),
(80930,'enUS','The mine began to quake and then the creatures appeared...','The mine began to quake and then the creatures appeared...',26124),
(80931,'enUS','My thanks! I think I can make it out on my own.','My thanks! I think I can make it out on my own.',26124),
(80932,'enUS','','Please, hold your weapons! I mean you no harm. I just needed to make sure you\'re not here with Borgal. From the way you two look, I don\'t think you\'re going to be on friendly terms when you catch up to him.',26124),
(80933,'enUS','This is Frostwolf territory, but you may claim this plateau as your own. Consider it a reward for rescuing my people.','',26124),
(80934,'enUS','Thank you, chieftain. We will establish a foothold immediately.','',26124),
(80935,'enUS','Honestly boss, I\'m a wee bit out o\' me element here. I think we should give her a shot. We might need her help.','',26124),
(80936,'enUS','','That fat ogre needs to pay for the suffering he caused! Maybe we can work together? If you help me out, I\'ll be able to help you track down Borgal.',26124),
(80937,'enUS','Why should we trust ye?','',26124),
(80938,'enUS','I would have surely died. Thank you, Hero.','I would have surely died. Thank you, Hero.',26124),
(80939,'enUS','Please help the others...I\'ll try to make it out on my own.','Please help the others...I\'ll try to make it out on my own.',26124),
(80940,'enUS','Our fallen demand vengeance!','Our fallen demand vengeance!',26124),
(80941,'enUS','For the Iron Wolf!','For the Iron Wolf!',26124),
(80942,'enUS','I would have perished without your aid. You have my gratitude!','I would have perished without your aid. You have my gratitude!',26124),
(80943,'enUS','Don\'t worry, little ones. We\'ll make it through this.','Don\'t worry, little ones. We\'ll make it through this.',26124),
(80944,'enUS','Any Thunderlord get in here, we\'ll carve them up!','Any Thunderlord get in here, we\'ll carve them up!',26124),
(80945,'enUS','Garrison - Event - Orc Attack Stage 1 Begin','',26124),
(80946,'enUS','Garrison - Event - Orc Attack Stage 2 Begin','',26124),
(80947,'enUS','Garrison - Event - Orc Attack Stage 3 Begin','',26124),
(80948,'enUS','Garrison - Event - Orc Attack Stage 1 End','',26124),
(80949,'enUS','Garrison - Event - Orc Attack Stage 2 End','',26124),
(80950,'enUS','Garrison - Event - Orc Attack Stage 3 End','',26124),
(80951,'enUS','The weak deserve this!','The weak deserve this!',26124),
(80952,'enUS','You cannot save them!','You cannot save them!',26124),
(80953,'enUS','Here\'s another come to die.','Here\'s another come to die.',26124),
(80954,'enUS','We will crush you just the same!','We will crush you just the same!',26124),
(80955,'enUS','Even our wyverns are not prepared for this type of cold.','Even our wyverns are not prepared for this type of cold.',26124),
(80956,'enUS','It looks as though we will not have allies in the skies for this one.','It looks as though we will not have allies in the skies for this one.',26124),
(80957,'enUS','We are going to have to find a better way to shield our wyvern from the cold.','We are going to have to find a better way to shield our wyvern from the cold.',26124),
(80958,'enUS','It would seem we need to rely on the local rylak for air travel.','It would seem we need to rely on the local rylak for air travel.',26124),
(80959,'enUS','The orc\'s face has been chewed off.','The orc\'s face has been chewed off.',26124),
(80960,'enUS','Half of this orc\'s body was seared away by a steam fissure.','Half of this orc\'s body was seared away by a steam fissure.',26124),
(80961,'enUS','The mangled body is scored by deep claw marks.','The mangled body is scored by deep claw marks.',26124),
(80962,'enUS','The flesh is macerated almost beyond recognition.','The flesh is macerated almost beyond recognition.',26124),
(80963,'enUS','','Eh, boss-mon. We gonna be needin\' a lot more furs. No one told us how cold it be on dis side of the portal before we stepped through.',26124),
(80964,'enUS','','I\'m gonna rearrange your nuts and bolts!',26124),
(80965,'enUS','','Saddle up maggot, you\'re going for a ride!',26124),
(80967,'enUS','Nope.','',26124),
(80968,'enUS','What do you make of it, Yrel?','',26124),
(80969,'enUS','','It reeks of hatred and dust, Omnuron. I don\'t like this.',26124),
(80970,'enUS','We should destroy it.','',26124),
(80971,'enUS','Okay let\'s do this! Borgal\'s been having prisoners delivered to a cave on the other side of the lava flows.','',26124),
(80972,'enUS','','',26124),
(80973,'enUS','Those poor people! Hurry $Glad:lass;, we got to get rid of Grubnor then follow Borgal through that portal to... wherever the blazes it goes!','',26124),
(80974,'enUS','The shard is mine. The portal will grow!','',26124),
(80975,'enUS','NO! THE LEGION WILL CONSUME ALL!','',26124),
(80976,'enUS','It be so cold I can feel me mojo freezin\'. Dis not what I signed up for.','',26124),
(80977,'enUS','Ya mon. These furs be lettin\' me legs thaw. I can feel my toes again.','',26124),
(80978,'enUS','How they not be tellin\' us this be a frozen wasteland. Even da fire be frozen. How can fire be frozen?','',26124),
(80979,'enUS','I tried to have a drink from me flask earlier. It froze just after it hit me tongue. Took two orcs to pry it off. Dey ain\'t happy \'bout that.','',26124),
(80980,'enUS','Eh mon. Eh. I dare ya to lick the metal. Do eet!','',26124),
(80981,'enUS','Who in charge thought island trolls be good for a frozen land war?','',26124),
(80982,'enUS','Ma breath just froze in front of me. It fell like ice to da ground. I hate dis place.','',26124),
(80983,'enUS','I be warmer now! I can think a full thought again wit\'out swearin\' at da cold.','',26124),
(80984,'enUS','Dat fur really be workin\' mon.','',26124),
(80985,'enUS','I smell like yeti. Dis pleases me.','',26124),
(80986,'enUS','I don\'t get it. How you be gettin\' fire and ice in da same place at da same time?','',26124),
(80987,'enUS','I clearly underestimated the size of the bones one can find here. I will need a larger hacksaw, and a few of those wolf sleds, and maybe a few extra wolves for resear... er... labor. Yes, labor.','',26124),
(80988,'enUS','Ah, $p. At least you have the stomach for my research. With the peace treaty under way in Azeroth I find I am in need of fresh corpses.$b$bFortunately, you seem to leave plenty in your wake.','',26124),
(80989,'enUS','You smell like something the Thunderlord would hunt.','You smell like something the Thunderlord would hunt.',26124),
(80990,'enUS','You may have strength on your side, but the cold will sap that from you in the first few seconds of combat. Stay warm if you want to stay alive.','You may have strength on your side, but the cold will sap that from you in the first few seconds of combat. Stay warm if you want to stay alive.',26124),
(80991,'enUS','Thunderlord hunt in packs and prefer large prey. Are you large prey?','Thunderlord hunt in packs and prefer large prey. Are you large prey?',26124),
(80992,'enUS','When dealing with Thunderlord, it is vital to reduce their numbers quickly. In a group they are lethal. Individually you can squash them like the bugs they are.','When dealing with Thunderlord, it is vital to reduce their numbers quickly. In a group they are lethal. Individually you can squash them like the bugs they are.',26124),
(80993,'enUS','','Look at me, isn\'t my reason obvious? I\'m dead! My body is rotted and gone! I used to go climb the mountains and watch the sunrise in the morning. Now I\'m doomed to not know the warmth of daylight ever again.',26124),
(80994,'enUS','','And I have Borgal to thank for this... this state I\'m in. I want to see his spirit flayed for what he\'s done to me and all of the others who he has murdered. Is that reason enough to believe me?',26124),
(80995,'enUS','Do not fear the snow and ice. Use it. If you are wounded you can quickly slow the damage until you get help from a healer. Embrace the cold and you survive.','Do not fear the snow and ice. Use it. If you are wounded you can quickly slow the damage until you get help from a healer. Embrace the cold and you survive.',26124),
(80996,'enUS','This terrain is ideal for a stronghold.','',26124),
(80997,'enUS','I can open up a portal to Orgrimmar only briefly. Reinforcements are standing by, I hope?','',26124),
(80998,'enUS','The very best.','',26124),
(80999,'enUS','Somebody call for a fixer?','',26124),
(81000,'enUS','... You\'re entrusting a goblin to be your foreman?','',26124),
(81001,'enUS','Gazlowe, here, oversaw the construction of Orgrimmar.','',26124),
(81002,'enUS','Orgrimmar! The impenetrable fortress!','',26124),
(81003,'enUS','Wasn\'t it recently sacked?','',26124),
(81004,'enUS','Yeah yeah, okay, one little sacking.','',26124),
(81005,'enUS','Omnuron, step up our operation in Gorgrond. Whatever the Iron Horde are planning, I want to be ready.','',26124),
(81006,'enUS','She makes a good argument. Honestly boss, I think we should give her a shot. We might need her help.','',26124),
(81007,'enUS','The nearby hatchlings try to skitter away...','The nearby hatchlings try to skitter away...',26124),
(81008,'enUS','|TInterface\\Icons\\ability_hunter_rapidregeneration.blp:20|t Admiral Gar\'an looks towards you and readies |cFFFF0000|Hspell:156626|h[Rapid Fire]|h|r!','|TInterface\\Icons\\ability_hunter_rapidregeneration.blp:20|t Admiral Gar\'an looks towards you and readies |cFFFF0000|Hspell:156626|h[Rapid Fire]|h|r!',26124),
(81009,'enUS','','You fools! I will make you pay for this interruption!',26124),
(81010,'enUS','','Enough! Once I dispose of you interlopers nothing will stand in my way!',26124),
(81011,'enUS','','No! It was not supposed to happen...this way...',26124),
(81012,'enUS','$p, I can only channel this barrier for a short time. You must defeat Kaelynara before it is too late!','$p, I can only channel this barrier for a short time. You must defeat Kaelynara before it is too late!',26124),
(81013,'enUS','','Such power...such potential. The latent energy within this crystal shall go to waste no longer!',26124),
(81014,'enUS','','How naive you are. This place is nothing but a shell, a husk, to be torn and discarded from the fruit of power that I shall devour!',26124),
(81015,'enUS','You will never take our homes!','You will never take our homes!',26124),
(81016,'enUS','Garrison - Event - Enemy Killed','',26124),
(81017,'enUS','','You must stop this madness Kaelynara! Look around at the destruction you are causing!',26124),
(81018,'enUS','Your lust for power has overcome you, Kaelynara. I will not allow you to destroy this mine!','',26124),
(81019,'enUS','To honor our fallen!','To honor our fallen!',26124),
(81020,'enUS','I give my life for my home!','I give my life for my home!',26124),
(81021,'enUS','Die!','Die!',26124),
(81022,'enUS','Repel the invaders!','Repel the invaders!',26124),
(81023,'enUS','What is this -- Wise-ear! You are alive!','',26124),
(81024,'enUS','Lead us to Durotan, old friend.','',26124),
(81025,'enUS','Wor\'gol is the winter home of the Frostwolf Clan.','',26124),
(81026,'enUS','Durotan walks a cliff\'s edge, pinned between the Thunderlord orcs and Bladespire ogres.','',26124),
(81027,'enUS','Ga\'nar seemed bent on dealing out retribution to both.','',26124),
(81028,'enUS','Ah yes! I worry about Durotan\'s brother. Always quick to fight. His need for vengeance will make him more reckless than ever.','',26124),
(81029,'enUS','What is THAT? I see a fortress of stone!','',26124),
(81030,'enUS','Bladespire Citadel. Once a far-flung outpost of the ogre empire.','',26124),
(81031,'enUS','If our people are to have any hope to survive, we must rout the ogres from their stronghold.','',26124),
(81032,'enUS','This is Durotan\'s goal. He will not ask for it, but we will need your help!','',26124),
(81033,'enUS','','Borgal\'s death is only a matter of time, and time is something I have plenty of.',26124),
(81034,'enUS','I found this totem, can you tell me anything about it?','I found this totem, can you tell me anything about it?',26124),
(81035,'enUS','','This is one of the totems that Borgal used to channel his magic before he unearthed the Soulgrinder. $b$bI sense there is still quite a bit of spiritual power emanating from it. If we can find the rest of his totems I can use them to eject Borgal out of the Spirit world. Once he has been cut off from the power of this plane you and Owynn should be able to end him.',26124),
(81036,'enUS','Garrison - Event - Reinformcement Killed','',26124),
(81037,'enUS','','The Jorune Mine provides many of the crystals used to power Auchindoun and Shattrath.',26124),
(81038,'enUS','Our Draenei brothers and sisters of the Alliance warned us of the Blood Elves\' lust for magical power. If such is the cost of their aid against the Burning Legion, I will gladly fight the demons alone.','',26124),
(81039,'enUS','Come here, hero! I need your help!','',26124),
(81040,'enUS','The Legion will rise! Draenor will be bathed in hellfire!','',26124),
(81041,'enUS','','Ga\'nar did not wait for the muster call. His blood burns too hot.',26124),
(81042,'enUS','','Go! Win us a great victory. Tell my husband I will defend the town until he returns.',26124),
(81043,'enUS','What can you tell me about this place?','What can you tell me about this place?',26124),
(81044,'enUS','','Concentrate, sisters! We must maintain Auchindoun\'s defenses.',26124),
(81045,'enUS','','Don\'t give up, soulbinders. Auchindoun must be protected!',26124),
(81046,'enUS','','The defenses will not falter. We are Auchindoun\'s protectors!',26124),
(81047,'enUS','As you already know, arcane crystals are an important part of Draenei culture. The crystals from this mine are used in many places, but are mostly supplied to Shattrath and Auchindoun.$b$bWhen treated with care these crystals can be powerful sources of arcane energy. Attempting to unleash the energy from a crystal this size is reckless and foolhardy.$b$bThe earth elementals you see rampaging throughout the mine typically slumber far beneath the ground. It appears as though Kaelynara\'s tampering has enraged them.$b$bMy vindicators will be successful in reclaiming the mine, but the battle will be hard fought.','',26124),
(81048,'enUS','','We are sworn to Auchindoun\'s protection. Keep up the defenses!',26124),
(81049,'enUS','','We must recover Karab\'uun at all costs. March forward the moment you see a hole in their lines!',26124),
(81050,'enUS','','We will stand by you, Exarch. No demon will set foot in Auchindoun on my watch.',26124),
(81051,'enUS','Today we fulfill our eternal oath. We will protect Auchindoun with our lives!','',26124),
(81052,'enUS','My enslavement... is over.','',26124),
(81053,'enUS','At... last... freedom.','',26124),
(81054,'enUS','Sweet release...','',26124),
(81055,'enUS','Back to dust.','',26124),
(81056,'enUS','','The Legion won\'t give up so easily. Auchindoun is too valuable to them.',26124),
(81057,'enUS','','Teron\'gor! The Light comes for you!',26124),
(81058,'enUS','Oooh... I don\'t feel so good...','',26124),
(81059,'enUS','|cFFFF0000|Hspell:156479|h[Massive Demolition]|h|r killed you.  Move away from the impact point to decrease damage taken.','',26124),
(81060,'enUS','The Legion will not stop here. They desire Auchindoun too much.','',26124),
(81061,'enUS','Nyami. Tuulani. We ride for Light\'s Rest immediately.','',26124),
(81062,'enUS','A mind control device is sitting on the table.','A mind control device is sitting on the table.',26124),
(81063,'enUS','I told Liadrin that I would take care of this...situation. The last thing the Sunsworn want right now is to lose the trust of the Auchenai.','',26124),
(81064,'enUS','Timber!','',26124),
(81065,'enUS','Strike their hearts!','Strike their hearts!',26124),
(81066,'enUS','Claiming','Claiming',26124),
(81067,'enUS','Those bodies don\'t look like they\'ve been laying there for long. Lets keep onward to that cave but keep ye eyes an ears open.','',26124),
(81068,'enUS','','I\'ve come to Talador at the request of Archmage Khadgar to assist the Auchenai against the Burning Legion. When I learned of the situation here at the mine I came to offer my aid.',26124),
(81069,'enUS','','Burn in fel fire, you insignificant maggots!',26124),
(81070,'enUS','','Cower before me, you insolent mortals!',26124),
(81071,'enUS','Down, ye filthy beast!','',26124),
(81072,'enUS','Not good!','Not good!',26124),
(81073,'enUS','For the Alliance!','',26124),
(81074,'enUS','Whoa! I said, \"Whoa!!!\"','Whoa! I said, \"Whoa!!!\"',26124),
(81075,'enUS','Seriously?!','Seriously?!',26124),
(81076,'enUS','Enough with the spinning!','Enough with the spinning!',26124),
(81077,'enUS','Eat dirt!','',26124),
(81078,'enUS','What are you doing?!','What are you doing?!',26124),
(81079,'enUS','I\'m gonna puke!','I\'m gonna puke!',26124),
(81080,'enUS','Stop! Stupid rylak!','Stop! Stupid rylak!',26124),
(81081,'enUS','Oh that looked like it hurt!','',26124),
(81082,'enUS','Hey! Hold on! Wait!','Hey! Hold on! Wait!',26124),
(81083,'enUS','Should have watched yer back!','',26124),
(81084,'enUS','AHH!!!','AHH!!!',26124),
(81085,'enUS','What the what?!','What the what?!',26124),
(81086,'enUS','NOT GOOD!','NOT GOOD!',26124),
(81087,'enUS','Why me?!','Why me?!',26124),
(81088,'enUS','I thought we were friends!','I thought we were friends!',26124),
(81089,'enUS','NOO!!','NOO!!',26124),
(81090,'enUS','We meet again, $n! Could you please wait a minute?$B$BNorana should be back at any moment. We should thank you together.','',26124),
(81091,'enUS','We meet again, $n! Thank you again for your help back there.','',26124),
(81092,'enUS','','<Ankaa blinks through tears.> I feel terrible about what happened to Isaari. She was my best friend!',26124),
(81093,'enUS','','<Riasa blinks through tears.> I feel terrible about what happened to Norana. She was my best friend!',26124),
(81094,'enUS','We should never have gone into that forest. I... I don\'t know how I\'m going to get over this.','',26124),
(81095,'enUS','We should never have gone into that forest. I... I don\'t know how I\'m going to get over this.','',26124),
(81096,'enUS','Breaking Lock','Breaking Lock',26124),
(81097,'enUS','Garrison - Event - Orc Attack Add Kill Bar','',26124),
(81098,'enUS','You know nothing of the power you meddle with, Mar\'gok. (It calls to us. We know! Its power will be ours!)','',26124),
(81099,'enUS','It baffles me to see so much that was once majestic and beautiful be reduced to the fel infested wasteland that is Outland.','',26124),
(81100,'enUS','Accept the The Staff of Archmage Vargoth. (Garrison Follower)','Accept the The Staff of Archmage Vargoth. (Garrison Follower)',26124),
(81101,'enUS','Your reign has come to an end, the infinite night begins. (Darkness comes!)','',26124),
(81102,'enUS','Tagar, destroy the intruder! These souls are nearly mine!','',26124),
(81103,'enUS','There is no darkness light cannot pierce, Ner\'zhul!','',26124),
(81104,'enUS','Ya can\'t tie a wolf to dat sledge, mon. Dem Frostwolf orcs gonna kill you for dat if dey be findin\' out.','',26124),
(81105,'enUS','Look at dat tiny wolf, mon. There no way it can pull the whole sledge. Ya just bein\' mean.','',26124),
(81106,'enUS','Ya got issues, mon. Serious issues. What dat wolf ever do to you?','',26124),
(81107,'enUS','The shadows have already consumed my soul, prophet.','',26124),
(81108,'enUS','Ah much better! Fits a bit loose but nothing a couple mugs o\' ale can\'t sort out.','',26124),
(81109,'enUS','','Quickly, hero! This beast must be stopped!',26124),
(81110,'enUS','Fool! Auchindoun will be mine. Every soul I consume grows my power. You face the wrath of a power greater than you can possibly imagine.','',26124),
(81111,'enUS','Sir, Thunderlord Orcs are marching on the garrison!','Sir, Thunderlord Orcs are marching on the garrison!',26124),
(81112,'enUS','Rain? Now? This feels unnatural, and I bet I know who is behind it.','',26124),
(81113,'enUS','Thunderlords, here?  Scout, ring the Call to Arms bell to get everyone inside!','',26124),
(81114,'enUS','Footmen, to arms! We\'re damn sure not dying in Draenor today! To your posts!','',26124),
(81115,'enUS','No! The power of the Dark Star will be MINE!','',26124),
(81116,'enUS','It is not too late. Turn from this dark path and let us help you.','',26124),
(81117,'enUS','','The Light is with us!',26124),
(81118,'enUS','Back, you mongrels! You\'ll get out of here over my dead body!','',26124),
(81119,'enUS','Don\'t worry, girls. I won\'t let anything happen to you.','',26124),
(81120,'enUS','I\'ll head back to the front. For Auchindoun!','',26124),
(81121,'enUS','Thank you for your help. These brutes will have to try harder than that to beat us!','',26124),
(81126,'enUS','Thunderlord! To the front!','Thunderlord! To the front!',26124),
(81127,'enUS','Do not let any more of them through!','Do not let any more of them through!',26124),
(81128,'enUS','Report to the front lines!','Report to the front lines!',26124),
(81129,'enUS','We will stop the Frostwolf!','We will stop the Frostwolf!',26124),
(81130,'enUS','Jus\' stay warm. It be okay. Ya gonna be fine.','',26124),
(81131,'enUS','We will stop the rest!','',26124),
(81132,'enUS','Jus\' stay close to da fire. Wyverns ain\'t be made for such cold. Jus\' stay warm.','',26124),
(81133,'enUS','Don\' be freezin\' on me now. Stay warm!','',26124),
(81134,'enUS','I am ready to confront Kaelynara.','I am ready to confront Kaelynara.',26124),
(81135,'enUS','I am ready to return to the Jorune Mine.','I am ready to return to the Jorune Mine.',26124),
(81136,'enUS','Well fought! We will meet you just up ahead!','',26124),
(81137,'enUS','Let\'s get going! Commander, we\'ll meet ye at the tower.','',26124),
(81138,'enUS','Furnace pressure is out of control - the Heart of the Mountain starts gaining more heat!','Furnace pressure is out of control - the Heart of the Mountain starts gaining more heat!',26124),
(81139,'enUS','Welcome, traveler. This land has seen hard times of late, but also great heroism. Would you like to walk in the steps of these brave adventurers and witness their deeds?','',26124),
(81140,'enUS','The tales I have to tell are still yours to experience! Go forth and adventure!$b$b(You must be at least level 91 to hear Fu\'s stories.)','The tales I have to tell are still yours to experience! Go forth and adventure!$b$b(You must be at least level 91 to hear Fu\'s stories.)',26124),
(81141,'enUS','Tell me of Greenstone Village.','Tell me of Greenstone Village.',26124),
(81142,'enUS','Tell me of Unga Ingoo.','Tell me of Unga Ingoo.',26124),
(81143,'enUS','Tell me of the Crypt of Forgotten Kings.','Tell me of the Crypt of Forgotten Kings.',26124),
(81144,'enUS','Tell me of the Arena of Annihilation.','Tell me of the Arena of Annihilation.',26124),
(81145,'enUS','Tell me the tale of a Brewing Storm.','Tell me the tale of a Brewing Storm.',26124),
(81146,'enUS','Tell me of the Assault on Zan\'vess.','Tell me of the Assault on Zan\'vess.',26124),
(81147,'enUS','Tell me of the Brewmoon Festival.','Tell me of the Brewmoon Festival.',26124),
(81148,'enUS','Tell me of Theramore\'s Fall.','Tell me of Theramore\'s Fall.',26124),
(81149,'enUS','Tell me of the Dagger in the Dark that felled Vol\'jin.','Tell me of the Dagger in the Dark that felled Vol\'jin.',26124),
(81150,'enUS','Tell me of the Battle on the High Seas.','Tell me of the Battle on the High Seas.',26124),
(81151,'enUS','Tell me of how Varian and Tyrande learned a Little Patience.','Tell me of how Varian and Tyrande learned a Little Patience.',26124),
(81152,'enUS','Tell me of the unearthing of the Dark Heart of Pandaria.','Tell me of the unearthing of the Dark Heart of Pandaria.',26124),
(81153,'enUS','Tell me of the Secrets of Ragefire.','Tell me of the Secrets of Ragefire.',26124),
(81154,'enUS','Tell me the tale of Blood in the Snow.','Tell me the tale of Blood in the Snow.',26124),
(81155,'enUS','','Stand ready, $n. As soon as her shield is broken I will teleport us out of the mine.',26124),
(81156,'enUS','','This madness ends now Kaelynara! We will not allow you to cause further destruction!',26124),
(81157,'enUS','So, you have decided to join me on my quest to tame the Darktide Matriarch?$b$bIt appears you are not the only one. The Iron Horde is destroying this island and the creatures that inhabit it. They have no respect for the rylaks they hunt.$b$bRest assured $c, I will not let this disgraceful slaughter go unpunished.','',26124),
(81158,'enUS','It appears that one of your allies has arrived, mage.','',26124),
(81159,'enUS','My vindicators will handle things here. May the Light return you both in safety.','',26124),
(81160,'enUS','','Wait...what are you...?! Nooooo!!',26124),
(81161,'enUS','Unfortunate, but now we know more. You can take the portal back to Throm\'var.','',26124),
(81162,'enUS','Garrison - Event - Attack Prototype - Building Burning','',26124),
(81163,'enUS','','Good, I have been waiting for a fight!',26124),
(81164,'enUS','Garrison - Event - Attack Prototype - Reduce Reinforcements','',26124),
(81165,'enUS','Arrogant spirit, you dare to summon me?!','',26124),
(81166,'enUS','Your pathetic magic will have no control over me back in da normal world. Once I\'ve fed your friends to da Soulgrinder I\'ll return for you!','',26124),
(81167,'enUS','%s |cFFFF0404|Hspell:158986|h[Fixates]|h|r on you!','%s |cFFFF0404|Hspell:158986|h[Fixates]|h|r on you!',26124),
(81168,'enUS','Khadgar, let\'s go over what happened when Garona attacked.','Khadgar, let\'s go over what happened when Garona attacked.',26124),
(81169,'enUS','You owe me a fight, cowards.','',26124),
(81170,'enUS','Carnage!','',26124),
(81171,'enUS','There is no escape.','',26124),
(81172,'enUS','Let\'s give the crowd something to chew on.','',26124),
(81173,'enUS','You break so easily!','',26124),
(81174,'enUS','You\'ll always be remembered, as a smudge on my boot.','',26124),
(81175,'enUS','No mercy!','',26124),
(81176,'enUS','The vanguard is falling. We will not let their great sacrifice be in vain!','',26124),
(81177,'enUS','Your sacrifices will not be forgotten, Netherwane.','',26124),
(81178,'enUS','Archmage, let me stay behind. It was my sworn duty to watch over this portal.','',26124),
(81179,'enUS','I shared that duty with you, Dar\'toon.  We will meet the enemy together.','',26124),
(81180,'enUS','They will sing songs of your heroism, Dar\'toon.','',26124),
(81181,'enUS','Just get me free, stranger. I could kill a hundred of these pigs with this shovel alone.','',26124),
(81182,'enUS','Prepare to heroically CTRL-E through the portal with me!','',26124),
(81183,'enUS','Be careful, I\'ve seen the bodies that come back after their \"boss\" has finished with them. They have no markings of torture on them but their faces are all frozen in a scream.','Be careful, I\'ve seen the bodies that come back after their \"boss\" has finished with them. They have no markings of torture on them but their faces are all frozen in a scream.',26124),
(81184,'enUS','I was helping to move the bodies out of the western cave. There was a tall skinny female with green hair and pale blue skin that was still alive! It didn\'t look like an orc or if it was it was by far the most sickly looking thing I\'ve ever seen. One of the ogres took her down to the cave in the north east.','I was helping to move the bodies out of the western cave. There was a tall skinny female with green hair and pale blue skin that was still alive! It didn\'t look like an orc or if it was it was by far the most sickly looking thing I\'ve ever seen. One of the ogres took her down to the cave in the north east.',26124),
(81185,'enUS','A few nights ago there was a bunch of weird looking lights flashing from the cave across the lava flows. More of that foul ogre magic no doubt.','A few nights ago there was a bunch of weird looking lights flashing from the cave across the lava flows. More of that foul ogre magic no doubt.',26124),
(81186,'enUS','On your guard, $n. Once I break through Kaelynara\'s shield I will teleport us outside the mine!','',26124),
(81187,'enUS','This has gone on long enough! Your madness ends here Kaelynara!','',26124),
(81188,'enUS','Kaelynara\'s betrayal was unfortunate. I will inform Astalor as to what has become of his apprentice...','',26124),
(81189,'enUS','When you are ready, I will teleport you back to Jorune Mine.','',26124),
(81190,'enUS','','True arcane mastery only comes with patience and dedication. Kaelynara was naive to think otherwise...',26124),
(81191,'enUS','','When you are ready, I will teleport you back to Jorune Mine, $p.',26124),
(81192,'enUS','','I\'ll lead the wounded to safety. Cover our escape!',26124),
(81193,'enUS','The Frenzied Manafeeder has entered a weakened state.','',26124),
(81194,'enUS','','Welcome, wolf-$g brother:sister;. Warm yourself by the fire.',26124),
(81195,'enUS','Greetings. I have focused my studies on the heroic deeds of recent visitors to these lands. Would you hear any of these tales?','',26124),
(81196,'enUS','Tell me of the Battle on the High Seas (Heroic).','Tell me of the Battle on the High Seas (Heroic).',26124),
(81197,'enUS','Tell me of the unearthing of the Dark Heart of Pandaria (Heroic).','Tell me of the unearthing of the Dark Heart of Pandaria (Heroic).',26124),
(81198,'enUS','Tell me of the Secrets of Ragefire (Heroic).','Tell me of the Secrets of Ragefire (Heroic).',26124),
(81199,'enUS','Tell me the tale of Blood in the Snow (Heroic).','Tell me the tale of Blood in the Snow (Heroic).',26124),
(81200,'enUS','Tell me the tale of a Brewing Storm (Heroic).','Tell me the tale of a Brewing Storm (Heroic).',26124),
(81201,'enUS','Tell me of the Crypt of Forgotten Kings (Heroic).','Tell me of the Crypt of Forgotten Kings (Heroic).',26124),
(81202,'enUS','Gul\'dan\'s a slippery one.$B$BDon\'t let it get you down, commander. We\'ll catch him.','',26124),
(81203,'enUS','','My apologies for not joining you, commander. I\'d love to be out there killing the Shadow Council with you.$B$BHowever, my duty to protect the archmage must come first.$B$BOf course, you could whisper in his ear to have one of my sisters come and take my place.',26124),
(81204,'enUS','','The Shadow Council are disgusting. But, infusing the bodies of dead frost wolves with demonic energy is a new low!',26124),
(81205,'enUS','','I\'d bet you my spare blade that whatever\'s causing these ground tremors is also directly responsible for those rockworms.$B$BOf course, you have no idea how to wield one of these. Maybe you could mount it on your wall.',26124),
(81206,'enUS','','I\'ll be fine!',26124),
(81207,'enUS','Don\'t worry about me. They can\'t see this projection.$B$BEverything we do here is leading to one thing, $n: Gul\'dan\'s capture.','',26124),
(81208,'enUS','Commander, our work here is done. Please use the portal to return to Throm\'var.$B$BWe\'ll speak at length of next steps when you return.','',26124),
(81209,'enUS','If we\'re to destroy the fel crystals and bring down the barrier protecting the Gloomspire, you must find the demon key.$B$BI\'d start by killing Fernus.','',26124),
(81210,'enUS','Quickly, $n. The next step is to move throughout the ruins, using the infernal\'s heart to destroy the fel crystals.','',26124),
(81211,'enUS','Time is of the essence, commander. Gul\'dan could leave at any moment.$B$BYou must destroy those fel crystals and get to him inside the Gloomspire.','',26124),
(81212,'enUS','You continue to impress, Commander $n.$B$BOne thing remains: to capture Gul\'dan.','',26124),
(81213,'enUS','Gul\'dan is down below. Do whatever you must, $n, but capture him before he escapes.','',26124),
(81214,'enUS','You lot need to smash harder! We gotta beat da Bladespire at da next Circle of Blood!','',26124),
(81215,'enUS','You hit harder or me hit you!','',26124),
(81216,'enUS','You win da Circle of Blood, me give you dat slave I gots locked up outside.','',26124),
(81217,'enUS','My apologies, wolf-$g brother:sister;. We are dishonored for letting the archmage be attacked here in our home.','',26124),
(81218,'enUS','If I had it within my power, I\'d go back in time and strangle Gul\'dan before he drank of Mannoroth\'s blood.','',26124),
(81219,'enUS','Mark my words, $g brother:sister;, no good will come of Cho\'gall\'s interest in these Pale.','',26124),
(81220,'enUS','My heart lies heavy in my chest. Thank you for showing the Mother of Wolves her proper respects.$B$BShe will be avenged.','',26124),
(81221,'enUS','%s cries out for help!','%s cries out for help!',26124),
(81222,'enUS','Whoever you are... thank you.','Whoever you are... thank you.',26124),
(81223,'enUS','They were bleeding us dry. I don\'t think we had much longer...','They were bleeding us dry. I don\'t think we had much longer...',26124),
(81224,'enUS','Whoever you are... thank you.','Whoever you are... thank you.',26124),
(81225,'enUS','They were bleeding us dry. I don\'t think we had much longer...','They were bleeding us dry. I don\'t think we had much longer...',26124),
(81226,'enUS','Help us!','Help us!',26124),
(81227,'enUS','Set us free!','Set us free!',26124),
(81228,'enUS','Is anybody out there?','Is anybody out there?',26124),
(81229,'enUS','Help! Anybody!','Help! Anybody!',26124),
(81230,'enUS','Time to spill your blood!','',26124),
(81231,'enUS','','Hurry! We must move these supplies.  Ner\'zhul will not tolerate delays and neither will I!',26124),
(81232,'enUS','','One...',26124),
(81233,'enUS','','Two...',26124),
(81234,'enUS','','Three...',26124),
(81235,'enUS','','Four... Where\'s a peon when you need one?',26124),
(81236,'enUS','Look at the Draenei, so peaceful.  They have no idea their conquest awaits.','',26124),
(81237,'enUS','','Wit\'out your help, commander, we\'d be hard pressed ta put dat ogre down.',26124),
(81238,'enUS','Hurry runts, we have a quota to make!','Hurry runts, we have a quota to make!',26124),
(81239,'enUS','The Iron Horde needs more steel!','The Iron Horde needs more steel!',26124),
(81240,'enUS','I\'ll eat the meat off your ribs!','I\'ll eat the meat off your ribs!',26124),
(81241,'enUS','Give me your blood...','Give me your blood...',26124),
(81242,'enUS','The Bleeding Hollow have you now!','The Bleeding Hollow have you now!',26124),
(81243,'enUS','CRUSH YOU, MAKE BLEED!','',26124),
(81244,'enUS','OUT OF THE WAY, INSECT!','',26124),
(81245,'enUS','YOUR BLOOD IS MINE!','',26124),
(81246,'enUS','Fetch!','Fetch!',26124),
(81247,'enUS','Get it boy!','Get it boy!',26124),
(81248,'enUS','Where\'s your ball?','Where\'s your ball?',26124),
(81249,'enUS','','Da mojo be strong here mon. Now be da time to fight dis monsta.',26124),
(81250,'enUS','You thought you could get away so easily?  Attack!','You thought you could get away so easily?  Attack!',26124),
(81251,'enUS','Stop them!  No one gets out of the city!','Stop them!  No one gets out of the city!',26124),
(81252,'enUS','This is the end of your race, draenei!','This is the end of your race, draenei!',26124),
(81253,'enUS','There is no escape!','There is no escape!',26124),
(81254,'enUS','Terrorfang will put an end to you.','Terrorfang will put an end to you.',26124),
(81255,'enUS','Bomb Exploded! (-$8911w)','',26124),
(81256,'enUS','$n triggered a Slag Bomb.','',26124),
(81257,'enUS','Stick around shorty! I gonna make ye watch as I feed yer friend to da Soulgrinder!','',26124),
(81258,'enUS','You stay right there small woman! You not gonna use yer weird magic on me! You gonna stay there an watch as I feed yer friend to da Soulgrinder!','',26124),
(81259,'enUS','Quickly! Get these flames under control.','Quickly! Get these flames under control.',26124),
(81260,'enUS','More water over there!','More water over there!',26124),
(81261,'enUS','If this building burns, so will you! Faster!','If this building burns, so will you!  Faster!',26124),
(81262,'enUS','','You there! Find water! We must put these fires out.',26124),
(81263,'enUS','Aaaah!','',26124),
(81264,'enUS','Run!','',26124),
(81265,'enUS','Fire!','',26124),
(81266,'enUS','Someone find water!','',26124),
(81267,'enUS','We must join the Iron Horde else we will be crushed by it.  We must prove our worth!','',26124),
(81268,'enUS','Our ancestors once prohibited the use of the dark magic, they held us back.','',26124),
(81269,'enUS','Back from the power needed to save our clan!','',26124),
(81270,'enUS','So I say to you my brothers and sisters of the Shadowmoon clan; use the skills passed down from age to age!','',26124),
(81271,'enUS','Use them and summon forth the spirits of our ancestors.','',26124),
(81272,'enUS','Bind them to your will.','',26124),
(81273,'enUS','And twist them into the power we need.  Into the power we deserve!','',26124),
(81274,'enUS','','',26124),
(81275,'enUS','Only then can the future of the Shadowmoon be certain!','',26124),
(81276,'enUS','','$p, I think you should follow Tuulani and protect her. We need to ensure the crystal reaches Auchindoun safely.',26124),
(81277,'enUS','$p, you should follow Tuulani and protect her. We must ensure the crystal reaches Auchindoun safely.','',26124),
(81278,'enUS','Squeezing','Squeezing',26124),
(81279,'enUS','Blessings to you, stranger. Because of you, I will see daylight once more.','',26124),
(81280,'enUS','','Thank you, stranger! I was supposed to be their next meal...',26124),
(81281,'enUS','','Thank you, hero. I can fight my way out of here on my own.',26124),
(81282,'enUS','We must deny Teron\'gor entrance to Auchindoun. Come, let us meet at Retribution Point and discuss how to bring the fight to the enemy.','',26124),
(81283,'enUS','','Lets go mon, da cave be ta de south an west of de lava fields.',26124),
(81284,'enUS','','These bodies, they still be warm. Lets move on but keep ye wits about ye.',26124),
(81285,'enUS','','I kill you!',26124),
(81286,'enUS','','Kill more mon, and we be bringing da spirits back to dis place!',26124),
(81287,'enUS','','Tayhuwaniwanga!',26124),
(81288,'enUS','','Hold up, mon. Keep quiet an\' come ova here.',26124),
(81289,'enUS','','Let\'s go, mon! We got ta hurry and clear out dat ogron so we can use de portal.',26124),
(81290,'enUS','','We on de hunt! Through de portal quickly now!',26124),
(81291,'enUS','','Watch ye back commander, we not be alone here. I sense ye presence spirit! Show yeself!',26124),
(81292,'enUS','','Commanda, I sense nae evil intent in her and she be da first spirit ta speak wid us since I be here. \'Twould be wise ta have her help.',26124),
(81293,'enUS','You have *cough* restored this dying orc\'s honor, champion. Farewell. And farewell, Snowpaw, my old friend...','',26124),
(81294,'enUS','','',26124),
(81295,'enUS','','Thank you, hero. Your deeds will be remembered.',26124),
(81296,'enUS','Did you hear? The Iron Horde has sent emissaries to talk to Ner\'zhul.','Did you hear? The Iron Horde has sent emissaries to talk to Ner\'zhul.',26124),
(81297,'enUS','I overheard one of the Iron Horde grunts. I think they\'re planning an attack on Karabor soon.','I overheard one of the Iron Horde grunts. I think they\'re planning an attack on Karabor soon.',26124),
(81298,'enUS','Ner\'zhul has taught us how to take the power we deserve.  The draenei will see soon enough.','Ner\'zhul has taught us how to take the power we deserve.  The draenei will see soon enough.',26124),
(81299,'enUS','Rulkan left with the weaker members of our clan who would not embrace the Void.','Rulkan left with the weaker members of our clan who would not embrace the Void.',26124),
(81300,'enUS','I\'ve heard whispers. Ner\'zhul intends to summon the Dark Star!','I\'ve heard whispers. Ner\'zhul intends to summon the Dark Star!',26124),
(81301,'enUS','Thank you!','Thank you!',26124),
(81302,'enUS','I must seek a fire!','I must seek a fire!',26124),
(81303,'enUS','I should never have come to this place!','I should never have come to this place!',26124),
(81304,'enUS','Get out before they freeze you too!','Get out before they freeze you too!',26124),
(81305,'enUS','So cold... but still aware...','So cold... but still aware...',26124),
(81306,'enUS','The torment..','The torment..',26124),
(81307,'enUS','So cold it burns!','So cold it burns!',26124),
(81308,'enUS','I have felt the absence of heat...','I have felt the absence of heat...',26124),
(81309,'enUS','I\'ll free the rylak. You take care of this worm.','',26124),
(81310,'enUS','[ALL TEXT TEMP] This altar blocks our way! I\'ll look for a weak spot...','',26124),
(81311,'enUS','This isn\'t working. I guess I\'ll have to hulk out...','',26124),
(81312,'enUS','Alright, now it\'s time to smash things!','',26124),
(81313,'enUS','Alright, all smashed. Let\'s head back.','',26124),
(81314,'enUS','Enough rest, move out!','Enough rest, move out!',26124),
(81315,'enUS','Our allies can only buy us so much time before the entirety of that... Iron Horde is upon our camp.$b$bWe have to keep moving.','',26124),
(81316,'enUS','Let\'s get going, then!','Let\'s get going, then!',26124),
(81317,'enUS','|TINTERFACE\\ICONS\\ability_socererking_arcanewrath.blp:20|t You have been branded by |cFFF00000|Hspell:156238|h[Arcane Wrath]|h|r!','|TINTERFACE\\ICONS\\ability_socererking_arcanewrath.blp:20|t You have been branded by |cFFF00000|Hspell:156238|h[Arcane Wrath]|h|r!',26124),
(81318,'enUS','|TINTERFACE\\ICONS\\Spell_Arcane_MassDispel.blp:20|t You are afflicted with |cFFF00000|Hspell:158605|h[Mark of Chaos]|h|r!','|TINTERFACE\\ICONS\\Spell_Arcane_MassDispel.blp:20|t You are afflicted with |cFFF00000|Hspell:158605|h[Mark of Chaos]|h|r!',26124),
(81319,'enUS','|TINTERFACE\\ICONS\\spell_Mage_NetherTempest.blp:20|t |cFFF00000|Hspell:158648|h[Orbs of Chaos]|h|r explode from $n!','|TINTERFACE\\ICONS\\spell_Mage_NetherTempest.blp:20|t |cFFF00000|Hspell:158648|h[Orbs of Chaos]|h|r explode from $n!',26124),
(81320,'enUS','Receive my gift, Vorpil. You will be the first of a new breed of conquerors!','',26124),
(81321,'enUS','','What a curious specimen! Have you ever seen such a flower as this, traveler?',26124),
(81322,'enUS','Ah, the thorn in my side has arrived.','',26124),
(81323,'enUS','It\'s time I taught you a lesson.','',26124),
(81324,'enUS','Come, Cerus. Dinner awaits.','',26124),
(81325,'enUS','','Start Worldaction!',26124),
(81326,'enUS','','End Worldaction!',26124),
(81327,'enUS','','Terminate Worldaction!',26124),
(81328,'enUS','Let the ritual begin.','',26124),
(81329,'enUS','Feast your eyes on my limitless power, mortal.','',26124),
(81330,'enUS','Spirit!','',26124),
(81331,'enUS','Hold her! We can\'t let her escape before the ritual completes!','Hold her! We can\'t let her escape before the ritual completes!',26124),
(81332,'enUS','We are almost finished! A little more and her power will be ours to command!','We are almost finished! A little more and her power will be ours to command!',26124),
(81333,'enUS','Hold steady!  We must consume our ancestor\'s power if we have any hope to join the Iron Horde.','Hold steady!  We must consume our ancestor\'s power if we have any hope to join the Iron Horde.',26124),
(81334,'enUS','IGNORE ME!','',26124),
(81335,'enUS','Stables.','Stables.',26124),
(81336,'enUS','Remove Stables.','Remove Stables.',26124),
(81337,'enUS','Well, hero, I owe you both my life and my honor. I ask that you allow me to repay this debt by serving under your command.$b$bYou will find that I am a fearsome warrior. I have also mastered the art of riding the rylaks, which few among the Frostwolves can claim.$b$bWill you accept my service?','',26124),
(81338,'enUS','Accept the Mulverick\'s Offer of Service. (Garrison Follower)','Accept the  Mulverick\'s Offer of Service. (Garrison Follower)',26124),
(81339,'enUS','Your deeds have shown you to be a fine commander. The sort of commander I would be honored to fight alongside.','',26124),
(81340,'enUS','Run! %s has |cFFFF0000|Hspell:159632|h[Insatiable Hunger]|h|r and wants to eat you!','',26124),
(81341,'enUS','What are you doing here?','What are you doing here?',26124),
(81342,'enUS','Run away... they\'ll torture you too...','Run away... they\'ll torture you too...',26124),
(81343,'enUS','Who... who are you...?','Who... who are you...?',26124),
(81344,'enUS','Just let me die already!','Just let me die already!',26124),
(81345,'enUS','Do it now, stranger! End my pain!','Do it now, stranger! End my pain!',26124),
(81346,'enUS','Need... water...','Need... water...',26124),
(81347,'enUS','What\'s happening? Who are you?','What\'s happening? Who are you?',26124),
(81348,'enUS','I want my mama...','I want my mama...',26124),
(81349,'enUS','Here, take one of their blades. Don\'t use it until we give the signal.','Here, take one of their blades. Don\'t use it until we give the signal.',26124),
(81350,'enUS','I lend you my strength, master!','',26124),
(81351,'enUS','Lord Mongrethod, hear my call. This mortal threatens the master\'s plans!','',26124),
(81352,'enUS','','Eh boss-mon! Come in outta da cold. We be findin\' a right hot spot here in these rocks. Make ya feel right at home.',26124),
(81353,'enUS','words and things','',26124),
(81355,'enUS','A glorious battle awaits us, $p.','',26124),
(81356,'enUS','Saberon! I smell your stink upon the shadows...come out and play!','',26124),
(81357,'enUS','This had better work, Gul\'dan.','',26124),
(81358,'enUS','Why do you torment us?','Why do you torment us?',26124),
(81359,'enUS','You have damned yourself and our clan.','You have damned yourself and our clan.',26124),
(81360,'enUS','You have defiled our sacred arts and for what?','You have defiled our sacred arts and for what?',26124),
(81361,'enUS','Hey! What you doing? Dems MY food!!','',26124),
(81362,'enUS','We do what we must to survive!','We do what we must to survive!',26124),
(81363,'enUS','Do not judge me!  Our clan depends on the power your soul hides.','Do not judge me!  Our clan depends on the power your soul hides.',26124),
(81364,'enUS','I will enjoy twisting what remains of you.','I will enjoy twisting what remains of you.',26124),
(81365,'enUS','I find no joy in this. Do not make this any harder than it already is.','I find no joy in this, do not make this any harder than it already is.',26124),
(81366,'enUS','Come, Teron\'gor. Our contact has provided another entrance to Auchindoun. Your feast of souls awaits.','',26124),
(81367,'enUS','My... dinner....','',26124),
(81368,'enUS','Yes, Gul\'dan. Your will be done.','Yes, Gul\'dan. Your will be done.',26124),
(81369,'enUS','Not dying on my watch!','Not dying on my watch!',26124),
(81370,'enUS','Live!','Live!',26124),
(81371,'enUS','Gaahh! How me supposed to learn how to control da ice if you breaks me out of it! Me gonna smash you for dat!','',26124),
(81372,'enUS','I t\'ink I\'m getting colder...','',26124),
(81373,'enUS','I\'ve seen enough here.','',26124),
(81374,'enUS','Kargath, you coward!','',26124),
(81375,'enUS','You wouldn\'t last ten seconds against me, draenei.','',26124),
(81376,'enUS','You sound afraid, Kargath.','',26124),
(81377,'enUS','Two on one? Now, you speak my language!','',26124),
(81378,'enUS','That\'s not very sportsmanlike, Bladefist. Why don\'t we settle this in the arena?','',26124),
(81379,'enUS','Hold everything! Now, they speak my language!','',26124),
(81380,'enUS','But I\'m afraid you\'re not much more than a warm-up, draenei. Doesn\'t anyone else feel like dying today?','',26124),
(81381,'enUS','Thought you\'d never ask.','',26124),
(81382,'enUS','Return to Khadgar, champion! We will buy you the time you need!','',26124),
(81383,'enUS','I\'d like to cut off that head of yours, draenei.','',26124),
(81384,'enUS','Why don\'t you put your blade where your mouth is, Kargath?','',26124),
(81385,'enUS','... looks like somebody already put his blade where his hand was.','',26124),
(81386,'enUS','I\'ll do one better and put my blade where your throat is!','',26124),
(81387,'enUS','Do you always let a draenei fight your battles for you, green-skin?','',26124),
(81388,'enUS','I do when we share a common enemy.','',26124),
(81389,'enUS','Ptuh! And I thought you were an orc...','',26124),
(81390,'enUS','You wield a Blackrock hammer, green-skin.','',26124),
(81391,'enUS','Yes, I do. Would you like to take a closer look?','',26124),
(81392,'enUS','I love fighting draenei. You people always look so scared before you die.','',26124),
(81393,'enUS','Sorry to disappoint you.','',26124),
(81394,'enUS','Mangy beasts! You fight like kittens!','',26124),
(81395,'enUS','Come at me with tooth and claw!','',26124),
(81396,'enUS','The blood of the innocent stains your claws!','',26124),
(81397,'enUS','%s flees to report your position!','%s flees to report your position!',26124),
(81398,'enUS','The rest have fled...but not from us.','',26124),
(81399,'enUS','The air...it smells like...something is wrong.','',26124),
(81400,'enUS','','Asha! To me!',26124),
(81401,'enUS','I\'ll help you!','I\'ll help you!',26124),
(81402,'enUS','I will fight by your side.','I will fight by your side.',26124),
(81403,'enUS','','Can you imagine a live colossus? They say this was the last one, and the Thunderlord clan took it down generations ago.',26124),
(81404,'enUS','I must help the others. Slay more of them for me!','I must help the others. Slay more of them for me!',26124),
(81405,'enUS','I am here to end your suffering, friend. Go in peace, your tormentors will not go unpunished.','',26124),
(81406,'enUS','Wipe out the Unmanned Shredders and meet us on the south side of the island.','',26124),
(81407,'enUS','Ha, we\'ll kill them yet!','Ha, we\'ll kill them yet!',26124),
(81408,'enUS','Death to our enemies!','Death to our enemies!',26124),
(81409,'enUS','Well fought!','Well fought!',26124),
(81410,'enUS','It\'s time for the Iron Horde to learn a little respect for the hunt. Haratha, see to it that our friend here is protected.','',26124),
(81411,'enUS','When I said I\'d help with the war effort I thought I\'d be a soldier helping win the war through skill with a weapon.$bInstead I\'m here drawing up plans and placing bricks.$b$bI guess I\'ll live longer this way at least.','',26124),
(81412,'enUS','As promised I will set you free. But I think these wolves would like to talk with you before you go.','',26124),
(81413,'enUS','Let\'s go, $n. Our hunt continues.','',26124),
(81414,'enUS','Whoa! Hold on! Now, just wait a second! We can talk this through!','',26124),
(81415,'enUS','You fight with honor, $p.','',26124),
(81416,'enUS','I will tell my brethren at the arena of your courage. Be safe.','',26124),
(81417,'enUS','Somebody help!!! I need back up!!','',26124),
(81418,'enUS','I feel the flames dying down. What is happening, exarch?','',26124),
(81419,'enUS','We have a visitor. Perhaps... a savior.','',26124),
(81420,'enUS','We are freed! Follow me, shaman. We will escape through the hills.','',26124),
(81421,'enUS','Steady...  steady. You are no longer in danger. I will not hurt you.','',26124),
(81422,'enUS','I will fly her to safety. Meet me at the islands east of here. Nisha will fly you there if you wish.','',26124),
(81423,'enUS','Whoa! There you go... good girl.','',26124),
(81424,'enUS','Eye of Gul\'dan has spotted you!','',26124),
(81425,'enUS','%s plants an Ironmarch War Banner!','%s plants an Ironmarch War Banner!',26124),
(81426,'enUS','Teron\'gor does not desire further disturbances. Dispose of the intruder!','',26124),
(81427,'enUS','I\'m ready to choose the outpost building now.','I\'m ready to choose the outpost building now.',26124),
(81428,'enUS','','This is where it happened...',26124),
(81429,'enUS','','Look here - wolf tracks. They turn into orc tracks. One of our shamans found her.',26124),
(81430,'enUS','Where is her body?','',26124),
(81431,'enUS','The Iron Horde has been feeding these wolves to the rylaks.$b$bThis little runt was trying to get away when I broke the gate open.$b$bLet\'s see if he is of any use to us.','',26124),
(81432,'enUS','','Whoever it was, they must have recovered Asha\'s body.',26124),
(81433,'enUS','','They will give her the proper last rites. Come, let us speak with Durotan.',26124),
(81434,'enUS','IGNORE ME!','',26124),
(81435,'enUS','I ain\'t giving up easy! Garrosh personally promised me Stormwind!','',26124),
(81436,'enUS','Hey Franz? Franzok! We got a jam!','',26124),
(81437,'enUS','I ain\'t un-jammin it! I un-jammed it last time!','',26124),
(81438,'enUS','Ey you! Get in dere and un-jam that stamper!','',26124),
(81439,'enUS','So? Go un-jam it den!','',26124),
(81440,'enUS','You wanna tell Blackhand we got a stamper that ain\'t stampin\'?','',26124),
(81441,'enUS','Ha ha ha! Guess dis batch will have some impurities.','',26124),
(81442,'enUS','Work work work...','',26124),
(81443,'enUS','He is right. The Iron Horde will move against us. We must be ready.','',26124),
(81444,'enUS','We\'ll be ready. They will NEVER take the pass.','',26124),
(81445,'enUS','','Are you okay, husband?',26124),
(81446,'enUS','No, I will never be okay with this.','',26124),
(81447,'enUS','He made his choice.','',26124),
(81448,'enUS','Come! To Thunder Pass. We are outnumbered 50 to 1. They don\'t stand a chance!','',26124),
(81450,'enUS','<Ared\'s breath comes in short gasps as he lays in an uneasy sleep.>','',26124),
(81451,'enUS','Examine Ared\'s condition more closely.','Examine Ared\'s condition more closely.',26124),
(81452,'enUS','<Ared\'s breath comes in short gasps as he lays in an uneasy sleep. Beads of sweat cover his head and a noxious odor rises from his bloody wounds. It would seem that what time he has left will not last for long.>','',26124),
(81453,'enUS','A nearby Void Wolf is alerted to you! Get away before it attacks!','A nearby Void Wolf is alerted to you! Get away before it attacks!',26124),
(81454,'enUS','A nearby Void Occulus is alerted to you! Get away before it attacks!','A nearby Void Occulus is alerted to you! Get away before it attacks!',26124),
(81455,'enUS','I have seen your forces marching boldly across the landscape with the confidence of the Warsong.$b$bYou have my attention.','',26124),
(81456,'enUS','Accept the Defection of Gronnstalker Rokash. (Garrison Follower)','Accept the  Defection of Gronnstalker Rokash. (Garrison Follower)',26124),
(81457,'enUS','You take care of the lieutenants, champion. Bladefist is mine.','',26124),
(81458,'enUS','Cutting down unarmed prisoners? Why not fight a real battle?','',26124),
(81459,'enUS','','[ph] Can I follow you?',26124),
(81460,'enUS','Accept the Blood Oath of Lokra. (Garrison Follower)','Accept the  Blood Oath of Lokra. (Garrison Follower)',26124),
(81461,'enUS','You are about to be ejected from your Wor\'var Demolisher. Return to Nagrand.','',26124),
(81462,'enUS','At your service, commander.','',26124),
(81463,'enUS','Capping','Capping',26124),
(81464,'enUS','Fracking','Fracking',26124),
(81465,'enUS','We\'re all counting on you, $n.','',26124),
(81471,'enUS','$n crafts an Air Trinket!','$n crafts an Air Trinket!',26124),
(81472,'enUS','$n is attempting to free an ally from all crowd-controlling effects!','$n is attempting to free an ally from all crowd-controlling effects!',26124),
(81473,'enUS','A throng of angry orcs begin throwing |cFFFF0000|Hspell:159386|h[Iron Bombs]|h|r into the arena! $B$B x5 Iron Bombers |TInterface\\Icons\\achievement_character_orc_male_brn.blp:32|t','',26124),
(81474,'enUS','Drunken Ogres begin hurling |cFFFF0000|Hspell:159410|h[Mauling Brew]|h|r from the stands! $B$B x2 Drunken Bileslingers|TInterface\\Icons\\achievement_reputation_ogre.blp:32|t x5 Iron Bombers |TInterface\\Icons\\achievement_character_orc_male_brn.blp:32|t','',26124),
(81479,'enUS','Eager for bloodshed, the crowd rains destruction onto the arena floor! $B$B x1 Drunken Bileslinger|TInterface\\Icons\\achievement_reputation_ogre.blp:32|t x5 Iron Bombers |TInterface\\Icons\\achievement_character_orc_male_brn.blp:32|t','',26124),
(81480,'enUS','Enthralled by the violence, the crowd attempts to up the body count! $B$B x3 Drunken Bileslingers |TInterface\\Icons\\achievement_reputation_ogre.blp:32|t x5 Iron Bombers |TInterface\\Icons\\achievement_character_orc_male_brn.blp:32|t','',26124),
(81481,'enUS','Enraged by the lack of corpses, the crowd showers the arena with explosives! $B$B x5 Iron Bombers |TInterface\\Icons\\achievement_character_orc_male_brn.blp:32|t','',26124),
(81482,'enUS','','Master Velen, I have never led soldiers before. Are you sure--',26124),
(81483,'enUS','You are capable of more than you know, Yrel.','',26124),
(81485,'enUS','Now go. The Rangari follow your orders. Find the prisoners.','',26124),
(81486,'enUS','','It\'s hopeless. How are we going to get out of here?',26124),
(81487,'enUS','Think of your people. The captives still need our help!','Think of your people. The captives still need our help!',26124),
(81488,'enUS','','Why? What is the use of saving them? Only death awaits us all in the end.',26124),
(81489,'enUS','We can\'t give up now! Heroes learn from their mistakes.','We can\'t give up now! Heroes learn from their mistakes.',26124),
(81490,'enUS','','A hero? Hardly! I am just an initiate, and not a very good one at that.',26124),
(81491,'enUS','We all start from humble beginnings. I once hunted troggs in the cold mountains of Dun Morogh.','We all start from humble beginnings. I once hunted troggs in the cold mountains of Dun Morogh.',26124),
(81492,'enUS','','I see, $n. You have never backed down from a challenge. I must strive to do the same.',26124),
(81493,'enUS','Pull yourself together, Yrel! You can do better than this!','Pull yourself together, Yrel! You can do better than this!',26124),
(81494,'enUS','','Oh! I needed to hear that, $n. I must not fall prey to my own fears.',26124),
(81495,'enUS','You must choose, Yrel. Will you rise and fight, or fall here to doubt?','You must choose, Yrel. Will you rise and fight, or fall here to doubt?',26124),
(81496,'enUS','','You are right, $n. My choices do matter. I choose... to fight!',26124),
(81497,'enUS','Believe in the Light! Despite setbacks, it will always prevail.','Believe in the Light! Despite setbacks, it will always prevail.',26124),
(81498,'enUS','','Is it true? Good doesn\'t always triumph over evil.',26124),
(81499,'enUS','The Light is only as strong as its champions. Believe in YOURSELF.','The Light is only as strong as its champions. Believe in YOURSELF.',26124),
(81500,'enUS','\'Doubt the Light\' just doesn\'t have the same ring to it.','\'Doubt the Light\' just doesn\'t have the same ring to it.',26124),
(81501,'enUS','Your people have triumphed over endless persecution. Will you let their hopes die here without a fight?','Your people have triumphed over endless persecution. Will you let their hopes die here without a fight?',26124),
(81502,'enUS','','You are truly wise, $n. I must believe in myself, for I carry the Light within me.',26124),
(81503,'enUS','','You choose the strangest times for humor, $c. Nevertheless, you have a point. I must have courage!',26124),
(81504,'enUS','','You are right, $n. I will not bow quietly to these enemies. I must fight!',26124),
(81505,'enUS','$n activates the Great Spire\'s Focusing Iris!','$n activates the Great Spire\'s Focusing Iris!',26124),
(81506,'enUS','You are about to be ejected from your Telaari Tank. Return to Nagrand.','',26124),
(81508,'enUS','','You have a pretty good shop going on here. Much bigger then the shack I used to work at in Shattrath.',26124),
(81509,'enUS','Just be ready when our ships arrive at Karabor.','',26124),
(81510,'enUS','I\'d like an equipment upgrade...','I\'d like an equipment upgrade...',26124),
(81511,'enUS','I found some strange metal for you to examine...','I found some strange metal for you to examine...',26124),
(81512,'enUS','I have more frost iron ingots for you.','I have more frost iron ingots for you.',26124),
(81513,'enUS','Artillery Strike Inbound!','Artillery Strike Inbound!',26124),
(81515,'enUS','','Keep flappin\' yer gums, if you want to be an orc kabob.',26124),
(81516,'enUS','You two are workin\' slower than scrawny goblins!','',26124),
(81517,'enUS','Might want to repair that stamper before Northrend thaws!','',26124),
(81518,'enUS','I can\'t wait to hear a job\'s done.','',26124),
(81519,'enUS','','You know how easy it is to hide a body under one of these things?',26124),
(81520,'enUS','','That\'s enough outta you, gasbag.',26124),
(81521,'enUS','Get those peons under control!  You heard Ner\'zhul, no one leaves this village!','Get those peons under control!  You heard Ner\'zhul, no one leaves this village!',26124),
(81522,'enUS','|TInterface\\Icons\\spell_shaman_improvedfirenova.blp:20|tThe frequency of the Heart of the Mountain\'s |cFFFF0000|Hspell:155209|h[Blast]|h|r has been increased!','|TInterface\\Icons\\spell_shaman_improvedfirenova.blp:20|tThe frequency of the Heart of the Mountain\'s |cFFFF0000|Hspell:155209|h[Blast]|h|r has been increased!',26124),
(81523,'enUS','Invaders have been spotted near the front gate!','Invaders have been spotted near the front gate!',26124),
(81524,'enUS','Invaders have been spotted near the farm!','Invaders have been spotted near the farm!',26124),
(81525,'enUS','Invaders have been spotted near the town hall!','Invaders have been spotted near the town hall!',26124),
(81526,'enUS','Garrison - Event - Orc Attack Stage 1.1a Begin','',26124),
(81527,'enUS','Garrison - Event - Orc Attack Stage 1.1 Begin','',26124),
(81528,'enUS','','Good! We must have arrived before Teron\'gor and Gul\'dan!',26124),
(81529,'enUS','','Nyami is working to bolster the defenses against their assault - follow me, we will report to her.',26124),
(81530,'enUS','','Beautiful, isn\'t it? Just think - you\'re one of the first outsiders to see inside Auchindoun.',26124),
(81531,'enUS','','Strange... why is the door sealed? No matter...',26124),
(81532,'enUS','','Let us proceed.',26124),
(81533,'enUS','','The Vindicators and Exarchs of the past. Heroes all - their souls still remain with us here.',26124),
(81534,'enUS','','Nyami! We are here -',26124),
(81535,'enUS','','What is this? Oh, no... no...',26124),
(81536,'enUS','','You have to stop them!',26124),
(81537,'enUS','','...The protector... still answers her call... you\'ll have to defeat it!',26124),
(81538,'enUS','','Ahhh!',26124),
(81539,'enUS','','She... got away. The defenses...',26124),
(81540,'enUS','','She had help. So many of our order were corrupt...',26124),
(81541,'enUS','','I\'ll gather any who remain loyal here and protect them. You - please, go put a stop to this madness!',26124),
(81542,'enUS','','You... you did it!',26124),
(81543,'enUS','','Here - this is not enough to thank you for your actions, but it is what we have to give.',26124),
(81544,'enUS','','Now we can rebuild... we must rebuild. We will never allow our souls to fall to the Legion.',26124),
(81545,'enUS','','You have done more than you know. Our people can never thank you enough.',26124),
(81546,'enUS','Seismic Shockwave! Use a steam vent to get off the ground!','',26124),
(81547,'enUS','','Now that the Heart of Auchindoun is back inside, our defenses should be impenetrable!',26124),
(81548,'enUS','Champion! It is good that you have joined us! I will hold these Thunderlord off in case any of your allies arrive.','',26124),
(81549,'enUS','','$n loses their Damage Shield!',26124),
(81550,'enUS','','$n regains their Damage Shield!',26124),
(81551,'enUS','Invaders have been spotted near the back gate!','Invaders have been spotted near the back gate!',26124),
(81552,'enUS','Invaders have been spotted near the mine!','Invaders have been spotted near the mine!',26124),
(81553,'enUS','Invaders have been spotted near the western wall!','Invaders have been spotted near the western wall!',26124),
(81554,'enUS','Invaders have been spotted near the town square!','Invaders have been spotted near the town square!',26124),
(81555,'enUS','','Are YOU, Tuulani, and your outsider friends.',26124),
(81556,'enUS','','Try as you might, this place is doomed. It is only a matter of time...',26124),
(81557,'enUS','','Yes! Yes! The crystal hums... just a bit of focus and...',26124),
(81558,'enUS','Time to build stuff!','Time to build stuff!',26124),
(81559,'enUS','Look out behind you!','Look out behind you!',26124),
(81560,'enUS','I think I got him.','I think I got him.',26124),
(81561,'enUS','You have my thanks.','You have my thanks.',26124),
(81562,'enUS','Praise the Light!','Praise the Light!',26124),
(81563,'enUS','A weapon!','A weapon!',26124),
(81564,'enUS','Now, let\'s see how THEY like being cut open!','Now, let\'s see how THEY like being cut open!',26124),
(81565,'enUS','At last, freedom!','At last, freedom!',26124),
(81566,'enUS','Farewell, my love.','Farewell, my love.',26124),
(81567,'enUS','Thank the Light!','Thank the Light!',26124),
(81568,'enUS','I thought I was going to die here.','I thought I was going to die here.',26124),
(81569,'enUS','You have no idea how long I\'ve been waiting to do this.','You have no idea how long I\'ve been waiting to do this.',26124),
(81570,'enUS','Die, pig!','Die, pig!',26124),
(81571,'enUS','I will avenge you, Tannosh.','I will avenge you, Tannosh.',26124),
(81572,'enUS','Go with the Light, sister.','Go with the Light, sister.',26124),
(81573,'enUS','May your spirit find rest with those of your people\'s ancestors.','May your spirit find rest with those of your people\'s ancestors.',26124),
(81574,'enUS','Kill them. Kill them all.','Kill them. Kill them all.',26124),
(81575,'enUS','Make them suffer, like I suffered.','Make them suffer, like I suffered.',26124),
(81576,'enUS','Thanks.','Thanks.',26124),
(81577,'enUS','I\'ve never held a weapon before.','I\'ve never held a weapon before.',26124),
(81578,'enUS','It feels good.','It feels good.',26124),
(81579,'enUS','Ooh!','Ooh!',26124),
(81580,'enUS','You give my people hope, stranger.','You give my people hope, stranger.',26124),
(81581,'enUS','','The poor dear, she injured herself trying to escape the flames.$b$b<Vilonia pats Miss Purr-Purr softly on the head.>$b$bLook at that sad face, I can\'t just leave her to face the fire alone.',26124),
(81582,'enUS','Oregorger has grown hungry and wants to eat more blackrock ore!','',26124),
(81583,'enUS','A bomb is placed! Find it!','',26124),
(81584,'enUS','','Help! The little Prowlers have been frightened senseless by the fire and won\'t evacuate! Please, calm them down so they can escape!',26124),
(81585,'enUS','Dagg tanks you, friend! <Dagg lets out a guttural chuckle.>','',26124),
(81586,'enUS','','I cannot thank you enough for all of your help, $n.',26124),
(81587,'enUS','','Commander! Your timing is impeccable as always.',26124),
(81588,'enUS','','Luuka, follow me. It is time we returned to the garrison.',26124),
(81589,'enUS','Oregorger is full of blackrock ore!','',26124),
(81590,'enUS','Ga\'nar said stay out of his way, so I am doing just that. I am not going to get myself killed in the name of the Iron Wolf or his kin.$b$bWe should talk... if you survive this.','',26124),
(81591,'enUS','Will you join me in the fight against the Iron Horde?','Will you join me in the fight against the Iron Horde?',26124),
(81592,'enUS','Don\'t mind me. I\'m staying out of this fight.','',26124),
(81593,'enUS','Dunno how dem orcs keep catchin\' me. <Dagg snickers disarmingly.>','',26124),
(81594,'enUS','Hi again.','',26124),
(81595,'enUS','Gonna have to ask demself, \"Did Dagg get catched or did Dagg catched dem?\"\n\nBig hero been blowin\' Dagg\'s cover! But you special, Dagg t\'inks. Dagg is master of dis guys and want to join you.\n\nDagg is unanimous in dis.','',26124),
(81596,'enUS','Unanimously agree with Dagg? (Garrison Follower)','Unanimously agree with Dagg? (Garrison Follower)',26124),
(81597,'enUS','A great leader sets an example for all those who follow.$b$bThey know when to speak, and when to listen.$b$bThey know when to stand and fight for their survival, and when to sacrifice it all for the greater good.$b$bAre you ready to lead, $n?','',26124),
(81598,'enUS','Thank you, stranger. Now I may finally enter Auchindoun.','Thank you, stranger. Now I may finally enter Auchindoun.',26124),
(81599,'enUS','I am free!','I am free!',26124),
(81600,'enUS','A thousand blessings, $c.','A thousand blessings, $c.',26124),
(81601,'enUS','Thank the Light you showed up.','Thank the Light you showed up.',26124),
(81602,'enUS','Can you feel it, $n? A great army will stand at this very spot, and they will look to you for guidance.','',26124),
(81603,'enUS','Plant your banner, and claim your destiny.','',26124),
(81607,'enUS','Don\' blow Dagg\'s cover!$B$BDey never question a tree.$B$BDagg is unanimous in dis.','',26124),
(81608,'enUS','Don\' let dem see us talkin\'!\n\nDey never question a two-head.\n\nDagg is unanimous in dis.','',26124),
(81609,'enUS','Shh! Act natural.','',26124),
(81610,'enUS','Shh! Don\' blow my cover.','',26124),
(81611,'enUS','Burn the bridge! Nothing must interfere!','Burn the bridge! Nothing must interfere!',26124),
(81612,'enUS','Turn away to avoid Hypnocroak\'s |cFFFF0000|Hspell:160664|h[Hypnotic Gaze]|h|r','',26124),
(81613,'enUS','So, this is where we will build your garrison.$b$bHave you commanded this many troops before?$b$bI\'m sure you\'ll do fine... I hope.','',26124),
(81614,'enUS','Debug - Garrison - Toggle Stage 1 Version','',26124),
(81616,'enUS','','I be feelin\' better \'bout our chances wid you here, $n.',26124),
(81617,'enUS','$n','',26124),
(81618,'enUS','$n','$n',26124),
(81619,'enUS','Garrisons - Attack Stage 1.2 Begin','',26124),
(81620,'enUS','Garrisons - Attack Stage 1.3 Begin','',26124),
(81621,'enUS','The Temple of Karabor? No... it cannot be. We are under attack!','',26124),
(81622,'enUS','Wait... no... it cannot be. The temple is under attack!','',26124),
(81623,'enUS','','Hold the barricades! Protect the defense crystal at all costs!',26124),
(81625,'enUS','ENOUGH! Play time is over. Ships, on my mark, FIRE ON THE CRYSTAL!','',26124),
(81626,'enUS','','No! That defense crystal was our only hope.',26124),
(81627,'enUS','Stay close to me, champion!','',26124),
(81628,'enUS','','There must be something we can use in these old bones.',26124),
(81629,'enUS','','Work faster fools, the Dark Star draws ever closer!',26124),
(81630,'enUS','$n is hosting a Feast of Blood. Enjoy!','$n is hosting a Feast of Blood. Enjoy!',26124),
(81631,'enUS','Yrel, what is happening?','',26124),
(81632,'enUS','','We couldn\'t stop the Dark Star, Prophet. The Iron Horde have taken the harbor!',26124),
(81633,'enUS','','Watch your heads! Iron capsules incoming!',26124),
(81634,'enUS','|TInterface\\Icons\\Spell_Fire_Fireball02:20|t $n has picked up |cFFFF0000|Hspell:160702|h[Blackrock Mortar Shells]|h|r!','|TInterface\\Icons\\Spell_Fire_Fireball02:20|t $n has picked up |cFFFF0000|Hspell:160702|h[Blackrock Mortar Shells]|h|r!',26124),
(81635,'enUS','|TInterface\\Icons\\inv_misc_pyriumgrenade:20|t $n has picked up |cFFFF0000|Hspell:160703|h[Blackrock Grenades]|h|r!','|TInterface\\Icons\\inv_misc_pyriumgrenade:20|t $n has picked up |cFFFF0000|Hspell:160703|h[Blackrock Grenades]|h|r!',26124),
(81636,'enUS','|TInterface\\Icons\\spell_shaman_improvedfirenova:20|t $n has picked up |cFFFF0000|Hspell:156357|h[Blackrock Shrapnel]|h|r!','|TInterface\\Icons\\spell_shaman_improvedfirenova:20|t $n has picked up |cFFFF0000|Hspell:156357|h[Blackrock Shrapnel]|h|r!',26124),
(81638,'enUS','I need you to come on patrol with me.','I need you to come on patrol with me.',26124),
(81639,'enUS','Yes, sir!','Yes, sir!',26124),
(81640,'enUS','Welcome to the Ring of Trials! I\'m here setting up fights for the arena. If you\'re looking to make some extra cash, you\'ve come to the right place!','',26124),
(81641,'enUS','What can I do for you, Commander?','What can I do for you, Commander?',26124),
(81642,'enUS','I\'ve got you, Commander!','I\'ve got you, Commander!',26124),
(81643,'enUS','Hang in there, sir!','Hang in there, sir!',26124),
(81644,'enUS','You\'re not going down that easy!','You\'re not going down that easy!',26124),
(81645,'enUS','The light will protect you!','The light will protect you!',26124),
(81646,'enUS','Marking','Marking',26124),
(81647,'enUS','You want fight in the arena? Talk wit\' Dexyl, he puts the fights together.$b$bMe? I just here to start the match... and clean up the bodies after! BAWHAHA!','',26124),
(81648,'enUS','Over here, you ugly brutes!','Over here, you ugly brutes!',26124),
(81649,'enUS','Grrraahh!','Grrraahh!',26124),
(81650,'enUS','I\'ve got these ones!','I\'ve got these ones!',26124),
(81651,'enUS','Why don\'t you pick on me for a bit?','Why don\'t you pick on me for a bit?',26124),
(81652,'enUS','Stop the saboteurs!','Stop the saboteurs!',26124),
(81653,'enUS','We\'re ready for construction! I learned a few new techniques when building Orgrimmar.','',26124),
(81654,'enUS','Begin Construction [Build Garrison]','Begin Construction [Build Garrison]',26124),
(81655,'enUS','Iron Fleet! Darken the skies!','',26124),
(81656,'enUS','I am ready to begin the first Trial of The Ring.','I am ready to begin the first Trial of The Ring.',26124),
(81657,'enUS','Marak the Blooded begins to channel a |cFFFF0000|Hspell:158079|h[Blood Ritual]|h|r on you!','Marak the Blooded begins to channel a |cFFFF0000|Hspell:158079|h[Blood Ritual]|h|r on you!',26124),
(81658,'enUS','So much to do and so little time.','',26124),
(81659,'enUS','I am ready to begin the second Trial of The Ring.','I am ready to begin the second Trial of The Ring.',26124),
(81660,'enUS','I am ready to begin the third Trial of The Ring.','I am ready to begin the third Trial of The Ring.',26124),
(81661,'enUS','I am ready to begin the fourth Trial of The Ring.','I am ready to begin the fourth Trial of The Ring.',26124),
(81662,'enUS','I am ready to begin the fifth Trial of The Ring.','I am ready to begin the fifth Trial of The Ring.',26124),
(81663,'enUS','They\'re bombarding with artillery!','',26124),
(81664,'enUS','Thank you for your assistance, be healed and back to battle!','Thank you for your assistance, be healed and back to battle!',26124),
(81665,'enUS','Forward! We must stop Vorka!','Forward! We must stop Vorka!',26124),
(81666,'enUS','My thanks to you. Be healed and carry on!','My thanks to you. Be healed and carry on!',26124),
(81667,'enUS','We did not expect to find any friendly faces out here in this wasteland. We have survived only by sticking together and relying on one another to get this far.$b$bOur escape attempt was only half executed though. Kor\'gall got wind of our plan before we could assassinate him and take his axe.','',26124),
(81668,'enUS','I have never met a beast I could not hunt!','I have never met a beast I could not hunt!',26124),
(81669,'enUS','','No! Awk! You\'re just another illusion! Another lie! Ra-awk! I\'ll expose the darkness within you!',26124),
(81670,'enUS','Admiral Gar\'an prepares to man the Dreadnaught\'s Main Cannon!','Admiral Gar\'an prepares to man the Dreadnaught\'s Main Cannon!',26124),
(81671,'enUS','Enforcer Sorka prepares to man the Dreadnaught\'s Main Cannon!','Enforcer Sorka prepares to man the Dreadnaught\'s Main Cannon!',26124),
(81672,'enUS','Marak the Blooded prepares to man the Dreadnaught\'s Main Cannon!','Marak the Blooded prepares to man the Dreadnaught\'s Main Cannon!',26124),
(81674,'enUS','I am afraid I must depart and rejoin our pack at Wor\'gol. Aka\'Magosh.','',26124),
(81675,'enUS','Out of the way, peon!','Out of the way, peon!',26124),
(81676,'enUS','What you looking at?','',26124),
(81677,'enUS','Kash\'drakor says it is time to escape.','Kash\'drakor says it is time to escape.',26124),
(81678,'enUS','','Who\'s there!? Oh - I\'m glad I\'m not the only one fighting these monsters.',26124),
(81679,'enUS','The darkness comes for you...','The darkness comes for you...',26124),
(81680,'enUS','More souls for the taking!','More souls for the taking!',26124),
(81681,'enUS','My life for Ner\'zhul!','My life for Ner\'zhul!',26124),
(81682,'enUS','Did my father send you? I told them he would find a way to spring me! Thanks, stranger.','',26124),
(81683,'enUS','You think you\'re clever?! You\'re next to burn!','',26124),
(81684,'enUS','Fool! You\'ll need more than flames to finish me!','',26124),
(81685,'enUS','Coward! You can\'t hide behind these traps forever!','',26124),
(81686,'enUS','My death changes nothing! Full... ATTACK!','',26124),
(81687,'enUS','','Up there! The fleet commander shows himself!',26124),
(81688,'enUS','Brave champion, I need your aid in my defense, we will break this siege if you can give me time!','Brave champion, I need your aid in my defense, we will break this siege if you can give me time!',26124),
(81689,'enUS','','They\'re breaking through. Retreat! We\'ll make our final stand on the stairs!',26124),
(81690,'enUS','Commander. I\'m at your disposal.$B$BDo you have any further orders?','',26124),
(81691,'enUS','Oh good, it\'s you, $n.','',26124),
(81692,'enUS','','How DARE you interrupt my work! I\'ll send your soul screaming into the beyond!',26124),
(81693,'enUS','$n is hosting a Feast of the Waters. Enjoy!','$n is hosting a Feast of the Waters. Enjoy!',26124),
(81694,'enUS','What? How did you find my sleeping post?!','',26124),
(81695,'enUS','','Now can I come in?',26124),
(81696,'enUS','The vision guides us, $n. Let us see what it wishes us to learn.','',26124),
(81697,'enUS','Prophet, we\'re being overrun!','Prophet, we\'re being overrun!',26124),
(81698,'enUS','I hear it tastes just like chicken, not that you\'d catch me eating raw meat.','',26124),
(81699,'enUS','She may backfire a bit, but don\'t worry. She\'ll get you there.','',26124),
(81700,'enUS','As long as I live, Karabor shall not fall!','',26124),
(81701,'enUS','Prophet, your attempts are meaningless. Witness the TRUE might of the Iron Horde!','',26124),
(81702,'enUS','The Iron Horde is like nothing you\'ve ever seen!  Every meal a banquet, every plunder a fortune!  We are unstoppable and the glory will be unending!','',26124),
(81703,'enUS','More intruders!','More intruders!',26124),
(81704,'enUS','Grommash leads us to countless victories across TWO worlds.  With a Warsong at our head, how can we lose?  The Warsong and Iron Horde together are unbeatable!','',26124),
(81705,'enUS','It is true that both foe and glory abound on the plains of Nagrand. That was not enough for your warchief though, and he has made a place for you at his side across ALL of Draenor.  The Iron Horde will see true glory across two worlds!','',26124),
(81706,'enUS','','$n, strike with the power of holy light!',26124),
(81707,'enUS','','We are the shield against the darkness!',26124),
(81708,'enUS','','There is no power stronger than hope!',26124),
(81709,'enUS','Welcome to Shadowmoon Valley. I\'ve been expecting you.','',26124),
(81710,'enUS','','We are the light against the darkness! Shield of the meek! Hope for the helpless!',26124),
(81711,'enUS','','Do not let doubt trouble you! Where there is light there is hope. Strike now!',26124),
(81712,'enUS','Yrel, my most promising student returns home. Please lead our friends here to the Shadowmoon Ruins.','',26124),
(81713,'enUS','I\'ll explain on the way there.','',26124),
(81714,'enUS','','Yes, teacher. $n, jump on that Elekk and we will be on our way.',26124),
(81715,'enUS','','Follow me.',26124),
(81716,'enUS','You\'re coming with me!','',26124),
(81717,'enUS','The trials that lay before you will not be easy, $n. Some of your most trusted companions will surely be lost. When the darkness closes in, follow the light.','',26124),
(81718,'enUS','Time to die!','',26124),
(81719,'enUS','We need to establish a foothold here in Shadowmoon Valley as soon as possible. There is a clearing not far from here that will be a perfect place to start.','',26124),
(81720,'enUS','Glory and death!','',26124),
(81721,'enUS','Ask not what the Iron Horde can do for you, but what you can do for the Iron Horde.  With your help, the Iron Horde can reach across the continent and rule everything the way it should be ruled!','',26124),
(81722,'enUS','Perhaps you fear the smoke and recoil from the fires.  I tell you these are not things to fear!  Our armor is impenetrable!  Our weapons unstoppable!  The fires of our industry make you the greatest warriors that have ever existed!','',26124),
(81723,'enUS','There is much glory riding for the Iron Horde!  The enemies of the Iron Horde are often strong and dangerous.  This is not something to fear though!  Strong enemies make us stronger, and while we can be hurt, we have never fallen.  We never will!','',26124),
(81724,'enUS','Hurry up! I can\'t hold this thing open forever!','',26124),
(81725,'enUS','','Killing the beast will surely gain the respect of Karabor peacekeepers.',26124),
(81726,'enUS','If you mark those trees, Shelly\'s lumberjacks will do the rest.','',26124),
(81727,'enUS','Giant killer ravens... I have a feeling it\'s going to be a long, cold night.','',26124),
(81728,'enUS','<whispers> No noise!','',26124),
(81729,'enUS','Commander. What would you say to showing the Warsong some Rangari justice?','',26124),
(81730,'enUS','Light forgive me. I failed them all.','',26124),
(81731,'enUS','We have everything we need. It\'s time to build the garrison.','We have everything we need. It\'s time to build the garrison.',26124),
(81732,'enUS','Throm-ka, commander.','Throm-ka, commander.',26124),
(81733,'enUS','Commander $n approaches! Salute!','Commander $n approaches! Salute!',26124),
(81734,'enUS','Lok\'tar, commander!','Lok\'tar, commander!',26124),
(81735,'enUS','My blade is yours, Commander $n.','My blade is yours, Commander $n.',26124),
(81736,'enUS','','Please, let us go. We haven\'t hurt anyone.',26124),
(81737,'enUS','','At least let Isel go. She\'s just a child.',26124),
(81738,'enUS','','We never harmed any of you. We all used to get along so well.',26124),
(81739,'enUS','','I just want to take my daughter and leave. We aren\'t any threat to you.',26124),
(81740,'enUS','','Maybe if I were to talk with your leader? Explain things? You\'d see it\'s okay for us to leave.',26124),
(81741,'enUS','','If you harm my baby, I will kill you!',26124),
(81742,'enUS','','You\'re monsters to threaten a defenseless woman and her child!',26124),
(81743,'enUS','','Please, I\'m begging you. Let us go!',26124),
(81744,'enUS','Orders, commander?','Orders, commander?',26124),
(81745,'enUS','Welcome Commander $n. It is an honor to serve under you.','Welcome Commander $n. It is an honor to serve under you.',26124),
(81746,'enUS','Our commander approaches! Men, at the ready!','Our commander approaches! Men, at the ready!',26124),
(81747,'enUS','At your service, commander.','At your service, commander.',26124),
(81748,'enUS','','The Shattered Hand\'s crimes against humanity are unforgivable, but we can\'t ignore their crimes against nature.',26124),
(81749,'enUS','|TInterface\\Icons\\ability_paladin_beaconoflight.blp:20|tK\'ara has blessed you with |cFFFF0000|Hspell:160972|h[K\'ara\'s Essence]|h|r!','|TInterface\\Icons\\ability_paladin_beaconoflight.blp:20|tK\'ara has blessed you with |cFFFF0000|Hspell:160972|h[K\'ara\'s Essence]|h|r!',26124),
(81750,'enUS','Khadgar wants us to scout the cave.','Khadgar wants us to scout the cave.',26124),
(81751,'enUS','If we make it out of this jungle, I will personally see to it that you and your people are taken care of.','',26124),
(81752,'enUS','Khadgar wants us to scout the cave.','Khadgar wants us to scout the cave.',26124),
(81753,'enUS','|TInterface\\Icons\\spell_holy_aspiration.blp:20|tK\'ara has blessed you with|cFFFF0000|Hspell:149699|h[K\'ara\'s Benevolence]|h|r!','|TInterface\\Icons\\spell_holy_aspiration.blp:20|tK\'ara has blessed you with|cFFFF0000|Hspell:149699|h[K\'ara\'s Benevolence]|h|r!',26124),
(81754,'enUS','|TInterface\\Icons\\spell_arcane_arcaneresilience.blp:20|tK\'ara has blessed you with |cFFFF0000|Hspell:157035|h[K\'ara\'s Resilience]|h|r!','|TInterface\\Icons\\spell_arcane_arcaneresilience.blp:20|tK\'ara has blessed you with |cFFFF0000|Hspell:157035|h[K\'ara\'s Resilience]|h|r!',26124),
(81755,'enUS','','Oh, thank the Light for you, stranger!',26124),
(81756,'enUS','','The Warsong attacked us without provocation.',26124),
(81757,'enUS','','Come, Isel. We must be very quiet.',26124),
(81758,'enUS','You have done it $n! Now to put an end to this assault!','You have done it $n! Now to put an end to this assault!',26124),
(81759,'enUS','','Yes, mama. Thank you, $g sir:ma\'am;!',26124),
(81760,'enUS','If I am to be forgotten here, so will you.','',26124),
(81761,'enUS','No! You will be forgotten as I have!','',26124),
(81762,'enUS','I... will... return...','',26124),
(81763,'enUS','Will you help me, $c? Scores of my brethren died because I failed to defend them.','',26124),
(81764,'enUS','Here lies the body of Arbiter Khan.','',26124),
(81765,'enUS','','You have the eggs, yes? They need to get to the hatchery straight away so I\'ll take them there now. May the light embrace you.',26124),
(81766,'enUS','Horrible creatures of appeared out of nowhere and are killing the drakes! $b$bThey are all going to be killed if we don\'t do anything!$b$bIf you could get rid of the creatures attacking them and help me gather some of their lost eggs it would be a huge help.$b$bPlease, $c, I\'m the only eggtender left, I need your help if they are to survive!','',26124),
(81767,'enUS','Don\'t get in my way.','',26124),
(81768,'enUS','I\'m unstoppable!','',26124),
(81769,'enUS','Got one!','',26124),
(81770,'enUS','This too much fun!','',26124),
(81771,'enUS','You! You hurt the boss man!','',26124),
(81772,'enUS','Time to go to plan B!','',26124),
(81773,'enUS','','My life... for the master.',26124),
(81774,'enUS','','Fool! I am in communion with forces beyond your reckoning!',26124),
(81775,'enUS','AHH!','',26124),
(81776,'enUS','Watch out!','',26124),
(81777,'enUS','HELP!!','',26124),
(81778,'enUS','Stay away from me!','',26124),
(81779,'enUS','The Warsong are trying to activate Telaar\'s shielding crystal down there. If they succeed, we won\'t be able to support you.','',26124),
(81780,'enUS','The Warsong are trying to activate Telaar\'s defense shield. If they succeed, the rangari on the overlook will not be able to support you.','',26124),
(81781,'enUS','Snow? Our shamans said there would be mild weather today... I don\'t trust these clouds.','',26124),
(81782,'enUS','Invaders have been spotted near the western wall!','Invaders have been spotted near the western wall!',26124),
(81783,'enUS','Invaders have been spotted near east wall!','Invaders have been spotted near east wall!',26124),
(81784,'enUS','','We must hurry - these Shadowmoon orcs are under the command of \"Ner\'zhul.\"',26124),
(81785,'enUS','','With his commanders dead, Ner\'zhul will surely come looking for us.',26124),
(81786,'enUS','','I\'ll take the right flank, Maraad will take the left, you defend K\'ara!',26124),
(81787,'enUS','This acolyte and I will retrieve the rest of our group. Do everything in your power to stop that orc from opening that portal!','',26124),
(81788,'enUS','','We will return with help.',26124),
(81789,'enUS','I\'ll murder all o\' ya!','',26124),
(81790,'enUS','Which one a ya is first?','',26124),
(81791,'enUS','Come ta die? You\'ve come ta the right place, boyos.','',26124),
(81792,'enUS','Don\'t be shy. There\'s plenty o\' me ta go \'round.','',26124),
(81793,'enUS','Don\'t worry. I\'m comin\' fer all o\' ya.','',26124),
(81794,'enUS','Where ya got the survivors stashed, ya animals?','',26124),
(81795,'enUS','If ye\'ve harmed the wee one or her mum, I\'m gonna kill ya twice... painfully!','',26124),
(81796,'enUS','Vindicator... Arbiter, can ya hear me? I\'m comin\'.','',26124),
(81797,'enUS','Invaders have been spotted near the western gate!','Invaders have been spotted near the western gate!',26124),
(81798,'enUS','Are you going to be okay?','Are you going to be okay?',26124),
(81799,'enUS','Thank you, again, for the aid. Luckily, I was able to get the eggs into the spare incubators.$bI wish I had more strength in my arms for swinging a weapon or I\'d be out there dealing righteous justice but... taking care of the eggs is about all I can do. Please find the cause of this mess and get rid of it, the fey dragons and I are counting on you!','',26124),
(81800,'enUS','I should be fine... I just twisted a hoof.','I should be fine... I just twisted a hoof.',26124),
(81801,'enUS','I am not jumping! Just go get a ladder!','I am not jumping! Just go get a ladder!',26124),
(81802,'enUS','No way! It\'s too far! Seriously... get a ladder!','No way! It\'s too far! Seriously... get a ladder!',26124),
(81803,'enUS','You will be fine. Just jump!','You will be fine. Just jump!',26124),
(81804,'enUS','It\'s not that far. Come on, just jump already!','It\'s not that far. Come on, just jump already!',26124),
(81805,'enUS','For years I\'ve worked to tame these gentle creatures.$bThey are fantastically intelligent, you know. We have so much we could learn from them, if only we had more youngsters willing to learn the delicate art of communing with them.$b$b<Alorn sighs>$b$bWere the world more peaceful I could have taught others my trade, but I\'m afraid we have more pressing concerns to deal with.','',26124),
(81806,'enUS','I softened \'em up fer ya.','',26124),
(81807,'enUS','Ack... I\'m a bit woozy. Ya got this? I need ta get back ta the station.','',26124),
(81808,'enUS','No... NO! This cannot be the fate of my people!','',26124),
(81809,'enUS','Ner\'zhul leads us to this destiny. To save Karabor, we must stop him.','',26124),
(81810,'enUS','Meet me back at Twilight Glade, champion. We have much to do.','',26124),
(81812,'enUS','<An inscription on the hilt reads:>\n\n\"Here Vindicator Torvath fell in battle to end the rage of the ancients.\n\n May the light shine upon this grove that he so valiantly fought to protect and may it forever bring peace upon its denizens.\"','',26124),
(81817,'enUS','<The waters begin to stir.>','<The waters begin to stir.>',26124),
(81818,'enUS','Percy, would you hold still?! How do you expect me to read it with you fluttering about like that?','',26124),
(81819,'enUS','We\'ll slip away while you keep the herald busy. Meet us near the bridge just outside of town!','',26124),
(81820,'enUS','Come along, Percy!','',26124),
(81821,'enUS','Good people of Fort Wrynn, our commander has finalized construction on a new building!','',26124),
(81822,'enUS','We\'re going to need to work together to get it up to full production. See to it our commander is not kept waiting!','',26124),
(81823,'enUS','I cannot... hold them... back...','',26124),
(81824,'enUS','Yo everybody, listen up. Thanks to our commander we got a new building up!','',26124),
(81825,'enUS','We gotta get this new structure up to snuff pronto, alright? Get to it yesterday!','',26124),
(81826,'enUS','You can handle things from here, I\'m sure. Well done!','',26124),
(81827,'enUS','You won\'t be needin\' me, you\'re in charge after all.','',26124),
(81828,'enUS','Honored to be fighting by your side, $n.','',26124),
(81829,'enUS','Khadgar wants us to scout the cave.','Khadgar wants us to scout the cave.',26124),
(81830,'enUS','','Their depravity sickens me.$b$bWe should wipe this Iron Horde off the map.',26124),
(81831,'enUS','Khadgar wants us to scout the cave.','Khadgar wants us to scout the cave.',26124),
(81832,'enUS','','I\'ll take this draenei back to Khadgar. Stop that orc from opening that portal!',26124),
(81833,'enUS','','We will return with help.',26124),
(81834,'enUS','The Grove of Ancients begins to awaken!','',26124),
(81835,'enUS','A second ancient is called to battle!','',26124),
(81836,'enUS','A third ancient moves to attack!','',26124),
(81837,'enUS','Drink the elixir and focus on the crystal, $n. Let the ebb and flow of time wash over you...','',26124),
(81838,'enUS','','I have what you want, commander. You\'ll have to come to me. Warsong, find $g him:her;!',26124),
(81839,'enUS','','Ahahaha. Come get your precious blueprints. If you can!',26124),
(81840,'enUS','Go, $n. Finish it. Exact justice for the fallen of Telaar.','',26124),
(81841,'enUS','Well done, commander!','',26124),
(81842,'enUS','We will get as much ore out of here as we can. We might need to reinforce some of these walls.','',26124),
(81843,'enUS','This place is looking pretty run down.','',26124),
(81844,'enUS','','I want this shield surrounding all of Telaar, now.',26124),
(81845,'enUS','','Find the intruder and those damned rangari.',26124),
(81846,'enUS','','All glory to the Warsong. All glory to the new warlord, Garrosh Hellscream!',26124),
(81847,'enUS','','No more prisoners. Kill outsiders on sight!',26124),
(81848,'enUS','','Warsingers, more power. Once the draenei shield surrounds all of Telaar, no one can get in.',26124),
(81849,'enUS','','We\'ve rid our homeland of the draenei. This is a glorious day for the Warsong.',26124),
(81850,'enUS','','Faster! I intend to ride upon Telaari Station soon.',26124),
(81851,'enUS','','Soon, we will crush the draenei survivors. For the Warsong!',26124),
(81852,'enUS','Go through the portal, Gazlowe said. You\'ll be rich, he said.$B$BWhat a load of bologna.','',26124),
(81853,'enUS','$n crafts a Defense Prism!','$n crafts a Defense Prism!',26124),
(81854,'enUS','$n crafts a Sun Trinket!','$n crafts a Sun Trinket!',26124),
(81855,'enUS','|TInterface\\Icons\\inv_feather_14.blp:20|tRukhran unleashes a shower of |cFFFF0000|Hspell:159382|h[Quills]|h|r - take cover!','',26124),
(81856,'enUS','|TInterface\\Icons\\inv-mount_raven_54.blp:20|tRukhran has no one to melee and begins to |cFFFF0000|Hspell:153896|h[Screech]|h|r!','',26124),
(81857,'enUS','For the Warsong!','For the Warsong!',26124),
(81858,'enUS','Blood and thunder!','Blood and thunder!',26124),
(81859,'enUS','Die outsider!','Die outsider!',26124),
(81860,'enUS','For Garrosh!','For Garrosh!',26124),
(81861,'enUS','Now you die.','Now you die.',26124),
(81862,'enUS','Nagrand is for the Warsong.','Nagrand is for the Warsong.',26124),
(81863,'enUS','Lok\'tar ogar!','Lok\'tar ogar!',26124),
(81864,'enUS','Lok-Narash!','Lok-Narash!',26124),
(81865,'enUS','Eh Boss-mon! We be needin\' ya for sometin\' important over here.','',26124),
(81866,'enUS','Power fluctuator active. Rebooting core systems. Please wait.','',26124),
(81867,'enUS','Alright, Pleasure-Bot 8000. Get back to work!','',26124),
(81868,'enUS','Command unrecognized. Will only accept commands from Pleasure-Bot 8000 owner: $p.','',26124),
(81869,'enUS','The Gift of the Naaru imbues you! Push through the courtyard, we will meet you at the harbor!','',26124),
(81870,'enUS','Damn it all, I give up. $p, you can have him! I\'m done!','',26124),
(81871,'enUS','I know how dangerous this place is, but I ain\'t leaving until I get back what\'s mine!','',26124),
(81872,'enUS','Leave me be.','Leave me be.',26124),
(81873,'enUS','You look like an able fisherman, do you think you can help us out?\n\nWe have established a small garrison nearby, but we are finding it difficult to feed our troops. Any fishing advice you could give us would really help.','You look like an able fisherman, do you think you can help us out?\n\nWe have established a small garrison nearby, but we are finding it difficult to feed our troops. Any fishing advice you could give us would really help.',26124),
(81874,'enUS','Who knows what we might invent with the materials on this world?','',26124),
(81875,'enUS','Alright, Pleasure-Bot 8000. Execute command X47G5!','',26124),
(81876,'enUS','That\'s it, I\'ve had it! $p, you can have him! I\'m going back to tank-building from here on out!','',26124),
(81877,'enUS','%s goes into a wild |cFFFF0404|Hspell:155222|h[Tantrum]|h|r!','',26124),
(81878,'enUS','%s creates an |cFFFF0404|Hspell:159044|h[Epicenter]|h|r!','',26124),
(81879,'enUS','%s goes into a wild |cFFFF0404|Hspell:162275|h[Tantrum]|h|r!','',26124),
(81880,'enUS','%s creates an |cFFFF0404|Hspell:162277|h[Epicenter]|h|r!','',26124),
(81881,'enUS','How can I be of service, commander?','',26124),
(81882,'enUS','Khadgar\'s magic is strong indeed. He managed to open a permanent portal directly to Stormwind.','',26124),
(81883,'enUS','Everything is going according to plan, commander. How may I help you?','',26124),
(81884,'enUS','','With the giant defeated we shouldn\'t have any more trouble clearing out the area.',26124),
(81885,'enUS','An excellent choice of lumber, if I do say so myself.','',26124),
(81886,'enUS','Impressive work, commander. I know I\'ll sleep a lot better without those giant killer birds flying around.','',26124),
(81887,'enUS','Let me know when you are ready to start construction, commander.','',26124),
(81888,'enUS','Thanks to you we have a terrific foothold here in Shadowmoon Valley.','',26124),
(81889,'enUS','Baros is just down the stairs. I\'m sure he will be more than happy to help you construct a barracks.','',26124),
(81890,'enUS','With the barracks complete we can finally shelter all of these troops from this eternal night.','',26124),
(81891,'enUS','Qiana just headed out to Moonflower Valley. She is quite eager to explore this new land.','',26124),
(81892,'enUS','I helped! Did you see?','',26124),
(81893,'enUS','That just happened!','',26124),
(81894,'enUS','Let\'s split the loot! How does 60/40 sound?','',26124),
(81895,'enUS','Are you rich and famous? If so, I want to be just like you when I grow up!','',26124),
(81896,'enUS','Check and see if there\'s any loot!','',26124),
(81897,'enUS','That...was...AWESOME!','',26124),
(81898,'enUS','Can you teach me to fight like that?','',26124),
(81899,'enUS','I\'ll take the next one! Just watch!','',26124),
(81900,'enUS','Please, repurpose me!','',26124),
(81901,'enUS','I think that arm is still usable, and maybe the leg.','',26124),
(81902,'enUS','You can\'t handle this!','',26124),
(81903,'enUS','I will destroy you.','',26124),
(81904,'enUS','I can feel this in my soul.','',26124),
(81905,'enUS','Just think all the things I will make out of your parts.','',26124),
(81906,'enUS','I hope those limbs aren\'t too broken.','',26124),
(81907,'enUS','So many pieces!','',26124),
(81908,'enUS','Don\'t try to run, you will only die tired.','',26124),
(81909,'enUS','I will catch you and I will fix you.','',26124),
(81910,'enUS','That one! That is the one that I need!','',26124),
(81911,'enUS','I can feel the vile taint flowing through me.','',26124),
(81912,'enUS','A revenge assault, eh?  Scout, sound the Call to Arms! Get the peons inside!','',26124),
(81913,'enUS','To arms! To your posts! Show the Thunderlords what it is to be Horde!','',26124),
(81914,'enUS','Sergeant, Thunderlord orcs are at the walls!','Sergeant, Thunderlord orcs are at the walls!',26124),
(81915,'enUS','You dare challenge the might of Skog?!','',26124),
(81916,'enUS','We all start from humble beginnings. I took my first steps outside an abbey in Elwynn Forest.','We all start from humble beginnings. I took my first steps outside an abbey in Elwynn Forest.',26124),
(81917,'enUS','We all start from humble beginnings. My life began after emerging from the wreckage of the Exodar.','We all start from humble beginnings. My life began after emerging from the wreckage of the Exodar.',26124),
(81918,'enUS','We all start from humble beginnings. Once, I was just a trainee on a faraway isle called Shen-zin Su.','We all start from humble beginnings. Once, I was just a trainee on a faraway isle called Shen-zin Su.',26124),
(81919,'enUS','We all start from humble beginnings. I began my journey in the tranquil boughs of Teldrassil.','We all start from humble beginnings. I began my journey in the tranquil boughs of Teldrassil.',26124),
(81920,'enUS','We all start from humble beginnings. My story began on the streets of Gilneas.','We all start from humble beginnings. My story began on the streets of Gilneas.',26124),
(81921,'enUS','','No army can function without orcs like me supplying them.',26124),
(81922,'enUS','Screaming with blood lust, the crowd wreaks havoc on the arena! $B$B x2 Drunken Bileslingers |TInterface\\Icons\\achievement_reputation_ogre.blp:32|t x5 Iron Bombers |TInterface\\Icons\\achievement_character_orc_male_brn.blp:32|t','',26124),
(81923,'enUS','Lusting for carnage, the crowd howls for a blood bath. $B$B x3 Drunken Bileslingers|TInterface\\Icons\\achievement_reputation_ogre.blp:32|t x5 Iron Bombers |TInterface\\Icons\\achievement_character_orc_male_brn.blp:32|t','',26124),
(81924,'enUS','Get back to work!','',26124),
(81925,'enUS','You cannot abandon them to this fate. If we forsake our friends now, we are no better than Ner\'zhul.','You cannot abandon them to this fate. If we forsake our friends now, we are no better than Ner\'zhul.',26124),
(81926,'enUS','It is not our deaths that matter in the end, but how we live. How will you live, Yrel?','It is not our deaths that matter in the end, but how we live. How will you live, Yrel?',26124),
(81927,'enUS','Your allies\' lives will mean nothing if you give up here. Let their sacrifice inspire you.','Your allies\' lives will mean nothing if you give up here. Let their sacrifice inspire you.',26124),
(81928,'enUS','','You\'re absolutely right, $n. Samaara and the others are depending on us. For them, I must survive!',26124),
(81929,'enUS','','I will live to protect the righteous, the helpless, and the hopeless. You are a wise teacher, $n.',26124),
(81930,'enUS','','Let us do this.',26124),
(81931,'enUS','We all start from humble beginnings. I began this life in service of the Lich King.','We all start from humble beginnings. I began this life in service of the Lich King.',26124),
(81932,'enUS','Hey! Hey! Wait up!','',26124),
(81933,'enUS','Are you here to fight the saberon? I need your help!','',26124),
(81934,'enUS','Please! You\'ve gotta help me out!','',26124),
(81935,'enUS','What do you want? Money? Power? I\'ll do anything! Just help me out!','',26124),
(81936,'enUS','Don\'t worry I can take care of myself, but I need your help getting my stuff back!','',26124),
(81937,'enUS','Take your time, I\'ll just be right here...waiting...next to you...forever.','',26124),
(81938,'enUS','You aren\'t going to leave me hanging here...right?','',26124),
(81939,'enUS','So much rests on your shoulders! You can\'t imagine the consequences!','',26124),
(81940,'enUS','Hammering','Hammering',26124),
(81941,'enUS','Think you can take a disciple of the Sorcerer King? HAH!','',26124),
(81942,'enUS','Stop my research? Let me show you my research! Meet my latest creation, Bulgorg!','',26124),
(81943,'enUS','Back to work, boss.','',26124),
(81944,'enUS','Commander save me. Me happy orc!','',26124),
(81945,'enUS','Give the blueprints a good look, commander.','',26124),
(81946,'enUS','Me thought me dead for sure!','',26124),
(81947,'enUS','Tiger-men try to eat me!','',26124),
(81950,'enUS','You found it! Roxxie Rocketgrip...Bombshell Belle...they\'re all here!','',26124),
(81951,'enUS','My precious...','',26124),
(81952,'enUS','Profession Building Blueprint','Profession Building Blueprint',26124),
(81953,'enUS','So boss, what\'s your focus? Remember, only the first one is free.','',26124),
(81954,'enUS','','Oh, Commander, you\'ve been awfully busy lately. Fancy a drink? Maybe a nice sharp sword?',26124),
(81955,'enUS','There is only one way you may prove your worth to me, stranger.$B$BCombat.','',26124),
(81956,'enUS','Very well. Let us fight.','Very well. Let us fight.',26124),
(81957,'enUS','Ah, sweet freedom! You won\'t regret this, commander. I\'ll make you the finest armaments in all of Draenor!','',26124),
(81958,'enUS','Let us begin.','',26124),
(81959,'enUS','Let\'s see what we have to work with.','',26124),
(81960,'enUS','The forge is the soul of the foundry. This one\'s small but with the right equipment I can enhance it.','',26124),
(81961,'enUS','These look good, with some modifications I should be able to load them into the cannons for a burst shot.','',26124),
(81963,'enUS','You have proven yourself to me.','',26124),
(81966,'enUS','','You want to lay eyes upon Auchindoun?$B$BProve your worth to me in combat.',26124),
(81967,'enUS','So be it.','So be it.',26124),
(81968,'enUS','','I yield! You are indeed worthy. Your soul is pure.',26124),
(81969,'enUS','','May you rest in peace.',26124),
(81970,'enUS','I\'ll not die out here on the frontier.  I will continue my research back at Highmaul!  Enjoy your temporary victory...','',26124),
(81971,'enUS','Shhh! Don\'t let dem see us talkin\' or you\'ll blow my cover!','',26124),
(81972,'enUS','See you around, $p! You can be my sidekick anytime!','',26124),
(81973,'enUS','ENOUGH. Play time is over. I will deal with you myself.','',26124),
(81974,'enUS','Pathetic...','',26124),
(81975,'enUS','I need a Shadowmoon orc illusion.','I need a Shadowmoon orc illusion.',26124),
(81976,'enUS','','The illusion should hold until your work is done.$B$BMagic is fickle, however!$B$BTake my Amulet of Illusion. If you lose your orc appearance while at Shaz\'gul, simply use the amulet.',26124),
(81977,'enUS','','Be careful of the wolves that patrol Shaz\'gul. Unlike eyes, their noses will not be fooled.',26124),
(81978,'enUS','Lok\'tar Commander $p.$b$bI was sent by Warchief Vol\'jin himself to assist you in day to day operations. While you are in the field I can manage, train, and dispatch your troops on missions essential to our survival in this place.','',26124),
(81979,'enUS','What Missions are available?','What Missions are available?',26124),
(81980,'enUS','I\'ll see if I can get this thing goin\'. Khadgar, buy me some time!','',26124),
(81981,'enUS','We will do what we can, Thaelin.','',26124),
(81982,'enUS','$n, keep these orcs off of us!','',26124),
(81983,'enUS','','Tank coming over the rise! Look out!',26124),
(81984,'enUS','These controls don\'t make SENSE. Remind me never ta drive a tank built by an orc.','',26124),
(81985,'enUS','Hold strong, everyone. Here they come!','',26124),
(81986,'enUS','They\'re bringin\' up explosives! $n, destroy those carts before they get close!','',26124),
(81987,'enUS','There\'s so many of them...','',26124),
(81988,'enUS','Don\'t you give up yet, paladin.','',26124),
(81989,'enUS','That\'s it! I\'ve got \'er runnin\'! Let\'s finish this.','',26124),
(81990,'enUS','We have been called upon to protect Auchindoun from further interference.','',26124),
(81991,'enUS','','Only those who prove their souls to us may enter.',26124),
(81992,'enUS','','I\'ll make my way through shortly. Thank you!',26124),
(81993,'enUS','I will make my way through shortly. Thank you again, $p.','',26124),
(81994,'enUS','Throm-Ka, commander.$B$BI\'m glad you\'re here. I need you to take over our preparations to deal with the Warsong clan.$B$BWe will drive them before us, and we\'ll bring Garrosh to justice once and for all.','',26124),
(81995,'enUS','','Ashes to ashes.',26124),
(81996,'enUS','','You... are not.. WORTHY!',26124),
(81997,'enUS','Not worthy.','',26124),
(81998,'enUS','The gateway shall remain sealed!','',26124),
(81999,'enUS','Hey, $c! You\'re the one in charge right? Tell your dogs to let me out of this cage!','',26124),
(82000,'enUS','Have you even inspected this cage? It\'s on the verge of falling apart! Let me out and I\'ll show you how to make one strong enough to hold a raging clefthoof bull in it!','',26124),
(82001,'enUS','Hey, let me out of this thing!','',26124),
(82002,'enUS','','I miss Telaar, but it\'s always a pleasure to see you, Commander $n.$B$BMay the naaru light your way.',26124),
(82003,'enUS','Flesh burns.','',26124),
(82004,'enUS','|TInterface\\Icons\\spell_arcane_arcaneresilience.blp:20|tK\'ara is nearing full power and gains |cFFFF0000|Hspell:161045|h[K\'ara\'s Defense]|h|r!','|TInterface\\Icons\\spell_arcane_arcaneresilience.blp:20|tK\'ara is nearing full power and gains |cFFFF0000|Hspell:161045|h[K\'ara\'s Defense]|h|r!',26124),
(82005,'enUS','Ahh ha ha haaa! Nice shot!','',26124),
(82006,'enUS','Invader Killed! (+$9042w)','',26124),
(82007,'enUS','Saboteur Killed! (+$9044w)','',26124),
(82008,'enUS','Boss Killed!','',26124),
(82009,'enUS','Defender slain! (-$9043w)','',26124),
(82010,'enUS','The Warsong are truly inspiring warriors!  You have taken Nagrand in your fist and made it yours!  The Iron Horde would be honored to have Warsong warriors in its ranks.  Let them fear the Warsong across Draenor as you ride for the Iron Horde!','',26124),
(82011,'enUS','','Oh, hehehe, aren\'t you a darling little tadpole? Tell me, do you like frogs?',26124),
(82012,'enUS','','The others don\'t believe me, but I have seen HIM. The great one. Once you fall under his gaze, you will never be the same again!',26124),
(82013,'enUS','For the Iron Horde!','For the Iron Horde!',26124),
(82014,'enUS','','Croak... croak... croak... Just listen to them! I love it when they talk about me.',26124),
(82015,'enUS','Even if I fall, ten more will take my place!','Even if I fall, 10 more will take my place!',26124),
(82016,'enUS','','Have you ever tried frog soup, dear? It\'s quite delicious, and good for you as well.',26124),
(82017,'enUS','','Oh, I just love their cute little bellies and slimy little toes, don\'t you?',26124),
(82018,'enUS','Die weakling!','Die weakling!',26124),
(82019,'enUS','Fall before the might of the Iron Horde!','Fall before the might of the Iron Horde!',26124),
(82020,'enUS','The Iron Horde needs ore, and you are in the way!','',26124),
(82021,'enUS','I must get the color out of the stone!','',26124),
(82022,'enUS','It\'s no safer under my guns, my blades are just as dangerous!','',26124),
(82023,'enUS','Old Torglork has sent hundreds like you to the depths!  Time to join them!','',26124),
(82024,'enUS','Attacked in the middle of this base?!  The Sorcerer King shall hear of this!','',26124),
(82025,'enUS','You\'ll find I\'m no Iron Horde weakling.  You face one trained by the Sorcerer King himself!','',26124),
(82026,'enUS','Your efforts are fruitless!  Soon you and your allies will fall!','',26124),
(82027,'enUS','You think the Warsong will just stop joining if you slay me?  My work here is finished and the Warsong swell the ranks of the Iron Horde!','',26124),
(82028,'enUS','Killing you will boost recruitment tenfold and I probably won\'t even scratch my armor!','',26124),
(82029,'enUS','Thank you again, $p. Now to use the potion to bring Tuliaa back!','',26124),
(82030,'enUS','Come on, Tuliaa. Wake up. Please... you have to wake up...','',26124),
(82031,'enUS','Go boss! Kill cat-man!','',26124),
(82032,'enUS','Hey cat-man! You smell!','',26124),
(82033,'enUS','Not so tough now, are you cat-man?','',26124),
(82034,'enUS','Woo! Kick his butt!','',26124),
(82035,'enUS','Cat-man? More like gnome lover!','',26124),
(82036,'enUS','Take that! And that!','',26124),
(82037,'enUS','That\'s it! Kill him good!','',26124),
(82038,'enUS','You unstoppable!','',26124),
(82039,'enUS','Thanks boss! Back to work!','',26124),
(82040,'enUS','Those filthy saberon ain\'t going to get away with this...nobody steals from the Steamwheedle Cartel and gets away with it!$b$bNobody!','',26124),
(82041,'enUS','','The Ring of Trials is the perfect place to make some cash!',26124),
(82042,'enUS','Mess with the peasant, you get the boss!','',26124),
(82043,'enUS','I\'m pretty sure you\'re gonna win!','',26124),
(82044,'enUS','You\'ll regret this, creature. I swear on me mum!','',26124),
(82045,'enUS','Kill him, Commander!','',26124),
(82046,'enUS','You\'re as intimidating as a goblin!','',26124),
(82047,'enUS','Take that! And that!','',26124),
(82048,'enUS','You picked the wrong day to mess with $p!','',26124),
(82049,'enUS','You can do it!','',26124),
(82050,'enUS','','Isel, don\'t go far.',26124),
(82051,'enUS','','Stay near, young lady.',26124),
(82052,'enUS','','I want you back soon, Isel.',26124),
(82053,'enUS','','Isel, come back!',26124),
(82054,'enUS','','No going outside the walls.',26124),
(82055,'enUS','','Don\'t be gone long, Isel.',26124),
(82056,'enUS','','Stay close. It\'s not safe anymore.',26124),
(82057,'enUS','','Did you finish your chores?',26124),
(82058,'enUS','','Oh mom.',26124),
(82059,'enUS','','Uh huh. Yep.',26124),
(82060,'enUS','','Be back soon.',26124),
(82061,'enUS','','I\'m not a baby!',26124),
(82062,'enUS','','I cleaned up. You promised!',26124),
(82063,'enUS','','Don\'t worry. I won\'t go outside the gates.',26124),
(82064,'enUS','','Mother!',26124),
(82065,'enUS','','There\'s nothing to do around here!',26124),
(82066,'enUS','','Ugh. Children.',26124),
(82067,'enUS','','Behave, young lady.',26124),
(82068,'enUS','','No bothering the guards.',26124),
(82069,'enUS','','Do you have any of your own, $p?',26124),
(82070,'enUS','','Just once, I wish she\'d behave.',26124),
(82071,'enUS','','She\'s growing up too quickly.',26124),
(82072,'enUS','','And, no fishing!',26124),
(82073,'enUS','','I mean it, little bug. Be safe.',26124),
(82074,'enUS','','Isel frowns.',26124),
(82075,'enUS','','Isel!',26124),
(82076,'enUS','Please, my family has nothin to eat.','',26124),
(82077,'enUS','What\'s a matter, little kitty?  Don\'t like the whip?','',26124),
(82078,'enUS','Adventurer, could you please spare some coin?','',26124),
(82079,'enUS','','Commander Tharbek, it seems your troops have allowed a group of pitiful heroes to sneak past them.',26124),
(82080,'enUS','','Isel sighs.',26124),
(82081,'enUS','','Disappointment crosses Isel\'s face.',26124),
(82082,'enUS','','The young lady rolls her eyes.',26124),
(82083,'enUS','','Isel shakes her head.',26124),
(82084,'enUS','','Isel wrinkles her nose.',26124),
(82085,'enUS','','The girl exhales dramatically.',26124),
(82086,'enUS','','Isel kicks at the dirt.',26124),
(82087,'enUS','','Coming!',26124),
(82088,'enUS','I apologize for this failure Warlord Zaela. The Iron March will take care of these intruders!','',26124),
(82089,'enUS','Iron March, kill them or I will kill you!','',26124),
(82090,'enUS','','Kill the one in the dress!',26124),
(82091,'enUS','','Why?! I\'ll kill them... I\'ll kill them all!!',26124),
(82092,'enUS','Perhaps you\'d like to join my little pet in this cage!','',26124),
(82093,'enUS','Can\'t you see I\'m busy with my \"honored\" guest?!','',26124),
(82094,'enUS','Come to save the poor broken cat?  Perhaps its time to switch pets!','',26124),
(82095,'enUS','This way, friend. The ward is nearly at full power.','',26124),
(82096,'enUS','We will sink these crystalline resonance emitters into the earth, harnessing the very energies of Draenor itself to power our defenses.','',26124),
(82097,'enUS','|TInterface\\Icons\\ability_warrior_shieldguard:20|t%s readies a |cFFFF0000|Hspell:158136|h[Shield Charge]|h|r!','',26124),
(82098,'enUS','|TInterface\\Icons\\ability_whirlwind:20|t%s readies a |cFFFF0000|Hspell:157943|h[Whirlwind]|h|r!','',26124),
(82099,'enUS','Boss killed! (+$9048w)','',26124),
(82100,'enUS','Total Score: $1i','',26124),
(82101,'enUS','We can\'t just run away while these barbarians bleed my people dry. We have to stop them!','',26124),
(82102,'enUS','We can\'t just run away while these brutes bleed my people dry. We have to stop them!','',26124),
(82103,'enUS','Very well, but don\'t take long. I will require both of you later, and you will need to be alive.','',26124),
(82104,'enUS','She\'s a beauty, there\'s no doubt about it. We do good work together, $n.$B$BWe\'re going to crush the Warsong!','',26124),
(82105,'enUS','This is no time for laziness!$B$BOnce this beauty\'s built, we\'re going to crush the Warsong and anyone else who gets in our way.','',26124),
(82106,'enUS','The corral is built. Time to put it to good use and bring justice to Nagrand.','',26124),
(82107,'enUS','The tankworks is built. Time to put it to good use and bring justice to Nagrand.','',26124),
(82108,'enUS','Together, we will bring justice to Garrosh and the Warsong clan.','',26124),
(82109,'enUS','Come, $p. I will introduce you to a friend of mine who can help you with your tower.','',26124),
(82110,'enUS','','Eh boss-mon! Ya be needin\' a rest?',26124),
(82111,'enUS','Come, Cordana!','',26124),
(82112,'enUS','Let us pass, gatekeeper.','',26124),
(82113,'enUS','','Well done Commander, but it seems that the intruders are still quite alive.',26124),
(82114,'enUS','What? Unacceptable!','',26124),
(82115,'enUS','Kill them you fools!','',26124),
(82116,'enUS','Lady Proudmoore has expressly forbid Horde from entering Kirin Tor grounds.','',26124),
(82117,'enUS','I am forming a small party to scout the enemy\'s fortifications.','I am forming a small party to scout the enemy\'s fortifications.',26124),
(82118,'enUS','Then let Jaina take it up with me. I am a member of the Council, and you WILL let me and my friend pass!','',26124),
(82119,'enUS','My tower lies just through this pass.','',26124),
(82120,'enUS','Thrall, take command of the remaining survivors and meet us up ahead.','Thrall, take command of the remaining survivors and meet us up ahead.',26124),
(82121,'enUS','Maraad, take command of the remaining survivors and meet us up ahead.','Maraad, take command of the remaining survivors and meet us up ahead.',26124),
(82122,'enUS','It will be done.','',26124),
(82123,'enUS','','The Iron Horde cares nothing for the quality of a blade or the workmanship that goes into it. They craft them big and heavy to make up for the poor steel they\'re made with.$b$bPathetic.',26124),
(82124,'enUS','Yes, Archmage.','',26124),
(82125,'enUS','<The mule looks at you with its big old eyes... then it tries to eat your shirt.>','<The mule looks at you with its big old eyes... then it tries to eat your shirt.>',26124),
(82126,'enUS','Very well, Archmage. As you wish.','',26124),
(82127,'enUS','It\'s so hard to find good ingredients around here.','',26124),
(82128,'enUS','','This is pitiful! Do your men not know where the sharp part of the axe goes?',26124),
(82129,'enUS','I don\'t understand, these intruders fight with the fury of Grommash himself.','',26124),
(82130,'enUS','Up ahead! Look at that!','',26124),
(82131,'enUS','Ancestors help us... look at that!','',26124),
(82132,'enUS','','I will hear no more of these excuses. I am going to go prepare the weapon, take care of these invaders or I will show you how a true orc deals with failure.',26124),
(82138,'enUS','When you are ready, take this portal down to my tower.','',26124),
(82139,'enUS','%s is attracted by the smell of fresh blood!','',26124),
(82140,'enUS','Yes Warlord! I will handle this personally!','',26124),
(82141,'enUS','Fetch my mount, I am tired of watching you peons disgrace my Iron Horde.','',26124),
(82142,'enUS','Finally! Now you will pay for embarrassing me!','',26124),
(82143,'enUS','My Warlord, I have failed you.','',26124),
(82144,'enUS','Now let us finish this.','',26124),
(82145,'enUS','Warlord Zaela! I have regained my honor!','',26124),
(82146,'enUS','Your friends will join you soon!','',26124),
(82147,'enUS','Too easy!','',26124),
(82148,'enUS','How did you get this far?','',26124),
(82149,'enUS','I know what I must do.','',26124),
(82150,'enUS','BLOOD AND HONOR!','',26124),
(82151,'enUS','KILROGG DEADEYE','KILROGG DEADEYE',26124),
(82152,'enUS','WARLORD OF THE BLEEDING HOLLOW','WARLORD OF THE BLEEDING HOLLOW',26124),
(82153,'enUS','Look what dragged itself through my jungle. Fresh meat!','',26124),
(82154,'enUS','We won\'t go without a fight, Deadeye.','',26124),
(82155,'enUS','It looks like you could use a hand.','',26124),
(82156,'enUS','No! Fight me instead!','',26124),
(82157,'enUS','GOOOO... FIND... KHADGARRRR....','',26124),
(82158,'enUS','My friend is just ahead.','',26124),
(82159,'enUS','Defend me and I will break this siege $n!','',26124),
(82160,'enUS','Ah, there you are! This is the one I was telling you about.','',26124),
(82161,'enUS','You fools! How could you dump mines into the harbor?!','',26124),
(82162,'enUS','No.','',26124),
(82163,'enUS','I should be out there killing the White Kraken but instead I have to clean up this mess! Get more orcs down there!','',26124),
(82164,'enUS','If those mines aren\'t cleared by daybreak tomorrow I will fire on the dock I swear!','',26124),
(82165,'enUS','Very good. I\'m sure I\'ll be seeing the both of you soon.','',26124),
(82166,'enUS','I am Magister Krelas. Pleasure. Let us begin, yes?','',26124),
(82167,'enUS','Vorka is landing, quickly destroy him and stop this Bombardment of Karabor!','',26124),
(82168,'enUS','Splendid! I can take things from here.','',26124),
(82169,'enUS','No outsiders allowed. Lady Proudmoore\'s orders.','',26124),
(82170,'enUS','','I\'m Mr. G\'s right hand gal on this expedition. A genius like Mr. G can\'t be bothered to deal with mundane everyday problems.$b$bThat\'s what I\'m here for, to get the doing done so that he can focus on the important stuff!',26124),
(82171,'enUS','My friend is just ahead.','',26124),
(82172,'enUS','Ah, there you are! This is the one I was telling you about.','',26124),
(82173,'enUS','','Wonderful! Thank you, Archmage. I can handle things from here.',26124),
(82174,'enUS','The Steamwheedle Preservation Society was created to help ensure the safety of valuable artifacts and antiquities across Azeroth and Draenor.$b$bWe travel far and wide to obtain the most precious relics and artifacts ever seen!$b$bOur mission is to put all of these priceless artifacts exactly where they belong... in the hands of the highest bidder!','',26124),
(82175,'enUS','I wish to disenchant some old gear.','I wish to disenchant some old gear.',26124),
(82176,'enUS','The essence font allows you to break down weapons and armor into enchanting materials.  The item is PERMANENTLY destroyed.\n\nDo you wish to continue?','The essence font allows you to break down weapons and armor into enchanting materials.  The item is PERMANENTLY destroyed.\n\nDo you wish to continue?',26124),
(82177,'enUS','Hello.','Hello.',26124),
(82178,'enUS','','Yay! Thank you thank you thank you SO much!',26124),
(82179,'enUS','I thought everyone forgot about me. Thank you, $Gkind mister:kind lady;!','',26124),
(82180,'enUS','Wow, did you fight off all the orcs? You\'re strong!','',26124),
(82182,'enUS','','<The little girl wails inconsolably.>',26124),
(82183,'enUS','Let\'s burn it up!','',26124),
(82184,'enUS','Aid me! I cannot move!','',26124),
(82185,'enUS','By the Earthmother, this land will test us at every turn!','',26124),
(82186,'enUS','That\'s it fellas, as of right now we\'re on strike!','',26124),
(82187,'enUS','%s lands. Attack him!','',26124),
(82188,'enUS','These rampaging elementals are a threat to worker safety! This wasn\'t in the contract!','',26124),
(82189,'enUS','If Futzwangler wants the diggin\' done in Stonecrag Gorge, then he can do it himself!','',26124),
(82190,'enUS','It\'s about time we had a new contract! Revise the labor agreement!','',26124),
(82191,'enUS','We need better pay! More leisure time! Fewer regulations!','',26124),
(82192,'enUS','Come on! Make some noise! Let old Futzwangler know that we ain\'t budging until we get a bigger cut!','',26124),
(82193,'enUS','When was the last time Gazmolf let us party? We\'ve got to fight for our right to party!','',26124),
(82194,'enUS','You\'ve been had! You\'ve been took! You\'ve been hoodwinked. Bamboozled!','',26124),
(82195,'enUS','Hmm. Perhaps we can use these energized mushrooms to our advantage.','',26124),
(82196,'enUS','Madam Goya has decided to move her operations to more lucrative markets. It seemed like a prudent time to give up a thankless job.','Madam Goya has decided to move her operations to more lucrative markets. It seemed like a prudent time to give up a thankless job.',26124),
(82197,'enUS','It\'s odd that these ancient protectors never awakened despite all this mess.','',26124),
(82198,'enUS','Watch out!','',26124),
(82199,'enUS','With luck, the small ones will now flee, and we can begin construction.','',26124),
(82200,'enUS','Great fishing in these local waters, just have to get out there!','Great fishing in these local waters, just have to get out there!',26124),
(82201,'enUS','Ready for me to go fishing?  I will return with a shipment soon.','Ready for me to go fishing?  I will return with a shipment soon.',26124),
(82202,'enUS','Who dares challenge me?','',26124),
(82203,'enUS','Readdyyyyyyyy!!!','',26124),
(82204,'enUS','Let \'em have it, boys!','',26124),
(82205,'enUS','I\'ve got my sights on you.','',26124),
(82206,'enUS','RAPID FIRE!!!','',26124),
(82207,'enUS','Give \'em all ya got.','',26124),
(82208,'enUS','Hah! Let\'s take this down to your level.','',26124),
(82209,'enUS','Another contender down!','',26124),
(82210,'enUS','So weak!','',26124),
(82211,'enUS','None can compete!','',26124),
(82212,'enUS','I didn\'t... even... try...','',26124),
(82213,'enUS','','Nobody stops the Iron Horde. Nobody!',26124),
(82214,'enUS','Excellent! We can make our scroll of mass teleportation with these.','',26124),
(82215,'enUS','We won\'t go without a fight, Deadeye.','',26124),
(82216,'enUS','I\'ve seen large numbers of Thunderlords massing nearby. They are preparing for an attack.','',26124),
(82217,'enUS','Khadgar speaks highly of you. You have quite the list of accolades.','',26124),
(82218,'enUS','','Commander! Great! Can you tell Gazlowe that if he is serious about trying to use this plot up here for fishing and farming that he is going to have to find someone who knows what they are doing?',26124),
(82219,'enUS','I was not expecting the arcane energy to be this... potent.','',26124),
(82220,'enUS','','Rakun, let\'s give \'em hell!',26124),
(82221,'enUS','','Another one!',26124),
(82222,'enUS','','Light \'em up!',26124),
(82223,'enUS','','How shocking.',26124),
(82224,'enUS','','Hah!',26124),
(82225,'enUS','','You can never stop this train!',26124),
(82226,'enUS','','You... can\'t...',26124),
(82227,'enUS','I can get the building started, but I can\'t finish it without the blueprints. They\'re the key to everything we\'re doing here.','',26124),
(82228,'enUS','The Burning Blade is an honorable clan, but they have chosen the wrong side in this conflict.','',26124),
(82229,'enUS','','Show them what you\'re made of!',26124),
(82230,'enUS','Gazlowe needs your extra construction materials.','Gazlowe needs your extra construction materials.',26124),
(82231,'enUS','Off your lazy butts. It\'s time to get to work.','',26124),
(82232,'enUS','','BOLD! Is that what this garrison says to you, commander? No! It does not! But then this is why I was hired.$b$bUsing the small plots we can build a striking array of structures like... an apothecary! Yes, an apothecary. Or perhaps a smithy or a workshop.$b$bIf we use the large plots, we could outfit you with a barracks for your troops that will strike fear into the hearts of your enemies and sleep into the faces of your soldiers.$b$bThe sky is the limit, as is the width and length.',26124),
(82233,'enUS','Gazlowe needs your extra construction materials.','Gazlowe needs your extra construction materials.',26124),
(82234,'enUS','Commander, your pack of peons awaits your orders.','',26124),
(82235,'enUS','Building Burning! (-$9063w)','',26124),
(82236,'enUS','[%s] confesses: After so much talk about Garrison, I thought it was a person.','[%s] confesses: After so much talk about Garrison, I thought it was a person.',26124),
(82237,'enUS','[%s] confesses: I knew he played a priest...','[%s] confesses: I knew he played a priest...',26124),
(82238,'enUS','[%s] confesses: I have no idea how to pronounce Draenor.','[%s] confesses: I have no idea how to pronounce Draenor.',26124),
(82239,'enUS','[%s] confesses: I frequently get Vale of Eternal Blossoms and Valley of the Four Winds confused.','[%s] confesses: I frequently get Vale of Eternal Blossoms and Valley of the Four Winds confused.',26124),
(82240,'enUS','[%s] confesses: I refuse to talk when I am underwater.','[%s] confesses: I refuse to talk when I am underwater.',26124),
(82241,'enUS','[%s] confesses: I frequently wondered where the greater charms of good fortune are.','[%s] confesses: I frequently wondered where the greater charms of good fortune are.',26124),
(82242,'enUS','[%s] confesses: I once did every daily quest all in one day.','[%s] confesses: I once did every daily quest all in one day.',26124),
(82243,'enUS','[%s] confesses: I really, really like to Leap of Faith my allies at \"opportune\" moments.','[%s] confesses: I really, really like to Leap of Faith my allies at \"opportune\" moments.',26124),
(82244,'enUS','[%s] confesses: I like to exaggerate what I get from Unclaimed Black Market Containers.','[%s] confesses: I like to exaggerate what I get from Unclaimed Black Market Containers.',26124),
(82245,'enUS','[%s] confesses: I don\'t understand how so many people know about the Brawler\'s Guild.  The first rule...','[%s] confesses: I don\'t understand how so many people know about the Brawler\'s Guild.  The first rule...',26124),
(82246,'enUS','[%s] confesses: I once died to the same Gastropod three times.','[%s] confesses: I once died to the same Gastropod three times.',26124),
(82247,'enUS','[%s] confesses: I purposely let Sooli die in Proving Grounds more than once.','[%s] confesses: I purposely let Sooli die in Proving Grounds more than once.',26124),
(82248,'enUS','[%s] confesses: I spent a whole day looking for mining nodes in Silvershard Mines.','[%s] confesses: I spent a whole day looking for mining nodes in Silvershard Mines.',26124),
(82249,'enUS','[%s] confesses: I thought capturing the enemy\'s mine cart in Deepwind Gorge would make me a better miner.','[%s] confesses: I thought capturing the enemy\'s mine cart in Deepwind Gorge would make me a better miner.',26124),
(82250,'enUS','[%s] confesses: I hum the same song to myself whenever I am pet battling.','[%s] confesses: I hum the same song to myself whenever I am pet battling.',26124),
(82251,'enUS','I\'m your temporary Follower. To battle, $N!','I\'m your temporary Follower. To battle, $N!',26124),
(82252,'enUS','I\'m your fake follower for now. Lead, I will follow!','I\'m your fake follower for now. Lead, I will follow!',26124),
(82253,'enUS','We make slaves of you all.','',26124),
(82254,'enUS','Dis my salvage!','',26124),
(82255,'enUS','Your kind will be our new slaves!','',26124),
(82256,'enUS','You no match for Bladespire army!','',26124),
(82257,'enUS','First, we deal with the bridge.','',26124),
(82258,'enUS','Mm.','',26124),
(82259,'enUS','This slaver and torturer knows nothing of honor.','',26124),
(82260,'enUS','We cannot hide here forever.','',26124),
(82261,'enUS','Step into my arena and die with honor.','',26124),
(82262,'enUS','You have entered my arena, strangers. You will either leave it as victors, or as corpses.','',26124),
(82263,'enUS','Such is the way of the SHATTERED HAND.','',26124),
(82264,'enUS','A combat arena. This may be a trap, but at least we will die with honor.','',26124),
(82265,'enUS','MY STUFF!','',26124),
(82266,'enUS','What\'s this? An outsider!','',26124),
(82267,'enUS','[%s] confesses: I once asked for a Jeeves to be dropped right after a different Jeeves had disappeared.','[%s] confesses: I once asked for a Jeeves to be dropped right after a different Jeeves had disappeared.',26124),
(82268,'enUS','I will go to your outpost to make the scroll. Meet me there when you can.','',26124),
(82269,'enUS','Pathetic.','',26124),
(82270,'enUS','You call yourself Burning Blade?','',26124),
(82271,'enUS','The half-breed fights better than you!','',26124),
(82272,'enUS','If it weren\'t for my sons, I\'d weep for the future of our clan.','',26124),
(82273,'enUS','You are the worst group I\'ve ever had the displeasure to train.','',26124),
(82274,'enUS','Once the masters see you, I\'ll be executed, my blade melted down, and my banner fed to the flames.','',26124),
(82275,'enUS','I\'d laugh if this inept display weren\'t so depressing.','',26124),
(82276,'enUS','The villagers would do a better job.','',26124),
(82277,'enUS','Your fishing shipment should be here soon, try back later.','Your fishing shipment should be here soon, try back later.',26124),
(82278,'enUS','%s begins to cast |cFFFF0404|Hspell:157659|h[Rippling Smash]|h|r!','',26124),
(82279,'enUS','Futzwangler hired a strikebreaker?!','Futzwangler hired a strikebreaker?!',26124),
(82280,'enUS','They\'re taking our jobs!','They\'re taking our jobs!',26124),
(82281,'enUS','You can\'t just take our jobs because we refuse to work! It ain\'t right!','You can\'t just take our jobs because we refuse to work! It ain\'t right!',26124),
(82282,'enUS','I knew this would happen! I\'ve got to get my job back!','I knew this would happen! I\'ve got to get my job back!',26124),
(82283,'enUS','It\'s all yours, buddy. Have fun with the elementals!','It\'s all yours, buddy. Have fun with the elementals!',26124),
(82284,'enUS','Futzwangler hired scabs?!','Futzwangler hired scabs?!',26124),
(82285,'enUS','What do you mean I\'m not getting paid?!','What do you mean I\'m not getting paid?!',26124),
(82286,'enUS','Maybe I can still get my job back!','Maybe I can still get my job back!',26124),
(82287,'enUS','','Quickly Aknor! Bring me another. Blackhand will not tolerate any delays.',26124),
(82288,'enUS','','My work. You\'ve interrupted my WORK!',26124),
(82289,'enUS','','Another falls to my blade!',26124),
(82290,'enUS','','Too hot for you?',26124),
(82291,'enUS','','Burn!',26124),
(82292,'enUS','','Your flesh feeds the fire.',26124),
(82293,'enUS','','Iron and flame!',26124),
(82294,'enUS','','Come my pets.',26124),
(82295,'enUS','','Feeding time!',26124),
(82296,'enUS','','I have more friends for you to meet!',26124),
(82297,'enUS','','Work complete!',26124),
(82298,'enUS','','Glory to the Blackrock!',26124),
(82299,'enUS','','Let flame kiss your tender flesh!',26124),
(82300,'enUS','','Your bodies will make good kindling.',26124),
(82301,'enUS','','Aknor! You are an embarrassment to your clan.',26124),
(82302,'enUS','','That\'s enough - you will burn!  YOU WILL ALL BURN!',26124),
(82303,'enUS','','My flame... burned too bright.',26124),
(82304,'enUS','What brings you to my door? I have no wares to sell, and no need for vagabonds!','',26124),
(82305,'enUS','Through the Undergrowth you go. Hurry now, and keep your eyes peeled!$B$BKah-hah hah ha!','',26124),
(82306,'enUS','I\'m a guard!','I\'m a guard!',26124),
(82307,'enUS','\"Shadows gather...\"','\"Shadows gather...\"',26124),
(82308,'enUS','I\'m a laborer!','I\'m a laborer!',26124),
(82309,'enUS','I\'m a laborer too!','I\'m a laborer too!',26124),
(82310,'enUS','Yes, yes, I understand. I will tell you the way.','',26124),
(82311,'enUS','And I see you out there, Reshad! No use hiding from me, darling. Come in, come in!','',26124),
(82312,'enUS','You too, Percy! That\'s it... give old Ornekka some sugar.','',26124),
(82313,'enUS','Oh... yes, of course. Greetings, Ornekka.','',26124),
(82314,'enUS','Hey, wait up! Don\'t leave, we\'re just getting started!','',26124),
(82315,'enUS','','Come on gang! Let\'s get back to work before Thazwix gets us in more trouble...',26124),
(82316,'enUS','Yes?','',26124),
(82317,'enUS','Show me my Garrison.','Show me my Garrison.',26124),
(82318,'enUS','You kill Guh friends, now who Guh trade with?','',26124),
(82319,'enUS','Very well.','',26124),
(82320,'enUS','You should trade with me, then.','You should trade with me, then.',26124),
(82321,'enUS','Perhaps you could be persuaded to visit my garrison and do some trading?','Perhaps you could be persuaded to visit my garrison and do some trading?',26124),
(82322,'enUS','My fist!','My fist!',26124),
(82323,'enUS','Guh no think that a good idea.','',26124),
(82324,'enUS','Strange face-coin, very shiny. Maybe me come visit sometime.','',26124),
(82325,'enUS','You not very nice.','',26124),
(82326,'enUS','Are you sure you want to give Guh some coins?','Are you sure you want to give Guh some coins?',26124),
(82327,'enUS','','You cannot stop Ner\'zhul. The power of the void will consume you!',26124),
(82328,'enUS','If you want to know where your important piece of paper is, you\'ll return with my blade or not at all.','',26124),
(82329,'enUS','Guh like you. Me come visit sometime.','',26124),
(82330,'enUS','A $c? You\'ve come to Hallvalor to die. It would appear that I have, too.$B$BAs a half-draenei, half-orc, my enemies within the Burning Blade cast me out when they rose to power. But my honor will not allow this to stand.$B$BExiling me was an act of cowardice. They should have allowed me to fight for my place like any other.$B$BNow, I will exact justice from them at the tip of my blade.','',26124),
(82331,'enUS','','Listen up you idiots! The excavation is happening with or without you! If you want to get paid you\'d better start working!',26124),
(82332,'enUS','Murderers! Brigands! Assassins! Where are my GUARDS!?!','',26124),
(82333,'enUS','','If you see any Shadowmoon orcs around the Stargazers... kill them.',26124),
(82334,'enUS','','The Shadowmoon clan is clearly not happy we have formed our own village. We will need to stay vigilant.',26124),
(82335,'enUS','Help! Guards! Where are they? Fine, I\'ll kill you myself!','',26124),
(82336,'enUS','Most buildings take some time to construct. But seein\' as how this is your first building, I\'m gonna comp ya and employ my handy Senior Peon II to help out.','',26124),
(82337,'enUS','When a building finishes its construction you finalize it and we\'ll open the building for business.','',26124),
(82338,'enUS','Look how it burns!','',26124),
(82339,'enUS','As you find more blueprints and materials you can bring \'em to me and we can try to use up some of your other plots.','',26124),
(82340,'enUS','Fire! Fire! Fire!','',26124),
(82341,'enUS','Rezlak will also try to keep some blueprints in stock that you can purchase... for a price.','',26124),
(82342,'enUS','Burn it all!','',26124),
(82343,'enUS','','I went stargazing with Zukaza once... ONCE! We were still young, and I had not yet met my mate.$B$BI\'ve rebuffed him gently over the years, but alas, his head is as thick as an elekk\'s hide.',26124),
(82344,'enUS','Love is such a fickle game...','',26124),
(82345,'enUS','','Ready when you are!',26124),
(82346,'enUS','','These mushrooms have been affected as well. We could use these to our advantage!',26124),
(82347,'enUS','','It is curious that these ancient protectors never awakened despite all this mess.',26124),
(82348,'enUS','','That ought to be all we need for our scroll of mass teleportation. Well done!',26124),
(82349,'enUS','','The Archmage talks about you all the time you know. You\'re quite the hero!',26124),
(82350,'enUS','','Oh, my. These energy levels are higher than I thought!',26124),
(82351,'enUS','','I will go back to your outpost to make the scroll. See you there!',26124),
(82352,'enUS','You will never take our land!','',26124),
(82353,'enUS','You! You don\'t belong here!','',26124),
(82354,'enUS','This is Gordunni land!','',26124),
(82355,'enUS','It will be a pleasure blasting you into the ground!','',26124),
(82356,'enUS','Love is in the air!','',26124),
(82357,'enUS','Look what $n brought me! Kat\'la will surely fall in love with me now!','',26124),
(82358,'enUS','Hey! You ate my flowers!!','',26124),
(82359,'enUS','I\'m doomed to live a life of solitude.','',26124),
(82360,'enUS','NOOO!!! I give up...','',26124),
(82361,'enUS','','Hurry, Yrel. Your hammer\'s might will help us greatly.',26124),
(82362,'enUS','','If you find Kral\'za, and he is with that void witch Dol\'mak, tell him his mother is looking for him.',26124),
(82363,'enUS','','FOOL! If you won\'t respect Ner\'zhul you will be sacrificed!',26124),
(82364,'enUS','Mother was right; the Shadowmoon clan cannot be trusted!','',26124),
(82365,'enUS','','Thank you, $n. Maybe next time my son will listen to his mother.',26124),
(82366,'enUS','For the Horde!','For the Horde!',26124),
(82367,'enUS','What can you tell me about the Steamwheedle Preservation Society?','What can you tell me about the Steamwheedle Preservation Society?',26124),
(82368,'enUS','Tell me, what do you see when you stare into an ancient artifact?$b$bHistory? Culture? Mystery?$b$bThat\'s because you have an untrained eye! Do you know what I see?$b$bMoney! Lots of it!$b$bStick around with me long enough and if you\'re smart you\'ll learn a thing or two about real archaeology!','',26124),
(82369,'enUS','Invaders Killed: $9046w (+$9072w)','',26124),
(82370,'enUS','Saboteurs Killed: $9047w (+$9068w)','',26124),
(82371,'enUS','Morale Bonus: $1i (+$2i VP)','',26124),
(82372,'enUS','Bombs Exploded: $1i (+$2i VP)','',26124),
(82373,'enUS','Burn Penalty: $9066w (-$9070w)','',26124),
(82374,'enUS','That\'s better!','',26124),
(82375,'enUS','Just a few whacks more!','',26124),
(82376,'enUS','','%s readies her |cFFFF0404|Hspell:154989|h[Inferno Breath]|h|r!',26124),
(82377,'enUS','%s prepares |cFFFF0404|Hspell:155499|h[Superheated Shrapnel]|h|r!','',26124),
(82378,'enUS','Sergeant, our soldiers need assistance! Charge forward and aid them!','',26124),
(82379,'enUS','The Alliance has won this stage of the battle!','',26124),
(82380,'enUS','The Horde has won this stage of the battle!','',26124),
(82381,'enUS','Sergeant, our situation worsens each moment! I need you in battle immediately!','',26124),
(82382,'enUS','Sergeant, our soldiers fight bravely, but they need our aid! Go, lead them to victory!','',26124),
(82383,'enUS','Sergeant, the situation has grown dire! March out, for honor and glory!','',26124),
(82384,'enUS','Soldiers of the Alliance! Stand fast against them! I come to aid you!','',26124),
(82385,'enUS','','I see the Prophet! He\'s here!',26124),
(82386,'enUS','Yrel, my student! I thought you had perished for sure.','',26124),
(82387,'enUS','','Prophet, this hero - and many others from another world - have come to aid us.',26124),
(82388,'enUS','I am extremely grateful, champion.','',26124),
(82389,'enUS','We need a base of operations on your world, Great Prophet.','',26124),
(82390,'enUS','It is good to see you, my child. My people welcome your aid, champion. Come with me.','',26124),
(82391,'enUS','Prophet, I must warn you: the Iron Horde intends to strike out against all who oppose him. We must prepare our defenses!','',26124),
(82392,'enUS','Indeed, we have many enemies both within and without.','',26124),
(82393,'enUS','We will deal with one problem at a time. First, we must settle your people.','',26124),
(82394,'enUS','Here! This location commands the entrance to our valley.','',26124),
(82395,'enUS','Do you sense the potential? A great army will someday stand on this very spot, and they will look to you for guidance.','',26124),
(82396,'enUS','Plant the banner, commander, and claim your destiny.','',26124),
(82397,'enUS','I can open up a portal to Stormwind only briefly.','',26124),
(82398,'enUS','The King assured me that our best builders will be ready.','',26124),
(82399,'enUS','This is it, boys! Let\'s break some ground and take this world for the Alliance!','',26124),
(82400,'enUS','I do hope my trust in your people is not misplaced.','',26124),
(82401,'enUS','I assure you, my Prophet, the commander we\'ve chosen represents the very best of the Alliance.','',26124),
(82402,'enUS','','Many of us owe our lives to these strangers.',26124),
(82403,'enUS','Mmnnn. That is good. This world is perched on oblivion. Many trials lie ahead. Many heroes will surely give their lives.','',26124),
(82404,'enUS','When the darkness closes in... follow the light.','',26124),
(82405,'enUS','I am needed here. Champion, please help the others!','',26124),
(82406,'enUS','What are you planning, Ariok?','',26124),
(82407,'enUS','Simply a back-up plan. Hopefully we don\'t need it.','',26124),
(82408,'enUS','Mm.','',26124),
(82409,'enUS','','No. We stand here against the Iron Horde. I will fight.',26124),
(82410,'enUS','It\'s time to finish this. Meet me in the Masters\' Cavern.','',26124),
(82411,'enUS','We\'re under attack!','We\'re under attack!',26124),
(82412,'enUS','Intruders!','Intruders!',26124),
(82413,'enUS','Lok-Narash!','Lok-Narash!',26124),
(82414,'enUS','Alert the masters!','Alert the masters!',26124),
(82415,'enUS','I\'ll kill you!','I\'ll kill you!',26124),
(82416,'enUS','Over here!','Over here!',26124),
(82417,'enUS','Outsiders in the village!','Outsiders in the village!',26124),
(82418,'enUS','Kill $g him:her;!','Kill $g him:her;!',26124),
(82419,'enUS','Help!','Help!',26124),
(82420,'enUS','Kagh!','Kagh!',26124),
(82421,'enUS','Lok\'tar ogar!','Lok\'tar ogar!',26124),
(82422,'enUS','I will wet my blade with your unworthy blood.','I will wet my blade with your unworthy blood.',26124),
(82423,'enUS','An easy test.','An easy test.',26124),
(82424,'enUS','I\'ll prove myself by killing you!','I\'ll prove myself by killing you!',26124),
(82425,'enUS','You have no honor.','You have no honor.',26124),
(82426,'enUS','Your tricks won\'t work on me, $c.','Your tricks won\'t work on me, $c.',26124),
(82427,'enUS','You\'ll die for setting foot in my home!','You\'ll die for setting foot in my home!',26124),
(82428,'enUS','No one will remember you when you\'re dead.','No one will remember you when you\'re dead.',26124),
(82429,'enUS','Burn!','Burn!',26124),
(82430,'enUS','I\'ll feed you to the flame.','I\'ll feed you to the flame.',26124),
(82431,'enUS','A fitting sacrifice for Hyperious.','A fitting sacrifice for Hyperious.',26124),
(82432,'enUS','Lava consume you!','Lava consume you!',26124),
(82433,'enUS','Hallvalor is under attack. Lok-Narash!','Hallvalor is under attack. Lok-Narash!',26124),
(82434,'enUS','Lok\'tar ogar!','Lok\'tar ogar!',26124),
(82435,'enUS','The fire is honor!','The fire is honor!',26124),
(82436,'enUS','My life for the Burning Blade!','My life for the Burning Blade!',26124),
(82437,'enUS','You dare challenge me?','You dare challenge me?',26124),
(82438,'enUS','You are without honor.','You are without honor.',26124),
(82439,'enUS','Taste my blade.','Taste my blade.',26124),
(82440,'enUS','For the Burning Blade.','For the Burning Blade.',26124),
(82441,'enUS','For honor and glory!','For honor and glory!',26124),
(82442,'enUS','There will be no songs sung for you, $c.','There will be no songs sung for you, $c.',26124),
(82443,'enUS','My blade seeks vengeance.','My blade seeks vengeance.',26124),
(82444,'enUS','A blademaster does not fear death, he fears dishonor.','A blademaster does not fear death, she fears dishonor.',26124),
(82445,'enUS','An outsider approaches!','An outsider approaches!',26124),
(82446,'enUS','Enter the ring and make your challenge.','',26124),
(82447,'enUS','Commander, shall we see the strength of your forces? You may have the honor of first blood.','',26124),
(82448,'enUS','Ya gonna\' be earnin\' ya titles this trip.','',26124),
(82449,'enUS','Remembah, try to not make the locals too angry. We gotta\' keep a low profile \'til we get fortified.','',26124),
(82450,'enUS','Bring ya scout reports to me, and I gonna be relayin\' dem to the commander.','',26124),
(82451,'enUS','Be watchin\' for any \'ting out of da ordinary.','',26124),
(82452,'enUS','','Those saberon are going to pay what they owe!',26124),
(82453,'enUS','','Find out what happened to that trade shipment, $p. I\'ll make it worth your while!',26124),
(82454,'enUS','I\'d worry less about the saberon and more about what Pyxni will do to us if we don\'t get her stuff back!','',26124),
(82455,'enUS','There\'s still time to save the others...but you\'ll have to hurry!','',26124),
(82456,'enUS','This will be the adventure of a lifetime!','',26124),
(82457,'enUS','Most gladiators have got a mean right or a mean left; Crushmaul... he\'s just mean!','',26124),
(82458,'enUS','Raketalon only eats when she wins in the ring... let\'s just say she\'s well fed!','',26124),
(82459,'enUS','You\'ve slain Raketalon and you\'ve crushed Crushmaul! Get in there and do the same thing to Hol\'yelaa! Good luck!','',26124),
(82460,'enUS','Nobody has been able to extinguish Boomspark! He\'s burned through the competition like a thatched roof cottage!','',26124),
(82461,'enUS','This is it, $n! There\'s nobody left to beat after Roakk! Get in there and give \'em hell!','',26124),
(82462,'enUS','','If you run into any of my lazy workers down there, tell \'em that if they want to get paid they\'d better start working!',26124),
(82463,'enUS','Do you hear that sound, $p? It\'s the sound of opportunity knocking at your door with a huge pile of money!','',26124),
(82464,'enUS','I am injured, but you must press on!','I am injured, but you must press on!',26124),
(82465,'enUS','Thank you, stranger.','Thank you, stranger.',26124),
(82466,'enUS','My thanks for your aid.','My thanks for your aid.',26124),
(82467,'enUS','My thanks.','My thanks.',26124),
(82468,'enUS','This frostwolf is not done yet.','This frostwolf is not done yet.',26124),
(82469,'enUS','I am in your debt.','I am in your debt.',26124),
(82470,'enUS','Lok\'tar friend.','Lok\'tar friend.',26124),
(82471,'enUS','These brutes test our strength!','These brutes test our strength!',26124),
(82472,'enUS','Hmm, nice and thick, and enough to coat the entire pile.','',26124),
(82473,'enUS','This much timber will burn quickly, be ready!','',26124),
(82474,'enUS','I demand vengeance!','I demand vengeance!',26124),
(82475,'enUS','Ogre blood will be spilled!','Ogre blood will be spilled!',26124),
(82476,'enUS','There are others, we must save them.','There are others, we must save them.',26124),
(82477,'enUS','They will see what a cornered wolf is like!','They will see what a cornered wolf is like!',26124),
(82478,'enUS','Let us slaughter these ogres!','Let us slaughter these ogres!',26124),
(82479,'enUS','My wrists are raw from the chains, but I can fight.','My wrists are raw from the chains, but I can fight.',26124),
(82480,'enUS','The ogres will pay in blood.','The ogres will pay in blood.',26124),
(82481,'enUS','I am weak, but I can follow.','I am weak, but I can follow.',26124),
(82482,'enUS','Lantresor cuts through his chains.','',26124),
(82483,'enUS','You want my things?','',26124),
(82484,'enUS','Those damned Goren, they took out over half of our numbers before we were able to evacuate the mine.$b$bWe\'re holding our own out here but we\'re going to need some serious help if the mine is going to be made safe again.','Those damned Goren, they took out over half of our numbers before we were able to evacuate the mine.$b$bWe\'re holding our own out here but we\'re going to need some serious help if the mine is going to be made safe again.',26124),
(82485,'enUS','I\'ll see you at the ring. Fight with honor, $n.','',26124),
(82486,'enUS','I\'ll move forward and scout their gates while you\'re taking out those catapults. Lok\'tar ogar!','',26124),
(82487,'enUS','It broke.','',26124),
(82488,'enUS','Maybe we can fix it?','',26124),
(82489,'enUS','I didn\'t break it!','',26124),
(82490,'enUS','Magic is scary.','',26124),
(82491,'enUS','Not gonna turn around.','',26124),
(82492,'enUS','Hope it run out of juice soon.','',26124),
(82493,'enUS','All my stuff in dat tower too...','',26124),
(82494,'enUS','Commander, Over here!','',26124),
(82495,'enUS','Now\'s my chance!','Now\'s my chance!',26124),
(82496,'enUS','Damn these ogres and their magic! I can\'t find a way to bring the barrier down so we\'re just going to have to sneak in around it.','',26124),
(82497,'enUS','I\'ll go first and clear the way, meet me on the other side.','',26124),
(82498,'enUS','A challenge has been issued from this $g man:woman;... this outsider.','',26124),
(82499,'enUS','Bomb Exploded: $9067w (-$8911w)','',26124),
(82500,'enUS','Finish it. Show us the might of the Warsong.','',26124),
(82501,'enUS','With pleasure.','',26124),
(82502,'enUS','Let\'s finish this, pup.','',26124),
(82503,'enUS','He was only Warsong and did not fight very well in any case.','',26124),
(82504,'enUS','Now you will face a true challenge -- my grandsons.','',26124),
(82505,'enUS','You killed their father outside. It\'s only fitting they return the favor.','',26124),
(82506,'enUS','For father! For honor!','',26124),
(82507,'enUS','I will cut you down, $pc!','',26124),
(82508,'enUS','My boys. You\'ve destroyed my legacy!','',26124),
(82509,'enUS','I\'ll kill you myself. Honor be damned!','',26124),
(82510,'enUS','Dharl. You have no honor. You will die.','',26124),
(82511,'enUS','','Hear me, Burning Blade! By right of ascension, I, Azuka Bladefury, daughter of Dharl, assume the mantle of warlord.',26124),
(82512,'enUS','','You, $pc, may leave unharmed. However, if I see you again, you will die.',26124),
(82513,'enUS','','Any clan member who wishes to challenge me may do so.',26124),
(82514,'enUS','','As for you, Lantresor of the Blade, you had no right joining this one\'s challenge.',26124),
(82515,'enUS','','You remain a half-breed and an exile. You are not worthy of the Burning Blade. Leave and never return.',26124),
(82516,'enUS','Lantresor spits and throws his banner on the ground.','',26124),
(82517,'enUS','Overloading','Overloading',26124),
(82518,'enUS','Dran\'ruk, your theft of $g his:her; blueprints brought $g him:her; here.','',26124),
(82523,'enUS','How did you find me?','How did you find me?',26124),
(82524,'enUS','Come, $pc. Issue your challenge. We will allow you to fight... and die.','',26124),
(82525,'enUS','Blood and thunder, what a battle!','',26124),
(82530,'enUS','Let\'s kill some ogres!','',26124),
(82531,'enUS','My blade is yours, $n. I will fight by your side until the end of my days.','',26124),
(82532,'enUS','The corral is built. Time to put it to good use and bring justice to Nagrand.','',26124),
(82533,'enUS','The tankworks is built. Time to put it to good use and bring justice to Nagrand.','',26124),
(82534,'enUS','I\'ve never seen anything so beautiful. It\'s good working with you, $n.$B$BWe\'re going to crush the Warsong!','',26124),
(82535,'enUS','','I will go with you, hero. A warm welcome awaits us at Embaari Village.',26124),
(82536,'enUS','','Your garrison is impressive, hero. Even draenei builders could not work so quickly.',26124),
(82537,'enUS','','Hello Mister Taarvos!',26124),
(82538,'enUS','','That temple is the home to the Shadowmoon Clan. Their leader is the warlord, Ner\'zhul.',26124),
(82539,'enUS','','Gloomshade Grove hides many dangers. If you enter, I will wait for you outside.',26124),
(82540,'enUS','','I have a bad feeling about these woods. I\'ll stay here if you want to venture within.',26124),
(82541,'enUS','','We are nearing draenei lands. Come now, my sister is waiting for us!',26124),
(82542,'enUS','','I never thought I\'d come back from the slave camps of Tanaan alive.',26124),
(82543,'enUS','','I watched so many of my people die... and I could do nothing to help them.',26124),
(82544,'enUS','','Wow! I\'ve never seen anyone move like that before.',26124),
(82545,'enUS','','What was that? I couldn\'t hear you! Quickly hero, let\'s go before she comes after me!',26124),
(82546,'enUS','','I will aid you as best I can.',26124),
(82547,'enUS','','Impressive.',26124),
(82548,'enUS','','In the flesh!',26124),
(82549,'enUS','','Let me guess. You\'ve done this before.',26124),
(82550,'enUS','','You have a natural gift.',26124),
(82551,'enUS','','I can\'t wait to surprise my sister, Samaara. I never thought I would see her again.',26124),
(82552,'enUS','','Yrel? After the Iron Horde took you, I feared the worst!',26124),
(82553,'enUS','','The light granted me strength when I needed it most. It is good to be home.',26124),
(82554,'enUS','','Samaara! I\'m back!',26124),
(82555,'enUS','In the end, all will be consumed.','',26124),
(82556,'enUS','It is but a fraction of the Dark Star\'s power.','',26124),
(82557,'enUS','','We\'ll see about that!',26124),
(82558,'enUS','The Iron Horde fleet has been sighted off the coast. We\'re calling every defender to the Temple.','',26124),
(82559,'enUS','','But Ner\'zhul poses an equal threat. What should we do, Prophet?',26124),
(82560,'enUS','Champion, I need your help to stop the Dark Star\'s arrival. Maraad, can you hold Karabor until we are finished?','',26124),
(82561,'enUS','As long as the defense crystal stands, we will hold.','',26124),
(82562,'enUS','Commander, I will gather the troops from your garrison. Do not delay long, they will need your leadership on the battlefield.','',26124),
(82563,'enUS','The Gordunni have been disconnected from the empire for too long. They really think a wall can stop us?','',26124),
(82564,'enUS','There we go! Let\'s, shall we?','',26124),
(82565,'enUS','','Let us hope Ga\'nar\'s fighting skills are better than his navigation skills.',26124),
(82566,'enUS','How we survived this far is a mystery to me. You are quite the field commander.','',26124),
(82567,'enUS','','Hero, are you with us?',26124),
(82568,'enUS','Fly with me, hero. We will assist them from above!','',26124),
(82569,'enUS','The purifying light of the naaru is both our hammer AND shield.','',26124),
(82570,'enUS','They are at the very temple gates - fly closer! Hurry!','',26124),
(82571,'enUS','Circle back. We must clear the steps.','',26124),
(82572,'enUS','Exarch Akama! Watch your flanks!','',26124),
(82573,'enUS','Thank you, old friend!','',26124),
(82574,'enUS','Never again will you orcish hordes darken the light of Karabor!','',26124),
(82575,'enUS','Press onward. By the light of the naaru!','',26124),
(82576,'enUS','Carry the light, brothers and sisters!','',26124),
(82577,'enUS','We\'ve done all we can from up here...','',26124),
(82578,'enUS','We did it! We broke the blockade!','',26124),
(82579,'enUS','We\'ve broken the main siege. We should meet with our forces on the ground.','',26124),
(82580,'enUS','These are the last of our forces. We\'ll stay here to hold the temple gates.','',26124),
(82581,'enUS','Champion, I need you to fight your way to the harbor.','',26124),
(82582,'enUS','','I\'ll approach the enemy from the south. Light of the naaru, guide you.',26124),
(82583,'enUS','','Champion, the naaru has come to aid us. We must defend it while it gathers power!',26124),
(82584,'enUS','','We\'ve done it! Now to put an end to this assault...',26124),
(82585,'enUS','Witness the TRUE power of the Iron Horde!','',26124),
(82586,'enUS','ENOUGH. Play time is over. I will deal with you myself.','',26124),
(82587,'enUS','','Up there! The fleet commander shows himself.',26124),
(82588,'enUS','','What is the naaru doing?',26124),
(82589,'enUS','It is done. Victory is ours!','',26124),
(82590,'enUS','','Hero, you fought fearlessly. For that, please accept my thanks.',26124),
(82591,'enUS','I am ready to teleport to the ship.','I am ready to teleport to the ship.',26124),
(82592,'enUS','Greetings, savior of my people!','',26124),
(82593,'enUS','If you are hearing this message, it means that I am no more - but Karabor is safe.','',26124),
(82594,'enUS','I owe you an explanation.','',26124),
(82595,'enUS','The naaru that we draenei revere are creatures of pure light.','',26124),
(82596,'enUS','But if their death is near, they lose their essence, collapsing into creatures of shadow.','',26124),
(82597,'enUS','When we draenei first arrived on this world, naaru accompanied us. But they could not stop our vessel from crashing.','',26124),
(82598,'enUS','The \"Dark Star\" that appeared in the skies above Draenor that terrible night was no celestial body.','',26124),
(82599,'enUS','It was a fallen naaru, ejected from our vessel in moments of panic and terror. Its name was K\'ara.','',26124),
(82600,'enUS','What was once a creature of faith and beauty became a dark and hungering God, a living font of darkness.','',26124),
(82601,'enUS','We owed K\'ara a great debt. Without the naaru\'s aid, my people would never have escaped our homeworld of Argus.','',26124),
(82602,'enUS','To see K\'ara\'s transformation into shadow was a heavy burden to bear. When the naaru returned to us... I did what I had to do.','',26124),
(82603,'enUS','Remember, life is the light, and light is life itself. They may be exchanged, but nothing is ever lost.','',26124),
(82604,'enUS','','Kitty!',26124),
(82605,'enUS','','Mr. Scratchy.',26124),
(82606,'enUS','','Let\'s play, Scratch.',26124),
(82607,'enUS','','Bad kitty.',26124),
(82608,'enUS','','Come on, Mr. Scratch. Follow me.',26124),
(82609,'enUS','','Mommy says you\'re a mean, ol\' kitty. But I don\'t think so.',26124),
(82610,'enUS','','I wonder who\'s going to fly in.',26124),
(82611,'enUS','Get back to work!','Get back to work!',26124),
(82612,'enUS','','Now nothing will stop the Iron Horde!',26124),
(82613,'enUS','The Rubble Pile is too close and %s throws over it!','',26124),
(82614,'enUS','','I am sorry Garrosh, I have failed you.',26124),
(82615,'enUS','','Now you have tasted the blade of the Dragonmaw.',26124),
(82616,'enUS','','All who stand against the Iron Horde will fall.',26124),
(82617,'enUS','','Are you dead or just pretending, coward?',26124),
(82618,'enUS','','You will burn!',26124),
(82619,'enUS','','Flames will consume you!',26124),
(82620,'enUS','','My blade will end you!',26124),
(82621,'enUS','','And now, you die!',26124),
(82622,'enUS','','Have you come to get a front row seat for Stormwind\'s destruction?',26124),
(82623,'enUS','It\'s not my fault. At least I have chicken.','',26124),
(82624,'enUS','Leerooooy! Jeeeeeenkins!','',26124),
(82625,'enUS','Check and see if it has my shoulders!','',26124),
(82626,'enUS','My Devout shoulders! I knew they were here! My quest is complete.','',26124),
(82627,'enUS','Now time for a little well deserved rest and relaxation! If you need me, I will be back at your garrison.','',26124),
(82628,'enUS','Attuning','Attuning',26124),
(82629,'enUS','','Dey kill me huntas. You an me, we gonna have some fun wit dese wolves.',26124),
(82630,'enUS','','Kargora is out in de open. Time ta kill her an\' destroy dat shield, mon.',26124),
(82631,'enUS','I am a shaman of the old ways and I care not for the petty conflicts between clans.$b$bThroughout the years many clans have called this valley home, but it has always belonged to the elements first.','',26124),
(82632,'enUS','','Be sure to check back for more resources later, commander. The peons will keep putting them in this chest while you are away.',26124),
(82633,'enUS','','Hush you.',26124),
(82634,'enUS','But, my lady, what about our reserve in the pon-','',26124),
(82635,'enUS','You got it. One fully armed and operational army of motivated peons coming right up.','',26124),
(82636,'enUS','Chop, Chop boys, these rocks aren\'t gonna blow themselves up!','Chop, Chop boys, these rocks aren\'t gonna blow themselves up!',26124),
(82637,'enUS','No sleeping on the job fellas!','No sleeping on the job fellas!',26124),
(82638,'enUS','At this rate, we might never get paid for this job.  Speed it up!','At this rate, we might never get paid for this job.  Speed it up!',26124),
(82639,'enUS','Hmmm... This looks just about right.','Hmmm... This looks just about right.',26124),
(82640,'enUS','Nope, this won\'t do at all.','Nope, this won\'t do at all.',26124),
(82641,'enUS','','The Warsong descended on us by surprise. Tensions have been high in Nagrand since the formation of the Iron Horde, but we didn\'t expect this.$B$BLet\'s be clear. There are only two reasons that I\'m helping you, $r.$B$BFirst, your shadow hunter here saved my life, albeit for her own selfish reasons. I certainly don\'t expect to see another sunrise.$B$BSecond, if the Warsong manage to learn how to use Telaar\'s shield, there\'ll be no stopping them.',26124),
(82642,'enUS','I\'m going to enjoy this.','',26124),
(82643,'enUS','','Bring me back any toads you find hibernating in the mud; I\'m sure one of them is my husband.',26124),
(82644,'enUS','We need to destroy all of these wards before we can use the scroll of mass teleportation we prepared.','',26124),
(82645,'enUS','','I\'ll have to kiss each toad to break the spell on my husband.',26124),
(82646,'enUS','Hey honey, I\'m back.','',26124),
(82647,'enUS','Oh not again... Loola, I\'m right here. I\'m not a toad... for Light\'s sake.','',26124),
(82648,'enUS','Varmint...','Varmint...',26124),
(82649,'enUS','','I don\'t know... seems suspicious. Maybe I should kiss a couple toads just to be sure.',26124),
(82650,'enUS','Masterful fighting! We need only take out Zulmork and Cromaug now.','',26124),
(82651,'enUS','Now to find Cromaug and put an end to his miserable existence.','',26124),
(82652,'enUS','Two down, only Zulmork to go.','',26124),
(82653,'enUS','Masterful fighting! We need only take out Vorgrosh and Cromaug now.','',26124),
(82654,'enUS','Now to find Cromaug and put an end to his miserable existence.','',26124),
(82655,'enUS','Two down, only Vorgorsh to go.','',26124),
(82656,'enUS','Masterful fighting! We need only take our Zulmork and Vorgorsh now.','',26124),
(82657,'enUS','Now to find Vorgorsh and put an end to his miserable existence.','',26124),
(82658,'enUS','Two down, only Zulmork to go.','',26124),
(82659,'enUS','Does this count for hazard pay?','',26124),
(82660,'enUS','','I\'ll move this impenetrable shield to Grommashar. There\'ll be no stopping the Warsong.',26124),
(82661,'enUS','The air\'s thin up here...','',26124),
(82662,'enUS','The harder we work, the faster we profit.','',26124),
(82663,'enUS','That\'s the last of them. We won\'t have to worry about them interfering.','',26124),
(82664,'enUS','We should get the peons to help.','',26124),
(82665,'enUS','When\'s the beer break?','',26124),
(82666,'enUS','What\'s this pick made of? Lodestone?','',26124),
(82667,'enUS','Let\'s portal in slave labor.','',26124),
(82668,'enUS','Anyone need Kafa ? 10 gold a bean.','',26124),
(82669,'enUS','We Rangari are trained to endure long vigils. I have not moved a single muscle for several hours.','We Rangari are trained to endure long vigils. I have not moved a single muscle for several hours.',26124),
(82670,'enUS','The swamplighters seem especially upset tonight.','The swamplighters seem especially upset tonight.',26124),
(82671,'enUS','It looks like a number of Botani have started to move into the marsh.','It looks like a number of Botani have started to move into the marsh.',26124),
(82672,'enUS','Granny Loola needs to be more careful. She has been wandering around the marsh kissing toads again.','Granny Loola needs to be more careful. She has been wandering around the marsh kissing toads again.',26124),
(82673,'enUS','Hydras are causing quite a bit of chaos. We will eventually need to take care of them to ensure our safety.','Hydras are causing quite a bit of chaos. We will eventually need to take care of them to ensure our safety.',26124),
(82674,'enUS','','You will find the Rangari Hidden throughout the marsh. Report back after you have spoken to each of them.',26124),
(82675,'enUS','','Impressive. Thank you for reporting back to me so quickly, $n.',26124),
(82676,'enUS','Darkness... comes...','',26124),
(82677,'enUS','The shadows grow closer!','',26124),
(82678,'enUS','The Dark Star approaches...','',26124),
(82679,'enUS','The void will consume all...','',26124),
(82680,'enUS','Your forces are waiting to teleport in. Morkurk won\'t last long against all of us.','',26124),
(82681,'enUS','%s |cFFFF0404|Hspell:162497|h[Fixates]|h|r on you!','%s |cFFFF0404|Hspell:162497|h[Fixates]|h|r on you!',26124),
(82682,'enUS','This sure is a lot of wood!','',26124),
(82683,'enUS','','I don\'t see many visitors all the way out here. It is so very nice to have a guest.$b$bWill you be staying for dinner?',26124),
(82684,'enUS','Tank ya, mon. Dese Warsong be trixie an\' got de drop on ol\' J\'wan.','',26124),
(82685,'enUS','I\'m off ta Samedi\'s realm. I be seein\' ya.','',26124),
(82686,'enUS','I wish to know the truth about Dahaka. What do you know of her death?','I wish to know the truth about Dahaka. What do you know of her death?',26124),
(82687,'enUS','WARLORD BLACKHAND','WARLORD BLACKHAND',26124),
(82688,'enUS','LEADER OF THE BLACKROCK ORCS','LEADER OF THE BLACKROCK ORCS',26124),
(82689,'enUS','Intruders approach the keep! To arms!','',26124),
(82690,'enUS','For Morkurk! For the empire!','',26124),
(82691,'enUS','Now, where were we?','',26124),
(82692,'enUS','','Durotan has grown into a great leader. In part, we have you to thank for that.',26124),
(82693,'enUS','Orgrim\'s forces are formidable. He may have betrayed me, but I will not allow vengeance to force me into folly.','',26124),
(82694,'enUS','I live to servo!','',26124),
(82695,'enUS','Almost anything can be fixed with a wrench and a good swingin\' arm.','',26124),
(82696,'enUS','Exploring my home world has proven more dangerous than I hoped.','',26124),
(82697,'enUS','I will stop at nothing to prevent Shattrath from falling again. Show these orcs no mercy.','',26124),
(82698,'enUS','','I fear that Maraad is becoming consumed by his anger.',26124),
(82699,'enUS','Depressing','Depressing',26124),
(82700,'enUS','Acquiring targets!','',26124),
(82701,'enUS','Correcting for air speed velocity.','',26124),
(82702,'enUS','Adjusting for drag coefficient.','',26124),
(82703,'enUS','All systems online! Fire!','',26124),
(82704,'enUS','Right in the face!','',26124),
(82705,'enUS','Ooo! Had ta hurt.','',26124),
(82706,'enUS','','Gar\'rok is a fool! I would have shared this power with him!',26124),
(82707,'enUS','','I will devour you!',26124),
(82708,'enUS','','Cower before my true power!',26124),
(82709,'enUS','','So that poor fool Gar\'rok is dying and wishes to know the truth?',26124),
(82710,'enUS','','I remember Dahaka. She was as you see me now...',26124),
(82711,'enUS','I \'preciate da blessin\', mon. De Lord of de Grave smile upon ya.','',26124),
(82712,'enUS','Dey\'s someting in Oshu\'gun pullin\' on me soul. I gonna hava look.','',26124),
(82713,'enUS','','...until I drained the life from her wretched body!',26124),
(82714,'enUS','What dis? I be dead!','',26124),
(82715,'enUS','I gonna haunt dese Warsong foreva. Stay away from de voodoo.','',26124),
(82716,'enUS','AHHHHHHHHHHHHHHHHHHHHHHHH!','AHHHHHHHHHHHHHHHHHHHHHHHH!',26124),
(82717,'enUS','','It be good ta see ya, Commanda. We need ta bless mah dead, stop de shield, and kill every Warsong in sight.',26124),
(82718,'enUS','','It\'s a simple matter, really. Just activate the perimeter crystals. Good thing the Warsong aren\'t too bright.',26124),
(82719,'enUS','I stand with you, Gar\'rok. Rest with honor.','I stand with you, Gar\'rok. Rest with honor.',26124),
(82720,'enUS','I\'ll erase you from existence!','',26124),
(82721,'enUS','Taste the power of the Empire!','',26124),
(82722,'enUS','I\'ve had enough of your meddling.','',26124),
(82723,'enUS','You are a fool for challenging me.','',26124),
(82724,'enUS','I\'ll turn you to dust where you stand.','',26124),
(82725,'enUS','You\'ll take the crystal from my quivering corpse, mortal.','',26124),
(82726,'enUS','<Hooks have been run through his limbs, and a Shattered Hand insignia carved into his beak.$B$BIt seems the orcs found him first.>','',26124),
(82727,'enUS','Quickly! We need a barrier to protect against his arcane annihilation!','Quickly! We need a barrier to protect against his arcane annihilation!',26124),
(82728,'enUS','Nooooooooooooooooooo!','',26124),
(82729,'enUS','You wish to see the power of the Empire firsthand, little $r? So be it. I could use some entertainment.','',26124),
(82730,'enUS','This body grows weary, $n.','',26124),
(82731,'enUS','Your forces can handle any remaining ogres. Let\'s get out of here.','',26124),
(82732,'enUS','I shall teleport us back.','',26124),
(82733,'enUS','I bring the gift of death to the Alliance.','',26124),
(82734,'enUS','The hour belongs to my enemy but I will return when the odds are in my favor.','',26124),
(82735,'enUS','','It\'s time to see what I can do, to test my limits and break through!',26124),
(82736,'enUS','','Defeat never bothered me anyway.',26124),
(82737,'enUS','I\'m interested in fishing these savage lands.','I\'m interested in fishing these savage lands.',26124),
(82738,'enUS','We won\'t go down that easy!','',26124),
(82739,'enUS','Down goes Van Rook eeeeeeeee....','',26124),
(82740,'enUS','Get the peons back to work.','Get the peons back to work.',26124),
(82741,'enUS','','Gar\'rok, my mate...',26124),
(82742,'enUS','','I have stood by you as a breath upon the wind.',26124),
(82743,'enUS','','I have watched as you lived with honor and my love has not waned.',26124),
(82744,'enUS','Tank schematics? Good thinkin\'. I\'ll look \'em over.','',26124),
(82745,'enUS','\'Ey, $n. You wanna join in the fun? Come get a hand on this here plunger.','',26124),
(82746,'enUS','Wait for it...','',26124),
(82747,'enUS','','Rise, husband. Your ancestors call...reunited we shall answer.',26124),
(82748,'enUS','','I want this shield surrounding all of Telaar, now.',26124),
(82749,'enUS','','Find the intruder and that damned shadow hunter.',26124),
(82750,'enUS','','All glory to the Warsong. All glory to the new warlord, Garrosh Hellscream!',26124),
(82751,'enUS','','No prisoners. Kill outsiders on sight!',26124),
(82752,'enUS','','Warsingers, more power. Once the draenei shield surrounds all of Telaar, no one can get in.',26124),
(82753,'enUS','','We\'ve rid our homeland of the draenei. This is a glorious day for the Warsong.',26124),
(82754,'enUS','','Faster! I intend to ride upon Wor\'var soon.',26124),
(82755,'enUS','','Soon, we will crush our enemies. For the Warsong!',26124),
(82757,'enUS','','Watch out, hero! We must protect K\'ara at all costs!',26124),
(82758,'enUS','','Dey shield is up. Now be da time ta strike, $n. Kill Kargora and get de shield back down.',26124),
(82759,'enUS','These old eyes darken...','',26124),
(82760,'enUS','','Keilnei looks hopeful.',26124),
(82761,'enUS','Dahaka, it is your call that I have waited so long to hear.','',26124),
(82762,'enUS','','We need to spread news of our victory. Take the fey dragon and meet me back at Embaari Village.',26124),
(82763,'enUS','You are... but a pebble to us...','',26124),
(82764,'enUS','You were dead the moment you came here.','',26124),
(82765,'enUS','NO! I cannot fall to the likes of you! I...','',26124),
(82766,'enUS','The fishing here is like nothing we have ever seen back home. How about helping us get this fishing operation off the ground?','The fishing here is like nothing we have ever seen back home. How about helping us get this fishing operation off the ground?',26124),
(82767,'enUS','You have my thanks once again, commander. These fiends were going to eat me alive. I will meet you back at the garrison.','',26124),
(82768,'enUS','%s goes into a frenzy at the sight of its master\'s death.','',26124),
(82769,'enUS','Beasts! Move your lazy hides!','Beasts! Move your lazy hides!',26124),
(82770,'enUS','Indolent animals! Clear the hallway!','Indolent animals! Clear the hallway!',26124),
(82771,'enUS','Move, brutes! These supplies need to get downstairs!','Move, brutes! These supplies need to get downstairs!',26124),
(82772,'enUS','You will not enter the Iron Assembly!','You will not enter the Iron Assembly!',26124),
(82773,'enUS','Dran\'ruk, as our guest, I give you the honor of the first battle.','',26124),
(82774,'enUS','Show us the might of the Warsong.','',26124),
(82775,'enUS','I need a break!','',26124),
(82776,'enUS','It\'s gonna blow! Up! After ya use it.','',26124),
(82777,'enUS','The Burning Blade are known for their honor in battle. However, that does not mean they will not try to kill you on sight.','',26124),
(82778,'enUS','We should have wiped Draenor clean of orcs when we arrived. None of this would ever have happened.','',26124),
(82779,'enUS','','The Iron Horde\'s machines must be disabled. Be careful, $n.',26124),
(82780,'enUS','','Those weapons can no longer be used against our people. Well done, $c.',26124),
(82781,'enUS','It is done.','',26124),
(82782,'enUS','Only bring back pages that are legible!','',26124),
(82783,'enUS','Mmm... sleep...','',26124),
(82784,'enUS','Just a quick nap...','',26124),
(82785,'enUS','Remind me to clean the eyepiece when yer done. Thing hasn\'t been cleaned for ages.','',26124),
(82786,'enUS','I got \'er all fixed up for ya!','',26124),
(82787,'enUS','So tired!','',26124),
(82788,'enUS','You defeated her!  You have proven yourself to me and saved me from a life of toil at the forge.  I pledge my life to you $n.','',26124),
(82789,'enUS','Use your |TInterface\\Icons\\inv_scroll_02.blp:32|t |cFFFF0000|Hspell:162568|h[Scroll of Mass Teleportation]|h|r now!','',26124),
(82790,'enUS','Thanks fer helpin\' out up in Telaar, $n.$B$BI had her under control, but it\'s always good ta have ya around, $g boyo:lass;.','',26124),
(82791,'enUS','Ya ask me, I say we kill every orc on sight! Who cares \'bout which clans they belong ta?','',26124),
(82792,'enUS','More stone!','',26124),
(82793,'enUS','Um... ROCKS!','',26124),
(82794,'enUS','Yes... fire!','',26124),
(82795,'enUS','More... fire?','',26124),
(82796,'enUS','Who is dat?','',26124),
(82797,'enUS','Oy! Dey fightin\'!','',26124),
(82798,'enUS','Da King don\'t wanna see nobody! Go away!','',26124),
(82799,'enUS','Fight \'em back den.','',26124),
(82800,'enUS','Hear \'dis?','',26124),
(82801,'enUS','Git out!','',26124),
(82802,'enUS','Watch out!','',26124),
(82803,'enUS','Boom!','',26124),
(82804,'enUS','Heh heh... \'Dis gonna be gud.','',26124),
(82805,'enUS','I got one, too!','',26124),
(82806,'enUS','Dey so small.','',26124),
(82807,'enUS','Hah! Hah! Hah!','',26124),
(82808,'enUS','Oooowwwww....','',26124),
(82809,'enUS','Crush dat!','',26124),
(82810,'enUS','Feel \'dis!','',26124),
(82811,'enUS','\'Dis gonna hurt.','',26124),
(82812,'enUS','Ha hah... Smash!','',26124),
(82813,'enUS','Let\'s have some fun!','',26124),
(82814,'enUS','Dat one\'s dead.','',26124),
(82815,'enUS','Dey squeal when ya smoosh \'em.','',26124),
(82816,'enUS','Dat wus fun. Let\'s do it again!','',26124),
(82817,'enUS','Ow... dat... hurts...','',26124),
(82818,'enUS','Bored. Let\'s kill \'dem now.','',26124),
(82819,'enUS','Oh yeah! Try to stay clear of the blast or you might get knocked around a bit.','',26124),
(82820,'enUS','These machines the Iron Horde has are unlike anything I had seen before their arrival.','',26124),
(82821,'enUS','','Good luck, and be careful with the explosives.',26124),
(82822,'enUS','I can\'t wait to fix this thing up!','',26124),
(82823,'enUS','Sorry if the Eye \'n\' Ear smells funny. Nothin\' to worry about!','',26124),
(82824,'enUS','Enjoy piloting the shredder! This is gonna be sweet!','',26124),
(82825,'enUS','Excellent. Let\'s grab that crystal and get out of here!','',26124),
(82826,'enUS','When you are ready, we will follow you into Shattrath.','',26124),
(82827,'enUS','Ornekka\'s hut is just down the road. Percy and I will be close behind.','',26124),
(82828,'enUS','Let\'s finalize this building and put it to work!','Let\'s finalize this building and put it to work!',26124),
(82829,'enUS','','Being a mage does have its perks!',26124),
(82830,'enUS','','How quaint. A wall! The Gordunni really have been disconnected from the empire for too long.',26124),
(82831,'enUS','','This ought to get us over!',26124),
(82832,'enUS','','Let\'s do this!',26124),
(82833,'enUS','','We\'ve got to get rid of these wards. They\'re stopping us from using the scroll of mass teleportation we prepared!',26124),
(82834,'enUS','','Splendid! Glad we won\'t have to deal with them.',26124),
(82835,'enUS','','What a fight! Grab the crystal and let\'s get out of here.',26124),
(82836,'enUS','','You\'re an incredible fighter! We\'ve only got Zulmork and Cromaug left now.',26124),
(82837,'enUS','','We just need to find Cromaug now.',26124),
(82838,'enUS','','That only leaves one. Zulmork.',26124),
(82839,'enUS','','You\'re an incredible fighter! We\'ve only got Vorgrosh and Cromaug left now.',26124),
(82840,'enUS','','You\'re an incredible fighter! We\'ve only got Zulmork and Vorgorsh left now.',26124),
(82841,'enUS','','We just need to find Vorgorsh now.',26124),
(82842,'enUS','','Your forces are waiting for our teleport spell. Morkurk won\'t know what hit him.',26124),
(82843,'enUS','','Let\'s get back to your outpost. Your forces can handle any remaining ogres.',26124),
(82844,'enUS','','I\'ll teleport us back.',26124),
(82845,'enUS','Filling','Filling',26124),
(82846,'enUS','A dark presence grows in the west. Gordawg, the great earthen fury, has gone missing.','',26124),
(82847,'enUS','Furies of the Throne of Elements, we answer your call. How may we serve?','',26124),
(82848,'enUS','Without a fury of earth upon the throne, the elemental bonds that hold this world together weaken.','',26124),
(82849,'enUS','Gordawg must be found and returned to the throne.','',26124),
(82850,'enUS','The balance has been disrupted. The Elemental Plateau has grown unstable and must be purged.','',26124),
(82851,'enUS','If left imbalanced, the elements will rage across this valley tearing all life asunder.','',26124),
(82852,'enUS','This is the Throne of Elements.$b$bYou stand in the presence of furies, $n. Here, the earth lives beneath your feet and the wind watches your every move.$b$bThis place is truly hallowed ground.','',26124),
(82853,'enUS','I am ready to commune with the furies.','I am ready to commune with the furies.',26124),
(82854,'enUS','%s emerges to haunt you!','',26124),
(82855,'enUS','Your will is understood. Gordawg will be found and the balance restored.','',26124),
(82856,'enUS','The fate of the elements rests in your hands.','',26124),
(82857,'enUS','After everything I\'ve gone through who would have thought I\'d end up here?$b$bNothing quite like gutting ogres while sticking it to my pompous ass former bosses in the Iron Horde!','',26124),
(82858,'enUS','Commander! When I heard the ogre\'s death cry I came as soon as I could. Did everything go well?','',26124),
(82859,'enUS','Use your |TInterface\\Icons\\CREATUREPORTRAIT_GOBLIN_ROCKET.blp:32|t |cFFFF0000|Hspell:162896|h[Emergency Rocket Pack]|h|r now!','',26124),
(82860,'enUS','Someone call for a lift?','',26124),
(82861,'enUS','Ugh! Get them!','',26124),
(82862,'enUS','Rargh!','',26124),
(82864,'enUS','If you return when you are wiser, I will regale you with tales of great heroics.$b$b(You must be at least level 91 to hear Shin\'s stories.)','If you return when you are wiser, I will regale you with tales of great heroics.$b$b(You must be at least level 91 to hear Shin\'s stories.)',26124),
(82865,'enUS','Tell me of the Guardians of Mogu\'shan.','Tell me of the Guardians of Mogu\'shan.',26124),
(82866,'enUS','I sing of arms and a man who.... Oh, hm, you are not quite ready for this one. Return when you have experienced more of the world.$b$b(You must be at least level 91 to hear Han\'s stories.)','I sing of arms and a man who.... Oh, hm, you are not quite ready for this one. Return when you have experienced more of the world.$b$b(You must be at least level 91 to hear Han\'s stories.)',26124),
(82867,'enUS','Not long ago, outsiders\' ships were cast upon the shores of Pandaria, bearing strife but also courage. Listen, and I will speak of how a deep shadow crept across Pandaria, and how brave heroes brought us a new dawn.','',26124),
(82868,'enUS','Tell me of the Vault of Mysteries.','Tell me of the Vault of Mysteries.',26124),
(82869,'enUS','Tell me of the Dread Approach to the Heart of Fear.','Tell me of the Dread Approach to the Heart of Fear.',26124),
(82870,'enUS','Tell me of the Nightmare of Shek\'zeer.','Tell me of the Nightmare of Shek\'zeer.',26124),
(82871,'enUS','Tell me of the Terrace of Endless Spring.','Tell me of the Terrace of Endless Spring.',26124),
(82872,'enUS','','That only leaves one. Cromaug.',26124),
(82873,'enUS','Tell me of the Last Stand of the Zandalari.','Tell me of the Last Stand of the Zandalari.',26124),
(82874,'enUS','Tell me of the Forgotten Depths beneath the Throne of Thunder.','Tell me of the Forgotten Depths beneath the Throne of Thunder.',26124),
(82875,'enUS','Tell me of the twisted mogu Halls of Flesh-Shaping.','Tell me of the twisted mogu Halls of Flesh-Shaping.',26124),
(82876,'enUS','Tell me of Lei Shen\'s Pinnacle of Storms.','Tell me of Lei Shen\'s Pinnacle of Storms.',26124),
(82877,'enUS','Tell me of the Vale of Eternal Sorrows that surrounds us.','Tell me of the Vale of Eternal Sorrows that surrounds us.',26124),
(82878,'enUS','Tell me of the war that came to the Gates of Retribution.','Tell me of the war that came to the Gates of Retribution.',26124),
(82879,'enUS','Tell me of the Underhold beneath Orgrimmar.','Tell me of the Underhold beneath Orgrimmar.',26124),
(82880,'enUS','Tell me of the Downfall of Garrosh Hellscream.','Tell me of the Downfall of Garrosh Hellscream.',26124),
(82881,'enUS','','We will not be able to pass through their gates. If you wish to try, I will wait for you here.',26124),
(82882,'enUS','You are not one of the flock but you leave an impressive gift for the Raven Mother.','',26124),
(82883,'enUS','Just let me look at it!','',26124),
(82884,'enUS','Not a chance. Malrok would skin us both if I let anyone near that thing.','',26124),
(82885,'enUS','Bah! I\'m not afraid of that old cutthroat.','',26124),
(82886,'enUS','You should be.','',26124),
(82887,'enUS','Now, let\'s get moving!','',26124),
(82888,'enUS','Only when you are attuned to the elements, will you be able to undertake the Ritual of Binding.','',26124),
(82889,'enUS','When you are ready, I will commune with the great furies.','',26124),
(82890,'enUS','Hurry, $c. The Cycle of Rebirth must take place.','',26124),
(82891,'enUS','Although they are weakened, the Avatars upon the plateau are still mighty incarnations. Do not underestimate their strength.','',26124),
(82892,'enUS','The fire and thorns of the ember blossom have always reminded me of her strength and conviction.','',26124),
(82893,'enUS','I have always suspected Challe, but I have not had the proof necessary to bring justice upon her.','',26124),
(82894,'enUS','My time is at an end, but I die knowing that I have honored her memory.','',26124),
(82895,'enUS','You will find Gar\'rok high upon a cliff, overlooking the Throne of Elements.','',26124),
(82896,'enUS','','Return when you have weathered the sands of time further. You are not yet ready for this challenge.$b$b(You must be at least level 86 to access Dragon Soul Raid Finder on your own.)',26124),
(82897,'enUS','','The sands of time have passed you by, but I can return you to the hour of twilight, when the Destroyer threatened to crush the world in his grasp.$b$b(Auridormi will allow you and your party members to access the Raid Finder version of Dragon Soul directly, without outside assistance.)',26124),
(82898,'enUS','Take me to the Siege of Wyrmrest Temple.','Take me to the Siege of Wyrmrest Temple.',26124),
(82899,'enUS','Bring me to the moments preceding the Fall of Deathwing.','Bring me to the moments preceding the Fall of Deathwing.',26124),
(82900,'enUS','You have for the moment earned my curiosity, yes. Tell me, what is it that brings you to us?','',26124),
(82901,'enUS','This is hardly a fitting camp for a member of the Gorian Empire.  If your Iron Horde wishes to remain allies you would do well to treat us well!','',26124),
(82902,'enUS','Water nourishes and sustains life, yet also has the power to cut through earth and rock.','',26124),
(82903,'enUS','Those who draw upon the strength of the earth will crush their enemies like gravel beneath their feet.','',26124),
(82904,'enUS','Break you!','',26124),
(82905,'enUS','Butchered!','',26124),
(82906,'enUS','Me rip, you die!','',26124),
(82907,'enUS','Those with burning conviction and fierce courage often attune themselves to the way of the flame.','',26124),
(82908,'enUS','The wind is the voice of the elements, it whispers gently upon the breeze and howls fiercely within the storm.','',26124),
(82909,'enUS','Join... us...','Join... us...',26124),
(82910,'enUS','Bring you... to the Heart...','Bring you... to the Heart...',26124),
(82911,'enUS','Please help... come to me...','Please help... come to me...',26124),
(82912,'enUS','Borrowing','Borrowing',26124),
(82913,'enUS','Be resolute brothers and sisters of the flock! Our faith is merely being tested by the Raven Mother!','',26124),
(82914,'enUS','The Raven Mother sends these beasts to test our resolve! We must lift our voices to her with even more fervor!','',26124),
(82915,'enUS','High Ravenspeaker, I have brought you this gift and wish an audience with you.','High Ravenspeaker, I have brought you this gift and wish an audience with you.',26124),
(82916,'enUS','May the Raven Mother\'s shadow be upon you.','',26124),
(82917,'enUS','Blackhand wants to see these shipments in Talador. NOW!','',26124),
(82918,'enUS','Blackhand won\'t tolerate any more delays.','',26124),
(82919,'enUS','Track one.','',26124),
(82920,'enUS','Live iron on track one!','',26124),
(82921,'enUS','Track two!','',26124),
(82922,'enUS','Incoming on two.','',26124),
(82923,'enUS','Track three.','',26124),
(82924,'enUS','Track three inbound.','',26124),
(82925,'enUS','Track four!','',26124),
(82926,'enUS','Inbound on four.','',26124),
(82927,'enUS','Trains inbound!','',26124),
(82928,'enUS','Double-time.','',26124),
(82929,'enUS','Clear the tracks!','',26124),
(82930,'enUS','Ah - reinforcements.','',26124),
(82931,'enUS','Reinforcements, right on time.','',26124),
(82932,'enUS','Troop train - inbound!','',26124),
(82933,'enUS','Here they come - hit the grit, boys!','',26124),
(82934,'enUS','The command car is here.','',26124),
(82935,'enUS','Here comes the brass.','',26124),
(82936,'enUS','Coming in hot.','',26124),
(82937,'enUS','Here\'s my artillery.','',26124),
(82938,'enUS','Here come the boomers!','',26124),
(82939,'enUS','Redball incoming!','',26124),
(82940,'enUS','Express, coming through.','',26124),
(82941,'enUS','Send \'er on down the line!','',26124),
(82942,'enUS','Faster! Bat the stack off her!','',26124),
(82943,'enUS','End of the line.','',26124),
(82944,'enUS','Terminated!','',26124),
(82945,'enUS','Hah, flat as a copper piece.','',26124),
(82946,'enUS','All aboard!','',26124),
(82947,'enUS','Right. On. Time.','',26124),
(82948,'enUS','Couldn\'t keep up, eh?','',26124),
(82949,'enUS','Hah hah, this timetable is a killer!','',26124),
(82950,'enUS','Let\'s step up the pace.','',26124),
(82951,'enUS','You\'re just in time for the rush.','',26124),
(82952,'enUS','I\'m not impressed. More trains are inbound!','',26124),
(82953,'enUS','I have a schedule to keep!','',26124),
(82954,'enUS','You are running out of time...','',26124),
(82955,'enUS','It is the END of the LINE!','',26124),
(82956,'enUS','That wasn\'t on the... schedule...','',26124),
(82957,'enUS','|TInterface\\Icons\\spell_shadow_mindbomb.blp:20|t Siege Bombs are locked on to you!','',26124),
(82958,'enUS','You worthless swine!  Get back to work.  We have a quota to make!','',26124),
(82959,'enUS','%s frenzies!','',26124),
(82960,'enUS','No! You gunna pay...','',26124),
(82961,'enUS','Now I grind yer soul!','',26124),
(82962,'enUS','Remember the lesson of the Scroll of The Broken Glass! You must shake before the might of the Raven Mother, do not swish around in life as if stirred to swirl in an eternal cycle! Through the Raven Mother\'s blessings the Flock will endure!','',26124),
(82963,'enUS','You three! Follow $p onto the battlefield, and listen for my call.','',26124),
(82964,'enUS','I have a plan.','',26124),
(82965,'enUS','What was his plan?','',26124),
(82966,'enUS','','We are yours to command, $p.',26124),
(82967,'enUS','Keep up your guard!','',26124),
(82968,'enUS','Excellent form. Now, press the attack!','',26124),
(82969,'enUS','And the Raven Mother spoke to me: Krikka, you are my dear child. You shall seek out my other wayward children and bring them back to the nest.','',26124),
(82970,'enUS','When all of the flock have gathered the end shall come. The world will be torn asunder in a great catastrophe! Fear not, for the Raven Mother will save us!','',26124),
(82971,'enUS','The Raven Mother will come from the heavens for her children. We will rise upon her great ebon wings to take our rightful place in her dark kingdom!','',26124),
(82972,'enUS','Until that time comes give your praise to the Raven Mother! Look after her great kin for guidance and strength. May she cast her shadow upon you!','',26124),
(82973,'enUS','Scribe! Did you get all of that?','',26124),
(82974,'enUS','Yes, High Ravenspeaker.','',26124),
(82975,'enUS','Praise the Raven Mother!','',26124),
(82976,'enUS','Who\'s there? Father... is that you?','',26124),
(82977,'enUS','Please, come closer. It\'s so dark...','',26124),
(82978,'enUS','You are not my father... but... you have something of his...','',26124),
(82979,'enUS','|c00FFFF00|Hspell:178380|h[Kor\'lok, the Ogre King]|h|r awakens!','',26124),
(82980,'enUS','|c00FFFF00|Hspell:178380|h[Kor\'lok, the Ogre King]|h|r slumbers once more.','',26124),
(82981,'enUS','|c00FFFF00|Hspell:178380|h[Kor\'lok, the Ogre King]|h|r has elected to fight alongside the Alliance!','',26124),
(82982,'enUS','|c00FFFF00|Hspell:178380|h[Kor\'lok, the Ogre King]|h|r has returned to his throne.','',26124),
(82983,'enUS','|c00FFFF00|Hspell:178380|h[Kor\'lok, the Ogre King]|h|r has elected to fight alongside the Horde!','',26124),
(82984,'enUS','','%s cast |cFFFF0404|Hspell:155277|h[Blazing Radiance]|h|r on you!',26124),
(82985,'enUS','Nooo! My... Soulgrinder...','',26124),
(82986,'enUS','We\'re eating riverbeast tonight, boys!','',26124),
(82988,'enUS','By the Raven Mother\'s shadow! How can such such a slaughter have happened to us?','',26124),
(82989,'enUS','Hold to your faith scribe! Remember the lesson in the Scroll of the Dark Dawn, \"Ravens of the flock should stay together.\" Once the Raven Mother has returned and all her children are in the nest then we will truly be safe!','',26124),
(82990,'enUS','Of course sir.','',26124),
(82991,'enUS','Change of plans. Tear it down!','',26124),
(82992,'enUS','We\'re moving in a different direction. Tear this building down!','',26124),
(82993,'enUS','With the keystone, you will be able to pass through, alone. Once inside, deactivate their shields and we will join you.','',26124),
(82994,'enUS','The caravan was led by a woman that looked like a wolf. I must admit, I\'m still getting used to you Azerothians. They left here just a few hours ago.','',26124),
(82995,'enUS','Commander, we found this draenei laying on the road outside our walls.','Commander, we found this draenei laying on the road outside our walls.',26124),
(82996,'enUS','','Hold on, Gidwin. Help is on the way.',26124),
(82997,'enUS','Come, I take you to the High Ravenspeaker, yes.','',26124),
(82998,'enUS','I should never have left Dalaran. What was I thinking?','',26124),
(82999,'enUS','Have you seen any of the hidden artifacts?$B$BYou can find fragments all throughout Ashran. I hear killing the creatures in this the outskirts off of the Road of Glory has uncovered some recently. $B$BYou can give me any you find, and I\'ll distribute them to those who need them.','Have you seen any of the hidden artifacts?$B$BYou can find fragments all throughout Ashran. I hear killing the creatures in this the outskirts off of the Road of Glory has uncovered some recently. $B$BYou can give me any you find, and I\'ll distribute them to those who need them.',26124),
(83000,'enUS','You have come to us at the perfect time, yes. Soon the Raven Mother herself will join us here!','',26124),
(83001,'enUS','High Ravenspeaker, may the Raven Mother always keep you in her sacred shadow.','',26124),
(83002,'enUS','High Ravenspeaker, this outsider has come to us just as written! Yes.','',26124),
(83003,'enUS','Mm? Need somethin\'?','',26124),
(83004,'enUS','Yes. I need you to help me operate that enormous tank.','Yes. I need you to help me operate that enormous tank.',26124),
(83005,'enUS','','Take home a wondrous creature, never before seen on Draenor!',26124),
(83006,'enUS','','Come see Chelie\'s Mystical Menagerie! Gaze upon these exotic creatures from faraway lands!',26124),
(83007,'enUS','','Over here, hero, before they see us! Listen - they\'re talking about the Dark Star.',26124),
(83008,'enUS','Can\'t... breathe... this foul smelling gas makes me even angrier!','',26124),
(83015,'enUS','','Sometimes I come here just to clear my head.',26124),
(83016,'enUS','','My younger sister comes here to ponder the Light.  Muku and I make sure the orcs think twice about bothering her.',26124),
(83017,'enUS','','Not too much longer.',26124),
(83018,'enUS','','Soon.  My meditation is almost complete.',26124),
(83019,'enUS','','Just a few more minutes.  It\'s so peaceful here, it reminds me of... of the past.',26124),
(83020,'enUS','','How long must we wait here?  It\'s not safe Amnumi.',26124),
(83021,'enUS','','Are you going to kneel there forever?',26124),
(83022,'enUS','','Please tell me you\'re ready to get back to the village! We\'ve been here for hours.',26124),
(83023,'enUS','','I love my little kitty buddies!',26124),
(83024,'enUS','','Awww... Isn\'t Barbar the sweetest little kitty you\'ve ever seen?',26124),
(83025,'enUS','','Dinah is a sweetheart. Just watch out for her claws, especially when she gets those crazy eyes.',26124),
(83026,'enUS','Them plant people are tryin\' to mulch me!','',26124),
(83027,'enUS','Make for the road.','Make for the road.',26124),
(83028,'enUS','Oh man... this war is crazy huh?$b$bI can\'t wait till it\'s over so I can go home and see my girls.$b$bWant to see some pictures?$b$bThis is my wife Ashley and my beautiful daughter Ella. Man, I miss them.','',26124),
(83029,'enUS','','I think it would be best if you left, $r.',26124),
(83030,'enUS','Well, well, a hero has come to our rescue. Be careful my friend, Gorgrond is no place for a hero.','',26124),
(83031,'enUS','The way is clear.','The way is clear.',26124),
(83032,'enUS','Ya don\'t have to tell me twice. I\'ll meet ya on the road.','',26124),
(83033,'enUS','Is it now? Well, I suppose we should abandon this post now that it has been compromised. The fara will not allow us to stay now that they have our scent.','',26124),
(83034,'enUS','','Very well. I\'ll meet you there. Stay safe.',26124),
(83035,'enUS','','Rest your weary bones for a spell?',26124),
(83036,'enUS','The spirit of Golmash is merciless. Let this gift of ancestral wind guide your hands.','',26124),
(83037,'enUS','If the pyres remain unlit, we too shall be drawn into the void and consumed.','',26124),
(83038,'enUS','','The echoes must be put down if the remaining spirits here are to rest.',26124),
(83039,'enUS','For the glory of the Warsong, I will crush you!','',26124),
(83040,'enUS','You dare approach the Giantslayer? I will cleave your head from your body!','',26124),
(83041,'enUS','Why do I feel no pain from your blows?','',26124),
(83042,'enUS','I see now... this is not my death. My death was long ago... and it was glorious!','',26124),
(83043,'enUS','','You wish to speak with Ared? I\'m sorry, his wounds were great and the illness too strong.',26124),
(83044,'enUS','','Ared would not want to see me standing here crying like this. Let\'s go to this armory of yours.',26124),
(83045,'enUS','','This looks amazing! If only Ared was alive to see this, he would be so proud!',26124),
(83046,'enUS','','After everything we went through in escaping Shattrath his sickness finally caught up to him.$b$b My dear master, you will be missed.',26124),
(83047,'enUS','The docks. Run to the docks. Run. RUN!','',26124),
(83048,'enUS','Come at me, Hellscream!','',26124),
(83049,'enUS','Don\'t be a fool, Ga\'nar - Run! We will fight another day.','',26124),
(83050,'enUS','','Look out!',26124),
(83051,'enUS','','Keep moving. I see the ships ahead.',26124),
(83052,'enUS','Their entire army is behind us.','',26124),
(83053,'enUS','','Their entire army is behind us.',26124),
(83054,'enUS','Where now?','',26124),
(83055,'enUS','No!  Let me see it... up close.  This has to be it!','',26124),
(83056,'enUS','Head for the ships at the end of the road.','',26124),
(83057,'enUS','This way. Go, go, go!','',26124),
(83058,'enUS','There is no place to run, outsiders. This is MY world. We will find you!','',26124),
(83059,'enUS','Dead... or used up.  I was so sure I would find what I needed here!','',26124),
(83060,'enUS','We Frostwolves will be waiting for you, Hellscream! You, your ogres, your whole Iron Horde... You\'re as good as dead!','',26124),
(83061,'enUS','Ignore his threats. We will go to Shadowmoon for reinforcements. This time, the draenei will triumph.','',26124),
(83062,'enUS','Let\'s get underway then. We will need to build a stronghold if we hope to end the Iron Horde threat. And we\'re going to need help from the natives.','',26124),
(83063,'enUS','To Shadowmoon!','',26124),
(83064,'enUS','To the home of the Frostwolves!','',26124),
(83065,'enUS','Come on, swines! Move like you signed up for this.','',26124),
(83066,'enUS','They\'re here... GET UP!','',26124),
(83070,'enUS','Formation, NOW!','',26124),
(83071,'enUS','Wait, I feel it.  It is closer now.  Quickly! To me!','',26124),
(83072,'enUS','','Everyone said I was foolish to collect all of these pets. Now look who\'s having the last laugh!',26124),
(83073,'enUS','Exotic pets? These all seem pretty ordinary...','Exotic pets? These all seem pretty ordinary...',26124),
(83074,'enUS','','Ordinary to you, perhaps. These yokels have never even seen a chicken before! I\'m going to make a fortune!',26124),
(83075,'enUS','','Long ago, before the exodus aboard the Genedar, the Draenei made up just a small portion of the great Eredar civilization.',26124),
(83076,'enUS','','Hakaam, please tell the class the name of the world that the Eredar once called home?',26124),
(83077,'enUS','Um... Is it Eredor?','',26124),
(83078,'enUS','','Good guess, Hakaam, but the world is actually called Argus.',26124),
(83079,'enUS','','The Eredar were a wise and powerful people. It was only through the deceitful corruption brought upon them by a fallen deity that led to their downfall.',26124),
(83080,'enUS','','Now, Rastaak, could you tell me the name of the fallen deity who was responsible for corrupting the Eredar?',26124),
(83081,'enUS','They need your help with Blackhand! I can get you there. Speak with me when you\'re ready.','',26124),
(83082,'enUS','Sargeras, I think...','',26124),
(83083,'enUS','','Very good, child.',26124),
(83084,'enUS','','When Sargeras approached the Eredar with his plans, our wise prophet saw through his lies and was able to save a small number of his people. Those few survivors are what make our civilization today.',26124),
(83085,'enUS','','Who can tell me the name of the prophet that saved our people from corruption and led us to Draenor? How about you, Ariaana?',26124),
(83086,'enUS','','You know, we make a pretty good team.$b$bAt first I just wanted to honor the memory of my master but now, I could really see working for you in the long term. Thanks for giving me a chance.',26124),
(83087,'enUS','','Velen, Miss Kierii.',26124),
(83088,'enUS','','Indeed it is. Well done.',26124),
(83089,'enUS','','However, even a prophet such as Velen could not hope to save the Draenei alone. In his quest he was aided by divine beings of light.',26124),
(83090,'enUS','','Does anyone know the name of the beings that helped Velen save the Draenei people?',26124),
(83091,'enUS','Ooh, I know this!','',26124),
(83092,'enUS','','Go ahead, Hakaam.',26124),
(83093,'enUS','The Naaru!','',26124),
(83094,'enUS','','Very good, Hakaam!',26124),
(83095,'enUS','','Our people, the Draenei, were the only ones to escape the absolute corruption of Sargeras. The remaining Eredar were transformed into his dark minions.',26124),
(83096,'enUS','','For extra credit, what do we call these minions, now that they are no longer recognizable as Eredar? Ariaana?',26124),
(83097,'enUS','','The Man\'ari, Miss Kierii.',26124),
(83098,'enUS','','Well, done Ariaana. That is correct.',26124),
(83099,'enUS','','That concludes today\'s lesson. Be sure to study up for our next lesson on the wonders of our new homeworld of Draenor.',26124),
(83100,'enUS','','Stay frosty, men. You\'re going to teleport into the heart of ogre territory.',26124),
(83101,'enUS','Keep your weapons hot. You\'re going to be teleporting straight into hell.','',26124),
(83102,'enUS','','I\'ll move forward and scout their gates while you\'re taking out those catapults. Dioniss aca.',26124),
(83103,'enUS','I\'m well aware that the fish are more plentiful in the upper pools. However, a real professional knows that the big ones prefer a spot with a little more cover. \n\nJust wait until Roluna sees what I can land down here in the weeds!','',26124),
(83104,'enUS','Is... is this the place?  Is it here?  Clear these creatures so I can think!','',26124),
(83105,'enUS','','Commander, over here!',26124),
(83106,'enUS','','That magical barrier is too strong for our explosives to break open. I can\'t find a way to bring it down so we\'re going to have to sneak in around it.',26124),
(83107,'enUS','','I\'ll go first and clear the way, meet me on the other side.',26124),
(83108,'enUS','I can\'t see...  I need a moment...','',26124),
(83109,'enUS','','Thank you for your aid, $n. I hope we meet again.',26124),
(83110,'enUS','Thank you for your assistance, $n. I am sure we will meet again in due time.','',26124),
(83111,'enUS','Nyami awaits you in the western ritual chamber, champions.','',26124),
(83112,'enUS','Blacksmith Haephest creates some of the finest arms and armor in Shadowmoon. His wares will fetch a hefty sum in the Shattrath markets.','',26124),
(83113,'enUS','Pah, weak. Come back when you\'re stronger.','',26124),
(83114,'enUS','Yrel!?! Have you come back from the dead?','',26124),
(83115,'enUS','','It will take more than some orcs to defeat me!',26124),
(83116,'enUS','','Yrel! Is that you? You still owe me six copper!',26124),
(83117,'enUS','','You still owe me six copper!',26124),
(83118,'enUS','A trader with an empty cart, such a sad sight, no? \n\nIf only my partner Daruun would make up his mind so we could be on our way.','',26124),
(83119,'enUS','It\'s a lovely plant, yes? What color would be best suited for Shattrath\'s markets? \n\nDoes anyone even buy plants these days?','',26124),
(83120,'enUS','Yay! You\'re here!','',26124),
(83121,'enUS','Hello stranger!','',26124),
(83122,'enUS','','Yrel! She\'s come to save us!',26124),
(83123,'enUS','','The stranger will help us!',26124),
(83124,'enUS','She\'s back!','',26124),
(83125,'enUS','A hero! A hero!','',26124),
(83126,'enUS','','Good day, children! I\'ve brought a hero from a far away land to meet you.',26124),
(83127,'enUS','That danged army should be here any minute. Let\'s move!','',26124),
(83128,'enUS','SESK!','',26124),
(83129,'enUS','GORN!','',26124),
(83130,'enUS','Now that we\'re connected, we can create a portal directly to your garrison.','',26124),
(83131,'enUS','Out in the field, weapon in hand, this is almost as fun as being at the forge!','',26124),
(83132,'enUS','Personnel evacuation system engaged.','',26124),
(83137,'enUS','','Arbor Glen is in trouble. We had better go see if we can help.',26124),
(83138,'enUS','','Nandaez might think he\'s clever for fishing the cover down below, but you can literally see the fish up here! Just look at them! What a fool he is.',26124),
(83139,'enUS','I\'m okay.  We must keep moving.  It calls to us.','',26124),
(83140,'enUS','Ha! I can see you are brave, but danger is my trade!','',26124),
(83141,'enUS','I live, I love, I slay, and I am content.','',26124),
(83142,'enUS','Ah, at last.','',26124),
(83143,'enUS','Argh!  I can\'t think with all these beasts shouting at me.  Stop their screaming!','',26124),
(83144,'enUS','Yrel is my brightest student, and at times the dimmest.$B$BShe is fierce in battle, but does not discipline herself through training.$B$BShe learns quickly, but cannot sit still enough to read a book.$B$BShe would much rather play with the village children than memorize the holy texts.$B$BIf only she would focus!','',26124),
(83145,'enUS','','By the light, what a battle!',26124),
(83146,'enUS','Not men, not women, not beasts...','',26124),
(83147,'enUS','This I can trust.','',26124),
(83148,'enUS','For me, there is no spring.','',26124),
(83149,'enUS','','Prophet Velen is a great teacher, but he\'s too serious sometimes!$B$BI would much rather live out the holy principles than read about them in a book, don\'t you agree?',26124),
(83150,'enUS','Nothing can hurt me! Only pain.','',26124),
(83151,'enUS','No man shall live in chains!','',26124),
(83152,'enUS','All that matters is that we few stood against many.','',26124),
(83153,'enUS','Very well. Come with me if you want to live.','',26124),
(83154,'enUS','','Lets do this!',26124),
(83155,'enUS','Pilfering','Pilfering',26124),
(83156,'enUS','Almost... almost there.  Just a little further.  Soon...','',26124),
(83157,'enUS','Enough talk!','',26124),
(83158,'enUS','','We\'re connected to the ley line network. Now we can create a portal directly to your garrison.',26124),
(83159,'enUS','I\'ll... be... back...','',26124),
(83160,'enUS','','One thing we learned early from the Laughing Skull: podlings hate fire.',26124),
(83161,'enUS','D\'kaan is coming with help.','D\'kaan is coming with help.',26124),
(83162,'enUS','','Go without me, stranger. I will only slow you down. I shall hold my own until D\'kaan arrives.',26124),
(83163,'enUS','Those foul creatures poison their spears. I keep an antidote but it will take time for my head to clear enough for me to move.','',26124),
(83164,'enUS','Here.  Yes here!  This is where I need to be.','',26124),
(83165,'enUS','Do not worry about me, my friend. I will await D\'kaan\'s arrival. Please, find the others.','',26124),
(83166,'enUS','Ah, the smell of victory. If only I had my sword with me... the things I could accomplish.','',26124),
(83167,'enUS','Together, we have crushed the slavers and brought upon them swift destruction. They who have taken everything from me. \n\nBut, I have one last thing to give. To be a part of something greater... I\'d forgotten what that feels like.','',26124),
(83168,'enUS','Yes, I see it now.  We must take this.  Take it back to our people and show them the way.  You have been very helpful. I think its time you joined us.','',26124),
(83169,'enUS','I will not leave the fallen to the children of the genesaur. I will protect their bodies until D\'kaan arrives.','',26124),
(83170,'enUS','We fought as well as we could. But in the end, too many of my friends were lost.','',26124),
(83171,'enUS','If it bleeds, we can kill it!','',26124),
(83172,'enUS','I\'m your worst nightmare!','',26124),
(83173,'enUS','Gidwin and I were out fishing when those things showed up and attacked us.$b$bWe would be dead for sure if wasn\'t for these draenei.$b$bI would have killed them myself but somebody needed to carry Gidwin back to camp... foolish little dwarf.','',26124),
(83174,'enUS','All hell\'s broken loose out there!','',26124),
(83175,'enUS','That monster\'s loose!','',26124),
(83176,'enUS','You\'ve fallen right into my trap, \'commander\'. WARSONG ATTACK!','',26124),
(83177,'enUS','The botani are never this hostile.$b$bIf this keeps up we are going to have to venture into the bloom.','',26124),
(83178,'enUS','','Watch yourself, commander. Despite our victory, I have a bad feeling about this.',26124),
(83179,'enUS','','I\'ll see you at the gates of Grommashar.',26124),
(83180,'enUS','We need fish for the garrison, are you up to the task?','We need fish for the garrison, are you up to the task?',26124),
(83181,'enUS','Is that Frostwolf runt broken yet?','',26124),
(83182,'enUS','Tell that Frostwolf to keep shoveling! Hrah hrah hrah...','',26124),
(83183,'enUS','Don\'t let up on that Frostwolf pup. We must break his spirit.','',26124),
(83184,'enUS','Just get me free, stranger. I could kill a hundred of these pigs with this shovel alone.','',26124),
(83185,'enUS','I wish that all we had to deal with in Nagrand were the Warsong and Highmaul.$B$BThere\'s a whole world of hurt on the other side of the river.','',26124),
(83186,'enUS','Lead the charge against the genesaur, $n. The rangari will be right behind you.','',26124),
(83187,'enUS','I\'m not sure we could have defeated that genesaur without you. Until we meet again, $n.','',26124),
(83188,'enUS','Tread carefully, $c. This bloom is as deadly as it is beautiful.','',26124),
(83189,'enUS','Detonating the explosives... now!','Detonating the explosives... now!',26124),
(83190,'enUS','','We need to make sure no more travelers are attacked by the botani.$b$bArepheon just left with the others, if you leave now you should be able to catch up with him.',26124),
(83191,'enUS','How am I supposed to make any money if we just sit here all day?$b$bYeah, I know Gidwin looks a little sick, but I have a lot of merchandise I need to sell over here!','',26124),
(83192,'enUS','In my profession I have learned that the nature of crystals is very much like that of the Draenei people. \n\nThe core material has amazing potential, but begins as rough and heavily flawed. It is only through careful shaping and nurturing that its potential can truly be reached. \n\nOnly then can it show its magnificent beauty and wondrous clarity.','',26124),
(83193,'enUS','A Ravenous Bloodmaw is released from its pit!','',26124),
(83194,'enUS','Commander! Shadowmoon forces are gathering up outside of the garrison. Our troops are in defensive positions and await your orders.','',26124),
(83195,'enUS','He\'s just getting started!','',26124),
(83196,'enUS','You are most entertaining but there\'s no stopping the Breakers!','',26124),
(83197,'enUS','Don\'t fail me, Bulgorg, you are worth a hundred ogre warriors!','',26124),
(83198,'enUS','Come and get it!','',26124),
(83199,'enUS','I will break you!','',26124),
(83200,'enUS','Time for the meat grinder!','',26124),
(83201,'enUS','Give it to us raw... and wiggling!','',26124),
(83202,'enUS','So juicy!','',26124),
(83203,'enUS','That was close.','',26124),
(83204,'enUS','There is no turning back. We press on, through the very jaws of the beast.','',26124),
(83205,'enUS','Come here you scrawny grabbers!','',26124),
(83206,'enUS','All crunch and no meat.','',26124),
(83207,'enUS','Gonna make a Pale stew.','',26124),
(83208,'enUS','Lanky, gamey, little runts!','',26124),
(83209,'enUS','Get off! You ain\'t worth eatin\'.','',26124),
(83210,'enUS','Just a slice off the top.','',26124),
(83211,'enUS','Get the blood flowing!','',26124),
(83212,'enUS','Smash!','',26124),
(83213,'enUS','Looks like meat\'s back on the menu!','',26124),
(83214,'enUS','Let me browse your wares.','Let me browse your wares.',26124),
(83215,'enUS','Thanks for the rescue pal! I knew we shouldn\'t have tried to get out on a half-built zeppelin.','Thanks for the rescue pal! I knew we shouldn\'t have tried to get out on a half-built zeppelin.',26124),
(83216,'enUS','If you are okay, I\'m ready to go.','If you are okay, I\'m ready to go.',26124),
(83217,'enUS','You are finally here.  This place stinks, let\'s be done with this mess quickly...','',26124),
(83218,'enUS','Thanks! I\'m so glad to see a face that\'s not been covered in fungus!','Thanks! I\'m so glad to see a face that\'s not been covered in fungus!',26124),
(83219,'enUS','Thanks for the rescue pal. That crash was rough.','Thanks for the rescue pal. That crash was rough.',26124),
(83220,'enUS','That was a REAAAAAALY nice explosion! Wish I wasn\'t in the middle of it.','That was a REAAAAAALY nice explosion! Wish I wasn\'t in the middle of it.',26124),
(83221,'enUS','I think I broke every bone in my body. I think I even broke some bones that we don\'t have names for!','I think I broke every bone in my body. I think I even broke some bones that we don\'t have names for!',26124),
(83222,'enUS','The Heart of the Mountain goes berserk!','The Heart of the Mountain goes berserk!',26124),
(83223,'enUS','The wind will destroy you!','The wind will destroy you!',26124),
(83224,'enUS','The Warsong will eradicate you!','The Warsong will eradicate you!',26124),
(83225,'enUS','I will scatter your bones upon the wind!','I will scatter your bones upon the wind!',26124),
(83226,'enUS','I will be your death!','I will be your death!',26124),
(83227,'enUS','I am the storm!','I am the storm!',26124),
(83228,'enUS','The Warsong will prevail!','The Warsong will prevail!',26124),
(83229,'enUS','Victory or death!','Victory or death!',26124),
(83230,'enUS','My power will destroy you!','My power will destroy you!',26124),
(83231,'enUS','Draw upon the void! Feel the power seep into your bones!','Draw upon the void! Feel the power seep into your bones!',26124),
(83232,'enUS','Drink of the void my brothers and sisters! The Warsong grow stronger!','Drink of the void my brothers and sisters! The Warsong grow stronger!',26124),
(83233,'enUS','With this dark gift, none shall challenge the superiority of our clan!','With this dark gift, none shall challenge the superiority of our clan!',26124),
(83234,'enUS','Unleash the void! None shall resist the might of the Warsong!','Unleash the void! None shall resist the might of the Warsong!',26124),
(83235,'enUS','There is no glory in weakness! Bathe yourself in this dark power and become mighty!','There is no glory in weakness! Bathe yourself in this dark power and become mighty!',26124),
(83236,'enUS','Let this dark gift flow through your veins! Feel it grow within you!','Let this dark gift flow through your veins! Feel it grow within you!',26124),
(83237,'enUS','As mortals, you are weak! Drink of the void and become endowed with power!','As mortals, you are weak! Drink of the void and become endowed with power!',26124),
(83238,'enUS','Harness the power of the void! Call upon this gift and realize your true destiny!','Harness the power of the void! Call upon this gift and realize your true destiny!',26124),
(83239,'enUS','Oh good, it\'s you, commander. This \'thing\' is ready for you.','',26124),
(83240,'enUS','Usurper! I AM the Talon King!','',26124),
(83241,'enUS','The blood of Sethe is a gift, not a curse! We will show them all!','',26124),
(83242,'enUS','Terokk...','',26124),
(83243,'enUS','The Sethekk will rise!','',26124),
(83244,'enUS','For Talon King Ikiss!','',26124),
(83245,'enUS','I have seen the other side...','',26124),
(83246,'enUS','Rukhmar has forsaken us.','',26124),
(83247,'enUS','Your entrails will make a fine tribute to Sethe.','',26124),
(83248,'enUS','Ikiss demands sacrifice!','',26124),
(83249,'enUS','We live for Sethe now!','',26124),
(83250,'enUS','Stealth and speed are our greatest friends.','',26124),
(83251,'enUS','My rangari are the absolute best at laying traps and creating camouflaged illusions. The Shadowmoon have no idea we are here.','',26124),
(83252,'enUS','','The Shadowmoon are an ancient clan with untold knowledge of this world and its secrets. If only we had access to their records!',26124),
(83253,'enUS','','There is one thing you must learn about us draenei.$B$BWe will learn everything we can from others, and use it to our advantage.',26124),
(83254,'enUS','Kneel before the Sethekk!','',26124),
(83255,'enUS','Who knew the draenei held such... delicious treasures in their temple?','',26124),
(83256,'enUS','Do you dare challenge me, defenders of Auchindoun?!','',26124),
(83257,'enUS','Sever my bonds... and the portal falls...','',26124),
(83258,'enUS','Such decadence... it will all burn.','',26124),
(83259,'enUS','Yes... Yes!','',26124),
(83260,'enUS','Grommash will pay for his arrogance.','',26124),
(83261,'enUS','The legion comes for you.... We will feast on these souls.','',26124),
(83262,'enUS','Do not delay, mortal. I can feel the life-essence of your armies fading. There will be time for regret later...','',26124),
(83263,'enUS','We will meet again... $n.','',26124),
(83264,'enUS','Gul\'dan, such foolishness. This gift... so much more than you could ever know....','',26124),
(83265,'enUS','Long have I waited...','',26124),
(83266,'enUS','...hungered... to be more...','',26124),
(83267,'enUS','On one side, our enemy, the Warsong. On the other, our more ancient foe, the ogres of Highmaul.$B$BWe must bring both to justice. We must rid Nagrand of their very presence.','',26124),
(83268,'enUS','And now, all shall bow before me!','',26124),
(83269,'enUS','This power... you will be the first to know it.','',26124),
(83270,'enUS','Iruun... You battled demons in life... in death, your power will feed them!','',26124),
(83271,'enUS','Joraa, paragon of Order - I shall twist your soul to power destruction!','',26124),
(83272,'enUS','Elum... a liftetime of healing, now you shall fuel disease and decay!','',26124),
(83273,'enUS','All will fall before me.','',26124),
(83274,'enUS','Fear my name.','',26124),
(83275,'enUS','Destruction!','',26124),
(83276,'enUS','Wither away!','',26124),
(83277,'enUS','I... become... something greater!','',26124),
(83278,'enUS','Die!','',26124),
(83279,'enUS','Your demise awaits.','',26124),
(83280,'enUS','Quickly, now!','',26124),
(83281,'enUS','More! I... need... more!','',26124),
(83282,'enUS','The bonds weaken. Freedom will be mine!','',26124),
(83283,'enUS','','Go\'el thinks that I should have stayed back on Azeroth with our children. I have put him in his place on that matter.$B$BMy Go\'el and I have been through much together. Now is not the time for us to be apart.$B$BTo be back in Nagrand after all of this time. It\'s a bit overwhelming for us both.$B$BI just wish for us to both get back to our little ones once this is all over.',26124),
(83284,'enUS','','Earth Mother willing, you and the shadow hunters will expel the Warsong from Telaar.',26124),
(83285,'enUS','Everyone - find cover!','',26124),
(83286,'enUS','We must defeat the ogres, the Burning Blade, and the orcs at Lok-rath. Then, we\'ll be ready to move on Grommashar.','',26124),
(83287,'enUS','As if all we had to deal with in Nagrand were the Warsong and Highmaul.$B$BThere\'s a whole world of pain on the other side of that river.','',26124),
(83288,'enUS','Commander.$B$BWe\'ve secured Lok-rath and the Warsong.$B$BI await your orders.','',26124),
(83289,'enUS','All hell\'s broken loose out there!','',26124),
(83290,'enUS','Watch yourself, commander. Despite our victory, the Warsong are never to be underestimated.','',26124),
(83291,'enUS','Oh good, it\'s you, commander. This \'thing\' is ready for you.','',26124),
(83292,'enUS','I\'ll see you at the gates of Grommashar.','',26124),
(83293,'enUS','That monster\'s loose!','',26124),
(83294,'enUS','I will slice the flesh from your bones!','',26124),
(83295,'enUS','We will feed your corpse to the Kaliri!','',26124),
(83296,'enUS','Move faster ground dweller!','',26124),
(83297,'enUS','Your doom is coming.','',26124),
(83298,'enUS','You cannot outrun the wind!','',26124),
(83299,'enUS','I... perish....','',26124),
(83300,'enUS','As long as we rule the skies, none shall oppose us!','',26124),
(83301,'enUS','We will cast you down like the mongrels you are!','',26124),
(83302,'enUS','You are unfit to rise to this height, return to your filth below!','',26124),
(83303,'enUS','What funny little birds, you have no wings!','',26124),
(83304,'enUS','Cast them down, let the scavengers below feed on their pulp!','',26124),
(83305,'enUS','Servants, protect your master!','',26124),
(83306,'enUS','We will always... soar....','',26124),
(83307,'enUS','As long as we rule the skies you will always be beneath us!','',26124),
(83308,'enUS','Behold the might of the Arakkoa!','',26124),
(83309,'enUS','','My brothers and sisters will be watching from the shadows, we will aid you when we can.',26124),
(83310,'enUS','','Those poor riverbeasts...',26124),
(83311,'enUS','','Thaelin? What are you doing here?',26124),
(83312,'enUS','','Giving away our position. The fool brought a genesaur down on us.',26124),
(83313,'enUS','It\'s okay, Gidwin. You are going to be okay.','',26124),
(83314,'enUS','','Please let me know if there is anything I can do to repay you.',26124),
(83315,'enUS','','Take care if you plan on roaming the plains, traveler. The windfang packs have been particularly dangerous of late.',26124),
(83316,'enUS','Kill them. Kill them all.','',26124),
(83317,'enUS','Those plants are lucky I don\'t have my shears on me...','',26124),
(83318,'enUS','Seek me out inside Blademoon Bloom. It is time we put a stop to this.','',26124),
(83319,'enUS','I heard Zorkra and her followers barely made it into Talador before orcs got them.','',26124),
(83320,'enUS','Perhaps we should have thrown our lot in with Ikiss...','',26124),
(83321,'enUS','All this talk about poison and paralysis is not helping my sales. Gidwin can be so rude sometimes.','',26124),
(83322,'enUS','Hey you wanna buy some stingtail eye drops before you head out? They are great for reading at night and almost never cause blindness.','',26124),
(83323,'enUS','Nonsense! I\'d sooner die than bend knee to that lunatic.','',26124),
(83324,'enUS','What do we have here? A hero? Gorgrond is no place for heroes, my friend.','',26124),
(83325,'enUS','What then? Join Iskar\'s fool crusade and stand up to the Adherents?','',26124),
(83326,'enUS','We\'d only get in his way.','',26124),
(83327,'enUS','We are unaccustomed to having so many with us. Our rangari are trained to be self sufficient, and are used to surviving for long periods of time in the wilds.$b$bYou may find some of us prefer it that way.','',26124),
(83328,'enUS','MASTER! I COME FOR YOU!','',26124),
(83329,'enUS','For now, we disappear. Disappear and survive.','',26124),
(83330,'enUS','It is unwise to draw the attention of the genesaur and their fara. In their eyes, we are nothing more than plant food.','',26124),
(83331,'enUS','Graaagh! KAHL...  AHK... RAAHHHH!','',26124),
(83332,'enUS','Ah, an exotic traveler from the north. Come, have a look at my wares!','',26124),
(83333,'enUS','Don\'t take too long, I don\'t share skulls!','',26124),
(83334,'enUS','Test 1 | Caster: %s  | Target: $n','Test 1 | Caster: %s  | Target: $n',26124),
(83335,'enUS','How exactly did you get to Draenor, anyway?','How exactly did you get to Draenor, anyway?',26124),
(83336,'enUS','','Oh, that? I may have hitched a ride through your garrison portal. \n\nThey should probably guard those things better, come to think of it.',26124),
(83338,'enUS','They fired on Veil Akraz!','',26124),
(83339,'enUS','It\'s just... gone...','',26124),
(83340,'enUS','Come, we must go!','',26124),
(83341,'enUS','','I have lost both my sister and my mentor, and yet I know there are others who suffer even more greatly.$B$BIt is for them that I must go on.',26124),
(83342,'enUS','','Prophet Velen was truly a great teacher. I will remember him, always.',26124),
(83343,'enUS','','There is so much to do. We must stay focused.',26124),
(83344,'enUS','','I am very thankful that you are here, $n. You are one of the few people I know I can trust.',26124),
(83345,'enUS','Trade is the backbone of Embaari Village. As a representative of the tradesmen of our village, it falls under my responsibility to keep these operations running smoothly.','',26124),
(83346,'enUS','','The skies hold untold wonders, waiting to be discovered. Our researchers study the stars and beyond over at the observatory. \n\nIf you have time, traveler, I would recommend paying it a visit.',26124),
(83347,'enUS','','The ranchers of Embaari raise elekk and talbuk to supply Shattrath, as well as many of the smaller draenei villages. \n\nIf you wish to review the livestock, you can find their ranches along the outskirts of the village.',26124),
(83348,'enUS','','Don\'t mind all of the noise and dust, commander.$B$BWhat can I get for you? Food? Drink? A place to put your feet up?',26124),
(83349,'enUS','Blessings of the naaru upon you, my friend.$B$BIs it not strange to be back on Draenor? I would not have guessed in a million years I would have ever returned.','',26124),
(83350,'enUS','This is test 1','This is test 1',26124),
(83351,'enUS','This is test 2','This is test 2',26124),
(83352,'enUS','I must break you!','I must break you!',26124),
(83353,'enUS','Garrison - Event - Orc Attack Sub Stage Begin','',26124),
(83354,'enUS','... the Lost Spirit fades away.','',26124),
(83355,'enUS','An |c00FFFF00|Hspell:178360|h[Alliance Captain]|h|r has joined the battle','',26124),
(83356,'enUS','A |c00FFFF00|Hspell:178361|h[Horde Captain]|h|r has joined the battle','',26124),
(83357,'enUS','Do not lose faith Alliance; I shall aid you in your cause.','',26124),
(83358,'enUS','','When I get my hands on him...',26124),
(83359,'enUS','','We\'ll see who gets the last laugh.',26124),
(83360,'enUS','Sorcerous fool! I alone am the key to this portal.','',26124),
(83361,'enUS','Set me free, or your precious world will burn.','',26124),
(83362,'enUS','Gul\'dan! Khadgar - they\'ve got Gul\'dan here.','',26124),
(83363,'enUS','He\'s in chains.','',26124),
(83364,'enUS','Good! That\'s where he belongs. Don\'t listen to a word he says.','',26124),
(83365,'enUS','Ah, Skyreach. I have not been this close to her in many years.','',26124),
(83366,'enUS','The High Sage will be well protected. We can fly no closer.','',26124),
(83367,'enUS','Destroy their false sun, that we may meet again in the shade.','',26124),
(83368,'enUS','The bones do not lie. They showed me fire, and then nothing!','',26124),
(83369,'enUS','The omens are clear! Skettis is doomed!','',26124),
(83370,'enUS','Abominations, all of us! Throw yourselves before Rukhmar and beg for the cleansing fire!','',26124),
(83371,'enUS','Rukhmar! Hear your forlorn children! Pray, rid us of this wretched form!','',26124),
(83372,'enUS','What the? Aaaaaaaaah!','',26124),
(83373,'enUS','Goblin! You better be finishing up.  Railmaster Rocketspark is almost finished patching up the Grimrail.','',26124),
(83374,'enUS','Come on ya runts.  I don\'t need anyone else breathin\' down my neck!','',26124),
(83375,'enUS','Do you feel that?','',26124),
(83376,'enUS','You are wrong. It is the Burning Blade that is not worthy of me.','',26124),
(83377,'enUS','Leave nothing alive!','',26124),
(83378,'enUS','Eat, you stupid creatures. Eat it all!','',26124),
(83379,'enUS','Stop rolling around that thing and just eat it!','',26124),
(83380,'enUS','Sergeant, a gronn is marching toward our garrison. It\'ll be here in minutes!','Sergeant, a gronn is marching toward our garrison. It\'ll be here in minutes!',26124),
(83381,'enUS','Rise up, Frostwolves! Avenge the murder of your Chieftain, and reclaim the honor of our clan!','',26124),
(83382,'enUS','Come, my brothers and sisters! We will bring justice to our dead by sending these orcs to the darkness beyond!','',26124),
(83383,'enUS','A revenge assault, eh?  Scout, sound the Call to Arms! Get the peons inside!','',26124),
(83384,'enUS','If there\'s a gronn coming, then goren won\'t be far. Quick, get the peons to high ground!','',26124),
(83385,'enUS','We don\'t have much more time! Everyone, get to high ground!','',26124),
(83386,'enUS','Free at last.','',26124),
(83387,'enUS','I swear, by the spirit of my father, I WILL MAKE THEM PAY.','',26124),
(83388,'enUS','Gah!','',26124),
(83389,'enUS','Ugh - oh!','',26124),
(83390,'enUS','Well now.','',26124),
(83391,'enUS','I\'d say we made an impact.','',26124),
(83392,'enUS','The fungus keeps creeping in but we have to keep burning it back. It\'s like celebrating Fire Festival every day; I love it!','',26124),
(83393,'enUS','You here to register for fire duty or what?','',26124),
(83394,'enUS','Eleena\'s a fine lass. I\'m sure she\'s just takin\' her sweet time gettin\' a proper look-see at them ogres.','',26124),
(83395,'enUS','','Wolf-$g brother:sister;, it is always good to see you.$B$BIt has been many years since last I strode the great Land of Winds. Yet some things, never change.$B$BThe Warsong are as dishonorable as ever, and now worse with this Garrosh Hellscream as their new warlord.$B$BI understand you have had trouble with him before. We shall have to see about dealing with him.$B$BBringing Garrosh to justice is just about the only thing that Thrall talks about.',26124),
(83396,'enUS','That was really mean, $n. I\'m not sure I can forgive you and Yrel after that.$B$B...$B$BAh, who am I kidding? I guess I had it coming.$B$BIt was a pretty good prank, don\'t ya think?$B$BI need to figure out what the next one\'s going to be. She\'ll never see it coming.','',26124),
(83397,'enUS','There she goes...','',26124),
(83398,'enUS','...wait for it...','',26124),
(83399,'enUS','KER-PLOW!','',26124),
(83400,'enUS','Ohhh, weren\'t that the prettiest thing?','',26124),
(83401,'enUS','The Laughing Skull fighting technique is a delicate balance of stabbing your enemy until long after they are dead while also laughing in a fine tuned insulting fashion.','',26124),
(83402,'enUS','You do the fightin\' and I\'ll do the fixin\'. Now let\'s get up on that tank!','',26124),
(83403,'enUS','Look back there. I think we can climb up those chains.','',26124),
(83404,'enUS','I see the controls!','',26124),
(83405,'enUS','Orcs off the starboard bow!','',26124),
(83406,'enUS','Looks like we arrived just in time.','',26124),
(83407,'enUS','$n! Hop inta that turret and keep \'em away!','',26124),
(83408,'enUS','How do I get materials?','How do I get materials?',26124),
(83409,'enUS','Hey... I\'m a versatile goblin. I can build out of almost anything. You find treasure lying about or some extra mean monsters with a nice hoard of loot, chances are there will be extra materials I can use.$b$bI\'ve been hearing of all sorts of rare beasts around here that might stash materials you could use. Not to mention I\'m pretty sure Lady Sena skimmed off the top and stashed those extra materials around your garrison somewhere.$b$bGet out and explore.','',26124),
(83410,'enUS','WARSONG, WE RIDE.','',26124),
(83411,'enUS','Eh? A traveler? It\'s a dangerous time to be in Skettis, you know.','',26124),
(83412,'enUS','\"Shadows gather...\"','\"Shadows gather...\"',26124),
(83413,'enUS','Azik sent you to me for answers, and I promise you will have them.$B$BBut for now, we need to escape.','',26124),
(83414,'enUS','COMMANDER $N. WARRIDERS ATTACK!','',26124),
(83415,'enUS','You want to know why my people flee Arak? Look outside. Our own kin fear and revile us for this curse!','',26124),
(83416,'enUS','The mountain of Oshu\'gun stands tall above the valley of Nagrand. This place is sacred among all orc clans, but now the Warsong have claimed it as their own.','',26124),
(83417,'enUS','Make it look real, or they are going to flood this place with ogres.','',26124),
(83418,'enUS','You win this round. But when we fight in the \"real\" arena, I will end you.','',26124),
(83419,'enUS','You... were going to save me? Ha.','',26124),
(83420,'enUS','Are you a savior or a challenger?','',26124),
(83421,'enUS','Challenge the gladiator.','Challenge the gladiator.',26124),
(83422,'enUS','Tell me of the defense of Lion\'s Landing.','Tell me of the defense of Lion\'s Landing.',26124),
(83423,'enUS','Tell me of the defense of Domination Point.','Tell me of the defense of Domination Point.',26124),
(83424,'enUS','To arms! To your posts! And look beneath you. They\'ll come from below....','',26124),
(83425,'enUS','Tell Akaani I will be ready for her signal.','',26124),
(83426,'enUS','I see Akaani left a mark on your cloths. So the time has finally come to make our escape?','',26124),
(83427,'enUS','Fight me. Do not let the ogres witness weakness.','',26124),
(83428,'enUS','Enough! This not real arena.','',26124),
(83429,'enUS','Dead dead dead.','',26124),
(83430,'enUS','I wait for Akaani\'s signal.','',26124),
(83431,'enUS','Free at last! Join me in the ogre mound when you are done, and we shall slay the ogre chieftain together.','',26124),
(83432,'enUS','You saved my life. Now I must repay the debt. I will teach you tricks and ways of fighting only seen in the darkest corners of Skettis.','',26124),
(83433,'enUS','That\'s a cute child\'s toy of a weapon you got there. Let\'s see what it can do against my orcish fists!','',26124),
(83434,'enUS','I laugh in the face of my own defeat!','',26124),
(83435,'enUS','You call that a fighting style? Ha ha ha!','',26124),
(83436,'enUS','Oh, and yes, I suppose I can wait for her signal.','',26124),
(83437,'enUS','Run back to Akaani and tell her I will rip this place apart, burn it to the ground, and laugh at the corpses of all the ogres!','',26124),
(83438,'enUS','You know what I hate about the arena?$b$bThe losers!$b$bThey keep dying so quickly. It is embarrassing. I barely have time to finish giving them a proper smile...','',26124),
(83439,'enUS','Got one!','Got one!',26124),
(83442,'enUS','...get back!','...get back!',26124),
(83443,'enUS','Profession Building Blueprint','Profession Building Blueprint',26124),
(83444,'enUS','I am ready, commander. Where would you like to start?','I am ready, commander. Where would you like to start?',26124),
(83445,'enUS','I am... THE SHOVELER!','I am... THE SHOVELER!',26124),
(83446,'enUS','A %s cries out incoherently and rushes up the ramp.','',26124),
(83447,'enUS','Back to the dust with you!','',26124),
(83448,'enUS','<The creature is still alive, but is completely incapacitated by the Iron Horde\'s chains.>','',26124),
(83449,'enUS','Release the creature from its chains.','Release the creature from its chains.',26124),
(83452,'enUS','','Wait! Spare me and I will tell you what you want to know!',26124),
(83453,'enUS','Go on.','Go on.',26124),
(83455,'enUS','','The Breaker Artifact. We have located it! It is deep within Ogron Grotto west of this location. We were going to take it from them before this camp was destroyed.',26124),
(83456,'enUS','Get out of my sight.','Get out of my sight.',26124),
(83457,'enUS','We must go.  I am so close now...  I must find it.','',26124),
(83458,'enUS','What a nightmare!','Thank you - the whole mine is overrun!',26124),
(83459,'enUS','It\'s the resonance crystal - it\'s driving them crazy!','It\'s the resonance crystal - it\'s driving them crazy!',26124),
(83460,'enUS','Garrison - Attack - 1.1 Complete','',26124),
(83461,'enUS','What is this? A new challenger? We will enjoy watching you consumed by my little pet.','',26124),
(83462,'enUS','','The Archmage tells me that Garrosh set all of these events in motion. He was a criminal from your world, yes? I have never seen the orcish idea of \'justice\' before.$B$BI wish I could say it\'s over, but this war is only beginning. Grommash\'s Iron Horde continues to grow stronger. My people will never be safe so long as his foundries continue churning out their terrible weapons. We draenei were not ready for this fight, but we must be prepared to finish it.$B$BThere are shadows before us - but only because the light is at our back.',26124),
(83463,'enUS','A meager victory. Let us see how you fair against my personal ogron.','',26124),
(83464,'enUS','','We march on your order, commander. Garrosh and his forces await.',26124),
(83465,'enUS','Such impudence. I will see you consumed by my favorite pet.','',26124),
(83466,'enUS','That was my favorite ravager. You filthy savage. I will kill you with my own bare hands!','',26124),
(83467,'enUS','Our forces are massed. We\'re ready to strike.$B$BLead the way, commander. Let us be rid of this Garrosh Hellscream once and for all.','',26124),
(83468,'enUS','Garrosh came out of nowhere, and manipulated the clans as you would play a drum. It is good that he is finished.$B$BBut, the damage is already done. It\'s like I don\'t recognize my own people anymore. Grommash Hellscream has turned family and friends alike against one another, and it has to stop. We must dismantle his war machine: First by taking out his ogre allies, then by demolishing the Blackrock Foundry.$B$BAfter that, we will bring Hellscream himself to justice. Just as we\'ve seen today.','',26124),
(83469,'enUS','It looks as if the Iron Horde attempted to fuse a cannon with this gronn\'s spine.','',26124),
(83470,'enUS','Molten helms don\'t fit on gronn as well as one might think.','',26124),
(83471,'enUS','A cannon for an arm and explosives on the back? Seriously?','',26124),
(83472,'enUS','<Thrall is deep in thought and doesn\'t appear to want to speak at the moment.>','',26124),
(83473,'enUS','','My husband takes all the responsibility of the world on his shoulders, as if it\'s his burden alone. He needs to learn that we all have a role to play.$B$BFriend, this whole world remains in turmoil. The elements cry out. They are being tortured in the depths of the Blackrock foundry, and Gul\'dan is still at large.$B$BSo much remains to be done... and the stronghold you\'ve built is the key. Never hesitate to call on me for aid. This is my fight, too.',26124),
(83474,'enUS','Take me to my base in Talador.','Take me to my base in Talador.',26124),
(83475,'enUS','Note the information.','Note the information.',26124),
(83476,'enUS','Split up and meet back at Akaani and Kash\'drakor. Kor\'gall\'s axe is yours for the taking, $p.','',26124),
(83477,'enUS','The storied Gorehowl rests here planted firmly in the grassy hill. At your touch, a barely-noticeable power vibrates from the axe.','',26124),
(83478,'enUS','Remember the Battle at the Stones of Prophecy.','Remember the Battle at the Stones of Prophecy.',26124),
(83479,'enUS','Take cover within the shield!','',26124),
(83480,'enUS','Hold \'em off! I\'ll get this Iron Star activated!','',26124),
(83481,'enUS','I got this!  Keep them off me!','',26124),
(83482,'enUS','Prepare for a little goblin ingenuity!','',26124),
(83483,'enUS','Ow ow ow! You\'ll pay for that!','',26124),
(83484,'enUS','Pinchwhistle Point is a nice town as long as you don\'t mind the heat and the oppressive humidity.$b$bOk, as long as you don\'t mind the heat, the oppressive humidity, and the infectious fungus.','',26124),
(83485,'enUS','Pinchwhistle Point can\'t be lost, I got to find a cure!','',26124),
(83488,'enUS','The mines are overrun!','The mines are overrun!',26124),
(83503,'enUS','Commander, reinforcements from the arcane sanctum have arrived!','',26124),
(83504,'enUS','Gather Shelly\'s report.','Gather Shelly\'s report.',26124),
(83505,'enUS','','Where did Pippers go? Little guys keeps stealing my supplies.$b$bOops! I meant to check in with Baros, we have just been really busy.$b$bThis forest is almost out of wood... I need to get a logging operation together. I\'ll send a full report to Baros as soon as possible.',26124),
(83506,'enUS','Take cover within the shield!','',26124),
(83511,'enUS','I need a flight to the border of Nagrand.','I need a flight to the border of Nagrand.',26124),
(83512,'enUS','A Hungry Goren ate his fill! (-$9168w)','',26124),
(83513,'enUS','Goren engorged: $9169w (-$9170w)','',26124),
(83514,'enUS','Strike!','',26124),
(83515,'enUS','Heavy strike!','',26124),
(83516,'enUS','Now, block!','',26124),
(83517,'enUS','Nice work, soldiers.','',26124),
(83518,'enUS','I tire of this. Begone!','',26124),
(83519,'enUS','I... am... king...','',26124),
(83520,'enUS','I will meet you at the base of the fortress.','',26124),
(83521,'enUS','Learn your place.','',26124),
(83522,'enUS','Your presence bores me.','',26124),
(83523,'enUS','My power knows no limit!','',26124),
(83524,'enUS','You have earned my wrath!','',26124),
(83525,'enUS','The arcane bends to my will, as shall you!','',26124),
(83526,'enUS','Come, see the error of your ways.','',26124),
(83527,'enUS','Begone from my sight.','',26124),
(83528,'enUS','I command the arcane!','',26124),
(83529,'enUS','','I\'ll meet you at the base of the fortress.',26124),
(83530,'enUS','Imperator Gor\'vidus laughs.','',26124),
(83531,'enUS','','Oh, come on! It\'s just a little spider!',26124),
(83532,'enUS','','This thing keeps wriggling! Could you please come give me a hand?!',26124),
(83533,'enUS','','I could use a little help over here, Hostus.',26124),
(83534,'enUS','A little spider?! Do you have eyes?','',26124),
(83535,'enUS','Nope nope nope nope!','',26124),
(83536,'enUS','Well, I could use a lot less spiders over here, Liveia!','',26124),
(83537,'enUS','We were lookin\' for something to help fight goren and I got separated.$b$bThen these botani lads showed up and just started feeding me berries, mead, honey.$b$bI swear I\'ve gained twenty pounds at least since I got here.','',26124),
(83538,'enUS','They are fattening you up. Your friends have been turned into mulch to feed the botani seedlings.','They are fattening you up. Your friends have been turned into mulch to feed the botani seedlings.',26124),
(83539,'enUS','A rescue? At last! I\'m never eatin\' another fruit again.','',26124),
(83540,'enUS','Thank you, kindly. I shall notify you of my results later.','',26124),
(83541,'enUS','D\'kaan, where are those parts? I\'ve only got two hands over here.','',26124),
(83542,'enUS','Good luck, commander.','',26124),
(83543,'enUS','','What do you want, initiate?',26124),
(83544,'enUS','','Only the strong prevail.',26124),
(83545,'enUS','','We ARE the chosen race.',26124),
(83546,'enUS','','The Sargerei will reclaim what is rightfully ours.',26124),
(83547,'enUS','Reporting for duty!','Reporting for duty!',26124),
(83548,'enUS','This is where they\'ll attack first...','',26124),
(83549,'enUS','','Welcome, initiate. Those who wish to join our order must prove themselves. You look... promising.',26124),
(83550,'enUS','As long as you hold the shaman stone, we will be able to speak with one another through the power of the elements.$b$bThe stone also grants me the ability to see the world through your eyes.','',26124),
(83551,'enUS','They\'re coming...','',26124),
(83552,'enUS','<Laanda lowers his voice to a whisper.>$B$BYou have the appearance of an ally, but I cannot speak long. I am working to infiltrate the ranks of the Sargerei, to take down their system from within. So far, no one suspects my identity.','',26124),
(83553,'enUS','The rain falls on Shadowmoon.','The rain falls on Shadowmoon.',26124),
(83554,'enUS','Modera sends her regards.','Modera sends her regards.',26124),
(83555,'enUS','The elekk is nature\'s most noble animal.','The elekk is nature\'s most noble animal.',26124),
(83556,'enUS','The portal has taken me into the Twisting Nether, Farseer.','The portal has taken me into the Twisting Nether, Farseer.',26124),
(83557,'enUS','You think so, do you?','',26124),
(83558,'enUS','Who is that?','',26124),
(83559,'enUS','I see. I am prepared for stormy weather.','',26124),
(83560,'enUS','','I did it, Papa! I made a wish!',26124),
(83561,'enUS','What is this $r doing here?','What is this $r doing here?',26124),
(83562,'enUS','Finalizing','Finalizing',26124),
(83563,'enUS','$p saved what is left of Aruuna. Let $Ghim:her; leave in peace.','',26124),
(83564,'enUS','Collapsing Portal','Collapsing Portal',26124),
(83565,'enUS','The day has come for true retribution!','',26124),
(83566,'enUS','What you think you doing?','',26124),
(83567,'enUS','It dinna matter where we are. SI:7 is gonna get the job done.','',26124),
(83568,'enUS','For da Empire!','',26124),
(83569,'enUS','Die puny thing!','',26124),
(83570,'enUS','I must find a way to enhance my performance for next time.','',26124),
(83571,'enUS','At last practice is over! Taste dis axe!','',26124),
(83572,'enUS','Reglakk says no complications... you is a complication.','',26124),
(83573,'enUS','But my research!  Reglakk... needs... it...','',26124),
(83574,'enUS','Me guess me need more practice...','',26124),
(83575,'enUS','I hope you Horde scum enjoy a shield to the face!','',26124),
(83576,'enUS','Hmm, I never had this problem in Alterac Valley.','',26124),
(83577,'enUS','Your magic is powerless here!','',26124),
(83578,'enUS','I am finished with you!','',26124),
(83579,'enUS','Impossible...','',26124),
(83580,'enUS','AHHHHHH!','',26124),
(83581,'enUS','YOU WILL PAY FOR THIS!!!','',26124),
(83582,'enUS','AHHHHHH!','',26124),
(83583,'enUS','For... The Highmaul...','',26124),
(83584,'enUS','You dare enter these halls?','',26124),
(83585,'enUS','Worthless.','',26124),
(83586,'enUS','Weak.','',26124),
(83587,'enUS','Your efforts were in vain!','',26124),
(83588,'enUS','Silence!','',26124),
(83589,'enUS','Quiet!','',26124),
(83590,'enUS','Broken.','',26124),
(83591,'enUS','The Highmaul will end you.','',26124),
(83592,'enUS','Your attacks are weak!','',26124),
(83593,'enUS','I will crush you!','',26124),
(83594,'enUS','I will tear you in half!','',26124),
(83595,'enUS','I am unstoppable.','',26124),
(83596,'enUS','Get out!','',26124),
(83597,'enUS','I am in control here.','',26124),
(83598,'enUS','We control the flow of power here.','',26124),
(83599,'enUS','That can\'t be all of them.','',26124),
(83600,'enUS','Spread out! Protect the structures!','',26124),
(83601,'enUS','You can\'t stop me!  I will make our Breakers even stronger!','',26124),
(83602,'enUS','Someone else will finish my research!','',26124),
(83603,'enUS','I will eat your Wind magic all up!','',26124),
(83604,'enUS','No... wind magic?','',26124),
(83605,'enUS','I would like to place a work order.','I would like to place a work order.',26124),
(83606,'enUS','I will send you dogs to the void!','',26124),
(83607,'enUS','My return will be your end.','',26124),
(83608,'enUS','I have laid out a list of available missions for your forces on the command table for you.$B$BI will relay any orders to your garrison for your convenience, commander.','',26124),
(83609,'enUS','I\'ve spread out all available missions for your forces on the command table.$B$BSay the word and I will send a courier to your garrison immediately with your will.','',26124),
(83610,'enUS','Are you prepared to meet Azeroth\'s greatest champion?!','',26124),
(83611,'enUS','Not goren one!','',26124),
(83612,'enUS','Abuuuguu!','',26124),
(83613,'enUS','Bwaaaah!','',26124),
(83614,'enUS','Guuughfff!','',26124),
(83615,'enUS','Ooohuuffuu!','',26124),
(83616,'enUS','Eeeeeerk!','',26124),
(83617,'enUS','Yeeeooowwwch!','',26124),
(83618,'enUS','The goren mumbles something incomprehensible to you.','',26124),
(83619,'enUS','I\'ve been watching you, $r. Come closer.','',26124),
(83620,'enUS','I foresee... your defeat.','',26124),
(83621,'enUS','Look into the maw of your demise!','',26124),
(83622,'enUS','I see everything... your time on this world ends here.','',26124),
(83623,'enUS','','Not a moment too soon, this ogre bastion is much busier than it used to be.$b$bLet\'s do something about it, yes?',26124),
(83624,'enUS','Engorged seeds and roots within the pool are digging into the corpse of Lera, feeding on the remains.','Engorged seeds and roots within the pool are digging into the corpse of Lera, feeding on the remains.',26124),
(83625,'enUS','','This area is back to normal thanks to you!',26124),
(83626,'enUS','It will be a pleasure to break you.','',26124),
(83627,'enUS','First, I break your spirit, then, I sell your future.','',26124),
(83628,'enUS','Burn!','',26124),
(83629,'enUS','You will be slaves to the slag!','',26124),
(83630,'enUS','The elements hear me and obey!','',26124),
(83631,'enUS','Your charred remains will make a fine example.','',26124),
(83632,'enUS','Fool!','',26124),
(83633,'enUS','You will learn to obey!','',26124),
(83634,'enUS','You will never... be... free...','',26124),
(83635,'enUS','Bring them to me alive, Roltall. They will fetch an excellent price.','',26124),
(83636,'enUS','A stunned look of surprise is frozen on the dead face of this dwarf.','A stunned look of surprise is frozen on the dead face of this dwarf.',26124),
(83637,'enUS','This dwarf appears to have gained a lot of weight prior to his death.','This dwarf appears to have gained a lot of weight prior to his death.',26124),
(83638,'enUS','C\'mon people step it up here. We got hungry bellies to fill.','',26124),
(83639,'enUS','Dat new kind! Da Keeper keep it!','',26124),
(83640,'enUS','Sir, commander, sir!$b$bOn Maraad\'s orders I rounded up a bunch of lackeys - erm - quality skilled labor. Say the word and we\'ll get this caravan to Elodor and secure some food.','',26124),
(83641,'enUS','Very good, Zipfizzle. Move out.','Very good, Zipfizzle. Move out.',26124),
(83642,'enUS','Hey! You don\'t belong here! Vexaar, tell Laanda that we have a traitor in our midst.','Hey! You don\'t belong here! Vexaar, tell Laanda that we have a traitor in our midst.',26124),
(83643,'enUS','You are all annoying.  I\'m going to go get some sleep.','',26124),
(83644,'enUS','You heard the commander. MOVE OUT! Go, go!','',26124),
(83645,'enUS','Commander! You have built a most impressive garrison. I am eager to see your men in action.','',26124),
(83646,'enUS','We were fools to follow Velen\'s path. Socrethar is our true leader!','',26124),
(83647,'enUS','Hey buddy, let\'s talk about what you saw.','Hey buddy, let\'s talk about what you saw.',26124),
(83648,'enUS','You\'ll find our Alliance is full of surprises, Exarch. This is the commander I told you about.','',26124),
(83649,'enUS','We will escort this caravan and meet you in Elodor, commander.','',26124),
(83650,'enUS','Ah. The little one is the taskmaster.','',26124),
(83651,'enUS','I will rend the mortal flesh from your bones and feast upon your soul!','',26124),
(83652,'enUS','Talking won\'t do any good. I know what I saw!','',26124),
(83653,'enUS','In fact, I\'ll take care of you myself. Zamaya is bound to promote me for this!','',26124),
(83654,'enUS','The draenei will not go free!','The draenei will not go free!',26124),
(83655,'enUS','You\'ll rot with the draenei.','You\'ll rot with the draenei.',26124),
(83656,'enUS','You\'ll free the draenei over my corpse, whelp.','You\'ll free the draenei over my corpse, whelp.',26124),
(83657,'enUS','Did you see the size of that thing? It\'s even bigger than I thought.','',26124),
(83658,'enUS','It took Talakuu. The fool got too close to the entrance of the cave.','',26124),
(83659,'enUS','I don\'t even think it\'s possible to kill it. I mean, it\'s made of dirt and stone.','',26124),
(83660,'enUS','You go first.','',26124),
(83661,'enUS','Yeah ummm... I just need to adjust my gloves really quick.','',26124),
(83662,'enUS','It seems like most of the earthfuries are coming out of this cave.','',26124),
(83663,'enUS','By the Light! You truly are a great champion.','',26124),
(83664,'enUS','Orgrim! Brother, what have you done?','',26124),
(83665,'enUS','Brother? You have allied with enemy invaders, Durotan. You\'ve chosen your side.','',26124),
(83666,'enUS','Can you not see it? The Iron Horde will destroy Draenor!','',26124),
(83667,'enUS','My visions show me otherwise.','',26124),
(83668,'enUS','Commander, I will meet you ahead. I must join Draka.','',26124),
(83669,'enUS','With me!','',26124),
(83670,'enUS','Maybe those orcs have something on that boat we can use?... besides tooth piercing devices.','',26124),
(83671,'enUS','Eww, some of these supplies are really water logged and... sticky? These will get the job done, but truly, this is disgusting.','',26124),
(83672,'enUS','So this is the traitor in our midst.','',26124),
(83673,'enUS','Join me, brother. Velen was wrong to refuse the Burning Legion\'s gifts.','',26124),
(83674,'enUS','Never. Will you take Kil\'jaeden\'s blessing, only to give up your soul?','',26124),
(83675,'enUS','Fool, your soul will be mine, even in death! Shattrath, Auchindoun, Elodor, Karabor... ALL shall fall!','',26124),
(83676,'enUS','Zamaya, finish him!','',26124),
(83677,'enUS','','With pleasure, master.',26124),
(83678,'enUS','Auuughhhh!','',26124),
(83679,'enUS','Auughh auuuughhhhh!','',26124),
(83680,'enUS','How am I supposed to do this all myself!? Keep it together, Baros... keep it together.','',26124),
(83681,'enUS','I feel so relieved. Maybe I can actually do some stargazing tonight. That would be a nice change of pace.','',26124),
(83682,'enUS','','Baros is looking for me?$b$bI\'ve been right here with my crew the whole time... Poor guy is so busy he\'s losing it.$b$bAlright, break time is over.',26124),
(83683,'enUS','Time to get back to work.','Time to get back to work.',26124),
(83684,'enUS','See reason, old friend. You must stop this lunacy!','',26124),
(83685,'enUS','War is not a time for reason. Lieutenant, deal with them.','',26124),
(83686,'enUS','Over...*cough*... here...','',26124),
(83687,'enUS','The barracks should take the men no time to complete at all.  Follow me, commander.','',26124),
(83688,'enUS','The Iron Horde have landed upon these shores. It is our task to make them regret it.','',26124),
(83689,'enUS','','Our presence here has gone undetected by the Sargerei so far. Let\'s keep it that way.',26124),
(83690,'enUS','A |cFFFF0404%s|r comes lurking from the depths!','',26124),
(83691,'enUS','','What little supplies we had upon arrival are quickly being used up for the needs of the refugees. \n\nI hope we are able to leave here soon, lest we become stranded in Auchindoun just like them.',26124),
(83692,'enUS','Most of our other buildings are going to take quite a while longer to construct.','',26124),
(83693,'enUS','The barracks looks fantastic. You should go check in with Maraad. I\'m going to hang out here and admire my handy work.','',26124),
(83694,'enUS','We must depart for Oshu\'gun with great haste.','',26124),
(83695,'enUS','The Warsong shaman have turned their backs on the old ways, $n. Do what must be done.','',26124),
(83696,'enUS','Be wary of the ritual leaders. The source of their power is corrupt, but it is by no means weak.','',26124),
(83697,'enUS','Once you have entered the Twisting Nether, use the shaman stone to contact me.','',26124),
(83698,'enUS','Be careful, commander. If these pale orcs are real, who knows what powers they possess.','',26124),
(83699,'enUS','How the Pale have learned to enslave the elements, I do not know, but it cannot be allowed to continue.','',26124),
(83700,'enUS','These pale orcs sound dangerous. Hopefully this is the last we see of them.','',26124),
(83701,'enUS','Find this Greyseer and bury him back into the mud from where he came!','',26124),
(83702,'enUS','Make your way to the ancestral grounds and discover the cause of the disturbance there.','',26124),
(83703,'enUS','The monsters of the void grow in strength and number. They must be stopped.','',26124),
(83704,'enUS','Countless portals are opening from within the Twisting Nether. They must be closed with all haste!','',26124),
(83705,'enUS','','How ye doin?',26124),
(83706,'enUS','Show no mercy when facing Invalidus, such kindness will not be returned to you.','',26124),
(83707,'enUS','','How ye doin\'? Welcome to the finest garage on Draenor.$b$bIf you need repair work on your trike, hot rod, shredder, flamethrower, or rocket sled we\'re the best!$b$bIn fact you could say we got the market cornered.',26124),
(83708,'enUS','Return to me from the Twisting Nether and we shall speak more.','',26124),
(83709,'enUS','The naaru...is dying! Hurry, you must stop Cho\'gall before all is lost!','',26124),
(83710,'enUS','I require a new shaman stone.','I require a new shaman stone.',26124),
(83711,'enUS','In here!','',26124),
(83712,'enUS','Da king tell me you gonna free us!','',26124),
(83713,'enUS','We gonna fight for you!','',26124),
(83714,'enUS','For da old king, and da new one!','',26124),
(83715,'enUS','We gonna help you, cuz\' you helpin\' us!','',26124),
(83716,'enUS','Dis be our way out!','',26124),
(83717,'enUS','Dis gonna save our souls!','',26124),
(83718,'enUS','We cannot stay here long. Soon, the entirety of the Iron Horde will be upon us.','',26124),
(83719,'enUS','$n, our champion, will stay back and disrupt the enemy camp. The rest of us will seek safe passage through the jungle.','',26124),
(83720,'enUS','Good luck, $n.','',26124),
(83721,'enUS','Fight well, $n.','',26124),
(83722,'enUS','It\'ll take more than a handful o\' mouthy earth beasts ta take out ol\' Heavyhands!','',26124),
(83723,'enUS','Dunna ask how we found that artifact. It\'s not what ya\'d call a \'happy\' story.','',26124),
(83724,'enUS','Invaders! Defend Morkurk, you fools!','',26124),
(83725,'enUS','The Witch Lord requires your blades! Attack!','',26124),
(83726,'enUS','YOU NO ATTACK MORKURK!','',26124),
(83727,'enUS','Help! Help!','',26124),
(83728,'enUS','Take care, the demons can strike again at any moment. It seems the Shadow Council will stop at nothing to breach the gates of Auchindoun.\n\nWe must remain vigilant!','',26124),
(83729,'enUS','The threat of the Burning Legion is larger than the Alliance and the Horde. We must set aside our differences, even reluctantly, to ensure that history does not repeat itself.','',26124),
(83730,'enUS','Remmel has been telling me the story of his people. We have more in common than one might think.','',26124),
(83731,'enUS','The Sargerei must be kept in check.','',26124),
(83732,'enUS','The talbuk and elekk are blessed gifts bestowed upon us by Draenor. Take of them only when necessary and give back whenever able.','',26124),
(83733,'enUS','Spill blood in the master\'s name!','',26124),
(83734,'enUS','Leave nothing alive. All life must burn!','',26124),
(83735,'enUS','I\'ll make this quick.','',26124),
(83736,'enUS','This world will be turned to ash!','',26124),
(83737,'enUS','You face the burning hatred of the master, cretin.','',26124),
(83738,'enUS','None will be spared. Slay them all!','',26124),
(83739,'enUS','','Feast your eyes upon the terrible might of the Burning Legion.',26124),
(83740,'enUS','','You are all fools. This world is damned.',26124),
(83741,'enUS','','Yes... come. Greet your death.',26124),
(83742,'enUS','','Alright, break time\'s over fellas.',26124),
(83743,'enUS','','My uncle\'s in Pinchwhistle Point, I hope everyone\'s ok.',26124),
(83744,'enUS','','Remember, the secret phrase is, \"The rain falls on Shadowmoon.\"',26124),
(83745,'enUS','Ok, fine.','Ok, fine.',26124),
(83746,'enUS','This spot\'s good for either a corral or a tankworks. You choose and I\'ll make sure it gets built.','',26124),
(83747,'enUS','Strength is of little importance without the wisdom to know when to properly use it.','',26124),
(83748,'enUS','','Wars cannot be won solely by destroying your enemies. Without the protection of your people, you can never be victorious.',26124),
(83749,'enUS','The greatness of our civilization cannot maintain if even a single draenei voice is silenced by its leaders.','',26124),
(83750,'enUS','The Naaru have blessed the draenei people with the gift of the Light. Let it guide you and be your solace.','',26124),
(83751,'enUS','The forces of the elements can offer unlimited power, but will surely lead to destruction for those who fail to maintain the balance.','',26124),
(83752,'enUS','','A leader is only as strong as the weakest of those they lead. The key to victory is to empower even the lowliest soldier to greatness.',26124),
(83753,'enUS','The latent power of Draenor can be found in every rock. When harnessed with care, it will never falter.','',26124),
(83754,'enUS','','Hey, you\'re here just in time!',26124),
(83755,'enUS','My contract was for burning fungus, repairing engines, and salvage work. It said nothing about dealing with bugs!','',26124),
(83756,'enUS','Greetings, initiate. What can I do for you?','',26124),
(83757,'enUS','I\'ll never sneak onto another wagon again. I swear!','',26124),
(83758,'enUS','','How is your mission of subterfuge going? In order to infiltrate the enemy, make sure you are wearing a Sargerei disguise.$B$BYou can create one by collecting the cowl, robe, and slippers from fallen Sargerei enemies.',26124),
(83759,'enUS','Communing','Communing',26124),
(83760,'enUS','','',26124),
(83761,'enUS','','You have my utmost respect, commander. I will follow you into the dark anytime.',26124),
(83762,'enUS','AAAAAAHHHHHHHHHH!','',26124),
(83763,'enUS','','Some of the larger demons can tear through our ballistae relatively quickly. \n\nIf I can\'t produce them more rapidly than they get destroyed, then there may be no stopping the Shadow Council.',26124),
(83764,'enUS','|TInterface\\Icons\\inv_misc_embers.blp:20|t %s is completely dehydrated and has |cFFFF0404|Hspell:164275|h[Brittle Bark]|h|r!','',26124),
(83765,'enUS','%s has absorbed enough water to become active again!','',26124),
(83766,'enUS','An Unchecked Growth absorbs a nearby Aqueous Globule and comes to life!','',26124),
(83767,'enUS','Use the Command Table to send Qiana on a mission.','',26124),
(83768,'enUS','','Starfall isn\'t far. Good luck, Qiana.',26124),
(83769,'enUS','Git to the surface an\' keep that genesaur busy. I\'ll git this cannon firin\' soon as I can!','',26124),
(83770,'enUS','Kicking','Kicking',26124),
(83771,'enUS','I hope you\'re right. The dead grow... fearful. Something truly dark is coming.','',26124),
(83772,'enUS','','Well, Commander, my life has gotten quite exciting since I started following you around.$b$bI see you managed to get the genesaur artifact. Here, take the seeds and water as well and please bring them to Maraad back at the main outpost.$b$bWe will help Thaelin remove his tank in the meantime.',26124),
(83773,'enUS','I will find my way to your garrison. Fight with honor.','',26124),
(83774,'enUS','','Exarch, have your soulbinders meet me at my camp. I intend to stop Teron\'gor before he unleashes more demons.',26124),
(83775,'enUS','We must stop Teron\'gor before this world falls... as so many others have.','',26124),
(83776,'enUS','','I understand that our relationship with the Draenei has been through some trying times, but right now, these soldiers need my help. \n\nWe need to stick together if we all wish to defeat the Shadow Council.',26124),
(83777,'enUS','','We need to be on our guard. This place is crawling with ogres.',26124),
(83778,'enUS','Don\'t worry, $n. We\'ve got your back!','',26124),
(83779,'enUS','','Leafshadow has hidden our position from Teron\'gor, and his forces have not yet left Gul\'rok for their final march on Auchindoun. We have the element of surprise on our side.',26124),
(83780,'enUS','They are far too powerful to attack head-on. Restalaan is most familiar with this area. I believe he has a plan.','',26124),
(83781,'enUS','Light of Lights, cover us from those who wish us harm.','',26124),
(83782,'enUS','Deliver us from the darkness and shine your light upon us.','',26124),
(83783,'enUS','Hide us from the Dark One. Protect our people from the Great Shadow.','',26124),
(83784,'enUS','We are the children of the Light. We ask for naught but peace.','',26124),
(83785,'enUS','','You won\'t stand alone. The Light gives us strength!',26124),
(83786,'enUS','We are bound together by the Light. We fight as one.','',26124),
(83787,'enUS','Today I repay my debt. I will handle the portals.','',26124),
(83788,'enUS','ANGO\'ROSH! TO ME!','',26124),
(83789,'enUS','Liadrin, I have it. Finish it!','',26124),
(83790,'enUS','','Let\'s go. They went through that portal.',26124),
(83791,'enUS','Thanks for the patch-up! Since you saved me here\'s some advice, stay away from Pinchwhistle Point.','Thanks for the patch-up! Since you saved me here\'s some advice, stay away from Pinchwhistle Point.',26124),
(83792,'enUS','Pinchwhistle Point is crawling with the infected, I... I think the town\'s a lost cause.','Pinchwhistle Point is crawling with the infected, I... I think the town\'s a lost cause.',26124),
(83793,'enUS','Pinchwhistle Point is completely lost. We only saw one guy who didn\'t look infected but we lost control of the zeppelin before we could make contact.','Pinchwhistle Point is completely lost. We only saw one guy who didn\'t look infected but we lost control of the zeppelin before we could make contact.',26124),
(83794,'enUS','The voice calls us to Oshu\'gun...and my ancestors answer. In time, we shall have no choice but to answer as well.','',26124),
(83795,'enUS','','I watched with great joy as you brought peace to Gar\'rok during his final hours of life. We will be forever grateful for your kindness and bravery.',26124),
(83796,'enUS','','These pilgrims gather from all over Draenor to hear the wisdom of the spirits interred at Auchindoun. \n\nFor the draenei people, such wisdom comes with great reward.',26124),
(83797,'enUS','The skirmishes with the Shadow Council have left many travelers stranded in Auchindoun. \n\nUnless the tide of battle turns, it is likely we will never leave this place.','',26124),
(83798,'enUS','You big oaf! Quit breaking my things!','',26124),
(83799,'enUS','That was my entire collection of Hearthstone cards!','',26124),
(83800,'enUS','Gah! That was my last samophlange! Do you know how hard those are to get?','',26124),
(83801,'enUS','Hey dummy! How would you like it if I broke all your things?!','',26124),
(83802,'enUS','We\'re nearly out of supplies, but the refugees keep coming. This cannot continue for long.','',26124),
(83803,'enUS','I got this boss.','',26124),
(83804,'enUS','','These great defense crystals are just one of the myriad uses for the crystals in the Jorune mine. \n\nIt is a pity that the Shadow Council forces us to use them only for instruments of war.',26124),
(83809,'enUS','prelude. Stage: $8883w sub-stage: $8938w','',26124),
(83810,'enUS','This is it, soldiers. Time to make your commander proud.','',26124),
(83811,'enUS','Fly me to the Spirit Woods near Oshu\'gun.','Fly me to the Spirit Woods near Oshu\'gun.',26124),
(83812,'enUS','Little blue warriors, you have proven yourself worthy of avoiding my wrath.','',26124),
(83813,'enUS','The red ones, yes, they will bear witness to my devastation!','',26124),
(83814,'enUS','It was an ambush - Shadowmoon orcs. They are circling back for the kill.','',26124),
(83815,'enUS','I have returned! Submit, peasants, to the might of the great Ogre Empire!','',26124),
(83816,'enUS','We can\'t fight them. We\'re just farmers! We don\'t even have weapons!','',26124),
(83817,'enUS','Such little faith. Give me your sickle. Watch what is possible with the light.','',26124),
(83818,'enUS','','You will pay for that!',26124),
(83819,'enUS','Take me to Shadowmoon Valley.','Take me to Shadowmoon Valley.',26124),
(83820,'enUS','The mountain of Oshu\'gun was once a place of peace and worship.','',26124),
(83821,'enUS','During the Kosh\'harg, our clans would meet at the foot of the great mountain in celebration.','',26124),
(83822,'enUS','The Kosh\'harg is just a memory now. The Warsong have claimed Oshu\'gun for their own.','',26124),
(83823,'enUS','Tressia was a good solider, but when the venom took its hold on her, she left me no choice. \n\nI hope we wipe every member of the Shadow Council from the face of Draenor. Our people deserve better than to end up like this.','',26124),
(83824,'enUS','The stench of darkness lingers in the air here...it is not as I remember.','',26124),
(83825,'enUS','<Lets out a soft, deep groan>','',26124),
(83826,'enUS','Our power is not strong enough to revive this ancient, but we\'ll keep trying. Are you going to help us?','',26124),
(83827,'enUS','We\'re from Moonglade, have you been? It\'s great this time of year.','',26124),
(83828,'enUS','We haven\'t been able to use our Crow shapeshift in this strange world yet, but I heard a rumor we\'ve found a way to do so here by using the power of the artifacts.','',26124),
(83829,'enUS','I\'m gonna load up me tank and head southwest. I\'ll see if I can\'t get one of these rangari to be a guide.','',26124),
(83830,'enUS','I see a... delicious, fleshy $c... do you like what you see before you? Cho\'gall has taught us so much...','',26124),
(83831,'enUS','Yes... closer, $c... delve deeper and I will show you the true power of the Pale! Our master has been good to us...','',26124),
(83832,'enUS','Our master has made us strong... behold his gifts!','',26124),
(83833,'enUS','The master commands and I obey!','',26124),
(83834,'enUS','','Come on, we need to get going pronto!',26124),
(83835,'enUS','We have waited long for this moment. The true power of the stones will be realized at last! (None shall survive. We shall be the unmaking! Destroy them! Wash over this world!)','',26124),
(83836,'enUS','Gaze into the abyss. (It sees you! It knows!)','',26124),
(83837,'enUS','Your world will be swallowed in darkness! (All will hear his call!)','',26124),
(83838,'enUS','Death comes! (We know it well.)','',26124),
(83839,'enUS','The end draws closer! (This is our purpose!)','',26124),
(83840,'enUS','Embrace the end.','',26124),
(83841,'enUS','Give in to darkness.','',26124),
(83842,'enUS','He comes... (You can never escape...)','',26124),
(83843,'enUS','The night consumes us! (We have won! All will be as foretold!)','',26124),
(83844,'enUS','Your prisoner is with me. He means your people no harm.','Your prisoner is with me. He means your people no harm.',26124),
(83845,'enUS','We will draw a cloak of midnight across the burning sky.','',26124),
(83846,'enUS','Let the prisoner go. Its master has earned a favor from us.','',26124),
(83847,'enUS','Here you are, miss Pinchwhistle!','',26124),
(83848,'enUS','','About time! Come on, Gazwitz.',26124),
(83849,'enUS','','Of course, ma\'am.',26124),
(83850,'enUS','','Supervising of course. Now, get moving!',26124),
(83851,'enUS','What can I do to help?','',26124),
(83852,'enUS','Khadgar has asked us to go distract the Eye of Kilrogg.','Khadgar has asked us to go distract the Eye of Kilrogg.',26124),
(83853,'enUS','Go ahead and sign off whenever you\'re ready, sir.','',26124),
(83854,'enUS','I be goin\' ahead to get da troops ready for your inspection, commander.','',26124),
(83855,'enUS','I will move ahead and ensure the troops are ready for your inspection.','',26124),
(83856,'enUS','You and I against an entire clan? Sounds like my kind of fight.','',26124),
(83857,'enUS','Here we stand, cowards! Come... FIGHT US!','',26124),
(83858,'enUS','I can see you...','',26124),
(83859,'enUS','We\'re in your kitchen, Kilrogg! Come and get us!','',26124),
(83860,'enUS','I\'m coming for you, intruders...','',26124),
(83861,'enUS','It looks like Khadgar and the rest are on the move. Our work is nearly done, champion!','',26124),
(83862,'enUS','Your deeds here will not be forgotten, $n. Your name shall be spoken in reverence among the spirits of my people.','',26124),
(83863,'enUS','Stand up straight, you pathetic savages! Our commander approaches!','',26124),
(83864,'enUS','For $p! For the Horde!','For $p! For the Horde!',26124),
(83865,'enUS','Garrison - Debug - Shutdown Scenario','',26124),
(83866,'enUS','This way, commander!','',26124),
(83867,'enUS','Such a joy to see Exarch Akama in action.','',26124),
(83868,'enUS','Look out - here they come.','',26124),
(83869,'enUS','Go now. I will cover the rear.','',26124),
(83870,'enUS','So far, none of our medicines have had any effect on the spiders\' poison. \n\nWe must gather more specimens before we can concoct an effective antidote.','',26124),
(83871,'enUS','We\'ve found another egg for your experiments, Teris. I hope this one helps.','',26124),
(83872,'enUS','Well done, ranger. These spider\'s eggs should aid in the concoction of an antidote for their venom.','',26124),
(83873,'enUS','Look!','',26124),
(83874,'enUS','Atten-tion! Our commander has arrived. Salute!','',26124),
(83875,'enUS','This way. I remember these hills well.','',26124),
(83876,'enUS','Another attack. They must think us an easy target. Hah!','',26124),
(83877,'enUS','','Start gathering everybody together, we need to expand our operation. And let me know if you find Pippers... he stole my favorite slippers.',26124),
(83878,'enUS','','I swear if he is swimming again... he has a horrible work ethic. He says he lost those supplies. I don\'t believe him for a second.',26124),
(83879,'enUS','For $p! For the Alliance!','For $p! For the Alliance!',26124),
(83880,'enUS','We are almost there.','',26124),
(83881,'enUS','Supplies? What supplies? I have no idea what you are talking about.$b$b<Scrap\'s eyes dart back and forth and he nervously clears his throat.>$b$bWhat? I\'m not trying to steal them or anything... I mean, if I knew what you were even talking about, which I don\'t.','',26124),
(83882,'enUS','You made it.','',26124),
(83883,'enUS','There you are. Now get to work, you slackers!','',26124),
(83884,'enUS','The Bleeding Hollow orcs use savage blood magic to transform their warriors into hulking berserkers.','',26124),
(83885,'enUS','Listen up, maggots. We\'re doubling up patrols. Nothing goes wrong while the commander is here, understood?','',26124),
(83886,'enUS','All of you, double your efforts! I want this place spotless for our commander.','',26124),
(83887,'enUS','Commander, a moment, please.','',26124),
(83888,'enUS','With any luck, we will escape before they can complete their transformation ritual.','',26124),
(83889,'enUS','We\'ve done it! |c00FFFF00|Hspell:178358|h[Fangraal]|h|r marches into Ashran to cleanse the Horde filth. Don\'t let him die, Alliance!','',26124),
(83890,'enUS','Excellent. I will endeavor to bring more, should the opportunity arise. Anu belore dela\'na!','',26124),
(83891,'enUS','As we stand beneath the shadow of the once mighty Gordawg, I can feel the elements weep.','',26124),
(83892,'enUS','|TInterface\\Icons\\spell_holy_surgeoflight.blp:20|t %s readies |cFFF00000|Hspell:153006|h[Consecrated Light]|h|r. Hide!','',26124),
(83893,'enUS','','I\'m on it.',26124),
(83894,'enUS','Ey commander, you have a second?','',26124),
(83895,'enUS','Fangraal is born! He is pushing forward on the Road of Glory at this moment.','',26124),
(83896,'enUS','The artifact fragments contain enough magical power to restore this Ancient to full strength. $B$BHow many have you brought us?','',26124),
(83897,'enUS','Search to the northwest. I will be right behind you.','',26124),
(83898,'enUS','Augh! Brain so cold!','',26124),
(83899,'enUS','Ungh! Brain freeze!','',26124),
(83900,'enUS','There are many injured who need my aid. There is no time to waste.','',26124),
(83901,'enUS','|c00FFFF00|Hspell:178358|h[Fangraal]|h|r has been slain by the Horde!','',26124),
(83902,'enUS','','Is he dead? Phew... great work, commander. I\'ll stay here and take care of any stragglers.',26124),
(83903,'enUS','','A temple-kneeler and a metal-bender have no place in this jungle. You will need my help to survive.',26124),
(83904,'enUS','','Hmmph. Just keep up if you can.',26124),
(83905,'enUS','I be goin\' ahead and makin\' sure it not a trap, commander.','',26124),
(83906,'enUS','I\'ll move ahead and check for any orc ambushes, commander.','',26124),
(83907,'enUS','','Prophet Velen trusted me to turn the Iron Horde from Karabor. I can handle the jungle.',26124),
(83908,'enUS','','Why did you join us, Kaalya? If we are such an inconvenience, why not leave us to our own devices?',26124),
(83909,'enUS','','Rangari do not leave people behind.',26124),
(83910,'enUS','Oh gross! Well, that wasn\'t it.','',26124),
(83915,'enUS','Hey, you don\'t look infected. You must be the $Gguy:lady; my niece was telling me about. Come on over!','',26124),
(83916,'enUS','Behold, a void god is born! (You fools are too late!)','',26124),
(83917,'enUS','Thank you, stranger.','',26124),
(83918,'enUS','A pity that I cannot stay to watch you die. (We\'re going to Highmaul!)','',26124),
(83919,'enUS','You can find those cherries under any of the trees.','',26124),
(83920,'enUS','New babies are just the thing to get these two feeling right as rain.','',26124),
(83921,'enUS','Ahh...','',26124),
(83922,'enUS','... CHOOO!','',26124),
(83923,'enUS','They could come from anywhere.','They could come from anywhere.',26124),
(83924,'enUS','They\'ll be going for our buildings!','They\'ll be going for our buildings!',26124),
(83925,'enUS','Spread out! Spread out!','Spread out! Spread out!',26124),
(83926,'enUS','I can\'t hear any more digging...','I can\'t hear any more digging...',26124),
(83927,'enUS','They\'re on the run now.','They\'re on the run now.',26124),
(83928,'enUS','Just a few whacks more.','Just a few whacks more.',26124),
(83929,'enUS','Their attack is weakening.','Their attack is weakening.',26124),
(83930,'enUS','Oy! Commander! That genesaur found us. The lasses are outside tryin\' to keep it at bay. They are gonna need yer help!','',26124),
(83931,'enUS','Hansel! You\'re alive! Here... let me help ya load.','',26124),
(83932,'enUS','Now you gonna get it!','',26124),
(83933,'enUS','Ow ow ow! Why me?!','',26124),
(83934,'enUS','','Let\'s get moving!',26124),
(83935,'enUS','Ha ha! Come get me now!','',26124),
(83936,'enUS','Grr! Now I show you!','',26124),
(83937,'enUS','Exarch Akama, these attacks are just the beginning.','',26124),
(83938,'enUS','Who the dummy now?','',26124),
(83939,'enUS','Ice da best!','',26124),
(83940,'enUS','The orcs would be fools to attack our fortified cities.','',26124),
(83941,'enUS','With respect, I disagree. We MUST not underestimate them. Take me to the Exarch Council.','',26124),
(83942,'enUS','Champions! Nyami\'s agents - they went this way!','',26124),
(83943,'enUS','Best be quick with that thing. We got incoming!','',26124),
(83944,'enUS','No... Oh no...','',26124),
(83945,'enUS','','Step inside the chamber of truth and be cleansed!',26124),
(83946,'enUS','On our homeworld, art, science, magic and technology were all as one. Ah, such wonders we would build!','',26124),
(83947,'enUS','Now, all I have is spare parts and whatever primitive materials we can cobble together.','',26124),
(83948,'enUS','It is ready! Go inside and power on the console while I observe...','',26124),
(83949,'enUS','Haunted Hound has spotted you!','',26124),
(83950,'enUS','Get the goren!','',26124),
(83951,'enUS','Someone find a way to collapse that tunnel!','',26124),
(83952,'enUS','Where do these keep coming from?','',26124),
(83953,'enUS','There\'s too many of these things!','',26124),
(83954,'enUS','There are so many of them!','',26124),
(83955,'enUS','Look at the size of its teeth!','',26124),
(83956,'enUS','I wonder if I could sell their crystals...','',26124),
(83957,'enUS','Don\'t die or they\'ll eat you!','',26124),
(83959,'enUS','Well done, $n.','',26124),
(83960,'enUS','This cave will serve us well.','',26124),
(83962,'enUS','At long last... my time has come! This world shall crumble beneath the power of the void!','',26124),
(83963,'enUS','The furies await you at the Throne of Elements, $n.','',26124),
(83964,'enUS','Uh oh!','',26124),
(83965,'enUS','Just like Mom used to make.','Just like Mom used to make.',26124),
(83966,'enUS','It\'s like a little piece of Ironforge.','It\'s like a little piece of Ironforge.',26124),
(83967,'enUS','Ah. Tastes like home.','Ah. Tastes like home.',26124),
(83968,'enUS','That\'ll get you there, son.','That\'ll get you there, son.',26124),
(83969,'enUS','No, no, no. The whole thing\'s all wrong!','',26124),
(83970,'enUS','Some sorta bad voodoo be happenin\' here, commander.','',26124),
(83971,'enUS','Bryan! It\'s me, Jasper. What happened to you?','',26124),
(83972,'enUS','Alliance Win!','',26124),
(83973,'enUS','There, there. It will all be okay.','',26124),
(83974,'enUS','The Light heals all wounds.','',26124),
(83975,'enUS','Go! I will hold back any reinforcements that attempt to follow!','',26124),
(83976,'enUS','Are you hungry, little Moonglow? Here, let me get you some fish.','',26124),
(83977,'enUS','Where did all of my workers go? They\'ll be working overtime to finish this.','',26124),
(83978,'enUS','Show the schematic to Bryan.','Show the schematic to Bryan.',26124),
(83979,'enUS','Though much has been lost, I sense a great peace in the elements. I will remember your courage always, friend.','',26124),
(83980,'enUS','Who\'s a pretty fey dragon? You\'re a pretty fey dragon!','',26124),
(83981,'enUS','This looks to be a hydra egg and is very close to hatching.$b$bIts mother would likely be nearby and would not appreciate you being near her nest.','',26124),
(83982,'enUS','I am ready to begin the Ritual of Binding.','I am ready to begin the Ritual of Binding.',26124),
(83983,'enUS','Wh- what happened? Where am I? Jasper... is that you?','',26124),
(83984,'enUS','Alright Moonglow, now play dead!','',26124),
(83985,'enUS','Wh- what happened? Where am I?','',26124),
(83986,'enUS','Sit, Moonglow, sit! Good dragon!','',26124),
(83987,'enUS','Horde Win!','',26124),
(83988,'enUS','Alright, come on through. Steady... Steady...','',26124),
(83989,'enUS','','Gronnlings, break their bones and bring them to me!',26124),
(83990,'enUS','','Gronn, gnash them in your teeth!',26124),
(83991,'enUS','Varasha charges into her lair!','',26124),
(83992,'enUS','','<Alice doesn\'t seem to acknowledge your presence.>',26124),
(83993,'enUS','Show the spectral essences to Alice.','Show the spectral essences to Alice.',26124),
(83994,'enUS','','Wh-who are you? Where\'s Bryan?',26124),
(83995,'enUS','Please... when you see her... tell her I love her.','',26124),
(83996,'enUS','Please... when you see her... tell her I love her.','',26124),
(83997,'enUS','The villagers were easy. You\'re next.','',26124),
(83998,'enUS','','We\'ll see who\'s best.',26124),
(83999,'enUS','','Make Azeroth proud, commander.',26124),
(84000,'enUS','','Don\'t underestimate the talbuk, $c. While they\'re mostly peaceful creatures, they hit as hard as an elekk.',26124),
(84001,'enUS','','I know... Tall Buck\'s a silly name. But, we have to call him something, and he is rather large.',26124),
(84002,'enUS','I am Nobundo, a humble paladin. I have been called here by a voice upon the wind. How may we aid you?','',26124),
(84003,'enUS','You will have our aid. We will find the fury of earth and restore the balance.','',26124),
(84004,'enUS','You must attune yourself with the elements upon the plateau.','',26124),
(84005,'enUS','When you are ready, we will commune with the great furies.','',26124),
(84006,'enUS','We must act swiftly, Oshu\'gun awaits.','',26124),
(84007,'enUS','I had heard of the Throne of Elements, a place where the elements could speak with the orcs. I had never dreamed that one day I would stand here in the presence of giants.$b$bThough I am a stranger here, I feel as if I have been here before...in a dream perhaps.','',26124),
(84008,'enUS','','Greetings, commander. How may I help you?',26124),
(84009,'enUS','Follow me, and stay close.','',26124),
(84010,'enUS','','Greetings, wolf-$g brother:sister;.',26124),
(84011,'enUS','We\'ll see who\'s best.','',26124),
(84012,'enUS','Make Azeroth proud, commander.','',26124),
(84013,'enUS','','Don\'t underestimate the talbuk, wolf-$g brother:sister;. While they\'re mostly peaceful creatures, they hit as hard as an elekk.',26124),
(84014,'enUS','','I know... Tall Buck\'s a silly name. But, we have to call him something, and he is rather large.',26124),
(84015,'enUS','Get back to work! Commander Taylor won\'t be kept waiting.','',26124),
(84016,'enUS','Your break isn\'t for another hour. Back to work!','',26124),
(84017,'enUS','I\'ll have you written up for this!','',26124),
(84018,'enUS','I\'ve had enough. You\'re fired!','',26124),
(84019,'enUS','I\'ve got the enemy in my sights. Hold the line, lads!','I\'ve got the enemy in my sights. Hold the line, lads!',26124),
(84020,'enUS','Now - kill your hundred, or die trying!','',26124),
(84021,'enUS','Sorry, but we don\'t have that kind of time.','',26124),
(84022,'enUS','Hmph. I only counted ninety-nine kills, wizard.','',26124),
(84023,'enUS','Then I guess we owe you one.','',26124),
(84024,'enUS','Everyone, with me!','',26124),
(84025,'enUS','Quickly! Into the cave, before they thaw.','',26124),
(84026,'enUS','','We brought this sapling with us from our home, and now it is dying. I cannot sense any evil nearby, but I will keep trying.',26124),
(84027,'enUS','Beneath the crystal mountain the orcs call Oshu\'gun lays the wreckage of the Genedar. Were it not for the Prophet Velen and the mercy of the naaru K\'ure, my people would have perished to the Burning Legion.','',26124),
(84028,'enUS','You have learned all the recipes from this research.','You have learned all the recipes from this research.',26124),
(84029,'enUS','Alright, back to work.','Alright, back to work.',26124),
(84030,'enUS','But, I was just about to win...','Alright, back to work.',26124),
(84031,'enUS','Do we have to?','Do we have to?',26124),
(84032,'enUS','The shaman stone that the furies gave to us at the Throne of Elements allows us to communicate through the elements.','',26124),
(84033,'enUS','The portal has taken me into the Twisting Nether.','The portal has taken me into the Twisting Nether.',26124),
(84034,'enUS','<Touch the sword.>','<Touch the sword.>',26124),
(84035,'enUS','','Impossible!',26124),
(84036,'enUS','The remains of this corpse are being devoured by the roots and vines of the swiftly budding seeds in the pool.','The remains of this corpse are being devoured by the roots and vines of the swiftly budding seeds in the pool.',26124),
(84037,'enUS','This Laughing Skull looks as though they were eating a lot before they were slain, their body grown fat and distorted before death.','This Laughing Skull looks as though they were eating a lot before they were slain, their body grown fat and distorted before death.',26124),
(84038,'enUS','What remains of this corpse is now fertilizer for the seeds growing in this pool.','What remains of this corpse is now fertilizer for the seeds growing in this pool.',26124),
(84039,'enUS','The Genedar was once a vessel guided by the naaru and powered by the Light itself. Now, as we stand among the wreckage of that great ship, the Light is absent... I sense only darkness here.','',26124),
(84040,'enUS','','Don\'t let them take the artifact!',26124),
(84041,'enUS','The object we seek is here!','',26124),
(84042,'enUS','Get them!','',26124),
(84043,'enUS','Hahaha! I\'ve always enjoyed killing gronn.','',26124),
(84044,'enUS','Nisha, get her down here!','',26124),
(84045,'enUS','REMOVE - Brak, you will receive no mercy this time.','',26124),
(84046,'enUS','','Aggghh!',26124),
(84047,'enUS','','In order to successfully train a fey dragon, one must keep them well fed and rested. A restless dragon tends to be less than receptive to orders.\n\nPlease do not disturb them.',26124),
(84048,'enUS','I am ready to make my choice.','I am ready to make my choice.',26124),
(84049,'enUS','Here is where we train the young fey darters to follow commands. \n\nThough their antics may seem silly, the discipline they learn now is imperative if we ever wish them to take a rider.','',26124),
(84050,'enUS','I should crush you but what would be the point... I have failed in my duties and can only wait until I am crushed to dust...','',26124),
(84051,'enUS','A building is being eaten!','',26124),
(84052,'enUS','Brighteye looks at you eagerly, awaiting a command.','',26124),
(84053,'enUS','Brighteye, go fetch!','Brighteye, go fetch!',26124),
(84054,'enUS','Thank you for not killing me.  What duty have you failed?','Thank you for not killing me.  What duty have you failed?',26124),
(84055,'enUS','Sit, Brighteye, sit!','Sit, Brighteye, sit!',26124),
(84056,'enUS','Okay, Brighteye, now play dead!','Okay, Brighteye, now play dead!',26124),
(84057,'enUS','Dionor was a powerful and bold champion of our kind. He sought to break the ancient lines of battle and take the fight to the enemy.$b$bIt ended with his defeat at the hands of several Magnaron... Here he fell, some of his energy creating a small sanctuary for those of us that remained until I could fulfill my duty... but I cannot...','',26124),
(84058,'enUS','What were you supposed to do?','What were you supposed to do?',26124),
(84059,'enUS','When a champion like Dionor falls, a Death Bloom will grow from his husk. I was to collect this Bloom and perform a sacred rite here to release his life force back to the overgrowth.$b$bAs I was about to do this I was set upon by fur-covered two legs and they took the Bloom first. We tried to follow but they raised barriers and used fire to drive us back.$b$bSo now I stand vigil over my failure until we are all ground into the tortured soil by our great enemy...','',26124),
(84060,'enUS','So getting that bloom back might fix things... interesting...','So getting that bloom back might fix things... interesting...',26124),
(84061,'enUS','It\'s your watch. Wake up!','',26124),
(84062,'enUS','We\'ve done all we can from up here...','',26124),
(84063,'enUS','Whatsh do you want? Can\'t you shee I\'m trying to drinksss here? Pour yourshelf one.$B$BHemetsh, come to Nagrandsss the Alliance and Horde shaid. There\'sh big game to hunt shtill.$B$BBut, when I gots here wasss that what they wantsh me to do? NO!$B$BHemetsh, hunt the Warshong\'s wolvesss. Deprive the orcsh of their mountsss.$B$BThat\'sh no job for Hemet Neshingwary!','',26124),
(84064,'enUS','','Brighteye is one of the smartest fey dragons we\'ve trained at the Draakorium. He loves doing tricks for visitors!\n\nWhy don\'t you see if Brighteye can do a trick for you?',26124),
(84065,'enUS','Well done. The artifact is yours to take.','',26124),
(84066,'enUS','It\'s working! It\'s... not stable. But it\'s working.','',26124),
(84067,'enUS','This new structure is able to tap into a surprising amount of power.','',26124),
(84068,'enUS','Defend the ward at all costs!','',26124),
(84069,'enUS','Keep the Shadowmoon at bay. What is causing this madness?','',26124),
(84070,'enUS','Defend the ridgeline. Let them come to us.','',26124),
(84071,'enUS','Keep them engaged. The defense ward is drawing so much power - I can\'t maintain it for long.','',26124),
(84072,'enUS','This is the final resting place of some of my companions who were killed by ogron.','',26124),
(84073,'enUS','Visha, newly born and not yet ready for combat.','',26124),
(84074,'enUS','Qisha, still young but showing great promise.','',26124),
(84075,'enUS','And finally, the dearest of them all, Latisha.','',26124),
(84076,'enUS','I will destroy the Breakers of this canyon and avenge those I have lost!','',26124),
(84077,'enUS','I used to be an adventurer like yourself...$b$bI remember it like it was yesterday. I was back in Azeroth at my favorite establishment, maybe you\'ve heard of it? Goes by the name of Lion\'s Pride Inn, smack dab in the middle of Goldshire.$b$bWell, there I was across from ol\' Dobbins enjoying myself a nice bit of fine aged cheddar and washing it back with a flagon of melon juice when Dughie runs into the tavern!$b$bHis face was white as snow...nay, whiter than snow! Says he spotted a kobold not far off and it was carrying a candle, like it was fixin\' to burn Goldshire to the ground!$b$bI threw down my fine aged cheddar, made for the door and tripped over a dwarven hunter.$b$bWe crashed to the ground and POW! I took an arrow right to the knee!','',26124),
(84078,'enUS','You! Strange thing. Come, eat! The food is so delicious. You must taste.$b$bIt is so tasty I have not thought to stab you once... yet.','',26124),
(84079,'enUS','Yrel, let\'s blow open those gates and take Grommashar.','Yrel, let\'s blow open those gates and take Grommashar.',26124),
(84080,'enUS','','Attention, trainees! My fellow riders call me Moonstag. You may address me as \"Sir.\"',26124),
(84081,'enUS','','You\'ve all flown before, but you\'re about to enter a whole new world, so pay attention.',26124),
(84082,'enUS','I\'m the fastest courier in the army. Do you need a report delivered?','',26124),
(84083,'enUS','','This is a Draakorium Fey Dragon. It\'s as maneuverable as a jackrabbit and can flip end to end in less than a second.',26124),
(84084,'enUS','','Today we will be doing basic take off, approach, and landing maneuvers.',26124),
(84085,'enUS','','Anyone not paying attention is liable to end up as a puddle of something to be scrubbed off the rocks of the Draakorium. Dismissed!',26124),
(84086,'enUS','After them! Don\'t let them get away!','',26124),
(84087,'enUS','Durotan, let\'s blow open those gates and take Grommashar.','Durotan, let\'s blow open those gates and take Grommashar.',26124),
(84088,'enUS','Come back Porkchop! You embarrassin\' us!!!','',26124),
(84089,'enUS','Bad Porkchop!','',26124),
(84090,'enUS','Change of plans, men. Let\'s do it again!','',26124),
(84091,'enUS','Energy... waning...','Energy... waning...',26124),
(84092,'enUS','Must... keep... fighting...','Must... keep... fighting...',26124),
(84093,'enUS','Cannot fail... I will not fail...','Cannot fail... I will not fail...',26124),
(84094,'enUS','We fight on for Azeroth!','We fight on for Azeroth!',26124),
(84095,'enUS','If I could just close my eyes for a few moments...','If I could just close my eyes for a few moments...',26124),
(84096,'enUS','Do you not honor our commander\'s will? Are you not Horde?! Build it AGAIN!','',26124),
(84097,'enUS','I can\'t kill all these botani by myself. I\'m coming with you!','',26124),
(84098,'enUS','Pull back! We must find Ner\'zhul his sacrifices elsewhere.','',26124),
(84099,'enUS','Burn it all while there\'s still time!','',26124),
(84100,'enUS','Ashes to ashes.','',26124),
(84101,'enUS','We have to burn the corpses while we still can!','',26124),
(84102,'enUS','Another dark soul for the chopping block.','',26124),
(84103,'enUS','This will only hurt for a second.','',26124),
(84104,'enUS','Defying the master\'s will is punishable by death.','',26124),
(84105,'enUS','Hungry Goren Killed! (+$9044w)','',26124),
(84106,'enUS','An |c00FFFF00|Hspell:178360|h[Alliance Captain]|h|r has joined the battle!','',26124),
(84107,'enUS','A |c00FFFF00|Hspell:178361|h[Horde Captain]|h|r has joined the battle!','',26124),
(84108,'enUS','I am pleased. I could watch you rats fight for hours.','',26124),
(84109,'enUS','These blasted plants have ruined my hunting grounds!','',26124),
(84110,'enUS','The sol-shapers will be severely weakened in those caves, but do not underestimate them!','',26124),
(84111,'enUS','I... I remember...','',26124),
(84112,'enUS','','I... I remember...',26124),
(84113,'enUS','We need to help Taylor!','',26124),
(84114,'enUS','','We need to help Taylor!',26124),
(84115,'enUS','Are you sure they can\'t see me?','',26124),
(84116,'enUS','Thank you, but where can I go now?','',26124),
(84117,'enUS','Ahh, a decoy. Now\'s my chance!','',26124),
(84118,'enUS','Back into hiding...','',26124),
(84119,'enUS','Come now, my beak isn\'t that big! This thing looks nothing like me...','',26124),
(84120,'enUS','Raven watch over you, friend.','',26124),
(84121,'enUS','Extricating','Extricating',26124),
(84122,'enUS','Exarch Maladaar, take Qiana with you and scout the cave.','',26124),
(84123,'enUS','As you wish.','',26124),
(84124,'enUS','$n - I have a special job for you.','',26124),
(84125,'enUS','Lady Liadrin, take Olin with you and scout the cave.','',26124),
(84126,'enUS','','At your command.',26124),
(84128,'enUS','$GSir:Madam;, an attack on our garrison looms close. I have commissioned some items that you may find useful.$B$BWhoever these fools are, I welcome the chance to earn another scar.','',26124),
(84129,'enUS','Prepare to battle the Gorens.','Prepare to battle the Gorens.',26124),
(84130,'enUS','Start the garrison invasion?','Start the garrison invasion?',26124),
(84131,'enUS','Porkchop go squish?! I squish you now!','',26124),
(84132,'enUS','Crushin\' time!','',26124),
(84133,'enUS','*gasp*  Th... *cough* Thanks for getting me outta that thing!','',26124),
(84134,'enUS','The damned hatch jammed shut on me! It\'s just my luck that I escape the infected only to get stuck in a defective escape pod.','',26124),
(84135,'enUS','Stop that thing! Bring it down!','',26124),
(84136,'enUS','Stay in your swamp, Rangari. I will handle this.','',26124),
(84137,'enUS','You really got me out of a tight situation there... ZING! Hah, I kill myself... DOUBLE ZING! ...Because I got stuck in the escape pod... eh you get the idea.','',26124),
(84138,'enUS','$GSir:Madam;, we\'ll assemble the troops at your command.','',26124),
(84139,'enUS','Look, I owe you some thanks for helping me out. I grabbed this while I was getting out of town; figure you could use it better than I can.','',26124),
(84140,'enUS','See you around $g dude : toots;!','',26124),
(84141,'enUS','Augh! Now hornets? Why!?!?','',26124),
(84142,'enUS','','What is going on here? The entire mushroom forest is riled up.',26124),
(84143,'enUS','','Did you sink resonance crystals in the ground again? You\'re driving the creatures of the earth berserk!',26124),
(84144,'enUS','','When will you learn that this world is nothing like Argus?',26124),
(84145,'enUS','<The two Exarchs are in the midst of a heated argument.>$b$bThank you for all your help, $n. Apparently my devices have riled up the local flora - not to mention my fellow Exarch.$b$bIt is no matter. I will do whatever it takes to defend our people and rebuild what we lost... the occasional bug is to be expected. Surely you agree!','',26124),
(84146,'enUS','','<The two Exarchs are in the middle of a heated argument.>$b$bExarch Hataaru focuses too much on what we lost. I keep trying to tell him - it would be folly to turn this world into a second Argus, even if we had the power. Draenor is unique, and we should build our technology to suit this new world. Not the other way around!$b$bHe seems willing to listen to you. Maybe you can talk some sense into him.',26124),
(84147,'enUS','I\'M HIT!','I\'M HIT!',26124),
(84148,'enUS','GET BEHIND ME!','',26124),
(84149,'enUS','KHADGAR! INCOMING!','',26124),
(84150,'enUS','Hero, help me down from here. We don\'t have much time!','',26124),
(84151,'enUS','Ephial betrayed me. He slaughtered my men and turned them against -','',26124),
(84152,'enUS','You have heart, Taylor. I\'ll give you that.','',26124),
(84153,'enUS','I suppose there\'s not much point in disguises anymore.','',26124),
(84154,'enUS','Now, Admiral, it is time to finish what I started.','',26124),
(84155,'enUS','Genesaur coming. Get ready!','',26124),
(84156,'enUS','Help Draka and Kaz! Draka said I get to fire the big gun. I\'m gonna rip that beast apart with this dwarven behemoth blaster.','',26124),
(84157,'enUS','Loading','Loading',26124),
(84158,'enUS','They\'re... eating our garrison.','They\'re... eating our garrison.',26124),
(84159,'enUS','They\'re eating our buildings!','They\'re eating our buildings!',26124),
(84160,'enUS','They can eat anything!','They can eat anything!',26124),
(84161,'enUS','','',26124),
(84162,'enUS','Go! I will defend you from any Pale that would interfere...','',26124),
(84163,'enUS','Would you be interested in some card trading?','Would you be interested in some card trading?',26124),
(84164,'enUS','','',26124),
(84165,'enUS','','Burn that beast to the ground!',26124),
(84166,'enUS','Your laborers are hard at work, Commander. Soon your garrison will be well-stocked with food.','',26124),
(84167,'enUS','I will seek out Exarchs Akama and Maladaar. Good luck, Commander.','',26124),
(84170,'enUS','The Pale must not be allowed to build an army of elemental slaves.','',26124),
(84171,'enUS','Speak with Kalandrios to begin the ritual.','',26124),
(84174,'enUS','The terrors of the void march upon Oshu\'gun, $n. They must be stopped.','',26124),
(84175,'enUS','The ritual leaders must be dealt with before it is too late!','',26124),
(84176,'enUS','With every moment, Invalidus grows in strength. Move swiftly!','',26124),
(84177,'enUS','The Warsong rituals must be stopped!','',26124),
(84178,'enUS','If the portals open, the path will be clear for the terrors of the void to march upon Draenor!','',26124),
(84179,'enUS','Seek out the four pillars upon the plateau and attune yourself to the elements.','',26124),
(84180,'enUS','Very well. I\'ll finish you myself.','',26124),
(84181,'enUS','Rise, and carry out my will!','',26124),
(84182,'enUS','You\'ve done it. We are free!','',26124),
(84183,'enUS','We are free now.','',26124),
(84184,'enUS','The Adherents will do their utmost to cast your corpses down to the forests below.  I can return you safely.','',26124),
(84185,'enUS','Return me to the surface, friend.','Return me to the surface, friend.',26124),
(84186,'enUS','Are you sure you wish to exit the dungeon?','Are you sure you wish to exit the dungeon?',26124),
(84187,'enUS','To arms! For the Horde!','To arms! For the Horde!',26124),
(84188,'enUS','Finally, a battle.','Finally, a battle.',26124),
(84189,'enUS','Get the peons to safety.','Get the peons to safety.',26124),
(84190,'enUS','Spirits of air, wind, and all...','',26124),
(84191,'enUS','I bind this creature to my call!','',26124),
(84192,'enUS','Fool.','',26124),
(84193,'enUS','You meddle in powers... beyond your comprehension.','',26124),
(84194,'enUS','','What?!  He\'s just gonna leave?!',26124),
(84195,'enUS','Rest Dionor, I am sorry it took so long...','',26124),
(84196,'enUS','','I will take the high roads and meet you south of the Evermorn Springs, should you survive.',26124),
(84197,'enUS','Commander, are you alright?','',26124),
(84198,'enUS','You alright, commander?','',26124),
(84199,'enUS','Aaaaauuuuuggghhhhh!','',26124),
(84200,'enUS','','The front lines are faltering. They cannot hold for much longer.',26124),
(84201,'enUS','','This should be easy.',26124),
(84202,'enUS','','This should be easy.',26124),
(84203,'enUS','','This should be easy.',26124),
(84204,'enUS','','This should be easy.',26124),
(84205,'enUS','','This should be easy.',26124),
(84206,'enUS','','This should be easy.',26124),
(84207,'enUS','','This should be easy.',26124),
(84208,'enUS','','This should be easy.',26124),
(84209,'enUS','','This should be easy.',26124),
(84210,'enUS','','This should be easy.',26124),
(84211,'enUS','$p needs more time to finish the mission!','',26124),
(84212,'enUS','The elements will grant us time! For Azeroth!','',26124),
(84213,'enUS','FURY OF EARTH, GRANT ME YOUR STRENGTH!','',26124),
(84214,'enUS','I... I grow weary. The elements are barely a whisper.','',26124),
(84215,'enUS','Rest now, heroes! Soon more will come! We must allow $p to finish the mission! For Azeroth!','',26124),
(84216,'enUS','MUSTER YOUR STRENGTH! ANOTHER IRON HORDE BATTALION APPROACHES!','',26124),
(84217,'enUS','You will not interrupt the master\'s plans!','',26124),
(84218,'enUS','%s is about to burst!','',26124),
(84219,'enUS','Of course.','Of course.',26124),
(84220,'enUS','','DISCLAIMER:\n\nThe Steamwheedle Preservation Society will not be held liable for any accidental deaths, dismemberments or mutilations involved with rocket-propelled ascensions.\n\nMisti Zingwozzer,\nLegal Department, Steamwheedle Preservation Society',26124),
(84221,'enUS','Good work so far! The crystal conduits are energizing. Just a few minutes longer...','',26124),
(84222,'enUS','Excellent. Keep them away. I\'ve almost got it!','',26124),
(84223,'enUS','It\'s done! Not bad, stranger. Take the spoils from that beast if you wish. We should be safe, now.','',26124),
(84224,'enUS','Watch out! Here they come!','',26124),
(84225,'enUS','','Get out of here! Only staff is allowed in the larder.',26124),
(84226,'enUS','%s calls down a |cFFFF0404|Hspell:150045|h[Molten Impact]|h|r!','',26124),
(84227,'enUS','I\'ll guide Admiral Taylor back to camp. See you there.','',26124),
(84228,'enUS','I be helpin\' da admiral find his way to his people. I be meetin\' you back at camp.','',26124),
(84229,'enUS','\"...when the raven swallows the day.\" Who sent you?','',26124),
(84230,'enUS','Very well. I\'m listening.','',26124),
(84231,'enUS','','IRON HORDE TANK HEADING TO THE FRONT! IT\'S MASSIVE!',26124),
(84232,'enUS','Focus on your mission, $p! I will handle the tank!','',26124),
(84233,'enUS','Hey! You have any idea of the repair cost for this thing!?','',26124),
(84234,'enUS','Stop using my own bombs against me!','',26124),
(84235,'enUS','Here\'s a tip! Stand in my fire, you\'ll like it!','',26124),
(84236,'enUS','WAAAAaaahh!','',26124),
(84237,'enUS','','',26124),
(84238,'enUS','','Wahoo! We\'re Airborne!',26124),
(84239,'enUS','','This thing wasn\'t built with this many passengers in mind, so just find a place and grab on. Hope you have a strong grip!',26124),
(84241,'enUS','','I\'m sure we could come up with a decent rental agreement. How about 5,000,000 gold for a cot down in the workshop?',26124),
(84244,'enUS','We\'ve done it! Kronus marches into battle for the Horde!','',26124),
(84245,'enUS','The Alliance has slain Kronus!','',26124),
(84246,'enUS','','Pull up a chair! Burgers are almost ready, boss!',26124),
(84247,'enUS','Hello, $n.','',26124),
(84248,'enUS','Your scurrying is at an end, rats.','',26124),
(84249,'enUS','Not so fast, Ner\'zhul.','',26124),
(84250,'enUS','Yes... step closer! I will bury you alive for the glory of the Iron Horde!','',26124),
(84251,'enUS','Check it out here, got the best seats in the house!\n\nDid you come here to watch some fights, too?','',26124),
(84252,'enUS','I don\'t know Kimzee, I\'m gettin\' too old for this nonsense. You have a nice place at the gearworks; think you could spare a place for your dear ol\' uncle to rest his weary legs?','',26124),
(84253,'enUS','I think my legs suddenly feel a lot better.','',26124),
(84254,'enUS','No luck this time!','No luck this time!',26124),
(84255,'enUS','I got one! I got one!','I got one! I got one!',26124),
(84256,'enUS','A whopper!','A whopper!',26124),
(84257,'enUS','Smuggling is my business.... and business is good.','',26124),
(84258,'enUS','Got some rare stuff here!','',26124),
(84259,'enUS','Ah, yes!  I\'ve something special just for you.','',26124),
(84260,'enUS','Not even a nibble!','Not even a nibble!',26124),
(84261,'enUS','Sigh...','Sigh...',26124),
(84262,'enUS','A bite!','A bite!',26124),
(84263,'enUS','Did I feel something?','Did I feel something?',26124),
(84264,'enUS','I think I got one!','I think I got one!',26124),
(84265,'enUS','Poisoning','',26124),
(84266,'enUS','Ah, traveler, did you expect more from a humble artist? A trinket perhaps? Coin, or a keepsake?','',26124),
(84267,'enUS','Just look in front of you. The true treasure is the beauty of this moment.','',26124),
(84268,'enUS','Worthless...','',26124),
(84269,'enUS','Do not waver!','',26124),
(84270,'enUS','Strike them down!','',26124),
(84271,'enUS','Victory is near!','',26124),
(84272,'enUS','Show them no mercy!','',26124),
(84273,'enUS','Your blood will spill!','',26124),
(84274,'enUS','Taste your own death!','',26124),
(84275,'enUS','','Steel yourselves!',26124),
(84276,'enUS','','Never give up!',26124),
(84277,'enUS','','We will not falter!',26124),
(84278,'enUS','','Be strong!',26124),
(84279,'enUS','','Keep your guard up!',26124),
(84280,'enUS','','I\'ve got this.',26124),
(84281,'enUS','You have not seen the likes of me!','',26124),
(84282,'enUS','Think you\'ve seen magic?','',26124),
(84283,'enUS','Together, we cannot fail!','',26124),
(84284,'enUS','Hey, thanks again for helping me down in Pinchwhistle Point.','',26124),
(84285,'enUS','','Hey if you ever need some engines fixed or something burned down just ask anytime!$b$bI\'ll even give you the employee discount of 0% off!',26124),
(84286,'enUS','Alright gang, it\'s archaeology time!','',26124),
(84287,'enUS','','Boss! My readings indicate a spatial anomaly around the artifact!',26124),
(84288,'enUS','We\'ll need to neutralize it. Set your archaeology blasters to dissipate!','',26124),
(84289,'enUS','I\'m getting feedback! My archaeology blaster can\'t hold it!','',26124),
(84290,'enUS','I just had to wear the red shirt...','',26124),
(84291,'enUS','Set blasters to full power!','',26124),
(84292,'enUS','','Such skill! You must have gone through much to learn how to fight like that. Only Zulmork and Cromaug remain.',26124),
(84293,'enUS','It\'s a live one!','It\'s a live one!',26124),
(84294,'enUS','It\'s fighting!','It\'s fighting!',26124),
(84295,'enUS','','Only Cromaug remains now.',26124),
(84296,'enUS','I\'m not letting you get away!','I\'m not letting you get away!',26124),
(84297,'enUS','','Zulmork is our last target.',26124),
(84298,'enUS','','Such skill! You must have gone through much to learn how to fight like that. Two targets remain.',26124),
(84299,'enUS','','Now only Cromaug remains.',26124),
(84300,'enUS','','Now we need to hunt down Vorgorsh.',26124),
(84301,'enUS','','Such skill! You must have gone through much to learn how to fight like that. Two targets remain.',26124),
(84302,'enUS','','Now we hunt down Vorgorsh.',26124),
(84303,'enUS','','Now we hunt down Zulmork.',26124),
(84304,'enUS','|TInterface\\Icons\\ability_hanzandfranz_bodyslam.blp:20|t$n is going to be hit by |cFFF00000|Hspell:159646|h[Body Slam]|h|r!','',26124),
(84305,'enUS','','I\'ll head to your garrison and get your mages in line. See you there!',26124),
(84306,'enUS','If you\'ll excuse me, commander, I\'d like to see your garrison and get your mages in line.','',26124),
(84307,'enUS','Only Cromaug remains now.','',26124),
(84308,'enUS','A fine strike! Onward to our next kill! Both Vorgorsh and Cromaug remain.','',26124),
(84309,'enUS','Now we need to hunt down Vorgorsh.','',26124),
(84310,'enUS','Only Cromaug remains now.','',26124),
(84311,'enUS','A fine strike! Onward to our next kill! Both Zulmork and Cromaug remain.','',26124),
(84312,'enUS','Zulmork is our last target.','',26124),
(84314,'enUS','A fine strike! Onward to our next kill! Both Zulmork and Vorgorsh remain.','',26124),
(84315,'enUS','Now we hunt down Zulmork.','',26124),
(84316,'enUS','Now we hunt down Vorgorsh.','',26124),
(84317,'enUS','Archmage, if $p is to succeed in their mission the vanguard must not fall!','',26124),
(84318,'enUS','I will not stand by and watch our heroes be destroyed!','',26124),
(84319,'enUS','FURY OF STORMS, HEAR MY PLEA!','',26124),
(84320,'enUS','I will not be able to defend the front for much longer. My power here is greatly diminished. $p must succeed or Azeroth will fall.','',26124),
(84321,'enUS','Commander, reinforcements from the arcane sanctum have arrived!','',26124),
(84322,'enUS','Nooooo! You can\'t take Wibson, he\'s all I have left!','',26124),
(84323,'enUS','Avenge me, Wibson. Avenge me...','',26124),
(84324,'enUS','Sappy\'s feeder?','',26124),
(84325,'enUS','Sappy hungry.','',26124),
(84326,'enUS','<Feed Sappy.>','<Feed Sappy.>',26124),
(84327,'enUS','Turn away to avoid Roakk\'s |cFFFF0000|Hspell:166139|h[Blinding Light]|h|r','',26124),
(84328,'enUS','If you\'ve got the gold, I\'ve got the goods!','',26124),
(84329,'enUS','Let\'s take a look','Let\'s take a look',26124),
(84330,'enUS','','D\'kaan, let\'s get in there.',26124),
(84331,'enUS','Siege engines, fire.','',26124),
(84332,'enUS','','Alliance, advance!',26124),
(84333,'enUS','Warsong, bring me their heads!','',26124),
(84334,'enUS','','We\'ll protect you while you flank them to the west.',26124),
(84335,'enUS','Watch out. Wolfriders!','',26124),
(84336,'enUS','Welcome! Come rest your head and leave your coin!','',26124),
(84337,'enUS','Warsong, run them down!','',26124),
(84338,'enUS','Fetch, girl.','',26124),
(84339,'enUS','You won\'t survive this.','',26124),
(84340,'enUS','Finish these weaklings.','',26124),
(84341,'enUS','No... this can\'t be.','',26124),
(84342,'enUS','','We need to move up.',26124),
(84343,'enUS','Leap from your caves, my wolves.','',26124),
(84344,'enUS','Seal those wolf dens!','',26124),
(84345,'enUS','Bad news, commander. They\'ve enslaved Durn the Hungerer.','',26124),
(84346,'enUS','','We have to go through the beast to get to Garrosh.',26124),
(84347,'enUS','Loose the Hungerer.','',26124),
(84348,'enUS','','Get into the Holy Light.',26124),
(84349,'enUS','Rangari, fire!','',26124),
(84350,'enUS','Come, draenei witch. I\'m waiting.','',26124),
(84351,'enUS','','D\'kaan, I need you and our forces to stay here.',26124),
(84352,'enUS','','Buy us the time we need to deal with Garrosh.',26124),
(84353,'enUS','Whatever happens, Maraad would be proud of you.','',26124),
(84354,'enUS','Blow open these gates!','',26124),
(84355,'enUS','You\'re a fool to come here.','',26124),
(84356,'enUS','You think after everything, you can kill me?','',26124),
(84357,'enUS','','We\'ll bring you to justice, monster!',26124),
(84358,'enUS','Justice. You don\'t know the meaning of the word.','',26124),
(84359,'enUS','I am your death.','',26124),
(84360,'enUS','Taste Gorehowl\'s steel.','',26124),
(84361,'enUS','I cannot be defeated.','',26124),
(84362,'enUS','Now, you die.','',26124),
(84363,'enUS','Garrosh!','',26124),
(84364,'enUS','Thrall? You\'re too late, old friend.','',26124),
(84365,'enUS','No. No more, Garrosh. Just you and me.','',26124),
(84366,'enUS','I challenge you to Mak\'gora.','',26124),
(84367,'enUS','','Thrall, no.',26124),
(84368,'enUS','Very well, shaman. We finish this alone, where it all began...','',26124),
(84369,'enUS','... at the Stones of Prophecy.','',26124),
(84370,'enUS','','Commander, over here.',26124),
(84371,'enUS','','Now, commander!',26124),
(84372,'enUS','Commander, over here.','',26124),
(84373,'enUS','Now, commander!','',26124),
(84374,'enUS','I\'ve seen it in my dreams... these strangers from other worlds would burn everything we\'ve fought for.','',26124),
(84375,'enUS','But it is orc blood that runs in the veins of Draenor!','',26124),
(84376,'enUS','Go forth, Iron Horde!  Make corpses of our enemies.','',26124),
(84377,'enUS','For the glory of Grommash!','',26124),
(84378,'enUS','','Well done! Two more to go.',26124),
(84379,'enUS','Masterful fighting! Two more to go.','',26124),
(84380,'enUS','A fine strike! Two remain.','',26124),
(84381,'enUS','','Such skill! You must have gone through much to learn how to fight like that. Two targets remain.',26124),
(84382,'enUS','','RAMPAGING BEASTS CHARGING TO OUR POSITION!',26124),
(84383,'enUS','Conserve your energy. We must ensure that $p completes the mission. I will deal with the beasts myself!','',26124),
(84384,'enUS','Aggra, let\'s get in there.','',26124),
(84385,'enUS','Light, grant me your vengeance and $p your protection.','',26124),
(84386,'enUS','','Demolishers, fire.',26124),
(84387,'enUS','Advance!','',26124),
(84388,'enUS','Warsong, bring me their heads!','',26124),
(84389,'enUS','We\'ll protect you while you flank them to the west.','',26124),
(84390,'enUS','Watch out. Wolfriders!','',26124),
(84391,'enUS','Warsong, run them down!','',26124),
(84392,'enUS','You won\'t survive this.','',26124),
(84393,'enUS','Fetch, girl.','',26124),
(84394,'enUS','Finish these weaklings.','',26124),
(84395,'enUS','No... this can\'t be.','',26124),
(84396,'enUS','','We need to move up.',26124),
(84397,'enUS','Leap from your caves, my wolves.','',26124),
(84398,'enUS','','Seal those wolf dens!',26124),
(84399,'enUS','','Bad news, commander. They\'ve enslaved Durn the Hungerer.',26124),
(84400,'enUS','We have to go through the beast to get to Garrosh.','',26124),
(84401,'enUS','Loose the Hungerer.','',26124),
(84402,'enUS','Darkspear, fire!','',26124),
(84403,'enUS','','Get next to my healing totem.',26124),
(84404,'enUS','Come, warchief. I am waiting.','',26124),
(84405,'enUS','Aggra, I need you and our forces to stay here.','',26124),
(84406,'enUS','Buy us the time we need to deal with Garrosh.','',26124),
(84407,'enUS','','Please know, Durotan, you have been like a father to Thrall.',26124),
(84408,'enUS','','Blow open these gates!',26124),
(84409,'enUS','You\'re a fool to come here.','',26124),
(84410,'enUS','You think after everything, you can kill me?','',26124),
(84411,'enUS','We\'ll bring you to justice, monster!','',26124),
(84412,'enUS','Justice. You don\'t know the meaning of the word.','',26124),
(84413,'enUS','I am your death.','',26124),
(84414,'enUS','I cannot be defeated.','',26124),
(84415,'enUS','Now, you die.','',26124),
(84416,'enUS','Garrosh!','',26124),
(84417,'enUS','Thrall? You\'re too late, old friend.','',26124),
(84418,'enUS','No. No more, Garrosh. Just you and me.','',26124),
(84419,'enUS','I challenge you to Mak\'gora.','',26124),
(84420,'enUS','Thrall, no.','',26124),
(84421,'enUS','Very well, shaman. We finish this alone, where it all began...','',26124),
(84422,'enUS','... at the Stones of Prophecy.','',26124),
(84423,'enUS','','Commander, over here.',26124),
(84424,'enUS','Commander, over here.','',26124),
(84425,'enUS','','Now, commander!',26124),
(84426,'enUS','Now, commander!','',26124),
(84427,'enUS','Taste Gorehowl\'s steel.','',26124),
(84428,'enUS','Fight on, brothers and sisters! $p will see us through this war!','',26124),
(84429,'enUS','Merely adolescent gronn, Khadgar. Nothing that Commander $p couldn\'t handle alone.','',26124),
(84430,'enUS','The shadows gather in Veil Terokk, beneath the lonely spire.','',26124),
(84431,'enUS','Let me get to da beaten!','',26124),
(84432,'enUS','\'Dis mace wants to help out with ya beaten.','',26124),
(84433,'enUS','You done getting beaten?','',26124),
(84434,'enUS','Dis here be your last beaten!','',26124),
(84435,'enUS','I gots something to tell you!','',26124),
(84436,'enUS','I heard you like da beaten!','',26124),
(84437,'enUS','Thank you! I would have surely died in there.','Thank you! I would have surely died in there.',26124),
(84438,'enUS','I\'ll never forget this.','I\'ll never forget this.',26124),
(84439,'enUS','Thank the light! I shall go rescue my sisters.','Thank the light! I shall go rescue my sisters.',26124),
(84440,'enUS','You are a true hero.','You are a true hero.',26124),
(84441,'enUS','Lok\'tar!','Lok\'tar!',26124),
(84442,'enUS','I\'m going to slay every ogre I see!','I\'m going to slay every ogre I see!',26124),
(84443,'enUS','Thank you, $n. May the spirits guide you.','Thank you, $n. May the spirits guide you.',26124),
(84444,'enUS','Sweet freedom!','Sweet freedom!',26124),
(84445,'enUS','Where is my power, ogre?','',26124),
(84446,'enUS','Your power? (It\'s MY power!)','',26124),
(84447,'enUS','You will obey, disciple. Hand over its reins.','',26124),
(84448,'enUS','I think not. (We\'re done taking orders from you!)','',26124),
(84449,'enUS','Now THAT\'S how archaeology is done!','',26124),
(84450,'enUS','Hey Boss, you sure this thing\'s safe?','',26124),
(84451,'enUS','Fel energies are even now devouring Exarch Hataaru\'s soul. We must act quickly.$b$bSoulbinder Nyami will anchor Hataaru\'s spirit to this realm while I exorcise the demons assaulting him. With luck, we will find out who murdered him.$b$bIt will be up to you to destroy the evil as I unleash it. Are you ready, $n?','',26124),
(84452,'enUS','I am ready. Begin the ritual, Exarch.','I am ready. Begin the ritual, Exarch.',26124),
(84453,'enUS','A traitor among us - a fallen Exarch!$b$bThis is... unthinkable.','',26124),
(84454,'enUS','Let\'s get moving! $n, we\'ll see you back at camp.','',26124),
(84455,'enUS','I will be unable to help once the ritual begins. Stay focused.','',26124),
(84456,'enUS','','The body is ready, Exarch. I will anchor his spirit.',26124),
(84457,'enUS','Of course! A little cosmic radiation never hurt anybody!','',26124),
(84458,'enUS','','Hey there and welcome to the Rusty Cylinder Bar and Grill!',26124),
(84459,'enUS','Golad, maloch, valsheva. Follow the sound of my voice, spirit - lend your sight to the living. Golad, maloch, valsheva!','',26124),
(84460,'enUS','Begone, exarch. This one, and all he knows, belongs to us now.','',26124),
(84461,'enUS','You may have claimed his body, but his immortal soul is mine to protect.','',26124),
(84462,'enUS','Golad, maloch, valsheva! Golad, maloch, valsheva - Light give me strength...','',26124),
(84463,'enUS','We\'ve learned much from K\'ure. (We\'re writing a book.)','',26124),
(84464,'enUS','You\'re insane.','',26124),
(84465,'enUS','Run away, old man. (Soon Highmaul will burn. Then, the world!)','',26124),
(84466,'enUS','','The glider is good to go! Just let us know if you find anything good, okay?',26124),
(84467,'enUS','','Looks like this spot\'s dried up. Maybe you should try one of the other gliders.',26124),
(84468,'enUS','Golad, maloch, valsheva. Follow the sound of my voice, spirit. Lend your sight to the living. Golad, maloch, valsheva!','',26124),
(84469,'enUS','Quickly now, I have a bad feeling about all this...','',26124),
(84470,'enUS','Hiya, pal. Nice day for some gliding, eh?','',26124),
(84471,'enUS','You... strange invaders...','',26124),
(84472,'enUS','You seek to disable the Dark Portal?','',26124),
(84473,'enUS','I can help you. Just... set me free.','',26124),
(84474,'enUS','How many Artifact Fragments have we collected?','How many Artifact Fragments have we collected?',26124),
(84475,'enUS','A persistent one, aren\'t ya? I think you\'re safe to move on now, boss.','',26124),
(84476,'enUS','We currently have $9250w collected. We need $9706w total.','',26124),
(84477,'enUS','Glider\'s all yours, friend. I\'d go myself, but untimely death is not my thing.','',26124),
(84478,'enUS','Still alive, eh? If I were you, I\'d cut my losses while you\'re ahead. There can\'t be anything more worth finding around here anyway.','',26124),
(84479,'enUS','There\'s a party in your heart, and all the bladed weapons are invited.  Have a pleasant day.','',26124),
(84480,'enUS','My presence is requested for duty.  I must leave immediately.','',26124),
(84481,'enUS','Rent my constructs.','',26124),
(84482,'enUS','Ok, I\'ll rent them.','Ok, I\'ll rent them.',26124),
(84483,'enUS','Put them away please.','Put them away please.',26124),
(84484,'enUS','How do you like my constructs?','',26124),
(84485,'enUS','Rent Constructs for 1 copper?','Rent Constructs for 1 copper?',26124),
(84486,'enUS','Not until we know. We must know who did this to him!','',26124),
(84487,'enUS','Exoch, maloch, talomai! Hataaru, come to the light...','',26124),
(84488,'enUS','K\'ure will be deeply missed by my people, but the story of your courage in the face of evil will inspire them.','',26124),
(84489,'enUS','','Exarch, they\'re tearing his soul apart. We must stop this!',26124),
(84490,'enUS','Auchindoun... they wanted...','',26124),
(84491,'enUS','...wanted what, Hataaru? The codes to Auchindoun? Your security wards?','',26124),
(84492,'enUS','','Maladaar. We\'re losing him.',26124),
(84493,'enUS','...the Exarch\'s orders...','',26124),
(84494,'enUS','Who, Hataaru? Who had you killed?','',26124),
(84495,'enUS','<coughs> What foul stench!  I don\'t think I got a full breath of it though...','',26124),
(84496,'enUS','...Soulbinder...','',26124),
(84497,'enUS','%s points at Soulbinder Nyami.','',26124),
(84498,'enUS','','We were about to lose him. You saw him - he called out to me for help. His spirit is safe now.',26124),
(84499,'enUS','What happened? Why did you stop it?','',26124),
(84500,'enUS','He mentioned an Exarch. A betrayal from within the council itself?','',26124),
(84501,'enUS','Nyami, take the body to Auchindoun and lay it to rest.','',26124),
(84502,'enUS','%s is about to vomit ectoplasm!','',26124),
(84503,'enUS','Purge the void energy from the Soulgrinder!','',26124),
(84504,'enUS','The Soulgrinder is purged!','',26124),
(84505,'enUS','','With all these rampaging elementals, we\'re running short on pilots. Got plenty of gliders, though. Take one out for a spin and see what you find!',26124),
(84506,'enUS','prelude 2. Stage: $8883w sub-stage: $8938w','',26124),
(84507,'enUS','','No sense in risking your neck out there anymore. We\'ve cleared out all of the profitable excavations.',26124),
(84512,'enUS','','We\'ll find a way out of this, that\'s what Pinchwhistles do best!',26124),
(84513,'enUS','Stop - stop the ritual at once! Focus. We must protect his spirit.','',26124),
(84514,'enUS','Our forces are faltering, and my energy is waning, $n. We have precious little time left before we are overwhelmed.','',26124),
(84515,'enUS','The mana bombs are placed!','The mana bombs are placed!',26124),
(84516,'enUS','Use whatever means are necessary, champion. Azeroth\'s final hope lies with you.','',26124),
(84517,'enUS','You cannot escape us, scrollkeeper!','',26124),
(84518,'enUS','Your beak will make a fine trophy for the High Sage!','',26124),
(84519,'enUS','Your pitiful uprising ends here.','',26124),
(84520,'enUS','Did you think yourself safe in the woods? Rukhmar sees all!','',26124),
(84521,'enUS','Filthy, accursed wretch - allow me to end your misery.','',26124),
(84522,'enUS','Ah, such easy prey.','',26124),
(84523,'enUS','Found you, Reshad!','',26124),
(84524,'enUS','RuaAWK!! What\'s this?!','',26124),
(84525,'enUS','A decoy?!','',26124),
(84526,'enUS','My eyes! What\'s happening?!','',26124),
(84527,'enUS','Rrre... shaaad...','',26124),
(84528,'enUS','WAAWWK! Where... where am I?','',26124),
(84529,'enUS','','Did the boss send you?\n\nLook, if he asks, just tell him I\'m doing some underwater excavation.',26124),
(84530,'enUS','If you ask me, excavating giant mushrooms sounds like a bad idea, but you\'re welcome to grab a glider and take a look. After all, it\'s not my time you\'re wastin\'.','',26124),
(84531,'enUS','I doubt you\'ll find anything more out there. All I\'m seeing here is mushrooms, mushrooms, and more mushrooms.','',26124),
(84532,'enUS','This is it... this is it!','',26124),
(84533,'enUS','Dead... or used up.  I was so sure I would find what I needed here!','',26124),
(84534,'enUS','Wait, I feel it.  It is closer now.  Quickly! To me!','',26124),
(84535,'enUS','This unfortunate soul seems to have suffered a rather disastrous fall.','',26124),
(84536,'enUS','Stop wasting time, Goblin. Keep that city in sight.','Stop wasting time, Goblin. Keep that city in sight.',26124),
(84537,'enUS','Don\'t lose focus, mage. We don\'t have all day.','Don\'t lose focus, mage. We don\'t have all day.',26124),
(84538,'enUS','Keep that portal open. Our Far Seers have almost calibrated the cannon.','Keep that portal open. Our Far Seers have almost calibrated the cannon.',26124),
(84539,'enUS','Peon, get those bombs in the cannon. NOW!','Peon, get those bombs in the cannon. NOW!',26124),
(84540,'enUS','What are you doing, maggot? You\'re supposed to have this done yesterday!','What are you doing, maggot? You\'re supposed to have this done yesterday!',26124),
(84541,'enUS','Hurry it up!','Hurry it up!',26124),
(84542,'enUS','Far Seers, status report!','Far Seers, status report!',26124),
(84543,'enUS','Shaman, give me an update.','Shaman, give me an update.',26124),
(84544,'enUS','What do you see?','What do you see?',26124),
(84545,'enUS','We\'re nearly there, Captain.','We\'re nearly there, Captain.',26124),
(84546,'enUS','She\'s just ahead, Captain.','She\'s just ahead, Captain.',26124),
(84547,'enUS','Almost in sight, Captain.','Almost in sight, Captain.',26124),
(84548,'enUS','','I have laid out a list of available missions for your forces on the command table for you.$B$BI will relay any orders to your garrison for your convenience, commander.',26124),
(84549,'enUS','We must go.  I am so close now...  I must find it.','',26124),
(84550,'enUS','I can\'t see...  I need a moment...','',26124),
(84551,'enUS','Is... is this the place?  Is it here?  Clear these creatures so I can think!','',26124),
(84552,'enUS','I\'m okay.  We must keep moving.  It calls to us.','',26124),
(84553,'enUS','Step aside, $p. Let us see if this fellow had anything worthwhile...','',26124),
(84554,'enUS','Mind the door, will you?','',26124),
(84555,'enUS','Argh!  I can\'t think with all these beasts shouting at me.  Stop their screaming!','',26124),
(84556,'enUS','Almost... almost there.  Just a little further.  Soon...','',26124),
(84557,'enUS','We are finally here... yet something is wrong.  I have to get closer... I have no choice!','',26124),
(84558,'enUS','I see it all now. It wants me to take the spores out of the Crimson Fen and give them to my friends.  I... must do it!  You must stop me $p!','',26124),
(84559,'enUS','Hold off the Adherents.','Hold off the Adherents.',26124),
(84560,'enUS','My, my... What a curious collection...','',26124),
(84561,'enUS','Percy, what\'s that you\'ve got there? Come, now, let\'s see it...','',26124),
(84562,'enUS','Fifty Layers of Shadow?! PERCIVAL, YOU PUT THAT BACK THIS INSTANT.','',26124),
(84563,'enUS','Ah, here\'s something! The Saga of Terokk.','',26124),
(84564,'enUS','And he\'s written notes inside. Here, have a look.','',26124),
(84565,'enUS','Nasty bird...','',26124),
(84566,'enUS','In death... I am free...','',26124),
(84567,'enUS','My life for Commander $p.','My life for Commander $p.',26124),
(84568,'enUS','Throm-Ka, Commander.','Throm-Ka, Commander.',26124),
(84569,'enUS','Lok\'tar, commander.','Lok\'tar, commander.',26124),
(84570,'enUS','We live and die for your will, commander.','We live and die for your will, commander.',26124),
(84571,'enUS','At your service, commander.','',26124),
(84572,'enUS','Travel well, commander.','',26124),
(84573,'enUS','The spirits smile upon you, commander.','',26124),
(84574,'enUS','May the wind carry tales of your greatness, commander.','',26124),
(84575,'enUS','Destroy the relic, invader!','',26124),
(84576,'enUS','Those Iron cowards were using us as conduits to power their portal. They will regret that.','',26124),
(84577,'enUS','The Shadow Council thanks you.','',26124),
(84578,'enUS','You... outsider. Destroy that relic, and set us free. (Crush the relic! Smash the relic!)','',26124),
(84579,'enUS','Crush the relic! Smash the relic!','',26124),
(84580,'enUS','Seek out Gul\'dan if you truly wish to stop the Iron Horde. (Gul\'dan! Gul\'dan powers the portal!)','',26124),
(84581,'enUS','Gul\'dan! Gul\'dan powers the portal!','',26124),
(84582,'enUS','Dig faster! The Sorcerer King wants more relics!','',26124),
(84583,'enUS','Work faster! The key to the relic is in here somewhere!','',26124),
(84584,'enUS','No more smashing artifacts! The Sorcerer King wants them unbroken!','',26124),
(84585,'enUS','Kill any intruders on sight! We supposed to keep what we doing secret!','',26124),
(84586,'enUS','First rule of digging for relics is don\'t talk about the relics!','',26124),
(84587,'enUS','Why you idiots break so many wagons? Now you have to carry the relics to Highmaul!','',26124),
(84588,'enUS','If you slack off you gonna answer to the Sorcerer King!','',26124),
(84589,'enUS','Look! The portal grows weaker!','',26124),
(84590,'enUS','Hold that front! Our work is nearly done!','',26124),
(84591,'enUS','Iron Horde! The intruders are freeing our prisoners!','',26124),
(84592,'enUS','Stop them!','',26124),
(84593,'enUS','Thank you, stranger.','',26124),
(84594,'enUS','Rarrgh! I hope you like dying!','',26124),
(84595,'enUS','Puny, $r! I\'ll squish you like a bug!','',26124),
(84596,'enUS','I want to smash you to bits! Rarrgh!','',26124),
(84597,'enUS','Hi','Hi',26124),
(84598,'enUS','I\'m going to crush your skull!','',26124),
(84599,'enUS','You going to pay for stealing the relic! Rargh!','',26124),
(84600,'enUS','You and those pesky goblins gonna pay!','',26124),
(84601,'enUS','That relic was for Highmaul! You gonna die!','',26124),
(84602,'enUS','You stole the relic, now I gonna crush your bones!','',26124),
(84603,'enUS','Keep it down, boss. If the Warsong found us up here, well, let\'s just say it\'d be bad for business.','',26124),
(84604,'enUS','These Warsong guys couldn\'t possibly need all of the supplies they\'ve been stockpiling here - especially after the Horde puts the hurt on \'em. \n\nSo the way I see it, if we want to take some to make some profit on the side, what\'s the harm?','',26124),
(84605,'enUS','The miasma here coats everything! We should not stay long...','',26124),
(84606,'enUS','I can\'t seem to get this filth off of me... don\'t worry, I\'ve crawled through worse...','',26124),
(84607,'enUS','It is so hazy here, I can barely see... and its so loud.  I wish everyone would be quiet!','',26124),
(84608,'enUS','Tell D\'kaan... I am... sorry...','',26124),
(84609,'enUS','No sticky spores are going to stop me!','',26124),
(84610,'enUS','Let\'s be done with this. There is power here, I can smell and taste it! No screaming marsh or misty monsters are going to stop me!','',26124),
(84611,'enUS','We... we could have ruled Gorgrond with this... red everywhere...','',26124),
(84612,'enUS','Just one more bolt to tighten....','',26124),
(84613,'enUS','The goren fled, but I don\'t think they fled from us...','',26124),
(84614,'enUS','','<Ka\'alu calmly gazes at you a moment before her voice fills your thoughts.>$b$bIn all of these eons I have never allowed anyone to ride upon my back. But now is the time for my vanity to end, too many lives hang in the balance.$b$bThe children of Rukhmar threaten both these accursed ones and my flock. I know that it is only together, with all of our strength, can we prevail.$b$bAre you ready to do that which must be done?',26124),
(84615,'enUS','','Careful if you plan on taking the glider over Grommashar, pal. Those orcs down there are not too fond of the pop-in.',26124),
(84616,'enUS','','I think you cleaned those Warsong out good an\' proper. No sense in risking your neck out there anymore.',26124),
(84617,'enUS','','Nagrand is just full of amazing artifacts and the Steamwheedle Preservation Society is here to find them!',26124),
(84618,'enUS','What does the Ancient of War do?','What does the Ancient of War do?',26124),
(84619,'enUS','Back to the shadows for us, Percy.','',26124),
(84620,'enUS','Ahh, it\'s you. Trust me, friend, I will handle this. You may go.','',26124),
(84621,'enUS','','Well \'ello there! \'Ave ya got somethin\' for me today?',26124),
(84622,'enUS','','Even the skies can be dangerous in Gorgrond. Be on your guard.',26124),
(84623,'enUS','I need to meet with Rangari Erdanii.','I need to meet with Rangari Erdanii.',26124),
(84624,'enUS','Fangraal will march into the Road of Glory and clear it of any Horde it finds.','',26124),
(84625,'enUS','What is that? Is that Maladaar\'s work? No no, you don\'t need to do that. He is not to be trusted.','',26124),
(84626,'enUS','','The Gateways are up and running, $n! Use them to move around Ashran faster.',26124),
(84627,'enUS','','The Warlocks will erect Gateways so we can move around Ashran faster. We just need the magical power from those scattered artifact pieces found around Ashran. $B$BHow many have you brought me?',26124),
(84628,'enUS','She\'s nothing now, a twisted soul chained to our world.  My sister was so sweet, so loving, so young... The Shadowmoon did this!  Twisted her by some foul magic! They left her walking the world as a shadow, crying out in eternal torment.\n\nI couldn\'t.  I can\'t.  I cannot end her pain.  I cannot be the one to relive her pain.\n\nRelease her spirit.  Put her to rest.  I cannot bear seeing her like this.','',26124),
(84629,'enUS','So you\'ve done it?  Well, then.  Be gone and leave me to my mourning.\n\nSo young... she was so young...','',26124),
(84630,'enUS','','Our work here is finished. The forgotten children of Rukhmar fight bravely against their headstrong brethren. Now, we must continue our attack. Hold tightly, our destination is the next spire.',26124),
(84631,'enUS','','We currently have $9261w collected. We need $9708w total.',26124),
(84632,'enUS','Yield, old friend... and we shall show mercy in your final hour.','',26124),
(84633,'enUS','','Socrethar! We bear proof of your slain lieutenants. Will you take retribution against us, or are you afraid?',26124),
(84634,'enUS','','They fell beneath the glory of the Light. As you will fall before us, demon!',26124),
(84635,'enUS','Who dares to challenge me? I am the voice of those who will burn this world to ash!','',26124),
(84636,'enUS','Never! My power is that of the Burning Legion... endless.','',26124),
(84637,'enUS','Now, DIE!','',26124),
(84638,'enUS','','When you see Gazmolf, tell him Gabby sent you!',26124),
(84639,'enUS','That wretched outcast begged for death in the end - and so will you!','',26124),
(84640,'enUS','We can\'t allow that relic to fall into ogre hands! It belongs in a private collection!','',26124),
(84641,'enUS','So this is what the little sneak was hiding... the High Sage will be pleased.','',26124),
(84642,'enUS','','The Gateways activate at the South-East and North-West of Ashran. Use them to teleport between the two points.',26124),
(84643,'enUS','What do the Gateways do?','What do the Gateways do?',26124),
(84644,'enUS','Failure!','',26124),
(84645,'enUS','Ornekka, it is not safe here - the Adherents are out in force. Come with us to Veil Terokk.','',26124),
(84646,'enUS','Oh, how sweet of you, Reshad! I never knew you cared.','',26124),
(84647,'enUS','But my old bones would only slow you down. I\'ll be fine here.','',26124),
(84648,'enUS','See you on the next dig, $n! We couldn\'t have done it without you!','',26124),
(84649,'enUS','Well fought, Lady Liadrin. Let us meet back at the Spire of Light.','',26124),
(84650,'enUS','','Same to you, Exarch. We have much to report to Archmage Khadgar.',26124),
(84651,'enUS','Very well. Let us proceed, $p.','',26124),
(84652,'enUS','A Gronnling is terrifying your troops!','A Gronnling is terrifying your troops!',26124),
(84653,'enUS','I have brought this as a peace offering. I hope we can become close allies.','I have brought this as a peace offering. I hope we can become close allies.',26124),
(84654,'enUS','You bring this strange gift and helped those in Skettis... yes, I think we can come to an arrangement. The shadows cover much.','',26124),
(84655,'enUS','What have we here? A friend of the family?','',26124),
(84656,'enUS','We cannot allow the Burning Legion to gain a foothold here on Draenor. Socrethar\'s reign must end.','',26124),
(84657,'enUS','','Socrethar is working directly with the Shadow Council. To stop the Burning Legion, we must end his reign.',26124),
(84658,'enUS','I admit, even in Socrethar\'s madness, there was a hint of truth.','',26124),
(84659,'enUS','He questioned our complacency. Perhaps we have been too content, too SAFE, hiding here on Draenor.','',26124),
(84660,'enUS','A call is coming, hero. I feel it, large and looming, just beyond the horizon. When the time  comes, the draenei must answer.','',26124),
(84661,'enUS','','The |c00FFFF00|Hspell:178535|h[Warlock Gateway]|h|r has been activated! Check your map for the locations.',26124),
(84662,'enUS','','Today, we have defeated one of Gul\'dan\'s strongest allies.',26124),
(84663,'enUS','','Without their leader, the Sargerei will crumble. The Auchenai will soon be able to reclaim their city.',26124),
(84664,'enUS','','The |c00FFFF00|Hspell:178535|h[Warlock Gateway]|h|r has been destroyed by the Horde!',26124),
(84665,'enUS','','For now, we can consider this a monumental victory. Thank you, hero.',26124),
(84666,'enUS','The vanguard will hold the front, commander. You must complete your mission!','The vanguard will hold the front, commander. You must complete your mission!',26124),
(84667,'enUS','Almost there. Come along, Percy!','',26124),
(84668,'enUS','I am ready to fly, Ka\'alu.','I am ready to fly, Ka\'alu.',26124),
(84669,'enUS','Set me free!','',26124),
(84670,'enUS','All\'s quiet!','All\'s quiet!',26124),
(84671,'enUS','The news!','The news!',26124),
(84672,'enUS','Raastok, I need a shroud at that dig site. Kura, back him up.','',26124),
(84673,'enUS','Shadows gather...','',26124),
(84674,'enUS','The Adherents grow bolder each day. It\'s all we can do to keep Veil Terokk shrouded from them.','',26124),
(84675,'enUS','Do you have the relics?','',26124),
(84676,'enUS','Yes, yes. And something unexpected, too! We have much to discuss.','',26124),
(84677,'enUS','Go on ahead, I would like a word with $p.','',26124),
(84678,'enUS','','<The Raven Mother\'s voice coos within your mind.>$B$BDo you know why I allow these accursed, forgotten children of Rukhmar to live among my flock? it is because I weep for them.$B$BThey are trapped between two gods: one who fears and rejects them, and one who would enslave them to his dark will.$B$BTheir only champion abandoned them long ago, and nobody has stood beside them since.$B$BUntil you came along.',26124),
(84679,'enUS','Thanks, commander. I don\'t know what I\'d do if something happened to her.','',26124),
(84680,'enUS','Better get used to loss, kid. That\'s life.','',26124),
(84681,'enUS','We\'re frostwolf. We don\'t lose, blood elf.','',26124),
(84682,'enUS','','My family must be avenged.',26124),
(84683,'enUS','','Thank you for sending the commander, Mankrik.',26124),
(84684,'enUS','I don\'t ever want us to be apart again.','',26124),
(84685,'enUS','Good on you, kid.','',26124),
(84687,'enUS','Reshad! You survived Skettis!','',26124),
(84688,'enUS','Yes, just barely. Are we late?','',26124),
(84689,'enUS','','The spirits of my family are forever with in my heart.',26124),
(84690,'enUS','','Thank you for everything, commander.$B$BI\'m happy to be back here with Mankrik, even if he is a jerk sometimes. Don\'t tell him, but I kinda like him, too.',26124),
(84691,'enUS','I feel like a fool for not having gone with her.','',26124),
(84692,'enUS','I\'m indebted to you for life, commander.$B$BOlgra and I were promised to each other. One day, she\'s going to be my wife.','',26124),
(84693,'enUS','Heretics! Kill! Feast!','',26124),
(84694,'enUS','Damn him. I thought I\'d gotten rid of Maladaar when I gave him up to the Iron Horde.','',26124),
(84695,'enUS','Yes, I had Hataaru killed. And you are next.','',26124),
(84696,'enUS','The Legion\'s power is unsurpassed.','',26124),
(84697,'enUS','','This jungle is beautiful. I have never seen a place like this before.$b$bOf course, Kaalya keeps insisting that is why \'the jungle will kill you.\'',26124),
(84698,'enUS','REMOVE - Good work. The artifact is yours to use.','',26124),
(84699,'enUS','','This jungle is no place for the temple-kneeler or the metal-bender.$b$bYou, however, I am not so sure of.$b$bYour weapons and gear speak of one who is experienced in a number of environments.',26124),
(84700,'enUS','Rifling Books','Rifling Books',26124),
(84701,'enUS','This is a traditional wayshrine. Terokk built many of them around the land to guide outcasts to Skettis.','',26124),
(84702,'enUS','If we are to move forward, we must understand what we\'ve left behind.','',26124),
(84703,'enUS','This blade looks worn and rusted... you said it was newly smithed!','',26124),
(84704,'enUS','This axe couldn\'t chop a twig... let alone a gladiator!','',26124),
(84705,'enUS','This blade has someone\'s initials engraved in it... did you find this on the arena floor?','',26124),
(84706,'enUS','These blades are too dull for combat....','',26124),
(84707,'enUS','Your prices are reasonable... but these weapons are battered.','',26124),
(84708,'enUS','Are these gladiator weapons or souvenirs?','',26124),
(84709,'enUS','I would sooner take a tree branch into combat than this shield....','',26124),
(84710,'enUS','Good to see you again, $p.$B$B I knew you couldn\'t leave the Adherents to run free - not after witnessing what they did in Aruuna and Veil Shadar.','',26124),
(84711,'enUS','You call that a battle axe? It looks more like a cheap hatchet....','',26124),
(84712,'enUS','The fate of Azeroth depends on you, $n!','The fate of Azeroth depends on you, $n!',26124),
(84713,'enUS','This is it, Commander $n. Judgment day is upon us! We must be victorious!','This is it, Commander $n. Judgment day is upon us! We must be victorious!',26124),
(84714,'enUS','Get us home safely, $n. I have a family I\'d like to see again.','Get us home safely, $n. I have a family I\'d like to see again.',26124),
(84715,'enUS','If my death results in success for your mission it will be a death well spent.','If my death results in success for your mission it will be a death well spent.',26124),
(84716,'enUS','It would seem that the gate is being powered by the souls of innocents!','It would seem that the gate is being powered by the souls of innocents!',26124),
(84717,'enUS','I hear that Gul\'dan is here! Is it true, commander?','I hear that Gul\'dan is here! Is it true, commander?',26124),
(84718,'enUS','I\'ve worked my whole life for this one moment. To die for Azeroth is the most glorious of deaths!','I\'ve worked my whole life for this one moment. To die for Azeroth is the most glorious of deaths!',26124),
(84719,'enUS','','Come, COME! Sit yourself by my fire. Would you like some frogs legs?',26124),
(84720,'enUS','Your bodies shall feed the bloom. Aren\'t you thankful?','',26124),
(84721,'enUS','Now\'s my chance!','Now\'s my chance!',26124),
(84722,'enUS','Run!','Run!',26124),
(84723,'enUS','She\'s dead! I\'m out of here!','She\'s dead! I\'m out of here!',26124),
(84724,'enUS','Thank you!','Thank you!',26124),
(84725,'enUS','Work it harder! Better! Faster! Stronger!','',26124),
(84726,'enUS','Take the rappelling rope down, commander.','',26124),
(84727,'enUS','You think you are gladiators? I could crush your skulls between my toes!','',26124),
(84728,'enUS','Fight harder or I\'ll save you the trouble of dying in the arena and kill you myself!','',26124),
(84729,'enUS','I\'ll see you there. Don\'t wait up!','',26124),
(84730,'enUS','','Go on, I\'ll be fine! I\'ll catch up.',26124),
(84731,'enUS','I am not the traitor here. It was the false prophet Velen who betrayed our people.','',26124),
(84732,'enUS','Do you have supplies for me commander?  Every piece helps the war effort.','',26124),
(84733,'enUS','%s was holding a Bloodmaul Cache!','',26124),
(84734,'enUS','More supplies commander? Our soldiers could always use them.','',26124),
(84735,'enUS','I\'m going to laugh when you weaklings die in the ring!','',26124),
(84736,'enUS','I serve our true master now. The Legion whose call I once denied.','',26124),
(84737,'enUS','If you try to dance like a butterfly... you\'ll get crushed like one!','',26124),
(84738,'enUS','My Lord Sargeras will scorch this pathetic world, as he has countless others.','',26124),
(84739,'enUS','You wimps aren\'t even worthy to clean the arena floor!','',26124),
(84740,'enUS','When you die in there, I\'ll make sure Meatgut puts what\'s left of you to good use!','',26124),
(84741,'enUS','You will eat, breathe, and kill for the glory of the arena!','',26124),
(84742,'enUS','I have sworn the sacrament. I have taken my new name... Socrethar.','',26124),
(84743,'enUS','Hey oh! These plant people make quite a spread, but I canno\' stand the sight o\' it much longer!','',26124),
(84744,'enUS','Lighting Torch','Lighting Torch',26124),
(84745,'enUS','Check for a pulse.','Check for a pulse.',26124),
(84746,'enUS','Cut down in the prime of his life, sadly the arbiter didn\'t make it.','',26124),
(84747,'enUS','Shhh... You\'ll be okay, Nisha.','',26124),
(84748,'enUS','That one almost hit me!','',26124),
(84749,'enUS','I didn\'t mean to steal from you, honest!','',26124),
(84750,'enUS','Nobody ever taught me that stealing was wrong! I was misled as a youth!','',26124),
(84751,'enUS','You can let me down now, I learned my lesson!','',26124),
(84752,'enUS','Wow, you want to fight in the arena with that aim?','',26124),
(84753,'enUS','All I did was borrow your purse... and your gear... and your mount. I was going to give it back!','',26124),
(84754,'enUS','You\'re pretty much the worst archer I\'ve ever seen!','',26124),
(84755,'enUS','Azeroth has been invaded by a vicious enemy that seems bent on world domination.$b$bWe must act quickly if we are to put a stop to the chaos that is unfolding around us.','',26124),
(84756,'enUS','I promise never to lie, cheat, or steal ever again! Honest!','',26124),
(84757,'enUS','I will take my rightful place.','',26124),
(84758,'enUS','The Legion will prevail.','',26124),
(84759,'enUS','There are others at my command. In Shattrath and Auchindoun.','',26124),
(84760,'enUS','Enough! When next we meet, it will be on MY terms.','',26124),
(84761,'enUS','Tell the remaining exarchs to number their days.','',26124),
(84762,'enUS','Initiate harvesting of organics.','',26124),
(84763,'enUS','Please! Take me to the town hall!','Please! Take me to the town hall!',26124),
(84764,'enUS','Thank you!','Thank you!',26124),
(84765,'enUS','Gar\'mak is dead. You fought well today. Meet me back at camp.','',26124),
(84766,'enUS','This madness ends now, Gar\'mak!','',26124),
(84767,'enUS','Attack!','Attack!',26124),
(84768,'enUS','For the Alliance!','For the Alliance!',26124),
(84769,'enUS','For Nethergarde!','For Nethergarde!',26124),
(84770,'enUS','We must hold the frontline!','',26124),
(84771,'enUS','I am glad you are on our side, $n.','',26124),
(84772,'enUS','We cannot win this battle if those Iron Horde war machines remain operational.','',26124),
(84773,'enUS','With those machines destroyed we can focus on our next move.','',26124),
(84774,'enUS','We cannot win this battle if the enemy is always one step ahead of us.','',26124),
(84775,'enUS','Terrifying Gronnling Killed: $1i (+$2i VP)','',26124),
(84776,'enUS','With those scouts dead we have a greater chance of catching the Iron Horde by surprise. Excellent work, $n.','',26124),
(84777,'enUS','My goods is only for ogres and gladiators! If you is something else, I\'ll crush your face with my hammer!','',26124),
(84778,'enUS','Nethergarde has lost so much already, I can\'t stand to see them lose more.','',26124),
(84779,'enUS','For the freshest meat come to Meatgut! If you don\'t, I\'ll pound your face in!','',26124),
(84780,'enUS','I am the night!','',26124),
(84781,'enUS','Hopefully the prisoners you saved will have an opportunity to rebuild Nethergarde to its former glory.','',26124),
(84782,'enUS','For the Raven Mother!','',26124),
(84783,'enUS','','Scrape your knee in the arena? I can fix any injury for the right price!',26124),
(84784,'enUS','I can fly again!','',26124),
(84785,'enUS','Bring those battleplans back to me and we can begin to dismantle this Iron Horde.','',26124),
(84786,'enUS','Come get your burgers! You like sausage? I\'ve got the juiciest clefthoof wieners around!','',26124),
(84787,'enUS','Hmm... it appears the Iron Horde has formed an alliance with the Dreadmaul ogres. This is going to be more difficult than I thought.','',26124),
(84788,'enUS','','You lookin\' to fight in the arena? I\'ve got everything you need under one roof!',26124),
(84789,'enUS','Ahhhhhh!','',26124),
(84790,'enUS','','Got someone you need to shank, bludgeon, cleave, or perforate? I\'ve got the right weapon for any job!',26124),
(84791,'enUS','Charge!','',26124),
(84792,'enUS','Plant the Alliance flags inside Nethergarde, our men will do the rest.','',26124),
(84793,'enUS','We must keep pushing back on the Iron Horde. They need to know we will not sit by and watch as they kill our brothers and sisters.','',26124),
(84794,'enUS','I will meet you at Okril\'lon. We will take down Gar\'mak together.','',26124),
(84795,'enUS','With Gar\'mak dead the Iron Horde will be in disarray until they appoint a new leader here on Azeroth. Although we have won this battle, I fear the war has just begun.','',26124),
(84796,'enUS','','Those ogres deserve a slow painful death. This poison will ensure that happens.',26124),
(84797,'enUS','','My sister is avenged. I am in your debt, $c.',26124),
(84798,'enUS','The will of the genesaur shall be upheld!','',26124),
(84799,'enUS','You\'re nothing more than a weed that must be pulled.','',26124),
(84800,'enUS','For Iyu!','',26124),
(84801,'enUS','For the genesaur!','',26124),
(84802,'enUS','Your body shall feed our armies.','',26124),
(84803,'enUS','Die, infestation of flesh.','',26124),
(84804,'enUS','You shall not pervert our grove.','',26124),
(84805,'enUS','You are unwelcome, flesh beast.','',26124),
(84806,'enUS','Weed!','',26124),
(84807,'enUS','Vile creature.','',26124),
(84808,'enUS','A terrified worker is caught in the open!','A terrified worker is caught in the open!',26124),
(84809,'enUS','Don\'t push the plunger!','',26124),
(84810,'enUS','I\'m gonna try to work me way back to Thaelin. I\'ll see ya there.','',26124),
(84811,'enUS','For the Horde!','For the Horde!',26124),
(84812,'enUS','Death to the Iron Horde!','Death to the Iron Horde!',26124),
(84813,'enUS','Scorchbrow! No! Ah they squished ya like a bug. I swear, as soon as I get back to fightin\' weight, I will avenge ye.','',26124),
(84814,'enUS','Workers Saved: $1i (+$2i VP)','Workers Saved: $1i (+$2i VP)',26124),
(84815,'enUS','','Alright, let\'s build the generator and get this show on the road!',26124),
(84816,'enUS','Let\'s get the generator up and running - stat!','',26124),
(84817,'enUS','','Naughty thing, you shouldn\'t be here...',26124),
(84818,'enUS','','You\'re too late, poor thing.',26124),
(84819,'enUS','I will never rest. I must join the Sethekk!','',26124),
(84820,'enUS','We were cut down... before our time...','',26124),
(84821,'enUS','','Despite that ancient\'s attack, these saberon are doing well... I can\'t wait to change that! <chuckles creepily>',26124),
(84822,'enUS','Taste my blade!','Taste my blade!',26124),
(84823,'enUS','For the Burning Blade!','For the Burning Blade!',26124),
(84824,'enUS','My blade seeks vengeance!','My blade seeks vengeance!',26124),
(84825,'enUS','','I\'ll show these saberon who the real hunter is... for the good of the Laughing Skull of course! We need these reagents!',26124),
(84826,'enUS','','What a disappointment... other than the slaughtered saberon village... and the plundered plant treasures... okay maybe this was a decent haul after all.$b$bMostly I was hoping to ride a Genesaur into battle...',26124),
(84827,'enUS','The challenge is met!','',26124),
(84828,'enUS','You are... a worthy foe...','',26124),
(84829,'enUS','None who challenge me survive!','',26124),
(84830,'enUS','I have been... defeated? No...','',26124),
(84831,'enUS','Get over here!','',26124),
(84832,'enUS','You cannot harm me!','',26124),
(84833,'enUS','Crushin\' time!','',26124),
(84834,'enUS','My bacon... is cooked...','',26124),
(84835,'enUS','I beg of you, $c, use the Heart for its true purpose!  The favor of Dionor will be quite tremendous indeed!','',26124),
(84836,'enUS','Let\'s turn up the heat!','',26124),
(84837,'enUS','He didn\'t kill us!  What an incredible reward!  We live to sprout another day.$b$bThank you for your service to the Overgrowth, $p!  I wish to personally repay you for your efforts.  Perhaps I can grow you some special fruits or something.  Do you have a home I can visit?','',26124),
(84838,'enUS','Your light will be extinguished!','',26124),
(84839,'enUS','Behold my brilliance!','',26124),
(84840,'enUS','Run!','Run!',26124),
(84841,'enUS','She\'s gonna blow!','She\'s gonna blow!',26124),
(84842,'enUS','Look out.','Look out.',26124),
(84843,'enUS','Uh oh.','Uh oh.',26124),
(84844,'enUS','Mommy.','Mommy.',26124),
(84845,'enUS','That\'s not good.','That\'s not good.',26124),
(84846,'enUS','The ammo\'s unstable!','The ammo\'s unstable!',26124),
(84847,'enUS','The mixture\'s too rich!','The mixture\'s too rich!',26124),
(84848,'enUS','My light can never go out...','',26124),
(84849,'enUS','If you\'ve got the cash, I\'ve got the ride!','',26124),
(84850,'enUS','With those scouts dead we have a greater chance of catching the Iron Horde by surprise. Aka\'Magosh, $n.','',26124),
(84851,'enUS','Plant the Horde flags inside Nethergarde, our men will do the rest.','',26124),
(84852,'enUS','We must keep pushing back on the Iron Horde. They need to know we will not sit by and watch as they kill our brethren.','',26124),
(84853,'enUS','Okril\'lon has lost so much already, I can\'t stand to see them lose more.','',26124),
(84854,'enUS','Follow the trail. Find our hidden foe.','',26124),
(84855,'enUS','Hopefully the prisoners you saved will have an opportunity to rebuild Okril\'lon to its former glory.','',26124),
(84856,'enUS','Where are you going, $c?','',26124),
(84857,'enUS','','Look deep into my eyes, $n and you can survey Ashran from afar.$B$BWhat would you like to see?',26124),
(84858,'enUS','Show me Brute\'s Rise.','Show me Brute\'s Rise.',26124),
(84859,'enUS','Show me the Molten Quarry.','Show me the Molten Quarry.',26124),
(84860,'enUS','Show me the Amphitheater Of Annihilation.','Show me the Amphitheater Of Annihilation.',26124),
(84861,'enUS','Show me the Ashmaul Burial Grounds.','Show me the Ashmaul Burial Grounds.',26124),
(84862,'enUS','Lok\'tar ogar!!','',26124),
(84863,'enUS','I will meet you in the Spirit Woods near Oshu\'gun. We must act swiftly!','',26124),
(84864,'enUS','Run for your lives! It\'s too strong!','',26124),
(84865,'enUS','I will meet you in the Spirit Woods near Oshu\'gun. Cho\'gall must be stopped!','',26124),
(84866,'enUS','Our only course of action is to retreat. Everyone, with me!','',26124),
(84867,'enUS','It looks like you might have a bite...','',26124),
(84868,'enUS','Reel it in!','Reel it in!',26124),
(84869,'enUS','You honor us, Kargath. I will enjoy watching you fight in the arena again, even with your... handicap.','',26124),
(84870,'enUS','Gladiators! Seize this opportunity to die gloriously, for your names will be carved into history. Let the battle begin!','',26124),
(84871,'enUS','Finish him.','',26124),
(84872,'enUS','Cho\'gall!','',26124),
(84873,'enUS','Guards! Stop him!','',26124),
(84874,'enUS','Seal the gates! Protect the palace! Highmaul will never fall to the likes you.','',26124),
(84875,'enUS','You tempt power that you cannot comprehend. Let me show you...','',26124),
(84876,'enUS','Have a taste of my power!','',26124),
(84877,'enUS','Feel the energies flow through you!','',26124),
(84878,'enUS','The stones and their power are mine to command.','',26124),
(84879,'enUS','Your fragile mind cannot resist my command!','',26124),
(84880,'enUS','Forfeit your power to me!','',26124),
(84881,'enUS','Highmaul will never fall. The Gorian empire will not be overthrown by these peasants!','',26124),
(84882,'enUS','End this now, Mal\'gris. Remove them from my throne room.','',26124),
(84883,'enUS','You thought to imprison us, Mar\'gok? (You could never control us!)','',26124),
(84884,'enUS','Destroy them all. Raze this city to the ground! (The stones will be ours! All shall fall to darkness!)','',26124),
(84885,'enUS','Take this key and get to safety!','Take this key and get to safety!',26124),
(84886,'enUS','The pleasure is mine. The crowd deserves a superior gladiator, seeing as the last one fell so easily.','',26124),
(84887,'enUS','This\'s gotta be a mistake! These puny squishies be the scourge of Nagrand? They look like Elekk poodoo.','',26124),
(84888,'enUS','Ha! Today\'s games honor great sorcerer king! We gonna see his bloody victory over the orcs at the Battle of Red Spires!','',26124),
(84889,'enUS','We\'ll see what dese competitors be made of, Thoktar, just as soon as what dey be made of gets splattered across the arena! HAHAHAHA!','',26124),
(84890,'enUS','Now, playing our mighty king, scream his name and bash a skull for the Shadow of Highmaul, champion of games, Vul\'gor!','',26124),
(84891,'enUS','Time to spill blood and die for Highmaul! The Battle of Red Spires begins!','',26124),
(84892,'enUS','These wimps be taking more limbs than losing em!','',26124),
(84893,'enUS','Looks like they don\'t care they\'re supposed to die.','',26124),
(84894,'enUS','The punies... defeated, Vul\'gor!?','',26124),
(84895,'enUS','The sorcerer king!? Here!? King only leaves palace to witness legendary battles.','',26124),
(84896,'enUS','The crowd is getting what it wants, blood and mayhem.','',26124),
(84897,'enUS','Ey, these peewees not bad.','',26124),
(84898,'enUS','These worms know how to crack skulls. I\'ll almost be sad to see em butchered.','',26124),
(84899,'enUS','Heh, slaves gonna have hard time cleaning that up.','',26124),
(84900,'enUS','Heh, if you\'d been hit like that, all you\'d have left are pebbles. HAHAHA!','',26124),
(84901,'enUS','HAHAHA!','',26124),
(84902,'enUS','Dey gonna look like puddles after dis fight.','',26124),
(84903,'enUS','I hope dese weaklings die better\'n they smell.','',26124),
(84904,'enUS','HAHAHAHAHA!','',26124),
(84905,'enUS','Didn\'t we win Battle O\' Red Spires?','',26124),
(84906,'enUS','Disrespectin\' our heritage won\'t get em invited to next year\'s games.','',26124),
(84907,'enUS','How tiny mens beat mighty Vul\'gor?!','',26124),
(84908,'enUS','Ouch, even I felt that hit in my boulders.','',26124),
(84909,'enUS','HAHAHA!','',26124),
(84910,'enUS','Kargath be one scary orc. When he starts choppin, not even his own limbs are safe! HAHA!','',26124),
(84911,'enUS','Enough! I will show these weaklings what a true champion is capable of.','',26124),
(84912,'enUS','The pleasure is mine. The crowd deserves a superior gladiator, seeing as the last one fell so easily.','',26124),
(84913,'enUS','You dare interrupt my ascendance!','',26124),
(84914,'enUS','Do it now!','',26124),
(84915,'enUS','Begin the Ritual!  I will become one with the Void!','',26124),
(84916,'enUS','You never should have interfered!','',26124),
(84917,'enUS','Take me to Darktide Roost.','Take me to Darktide Roost.',26124),
(84918,'enUS','','My cries will rattle your enemies like thunder. Guide my aim and strike them down!',26124),
(84919,'enUS','We\'ve spawned the Portals and they\'re up and running. Good work!','',26124),
(84920,'enUS','How many Artifact Fragments have we collected?','How many Artifact Fragments have we collected?',26124),
(84921,'enUS','What do the Mage Portals do?','What do the Mage Portals do?',26124),
(84922,'enUS','If you bring us enough of those artifact pieces scattered around Ashran we can use their power to conjure a Mage Portal. $B$BHow many have you brought me?','',26124),
(84923,'enUS','The riders are out and on duty now. Good job procuring those artifacts, soldier.','',26124),
(84924,'enUS','Bring me back enough of those artifacts and I can gear up our Knights and send them out into battle. $B$BHow many have you brought me?','',26124),
(84925,'enUS','How many Artifact Fragments have we collected?','How many Artifact Fragments have we collected?',26124),
(84926,'enUS','We currently have $9314w collected. We need $9705w total.','',26124),
(84927,'enUS','What do the Knight Riders do?','What do the Knight Riders do?',26124),
(84928,'enUS','Our best Knight Riders will ride around Ashran to protect and serve. You know, ruin the Horde\'s day.','',26124),
(84929,'enUS','Welcome to the Ring of Trials! Your first match is wit\' Crushmaul the orc slayer!','',26124),
(84930,'enUS','Unbelievable! Crushmaul has been defeated! Thoktar, how this happen?','',26124),
(84931,'enUS','','Let\'s just get this apparatus hooked up.',26124),
(84932,'enUS','','Ok, all systems are go. Fire it up!',26124),
(84933,'enUS','Dis next fight is against Raketalon! Dis gonna be a good one!','',26124),
(84934,'enUS','HAHAHAHA!!','',26124),
(84935,'enUS','Raketalon is dead! This the first time Raketalon ever died in the ring!','',26124),
(84936,'enUS','<A crude arakkoa effigy adorned with relics of the old king Terokk.>','',26124),
(84937,'enUS','Touch the wingblades to witness one of Terokk\'s legends.','Touch the wingblades to witness one of Terokk\'s legends.',26124),
(84938,'enUS','The next trial is about to commence! I hope you like dying \'cuz you about to face Hol\'yelaa!','',26124),
(84940,'enUS','Inconceivable! Hol\'yelaa has been defeated! Who would have seen this coming?','',26124),
(84941,'enUS','Oggum dror undro dukkar.','',26124),
(84942,'enUS','DESTRUCTION!','',26124),
(84943,'enUS','LANDSLIDE!','',26124),
(84944,'enUS','Bury you!','',26124),
(84945,'enUS','MOGGOK DOOM AGURR!','',26124),
(84946,'enUS','CRRRRRUSH... YOU!','',26124),
(84947,'enUS','Into nothing....','',26124),
(84948,'enUS','Into... nothing....','',26124),
(84949,'enUS','To dust....','',26124),
(84950,'enUS','%s rumbles into laughter.','',26124),
(84951,'enUS','Gruul smell flesh...','',26124),
(84952,'enUS','Hahahaha, Gruul kill you so easy!','',26124),
(84953,'enUS','You stay...','',26124),
(84954,'enUS','GRUUL SMASH!','',26124),
(84955,'enUS','No escape!','',26124),
(84956,'enUS','Scurry....','',26124),
(84957,'enUS','Unworthy.','',26124),
(84958,'enUS','No more.','',26124),
(84959,'enUS','Gruul... Fall... Down?','',26124),
(84960,'enUS','GRUUL CRUSH YOU NOW!!!','',26124),
(84961,'enUS','De Alliance be at de gates! To Arms soldiers of de Horde!','',26124),
(84962,'enUS','Get ready for the next bout! You going up against Captain Boomspark and the Burninator!','',26124),
(84963,'enUS','Stop that.','',26124),
(84964,'enUS','Please stop doing that.','',26124),
(84965,'enUS','','Well, well, well... look who\'s walked right into our trap.',26124),
(84966,'enUS','','You will be my gift to Warchief Hellscream.',26124),
(84967,'enUS','Alliance fools! You expect to attack my base and live?!','',26124),
(84968,'enUS','Capain Boomspark is defeated! Only one gladiator remains!','',26124),
(84969,'enUS','Let me hook up the apparatus. Just a moment.','',26124),
(84970,'enUS','All systems are active. Fire!','',26124),
(84971,'enUS','This is how he was found. Murdered!','',26124),
(84972,'enUS','Exarch Naielle, weren\'t you overheard arguing with Hataaru earlier?','',26124),
(84973,'enUS','','We ALWAYS argue. That doesn\'t mean I killed him!',26124),
(84974,'enUS','The weapon is tainted with fel energy.','',26124),
(84975,'enUS','You seem to know an awful lot about the tools of our enemy.','',26124),
(84976,'enUS','It is my duty to know. Allow me to speak with the body.','',26124),
(84977,'enUS','I forbid it! He has suffered enough!','',26124),
(84978,'enUS','I agree. Stand down, Exarch. Enough damage has been done.','',26124),
(84979,'enUS','There is a rat among us. I will find out who.','',26124),
(84980,'enUS','The time has come for the final bout! Roakk the Zealot versus the challenger!','',26124),
(84981,'enUS','Meet me north of here when you are finished.','',26124),
(84982,'enUS','Incredible! The Ring of Trials has a new champion! What you think, Thoktar?','',26124),
(84983,'enUS','Crushmaul gonna win dis by a landslide! HAHAHA!!','',26124),
(84984,'enUS','It obvious dat dis was a fluke! Dat is my expert opinion, Jhorn!','',26124),
(84985,'enUS','Raketalon always fight harder when she hungry, and we not feed her dis week! BAHAHAHA!!','',26124),
(84986,'enUS','Raketalon was weak! Da next fight won\'t be so easy!','',26124),
(84987,'enUS','Hol\'yelaa kill da last challenger before da fight even start! HAHAHA!!','',26124),
(84988,'enUS','Yea, yea... I not impressed! Let\'s see how da next fight goes!','',26124),
(84989,'enUS','Da best part of Captain Boomspark fights is eatin\' da extra crispy challengers! HAHAHA!!','',26124),
(84990,'enUS','Now Captain Boomspark is da extra crispy one! Save me a drumstick! HAHAHA! Drumstick!','',26124),
(84991,'enUS','Da only gladiator strong enough to beat Roakk is Vul\'gor! Dis fight is over before it even start!','',26124),
(84992,'enUS','We are truly kindred spirits, $n. Until we meet again.','',26124),
(84993,'enUS','Dis gladiator may be da new champion of da ring, but dey is still no match for Vul\'gor!','',26124),
(84994,'enUS','Long ago, a Bloodmane pridelord commanded his hunters to bring him ten thousand arakkoa feathers.','',26124),
(84995,'enUS','But the Talon King came alone, and what ensued was not a war. It was a slaughter.','',26124),
(84996,'enUS','Gggrrr... You are unworthy to fight Vul\'gor!','',26124),
(84997,'enUS','He moved with grace and power matched only by the wind.','',26124),
(84998,'enUS','With the sweep of his wings, he cut down even the strongest of the Bloodmane like so many blades of grass.','',26124),
(84999,'enUS','','Hello commander! What\'s the plan for today?$b$bPut me in the front, I\'m ready for anything!',26124),
(85000,'enUS','Their pridelord was fierce, but he was no match for Terokk.','',26124),
(85001,'enUS','Greetings, commander!$b$bNeed anything fixed? Tinkered with? ...Killed?','',26124),
(85002,'enUS','Satisfied that his message was clear, the Talon King left the Bloodmane to pick up the pieces of their broken tribe.','',26124),
(85003,'enUS','','Hello, commander.$b$bI\'ve been scouting around the garrison to make sure the perimeters are secure. Unfortunately, I wasn\'t alone. Something was watching me from the underbrush, but it ran away. The trail gets cold at the river\'s edge.$b$bStay on your guard!',26124),
(85004,'enUS','Eager for the glory of battle, the young chieftain had hoped to incite a war with the arakkoa.','',26124),
(85005,'enUS','','Rangari Chel reporting for duty.',26124),
(85006,'enUS','The final setting sun draws near.','',26124),
(85007,'enUS','','Greetings, commander! My name is Rangari Chel.$b$bWhen we first arrived on Draenor, this whole world was a mystery - a dangerous mystery. The rangari were tasked with exploring all these new, hostile environments. We learned to survive on our feet - using the natural resources of the land around us to survive and slip unseen in and out of enemy territory.$b$bAs your follower, I\'d focus on staying out of sight, keeping foes at bay, and doing serious damage.',26124),
(85008,'enUS','Someday I hope to drop the \"Apprentice\" title.','',26124),
(85009,'enUS','Commander!$b$bI am Apprentice Artificer Andren. Before Hataaru was murdered I was one of his most trusted assistants. As an Artificer I use draenei technology to disable foes long enough for me or someone else to crush them. I suppose among your people I\'d be considered a... warrior engineer?$b$bI will do my best to serve your interests if you choose me as a follower.','',26124),
(85010,'enUS','','Vindicator Onaala, ready for orders.',26124),
(85011,'enUS','','Commander, it is a pleasure to meet you.$b$bWhen I was young I trained hard to become an anchorite in the priesthood, but the Light walks us down mysterious paths. My defensive spells were so powerful that the Prophet himself encouraged me to train with the Vindicators.$b$bThese days, I am not afraid to stand toe-to-toe with our enemies, protecting those behind me. Choose me as your follower and my faith will be your shield, my armor a bulwark protecting your garrison from our many enemies.',26124),
(85012,'enUS','','The ogres of Stonemaul forced us to be gladiators.$b$bEveryday we fight, we kill, and we salute.$b$bThey made us battle whatever beast or creature the ogres had found that day.$b$bIt took a long time planning, but some of us managed to escape.',26124),
(85013,'enUS','Now I can kill who I want, when I want! Meet me in the ogre mound when you are done and we will rip faces together!','',26124),
(85014,'enUS','Operations in Tanaan go well. The Citadel is almost complete.','',26124),
(85015,'enUS','I am keeping a close eye on the Highmaul ogres, Warchief. So far, they remain... obedient.','',26124),
(85016,'enUS','What of you, Blackhand?','',26124),
(85017,'enUS','Alliance and Horde forces strike at the Foundry, but they are nothing I cannot handle.','',26124),
(85018,'enUS','Again, Blackhand? All I hear are excuses.','',26124),
(85019,'enUS','Azuka! How goes the search for the alpha?','',26124),
(85020,'enUS','','Well, Warchief. We need only the Heart of Gorgorek to give it life.',26124),
(85021,'enUS','Good. I will have you deal with the other-worlders as well. Or... do you lack the bloodlust of your forefathers?','',26124),
(85022,'enUS','','My blade skills surpass those of my sires, Warchief. I can clean up Blackhand\'s mess.',26124),
(85023,'enUS','Hrahh... I will slice off your tongue for that!','',26124),
(85024,'enUS','Ahahaha... bold words from my newest Warlord. Very well!','',26124),
(85026,'enUS','Carry forth your ancestral blade. Bathe it in the blood of our enemies. Show me its legendary power.','',26124),
(85027,'enUS','Prove yourself, Azuka, and I shall esteem you among my Warlords.','',26124),
(85028,'enUS','','Don\'t worry, little mouse. I haven\'t forgotten about you. I\'ll take care of you... later.',26124),
(85029,'enUS','','More supplies commander? Our soldiers could always use them.',26124),
(85030,'enUS','','My... my husband... did you save my husband?',26124),
(85031,'enUS','My fists and gratitude are yours, stranger. How do you feel about killing an ogre chief before you go?','',26124),
(85032,'enUS','Fight another.','',26124),
(85033,'enUS','Getting tired yet, little draenei?','',26124),
(85034,'enUS','You will learn to salute after each kill, or I will take your other eye.','',26124),
(85035,'enUS','Faster! You should have been able to kill that thing in half the time it took you.','',26124),
(85036,'enUS','Andren, I choose you!','Andren, I choose you!',26124),
(85037,'enUS','Are you sure this is the follower you want?','Are you sure this is the follower you want?',26124),
(85038,'enUS','I\'d like to speak to the others.','I\'d like to speak to the others.',26124),
(85039,'enUS','Chel, I choose you!','Chel, I choose you!',26124),
(85040,'enUS','Onaala, I choose you!','Onaala, I choose you!',26124),
(85041,'enUS','Hang tight, $Gsir:my lady;. I\'m here to help you.','',26124),
(85042,'enUS','Come, little draenei, that thing should not have cut you. You are getting sloppy.','',26124),
(85044,'enUS','Such a clever bird. How clever are you feeling now?','',26124),
(85045,'enUS','Begone invaders! I, Malkor, rule here now! My minions will feast on your bones!','',26124),
(85046,'enUS','Find the choicest bits of the intruders my minions! Find them and bring them to me!','',26124),
(85047,'enUS','If you kneel before me, I will grant you a quick death before feeding you to my digestion pool!','',26124),
(85048,'enUS','Do not presume your parlor tricks will work on me.','',26124),
(85049,'enUS','Don\'t worry about me. I know my way around here.','',26124),
(85050,'enUS','I\'ll poke around here. See if you can find anything elsewhere in the camp.','',26124),
(85051,'enUS','Where are you going, my brethren? It has only been a thousand years since we saw the last ogre! They may return anytime, we must be vigilant!','',26124),
(85052,'enUS','What do you know about Grommash Hellscream\'s plans?','What do you know about Grommash Hellscream\'s plans?',26124),
(85053,'enUS','The proud Y\'kish, bound in chain and leagues upon leagues from your precious Skettis.','',26124),
(85054,'enUS','I... I will stay until the job is done my brothers... return to the Overgrowth and I will meet you there in a few thousand years... I will not rest until my minions have crushed every worked stone to dust!','',26124),
(85055,'enUS','I... I do not remember... what is this?  Fleshbags in my domain! Slay them my minions!','',26124),
(85056,'enUS','You are free to go, you need only fly away. Hee hee.','',26124),
(85057,'enUS','Kill the ogres! Wait... there are no more ogres... all gone so long ago. Only their broken ruins that must be returned to the ground...','',26124),
(85058,'enUS','Grommash Hellscream met with his Warlords - Blackhand, Kargath Bladefist, Kilrogg Deadeye, and Azuka Bladefury. I\'d watch out for Azuka... it seems she is charged with destroying the Alliance forces here on Draenor.','',26124),
(85059,'enUS','Backup has arrived! Dispose of dose dat remain.','',26124),
(85060,'enUS','<Written on a nearby piece of paper:$B$BWe have uncovered Gorgorek the Worldrender, an ancient magnaron frozen in the stone pools of Gorgrond.$B$BThe Warsong elders believe this magnaron was a once-powerful alpha, with the ability to command lesser beings of its own kind.$B$BAncient clan records suggest that the beast can be awakened.>','<Written on a nearby piece of paper:$B$BWe have uncovered Gorgorek the Worldrender, an ancient magnaron frozen in the stone pools of Gorgrond.$B$BThe Warsong elders believe this magnaron was a once-powerful alpha, with the ability to command lesser beings of its own kind.$B$BAncient clan records suggest that the beast can be awakened.>',26124),
(85061,'enUS','<Scraps of paper surround the map of Blackrock Foundry. They look like manufacturing orders for war machines.>','<Scraps of paper surround the map of Blackrock Foundry. They look like manufacturing orders for war machines.>',26124),
(85062,'enUS','<This map bears many markings within Tanaan Jungle, including drawings of fortifications and troop movements. Hellscream seems quite interested in that region.>','<This map bears many markings within Tanaan Jungle, including drawings of fortifications and troop movements. Hellscream seems quite interested in that region.>',26124),
(85063,'enUS','Touch the bangle to witness Terokk\'s fall.','Touch the bangle to witness Terokk\'s fall.',26124),
(85064,'enUS','Accept Terokk\'s power.','Accept Terokk\'s power.',26124),
(85065,'enUS','Take me to Shadow\'s Vigil.','Take me to Shadow\'s Vigil.',26124),
(85066,'enUS','It is an honor to serve you, commander.','',26124),
(85067,'enUS','|TInterface\\Icons\\spell_holy_avengersshield:20|t %s hurls his |cFFF00000|Hspell:153480|h[Holy Shield]|h|r at $n!','',26124),
(85068,'enUS','I am at your command.','',26124),
(85069,'enUS','The Talon King\'s own sages betrayed him. Terokk and his allies were cast into the pools.','',26124),
(85070,'enUS','The accursed blood seared his flesh and tore at his mind.','',26124),
(85071,'enUS','As he withered, Terokk had but one concern: his daughter Lithic.','',26124),
(85072,'enUS','Seeing her broken body, Terokk despaired. He surrendered to the creeping darkness.','',26124),
(85073,'enUS','But in that darkness, something found him.','',26124),
(85074,'enUS','A strange power filled the Talon King. A presence urged him on.','',26124),
(85075,'enUS','Fool! You\'ve walked right into my trap!','',26124),
(85076,'enUS','A strange orb peeked out from the wastes. Gazing into it, Terokk met the being that had saved him.','',26124),
(85077,'enUS','','I\'ll meet you there.',26124),
(85078,'enUS','','I\'ll meet ye there.',26124),
(85079,'enUS','The Raven God Anzu gifted Terokk and his guards with dark powers. In time, they would be known as Talonpriests.','',26124),
(85080,'enUS','Is this one of yours?','',26124),
(85081,'enUS','Watch yourself, dog!','Watch yourself, dog!',26124),
(85082,'enUS','Stand down, fool!','Stand down, fool!',26124),
(85083,'enUS','For the Alliance!','',26124),
(85084,'enUS','Charge!','',26124),
(85085,'enUS','To arms!','',26124),
(85086,'enUS','For the Horde!','',26124),
(85087,'enUS','Attack!','',26124),
(85088,'enUS','Lok\'tar!','',26124),
(85089,'enUS','Told you! Tell him who I am, commander. Tell him how I like bones and killing.','',26124),
(85090,'enUS','','You won\'t find stuff this good anywhere else!',26124),
(85091,'enUS','','I smuggled these myself!',26124),
(85092,'enUS','','No time to haggle!  Take it or leave it.',26124),
(85093,'enUS','Fine, but my animal friends will be watching.','',26124),
(85094,'enUS','','I gotta go.  Maybe you\'ll spend a little more coin next time.',26124),
(85095,'enUS','','Time\'s up.  Back to swindlin\' the locals.',26124),
(85096,'enUS','It\'s back to the road for me!','',26124),
(85097,'enUS','Gotta run.  Stay out of trouble!','',26124),
(85098,'enUS','','Kajassa got ya, mon. I be here ta help ya.',26124),
(85099,'enUS','','Shhhh... keep dem eyes an\' ears open.',26124),
(85100,'enUS','','Reinforcements have arrived! Clear this rabble from Stormshield!',26124),
(85101,'enUS','','Stormshield is under attack! To the defenses. Push them back!',26124),
(85102,'enUS','Wake up! Pathetic worms... why do we even bother with you.','Wake up! Pathetic worms... why do we even bother with you.',26124),
(85103,'enUS','Using Nether Beacon','Using Nether Beacon',26124),
(85104,'enUS','Beat it, kid. I told you, we\'re not interested.','Beat it, kid. I told you, we\'re not interested.',26124),
(85105,'enUS','','You\'re all a bunch of cowards. $p\'s the only one of you with any guts.',26124),
(85106,'enUS','<Fence your loot>','<Fence your loot>',26124),
(85107,'enUS','Ya got the goods, mon. I be able to turn dem inta Dingy Iron Coins for ya. I got my ways. See me lata and spend dem coins on someting fancy!','Ya got the goods, mon. I be able to turn dem inta Dingy Iron Coins for ya. I got my ways. See me lata and spend dem coins on someting fancy!',26124),
(85108,'enUS','Don\'t go easy on the horde, $n. Bring me back a token of their demise and I\'ll reward you handsomely.','',26124),
(85109,'enUS','I\'ve heard of Warlord Bladefury. She is a masta a da blade, undefeated across da orc clans. Those who underestimate her, die.','',26124),
(85110,'enUS','She be ambitious, clever, an\' cruel. Now dat she has risen ta Warlord, we had betta watch our backs.','',26124),
(85111,'enUS','I have heard of Warlord Bladefury. She is a master of the blade. Many underestimate her, but she is undefeated across the orc clans.','',26124),
(85112,'enUS','She is ambitious, clever, and cruel. Now that she has risen to power, I fear we must face her soon.','',26124),
(85113,'enUS','Wretches driven mad by the curse thrashed about in the pools in agony. But Terokk set them free.','',26124),
(85114,'enUS','|TInterface\\Icons\\sha_ability_rogue_bloodyeye.blp:32|t$b\n|cFFFF0000|Hspell:167410|h[Khadgar\'s Watch]|h|r reverses time!','|TInterface\\Icons\\sha_ability_rogue_bloodyeye.blp:32|t$b\n|cFFFF0000|Hspell:167410|h[Khadgar\'s Watch]|h|r reverses time!',26124),
(85115,'enUS','Prepare to battle the Iron Horde.','Prepare to battle the Iron Horde.',26124),
(85116,'enUS','I\'m ready, High Ravenspeaker.','I\'m ready, High Ravenspeaker.',26124),
(85117,'enUS','Tag! You\'re it!','Tag! You\'re it!',26124),
(85118,'enUS','OGRE! You\'re the ogre! HA-HA!','OGRE! You\'re the ogre! HA-HA!',26124),
(85119,'enUS','Can we stop running now?','Can we stop running now?',26124),
(85120,'enUS','You know why orc eyes glow red? It\'s because they drink blood!','You know why orc eyes glow red? It\'s because they drink blood!',26124),
(85121,'enUS','Well done!','',26124),
(85122,'enUS','Yes, very good.','',26124),
(85123,'enUS','No, that isn\'t how the ritual goes. Try again.','',26124),
(85124,'enUS','Defenders of Shattrath, we\'ve taken the docks!  Fall back to the city and look for any survivors!','',26124),
(85127,'enUS','Fool child. You are my property now.','',26124),
(85128,'enUS','Your father has abandoned you. Now you will replace him in the arena.','',26124),
(85129,'enUS','You will grow, you will bleed, you will fight, or you will die.','',26124),
(85130,'enUS','It falls to you, little one, to pay the debt of your father\'s escape.','',26124),
(85131,'enUS','My father is going to rip your horn off.','',26124),
(85132,'enUS','You better fear the day I get let out of this cage!','',26124),
(85133,'enUS','You can\'t keep me locked up forever.','',26124),
(85135,'enUS','You dogs will soon do your part to strengthen the Iron Horde!','',26124),
(85136,'enUS','Shhhh... This will all be over soon. The pain will end when your souls depart from your bodies and feed the Dark Portal!','',26124),
(85137,'enUS','This is the price you Frostwolf pay for not joining the Iron Horde!','',26124),
(85138,'enUS','Do not fret, even now the might of the Iron Horde amasses at Frostfire. Your home will be ours soon!','',26124),
(85139,'enUS','We have captured your leader! HAH! He shovels our excrement in the quarry! His brother Durotan will be next!','',26124),
(85140,'enUS','We have captured the Shadow Council and their leader, Gul\'dan! It is they who power this portal -- with your souls!','',26124),
(85141,'enUS','','',26124),
(85142,'enUS','It is only through our faith in the Raven Mother that we will find our salvation.','',26124),
(85143,'enUS','This might hurt a little.','This might hurt a little.',26124),
(85144,'enUS','Like a bird to the slaughter.','Like a bird to the slaughter.',26124),
(85145,'enUS','I\'ll eat your bones!','I\'ll eat your bones!',26124),
(85146,'enUS','Another trophy for my necklace.','Another trophy for my necklace.',26124),
(85147,'enUS','Die!','Die!',26124),
(85148,'enUS','Did your \"prophet\" not see this in your future? HAH!','',26124),
(85149,'enUS','Little draenei, did you think that you could keep us suppressed forever? This is our world and none will hold us from it!','',26124),
(85150,'enUS','The Iron Horde war machine is already on the way to Karabor. It will soon be nothing more than ash!','',26124),
(85151,'enUS','The fate of your people is to feed the Iron Horde war machine!','',26124),
(85152,'enUS','It is your souls that fuel the portal. And soon you will join the countless souls that have already crossed over!','',26124),
(85153,'enUS','None will stand in the way of the warlords! You do not stand a chance! Once Karabor falls, Shattrath will soon follow!','',26124),
(85154,'enUS','Time may have taken some of my strength, but this old wolf still has his bite!','',26124),
(85155,'enUS','At least, I die... in combat...','',26124),
(85156,'enUS','<The voice of Kalandrios fills your mind as you approach the Shamanstone.>','',26124),
(85157,'enUS','','As handmaiden to Tyrande, my sentinels stand ready to fight by your side and defend your garrison.',26124),
(85158,'enUS','I would like the night elves to protect the garrison.','I would like the night elves to protect the garrison.',26124),
(85159,'enUS','Mr. Nichols? Another cup of coffee please.','',26124),
(85160,'enUS','Coming right up, lad. Say \"hi\" to your mother for me.','',26124),
(85161,'enUS','She\'s my best customer.','',26124),
(85162,'enUS','Thanks, I will.','',26124),
(85163,'enUS','The garrison is yours, commander.','',26124),
(85164,'enUS','Switch back to human guards.','Switch back to human guards.',26124),
(85165,'enUS','Hey, Ana!','',26124),
(85166,'enUS','','Hey, Xander.',26124),
(85167,'enUS','Hi, Topper.','',26124),
(85168,'enUS','Better get a move on, kid. That coffee\'s not getting any hotter.','',26124),
(85169,'enUS','Don\'t worry, I\'ll get around to all of you.','Don\'t worry, I\'ll get around to all of you.',26124),
(85170,'enUS','Here\'s your coffee, mom.','',26124),
(85171,'enUS','Phew. I could really use a break.','Phew. I could really use a break.',26124),
(85172,'enUS','Ewwww. I JUST washed my boots.','Ewwww. I JUST washed my boots.',26124),
(85173,'enUS','','Thank you, sweetie.',26124),
(85174,'enUS','','Mmm, that\'s good. All right, off with you. Go play.',26124),
(85175,'enUS','Is everyone in their places? Good, let us begin!','',26124),
(85176,'enUS','Okay! See you in an hour.','',26124),
(85177,'enUS','The strongest of his guards clung to sanity. And when the Talon King called, they answered.','',26124),
(85178,'enUS','Hello, boy.','',26124),
(85179,'enUS','It was written in the \"Tome of the Falling Sands\", \"Time waits for no one\". The Raven Mother knew we would have one who is not of the flock here for the ritual! Oh, You are truly blessed!','',26124),
(85180,'enUS','Hey, dad!','',26124),
(85181,'enUS','Hey you with the face! You gotta help me down... my pants are chafing like crazy.','',26124),
(85182,'enUS','We need to fill the air with a sweet smell. Put something fragrant into the fire.','',26124),
(85183,'enUS','Now, inspire us with a reading from the Scroll of the Ravens.','',26124),
(85184,'enUS','Quickly now, throw the sacred feathers to the winds!','',26124),
(85185,'enUS','Now, splash the flames with some of the blessed water!','',26124),
(85186,'enUS','Together they would build Skettis, and protect the unwanted children of Rukhmar.','',26124),
(85187,'enUS','As the years passed, the Talon King\'s health declined. Grief hung in his heart, while the curse chewed relentlessly at his mind.','',26124),
(85188,'enUS','He began to hate this world, abandoning Skettis - even sacrificing his own people in search of a cure.','',26124),
(85189,'enUS','The Raven Mother! We humbly welcome you back to the nest! Your presence brings joy to our hearts!','',26124),
(85190,'enUS','You call this pain? I\'ve done worse to myself.','You call this pain? I\'ve done worse to myself.',26124),
(85191,'enUS','Your poison is pathetic.','Your poison is pathetic.',26124),
(85192,'enUS','Yes... the pain... it sustains me...','Yes... the pain... it sustains me...',26124),
(85193,'enUS','More... give me more!','More... give me more!',26124),
(85194,'enUS','My will is iron. I\'ll never talk.','My will is iron. I\'ll never talk.',26124),
(85195,'enUS','It\'s going to take more than that, whelp.','It\'s going to take more than that, whelp.',26124),
(85196,'enUS','I\'ll chew on your bones.','I\'ll chew on your bones.',26124),
(85197,'enUS','You want pain? I\'ll show you pain.','You want pain? I\'ll show you pain.',26124),
(85198,'enUS','I took my own hand. You are nothing!','I took my own hand. You are nothing!',26124),
(85199,'enUS','Yes, more. Give me more!','Yes, more. Give me more!',26124),
(85200,'enUS','Kargath will hang your corpse on his throne.','Kargath will hang your corpse on his throne.',26124),
(85201,'enUS','This is your idea of poison? I bathe with worse.','This is your idea of poison? I bathe with worse.',26124),
(85202,'enUS','Let me give you a taste of real poison.','Let me give you a taste of real poison.',26124),
(85203,'enUS','I\'ve given everything to be Shattered Hand. You\'ll get nothing from me.','I\'ve given everything to be Shattered Hand. You\'ll get nothing from me.',26124),
(85204,'enUS','I live for pain. Your efforts are weak.','I live for pain. Your efforts are weak.',26124),
(85205,'enUS','You are too late. Our poisoned blades will be your end.','You are too late. Our poisoned blades will be your end.',26124),
(85206,'enUS','STOP! No more!','STOP! No more!',26124),
(85207,'enUS','Our master assassin\'s name is Gardul Venomshiv. He crafted the poison.','Our master assassin\'s name is Gardul Venomshiv. He crafted the poison.',26124),
(85208,'enUS','He is at the camp just down the road right now. But you\'ll never stop...','He is at the camp just down the road right now. But you\'ll never stop...',26124),
(85209,'enUS','Who crafted the poison that killed the arakkoa?','Who crafted the poison that killed the arakkoa?',26124),
(85210,'enUS','Who is behind this? Where are they?','Who is behind this? Where are they?',26124),
(85211,'enUS','Who creates the poison on your blade. Tell me!','Who creates the poison on your blade. Tell me!',26124),
(85212,'enUS','I need answers. Tell me who created the poison you use.','I need answers. Tell me who created the poison you use.',26124),
(85213,'enUS','You did not craft this poison. Tell me who did and this can all end.','You did not craft this poison. Tell me who did and this can all end.',26124),
(85214,'enUS','Who is G.V.? His poisons killed the arakkoa. Tell me!','Who is G.V.? His poisons killed the arakkoa. Tell me!',26124),
(85215,'enUS','Who led the raid on the arakkoa. Where is he hiding?','Who led the raid on the arakkoa. Where is he hiding?',26124),
(85216,'enUS','Do not test my patience. Tell me who crafted the poison you wield.','Do not test my patience. Tell me who crafted the poison you wield.',26124),
(85217,'enUS','Do not waste my time. Who is G.V. and where is he?','Do not waste my time. Who is G.V. and where is he?',26124),
(85218,'enUS','Good seein\' ya.','Good seein\' ya.',26124),
(85219,'enUS','','Hold your arms, brothers. I do not believe this one serves the ogres.',26124),
(85220,'enUS','Hold, friends! This one does not look like a minion of the ogres.','',26124),
(85221,'enUS','%s succumbs to the poison.','%s succumbs to the poison.',26124),
(85222,'enUS','Time is of the essence! Meet me in the Underpale and we will confront Cho\'gall!','',26124),
(85223,'enUS','K\'ure must be saved! Meet me in the Underpale and we will confront Cho\'gall!','',26124),
(85224,'enUS','Glory to the Alliance!','Glory to the Alliance!',26124),
(85225,'enUS','','I have returned!',26124),
(85227,'enUS','OW, MY LEG!','',26124),
(85228,'enUS','','Tiny! Please don\'t die!!',26124),
(85229,'enUS','','Please save Tiny!',26124),
(85230,'enUS','','Is he going to be okay?',26124),
(85231,'enUS','','Why did you have to fight with those mean old orcs!?',26124),
(85232,'enUS','','Just hang in there Tiny!',26124),
(85235,'enUS','','Don\'t worry, he will be fine.',26124),
(85236,'enUS','','He fought bravely, you should be proud!',26124),
(85237,'enUS','','Your elekk managed to save many lives.',26124),
(85238,'enUS','','I will make sure that he is fully healed.',26124),
(85239,'enUS','Alright, it\'s time to go!','',26124),
(85240,'enUS','','I see your friends in the chamber up above. I think I can get there safely.',26124),
(85241,'enUS','You - from beyond the portal! You will make a marvelous sacrifice.','',26124),
(85242,'enUS','Come closer... and burn!','',26124),
(85243,'enUS','The void consumes you!','',26124),
(85244,'enUS','Ner\'zhul... Help me...','',26124),
(85245,'enUS','Find us weapons and armor, and I swear my people will carve a path through these orcs all the way to Karabor if we must.','',26124),
(85246,'enUS','Put axes in our hands and I promise you, every Frostwolf orc here can take down ten orcs of any other clan.','',26124),
(85247,'enUS','We gonna crush dem good, Porkchop!','',26124),
(85248,'enUS','Bahaha! You so puny!','',26124),
(85249,'enUS','','I sense one who is not of the flock. Come closer, child.',26124),
(85250,'enUS','Come at me, bro!','',26124),
(85251,'enUS','','Oh, it\'s worse than I thought. They hit here, too.',26124),
(85252,'enUS','','Dark Lady watch over us. We weren\'t the only ones.',26124),
(85253,'enUS','We don\'t yet know of the casualties.','We don\'t yet know of the casualties.',26124),
(85254,'enUS','How could this have happened...','How could this have happened...',26124),
(85255,'enUS','...and the children. Who will care for them now?','...and the children. Who will care for them now?',26124),
(85256,'enUS','It hasn\'t just affected our lives - the weather is gloomier.  The attack is mourned by all.','It hasn\'t just affected our lives - the weather is gloomier.  The attack is mourned by all.',26124),
(85257,'enUS','Light\'s blessing be upon us.','Light\'s blessing be upon us.',26124),
(85258,'enUS','Mind your form.','Mind your form.',26124),
(85259,'enUS','The savages won\'t be so kind to forgive attacks like that.','The savages won\'t be so kind to forgive attacks like that.',26124),
(85260,'enUS','Good...good.','Good...good.',26124),
(85261,'enUS','Maintain your balance. You must remain steady at all times.','Maintain your balance. You must remain steady at all times.',26124),
(85262,'enUS','Excellent work. Your skills are improving.','Excellent work. Your skills are improving.',26124),
(85263,'enUS','Just a taste of Gorian civilization!','',26124),
(85264,'enUS','<This head used to be attached to a large brute, until it was ripped off by a larger brute name Brokyo.>','<This head used to be attached to a large brute, until it was ripped off by a larger brute name Brokyo.>',26124),
(85265,'enUS','Challenge Brokyo.','Challenge Brokyo.',26124),
(85266,'enUS','I love the smell of burnt gladiators in the morning!','',26124),
(85267,'enUS','Taking a look...','Taking a look...',26124),
(85268,'enUS','Rukhmar takes flight!','Rukhmar takes flight!',26124),
(85269,'enUS','|TInterface\\Icons\\ability_fixated_state_red:20|tA Phoenix has |cFFFF0000fixated|r on you! If it reaches you it will |cFFFF0000|Hspell:167630|h[Explode]|h|r!','',26124),
(85270,'enUS','Get on in there, champ!','',26124),
(85271,'enUS','I need some luck!','I need some luck!',26124),
(85272,'enUS','%s tosses a coin in the fountain.','%s tosses a coin in the fountain.',26124),
(85273,'enUS','Come to Highmaul and my claws will tear you apart....','',26124),
(85274,'enUS','What\'ve you got?','What\'ve you got?',26124),
(85275,'enUS','The mending begins.','The mending begins.',26124),
(85276,'enUS','I know it hurts, but you must try and rest.','I know it hurts, but you must try and rest.',26124),
(85277,'enUS','The wounds are great, but the spirit is stronger.','The wounds are great, but the spirit is stronger.',26124),
(85278,'enUS','Blessings aide your wounds.','Blessings aide your wounds.',26124),
(85279,'enUS','$n says a prayer for the spirit of the departed.','$n says a prayer for the spirit of the departed.',26124),
(85280,'enUS','%s inhales slowly, each breath increasing discomfort.','%s inhales slowly, each breath increasing discomfort.',26124),
(85281,'enUS','%s ignores the pain, allowing nearby injured brethren to be cared for.','%s ignores the pain, allowing nearby injured brethren to be cared for.',26124),
(85282,'enUS','%s lets loose a whisper from under his breath, slowly releasing a pained sigh.','%s lets loose a whisper from under his breath, slowly releasing a pained sigh.',26124),
(85283,'enUS','%s swings with great force at their target.','%s swings with great force at their target.',26124),
(85284,'enUS','%s adjusts their combat stance, improving balance and form.','%s adjusts their combat stance, improving balance and form.',26124),
(85285,'enUS','%s breathes heavily, attacking their target with precision and focus.','%s breathes heavily, attacking their target with precision and focus.',26124),
(85286,'enUS','We\'ll get our chance.','We\'ll get our chance.',26124),
(85287,'enUS','','How is Sir Percival today?',26124),
(85288,'enUS','','Come on Percy!',26124),
(85289,'enUS','','Such a good boy.',26124),
(85290,'enUS','Bring me back enough of those artifacts and I can gear up our Wolf Riders and send them out into battle. $B$BHow many have you brought me?','',26124),
(85291,'enUS','','Ok, Percy. Bang!',26124),
(85292,'enUS','','Show them no mercy.',26124),
(85293,'enUS','','Give them a piece o\' their own medicine.',26124),
(85294,'enUS','','Good Job!',26124),
(85295,'enUS','I want a new recipe for myself.','I want a new recipe for myself.',26124),
(85296,'enUS','I want you to make me something.','I want you to make me something.',26124),
(85297,'enUS','','Amazing what you can dig up if you don\'t mind fighting through monsters, traps, bandits, and any other number of things trying to kill you.',26124),
(85298,'enUS','Traitors, all of you. You\'ve led the enemy to our doorstep!','',26124),
(85299,'enUS','Hoping to rejuvenate their fading king, the Talonpriests sealed Terokk away in the shadows.','',26124),
(85300,'enUS','','Hello, peach - great to be back under your command!$b$bGazlowe said you might need some goblin firepower, ingenuity, and awesomeness out here, so naturally I was chosen.$b$bAnd this has absolutely nothing to do with him not wanting me around his explosives.$b$bI got your back, commander!',26124),
(85301,'enUS','And that brings us to today! With the relics and the Talonpriests in place, we are ready to call upon the Talon King.','',26124),
(85302,'enUS','','Husband, please reconsider. No good can come of this.',26124),
(85303,'enUS','Enough. I will handle this myself.','',26124),
(85304,'enUS','My lord, I -','',26124),
(85305,'enUS','We\'ve closed this chapter. But Garrosh only set these events in motion... We\'ll have to close all the loops if we want to keep Azeroth safe. That means finding and neutralizing Gul\'dan.$B$B<Khadgar breathes a heavy sigh.>$B$BStill, a little celebration may be in order before we get back to business. I\'ve got a bottle of aged Dalaran red saved up for just such an occasion, if you\'d care to meet me in my tower later.','',26124),
(85306,'enUS','I yet live you green beasts! Come face Tormmok if you dare!','',26124),
(85307,'enUS','Curse you... Mar\'gok...','',26124),
(85308,'enUS','You\'re not supposed to be here yet! The assault on the Dark Portal isn\'t ready!$b$bCome back later, $c.','',26124),
(85309,'enUS','You look like a strong, capable $c. I could use a champion like you.$b$bInterested in risking your life on a suicide mission to save Azeroth?$b$bJust say the word.','',26124),
(85310,'enUS','','The archmage is gearing up for another campaign. All he can talk about is finding Gul\'dan.$B$BBut, I worry... Gul\'dan has already tried to kill Khadgar once. The Archmage is going to need all the help he can get.$B$B<Cordana looks at you, pointedly.>',26124),
(85311,'enUS','The word.','The word.',26124),
(85312,'enUS','','We Frostwolves have always walked alone, with only our wolves at our side. But, our clan is a part of this world, and it\'s clear that we have a role to play in protecting it.$B$BThis \'Garrosh\' was a dangerous one. Still, he showed us something valuable. I see now that, united, the orcs can be great. It is more important than ever to have a righteous voice to guide them.$B$BThe Frostwolves must be that voice.',26124),
(85313,'enUS','Is that the best you can do?! I\'ve put bigger forests to the torch in my campaigns!','',26124),
(85314,'enUS','You just keep coming like the weeds you are! Fine then! I\'ve killed a hundred of you, I can kill hundreds more!','',26124),
(85315,'enUS','Vindicator Yrel says that we must work with both the Alliance and the Horde from your world.$B$BBut, if your world created monsters like Garrosh - why should we trust you?','',26124),
(85316,'enUS','I will NOT die in this accursed jungle! I will not become plant food! My death is meant for something far more glorious than you plants!','',26124),
(85317,'enUS','Anybody want to go to Tanaan?','',26124),
(85318,'enUS','Don\'t waste my time.','',26124),
(85319,'enUS','Fear not flesh bag, you will do more good in the ground than above it. I will see to that.','',26124),
(85320,'enUS','Ha ha ha, wind cannot hurt me!','',26124),
(85321,'enUS','The Iron Horde remains a threat. We should hit them where it hurts, and take out the Blackrock Foundry.','',26124),
(85322,'enUS','','Perhaps we should deprive them of their allies. The ogres here in Nagrand are vulnerable now.',26124),
(85323,'enUS','Good plan. Now, let\'s get moving.','',26124),
(85324,'enUS','Stay alive, $n.','',26124),
(85325,'enUS','Stay alive, $n.','',26124),
(85326,'enUS','Good, good.','',26124),
(85327,'enUS','Yes, that is coming along nicely.','',26124),
(85328,'enUS','Hopefully there will not be any more interruptions.','',26124),
(85329,'enUS','It will be a struggle to make quota this week.','',26124),
(85330,'enUS','To prove yourself worthy of the wolf, you must first test your strength and tenacity. \n\nTo do this, you must gather a heavy stone from the quarry and bear it on your back into the lands of your enemy. Once you have cut your way through their ranks, place the stone in a place of prominence, and set upon it a trophy of your foe.\n\nOnly then, when your strength is displayed for all to see, can you hope to claim the wolf as your subject.','',26124),
(85331,'enUS','Once your display of strength is set for all to see, you must claim your wolf.\n\nGo to their hunting grounds. There you must find the largest wolf in the pack, and subdue it in the presence of its kin. You will likely be eaten alive, but if you survive the ordeal, the wolf will answer to you as its master.','',26124),
(85332,'enUS','It is not enough that the wolf regard you as its master. To ready your wolf for riding, you must break its will completely.\n\nOnce you have subdued your wolf, you will mount it and ride it to the top of the tallest peak in Nagrand. If your wolf is willful, it will throw you to your death on the mountain slopes. \n\nIf you survive to the peak, the will of your wolf will be broken. \n\nThen, you can call yourself \"Wolfrider\".','',26124),
(85333,'enUS','What do the Wolf Riders do?','What do the Wolf Riders do?',26124),
(85334,'enUS','Our best Wolf Riders will ride around Ashran to protect and serve. Tear those Alliance dogs to shreds.','',26124),
(85335,'enUS','How many Artifact Fragments have we collected?','How many Artifact Fragments have we collected?',26124),
(85336,'enUS','We currently have $9313w collected. We need $9705w total.','',26124),
(85337,'enUS','What does Kronus do?','What does Kronus do?',26124),
(85338,'enUS','How many Artifact Fragments have we collected?','How many Artifact Fragments have we collected?',26124),
(85339,'enUS','','We currently have $9312w collected. We need $9707w total.',26124),
(85340,'enUS','We currently have $9262w collected. We need $9708w total.','',26124),
(85341,'enUS','We currently have $9253w collected. We need $9706w total.','',26124),
(85342,'enUS','','The fool. He\'s going to lead us straight to his brewing operation. Follow me.',26124),
(85343,'enUS','Kronus will patrol into the Road of Glory and clear it of any Alliance it finds.','',26124),
(85344,'enUS','Kill... eat... torn to pieces... ate... alive... they took us... DIE... kill... me... kill me... KILL ME... please...','',26124),
(85345,'enUS','Put the corporal out of his misery.','Put the corporal out of his misery.',26124),
(85346,'enUS','WHAT ARE YOU DOING JUST STANDING AROUND? GO SLAY SOME ALLIANCE SCUM. BRING ME BACK THEIR HEADS, TEETH, TAILS... WHATEVER! GO, NOW!!','',26124),
(85347,'enUS','','The fool. He\'s going tae lead us straight to his brewin\' operation. Come on.',26124),
(85348,'enUS','I can clear the way to the flagship. Hold off these invaders while I finish my spell!','',26124),
(85349,'enUS','Your corpse will grow countless of us!','',26124),
(85350,'enUS','There will always be more of us... here...','',26124),
(85351,'enUS','I hate this jungle... You there! I would speak with you.','',26124),
(85352,'enUS','You are the first thing that has not immediately attacked me since my expedition arrived in this forsaken land... I should not even be here!','',26124),
(85353,'enUS','No one should become fertilizer for these monsters.  How did you come to be here?','No one should become fertilizer for these monsters.  How did you come to be here?',26124),
(85354,'enUS','Ever since \"Sorceror King\" Mar\'gok came to power and found those artifacts its been Felbreaker this and Firebreaker that. With his newfound power he thinks he doesn\'t need the Legion!$b$bThis empire was forged with ogre strength and ogre blades and I told him as such!','',26124),
(85355,'enUS','I doubt he took that well...','I doubt he took that well...',26124),
(85356,'enUS','He did not. He turned my words against me!$b$bHe ordered me and my loyal supporters to go on this cursed expedition to find the first ogre civilization and find some stupid relics! I could not disobey... now my troops are all dead and I cannot return...','',26124),
(85357,'enUS','','You and your friend are too late, $n. My blade has already tasted the blood of Ugbright. My power will soon be unstoppable.',26124),
(85358,'enUS','','Now if you will excuse me, I have more blood to spill. Take care of this worm.',26124),
(85360,'enUS','','Till we meet again, $n.',26124),
(85361,'enUS','Augh! Too much!','',26124),
(85362,'enUS','Acquiring','Acquiring',26124),
(85363,'enUS','','We cannot hold for much longer!',26124),
(85364,'enUS','We must give the wizard more time! Hold the line!','',26124),
(85365,'enUS','It is finished. I must rest a moment. The flagship is up ahead. I will join you there once I regain my energy.','',26124),
(85366,'enUS','No touchin\' da merchandise without proof of purchase.','No touchin\' da merchandise without proof of purchase.',26124),
(85367,'enUS','I can\'t believe we\'re both standing here, $n. It\'s Draenor... but it\'s not Draenor. I feel as though we\'re trespassing on the far side of the looking glass.$b$bLet\'s finish the job and get out of this place, hm?','',26124),
(85368,'enUS','','For the Horde!',26124),
(85369,'enUS','Are you ready?','',26124),
(85370,'enUS','What\'s the plan, Khadgar?','What\'s the plan, Khadgar?',26124),
(85371,'enUS','It\'s coming right for us!','It\'s coming right for us!',26124),
(85372,'enUS','WHAT THE HELL?!','WHAT THE HELL?!',26124),
(85373,'enUS','','Yes... this body will do nicely!',26124),
(85374,'enUS','[Placeholder Scene!]','',26124),
(85375,'enUS','Take me to the Broken Precipice in Nagrand.','Take me to the Broken Precipice in Nagrand.',26124),
(85381,'enUS','','The Archmage is expecting you.',26124),
(85382,'enUS','Ra-AWWK! I am still-awAWWK - still with you, my king!','',26124),
(85383,'enUS','I... still have my strength...','',26124),
(85384,'enUS','What will become of us?','',26124),
(85385,'enUS','I.. huh... wha? Ra-AWWK!!','',26124),
(85386,'enUS','The Talon King lives!','',26124),
(85387,'enUS','','It will be alright.',26124),
(85388,'enUS','T-t-to the end, my k-king!','',26124),
(85389,'enUS','','He escaped, I just know it.',26124),
(85390,'enUS','','We have to stay strong. I am sure he will be back soon.',26124),
(85391,'enUS','AAHHHHHHHHH!!!!!!!','AAHHHHHHHHH!!!!!!!',26124),
(85392,'enUS','','Have hope $n!  The Light will protect you.',26124),
(85393,'enUS','<The amorphous blob of arcane energy appears to be giving people a tour of your garrison.>','',26124),
(85394,'enUS','','May the light bless you $r!',26124),
(85395,'enUS','This Warsong orc looks to have died trying to carry a giant stone through the Gorian outpost. \n\nThere\'s no clear indication of where he was taking the stone, but it obviously didn\'t help him in combat.','',26124),
(85397,'enUS','Get these war machines ready for the siege.','',26124),
(85398,'enUS','Don\'t shoot until you see the whites of their eyes!','',26124),
(85399,'enUS','One shot, one kill!','',26124),
(85401,'enUS','Don\'t let your lust for battle cloud your sight.','',26124),
(85402,'enUS','Stop showin\' off.','',26124),
(85403,'enUS','Get in there and show me what you\'ve got.','',26124),
(85404,'enUS','You think you have what it takes to bear the standard of the Iron Horde?','',26124),
(85405,'enUS','No quarter. No mercy.','',26124),
(85406,'enUS','Warsong arrows sing from the sky! They\'ll be the last thing you hear as I crush your skull.','',26124),
(85407,'enUS','Start the funeral pyres!','',26124),
(85408,'enUS','Let them have it!','',26124),
(85409,'enUS','That\'s it? You barely drew blood!','',26124),
(85410,'enUS','A death worthy of a warrior!','',26124),
(85411,'enUS','Terror overwhelms you, death is near.','',26124),
(85412,'enUS','Revel in the slaughter!','',26124),
(85413,'enUS','My blade thirsts for more.','',26124),
(85414,'enUS','You will burn with me.','',26124),
(85415,'enUS','','Now you ain\'t so tall no more.',26124),
(85416,'enUS','','Ooooh! Is there killin\' ta be done? Lemme at\'em!',26124),
(85417,'enUS','','You\'d better step back. I\'m calling in the Bombsquad!',26124),
(85418,'enUS','','Time is money, friend! And it looks like you\'s outta both!',26124),
(85419,'enUS','','Tick tick tick... BOOM!',26124),
(85420,'enUS','Event sent.','',26124),
(85421,'enUS','','Ahhhhhhhh! I\'m hit!',26124),
(85422,'enUS','$n browses the books.','$n browses the books.',26124),
(85423,'enUS','Hmmm... something helpful?','Hmmm... something helpful?',26124),
(85424,'enUS','','It\'s alright... they are all gone now.',26124),
(85425,'enUS','I\'m going to killl the gronn!','I\'m going to killl the gronn!',26124),
(85426,'enUS','','There is no reason to be scared!',26124),
(85427,'enUS','','Can we please head back now?',26124),
(85428,'enUS','I... couldn\'t save them.','I... couldn\'t save them.',26124),
(85429,'enUS','What\'s this? What\'s going on down there?','',26124),
(85430,'enUS','What good are a handful of slaves against the Blackrock war machine?','',26124),
(85431,'enUS','Blackrocks... CRUSH THEM!','',26124),
(85432,'enUS','Super Thrall Action Dialogue!','',26124),
(85433,'enUS','Super Thrall Action Option 1!','Super Thrall Action Option 1!',26124),
(85434,'enUS','','You will never defeat the Light, demon!',26124),
(85435,'enUS','Eh Boss-mon! Ol\' Vol\'jin da warchief be sendin\' me some shadow hunters to be ya eyes an ears.$b$bWhen I hear of tings out there in da world ya should be hearin\' of, I\'ll be lettin\' ya know.','',26124),
(85436,'enUS','Call upon Terokk.','Call upon Terokk.',26124),
(85437,'enUS','Wowee, that\'s a big one!','',26124),
(85438,'enUS','Something me doing?','',26124),
(85439,'enUS','OWWWW! Okay, okay, me go back to work!','',26124),
(85440,'enUS','Whaaat?','',26124),
(85441,'enUS','Bad touch! Bad touch!','',26124),
(85442,'enUS','Ain\'t bigger than Princess!','',26124),
(85443,'enUS','$g Yessir:Yes ma\'am;, right away, $g sir:ma\'am;.','',26124),
(85444,'enUS','Me busy. Leave me alone.','',26124),
(85445,'enUS','We\'ll take \'er from here!','',26124),
(85446,'enUS','Me not that kind of orc.','',26124),
(85447,'enUS','What you want?','',26124),
(85448,'enUS','This son of Hellscream is a madman.$B$BI don\'t want justice... I want vengeance for what he did at Telaar.','',26124),
(85449,'enUS','D\'kaan, what\'s up ahead?','D\'kaan, what\'s up ahead?',26124),
(85450,'enUS','','Garrosh has escaped justice time and again, but we\'re going to finish him off this time, once and for all.',26124),
(85451,'enUS','Aggra, what\'s up ahead?','Aggra, what\'s up ahead?',26124),
(85452,'enUS','I LIVE!','',26124),
(85453,'enUS','BE CONSUMED BY FLAME!','',26124),
(85454,'enUS','They seem focused on their ritual. Maybe destroying those blood orbs will get their attention.','',26124),
(85455,'enUS','','The power lies within the artifact fragments, $n. Bring back enough of those and the mages will summon a portal so we can return back to Warspear Outpost faster.$B$BHow many have you brought me?',26124),
(85456,'enUS','','The portal is up, $c. Good work.',26124),
(85457,'enUS','How many Artifact Fragments have we collected?','How many Artifact Fragments have we collected?',26124),
(85458,'enUS','What do the Mage Portals do?','What do the Mage Portals do?',26124),
(85459,'enUS','What do the Warlock Gateways do?','What do the Warlock Gateways do?',26124),
(85460,'enUS','','The mages will summon a portal west of Ashran which can be used to take you back to Warspear Outpost.',26124),
(85461,'enUS','The Gateways are located in the North-West and South-East and can be used to move between those two points.','',26124),
(85462,'enUS','Somebody call for a highly overqualified lumberjack?','',26124),
(85463,'enUS','The warlocks have finished activating the Gateways and they are now fully functional. Good work, $n.','',26124),
(85464,'enUS','If we can gather enough of the artifact fragments found within Ashran we can activate the Warlock Gateways so we can move between the areas faster. $B$BHow many have you brought me?','',26124),
(85465,'enUS','How many Artifact Fragments have we collected?','How many Artifact Fragments have we collected?',26124),
(85466,'enUS','You have my thanks, hero, for releasing my soul from Cho\'gall\'s malevolent grip.$b$bThough my body rests, my spirit will stand vigil and maintain the balance until a new earthen fury takes my place.','',26124),
(85467,'enUS','','Of course.',26124),
(85468,'enUS','Draka, join the draenei in searching for any survivors.','',26124),
(85469,'enUS','Forward! The superweapon is on one of these ships. Follow me!','',26124),
(85470,'enUS','','Right away, captain! It will be my pleasure.',26124),
(85471,'enUS','','The blood of the slain comes to my aid!',26124),
(85472,'enUS','','You dare contest my power??? Our blood surges with energy!',26124),
(85473,'enUS','','Your blood washes over me!',26124),
(85474,'enUS','','No! None shall possess my potency!',26124),
(85475,'enUS','Hah. Ditto.','',26124),
(85476,'enUS','You will burn!','',26124),
(85477,'enUS','This is far from over.','',26124),
(85478,'enUS','','',26124),
(85479,'enUS','','',26124),
(85480,'enUS','','',26124),
(85481,'enUS','','Warsong! To me!',26124),
(85482,'enUS','','Don worry mon. I keep dese raiders off ya back!',26124),
(85483,'enUS','Allow me the honor of holding back these raiders!','',26124),
(85484,'enUS','','The Warsong will tear you apart!',26124),
(85485,'enUS','','The dangers of this land are not to be underestimated.$b$b<Thorn points to her eyepatch>$b$bI bear the mark of my naivety and own this mistake.',26124),
(85486,'enUS','','In Pandaria I did not make a habit of asking for \"help\" on missions. Perhaps that is why we haven\'t met before?',26124),
(85487,'enUS','','My blood runs rose red. This heart beats for Gilneas.',26124),
(85488,'enUS','','Not so fast, mon!',26124),
(85489,'enUS','You have my hammer!','',26124),
(85490,'enUS','','Haha, Who\'d thought an apprenticeship\'d plop me here? It\'s quite exciting!',26124),
(85491,'enUS','','Psst, do ye think Alexston and Thorn would make a cute couple? HEEHEE!',26124),
(85492,'enUS','','Hey Commander, ye ever catch a game of Battle Ball? GO FORGERS!',26124),
(85493,'enUS','','That Thorn needs to throw back a pint n\' lighten up!  Er um... Commander!',26124),
(85494,'enUS','','So you\'re the new commander, eh? I thought you\'d be taller.',26124),
(85495,'enUS','Have you seen Brightstone? My latest assistant is more than a handful.$b$bShe does everything to the extreme - drinking, talking, rushing from one task to another...$b$bShe is a damn fine architect though, and probably the brightest student I\'ve ever had.$b$bI\'ll give her that.','',26124),
(85496,'enUS','','Commander! I trust you are prepared to have your mind blown away by my designs.$b$bI am thinking... wood! Yes, wood! Lots of it. In BOLD arrangement the way that only the orcs of the original horde could conceive.$b$bAnd spikes! Yes, spikes. We must not forget the spikes. That is how you know it is Horde.',26124),
(85497,'enUS','Lieutenant Thorn is a shining example to us all. Never have I seen such a dedicated leader.$B$BI haven\'t worked up the courage to speak to her, but perhaps someday, she will know my name.','',26124),
(85498,'enUS','You need a tree murdered, commander?','',26124),
(85499,'enUS','Don\'t you have a world to save, $n? Let me do the dirty work here!','',26124),
(85500,'enUS','Did you know that we commandojacks have a twenty percent survival rate in the wild?','',26124),
(85501,'enUS','I got this, Commander $n. Go save some orphans or kill an orc or something equally heroic.','',26124),
(85502,'enUS','Return to Gorgrond or Tanaan Jungle!','',26124),
(85503,'enUS','After I\'m done with you even the Kaliri will refuse to pick at your corpse!','',26124),
(85504,'enUS','By the will of Rukhmar, you shall die!','',26124),
(85505,'enUS','I shall end this pathetic uprising here and now!','',26124),
(85506,'enUS','I will see your corpse broken on the stones below!','',26124),
(85507,'enUS','Filthy scum! How dare you set foot on my terrace!','',26124),
(85508,'enUS','You cannot stop us...','',26124),
(85509,'enUS','','Greblin Fastfizzle\'s last know location was the Broken Precipice. Dungar will set you up with a flight, when you\'re ready.',26124),
(85510,'enUS','My life... for Rukhmar...','',26124),
(85511,'enUS','','Keep yer volume down, their camp is right here.',26124),
(85512,'enUS','','Stay down. Their camp is right here.',26124),
(85513,'enUS','No... not into the darkness...','',26124),
(85514,'enUS','How dare you outcasts land on my terrace! I\'ll see your bodies broken upon the stones below!','',26124),
(85515,'enUS','Here Mr. Lizzy... over here.','Here Mr. Lizzy... over here.',26124),
(85516,'enUS','Yes, those are sawblades. Now step aside! I got a tree to murder!','',26124),
(85517,'enUS','I\'ve pooped timber bigger than this! Step aside and let me get to work!','',26124),
(85518,'enUS','You go do what you\'re good at and I\'ll do what I\'m good at: killing trees.','',26124),
(85519,'enUS','Do you feel it? This tree is scared. I\'d say it\'s petrified...','',26124),
(85520,'enUS','Please remain calm while I administer healing.','Please remain calm while I administer healing.',26124),
(85521,'enUS','Please remain calm while I administer healing.','',26124),
(85522,'enUS','Cut them down! Nothing will keep us from taking the city.','',26124),
(85523,'enUS','Another pup enters the fray?','',26124),
(85524,'enUS','Derrook waves good bye.','',26124),
(85525,'enUS','I have dedicated my life to preserving priceless artifacts and then quickly selling them for profit.$b$bIt\'s a difficult job, but I like money. Know what I\'m sayin?','',26124),
(85526,'enUS','If you find anything that looks like it needs some preserving let me know, chances are I can sell it somebody who likes old stuff.','',26124),
(85527,'enUS','You know the old saying?$b$bOne goblin\'s junk, is another goblin\'s garbage, so sell it to someone stupid enough to buy it.$b$bMy dear old mother told me that one, right before she sold me to that caravan of worgen.$b$bStill not sure how I feel about that.','',26124),
(85528,'enUS','<The wyvern looks at you expectantly.>','',26124),
(85529,'enUS','Take me back to my outpost.','Take me back to my outpost.',26124),
(85530,'enUS','<The gryphon looks at you expectantly.>','',26124),
(85531,'enUS','Once those ogres are outta here I can call my people and get this excavation started.','',26124),
(85532,'enUS','The nerve of some ogres. I could have been done with this surveying operation weeks ago if they would have died sooner.','',26124),
(85533,'enUS','Amongst many scribbled entries of the trials of a pirate\'s life and a surprising amount of different uses for barnacles, you find an entry of note:\n\n\"\'Tis been a week since that cursed bird made off with the keys to my chest. He keeps flyin\' by, as if he be tauntin\' me, but I can\'t seem to to catch him on the wing. \n\nThat good for nothin\' squab can\'t fly forever. I\'ll just wait here \'till he goes aground.\"','',26124),
(85534,'enUS','These ogres wouldn\'t know a priceless artifact if it jumped up and bit\'em in the rear. In fact, they probably wouldn\'t know if anything bit\'em in the rear. Know what I\'m sayin?','',26124),
(85535,'enUS','The Horde controls the Market Graveyard for 15 minutes!','',26124),
(85536,'enUS','The Alliance controls the Market Graveyard for 15 minutes!','',26124),
(85537,'enUS','The Market Graveyard has become neutral!','',26124),
(85538,'enUS','I... uh... I thought it would be funny.','',26124),
(85539,'enUS','I sleep all night and I work all day, commander.$B$BI\'ve got to relieve stress somehow.','',26124),
(85540,'enUS','I hope this is alright, commander.','',26124),
(85541,'enUS','This isn\'t what it looks like, I swear.$B$BPlease don\'t put me on outhouse duty.','',26124),
(85542,'enUS','\'Go touch the ravager nest,\' Tom said. \'It\'ll be fun,\' he said.$B$BThis oughta show him...','',26124),
(85543,'enUS','Brokyo killed the old ogre chieftain and put his head on a stake by his throne. He\'s surrounded by guards, but trust me, if you touch that ogre head he\'ll come down to greet you.','',26124),
(85544,'enUS','<Nisha bobs her head at you, affection showing in her glowing blue eyes.>','<Nisha bobs her head at you, affection showing in her glowing blue eyes.>',26124),
(85545,'enUS','I work hard, too, commander. Really, I do.$B$BTom made fun of me one too many times, that\'s all. I have to get back at him.','',26124),
(85546,'enUS','Ride Nisha to Fissure of Fury.','Ride Nisha to Fissure of Fury.',26124),
(85547,'enUS','Well, looks like your debt to me is finally paid off. See you around.','',26124),
(85548,'enUS','<Nisha playfully flicks out her tongue and licks your cheek.>','<Nisha playfully flicks out her tongue and licks your cheek.>',26124),
(85549,'enUS','No touch! I squish you for being so dumb!','',26124),
(85550,'enUS','Our fates are intertwined.','',26124),
(85551,'enUS','Have you come to join the other fools in death?','',26124),
(85552,'enUS','Take my power. It is yours to command.','',26124),
(85553,'enUS','I\'ll make you wish you stayed on the ground!','',26124),
(85554,'enUS','For Rukhmar!','',26124),
(85555,'enUS','The skies are ours!','',26124),
(85556,'enUS','Yrel and I will lead the bulk of our forces south beyond this barrier.$B$BMeanwhile, if I may suggest, you lead the rest of the soldiers west and create a flanking diversion.','',26124),
(85557,'enUS','I agree. A flanking maneuver will buy you the time you need to move most of our forces closer to Garrosh.','I agree. A flanking maneuver will buy you the time you need to move most of our forces closer to Garrosh.',26124),
(85558,'enUS','','Durotan and I will lead the bulk of our forces south beyond this barrier.$B$BMeanwhile, if I may suggest, you lead the rest of the soldiers west and create a flanking diversion.',26124),
(85559,'enUS','I agree. A flanking maneuver will buy you the time you need to move most of our forces closer to Garrosh.','I agree. A flanking maneuver will buy you the time you need to move most of our forces closer to Garrosh.',26124),
(85560,'enUS','Khadgar! Get us out of here!','',26124),
(85561,'enUS','','D\'kaan just finished scouting up ahead. I don\'t think you\'re going to like this.',26124),
(85562,'enUS','Like it or not, we need to move ahead. What\'s the situation?','Like it or not, we need to move ahead. What\'s the situation?',26124),
(85563,'enUS','That\'s Durn the Hungerer they\'ve enslaved up ahead.$B$BIt\'s going to take everything we\'ve got to get through him.','',26124),
(85564,'enUS','','That\'s Durn the Hungerer they\'ve enslaved up ahead.$B$BIt\'s going to take everything we\'ve got to get through him.',26124),
(85565,'enUS','Aggra just finished scouting up ahead. I don\'t think you\'re going to like this.','',26124),
(85566,'enUS','Like it or not, we need to move ahead. What\'s the situation?','Like it or not, we need to move ahead. What\'s the situation?',26124),
(85567,'enUS','','Garrosh sits on his throne behind these gates. This is the moment it\'s all been building toward, $n.$B$BOn your order, you and I will confront him once and for all.',26124),
(85568,'enUS','Give the order, Yrel. Destroy the gates and get us in there.','Give the order, Yrel. Destroy the gates and get us in there.',26124),
(85569,'enUS','Garrosh sits on his throne behind these gates. This is the moment it\'s all been building toward, $n.$B$BOn your order, you and I will confront him once and for all.','',26124),
(85570,'enUS','Give the order, Durotan. Destroy the gates and get us in there.','Give the order, Durotan. Destroy the gates and get us in there.',26124),
(85571,'enUS','I naer thought I would live to see such an incredible place, commander.$B$BI\'m just glad I have my trusty old pal Sir Bearington tae see it all wi\' me.','',26124),
(85572,'enUS','Good morning, commander!','',26124),
(85573,'enUS','Good afternoon, commander!','',26124),
(85574,'enUS','Been a long day, commander.','',26124),
(85575,'enUS','Commander.','',26124),
(85576,'enUS','Keep up the good work, commander.','',26124),
(85578,'enUS','My back is aching!','',26124),
(85579,'enUS','I\'m ready for that drink.','',26124),
(85580,'enUS','Is it just me or is this work never done?','',26124),
(85581,'enUS','Good to see you, commander.','',26124),
(85582,'enUS','Just a few whacks more.','',26124),
(85583,'enUS','Commander.','Commander.',26124),
(85584,'enUS','Good to see you, commander.','Good to see you, commander.',26124),
(85585,'enUS','All\'s quiet, commander.','All\'s quiet, commander.',26124),
(85586,'enUS','We\'re ready, commander.','We\'re ready, commander.',26124),
(85587,'enUS','Orders, commander?','Orders, commander?',26124),
(85588,'enUS','','Even you need to rest sometimes, commander.',26124),
(85589,'enUS','Take me to the Broken Precipice.','Take me to the Broken Precipice.',26124),
(85590,'enUS','Commander.','',26124),
(85591,'enUS','I\'m working!','',26124),
(85592,'enUS','Just resting my eyes, commander.','',26124),
(85593,'enUS','I\'ll take care of it, commander.','',26124),
(85594,'enUS','Commander.','Commander.',26124),
(85595,'enUS','Hail, commander.','Hail, commander.',26124),
(85596,'enUS','Orders, commander?','Orders, commander?',26124),
(85597,'enUS','At your command.','At your command.',26124),
(85598,'enUS','All\'s quiet, commander.','All\'s quiet, commander.',26124),
(85599,'enUS','We\'re under attack!','We\'re under attack!',26124),
(85600,'enUS','Commander. What are your orders?','Commander. What are your orders?',26124),
(85601,'enUS','Commander! We\'re under attack!','Commander! We\'re under attack!',26124),
(85602,'enUS','What are your orders, commander?','What are your orders, commander?',26124),
(85603,'enUS','Glory to you, commander.','Glory to you, commander.',26124),
(85604,'enUS','Long live Commander $p.','Long live Commander $p.',26124),
(85605,'enUS','Nothing major to report, commander.','Nothing major to report, commander.',26124),
(85606,'enUS','Orders, commander?','Orders, commander?',26124),
(85607,'enUS','May the winds carry you swiftly, commander.','',26124),
(85608,'enUS','Your ancestors would be proud of your deeds, commander.','',26124),
(85609,'enUS','I will get you anywhere you need to go, commander. Just say the word.','',26124),
(85610,'enUS','May Elune bless our mission, commander.','',26124),
(85611,'enUS','Move along, nothing to see here.','Move along, nothing to see here.',26124),
(85612,'enUS','Blast off!','',26124),
(85613,'enUS','From death.... sprouts life.','',26124),
(85614,'enUS','Out with the old, in with the.... new.','',26124),
(85615,'enUS','Arise, my little sapling.','',26124),
(85616,'enUS','These leaves I\'ve sprouted... are new.','',26124),
(85617,'enUS','Thank you Druids... you\'ve got the nature\'s touch.','',26124),
(85618,'enUS','And now, let\'s clear those Horde from this land.','',26124),
(85619,'enUS','','Apples, check. Helmets, check. Beautiful quartermaster, check.',26124),
(85620,'enUS','','No, no, no, this won\'t do at all. We don\'t have nearly enough swords.',26124),
(85621,'enUS','','Oh, my. We\'re definitely going to need more food.',26124),
(85622,'enUS','','For the Alliance!',26124),
(85623,'enUS','What\'s this? An arakkoa challenger in my arena?!','',26124),
(85624,'enUS','Tired of being hunted? Or just here for revenge?','',26124),
(85625,'enUS','%s laughs.','',26124),
(85626,'enUS','Go ahead, little bird. Do your worst!','',26124),
(85627,'enUS','What?! Who are you?!','',26124),
(85628,'enUS','Enough. This ends NOW!','',26124),
(85629,'enUS','I am the Talon King! I have come from beyond death to stem the iron tide!','',26124),
(85630,'enUS','Hngh! Im...possible...','',26124),
(85631,'enUS','Well I\'m Kargath Bladefist, and when I kill something IT STAYS DEAD.','',26124),
(85632,'enUS','My power... has... failed you... $p.','',26124),
(85633,'enUS','Hmph. So it\'s you in there.','',26124),
(85634,'enUS','Khadgar isn\'t here to protect you this time.','',26124),
(85649,'enUS','Blackhand has cast |TInterface\\Icons\\ability_rogue_hungerforblood.blp:20|t|cFFFF0404|Hspell:168261|h[Marked for Death]|h|r on you. Hide behind the Iron Stars to avoid the attack!','',26124),
(85650,'enUS','What?! GGRAAAHHH!!!!','',26124),
(85651,'enUS','','I don\'t want to say we were unprepared, but we are short on supplies here in Ashran. We just didn\'t bring enough through the portal.$B$BHopefully Sprocket\'s team can get us the heavy machinery we need to win this battle against the Horde.',26124),
(85652,'enUS','Are you alright? That was a close call.','',26124),
(85653,'enUS','Time to paint my masterpiece!','Time to paint my masterpiece!',26124),
(85654,'enUS','No tree can withstand the force of my blows!','',26124),
(85655,'enUS','This monster tree will be obliterated in no time, commander. Stand by!','',26124),
(85656,'enUS','I\'m a mobile lumber mill, built for shredding wood. Stand back!','',26124),
(85657,'enUS','I could do better.','I could do better.',26124),
(85658,'enUS','','I have been waiting all day for some repairs to be done. But that\'s okay, there are plenty of things to do to pass the time.',26124),
(85659,'enUS','','Fellworth got our group lost by finding a \"shortcut\" through the hollow and now my boots are full of slime and mud!\n\nI think I will be charge of the map from now on.',26124),
(85660,'enUS','','Your flight master insisted you fly back.',26124),
(85661,'enUS','','Yer flight master insisted ye fly back.',26124),
(85662,'enUS','Very well, Birchus, let\'s see if this works.  Here\'s the Heart Seed.','Very well, Birchus, let\'s see if this works.  Here\'s the Heart Seed.',26124),
(85663,'enUS','You will not be disappointed. Finally my long adventure is over! Arise Dionor!','',26124),
(85664,'enUS','We weren\'t lost; I was just taking the adventurous route!','',26124),
(85665,'enUS','So, what do you do for a living?','',26124),
(85666,'enUS','Well, I study and translate ancient mogu scrolls.','',26124),
(85667,'enUS','Yeah, I know, tell that to my C.O.','',26124),
(85668,'enUS','You don\'t find a lot of that out here...','',26124),
(85669,'enUS','','Let me check the map, Fellworth. I will decide where we travel next.',26124),
(85670,'enUS','Patrols have been increased throughout the city.  We will not succumb to attacks by these savages.','Patrols have been increased throughout the city.  We will not succumb to attacks by these savages.',26124),
(85671,'enUS','Defenders of Karabor stand ready!','Defenders of Karabor stand ready!',26124),
(85672,'enUS','Our people nor our city shall fall to the savages!','Our people nor our city shall fall to the savages!',26124),
(85673,'enUS','It is now we must come together, stronger than ever.','It is now we must come together, stronger than ever.',26124),
(85674,'enUS','It bein\' just my luck, mon! I be findin\' da best fishin\' spot down \'ere, but only after da elementals and da ogres broke up all my gear. \n\nNow I\'m needin\' a new rod, reel, and da special voodoo lure so I can land da big ones hidin\' in da weeds.','',26124),
(85675,'enUS','I think I can help you. (Give Abu\'gar his rod, reel and lure)','I think I can help you. (Give Abu\'gar his rod, reel and lure)',26124),
(85676,'enUS','Hey, commander! You sure you aren\'t part Laughing Skull?','',26124),
(85677,'enUS','You have proven that you have the strength to survive even the most dangerous of situations. Your technique in combat is unlike anyone I have seen. I am glad to call you friend.','',26124),
(85678,'enUS','Ey, boss-mon. Take a load off. Relax.','',26124),
(85679,'enUS','May the Light\'s power resonate within your actions. We shall not let the hatred of our savage enemies overcome our will to survive. Carry forth and return our people to health!','May the Light\'s power resonate within your actions. We shall not let the hatred of our savage enemies overcome our will to survive. Carry forth and return our people to health!',26124),
(85680,'enUS','','So it is true. The heart CAN infuse life into these creatures.',26124),
(85681,'enUS','','Ah, hero... I knew you would come. You are just in time to witness the heart\'s power.',26124),
(85682,'enUS','','This magnaron walked Draenor before the first orc took breath. And now, it... and an endless army of these destroyers... bend to MY will!',26124),
(85683,'enUS','','Follow me, $n. She\'s up this way.',26124),
(85684,'enUS','Foreman, change this building into a tankworks.','Foreman, change this building into a tankworks.',26124),
(85685,'enUS','We barely got you out in time.','',26124),
(85686,'enUS','That orc... Kargath. Even at my full strength, he would prove a challenge.','',26124),
(85687,'enUS','My children, it will take more than a fading memory from the past to overcome the challenges you face today.','',26124),
(85688,'enUS','Switching the building will cost 5,000 gold.\n\nAre you sure?','Switching the building will cost 5,000 gold.\n\nAre you sure?',26124),
(85689,'enUS','You must strike your own path. Lay the past to rest and raise new champions.','',26124),
(85690,'enUS','So far the Alliance found them all over Ashran. Killing any creature you can find will no doubt increase your chances for discovery.','',26124),
(85691,'enUS','','We got wind that there are hidden artifacts here, in this place called Ashran. Artifacts from a remnant Highmaul Ogre clan.$B$BThey could be the key to our success against the Iron Horde.',26124),
(85692,'enUS','Stouttoe! Is that you?','Stouttoe! Is that you?',26124),
(85693,'enUS','You have one already.','',26124),
(85694,'enUS','Hero, I can never again grant you my full power. Kargath severed that bond.','',26124),
(85695,'enUS','But so long as you tread in Arak, some piece of me will remain with you.','',26124),
(85696,'enUS','Foreman, change this building into a corral.','Foreman, change this building into a corral.',26124),
(85697,'enUS','I will lend my power as often as I can.','',26124),
(85698,'enUS','Your suffering will be legendary.','',26124),
(85699,'enUS','Thaelin, let\'s change this building into a tankworks.','Thaelin, let\'s change this building into a tankworks.',26124),
(85700,'enUS','But first... I think I need to wash my hands. I will meet you back at your camp.','',26124),
(85701,'enUS','Thaelin, let\'s change this building into a corral.','Thaelin, let\'s change this building into a corral.',26124),
(85702,'enUS','Arise, my minions! Rend their flesh.','',26124),
(85703,'enUS','VERMIN! I WILL TURN YOUR WORLD TO ASH!','',26124),
(85704,'enUS','Where are they, exactly?','Where are they, exactly?',26124),
(85705,'enUS','Should I bring them to you?','Should I bring them to you?',26124),
(85706,'enUS','I\'ll do my best!','I\'ll do my best!',26124),
(85707,'enUS','Tell you what, go grab me five or so and bring them back to the Mage sitting near the campfire over there. Ecilam\'s his name. He\'s using the artifact\'s power to summon some Mage portals within Ashran.','',26124),
(85708,'enUS','Commander, what\'s wrong?','',26124),
(85709,'enUS','','I cannot wait to target some Iron Horde.',26124),
(85710,'enUS','Squeeeeeeek!','',26124),
(85711,'enUS','','So then he pulls out a handful of moss. What a weirdo!',26124),
(85712,'enUS','','So I said, \"I can do it, but not for cheap.\"',26124),
(85713,'enUS','','Next thing I know I\'m waking up behind the shop with it all in my hair!',26124),
(85714,'enUS','They keep coming!','They keep coming!',26124),
(85715,'enUS','More to slay.','More to slay.',26124),
(85716,'enUS','I lost count. How many was that?','I lost count. How many was that?',26124),
(85717,'enUS','They must breed like Murlocs.','They must breed like Murlocs.',26124),
(85718,'enUS','Praise the Raven Mother, we have everything ready! Speak with me again when you are prepared to begin.','',26124),
(85719,'enUS','Goren Gluttons Killed: $1i (+$2i)','Goren Gluttons Killed: $1i (+$2i)',26124),
(85720,'enUS','Goren Burrowers Killed: $1i (+$2i VP)','Goren Burrowers Killed: $1i (+$2i VP)',26124),
(85721,'enUS','Acidback Rollers Killed: $1i (+$2i VP)','Acidbacks Rollers Killed: $1i (+$2i VP)',26124),
(85722,'enUS','','What do you make of that... thing? It\'s enormous.',26124),
(85723,'enUS','What\'s the situation?','What\'s the situation?',26124),
(85724,'enUS','Can I get another Icespine Stinger Bait?','Can I get another Icespine Stinger Bait?',26124),
(85725,'enUS','now... Nowww!','',26124),
(85726,'enUS','Aaaaahhhh!','',26124),
(85727,'enUS','Death comes...','',26124),
(85728,'enUS','Yeeeesssss','',26124),
(85729,'enUS','','Now... Nowww!',26124),
(85730,'enUS','','Aaaaahhhh!',26124),
(85731,'enUS','','Death comes...',26124),
(85732,'enUS','','Yeeeesssss',26124),
(85733,'enUS','What should I paint... what should I paint?','What should I paint... what should I paint?',26124),
(85734,'enUS','','Argghh! Looks like we\'ll have to deal with that gronn.',26124),
(85735,'enUS','','Well, at least we took care of that thing. Come on, hero. We\'d better report this back to headquarters.',26124),
(85736,'enUS','Shattrath has been attacked by a terrible foe!','',26124),
(85737,'enUS','Many lives were lost in the attack, both friends and family alike.','',26124),
(85738,'enUS','Due to your heroic actions, however, many more lives were saved!','',26124),
(85739,'enUS','Although we were unprepared for the attack, each one of you performed admirably.','',26124),
(85740,'enUS','Starting today, new patrols will be instituted across all of Shattrath.','',26124),
(85741,'enUS','Make no mistake, we will NOT be caught unprepared again!','',26124),
(85742,'enUS','May the light embrace you!','',26124),
(85743,'enUS','How goes the fight from the front lines, $n?','',26124),
(85744,'enUS','$n, Sir! Reporting for duty, Sir!','$n, Sir! Reporting for duty, Sir!',26124),
(85745,'enUS','Don\'t let this nuisance anywhere near the cannon.','',26124),
(85746,'enUS','Don\'t let those Horde anywhere near Stormshield, $n.','',26124),
(85747,'enUS','Huh, well then, I\'ll just have to end this myself.','',26124),
(85748,'enUS','I\'ll take you out with me!','',26124),
(85749,'enUS','Reporting for duty, Sir!','Reporting for duty, Sir!',26124),
(85750,'enUS','Reporting in!','Reporting in!',26124),
(85751,'enUS','Your Alchemy Lab is under attack!','Your Alchemy Lab is under attack!',26124),
(85752,'enUS','Watch this!','Watch this!',26124),
(85753,'enUS','Your Armory is under attack!','Your Armory is under attack!',26124),
(85754,'enUS','Your Barn is under attack!','Your Barn is under attack!',26124),
(85755,'enUS','Your Barracks is under attack!','Your Barracks is under attack!',26124),
(85756,'enUS','Your Blacksmith is under attack!','Your Blacksmith is under attack!',26124),
(85757,'enUS','Your Enchanter\'s Study is under attack!','Your Enchanter\'s Study is under attack!',26124),
(85758,'enUS','Your Engineering Works is under attack!','Your Engineering Works is under attack!',26124),
(85759,'enUS','Your Inn is under attack!','Your Inn is under attack!',26124),
(85760,'enUS','Your Scribe\'s Quarters is under attack!','Your Scribe\'s Quarters is under attack!',26124),
(85761,'enUS','Your Gem Boutique is under attack!','Your Gem Boutique is under attack!',26124),
(85762,'enUS','Your Tannery is under attack!','Your Tannery is under attack!',26124),
(85763,'enUS','You\'re to show me Ashran?','You\'re to show me Ashran?',26124),
(85764,'enUS','Your Lumber Mill is under attack!','Your Lumber Mill is under attack!',26124),
(85765,'enUS','Your Sparring Arena is under attack!','Your Sparring Arena is under attack!',26124),
(85766,'enUS','Not again! Another broken string.','Not again! Another broken string.',26124),
(85767,'enUS','Your Mage Tower is under attack!','Your Mage Tower is under attack!',26124),
(85768,'enUS','Your Salvage Yard is under attack!','Your Salvage Yard is under attack!',26124),
(85769,'enUS','Your Stables are under attack!','Your Stables are under attack!',26124),
(85770,'enUS','Your Storehouse is under attack!','Your Storehouse is under attack!',26124),
(85771,'enUS','Good Shot!','Good Shot!',26124),
(85772,'enUS','Your Trading Post is under attack!','Your Trading Post is under attack!',26124),
(85773,'enUS','Your Tailoring Emporium is under attack!','Your Tailoring Emporium is under attack!',26124),
(85774,'enUS','Your Workshop is under attack!','Your Workshop is under attack!',26124),
(85775,'enUS','BONUS: Alchemy Lab Intact (+$1i VP)','BONUS: Alchemy Lab Intact (+$1i VP)',26124),
(85776,'enUS','Show off.','Show off.',26124),
(85777,'enUS','Now let\'s try this again.','Now let\'s try this again.',26124),
(85778,'enUS','Child\'s Play.','Child\'s Play.',26124),
(85779,'enUS','I... <gasp> I\'m fine, $p. I just need to catch my breath.$b$bI wasn\'t expecting the ride to be so fast.','',26124),
(85780,'enUS','Good work, $p! Come speak with me, there is much still to do.','',26124),
(85781,'enUS','BONUS: Armory Intact (+$1i VP)','BONUS: Armory Intact (+$1i VP)',26124),
(85782,'enUS','BONUS: Barn Intact (+$1i VP)','BONUS: Barn Intact (+$1i VP)',26124),
(85783,'enUS','BONUS: Barracks Intact (+$1i VP)','BONUS: Barracks Intact (+$1i VP)',26124),
(85784,'enUS','BONUS: Blacksmith Intact (+$1i VP)','BONUS: Blacksmith Intact (+$1i VP)',26124),
(85785,'enUS','BONUS: Enchanter\'s Study Intact (+$1i VP)','BONUS: Enchanter\'s Study Intact (+$1i VP)',26124),
(85786,'enUS','BONUS: Engineering Works Intact (+$1i VP)','BONUS: Engineering Works Intact (+$1i VP)',26124),
(85787,'enUS','BONUS: Inn Intact (+$1i VP)','BONUS: Inn Intact (+$1i VP)',26124),
(85788,'enUS','BONUS: Scribe\'s Quarters Intact (+$1i VP)','BONUS: Scribe\'s Quarters Intact (+$1i VP)',26124),
(85789,'enUS','BONUS: Gem Boutique Intact (+$1i)','BONUS: Gem Boutique Intact (+$1i)',26124),
(85790,'enUS','BONUS: Tannery Intact (+$1i VP)','BONUS: Tannery Intact (+$1i VP)',26124),
(85791,'enUS','BONUS: Lumber Mill Intact (+$1i VP)','BONUS: Lumber Mill Intact (+$1i VP)',26124),
(85792,'enUS','BONUS: Mage Tower Intact (+$1i VP)','BONUS: Mage Tower Intact (+$1i VP)',26124),
(85793,'enUS','BONUS: Salvage Yard Intact (+$1i VP)','BONUS: Salvage Yard Intact (+$1i VP)',26124),
(85794,'enUS','BONUS: Sparring Arena Intact (+$1i VP)','BONUS: Sparring Arena Intact (+$1i VP)',26124),
(85795,'enUS','BONUS: Stable Intact (+$1i VP)','BONUS: Stable Intact (+$1i VP)',26124),
(85796,'enUS','BONUS: Storehouse Intact (+$1i VP)','BONUS: Storehouse Intact (+$1i VP)',26124),
(85797,'enUS','BONUS: Tailoring Emporium Intact (+$1i VP)','BONUS: Tailoring Emporium Intact (+$1i VP)',26124),
(85798,'enUS','BONUS: Trading Post Intact (+$1i VP)','BONUS: Trading Post Intact (+$1i VP)',26124),
(85799,'enUS','BONUS: Workshop Intact (+$1i VP)','BONUS: Workshop Intact (+$1i VP)',26124),
(85800,'enUS','You make Graveltooth ANGRY! Now you go squish!','',26124),
(85801,'enUS','Then let\'s hurry!','Then let\'s hurry!',26124),
(85802,'enUS','This area is off limits.','This area is off limits.',26124),
(85803,'enUS','Please take a step back.','Please take a step back.',26124),
(85804,'enUS','Lumber shipment en route to your lumber mill!','Lumber shipment en route to your lumber mill!',26124),
(85805,'enUS','I am ready to fly again, Ka\'alu.','I am ready to fly again, Ka\'alu.',26124),
(85806,'enUS','','Such devastation...',26124),
(85807,'enUS','','Why must the orcs cause so much suffering?',26124),
(85808,'enUS','','Next time... I will reduce ALL of them to ash!',26124),
(85809,'enUS','','%s lets out a long, drawn out sigh.',26124),
(85810,'enUS','The enemy battleship is just off the coast.  We will hold off Blackhand, it\'s up to you to disable that boat and save Shattrath!','',26124),
(85811,'enUS','What progress do you have to report? This better not be like last time!','',26124),
(85812,'enUS','','We have learned how to dominate the minds of gronn.',26124),
(85813,'enUS','Good. Finish your work and bring them to me.','',26124),
(85814,'enUS','','Yes, Commander Gar.',26124),
(85815,'enUS','Greetings, $n. Here to do some lumberjacking?','',26124),
(85816,'enUS','I\'d like to submit a work order.','I\'d like to submit a work order.',26124),
(85817,'enUS','Place your hand on Nisha\'s head.','Place your hand on Nisha\'s head.',26124),
(85818,'enUS','<Nisha flutters her wings, ready to go scouting for Rexxar.>','',26124),
(85819,'enUS','<Kolrigg\'s eyes are closed and his skin is pale.>','',26124),
(85820,'enUS','Administer the antidote to Kolrigg.','Administer the antidote to Kolrigg.',26124),
(85821,'enUS','','<Lunzul\'s eyes are closed and her skin is pale.>',26124),
(85822,'enUS','Administer the antidote to Lunzul.','Administer the antidote to Lunzul.',26124),
(85823,'enUS','Oi, me head.','',26124),
(85824,'enUS','Ah, commander, I can\'t thank ye enough. I\'ll get the ol\' brewery up and runnin\' in two shakes of a talbuk\'s tail.','',26124),
(85825,'enUS','','My head be hurtin\' somethin\' terrible.',26124),
(85826,'enUS','','Bless ya, boss mon. I be gettin\' da tavern up and runnin\' faster than you be believin\'.',26124),
(85827,'enUS','Your Alchemy Lab has been damaged!','Your Alchemy Lab has been damaged!',26124),
(85828,'enUS','Your Workshop has been damaged!','Your Workshop has been damaged!',26124),
(85829,'enUS','Your Trading Post has been damaged!','Your Trading Post has been damaged!',26124),
(85830,'enUS','Your Tailoring Emporium has been damaged!','Your Tailoring Emporium has been damaged!',26124),
(85831,'enUS','Your Storehouse has been damaged!','Your Storehouse has been damaged!',26124),
(85832,'enUS','Your Stables have been damaged!','Your Stables have been damaged!',26124),
(85833,'enUS','Your Sparring Arena has been damaged!','Your Sparring Arena has been damaged!',26124),
(85834,'enUS','Your Salvage Yard has been damaged!','Your Salvage Yard has been damaged!',26124),
(85835,'enUS','Your Mage Tower has been damaged!','Your Mage Tower has been damaged!',26124),
(85836,'enUS','Your Lumber Mill has been damaged!','Your Lumber Mill has been damaged!',26124),
(85837,'enUS','Your Tannery has been damaged!','Your Tannery has been damaged!',26124),
(85838,'enUS','Your Gem Boutique has been damaged!','Your Gem Boutique has been damaged!',26124),
(85839,'enUS','Your Scribe\'s Quarters has been damaged!','Your Scribe\'s Quarters has been damaged!',26124),
(85840,'enUS','Your Inn has been damaged!','Your Inn has been damaged!',26124),
(85841,'enUS','Your Engineering Works has been damaged!','Your Engineering Works has been damaged!',26124),
(85842,'enUS','The Iron Maidens have fallen? They were my favorite! Find these invaders and bring me their heads!','',26124),
(85843,'enUS','Your Enchanter\'s Study has been damaged!','Your Enchanter\'s Study has been damaged!',26124),
(85844,'enUS','That beast was irreplaceable. Where are the attackers now? I want them dead. DEAD!','',26124),
(85845,'enUS','Your Blacksmith has been damaged!','Your Blacksmith has been damaged!',26124),
(85846,'enUS','Your Barracks has been damaged!','Your Barracks has been damaged!',26124),
(85847,'enUS','Your Barn has been damaged!','Your Barn has been damaged!',26124),
(85848,'enUS','You? You\'re the dogs who have been wreaking havoc throughout my foundry? Step forward! I will put you in your place.','',26124),
(85849,'enUS','Your Armory has been damaged!','Your Armory has been damaged!',26124),
(85850,'enUS','I will hang your broken bodies from the gates of this foundry!','',26124),
(85851,'enUS','You destroyed my furnace.... Now, my furnace will destroy YOU.','',26124),
(85852,'enUS','Open the flumes! Flood the room with molten slag.','',26124),
(85853,'enUS','I\'ll burn you alive, even if I have to flood the whole foundry...','',26124),
(85854,'enUS','I\'ll bring this whole place down around your heads!','',26124),
(85855,'enUS','I\'ll tear this place apart if I have to!','',26124),
(85856,'enUS','We will rebuild this place... but no one will be able to put YOU back together.','',26124),
(85857,'enUS','You are slow.','',26124),
(85858,'enUS','You are weak.','',26124),
(85859,'enUS','You should\'ve ducked.','',26124),
(85860,'enUS','There\'s no place to hide, now.','',26124),
(85861,'enUS','Coward!','',26124),
(85862,'enUS','You hide like children!','',26124),
(85863,'enUS','Get out here and fight!','',26124),
(85864,'enUS','Everyone DOWN.','',26124),
(85865,'enUS','Snipers! Gun them down.','',26124),
(85866,'enUS','Soldiers! Open fire!','',26124),
(85867,'enUS','Blackrock warriors - fire!','',26124),
(85868,'enUS','Bring in the siegemaker.','',26124),
(85869,'enUS','Siege machines! Tear this place apart!','',26124),
(85870,'enUS','Machines, open fire! Destroy them at any cost!','',26124),
(85871,'enUS','Burn - you will all BURN!','',26124),
(85872,'enUS','This foundry\'s molten heart will devour you.','',26124),
(85873,'enUS','Your bodies will fuel the flames.','',26124),
(85874,'enUS','The furnace will consume you!','',26124),
(85875,'enUS','The hotter the flame, the stronger the steel...','',26124),
(85876,'enUS','This cauldron is your end.','',26124),
(85877,'enUS','Your time runs out.','',26124),
(85878,'enUS','This crucible is your molten grave!','',26124),
(85879,'enUS','Weak.','',26124),
(85880,'enUS','You have no discipline.','',26124),
(85881,'enUS','Our weapons are superior.','',26124),
(85882,'enUS','Pah! Dead.','',26124),
(85883,'enUS','That\'s all you can muster?','',26124),
(85884,'enUS','I will finish this myself!','',26124),
(85885,'enUS','This one should go out with a bang...','',26124),
(85886,'enUS','This one\'s packing a little extra heat.','',26124),
(85887,'enUS','This prototype has double armor plating.','',26124),
(85888,'enUS','The fastest machine in our arsenal!','',26124),
(85889,'enUS','We are... the Warchief\'s weapon... Without us, he...','',26124),
(85890,'enUS','A wounded defender has perished!','A wounded defender has perished!',26124),
(85891,'enUS','Prepare to battle the Primals.','Prepare to battle the Primals.',26124),
(85892,'enUS','Try and keep the peon from dying. They\'re like monster magnets!','',26124),
(85893,'enUS','','<A voice fills your thoughts.>$b$bWe must hurry before the children of Rukhmar can regroup their forces.',26124),
(85894,'enUS','Fine, but I\'ll have my eye on her.','',26124),
(85895,'enUS','','Much better, oaf! I am here to see the commander.',26124),
(85896,'enUS','Please, don\'t wander too far. We need you here, champion.','',26124),
(85897,'enUS','Shelly? Is that you?','',26124),
(85898,'enUS','Yes?','',26124),
(85899,'enUS','Don\'t trust them, Shelly! They are lying to you. They will eat you. They will eat us all!','',26124),
(85900,'enUS','I always did hate vegetables...','',26124),
(85901,'enUS','','Hi Mom!',26124),
(85902,'enUS','Well done, friend. It is rare for one to emerge from that cave alive.','',26124),
(85903,'enUS','Fall in line, maggots! Looks like we\'ve got company.','Fall in line, maggots! Looks like we\'ve got company.',26124),
(85904,'enUS','CRUSH THEM!!!','',26124),
(85905,'enUS','','Rubee just loves her treats.',26124),
(85906,'enUS','Calm yourself, Zoggosh. We will do no such thing. If these weaklings are so eager to die, then we should oblige.','',26124),
(85907,'enUS','Zoggosh, do not question my authority. This isn\'t just ANY gronn. This is Skulloc, Son of Gruul. The blood of a champion courses through his veins. I\'m not concerned with these... paltry whelps.','',26124),
(85908,'enUS','And what exactly do you think they\'re going to do with orcish iron? Fall on it and die, probably. I\'m not worried in the least.','',26124),
(85909,'enUS','Hah. Would you look at that. Maybe I... underestimated them. Zoggosh! Prepare Skulloc! Let them have a taste of what he has to offer.','',26124),
(85910,'enUS','FIRE... FIRE! AIM, THEN FIRE!','',26124),
(85911,'enUS','What is wrong with you?! Keep firing you oaf!','',26124),
(85912,'enUS','Argghhhh! Forget it! They\'ll never make it past the tracks. Makogg, Ahri\'ok - front and center! There\'s some new meat for you to tenderize.','',26124),
(85913,'enUS','That was an insignificant loss. Let them exhaust themselves, preying against our weak -- against those who are unworthy of serving in Blackhand\'s army! Blood and honor, Zoggosh. That is all that orcs understand.','',26124),
(85914,'enUS','That is what I do, Zoggosh. I think good.','',26124),
(85915,'enUS','I\'m not playing these games anymore. Bring in the saberon and we\'ll be done with it.','',26124),
(85916,'enUS','Put a muzzle on it.','',26124),
(85917,'enUS','I didn\'t mean the cat.','',26124),
(85918,'enUS','How dare you march into MY DOCKS and so brazenly set foot on MY SHIP. Nothing will stop the Iron Horde, least of all you.  Enjoy your death, weaklings. Zoggosh, man the machine turret!','',26124),
(85919,'enUS','I don\'t have the 10 timber required to place a work order. Where can I find more timber?','I don\'t have the 10 timber required to place a work order. Where can I find more timber?',26124),
(85920,'enUS','Zoggosh, ready your axe. This ends now!','',26124),
(85921,'enUS','So WEAK!','',26124),
(85922,'enUS','Bow before the might of the Iron Horde!','',26124),
(85923,'enUS','In... conceivable....','',26124),
(85924,'enUS','Sir, they\'ve breached the gates! Nok\'gar... He\'s dead!! We should pick up anchor and set sail for Talador right now!','',26124),
(85925,'enUS','But sir, this is the last of the gronn that we have! Blackhand will have our hides if we show up empty handed!','',26124),
(85926,'enUS','Yessir!','',26124),
(85927,'enUS','Sir! They\'re tampering with the Iron Stars!','',26124),
(85928,'enUS','Igniting the cannons, sir!','',26124),
(85929,'enUS','Sir, he\'s out of ammunition! I\'m reloading, I\'m reloading!','',26124),
(85930,'enUS','Sir, half of our army has been taken out! Don\'t you think we should--','',26124),
(85931,'enUS','Ahhh. Good thinking, sir.','',26124),
(85932,'enUS','Captain, they\'re almost here! What do we do now?!','',26124),
(85933,'enUS','Uhhh... Are you sure you want to let that thing out of its cage? I don\'t think we have fed it since we found it.','',26124),
(85934,'enUS','Good idea, sir!','',26124),
(85935,'enUS','Oh.','',26124),
(85936,'enUS','Aye aye, sir!','',26124),
(85937,'enUS','Yes, captain!','',26124),
(85938,'enUS','Koramar, no! I will avenge you!','',26124),
(85939,'enUS','','Right away, captain! It will be my pleasure.',26124),
(85940,'enUS','Hah. Ditto.','',26124),
(85941,'enUS','','Ooooh! Is there killin\' ta be done? Lemme at\'em!',26124),
(85942,'enUS','Rooby Roo looks at you, then runs off!','',26124),
(85943,'enUS','Iron Horde Killed: $1i (+$2i VP)','Iron Horde Killed: $1i (+$2i VP)',26124),
(85944,'enUS','Scout! What do you have to report?','',26124),
(85945,'enUS','Looks like the Iron Horde is making their move. Grunts! Get the peons to shelter!','',26124),
(85946,'enUS','To arms! To your posts! We face a worthy foe today...','',26124),
(85947,'enUS','Sergeant! Smoke on the horizon, and war drums in the distance!','Sergeant! Smoke on the horizon, and war drums in the distance!',26124),
(85948,'enUS','We\'ll have to face their scouts first.','',26124),
(85949,'enUS','Here they come...','',26124),
(85950,'enUS','Rooby Roo is hungry!','',26124),
(85951,'enUS','','To become an Exarch, I must first pass through a series of trials.',26124),
(85952,'enUS','','I am allowed one champion to accompany me along this journey. I would like that person to be you, $n.',26124),
(85953,'enUS','','I am ready. Come, the Exarch Council awaits.',26124),
(85954,'enUS','They were just sent to soften us up...','',26124),
(85955,'enUS','Spread out! They\'ll be coming from all angles!','',26124),
(85956,'enUS','Rukhmar sheds her feathers, igniting all Piles of Ash to fight one last time!','Rukhmar sheds her feathers, igniting all Piles of Ash to fight one last time!',26124),
(85957,'enUS','We.... we made it...','',26124),
(85958,'enUS','','|TInterface\\Icons\\Ability_Mage_MoltenArmor.blp:20|tArchmage Sol begins casting Fire spells!',26124),
(85959,'enUS','','|TInterface\\Icons\\Spell_Frost_FrostArmor02.blp:20|tArchmage Sol begins casting Frost spells!',26124),
(85960,'enUS','','|TInterface\\Icons\\Spell_MageArmor.blp:20|tArchmage Sol begins casting Arcane spells!',26124),
(85961,'enUS','Rooby Roo looks at you, then slowly saunters off.','',26124),
(85962,'enUS','Rooby Roo barks. There\'s something in there!','',26124),
(85963,'enUS','','Is... is it dead?',26124),
(85964,'enUS','I was promised... eternal life...','',26124),
(85965,'enUS','We are nearly free of Tanaan\'s grasp. Stay focused now, $n.','',26124),
(85966,'enUS','','A-a-a-about t-time, $n. I-it\'s f-freezing out here. No wonder we draenei s-s-settled in warmer areas.',26124),
(85967,'enUS','Let\'s get out of here.','Let\'s get out of here.',26124),
(85968,'enUS','I\'m ready to face Everburn.','I\'m ready to face Everburn.',26124),
(85969,'enUS','','Are you ready, hero? It is just up this way.',26124),
(85970,'enUS','','Steel yourself. This is not the lair of an ordinary beast.',26124),
(85971,'enUS','','Come, fury! My courage shall not falter before you!',26124),
(85973,'enUS','','Well done, champion! Akama\'s task is finished. I cannot wait to see his face when we report on our success.',26124),
(85974,'enUS','I will tear you and your garrison apart.','',26124),
(85975,'enUS','A soldier\'s duty... is never done.','',26124),
(85976,'enUS','Your time... will come.','',26124),
(85977,'enUS','You\'re a fool. Just like Taylor.','',26124),
(85978,'enUS','I turned the Admiral\'s \"followers\" against him. Perhaps I shall pay your garrison a visit next?','',26124),
(85979,'enUS','The dark one promised me so much... if I succeeded...','',26124),
(85980,'enUS','<Rooby Roo looks hungry. Perhaps her owner has something that would help.>','',26124),
(85981,'enUS','Your bags have been pickpocketed by |c00FFFF00|Hspell:168798|h[Pick Pocket]|h|r. You\'ve lost 5 |c00FFFFFF|Hcurrency:944|h[Artifact Fragments]|h|r.','Your bags have been pickpocketed by |c00FFFF00|Hspell:168798|h[Pick Pocket]|h|r. You\'ve lost 5 |c00FFFFFF|Hcurrency:944|h[Artifact Fragments]|h|r.',26124),
(85982,'enUS','Were it not for you, this would be Nisha\'s resting place as well.','',26124),
(85983,'enUS','Oregorger has gone insane from hunger!','',26124),
(85984,'enUS','Very good! Did you rehearse when I wasn\'t looking?','',26124),
(85985,'enUS','Correct, you are doing fine.','',26124),
(85986,'enUS','Fantastic! The power of the ritual is increasing!','',26124),
(85987,'enUS','Perfect! Oh, we are so close to success!','',26124),
(85988,'enUS','Come on, Bryan. Snap out of it!','',26124),
(85989,'enUS','Snap out of it, mon. Come back to us.','',26124),
(85990,'enUS','%s does not detect any nearby enemies, and initiates |cFFFF0404|Hspell:168929|h[Cannon Barrage!]|h|r!','',26124),
(85991,'enUS','It came... in the night...','',26124),
(85992,'enUS','','This is it. Garrosh Hellscream sits smugly on his throne just beyond these gates.$B$BWe can\'t let him escape this time, $n.',26124),
(85993,'enUS','Can\'t you see I am trying to fish here?','Can\'t you see I am trying to fish here?',26124),
(85994,'enUS','You look like an able fisherman, do you think you can help us out?\n\nWe have established a small garrison nearby, but we are finding it difficult to feed our troops. Any fishing advice you could give us would really help.','You look like an able fisherman, do you think you can help us out?\n\nWe have established a small garrison nearby, but we are finding it difficult to feed our troops. Any fishing advice you could give us would really help.',26124),
(85995,'enUS','At this point, we are just waiting for an opening. Once the stream of enemies abates, we make our move.','',26124),
(85996,'enUS','<The archmage focuses intently on the portal.>$b$bLook. Their numbers are abating, however briefly. This may be our chance.$b$bAre you prepared to face whatever\'s on the other side of that portal?','',26124),
(85997,'enUS','FOR AZEROTH!','FOR AZEROTH!',26124),
(85998,'enUS','Tread carefully. If the rumors I hear are true, you will find yourself in grave danger.','',26124),
(85999,'enUS','You have shown great courage and recovered an invaluable artifact. Lok\'tar.','',26124),
(86000,'enUS','I know not what you will find out there, but if you encounter any of the Iron Horde, show them no mercy.','',26124),
(86001,'enUS','The heart of the magnaron... the power we now wield against the Iron Horde is immense.','',26124),
(86003,'enUS','Miss Pinchwhistle! The \"Mother Lode,\" it just crashed into the mountains south of here!','',26124),
(86004,'enUS','','What!? They were only supposed to be observing; we need to get a rescue team down there pronto!',26124),
(86005,'enUS','','Whoa! What was that?',26124),
(86006,'enUS','Speak with Ka\'alu when you are ready to fly.','',26124),
(86007,'enUS','There\'s timber to be found across all of Draenor!','',26124),
(86008,'enUS','There\'s timber all across this world, commander, but I would recommend that you harvest in Gorgrond or Talador.','',26124),
(86009,'enUS','There\'s timber all across this world, commander, but I would recommend that you harvest in the Spires of Arak or Talador.$B$BBoth of those regions are overflowing with timber to chop down!','',26124),
(86010,'enUS','Nagrand is the final frontier for harvesting timber, $g sir:ma\'am;.$B$BOf course the rest of Draenor is wide open to your keen harvesting skills.','',26124),
(86011,'enUS','','I can\'t believe Baros is gone... If you will excuse me commander I really need to focus on my work right now.',26124),
(86012,'enUS','','Poor Thorn, she\'s so heartbroken. I don\'t think she will ever leave her worgen form again.',26124),
(86013,'enUS','Many leagues of deadly land yet stand between us and the Blackrock.','',26124),
(86014,'enUS','Gorgrond is no place for armies. This land swallows all who enter. We will be fortunate to even lay eyes upon the Iron Horde base.','',26124),
(86015,'enUS','','We should have brought an army to fight the Iron Horde!',26124),
(86016,'enUS','','Life is short, commander. It is important to seize the moment.',26124),
(86017,'enUS','','Baros was such a sweet man.$b$bIf only I would have paid more attention to him when he was alive. I\'ll never forgive myself for letting him slip through my fingers.',26124),
(86018,'enUS','','How can I help you, commander?',26124),
(86019,'enUS','','Ha! Your size makes you weak, giant.',26124),
(86020,'enUS','Tell me, commander, what do you think of Lieutenant Thorn? Whenever she\'s around, I get so flustered.$b$bI\'m just... not really good with women. Which she is an exceptional example of. A woman, that is. Although she is also a worgen. Which I also like. Oh, that long, silky fur...$B$BSigh...','',26124),
(86021,'enUS','','Commander, I was just wondering. Has Baros mentioned me by any chance? What? Oh... no reason.$b$b<Thorn blushes>',26124),
(86022,'enUS','Logging is just a hobby. My true calling is singing and dancing. Me and my group, \'N Swing, are going to be rich and famous some day.','',26124),
(86023,'enUS','There\'s timber all across this world, commander, but I would recommend that you start your search in Gorgrond.$B$BIf you\'re a risk taker you can try Shadowmoon Valley, but I hear the Alliance controls that region. You might run into some trouble if you\'re not careful.$B$BFrostfire isn\'t so great for trees, but if you\'re desperate you can look around. You might find a few small timber.','',26124),
(86024,'enUS','There\'s timber all across this world, commander, but I would recommend that you start your search in Shadowmoon Valley or Gorgrond.$B$BIf you\'re a risk taker you can try Frostfire Ridge, but I hear the Horde controls that region. You might run into some trouble if you\'re not careful.','',26124),
(86025,'enUS','Fury of Earth, grant these heroes your protection!','',26124),
(86026,'enUS','Fury of Fire, ignite our fists and weapons!','',26124),
(86027,'enUS','Fury of Wind, honor these soldiers with your presence!','',26124),
(86028,'enUS','Fury of Water, heal our injured!','',26124),
(86029,'enUS','I thought I was done for. Thank you, hero.','I thought I was done for. Thank you, hero.',26124),
(86030,'enUS','The mist took me by surprise. Thank you for helping me.','The mist took me by surprise. Thank you for helping me.',26124),
(86031,'enUS','Thank you, stranger. What brought this mist upon us so suddenly?','Thank you, stranger. What brought this mist upon us so suddenly?',26124),
(86032,'enUS','My gratitude to you, hero. I thought my fate was surely sealed.','My gratitude to you, hero. I thought my fate was surely sealed.',26124),
(86033,'enUS','Bless you, stranger. I can find my way back from here.','Bless you, stranger. I can find my way back from here.',26124),
(86034,'enUS','The creatures native to this swamp seem unaffected by the poison mist.$B$BThere must be something about the clackers and crabs that make them especially resilient to this strange phenomenon.','',26124),
(86035,'enUS','Luckily, we\'ve discovered that the native mushroom species have immense restorative properties.$B$BWhile we search for the cause of the mist, we have been eating the mushrooms to recover our strength and combat the poison.','',26124),
(86036,'enUS','We currently have $9311w collected. We need $9707w total.','',26124),
(86037,'enUS','We have activated the |c00FFFF00|Hspell:178538|h[Mage Portal]|h|r! Good work!','',26124),
(86038,'enUS','The Axe of Serathil compels you!','',26124),
(86039,'enUS','The Mage Portal has been destroyed by the Horde!','',26124),
(86040,'enUS','Ha! Now I fight... you?','',26124),
(86041,'enUS','I am sorry! The axe whispers and I must obey!','',26124),
(86042,'enUS','The |c00FFFF00|Hspell:178537|h[Knight Riders]|h|r are out for duty!','',26124),
(86043,'enUS','The |c00FFFF00|Hspell:178537|h[Knight Riders]|h|r have been slain by the Horde!','',26124),
(86044,'enUS','My mind is not my own! Serathil!','',26124),
(86045,'enUS','','So how many Alliance have you slain today, $n?',26124),
(86046,'enUS','','Tag you\'re it!',26124),
(86047,'enUS','','Foolish little rodent, you are too late! The Heart of Gorgorek is mine.',26124),
(86048,'enUS','','Unfortunately for you, my blade hungers.',26124),
(86049,'enUS','','Race you around!',26124),
(86050,'enUS','','Warlord, we have it under control.',26124),
(86051,'enUS','Race you back!','',26124),
(86052,'enUS','I win!','',26124),
(86053,'enUS','','It... is free. Warlord, we have failed...',26124),
(86054,'enUS','','Hey, no fair.',26124),
(86055,'enUS','','I don\'t have time for this. Your end is near, hero. The next time we meet, be prepared for death.',26124),
(86056,'enUS','1, 2, 3...','',26124),
(86057,'enUS','Twenty! Ready or not, here I come!','',26124),
(86058,'enUS','Found you!','',26124),
(86059,'enUS','','No peeking.',26124),
(86060,'enUS','','Race you back!',26124),
(86061,'enUS','','Syd, Brae!',26124),
(86062,'enUS','','Now, I want you to come home before dark.',26124),
(86063,'enUS','','And you stay out of trouble!',26124),
(86064,'enUS','','Bye Mom.',26124),
(86065,'enUS','Yes, mom.','',26124),
(86066,'enUS','Caught anything?','',26124),
(86067,'enUS','Any bites?','',26124),
(86068,'enUS','So, still...','',26124),
(86069,'enUS','Maybe we should move on?','',26124),
(86070,'enUS','Nah.','',26124),
(86071,'enUS','Same answer as the last two times.','',26124),
(86072,'enUS','The Matriarch is safe. You have proven to be a worthy ally; I look forward to fighting alongside you again.','',26124),
(86073,'enUS','Haha...haha... AHHAHAHAHA! Didn\'t anyone ever tell you not to play with fire?','',26124),
(86074,'enUS','They took Corporal Thukmar!','',26124),
(86080,'enUS','The skies are not out of reach. No, not out of reach.','',26124),
(86081,'enUS','The dusk will rise to the stars.','',26124),
(86082,'enUS','My muzzle\'s never missed its mark! The prize is as good as mine!','My muzzle\'s never missed its mark! The prize is as good as mine!',26124),
(86083,'enUS','Holy light, did ya hafta get the worst-smelling one of the bunch?','',26124),
(86084,'enUS','Aw, ain\'t his fault he\'s stinky, is it fella?','',26124),
(86085,'enUS','Tommy Joe, last time you took a bath \nwas before the Cataclysm.','',26124),
(86086,'enUS','Even in the light, there is shadow.','',26124),
(86087,'enUS','Caught yerself a fiesty one here, Commander!','',26124),
(86088,'enUS','Look at him go!','',26124),
(86089,'enUS','Oh... So close that time!','Oh... So close that time!',26124),
(86090,'enUS','Guess you can\'t make milk without breakin\' a few eggs!','',26124),
(86091,'enUS','I wonder how the other competitors are doing.','I wonder how the other competitors are doing.',26124),
(86092,'enUS','Folks back at the garrison will appreciate this one.','',26124),
(86093,'enUS','I wanna eat it already, how about just a little bite?','',26124),
(86094,'enUS','Another shot, another miss.','Another shot, another miss.',26124),
(86095,'enUS','Tommy Joe, last time you tried that you ended up with a bad case of broken face.','',26124),
(86096,'enUS','I should really work on my aim if I expect to win the competition!','I should really work on my aim if I expect to win the competition!',26124),
(86097,'enUS','Ya know, haulin\' these things back ain\'t a walk in the park.','',26124),
(86098,'enUS','A wolf nearly ate my foot!','',26124),
(86099,'enUS','Back in my day, wolves would eat both of our feet, both ways to and from Ironforge, in the snow.','',26124),
(86100,'enUS','This one\'s even bigger than the last one!','',26124),
(86101,'enUS','Bigger\'n three cows tied together!','',26124),
(86102,'enUS','Yep, sure bigger\'n... wait, what?','',26124),
(86103,'enUS','Come take a look at my newest goods!','',26124),
(86104,'enUS','Come try out the best tools in Draenor!','',26124),
(86105,'enUS','Rare items from the fabled Azeroth!','',26124),
(86106,'enUS','Someday, I will have a greenhouse of my own.','',26124),
(86107,'enUS','Just two more years, then I can branch out on my own.','',26124),
(86108,'enUS','I am glad Jayciel made it out of Karabor.','',26124),
(86109,'enUS','Can I get another Moonshell Claw Bait?','Can I get another Moonshell Claw Bait?',26124),
(86110,'enUS','Tomen? Are you in there?','',26124),
(86111,'enUS','Who\'s that hollering?','',26124),
(86112,'enUS','Berethal? It has been a long time. What brings you back here?','',26124),
(86113,'enUS','I heard about the attacks and came out to help.','',26124),
(86114,'enUS','Well it is good to see you. What can I get you?','',26124),
(86115,'enUS','Just two packages for now.','',26124),
(86116,'enUS','You think yourself a worthy vessel for my power? Prove it!','',26124),
(86117,'enUS','Impressive...','',26124),
(86118,'enUS','','I\'ve been waiting for you. I\'m going to have to cut you now -- and it\'s going to burn.',26124),
(86119,'enUS','Fool, you challenge me? I will boil your insides.','',26124),
(86120,'enUS','So you are the one Azuka spoke of. So puny, I thought this would be a challenge.  Prepare to die.','',26124),
(86121,'enUS','Long have my people suffered the Curse of Sethe, and long have we sought a cure.','',26124),
(86122,'enUS','','Some sort of veil has descended on this outpost. We need to find the cause.',26124),
(86123,'enUS','Let\'s do some investigating.','Let\'s do some investigating.',26124),
(86124,'enUS','Begin your spell.  I\'ll protect you!','Begin your spell.  I\'ll protect you!',26124),
(86125,'enUS','','So be it. Katsuo, show this \'gladiator\' the might of the Burning Blade.',26124),
(86126,'enUS','The chest is empty, the heart has been stolen.','The chest is empty, the heart has been stolen.',26124),
(86127,'enUS','','You are fortunate. The honor of the arena stays my hand.',26124),
(86128,'enUS','Sorceries, rituals and rites. Unspeakable acts of darkness and desperation, all for naught.','',26124),
(86129,'enUS','','Who dares to challenge my clan?',26124),
(86130,'enUS','We now must face the Iron Horde fleet. They have a powerful weapon aboard a battleship just off the coast. I know a spell that can clear the way, but it will take all my focus to channel it. During my incantation, I will be vulnerable. It will be up to you and our allies to protect me.','',26124),
(86131,'enUS','Continue your search for Azuka Bladefury.','Continue your search for Azuka Bladefury.',26124),
(86132,'enUS','We found refuge in the shadows, yes, but also shame. We lost our way.','',26124),
(86133,'enUS','','Impossible! Insolent whelp. You dare spit in the face of my clan\'s honor?',26124),
(86134,'enUS','','This just became personal. Let me see how you fight firsthand.',26124),
(86135,'enUS','I led my people astray. You would have been fair to shun them as others do.','',26124),
(86136,'enUS','And yet, you showed them kindness. Curious.','',26124),
(86137,'enUS','Did we import roses from Azeroth to the garrison farm? I don\'t remember.','',26124),
(86138,'enUS','','I\'ll set up a patrol. We need to know if any more members of the Burning Blade have infiltrated the garrison.',26124),
(86139,'enUS','','Baros, you fool... you should have told me you loved me sooner. It didn\'t have to end like this.',26124),
(86140,'enUS','','This is not over. The Iron Horde... will... pay.',26124),
(86141,'enUS','','These mists are quite dangerous. I will try to keep you safe, but use the mushrooms to heal yourself.',26124),
(86142,'enUS','','There! That creature must be the cause of the poisonous mist!',26124),
(86143,'enUS','','Excellent teamwork, hero! We have cured the swamp of its curse. I will go on ahead, so meet me when you are done here.',26124),
(86144,'enUS','I have half a dozen rangari unaccounted for. Please find them!','',26124),
(86145,'enUS','Thank you for helping my people, friend. I will be sure to send word of your kindness to Exarch Naielle.','',26124),
(86146,'enUS','Mr. Jones! Is that you?','Mr. Jones! Is that you?',26124),
(86147,'enUS','You gave them strength. Though the curse may forever weigh upon their bones, I see them standing tall and proud.','',26124),
(86148,'enUS','You have succeeded where I failed. You have set my people free.','',26124),
(86149,'enUS','Truly, you are their Talon King.','',26124),
(86150,'enUS','Truly, you are their Talon Queen.','',26124),
(86151,'enUS','Reporting in!','Reporting in!',26124),
(86152,'enUS','You\'re to show me Ashran?','You\'re to show me Ashran?',26124),
(86153,'enUS','Xeri\'tac descends from her web!','',26124),
(86154,'enUS','|TInterface\\Icons\\Ability_Racial_Cannibalize.blp:20|tXeri\'tac starts to |cFFFF0000|Hspell:169248|h[Consume]|h|r a Pale Orc!','',26124),
(86155,'enUS','|TInterface\\Icons\\spell_festergutgas.blp:20|tA Pale Orc has |cFFFF0000|Hspell:169233|h[Inhaled]|h|r Toxic Gas! Their power will increase the longer they are alive.','|TInterface\\Icons\\spell_festergutgas.blp:20|tA Pale Orc has |cFFFF0000|Hspell:169233|h[Inhaled]|h|r Toxic Gas! Their power will increase the longer they are alive.',26124),
(86156,'enUS','So. Thirsty.','',26124),
(86157,'enUS','Returned to the earth.','',26124),
(86158,'enUS','Feed my roots.','',26124),
(86159,'enUS','No!','',26124),
(86160,'enUS','I. Cannot. Be. Stopped.','',26124),
(86161,'enUS','Refreshed.','',26124),
(86163,'enUS','+$i Points from $n!','',26124),
(86164,'enUS','Come, he has not yet reached his full strength.','',26124),
(86165,'enUS','I will handle Sethe, you take care of the cultists!','',26124),
(86166,'enUS','Behold, my rebirth!','',26124),
(86167,'enUS','My blood will blacken the seas!','',26124),
(86168,'enUS','My flesh shall fester until the very sky rots with it!','',26124),
(86169,'enUS','My hatred is... undying...','',26124),
(86170,'enUS','*sneeze* There\'s something in the air...','',26124),
(86171,'enUS','Through this rocky ground? Impossible. Sound the alarm!','',26124),
(86172,'enUS','To arms! To your posts! And be wary of new wild growth.','',26124),
(86173,'enUS','Sergeant, strange plants are growing inside the garrison.','Sergeant, strange plants are growing inside the garrison.',26124),
(86174,'enUS','Apexis crystals are common among the most dangerous parts of Draenor. You will find them immensely useful as you augment your equipment.','',26124),
(86175,'enUS','We\'ll cart this sucker back to base immediately, commander!','',26124),
(86176,'enUS','I think this is the beginning of a very powerful partnership, my friend. Good luck.','',26124),
(86177,'enUS','I brought my favorite rope!','',26124),
(86178,'enUS','Oh no, not Clyde.','',26124),
(86179,'enUS','Interestin\' markings on this little guy.','',26124),
(86180,'enUS','Aww, look at his little tuft of fur!','',26124),
(86181,'enUS','Now don\'t be touchin\' that, Tommy Joe.','',26124),
(86182,'enUS','','Be careful, champion.',26124),
(86183,'enUS','You create a diversion to the west while I move the rest of us south.','',26124),
(86184,'enUS','Yrel, Maraad, and Duotan need your help on the flagship.  Blackhand will not go down without a fight.','',26124),
(86185,'enUS','Who dare challenge Lug\'dol?','',26124),
(86186,'enUS','I snap da neck of anyone who challenge me!','',26124),
(86187,'enUS','Nobody can beat Lug\'dol. Lug\'dol da best!','',26124),
(86188,'enUS','Nobody left to fight. Lug\'dol sad.','',26124),
(86189,'enUS','I\'m in da running to be da next blood champion. You dead!','',26124),
(86190,'enUS','I\'m gonna be da next blood champion. You die!','',26124),
(86191,'enUS','Your head will be my good luck charm to be the next blood champion.','',26124),
(86192,'enUS','You just another kill towards me becoming da blood champion.','',26124),
(86193,'enUS','I... lose?','',26124),
(86194,'enUS','','We have activated the |c00FFFF00|Hspell:178539|h[Mage Portal]|h|r!',26124),
(86195,'enUS','It no end like dis...','',26124),
(86196,'enUS','But you so small...','',26124),
(86197,'enUS','','The |c00FFFF00|Hspell:178539|h[Mage Portal]|h|r has been destroyed by the Alliance!',26124),
(86198,'enUS','Lug\'dol... finished.','',26124),
(86199,'enUS','Enough of dis. Lug\'dol SMASH!','',26124),
(86200,'enUS','The |c00FFFF00|Hspell:178536|h[Wolf Riders]|h|r are out for duty!','',26124),
(86201,'enUS','The |c00FFFF00|Hspell:178536|h[Wolf Riders]|h|r have been slain by the Alliance!','',26124),
(86202,'enUS','The |c00FFFF00|Hspell:178534|h[Warlock Gateway]|h|r has been activated! Check your map for the locations.','',26124),
(86203,'enUS','The |c00FFFF00|Hspell:178534|h[Warlock Gateway]|h|r has been destroyed by the Alliance!','',26124),
(86204,'enUS','|c00FFFF00|Hspell:178359|h[Kronus]|h|r has arisen!','',26124),
(86205,'enUS','You fools! The Alliance has killed |c00FFFF00|Hspell:178359|h[Kronus]|h|r!','',26124),
(86206,'enUS','We\'ve managed to contain this building. You should be safe from the mist in here.','',26124),
(86207,'enUS','The mine entrance is boarded up while work goes on inside.','',26124),
(86208,'enUS','','We shall fight it, together.',26124),
(86209,'enUS','','Your size works against you!',26124),
(86210,'enUS','','I remember your true face.',26124),
(86211,'enUS','','Yes! Burn it... sister.',26124),
(86212,'enUS','','For the light!',26124),
(86213,'enUS','','We do not fear you!',26124),
(86214,'enUS','','Be at peace.',26124),
(86215,'enUS','Oh yeah, this conversation never happened. Gotta be an unbiased promoter and all.','',26124),
(86216,'enUS','','Watch your flank, sister.',26124),
(86217,'enUS','Coming right up.','',26124),
(86218,'enUS','This is the life. I missed good old Nagrand.','',26124),
(86219,'enUS','These will work great. Thank you Tomen, I hope to get back to them soon.','',26124),
(86220,'enUS','See you at the ring, champ.','',26124),
(86221,'enUS','Here you go. I hope you can get back to your family in Shattrath soon.','',26124),
(86222,'enUS','Our campaign is gaining momentum. Both the Alliance and Horde have established garrisons on the mainland. But we must be wary of counter-attacks...','',26124),
(86223,'enUS','I\'m ready. Start casting!','I\'m ready. Start casting!',26124),
(86224,'enUS','Invasive Thornblooms Killed: $1i (+$2i VP)','',26124),
(86225,'enUS','Ravager Wasps Killed: $1i (+$2i VP)','',26124),
(86226,'enUS','Podlings Killed: $1i (+$2i VP)','',26124),
(86227,'enUS','Plant Hydras Killed: $1i (+$2i VP)','',26124),
(86228,'enUS','Lashers Killed: $1i (+$2i VP)','',26124),
(86229,'enUS','Gnarled Ancient Killed: $1i (+$2i VP)','',26124),
(86230,'enUS','Botanis Killed: $1i (+$2i VP)','',26124),
(86231,'enUS','Ancients Killed: $1i (+$2i VP)','',26124),
(86232,'enUS','','I can\'t wait to explore Draenor Percy!',26124),
(86233,'enUS','Roadblock removed!','Roadblock removed!',26124),
(86234,'enUS','','Ooh, another trick!',26124),
(86235,'enUS','','That was great!',26124),
(86236,'enUS','','So what is he?',26124),
(86237,'enUS','','Bark* Bark*',26124),
(86238,'enUS','','Percy is a pug.',26124),
(86239,'enUS','','A... what?',26124),
(86240,'enUS','','Hmm.. well, a pug is a type of dog we have on Azeroth.',26124),
(86241,'enUS','','It\'s a shame what happened to his face.',26124),
(86243,'enUS','','Ruff*!',26124),
(86244,'enUS','','I am Magister Serena. Nice to meet you!',26124),
(86245,'enUS','Commander, our aerial squadron has weakened the magnaron, but we\'re pinned out here. We need your help to assault the main compound.','',26124),
(86246,'enUS','I don\'t like da look a\' dis ting, hero.','',26124),
(86247,'enUS','Is this him?','',26124),
(86248,'enUS','Betrayed by Garrosh the moment they arrived on Draenor.','',26124),
(86249,'enUS','','It is. The final resting place of Kairozdormu.',26124),
(86250,'enUS','','Ah, welcome, Vindicator Yrel. I see you have come for Maladaar\'s trial.',26124),
(86251,'enUS','','The spirits sense your purpose. They already grow eager to challenge you.',26124),
(86252,'enUS','','It is my honor to face the heroes of the ancient past. They will not find me lacking.',26124),
(86253,'enUS','','Good luck, Lady Yrel.',26124),
(86254,'enUS','Yrel, this is how I always wished to see you. Do not let me down.','',26124),
(86255,'enUS','','Greetings, teacher. Let me show you what I have learned in my travels.',26124),
(86256,'enUS','You have exceeded all my hopes, Yrel. You may proceed.','',26124),
(86257,'enUS','','Now, to lay Maraad\'s ashes to rest.',26124),
(86258,'enUS','Yrel... how you have grown since last we met. But... is it enough? Are you worthy of leading our people?','',26124),
(86259,'enUS','Now, it is my turn to test your strength.','',26124),
(86260,'enUS','When you face a more powerful foe, will you stand strong?','',26124),
(86261,'enUS','','Do not fear, for I will stand!',26124),
(86262,'enUS','When our people look to you, will you be ready to command?','',26124),
(86263,'enUS','','I shall not let them down!',26124),
(86264,'enUS','When all hope is lost, will you... still... fight?','',26124),
(86265,'enUS','','I shall never yield!',26124),
(86266,'enUS','','I... can...',26124),
(86267,'enUS','When you look inside yourself and see only darkness, can you still find the Light?','',26124),
(86268,'enUS','What was that?','',26124),
(86269,'enUS','','Because... in this world... we are never...',26124),
(86270,'enUS','','Hero! Use the hammer, now!',26124),
(86271,'enUS','Yrel... it is true. The student has surpassed the teacher. You are ready.','',26124),
(86272,'enUS','If only Prophet Velen could see you now... he would be proud.','',26124),
(86273,'enUS','Rise, Yrel. It is your charge to unite the draenei. Prepare them for what\'s to come.','',26124),
(86274,'enUS','Farewell...','',26124),
(86275,'enUS','','Maraad, my friend... be at peace.',26124),
(86276,'enUS','','Thank you, hero. I will meet up with you later. I just need a moment to pay my respects to the ancestors.',26124),
(86277,'enUS','One final trial awaits, Yrel. US!','',26124),
(86278,'enUS','You have chosen your champion. Now, let us begin!','',26124),
(86279,'enUS','Ahh, I am defeated.','',26124),
(86280,'enUS','','Such strength!',26124),
(86281,'enUS','I submit!','',26124),
(86282,'enUS','Yrel, today, you have completed the trials of the exarch.','',26124),
(86283,'enUS','You have proven courage, kindness, faith, and strength... pillars upon which our society has arisen.','',26124),
(86284,'enUS','However, we measure a leader not only by her merit, but also by the character of her companions.','',26124),
(86285,'enUS','Champion, we have watched you throughout this trial.','',26124),
(86286,'enUS','We saw your bravery in Frostfire, your persistence in Nagrand, and your loyalty in Auchindoun.','',26124),
(86287,'enUS','Your dedication to Lady Yrel proves to us that she is worthy. We did not choose the next Exarch. YOU did.','',26124),
(86288,'enUS','Yrel, do not forget that an exceptional leader inspires greatness in others. Trust in your people, and trust in yourself.','',26124),
(86289,'enUS','Now, RISE...','',26124),
(86290,'enUS','EXARCH YREL!','',26124),
(86291,'enUS','Good luck to you, Yrel. Courage comes from the mind and heart.','',26124),
(86292,'enUS','','Go with my blessing, Yrel. Do not forget those less fortunate.',26124),
(86293,'enUS','Let faith guide you, Yrel.','',26124),
(86294,'enUS','','Gaze upon the source of your demise, heroes.',26124),
(86295,'enUS','','This magnaron walked Draenor before the first orc took breath.  And now it bends to my will.',26124),
(86296,'enUS','','It will crush your armies and your pitiful fortress.  But first, it will crush YOU!',26124),
(86297,'enUS','The beast is defeated, but we cannot rest yet. One enemy still remains.','',26124),
(86298,'enUS','I am needed near the gates. Warchief Hellscream has been spotted on the battlefield.','',26124),
(86299,'enUS','Find Bladefury. Bring me her head!','',26124),
(86300,'enUS','Taz\'dingo! Well fought, mon. But we ain\'t leavin\' until da she-orc be dead.','',26124),
(86301,'enUS','I be needed near da main gate. Dey say Grommash has joined da battle.','',26124),
(86302,'enUS','Take care a  Bladefury. Bring me her head!','',26124),
(86303,'enUS','','I grow tired of our games, little mouse. It\'s time to finish this.',26124),
(86304,'enUS','','My blade thirsts for your blood!',26124),
(86305,'enUS','','No... noooo... Warchief... I have... failed you...',26124),
(86306,'enUS','','Halt! Hellscream approaches.',26124),
(86307,'enUS','Look! Hellscream shows himself.','',26124),
(86308,'enUS','','The battle is finished! We\'ve routed the Iron Horde and pushed them back to the gates!',26124),
(86309,'enUS','The Iron Horde is never beaten! I will NEVER surrender!','',26124),
(86310,'enUS','I will remember this day, heroes. I will remember your names and your faces, and when the time comes, I will carve you limb from limb.','',26124),
(86311,'enUS','+$1i score','',26124),
(86312,'enUS','|cFFFF0000+$1i score|r','',26124),
(86313,'enUS','|cFF0000FF-1 reinforcement|r','',26124),
(86314,'enUS','|cFFFF0000-1 reinforcement|r','',26124),
(86315,'enUS','You want to fight, hmm? How tough are you?','',26124),
(86316,'enUS','Never before have the spirits spoken with such strength to me.','',26124),
(86317,'enUS','Dis one time, I killed two clefthoof at once with bare hands!','',26124),
(86318,'enUS','','Sorry for all the times you\'re about to get killed. If it\'s any consolation, you won\'t remember any of them.',26124),
(86319,'enUS','Deez Ashmaul dunt break my Boulder Shield so dey threw me in dis cage... Now dat I\'m free I dun need it no more, you have it $n.','',26124),
(86320,'enUS','Hah! You nowhere near tough enough.','',26124),
(86321,'enUS','Draenor is not without its own primal beauty.','',26124),
(86322,'enUS','The three of us all bring different talents to the table. Chromie can manipulate time to heal our wounds, and I am capable of bearing the brunt of the dragon\'s attacks. All of us are worthy fighters.$b$bBut YOU are the tactical expert. We\'ll follow your lead. In what role are you strongest? Say the word and we\'ll begin!','',26124),
(86323,'enUS','I\'ll deal out the damage.','I\'ll deal out the damage.',26124),
(86324,'enUS','I\'ll heal us.','I\'ll heal us.',26124),
(86325,'enUS','I\'ll defend us.','I\'ll defend us.',26124),
(86326,'enUS','Attacking Vines Killed: $1i (+$2i VP)','',26124),
(86327,'enUS','Mutated Defenders Killed: $1i (+$2i)','',26124),
(86328,'enUS','Don\'t yell at your students; Instead, speak very softly but firmly when disciplining them.  It forces them to listen more carefully and frankly it\'s a lot scarier than yelling.','',26124),
(86329,'enUS','Few truly understand how fragile the fabric of this world is.$b$bWhy, a poorly designed spell could bring our entire reality to a screeching halt.','',26124),
(86330,'enUS','Firebolts, ice blocks, arcane blasts, all of these are simple manifestations of arcana.$b$bThey are safe spells, proven time and again to be both stable and effective.$b$bNow, if you really want to blow up the universe, well... some things are best kept for the advanced class.','',26124),
(86331,'enUS','Before one can truly understand the artistry of weaving a spell, one must first ask themselves how many bunnies can you see?$b$bWhen you understand the meaning of this question, the foundation of the universe will become more clear.','',26124),
(86332,'enUS','If your spell fails to land, make sure the arcana you are trying to wield has enough power to manifest at its destination.','',26124),
(86333,'enUS','This week we are discussing ley lines... again. Their practicality when it comes to magical understanding cannot be understated.','',26124),
(86334,'enUS','Never underestimate the ingenuity and mischief that can be caused by a child who has mastered Invsibility.','',26124),
(86335,'enUS','LUG\'DOL! What dis little thing do to you?!','',26124),
(86336,'enUS','','Grom\'kar archers, fire at will!',26124),
(86338,'enUS','My wings were taken from me once. You will not take them again!','',26124),
(86339,'enUS','Well done, $n. Allow me to return you safely to the surface.','',26124),
(86340,'enUS','It cannot be! My wings have failed me once again...','',26124),
(86341,'enUS','Excellent, more raw materials!','',26124),
(86342,'enUS','Think you got what it takes, $n? Remember, once a battle starts you have to stay in the arena. It\'s life or death!','',26124),
(86343,'enUS','Step right up, ladies and gentle-ogres. Witness utter carnage and devastation in the one and only Ring of Blood! In this once in a lifetime battle for the coveted Blood Champion title we have $n from parts unknown versus Katsuo of the Burning Blade!','',26124),
(86344,'enUS','Let the Blood Champion title fight BEGIN!','',26124),
(86345,'enUS','Not even close, baby! What a slaughter!','',26124),
(86346,'enUS','Finish him! Oh, wait, you did. All over the arena floor, too. We need a cleanup over here!','',26124),
(86347,'enUS','Oh, for the love of... I just had this place cleaned! Can you kill a little bit neater next time?','',26124),
(86348,'enUS','What a one-sided fight! Absolutely unfair. Not even remotely close!','',26124),
(86349,'enUS','Wodin, toss me the scraper. It\'s a mess down here!','',26124),
(86350,'enUS','Right in the face! I could feel that one from here!','',26124),
(86351,'enUS','Going... going... dead! Definitely dead. Oh, the humanity!','',26124),
(86352,'enUS','That\'s one to tell the kids about, folks. I haven\'t seen carnage like that in years!','',26124),
(86353,'enUS','Azuka Bladefury emerges from the shadows!','',26124),
(86354,'enUS','We\'ll find that dragon, dead or alive!','',26124),
(86355,'enUS','','Incredible work. The archmage would be lost without you!',26124),
(86356,'enUS','Got a bit tired of Elwynn after so many years, and figured we should come on out and do our part.','',26124),
(86357,'enUS','Sure is awful quiet out here at night, makes me miss the sounds of Goldshire in the distance.','',26124),
(86358,'enUS','You ever seen one of those rylaks? Kinda wonder how one of them would taste.','',26124),
(86359,'enUS','Sure wish we didn\'t have to live in this barn, not sure I\'ll ever get the smell out of my clothes.','',26124),
(86360,'enUS','Ma does the grillin\' around here. She can cook you up a mean flank!','',26124),
(86361,'enUS','Bein\' out here with so many different types makes me wonder if those Maclures are really so bad after all.','',26124),
(86362,'enUS','Can you tell me about trapping beasts?','Can you tell me about trapping beasts?',26124),
(86363,'enUS','What\'s new with the improved iron trap?','What\'s new with the improved iron trap?',26124),
(86364,'enUS','What about the deadly iron trap?','What about the deadly iron trap?',26124),
(86365,'enUS','What can I do with meat obtained from trapping?','What can I do with meat obtained from trapping?',26124),
(86366,'enUS','Well, you just pick up one of these traps I\'ve got right beside me here. Then, head on out to and find yourself a beast. You\'re looking for talbuk and elekk, but wolves and clefthooves can do in a pinch.$B$BAll you got to do is give the beast of your choice a whallop until it ain\'t got much fight left in it, then lead it into the trap. Be careful now, that trap can snap shut on your feet, too!$B$BBring the trap back to us, and we can turn it into materials. The type of creature you trap will determine what all we can get out of it: clefthooves and elekk produce the best leathers, while talbuks and wolves have the most fur.','',26124),
(86367,'enUS','This trap\'s a sure sight more resilient than the last one. With the improved iron trap, you\'ll be able to take down boars and riverbeasts.$B$BBring us back a boar or riverbeast and ma back there will cook you up some of the tastiest grilled meat you\'ve ever had!','',26124),
(86368,'enUS','This is the biggest, iron-est trap we could create, and it\'ll allow you to take down the largest beasts this world has to offer. Out in Nagrand you\'ll find the most powerful critters around. Trapping one of them will net you tons of the best materials!','',26124),
(86369,'enUS','Take it on over to Ma back there, she\'ll grill you up a mean steak.','',26124),
(86370,'enUS','Win or die, mon! Win or die! You can\'t be fleein\'!','',26124),
(86372,'enUS','You looking for a fight, champ?','',26124),
(86373,'enUS','The entrance to the main vestibule opens!','',26124),
(86374,'enUS','The barrier behind Exarch Hataaru slides open!','',26124),
(86375,'enUS','','I was so angry when you didn\'t return. I couldn\'t understand why you had to leave.',26124),
(86376,'enUS','I know, Kugra... but, I had to support our forces.','',26124),
(86377,'enUS','The teleporter to the central platform is now active!','',26124),
(86378,'enUS','','I didn\'t understand why you had to go.',26124),
(86379,'enUS','I know, Kugra... but, I wanted to help put an end to this miserable conflict.','',26124),
(86380,'enUS','The Thunderlords spared my life, but they forced me to work... forging weapons to be used against our own.','',26124),
(86381,'enUS','','Why didn\'t you try to flee!?',26124),
(86382,'enUS','I tried, Kugra! They hunted me... tortured me....','',26124),
(86383,'enUS','Kugra, you owe me no apologies! But now, I must ask that you continue my work here.','',26124),
(86384,'enUS','The Thunderlords wanted me to forge weapons to be used against our brothers and sisters.','',26124),
(86385,'enUS','Some assistant you are. You need to learn to keep better tabs on your employees.','',26124),
(86386,'enUS','','I... I had no idea. I am so sorry that I let my anger consume me, father.',26124),
(86387,'enUS','Sorry, boss.','',26124),
(86388,'enUS','Kugra, you owe me no apologies! Please, honor me by taking up my hammer and continuing to fight!','',26124),
(86389,'enUS','See what happens? Now your assistant is all burned up and dead. How does that make you feel?','',26124),
(86390,'enUS','Not good...','',26124),
(86391,'enUS','I owe my allegiance to $n now. I will accompany $Ghim:her; on $Ghis:her; mission to confront this new Iron Horde threat.','',26124),
(86392,'enUS','','Father, I swear to make you proud!',26124),
(86393,'enUS','I\'d sure hate to be on the end of one of those Burning Blade swords. Talk about painful.','',26124),
(86394,'enUS','You already have, Kugra, you already have....','',26124),
(86395,'enUS','A $c? Oh, are you a sight for sore eyes.$b$bWe didn\'t expect to hit anything when digging through the ground like we were.','',26124),
(86396,'enUS','My poor assistant...','',26124),
(86397,'enUS','','Thank you, $n. If you are ever in need of aid, please come back and see me.',26124),
(86398,'enUS','|TInterface\\Icons\\warrior_disruptingshout.blp:20|t %s begins to cast |cFFFF0000|Hspell:169498|h[Deafening Shout]|h|r!','',26124),
(86399,'enUS','I\'m ready to fight in the Blood Championship.','I\'m ready to fight in the Blood Championship.',26124),
(86400,'enUS','','I am so sorry that I let my anger consume me father.',26124),
(86401,'enUS','Alright, alright, move along. No shame in not fightin\'. NEXT!','',26124),
(86402,'enUS','Looks like we have a no-show folks. Bring out the next fight!','',26124),
(86403,'enUS','Time\'s up, and time is money. Let\'s get movin\'!','',26124),
(86404,'enUS','Where\'s the action at? I\'m falling asleep over here! Next!','',26124),
(86405,'enUS','Clear out, clear out. We have a tight schedule, folks.','',26124),
(86406,'enUS','I can\'t blame ya pal, you\'d probably be dead by now if you\'d gone through with it.','',26124),
(86407,'enUS','What kind of mom and pop show is this? Get someone in that ring!','',26124),
(86408,'enUS','Are we fightin\' hard or hardly fightin\' in this joint? Put some feeling into it, people!','',26124),
(86409,'enUS','I\'m ready for the Trial of Faith.','I\'m ready for the Trial of Faith.',26124),
(86410,'enUS','','I want to see how you fight.',26124),
(86411,'enUS','','Coward.',26124),
(86412,'enUS','|TInterface\\Icons\\achievement_halloween_rottenegg_01.blp:20|tXeri\'tac begins unleashing Toxic Spiderlings down on you!','',26124),
(86413,'enUS','Do you have your ring with you? Good! Are you ready?$b$bHold on to your helm, $c!','',26124),
(86414,'enUS','I am ready, Archmage.','I am ready, Archmage.',26124),
(86415,'enUS','I will head to your garrison now, $n.','',26124),
(86416,'enUS','','Enough! Not bad... for a rat that escaped its cage.',26124),
(86417,'enUS','','But do you know the power of my blade? The more it kills, the stronger it grows.',26124),
(86418,'enUS','You\'ll never make it out alive!','You\'ll never make it out alive!',26124),
(86419,'enUS','%s puts a letter into the mailbox.','%s puts a letter into the mailbox.',26124),
(86420,'enUS','','The portal is lost! We must stop this beast before it can escape!',26124),
(86421,'enUS','','We\'ve got its attention!',26124),
(86422,'enUS','','Look out!',26124),
(86423,'enUS','','Quickly, draw it towards the flames!',26124),
(86424,'enUS','','It\'s reviving the little ones!',26124),
(86425,'enUS','','The vines are overtaking everything!',26124),
(86426,'enUS','','That doesn\'t look good...',26124),
(86427,'enUS','','We are lost! It\'s pushing us back!',26124),
(86428,'enUS','','Do you want to die here?! Move!',26124),
(86429,'enUS','','You\'ve saved us all! Thank you strangers, the city would have been lost without you.',26124),
(86430,'enUS','','I never thought we\'d be saved by the Horde. You should go before the Stormwind guard arrive...',26124),
(86431,'enUS','You will never escape...','',26124),
(86432,'enUS','You befoul this place!','',26124),
(86433,'enUS','You will be purged!','',26124),
(86434,'enUS','The forest shields us.','',26124),
(86435,'enUS','We protect.','',26124),
(86436,'enUS','The cycle continues...','',26124),
(86437,'enUS','Life ends.','',26124),
(86438,'enUS','I will... be... renewed...','',26124),
(86439,'enUS','You are not welcome here!','',26124),
(86440,'enUS','The forest closes in around you.','',26124),
(86441,'enUS','Water brings life!','',26124),
(86442,'enUS','Grow!','',26124),
(86443,'enUS','Life renewed!','',26124),
(86444,'enUS','You were warned!','',26124),
(86445,'enUS','Trespassers beware!','',26124),
(86446,'enUS','I return... to the soil...','',26124),
(86447,'enUS','Delivery of animal skins!','Delivery of animal skins!',26124),
(86448,'enUS','Wait... is that Thaelin\'s tank? The lad made it!','',26124),
(86449,'enUS','Fly me to Talon Watch.','Fly me to Talon Watch.',26124),
(86450,'enUS','They grow like weeds.','They grow like weeds.',26124),
(86451,'enUS','Reaping crop is peon\'s work.','Reaping crop is peon\'s work.',26124),
(86452,'enUS','Capture and control the bonfires!','',26124),
(86453,'enUS','The Alliance controls this fire but another has appeared!','',26124),
(86454,'enUS','The Horde controls this fire but another has appeared!','',26124),
(86455,'enUS','The Alliance wins!','',26124),
(86456,'enUS','The Horde wins!','',26124),
(86457,'enUS','Slay the invaders and bring me their bodies. We have much work to do.','',26124),
(86458,'enUS','Faster. I do not wish to keep the great Iyu waiting.','',26124),
(86459,'enUS','Alive or dead, bring these invaders to me.','',26124),
(86460,'enUS','Uproot this infestation of a camp.','',26124),
(86461,'enUS','More fodder for our soil!','',26124),
(86462,'enUS','I have known weeds that were more threatening than your kind.','',26124),
(86463,'enUS','Your kind will not defy the will of Iyu.','',26124),
(86464,'enUS','Over here!','',26124),
(86465,'enUS','I will bring glory to your name, warlord!','',26124),
(86466,'enUS','DEFILER! Your lifeblood will nourish the Everbloom!','',26124),
(86467,'enUS','','ALONE!',26124),
(86468,'enUS','No brawlin\' ahead unless in da ring. Mogor\'s orders.','',26124),
(86469,'enUS','Da ring is just ahead. Don\'t cause no trouble.','',26124),
(86470,'enUS','Mogor says no brawlin\' ahead unless you in da ring.','',26124),
(86471,'enUS','Ready for fightin\', tiny one? Da ring is just ahead.','',26124),
(86472,'enUS','Follow da rules. Only brawl in da ring. Uh... and don\'t brawl not in da ring.','',26124),
(86473,'enUS','Talk to tiny green thing by Mogor if you want to fight.','',26124),
(86474,'enUS','Me crush you if you fight outside da ring. Mogor said so.','',26124),
(86475,'enUS','RAAAAAAAAAAAAAR! Me... uphold order!','',26124),
(86476,'enUS','','Yes, sugar?',26124),
(86477,'enUS','','%s marks the location of the most recent coordinates on her parchment.',26124),
(86478,'enUS','','%s inspects the translocator\'s findings.',26124),
(86479,'enUS','','%s ponders the location of the next transponder unit.',26124),
(86480,'enUS','Cherish this victory, invader. The next time we meet you will suffer!','',26124),
(86481,'enUS','I have found you once more, defiler! The wilds will grant you no reprieve!','',26124),
(86482,'enUS','Sunderthorn descends from the treetops to protect her hive!','',26124),
(86483,'enUS','Your... Your species is superior. I am yours to command.','',26124),
(86484,'enUS','Twice you have bested me. You will not win again!','',26124),
(86485,'enUS','I will journey to your fortress, $g master:mistress;. Once there, all that I know, you will know.','',26124),
(86486,'enUS','Anything good?','Anything good?',26124),
(86487,'enUS','I\'ll find the right person for the job.','I\'ll find the right person for the job.',26124),
(86488,'enUS','I\'m looking to recruit someone.','I\'m looking to recruit someone.',26124),
(86489,'enUS','|cFF0000FF+$1i slain|r','',26124),
(86490,'enUS','|cFFFF0000+$1i slain|r','',26124),
(86491,'enUS','|cFF0000FF+1 points|r','',26124),
(86492,'enUS','|cFFFF0000+1 points|r','',26124),
(86493,'enUS','|cFF0000FF+$1i points|r','',26124),
(86494,'enUS','|cFFFF0000+$1i points|r','',26124),
(86495,'enUS','Greetings, and thank you for helping to test the Warlords of Draenor Beta! \n\nI can teleport you directly into a number of raid or dungeon instances that are currently open for testing. This is just a teleport, not a match-making service, so I hope you have a party ready to tackle the challenges waiting inside. If not, you might want to check out our new Group Finder feature to find some allies.\n\nMake sure you have selected the difficulty you want to test before teleporting, since you may not be able to zone out easily if you need to change the difficulty setting!','',26124),
(86496,'enUS','I want to go to Bloodmaul Slag Mines.','I want to go to Bloodmaul Slag Mines.',26124),
(86497,'enUS','I want to go to Iron Docks.','I want to go to Iron Docks.',26124),
(86498,'enUS','I want to go to Auchindoun.','I want to go to Auchindoun.',26124),
(86499,'enUS','I want to go to Skyreach.','I want to go to Skyreach.',26124),
(86500,'enUS','I want to go to Grimrail Depot.','I want to go to Grimrail Depot.',26124),
(86501,'enUS','I want to go to Overgrown Outpost.','I want to go to Overgrown Outpost.',26124),
(86502,'enUS','I want to go to Shadowmoon Burial Grounds.','I want to go to Shadowmoon Burial Grounds.',26124),
(86503,'enUS','I want to go to Upper Blackrock Spire.','I want to go to Upper Blackrock Spire.',26124),
(86504,'enUS','I want to go to Highmaul (Raid).','I want to go to Highmaul (Raid).',26124),
(86505,'enUS','I want to go to Blackrock Foundry (Raid).','I want to go to Blackrock Foundry (Raid).',26124),
(86506,'enUS','So eager to die?','',26124),
(86507,'enUS','We are ready, Gharg!','We are ready, Gharg!',26124),
(86508,'enUS','A leader\'s work is never finished. Onward we press, fighting for justice and protecting our people.','',26124),
(86509,'enUS','I am ready to fight the Exarch Council.','I am ready to fight the Exarch Council.',26124),
(86510,'enUS','Shinri flees at the sight of you!','',26124),
(86511,'enUS','Ready for more, $n?','',26124),
(86512,'enUS','Send me to the arena, Gharg.','Send me to the arena, Gharg.',26124),
(86513,'enUS','No! Stop! I can\'t control him!','',26124),
(86514,'enUS','','You\'re far from home, $r. For the right coin, I\'ll offer you a flight instead of an axe, but don\'t tarry.',26124),
(86515,'enUS','','I\'m sorry to disappoint you, but If you\'ve come to join up with the Nesingwary Safari then you\'re out of luck.$b$bThe safari has been put on hold while Hemet assists the Alliance and Horde in their fight against the Warsong.$b$bA shame really, this land is one of the most majestic and savage that I have ever laid eyes on.',26124),
(86516,'enUS','I have yet to fully unravel the mysteries of the Zangar fungi, but I am making great progress.$b$bIf my theories are correct, an understanding of the fungal strains in relation to the local ecology will teach us a great deal about the various species on Draenor!','',26124),
(86517,'enUS','A pleasure to meet you! My name is Dr. Hadley Ricard, and as you can see I seem to be in a pickle of sorts...$b$bI\'ve been taken captive by these podlings, and if my assessment of their intentions is correct... they mean to kill me and use my remains as fertilizer for their offspring!','',26124),
(86518,'enUS','Marybelle Walsh sent me to rescue you. Go and I\'ll protect you!','Marybelle Walsh sent me to rescue you. Go and I\'ll protect you!',26124),
(86519,'enUS','My research station is near the shore, not far from here. I\'ll wait for you there!','',26124),
(86520,'enUS','Used glass vials.','Used glass vials.',26124),
(86521,'enUS','Have a box of foraged herbs.','Have a box of foraged herbs.',26124),
(86522,'enUS','I found all these potions while I was out on adventure.','I found all these potions while I was out on adventure.',26124),
(86523,'enUS','Dropping off the things you asked for.','Dropping off the things you asked for.',26124),
(86524,'enUS','Hope you get some use out of this.','Hope you get some use out of this.',26124),
(86525,'enUS','Here you go.','Here you go.',26124),
(86526,'enUS','Anything new?','Anything new?',26124),
(86527,'enUS','Any new inventory?','Any new inventory?',26124),
(86528,'enUS','I need to pick up a few things.','I need to pick up a few things.',26124),
(86529,'enUS','What do you have in stock?','What do you have in stock?',26124),
(86530,'enUS','Did you get the items I was looking for?','Did you get the items I was looking for?',26124),
(86531,'enUS','What\'s for sale?','What\'s for sale?',26124),
(86532,'enUS','Just browsing.','Just browsing.',26124),
(86533,'enUS','Anything on sale?','Anything on sale?',26124),
(86534,'enUS','','You expect to defend us with those skills?',26124),
(86535,'enUS','','Keep your guard up when you strike!',26124),
(86536,'enUS','','Lean into your attack more!',26124),
(86537,'enUS','','That thrust was pitiful!',26124),
(86538,'enUS','','Hmph... that attack was satisfactory. More like that!',26124),
(86539,'enUS','Give me a list of what you need and I\'ll get on it.','Give me a list of what you need and I\'ll get on it.',26124),
(86540,'enUS','Short on anything?','Short on anything?',26124),
(86541,'enUS','I\'ll have your order done soon.','I\'ll have your order done soon.',26124),
(86542,'enUS','We\'re a little backed up today.','We\'re a little backed up today.',26124),
(86543,'enUS','War!','',26124),
(86544,'enUS','For glory!','',26124),
(86545,'enUS','To battle!','',26124),
(86546,'enUS','Death to all!','',26124),
(86547,'enUS','Spill their blood!','',26124),
(86548,'enUS','Victory will be ours!','',26124),
(86549,'enUS','It\'s... only... a flesh wound!','',26124),
(86550,'enUS','You win... this time...','',26124),
(86551,'enUS','Spiteleaves... avenge me!','',26124),
(86552,'enUS','I cannot... die...','',26124),
(86553,'enUS','Our seeds... will blot out the sun!','',26124),
(86554,'enUS','Victory is ours!','',26124),
(86555,'enUS','Death to fungi!','',26124),
(86556,'enUS','Victory!','',26124),
(86557,'enUS','Onward to battle!','',26124),
(86558,'enUS','Once the research and supplies are returned, Pickles and I will be able to continue our experiments!','',26124),
(86559,'enUS','I\'ve heard that Dirgemire makes its lair in an underwater cavern... how magnificently primitive!','',26124),
(86560,'enUS','In order to properly dissect such a delicate organ, one must have a steady hand and precise...','',26124),
(86561,'enUS','Pickles... NO!!','',26124),
(86562,'enUS','Quickly, Pickles! Describe to me in exacting detail what you feel at this very moment!','',26124),
(86563,'enUS','Wait, Pickles! We must document the experiment!','',26124),
(86564,'enUS','It appears that I require a new research assistant...','',26124),
(86565,'enUS','Ribbit.','',26124),
(86567,'enUS','A townsfolk has been mutated!','A townsfolk has been mutated!',26124),
(86568,'enUS','Thank you for helping my people through this dark time. We hope to return the favor someday.','',26124),
(86569,'enUS','All the components for the spell are in place. I am ready when you are, $n.','',26124),
(86570,'enUS','When your armor sad from fightin\' in da ring, Glub make not sad.','',26124),
(86571,'enUS','Meat for the meat god!','',26124),
(86572,'enUS','Work complete!','',26124),
(86573,'enUS','Off I go then!','',26124),
(86574,'enUS','Hey there, you headed out to the shallows?','',26124),
(86575,'enUS','I\'ve been at it for hours. My satchel is almost ready for delivery.','I\'ve been at it for hours. My satchel is almost ready for delivery.',26124),
(86576,'enUS','Take a look at what I\'ve collected so far.','Take a look at what I\'ve collected so far.',26124),
(86577,'enUS','Collecting the talons sure isn\'t easy.','Collecting the talons sure isn\'t easy.',26124),
(86578,'enUS','There\'s some stiff competition this year!','There\'s some stiff competition this year!',26124),
(86579,'enUS','Have you seen Garaal\'s work? It\'s quite amazing!','Have you seen Garaal\'s work? It\'s quite amazing!',26124),
(86580,'enUS','Hey you, with da face. Fresh grub over here!','',26124),
(86585,'enUS','','See ya there, commander!',26124),
(86586,'enUS','Thanks, pal! You\'re a life saver!','',26124),
(86587,'enUS','More! More more more!','',26124),
(86588,'enUS','Fire all the cannons!','',26124),
(86589,'enUS','Blow them to bits!','',26124),
(86590,'enUS','Boom!','',26124),
(86591,'enUS','Help! Help!...','',26124),
(86592,'enUS','After many years in Durotar, it feels good to return home.','',26124),
(86593,'enUS','I am not used to the scent of air so crisp. It is much less boar-flavored.','',26124),
(86594,'enUS','This is not the Draenor I remember, but I was young, and Nagrand was my home.','',26124),
(86595,'enUS','We have come to aid the horde in any way that we can.','',26124),
(86596,'enUS','Our fortifications here are mighty, but the landscape is savage.','',26124),
(86597,'enUS','I have obtained a new pitchfork for this adventure.','',26124),
(86598,'enUS','So, you wish to test your strength against the beasts of Draenor? I spent many days, in my youth, doing the same. Take one of the iron traps from the stack behind me, and find a wolf, clefthoof, talbuk, or elekk to pit yourself against.$B$BFirst, you must wound the creature greatly. Then, lead it into the trap, which will snap shut, capturing the creature.$B$BBring the trapped creature back to us, and we will turn it into materials. The creature you choose to hunt will determine what we will gain: the talbuk and wolves have the thickest furs, while the clefthoof and elekks have sturdy hides of leather.','',26124),
(86599,'enUS','We have managed to create a trap that closes more tightly than the last. With this improved iron trap, you will be able to bring down the mighty boar and riverbeast.$B$BBoar and riverbeast meat are thick and tasty. We can make them into the perfect meal.','',26124),
(86600,'enUS','Our elders once spoke of the most ancient and powerful beasts on the western plains of Nagrand. We now have a trap with jaws that can rival any war wolf. Should you manage to bring down one of these beasts, the furs, meats, and leathers will last us for some time.','',26124),
(86601,'enUS','','It\'s about time you got that fixed, Thuldren!',26124),
(86602,'enUS','An excellent catch, commander, I will have it taken back to the stronghold.','',26124),
(86603,'enUS','A mighty beast, well done! We will bring it back right away.','',26124),
(86604,'enUS','Quite a fine creature, it will surely produce many materials for us.','',26124),
(86605,'enUS','The smell of this one reminds me of the boar farms in Durotar.','',26124),
(86606,'enUS','The hide of this beast is like iron! I will sharpen my blades.','',26124),
(86607,'enUS','Ah, the air of Nagrand smells as I remember. Fresh, with a hint of blood!','',26124),
(86608,'enUS','I smelled blood in the air, and was not disappointed!','',26124),
(86609,'enUS','A mighty kill, you should be quite proud!','',26124),
(86610,'enUS','Look for traces of fel energy and follow them! I saw her running west.','',26124),
(86611,'enUS','I saw something rush past. I think she scrambled down the cliff here...','',26124),
(86612,'enUS','We\'re in this together, $p. Side by side.','',26124),
(86613,'enUS','I\'ll be at your garrison if you need me. Be careful out there.','',26124),
(86614,'enUS','Thank you again, friend. I\'ll see you soon.','',26124),
(86615,'enUS','You are a parasite! A blood-sucking insect that looks to feed on my world! We will not allow it!','',26124),
(86616,'enUS','Ten thousand years as Interfactional Champion, Oooooh yeeeah!','',26124),
(86617,'enUS','Rulkamania is like a single grain of sand in the Silithus desert that is Honcho Madness.','',26124),
(86618,'enUS','History beckons the Honcho Man!','',26124),
(86619,'enUS','I\'m the Honcho Man Randy Ravage and I\'m the Azerothian Brawler\'s Guild Champion and YOU\'RE NOT!','',26124),
(86620,'enUS','We\'re in Draenor and Draenor is the domicile!','',26124),
(86621,'enUS','Oooooh yeeeah!','',26124),
(86622,'enUS','Put yer back into it. There ya go!','',26124),
(86623,'enUS','I must be going now.','I must be going now.',26124),
(86624,'enUS','The trap worked! Kill it!','',26124),
(86625,'enUS','','Curse these plant vermin.',26124),
(86626,'enUS','','Mow them down.',26124),
(86627,'enUS','','Don\'t let the little ones past you!',26124),
(86628,'enUS','Let\'s get outta here!','',26124),
(86629,'enUS','','They just keep coming!',26124),
(86630,'enUS','','Pitiful plants.',26124),
(86631,'enUS','Only gladiators is welcome here! If you ain\'t here to fight, then you ain\'t allowed to stay!','',26124),
(86632,'enUS','You too puny to be a gladiator! This some kind of joke? Get lost!','',26124),
(86633,'enUS','We only allow gladiators here... if I find out you ain\'t here to fight, I\'ll kill you myself!','',26124),
(86634,'enUS','Puny $r! Just looking at you makes me angry!','',26124),
(86635,'enUS','Knowledge is half the battle.','',26124),
(86636,'enUS','Keep your wits about you, commander.','',26124),
(86637,'enUS','The battle is heating up. We must push forward!','',26124),
(86638,'enUS','This is our chance to send the Iron Horde scattering. Steel yourself. We must hold the front line!','',26124),
(86639,'enUS','Reporting for battle!','Reporting for battle!',26124),
(86640,'enUS','See ya at Tangleheart.','',26124),
(86641,'enUS','I\'ll be pulling thorns out of my armor for weeks...','',26124),
(86642,'enUS','This is it, warriors. Time for axe work!','',26124),
(86643,'enUS','','Hey there, Commander! I found us a tactical copse.$b$bI just need to build us a front door so we don\'t have to find janky ways around it whenever we go in or out.$b$bWanna do the honors? Hit the plunger and enjoy the fireworks.',26124),
(86644,'enUS','$n nails a note on the board.','$n nails a note on the board.',26124),
(86645,'enUS','Attacking Vines Killed: $1i (+$2i VP)','Attacking Vines Killed: $1i (+$2i VP)',26124),
(86646,'enUS','Take all of my Artifact Fragments!','Take all of my Artifact Fragments!',26124),
(86647,'enUS','Oh man, that crash was so rough that my insides are still churning.','',26124),
(86648,'enUS','I thought I was never going to get back up from that crash. I really can\'t thank you enough!','',26124),
(86649,'enUS','I owe you a drink!','',26124),
(86650,'enUS','I owe you my life! Thanks for the help!','',26124),
(86651,'enUS','','<The assassin can no longer put up a fight. Her arms hang limply at her sides.>$b$bFinish it, $c.$b$b<A quick search of her belongings reveals the antidote to the poison she used on you. You hurriedly prepare the incarceration rune to capture her and send her up to Khadgar\'s Tower above.>',26124),
(86652,'enUS','<Use the Incarceration Rune.>','<Use the Incarceration Rune.>',26124),
(86653,'enUS','Thank you, $r. I thought I would be trapped forever.','Thank you, $r. I thought I would be trapped forever.',26124),
(86654,'enUS','Miss Kimzee, before we crashed we saw one survivor. I think it might be your uncle.','',26124),
(86655,'enUS','Good luck!','Good luck!',26124),
(86656,'enUS','','Uncle Krixel!? Get outta the way, I got to rescue him!',26124),
(86657,'enUS','Dad! Dad! We brought your tools!','',26124),
(86658,'enUS','I will show these Alliance mongrels what a real warrior can do!','',26124),
(86659,'enUS','Did my father send you?','',26124),
(86660,'enUS','Aaargh, I\'ll stick to tavern games from now on.','',26124),
(86661,'enUS','Ahahaha, major choppable!','',26124),
(86662,'enUS','Yes, come with me.','Yes, come with me.',26124),
(86663,'enUS','B... Ba... Bad idea...','',26124),
(86664,'enUS','$GSir:Madam;, an attack on our garrison looms close. I have commissioned some items that you may find useful.','',26124),
(86665,'enUS','Guys, I have some really bad news...I\'ve been defeated.','',26124),
(86666,'enUS','I thought I knew cold, but that was beyond anything an orc should endure.','',26124),
(86667,'enUS','Time to unleash my macro power on the Horde!','',26124),
(86668,'enUS','One shot!!!','',26124),
(86669,'enUS','Whoooo. Darrrrrres. Awakkkkken. ME!','',26124),
(86670,'enUS','Get stomped on!','',26124),
(86671,'enUS','Hit\'em with the flex!','',26124),
(86672,'enUS','Sergeant, a gronn is marching toward our garrison. It\'ll be here in minutes!','Sergeant, a gronn is marching toward our garrison. It\'ll be here in minutes!',26124),
(86673,'enUS','Good luck $r, I am going to find a nice warm fire!','',26124),
(86674,'enUS','Failure is not an option, I will return, after training.','',26124),
(86675,'enUS','Fury Bajheera has been unleashed!','',26124),
(86676,'enUS','','I\'m free! I will never waste time again.',26124),
(86677,'enUS','Sergeant, Thunderlord Orcs are at the walls!','Sergeant, Thunderlord Orcs are at the walls!',26124),
(86678,'enUS','','Good luck, $r. Don\'t waste time, ever!',26124),
(86679,'enUS','My stature is only surpassed by my power!','',26124),
(86680,'enUS','Send my regards to Armsmaster Holinka little one!','',26124),
(86681,'enUS','Sergeant! Smoke on the horizon, and war drums in the distance!','Sergeant! Smoke on the horizon, and war drums in the distance!',26124),
(86682,'enUS','Sergeant, strange plants are growing inside the garrison.','Sergeant, strange plants are growing inside the garrison.',26124),
(86683,'enUS','Perhaps I\'ll stick to commentating the action from afar.','',26124),
(86684,'enUS','What?! Did you see my health!','',26124),
(86685,'enUS','The Horde is no match for the power of sun and moon.','',26124),
(86686,'enUS','Goodness.','',26124),
(86687,'enUS','It is most certainly kill time.','',26124),
(86688,'enUS','These ferns don\'t look friendly...','These ferns don\'t look friendly...',26124),
(86689,'enUS','','Now where am I supposed to work on my trophies?!',26124),
(86690,'enUS','The power of the elements flows through me.','',26124),
(86691,'enUS','This is but a setback, I will return.','',26124),
(86692,'enUS','Free win!','',26124),
(86693,'enUS','Small, sneaky and ready to fight!','',26124),
(86694,'enUS','For Gnomeregan...','',26124),
(86695,'enUS','','Let the hunt begin!',26124),
(86696,'enUS','','The hunt is over...for now.',26124),
(86697,'enUS','If Pazerp doesn\'t return soon I\'m going to have to send a scout to find my scout. That will be awkward for everybody involved.','',26124),
(86698,'enUS','The shadow looms larger than ever before','',26124),
(86699,'enUS','This is not the end.','',26124),
(86700,'enUS','We have lost too many lives already. This battle is getting out of hand.','',26124),
(86701,'enUS','','Tell Isaac, I tried.',26124),
(86702,'enUS','','What you\'ve been looking for has been here the whole time!',26124),
(86703,'enUS','','We will stand together!',26124),
(86704,'enUS','','We cannot win if we do not show courage.',26124),
(86705,'enUS','Nooooo!','',26124),
(86706,'enUS','I will not stay silenced for long.','',26124),
(86707,'enUS','Your quality has been assured.','',26124),
(86708,'enUS','Ah, c\'mon! You was workin\' just a minute ago!','',26124),
(86709,'enUS','I will test your strength and your skill.','',26124),
(86710,'enUS','Your will to fight will bleed away before my eyes.','',26124),
(86711,'enUS','Lousy hunk of... ooof! Pinched myself that time!','',26124),
(86712,'enUS','This thing has some serious upkeep!','',26124),
(86713,'enUS','I hope you\'ve recovered from any wounds that Garona inflicted on you.$b$bAs soon as you are ready, we will combine our efforts to upgrade your ring.','',26124),
(86714,'enUS','Hacked to pieces','',26124),
(86715,'enUS','If you dare challenge me, I will be waiting in Tanaan Jungle. You will find only death beyond these gates.','',26124),
(86716,'enUS','Fear not Alliance, for fear is now your ally.','',26124),
(86717,'enUS','Defeated but not destroyed.','',26124),
(86718,'enUS','I will cut them down one by one!','',26124),
(86719,'enUS','I never asked for this.','',26124),
(86720,'enUS','','Disease, death and defeat come for you Horde scum!',26124),
(86721,'enUS','','This is not the end.',26124),
(86722,'enUS','$g Sir:Ma\'am;, I know I\'m not the sharpest saw in the shed, but this doesn\'t seem like the best idea you\'ve ever had. Are you sure about this?','',26124),
(86723,'enUS','Ok then! Silence means yes.','',26124),
(86724,'enUS','No! You cannot stop me!','',26124),
(86725,'enUS','','They will... overrun... you...',26124),
(86726,'enUS','Don\'t you worry! The effects will fade soon!','',26124),
(86727,'enUS','Just relax... take it easy for a few.','',26124),
(86728,'enUS','I can\'t believe we made it!','',26124),
(86729,'enUS','<The music box crackles and sparks.>','',26124),
(86730,'enUS','','I\'m surprised you hit the mark. The last one wasn\'t so fortunate!',26124),
(86731,'enUS','','Fully intact, eh? That\'s new.',26124),
(86732,'enUS','','Wow! Where did you come from? This thing isn\'t even hooked up yet!',26124),
(86733,'enUS','','My, my, my... another delivery from Goggles\'. What\'s next? Flyin\' Alarm-o-Bots?',26124),
(86734,'enUS','Play \"Legends of Azeroth\"','Play \"Legends of Azeroth\"',26124),
(86735,'enUS','Play \"The Burning Legion\"','Play \"The Burning Legion\"',26124),
(86736,'enUS','Play \"Wrath of the Lich King\"','Play \"Wrath of the Lich King\"',26124),
(86737,'enUS','Play \"The Shattering\"','Play \"The Shattering\"',26124),
(86738,'enUS','Play \"Heart of Pandaria\"','Play \"Heart of Pandaria\"',26124),
(86739,'enUS','Play \"A Siege of Worlds\"','Play \"A Siege of Worlds\"',26124),
(86740,'enUS','Play \"Stormwind\"','Play \"Stormwind\"',26124),
(86741,'enUS','Play \"High Seas\"','Play \"High Seas\"',26124),
(86742,'enUS','Boss, me not what dey call smart, but dis tree not right. Maybe we no chop dis one?','',26124),
(86743,'enUS','Doh! Me sorry for being stupid! STUPID ME! STUPID! STUPID! Choppy dis tree now, boss!','',26124),
(86744,'enUS','Where is the rest of the army?','Where is the rest of the army?',26124),
(86745,'enUS','If ya see Pazaztick, tell\'em Rokhan be lookin\' for him.','',26124),
(86746,'enUS','Da Iron Horde is bad news. We need ta put a stop ta dis.','',26124),
(86747,'enUS','','Follow me, hero!',26124),
(86748,'enUS','','Give up, Grommash! Look around you. You are beaten!',26124),
(86749,'enUS','','Very well, Grommash... then we will come for you.',26124),
(86750,'enUS','','Congratulations, hero. This victory is ours.',26124),
(86751,'enUS','The void beckons for your soul!','',26124),
(86752,'enUS','NOOOOO!!','',26124),
(86753,'enUS','%s goes berserk and begins to attack friend and foe alike!','',26124),
(86754,'enUS','','Goren teeth make an excellent tool for cutting through the thickest armor.',26124),
(86755,'enUS','','Hello, commander. It has been a pleasure seeing you in action.',26124),
(86756,'enUS','I was almost back to base with a sack of those artifact fragments when some Horde stole them from me. Watch your back at all times, $n.','',26124),
(86757,'enUS','Search him for the gavel.','Search him for the gavel.',26124),
(86758,'enUS','How\'d you get up here? Harrison Jones didn\'t mention this adventure would be so... dangerous.','',26124),
(86759,'enUS','','It is good that nobody touched my... work... here. I chose this place to avoid those who would intrude on my... collection...',26124),
(86760,'enUS','You riding or biting today?','',26124),
(86761,'enUS','I got dis $p!','',26124),
(86762,'enUS','By the elements... what has Cho\'gall done?','',26124),
(86763,'enUS','Hold fast, $n! The naaru is transforming into a void god... we have no choice but to stand and fight!','',26124),
(86764,'enUS','','Auchindoun is safe... for now. Fan out and find Teron\'gor and Gul\'dan.',26124),
(86765,'enUS','The great furies must be informed of what has transpired here. Quickly, follow me!','',26124),
(86766,'enUS','I sense a cool draft on my skin and the smell of earth and leaves... there must be an opening to the outside!','',26124),
(86767,'enUS','The naaru... this cannot be!','',26124),
(86768,'enUS','K\'ure is transforming into a void god... and we are all that stands between it and the destruction of this land!','',26124),
(86769,'enUS','My heart aches over the loss of K\'ure... but there is little time to mourn. We must find a way out of this place. Follow me!','',26124),
(86770,'enUS','','Good, let\'s get in there!',26124),
(86771,'enUS','%s calls for help from its mother.','',26124),
(86772,'enUS','Just as I thought! There is an opening not far ahead!','',26124),
(86773,'enUS','%s chirps excitedly and flutters away.','',26124),
(86774,'enUS','Dis battle is jus\' gettin\' started. Let no Iron Horde survive!','',26124),
(86775,'enUS','Commander, our rylak riders have weakened da magnaron, but we\'re pinned outside. We need ya help ta break inta da main compound.','',26124),
(86776,'enUS','Greetings, Commander! You will find today\'s glorious invention waiting for you on the workbench.','Greetings, Commander! You will find today\'s glorious invention waiting for you on the workbench.',26124),
(86777,'enUS','Tell me about how inventions work.','Tell me about how inventions work.',26124),
(86778,'enUS','Just a moment, $n, please allow me to prepare the materials.','',26124),
(86779,'enUS','It is done!','',26124),
(86780,'enUS','Your bones will be ground into fertile soil!','',26124),
(86781,'enUS','The might of the forest will destroy you!','',26124),
(86782,'enUS','Eternal darkness awaits!','',26124),
(86783,'enUS','I am the protector of these forests. Time to die!','',26124),
(86784,'enUS','','Hands where I can see \'em, big \'n\' tall.',26124),
(86785,'enUS','Fell off yer glider right into me lap!','',26124),
(86786,'enUS','','The battle is finished. We\'ve pushed the Iron Horde army back to the gates.',26124),
(86788,'enUS','Lay down your weapons, Grommash! Look around you. You are lost.','',26124),
(86789,'enUS','Wait then, Grommash. Wait, because we are coming for you.','',26124),
(86790,'enUS','Thank you, hero.  Today, we taste victory! Lok\'tar ogar!','',26124),
(86791,'enUS','I am with you, $p! We shall face this evil together!','',26124),
(86792,'enUS','With me, $p! We fight as wolves!','',26124),
(86793,'enUS','What new inventions will be available now that we\'ve upgraded?','What new inventions will be available now that we\'ve upgraded?',26124),
(86794,'enUS','Tell me about making vehicles.','Tell me about making vehicles.',26124),
(86795,'enUS','This workshop is great! Each day we\'ll have a different invention available for you to try out. Right now we have the plans and machinery to make four inventions.$B$BThe Sticky Grenade is a grenade that... sticks to things. After a bit, it will explode for terrible damage!$B$BThe Pneumatic Power Glove can pull foes towards you or push them away, using the power of steam and magnets. It will automatically detect which feature to use, depending on your combat abilities.$B$BThe Robo-Rooster is based on the OOX technology we thoroughly tested in Azeroth, this robot fowl can also go berserk, furiously decimating foes!$B$BFinally, we\'ve packaged up a glider and rocket into the \"Skyterror\" P.D.S. The best in highly-explosive one-way travel!','This workshop is great! Each day we\'ll have a different invention available for you to try out. Right now we have the plans and machinery to make four inventions.$B$BThe Sticky Grenade is a grenade that... sticks to things. After a bit, it will explode for terrible damage!$B$BThe Pneumatic Power Glove can pull foes towards you or push them away, using the power of steam and magnets. It will automatically detect which feature to use, depending on your combat abilities.$B$BThe Robo-Rooster is based on the OOX technology we thoroughly tested in Azeroth, this robot fowl can also go berserk, furiously decimating foes!$B$BFinally, we\'ve packaged up a glider and rocket into the \"Skyterror\" P.D.S. The best in highly-explosive one-way travel!',26124),
(86796,'enUS','I\'m glad that you asked! Our manufacture of the rare 7-sided wingnut have unlocked our most brilliant inventions yet!$B$BThe Prototype Chopper is the most rapid ground-faring vehicle we\'ve ever created, and comes with an explosive ejector seat.$B$BYou want to go faster? Try  the XD-57 \"Bullseye\" Guided Rocket Kit! It can\'t stop, or slow down, and explodes when it hits things!$B$BThe Sentry Turret Dispenser will rapidly build a turret capable of shredding your foes into a fine, fragrant mist.$B$BThe GG-117 Micro-Jetpack will allow you to rapidly leap from location to location, creating a explosion when you land.$B$BFinally, the N.U.K.U.L.A.R. Target Painter: select a location, and we\'ll launch a huge rocket capable of massive destruction!','I\'m glad that you asked! Our manufacture of the rare 7-sided wingnut have unlocked our most brilliant inventions yet!$B$BThe Prototype Chopper is the most rapid ground-faring vehicle we\'ve ever created, and comes with an explosive ejector seat.$B$BYou want to go faster? Try  the XD-57 \"Bullseye\" Guided Rocket Kit! It can\'t stop, or slow down, and explodes when it hits things!$B$BThe Sentry Turret Dispenser will rapidly build a turret capable of shredding your foes into a fine, fragrant mist.$B$BThe GG-117 Micro-Jetpack will allow you to rapidly leap from location to location, creating a explosion when you land.$B$BFinally, the N.U.K.U.L.A.R. Target Painter: select a location, and we\'ll launch a huge rocket capable of massive destruction!',26124),
(86797,'enUS','We\'ve completed the vehicle bays, which will allow us to make siege weaponry right here in the shop!$B$BAll we need are some resources, and in about a day\'s time we\'ll be able to deliver a high-powered weapon of destruction.$B$BThe siege weapon will be limited by its fuel consumption, so be sure to watch that gauge!','We\'ve completed the vehicle bays, which will allow us to make siege weaponry right here in the shop!$B$BAll we need are some resources, and in about a day\'s time we\'ll be able to deliver a high-powered weapon of destruction.$B$BThe siege weapon will be limited by its fuel consumption, so be sure to watch that gauge!',26124),
(86798,'enUS','I would like the dwarves to protect the garrison.','I would like the dwarves to protect the garrison.',26124),
(86799,'enUS','The might of Ironforge is at your call, commander.','',26124),
(86800,'enUS','','The gnomish infantry stands at the ready, commander!',26124),
(86801,'enUS','Only say the word, commander, and the draenei will help to keep the peace.','',26124),
(86802,'enUS','The others think they can help. That\'s laughable. Only the might and the ferocity of the worgen can match these lands and protect your garrison. Don\'t you agree?','',26124),
(86803,'enUS','We are at your service, commander.','',26124),
(86804,'enUS','I would like the gnomes to protect the garrison.','I would like the gnomes to protect the garrison.',26124),
(86805,'enUS','I would like the draenei to protect the garrison.','I would like the draenei to protect the garrison.',26124),
(86806,'enUS','I do. I would like the worgen to protect the garrison.','I do. I would like the worgen to protect the garrison.',26124),
(86807,'enUS','I would like the pandaren to protect the garrison.','I would like the pandaren to protect the garrison.',26124),
(86808,'enUS','The city is safe now.','The city is safe now.',26124),
(86809,'enUS','The people of Karabor will overcome the losses. The fate of our people will not succumb to the acts of savages.','The people of Karabor will overcome the losses. The fate of our people will not succumb to the acts of savages.',26124),
(86810,'enUS','We must carry our strengths not just for ourselves, but for our people!','We must carry our strengths not just for ourselves, but for our people!',26124),
(86811,'enUS','','No... You can\'t... It\'s... I can\'t FIGHT IT!',26124),
(86812,'enUS','','Flee! The vines! They control us all!',26124),
(86813,'enUS','','Yes, fire! Fire will burn away the contagion.',26124),
(86814,'enUS','','Surely the cold will make them wither?',26124),
(86815,'enUS','','Get away! GET AWAY!',26124),
(86816,'enUS','','No! They will take you too!',26124),
(86817,'enUS','','You mustn\'t give them another host!',26124),
(86818,'enUS','','Burn my body, it\'s the only way to stop them.',26124),
(86819,'enUS','Outsider! I\'ll have your head!','',26124),
(86820,'enUS','Leave me alone. Only one who is familiar with the art of enchanting will understand my dilemma.','',26124),
(86821,'enUS','What do you want, weakling?','',26124),
(86822,'enUS','I will wait for you at the Throne of Elements. Be safe.','',26124),
(86823,'enUS','The opening is just ahead!','',26124),
(86824,'enUS','What are you doing here?','What are you doing here?',26124),
(86825,'enUS','Prepare to battle the Shadowmoon clan.','Prepare to battle the Shadowmoon clan.',26124),
(86826,'enUS','The exit is just ahead!','',26124),
(86827,'enUS','You have nothing to offer me enchanter. Let me return to my study.','',26124),
(86828,'enUS','Prepare to battle the Shadowmoon clan.','Prepare to battle the Shadowmoon clan.',26124),
(86830,'enUS','I will await your return at the Throne of Elements.','',26124),
(86831,'enUS','We can wait no longer. The Talon King must return.','',26124),
(86832,'enUS','','Be careful out there, $c.',26124),
(86833,'enUS','I\'ll get that scared little girl out from under the log, $g sir:ma\'am;!','',26124),
(86834,'enUS','[PLACEHOLDER] YOU GOT IT!','',26124),
(86835,'enUS','I tink der\'s a woman stuck under der, boss! We gotta help her!','',26124),
(86836,'enUS','[PLACEHOLDER] WORK WORK!','',26124),
(86837,'enUS','There is power here. I will take it.','',26124),
(86838,'enUS','I\'m glad for the help, $c.','',26124),
(86839,'enUS','Frost is clearly the superior path. Give up!','',26124),
(86840,'enUS','We\'ll see about that!','',26124),
(86841,'enUS','N.U.K.U.L.A.R. Launch Detected','N.U.K.U.L.A.R. Launch Detected',26124),
(86842,'enUS','MMMMF! HELFFP!! STMUCK UMDER LOG!','',26124),
(86843,'enUS','Ah, thank you for the assistance, young peasant. Here is a token of my gratitude.','',26124),
(86844,'enUS','+$1i VP','+$1i VP',26124),
(86845,'enUS','Should you be looking to make a few more coppers there will be work for you at your garrison. I will take my leave. Find me there if you wish.','',26124),
(86846,'enUS','Iron Horde Flame Tanks Destroyed: $1i (+$2i VP)','Iron Horde Flame Tanks Destroyed: $1i (+$2i VP)',26124),
(86847,'enUS','Here comes their commander!','',26124),
(86848,'enUS','Oh wow, my head hurts...','Oh wow, my head hurts...',26124),
(86849,'enUS','It was like someone else was controlling my body.','It was like someone else was controlling my body.',26124),
(86850,'enUS','What am I doing here? I got to get somewhere safe!','What am I doing here? I got to get somewhere safe!',26124),
(86851,'enUS','Whoa, I\'m in control of myself again! Thanks, friend!','Whoa, I\'m in control of myself again! Thanks, friend!',26124),
(86852,'enUS','Filth! I\'ll send you back where you belong!','',26124),
(86853,'enUS','This may take a moment.','',26124),
(86854,'enUS','%s hears the whispers growing, louder and louder as the secrets become overwhelming.','',26124),
(86855,'enUS','... do you hear that?','',26124),
(86856,'enUS','His powers were much greater than I anticipated.','',26124),
(86857,'enUS','I should be able to get back to Karabor by the end of the week.','',26124),
(86858,'enUS','It is good you are here, there is more trouble than even I can handle.','',26124),
(86861,'enUS','The spell has been nullified. Our crystals pulse with vigorous energy once again.','',26124),
(86862,'enUS','','Ain\'t nuthin\' better than ridin\' the ol\' red rocket!',26124),
(86863,'enUS','I\'m going to try to counter Morakh\'s spell.','',26124),
(86864,'enUS','I wonder what Chris Clarkie does with all those Troll Feet people bring him.','',26124),
(86865,'enUS','The incantations on the tablets you discovered will imbue your ring with tremendous power. Are you ready?','',26124),
(86866,'enUS','','I\'m so glad I was rescued from that cramped cage. Once I find the rest of my supplies, I\'m going back to the village.',26124),
(86867,'enUS','Flare spotted! An ally signals for aid. The location is marked on your map.','',26124),
(86868,'enUS','Flare spotted! Our soldiers need your help. The location is marked on your map.','',26124),
(86869,'enUS','Hey, be careful with that sword!','Hey, be careful with that sword!',26124),
(86870,'enUS','A Laughing Skull orc does grim work here. We should finish our task quickly before they return.$b$bThis one is particularly brutal...','',26124),
(86871,'enUS','These saberon are playing with magic they don\'t understand! They are sure to enrage the magnaron.','',26124),
(86872,'enUS','Let\'s see...','Let\'s see...',26124),
(86873,'enUS','Hmm...','Hmm...',26124),
(86874,'enUS','What do we have here?','What do we have here?',26124),
(86875,'enUS','How much is this?','How much is this?',26124),
(86876,'enUS','How interesting!','How interesting!',26124),
(86877,'enUS','I hope this all works out...','',26124),
(86878,'enUS','There\'s a chill in the air...','',26124),
(86879,'enUS','It must be the Shadowmoon Clan. Sound the alarm!','',26124),
(86880,'enUS','To arms! To your posts! The Shadowmoon Clan has a score to settle.','',26124),
(86881,'enUS','Don\'t fear, brothers and sisters. We\'ve fought orcs for decades.','',26124),
(86882,'enUS','Do you feel that chill? Like something stomping on your grave...','',26124),
(86883,'enUS','Garona is a dangerous assassin. We must keep our guard up. Let me know when you are ready!','',26124),
(86884,'enUS','That was just a test.','',26124),
(86885,'enUS','Spread out! Protect the structures!','',26124),
(86886,'enUS','I am ready. Let\'s free Garona\'s mind!','I am ready. Let\'s free Garona\'s mind!',26124),
(86887,'enUS','Take heart. It is always darkest before dawn.','',26124),
(86888,'enUS','It is here. Charge! For the Alliance!','',26124),
(86889,'enUS','Sergeant, the dead walk outside our garrison.','Sergeant, the dead walk outside our garrison.',26124),
(86890,'enUS','%s checks the delivery list.','%s checks the delivery list.',26124),
(86891,'enUS','writes something on the list of deliveries.','writes something on the list of deliveries.',26124),
(86892,'enUS','The Shadowmoon spirit thanks you before departing the realm of the living.','The Shadowmoon spirit thanks you before departing the realm of the living.',26124),
(86893,'enUS','Mr. Coinbender,\n\nYour payment\'s been arranged, but I had to leave it off shore so the local orcs wouldn\'t confiscate the goods.\n\nI\'ve put out some buoys to help you find it. Best of luck, pal.\n\nRegards,\nGazrix Gearlock','',26124),
(86894,'enUS','You\'ve still got a ways to go. Just keep following the buoys and you\'ll find it.\n\n- Gazrix','',26124),
(86895,'enUS','You\'re almost there. I\'m sure you can see the final buoy by now, chum.\n\n- Gazrix','',26124),
(86896,'enUS','Oh, did I forget to mention that your payment is on the bottom of the ocean?  Maybe you\'ll think about that next time you try to double-cross the Cartel.\n\nJust keep swimming down, though. I\'m sure you\'ll find it, chump.\n\n- GG','',26124),
(86897,'enUS','','These bones are huge! I bet they belong to an ogre... maybe a GIANT ogre!',26124),
(86898,'enUS','Beautiful day commander.','Beautiful day commander.',26124),
(86899,'enUS','Everything is growing so well here.','Everything is growing so well here.',26124),
(86900,'enUS','Don\'t all the plants look great?','Don\'t all the plants look great?',26124),
(86901,'enUS','I would like to pick what we plant next.','I would like to pick what we plant next.',26124),
(86902,'enUS','Ok commander, I am currently planting a random set of herbs. Would you like me to switch to something specific?','Ok commander, I am currently planting a random set of herbs. Would you like me to switch to something specific?',26124),
(86903,'enUS','Frostweed.','Frostweed.',26124),
(86904,'enUS','Fireweed.','Fireweed.',26124),
(86905,'enUS','Gorgrond Flytrap.','Gorgrond Flytrap.',26124),
(86906,'enUS','Talador Orchid.','Talador Orchid.',26124),
(86907,'enUS','Nagrand Arrowbloom.','Nagrand Arrowbloom.',26124),
(86908,'enUS','Starflower.','Starflower.',26124),
(86909,'enUS','Let\'s go with a random planting.','Let\'s go with a random planting.',26124),
(86910,'enUS','Ok commander, I am currently planting Frostweed. Would you like me to switch to something specific?','Ok commander, I am currently planting Frostweed. Would you like me to switch to something specific?',26124),
(86911,'enUS','Ok commander, I am currently planting Fireweed. Would you like me to switch to something specific?','Ok commander, I am currently planting Fireweed. Would you like me to switch to something specific?',26124),
(86912,'enUS','Ok commander, I am currently planting Starflower. Would you like me to switch to something specific?','Ok commander, I am currently planting Starflower. Would you like me to switch to something specific?',26124),
(86913,'enUS','Ok commander, I am currently planting Talador Orchid. Would you like me to switch to something specific?','Ok commander, I am currently planting Talador Orchid. Would you like me to switch to something specific?',26124),
(86914,'enUS','Ok commander, I am currently planting Gorgrond Flytrap. Would you like me to switch to something specific?','Ok commander, I am currently planting Gorgrond Flytrap. Would you like me to switch to something specific?',26124),
(86915,'enUS','','Okay commander, you should be able to use the mole machine to get back to the outpost.',26124),
(86916,'enUS','Ok commander, I am currently planting Nagrand Arrowbloom. Would you like me to switch to something specific?','Ok commander, I am currently planting Nagrand Arrowbloom. Would you like me to switch to something specific?',26124),
(86921,'enUS','Commander, feel free to use the mole machine to return to yer outpost. It\'ll get ya there. Perhaps.','',26124),
(86922,'enUS','Excellent, now to business!','',26124),
(86923,'enUS','|cffADFF2F+$1i Timber|r','|cFF0000FF+$1i Timber|r',26124),
(86924,'enUS','','How do you think these got here? Do you think someone put them in the sand?',26124),
(86925,'enUS','','No, dummy! Something died and it turned into bones!',26124),
(86926,'enUS','+$1i VP','+$1i VP',26124),
(86927,'enUS','Yea, this place is pretty interesting to explore. But have you ever been to the Timeless Isle? Now that place was perfection!','',26124),
(86928,'enUS','I seem to have misplaced my key to Admiral Taylor\'s coffer. I know I had it a moment ago, but now everything seems so hazy...','',26124),
(86929,'enUS','Maybe you should try retracing your steps?','Maybe you should try retracing your steps?',26124),
(86930,'enUS','The last I remember, I was enjoying a book under a tree somewhere nearby. I\'m not sure quite where, though.\n\nI seem to recall large stones... and for some reason a painting of a death\'s-head... but that is all.','',26124),
(86931,'enUS','It was nearly the end for me out there, $n. Those of us who made it back are truly blessed.','',26124),
(86932,'enUS','','What ARE those things? They look like figures carved from stone.',26124),
(86933,'enUS','What! Who are you?! How did you cross over to this side?','',26124),
(86934,'enUS','%s sniffs the air and reels.','',26124),
(86935,'enUS','An elixir? And a powerful one at that...','',26124),
(86936,'enUS','By tonight I\'ll be wearing your face for a mask!','',26124),
(86937,'enUS','For the Shattered Hand!','',26124),
(86938,'enUS','You just made the wrong choice!','',26124),
(86939,'enUS','All it takes is a little bit of love and care to keep a beautiful garden.','All it takes is a little bit of love and care to keep a beautiful garden.',26124),
(86940,'enUS','Can you grow these draenic seeds into herbs for me?','Can you grow these draenic seeds into herbs for me?',26124),
(86941,'enUS','Draenic seeds can be gathered from herbalism nodes across draenor.  Return to me once you have 5 or more and I will grow them into herbs for you.','Draenic seeds can be gathered from herbalism nodes across draenor.  Return to me once you have 5 or more and I will grow them into herbs for you.',26124),
(86942,'enUS','You! Maybe there is still time. The portal atop this outpost is a direct link to our world-- to Stormwind! The genesaur...','',26124),
(86943,'enUS','If that beast crosses through, the unchecked growth will choke the whole of Azeroth! Hurry!','',26124),
(86944,'enUS','Look at my horse, isn\'t it magnificent? My partner over there doesn\'t even HAVE a horse. Turn your face from them, now, and look back at me. Still on a horse! Aren\'t you amazed? And look at how great my hat is!','',26124),
(86945,'enUS','','Ooooh!',26124),
(86946,'enUS','','Ooooh!',26124),
(86947,'enUS','My next pet won\'t be so easy!','',26124),
(86948,'enUS','All\'s fair in tiny monkeys and war.','',26124),
(86949,'enUS','What? How?? I will have my revenge, you liver-scented codswallup!','',26124),
(86950,'enUS','A fitting conclusion to yet another epic battle, featuring me!','',26124),
(86951,'enUS','Prepare for the smiting of a lifetime!','',26124),
(86952,'enUS','Ah, lucky for you I was not paying attention this time!','',26124),
(86953,'enUS','I will make for Veil Terokk. Time is short and we have many preparations to make.','',26124),
(86954,'enUS','Those are our people down there. May the light bring them peace.','',26124),
(86955,'enUS','','Papa said you\'ll be in trouble if you don\'t get out of the boat!',26124),
(86956,'enUS','I\'m not done playing captain! I\'ll go back when I\'m done.','',26124),
(86957,'enUS','','I\'m telling!',26124),
(86958,'enUS','As powerful as I am, I cannot be everywhere at once.','',26124),
(86959,'enUS','But you, commander, are my greatest resource. Between the skill of your allies and the might of your garrison, there is not a stronghold that can withstand you.','',26124),
(86960,'enUS','Under your leadership, the full might of the Alliance expeditionary force will engage the Iron Horde.','',26124),
(86961,'enUS','Under your command, the Horde\'s greatest warriors will engage Grommash and his army.','',26124),
(86962,'enUS','But I will be concentrating on the single greatest threat to the safety of Azeroth:','',26124),
(86963,'enUS','Gul\'dan. Darkness incarnate.','',26124),
(86964,'enUS','In all my years, Gul\'dan is the craftiest, most diabolical foe I have ever encountered. I hold myself accountable for his release.','',26124),
(86965,'enUS','We MUST find and eliminate Gul\'dan and his nascent Shadow Council network.','',26124),
(86966,'enUS','With your help, I can track him down. I will ask a great deal of you. I will task you to the very edge of your abilities.','',26124),
(86967,'enUS','But I will also help you as much as I am able. Together we will create for you an artifact of legendary power.','',26124),
(86968,'enUS','With a core forged from the heart of Draenor\'s sun, this ring is a foundation upon which we will build a wonder.','',26124),
(86969,'enUS','...there! It is done. Now to find Gul\'dan.','',26124),
(86970,'enUS','Follow me, commander!','',26124),
(86971,'enUS','Once we locate Gul\'dan, we may have to move quickly...','',26124),
(86972,'enUS','My eyes are open: Van shalach, om aeschis, khaz\'tolim!','',26124),
(86973,'enUS','Come on, come on... Where are you...','',26124),
(86974,'enUS','Wait - here - what...?','',26124),
(86975,'enUS','Hiding! He\'s countering my spell.','',26124),
(86976,'enUS','Champion, killing Teron\'gor must\'ve shaken him up. That\'s good. But now he knows we\'re getting closer.','',26124),
(86977,'enUS','We need... more power!','',26124),
(86978,'enUS','','Perfect timing!',26124),
(86979,'enUS','','We\'ll track you from the air!',26124),
(86980,'enUS','The trail will not be easy to follow. Start by heading east.','',26124),
(86981,'enUS','','Follow the trail of time anomalies like this.',26124),
(86982,'enUS','','Here! It looks like Garrosh came down this way alone after he first arrived on Draenor. But where was Kairoz?',26124),
(86983,'enUS','Look at Garrosh. His hands are bound. But he\'s alone. When did he and Kairoz part ways?','',26124),
(86984,'enUS','','Hmmm... That ogre shouldn\'t be here. Something strange must\'ve happened up on this ridge.',26124),
(86985,'enUS','Who is that?','',26124),
(86986,'enUS','','That\'s Kairoz in disguise. Garrosh killed him! But where was the body?',26124),
(86987,'enUS','We must be close!','',26124),
(86988,'enUS','Very good: I will distract Kairoz while you attack.','',26124),
(86989,'enUS','','If anyone gets too hurt, I\'ll undo your wounds.',26124),
(86990,'enUS','Excellent! I will distract Kairoz while Chromie goes on the offensive.','',26124),
(86991,'enUS','','Do your best to keep us both alive!',26124),
(86992,'enUS','Good plan. You distract Kairoz while I attack.','',26124),
(86993,'enUS','Bloodmaul...$B$BNo matter what you hear of that horrid place, you know nothing! I\'ll never go back.','Bloodmaul...$B$BNo matter what you hear of that horrid place, you know nothing! I\'ll never go back.',26124),
(86994,'enUS','Now that I\'ve been freed I must plan to help others escape from Bloodmaul. We cannot leave our brothers and sisters behind!','Now that I\'ve been freed I must plan to help others escape from Bloodmaul. We cannot leave our brothers and sisters behind!',26124),
(86995,'enUS','You are Warchief no longer, Hellscream. You\'re free because I willed it. You live because I will it. You will join your father and rally the old orc clans because I will it!','',26124),
(86996,'enUS','','He thinks he\'s still fighting Garrosh.',26124),
(86997,'enUS','Kairoz! What did you want? Why did you need an army?','',26124),
(86998,'enUS','Not just one... An infinite number of armies, across an infinite number of worlds...','',26124),
(86999,'enUS','I would be INFINITE!','',26124),
(87000,'enUS','Auuuggh - Hellscream - without me - wh-','',26124),
(87001,'enUS','Look out!','',26124),
(87002,'enUS','I\'ve got him...','',26124),
(87003,'enUS','Keep him distracted!','',26124),
(87004,'enUS','','Watch your feet!',26124),
(87005,'enUS','','Stay away from him!',26124),
(87006,'enUS','Stop it - Chromie, take us back!','',26124),
(87007,'enUS','No - it\'s not working - Chromie-!','',26124),
(87008,'enUS','','Eek! Noooo - I\'m stopping it!',26124),
(87009,'enUS','','...I fixed it.',26124),
(87010,'enUS','','...we\'ll have to try that again.',26124),
(87011,'enUS','','...it\'s okay. We have all the time in the world.',26124),
(87012,'enUS','Victory! Champion, you did it!','',26124),
(87013,'enUS','So many were lost inside the mines...$B$BI barely escaped, but so many are still enslaved.','So many were lost inside the mines...$B$BI barely escaped, but so many are still enslaved.',26124),
(87014,'enUS','Kairoz created this world. We will use his power to find Gul\'dan within it.','',26124),
(87015,'enUS','','Good night, my time-lost prince.',26124),
(87016,'enUS','I am forever indebted to those who set me free.','I am forever indebted to those who set me free.',26124),
(87017,'enUS','Those ogres treated us like dirt. They enslaved our people, forced them to work and slaughtered our kind for their own enjoyment.','Those ogres treated us like dirt. They enslaved our people, forced them to work and slaughtered our kind for their own enjoyment.',26124),
(87018,'enUS','I know now how to defeat Gul\'dan\'s magic and reveal the Shadow Council. But we\'ll need more power.','',26124),
(87019,'enUS','The mines are an unspeakable place.','The mines are an unspeakable place.',26124),
(87020,'enUS','We will have to tear artifacts from the very heart of the Ogre Empire.','',26124),
(87021,'enUS','I can help you. Let us augment the power of that ring of yours...','',26124),
(87022,'enUS','Hold out your hand, and step into the light!','',26124),
(87023,'enUS','I\'m sorry, I should\'ve mentioned that you would be... slightly killed.','',26124),
(87024,'enUS','Don\'t let down your guard, my friend. The ogres of this era are not all brainless brutes. Some among them are dangerously clever.','',26124),
(87025,'enUS','The Sorcerer King comes from a long lineage of terror. To crush him in battle was no small feat.','',26124),
(87026,'enUS','Marvelous... we have everything we need!','',26124),
(87027,'enUS','Gul\'dan will NOT be able to hide from my gaze this time.','',26124),
(87028,'enUS','','Archmage, be careful.',26124),
(87029,'enUS','The mines are sweltering. The heat permeates through everything. I had no energy to move, yet somehow I was able to work countless days without rest.$B$BI would never wish what I went through on another being. It was unbearable...','The mines are sweltering. The heat permeates through everything. I had no energy to move, yet I worked countless days without rest.',26124),
(87030,'enUS','We have him where we want him!','',26124),
(87031,'enUS','My eyes are open: Val\'mir, khar abra, mal ozymius...','',26124),
(87032,'enUS','Come, come, come... I will find you...','',26124),
(87033,'enUS','...there! Gul\'dan! He is -','',26124),
(87034,'enUS','You! The human mage from Tanaan...','',26124),
(87035,'enUS','I have found you!','',26124),
(87036,'enUS','I\'ve been inquiring about you, \"Khadgar.\" It would seem we have a history.','',26124),
(87037,'enUS','Then you know how this ends. Give yourself up.','',26124),
(87038,'enUS','Your clumsy magic works both ways. I have also found you.','',26124),
(87039,'enUS','','Archmage, look ou-',26124),
(87040,'enUS','Foolish mage. Your death will be excruciatingly slow. I only wish I could be there to enjoy it.','',26124),
(87041,'enUS','','Champion - The archmage!',26124),
(87042,'enUS','','I will stay with the archmage and find help. Quickly! Capture Garona!',26124),
(87043,'enUS','','You\'re a brave one, coming after me all alone...',26124),
(87044,'enUS','','Come out into the open, \"hero.\" Let me get a good look at you.',26124),
(87045,'enUS','','Following my trail? You\'re strong AND crafty. I LOVE a good hunt.',26124),
(87046,'enUS','','The trail ends! Where did she go...?',26124),
(87047,'enUS','','Got you!',26124),
(87048,'enUS','','The poison is like fire in your veins, isn\'t it? Don\'t worry - it\'ll all be over soon!',26124),
(87049,'enUS','','Still on your feet? You\'re a tough one!',26124),
(87050,'enUS','','Better kill me quick. You don\'t have much time.',26124),
(87051,'enUS','','You\'re too late. Nothing can save your Archmage now.',26124),
(87052,'enUS','','Gul\'dan takes what he wants. Always. I am nothing.',26124),
(87053,'enUS','How do I play Firebird\'s Challenge?','How do I play Firebird\'s Challenge?',26124),
(87054,'enUS','','Thank you, champion! We got the murder weapon just in time.',26124),
(87055,'enUS','','Be still, Khadgar. Garona\'s dagger was enchanted.',26124),
(87056,'enUS','%s groans in pain.','',26124),
(87057,'enUS','','This wound is grisly. You should see a priest.',26124),
(87058,'enUS','I am freed, but others are still captive. I shall avenge my brothers and sisters when the time is right.$B$BThe Bloodmaul do not realize what is coming.','I am freed, but others are still captive. I shall avenge my brothers and sisters when the time is right.$B$BThe Bloodmaul do not realize what is coming.',26124),
(87059,'enUS','The Bloodmaul ogres are relentless. They stop at nothing to maintain their workforce.','The Bloodmaul ogres are relentless. They stop at nothing to maintain their workforce.',26124),
(87060,'enUS','For years I was enslaved by the Bloodmaul deep within their mines, but no longer.','For years I was enslaved by the Bloodmaul deep within their mines, but no longer.',26124),
(87061,'enUS','No - no priest. Cordana, stitch me up.','',26124),
(87062,'enUS','Ready to fly! |cFF0008E8(Darkmoon Game Token)|r','Ready to fly! |cFF0008E8(Darkmoon Game Token)|r',26124),
(87063,'enUS','','I see you\'ve been working with the Horde.',26124),
(87064,'enUS','We\'re worlds away from the conflict in Azeroth. I need all the help I can find.','',26124),
(87065,'enUS','','The rest of the Council of Six doesn\'t want the Horde anywhere near Kirin Tor business.',26124),
(87066,'enUS','It\'s not the first time I\'ve disagreed with the council and it won\'t be the last.','',26124),
(87067,'enUS','','Stubborn old man!',26124),
(87068,'enUS','','Thank you, Commander. You\'re an asset to the Alliance.',26124),
(87069,'enUS','I work with the best.','',26124),
(87070,'enUS','','I heard you\'ve also been working with the Horde. The rest of the Council of Six wouldn\'t approve. I don\'t.',26124),
(87071,'enUS','','Keep protecting our archmage, Commander. We\'d be lost without him.',26124),
(87072,'enUS','Come, this way. This will only hurt - well, quite a bit actually.','',26124),
(87073,'enUS','The power once reserved for the Sorcerer Kings, I place in your hands.','',26124),
(87074,'enUS','Omnivus, al-vitrade! Arcanum totalus!','',26124),
(87075,'enUS','','These are dangerous forces you\'re working with, archmage.',26124),
(87076,'enUS','Our friend needs them. The hardest trials are yet to come.','',26124),
(87077,'enUS','','Welcome! We\'ve got a special delivery of \"Firebird\"-class fireworks ready to strap to your back and send you soaring in search of rings and glory!',26124),
(87078,'enUS','Hand over a game token and I\'ll strap one of our newfangled \"Firebird\"-class fireworks to your back. You\'ll be launched up high in the air and sprout wings of flame!$B$BNow here\'s the tricky part: you only have 10 seconds of flight, and there are a bunch of fiery rings scattered around the fairgrounds. Each ring you pass through will count towards your total of collected rings, and most importantly, will give you another 10 seconds of flight.$B$BCollect 15 rings and the prizes are yours! But if you fail to collect enough rings, it will cost you another token!','Hand over a game token and I\'ll strap one of our newfangled \"Firebird\"-class fireworks to your back. You\'ll be launched up high in the air and sprout wings of flame!$B$BNow here\'s the tricky part: you only have 10 seconds of flight, and there are a bunch of fiery rings scattered around the fairgrounds. Each ring you pass through will count towards your total of collected rings, and most importantly, will give you another 10 seconds of flight.$B$BCollect 15 rings and the prizes are yours! But if you fail to collect enough rings, it will cost you another token!',26124),
(87079,'enUS','Today has been a great day for fishing! Now we can have fish for every meal!','',26124),
(87080,'enUS','','Hey there, you look like someone that might enjoy strapping a dozen fireworks to their back!',26124),
(87081,'enUS','','Fly high in the sky with the Firebird\'s Challenge!',26124),
(87082,'enUS','','Great prizes await, just a fuse away!',26124),
(87083,'enUS','','Am I seeing stars? Nope, it\'s just another great contender for the Firebird\'s Challenge!',26124),
(87084,'enUS','','I may not share my husband\'s enthusiasm for fish, but I am happy that we will have enough food for a while.',26124),
(87085,'enUS','','I\'ll be keeping my eyes on you.',26124),
(87086,'enUS','','Good luck, champion. Be careful in that foundry!',26124),
(87087,'enUS','Now, stand perfectly still.','',26124),
(87088,'enUS','This magic is extremely reliable and - maybe a tiny bit fatal. Hold still, I said!','',26124),
(87089,'enUS','I draw my strength, from the HEART of Draenor...','',26124),
(87090,'enUS','Come, Grommash. Drink.','',26124),
(87091,'enUS','I told you - get out!','',26124),
(87092,'enUS','They assault your foundry. They murder your allies. Mine is the only way.','',26124),
(87093,'enUS','Go!','',26124),
(87094,'enUS','Take me to the Pinchwhistle Gearworks.','Take me to the Pinchwhistle Gearworks.',26124),
(87095,'enUS','','It worked.',26124),
(87096,'enUS','I maintain a pair of goblin jumper cables for just such an emergency. Are you well, commander?','',26124),
(87097,'enUS','And so the foundry falls! You\'ve got the Iron Horde on the run, commander.','',26124),
(87098,'enUS','Come with me. Gul\'dan will not give up control of his pet without a fight.','',26124),
(87099,'enUS','','Just kill me and be done with it, archmage.',26124),
(87100,'enUS','I\'m not here to kill you, assassin.','',26124),
(87101,'enUS','','%s reels in pain.',26124),
(87102,'enUS','Where is your master? Tell me!','',26124),
(87103,'enUS','','Burn... in a thousand... hells...',26124),
(87104,'enUS','You first. Where is Gul\'dan!?','',26124),
(87105,'enUS','','Argghgh - he - will undo you -',26124),
(87106,'enUS','Where is he hiding?','',26124),
(87107,'enUS','','Archmage...',26124),
(87108,'enUS','TELL ME!','',26124),
(87109,'enUS','','%s grasps her head.',26124),
(87110,'enUS','','Khadgar, stop! What\'s the difference between this and torture?',26124),
(87111,'enUS','But she knows...','',26124),
(87112,'enUS','','I don\'t even know what you\'re fighting for anymore.',26124),
(87113,'enUS','You - you\'re right. Gul\'dan has butchered her mind already.','',26124),
(87114,'enUS','I am sorry, Garona. We will find another way.','',26124),
(87115,'enUS','This note appears to have fallen off the crate. It reads:\n\n\"Caution. Contents extremely dangerous and unpredictable. Do not tamper with or compromise shipping containers.\"','',26124),
(87116,'enUS','I\'d like to join the Sargerei.','I\'d like to join the Sargerei.',26124),
(87117,'enUS','I\'m gonna steal the Statement of Subordination!','',26124),
(87118,'enUS','No... Mogor... cannot die...','',26124),
(87119,'enUS','MOGOR CANNOT DIE!!!','',26124),
(87120,'enUS','Ergh... mfmff...','',26124),
(87121,'enUS','Heh... heheh... hah','',26124),
(87122,'enUS','Nyaaana na na na... haha','',26124),
(87123,'enUS','Row... roads... row-ads heh heh','',26124),
(87124,'enUS','Hrgrhlflffbrrrr...thhpppttpt','',26124),
(87125,'enUS','Secret seeker it\'s a - NO! No-no-no...','',26124),
(87126,'enUS','I SEE IT!','',26124),
(87127,'enUS','The door... do you see it? I...','',26124),
(87128,'enUS','','Look at this place. The botani are monsters.$b$bI think I am starting to see why the Laughing Skull are as brutal as they are.',26124),
(87129,'enUS','See you soon! Hehehe...','',26124),
(87130,'enUS','Exarch Maladaar has opened his weapon stores to any willing to lend their hand to the battle.','',26124),
(87131,'enUS','Oh good, you\'re back! Enjoy yourself in there?','',26124),
(87132,'enUS','Kaz! Kaz! Kaz! This no-mask took me on an adventure! We saw infested orcs, a green ogron, and we set everything on FIRE!','',26124),
(87133,'enUS','You have drawn Wrath!','You have drawn Wrath!',26124),
(87134,'enUS','You have drawn Devastation!','You have drawn Devastation!',26124),
(87135,'enUS','You have drawn Nimbleness!','You have drawn Nimbleness!',26124),
(87136,'enUS','You have drawn Frailty!','You have drawn Frailty!',26124),
(87137,'enUS','You have drawn Vulnerability!','You have drawn Vulnerability!',26124),
(87138,'enUS','You have drawn Swiftness!','You have drawn Swiftness!',26124),
(87139,'enUS','You have drawn The Void!','You have drawn The Void!',26124),
(87140,'enUS','You have drawn The Herd!','You have drawn The Herd!',26124),
(87141,'enUS','You have drawn The Warp!','You have drawn The Warp!',26124),
(87142,'enUS','You have drawn The Barbarian!','You have drawn The Barbarian!',26124),
(87143,'enUS','Long have I dwelt in the shadows. I can hide no longer.','',26124),
(87144,'enUS','Are you ready to fight Sethe, $r?','',26124),
(87145,'enUS','I am ready Anzu, we will not fail.','I am ready Anzu, we will not fail.',26124),
(87146,'enUS','Are you ready to join Anzu in his fight with Sethe?','Are you ready to join Anzu in his fight with Sethe?',26124),
(87147,'enUS','Protect me, $n! Sethe\'s blood is harmful to all who cross its path.','',26124),
(87148,'enUS','Help me, $n! My life force is fading!','',26124),
(87149,'enUS','I will darken the skies, and all will fall!','',26124),
(87150,'enUS','It is done. Meet me at Lithic\'s Rest.','',26124),
(87151,'enUS','','We\'ll get a rescue party together as soon as we can. Where did you see him last?',26124),
(87153,'enUS','<The spirit wolf does not acknowledge your presence, and continues to stare blankly at a crude grave nearby.>','',26124),
(87154,'enUS','(Beast Mastery) Lean down and scratch the wolf behind its ears.','(Beast Mastery) Lean down and scratch the wolf behind its ears.',26124),
(87155,'enUS','Hey, pal! Good to see one of you $gguys:ladies; from the Alliance around here!\n\nWith your help, I bet I can make some progress with my work.','',26124),
(87156,'enUS','If she is searching for this \"Heart of Gorgorek,\" then we must find it before her. I will notify you as soon as I learn more.','',26124),
(87157,'enUS','Commander, this will be a protracted campaign. I should have more information for you in a week\'s time.','',26124),
(87158,'enUS','If she and da Iron Horde be searchin\' for dis \"Heart a Gorgorek,\" den we must find it first. I will send for ya when I hear more.','',26124),
(87159,'enUS','Commander, dis will be a long campaign. I will have more information for ya in a week\'s time.','',26124),
(87160,'enUS','You\'re from the Horde aren\'t you?$b$bI didn\'t know Kimzee would be out working with your kind, but considering the situation, I\'ll take any help I can get.','',26124),
(87161,'enUS','Gwaagghhh!!!!','Gwaagghhh!!!!',26124),
(87162,'enUS','We aren\'t the only ones with Prisoners, $n.$B$BOver at the Horde base lies their prison, underneath the relief hut to the left when you go through their main gate.$B$BIf we can find some of those Warspear Prison Keys in Ashran, we can break them free.','',26124),
(87163,'enUS','Did... did you hear something?','',26124),
(87164,'enUS','The Sargerei were no fools. They had been watching me this whole time.$B$BBut I am happy to know that my work was not in vain.','',26124),
(87165,'enUS','You cannot flee.','',26124),
(87166,'enUS','','',26124),
(87167,'enUS','Your souls are mine.','',26124),
(87168,'enUS','Flee! Flee from your former masters!','',26124),
(87169,'enUS','Your mortal bodies are so fragile.','',26124),
(87170,'enUS','Another soul to devour.','',26124),
(87171,'enUS','You are just maggots swarming to the corpse of a dying god.','',26124),
(87172,'enUS','Yes, come closer... your souls are strong and proud! I will feast on your terror!','',26124),
(87173,'enUS','It seems like they are close to figuring out the concept of death. Do you think we should tell them a bit more about it?','',26124),
(87174,'enUS','No, we should let them learn about it through their own discoveries. Just as we learned about the cycle of life on our own, they must do the same.','',26124),
(87175,'enUS','Ahh, I thought I\'d never get out of there! Good work!','',26124),
(87176,'enUS','I try to bring my talbuk down to the shore to relax as often as I can. He really likes watching the fishermen on the boats.','',26124),
(87177,'enUS','','Papa, brother won\'t get out of the boat. I told him and he didn\'t listen to me!',26124),
(87178,'enUS','That\'s alright, honey. That just means there\'s more of your mother\'s stew for us!','',26124),
(87179,'enUS','%s begins to cast |cFFFF0404|Hspell:171078|h[Exsteaminate]|h|r on targets that are both |cFFFF0404|Hspell:171061|h[Waterlogged]|h|r and |cFFFF0404|Hspell:171065|h[On Fire]|h|r!','',26124),
(87180,'enUS','','Maybe he will learn now not to skip meals.',26124),
(87181,'enUS','','You there, scrollkeeper. You are not of the ravenspeakers. Why do you stand before me?',26124),
(87182,'enUS','Great Ka\'alu, the tales of your majesty are woefully inadequate.','',26124),
(87183,'enUS','','You flatter me, but darkness weighs upon your thoughts - speak, child.',26124),
(87184,'enUS','The Adherents of Rukhmar wield a great power. They would use it to burn us all, including your ravens.','',26124),
(87185,'enUS','','They also subjugate my children, forcing them to fight and die. What might you have us do?',26124),
(87186,'enUS','Great mother, in the name of Anzu we ask humbly that you lend us your wings.','',26124),
(87187,'enUS','With your help, we can extinguish the light which sets the sky ablaze.','',26124),
(87188,'enUS','','Anzu always was meddling in the affairs of mortals. One would think I might learn from his mistakes.',26124),
(87189,'enUS','','Very well, scrollkeeper. My flock is yours.',26124),
(87190,'enUS','I came to find my daddy\'s tools and these savages trapped me! He needs them to work...','',26124),
(87191,'enUS','Percy, you stay here and guard the nest.','',26124),
(87192,'enUS','We must secure this terrace. Help our forces turn the tide!','',26124),
(87193,'enUS','You fight like a legend! Come, let us return to the sky.','',26124),
(87194,'enUS','We need to capture those alignment controls.','',26124),
(87195,'enUS','The ravenspeaker acolytes are ready to leap at your command.','',26124),
(87196,'enUS','It\'s no good, they\'re dying out there! Clear a path for them!','',26124),
(87197,'enUS','Reinforcements! Clear them out!','',26124),
(87198,'enUS','It looks like everyone is in position. Ka\'alu, give the signal and get us out of here!','',26124),
(87199,'enUS','Tweet me if you hate it.','',26124),
(87200,'enUS','Tweet me if you LOVE it.','',26124),
(87201,'enUS','Tweet me if you find bugs!','',26124),
(87202,'enUS','This one! Take it down!','',26124),
(87203,'enUS','So my wretched brother lives... and he has sent an assassin!','',26124),
(87204,'enUS','Duna! My boy... I thought you were lost.','',26124),
(87205,'enUS','Servants, attack!!!','',26124),
(87206,'enUS','Think you can help us catch some fish around here?','Think you can help us catch some fish around here?',26124),
(87207,'enUS','','Armies fight and die on the backs o\' their suppliers.',26124),
(87208,'enUS','How many do you think you can catch today?','',26124),
(87209,'enUS','I\'m feeling pretty lucky, so I\'m thinking double the catch I pulled in yesterday.','',26124),
(87210,'enUS','So you think you\'ll catch two fish today?','',26124),
(87211,'enUS','It was a pretty big fish! It was bigger than the little ones you brought in...','',26124),
(87212,'enUS','I was just using the wrong bait! I actually brought the correct one today.','',26124),
(87213,'enUS','Shadowmoon Dark Prophets Killed: $1i (+$2i VP)','',26124),
(87214,'enUS','Shadowmoon Defilers Killed: $1i (+$2i VP)','',26124),
(87215,'enUS','Shadowmoon Voidtwisters Killed: $1i (+$2i VP)','',26124),
(87216,'enUS','Reanimated Bones Killed: $1i (+$2i VP)','',26124),
(87217,'enUS','Risen Guards Killed: $1i (+$2i VP)','',26124),
(87218,'enUS','Primordial Horror Killed: $1i (+$2i VP)','',26124),
(87219,'enUS','Shadowmoon Warriors Killed: $1i (+$2i VP)','',26124),
(87220,'enUS','We shall purge these Iron Horde scum from my hunting grounds!','',26124),
(87221,'enUS','This is one of my allies.','This is one of my allies.',26124),
(87222,'enUS','Working like a charm! Don\'t mind the smoke...','',26124),
(87223,'enUS','Hop in!','',26124),
(87224,'enUS','','My Phantom Potions are perfect for sneaking around the Horde guards, or even into their main base! Have you tried them yet, $n?',26124),
(87225,'enUS','','Someone just showed me a Tuber root they found somewhere in east of Ashran. $B$BThey rival my healing potions in power!',26124),
(87226,'enUS','','Are you here to visit one of the wounded, $n?',26124),
(87227,'enUS','','Every day I see more and more wounded come into this relief hut. Take my advice and bring a healer along with you on your missions.',26124),
(87228,'enUS','','Healers are truly underestimated, $n. If more would choose to bring us along on their missions there would be less here in my relief hut.',26124),
(87229,'enUS','','Have you seen Feezzel? I can\'t find him anywhere.',26124),
(87230,'enUS','Shadowmoon Deathcallers Killed: $1i (+$2i VP)','',26124),
(87231,'enUS','Better luck next time.','Better luck next time.',26124),
(87232,'enUS','Nothing.','Nothing.',26124),
(87233,'enUS','What was that?','What was that?',26124),
(87234,'enUS','Hey!','Hey!',26124),
(87235,'enUS','Success!','Success!',26124),
(87236,'enUS','Finally!','Finally!',26124),
(87237,'enUS','That\'s more like it!','That\'s more like it!',26124),
(87238,'enUS','Catch of the day!','Catch of the day!',26124),
(87239,'enUS','Wow! Look at the size of that one!','Wow! Look at the size of that one!',26124),
(87240,'enUS','There\'s always a bigger fish.','There\'s always a bigger fish.',26124),
(87241,'enUS','Will you look at that?','Will you look at that?',26124),
(87242,'enUS','A prize catch!','A prize catch!',26124),
(87243,'enUS','purrs.','purrs.',26124),
(87244,'enUS','The secrets of the Apexis will be revealed to us!','',26124),
(87245,'enUS','Sister...','',26124),
(87246,'enUS','You will... burn...','',26124),
(87247,'enUS','How dare you challenge the will of Rukhmar!','',26124),
(87248,'enUS','Be careful with that serum, I\'m not exactly sure what the effects will be.','',26124),
(87249,'enUS','','Don\'t you worry, I\'ll get this thing flying one way or another.',26124),
(87250,'enUS','You ground-dwellers need to learn your place!','',26124),
(87251,'enUS','Lowborn... wretches...','',26124),
(87252,'enUS','A Shadowmoon Deathcaller begins awakening the dead.','A Shadowmoon Deathcaller begins awakening the dead.',26124),
(87253,'enUS','Dig, you worms!','',26124),
(87254,'enUS','You have my thanks!','You have my thanks!',26124),
(87255,'enUS','It\'s an honor to fight by your side!','It\'s an honor to fight by your side!',26124),
(87256,'enUS','You fight well!','You fight well!',26124),
(87257,'enUS','You have my gratitude!','You have my gratitude!',26124),
(87258,'enUS','Victory will be ours!','Victory will be ours!',26124),
(87259,'enUS','With you on our side, they cannot win!','With you on our side, they cannot win!',26124),
(87260,'enUS','Ready to do some mining?','Ready to do some mining?',26124),
(87261,'enUS','Blood, sweat and tears. That\'s what it takes to be a strong miner.\n\nAre you up to the task?','Blood, sweat and tears. That\'s what it takes to be a strong miner.\n\nAre you up to the task?',26124),
(87262,'enUS','Never thought you would be into mining, did ya?','Never thought you would be into mining, did ya?',26124),
(87263,'enUS','Can you refine this draenic stone into ore for me?','Can you refine this draenic stone into ore for me?',26124),
(87264,'enUS','Draenic stone can be mined from mining deposits across draenor.  Return to me once you have 5 or more and I will refine them into ore for you.','Draenic stone can be mined from mining deposits across draenor.  Return to me once you have 5 or more and I will refine them into ore for you.',26124),
(87265,'enUS','Care for your Garden and it will take care for you in return.','Care for your Garden and it will take care for you in return.',26124),
(87266,'enUS','Glory to the Alliance!','Glory to the Alliance!',26124),
(87267,'enUS','Good day, Commander. Or is it night? Never can tell in this blasted place.','Good day, Commander. Or is it night? Never can tell in this blasted place.',26124),
(87268,'enUS','All hail Commander $n, hero of the Alliance!','All hail Commander $n, hero of the Alliance!',26124),
(87269,'enUS','You are a light in this dark place, Commander.','You are a light in this dark place, Commander.',26124),
(87270,'enUS','Commander! Never a dull day on Draenor, is it?','Commander! Never a dull day on Draenor, is it?',26124),
(87271,'enUS','Victory or death, Commander! I\'d prefer the first one, though, if at all possible.','Victory or death, Commander! I\'d prefer the first one, though, if at all possible.',26124),
(87272,'enUS','For the Horde!','For the Horde!',26124),
(87273,'enUS','Show those iron mongrels what the real Horde is made of, Commander!','Show those iron mongrels what the real Horde is made of, Commander!',26124),
(87274,'enUS','Strength and honor!','Strength and honor!',26124),
(87275,'enUS','For Warchief Vol\'jin and Commander $n!','For Warchief Vol\'jin and Commander $n!',26124),
(87276,'enUS','You bring glory to the Horde, Commander!','You bring glory to the Horde, Commander!',26124),
(87277,'enUS','All hail Commander $n, pride of the Horde!','All hail Commander $n, pride of the Horde!',26124),
(87278,'enUS','Tonight we feast in your honor, Commander!','Tonight we feast in your honor, Commander!',26124),
(87279,'enUS','Glad to be in your presence, Commander.','Glad to be in your presence, Commander.',26124),
(87280,'enUS','It is my honor to serve you.','It is my honor to serve you.',26124),
(87281,'enUS','The garrison is secure.','The garrison is secure.',26124),
(87282,'enUS','That a new scar, Commander? What\'s the tally at now?','That a new scar, Commander? What\'s the tally at now?',26124),
(87283,'enUS','Look alive, everyone! The commander is here!','Look alive, everyone! The commander is here!',26124),
(87284,'enUS','Commander!','Commander!',26124),
(87285,'enUS','One look at you and our enemies will cower like the dogs they are!','One look at you and our enemies will cower like the dogs they are!',26124),
(87286,'enUS','I live to serve.','I live to serve.',26124),
(87287,'enUS','I smell battle in the air, Commander.','I smell battle in the air, Commander.',26124),
(87288,'enUS','It is an honor to fight by your side!','It is an honor to fight by your side!',26124),
(87289,'enUS','Need something killed?','Need something killed?',26124),
(87290,'enUS','Commander. How goes the battle?','Commander. How goes the battle?',26124),
(87291,'enUS','Say the word and it\'s done.','Say the word and it\'s done.',26124),
(87292,'enUS','Orders, Commander?','Orders, Commander?',26124),
(87293,'enUS','We will strike hard and true.','We will strike hard and true.',26124),
(87294,'enUS','I stand before a legend.','I stand before a legend.',26124),
(87295,'enUS','Stand as one!','Stand as one!',26124),
(87296,'enUS','For the Alliance!','For the Alliance!',26124),
(87297,'enUS','They will write songs of this battle.','They will write songs of this battle.',26124),
(87298,'enUS','For the Horde!','For the Horde!',26124),
(87299,'enUS','You\'ll make a nice trophy.','You\'ll make a nice trophy.',26124),
(87300,'enUS','I survived the Siege of Orgrimmar. This is nothing.','I survived the Siege of Orgrimmar. This is nothing.',26124),
(87301,'enUS','This won\'t take long.','This won\'t take long.',26124),
(87302,'enUS','That one\'s got loot! Get it!','That one\'s got loot! Get it!',26124),
(87303,'enUS','Take them down!','Take them down!',26124),
(87304,'enUS','Oh good, I was getting bored.','Oh good, I was getting bored.',26124),
(87305,'enUS','Feel free to run.','Feel free to run.',26124),
(87306,'enUS','More enemies. Watch your back!','More enemies. Watch your back!',26124),
(87307,'enUS','This won\'t be a problem.','This won\'t be a problem.',26124),
(87308,'enUS','Here we go!','Here we go!',26124),
(87309,'enUS','I\'m starting to like this garrison. You can\'t have it.','I\'m starting to like this garrison. You can\'t have it.',26124),
(87310,'enUS','They\'re attacking! That\'s too bad for them.','They\'re attacking! That\'s too bad for them.',26124),
(87311,'enUS','Someone\'s going to get hurt real bad.','Someone\'s going to get hurt real bad.',26124),
(87312,'enUS','Don\'t get cocky!','Don\'t get cocky!',26124),
(87313,'enUS','Brace yourselves!','Brace yourselves!',26124),
(87314,'enUS','This will be your end. Try not to embarrass yourself.','This will be your end. Try not to embarrass yourself.',26124),
(87315,'enUS','When this is over, I\'ll buy the first round.','When this is over, I\'ll buy the first round.',26124),
(87316,'enUS','Here they come. Stay focused.','Here they come. Stay focused.',26124),
(87317,'enUS','This might be interesting.','This might be interesting.',26124),
(87318,'enUS','Eyes open, everyone! They\'re here!','Eyes open, everyone! They\'re here!',26124),
(87319,'enUS','I hope you\'re more of a challenge than the last one.','I hope you\'re more of a challenge than the last one.',26124),
(87320,'enUS','This is not the day I die.','This is not the day I die.',26124),
(87321,'enUS','I have prepared my whole life for this moment.','I have prepared my whole life for this moment.',26124),
(87322,'enUS','I\'ve killed tougher things than you.','I\'ve killed tougher things than you.',26124),
(87323,'enUS','A challenger!','A challenger!',26124),
(87324,'enUS','I will crush you!','I will crush you!',26124),
(87325,'enUS','That\'s not a weapon - this is a weapon!','That\'s not a weapon - this is a weapon!',26124),
(87326,'enUS','Fight me! Fight like a warrior!','Fight me! Fight like a warrior!',26124),
(87327,'enUS','I will take your head as a trophy, coward.','I will take your head as a trophy, coward.',26124),
(87328,'enUS','Submit now, and I will kill you quickly.','Submit now, and I will kill you quickly.',26124),
(87329,'enUS','All you fight for will be dust.','All you fight for will be dust.',26124),
(87330,'enUS','Ours is the side of right!','Ours is the side of right!',26124),
(87331,'enUS','Victory shall be mine.','Victory shall be mine.',26124),
(87332,'enUS','I will strike you down!','I will strike you down!',26124),
(87333,'enUS','You will not prevail!','You will not prevail!',26124),
(87334,'enUS','Ah, finally, a worthy opponent!','Ah, finally, a worthy opponent!',26124),
(87335,'enUS','A pity I\'ll have to kill you.','A pity I\'ll have to kill you.',26124),
(87336,'enUS','Pathetic. You fight like a child.','Pathetic. You fight like a child.',26124),
(87337,'enUS','I\'ve seen better strategy from a target dummy!','I\'ve seen better strategy from a target dummy!',26124),
(87338,'enUS','I will fight to my last breath.','I will fight to my last breath.',26124),
(87339,'enUS','The ground will run red with your blood!','The ground will run red with your blood!',26124),
(87340,'enUS','Ever wonder what color your insides are? You\'re about to find out.','Ever wonder what color your insides are? You\'re about to find out.',26124),
(87341,'enUS','Your every bone - broken!','Your every bone - broken!',26124),
(87342,'enUS','Let\'s see how you fight without limbs.','Let\'s see how you fight without limbs.',26124),
(87343,'enUS','You will die here, alone and forgotten.','You will die here, alone and forgotten.',26124),
(87344,'enUS','Nice weapon. I\'ll have to take it off your corpse.','Nice weapon. I\'ll have to take it off your corpse.',26124),
(87345,'enUS','Hah! With every blow, your hope flees!','Hah! With every blow, your hope flees!',26124),
(87346,'enUS','Don\'t worry. Your end will be quick.','Don\'t worry. Your end will be quick.',26124),
(87347,'enUS','You\'re the best your kind could muster?','You\'re the best your kind could muster?',26124),
(87348,'enUS','I\'ll put your head on a pike!','I\'ll put your head on a pike!',26124),
(87349,'enUS','Why don\'t you do something useful, like dig your own grave?','Why don\'t you do something useful, like dig your own grave?',26124),
(87350,'enUS','This is growing tedious! Surrender!','This is growing tedious! Surrender!',26124),
(87351,'enUS','You should have trained harder.','You should have trained harder.',26124),
(87352,'enUS','I could take you down with one blow.','I could take you down with one blow.',26124),
(87353,'enUS','Fool! You\'re no match for me!','Fool! You\'re no match for me!',26124),
(87354,'enUS','This is too easy! Are you trying to die?','This is too easy! Are you trying to die?',26124),
(87355,'enUS','I will not be defeated!','I will not be defeated!',26124),
(87356,'enUS','I fight with honor! You fight like a dog!','I fight with honor! You fight like a dog!',26124),
(87357,'enUS','This is not even a challenge.','This is not even a challenge.',26124),
(87358,'enUS','Go back home, whelp. There\'s nothing for you here but death.','Go back home, whelp. There\'s nothing for you here but death.',26124),
(87359,'enUS','Try this on for size!','Try this on for size!',26124),
(87360,'enUS','I go now to the Light.','I go now to the Light.',26124),
(87361,'enUS','I return to my ancestors.','I return to my ancestors.',26124),
(87362,'enUS','I have failed you, Commander.','I have failed you, Commander.',26124),
(87363,'enUS','The dark consumes me.','The dark consumes me.',26124),
(87364,'enUS','Is this how it ends?','Is this how it ends?',26124),
(87365,'enUS','I give my life for Azeroth!','I give my life for Azeroth!',26124),
(87366,'enUS','Tell my family... I love them.','Tell my family... I love them.',26124),
(87367,'enUS','Curse this Light-forsaken realm!','Curse this Light-forsaken realm!',26124),
(87368,'enUS','My sacrifice will not be in vain.','My sacrifice will not be in vain.',26124),
(87369,'enUS','I did... my best.','I did... my best.',26124),
(87370,'enUS','I may be defeated, but Azeroth shall prevail!','I may be defeated, but Azeroth shall prevail!',26124),
(87371,'enUS','I\'ll see Garrosh in hell!','I\'ll see Garrosh in hell!',26124),
(87372,'enUS','I cannot go on.','I cannot go on.',26124),
(87373,'enUS','This isn\'t over. I shall be avenged!','This isn\'t over. I shall be avenged!',26124),
(87374,'enUS','At least I go down fighting.','At least I go down fighting.',26124),
(87375,'enUS','I die with honor.','I die with honor.',26124),
(87376,'enUS','I regret nothing!','I regret nothing!',26124),
(87377,'enUS','So... cold...','So... cold...',26124),
(87378,'enUS','Promise me... you\'ll get the one that got me.','Promise me... you\'ll get the one that got me.',26124),
(87379,'enUS','Death is a small price to pay.','Death is a small price to pay.',26124),
(87380,'enUS','I\'d die a thousand deaths for Azeroth.','I\'d die a thousand deaths for Azeroth.',26124),
(87381,'enUS','You should see the other guy...','You should see the other guy...',26124),
(87382,'enUS','I am... finished...','I am... finished...',26124),
(87383,'enUS','Is that the best you\'ve got... Wait, that was pretty good.','Is that the best you\'ve got... Wait, that was pretty good.',26124),
(87384,'enUS','My only regret is I didn\'t kill more of you Iron Horde dogs.','My only regret is I didn\'t kill more of you Iron Horde dogs.',26124),
(87385,'enUS','I\'m not even supposed to be here today.','I\'m not even supposed to be here today.',26124),
(87386,'enUS','\'Tis but a scratch!','\'Tis but a scratch!',26124),
(87387,'enUS','I said I\'d die for Azeroth, but I didn\'t think it would be so soon.','I said I\'d die for Azeroth, but I didn\'t think it would be so soon.',26124),
(87388,'enUS','Finish me, you cur. I\'ll never surrender!','Finish me, you cur. I\'ll never surrender!',26124),
(87389,'enUS','I could not resist the primal call of this world. This land is so unlike Azeroth. There is so much to discover, and so much to understand.','',26124),
(87390,'enUS','The Druids of the Talon are here to help defend our world against the Iron Horde. The balance of life on Azeroth must be preserved.','',26124),
(87391,'enUS','We druids are uniquely equipped to fight against the Iron Horde. I have stationed most of my forces throughout Gorgrond.$B$BThere, we patrol the jungles, deserts, and skies.$B$BI have eyes and ears reporting regularly on Blackhand\'s movements.','',26124),
(87392,'enUS','','The Druids of the Talon are here to help. Our teams are spread out across Gorgrond, listening and watching.',26124),
(87393,'enUS','There are still Iron Horde in the northern courtyard.','',26124),
(87394,'enUS','I smell battle in the air, Commander. Or is that the outhouse again?','I smell battle in the air, Commander. Or is that the outhouse again?',26124),
(87395,'enUS','I have lost my garrison hearthstone, can you give me another?','I have lost my garrison hearthstone, can you give me another?',26124),
(87396,'enUS','Blacksmith Haephest has gone into the village to sell our wares today. However, I can handle any repair needs you may have.\n\nMay I be of assistance?','',26124),
(87397,'enUS','%s sighs wearily.','%s sighs wearily.',26124),
(87398,'enUS','%s looks exhausted.','%s looks exhausted.',26124),
(87399,'enUS','%s wipes his brow.','%s wipes her brow.',26124),
(87400,'enUS','','No matter how much I feed them, your pets keep wandering into the town hall and begging for scraps.',26124),
(87401,'enUS','I hear you\'re a force to be reckoned with in the arena, $n.','',26124),
(87402,'enUS','Not all High Warlords are the same, $c. Some got here by persistence and time, others by skill of combat. Take a guess at which of those I belong.','',26124),
(87403,'enUS','Sorry, I can\'t heal your pets right now.  I can help if you come back in a few minutes.\n\n(You cannot heal your pets within 3 minutes of logging in.)','Sorry, I can\'t heal your pets right now.  I can help if you come back in a few minutes.\n\n(You cannot heal your pets within 3 minutes of logging in.)',26124),
(87404,'enUS','','So this whole fight club thing just isn\'t my style. I\'m more of a rip the trees down with a homemade giant mechanical monster kind of gal.$b$bIf you change your mind later, come talk to me and I can flip this fight club out of your way and replace it with a nice big rompin\' lumber camp! Complete with its own shredder!$b$bOf course, that ain\'t gonna be cheap.',26124),
(87405,'enUS','Build the Lumber Yard instead.','Build the Lumber Yard instead.',26124),
(87406,'enUS','Do you have any booty for sale?','Do you have any booty for sale?',26124),
(87407,'enUS','Why are you called the Lioness?','Why are you called the Lioness?',26124),
(87408,'enUS','','<Lio narrows her eyes.>',26124),
(87409,'enUS','','You sure you want an answer?',26124),
(87410,'enUS','','<Lio growls softly.>',26124),
(87411,'enUS','','Someone else asked me that once... just once.',26124),
(87412,'enUS','','Kid, don\'t start with me.',26124),
(87413,'enUS','Pursue Garona!','Pursue Garona!',26124),
(87414,'enUS','Nevermind!','Nevermind!',26124),
(87415,'enUS','Any pet stuff for sale?','Any pet stuff for sale?',26124),
(87416,'enUS','','Oh, what a great question.  Let me write that one down.',26124),
(87417,'enUS','','Do you like scars?',26124),
(87418,'enUS','','Did you find anything on O\'rok\'s body? A letter perhaps? Or some orders?',26124),
(87419,'enUS','Gro the Uncreator, I call to you!','',26124),
(87420,'enUS','The spirits of the Laughing Skull have spoken. We must join together to fight our common enemy, the Iron Horde!','',26124),
(87421,'enUS','Yes! It is working! The spirits were right!','',26124),
(87422,'enUS','Trees? Bah! Why rebuild when we can destroy!$b$bI can show you and your soldiers tricks no shredder could compete with.$b$bCome back when you are older and have some coin, and we\'ll get ourselves a proper fight club going.','',26124),
(87423,'enUS','Xuk...','',26124),
(87424,'enUS','Build the Fight Club instead.','Build the Fight Club instead.',26124),
(87425,'enUS','%s\'s Wicked Curse has found a more suitable host and jumps to $n.','%s\'s Wicked Curse has found a more suitable host and jumps to $n.',26124),
(87426,'enUS','I want the head of the orc that dumped those mines into the harbor!','',26124),
(87427,'enUS','The White Kraken could attack at any time! I need those mines loaded now!','',26124),
(87428,'enUS','We have already discovered hundreds of new species here on Draenor. There is so much to study, so much to collect, so much to catalog!','',26124),
(87429,'enUS','Take me down to the ground.','Take me down to the ground.',26124),
(87430,'enUS','The pain... so exquisite...','',26124),
(87431,'enUS','But who... will stop... the White Kraken...','',26124),
(87432,'enUS','The Iron Horde will fight on without me!','',26124),
(87433,'enUS','The Gorian Empire will... prevail...','',26124),
(87434,'enUS','','Hey! I\'m scouting for danger.',26124),
(87435,'enUS','Take me up to Cragplume Cauldron.','Take me up to Cragplume Cauldron.',26124),
(87436,'enUS','This place is quaint. It reminds me of the servant\'s quarters in my summer retreat on the shores of Lordamere Lake - only more rustic. And dirtier.$B$BPerhaps you should make an investment in some of Barov Industries\' wares to secure this make-shift tree fort before a light breeze topples the structure.','',26124),
(87437,'enUS','What have you got for sale?','What have you got for sale?',26124),
(87438,'enUS','My brother must be brought to justice!','',26124),
(87439,'enUS','Interested in representing your guild here in Lunarfall?','Interested in representing your guild here in Lunarfall?',26124),
(87440,'enUS','I would like to display my guild\'s standards in the garrison.','I would like to display my guild\'s standards in the garrison.',26124),
(87441,'enUS','I would like to remove my guild\'s standards from the garrison.','I would like to remove my guild\'s standards from the garrison.',26124),
(87442,'enUS','More invaders?','',26124),
(87443,'enUS','Burners and usurpers!','',26124),
(87444,'enUS','How dare you enter our sacred grove.','',26124),
(87445,'enUS','Your body will serve us in death.','',26124),
(87446,'enUS','Your blood shall become sap.','',26124),
(87447,'enUS','Ahhh, there it is. There\'s MY artifact. How foolish of me to trust Brak with something so valuable.','',26124),
(87448,'enUS','It\'s a shame that you\'re too late to stop me. Surrender the artifact, and I will allow you to escape with your lives.','',26124),
(87449,'enUS','Hahahaha, so be it! IRON HORDE, ADVANCE!','',26124),
(87450,'enUS','See what weapons I have in my arsenal!','',26124),
(87451,'enUS','You will never withstand the might of Goc!','',26124),
(87452,'enUS','RELEASE THE IRON STARS!','',26124),
(87453,'enUS','Gronnlings, attack!','',26124),
(87454,'enUS','ARGH... UNBELIEVEABLE! You will DIE for your insolence! I\'LL TEAR YOU LIMB FROM LIMB!','',26124),
(87455,'enUS','NO! I will DIE before I let you take what is mine! YOU... WILL NOT... WIN... THIS... WAR! AAARRRRGHH!','',26124),
(87456,'enUS','Hahaha! Not so confident now, are we?! Face me on even ground, cowards!','',26124),
(87457,'enUS','','We will never surrender to you! Champion, now is the time! Use the artifact!',26124),
(87459,'enUS','','Brace yourself, champion. The light is with you. I will not let you fall.',26124),
(87461,'enUS','','The artifact... What has he done?! We must restore it, we must get it to safety!',26124),
(87463,'enUS','','With pleasure.',26124),
(87464,'enUS','','With pleasure.',26124),
(87465,'enUS','','It is over, their defenses are shattered. We have won this battle, but without the artifact we have far to go.',26124),
(87466,'enUS','','Let us rally back at your outpost, commander. We must plan our next course of attack.',26124),
(87467,'enUS','','It is over, their defenses are shattered. We have won this battle, but without the artifact we have far to go. Let us rally back at your outpost, commander. We must plan our next course of attack.',26124),
(87469,'enUS','SKRAWWAWWW!!','',26124),
(87470,'enUS','We shall rule the skies, and all the lands below them!','',26124),
(87471,'enUS','You should have trained harder!','You should have trained harder!',26124),
(87472,'enUS','Hold just a little longer!','Hold just a little longer!',26124),
(87473,'enUS','','Fantastic choice! I\'ll go ahead and head on to your garrison.',26124),
(87474,'enUS','I am needed urgently at the Iron Docks.','I am needed urgently at the Iron Docks.',26124),
(87475,'enUS','This won\'t be a problem.','This won\'t be a problem.',26124),
(87476,'enUS','Nothing can stop us now that we have the artifact. Come, let us paint these rocks with their blood!','',26124),
(87477,'enUS','','The Iron Horde have no idea how much potential lies within the artifact. Let us give them a proper demonstration, shall we?',26124),
(87478,'enUS','Gotta be careful in Gorgrond, even in the sky!','',26124),
(87479,'enUS','Blessings to you stranger, you have my thanks.','Blessings to you stranger, you have my thanks.',26124),
(87480,'enUS','At long last... freedom.','At long last... freedom.',26124),
(87481,'enUS','My people.  What have they done?','My people.  What have they done?',26124),
(87482,'enUS','Finally, I can find rest.','Finally, I can find rest.',26124),
(87483,'enUS','Prove allegiance to your guild by conquering all the dungeons in Draenor with your guild mates.  Once you complete this task, you may purchase Garrison Guild Banners from the Guild Vendor.\n\nCome see me once you have acquired the item and I will help you display guild banners in your Garrison for all to see.','Prove allegiance to your guild by conquering all the dungeons in Draenor with your guild mates.  Once you complete this task, you may purchase Garrison Guild Banners from the Guild Vendor.\n\nCome see me once you have acquired the item and I will help you display guild banners in your Garrison for all to see.',26124),
(87484,'enUS','So this is how it ends...','So this is how it ends...',26124),
(87485,'enUS','If only you put up more of a fight!','If only you put up more of a fight!',26124),
(87486,'enUS','You call that fighting?','You call that fighting?',26124),
(87487,'enUS','Go! I\'ll cover you!','Go! I\'ll cover you!',26124),
(87488,'enUS','Hold just a little longer!','Hold just a little longer!',26124),
(87489,'enUS','We stand together! We fight as one!','We stand together! We fight as one!',26124),
(87491,'enUS','First one to fifty kills wins!','First one to fifty kills wins!',26124),
(87492,'enUS','C\'mon then! Battles don\'t start every day, you know!','C\'mon then! Battles don\'t start every day, you know!',26124),
(87493,'enUS','Follow my lead!','Follow my lead!',26124),
(87494,'enUS','To battle!','To battle!',26124),
(87495,'enUS','Hold the line! Do not let the Iron Horde break your ranks!','',26124),
(87496,'enUS','Push back the Iron Horde with all your strength!','',26124),
(87502,'enUS','Fight with courage and victory will be ours!','',26124),
(87503,'enUS','Teach the Iron Horde the value of cold steel!','',26124),
(87507,'enUS','Fight with all of your might for each inch of the battlefield!','',26124),
(87512,'enUS','Hold your ground! Show the Iron Horde that we will not be broken!','',26124),
(87513,'enUS','RRRRRRRRRrrooaaaarrr...','',26124),
(87514,'enUS','Smash you... into mountain.','',26124),
(87515,'enUS','','',26124),
(87516,'enUS','','',26124),
(87517,'enUS','May the healing mend your wounds.','May the healing mend your wounds.',26124),
(87518,'enUS','My blade\'s edge will cut right through you!','My blade\'s edge will cut right through you!',26124),
(87519,'enUS','My strikes are swift and true.','My strikes are swift and true.',26124),
(87520,'enUS','Your skills are no match for my blade.','Your skills are no match for my blade.',26124),
(87521,'enUS','Feel healing\'s touch upon you.','Feel healing\'s touch upon you.',26124),
(87522,'enUS','Stand close! Healing is on its way!','Stand close! Healing is on its way!',26124),
(87523,'enUS','Moving targets... my favorite!','Moving targets... my favorite!',26124),
(87524,'enUS','You can\'t avoid my shots forever!','You can\'t avoid my shots forever!',26124),
(87525,'enUS','Get behind me! Quickly!','Get behind me! Quickly!',26124),
(87526,'enUS','I\'ll hold them off while you take them down!','I\'ll hold them off while you take them down!',26124),
(87527,'enUS','You\'ll have to get through me first!','You\'ll have to get through me first!',26124),
(87528,'enUS','Feel my spell\'s wrath!','Feel my spell\'s wrath!',26124),
(87529,'enUS','I don\'t need mana to take you down!','I don\'t need mana to take you down!',26124),
(87530,'enUS','I\'ve got something better than weapons - magic!','I\'ve got something better than weapons - magic!',26124),
(87531,'enUS','I strike without hesitation!','I strike without hesitation!',26124),
(87532,'enUS','My attacks never miss their mark.','My attacks never miss their mark.',26124),
(87533,'enUS','My shield has never been broken!','My shield has never been broken!',26124),
(87534,'enUS','Your attacks are no match for my armor!','Your attacks are no match for my armor!',26124),
(87535,'enUS','Just try to get through my shield. I dare you!','Just try to get through my shield. I dare you!',26124),
(87536,'enUS','Just because I have a shield doesn\'t mean you have to run!','Just because I have a shield doesn\'t mean you have to run!',26124),
(87537,'enUS','Have you ever heard of Nat Pagle? No? Well come over here and let me tell you about him!','Have you ever heard of Nat Pagle? No? Well come over here and let me tell you about him!',26124),
(87538,'enUS','You have never heard of Nat Pagle? The man is a legend!\n\nNat has traveled the world over, always looking for the biggest catch! Speaking of big catches, I bet there are some huge catches for us out here in Draenor. If only we could get Nat to come out here and teach us the way...  Keep working on that fishing skill and come back to me when you are fully trained.','You have never heard of Nat Pagle? The man is a legend!\n\nNat has traveled the world over, always looking for the biggest catch! Speaking of big catches, I bet there are some huge catches for us out here in Draenor. If only we could get Nat to come out here and teach us the way...  Keep working on that fishing skill and come back to me when you are fully trained.',26124),
(87539,'enUS','You may commune with Gro the Uncreator.','You may commune with Gro the Uncreator.',26124),
(87540,'enUS','What can you tell me about this \"Nat Pagle\" character?','What can you tell me about this \"Nat Pagle\" character?',26124),
(87541,'enUS','You mirin\'?','',26124),
(87542,'enUS','Are you Nat Pagle?  I have been looking all over for you!','Are you Nat Pagle?  I have been looking all over for you!',26124),
(87543,'enUS','The Exarch Council is the \"Hand of the Prophet.\" We represent the draenei people, and act as the Prophet\'s messengers, enforcers, and conscience.','',26124),
(87544,'enUS','I made it! This place is a long way from home!','I made it! This place is a long way from home!',26124),
(87545,'enUS','Let\'s go fishing!','Let\'s go fishing!',26124),
(87546,'enUS','You will pay for that!','You will pay for that!',26124),
(87547,'enUS','Hold the entrance soldiers! Once the gronn lose interest we will move out!','',26124),
(87548,'enUS','I\'d like to requisition my seal for the week.','I\'d like to requisition my seal for the week.',26124),
(87549,'enUS','I was brave... wasn\'t I?','',26124),
(87550,'enUS','It just stepped on me like an ant...','',26124),
(87551,'enUS','What am I needed for?','',26124),
(87552,'enUS','Leave me... I will only slow you down... Lok\'tar...','',26124),
(87553,'enUS','When I heal, the gronn will pay...','',26124),
(87554,'enUS','Taming these gronn is stupid... we should rely on our own strength!','',26124),
(87555,'enUS','We will make it.  Greldrok has a way of getting out of these things...','',26124),
(87556,'enUS','The Laughing Skull will rise again!','',26124),
(87557,'enUS','','Rexxar is not quick to trust, is he? It is lucky that you happened upon us when you did.',26124),
(87558,'enUS','Fish fall down the waterfall and right to my bait.$B$BI hope to share my catch with Tega back at camp. She is... ferocious.','Fish fall down the waterfall and right to my bait.$B$BI hope to share my catch with Tega back at camp. She is... ferocious.',26124),
(87559,'enUS','Once I get this thing working we\'ll be able to clear-cut this island in no time flat.\n\nLasers, baby!','',26124),
(87560,'enUS','Trust Greldrok, he will get us out of this... mess...','',26124),
(87561,'enUS','Who would think so many gronn would be here? Our scouts should be broken for this!','',26124),
(87562,'enUS','Think to take advantage of us while we recover? Think again fool!','',26124),
(87563,'enUS','Perhaps your corpse will distract the gronn!','',26124),
(87564,'enUS','We may be wounded but you will find us strong still!','',26124),
(87565,'enUS','We will be back... you cannot stop us...','',26124),
(87566,'enUS','Rally Score Earned!','Rally Score Earned!',26124),
(87567,'enUS','Gorian Bruisers Killed: $1i (+$2i VP)','',26124),
(87568,'enUS','Gorian Elementalists Killed: $1i (+$2i VP)','',26124),
(87569,'enUS','Gorian Arcanists Killed: $1i (+$2i VP)','',26124),
(87570,'enUS','Gorian Mage-Lords Killed: $1i (+$2i VP)','',26124),
(87571,'enUS','Gorian Cohorts Killed: $1i (+$2i VP)','',26124),
(87572,'enUS','Gorian Sentinels Killed: $1i (+$2i VP)','',26124),
(87573,'enUS','Gorian Centurions Killed: $1i (+$2i VP)','',26124),
(87574,'enUS','Commander, Gorgrond is a hardy place. If you let it, it can shape you into a weapon.$b$BSpeak with me if you grow tired of chopping down trees.$b$BWith a bit of coin we can replace this lumber yard with a prized sparring arena.','',26124),
(87575,'enUS','Build the Sparring Arena instead.','Build the Sparring Arena instead.',26124),
(87576,'enUS','That sparring arena of yours is way too sweaty and violent for my tastes.$b$bNow, if you want something that is more practical, then I got what ye need!$b$bWe could build a big ol\' lumber yard with what I got in me mole machine.$b$bI think I even have the schematics for a goblin mechano-shredder.$b$bYou get the coin together an\' I can build it for ya.','',26124),
(87577,'enUS','I\'m not much use in a sparring arena. But if ya fancy a lumber yard, I\'m yer dwarf.$b$bCome see me when you are a bit more experienced an\' finished your Iron Horde vendetta.','',26124),
(87578,'enUS','Build a Lumber Yard instead.','Build a Lumber Yard instead.',26124),
(87579,'enUS','You want a garrison.$B$BI know.','',26124),
(87580,'enUS','Commander, I have no interest in lumber or the collection of wood.$b$bSee me when you have completed your tasks with the Iron Horde, and perhaps after you have gained more experience in combat.$b$bWith a bit of coin I could have this lumber yard removed and replaced with a sparring arena you would be proud of.','',26124),
(87581,'enUS','Create a garrison for me.','Create a garrison for me.',26124),
(87582,'enUS','Upgrade my garrison to the next tier.','Upgrade my garrison to the next tier.',26124),
(87583,'enUS','What are you waiting for? Let\'s catch some fish!','What are you waiting for? Let\'s catch some fish!',26124),
(87584,'enUS','Can I get another Hookshot Bait?','Can I get another Hookshot Bait?',26124),
(87585,'enUS','I need a set of blueprints for all of the Tier 1 and Tier 2 buildings.','I need a set of blueprints for all of the Tier 1 and Tier 2 buildings.',26124),
(87586,'enUS','I need a way to finish under construction garrison buildings instantly.','I need a way to finish under construction garrison buildings instantly.',26124),
(87587,'enUS','','What do you need, commander?',26124),
(87588,'enUS','Are you ready to join up, Nat? I can\'t wait for you to join the team!','Are you ready to join up, Nat? I can\'t wait for you to join the team!',26124),
(87589,'enUS','Fortune shine on me.','Fortune shine on me.',26124),
(87590,'enUS','I could always use a little luck.','I could always use a little luck.',26124),
(87591,'enUS','Couldn\'t hurt.','Couldn\'t hurt.',26124),
(87592,'enUS','I\'m feeling lucky!','I\'m feeling lucky!',26124),
(87593,'enUS','Give me more garrison materials.','Give me more garrison materials.',26124),
(87594,'enUS','I need some followers for my garrison.','I need some followers for my garrison.',26124),
(87595,'enUS','Take me to Stormshield in Ashran.','Take me to Stormshield in Ashran.',26124),
(87596,'enUS','Nisha is willing to take you to the den of the ogron if you are in need.','',26124),
(87597,'enUS','Incoming target!','Incoming target!',26124),
(87598,'enUS','Target to the northeast!','Target to the northeast!',26124),
(87599,'enUS','Target to the northwest.','Target to the northwest.',26124),
(87600,'enUS','Didn\'t stand a chance!','Didn\'t stand a chance!',26124),
(87601,'enUS','Aim!','Aim!',26124),
(87602,'enUS','Prepare to fire!','Prepare to fire!',26124),
(87603,'enUS','FIRE!','FIRE!',26124),
(87604,'enUS','BOOM!','BOOM!',26124),
(87605,'enUS','Looks like we are having seared clefthoof tonight!','Looks like we are having seared clefthoof tonight!',26124),
(87606,'enUS','I can\'t believe we are getting paid for this.','I can\'t believe we are getting paid for this.',26124),
(87607,'enUS','Where do they keep coming from?','Where do they keep coming from?',26124),
(87608,'enUS','','Commander! Oh wow, didn\'t expect to see you out here. Would you like to trade for some blueprints?',26124),
(87609,'enUS','','Such and honor to serve you, $GSir:Madam;. Wait till I tell the others.',26124),
(87610,'enUS','I\'m almost done with my shift. You want to grab a steak over at Elton Black\'s place? I heard he kills the cow right in front of you so you know it\'s fresh.','',26124),
(87611,'enUS','We don\'t have much more time! Everyone, get to high ground!','',26124),
(87612,'enUS','Hot stuff coming through!','',26124),
(87613,'enUS','Cho\'gall has escaped! The city is in chaos!','',26124),
(87614,'enUS','Better luck next time.','Better luck next time.',26124),
(87615,'enUS','Coming here today was a poor choice.','Coming here today was a poor choice.',26124),
(87616,'enUS','Enjoy the afterlife, $n.','Enjoy the afterlife, $n.',26124),
(87617,'enUS','Your efforts have failed you, $n!','Your efforts have failed you, $n!',26124),
(87618,'enUS','$R\'s like you should know better than to challenge me.','$R\'s like you should know better than to challenge me.',26124),
(87619,'enUS','May your spirit rest in peace.','May your spirit rest in peace.',26124),
(87620,'enUS','Prepare to battle the ogres.','Prepare to battle the ogres.',26124),
(87621,'enUS','Prepare to battle the ogres.','Prepare to battle the ogres.',26124),
(87622,'enUS','Prepare to battle the Gorens.','Prepare to battle the Gorens.',26124),
(87623,'enUS','Prepare to battle the Iron Horde.','Prepare to battle the Iron Horde.',26124),
(87624,'enUS','Prepare to battle the Primals.','Prepare to battle the Primals.',26124),
(87625,'enUS','Sergeant, ogres storm toward our front gate.','Sergeant, ogres storm toward our front gate.',26124),
(87626,'enUS','What\'s that sound? It\'s like a stampede...','',26124),
(87627,'enUS','Sound the alarm! Prepare for a frontal assault!','',26124),
(87628,'enUS','To arms! To your posts! Our fight today is with ogres.','',26124),
(87629,'enUS','Stand firm, soldiers. Draenor ogres are not unlike Azeroth\'s.','',26124),
(87630,'enUS','Remember when they die, don\'t let them fall on you.','',26124),
(87631,'enUS','No more at the front gate....','',26124),
(87632,'enUS','Spread out! Protect the structures!','',26124),
(87633,'enUS','That took care of the lesser ogres.','',26124),
(87634,'enUS','Is he going to fit through the gate? Charge! For the Alliance!','',26124),
(87635,'enUS','What the... THIEF!','What the... THIEF!',26124),
(87636,'enUS','Whoa! You are here too? Phew... I was starting to think I made a bad call. I\'m ready to win this war for the Alliance, $GSir:Madam;!','',26124),
(87638,'enUS','','You know I\'m a vegetarian right?',26124),
(87639,'enUS','You will not join the red? Then you will die!','',26124),
(87640,'enUS','The inn is this way, commander.','',26124),
(87641,'enUS','I will show them! I will show them all my power!','',26124),
(87642,'enUS','','Welcome, commander. Please let me know if there is anything I can do to make your stay more comfortable.',26124),
(87643,'enUS','Just a second, pal. Can\'t you see I\'m busy here?','',26124),
(87644,'enUS','We have come far since our journey began, but we always have more to do.','',26124),
(87645,'enUS','May the Raven Mother keep you under her wing!','May the Raven Mother keep you under her wing!',26124),
(87646,'enUS','Praise the Raven Mother!','Praise the Raven Mother!',26124),
(87647,'enUS','The Raven Mother bless you!','The Raven Mother bless you!',26124),
(87648,'enUS','%s emerges!','',26124),
(87649,'enUS','','Speak with Dungar when you are ready to fly to Ashran.',26124),
(87650,'enUS','Come one, come all. Witness fights to the death in the one and only Ring of Blood! Today we have $n and $Ghis:her; pals foolishly going up against Skull Chewer! Time for some more skulls, buddy!','',26124),
(87651,'enUS','Let the fight begin!','',26124),
(87652,'enUS','Me grandpa Gygax trained me when I was just a lad. Ye won\'t be finding a better warrior in these parts. I can promise ye that.','',26124),
(87653,'enUS','Everyone is a little on edge with the Iron Horde\'s presence looming. Your visit here is much appreciated.','',26124),
(87654,'enUS','Delvar Ironfist is just up the hill. He\'s surly, but his passion for battle is palpable.','',26124),
(87655,'enUS','It\'s that time again, folks. Come watch hopeful gladiators lay their lives on the line for your enjoyment! This match will be $n and $Ghis:her; friends against the impenetrable Fracktus! No weapon can pierce his granite hide!','',26124),
(87656,'enUS','Just point me in the direction of the Iron Horde. I\'ll take care of the rest.','',26124),
(87657,'enUS','Once the mages opened up the portal from Stormwind this place really started to boom. We probably have the greatest assembly of vendors and trade goods this side of Draenor.','',26124),
(87658,'enUS','Lieutenant Howell has done an excellent job pulling this staging area together.','',26124),
(87659,'enUS','Lieutenant Howell is just inside. It\'s been a pleasure serving you, commander.','',26124),
(87660,'enUS','Dead $Gman:woman; walking, folks. $n and $Ghis:her; allies are entering the world famous Ring of Blood to test themselves versus Rotvine, living weapon of destruction! This will be a slaughter to see!','',26124),
(87661,'enUS','$n and $Ghis:her; allies want to prove their worth against Mogor\'s prize beast: Dreshax, the Corpse Mauler! This worm has consumed the bones of countless fallen hopefuls - can $n come out of this alive?','',26124),
(87662,'enUS','No! He will awaken!','',26124),
(87663,'enUS','We have not yet purified the water!','',26124),
(87664,'enUS','We are all... doomed.','',26124),
(87665,'enUS','The bindings no longer hold me...','',26124),
(87666,'enUS','Now all shall die!','',26124),
(87667,'enUS','Life essence...','',26124),
(87668,'enUS','No! Stay back!','',26124),
(87669,'enUS','','Let\'s see your skill at arms!',26124),
(87670,'enUS','Ah, a $c. Would you like to participate in today\'s lecture?$b$bI am in need of a volunteer.','',26124),
(87671,'enUS','Volunteer.','Volunteer.',26124),
(87672,'enUS','Thank you, commander.','Thank you, commander.',26124),
(87673,'enUS','Commander.','Commander.',26124),
(87674,'enUS','We shall use the orb to contact Anzu. But first, I believe its power can help us save lives here...','',26124),
(87675,'enUS','What have they... done to me...','',26124),
(87676,'enUS','The voices... they\'re stopping...','',26124),
(87677,'enUS','The fog is lifting... where am I?','',26124),
(87678,'enUS','Thank you... I can still walk.','',26124),
(87679,'enUS','My wings! My beautiful wings!','',26124),
(87680,'enUS','They will pay for this...','',26124),
(87681,'enUS','This power... I must have more!','',26124),
(87682,'enUS','Sethe has chosen me!','',26124),
(87683,'enUS','I am reborn...','',26124),
(87684,'enUS','A new way... yes...','',26124),
(87685,'enUS','I see my fate...','',26124),
(87686,'enUS','Bwagh! Your face makes me ANGRY!','',26124),
(87687,'enUS','Rargh!!','',26124),
(87688,'enUS','I\'m going to crush you!','',26124),
(87689,'enUS','Grarrgh! Your skull needs crushing!','',26124),
(87690,'enUS','I\'m gonna punch your head in!','',26124),
(87691,'enUS','Grargh! Crush the weakling!','',26124),
(87692,'enUS','I hope you like dying! GRAAGH!','',26124),
(87693,'enUS','Now I gonna break you!','',26124),
(87694,'enUS','Boss, I got the recent threats sketched out on the table for ya whenever you be ready.','',26124),
(87695,'enUS','It\'s in my head, $p! I can\'t control myself! Kill me before I spread the disease!','',26124),
(87696,'enUS','Ogres and ogrettes, history is being made today at the world famous Ring of Blood! Mogor, reigning champion of the ring, is going to defend his title against the likes of $n and $Ghis:her; friends. This will be a fight to see!','',26124),
(87697,'enUS','We must hurry, $p! I have to get there now!','',26124),
(87698,'enUS','You dare challenge me in MY arena? You are a fool.','',26124),
(87699,'enUS','I will make you beg for mercy, and will show you none.','',26124),
(87700,'enUS','Pour it on!','Pour it on!',26124),
(87701,'enUS','Reminds me of that Stranglethorn campaign, years ago.','Reminds me of that Stranglethorn campaign, years ago.',26124),
(87702,'enUS','I feel like a gardener killing weeds.','I feel like a gardener killing weeds.',26124),
(87703,'enUS','MEATBALL GETTING HUNGRY!','',26124),
(87704,'enUS','MEATBALL READY TO FIGHT!','',26124),
(87705,'enUS','MEATBALL KILL!','',26124),
(87706,'enUS','These plants remind me of Orgrimmar....','These plants remind me of Orgrimmar....',26124),
(87707,'enUS','MEATBALL WANT TO FIGHT YOU!','',26124),
(87708,'enUS','MEATBALL EAT WHAT MEATBALL WANT!','',26124),
(87709,'enUS','They\'re weakening.','They\'re weakening.',26124),
(87710,'enUS','MEATBALL KILL WHAT MEATBALL WANT!','',26124),
(87711,'enUS','MEATBALL NO LOSE!','',26124),
(87712,'enUS','','There is still so much we do not know about this world. The Iron Horde have been here far longer than we, and their allies have lived here for generations.$B$BThey know more about this artifact\'s powers than we do. If we are to succeed, we must press every advantage.',26124),
(87713,'enUS','MEATBALL GET SNACK NOW!','',26124),
(87714,'enUS','MEATBALL READY TO FIGHT!','',26124),
(87715,'enUS','MEATBALL HUNGRY!','',26124),
(87716,'enUS','MEATBALL BELLY GURGLE!','',26124),
(87717,'enUS','MEATBALL TUMMY RUMBLE!','',26124),
(87718,'enUS','MEATBALL LIKE TO FIGHT!','',26124),
(87719,'enUS','BURP...','',26124),
(87720,'enUS','|TInterface\\Icons\\Spell_Arcane_Blink:20|t%s casts |cFFFF0000|Hspell:163359|h[Arcane Fragment]|h|r!','',26124),
(87721,'enUS','|TInterface\\Icons\\Spell_Arcane_Arcane04:20|t%s casts |cFFFF0000|Hspell:163372|h[Arcane Volatility]|h|r!','',26124),
(87722,'enUS','','You\'ll regret this.',26124),
(87723,'enUS','','This garrison will not fall!',26124),
(87724,'enUS','','I wield powers from beyond.',26124),
(87725,'enUS','','Taste my power.',26124),
(87726,'enUS','','Step back before I turn you to ash!',26124),
(87727,'enUS','','Taste the fury of the sun!',26124),
(87728,'enUS','','For the Horde!',26124),
(87729,'enUS','','Come closer... and burn!',26124),
(87730,'enUS','','Nice try.',26124),
(87731,'enUS','','You deserved that.',26124),
(87732,'enUS','','One down.',26124),
(87733,'enUS','','Who\'s next?',26124),
(87734,'enUS','','You do not belong!',26124),
(87735,'enUS','','For the Horde!',26124),
(87736,'enUS','','I tried to warn you.',26124),
(87737,'enUS','|TInterface\\Icons\\Spell_Arcane_FocusedPower:20|t%s casts |cFFFF0000|Hspell:163297|h[Arcane Twisted]|h|r at $n!','',26124),
(87738,'enUS','','You are weak.',26124),
(87739,'enUS','','Bal\'a dash, malanore.',26124),
(87740,'enUS','','Anu belore dela\'na.',26124),
(87741,'enUS','','I am yours to command.',26124),
(87742,'enUS','','This is not the version of this world I know.',26124),
(87743,'enUS','','My power is yours, commander.',26124),
(87744,'enUS','','I am sworn to you, commander.',26124),
(87745,'enUS','','Andu fallah.',26124),
(87746,'enUS','','Our destiny awaits, commander.',26124),
(87747,'enUS','','It\'s so... cold...',26124),
(87748,'enUS','','For Auchindoun!',26124),
(87749,'enUS','','You do not belong here.',26124),
(87750,'enUS','','Souls of Auchenai past, guide my hand!',26124),
(87751,'enUS','','A million draenei souls stand by my side, fiend.',26124),
(87752,'enUS','','We\'re under attack. Protect the unarmed!',26124),
(87753,'enUS','','I will not let you harm the innocent.',26124),
(87754,'enUS','','Step no further!',26124),
(87755,'enUS','','I won\'t let you take another innocent life!',26124),
(87756,'enUS','','Your soul was too weak.',26124),
(87757,'enUS','','You do not deserve the gift of life.',26124),
(87758,'enUS','','Be gone with you!',26124),
(87759,'enUS','','Such dark souls.',26124),
(87760,'enUS','','Ashes to ashes.',26124),
(87761,'enUS','','Your soul departs this realm.',26124),
(87762,'enUS','','Forever hold your peace, heathen.',26124),
(87763,'enUS','Ride Nisha to your outpost.','Ride Nisha to your outpost.',26124),
(87764,'enUS','','Dust to dust.',26124),
(87765,'enUS','','Your soul burns brightly as always!',26124),
(87766,'enUS','','How go your exploits?',26124),
(87767,'enUS','','At your service.',26124),
(87768,'enUS','','The spirits smile upon you, commander.',26124),
(87769,'enUS','','Anything I can help you with?',26124),
(87770,'enUS','','Together we will never falter against the darkness.',26124),
(87771,'enUS','','The Light guides us always, commander.',26124),
(87772,'enUS','','It\'s good to see you, commander.',26124),
(87773,'enUS','','Auchindoun... I am coming...',26124),
(87774,'enUS','For $p! Charge!','',26124),
(87775,'enUS','Show me what you\'ve got.','',26124),
(87776,'enUS','Maybe you\'ll put up an actual fight.','',26124),
(87777,'enUS','Form up! We\'ve got company.','',26124),
(87778,'enUS','Brace yourselves. Hostiles incoming!','',26124),
(87779,'enUS','You will go no further!','',26124),
(87780,'enUS','We fight for the Alliance!','',26124),
(87781,'enUS','I will show you no quarter, fiend!','',26124),
(87782,'enUS','Not on my watch.','',26124),
(87783,'enUS','This garrison will not fall!','',26124),
(87784,'enUS','None can stand against the might of the Alliance.','',26124),
(87785,'enUS','Over my dead body.','',26124),
(87786,'enUS','Victory shall be ours today!','',26124),
(87787,'enUS','For $p. For the Alliance!','',26124),
(87788,'enUS','You\'ll have to try harder than that.','',26124),
(87789,'enUS','Another one bites the dust.','',26124),
(87790,'enUS','Good to see you, $n.','',26124),
(87791,'enUS','Our enemies stand no chance against the both of us.','',26124),
(87792,'enUS','At your service, commander.','',26124),
(87793,'enUS','Care to swap some old war stories?','',26124),
(87794,'enUS','Any sign of the Horde?','',26124),
(87795,'enUS','For the Alliance, always and forever.','',26124),
(87796,'enUS','The Light guides us to victory.','',26124),
(87797,'enUS','I\'ll fight by your side through anything.','',26124),
(87798,'enUS','The Alliance... will live on...','',26124),
(87799,'enUS','New plaything!','',26124),
(87800,'enUS','Know the might of the Iron Horde!','',26124),
(87801,'enUS','Who interrupts the harvest?','',26124),
(87802,'enUS','These savages will eat anything!','These savages will eat anything!',26124),
(87803,'enUS','To arms! To arms!','To arms! To arms!',26124),
(87804,'enUS','Danger is close!','Danger is close!',26124),
(87805,'enUS','Get the townsfolk to safety.','Get the townsfolk to safety.',26124),
(87806,'enUS','I want to recruit guards from other lands.','I want to recruit guards from other lands.',26124),
(87807,'enUS','If you are exalted by Ironforge, Darnassus, Gnomeregan, Exodar, Gilneas, the Tushui pandaren, or if you are a Death Knight exalted by the Knights of the Ebon Blade, you can recruit guards from their respective ranks by speaking to the corresponding recruiting officer in the Town Hall.','If you are exalted by Ironforge, Darnassus, Gnomeregan, Exodar, Gilneas, the Tushui pandaren, or if you are a Death Knight exalted by the Knights of the Ebon Blade, you can recruit guards from their respective ranks by speaking to the corresponding recruiting officer in the Town Hall.',26124),
(87808,'enUS','Graveltooth gonna make you sorry for hurting the munchkins! Rarrggh!','',26124),
(87809,'enUS','Grrrggh! Graveltooth no like it when you kill the munchkins!','',26124),
(87810,'enUS','The Raven Mother watches over the flock once again!$b$bWe could not have done this without you, $n.$b$bWe will always remember the outsider who helped us in our time of need.','',26124),
(87811,'enUS','MEATBALL GETTING TIRED!','',26124),
(87812,'enUS','MEATBALL STILL HUNGRY!','',26124),
(87813,'enUS','MEATBALL BUTT ITCHY!','',26124),
(87814,'enUS','MEATBALL VOICE HURT MEATBALL EAR!','',26124),
(87815,'enUS','MEATBALL READY TO STOP FIGHTING!','',26124),
(87816,'enUS','Dis\' is a big one, mon!','',26124),
(87817,'enUS','I\'ll gut ya like a fat eel!','',26124),
(87818,'enUS','You take da bait, I reel ya in!','',26124),
(87819,'enUS','Dis one\'s a fighta!','',26124),
(87820,'enUS','You gon\' be bait for my next big catch!','',26124),
(87821,'enUS','Lookin\' like we got some more chum!','',26124),
(87822,'enUS','No catch and release for you, mon!','',26124),
(87823,'enUS','I could kill a hundred of you at once!','',26124),
(87824,'enUS','This can hardly be called a battle...','',26124),
(87825,'enUS','I will end your worthless life!','',26124),
(87826,'enUS','Your pathetic life is over.','',26124),
(87827,'enUS','Your death will be forgotten quickly...','',26124),
(87828,'enUS','Barely worth the effort.','',26124),
(87829,'enUS','You wanna know da\' secret to catching the lunkers mon? Voodoo!','',26124),
(87830,'enUS','Catch anything lately, boss man?','',26124),
(87831,'enUS','This camp could use discipline, commander.','',26124),
(87832,'enUS','','Hey stranger! I\'m good at fixing stuff. Do you want me to take a look?',26124),
(87833,'enUS','','Someday I\'m going to be a hero, too!',26124),
(87834,'enUS','Give me troops, commander, and I will give you the Gorian Empire!','',26124),
(87835,'enUS','Been workin on a new rod, mon, but I can\'t think of a good name. Maybe \"Abu\'gar\'s Vivaciousness?\"','',26124),
(87836,'enUS','You have orders, sir?','',26124),
(87837,'enUS','Nothin\' doin\' today, mon. I guess that\'s why they call it fishin\' and not catchin\'.','',26124),
(87838,'enUS','Is there a foe worth crushing, commander?','',26124),
(87839,'enUS','You wanna know da best way ta fish? Trollin\'.','',26124),
(87840,'enUS','My line neva break, mon. I be makin it from braided Dwarf beard hair.','',26124),
(87841,'enUS','To die so far... from home...','',26124),
(87842,'enUS','Not the end... I had imagined...','',26124),
(87843,'enUS','It... got... away...','',26124),
(87844,'enUS','','After seeing you and Rexxar in action, I hope to learn more of combat from each of you.',26124),
(87845,'enUS','Rarrgh! You kill munchkins and Graveltooth gonna kill you back!','',26124),
(87846,'enUS','Die!','',26124),
(87848,'enUS','You\'ll make a fine meal for the ravagers.','',26124),
(87849,'enUS','Kill!','',26124),
(87850,'enUS','I\'m searching for Owynn Graddock. Take me to Frostfire Ridge.','I\'m searching for Owynn Graddock. Take me to Frostfire Ridge.',26124),
(87851,'enUS','Take me to Ashran.','Take me to Ashran.',26124),
(87852,'enUS','Face me, and we will see who is stronger.','',26124),
(87853,'enUS','My new Blood Champion has been crowned. Bow before $n, for $Ghe:she; has proven $Ghimself:herself; worthy of my favor in the arena.','',26124),
(87854,'enUS','Enough! I will not stand by and watch my prized beasts fall. I will show them true strength.','',26124),
(87855,'enUS','Much thanks again, mon, for gettin\' me back my gear. \n\nNow da fishes don\'t stand a chance against Abu\'gar!','',26124),
(87856,'enUS','For the light of Karabor.','',26124),
(87857,'enUS','My hammer should suffice.','',26124),
(87858,'enUS','Don\'t underestimate me!','',26124),
(87859,'enUS','Justice prevails.','',26124),
(87860,'enUS','Not on my watch.','',26124),
(87861,'enUS','You have been defeated!','',26124),
(87862,'enUS','I serve you, commander.','',26124),
(87863,'enUS','Do you need anything fixed, commander?','',26124),
(87864,'enUS','I should have... tried... harder...','',26124),
(87865,'enUS','','On guard!',26124),
(87866,'enUS','','It\'s a nice day for a fight.',26124),
(87867,'enUS','','Do you challenge me?',26124),
(87868,'enUS','','I hope you\'re ready for this.',26124),
(87869,'enUS','','That was easy.',26124),
(87870,'enUS','','I didn\'t even break a claw.',26124),
(87871,'enUS','','And stay down!',26124),
(87872,'enUS','','Greetings from Elune, commander.',26124),
(87873,'enUS','','May the stars shine upon you.',26124),
(87874,'enUS','','A beautiful day awaits us.',26124),
(87875,'enUS','','Ugh... it wasn\'t... enough...',26124),
(87876,'enUS','','Give me your best shot.',26124),
(87877,'enUS','','Do you think you can take me?',26124),
(87878,'enUS','','I know a dirty trick or two.',26124),
(87879,'enUS','','Hmm, just as I thought.',26124),
(87880,'enUS','','I made quick work of you.',26124),
(87881,'enUS','','Let that be a lesson to you.',26124),
(87882,'enUS','','Think twice before crossing me.',26124),
(87883,'enUS','','My skills are at your disposal, commander.',26124),
(87884,'enUS','','I am ready to serve.',26124),
(87885,'enUS','','Do you have a mission for me, commander?',26124),
(87886,'enUS','','I... did not... expect that...',26124),
(87887,'enUS','','I will try my best!',26124),
(87888,'enUS','','Let\'s fight fair!',26124),
(87889,'enUS','','We did it!',26124),
(87890,'enUS','','That wasn\'t so bad!',26124),
(87891,'enUS','','All right!',26124),
(87892,'enUS','','That was a close one!',26124),
(87893,'enUS','','Good day, commander!',26124),
(87894,'enUS','','What shall we do today?',26124),
(87895,'enUS','','Today is a beautiful day for an adventure.',26124),
(87896,'enUS','','Ouch...',26124),
(87897,'enUS','','Patience, sisters. The sooner we finish our work, the sooner we crush our enemies.',26124),
(87898,'enUS','','Sorka! Ensure the peons are keeping pace!',26124),
(87899,'enUS','','Marak! Load the ammunition into the main cannon!',26124),
(87900,'enUS','','What?! The trains are behind schedule?',26124),
(87901,'enUS','','Sorka! This isn\'t a game! Get down there!',26124),
(87902,'enUS','','You insufferable...',26124),
(87903,'enUS','Ohh, that\'s how you sweep the leg!','',26124),
(87904,'enUS','','Sisters, to battle!',26124),
(87905,'enUS','','Sisters, I... failed...',26124),
(87906,'enUS','Maybe I\'m not cut out for this.','',26124),
(87907,'enUS','I hope they don\'t catch me with this manual...','',26124),
(87908,'enUS','I can\'t wait to get my first real set of armor!','',26124),
(87909,'enUS','','None will stand against the Iron Horde!',26124),
(87910,'enUS','I\'ll show them what I\'m made of. I\'ll prove them all wrong!','',26124),
(87911,'enUS','','Enemy down.',26124),
(87912,'enUS','','Grenade out!',26124),
(87913,'enUS','','You will burn!',26124),
(87914,'enUS','','Lining up my sights...',26124),
(87915,'enUS','','Blood and Thunder!',26124),
(87916,'enUS','','Rapid fire!',26124),
(87917,'enUS','','... than battle to death!',26124),
(87918,'enUS','','Sorka! Man the cannon!',26124),
(87919,'enUS','','Marak! Let your aim be true.',26124),
(87920,'enUS','','Must I do everything myself?!',26124),
(87921,'enUS','','My pleasure.',26124),
(87922,'enUS','','I think I see the problem...',26124),
(87923,'enUS','','Let\'s see how well you\'ve trained our soldiers, Gar\'an.',26124),
(87924,'enUS','','Ha! What brutality, what bloodshed... Beautiful!',26124),
(87925,'enUS','','Don\'t worry, I\'m coming... this looks fun.',26124),
(87926,'enUS','','I\'m going to enjoy this...',26124),
(87927,'enUS','','It feels... so...',26124),
(87928,'enUS','','Oh, look. I broke it.',26124),
(87929,'enUS','','I\'m just too good.',26124),
(87930,'enUS','','Come closer!',26124),
(87931,'enUS','','Too slow!',26124),
(87932,'enUS','','Catch!',26124),
(87933,'enUS','','You...',26124),
(87934,'enUS','','...die now!',26124),
(87935,'enUS','','All will burn!',26124),
(87936,'enUS','','No greater pleasure...',26124),
(87937,'enUS','','Right.',26124),
(87938,'enUS','','Time to die.',26124),
(87939,'enUS','','My... blood...',26124),
(87940,'enUS','','Feast, Koloch na!',26124),
(87941,'enUS','','I win.',26124),
(87942,'enUS','','Koloch na, wind and blood!',26124),
(87943,'enUS','','Dance with my blade!',26124),
(87944,'enUS','','Death...',26124),
(87945,'enUS','','Ancestors, guide my axe...',26124),
(87946,'enUS','','You will know pain...',26124),
(87947,'enUS','','Lok\'tar ogar!',26124),
(87948,'enUS','What kind of fish is that? I have never seen anything like that before, get over here and let me check it out!','What kind of fish is that? I have never seen anything like that before, get over here and let me check it out!',26124),
(87949,'enUS','','I\'ll take you down!',26124),
(87950,'enUS','','Your death will be swift.',26124),
(87951,'enUS','','I won\'t go easy on you.',26124),
(87952,'enUS','','Just as you deserved.',26124),
(87953,'enUS','','The darkness closes in.',26124),
(87954,'enUS','','Do you need any killing, commander?',26124),
(87955,'enUS','','Send me to the front lines, commander.',26124),
(87956,'enUS','','My blade is at your call.',26124),
(87957,'enUS','','Jarrod... I will be with you... soon...',26124),
(87958,'enUS','','Do you seek your own death?',26124),
(87959,'enUS','','The eve of your demise is here.',26124),
(87960,'enUS','','I\'m looking forward to this.',26124),
(87961,'enUS','','Another kill.',26124),
(87962,'enUS','','An honorable fight.',26124),
(87963,'enUS','','Well fought, but not well enough.',26124),
(87964,'enUS','','Honor to you, commander.',26124),
(87965,'enUS','','Can I be of service today?',26124),
(87966,'enUS','','The elements are calling.',26124),
(87967,'enUS','','I was not strong... enough...',26124),
(87968,'enUS','I\'m your worst nightmare!','',26124),
(87969,'enUS','If it bleeds, we can kill it.','',26124),
(87970,'enUS','I will terminate you!','',26124),
(87971,'enUS','It\'s showtime.','',26124),
(87972,'enUS','You\'ve just been erased.','',26124),
(87973,'enUS','','My wrench, your face.',26124),
(87974,'enUS','Just plain zero.','',26124),
(87975,'enUS','Well that hit the spot.','',26124),
(87976,'enUS','','This is REALLY going to leave a mark.',26124),
(87977,'enUS','Iced that guy!','',26124),
(87978,'enUS','Who needs slaying, commander?','',26124),
(87979,'enUS','Today could use a little mayhem, what do you say?','',26124),
(87980,'enUS','','I don\'t go down that easily.',26124),
(87981,'enUS','Just point me at any ogres. I\'ll carve \'em up for you.','',26124),
(87982,'enUS','','Disassembly, required.',26124),
(87983,'enUS','Good to see you again, sir.','',26124),
(87984,'enUS','','Oops, I did it again.',26124),
(87985,'enUS','When\'s the next battle, commander?','',26124),
(87986,'enUS','','Sometimes I amaze even myself.',26124),
(87987,'enUS','I\'ll be back...','',26124),
(87988,'enUS','','Got any business leads today?',26124),
(87989,'enUS','','Come on, I\'m getting bored here. You have anything for me to do?',26124),
(87990,'enUS','','So what do you prefer, gunpowder or napalm? Me, I\'m a napalm girl.',26124),
(87991,'enUS','','What\'s up, commander?',26124),
(87992,'enUS','','Hey there commander, you here to give me a job or can we just skip straight to you giving me money?',26124),
(87993,'enUS','','Up... yours...',26124),
(87994,'enUS','','You march towards your grave.',26124),
(87995,'enUS','','Beautiful death awaits you.',26124),
(87996,'enUS','','Revel in your final moments.',26124),
(87997,'enUS','','Death is only the beginning.',26124),
(87998,'enUS','','Welcome to the Dark Lady\'s embrace.',26124),
(87999,'enUS','','The Dark Lady sends her regards.',26124),
(88000,'enUS','','Anything that needs killing, commander?',26124),
(88001,'enUS','','Any new assignments?',26124),
(88002,'enUS','','At your service, commander.',26124),
(88003,'enUS','','Good evening, commander.',26124),
(88004,'enUS','','Lovely evening for some killing, don\'t you think?',26124),
(88005,'enUS','','My staff is yours to command.',26124),
(88006,'enUS','','Death will come... to you too...',26124),
(88007,'enUS','Lok\'tar ogar!','',26124),
(88008,'enUS','Taste my blade.','',26124),
(88009,'enUS','You too will die by my blade.','',26124),
(88010,'enUS','Come, face me if you can.','',26124),
(88011,'enUS','This is a waste of my time.','',26124),
(88012,'enUS','Don\'t you know death by sight?','',26124),
(88013,'enUS','Finally, something to kill.','',26124),
(88014,'enUS','This will be quick','',26124),
(88015,'enUS','You were not worthy.','',26124),
(88016,'enUS','Is there no one to challenge me?','',26124),
(88017,'enUS','Your blood dishonors my blade.','',26124),
(88018,'enUS','At least you didn\'t run.','',26124),
(88019,'enUS','I salute you.','',26124),
(88020,'enUS','A clean death was more than you deserved.','',26124),
(88021,'enUS','Anyone else?','',26124),
(88022,'enUS','I yearn for a true adversary.','',26124),
(88023,'enUS','It\'s good to see you again, $n.','',26124),
(88024,'enUS','Lok-Regar. I am ready for something new.','',26124),
(88025,'enUS','Throm-Ka, $n.','',26124),
(88026,'enUS','I miss the grassy plains of Nagrand.','',26124),
(88027,'enUS','My blade hungers.','',26124),
(88028,'enUS','Honor is everything.','',26124),
(88029,'enUS','Any news of the Burning Blade?','',26124),
(88030,'enUS','How long must we stay in this \'garrison\' of yours?','',26124),
(88031,'enUS','It was... an... honor.','',26124),
(88032,'enUS','Leeroooooooy! Jeeeeenkins!','',26124),
(88033,'enUS','Time\'s up. Let\'s do this!','',26124),
(88034,'enUS','Great job, guys!','',26124),
(88035,'enUS','Sorry, did you say something?','',26124),
(88036,'enUS','Uh, what did you say?','',26124),
(88037,'enUS','We are pals for life.','',26124),
(88038,'enUS','It\'s not my fault.','',26124),
(88039,'enUS','At least I have chicken.','',26124),
(88040,'enUS','Stick to the plan, chums!','',26124),
(88041,'enUS','You seem surprised to see us here, $C. It is understandable. I am all too familiar with how the arakkoa have treated your people.\n\nThe Adherents of Rukhmar are savage creatures, and their lust for power can only lead to their downfall. We seek a different path.\n\nWe search for artifacts of the Apexis so that we may use them to initiate a peaceful new beginning for the arakkoa. In exchange for these relics, we offer finely crafted goods, which we hope you will find equal in value.\n\nWould you see it fit to aid us, $C?','',26124),
(88042,'enUS','','Don\'t be scared Rosie, we are safe here.',26124),
(88043,'enUS','Only da very best be fightin\' in the ring.','',26124),
(88044,'enUS','Find respite in the shadows.','',26124),
(88045,'enUS','','Shut your mouth, goblin, unless you want me to shut it for you. I just want a taste of this one\'s skill.',26124),
(88046,'enUS','Hey! No registered contenders in the ring, please!','',26124),
(88047,'enUS','','Someday, your blood will coat its edge. It is only a matter of time.',26124),
(88048,'enUS','I greet you, $C. We are the Order of the Awakened, and we represent the best interests of the arakkoa people.\n\nI am certain that you have witnessed the horrors brought upon the arakkoa and others by the Adherents of Rukhmar. We wish to reverse this damage and bring about a peaceful new era for our society. To do this, however, we require the knowledge of the Apexis.\n\nIf you wish to assist us, we will trade valuable items for any Apexis relics you happen upon. What say you, $C?','',26124),
(88049,'enUS','Lieutenant Kragil is just inside. It\'s been a pleasure serving you, commander.','',26124),
(88050,'enUS','','Everyone is a little on edge with the Iron Horde\'s presence looming. Your visit here is much appreciated.',26124),
(88051,'enUS','Commander! Oh wow, didn\'t expect to see you out here. While you\'re here, you wanna trade for some blueprints?','',26124),
(88052,'enUS','Boss-mon! Ya here too? Phew... I was startin\' ta tink I made da bad call. Let\'s win dis war for da Horde!','',26124),
(88053,'enUS','','It is done! As for you, I think it is fitting that one of my tools dispatches the others...',26124),
(88058,'enUS','','Vivianne is just down the hill. She\'s a bit of a pyro, but her passion for battle is palpable.',26124),
(88059,'enUS','','Welcome, commander. Please let me know if there is anything I can do to make your stay more comfortable.',26124),
(88060,'enUS','This is almost too easy!','',26124),
(88061,'enUS','An Imperial battalion would be done with this fight already!','',26124),
(88062,'enUS','The Emperor protects me!','',26124),
(88063,'enUS','No formations... no tactics... this is a brawl, not a battle!','',26124),
(88064,'enUS','','If you play with me, you are playing with fire... literally.',26124),
(88065,'enUS','And that\'s... one hundred.','',26124),
(88066,'enUS','','As you wish, commander. The Iron Horde will suffer.',26124),
(88067,'enUS','If only you had some skill.','If only you had some skill.',26124),
(88068,'enUS','Such a pity.','Such a pity.',26124),
(88069,'enUS','And to think... that could have been me.','And to think... that could have been me.',26124),
(88070,'enUS','A most unfortunate end.','A most unfortunate end.',26124),
(88071,'enUS','Your sacrifice is a valuable lesson to us all.','Your sacrifice is a valuable lesson to us all.',26124),
(88072,'enUS','My regards.','My regards.',26124),
(88073,'enUS','A noble sacrifice.','A noble sacrifice.',26124),
(88074,'enUS','May you rest in pieces.','May you rest in pieces.',26124),
(88075,'enUS','','For the fallen!',26124),
(88076,'enUS','','This\'ll be easier than working the forge.',26124),
(88077,'enUS','','In memory of Ared!',26124),
(88078,'enUS','','I will not let you pass!',26124),
(88079,'enUS','','Begone!',26124),
(88080,'enUS','','Shoddy equipment, shoddy fighting.',26124),
(88081,'enUS','','With gear that poor I\'m not surprised you lost.',26124),
(88082,'enUS','','And stay down!',26124),
(88083,'enUS','','Hello commander. Do you have need of my skills?',26124),
(88084,'enUS','','My skills are at your command.',26124),
(88085,'enUS','','Does this weapon match my horns? I\'m trying to color coordinate.',26124),
(88086,'enUS','','This beats working at a forge in some dusty old city.',26124),
(88087,'enUS','','Ared, I join you... at last...',26124),
(88088,'enUS','Really? You\'re going to fight me with THAT? Hah!','',26124),
(88089,'enUS','Time to test my latest weapon!','',26124),
(88090,'enUS','Pathetic.','',26124),
(88091,'enUS','Nothing worth looting here.','',26124),
(88092,'enUS','Didn\'t even leave a scratch on my weapon.','',26124),
(88093,'enUS','Need me to make you anything?','',26124),
(88094,'enUS','Forge or field, commander?','',26124),
(88095,'enUS','Seen any sign of the Iron Horde? I could use their gear for scrap metal.','',26124),
(88096,'enUS','Not... yet...','',26124),
(88097,'enUS','STOP. There is no courage in attacking others here.','',26124),
(88098,'enUS','What\'s wrong with you?!','',26124),
(88099,'enUS','A Warrior of the Light will not just sit and take it!','',26124),
(88100,'enUS','Hrgraaah!','',26124),
(88101,'enUS','I have no choice!','',26124),
(88102,'enUS','You are quite stubborn.','',26124),
(88103,'enUS','Ohh, ohhh...','',26124),
(88104,'enUS','In your last moments, think upon what you have accomplished.','',26124),
(88105,'enUS','In the name of the Light!','',26124),
(88106,'enUS','Now you shall know the brilliance of our Light!','',26124),
(88107,'enUS','Yes, I did it... I did!','',26124),
(88108,'enUS','I am the Light!','',26124),
(88109,'enUS','Hah hah hah!','',26124),
(88110,'enUS','Ahh, it\'s over...','',26124),
(88111,'enUS','Exhilarating, is it not?','',26124),
(88112,'enUS','This place is sacred and you are NOT welcome here.','',26124),
(88113,'enUS','Magnificent!','',26124),
(88114,'enUS','Praise the Light!','',26124),
(88115,'enUS','No need to hide your reaction. I get that look all the time!','',26124),
(88116,'enUS','We are surrounded by strange beings, in a strange land...','',26124),
(88117,'enUS','The flow of time itself is twisted...','',26124),
(88118,'enUS','Let us engage in joyous collaboration!','',26124),
(88119,'enUS','If only I could be so utterly luminescent!','',26124),
(88120,'enUS','I am honored to have found such a brave companion!','',26124),
(88121,'enUS','You really are fond of conversing with me, aren\'t you?','',26124),
(88122,'enUS','Ahh, it\'s over...','',26124),
(88123,'enUS','My light... it\'s fading...','',26124),
(88124,'enUS','It\'s dark, so dark...','',26124),
(88125,'enUS','Miss Chi-Yuan possesses a talent in inscription which I can only hope to one day achieve.\n\nIf you wish to be trained on the subject, there is no finer instructor than she.','',26124),
(88126,'enUS','I am not finished!','',26124),
(88127,'enUS','For my family!','',26124),
(88128,'enUS','I will not let you attack this place.','',26124),
(88129,'enUS','I have unfinished business.','',26124),
(88130,'enUS','You do not belong here.','',26124),
(88131,'enUS','I will not falter!','',26124),
(88132,'enUS','Commander, enemies over here!','',26124),
(88133,'enUS','You will not leave this place alive.','',26124),
(88134,'enUS','I\'ll see you on the other side.','',26124),
(88135,'enUS','Join me in the spirit realm.','',26124),
(88136,'enUS','Your kind will plague this world no longer.','',26124),
(88137,'enUS','What did you expect to do, kill me?','',26124),
(88138,'enUS','My spirit stands strong!','',26124),
(88139,'enUS','Is that all you\'ve got?','',26124),
(88140,'enUS','Put some effort into it at least.','',26124),
(88141,'enUS','My family will no longer live in fear of the likes of you.','',26124),
(88142,'enUS','Greetings, commander.','',26124),
(88143,'enUS','I will not rest until the Iron Horde is destroyed.','',26124),
(88144,'enUS','I am in your debt, commander.','',26124),
(88145,'enUS','We will defeat the Iron Horde together, commander.','',26124),
(88146,'enUS','Any sign of the Iron Horde, commander?','',26124),
(88147,'enUS','Blademaster Bralok will torment my family no longer, thanks to you.','',26124),
(88148,'enUS','I am bound to you, commander.','',26124),
(88149,'enUS','It is calm, commander. Too calm.','',26124),
(88150,'enUS','Peace... at last...','',26124),
(88151,'enUS','Give Rooby Roo a Rooby Reat.','Give Rooby Roo a Rooby Reat.',26124),
(88152,'enUS','Cut!','',26124),
(88153,'enUS','Thrust!','',26124),
(88154,'enUS','Block!','',26124),
(88155,'enUS','Tell me what you know!','',26124),
(88156,'enUS','HA! So much fun to torture you weaklings.','',26124),
(88157,'enUS','I take such pleasure in my job.','',26124),
(88158,'enUS','The local draenei have been indispensable allies in our fight here in Ashran. \n\nSo long as we keep a steady stream of supplies from the mainland, our victory is assured!','',26124),
(88159,'enUS','','Your cause on Ashran is just, and the draenei will assist in any way we can.',26124),
(88160,'enUS','People always wonder how a Worgen becomes a stablehand, but the truth is, I\'ve been doing this long before I got afflicted. Just leave your pets with ol\' Orville and I\'ll take good care of them.\n\nAnd before you ask, yes, I promise I won\'t eat them.','',26124),
(88161,'enUS','Let us get to work.','',26124),
(88162,'enUS','In killing Sethe, Anzu was the first to bear his dying curse.','',26124),
(88163,'enUS','As he grappled with the curse, Anzu commanded his dread ravens to eradicate the brood of Sethe.','',26124),
(88164,'enUS','$gSir:Ma\'am;, I have some recent threats sketched out on the map here whenever you\'re ready.','',26124),
(88165,'enUS','|cFF3ADF00+5% Progress!|r','|cFF3ADF00+5% Progress!|r',26124),
(88166,'enUS','You are afflicted with |TInterface\\Icons\\spell_burningbladeshaman_molten_torrent.blp:20|t |cFFFF0404|Hspell:154938|h[Molten Torrent]|h|r!','You are afflicted with |TInterface\\Icons\\spell_burningbladeshaman_molten_torrent.blp:20|t |cFFFF0404|Hspell:154938|h[Molten Torrent]|h|r!',26124),
(88167,'enUS','Pleasure-Bot 8000, engaging.','',26124),
(88168,'enUS','Your systems appear to be malfunctioning.','',26124),
(88169,'enUS','Activating defense mechanisms.','',26124),
(88170,'enUS','Intruder!','',26124),
(88171,'enUS','In the name of my Commander!','',26124),
(88172,'enUS','Your skills were found to be lacking.','',26124),
(88173,'enUS','Target deactivated.','',26124),
(88174,'enUS','The pleasure was mine.','',26124),
(88175,'enUS','Your service is no longer required.','',26124),
(88176,'enUS','I was made to serve!','',26124),
(88177,'enUS','Need some assistance?','',26124),
(88178,'enUS','Greetings, commander. May I interest you in a massage?','',26124),
(88179,'enUS','Greetings! Allow me to assist you!','',26124),
(88180,'enUS','It\'s my... pleasure to serve you!','',26124),
(88181,'enUS','Commander, your clothing appears to be dirty. Allow me to clean them for you.','',26124),
(88182,'enUS','Entering shutdown mode...','',26124),
(88183,'enUS','Systems... overload...','',26124),
(88184,'enUS','Pl... pleas... pleasure serving...','',26124),
(88185,'enUS','My people have been held captive for too long by these creatures.','',26124),
(88186,'enUS','In one bloody night, the children of Sethe were eradicated.','',26124),
(88187,'enUS','','Hey! Wadda ya think ya doin\' here?',26124),
(88188,'enUS','','I may be small, but I pack a punch!',26124),
(88189,'enUS','','I knew I shoulda brought some dynamite!',26124),
(88190,'enUS','It seems the wind serpents, like their master, refuse to stay dead.','',26124),
(88191,'enUS','','Looks like someone needs some explodin\'!',26124),
(88192,'enUS','','Hey, you! Over here, busta!',26124),
(88193,'enUS','','Kaaa-blooouuiiieeeee!',26124),
(88194,'enUS','','Ha ha ha ha! Another one down!',26124),
(88195,'enUS','','Shoulda stayed home today, friend!',26124),
(88196,'enUS','','Woah... that had to hurt!',26124),
(88197,'enUS','','Add another to my tally.',26124),
(88198,'enUS','','Don\'t let the eye patch fool ya. I see everything!',26124),
(88199,'enUS','','Need somethin\', commander?',26124),
(88200,'enUS','','Hey there!',26124),
(88201,'enUS','','This... ain\'t... over...',26124),
(88202,'enUS','','Always figured I\'d go out with a bang...',26124),
(88203,'enUS','Sorry hon, we need more room in this place before we start considering what else to build.  Come back once you upgrade to tier 2, then we can talk specifics.','Sorry hon, we need more room in this place before we start considering what else to build.  Come back once you upgrade to tier 2, then we can talk specifics.',26124),
(88204,'enUS','Sorry boss, Gazlowe says this place needs to be bigger before we think about remodeling.  Come back once you upgrade to tier 2 and I will show ya what I got.','Sorry boss, Gazlowe says this place needs to be bigger before we think about remodeling.  Come back once you upgrade to tier 2 and I will show ya what I got.',26124),
(88205,'enUS','Soaking','Soaking',26124),
(88206,'enUS','Are you ready for a real battle?','',26124),
(88207,'enUS','I am ready!','I am ready!',26124),
(88208,'enUS','Scaly vermin!','',26124),
(88209,'enUS','I am at your service, $g master:mistress;.','',26124),
(88210,'enUS','Phylarch, I need more Everbloom seeds.','Phylarch, I need more Everbloom seeds.',26124),
(88211,'enUS','Out of seeds?$B$BIn exchange for the timber you are stealing from the land I will grant you another packet.','',26124),
(88212,'enUS','','Light \'em up!',26124),
(88213,'enUS','No, the ritual doesn\'t go like that! Try again.','',26124),
(88214,'enUS','Wrong! Every mistake weakens the ritual. Quickly, do what I said and we might be able to salvage this.','',26124),
(88215,'enUS','By the Raven Mother... are you paying attention? Try again.','',26124),
(88216,'enUS','No, that isn\'t right. Let\'s try again.','',26124),
(88217,'enUS','Put your backs into it!','Put your backs into it!',26124),
(88218,'enUS','Blackhand won\'t stand for this pace! Pick it up!','Blackhand won\'t stand for this pace! Pick it up!',26124),
(88219,'enUS','DIG! DIG! We need this ore!','DIG! DIG! We need this ore!',26124),
(88220,'enUS','Good work men! Keep it up!','Good work men! Keep it up!',26124),
(88221,'enUS','Prepare to battle the Shadow Council.','Prepare to battle the Shadow Council.',26124),
(88222,'enUS','Prepare to battle the Shadow Council.','Prepare to battle the Shadow Council.',26124),
(88223,'enUS','Stealth Detection Systems Online. Invisibility Flare Booting up...','',26124),
(88224,'enUS','Systems Shutting Down...','',26124),
(88225,'enUS','The train doesn\'t come through here anymore... Right?','',26124),
(88226,'enUS','I don\'t think we should be standing on these tracks.','',26124),
(88227,'enUS','Should we really be hanging out so close to these tracks?','',26124),
(88228,'enUS','','I\'m heading to your garrison, commander!',26124),
(88229,'enUS','You follow a false king!','',26124),
(88230,'enUS','Cultist filth!','',26124),
(88231,'enUS','In Terokk\'s name!','',26124),
(88232,'enUS','I\'ll see ya at yer garrison, commander!','',26124),
(88233,'enUS','Back, you beast!','',26124),
(88234,'enUS','Ra-aawk! For Anzu!','',26124),
(88235,'enUS','Who puts wings on a snake?! Honestly!','',26124),
(88236,'enUS','Sorry, big fellow.','',26124),
(88237,'enUS','Rest well.','',26124),
(88238,'enUS','Look at the size of that thing! We\'d better put it down.','',26124),
(88239,'enUS','Let us make for the Talon Altar.','',26124),
(88240,'enUS','','Let us make haste to Khadgar and the others.',26124),
(88241,'enUS','He\'s here.','',26124),
(88242,'enUS','Let\'s go. Khadgar isn\'t far from here.','',26124),
(88243,'enUS','What can I do for you?','What can I do for you?',26124),
(88244,'enUS','Your arrival is timely, mortals. The Sethekk must be stopped.','',26124),
(88245,'enUS','You are just in time. Witness the dark majesty of the void!','',26124),
(88246,'enUS','','I look forward to seeing your garrison, commander.',26124),
(88247,'enUS','Come at me!','',26124),
(88248,'enUS','My face, your mace! Wait... reverse that.','',26124),
(88249,'enUS','Victory for me!','',26124),
(88250,'enUS','It is a good day for a fight, eh commander?','',26124),
(88251,'enUS','These fools think they can win? Ha!','',26124),
(88252,'enUS','Die with honor.','',26124),
(88253,'enUS','You have failed, Kil\'Jaeden. The orcs did not drink of Mannoroth\'s blood as you promised.','',26124),
(88254,'enUS','We will take this world with the unending strength of the Legion. The time for subtlety has passed.','',26124),
(88255,'enUS','Lord Mongrethod, rally your forces. The time is close at hand.','',26124),
(88256,'enUS','It is time, Mongrethod. Gul\'dan\'s work is nearly complete.','',26124),
(88257,'enUS','Azzakel, you will be our vanguard. Lead the charge.','',26124),
(88258,'enUS','The draenei\'s souls will empower us. Any living orcs and draenei will become our puppets.','',26124),
(88259,'enUS','Yes... Auchindoun will be ours. The portals are nearly ready for our full invasion.','',26124),
(88260,'enUS','The sky will rain fire... the oceans will be filled with blood...','',26124),
(88261,'enUS','|TInterface\\Icons\\INV_Fabric_Felcloth_Ebon.blp:20|t |cFFFF0404|Hspell:161242|h[Caustic Energy]|h|r begins to flow into $n.','',26124),
(88262,'enUS','','A penny for your thoughts.',26124),
(88263,'enUS','','You\'re on the wrong side of my gun, pal.',26124),
(88264,'enUS','','Ready... draw!',26124),
(88265,'enUS','','I\'m gonna take a shot in the dark...',26124),
(88266,'enUS','','Know why they call me Clobberbottom? Because I kick butt!',26124),
(88267,'enUS','','You should never have crossed me!',26124),
(88268,'enUS','','Know what\'s as fast as a speeding bullet? A bullet.',26124),
(88269,'enUS','','Am I gonna need the big guns for this one?',26124),
(88270,'enUS','','A little slow on the draw, aren\'t ya?',26124),
(88271,'enUS','','My jokes killed out there!',26124),
(88272,'enUS','','Gotta love the smell of gunpowder.',26124),
(88273,'enUS','','A bullet is best served as fast as a speeding bullet.',26124),
(88274,'enUS','','Toodles!',26124),
(88275,'enUS','','Another one up in smoke!',26124),
(88276,'enUS','','Who wants some?!',26124),
(88277,'enUS','','Not sure they were even worth the bullets.',26124),
(88278,'enUS','','Heya, commander!',26124),
(88279,'enUS','','Need a gunslinger?',26124),
(88280,'enUS','','What\'s up?',26124),
(88281,'enUS','','Sometimes I use an axe to cut down a tree. Sometimes I just blow \'em up.',26124),
(88282,'enUS','','Look around your garrison and you can tell it\'s good ol\' goblin engineering!',26124),
(88283,'enUS','','Say... you look like famil... oh, hiya commander!',26124),
(88284,'enUS','','Talk high, talk fast, and say anything that comes to mind. Potato!',26124),
(88285,'enUS','','Ain\'t it cool bein\' on Draenor? Another world to exploit... er... explore.',26124),
(88286,'enUS','','That didn\'t go... as well as I hoped...',26124),
(88287,'enUS','I have a crossbow pointed at yer unmentionables.','',26124),
(88288,'enUS','What\'ll it be, axe or crossbow?','',26124),
(88289,'enUS','Target practice!','',26124),
(88290,'enUS','You callin\' me a coward?!','',26124),
(88291,'enUS','Looks like someone wants ta tussle!','',26124),
(88292,'enUS','Let me axe you a question.','',26124),
(88293,'enUS','Don\'t be runnin\' off now!','',26124),
(88294,'enUS','Do not fail again.','',26124),
(88295,'enUS','What ya doin\' ya dunderhead?','',26124),
(88296,'enUS','Kick \'em while they\'re down!','',26124),
(88297,'enUS','I tol\' ya not to look at me that way.','',26124),
(88298,'enUS','Must\'ve been the first Dark Iron you met.','',26124),
(88299,'enUS','This is the last time I warn ya... err... oops.','',26124),
(88300,'enUS','Say hi to yer ancestors for me.','',26124),
(88301,'enUS','Who\'s next?','',26124),
(88302,'enUS','Don\'t lose yer heed!','',26124),
(88303,'enUS','Another notch for me axe.','',26124),
(88304,'enUS','Lumber, I hardly knew \'er!','',26124),
(88305,'enUS','You a fan of pubs?','',26124),
(88306,'enUS','Nice place ya got here, commander.','',26124),
(88307,'enUS','How are ya?','',26124),
(88308,'enUS','Good day.','',26124),
(88309,'enUS','Where\'s the lavvy?','',26124),
(88310,'enUS','What ale\'s ya? Get it?','',26124),
(88311,'enUS','Cheers!','',26124),
(88312,'enUS','Ah, ya bastart!','',26124),
(88313,'enUS','I care not for your vendetta against the draenei... but their souls may still prove useful to us.','',26124),
(88314,'enUS','I wonder what your bones will look like...','',26124),
(88315,'enUS','Sticks and stones will break your bones.','',26124),
(88316,'enUS','Xuk you!','',26124),
(88317,'enUS','What the Xuk?!','',26124),
(88318,'enUS','Haha! Haha! Hahahahahaha!','',26124),
(88319,'enUS','I like killing! And bones!','',26124),
(88320,'enUS','You\'re boned!','',26124),
(88321,'enUS','What is this? A new friend for Xuk?','',26124),
(88322,'enUS','Just a pile of bones.','',26124),
(88323,'enUS','Ahahahahahaha!','',26124),
(88324,'enUS','Time to debone this one.','',26124),
(88325,'enUS','You\'re Xuk out of luck.','',26124),
(88326,'enUS','Another skull for my collection.','',26124),
(88327,'enUS','Orc and draenei both will bow in fealty to the Legion. Our hordes will scorch the earth beneath them. Together, Kil\'Jaeden, we are unstoppable.','',26124),
(88328,'enUS','Don\'t bleed too much on your bones!','',26124),
(88329,'enUS','Does anyone else want to kick this corpse?','',26124),
(88330,'enUS','Go torment my spirits.','',26124),
(88331,'enUS','Remember when the spirits made me talk to that magnaron? Xuk that.','',26124),
(88332,'enUS','Good to see your bones are still intact, commander.','',26124),
(88333,'enUS','Xuk will haunt your garrison. Helpfully.','',26124),
(88334,'enUS','You sure you weren\'t born Laughing Skull?','',26124),
(88335,'enUS','Our orc pawn readies portals into the heart of Auchindoun as I speak. We will devour their souls and usher in the full might of our forces.','',26124),
(88336,'enUS','Commander, you have lovely bone structure.','',26124),
(88337,'enUS','Sometimes it\'s fun to scare the others.','',26124),
(88338,'enUS','Xuk is honored by your presence.','',26124),
(88339,'enUS','Tonight we will FEAST!','',26124),
(88340,'enUS','I no longer trust my ancestors. You, I trust. Xuk them.','',26124),
(88341,'enUS','Xuk...','',26124),
(88342,'enUS','You will herald the end of this world.','',26124),
(88343,'enUS','','Enjoy your last moments.',26124),
(88344,'enUS','Nothing can stop your might. Pour out into this world... and feast!','',26124),
(88345,'enUS','','You are not the first to oppose me.',26124),
(88346,'enUS','','May your days be short and your hardships many.',26124),
(88347,'enUS','','May I be of service?',26124),
(88348,'enUS','','Even the patience of the draenei has its limits.',26124),
(88349,'enUS','','Have any last words?',26124),
(88350,'enUS','','Blade or bow? Loser\'s choice.',26124),
(88351,'enUS','','This is your final lesson.',26124),
(88352,'enUS','','It was a better death than you deserved.',26124),
(88353,'enUS','','Dioniss aca.',26124),
(88354,'enUS','','Do you require medical attention?',26124),
(88355,'enUS','','Good death, short life.',26124),
(88356,'enUS','','Embrace your final rest.',26124),
(88357,'enUS','','Remember the lessons of your death.',26124),
(88358,'enUS','','Now you understand what it is to oppose me.',26124),
(88359,'enUS','','Was that all you could muster?',26124),
(88360,'enUS','','Commander.',26124),
(88361,'enUS','','Hello, commander.',26124),
(88362,'enUS','','Archenon poros.',26124),
(88363,'enUS','','It is good to see you again.',26124),
(88364,'enUS','','Thank you for inviting me here.',26124),
(88365,'enUS','','May you have good fortune.',26124),
(88366,'enUS','','My training has failed me...',26124),
(88367,'enUS','I don\'t remember singing up for this.','',26124),
(88368,'enUS','Maybe after this we can grab a drink.','',26124),
(88369,'enUS','Aw, don\'t start yet... I lost a sandal.','',26124),
(88370,'enUS','Come and get it, chums!','',26124),
(88371,'enUS','Looks like the tide\'s rollin\' in!','',26124),
(88372,'enUS','Sit your duff down.','',26124),
(88373,'enUS','I reckon you\'re not quite welcome here.','',26124),
(88374,'enUS','Quite a character, that one.','',26124),
(88375,'enUS','I just keep reeeeeeling \'em in!','',26124),
(88376,'enUS','You\'ve been found gill-ty. Hah!','',26124),
(88377,'enUS','Rise, legion, and turn this world to ash!','',26124),
(88378,'enUS','Bring you a drink, commander?','',26124),
(88379,'enUS','How\'s about some fishing?','',26124),
(88380,'enUS','Ever dipped your foot in some water and it\'s really cold?','',26124),
(88381,'enUS','I feel like a fish outta water here, commander.','',26124),
(88382,'enUS','I don\'t suppose there\'s a watering hole in this garrison?','',26124),
(88383,'enUS','Alright, well... it\'s no big deal...','',26124),
(88384,'enUS','Got me hook, line and sinker.','',26124),
(88385,'enUS','To the deep sea...','',26124),
(88386,'enUS','Ouch, I\'m hooked!','',26124),
(88387,'enUS','DRAENOR WILL BURN!','',26124),
(88388,'enUS','Sergeant, the Shadow Council is upon us!','Sergeant, the Shadow Council is upon us!',26124),
(88389,'enUS','You saved my life once, it is about time I returned the favor!','',26124),
(88390,'enUS','The air has taken a turn for the foul...','',26124),
(88391,'enUS','The Council? The demons! Sound the alarm!','',26124),
(88392,'enUS','Soldiers, to your posts! Others, to shelter. And those who hold sway with the Light, pray.','',26124),
(88393,'enUS','One last fight, I see. This is it, soldiers. Charge!','',26124),
(88394,'enUS','Draw strength from each other, brothers and sisters.','',26124),
(88395,'enUS','May the spirits guide my hand.','',26124),
(88396,'enUS','The winds turn against you.','',26124),
(88397,'enUS','I have no time for insolence.','',26124),
(88398,'enUS','You test my patience.','',26124),
(88399,'enUS','Let me introduce you to my friend, lumber.','',26124),
(88400,'enUS','I fell trees with my bare hands. You will fall easily.','',26124),
(88401,'enUS','Remember, strike for head and heart. And do not fear. Fear will kill you.','',26124),
(88402,'enUS','The winds speak to me.','',26124),
(88403,'enUS','The Earthmother is with me.','',26124),
(88404,'enUS','The wind takes you.','',26124),
(88405,'enUS','You are naught but ash.','',26124),
(88406,'enUS','Back to the dust with you.','',26124),
(88407,'enUS','Let me just sprinkle some dust right there...','',26124),
(88408,'enUS','Do not get underhoof.','',26124),
(88409,'enUS','We won\'t go down that easy!','',26124),
(88410,'enUS','This one fell easily.','',26124),
(88411,'enUS','The spirits were not with you.','',26124),
(88412,'enUS','You should not have come here.','',26124),
(88413,'enUS','May the winds guide your steps, commander.','',26124),
(88414,'enUS','Peace, commander.','',26124),
(88415,'enUS','The Earthmother is with you.','',26124),
(88416,'enUS','The best views can be seen from a cliff\'s edge.','',26124),
(88417,'enUS','Which way does the wind blow?','',26124),
(88418,'enUS','The winds of this land speak, should you choose to listen.','',26124),
(88419,'enUS','If a wind stirs in the forest with no one there to hear it, does it make a sound?','',26124),
(88420,'enUS','Spread out! Don\'t let them gain a foothold!','',26124),
(88421,'enUS','Commander, the spirits speak of your bravery.','',26124),
(88422,'enUS','All we are is dust in the wind.','',26124),
(88423,'enUS','Have we driven them back?','',26124),
(88424,'enUS','This was not the plan...','',26124),
(88425,'enUS','Talon Guard, ready the altar beneath the broken spire.','',26124),
(88426,'enUS','Hero, meet us there when you have broken the cult.','',26124),
(88427,'enUS','I\'m ready to fly down to Aegwynn\'s Tower.','I\'m ready to fly down to Aegwynn\'s Tower.',26124),
(88428,'enUS','So Roben, what is the soup today?','So Roben, what is the soup today?',26124),
(88429,'enUS','','It\'s split legume.',26124),
(88430,'enUS','Ooh, my mom used to make a split legume soup. What are the orange slices?','Ooh, my mom used to make a split legume soup. What are the orange slices?',26124),
(88431,'enUS','','Those are carrots, our new allies brought them to me.',26124),
(88432,'enUS','Interesting, well I look forward to trying it.','Interesting, well I look forward to trying it.',26124),
(88433,'enUS','I am sure it will be great. See you later Roben.','I am sure it will be great. See you later Roben.',26124),
(88434,'enUS','','Thank you, let me know what you think.',26124),
(88435,'enUS','Ugh... me no feel so good... hic!','',26124),
(88436,'enUS','You want a piece of thish? ...hic!','',26124),
(88437,'enUS','You dare to defy Rukhmar?','',26124),
(88438,'enUS','You defile us with your presence!','',26124),
(88439,'enUS','Rukhmar has forsaken me.','',26124),
(88440,'enUS','Defeated by filthy outcasts and foreign trash!','',26124),
(88441,'enUS','I go to the judgment of Rukhmar.','',26124),
(88442,'enUS','I am undone!','',26124),
(88443,'enUS','Another sacrifice for Rukhmar!','',26124),
(88444,'enUS','You are unworthy!','',26124),
(88445,'enUS','Want to join slaves? Why not say so?','',26124),
(88446,'enUS','Stop hitting slaves? You funny!','',26124),
(88447,'enUS','Me hate trespassers!','',26124),
(88448,'enUS','You no belong here!','',26124),
(88449,'enUS','Let slaves go? You stupid!','',26124),
(88450,'enUS','Why my insides go outside?','',26124),
(88451,'enUS','It hurts! Wait, going numb. Better!','',26124),
(88452,'enUS','Sleepy now...','',26124),
(88453,'enUS','No fair!','',26124),
(88454,'enUS','You no want to play anymore?','',26124),
(88455,'enUS','Enough talking!','',26124),
(88456,'enUS','You look cold. Here fire!','',26124),
(88457,'enUS','Magic make slaves listen!','',26124),
(88458,'enUS','|TInterface\\Icons\\ability_fixated_state_red:20|tA creature has |cFFFF0000fixated|r on you! It will chase only you until it dies!','|TInterface\\Icons\\ability_fixated_state_red:20|tA creature has |cFFFF0000fixated|r on you! It will chase only you until it dies!',26124),
(88459,'enUS','Let\'s give these dogs their medicine.','',26124),
(88460,'enUS','I shall enjoy torturing you.','',26124),
(88461,'enUS','I will take your skull as a trophy!','',26124),
(88462,'enUS','Are you so eager to die?','',26124),
(88463,'enUS','You\'ll beg for death!','',26124),
(88464,'enUS','My death means nothing.','',26124),
(88465,'enUS','My torment ends.','',26124),
(88466,'enUS','Kargath will not be pleased.','',26124),
(88467,'enUS','The pain... feels so good...','',26124),
(88468,'enUS','Hah hah hah... got one!','',26124),
(88469,'enUS','Ready to die already? Pathetic!','',26124),
(88470,'enUS','You\'re almost not worth killing.','',26124),
(88471,'enUS','Bored now. Time for you to die.','',26124),
(88472,'enUS','Not even a good fight, what a waste of my time.','',26124),
(88473,'enUS','More food for Soulgrinder!','',26124),
(88474,'enUS','Borgal no like you. I no like you!','',26124),
(88475,'enUS','Slaves no need souls! You dumb!','',26124),
(88476,'enUS','Intruders must die!','',26124),
(88477,'enUS','GET OUT!','',26124),
(88478,'enUS','Borgal said I don\'t die. Borgal lie!','',26124),
(88479,'enUS','Soulgrinder eat me now?','',26124),
(88480,'enUS','My blood! It runs away!','',26124),
(88481,'enUS','Why lights go out?','',26124),
(88482,'enUS','Help me put snake-things back in stomach!','',26124),
(88483,'enUS','Hey, we\'re workin\' here!','Hey, we\'re workin\' here!',26124),
(88484,'enUS','You lookin\' for a smackdown?','You lookin\' for a smackdown?',26124),
(88485,'enUS','You die too easy! Die harder next time!','',26124),
(88486,'enUS','Stay outta my business!','Stay outta my business!',26124),
(88487,'enUS','Soulgrinder eat you now!','',26124),
(88488,'enUS','Soulgrinder make my magic strong!','',26124),
(88489,'enUS','I\'ll pulverize ya!','I\'ll pulverize ya!',26124),
(88490,'enUS','','My wolves will rend your flesh!',26124),
(88491,'enUS','We found these animals fair and square!','We found these animals fair and square!',26124),
(88492,'enUS','Keep your grubby hands off our merchandise!','Keep your grubby hands off our merchandise!',26124),
(88493,'enUS','These animals ain\'t worth your life!','These animals ain\'t worth your life!',26124),
(88494,'enUS','','Aid me, my children...',26124),
(88495,'enUS','We are making a fortune off these birds. So back off!','We are making a fortune off these birds. So back off!',26124),
(88496,'enUS','','I\'m going to enjoy this.',26124),
(88497,'enUS','','Today is not my day to die.',26124),
(88498,'enUS','The storm will take you!','',26124),
(88499,'enUS','No job was worth... this...','No job was worth... this...',26124),
(88500,'enUS','Tell my wife I... ah, forget it.','Tell my wife I... ah, forget it.',26124),
(88501,'enUS','The shadows will consume you!','',26124),
(88502,'enUS','Well... that sucked.','Well... that sucked.',26124),
(88503,'enUS','Bury me... with my gold.','Bury me... with my gold.',26124),
(88504,'enUS','Mis... calculated...','Mis... calculated...',26124),
(88505,'enUS','I got a... real bad headache...','I got a... real bad headache...',26124),
(88506,'enUS','Ooh... that really hurts.','Ooh... that really hurts.',26124),
(88507,'enUS','You will find only death here.','',26124),
(88508,'enUS','I return to the elements...','',26124),
(88509,'enUS','This may have been a bad idea...','',26124),
(88510,'enUS','Fear the axe of the Warsong!','',26124),
(88511,'enUS','I... shoulda brought... more axes...','',26124),
(88512,'enUS','Now... who protect... my munchkins?','',26124),
(88513,'enUS','Why is everyone so intent on war? Can we not give peace a chance?','',26124),
(88514,'enUS','','One day, we will live in peace. I hope...',26124),
(88515,'enUS','Your blood will give me strength!','',26124),
(88516,'enUS','Sethe calls to me...','',26124),
(88517,'enUS','You are no match for the Shattered Hand\'s venom!','',26124),
(88518,'enUS','Your end will come...','',26124),
(88519,'enUS','Interloper! You will not tamper with the relics of the Apexis!','',26124),
(88520,'enUS','Rukhmar will avenge me...','',26124),
(88521,'enUS','Thanks again for doin\' me a service back dere in Nagrand, mon. Eva\' since da Lich King be forcin\' me into his service, all I eva\' want ta do is get away an\' do some fishin\'.\n\nDis Draenor place be much nicer dan Northrend for fishin\', ya know. Ya don\'t have ta worry about da ice, and da fish be a lot less likely ta eat ya.','',26124),
(88522,'enUS','I\'ll filet ya wit\' me runeblade, mon!','',26124),
(88523,'enUS','Ya soul will make a fine voodoo lure!','',26124),
(88524,'enUS','Maybe I should try runeforgin\' da fishin\' rod.','',26124),
(88525,'enUS','','TEST, I GOT THE TRIGGER',26124),
(88526,'enUS','','The Iron Horde should pay for what they did to Karabor.',26124),
(88527,'enUS','To take up the weapon of a Blademaster is to invite your own demise.','',26124),
(88528,'enUS','We must get the wards reignited. Otherwise, I guarantee the Legion will overrun our position and pour into Azsuna.','',26124),
(88529,'enUS','Your own order is unraveling. Betrayed from within... a curse you\'ll bear for all eternity.','',26124),
(88530,'enUS','Enter the portal when you are ready to teleport.  You will be sent directly to Stormshield on the island of Ashran.\n\nHave no fear, Stormshield will not flag you for PVP.','',26124),
(88531,'enUS','Enter the portal when you are ready to teleport.  You will be sent directly to Warspear on the island of Ashran.\n\nHave no fear, Warspear will not flag you for PVP.','',26124),
(88532,'enUS','I\'m ready to teleport to Stormshield on Ashran!','I\'m ready to teleport to Stormshield on Ashran!',26124),
(88533,'enUS','I\'m ready to teleport to Warspear on Ashran!','I\'m ready to teleport to Warspear on Ashran!',26124),
(88534,'enUS','Meet me within the Broken Spire.','',26124),
(88535,'enUS','','Kesmet. Please sit down to eat.',26124),
(88536,'enUS','','Hands off, you filthy thief!',26124),
(88537,'enUS','','Greetings commander!$b$bHow are you doing today?',26124),
(88538,'enUS','Tuura, it was a magnificent meal as always.','',26124),
(88539,'enUS','How were your errands?','',26124),
(88540,'enUS','','They were fine. Urel says hello.',26124),
(88541,'enUS','','He asks how the fishing is going. Did you catch much today?',26124),
(88542,'enUS','I caught a few.','',26124),
(88543,'enUS','I will have to venture down and talk with Urel tomorrow. I need to also swing by Alexie\'s and pick up some new bait.','',26124),
(88544,'enUS','','That will do you good. You stay up here too much.',26124),
(88545,'enUS','Kesmet grunts.','',26124),
(88546,'enUS','','Tuura smiles.',26124),
(88547,'enUS','','How are we holding up in the front lines, $n?',26124),
(88548,'enUS','','GO!',26124),
(88549,'enUS','I\'ll slit any Alliance\'s throat for a copper.','',26124),
(88550,'enUS','I come and go like the wind.','',26124),
(88551,'enUS','','Tending the horses is not as easy as it seems, but at least you get to enjoy the outdoors.',26124),
(88552,'enUS','You, over there! Mind helping me out of this? Contrary to what these idiots seem to believe I am in fact not dead yet. Not in that sense of the word at least.','',26124),
(88553,'enUS','Thank you, commander. I\'ll make my way back to your garrison. I saw what I assume is your outpost not far from here.','',26124),
(88554,'enUS','%s goes into a |cFFFF0404|Hspell:155539|h[Destructive Rampage]|h|r!','',26124),
(88555,'enUS','I\'m responding to the Steamwheedle call for help. Take me to the Spires of Arak.','I\'m responding to the Steamwheedle call for help. Take me to the Spires of Arak.',26124),
(88556,'enUS','Yuz be needin\' me! I haz da information yuz need... help me mon!','',26124),
(88557,'enUS','HAAALP!','',26124),
(88558,'enUS','You be messin\' with the wrong mojo mon, deez new Iron Horde save me!','',26124),
(88559,'enUS','','Greetings Commander, I hope your travels are going well.',26124),
(88560,'enUS','Spirits! Get them!','',26124),
(88561,'enUS','Argh! These flamethrowers are useless, it\'s eating us alive!','',26124),
(88562,'enUS','Fall back! Drop your weapons and retreat to the ship!','',26124),
(88563,'enUS','|TInterface\\Icons\\spell_fire_felfirenova.blp:20|t You are afflicted with |cFFFF0404|Hspell:172895|h[Expel Magic: Fel]|h|r!','|TInterface\\Icons\\spell_fire_felfirenova.blp:20|t You are afflicted with |cFFFF0404|Hspell:172895|h[Expel Magic: Fel]|h|r!',26124),
(88564,'enUS','Good day Commander!','Good day Commander!',26124),
(88565,'enUS','We will be done with the harvest in no time.','We will be done with the harvest in no time.',26124),
(88566,'enUS','We are with you commander.','We are with you commander.',26124),
(88567,'enUS','For the Alliance!','For the Alliance!',26124),
(88568,'enUS','Once the mages opened up the portal from Orgrimmar this place really started to boom. We probably have the greatest assembly of vendors and trade goods this side of Draenor.','',26124),
(88569,'enUS','Interested in fishing around here?','Interested in fishing around here?',26124),
(88570,'enUS','Foolish raven!','',26124),
(88571,'enUS','<The Altar of Glory awaits an offering.>','',26124),
(88572,'enUS','<Place an offering atop the Altar of Glory.>','<Place an offering atop the Altar of Glory.>',26124),
(88573,'enUS','In this circle of blood only glory matters! Throw the broken bones of your enemies upon the altar and a conqueror\'s tribute will be yours.','',26124),
(88574,'enUS','The cursed ones are safe from Sethe, but their sky still burns.','',26124),
(88575,'enUS','They will need help from the ravens. Find me in Veil Terokk.','',26124),
(88576,'enUS','|Hunit:77182:Oregorger|hOregorger prepares to cast |cFFFF0000|Hspell:156879|h[Blackrock Barrage]|h|r.','',26124),
(88577,'enUS','','I got caught by the guards while trying to rescue Jobby. He owes me one.',26124),
(88578,'enUS','I was a moment too late. Your scout is dead... this is worse than I could have imagined. The Iron Horde invasion has begun. Take a look for yourself.','',26124),
(88579,'enUS','I laugh at your failure, hahaha!','',26124),
(88580,'enUS','More next time. Many more!','',26124),
(88581,'enUS','That was pretty savage.','',26124),
(88582,'enUS','I\'m not done killing you yet.','',26124),
(88583,'enUS','Kill them a lot!','',26124),
(88584,'enUS','Let us carve a smile on their faces.','',26124),
(88585,'enUS','Learn to beat more better.','',26124),
(88586,'enUS','Dat was good.','',26124),
(88587,'enUS','Dat was glor-ee-ous!','',26124),
(88588,'enUS','|cffADFF2F+$1i Broken Bones|r','|cFF0000FF+$1i Broken Bones|r',26124),
(88589,'enUS','','This is not the day we die.',26124),
(88590,'enUS','','They think they are doing well?',26124),
(88591,'enUS','','Stay down!',26124),
(88592,'enUS','','That was... disappointing.',26124),
(88593,'enUS','','Keep your guard up.',26124),
(88594,'enUS','','That was a glorious fight!',26124),
(88595,'enUS','Start running. I will even give you a head start...','',26124),
(88596,'enUS','We may need more to hunt after this.','',26124),
(88597,'enUS','I could do this blindfolded.','',26124),
(88598,'enUS','Continue practicing, commander.','',26124),
(88599,'enUS','My eye is on you, commander.','',26124),
(88600,'enUS','You are becoming quite the survivor.','',26124),
(88601,'enUS','You should work more on your form, commander.','',26124),
(88602,'enUS','Not bad! Now back to the Arena!','',26124),
(88603,'enUS','Now THAT was a battle!','',26124),
(88604,'enUS','I am here to repay my debt.','',26124),
(88605,'enUS','For Skettis!','',26124),
(88606,'enUS','You trust your eyes too much, fool.','',26124),
(88607,'enUS','I expected more from you.','',26124),
(88608,'enUS','Good. You are learning.','',26124),
(88609,'enUS','Yes! At this rate my debt to you will be paid in no time.','',26124),
(88610,'enUS','I tried to break Lyrdrea out of here but failed. Think she will appreciate the effort?','',26124),
(88611,'enUS','There MUST be a way past these statues.$b$bI want to retire to my chamber, but the owls send me away whenever I step in front of them. And I\'m growing so very tired...','There MUST be a way past these statues.$b$bI want to retire to my chamber, but the owls send me away whenever I step in front of them. And I\'m growing so very tired...',26124),
(88612,'enUS','Well, I suppose you could get past them if you were |cFF0000FF[Invisible]|r...','Well, I suppose you could get past them if you were |cFF0000FF[Invisible]|r...',26124),
(88613,'enUS','I will find a way past the owls.','I will find a way past the owls.',26124),
(88614,'enUS','I need help! How do you get past the owls?','I need help! How do you get past the owls?',26124),
(88615,'enUS','Work harder! Crack more stones!','',26124),
(88616,'enUS','Them stones won\'t crack theyselves!','',26124),
(88617,'enUS','Work! Work!','',26124),
(88618,'enUS','I must tell King Wrynn at once. Keep alert, $c. Dark times lay ahead.','',26124),
(88619,'enUS','My stomach growls louder and louder with each passing year. I could really use a bite to eat.$b$bI might even be convinced to give my scroll to you if you could help me sate this hunger.','My stomach growls louder and louder with each passing year. I could really use a bite to eat.$b$bI might even be convinced to give my scroll to you if you could help me sate this hunger.',26124),
(88620,'enUS','Hmm... you look like a conjurer, of sorts. You must have a way to |cFF0000FF[Conjure Refreshments]|r for me...','Hmm... you look like a conjurer, of sorts. You must have a way to |cFF0000FF[Conjure Refreshments]|r for me...',26124),
(88621,'enUS','I will get you some food.','I will get you some food.',26124),
(88622,'enUS','I need help! What can I possibly do to feed a hungry companion?','I need help! What can I possibly do to feed a hungry companion?',26124),
(88623,'enUS','I really should go put my daughter to sleep. It\'s centuries past her bedtime.$b$bI can\'t seem to get past these walls, though. What\'s a parent to do?','I really should go put my daughter to sleep. It\'s centuries past her bedtime.$b$bI can\'t seem to get past these walls, though. What\'s a parent to do?',26124),
(88624,'enUS','Children grow so fast. |cFF0000FF[Blink]|r twice and they\'re all grown up...','Children grow so fast. |cFF0000FF[Blink]|r twice and they\'re all grown up...',26124),
(88625,'enUS','I will find a way past the walls.','I will find a way past the walls.',26124),
(88626,'enUS','I need help! How can I get past these walls?','I need help! How can I get past these walls?',26124),
(88627,'enUS','The master has asked me to clear the vermin out of the lyceum. This one particular rat, however, has me completely vexed.','The master has asked me to clear the vermin out of the lyceum. This one particular rat, however, has me completely vexed.',26124),
(88628,'enUS','The damned thing has a powerful enchantment on it. Sure, a powerful mage might be able to |cFF0000FF[Steal its Spell]|r somehow, but I\'m just a guy with a broom...','The damned thing has a powerful enchantment on it. Sure, a powerful mage might be able to |cFF0000FF[Steal its Spell]|r somehow, but I\'m just a guy with a broom...',26124),
(88629,'enUS','I will defeat it for you.','I will defeat it for you.',26124),
(88630,'enUS','Murg used to be a peon just like these orcs, but I got to be the best stone cracker out there!\n\nNow, they give Murg the name \"Stonecrack\" and lets me boss around these little guys. It\'s the best job, I tell ya!','',26124),
(88631,'enUS','I need help! How can I defeat that monstrosity?','I need help! How can I defeat that monstrosity?',26124),
(88632,'enUS','This Murg guy is great. It\'s a real inspiration watching him yell at those peons.\n\nMaybe after we get off this rock, I\'ll acquire his services for some of my operations.','',26124),
(88633,'enUS','In this circle of blood only glory matters! Throw the broken bones of your enemies upon the altar and a conqueror\'s tribute will be yours.','',26124),
(88634,'enUS','Together, we will reseal the Tomb of Sargeras and defeat the Burning Legion.','',26124),
(88635,'enUS','I\'m ready to go find my artifact!','I\'m ready to go find my artifact!',26124),
(88636,'enUS','Hey! What\'s the big deal trying to bring your goons in here to stop my business?','',26124),
(88637,'enUS','Business?! These are priceless artifacts that you\'re offloading here!','',26124),
(88638,'enUS','In my experience, \'priceless\' just means really expensive. What do you expect me to do, give them away?','',26124),
(88639,'enUS','The Horde needs those artifacts! We must study them if we wish to gain the upper hand in this war.','',26124),
(88640,'enUS','That still doesn\'t answer my question.','',26124),
(88641,'enUS','Listen, you green little twerp! You\'ll hand over the artifacts or we will be forced to take them!','',26124),
(88642,'enUS','Easy pal, how \'bout I give you a nice discount and you can be on your way. How does five percent sound?','',26124),
(88643,'enUS','Fair enough, ten. And I wouldn\'t try any funny business if I were you. Nobody wants in bad with the Cartel.','',26124),
(88644,'enUS','Food! Please, take my spell scroll, I no longer have need of it.','Food! Please, take my spell scroll, I no longer have need of it.',26124),
(88645,'enUS','Are you mad?','',26124),
(88646,'enUS','','These Reliquary guys look like they mean business.\n\nTo me, that sounds very bad for business.',26124),
(88647,'enUS','Train me in Archaeology.','Train me in Archaeology.',26124),
(88648,'enUS','I must inform Warchief Vol\'jin. Keep alert, $c. Dark times lie ahead.','',26124),
(88649,'enUS','Want bodyguard? You not need one, but I can help you kill stuff.','',26124),
(88650,'enUS','Sure. I could use a little muscle.','Sure. I could use a little muscle.',26124),
(88651,'enUS','Your order has already been placed.','',26124),
(88652,'enUS','Collect your blood to regain your health!','Collect your blood to regain your health!',26124),
(88653,'enUS','%s comforts you.','%s comforts you.',26124),
(88654,'enUS','%s gives you a high five!','%s gives you a high five!',26124),
(88655,'enUS','Ye ain\'t gettin\' through me!','',26124),
(88656,'enUS','I\'ll cut ya!','',26124),
(88657,'enUS','Your head will make a fine trophy!','',26124),
(88658,'enUS','That\'s for me grand pappy!','',26124),
(88659,'enUS','Ick... ya got blood in me beard.','',26124),
(88660,'enUS','At ye service, commander.','',26124),
(88661,'enUS','What da ye want? Err... commander.','',26124),
(88662,'enUS','Let me know when there\'s something to kill.','',26124),
(88663,'enUS','Is it time ta kill something?','',26124),
(88664,'enUS','Death... where is thy sting?','',26124),
(88665,'enUS','I\'m coming home, pappy...','',26124),
(88666,'enUS','Psh... just a... flesh... wound...','',26124),
(88667,'enUS','Is that me blood or yours?... Definitely mine...','',26124),
(88668,'enUS','We\'re out of time, we need to start the ritual over. Everyone in your places, we\'re doing this again!','',26124),
(88669,'enUS','Our moment has passed and we need to do this again. Please, assist us with the ritual one more time.','',26124),
(88670,'enUS','%s salutes you with respect.','%s salutes you with respect.',26124),
(88671,'enUS','Filthy burgla! You gun be my dinna now!','',26124),
(88672,'enUS','Perhaps you were not ready for the ritual? It\'s ok, we can try this again.','',26124),
(88673,'enUS','Oooh, dis look like a tasty one!','',26124),
(88674,'enUS','','Thank you, commander. On my honor, I shall not disappoint you.',26124),
(88675,'enUS','What are you offering today?','What are you offering today?',26124),
(88676,'enUS','Work work!','',26124),
(88677,'enUS','Howdy.','',26124),
(88678,'enUS','Ha! Caught one.','',26124),
(88679,'enUS','','You\'ve angered the wrong night elf!',26124),
(88680,'enUS','','Your death will be swift.',26124),
(88681,'enUS','','I don\'t take any prisoners.',26124),
(88682,'enUS','','Any last words?',26124),
(88683,'enUS','','That wasn\'t so tough.',26124),
(88684,'enUS','','Hardly a challenge.',26124),
(88685,'enUS','','A clean kill.',26124),
(88686,'enUS','','Where\'s the danger?',26124),
(88687,'enUS','','I\'m on the alert.',26124),
(88688,'enUS','','Do you need my aid?',26124),
(88689,'enUS','','Nooo...',26124),
(88690,'enUS','','Do you disturb the wilds?',26124),
(88691,'enUS','','Nature guide me!',26124),
(88692,'enUS','','You will go no further!',26124),
(88693,'enUS','','Rest in peace.',26124),
(88694,'enUS','','Mu\'sha guide you.',26124),
(88695,'enUS','','Well fought.',26124),
(88696,'enUS','','May the moon guide you.',26124),
(88697,'enUS','','Be one with nature, commander.',26124),
(88698,'enUS','','Shhh, listen. The wind whispers...',26124),
(88699,'enUS','','I see... the... light...',26124),
(88700,'enUS','Who dares challenge the might of Skog?!','',26124),
(88701,'enUS','Bring me the corpses of these invaders.','',26124),
(88702,'enUS','This is MY domain!','',26124),
(88703,'enUS','What are these... things... that dare enter the domain of Skog?','',26124),
(88704,'enUS','Something need doing?','',26124),
(88705,'enUS','Gazlowe needs you.','Gazlowe needs you.',26124),
(88706,'enUS','Okee dokee.','',26124),
(88707,'enUS','YES! They must burn! Come, we have much to discuss!','',26124),
(88708,'enUS','Write, write, all day long. Make the pretty letters flow.','',26124),
(88709,'enUS','The Bloodmane attack came from the southern path over the mountain. If you follow it you should find the valley they come from.','',26124),
(88710,'enUS','I swear to eradicate all humans from the face of Draenor.','I swear to eradicate all humans from the face of Draenor.',26124),
(88711,'enUS','You have selected human as your nemesis.\n\nAre you sure?','You have selected human as your nemesis.\n\nAre you sure?',26124),
(88712,'enUS','','The Light prevails, because WE stand against the darkness.',26124),
(88713,'enUS','You have selected draenei as your nemesis.\n\nAre you sure?','You have selected draenei as your nemesis.\n\nAre you sure?',26124),
(88714,'enUS','You have selected night elf as your nemesis.\n\nAre you sure?','You have selected night elf as your nemesis.\n\nAre you sure?',26124),
(88715,'enUS','You have selected gnome as your nemesis.\n\nAre you sure?','You have selected gnome as your nemesis.\n\nAre you sure?',26124),
(88716,'enUS','You have selected worgen as your nemesis.\n\nAre you sure?','You have selected worgen as your nemesis.\n\nAre you sure?',26124),
(88717,'enUS','You have selected dwarf as your nemesis.\n\nAre you sure?','You have selected dwarf as your nemesis.\n\nAre you sure?',26124),
(88718,'enUS','You have selected pandaren as your nemesis.\n\nAre you sure?','You have selected pandaren as your nemesis.\n\nAre you sure?',26124),
(88719,'enUS','A fine choice. Humans are a blight upon this world and must be destroyed or driven out of Draenor.$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',26124),
(88720,'enUS','Draenei...$B$B<Raza\'kul spits.>$B$BYou would do all denizens of this world a great service by ridding these lands of draenei.$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',26124),
(88721,'enUS','The lasso breaks! The beast got away!','The lasso breaks! The beast got away!',26124),
(88722,'enUS','I swear to eradicate all draenei from the face of Draenor.','I swear to eradicate all draenei from the face of Draenor.',26124),
(88723,'enUS','I swear to eradicate all pandaren from the face of Draenor.','I swear to eradicate all pandaren from the face of Draenor.',26124),
(88724,'enUS','I swear to eradicate all dwarves from the face of Draenor.','I swear to eradicate all dwarves from the face of Draenor.',26124),
(88725,'enUS','I swear to eradicate all worgen from the face of Draenor.','I swear to eradicate all worgen from the face of Draenor.',26124),
(88726,'enUS','I swear to eradicate all gnomes from the face of Draenor. And hopefully the rest of the known universe.','I swear to eradicate all gnomes from the face of Draenor. And hopefully the rest of the known universe.',26124),
(88727,'enUS','I swear to eradicate all night elves from the face of Draenor.','I swear to eradicate all night elves from the face of Draenor.',26124),
(88728,'enUS','','We will hold the Temple. I will not accept any other outcome.',26124),
(88729,'enUS','','We\'ve done it, $n! K\'ara\'s energy has destroyed what\'s left of the Iron Horde army.$B$BWe are safe.',26124),
(88730,'enUS','These worgen that have invaded our lands share the same ferocity and animal instincts of the native saberon, but with none of their survival sense. Let their deaths serve as a lesson to the rest of this so called \"Alliance.\"$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',26124),
(88731,'enUS','These pandaren had a choice to serve in your mighty army, but instead opted to betray the Horde and join the enemy. Now they aid the draenei in their mission to kill all orcs. The traitorous pandaren of the Alliance must be exterminated.$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',26124),
(88732,'enUS','Whether an aberration of nature or a cruel joke by the gods of your world, gnomes have no business living. Their extinction will clear the way for a more powerful species to rise. You must be the instrument of their demise!$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',26124),
(88734,'enUS','Commander, check this thing out. We found an Iron Star and Thaelin over there has been helping me get it fully operational.\n\nI think it\'s ready for action, if you want to give it a test roll.\n\nKhadgar and the others said they\'d meet you at the entrance to the harbor. Maybe run over any Iron Horde you encounter along the way for kicks.','',26124),
(88735,'enUS','Thanks. I\'ll meet them at the docks.','Thanks. I\'ll meet them at the docks.',26124),
(88736,'enUS','Cheers, commander. We found this Iron Star here just waitin\' to be repaired, and Gazlowe over there has been helpin\' me fix it up.\n\nIt should be ready for action when you are.\n\nKhadgar said he\'d meet ya down by the harbor with the others. I\'m a wee bit jealous that ya get to roll over some Iron Horde in this thing.','',26124),
(88737,'enUS','Aye, that\'s a fine one, commander. I\'ll get \'er back to the stables now.','',26124),
(88738,'enUS','Night elves, conspirators one and all. The night elf invaders must be crushed and sent back to their moon gods!$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',26124),
(88739,'enUS','Dwarves are integral to the Alliance as they are the builders of war machines. For this reason alone they must all be slain. Show no mercy, as none will be shown to you.$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',26124),
(88740,'enUS','I\'ve changed my mind. I feel there is an enemy more worthy of my rage.','I\'ve changed my mind. I feel there is an enemy more worthy of my rage.',26124),
(88741,'enUS','Tectus directs his Crystalline Barrage towards you!','Tectus directs his Crystalline Barrage towards you!',26124),
(88742,'enUS','','We can\'t be stopped!',26124),
(88743,'enUS','','Have any spare Artifact Fragments, $n? My friend Ecilam could use them.',26124),
(88744,'enUS','','Chris Clarkie rewards handsomely if you bring him some Tauren Hooves.$B$BI don\'t know why.',26124),
(88745,'enUS','<The book is filled with spells - some strange, many familiar. One spell, in particular, is of special interest.>','',26124),
(88746,'enUS','<Cast the spell to summon Aluneth.>','<Cast the spell to summon Aluneth.>',26124),
(88747,'enUS','I\'m... uh oh...','',26124),
(88748,'enUS','I\'M UNSTOPPABLE!','',26124),
(88749,'enUS','Beyond this point is Stormshield Stronghold. I suggest you stay away if you aren\'t too keen in battle.','',26124),
(88750,'enUS','If you\'re going in, could you say a kind hello to Damarcus and Vessup at the main gate for me? They must miss me.','',26124),
(88751,'enUS','Leaf me alone!','',26124),
(88752,'enUS','\"The great staff Aluneth resides in a plane unreachable by all except the most skilled arcanists. Archmage Rentarric was the first to summon it. I was the last.\"$b$b- Magna Aegwynn','\"The great staff Aluneth resides in a plane unreachable by all except the most skilled arcanists. Archmage Rentarric was the first to summon her. I was the last.\"$b$b- Magna Aegwynn',26124),
(88753,'enUS','\"Aluneth will defy those who attempt to wield it. The greatstaff\'s willful spirit must first be broken.\"$b$b- Magna Aegwynn','\"Aluneth will defy those who attempt to wield her. The greatstaff\'s willful spirit must first be broken.\"$b$b- Magna Aegwynn',26124),
(88754,'enUS','\"Aluneth is capricious. The entity must be quickly bound to her summoner before its curiosity leads it astray.\"$b$b- Magna Aegwynn','\"Aluneth is capricious. She must be quickly bound to her summoner before her curiosity leads her astray.\"$b$b- Magna Aegwynn',26124),
(88755,'enUS','\"Aluneth\'s power should be immediately apparent to any who wield it. Its subtleties, however, will only become more apparent with time.\"$b$b- Magna Aegwynn','\"Aluneth\'s power should be immediately apparent to any who wield her. Her subtleties, however, will only become more apparent with time.\"$b$b- Magna Aegwynn',26124),
(88756,'enUS','\"When unused, Aluneth must be allowed to return to its own plane.\"$b$b- Magna Aegwynn','\"When unused, Aluneth must be allowed to return to her own plane.\"$b$b- Magna Aegwynn',26124),
(88757,'enUS','This world don\'t give us nothing, $n. It be our lot to suffer... and our duty to fight back.$b$b\nThis Horde be our family! We don\'t always see eye-to-eye. We come to blows before. But when we work together - ah - there\'s nothing this Horde can\'t do.','',26124),
(88758,'enUS','','My brothers... will avenge me...',26124),
(88759,'enUS','','Death to the enemies of the Warsong!',26124),
(88760,'enUS','This won\'t end well for you.','This won\'t end well for you.',26124),
(88761,'enUS','Give them no quarter!','Give them no quarter!',26124),
(88762,'enUS','We are the iron hand of war!','We are the iron hand of war!',26124),
(88763,'enUS','Wipe them out!','Wipe them out!',26124),
(88764,'enUS','Nothing can stop the Iron Horde!','Nothing can stop the Iron Horde!',26124),
(88765,'enUS','A storm of iron comes!','A storm of iron comes!',26124),
(88766,'enUS','You worms dare to oppose us?','You worms dare to oppose us?',26124),
(88767,'enUS','Curs. You are outmatched!','Curs. You are outmatched!',26124),
(88768,'enUS','Ahh... Aluneth. You speak of the Magna\'s greatstaff.$b$bI knew from the start it was not a weapon of normal means. My lady would simply reach upwards and GRAB the staff out of thin air, wave it around a bit, and then... just PUT it back into the thin air it came out of.$b$bThere was no cloaking or charlatan\'s invisibility going on here. That staff came from another realm. And the Magna knew how to reach into that realm and pluck it out.','Ahh... Aluneth. You speak of the Magna\'s greatstaff.$b$bI knew from the start it was not a weapon of normal means. My lady would simply reach upwards and GRAB the staff out of thin air, wave it around a bit, and then... just PUT it back into the thin air it came out of.$b$bThere was no cloaking or charlatan\'s invisibility going on here. That staff came from another realm. And the Magna knew how to reach into that realm and pluck it out.',26124),
(88769,'enUS','I saw the great weapon once, in my lady\'s library, moving on its own through the stacks!$b$bI pretended not to see it, but I fear it noticed my stare.','I saw the great weapon once, in my lady\'s library, moving on its own through the stacks!$b$bI pretended not to see it, but I fear it noticed my stare.',26124),
(88770,'enUS','You mean the Magna\'s weapon? I can tell you what I know.$b$bOnce, when I was much, much younger, I reached out to touch the greatstaff, as my lady had left it propped up against her chamber door. The staff rejected my touch with painful tendrils of pink and purple lightning.$b$bNot one second later, the Magna appeared and wrested the weapon away from me.$b$bShe shared a powerful bond with that staff - one that I will never fully understand.','You mean the Magna\'s weapon? I can tell you what I know.$b$bOnce, when I was much, much younger, I reached out to touch the greatstaff, as my lady had left it propped up against her chamber door. The staff rejected my touch with painful tendrils of pink and purple lightning.$b$bNot one second later, the Magna appeared and wrested the weapon away from me.$b$bShe shared a powerful bond with that staff - one that I will never fully understand.',26124),
(88771,'enUS','That weapon... I\'ve never seen anything like it before.$b$bMy lady used to talk to the thing, like it was alive. She\'d talk about spells, rituals, other matters of the arcane... all of it well over my head.$b$bShe was always a bit wild, my lady was, but she never quite struck me as batty. Odd to be talking to a staff, though.','That weapon... I\'ve never seen anything like it before.$b$bMy lady used to talk to the thing, like it was alive. She\'d talk about spells, rituals, other matters of the arcane... all of it well over my head.$b$bShe was always a bit wild, my lady was, but she never quite struck me as batty. Odd to be talking to a staff, though.',26124),
(88772,'enUS','What can you tell me about Aluneth?','What can you tell me about Aluneth?',26124),
(88773,'enUS','You are about to embark on a dangerous mission, and you may not be able to return immediately. Are you sure?','You are about to embark on a dangerous mission, and you may not be able to return immediately. Are you sure?',26124),
(88774,'enUS','','Ye be lookin\' lost, mon.',26124),
(88775,'enUS','Um... I\'m gonna need your raptor again.','Um... I\'m gonna need your raptor again.',26124),
(88776,'enUS','','We do not fear you!',26124),
(88777,'enUS','Thank... you...','Thank... you...',26124),
(88778,'enUS','My liege, the city is lost! We must abandon the palace!','',26124),
(88779,'enUS','The gates have been breached! They have come for the stones!','',26124),
(88780,'enUS','... return... to... the light...','... return... to... the light...',26124),
(88781,'enUS','The pain... thank you...','The pain... thank you...',26124),
(88782,'enUS','... you... are kind...','... you... are kind...',26124),
(88783,'enUS','May the light... watch... over you...','May the light... watch... over you...',26124),
(88784,'enUS','I\'m glad you made it here safely. Are you ready?','I\'m glad you made it here safely. Are you ready?',26124),
(88786,'enUS','Abyssal Killed: $1i (+$2i VP)','',26124),
(88787,'enUS','Shadow Anguishers Killed: $1i (+$2i VP)','',26124),
(88788,'enUS','Imps Killed: $1i (+$2i VP)','',26124),
(88789,'enUS','Shadowblades Killed: $1i (+$2i VP)','',26124),
(88790,'enUS','Shadow Council Portals Destroyed: $1i (+$2i VP)','',26124),
(88791,'enUS','Council Voidrenders Killed: $1i (+$2i VP)','',26124),
(88792,'enUS','Aren\'t you thankful?','',26124),
(88793,'enUS','Felfire Batriders Killed: $1i (+$2i VP)','',26124),
(88794,'enUS','The rest of the story will have to wait until you\'ve returned from Talon Watch.','',26124),
(88795,'enUS','Ah, thanks to the bangle you recovered from Ikiss, we can go right into the tale of Terokk\'s fall.','',26124),
(88796,'enUS','This gift will surely prove useful - but we still need the Talonpriests to perform the rites.','',26124),
(88797,'enUS','Tread carefully, stranger. I am not accustomed to visitors in this wasteland.','',26124),
(88798,'enUS','With this, we can delve into the tale of Terokk\'s fall.','',26124),
(88799,'enUS','The past has much to teach us.','',26124),
(88800,'enUS','Train me in Archaeology.','Train me in Archaeology.',26124),
(88801,'enUS','Train me in Inscription.','Train me in Inscription.',26124),
(88802,'enUS','A giant Carrion Worm smells his next meal!','A giant Carrion Worm smells his next meal!',26124),
(88803,'enUS','Carrion Worms Killed: $1i (+$2i VP)','',26124),
(88804,'enUS','','<The half-orc snarls at you from within her arcane prison. Her eyes are filled with fire and hate - it\'s clear that Gul\'dan still has her under his complete control.>',26124),
(88805,'enUS','Long have I toiled at my craft, stranger. There is no greater pursuit, in my opinion, than to admire and reflect upon the beauty of this world.','',26124),
(88806,'enUS','','Please don\'t die... please! Nyami said I cannot fail again!',26124),
(88807,'enUS','Greetings champion.$b$BI volunteered for this expedition to examine the oddities and abnormalities of Draenor.$b$bIf you find any strange anomalies during your journey I would be interested in examining them.','',26124),
(88808,'enUS','The battle for the ritual fires will begin in 3 minutes!','',26124),
(88809,'enUS','%s begins to cast |TInterface\\Icons\\ability_priest_voidentropy.blp:20|t |cFFFF0404|Hspell:174016|h[Decimate]|h|r! Run into a Neutralization Zone!','%s begins to cast |TInterface\\Icons\\ability_priest_voidentropy.blp:20|t |cFFFF0404|Hspell:174016|h[Decimate]|h|r! Run into a Neutralization Zone!',26124),
(88810,'enUS','','Right away, Exarch. May the dead speak through you.',26124),
(88811,'enUS','Story time is over!','',26124),
(88812,'enUS','We have found him...','',26124),
(88813,'enUS','The battle for the quarry will begin in 3 minutes!','',26124),
(88814,'enUS','The battle for the stadium will begin in 3 minutes!','',26124),
(88815,'enUS','This cannot be! My gaze is.. eternal...','',26124),
(88816,'enUS','The feeble arakkoa thought he could enslave me, but nothing can contain the void\'s eternal gaze!','',26124),
(88817,'enUS','You got it, boss. I meet you outside.','',26124),
(88818,'enUS','You will meet the same fate!','',26124),
(88819,'enUS','Fool!','',26124),
(88820,'enUS','Lead the way, boss.','',26124),
(88821,'enUS','Tormmok, head back to the barracks.','Tormmok, head back to the barracks.',26124),
(88822,'enUS','Okay boss.','',26124),
(88823,'enUS','This unusual arakkoa seems to have suffered mortal wounds from some sort of powerful dark magic.\n\nWhatever caused these wounds, however, is nowhere to be seen.','',26124),
(88824,'enUS','It\'s no use.','',26124),
(88825,'enUS','Thank you again, $p. Your kindness will not be forgotten... and neither will Tuliaa.','',26124),
(88826,'enUS','|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the man slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the man slayer is hunting you.',26124),
(88827,'enUS','We obey Ner\'zhul\'s will!','We obey Ner\'zhul\'s will!',26124),
(88828,'enUS','We will cover this world in darkness!','We will cover this world in darkness!',26124),
(88829,'enUS','Another prisoner for the sacrifice!','Another prisoner for the sacrifice!',26124),
(88830,'enUS','Darkness is our will, and iron is our blood!','Darkness is our will, and iron is our blood!',26124),
(88831,'enUS','I will deliver you to your end!','I will deliver you to your end!',26124),
(88832,'enUS','','Do you want some company, commander?',26124),
(88833,'enUS','Lookin\' fer a bodyguard, commander?$B$BYe\'ve come tae the right dwarf.','',26124),
(88834,'enUS','Leorajh come with $n?$B$BLeorajh good bodyguard. Keep you alive!','',26124),
(88835,'enUS','The shadows foretold that you might ask of my protection.$B$BI am prepared.','',26124),
(88836,'enUS','','Do you desire my aid, commander?',26124),
(88837,'enUS','','Would you like me to accompany you, $gsir:ma\'am;?',26124),
(88838,'enUS','Sure. I could use a little muscle.','Sure. I could use a little muscle.',26124),
(88839,'enUS','','Perfect! I\'ll meet you outside.',26124),
(88840,'enUS','Illona, head back to the barracks.','Illona, head back to the barracks.',26124),
(88841,'enUS','','Ready when you are!',26124),
(88842,'enUS','','I\'ll meet you back home!',26124),
(88843,'enUS','Sure. I could use a little muscle.','Sure. I could use a little muscle.',26124),
(88844,'enUS','','Gladly. I will meet you outside.',26124),
(88845,'enUS','Vivianne, head back to the barracks.','Vivianne, head back to the barracks.',26124),
(88846,'enUS','','Ready when you are.',26124),
(88847,'enUS','','I\'ll return to base.',26124),
(88848,'enUS','Sure. I could use a little muscle.','Sure. I could use a little muscle.',26124),
(88849,'enUS','I will join you outside.','',26124),
(88850,'enUS','Ishaal, head back to the barracks.','Ishaal, head back to the barracks.',26124),
(88851,'enUS','I heed your call.','',26124),
(88852,'enUS','I return to the shadows.','',26124),
(88853,'enUS','Sure. I could use a little muscle.','Sure. I could use a little muscle.',26124),
(88854,'enUS','Leorajh meet you outside.','',26124),
(88855,'enUS','Leorajh, head back to the barracks.','Leorajh, head back to the barracks.',26124),
(88856,'enUS','Yes, master?','',26124),
(88857,'enUS','Leorajh meet you at home.','',26124),
(88858,'enUS','Sure. I could use a little muscle.','Sure. I could use a little muscle.',26124),
(88859,'enUS','Yer the boss. I\'ll meet ye outside.','',26124),
(88860,'enUS','Delvar, head back to the barracks.','Delvar, head back to the barracks.',26124),
(88861,'enUS','I\'m right behind ye.','',26124),
(88862,'enUS','See ya at home.','',26124),
(88863,'enUS','Sure. I could use a little muscle.','Sure. I could use a little muscle.',26124),
(88864,'enUS','','So be it. I shall meet you outside.',26124),
(88865,'enUS','Aeda, head back to the barracks.','Aeda, head back to the barracks.',26124),
(88866,'enUS','','Say the word.',26124),
(88867,'enUS','','See you back home.',26124),
(88868,'enUS','Commander! Would you endorse my shop?','',26124),
(88869,'enUS','Quite the beast ye caught there! Let me get it back to the stables and brushed down.','',26124),
(88870,'enUS','This one\'s gonna be feisty, hope I make it back in one piece!','',26124),
(88871,'enUS','A great catch, commander! I\'ll get it some water when we get back.','',26124),
(88872,'enUS','Quite the beast ye got there, let me get it back to the stables.','',26124),
(88873,'enUS','Oi, this one\'s meh favorite yet! Come with me lil\' beastie!','',26124),
(88874,'enUS','Ah, a fine beast. I will return it to the stables.','',26124),
(88875,'enUS','A powerful creature, it will make a fine mount. I shall guide it home.','',26124),
(88876,'enUS','This beast will require some handling to be properly trained. I will begin immediately.','',26124),
(88877,'enUS','The beasts here are quite savage, but this one looks to be breakable. Come with me, beast.','',26124),
(88878,'enUS','A great catch, commander. I will get it some water.','',26124),
(88879,'enUS','I have not seen this much fire in a beast in quite some time. Come, unruly creature.','',26124),
(88880,'enUS','Welcome, commander. I carry the finest weapons and armor in all of Ashran.$b$bLet me know if there is anything I can help you with.','Welcome, commander. I carry the finest weapons and armor in all of Ashran.$b$bLet me know if there is anything I can help you with.',26124),
(88881,'enUS','Lookout! The Alliance has summoned a Frostwyrm! Get out of the main road!','',26124),
(88882,'enUS','|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the draenei slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the draenei slayer is hunting you.',26124),
(88883,'enUS','|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the dwarf slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the dwarf slayer is hunting you.',26124),
(88884,'enUS','|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the night elf slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the night elf slayer is hunting you.',26124),
(88885,'enUS','|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the gnome slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the gnome slayer is hunting you.',26124),
(88886,'enUS','I could kill a hundred of you at once!','',26124),
(88887,'enUS','|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the worgen slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the worgen slayer is hunting you.',26124),
(88888,'enUS','|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the pandaren slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_H_H.BLP:##|t |cFFF00000%s|r the pandaren slayer is hunting you.',26124),
(88889,'enUS','I will end your worthless life!','',26124),
(88890,'enUS','This can hardly be called a battle...','',26124),
(88891,'enUS','Mar\'gok will regret losing my brawn.','',26124),
(88892,'enUS','Hah. I\'ve killed bigger in my sleep!','',26124),
(88893,'enUS','You face the fist of the empire, fool.','',26124),
(88894,'enUS','Face me, cowards!','',26124),
(88895,'enUS','Today is not the day I die.','',26124),
(88896,'enUS','Your pathetic life is over.','',26124),
(88897,'enUS','Your death will be forgotten quickly...','',26124),
(88898,'enUS','Barely worth the effort.','',26124),
(88899,'enUS','I almost broke a sweat that time.','',26124),
(88900,'enUS','You call that a fight?','',26124),
(88901,'enUS','That nearly tickled.','',26124),
(88902,'enUS','Another. I could do this all day!','',26124),
(88903,'enUS','Surely there are stronger foes.','',26124),
(88904,'enUS','Want some meat?','',26124),
(88905,'enUS','You have orders, sir?','',26124),
(88906,'enUS','Is there a foe worth crushing, commander?','',26124),
(88907,'enUS','We will slay countless foes together.','',26124),
(88908,'enUS','This will be a glorious battle.','',26124),
(88909,'enUS','I knew you\'d recognize my might, commander.','',26124),
(88910,'enUS','All of Draenor will fall beneath us.','',26124),
(88911,'enUS','You need true ogre strength at your side, commander.','',26124),
(88912,'enUS','I am yours to command, my liege.','',26124),
(88913,'enUS','To die so far... from home...','',26124),
(88914,'enUS','Not the end... I had imagined...','',26124),
(88915,'enUS','Too... soon...','',26124),
(88916,'enUS','No! I... refuse...','',26124),
(88917,'enUS','This is almost too easy!','',26124),
(88918,'enUS','An Imperial battalion would be done with this fight already!','',26124),
(88919,'enUS','You cannot break me!','',26124),
(88920,'enUS','No formations... no tactics... this is a brawl, not a battle!','',26124),
(88921,'enUS','How about we get a few more into the fray?','',26124),
(88922,'enUS','Don\'t worry, it\'s almost over.','',26124),
(88923,'enUS','Come closer. My blade isn\'t bloody enough yet!','',26124),
(88924,'enUS','For a moment I thought this might have been a challenge.','',26124),
(88925,'enUS','Looking for a way to impress your friends? Maybe catch the eye of a lass you bumped into at the inn? Well, you\'re in luck, my friend. Feast your eyes on Bil Sparktonic\'s fantastical incantations!\n\nFor a low, low price, you too can enchant the world and make it glow! \n\nMy assistant, Bob, can also help you with recipes for the latest and greatest enchantments from Draenor!','',26124),
(88926,'enUS','Impress the ladies with Sparktonic\'s Spectacular Sparkles!','',26124),
(88927,'enUS','Sparktonics Enchanting: Bringing you the best Enchanting prices in Stormshield!','',26124),
(88928,'enUS','Have the shiniest weapon in town with Sparktonic\'s Enchanting!','',26124),
(88929,'enUS','Sparktonic\'s Enchanting: We turn plus one into plus fun!','',26124),
(88930,'enUS','Welcome to Sparktonic\'s Enchantments, offering the lowest prices on enchanting in Stormshield.\n\nCare to browse our recipes?','',26124),
(88931,'enUS','','Jeek on it. Jeek on this. You take that back, dooker $r!',26124),
(88932,'enUS','','Mank you, $g man:lady;. MANK YOU.',26124),
(88933,'enUS','Blikkety slickety ook. This mank jeeked on my dook. Face! Now hand over the Fighter Chow!','Blikkety slickety ook. This mank jeeked on my dook. Face! Now hand over the Fighter Chow!',26124),
(88934,'enUS','','You\'ve out-hozened me, wicket-lover. Here, take the chow. You earned it.',26124),
(88935,'enUS','','What now, you ookin dookin, blookin flookin, blickjikity flip wicket, slicky slapper, dook manker? Jeek!',26124),
(88936,'enUS','If we didn\'t want the support of these giants, I\'d kill you where you stand.','',26124),
(88937,'enUS','No food for you today, slave.','',26124),
(88938,'enUS','','Tell me, demon! Where is the Legion holding Illidan\'s body?',26124),
(88939,'enUS','Ah, it feels great to get Fanny out on a proper honeymoon!','',26124),
(88940,'enUS','I sought to escape the frozen wastes of Northrend for a while. I choose poorly.','',26124),
(88941,'enUS','<The young adventurer\'s body is punctured in several places.$B$BJudging from the state of the makeshift camp, a struggle broke out here not long ago.$B$BA note is crumpled in his hand.>','',26124),
(88942,'enUS','','What ARE these creatures?',26124),
(88943,'enUS','I am stronger than ever!','',26124),
(88944,'enUS','I am the strongest ogre in all of Draenor!','',26124),
(88945,'enUS','Go ahead, Ga\'nar. Take the clan. Slay your own brother in cold blood. See who follows you then.','',26124),
(88946,'enUS','You think THIS is what father wanted?','',26124),
(88947,'enUS','Ow! Sleep... time... now...','',26124),
(88948,'enUS','My totem will empower you!','',26124),
(88949,'enUS','Stand nearby to use my totem\'s strength.','',26124),
(88950,'enUS','Stand beside my totem to gain its power.','',26124),
(88951,'enUS','A fine choice. Blood elves are a blight upon this world and must be destroyed or driven out of Draenor.$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',26124),
(88952,'enUS','','Auchenai, secure this chamber.',26124),
(88953,'enUS','','The barrier protecting Auchindoun is asunder.',26124),
(88954,'enUS','','A foul force has penetrated these sacred chambers.',26124),
(88955,'enUS','Orc...$B$B<Kuros spits.>$B$BYou would do all denizens of this world a great service by ridding these lands of orc.$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',26124),
(88956,'enUS','','Scout ahead while we establish a foothold.',26124),
(88957,'enUS','','No... no, she cannot! My mind is not my own!',26124),
(88958,'enUS','','I return... to the Light.',26124),
(88959,'enUS','In my tongue, goblin roughly translates to parasite. A fitting name they have given themselves. As with any pest, they must be exterminated. Let their deaths serve as a lesson to the rest of this so called \"Alliance.\"$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',26124),
(88960,'enUS','These pandaren had a choice to serve in your mighty army, but instead opted to betray the Alliance and join the enemy. Now they aid the orcs in their mission to kill all draenei. The traitorous pandaren of the Horde must be exterminated.$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',26124),
(88961,'enUS','On Argus we hunted powerful horned beasts like your tauren for sport. Prove your might over this worthy adversary!$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',26124),
(88962,'enUS','Trolls, conspirators one and all. The troll invaders must be crushed and sent back to their savage gods!$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',26124),
(88963,'enUS','Death incarnate now walks the land. These Forsaken are a crime against life itself... anathema to the Light. For that alone they must all be purged from Draenor.$B$BThe path before you will be beset on all sides by those that would seek to stop you in your righteous mission. There can be only one outcome: victory or death.$B$BAre you certain about this choice?','',26124),
(88964,'enUS','Your Mount-In-Training runs away in fear!','Your Mount-In-Training runs away in fear!',26124),
(88965,'enUS','','We will never surrender to you! Champion, now is the time! Use the artifact!',26124),
(88966,'enUS','','Brace yourself, champion. The might of the Horde is within you. Lok\'tar ogar!',26124),
(88967,'enUS','','The artifact! Has he gone mad?! We must restore it. We must get it to safety.',26124),
(88968,'enUS','<Little power is left in this machine, rendering it useless>','<Little power is left in this machine, rendering it useless>',26124),
(88969,'enUS','<Investigate further>','<Investigate further>',26124),
(88970,'enUS','','',26124),
(88971,'enUS','','My strength grows!',26124),
(88972,'enUS','','The Light shines ever brighter!',26124),
(88973,'enUS','','I won\'t go down easily.',26124),
(88974,'enUS','','For my grandfather.',26124),
(88975,'enUS','','I will earn my place.',26124),
(88976,'enUS','','You will not break us.',26124),
(88977,'enUS','','Light grant me strength!',26124),
(88978,'enUS','','You cannot stand against the Light!',26124),
(88979,'enUS','','We fight as one.',26124),
(88980,'enUS','','I will never be broken.',26124),
(88981,'enUS','','You are broken.',26124),
(88982,'enUS','','You will threaten this world no longer.',26124),
(88983,'enUS','','You cannot stand against the Light.',26124),
(88984,'enUS','','Not on my watch.',26124),
(88985,'enUS','','I\'ve killed one!',26124),
(88986,'enUS','','We will prevail!',26124),
(88987,'enUS','','Our defenses hold.',26124),
(88988,'enUS','','I stand for another day.',26124),
(88989,'enUS','','May the Light protect us.',26124),
(88990,'enUS','','I will stand by your side, commander.',26124),
(88991,'enUS','','May the Light bless you, commander.',26124),
(88992,'enUS','','Lead the way.',26124),
(88993,'enUS','','Together we cannot fall.',26124),
(88994,'enUS','','I will avenge the fallen.',26124),
(88995,'enUS','','The spirits of the fallen watch over us.',26124),
(88996,'enUS','','It is an honor to fight by your side.',26124),
(88997,'enUS','','I am... done.',26124),
(88998,'enUS','','The Light... fades...',26124),
(88999,'enUS','','I see... only... darkness...',26124),
(89000,'enUS','','Grandfather... I have failed you...',26124),
(89001,'enUS','','Spirits grant me strength!',26124),
(89002,'enUS','','I do not fear you.',26124),
(89003,'enUS','','I will defend my homeland with my life.',26124),
(89004,'enUS','','Fall before my hammer, fiend.',26124),
(89005,'enUS','','My conviction is unwavering.',26124),
(89006,'enUS','','I will not falter.',26124),
(89007,'enUS','','I will have retribution!',26124),
(89008,'enUS','','For Draenor!',26124),
(89009,'enUS','','None will stand in my way now.',26124),
(89010,'enUS','','Power... overwhelming!',26124),
(89011,'enUS','','You will regret this.',26124),
(89012,'enUS','','I wield powers from beyond.',26124),
(89013,'enUS','','You will beg for mercy.',26124),
(89014,'enUS','','I will turn you to ash!',26124),
(89015,'enUS','','Taste the fury of the sun!',26124),
(89016,'enUS','','For the Horde!',26124),
(89017,'enUS','','You will know pain.',26124),
(89018,'enUS','','I will tear your very soul asunder.',26124),
(89019,'enUS','','Nice try.',26124),
(89020,'enUS','','You deserved that.',26124),
(89021,'enUS','','One down.',26124),
(89022,'enUS','','Who\'s next?',26124),
(89023,'enUS','','I tried to warn you.',26124),
(89024,'enUS','','You are weak.',26124),
(89025,'enUS','','That was only the beginning.',26124),
(89026,'enUS','','Chaos reigns!',26124),
(89027,'enUS','','I am yours to command.',26124),
(89028,'enUS','','My power is yours, commander.',26124),
(89029,'enUS','','Our destiny awaits.',26124),
(89030,'enUS','','I am sworn to your service, commander.',26124),
(89031,'enUS','','Shall we sow fear into the hearts of your enemies?',26124),
(89032,'enUS','','We aren\'t in Outland anymore.',26124),
(89033,'enUS','','I will bathe your enemies in hellfire.',26124),
(89034,'enUS','','We will defeat the Legion.',26124),
(89035,'enUS','','It\'s so... cold...',26124),
(89036,'enUS','','The nether... embraces me...',26124),
(89037,'enUS','','Commander... I have... failed.',26124),
(89038,'enUS','','My soul... was too weak.',26124),
(89039,'enUS','','CHAOS!',26124),
(89040,'enUS','','Burn!',26124),
(89041,'enUS','','Stand still.',26124),
(89042,'enUS','','I will banish you to the Twisting Nether.',26124),
(89043,'enUS','','You will learn to fear me.',26124),
(89044,'enUS','','Impressive.',26124),
(89045,'enUS','','My power is unending.',26124),
(89046,'enUS','','You will suffer.',26124),
(89047,'enUS','Ha!  Just what I expected from something so puny.','',26124),
(89048,'enUS','You think you can beat Tarr with pets?  Funny.','',26124),
(89049,'enUS','','I don\'t really like when my pets fight, but I love making them feel better when they\'re done.',26124),
(89069,'enUS','','Do you wish to offer challenge?  My wolves must train to become strong.',26124),
(89079,'enUS','6.0 Battle Pet Trainer - Reenari - None','',26124),
(89094,'enUS','6.0 Battle Pet Trainer - Vesharr - None','',26124),
(89095,'enUS','6.0 Battle Pet Trainer - Veruna - None','',26124),
(89096,'enUS','','My wolves will tear your pets apart!',26124),
(89098,'enUS','|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the pandaren slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the pandaren slayer is hunting you.',26124),
(89099,'enUS','|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the goblin slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the goblin slayer is hunting you.',26124),
(89100,'enUS','|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the tauren slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the tauren slayer is hunting you.',26124),
(89101,'enUS','|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the troll slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the troll slayer is hunting you.',26124),
(89102,'enUS','|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the Forsaken slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the Forsaken slayer is hunting you.',26124),
(89103,'enUS','|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the blood elf slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the blood elf slayer is hunting you.',26124),
(89104,'enUS','|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the orc slayer is hunting you.','|TInterface\\Icons\\ACHIEVEMENT_PVP_A_A.BLP:##|t |cFF0000FF%s|r the orc slayer is hunting you.',26124),
(89105,'enUS','... our might rules the skies... behold, terror given wings!','',26124),
(89106,'enUS','','%s glares intensely at you.',26124),
(89107,'enUS','','I do love the fresh air out here!',26124),
(89108,'enUS','Once I walked these halls with pride, holding my head high as an orc of the Blackrock clan. But this is a wrong path. Our hammers were meant to craft axes, swords... not these machines from the stranger\'s whispers.','',26124),
(89109,'enUS','I will punch you in the face!','',26124),
(89110,'enUS','Rocketspark leaps, beginning a |TInterface\\Icons\\inv_misc_missilelargecluster_red.blp:20|t |cFFFF0404|Hspell:162407|h[X21-01A Missile Barrage]|h|r!','Rocketspark leaps, beginning a |TInterface\\Icons\\inv_misc_missilelargecluster_red.blp:20|t |cFFFF0404|Hspell:162407|h[X21-01A Missile Barrage]|h|r!',26124),
(89111,'enUS','To procure and shreddinate.','',26124),
(89112,'enUS','Initiating the Lower Extremity Adjustment Protocol...','',26124),
(89113,'enUS','... Protocol.','',26124),
(89114,'enUS','Unacceptable heat parameters... initiating the Sublimega-Z Protocool.','',26124),
(89115,'enUS','','You should have left when you had the chance.',26124),
(89116,'enUS','Witness true power!','',26124),
(89117,'enUS','I\'d stand back... if I were you!','',26124),
(89118,'enUS','Johnny Five... dead?','',26124),
(89119,'enUS','','Tormak asked me to accompany him on an adventure through Azeroth. I never thought we\'d end up here. I\'m glad I came with him, though.',26124),
(89120,'enUS','Ye ain\'t gettin\' through me!','',26124),
(89121,'enUS','I\'ll cut ya!','',26124),
(89122,'enUS','Yer head will make a fine trophy!','',26124),
(89123,'enUS','Where\'s the rest o\' ya?','',26124),
(89124,'enUS','Ye\'ve no idea who yer messin\' with.','',26124),
(89125,'enUS','Don\'t expect me ta go easy on ye.','',26124),
(89126,'enUS','For the Alliance!','',26124),
(89127,'enUS','Show me what ye\'ve got!','',26124),
(89128,'enUS','That\'s fer me grand pappy!','',26124),
(89129,'enUS','Ya got blood in me beard. Delicious.','',26124),
(89130,'enUS','Haha! Never faced a dwarf death knight, have ye?','',26124),
(89131,'enUS','Keep yer kills up commander, I think I\'m winnin\'!','',26124),
(89132,'enUS','Another kill fer me!','',26124),
(89133,'enUS','Me beard\'s killed tougher!','',26124),
(89134,'enUS','When\'s the battle start? I\'m fallin\' asleep!','',26124),
(89135,'enUS','I\'ll drink to that!','',26124),
(89136,'enUS','At yer service, commander.','',26124),
(89137,'enUS','What da ye want? Err... commander.','',26124),
(89138,'enUS','Let me know when there\'s something ta kill.','',26124),
(89139,'enUS','Is it time fer some good ol\' fashioned slaughter?','',26124),
(89140,'enUS','Ye\'ve got the best dwarf this side a Draenor by yer side!','',26124),
(89141,'enUS','Shay, commander ...hic! What\'sh yer policy on havin\' a bit o\' mead on the job?','',26124),
(89142,'enUS','I\'m with ye, commander.','',26124),
(89143,'enUS','Delvar Ironfist reportin\' fer duty.','',26124),
(89144,'enUS','I\'m comin\' home, pappy...','',26124),
(89145,'enUS','Psh... just a... flesh... wound...','',26124),
(89146,'enUS','Is that me blood or yours?... Definitely mine...','',26124),
(89147,'enUS','Commander... I\'m... finished....','',26124),
(89148,'enUS','Feelin\' saucy, are ye?','',26124),
(89149,'enUS','Yer goin\' ta have ta try harder than that!','',26124),
(89150,'enUS','Me grand pappy would\'ve loved this.','',26124),
(89151,'enUS','I\'ll only tell ye once. No touchin\' a the beard o\' face.','',26124),
(89152,'enUS','Let me show ye why they call me ironfist.','',26124),
(89153,'enUS','Come on. Put some feelin\' into it!','',26124),
(89154,'enUS','I\'m a fighter o\' the Alliance. Ye stand no chance.','',26124),
(89155,'enUS','By my axe, you\'ll pay fer that!','',26124),
(89156,'enUS','That\'s what I\'m talkin\' about!','',26124),
(89157,'enUS','I\'m nigh unstoppable!','',26124),
(89158,'enUS','','You march towards your grave.',26124),
(89159,'enUS','','Beautiful death awaits you.',26124),
(89160,'enUS','','Your end is near.',26124),
(89161,'enUS','','I\'ll make this quick.',26124),
(89162,'enUS','','Everything you know will burn!',26124),
(89163,'enUS','','Death is inevitable.',26124),
(89164,'enUS','','You know what happens when you play with fire.',26124),
(89165,'enUS','','I hope your estate is in order.',26124),
(89166,'enUS','','Revel in your final moments.',26124),
(89167,'enUS','','Death is only the beginning.',26124),
(89168,'enUS','','Welcome to the Dark Lady\'s embrace.',26124),
(89169,'enUS','','The Dark Lady sends her regards.',26124),
(89170,'enUS','','You\'re far more useful to me dead.',26124),
(89171,'enUS','','You cannot stop death.',26124),
(89172,'enUS','','Forever hold your peace.',26124),
(89173,'enUS','','The hour of your departure has arrived.',26124),
(89174,'enUS','','Anything that needs killing, commander?',26124),
(89175,'enUS','','Any new assignments?',26124),
(89176,'enUS','','At your service, commander.',26124),
(89177,'enUS','','Good evening, commander.',26124),
(89178,'enUS','','Lovely evening for some killing, don\'t you think?',26124),
(89179,'enUS','','My staff is yours to command.',26124),
(89180,'enUS','','Where shall we go next?',26124),
(89181,'enUS','','Your wish is my desire, commander.',26124),
(89182,'enUS','','Death will come... to you too...',26124),
(89183,'enUS','','My service is... complete...',26124),
(89184,'enUS','','Dark Lady... watch over me...',26124),
(89185,'enUS','','My time... has come...',26124),
(89186,'enUS','','Burn!',26124),
(89187,'enUS','','You\'ll pay for that.',26124),
(89188,'enUS','','I am forsaken.',26124),
(89189,'enUS','','How do you kill that which has no life?',26124),
(89190,'enUS','','I\'ll see you on the other side.',26124),
(89191,'enUS','','It is time for your reckoning.',26124),
(89192,'enUS','','I will bathe you in flames until there is nothing left.',26124),
(89193,'enUS','','Stare into the darkness of your demise.',26124),
(89194,'enUS','With danger at every corner, it\'s most wise to form a Party when exploring Ashran. If within a Party, I can teleport you to your Party Leader. $b$bWould you like me to Teleport you to your Party Leader?','',26124),
(89195,'enUS','','My power grows.',26124),
(89196,'enUS','','The Dark Lady smiles upon me.',26124),
(89197,'enUS','Yes, Teleport me to my Party Leader.','Yes, Teleport me to my Party Leader.',26124),
(89198,'enUS','A model with skill such as mine does not come without dedication.  \n\nI have spent a lifetime perfecting my signature poses.','',26124),
(89199,'enUS','Show me \"Le Talbuk!\"','Show me \"Le Talbuk!\"',26124),
(89200,'enUS','Okay, how about \"Azure Steel?\"','Okay, how about \"Azure Steel?\"',26124),
(89201,'enUS','Now show me \"Magnuum!\"','Now show me \"Magnuum!\"',26124),
(89202,'enUS','A classic pose. Stand back and let me show you how it\'s done.','',26124),
(89203,'enUS','Le Talbuk!','',26124),
(89204,'enUS','This is my most popular pose. Brace yourself.','',26124),
(89205,'enUS','Azure Steel!','',26124),
(89206,'enUS','Ah, Magnuum. I have been practicing for years to perfect it. Let me show you.','',26124),
(89207,'enUS','Magnuum!','',26124),
(89208,'enUS','A Horde spy has snuck in amidst the chaos!','A Horde spy has snuck in amidst the chaos!',26124),
(89209,'enUS','A Ravenous Goren is feasting on your garrison\'s resources!','A Ravenous Goren is feasting on your garrison\'s resources!',26124),
(89210,'enUS','A Traitorous Looter is looting your buildings!','A Traitorous Looter is looting your buildings!',26124),
(89211,'enUS','Dere be danger at every corner, ya be wise to form a Party when explorin\' Ashran. If ya within a Party, I can teleport ya to your Party Leader. $b$bTeleport ya to ya Party Leader?','',26124),
(89212,'enUS','Infiltrators Killed: $1i (+$2i VP)','',26124),
(89213,'enUS','Goldsniffers Killed: $1i (+$2i VP)','',26124),
(89214,'enUS','Turncoats Brought to Justice: $1i (+$2i VP)','',26124),
(89215,'enUS','Together, we will defeat the Shadow Council.','',26124),
(89216,'enUS','Sorry, $n.','Sorry, $n.',26124),
(89217,'enUS','Not so fast!','Not so fast!',26124),
(89218,'enUS','So eager to run away?','So eager to run away?',26124),
(89219,'enUS','Azuka isn\'t finished with you yet.','Azuka isn\'t finished with you yet.',26124),
(89220,'enUS','You don\'t stand a chance.','You don\'t stand a chance.',26124),
(89221,'enUS','World Broadcast Text Test','World Broadcast Text Test',26124),
(89222,'enUS','','Pitiful. Just as I expected.',26124),
(89223,'enUS','Teleport to Party Leader','Teleport to Party Leader',26124),
(89224,'enUS','Teleport to your Party Leader?','',26124),
(89225,'enUS','Teleport to your Party Leader?','',26124),
(89230,'enUS','I will gladly give my life for the Iron Horde!','I will gladly give my life for the Iron Horde!',26124),
(89231,'enUS','','Enough! It\'s time to show you the true power of this blade.',26124),
(89232,'enUS','','My blade grows stronger!',26124),
(89233,'enUS','','Ya be needin\' someone for a job? I\'ll find ya two.',26124),
(89234,'enUS','Who\'s looking for a job?','Who\'s looking for a job?',26124),
(89235,'enUS','The Talon King\'s power belongs to the children of Skettis.$B$BReshad should never have shared it with an outsider...','',26124),
(89236,'enUS','|TInterface\\Icons\\Spell_Fire_Fireball02:20|t You are carrying |cFFFF0000|Hspell:160702|h[Blackrock Mortar Shells]|h|r. Hop in a Blackrock Turret to use them!','|TInterface\\Icons\\Spell_Fire_Fireball02:20|t You are carrying |cFFFF0000|Hspell:160702|h[Blackrock Mortar Shells]|h|r. Hop in a Blackrock Turret to use them!',26124),
(89237,'enUS','Iskar wanted to bring Terokk back with a body of his own. But would the Talon King have saved us, or lead us further into darkness?$B$BI was not willing to repeat the mistakes of our past.$B$BIn you, I saw a worthy steward of the Talon King\'s power. Ishaal agreed, and helped me to bind your essences together.$B$BIskar will not be happy about this, but what\'s done is done.','',26124),
(89238,'enUS','In my days with the rangari, I have learned many nuances of skinning the varied beasts of Draenor.\n\nNow that I am in Stormshield, however, I find it is much more enjoyable to pass these teachings onto others, than to toil in the fields with the skinning knife.\n\nWouldn\'t you agree?','',26124),
(89239,'enUS','','That Swann may not have been born a dwarf, but the heat of the forge runs through her veins. \n\nI could not ask for a finer apprentice.',26124),
(89240,'enUS','','Come close heroes, and let me heal your wounds.',26124),
(89241,'enUS','','No pets up to the challenge?  I don\'t have time for amateurs, come back when you have a few fights under your belt.',26124),
(89242,'enUS','','Come close heroes, and let me heal your wounds.',26124),
(89243,'enUS','','Sanketsu! Unleash your power!',26124),
(89244,'enUS','Slay the Burning Blade Initiate before they can reach Azuka!','Slay the Burning Blade Initiate before they can reach Azuka!',26124),
(89245,'enUS','It is good that you have come to Ashran, $C. You will likely be needed in the days to come.\n\nThe artifacts found on this island from the ancient ogre kingdom may be the determining factor in our battle against the Iron Horde. Unfortunately, the Horde has decided that they wish to take this knowledge for their own, in spite of our truce.\n\nWe must not let the Horde impede our efforts against our foe here on Draenor. Take the battle to them and pry the artifacts from their dead hands if you must!\n\nFor the Alliance!','',26124),
(89246,'enUS','Our people appreciate the aid you have lent us against the Adherents of Rukhmar. \n\nWe will not forget your generosity.','',26124),
(89247,'enUS','The appearance of the Order of the Awakened vexes many of the Outcasts. Though they claim their intentions are pure, their kind has wronged us so many times before.\n\nWe hope they are true to their words, but for now we will wait and see.','',26124),
(89248,'enUS','I am not a fighter myself, but I feel like even the most battle-minded of us should step away from time to time to enjoy some peace and quiet.\n\nFor me, there\'s no better way to do so then with a fishing rod in your hand and the gentle sounds of the ocean. \n\nWhat do you think, $C?','',26124),
(89249,'enUS','Train me in Fishing.','Train me in Fishing.',26124),
(89250,'enUS','Is that $n? I can\'t believe $Ghe:she;\'s in Stormshield!','',26124),
(89251,'enUS','$n has come to Stormshield! I\'ve never seen a finer $c in my day!','',26124),
(89252,'enUS','Look, $n has arrived! This may be the stroke that turns the tide of this battle!','',26124),
(89253,'enUS','','What is your command?',26124),
(89254,'enUS','Switch back to orc grunts.','Switch back to orc grunts.',26124),
(89255,'enUS','I want to recruit guards from other lands.','I want to recruit guards from other lands.',26124),
(89256,'enUS','The Horde has conquered Stormshield Hold!','',26124),
(89257,'enUS','The Alliance has conquered Warspear Outpost!','',26124),
(89258,'enUS','If you are exalted by Undercity, Thunder Bluff, the Darkspear trolls, Silvermoon City, Bilgewater Port, the Huojin pandaren, or if you are a death knight exalted by the Knights of the Ebon Blade, you can recruit guards from their respective ranks by talking to the right recruiting officer in your Great Hall.','If you are exalted by Undercity, Thunder Bluff, the Darkspear trolls, Silvermoon City, Bilgewater Port, the Huojin pandaren, or if you are a death knight exalted by the Knights of the Ebon Blade, you can recruit guards from their respective ranks by talking to the right recruiting officer in your Great Hall.',26124),
(89259,'enUS','The shadows are restless.','',26124),
(89260,'enUS','Your time has come.','',26124),
(89261,'enUS','Gaze into the abyss!','',26124),
(89262,'enUS','RaAWK!','',26124),
(89263,'enUS','The darkness comes for you.','',26124),
(89264,'enUS','Your fate has already been set.','',26124),
(89265,'enUS','Come closer... the shadow fiends hunger.','',26124),
(89266,'enUS','You will be eradicated.','',26124),
(89267,'enUS','A feast for the shadow fiends.','',26124),
(89268,'enUS','Fade away.','',26124),
(89269,'enUS','Kaw-ha-ha! Fool!','',26124),
(89270,'enUS','Wither and fall.','',26124),
(89271,'enUS','Ra-aawk! Pathetic.','',26124),
(89272,'enUS','Welcome the shadow\'s embrace.','',26124),
(89273,'enUS','Enough.','',26124),
(89274,'enUS','I had expected more.','',26124),
(89275,'enUS','Commander.','',26124),
(89276,'enUS','Shadows gather...','',26124),
(89277,'enUS','What ruin shall we dispense today?','',26124),
(89278,'enUS','I have seen good omens for us.','',26124),
(89279,'enUS','I am prepared.','',26124),
(89280,'enUS','As you wish.','',26124),
(89281,'enUS','You called?','',26124),
(89282,'enUS','The shadows smile upon you, commander.','',26124),
(89283,'enUS','At last... I am free.','',26124),
(89284,'enUS','So much... left... undone.','',26124),
(89285,'enUS','I... can-raAWK!... Go no further...','',26124),
(89286,'enUS','The shadows... welcome me...','',26124),
(89287,'enUS','Gaze upon your demise.','',26124),
(89288,'enUS','I will be your end.','',26124),
(89289,'enUS','Your future is... short.','',26124),
(89290,'enUS','Suffer... as I have.','',26124),
(89291,'enUS','Kaw-rawk!','',26124),
(89292,'enUS','You know nothing of pain.','',26124),
(89293,'enUS','Begone!','',26124),
(89294,'enUS','Writhe in agony.','',26124),
(89295,'enUS','You die!','',26124),
(89296,'enUS','This our territory!','',26124),
(89297,'enUS','Leorajh keep friends alive.','',26124),
(89298,'enUS','Sun rock protects us.','',26124),
(89299,'enUS','Battle make us stronger.','',26124),
(89300,'enUS','Leorajh bring glory to clan.','',26124),
(89301,'enUS','Leorajh ready for anything.','',26124),
(89302,'enUS','We fight together.','',26124),
(89303,'enUS','Leorajh kill with purpose.','',26124),
(89304,'enUS','Learn much from this.','',26124),
(89305,'enUS','Weak!','',26124),
(89306,'enUS','Our clan is strongest!','',26124),
(89307,'enUS','Go away!','',26124),
(89308,'enUS','You will not hurt master.','',26124),
(89309,'enUS','Sun rock never fail us.','',26124),
(89310,'enUS','Leorajh understands you now.','',26124),
(89311,'enUS','New lessons today?','',26124),
(89312,'enUS','<The scroll details a secret war council meeting that is to take place within Sunspring Watchpost. In order to call the members together, the signal horn in front of the Warsong meeting chambers must be blown.>','',26124),
(89313,'enUS','Leorajh use sun rock, help clan.','',26124),
(89314,'enUS','What teaching does commander bring?','',26124),
(89315,'enUS','Leorajh ready to learn.','',26124),
(89316,'enUS','Where we going?','',26124),
(89317,'enUS','If you require our aid, the tauren will provide it.','If you require our aid, the tauren will provide it.',26124),
(89318,'enUS','Leorajh up for anything.','',26124),
(89319,'enUS','You call Leorajh?','',26124),
(89320,'enUS','For good of clan.','',26124),
(89321,'enUS','Was only beginning... to understand...','',26124),
(89322,'enUS','Leorajh... hurt...','',26124),
(89323,'enUS','Sun rock... not help...','',26124),
(89324,'enUS','Why... Leorajh... cold...?','',26124),
(89325,'enUS','Leorajh help!','',26124),
(89326,'enUS','You no hurt master!','',26124),
(89327,'enUS','You not so tough.','',26124),
(89328,'enUS','Leorajh make you hurt.','',26124),
(89329,'enUS','Do not worry. Leorajh heal.','',26124),
(89330,'enUS','Leorajh heal clan.','',26124),
(89331,'enUS','Furies on our side.','',26124),
(89332,'enUS','Sun rock help us!','',26124),
(89333,'enUS','Do you feel that? RUN! It\'s a STAMPEDE!','',26124),
(89334,'enUS','The Darkspear trolls are yours to command.','The Darkspear trolls are yours to command.',26124),
(89335,'enUS','The archmage gestures toward the forge and awaits your return with the fiery heart of Krosnis.','',26124),
(89336,'enUS','I will leave the defense of the garrison to the Darkspear trolls.','I will leave the defense of the garrison to the Darkspear trolls.',26124),
(89337,'enUS','I want the tauren to protect the garrison.','I want the tauren to protect the garrison.',26124),
(89338,'enUS','','Like I said, the claw has a strange effect on the mounts we\'ve got here. If ye have it with ye when training a mount-in-training, your mount will be MUCH more vulnerable.$B$BShould ye find the training not rough enough, ye might want to challenge yourself.$B$BI\'d have a pretty hefty prize for anyone that could manage that!',26124),
(89339,'enUS','What are your orders, commander?','What are your orders, commander?',26124),
(89340,'enUS','I want the Forsaken to defend the garrison.','I want the Forsaken to defend the garrison.',26124),
(89341,'enUS','The Alliance has defended Stormshield Hold!','',26124),
(89342,'enUS','What are your orders, commander?','What are your orders, commander?',26124),
(89343,'enUS','I want the blood elves to defend the garrison.','I want the blood elves to defend the garrison.',26124),
(89344,'enUS','The Horde has defended Warspear Outpost!','',26124),
(89345,'enUS','Need something, commander? I\'m sure we can work it out.','Need something, commander? I\'m sure we can work it out.',26124),
(89346,'enUS','I want the goblins to defend the garrison.','I want the goblins to defend the garrison.',26124),
(89347,'enUS','Our warriors return via the north gate! They bring treasures from their recent raid!','Our warriors return via the north gate! They bring treasures from their recent raid!',26124),
(89348,'enUS','At least we\'ve wounded it!  How dangerous can it be?','At least we\'ve wounded it!  How dangerous can it be?',26124),
(89349,'enUS','There\'s no way I\'m going back in there, did you see what it did?','There\'s no way I\'m going back in there, did you see what it did?',26124),
(89350,'enUS','|TInterface\\Icons\\Spell_Arcane_Blast.blp:20|t You are afflicted with |cFFFF0404|Hspell:162186|h[Expel Magic: Arcane]|h|r!','|TInterface\\Icons\\Spell_Arcane_Blast.blp:20|t You are afflicted with |cFFFF0404|Hspell:162186|h[Expel Magic: Arcane]|h|r!',26124),
(89351,'enUS','Greetings, commander. How can I be of service?','Greetings, commander. How can I be of service?',26124),
(89352,'enUS','I want the Huojin pandaren to defend the garrison.','I want the Huojin pandaren to defend the garrison.',26124),
(89353,'enUS','','I\'m wounded, leave me. Protect the village below.',26124),
(89354,'enUS','','You should not have come here.',26124),
(89355,'enUS','','You were no match for us.',26124),
(89356,'enUS','','One less problem for the Alliance.',26124),
(89357,'enUS','','Your advance stops here!',26124),
(89358,'enUS','Do you feel that? RUN! It\'s a STAMPEDE!','',26124),
(89359,'enUS','Lookout! The Horde has summoned a Frostwyrm! Get out of the main road!','',26124),
(89360,'enUS','Our warriors return via the south gate! They bring treasures from their recent raid!','Our warriors return via the south gate! They bring treasures from their recent raid!',26124),
(89361,'enUS','I sell designs for the techniques used to harness the power of Draenor\'s crystals. \n\nIf you are skilled enough, you may benefit greatly from this knowledge.','',26124),
(89362,'enUS','I have for sale a collection of plans for the most wondrous creations of your imagination!\n\nCare to take a look?','',26124),
(89363,'enUS','Do you have what it takes to shape the metals of Draenor to your bidding? \n\nIf you do, then my plans may be of use to you.','',26124),
(89364,'enUS','','Ready to turn those raggedy old leathers into something worth wearing?',26124),
(89365,'enUS','I am quite busy, as you can no doubt see. \n\nAre you going to buy something?','',26124),
(89366,'enUS','I can reveal to you the greatest secrets of Inscription if you have the proper skill.','',26124),
(89367,'enUS','Good day $Gsir:mam;, Have anything you want me to break down for you?','',26124),
(89368,'enUS','Send or receive mail.','Send or receive mail.',26124),
(89369,'enUS','Ra-aawwk!','',26124),
(89370,'enUS','','Interested in rare pets? My crawlies are the best!',26124),
(89371,'enUS','','You need to talk to Audrey Burnhep in Stormwind City!  Any guard there should be able to give you directions to find her.\n\nYou will find a portal to Stormwind inside the Mage Tower.  Good luck!',26124),
(89372,'enUS','Come! You have your orders. I ride for Tanaan.','',26124),
(89373,'enUS','The battle for supremacy begins in 2 minutes!','',26124),
(89374,'enUS','The battle for supremacy begins in 1 minute!','',26124),
(89375,'enUS','The battle for supremacy begins in 30 seconds!','',26124),
(89376,'enUS','The battle for supremacy has begun!','',26124),
(89377,'enUS','I need a way to level my followers up quickly.','I need a way to level my followers up quickly.',26124),
(89378,'enUS','Ner\'zhul! Your ambitions are at an end. Today will be the day of your final judgment!','',26124),
(89379,'enUS','I only hope my people will understand.','',26124),
(89380,'enUS','','You cannot escape my blades!',26124),
(89381,'enUS','','Your power will be MINE!',26124),
(89382,'enUS','','You aren\'t afraid of a little blood, are you?',26124),
(89383,'enUS','Hello there stranger!','',26124),
(89384,'enUS','','Hey there, boss, Want me to melt something down for ya?',26124),
(89385,'enUS','','Champion! Let us send this creature back to the shadows!',26124),
(89386,'enUS','Wibson Strike!','',26124),
(89387,'enUS','Save me, Wibson!','',26124),
(89388,'enUS','Oh, now you asked for it... WIBSON! GET THEM!','',26124),
(89389,'enUS','Wibson, use your sand storm, now! Do-do-do-do-do!','',26124),
(89390,'enUS','Wibson, use your fire breath on them!','',26124),
(89391,'enUS','Wibson, slam attack, now!','',26124),
(89392,'enUS','Wibson, hit them with your confuse ray!','',26124),
(89393,'enUS','Oh Wibson, I knew we could do it.','',26124),
(89394,'enUS','$n is victorious!','$n is victorious!',26124),
(89395,'enUS','The Coliseum will close in 5 minutes.','',26124),
(89396,'enUS','This is going to hurt you so much more than it will hurt me.','',26124),
(89397,'enUS','Another trip \'round the murder-go-round, eh?','',26124),
(89398,'enUS','Let\'s have a little bit of fun.','',26124),
(89399,'enUS','Yes... you will do nicely.','',26124),
(89400,'enUS','Very well then. I\'ll kill you first.','',26124),
(89401,'enUS','I will kill you, take a break, raise you from the dead, and then kill you again.','',26124),
(89402,'enUS','Oh good... more of you.','',26124),
(89403,'enUS','You\'re begging me to cut your head off, aren\'t you?','',26124),
(89404,'enUS','That tickled.','',26124),
(89405,'enUS','Scream louder... I can\'t hear you.','',26124),
(89406,'enUS','I had really thought that might have been a challenge.','',26124),
(89407,'enUS','For my next trick... I will make your corpse dance around like a marionette!','',26124),
(89408,'enUS','Really, now. Is that the best you can do?','',26124),
(89409,'enUS','That was short lived.','',26124),
(89410,'enUS','I suppose I\'ll have to take what I can get.','',26124),
(89411,'enUS','Death is all that awaits you.','',26124),
(89412,'enUS','Salutations, commander.','',26124),
(89413,'enUS','I haven\'t killed anything in what feels like ages... might I go on a mission?','',26124),
(89414,'enUS','The Dark Lady watches over us, commander.','',26124),
(89415,'enUS','Commander, I\'m sure you don\'t have a favorite amongst your followers... but if you did, let\'s be honest. I\'m by far the most capable soldier you\'ve got - I don\'t even sleep!','',26124),
(89416,'enUS','Your will is my own, commander.','',26124),
(89417,'enUS','What is it you wish, commander? Say the word and consider it done.','',26124),
(89418,'enUS','I will lay my life on the line for you, commander... what\'s left of it, anyway.','',26124),
(89419,'enUS','Do you think Hellscream has any idea what\'s coming for him? The fool.','',26124),
(89420,'enUS','Death isn\'t so bad... the second time around.','',26124),
(89421,'enUS','The shadows are restless.','',26124),
(89422,'enUS','Your time has come.','',26124),
(89423,'enUS','Gaze into the abyss!','',26124),
(89424,'enUS','RaAWK!','',26124),
(89425,'enUS','A feast for the shadow fiends.','',26124),
(89426,'enUS','Fade away.','',26124),
(89427,'enUS','Kaw-ha-ha! Fool!','',26124),
(89428,'enUS','Wither and fall.','',26124),
(89429,'enUS','Commander.','',26124),
(89430,'enUS','Shadows gather...','',26124),
(89431,'enUS','What ruin shall we dispense today?','',26124),
(89432,'enUS','I have seen good omens for us.','',26124),
(89433,'enUS','I am prepared.','',26124),
(89434,'enUS','At last... I am free.','',26124),
(89435,'enUS','You die!','',26124),
(89436,'enUS','This our territory!','',26124),
(89437,'enUS','Leorajh keep friends alive.','',26124),
(89438,'enUS','Sun rock protect us.','',26124),
(89439,'enUS','Battle make us stronger.','',26124),
(89440,'enUS','Leorajh bring glory to clan.','',26124),
(89441,'enUS','Leorajh kill with purpose.','',26124),
(89442,'enUS','Learn much from this.','',26124),
(89443,'enUS','Weak!','',26124),
(89444,'enUS','Our clan is strongest!','',26124),
(89445,'enUS','New lessons today?','',26124),
(89446,'enUS','Leorajh use sun rock, help clan.','',26124),
(89447,'enUS','What teaching does commander bring?','',26124),
(89448,'enUS','Leorajh ready to learn.','',26124),
(89449,'enUS','Was only beginning... to understand...','',26124),
(89450,'enUS','Come quickly. We must not let him overwhelm us.','',26124),
(89451,'enUS','For Terokk!','',26124),
(89452,'enUS','Back, you filth!','',26124),
(89453,'enUS','KrAWW!','',26124),
(89454,'enUS','Let us get to work.','',26124),
(89455,'enUS','Grim... but necessary','',26124),
(89456,'enUS','Die well.','',26124),
(89457,'enUS','Hah - too easy.','',26124),
(89458,'enUS','This is how we do it in Skettis.','',26124),
(89459,'enUS','Our path is right, of this I am certain.','',26124),
(89460,'enUS','My life for the Talon King.','',26124),
(89461,'enUS','Ready when you are, my king.','',26124),
(89462,'enUS','By your command.','',26124),
(89463,'enUS','I will follow you to the end.','',26124),
(89464,'enUS','My service has ended...','',26124),
(89465,'enUS','The Knights of the Ebon Blade are here.','The Knights of the Ebon Blade are here.',26124),
(89466,'enUS','I want the Knights of the Ebon Blade to defend the garrison.','I want the Knights of the Ebon Blade to defend the garrison.',26124),
(89467,'enUS','|TInterface\\Icons\\SPELL_HOLY_PROCLAIMCHAMPION_02.BLP:##|t |cFFF00000%s|r is victorious!','|TInterface\\Icons\\SPELL_HOLY_PROCLAIMCHAMPION_02.BLP:##|t |cFFF00000%s|r is victorious!',26124),
(89468,'enUS','Initializing defense sequence.','',26124),
(89469,'enUS','Actuating subjugation systems.','',26124),
(89470,'enUS','Threat detected.','',26124),
(89471,'enUS','Commencing conflict resolution routines.','',26124),
(89472,'enUS','Engaging purification module.','',26124),
(89473,'enUS','Murder drive online.','',26124),
(89474,'enUS','Anomaly detected.','',26124),
(89475,'enUS','Outcome optimal.','',26124),
(89476,'enUS','Threat neutralized.','',26124),
(89477,'enUS','Sequence completed.','',26124),
(89478,'enUS','Conflict resolved.','',26124),
(89479,'enUS','Relations module: Have a nice day. END: Relations module.','',26124),
(89480,'enUS','Apexis core online. Power reserves at ninety-nine percent.','',26124),
(89481,'enUS','Systems optimal. Awaiting input.','',26124),
(89482,'enUS','Maintenance cycle complete. Looping standby routine.','',26124),
(89483,'enUS','Master detected. Diverting power to relations module. Relations module: Greetings.','',26124),
(89484,'enUS','Relations module: Master, do I have a soul? Ha-ha-ha. Just kidding. END: Relations module.','',26124),
(89485,'enUS','Error: Locomotion systems non-functional. Jettisoning ellipses...','',26124),
(89486,'enUS','','The light shall protect us!',26124),
(89487,'enUS','I have failed my Horde, my tribe, my chieftain...','',26124),
(89488,'enUS','','Present a challenge at least.',26124),
(89489,'enUS','','I salute you.',26124),
(89490,'enUS','','You shall taste my blade.',26124),
(89491,'enUS','','Glorious.',26124),
(89492,'enUS','','Well fought.',26124),
(89493,'enUS','','Lok\'tar.',26124),
(89494,'enUS','','Hail, $p.',26124),
(89495,'enUS','Tiny thing.','',26124),
(89496,'enUS','Beating time!','',26124),
(89497,'enUS','Nobody beats Blook!','',26124),
(89498,'enUS','','We will persevere!',26124),
(89499,'enUS','But... Blook beats. Not beaten.','',26124),
(89500,'enUS','You beaten by Blook.','',26124),
(89501,'enUS','Blooked!','',26124),
(89502,'enUS','Beated!','',26124),
(89503,'enUS','Hail, Blook beater.','',26124),
(89504,'enUS','Hi beater boss.','',26124),
(89505,'enUS','I am Bashiok!','',26124),
(89506,'enUS','I... am... Bashiok.','',26124),
(89507,'enUS','You made a mistake comin\' ta Warspear.','',26124),
(89508,'enUS','You think you can kill me with that? Ha!','',26124),
(89509,'enUS','Another fool falls.','',26124),
(89510,'enUS','Yes! Charge toward your death!','',26124),
(89511,'enUS','I\'m gonna punch a grin into your face.','',26124),
(89512,'enUS','You die better than ya fight.','',26124),
(89513,'enUS','I am going to put a smile on your corpse.','',26124),
(89514,'enUS','You call that a fighting style? Ha ha ha!','',26124),
(89515,'enUS','Your allies have no sense of humor, or pain threshold.','',26124),
(89516,'enUS','You are foolish ta challenge me!','',26124),
(89517,'enUS','I laugh at my own defeat!','',26124),
(89518,'enUS','Slay dem all!','',26124),
(89519,'enUS','I am all that is ORC!','',26124),
(89520,'enUS','Stay there, I\'m going to burn your corpse later.','',26124),
(89521,'enUS','Aw. You fell down.','',26124),
(89522,'enUS','Stop looking at me!','',26124),
(89523,'enUS','Never fight like that again.','',26124),
(89524,'enUS','May you have the last laugh, commander.','',26124),
(89525,'enUS','Your troops seem afraid of my headbutting competition.','',26124),
(89526,'enUS','How you find me?','',26124),
(89527,'enUS','Dagg is the greatest thief that ever lived!','',26124),
(89528,'enUS','You no see me!','',26124),
(89529,'enUS','How... you... see... Dagg... ?','',26124),
(89530,'enUS','Dagg rolling need.','',26124),
(89531,'enUS','Dagg dibs on loot!','',26124),
(89532,'enUS','You find more treasure?','',26124),
(89533,'enUS','Always be looking for Dagg.','',26124),
(89534,'enUS','How you see through Dagg\'s dis guys?','',26124),
(89535,'enUS','Dis guys Dagg!','',26124),
(89536,'enUS','You best boss Dagg ever had. Dagg is unanimous in dis.','',26124),
(89537,'enUS','You\'s dead. Dagg is unanimous in dis.','',26124),
(89538,'enUS','Dat give Dagg idea for new dis guys.','',26124),
(89539,'enUS','Fresh prey.','',26124),
(89540,'enUS','More food for my pet.','',26124),
(89541,'enUS','Ah! Something to test my new traps on.','',26124),
(89542,'enUS','This... was a terrible... idea...','',26124),
(89543,'enUS','Pathetic.','',26124),
(89544,'enUS','You chose the wrong side, fool.','',26124),
(89545,'enUS','Still the highest predator on the food chain, commander?','',26124),
(89546,'enUS','For the Kirin Tor!','',26124),
(89547,'enUS','What do you believe you will accomplish?','',26124),
(89548,'enUS','Oh dear, do you believe you will win?','',26124),
(89549,'enUS','Fascinating. How barbaric.','',26124),
(89550,'enUS','You do realize I am not really here, don\'t you?','',26124),
(89551,'enUS','I\'m losing control of my image...','',26124),
(89552,'enUS','Well, that was an interesting result.','',26124),
(89553,'enUS','With some practice you might have been a greater threat.','',26124),
(89554,'enUS','Well met, commander.','',26124),
(89555,'enUS','Greetings Commander.','',26124),
(89556,'enUS','','I am going to burn a smile on that face of yours.',26124),
(89557,'enUS','','Hahahaha!',26124),
(89558,'enUS','','I am going to wear your skull.',26124),
(89559,'enUS','','I will get you to laugh.',26124),
(89560,'enUS','','I... die... laughing!',26124),
(89561,'enUS','','Burn my body... keep... my skull.',26124),
(89562,'enUS','','Don\'t die yet. I\'m not done with you.',26124),
(89563,'enUS','','Say hello to goodbye!',26124),
(89564,'enUS','','When you die, might I wear your skull?',26124),
(89565,'enUS','','May your enemies burn!',26124),
(89566,'enUS','','For the Frostwolves!',26124),
(89567,'enUS','','Spirits guide me!',26124),
(89568,'enUS','','You have bit off more than you can chew, $t.',26124),
(89569,'enUS','','We stand ready!',26124),
(89570,'enUS','','For honor!',26124),
(89571,'enUS','','Honorless fool.',26124),
(89572,'enUS','','Victory for the Frostwolves.',26124),
(89573,'enUS','','Asha... I\'m coming...',26124),
(89574,'enUS','','Hail.',26124),
(89575,'enUS','This is what I call a target rich environment.','',26124),
(89576,'enUS','I come for you, $n!','',26124),
(89577,'enUS','Going... down...','',26124),
(89578,'enUS','Top axe!','',26124),
(89579,'enUS','Requesting a flyby.','',26124),
(89580,'enUS','You can be my wingman anytime.','',26124),
(89581,'enUS','Let us see what you are made of.','',26124),
(89582,'enUS','Can you fold in half? Let us see.','',26124),
(89583,'enUS','A challenger?','',26124),
(89584,'enUS','Well... fought...','',26124),
(89585,'enUS','Boot to the head.','',26124),
(89586,'enUS','You must learn to be faster than any punch.','',26124),
(89587,'enUS','You never stood a chance.','',26124),
(89588,'enUS','These soldiers of yours need to be tougher.','',26124),
(89589,'enUS','I look forward to our next challenge, Commander.','',26124),
(89590,'enUS','Lug\'dol is nearby.','',26124),
(89591,'enUS','','One shot, one kill.',26124),
(89592,'enUS','','You cannot escape.',26124),
(89593,'enUS','','I have a poison just for you.',26124),
(89594,'enUS','','What a waste of arrows.',26124),
(89595,'enUS','','Target practice.',26124),
(89596,'enUS','','Burn... my body...',26124),
(89597,'enUS','','Cover your tracks.',26124),
(89598,'enUS','Ya dead, mon. Ya just don\' know it yet.','',26124),
(89599,'enUS','We gonna kill ya mon. Nothin\' personal.','',26124),
(89600,'enUS','For da Warchief!','',26124),
(89601,'enUS','For da Horde!','',26124),
(89602,'enUS','Neva\' know what hit ya.','',26124),
(89603,'enUS','Ya gonna be bleedin\' soon, mon.','',26124),
(89604,'enUS','It gonna take... more... dan... dat to kill... me.','',26124),
(89605,'enUS','Ya dead, mon!','',26124),
(89606,'enUS','Anotha\' one be down.','',26124),
(89607,'enUS','Ding!','',26124),
(89608,'enUS','Taz\'dingo!','',26124),
(89609,'enUS','Watch da shadows, boss-mon','',26124),
(89610,'enUS','Eh, boss-mon.','',26124),
(89611,'enUS','Vol\'jin sends his regards.','',26124),
(89612,'enUS','May I take your cloak? No? Very well, commander. The commander is, of course, welcome to continue dripping mud all over the floor that I have spent just this morning polishing.','',26124),
(89613,'enUS','You would ally with the enemy, Tormmok? You betray your king!','',26124),
(89614,'enUS','Yeah, yeah let\'s, let\'s... incinerate and pulverate \'em!','',26124),
(89615,'enUS','Ha! Quit... hitting yourselves!','',26124),
(89616,'enUS','Pump the forge up to overdrive!','',26124),
(89617,'enUS','I\'ll be back!','',26124),
(89618,'enUS','Wait till they get a load of me.','',26124),
(89619,'enUS','No, Aaagh! I wasn\'t done yet!','',26124),
(89620,'enUS','No, not like this....','',26124),
(89621,'enUS','I\'m going to take you DOWN!','',26124),
(89622,'enUS','Ahh, I\'ve been waiting for something to pulverize and incinerate!','',26124),
(89623,'enUS','Defenseless weakling!','',26124),
(89624,'enUS','There can only be... two! Ha ha ha!','',26124),
(89625,'enUS','Hah, you think that was good? You just wait!','',26124),
(89626,'enUS','If it bleeds, we can kill it!','',26124),
(89627,'enUS','Hear me now... and believe me... later....','',26124),
(89628,'enUS','Your bones will be crushed to dust!','',26124),
(89629,'enUS','Oh no yeh don\'t!','',26124),
(89630,'enUS','Imma beat dis one down!','',26124),
(89631,'enUS','C\'mere! I got sumtun\' fer yeh!','',26124),
(89632,'enUS','Yer gettin\' a good swift kick inna jimmies.','',26124),
(89633,'enUS','Oh yeh want somma dis do yeh?','',26124),
(89634,'enUS','Oh aye, that\'s watcha get.','',26124),
(89635,'enUS','And I\'ll do tha same ta yer mum!','',26124),
(89636,'enUS','An\' stay down!','',26124),
(89637,'enUS','Har! Smoked \'at one.','',26124),
(89638,'enUS','%s belches.','',26124),
(89639,'enUS','Ah-hyup!','',26124),
(89640,'enUS','Jes\' gimmie somethun\' ta shoot.','',26124),
(89641,'enUS','Issit time ta eat yet?','',26124),
(89642,'enUS','They won\'t let me near tha powder reserves. Whadder they reservin\' it fer, anyways!?','',26124),
(89643,'enUS','Yer heals is CRAP!','',26124),
(89644,'enUS','I have no king. I\'ve chosen my side.','',26124),
(89645,'enUS','I loot the hat.','',26124),
(89646,'enUS','%s squeaks.','',26124),
(89647,'enUS','I. AM. BASHIOK!','',26124),
(89648,'enUS','I am Bashiok.','',26124),
(89649,'enUS','I AM Bashiok.','',26124),
(89650,'enUS','Ahahahaha!','',26124),
(89651,'enUS','Bugs, you are bugs to me!','',26124),
(89652,'enUS','More, bring more to die at my blade!','',26124),
(89653,'enUS','You are a fool to oppose me weakling!','',26124),
(89654,'enUS','Too easy','',26124),
(89655,'enUS','Give in now, Socrethar. You have been bested.','',26124),
(89656,'enUS','The empire... will rise again!','',26124),
(89657,'enUS','Your will is meaningless here.','',26124),
(89658,'enUS','Victory or death!','',26124),
(89659,'enUS','You should run while you can.','',26124),
(89660,'enUS','No foe can stand to my might!','',26124),
(89661,'enUS','You should have ran.','',26124),
(89662,'enUS','Hammer! Meet face!','',26124),
(89663,'enUS','I\'ll forge a weapon in your honor commander.','',26124),
(89664,'enUS','I saw a new shipment of ore. I\'ll make sure it goes to good use.','',26124),
(89665,'enUS','What do you ask of me?','',26124),
(89666,'enUS','Thank you once more for my freedom.','',26124),
(89667,'enUS','Commander, I can never repay the debt.','',26124),
(89668,'enUS','I have not yet gotten used to being under the sky all day.','',26124),
(89669,'enUS','At least... I die... free.','',26124),
(89670,'enUS','Will you grab my sword, commander? I cannot penetrate the runic circle Dar\'gud placed around it.','',26124),
(89671,'enUS','Are these orcs alive, or undead?','Are these orcs alive, or undead?',26124),
(89672,'enUS','I am eternally grateful.','',26124),
(89673,'enUS','I live another day. You have my thanks.','',26124),
(89674,'enUS','The furies will never forget this, thank you.','',26124),
(89675,'enUS','You have made a powerful ally, friend.','',26124),
(89676,'enUS','Saving','Saving',26124),
(89677,'enUS','STAND AT ATTENTION!','',26124),
(89678,'enUS','GET BACK TO WORK!','',26124),
(89679,'enUS','I\'M SURROUNDED BY LAZY RUNTS!','',26124),
(89680,'enUS','','Do you see the light up ahead? That must be it!',26124),
(89681,'enUS','','That light up ahead must be where the crystal is. Hellmaw must be there.',26124),
(89682,'enUS','The scent of blood attracts nearby goren nibblers!','',26124),
(89683,'enUS','You will pay dearly for your interference, mortal.','',26124),
(89684,'enUS','','Well done! Let us get the Light of Exodus to safety.',26124),
(89685,'enUS','','You hear a barely audible whistle come from the south.',26124),
(89686,'enUS','','And don\'t come back, demon scum. Commander, let\'s get the Light of Exodus out of here.',26124),
(89687,'enUS','|TInterface\\Icons\\Ability_Druid_EmpoweredTouch:20|t Yalnu begins to channel |cFFFF0404|Hspell:169613|h[Genesis]|h|r.','',26124),
(89688,'enUS','Bah, those peons at the docks must be slacking.','Bah, those peons at the docks must be slacking.',26124),
(89689,'enUS','What happened?  Our machinery stopped working.','What happened?  Our machinery stopped working.',26124),
(89690,'enUS','Send one of the runts down to the docks to check this out.','Send one of the runts down to the docks to check this out.',26124),
(89691,'enUS','Send one of the runts down to the furnace to check this out.','Send one of the runts down to the furnace to check this out.',26124),
(89692,'enUS','What happened to the presses?  They\'ve gone cold!','What happened to the presses?  They\'ve gone cold!',26124),
(89693,'enUS','Where\'s Foreman Feldspar? Someone needs to get these running again!','Where\'s Foreman Feldspar? Someone needs to get these running again!',26124),
(89694,'enUS','Keep them away from me!','',26124),
(89695,'enUS','I\'m not dying first this time.','',26124),
(89696,'enUS','Stay away!','',26124),
(89697,'enUS','Stop it. Stop... just stop that.','',26124),
(89698,'enUS','I\'m keeping the loot.','',26124),
(89699,'enUS','Whew.','',26124),
(89700,'enUS','I got one. Hey guys - I got one!','',26124),
(89701,'enUS','\"Warlord\" Schweitzer. I like the sound of that.','',26124),
(89702,'enUS','One step closer to High Marshall.','',26124),
(89703,'enUS','This garrison needs a trampoline.','',26124),
(89704,'enUS','When are you building the ball-pit?','',26124),
(89705,'enUS','Can we build a brewery next?','',26124),
(89706,'enUS','Commander, the men are demanding a water slide. By \"the men\" I mean me.','',26124),
(89707,'enUS','When are you building the mosh-pit?','',26124),
(89708,'enUS','Can we get a park? Like Stormwind. But, not like Stormwind.','',26124),
(89709,'enUS','Commander I\'d like to formally apologize for last night\'s wet-tabard contest.','',26124),
(89710,'enUS','...again... ?','',26124),
(89711,'enUS','Suck mana, twerp!','Suck mana, twerp!',26124),
(89712,'enUS','I\'ve got this.','I\'ve got this.',26124),
(89713,'enUS','Eat it!','Eat it!',26124),
(89714,'enUS','Have at it!','Have at it!',26124),
(89715,'enUS','Weak.','Weak.',26124),
(89716,'enUS','Ha HAH - for Gnomeregan!','Ha HAH - for Gnomeregan!',26124),
(89717,'enUS','Pathetic.','Pathetic.',26124),
(89718,'enUS','Sad.','Sad.',26124),
(89719,'enUS','Dead!','Dead!',26124),
(89720,'enUS','Might I suggest upgraded mage facilities?','Might I suggest upgraded mage facilities?',26124),
(89721,'enUS','Commander, how do I get into the more... lucrative missions?','Commander, how do I get into the more... lucrative missions?',26124),
(89722,'enUS','My gear is gemmed and enchanted, commander!','My gear is gemmed and enchanted, commander!',26124),
(89723,'enUS','When you have the time, commander, I\'d like to suggest some ways you can optimize your gear.','When you have the time, commander, I\'d like to suggest some ways you can optimize your gear.',26124),
(89724,'enUS','Out... of... manaaaa...','Out... of... manaaaa...',26124),
(89725,'enUS','','I\'ll get this one.',26124),
(89726,'enUS','','Cover me!',26124),
(89727,'enUS','','Call the shot...',26124),
(89728,'enUS','','Oooh, right in the neck!',26124),
(89729,'enUS','','Ooh! Gut shot.',26124),
(89730,'enUS','','Ooh! Gut shot.',26124),
(89731,'enUS','','Ow! Right through the head.',26124),
(89732,'enUS','','Dropped one.',26124),
(89733,'enUS','','I\'m your biggest fan, commander.',26124),
(89734,'enUS','','I\'m so glad to be here. My last party was... I think they\'re dead.',26124),
(89735,'enUS','','Shadowmoon is so pretty!',26124),
(89736,'enUS','','This garrison is SO much nicer than Admiral Taylor\'s.',26124),
(89737,'enUS','','...help!',26124),
(89738,'enUS','Fly me to Warspear Outpost!','Fly me to Warspear Outpost!',26124),
(89739,'enUS','Quick $n, the Grand Marshal wants to see you back at Stormshield at once!','Quick $n, the Grand Marshal wants to see you back at Stormshield at once!',26124),
(89740,'enUS','','Fresh bread! Fresh bread for sale!',26124),
(89741,'enUS','','Warm, wholesome bread!',26124),
(89742,'enUS','','Rolls, buns and bread. Fresh from the oven!',26124),
(89743,'enUS','','Come and get your freshly baked bread!',26124),
(89744,'enUS','I hear that Harrison Jones still isn\'t any closer to finding that artifact.','',26124),
(89745,'enUS','','How long does he plan to take? We can\'t stay holed up here forever with the Horde breathing down our necks.',26124),
(89746,'enUS','I hope it\'s not much longer. I haven\'t seen my family in Stormwind in months.','',26124),
(89747,'enUS','','The Horde is growing bolder every day. They attacked another one of our outposts this morning.',26124),
(89748,'enUS','Did those mongrels forget that we\'re supposed to have a treaty?','',26124),
(89749,'enUS','','It looks that way. I think they fear that if we do find the artifact, we\'ll end up using it against them.',26124),
(89750,'enUS','If they keep attacking our soldiers the way they have been, they may just drive us to it.','',26124),
(89751,'enUS','Flank and destroy!','',26124),
(89752,'enUS','Annihilate them.','',26124),
(89753,'enUS','For Orgrimmar, for the Horde - for the glory of our fathers!','',26124),
(89754,'enUS','I will end this.','',26124),
(89755,'enUS','Leave their bones to amuse the wolves.','',26124),
(89756,'enUS','%s spits on the corpse.','',26124),
(89757,'enUS','The taste of victory never sours.','',26124),
(89758,'enUS','Take the body but save me the teeth.','',26124),
(89759,'enUS','Nothing more beautiful than blood on the snow.','',26124),
(89760,'enUS','Glory to the mighty Horde, commander!','',26124),
(89761,'enUS','None dare question your strength.','',26124),
(89762,'enUS','Frostfire is secured for the Horde. If we need to construct another garrison, I volunteer to be among the vanguard.','',26124),
(89763,'enUS','Glory to the new Warchief! Even if he isn\'t an orc.','',26124),
(89764,'enUS','Send me to the front. My strength is yours to command.','',26124),
(89765,'enUS','We will see our enemies driven before us! We will hear the lamentations of - whatever would lament these beasts. I can\'t wait to hear them lamenting! Ha hah! Lamenters are funny.','',26124),
(89766,'enUS','I give my life... for... THE HORDE!','',26124),
(89767,'enUS','','Eek - get them!',26124),
(89768,'enUS','','Oh! Oh! I\'m fighting!',26124),
(89769,'enUS','','They\'re in our base! They\'re breaking all my things!',26124),
(89770,'enUS','','I\'m casting magic!',26124),
(89771,'enUS','','Yea THAT happened.',26124),
(89772,'enUS','','And I wasn\'t even paying attention.',26124),
(89773,'enUS','','Yay!',26124),
(89774,'enUS','','So dead.',26124),
(89775,'enUS','','Hi!',26124),
(89776,'enUS','','Oooh, I like your gear.',26124),
(89777,'enUS','','I love what you\'ve done with your place.',26124),
(89778,'enUS','','I\'m sorry about all my demons burning your things. They do that.',26124),
(89779,'enUS','','But... but... no!',26124),
(89780,'enUS','I will disintegrate them.','',26124),
(89781,'enUS','Heh. Heh. Heh. Heh heh HAH.','',26124),
(89782,'enUS','Oh such sweet glorious slaughter!','',26124),
(89783,'enUS','Look what just walked in. Parts!','',26124),
(89784,'enUS','Save the best parts for me!','',26124),
(89785,'enUS','Save the limbs, I can use those.','',26124),
(89786,'enUS','Face: Melted.','',26124),
(89787,'enUS','If there are any brains left, save them for me.','',26124),
(89788,'enUS','I could build such a wonderful creature from these parts.','',26124),
(89789,'enUS','Those organs will fetch a pretty price.','',26124),
(89790,'enUS','My work is progressing wonderfully on Draenor. There just aren\'t as many \"laws\" here to fret over.','',26124),
(89791,'enUS','I was wondering if I had your permission to \'experiment\' on some of the guards... ?','',26124),
(89792,'enUS','Can I offer you some embalming fluid, commander?','',26124),
(89793,'enUS','Let me run this by you: Instead of five ordinary-sized guards, what if we stitched together one enormous shambly guard? Think of the possibilities!','',26124),
(89794,'enUS','I adore the frigid cold of Frostfire Ridge. It arrests corpse decay.','',26124),
(89795,'enUS','How are you doing, commander? Are you happy with your arms? would you like... a third? You know who to talk to.','',26124),
(89796,'enUS','Most of your other followers have redundant kidneys. You wouldn\'t mind if I \"borrowed\" a few? The bathtub is ready.','',26124),
(89797,'enUS','I will haunt you!','',26124),
(89798,'enUS','Imma get dis one!','',26124),
(89799,'enUS','*Cough* Are we fighting something?','',26124),
(89800,'enUS','*Cough cough* Eh? We fightin\'?','',26124),
(89801,'enUS','Hey mon I kill dis one!','',26124),
(89802,'enUS','Dat\'s right.','',26124),
(89803,'enUS','Grav wit\' da kill, oh yah.','',26124),
(89804,'enUS','$n (Alliance) has looted the |c00FFFF00|Hspell:168506|h[Ancient Artifact]|h|r!','',26124),
(89805,'enUS','Mmnn-hmmm!','',26124),
(89806,'enUS','Imma cook you for dinner.','',26124),
(89807,'enUS','$n (Horde) has looted the |c00FFFF00|Hspell:168506|h[Ancient Artifact]|h|r!','',26124),
(89808,'enUS','Lookout it\'s da commander!','',26124),
(89809,'enUS','I ain\'t doin\' nothin\' wrong over here.','',26124),
(89810,'enUS','Commander! You didn\'t see nothin\' did you? No? I\'m good, we all good. Everything be good here.','',26124),
(89811,'enUS','Hey Commander you hungry?','',26124),
(89812,'enUS','Shhhh quiet here come da commander. Shh! Hey. Hi.','',26124),
(89813,'enUS','%s goes into a coughing fit.','',26124),
(89814,'enUS','For the... Allia- uh - HORDE!','',26124),
(89815,'enUS','For somebody!','',26124),
(89816,'enUS','What are these guys doing here?','',26124),
(89817,'enUS','Don\'t kill me! I\'m a priest!','',26124),
(89818,'enUS','That was one hell of a bender last night. When did it start snowing in Shadowmoon?','',26124),
(89819,'enUS','Commander I uh - come closer - shhh - I think there\'s some Horde spies in our base.','',26124),
(89820,'enUS','What\'s with all the skulls and spikes? It\'s like... does the King know about this?','',26124),
(89821,'enUS','Commander I don\'t know what contractors you\'re using but if you ask me this looks like a Horde base.','',26124),
(89822,'enUS','Welcome, gladiators! You have been hand selected by Imperator Mar\'gok himself to participate in these gladiatorial games! An honor this great is reserved only for the most bloodthirsty and savage fighters of Draenor. May honor and victory be yours today!','',26124),
(89823,'enUS','I came across a Horde patrol trying to sweep around one of our outposts today.','',26124),
(89824,'enUS','','Did you, now? Were you spotted?',26124),
(89825,'enUS','Yeah, one of em saw me. Knife to the eye took care of that.','',26124),
(89826,'enUS','Fly me to Stormshield Hold.','Fly me to Stormshield Hold.',26124),
(89827,'enUS','Board the platform. It will take you to the arena floor, where glory awaits!','',26124),
(89828,'enUS','','Let me guess, subtlety not your strong suit?',26124),
(89829,'enUS','I got myself a shiny new knife when I was out scouting today.','',26124),
(89830,'enUS','','Oh yeah? Where did you find it?',26124),
(89831,'enUS','Belly of one of them goren.','',26124),
(89832,'enUS','Once that elevator starts moving this room will flood with deadly poison gas, killing anyone left behind. I suggest you get aboard the platform.','',26124),
(89833,'enUS','That\'s it, get bunched up on the platform. You don\'t want to be left behind down here. No, not with the poison gas that we\'ll be releasing in here to clear out cowards.','',26124),
(89834,'enUS','Get on the platform! The elevator will begin its glorious ascent into the arena shortly!','',26124),
(89835,'enUS','Good luck, champions! May the strongest among you earn glory in the Coliseum today!','',26124),
(89836,'enUS','','You found a knife in the stomach of a goren? What made you even think of cutting it open?',26124),
(89837,'enUS','Where else do you think one of them things would keep its loot?','',26124),
(89838,'enUS','I... see...','',26124),
(89839,'enUS','I don\'t know why Harrison Jones asked us to come out here and help with the excavation. I can\'t hunt for a single artifact without an ogre trying to cut me in half!','',26124),
(89840,'enUS','If you think the ogres are bad, you should see the spirit ogres around that altar. Bad news, there.','',26124),
(89841,'enUS','Spirit ogres? Geez, this island sure has some creative ways to kill a guy.','',26124),
(89842,'enUS','So I hear that they\'re uncovering some interesting stuff in the mines. Harrison is staying pretty hush hush about it though.','',26124),
(89843,'enUS','Why do you think that is?','',26124),
(89844,'enUS','I spoke to one of the workers, and they think the place is haunted. They say folks are disappearing, and then there\'s the accidents.','',26124),
(89845,'enUS','Weird ones. Solid cave walls up and crumbling on a digger. Malfunctioning machinery chewing up its operator. They say it happens more and more the further down you go.','',26124),
(89846,'enUS','I don\'t like the sound of that. I think I\'ll just stay here at the inn.','',26124),
(89847,'enUS','You get no argument from me, there.','',26124),
(89848,'enUS','Accidents? What kind of accidents?','',26124),
(89849,'enUS','How did you get over here?','',26124),
(89850,'enUS','It\'s quiet over here, don\'t you think? Almost... too quiet.','',26124),
(89851,'enUS','Poisoning','Poisoning',26124),
(89852,'enUS','Hurry $n, Volrath has ordered you to return to Warspear at once!','Hurry $n, Volrath has ordered you to return to Warspear at once!',26124),
(89853,'enUS','Kronus is born! Good work, $n.','',26124),
(89854,'enUS','Look around you. Can you not see that we have already won?','',26124),
(89855,'enUS','The artifact fragments contain enough magical power to restore this Earth Fury to full strength. $B$BHow many have you brought us?','',26124),
(89856,'enUS','Report from the field, sir!','',26124),
(89857,'enUS','De Alliance can\'t have Ashran, $c. Da powa of any Ogre artifacts here will be ours.','',26124),
(89858,'enUS','','Alliance soldiers, take their supplies quickly and take a gryphon back to Stormshield Stronghold!',26124),
(89859,'enUS','','Alliance soldiers, we must leave now! Horde reinforcements are on their way.',26124),
(89860,'enUS','','Retreat quickly, Alliance reinforcements are arriving soon!',26124),
(89861,'enUS','','Plunder their supplies then grab a wyvern back to Warspear Outpost!',26124),
(89862,'enUS','Loosen yer belts, ladies! We\'re eatin\' a feast tonight!','',26124),
(89863,'enUS','','I shoot to kill.',26124),
(89864,'enUS','','What are you lookin\' at?',26124),
(89865,'enUS','By all that is unholy, what is that thing?','',26124),
(89866,'enUS','','No one pulls a fast one on me.',26124),
(89867,'enUS','','Dark Lady save us all... it\'s worse than I thought.',26124),
(89868,'enUS','It seems the ogres at Brute\'s Rise are employing large beasts to hurl giant boulders at our troops!','',26124),
(89869,'enUS','So the ogres like to throw stones, do they?','',26124),
(89870,'enUS','I\'ll have Sprocket ready one of his tanks to pay them a visit. We\'ll see how their stones fare against steel.','',26124),
(89871,'enUS','Thank you for your report, soldier. You may return to the field.','',26124),
(89872,'enUS','Yes sir!','',26124),
(89873,'enUS','Something resembling sap drools out of Acanthus\' mouth.','',26124),
(89874,'enUS','Sir, our scouts report that the Horde forces are working to empower an ancient earth fury!','',26124),
(89875,'enUS','A fury of the earth, you say? That is troubling.','',26124),
(89876,'enUS','I will have to confer with our druid allies. The ancient that they are awakening may be our only key to defeating such a force.','',26124),
(89877,'enUS','$n has placed a Savage Feast.','$n has placed a Savage Feast.',26124),
(89878,'enUS','Reports are coming in of a massive beast residing in the ogre mine.','',26124),
(89879,'enUS','None of our scouts have been able to get a good look at it, but its so massive it barely fits in the cave!','',26124),
(89880,'enUS','We will have to alert our men fighting near the cave. Good work, soldier.','',26124),
(89881,'enUS','Commander, I suggest we get out o\' here. This is nae a place ye want ta stick around in.','',26124),
(89882,'enUS','','Disgusting. Commander, I\'ll watch your back while you grab what\'s left of that... thing.',26124),
(89883,'enUS','Harrison Jones is reports that though he has received several fragments, he is no closer to discovering the location of the artifact we seek.','',26124),
(89884,'enUS','He requests more men to aid in the search.','',26124),
(89885,'enUS','He asks as if we have an endless supply of adventurers at our disposal. He will get whoever volunteers to aid him. Our soldiers are already spread thin due to the Horde threat.','',26124),
(89886,'enUS','The shadows have granted me new strength.','',26124),
(89887,'enUS','Leorajh is stronger!','',26124),
(89888,'enUS','Yes... I grow ever closer to the shadows.','',26124),
(89889,'enUS','Leorajh more powerful than ever!','',26124),
(89890,'enUS','There is the one we seek. Her staff is the key.','',26124),
(89891,'enUS','Yes... excellent. RaAWK!','',26124),
(89892,'enUS','Give Leorajh back his prayer beads!','',26124),
(89893,'enUS','Commander, we did it!','',26124),
(89894,'enUS','','Thanks sweetie. Now back to battle!',26124),
(89895,'enUS','','I was dying in there! Thanks!',26124),
(89896,'enUS','Alright, Twix... let\'s take a look at the fabled predator Aogexon!','',26124),
(89897,'enUS','We aren\'t the only ones with Prisoners, $c.$B$BOver at the Alliance base, underneath their main building lies their prison.$B$BWe just need to find those Stormshield Prison Keys to break them out.','',26124),
(89898,'enUS','','You got it boss! Initiating holo-projection D-092!',26124),
(89899,'enUS','It\'s been said that Aogexon\'s fangs can cut through solid steel! Magnificent!','',26124),
(89900,'enUS','We simply must have Aogexon\'s fangs, Twixnee. They will make fine fossils one day!','',26124),
(89901,'enUS','Let\'s move on to the next specimen!','',26124),
(89902,'enUS','','Next up in the database is Bergruu. Initiating holo-projection D-093...',26124),
(89903,'enUS','Ahh yes! Bergruu, the mighty Ironhide of the northern plains! Bergruu\'s horn is said to be the largest clefthoof horn ever seen...','',26124),
(89904,'enUS','','Has anyone actually gotten close enough to measure the thing?',26124),
(89905,'enUS','Not yet! However, there are several collectors that would pay a fortune to acquire it.','',26124),
(89906,'enUS','Let\'s move on to Dekorhan, the mysterious and ancient Elekk of Nagrand!','',26124),
(89907,'enUS','','Initiating holo-projection D-095...',26124),
(89908,'enUS','Elekk are one of the oldest living species on Draenor, and Dekorhan sightings have been recorded by the orcs for generations...','',26124),
(89909,'enUS','Pop quiz, Twix! How do you tell the age of an Elekk?','',26124),
(89910,'enUS','','Umm... by the size of its tusks?',26124),
(89911,'enUS','Precisely! Did you learn that from me?','',26124),
(89912,'enUS','','That size matters? Uhh... yeah, sure! You bet!',26124),
(89913,'enUS','Now then, let\'s review the deadly and elusive talbuk known as Direhoof...','',26124),
(89914,'enUS','','Holo-projection D-096 initiated, boss!',26124),
(89915,'enUS','Direhoof is the most dangerous talbuk this side of Nagrand, and a specimen of rare quality...','',26124),
(89916,'enUS','It\'s our duty as archaeologists to preserve this mighty beast while still in the prime of its life!','',26124),
(89917,'enUS','','Just hearing you speak makes me proud to be an archaeologist, sir!',26124),
(89918,'enUS','As it should, Twixnee... as it should.','',26124),
(89919,'enUS','Now, on to the next specimen!','',26124),
(89920,'enUS','','Initiating holo-projection D-097... Gagrog the Brutal!',26124),
(89921,'enUS','Such a magnificently brutal creature! Few Gronn are as feared as Gagrog the Brutal!','',26124),
(89922,'enUS','','Hide the women and the children! Hide everybody!',26124),
(89923,'enUS','Somewhere out there, in a private collection, is an empty place just waiting for Gagrog\'s skull to fill the void.','',26124),
(89924,'enUS','Boss, you\'re bringing tears to my eyes!','',26124),
(89925,'enUS','This is our town, scrub.','This is our town, scrub.',26124),
(89926,'enUS','Yeah, beat it!','Yeah, beat it!',26124),
(89927,'enUS','Behold the power of the Legion!','',26124),
(89928,'enUS','I will destroy you!','',26124),
(89929,'enUS','Now, let\'s take a look at Mu\'gra! Holo-projection D-098, Twix...','',26124),
(89930,'enUS','','D-098 coming right up!',26124),
(89931,'enUS','Mu\'gra... my old nemesis!','',26124),
(89932,'enUS','','Nemesis? Do you and this hippo have some kind of history?',26124),
(89933,'enUS','Let\'s just say that extracting a hippo tooth for preservation is far more dangerous while the hippo is alive...','',26124),
(89934,'enUS','','The things we archaeologists have to deal with these days! Sheesh!',26124),
(89935,'enUS','Let us continue on to the next specimen!','',26124),
(89936,'enUS','','You got it, Mr. G! Initiating holo-projection D-099...',26124),
(89937,'enUS','Ahh, yes! Here we have Thek\'talon, a windroc of superb size and ferocity.','',26124),
(89938,'enUS','','Does it have large talons?',26124),
(89939,'enUS','Indeed, Twix... and razor sharp! It\'s a shame we don\'t have time to allow Thek\'talon to die naturally and slowly fossilize through the ages...','',26124),
(89940,'enUS','...instead, it is our duty to lend nature a helping hand and speed up the process!','',26124),
(89941,'enUS','','Natural fossilization? Ain\'t nobody got time for that!',26124),
(89942,'enUS','Twixnee, please intiate the holo-projection for Xelganak!','',26124),
(89943,'enUS','','Sure thing, boss! Initiating holo-projection D-100...',26124),
(89944,'enUS','Xelganak is a most peculiar creature indeed! The bioluminescent fluid in Xelganak\'s sac is highly corrosive and can be propelled at high velocity.','',26124),
(89945,'enUS','','So Xelganak could melt someone\'s face off?',26124),
(89946,'enUS','What do you think happened to Bozzil? He wasn\'t born looking like that!','',26124),
(89947,'enUS','','<Rachelle gives you a polite nod.>$B$BGreetings.',26124),
(89948,'enUS','','Yes?',26124),
(89949,'enUS','','Hello.',26124),
(89950,'enUS','','Good day.',26124),
(89951,'enUS','','Need something?',26124),
(89952,'enUS','','<Rachelle looks at her tools.>$B$BThere\'s much work to do.',26124),
(89953,'enUS','','<Rachelle shrugs.>$B$BI\'m not much for words.',26124),
(89954,'enUS','','What can I do for you?',26124),
(89955,'enUS','My patented Rocket Cast system works flawlessly. Now if only these fish wouldn\'t be so picky and bite!','',26124),
(89956,'enUS','Nina, we\'re not getting enough fish! We need more rockets!','',26124),
(89957,'enUS','Whoever said proper technique is required for a long cast has obviously never tried rockets!','',26124),
(89958,'enUS','Tired of casting like the puny weakling that you are? Try my patented Rocket Cast system!','',26124),
(89959,'enUS','Some think it strange, but I find the rhythmic sound of goblin machinery to be quite relaxing. \n\nThe smell, however, I could do without.','',26124),
(89960,'enUS','Burn in Fel Fire!','',26124),
(89961,'enUS','All gladiators have perished. There will be no champion today.','All gladiators have perished. There will be no champion today.',26124),
(89962,'enUS','I have a few spells that can mend your equipment - for a price.','',26124),
(89963,'enUS','I need reagents.','I need reagents.',26124),
(89964,'enUS','Man, those Alliance soldiers sure are crybabies!','',26124),
(89965,'enUS','You talkin\' bout da one who kept screamin\' after you chopped off his foot?','',26124),
(89966,'enUS','Yeah! I mean come on, it\'s only a foot! Those things are so easy to stitch back on.','',26124),
(89967,'enUS','Uh, I don\'t think it works that way...','',26124),
(89968,'enUS','So what\'s the deal with these artifacts I keep hearing about?','',26124),
(89969,'enUS','All I know is da Alliance wants em, and da elves think they big and powerful. We don\'t want da Alliance havin that.','',26124),
(89970,'enUS','Powerful, you say? Maybe I should go get my hands on some of them.','',26124),
(89971,'enUS','','Must you orcs always practice with sharpened axes?',26124),
(89972,'enUS','','Next time, don\'t pull out the barbed arrow yourself. Find something else to stab your opponent with.',26124),
(89973,'enUS','','Let me see to that wound...',26124),
(89974,'enUS','','Hold still, I\'ll patch you up.',26124),
(89975,'enUS','The answers are out there, hiding in dark places.$B$BWe must be bold enough to seek them.','',26124),
(89976,'enUS','I want to check my mail.','I want to check my mail.',26124),
(89977,'enUS','I need you to repair my gear.','I need you to repair my gear.',26124),
(89978,'enUS','I got gold on the big guy!','I got gold on the big guy!',26124),
(89979,'enUS','OUCH! That had to hurt!','OUCH! That had to hurt!',26124),
(89980,'enUS','Bite him! Bite him!','Bite him! Bite him!',26124),
(89981,'enUS','Hey! That one no fight fair!','Hey! That one no fight fair!',26124),
(89982,'enUS','Come on Brute!','Come on Brute!',26124),
(89983,'enUS','I am close to replicating the Apexis interface.','',26124),
(89984,'enUS','','Intruders! Someone, inform Keli\'dan!',26124),
(89985,'enUS','I will enjoy feasting on your soul...','',26124),
(89986,'enUS','<Raastok cackles with glee.>$B$BDid you see the size of that explosion?! Marvelous!','',26124),
(89987,'enUS','Interrupting cretins! I\'ll sear that pretty armor right into your skin!','',26124),
(89988,'enUS','I want to check on my followers\' missions.','I want to check on my followers\' missions.',26124),
(89989,'enUS','%s escapes!','',26124),
(89990,'enUS','You now stand upon hallowed ground. In this place, upon the arena floor, the greatest gladiators of Draenor have spilled blood. Most have given up their lives for such a great honor. Today, you will do the same.','',26124),
(89991,'enUS','You will fight. You will kill. You will salute! 100 LIVES. Live or die.','',26124),
(89992,'enUS','To the last gladiator standing goes honor, glory and riches!','',26124),
(89993,'enUS','Down goes $n! Dat $r left notin\' but doodoo an blood on da floor!','',26124),
(89994,'enUS','What was dat?! Sometin\' exploded on da floor. I tink it was $n!','',26124),
(89995,'enUS','$n down! Dat remind me of da time when dat orc got his stones crushed by dat big elekk. Dat was a good week at da circus!','',26124),
(89996,'enUS','$n dead! Looks like der are $9662W gladiators still fighting!','',26124),
(89997,'enUS','Oof! Dat little $r died ugly!','',26124),
(89998,'enUS','Looks like da janitor gonna be pickin\' up pieces of $n for days!','',26124),
(89999,'enUS','Was dat a baby $r or da fully growd up kind? Dat died too easy!','',26124),
(90000,'enUS','HAH! Hey Jhorn, remember da poop I made dat looked like a $r? Dat\'s what $n looks like now!','',26124),
(90001,'enUS','','Oh, this should be interesting.  You don\'t mind if I take notes, do you?',26124),
(90002,'enUS','','It\'s easy to see why objects such as these would have been highly prized by their cultures!  Er, sorry about your pets.',26124),
(90003,'enUS','','Very interesting results.  Thanks for helping me test them out!',26124),
(90004,'enUS','','Well, what can you expect from something that\'s been buried in the ground for a millennium?',26124),
(90005,'enUS','','In its native culture, that pet might have been revered as a martyr.',26124),
(90006,'enUS','','Huh, I kinda thought that might happen.',26124),
(90007,'enUS','','Fortunately, Gyraxle can repair anything.  Even himself.',26124),
(90008,'enUS','','Now, was that result the device performing as expected, or did it just explode?',26124),
(90009,'enUS','','All in the name of science.',26124),
(90010,'enUS','You will feed my roots.','',26124),
(90011,'enUS','','I\'ve got bandages in my field kit if you need some...',26124),
(90012,'enUS','','You have to respect the ingenuity of such an ancient device.',26124),
(90013,'enUS','The plants will feast on you.','',26124),
(90014,'enUS','','I\'ll add a special thanks to your pet when I publish this research.',26124),
(90015,'enUS','','Oh, you must mean my father, Belloc.  What he and the Reliquary do can hardly be called \'archaeology\'.  Grave robbing is more like it.$b$bTrue archaeology is the search for fact, not treasure.  I want to learn about the past, study where we came from, and rediscover lost knowledge.',26124),
(90016,'enUS','I may fall... but the Overgrowth will take you eventually...','',26124),
(90017,'enUS','Brightblade?  That name sounds familiar...','Brightblade?  That name sounds familiar...',26124),
(90018,'enUS','','You don\'t look like you\'re very good at pet battles.  Maybe you should come back when you\'re better.',26124),
(90019,'enUS','','Here we go!',26124),
(90020,'enUS','','Oh my pets did so good.  They\'re going to get so many extra snuggles for that.',26124),
(90021,'enUS','','Oh, that\'s okay I guess.  Doodle will need a new eye though.',26124),
(90022,'enUS','','Don\'t worry, I\'ll kiss the boo-boo all better.',26124),
(90023,'enUS','','Soup will make you all better!',26124),
(90024,'enUS','','Oh no!',26124),
(90025,'enUS','','She\'s not dead, she\'s just sleeping.',26124),
(90026,'enUS','','We\'ll put the rainbow bandage on that.',26124),
(90027,'enUS','','Oh no!',26124),
(90028,'enUS','','Is your pet sleeping too?',26124),
(90029,'enUS','','You can make your pet all better, right?',26124),
(90030,'enUS','Begin a ritual of summoning. I want to summon my allies to my location.','Begin a ritual of summoning. I want to summon my allies to my location.',26124),
(90031,'enUS','','As I thought, $r, you are too weak.',26124),
(90032,'enUS','','You are lucky my wolves are not yet full grown, or else you would have been the meal.',26124),
(90033,'enUS','','Only defeat truly exposes our weaknesses.  This loss will improve their training.',26124),
(90034,'enUS','','That one was too stupid.',26124),
(90035,'enUS','','That one did not lack courage.',26124),
(90036,'enUS','','That one won\'t make that mistake again.',26124),
(90037,'enUS','','That one was too slow.',26124),
(90038,'enUS','','That one will need some healing.',26124),
(90039,'enUS','','A good kill.',26124),
(90040,'enUS','','A clean kill.',26124),
(90041,'enUS','','Hardly even a challenge.',26124),
(90042,'enUS','','Why are your pets so weak?',26124),
(90043,'enUS','','An easy kill.  My wolves will learn nothing.',26124),
(90044,'enUS','Gladiators, kill!','',26124),
(90045,'enUS','I remain the greatest warlord in all of Nagrand!','',26124),
(90046,'enUS','What?  How is this possible?  You must have cheated!','',26124),
(90047,'enUS','What is one death when I have an army of three?','',26124),
(90048,'enUS','My gladiators fight to the death!','',26124),
(90049,'enUS','You make Tarr angry!','',26124),
(90050,'enUS','I told you to kill, not die!','',26124),
(90051,'enUS','Haha, puny $r has puny pets.','',26124),
(90052,'enUS','Gladiator smash!','',26124),
(90053,'enUS','Are you not entertained?','',26124),
(90054,'enUS','Tarr will rock you!','',26124),
(90055,'enUS','This is why Tarr is the greatest warlord in all of Nagrand!','',26124),
(90056,'enUS','','Hey $gMister:Lady;, you wanna see my pets?',26124),
(90057,'enUS','','Come back another time then.',26124),
(90058,'enUS','','I may be small, but if you hurt my pets, I\'ll hurt you.',26124),
(90059,'enUS','','Thanks $gMister:Lady;!  I bet 100 coppers on this fight.',26124),
(90060,'enUS','','This is just like the time my home town was overrun by demons.',26124),
(90061,'enUS','','It\'s okay, they\'re used to dying.',26124),
(90062,'enUS','','Not the first time someone has hunted that one to the ends of the earth.',26124),
(90063,'enUS','','Easy now!  I paid a pretty copper for that one.',26124),
(90064,'enUS','','I\'ll sell ya a Stone of Jordan if you promise not to do that again.',26124),
(90065,'enUS','','Bad luck just runs in my family.',26124),
(90066,'enUS','','Sorry, $gMister:Lady;.',26124),
(90067,'enUS','','Don\'t throw that one away, it can still be fixed up.',26124),
(90068,'enUS','','That\'s right!  My pets are from the mean streets of Caldeum.',26124),
(90069,'enUS','','That\'s a bit of bad luck there, $gMister:Lady;.',26124),
(90070,'enUS','$R, I am devoted to training the guardians of Anzu.  Will you aid me in this cause?','',26124),
(90071,'enUS','Very well.  Train and come back to me.','',26124),
(90072,'enUS','Our hopes lie in what these pets will become.  They are sacred to us.','',26124),
(90073,'enUS','Glory to Anzu!','',26124),
(90074,'enUS','We are Arakkoa.  We are not broken by a single defeat.','',26124),
(90075,'enUS','A bad omen.','',26124),
(90076,'enUS','Anzu protect your children!','',26124),
(90077,'enUS','No!  The guardians cannot fall!','',26124),
(90078,'enUS','Doom and gloom!  Dooooooooom and glooooooom!','',26124),
(90079,'enUS','The curse of Sethe is upon us.','',26124),
(90080,'enUS','A good omen.','',26124),
(90081,'enUS','The strength of the Arakkoa is with us.','',26124),
(90082,'enUS','The raven god blesses us today.','',26124),
(90083,'enUS','The guardians stand strong.','',26124),
(90084,'enUS','Anzu protects his children.','',26124),
(90085,'enUS','','Hello $n.  Would you like to dance with my moths?',26124),
(90086,'enUS','','I understand.  Please come back when you are ready.',26124),
(90087,'enUS','','Pay attention, $n.  Strength is often found where you least expect it.',26124),
(90088,'enUS','','I hope you have learned something today.',26124),
(90089,'enUS','','I hope you have learned something today.',26124),
(90090,'enUS','','I am sad for the loss, but glad for your victory.',26124),
(90091,'enUS','','Fear not, a simple healing spell will set that to rights.',26124),
(90092,'enUS','','Life is full of surprises.',26124),
(90093,'enUS','','The Light has not yet taken her.  She simply rests.',26124),
(90094,'enUS','','The moth is drawn to the flame, it seems.',26124),
(90095,'enUS','','Life is full of surprises.',26124),
(90096,'enUS','','It is folly to underestimate the stength of nature.',26124),
(90097,'enUS','','The moth is delicate, but not without defenses.',26124),
(90098,'enUS','','Do not dispair, both you and your pet can learn from this.',26124),
(90099,'enUS','','A tender lesson learned too late.',26124),
(90100,'enUS','Begin a guiding light ritual. I want to summon my allies to my location.','Begin a guiding light ritual. I want to summon my allies to my location.',26124),
(90101,'enUS','Sorry, I still need to train one of my pets to level 25.','Sorry, I still need to train one of my pets to level 25.',26124),
(90102,'enUS','I admire your morals.  Carry on.','I admire your morals.  Carry on.',26124),
(90103,'enUS','Open a portal to my garrison.','Open a portal to my garrison.',26124),
(90104,'enUS','The |cFFE86B17|Hspell:175519|h[Essence of Flame]|h|r is knocked from your hands!','The |cFFE86B17|Hspell:175519|h[Essence of Flame]|h|r is knocked from your hands!',26124),
(90105,'enUS','The darkness... it flows within me. It seeps from every vein.','',26124),
(90106,'enUS','Come, strangers! Cross into the realm of the Shadow Lands! I shall deliver you to your death.','',26124),
(90107,'enUS','The Shadowmoon CANNOT be defeated - we walk in the realm of death itself.','',26124),
(90108,'enUS','I am the herald of the end!','',26124),
(90109,'enUS','A kindling of bone and shadow! Army of the dead, arise!','',26124),
(90110,'enUS','Into the abyss!','',26124),
(90111,'enUS','Feel the void\'s cold embrace.','',26124),
(90112,'enUS','My power... Will ripple... Across eternity.','',26124),
(90113,'enUS','Your soul shall serve me!','',26124),
(90114,'enUS','You bend to my will!','',26124),
(90115,'enUS','','Rivers of the damned, RISE! RISE in the name of darkness, RISE in the name of Ner\'zhul! The Shadowmoon beckons...',26124),
(90116,'enUS','','Ancestors of the Shadowmoon, shine in the darkness! Lend me your strength!',26124),
(90117,'enUS','','For Ner\'zhul...',26124),
(90118,'enUS','','Mmm, yes. The PERFECT sacrifice.',26124),
(90119,'enUS','','Your souls will belong to ME.',26124),
(90120,'enUS','','Restless spirits, HEED my command!',26124),
(90121,'enUS','','Another spirit for the army!',26124),
(90122,'enUS','','Embrace the eternal darkness...',26124),
(90123,'enUS','','The dead... Shall rise again...',26124),
(90124,'enUS','Let\'s do this!','Let\'s do this!',26124),
(90125,'enUS','Rekindle the |cFFE86B17|Hspell:175519|h[Essence of Flame]|h|r at a Kindling Flame!','Rekindle the |cFFE86B17|Hspell:175519|h[Essence of Flame]|h|r at a Kindling Flame!',26124),
(90126,'enUS','Thank you, $n. May the Furies of Frostfire burn within you!','',26124),
(90127,'enUS','Thank you for help, $n. I may be wounded, but no matter. Lead on!','Thank you for help, $n. I may be wounded, but no matter. Lead on!',26124),
(90128,'enUS','$n, I will remember your help. These wounds won\'t stop a good fight!','$n, I will remember your help. These wounds won\'t stop a good fight!',26124),
(90129,'enUS','That\'s more like it. I\'m injured, but you\'ve given me a chance to redeem myself.','That\'s more like it. I\'m injured, but you\'ve given me a chance to redeem myself.',26124),
(90130,'enUS','By Sha\'tar, thanks for your aid. I\'m wounded, but you\'ve given me a chance to fight on!','By Sha\'tar, thanks for your aid. I\'m wounded, but you\'ve given me a chance to fight on!',26124),
(90131,'enUS','$n, I will remember your name. These wounds are no greater than my anger - let us fight on!','$n, I will remember your name. These wounds are no greater than my anger - let us fight on!',26124),
(90132,'enUS','Thanks for the help, $n. We shall fight together, for Shattrath!','Thanks for the help, $n. We shall fight together, for Shattrath!',26124),
(90133,'enUS','Thanks, $r, but I have no desire to fight by your side.','Thanks, $r, but I have no desire to fight by your side.',26124),
(90134,'enUS','Our paths do not align, $r. Thank you for the aid, but I must be going.','Our paths do not align, $r. Thank you for the aid, but I must be going.',26124),
(90135,'enUS','My wounds are too great, friend. I must leave, but I hope we meet again.','My wounds are too great, friend. I must leave, but I hope we meet again.',26124),
(90136,'enUS','I need another drink.','',26124),
(90137,'enUS','A crushed fruit tastes all the sweeter.','',26124),
(90138,'enUS','I am too injured, $n, and must go heal. Thank you for our time together.','I am too injured, $n, and must go heal. Thank you for our time together.',26124),
(90139,'enUS','You have already been blessed by a Pilgrim\'s Altar. A feeling of great peace and serenity envelops you.','You have already been blessed by a Pilgrim\'s Altar. A feeling of great peace and serenity envelops you.',26124),
(90140,'enUS','Blessing of K\'ure','Blessing of K\'ure',26124),
(90141,'enUS','Some fine grog you have here, commander.','',26124),
(90142,'enUS','','Go away.',26124),
(90143,'enUS','Light be with you, commander.','',26124),
(90144,'enUS','So much death in this land...','',26124),
(90145,'enUS','Aviana\'s blessing upon you.','',26124),
(90146,'enUS','The herbs and fungus found on Draenor can be used to concoct all manner of pestilence. \n\nI believe our next plague will be the best yet!','',26124),
(90147,'enUS','Have you ever spent time, like really spent time, in the belly of an acidic swamp ooze? I wouldn\'t recommend it.','',26124),
(90148,'enUS','What ho, squire?','',26124),
(90149,'enUS','I will find a way to save Bolvar, if it takes the rest of my days.','',26124),
(90150,'enUS','','I wish to be alone.',26124),
(90151,'enUS','Zen\'kiki likes da kitty form best for sleeping.','',26124),
(90152,'enUS','I am wounded, $n, and need rest. Al diel shala!','I am wounded, $n, and need rest. Al diel shala!',26124),
(90153,'enUS','With my recipes, you can transform the reagents of Draenor into concoctions with the power to bestow or destroy life as you see fit.\n\nThat is, of course, if you possess the proper skill to wield them.','',26124),
(90154,'enUS','Ah, hello commander! Would you like me to tell you a lengthy story about a bridge?','',26124),
(90155,'enUS','I need rest, $n. Shorel\'aran!','I need rest, $n. Shorel\'aran!',26124),
(90156,'enUS','','The instructions are simple: you duck, or you don\'t have a head any longer. It does make ducking much easier in the future.',26124),
(90157,'enUS','I, Gamon, will save us!','',26124),
(90158,'enUS','I wonder if this world has any world-destroying artifacts? We can\'t allow them to fall into the hands of the enemy, you know!','',26124),
(90159,'enUS','No fight, sit by fire. Fire warm, outside cold. You sit.','',26124),
(90160,'enUS','I love boats!','',26124),
(90161,'enUS','You may inspect me from the maximum distance only.','',26124),
(90162,'enUS','','Good fortune, commander.',26124),
(90163,'enUS','All I\'ve ever known is war. Out here, I\'m someone.','',26124),
(90164,'enUS','Fifty! Yep! I was just tellin\' them all about the best task I\'ve ever given an\' aspirin\' adventurer. Ah, those were the days...','',26124),
(90165,'enUS','Many beasts of Draenor have hides as resilient as the toughest kodo. \n\nWith the proper skill, I can show you how to work these hides into fine armors.','',26124),
(90166,'enUS','I\'m right in the middle of communicating cross-dimensionally with Nibly, if you DON\'T MIND.','',26124),
(90167,'enUS','','Hi! This fort is swell.',26124),
(90168,'enUS','The stone statue gives off a restful aura. A plaque on the sign reads:$B$BThose blessed by the light of A\'dal shall gain fortitude and armor to confront the most challenging of foes.$B$BSeek the blessing of D\'ore to be healed in times of need.$B$BK\'ara guides the weapons of the blessed, granting the chance for additional strikes in times of war.$B$BK\'ure rewards the faithful, granting their movement the swiftness of wind.','The stone statue gives off a restful aura. A plaque on the sign reads:$B$BThose blessed by the light of A\'dal shall gain fortitude and armor to confront the most challenging of foes.$B$BSeek the blessing of D\'ore to be healed in times of need.$B$BK\'ara guides the weapons of the blessed, granting the chance for additional strikes in times of war.$B$BK\'ure rewards the faithful, granting their movement the swiftness of wind.',26124),
(90169,'enUS','Blessing of D\'ore','Blessing of D\'ore',26124),
(90170,'enUS','Blessing of K\'ara','Blessing of K\'ara',26124),
(90171,'enUS','Blessing of A\'dal','Blessing of A\'dal',26124),
(90172,'enUS','You look like you could use an updated wardrobe.  \n\nLuckily for you, I may just be able to teach you how to make some of the finest tailored garments in Draenor.\n\nCare to take a look at my patterns?','',26124),
(90173,'enUS','The draenei crystalsmiths closely guard the secrets to harnessing the latent power of the gems of Draenor. \n\nI, however, have managed to access these secrets and can share them with a talented jewelcrafter.\n\nFor a price, of course.','',26124),
(90174,'enUS','I see ya wishin\' to enhance ya gear with da powah of da voodoo. \n\nGed\'kah can be of service, mon.','',26124),
(90175,'enUS','','Da right words have da powah of da strongest voodoo. \n\nDem dat keep da words, dey know real powah!',26124),
(90176,'enUS','These Iron Horde guys think they know how to make machines. \n\nJust wait until they see what a goblin can do once we get our hands on their tech!','',26124),
(90177,'enUS','With the Alliance making themselves a threat again on Ashran, the demand for quality weapons and armor is higher than ever!\n\nDo you smell profit?','',26124),
(90178,'enUS','Zikk mon. Could ya be doin me a fava and grab me da scroll from da enchantas?','',26124),
(90179,'enUS','Now dat\'s a good rapta!','',26124),
(90180,'enUS','Where I be puttin dat quill, now?','',26124),
(90181,'enUS','A scribe\'s work neva be done, mon.','',26124),
(90182,'enUS','','You be free to house any of ya animals here wit\' da raptas. We will be keepin dem well fed. \n\nYa animals, of course. What did ya think I meant?',26124),
(90183,'enUS','','Shhhhh... I\'m trying to catch something!',26124),
(90184,'enUS','Why are we out here, do you ask? We are seasoned adventurers, seeking the wake of a legendary sea beast.','',26124),
(90185,'enUS','The creature must exist! I will seek it to the end of my days!','',26124),
(90186,'enUS','','The reagents of Draenor are as wondrous as they are mysterious.\n\nFor a price, I can teach you to harness their potential.',26124),
(90187,'enUS','My power is unending!','',26124),
(90188,'enUS','By the Raven Mother\'s feathers, you will not find a better deal!','',26124),
(90189,'enUS','Show me your wares.','Show me your wares.',26124),
(90190,'enUS','Raaaaawwwwrrrrr! Raaawwwwwrrrrrrrr!!!!!','',26124),
(90191,'enUS','Have you seen any enormous sea creatures in these waters?','',26124),
(90192,'enUS','Here, you look hungry.','',26124),
(90193,'enUS','Eat this, it will make you strong.','',26124),
(90194,'enUS','01001001 01100110 00100000 01111001 01101111 01110101 00100000 01110111 01100001 01101110 01110100 00100000 01110100 01101111 00100000 01110111 01101001 01101110 00100000 01110100 01101000 01100101 00100000 01100111 01100001 01101101 01100101','',26124),
(90195,'enUS','01111001 01101111 01110101 00100000 01100111 01101111 01110100 00100000 01110100 01101111 00100000 01110100 01100001 01101011 01100101 00100000 01100111 01101111 01101111 01100100 00100000 01100001 01101001 01101101','',26124),
(90196,'enUS','','I\'m telling you it\'s going to work, just trust me!',26124),
(90197,'enUS','I can\'t even see out of this thing... how\'s the plan supposed to work if we can\'t see where we\'re going?','',26124),
(90198,'enUS','','Just follow the sound of the money you\'ll make when we sell off all these bones!',26124),
(90199,'enUS','','The disguise is working! Those dumb gronn don\'t even know we\'re here!',26124),
(90200,'enUS','So all we gotta do now is wait until they go to sleep and then scram with the bones?','',26124),
(90201,'enUS','','Right... hey you feel something crawling around in your skull?',26124),
(90202,'enUS','Only a sense of regret for letting you talk me into this...','',26124),
(90203,'enUS','','So how about you tell us a little bit about these machines you and your cronies have been making for the Iron Horde?',26124),
(90204,'enUS','I ain\'t got nothin\' to say to you!','',26124),
(90205,'enUS','','Oh well, we can do this the hard way.',26124),
(90206,'enUS','','Did that loosen up your tongue a bit, or do you need more persuasion?',26124),
(90207,'enUS','I\'m not talkin! I ain\'t no rat!','',26124),
(90208,'enUS','','Persuade em, boys.',26124),
(90209,'enUS','All right, all right! I\'ll talk! Just call off your goons!','',26124),
(90210,'enUS','','Take five, guys. We\'ve got a little conversing to do here.',26124),
(90211,'enUS','Hollowed Skull','Hollowed Skull',26124),
(90212,'enUS','I... will not... tell you!','',26124),
(90213,'enUS','Amidst the chaos and carnage of the Coliseum, one among you has emerged the victor. $n! Shout $ghis:her; name in praise! Glory be to $n on this day!','',26124),
(90214,'enUS','Come! Honor your champion! See the riches bestowed upon the most powerful of your kind!','',26124),
(90215,'enUS','','Then taste the Scythe of Souls...',26124),
(90216,'enUS','','Forged in flame, my power knows no bounds, my allies fear nothing!',26124),
(90217,'enUS','The battle has begun! The last gladiator standing will be victorious!','',26124),
(90218,'enUS','','My body has fallen, but my spirit rises. I will always be with you.',26124),
(90219,'enUS','Hack imposters like Harrison Jones may frown on my methods, but fossilization takes thousands of years!$b$bThe best way to preserve a rare and fascinating creature is to do it yourself!$b$bWhy wait thousands of years for nature to do something that you can do a better job of yourself?','',26124),
(90220,'enUS','You help out the Steamwheedle Preservation Society and we help you back! But don\'t forget, sharing may be caring but gold is how it\'s sold!','',26124),
(90221,'enUS','<Bozzil flails his arms wildly as you approach>$b$bWhoa! Hey! Who\'s there?$b$bOh, sorry... I haven\'t been able to see very well since that whole... Xelganak thing.','',26124),
(90222,'enUS','I said, when I beat your brother black and blue, he dooked his pants and jumped away. Now give me the chow!','I said, when I beat your brother black and blue, he dooked his pants and jumped away. Now give me the chow!',26124),
(90223,'enUS','Hey, Ooka, your ooker is showing. That\'s unsavory and not the least bit sanitary.','Hey, Ooka, your ooker is showing. That\'s unsavory and not the least bit sanitary.',26124),
(90224,'enUS','Your mom.','Your mom.',26124),
(90225,'enUS','It burnssss... it BURNSSSSS!','',26124),
(90226,'enUS','The mages will summon a portal west of Ashran which can be used to take you back to Stormshield Stronghold.','',26124),
(90227,'enUS','GRRRRAAAAaaaaahhhh!!!','',26124),
(90228,'enUS','$n is unstoppable! Keep an eye on $ghim:her;, Kargath.','',26124),
(90229,'enUS','Did I steal these rylaks from the Iron Horde?$b$bThat depends on who\'s asking!','',26124),
(90230,'enUS','','You look like the adventering type!$b$bIf you find any relics or artifacts while you\'re out there, bring them back here and we\'ll make a deal!',26124),
(90231,'enUS','','Go mank a slicky, wicket. In fact, go mank two while one manks you from behind and the other manks your dooker.',26124),
(90232,'enUS','','My head? You\'re a slicky headed dook-manker!',26124),
(90233,'enUS','The signal horn was blown, why have the others not arrived?','',26124),
(90234,'enUS','Probably drinking themselves into a stupor.','',26124),
(90235,'enUS','Something isn\'t right. Feels like we are being watched.','',26124),
(90236,'enUS','','You leave my brother out of this you, blickjikity dook-manker!',26124),
(90237,'enUS','','Don\'t mind me, I just work the holo-projector! If you\'re looking for work you should talk with Mr. G over there!',26124),
(90238,'enUS','I\'d like to see your selection of spirits.','I\'d like to see your selection of spirits.',26124),
(90239,'enUS','No word yet on the northern troop movements.','',26124),
(90240,'enUS','Our raiders spotted artillery moving up the coast.','',26124),
(90241,'enUS','Our warriors caught the outpost by surprise and burned it to the ground.','',26124),
(90242,'enUS','No word back from our scouts yet.','',26124),
(90243,'enUS','Our ships will be arriving at the Iron Docks soon.','',26124),
(90244,'enUS','Reports of heavy losses to the south.','',26124),
(90245,'enUS','Our scouts have spotted a caravan ripe for the plundering.','',26124),
(90246,'enUS','No word yet from the other clans.','',26124),
(90247,'enUS','','My mom? MY MOM! You wikket licking ooker!',26124),
(90248,'enUS','Our raiders have burned the village and left no survivors.','',26124),
(90249,'enUS','We have enemy forces moving west through Nagrand.','',26124),
(90250,'enUS','Any bites yet?  I have found that patience (and beer) really helps bring in the big catch!','',26124),
(90251,'enUS','Did you bring a cooler?  Don\'t EVER go fishing without a cooler!','',26124),
(90252,'enUS','Any bites yet?  I have found that patience (and beer) really helps bring in the big catch!','',26124),
(90253,'enUS','*HIC!*  Was that a dolphin?!  *HIC!*  I love dolphins!','',26124),
(90254,'enUS','Seriously?  I think I would actually just throw that one back.','',26124),
(90255,'enUS','We need to concentrate on getting weapons to give to the other prisoners and setting you up as Sternfathom\'s champion pit fighter.\n\nThen, we can go kill Prince Oceanus.','',26124),
(90256,'enUS','The Legion will enslave all!','',26124),
(90257,'enUS','Carrion Worms Killed: $1i (+$2i VP)','Carrion Worms Killed: $1i (+$2i VP)',26124),
(90258,'enUS','Infiltrators Killed: $1i (+$2i VP)','',26124),
(90260,'enUS','Looters Stopped: $1i (+$2i VP)','',26124),
(90261,'enUS','*YAWN* It would seem that you require some outside assistance!','',26124),
(90262,'enUS','The crowd grows weary of this battle! Perhaps a little fire can liven things up!','',26124),
(90263,'enUS','This pace is not to my liking! This should help...','',26124),
(90264,'enUS','My patience has run out! I WILL MAKE YOU FIGHT!','',26124),
(90265,'enUS','See ya!','',26124),
(90266,'enUS','I will be back later, save me a beer!','',26124),
(90267,'enUS','Good luck on the lunkers!','',26124),
(90268,'enUS','Howdy $n!  Any luck out here?','',26124),
(90269,'enUS','$n, I found ya!','',26124),
(90270,'enUS','Greetings $n!','',26124),
(90271,'enUS','Snowfury mournfully paws at the rubble.','',26124),
(90272,'enUS','We stand victorious, but at a high cost.','',26124),
(90273,'enUS','What happened here?','What happened here?',26124),
(90274,'enUS','Bwargh! Nobody spills my brew... DIE!','',26124),
(90275,'enUS','MY WILL... I WILL NOT BE... BROK... EN....','',26124),
(90276,'enUS','AUGHHHHH!','',26124),
(90277,'enUS','ALL THAT LIVES, TO DUST.','',26124),
(90278,'enUS','BREAK.','',26124),
(90279,'enUS','THE EARTH CONSUMES YOU.','',26124),
(90280,'enUS','I... AM... ETERNAL!','',26124),
(90281,'enUS','SHATTER.','',26124),
(90282,'enUS','RISE, MOUNTAINS!','',26124),
(90283,'enUS','TOO... MUCH!','',26124),
(90284,'enUS','WHAT... IS... THIS....','',26124),
(90285,'enUS','EVEN THE MOUNTAIN... FALLS....','',26124),
(90286,'enUS','RETURN TO THE EARTH.','',26124),
(90287,'enUS','FLESH. WEAK.','',26124),
(90288,'enUS','His sacrifice will echo through our generations... forever.','',26124),
(90289,'enUS','Kral\'ach.... The darkness speaks.... A VOICE!','',26124),
(90290,'enUS','MASTER! I COME FOR YOU!','',26124),
(90291,'enUS','Yjj\'rmr... Xzzolos...','',26124),
(90292,'enUS','Night! My blood... stars....','',26124),
(90293,'enUS','Yes, Tectus. Bend to master\'s will!','',26124),
(90294,'enUS','No! You do not understand... must not get away...','',26124),
(90295,'enUS','Who dares meddle in the works of the Legion?!','',26124),
(90296,'enUS','This world... ALL worlds... shall burn!','',26124),
(90297,'enUS','The master claims your soul.','',26124),
(90298,'enUS','Burn.','',26124),
(90299,'enUS','Come forth, servants!','',26124),
(90300,'enUS','Burn in the master\'s fire!','',26124),
(90301,'enUS','Die, insect!','',26124),
(90302,'enUS','That\'s better! Do not disappoint us again!','',26124),
(90303,'enUS','Am I not a gracious host? Are you not entertained?!','',26124),
(90304,'enUS','Lose the crowd again and you will all pay dearly!','',26124),
(90305,'enUS','|TInterface\\Icons\\spell_druid_massentanglement.blp:20|t You are entangled in |cFFFF0404|Hspell:176001|h[Savage Vines]|h|r!','|TInterface\\Icons\\spell_druid_massentanglement.blp:20|t You are entangled in |cFFFF0404|Hspell:176001|h[Savage Vines]|h|r!',26124),
(90306,'enUS','All dem muscles and you can\'t break boulders?! Useless ogron!','',26124),
(90307,'enUS','Even dead talbuk be more useful den dese stupid ogron!','',26124),
(90308,'enUS','|TInterface\\Icons\\Ability_Druid_EmpoweredTouch:20|t Tarlna begins to channel |cFFFF0404|Hspell:175979|h[Genesis]|h|r.','|TInterface\\Icons\\Ability_Druid_EmpoweredTouch:20|t Tarlna begins to channel |cFFFF0404|Hspell:175979|h[Genesis]|h|r.',26124),
(90309,'enUS','Ey, wanna know what\'s more stupid den a ogron?','',26124),
(90310,'enUS','Two ogron! Har har har!','',26124),
(90311,'enUS','','Yeah? What? This fighter chow is a special family secret.\n\nThere\'s no ookin way you\'re getting any, $r.',26124),
(90312,'enUS','Get back ta work ya lazy ogron!','',26124),
(90313,'enUS','You better start breakin\' rocks before I break you!','',26124),
(90314,'enUS','Quit wanderin\' round and break some rocks ya stupid ogron!','',26124),
(90315,'enUS','Go into the Road of Glory!','',26124),
(90316,'enUS','Thaelin is on his way soon.','Thaelin is on his way soon.',26124),
(90317,'enUS','Test - male.','Test - female',26124),
(90318,'enUS','Get dem ogron back to work!','',26124),
(90319,'enUS','Get control of da ogron, now!','',26124),
(90320,'enUS','Get dem ogron workin\', or start bashin\' skulls!','',26124),
(90321,'enUS','You like meat? We got lots o\' fresh meat here! How much you want?','',26124),
(90322,'enUS','','Commander, may I have a moment?',26124),
(90324,'enUS','','I understand your concerns about this artifact, Myshal, but we must not interfere with our allies efforts to retrieve it.',26124),
(90325,'enUS','But Priestess, if the artifact is as powerful as they say, the destruction that could be wrought by its wielder could be devastating!','',26124),
(90326,'enUS','','That is why we must assure that our allies are the ones to retrieve it. Once recovered, we will offer our guidance to ensure it is not misued.',26124),
(90327,'enUS','What if they don\'t listen? What if our allies\' lust for power leads them down the path of destruction?','',26124),
(90328,'enUS','I love goblins, but they are a tough audience.','',26124),
(90329,'enUS','','Let us hope that day does not come, Myshal.',26124),
(90330,'enUS','','You seem troubled, Myshal. What vexes you?',26124),
(90331,'enUS','It\'s the Horde forces, Priestess. They fight with great savagery to obtain the artifact before us.','',26124),
(90332,'enUS','Do you think they wish to use it against the Alliance?','',26124),
(90333,'enUS','','Perhaps they fight with such ferocity because they fear we will use it against them.',26124),
(90334,'enUS','','Greetings, friend.',26124),
(90335,'enUS','','Your order has already been placed.',26124),
(90336,'enUS','','Thank you, commander. I will see you at your garrison.',26124),
(90337,'enUS','You\'re only given a little spark of madness... and if you lose that, you\'re nothing.','',26124),
(90338,'enUS','No matter what people tell you, words and ideas can change the world.','',26124),
(90339,'enUS','If there\'s one thing I\'ve learned on Draenor, it\'s never to pick a fight with an ogre; they\'ve got nothing to lose.','',26124),
(90340,'enUS','','If this artifact that Harrison is seeking is as powerful as he seems to think, I hope it remains undiscovered.\n\nRegardless of intentions, the wielding of great power often comes with drastic consequences.',26124),
(90341,'enUS','But hey, the Alliance aren\'t all bad. If you want a linguistic adventure, go drinking with a dwarf!','',26124),
(90342,'enUS','Goblin \"engineering\" - yeah, right. You goblins got hands and a brain, and only enough blood to run one at a time!','',26124),
(90343,'enUS','How about those draenei? Or as they like to say, the other blue race. How can you trust an army that makes warhammers out of pink gemstones?!','',26124),
(90344,'enUS','You know the difference between a bar fight and an orcish wedding? Me neither.','',26124),
(90345,'enUS','You guys have it great out here. You got the right to bear arms, the right to arm bears. Whatever the hell you want to do!','',26124),
(90346,'enUS','','Commander, could I have a moment o\' yer time?',26124),
(90347,'enUS','Anyone been to Silvermoon? I only ever play Silvermoon one night at a time. It\'s a hideous, gaudy place.','',26124),
(90348,'enUS','Do you do characters?','Do you do characters?',26124),
(90349,'enUS','','Thank ye, commander. I\'ll see ye at your garrison.',26124),
(90350,'enUS','Show me the Blasted Lands before the invasion.','Show me the Blasted Lands before the invasion.',26124),
(90351,'enUS','Hey everyone, John Swifty here!','',26124),
(90352,'enUS','Check THIS one out!','',26124),
(90353,'enUS','PHENOMENAL COSMIC POWERS!','',26124),
(90354,'enUS','Itty bitty living space.','',26124),
(90355,'enUS','','War does not simply visit these lands, it lives here.  The violence thrives in past, present, and future...',26124),
(90356,'enUS','I only had one shot.','',26124),
(90357,'enUS','Macro power!','',26124),
(90358,'enUS','<Kharg seems uninterested.>','',26124),
(90359,'enUS','How can Kharg assist you, gladiator?','',26124),
(90360,'enUS','I wish to battle in the Coliseum!','I wish to battle in the Coliseum!',26124),
(90361,'enUS','The cost to do battle in the Coliseum is 100 Broken Bones. Do you wish to proceed?','',26124),
(90362,'enUS','Wut is it? Me need to work out more!','',26124),
(90363,'enUS','Never keep a kaliri in the bedroom. They hear EVERYTHING.','',26124),
(90364,'enUS','Clockspan, we need to get that tank repaired. Our troops need some assistance on the front line!','',26124),
(90365,'enUS','We need that rock clearing bot on the double, Sparkswift. Do you expect Harrison Jones to clear out that mine with a pick?','',26124),
(90366,'enUS','How long does normal maintenance take, Springfizzle? We needed that tank on the field hours ago!','',26124),
(90367,'enUS','Where is Wobblewrench? She\'s been working on that spider tank for ages!','',26124),
(90368,'enUS','All this coordinating work is tiring. I sure could use a frosty brew.','',26124),
(90369,'enUS','Apologies, gladiator, but you have already been victorious in the Coliseum this week. Come back next week.','',26124),
(90370,'enUS','Shome commander you are ...hic! I\'ve been working with the orcsh shince the shtart! ...hic!','',26124),
(90371,'enUS','It\'s over, Jacob. Come quietly and we\'ll get you on the first gryphon to prison for treason.','It\'s over, Jacob. Come quietly and we\'ll get you on the first gryphon to prison for treason.',26124),
(90372,'enUS','You da champ! Dat means you can\'t fight in Coliseum for six...hundred years. Or maybe it one week? Me no know!','',26124),
(90373,'enUS','Hold on, you\'ll like this.','',26124),
(90374,'enUS','What\'s that sound? Reminds me of a kodo stampede...','',26124),
(90375,'enUS','You\'ll never take me alive ...hic!','',26124),
(90376,'enUS','There\'s a stench in the air. Demons...','',26124),
(90377,'enUS','We\'re in luck! Once again, we can show the demons that the true Horde will not be swayed!','',26124),
(90378,'enUS','This is where they\'ll attack first...','',26124),
(90379,'enUS','Finally, a fight...','',26124),
(90380,'enUS','Keep your eyes open. They might spring from anywhere.','',26124),
(90381,'enUS','I can feel them down there...','',26124),
(90382,'enUS','The Shadowmoon Clan shames all Orcs. Every one we kill is a lesson to the rest.','',26124),
(90383,'enUS','Hello there, poppet!','Hello there, poppet!',26124),
(90384,'enUS','Oh! Two seconds as a woman and I\'m already getting hot flashes.','Oh! Two seconds as a woman and I\'m already getting hot flashes.',26124),
(90385,'enUS','','The cold certainly bothers you',26124),
(90386,'enUS','Many adventurers have come to Ashran of late. Some seek their own personal fortune, while others come to aid the Alliance in their plight against the Horde.\n\nWhat adventure do you seek here, friend?','',26124),
(90387,'enUS','','From a distance, you look very small.',26124),
(90388,'enUS','Commander, we\'ll assemble the troops at your command.','',26124),
(90389,'enUS','My power is surpassed only by my stature!','',26124),
(90390,'enUS','I hope this last one\'s bigger than the rest.','',26124),
(90391,'enUS','','Be healed!',26124),
(90392,'enUS','','Light mend your wounds!',26124),
(90393,'enUS','','It is not your day to die!',26124),
(90394,'enUS','Their leader is here. For the Horde!','',26124),
(90395,'enUS','Defeated? No! Charles, where were you?!','',26124),
(90396,'enUS','I am unstoppable!','',26124),
(90397,'enUS','Alive or dead, I tower over you!','',26124),
(90398,'enUS','Let\'s beat these ogres back to Highmaul!','',26124),
(90399,'enUS','Now let\'s put these demon-spawn out of their misery!','',26124),
(90400,'enUS','The goren fled, but I don\'t think they fled from us...','',26124),
(90401,'enUS','The power of sun and moon flow through me with a deafening boom!','',26124),
(90402,'enUS','I\'ll be pulling thorns out of my armor for weeks...','',26124),
(90403,'enUS','By Alune, I will return, stronger than ever before!','',26124),
(90404,'enUS','I never thought I\'d tire of smashing skulls.','',26124),
(90405,'enUS','That took care of the lesser ogres.','',26124),
(90406,'enUS','They\'re too fever-brained to know they\'re defeated!','',26124),
(90407,'enUS','BOOM!','',26124),
(90408,'enUS','KA-BOOM!','',26124),
(90409,'enUS','BA-BA-BOOM!','',26124),
(90410,'enUS','All hail, $n! Champion of the Coliseum! King of the gladiators!','',26124),
(90411,'enUS','If there\'s a gronn coming, then goren won\'t be far. Get the peasants to safety!','',26124),
(90412,'enUS','To arms! To your posts! And look beneath you. They\'ll come from below....','',26124),
(90413,'enUS','This is where they\'ll attack first...','',26124),
(90414,'enUS','They\'re coming...','',26124),
(90415,'enUS','Be wary of flowers and vines. Any plant may be our foe...','',26124),
(90416,'enUS','They\'re coming...','',26124),
(90417,'enUS','I\'m gonna light you up, sweet cheeks!','I\'m gonna light you up, sweet cheeks!',26124),
(90418,'enUS','Remember when they die, don\'t let them fall on you.','',26124),
(90419,'enUS','','Shome commander you are ...hic! I\'ve been working with the Alliance shince the shtart! ...hic!',26124),
(90420,'enUS','It\'s over, Rorka. Come quietly and we\'ll get you on the first wyvern to prison for treason.','It\'s over, Rorka. Come quietly and we\'ll get you on the first wyvern to prison for treason.',26124),
(90421,'enUS','','You\'ll never take me alive ...hic!',26124),
(90422,'enUS','That can\'t be all of them.','',26124),
(90423,'enUS','Spread out! Protect the structures!','',26124),
(90424,'enUS','They were just sent to soften us up...','',26124),
(90425,'enUS','Spread out! They\'ll be coming from all angles!','',26124),
(90426,'enUS','Kneel before the might of the Iron Horde!','',26124),
(90427,'enUS','I\'ll have your head on my axe!','',26124),
(90428,'enUS','Looks like I\'ll have to take care of this one myself!','',26124),
(90429,'enUS','Where do you think you\'re going?','',26124),
(90430,'enUS','Spread out! Protect the structures!','',26124),
(90431,'enUS','That was just a test.','',26124),
(90432,'enUS','Spread out! Protect the structures!','',26124),
(90433,'enUS','No more at the front gate....','',26124),
(90434,'enUS','Spread out! Protect the structures!','',26124),
(90435,'enUS','We won\'t go down that easy!','',26124),
(90436,'enUS','Spread out! Don\'t let them gain a foothold!','',26124),
(90437,'enUS','The goren fled, but I don\'t think they fled from us...','',26124),
(90438,'enUS','','The battle begins!',26124),
(90439,'enUS','This... Horde is... tough.','',26124),
(90440,'enUS','','It\'s getting warm up here...',26124),
(90441,'enUS','','Thought I was a pushover like Balinda? Ha!',26124),
(90442,'enUS','','Chill out.',26124),
(90443,'enUS','','Dress warmer next time.',26124),
(90444,'enUS','','I\'m burning up!',26124),
(90445,'enUS','This is it, soldiers. Stay focused and we\'ll make it through.','',26124),
(90446,'enUS','The enemy commander comes! It\'ll be just like old times!','',26124),
(90447,'enUS','','Shattered!',26124),
(90448,'enUS','Ahhh, I have feelin\' back in my toes. Tanks, $Gbrudda:sista;. I won\'t forget dis.','',26124),
(90449,'enUS','Feel the burn!','',26124),
(90450,'enUS','The heat is on!','',26124),
(90451,'enUS','I will rise again... and again.','',26124),
(90452,'enUS','I\'m burned out.','',26124),
(90453,'enUS','Ashes to ashes.','',26124),
(90454,'enUS','Too hot for you?','',26124),
(90455,'enUS','Aaalllriiiight!! Who ordered up an extra large can of whoop-ass?','Aaalllriiiight!! Who ordered up an extra large can of whoop-ass?',26124),
(90456,'enUS','','I could use a heal here!',26124),
(90457,'enUS','','Say Bahh to your healers!',26124),
(90458,'enUS','Gordawg is nowhere to be found! The minions of Kalandrios must be to blame! Bury the air with earth... suffocate the wind!','',26124),
(90459,'enUS','The earthen fury has abandoned the throne! The minions of Gordawg must be punished...  scatter the earth like pebbles upon the wind!','',26124),
(90460,'enUS','The fury of earth is missing and the minions of Aborius do nothing to aid the throne! If the waters refuse to flow... we shall boil them!','',26124),
(90461,'enUS','The minions of Gordawg are without control! The followers of Incineratus burn uncontrollably! Cleanse the plateau... drown the lesser elements and wash them away!','',26124),
(90462,'enUS','','Ahh... a nice cool breeze.',26124),
(90463,'enUS','|cFFFF0000|Hspell:155187|h[Bombs]|h|r damage all players in the area when they expire or when they are triggered by the player wearing them.','|cFFFF0000|Hspell:155187|h[Bombs]|h|r damage all players in the area when they expire or when they are triggered by the player wearing them.',26124),
(90464,'enUS','|TInterface\\Icons\\ability_foundryraid_traindeath:20|t An |cFFFF0000|Hspell:156554|h[Incoming Train]|h|r has killed you. Avoid standing on a track while that track\'s doors are open.','',26124),
(90465,'enUS','Haven\'t been here in ages.','',26124),
(90466,'enUS','Hahaha.','',26124),
(90467,'enUS','|TInterface\\Icons\\ability_whirlwind:20|t |cFFFF0000|Hspell:157943|h[Whirlwind]|h|r has killed you. Avoid standing near Phemos during |cFFFF0000|Hspell:157943|h[Whirlwind]|h|r.','',26124),
(90468,'enUS','|cFFFF0000|Hspell:176123|h[Volatile Fire]|h|r deals damage to the player with the Volatile Fire and any nearby players when it expires.','|cFFFF0000|Hspell:176123|h[Volatile Fire]|h|r deals damage to the player with the Volatile Fire and any nearby players when it expires.',26124),
(90469,'enUS','|cFFFF0000|Hspell:155200|h[Burn]|h|r deals damage to the player Fixated by the Slag Elemental.','|cFFFF0000|Hspell:155200|h[Burn]|h|r deals damage to the player Fixated by the Slag Elemental.',26124),
(90470,'enUS','|cFFFF0000|Hspell:155209|h[Blast]|h|r deals damage to all players every time the Heart of the Mountain reaches 100 energy.','|cFFFF0000|Hspell:155209|h[Blast]|h|r deals damage to all players every time the Heart of the Mountain reaches 100 energy.',26124),
(90471,'enUS','|cFFFF0000|Hspell:155223|h[Melt]|h|r deals damage to all players inside its area of effect every second for as long as they remain in the area.','|cFFFF0000|Hspell:155223|h[Melt]|h|r deals damage to all players inside its area of effect every second for as long as they remain in the area.',26124),
(90472,'enUS','|cFFFF0000|Hspell:155242|h[Heat]|h|r deals more damage to you the more |cFFFF0000|Hspell:155240|h[Tempered]|h|r you are and stacks.','|cFFFF0000|Hspell:155242|h[Heat]|h|r deals more damage to you the more |cFFFF0000|Hspell:155240|h[Tempered]|h|r you are and stacks.',26124),
(90473,'enUS','The |cFFFF0000|Hspell:155743|h[Slag Pool]|h|r activates once the Heart of the Mountain leaves the Blast Furnace and burns all players standing in it.','The |cFFFF0000|Hspell:155743|h[Slag Pool]|h|r activates once the Heart of the Mountain leaves the Blast Furnace and burns all players standing in it.',26124),
(90474,'enUS','|cFFFF0000|Hspell:175104|h[Melt Armor]|h|r Inflicts more damage to you the more times you get hit by the spell. Alternate tanking Foreman Feldspar with other players to allow your Melt Armor stacks to expire.','|cFFFF0000|Hspell:175104|h[Melt Armor]|h|r Inflicts more damage to you the more times you get hit by the spell. Alternate tanking Foreman Feldspar with other players to allow your Melt Armor stacks to expire.',26124),
(90475,'enUS','Slag Elementals become a |cFFFF0000|Hspell:176133|h[Slag Bomb]|h|r when their health is depleted.','Slag Elementals become a |cFFFF0000|Hspell:176133|h[Slag Bomb]|h|r when their health is depleted.',26124),
(90476,'enUS','|cFFFF0000|Hspell:156147|h[The Cleaver]|h|r stacks up the longer you tank the Butcher.','|cFFFF0000|Hspell:156147|h[The Cleaver]|h|r stacks up the longer you tank the Butcher.',26124),
(90477,'enUS','|cFFFF0000|Hspell:156143|h[The Tenderizer]|h|r inflicts more damage to you the longer you tank the Butcher.','|cFFFF0000|Hspell:156143|h[The Tenderizer]|h|r inflicts more damage to you the longer you tank the Butcher.',26124),
(90478,'enUS','|cFFFF0000|Hspell:156153|h[Gushing Wounds]|h|r will instantly kill any player with more than 9 stacks of the debuff.','|cFFFF0000|Hspell:156153|h[Gushing Wounds]|h|r will instantly kill any player with more than 9 stacks of the debuff.',26124),
(90479,'enUS','|cFFFF0000|Hspell:156157|h[Cleave]|h|r divides its damage amongst all targets and always targets the largest clump within melee range.','|cFFFF0000|Hspell:156157|h[Cleave]|h|r divides its damage amongst all targets and always targets the largest clump within melee range.',26124),
(90480,'enUS','Oh captain, my captain.','',26124),
(90481,'enUS','|cFFFF0000|Hspell:156138|h[Heavy Handed]|h|r attacks the next closest target to the Butcher\'s current tank target or attacks his current tank a second time if there are no other tanks in range.','|cFFFF0000|Hspell:156138|h[Heavy Handed]|h|r attacks the next closest target to the Butcher\'s current tank target or attacks his current tank a second time if there are no other tanks in range.',26124),
(90482,'enUS','The earth will crush your mortal bones!','',26124),
(90483,'enUS','You dare approach the fury of the storm?!','',26124),
(90484,'enUS','%s prepares a |cFFFF0404|Hspell:168148|h[Cannon Barrage]|h|r! Get behind cover to survive!','',26124),
(90485,'enUS','I DIED!','I DIED!',26124),
(90486,'enUS','My waters will cleanse your pathetic mortal flesh!','',26124),
(90487,'enUS','Why can\'t I fight?','Why can\'t I fight?',26124),
(90488,'enUS','My flames will turn your bones to ash!','',26124),
(90489,'enUS','%s begins to channel |cFFFF0404|Hspell:157059|h[Rune of Grasping Earth]|h|r, seek a rune for protection!','',26124),
(90490,'enUS','|cFFFF0404|Hspell:163590|h[Creeping Moss]|h|r is spreading! Use flame throwers to control the overgrowth!','',26124),
(90491,'enUS','%s\'s |cFFFF0404|Hspell:155539|h[Destructive Rampage]|h|r ends.','',26124),
(90492,'enUS','You have emerged victorious, gladiator. You are not permitted to battle again until next week.','',26124),
(90493,'enUS','The Exarchs are charged with leading the draenei people. We represent and uphold the values of our society.','',26124),
(90494,'enUS','It\'s not the end of the world per se, but you can certainly see it from there!','',26124),
(90495,'enUS','Mrrgggl!','',26124),
(90496,'enUS','Mrrgl.','',26124),
(90497,'enUS','Mrrrrgl?','',26124),
(90498,'enUS','Mrrgl. Mrrgl.','',26124),
(90499,'enUS','','The situation has become very dangerous on Ashran lately. This morning I nearly had my head taken off by an enraged ancient!',26124),
(90500,'enUS','','Da Alliance must be desparate to obtain da artifact to unleash such foes upon us.',26124),
(90501,'enUS','','The fury of nature should not be abused in such a way. In the end, they will pay for their folly.',26124),
(90502,'enUS','','The primal forces of Draenor are wild and untamed. They seem to resist any attempt at control.',26124),
(90503,'enUS','','Dat must make things diffcult for ya on da battlefield.',26124),
(90504,'enUS','','Not necessarily. I still have my teeth and claws.',26124),
(90505,'enUS','','You hear what happened? The blood elves say they found something big in the mines.',26124),
(90506,'enUS','What, like a really big axe?','',26124),
(90507,'enUS','','Not an axe, dimwit! They say it\'s part of the big artifact the Alliance is lookin\' for.',26124),
(90508,'enUS','Bah! Who cares about some old, dusty relics? I came here to bash some Alliance heads in!','',26124),
(90509,'enUS','','Do you even understand why we\'re here in Ashran?',26124),
(90510,'enUS','All I care about is that we get to bring the battle to the humans again. I\'ve been itchin\' for a proper fight!','',26124),
(90511,'enUS','','It\'s been years since I\'ve been out in the field like this.$B$B<The stately archmage takes a deep breath.>$B$BThere\'s nothing like the smell of clean air and danger.',26124),
(90512,'enUS','','If it were up to me, I\'d be the one to carry out this mission. But Archmage Khadgar insisted that you would have a more delicate touch.',26124),
(90513,'enUS','','I still bear old wounds from the demons\' first coming to Azeroth. I remember the horror, the madness, and the stillness that descended upon a city destroyed.$B$BI will do anything in my power to prevent that from happening again.',26124),
(90514,'enUS','','I cannot fathom why anyone would pledge themselves to the Legion.$B$BThere are those who lust for power, and do not know how to wield it.',26124),
(90515,'enUS','','The Sargerei village is like a beehive.$B$BDisturb its denizens, and we will get stung. Destroy it in flames, and we will destroy the precious honeycomb as well.$B$BThe only way to retrieve the information we seek is through sublety.',26124),
(90516,'enUS','','I spoke with Warlord Volrath today. He is concerned that our troops are refusing to march into the burial grounds.',26124),
(90517,'enUS','To arms! To your posts! The Thunderlords want to play.','',26124),
(90518,'enUS','Oh yeah? Why do you think that is?','',26124),
(90519,'enUS','I\'ve toyed with you long enough!','',26124),
(90520,'enUS','','The grunts that return from there are reporting sighting of strange spirits. They say that necromancers are enslaving the ghosts of the ancient ogres.',26124),
(90521,'enUS','Ghost ogres? I can see why they\'d stay away. Not that I\'m afraid or anything, but I prefer enemies I can actually strike with an axe.','',26124),
(90522,'enUS','','Exarch Othaar\'s betrayal was sudden. How could a leader of the draenei turn his back on the Light, and embrace the enemies who persecuted his entire race?',26124),
(90523,'enUS','I\'ve seen enough. Fight your own battles, oh great and powerful king.','',26124),
(90524,'enUS','Our task is grim, but necessary.','',26124),
(90525,'enUS','','His new allies have given him a new name, and a new identity - \"Socrethar.\" He is a powerful enemy, and I fear what he is capable of.',26124),
(90526,'enUS','','Greetings, commander. Would you like to view any recent major events?',26124),
(90527,'enUS','Show me what happened at the Battle for Shattrath.','Show me what happened at the Battle for Shattrath.',26124),
(90528,'enUS','','Have you heard of me, $n? I am Modera, archmage of the Council of Six, which rules the Kirin Tor and Dalaran.$B$BI could wipe out this entire village if I chose.$B$BBut that is not why we are here. As I have learned through the years, sometimes you need honey to catch a fly.',26124),
(90529,'enUS','Lok\'tar, commander. Would you like to view any recent major events?','',26124),
(90530,'enUS','','Look! It\'s $n!',26124),
(90531,'enUS','','Is that $n? They say $Ghe\'s:she\'s; the greatest $c that ever was!',26124),
(90532,'enUS','It looks like $n\'s arrived to help crack some Alliance skulls!','',26124),
(90533,'enUS','Could you conjure me some food?','Could you conjure me some food?',26124),
(90534,'enUS','','It\'s a bit warm out today, don\'t you think?',26124),
(90535,'enUS','Da Alliance think dey so smart. Dey hidin\' behind dis truce of deirs, meanwhile dey searchin\' dis island high and low for a powerful weapon, but dey no askin\' for our help.\n\nSure, dey say da weapon is ta be used against da Iron Horde, but what is ta stop dem from turnin\' it on us once we off dis world?\n\nI say we take da weapon, and we be showin\' dem who has da powah - on dis world as well as ours.\n\nFor da Horde!','',26124),
(90536,'enUS','','We got reports from da field, mon!',26124),
(90537,'enUS','You did good bringin\' me dis report. Now, be returnin\' to da field.','',26124),
(90538,'enUS','','Right away, boss!',26124),
(90539,'enUS','','Our reports be statin\' dat dere is a group of hostile arakkoa outcasts  jus\' outside da outpost.',26124),
(90540,'enUS','Arakkoa outcasts, ya say? Here I thought we be allies with dem.','',26124),
(90541,'enUS','I\'ll be needin\' to have some words with our friends from the Ravenspeakers to figure out da true nature of dese arakkoa.','',26124),
(90542,'enUS','','Boss, our scouts are sayin\' dat da Alliance is empowerin\' a giant ancient ta send into battle!',26124),
(90543,'enUS','Hah! If dey think they can scare da Horde with a big tree, den we be havin\' a surprise for dem!','',26124),
(90544,'enUS','We\'ll be seein how dey feel when da earth below dem comes ta fight at our side!','',26124),
(90545,'enUS','','Da elf, Belloc, been sayin\' dat he be needin more men ta find da big artifact.',26124),
(90546,'enUS','Dat Belloc bein\' lucky dat I haven\'t lost my patience with him! I don\'t jave soldia\'s layin around ta be diggin\' up relics!','',26124),
(90547,'enUS','You tell da elf that he get whateva\' volunteers he get. And he better be hurryin\' up before I get tired a\' lookin at him!','',26124),
(90548,'enUS','','We be gettin some strange reports from out scouts over by da big ogre mine.',26124),
(90549,'enUS','','Dey say dere be a giant creature in the mine dat\'s been makin\' short work of any grunts dat look at it twice.',26124),
(90550,'enUS','I am a master of persuasion, but it seems the Sargerei value strength, not oratory.$B$BThe quickest way to earn their trust is through battle. I am sure that is why Modera sent you to help me.','',26124),
(90551,'enUS','Da grunts be tough, it\'s true, but dey don\'t have da smarts to take on such a monsta. I\'ll send da Shadow Huntas in, and we\'ll see how tough dis thing is.','',26124),
(90552,'enUS','The Thunderlords are here to give us a lesson in revenge. Instead, let\'s teach them humility.','',26124),
(90553,'enUS','The first charge is broken.','',26124),
(90554,'enUS','Spread out! Don\'t let them flank us!','',26124),
(90555,'enUS','We\'ve almost got them!','',26124),
(90556,'enUS','Stubborn, I see. This is it, soldiers. For the Alliance!','',26124),
(90557,'enUS','Touch the Time Bombs to send them back into the sky!','Touch the Time Bombs to send them back into the sky!',26124),
(90558,'enUS','Remember, keep your mouth clenched, so if you\'re struck by lightning then you won\'t bite off your tongue.','',26124),
(90559,'enUS','Go Away!','Go Away!',26124),
(90560,'enUS','Tears Ahead','Tears Ahead',26124),
(90561,'enUS','Dead Inside','Dead Inside',26124),
(90562,'enUS','Allies Required Ahead','Allies Required Ahead',26124),
(90563,'enUS','Help Me!','Help Me!',26124),
(90564,'enUS','Visions of Demise','Visions of Demise',26124),
(90565,'enUS','Stay Calm','Stay Calm',26124),
(90566,'enUS','Loot Ahead','Loot Ahead',26124),
(90567,'enUS','Thousands of years ago, the demons of the Burning Legion came to our homeworld and offered our leaders a great gift.$B$BTwo of them, Kil\'jaeden and Archimonde, saw the wisdom in their offering, but the last leader, Prophet Velen, refused.$B$BHe and his followers fled from that world, forever hunted by those who once offered their hands in friendship.$B$BVelen was a FOOL! And we are descended from those fools, who would turn their backs on paradise!$B$BNo longer, my brethren! Today, we rise up and bow to the demon lords. They have given us another chance to share in their power.$B$BThis, my brothers and sisters, is our TRUE destiny. Today, we walk in the footsteps of our eredar forerunners, and claim the future that is rightfully ours!','',26124),
(90568,'enUS','The Legion\'s work must continue uninterrupted. There are those on Draenor who wish to disrupt their plans, and chief among them are the unbelievers - draenei who still follow the Light.$B$BDestroy our kin, and keep our masters\' work unhindered. Defeat the draenei, and we prove our loyalty to the Legion. Crush Shattrath, and the demons promise us the glory of immortality!','',26124),
(90569,'enUS','We draenei are the chosen race... civilized, cultivated, keenly intellectual.$B$BThere is no technology that our minds cannot grasp, and no magic that our arcanists cannot master.$B$BOur civilization on Argus was magnificent to behold.$B$BOur people were never slaves nor cowards, hiding from their potential.$B$BOur people have the means to conquer the stars!$B$BUnite with me, brothers and sisters, and let us take what is rightfully ours!','',26124),
(90570,'enUS','','When is Papa coming home?',26124),
(90574,'enUS','%s begins to cast |cFFFF0404|Hspell:176464|h[Ripples in Time]|h|r! Seek cover!','',26124),
(90577,'enUS','','Is Papa still hunting?',26124),
(90579,'enUS','I want to build a new structure.','I want to build a new structure.',26124),
(90588,'enUS','Only the very best for you, commander.','',26124),
(90589,'enUS','You can make your choice at the drafting table, commander.','',26124),
(90590,'enUS','Strengthen my armor and weapon so that they do not dull.','Strengthen my armor and weapon so that they do not dull.',26124),
(90591,'enUS','Ranjit creates a |cFFFF0000|Hspell:153759|h[Windwall]|h|r near |cFFFF0000$n|r!','Ranjit creates a |cFFFF0000|Hspell:153759|h[Windwall]|h|r near |cFFFF0000$n|r!',26124),
(90592,'enUS','Ranjit uses his secret technique, |cFFFF0000|Hspell:156793|h[Four Winds]|h|r!','Ranjit uses his secret technique, |cFFFF0000|Hspell:156793|h[Four Winds]|h|r!',26124),
(90593,'enUS','|TInterface\\Icons\\ability_fixated_state_red:20|tA Solar Flare has |cFFFF0000|Hspell:176544|h[Fixated]|h|r on you! If it reaches you it will |cFFFF0000|Hspell:153828|h[Explode]|h|r!','',26124),
(90594,'enUS','A Solar Flare |cFFFF0000|Hspell:176544|h[Fixates]|h|r on |cFFFF0000$n|r!','A Solar Flare |cFFFF0000|Hspell:176544|h[Fixates]|h|r on |cFFFF0000$n|r!',26124),
(90595,'enUS','|cFFFF0000$n|r has been targeted by the Arakkoa\'s |cFFFF0000|Hspell:154043|h[Super Weapon]|h|r!','|cFFFF0000$n|r has been targeted by the Arakkoa\'s |cFFFF0000|Hspell:154043|h[Super Weapon]|h|r!',26124),
(90596,'enUS','|cFFFF0000$n|r has been selected to be |cFFFF0000|Hspell:153954|h[Cast Down]|h|r!','|cFFFF0000$n|r has been selected to be |cFFFF0000|Hspell:153954|h[Cast Down]|h|r!',26124),
(90597,'enUS','Tremble before the might of the Forsaken.','',26124),
(90598,'enUS','One shot, one kill.','',26124),
(90599,'enUS','You won\'t even see me coming.','',26124),
(90600,'enUS','Hold still.','',26124),
(90601,'enUS','You might feel a slight pinch.','',26124),
(90602,'enUS','You\'re already dead.','',26124),
(90603,'enUS','Let\'s dance.','',26124),
(90604,'enUS','Don\'t make this boring.','Don\'t make this boring.',26124),
(90605,'enUS','Right between the eyes.','',26124),
(90606,'enUS','You will serve in death.','',26124),
(90607,'enUS','Dark Lady watch over you.','',26124),
(90608,'enUS','That\'s it?','',26124),
(90609,'enUS','Hardly worth the effort.','',26124),
(90610,'enUS','You are unfit to even be raised as a ghoul.','',26124),
(90611,'enUS','I knew you wouldn\'t last long.','',26124),
(90612,'enUS','You are unworthy of my mercy.','',26124),
(90613,'enUS','What is your wish, commander?','What is your wish, commander?',26124),
(90614,'enUS','May the Dark Lady smile upon you.','',26124),
(90615,'enUS','I shall send your regards to the Dark Lady.','',26124),
(90616,'enUS','At your service.','',26124),
(90617,'enUS','Say the word and consider it done.','',26124),
(90618,'enUS','My bow is ready.','',26124),
(90619,'enUS','Your will be done.','',26124),
(90620,'enUS','Yes, commander?','',26124),
(90621,'enUS','You will pay... for this...','',26124),
(90622,'enUS','','Don\'t worry, I\'ll only take a moment.',26124),
(90623,'enUS','','Ye want me tae cut ya here first? How about... here?',26124),
(90624,'enUS','','Let me show ye how it\'s done.',26124),
(90625,'enUS','','I\'m goin\' tae take me time with ye. I want tae savor yer screamin\'.',26124),
(90626,'enUS','','Ye want tae fight with me, do ye?',26124),
(90627,'enUS','','Show me what yer made out of, ye mongrel.',26124),
(90628,'enUS','','Ye won\'t even know what hit ye.',26124),
(90629,'enUS','','Very well. I\'ll kill ye first.',26124),
(90630,'enUS','','Oops. Did I do that?',26124),
(90631,'enUS','','Scream louder, will ye? I can barely hear ye!',26124),
(90632,'enUS','','That\'s how a Dark Iron does it.',26124),
(90633,'enUS','','I may have stabbed ye one too many times.',26124),
(90634,'enUS','','I cannae believe ye were so easy.',26124),
(90635,'enUS','','Not much of a fight, really.',26124),
(90636,'enUS','','Well, ye died, so ye have that goin\' fer ya.',26124),
(90637,'enUS','','Better luck next time.',26124),
(90638,'enUS','','What can I do fer ye?',26124),
(90639,'enUS','','Nice to see ye, commander.',26124),
(90640,'enUS','','The pleasure is mine.',26124),
(90641,'enUS','','My blades are yours, commander.',26124),
(90642,'enUS','','Need somethin\' \'taken care of\', commander?',26124),
(90643,'enUS','','I won\'t let ye down.',26124),
(90644,'enUS','','At yer service.',26124),
(90645,'enUS','','Point in a direction and I\'m there.',26124),
(90646,'enUS','','Ah... they got me...',26124),
(90647,'enUS','On your knees, slave!','',26124),
(90648,'enUS','100 gold pieces to the ogre who can bring me this weakling\'s head!','',26124),
(90649,'enUS','I\'m casting a big cooldown.','I\'m casting a big cooldown.',26124),
(90650,'enUS','Greetings, Commander $p.','',26124),
(90651,'enUS','One more cast...','',26124),
(90652,'enUS','A bad day of fishing is still better than the best day of work.','',26124),
(90653,'enUS','Here fishy, fishy fishy...','',26124),
(90654,'enUS','Spending too much time fishing? That\'s a good problem to have.','',26124),
(90655,'enUS','You can make your choice at the drafting table, commander.','',26124),
(90656,'enUS','','Greetings, Commander $p.',26124),
(90657,'enUS','$N is under our protection.','',26124),
(90658,'enUS','You shall not harm this $c.','',26124),
(90659,'enUS','The guardians of the forge watch over this $r.','',26124),
(90660,'enUS','I\'m going to light you up, sweet cheeks!','',26124),
(90661,'enUS','Who ordered up an extra large can of whoop-ass?','',26124),
(90662,'enUS','Stonecore was merely a setback!','',26124),
(90663,'enUS','You go ahead and get started. I need to summon up some water.','',26124),
(90664,'enUS','I will gladly join your fight against this impudent imbecile!','',26124),
(90665,'enUS','Prepare to defend yourself, cretin!','',26124),
(90666,'enUS','Here\'s a little something you\'re gonna love!','',26124),
(90667,'enUS','Who\'s bad? Who\'s bad? That\'s right, we bad!','',26124),
(90668,'enUS','I didn\'t even break a sweat on that one!','',26124),
(90669,'enUS','You guys feel free to jump in anytime.','',26124),
(90670,'enUS','Don\'t say I didn\'t warn ya!','',26124),
(90671,'enUS','Witness the full power of Millhouse Manastorm!','',26124),
(90672,'enUS','Meet your DOOOOOOOM!','',26124),
(90673,'enUS','Better luck next time, BWAHAHAHA!','',26124),
(90674,'enUS','Greetings, commander! Faithful minion Millhouse Manastorm here!','',26124),
(90675,'enUS','You wouldn\'t happen to have access to any N.U.K.U.L.A.R. weapons, would you?','',26124),
(90676,'enUS','Point me at \'em!','',26124),
(90677,'enUS','Hold on, one sec, just need to get my buffs up.','',26124),
(90678,'enUS','When do we destroy the world? Soon? I hope it\'s soon.','',26124),
(90679,'enUS','You will all be my slaves! Er, I mean, hi!','',26124),
(90680,'enUS','If you have any excess priceless artifacts that were lost in time, I\'m making a collection.','',26124),
(90681,'enUS','Have you ever been hit in the face by a worm made out of rocks? It feels like what it sounds like.','',26124),
(90682,'enUS','Heal me! For the love of all that\'s holy, heal me! I\'m dying!!','',26124),
(90683,'enUS','Krud is here! Any puke dat tinks dey can bring Krud down, better get some tribute. Get enough before Krud gets bored, and earn da right to be eviscerated by Krud.','',26124),
(90684,'enUS','Ha! You must really want Krud to slice you in half. Krud be twice as happy to oblige!','',26124),
(90685,'enUS','Ha! Krud knew no one brave enough to face Krud. You not even half da fighter Krud be.','',26124),
(90686,'enUS','When dis be over, da gravediggers gonna spend days figurin\' out what limbs go wit which body.','',26124),
(90687,'enUS','Pathetic... Krud could of cut dat kill time in half...','',26124),
(90688,'enUS','Thank you for sparing Leorajh.','',26124),
(90689,'enUS','Leorajh and sun rock serve you well. Bring glory to clan!','',26124),
(90690,'enUS','Tick... Tock... Tick... Tock','',26124),
(90691,'enUS','Who set up the bomb? Me.','',26124),
(90692,'enUS','Time to bash skulls.','',26124),
(90693,'enUS','No way you gonna get to the Ring of Blood.','',26124),
(90694,'enUS','When did dey start lettin\' vermin into da provin\' grounds?','',26124),
(90695,'enUS','Dis gonna be a quick fight.','',26124),
(90696,'enUS','I\'ve been killin\' pukes like you all day.','',26124),
(90697,'enUS','HA! You tink you\'re gonna make it past me?','',26124),
(90698,'enUS','Careful with that beast you idiots! You have no idea what it cost me to get it here!','',26124),
(90699,'enUS','Stop gawking and get that beast into a cage!','',26124),
(90700,'enUS','Do your job, morons! This beast is worth more than both of your lives!','',26124),
(90701,'enUS','If the alliance want Volrath, they\'ll have to get through me first.','',26124),
(90702,'enUS','','Well met.',26124),
(90703,'enUS','','Spirits be with you, commander.',26124),
(90704,'enUS','','Watch the shadows, commander.',26124),
(90705,'enUS','Long ago, before this place was infested with saberon, it was a peaceful village.The saberon invaded in the darkness of night and murdered us as we slept.$b$bAll that remains of my kin are our bones beneath the earth.','',26124),
(90706,'enUS','I\'m sorry $Gladdie:lass;, but I can\'t give you access to the vault.\n\nThis is where Dr Jones is keepin\' his artifacts secure. Even though the Explorer\'s League is allowing adventurers to store their gear in the extra space, the vault stays off limits.','',26124),
(90707,'enUS','turns his |Hitem:118427|h|cFFFFFFFF[Autographed Hearthstone Card]|r|h card over, revealing a |cFFFFFFFF[Common Hearthstone Card]|r!','turns her |Hitem:118427|h|cFFFFFFFF[Autographed Hearthstone Card]|r|h card over, revealing a |cFFFFFFFF[Common Hearthstone Card]|r!',26124),
(90708,'enUS','Chopped and brewed.','',26124),
(90709,'enUS','Alright boys and girls, it\'s prime time!','',26124),
(90710,'enUS','I don\'t care how many o you dere be, one swing and you all be on da ground.','',26124),
(90711,'enUS','turns his |Hitem:118427|h|cFFFFFFFF[Autographed Hearthstone Card]|r|h card over, revealing a |cFF0070dd[Rare Hearthstone Card]|r!','turns her |Hitem:118427|h|cFFFFFFFF[Autographed Hearthstone Card]|r|h card over, revealing a |cFF0070dd[Rare Hearthstone Card]|r!',26124),
(90712,'enUS','turns his |Hitem:118427|h|cFFFFFFFF[Autographed Hearthstone Card]|r|h card over, revealing an |cFFa335ee[Epic Hearthstone Card]|r!','turns her |Hitem:118427|h|cFFFFFFFF[Autographed Hearthstone Card]|r|h card over, revealing an |cFFa335ee[Epic Hearthstone Card]|r!',26124),
(90713,'enUS','Dead rats!','',26124),
(90714,'enUS','That was not a profitable endeavor.','',26124),
(90715,'enUS','turns his |Hitem:118427|h|cFFFFFFFF[Autographed Hearthstone Card]|r|h card over, revealing a |cffff8000[Legendary Hearthstone Card]|r!','turns her |Hitem:118427|h|cFFFFFFFF[Autographed Hearthstone Card]|r|h card over, revealing a |cffff8000[Legendary Hearthstone Card]|r!',26124),
(90716,'enUS','To the face!','',26124),
(90717,'enUS','Eat dirt!','',26124),
(90718,'enUS','I puke up puddles tougher den you.','',26124),
(90719,'enUS','','Time for you to leave!',26124),
(90720,'enUS','I not sure whether to kiss you... or fight you.','',26124),
(90721,'enUS','I been lookin\' for a fight!','',26124),
(90722,'enUS','Victory or death. There are no other options.','',26124),
(90723,'enUS','I fought long and hard to get the opportunity to serve under you, commander.$B$BIt\'s truly an honor.','',26124),
(90724,'enUS','It will be done, commander.','',26124),
(90725,'enUS','Right away, commander.','',26124),
(90726,'enUS','You can make your choice at the drafting table, commander.','',26124),
(90727,'enUS','You can make your choice at the drafting table, commander.','',26124),
(90728,'enUS','Fortune cookie say...','',26124),
(90729,'enUS','Oh boy...','',26124),
(90730,'enUS','Awful, just awful.','',26124),
(90731,'enUS','Please, never again.','',26124),
(90732,'enUS','What?! C\'mon that was gold man.','',26124),
(90733,'enUS','Did you see the look on his face?','',26124),
(90734,'enUS','It was priceless!','',26124),
(90735,'enUS','Cymre! Is that you?','Cymre! Is that you?',26124),
(90736,'enUS','','Hello again. We got wind that there are hidden artifacts here, in this place called Ashran. Artifacts from a remnant Highmaul Ogre clan. $B$BDo you have any idea what kind of power they could possibly hold?$B$B',26124),
(90737,'enUS','We\'re going to have to get back out there soon.','',26124),
(90738,'enUS','Yeah I know, but those crazy bird things really creep me out.','',26124),
(90739,'enUS','Welcome, my friend, to your death.','',26124),
(90740,'enUS','By the light!','',26124),
(90741,'enUS','Go on! Give me a reason to heal myself.','',26124),
(90742,'enUS','... sigh...','',26124),
(90743,'enUS','Try healing through that.','',26124),
(90744,'enUS','Should have brought a better healer, my friend.','',26124),
(90745,'enUS','... sigh...','',26124),
(90746,'enUS','I look forward to healing you, commander.','',26124),
(90747,'enUS','Warm wishes to you.','',26124),
(90748,'enUS','Where was my tank... ?','',26124),
(90749,'enUS','Hey there, Commander $n.','',26124),
(90750,'enUS','For the Frostwolves!','',26124),
(90751,'enUS','For honor!','',26124),
(90752,'enUS','To battle!','',26124),
(90753,'enUS','Lok-tar ogar! Victory or death!','',26124),
(90754,'enUS','Taste my axe!','',26124),
(90755,'enUS','For Stonefang!','',26124),
(90756,'enUS','A good death.','',26124),
(90757,'enUS','Die with some dignity.','',26124),
(90758,'enUS','Lok-tar!','',26124),
(90759,'enUS','Yes! A good battle!','',26124),
(90760,'enUS','Throm-Ka.','',26124),
(90761,'enUS','The Frostwolves stand ready.','',26124),
(90762,'enUS','Lok-Regar.','',26124),
(90763,'enUS','My axe is ready.','',26124),
(90764,'enUS','Nerok thirsts for battle.','',26124),
(90765,'enUS','The Iron Horde will pay for my fallen brothers and sisters.','',26124),
(90766,'enUS','Lokra... forgive me...','',26124),
(90767,'enUS','|cFFFF0000WARNING!|r! You\'ve entered an extremely dangerous area! |cFFFF0000Turn Back|r!','',26124),
(90768,'enUS','When you die, I shall claim your shoes as my own!','',26124),
(90769,'enUS','Hahahaha!','',26124),
(90770,'enUS','Time for a taste from the pain wagon of murder meat!','',26124),
(90771,'enUS','Another skull to wear.','',26124),
(90772,'enUS','Dibs on its belt!','',26124),
(90773,'enUS','I am keeping its nose.','',26124),
(90774,'enUS','This skull is too small and unusable. Bring me another!','',26124),
(90775,'enUS','Can I have your skull when you die?','',26124),
(90776,'enUS','I shall make a totem from the corpses of your enemies.','',26124),
(90777,'enUS','Hahahaha... ahem... hail.','',26124),
(90778,'enUS','No! I lost my ankh.','',26124),
(90779,'enUS','','Ah, hero... I knew you would come. Gaze upon the source of your demise!',26124),
(90780,'enUS','','Now, I will leave you a taste of the Iron Horde\'s new power!',26124),
(90781,'enUS','We have been studying this \"Heart of Gorgorek.\" It bears a great number of similarities to certain titan artifacts we have seen back on Azeroth.','',26124),
(90782,'enUS','We must call upon experts before we can be sure of the artifact\'s origin, and purpose. In fact, we may need to transport the device back to Azeroth for additional study.','',26124),
(90783,'enUS','The artifact that we discovered in Gorgrond appears to have a similiar signature to this one.$B$BIt is almost certain that it was a smaller fragment of this larger, intact device.$B$BIf the splinter was capable of summoning a colossal creature to your aid, then what could this device be capable of?','',26124),
(90784,'enUS','','We have been studying this \"Heart of Gorgorek.\" It bears a great number of similarities to certain titan artifacts we have seen back on Azeroth.',26124),
(90785,'enUS','','We must call upon experts before we can be sure of the artifact\'s origin, and purpose. In fact, we may need to transport the device back to Azeroth for additional study.',26124),
(90786,'enUS','','The artifact that we discovered in Gorgrond appears to have a similiar signature to this one.$B$BIt is almost certain that it was a smaller fragment of this larger, intact device.$B$BIf the splinter was capable of summoning a colossal creature to your aid, then what could this device be capable of?',26124),
(90787,'enUS','','Why did we have to come to Shadowmoon? Min Loo knows I hate the dark...',26124),
(90788,'enUS','','I improved our map by color coding each destination by its danger level!',26124),
(90789,'enUS','Have you tried the local fare? These draenei sure know how to cook.','',26124),
(90790,'enUS','Have you been to the Crescent Hearth? They have some delicious pies. Or Embaari Village? The fresh produce is shipped in from Elodor daily!','',26124),
(90791,'enUS','I like it here in Shadowmoon Valley. It\'s so peaceful and quiet... not like that bone zone.','',26124),
(90792,'enUS','When we improve this boat, I\'m going to replace all the parts for half the price!','',26124),
(90793,'enUS','','This boat is quite legitimate!',26124),
(90794,'enUS','Zarg like kitties. Zarg train his little kitties to be cute little warriors. \n\nWhat? Why you look at me like that? \n\nYou got something against kitties?','',26124),
(90795,'enUS','You need talk to Varzok in Orgrimmar!  Any guard there should be able to give directions to him.\n\nDa portal to Orgrimmar inside shaman hut.  Good luck!','',26124),
(90796,'enUS','$n detonated Destructive Resonance!','',26124),
(90797,'enUS','I have seen the saberon strip the bones of the innocent. I have seen the remains of my clansmen cooked in their wretched cauldron. Now... it shall be the saberon whose bones are desecrated and boiled!','',26124),
(90798,'enUS','You have honored the memory of my kin, $c. Take this blessing with you on your journey, so that it may it guide your arm and swiften your step.','',26124),
(90799,'enUS','Man, I thought it would be a pretty sweet gig coming out here with the Society. Boy was I wrong!','',26124),
(90800,'enUS','','What\'s wrong with this place? The digs ain\'t bad.',26124),
(90801,'enUS','It ain\'t the digs I\'m concerned about. Everywhere you turn either an ogre is trying to club your head in, or one of those Alliance goons wants to stick a sword in ya!','',26124),
(90802,'enUS','','I thought you were tellin\' me that you laugh in the face of danger? Sounds like you might be afraid of this place.',26124),
(90803,'enUS','Oh I ain\'t afraid, baby. It\'s just that death puts a steep cut in the profit margins.','',26124),
(90804,'enUS','Is beer the only thing these orcs drink? What does a goblin gotta do to get a nice cocktail around here?','',26124),
(90805,'enUS','','It ain\'t so bad. It kinda makes me nostalgic.',26124),
(90806,'enUS','Nostalgic? How does that swill make you nostalgic?','',26124),
(90807,'enUS','','Well, the taste kinda reminds me of the runoff water from cooling the machines back home. It\'s all we had to drink when I was a kid.',26124),
(90808,'enUS','Wow, that\'s... surprisingly accurate.','',26124),
(90809,'enUS','How about we see who is on the other side of these anomalous shenanigans?','',26124),
(90810,'enUS','After the toll taken from our assault on the Dark Portal, much of our remaining forces came to regroup here in Ashran. It is unfortunate that hostilities with the Alliance came shortly after.\n\nDo you seek refuge here, as well, or do you wish to stoke the flames of battle further?','',26124),
(90811,'enUS','Temporal juxtaposition incoming!','',26124),
(90812,'enUS','','These trolls aren\'t so bad. They may be skinny and talk funny, but they make a fun spear launcha! \n\nI can\'t wait to skewer some dwarves with this thing!',26124),
(90813,'enUS','Wow! It worked. And we haven\'t been temporally inverted.','',26124),
(90814,'enUS','The sign reads:\n\n\"I\'m Commander $n, and this is my favorite merchant in Warspear.\"','',26124),
(90815,'enUS','','Pay dat sign no heed, mon. Just a harmless bit a\' advertisin\'.',26124),
(90816,'enUS','','This did not have to end in violence.',26124),
(90817,'enUS','','The light shall burn you.',26124),
(90818,'enUS','','For the Sha\'tari.',26124),
(90819,'enUS','','For the Alliance, for the King!',26124),
(90820,'enUS','','You chose the wrong side.',26124),
(90821,'enUS','','You have failed in your quest.',26124),
(90822,'enUS','','Commander, I think an inn would greatly improve morale.',26124),
(90823,'enUS','','Commander, I have tallied your defenses and believe we might benefit from additional balancing.',26124),
(90824,'enUS','','Commander! ...When will the Prince be visiting?',26124),
(90825,'enUS','','If I wrote a letter, would you take it to Stormwind for me?',26124),
(90826,'enUS','','I hear you have a prince who follows the light. Will he be visiting soon?',26124),
(90827,'enUS','','For... the light.',26124),
(90828,'enUS','The Spirit of Exarch Hataaru begins casting |cFFFF0000|Hspell:176784|h[Pain Field]|h|r!','The Spirit of Exarch Hataaru begins casting |cFFFF0000|Hspell:176784|h[Pain Field]|h|r!',26124),
(90829,'enUS','','Let\'s see what YOUR bones look like.',26124),
(90830,'enUS','','Mind helping with an experiment?',26124),
(90831,'enUS','','Oh, hold still. I want to try a new spell.',26124),
(90832,'enUS','','Are you an animal, vegetable, mineral, or other?',26124),
(90833,'enUS','','I mostly work with fossils, so, this might hurt.',26124),
(90834,'enUS','','Oh, so that happened.',26124),
(90835,'enUS','','Interesting results.',26124),
(90836,'enUS','','Note to self, $n is very sensitive to fire.',26124),
(90837,'enUS','','Oops.',26124),
(90838,'enUS','','There are all sorts of shiny trinkets buried under the ground here.',26124),
(90839,'enUS','','Hey commander. Can I get salvage rites to this place after you die?',26124),
(90840,'enUS','','Live by the fossil, become a fossil.',26124),
(90841,'enUS','Kneecaaaaps!','Kneecaaaaps!',26124),
(90842,'enUS','Die! Die-die-die-die!','Die! Die-die-die-die!',26124),
(90843,'enUS','Mmm. Smell meat!','Mmm. Smell meat!',26124),
(90844,'enUS','Dinner time? Dinner tiiiime!','Dinner time? Dinner tiiiime!',26124),
(90845,'enUS','Look tasty-tasty!','Look tasty-tasty!',26124),
(90846,'enUS','Hee hee hee! Blood!','Hee hee hee! Blood!',26124),
(90847,'enUS','We kill! Kill-kill-kill!','We kill! Kill-kill-kill!',26124),
(90848,'enUS','No kill?','No kill?',26124),
(90849,'enUS','This will only hurt for a moment.','',26124),
(90850,'enUS','Why you no die?','Why you no die?',26124),
(90851,'enUS','I will reduce you to ashes!','',26124),
(90852,'enUS','For the Order!','',26124),
(90853,'enUS','Ow-ow-ow-ow-ow!','Ow-ow-ow-ow-ow!',26124),
(90854,'enUS','You will burn for your crimes!','',26124),
(90855,'enUS','Rukhmar, guide my hand.','',26124),
(90856,'enUS','You... you no good.','You... you no good.',26124),
(90857,'enUS','You have no place in our future.','',26124),
(90858,'enUS','No-no-no-no-no...','No-no-no-no-no...',26124),
(90859,'enUS','Such is the cost of progress.','',26124),
(90860,'enUS','I have no tolerance for savagery.','',26124),
(90861,'enUS','Blind fool.','',26124),
(90862,'enUS','A brilliant future awaits us.','',26124),
(90863,'enUS','Greetings, commander. I trust everything is in order?','',26124),
(90864,'enUS','The light of the Awakened is at your command.','',26124),
(90865,'enUS','You are looking rather radiant today.','',26124),
(90866,'enUS','I am glad to be among new allies.','',26124),
(90867,'enUS','Forgive me, commander, but I am feeling a bit... cooped up. Do you have an away mission for me?','',26124),
(90868,'enUS','I return... to Rukhmar.','',26124),
(90869,'enUS','You will not interfere!','You will not interfere!',26124),
(90870,'enUS','Are you lost?','Are you lost?',26124),
(90871,'enUS','These rylaks are property of the Iron Horde!','These rylaks are property of the Iron Horde!',26124),
(90872,'enUS','Your path leads only to death.','Your path leads only to death.',26124),
(90873,'enUS','Trespasser!','Trespasser!',26124),
(90874,'enUS','Bin huruk thora korro... rra hokumm ura korak.','Bin huruk thora korro... rra hokumm ura korak.',26124),
(90875,'enUS','I do not fear death.','I do not fear death.',26124),
(90876,'enUS','My brothers shall avenge me.','My brothers shall avenge me.',26124),
(90877,'enUS','Ah ha! More for the mulch!','Ah ha! More for the mulch!',26124),
(90878,'enUS','The god in bloom will not be disturbed!','The god in bloom will not be disturbed!',26124),
(90879,'enUS','Remove this... bramble from our garden.','Remove this... bramble from our garden.',26124),
(90880,'enUS','Your corpse will feed our god!','Your corpse will feed our god!',26124),
(90881,'enUS','You will be harvested!','You will be harvested!',26124),
(90882,'enUS','Great genesaur, feed on me.','Great genesaur, feed on me.',26124),
(90883,'enUS','I give life to my master.','I give life to my master.',26124),
(90884,'enUS','The cycle... continues...','The cycle... continues...',26124),
(90885,'enUS','...Farondis... the Tidestone of Golganneth... our last hope...','',26124),
(90886,'enUS','That is all I can remember. Help me reclaim my memories, and I may be able to aid you.','',26124),
(90887,'enUS','Farondis, the time to move is now.','',26124),
(90888,'enUS','Your Queen Azshara\'s abuse of magic has attracted the attention of a legion of demons. We have little time left.','',26124),
(90889,'enUS','I agree... but must we use the Tidestone? Such a drastic solution.','',26124),
(90890,'enUS','Very well.','',26124),
(90891,'enUS','I knew I could rely on you, Farondis.','',26124),
(90894,'enUS','Illidan, I have doubts about Cenarius\' plan.','',26124),
(90895,'enUS','He wants to use the Tidestone of Golganneth! To destroy the Well of Eternity itself!','',26124),
(90896,'enUS','It\'s a doomsday device!','',26124),
(90897,'enUS','I know. But you aren\'t strong enough to keep Cenarius away from the Tidestone... even with my help.','',26124),
(90898,'enUS','What do we do, then?','',26124),
(90899,'enUS','Only Queen Azshara herself stands a chance against a demigod like him.','',26124),
(90900,'enUS','I\'m sorry, Cenarius. I believed in your cause, but I couldn\'t bring myself to turn against...','',26124),
(90901,'enUS','','You\'ve done me a great service today, Farondis.',26124),
(90902,'enUS','','What a shame that you won\'t LIVE to reap the benefits of my gratitude.',26124),
(90903,'enUS','...what?!','',26124),
(90904,'enUS','','This whole valley is filled with plotters and schemers.',26124),
(90905,'enUS','','Cavorting with Cenarius behind my back? I will NOT tolerate dissent!',26124),
(90906,'enUS','Tasty tasty!','',26124),
(90907,'enUS','Aim for its heart!','Aim for its heart!',26124),
(90908,'enUS','Watch. I shall conjure an image of the few memories I have about this... Tidestone.','',26124),
(90909,'enUS','I\'m afraid that the Tidestone of Golganneth may be our last hope.','',26124),
(90910,'enUS','','Here it is, my Prince: The Tidestone of Golganneth, one of the seven Stones of Creation, and treasured relic of the kaldorei.',26124),
(90911,'enUS','Very good. Leave me.','',26124),
(90912,'enUS','','Tales of your deeds travel far, $c. Allow me to recount some of your greatest exploits.',26124),
(90913,'enUS','%s throws down a Hearthstone board! Who\'s ready to play?','%s throws down a Hearthstone board! Who\'s ready to play?',26124),
(90914,'enUS','%s opens up a new pack of Hearthstone cards. Mmm, love that new card smell!','%s opens up a new pack of Hearthstone cards. Mmm, love that new card smell!',26124),
(90915,'enUS','%s just won a game of Hearthstone!','%s just won a game of Hearthstone!',26124),
(90916,'enUS','|TInterface\\Icons\\spell_burningbladeshaman_molten_torrent.blp:20|t |cFFFF0404|Hspell:154938|h[Molten Torrent]|h|r killed you. Minimize damage by standing near several allies.','',26124),
(90917,'enUS','Where did everyone go?','',26124),
(90918,'enUS','|TInterface\\Icons\\spell_burningbladeshaman_molten_torrent.blp:20|t |cFFFF0404|Hspell:154938|h[Molten Torrent]|h|r killed you. Standing near a group of allies reduces the amount of damage taken by everyone affected!','',26124),
(90919,'enUS','|TInterface\\Icons\\spell_burningbladeshaman_molten_torrent.blp:20|t |cFFFF0404|Hspell:154938|h[Molten Torrent]|h|r killed you.','',26124),
(90920,'enUS','You want spikes? Got lots of spikes. Spikes go good on everything! Make it look spikier.','',26124),
(90921,'enUS','The shrine has dozens of niches where the Prophet\'s followers have placed memory crystals, mourning the great leader\'s sacrifice. There are hundreds of prayers and remembrances here, from peasants to Exarchs and everyone in-between.','',26124),
(90922,'enUS','The shipment from the Forge never arrived, so the boys took off early.','',26124),
(90923,'enUS','Listen to the Prophet\'s final message.','Listen to the Prophet\'s final message.',26124),
(90924,'enUS','The load of weapons from the Forge never showed up, what\'s going on up there?','',26124),
(90925,'enUS','These weapons aren\'t imbued! Ka\'graz go on break or something?','',26124),
(90926,'enUS','This place needs more spikes.','This place needs more spikes.',26124),
(90927,'enUS','','Tales of your deeds travel far, $c. Allow me to recount some of your greatest exploits.',26124),
(90928,'enUS','Man who turned the heat off, it\'s FREEZING in here!','',26124),
(90929,'enUS','What\'s wrong with Kromog? I haven\'t heard him rumbling in a while.','',26124),
(90930,'enUS','Not now! These humans have brought in all of this mouth watering meat! Just look at it! Imagine, gnashing and shredding it with your fangs. The juices and the ripping of meat from the bone as you\'re devouring it... \n\n<The worgen\'s eyes wander off...>\n\nWhat did you want again?','',26124),
(90931,'enUS','When a Druid fights in tree form, he\'s called a combat log.','',26124),
(90932,'enUS','Talador: The Battle for Shattrath','Talador: The Battle for Shattrath',26124),
(90933,'enUS','Frostfire Ridge: Thunder Pass','Frostfire Ridge: Thunder Pass',26124),
(90934,'enUS','These crates of Ore are piling up, those guys up in the Blast Furnace sure are slacking!','',26124),
(90935,'enUS','When a gnome clockmaker is hungry, he goes back 4 seconds.','',26124),
(90936,'enUS','Talador: Battle for Shattrath','Talador: Battle for Shattrath',26124),
(90937,'enUS','Shadowmoon Valley: Darkness Falls','Shadowmoon Valley: Darkness Falls',26124),
(90938,'enUS','I tried getting Feldspar on the line and he isn\'t answering, I bet he\'s off talking to Foreman Jorge again.','',26124),
(90939,'enUS','When one Tauren spies on another, it\'s called a steak out.','',26124),
(90940,'enUS','A rogue\'s favorite drink is subtle tea.','',26124),
(90941,'enUS','A Pandaren who cooks in the dark must use a Shado-Pan.','',26124),
(90942,'enUS','Why would you start a fire! Don\'t you see the crates of ammo piling up over there!','',26124),
(90943,'enUS','Cuz it\'s cold!!!','',26124),
(90944,'enUS','Hunters take bad photographs because they are always out of focus.','',26124),
(90945,'enUS','Blasted Lands: Into the Portal','Blasted Lands: Into the Portal',26124),
(90946,'enUS','Never argue with a Tauren, it goes in one ear and out the udder.','',26124),
(90947,'enUS','A Mage who cannot fish is considered a bad caster.','',26124),
(90948,'enUS','Queue me up for the Coliseum!','Queue me up for the Coliseum!',26124),
(90949,'enUS','Tanaan Jungle: A Taste of Iron','Tanaan Jungle: A Taste of Iron',26124),
(90950,'enUS','When a trinket gets angry, it needs to cooldown.','',26124),
(90951,'enUS','When Paladins are unhappy about their pay, they go on Crusader Strike.','',26124),
(90952,'enUS','Nagrand: And Justice for Thrall','Nagrand: And Justice for Thrall',26124),
(90953,'enUS','Kill the interlopers! The siphoning must not be disturbed! (We\'re making a void god!)','',26124),
(90954,'enUS','Open the portals to the realm of the living! Soon we shall feast upon their souls!','',26124),
(90955,'enUS','I can\'t wait till I\'m strong enough to wear THIS skull!','',26124),
(90956,'enUS','The Light within Oshu\'gun is dying... soon our path will be clear to invade the realm of the living!','',26124),
(90957,'enUS','Oh hi! Kaz told me you might be back. She comes by sometimes to see how I\'m doing and burn bodies.','',26124),
(90958,'enUS','The legions of the void are without number! Nothing will stand in our way!','',26124),
(90959,'enUS','Did you know genesaur have skulls? I didn\'t know. It took a long time to get all the vines off of it.','',26124),
(90960,'enUS','The void within Oshu\'gun grows... and with it our path to the mortal realm! The feast of souls is upon us!','',26124),
(90961,'enUS','Greetings, $r.$B$BI can see from your demeanor that you are no ordinary adventurer.$B$BDraenor is a harsh world and many dangerous enemies lurk in both palaces and crypts. They aim to bring terrible destruction to this land using devastating weapons and magic. Securing these places and their treasures would mean excellent rewards for you and your companions.$B$BHowever, do not tread idly into these places, for other adventurers are nipping at your heels and only a race against time will prove your skills to be unmatched!$B$BAre you up for the new challenge Draenor has to offer?','Greetings, $r.$B$BI can see from your demeanor that you are no ordinary adventurer.$B$BDraenor is a harsh world and many dangerous enemies lurk in both palaces and crypts. They aim to bring terrible destruction to this land using devastating weapons and magic. Securing these places and their treasures would mean excellent rewards for you and your companions.$B$BHowever, do not tread idly into these places, for other adventurers are nipping at your heels and only a race against time will prove your skills to be unmatched!$B$BAre you up for the new challenge Draenor has to offer?',26124),
(90962,'enUS','Grant me the blessings of the anvil and the forge.','Grant me the blessings of the anvil and the forge.',26124),
(90963,'enUS','We will feed your bones to the wolves, outsider.','',26124),
(90964,'enUS','You cannot defeat the spirit of the Warsong!','',26124),
(90965,'enUS','Relent to the unstoppable power of the elements!','',26124),
(90966,'enUS','What wonderful timing. My last plaything had to split.','',26124),
(90967,'enUS','I return to the earth, but I will rise again enflamed!','',26124),
(90968,'enUS','Coming into our camp was reckless, but facing me is suicide.','',26124),
(90969,'enUS','It\'s an ambush!','',26124),
(90970,'enUS','I want to hear you scream as I peel the flesh from your bones!','',26124),
(90971,'enUS','Scream for me!','Scream for me!',26124),
(90972,'enUS','I want to watch you bleed.','I want to watch you bleed.',26124),
(90973,'enUS','Blood and pain!','Blood and pain!',26124),
(90974,'enUS','I\'m going to rip you apart slowly.','I\'m going to rip you apart slowly.',26124),
(90975,'enUS','Such lovely skin, I think I\'ll keep it after you\'re dead.','',26124),
(90976,'enUS','Victory or death!','Victory or death!',26124),
(90977,'enUS','For the glory of the Warsong!','For the glory of the Warsong!',26124),
(90978,'enUS','The might of the Warsong will crush you!','The might of the Warsong will crush you!',26124),
(90979,'enUS','How did you get up here?!','',26124),
(90980,'enUS','What are you doing here?!','',26124),
(90981,'enUS','This land is ours!','This land is ours!',26124),
(90982,'enUS','You dare stand against the Warsong?!','You dare stand against the Warsong?!',26124),
(90983,'enUS','Blood and glory!','Blood and glory!',26124),
(90984,'enUS','Death to our enemies!','Death to our enemies!',26124),
(90985,'enUS','You should not be here!','You should not be here!',26124),
(90986,'enUS','Leave us to our anguish!','Leave us to our anguish!',26124),
(90987,'enUS','','For Draenor!',26124),
(90988,'enUS','','Try to flank them...',26124),
(90989,'enUS','','Keep the high ground!',26124),
(90990,'enUS','','Exarch Naielle sends her regards.',26124),
(90991,'enUS','','Dispatched.',26124),
(90992,'enUS','The pain... make it stop!','The pain... make it stop!',26124),
(90993,'enUS','','Stay out of Shadowmoon!',26124),
(90994,'enUS','','The rangari are ready to serve.',26124),
(90995,'enUS','','May I suggest building a few sniper nests in the trees surrounding our stronghold?',26124),
(90996,'enUS','I\'ll rip the skin from your bones!','I\'ll rip the skin from your bones!',26124),
(90997,'enUS','','I will scout the perimeter during the night watch.',26124),
(90998,'enUS','','These woods provide excellent cover, but may mask an attack. We should stay vigilant.',26124),
(90999,'enUS','You\'ll pay for coming here!','You\'ll pay for coming here!',26124),
(91000,'enUS','','I\'m... bleeding out...',26124),
(91001,'enUS','Die!','Die!',26124),
(91002,'enUS','Make the voices stop!','Make the voices stop!',26124),
(91003,'enUS','I am engaging!','',26124),
(91004,'enUS','Defend the town hall!','',26124),
(91005,'enUS','Get the laborers to safety.','',26124),
(91006,'enUS','They will go no further!','',26124),
(91007,'enUS','Engage the defenses. Begin the counter-attack!','',26124),
(91008,'enUS','Target eliminated.','',26124),
(91009,'enUS','You are finished!','',26124),
(91010,'enUS','Begone!','',26124),
(91011,'enUS','My equipment is superior.','',26124),
(91012,'enUS','','You fight with much experience, Thrall. Why do you not have a mate?',26124),
(91013,'enUS','Commander! I have submitted plans to reinforce the walls.','',26124),
(91014,'enUS','For the glory of the Iron Horde!','For the glory of the Iron Horde!',26124),
(91015,'enUS','Do you need anything repaired?','',26124),
(91016,'enUS','Our might will crush you!','Our might will crush you!',26124),
(91017,'enUS','','You... wanted her to stay? This is war! More than ever, this is when family belongs at your side!',26124),
(91019,'enUS','Your followers need better equipment. I will do my best to procure what I can.','',26124),
(91020,'enUS','You dare challenge our might?!','You dare challenge our might?!',26124),
(91021,'enUS','','What a strange green orc you are.',26124),
(91022,'enUS','Your death will be my glory!','Your death will be my glory!',26124),
(91024,'enUS','I\'ve been sharing schematics with the engineers from Azeroth. Gnomish technology is... unique.','',26124),
(91025,'enUS','So much to build. So little time!','',26124),
(91026,'enUS','They got me...','',26124),
(91027,'enUS','The Iron Horde will break you!','The Iron Horde will break you!',26124),
(91028,'enUS','Hurry up and die!','Hurry up and die!',26124),
(91030,'enUS','','Light protect us.',26124),
(91031,'enUS','','The faithful will never fall!',26124),
(91032,'enUS','','Light guide my strikes...',26124),
(91033,'enUS','','We will never falter!',26124),
(91034,'enUS','','Stay behind me.',26124),
(91035,'enUS','I will crush the life from your bones!','I will crush the life from your bones!',26124),
(91036,'enUS','','Justice is done.',26124),
(91038,'enUS','I do. I saw that my mate remained behind to care for our little ones.','',26124),
(91039,'enUS','','We must fight on.',26124),
(91040,'enUS','','This is not over.',26124),
(91041,'enUS','I will be your end!','I will be your end!',26124),
(91042,'enUS','','The light will never forsake us.',26124),
(91043,'enUS','I... never looked at it that way.','',26124),
(91045,'enUS','','It is good to see you, commander.',26124),
(91046,'enUS','','I have been aiding the wounded since the last attack.',26124),
(91048,'enUS','','We must protect the draenei heartland.',26124),
(91049,'enUS','','You have created a tranquil bastion amidst the chaos of war. Thank you, commander.',26124),
(91052,'enUS','','I give myself to the light!',26124),
(91053,'enUS','Primordial Horrors Killed: $1i (+$2i)','',26124),
(91054,'enUS','We may have lost the heart but we won this battle. The garrison is secure... for now.','',26124),
(91055,'enUS','Shadowmoon Voidaxes Killed: $1i (+$2i VP)','',26124),
(91056,'enUS','Shadowmoon Ritualist Killed: $1i (+$2i VP)','',26124),
(91057,'enUS','My assistant is dead? Oh man... that\'s not good. This is a little over my pay grade. You probably want to speak with Zog.','',26124),
(91058,'enUS','Shadowmoon Prophets Killed: $1i (+$2i VP)','',26124),
(91059,'enUS','Shadowmoon Voidbinder Killed: $1i (+$2i VP)','',26124),
(91060,'enUS','Void Essences Killed: $1i (+$2i VP)','',26124),
(91061,'enUS','Shadowmoon Darkcasters Killed: $1i (+$2i VP)','',26124),
(91062,'enUS','Where can I replace a lost ring or acquire another?','Where can I replace a lost ring or acquire another?',26124),
(91063,'enUS','','Despite the chaos, the sunset here is very soothing.',26124),
(91064,'enUS','Impossible! Your ring is a handcrafted masterpiece of exquisite arcane craftsmanship, invaluable and irreplaceable!$b$bOn the other hand, Zooti Fizzlefury outside of my tower here is an expert in procuring the impossible. Maybe you could cross his palms with some gold.$b$bI won\'t make any guarantees.','',26124),
(91065,'enUS','Hello $ghandsome:miss;.  I can assist you in recovering lost companions.','Hello $ghandsome:miss;.  I can assist you in recovering lost companions.',26124),
(91066,'enUS','The void beckons me...','The void beckons me...',26124),
(91067,'enUS','I am unstoppable!','',26124),
(91068,'enUS','Return to the earth mongrel!','',26124),
(91069,'enUS','Return to the light!','',26124),
(91070,'enUS','You have been judged, unworthy.','',26124),
(91071,'enUS','For Silvermoon!','',26124),
(91072,'enUS','','I hear you are responsible for returning one of my sons to me, $p. You have my eternal gratitude.$b$bThough my heart was warmed at the sight of Ga\'nar again, his own heart has been torn by too much grief and suffering.$b$bI had seen this before in his eldest brother Fenris before we lost him forever.',26124),
(91073,'enUS','I feel like I\'m staring into eternity...','',26124),
(91074,'enUS','<Simply standing in the presence of the naaru fills you with a sense of peace. You sense something else, as well - a watchful, protective eye. Perhaps Prophet Velen lives forever within the light of the purified naaru.>','',26124),
(91075,'enUS','I was raised on stories of Frostfire Ridge, the ancestral home of the Frostwolves.$b$bI never believed I would ever see the clan as they were in their prime, with Durotan as their chief.$b$bHe is... shorter... than I imagined. The burden of leadership weighs heavy on his shoulders.','',26124),
(91076,'enUS','Turn around, $c. You\'ll find nothing but suffering in here.','Turn around, $c. You\'ll find nothing but suffering in here.',26124),
(91077,'enUS','The darkness calls... I cannot resist.','The darkness calls... I cannot resist.',26124),
(91078,'enUS','Oshu\'gun awaits...','Oshu\'gun awaits...',26124),
(91079,'enUS','The call of the void... I can hear it beckoning...','The call of the void... I can hear it beckoning...',26124),
(91080,'enUS','The void... calls...','The void... calls...',26124),
(91082,'enUS','Can\'t stop, won\'t stop!','',26124),
(91083,'enUS','Shattered!','',26124),
(91084,'enUS','If you\'ve got the cash, I\'ve got the ride!','',26124),
(91085,'enUS','I can fly you anywhere... for a price of course!','',26124),
(91086,'enUS','Galactic Fist Strike!','',26124),
(91087,'enUS','You lack discipline!','',26124),
(91088,'enUS','Aha ha ha ha!','',26124),
(91089,'enUS','|cFFFF0000|Hspell:177150|h[Booming Shout]|h|r killed you.  Get out of Line of Sight or the further you are from Kor\'lok, the lower the damage from Booming Shout.','',26124),
(91090,'enUS','','For Gnomergan!',26124),
(91091,'enUS','Just don\'t touch my pigtails please...','Just don\'t touch my pigtails please...',26124),
(91092,'enUS','','Fear the power of the gnomes!',26124),
(91093,'enUS','','Gnome power!',26124),
(91094,'enUS','','Small and sneaky!',26124),
(91095,'enUS','','These Steamwheedle goblins are reprehensible. They\'ll do anything to make a quick coin!',26124),
(91096,'enUS','What did they do this time?','',26124),
(91097,'enUS','Fresh meat!','',26124),
(91098,'enUS','No one survives.','',26124),
(91099,'enUS','Pain is the lesson!','',26124),
(91100,'enUS','This one is mine!','',26124),
(91101,'enUS','Run! It\'s more fun that way...','',26124),
(91102,'enUS','','They\'ve started selling souvenirs!',26124),
(91103,'enUS','Your life is mine!','',26124),
(91104,'enUS','I\'ll cut you to pieces!','',26124),
(91105,'enUS','|TInterface\\Icons\\warrior_disruptingshout.blp:20|t %s begins to cast |cFFFF0000|Hspell:177155|h[Disrupting Shout]|h|r!','',26124),
(91106,'enUS','Show me your blood!','',26124),
(91107,'enUS','We\'re barely recovering from our assault on the dark portal, and they\'re setting up a tourism racket? Surely you must be joking.','',26124),
(91108,'enUS','I die free!','',26124),
(91109,'enUS','I fear no death!','',26124),
(91110,'enUS','I regret nothing!','',26124),
(91111,'enUS','Freedom... was a lie.','',26124),
(91112,'enUS','','I wish it were a jest. They\'ve been stringing together artifact fragments and selling them as jewelry. The nerve of them to treat a priceless such a way!',26124),
(91113,'enUS','Never... surrender...','',26124),
(91114,'enUS','','Has Belloc come any closer to finding the location of this mysterious artifact?',26124),
(91115,'enUS','|TInterface\\Icons\\ability_warrior_savageblow.blp:20|t %s begins to cast |cFFFF0000|Hspell:177147|h[Mortal Cleave]|h|r!','',26124),
(91116,'enUS','Iron and blood!','',26124),
(91117,'enUS','You cannot stand against iron!','',26124),
(91118,'enUS','Iron hearts and iron will!','',26124),
(91119,'enUS','Frostfire is ours!','',26124),
(91120,'enUS','He\'s had some leads, but nothing terribly solid yet.','',26124),
(91121,'enUS','','We must make haste if we wish to find it before Dr. Jones gets his hands on it.',26124),
(91122,'enUS','Agreed, there is no telling what the Alliance might do with such a powerful weapon. We must petition for more aid before our cause becomes lost.','',26124),
(91123,'enUS','Death to the low races!','',26124),
(91124,'enUS','The skies are ours!','',26124),
(91125,'enUS','Die, vermin!','',26124),
(91126,'enUS','For Rukhmar\'s glory!','',26124),
(91127,'enUS','For Skyreach!','',26124),
(91128,'enUS','So what do you supposed the nature of this fabled artifact is?','',26124),
(91129,'enUS','Kneel before your superior!','',26124),
(91130,'enUS','You will not escape me!','',26124),
(91131,'enUS','','If it is as powerful as Dr. Jones theorizes, it may very well be of titan origin.',26124),
(91132,'enUS','Ra-kawww!','',26124),
(91133,'enUS','That seems a little far-fetched. I haven\'t seen any evidence to link the titans to this world.','',26124),
(91134,'enUS','How... ?','',26124),
(91135,'enUS','Not by... you...','',26124),
(91136,'enUS','','That may be so, but wouldn\'t it be grand to discover that the titans had reach even here? Just think of the ramifications!',26124),
(91137,'enUS','','Another trophy for my wall.',26124),
(91138,'enUS','That was some rough business at the Dark Portal. How are you holding up?','',26124),
(91139,'enUS','','I\'m a little worse for the wear, but it\'s not my first scrape. I\'m just excited that our new outpost has such fascinating history to discover!',26124),
(91140,'enUS','Aye, that it does. That is, when said history isn\'t chasing after you with a broadaxe!','',26124),
(91141,'enUS','My flight... has ended...','',26124),
(91142,'enUS','I die for Skyreach.','',26124),
(91143,'enUS','','My pet hungers.',26124),
(91144,'enUS','','Shots fired!',26124),
(91145,'enUS','Lord Mes hungers.','',26124),
(91146,'enUS','Utterly pathetic.','',26124),
(91147,'enUS','Kolrigg! Are you alright?','',26124),
(91148,'enUS','Death cannot be stopped.','',26124),
(91149,'enUS','Lunzul! Stand up, soldier!','',26124),
(91150,'enUS','You show no skill.','',26124),
(91151,'enUS','Your will melts before my eyes.','',26124),
(91152,'enUS','Thieves!','Thieves!',26124),
(91153,'enUS','You dare defy the Adherents?','You dare defy the Adherents?',26124),
(91154,'enUS','Behold Rukhmar\'s fury!','Behold Rukhmar\'s fury!',26124),
(91155,'enUS','Filthy lowborn!','Filthy lowborn!',26124),
(91156,'enUS','Rukhmar... have mercy...','Rukhmar... have mercy...',26124),
(91157,'enUS','Rukhmar... I have failed...','Rukhmar... I have failed...',26124),
(91158,'enUS','The Adherents never forget...','The Adherents never forget...',26124),
(91159,'enUS','Exterminate them all!','Exterminate them all!',26124),
(91160,'enUS','Purge these interlopers from our midst!','Purge these interlopers from our midst!',26124),
(91161,'enUS','You will die like the outcasts!','You will die like the outcasts!',26124),
(91162,'enUS','No mercy for the lowborn.','No mercy for the lowborn.',26124),
(91163,'enUS','This is not your battle, stranger.','This is not your battle, stranger.',26124),
(91164,'enUS','You are a blight on this world.','You are a blight on this world.',26124),
(91165,'enUS','Pitiful ground dweller!','Pitiful ground dweller!',26124),
(91166,'enUS','You will burn with the outcasts!','You will burn with the outcasts!',26124),
(91167,'enUS','You will all burn...','You will all burn...',26124),
(91168,'enUS','Do not trust the outcasts...','Do not trust the outcasts...',26124),
(91169,'enUS','Their curse will rot you...','Their curse will rot you...',26124),
(91170,'enUS','This was not... Rukhmar\'s will...','This was not... Rukhmar\'s will...',26124),
(91171,'enUS','Trespassers!','Trespassers!',26124),
(91172,'enUS','This ogre land! You not ogre!','This ogre land! You not ogre!',26124),
(91173,'enUS','Bow to Morkurk!','Bow to Morkurk!',26124),
(91174,'enUS','Ha! So puny!','Ha! So puny!',26124),
(91175,'enUS','I add your head to my collection!','I add your head to my collection!',26124),
(91176,'enUS','Enjoy the void','',26124),
(91177,'enUS','Your head nice. Make good trophy!','Your head nice. Make good trophy!',26124),
(91178,'enUS','What hole you crawl out of?','What hole you crawl out of?',26124),
(91179,'enUS','You strong... for something so small...','You strong... for something so small...',26124),
(91180,'enUS','How you do that?','How you do that?',26124),
(91181,'enUS','Morkurk break you soon!','Morkurk break you soon!',26124),
(91182,'enUS','Ah... a fresh soul!','Ah... a fresh soul!',26124),
(91183,'enUS','Another soul for Teron\'gor!','Another soul for Teron\'gor!',26124),
(91184,'enUS','Behold Gul\'dan\'s power!','Behold Gul\'dan\'s power!',26124),
(91185,'enUS','Teron\'gor will not be denied!','Teron\'gor will not be denied!',26124),
(91186,'enUS','Teron\'gor... my soul is yours...','Teron\'gor... my soul is yours...',26124),
(91187,'enUS','This... changes... nothing...','This... changes... nothing...',26124),
(91188,'enUS','You will join me soon.','You will join me soon.',26124),
(91189,'enUS','You have already lost...','You have already lost...',26124),
(91190,'enUS','Delicious souls...','Delicious souls...',26124),
(91191,'enUS','Mongrethod hungers!','Mongrethod hungers!',26124),
(91192,'enUS','We are the gateway to oblivion.','We are the gateway to oblivion.',26124),
(91193,'enUS','Another soul to harvest.','Another soul to harvest.',26124),
(91194,'enUS','Flay them all!','Flay them all!',26124),
(91195,'enUS','How eagerly you seek death...','How eagerly you seek death...',26124),
(91196,'enUS','Mortal blood... delicious...','Mortal blood... delicious...',26124),
(91197,'enUS','A-kreesh!','A-kreesh!',26124),
(91198,'enUS','A-rul shach kigon!','A-rul shach kigon!',26124),
(91199,'enUS','Katra zil shukil!','Katra zil shukil!',26124),
(91200,'enUS','Reesh, hokta!','Reesh, hokta!',26124),
(91201,'enUS','Shaza-kiel!','Shaza-kiel!',26124),
(91202,'enUS','I will live... again...','I will live... again...',26124),
(91203,'enUS','You will succumb... in time...','You will succumb... in time...',26124),
(91204,'enUS','Wretched mortal!','Wretched mortal!',26124),
(91205,'enUS','Anakh kyree!','Anakh kyree!',26124),
(91206,'enUS','Gor\'om haguul!','Gor\'om haguul!',26124),
(91207,'enUS','Kirel narak!','Kirel narak!',26124),
(91208,'enUS','The invasion has begun!','The invasion has begun!',26124),
(91209,'enUS','The Legion consumes all!','The Legion consumes all!',26124),
(91210,'enUS','Drown this city in blood!','Drown this city in blood!',26124),
(91211,'enUS','Auchindoun will crumble!','Auchindoun will crumble!',26124),
(91212,'enUS','This city belongs to the Legion!','This city belongs to the Legion!',26124),
(91213,'enUS','You will find only death here.','You will find only death here.',26124),
(91214,'enUS','I see... darkness eternal...','I see... darkness eternal...',26124),
(91215,'enUS','You have gained nothing.','You have gained nothing.',26124),
(91216,'enUS','Gul\'dan will flay your soul...','Gul\'dan will flay your soul...',26124),
(91217,'enUS','Begone from this place!','Begone from this place!',26124),
(91218,'enUS','You should not have come here.','You should not have come here.',26124),
(91219,'enUS','Do not meddle in our affairs!','Do not meddle in our affairs!',26124),
(91220,'enUS','Socrethar demands your soul!','Socrethar demands your soul!',26124),
(91221,'enUS','The Legion guides us!','The Legion guides us!',26124),
(91222,'enUS','The Sargerei will... prevail...','The Sargerei will... prevail...',26124),
(91223,'enUS','We did what was... necessary...','We did what was... necessary...',26124),
(91224,'enUS','This is not what was promised...','This is not what was promised...',26124),
(91225,'enUS','This world is ripe for conquest!','This world is ripe for conquest!',26124),
(91226,'enUS','This world will burn like the rest.','This world will burn like the rest.',26124),
(91227,'enUS','Burn in emerald fire!','Burn in emerald fire!',26124),
(91228,'enUS','Bleed this world dry!','Bleed this world dry!',26124),
(91229,'enUS','Submit or be consumed!','Submit or be consumed!',26124),
(91230,'enUS','The Legion is eternal.','The Legion is eternal.',26124),
(91231,'enUS','You will fall... in time...','You will fall... in time...',26124),
(91232,'enUS','You only delay the inevitable.','You only delay the inevitable.',26124),
(91233,'enUS','Intruders!','Intruders!',26124),
(91234,'enUS','Form ranks!','Form ranks!',26124),
(91235,'enUS','Repel the attackers!','Repel the attackers!',26124),
(91236,'enUS','My hatred... burns...','My hatred... burns...',26124),
(91237,'enUS','You will suffer our fate!','You will suffer our fate!',26124),
(91238,'enUS','Traitors!','Traitors!',26124),
(91239,'enUS','Stand down or die!','Stand down or die!',26124),
(91240,'enUS','Protect the garrison!','Protect the garrison!',26124),
(91241,'enUS','So... cold...','So... cold...',26124),
(91242,'enUS','Strange. I feel no pain...','Strange. I feel no pain...',26124),
(91243,'enUS','My spirit... is free...','My spirit... is free...',26124),
(91244,'enUS','I am... at peace...','I am... at peace...',26124),
(91245,'enUS','This is our slaughterhouse!','This is our slaughterhouse!',26124),
(91246,'enUS','I hope you fight better than those birds!','I hope you fight better than those birds!',26124),
(91247,'enUS','Your skin will make a fine belt.','Your skin will make a fine belt.',26124),
(91248,'enUS','Finally, a challenge!','Finally, a challenge!',26124),
(91249,'enUS','Go on, beg for mercy!','Go on, beg for mercy!',26124),
(91250,'enUS','I\'ll give you a scar to be proud of!','I\'ll give you a scar to be proud of!',26124),
(91251,'enUS','Lucky mongrel!','Lucky mongrel!',26124),
(91252,'enUS','Let me suffer!','Let me suffer!',26124),
(91253,'enUS','Kargath will be angry...','Kargath will be angry...',26124),
(91254,'enUS','Such... glorious... pain...','Such... glorious... pain...',26124),
(91255,'enUS','Break time!','Break time!',26124),
(91256,'enUS','I\'ve got an empty hook for you.','I\'ve got an empty hook for you.',26124),
(91257,'enUS','You must be feeling lucky.','You must be feeling lucky.',26124),
(91258,'enUS','Come to join the beasts?','Come to join the beasts?',26124),
(91259,'enUS','Good. Something to skin!','Good. Something to skin!',26124),
(91260,'enUS','Let me hear you scream!','Let me hear you scream!',26124),
(91261,'enUS','This... this is true pain...','This... this is true pain...',26124),
(91262,'enUS','You will not leave here alive.','You will not leave here alive.',26124),
(91263,'enUS','I have never felt... more alive...','I have never felt... more alive...',26124),
(91264,'enUS','Put me on a hook...','Put me on a hook...',26124),
(91265,'enUS','This one is mine!','This one is mine!',26124),
(91266,'enUS','Just like in the arena!','Just like in the arena!',26124),
(91267,'enUS','I\'ll bleed you good!','I\'ll bleed you good!',26124),
(91268,'enUS','You must enjoy pain.','You must enjoy pain.',26124),
(91269,'enUS','Die, you little runt!','Die, you little runt!',26124),
(91270,'enUS','','Taste the fury!',26124),
(91271,'enUS','','Small in stature, grand in talent!',26124),
(91272,'enUS','','You bore me.',26124),
(91273,'enUS','My power is unlimited!','',26124),
(91274,'enUS','Bwahahahaha!','',26124),
(91275,'enUS','B-b-b-b-bladestorm!','',26124),
(91276,'enUS','Not in my house!','',26124),
(91277,'enUS','','Don\'t bother trying to duel Zurge, he\'s such a sore loser.$B$BDon\'t tell him I said that.',26124),
(91278,'enUS','Orders are orders.','',26124),
(91279,'enUS','If only Max were here.','',26124),
(91280,'enUS','I told Mare Wildrunner I\'d go explore any part of Ashran other than that Altar area. Ogres I can deal with, but ghost ones? Sorry but it gives me the willies.','',26124),
(91281,'enUS','I don\'t know how you can stand talking to that animal Zurge. He\'s so uncivil, even for an Orc.','',26124),
(91282,'enUS','You\'re dead weight!','',26124),
(91283,'enUS','As for you, well you\'re easy.','',26124),
(91284,'enUS','I was carrying a sack full of the artifact fragments back to Warspear when some Alliance scum took them from me. Watch your back out there, $n.','',26124),
(91285,'enUS','You slow me down, I\'m gonna drop you.','',26124),
(91286,'enUS','Me lightning!','',26124),
(91287,'enUS','You no lightning! You thunder! A force of nature and energy.','',26124),
(91288,'enUS','Oh! Yes. Me thunder, naturally.','',26124),
(91289,'enUS','Yes, it comes naturally to you.','',26124),
(91290,'enUS','But you lightning, we come together... sparks fly!','',26124),
(91291,'enUS','KIIILLLLLLLL!!!!','',26124),
(91292,'enUS','DIIIIIEEEEE!','',26124),
(91293,'enUS','DEAAATTTH!!!','',26124),
(91294,'enUS','Test, failed!','',26124),
(91295,'enUS','Your skills are not up to par.','',26124),
(91296,'enUS','I consider your effort, incomplete.','',26124),
(91297,'enUS','You are nothing to me.','',26124),
(91298,'enUS','You have failed.','',26124),
(91299,'enUS','Drown in shadow.','',26124),
(91300,'enUS','Greetings, commander. Some willing recruits may still wish to join our garrison. I will gather the contracts for you, so that you may peruse them at your leisure.','Greetings, commander. Some willing recruits may still wish to join our garrison. I will gather the contracts for you, so that you may peruse them at your leisure.',26124),
(91301,'enUS','I don\'t have time to chat. Grand Marshal Tremblade is in desperate need of tanks to help in the battle against the Horde.$B$BWhere did I put that Arclight Spanner...','',26124),
(91302,'enUS','','If you see any Horde out there, use some of Bixxie Rocketsocket\'s relief flares. Alliance in the area are sure to come assist you.',26124),
(91303,'enUS','We have a number of mounts that still need to be trained. They aren\'t as hardy as your mounts, though, and will tire out after a few battles.','',26124),
(91304,'enUS','Do you have any mounts left to train?','Do you have any mounts left to train?',26124),
(91305,'enUS','I\'d like the talbuk-in-training.','I\'d like the talbuk-in-training.',26124),
(91306,'enUS','I\'d like the clefthoof-in-training.','I\'d like the clefthoof-in-training.',26124),
(91307,'enUS','I\'d like the boar-in-training.','I\'d like the boar-in-training.',26124),
(91308,'enUS','I\'d like the elekk-in-training.','I\'d like the elekk-in-training.',26124),
(91309,'enUS','I\'d like the wolf-in-training.','I\'d like the wolf-in-training.',26124),
(91310,'enUS','I\'d like the riverbeast-in-training.','I\'d like the riverbeast-in-training.',26124),
(91311,'enUS','','Harrison Jones is convinced the Artifact may lie within the mines. If that\'s true, the next stage of this battle will be fought underground.$B$BWhat new dangers await us in there? That\'s what I need to find out.',26124),
(91312,'enUS','','While the battle against the Horde indeed lies within what we\'re calling the Road of Glory, we must also focus our efforts at trying to find the Artifact. Who knows where it may be.$B$BLeave no stone unturned. We must find the Artifact before the Horde.',26124),
(91313,'enUS','How are we supposed to win this battle against the Horde without siege engines?','',26124),
(91314,'enUS','If only we had an airship. We could take out Warspear from the skies!','',26124),
(91315,'enUS','We must focus all of our efforts into the mines. I agree with Dr. Jones, the Artifact has to be there. It has to be!','',26124),
(91316,'enUS','It is as we feared, we must venture into the mines. Who knows what ancient dangers are within there...','',26124),
(91317,'enUS','Truce? With the Alliance? Never.','',26124),
(91318,'enUS','Rogue spies have informed us that the Alliance are building machinery used to drill through rocks. Do you think its for the mines?','',26124),
(91319,'enUS','Have you seen how many Death Knights are within our ranks? Why is it that we still can\'t penetrate Stormshield? Are they not using Necrotic Plague?','',26124),
(91320,'enUS','If only we were able to bring a Zeppelin through the portal. We could take out Stormshield from the skies!','',26124),
(91321,'enUS','Your suffering will be legendary.','',26124),
(91322,'enUS','Arise, my minions! Rend their flesh.','',26124),
(91323,'enUS','VERMIN! I WILL TURN YOUR WORLD TO ASH!','',26124),
(91324,'enUS','Orgrim\'s warpath stops here. I will see to it that my old friends meets the fate he has earned.','',26124),
(91325,'enUS','Shattrath will not fall again. Let us go put these Iron Horde dogs in the ground.','',26124),
(91326,'enUS','','Everything Maraad did... he did to protect our people.',26124),
(91327,'enUS','','He paid the ultimate price for our freedom. We can never forget his sacrifice.',26124),
(91328,'enUS','','Thank you for everything you did, $n. Without you... none of us would have survived.',26124),
(91329,'enUS','Orgrim did what he thought was right. He did not know the path he was following.','',26124),
(91330,'enUS','I will never forget you... old friend.','',26124),
(91331,'enUS','I won\'t forget your help, $n. Without your aid, we all would have fallen to Blackhand.','',26124),
(91332,'enUS','Thank you! We could never have defeated the golem alone.','Thank you! We could never have defeated the golem alone.',26124),
(91333,'enUS','What can I do fer ya?','',26124),
(91334,'enUS','You not worthy of ring!','You not worthy of ring!',26124),
(91335,'enUS','I crush you!','I crush you!',26124),
(91336,'enUS','Ha! You no gladiator!','Ha! You no gladiator!',26124),
(91337,'enUS','You came to wrong place, runt!','You came to wrong place, runt!',26124),
(91338,'enUS','Me smash you!','Me smash you!',26124),
(91339,'enUS','You die in ring...','You die in ring...',26124),
(91340,'enUS','I strong... you stronger...','I strong... you stronger...',26124),
(91341,'enUS','Me... smash... you...','Me... smash... you...',26124),
(91342,'enUS','For Auchindoun!','For Auchindoun!',26124),
(91343,'enUS','Light grant us strength!','Light grant us strength!',26124),
(91344,'enUS','Spirits watch over us!','Spirits watch over us!',26124),
(91345,'enUS','We will stand against the darkness.','We will stand against the darkness.',26124),
(91346,'enUS','Forward march. For Auchindoun!','Forward march. For Auchindoun!',26124),
(91347,'enUS','The Light... fades...','The Light... fades...',26124),
(91348,'enUS','Auchindoun welcome me...','Auchindoun welcome me...',26124),
(91349,'enUS','The darkness comes for us all...','The darkness comes for us all...',26124),
(91350,'enUS','Want to see a magic trick?','',26124),
(91352,'enUS','This ought to be entertaining.','',26124),
(91353,'enUS','I hope you\'re wearing fire resistant armor.','',26124),
(91354,'enUS','You might feel a slight burning sensation.','',26124),
(91355,'enUS','I did try to warn you.','',26124),
(91356,'enUS','Is it warm out here, or is it just me?','',26124),
(91357,'enUS','Now, now, don\'t get all burned out on me.','',26124),
(91358,'enUS','It was inevitable, really.','',26124),
(91359,'enUS','Pleasure to see you, commander.','',26124),
(91360,'enUS','Any spells you need cast, commander? Portals you need opened? Diabolical schemes you need carried out?','',26124),
(91361,'enUS','Lovely time for a stroll around the garrison, commander.','',26124),
(91362,'enUS','Honored as always, commander.','',26124),
(91363,'enUS','Not... cool...','',26124),
(91364,'enUS','I\'ve been snuffed out...','',26124),
(91365,'enUS','','I won\'t go easy on you!',26124),
(91366,'enUS','','You want to play rough, huh?',26124),
(91367,'enUS','','Freeze!',26124),
(91368,'enUS','','I\'ve spotted one. Over here!',26124),
(91369,'enUS','','You got what you deserved.',26124),
(91370,'enUS','','You aren\'t so tough.',26124),
(91371,'enUS','','Maybe you\'ll think twice next time! Wait....',26124),
(91372,'enUS','','I did it! I got one!',26124),
(91373,'enUS','','Hey, commander! Got any missions I could go on? I\'m ready!',26124),
(91374,'enUS','','Nice to see you!',26124),
(91375,'enUS','','Anything I can do for you, commander?',26124),
(91376,'enUS','','Commander! It\'s an honor.',26124),
(91377,'enUS','','Is it warm in here? Or is it just me...',26124),
(91378,'enUS','','I... tried my best...',26124),
(91379,'enUS','','I\'m sorry commander...',26124),
(91380,'enUS','(Beast Mastery) Show Gara the Shadowberries.','(Beast Mastery) Show Gara the Shadowberries.',26124),
(91381,'enUS','<Gara sniffs the berries, then looks at you expectedly.>','',26124),
(91382,'enUS','My soul... feels at peace... thank you.','My soul... feels at peace... thank you.',26124),
(91383,'enUS','(Beast Mastery) I am not with the Shadowmoon, and I want to help this wolf!','(Beast Mastery) I am not with the Shadowmoon, and I want to help this wolf!',26124),
(91384,'enUS','Gara was my wolf, back before we forsook shamanism for these... dark magics. She wouldn\'t even look at me, not after I was tainted by the void.','Gara was my wolf, back before we forsook shamanism for these... dark magics. She wouldn\'t even look at me, not after I was tainted by the void.',26124),
(91385,'enUS','How dare you set her soul at rest. Om\'ra\'s soul belongs to the VOID!','',26124),
(91386,'enUS','I shall take this one as compensation!','',26124),
(91387,'enUS','Your soul will fill the void!','',26124),
(91388,'enUS','You can never escape from the void! Your souls will be devoured!','',26124),
(91389,'enUS','She is being swallowed by the void! You must help her! There is only one way, tame her, now! Maybe you can find a way to reverse the process, and put her soul at rest, as you have done mine!','She is being swallowed by the void! You must help her! There is only one way, tame her, now! Maybe you can find a way to reverse the process, and put her soul at rest, as you have done mine!',26124),
(91390,'enUS','You\'ve done it... thank you. Goodbye, Gara, my soul is at peace now. I hope... that you find this peace some day, too. I am so sorry, my dearest Gara.','You\'ve done it... thank you. Goodbye, Gara, my soul is at peace now. I hope... that you find this peace some day, too. I am so sorry, my dearest Gara.',26124),
(91391,'enUS','You instinctively use Deterrance to avoid the attack!','You instinctively use Deterrance to avoid the attack!',26124),
(91392,'enUS','Your skill at tracking allows you to remain in this realm!','Your skill at tracking allows you to remain in this realm!',26124),
(91393,'enUS','You are pulled into the Void Realm!','You are pulled into the Void Realm!',26124),
(91394,'enUS','I will consume all!','',26124),
(91395,'enUS','The fight against the Warsong clan is honorable, but I don\'t think Hemet has taken very well to the change of priorities here in Nagrand.','',26124),
(91396,'enUS','Fool! You dare challenge the might of the Spiteleaves? Die!','',26124),
(91397,'enUS','Winter... has... come for me...','',26124),
(91398,'enUS','The master... will burn your soul!','',26124),
(91399,'enUS','The hour is near... soon you will die...','',26124),
(91400,'enUS','Our master will devour your soul...','',26124),
(91401,'enUS','You cannot stop the destruction...','',26124),
(91402,'enUS','Noooo... it is you who should die!','',26124),
(91403,'enUS','No! No... nooo... the darkness...','',26124),
(91404,'enUS','The void is coming... it will destroy you all!','',26124),
(91405,'enUS','You fool... we\'ve already... won...','',26124),
(91406,'enUS','Hey... what were you expecting? Frostmourne or something?','',26124),
(91407,'enUS','Cut down to size.','',26124),
(91408,'enUS','And not a hair out of place.','',26124),
(91409,'enUS','That\'s why I\'m here.','',26124),
(91410,'enUS','','You are not welcome here.',26124),
(91411,'enUS','','I am unimpressed.',26124),
(91412,'enUS','','You had no chance.',26124),
(91413,'enUS','I\'d like to go back to the nest.','I\'d like to go back to the nest.',26124),
(91414,'enUS','Grrrawr I thirst for blood!','',26124),
(91415,'enUS','Well met.','',26124),
(91416,'enUS','Whoops! My bad.','',26124),
(91417,'enUS','Globalized!','',26124),
(91418,'enUS','Making plays!','',26124),
(91419,'enUS','I would like to place a work order for leather.','I would like to place a work order for leather.',26124),
(91420,'enUS','I would like to place a large work order for leather.','I would like to place a large work order for leather.',26124),
(91421,'enUS','I would like to place a work order for meat.','I would like to place a work order for meat.',26124),
(91422,'enUS','I would like to place a large work order for meat.','I would like to place a large work order for meat.',26124),
(91423,'enUS','I would like to place a work order for fur.','I would like to place a work order for fur.',26124),
(91424,'enUS','I would like to place a large work order for fur.','I would like to place a large work order for fur.',26124),
(91425,'enUS','<The good doctor reeks like the floor of tavern and wears a face like five miles of bad road. His color is washed out and he\'s making a deliberate effort not to be sick all over your feet.>$b$bHey Com-om-mander! <Urp> S\'was one HELLUVA bender at Pinchwhistle last night. But I got home all-right for ready! Duty! Yessir. <Belch> Man you really did a number on this garrison since yessserday. With um. Spikes. Furs. And... snow? Did you do that?  I\'mma sit down.','',26124),
(91426,'enUS','Jeron Emberfall has been slain by the Alliance!','',26124),
(91427,'enUS','Rylai Crestfall has been slain by the Horde!','',26124),
(91428,'enUS','Do you need an analysis? I can have it ready for you by the end of the week.','',26124),
(91429,'enUS','Once we\'re done here, whaddaya say we go to shore and grab a drink?','',26124),
(91430,'enUS','If you find yourself within the Dark Woods, keep an eye out for the blooming Song Flower. They have powerful magical properties.$B$BYou may have to fight off a few of the Arakkoa for them though.','',26124),
(91431,'enUS','Tell me about the mounts-in-training.','Tell me about the mounts-in-training.',26124),
(91432,'enUS','The Night Elves are attempting to resurrect an Ancient to be used against us using the power of the Artifacts found here in Ashran.$B$BIf you see any alliance out there, take any fragments they carry by any force necessary.','',26124),
(91433,'enUS','We\'ve been following your lead, and capturing mounts to train up for the rest of the garrison. You\'re welcome to take one out for the day, just ask and I\'ll hand you the whistle.$B$BKeep in mind that they\'re not as well-trained as your own mount, and will tire out after only a few battles.','',26124),
(91434,'enUS','We have been following your lead, and capturing mounts to train for use in the garrison. Of course, you are welcome to take one out for the day, simply tell me which whistle you would prefer.$B$BBe aware that they are not as well-trained as your own mount, and will tire out after only a few battles.','',26124),
(91435,'enUS','','The flames coming out of the braziers near the Ring of Conquest may look ordinary at first glance. However, I believe they have been enchanted by ancient Highmaul magic.$B$BI was strangely drawn to them. Touching one, I was suddenly filled with magical energy.',26124),
(91436,'enUS','','Protect our Priests in the Road of Glory if you see them under attack.$B$BI\'ve trained them myself, their healing power is unmatched this side of the Dark Portal.',26124),
(91437,'enUS','I am SUPER excited to be here today!','',26124),
(91438,'enUS','','Who goes there? Keep your hands and weapons where I can see them.',26124),
(91439,'enUS','','Prove to me that you are not an enemy.',26124),
(91442,'enUS','|TInterface\\Icons\\spell_sandexplosion.blp:20|tYou have a |cFFFF0000|Hspell:155187|h[Bomb]|h|r on you!','|TInterface\\Icons\\spell_sandexplosion.blp:20|tYou have a |cFFFF0000|Hspell:155187|h[Bomb]|h|r on you!',26124),
(91443,'enUS','|TInterface\\Icons\\Spell_Fire_LavaSpawn.blp:20|tA Firecaller has affected you with |cFFFF0000|Hspell:176121|h[Volatile Fire]|h|r!','|TInterface\\Icons\\Spell_Fire_LavaSpawn.blp:20|tA Firecaller has affected you with |cFFFF0000|Hspell:176121|h[Volatile Fire]|h|r!',26124),
(91444,'enUS','|TInterface\\Icons\\ability_rhyolith_magmaflow_whole.blp:20|tForeman Feldspar is going to create a |cFFFF0000|Hspell:156934|h[Rupture]|h|r under your feet!','|TInterface\\Icons\\ability_rhyolith_magmaflow_whole.blp:20|tForeman Feldspar is going to create a |cFFFF0000|Hspell:156934|h[Rupture]|h|r under your feet!',26124),
(91445,'enUS','|TInterface\\Icons\\ability_foundryraid_melt.blp:20|tThe Heart of the Mountain is going to |cFFFF0000|Hspell:155225|h[Melt]|h|r the ground under your feet!','|TInterface\\Icons\\ability_foundryraid_melt.blp:20|tThe Heart of the Mountain is going to |cFFFF0000|Hspell:155225|h[Melt]|h|r the ground under your feet!',26124),
(91446,'enUS','|TInterface\\Icons\\ability_garrosh_hellscreams_warsong.blp:20|t%s begins to cast |cFFF00000|Hspell:160838|h[Disrupting Roar]|h|r!','',26124),
(91447,'enUS','Forgive me, father.','',26124),
(91448,'enUS','You\'ve got quite the mouth on you, Ooka. Maybe I should stuff it full of your blookin mank chow.','You\'ve got quite the mouth on you, Ooka. Maybe I should stuff it full of your blookin mank chow.',26124),
(91449,'enUS','Ah, visitors. It\'s been a long time since Mardum, Allari.','',26124),
(91450,'enUS','Placeholder Text','Placeholder Text',26124),
(91451,'enUS','','|TInterface\\Icons\\ability_warrior_dragonroar.blp:20|t %s begins to cast |cFFFF0000|Hspell:177477|h[Dragon Roar]|h|r!',26124),
(91452,'enUS','','Whatcha need?',26124),
(91453,'enUS','What do you need directions to?','What do you need directions to?',26124),
(91454,'enUS','If you\'re looking for information on pet battling, seek out Misty Webtangle.\n\nI believe she\'s staying in the cellar of the inn. Let\'s hope she can keep her pets from wandering too far from there.','If you\'re looking for information on pet battling, seek out Misty Webtangle.\n\nI believe she\'s staying in the cellar of the inn. Let\'s hope she can keep her pets from wandering too far from there.',26124),
(91455,'enUS','A pair of ethereals have set up shop in the lower floor of Andromath\'s Rise. \n\nSeek them out there if you wish to use their services for Transmogrification or Void Storage.','A pair of ethereals have set up shop in the lower floor of Andromath\'s Rise. \n\nSeek them out there if you wish to use their services for Transmogrification or Void Storage.',26124),
(91456,'enUS','Whether you\'re looking to make a little coin or spend it, the Tyron family and their associates should be able to help you.\n\nThey\'ve set up shop just down the road from the Town Hall, next to the arakkoa refugees.','Whether you\'re looking to make a little coin or spend it, the Tyron family and their associates should be able to help you.\n\nThey\'ve set up shop just down the road from the Town Hall, next to the arakkoa refugees.',26124),
(91457,'enUS','The dwarves of the Explorer\'s League have been allowing adventurers to use the extra space in Bronzebeard\'s Vault to store their excess goods.\n\nIt\'s the big metal building with the cannon on top in the center of town. You can\'t miss it.','The dwarves of the Explorer\'s League have been allowing adventurers to use the extra space in Bronzebeard\'s Vault to store their excess goods.\n\nIt\'s the big metal building with the cannon on top in the center of town. You can\'t miss it.',26124),
(91458,'enUS','If you need to travel by gryphon, you\'ll want to speak to our Gryphon Master, Ernst ten Bosch. \n\nYou can find him at the top of the hill past the mess hall.','If you need to travel by gryphon, you\'ll want to speak to our Gryphon Master, Ernst ten Bosch. \n\nYou can find him at the top of the hill past the mess hall.',26124),
(91459,'enUS','If you\'re looking to take a load off, then you\'ll want to head down to the Hero\'s Rest Inn. Jaesia should be able to set you up with a room and a mug of ale.\n\nJust take the road past the stone walls and follow it to the west. That\'ll take you right to it.','If you\'re looking to take a load off, then you\'ll want to head down to the Hero\'s Rest Inn. Jaesia should be able to set you up with a room and a mug of ale.\n\nJust take the road past the stone walls and follow it to the west. That\'ll take you right to it.',26124),
(91460,'enUS','We\'ve actually got a few mailboxes about. Were you looking for one in particular?','We\'ve actually got a few mailboxes about. Were you looking for one in particular?',26124),
(91461,'enUS','You can find that mailbox right outside of Bronzebeard\'s Vault in the center of town.\n\nIt\'s the big metal building with the cannon on top.','You can find that mailbox right outside of Bronzebeard\'s Vault in the center of town.\n\nIt\'s the big metal building with the cannon on top.',26124),
(91462,'enUS','You can find that mailbox right next to the door to the Hero\'s Rest Inn. \n\nJust take the road through the stone walls and follow it west and you\'ll run into the inn at the bottom of the hill.','You can find that mailbox right next to the door to the Hero\'s Rest Inn. \n\nJust take the road through the stone walls and follow it west and you\'ll run into the inn at the bottom of the hill.',26124),
(91463,'enUS','Town Hall','Town Hall',26124),
(91464,'enUS','You\'ll find another mailbox just outside the Town Hall. \n\nJust head to the southern part of town. The Town Hall is just past the central monument.','You\'ll find another mailbox just outside the Town Hall. \n\nJust head to the southern part of town. The Town Hall is just past the central monument.',26124),
(91465,'enUS','Our mages have set up portals to a few different locations in various parts of the settlement. \n\nWhere would you like to go?','Our mages have set up portals to a few different locations in various parts of the settlement. \n\nWhere would you like to go?',26124),
(91466,'enUS','Darnassus','Darnassus',26124),
(91467,'enUS','The portal to Darnassus can be found near the night elf moonwell on the eastern side of Stormshield. \n\nJust follow the road past the auction house and that will lead you to it.','The portal to Darnassus can be found near the night elf moonwell on the eastern side of Stormshield. \n\nJust follow the road past the auction house and that will lead you to it.',26124),
(91468,'enUS','Ironforge','Ironforge',26124),
(91469,'enUS','Not surprisingly, the portal to Ironforge has been set up outside of Bronzebeard\'s Vault. You can find it on the south side of the building.\n\nIt\'s the big metal one with the cannon on top in the center of town.','Not surprisingly, the portal to Ironforge has been set up outside of Bronzebeard\'s Vault. You can find it on the south side of the building.\n\nIt\'s the big metal one with the cannon on top in the center of town.',26124),
(91470,'enUS','Stormwind','Stormwind',26124),
(91471,'enUS','The portal to Stormwind has been set up outside Andromath\'s Rise.\n\nIf you head up the road past Bronzebeard\'s Vault you\'ll run right into the tower.','The portal to Stormwind has been set up outside Andromath\'s Rise.\n\nIf you head up the road past Bronzebeard\'s Vault you\'ll run right into the tower.',26124),
(91472,'enUS','In what particular profession were you seeking training?','In what particular profession were you seeking training?',26124),
(91473,'enUS','Looks like the Iron Horde is making its move. Soldiers! Get the townsfolk to safety!','',26124),
(91474,'enUS','The secrets of Draenor alchemy are well known by our resident alchemist, Jaiden Trask. \n\nYou can find him outside of the Hero\'s Rest Inn, in the southern part of town.','The secrets of Draenor alchemy are well known by our resident alchemist, Jaiden Trask. \n\nYou can find him outside of the Hero\'s Rest Inn, in the southern part of town.',26124),
(91475,'enUS','Our resident archaeologist, Manda Darlowe, has set up shop outside the barracks in the center of Stormshield.\n\nShe is accompanied by a strange arakkoa who may be able to assist you in your endeavors as well.','Our resident archaeologist, Manda Darlowe, has set up shop outside the barracks in the center of Stormshield.\n\nShe is accompanied by a strange arakkoa who may be able to assist you in your endeavors as well.',26124),
(91476,'enUS','Me too!','Me too!',26124),
(91477,'enUS','Aimee Goldforge is our local blacksmithing expert. \n\nYou can find her and her crew around the open-air forge outside of Bronzebeard\'s Vault in the center of Stormshield.','Aimee Goldforge is our local blacksmithing expert. \n\nYou can find her and her crew around the open-air forge outside of Bronzebeard\'s Vault in the center of Stormshield.',26124),
(91478,'enUS','If you\'re looking for the best cook in town, seek out Elton Black over at the Hero\'s Rest Inn.\n\nHe may seem a bit silly with his props and gadgets, but he knows how to make some seriously great eats.','If you\'re looking for the best cook in town, seek out Elton Black over at the Hero\'s Rest Inn.\n\nHe may seem a bit silly with his props and gadgets, but he knows how to make some seriously great eats.',26124),
(91479,'enUS','Hope you draw some lucky hands today!','',26124),
(91480,'enUS','If you seek training in enchanting, Bil Sparktonic is the most knowledgeable enchanter in Stormshield. Just be careful of anything he offers at a \"discount.\"\n\nYou can find him and his associate, Bob, hanging out behind the Auction House, crying their wares.','If you seek training in enchanting, Bil Sparktonic is the most knowledgeable enchanter in Stormshield. Just be careful of anything he offers at a \"discount.\"\n\nYou can find him and his associate, Bob, hanging out behind the Auction House, crying their wares.',26124),
(91481,'enUS','','|TInterface\\Icons\\Spell_Shadow_SoulLeech_2.blp:20|t %s begins to cast |cFFF00000|Hspell:153477|h[Soul Vessel]|h|r!',26124),
(91482,'enUS','Our foremost engineer in Stormshield is Hilda Copperfuze.\n\nYou can find her in the Engineering Works at the center of town.','Our foremost engineer in Stormshield is Hilda Copperfuze.\n\nYou can find her in the Engineering Works at the center of town.',26124),
(91483,'enUS','|TInterface\\Icons\\inv_elemental_crystal_fire.blp:20|tYou have been targeted with |cFFFF0000|Hspell:160282|h[Solar Detonation]|h|r! Move away from your allies!','|TInterface\\Icons\\inv_elemental_crystal_fire.blp:20|tYou have been targeted with |cFFFF0000|Hspell:160282|h[Solar Detonation]|h|r! Move away from your allies!',26124),
(91484,'enUS','$n crafts a Cyclone Trinket!','$n crafts a Cyclone Trinket!',26124),
(91485,'enUS','Thunderlord Windfires Killed: $1i (+$2i VP)','Thunderlord Windfires Killed: $1i (+$2i VP)',26124),
(91486,'enUS','A Flame Tank draws near!','A Flame Tank draws near!',26124),
(91487,'enUS','The battle for the burial grounds will begin in 3 minutes!','',26124),
(91488,'enUS','At long last... I can finally rest...','At long last... I can finally rest...',26124),
(91489,'enUS','The torment is over...','The torment is over...',26124),
(91490,'enUS','Thank you for this kindness...','Thank you for this kindness...',26124),
(91491,'enUS','Please... do not let us be forgotten...','Please... do not let us be forgotten...',26124),
(91492,'enUS','The saberon attack is over. Go now, and rest in peace.','The saberon attack is over. Go now, and rest in peace.',26124),
(91493,'enUS','Please! You must help us! The saberon have come and our lives are in danger!','Please! You must help us! The saberon have come and our lives are in danger!',26124),
(91494,'enUS','|TInterface\\Icons\\spell_shaman_earthquake.blp:20|t %s begins to cast |cFFFF0000|Hspell:170905|h[Ground Pound]|h|r!','',26124),
(91495,'enUS','You aren\'t in a party.','',26124),
(91496,'enUS','If you run into some trouble with alliance around here, use one of Frizzo Sparkrocket\'s flares.$B$BWe can\'t help you if we don\'t know where you\'re at.','',26124),
(91497,'enUS','<Gara\'s ears perk up, but her gaze remains on the grave.>','',26124),
(91498,'enUS','The Lord of Glass, a void god who calls himself Xan, had taken my soul captive in the void realm. Fragments of it were... torn away... for use by the Shadowmoon here in the burial grounds.','The Lord of Glass, a void god who calls himself Xan, had taken my soul captive in the void realm. Fragments of it were... torn away... for use by the Shadowmoon here in the burial grounds.',26124),
(91499,'enUS','But she wouldn\'t leave my side, Gara. Not until the proper effigy was burned, that my soul may find peace.','But she wouldn\'t leave my side, Gara. Not until the proper effigy was burned, that my soul may find peace.',26124),
(91500,'enUS','Thank you for releasing us both.','Thank you for releasing us both.',26124),
(91501,'enUS','Please fly me to Spires of Arak.','Please fly me to Spires of Arak.',26124),
(91502,'enUS','%s begins to channel |cFFFF0404|Hspell:159996|h[Infesting Spores]|h|r!','',26124),
(91503,'enUS','','Your orders are clear! Find the Tidestone, and return it to Her Glory, Queen Azshara!',26124),
(91504,'enUS','','These creatures only pretend to understand its power. The Tidestone belongs to Azshara, Her Radiance, the Light Beneath the Tides!',26124),
(91505,'enUS','','Scour the sands!',26124),
(91506,'enUS','','Pillage the ruins!',26124),
(91507,'enUS','','Slay anyone and anything that gets in your path!',26124),
(91508,'enUS','','FIND THAT TIDESTONE!',26124),
(91509,'enUS','','Your Queen Azshara wills it, and so shall it be done!',26124),
(91510,'enUS','Telys Vinemender is our resident first aid expert. \n\nYou can find her and her apprentice tending to the wounded in the barracks.','Telys Vinemender is our resident first aid expert. \n\nYou can find her and her apprentice tending to the wounded in the barracks.',26124),
(91511,'enUS','Austin Windmill is the best with a rod and reel here in Stormshield. Seek him out for your fishing needs.\n\nYou can normally find him outside his house along the shore, just behind the Town Hall and Auction House.','Austin Windmill is the best with a rod and reel here in Stormshield. Seek him out for your fishing needs.\n\nYou can normally find him outside his house along the shore, just behind the Town Hall and Auction House.',26124),
(91512,'enUS','Stormshield\'s premier herbalist, Jie Wildblossom, has travelled all the way from Pandaria to study the native flora of Draenor. \n\nYou can find her outside the Hero\'s Rest Inn, if you require instruction in Herbalism.','Stormshield\'s premier herbalist, Jie Wildblossom, has travelled all the way from Pandaria to study the native flora of Draenor. \n\nYou can find her outside the Hero\'s Rest Inn, if you require instruction in Herbalism.',26124),
(91513,'enUS','In the Mage Tower you will find Scribe Chi-Yuan. \n\nShe is the finest scribe in all of Ashran, and can train you for any of your inscription needs.','In the Mage Tower you will find Scribe Chi-Yuan. \n\nShe is the finest scribe in all of Ashran, and can train you for any of your inscription needs.',26124),
(91514,'enUS','The draenei Artificers are lending a hand with our operations in Stormshield. \n\nIf you seek training in jewelcrafting, find Artificer Nissea in the draenei encampment, just west of the center of Stormshield.','The draenei Artificers are lending a hand with our operations in Stormshield. \n\nIf you seek training in jewelcrafting, find Artificer Nissea in the draenei encampment, just west of the center of Stormshield.',26124),
(91515,'enUS','Jistun Sharpfeather is the local expert on leatherworking. \n\nYou can find his stall just outside of Bronzebeard\'s Vault, in the center of town.','Jistun Sharpfeather is the local expert on leatherworking. \n\nYou can find his stall just outside of Bronzebeard\'s Vault, in the center of town.',26124),
(91516,'enUS','If you need help with mining, I\'d speak with Jonath Chainfist. He\'s the expert in these parts. \n\nYou can find him just outside the Engineering Works, in the center of town.','If you need help with mining, I\'d speak with Jonath Chainfist. He\'s the expert in these parts. \n\nYou can find him just outside the Engineering Works, in the center of town.',26124),
(91517,'enUS','Rangari Laandon has been lending his expertise on skinning to our forces here in Stormshield. \n\nHe can be found in the leatherworking stall, right outside of Bronzebeard\'s Vault in the center of town.','Rangari Laandon has been lending his expertise on skinning to our forces here in Stormshield. \n\nHe can be found in the leatherworking stall, right outside of Bronzebeard\'s Vault in the center of town.',26124),
(91518,'enUS','Joshua Fuesting is the finest tailor in all of Draenor. There\'s no better to assist you with anything done with needle and thread. \n\nYou can find him in his stall in the trade center of town. Just looks for the sharp-dressed models, they are easy to spot.','Joshua Fuesting is the finest tailor in all of Draenor. There\'s no better to assist you with anything done with needle and thread. \n\nYou can find him in his stall in the trade center of town. Just looks for the sharp-dressed models, they are easy to spot.',26124),
(91519,'enUS','The Order of the Awakened have set up shop right outside the Auction House, in the southern part of Stormshield.  \n\nI hear they\'re offering great rewards to any adventurer who can help them in their search for Apexis relics.','The Order of the Awakened have set up shop right outside the Auction House, in the southern part of Stormshield.  \n\nI hear they\'re offering great rewards to any adventurer who can help them in their search for Apexis relics.',26124),
(91520,'enUS','Various factions throughout Draenor have gathered in the Town Hall to offer their assistance in Ashran. \n\nThey even have goods for sale to those with sufficient reputation with them.','Various factions throughout Draenor have gathered in the Town Hall to offer their assistance in Ashran. \n\nThey even have goods for sale to those with sufficient reputation with them.',26124),
(91521,'enUS','Kenneth Knowles has set up shop in the center of Stormshield, close to many of our profession trainers.\n\nIf you are in need of materials for your craft, seek him out there.','Kenneth Knowles has set up shop in the center of Stormshield, close to many of our profession trainers.\n\nIf you are in need of materials for your craft, seek him out there.',26124),
(91522,'enUS','Trader Caerel offers various goods for adventurers such as yourself. \n\nYou can find his wagon set up just outside the Town Hall, next to the central monument.','Trader Caerel offers various goods for adventurers such as yourself. \n\nYou can find his wagon set up just outside the Town Hall, next to the central monument.',26124),
(91523,'enUS','If you wish to stable your animals, seek out Orville Manfred, outside the inn in the southern part of Stormshield.\n\nDespite his ferocious appearance, I hear he takes quite good care of the animals.','If you wish to stable your animals, seek out Orville Manfred, outside the inn in the southern part of Stormshield.\n\nDespite his ferocious appearance, I hear he takes quite good care of the animals.',26124),
(91524,'enUS','We have many merchants who have set up shop here in Stormshield. Which one were you looking for?','We have many merchants who have set up shop here in Stormshield. Which one were you looking for?',26124),
(91525,'enUS','Apexis Shard Vendor','Apexis Shard Vendor',26124),
(91526,'enUS','Reputation Vendors','Reputation Vendors',26124),
(91527,'enUS','Sound the alarm! It must be a Primal invasion.','',26124),
(91532,'enUS','Rubbing','Rubbing',26124),
(91533,'enUS','Witherbark casts |TInterface\\Icons\\Spell_Nature_ElementalShields.blp:20|t |cFFFF0404|Hspell:164294|h[Unchecked Growth]|h|r on you!','Witherbark casts |TInterface\\Icons\\Spell_Nature_ElementalShields.blp:20|t |cFFFF0404|Hspell:164294|h[Unchecked Growth]|h|r on you!',26124),
(91534,'enUS','%s begins to breath |cFFFF0404|Hspell:155031|h[Engulfing Fire]|h|r!','',26124),
(91535,'enUS','What were you looking for?','What were you looking for?',26124),
(91536,'enUS','Pet battles? You want to talk to Zarg Bonecrunch. He\'s the orc with the kittens, north of the big totem. \n\nYeah, you heard right, the orc with the kittens.','Pet battles? You want to talk to Zarg Bonecrunch. He\'s the orc with the kittens, north of the big totem. \n\nYeah, you heard right, the orc with the kittens.',26124),
(91537,'enUS','A couple of those ethereals came with and set up shop in the Tower of Elements. \n\nI\'m not sure what their game is here in Ashran, but they have some useful services.','A couple of those ethereals came with and set up shop in the Tower of Elements. \n\nI\'m not sure what their game is here in Ashran, but they have some useful services.',26124),
(91538,'enUS','If you\'re lookin\' to try your hand at the markets, you might want to seek out the Auction House. \n\nYou can find it in the tauren quarter, in the northern part of Warspear.','If you\'re lookin\' to try your hand at the markets, you might want to seek out the Auction House. \n\nYou can find it in the tauren quarter, in the northern part of Warspear.',26124),
(91539,'enUS','You can keep your extra gear protected by leaving it with the bankers in Warspear Hold. Nobody would be crazy enough to try to steal anything from that place! \n\nIt\'s the big building just south of the totem, you can\'t miss it.','You can keep your extra gear protected by leaving it with the bankers in Warspear Hold. Nobody would be crazy enough to try to steal anything from that place! \n\nIt\'s the big building just south of the totem, you can\'t miss it.',26124),
(91540,'enUS','We\'ve got a couple of trained wind riders in Warspear if you need to travel quickly. \n\nSeek out Ilalu at the top of the hill behind the inn, if you have need of them.','We\'ve got a couple of trained wind riders in Warspear if you need to travel quickly. \n\nSeek out Ilalu at the top of the hill behind the inn, if you have need of them.',26124),
(91541,'enUS','If you are in need of rest, the Brokenspear Tavern is where you should be headed. \n\nYou will find it off of the road heading north from the big totem.','If you are in need of rest, the Brokenspear Tavern is where you should be headed. \n\nYou will find it off of the road heading north from the big totem.',26124),
(91542,'enUS','We\'ve got plenty of mailboxes. Which one were you lookin\' for?','We\'ve got plenty of mailboxes. Which one were you lookin\' for?',26124),
(91543,'enUS','There\'s one right outside of the Brokenspear Tavern. \n\nYou can find it right off the road heading north from the big totem.','There\'s one right outside of the Brokenspear Tavern. \n\nYou can find it right off the road heading north from the big totem.',26124),
(91544,'enUS','We got a mailbox right outside the Auction House, in the tauren quarter.\n\nIt\'s just north of the big bonfire.','We got a mailbox right outside the Auction House, in the tauren quarter.\n\nIt\'s just north of the big bonfire.',26124),
(91545,'enUS','The bankers put a mailbox right outside of Warpsear Hold that you\'re welcome to use. \n\nIt\'s the big building to the south of the totem.','The bankers put a mailbox right outside of Warpsear Hold that you\'re welcome to use. \n\nIt\'s the big building to the south of the totem.',26124),
(91546,'enUS','The goblins have set up a mailbox outside of Gallywix\'s Garage. \n\nIt\'s the biggest building in the goblin quarter, on the east side of town.','The goblins have set up a mailbox outside of Gallywix\'s Garage. \n\nIt\'s the biggest building in the goblin quarter, on the east side of town.',26124),
(91547,'enUS','The mages set up a handful of portals to different places. Which one did you want?','The mages set up a handful of portals to different places. Which one did you want?',26124),
(91548,'enUS','You can find the portal to Orgrimmar in the Tower of Elements. \n\nJust head east from the big totem.','You can find the portal to Orgrimmar in the Tower of Elements. \n\nJust head east from the big totem.',26124),
(91549,'enUS','The portal to Thunder Bluff has been set up in the tauren quarter. \n\nIt should be right next to the Auction House.','The portal to Thunder Bluff has been set up in the tauren quarter. \n\nIt should be right next to the Auction House.',26124),
(91550,'enUS','The Forsaken have set up a portal to the Undercity in their quarter. \n\nLook for it behind their alchemy hut.','The Forsaken have set up a portal to the Undercity in their quarter. \n\nLook for it behind their alchemy hut.',26124),
(91551,'enUS','What kind of profession did you need help with?','What kind of profession did you need help with?',26124),
(91552,'enUS','If you\'re lookin\' to make a new plague, there\'s no better than the Forsaken. \n\nLook for Kristoph Cossey in their quarter, inside the alchemy hut.','If you\'re lookin\' to make a new plague, there\'s no better than the Forsaken. \n\nLook for Kristoph Cossey in their quarter, inside the alchemy hut.',26124),
(91553,'enUS','The Steamwheedle Preservation Society is your best bet for archaeology around here. \n\nYou can find them in the smaller garage in the goblin quarter. Just seek out Reena Cogscrap there.','The Steamwheedle Preservation Society is your best bet for archaeology around here. \n\nYou can find them in the smaller garage in the goblin quarter. Just seek out Reena Cogscrap there.',26124),
(91554,'enUS','Mazdon Bizratchet is your best bet for blacksmithing around here. \n\nYou can find him in the goblin quarter, behind Gallywix\'s Garage.','Mazdon Bizratchet is your best bet for blacksmithing around here. \n\nYou can find him in the goblin quarter, behind Gallywix\'s Garage.',26124),
(91555,'enUS','You want to speak with me?','',26124),
(91556,'enUS','The best cook on Warspear is Guy Fireeye, no doubt about that. He makes all the grub for the Brokenspear Tavern. \n\nYou can usually find him manning the kichen below the inn itself.','The best cook on Warspear is Guy Fireeye, no doubt about that. He makes all the grub for the Brokenspear Tavern. \n\nYou can usually find him manning the kichen below the inn itself.',26124),
(91557,'enUS','The trolls are taking care of all our enchanting needs in Warspear. \n\nLook for Hane\'ke in the Enchanter\'s Study over in their quarter. He should be able to help you out.','The trolls are taking care of all our enchanting needs in Warspear. \n\nLook for Hane\'ke in the Enchanter\'s Study over in their quarter. He should be able to help you out.',26124),
(91558,'enUS','Your people treat you with contempt. Why? What did you do?','Your people treat you with contempt. Why? What did you do?',26124),
(91559,'enUS','They\'ve got a pretty good engineering setup in Gallywix\'s Garage over in the goblin quarter. Just look for the biggest building in the area.\n\nOnce you\'re there, talk to Han Leaprocket if you need training.','They\'ve got a pretty good engineering setup in Gallywix\'s Garage over in the goblin quarter. Just look for the biggest building in the area.\n\nOnce you\'re there, talk to Han Leaprocket if you need training.',26124),
(91560,'enUS','The pandaren, Wei Suremend, has been tending to our grunts. He\'s probably your best bet for first aid training. \n\nYou can find him in the barracks. Just follow the sound of training orcs.','The pandaren, Wei Suremend, has been tending to our grunts. He\'s probably your best bet for first aid training. \n\nYou can find him in the barracks. Just follow the sound of training orcs.',26124),
(91561,'enUS','Brix Rocketcast is the goblin with the most fishing know-how around here. \n\nYou can find his little island off the shore, north of the goblin quarter.','Brix Rocketcast is the goblin with the most fishing know-how around here. \n\nYou can find his little island off the shore, north of the goblin quarter.',26124),
(91562,'enUS','If you need help with herbalism, you should look in the undead quarter. \n\nAnthony Allain is over there next to the alchemist\'s hut. He should be able to show you a thing or two.','If you need help with herbalism, you should look in the undead quarter. \n\nAnthony Allain is over there next to the alchemist\'s hut. He should be able to show you a thing or two.',26124),
(91563,'enUS','The best scribe we have in Warspear is Joro\'man over in the troll quarter. \n\nFor your sake, I hope he doesn\'t write the way he talks.','The best scribe we have in Warspear is Joro\'man over in the troll quarter. \n\nFor your sake, I hope he doesn\'t write the way he talks.',26124),
(91564,'enUS','A small group of Blood Elves set up camp across the way from the tauren. \n\nYou\'ll find a jewelcrafter there by the name of Alixander Swiftsteel.','A small group of Blood Elves set up camp across the way from the tauren. \n\nYou\'ll find a jewelcrafter there by the name of Alixander Swiftsteel.',26124),
(91565,'enUS','The tauren that came over with us seem to have the best grasp on leatherworking around here. \n\nSeek out Burga Stronghide in their quarter for leatherworking training.','The tauren that came over with us seem to have the best grasp on leatherworking around here. \n\nSeek out Burga Stronghide in their quarter for leatherworking training.',26124),
(91566,'enUS','If you\'re lookin\' for a good miner, go find Murg Stonecrack. He\'s so good that they promoted him from a peon and put him in charge of the mining operations here in Warspear. \n\nLast I saw him, I think he was working the rocks east of the goblin quarter.','If you\'re lookin\' for a good miner, go find Murg Stonecrack. He\'s so good that they promoted him from a peon and put him in charge of the mining operations here in Warspear. \n\nLast I saw him, I think he was working the rocks east of the goblin quarter.',26124),
(91567,'enUS','The Huntsworns have skinned just about every kind of beast on Draenor, so if you need training, go to them. \n\nYou can find Kondal working his skins in the tauren quarter.','The Huntsworns have skinned just about every kind of beast on Draenor, so if you need training, go to them. \n\nYou can find Kondal working his skins in the tauren quarter.',26124),
(91568,'enUS','I prefer hides and furs myself, but if you prefer to work with dainty cloth, then you should seek out the blood elf, Saesha Silverblood. \n\nShe\'s set up with her kin, across from the tauren quarter.','I prefer hides and furs myself, but if you prefer to work with dainty cloth, then you should seek out the blood elf, Saesha Silverblood. \n\nShe\'s set up with her kin, across from the tauren quarter.',26124),
(91569,'enUS','The birds have set themselves up next to our training grounds in the southern part of town. \n\nThey say they\'re looking for ancient relics, and have some pretty nice gear to trade for them.','The birds have set themselves up next to our training grounds in the southern part of town. \n\nThey say they\'re looking for ancient relics, and have some pretty nice gear to trade for them.',26124),
(91570,'enUS','We\'ve got a couple different factions holed up in Warspear Hold. \n\nI\'ve heard they\'ve even got stuff for sale, though they\'re picky who they sell to.','We\'ve got a couple different factions holed up in Warspear Hold. \n\nI\'ve heard they\'ve even got stuff for sale, though they\'re picky who they sell to.',26124),
(91571,'enUS','Bren Puresun in the tauren quarter has been working to keep our tradesmen supplied. \n\nSeek him out if you need goods for crafting.','Bren Puresun in the tauren quarter has been working to keep our tradesmen supplied. \n\nSeek him out if you need goods for crafting.',26124),
(91572,'enUS','Outside the Brokenspear Tavern, you can find Jasa\'s trade hut. \n\nThere you can find whatever adventuring supplies you might need.','Outside the Brokenspear Tavern, you can find Jasa\'s trade hut. \n\nThere you can find whatever adventuring supplies you might need.',26124),
(91573,'enUS','Ujia handles the beasts for most of us around here. I\'d just be careful around her raptors. \n\nYou can find her outside the cave in the troll quarter.','Ujia handles the beasts for most of us around here. I\'d just be careful around her raptors. \n\nYou can find her outside the cave in the troll quarter.',26124),
(91574,'enUS','Lookin\' to buy somethin\'? What, exactly?','Lookin\' to buy somethin\'? What, exactly?',26124),
(91579,'enUS','Gallywix\'s Garage','Gallywix\'s Garage',26124),
(91580,'enUS','Orgrimmar','Orgrimmar',26124),
(91581,'enUS','Thunder Bluff','Thunder Bluff',26124),
(91582,'enUS','Undercity','Undercity',26124),
(91583,'enUS','You did all this? How? Why?','You did all this? How? Why?',26124),
(91584,'enUS','','Ookin Dookin blookin flookin wikket!',26124),
(91585,'enUS','','Flip blookin dook-sniffer. You better take that back!',26124),
(91587,'enUS','You want to fight in the arena? No? Work harder!','',26124),
(91588,'enUS','Test 2 | Caster: %s  | Target: $n','Test 2 | Caster: %s  | Target: $n',26124),
(91590,'enUS','Leading Kargath Bladefist into an active Fire Pillar will counter his Berserker Rush.','Leading Kargath Bladefist into an active Fire Pillar will counter his Berserker Rush.',26124),
(91591,'enUS','Slicky slapper! That\'s right, I said it. Slicky slapper.','Slicky slapper! That\'s right, I said it. Slicky slapper.',26124),
(91592,'enUS','I am taking my leave, nightwatchers... though I doubt you will miss me.','',26124),
(91593,'enUS','Hmm. How long has this road been flooded? I must have the groundskeepers attend to it.','',26124),
(91594,'enUS','Look out!','',26124),
(91595,'enUS','Gah! Watch out!','',26124),
(91596,'enUS','Thaldrys, my trusted captain.','',26124),
(91597,'enUS','You know what, Ooka? You have a dook for a head!','You know what, Ooka? You have a dook for a head!',26124),
(91598,'enUS','If the giants didn\'t want you alive for their sport, you\'d be dead.','',26124),
(91599,'enUS','Let\'s go find that Tidestone.','Let\'s go find that Tidestone.',26124),
(91600,'enUS','Why did you let THAT one free? He opposed Lord Illidan!','',26124),
(91603,'enUS','Soothsayers Killed: $1i (+$2i VP)','',26124),
(91604,'enUS','|TInterface\\Icons\\ability_mage_livingbomb.blp:20|tYou have a |cFFFF0000|Hspell:176670|h[Living Bomb]|h|r on you!','|TInterface\\Icons\\ability_mage_livingbomb.blp:20|tYou have a |cFFFF0000|Hspell:176670|h[Living Bomb]|h|r on you!',26124),
(91605,'enUS','Deathblades Killed: $1i (+$2i VP)','',26124),
(91606,'enUS','|TInterface\\Icons\\spell_shaman_improvedfirenova.blp:20|tThe Heart of the Mountain is about to release a |cFFFF0000|Hspell:155209|h[Blast]|h|r of intense heat!','|TInterface\\Icons\\spell_shaman_improvedfirenova.blp:20|tThe Heart of the Mountain is about to release a |cFFFF0000|Hspell:155209|h[Blast]|h|r of intense heat!',26124),
(91607,'enUS','While you are helping the Illidari in their fight against the demons, I will figure out what our next move is here on Azsuna.\n\nWe must track down that Pillar of Creation. I know it is here somewhere.','',26124),
(91608,'enUS','Khadgar, let\'s go.','Khadgar, let\'s go.',26124),
(91609,'enUS','Don\'t let them get by us!','',26124),
(91610,'enUS','I remember - I stowed the Tidestone within the confines of the Nar\'thalas Academy.','',26124),
(91611,'enUS','That was a very long time ago.','',26124),
(91612,'enUS','Come with me.','',26124),
(91613,'enUS','The elves in this area are much less hospitable than I am. Tread carefully.','',26124),
(91614,'enUS','Farondis! You traitor! You brought this upon us!','',26124),
(91615,'enUS','','DIE... FARONDIS....',26124),
(91616,'enUS','Here, the Nar\'thalas Academy. This is where it all happened.','',26124),
(91617,'enUS','Please, show me where the Tidestone lies.','Please, show me where the Tidestone lies.',26124),
(91620,'enUS','Fum fee fo fie!  Get back to work or it\'s time to die!','',26124),
(91621,'enUS','Whalebelly can make our job more difficult. Try not to offend him.','',26124),
(91622,'enUS','What\'s a puny $r like you doing in here?\n\nOh, we\'re going to have a good time making chum of you.','',26124),
(91623,'enUS','Boss Whalebelly, it\'s great to meet you. Just letting you know that I\'m going to be the arena champion by the end of the day.','Boss Whalebelly, it\'s great to meet you. Just letting you know that I\'m going to be the arena champion by the end of the day.',26124),
(91624,'enUS','Don\'t let the dark sky fool you. This is a good day.','',26124),
(91625,'enUS','Show the demon-tainted Shadow Council the strength of freedom!','',26124),
(91626,'enUS','','Greblin Fastfizzle\'s last known location was the Broken Precipice. You might want to catch a flight out there before it\'s too late.',26124),
(91627,'enUS','I\'m on to you and your little friend over there. You think you can muscle in on what I\'ve got going on here?\n\nNever going to happen.\n\nLet me assure you that by the end of the day, you\'ll be groveling on the arena floor with my boot to your neck, $r.','',26124),
(91628,'enUS','That\'s where you\'re wrong, chum. Dead wrong.','',26124),
(91629,'enUS','You see this blade? I\'m going to stick it so far up your...','',26124),
(91630,'enUS','Wait... what?','',26124),
(91631,'enUS','I\'ll get you, $p, if it\'s the last thing I do.','',26124),
(91632,'enUS','Whalebelly, what\'s all this?','',26124),
(91633,'enUS','Told you. No talking to enemy pit fighters!','',26124),
(91634,'enUS','Stop your blubbering. Your battle\'s coming.','',26124),
(91635,'enUS','This is it, warriors. Let\'s see how hard this Gronn falls.','',26124),
(91636,'enUS','Stubborn, I see. This is it, warriors. For the Horde!','',26124),
(91637,'enUS','Please! Mercy! Oh, the shame...','Please! Mercy! Oh, the shame...',26124),
(91638,'enUS','Win or don\'t bother crawling back, little crab.','',26124),
(91639,'enUS','I\'m going to keep digging around for more artifacts. Thanks again for all your help.','',26124),
(91640,'enUS','','You\'re a life saver, $n. I can see why everyone is following you around. You really live up to the hype.',26124),
(91641,'enUS','Not bad for a bunch of worthless pukes! Come face Krud when you ready to die!','',26124),
(91643,'enUS','Where do you want this box?','',26124),
(91644,'enUS','Spore Flowers: $1i (+$2i VP)','',26124),
(91645,'enUS','Why do I gotta move all the boxes?','',26124),
(91646,'enUS','Over there! Why do you keep asking? You always move the boxes from here to there!','',26124),
(91647,'enUS','Stop askin\' and get back to work!','',26124),
(91648,'enUS','A Spore Flower is blocking your road!','A Spore Flower is blocking your road!',26124),
(91649,'enUS','I like your bravery, little one. I\'ll enjoy gutting you in front of my entire battalion.','',26124),
(91650,'enUS','My lady, Athissa! I have... failed you...','',26124),
(91651,'enUS','','What\'s going on down there?',26124),
(91652,'enUS','','Myrmidons! Slay these intruders!',26124),
(91653,'enUS','With pleasure, my mistressss...','',26124),
(91654,'enUS','Get in there and kill. Nothing else matters.','',26124),
(91655,'enUS','Fight like your life depends on it. It does.','',26124),
(91656,'enUS','You\'re what I have left?','',26124),
(91657,'enUS','Do whatever it takes to win. Cheat, throw sand in his eyes, I don\'t care. Just win!','',26124),
(91658,'enUS','I need to go sink another ship and find some better fighters.','',26124),
(91659,'enUS','Gut him through the liver. Pull out his spleen!','',26124),
(91660,'enUS','I want to see blood all over the sand and it better not be yours!','',26124),
(91661,'enUS','I choose you.','',26124),
(91662,'enUS','I have faith in you, little one.','',26124),
(91663,'enUS','Just get in there and try your best.','',26124),
(91664,'enUS','Win or lose, you\'re still a winner in my eyes.','',26124),
(91665,'enUS','Don\'t be afraid. You can do it.','',26124),
(91666,'enUS','Don\'t listen to old Bilgerudder. He\'s just mad because no one loves him.','',26124),
(91667,'enUS','With the right attitude, you can accomplish anything.','',26124),
(91668,'enUS','Make me proud, my little friend.','',26124),
(91669,'enUS','I\'ll murder all of you if I don\'t see some wins out there!','',26124),
(91670,'enUS','Useless, little piece of flotsam!','',26124),
(91671,'enUS','Your pet cheated, Sternfathom. You\'ll pay for that.','',26124),
(91672,'enUS','I\'ve half a mind to come over there and wipe that grin off your face.','',26124),
(91673,'enUS','It\'s good to cull the weak. I haven\'t played my strongest fighters yet.','',26124),
(91674,'enUS','If you know what\'s good for you, you\'ll stay down.','',26124),
(91675,'enUS','You\'re all worthless. You hear me? Worthless!','',26124),
(91676,'enUS','Goes to show you how weak the smaller races are. We should crush them all.','',26124),
(91677,'enUS','If you know what\'s good for you, you\'ll keep winning, little crab.','',26124),
(91678,'enUS','Hah! Of course, I won. Was there any doubt?','',26124),
(91679,'enUS','Give it up, Sternfathom. Your puny weaklings don\'t have what it takes to win.','',26124),
(91680,'enUS','And you\'re going to keep fighting until you die or he runs out of pets.','',26124),
(91681,'enUS','Fight better next time, or I\'ll crush you under my boot.','',26124),
(91682,'enUS','Another win for me! You\'re nothing but a weak, has-been, Sternfathom.','',26124),
(91683,'enUS','Now that\'s how you win a fight. The rest of you better have been paying attention!','',26124),
(91684,'enUS','A-B-W. A-Always, B-Be, W-Winning. Always be winning, ALWAYS BE WINNING!','',26124),
(91685,'enUS','NOOOOOOOOooooooo....','',26124),
(91686,'enUS','Oh no, not you, my little friend.','',26124),
(91687,'enUS','Rest in peace, buddy. You\'ve earned it.','',26124),
(91688,'enUS','Bilgerudder, you villain. Your fighter cheated!','',26124),
(91689,'enUS','You fought valiantly and with great skill, little one.','',26124),
(91690,'enUS','Don\'t worry, my friends. We\'ll win next time.','',26124),
(91691,'enUS','Let\'s drink a toast to our fallen comrade.','',26124),
(91692,'enUS','Chin up, everyone. Bilgerudder\'s people have more experience, but we have heart!','',26124),
(91693,'enUS','Score one for the good guys!','',26124),
(91694,'enUS','YES! Great fighting, my little friend.','',26124),
(91695,'enUS','You\'re unstoppable, little one.','',26124),
(91696,'enUS','Now we\'re having fun!','',26124),
(91697,'enUS','Good show, but maybe next time let them live?','',26124),
(91698,'enUS','Here\'s mud in your eye, Bilgerudder.','',26124),
(91699,'enUS','Team Sternfathom wins again. Huzzah!','',26124),
(91700,'enUS','Great work, team. Let\'s make sure we stay safe out there.','',26124),
(91702,'enUS','That hits the spot!','That hits the spot!',26124),
(91703,'enUS','Not bad at all!','Not bad at all!',26124),
(91704,'enUS','Good stuff!','Good stuff!',26124),
(91705,'enUS','Ah. Worth the trip!','Ah. Worth the trip!',26124),
(91706,'enUS','Hey! Is this pandaren ale?!','Hey! Is this pandaren ale?!',26124),
(91707,'enUS','|c00FFFF00|Hspell:178019|h[Event: Collect Empowered Ore]|h|r begins at the Molten Quarry in 3 minutes.','',26124),
(91708,'enUS','|c00FFFF00|Hspell:178022|h[Event: Stadium Racing]|h|r begins at the Amphitheater of Annihilation in 3 minutes.','',26124),
(91709,'enUS','|c00FFFF00|Hspell:178020|h[Event: Risen Spirits]|h|r begins at the Ashmaul Burial Grounds in 3 minutes.','',26124),
(91710,'enUS','|c00FFFF00|Hspell:178021|h[Event: Ogre Fires]|h|r begins at Brute\'s Rise in 3 minutes.','',26124),
(91711,'enUS','Good luck on your quest for the Tidestone, $n.','',26124),
(91712,'enUS','I dare not enter that academy, but I swear I will aid you in whatever way I can.','',26124),
(91713,'enUS','','Yes, yes, what is it?$b$bIf this is about the evocation final, then the answer is no, you may not take it again.',26124),
(91714,'enUS','','You - pff - what!?$b$bYou ARE aware that the Tidestone Chamber is under quarantine, and has been so since the very day of Prince Farondis\' betrayal, correct?',26124),
(91715,'enUS','','And you are ALSO aware that infringement upon said quarantine carries punishments as severe as death or even detention, correct?',26124),
(91716,'enUS','','Nooo! Must... protect... the Tidestone...',26124),
(91717,'enUS','You have the stink of that traitor Farondis on you...','You have the stink of that traitor Farondis on you...',26124),
(91718,'enUS','Fool! You\'ve disturbed my studies!','Fool! You\'ve disturbed my studies!',26124),
(91719,'enUS','Sul\'dren il nathas!','Sul\'dren il nathas!',26124),
(91720,'enUS','Intruders in our halls! Inform the headmistress!','Intruders in our halls! Inform the headmistress!',26124),
(91721,'enUS','STAY... OUT...','',26124),
(91722,'enUS','WHERE IS FARONDIS...?','',26124),
(91723,'enUS','SLAY THE OUTSIDERS...','',26124),
(91724,'enUS','MUST PROTECT TIDESTONE...','',26124),
(91725,'enUS','','How perfectly convenient... the brainless $r led us right to the Tidestone.',26124),
(91726,'enUS','','Our Queen Beneath the Tides can reassemble the pieces.',26124),
(91727,'enUS','','As for you... you will make an acceptable slave.',26124),
(91728,'enUS','If Azuka is able to retrieve the heart, there is no telling what type of evil she will unleash on our people.','',26124),
(91729,'enUS','If you see that worthless grunt can you tell him I\'m looking for him?','',26124),
(91730,'enUS','Hey you! Where do you think you\'re going?','',26124),
(91731,'enUS','Stay out.','',26124),
(91732,'enUS','Be careful, $n. Dhow\'s a light sleeper.','',26124),
(91733,'enUS','While you\'re doing that, I\'m heading into Oceanus Cove.','',26124),
(91734,'enUS','I\'ll free and arm the pit fighters in there. That\'ll get us some help dealing with the giants.','',26124),
(91739,'enUS','Our people are being held captive, $r. Please help us free them. Head into the ruins and free our brothers from their oppressors. Leading them in battle will greatly aid our cause; but you must get them back to one of the Darkscryers safely!','',26124),
(91740,'enUS','I\'ve rescued these outcasts, guide them to safety.','I\'ve rescued these outcasts, guide them to safety.',26124),
(91741,'enUS','Yes, good! You have freed more outcasts from our oppressive brothers. Quickly now, we must get them to safety.','',26124),
(91742,'enUS','Free the outcasts, lead them in battle, escort them out to the Darkscryers, don\'t let them perish. Got it.','Free the outcasts, lead them in battle, escort them out to the Darkscryers, don\'t let them perish. Got it.',26124),
(91743,'enUS','Don\'t let me catch you back here again.','',26124),
(91745,'enUS','I\'m trying to sleep here!','',26124),
(91747,'enUS','Think you can sneak past me?','',26124),
(91750,'enUS','That stuff\'s not for you.','',26124),
(91751,'enUS','Next time, I\'ll squish you!','',26124),
(91755,'enUS','Don\'t let me see your face again.','',26124),
(91757,'enUS','Help! I\'m alive!','Help! I\'m alive!',26124),
(91758,'enUS','Retreat!','',26124),
(91759,'enUS','','Run!',26124),
(91760,'enUS','Retreat!','',26124),
(91761,'enUS','','Run!',26124),
(91762,'enUS','Charge!','',26124),
(91763,'enUS','','To battle!',26124),
(91764,'enUS','','For Durotar!',26124),
(91765,'enUS','Slay them all!','',26124),
(91766,'enUS','Good work Alliance! If we now capture Emberfall Tower we can have our Sentinels take out those |c00FFFF00|Hspell:178362|h[Warspear Gladiators]|h|r. Victory is near!','Good work Alliance! If we now capture Emberfall Tower we can have our Sentinels take out those |c00FFFF00|Hspell:178362|h[Warspear Gladiators]|h|r. Victory is near!',26124),
(91767,'enUS','Lok\'tar ogar! We must capture this last point and our Headhunters can take out those |c00FFFF00|Hspell:178363|h[Stormshield Gladiators]|h|r, then we can storm Stormshield Stronghold. Tremblade will die this day!','Lok\'tar ogar! We must capture this last point and our Headhunters can take out those |c00FFFF00|Hspell:178363|h[Stormshield Gladiators]|h|r, then we can storm Stormshield Stronghold. Tremblade will die this day!',26124),
(91768,'enUS','$p? Hah! You\'re the last of Sternfathom\'s pit fighters.','',26124),
(91769,'enUS','Come on. Let\'s finish this!','',26124),
(91770,'enUS','Alright, Feargus, you\'re up. Kill for me.','',26124),
(91771,'enUS','Ready to die, $pr?','',26124),
(91772,'enUS','Good luck, my little friend.','',26124),
(91773,'enUS','Great job, $p! Only two more to go.','',26124),
(91774,'enUS','|TInterface\\Icons\\ability_warrior_rampage.blp:20|t %s begins to cast |cFFFF0000|Hspell:164426|h[Reckless Provocation]|h|r!','',26124),
(91775,'enUS','Don\'t fail me, fish man, or you\'ll be bait on my hook.','',26124),
(91776,'enUS','Blessings of the Jade Serpent upon you.','',26124),
(91777,'enUS','You\'re still going to lose.','',26124),
(91778,'enUS','Yes!','',26124),
(91779,'enUS','NOOO!','',26124),
(91780,'enUS','Finish this, Whalebelly!','',26124),
(91781,'enUS','Come on, Bilgerudder. Get me in there!','',26124),
(91782,'enUS','I told you I was going to chop you up into little chunks of chum, $p.','',26124),
(91783,'enUS','And that\'s what I\'m going to do!','',26124),
(91784,'enUS','Stupid tuskarr!','',26124),
(91785,'enUS','You win this time, Sternfathom. It won\'t happen again.','',26124),
(91786,'enUS','An incredible performance, my little $p. Go, find your friend.','',26124),
(91787,'enUS','WHAT? No...','',26124),
(91788,'enUS','We are shamed in this defeat. Fall back!','',26124),
(91789,'enUS','','Discretion is the better part of valor. Now flee!',26124),
(91790,'enUS','Ready to be thrown into the arena?','',26124),
(91791,'enUS','It\'s my lifelong dream to beat Bilgerudder during a real challenge against his three champions. They\'re just so good!\n\nMaybe you\'ll be the one to make my dream come true, $n?','',26124),
(91792,'enUS','$n! So good to see you.\n\nYou can come back and fight for me anytime.','',26124),
(91793,'enUS','They\'re ready, Sternfathom. Toss me into battle.','They\'re ready, Sternfathom. Toss me into battle.',26124),
(91794,'enUS','Make Team Sternfathom proud.','',26124),
(91795,'enUS','','|TInterface\\Icons\\ability_deathwing_bloodcorruption_earth.blp:20|t%s begins to cast |cFFFF0000|Hspell:163689|h[Sanguine Sphere]|h|r!',26124),
(91796,'enUS','Eeeeek! A dooker on you!','',26124),
(91797,'enUS','I\'m ookin\' outa here.','',26124),
(91798,'enUS','What the ook? This not sanctioned fight!','',26124),
(91799,'enUS','Ookin\' wikket! Walk away, just like your brother.','Ookin\' wikket! Walk away, just like your brother.',26124),
(91800,'enUS','','Parjesh! Rally the rest of our forces. I shall make short work of this minor interruption.',26124),
(91801,'enUS','It will be done, Tidemistress.','',26124),
(91802,'enUS','','I have lost two sons this day. I would see this war end before more brothers and sisters of the clans fall prey to the Iron Horde.$b$bMy way is that of a healer. It is my gift to aid others injured by life or battle.$b$bIf you will have me, I shall lend my healing talents to your forces.',26124),
(91803,'enUS','Greatmother Geyah, I choose you!','Greatmother Geyah, I choose you!',26124),
(91804,'enUS','You\'ve surpassed me on the battlefield more than once, and that\'s no simple feat.$b$bStill, there is much I can do that you\'ve not yet seen. The spirits have seen it fit to grant me their coldest, most harsh powers. The elements are my allies, and the bane of our enemies.$b$bIt would be my honor to serve at your side.','',26124),
(91805,'enUS','Kal\'gor the Honorable, I choose you!','Kal\'gor the Honorable, I choose you!',26124),
(91806,'enUS','Lokra, I choose you!','Lokra, I choose you!',26124),
(91807,'enUS','','You\'ve seen me at my worst, $n. My husband taken from me... my wolf killed by the coward, Fenris. I know intimately the price of war.$B$BWe must bring the Iron Horde to an end. Grant me a place by your side on the battlefield and I will bring the elements to bear to reap vengeance on our enemies.$b$bYou have only to accept my axe, and I will come.',26124),
(91808,'enUS','What happened, Farondis?','What happened, Farondis?',26124),
(91809,'enUS','Guilt overcame me. I could not simply WAIT while you fought my battles.','',26124),
(91810,'enUS','I resolved to follow you into the academy.','',26124),
(91811,'enUS','','Make sure that prisoner doesn\'t awaken, Parjesh.',26124),
(91812,'enUS','Yes, my mistress.','',26124),
(91813,'enUS','I followed them as closely as I dared.','',26124),
(91814,'enUS','In the midst of the chaos, I saw it: the sorceress had dropped the Tidestone.','',26124),
(91815,'enUS','You deal with our guest, Athissa. I shall take the prisoner to the slave pens.','',26124),
(91816,'enUS','','Curse you and your kind, elf. The queen herself will hear of this!',26124),
(91817,'enUS','Athissa and the Tidestone had evaded me. Rather than pursuing her, I set off to rescue you, my champion.','',26124),
(91818,'enUS','At the entrance to the cave, however, I ran into an old acquaintance.','',26124),
(91819,'enUS','I had finally found their slave pen.','',26124),
(91820,'enUS','','Be gone, spirit! The Tidestone belongs to us now!',26124),
(91821,'enUS','I believe you know the rest of the story, $n.','',26124),
(91822,'enUS','Follow Maraad','',26124),
(91832,'enUS','<Okuna Longtusk\'s pack lies here on the ground. One of the straps is broken and there are signs of a struggle. But otherwise, it\'s intact including its contents.>\n\n<Odds are that Okuna was captured and taken to Prince Oceanus. Time to proceed without him.>','',26124),
(91833,'enUS','Freedom!','Freedom!',26124),
(91834,'enUS','Aaarr! Now you die, scum.','Aaarr! Now you die, scum.',26124),
(91835,'enUS','This isn\'t my weapon, but she feels good in my hand.','This isn\'t my weapon, but she feels good in my hand.',26124),
(91836,'enUS','Time to pay the price of iron, skrogs.','Time to pay the price of iron, skrogs.',26124),
(91837,'enUS','Rise up. Let\'s kill them all.','Rise up. Let\'s kill them all.',26124),
(91838,'enUS','Better to die free than as a slave.','Better to die free than as a slave.',26124),
(91839,'enUS','Death to the giants. Death to Prince Oceanus!','Death to the giants. Death to Prince Oceanus!',26124),
(91840,'enUS','Kill them all. Let Neptulon sort them out.','Kill them all. Let Neptulon sort them out.',26124),
(91841,'enUS','%s takes a deep breath.','%s takes a deep breath.',26124),
(91842,'enUS','Commander, Morthis Whisperwing from the Druids of the Talon was looking for you. He can be found beneath the great tree to the south.','',26124),
(91843,'enUS','My hero! Say, you don\'t happen to have my weapons?','',26124),
(91844,'enUS','Outstanding! Let\'s get to work.','',26124),
(91845,'enUS','You start things off and I\'ll be sneaky.','',26124),
(91846,'enUS','The sooner we deal with Oceanus, the sooner we can get out of here.','',26124),
(91847,'enUS','We really did it. We took out Oceanus!\n\nNow we\'re free.','',26124),
(91848,'enUS','Hey, $p, I\'m right over here in this cage. Let me out!','',26124),
(91849,'enUS','You\'re going down, Oceanus!','',26124),
(91850,'enUS','Zug! You lead to great hall?','Zug! You lead to great hall?',26124),
(91851,'enUS','Zug zug!','Zug zug!',26124),
(91852,'enUS','You want an audience? You\'ve got one!','',26124),
(91853,'enUS','For the Horde!','',26124),
(91854,'enUS','Blood and Honor!','',26124),
(91855,'enUS','Drive them out! Do not hold back!','',26124),
(91856,'enUS','For the Alliance!','',26124),
(91857,'enUS','Do not falter!','',26124),
(91858,'enUS','Press the attack! Onward!','',26124),
(91859,'enUS','YES! I\'ll see you down below.','',26124),
(91860,'enUS','The Alliance has assaulted the Blacksmith!','',26124),
(91861,'enUS','The Horde has assaulted the Blacksmith!','',26124),
(91862,'enUS','The Alliance has taken the Blacksmith!','',26124),
(91863,'enUS','The Horde has taken the Blacksmith!','',26124),
(91864,'enUS','The Horde has defended the Blacksmith!','',26124),
(91865,'enUS','The Alliance has defended the Blacksmith!','',26124),
(91866,'enUS','The Alliance has assaulted the Farm!','',26124),
(91867,'enUS','The Horde has assaulted the Farm!','',26124),
(91868,'enUS','The Alliance has taken the Farm!','',26124),
(91869,'enUS','The Horde has taken the Farm!','',26124),
(91870,'enUS','The Alliance has defended the Farm!','',26124),
(91871,'enUS','The Horde has defended the Farm!','',26124),
(91872,'enUS','The Alliance has assaulted the mine!','',26124),
(91873,'enUS','The Horde has assaulted the mine!','',26124),
(91874,'enUS','The Alliance has taken the mine!','',26124),
(91875,'enUS','The Horde has taken the mine!','',26124),
(91876,'enUS','The Alliance has defended the mine!','',26124),
(91877,'enUS','The Horde has defended the mine!','',26124),
(91878,'enUS','The Alliance has assaulted the Lumber Mill!','',26124),
(91879,'enUS','The Horde has assaulted the Lumber Mill!','',26124),
(91880,'enUS','The Alliance has taken the Lumber Mill!','',26124),
(91881,'enUS','The Horde has taken the Lumber Mill!','',26124),
(91882,'enUS','The Alliance has defended the Lumber Mill!','',26124),
(91883,'enUS','The Horde has defended the Lumber Mmill!','',26124),
(91884,'enUS','The Alliance has assaulted the Stables!','',26124),
(91885,'enUS','The Horde has assaulted the Stables!','',26124),
(91886,'enUS','The Horde has defended the Stables!','',26124),
(91887,'enUS','The Alliance has defended the Stables!','',26124),
(91888,'enUS','The Alliance has taken the Stables!','',26124),
(91889,'enUS','The Horde has taken the Stables!','',26124),
(91890,'enUS','Thank you, stranger.','',26124),
(91891,'enUS','I don\'t know what happened. I heard a loud crashing noise, and then I found myself stuck beneath this beam. Since then, I\'ve just been waiting.','',26124),
(91892,'enUS','Now, where did that lovely girl run off to?','',26124),
(91893,'enUS','Whew, thank goodness I got to you in time! I know you are eager, hero, but we should build our strength before facing the dangers of Tanaan Jungle.','Whew, thank goodness I got to you in time! I know you are eager, hero, but we should build our strength before facing the dangers of Tanaan Jungle.',26124),
(91894,'enUS','An Alliance spy has snuck in amidst the chaos!','An Alliance spy has snuck in amidst the chaos!',26124),
(91895,'enUS','Let battle be joined!','',26124),
(91896,'enUS','For the Frostwolves!','',26124),
(91897,'enUS','For Commander $p!','',26124),
(91898,'enUS','A... glorious... end.','',26124),
(91899,'enUS','May the spirits have mercy on you.','',26124),
(91900,'enUS','The spirits will break you!','',26124),
(91901,'enUS','You have failed!','',26124),
(91902,'enUS','Lok-narosh.','',26124),
(91903,'enUS','May the spirits bring you victory.','',26124),
(91904,'enUS','','Have you heard from my son, Durotan?',26124),
(91905,'enUS','','Will this war ever end?',26124),
(91906,'enUS','','How is my son, Durotan?',26124),
(91907,'enUS','','It did not have to be this way.',26124),
(91908,'enUS','','These people are protected.',26124),
(91909,'enUS','','You will harm our people no more.',26124),
(91910,'enUS','','I am sorry it ended this way.',26124),
(91911,'enUS','','Garad... I am coming...',26124),
(91912,'enUS','','You will not harm our people.',26124),
(91913,'enUS','','The Burning Legion has overrun the vault and most of my wardens are dead. That\'s why I\'m setting you free. No one kills demons like you, $n.\n\nThey\'re heading for Illidan\'s tomb. We have to work together to stop the Legion.',26124),
(91914,'enUS','I advise we cooperate with our jailors... for now.','',26124),
(91915,'enUS','Lingering in this prison is a waste of our time. We need to get out of here as soon as possible.','',26124),
(91916,'enUS','It has been a long time, Kayn. I still believe in the cause. But, I do not blindly follow anyone... even Illidan.','',26124),
(91917,'enUS','The Horde has taken control of the Draenei Ruins!','',26124),
(91918,'enUS','$n has defended the Draenei Ruins!','',26124),
(91919,'enUS','$n has defended the Blood Elf Tower!','',26124),
(91920,'enUS','$n has defended the Blood Elf Tower!','',26124),
(91921,'enUS','$n has defended the Fel Reaver Ruins!','',26124),
(91922,'enUS','$n has defended the Fel Reaver Ruins!','',26124),
(91923,'enUS','$n has defended the Mage Tower!','',26124),
(91924,'enUS','$n has defended the Mage Tower!','',26124),
(91925,'enUS','Goren Shardbacks Killed: $1i (+$2i VP)','Goren Shardbacks Killed: $1i (+$2i VP)',26124),
(91926,'enUS','Gronn Earthbreakers Killed: $1i (+$2i VP)','Gronn Earthbreakers Killed: $1i (+$2i VP)',26124),
(91931,'enUS','Wildfire Elementals Killed: $1i (+$2i VP)','',26124),
(91932,'enUS','A Wildfire Elemental is being summoned at the front gates!','A Wildfire Elemental is being summoned at the front gates!',26124),
(91933,'enUS','A Goren Hole has opened up!','A Goren Hole has opened up!',26124),
(91934,'enUS','Goren Holes closed: $1i (+$2i VP)','',26124),
(91935,'enUS','Ready when you are, my queen.','',26124),
(91936,'enUS','My life for the Talon Queen.','',26124),
(91937,'enUS','','',26124),
(91938,'enUS','Dese pukes better at dieing den fighten.','',26124),
(91939,'enUS','HA! Looks like getting split in half made that grub twice as ugly!','',26124),
(91940,'enUS','<Snore>','',26124),
(91941,'enUS','Observing','Observing',26124),
(91942,'enUS','Gronnling Groundshakers Killed: $1i (+$2i VP)','Gronnling Groundshakers Killed: $1i (+$2i VP)',26124),
(91943,'enUS','','Let\'s go! Commander, we\'ll meet ya at the tower.',26124),
(91944,'enUS','A Gorian Warcaller joins the battle to raise morale!','A Gorian Warcaller joins the battle to raise morale!',26124),
(91945,'enUS','Gorian Warcallers Killed: $1i (+$2i VP)','',26124),
(91946,'enUS','Rifts to the void open!','Rifts to the void open!',26124),
(91947,'enUS','Void Portals Closed: $1i (+$2i VP)','',26124),
(91948,'enUS','Void Fragments Killed: $1i (+$2i VP)','',26124),
(91949,'enUS','A fallen guard has been turned into a skeleton!','A fallen guard has been turned into a skeleton!',26124),
(91950,'enUS','Exarch Haataru - How do you plan to vote with the council?','',26124),
(91951,'enUS','You would risk everything we have built. I cannot agree!','',26124),
(91952,'enUS','It is wisest to fight where we are strongest.','',26124),
(91953,'enUS','This \"Alliance\" from another world intrigues me. I would give them our full support.','',26124),
(91954,'enUS','','Exarch Akama, how do you plan to vote? I suppose you\'ll want to wait behind the fortifications of Shattrath and Karabor.',26124),
(91955,'enUS','','If we never leave our city walls, we will never be able to call this world our home.',26124),
(91956,'enUS','Gorian Battle Beasts Killed: $1i (+$2i)','',26124),
(91957,'enUS','The Alliance has lost control of the Blood Elf Tower!','',26124),
(91958,'enUS','The Horde has lost control of the Blood Elf Tower!','',26124),
(91959,'enUS','The Alliance has lost control of the Draenei Ruins!','',26124),
(91960,'enUS','The Horde has lost control of the Draenei Ruins!','',26124),
(91961,'enUS','The Alliance has lost control of the Fel Reaver Ruins!','',26124),
(91962,'enUS','The Horde has lost control of the Fel Reaver Ruins!','',26124),
(91963,'enUS','The Alliance has lost control of the Mage Tower!','',26124),
(91964,'enUS','The Horde has lost control of the Mage Tower!','',26124),
(91965,'enUS','A Void Wolf Patriarch is terrorizing your guards!','A Void Wolf Patriarch is terrorizing your guards!',26124),
(91966,'enUS','Void Wolf Patriarchs Killed: $1i (+$2i VP)','',26124),
(91967,'enUS','Ah! That old thing. I was so young and naive when I made that staff. Look at that hair! And that nose!$b$bAnd I can\'t BELIEVE I ever wore something so atrocious as a hat like that.$b$bYou should keep this old staff. The image is from a few years ago, and hasn\'t quite caught on to current events. May you enjoy the nostalgia of my more youthful visage.','',26124),
(91968,'enUS','Is this |Hitem:118191|h|cff0070dd[Archmage Vargoth\'s Spare Staff]|r|h yours?','Is this |Hitem:118191|h|cff0070dd[Archmage Vargoth\'s Spare Staff]|r|h yours?',26124),
(91969,'enUS','Felbringers Killed: $1i (+$2i VP)','',26124),
(91970,'enUS','Destructors Killed: $1i (+$2i VP)','',26124),
(91971,'enUS','Soulspeakers Killed: $1i (+$2i VP)','',26124),
(91972,'enUS','Ritualists Killed: $1i (+$2i VP)','',26124),
(91973,'enUS','Insurgents Killed: $1i (+$2i VP)','',26124),
(91974,'enUS','Militants Killed: $1i (+$2i VP)','',26124),
(91975,'enUS','Ransacking','Ransacking',26124),
(91976,'enUS','An Earth Fury is causing an earthquake in your garrison!','An Earth Fury is causing an earthquake in your garrison!',26124),
(91977,'enUS','Infuriated Earthpounder Killed: $1i (+$2i VP)','',26124),
(91978,'enUS','Marauders Killed: $1i (+$2i VP)','',26124),
(91979,'enUS','Doombringers Killed: $1i (+$2i VP)','',26124),
(91980,'enUS','Imp Charmers Killed: $1i (+$2i VP)','',26124),
(91981,'enUS','Imp Seers Killed: $1i (+$2i VP)','',26124),
(91982,'enUS','','NO! This is not for you. It\'s for Prince Oceanus!',26124),
(91983,'enUS','','Wake up. I demand to see Prince Oceanus, now!',26124),
(91984,'enUS','','You slumbering oaf. I will not be made to wait here all day. I demand to see your prince!',26124),
(91985,'enUS','A Gorian Battle-Mage enters the fray!','A Gorian Battle-Mage enters the fray!',26124),
(91986,'enUS','Gorian Battle-Mages Killed: $1i (+$2i VP)','',26124),
(91987,'enUS','','If your prince does not want this treasure, I will happily take it and leave.',26124),
(91991,'enUS','','If treasure is not to his liking, perhaps your prince needs a different kind of motivation?',26124),
(91993,'enUS','The commotion of the battle attracts a rylak!','The commotion of the battle attracts a rylak!',26124),
(91994,'enUS','A Gorian Spellbinder arrives to slow down your forces!','A Gorian Spellbinder arrives to slow down your forces!',26124),
(91995,'enUS','Gorian Spellbinders Killed: $1i (+$2i VP)','',26124),
(91996,'enUS','Rylak Killed: $1i (+$2i)','',26124),
(91997,'enUS','Nefarious Consorts Killed: $1i (+$2i VP)','',26124),
(91998,'enUS','Fel Legionnaires Killed: $1i (+$2i VP)','',26124),
(91999,'enUS','Shattered Hand Assassins Killed: $1i (+$2i VP)','Shattered Hand Assassins Killed: $1i (+$2i VP)',26124),
(92000,'enUS','An Assassin is hunting your guards!','An Assassin is hunting your guards!',26124),
(92001,'enUS','I would like to deactivate this waygate.','I would like to deactivate this waygate. |cFFFF2222 [Requires 10 Ogre Waystones]|r |TInterface\\Icons\\INV_RELICS_RUNESTONE.BLP:##|t',26124),
(92002,'enUS','What business do you have here, mortal?\n\nMy life is dedicated to protecting these ancient waygates.  If you wish to activate them, you will need to procure a collection of ancient artifacts known as ogre waystones.','',26124),
(92003,'enUS','Are you sure you want to deactivate this ogre waygate?\n\n|TInterface\\Icons\\INV_RELICS_RUNESTONE.BLP:24|t Requires 10 Ogre Waystones','',26124),
(92004,'enUS','I heard you might have high-quality rings for sale?','I heard you might have high-quality rings for sale?',26124),
(92005,'enUS','A Siege Cannon draws near!','A Siege Cannon draws near!',26124),
(92006,'enUS','Siege Cannons Destroyed: $1i (+$2i VP)','Siege Cannons Destroyed: $1i (+$2i VP)',26124),
(92007,'enUS','A Brute is frightening your troops!','A Brute is frightening your troops!',26124),
(92008,'enUS','Horrifying Brutes Destroyed: $1i (+$2i VP)','Horrifying Brutes Destroyed: $1i (+$2i VP)',26124),
(92009,'enUS','Concubines of Sin Killed: $1i (+$2i VP)','',26124),
(92010,'enUS','A Sniper is shooting your guards!','A Sniper is shooting your guards!',26124),
(92011,'enUS','Grom\'kar Sniper Killed: $1i (+$2i VP)','Grom\'kar Sniper Killed: $1i (+$2i VP)',26124),
(92012,'enUS','A host of Concubines appear!','A host of Concubines appear!',26124),
(92013,'enUS','Succubus Group Killed: $1i (+$2i VP)','',26124),
(92014,'enUS','Go away, tiny creature, or I will have you for a snack.','',26124),
(92015,'enUS','$n, over here. Get me out of this cage.','',26124),
(92016,'enUS','Grom\'kar Commander Killed: $1i (+$2i VP)','Grom\'kar Commander Killed: $1i (+$2i VP)',26124),
(92017,'enUS','BLACKHAND','BLACKHAND',26124),
(92018,'enUS','GUL\'DAN','GUL\'DAN',26124),
(92019,'enUS','KARGATH','KARGATH',26124),
(92020,'enUS','KILROGG','KILROGG',26124),
(92021,'enUS','NER\'ZHUL','NER\'ZHUL',26124),
(92022,'enUS','Infernals Killed: $1i (+$2i VP)','',26124),
(92023,'enUS','Infernal Waves Killed: $1i (+$2i VP)','',26124),
(92024,'enUS','A storm of Infernals appear!','A storm of Infernals appear!',26124),
(92025,'enUS','What do we have in stock?','What do we have in stock?',26124),
(92026,'enUS','The Horde has assaulted the Blood Elf Tower!','',26124),
(92027,'enUS','The Alliance has assaulted the Blood Elf Tower!','',26124),
(92028,'enUS','The Horde has assaulted the Draenei Ruins!','',26124),
(92029,'enUS','The Alliance has assaulted the Draenei Ruins!','',26124),
(92030,'enUS','The Horde has assaulted the Fel Reaver Ruins!','',26124),
(92031,'enUS','The Alliance has assaulted the Fel Reaver Ruins!','',26124),
(92032,'enUS','The Horde has assaulted the Mage Tower!','',26124),
(92033,'enUS','The Alliance has assaulted the Mage Tower!','',26124),
(92034,'enUS','Alchemy Lab\nLevel 1','',26124),
(92035,'enUS','Barn\nLevel 1','',26124),
(92036,'enUS','Barracks\nLevel 1','',26124),
(92037,'enUS','Dwarven Bunker\nLevel 1','',26124),
(92038,'enUS','Enchanter\'s Study\nLevel 1','',26124),
(92039,'enUS','Engineering Works\nLevel 1','',26124),
(92040,'enUS','Fishing Shack\nLevel 1','',26124),
(92041,'enUS','Gem Boutique\nLevel 1','',26124),
(92042,'enUS','Gladiator\'s Sanctum\nLevel 1','',26124),
(92043,'enUS','Gnomish Gearworks\nLevel 1','',26124),
(92044,'enUS','Herb Garden\nLevel 1','',26124),
(92045,'enUS','Lumber Mill\nLevel 1','',26124),
(92046,'enUS','Lunarfall Excavation\nLevel 1','',26124),
(92047,'enUS','Lunarfall Inn\nLevel 1','',26124),
(92048,'enUS','Mage Tower\nLevel 1','',26124),
(92049,'enUS','Menagerie\nLevel 1','',26124),
(92050,'enUS','Salvage Yard\nLevel 1','',26124),
(92051,'enUS','Scribe\'s Quarters\nLevel 1','',26124),
(92052,'enUS','Stables\nLevel 1','',26124),
(92053,'enUS','Storehouse\nLevel 1','',26124),
(92054,'enUS','Tailoring Emporium\nLevel 1','',26124),
(92055,'enUS','The Forge\nLevel 1','',26124),
(92056,'enUS','The Tannery\nLevel 1','',26124),
(92057,'enUS','Trading Post\nLevel 1','',26124),
(92058,'enUS','Frostwall Mine\nLevel 1','',26124),
(92059,'enUS','Frostwall Tavern\nLevel 1','',26124),
(92060,'enUS','Goblin Workshop\nLevel 1','',26124),
(92061,'enUS','Spirit Lodge\nLevel 1','',26124),
(92062,'enUS','War Mill\nLevel 1','',26124),
(92066,'enUS','Alchemy Lab\nLevel 2','',26124),
(92067,'enUS','Barn\nLevel 2','',26124),
(92068,'enUS','Barracks\nLevel 2','',26124),
(92069,'enUS','Dwarven Bunker\nLevel 2','',26124),
(92070,'enUS','Enchanter\'s Study\nLevel 2','',26124),
(92071,'enUS','Engineering Works\nLevel 2','',26124),
(92072,'enUS','Fishing Shack\nLevel 2','',26124),
(92073,'enUS','Gem Boutique\nLevel 2','',26124),
(92074,'enUS','Gladiator\'s Sanctum\nLevel 2','',26124),
(92075,'enUS','Gnomish Gearworks\nLevel 2','',26124),
(92076,'enUS','Herb Garden\nLevel 2','',26124),
(92077,'enUS','Lumber Mill\nLevel 2','',26124),
(92078,'enUS','Lunarfall Excavation\nLevel 2','',26124),
(92079,'enUS','Lunarfall Inn\nLevel 2','',26124),
(92080,'enUS','Mage Tower\nLevel 2','',26124),
(92081,'enUS','Menagerie\nLevel 2','',26124),
(92082,'enUS','Salvage Yard\nLevel 2','',26124),
(92083,'enUS','Scribe\'s Quarters\nLevel 2','',26124),
(92084,'enUS','Stables\nLevel 2','',26124),
(92085,'enUS','Storehouse\nLevel 2','',26124),
(92086,'enUS','Tailoring Emporium\nLevel 2','',26124),
(92087,'enUS','The Forge\nLevel 2','',26124),
(92088,'enUS','The Tannery\nLevel 2','',26124),
(92089,'enUS','Trading Post\nLevel 2','',26124),
(92090,'enUS','Frostwall Mine\nLevel 2','',26124),
(92091,'enUS','Frostwall Tavern\nLevel 2','',26124),
(92092,'enUS','Goblin Workshop\nLevel 2','',26124),
(92093,'enUS','Spirit Lodge\nLevel 2','',26124),
(92094,'enUS','War Mill\nLevel 2','',26124),
(92095,'enUS','Alchemy Lab\nLevel 3','',26124),
(92096,'enUS','Barn\nLevel 3','',26124),
(92097,'enUS','Barracks\nLevel 3','',26124),
(92098,'enUS','Dwarven Bunker\nLevel 3','',26124),
(92099,'enUS','Enchanter\'s Study\nLevel 3','',26124),
(92100,'enUS','Engineering Works\nLevel 3','',26124),
(92101,'enUS','Fishing Shack\nLevel 3','',26124),
(92102,'enUS','Gem Boutique\nLevel 3','',26124),
(92103,'enUS','Gladiator\'s Sanctum\nLevel 3','',26124),
(92104,'enUS','Gnomish Gearworks\nLevel 3','',26124),
(92105,'enUS','Herb Garden\nLevel 3','',26124),
(92106,'enUS','Lumber Mill\nLevel 3','',26124),
(92107,'enUS','Lunarfall Excavation\nLevel 3','',26124),
(92108,'enUS','Lunarfall Inn\nLevel 3','',26124),
(92109,'enUS','Mage Tower\nLevel 3','',26124),
(92110,'enUS','Menagerie\nLevel 3','',26124),
(92111,'enUS','Salvage Yard\nLevel 3','',26124),
(92112,'enUS','Scribe\'s Quarters\nLevel 3','',26124),
(92113,'enUS','Stables\nLevel 3','',26124),
(92114,'enUS','Storehouse\nLevel 3','',26124),
(92115,'enUS','Tailoring Emporium\nLevel 3','',26124),
(92116,'enUS','The Forge\nLevel 3','',26124),
(92117,'enUS','The Tannery\nLevel 3','',26124),
(92118,'enUS','Trading Post\nLevel 3','',26124),
(92119,'enUS','Frostwall Mine\nLevel 3','',26124),
(92120,'enUS','Frostwall Tavern\nLevel 3','',26124),
(92121,'enUS','Goblin Workshop\nLevel 3','',26124),
(92122,'enUS','Spirit Lodge\nLevel 3','',26124),
(92123,'enUS','War Mill\nLevel 3','',26124),
(92124,'enUS','|TInterface\\Icons\\inv_bannerpvp_02.blp:20|t An Alliance Bannerman arrives at your Town Hall! |TInterface\\Icons\\inv_bannerpvp_02.blp:20|t','|TInterface\\Icons\\inv_bannerpvp_02.blp:20|t An Alliance Bannerman arrives at your Town Hall! |TInterface\\Icons\\inv_bannerpvp_02.blp:20|t',26124),
(92125,'enUS','|TInterface\\Icons\\inv_bannerpvp_01.blp:20|t A Horde Bannerman arrives at your Great Hall! |TInterface\\Icons\\inv_bannerpvp_01.blp:20|t','|TInterface\\Icons\\inv_bannerpvp_01.blp:20|t A Horde Bannerman arrives at your Great Hall! |TInterface\\Icons\\inv_bannerpvp_01.blp:20|t',26124),
(92126,'enUS','A swarm of ravager wasps approaches!','A swarm of ravager wasps approaches!',26124),
(92127,'enUS','Void Wolves Killed: $1i (+$2i VP)','',26124),
(92128,'enUS','Void Essences Killed: $1i (+$2i VP)','',26124),
(92129,'enUS','Shadowmoon Darkcasters Killed: $1i (+$2i VP)','',26124),
(92130,'enUS','Shadowmoon Reavers Killed: $1i (+$2i VP)','',26124),
(92131,'enUS','I\'m out of banners, commander! I shall take my leave.','',26124),
(92132,'enUS','Spor Shooters are attacking your guards!','Spor Shooters are attacking your guards!',26124),
(92133,'enUS','Guards Inspired: $1i (+$2i VP)','Guards Inspired: $1i (+$2i VP)',26124),
(92134,'enUS','Spore Shooters: $1i (+$2i VP)','',26124),
(92135,'enUS','Ravager Wasps: $1i (+$2i VP)','',26124),
(92140,'enUS','Enthralled Mutants: $1i (+$2i VP)','',26124),
(92141,'enUS','A Nefarious Consort is assaulting your forces!','A Nefarious Consort is assaulting your forces!',26124),
(92142,'enUS','A Fel Legionnaire draws near!','A Fel Legionnaire draws near!',26124),
(92143,'enUS','Ravager Swarms Killed: $1i (+$2i VP)','',26124),
(92144,'enUS','Spore Shooter Waves Killed: $1i (+$2i VP)','',26124),
(92145,'enUS','Searching for Clues','Searching for Clues',26124),
(92146,'enUS','We were headed for... Stormheim.','We were headed for... Stormheim.',26124),
(92147,'enUS','Ship crashed... gilblin swarmed us.','Ship crashed... gilblin swarmed us.',26124),
(92148,'enUS','Makrura queen... demon...','Makrura queen... demon...',26124),
(92149,'enUS','Storm... ran aground.','Storm... ran aground.',26124),
(92150,'enUS','Captain... taken...','Captain... taken...',26124),
(92151,'enUS','We were... going to Stormheim... after the Broken Shore.','We were... going to Stormheim... after the Broken Shore.',26124),
(92152,'enUS','Demon... here...','Demon... here...',26124),
(92153,'enUS','I heard... makrura ate... the captain!','I heard... makrura ate... the captain!',26124),
(92154,'enUS','The queen...','',26124),
(92155,'enUS','A $r, how refreshing. Come closer, child.','',26124),
(92156,'enUS','What am I thinking? This fight is all yours, my queen.','',26124),
(92157,'enUS','Useless, like the rest of her kind. I\'ll deal with you, myself!','',26124),
(92158,'enUS','HEY! That\'s not for you.','',26124),
(92159,'enUS','Don\'t think of us as smugglers. Instead, refer to us as professional salvors.\n\nWe are salvage experts. We specialize in flotsam, jetsam, lagan, derelicts, and, of course, exotic archaeological recovery.\n\nOh, and by the way, you might want to steer clear of the temple area to the south. I have my men investigating some salvage opportunities and I wouldn\'t want you to be confused for a competitor.','',26124),
(92160,'enUS','%s beckons the sailor forward.','',26124),
(92161,'enUS','Stranger, quickly. Over here.','',26124),
(92162,'enUS','I await your orders, $g sir:ma\'am;.','',26124),
(92163,'enUS','You, Kor\'vas, and Cyana attack the Legion from within. Then, we will wipe them out together.','',26124),
(92164,'enUS','','You must all be taught a lesson.',26124),
(92169,'enUS','Accompany Prophet Velen to Lunarfall.','',26124),
(92170,'enUS','We must hurry to Lunarfall.','',26124),
(92171,'enUS','Escort Prophet Velen to Lunarfall.','Escort Prophet Velen to Lunarfall.',26124),
(92172,'enUS','Accompany Prophet Velen to Lunarfall.','',26124),
(92173,'enUS','Great job on the training, let\'s let your talbuk rest for the night.','Great job on the training, let\'s let your talbuk rest for the night.',26124),
(92174,'enUS','They\'re tough, for sure, but your clefthoof will still need to rest for a while.','They\'re tough, for sure, but your clefthoof will still need to rest for a while.',26124),
(92175,'enUS','Your boar looks like he could use a good brushing and feeding, check back tomorrow.','Your boar looks like he could use a good brushing and feeding, check back tomorrow.',26124),
(92176,'enUS','Ye fought well today, we\'ll let the riverbeast bed down for the night.','Ye fought well today, we\'ll let the riverbeast bed down for the night.',26124),
(92177,'enUS','The elekk\'s already almost asleep, we\'ll let it rest up a bit before more training.','The elekk\'s already almost asleep, we\'ll let it rest up a bit before more training.',26124),
(92178,'enUS','That wolf\'s a fiesty one, but he\'s all curled up and asleep after today\'s training, come back tomorrow for more.','That wolf\'s a fiesty one, but he\'s all curled up and asleep after today\'s training, come back tomorrow for more.',26124),
(92179,'enUS','The wolf is a fiery predator, but will require a day\'s rest before it can be trained further.','The wolf is a fiery predator, but will require a day\'s rest before it can be trained further.',26124),
(92180,'enUS','The talbuk training appears to be going well, it should rest for the night.','The talbuk training appears to be going well, it should rest for the night.',26124),
(92181,'enUS','The riverbeasts are not so used to land combat, we will need to let this one retire for tonight.','The riverbeasts are not so used to land combat, we will need to let this one retire for tonight.',26124),
(92182,'enUS','The elekk is nearly asleep after today\'s training, we will let it rest for the night.','The elekk is nearly asleep after today\'s training, we will let it rest for the night.',26124),
(92183,'enUS','The clefthoof will need a good brushing and some water, check back tomorrow for more training.','The clefthoof will need a good brushing and some water, check back tomorrow for more training.',26124),
(92184,'enUS','Your boar looks weary but healthy, leave it with us for tonight and we will take care of it.','Your boar looks weary but healthy, leave it with us for tonight and we will take care of it.',26124),
(92190,'enUS','Somehow, the Burning Legion is nullifying my demon wards. If we don\'t get those defenses back in working order, we\'ll be overrun and I will have failed all of us.','',26124),
(92192,'enUS','Welcome to our humble place of business, traveler.','',26124),
(92193,'enUS','I saw my chance. I would attack the naga leaders and save you from captivity.','',26124),
(92195,'enUS','\"Going for a walk.\" Hah! He\'s probably out visiting that little common girl he fancies so much.','',26124),
(92196,'enUS','','Aldryth. You weren\'t out consorting with that servant girl, were you?',26124),
(92197,'enUS','What? No, of course not!','',26124),
(92198,'enUS','...','',26124),
(92199,'enUS','I was visiting a different girl.','',26124),
(92200,'enUS','What should we do with this one?','',26124),
(92201,'enUS','Torture? Hard labor? Kill it?','',26124),
(92202,'enUS','I say we kill it.','',26124),
(92203,'enUS','Good idea, let\'s kill it.','',26124),
(92204,'enUS','Huh?','',26124),
(92205,'enUS','What?','',26124),
(92206,'enUS','Ten thousand years ago, I found myself mixed up with a rebel alliance of sorts.','',26124),
(92207,'enUS','This was during the pinnacle of Queen Azshara\'s power over the elves. Her abuse of magic had grown dangerously strong.','',26124),
(92208,'enUS','We plotted to use the Tidestone of Golganneth against the queen.','',26124),
(92209,'enUS','Cenarius. I can wield the Tidestone, but I must warn you: we risk destroying the entire Well of Eternity!','',26124),
(92210,'enUS','That, my friend, is precisely the plan.','',26124),
(92211,'enUS','Fah! We need simply to do away with Queen Azshara herself, not the very source of our people\'s power.','',26124),
(92212,'enUS','I agree. We are firing a cannon at sparrows.','',26124),
(92213,'enUS','','We are fighting the greatest danger our world has ever seen!',26124),
(92214,'enUS','','Even now, Queen Azshara colludes with demons. She puts our world at risk.',26124),
(92215,'enUS','Very well. Prince Farondis, you can secure the Tidestone of Golganneth?','',26124),
(92216,'enUS','I shall have it arranged, Cenarius.','',26124),
(92217,'enUS','You there. Stop!','',26124),
(92218,'enUS','Such interesting thoughts! Show us more, $r. Kill the others here! Let us feed on our enemies, exploit their machines and discover the wonders that our home hides!','',26124),
(92219,'enUS','Let us feed... slay them all!','',26124),
(92220,'enUS','We hunger... kill more of them! Let us consume their corpses!','',26124),
(92221,'enUS','What is this? We must know more. Move closer!','',26124),
(92222,'enUS','Fascinating, we will have to remember this.','',26124),
(92223,'enUS','Our power grows...','',26124),
(92224,'enUS','We are learning! We can see the next phase of our life cycle.','',26124),
(92225,'enUS','Our powers are ready, we EVOLVE!','',26124),
(92226,'enUS','A strange parasite attaches itself to your head, you feel an intrusion in your thoughts.','A strange parasite attaches itself to your head, you feel an intrusion in your thoughts.',26124),
(92227,'enUS','The Amorphic Cognitor undulates with excitement, it is clearly pleased with your actions.','The Amorphic Cognitor undulates with excitement, it is clearly pleased with your actions.',26124),
(92228,'enUS','The Amorphic Cognitor tightens its grip on your head, it is getting stronger.','The Amorphic Cognitor tightens its grip on your head, it is getting stronger.',26124),
(92229,'enUS','As the Amorphic Cognitor evolves, you feel yourself pulled off the ground. You are evolving with it!','As the Amorphic Cognitor evolves, you feel yourself pulled off the ground. You are evolving with it!',26124),
(92230,'enUS','','Together, we will release the demon souls from the gems and use the scythe to compel them to talk.\n\nLet me know when you are ready to begin.',26124),
(92231,'enUS','We cannot leave our home, $r. We will continue our life cycle without you.','',26124),
(92232,'enUS','The strange parasite detaches from your head and disappears into the distance.','The strange parasite detaches from your head and disappears into the distance.',26124),
(92233,'enUS','You\'ll learn nothing from me, Souleater!','',26124),
(92234,'enUS','','After the Battle at the Broken Shore, it was only fitting that I step down so that Khadgar could lead the Kirin Tor.',26124),
(92235,'enUS','The time has come for us to put aside our petty differences. The united force of Dalaran will crush the Burning Legion!','',26124),
(92236,'enUS','Ooka, may I please have some of your delicious Fighter Chow? I hear it\'s the best.','Ooka, may I please have some of your delicious Fighter Chow? I hear it\'s the best.',26124),
(92237,'enUS','','Where is the Legion keeping Illidan\'s body? Tell me or your suffering will be the stuff of legend.',26124),
(92238,'enUS','I\'m ready, Allari. Let\'s begin.','I\'m ready, Allari. Let\'s begin.',26124),
(92239,'enUS','','What did they do? What did the demons offer you?',26124),
(92240,'enUS','','Who did this to you?',26124),
(92241,'enUS','','Did anyone give in?',26124),
(92242,'enUS','','We will work together to destroy the Legion from within.',26124),
(92243,'enUS','','They have all been tortured.',26124),
(92244,'enUS','','I think I understand why this is not working.',26124),
(92245,'enUS','','$p, you must enter the soul gem and force Arev\'naal to reveal Lord Illidan\'s location.',26124),
(92246,'enUS','','A powerful demon I have kept trapped in the gems is helping them to resist.',26124),
(92247,'enUS','Our combined will is stronger than your scythe. I will not tell you.','',26124),
(92248,'enUS','','Illidari, what happened here?',26124),
(92252,'enUS','','Quickly, $p, break the next soul gem.',26124),
(92333,'enUS','We sense the deaths of some of our brothers. This is good, they were clearly unfit to evolve.','',26124),
(92334,'enUS','Such a sweet taste of our future evolution. We must have more.','',26124),
(92335,'enUS','The Amorphic Cognitor tightens its grip on your head once again, its voice booms through your mind.','The Amorphic Cognitor tightens its grip on your head once again, its voice booms through your mind.',26124),
(92336,'enUS','|TInterface\\Icons\\Ability_Racial_Cannibalize:20|tRight-click on corpses to |cFFFF0000|Hspell:174133|h[Consume]|h|r them after you\'ve looted them.','|TInterface\\Icons\\Ability_Racial_Cannibalize:20|tRight-click on corpses to |cFFFF0000|Hspell:174133|h[Consume]|h|r them after you\'ve looted them.',26124),
(92337,'enUS','','Quickly, $p, we have to find the key to those demonic locks. I\'d bet anything it\'s on that big jailer to the east.',26124),
(92339,'enUS','','Get the key. Let\'s get over there and free that drake.',26124),
(92340,'enUS','Who are you? You\'re no slave!','',26124),
(92341,'enUS','Where are you going?','',26124),
(92342,'enUS','What\'s the meaning of this?','',26124),
(92343,'enUS','Greetings, $c.\n\nThe Burning Legion have taken Faronaar. I have a plan to contain and crush them before they overrun all of Azsuna.\n\nWe could use your assistance in doing so.','',26124),
(92344,'enUS','Already, the Burning Legion spreads like a wildfire across the Broken Isles.\n\nWe must hunt them down and destroy them wherever they pop up.\n\nYou must see to it that the Tomb of Sargeras is resealed.','',26124),
(92345,'enUS','Come friend, let us walk in together and greet this Senegos.','',26124),
(92346,'enUS','This does not look good. He is not well.','',26124),
(92347,'enUS','Archmage Khadgar? $C? An unexpected surprise.','',26124),
(92358,'enUS','The Tidestone calls to them...','The Tidestone calls to them...',26124),
(92359,'enUS','Show me your goods!','Show me your goods!',26124),
(92360,'enUS','My queen.','',26124),
(92361,'enUS','These big ones are strange. Big and slow yes; but with the potential for great intellect just slipping away.','',26124),
(92362,'enUS','We can\'t explain why; but we feel great unease around these feathered ones and their cave.','',26124),
(92363,'enUS','These little ones are most curious, always so eager to explore, experiment, and learn. Much like us.','',26124),
(92364,'enUS','These sickly looking creatures are more... pliable than the others. They give themselves over to our brothers.','',26124),
(92365,'enUS','This one was already host to one like us. They chose a poor host.','',26124),
(92366,'enUS','Such a sad fate for our brother. Evolution\'s circle is savage, not merciful.','',26124),
(92384,'enUS','Without the moss here our minds would rot away, leaving us shells of our true potential.','',26124),
(92385,'enUS','How interesting, we have not tasted the fruits from this cave.','',26124),
(92386,'enUS','What is this ... thing? What hides inside?','',26124),
(92387,'enUS','How strange, we do not remember how such things came to be here.','',26124),
(92388,'enUS','Fascinating, we can sense the energy coursing through you. What could it possibly be for?','',26124),
(92389,'enUS','We recognize this now! This infernal device is responsible for the slaughter of so many of us! Our brothers are going to perish soon, leaving us to thrive in their absence.','',26124),
(92390,'enUS','Why does this make so much noise? What is this thing\'s purpose?','',26124),
(92391,'enUS','I will fight by your side.','I will fight by your side.',26124),
(92392,'enUS','Hopefully that was enough to deter them. Let\'s report in to the prince.','Hopefully that was enough to deter them. Let\'s report in to the prince.',26124),
(92393,'enUS','%s laughs heartily.','',26124),
(92394,'enUS','Yes, good thinking. Perhaps a few comparable items are all I need to jog my failing memory.','',26124),
(92395,'enUS','','Enough of this! The Tidestone will be ours!',26124),
(92402,'enUS','The Amorphic Cognitor\'s evolution fades away. You feel the parasite resume its precarious position atop your head.','The Amorphic Cognitor\'s evolution fades away. You feel the parasite resume its precarious position atop your head.',26124),
(92403,'enUS','Ahahaha! We are Legion. We know you, Allari, and you, $p. You will be ours.','',26124),
(92411,'enUS','We have seen all you can show us, we will seek another to show us more.','',26124),
(92412,'enUS','Placeholder Text','Placeholder Text',26124),
(92413,'enUS','Placeholder Text','Placeholder Text',26124),
(92414,'enUS','Placeholder Text','Placeholder Text',26124),
(92415,'enUS','','Tell us everything you know, foul creature!',26124),
(92416,'enUS','','Come, $c, we are going to compel some demon souls.',26124),
(92417,'enUS','You can mank my dook, Ooka. I\'m taking the chow and there\'s nothing you can ookin do about it, wicket licker.','You can mank my dook, Ooka. I\'m taking the chow and there\'s nothing you can ookin do about it, wicket licker.',26124),
(92418,'enUS','','What did you ookin say?!',26124),
(92419,'enUS','We have chosen... poorly. We shall find another host.','',26124),
(92421,'enUS','A stranger approaches!','',26124),
(92442,'enUS','This is the prince\'s palace. Let\'s finish off those naga before we return.','This is the prince\'s palace. Let\'s finish off those naga before we return.',26124),
(92443,'enUS','Stay close, $n. Do not leave my side.','',26124),
(92444,'enUS','$p? Where are you going?','',26124),
(92445,'enUS','Please stay close, $p.','',26124),
(92446,'enUS','I cannot do this on my own. Stay with me.','',26124),
(92447,'enUS','Where are you?','',26124),
(92448,'enUS','I am truly sorry.','',26124),
(92540,'enUS','Where is the Tidestone?!','',26124),
(92541,'enUS','Give usss the Tidesssstone!','',26124),
(92545,'enUS','','The Illidari are the first and last defense against the Burning Legion.',26124),
(92547,'enUS','Let\'s see what you have.','Let\'s see what you have.',26124),
(92550,'enUS','I should be out there fighting. The best use for my hands are wrapped around the neck of a demon.','',26124),
(92551,'enUS','Bind me. I might be here a while.','Bind me. I might be here a while.',26124),
(92552,'enUS','','$p, break the first soul gem and release a demon soul.',26124),
(92556,'enUS','Get out of here. I don\'t want to see you again!','',26124),
(92557,'enUS','You\'ll hand over the fighter chow now if you know what\'s good for you.','You\'ll hand over the fighter chow now if you know what\'s good for you.',26124),
(92565,'enUS','Bring the Constructs back here.','Bring the Constructs back here.',26124),
(92566,'enUS','Summon Constructs?','Summon Constructs?',26124),
(92592,'enUS','Those eggs will provide the perfect balance of texture and arcane power my cocktail needs.','',26124),
(92593,'enUS','This will be the one they remember me by.','',26124),
(92594,'enUS','Now for the finishing touches.','',26124),
(92595,'enUS','Your instructors should be down the ramp to the west. You\'d better hurry, before the second bell rings!','',26124),
(92596,'enUS','Bottoms up.','',26124),
(92597,'enUS','Uh oh!','',26124),
(92598,'enUS','','Garuhod? He exploded!',26124),
(92599,'enUS','','First, a simple arcane rune. Trace its outline with your steps. Memorize it. Commit its intricacies to memory.',26124),
(92600,'enUS','','Well done. Now, we will trace a fire rune. Be careful: incorrectly drawing this rune can result in instant, painful death.',26124),
(92601,'enUS','','Excellent! Finally, a frost rune. Don\'t forget the fifth circle! Everybody always forgets the fifth circle.',26124),
(92602,'enUS','','That will do for today.',26124),
(92603,'enUS','Gift of the Earth','',26124),
(92604,'enUS','','Ready... fire!',26124),
(92605,'enUS','','Aim carefully, and fire!',26124),
(92606,'enUS','','Line up your wand, and fire!',26124),
(92607,'enUS','','Fire!',26124),
(92608,'enUS','','Shoot!',26124),
(92609,'enUS','','Fire at will!',26124),
(92610,'enUS','','You may fire when ready.',26124),
(92611,'enUS','','Ready, aim, fire!',26124),
(92612,'enUS','','Well done!',26124),
(92613,'enUS','','Excellent hit!',26124),
(92614,'enUS','','Spectacular!',26124),
(92615,'enUS','','Fantastic.',26124),
(92616,'enUS','','You\'ve been studying, I see.',26124),
(92617,'enUS','','Impeccable aim, as usual.',26124),
(92618,'enUS','','Perfect.',26124),
(92619,'enUS','','Good form.',26124),
(92620,'enUS','','No, no, no! Your aim is all off!',26124),
(92621,'enUS','','Come on, focus!',26124),
(92622,'enUS','','Gah... pay attention!',26124),
(92623,'enUS','','<Sigh...>',26124),
(92624,'enUS','','You\'ll have to do better than that.',26124),
(92625,'enUS','','No. We will try it again.',26124),
(92626,'enUS','','Still needs work.',26124),
(92627,'enUS','','Unacceptable.',26124),
(92628,'enUS','','Your turn.',26124),
(92629,'enUS','','Now it is your turn.',26124),
(92630,'enUS','','Now, you try.',26124),
(92631,'enUS','','Next student.',26124),
(92632,'enUS','For Gul\'dan! For the Legion!','',26124),
(92633,'enUS','For... Gul\'dan...','',26124),
(92634,'enUS','$b','',26124),
(92635,'enUS','Zzz... no, Headmistress! Not the paddle... zzzz....','Zzz... no, Headmistress! Not the paddle... zzzz....',26124),
(92636,'enUS','Just five more minutes...','Just five more minutes...',26124),
(92637,'enUS','Abjuration, Conjuration, Divination, Necromancy...','Abjuration, Conjuration, Divination, Necromancy...',26124),
(92638,'enUS','<sigh>... I feel like I\'ve been reading this same scroll for ten thousand years, and I STILL don\'t understand it.','<sigh>... I feel like I\'ve been reading this same scroll for ten thousand years, and I STILL don\'t understand it.',26124),
(92639,'enUS','I hope everything went alright in there.','I hope everything went alright in there.',26124),
(92643,'enUS','YAEGER-367 SYSTEMS INITIATED. SECOND PILOT REQUIRED TO BEGIN PROGRAM.','YAEGER-367 SYSTEMS INITIATED. SECOND PILOT REQUIRED TO BEGIN PROGRAM.',26124),
(92644,'enUS','MISSION INITIATED. DESTINATION COORDINATES RETRIEVED.','MISSION INITIATED. DESTINATION COORDINATES RETRIEVED.',26124),
(92645,'enUS','PROGRAM COMMENCING. AUTO-DRIFT ENGAGE.','PROGRAM COMMENCING. AUTO-DRIFT ENGAGE.',26124),
(92646,'enUS','RIFT DETECTED 1000 METERS AHEAD. MANUAL PILOT MODE INITIATED.','RIFT DETECTED 1000 METERS AHEAD. MANUAL PILOT MODE INITIATED.',26124),
(92647,'enUS','Search high and low! Turn the ruins to rubble!','',26124),
(92648,'enUS','The Tidestone will be ours!','',26124),
(92649,'enUS','PILOT SYNCHRONIZATION REQUIRED. AWAITING MOVEMENT ORDERS.','PILOT SYNCHRONIZATION REQUIRED. AWAITING MOVEMENT ORDERS.',26124),
(92650,'enUS','HOSTILE TARGET DETECTED.','HOSTILE TARGET DETECTED.',26124),
(92651,'enUS','NEW MISSION: ELIMINATE ENEMY.','NEW MISSION: ELIMINATE ENEMY.',26124),
(92652,'enUS','MISSION SUCCESSFUL. RETURN SEQUENCE INTITIATED.','MISSION SUCCESSFUL. RETURN SEQUENCE INTITIATED.',26124),
(92653,'enUS','COMMENCING SHUTDOWN AND RETURN SEQUENCE.','COMMENCING SHUTDOWN AND RETURN SEQUENCE.',26124),
(92654,'enUS','','I carry the finest selection of wines you\'ve ever seen.',26124),
(92655,'enUS','','Oh look, \"nope\" and \"not a chance\" overlap right where you\'re standing.',26124),
(92656,'enUS','WARNING: PILOT EJECTED. SHUTDOWN SEQUENCE INITIATED.','WARNING: PILOT EJECTED. SHUTDOWN SEQUENCE INITIATED.',26124),
(92657,'enUS','WARNING: NO INPUT DETECTED. COMMENCING AUTOMATIC SHUTDOWN SEQUENCE.','WARNING: NO INPUT DETECTED. COMMENCING AUTOMATIC SHUTDOWN SEQUENCE.',26124),
(92662,'enUS','A quest accept event fires at this point.','A quest accept event fires at this point.',26124),
(92663,'enUS','A quest completion event fires at this point.','A quest completion event fires at this point.',26124),
(92664,'enUS','Cut down the intruder!','Cut down the intruder!',26124),
(92665,'enUS','We are the Iron Horde! We will never be defeated!','We are the Iron Horde! We will never be defeated!',26124),
(92666,'enUS','Kill them all, leave no survivors!','Kill them all, leave no survivors!',26124),
(92667,'enUS','Lok\'tar ogar!','Lok\'tar ogar!',26124),
(92668,'enUS','I\'ll take your head for a trophy!','I\'ll take your head for a trophy!',26124),
(92669,'enUS','Our will is Iron!','Our will is Iron!',26124),
(92670,'enUS','It looks like this is where Val Goldspade\'s hunt for Gutrek\'s Cleaver came to an end.','It looks like this is where Val Goldspade\'s hunt for Gutrek\'s Cleaver came to an end.',26124),
(92671,'enUS','Search the orc for clues','Search the orc for clues',26124),
(92672,'enUS','Take me to the Iron Docks.','Take me to the Iron Docks.',26124),
(92673,'enUS','Heating','Heating',26124),
(92674,'enUS','Forging','Forging',26124),
(92675,'enUS','Quenching','Quenching',26124),
(92676,'enUS','Arise my lovelies, it\'s feeding time!','',26124),
(92677,'enUS','My pets are so hungry.','',26124),
(92678,'enUS','You\'ll make an excellent treat.','',26124),
(92679,'enUS','You\'ll never take my pets from me!','',26124),
(92680,'enUS','Try not to scream, my pets are sleeping.','',26124),
(92681,'enUS','Shhhhh, sleep now my precious.','',26124),
(92682,'enUS','You\'re so adorable when you\'re sleeping.','',26124),
(92683,'enUS','I won\'t let anything bad happen to you again, little one.','',26124),
(92684,'enUS','Return to the Start Banner!','Return to the Start Banner!',26124),
(92685,'enUS','You want my blade, little $c?','',26124),
(92686,'enUS','How bout I plant it in your little skull!','',26124),
(92687,'enUS','You are a fool for coming here, mortals. All of your accomplishments... all the foes you\'ve struck down... all mean nothing here.','',26124),
(92688,'enUS','Feast, my minions. Bring me the Ashbringer.','',26124),
(92689,'enUS','Your schemes are through, demon. We\'ve come to destroy you once and for all.','',26124),
(92690,'enUS','I\'ve had enough of your meddling. This ends now.','',26124),
(92691,'enUS','We stand together, champion.','',26124),
(92692,'enUS','In this book are catalogued notes of your past relic hunts.\n\nIf at any point you happen to lose your way, you can consult these notes to pick up where you\'ve left off.','',26124),
(92694,'enUS','<The great dragon pulls in ragged breaths. He is in pain.>','',26124),
(92695,'enUS','I\'m here! Oh what\'s this?','I\'m here! Oh what\'s this?',26124),
(92696,'enUS','Hero... the Ashbringer... it is the only way... take it!','',26124),
(92697,'enUS','You dare to come into my port and kill my soldiers? Come, face me and learn the might of the Iron Horde!','',26124),
(92702,'enUS','Do you grunts have no pride? Train harder or I\'ll throw your worthless hides into the bay!','',26124),
(92703,'enUS','Gul\'dan will not tolerate weakness!','',26124),
(92704,'enUS','I swear that if you don\'t improve I\'ll make sure you peons will never obtain Gul\'dan\'s blessing!','',26124),
(92705,'enUS','You\'re not trying hard enough. Half rations until you get it together!','',26124),
(92706,'enUS','Togg, next time you use da forge, remember to hammer da blade while it still nice and hot. \n\nIf you put da blade in da water before you hammer it, it just gonna break again.','',26124),
(92707,'enUS','Time: $1i tolls','',26124),
(92708,'enUS','Did that dying lizard and his brood send you? I shall not be bound again!','',26124),
(92709,'enUS','You call that a trident swing?','',26124),
(92710,'enUS','Learn to fight you weakling water worms.','',26124),
(92711,'enUS','Keep that trident up you lazy sea snakes.','',26124),
(92712,'enUS','So, the surface-dweller seeks to fly upon the golden wings of Rukhmar?','',26124),
(92713,'enUS','A pity that you arrived too late. Now you must be punished for your insolence!','',26124),
(92714,'enUS','Rukhmar\'s gifts belong to the Arakkoa!','',26124),
(92715,'enUS','Take me back to the garrison.','Take me back to the garrison.',26124),
(92716,'enUS','The iron siegeworks. We could steal some of their cannons.','',26124),
(92717,'enUS','The Iron Horde cowers behind their walls.','',26124),
(92718,'enUS','There is a harbor there. Could we commandeer any boats?','',26124),
(92719,'enUS','The Iron Docks... yes, your earlier assault put it out of commission.','',26124),
(92720,'enUS','Use the |cFFE86B17|Hspell:179576|h[Net]|h|r to stop Tremor\'s submerge!','Use the |cFFE86B17|Hspell:179576|h[Net]|h|r to stop Tremor\'s submerge!',26124),
(92721,'enUS','','You have some nerve showing your face around here.',26124),
(92726,'enUS','','For the Queen!',26124),
(92727,'enUS','','We will claim the Tidestone and there is nothing you can do to stop us!',26124),
(92728,'enUS','','Azshara\'s wrath will drown you.',26124),
(92729,'enUS','','Have you come to drown?',26124),
(92730,'enUS','For Nazjatar!','',26124),
(92731,'enUS','Your bones will sharpen my trident.','',26124),
(92732,'enUS','You dare stand against us?','',26124),
(92733,'enUS','%s sheds the net in which it was entangled!','%s sheds the net in which it was entangled!',26124),
(92735,'enUS','The bomb has been planted. Stand clear!','',26124),
(92736,'enUS','3','',26124),
(92737,'enUS','2','',26124),
(92738,'enUS','1','',26124),
(92739,'enUS','I will lead the diversion on the western gates and draw the Iron Horde forces to me. This will give you and Draka enough time to establish a base of operations on their flank.','',26124),
(92740,'enUS','Let us begin the invasion.','Let us begin the invasion.',26124),
(92741,'enUS','','You have no game tokens. Get at least one and then come back to me.',26124),
(92742,'enUS','The prisoners are breaking free!','',26124),
(92743,'enUS','It\'s an uprising!','',26124),
(92744,'enUS','Alright boys, this dock isn\'t going to clear itself! Get to work!','',26124),
(92745,'enUS','','I see that you\'re ready to race! Well step right up and we\'ll get you started.',26124),
(92746,'enUS','True wisdom can only be reached when we focus as one.\n\nIt is then that the path will be opened.','',26124),
(92747,'enUS','Commander, what do you suggest?','',26124),
(92748,'enUS','Many would die in a direct assault.','',26124),
(92749,'enUS','You look like you have another plan, Commander. A feint perhaps?','',26124),
(92750,'enUS','The waters are mined, and there are more soldiers than supplies there.','',26124),
(92751,'enUS','Yes, but no shipbuilding materials. I think the commander is looking for a naval strategy.','',26124),
(92752,'enUS','A shipyard. We could use the abandoned equipment there.','',26124),
(92753,'enUS','Genius, commander! We\'ll sail around Tanaan and hit the Iron Horde from the sea where they least expect it.','',26124),
(92754,'enUS','This appears to be the altar the ogres use to place offerings for the ancient rylaks. The bones of previous meals lay scattered about.\n\nIf you can find a proper offering, perhaps you could lure one of the rylaks down. \n\nThe bones may provide some clue as to what they would eat...','',26124),
(92755,'enUS','Place offering of raw clefthoof meat.','Place offering of raw clefthoof meat.',26124),
(92756,'enUS','','This Real Big Race will reopen every 15 minutes. Be ready!',26124),
(92757,'enUS','','The Real Big Race will reopen in 1 minute!',26124),
(92758,'enUS','','The Real Big Race will reopen any second! Good luck!',26124),
(92759,'enUS','You are like the wind!','You are like the wind!',26124),
(92760,'enUS','I\'ll take care of this, commander.','I\'ll take care of this, commander.',26124),
(92761,'enUS','','Maraad would\'ve argued for a direct assault on the gates. But how could we hope to succeed?',26124),
(92762,'enUS','','The rangari report that very little equipment remains for us to steal.',26124),
(92763,'enUS','','The orcs left behind some siege equipment here, at the Iron Siegeworks.',26124),
(92764,'enUS','','But heavy equipment remains. Enough to commandeer a ship!',26124),
(92765,'enUS','','The Iron Horde has regrouped behind fortified walls.',26124),
(92766,'enUS','Commander, what do you suggest?','',26124),
(92767,'enUS','The Iron Horde cowers behind their walls.','',26124),
(92768,'enUS','The Thunderlord sage didn\'t make it very far through Magnarok. Hopefully he still possesses some useful information...','',26124),
(92769,'enUS','The Light watches over us all, friend.','',26124),
(92770,'enUS','After you, $n. Your presence is of the utmost importance.','',26124),
(92771,'enUS','Rest in peace, brother... we will never forget the events of the Broken Shore.','',26124),
(92772,'enUS','Under Malygos\' command, these blue scaled beasts killed my friends, my family, and my wife.$b$bDo what you must with me, but know that I will never stop hunting them until they share the pain I feel.','',26124),
(92773,'enUS','I... I remember you. From Northrend. You helped me interrogate the foul minions of these blue scaled beasts.$b$bUnder Malygos\' command, they killed my friends, my family, and my wife, simply because they disagreed with our use of magic.$b$bDo what you must with me, but know that I will never stop hunting them until they share the pain I feel.','',26124),
(92774,'enUS','Let him live.','Let him live.',26124),
(92775,'enUS','Finish him.','Finish him.',26124),
(92776,'enUS','Test line!','Test line!',26124),
(92777,'enUS','No! I must be allowed to end these creatures! I will have my revenge!','',26124),
(92778,'enUS','I will make your kind PAY for what you did in Northrend!','',26124),
(92779,'enUS','You blue-scaled lizard-breaths slew many of my friends in Northrend!','',26124),
(92780,'enUS','This is a fortified high-security bastion. Only a fool would go into there without an army.$b$bI mean... good luck, Champion.$b$b<Khadgar gives you a comforting pat on the shoulder.>','',26124),
(92781,'enUS','Compassion? It has been so long since I have known that. I will remember this, $r.','',26124),
(92782,'enUS','%s is sounding the alarm!','%s is sounding the alarm!',26124),
(92783,'enUS','Alarms sound! You\'ve been caught!','',26124),
(92784,'enUS','','Tirion said you would come. Is it time?',26124),
(92785,'enUS','Yes, it is time. We leave immediately.','Yes, it is time. We leave immediately.',26124),
(92786,'enUS','','I am with you, $n. ((Liadrin runs outside))',26124),
(92787,'enUS','This way!','',26124),
(92788,'enUS','You\'re safe. I\'ve got you.','',26124),
(92789,'enUS','That was close. You should be more careful.','',26124),
(92790,'enUS','Whoa now! I nearly didn\'t get you out in time.','',26124),
(92791,'enUS','Let the youthful one approach. I am not as dead as I look.','',26124),
(92792,'enUS','Forgive my granddaughters. They think they need to protect me from every $r $c that stumbles through my pools.$b$bGo on, then.','',26124),
(92793,'enUS','<Place your hand upon Senegos\' horn.>','<Place your hand upon Senegos\' horn.>',26124),
(92794,'enUS','','Rest now, grandfather! You must save your energy.',26124),
(92795,'enUS','Don\'t be so eager to mourn, starlight. Give me this one last adventure.','',26124),
(92796,'enUS','We should return to grandfather.','',26124),
(92797,'enUS','Let\'s get back to Azurewing Repose!','Let\'s get back to Azurewing Repose!',26124),
(92798,'enUS','<Before you stands... not Senegos himself, but a magical projection of him. He appears strong, confident, and cheerful. This is not the decaying dragon you saw languishing in a pool.>','',26124),
(92799,'enUS','<As you approach the ravager, a high-pitched, chittering voice echoes in your mind.>\n\nYou drink the seeing juice, and now you speak! You must be friend of the skull-head. \n\nYou here to take skulls too?','',26124),
(92800,'enUS','Can you take me to Skulltaker?','Can you take me to Skulltaker?',26124),
(92801,'enUS','Avoid the darkness, friend. Your mind-sight is fragile.','',26124),
(92802,'enUS','You have skulls? Gu\'rakh can carry all skulls!','',26124),
(92803,'enUS','Friend want Gu\'rakh. Can take you to high place.','',26124),
(92804,'enUS','Follow us. We show!','',26124),
(92805,'enUS','Wrong way, two-leg! Turn around!','',26124),
(92806,'enUS','Friend brings more skulls to pick clean?','',26124),
(92807,'enUS','Do not stray, friend. The ground-walkers will lead the way.','',26124),
(92808,'enUS','Gu\'rakh very close! Take all the skulls!','',26124),
(92813,'enUS','So, this one wishes to find the Skulltaker?','',26124),
(92814,'enUS','Very well, I will bring you to him.','',26124),
(92815,'enUS','Take care, $C, lest it be your skull that is taken.','',26124),
(92816,'enUS','Show me what contracts are available.','Show me what contracts are available.',26124),
(92817,'enUS','I seek the seeker.','I seek the seeker.',26124),
(92818,'enUS','Come one, come all, and witness history in the making! Today we have an exhibition match in the the bloodiest place in Draenor, the Ring of Blood! We have a real treat for you today. $n and their friends will take on Mogor\'s newest, exclusive find. Ousted from Highmaul, completely blind but with a special sense for magic, it\'s the one and only Nullifier Darkoor!','',26124),
(92819,'enUS','Let the exhibition match BEGIN!','',26124),
(92820,'enUS','WHAT YOU CALL ME?!','',26124),
(92821,'enUS','Hm, not bad. Take your prize from my coffer. You live... for now.','',26124),
(92822,'enUS','[PH] I NEED TEXT','[PH] I NEED TEXT',26124),
(92823,'enUS','I\'m ready to leave when you are, $n.','',26124),
(92824,'enUS','Then let us make haste.','Then let us make haste.',26124),
(92825,'enUS','Very good. I will meet you at the Highlord. ((Gryan runs outside))','',26124),
(92826,'enUS','No. NO! I will tolerate no more setbacks!','',26124),
(92827,'enUS','Kaboom!','',26124),
(92828,'enUS','Brewing Elixir','Brewing Elixir',26124),
(92829,'enUS','I will meet you outside and prepare our mounts. I formed the Order of the Silver Hand to defeat the Burning Legion - this will be its first charge.((Tirion walks outside))','',26124),
(92830,'enUS','Free the outcasts from their shackles, the Labormasters will definitely have keys.','Free the outcasts from their shackles, the Labormasters will definitely have keys.',26124),
(92831,'enUS','Guide freed Outcasts to the safety of the Darkscryers. Their morale will be added to your progress.','Guide freed Outcasts to the safety of the Darkscryers. Their morale will be added to your progress.',26124),
(92832,'enUS','Kills made with freed Arakkoa Outcasts in tow will increase their morale. Morale is added to your progress when you guide the freed Arakkoa Outcasts to safety.','Kills made with freed Arakkoa Outcasts in tow will increase their morale. Morale is added to your progress when you guide the freed Arakkoa Outcasts to safety.',26124),
(92833,'enUS','If a freed Arakkoa Outcast expires before being led to safety its morale will be lost.','If a freed Arakkoa Outcast expires before being led to safety its morale will be lost.',26124),
(92834,'enUS','Higher morale scores will greatly increase your progress when the Arakkoa Outcast is led to safety.','Higher morale scores will greatly increase your progress when the Arakkoa Outcast is led to safety.',26124),
(92835,'enUS','You are afflicted with |TInterface\\Icons\\Spell_Shadow_ChillTouch.blp:20|t |cFFFF0404|Hspell:179977|h[Touch of Doom]|h|r!','You are afflicted with |TInterface\\Icons\\Spell_Shadow_ChillTouch.blp:20|t |cFFFF0404|Hspell:179977|h[Touch of Doom]|h|r!',26124),
(92836,'enUS','Stay close to Garona, and stay out of sight!','',26124),
(92837,'enUS','I will teleport you out of there if you get into trouble.','',26124),
(92838,'enUS','','Discipline is lax. Your campaign against the Iron Horde is wearing them down.',26124),
(92839,'enUS','','Bleeding Hollow scavengers. We should crush them before they threaten our supply lines.',26124),
(92840,'enUS','','What was THAT?',26124),
(92841,'enUS','','Grrr! We were almost through.',26124),
(92842,'enUS','','Bah! We can do better.',26124),
(92843,'enUS','Hiding','Hiding',26124),
(92844,'enUS','','We\'re ready when you are, Highlord.',26124),
(92845,'enUS','','Gul\'dan\'s thugs are up to something. I do not know what they are planning so near the Dark Portal, but they are in the way.',26124),
(92846,'enUS','','Jackpot! Iron Horde plans and papers...',26124),
(92847,'enUS','','Grommash ordered a full retreat behind the walls of Tanaan.',26124),
(92848,'enUS','','Interesting. The Bleeding Hollow clan are showing signs of insubordination. Perhaps the Iron Horde is falling apart?',26124),
(92849,'enUS','We will leave on your command, friend.','',26124),
(92850,'enUS','[[Spectacular Cinematic of Gul\'dan Being a BOSS!]]','[[Spectacular Cinematic of Gul\'dan Being a BOSS!]]',26124),
(92851,'enUS','Bah, these cannons are WORTHLESS! Face our latest creation, the Fel Orc!','',26124),
(92852,'enUS','The Legion thinks we are finished. We will show them how wrong they are.','',26124),
(92853,'enUS','','After you, $n. Your presence is of the utmost importance.',26124),
(92854,'enUS','Entering','Entering',26124),
(92855,'enUS','Ahh, my friend. My good, dependable friend $n.$b$bYou wouldn\'t happen to have any mana crystals on you, would you?$b$bListen, my friend. If you ever need anything - I stress, ANYTHING - you just come talk to your loyal friend Runas. I will make your problems go away. You can count on me.$b$bOf course, if I needed something, I assume you would assist me, correct? For example, if I needed a mana crystal or something similar, you would give me one?','',26124),
(92856,'enUS','Just... just lead the way, Runas.','Just... just lead the way, Runas.',26124),
(92857,'enUS','The Warchief does not want to see you.','',26124),
(92858,'enUS','Come, Warlock. Show us what you\'ve got.','',26124),
(92859,'enUS','He doesn\'t have a choice.','',26124),
(92860,'enUS','Gul\'dan has only grown in power since our last encounter. He must still have contact with the Burning Legion. Stopping him is more important than ever.','',26124),
(92861,'enUS','','Over here, commander!',26124),
(92862,'enUS','','This be a prime spot. We can see for miles. Plant your banner, commander.',26124),
(92863,'enUS','','We on our way!',26124),
(92864,'enUS','You need a Darkmoon Game Token to start the race!','You need a Darkmoon Game Token to start the race!',26124),
(92865,'enUS','-1 Darkmoon Game Token','-1 Darkmoon Game Token',26124),
(92866,'enUS','Bonus Objective Unlocked!\n|TINTERFACE\\GLUES\\CREDITS\\CrystalSong1TGA1.blp:64|t|TINTERFACE\\GLUES\\CREDITS\\CrystalSong1TGA2.blp:64|t|TINTERFACE\\GLUES\\CREDITS\\CrystalSong1TGA3.blp:64|t\n|TINTERFACE\\GLUES\\CREDITS\\CrystalSong1TGA5.blp:64|t|TINTERFACE\\GLUES\\CREDITS\\CrystalSong1TGA6.blp:64|t|TINTERFACE\\GLUES\\CREDITS\\CrystalSong1TGA7.blp:64|t\n|cFFFFFFFFLey-Ruins of Zarkhenar|r','',26124),
(92867,'enUS','What in blazes are you doing?','',26124),
(92868,'enUS','Don\'t you know who I am?','',26124),
(92869,'enUS','I surrender. Please, my friend, forgive me. I am truly, truly sorry.','',26124),
(92870,'enUS','Feeding on such raw energy... it clouds my judgment.','',26124),
(92871,'enUS','I hope you can see beyond my tattered robes and desperate behavior. I am not a monster.','',26124),
(92872,'enUS','You go on, my friend. I will stay here.','',26124),
(92873,'enUS','Thank you, my friend, for letting my last few hours mean something.','',26124),
(92874,'enUS','Watch. I shall prove it to you. I am not just some mana-addled FREAK, like the rest of those wretches.','',26124),
(92875,'enUS','Ooh, look! Mana crystal! Just a taste.','',26124),
(92876,'enUS','I think... perhaps it is time to say goodbye, then.','',26124),
(92877,'enUS','Quite an impressive weapon, my friend!','',26124),
(92878,'enUS','I... I can not see you anymore.','',26124),
(92879,'enUS','Who is this?','',26124),
(92880,'enUS','I am called Runas, son of Indarril, formerly of Suramar. Pleased to make your acquaintance.','',26124),
(92881,'enUS','Nightfallen. I do not trust you and your kind.','',26124),
(92882,'enUS','I understand, good dragon. My people have earned your distrust. Allow me to make amends.','',26124),
(92883,'enUS','Very good! Off to Zarkhenar, then. Off to see all my friends and family and loved ones.','',26124),
(92884,'enUS','...to kill them, of course, for harming your dragon.','',26124),
(92885,'enUS','Bunch of mana addicts, that lot, ha hah! Not me, though. My discipline is iron.','',26124),
(92886,'enUS','Ooh! Mana crystal. Just a moment.','',26124),
(92887,'enUS','So... why are you here in Azsuna, friend? Just visiting, or...?','',26124),
(92888,'enUS','Does this one ever stop talking?','',26124),
(92889,'enUS','My apologies, good dragon. Ahh, look! We are here.','',26124),
(92890,'enUS','This hunger is consuming my very mind. It is taking every ounce of my energy to just... just...','',26124),
(92891,'enUS','','Not like this...',26124),
(92892,'enUS','','Another one down.',26124),
(92893,'enUS','','Swift and silent...',26124),
(92894,'enUS','','I love the hunt!',26124),
(92895,'enUS','','You\'re finished.',26124),
(92896,'enUS','','The hunt begins!',26124),
(92897,'enUS','','Leave this one to me.',26124),
(92898,'enUS','','You\'ve come to the wrong house, puppet.',26124),
(92899,'enUS','','Any last words?',26124),
(92900,'enUS','','I am all yours, commander.',26124),
(92901,'enUS','','Who\'s next...?',26124),
(92902,'enUS','','Give me a target, commander. I am ready for anything.',26124),
(92903,'enUS','','None can oppose us! Not Gul\'dan, not the Shadow Council, not even the Legion itself.',26124),
(92904,'enUS','','I cannot thank you enough for what you and Khadgar have done for me. I am yours to command.',26124),
(92905,'enUS','|TInterface\\Icons\\inv_blacksmithdye_black.blp:20|t %s dropped |cFFFF0000|Hspell:180147|h[Felfire Munitions]|h|r.','|TInterface\\Icons\\inv_blacksmithdye_black.blp:20|t %s dropped |cFFFF0000|Hspell:180147|h[Felfire Munitions]|h|r.',26124),
(92906,'enUS','We must find a way to break into Tanaan again!','',26124),
(92907,'enUS','','I long to spill the blood of our foes, but I can be patient when I need to.',26124),
(92908,'enUS','Those walls boss... and those orcs in the way... woo boy!','',26124),
(92909,'enUS','If there\'s anyone that can crack this nut, its you, commander.','',26124),
(92910,'enUS','They just leave this stuff laying around? Sweet!','They just leave this stuff laying around? Sweet!',26124),
(92911,'enUS','I\'ll have this outta here in a jiffy, boss!','I\'ll have this outta here in a jiffy, boss!',26124),
(92912,'enUS','','$C, the Burning Legion is sending the most powerful demons in its arsenal against us. They do not intend to lose this third war and they will stop at nothing to see to it that we are all wiped from the face of Azeroth.\n\nWe will return the favor.',26124),
(92913,'enUS','','Looters are not welcome here! This belongs to the Iron Horde!',26124),
(92914,'enUS','','It... makes... no difference...',26124),
(92915,'enUS','','This is Iron Horde property! You will pay for trying to take it!',26124),
(92916,'enUS','','Hate you... hate you all...',26124),
(92917,'enUS','This\'ll be quite tha siege, commander!','',26124),
(92918,'enUS','We are ready to put an end to this commander, no matter the cost.','',26124),
(92919,'enUS','I understand the need to defeat this foe, but my heart breaks for the lives it will take from us.','',26124),
(92920,'enUS','','I prefer to go around such problems, and I think you do too, commander.',26124),
(92921,'enUS','','I\'m still unfamiliar with such strategy, such numbers. We must do our best to minimize casualties, our soldiers deserve better.',26124),
(92922,'enUS','','Just give me a moment...',26124),
(92923,'enUS','These will help immensely, commander.','These will help immensely, commander.',26124),
(92924,'enUS','This is a great find, commander!','This is a great find, commander!',26124),
(92925,'enUS','I\'d like to fight Skull Chewer.','I\'d like to fight Skull Chewer.',26124),
(92926,'enUS','I\'d like to fight Fracktus.','I\'d like to fight Fracktus.',26124),
(92927,'enUS','I\'d like to fight Rotvine.','I\'d like to fight Rotvine.',26124),
(92928,'enUS','I\'d like to fight Dreshax.','I\'d like to fight Dreshax.',26124),
(92929,'enUS','I\'d like to fight the champion.','I\'d like to fight the champion.',26124),
(92930,'enUS','You\'ll have to hold on a minute, pal. I can\'t start the next fight until this one\'s finished.$B$BI may be a profiteering heartless fight promoter leading countless innocents to their untimely deaths, but I have a conscience for coin\'s sake.','',26124),
(92931,'enUS','','How strange that Gul\'dan\'s Horde has all but abandoned this area. I was expecting more of a fight.',26124),
(92932,'enUS','','The Bleeding Hollow are running rampant out here. Where is their leadership?',26124),
(92933,'enUS','','What foul magic was that warlock cooking up? I think I preferred fighting Iron Horde cannons!',26124),
(92934,'enUS','','I take back what I said about cannons. We\'ll have to fight our way through.',26124),
(92935,'enUS','Here\'s your share of the winnings, champ!','',26124),
(92936,'enUS','Drawing Power','Drawing Power',26124),
(92937,'enUS','They did... things... to me.','',26124),
(92938,'enUS','I didn\'t give in.','',26124),
(92939,'enUS','The demons promised us unimaginable power.','',26124),
(92940,'enUS','A warden tried to convince us to turn traitor. I heard screaming.','',26124),
(92941,'enUS','Cyana Nightglaive turned traitor. She joined the Legion.','',26124),
(92942,'enUS','Nightglaive went southwest with a warden named Cordana Felsong.','',26124),
(92943,'enUS','All will be consumed in my flames!','',26124),
(92944,'enUS','|TInterface\\Icons\\ability_fixated_state_purple:20|t%s |cFFFF0404|Hspell:180148|h[Fixates]|h|r on you!','|TInterface\\Icons\\ability_fixated_state_purple:20|t%s |cFFFF0404|Hspell:180148|h[Fixates]|h|r on you!',26124),
(92945,'enUS','Graaah, and who do YOU think you are?','',26124),
(92946,'enUS','Give yourselves to the shadow. None can resist the master.','',26124),
(92947,'enUS','All must serve or DIE.','',26124),
(92948,'enUS','You will not leave this cave alive!','',26124),
(92949,'enUS','Throw the corpse to the felhounds, hah hah hah!','',26124),
(92950,'enUS','Take me to the Iron Front.','Take me to the Iron Front.',26124),
(92951,'enUS','','Watch yourself, champion. The Shadow Council will prey on your doubts and weaknesses.',26124),
(92952,'enUS','Play \"Ironforge\"','Play \"Ironforge\"',26124),
(92953,'enUS','Play \"Cold Mountain\"','Play \"Cold Mountain\"',26124),
(92954,'enUS','Play \"Night Song\"','Play \"Night Song\"',26124),
(92955,'enUS','','I can feel the dark energy surrounding you. What IS that thing?',26124),
(92956,'enUS','Play \"Gnomeregan\"','Play \"Gnomeregan\"',26124),
(92957,'enUS','Play \"Tinkertown\"','Play \"Tinkertown\"',26124),
(92958,'enUS','Play \"Exodar\"','Play \"Exodar\"',26124),
(92959,'enUS','Play \"Curse of the Worgen\"','Play \"Curse of the Worgen\"',26124),
(92960,'enUS','Play \"Way of the Monk\"','Play \"Way of the Monk\"',26124),
(92961,'enUS','Play \"Song of Liu Lang\"','Play \"Song of Liu Lang\"',26124),
(92962,'enUS','Play \"Angelic\"','Play \"Angelic\"',26124),
(92963,'enUS','Play \"Ghost\"','Play \"Ghost\"',26124),
(92964,'enUS','Play \"Jungle.\"','Play \"Jungle.\"',26124),
(92965,'enUS','Play \"Magic\"','Play \"Magic\"',26124),
(92966,'enUS','Play \"The Black Temple\"','Play \"The Black Temple\"',26124),
(92967,'enUS','Play \"Invincible\"','Play \"Invincible\"',26124),
(92968,'enUS','Play \"Bronze Jam.\"','Play \"Bronze Jam.\"',26124),
(92969,'enUS','These new fel orcs fight hard. This will not be over soon...','',26124),
(92970,'enUS','We began our siege the moment you took the boats. We fought cautiously until a large contingent of Iron Horde left, probably to face you. That is when we truly struck!$b$bYour Gazlowe fashioned a terrible device to destroy the gates and we charged through... only to be met with this new foe... the fel orcs. They have managed to stop our advance and keep us here. I hope you are having better luck in the east.','',26124),
(92971,'enUS',';p;','',26124),
(92972,'enUS','What\'s the situation?','What\'s the situation?',26124),
(92973,'enUS','Eating','Eating',26124),
(92974,'enUS','Kaz said I could help! This place is so cool!$b$bI can tell you about Zeth\'Gol to the northwest, the Temple of Sha\'naar to the south, and the Zorammarsh to the southeast.','',26124),
(92975,'enUS','Uh okay... so what do you have for me Scout Cutter?','Uh okay... so what do you have for me Scout Cutter?',26124),
(92976,'enUS','Yeah! So these Bleeding Hollow guys are almost as dangerous as Laughing Skull, but they spend too much time looking at the skies. They have tons of traps and hunt like raptors in the jungle. Deeper in their town they are doing weird things with blood and magic.$b$bI think sending a magnaron through the center of this village would do it a lot of good!','',26124),
(92977,'enUS','Commander beware! The Sargerei are here!','',26124),
(92978,'enUS','The Sargerei? What\'s going on up there?','The Sargerei? What\'s going on up there?',26124),
(92979,'enUS','They\'ve slaughtered the civilians there some time ago. I couldn\'t get too close but they are corrupting the wildlife with fel energy and summoning demons.$b$bThis fallen village should be razed to the ground, commander.','',26124),
(92980,'enUS','','Stellagosa, no... come back. Damn!',26124),
(92981,'enUS','Hey commandah. De arakkoa are here in Aktar\'s Watch. Also I checked out that big tunnel to de southeast there.','',26124),
(92982,'enUS','What are the arakkoa doing here? And who is this?','What are the arakkoa doing here? And who is this?',26124),
(92983,'enUS','Dis be Aktar. De followers of Sethe an\' the Shadow Council be gatherin\' in tha ruins near here and he be keepin\' a eye on em. Also mo\' a da flyin\' arakkoa are here causing trouble. Der be a lot of bird poop to clean up here.$b$bAlso if ya need to head east, dere\'s a big tunnel to the southeast, take ya right to Ironhold Harbor. Might be dangerous though.','',26124),
(92984,'enUS','Now it be time to demonstrate what we learned!','Now it be time to demonstrate what we learned!',26124),
(92985,'enUS','How dare you interrupt my instruction!','How dare you interrupt my instruction!',26124),
(92986,'enUS','Ah... I can use your soul for the next lesson!','Ah... I can use your soul for the next lesson!',26124),
(92987,'enUS','Commander! I have news! I can tell you about Ironhold Harbor, the Fel Forge, and the Throne of Kil\'jaeden.','',26124),
(92988,'enUS','Tell me what occurs at Ironhold Harbor.','Tell me what occurs at Ironhold Harbor.',26124),
(92989,'enUS','It appears Gul\'dan is calling in all Iron Horde from across Draenor. They come in from the harbor on ships... then they go east... to the pits.$b$bThere they are... converted... into fel orcs. It is horrible. We must destroy this place at once!','',26124),
(92990,'enUS','Was this your friend? He died well... saved me...','',26124),
(92991,'enUS','What happened here?','What happened here?',26124),
(92992,'enUS','Your warrior tried to save me but my captors caught up with us. I am sorry for your friend.$b$bUp on the mountain a powerful demon was slain by Grommash. It was left alone for some time but the Iron Horde has a new master... one with renewed interest. Minions of Gul\'dan summon demons and keep the fel corrupted waters flowing.$b$b It is extremely dangerous up there, you should not go alone.','',26124),
(92993,'enUS','Greetings, is there something I can help you with?','',26124),
(92994,'enUS','You are Lagar? I bring word from a shaman of your order. He says... Gul\'dan knows. May I ask what this means?','You are Lagar? I bring word from a shaman of your order. He says... Gul\'dan knows. May I ask what this means?',26124),
(92995,'enUS','Thank you friend. It means that an ancient secret has been revealed to the worst person possible.$b$bI will need to summon the rest of my order to defend it.$b$bYou lead the army that opposes Gul\'dan? You are welcome here and we will assist where we can. We are few, but are well respected by the elemental forces of Draenor.$b$bWe will speak of this secret later. Go in peace.','',26124),
(92996,'enUS','Very painful to be hit with.','',26124),
(92997,'enUS','You... you are beginning to ANGER ME!!','',26124),
(92998,'enUS','<The great dragon acknowledges you with a smile.>','',26124),
(92999,'enUS','Urgent message for Senegos!','',26124),
(93000,'enUS','The Nightfallen have assaulted the whelplands.','',26124),
(93001,'enUS','These four whelplings need to be treated with ley crystals immediately.','',26124),
(93002,'enUS','You are a kind small thing, $n.','',26124),
(93003,'enUS','','Where did Cyana Nightglaive go? I need to find her!',26124),
(93004,'enUS','Wait... what is that you\'re holding?','',26124),
(93005,'enUS','I\'LL KILL YOU! I\'LL RIP OUT YOUR HEART!','',26124),
(93006,'enUS','Come to free that pitiful drake, demon hunter?','',26124),
(93007,'enUS','','Feel the fel energy course through...',26124),
(93008,'enUS','','We\'ve been expecting you, $p. How is Khadgar?',26124),
(93009,'enUS','','We\'ve dealt them a telling blow. But even now, the Legion is summoning in more powerful demons.',26124),
(93010,'enUS','','Felsworn Nightglaive, prove yourself. I have other matters to attend to.',26124),
(93011,'enUS','','Yes, my mistress...',26124),
(93012,'enUS','','We cannot allow them to regain their momentum or the Broken Isles are lost.',26124),
(93013,'enUS','','What\'s he talking about? Meet me outside the gem.',26124),
(93014,'enUS','','You WILL talk, foul demon!',26124),
(93015,'enUS','','You are no demon. Friend or foe?',26124),
(93016,'enUS','','I am more powerful than all of you!',26124),
(93017,'enUS','','Cyana. Do not give in!',26124),
(93018,'enUS','','I have to find Stellagosa and Cyana Nightglaive.',26124),
(93019,'enUS','','Meet me up at the overlook. We will finish this business together.',26124),
(93020,'enUS','','$p, let\'s get out of here before we\'re overrun.',26124),
(93021,'enUS','','A warden working for the Legion? I look forward to killing her.',26124),
(93023,'enUS','','You stand in one of the great wonders of the world.$b$bOur wine is made of the finest fruits, and our oils the finest of olives.$b$bI dare anyone to claim they have better.',26124),
(93024,'enUS','Gather what you need and meet me outside the entrance.','',26124),
(93025,'enUS','','You will soon be free, drake.',26124),
(93026,'enUS','Come with me. This is exactly what I need to undo Gul\'dan\'s hold on Garona.','',26124),
(93027,'enUS','We\'re using the tools of our enemy against them.','',26124),
(93028,'enUS','Not \'til my dying breath. I will end your torment, Garona.','',26124),
(93029,'enUS','Om na ka om, Fel na om kal...','',26124),
(93030,'enUS','Quickly, destroy that thing!','',26124),
(93031,'enUS','Awaken, Garona. You are free at last.','',26124),
(93032,'enUS','Come with me, Garona. Together we will plan for Gul\'dan\'s downfall.','',26124),
(93033,'enUS','','Archmage. That is dark magic you\'re working with.',26124),
(93034,'enUS','','You are using the tools of our enemy!',26124),
(93035,'enUS','','I do not like this.',26124),
(93036,'enUS','','Give me that orb, Khadgar. I will destroy that hideous thing.',26124),
(93037,'enUS','','Haven\'t you given up already, mage?',26124),
(93038,'enUS','','%s gasps in pain.',26124),
(93039,'enUS','','Gul\'dan... he\'s not in my head anymore...',26124),
(93040,'enUS','','I owe everything to you! To both of you!',26124),
(93041,'enUS','','I will do whatever it takes to stop Gul\'dan. Wherever you lead, I will follow... commander!',26124),
(93042,'enUS','Let\'s try this again. For Garona!','Let\'s try this again. For Garona!',26124),
(93043,'enUS','','Lookin\' to learn something?',26124),
(93044,'enUS','','You are unworthy of our craft!',26124),
(93045,'enUS','','My wine is only for the queen.',26124),
(93046,'enUS','','Begone from this place. Our works are not for the lowly likes of you.',26124),
(93047,'enUS','You should not be here.','',26124),
(93048,'enUS','This place is not for you.','',26124),
(93049,'enUS','We remember the queen.','',26124),
(93050,'enUS','For Azshara!','',26124),
(93051,'enUS','Your soul will be made to serve!','',26124),
(93052,'enUS','Death cannot take... its master...','',26124),
(93053,'enUS','','The Shadowmoon will break you!',26124),
(93054,'enUS','','The crystal... is mine...',26124),
(93055,'enUS','The void will claim you!','',26124),
(93056,'enUS','I return to the nether...','',26124),
(93057,'enUS','I\'ll blast you to pieces!','',26124),
(93058,'enUS','Shoulda... brought more... rockets...','',26124),
(93059,'enUS','No one beat Gutrek... no one...','',26124),
(93060,'enUS','I lost track of Garona.','I lost track of Garona.',26124),
(93061,'enUS','Play Default Garrison Music','Play Default Garrison Music',26124),
(93062,'enUS','Play \"Mountains of Thunder\"','Play \"Mountains of Thunder\"',26124),
(93063,'enUS','I\'ve lost my Theramore Tabard.','I\'ve lost my Theramore Tabard.',26124),
(93064,'enUS','Reigniting','Reigniting',26124),
(93065,'enUS','Play \"Karazhan Opera House\"','Play \"Karazhan Opera House\"',26124),
(93066,'enUS','Play \"The Argent Tournament\"','Play \"The Argent Tournament\"',26124),
(93067,'enUS','Play \"Lament of the Highborne\"','Play \"Lament of the Highborne\"',26124),
(93068,'enUS','Play \"Faerie Dragon\"','Play \"Faerie Dragon\"',26124),
(93069,'enUS','Play \"Totems of the Grizzlemaw\"','Play \"Totems of the Grizzlemaw\"',26124),
(93071,'enUS','Play \"Darkmoon Carousel\"','Play \"Darkmoon Carousel\"',26124),
(93072,'enUS','Play \"Shalandis Isle\"','Play \"Shalandis Isle\"',26124),
(93073,'enUS','Excellent, you\'re getting better! Soon you will be ready to summon your first imp!','',26124),
(93074,'enUS','Keep your focus and bend the chaos to your will.','',26124),
(93075,'enUS','You mind must be strong, like ogre! If you weak then you die. Our path be that simple.','',26124),
(93080,'enUS','Hold on for just a moment while I unlock the seal.','',26124),
(93082,'enUS','Ish valah, wynn talos...','',26124),
(93083,'enUS','Aha! There we are.','',26124),
(93084,'enUS','Follow me, $n. I read all about this place when I was studying to join the Kirin Tor. I\'ll show you around.','',26124),
(93086,'enUS','Sarim!','',26124),
(93087,'enUS','This is the portrait room. Each picture works as a portal.','',26124),
(93088,'enUS','We can direct them almost anywhere on Azeroth we need to go. It is with these that we will gather the resources we need to defeat the Legion.','',26124),
(93089,'enUS','Now, let us discuss where our efforts are best focused.','',26124),
(93090,'enUS','$B***** RULES OF THE GAME *****\n$B$GHe:She; who starts the game will be the|cFF990000 Seeker|r and gain the ability to|cFF2959D3 Tag|r party members. All other party members will gain the ability to|cFF2959D3 Hide|r.\n$BThe |cFF990000 Seeker|r has 60 seconds from the time the game begins to find and|cFF2959D3 Tag|r a party member.\n$BHidden party members will be revealed if they move OR if the|cFF990000 Seeker|r draws near. Players who can reach home base without being|cFF2959D3 Tagged|r win!','',26124),
(93091,'enUS','I... am... awakened!','',26124),
(93092,'enUS','','Are you injured?',26124),
(93093,'enUS','Fortune and glory, kid. Fortune and Glory.','',26124),
(93094,'enUS','I\'m like a bad penny. I always turn up.','',26124),
(93095,'enUS','I\'m making this up as I go!','',26124),
(93096,'enUS','I\'ll give ya a tip, kid. \"X\" never, ever marks the spot.','',26124),
(93097,'enUS','Thank the Light I found you! Please wait a moment, champion!','',26124),
(93098,'enUS','Highlord Tirion sent me to find you. He needs to see you right away!','',26124),
(93099,'enUS','Fortunately I kept some of these handy. It had to be snakes!','',26124),
(93100,'enUS','Too good to be... true.','',26124),
(93101,'enUS','See ya around... kid...','',26124),
(93102,'enUS','Fortune and... glory...','',26124),
(93103,'enUS','He chose... poorly.','',26124),
(93104,'enUS','I hate snakes, kid. I hate\'em!','',26124),
(93105,'enUS','This looks dangerous. You go first!','',26124),
(93106,'enUS','Leave this one to me!','',26124),
(93107,'enUS','You call THIS archaeology?','',26124),
(93108,'enUS','Nothing surprises me, commander. I\'m a scientist.','',26124),
(93109,'enUS','Have you found any more artifacts, commander?','',26124),
(93110,'enUS','You need my help with anything today, commander?','',26124),
(93111,'enUS','This is gonna get nasty.','',26124),
(93112,'enUS','The Kirin Tor is here to help! When I\'m fully-implemented, I\'ll help you close a rift and give you something good if I survive!','The Kirin Tor is here to help! When I\'m fully-implemented, I\'ll help you close a rift and give you something good if I survive!',26124),
(93113,'enUS','Sargeras sends forces against you!','Sargeras sends forces against you!',26124),
(93114,'enUS','','I overestimated my strength. All of the dragons - even the Aspects themselves - have been greatly weakened since the fall of Deathwing.',26124),
(93115,'enUS','','My grandfather is the last among us that clings to any magical power. Do you really want him to expend it all on this Tidestone?',26124),
(93116,'enUS','After you, $n. Your presence is of the utmost importance.','',26124),
(93117,'enUS','','After you, $n. Your presence is of the utmost importance.',26124),
(93118,'enUS','','Thank the Light I found you! Please wait a moment, champion!',26124),
(93119,'enUS','','Highlord Tirion sent me to find you. He needs to see you right away!',26124),
(93120,'enUS','We\'re ready to begin!','We\'re ready to begin!',26124),
(93121,'enUS','My keepers are overrun. We will require aid.','',26124),
(93122,'enUS','Is your party ready to begin?','Is your party ready to begin?',26124),
(93123,'enUS','Stellagosa. Do me one last favor. Your younger brothers and sisters need your help.','',26124),
(93124,'enUS','10...','10...',26124),
(93125,'enUS','','Of course.',26124),
(93126,'enUS','9...','9...',26124),
(93127,'enUS','8...','8...',26124),
(93128,'enUS','','Farewell, grandfather.',26124),
(93129,'enUS','7...','7...',26124),
(93130,'enUS','See you soon, starlight.','',26124),
(93131,'enUS','6...','6...',26124),
(93132,'enUS','5...','5...',26124),
(93133,'enUS','4...','4...',26124),
(93134,'enUS','3...','3...',26124),
(93135,'enUS','2...','2...',26124),
(93136,'enUS','1...','1...',26124),
(93137,'enUS','Ready or not, here I come!','Ready or not, here I come!',26124),
(93138,'enUS','%s begins to count down. Find a hiding spot!','%s begins to count down. Find a hiding spot!',26124),
(93139,'enUS','%s was unable to tag any players! The Hiders win!','%s was unable to tag any players! The Hiders win!',26124),
(93140,'enUS','%s has tagged $n, the Seeker wins!','%s has tagged $n, the Seeker wins!',26124),
(93141,'enUS','%s has reached home base! $GHe:She; is safe!','%s has reached home base! $GHe:She; is safe!',26124),
(93144,'enUS','Ah, that\'s the stuff!','Ah, that\'s the stuff!',26124),
(93145,'enUS','Thanks - my back has been killing me since the crash.','Thanks - my back has been killing me since the crash.',26124),
(93146,'enUS','Exactly what I needed!','Exactly what I needed!',26124),
(93147,'enUS','This stuff isn\'t habit-forming, right?','This stuff isn\'t habit-forming, right?',26124),
(93148,'enUS','I owe ya one - and Mishka, too!','I owe ya one - and Mishka, too!',26124),
(93149,'enUS','Gah, I hate needles! But... that does feel nice.','Gah, I hate needles! But... that does feel nice.',26124),
(93150,'enUS','I could fight all day. Bring it!','I could fight all day. Bring it!',26124),
(93151,'enUS','Another Nightfallen attack? Bring my child to me, young one.','',26124),
(93152,'enUS','My poor, poor children. We can\'t afford to lose a single one of you.','',26124),
(93153,'enUS','Very good, soon you will be ready for the next lesson.','Very good, soon you will be ready for the next lesson.',26124),
(93154,'enUS','Let the dark power flow through you. Focus it!','Let the dark power flow through you. Focus it!',26124),
(93155,'enUS','The ritual is weakening, try harder!','The ritual is weakening, try harder!',26124),
(93156,'enUS','Gul\'dan will be pleased when I bring him your soul!','Gul\'dan will be pleased when I bring him your soul!',26124),
(93157,'enUS','The masters come!','The masters come!',26124),
(93158,'enUS','The Sethekk will rise again!','',26124),
(93159,'enUS','We have been shown the path to true power!','',26124),
(93160,'enUS','We serve a new master now!','',26124),
(93161,'enUS','The master demands a sacrifice!','',26124),
(93162,'enUS','Let me show you what I\'ve learned.','',26124),
(93163,'enUS','So... much... blood! Death to the enemies of the Bleeding Hollow!','',26124),
(93165,'enUS','Play \"Mountains\"','Play \"Mountains\"',26124),
(93166,'enUS','I will slay those that disrupt our rituals! Prepare for death!','',26124),
(93167,'enUS','Play \"Orgrimmar\"','Play \"Orgrimmar\"',26124),
(93168,'enUS','Night falls...','',26124),
(93169,'enUS','We will rise again.','',26124),
(93170,'enUS','I\'ll drag you down with me!','',26124),
(93171,'enUS','I\'ll make you kneel.','',26124),
(93172,'enUS','I found it first!','',26124),
(93173,'enUS','Get back! It\'s mine... MINE!','',26124),
(93174,'enUS','Don\'t look at me!','',26124),
(93175,'enUS','Stay back! Stay back!','',26124),
(93176,'enUS','','No... NO! I still thirst. Give me more!',26124),
(93177,'enUS','','So... thirsty...',26124),
(93178,'enUS','Kneel, lowborn scum!','',26124),
(93179,'enUS','This cannot be! I had it all...','',26124),
(93180,'enUS','What\'s this? Have the peasants come to grovel before their prince?','',26124),
(93181,'enUS','You rats aren\'t fit to touch the hem of my robe!','',26124),
(93182,'enUS','I need... more... power!','',26124),
(93183,'enUS','Yes... YEEESSSSS!','',26124),
(93184,'enUS','We will see if you are truly worthy. Come, and prove yourself a champion of the Light.','',26124),
(93185,'enUS','I carved through thousands of foul scourge. No creature of darkness could stand against The Ashbringer.','',26124),
(93186,'enUS','No... I was betrayed... cut down... by my own son.','',26124),
(93187,'enUS','Play \"War March\"','Play \"War March\"',26124),
(93188,'enUS','Play \"Thunder Bluff\"','Play \"Thunder Bluff\"',26124),
(93189,'enUS','Play \"Mulgore Plains\"','Play \"Mulgore Plains\"',26124),
(93190,'enUS','Play \"Undercity\"','Play \"Undercity\"',26124),
(93191,'enUS','Play \"Zul\'Gurub Voodoo\"','Play \"Zul\'Gurub Voodoo\"',26124),
(93192,'enUS','Play \"The Zandalari\"','Play \"The Zandalari\"',26124),
(93193,'enUS','Play \"Silvermoon\"','Play \"Silvermoon\"',26124),
(93194,'enUS','Play \"Rescue the Warchief\"','Play \"Rescue the Warchief\"',26124),
(93195,'enUS','','I am busy, $n. Finish your business here and move on.',26124),
(93196,'enUS','Ahh... I feared we might lose that one. He was so weak when I found him. Pick him up and take him to Senegos.','',26124),
(93197,'enUS','Thanks, $c. I\'ll be fine.','Thanks, $c. I\'ll be fine.',26124),
(93198,'enUS','Go on ahead, I can make it from here.','Go on ahead, I can make it from here.',26124),
(93199,'enUS','<cough> I\'m good.','<cough> I\'m good.',26124),
(93200,'enUS','','Champion, follow the Highlord\'s spirit! We will hold this ground!',26124),
(93201,'enUS','We have to get out of here before more demons come. Quickly, the Highlord is just outside the temple.','',26124),
(93202,'enUS','Renault! My son... by the Light... help me up!','',26124),
(93203,'enUS','The Light is dead.','',26124),
(93204,'enUS','Attention, soldiers! Commander $p passing through.','Attention, soldiers! Commander $p passing through.',26124),
(93205,'enUS','You are stronger than I thought. Come.','',26124),
(93206,'enUS','Ahhhhh...','',26124),
(93207,'enUS','','Get up, brother. Wake up.',26124),
(93208,'enUS','','No! Not you, too...',26124),
(93209,'enUS','','You are nothing but a coward.',26124),
(93210,'enUS','','If you only knew the Legion\'s power. Join us, Kor\'vas.',26124),
(93211,'enUS','','Never! You and your new mistress will die by my warglaives.',26124),
(93212,'enUS','','My wine is only for Queen Azshara!',26124),
(93213,'enUS','Stranger! Can you help me? None of these fools will believe me.','',26124),
(93214,'enUS','Leaving','Leaving',26124),
(93215,'enUS','','But, I was promised...',26124),
(93216,'enUS','They all laughed when I said I could out brew them. I told them I would make something worthy of Lady Challiane, maybe even worthy of the queen herself.','',26124),
(93217,'enUS','Eat this!','Eat this!',26124),
(93218,'enUS','Yeah! Keep \'em coming!','Yeah! Keep \'em coming!',26124),
(93219,'enUS','Get some!','Get some!',26124),
(93220,'enUS','You truly think yourself worthy?','',26124),
(93221,'enUS','The Ashbringer can only be wielded by the pure. You waste your time!','',26124),
(93222,'enUS','','Now, now, Zeliek. Perhaps this is the chosen one the blade speaks of?',26124),
(93223,'enUS','No more babblin\'. Let\'s get to fightin\'!','',26124),
(93224,'enUS','Enough. If you are worthy of the Ashbringer...','',26124),
(93225,'enUS','Prove yourself.','',26124),
(93226,'enUS','','You are getting so very frail and weak.',26124),
(93227,'enUS','More slaves for the queen and her new master.','',26124),
(93228,'enUS','You don\'t look like a sailor, but you\'ll do.','',26124),
(93229,'enUS','I\'ll enslave you with my spells.','',26124),
(93230,'enUS','You do not belong. I\'ll kill ya for the queen.','',26124),
(93231,'enUS','A taste of my venom and you\'ll be mine.','',26124),
(93232,'enUS','Another victim for the queen and her demonic friend.','',26124),
(93233,'enUS','My poison is fast to act, but slow to burn.','',26124),
(93234,'enUS','Don\'t be afraid. My venom weakens. Makes you cooperative.','',26124),
(93235,'enUS','So long as my twisted soul dwells within the Ashbringer you will not take it!','',26124),
(93236,'enUS','|TInterface\\Icons\\Ability_Warlock_FireandBrimstone:20|tYou have been targeted with |cFFFF0000|Hspell:180776|h[Overwhelming Flames]|h|r! Move away from your allies!','|TInterface\\Icons\\Ability_Warlock_FireandBrimstone:20|tYou have been targeted with |cFFFF0000|Hspell:180776|h[Overwhelming Flames]|h|r! Move away from your allies!',26124),
(93237,'enUS','I\'LL DRINK THE MANA FROM YOUR BROKEN BONES!!','',26124),
(93238,'enUS','I... I...','',26124),
(93243,'enUS','By the Light... it really is you.','',26124),
(93244,'enUS','What? You not supposed to be here!','',26124),
(93245,'enUS','You are pure of heart and noble of spirit. You are the one the Ashbringer was searching for.','',26124),
(93246,'enUS','Come with me. The blade awaits.','',26124),
(93247,'enUS','','Enforcer, enact my will!',26124),
(93248,'enUS','Crush you underfoot, little fish.','',26124),
(93249,'enUS','For Prince Oceanus!','',26124),
(93250,'enUS','Me drown you in the sea.','',26124),
(93251,'enUS','Take up the blade and fulfill your destiny, champion. You are... The Ashbringer.','',26124),
(93252,'enUS','I do not trust Nightfallen...','',26124),
(93253,'enUS','But it seems we have little choice.','',26124),
(93254,'enUS','I only want to help, good dragon.','',26124),
(93255,'enUS','Use the whelplings, then. But if you deceive me, prepare to face the wrath of a dragonflight.','',26124),
(93256,'enUS','I was once a noble elf, good dragon. I know the meaning of honor.','',26124),
(93261,'enUS','','You\'ve been a naughty child. Time to be punished.',26124),
(93262,'enUS','','Avenge me, my children!',26124),
(93263,'enUS','I know why you are here, small one...','',26124),
(93264,'enUS','','No... you can\'t... have it.',26124),
(93265,'enUS','Please... help...','',26124),
(93266,'enUS','You mortals and your arrogance. You will burn in my flames!','',26124),
(93267,'enUS','I will return!','',26124),
(93268,'enUS','Ah, the Light\'s greatest champion has arrived to claim the holy Ashbringer and lay waste to my kin.','',26124),
(93269,'enUS','I\'ve been waiting for you, paladin. Know that I will rip the soul from your flesh and make your body my own.','',26124),
(93270,'enUS','','We\'ve got your back, champion!',26124),
(93271,'enUS','The Light will always triumph against darkness.','',26124),
(93272,'enUS','Burn everything, my pets. Leave only ash.','',26124),
(93273,'enUS','I WILL return!','',26124),
(93278,'enUS','Ah, $p. Good. I am in need of someone with a calmer head than Marius here.$b$bThis location is prime for summoning a demon more powerful than any I have summoned before.$b$bI need you to ensure that this demon hunter doesn\'t do anything foolish like killing the demon before I have a chance to force it into submission.$b$bWill you stand with me?','',26124),
(93279,'enUS','Okay...?','Okay...?',26124),
(93280,'enUS','Your cowardice is showing, Marius. We must learn the limits of our enemy if we are to defeat them.','',26124),
(93281,'enUS','Who dares summon me?','',26124),
(93282,'enUS','There are enough demons for us to kill without you summoning more.','',26124),
(93283,'enUS','Too big! Too big! KILL IT!','',26124),
(93284,'enUS','Next time I need to remember to have a soulstone ready.','',26124),
(93285,'enUS','Not right now, my friend. Not right now.','',26124),
(93286,'enUS','Activate','',26124),
(93287,'enUS','Legion has chosen its champion!','',26124),
(93288,'enUS','You are not wanted here!','',26124),
(93289,'enUS','For the God King!','',26124),
(93290,'enUS','The God King will have the Aegis!','',26124),
(93291,'enUS','The God King commands your death!','',26124),
(93292,'enUS','You are not worthy of the trials! Hail the God King!','',26124),
(93293,'enUS','No one will challenge the God King!','',26124),
(93294,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Balnazzar.blp:50:80|t$b[Balnazzar] You really think you can stand against me? My endless felguard will cut you down.','',26124),
(93295,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Balnazzar.blp:50:80|t$b[Balnazzar] Impressive... but not enough. Infernal, crush them.','',26124),
(93296,'enUS','Enough. Never again will that damned blade slay my brethren! YOU... WILL... DIE!','',26124),
(93297,'enUS','HAHA!! Now that I have consumed the blood of my brothers, I have the power to destroy you and the God King!','',26124),
(93300,'enUS','<The strange gnomish robot has one eye hanging loose from its socket. A cardboard sign on its chest says, \"BETA.\" Most of its wiring is duct-taped in place. Suddenly, it speaks in a warbling voice:>$b$bGreetings adventur-er-er*click*! Inp-p-p-*clink* TEST PARAMETERS REBOOT 001011010 Greetings adventurer!','',26124),
(93301,'enUS','','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-COMMANDER SARANNIS.blp:50:80|t$b[Lady Liadrin] Hero, we\'re up on the ledge behind you!',26124),
(93302,'enUS','$p, you must come quickly. Tirion called for you by name. I fear he does not have long for this world. Hurry!','',26124),
(93303,'enUS','Protect Reshad.','Protect Reshad.',26124),
(93304,'enUS','BETA: Trigger the Invasion','BETA: Trigger the Invasion',26124),
(93306,'enUS','Praying','',26124),
(93307,'enUS','|cffADFF2F+$1i Artifact Power|r','|cFF0000FF+$1i Artifact Power |r',26124),
(93308,'enUS','','The Ashbringer...',26124),
(93309,'enUS','','The Ashbringer...',26124),
(93310,'enUS','The Ashbringer...','',26124),
(93311,'enUS','((This will be a brief cutscene. You attempt to give Tirion the Ashbringer, but he refuses.)) No... I am too crippled to continue the Ashbringer\'s legacy. The burden must fall on your shoulders, $p. From this day forward, you will wield the Ashbringer against the forces of darkness wherever you are needed, champion.','',26124),
(93312,'enUS','((This will be a brief cutscene. You attempt to give Tirion the Ashbringer, but he refuses.)) No... I am too crippled to continue the Ashbringer\'s legacy. The burden must fall on your shoulders, $p. From this day forward, you will wield the Ashbringer against the forces of darkness wherever you are needed, champion.','',26124),
(93319,'enUS','Word has already spread of your exploits on the Broken Shore. The Ashbringer... the forces of the Legion will surely cower in your wake.','',26124),
(93320,'enUS','The Burning Legion\'s numbers are endless. If we are ever going to put a stop to their assault, we need to stop them at the source - the Tomb of Sargeras.','',26124),
(93321,'enUS','Long ago, the Titans used powerful tools called the Pillars of Creation to shape Azeroth. They are the key to seal the Legion\'s gateway into our world forever.','',26124),
(93322,'enUS','We\'ve identified the location of one of the pillars - the Tidestone of Golganneth. It is somewhere on the ancient isle of Azsuna. I need you to retrieve it by any means necessary.','',26124),
(93323,'enUS','Aegwynn built this chamber in secret as some sort of safeguard against the Legion. We must discover its secrets so we can make use of it.','',26124),
(93324,'enUS','Why have you summoned me here, imp?','',26124),
(93325,'enUS','Minion! Glad you could make it. The time has come to make my old master pay for violating my contract. You ready to face him?','',26124),
(93326,'enUS','Begin your ritual.','Begin your ritual.',26124),
(93327,'enUS','Ah... my \'former\' master. Minion! Kill it!','',26124),
(93328,'enUS','You failed, \'master\'! Who\'s the master now?','',26124),
(93329,'enUS','You will pay for this betrayal!','',26124),
(93330,'enUS','Of course. If Tirion beckons, it must be important.','',26124),
(93331,'enUS','Follow me, champion. Let me show you Light\'s Hope Sanctum and introduce you to the Order of the Silver Hand.','',26124),
(93332,'enUS','Yes! Yes! Dark-ish feathers for dark-ish purpose!','',26124),
(93333,'enUS','','Greetings, $c. Your aid is welcome here.',26124),
(93334,'enUS','Yes! Yes! Good! The cursed power that flows in these horns is invaluable to any evil...er... morally ambiguous ritual.','',26124),
(93335,'enUS','Well done, minion! One olive for each of my fingers.','',26124),
(93336,'enUS','Please join me. I am ready to continue our quest.','Please join me. I am ready to continue our quest.',26124),
(93337,'enUS','Make way for the little guy!','',26124),
(93338,'enUS','Meet me at the ritual site for your reward.','',26124),
(93339,'enUS','Switching the building will cost 500 gold.\n\nAre you sure?','Switching the building will cost 500 gold.\n\nAre you sure?',26124),
(93340,'enUS','Archmage Khadgar, can you direct one of these portals to Light\'s Hope Chapel?','',26124),
(93341,'enUS','','Archmage Khadgar, can you direct one of these portals to Light\'s Hope Chapel?',26124),
(93342,'enUS','You never know what you\'ll find while wandering the land in search of a good trade.  Hopefully I\'ve found someone willing to barter?','You never know what you\'ll find while wandering the land in search of a good trade.  Hopefully I\'ve found someone willing to barter?',26124),
(93343,'enUS','Come brothers! Seize your destiny!','',26124),
(93348,'enUS','','I have heard Malfurion\'s name spoken in passing. He was \'alora thero-shan\' - the beloved first student - of Cenarius.',26124),
(93349,'enUS','','I understand your matter is of great urgency. Help us, and we shall help you.',26124),
(93350,'enUS','','Many of our own slumber in the barrow den, keeping watch within the Emerald Dream.$B$BThe Archdruid is among them. I only pray we are not too late to save them.',26124),
(93351,'enUS','','The furbolg are relentless, and strong. There is no stopping them without the use of force.',26124),
(93352,'enUS','It hurts...','',26124),
(93354,'enUS','','Greetings, traveler!$B$BNormally, I would welcome you to this sunlit glade by sitting you down for a meal of fresh berries bursting with ripeness, washed down with clear stream water caressed by moonlight, but unfortunately, we are under attack!',26124),
(93355,'enUS','','If you believe, you can achieve!',26124),
(93356,'enUS','','Hang in there, Tenno. Shhh, save your strength. Don\'t die on me now!',26124),
(93357,'enUS','Druids of the Claw, do not falter! We must retake the barrow den!','Druids of the Claw, do not falter! We must retake the barrow den!',26124),
(93358,'enUS','','I haven\'t had any fancy druidic training like you, but I\'m going to heal Tenno with the power of my friendship!',26124),
(93359,'enUS','Cenarius, my mentor...$b$bWhat foul power could hold sway over him?','',26124),
(93360,'enUS','','The Dream was clouded with such darkness...',26124),
(93361,'enUS','I can fly you back to Light\'s Hope Sanctum if you need, hero.','',26124),
(93362,'enUS','I would like to return to Light\'s Hope Sanctum.','I would like to return to Light\'s Hope Sanctum.',26124),
(93363,'enUS','I\'m awake, I\'m awake...','',26124),
(93364,'enUS','Is this world real? Or is the dream the actual reality?','',26124),
(93365,'enUS','I slept well, but my dreams were troubled.','',26124),
(93366,'enUS','My dreams felt strange. I fear not all is well in the Emerald Dream.','',26124),
(93367,'enUS','I wandered long and far in my dreams. So very, very far...','',26124),
(93368,'enUS','I sensed a dark presence within the Dream.','',26124),
(93369,'enUS','','My druids are still caught inside The Emerald Dream, unable to awaken.',26124),
(93370,'enUS','The demons before us are all that stand between us and the Ashbringer. Regardless of the outcome, our families will know that we fought for the freedom and safety of our world.','',26124),
(93371,'enUS','','My slumber was overcome by shadows. I have awoken, only to find those shadows reaching into our world.',26124),
(93373,'enUS','Come, champion, before we are overrun by demons!','',26124),
(93374,'enUS','Arise Dorg! Arise and avenge your fallen brethren!','',26124),
(93375,'enUS','Bloodhunter Zulk! Too many of our rituals are being stopped, execute the interlopers!','',26124),
(93376,'enUS','The Blood Moon rises and strengthens our chieftain! Rejoice Bleeding Hollow, soon he will be unstoppable!','',26124),
(93377,'enUS','The Blood Moon has been drained! Quickly, animate the remains and salvage what power is left!','',26124),
(93378,'enUS','Curse you interlopers! The Blood Moon will rise again!','',26124),
(93379,'enUS','You must hurry.... w-we don\'t have much time!','',26124),
(93380,'enUS','%s spits.','',26124),
(93381,'enUS','Coward.','',26124),
(93383,'enUS','','You did this to us, Farondis.',26124),
(93384,'enUS','H... He is... c-coming...','',26124),
(93385,'enUS','','We should never have forsaken the grace of Elune for the vanity of the arcane!',26124),
(93386,'enUS','I gonna break you!','',26124),
(93387,'enUS','More souls for the masters!','',26124),
(93388,'enUS','I\'m gonna drink your blood!','',26124),
(93389,'enUS','Kaww! You dare to harm my worshipers? You will know the vengeance of the Sethekk!','',26124),
(93390,'enUS','','Deal with this...',26124),
(93391,'enUS','Take me to Aktar\'s Post.','Take me to Aktar\'s Post.',26124),
(93392,'enUS','','Maintain your vigil. I want to know every move that dragon makes.',26124),
(93393,'enUS','Hold right there. We will not let you into Nar\'thalas again. Not after what happened last time.','',26124),
(93394,'enUS','I beg your forgiveness, Thaldrys.','',26124),
(93395,'enUS','You sundered the land we called home. You denied us the release of death.','',26124),
(93396,'enUS','Ten thousand years of damnation for ten thousand elves. All because of your foolish alliances and botched politics.','',26124),
(93397,'enUS','What can I do to make amends?','',26124),
(93398,'enUS','I doubt there\'s anything you can do now, prince.','',26124),
(93399,'enUS','Failure.','Failure.',26124),
(93400,'enUS','Murderer.','Murderer.',26124),
(93401,'enUS','Fool.','Fool.',26124),
(93402,'enUS','Butcher.','Butcher.',26124),
(93403,'enUS','Stop! Stop the voices, I beg you!','',26124),
(93404,'enUS','Take me to Aktar\'s Post.','Take me to Aktar\'s Post.',26124),
(93405,'enUS','','I will escort you to Prince Farondis, if that is what you truly wish.',26124),
(93406,'enUS','','If you get the chance, spit on him for me.',26124),
(93407,'enUS','The Archdruid of Lore has sent me to you. Will you help me cure the petrified acolytes?','The Archdruid of Lore has sent me to you. Will you help me cure the petrified acolytes?',26124),
(93408,'enUS','Prepare for your deaths, worms!','',26124),
(93409,'enUS','You cannot escape your punishment!','',26124),
(93410,'enUS','Ha! Impudent coward!','',26124),
(93411,'enUS','Not so fast!','',26124),
(93412,'enUS','Grommash, I have... failed...','',26124),
(93413,'enUS','Wrong move, weaklings.','',26124),
(93414,'enUS','Witness your unmaking!','',26124),
(93415,'enUS','Scurry, like the vermin you are!','',26124),
(93416,'enUS','You can\'t handle this!','',26124),
(93417,'enUS','How did I... lose?!','',26124),
(93418,'enUS','','Burn... BURN!',26124),
(93419,'enUS','','Oh, new playthings?!',26124),
(93420,'enUS','','Dance, little one!',26124),
(93421,'enUS','','What a bore... I tire of this.',26124),
(93422,'enUS','','No! NO!',26124),
(93423,'enUS','','I will open the way for you, but be careful. I sense powerful magic down below.',26124),
(93424,'enUS','This is just... the beginning.','',26124),
(93425,'enUS','We are prisoners of the druids no longer. Soon, your world will become ours!','',26124),
(93426,'enUS','You must excuse my attendants. Their brusqueness is not directed at you... it is toward me.','',26124),
(93427,'enUS','Azsuna was once a center of elven civilization. My people flourished. Now, they are damned.$b$bMost cannot bear to look at me.$b$bThey are the scars of my past. The marks of my shame.','',26124),
(93428,'enUS','This is too difficult. I cannot look my people in the eye and explain my actions.$b$bI should return to the solitude of my palace. At least my guards are content to ignore me.','',26124),
(93429,'enUS','','I will travel to the Grove of Cenarius shortly, hero. Thank you for your help here.',26124),
(93430,'enUS','','Be wary. $n is here.',26124),
(93431,'enUS','','Kill them, Malinoth!',26124),
(93432,'enUS','I damned our people. I brought about the destruction of our ancestral homeland.$b$bI killed them all.$b$bIt is because of my folly that our people cannot experience the relief of death. My failures led our people to this cursed ghostly half-existence.','',26124),
(93433,'enUS','It will be my pleasure.','',26124),
(93434,'enUS','I will feast upon your soul when you die!','',26124),
(93435,'enUS','I was a poor leader. I was blind, and I chose the wrong path for my people. I...$b$b...I cannot go into any more detail than that. Give me time, $n. I am certain that all will be revealed in good time.','',26124),
(93436,'enUS','Percy and I will travel on ahead. When you are ready to join us speak with your flight master.','',26124),
(93437,'enUS','Out with the tides...','',26124),
(93438,'enUS','','You are no match for the might of our forces!',26124),
(93439,'enUS','None shall enter without the blessing of Yotnar.','',26124),
(93440,'enUS','You will surely die if you enter Aggramar\'s Vault without the blessing of Yotnar.','',26124),
(93441,'enUS','Haha! Back to the nether!','',26124),
(93442,'enUS','D\'ah! Now you\'re making me angry!','D\'ah! Now you\'re making me angry!',26124),
(93443,'enUS','You landlubbers are tougher than I thought! I\'ll have to improvise!','You landlubbers are tougher than I thought! I\'ll have to improvise!',26124),
(93444,'enUS','We\'re under attack! Avast, ye swabs! Repel the invaders!','We\'re under attack! Avast, ye swabs! Repel the invaders!',26124),
(93445,'enUS','They will bleed. I will show them how to bleed.','',26124),
(93446,'enUS','You there! Check out that noise!','You there! Check out that noise!',26124),
(93447,'enUS','I can wait no longer - follow!','',26124),
(93448,'enUS','I\'d only reached the academy entrance when I saw those two naga, with you in tow.','',26124),
(93449,'enUS','For Azsuna!','',26124),
(93450,'enUS','The shrine has been brutally defaced.','The shrine has been brutally defaced.',26124),
(93451,'enUS','Look alive, nightwatchers! Our prince needs us!','',26124),
(93452,'enUS','For Azsuna!','For Azsuna!',26124),
(93453,'enUS','','Farondis! My most loyal subject. It\'s been too long.',26124),
(93454,'enUS','That voice...','',26124),
(93455,'enUS','','I\'m sorry, you must not recognize me.',26124),
(93456,'enUS','We have devoured countless worlds. Yours will be no different.','',26124),
(93457,'enUS','','Is this better?',26124),
(93458,'enUS','Queen Azshara... you... YOU lead the naga?','',26124),
(93459,'enUS','','Poor, deluded Farondis. Don\'t you remember? I quashed your rebellion ten thousand years ago. Do you remember how powerless you were to stop me?',26124),
(93460,'enUS','To release my people\'s curse... to redeem myself and secure my legacy...','',26124),
(93461,'enUS','The people of Azsuna were-- and always will be-- too proud to kneel before your demonic allies, witch.','',26124),
(93462,'enUS','','Ha ha ha haaa... my wrath is coming.',26124),
(93463,'enUS','Let us begin.','Let us begin.',26124),
(93464,'enUS','Impossible!','Impossible!',26124),
(93465,'enUS','I am victorious again.','I am victorious again.',26124),
(93466,'enUS','That was unexpected.','That was unexpected.',26124),
(93467,'enUS','Your pet will recover with time.','Your pet will recover with time.',26124),
(93468,'enUS','Eh? I\'m new to this game. Got any tips for building mah deck?','Eh? I\'m new to this game. Got any tips for building mah deck?',26124),
(93469,'enUS','I\'m on a winning streak with this new strategy. I call it my \'menagerie\' deck.','I\'m on a winning streak with this new strategy. I call it my \'menagerie\' deck.',26124),
(93470,'enUS','Mind controlled again? Noooooo!','Mind controlled again? Noooooo!',26124),
(93471,'enUS','Wha?!? Now just how did that dragon pop out o\' that shredder?','Wha?!? Now just how did that dragon pop out o\' that shredder?',26124),
(93472,'enUS','Murlocs? Nooooo! Why did it have to be murlocs?','Murlocs? Nooooo! Why did it have to be murlocs?',26124),
(93473,'enUS','Did you just unleash the hounds on me?','Did you just unleash the hounds on me?',26124),
(93474,'enUS','Looks like I win again. But well played.','Looks like I win again. But well played.',26124),
(93475,'enUS','Let\'s see how you handle a different threat.','Let\'s see how you handle a different threat.',26124),
(93476,'enUS','Illidan\'s soul is in the Twisting Nether. I must get back to him.','Illidan\'s soul is in the Twisting Nether. I must get back to him.',26124),
(93477,'enUS','The glyph is covered with fine writing in an unknown language. A large portion of it appears to be missing.','The glyph is covered with fine writing in an unknown language. A large portion of it appears to be missing.',26124),
(93478,'enUS','','Gul\'dan\'s army awaits within the armored walls of Hellfire Citadel. What horrors lie within, we have yet to find out.$B$BOur forces here at Lion\'s Watch will hold back the demonic threat until the last of us falls.',26124),
(93479,'enUS','Please don\'t make any sudden moves around Alexi, or you might lose a finger.  Or worse.','',26124),
(93480,'enUS','The scroll is addressed to Iskar. You quickly show it to Reshad.','The scroll is addressed to Iskar. You quickly show it to Reshad.',26124),
(93481,'enUS','I have a great deal of information to give to you, but time is short. I will tell you what I can and you will have to find a way to return later to hear the rest.','',26124),
(93482,'enUS','I am ready, Illidan.','I am ready, Illidan.',26124),
(93483,'enUS','','And what offerings do you have for me?',26124),
(93484,'enUS','Planting Seeds','Planting Seeds',26124),
(93485,'enUS','Look around. What do you see? Worlds enough to fill the sky.','',26124),
(93486,'enUS','This is how it looked millennia ago, before the Burning Legion started its march of destruction across the cosmos.','',26124),
(93488,'enUS','That\'s a powerful artifact that you carry. Powerful enough to destroy the Legion.','',26124),
(93489,'enUS','You and the Illidari must recover my corpse from Black Rook Hold before it is too late.','',26124),
(93490,'enUS','Ah Interesting... \"Come to Tanaan. Assist me, and I will return you to the skies.\"','',26124),
(93491,'enUS','Our time is at an end. You must return again. But for now, leave before the Legion detects us here.','',26124),
(93492,'enUS','<The dead orc clutches an unsent letter in his hand.>$B$BDear Ma, I\'ve decided to leave da Iron Horde army.$B$BNot enough grub, and I miss your cooking.$B$BLove, Your Son.','',26124),
(93493,'enUS','Mmmmmm, you look tasty!','',26124),
(93494,'enUS','Let us proceed, $p.','',26124),
(93495,'enUS','|cFFFF0000%s|r prepares a brutal attack!','',26124),
(93496,'enUS','Who wrote this message? Come, let\'s continue the search.','',26124),
(93497,'enUS','I... I am sorry.','',26124),
(93498,'enUS','You there! Check out that noise!','You there! Check out that noise!',26124),
(93499,'enUS','We\'re under attack! Avast, ye swabs! Repel the invaders!','We\'re under attack! Avast, ye swabs! Repel the invaders!',26124),
(93500,'enUS','You landlubbers are tougher than I thought! I\'ll have to improvise!','You landlubbers are tougher than I thought! I\'ll have to improvise!',26124),
(93501,'enUS','D\'ah! Now you\'re making me angry!','D\'ah! Now you\'re making me angry!',26124),
(93502,'enUS','Ah-ha! I\'ve got you right where I want you!','Ah-ha! I\'ve got you right where I want you!',26124),
(93503,'enUS','Now... witness the full power of Millhouse Manastorm!','Now... witness the full power of Millhouse Manastorm!',26124),
(93504,'enUS','Yes! Yes! More blood!','Yes! Yes! More blood!',26124),
(93505,'enUS','Blood blood blood BLOOD BLOOD!!','Blood blood blood BLOOD BLOOD!!',26124),
(93506,'enUS','Dripping and pouring and clotting!','Dripping and pouring and clotting!',26124),
(93507,'enUS','More blood!','More blood!',26124),
(93508,'enUS','The scent of blood...so delicious!','The scent of blood...so delicious!',26124),
(93509,'enUS','Spurts of crimson!','Spurts of crimson!',26124),
(93510,'enUS','Always pumping, always pumping!','Always pumping, always pumping!',26124),
(93511,'enUS','So warm, so red!','So warm, so red!',26124),
(93512,'enUS','We are everywhere... you cannot hide!','',26124),
(93513,'enUS','Hello again, $n.','',26124),
(93514,'enUS','What do you require, oh most noble Highlord? Are there any damsels that are in a state of distress?','',26124),
(93515,'enUS','Show me your wares, squire.','Show me your wares, squire.',26124),
(93516,'enUS','I need to relay mission orders.','I need to relay mission orders.',26124),
(93517,'enUS','The great and all-powerful Highlord has called upon me. What dragon needs slaying, $ct $p?','',26124),
(93518,'enUS','Why, Thaldrys? Why did you and your men come to my aid?','',26124),
(93519,'enUS','I thought you despised me.','',26124),
(93520,'enUS','We saw what you did.','',26124),
(93521,'enUS','','Any elf with the courage to stand up against the Queen herself is worth following.',26124),
(93522,'enUS','The nightwatchers are yours to command once more, my prince.','',26124),
(93523,'enUS','I\'m glad to have your loyalty again. It\'s been a long time Thaldrys.','',26124),
(93524,'enUS','Yes. Warlord Parjesh escaped with it through the magic portal ahead.','',26124),
(93525,'enUS','Oh, hello there.  I don\'t get many visitors up here.\n\nYou may not know this, but I\'m the author of Tome of the Clear Mind.  It\'s a best seller, for sure, but I came up here for inspiration on something less technical.','',26124),
(93526,'enUS','Any inspiration so far?','Any inspiration so far?',26124),
(93527,'enUS','I\'d rather not say.  Last time I talked about it, another author stole my idea and made it into a disturbing romance novel.','',26124),
(93536,'enUS','A stranger? Hopefully $ghe:she;\'s an assassin, to finally do away with that prince!','',26124),
(93537,'enUS','','I wish.',26124),
(93539,'enUS','Become prey to the darkness!','',26124),
(93540,'enUS','I will send you to eternal sleep.','',26124),
(93541,'enUS','Your torment will be endless!','',26124),
(93542,'enUS','Nightmare consume you!','',26124),
(93543,'enUS','A shrine to Terokk! The Sethekk revere the Talon king, why would they deface their own shrine? Hmm... we must continue to investigate.','',26124),
(93545,'enUS','Every garrison could use a bit more bass, wouldn\'t you agree Commander?','',26124),
(93546,'enUS','You keep the garrison safe, and I\'ll supply the tunes.','',26124),
(93547,'enUS','Where are the jukebox parts?','Where are the jukebox parts?',26124),
(93548,'enUS','We know why you and your abomination are here.','',26124),
(93549,'enUS','You do not attack. What is this place?','You do not attack. What is this place?',26124),
(93550,'enUS','In this cave, chieftains of the Bleeding Hollow perform a ritual to see glimpses of the future, and their own death. The other chieftains... they blindly follow Kilrogg... but not us. Grommash was worthy, Gul\'dan...\n\nWe have felt disturbances deep in Draenor. We believe Gul\'dan means to do great harm to Draenor, and our tribe will suffer greatly for it.','',26124),
(93551,'enUS','Ah, this is written in the language of the Apexis. \"... buried... evil... forbidden...\" Without the other half of this fragment this is all I can discern. We must carry on.','',26124),
(93552,'enUS','We share a problem then. Will you aid us?','We share a problem then. Will you aid us?',26124),
(93553,'enUS','... Yes. There is a way for you to... see... some of Kilrogg\'s future... and your own.','',26124),
(93554,'enUS','There you are, $p. Welcome to Val\'Sharah.','',26124),
(93555,'enUS','Welcome to Lorlathil, sanctuary of the druids. Though this forest has aged, its spirits still remember me.','',26124),
(93556,'enUS','Speak to me when you wish to depart. I know these forests better than any other.','',26124),
(93557,'enUS','Every step in this forest brings back precious memories.','',26124),
(93558,'enUS','Ages ago, the first druids molded this land to be a reflection of the Emerald Dream.','',26124),
(93559,'enUS','[lose this]','',26124),
(93560,'enUS','Merely an echo, but Val\'sharah is as close to the Dream as this world can come.','',26124),
(93561,'enUS','Prepare yourself, hero. We draw near to the Grove of Cenarius.','',26124),
(93562,'enUS','We shall stand in the presence of the Lord of the Forest.','',26124),
(93563,'enUS','He will direct us to the Tears of Elune.','',26124),
(93564,'enUS','And then you will be free to collect Aegwynn\'s other relics.','',26124),
(93565,'enUS','Follow me.','',26124),
(93566,'enUS','','Malfurion! Thank Elune you\'ve come!',26124),
(93567,'enUS','It is good to see you agai--','',26124),
(93568,'enUS','','You must come quickly; something\'s happened!',26124),
(93569,'enUS','','He was in the Dream, but now he won\'t wake. We cannot stir him.',26124),
(93570,'enUS','What is this... corruption?','',26124),
(93571,'enUS','','We--we don\'t know. It only just appeared.',26124),
(93574,'enUS','Listen well, $n.','',26124),
(93575,'enUS','Our work is nearly done.$b$bI must thank you for including me in your adventure, $n. I may have assisted you in finding the Tidestone itself, but I feel you have done so much more for me and my people.','',26124),
(93577,'enUS','I am ready, Malfurion.','I am ready, Malfurion.',26124),
(93578,'enUS','','Hatecoil! Seize them!',26124),
(93579,'enUS','Look alive, nightwatchers! Our prince needs us!','',26124),
(93580,'enUS','The Tidestone of Golganneth...','',26124),
(93581,'enUS','I\'m afraid it will be of no use to you in its current shattered state.','',26124),
(93583,'enUS','I can rebuild it. This will be my final gift to you.','',26124),
(93585,'enUS','What\'s this? This book looks... familiar.','',26124),
(93586,'enUS','I\'m ready to begin.','I\'m ready to begin.',26124),
(93587,'enUS','These lands feel very foreign to me.  Conflict, anger and hate are everywhere.','',26124),
(93588,'enUS','Would you like to join our cause?','Would you like to join our cause?',26124),
(93589,'enUS','Allow Fen Tao to join our cause?','',26124),
(93590,'enUS','I have heard stories of your glorious deeds in Pandaria!  It\'s an honor to finally meet you in person!','',26124),
(93591,'enUS','Dat not smart, little thing!','',26124),
(93592,'enUS','We hit you more hard than bass blaster!','',26124),
(93593,'enUS','Party pooper get smashed!','',26124),
(93594,'enUS','Hey... that\'s mine! I think...','',26124),
(93595,'enUS','Why are you here?','Why are you here?',26124),
(93596,'enUS','My name is Fen Tao, and I am from Pandaria.  I have spent many days traveling to these lands.  Why you ask?\n\nWe are a family of helpful people, and you look like someone that could use some help.  Just let me know how I can be of service to you.','',26124),
(93597,'enUS','To die gloriously in battle protecting your home... that is the fate all true warriors strive for.','',26124),
(93598,'enUS','<The faerie dragon looks sad.>','',26124),
(93599,'enUS','How are you?','How are you?',26124),
(93600,'enUS','Oh, I\'ve had better nights... I was working on a beautiful enchantment for months and months but no one got to see it!\n\nHey, would YOU like to see it?','',26124),
(93601,'enUS','It\'s good to see you survived that last assault, but when the Burning Legion makes its final push, they\'ll wipe us out.','',26124),
(93602,'enUS','It\'s been an honor to fight by your side all these years, but our strength was not enough to save Azeroth. Before we meet death, let\'s send a few hundred demons screaming back to the Twisting Nether!','',26124),
(93603,'enUS','Gather them together, champions! My magic will do the rest!','',26124),
(93604,'enUS','Give Sargeras my regards!','',26124),
(93605,'enUS','You will not defeat us so easily!','',26124),
(93606,'enUS','Sure, why not?','Sure, why not?',26124),
(93607,'enUS','','BEHOLD! My wondrous creation! Convincing, isn\'t it?',26124),
(93608,'enUS','We will reap your souls.','',26124),
(93609,'enUS','I must protect our sacred grounds...','',26124),
(93610,'enUS','I will not allow you to take that!','',26124),
(93611,'enUS','Die desecrator!','',26124),
(93612,'enUS','Rally up ya scurvy dogs. Are you going to let this big burly giant drag your fortunes to the bottom of the sea?','',26124),
(93613,'enUS','Come on lads! Slay that large beast so we can be off.','',26124),
(93614,'enUS','Here spirits are restless. They are angry we are here. They will not stop me.','',26124),
(93615,'enUS','Put yer backs into it! I don\'t want to get ate.','',26124),
(93616,'enUS','Now that\'s the spirit! Fire another salvo across that thing\'s chin.','',26124),
(93617,'enUS','Stand to and bring that thing down or its the gullet for all of you.','',26124),
(93618,'enUS','','Thanks for taking a moment to appreciate my hard work. It really makes me happy!',26124),
(93619,'enUS','We go. Find me Kilrogg.','',26124),
(93620,'enUS','Well done, men! You have saved your beloved captain and- wait... where are you all going?','',26124),
(93621,'enUS','You are not welcome here invader, but we must talk.','',26124),
(93622,'enUS','Blood and thunder, there you are! We must speak at once, champion.','',26124),
(93623,'enUS','Saurfang wants to see you at once.','',26124),
(93624,'enUS','Khadgar, can you direct this portal to Orgrimmar?','',26124),
(93625,'enUS','I will follow your lead, champion. We mustn\'t keep Saurfang waiting.','',26124),
(93626,'enUS','Khadgar, old friend! I hate to interrupt, but I need to speak with $n immediately.','',26124),
(93627,'enUS','King Magni of Ironforge wants to see you at once.','',26124),
(93628,'enUS','Khadgar, can you direct this portal to Stormwind?','',26124),
(93629,'enUS','I will follow your lead, champion. We mustn\'t keep King Magni waiting.','',26124),
(93630,'enUS','They are raiding Zeth\'Gol. We need to pull back and defend my home -','',26124),
(93631,'enUS','Patience, Kilrogg. Your warriors must continue to seek the cipher.','',26124),
(93632,'enUS','But-','',26124),
(93633,'enUS','Once the cipher is mine our enemies will have no safe ground... wait - do you feel it? We are being watched. Hold still.','',26124),
(93634,'enUS','Your sacred grounds are defiled, Kilrogg. Do not worry - I have taken care of the problem.','',26124),
(93635,'enUS','Destroying Armaments','Destroying Armaments',26124),
(93636,'enUS','Cutscene Placeholder: The God-King blows up the bridge, blocking your way up the mountain path!','',26124),
(93638,'enUS','Helheim... the sooner we find a way out of here the better.','',26124),
(93639,'enUS','Seaweed Disguise','Seaweed Disguise',26124),
(93640,'enUS','You know not what you do, foolish mortal.','',26124),
(93641,'enUS','Wh-what are you... doing?!','',26124),
(93642,'enUS','You... you dare disturb my work?!','',26124),
(93643,'enUS','What is the meaning of this?!','',26124),
(93644,'enUS','You dare taunt death itself, mortal?','',26124),
(93645,'enUS','','We seek Solog Roark!',26124),
(93646,'enUS','','We don\'t want you dead. We need a shipwright.',26124),
(93647,'enUS','You found him. If you wish me dead, put a hammer in my hands and let\'s make a fight of it.','',26124),
(93648,'enUS','Hah! There\'s none better.','',26124),
(93649,'enUS','Go use the eye! I will stop the spirits from attacking you.','',26124),
(93650,'enUS','I\'m counting on you and my drakes to protect me, $n.$b$bThe ritual I am about to perform is complicated, and will take some time. It will almost certainly attract the attention of Azsuna\'s more unsavory inhabitants.','',26124),
(93651,'enUS','I will protect you, Senegos.','I will protect you, Senegos.',26124),
(93652,'enUS','Kilrogg... at the citadel. I must kill him... before I lose... everything...','',26124),
(93653,'enUS','','Farondis did this to us!',26124),
(93654,'enUS','','Why has the queen forsaken us?',26124),
(93655,'enUS','','Join us. Join us forever...',26124),
(93656,'enUS','','Azshara forgive me!',26124),
(93657,'enUS','Your Bleeding Hollow dogs have failed, Gul\'dan. They are as inept as ever.','',26124),
(93658,'enUS','Arrogance will not be tolerated, Iskar. What of your search for the cipher? Or are you too... a failure?','',26124),
(93659,'enUS','In the ruins I\'ve found mention of a dark power hidden within the earth. This fragment will show you the path to where it is sealed.','',26124),
(93660,'enUS','You have done well Iskar! Success will be rewarded.','',26124),
(93661,'enUS','Drink and you will fly once more.','',26124),
(93663,'enUS','This feeling... my wings are strong again! I am forever yours, my master!','',26124),
(93664,'enUS','Go, prepare an army of your kind. They too will serve the legion.','',26124),
(93665,'enUS','We are ready. Let it come!','',26124),
(93666,'enUS','Marius, you prideful glutton. You almost got me killed.','',26124),
(93667,'enUS','I... can\'t... hold it... any longer.','',26124),
(93668,'enUS','This... demon... is too powerful. I can\'t contain it for long and we... are not strong enough... to defeat it by ourselves.','',26124),
(93669,'enUS','Kilrogg and others... they wounded themselves here. Mmm... sacrifice?','',26124),
(93670,'enUS','It is Kilrogg\'s eye, I can smell it. We must go, the spirits are enraged.','',26124),
(93671,'enUS','Could I purchase a copy?','Could I purchase a copy?',26124),
(93672,'enUS','','Smooth sailing so far. Give me a status report.',26124),
(93673,'enUS','King Wrynn and the Stormwind Fleet arrived several hours ago. Reports indicate heavy fighting.','',26124),
(93674,'enUS','<The ghost wails mournfully.>','',26124),
(93675,'enUS','I wish to hear your music.','I wish to hear your music.',26124),
(93676,'enUS','<The ghost seems a bit happier.>','',26124),
(93677,'enUS','Let\'s see what we can discover. Oh and keep your guard, this might draw some attention our way.','',26124),
(93678,'enUS','I\'ve seen enough. Iskar is lost to us, he has traded one curse for another.','',26124),
(93679,'enUS','We are all that stands between the sanctity of this forest and the demonic legions that would raze it to the ground.','',26124),
(93680,'enUS','The power - it courses through my veins! It is like nothing you\'ve ever felt.','The power - it courses through my veins! It is like nothing you\'ve ever felt.',26124),
(93681,'enUS','Gul\'dan will save us. Gul\'dan is our last hope. His is the way!','Gul\'dan will save us. Gul\'dan is our last hope. His is the way!',26124),
(93682,'enUS','Great is the power of the Legion. You will know no fear. No doubt. Everything is clear!','Great is the power of the Legion. You will know no fear. No doubt. Everything is clear!',26124),
(93683,'enUS','Your destiny lies in Tanaan. Come! Drink the fel gift, and you will be as war incarnate.','Your destiny lies in Tanaan. Come! Drink the fel gift, and you will be as war incarnate.',26124),
(93684,'enUS','Your leaders have failed you! Only Gul\'dan can save our race. Join us or perish in defeat.','Your leaders have failed you! Only Gul\'dan can save our race. Join us or perish in defeat.',26124),
(93685,'enUS','This is not your destiny. Gul\'dan will lead us to victory. It is not too late!','This is not your destiny. Gul\'dan will lead us to victory. It is not too late!',26124),
(93686,'enUS','Need some help with the shopping list?\n\nBass Blaster\'s easy. The Ogres love loud music to go with their fights at the Ring of Blood. The spectators aren\'t there to fight. Just take it from them!\n\nI seem to remember a working Laz-tron down at Pinchwhistle Point, from a gig I played there once.\n\nWe\'ll never find a real Phonic Amplifier, so just rip a big hunk of metal off of one of those Arakkoa sun constructs. That\'ll do fine.\n\nAs for the capacitor, you\'ll probably need to break open an Iron Horde shredder. Seems like your kind of work.\n\nOh, and the kind of wood I need has to be seriously ancient, so Everbloom Wilds is probably your best bet in Draenor.','Need some help with the shopping list?\n\nBass Blaster\'s easy. The Ogres love loud music to go with their fights at the Ring of Blood. The spectators aren\'t there to fight. Just take it from them!\n\nI seem to remember a working Laz-tron down at Pinchwhistle Point, from a gig I played there once.\n\nWe\'ll never find a real Phonic Amplifier, so just rip a big hunk of metal off of one of those Arakkoa sun constructs. That\'ll do fine.\n\nAs for the capacitor, you\'ll probably need to break open an Iron Horde shredder. Seems like your kind of work.\n\nOh, and the kind of wood I need has to be seriously ancient, so Everbloom Wilds is probably your best bet in Draenor.',26124),
(93687,'enUS','Destroy them - in the name of Gul\'dan!','Destroy them - in the name of Gul\'dan!',26124),
(93688,'enUS','Nothing will stop us.','Nothing will stop us.',26124),
(93689,'enUS','Where can I get more music rolls?','Where can I get more music rolls?',26124),
(93690,'enUS','Kill me if you can - but nothing will stop the Legion I serve!','Kill me if you can - but nothing will stop the Legion I serve!',26124),
(93691,'enUS','Another victory in the name of Gul\'dan!','Another victory in the name of Gul\'dan!',26124),
(93692,'enUS','Deep in the heart of Blackrock is a track so legendary, it takes two dragons to protect it.','',26124),
(93693,'enUS','Up for a journey into the Black Temple? You still won\'t be prepared for the hard hitting bass of the track you\'ll find.','',26124),
(93694,'enUS','Face his wrath, in that flying fortress, with that icy weather? All for new music? You\'re crazy!','',26124),
(93695,'enUS','Finding classic tracks takes hard work, and sometimes that means flying on the back of a colossal, cataclysmic dragon. Them\'s the breaks.','',26124),
(93696,'enUS','Conquering fear itself will help you glimpse the Heart of Pandaria, musically speaking, of course.','',26124),
(93697,'enUS','You\'re already leading a campaign against the Iron Horde. Might as well take Blackhand\'s music roll collection while you\'re at it.','',26124),
(93698,'enUS','Lion\'s Landing has a track as fresh as the sea. Watch out for sharks!','',26124),
(93699,'enUS','EXTREMELY PLACEHOLDER EVENT!!!! YSERA ARRIVES, POOF!','EXTREMELY PLACEHOLDER EVENT!!!! YSERA ARRIVES, POOF!',26124),
(93700,'enUS','Got a rod and reel handy? I hear there\'s an artist leaving her work in creative places in Ironforge.','',26124),
(93701,'enUS','Tinkertown is good, clean fun. Good music, too!','',26124),
(93702,'enUS','Are you dying for more music? I hear the spirits of Duskwood are something to behold.','',26124),
(93703,'enUS','I camped out once in Winterspring with this amazing artist who loved cold, crisp weather. I\'d love to hear his stuff again.','',26124),
(93704,'enUS','Ashenvale\'s a magical place. Musicians have been known to find shady nooks there, and write for weeks on end.','',26124),
(93705,'enUS','Songs of the Black Temple used to echo through the Warden\'s prison. I wonder if I\'ll ever hear those again.','',26124),
(93706,'enUS','Invincible is a pretty bold name for a music track, let alone a horse.','',26124),
(93707,'enUS','Opera can make a great roll, if you\'re adventurous enough to find it.','',26124),
(93708,'enUS','Songs of Northrend valor are worth seeking out as morale boosters for your troops.','',26124),
(93709,'enUS','Faerie Dragons are known to make amazing music, if you catch them in the right Glade.','',26124),
(93710,'enUS','Willing to get dirty for a new track? I hear the Stranglethorn Arena\'s prize pot has been sweetened lately.','',26124),
(93711,'enUS','I once ran into a grizzled musician in the hills of Northrend with a ton of talent. He\'d be worth finding.','',26124),
(93712,'enUS','Titan songs of Ulduar are awfully hard to come by these days.','',26124),
(93713,'enUS','Hearing carousel music always takes me back. Maybe the Darkmoon Faire has a roll of that somewhere?','',26124),
(93714,'enUS','Sylvanas\' legendary lamentation was recorded only once. Rumor is she keeps it in a very safe place.','',26124),
(93715,'enUS','Tyrande herself loves the mysterious Shalandis Isle roll. She has the only copy I\'ve ever seen.','',26124),
(93716,'enUS','Lorewalkers love great music almost as much as they love food and drink.','',26124),
(93717,'enUS','Don\'t you just love the outdoors? Go ahead, breathe in that crisp mountain air!','',26124),
(93718,'enUS','It\'s crisp!','It\'s crisp!',26124),
(93719,'enUS','I literally just said that.','',26124),
(93720,'enUS','<Breathe deeply.>','<Breathe deeply.>',26124),
(93721,'enUS','Ha ha! There you go! Now what brings you out here, friend?','',26124),
(93722,'enUS','I\'d rather be in a tavern right now.','I\'d rather be in a tavern right now.',26124),
(93723,'enUS','If there\'s a game of Hearthstone going on there, you\'ll probably find my father as well.','',26124),
(93724,'enUS','I\'m looking for a song...','I\'m looking for a song...',26124),
(93725,'enUS','Nothing in particular.','Nothing in particular.',26124),
(93726,'enUS','Ha! Well I wish you the best in your travels, then!','',26124),
(93727,'enUS','The... mountain air?','The... mountain air?',26124),
(93728,'enUS','You sure do like to talk about air! Bit of a one-trick subject, though. \n\nBoring, is what I\'m saying.','',26124),
(93729,'enUS','A song? Well, there\'s nothing that goes better with lumberjacking than singing, that\'s for sure!  \n\nWhat kind of song are you looking for?','',26124),
(93730,'enUS','A song about lumberjacking?','A song about lumberjacking?',26124),
(93731,'enUS','A song about adventure!','A song about adventure!',26124),
(93732,'enUS','A song about the wilderness.','A song about the wilderness.',26124),
(93733,'enUS','We don\'t sing songs ABOUT lumberjacking. That would be crazy.','',26124),
(93734,'enUS','Can\'t say I\'ve had too many of those, spend most of my time around these parts.','',26124),
(93735,'enUS','Ha, yes! The wilderness is both serene and wild, the perfect subject of a song.\n\nI happen to have one of the old lumberjack\'s songs written down here. Would you like a copy?','',26124),
(93736,'enUS','Yes!','Yes!',26124),
(93737,'enUS','Yes, please.','Yes, please.',26124),
(93738,'enUS','No.','No.',26124),
(93739,'enUS','Well, it was nice talking to you.','',26124),
(93740,'enUS','Here you go!','',26124),
(93742,'enUS','I hope that song reminds you of the wilds of Northrend!','',26124),
(93743,'enUS','Feeling a song of war? Domination Point in Pandaria used to shake with heavy drum beats.','',26124),
(93744,'enUS','How about fishing the Bluffs? An eccentric musician is known to toss rolls of hers in there, from time to time.','',26124),
(93745,'enUS','Trolls make some... interesting music. Their best stuff is somewhere in Zul\'Gurub.','',26124),
(93746,'enUS','Where can I get some really hard to find music rolls?','Where can I get some really hard to find music rolls?',26124),
(93747,'enUS','I still need more music rolls! Where should I go to finish my collection?','I still need more music rolls! Where should I go to finish my collection?',26124),
(93748,'enUS','Such power - you\'ve never experienced anything like it.','Such power - you\'ve never experienced anything like it.',26124),
(93749,'enUS','Put your faith in Gul\'dan. He knew what was right all along.','Put your faith in Gul\'dan. He knew what was right all along.',26124),
(93750,'enUS','Our time is now. Gul\'dan will save us. Our power will be infinite!','Our time is now. Gul\'dan will save us. Our power will be infinite!',26124),
(93751,'enUS','The fel is not a curse. It\'s a gift. A wonderous gift!','The fel is not a curse. It\'s a gift. A wonderous gift!',26124),
(93752,'enUS','','Were it not for the Archdruid Seferaes Nightmane, we would not be alive.$b$bWe were greatly outnumbered and wounded, but Seferaes ferociously fought to preserve our lives with no regard to his own safety.$b$bThe Archdruid was wounded in the battle and, though we tried to treat his wounds, he insisted that there was no time.$b$bLast I saw of him, he fought his way up the cliff to Moonrise Cavern.',26124),
(93753,'enUS','Malfurion Stormrage has sent me to find the Archdruid of the Prowl.','Malfurion Stormrage has sent me to find the Archdruid of the Prowl.',26124),
(93754,'enUS','<Reshad reads over the page.>$B$BSo, his travel here was in truth to hide his search for this \"cipher.\" This is troubling but there are many unanswered questions that remain.$b$bI have a small vial of enchanted sands that when paired with the book will show us what occurred when it was last in Iskar\'s hands.$b$bWhen you are ready we will see what really happened.','',26124),
(93755,'enUS','','There were... too many...',26124),
(93756,'enUS','','I see enemies coming in from the lagoon!',26124),
(93757,'enUS','Those are no enemies, starlight.','',26124),
(93758,'enUS','Farondis, old friend. Is that you?','',26124),
(93759,'enUS','We\'re here to help. The naga are right on our tail.','',26124),
(93760,'enUS','The Tidestone calls to them. We cannot let them approach.','',26124),
(93761,'enUS','$p. Aid Prince Farondis in the southeast.','',26124),
(93762,'enUS','Heroes! Something is attacking me from behind!','',26124),
(93763,'enUS','Someone, anyone, go protect Senegos!','',26124),
(93764,'enUS','$p, to me! The naga are about to break through!','',26124),
(93765,'enUS','The Tidestone... such power...','',26124),
(93766,'enUS','','You... Runas! What are you doing here?',26124),
(93767,'enUS','So sorry, my friends. I just couldn\'t help myself.','',26124),
(93768,'enUS','Sisters, brothers! The great mana crystal I promised lies in the pool above!','',26124),
(93769,'enUS','','They\'re attacking, we need re-enforcements in the north east.',26124),
(93770,'enUS','','|TInterface\\Icons\\achievement_boss_princesstheradras.blp:40|tMy master\'s master knows your plans, dragon. The Tidestone shall not be yours.',26124),
(93771,'enUS','The demons have returned.','',26124),
(93772,'enUS','Idri. Protect the great dragon at all costs.','',26124),
(93773,'enUS','','Yes, my prince.',26124),
(93774,'enUS','','Come join us, $p. We could use your weapon.',26124),
(93775,'enUS','Forget the Tidestone, brothers. Let the lizards and the lowborn have their crystal.','',26124),
(93776,'enUS','We will feast on the dragons instead!','',26124),
(93777,'enUS','$p, my starlight is in danger! Protect her!!','',26124),
(93778,'enUS','Great day for some tunes, eh Commander?','',26124),
(93779,'enUS','A quiet garrison is a sad garrison. Nothing some music can\'t fix!','',26124),
(93780,'enUS','Need some help with the shopping list?\n\nI hate to encourage theft, but the Ogres partying at the Ring of Blood love their Bass Blaster. I doubt they\'ll be in a fighting mood, but don\'t stick around after you swipe it from them.\n\nI had a Laz-tron Disc Reader stolen from me a few weeks ago, and I couldn\'t get the Goblin smell out of my bunk for a week. Check Pinchwhistle Point.\n\nPhonic Amplifiers are tough to find. A piece of metal from an Arakkoa construct might be enough.\n\nIf you\'re up to sticking it to some Iron Horde, their shredders in Talador usually have the sort of capacitor I need.\n\nAnd for the finishing touch, wood from the ancients in Gorgrond, if the Commandojacks have spared any.','Need some help with the shopping list?\n\nI hate to encourage theft, but the Ogres partying at the Ring of Blood love their Bass Blaster. I doubt they\'ll be in a fighting mood, but don\'t stick around after you swipe it from them.\n\nI had a Laz-tron Disc Reader stolen from me a few weeks ago, and I couldn\'t get the Goblin smell out of my bunk for a week. Check Pinchwhistle Point.\n\nPhonic Amplifiers are tough to find. A piece of metal from an Arakkoa construct might be enough.\n\nIf you\'re up to sticking it to some Iron Horde, their shredders in Talador usually have the sort of capacitor I need.\n\nAnd for the finishing touch, wood from the ancients in Gorgrond, if the Commandojacks have spared any.',26124),
(93781,'enUS','For Gul\'dan!','For Gul\'dan!',26124),
(93782,'enUS','You\'ll never defeat us. We are legion!','You\'ll never defeat us. We are legion!',26124),
(93783,'enUS','','The Archdruids have studied at the feet of Cenarius himself for thousands of years.',26124),
(93784,'enUS','Your fate is sealed.','Your fate is sealed.',26124),
(93785,'enUS','For the glory of Gul\'dan!','For the glory of Gul\'dan!',26124),
(93786,'enUS','Get moving! We need to get these supplies to Tanaan.','',26124),
(93787,'enUS','We\'re pulling out. Go go go!','',26124),
(93788,'enUS','Step it up, you peons. You don\'t want to be left behind.','',26124),
(93789,'enUS','Gul\'dan wants us in Tanaan. This is our last chance. Haul those crates!','',26124),
(93790,'enUS','Faster, faster. Let\'s get this gear on the boat to Tanaan. Today, you scrubs!','',26124),
(93791,'enUS','This is no place to linger. I\'ll head back to Aktar\'s camp.','',26124),
(93792,'enUS','If anyone is going to be able to stop Iskar, it\'s you.','',26124),
(93793,'enUS','I was just speaking with Aktar. Did you know that he used to be a Sky Admiral before he was banished by the adherents?','',26124),
(93794,'enUS','Keep Aktar safe Percy. I\'ll be back soon.','',26124),
(93795,'enUS','The forest whispered of your arrival, young one.$b$bFew outsiders have entered my precious grove. Please show reverence during your visit.','',26124),
(93796,'enUS','These harpies have coexisted peacefully with us for ages.$b$bWhat could have prompted such aggression?','',26124),
(93797,'enUS','','Fools! This forest will soon die... and you with it!',26124),
(93798,'enUS','','Wretched! Soon... <cough>... you will follow me in death!',26124),
(93799,'enUS','','',26124),
(93800,'enUS','Come at me!','',26124),
(93801,'enUS','Stab it! Stab it! Hahaha!','',26124),
(93802,'enUS','You\'re not taking our dragons!','',26124),
(93803,'enUS','Let\'s kill it!','',26124),
(93804,'enUS','Arrgh!','',26124),
(93805,'enUS','You win... this time...','',26124),
(93806,'enUS','Can\'t see... too much pain...','',26124),
(93807,'enUS','Just wanted... a little fun...','',26124),
(93808,'enUS','The Nightmare will consume us all!','',26124),
(93809,'enUS','All that remains... agony... madness!','',26124),
(93810,'enUS','<The body of this nightsaber matriarch is not long dead. It appears to have put up a stalwart fight before eventually succumbing to its wounds.>','<The body of this nightsaber matriarch is not long dead. It appears to have put up a stalwart fight before eventually succumbing to its wounds.>',26124),
(93811,'enUS','','Flesh and bone to earth and stone!',26124),
(93812,'enUS','','This land is ours now!',26124),
(93813,'enUS','','Behold my curse!',26124),
(93814,'enUS','','Fool! Die!',26124),
(93815,'enUS','','The Witchmother commands it!',26124),
(93816,'enUS','','Flay the flesh and scatter the bones!',26124),
(93817,'enUS','','No... it cannot be!',26124),
(93818,'enUS','','This land... is.. ours...',26124),
(93819,'enUS','','Ahh... curse you!',26124),
(93820,'enUS','','We will not be stopped!',26124),
(93821,'enUS','','You cannot... escape... the curse!',26124),
(93822,'enUS','','Crrggghaaawww!',26124),
(93823,'enUS','I live!','I live!',26124),
(93824,'enUS','Ahh, to breathe again!','Ahh, to breathe again!',26124),
(93825,'enUS','Bless you, stranger!','Bless you, stranger!',26124),
(93826,'enUS','You have my gratitude, traveler.','You have my gratitude, traveler.',26124),
(93827,'enUS','I felt myself slipping away...','I felt myself slipping away...',26124),
(93828,'enUS','You... you have saved me!','You... you have saved me!',26124),
(93829,'enUS','','Those afflicted with the curse have little time... we must hurry!',26124),
(93830,'enUS','','We have saved all that we can, $n. I\'ll meet you back in the grove. Elen\'elora-ethil.',26124),
(93831,'enUS','Terrors... everywhere!','Terrors... everywhere!',26124),
(93832,'enUS','No... not my mind! Stop!','No... not my mind! Stop!',26124),
(93833,'enUS','The Nightmare comes for you!','The Nightmare comes for you!',26124),
(93834,'enUS','Help me! Why won\'t you help me?!','Help me! Why won\'t you help me?!',26124),
(93835,'enUS','They\'re chasing me... They... Make them stop!','They\'re chasing me... They... Make them stop!',26124),
(93836,'enUS','Bwahaha... HAHAHA!','Bwahaha... HAHAHA!',26124),
(93837,'enUS','Welcome to your nightmare!','',26124),
(93838,'enUS','Soon, you will welcome death with open arms!','',26124),
(93839,'enUS','This land shall be consumed!','',26124),
(93840,'enUS','You cannot stop us. We are Legion!','',26124),
(93841,'enUS','My master will devour... your... soul...','',26124),
(93842,'enUS','The Nightmare... welcomes me...','',26124),
(93843,'enUS','You cannot... escape... your dreams....','',26124),
(93844,'enUS','Fool... this land is already doomed...','',26124),
(93845,'enUS','Who dares disturb Lord Balnazzar\'s work?','',26124),
(93846,'enUS','You cannot hide from our gaze.','',26124),
(93847,'enUS','Our lord needs more time. Slay them all in the name of the Legion!','',26124),
(93848,'enUS','The Ashbringer belongs to the Legion. All who stand in our way shall burn!','',26124),
(93849,'enUS','Zerus... will... stop... you...','',26124),
(93850,'enUS','You will suffer for a thousand lifetimes.','',26124),
(93851,'enUS','NO! The Ashbringer... must not...','',26124),
(93852,'enUS','','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-COMMANDER SARANNIS.blp:50:80|t$b[Lady Liadrin] By the Light, Tirion is alive!',26124),
(93853,'enUS','','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-COMMANDER SARANNIS.blp:50:80|t$b[Lady Liadrin] We will scout ahead and try to find some sign of Tirion. We\'re with you!',26124),
(93854,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-GRAND CHAMPIONS-ALLIANCE.blp:50:80|t$b[Lord Maxwell Tyrosus] We found him, champion! Tirion is alive!','',26124),
(93855,'enUS','','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-COMMANDER SARANNIS.blp:50:80|t$b[Lady Liadrin] We found him, champion! Tirion is alive!',26124),
(93856,'enUS','Tirion needs to speak with you, champion. The Ashbringer is lost!','',26124),
(93857,'enUS','','Tirion needs to speak with you, champion. The Ashbringer is lost!',26124),
(93858,'enUS','','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-COMMANDER SARANNIS.blp:50:80|t$b[Lady Liadrin] Champion, move ahead and find Tirion. We will cover your advance!',26124),
(93859,'enUS','','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-COMMANDER SARANNIS.blp:50:80|t$b[Lady Liadrin] The Ashbringer is somewhere in the crevice ahead - we need to hold these demons off long enough for someone to make it through their lines!',26124),
(93860,'enUS','What sort of bait would ya like?','',26124),
(93861,'enUS','Abyssal Gulper Eel','Abyssal Gulper Eel',26124),
(93862,'enUS','Sea Scorpion','Sea Scorpion',26124),
(93863,'enUS','Blind Lake Sturgeon','Blind Lake Sturgeon',26124),
(93864,'enUS','Blackwater Whiptail','Blackwater Whiptail',26124),
(93865,'enUS','Fire Ammonite','Fire Ammonite',26124),
(93866,'enUS','Jawless Skulker','Jawless Skulker',26124),
(93867,'enUS','Fat Sleeper','Fat Sleeper',26124),
(93868,'enUS','Any regular fish bait?','Any regular fish bait?',26124),
(93869,'enUS','','Our first combat mission, time to prove that Bravery isn\'t just a name.',26124),
(93870,'enUS','','I haven\'t seen so much as a seagull for hours now.',26124),
(93871,'enUS','There is a foulness in the air, and we are headed directly towards it.','',26124),
(93872,'enUS','Face my wrath.','',26124),
(93873,'enUS','Eternal suffering.','',26124),
(93874,'enUS','','You\'ll find the giants to the southeast. There are a few ways into their arena. Good luck.',26124),
(93875,'enUS','Aid me, damn you. Our lord must not be disturbed!','',26124),
(93876,'enUS','','Disciples! Your work is not yet done!',26124),
(93877,'enUS','I... am returned...','',26124),
(93878,'enUS','Once more into the breach!','',26124),
(93879,'enUS','I am the Enforcer\'s will... and your demise.','',26124),
(93880,'enUS','You will trespass no further!','',26124),
(93881,'enUS','','I was to be... undying...',26124),
(93882,'enUS','','Harbinger, restore my wounds!',26124),
(93883,'enUS','','The Sovereign watches over me!',26124),
(93884,'enUS','','The Eredar are no strangers to war. Are you so eager to meet your end?',26124),
(93885,'enUS','','Enough! This is where you die!',26124),
(93886,'enUS','','What a... tragedy...',26124),
(93887,'enUS','','A tempest of righteous fire!',26124),
(93888,'enUS','By all that is good in this world... you did it. The Ashbringer is saved!','',26124),
(93889,'enUS','','Insects deserve to be crushed!',26124),
(93890,'enUS','The blade glows so brightly... not even at the top of Icecrown Citadel have I seen it so powerful. It must be so.','',26124),
(93891,'enUS','','Your pathetic defeat was... inevitable.',26124),
(93892,'enUS','All Paladins, hear my voice. The Ashbringer has chosen its successor.','',26124),
(93893,'enUS','$p will wield its power against the forces of the Legion. They will strike at the very heart of darkness. The Light shall TRIUMPH!','',26124),
(93894,'enUS','','Your attempts, meaningless.',26124),
(93895,'enUS','','Your existence, without purpose.',26124),
(93896,'enUS','','Your failures, absolute.',26124),
(93897,'enUS','','Your thoughts, insipid.',26124),
(93898,'enUS','Work faster, I will not tolerate any further delays!','',26124),
(93899,'enUS','If this reaver isn\'t finished in time, I will devour your souls!','',26124),
(93900,'enUS','Yes! Fight for your pathetic life, mortal! I could use the entertainment.','',26124),
(93901,'enUS','I will feast upon your heart!','',26124),
(93902,'enUS','You will suffer for this disturbance!','',26124),
(93903,'enUS','This... isn\'t over!','',26124),
(93904,'enUS','I\'ll be back... I\'ll... have my revenge...','',26124),
(93905,'enUS','Fool! The shadows betray you!','',26124),
(93906,'enUS','I am prepared. Take me to the Nor\'danil Wellspring.','I am prepared. Take me to the Nor\'danil Wellspring.',26124),
(93907,'enUS','I feel strong enough to perform this task, $n, but it cannot be done here. I must first take the Tidestone fragments to the Nor\'danil Wellspring, in the west.$b$bMy drakes will protect me, of course... but I would appreciate having you nearby. Hop on my back. I will take you there much more quickly than your small legs could manage.','',26124),
(93908,'enUS','','These naga invaded Azsuna only recently. They\'ve been trying to free Prince Farondis.\n\nNo doubt, like you, they and Queen Azshara are after the Tidestone of Golganneth. The prince knows where it is.',26124),
(93909,'enUS','No, please! No!','No, please! No!',26124),
(93910,'enUS','No, please! No!','No, please! No!',26124),
(93911,'enUS','Another ear for my necklace!','Another ear for my necklace!',26124),
(93912,'enUS','I saw you at the Iron Docks! This time you\'re going down!','I saw you at the Iron Docks! This time you\'re going down!',26124),
(93913,'enUS','You\'re finished!','You\'re finished!',26124),
(93914,'enUS','Engaging!','Engaging!',26124),
(93915,'enUS','Drop \'em!','Drop \'em!',26124),
(93916,'enUS','Fire at will!','Fire at will!',26124),
(93917,'enUS','Suppress that target!','Suppress that target!',26124),
(93918,'enUS','(Possible transition scene showing Thrymjaris empowering your artifact.)','',26124),
(93919,'enUS','Are you ready to take the fight to the Drekirjar?','',26124),
(93920,'enUS','Let\'s blast these Vrykul!','Let\'s blast these Vrykul!',26124),
(93921,'enUS','How nice of you to spare me the trouble of culling the weak. Come, I will show you a real fight!','',26124),
(93922,'enUS','Soon, you will beg for death!','',26124),
(93923,'enUS','Couldn\'t take the pain?','',26124),
(93924,'enUS','Did you even try?','',26124),
(93925,'enUS','Ah, your tears are pure ecstasy.','',26124),
(93926,'enUS','Inconceivable...','',26124),
(93927,'enUS','Sargeras fills us with his presence.','',26124),
(93928,'enUS','Feel the wrath of the God of Fel and Flame!','',26124),
(93929,'enUS','The Destroyer of Worlds grants me his power. Your time has come, mortal!','',26124),
(93930,'enUS','Hey there, $c.  I\'m looking to trade for some leather, so whaddya say?','Hey there, $c.  I\'m looking to trade for some leather, so whaddya say?',26124),
(93931,'enUS','I grow bored of waiting for a real challenge.','',26124),
(93932,'enUS','I knew you were too pathetic to face me!','',26124),
(93933,'enUS','I will show you to your maker!','I will show you to your maker!',26124),
(93934,'enUS','Are you so eager to meet your ancestors?','Are you so eager to meet your ancestors?',26124),
(93935,'enUS','Unfortunately for you, your spirit will never see Auchindoun!','Unfortunately for you, your spirit will never see Auchindoun!',26124),
(93936,'enUS','The naaru\'s promises were empty. Our new master gives us true power!','The naaru\'s promises were empty. Our new master gives us true power!',26124),
(93937,'enUS','What good is faith, when the Legion grants such power?','What good is faith, when the Legion grants such power?',26124),
(93938,'enUS','Fool! You follow the wrong path!','Fool! You follow the wrong path!',26124),
(93939,'enUS','The Legion is truth. The Legion is strength!','The Legion is truth. The Legion is strength!',26124),
(93940,'enUS','In the Light, I saw only emptiness.','In the Light, I saw only emptiness.',26124),
(93941,'enUS','Who dares interrupt me?','Who dares interrupt me?',26124),
(93942,'enUS','What a nuisance. I will deal with you, first!','What a nuisance. I will deal with you, first!',26124),
(93943,'enUS','Katra zil shukil! You will die for your insolence!','Katra zil shukil! You will die for your insolence!',26124),
(93944,'enUS','You will take our secrets to the grave!','You will take our secrets to the grave!',26124),
(93945,'enUS','The power of the Legion flows through me!','The power of the Legion flows through me!',26124),
(93946,'enUS','','They are here Teron\'gor! We must leave.',26124),
(93947,'enUS','NO! So many souls... such power...','',26124),
(93948,'enUS','You will not interrupt my feast!','',26124),
(93949,'enUS','You cannot stop me now!','',26124),
(93950,'enUS','I will add your soul to the others I have claimed!','',26124),
(93951,'enUS','I must have it all!','',26124),
(93952,'enUS','I will show you my new power!','',26124),
(93953,'enUS','','Cease your desecration of my ancestors!',26124),
(93954,'enUS','','Time to die vile beast!',26124),
(93955,'enUS','Bah! I will return here once Gul\'dan has annihilated you.','',26124),
(93956,'enUS','Your boots! Yes... we has them!','',26124),
(93957,'enUS','Attack the feet! The feet!','',26124),
(93958,'enUS','','Wretched $c, be purged by the flames of a new world!',26124),
(93959,'enUS','If you\'ll excuse us, Council and guests. I need to speak with $n immediately.','',26124),
(93960,'enUS','Follow me, friend. This won\'t take long, I promise.','',26124),
(93961,'enUS','','I will do whatever it takes to stop Gul\'dan. Wherever you lead, I will follow... commander.',26124),
(93962,'enUS','Start Phase 2!','',26124),
(93963,'enUS','You have been gathered here because you are weak. On every front we have been broken by our enemies. Even now they close in upon us.','',26124),
(93964,'enUS','Why did we end up in this situation? Pride. Hellscream\'s foolish pride denied us the means to unleash our true strength.','',26124),
(93965,'enUS','However Gul\'dan is merciful. He again offers you the power to surpass your mortal limits! Partake of this gift and obtain the might that\'s been denied you!','',26124),
(93966,'enUS','This device is imbued with powerful magic. Perhaps it is linked to these portraits lining the chamber walls?','',26124),
(93967,'enUS','You have been chosen to partake of the master\'s gift. Step forward and drink. Obtain the strength that has for so long been denied you!','You have been chosen to partake of the master\'s gift. Step forward and drink. Obtain the strength that has for so long been denied you!',26124),
(93968,'enUS','','They must be rooted out before they accomplish their task.',26124),
(93969,'enUS','','I fear for the countless souls this Gorefiend has consumed. He must be destroyed!',26124),
(93970,'enUS','Start Phase 3!','',26124),
(93971,'enUS','Start Phase 4!','',26124),
(93972,'enUS','Hold them here, Mannoroth. My work is almost done. Our master comes...','',26124),
(93973,'enUS','We need you to sneak into the compound. SNEAK! Stealthy! Not go blasting around in a rocket like some sort of goblin maniac. Honestly, now. We should\'ve never given you a garrison.','',26124),
(93974,'enUS','|TInterface\\Icons\\warlock_summon_doomguard.blp:20|t|cFFFF0000$n|r has been afflicted with |cFFFF0000|Hspell:181275|h[Curse of the Legion]|h|r!','',26124),
(93975,'enUS','|cFFFF0000%s|r appears and begins to empower the Fel Spire!','',26124),
(93976,'enUS','Raaaaaaghh!!!','',26124),
(93977,'enUS','GRRAAaaaaggghhh!!!','',26124),
(93978,'enUS','|cFFFF0000%s|r begins to empower the Fel Spire!','',26124),
(93979,'enUS','DIE! DIE! DIE!','',26124),
(93980,'enUS','I AM IMMORTAL!!','',26124),
(93981,'enUS','B... Blood! Can\'t fight it... must kill!','',26124),
(93982,'enUS','It\'s so... dark...','',26124),
(93983,'enUS','I regret nothing...','',26124),
(93984,'enUS','Just one more... strike...','',26124),
(93985,'enUS','I\'m... free now...','',26124),
(93986,'enUS','I... should have... never drank...','',26124),
(93987,'enUS','You make it seem so easy.','',26124),
(93988,'enUS','Grim... but necessary.','',26124),
(93989,'enUS','Back to the shadows with them.','',26124),
(93990,'enUS','I didn\'t expect that to be over so quickly.','',26124),
(93991,'enUS','|cFFFF0000%s|r begins to cast |cFFFF0000|Hspell:182178|h[Fel Chakram]|h|r at you!','',26124),
(93992,'enUS','You cannot have more than 10 seals at once!  Too much fate-twisting is a terrible thing.','',26124),
(93993,'enUS','<Laanda eyes you up and down, then whispers urgently.>$B$BWhat are you doing, $c? If you mean to carry out your garrison mission without getting caught, YOU NEED A DISGUISE.$B$BSpeak to me again when you have acquired and equipped a Sargerei Disguise.$B$BKill the nearby Sargerei and loot their clothing if you have to. Just don\'t compromise my cover.','',26124),
(93994,'enUS','I cannot give you any Seals of Inevitable Fate.  Maybe a time in the future?  Either when you are powerful enough to wield them or enough time has passed.','',26124),
(93995,'enUS','','Light\'s sake, what is THAT?',26124),
(93996,'enUS','It appears to be a great source of fel energy. I have never seen anything like it.','',26124),
(93997,'enUS','$p, thank the Light I found you. I must speak with you at once.','',26124),
(93998,'enUS','','We will mend Tirion\'s wounds enough to get him out of here. Highlord, you must move on and retrieve the Ashbringer!',26124),
(93999,'enUS','I will lead the diversion on the western gates and draw the Iron Horde forces to me. This will give you and Yrel enough time to establish a base of operations on their flank.','',26124),
(94000,'enUS','','The Iron Horde have all but abandoned this area. I was expecting a harder fight for the docks.',26124),
(94001,'enUS','','Bleeding Hollow scavengers. We should deal with their leader and send them scurrying back into the jungle!',26124),
(94002,'enUS','We are the masters of the storm!','',26124),
(94003,'enUS','You have already failed. The Thorignir are broken!','',26124),
(94004,'enUS','You are not worthy of the Thorignir\'s power!','',26124),
(94005,'enUS','The dragons belong to the Skovald, worm!','',26124),
(94006,'enUS','Beg for your life!','',26124),
(94007,'enUS','Kneel to the God-King!','',26124),
(94008,'enUS','Another soul to fuel the legion.','',26124),
(94009,'enUS','Ha ha ha!','',26124),
(94010,'enUS','We will cleave your souls in twain.','',26124),
(94011,'enUS','Yes.. we leave destruction in our wake.','',26124),
(94012,'enUS','Corrupt souls are so easily harvested.','',26124),
(94013,'enUS','You cannot contain our power!','',26124),
(94014,'enUS','We sow the seeds of your demise.','',26124),
(94015,'enUS','Behold the power of the Legion.','',26124),
(94016,'enUS','Die!','',26124),
(94017,'enUS','Suffer!','',26124),
(94018,'enUS','Flame! Death! Destruction!','',26124),
(94019,'enUS','We are as one.','',26124),
(94020,'enUS','We are unstoppable!','',26124),
(94021,'enUS','Power unleashed!','',26124),
(94022,'enUS','We will consume this puny world.','',26124),
(94023,'enUS','We are... bested.','',26124),
(94024,'enUS','','If these looters are roaming free, where is the rest of Gul\'dan\'s Horde? They may be waiting for us up ahead.',26124),
(94025,'enUS','','Warlocks and their foul magic! If Gul\'dan has his way, this whole world would burn.',26124),
(94026,'enUS','I have little time for talk. Unimaginable destruction marches towards us and we are all that stands in the way.','',26124),
(94027,'enUS','','Deserted except for looters and warlocks. What are Gul\'dan\'s minions doing so close to the ruins of the portal?',26124),
(94028,'enUS','%s casts |cFFFF0000|Hspell:156446|h[Blast Wave]|h|r! Hide!','',26124),
(94029,'enUS','','Gul\'dan\'s fel magic is corrupting even the very machinery of the Iron Horde! We must fight through this gauntlet...',26124),
(94030,'enUS','|TInterface\\Icons\\Spell_Shadow_GatherShadows.blp:20|tYou\'ve been |cFFFF0000|Hspell:179711|h[Befouled]|h|r, move away from your allies!','|TInterface\\Icons\\Spell_Shadow_GatherShadows.blp:20|tYou\'ve been |cFFFF0000|Hspell:179711|h[Befouled]|h|r, move away from your allies!',26124),
(94031,'enUS','|TInterface\\Icons\\spell_fel_elementaldevastation.blp:20|tA |cFFFF0000|Hspell:181498|h[Wake of Destruction]|h|r strikes a |cFFFF0000|Hspell:179620|h[Fel Crystal]|h|r!','|TInterface\\Icons\\spell_fel_elementaldevastation.blp:20|tA |cFFFF0000|Hspell:181498|h[Wake of Destruction]|h|r strikes a |cFFFF0000|Hspell:179620|h[Fel Crystal]|h|r!',26124),
(94032,'enUS','|TInterface\\Icons\\spell_fel_elementaldevastation.blp:20|t$n\'s |cFFFF0000|Hspell:182008|h[Latent Energy]|h|r reacts violently as they step into the |cFFFF0000|Hspell:179582|h[Rumbling Fissure]|h|r!','|TInterface\\Icons\\spell_fel_elementaldevastation.blp:20|t$n\'s |cFFFF0000|Hspell:182008|h[Latent Energy]|h|r reacts violently as they step into the |cFFFF0000|Hspell:179582|h[Rumbling Fissure]|h|r!',26124),
(94033,'enUS','|TInterface\\Icons\\spell_fel_elementaldevastation.blp:20|t$n\'s |cFFFF0000|Hspell:182008|h[Latent Energy]|h|r reacts violently as they are struck by a |cFFFF0000|Hspell:181498|h[Wake of Destruction]|h|r!','|TInterface\\Icons\\spell_fel_elementaldevastation.blp:20|t$n\'s |cFFFF0000|Hspell:182008|h[Latent Energy]|h|r reacts violently as they are struck by a |cFFFF0000|Hspell:181498|h[Wake of Destruction]|h|r!',26124),
(94034,'enUS','This is ours now, back to the sea with you!','',26124),
(94035,'enUS','Kilrogg will... avenge me...','',26124),
(94036,'enUS','|TInterface\\Icons\\Spell_Shadow_ChillTouch.blp:20|t|cFFFF0000|Hspell:182008|h[Latent Energy]|h|r corrupts you!','|TInterface\\Icons\\Spell_Shadow_ChillTouch.blp:20|t|cFFFF0000|Hspell:182008|h[Latent Energy]|h|r corrupts you!',26124),
(94037,'enUS','|TInterface\\Icons\\Spell_Shadow_SeedOfDestruction.blp:20|tYour |cFFFF0000|Hspell:181508|h[Seed of Destruction]|h|r will emit |cFFFF0000|Hspell:181498|h[Wakes of Destruction]|h|r.','|TInterface\\Icons\\Spell_Shadow_SeedOfDestruction.blp:20|tYour |cFFFF0000|Hspell:181508|h[Seed of Destruction]|h|r will emit |cFFFF0000|Hspell:181498|h[Wakes of Destruction]|h|r.',26124),
(94038,'enUS','|TInterface\\Icons\\ability_deathwing_grasping_tendrilsgreen.blp:20|tThe |cFFFF0000|Hspell:179582|h[Rumbling Fissures]|h|r harden into |cFFFF0000|Hspell:179620|h[Fel Crystals]|h|r!','|TInterface\\Icons\\ability_deathwing_grasping_tendrilsgreen.blp:20|tThe |cFFFF0000|Hspell:179582|h[Rumbling Fissures]|h|r harden into |cFFFF0000|Hspell:179620|h[Fel Crystals]|h|r!',26124),
(94039,'enUS','|TInterface\\Icons\\ability_warlock_moltencoregreen.blp:20|tFel Lord Zakuun\'s axe begins emitting |cFFFF0000|Hspell:179622|h[Fel Explosions]|h|r!','|TInterface\\Icons\\ability_warlock_moltencoregreen.blp:20|tFel Lord Zakuun\'s axe begins emitting |cFFFF0000|Hspell:179622|h[Fel Explosions]|h|r!',26124),
(94040,'enUS','|TInterface\\Icons\\inv_axe_2h_pvphorde_a_01blackhigh.blp:20|tFel Lord Zakuun takes up his axe again, |cFFFF0000|Hspell:179670|h[Arming]|h|r himself.','|TInterface\\Icons\\inv_axe_2h_pvphorde_a_01blackhigh.blp:20|tFel Lord Zakuun takes up his axe again, |cFFFF0000|Hspell:179670|h[Arming]|h|r himself.',26124),
(94041,'enUS','|TInterface\\Icons\\inv_axe_2h_orgrimmarraid_d_01.blp:20|tFel Lord Zakuun frenzies and is now |cFFFF0000|Hspell:179671|h[Heavily Armed]|h|r!','|TInterface\\Icons\\inv_axe_2h_orgrimmarraid_d_01.blp:20|tFel Lord Zakuun frenzies and is now |cFFFF0000|Hspell:179671|h[Heavily Armed]|h|r!',26124),
(94042,'enUS','What is your will, Archdruid? Death and terror surround us...','',26124),
(94043,'enUS','|TInterface\\Icons\\warrior_talent_icon_mastercleaver.blp:20|tFel Lord Zakuun\'s axe sends out |cFFFF0000|Hspell:181498|h[Wakes of Destruction]|h|r!','|TInterface\\Icons\\warrior_talent_icon_mastercleaver.blp:20|tFel Lord Zakuun\'s axe sends out |cFFFF0000|Hspell:181498|h[Wakes of Destruction]|h|r!',26124),
(94044,'enUS','Finally a break from the boredom of all this \"preparation!\"','',26124),
(94045,'enUS','He will bring me back... he is never finished with... us...','',26124),
(94046,'enUS','You pull the Ashbringer out of the ground, holding it up triumphantly. A moment later, Balanazzar appears in front of you.','',26124),
(94047,'enUS','','Quickly now, you must see this place!',26124),
(94048,'enUS','','Over here, commander!',26124),
(94049,'enUS','','Excellent location... good fields of fire... excellent recon routes. I recommend planting your banner here, commander.',26124),
(94050,'enUS','All is lost...','',26124),
(94051,'enUS','Don\'t let them feed me to the hounds again...','',26124),
(94052,'enUS','I fought well in life... I don\'t belong here','',26124),
(94053,'enUS','Helira! Hear my calls! Please... set me free.','',26124),
(94054,'enUS','Doomed... we are all doomed.','',26124),
(94055,'enUS','Helira, send me to the eternal battlefield. I am worthy!','',26124),
(94056,'enUS','If we do not act swiftly, the vale will be overrun. Druids, lend me your claws!','',26124),
(94057,'enUS','Our losses were almost more than I could bear... but we made it through. To this!','',26124),
(94058,'enUS','Our siege began the moment you took the boats. It looked like it would be a long battle until a large part of their forces departed suddenly, most likely when you attacked from the east.$b$b\nThen we hit them with everything. Thaelin brought in a massive powered ram and the gates fell quickly. Then we ran into this new foe... the fel orcs. They press us sorely and we can make no headway. I hope you are having better luck in the east.','',26124),
(94059,'enUS','Die!','',26124),
(94060,'enUS','You will not win this fight!','',26124),
(94061,'enUS','I will bathe in your blood!','',26124),
(94062,'enUS','I will ascend!','',26124),
(94063,'enUS','We meet again, friend. This place is not Gorgrond, but I do not miss the giant beasts that shake the earth!$b$bI have reports on Zeth\'Gol, the Temple of Sha\'naar, and the Zorammarsh.','',26124),
(94064,'enUS','Tell me of Zeth\'Gol.','Tell me of Zeth\'Gol.',26124),
(94065,'enUS','Helya, witness my strength. I am worthy!','',26124),
(94066,'enUS','These Bleeding Hollow are fearsome hunters and trappers. They have lived well in this jungle. Deep inside their village they practice dark blood magic. That cannot be good for us, so I must recommend reducing this village to ash at the earliest opportunity!','',26124),
(94067,'enUS','','This poor village... crushed by the Sargerei...',26124),
(94068,'enUS','What is happening at the Temple of Sha\'naar?','What is happening at the Temple of Sha\'naar?',26124),
(94069,'enUS','They destroyed this village some time ago and replaced it with training grounds, demon summoning, and corrupting the wildlife into fel weapons.$b$bThe people that died here must be avenged, commander!','',26124),
(94070,'enUS','Incredible. With the Ashbringer and your might at our head, we might still stand a chance of turning the Burning Legion back.','',26124),
(94071,'enUS','','The Ashbringer...',26124),
(94072,'enUS','','The hunt continues here, commander. I have reports on Aktar\'s Watch just to the northwest and the Ironmonger\'s Hold, that big tunnel to the southeast.',26124),
(94073,'enUS','Arakkoa in Tanaan? Tell me more of Aktar\'s Watch.','Arakkoa in Tanaan? Tell me more of Aktar\'s Watch.',26124),
(94074,'enUS','','The outcasts are concerned about their brethren. Some lost souls are being trained by the Shadow Council in fel magics and demon summoning. They have even recruited some high arakkoa as well but that area is significantly more dangerous, you will need allies to clear that particular area out. We should clear out this poisonous nest soon.',26124),
(94075,'enUS','Our men are waiting outside to take us back to Dalaran. We should leave while we still can!','',26124),
(94076,'enUS','[Nathanos and his rangers move out.]','[Nathanos and his rangers move out.]',26124),
(94077,'enUS','','Directly ahead, Alliance ships! Make for the beach! Hold on everyone, this is going to get worse before it gets better!',26124),
(94078,'enUS','Thievery will not be tolerated, slave.','',26124),
(94079,'enUS','[Nathanos leaps down from the cliff and walks over.]','[Nathanos leaps down from the cliff and walks over.]',26124),
(94080,'enUS','No sign of Sylvanas in the hills. What have we here?','',26124),
(94081,'enUS','That\'s one of hers alright...','',26124),
(94082,'enUS','Eat up, lads! We\'ve a witch to hunt!','',26124),
(94083,'enUS','Ye won\'t stop my hunt!','',26124),
(94084,'enUS','','I\'m not sure if I\'ve ever been in an area that was more determined to kill me!$b$bThat being said I have some early information on Ironhold Harbor just to the northwest, the Fel Forge to the southeast, and the Throne of Kil\'jaeden up on the mountain right behind you.',26124),
(94085,'enUS','Lots of ships coming into that harbor, what\'s going on there?','Lots of ships coming into that harbor, what\'s going on there?',26124),
(94086,'enUS','','It appears the Iron Horde is summoning all of its farflung holdings back here. Most Iron Horde troops disembark at the harbor and immediately go to get converted. The rest stay and bring in munitions and other resources to feed their army.$b$bIf Gul\'dan is allowed to convert the entire Iron Horde he will have an unbeatable army!',26124),
(94087,'enUS','Now!','',26124),
(94088,'enUS','Why do you resist your own blood, Ariok? Give into your rage.','',26124),
(94089,'enUS','Release me from these bonds and I will show you my rage, Kilrogg!','',26124),
(94090,'enUS','The choice is simple, Ariok. Submit, or die.','',26124),
(94091,'enUS','I\'ve been waiting for this day!','',26124),
(94092,'enUS','Let\'s see how many fall before I do!','',26124),
(94093,'enUS','Gaze into my eyes and witness your doom!','',26124),
(94094,'enUS','I\'m going to cut your heart out!','',26124),
(94095,'enUS','Was this how you wanted to die?','',26124),
(94096,'enUS','Die!','',26124),
(94097,'enUS','Did you believe you could kill me?','',26124),
(94098,'enUS','You were not the ones I saw.','',26124),
(94099,'enUS','At last, this is the death I saw!','',26124),
(94100,'enUS','FOR AZEROTH!','',26124),
(94101,'enUS','','Soon you will burn with the rest of Azeroth!',26124),
(94102,'enUS','','Burn!',26124),
(94103,'enUS','Unstoppable!','Unstoppable!',26124),
(94104,'enUS','Crush the weak!','Crush the weak!',26124),
(94105,'enUS','Fool dwarf. Deliver his head to the foothold!','',26124),
(94106,'enUS','|TInterface\\Icons\\Ability_GolemThunderClap.blp:20|tKormrok begins |cFFFF0000|Hspell:180244|h[Pounding]|h|r the ground!','',26124),
(94107,'enUS','|TInterface\\Icons\\Spell_Shaman_TidalWaves.blp:20|tThe Shadow Pool starts generating |cFFFF0000|Hspell:181292|h[Shadow Globules]|h|r!','',26124),
(94108,'enUS','|TInterface\\Icons\\Spell_Shaman_TidalWaves.blp:20|tAll three pools start generating |cFFFF0000|Hspell:181293|h[Fel Globules]|h|r!','',26124),
(94109,'enUS','|TInterface\\Icons\\spell_fire_rune.blp:20|t|cFFFF0000|Hspell:181296|h[Explosive Runes]|h|r appear on the ground!','',26124),
(94110,'enUS','|TInterface\\Icons\\spell_fire_rune.blp:20|t|cFFFF0000|Hspell:181297|h[Empowered Explosive Runes]|h|r appear on the ground!','',26124),
(94111,'enUS','|TInterface\\Icons\\Spell_Shadow_Requiem.blp:20|tKormrok summons |cFFFF0000|Hspell:181299|h[Grasping Hands]|h|r from the ground!','',26124),
(94112,'enUS','|TInterface\\Icons\\Spell_Shadow_Requiem.blp:20|tKormrok summons |cFFFF0000|Hspell:181300|h[Dragging Hands]|h|r from the ground!','',26124),
(94113,'enUS','|TInterface\\Icons\\inv_offhand_stratholme_a_02.blp:20|t$n is |cFFFF0000|Hspell:181305|h[Launched]|h|r into the air!','',26124),
(94114,'enUS','|TInterface\\Icons\\spell_arcane_teleportdalarancrater.blp:20|tWith no one to absorb their |cFFFF0000|Hspell:182427|h[Impact]|h|r, $n perishes.','',26124),
(94115,'enUS','|TInterface\\Icons\\Ability_Mage_LivingBomb.blp:20|t$n is going to |cFFFF0000|Hspell:181324|h[Explode]|h|r!','',26124),
(94116,'enUS','|TInterface\\Icons\\Spell_DeathKnight_Strangulate.blp:20|tA Fel Hand starts |cFFFF0000|Hspell:181345|h[Crushing]|h|r $n!','',26124),
(94117,'enUS','|TInterface\\Icons\\INV_Bijou_Purple.blp:20|tKormrok leaps into the Shadow Pool, gaining |cFFFF0000|Hspell:181293|h[Empowered Fel Outpouring]|h|r.','',26124),
(94118,'enUS','|TInterface\\Icons\\INV_Bijou_Orange.blp:20|tKormrok leaps into the Fiery Pool, gaining |cFFFF0000|Hspell:181297|h[Empowered Explosive Runes]|h|r.','',26124),
(94119,'enUS','|TInterface\\Icons\\INV_Bijou_Green.blp:20|tKormrok leaps into the Foul Pool, gaining |cFFFF0000|Hspell:181300|h[Empowered Fel Grasp]|h|r.','',26124),
(94120,'enUS','|TInterface\\Icons\\INV_Bijou_Purple.blp:20|tKormrok leaps into the Shadow Pool, gaining |cFFFF0000|Hspell:181292|h[Fel Outpouring]|h|r.','',26124),
(94121,'enUS','|TInterface\\Icons\\INV_Bijou_Orange.blp:20|tKormrok leaps into the Fiery Pool, gaining |cFFFF0000|Hspell:181296|h[Explosive Runes]|h|r.','',26124),
(94122,'enUS','|TInterface\\Icons\\INV_Bijou_Green.blp:20|tKormrok leaps into the Foul Pool, gaining |cFFFF0000|Hspell:181299|h[Fel Grasp]|h|r.','',26124),
(94123,'enUS','|TInterface\\Icons\\INV_Bijou_purple.blp:20|tA |cFFFF0000|Hspell:181365|h[Violent Reaction]|h|r occurs from Kormrok leaping into the Shadowy Pool!','',26124),
(94124,'enUS','|TInterface\\Icons\\INV_Bijou_orange.blp:20|tA |cFFFF0000|Hspell:181370|h[Violent Reaction]|h|r occurs from Kormrok leaping into the Fiery Pool!','',26124),
(94125,'enUS','|TInterface\\Icons\\INV_Bijou_green.blp:20|tA |cFFFF0000|Hspell:181371|h[Violent Reaction]|h|r occurs from Kormrok leaping into the Foul Pool!','',26124),
(94126,'enUS','|TInterface\\Icons\\spell_fire_rune.blp:20|t$n triggers an |cFFFF0000|Hspell:180370|h[Explosive Rune]|h|r.','',26124),
(94127,'enUS','|TInterface\\Icons\\spell_fire_rune.blp:20|tAn |cFFFF0000|Hspell:180370|h[Explosive Rune]|h|r explodes on its own.','',26124),
(94128,'enUS','|TInterface\\Icons\\Trade_Engineering.blp:20|tThe |cFFFF0000|Hspell:181300|h[Empowered Fel Hand]|h|r |cFFFF0000|Hspell:180442|h[Releases]|h|r a fatal burst of Fel Energy!','',26124),
(94129,'enUS','He\'s not... the archdruid has... save yourself... run!','',26124),
(94130,'enUS','','We got the queen into a rowboat, but she didn\'t want an escort. Told us to stay behind and fight.',26124),
(94131,'enUS','','My guess? She landed somewhere up the coast and continued on foot.',26124),
(94132,'enUS','[Tattersail tells you what she knows and runs away.]','[Tattersail tells you what she knows and runs away.]',26124),
(94133,'enUS','I\'m not dying again without a fight!','',26124),
(94134,'enUS','You\'re not feeding me to the hounds this time!','',26124),
(94135,'enUS','Helira! You can\'t hold me here forever! I will be free!','',26124),
(94136,'enUS','This beautiful madness... why did I fight it?','',26124),
(94137,'enUS','%s targets you for |cFFFF0404|Hspell:180372|h[Heart Seeker]|h|r!','',26124),
(94138,'enUS','There is nowhere to hide.','',26124),
(94139,'enUS','Something has stirred the furbolgs into a frenzy. In my memory, never have they attacked in force like this.','Something has stirred the furbolgs into a frenzy. In my memory, never have they attacked in force like this.',26124),
(94140,'enUS','The heart of a Druid of the Claw never falters. We are the ones who endure.','The heart of a Druid of the Claw never falters. We are the ones who endure.',26124),
(94141,'enUS','Archdruid Steelclaw is still down in the barrows, with the others. We must save them quickly.','Archdruid Steelclaw is still down in the barrows, with the others. We must save them quickly.',26124),
(94142,'enUS','We must hold on. We will outlast them, I know it.','We must hold on. We will outlast them, I know it.',26124),
(94143,'enUS','Just one... more... fight...','Just one... more... fight...',26124),
(94144,'enUS','Cover\'s blown. Now you die!','',26124),
(94145,'enUS','We are all doomed to spend an eternity here.','',26124),
(94146,'enUS','There is no light anymore... only darkness.','',26124),
(94147,'enUS','What is this place?','What is this place?',26124),
(94148,'enUS','We are the Legion!','',26124),
(94149,'enUS','Don\'t you know? You are in Helheim, $r... your soul belongs to Helira now. No one leaves here without the goddess\'s consent.$b$bI have heard rumors the corpses clashing on the eternal battlefield are allowed to leave if they prove their might to Helira.$b$bBut it\'s impossible to get to the battlefield with that beast Guarm guarding the path to Helira.$b$bI\'ve tried to slip by that monster more times than you can imagine, and it always ends the same way... me torn apart and fed to the hounds.','',26124),
(94150,'enUS','There has to be a way.','There has to be a way.',26124),
(94151,'enUS','Feel the power flowing through you, servants!','',26124),
(94152,'enUS','Gorefiend is about to |TInterface\\Icons\\Spell_Shadow_DeathCoil:20|t |cFFFF0404|Hspell:181295|h[Digest]|h|r you!','Gorefiend is about to |TInterface\\Icons\\Spell_Shadow_DeathCoil:20|t |cFFFF0404|Hspell:181295|h[Digest]|h|r you!',26124),
(94153,'enUS','We must regroup and rally to our queen. The task of finding the Aegis of Aggramar falls to you.','',26124),
(94154,'enUS','','The Ashbringer has certainly earned its reputation. We could hear the demons screaming in agony from here.',26124),
(94155,'enUS','','We\'ll meet you back at Illidari Stand.',26124),
(94156,'enUS','','Ha Ha Ha... it looks like we have a new challenger. It has been ages since a soul has approached my throne.',26124),
(94157,'enUS','','Baldir, find out what $n\'s soul seeks. I do long for amusement.',26124),
(94158,'enUS','Through the mist, and into the darkness, I rest my soul forever in the hands of Helira.$b$bKneel before your goddess.','',26124),
(94159,'enUS','','I will gather the rest of the Blood Knights and await your call.',26124),
(94160,'enUS','','My men are at Azurewing Repose negotiating safe passage with the dragon\'s brood.',26124),
(94161,'enUS','Who is Bloodbeard?','Who is Bloodbeard?',26124),
(94162,'enUS','Bloodbeard is Helira\'s champion.$b$bHe has defeated every warrior on the battlefield a thousand times over...$b$bYou will not win.','',26124),
(94163,'enUS','We will see about that.','We will see about that.',26124),
(94164,'enUS','Bloooood... Bloodbeard... Bloodbeard must... die...','',26124),
(94165,'enUS','','Bloodbeard is Helira\'s champion.$b$bHe has defeated every warrior on the battlefield a thousand times over...$b$bIt would bring me pleasure to watch him die at the tip of my blade.',26124),
(94166,'enUS','','Their souls are weak and not worthy of my blade. I long to return to the Halls of Valor.',26124),
(94167,'enUS','GHHAAAaaa!!!','',26124),
(94168,'enUS','','I\'ll see you there.',26124),
(94169,'enUS','I agree with you.','I agree with you.',26124),
(94170,'enUS','Friends of yours, Ariok? No, wait... you look familiar.','',26124),
(94171,'enUS','I am in your debt, heroes. My strength is yours.','',26124),
(94172,'enUS','','The slayer of Malinoth returns. Blood Knights, salute!',26124),
(94173,'enUS','I will die before I serve The Burning Legion!','',26124),
(94174,'enUS','You cannot fight fate, Ariok! You can only embrace it!','',26124),
(94175,'enUS','Over here! Please help!','',26124),
(94176,'enUS','','How can I help you, $g handsome : gorgeous;?',26124),
(94177,'enUS','A paladin? Here? We must investigate.','',26124),
(94178,'enUS','I am on the beach now.','',26124),
(94179,'enUS','There is no time to waste, demon hunter. We have urgent matters at hand.','',26124),
(94180,'enUS','Are you sure?','Are you sure?',26124),
(94181,'enUS','Give up! This is your final resting place.','',26124),
(94182,'enUS','It is pointless. Why try?','',26124),
(94183,'enUS','There is no happiness. Only darkness.','',26124),
(94184,'enUS','Don\'t be a fool. You will not succeed.','',26124),
(94185,'enUS','Eternal sadness is all that awaits you.','',26124),
(94186,'enUS','I, Daglop the Mercifel, Daglop the Magnivalent, Daglop the Wondevil, have come to make a deal!','',26124),
(94187,'enUS','Read contract.','Read contract.',26124),
(94188,'enUS','Sign contract in blood.','Sign contract in blood.',26124),
(94189,'enUS','The contract starts with a large, flowing, vile looking script that, with each sentence gets smaller and smaller in its lettering. It begins:$b$bPage 1:$b\"I, the undersigned, hereafter referred to as \'the second party,\' do solemnly swear and agree to the terms set forth by Daglop Ravaliash Driscol Blat, here after referred to as \'Daglop.\'\"','',26124),
(94190,'enUS','Flip to Page 2.','Flip to Page 2.',26124),
(94191,'enUS','Flip to Page 3.','Flip to Page 3.',26124),
(94192,'enUS','Flip to Page 1.','Flip to Page 1.',26124),
(94193,'enUS','The contract continues in a progressively smaller font:$b$bPage 2:$b\"These terms include the acquisition of materials required for the Ritual of Sharazaan, hereafter referred to as \'the gig,\' and any extermination, elimination, assassination, or murderation of subjects, living or otherwise, that resist the afore mentioned assets required by the gig and Daglop.\"','',26124),
(94194,'enUS','The lettering is now nearly illegible:$b$bPage 3:$b\"In exchange, Daglop agrees to provide the second party with a physically intangible source of fel-based energy for the infusing of one artifact of great power in said second party\'s possession, hereafter referred to as \'the reward.\'\"','',26124),
(94195,'enUS','Flip to Page 4.','Flip to Page 4.',26124),
(94196,'enUS','Page 4:$b\"Upon completion of the gig, the aforementioned reward intended for the second party must be provided through direct source extraction from the third party, role to be filled by the target of-\"$b$bThe lettering becomes so small at this point the words are effectively unreadable by mortal eyes.','',26124),
(94197,'enUS','Kneel before Helira.','Kneel before Helira.',26124),
(94198,'enUS','You are the commander? Please, I beg you to listen to me, the fate of Draenor is at stake! Gul\'dan has found it! He found the Cipher!','',26124),
(94199,'enUS','Xalythar has fallen! How can this be?!','Xalythar has fallen! How can this be?!',26124),
(94200,'enUS','The druids were not supposed have such power! Gathenak is slain!','The druids were not supposed have such power! Gathenak is slain!',26124),
(94201,'enUS','Who could slay Xalythar?!','Who could slay Xalythar?!',26124),
(94202,'enUS','They\'ve killed Gathenak!','They\'ve killed Gathenak!',26124),
(94203,'enUS','Speak quickly warlock.','Speak quickly warlock.',26124),
(94204,'enUS','Gul\'dan intends to use the Cipher of Damnation to corrupt the very elements of Draenor. He will scorch the whole of this jungle in hellfire.$b$bOnly now do I see the depths of his madness and hatred.$b$bQuickly! Gul\'dan has learned of the guardian shaman that protect the Cipher. He is moving to attack their stronghold. Someone must protect them.','',26124),
(94205,'enUS','I will go immediately.','I will go immediately.',26124),
(94206,'enUS','','The world has never been so dark. We will help bring in a new dawn.',26124),
(94207,'enUS','Smell that sea air! It feels good to be out in the open water again.','',26124),
(94208,'enUS','Help! Gul\'dan... he is inside!','',26124),
(94209,'enUS','Kneel before the goddess, Helya.','',26124),
(94210,'enUS','Are you crazy, launching yourself into the air like that!? Why not just send Gul\'dan a telegram? Better yet, march into the compound at the head of a Brewfest oompah band. This is a stealth mission, $n! Stealth!','',26124),
(94211,'enUS','Protect me while I sever this link to the Twisting Nether!','Protect me while I sever this link to the Twisting Nether!',26124),
(94212,'enUS','I\'ll disrupt the portal. Keep the Demons at bay while I work!','I\'ll disrupt the portal. Keep the Demons at bay while I work!',26124),
(94213,'enUS','','Thank you for allowing us to join you, $n. When you call, the Sunwalkers will answer.',26124),
(94214,'enUS','','I will go gather the rest of the Sunwalkers - they will not want to miss seeing you in action. Light be with you.',26124),
(94215,'enUS','$GHe:She; fell for it!','',26124),
(94216,'enUS','Did you think it would be that easy?','',26124),
(94217,'enUS','That\'s our treasure, ugly $r!','',26124),
(94218,'enUS','Ha! Got you!','',26124),
(94219,'enUS','I\'m sure dat payment from Orgrimmar had nothin\' ta do wit it.','',26124),
(94220,'enUS','There\'s an old goblin saying that goes \"the best bets use other people\'s money.\"','',26124),
(94221,'enUS','Dat assumes we gonna make it back.','',26124),
(94222,'enUS','At last! With this I will scorch the land with hellfire. The very elements will tremble before me.','',26124),
(94223,'enUS','Any messages from Orgrimmar?','',26124),
(94224,'enUS','You are too late hero. The cipher is mine. Your armies will burn!','',26124),
(94225,'enUS','','The owls of this grove are in grave danger from a murderous vulture known as Gorebeak.$B$BTiris and I plan to lure the beast down from its lair.$B$BWe must slay him to restore balance to the forest, but we could use all the help we can get.',26124),
(94226,'enUS','','Are you ready, Tiris?',26124),
(94227,'enUS','','The vulture must be stopped, Lorel. It\'s time we restored balance to this grove.',26124),
(94228,'enUS','','Aren\'t these little birds just precious? If we don\'t help them, they are in danger of being wiped out.',26124),
(94229,'enUS','I will help you defeat Gorebeak.','I will help you defeat Gorebeak.',26124),
(94230,'enUS','Sylvanas an\' da main fleet arrived a few hours ago. Demons coverin\' da whole island.','',26124),
(94231,'enUS','Already? How\'d they get so many here so fast?','',26124),
(94232,'enUS','I got da feelin we gonna find out.','',26124),
(94233,'enUS','Cut through those waves, Blackwater! We\'re pirates, we own these seas! Keep her steady!','',26124),
(94234,'enUS','What\'s that ahead?','',26124),
(94235,'enUS','','Not. Even. Worthy.',26124),
(94236,'enUS','','Know your place, weakling!',26124),
(94237,'enUS','','Oh, is that one finished?',26124),
(94238,'enUS','Looks like trouble. Big trouble.','',26124),
(94239,'enUS','Alright horde troops, this is your stop, a beach lined with demons! Bring her in snappy now!','',26124),
(94240,'enUS','','The third fleet reinforcements!',26124),
(94241,'enUS','Just in time. We haven\'t been able to break their line, now we may have a chance.','',26124),
(94242,'enUS','','It\'s now or never, Genn!',26124),
(94243,'enUS','','Does it hurt, being so powerless?',26124),
(94244,'enUS','','Look, someone approaches!',26124),
(94245,'enUS','Be ready champion, I do not know what lies beyond this barrier, but it will be bad.','',26124),
(94246,'enUS','Almost... there...','',26124),
(94247,'enUS','Oh, thank goodness! Please help me!$B$BI was attempting a growth spell, but something went terribly wrong.$B$BOne of the flowers kept growing and growing, and now it\'s taken on a mind of its own.$B$BPlease, you have to stop it before someone gets hurt!','',26124),
(94248,'enUS','No, no, stop! This wasn\'t supposed to happen! Stop growing!','',26124),
(94249,'enUS','It... is done. Go and stop him...','',26124),
(94250,'enUS','I\'ve got to get my hands on those plans. They are my life\'s work.','',26124),
(94251,'enUS','%s loots a rifle from the corpse of a fallen foe.','',26124),
(94252,'enUS','Let\'s roll, Roark!','Let\'s roll, Roark!',26124),
(94253,'enUS','Let\'s get this over with. Gul\'dan has turned these docks into a recruiting ground.','',26124),
(94254,'enUS','Cyrukh! You serve no shaman now. Sever your link to them. Ravage this land!','',26124),
(94255,'enUS','No! How could he be defeated?!','',26124),
(94256,'enUS','Blackhand ordered construction of a gigantic cannon. Then I built a monstrous warship to carry it. Bigger isn\'t always better - our strategy fell apart in the waters around Shattrath.','',26124),
(94257,'enUS','We normally use these grapples to tug ships into port...','',26124),
(94258,'enUS','This is why you should cover your buildings in spikes!','',26124),
(94259,'enUS','','You did it! Why don\'t you take a bloom yourself, adventurer? Elune\'s Kiss has powerful properties.',26124),
(94260,'enUS','','Adventurer, over here!',26124),
(94261,'enUS','','Stranger, do you see those flowers growing on the lake shore?$B$BElune\'s Kiss, we call them. I\'ve searched the forest for days to find this patch, only to find it guarded by that foul monster.$B$BPlease, adventurer. I need to get those flowers.',26124),
(94262,'enUS','','Pah! You\'re too ugly for my collection. Better to kill you!',26124),
(94263,'enUS','','My collection... they were all... I had...',26124),
(94264,'enUS','Please, please... no more!','Please, please... no more!',26124),
(94265,'enUS','FOOL! You will fall before the might of the Legion!','FOOL! You will fall before the might of the Legion!',26124),
(94266,'enUS','Great work, heroes! Keep up the fight!','Great work, heroes! Keep up the fight!',26124),
(94267,'enUS','One rift closed, but there are still more demons. Do they ever cease?','One rift closed, but there are still more demons. Do they ever cease?',26124),
(94268,'enUS','With me by your side we will overcome the Legion. Nothing can stand in our way!','With me by your side we will overcome the Legion. Nothing can stand in our way!',26124),
(94269,'enUS','As we speak, the God-King\'s forces amass at Hrydshal. We must strike at them with all the fury of the storm.\n\nAre you ready to leave this place, $C?','',26124),
(94270,'enUS','Take me out of the cave.','Take me out of the cave.',26124),
(94271,'enUS','I\'ll keep watch. Get my blueprints.','',26124),
(94273,'enUS','What is this filth doing on my docks!?','',26124),
(94274,'enUS','Gul\'dan... will finish this...','',26124),
(94275,'enUS','Look, brother. A new challenger approaches.','',26124),
(94276,'enUS','Let us test your strength, champion! Prepare yourself! [OUR ABILITIES AND CLEANUP AREN\'T SET UP YET!]','',26124),
(94277,'enUS','Hang in there, Oakleaf. I know it is painful, but please, hold on!','',26124),
(94278,'enUS','It will get worse before it gets better, old friend. Let us begin!','',26124),
(94279,'enUS','Something is wrong with my friend. A darkness has taken root within him, paralyzing him with fear.$B$BI believe the only recourse is to cleanse his mind, but in doing so, we will face his nightmares.$B$BI cannot defeat this evil alone. Will you help me?','',26124),
(94280,'enUS','I will help. Let\'s begin.','I will help. Let\'s begin.',26124),
(94281,'enUS','Darkness, come forth!','',26124),
(94282,'enUS','That\'s the spirit, Oakleaf. Thank you, adventurer. He seems to have regained control of his senses.','',26124),
(94283,'enUS','We did it! How do you feel, old friend?','',26124),
(94284,'enUS','%s grunts.','',26124),
(94285,'enUS','','Arg, why isn\'t it working? The power of my friendship should heal all wounds!',26124),
(94286,'enUS','','Oh, hello there!$B$BMy poor friend here was attacked by wolves, and now I\'m nursing him back to health!$B$BI\'m having a little bit of trouble with this spell, so it should just take a few more minutes.$B$BI think some of those nasty predators are still nearby, so could you hold them off while I finish here?',26124),
(94287,'enUS','Yes, I\'ll defend you.','Yes, I\'ll defend you.',26124),
(94288,'enUS','','Eep! Watch out! Defend me, hero!',26124),
(94289,'enUS','','Look, my wonderful forest friend has been saved!',26124),
(94290,'enUS','','Champion, it looks like he wants us to follow him!',26124),
(94291,'enUS','%s bows to you.','',26124),
(94292,'enUS','%s beckons to the chest inside the den, as if he wants you to have it.','',26124),
(94293,'enUS','','What a curious little house he has! I\'ll stay and make sure he\'s all right. Thank you, hero.',26124),
(94294,'enUS','Death to the enemies of Kilrogg!','Death to the enemies of Kilrogg!',26124),
(94295,'enUS','Your corpse will serve in our rituals!','Your corpse will serve in our rituals!',26124),
(94296,'enUS','I will skin you alive!','I will skin you alive!',26124),
(94297,'enUS','Glory to the Bleeding Hollow!','Glory to the Bleeding Hollow!',26124),
(94298,'enUS','Your blood will be most useful!','Your blood will be most useful!',26124),
(94299,'enUS','Kilrogg... I\'ve failed you...','Kilrogg... I\'ve failed you...',26124),
(94300,'enUS','You cannot stop us!','You cannot stop us!',26124),
(94301,'enUS','Kill you... kill... you...','Kill you... kill... you...',26124),
(94302,'enUS','My brothers will make you pay.','My brothers will make you pay.',26124),
(94303,'enUS','Kilrogg will still be victorious...','Kilrogg will still be victorious...',26124),
(94304,'enUS','Now you die!','Now you die!',26124),
(94305,'enUS','Crush you!','',26124),
(94306,'enUS','Stomp and smash!','',26124),
(94307,'enUS','Blood for Kilrogg!','',26124),
(94308,'enUS','Crush... you...','',26124),
(94309,'enUS','Rest... at last...','',26124),
(94310,'enUS','No... Kilrogg...','',26124),
(94311,'enUS','Try and dodge my spears fool!','',26124),
(94312,'enUS','Spears... you have failed me...','',26124),
(94313,'enUS','If you flee, I will hunt you to the ends of the world!','',26124),
(94314,'enUS','My hunters will find you... wherever you...','',26124),
(94315,'enUS','Blood for the Blood Moon!','',26124),
(94316,'enUS','My blood... for Kilrogg...','',26124),
(94317,'enUS','','Don\'t worry, Brimbil. Every young sapling must step into the real world. You\'ll be fine!',26124),
(94318,'enUS','You cannot stop the rituals, you can only join them!','',26124),
(94319,'enUS','My blood... joins the others...','',26124),
(94320,'enUS','I will take your blood as payment for your interference!','',26124),
(94321,'enUS','There will be another after me...','',26124),
(94322,'enUS','','Ah, hello traveler!$B$BSometimes, young saplings just need a little push to gain confidence, you know?$B$BYoung Brimbil here has everything he needs to take his first journey across the forest, but perhaps he could use some guidance.$B$BWould you escort him to Keeper Ferthalos, across the river?$B$BJust follow Brimbil. He should know the way.',26124),
(94323,'enUS','I will accompany Brimbil.','I will accompany Brimbil.',26124),
(94324,'enUS','','Take good care of him, adventurer!',26124),
(94325,'enUS','We saved Draenor once, I will help you save it again.','',26124),
(94326,'enUS','','These new cannon... dey be something else...',26124),
(94327,'enUS','%s moans in agony.','',26124),
(94332,'enUS','[PH] Climb to the top of the ridge to get a good view of the grapple point.','',26124),
(94333,'enUS','Click the nearby Grapple Point to launch yourself to the top of the wall. Grapple points within range will light up.','',26124),
(94334,'enUS','These poor people. Gul\'dan will stop at nothing to get what he wants!','',26124),
(94335,'enUS','What is the Black Candle?','What is the Black Candle?',26124),
(94336,'enUS','The Black Candle... I know not where Gul\'dan found this. It never burns down and exudes a corruptive smoke as it lights everything with an unholy glint.\n\nMy fingers still feel oily from when I touched it.','',26124),
(94337,'enUS','What is the Tome of Protection?','What is the Tome of Protection?',26124),
(94338,'enUS','The Tome was stolen from the Imperator Mar\'gok himself, though he blames the Frostwolf clan for the theft. It is more arcane in nature but is still usable by warlocks.\n\nThe enchantments from this tome are a core component to the barrier spell. Fear not, I can dispel it though it may cost me dearly.','',26124),
(94339,'enUS','What is this... Mac\'Gufin?','What is this... Mac\'Gufin?',26124),
(94340,'enUS','It is a true mystery. Gul\'dan went through great lengths to get this dagger. He says it was quite the adventure. \n\nHe made sure I knew it was the most important part of the spell. Truth be told, when I held it I felt nothing. I\'m not entirely sure it did anything at all, but we should get it just in case. Gul\'dan wouldn\'t have given it to me otherwise... right?','',26124),
(94341,'enUS','','G\'day to ye, Highlord $n. Can I help ye find somethin\'?',26124),
(94342,'enUS','','Lookin\' fer somethin\' specific, Highlord?',26124),
(94343,'enUS','','The knowledge of our forefathers is laid bare before us. What a marvelous opportunity!',26124),
(94344,'enUS','','Whenever ye accomplish a great feat, I\'ll be sure tae jot it down in yer libram for posterity!',26124),
(94347,'enUS','Show me what happened in Azsuna.','Show me what happened in Azsuna.',26124),
(94350,'enUS','Light\'s honor, Highlord.','',26124),
(94351,'enUS','Say the world and I will rally your best knights, $GLord:Lady; $n.','',26124),
(94352,'enUS','What threats shall we tackle first? Say the word and consider it done.','',26124),
(94353,'enUS','Our enemies grow bolder with each passing day. Thank the Light we have you at the helm of our efforts.','',26124),
(94354,'enUS','You trespass on sacred ground!','',26124),
(94355,'enUS','I will guard the eyes with my eternal soul!','',26124),
(94356,'enUS','Think you can loot the Bleeding Hollow\'s most treasured relics?!','',26124),
(94357,'enUS','Others will guard the eyes after me...','',26124),
(94358,'enUS','You will pay infidel... someday...','',26124),
(94359,'enUS','Kilrogg... they come for the eyes...','',26124),
(94360,'enUS','I have failed my chieftain...','',26124),
(94361,'enUS','You will pay... defiler...','',26124),
(94362,'enUS','I will return...','',26124),
(94363,'enUS','','The human King is quite versed in military strategy, but even he can\'t perform miracles.$b$bIf we\'re to break through into the jungles of Tanaan, we\'re going to need some sort of diversion.',26124),
(94364,'enUS','Gul\'dan\'s Horde is ready for us. A full-frontal assault would be costly at best and suicide at worst.$b$bThere\'s got to be another way...','',26124),
(94365,'enUS','I heard Kilrogg! What happened?!','',26124),
(94366,'enUS','You have found all you will find down here. Now leave and do not return...','',26124),
(94367,'enUS','','Hi there!$b$bI\'m a placeholder treasure hunter. I travel around telling people where the treasures are that I can\'t actually get myself because of \'reasons.\' Eventually I may be found in exotic and/or common places once I make up my mind.$b$bDo you want to hunt treasures?',26124),
(94368,'enUS','I am looking for treasure.','I am looking for treasure.',26124),
(94369,'enUS','Heroes, up here! This portal is too strong for my magic to close!','Heroes, up here! This portal is too strong for my magic to close!',26124),
(94370,'enUS','Quickly, activate the temple\'s defenses to amplify my magic!','Quickly, activate the temple\'s defenses to amplify my magic!',26124),
(94371,'enUS','Each death has given me untold power.  Now I unleash it upon you!','',26124),
(94372,'enUS','It is my blood they require fools! They\'ll let no harm come to me.','',26124),
(94373,'enUS','I have feasted upon a thousand souls.  Yours will be next!','',26124),
(94374,'enUS','Give in!','',26124),
(94375,'enUS','Death!','',26124),
(94376,'enUS','Wither and DIE!','',26124),
(94377,'enUS','Don\'t worry... it gets worse.','',26124),
(94378,'enUS','I must have more souls!','',26124),
(94379,'enUS','More! I must have more!','',26124),
(94380,'enUS','I must feast!','',26124),
(94381,'enUS','I\'ll savor your soul the most.','',26124),
(94382,'enUS','Each death only makes me more powerful!','',26124),
(94383,'enUS','But... my power...','',26124),
(94384,'enUS','','Ah... another succulent world ready to be beat into submission!',26124),
(94385,'enUS','Not this time Gul\'dan! Hurry, get the Cipher!','',26124),
(94386,'enUS','Impossible! This means nothing. One way or another, this world will burn!','',26124),
(94387,'enUS','Get those fires out before Nathanos returns! I don\'t want to be food for his dogs.','',26124),
(94388,'enUS','Faster! Get this ship floating before more of those scum scavenging crab people notice us.','',26124),
(94389,'enUS','Hammer you fools! We have a schedule to keep.','',26124),
(94390,'enUS','Are you going to let the Alliance sink your ship? Prove the feebleness of their weapons by getting this barge floating.','',26124),
(94391,'enUS','Nathanos has charged us with restoring his ship to operational status.$b$bBut these lazy fools are taking forever to... wait... do you hear that?','',26124),
(94392,'enUS','Hear what?','Hear what?',26124),
(94393,'enUS','Incoming!','',26124),
(94394,'enUS','And stay off, you crab faced filth!','',26124),
(94395,'enUS','','The plan is working. Our landing was unopposed. We have taken them by surprise!',26124),
(94396,'enUS','','Your plan is working, commander. Our landing met little resistance.',26124),
(94397,'enUS','','We must stop them before they accomplish their dark goals.',26124),
(94398,'enUS','','I will weep for the lost souls later. We will seal this breach...',26124),
(94399,'enUS','','|cFFFF0000%s|r activates an |cFFFF0000|Hspell:181718|h[Aura of Oppression]|h|r!',26124),
(94400,'enUS','','|cFFFF0000%s|r activates an |cFFFF0000|Hspell:179986|h[Aura of Contempt]|h|r!',26124),
(94401,'enUS','','|cFFFF0000%s|r activates an |cFFFF0000|Hspell:179991|h[Aura of Malice]|h|r!',26124),
(94402,'enUS','','|cFFFF0000%s|r targets you with an |cFFFF0000|Hspell:180260|h[Annihilating Strike]|h|r!',26124),
(94403,'enUS','','|cFFFF0000%s|r begins to channel an |cFFFF0000|Hspell:180312|h[Infernal Tempest]|h|r!',26124),
(94404,'enUS','','|cFFFF0000%s|r readies a |cFFFF0000|Hspell:180608|h[Gavel of the Tyrant]|h|r!',26124),
(94405,'enUS','','|cFFFF0000%s|r focuses you with an |cFFFF0000|Hspell:182459|h[Edict of Condemnation]|h|r!',26124),
(94406,'enUS','Polishing','Polishing',26124),
(94407,'enUS','','|cFFFF0000%s|r attempts to heal its master!',26124),
(94408,'enUS','|cFFFF0000%s|r protects its master with |cFFFF0000|Hspell:180040|h[Sovereign\'s Ward]|h|r!','',26124),
(94410,'enUS','The avatar of an |cFFFF0000%s|r enters the battle!','The avatar of an |cFFFF0000%s|r enters the battle!',26124),
(94412,'enUS','|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tI can already tell that we\'ll need to pre-temper this. Heat the ore in the forge.','',26124),
(94413,'enUS','|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tNow, quickly, quench it in the trough.','',26124),
(94414,'enUS','|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tSee? It already looks better. Heat and quench again.','',26124),
(94415,'enUS','|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tNow, bring the metal up to drawing heat in the forge.','',26124),
(94416,'enUS','|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tThat should be hot enough. Next, we\'ll draw the metal out into a bar.','',26124),
(94417,'enUS','|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tYou know what to do next. Heat the bar, then hammer it into shape.','',26124),
(94418,'enUS','|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tVery good. Let\'s get ready to weld. Apply some of the flux from my workbench.','',26124),
(94419,'enUS','Heroes, hurry! Iroxus must not be allowed to enter Dire Maul!','',26124),
(94420,'enUS','I have arrived, whelps. Come face me and get this over with!','',26124),
(94421,'enUS','Heh-eh, marvelous, marvelous.','',26124),
(94422,'enUS','Impressive.','',26124),
(94423,'enUS','','The metal will not bend so easily, try striking harder.',26124),
(94424,'enUS','Everything rests upon your shoulders, commander. Build us a navy so we can assault Gul\'dan from all sides. Good luck!','',26124),
(94425,'enUS','These fine men and women need a leader, $p. Your deeds prove you are the clear choice to bear that burden. Come, I will address them on your behalf.','',26124),
(94426,'enUS','Paladins of Azeroth, you\'ve gathered to mourn the loss of Highlord Tirion Fordring. Many of you looked to him as an ideal, the paragon of what we all strive to be.','',26124),
(94427,'enUS','You all know the noble deeds of the champion at my side. $p has been chosen by the Light to succeed Tirion as Highlord. Under our new leader, this order shall become a mighty weapon brought to bear against the Legion!','',26124),
(94428,'enUS','On this day, the Order of the Silver Hand is reborn! Together, Sargeras himself shall shudder at our might!','',26124),
(94429,'enUS','|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tOkay. It appears that leystone interacts violently with flux. Let\'s stop right there.','',26124),
(94430,'enUS','We seek Solog Roark!','',26124),
(94431,'enUS','No, friend. We have a common enemy and need your skills.','',26124),
(94432,'enUS','Tell me more...','',26124),
(94433,'enUS','You dare come into MY CAMP? I\'m going to take great pleasure in tearing you apart... piece by piece.','',26124),
(94434,'enUS','Come, heroes! Stand by my side and unleash your power!','Come, heroes! Stand by my side and unleash your power!',26124),
(94435,'enUS','','I hunt in shadow...',26124),
(94436,'enUS','The hunt continues...','',26124),
(94437,'enUS','','Evil shall tremble before my claws...',26124),
(94438,'enUS','Fear the night!','',26124),
(94439,'enUS','','These claws demand vengeance!',26124),
(94440,'enUS','Even the wicked fear what lurks behind the shadows...','',26124),
(94441,'enUS','Hail, Highlord.','Hail, Highlord.',26124),
(94442,'enUS','I heard that Highlord $p killed Archimonde with $Ghis:her; own bare hands!','I heard that Highlord $p killed Archimonde with $Ghis:her; own bare hands!',26124),
(94443,'enUS','Did you know that the Highlord once slew five hundred demons in a single blow?','Did you know that the Highlord once slew five hundred demons in a single blow?',26124),
(94444,'enUS','I overheard Champion Bachi say that the Highlord can come back from death.','I overheard Champion Bachi say that the Highlord can come back from death.',26124),
(94445,'enUS','I read that Highlord $p killed Ragnaros the Firelord... twice!','I read that Highlord $p killed Ragnaros the Firelord... twice!',26124),
(94446,'enUS','We\'ll continue our training later, $p. Stay alive out there.','',26124),
(94447,'enUS','Do you think I\'ll be picked to go on the next mission outing? I heard that the Highlord lets you keep some of the spoils!','Do you think I\'ll be picked to go on the next mission outing? I heard that the Highlord lets you keep some of the spoils!',26124),
(94448,'enUS','All the world\'s paladins united under one roof... the Legion doesn\'t stand a chance.','All the world\'s paladins united under one roof... the Legion doesn\'t stand a chance.',26124),
(94449,'enUS','Do you think Highlord $p has noticed how hard I\'ve been training lately? I want to impress $Ghim:her; so much!','Do you think Highlord $p has noticed how hard I\'ve been training lately? I want to impress $Ghim:her; so much!',26124),
(94450,'enUS','Do you think Highlord $p is a demigod?','Do you think Highlord $p is a demigod?',26124),
(94451,'enUS','The Highlord approaches. Salute!','The Highlord approaches. Salute!',26124),
(94452,'enUS','This creature is the chieftain of your Horde, $n? I like him. He is not afraid of brash action, but he waits to build a consensus among his people before he makes a move.$b$bWe will need a bold strategy if we are to attack Tanaan Jungle. Your warchief is fortunate to have you at the ready.','',26124),
(94453,'enUS','|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tLet\'s do this! Heat the leystone in the forge, just as you did before.','',26124),
(94454,'enUS','|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tNow, let\'s ask a Kirin Tor mage to thoroughly chill the metal. Check the cake stand outside my shop.','',26124),
(94455,'enUS','','You need my help in the blacksmithing shop? Fine, but every mage has her price... and my price happens to be candy.',26124),
(94456,'enUS','|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tCome on back in here! We still need to heat and re-chill the metal one more time.','',26124),
(94457,'enUS','','Consider me hired. See you there!',26124),
(94458,'enUS','|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_HUMAN_MALE.BLP:40|tVery good. Now let\'s see if you remember the rest.','',26124),
(94459,'enUS','I\'ll keep pondering on how we can improve our leystone techniques, $n. Your training isn\'t done yet.','',26124),
(94460,'enUS','This world will be burned to ash!','This world will be burned to ash!',26124),
(94461,'enUS','Submit to your destruction!','Submit to your destruction!',26124),
(94462,'enUS','None shall be spared!','None shall be spared!',26124),
(94463,'enUS','You have no idea... what you face...','You have no idea... what you face...',26124),
(94464,'enUS','You can\'t stop us all.','You can\'t stop us all.',26124),
(94465,'enUS','The Legion is eternal!','The Legion is eternal!',26124),
(94466,'enUS','You... will... die...','You... will... die...',26124),
(94467,'enUS','Da Horde be countin\' on ya, commander. Find us a shipwright so we can surround Tanaan!','',26124),
(94468,'enUS','','Since the time of my youth, I have lived in this vale... hunting alongside the vale prowlers and protecting the sanctity of the forest.$b$bAs I look out upon what was once the beautiful land that I love... my heart is filled with sadness. Will the forest ever be whole again?',26124),
(94469,'enUS','See how easily your gauntlet crumples beneath my hoof! This is unacceptable.','',26124),
(94470,'enUS','','Their numbers are endles... how can we possibly defeat the satyrs?',26124),
(94472,'enUS','Chaos will rain down upon you.','Chaos will rain down upon you.',26124),
(94473,'enUS','Destruction!','Destruction!',26124),
(94474,'enUS','You will know pain.','You will know pain.',26124),
(94475,'enUS','No mercy.','No mercy.',26124),
(94476,'enUS','Destroying Fel Conduit','Destroying Fel Conduit',26124),
(94477,'enUS','PH: TALKING HEAD - MALFURION: Archdruid Moonclaw and his kin embody the most feral and savage aspects of nature. I would tread lightly in their domain, $n.','',26124),
(94478,'enUS','','The flora of this land vary wildly from those of my home. Some of them seem more animal than plant.',26124),
(94479,'enUS','','The flowers have much to teach, if you are willing to listen.',26124),
(94480,'enUS','','Walk with a light hoof. The grass still breathes beneath you.',26124),
(94481,'enUS','Alard at the blacksmith shop will need a regular supply of foxflower. Do you have any?','Alard at the blacksmith shop will need a regular supply of foxflower. Do you have any?',26124),
(94482,'enUS','Alard at the blacksmith shop will need a regular supply of foxflower flux. Can you make any?','Alard at the blacksmith shop will need a regular supply of foxflower flux. Can you make any?',26124),
(94483,'enUS','','The Light is lost... they\'ve already won.',26124),
(94484,'enUS','You carry the Light within you, Tiza. Look inside yourself.','You carry the Light within you, Tiza. Look inside yourself.',26124),
(94485,'enUS','You\'re a paladin - you must uphold your oath fight against the darkness.','You\'re a paladin - you must uphold your oath fight against the darkness.',26124),
(94486,'enUS','I won\'t give up on you. You\'re getting out of here.','I won\'t give up on you. You\'re getting out of here.',26124),
(94487,'enUS','There\'s no point anymore. Look around you... it\'s over.','',26124),
(94488,'enUS','No, YOU look around. Is this what you want for all of Azeroth?','No, YOU look around. Is this what you want for all of Azeroth?',26124),
(94489,'enUS','Your death comes from the sky!','',26124),
(94490,'enUS','The Light has never forsaken you, Sammuel. Don\'t forsake it.','The Light has never forsaken you, Sammuel. Don\'t forsake it.',26124),
(94491,'enUS','Stand strong, brother. It is not over yet.','Stand strong, brother. It is not over yet.',26124),
(94492,'enUS','','I... I can feel the Light deep in me heart.',26124),
(94493,'enUS','','The Legion cannae defeat us! I\'ll make my way back to camp while I have the chance!',26124),
(94494,'enUS','','Yer right. I swore to defend the Light and here I am forsakin\' it.',26124),
(94495,'enUS','','I won\'t let ye down $p! I\'ll meet ye back at camp.',26124),
(94496,'enUS','','Bless ye, hero. I thought I was a goner!',26124),
(94497,'enUS','','I won\'t forget this! I\'ll meet ye back at camp.',26124),
(94498,'enUS','I knew someone would come for me. The Legion hasn\'t won yet!','',26124),
(94499,'enUS','I will fight against the Legion until my last breath! I\'ll meet you back at camp.','',26124),
(94500,'enUS','You\'re right, $p. How could I turn my back on the Light?','',26124),
(94501,'enUS','I can\'t. I won\'t. I will stand strong! I will meet you back at camp.','',26124),
(94502,'enUS','Maybe there is hope after all...','',26124),
(94503,'enUS','I won\'t let it be over. We can do this! I will meet you back at camp.','',26124),
(94504,'enUS','Time is running out, $n. You are needed at the Grove of Cenarius... we must act swiftly.','',26124),
(94505,'enUS','','Use your body to swing the hammer, not just your arm.',26124),
(94506,'enUS','','You\'re progressing quite nicely.',26124),
(94507,'enUS','','Of course. Our herbalists bring in plenty of foxflower. I will make sure to set some aside for your metalwork.',26124),
(94508,'enUS','','Whoah! Neat recipe. As long as the herbalists keep bringing me fresh foxflower, I can certainly make this preparation for you. No problem.',26124),
(94509,'enUS','Come back again later, $n. I have something interesting I want to show you.','',26124),
(94510,'enUS','I\'ve expended my energy. Keep at it while I recharge my powers!','I\'ve expended my energy. Keep at it while I recharge my powers!',26124),
(94511,'enUS','The dragons will serve or be slain!','',26124),
(94512,'enUS','The Thorgnir are broken. You\'re next!','',26124),
(94513,'enUS','','Skovald will possess the Aegis. You will not interfere!',26124),
(94514,'enUS','','Insolent worm... you cannot stop the God-King...',26124),
(94515,'enUS','You are too late, weakling! Even now, we break the dragons to serve us!','',26124),
(94516,'enUS','Only I possess the power of the Thorignir! The Aegis will be mine!','',26124),
(94517,'enUS','Give up, outsider. You are not worthy of the Halls of Valor!','',26124),
(94518,'enUS','','You need your mount shod? Let\'s see if I can make these hoofplates fit...',26124),
(94519,'enUS','','All done! You take care of that mount now. It\'s a beauty.',26124),
(94520,'enUS','Can you fit these hoofplates on my mount?','Can you fit these hoofplates on my mount?',26124),
(94521,'enUS','','I sure can! Just mount up right here on the curb and I\'ll take a look.',26124),
(94522,'enUS','Don\'t be a stranger, smith.','',26124),
(94523,'enUS','','I have more I can teach you, but you\'re not ready to learn it yet. Come back when you\'re a bit less green, $c.',26124),
(94524,'enUS','How pitiful. You must prove yourself worthy before you are given the privilege of facing me in battle.','',26124),
(94525,'enUS','Erling, teach this invader some manners.','',26124),
(94526,'enUS','A trifle. Asger, deliver this fool to Helheim!','',26124),
(94527,'enUS','Bah! She was nothing to me. Cuyler, avenge your fallen comrades.','',26124),
(94528,'enUS','Well, perhaps you can offer me some sport after all.','',26124),
(94529,'enUS','I thought I was dead for sure. I owe you my life!','',26124),
(94530,'enUS','I think I can make it back to camp on my own. Strike swiftly, champion!','',26124),
(94531,'enUS','The might of Stormwind will prevail, demons!','',26124),
(94532,'enUS','Shoot true, men. These demons will feel our fury!','',26124),
(94533,'enUS','Heroes, man the cannons! Take out that crystal!','',26124),
(94534,'enUS','','Hey there, commander. The crew\'s doing a fine job keeping the defenses up!',26124),
(94535,'enUS','','I have freely given you our hard-learned pattern for Demonsteel Armguards.',26124),
(94536,'enUS','','Speak with Urael if you wish to learn more demonsteel patterns.',26124),
(94537,'enUS','They will come at a price. We need raw materials.','',26124),
(94538,'enUS','$p has arrived!','$p has arrived!',26124),
(94539,'enUS','A rider approaches from the south!','A rider approaches from the south!',26124),
(94540,'enUS','Bless us all. The cavalry is here, lads!','',26124),
(94541,'enUS','A rider approaches from the north!','A rider approaches from the north!',26124),
(94542,'enUS','','I must take to the sky. Embrace the power I have given you.',26124),
(94547,'enUS','Hey there, commander! This place isn\'t quite as nice as Stormshield, but it\'s starting to get there.$b$bDon\'t you think?','',26124),
(94548,'enUS','The Drekirjar are attacking your dragon! Use Unleash Storm\'s Fury to blast them off!','',26124),
(94549,'enUS','We\'ve already directed a portrait to Undercity for you, $n. Follow me, please.','',26124),
(94550,'enUS','When you are ready, step through the portrait to teleport to Undercity.','',26124),
(94551,'enUS','Everyone, we ride for Light\'s Hope at once!','',26124),
(94552,'enUS','','I can\'t believe you talked me into this! Can you even control this thing?!',26124),
(94553,'enUS','','Heads up! Very big dragon incoming!',26124),
(94554,'enUS','Of course I can! Wait... woahh! Woah!','',26124),
(94555,'enUS','Alright, let\'s just set her down nice and eas-GAAHH!!','',26124),
(94556,'enUS','Return to the Gates of Valor','',26124),
(94557,'enUS','Come here, $n. I wish to show you something.','',26124),
(94558,'enUS','I can teach you how to craft that more efficiently.','',26124),
(94559,'enUS','Pause for a moment, smith. I have a lesson for you.','',26124),
(94560,'enUS','Allow me to teach you something, $n.','',26124),
(94561,'enUS','Very good, but let me teach you how to do it better.','',26124),
(94562,'enUS','Somebody call for air support?','Somebody call for air support?',26124),
(94563,'enUS','Keep those Pale scum back troops!','',26124),
(94564,'enUS','We must keep the tunnel open! Fight on!','',26124),
(94565,'enUS','Get me more men! These Pale are endless!','',26124),
(94566,'enUS','Collect the supplies! Don\'t let the Pale take them!','',26124),
(94567,'enUS','<The machine looks like it\'s best days are long gone, but it might still get you off the ground.>','',26124),
(94568,'enUS','Target is bugging out. Secure the Admiral.','Target is bugging out. Secure the Admiral.',26124),
(94569,'enUS','Let\'s fly to the Throne of Kil\'jaeden.','Let\'s fly to the Throne of Kil\'jaeden.',26124),
(94570,'enUS','A plaque on the side reads:$B$BThank you for purchasing the B-2 Personnel Relocator system. Be aware that use of the system is at your own risk and Vol\'mar Engineering takes no responsibility for death or dismemberment incurred from use.$b$bPersonnel Relocator features:$B$B* Minimalist cockpit,$b* Weight-shift adjustment turning,$b* Guided navigation system,$b    - G-X3 Beacons sold separately.$b* Gigantic supply of fuel.','',26124),
(94571,'enUS','Let\'s fly to the Throne of Kil\'jaeden.','Let\'s fly to the Throne of Kil\'jaeden.',26124),
(94572,'enUS','Bat-riders heading your way! Hang in there, the Admiral and I are trying to find a way up!','',26124),
(94573,'enUS','Many of the greatest paladins to walk Azeroth were buried on these sacred grounds. The others await you within the sanctum just below, $n.','Many of the greatest paladins to walk Azeroth were buried on these sacred grounds. The others await you within the sanctum just below, $n.',26124),
(94574,'enUS','Light bless you, $n. Azeroth would be lost to the Legion if it weren\'t for you.','Light bless you, $n. Azeroth would be lost to the Legion if it weren\'t for you.',26124),
(94575,'enUS','My beautiful leaves! You fleshbags will pay!','',26124),
(94576,'enUS','The green fire does not stop burning! It is inside me!','',26124),
(94577,'enUS','The corruption is too much! All will pay for this injustice!','',26124),
(94578,'enUS','You were supposed to hook the vrykul, not his pet lizard.','',26124),
(94579,'enUS','Victory for Sylvanas!','',26124),
(94580,'enUS','Hero, we\'re behind you! For Stormwind!','',26124),
(94581,'enUS','We will defend our homeland to the death!','',26124),
(94582,'enUS','Broadcasting Signal','Broadcasting Signal',26124),
(94583,'enUS','You will pay for your insolence, mortal!','',26124),
(94584,'enUS','Are you really so eager for death?','',26124),
(94585,'enUS','There\'s only one way out of this, Alliance, and it\'s through that line of demons! Cannons, lay down covering fire! All forces, CHARGE!','',26124),
(94586,'enUS','I\'m not going to make it...','I\'m not going to make it...',26124),
(94587,'enUS','Everything is... going dark...','Everything is... going dark...',26124),
(94588,'enUS','I\'m hit!','I\'m hit!',26124),
(94589,'enUS','Can\'t... hold on any longer...','Can\'t... hold on any longer...',26124),
(94590,'enUS','Side by side, don\'t let them break through!','',26124),
(94591,'enUS','Go for the throat!','',26124),
(94592,'enUS','This one\'s mine!','',26124),
(94593,'enUS','','Laying down a blizzard!',26124),
(94594,'enUS','','Putting this one on ice!',26124),
(94595,'enUS','','My magic will tear you apart!',26124),
(94596,'enUS','Break them!','',26124),
(94597,'enUS','You march to your doom!','',26124),
(94598,'enUS','Do not let them reach the spires!','',26124),
(94599,'enUS','Fer the glory of the Alliance!','',26124),
(94600,'enUS','I know... I\'m a wee bit late. Me misses weren\'t too pleased fer me ta come out ta battle after all these years. There  ain\'t nobody wantin\' an old warrior, she said.','',26124),
(94601,'enUS','Let\'s get this rumble started!','',26124),
(94602,'enUS','Me shields by me side and me blade\'s at yer service, commander!','',26124),
(94604,'enUS','You dare defy the Legion?','',26124),
(94605,'enUS','Shields up! Never give in!','',26124),
(94606,'enUS','You saved me! I... I can still hear the voices. Please, stop them from taking others.','',26124),
(94607,'enUS','I don\'t feel so good. How did I get here? What... what are those things?','',26124),
(94608,'enUS','The God King has already entered the Halls of Valor. It is time for you to finish your trials and defeat the Gatekeeper.','The God King has already entered the Halls of Valor. It is time for you to finish your trials and defeat the Gatekeeper.',26124),
(94609,'enUS','Fly me through the storm. I am ready to fight the Gatekeeper.','Fly me through the storm. I am ready to fight the Gatekeeper.',26124),
(94610,'enUS','Hey, I think I\'ve got it!','',26124),
(94611,'enUS','','Put that vile thing out of its misery already.',26124),
(94612,'enUS','He\'s not vile! Just... misunderstood.','',26124),
(94613,'enUS','Don\'t let my trophy headpiece fool you. I\'m on your side!','',26124),
(94614,'enUS','The cipher will be ours!','',26124),
(94615,'enUS','','We had the Forsaken fleet right where we wanted them - trapped in that bay like fish in a barrel.$B$BThere was no time to wait for reinforcements.$B$BWe had one shot, so I gave the order.$B$BI have no regrets.',26124),
(94616,'enUS','','Our crew will rendezvous with the Alliance navy and continue hunting Sylvanas.$B$BYou, however, have bigger fish to fry.',26124),
(94617,'enUS','We will find the cipher!','',26124),
(94618,'enUS','Strength alone will not win what you seek.','',26124),
(94619,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-GRAND CHAMPIONS-ALLIANCE.blp:50:80|t$b[Gryan Stoutmantle] Your invasion stops now, demon.','',26124),
(94620,'enUS','But it will get you started. Find me near Aggramar\'s Vault, and I will put your strength to the test.','',26124),
(94621,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-GRAND CHAMPIONS-ALLIANCE.blp:50:80|t$b[Gryan Stoutmantle] $p has unleashed the wrath of the Ashbringer. Charge!','',26124),
(94622,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-ARGALOTH.blp:50:80|t$b[Malgalor] I will crush the Pillars of Creation and you with them.','',26124),
(94623,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-ARGALOTH.blp:50:80|t$b[Malgalor] You waste your time, mortals.','',26124),
(94624,'enUS','Grab some healthstones, heroes!','',26124),
(94625,'enUS','','Ah, something to relieve the tedium!',26124),
(94626,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-ARGALOTH.blp:50:80|t$b[Malgalor] Your pathetic weapons cannot penetrate my armor.','',26124),
(94627,'enUS','You did it! I\'ll fly you back down to the portal.','You did it! I\'ll fly you back down to the portal.',26124),
(94628,'enUS','Fly me back through the storm. I am ready to enter the Halls of Valor.','Fly me back through the storm. I am ready to enter the Halls of Valor.',26124),
(94629,'enUS','','Wrong... mixture....',26124),
(94630,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-ARGALOTH.blp:50:80|t$b[Malgalor] This world will burn. Listen to the screams of your allies, \'champion\'.','',26124),
(94632,'enUS','','Those crystals appear to be anchoring the structures to our dimension. Take them out, and I bet the whole structure would crumble!',26124),
(94633,'enUS','Let\'s hope you\'re right.','',26124),
(94634,'enUS','My wolf is going to eat well tonight!','',26124),
(94635,'enUS','','It worked!',26124),
(94636,'enUS','One down, two to go.','',26124),
(94637,'enUS','You will pay for this transgression. The legion is endless! INFERNO.','',26124),
(94638,'enUS','One more and the shore is ours!','',26124),
(94639,'enUS','You wish to face the might of the Legion? Ha, very well. The master will reward me for your souls.','',26124),
(94640,'enUS','Your head will be a gift to Gul\'dan!','',26124),
(94641,'enUS','Finally, enough of your chatter.','',26124),
(94642,'enUS','We are strong, we are legion!','',26124),
(94643,'enUS','I will gather anyone still able to fight and join you on the battlefield, $p.','',26124),
(94644,'enUS','','Bringing such divided forces together is quite the feat, but there is still much to prove. I pray you live up to the Ashbringer\'s legacy, Highlord. Call on me when needed.',26124),
(94645,'enUS','What are you waiting for? Charge!','What are you waiting for? Charge!',26124),
(94646,'enUS','You, mortal, are merely postponing the inevitable...','You, mortal, are merely postponing the inevitable...',26124),
(94647,'enUS','Your form means nothing! We sense your being regardless of physical presence.','Your form means nothing! We sense your being regardless of physical presence.',26124),
(94648,'enUS','Into the shadows you go... But will you escape?','Into the shadows you go... But will you escape?',26124),
(94649,'enUS','Your safety is quite an illusion.','Your safety is quite an illusion.',26124),
(94650,'enUS','In the end, there is nothing...','In the end, there is nothing...',26124),
(94651,'enUS','The shadows offer no protection.','The shadows offer no protection.',26124),
(94652,'enUS','The forces grow stronger while you hide from your surroundings.','The forces grow stronger while you hide from your surroundings.',26124),
(94653,'enUS','You are nothing.','You are nothing.',26124),
(94654,'enUS','','They came so quickly! We\'re outnumbered!',26124),
(94655,'enUS','','We will meet you outside Light\'s Hope Sanctum when you are ready, Highlord $p. ((Liadrin and Gryan walk outside.))',26124),
(94656,'enUS','GOT YOU $n!','',26124),
(94657,'enUS','You think this is over, paladin? Our journey together has just begun...','',26124),
(94658,'enUS','The gates are surrounded by vrykul. No doubt a small task for a champion like yourself.$b$bI\'m sure you are weary after your travels through Helhiem.$b$bYou will need your full strength if you wish to defeat the gatekeeper.$b$bIt would be my honor if I could carry you to the Halls of Valor.$b$bWhat say you, champion?','',26124),
(94659,'enUS','I\'d love a ride.','I\'d love a ride.',26124),
(94660,'enUS','No thanks.','No thanks.',26124),
(94661,'enUS','Die, vermin!','',26124),
(94662,'enUS','Glory to Skovald!','',26124),
(94663,'enUS','For the God-King!','',26124),
(94664,'enUS','Valhalas!','',26124),
(94665,'enUS','You have bested me, champion. You may enter the Halls of Valor and continue your trials.','',26124),
(94666,'enUS','Give up or suffer.','',26124),
(94667,'enUS','This champion is worthy! You will let him through.','',26124),
(94668,'enUS','Ah! Finally a battle worth fighting!','',26124),
(94669,'enUS','Ha! Even deadlier than I\'d hoped!','Ha! Even deadlier than I\'d hoped!',26124),
(94671,'enUS','This will make their blood burn.','This will make their blood burn.',26124),
(94672,'enUS','Kilrogg will be pleased.','Kilrogg will be pleased.',26124),
(94673,'enUS','HURTS! Make you hurt, too!','',26124),
(94674,'enUS','My blood burns!','',26124),
(94675,'enUS','Fear smell good.','',26124),
(94676,'enUS','Crunch your bones.','',26124),
(94677,'enUS','By the Light... the Ashbringer...','',26124),
(94678,'enUS','','Words cannot describe... such purity...',26124),
(94679,'enUS','$n... come closer...','',26124),
(94680,'enUS','You must... wield the blade... you must... stop the Legion...','',26124),
(94681,'enUS','They need... you...','',26124),
(94682,'enUS','[[ Client-Side Cinematic - Docks Being Built ]]','',26124),
(94683,'enUS','Round clear! Reload!','',26124),
(94684,'enUS','Boom! Great shot!','',26124),
(94685,'enUS','Keep firing, I\'ll keep you loaded!','',26124),
(94686,'enUS','','Without this corn, our village dies. But don\'t worry dear, I\'ve got this area on lockdown!',26124),
(94687,'enUS','Over here! I\'ve got me mortar ready to fire!','',26124),
(94688,'enUS','','I wish I could explain what\'s happening, but it\'s as if the dead have arisen.',26124),
(94689,'enUS','Worst fishing spot ever.','',26124),
(94690,'enUS','How do they move so fast?!','',26124),
(94691,'enUS','Almost had it that time!','',26124),
(94692,'enUS','They\'re mocking me!','',26124),
(94693,'enUS','Would you shut up about the fish?!','',26124),
(94694,'enUS','Maybe you should try some REAL work.','',26124),
(94695,'enUS','Don\'t make me come over there.','',26124),
(94696,'enUS','Worthless wretch. I hope you fall in.','',26124),
(94697,'enUS','GAH! Ah... <gasp> that\'s better...','GAH! Ah... <gasp> that\'s better...',26124),
(94698,'enUS','Help... Help!','Help... Help!',26124),
(94699,'enUS','Anyone? Please help...','Anyone? Please help...',26124),
(94700,'enUS','Help! They won\'t let me leave!','Help! They won\'t let me leave!',26124),
(94702,'enUS','','You will have to get through me first if you want Gorefiend!',26124),
(94703,'enUS','','You can\'t stop him... and you can\'t stop the Burning Legion...',26124),
(94705,'enUS','Is the Admiral okay?','Is the Admiral okay?',26124),
(94706,'enUS','Heh, someone\'s rescuing us for a change. I\'ll try not to get used to it.','Heh, someone\'s rescuing us for a change. I\'ll try not to get used to it.',26124),
(94707,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-GRAND CHAMPIONS-ALLIANCE.blp:50:80|t$b[Gryan Stoutmantle] You\'ve done it! Meet back at camp at once!','',26124),
(94708,'enUS','Another volunteer! New blood to be spilled!','Another volunteer! New blood to be spilled!',26124),
(94709,'enUS','','Thank you, $Gmister:miss;! I was so scared all by myself, but I know a shortcut back to town!',26124),
(94711,'enUS','A Hulking Terror howls in rage!','',26124),
(94712,'enUS','We can observe Zeth\'Gol from here. The Bleeding Hollow clan is in chaos as one by one their leaders embrace Gul\'dan\'s dark gift. It is a good time to strike.','We can observe Zeth\'Gol from here. The Bleeding Hollow clan is in chaos as one by one their leaders embrace Gul\'dan\'s dark gift. It is a good time to strike.',26124),
(94713,'enUS','Work faster! Fail me and you will know horrors beyond reckoning!','',26124),
(94714,'enUS','','I have come too far to give up now. My people are in danger.',26124),
(94715,'enUS','','The villagers tell stories about the people of the forest, but until today, I had never seen a... a druid.$B$BTheir magic is beyond my comprehension. It\'s as if the very forest can hear their commands.',26124),
(94716,'enUS','','It was a desperate plan, some might even say foolish. It was a gamble to ask the druids for help.$B$BThey have treated me kindly, but it looks like they have their own battle to fight.',26124),
(94717,'enUS','','Do not tarry, $r. We cannot afford to squander such time.',26124),
(94718,'enUS','I am ready, Ysera. Let us find Malfurion!','I am ready, Ysera. We must find Malfurion!',26124),
(94719,'enUS','I see that I am speaking to a seasoned veteran.','',26124),
(94720,'enUS','Watch yourself. Make one wrong move and we\'ll throw you in chains.','',26124),
(94726,'enUS','Yum-my.','',26124),
(94727,'enUS','Uh. Meat\'s back on menu.','',26124),
(94728,'enUS','Eat.','',26124),
(94729,'enUS','Free! Free from that accursed body!','',26124),
(94730,'enUS','By besting me in battle, by destroying my body, you have undone the vile curse laid upon me by the mystics.','',26124),
(94731,'enUS','I go now to the Halls of Valor. You have my everlasting thanks, champion. May you one day die with honor.','',26124),
(94732,'enUS','I accept your challenge.','',26124),
(94733,'enUS','No! The Light burns in my heart... I will NEVER surrender!','',26124),
(94734,'enUS','Great work! Better get movin\' to the next spot \'fore it\'s too late!','',26124),
(94735,'enUS','Time fer me ta get movin\'! This evil ne\'er seems ta stop!','',26124),
(94736,'enUS','Well that weren\'t too bad. Time we get a move on it!','',26124),
(94737,'enUS','$n! You must... the Ashbringer. Leave me... there... isn\'t much time...','',26124),
(94738,'enUS','','Rage has blinded Malfurion. He and Xavius have a long history of conflict.',26124),
(94739,'enUS','','Barrage incoming to the gates! Take Cover!',26124),
(94740,'enUS','Akrrilo has been challenged at the Arena!','',26124),
(94741,'enUS','Tremble, mortals and despair! Doom has come to this world.','',26124),
(94742,'enUS','Gul\'dan, ready the Black Gate for my invasion. These vermin will not delay me. The last light will fall by my hand.','',26124),
(94743,'enUS','My coming heralds the end of your pathetic world, insects. Your meager forces shall be the first of many to be consumed by the Burning Legion!','',26124),
(94744,'enUS','Let the echoes of doom resound across this wretched world, that all who live may hear them and despair.','',26124),
(94745,'enUS','Your foolish crusade ends here, mortals. The legion comes and with it this world breathes its dying breath!','',26124),
(94746,'enUS','Insignificant whelps!','',26124),
(94747,'enUS','Anach kyree!','',26124),
(94748,'enUS','Vermin!','',26124),
(94749,'enUS','This world will burn!','',26124),
(94750,'enUS','Witness the flames that have consumed countless worlds!','',26124),
(94751,'enUS','All will burn in the legion\'s fire.','',26124),
(94752,'enUS','Accept your miserable fate.','',26124),
(94753,'enUS','Akim-kurai!','',26124),
(94754,'enUS','Kirel narak!','',26124),
(94755,'enUS','You are so easily corrupted.','',26124),
(94756,'enUS','Kneel before the might of the legion!','',26124),
(94757,'enUS','You cannot escape my power!','',26124),
(94758,'enUS','Your foolish resolve will break.','',26124),
(94759,'enUS','Manach sheek-thrish!','',26124),
(94760,'enUS','Face my eternal wrath!','',26124),
(94761,'enUS','Your soul will be mine!','',26124),
(94762,'enUS','Your soul shall know endless torment!','',26124),
(94763,'enUS','You will never escape the endless void!','',26124),
(94764,'enUS','The infinite darkness shall claim you!','',26124),
(94765,'enUS','You are powerless to stop me!','',26124),
(94766,'enUS','Burn! Burn in the fires of my wrath!','',26124),
(94767,'enUS','Your existence ends now!','',26124),
(94768,'enUS','The legion cannot be stopped!','',26124),
(94769,'enUS','Your fate is sealed!','',26124),
(94770,'enUS','Durotan sent me here to keep the peace between the Laughing Skull survivors and the Draenei.$b$b<Frogan looks uncomfortably toward the filthy Laughing Skull refugee camp.>$b$bI\'d rather be fighting something.','',26124),
(94771,'enUS','All will come to ruin!','',26124),
(94772,'enUS','Your souls are mine.','',26124),
(94773,'enUS','This meaningless little world has already succumbed to my corruption. The land itself seethes with the mark of the legion!','',26124),
(94774,'enUS','The pitiful light you call upon is powerless against me, child. End this foolishness!','',26124),
(94775,'enUS','Rikk amanalar golad mishun amir shi!','',26124),
(94776,'enUS','You have only delayed the inevitable! The Burning Legion consumes all!','',26124),
(94777,'enUS','Enough! Your meaningless struggle ends now!','',26124),
(94778,'enUS','Look upon the endless forces of the Burning Legion and know the folly of your resistance.','',26124),
(94779,'enUS','Destructions comes! Lok thorje sorankar!','',26124),
(94780,'enUS','Worthless mongrel! Your miserable race will suffer endlessly for your rebellion.','',26124),
(94781,'enUS','I grow tired of this pointless game. You face the immortal Legion, scourge of a thousand worlds.','',26124),
(94782,'enUS','I will shatter this pathetic world! Its broken husk will be torn apart in the twisting nether for all time!','',26124),
(94783,'enUS','Oblivion draws closer, mage! Give up!','',26124),
(94784,'enUS','I am the defiler! Lord of the Burning Legion! This world will feel my wrath and burn!','',26124),
(94785,'enUS','Pathetic.','',26124),
(94786,'enUS','You fall so easily!','',26124),
(94787,'enUS','Miserable worm.','',26124),
(94788,'enUS','You have failed this world!','',26124),
(94789,'enUS','Incoming barrage! Brace yourselves!','',26124),
(94790,'enUS','Here lies Javen Moonpaw, devoted father and loyal soldier. He fell in the Battle of Rinuin to a demon\'s blade. He shall be remembered always.','',26124),
(94791,'enUS','Jus to da southeast lies Fang\'rila. You be bringing friends wit ya, de Blackfang saberon are de most powerful tribe I ever seen. \n\nYou bring back da claws and mebbe I have some tings for ya...','',26124),
(94792,'enUS','What do those challenge totems you sell do?','What do those challenge totems you sell do?',26124),
(94793,'enUS','Summa dem kitties been around a while. They only come out when ya challenge dem.\n\nGo kill summa dem cats.\n\nI take ya claws and make a challenge totem. Take it to da Fang\'rila arena and place it. It be sure to anger one of dem really big ones. Make sure ya bring friends, them kitties be no joke!','',26124),
(94794,'enUS','Finish your business here, then meet me in the keep.','',26124),
(94795,'enUS','Centuries ago, Black Rook Hold was known amongst all the kaldorei. The masses feared its cruel justice, and the nobility were in awe of its power.','',26124),
(94796,'enUS','After Lord Ravencrest\'s passing, I led his army. The weight of command seasoned me quickly.','',26124),
(94797,'enUS','Lord Ravencrest was the greatest commander of his time. Only few can be considered his equal.','',26124),
(94798,'enUS','','Light protect us from this atrocity! Grant us your strength to banish this evil!',26124),
(94799,'enUS','Kur\'talos Ravencrest, Lord of Black Rook Hold, was respected and feared by many.','',26124),
(94800,'enUS','','No! I will never give in to darkness. The legion will fall!',26124),
(94801,'enUS','','The light will not fail!',26124),
(94802,'enUS','It has been thousands of years since I last walked these grounds, and yet, the memories flood back quickly.$B$BIt was here that we rallied our efforts to hold back the demon invasion.','',26124),
(94803,'enUS','Rise! Grow! Take this forest!','',26124),
(94804,'enUS','I live to serve Xavius.','',26124),
(94805,'enUS','Nothing can withstand the might of Xavius.','',26124),
(94806,'enUS','I will spread the Nightmare to every mountain and valley!','',26124),
(94807,'enUS','I\'m going to check in with Stormwind for updates.','I\'m going to check in with Stormwind for updates.',26124),
(94808,'enUS','I\'ll regroup with you shortly. I\'ve got to repair.','I\'ll regroup with you shortly. I\'ve got to repair.',26124),
(94809,'enUS','Duty calls!','Duty calls!',26124),
(94810,'enUS','You cannot hope to stop me.','',26124),
(94811,'enUS','Cut me down and I will grow anew!','',26124),
(94812,'enUS','I grow tired of you.','',26124),
(94813,'enUS','Your souls will feel the agony of a thousand worlds!','',26124),
(94814,'enUS','I will turn you into a weapon of the Legion. With your death, the last glimmer of hope for this world will be extinguished.','',26124),
(94815,'enUS','Thank you... I\'ll make my way back behind the lines.','Thank you... I\'ll make my way back behind the lines.',26124),
(94816,'enUS','They\'re animals! What has Gul\'dan done?','They\'re animals! What has Gul\'dan done?',26124),
(94817,'enUS','I\'ll try to make it to safety. Thank you.','I\'ll try to make it to safety. Thank you.',26124),
(94818,'enUS','The carnage...!','The carnage...!',26124),
(94819,'enUS','You saved my life. I\'ll make my way back to camp.','You saved my life. I\'ll make my way back to camp.',26124),
(94820,'enUS','I owe you my life. I will return to camp!','',26124),
(94821,'enUS','These animals fight without honor - were our people ever this savage?','',26124),
(94822,'enUS','Thank you... I will re-arm myself back at camp.','',26124),
(94823,'enUS','Gul\'dan is turning orcs into beasts!','',26124),
(94824,'enUS','Must... get... another weapon...','',26124),
(94825,'enUS','What do you know of Zorammarsh?','What do you know of Zorammarsh?',26124),
(94826,'enUS','Nobody owns the swamp, it is a death trap. Raptors, giant bats, giant snakes... and something else. There\'s some kind of giant shadow that prowls there. I felt its eyes on me while I inspected a mutilated corpse.$b$bNeedless to say I did not linger.','',26124),
(94827,'enUS','How defended is that Iron Horde tunnel?','How defended is that Iron Horde tunnel?',26124),
(94828,'enUS','','The hold still has forces in it, but with the recent \"landscaping\" from the citadel, they have apparently been breached by more of those Pale.$b$bWe could probably leave it alone and let the Iron Horde and Pale fight it out in there, but I suspect there may be useful resources to \"acquire\" as well.',26124),
(94829,'enUS','It is just as I feared. Lord Ravencrest\'s remains are gone.','',26124),
(94830,'enUS','The Fel Forge looks completely corrupted, what are they building there?','The Fel Forge looks completely corrupted, what are they building there?',26124),
(94831,'enUS','','Combine typical Iron Horde mass weapons building with fel corruption and you have that mess down there.$b$bThey are building tanks, cannons, and infantry weapons infused with fel energy. Also something bigger further in, something we should really stop them from building.',26124),
(94832,'enUS','Fel corrupted water is just pouring down from the mountain. What is going on at the Throne of Kil\'jaeden?','Fel corrupted water is just pouring down from the mountain. What is going on at the Throne of Kil\'jaeden?',26124),
(94833,'enUS','','I didn\'t get a great look but I didn\'t need to, it is a Burning Legion paradise up there. Giant demons being summoned, infernals raining down from the sky, cultists continuing the flow of corrupted water...$b$bYou should be really careful up there, everything there is big and mean. I highly recommend you bring friends before you take any offensive actions there.',26124),
(94834,'enUS','Join us in death, and the Master of the Tower will grant you eternal glory!','',26124),
(94835,'enUS','Insects! I am the will of Sargeras made manifest in your world. Stormwind is helpless before me!','',26124),
(94836,'enUS','Have fun! Second gear sticks a little.','Have fun! Second gear sticks a little.',26124),
(94837,'enUS','Need a lift?','Need a lift?',26124),
(94838,'enUS','Ready yourselves, men! The Broken Shore awaits. We leave on $n\'s command.','',26124),
(94839,'enUS','You brave souls have been chosen to strike into the depths of hell itself to rescue Highlord Tirion. This is your last chance to turn back.','',26124),
(94840,'enUS','I cannot thank you enough! You saved me!','I cannot thank you enough! You saved me!',26124),
(94841,'enUS','I am in your debt, but I must hurry to warn the others!','I am in your debt, but I must hurry to warn the others!',26124),
(94842,'enUS','These lands are safe no longer...','These lands are safe no longer...',26124),
(94843,'enUS','Ten hours in the sky. It\'s time for a break! You can take \'er up, if you have the skills.','',26124),
(94844,'enUS','There\'s bad stuff going on up there. Evil glowy draenei are messing with wolves and summoning demons. I think they killed all the normal draenei up there.$b$bIsn\'t there some sort of giant rock you can drop on all of them?','',26124),
(94845,'enUS','At first it wasn\'t impressive... raptors, snakes, big bats, nothing special.$b$bBut there is something in there... something really creepy that kills people. I got out of there super quick after that. And I\'m not going back.','',26124),
(94846,'enUS','I\'m on a break.','I\'m on a break.',26124),
(94847,'enUS','Hey! Don\'t scratch it up!','Hey! Don\'t scratch it up!',26124),
(94848,'enUS','Simply tell me where Sylvanas is, and I will end this quickly.','',26124),
(94849,'enUS','You should tell me what you know. My hounds are getting... hungry.','',26124),
(94850,'enUS','Where is Sylvanas? We shall stalk this entire wood if necessary.','',26124),
(94851,'enUS','Da Iron Horde dere are in trouble. When de fel stuff broke da land, it angered da Pale. They be attacking each other in da tunnel.$b$bWe don\'t have ta worry about dat tunnel too much, but dere may be sum useful stuff in dere.','',26124),
(94852,'enUS','Defend the strongpoint!','',26124),
(94853,'enUS','Why not save yourself the pain and tell me where Sylvanas is? You could spare both of us a lot of inconvenience if you would just come clean.','',26124),
(94854,'enUS','Ah! Perfect! A fresh lead. Where is your banshee queen?','',26124),
(94855,'enUS','They are building weapons of war, but now they power them with Gul\'dan\'s fel might. Soon we will face fel cannon, tanks, and smaller weapons.$b$bAlso, something else... something bigger.','',26124),
(94856,'enUS','Come down, come down, my little bony friend. We might let you live if you tell me what I want to know.','',26124),
(94857,'enUS','I was not able to get too close but what I saw was terrible!$b$bDemons! Infernals! Cultists corrupting the waters as they fall down here. You should take care and bring allies if you go up there, commander. The foes are quite fearsome.','',26124),
(94858,'enUS','I am suspicious of Altruis\'s motivations, but for now, we have the same goal - getting out of this prison.','',26124),
(94859,'enUS','Unleash the beasts!','',26124),
(94860,'enUS','Soon, I too will drink from Gul\'dan\'s font of power. We will be unstoppable!','',26124),
(94861,'enUS','I may be a demon hunter, but I am not one of the Illidari. I do not follow Illidan\'s teachings with the same blind loyalty as you.','',26124),
(94863,'enUS','You must become... the Ashbringer...','',26124),
(94864,'enUS','In the end, I could not follow Illidan\'s ways. He was falling to the demonic taint, and becoming more like his sworn enemies.','',26124),
(94865,'enUS','We got...','',26124),
(94866,'enUS','Nothing will... stop us...','',26124),
(94867,'enUS','|TInterface\\Icons\\Spell_Frost_WindWalkOn:20|t %s |cFFFF0404|Hspell:183480|h[Windwalks]|h|r, leaving behind images!','',26124),
(94868,'enUS','My power is but a fraction of... Gul\'dan\'s...','',26124),
(94869,'enUS','They are advancing! Felsworn, descend upon them. Show them your newfound strength.','',26124),
(94870,'enUS','Hold a bit longer, men! Reinforcements have arrived!','',26124),
(94871,'enUS','Hold the line! Those bombs will break through the doors soon enough!','',26124),
(94872,'enUS','Hah! Is that all ye got, demons? Ye ain\'t seen what me men have in store for ye just yet!','',26124),
(94873,'enUS','Still they stand in defiance. ARTILLERY! Fire on their position. Reduce them to PULP!','',26124),
(94874,'enUS','By my hammer!','By my hammer!',26124),
(94875,'enUS','This one\'s fer you!','This one\'s fer you!',26124),
(94876,'enUS','Keep movin\'! There\'s more just beyond!','Keep movin\'! There\'s more just beyond!',26124),
(94877,'enUS','This here\'s fer you!','This here\'s fer you!',26124),
(94878,'enUS','Yess... Yes... scorch the earth!','',26124),
(94879,'enUS','Felsworn, the master calls us to action! Reclaim what\'s ours...','',26124),
(94880,'enUS','Very well, I shall come down there myself.','',26124),
(94881,'enUS','Another victory on the field. Gul\'dan will be pleased.','',26124),
(94882,'enUS','Blood and honor, commander.','',26124),
(94883,'enUS','Ahahahahaha! I will cut you down.','',26124),
(94884,'enUS','For honor!','',26124),
(94885,'enUS','For justice!','',26124),
(94886,'enUS','There is no escape!','',26124),
(94887,'enUS','This is your final chapter!','',26124),
(94889,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-ARGALOTH.blp:50:80|t$b[Malgalor] What is the meaning of this?! My armor!','',26124),
(94890,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-ARGALOTH.blp:50:80|t$b[Malgalor] This... is... impossible!','',26124),
(94892,'enUS','Victory! Heroes have gained ground against Gul\'dan\'s forces.','',26124),
(94893,'enUS','[PH] Thanks for freeing me! I\'m going to run off now!','[PH] Thanks for freeing me! I\'m going to run off now!',26124),
(94894,'enUS','','Bring us in!',26124),
(94895,'enUS','You will be destroyed!','',26124),
(94896,'enUS','I thirst for battle!','',26124),
(94897,'enUS','Glory to Gul\'dan!','',26124),
(94898,'enUS','Come! My blood burns for combat!','',26124),
(94899,'enUS','<The Illidari prisoner\'s face is ghostly white.>$B$BI... broke free... and ran...$B$BI... almost made it...$B$BPlease save... my companions...','',26124),
(94900,'enUS','','I thirst for bloodshed...',26124),
(94901,'enUS','','Gul\'dan brings us strength!',26124),
(94902,'enUS','','Must ... kill!',26124),
(94903,'enUS','Gul\'dan will finish you all.','Gul\'dan will finish you all.',26124),
(94904,'enUS','I\'ve got one in my sights.','I\'ve got one in my sights.',26124),
(94905,'enUS','We\'re being attacked!','',26124),
(94906,'enUS','Keep them from the machines...','',26124),
(94907,'enUS','No, get away!','',26124),
(94908,'enUS','','Gul\'dan must not succeed. As long as I live, we shall stand against the Legion.',26124),
(94909,'enUS','Our army grows in might. You will be overrun!','',26124),
(94910,'enUS','Gul\'dan has shown us the way. Soon, we will all have the fel gift!','',26124),
(94911,'enUS','The might of our machines and the power of our warlocks will spell your doom.','',26124),
(94912,'enUS','You are nothing compared to Gul\'dan\'s magic!','',26124),
(94913,'enUS','The fel blood burns my veins! It gives me strength!','',26124),
(94914,'enUS','I will RIP you to SHREDS!!','',26124),
(94915,'enUS','Gul\'dan has shown me the path to infinite power.','',26124),
(94916,'enUS','Sad little creatures. You understand so little of the power we wield.','',26124),
(94917,'enUS','','Even he cannot hope to defeat Xavius alone. We must find him at once.',26124),
(94922,'enUS','This brave animal stayed by his master\'s side until the bitter end.','',26124),
(94923,'enUS','Avenge... us....','Avenge... us....',26124),
(94924,'enUS','Welcome to the Ironhorn Enclave.','',26124),
(94925,'enUS','He took everything! My crew... my name... my SHIP!','',26124),
(94926,'enUS','Death will not stop my rage. I\'M the real Ironbeard!','',26124),
(94927,'enUS','Ha ha, my crew may have betrayed me, but they didn\'t get my treasure! It\'s like they forgot how to swim!','',26124),
(94928,'enUS','I curse the false Ironbeard! May his ship run into mines!','',26124),
(94929,'enUS','They got me... but at least I took several of them double-crossers with me!','',26124),
(94930,'enUS','I can see your secrets...','',26124),
(94931,'enUS','Guarm sniffs you as you walk by.','',26124),
(94932,'enUS','Invaders. Warn the Brood Queen!','',26124),
(94933,'enUS','I will drink your blood!','',26124),
(94934,'enUS','Demon hunters? How did you get here?','',26124),
(94935,'enUS','I\'ll rend you limb from limb.','',26124),
(94936,'enUS','Die, Illidari fool.','',26124),
(94937,'enUS','I will bathe in your blood!','',26124),
(94938,'enUS','All who stand against Gul\'dan will be destroyed!','',26124),
(94939,'enUS','The blood is our power!','',26124),
(94940,'enUS','For Gul\'dan! For Victory!','',26124),
(94941,'enUS','Don\'t let them near the equipment!','',26124),
(94942,'enUS','My hammer, your face!','',26124),
(94943,'enUS','Intruder in the camp!','',26124),
(94944,'enUS','Huh? You\'re not supposed to be here!','',26124),
(94945,'enUS','Ahh... you\'re not a miner, are you? Well I\'m sure you can find some ore on the auction house. Or you could simply purchase ore from another adventurer.','',26124),
(94946,'enUS','Don\'t interrupt me when I\'m working!','',26124),
(94947,'enUS','In the name of Gul\'dan!','In the name of Gul\'dan!',26124),
(94948,'enUS','You dare attack us? Fool! The Legion is all-powerful!','You dare attack us? Fool! The Legion is all-powerful!',26124),
(94949,'enUS','Show them the powers Gul\'dan has taught us!','Show them the powers Gul\'dan has taught us!',26124),
(94950,'enUS','Nothing will stop us!','Nothing will stop us!',26124),
(94951,'enUS','$n, we must take the fight to the Legion here in the volcano. They must be destroyed before we fly up to the Brood Queen\'s command ship, the Fel Hammer.\n\nThen, we\'ll kill her, take the Sargerite Keystone, and return to the Black Temple to slay the invaders.\n\nNo small feat, but I think we\'ll manage.','',26124),
(94952,'enUS','Stick your head up for one second... just one second...','',26124),
(94953,'enUS','He he... don\'t worry... you won\'t even feel this...','',26124),
(94954,'enUS','Why do they keep showing up in the same spots?! This is too easy!','',26124),
(94955,'enUS','Hah! I shot them all in formation!','',26124),
(94956,'enUS','Oops, that was a fel orc... his fault for getting in my sights at the last second.','',26124),
(94957,'enUS','For the Horde!','',26124),
(94958,'enUS','These are our lands!','',26124),
(94959,'enUS','Press onward! We must stop them before they send reinforcements!','',26124),
(94960,'enUS','These battles never end!','',26124),
(94961,'enUS','I\'m going to check in with Orgrimmar.','I\'m going to check in with Orgrimmar.',26124),
(94963,'enUS','WARNING: CONTENT BEYOND THIS POINT IS VERY UGLY FIRST PASS. IT\'S PLAYABLE, BUT DO SO AT YOUR OWN RISK.','WARNING: CONTENT BEYOND THIS POINT IS VERY UGLY FIRST PASS. IT\'S PLAYABLE, BUT DO SO AT YOUR OWN RISK.',26124),
(94964,'enUS','','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TInterface\\Icons\\achievement_character_bloodelf_female.blp:40|t$B[Lady Liadrin] You there. Over here!',26124),
(94965,'enUS','Hi!','[NYI - SEE A COOL SCENE WITH RAVENCREST & GUL\'DAN TURNING THE ILLIDARI.]',26124),
(94966,'enUS','Lord Ravencrest cannot be stopped. We will prevail!','',26124),
(94967,'enUS','Lord Ravencrest\'s army will purge this land of all you invaders.','',26124),
(94968,'enUS','','Death is just the beginning!',26124),
(94969,'enUS','','You heard the master.  These trespassers have caused enough trouble!',26124),
(94970,'enUS','','Finally... one with... the master...',26124),
(94971,'enUS','','Cease bombardment!',26124),
(94972,'enUS','','Man the deck guns! All hands, prepare for contact with the enemy!',26124),
(94973,'enUS','','Gryphon riders, first wing, prepare to descend! Second wing, hold position!',26124),
(94974,'enUS','','Enemy fliers incoming! All guns, fire at will!',26124),
(94975,'enUS','The body has been scorched in several places.','',26124),
(94976,'enUS','Face it... we\'s lost.','',26124),
(94977,'enUS','We ain\'t gonna find no beach if we\'s keep goin\' in circles. You getting us lost!','',26124),
(94978,'enUS','Ain\'t no peasants down here to munch on. You says there was peasants!','',26124),
(94979,'enUS','Thems vrykul are hard on me teeth. We should head back to Highmountain.','',26124),
(94980,'enUS','Yous said we was gonna be there by now. I ain\'t seein\' us being there now.','',26124),
(94981,'enUS','This all your fault. We\'s lost.','',26124),
(94982,'enUS','Ain\'t nuthin\' out here but mutton and vrykul. I thoughts you said we was going to find a bunch of tasty gnomes down here.','',26124),
(94983,'enUS','Ain\'t no roastable tauren down here. You said we was going to find more roastable tauren down here.','',26124),
(94984,'enUS','','Boarding party on the deck!',26124),
(94986,'enUS','A quest objective event fires at this point.','A quest objective event fires at this point.',26124),
(94987,'enUS','My magic will fix your gear right up. All I ask is a small tip for my work.','',26124),
(94988,'enUS','Rendarr has been challenged at the Arena!','',26124),
(94989,'enUS','Eyepiercer has been challenged at the Arena!','',26124),
(94990,'enUS','They will die.','',26124),
(94991,'enUS','You won\'t survive Inferno Peak...','',26124),
(94992,'enUS','Go forth, minions of Sargeras. Our time has come!','',26124),
(94993,'enUS','Spare no one.','',26124),
(94994,'enUS','Destroy all living things. Leave nothing in your path!','',26124),
(94995,'enUS','It\'s too late - they\'re here!','',26124),
(94996,'enUS','I\'m supposed to be on the next boat!','',26124),
(94997,'enUS','','Darkgrove has fled into a nearby cavern. Hunt him down and end this.',26124),
(94998,'enUS','Defend the boats. We\'ve got to get to Tanaan.','Defend the boats. We\'ve got to get to Tanaan.',26124),
(94999,'enUS','I\'ll hold them off. Get to the boats!','I\'ll hold them off. Get to the boats!',26124),
(95000,'enUS','You can\'t stop all of us.','You can\'t stop all of us.',26124),
(95001,'enUS','This war isn\'t over yet.','This war isn\'t over yet.',26124),
(95002,'enUS','Protect the shoreline. They\'re trying to stop us!','Protect the shoreline. They\'re trying to stop us!',26124),
(95003,'enUS','Don\'t let them destroy the ships!','Don\'t let them destroy the ships!',26124),
(95004,'enUS','A battle takes place against Xavius. Ysera falls and is corrupted. Malfurion, gravely wounded, chases after Xavius.','A battle takes place against Xavius. Ysera falls and is corrupted. Malfurion, gravely wounded, chases after Xavius.',26124),
(95005,'enUS','Did you think it would be so easy, to wander these halls unattended?','',26124),
(95006,'enUS','Come then. This journey shall be your trial... and your doom.','',26124),
(95007,'enUS','[PLACEHOLDER SCENE] The tears have been stolen and the guards are dead! The player will see Xavius escape with the tears before anything can be done.','[PLACEHOLDER SCENE] The tears have been stolen and the guards are dead! The player will see Xavius escape with the tears before anything can be done.',26124),
(95008,'enUS','','The battle continues, commander. Where shall we concentrate our efforts?',26124),
(95009,'enUS','','Our enemies surround us, commander. Where shall we spill their blood today?',26124),
(95010,'enUS','You called, and the Hand of Argus has answered.','',26124),
(95011,'enUS','','The very mountains bleed today, commander. Come, let us stave off armageddon one more day!',26124),
(95012,'enUS','','Our outriders have reported back, commander. We are greatly outnumbered on all sides. It is a glorious day to fight!',26124),
(95013,'enUS','','So many foes... so little time... Who should die today?',26124),
(95014,'enUS','','The jungle hides many dangers. It would be wise to go on the offensive today.',26124),
(95015,'enUS','','If this is truly the end of the world, then let us meet our end in the fields of combat!',26124),
(95016,'enUS','','Gul\'dan hasn\'t broken us yet, commander. Where shall we strike today?',26124),
(95017,'enUS','How dare you interrupt my entertainment!','',26124),
(95018,'enUS','How did... I... lose....','',26124),
(95019,'enUS','Hostiles in the camp! Destroy them - in the name of Gul\'dan!','Hostiles in the camp! Destroy them - in the name of Gul\'dan!',26124),
(95020,'enUS','The might of Gul\'dan is upon you!','The might of Gul\'dan is upon you!',26124),
(95021,'enUS','For Gul\'dan! For the Legion!','For Gul\'dan! For the Legion!',26124),
(95022,'enUS','Burn!','Burn!',26124),
(95023,'enUS','Kill them all!','',26124),
(95024,'enUS','YOUR BLOOD IS MINE!','',26124),
(95025,'enUS','I\'m gonna enjoy gutting you!','',26124),
(95026,'enUS','Blood! Blood! BLOOD!','',26124),
(95027,'enUS','Strip the flesh!','',26124),
(95028,'enUS','For the glory of Gul\'dan!','',26124),
(95029,'enUS','You know what to do, smith: temper, heat, hammer, and weld. You can use any of the shop\'s equipment.','',26124),
(95030,'enUS','Go see if you can find a frost mage to help us, $n. If we can get our quenching trough cool enough, we can perform this leysmithing technique.','',26124),
(95031,'enUS','Noo! My power!','',26124),
(95032,'enUS','A responsible smith does not waste material. You may use any pieces of scrap metal that you find around our camp.','',26124),
(95033,'enUS','','Be quick about your work. You\'ll only have a small window of time to hammer out those red-hot leystone bars into the components you need.',26124),
(95034,'enUS','Your feeble minds will be mine to harvest!','',26124),
(95035,'enUS','None can resist the Legion. In time, all will serve.','',26124),
(95036,'enUS','The Firmament Stone is sacred to our order.$b$bIt is not unheard of for an outsider to seek out our anvil... but access does not come easily.','',26124),
(95037,'enUS','Never should have come here! He is lost!','',26124),
(95038,'enUS','Leave! The Crusader must not be disturbed!','',26124),
(95039,'enUS','The Construct prepares to |cFFFF0000|Hspell:184247|h[Felblaze Charge]|h|r towards you!','The Construct prepares to |cFFFF0000|Hspell:184247|h[Felblaze Charge]|h|r towards you!',26124),
(95040,'enUS','Stay away! Stay away! I do you favor!','',26124),
(95041,'enUS','I will conquer this jungle! I will bring it all to the light! You will not stop me!','',26124),
(95042,'enUS','At last I see... I failed long ago...','',26124),
(95043,'enUS','The Construct faces you and readies a |cFFFF0000|Hspell:180221|h[Volatile Fel Orb]|h|r!','The Construct faces you and readies a |cFFFF0000|Hspell:180221|h[Volatile Fel Orb]|h|r!',26124),
(95044,'enUS','The Legion is coming. It is in our best interest to be ready for them.','',26124),
(95045,'enUS','I say let them come. We will defeat them together... or die trying.','',26124),
(95046,'enUS','','This temple has stood for generations as a tribute to The Moon Goddess, Elune.$b$bThis is not the first time the Burning Legion has sought to destroy it... and they will fail just as they did before.',26124),
(95047,'enUS','Come and get some, demons! I\'ve got one bomb for each of ya!','',26124),
(95048,'enUS','Hold the line! Funnel them into range of my bombs!','',26124),
(95049,'enUS','Boom!','',26124),
(95050,'enUS','That\'s gotta hurt!','',26124),
(95051,'enUS','The threat of the Emerald Nightmare approaches as an unstoppable storm upon the horizon... but we would sooner die fighting than run away and let it claim all that we hold dear.','',26124),
(95052,'enUS','First Cenarius... now... Ysera?$b$bXavius will pay for what he has done... they will be avenged!','',26124),
(95053,'enUS','Our power is undeniable!','',26124),
(95054,'enUS','How... did you...?','',26124),
(95055,'enUS','','We\'ve got him now! Focus on their commander!',26124),
(95056,'enUS','The legion will crush you! INFERNO!','',26124),
(95057,'enUS','Xavius...$b$bHe must be stopped...','',26124),
(95058,'enUS','','Look out, infernals!',26124),
(95059,'enUS','Your souls will fuel the soul forge!','',26124),
(95060,'enUS','I will flay the flesh from your bones!','',26124),
(95061,'enUS','What has become of our precious Shaladrassil... our beloved Cenarius?$b$bI have failed them.','',26124),
(95062,'enUS','<The sapling that grew from the Seed of Life is lush and vibrant, starkly contrasting the twisted destruction all around. From within the glowing leaves of the tree, the whisper of a voice can be softly heard...>','',26124),
(95063,'enUS','Now, $p, hit the metal as hard as you can.','',26124),
(95064,'enUS','Is that all you can do? You\'ll have to do much better than that.','',26124),
(95065,'enUS','Come on, smith! HIT IT!!!','',26124),
(95066,'enUS','','You... must get to the temple...',26124),
(95067,'enUS','My power will destroy this pathetic land!','',26124),
(95068,'enUS','How do you think you will fare against the might of Xavius?','',26124),
(95069,'enUS','The Nightmare will consume all of you!','',26124),
(95070,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-ARGALOTH.blp:50:80|t$b[Malgalor] You will all DIE!','',26124),
(95071,'enUS','Azsuna will fall!','Azsuna will fall!',26124),
(95072,'enUS','Surrender the Tidestone, mortal.','Surrender the Tidestone, mortal.',26124),
(95073,'enUS','You cannot stop us. We are infinite.','You cannot stop us. We are infinite.',26124),
(95074,'enUS','Azsuna is only the beginning.','Azsuna is only the beginning.',26124),
(95075,'enUS','Hurry. The Illidari are about to be overrun.','',26124),
(95076,'enUS','','Such devastation. We must destroy these monstrosities.',26124),
(95077,'enUS','','Call down my wrath to purge these unnatural creatures.',26124),
(95078,'enUS','','I fear that this forest is beyond hope. We must make haste.',26124),
(95079,'enUS','PLACEHOLDER: Cenarius is taken by the Nightmare. Enraged, Malfurion pursues Xavius, leaving the others behind.','',26124),
(95080,'enUS','We need to get down there, $n. The Illidari need our help to destroy the Burning Legion.\n\nOnce we\'ve done that, we can get to our business with the Pillar of Creation here on Azsuna.','',26124),
(95081,'enUS','','I will never be taken prisoner again. Never!',26124),
(95082,'enUS','PLACEHOLDER: Xavius escapes with Malfurion to the dungeon. Ysera has been sent to destroy the temple. Koda the Archdruid is dying...','',26124),
(95083,'enUS','','Xavius commands us.',26124),
(95084,'enUS','','This river will flow with your blood.',26124),
(95085,'enUS','','Succumb to the Nightmare or die.',26124),
(95086,'enUS','','This river is ours!',26124),
(95087,'enUS','You\'ve come because you\'ve heard of the legend of $p, the paladin proven worthy of wielding the Silver Hand and succeeding Tirion. With $p at our head we can be the weapon brought to bear against the Legion.','',26124),
(95088,'enUS','Do not linger here too long. The Legion is attacking everywhere.','',26124),
(95089,'enUS','$n, I\'ll meet you up there. You will find the repose up the road to the northeast.','',26124),
(95090,'enUS','Khadgar nods to Stellagosa.','',26124),
(95091,'enUS','|cFFFF0000|Hspell:182582|h[Fel Incineration]|h|r is following you!','',26124),
(95092,'enUS','What is happening here?','',26124),
(95093,'enUS','I\'m free!','',26124),
(95094,'enUS','You got it from here! We\'ll push them back at the other camps!','',26124),
(95095,'enUS','Keep pushing! We\'ve gotta go help the others.','',26124),
(95096,'enUS','This is as far as we go. We\'ll secure the perimeter and meet up with you soon.','',26124),
(95097,'enUS','What ho! The pathway to Un\'goro Crater is embroiled in a great fracas! I suspect dragons!','',26124),
(95098,'enUS','We\'ve set up along the cliffs at the southern pass! We will hold them off as long as we can...','We\'ve set up along the cliffs at the southern pass! We will hold them off as long as we can...',26124),
(95099,'enUS','Good job Warder! Did any get away?','',26124),
(95100,'enUS','No sir, it was only these two.','',26124),
(95101,'enUS','Yes executor!','',26124),
(95102,'enUS','We\'re on our way!','',26124),
(95103,'enUS','Engineers! Throw yourselves upon them!','',26124),
(95104,'enUS','Your presence is NOT welcome in OUR chamber! Your kind could never fathom the knowledge flowing through these runes!','',26124),
(95105,'enUS','I won\'t bother with you, peasants. I\'ll let my students deal with your kind.','',26124),
(95106,'enUS','Very well. I\'ll deal with you myself.','',26124),
(95107,'enUS','','HA HA HA!  Bloodbeard, it looks like your challenger has arrived.',26124),
(95108,'enUS','','Don\'t worry Nel. We\'ll find our prey soon.',26124),
(95109,'enUS','','And afterward I\'ll give you two a juicy clefthoof steak!',26124),
(95110,'enUS','They come for me. Stop them, Sargerei!','',26124),
(95111,'enUS','You could not stop me in Shattrath. You will not end me here, fools.','',26124),
(95112,'enUS','Just a bit longer, and the binding will be complete...','',26124),
(95113,'enUS','Fight, you fools! Stop them!','',26124),
(95114,'enUS','I should have expected as much. No matter.','',26124),
(95115,'enUS','The construct is fully powered... the final binding will have to wait. For now, I believe we have a score to settle, fleas!','',26124),
(95116,'enUS','For now, I believe we have a score to settle, fleas.','',26124),
(95117,'enUS','Death could not stop me - how do you hope to?','',26124),
(95118,'enUS','You killed me once, mortals. It will not happen again.','',26124),
(95119,'enUS','$n, over here. Let us walk in together.','',26124),
(95124,'enUS','Placeholder cinematic: The player is granted freedom by Helira.','',26124),
(95125,'enUS','Time itself bends to my will!','',26124),
(95126,'enUS','I am more powerful than ever!','',26124),
(95127,'enUS','Kneel before me!','',26124),
(95128,'enUS','HEY! I\'m at 100% Life!','HEY! I\'m at 100% Life!',26124),
(95129,'enUS','No! The binding... I cannot control...','',26124),
(95130,'enUS','My soul itself shall strike you down!','',26124),
(95131,'enUS','Sargerei! To me!','',26124),
(95132,'enUS','Join me in death!','',26124),
(95133,'enUS','Wither away, fools!','',26124),
(95134,'enUS','Your life ends here!','',26124),
(95135,'enUS','You cannot control it... it is MINE!','',26124),
(95136,'enUS','Out! It is too good for you, pitiful soul!','',26124),
(95137,'enUS','The nether! It... consumes me...','',26124),
(95138,'enUS','The time of apocalypse is upon us once again, $n.$b$bWill you rise to the occasion?','',26124),
(95139,'enUS','You! Yesssss! With that power in my hands, I can get him back.','',26124),
(95140,'enUS','<Koltira regards you with an emotionless stare.>','',26124),
(95141,'enUS','<Koltira glowers at you.>$b$bLeave... I have nothing to say to you.','',26124),
(95142,'enUS','When you took your first unholy breath it was in the musty halls of Acherus.$b$bIt is here where we must set aside our differences and work as a united Knights of the Ebon Blade if we are to defeat the Demons.','',26124),
(95143,'enUS','Ywaqol ish\'wi agthshh.','',26124),
(95144,'enUS','What has been set in motion will come to pass.','',26124),
(95145,'enUS','Iilth vwah, uhn\'agth fhssh za.','',26124),
(95146,'enUS','Where one falls, many shall take its place.','',26124),
(95147,'enUS','Yglath vu\'aghth qol. Yglath ish\'za.','',26124),
(95148,'enUS','There is no light in the darkness. There is no hope.','',26124),
(95149,'enUS','Ithvil azj shnk naush.','',26124),
(95150,'enUS','Gaze upon your end.','',26124),
(95151,'enUS','[PH]The Runeseer banishes you to Helheim!','',26124),
(95152,'enUS','Az\'jtal calls upon its servants!','Az\'jtal calls upon its servants!',26124),
(95153,'enUS','You can\'t backstab me again Torglork! I\'m already dead!','',26124),
(95154,'enUS','Should have died... on my own ship...','',26124),
(95155,'enUS','I can kill just as fast up close!','',26124),
(95156,'enUS','Take care of my rifle...','',26124),
(95157,'enUS','This is sacred ground! Prepare to die!','',26124),
(95158,'enUS','I will haunt you... forever...','',26124),
(95159,'enUS','Not... over..','',26124),
(95160,'enUS','Slice it into strips!','',26124),
(95161,'enUS','Must... sleep....','',26124),
(95162,'enUS','Great... ANOTHER problem!','',26124),
(95163,'enUS','You take care of the Pale then...','',26124),
(95164,'enUS','I saw you coming a mile away!','',26124),
(95165,'enUS','You\'ll never get past the traps...','',26124),
(95166,'enUS','Little $r $n is friend to Gentle Rosh.\n\nYou stay?','',26124),
(95167,'enUS','Yes, I think I\'ll stay awhile.','Yes, I think I\'ll stay awhile.',26124),
(95168,'enUS','$n was consumed by Hunger for Life.','',26124),
(95169,'enUS','','Thanks for the help, $g handsome:beautiful;.',26124),
(95170,'enUS','','I\'m taking this opportunity to leave. I\'ll tell Mr. Shackle to expect you.',26124),
(95171,'enUS','Heyo! You... YOU! I owe you. I better get out of here.','',26124),
(95172,'enUS','Rgth vi zash.','',26124),
(95173,'enUS','They see your soul. They know your fear.','',26124),
(95174,'enUS','Vilk qo nrsh, czkth.','',26124),
(95175,'enUS','The tide cannot be altered. It ebbs and flows.','',26124),
(95176,'enUS','One for you! And another for you! Boom! Ha ha ha ha!','',26124),
(95177,'enUS','There\'s enough black powder to go around, demon scum! Step right up!','',26124),
(95178,'enUS','You, in the green! Hit their left flank! No, their other left!','',26124),
(95179,'enUS','Gentle Rosh likes you, my little $r. Now Gentle Rosh will leave.','',26124),
(95181,'enUS','','You\'re messin\' with the wrong cartel! Get \'em, boys!',26124),
(95182,'enUS','','Steady! Stay in file! Show this Demon scum how a Goblin fights!',26124),
(95183,'enUS','','Yo flyboy, in the balloon! More bombs!',26124),
(95184,'enUS','','I\'ve been in there for days. Thank you, $c. I have got to go, if you know what I mean!',26124),
(95185,'enUS','To walk the high halls is the greatest honor of the valorous.','',26124),
(95186,'enUS','You wield the Light with an unwavering conviction. I admire your passion, $n. I will give you my blessing.','',26124),
(95187,'enUS','I will give you my blessing.','',26124),
(95188,'enUS','A pity you will never set foot beyond its gates!','',26124),
(95189,'enUS','Impossible! No outsider has ever bested me in combat!','',26124),
(95191,'enUS','I judge you worthy, $c.','',26124),
(95192,'enUS','What\'s this? An outsider seeks my judgment?','',26124),
(95193,'enUS','Insolent worm!  You would disgrace the Halls of Valor with your presence!','',26124),
(95194,'enUS','I was mistaken. Your worth cannot be denied.','',26124),
(95195,'enUS','You wish to walk among the chosen?','',26124),
(95196,'enUS','Come then, show me your fury!','',26124),
(95197,'enUS','Never have I faced such ferocity. The blood of the dragon flows within your veins, outsider.','',26124),
(95198,'enUS','','Hey... HEY $g mister:lady;. You gotta let me outa here.',26124),
(95199,'enUS','I\'m right over here. Just watch out for the giant!','',26124),
(95200,'enUS','You come open door. Gentle Rosh not crush you.','',26124),
(95201,'enUS','','Stand proud, warriors. Our enemies march upon the foot of this mighty citadel. Be on guard.',26124),
(95202,'enUS','','Status report, soldier!',26124),
(95203,'enUS','','How fares your work, warrior?',26124),
(95204,'enUS','','You, check on the citadel\'s defenses.',26124),
(95205,'enUS','','Inspect our defenses, now!',26124),
(95206,'enUS','','I see we have visitors. To arms!',26124),
(95207,'enUS','','So, you wish to test the might of the Fel Horde? Come warriors, show them how we treat unwanted guests.',26124),
(95208,'enUS','','Hah-ha! Trample their corpses!',26124),
(95209,'enUS','','For Gul\'dan!',26124),
(95210,'enUS','','We are victorious!',26124),
(95211,'enUS','','Taste my axe!',26124),
(95212,'enUS','','Die!',26124),
(95213,'enUS','','If you want something done right, you have to do it yourself...',26124),
(95214,'enUS','','I\'ll be back...',26124),
(95215,'enUS','','Fire in the hole!',26124),
(95216,'enUS','','Comin\' in hot!',26124),
(95217,'enUS','','Blitz!',26124),
(95218,'enUS','','Run them down!',26124),
(95219,'enUS','','Cannons on the way.',26124),
(95220,'enUS','','They\'ll never see what hit them...',26124),
(95221,'enUS','','Send in the crusher!',26124),
(95222,'enUS','','Crusher, incoming!',26124),
(95223,'enUS','','Burn them to the ground.',26124),
(95224,'enUS','','Destruction!',26124),
(95225,'enUS','','Strike them down!',26124),
(95226,'enUS','','Destroy them!',26124),
(95227,'enUS','','The might and invention of the Fel Horde... the fury of Hellfire itself! Behold!',26124),
(95228,'enUS','','I warned you!',26124),
(95229,'enUS','','FULLY CHARGED!',26124),
(95230,'enUS','','Heads up!',26124),
(95231,'enUS','','Ha ha ha, that was fun.',26124),
(95232,'enUS','','EJECT! EJECT!',26124),
(95233,'enUS','','Tick tock, your time is up!',26124),
(95234,'enUS','','Pounded.',26124),
(95235,'enUS','','Well done.',26124),
(95236,'enUS','','The ground trembles!',26124),
(95237,'enUS','','Burn burn burn!',26124),
(95238,'enUS','','Incoming!',26124),
(95239,'enUS','','Fire!',26124),
(95240,'enUS','','Inferno!',26124),
(95241,'enUS','','Tick tock, the clock is ticking!',26124),
(95242,'enUS','','Boom!',26124),
(95243,'enUS','The spirits have sent you here, $c.','',26124),
(95244,'enUS','Do you hear? The elements cry out.','',26124),
(95245,'enUS','My people mean you no harm.','',26124),
(95246,'enUS','Rest while you can, hero. I will keep watch.','',26124),
(95247,'enUS','Knights, ATTENTION!','Knights, ATTENTION!',26124),
(95248,'enUS','We\'ve just entered hostile territory. Because of this we will be changing the patrol plan to maintain at least one flight active at all times. I don\'t want any surprises like at the Broken Shore.','',26124),
(95249,'enUS','','What is nature\'s call?',26124),
(95250,'enUS','','Is there trouble?',26124),
(95251,'enUS','','When Nature speaks, we must listen and take action.',26124),
(95252,'enUS','I, Tyr, divine all the power granted to me by the Pantheon onto this paladin.','',26124),
(95253,'enUS','Our foes gather and the edge of oblivion hangs over our heads once again. They would have our world destroyed in a wave of hellfire. This we must not allow!','Our foes gather and the edge of oblivion hangs over our heads once again. They would have our world destroyed in a wave of hellfire. This we must not allow!',26124),
(95254,'enUS','Use my gift wisely, $n. The weapon you now hold is a living bastion of the Light.','',26124),
(95255,'enUS','Go, report to Lady Alistra for your assignments. Suffer well, knights.','Go, report to Lady Alistra for your assignments. Suffer well, knights.',26124),
(95256,'enUS','Suffer well, sir!','Suffer well, sir!',26124),
(95257,'enUS','Commander!','Commander!',26124),
(95259,'enUS','Plundering','Plundering',26124),
(95260,'enUS','|TInterface\\Icons\\inv_misc_boilingblood.blp:20|t %s begins to use |cFFFF0404|Hspell:184357|h[Tainted Blood]|h|r!','',26124),
(95261,'enUS','','%s marks half of her enemies with |cFFFF0404|Hspell:184449|h[Mark of the Necromancer]|h|r!',26124),
(95262,'enUS','','%s summons horrors from the |cFFFF0404|Hspell:184681|h[Darkness]|h|r!',26124),
(95263,'enUS','|TInterface\\Icons\\spell_nature_mirrorimage.blp:20|t %s begins to duplicate into |cFFFF0404|Hspell:183734|h[Mirror Images]|h|r!','',26124),
(95264,'enUS','|TInterface\\Icons\\ability_foundryraid_demolition.blp:20|t %s crashes around using |cFFFF0404|Hspell:184366|h[Demolishing Leap]|h|r!','',26124),
(95269,'enUS','Leave me! My research must continue undisturbed.','',26124),
(95270,'enUS','This new job is m-much better... no m-mistress to boss me around.','',26124),
(95271,'enUS','M-more cleaning to be d-done!','',26124),
(95272,'enUS','Oh, I m-missed a spot...','',26124),
(95273,'enUS','Ah, m-more dirt. It\'s a m-mirror into my soul.','',26124),
(95274,'enUS','The satyrs will pay for this!','The satyrs will pay for this!',26124),
(95275,'enUS','I thought I was done for!','I thought I was done for!',26124),
(95276,'enUS','You have my thanks!','You have my thanks!',26124),
(95277,'enUS','The satyrs... they came out of nowhere!','The satyrs... they came out of nowhere!',26124),
(95278,'enUS','I would be dead were it not for your aid!','I would be dead were it not for your aid!',26124),
(95279,'enUS','Please... Val\'sharah must be saved!','Please... Val\'sharah must be saved!',26124),
(95280,'enUS','That was only the beginning! Line \'em up, boys!','',26124),
(95281,'enUS','I\'m gonna gather the troops! Hold out as long as you can!','',26124),
(95282,'enUS','Another wave incoming!','',26124),
(95283,'enUS','Nice weapon you have there, $c. Speak with Jace and Allari if you\'d like to help.','',26124),
(95284,'enUS','Make ready, hero. We shall soon stand in the presence of the Lord of the Forest.','',26124),
(95285,'enUS','','You have my thanks, stranger. It is good to have found aid in such dire circumstances.',26124),
(95286,'enUS','Nightmane sent me to find you. Can you walk?','Nightmane sent me to find you. Can you walk?',26124),
(95287,'enUS','','',26124),
(95288,'enUS','If you make it past the beast seek Baldir. Through Baldir you may speak with Helira. Goodluck, $c.','',26124),
(95289,'enUS','','You are too late... The Dark Lady is already gone...',26124),
(95290,'enUS','<The small creature shivers in fear. It appears too distraught to speak with you.>','',26124),
(95291,'enUS','Queen Ashildir is on the Eternal Battlefield. I suggest you move quickly before Helira changes her mind.','',26124),
(95292,'enUS','','We\'ll tend to the wounded up here. Go quickly. Wake the Archdruid.',26124),
(95293,'enUS','<The drake fixes you with a serpentine stare.>','',26124),
(95294,'enUS','Advance. Destroy the Illidari. Take Azsuna.','',26124),
(95295,'enUS','We are the LEGION. You cannot prevail.','',26124),
(95296,'enUS','Too late, \"heroes\". Your world is lost.','',26124),
(95297,'enUS','Grovel on your knees. Beg for your lives!','',26124),
(95298,'enUS','You and your world will soon perish.','',26124),
(95299,'enUS','Your titan gods have abandoned you. Lay down your arms. There is no hope left.','',26124),
(95300,'enUS','That weapon will not save you. How can such a tiny thing prevail against the might of the Burning Legion?','',26124),
(95301,'enUS','Salt the earth. Boil their seas. Drive them before you!','',26124),
(95302,'enUS','You should have joined us!','',26124),
(95303,'enUS','Back to the Twisting Nether...','',26124),
(95304,'enUS','The console displays a number 1.','',26124),
(95305,'enUS','Enough, parasites! You deal with me now.','',26124),
(95306,'enUS','I should be on the battlefield with the others.','',26124),
(95307,'enUS','As soon as I get free I\'m going to kill the first kvaldir I see.','',26124),
(95308,'enUS','I am worthy. I know I\'m worthy...','',26124),
(95309,'enUS','Be ready champion, I know not what lies beyond this barrier.','',26124),
(95310,'enUS','Almost there...','',26124),
(95311,'enUS','It is done. Go. Stop Gul\'dan!','',26124),
(95312,'enUS','Guarm senses something.','',26124),
(95313,'enUS','Be blessed, young one.','',26124),
(95314,'enUS','Ashildir is here among us? Soon we will be free.','',26124),
(95315,'enUS','You have brought hope. Helira will not hold me here any longer.','',26124),
(95316,'enUS','Bloodbeard will feel my wrath.','',26124),
(95317,'enUS','My queen has returned. The mystics will pay for their deception.','',26124),
(95318,'enUS','I... I can think clearly again.','',26124),
(95319,'enUS','The goddess Helira has spoken. You will not defeat me.','',26124),
(95320,'enUS','No.... impossible. Helira, spare me!','',26124),
(95321,'enUS','','Bloodbeard you have failed me. Your punishment will be swift.',26124),
(95322,'enUS','','You are free to go champion. Leave now before I change my mind.',26124),
(95323,'enUS','Thank you, traveler. All is not yet lost.','',26124),
(95324,'enUS','Elothir be with you, friend of the grove.','',26124),
(95325,'enUS','Here they come!','',26124),
(95326,'enUS','Destroying this barrier will take a great deal of my strength. I fear I may not be able to aid you after it is broken.','',26124),
(95328,'enUS','Begin the ritual please.','Begin the ritual please.',26124),
(95331,'enUS','','Prepare yourself. Gul\'dan is at his most powerful.',26124),
(95332,'enUS','','In the name of the prophet. In the name of the light. This place shall be cleansed!',26124),
(95333,'enUS','','Ugh...',26124),
(95334,'enUS','','There... Go! Stop Gul\'dan!',26124),
(95335,'enUS','','I... survived the fall.',26124),
(95336,'enUS','','Swiftflight! Where is Swiftflight!?',26124),
(95337,'enUS','Kill!','',26124),
(95338,'enUS','Your soul is complete once more. Helira\'s hold on you is slipping away.','',26124),
(95339,'enUS','Destroy!','',26124),
(95340,'enUS','Smash!','',26124),
(95341,'enUS','Drown!','',26124),
(95342,'enUS','Burn to Ashes!','',26124),
(95343,'enUS','Crushed by earth!','',26124),
(95344,'enUS','None Escape!','',26124),
(95345,'enUS','Destruction!','',26124),
(95346,'enUS','Weak!','',26124),
(95347,'enUS','Break!','',26124),
(95348,'enUS','Shatter!','',26124),
(95349,'enUS','Ruin!','',26124),
(95350,'enUS','Fragile!','',26124),
(95351,'enUS','Broken!','',26124),
(95352,'enUS','I... am... unmade...','',26124),
(95353,'enUS','','Oh no! What did they do to you!?',26124),
(95354,'enUS','A Sargerei Dominator protects Socrethar with |cFFFF0000|Hspell:184053|h[Fel Barrier]|h|r!','A Sargerei Dominator protects Socrethar with |cFFFF0000|Hspell:184053|h[Fel Barrier]|h|r!',26124),
(95359,'enUS','','We are free! Until we meet again, champion.',26124),
(95360,'enUS','Four hours up in the air... It\'s time for a rest.','',26124),
(95361,'enUS','You hit \'em hard, sir!','',26124),
(95362,'enUS','I\'m sure the new pilots coming in will do great!','',26124),
(95363,'enUS','','Legionnaires, move out! Storm those ships and find Sylvanas!',26124),
(95364,'enUS','I only did what I thought was right.','',26124),
(95365,'enUS','If we do not act quickly against the satyrs, the vale will be lost. We have little time...','',26124),
(95366,'enUS','We must fight our way deeper into the corruption if we are to strike at the heart of this threat!','',26124),
(95367,'enUS','The leader of the satyrs was seen near Saberfang Cavern. I shall go on ahead to confront him.','',26124),
(95368,'enUS','When you have completed your mission, meet me at Saberfang Cavern! This corruption ends now!','',26124),
(95369,'enUS','','%s |cFFFF0404|Hspell:184476|h[Reaps]|h|r all marked foes!',26124),
(95370,'enUS','$p, the Skyfire is being overrun. They need you up there!','$p, the Skyfire is being overrun. They need you up there!',26124),
(95371,'enUS','It looks as if woodland sprites have slain this little bear\'s family.$b$bVisibly trembling, the cub looks up at you with desperate eyes.$b$bYou hear rustling in the woods nearby: the forest sprites are coming back.$b$bThe baby bear won\'t survive on its own. Are you willing to rescue it?','',26124),
(95372,'enUS','The power of the totem is mine. You won\'t take it!','',26124),
(95373,'enUS','Faster, swine! Move faster! You serve Sargeras now!','',26124),
(95374,'enUS','Take everything for the Legion! Leave no spoils behind.','',26124),
(95375,'enUS','','I\'ll need some time to look at this, $glad:lass;. I may need to consult with some of my... contemporaries, as well. Come back in a few and I\'ll tell you what I\'ve learned.',26124),
(95376,'enUS','','Glad you made it, champion! Better prepare for a bit of action. The Legion seems to have found a power source located in Un\'Goro. We must stop them!',26124),
(95377,'enUS','','Wait...! Wait for us...',26124),
(95378,'enUS','','They hurt our friend Lixi over there. It\'s time for some payback!',26124),
(95379,'enUS','','Hey, Porsha! Get a move on it, sister!',26124),
(95380,'enUS','You... *cough* filthy swine!','',26124),
(95381,'enUS','','Thank you - all of you. Everyone get ready. This isn\'t going to be easy.',26124),
(95382,'enUS','*cough* You\'re going to pay for that!','',26124),
(95383,'enUS','*cough* Augh my eyes!','',26124),
(95384,'enUS','Augh! It burns!','',26124),
(95385,'enUS','I\'ll save you, poor little thing.','I\'ll save you, poor little thing.',26124),
(95386,'enUS','','Stay close! Here we go!',26124),
(95387,'enUS','I\'ll stab you in the knees!','',26124),
(95388,'enUS','You\'ll be sorry!','',26124),
(95389,'enUS','','',26124),
(95390,'enUS','The bigger you are, the more there is to hurt!','',26124),
(95391,'enUS','We will never yield the wilds!','',26124),
(95392,'enUS','Bears don\'t like you! Why protect them?','',26124),
(95393,'enUS','Only wanted a little fun. This is... no fun...','',26124),
(95394,'enUS','I enjoy watching you squirm. You make a fitting sacrifice.','',26124),
(95395,'enUS','Draenor itself serves the Legion now. See how the elements bend to my will!','',26124),
(95396,'enUS','Cyrukh, what are you doing? Only flesh and blood oppose you!','',26124),
(95397,'enUS','','I see you, $n. What is the plan?',26124),
(95398,'enUS','You kneel down and hold out a hand. The baby bear runs to you and sniffs at your fingers.','',26124),
(95399,'enUS','I\'ll adopt you, little cub.','I\'ll adopt you, little cub.',26124),
(95400,'enUS','Welcome to Ironhorn Enclave.','',26124),
(95401,'enUS','Greetings, miner. Do you seek training?','',26124),
(95402,'enUS','Open your ears, $n.','',26124),
(95403,'enUS','The first ancestor that any of us can remember was Rethu.\n\nRethu Ironhorn was the first of our kind to set hoof on this mountain. He made this plateau his home, and raised his children here. Some say he carved this very camp out of the mountain itself.\n\nHe was a smith, and he was a father, but before any of that... he was a MINER.','',26124),
(95404,'enUS','All stories mention his patience, and most refer to his wisdom. He may have been the greatest miner that our people have ever known, but he was not afraid to share his knowledge with the rest of the herd.\n\nHe trained his sons and daughters, of course, but he also took on apprentices. Greenhoofs who sought direction found themselves ascending Highmountain to learn what he had to teach.\n\nEverything we know, we owe to him.','',26124),
(95405,'enUS','In his youth, he walked the land. He carved out caves and canyons. He spoke to the rocks. Some stories say that this rock-speech was the reason he was ejected from his original tribe.\n\nHis knowledge of leystone was legendary. His time on Azeroth, much like ours, was also plagued with demons, and he worked with ore much like the felslate that you see nowadays.\n\nHe was a pioneer, $n. We all walk in his long shadow.','',26124),
(95406,'enUS','Nobody knows. He left the enclave while they slept, and never returned. Some say he sailed off in search of new challenges. Others say that he dug too deep and uncovered something he should not.\n\nEither way, his legacy lives on, threefold. He left us this land. He left us his knowlege. And he left a lineage - some of us, myself included, bear his surname.','',26124),
(95407,'enUS','Tell me your story.','Tell me your story.',26124),
(95408,'enUS','What was he like?','What was he like?',26124),
(95409,'enUS','Tell me about Rethu\'s mining.','Tell me about Rethu\'s mining.',26124),
(95410,'enUS','What happened to Rethu?','What happened to Rethu?',26124),
(95411,'enUS','I see.','I see.',26124),
(95412,'enUS','Taste the steely justice-blows of my blade!','',26124),
(95413,'enUS','I say! Know you nothing of honor, dragon?','',26124),
(95414,'enUS','Art that the best thou canst do?','',26124),
(95415,'enUS','','Destroying this barrier will take a great deal of my strength. I fear I may not be able to aid you after it is broken.',26124),
(95416,'enUS','Dragons! I\'ll slice off your tails, should I find them!','',26124),
(95417,'enUS','','There are tracks here. Swiftflight must have gone this way!',26124),
(95419,'enUS','Your beloved Swiftflight is dead! You managed to survive the fall, night elf. You will not be so lucky again.','',26124),
(95420,'enUS','','Hero! Avenge Swiftflight!',26124),
(95421,'enUS','I will crush you!','',26124),
(95422,'enUS','Stab it until it\'s dead!','',26124),
(95423,'enUS','The magic is ours, thief!','',26124),
(95424,'enUS','My arrow kill you!','',26124),
(95425,'enUS','I\'ll poke holes in you!','',26124),
(95426,'enUS','I make you bleed!','',26124),
(95427,'enUS','Go away, monster of dreams!','',26124),
(95428,'enUS','You dare disrupt our rituals?','',26124),
(95429,'enUS','Creature of dreams, begone!','Auughh! Creature of dreams, begone!',26124),
(95430,'enUS','The bear cub sits on your foot and looks up at you trustingly.','',26124),
(95431,'enUS','Thanks, boss... but two hundred gold? What a rip-off!','Thanks, boss... but two hundred gold? What a rip-off!',26124),
(95432,'enUS','Yeowch! That\'s gonna leave a mark!','Yeowch! That\'s gonna leave a mark!',26124),
(95433,'enUS','','Thank you, hero. I could not have done this alone.',26124),
(95434,'enUS','What is this magic?! You\'ll pay for this!','',26124),
(95435,'enUS','What?! My Power!','',26124),
(95436,'enUS','Justice has been laid. Heroic deeds of valor, performed. I must now attend to matters of CHIVALRY!','',26124),
(95437,'enUS','A noble hero never forgets what beauty he fights for.','',26124),
(95438,'enUS','Know this, my worship: I nearly died this day. But my mortality was not threatened by any dragon-wound.','',26124),
(95439,'enUS','NAY! I nearly died, amidst that clanging melee, simply from unsatisfied desire!','',26124),
(95440,'enUS','While dragons bled on the ground, my heart bled for thee!','',26124),
(95441,'enUS','Wouldst thou consummate our secret love with a smile, or, perhaps, a wave?','',26124),
(95442,'enUS','The rustling sounds grow louder. The forest sprites are approaching the cave entrance! Prepare for their attack.$b$bThe baby bear looks helpless and frightened.','',26124),
(95443,'enUS','Squires, heroes, and damsels alike! Bring thineselves here, and be protected by me!','',26124),
(95444,'enUS','You mortals dare stand against the might of the Legion?','',26124),
(95445,'enUS','Your time has come - and now it shall end.','',26124),
(95451,'enUS','<The druid speaks softly in his sleep.>$B$BThey will never find my treasure. I have hidden it too well.$B$B<He begins mumbling inaudibly afterwards.>','',26124),
(95452,'enUS','The center control zone is now active!','',26124),
(95453,'enUS','The Alliance captured the center control zone','',26124),
(95454,'enUS','The Horde have captured the center control zone','',26124),
(95456,'enUS','<Gently shake the sleeping druid.>','<Gently shake the sleeping druid.>',26124),
(95457,'enUS','','There\'s a war outside. That means lives to save and money to be made, $n!\n\nWhadda ya say to taking my Nitro-Electric Jumpstarter and helping the Bruisers on the front shake it off? Don\'t forget to leave \'em the bill!',26124),
(95458,'enUS','','They\'re not dead yet, $n. That means they\'re potential customers!\n\nIt\'s simple. You take my Nitro-Electric Jumpstarter and use it on some Bruisers who look a bit worse for wear. Then, they pay me! I\'m gonna be rich!',26124),
(95459,'enUS','I\'ll take a Nitro-Electric Jumpstarter, Nurse.','I\'ll take a Nitro-Electric Jumpstarter, Nurse.',26124),
(95460,'enUS','Champions! You must not let them reach the Caverns!','',26124),
(95461,'enUS','Still holding out hope Hellscream? Your precious Horde will serve the Legion.','',26124),
(95462,'enUS','Prepare yourselves. My powers can only hold them for so long...','',26124),
(95463,'enUS','We... will.. NEVER be slaves!','',26124),
(95464,'enUS','See how they struggle, not even their combined might will be enough to save you.','',26124),
(95465,'enUS','I will have your skull for my helm when I next face your foul legion.','',26124),
(95466,'enUS','No matter, we will crush you all.','',26124),
(95467,'enUS','Heh Heh Heh, they are besting you demon.','',26124),
(95468,'enUS','Finish him heroes, that I may drive that cursed axe down his throat and cut out his fel heart.','',26124),
(95469,'enUS','My thanks to you, now leave me.  I have a trophy to carve.','',26124),
(95470,'enUS','','Even the greatest heroes have tae rest every now and again.',26124),
(95471,'enUS','Show me what goods you have for sale.','Show me what goods you have for sale.',26124),
(95472,'enUS','[Outro cinematic of Skyfire flying away in flames, shaking from explosions.]','[Outro cinematic of Skyfire flying away in flames, shaking from explosions.]',26124),
(95473,'enUS','No one will ever think to look behind the dishes.','',26124),
(95474,'enUS','[Outro cinematic of Skyfire flying away in flames, shaking from explosions.]','[Outro cinematic of Skyfire flying away in flames, shaking from explosions.]',26124),
(95475,'enUS','Fools! You have invoked the wrath of the Forsaken!','',26124),
(95476,'enUS','Burn! Hahaha!','',26124),
(95477,'enUS','<The druid continues to mumble in his sleep, occasionally tossing and turning.>','',26124),
(95478,'enUS','Aspect of Ursol','Aspect of Ursol',26124),
(95479,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ICONS\\ACHIEVEMENT_CHARACTER_ORC_MALE.BLP:40|t[High Overlord Saurfang] Your invasion stops now, demon.','',26124),
(95480,'enUS','|TInterface\\Icons\\spell_shadow_auraofdarkness:20|tYou have |cFFFF0000|Hspell:181099|h[Mark of Doom]|h|r!','',26124),
(95481,'enUS','|TInterface\\Icons\\ability_ironmaidens_convulsiveshadows:20|tYou are afflicted by |cFFFF0000|Hspell:181799|h[Shadowforce]|h|r!','',26124),
(95482,'enUS','|TInterface\\Icons\\ability_ironmaidens_convulsiveshadows:20|t%s begins to cast |cFFFF0000|Hspell:182084|h[Empowered Shadowforce]|h|r!','',26124),
(95483,'enUS','Aspect of Shakama','Aspect of Shakama',26124),
(95484,'enUS','Aspect of the Moon','Aspect of the Moon',26124),
(95485,'enUS','','A valorous sacrifice! But it is not yet your time...',26124),
(95486,'enUS','','Keep your eyes on the skies. The infernals could start falling again at any moment.',26124),
(95487,'enUS','','I will place three shards of felslate into your mining arm: one in your shoulder, one in the elbow, and one in the wrist. Small shards, but jagged shards of stone, nonetheless.$b$bThis may hurt a bit.',26124),
(95488,'enUS','','You handled that well enough.$b$bThe next one goes into your elbow. Are you ready?',26124),
(95489,'enUS','','We are nearly done. As is often the case, three is the magic number. You do not want any less felslate in your body... and you CERTAINLY don\'t want any more.$b$bThe final piece goes directly into your wrist. Ready?',26124),
(95490,'enUS','','Understandable. The risk is high... but if you wish to improve your mining skill, there is no other way.',26124),
(95491,'enUS','','Don\'t waste my time then. Go back to mining leystone.',26124),
(95492,'enUS','','We\'ve nearly finished the procedure, miner. No point in backing out now.',26124),
(95493,'enUS','','We demon hunters toe a dangerous line. Only you can determine where that line lays.',26124),
(95494,'enUS','I am ready. Drive the felslate shard into my shoulder.','I am ready. Drive the felslate shard into my shoulder.',26124),
(95495,'enUS','Actually, I\'m having second thoughts. I don\'t think I want to do this.','Actually, I\'m having second thoughts. I don\'t think I want to do this.',26124),
(95496,'enUS','Yes. Hammer the felslate into my elbow.','Yes. Hammer the felslate into my elbow.',26124),
(95497,'enUS','I don\'t want to do this anymore.','I don\'t want to do this anymore.',26124),
(95498,'enUS','Ready. Imbue my wrist with felslate.','Ready. Imbue my wrist with felslate.',26124),
(95499,'enUS','This is too much. I\'m not a demon hunter like you - I have no tolerance for such demonic augmentation.','This is too much. I\'m not a demon hunter like you - I have no tolerance for such demonic augmentation.',26124),
(95500,'enUS','This is too risky. I am a demon hunter, Nal\'ryssa... I have already demon\'s blood in my veins. I may lose control.','This is too risky. I am a demon hunter, Nal\'ryssa... I have already demon\'s blood in my veins. I may lose control.',26124),
(95501,'enUS','CLUCK! Threat detected! Extermination commencing.','CLUCK! Threat detected! Extermination commencing.',26124),
(95502,'enUS','Hardware overdrive enabled. Frz... gr... malfunction!','Hardware overdrive enabled. Frz... gr... malfunction!',26124),
(95503,'enUS','Engaging. Entity type: Unknown.','Engaging. Entity type: Unknown.',26124),
(95504,'enUS','Ha! This one\'s still got spirit!','',26124),
(95505,'enUS','This one\'s slow! Somebody give me a dagger!','',26124),
(95506,'enUS','You won\'t get rid of me that easily!','',26124),
(95507,'enUS','Come on! You can\'t be that tired!','',26124),
(95508,'enUS','$n prepares a Sugar-Crusted Fish Feast!','$n prepares a Sugar-Crusted Fish Feast!',26124),
(95509,'enUS','$n prepares a Fancy Darkmoon Feast!','$n prepares a Fancy Darkmoon Feast!',26124),
(95510,'enUS','Kraw, my cousin, harbors a thirst for power. Now, the tribe follows him into madness.','',26124),
(95511,'enUS','An Icebound Dreadnought freezes the gun solid!','',26124),
(95512,'enUS','Please find my nephew before he goes mad like the others!','Please find my nephew before he goes mad like the others!',26124),
(95513,'enUS','Rockets, er... transportation systems ready to go!','',26124),
(95514,'enUS','Next victim! Ha! Hey, I\'m only kiddin\'...','',26124),
(95515,'enUS','No sign of Sylvanas here. We\'ll clean this up - find a way over to the next ship!','No sign of Sylvanas here. We\'ll clean this up - find a way over to the next ship!',26124),
(95516,'enUS','We\'ll take it from here. Keep looking for the Windrunner!','We\'ll take it from here. Keep looking for the Windrunner!',26124),
(95517,'enUS','I go to my uncle. Thank you, kind stranger!','',26124),
(95518,'enUS','|TInterface\\Icons\\ACHIEVEMENT_CHARACTER_NIGHTELF_MALE.BLP:50|tWell done, $n. The druids of the claw are on our side, but our work is not yet finished.','',26124),
(95519,'enUS','<The stone emanates demonic energy. Speak the name of its owner, and she will appear.>','<The stone emanates demonic energy. Speak the name of its owner, and she will appear.>',26124),
(95520,'enUS','Rin\'thissa.','Rin\'thissa.',26124),
(95521,'enUS','Lyrelle.','Lyrelle.',26124),
(95522,'enUS','Ondri.','Ondri.',26124),
(95523,'enUS','Can I ask your help, stranger?$B$BMy tribe is the Smolderhide. Recently, my brothers found bad magic. They have gone mad with rage. They attack the druids that are our friends.','',26124),
(95524,'enUS','Thank you for saving my nephew. Hopefully, we can rebuild our village.','',26124),
(95525,'enUS','Parachutes are downstairs, $Gsir:ma\'am;.','Parachutes are downstairs, $Gsir:ma\'am;.',26124),
(95526,'enUS','I thank you, $c. If you had not saved me, I would have lost my mind... like the others.','',26124),
(95527,'enUS','The legionnaires are deploying from the rear deck. They\'ll be glad to fight alongside you!','The legionnaires are deploying from the rear deck. They\'ll be glad to fight alongside you!',26124),
(95528,'enUS','<Deep lacerations cover the arms and face of this druid. Unfortunately, there is nothing more you can do for her.>','<Deep lacerations cover the arms and face of this druid. Unfortunately, there is nothing more you can do for her.>',26124),
(95529,'enUS','May you rest in peace. I will inform the Archdruid that you fought bravely to the end.','May you rest in peace. I will inform the Archdruid that you fought bravely to the end.',26124),
(95530,'enUS','I was overwhelmed by the enemy. I was sure that I would die here... but not without a fight!','',26124),
(95531,'enUS','Nightmane sent me to find you. Are you wounded?','Nightmane sent me to find you. Are you wounded?',26124),
(95532,'enUS','','Tell Nightmane that I still live, thanks to your aid.',26124),
(95533,'enUS','I\'ll return to safety as soon as I recover my strength. Thank you.','',26124),
(95534,'enUS','','My sisters are out there somewhere, $p. They\'re more demon than elf now, but they are still miners. Let me know if you see any sign of them in your travels.',26124),
(95535,'enUS','Applying','Applying',26124),
(95536,'enUS','Interested in building some ships?','',26124),
(95537,'enUS','I would like to build a carrier.','I would like to build a carrier.',26124),
(95538,'enUS','Start construction on our first destroyer.','Start construction on our first destroyer.',26124),
(95539,'enUS','I would like to build a submarine.','I would like to build a submarine.',26124),
(95540,'enUS','','Yes?',26124),
(95541,'enUS','Show me what missions you have prepared.','Show me what missions you have prepared.',26124),
(95542,'enUS','','Let me know when you\'re ready to split up.',26124),
(95543,'enUS','Slay these unholy creatures! For the Alliance!','Slay these unholy creatures! For the Alliance!',26124),
(95544,'enUS','Watch yourselves - that doesn\'t look like Westfall Stew in those cauldrons...','Watch yourselves - that doesn\'t look like Westfall Stew in those cauldrons...',26124),
(95545,'enUS','Royal guards - this is the Windrunner! Seize the captain!','Royal guards - this is the Windrunner! Seize the captain!',26124),
(95546,'enUS','|cFFFF0000%s|r is about to finish casting |cFFFF0000|Hspell:181912|h[Focused Blast]|h|r!','',26124),
(95547,'enUS','','And your ship is already doomed!',26124),
(95548,'enUS','Redeem your darkmoon daggermaw here for fabulous prizes!','Redeem your darkmoon daggermaw here for fabulous prizes!',26124),
(95549,'enUS','Fishing prizes for all ages!','Fishing prizes for all ages!',26124),
(95550,'enUS','Try your rod against the crafty darkmoon daggermaw today!','Try your rod against the crafty darkmoon daggermaw today!',26124),
(95551,'enUS','Fresh-caught prizes right here, only a rod and reel away!','Fresh-caught prizes right here, only a rod and reel away!',26124),
(95552,'enUS','Ahh, Val\'sharah...','',26124),
(95553,'enUS','','Wait! She may have information!',26124),
(95554,'enUS','','So many bats...',26124),
(95555,'enUS','Your pathetic efforts have accomplished nothing, mortals! Our citadels anchor Sargeras to this world. Your end is inevitable!','',26124),
(95556,'enUS','You were always weak, Iroxus! You will be flayed for millennia for failing Sargeras!','',26124),
(95557,'enUS','You dare to resist Sargeras\' will on this pathetic world? I will see to your end myself, mortals!','',26124),
(95558,'enUS','Need equipment for your ship?  I\'m your man!','',26124),
(95559,'enUS','What kind of naval equipment do you have?','What kind of naval equipment do you have?',26124),
(95560,'enUS','Are you sure you want to buy th\'gear I\'ve got for sale? Slugg over there has all th\' latest and greatest.','',26124),
(95561,'enUS','I would like to buy outdated equipment from you.','I would like to buy outdated equipment from you.',26124),
(95562,'enUS','Are you sure you want to buy th\'gear I\'ve got for sale? Crunchpaw has th\' best stuff these days.\n\nB\'tween the two of us, I heard she didn\'t get her nickname from fightin\' the Horde.\n\nDon\'t tell her I said that.\n\nActually, I\'d prefer y\'din\'t even mention that we spoke. I\'m not on her good side right now.','',26124),
(95563,'enUS','Well met.','Well met.',26124),
(95564,'enUS','Legendary: Gul\'dan Ascendant','Legendary: Gul\'dan Ascendant',26124),
(95565,'enUS','','We will find someone with knowledge of the Pillars of Creation. You have my word.',26124),
(95566,'enUS','','You are welcome to what shelter we can provide, $c.',26124),
(95567,'enUS','You should have stayed home!','',26124),
(95568,'enUS','The master will mend my flesh again and again. You have not won. You cannot win. We are endless! We are Legion!','',26124),
(95569,'enUS','Our transport is ready. The invasion of Tanaan can begin.','',26124),
(95570,'enUS','Durotan - are the Frostwolves prepared?','',26124),
(95571,'enUS','Yes. We will assault the main gate while your ships circle around to the eastern shore.','',26124),
(95572,'enUS','We\'re countin\' on you, commander. Bring victory to da Horde!','',26124),
(95573,'enUS','','Durotan and I have spoken. I will accompany your naval assault and protect you while we establish a foothold in Tanaan Jungle.$b$bI am ready. Are you?',26124),
(95574,'enUS','Come now. Tell me you\'re at least considering it.','',26124),
(95575,'enUS','Twenty-seven times in the past two hours. The same talk.','',26124),
(95578,'enUS','Damn it, Doug, look at me. We can\'t stay here!','',26124),
(95579,'enUS','We\'ll hold out if we all do our part. Get back to work.','',26124),
(95580,'enUS','','|cFFFF0000%s|r attempts to remove any harmful effects on herself!',26124),
(95581,'enUS','','I have spoken with the other Exarchs and everything is prepared. I will accompany your naval mission and support you while we establish a rear base. Maladaar has volunteered to lead the diversionary assault at the main gate.$b$bI\'m as ready as I\'ll ever be. Are you?',26124),
(95582,'enUS','Yrel - are your people prepared?','',26124),
(95583,'enUS','','Yes. The draenei will lead an assault on the main gates while your navy circles around to the rear.',26124),
(95584,'enUS','Godspeed, Commander!','',26124),
(95585,'enUS','There\'s a ghost riding a big cat in the ruins.','There\'s a ghost riding a big cat in the ruins.',26124),
(95586,'enUS','','There is an ancient blue dragon just north of here. If anyone will know of the Pillars, it will be him.',26124),
(95587,'enUS','I\'ve been feeling a powerful magical presence in that same direction - it may be the dragon you found. We should investigate at once.','',26124),
(95588,'enUS','I got to visit the coffin maker yesterday. Brilliant!','I got to visit the coffin maker yesterday. Brilliant!',26124),
(95589,'enUS','There were lights in the castle last night. Did you see them?','There were lights in the castle last night. Did you see them?',26124),
(95590,'enUS','Have you seen a dead body? I have.','Have you seen a dead body? I have.',26124),
(95591,'enUS','Da caught a two-headed fish a few days ago. It was all purple and oozy.','Da caught a two-headed fish a few days ago. It was all purple and oozy.',26124),
(95592,'enUS','Sis won\'t take me night fishing anymore. I never get to do anything fun.','Sis won\'t take me night fishing anymore. I never get to do anything fun.',26124),
(95593,'enUS','','Yes, my liege. The camps are being prepared as we speak.',26124),
(95594,'enUS','','You should finish your business with Kayn in the meantime.',26124),
(95595,'enUS','','Our strength is unmatched. These beings have yet to withstand our assaults.',26124),
(95596,'enUS','','Our grasp expands over the lands. The knowledge will soon be ours.',26124),
(95597,'enUS','','A truly delicate planet. The inhabitants are quite... fragile.',26124),
(95598,'enUS','Nathanos\' Rangers launch |TInterface\\Icons\\inv_ammo_arrow_04:20|t |cFFFF0404|Hspell:182466|h[Plague Arrows]|h|r.  Lead Thane Wildsky into them!','Nathanos\' Rangers launch |TInterface\\Icons\\inv_ammo_arrow_04:20|t%s |cFFFF0404|Hspell:182466|h[Plague Arrows]|h|r.  Lead Thane Wildsky into them!',26124),
(95599,'enUS','Move out!','',26124),
(95600,'enUS','Charge!','',26124),
(95601,'enUS','Attack!','',26124),
(95602,'enUS','Ow!','',26124),
(95603,'enUS','Reporting for duty!','',26124),
(95604,'enUS','Ready to go!','',26124),
(95605,'enUS','','Move out!',26124),
(95606,'enUS','','Charge!',26124),
(95607,'enUS','','Attack!',26124),
(95608,'enUS','','Ow!',26124),
(95609,'enUS','','Reporting for duty!',26124),
(95610,'enUS','','Ready to go!',26124),
(95611,'enUS','Ahh! Damn you, demon!','',26124),
(95612,'enUS','Whoever you are, aid me, I beg you!','',26124),
(95613,'enUS','Over here! Please help me!','',26124),
(95614,'enUS','In the name of Elune! Save me!','',26124),
(95615,'enUS','','Main cannons, prepare for a second volley as we breach the cloud-line.',26124),
(95618,'enUS','Ssssmoke won\'t stop me, pitiful creature!','',26124),
(95620,'enUS','Old woman doesssn\'t sssssscare me!','',26124),
(95623,'enUS','Ha! That Granny is blind as a bat!','',26124),
(95624,'enUS','Wassss that ssssupposed to hurt?','',26124),
(95625,'enUS','%s finishes off its victim, then departs in search of fresh prey.','',26124),
(95626,'enUS','I... um... well, this is terribly embarassing, but I\'ve misplaced the Branch of Nordrassil.','I... um... well, this is terribly embarassing, but I\'ve misplaced the Branch of Nordrassil.',26124),
(95627,'enUS','Did that traitor of a prince send you? So be it, I\'ll show no mercy!','',26124),
(95628,'enUS','What... what have I done?','',26124),
(95629,'enUS','%s lunges at new prey.','',26124),
(95630,'enUS','|cFFFF0000%s|r begins to cast |cFFFF0000|Hspell:186045|h[Solar Chakram]|h|r at you!','',26124),
(95631,'enUS','I will restrain my hand against these civilians. They do not know who I am, and I am in no danger from them.','',26124),
(95632,'enUS','I must make them heed my words, not my sword. Novices will often resort to force, but persuasion is a master\'s weapon.','',26124),
(95633,'enUS','|cFFFF0000%s|r is creating an energy well to empower his allies!','',26124),
(95634,'enUS','|cFFFF0000%s|r is being drained of energy!','',26124),
(95635,'enUS','','You\'ve led well so far, $n - I see no reason to change direction now.',26124),
(95636,'enUS','','I\'m off to Dalaran to find paladins worthy of joining our cause. Knights, stay here in case $n needs anything while I\'m gone.',26124),
(95637,'enUS','They should have been here by - ah, there they are.','',26124),
(95638,'enUS','','Elune bless my arrow. Let my aim be true!',26124),
(95639,'enUS','','Invader, this world will not fall to your kind!',26124),
(95640,'enUS','','Interlopers! The kaldorei protect these lands.',26124),
(95641,'enUS','','Countless worlds have you destroyed, but we will not fall so easily.',26124),
(95642,'enUS','','In Azshara\'s name, begone from this place!',26124),
(95643,'enUS','','My blade is sharp, and my arrow, swift. We will not be easy targets.',26124),
(95644,'enUS','Taste steel.','',26124),
(95645,'enUS','No obstacle shall stand in our way.','',26124),
(95646,'enUS','Bandu thoribas!','',26124),
(95647,'enUS','Tor ilisar\'thera\'nal!','',26124),
(95648,'enUS','In the master\'s name!','',26124),
(95649,'enUS','You shall not live to see another moon.','',26124),
(95650,'enUS','','Amelia over there has much bett\'r gear than what I can offer yeh if you\'re lookin\' to take on the Horde.',26124),
(95651,'enUS','','Y\'should speak with Holly McTilla if you\'re lookin\' to square off against the best the Horde has to offer. Also, ask her who does her hair for me would ya?',26124),
(95654,'enUS','Lion\'s Watch','',26124),
(95655,'enUS','Vol\'mar','',26124),
(95656,'enUS','','Ainderu! What do you make of this cloth?',26124),
(95657,'enUS','Looks like night elf cloth to... wait a moment...','',26124),
(95658,'enUS','No... those are ancient Highborne patterns!','',26124),
(95659,'enUS','','Fascinating...',26124),
(95660,'enUS','While the Nightfallen look much like I do, they are craven, twisted ley-addicts who will stab you in the back to get a taste of your mana. I am a friendly tailor who has simply fallen on hard times. Note the difference!','',26124),
(95661,'enUS','We will not stand idle while the Legion threatens our home. Our blades are yours.','',26124),
(95662,'enUS','Come forth, Incindrius! Show these fools the might of the Burning Legion!','',26124),
(95663,'enUS','','We will always answer the Light\'s call. Let us know where we are needed.',26124),
(95664,'enUS','This equipment isn\'t as good as what Fobbly Kickfix sells. I suggest you arm yourself with her wares first.','',26124),
(95665,'enUS','You should speak with Malukah Lightsong if you intend to buy the best equipment available.','',26124),
(95666,'enUS','','Cladd Dawnstrider is the one you seek if you wish to claim the highest quality rewards for your honor in battle.',26124),
(95667,'enUS','','Tae\'lox Soulshrivel is the one you seek if you wish to claim the highest quality rewards for your honor in battle.',26124),
(95668,'enUS','','Yeah yeah, I know, my stuff isn\'t as good as what Tae\'lox is sellin\'. But ya know what, it\'s still prettier, right? Whaddaya mean you think it looks the same? It\'s CLEARLY different! You ungrateful bum! You\'re lucky my contract is still being enforced.',26124),
(95669,'enUS','The quality of my wares is inferior to those sold by Malukah Lightsong. You should talk to her if you intend to take on the Alliance.','',26124),
(95670,'enUS','The quality of my equipment is inferior to that of the lovely Malukah Lightsong. Speak wit her if you intend to buy the best equipment available.','',26124),
(95671,'enUS','I regrettably inform you that the finest arms and armaments for use in the field of battle are now sold by Ms. Crunchpaw. Don\'t worry, I\'m hard at work figuring out how to modify what I do have to be even better. I\'m thinking... extra arms! That you control with your mind!','',26124),
(95672,'enUS','I would like to build a battleship.','I would like to build a battleship.',26124),
(95673,'enUS','I would like to build a transport.','I would like to build a transport.',26124),
(95674,'enUS','','I can\'t believe that peasant Holly McTilla was trusted with the finest weapons and armor. A dwarf! Honestly, it\'s no wonder we haven\'t taken this island yet.',26124),
(95675,'enUS','Woof!','',26124),
(95676,'enUS','Rrrrruff!','',26124),
(95677,'enUS','%s whines piteously.','',26124),
(95678,'enUS','The shipyard is currently full, try back once the current ship completes.','The shipyard is currently full, try back once the current ship completes.',26124),
(95679,'enUS','Let us make haste. We must find the Legion before they strike again.','',26124),
(95680,'enUS','|c00FFFF00|Hspell:186255|h[Event: Apexis Marks]|h|r begins at the Ashran Excavation in 3 minutes.','',26124),
(95681,'enUS','','We should hurry. The Legion could attack at any moment.',26124),
(95682,'enUS','Please, take your time.','',26124),
(95683,'enUS','I\'ll just be waiting here patiently to be summoned to Dalaran.','',26124),
(95684,'enUS','Try not to forget me, or how helpful I was!','',26124),
(95685,'enUS','|c00FFFF00|Hspell:178022|h[Event: Stadium Racing]|h|r has begun at the Amphitheater of Annihilation!','',26124),
(95686,'enUS','|c00FFFF00|Hspell:186255|h[Event: Apexis Marks]|h|r has begun at the Ashran Excavation!','',26124),
(95687,'enUS','|c00FFFF00|Hspell:178019|h[Event: Collect Empowered Ore]|h|r has begun at the Molten Quarry!','',26124),
(95688,'enUS','|c00FFFF00|Hspell:178021|h[Event: Ogre Fires]|h|r has begun at Brute\'s Rise!','',26124),
(95689,'enUS','|c00FFFF00|Hspell:178020|h[Event: Risen Spirits]|h|r has begun at the Ashmaul Burial Grounds!','',26124),
(95690,'enUS','','There\'s no time to waste. Let\'s move!',26124),
(95691,'enUS','I need somebody summoned up to Dalaran. Can you help me?','I need somebody summoned up to Dalaran. Can you help me?',26124),
(95692,'enUS','','A summon? Sure! Where did you say he was?',26124),
(95693,'enUS','','Hold on a sec... there! I\'ve got him!',26124),
(95694,'enUS','$n! Such a pleasure to see you again!','',26124),
(95695,'enUS','So... this is Dalaran.','',26124),
(95696,'enUS','This is a lovely tailoring shop you have here. Do you mind if I look around?','',26124),
(95697,'enUS','','Not at all. Make yourself at home.',26124),
(95698,'enUS','','I\'m sure there is much we can learn from one another.',26124),
(95699,'enUS','Thank you, $n. I need to... acquaint myself with this shop before I can train you any further.','',26124),
(95700,'enUS','','Welcome to Cartier and Company Fine Jewelry, $c. I can tell you\'re a customer with an appreciation for the finer things.$b$bWhat can I show you today?',26124),
(95701,'enUS','Something very expensive, please.','Something very expensive, please.',26124),
(95702,'enUS','I was told you can sharpen these needles for me.','I was told you can sharpen these needles for me.',26124),
(95703,'enUS','','Done! Tell Tanithria that she owes me another silk pillow.',26124),
(95704,'enUS','','Easy enough...',26124),
(95705,'enUS','Careful, $n. Cordana has declared Khadgar\'s tower off-limits. She\'s acting odd.','',26124),
(95706,'enUS','We will send Gul\'dan\'s filth to the bottom of the sea!','',26124),
(95707,'enUS','Farahlon is mysterious land. Only send a crew you trust... or can afford to lose.','',26124),
(95708,'enUS','Aid me, champions! This is not our final hour! We must survive!','',26124),
(95709,'enUS','Never! This world will stand against the legion and prevail!','',26124),
(95710,'enUS','The citadel is breached! Gul\'dan is within. I will establish a foothold here - press forward!','',26124),
(95711,'enUS','We will plumb the depths of Draenor for all its secrets!','',26124),
(95712,'enUS','I never believed Gul\'dan would go this far... We must press on. A portal lies within these ruins that will take us further into the citadel.','',26124),
(95713,'enUS','The portal is ready, champion. Steel yourselves, I know not what further atrocities Gul\'dan has unleashed in this place.','',26124),
(95714,'enUS','This entire citadel seethes with Gul\'dan\'s corruption! A second portal is nearby. Keep his demons at bay while I break the seals and attune the portal to his location.','',26124),
(95715,'enUS','I\'ve breached the first seal, soon the portal will take us to Gul\'dan.','',26124),
(95716,'enUS','Give Cordana my best. She\'s been quite distant lately.','',26124),
(95717,'enUS','Another seal is open! Oh, I am good.','',26124),
(95718,'enUS','The portal is nearly complete, the next seal has been removed.','',26124),
(95719,'enUS','The final seal has fallen! My work here is almost finished.','',26124),
(95720,'enUS','The portal is unlocked! It will take us directly to Gul\'dan. Now he will pay for his crimes.','',26124),
(95721,'enUS','Gul\'dan has fled to the Dark Portal! Quickly, champions! He has no place left to run - we will finish this!','',26124),
(95722,'enUS','And save me his skull. For... reasons.','',26124),
(95723,'enUS','','Books. Yes, Gul\'dan\'s tomes. Are you sure Khadgar didn\'t try to use them?',26124),
(95724,'enUS','','Books of power... books of knowledge... books written in the language of chaos... Don\'t you worry, champion, all will be destroyed.',26124),
(95725,'enUS','','Now, give me your ring. I need it. Give it here!',26124),
(95726,'enUS','That\'ll do for now. I think I\'d like to... explore your city some more.','',26124),
(95727,'enUS','','Then I will TAKE it from you! For the Glory of Gul\'dan!',26124),
(95728,'enUS','','The Orb of Dominion spoke to me. I saw the TRUTH.',26124),
(95729,'enUS','','Khadgar is just a child, swaggering around, torturing his prisoners, playing with lives, dabbling in magics he pretends to comprehend.',26124),
(95730,'enUS','','Such is the power of the Legion!',26124),
(95731,'enUS','','Very well, walk away. Nothing will stop Gul\'dan, for the Legion stands behind him. Mark my words: Your leaders will betray you. AZEROTH WILL BURN.',26124),
(95732,'enUS','The Burning Legion comes!','',26124),
(95733,'enUS','Go now to Karabor, champion of the Alliance!','',26124),
(95734,'enUS','You face the might of the Burning Legion!','',26124),
(95735,'enUS','The elemental spirits of Draenor await you, champion of the Horde!','',26124),
(95736,'enUS','Burn!','',26124),
(95737,'enUS','Your life ends now!','',26124),
(95738,'enUS','Suffer my wrath!','',26124),
(95739,'enUS','My power grows!','',26124),
(95740,'enUS','Feel the legion\'s power!','',26124),
(95741,'enUS','All life will be eradicated!','',26124),
(95742,'enUS','Pathetic wretch!','',26124),
(95743,'enUS','Oblivion... comes...','',26124),
(95744,'enUS','','Welcome, commander! Khadgar tells me you\'ve accomplished so many great things...',26124),
(95745,'enUS','','Take your knee, champion. It is a rare and special privilege to be blessed by a Naaru.',26124),
(95746,'enUS','Blessed are the torchbearers, who bring the light to darkness.','',26124),
(95747,'enUS','Blessed are the valorous, who stand fast in an unjust world.','',26124),
(95748,'enUS','Champion. A great darkness has taken root on Draenor.','',26124),
(95749,'enUS','The righteous will flock to your banner. You must not falter.','',26124),
(95750,'enUS','Go now, with the Light\'s blessing. Take the fight to our enemies.','',26124),
(95751,'enUS','The fate of two worlds hangs in the balance...','',26124),
(95752,'enUS','','Did you hear anything? Did the Naaru speak to you?',26124),
(95753,'enUS','','Commander, whatever you should do next, know that you have the full support of the draenei people.',26124),
(95754,'enUS','','We stand with you!',26124),
(95755,'enUS','Commander, is that you? Your aura has grown quite strong.','',26124),
(95756,'enUS','The very elements of Draenor tremble, friend. Can you hear them? Listen... listen...','',26124),
(95757,'enUS','Spirits of stone, lend your strength to our champion.','',26124),
(95758,'enUS','Spirits of air, grant our champion quickness of mind and body.','',26124),
(95759,'enUS','Spirits of water, give our hero the gift of your wisdom.','',26124),
(95760,'enUS','Spirits of flame, lend us your fury, that our enemies will be driven before us!','',26124),
(95761,'enUS','Arise, champion. Know that the primal heart of Draenor burns within you.','',26124),
(95762,'enUS','Gul\'dan will do all he can to sever our connection to the elements, to deprive us on their power. You must stop him.','',26124),
(95763,'enUS','The fate of our world is in your hands, commander. Lok\'tar ogar.','',26124),
(95764,'enUS','With every passing moment, Gul\'dan grows in power. But he no longer slinks through the shadows - we know where he is. We know what he\'s doing. Now, we strike! May the Light have mercy on all our souls.','',26124),
(95765,'enUS','Did you think to challenge me, infant? A poor decision.','',26124),
(95766,'enUS','','Gryphon riders, back them up!',26124),
(95767,'enUS','','Hero! <cough> Get those chemical flares away from the ammo!',26124),
(95768,'enUS','Accept your death. It is bitter, but preferable to what is coming.','',26124),
(95769,'enUS','The last hero to oppose me lies dead at my feet. Join her.','',26124),
(95770,'enUS','You encroach upon our lands. For that, you shall pay dearly.','',26124),
(95771,'enUS','Mother Moon, have mercy. Let me rest now.','',26124),
(95772,'enUS','You have... won this fight, and yet I... almost pity you.','',26124),
(95773,'enUS','Those damned leyweavers had no right to throw me out. No right at all, I say.','',26124),
(95774,'enUS','Lyndras, what are you doing here?','Lyndras, what are you doing here?',26124),
(95775,'enUS','My lord will hear of this and know... you are... no mere nuisance.','',26124),
(95776,'enUS','I welcome the darkness. I have always... loved... the night.','',26124),
(95777,'enUS','The Ashbringer glows brightly and protects you with |cFFFF0000|Hspell:642|h[Divine Shield]|h|r!','The Ashbringer glows brightly and protects you with |cFFFF0000|Hspell:642|h[Divine Shield]|h|r!',26124),
(95778,'enUS','Err... I was just uh... looking for new dyes. Yes, that\'s it. New dyes. I\'ll return to the shop immediately.','',26124),
(95779,'enUS','Destiny calls to you, $n.','',26124),
(95784,'enUS','I swear, I\'m staying put. No more exploring the city for me. I\'m happy right here in the tailoring shop.','',26124),
(95785,'enUS','I had thought $p dead in the explosion, but $Ghe:she; survived and slew the demon! Never in all my days have I - there you are! I was just telling your men about your fight with Malgalor.','',26124),
(95786,'enUS','Lyndras, please, stop! Get a hold of yourself, man!','Lyndras, please, stop! Get a hold of yourself, man!',26124),
(95787,'enUS','Prove to me that you are worthy of this power! Free my brethren from their ghostly imprisonment, then come to me with their mark upon you.','',26124),
(95788,'enUS','...What are you doing with the Orb of Dominion, Cordana?','...What are you doing with the Orb of Dominion, Cordana?',26124),
(95789,'enUS','Khadgar wants you to destroy these books.','Khadgar wants you to destroy these books.',26124),
(95790,'enUS','','Nothing.$b$bNothing that concerns you.$b$bI have this under control.',26124),
(95791,'enUS','A squire from the Argent Crusade? Here?','',26124),
(95796,'enUS','','Yes, your ring. THE ring! The one Khadgar has been cooking up for you since we arrived on Draenor.$b$bGive it here. I just want to... borrow it.',26124),
(95797,'enUS','No.','No.',26124),
(95798,'enUS','Oh, HELL no!','Oh, HELL no!',26124),
(95799,'enUS','Destroy the Tomes of Chaos to break Cordana\'s shield','Destroy the Tomes of Chaos to break Cordana\'s shield',26124),
(95803,'enUS','','Father, please! Stranger, forgive us. We\'re all a tad wary of strangers these days.',26124),
(95804,'enUS','','Thorns are a means of defense for green and growing things: fragile flora that would otherwise be defenseless.$B$BDo not curse the thorns. Rejoice in the blossoms they make possible.',26124),
(95805,'enUS','','When our hearts falter, we cease to respect the world around us.$B$BNature holds a mirror to our souls.',26124),
(95806,'enUS','Your bones will join the others!','',26124),
(95807,'enUS','Share in our curse!','',26124),
(95808,'enUS','You\'ll never defeat Bloodbeard!','',26124),
(95831,'enUS','We are in luck. Had the Underking learned all of the secrets of the Hammer, we would not be having this conversation.$b$bFor now he is like a child with a new toy. Dangerous, yes, but not as much as he will be the longer he possesses the hammer.','',26124),
(95836,'enUS','Dig faster! We must bury this giant before the other challengers arrive.','',26124),
(95853,'enUS','','As with Moonglade, this village and its denizens are under my protection. I only wish I could shelter more of the wilds and its caretakers.$B$BWould that I were strong enough to protect you all.',26124),
(95854,'enUS','','I have never seen these sprites so agitated.',26124),
(95855,'enUS','What can you tell me about these Thistleleaf sprites?','What can you tell me about these Thistleleaf sprites?',26124),
(95857,'enUS','May Odyn bless you on your trials.','',26124),
(95858,'enUS','','You may take your rest here without fear of nightmares.',26124),
(95859,'enUS','','The Thistleleaf have always been a minor nuisance. However, lately their behavior has changed from puerile to hostile and destructive.$B$BI do not know what has caused this change, but something must be done to protect these faerie dragons.',26124),
(95860,'enUS','Odyn? I kneel before no god.','',26124),
(95861,'enUS','I will do what I can.','I will do what I can.',26124),
(95862,'enUS','Awww man not again.','Awww man not again.',26124),
(95863,'enUS','','Commander, reinforcements are arriving daily. Use this portal to travel between here and our stronghold in Ashran.',26124),
(95864,'enUS','Stay out of Violet Hold if you know what\'s good for you, $r. I don\'t like the look of some of the creatures they\'re storing in there.','',26124),
(95865,'enUS','Have you seen Lyndras?','Have you seen Lyndras?',26124),
(95866,'enUS','Is he that Nightfallen rat? We caught him snooping around the edges of town. Looked suspicious. He\'s been thrown into Violet Hold for questioning.','',26124),
(95867,'enUS','Once I have the Aegis of Aggramar -- the gods will kneel to me.','',26124),
(95868,'enUS','We Elderbranch know little of lands beyond our own.$B$BYou are good to have come here to help us, so far from your home.','',26124),
(95869,'enUS','','Now my warriors! The Halls of Valor are moments away!',26124),
(95871,'enUS','Your lines are weak, mortals. Our ranks are endless! Lay down your arms and serve Sargeras!','',26124),
(95872,'enUS','There is no honor in death! Your cities will burn. Your armies will break. It is inevitable!','',26124),
(95873,'enUS','Into the breach! Show these weaklings what the might of Sargeras does when brought to bear on an enemy!','',26124),
(95874,'enUS','','Go on and run, I won\'t cower under a tent! If the next shot has my name on it, so be it.',26124),
(95875,'enUS','','I know your purpose, Banshee Queen! You should turn away, lest you invoke my wrath!',26124),
(95878,'enUS','','Refuse, and I will take your gifts by force!',26124),
(95879,'enUS','[Intro cinematic of Skyfire unloading a volley on the fleet from above the clouds.]','[Intro cinematic of Skyfire unloading a volley on the fleet from above the clouds.]',26124),
(95880,'enUS','','Foolish girl! You cannot comprehend the forces you meddle with.',26124),
(95881,'enUS','','You will fall to your own arrogance. As did the one who created you.',26124),
(95882,'enUS','You have foolishly rushed to your end. The Black Gate is whole!','',26124),
(95883,'enUS','Behold the might of the legion!','',26124),
(95884,'enUS','Yes, master.','',26124),
(95889,'enUS','','We will seize the Aegis in time - we must not miss this opportunity to take out Sylvanas!',26124),
(95890,'enUS','Gilneas demands justice!','',26124),
(95891,'enUS','','Sylvanas will pay for her crimes...',26124),
(95892,'enUS','Sound design is the best!','Sound design is the best!',26124),
(95893,'enUS','Any luck contacting the fleet?','',26124),
(95894,'enUS','It\'s no use - the weather systems around Stormheim are too strong. I can\'t get a signal through.','',26124),
(95895,'enUS','','It is an honor to fight alongside you, $n. From the moment I first encountered you inside that horrible tunnel behind the Dark Portal, your presence has always inspired me.$b$bK\'ara, too, sees your inner strength. Are you ready to speak with the Naaru?',26124),
(95896,'enUS','I am ready, Yrel.','I am ready, Yrel.',26124),
(95897,'enUS','','You aren\'t supposed to be up here, $n.',26124),
(95898,'enUS','','The others were speaking of |5$r $c that knew how to sew. I assume that you are that $c.$b$bIf Tytallo thinks you\'re ready, then I can show you the Queen\'s Grace Loom.',26124),
(95899,'enUS','','Greetings, $n.',26124),
(95900,'enUS','','Wh- what is this power?! It.. can\'t be...',26124),
(95901,'enUS','Tell me about the loom.','Tell me about the loom.',26124),
(95902,'enUS','','The loom itself, frankly, isn\'t anything special.$b$bIt\'s a thing of beauty, to be sure. It\'s quite old, but at its core it\'s nothing but alderwood and a few nails. We do our best to maintain it.$b$bBut no, the loom itself is immaterial to our methods.',26124),
(95903,'enUS','','How attentive of you. Yes, our order has made a bargain with a higher power, in order to gain more skill in our trade.$b$bI am prepared to show you our secret. Behold, the power of the Leyweavers!',26124),
(95904,'enUS','Tytallo mentioned something about sacrifice.','Tytallo mentioned something about sacrifice.',26124),
(95905,'enUS','Show me your secret.','Show me your secret.',26124),
(95906,'enUS','','I am nothing like him! Behold!',26124),
(95907,'enUS','Work quickly! No relic is to fall into mortal hands!','',26124),
(95908,'enUS','Wrest this world\'s secrets from the earth! The Legion will have every drop of power this place has to offer.','',26124),
(95909,'enUS','','A gift from your sister, Helya. Now... kneel!',26124),
(95910,'enUS','Let\'s go for a joyride!','',26124),
(95917,'enUS','You cursed beasts! After I return to the skies I will have your pathetic races obliterated!','',26124),
(95918,'enUS','Lord Iskar... I\'ve failed you...','',26124),
(95919,'enUS','','We\'ve come to an arrangement with Gul\'dan. We provide him and his forces with supplies, and in return, he\'s granted us a few of his more capable inquisitors.',26124),
(95920,'enUS','','Of course, I\'d prefer that the leyweavers operate without anyone\'s assistance, but the quality of this demonically-imbued cloth far surpasses anything we could do on our own.',26124),
(95921,'enUS','','We\'re tailors, $n, and so are you. No price is too high if it means a better robe. Am I right?',26124),
(95922,'enUS','|TInterface\\Icons\\Spell_DeathKnight_AntiMagicZone:20|tA nearby Dreadstalker begins to cast |cFFF00000|Hspell:186562|h[Consume Magic]|h|r!','|TInterface\\Icons\\Spell_DeathKnight_AntiMagicZone:20|tA nearby Dreadstalker begins to cast |cFFF00000|Hspell:186562|h[Consume Magic]|h|r!',26124),
(95923,'enUS','I have shown you how to make Imbued Silkweave, and I\'ve also given you the pattern for Imbued Silkweave Bracers.','',26124),
(95924,'enUS','Inondra and I can help, but we cannot teach you all the patterns you need. You will need to earn or purchase them from others.','',26124),
(95925,'enUS','','There are many other leyweavers out wandering the world. I can show you where they are.',26124),
(95926,'enUS','MY SHINY EYE! MINE! MINE! MINE! MINE!','',26124),
(95927,'enUS','','What is it you need?',26124),
(95928,'enUS','','Be careful out there!',26124),
(95929,'enUS','Where can I learn how to make an Imbued Silkweave Robe?','Where can I learn how to make an Imbued Silkweave Robe?',26124),
(95930,'enUS','Where can I learn how to make an Imbued Silkweave Hood?','Where can I learn how to make an Imbued Silkweave Hood?',26124),
(95931,'enUS','Where can I learn how to make an Imbued Silkweave Cinch?','Where can I learn how to make an Imbued Silkweave Cinch?',26124),
(95932,'enUS','Where can I learn how to make Imbued Silkweave Slippers?','Where can I learn how to make Imbued Silkweave Slippers?',26124),
(95933,'enUS','Where can I learn how to make Imbued Silkweave Gloves?','Where can I learn how to make Imbued Silkweave Gloves?',26124),
(95934,'enUS','Where can I learn how to make Imbued Silkweave Pantaloons?','Where can I learn how to make Imbued Silkweave Pantaloons?',26124),
(95935,'enUS','Where can I learn how to make Imbued Silkweave Epaulets?','Where can I learn how to make Imbued Silkweave Epaulets?',26124),
(95936,'enUS','Where can I learn how to make Imbued Silkweave cloaks?','Where can I learn how to make Imbued Silkweave cloaks?',26124),
(95937,'enUS','','Leyweaver Mithrogane, just outside this hall, knows that pattern.',26124),
(95938,'enUS','','You should speak with Leyweaver Jorjana, in southern Suramar within the Docks District. I\'ll mark her position on your map.',26124),
(95939,'enUS','','Leyweaver Erenyi. She\'s currently out researching druidic patterns in Val\'sharah. I\'ll mark her position on your map.',26124),
(95940,'enUS','','Speak with Leyweaver Yaphisteia. She walks the roads of Highmountain. I\'ll mark her position on your map.',26124),
(95941,'enUS','','I believe Leyweaver Athystro knows that pattern. You\'ll find him just west of here overlooking Felsoul Hold. I\'ll mark his position on your map.',26124),
(95942,'enUS','','Leyweaver Tellumi, who is currently traveling in Stormheim, maintains that pattern for our guild. I\'ll mark her position on your map.',26124),
(95943,'enUS','','Shoulder armor is the domain of Leyweaver Phaxondus. He prefers to spend his time near the exposed ley lines of Azsuna. I\'ll mark his position on your map.',26124),
(95944,'enUS','','You are in luck. I can teach you those patterns myself.$b$bThey will come at a cost. Our clients are demanding, and our shop consumes a great amount of raw materials.',26124),
(95945,'enUS','OK, how much?','OK, how much?',26124),
(95946,'enUS','','Someday I hope to see this \"Azeroth\" of yours. What an amazing world it must be.',26124),
(95947,'enUS','You are of no interest to me. I come from an accomplished lineage of Suramar tailors. You, obviously, do not.','',26124),
(95948,'enUS','How fortuitous! A fellow tailor!$b$bWelcome to the leyweavers\' guild of Suramar. Perhaps you have heard of us?','',26124),
(95949,'enUS','Hello, leyweaver. What can I do for you?','',26124),
(95950,'enUS','|TInterface\\Icons\\spell_fire_ragnaros_lavaboltgreen.blp:20|t %s has marked you for |cFFF00000|Hspell:182108|h[Artillery]|h|r!','|TInterface\\Icons\\spell_fire_ragnaros_lavaboltgreen.blp:20|t %s has marked you for |cFFF00000|Hspell:182108|h[Artillery]|h|r!',26124),
(95951,'enUS','In-Game Cutscene','',26124),
(95952,'enUS','Stupid dragon! That\'ll cost you.','',26124),
(95953,'enUS','I... will... return...','',26124),
(95954,'enUS','','Is everyone alright?',26124),
(95955,'enUS','Singed, but alive. We lost many good troops.','',26124),
(95956,'enUS','','Steady! Hold this line or Menethil will fall!',26124),
(95957,'enUS','','The front lines are broken! Hold fast, I\'m sure reinforcements are coming!',26124),
(95958,'enUS','','We\'ll have to mourn them later, we need to move before more demons arrive.',26124),
(95959,'enUS','Agreed.','',26124),
(95960,'enUS','Varian\'s forces should have landed just around this hill, let\'s hope they had more luck.','',26124),
(95961,'enUS','','I\'ve never seen the demons expand this quickly.',26124),
(95962,'enUS','Neither have I. Something has changed, this isn\'t the same legion we\'ve fought before.','',26124),
(95963,'enUS','How... quaint.','',26124),
(95964,'enUS','Simple, but it has an antique charm to it.','',26124),
(95965,'enUS','Hey, watch this!','',26124),
(95966,'enUS','I do like a plunging neckline.','',26124),
(95967,'enUS','Your hemming is impressive. This pattern, though... I could take it or leave it.','',26124),
(95968,'enUS','This should be fun!','',26124),
(95969,'enUS','I really enjoy this pattern, $n. It has a classic feel to it, but the embroidery is so intriguing and unique.','',26124),
(95970,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ICONS\\ACHIEVEMENT_BOSS_ILLIDAN.blp:40|t$bYou are the most loyal of all the Illidari. You will be my eyes until this matter is finished.','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ICONS\\ACHIEVEMENT_BOSS_ILLIDAN.blp:40|t$bYou are the most loyal of all the Illidari. You will be my eyes until this matter is finished.',26124),
(95971,'enUS','Let\'s try to catch the wind!','',26124),
(95972,'enUS','Faster! Faster!','',26124),
(95973,'enUS','You\'ll pay for that, dragon!','',26124),
(95974,'enUS','','Oh no...',26124),
(95975,'enUS','Crash landing!','',26124),
(95976,'enUS','There, there, Feronas. The Warglaives of Kil\'Jaeden were created to destroy demons. You never stood a chance.','',26124),
(95977,'enUS','You are but the first to die. The rest your brethren will soon follow. I, Varedis Felsoul, will be your end.','',26124),
(95978,'enUS','Feel my wrath!','',26124),
(95979,'enUS','','Greetings, traveler. Our glade has seen more peaceful times, but the Druids of the Claw offer what protection we can.',26124),
(95980,'enUS','This isn\'t possible. There are so many of them.','',26124),
(95981,'enUS','','The streets of Dalaran are perfectly safe, I assure you. It is hardly surprising that someone might attack one of these... things.',26124),
(95982,'enUS','Ohh! That had to hurt!','',26124),
(95983,'enUS','What a throw!','',26124),
(95984,'enUS','You can\'t escape me!','',26124),
(95990,'enUS','For the Legion!','For the Legion!',26124),
(95992,'enUS','Your bones will break under my boot, $r!','Your bones will break under my boot, $r!',26124),
(95993,'enUS','Demon! Test your might upon me!','',26124),
(95994,'enUS','Long live the Legion! Die you worthless $r!','Long live the Legion! Die you worthless $r!',26124),
(95996,'enUS','Not so mighty now, are we?','',26124),
(96000,'enUS','It is time to put an end to Varedis. I have arranged for a felbat to meet you at Krasus\' Landing to bring you to Felsoul Hold.','It is time to put an end to Varedis. I have arranged for a felbat to meet you at Krasus\' Landing to bring you to Felsoul Hold.',26124),
(96002,'enUS','You are too late! The master\'s plan is already in motion.','',26124),
(96004,'enUS','Yes, yes! I will feed upon your fear, and twist it into a living nightmare!','',26124),
(96010,'enUS','My eyes... My eyes!','',26124),
(96011,'enUS','Hold fast, Alliance! We will not fall this day! Push them back to the portal!','',26124),
(96012,'enUS','Return Mannoroth... Yes, yes! Your masters call you to this world once more!','',26124),
(96013,'enUS','Wha- What is this? Gul\'dan what have you done? I am... So weak...','',26124),
(96014,'enUS','Fear the Legion\'s might!','',26124),
(96015,'enUS','Fear not, Mannoroth. The fel gift empowers you... Make them suffer!','',26124),
(96016,'enUS','My power returns! I am unleashed!','',26124),
(96017,'enUS','Begone!','',26124),
(96018,'enUS','These mortals cannot be this strong. Gul\'dan, do something!','',26124),
(96019,'enUS','Let the power flow through you. You are the destructor, the flayer of flesh!','',26124),
(96020,'enUS','I... AM... UNSTOPPABLE...','',26124),
(96022,'enUS','Faithless fools. The Legion wills it; it will be done.','',26124),
(96023,'enUS','Tremble before the Legion\'s might!','',26124),
(96024,'enUS','You dare challenge the Legion?','',26124),
(96025,'enUS','I will not fall again.','',26124),
(96026,'enUS','Die, mongrels.','',26124),
(96027,'enUS','Die, mongrels.','',26124),
(96028,'enUS','Die, mongrels.','',26124),
(96029,'enUS','Fall to your knees!','',26124),
(96030,'enUS','Fall to your knees!','',26124),
(96031,'enUS','The molten hand of the master will scourge this world clean!','',26124),
(96032,'enUS','The Legion will burn this world, as it has countless others!','',26124),
(96033,'enUS','Your flesh will burn.','',26124),
(96034,'enUS','Your end has come.','',26124),
(96035,'enUS','A worthy effort... but futile.','',26124),
(96036,'enUS','A worthy effort... but futile.','',26124),
(96037,'enUS','A worthy effort... but futile.','',26124),
(96038,'enUS','Squirm... Scream!','',26124),
(96039,'enUS','Squirm... Scream!','',26124),
(96040,'enUS','Squirm... Scream!','',26124),
(96041,'enUS','I am the destructor!','',26124),
(96042,'enUS','I am the destructor!','',26124),
(96043,'enUS','I am the destructor!','',26124),
(96044,'enUS','The Legion will find you... No matter where you flee...','',26124),
(96045,'enUS','None can oppose us!','',26124),
(96046,'enUS','None can oppose us!','',26124),
(96047,'enUS','Your end has come.','',26124),
(96049,'enUS','','Varian!',26124),
(96050,'enUS','Interested in building some ships?','',26124),
(96051,'enUS','','Here, try this pattern out. And use my materials! You\'ll find them lying around the shop.',26124),
(96052,'enUS','','Now that you\'ve gathered the required materials, finish the pattern on my finishing table.',26124),
(96053,'enUS','','What\'s that? What\'s happening with your thread? Why is the robe SMOKING?',26124),
(96054,'enUS','','What a disaster. Look, the thread is just falling right out of the fabric. I\'ve never seen anything like this before.',26124),
(96055,'enUS','','Ready yourself, hero. The creature descends!',26124),
(96056,'enUS','','We did it! The pygmy owls of this grove are safe thanks to you.',26124),
(96057,'enUS','<Ga\'nar\'s spirit - so angry and ferocious in life - has at last found peace. He speaks to you with warmth.>$b$bGive \'em hell, $n.','',26124),
(96058,'enUS','We owe you everything! Surely that last push would have forced us underwater.','',26124),
(96059,'enUS','These chests are full of supplies. You look like you might put them to better use than we will.','',26124),
(96060,'enUS','Help! We\'re going to be pushed back into the sea!','',26124),
(96061,'enUS','Oh thank the Light! We\'ve been holed up here, cut off from Menethil!','',26124),
(96062,'enUS','Here they come again! Steel yourselves! Help us fend them off!','',26124),
(96063,'enUS','No... Not again!','No... Not again!',26124),
(96064,'enUS','They never stop... there are so many of them!','They never stop... there are so many of them!',26124),
(96068,'enUS','Commander. It IS you. Word of your deeds has traveled far and wide. Even the very winds whisper your name.$b$bCome. It is time. As the defender of this world, it is only fitting that Draenor\'s elements bestow their power upon you. Are you ready?','',26124),
(96069,'enUS','<Drek\'Thar bows deeply.>$b$bChampion, remember. Those who live with regrets are slaves to the past. Those who live with hope are ready for the future.','',26124),
(96070,'enUS','I am ready, Farseer.','I am ready, Farseer.',26124),
(96071,'enUS','They are here. Hurry! Gul\'dan demands we finish this...','They are here. Hurry! Gul\'dan demands we finish this...',26124),
(96072,'enUS','Take me to the Tanaan Jungle.','Take me to the Tanaan Jungle.',26124),
(96073,'enUS','Varedis is well guarded. We need to take out the wards projecting that barrier.','',26124),
(96074,'enUS','You\'ve been spotted. Push forward! Quickly!','',26124),
(96075,'enUS','There\'s no time to land. You must dive headlong into the fray. Go!','',26124),
(96076,'enUS','The Aegis of Aggramar belongs to me!','',26124),
(96077,'enUS','You dare disturb me, weaklings? Your feeble minds cannot fathom the power of the Legion!','',26124),
(96078,'enUS','Not... possible...','',26124),
(96079,'enUS','You challenge me? I\'ll crush you like a bug!','',26124),
(96080,'enUS','I will kill... you... ack!','',26124),
(96081,'enUS','','',26124),
(96082,'enUS','You are not the only one seeking the Aegis. I suggest you hurry.','',26124),
(96083,'enUS','','It\'s no use, the ammunition has caught fire! Quickly, up the stairs!',26124),
(96084,'enUS','Allow me to dispose of them, master.','',26124),
(96085,'enUS','','There are demon hunters on my world, doom commander. This is unacceptable.',26124),
(96086,'enUS','Defeat the other challengers and I will consider you for the trials.','',26124),
(96087,'enUS','Bring me the remains of my fallen brother and I will allow you to enter the vault.','',26124),
(96088,'enUS','Odyn, give me strength to do thy bidding.','',26124),
(96089,'enUS','','My spiders will feast upon your marrow.',26124),
(96090,'enUS','|TInterface\\Icons\\achievement_character_human_female.blp:40|tLining up the shot...','',26124),
(96091,'enUS','Ha ha ha... You fight with purpose. That worthless orc would never be accepted among our ranks.','',26124),
(96092,'enUS','You are too late. Soon the Halls of Valor will belong to the Legion.','',26124),
(96093,'enUS','I\'m going to enjoy ridding our new home of your kind.','',26124),
(96094,'enUS','|TInterface\\Icons\\achievement_character_human_female.blp:40|tThis one\'s for Gilneas!','',26124),
(96095,'enUS','|TInterface\\Icons\\achievement_character_human_female.blp:40|tTaking him down...','',26124),
(96096,'enUS','Ahh... much better. Odyn has a plan for you, my friend.','',26124),
(96097,'enUS','Meet me inside the vault. Your trials are about to begin.','',26124),
(96098,'enUS','Get a move on it! I can\'t hold this forever.','Act quickly! This will only hold for a short time!',26124),
(96099,'enUS','Your first trial begins now. Defend yourself!','',26124),
(96100,'enUS','I submit... I can see why Odyn favors you over the God-King. You may continue your trials.','',26124),
(96101,'enUS','I am not your enemy, Mayor. I came here to find someone within Black Rook Hold.','',26124),
(96102,'enUS','Stop with your lies, night elf. You\'ll stay where we can keep an eye on you.','',26124),
(96103,'enUS','<The blades hover before you.>','',26124),
(96106,'enUS','Let\'s go!','',26124),
(96107,'enUS','Genn, Jaina, it\'s good to see you safe.','',26124),
(96108,'enUS','|TInterface\\Icons\\achievement_boss_hellfire_felmagnaron.blp:20|tKormrok |cFFFF0000|Hspell:186882|h[Enrages]|h|r!','',26124),
(96109,'enUS','','Do not let them enter the volcano. The key to the Legion\'s worlds must not fall into their hands, Beliash.',26124),
(96110,'enUS','Y\'know full well you lot should be inside. Come along!','',26124),
(96111,'enUS','Aww...','Aww...',26124),
(96112,'enUS','','This day will be your last!',26124),
(96113,'enUS','Gul\'dan is close! I will send you further into the citadel. We must stop him before this corruption spreads any further.','',26124),
(96114,'enUS','Send me to the Hellfire Antechamber.','Send me to the Hellfire Antechamber.',26124),
(96115,'enUS','Send me to the Court of Blood.','Send me to the Court of Blood.',26124),
(96116,'enUS','Send me to the Nexus of Souls.','Send me to the Nexus of Souls.',26124),
(96117,'enUS','Go on. And this time, stay there.','',26124),
(96118,'enUS','Send me to the Amphitheater of the Eternal.','Send me to the Amphitheater of the Eternal.',26124),
(96119,'enUS','Grownups are so stupid.','Grownups are so stupid.',26124),
(96120,'enUS','Rascals. Don\'t worry: I\'ll keep an eye out for them.','',26124),
(96129,'enUS','You\'re mean!','You\'re mean!',26124),
(96130,'enUS','Yep.','Yep.',26124),
(96131,'enUS','Send me to The Black Gate.','Send me to The Black Gate.',26124),
(96132,'enUS','With your base fully constructed and your army in place, we can finally bring this campaign to a close. All that remains is the fortified bastion of Hellfire Citadel...','',26124),
(96134,'enUS','%s emerges from the shadows!','',26124),
(96135,'enUS','','Now, now. They can\'t help being lively.',26124),
(96136,'enUS','Receiving Blessing','Receiving Blessing',26124),
(96137,'enUS','My blades thirst for Legion blood. Do you know this thirst? Do you desire an end to the legion with every fiber of your being?\n\nDon\'t waste my time, nor yours. Every second the Legion persists is one too many.','',26124),
(96138,'enUS','<Throw the crystals into the pool.>','<Throw the crystals into the pool.>',26124),
(96139,'enUS','|TInterface\\Icons\\spell_fire_ragnaros_molteninferno.blp:20|t$n |cFFFF0000|Hspell:185828|h[Rekindles]|h|r a Fel Scorcher!','|TInterface\\Icons\\spell_fire_ragnaros_molteninferno.blp:20|t$n |cFFFF0000|Hspell:185828|h[Rekindles]|h|r a Fel Scorcher!',26124),
(96140,'enUS','|TInterface\\Icons\\spell_fire_ragnaros_molteninferno.blp:20|t$n |cFFFF0000|Hspell:185835|h[Enkindles]|h|r all nearby Fel Scorchers!','|TInterface\\Icons\\spell_fire_ragnaros_molteninferno.blp:20|t$n |cFFFF0000|Hspell:185835|h[Enkindles]|h|r all nearby Fel Scorchers!',26124),
(96142,'enUS','|TInterface\\Icons\\spell_fire_ragnaros_molteninferno.blp:20|tThe $n |cFFFF0000|Hspell:185824|h[Detonates]|h|r as it dies!','',26124),
(96144,'enUS','I\'m glad that you\'re here, $n.\n\nNow, let\'s be about our business.','',26124),
(96145,'enUS','My eredar are summoning in more demons to attack them from behind, your highness.','',26124),
(96146,'enUS','','Deal with these insects, Beliash.',26124),
(96148,'enUS','What\'s this?!','',26124),
(96149,'enUS','This is a titan construct! It must have been guarding the prize that Sylvanas seeks.','',26124),
(96150,'enUS','It seems that we are again a step behind. We must move quickly!','',26124),
(96151,'enUS','This world is full of kindling... a storm of fire is upon you, mortals!','',26124),
(96152,'enUS','The shadows will envelop you!','',26124),
(96153,'enUS','Behind the veil, all you find is death!','',26124),
(96154,'enUS','[PH] Sylvanas narrowly escapes, leaving you to fight her newest dark Val\'kyr!','',26124),
(96155,'enUS','Now you dwell in darkness.','',26124),
(96156,'enUS','The only truth is your death.','',26124),
(96157,'enUS','Terokk\'s lies are proven false!','',26124),
(96158,'enUS','Curses! The banshee witch escaped! Greymane will not be pleased...','',26124),
(96159,'enUS','And now, the Veil covers all!','',26124),
(96160,'enUS','Let us dispatch of this infernal machine. At least we may be able to prevent Sylvanas from creating a new army of Val\'kyr...','',26124),
(96161,'enUS','[PH] Crowley rigs explosives to the machine.','',26124),
(96162,'enUS','Briefing','Briefing',26124),
(96163,'enUS','I\'ll return to camp. You bring word of our findings to Greymane. Hurry, $c, this place is about to go down on our heads!','',26124),
(96164,'enUS','I took a pretty bad hit up there... my bird\'s still in good shape though. Bag a few Demons for me, eh?','I took a pretty bad hit up there... my bird\'s still in good shape though. Bag a few Demons for me, eh?',26124),
(96166,'enUS','','Got \'em in my sights!',26124),
(96167,'enUS','','I see \'em. Good job with those stun grenades, $Glad:lass;!',26124),
(96168,'enUS','','No way I\'ll miss this shot!',26124),
(96169,'enUS','','Got that one, clear as day.',26124),
(96170,'enUS','','Pow! Right in the kisser!',26124),
(96171,'enUS','','Somebody order a bullseye?',26124),
(96172,'enUS','','Headshot. Easy as pie.',26124),
(96173,'enUS','','Like shootin\' fish in a bloody barrel.',26124),
(96174,'enUS','Do you think you have won? You know nothing!','',26124),
(96175,'enUS','Witness true power!','',26124),
(96176,'enUS','The Veil can not hide my might!','',26124),
(96177,'enUS','Terokk can not protect you!','',26124),
(96178,'enUS','You had better learn to fly!','',26124),
(96179,'enUS','The winds will punish you!','',26124),
(96180,'enUS','It\'s a long way down!','',26124),
(96181,'enUS','','Here, come closer and let me have a good look at you.$B$BAh! A $c, all the way out in these parts? My goodness!',26124),
(96182,'enUS','After years of heroism, your life is snuffed out by a Hellblaze Imp.','',26124),
(96183,'enUS','Your last moments are agony as you fall before the Hellblaze Fiend.','',26124),
(96184,'enUS','','The last thing you see is a Hellblaze Mistress laughing over your corpse.',26124),
(96185,'enUS','We must go to Light\'s Hope Chapel at once. Highlord Fordring deserves to be put to rest amongst the ancient heroes of the Light buried there.','',26124),
(96186,'enUS','','What\'s our status, Orc?',26124),
(96187,'enUS','With his final breath, Khadgar unleashes a mana explosion that decimates everyone.','',26124),
(96188,'enUS','<This is a tub suitable for dyeing fabric.>','',26124),
(96189,'enUS','Fill the tub with amber dye.','Fill the tub with amber dye.',26124),
(96190,'enUS','Dye the silkweave.','Dye the silkweave.',26124),
(96191,'enUS','<This is a tub suitable for dyeing fabric. The pattern you are working on requires a combination of green dye and brimstone shavings.>','',26124),
(96192,'enUS','Fill the tub with green dye and brimstone shavings.','Fill the tub with green dye and brimstone shavings.',26124),
(96193,'enUS','Tanithria at the tailoring shop needs some brimstone shavings for a pattern.','Tanithria at the tailoring shop needs some brimstone shavings for a pattern.',26124),
(96194,'enUS','Brimstone? What could she possibly want THAT for? Gah, tailors. Here you go.','',26124),
(96195,'enUS','','You should start by filling the dyeing tub. Green dye\'s on the shelf, but you\'ll have to get the brimstone shavings from Alard Schmied in the blacksmithing shop.',26124),
(96196,'enUS','That will be all for now. Go on, then.','That will be all for now. Go on, then.',26124),
(96197,'enUS','You will be missed, brother.','',26124),
(96198,'enUS','Highlord Tirion Fordring\'s last light fades.','Highlord Tirion Fordring\'s last light fades.',26124),
(96199,'enUS','Greetings Commander!  We have lots of work to do before we get this shipyard operational!','',26124),
(96200,'enUS','Talk to me about naval missions.','Talk to me about naval missions.',26124),
(96201,'enUS','Controlling our fleet is no easy task, Commander.','',26124),
(96202,'enUS','I almost lost the fight against the fel energy inside me.','',26124),
(96203,'enUS','Over here, Commander!  Let\'s get started on these naval missions!','',26124),
(96205,'enUS','Communing With Ashildir','',26124),
(96206,'enUS','Before you stands a statue depicting the leader of the Shieldmaidens in Skold-Ashil. \n\nHer features look familiar...','',26124),
(96207,'enUS','Attempt to commune with the statue.','Attempt to commune with the statue.',26124),
(96208,'enUS','','',26124),
(96210,'enUS','The power of Xavius is too potent. I do not know what we can do against his Nightmare.','',26124),
(96211,'enUS','The corruption of the Nightmare has seeped into the waters of the river.$B$BStand by, $c. I will call upon the power of Elune and purge this river.','',26124),
(96212,'enUS','I hope this works, druid.','I hope this works, druid.',26124),
(96213,'enUS','Just a few more minutes here...  She will be seaworthy shortly!','',26124),
(96214,'enUS','The Portal Lord collapses, leaving its portal exposed! (Click the portal, glow is broken)','The Portal Lord collapses, leaving its portal exposed! (Click the portal, glow is broken)',26124),
(96215,'enUS','','The Legion is invading the research station! Heroes, rally with me. We must protect the Kirin Tor at all costs! [PH]',26124),
(96216,'enUS','','The Fel Lord has fallen, and the legion has retreated! We have pushed them back for now, but we must stay vigilant. [PH]',26124),
(96217,'enUS','[PH] Ashildir tells you about the Val\'kyr.','',26124),
(96218,'enUS','Penelope? Thank goodness you\'re all right! I was so worried!','',26124),
(96219,'enUS','','Papa, papa, I\'m home! $GMister:Miss; $p saved me!',26124),
(96220,'enUS','We was supposed to be off hours ago... at least we have these brews, eh?','',26124),
(96221,'enUS','A few more o\' these and I might even join this fight.','',26124),
(96222,'enUS','You will interfere no longer, mortals. Surrender the relic, or the Legion will burn you to ash and pluck it from your cinders! [PH]','',26124),
(96223,'enUS','','I do hope they are still alive. It would break the Mayor\'s heart if we couldn\'t find his little girl.',26124),
(96224,'enUS','','Use that flare gun to mark the birds. That\'ll daze \'em long enough for me to take \'em out!',26124),
(96225,'enUS','Cower before the might of the Legion!','Cower before the might of the Legion!',26124),
(96226,'enUS','Our numbers are infinite!','Our numbers are infinite!',26124),
(96227,'enUS','The relic shall be ours!','The relic shall be ours!',26124),
(96228,'enUS','','We can handle the defense of the research station from here. Heroes, close the portals to cut off their line of attack!',26124),
(96229,'enUS','','Face your judgment!',26124),
(96232,'enUS','The Light will never leave your side.','',26124),
(96233,'enUS','','Bask in the glory of the Light.',26124),
(96234,'enUS','We stand united!','',26124),
(96235,'enUS','If it breathes, put it out of its misery.','If it breathes, put it out of its misery.',26124),
(96236,'enUS','These lands will fall to our hand.','These lands will fall to our hand.',26124),
(96237,'enUS','Pathetic! Do these lands offer no challenge?','Pathetic! Do these lands offer no challenge?',26124),
(96238,'enUS','The world crumbles under the Legion!','',26124),
(96239,'enUS','Fragile beings serve no purpose under the Legion!','Fragile beings serve no purpose under the Legion!',26124),
(96240,'enUS','Hope is your only enemy.','Hope is your only enemy.',26124),
(96241,'enUS','No presence is greater, mortals. In time you will see...','No presence is greater, mortals. In time you will see...',26124),
(96242,'enUS','For centuries you have acted as uninvited guests in OUR world.','For centuries you have acted as uninvited guests in OUR world.',26124),
(96243,'enUS','','',26124),
(96244,'enUS','','They come for us! They will not find what they seek...',26124),
(96245,'enUS','','Gurtogg! Dispatch our enemies...',26124),
(96246,'enUS','','The sweet mercy... of death.',26124),
(96247,'enUS','','How it struggles when death is near!',26124),
(96248,'enUS','','It has fallen. It is mine now.',26124),
(96249,'enUS','','They have been marked.',26124),
(96250,'enUS','','They will carry the darkness with them.',26124),
(96251,'enUS','','It rips. It tears. It is boundless and eternal...',26124),
(96252,'enUS','','The void, it hungers!',26124),
(96253,'enUS','','And then the dead shall rise once more.',26124),
(96255,'enUS','','The Alliance will be upon us soon, and we have nowhere to run.',26124),
(96256,'enUS','Iron Horde will CRUSH you!','',26124),
(96257,'enUS','ArRRgghhHhh...','',26124),
(96258,'enUS','ArRRgghhHhh...','',26124),
(96259,'enUS','ArRRgghhHhh...','',26124),
(96260,'enUS','','Do not question me, Nathanos. Now go - make for the Eternity, and bring this hero with you.',26124),
(96261,'enUS','Tell us your plans, imp!','Tell us your plans, imp!',26124),
(96262,'enUS','My Queen, your safety must be our first concern. Surely we can leave a few ships behind to-','',26124),
(96263,'enUS','Yes, of course. Come along... \"hero.\"','',26124),
(96264,'enUS','Me scratch you to bits!','',26124),
(96265,'enUS','','Organize our defenses beginning with the rear. I want bat-riders in the air and catapults at the ready!',26124),
(96266,'enUS','We know you\'re after something. Out with it!','We know you\'re after something. Out with it!',26124),
(96267,'enUS','Yes, Dark Lady.','',26124),
(96268,'enUS','Time to feast!','',26124),
(96269,'enUS','Crush you!','',26124),
(96270,'enUS','Crush you!','',26124),
(96271,'enUS','Drink your blood! Eat your flesh!','',26124),
(96272,'enUS','I\'ll rip the meat from your bones!','',26124),
(96273,'enUS','More! I want MORE!','',26124),
(96274,'enUS','My blade seeks vengeance!','',26124),
(96275,'enUS','To ash...','',26124),
(96276,'enUS','To cinders!','',26124),
(96277,'enUS','I walk in shadow...','',26124),
(96278,'enUS','Burn... BURN!','',26124),
(96279,'enUS','A map of the Broken Isles showing the current status of your forces.','A map of the Broken Isles showing the current status of your forces.',26124),
(96280,'enUS','Investigate the map.','Investigate the map.',26124),
(96281,'enUS','No... The taint of Xavius is too strong.','',26124),
(96282,'enUS','Who are you? Stay back - I will protect the Queen with my last breath!','Who are you? Stay back - I will protect the Queen with my last breath!',26124),
(96283,'enUS','Queen Azshara... betrayed us...','Queen Azshara... betrayed us...',26124),
(96284,'enUS','','I was drawn back to this place, and for a moment I mistook you for the enemy. Be careful, hero. This place reeks of restless spirits.',26124),
(96289,'enUS','Foul demons! You are no match for the Horde!','',26124),
(96290,'enUS','Tirion!','',26124),
(96291,'enUS','Have a go with me mortar. I\'ll spot for ye!','',26124),
(96292,'enUS','Master, I fight in your name!','',26124),
(96293,'enUS','Lord Ravencrest died long ago, but I will always revere him as my mentor.','',26124),
(96294,'enUS','It appears we both have been wandering for quite some time. Would you care for some company?','',26124),
(96295,'enUS','Glad to see you out here, $n. Care for a lift?','',26124),
(96296,'enUS','These are not parts one should wander alone, $n. Allow me to offer you safe travel.','',26124),
(96297,'enUS','','Lord Ravencrest appointed me as Queen Azshara\'s personal guard.',26124),
(96298,'enUS','','The tower beckons, but I fear its call. Hurry, free us before it\'s too late!',26124),
(96299,'enUS','[WALKS FORWARD.] Wait, what is this? His tomb has been disturbed! His ashes are gone!','',26124),
(96300,'enUS','Greetings, and thank you for helping to test patch 6.2!\n\nI can teleport you directly into Hellfire Citadel or Tanaan Jungle. This is just a teleport, not a match-making service, so I hope you have a party ready to tackle the challenges waiting inside. If not, you might want to check out our new Group Finder feature to find some allies.\n\nMake sure you have selected the difficulty you want to test before teleporting, since you may not be able to zone out easily if you need to change the difficulty setting!','',26124),
(96301,'enUS','I want to go to Hellfire Citadel (Raid).','I want to go to Hellfire Citadel (Raid).',26124),
(96302,'enUS','I want to go to Tanaan Jungle.','I want to go to Tanaan Jungle.',26124),
(96303,'enUS','','Entrap them, my children.',26124),
(96304,'enUS','Activate all three gateways and summon in the rest of our forces.','',26124),
(96305,'enUS','','Kill them all!',26124),
(96306,'enUS','','Follow me, Highlord. You\'ll use the command map from now on to delegate your forces.',26124),
(96307,'enUS','','Yes? How might I help you, $n?',26124),
(96308,'enUS','The Ashbringer... it\'s been a long time since I\'ve seen that blade. You\'re doing the Light\'s work defending our world, $n.','',26124),
(96309,'enUS','These lands are covered with shrines of power that can make the Ashbringer even more powerful. Seek them out on your travels and you will truly become a force to be reckoned with.','',26124),
(96310,'enUS','Walk always with the Light, Highlord, and it will never forsake you. Take my blessing, and you will never truly stand alone. Farewell.','',26124),
(96311,'enUS','How DARE you enter MY sanctuary! You\'ll deal with me now!','How DARE you enter MY sanctuary! You\'ll deal with me now!',26124),
(96312,'enUS','Insolence! The Legion won\'t stand for this!','Insolence! The Legion won\'t stand for this!',26124),
(96313,'enUS','Begone, pests! It is time you met your end!','Begone, pests! It is time you met your end!',26124),
(96314,'enUS','','Greetings keeper of the <artifact>. I speak for the Skyhorn Tribe.$b$b',26124),
(96315,'enUS','Will the Skyhorn join with Mayla Highmountain?','Will the Skyhorn join with Mayla Highmountain?',26124),
(96316,'enUS','It\'s time we reclaim our lands!','It\'s time we reclaim our lands!',26124),
(96317,'enUS','Thanks to the failure of Highmountain, the harpies have become emboldened and assault my people. The Skyhorn cannot fight a battle on two fronts.','',26124),
(96318,'enUS','Their shields are too strong! Protectors, at your will!','Their shields are too strong! Protectors, at your will!',26124),
(96319,'enUS','So you are the one who carries <artifact>. I thought you would be taller.$b$bYou stand before Speaker Ragebull.$b$bI am the voice for the great Bloodtotem Tribe, strength of the earth and the most powerful warriors Highmountain has ever known.','',26124),
(96320,'enUS','Will the Bloodtotem join with Mayla Highmountain?','Will the Bloodtotem join with Mayla Highmountain?',26124),
(96321,'enUS','Ha! Highmountain cannot even defend its own chieftain and you would have us join with them? The Bloodtotem honor strength, not victims.','',26124),
(96322,'enUS','The bearer of <artifact>? This is a great honor.$b$bI speak for the Whitewater Tribe.','',26124),
(96323,'enUS','Will the Rivermane join with Mayla Highmountain?','Will the Rivermane join with Mayla Highmountain?',26124),
(96325,'enUS','','It is with a heavy heart I must decline. The drogbar assault my lands. I am here to ask for aid and yet Mayla has none to give.',26124),
(96334,'enUS','$r creaks and moans, gathering its strength as it prepares for battle.','',26124),
(96335,'enUS','%s picks up the Wraith Zapper and checks its energy reserves. Good to go!','',26124),
(96336,'enUS','','Well done, hero. Now let us regroup before our enemy is able to.',26124),
(96337,'enUS','<Apparently this brave soul perished moments after trapping something dangerous.>$B$B<Her gun lies nearby. Dare you pick it up and investigate further?>','',26124),
(96338,'enUS','These birds are comin\' from Black Rook Hold. Fourth one I\'ve shot today.','',26124),
(96339,'enUS','','What manner of beast IS this?',26124),
(96340,'enUS','Sentinels, let\'s give them cover!','Sentinels, let\'s give them cover!',26124),
(96342,'enUS','','Windgore! Attack this infidel!',26124),
(96344,'enUS','I want these tauren off my mountain.','',26124),
(96351,'enUS','Just inspect the anvil when yer ready to peruse yer options. Take yer time, it\'s nae a decision to rush through!','',26124),
(96353,'enUS','','You know, they used to call me \"Mean Marlene.\" I could shoot the head off a nail at hundred paces.',26124),
(96355,'enUS','My daughter is everything to me. I can\'t thank you enough for bringing her home, safe.','',26124),
(96356,'enUS','Sharpen your blades, warriors! No demon shall pass through our gates.','',26124),
(96357,'enUS','The master commands us...','',26124),
(96358,'enUS','Go to your grave!','',26124),
(96359,'enUS','Join us in eternity...','',26124),
(96360,'enUS','The Hold shall not fall...','',26124),
(96361,'enUS','Dang it! Jammed again.','',26124),
(96362,'enUS','Demons won\'t even see it coming!','',26124),
(96363,'enUS','Right between the eyes.','',26124),
(96364,'enUS','Did you think to reclaim this land? What we take, we shall keep.','',26124),
(96365,'enUS','Excellent choice, if I do say so myself. We\'ll need a much stronger anvil to upgrade the blade further, but I\'ll find one. You have my word!','',26124),
(96366,'enUS','Demons... hah! Demons don\'t scare me!','',26124),
(96367,'enUS','I may be small, but I ain\'t scared of nothin\'!','',26124),
(96368,'enUS','Come and get some, demons!','',26124),
(96369,'enUS','You discard the Wraith Zapper as you leave the hilltop.','',26124),
(96370,'enUS','It\'s pretty bad up here over the Hill! I\'ll hold the skies as long as I can.','',26124),
(96371,'enUS','Don\'t worry friends. I\'ve got the skies over Sentinel Hill covered!','',26124),
(96372,'enUS','Sorry, demons! The skies over Sentinel Hill belong to us!','',26124),
(96373,'enUS','You dare challenge me?','',26124),
(96374,'enUS','The skies above Sentinel Hill seem to be thinning out. I\'ll continue my patrols until we\'re sure it\'s safe!','',26124),
(96375,'enUS','It appears to be over, friends! I\'ll keep watch over the Hill a while longer.','',26124),
(96377,'enUS','Don\'t blink when you shoot!','',26124),
(96378,'enUS','','Our battle against the harpies is ongoing, but your actions have helped restore some balance to the basin. \n\nWith Morashu\'s spirit reborn, he will once again be able to guide other animals back to nature.',26124),
(96379,'enUS','Behold, the hilt of Frostmourne. From its broken form you will create a blade without equal! Approach and channel your power into it to create your weapon.','',26124),
(96380,'enUS','Good.','',26124),
(96381,'enUS','Excellent shot!','',26124),
(96382,'enUS','To arms, men!','',26124),
(96383,'enUS','Move into positions!','',26124),
(96385,'enUS','Heard any pet battle news out of Tanaan Jungle?','Heard any pet battle news out of Tanaan Jungle?',26124),
(96386,'enUS','','I\'ve heard rumors of no less than 15 very powerful pets, corrupted by the fel energies unleashed by Gul\'dan. Find and defeat them and you\'ll surely find some rewards of value!',26124),
(96390,'enUS','Please... the others! We were separated... you have to save them!','Please... the others! We were separated... you have to save them!',26124),
(96391,'enUS','Oh thank you. Thank you, hero!','Oh thank you. Thank you, hero!',26124),
(96392,'enUS','Why is this happening to us? What are these things?','Why is this happening to us? What are these things?',26124),
(96393,'enUS','Stay calm, everyone. Reinforcements are here. We will protect you!','',26124),
(96394,'enUS','We won\'t let them through! You\'re safe, so long as you stay here!','',26124),
(96395,'enUS','We don\'t feel safe! What\'s going on out there?','We don\'t feel safe! What\'s going on out there?',26124),
(96397,'enUS','Everything gone... just like that. How can you hope to stop them?','Everything gone... just like that. How can you hope to stop them?',26124),
(96400,'enUS','Is that help I hear? Inside, please hurry!','',26124),
(96401,'enUS','So weak. So delicious! Me feed!','',26124),
(96402,'enUS','Oh thank the Light! Please, you must stay here to protect us!','',26124),
(96403,'enUS','','Father, look out!',26124),
(96404,'enUS','','I will join you. Let\'s kill some more demons.',26124),
(96405,'enUS','','I... will not... give in!',26124),
(96406,'enUS','Enough! I will reap your souls myself!','',26124),
(96407,'enUS','So weak... hard to contain... my energy.','',26124),
(96408,'enUS','<The construct sits motionless on the ground.>','',26124),
(96409,'enUS','<Insert 1000 Apexis Crystals.>','<Insert 1000 Apexis Crystals.>',26124),
(96410,'enUS','Repairing the construct will cost 1000 Apexis Crystals. Are you sure?','',26124),
(96411,'enUS','I will destroy all of you.','',26124),
(96412,'enUS','Lemme hear your bones crunch!','',26124),
(96413,'enUS','We\'re takin\' the mountain!','',26124),
(96414,'enUS','Gonna enjoy guttin\' you!','',26124),
(96415,'enUS','','The pain!',26124),
(96416,'enUS','These are drogbar rocks! Drogbar stones!','',26124),
(96418,'enUS','It appears to be in working order. Why don\'t you take a look and see what it can do?','',26124),
(96419,'enUS','','Help has arrived at last! Elune be praised!',26124),
(96420,'enUS','Tremble beneath the might of the Burning Legion!','',26124),
(96421,'enUS','Enjoy this moment, mortals... It shall be your last!','',26124),
(96422,'enUS','At long last... destruction has come to this pathetic world!','',26124),
(96423,'enUS','Yes... struggle... your meager attempts to survive amuse me!','',26124),
(96424,'enUS','None shall awake from the Nightmare!','',26124),
(96425,'enUS','Rend the flesh from their bones... and drain the life from their mortal bodies!','',26124),
(96426,'enUS','Pray to your pathetic goddess... let her listen to your cries of agony!','',26124),
(96427,'enUS','Shaladrassil... it cannot... it must not be true!','',26124),
(96428,'enUS','I sense greater power within you, $n. Have you stolen a demon\'s essence?','',26124),
(96429,'enUS','I would have perished without your aid!','I would have perished without your aid!',26124),
(96430,'enUS','I\'m ready.','I\'m ready.',26124),
(96431,'enUS','It\'s as if the forest itself has risen against us...','It\'s as if the forest itself has risen against us...',26124),
(96432,'enUS','You have my thanks!','You have my thanks!',26124),
(96433,'enUS','I will defend this forest to my dying breath!','I will defend this forest to my dying breath!',26124),
(96434,'enUS','Hope is lost... but I will fight on!','Hope is lost... but I will fight on!',26124),
(96435,'enUS','|TInterface\\Icons\\spell_fire_rune.blp:20|tThe |cFFFF0000|Hspell:187658|h[Empowered Explosive Rune]|h|r detonates one last time.','',26124),
(96436,'enUS','Thank you!','Thank you!',26124),
(96437,'enUS','How kind of you.','How kind of you.',26124),
(96438,'enUS','Most appreciated.','Most appreciated.',26124),
(96439,'enUS','I hope to someday repay the favor!','I hope to someday repay the favor!',26124),
(96440,'enUS','You\'ve been a great help, $n. Thank you.','You\'ve been a great help, $n. Thank you.',26124),
(96441,'enUS','','$n, over here.',26124),
(96442,'enUS','Beware, brothers! We are discovered!','',26124),
(96443,'enUS','I\'ll handle this interference personally.','',26124),
(96444,'enUS','This... means nothing. You... are... nothing.','',26124),
(96445,'enUS','We shall rise again... more numberless than the stars.','',26124),
(96446,'enUS','You fight for a world... that is... already lost.','',26124),
(96447,'enUS','The Nightmare is no mere illusion. It was born... from your darkest... truths.','',26124),
(96448,'enUS','Cowards and weaklings! You deserve to burn!','',26124),
(96449,'enUS','This ends now!','',26124),
(96450,'enUS','','No!',26124),
(96451,'enUS','Eek! They take candle!','',26124),
(96452,'enUS','Is my candle! Why take?','',26124),
(96453,'enUS','Keep calm, fools! Finish defiling the shrine!','',26124),
(96454,'enUS','Taking','Taking',26124),
(96455,'enUS','Shhh... Quit tryin\' ta attract \'em ta me!','',26124),
(96456,'enUS','Find yer own hidin\' spot!','',26124),
(96457,'enUS','Come and get me when it\'s o\'er!','',26124),
(96458,'enUS','Quit makin\' all that racket! You\'ll draw their attention!','',26124),
(96459,'enUS','Spots claimed! Now if ya don\' mind... tryin\' ta keep me location a secret!','',26124),
(96460,'enUS','It burns!','',26124),
(96461,'enUS','Noooo!!','',26124),
(96462,'enUS','Finally, flesh worthy of my pyre!','',26124),
(96463,'enUS','Protocol: Soul Harvest is active!','',26124),
(96464,'enUS','Soul detected. Reaping in progress.','',26124),
(96465,'enUS','Harvesting... unsuccessful.','',26124),
(96466,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-King Ymiron.blp:50:80|t$bAre you strong enough to wield Magnar Icebreaker\'s weapons? We shall see...','',26124),
(96467,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-King Ymiron.blp:50:80|t$bFinally someone worthy of Magnar Icebreaker\'s legacy.$bIf you would claim his legendary weapons, follow... and survive...','',26124),
(96468,'enUS','A 7th Legion Battlemage freezes the catapult solid!','A 7th Legion Battlemage freezes the catapult solid!',26124),
(96469,'enUS','You do not look well, $n... are you alright?','',26124),
(96470,'enUS','$n, my thanks for coming..','',26124),
(96471,'enUS','|TInterface\\Icons\\spell_shadow_auraofdarkness:20|t%s begins to cast |cFFFF0000|Hspell:187466|h[Supreme Doom]|h|r!','',26124),
(96472,'enUS','It is very good to see you, $n.','',26124),
(96473,'enUS','I\'m ready to go to Magnar\'s island.','I\'m ready to go to Magnar\'s island.',26124),
(96474,'enUS','DO NOT TRANSLATE','',26124),
(96475,'enUS','DO NOT TRANSLATE','',26124),
(96476,'enUS','DO NOT TRANSLATE','',26124),
(96477,'enUS','DO NOT TRANSLATE','',26124),
(96478,'enUS','DO NOT TRANSLATE','',26124),
(96479,'enUS','|TInterface\\Icons\\spell_nature_astralrecalgroup:20|t%s casts |cFFFF0000|Hspell:187702|h[Twisted Reflection]|h|r!','',26124),
(96480,'enUS','Finally we get some help around here. That is, if you\'re willing to put aside past differences, for now.','',26124),
(96481,'enUS','Let\'s team up. If we fight, we only help the demons.','Let\'s team up. If we fight, we only help the demons.',26124),
(96482,'enUS','I don\'t work with murderers. The Defias are never to be trusted!','I don\'t work with murderers. The Defias are never to be trusted!',26124),
(96483,'enUS','You high and mighty types are worse than demons!','',26124),
(96484,'enUS','Now... who is the murderer?','',26124),
(96485,'enUS','','What is this? The hero of Helheim seeks entrance to the vault?',26124),
(96486,'enUS','','I know your worth. I will grant you an audience with Eyir.',26124),
(96487,'enUS','','You may proceed, but know that Eyir may not regard you as I do.',26124),
(96488,'enUS','','Seek your fate in the vault, $n. May Eyir be your wings.',26124),
(96489,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ICONS\\Ability_Warlock_EmpoweredImp.blp:50:80|tI smell power behind this door! Let\'s dig it up!','',26124),
(96490,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ICONS\\Ability_Warlock_EmpoweredImp.blp:50:80|tOuch ouch! I must get help!','',26124),
(96491,'enUS','Ladies and gentlemen, please! Please! We are doing all we can to address the situation.','Ladies and gentlemen, please! Please! We are doing all we can to address the situation.',26124),
(96492,'enUS','Rest assured, Sentinel Hill is well protected!','Rest assured, Sentinel Hill is well protected!',26124),
(96493,'enUS','The Legion will not penetrate our defenses. I assure you!','The Legion will not penetrate our defenses. I assure you!',26124),
(96494,'enUS','Please, listen a moment. We are forcing them back as we speak!','Please, listen a moment. We are forcing them back as we speak!',26124),
(96495,'enUS','Ladies and gentlemen, we are safe and secure within the walls. There is no need for panic.','Ladies and gentlemen, we are safe and secure within the walls. There is no need for panic.',26124),
(96498,'enUS','DO NOT TRANSLATE','',26124),
(96499,'enUS','The bold fools are boarding my ship. Come on!','',26124),
(96500,'enUS','Transport','',26124),
(96501,'enUS','Carrier','',26124),
(96502,'enUS','Destroyer','',26124),
(96503,'enUS','','You defile these grounds!',26124),
(96504,'enUS','','Eyir take you!',26124),
(96505,'enUS','','Eyir, guide my spear!',26124),
(96506,'enUS','','You are not worthy of ascension!',26124),
(96507,'enUS','','My shield will not falter!',26124),
(96508,'enUS','','You are but another test!',26124),
(96509,'enUS','','Sisters, to battle!',26124),
(96510,'enUS','','Eyir, be my wings...',26124),
(96511,'enUS','','The Halls of Valor await...',26124),
(96512,'enUS','','It was... a glorious death...',26124),
(96513,'enUS','','My shield remains... unbroken...',26124),
(96515,'enUS','','The battle is upon us, sisters!',26124),
(96516,'enUS','','Protect the temple!',26124),
(96517,'enUS','','Break upon my shield!',26124),
(96518,'enUS','','The temple must not fall...',26124),
(96519,'enUS','','Eyir... I have failed...',26124),
(96521,'enUS','Battleship','',26124),
(96522,'enUS','Submarine','',26124),
(96523,'enUS','We must take the fight to them. But it would be rude to show up without a gift... The apothecaries will have just what we need.','',26124),
(96525,'enUS','Transport','',26124),
(96526,'enUS','Submarine','',26124),
(96527,'enUS','Battleship','',26124),
(96528,'enUS','Destroyer','',26124),
(96529,'enUS','Carrier','',26124),
(96533,'enUS','It is time to pass my legacy on to someone powerful enough to wield them. Survive my trial and you will be given the strongest sword and shield this world has ever seen...','',26124),
(96535,'enUS','What are the Armaments of the Black Wyrm?','What are the Armaments of the Black Wyrm?',26124),
(96537,'enUS','Do you know of the Earthwarder, Neltharion? He was a glorious beast before he... fell. He was invulnerable to all but the gods in that age. Magnar worshipped him in his youth.\n\nEven though he was a venerated warrior Magnar wanted to be like him, invulnerable. His plan was arrogant. He would storm the nest of Neltharion himself and take something from his legendary hoard.\n\nMagnar and his warband fought Neltharion\'s younglings in a fierce battle. They had just made the nest when the dragon returned. With one breath he wiped away entire force. Magnar grabbed one of his cast off scales, used it to shield himself, and was blown down the mountain.','',26124),
(96538,'enUS','So he left with nothing but a scale?','So he left with nothing but a scale?',26124),
(96539,'enUS','Nothing but a scale? Hah! A scale from the most hard to kill dragon in the world!\n\nMagnar realized what he had and spent years learning the forge under masters both titanforged and vrykul. When he was finally skilled enough, he crafted from the scale a shield and sword that have never seen an equal. Those are the Armaments of the Black Wyrm. In the right hands they project the strength and invulnerability of the Earthwarder himself.\n\nTo this day I am still unsure if he was lucky to survive that encounter or if the Black Wyrm judged him worthy enough to live.','',26124),
(96541,'enUS','Xhul\'horac targets you with |cFFFF0000|Hspell:186407|h[Fel Surge]|h|r!','Xhul\'horac targets you with |cFFFF0000|Hspell:186407|h[Fel Surge]|h|r!',26124),
(96542,'enUS','Filthy worgen... A beast in a hat is still a beast.','',26124),
(96543,'enUS','Dread-Riders, grab as many vials as you can carry and form up on me! We are bringing down that gunship.','',26124),
(96546,'enUS','','I\'ve heard rumors of no less than 15 very powerful pets, corrupted by the fel energies unleashed by Gul\'dan. Find and defeat them and you\'ll surely find some rewards of value!',26124),
(96547,'enUS','Heard any pet battle news out of Tanaan Jungle?','Heard any pet battle news out of Tanaan Jungle?',26124),
(96550,'enUS','I am ready to begin the trial.','I am ready to begin the trial.',26124),
(96551,'enUS','That was an exhilarating kill, one that will make a fine chapter in my next novel.','',26124),
(96552,'enUS','Xhul\'horac targets you with |cFFFF0000|Hspell:186333|h[Void Surge]|h|r!','Xhul\'horac targets you with |cFFFF0000|Hspell:186333|h[Void Surge]|h|r!',26124),
(96553,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-King Ymiron.blp:50:80|t$bYou are the one, bring them glory and they will bring glory to you. I will finally take my place in the Halls of Valor, where the brave may fight forever.','',26124),
(96554,'enUS','New directives: Serve Legion. Destroy property.','',26124),
(96555,'enUS','Slash. Burn. Harvest!','',26124),
(96556,'enUS','A |cFFFF0000|Hspell:186407|h[Shadowfel Annihilation]|h|r detonates on $n!','A |cFFFF0000|Hspell:186407|h[Shadowfel Annihilation]|h|r detonates on $n!',26124),
(96558,'enUS','','I may carry a book instead of a rifle, but I assure you $n, I\'m a hunter at heart.',26124),
(96559,'enUS','<Despite a heavy cloth across his eyes, the wizened seer gazes up at the skies with a contemplative look.>$B$BThe stars shape our destinies, child, granting their blessing to the worthy and shunning the weak.','',26124),
(96560,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] Do not hold back, $n. Show him your wrath.','',26124),
(96561,'enUS','Darksorrow and Ravencrest will have the honor of accompanying you into Suramar, $p. A small force will have the best chance of flying undetected into the hold.','',26124),
(96562,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ICONS\\Warlock_Summon_DoomGuard.blp:50:80|t$bI am here Pillik! What insect scared you off?!? Come out of there insect or I will bring everything down upon you!','',26124),
(96563,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ICONS\\Warlock_Summon_DoomGuard.blp:50:80|t$bWe didn\'t kill all of you at the Broken Shore? I shall correct that mistake now!','',26124),
(96564,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-ARCHIMONDEWOD.blp:50:80|t$B[Taldath the Destroyer] Insolent whelps! Release me now and I may yet spare you.','',26124),
(96565,'enUS','FOOL! You dare face me alone?!','',26124),
(96566,'enUS','Varedis will hunt down every one of your disgusting ilk. Pity you won\'t be around to witness it.','',26124),
(96567,'enUS','The Twinblades... will be your end...','',26124),
(96568,'enUS','Vermin! My lord wields power beyond your comprehension! He will end you!','',26124),
(96569,'enUS','The smallest touch adds a just enough.','',26124),
(96570,'enUS','Ingredients as far as the eye can see...','',26124),
(96571,'enUS','Elixirs require such a delicate touch.','',26124),
(96572,'enUS','Potions by day. Potions by night.','',26124),
(96573,'enUS','A touch of this for ailments... or double for a more... sinister use, perhaps.','',26124),
(96574,'enUS','Mmm... such a pleasant aroma.','',26124),
(96575,'enUS','Hold your ground! Show them we will not be broken by such petty sorcery.','',26124),
(96576,'enUS','This one met a grisly end. No sign of Maiev here.','',26124),
(96577,'enUS','\"Despite our attempts to extract information, the Warden remains stubbornly resistant.\" Could they be talking about Maiev?','',26124),
(96578,'enUS','That\'s Maiev\'s weapon! She was here!','',26124),
(96579,'enUS','','Eyir, mother of the Val\'kyr, I offer you this one chance to submit willingly.',26124),
(96580,'enUS','When the ancient war began, we suffered countless losses. Our cities burned.','',26124),
(96581,'enUS','Lord Ravencrest saved our people and rescued our world from annihilation.','',26124),
(96582,'enUS','His loss was tragic for us all. We owe him... everything.','',26124),
(96583,'enUS','If you\'ve come for the warden, you\'re too late!','If you\'ve come for the warden, you\'re too late!',26124),
(96584,'enUS','Lord Ravencrest, I have served you loyally.','Lord Ravencrest, I have served you loyally.',26124),
(96585,'enUS','My loyalty to Lord Ravencrest will not falter.','My loyalty to Lord Ravencrest will not falter.',26124),
(96586,'enUS','In death, I see the truth. You are no enemy.','In death, I see the truth. You are no enemy.',26124),
(96587,'enUS','You shall never reach Lord Ravencrest\'s tower!','You shall never reach Lord Ravencrest\'s tower!',26124),
(96588,'enUS','You\'ll be thrown into the prisons, just like the others.','You\'ll be thrown into the prisons, just like the others.',26124),
(96593,'enUS','The undead approach! To arms!','',26124),
(96595,'enUS','How did you and your sister get separated?','How did you and your sister get separated?',26124),
(96596,'enUS','What did she do?','What did she do?',26124),
(96597,'enUS','So why are you trying to save her?','So why are you trying to save her?',26124),
(96598,'enUS','Maiev and I chose very different paths in life.$B$BNot long after the Legion\'s first defeat on Azeroth, she dedicated her life to the pursuit of justice.$B$BSome would say she\'s gone too far in that pursuit at times.','',26124),
(96599,'enUS','She murdered innocents, hoping to sever our people\'s ties with the Alliance.$B$BStill, I couldn\'t bring myself to kill her.$B$BAt first I thought that I\'d been weak -- that love had left me unable to do what was necessary.','',26124),
(96600,'enUS','I know my sister. She\'d never commit such crimes unless she was under some foul influence.$B$BEven so, rather than investigate fully, I assumed the worst.$B$BI\'ve been a poor brother, but there\'s still time for me to make things right.','',26124),
(96601,'enUS','DO NOT TRANSLATE','',26124),
(96602,'enUS','I\'ll help you find Maiev.','I\'ll help you find Maiev.',26124),
(96603,'enUS','White Lady, grant me your light so that I may purge these waters of the vile corruption of Xavius.','',26124),
(96604,'enUS','','Little brother. You came for me. Even after I tried to k--',26124),
(96605,'enUS','Foolish druid. The power of your goddess is pitiful. Behold the might of Xavius!','',26124),
(96606,'enUS','DO NOT TRANSLATE','',26124),
(96607,'enUS','We can\'t go out there! Are you crazy? Have you seen those things?','',26124),
(96608,'enUS','Priom\'s right. Those things will crush us! It\'s just the five of us!','',26124),
(96609,'enUS','We\'re completely cut off. We have to wait for reinforcements!','',26124),
(96610,'enUS','','Enough! I won\'t stand for this cowardace.',26124),
(96611,'enUS','','We\'re dead if we stay here too long. Allen, keep your eyes open for any sign of help! We move as soon as reinforcements are in sight!',26124),
(96612,'enUS','Sergeant! I hear movement outside. It could be our reinforcements!','',26124),
(96613,'enUS','','Excellent! Shields up, everyone. We\'re headed outside! Form up!',26124),
(96614,'enUS','You have to earn the Legion\'s gift!','You have to earn the Legion\'s gift!',26124),
(96615,'enUS','The Fel Touch is within your grasp!','The Fel Touch is within your grasp!',26124),
(96616,'enUS','We cannot... allow Xavius... to get away with this! We must get to Shaladrassil... and put an end to the demon!','',26124),
(96617,'enUS','I will meet you further ahead... We must hurry!','',26124),
(96618,'enUS','No! We must press onward... The fate of the world is at stake!','',26124),
(96619,'enUS','Great kill down there! Here comes the air support!','',26124),
(96620,'enUS','Like the wind!','',26124),
(96621,'enUS','Your darkness burns within me!','',26124),
(96622,'enUS','Clear the field of these demons and we\'ll get you the birds you\'ll need to attack this citadel!','',26124),
(96623,'enUS','That citadel\'s not going to destroy itself! Clear a landing site on the farm and we\'ll get you some birds for the assault!','',26124),
(96624,'enUS','If my memory serves me... there was an outpost not far from here.','',26124),
(96625,'enUS','I am everburning!','',26124),
(96626,'enUS','Do not worry about us, commander. We are outnumbered, but they lack our spirit. LOK\'TAR!','',26124),
(96627,'enUS','Go now commander. We will continue to put pressure on this front.','',26124),
(96628,'enUS','','Rotbeak is just northwest, past the dock. Bring me its head!',26124),
(96629,'enUS','I will scour every inch of this island until I find someone who knows of the Pillars of Creation. On my honor.','',26124),
(96630,'enUS','You have business with the Master you should attend to.','',26124),
(96631,'enUS','Throwing','Throwing',26124),
(96632,'enUS','The Legion will fall.','',26124),
(96633,'enUS','Show me what missions you have prepared.','Show me what missions you have prepared.',26124),
(96634,'enUS','Farahlon is mysterious land. Only send a crew you trust... or can afford to lose.','',26124),
(96635,'enUS','We will plumb the depths of Draenor for all its secrets!','',26124),
(96636,'enUS','Give Cordana my best. She\'s been quite distant lately.','',26124),
(96637,'enUS','With every passing moment, Gul\'dan grows in power. But he no longer slinks through the shadows - we know where he is. We know what he\'s doing. Now, we strike! May the Light have mercy on all our souls.','',26124),
(96640,'enUS','I have safely negotiated entrance into the elder drake\'s lair.','',26124),
(96641,'enUS','I will meet you there.','',26124),
(96642,'enUS','','An ancient blue dragon lies to the north. He is our best chance at finding out more about the Pillars.',26124),
(96643,'enUS','I will kill every last demon in my way.','',26124),
(96644,'enUS','','A slight setback. I assure you it will not happen again.',26124),
(96645,'enUS','Doom!','',26124),
(96646,'enUS','You will die!','',26124),
(96647,'enUS','Intruder, your life ends now.','',26124),
(96648,'enUS','The Legion conquers all.','',26124),
(96649,'enUS','You do not belong here.','',26124),
(96650,'enUS','A fatal mistake, mortal.','',26124),
(96651,'enUS','Succulent marrow. Crunchy bones.','',26124),
(96652,'enUS','I will rip the fel from your soul.','',26124),
(96653,'enUS','Quickly, grab them!','',26124),
(96654,'enUS','Another morsel has come to say, hello.','',26124),
(96655,'enUS','Help! Baddies here!','',26124),
(96656,'enUS','We\'ll feast on your flesh and devour your soul.','',26124),
(96657,'enUS','Hey! You\'re not supposed to be here.','',26124),
(96658,'enUS','Tasty meats for me to eats.','',26124),
(96659,'enUS','Warn the Brood Queen!','',26124),
(96660,'enUS','I\'ll burn your kneecaps off.','',26124),
(96661,'enUS','The fel you wield will not be enough.','',26124),
(96662,'enUS','You dare attack us here?!','',26124),
(96663,'enUS','For the Legion!','',26124),
(96664,'enUS','For Brood Queen Tyranna. For the Legion!','',26124),
(96665,'enUS','Stand still so I can shoot you!','',26124),
(96666,'enUS','Let\'s see if your shields can stop a bullet!','',26124),
(96667,'enUS','Why do you always have to be so blurry?','',26124),
(96668,'enUS','You are too late! The corruption is nearly complete!','',26124),
(96669,'enUS','Xavius is the master of this forest now, $c. To enter is to succumb to the Nightmare.','',26124),
(96670,'enUS','Excuse me...','Excuse me...',26124),
(96671,'enUS','<The demon hunter looks as pale as a ghost. He shivers uncontrollably.>','',26124),
(96672,'enUS','Be at peace.','Be at peace.',26124),
(96673,'enUS','Arduen sent me. You\'re free.','Arduen sent me. You\'re free.',26124),
(96674,'enUS','','We were in pursuit of a dangerous dreadlord. Unfortunately, he lured us right into a trap.',26124),
(96675,'enUS','<The Illidari\'s body is nearly unrecognizable. He was tortured, then died from the wounds.>','',26124),
(96676,'enUS','','Good luck. I will make my way up to the foothold as soon as I am done with this demon.',26124),
(96677,'enUS','Nethrandamus, take to the skies. Warn us if enemies approach.','',26124),
(96678,'enUS','','Quickly! The archdruid\'s condition is quite serious...',26124),
(96679,'enUS','Completing Ritual','Completing Ritual',26124),
(96680,'enUS','Use the crucible to complete the ritual.','',26124),
(96681,'enUS','Take me to the nearest invasion point!','Take me to the nearest invasion point!',26124),
(96682,'enUS','I suppose we can offer some assistance.','I suppose we can offer some assistance.',26124),
(96683,'enUS','There were few of our brethren who were worthy, but I do not return empty-handed.','',26124),
(96686,'enUS','As powerful as we are, if Faronaar is any indicatio we will not be able to stop the demons alone.','',26124),
(96687,'enUS','I will find any of our brethren with the courage to follow you into battle and do what needs to be done.','',26124),
(96688,'enUS','Ah, a champion arrives in our most dire hour. Welcome.','',26124),
(96689,'enUS','Beliash is protected by those Spires of Woe. You\'ll want to deactivate them.','',26124),
(96690,'enUS','','This bastard leads the guards in this prison. He must pay for his crimes!',26124),
(96691,'enUS','How dare you attack a kaldorei noble? You will beg for mercy, which I will not give.','',26124),
(96692,'enUS','You always did think too highly of yourself. Another foolish death, then, if you insist.','',26124),
(96693,'enUS','|TINTERFACE\\ICONS\\spell_fire_felflamestrike.blp:20|t Archimonde begins to cast |cFFF00000|Hspell:183254|h[Allure of Flames]|h|r!','|TINTERFACE\\ICONS\\spell_fire_felflamestrike.blp:20|t Archimonde begins to cast |cFFF00000|Hspell:183254|h[Allure of Flames]|h|r!',26124),
(96695,'enUS','A massive gronnling is heading for Rangari Refuge! We are going to require some assistance!','',26124),
(96696,'enUS','','This is only the beginning.',26124),
(96697,'enUS','I wish to browse your goods.','I wish to browse your goods.',26124),
(96698,'enUS','All clear boys! Here come some extra birds. Set down and prepare to assault the citadel!','',26124),
(96699,'enUS','','You heard the commander! Let\'s help clear a landing zone!',26124),
(96700,'enUS','Charge!','Charge!',26124),
(96701,'enUS','','Begging\'s never been one of my talents, Stareye. You should know that by now.',26124),
(96702,'enUS','Lord Ravencrest himself gave me this post. I won\'t surrender it to you demons!','',26124),
(96703,'enUS','Ravencrest? Impossible! And we\'re not demons. Don\'t you recognize me?','',26124),
(96704,'enUS','','It\'s useless, brother. Like the other undead, he cannot see us for who we are.',26124),
(96705,'enUS','Never mind that. I heard what happened in the Vault of the Wardens. Luckily my hair can\'t get any grayer.','',26124),
(96706,'enUS','Why did you have to chase after Gul\'dan alone? Thank Elune you\'re still alive.','',26124),
(96707,'enUS','','Well said, brother: we have bigger concerns. Let\'s go. Stareye has much to answer for.',26124),
(96715,'enUS','You broke ANOTHER drill!? Where did you get those, Venture Company?!','',26124),
(96716,'enUS','Keep your helmet on... we are practically through. Just need to kick it a few times and we got our payday!','',26124),
(96717,'enUS','You\'re gonna need a sick note tomorrow!','',26124),
(96718,'enUS','Quickly, finish the summons.','',26124),
(96719,'enUS','The Legion\'s will be done.','',26124),
(96720,'enUS','Kill the Illidari.','',26124),
(96721,'enUS','For the Brood Queen.','',26124),
(96722,'enUS','Your world will be purged!','',26124),
(96723,'enUS','Our ritual is interrupted.','',26124),
(96724,'enUS','Defend the portal.','',26124),
(96725,'enUS','In Sargeras\'s name.','',26124),
(96726,'enUS','Never should have come to this stinkin\' world...','',26124),
(96727,'enUS','Don\'t be tricky now. I hate tricky!','',26124),
(96728,'enUS','No tricks! I said no tricks!','',26124),
(96729,'enUS','Nothing here for you pal, honest!','',26124),
(96730,'enUS','No... my payday...','',26124),
(96731,'enUS','Hold still a sec, I can fix that whole \"living\" thing for you.','',26124),
(96732,'enUS','Ah man I\'m down!','',26124),
(96733,'enUS','The huntin\' party is here to help shoot down that cursed bird!','',26124),
(96734,'enUS','You will not stop the spread of the Nightmare!','',26124),
(96735,'enUS','','Altruis said you would only take the best. Here we are.',26124),
(96736,'enUS','The engravings on the shield depict a goddess of the shieldmaidens, watching over them in battle. \n\nAbove her is inscribed the name \"Eyir\".','',26124),
(96737,'enUS','This shield appears to show various trials undergone by the warriors of Skold-Ashil.\n\nA depiction of the nearby temple adorns the center.','',26124),
(96738,'enUS','An image of a shieldmaiden is carved on this shield, kneeling before an elaborate spear. \n\nThe priestesses of the temple stand nearby, silently observing the rite.','',26124),
(96739,'enUS','The scene on this shield shows one of the shieldmaidens hovering above a statue of an ancient champion of Skold-Ashil.\n\nThe shieldmaiden is glowing with a radiant aura, and is held aloft by golden wings.','',26124),
(96740,'enUS','Upon this shield, an engraving of Eyir stands at the entrance to the titan vault. \n\nShe appears to be welcoming a winged champion of the shieldmaidens inside.','',26124),
(96741,'enUS','This shield bears an image of a winged shieldmaiden lifting the body of a fallen vrykul from a battlefield.\n\nThe shieldmaiden\'s image appears eerily similar to that of a Val\'kyr.','',26124),
(96742,'enUS','','',26124),
(96743,'enUS','|TINTERFACE\\ICONS\\ability_fixated_state_red.blp:20|t A Doomfire Spirit is |cFFF00000|Hspell:182879|h[Fixated]|h|r on you!','|TINTERFACE\\ICONS\\ability_fixated_state_red.blp:20|t A Doomfire Spirit is |cFFF00000|Hspell:182879|h[Fixated]|h|r on you!',26124),
(96746,'enUS','We will find a Legion gateway or die trying.','',26124),
(96747,'enUS','','Spare us the theatrics, won\'t you, Altruis?',26124),
(96748,'enUS','Ah, get behind me!','',26124),
(96749,'enUS','I\'m flyin\'!','',26124),
(96750,'enUS','Did someone say bomb?!','',26124),
(96751,'enUS','Special DELIVERY!','',26124),
(96752,'enUS','You have no power over me!','',26124),
(96753,'enUS','You demons picked the wrong gnome to mess with!','',26124),
(96754,'enUS','Our blades have been honed for millennia. This world will fall!','',26124),
(96758,'enUS','Don\'t let them into the tower!','',26124),
(96759,'enUS','Keep them out of here!','',26124),
(96760,'enUS','I\'ll be damned if those demons think they can take the tower!','',26124),
(96766,'enUS','Aye commander, we can divert resources from any of your nearby outposts for use here in Tanaan. Ye\' just let me know which one ye\' want!','',26124),
(96767,'enUS','Call to Arms.','Call to Arms.',26124),
(96768,'enUS','Guardian Orb.','Guardian Orb.',26124),
(96769,'enUS','Artillery Strike.','Artillery Strike.',26124),
(96770,'enUS','Champion\'s Honor.','Champion\'s Honor.',26124),
(96771,'enUS','The Mechashredder.','The Mechashredder.',26124),
(96772,'enUS','DO NOT TRANSLATE','',26124),
(96773,'enUS','The structure cracks under pressure, exploding and releasing large amounts of fel energy into the sky.','',26124),
(96775,'enUS','Aye, Commander, I\'d like to talk to you about bringing some of our reinforcements here to Tanaan, if ye\' have a minute.','',26124),
(96776,'enUS','Hey there, Commander. We\'ve got some extra supplies I can call in to help out, if you give the order.','',26124),
(96777,'enUS','We\'ve got supplies from our nearby outposts that we can call in, now that most of the heat is taking place here. Which supplies did you want to bring over?','',26124),
(96779,'enUS','Time I stood up, got out there and helped! Ah, what\'s the use?','',26124),
(96780,'enUS','Great spot, great view - just me and the end of the world!','',26124),
(96781,'enUS','Here we come! This is it! It\'s the end of the world as we know it!','',26124),
(96785,'enUS','You\'re gonna wear that hideous outfit today?','',26124),
(96786,'enUS','Do you really need to be carrying ALL that stuff around?','',26124),
(96787,'enUS','You should write to your mother. She\'s worried sick about you.','',26124),
(96788,'enUS','I don\'t understand why you have critters fight other critters when you could do a much better job yourself.','',26124),
(96789,'enUS','If I get you to where you want to go, will you agree to leave me alone?','',26124),
(96790,'enUS','You wanna get out of here? I\'ll get you out of here, but I\'m not making any promises on where you go.','',26124),
(96791,'enUS','Sure, I trust a demon to send me to a safe location.','Sure, I trust a demon to send me to a safe location.',26124),
(96792,'enUS','','You found it! Thank you, traveler.$B$B<Syndrelle pauses for a moment.>$B$BOn second thought, I would rather you keep it and think of it as a reminder of our new friendship.',26124),
(96793,'enUS','','Hello traveler. I\'ve lost my favorite charm somewhere around here. I don\'t suppose that you\'d be willing to help me look for it?',26124),
(96794,'enUS','I\'d be happy to help.','I\'d be happy to help.',26124),
(96795,'enUS','You must go ahead - Nethrandamus stayed with the others so I will only slow you down. Go!','',26124),
(96796,'enUS','','This is so exciting!',26124),
(96797,'enUS','','Don\'t worry, I can talk and shoot at the same time!',26124),
(96798,'enUS','','Do rifles always have this much recoil?',26124),
(96799,'enUS','','You make it look so easy!',26124),
(96803,'enUS','It\'s a fine day for a hunt.','',26124),
(96804,'enUS','It doesn\'t get much better than this; the smell of fresh pine in the breeze, an abundance of game to be hunted.','',26124),
(96805,'enUS','','$n has arrived. For the Illidari!',26124),
(96806,'enUS','Help! Please!','Help! Please!',26124),
(96807,'enUS','Please, save me!','Please, save me!',26124),
(96808,'enUS','They won\'t leave me alone...','They won\'t leave me alone...',26124),
(96809,'enUS','Get me out of here!','Get me out of here!',26124),
(96810,'enUS','Please... help me...','Please... help me...',26124),
(96811,'enUS','My services are yours if you help me escape!','My services are yours if you help me escape!',26124),
(96812,'enUS','I shouldn\'t have come out here all alone!','I shouldn\'t have come out here all alone!',26124),
(96813,'enUS','I don\'t want to go out like this...','I don\'t want to go out like this...',26124),
(96814,'enUS','|TInterface\\Icons\\ability_vehicle_siegeenginecannon.blp:20|t A %s is slightly damaged!','|TInterface\\Icons\\ability_vehicle_siegeenginecannon.blp:20|t A %s is slightly damaged!',26124),
(96815,'enUS','|TInterface\\Icons\\ability_vehicle_siegeenginecannon.blp:20|t A %s is severely damaged!','|TInterface\\Icons\\ability_vehicle_siegeenginecannon.blp:20|t A %s is severely damaged!',26124),
(96816,'enUS','|TInterface\\Icons\\ability_vehicle_siegeenginecannon.blp:20|t A %s is critically damaged!','|TInterface\\Icons\\ability_vehicle_siegeenginecannon.blp:20|t A %s is critically damaged!',26124),
(96817,'enUS','','The Burning Legion will fall.',26124),
(96818,'enUS','You are spotted by the %s!','',26124),
(96819,'enUS','My blades thirst for the blood of the Legion!','My blades thirst for the blood of the Legion!',26124),
(96820,'enUS','You shall perish!','You shall perish!',26124),
(96821,'enUS','Your advances are ill-advised.','Your advances are ill-advised.',26124),
(96822,'enUS','You will witness true power!','You will witness true power!',26124),
(96823,'enUS','You will pray for a swift death!','You will pray for a swift death!',26124),
(96824,'enUS','','I don\'t trust a gnome with a gun. \n\nAddie\'s more likely to shoot you than any of her intended targets.',26124),
(96825,'enUS','','It... it must be around here somewhere!',26124),
(96826,'enUS','','Maybe the current moved it...',26124),
(96827,'enUS','','Where could it have gone?',26124),
(96828,'enUS','','By the antlers of Cenarius! Where is it?',26124),
(96829,'enUS','','Don\'t you ever listen to your elders, $c? No matter, you did save my life.$B$BLet me rest a while. I\'ll be fine, just wait.',26124),
(96830,'enUS','','I\'ll be fine, $c. Turn back. This is my score to settle.',26124),
(96831,'enUS','Score? Don\'t be a fool. You are badly injured.','Score? Don\'t be a fool. You are badly injured.',26124),
(96832,'enUS','Gorefiend begins to cast |TInterface\\Icons\\spell_misc_zandalari_council_soulswap:20|t |cFFFF0404|Hspell:181973|h[Feast of Souls]|h|r!','Gorefiend begins to cast |TInterface\\Icons\\spell_misc_zandalari_council_soulswap:20|t |cFFFF0404|Hspell:181973|h[Feast of Souls]|h|r!',26124),
(96833,'enUS','How ya doin\'?','',26124),
(96834,'enUS','Time for a workout!','',26124),
(96835,'enUS','Anyone up for sketch group?','',26124),
(96836,'enUS','Oh ho ho. Well looky here. We got ourselves something new to hunt.','',26124),
(96837,'enUS','Now I find you spending your last moments with this, this beast.','',26124),
(96838,'enUS','I shalll enjoy putting you down.','',26124),
(96840,'enUS','','You should have listened... On your guard, $c.',26124),
(96841,'enUS','This ancient moonwell has seen better days, but its waters still glow with the radiant  moonlight of Elune.','',26124),
(96842,'enUS','','Stand back. I do not need your assistance.',26124),
(96843,'enUS','Welcome to sketch group! Grab an easel, get comfortable. No judgments here - unless you\'re a Paladin, of course.$b$bToday we\'re studying the nexus. Such beauty! Such chaos! So much... blue.','',26124),
(96844,'enUS','','Even though these woods have been lost to the corruption of Shaladrassil, this is still our home.$b$bThe fate of the forest is ours to share.',26124),
(96846,'enUS','','That wasn\'t necessary of ya, but you have my thanks.',26124),
(96848,'enUS','Charge!','Charge!',26124),
(96849,'enUS','Hyyeeaahhhaaay!','',26124),
(96850,'enUS','Take up the blade, Arthas Menethil. Embrace your destiny!','',26124),
(96851,'enUS','Yes... you are right... I will bear any curse to have my revenge...','',26124),
(96852,'enUS','','Insolent dog!',26124),
(96853,'enUS','','You will suffer for this! Bring me his head!',26124),
(96854,'enUS','What? An intruder! You won\'t stop me! Frostmourne will be mine!','',26124),
(96855,'enUS','To arms! Lord Felsoul must not be disturbed.','',26124),
(96856,'enUS','Face me, Banshee Queen. Answer for your crimes!','',26124),
(96857,'enUS','The demons underestimate your power. Punish them for their hubris!','',26124),
(96858,'enUS','How dare you interfere! His soul belongs to ME!','',26124),
(96860,'enUS','Argh! The darkness... I can\'t... I...','',26124),
(96861,'enUS','ARRGHHHHHH!!!','',26124),
(96866,'enUS','Bathe them in hellfire! Halt their advance!','',26124),
(96867,'enUS','','It\'s about time I put you down, Greymane!',26124),
(96868,'enUS','','Azshara kept her secrets well. By the time I saw the demons first-hand, it was already too late.',26124),
(96869,'enUS','','The Queen\'s thirst for power doomed us all.',26124),
(96870,'enUS','Ishnu-dal-dieb, traveler.','',26124),
(96871,'enUS','So many worlds... so many layers of existence...','',26124),
(96872,'enUS','In the end, they become nothingness... or, perhaps...','',26124),
(96873,'enUS','They will BURN! Die! The master wills it!','',26124),
(96874,'enUS','No matter how it all ends, you will die here.','',26124),
(96875,'enUS','I have so much to show you...','',26124),
(96876,'enUS','Servants of the Void! Swallow this world!','',26124),
(96877,'enUS','All life must decay.','',26124),
(96878,'enUS','Corruption! Flame! Ash!','',26124),
(96879,'enUS','LEGION! Destroy all who stand before you!','',26124),
(96880,'enUS','I TEAR APART! AND WITH ME, YOU TOO SHALL DIE!','',26124),
(96881,'enUS','These gaps in reality... I must tear them wider!','',26124),
(96882,'enUS','All will be swallowed! No life shall remain!','',26124),
(96883,'enUS','I cannot remain... I am becoming... EVERYTHING! NOTHING!','',26124),
(96884,'enUS','BURN!','',26124),
(96885,'enUS','RIP APART!','',26124),
(96886,'enUS','I CANNOT... CONTAIN...','',26124),
(96887,'enUS','IT OVERWHELMS ME!','',26124),
(96888,'enUS','YES! YES! I SEE IT! I can see... the... end...','',26124),
(96889,'enUS','This world will not fall so easily, demon. Its people will not give up without a fight. Our will is unbreakable! For Draenor!','',26124),
(96890,'enUS','Lok\'tar ogar! They are pushed back! To the portal! Gul\'dan is mine!','',26124),
(96891,'enUS','The final hour is at hand, the master comes! This is your purpose, summoners. Mannoroth will be whole again!','',26124),
(96892,'enUS','The wrath of the legion will destroy you!','',26124),
(96893,'enUS','Your failure will please the master!','',26124),
(96894,'enUS','Death awaits...','',26124),
(96895,'enUS','I\'d like to purchase Seals of Tempered Fate.','I\'d like to purchase Seals of Tempered Fate.',26124),
(96896,'enUS','Finish the portal, damn you! We must protect the wards!','',26124),
(96897,'enUS','','Thanks! Let\'s get to work. Here kitty, kitty, kitty...',26124),
(96898,'enUS','','Seek out Maladaar in the west. I fear he may have encountered the brunt of Gul\'dan\'s forces.',26124),
(96899,'enUS','','Find my husband in the battlefield to the west! I pray our losses were not too great.',26124),
(96900,'enUS','Let the darkness consume you! Feast upon the souls of the damned!','',26124),
(96902,'enUS','Here! This is a perfect natural harbor.','',26124),
(96903,'enUS','Many of the souls freed by Frostmourne\'s destruction wander the halls of Icecrown, lashing out in eternal torment.','',26124),
(96904,'enUS','|TInterface\\Icons\\spell_shadow_deadofnight.blp:20|t Cull the scourge before they are sacrificed!','',26124),
(96905,'enUS','Use |TInterface\\Icons\\spell_shadow_antimagicshell.blp:20|t |cFF2959D3|Hspell:184366|h[Anti-Magic Shell]|h|r to avoid harmful spells!','Use |TInterface\\Icons\\spell_shadow_antimagicshell.blp:20|t |cFF2959D3|Hspell:184366|h[Anti-Magic Shell]|h|r to avoid harmful spells!',26124),
(96906,'enUS','Exposition','',26124),
(96907,'enUS','Our people look to us for aid. Make these foul creatures regret the day they invaded our world!','',26124),
(96908,'enUS','These demons think us easy prey. Today they will learn that the kaldorei stand down to no one.','',26124),
(96909,'enUS','Warriors, you pledged your blades to the House of Ravencrest. Today, we take up arms and fight!','',26124),
(96910,'enUS','Rally to me, soldiers! No matter the foes we face, Black Rook Hold shall not fall!','',26124),
(96911,'enUS','Stand firm, champions! Our might is tested, but we shall prevail!','',26124),
(96912,'enUS','You have gone far enough, mortal. This ends here.','',26124),
(96913,'enUS','Another prisoner for my cells? Looks like I\'ll need to break you first!','',26124),
(96914,'enUS','Intruder! Sound the alarm!','Intruder! Sound the alarm!',26124),
(96915,'enUS','I\'ve been training for this moment!','I\'ve been training for this moment!',26124),
(96916,'enUS','You\'ll get no further, invader!','You\'ll get no further, invader!',26124),
(96917,'enUS','This world has no place for you, demon!','This world has no place for you, demon!',26124),
(96918,'enUS','Your kind is not welcome here!','Your kind is not welcome here!',26124),
(96919,'enUS','I\'ll wipe your blood off my blade, just like the rest!','I\'ll wipe your blood off my blade, just like the rest!',26124),
(96920,'enUS','I have slain hundreds before you. You\'ll simply be one more notch on my belt.','I have slain hundreds before you. You\'ll simply be one more notch on my belt.',26124),
(96921,'enUS','I will grant you a swift death, trespasser.','I will grant you a swift death, trespasser.',26124),
(96922,'enUS','','I never miss!',26124),
(96923,'enUS','','Stop, interloper. I\'ll make you bleed first!',26124),
(96924,'enUS','','My strike is swift and true!',26124),
(96925,'enUS','','If you won\'t return to your world, I\'ll send you there in pieces!',26124),
(96926,'enUS','','Enjoy this moment. It will be your last!',26124),
(96927,'enUS','','The lieutenant has ordered your execution.',26124),
(96928,'enUS','$n... it\'s been years. You should know better than to stand against me.','',26124),
(96929,'enUS','My master has granted me many gifts. Witness the power of the Deceiver!','',26124),
(96930,'enUS','Each Vision of Death rune needs someone within it to avoid raid damage!','',26124),
(96931,'enUS','Over here, $c! Your help is needed inside!','',26124),
(96932,'enUS','I will personally deal with their leader, my queen.','',26124),
(96933,'enUS','I almost... made it... out...','',26124),
(96934,'enUS','Welcome to the Scribes\' Sacellum!','',26124),
(96935,'enUS','Deucus said you owe him a favor. I have a tome in need of translation.','Deucus said you owe him a favor. I have a tome in need of translation.',26124),
(96937,'enUS','Skyhorn, to me!','',26124),
(96938,'enUS','Ha! Now that was a battle.','',26124),
(96939,'enUS','The differences that have set the Arakkoa apart for years seem so trivial today. We have squandered the might of our people on fear and mistrust of one another when we should have been looking beyond the safety of Skyreach. There is nothing to be done about the past, but know that there are some who wish for our people to be more than a footnote to what Gul\'dan has wrought.\n\nI will help you, $c. We must all help one another now, or this world is doomed.','',26124),
(96940,'enUS','I suppose I do owe that blowhard a favor. Lucky for you, translation is my specialty!','',26124),
(96941,'enUS','This is ancient vrykul script, the property of someone named \"Svena\". A rare and intriguing find indeed. Tell Deucus he is now in MY debt!','',26124),
(96942,'enUS','','I\'m sorry to hear that Arduen didn\'t make it. I will make sure the demons pay for his death.',26124),
(96943,'enUS','Who dares stand against the might of the Legion?','',26124),
(96944,'enUS','Come, champion. Let us pluck this Witchqueen from her throne.','',26124),
(96945,'enUS','You handle the Witchqueen. We will contend with her brood.','',26124),
(96946,'enUS','Finally, I can rest.','Finally, I can rest.',26124),
(96947,'enUS','','See that you do.',26124),
(96948,'enUS','Quel\'Thalas will never fall!','Quel\'Thalas will never fall!',26124),
(96949,'enUS','You are not welcome here!','You are not welcome here!',26124),
(96950,'enUS','You shall not pass!','You shall not pass!',26124),
(96951,'enUS','The king may have fallen but I will never abandon Lordaeron!','',26124),
(96952,'enUS','You an\' that prince of yours are gonna pay for what he did to ole\' Muradin!','',26124),
(96953,'enUS','The Light... no...','',26124),
(96954,'enUS','You unholy monster! The righteous fury of the Light will tear you apart!','',26124),
(96955,'enUS','Peace... at... last...','',26124),
(96956,'enUS','The Silver Hand will remove your blight from this world!','',26124),
(96957,'enUS','The pain... is over...','',26124),
(96958,'enUS','To arms soldiers of Quel\'Thalas! The enemy is at our very doorstep!','',26124),
(96959,'enUS','Ah, $n. So the Lich King chose you to be his hand? I\'m not surprised. We have all heard of your exploits.','',26124),
(96960,'enUS','Our forces have gathered from all across Northrend. When the call to action comes... and it will come soon... the Knights of the Ebon Blade will be ready.','',26124),
(96961,'enUS','Make no mistake, we are not bound to this new Lich King. However, he may prove a valuable ally against the Legion.','',26124),
(96962,'enUS','The gates of Icecrown lie to the north. Do not keep our ally waiting!','',26124),
(96964,'enUS','For now, our goals align with his. And in the meantime, it is in our best interests that the Scourge stay... contained.','',26124),
(96968,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\LFGFRAME\\LFGICON-SUNWELL.BLP:50:80|t$bI will have my revenge!','',26124),
(96969,'enUS','|TINTERFACE\\ICONS\\ability_warlock_moltencoregreen.blp:20|t $n is marked with |cFFF00000|Hspell:186961|h[Nether Banish]|h|r!','|TINTERFACE\\ICONS\\ability_warlock_moltencoregreen.blp:20|t $n is marked with |cFFF00000|Hspell:186961|h[Nether Banish]|h|r!',26124),
(96970,'enUS','|TINTERFACE\\ICONS\\spell_misc_zandalari_council_soulswap.blp:20|t You are marked with |cFFF00000|Hspell:186123|h[Wrought Chaos]|h|r!','|TINTERFACE\\ICONS\\spell_misc_zandalari_council_soulswap.blp:20|t You are marked with |cFFF00000|Hspell:186123|h[Wrought Chaos]|h|r!',26124),
(96971,'enUS','|TINTERFACE\\ICONS\\spell_shadow_soulleech_1.blp:20|t You are marked with |cFFF00000|Hspell:185014|h[Focused Chaos]|h|r!','|TINTERFACE\\ICONS\\spell_shadow_soulleech_1.blp:20|t You are marked with |cFFF00000|Hspell:185014|h[Focused Chaos]|h|r!',26124),
(96972,'enUS','Your soul is mine!','',26124),
(96975,'enUS','For Lordaeron!','For Lordaeron!',26124),
(96976,'enUS','Meet your second death, undead filth!','Meet your second death, undead filth!',26124),
(96977,'enUS','Repel the intruder!','Repel the intruder!',26124),
(96978,'enUS','To arms!','To arms!',26124),
(96981,'enUS','Death... really isn\'t so bad.','',26124),
(96982,'enUS','What are you afraid of?','',26124),
(96983,'enUS','Your death makes me stronger.','',26124),
(96985,'enUS','It\'s a fine day for a hunt.','',26124),
(96986,'enUS','The Wardens are searching every corner of the Broken Isles for Gul\'dan.$B$BThey have reason to believe the warlock hides some secret within Black Rook Hold. And if he is here, then so perhaps is my sister, Maiev.','',26124),
(96988,'enUS','How strange... Ravencrest\'s army sees us as invaders. It\'s as if they are trapped within their own memories.','',26124),
(96989,'enUS','Sira and the other Wardens are doing everything they can to find Maiev.$B$BThe attack on the Vault of the Wardens was devastating. Of hundreds, only a handful survived.$B$BBut the Wardens are tough as steel. They will survive.','',26124),
(96990,'enUS','I refuse to believe it. Lord Ravencrest cannot be working with Gul\'dan.','',26124),
(96991,'enUS','','We must retrieve it. He\'s still my charge. We\'ll have to invade the tower. But it will be no easy task.',26124),
(96992,'enUS','','Champion, return to your other duties for now. Soon we will face Lord Ravencrest himself.',26124),
(96993,'enUS','Slay them all! For the Dark Lady!','',26124),
(96994,'enUS','Hand over the Banshee Queen!','',26124),
(96995,'enUS','Sylvanas! Come and face your executioner!','',26124),
(96996,'enUS','I\'ll reduce this camp to rubble if I have to!','',26124),
(96997,'enUS','','Thank you, hero. I did not expect salvation from this place. Where is my brother?',26124),
(96998,'enUS','Show yourself, Sylvanas!','',26124),
(96999,'enUS','You cannot hide from me!','',26124),
(97000,'enUS','You call us monsters? How rich.','',26124),
(97001,'enUS','Monsters! You have no place in this world!','',26124),
(97002,'enUS','Stop holding back, old man! Show us the real you.','',26124),
(97003,'enUS','I will take out the guards inside the prison. Get those keys and meet me within the cells.','',26124),
(97004,'enUS','Rrgghhh... ENOUGH!','',26124),
(97005,'enUS','I will stay to ease this prisoner\'s passing. It won\'t be long, now. Go ahead and find Maiev.','',26124),
(97006,'enUS','Take me to Dreadmist Peak!','Take me to Dreadmist Peak!',26124),
(97007,'enUS','','Lieutenant Stareye commands. Death to all intruders!',26124),
(97008,'enUS','We have secured the walls, demon! You will not escape here alive.','',26124),
(97009,'enUS','Test my hammer, and YOU will be the one to break!','',26124),
(97010,'enUS','Ah, there you are!','',26124),
(97011,'enUS','This ends here, Demons!','',26124),
(97012,'enUS','Mo\'arg, to the front! This has gone on long enough.','',26124),
(97013,'enUS','','Over here! This sewer will take us back outside. We should go before our enemies regroup.',26124),
(97014,'enUS','What a tragic waste. Even in death, he only wanted to protect our people.','',26124),
(97015,'enUS','','The battle rages throughout Tanaan, Commander. Where shall we focus our attention today?',26124),
(97016,'enUS','','Gul\'dan is creating his own army of zealots. Where should we strike back?',26124),
(97017,'enUS','','Gul\'dan will not break us. The Legion will NEVER break us! Today we fight back.',26124),
(97018,'enUS','','This jungle hides dangers untold. But if we are wise, we can use it to mask our next attack.',26124),
(97019,'enUS','','I have the latest reports from the Rangari right here, commander. Where should we strike?',26124),
(97020,'enUS','','Gul\'dan\'s fel minions are closing in around us. We MUST go on the offensive, commander!',26124),
(97021,'enUS','','Our warriors are blessed by the light, sure of purpose and hardened by battle. They await your orders.',26124),
(97022,'enUS','','If this is truly the end of the world, then I, for one, will go out fighting. For Samara, for Maraad, for all those who gave their lives to give us this day!',26124),
(97023,'enUS','DIE!','',26124),
(97024,'enUS','My forces are yours.','',26124),
(97025,'enUS','We will assist in establishing the volcano foothold.','',26124),
(97026,'enUS','Ashtongue, forward!','',26124),
(97027,'enUS','You face not Malchezaar alone, but the legions I command!','',26124),
(97028,'enUS','What, good $gsir:madam;, can I do to assist you today?','',26124),
(97029,'enUS','Where can I find a Leyflame Burner?','Where can I find a Leyflame Burner?',26124),
(97030,'enUS','Where can I find Advanced Corks?','Where can I find Advanced Corks?',26124),
(97031,'enUS','Where can I find a Dual-Chambered Mixing Flask?','Where can I find a Dual-Chambered Mixing Flask?',26124),
(97032,'enUS','Where can I find Precipitating Powder?','Where can I find Precipitating Powder?',26124),
(97033,'enUS','Where can I find a Shaldorei Silk Filter?','Where can I find a Shaldorei Silk Filter?',26124),
(97034,'enUS','Where can I find a Demonsbreath Crucible?','Where can I find a Demonsbreath Crucible?',26124),
(97035,'enUS','Where can I find Bendy Glass Tubes?','Where can I find Bendy Glass Tubes?',26124),
(97036,'enUS','Where can I find a Malloric Burette?','Where can I find a Malloric Burette?',26124),
(97037,'enUS','Where can I find a High-Capacity Decoction Conduit?','Where can I find a High-Capacity Decoction Conduit?',26124),
(97038,'enUS','I need help finding the replacement alchemy equipment.','I need help finding the replacement alchemy equipment.',26124),
(97039,'enUS','Our alchemy table remains woefully incomplete.$b$bI shall use my extensive knowledge to point you in the direction of replacement parts, but I fear you will have to do some legwork on your own.','',26124),
(97040,'enUS','I\'ve heard that someone over in the engineering shop is selling a burner that might be usable. You could likely negotiate a fairer price than I could!$b$bThe shop is just across the street. I\'ll make a note on your map for you.','',26124),
(97041,'enUS','The naga have been known to hoard all manner of potions, so they might have the sort of corks we need. The best place to search is the Eye of Azshara itself!','',26124),
(97042,'enUS','We require a flask capable of mixing more than reagents. Thoughts, ideas, dreams...$b$bYou may have to search the Emerald Nightmare for such an item!$b$bPLAYTEST CHEAT: CI 127872','',26124),
(97043,'enUS','It\'s said the ancient vrykul collected such powderfrom the residue of dragon\'s breath. If it\'s true that Neltharion\'s Lair lies somewhere below us, it seems a likely source.$b$bPLAYTEST CHEAT: CI 127874','',26124),
(97044,'enUS','The delicate yet resilient fabric needed for this sort of filter would come from a place of majesty and power. The locals speak of something called the Halls of Valor... you might investigate.$b$bPLAYTEST CHEAT: CI 127875','',26124),
(97045,'enUS','Artifacts of such potency are supposedly kept within the Vault of the Wardens. There are whispers of trouble in those halls, so be careful!$b$bPLAYTEST CHEAT: CI 127876','',26124),
(97046,'enUS','The alchemists of old were known to be buried alongside their implements. Searching within Suramar Crypts may yield results.$b$bPLAYTEST CHEAT: CI 127877','',26124),
(97047,'enUS','That particular burette was designed by Alchemist Mallory of Stormwind. I\'ve heard that similarly valuable equipment might be stored in the Violet Hold.$b$bPLAYTEST CHEAT: CI 127878','',26124),
(97048,'enUS','Often rare finds only come from the darkest of places, $n. Dare I speak the name aloud? Venture into Helheim... if you dare!','',26124),
(97049,'enUS','Queue for dungeon','Queue for dungeon',26124),
(97050,'enUS','Queue for heroic dungeon','Queue for heroic dungeon',26124),
(97051,'enUS','Nicely done! Patricia has a new recipe for you, $n.','',26124),
(97052,'enUS','How dare you speak to me!','How dare you speak to me!',26124),
(97053,'enUS','I can only laugh that you mortals keep holding on. The master even foresaw the coming of these days.','I can only laugh that you mortals keep holding on. The master even foresaw the coming of these days.',26124),
(97054,'enUS','Pathetic. Begone from my sight... I can\'t stand grovelers.','Pathetic. Begone from my sight... I can\'t stand grovelers.',26124),
(97055,'enUS','You are afflicted with |TInterface\\Icons\\Spell_Shadow_ChillTouch.blp:20|t |cFFFF0404|Hspell:189434|h[Touch of Doom]|h|r!','You are afflicted with |TInterface\\Icons\\Spell_Shadow_ChillTouch.blp:20|t |cFFFF0404|Hspell:189434|h[Touch of Doom]|h|r!',26124),
(97056,'enUS','|cFFFF0000|Hspell:181295|h[Digest]|h|r killed you.  Run to the center to escape before the timer expires!','|cFFFF0000|Hspell:181295|h[Digest]|h|r killed you.  Run to the center to escape before the timer expires!',26124),
(97059,'enUS','Grah - uh COMMANDER! Yes commander! Zug zug!','',26124),
(97063,'enUS','<This grunt is oblivious to your presence, and is slumped against the wall dozing.>','',26124),
(97064,'enUS','WAKE UP! Or I\'ll have you cleaning latrines before you can say \"ready to work!\"','WAKE UP! Or I\'ll have you cleaning latrines before you can say \"ready to work!\"',26124),
(97068,'enUS','Master... I have... failed...','',26124),
(97070,'enUS','','This is pretty much the best day ever!',26124),
(97071,'enUS','Curse Helya! Curse her cowardly followers! I\'ll not rest until she is dead!','',26124),
(97073,'enUS','','You can\'t beat the thrill of hunting something ten times your size!',26124),
(97074,'enUS','','Should we take a S.E.L.F.I.E.?',26124),
(97075,'enUS','','On to the next one!',26124),
(97078,'enUS','','I\'m feeling a bit more comfortable with my rifle.',26124),
(97080,'enUS','I was Illidari once... left for dead at the Black Temple. Now you will witness the might of my new master!','',26124),
(97081,'enUS','','We\'re not going in there, are we?',26124),
(97082,'enUS','So, Illidari, you seek my head, that you might take the Twinblades as your own? Allow me to introduce you to their power... personally.','',26124),
(97083,'enUS','Join me! Unleash your true power. Do not let the weak hold you back!','',26124),
(97084,'enUS','Behold the might of the Deceiver! Behold the glory of the demon within!','',26124),
(97085,'enUS','I am a GOD! KNEEL BEFORE ME!','',26124),
(97086,'enUS','Beasts all over the ship! Put them down!','',26124),
(97087,'enUS','Feel the icy chill of death around you!','',26124),
(97088,'enUS','<Skoller pelts you in the face with several nuts before realizing you\'re not a squirrel.>$b$bOh, hello friend. Even in the heart of a war-torn jungle, it\'s important to take care of the little ones.','',26124),
(97089,'enUS','<Skoller pelts you in the face with several nuts before realizing you\'re not a squirrel.>$b$bOh, hello friend. Even in the heart of a war-torn jungle, it\'s important to take care of the little ones.$b$bHey... c\'mere. Since you took the time to say hello... Would you like a gift?','',26124),
(97090,'enUS','Yes I would! You, sir, are a gentleman and a ... Skoller.','Yes I would! You, sir, are a gentleman and a ... Skoller.',26124),
(97091,'enUS','Stand at attention! Commander $p is here.','Stand at attention! Commander $p is here.',26124),
(97092,'enUS','Garrison: Shipyard Construction','Garrison: Shipyard Construction',26124),
(97093,'enUS','Tanaan Jungle: The Invasion Begins','Tanaan Jungle: The Invasion Begins',26124),
(97094,'enUS','Tanaan Jungle: The Founding of Lion\'s Watch','Tanaan Jungle: The Founding of Lion\'s Watch',26124),
(97095,'enUS','Tanaan Jungle: The Founding of Vol\'mar','Tanaan Jungle: The Founding of Vol\'mar',26124),
(97096,'enUS','Hellfire Citadel: Gul\'dan\'s Plan','Hellfire Citadel: Gul\'dan\'s Plan',26124),
(97097,'enUS','Hellfire Citadel: Victory in Draenor!','Hellfire Citadel: Victory in Draenor!',26124),
(97098,'enUS','The explosives are set! Get to a safe distance and detonate them!','',26124),
(97099,'enUS','The portal shimmers with images of the citadel.','',26124),
(97100,'enUS','Teleport to the Hellfire Antechamber.','Teleport to the Hellfire Antechamber.',26124),
(97101,'enUS','Teleport to the Court of Blood.','Teleport to the Court of Blood.',26124),
(97102,'enUS','Curse you, interloper! All my plans... ruined!','',26124),
(97105,'enUS','Teleport to upper Hellfire Citadel.','Teleport to upper Hellfire Citadel.',26124),
(97106,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-King Ymiron.blp:50:80|t$bReady are you? Let us see!','',26124),
(97107,'enUS','Gladly, my master!','',26124),
(97108,'enUS','Send me to Destructor\'s Rise.','Send me to Destructor\'s Rise.',26124),
(97109,'enUS','You are victorious! Khadgar was watching the island, but the demons blocked us somehow for teleporting earlier. I should have known you would need no assistance.','',26124),
(97110,'enUS','Teleport to the Destructor\'s Rise.','Teleport to the Destructor\'s Rise.',26124),
(97111,'enUS','Teleport to the Black Gate.','Teleport to the Black Gate.',26124),
(97112,'enUS','How may I aid you, $c?','',26124),
(97113,'enUS','A single gunship? Are they insane?','',26124),
(97114,'enUS','I wish to return to the Iron Bulwark.','I wish to return to the Iron Bulwark.',26124),
(97115,'enUS','He put up quite a fight, but your archdruid belongs to me now...','',26124),
(97116,'enUS','The other one put up quite a struggle.','',26124),
(97117,'enUS','This will not be the last ally you lose. Even rats abandon a sinking ship.','',26124),
(97118,'enUS','Lord Varedis will not rest until your heads decorate his throne!','',26124),
(97119,'enUS','Gryphons incoming! Man that catapult!','',26124),
(97120,'enUS','','This one is unfortunately resilient. Ready when you are.',26124),
(97121,'enUS','The mixture in those vials is extremely volatile. Once you pop the cork, there\'s no containing it.','',26124),
(97122,'enUS','Place a few vials near their ammunition - before long, the ship will be tearing itself apart from the inside.','',26124),
(97123,'enUS','We will have our revenge, but I\'m far more interested in the blades the demon spoke of.','',26124),
(97124,'enUS','Meet me on deck when the vials are in place. There is someone here I want to kill personally...','',26124),
(97125,'enUS','Just think of the power they could hold... power you could use to destroy the Legion.','',26124),
(97126,'enUS','We will meet you at Krasus\' Landing. The hunt begins.','',26124),
(97127,'enUS','It\'s clobbering time.','',26124),
(97128,'enUS','','Give me a moment to catch my breath, hero. The long years of vigil have taken their toll.',26124),
(97129,'enUS','The dreamworg phases into reality!','The dreamworg phases into reality!',26124),
(97130,'enUS','','Damnit! We\'re sitting ducks out here!',26124),
(97131,'enUS','','Show yourselves you cowards...',26124),
(97133,'enUS','','More outsiders in my skies?! Die!',26124),
(97134,'enUS','I\'ll find a way to repay you, I swear!','I\'ll find a way to repay you, I swear!',26124),
(97135,'enUS','A free rescue? You\'re some kind of hero!','A free rescue? You\'re some kind of hero!',26124),
(97136,'enUS','Is it over? Can I go home now?','Is it over? Can I go home now?',26124),
(97137,'enUS','Behold the infinite power of the Twinblades!','',26124),
(97138,'enUS','Xandris has seen his last moonrise!','',26124),
(97139,'enUS','After the War of Ancients, the surviving satyrs were assembled together. I argued to execute them for their transgressions, but our merciful nature won the day. I was overruled.$b$bInstead, the satyrs were placed in an eternal sleep deep below the roots of Shaladrassil. Now, somehow, they have awoken.$B$BWe shall not make the same mistake again, if I must kill them all myself!','',26124),
(97140,'enUS','<Thaon snarls> These satyrs should never have been allowed to live.','',26124),
(97141,'enUS','My lands suffer because of the council\'s shortsightedness...','',26124),
(97142,'enUS','These satyrs should never have been allowed to live. A demon can never be redeemed.','',26124),
(97143,'enUS','The council foolishly decided to banish the satyrs deep below the roots of the World Tree.','',26124),
(97144,'enUS','Now, thousands of years later, some malevolent force has broken their bonds, rousing these demons to fight us once again.','',26124),
(97145,'enUS','I will not stand idly by and watch my home succumb to this corruption!','',26124),
(97146,'enUS','We will correct the mistakes of the past and slay these satyrs. I will see their blood as payment for their curse!','',26124),
(97147,'enUS','With our combined might, we will destroy their demonic presence once and for all. They cannot hope to stand against us.','',26124),
(97148,'enUS','For the World Tree! For Val\'sharah!','',26124),
(97149,'enUS','Target acquired!','',26124),
(97150,'enUS','I\'ve got you!','',26124),
(97151,'enUS','Get out!','',26124),
(97152,'enUS','Arthas is healed when the scourge are sacrificed to Frostmourne!','',26124),
(97153,'enUS','','I am relieved to see my brethren safe. The satyr have been defeated, but our fight is only beginning, I\'m afraid.$B$BIf what they said was true, then our vigil within the Emerald Dream must continue, with even greater urgency than before.',26124),
(97154,'enUS','','I saw the signs early, but I was trapped within the dream. If only I had warned them sooner!',26124),
(97155,'enUS','Begone from here, outsider!','',26124),
(97156,'enUS','Over here, champion! Malorne himself has blessed this gazebo\'s flame.','Over here, champion! Malorne himself has blessed this gazebo\'s flame.',26124),
(97157,'enUS','Merely touch the brazier, and you will be fortified for the battles ahead.','Merely touch the brazier, and you will be fortified for the battles ahead.',26124),
(97158,'enUS','Consuming','Consuming',26124),
(97159,'enUS','|TInterface\\Icons\\warlock_curse_shadow_aura:20|t%s begins to cast |cFFFF0000|Hspell:186348|h[Wrath of Gul\'dan]|h|r!','',26124),
(97164,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\LFGFRAME\\LFGICON-SUNWELL.BLP:50:80|t$bBurn to Ashes!','',26124),
(97165,'enUS','I\'ll wager a good amount of gold that she\'ll shoot $n before she shoots her target!','',26124),
(97167,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\LFGFRAME\\LFGICON-SUNWELL.BLP:50:80|t$bYou arrogant insect, you think your pathetic blades will harm me?','',26124),
(97168,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\LFGFRAME\\LFGICON-SUNWELL.BLP:50:80|t$bI do not have time to waste with this distraction. Felguards, cut this one down!','',26124),
(97169,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\LFGFRAME\\LFGICON-SUNWELL.BLP:50:80|t$bThe end has come!','',26124),
(97170,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\LFGFRAME\\LFGICON-SUNWELL.BLP:50:80|t$bEnough! You only delay the inevitable!','',26124),
(97171,'enUS','','Bat Handler Alzyzek calls forth a Screeching Felbat to rally nearby Legion forces!',26124),
(97172,'enUS','','Meddlesome worgen, you should have let the flames take you.',26124),
(97173,'enUS','|TINTERFACE\\ICONS\\TRADE_ENGINEERING.BLP:50|tA plume from Malfurion\'s coat... he may be close. You must continue the search!','',26124),
(97174,'enUS','|TINTERFACE\\ICONS\\TRADE_ENGINEERING.BLP:50|tAnother of Malfurion\'s plumes... and signs of a struggle. We must find him before it is too late!','',26124),
(97175,'enUS','|TINTERFACE\\ICONS\\TRADE_ENGINEERING.BLP:50|tClear signs of a confrontation... but Malfurion is not to be found...','',26124),
(97176,'enUS','','Enjoy your last moments as my venom destroys you from the inside. I delight to know how much you will suffer.',26124),
(97177,'enUS','','Let us leave this place, $c.',26124),
(97178,'enUS','For the Horde!','For the Horde!',26124),
(97179,'enUS','For Honor!','For Honor!',26124),
(97180,'enUS','These lands will not succumb to your kind.','These lands will not succumb to your kind.',26124),
(97181,'enUS','Your presence is not welcome in our lands!','Your presence is not welcome in our lands!',26124),
(97182,'enUS','Dey not gone take dis land from us. Dat be the truth, mon.','Dey not gone take dis land from us. Dat be the truth, mon.',26124),
(97183,'enUS','Maybe dey got de ships, but we got de lands, tools, and we got eacho\'da.','Maybe dey got de ships, but we got de lands, tools, and we got eacho\'da.',26124),
(97184,'enUS','','Ysera is attacking the Temple of Elune!$b$bWe must stop her before the temple is completely destroyed... we don\'t have much time!',26124),
(97185,'enUS','I am ready to begin the defense of the temple!','I am ready to begin the defense of the temple!',26124),
(97186,'enUS','Ain\'t nobody \'fraid o\' dem Legion.','Ain\'t nobody \'fraid o\' dem Legion.',26124),
(97187,'enUS','If dey want war, we gonna bring \'em war.','If dey want war, we gonna bring \'em war.',26124),
(97188,'enUS','Ain\'t nobody gone sit at home durin\' these times. Everybody gonna fight.','Ain\'t nobody gone sit at home durin\' these times. Everybody gonna fight.',26124),
(97189,'enUS','','',26124),
(97190,'enUS','I know, Koru. I sense them too, but worry is for the weak. The Legion will not succeed.','',26124),
(97191,'enUS','We\'ve known these lands for so long...','',26124),
(97192,'enUS','It is good that you arrived when you did. Our walls can\'t take much more of a beating from Greymane\'s cannons.','',26124),
(97193,'enUS','Koru, you must remain calm. These are our lands. Our people... we will not be defeated.','',26124),
(97194,'enUS','Excellent! With the cannons stopped, we can press our advance. \n\nNow we just need to find a way to take out his ship for good...','',26124),
(97195,'enUS','I could feel that explosion from here! \n\nThat Gilnean bastard never knew what hit him!','',26124),
(97196,'enUS','The disturbed tomb, demons here at Black Rook Hold, and the enemy night elves are no coincidence.$B$BThe Legion has resurrected Lord Ravencrest. My former master lives again.','',26124),
(97197,'enUS','|TINTERFACE\\ICONS\\inv_enchant_voidsphere.blp:20|t A Void Star is |cFFF00000|Hspell:189894|h[Fixated]|h|r on you!','|TINTERFACE\\ICONS\\inv_enchant_voidsphere.blp:20|t A Void Star is |cFFF00000|Hspell:189894|h[Fixated]|h|r on you!',26124),
(97198,'enUS','Fun to smash small people.','',26124),
(97199,'enUS','Plainsland Cheetah voraciously defends its kin.','',26124),
(97200,'enUS','You\'ll make a fine fillet.','',26124),
(97201,'enUS','Tiny bait for my hook.','',26124),
(97202,'enUS','Let\'s try the recipe for this \"Draught of Wild Magic\", shall we?','',26124),
(97203,'enUS','Join me over here, $n. I believe we have some of the reagents here on this shelf.','',26124),
(97204,'enUS','Let\'s see here...','',26124),
(97205,'enUS','','WHO DARES TAMPER WITH MY BOOK?',26124),
(97206,'enUS','','ITS SECRETS ARE NOT YOURS TO STEAL, MORTALS!',26124),
(97207,'enUS','','YOU WILL PAY FOR YOUR INSOLENCE! THIS ENTIRE CITY WILL BURN!',26124),
(97208,'enUS','Dalaran is under my protection, vrykul! BEGONE!','',26124),
(97209,'enUS','We\'ll be fine, Archmage, but... look what that wretched creature did to my alchemy table!','',26124),
(97210,'enUS','Our friend $n can help rebuild your precious table, Deucus. Oh, and next time, have more care when handling ancient relics!','',26124),
(97211,'enUS','','ONCE AGAIN YOU STEAL FROM THE VRYKUL, OUTSIDER!',26124),
(97212,'enUS','','MY TOME HOLDS WISDOM GLEANED FROM A THOUSAND LIFETIMES!',26124),
(97213,'enUS','','ATONE FOR YOUR CRIMES! RETURN THE BOOK TO MY PEOPLE!',26124),
(97214,'enUS','','PERSIST IN PLUNDERING ITS SECRETS AND YOUR LIFE SHALL BE FORFEIT!',26124),
(97215,'enUS','Lord of the Seas take you!','',26124),
(97224,'enUS','','So you mean to tell me that not only were you not able to secure the vault, you were unable to even overtake the village?',26124),
(97225,'enUS','','My Dark Lady, the vrykul here have proven more formidable than anticipated.',26124),
(97226,'enUS','','Formidable for you, perhaps. We\'ll see how they fare when confronted by the Banshee Queen!',26124),
(97227,'enUS','','Of course, Dark Lady.',26124),
(97232,'enUS','Sea spray and sand!','',26124),
(97233,'enUS','What\'s that you have there? A shiny weapon?','',26124),
(97234,'enUS','You\'ll make for a fatty meal.','',26124),
(97235,'enUS','Great kraken take you!','',26124),
(97236,'enUS','An offering for the tides.','',26124),
(97237,'enUS','You\'re not from the ship!','',26124),
(97238,'enUS','I\'ll chop you up into chum.','',26124),
(97239,'enUS','Over here! Invaders!','',26124),
(97240,'enUS','','I must commend you on ending that miserable worgen, Greymane. \n\nMy only regret is that I was not there to witness his final throes.',26124),
(97241,'enUS','','I must commend you on ending that miserable worgen, Greymane. \n\nMy only regret is that I was not there to witness his final throes.',26124),
(97242,'enUS','Thankfully I sensed her presence before she could do too much damage. Is anyone hurt?','',26124),
(97243,'enUS','Give us the Banshee Queen!','',26124),
(97244,'enUS','We will have retribution!','',26124),
(97245,'enUS','For Gilneas!','',26124),
(97246,'enUS','For the Alliance!','',26124),
(97247,'enUS','The Horde will pay for their treachery!','',26124),
(97248,'enUS','I\'ll tear you to ribbons!','',26124),
(97249,'enUS','Sylvanas cannot hide from justice!','',26124),
(97250,'enUS','You cannot escape justice...','You cannot escape justice...',26124),
(97251,'enUS','Greymane... avenge me...','',26124),
(97252,'enUS','Gilneas... will rise...','',26124),
(97253,'enUS','Sylvanas will not escape...','',26124),
(97254,'enUS','Savannah Highmane roars ferociously, licks his wounds and surrenders his services.','',26124),
(97255,'enUS','It is good to see you, $n. May the Waywatcher guide your path.','It is good to see you, $n. May the Waywatcher guide your path.',26124),
(97256,'enUS','Is more important tings to do dan sellin\' me goods today, mon.','Is more important tings to do dan sellin\' me goods today, mon.',26124),
(97257,'enUS','Let\'s go make that potion!','Let\'s go make that potion!',26124),
(97264,'enUS','Aaaaaagh! Vengeance for our sisters!','Aaaaaagh! Vengeance for our sisters!',26124),
(97265,'enUS','Don\'t you have a building to build?','Don\'t you have a building to build?',26124),
(97266,'enUS','','Yo! Think I can get that Demolisher outside up and runnin\', if you think it\'s safe!',26124),
(97267,'enUS','I\'ll protect you, Torrix. Get the Demolisher working!','I\'ll protect you, Torrix. Get the Demolisher working!',26124),
(97269,'enUS','','Alright boss, but you better watch my flank!',26124),
(97270,'enUS','Sounding','Sounding',26124),
(97275,'enUS','','I\'m outta here! Good luck savin\' the world, boss!',26124),
(97276,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] Speak, demon. Who dares hunt the Illidari?','',26124),
(97277,'enUS','If you would do the honors, I will stand guard to ensure no one interferes.','',26124),
(97278,'enUS','Meet Taldath, one of the most powerful eredar we\'ve ever encountered. I\'m sure you two will be fast friends.','',26124),
(97279,'enUS','We have what we came for. Finish him!','',26124),
(97280,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] Who is your master? Where is he hiding? SPEAK, DAMN YOU!','',26124),
(97281,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] Well done. The fool told us everything.','',26124),
(97282,'enUS','Help! Sound the alarm! The Sludge Fen rig\'s under attack!','',26124),
(97283,'enUS','We can\'t afford to lose this rig, boys! Break out the bombs!','',26124),
(97284,'enUS','They\'re getting closer! If they destroy the Pressure Control we\'re all gonna have a bad day!','',26124),
(97285,'enUS','Hurry and get up here or this rig\'s a goner! Bombs, bombs, bombs!','',26124),
(97286,'enUS','That was close! I\'ve got somethin\' to help you stick it to these demons up on top of the rig!','',26124),
(97287,'enUS','The finest in Goblin applied sciences. All yours, for savin\' my rig!','',26124),
(97288,'enUS','It\'s gonna blow! Get to safety!','',26124),
(97289,'enUS','You are not worthy! Turn back now or face the might of the Valarjar!','',26124),
(97291,'enUS','But I am not without mercy... You shall live long enough to watch your precious temple be destroyed.','',26124),
(97292,'enUS','<The White Stag returns your gaze, approval in his glowing eyes. His gleaming white fur is so radiant that you have to blink away afterimages.>$b$b<Historically, sightings of Malorne have been rare and fleeting. Clearly your heroic deeds here have earned his favor.>','',26124),
(97293,'enUS','','The Legion will fall.',26124),
(97294,'enUS','Who dares awaken me?','',26124),
(97295,'enUS','Your souls will burn!','',26124),
(97296,'enUS','My flames will consume you!','',26124),
(97298,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-King Ymiron.blp:50:80|t$bYou\'ve lasted longer than most.','',26124),
(97299,'enUS','Thank you, $c.','',26124),
(97300,'enUS','I am confident you are up to the task, $n.','',26124),
(97301,'enUS','','Commander, if you wish to continue the fight, the other battlefields throughout Tanaan are now ripe for conquest.',26124),
(97302,'enUS','','We have the momentum, commander. You should assault the other battlefields throughout the jungle.',26124),
(97303,'enUS','','Another glorious victory! If your blood still runs hot, know that the rest of Tanaan\'s battlefields are ripe for the plucking...',26124),
(97304,'enUS','','We should keep up the pressure, commander. The other hotspots throughout Tanaan are now vulnerable to attack.',26124),
(97305,'enUS','The Nightmare encroaches.','',26124),
(97306,'enUS','For Moonclaw Vale!','',26124),
(97307,'enUS','','Another triumph for the Alliance! You should press our advantage and attack one of the other Tanaan hotspots.',26124),
(97308,'enUS','','Well done, commander. Rangari scouts report that the other battlefields throughout Tanaan are now vulnerable.',26124),
(97309,'enUS','','You\'ve got Gul\'dan\'s minions scrambling, commander. Consider attacking some of the other Tanaan battlefields while they are on the run.',26124),
(97310,'enUS','','Keep up the good fight, commander! There are other hotspots throughout Tanaan that are now vulnerable to attack.',26124),
(97311,'enUS','Defeat the demons that threaten the the Halls of Valor and Odyn will surely let you compete in the final trial for the Aegis of Aggramar.','',26124),
(97313,'enUS','','I\'m telling you, Alistair, I don\'t like this one bit. Don\'t you remember the Scourge uprising back in Gilneas?',26124),
(97314,'enUS','I will never forget that horror. If it comes to that, we\'ll build another ship. We started over once, and we can do it again.','',26124),
(97316,'enUS','Yes!','Yes!',26124),
(97319,'enUS','I told Eitrigg not to worry, but I am impressed nonetheless. A powerful artifact obtained and a major demon lord slain!','',26124),
(97320,'enUS','','Fools. This mountain is ours!',26124),
(97321,'enUS','','For High Crawliac!',26124),
(97322,'enUS','','You cannot stand against the might of our covens.',26124),
(97323,'enUS','','Your corpse shall feed my young.',26124),
(97324,'enUS','','I will make such lovely spells from your bones.',26124),
(97325,'enUS','','Crawliac descends upon you all!',26124),
(97326,'enUS','','I have a new spell just for you.',26124),
(97327,'enUS','','The skies belong to the Crawliac!',26124),
(97328,'enUS','Zephyrus is a great spirit, and not easily tamed. Even if we win today, my people will need more reasons to follow you than some artifact from beyond the sea. This may prove the symbol they need to see you as a leader.','',26124),
(97329,'enUS','The rest of the way you must go alone. Follow this path up until you find the Skyhorn. If you live, I shall join you in the skies over Highmountain!','',26124),
(97330,'enUS','Who calls me?','',26124),
(97331,'enUS','Come, mortal, let us see what you are made of.','',26124),
(97332,'enUS','<Placeholder Event: High Crawliac attacks, stealing Zephyrus and leaving the player at this upcoming position>','',26124),
(97333,'enUS','','The Skyhorn are not the only ones to suffer at the hands of the harpies. \n\nThe wildlife native to these mountains are plagued by the witches\' cruelty and chaos, and without Morashu to guide their spirits, they will never know peace.',26124),
(97334,'enUS','Tell me more about Morashu.','Tell me more about Morashu.',26124),
(97335,'enUS','You are welcome to anything of value you find on its corpse.','',26124),
(97336,'enUS','Thank you! I never thought to see a demon here in Val\'sharah.','',26124),
(97337,'enUS','','Morashu has lingered in these mountains as long as any tribe. His presence is needed to carry out the cycle of life and death that keeps nature in balance.\n\nIt is said that Morashu guides the spirits of animals when they meet their end. He is with them when the light leaves their eyes, and leads them down a path where their spirits may rejoin nature.',26124),
(97338,'enUS','','Genn is resting.$B$BWe should focus on making contact with the fleet and getting to a fortified position.',26124),
(97339,'enUS','Who are you?','Who are you?',26124),
(97340,'enUS','What\'s happening here?','What\'s happening here?',26124),
(97341,'enUS','Have our paths crossed before, hero?$B$BI once commanded the night elf forces who defended this land from the Burning Legion, ten thousand years ago.$B$BMy sister is the warden named Maiev, and it is because of her that my path leads here.','',26124),
(97342,'enUS','My people have seen too much suffering. It was the Scourge uprising that led us to flee Gilneas many years ago.$B$BNow, undead creatures have risen from the fortress to the north.$B$BI will defend this village to the bitter end.','',26124),
(97343,'enUS','','Look, it\'s $n! I told you $Ghe:she; was going to be the one chosen. Now, pay up!',26124),
(97344,'enUS','Hurry up, Minerva! We\'re about to pull out of here. Mograine will kill us if we hold things up!','',26124),
(97345,'enUS','One of Amal\'thazad\'s students? Bah! Fine, take your gold.','',26124),
(97346,'enUS','Ah, a fellow miner! Mama must have sent you to help me study the forest here. Or perhaps to relieve me of her son, I pray?','',26124),
(97347,'enUS','Yes yes, Diarmad, the dragons are nice, just don\'t bother them or me right no...','',26124),
(97348,'enUS','Mama Diggs sent me to collect your mineral analysis report.','Mama Diggs sent me to collect your mineral analysis report.',26124),
(97349,'enUS','Ahhhhhhh!','Ahhhhhhh!',26124),
(97352,'enUS','','We\'re already dead, idiot!',26124),
(97353,'enUS','Looks like we\'re not wanted, Minerva. I guess we\'ll just guard the entrance then.','',26124),
(97354,'enUS','Gryphon Riders! To me!','',26124),
(97355,'enUS','Riders! Circle back. Turn this ship to splinters!','',26124),
(97356,'enUS','Concentrate fire on the Blightcaller!','',26124),
(97357,'enUS','Lord Shadowsong, I was wrong about you. Everyone, put down your arms!','',26124),
(97358,'enUS','Ah, here ya go $Glad:lass;! Could ye let Mama know I\'m running low on picks down here when ye see her again?','',26124),
(97359,'enUS','$n, thank you for finding my daughter. Please, you are most welcome here.','',26124),
(97360,'enUS','There\'s really nothing more I can teach the boy. I wish Mama would send for him already.','',26124),
(97361,'enUS','I need another set of Destroyer blueprints.','I need another set of Destroyer blueprints.',26124),
(97363,'enUS','Looks like you lost one of our naval blueprints?  I can help you out with that!','',26124),
(97364,'enUS','I need another set of Blast Furnace blueprints.','I need another set of Blast Furnace blueprints.',26124),
(97365,'enUS','Looks like you lost one of our naval equipment blueprints?  I can help you out with that!','',26124),
(97366,'enUS','|TINTERFACE\\ICONS\\inv_ammo_bullet_04:20|t |cFFFF0404|Hspell:190249|h[Explosive Rounds]|h|r on you! Close to melee range to disrupt the Huntress.','|TINTERFACE\\ICONS\\inv_ammo_bullet_04:20|t |cFFFF0404|Hspell:190249|h[Explosive Rounds]|h|r on you! Close to melee range to disrupt the Huntress.',26124),
(97367,'enUS','','$GHe\'s:She\'s; waking up!',26124),
(97368,'enUS','A true $c, $n. I admire your bravery. Please don\'t think less of me. I\'ll be when it\'s safe.','A true $c, $n. I admire your bravery. Please don\'t think less of me. I\'ll be when it\'s safe.',26124),
(97369,'enUS','Thanks for the words, $n. I wish I could stay, but I\'ll return when it\'s a bit safer around these parts.','Thanks for the words, $n. I wish I could stay, but I\'ll return when it\'s a bit safer around these parts.',26124),
(97370,'enUS','Apologies, $n. It\'s not that I\'m afraid. I\'m just no good in battle.','Apologies, $n. It\'s not that I\'m afraid. I\'m just no good in battle.',26124),
(97371,'enUS','','Good. Can $Ghe:she; fight?',26124),
(97372,'enUS','I\'ll be back when it\'s all over.','I\'ll be back when it\'s all over.',26124),
(97373,'enUS','I understand what you\'re saying, but I just don\'t have it in me to fight, $n.','I understand what you\'re saying, but I just don\'t have it in me to fight, $n.',26124),
(97374,'enUS','Do you crave death, elf? Do you dare face my lord\'s wrath alone?','',26124),
(97375,'enUS','If you are ready to depart, Aviash can fly you to Thunder Totem.','',26124),
(97376,'enUS','I am through with this charade! Your soul will feed the Twinblades.','',26124),
(97377,'enUS','Mama Diggs sent me to collect your obsidian analysis report.','Mama Diggs sent me to collect your obsidian analysis report.',26124),
(97378,'enUS','','W-w-where is everyone?',26124),
(97379,'enUS','It\'s safe now.','It\'s safe now.',26124),
(97380,'enUS','This oil is promising! Gather all the fish you can carry! Melt their bones!','',26124),
(97381,'enUS','I will have it all! No fish left behind!','',26124),
(97382,'enUS','Goblin cowards! GET LOST!','',26124),
(97383,'enUS','Here\'s everything I\'ve been able to gather from the obsidian here. Hopefully there\'s something in it that can help with your venture.','',26124),
(97384,'enUS','If you don\'t mind, I\'m rather busy right now.','',26124),
(97385,'enUS','The mineral composition of this stone is amazing... err... who are you?','',26124),
(97386,'enUS','Any word on those picks? I\'m down to me last one.','',26124),
(97387,'enUS','My blade will bathe in Legion blood before this fight is over.','',26124),
(97388,'enUS','DNT','',26124),
(97389,'enUS','Despite what they say, these people need help. Defend their farms, and we will ease their suspicions.','',26124),
(97390,'enUS','Is time actually money? Or is it, in fact, a more abstract concept?','',26124),
(97391,'enUS','Oh my god! There\'s another one and it\'s even bigger than the last one!','',26124),
(97392,'enUS','Rhol! Look! Look at them all! Rhol? Rhol? Rhol?!','',26124),
(97393,'enUS','This is the best trip ever! I\'m never gonna leave!','',26124),
(97394,'enUS','These children... The innocent need not die here on the field of battle.$B$BIf you are brave enough, I could use a hand escorting them to safety.','',26124),
(97396,'enUS','I will help escort the children to safety!','I will help escort the children to safety!',26124),
(97397,'enUS','','I will tear your pitiful worgen apart, Greymane!',26124),
(97398,'enUS','','You will pay for your interference!',26124),
(97399,'enUS','Very well. Stay close.','',26124),
(97400,'enUS','','Death awaits you all!',26124),
(97401,'enUS','','Your life ends here, dog!',26124),
(97402,'enUS','','Enough!',26124),
(97403,'enUS','On your toes, $n! Our defenses are under constant attack from the Legion.$B$BYou can stay and find what comfort there is left, but remember - if you fight, you fight in the name of the Warchief.','',26124),
(97404,'enUS','Storm the vault! For Gilneas!','',26124),
(97405,'enUS','Can\'t... control...','',26124),
(97406,'enUS','Come, Sylvanas! Face the beast you have unleashed!','',26124),
(97407,'enUS','There is plenty of room in my cage for your souls.','',26124),
(97408,'enUS','You are no match for us, landwalker.','',26124),
(97409,'enUS','Die, landwalker!','',26124),
(97410,'enUS','The sea will claim your corpse.','',26124),
(97411,'enUS','','For Nazjatar!',26124),
(97412,'enUS','','My voice will be the last thing you hear.',26124),
(97413,'enUS','Don\'t mistake me for these weak-minded fools. I\'m here on orders.','',26124),
(97414,'enUS','Mama Diggs sent me to collect your saronite composition report.','Mama Diggs sent me to collect your saronite composition report.',26124),
(97415,'enUS','','Die, landwalker!',26124),
(97416,'enUS','','The tide turns.',26124),
(97417,'enUS','What do you want? Who sent you?! Are you the one who\'s been whispering to me?','',26124),
(97418,'enUS','Oh, right. Here\'s everything I\'ve learned so far. There\'s... something... something inside the ore that speaks to you.','',26124),
(97419,'enUS','I need to get out of here before I become a mindless slave like these wretches.','',26124),
(97420,'enUS','|TINTERFACE\\ICONS\\TRADE_ENGINEERING.BLP:50|tSo long as the worldseed sapling survives, I will be able to aid you in your search for Malfurion.','',26124),
(97421,'enUS','Fresh tuning comin\' right up, boss!','',26124),
(97422,'enUS','Oilin\' her up!','',26124),
(97423,'enUS','I\'ll fix that hitch for ya.','',26124),
(97424,'enUS','Hmm... agh. Yep! That\'ll do it. Good to go!','',26124),
(97425,'enUS','','Gag, you\'re a sweetheart for checkin\' on me, but today is not the day, hon. We got demons to take care of!',26124),
(97426,'enUS','Enter, $n, there is much to be done.','',26124),
(97427,'enUS','Hey Liv. You doin\' okay over here?','',26124),
(97428,'enUS','If you need anything, you know where I\'ll be.','',26124),
(97429,'enUS','Argent Crusade - CHARGE!','',26124),
(97430,'enUS','Such arrogance... must be punished.','',26124),
(97431,'enUS','I get it, but I just don\'t have it in me to fight.','I get it, but I just don\'t have it in me to fight.',26124),
(97432,'enUS','','All\'s clear over here, Gaz!',26124),
(97433,'enUS','An in-game event fires at this point.','An in-game event fires at this point.',26124),
(97434,'enUS','Saddle up, boys! We\'re ridin\' this one out!','',26124),
(97435,'enUS','Shredder\'s all banged up. I\'m gonna need a new one with a little more oomph!','',26124),
(97436,'enUS','What\'re they always shootin\' at me for? I\'m just a goblin in a gigantic metal suit with rockets.','',26124),
(97437,'enUS','Baelgun\'s soul was cursed to relive the moment of his death for eternity and will see you as his enemy. Destroy him.','',26124),
(97439,'enUS','Throw the |cFFFF0000|Hspell:179202|h[Eye of Anzu]|h|r to a Healer to dispel |cFFFF0000|Hspell:181753|h[Fel Bomb]|h|r.','',26124),
(97440,'enUS','Throw the |cFFFF0000|Hspell:179202|h[Eye of Anzu]|h|r to a someone affected by |cFFFF0000|Hspell:181957|h[Phantasmal Winds]|h|r.','',26124),
(97441,'enUS','Throw the |cFFFF0000|Hspell:179202|h[Eye of Anzu]|h|r to Tank affected by |cFFFF0000|Hspell:181824|h[Phantasmal Corruption]|h|r.','',26124),
(97442,'enUS','The soul of Halahk was tortured within Frostmourne till he cursed the Light. Now that he has forsaken it, slay him.','',26124),
(97443,'enUS','Even when consumed by Frostmourne, the soul of Magroth refused to give up the Light. Show him the error of his ways.','',26124),
(97444,'enUS','Scorch the earth behind us. I must finish breaking our... guest.','',26124),
(97445,'enUS','Once hailed by Arthas as a brother, Gavinrad too was ultimately fed to Frostmourne. Grant him a final death.','',26124),
(97446,'enUS','','The drogbar here were at peace with us. Some were even friendly. What their Underking did to turn them against us, I do not know.',26124),
(97447,'enUS','Aaaaaaah!','',26124),
(97448,'enUS','Without the fish the Rivermane supply, our mountain would soon starve.','',26124),
(97449,'enUS','','Though some of the other Highmountain look down on us for our peaceful way of life, we provide them with most of their food and heal the wounds of battle.\n\nThose calves need to show some respect for their elders.',26124),
(97450,'enUS','They no take treasure. I watch. I wait. I see them coming.','',26124),
(97451,'enUS','Infernals! Crush them!','',26124),
(97452,'enUS','You no take treasure!','',26124),
(97453,'enUS','Take me the northern Illidari camp!','Take me the northern Illidari camp!',26124),
(97454,'enUS','Take me the main Illidari camp!','Take me the main Illidari camp!',26124),
(97455,'enUS','This location, adventurer, provides you the opportunity to survive in times like these.$B$BDo not be alarmed by the riders in the skies. They merely provide safe keeping and will do no harm to you, unless, of course, it is provoked.','',26124),
(97456,'enUS','We take the fight to Gul\'dan. We finish it here!','',26124),
(97457,'enUS','Vol\'jin sent me to support your Tanaan campaign, commander. We shadow hunters be callin\' out the targets for you.','',26124),
(97458,'enUS','We kill \'em here, commander. Every demon we slay in Tanaan is one less we deal with in Azeroth.','',26124),
(97459,'enUS','Take me the main Illidari camp!','Take me the main Illidari camp!',26124),
(97460,'enUS','Take me the eastern Illidari camp!','Take me the eastern Illidari camp!',26124),
(97461,'enUS','Champion, we must persevere!','',26124),
(97462,'enUS','We move on our champion\'s command.','',26124),
(97463,'enUS','The fiends have Tirion! We have to act quickly.','',26124),
(97464,'enUS','Champion, I\'ll signal for our hippogryph riders to get our fallen to Light\'s Hope Chapel. You must forge ahead and find the Highlord!','',26124),
(97466,'enUS','Take me the southern Illidari camp!','Take me the southern Illidari camp!',26124),
(97467,'enUS','A raven flies up and hovers expectantly. It has a message!','',26124),
(97468,'enUS','','You are needed at Greywatch, $Gsir:ma\'am;.$B$BWhenever you\'re ready.',26124),
(97469,'enUS','Take me to Greywatch.','Take me to Greywatch.',26124),
(97470,'enUS','','Nathanos has requested your presence in Dreadwake\'s Landing.$B$BReady to go?',26124),
(97471,'enUS','Take me to Dreadwake\'s Landing.','Take me to Dreadwake\'s Landing.',26124),
(97472,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-King Ymiron.blp:50:80|t$bYour stamina is impressive... but I am just getting started!','',26124),
(97474,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-King Ymiron.blp:50:80|t$bSo you can fight off a few lesser warriors. Its time to face a real foe!','',26124),
(97475,'enUS','Oh no... where is it? The Potion of Bubbling Pustules! ... you didn\'t drink it, did you?','',26124),
(97476,'enUS','It wasn\'t quite ready yet, so if you start to feel woozy just breath deeply. You may or may not keel over suddenly.','',26124),
(97477,'enUS','The Nightmare will consume you!','',26124),
(97478,'enUS','None can stand against the Nightmare Lord!','',26124),
(97479,'enUS','Pathetic creature! This curse has made me stronger than the ancients!','',26124),
(97480,'enUS','Sir, I\'ll have to excuse myself until these happenings are at an end.','',26124),
(97481,'enUS','','I... I was too late...',26124),
(97482,'enUS','','Moonclaw... No...',26124),
(97483,'enUS','','We are lost without Thaon.',26124),
(97484,'enUS','','<Aylea sobs uncontrollably.>$B$BI do not know what will do without Thaon Moonclaw by our side.',26124),
(97485,'enUS','Well, that was certainly unexpected.','',26124),
(97488,'enUS','You will not escape me this time, betrayer!','',26124),
(97489,'enUS','Find me when Kagraxxis has been slain! I sense an even darker presence here...','',26124),
(97490,'enUS','I will protect Val\'sharah with my life!','',26124),
(97491,'enUS','Begone from my lands!','',26124),
(97492,'enUS','Yes... harvest it all. Every last bit.','',26124),
(97493,'enUS','Our turn! We not lose this time we hope.','',26124),
(97494,'enUS','Time to face da pretty one, little thing!','',26124),
(97495,'enUS','You think you take our belt? We are champion!','',26124),
(97496,'enUS','\"Karkun\"','\"Karkun\"',26124),
(97497,'enUS','\"Danashj\"','\"Danashj\"',26124),
(97498,'enUS','\"Belan\"','\"Belan\"',26124),
(97499,'enUS','\"Rukadare\"','\"Rukadare\"',26124),
(97500,'enUS','\"Ticharamir\"','\"Ticharamir\"',26124),
(97501,'enUS','\"Veni\"','\"Veni\"',26124),
(97502,'enUS','\"Maez\"','\"Maez\"',26124),
(97503,'enUS','\"Parnus\"','\"Parnus\"',26124),
(97504,'enUS','\"Maladath\"','\"Maladath\"',26124),
(97505,'enUS','Enchant shoulder armor.','Enchant shoulder armor.',26124),
(97506,'enUS','Enchant gloves.','Enchant gloves.',26124),
(97507,'enUS','Enchant gloves.','Enchant gloves.',26124),
(97508,'enUS','Enchant boots.','Enchant boots.',26124),
(97509,'enUS','Let\'s attempt to assemble a demonic enchant.','Let\'s attempt to assemble a demonic enchant.',26124),
(97515,'enUS','','Karkun...',26124),
(97516,'enUS','','Danashj...',26124),
(97517,'enUS','','Belan...',26124),
(97518,'enUS','','Rukadare...',26124),
(97520,'enUS','','Ticharamir...',26124),
(97522,'enUS','','Veni...',26124),
(97523,'enUS','','Maez!',26124),
(97524,'enUS','','Parnus!',26124),
(97525,'enUS','','Maladath!',26124),
(97526,'enUS','At the end of their life, a vrykul\'s worth is determined by the great rulers of their people.','',26124),
(97527,'enUS','If you wish to claim the Aegis, seek these ancient rulers and prove to them your merit.','',26124),
(97528,'enUS','Only those deemed worthy shall pass the Trial of Valor.','',26124),
(97529,'enUS','Be careful. I saw a few wyrmtongue roaming about.','',26124),
(97530,'enUS','The Legion is here! Get out of here!','',26124),
(97531,'enUS','I don\'t remember what happened, but the Legion...','',26124),
(97532,'enUS','Those spiders were vicious before, but now... well, you\'ll see.','',26124),
(97533,'enUS','They\'re controlling them! The spiders... Get me outta here!','',26124),
(97534,'enUS','','|cFFFF0000%s|r begins to cast |cFFFF0000|Hspell:192754|h[Nightmare Breath]|h|r!',26124),
(97535,'enUS','Hero, free us from this curse!','Hero, free us from this curse!',26124),
(97536,'enUS','It is done. From the shards of Frostmourne the twin blades are born! Soon, they shall feed upon the souls of my enemies!','',26124),
(97537,'enUS','I sense powerful spirits remain within the blades. Enter into the spiritual realm within and purge them of all that resist your domination!','',26124),
(97543,'enUS','','Yeah, I\'m getting a good feeling about ... that... spot over there...',26124),
(97544,'enUS','Don\'t you have a building to build?','Drill baby drill!',26124),
(97545,'enUS','Don\'t you have a building to build?','Hey commander, can I interest you in an investment plan that moves some of your assets offshore? Literally offshore, I know a guy that wants to build an oil rig.',26124),
(97546,'enUS','','I just want to say one word to you. Just one word. Are you listening? Oil.',26124),
(97547,'enUS','','Commander! Any good premonitions lately?',26124),
(97548,'enUS','','Oh boy I just know we\'re going to strike it rich next time!',26124),
(97549,'enUS','','Do you think that those fel-powered machines the Iron Horde are using still need lubricants?',26124),
(97550,'enUS','|TInterface\\Icons\\Spell_Fire_FelRainOfFire.blp:20|t %s begins to cast |cFFF00000|Hspell:185284|h[Barrage]|h|r!','|TInterface\\Icons\\Spell_Fire_FelRainOfFire.blp:20|t %s begins to cast |cFFF00000|Hspell:185284|h[Barrage]|h|r!',26124),
(97551,'enUS','You have done well. Ascend to my throne and receive your charge.','',26124),
(97552,'enUS','Where the weak showed mercy, you did not hesitate to strike. Where the unworthy were vanquished, you have conquered.','',26124),
(97553,'enUS','As we speak the Ebon Blade is en route to the Broken Isles to hunt for the Dreadlords.','',26124),
(97554,'enUS','Accessing Record','Accessing Record',26124),
(97555,'enUS','Nothing will stand in the way of my vengeance!','',26124),
(97556,'enUS','I see... only darkness... before me.','',26124),
(97557,'enUS','Powering up archive device...','',26124),
(97558,'enUS','Archive device activated. The record is now accessible.','',26124),
(97559,'enUS','You cannot win, mortal.','',26124),
(97560,'enUS','Skovald has tasted the Legion\'s power. He will claim the Aegis and grant its power to us!','',26124),
(97561,'enUS','This land will be ours!','',26124),
(97562,'enUS','In the name of the Prophet, we must cleanse this land.','',26124),
(97563,'enUS','There is much to be done and little time. Our ancient enemies have found us. If we do not reclaim Tanaan... all is lost.','',26124),
(97564,'enUS','We have been running for too long. Always running. No more! We made this world our home, and we will fight to the last to preserve it.','',26124),
(97565,'enUS','Master, I have failed you...','',26124),
(97566,'enUS','I underestimated your strength...','',26124),
(97567,'enUS','','Forgive me, Lord Ravencrest. I... failed you...',26124),
(97568,'enUS','I must... alert... the others...','',26124),
(97601,'enUS','The outsider must not learn of the trials!','',26124),
(97602,'enUS','You are unworthy of this place!','',26124),
(97603,'enUS','','The God-King will have your head!',26124),
(97604,'enUS','The Thorignir are the oldest and wisest dragons in Stormheim.','',26124),
(97605,'enUS','To fly with them is to sail amongst the gods themselves.','',26124),
(97606,'enUS','Seek their blessing to pass the Trial of Will.','',26124),
(97607,'enUS','You are proving an invaluable ally in my efforts, $n. How may I help you?','',26124),
(97608,'enUS','Commander Thalanor, patrol reporting in!','Commander Thalanor, patrol reporting in!',26124),
(97609,'enUS','My blood... it burns! The fel energy... I can\'t.... control it... AAAAUUUGGGGHHH!','',26124),
(97610,'enUS','The demons control Black Rook Hold. You must... stop them...','',26124),
(97611,'enUS','You mortals are so vain... so arrogant. You will suffer for your hubris.','',26124),
(97612,'enUS','','What? How? The whole time?!',26124),
(97613,'enUS','The sundering of this one\'s soul has been... taxing. But he will be ours soon.','',26124),
(97614,'enUS','','[Placeholder] I will be honest, the battles have not been going well. While our troops are powerful and well trained, they are not as familiar with war.',26124),
(97615,'enUS','','[Placeholder] My time is short, Spiritwalker. Explain why you have summoned me.',26124),
(97616,'enUS','Archive device power at 50 percent...','',26124),
(97617,'enUS','Archive device power at 75 percent...','',26124),
(97618,'enUS','$p... save... the Ashbringer...','',26124),
(97619,'enUS','Leave me... hurry, before more come...','',26124),
(97620,'enUS','Lady Ysera, thank you for answering our call. We face a dire threat!','',26124),
(97621,'enUS','','No need to explain, Malfurion. I have seen what is coming.',26124),
(97622,'enUS','','The Emerald Dream is being overtaken by the Nightmare. The Legion and the satyr Xavius are to blame.',26124),
(97623,'enUS','','Shaladrassil, the World Tree, has fallen to the Nightmare\'s corruption and spreads its curse across our precious land.',26124),
(97624,'enUS','','The Nightmare Lord must be vanquished, or Val\'sharah is lost.',26124),
(97625,'enUS','The Tears of Elune, stolen by Xavius! Then our champion\'s efforts were for nothing?','',26124),
(97626,'enUS','','On the contrary, the temple was saved, and there is still time to recover the Tears.',26124),
(97627,'enUS','Time we do not have. The temple was saved, but Cenarius was lost to the Nightmare.','',26124),
(97628,'enUS','','Calm yourself, Malfurion. You have not seen the terrible power Xavius now possesses.',26124),
(97629,'enUS','I have wasted too much time here. No more!','',26124),
(97630,'enUS','','Cenarius\'s loss has left Malfurion unable to see reason.',26124),
(97631,'enUS','','Make haste to the World Tree. He may be headed there, all too ready to take reckless risks.',26124),
(97632,'enUS','','Meanwhile, you and I will follow his trail from here. Malfurion must not fall.',26124),
(97633,'enUS','Insignificant gnat. I will enjoy breaking you.','',26124),
(97634,'enUS','It\'s so good to fight again.','',26124),
(97635,'enUS','Activating sequence: Trial of Might...','',26124),
(97636,'enUS','I hope you are ready to face your first trial, outsider.','',26124),
(97637,'enUS','As the keeper of this vault, it is my duty to test the might of those who wish to proceed.','',26124),
(97638,'enUS','Prepare yourself!','',26124),
(97639,'enUS','Death is weakness leaving the universe.','',26124),
(97640,'enUS','More power for my blades.','',26124),
(97641,'enUS','My blades hunger.','',26124),
(97642,'enUS','I will cast you all aside...','',26124),
(97643,'enUS','... and I will unleash my fury upon you all!','',26124),
(97644,'enUS','My hatred flows through me.','',26124),
(97646,'enUS','Play with fire and you\'ll get burned.','',26124),
(97647,'enUS','I need no blade to defeat you.','',26124),
(97648,'enUS','My powers wane, I must have more!','',26124),
(97649,'enUS','Anger, hate, rage! These will fuel me with the power I crave!','',26124),
(97650,'enUS','My power.. Wasn\'t enough?','',26124),
(97651,'enUS','I cannot be stopped.','',26124),
(97655,'enUS','So ... long ... where is my Lord of Fire, why does he not answer my call?','',26124),
(97656,'enUS','The fire consumes all.','',26124),
(97657,'enUS','More fuel for our fire.','',26124),
(97658,'enUS','Your flesh will know the sweet caress of fire.','',26124),
(97659,'enUS','Your bones will blacken, your life extinguished.','',26124),
(97660,'enUS','We give rise to flame.','',26124),
(97661,'enUS','Fire has a life of its own.','',26124),
(97662,'enUS','We will make ashes of you all!','',26124),
(97663,'enUS','Flame! Death!','',26124),
(97664,'enUS','So... C.. Cold.','',26124),
(97665,'enUS','You cannot contain these flames!','',26124),
(97667,'enUS','I am... Extinguished.','',26124),
(97668,'enUS','I will burn this prison to the ground!','',26124),
(97672,'enUS','Visitors? How exciting!','',26124),
(97673,'enUS','Didn\'t see that one coming did you?','',26124),
(97674,'enUS','You can watch from the floor.','',26124),
(97675,'enUS','Follow the bouncing ball.','',26124),
(97676,'enUS','Watch your step!','',26124),
(97677,'enUS','Time to focus.','',26124),
(97681,'enUS','Look into my eye.','',26124),
(97682,'enUS','Curse the wardens and their mirrors.','',26124),
(97683,'enUS','That didn\'t look that close...','',26124),
(97684,'enUS','If only I could see the future...','',26124),
(97685,'enUS','I look forward to my next set of guests.','',26124),
(97689,'enUS','','So be it. I will slay you all.',26124),
(97690,'enUS','','You should know better than to challenge a warden.',26124),
(97691,'enUS','','Death embraces you, perhaps not for the first time?',26124),
(97692,'enUS','','The best prison needs no walls.',26124),
(97693,'enUS','','A warden\'s glaive can pierce the toughest armor.',26124),
(97694,'enUS','','Yeeeah!',26124),
(97695,'enUS','','Your downfall is inevitable.',26124),
(97696,'enUS','','Watch your step! It\'s a long way down.',26124),
(97698,'enUS','','Vengeance will be mine!',26124),
(97699,'enUS','','All night elf children learn to love the dark.',26124),
(97700,'enUS','','My powers have grown since joining the Legion. Here, let me show you.',26124),
(97701,'enUS','','I will not be stopped! I have fought too long, suffered too much. Victory must be mine!',26124),
(97702,'enUS','','Beaten? How! You are... nothing',26124),
(97703,'enUS','','Your death was inevitable.',26124),
(97704,'enUS','','How utterly predictable! Maiev is nothing if not persistent.',26124),
(97705,'enUS','','I knew she had that artifact secreted away after the events at the Black Temple.',26124),
(97706,'enUS','','And now you fools have brought me the key. I\'ll thank you to hand it over... willingly or otherwise.',26124),
(97707,'enUS','Ooohh... New subjects.','',26124),
(97708,'enUS','A pity.','',26124),
(97709,'enUS','Death becomes you.','',26124),
(97710,'enUS','Let\'s see what\'s behind door number...','',26124),
(97711,'enUS','Your souls are mine.','',26124),
(97712,'enUS','How terribly disappointing.','',26124),
(97713,'enUS','Playtime has ended.','',26124),
(97714,'enUS','','You have brought my armor and glaive...',26124),
(97715,'enUS','Trial of Might sequence concluded.','',26124),
(97716,'enUS','That is enough, outsider...','',26124),
(97717,'enUS','Unbelievable! Decades of waiting without a worthy challenger, only to be beaten twice in the same day!','',26124),
(97718,'enUS','You have passed the Trial of Might, outsider. Seek me at the vault\'s entrance, and I will grant you the blessing of the Watchers.','',26124),
(97719,'enUS','The mortal approaches the Ashbringer. To arms!','',26124),
(97722,'enUS','','We have failed... Lord Balna...',26124),
(97723,'enUS','Glaive Throwers cannot withstand the terrain outside of the Ravencourt. Return immediately or you will be ejected.','',26124),
(97724,'enUS','','Destroy them! Leave nothing but ash!',26124),
(97727,'enUS','','Squaaak! I\'ll tear you apart!',26124),
(97728,'enUS','','Rip the flesh from its bones!',26124),
(97729,'enUS','','A prize for the Witchmother!',26124),
(97730,'enUS','','Squaaak! You\'ll regret this!',26124),
(97731,'enUS','','Shred its flesh! Scraaawk!',26124),
(97732,'enUS','','I\'ll enjoy killing you!',26124),
(97733,'enUS','','Scraaawk! Make it bleed!',26124),
(97734,'enUS','','None shall survive!',26124),
(97735,'enUS','','Craaawwkk!',26124),
(97736,'enUS','','Sisters! Avenge me...',26124),
(97737,'enUS','','No... Squaaggk!',26124),
(97738,'enUS','','Curses upon you!',26124),
(97739,'enUS','','Coward! You\'ll pay for this...',26124),
(97740,'enUS','','No! NO! Craaawwkk...',26124),
(97741,'enUS','','The village is... ours...',26124),
(97742,'enUS','','OH GOD, WHAT IS THAT THING?! Someone, help! Please! It\'s tearing my room apart!',26124),
(97743,'enUS','It\'s in here! I know it!','',26124),
(97744,'enUS','Why won\'t this blasted cabinet open up!!','',26124),
(97745,'enUS','Just a taste, that\'s all I need! Just, one... little... TASTE!','',26124),
(97746,'enUS','Nothing will save you from our master!','',26124),
(97747,'enUS','I will awaken the darkness inside you!','',26124),
(97748,'enUS','You\'ll beg for death when I\'m done with you!','',26124),
(97749,'enUS','Get away from me!','',26124),
(97750,'enUS','Let me see your entrails!','',26124),
(97751,'enUS','These potions are just delightful...','',26124),
(97752,'enUS','Your moon goddess has no power here!','',26124),
(97753,'enUS','Fool! This land is already ours!','',26124),
(97754,'enUS','You are too late... this land is ours!','',26124),
(97755,'enUS','Our master will burn this world... and you with it!','',26124),
(97756,'enUS','Terror is all that awaits... you...','',26124),
(97757,'enUS','Raaarrgh...','',26124),
(97758,'enUS','Mine are not the only hands... stained in blood...','',26124),
(97759,'enUS','Death will not... stop us...','',26124),
(97760,'enUS','Give up! There is no hope for this world...','',26124),
(97761,'enUS','Your world is... doomed...','',26124),
(97762,'enUS','','Illidari $n, I present the Coilskar.',26124),
(97763,'enUS','','Lord Illidan sends his best wishes for a speedy success.',26124),
(97764,'enUS','','I assume the foothold has been established?',26124),
(97765,'enUS','','Lovely... another fel volcano.',26124),
(97766,'enUS','The crystal pulses faintly, but fails to locate any nearby prey....','The crystal pulses faintly, but fails to locate any nearby prey.....',26124),
(97767,'enUS','Master...','',26124),
(97768,'enUS','I was a fool to resist the call of Xavius.. behold my power!','',26124),
(97769,'enUS','Val\'sharah will... perish!','',26124),
(97770,'enUS','Insects! I will stomp you into the ground!','',26124),
(97771,'enUS','GRRGHH... My leaves... have fallen...','',26124),
(97772,'enUS','So, you think yourself a hunter, using that little toy to lead you around? Let me show you true strength....','',26124),
(97773,'enUS','The shadows.... Everywhere....','',26124),
(97774,'enUS','What?! Oh, it\'s you, $n. I was just looking for something. My apologies. I\'ll return to the shop immediately.','',26124),
(97777,'enUS','None may challenge the Brotherhood!','None may challenge the Brotherhood!',26124),
(97778,'enUS','Lap dogs, all of you!','Lap dogs, all of you!',26124),
(97779,'enUS','Socrethar summons aid from portals around the room!','Socrethar summons aid from portals around the room!',26124),
(97782,'enUS','I apologize for the ruse, but I did not wish to reveal my identity in front of a tribe of known dragonslayers.$b$bI don\'t think they would approve of the real reason I am here.$b$bChampion, do you stand ready to assist me? I shall make it worth your while.','',26124),
(97783,'enUS','Ready.','Ready.',26124),
(97784,'enUS','Very well, champion. Stay close.','',26124),
(97785,'enUS','Be on your guard. I have no doubt Deathwing left many traps behind to guard these treasures.','',26124),
(97786,'enUS','','Ah, there you are. Lord Illidan has placed my Shivarra at your disposal.',26124),
(97787,'enUS','','A small force has infiltrated the Black Temple, but the Sha\'tari army is still being repelled.',26124),
(97788,'enUS','','We are to obtain the Sargerite Keystone with all due haste and return to aid in the defense.',26124),
(97790,'enUS','','If you will excuse us. Come my dears. Up the volcano to the foothold.',26124),
(97794,'enUS','Not all of these eggs shall survive. But those that do should be free of Deathwing\'s corruption.','',26124),
(97795,'enUS','Keep them off me just a little longer. One of the eggs is starting to hatch.','',26124),
(97796,'enUS','Look! One survived. Such a small thing, and with little black horns.','',26124),
(97797,'enUS','I shall call you Ebonhorn.','',26124),
(97804,'enUS','I will search ahead for the trove. Search for what you are after but do not keep me waiting. This is a dangerous place.','',26124),
(97805,'enUS','Excellent. Meet me at Krasus\' Landing when you are ready. I\'ve assembled the Argent Crusade\'s finest to join us to rescue Highlord Tirion.','',26124),
(97806,'enUS','The vrykul champion is nowhere to be found. Oh well, the heads of the other champions will have to suffice.','',26124),
(97807,'enUS','You have shown true valor today, and for this I will grant you a boon.','',26124),
(97808,'enUS','Hold aloft your weapon, outsider, and receive a gift from the Titans!','',26124),
(97809,'enUS','It is done. May our power aid you when you need it most.','',26124),
(97810,'enUS','Go forth, champion of the vault!','',26124),
(97811,'enUS','You have shown yourself as a challenger truly worthy of the trials. It was an honor to test you.','',26124),
(97812,'enUS','You have one more trial, then we can talk about the Bloodtotem joining Mayla\'s crusade.','',26124),
(97813,'enUS','Take this drogbar to the cavern below. Slay the ettin. If you survive, we\'ll talk. If he survives, I\'ll leave his group of drogbar alone. Anything goes.','',26124),
(97814,'enUS','I am ready to receive your gift, Yotnar.','I am ready to receive your gift, Yotnar.',26124),
(97815,'enUS','Know that I am Balnazzar. Know that you are but a pawn in plans beyond your reckoning.','',26124),
(97816,'enUS','You have no reason to trust me, but we will have to work together to survive this cave.','',26124),
(97817,'enUS','This ettin is formidable. Beware its massive club.','',26124),
(97818,'enUS','I will turn you into a weapon of the Legion. I will use your hollow shell to corrupt and destroy everything you have ever loved, piece by piece.','',26124),
(97819,'enUS','Impressive. I did not expect you to attune to the Ashbringer so quickly. No matter, I will finish you off personally.','',26124),
(97820,'enUS','I heard you may have seen Lyndras?','I heard you may have seen Lyndras?',26124),
(97821,'enUS','Haha! Such fun!','',26124),
(97822,'enUS','I can get us out of here. I know a secret path.','',26124),
(97823,'enUS','Let\'s get out of here!','Let\'s get out of here!',26124),
(97824,'enUS','The Bloodtotem are merciless and bloodthirsty. I don\'t think they mean for either of us to make it out of here alive.','',26124),
(97825,'enUS','The forest will prevail!','',26124),
(97826,'enUS','Nature shall endure!','',26124),
(97827,'enUS','My branches may bend... but they will not break!','',26124),
(97828,'enUS','The wrath of nature is upon you, demons!','',26124),
(97829,'enUS','Commander, over here!  I have the plans you are looking for.','',26124),
(97830,'enUS','Pathetic creatures.','',26124),
(97831,'enUS','Where is your goddess now?','',26124),
(97832,'enUS','Claw marks can be seen around the manhole cover and a trail of ley dust leads off towards Violet Hold.','Claw marks can be seen around the manhole cover and a trail of ley dust leads off towards Violet Hold.',26124),
(97833,'enUS','Look what wandered into my lair.','',26124),
(97834,'enUS','Look Razzok, more target practice!','',26124),
(97835,'enUS','I will add your corpse to the pile!','',26124),
(97836,'enUS','All will fall before Xavius.','',26124),
(97837,'enUS','You think you have won?','',26124),
(97838,'enUS','Into darkness...','',26124),
(97839,'enUS','','Yea, I\'ve seen him. That cursed elf friend of yours came in here and stole one of my ley flame burners! I chased him as far as the sewers before he slipped away. \n\nIf you find him, make sure he returns that burner, they\'re very rare.',26124),
(97840,'enUS','I can supply you with the battleship plans you need, but first, you need to prove your worth to the Hand of the Prophet here in Tannan Jungle.','',26124),
(97841,'enUS','Outsider, you will never lay your hands on the Hammer of Khaz\'goroth! It is my destiny to wield it, not yours.','',26124),
(97842,'enUS','As for you, drogbar... We will wipe out your little cave after we throw your corpses off the cliff.','',26124),
(97843,'enUS','Bloodtotem, let\'s end this.','',26124),
(97844,'enUS','I can supply you with the battleship plans you need, but first, you need to prove your worth to the Vol\'jin\'s Headhunters here in Tannan Jungle.','',26124),
(97845,'enUS','','Your gift is worthy, $r. Now let me see about that cloth you need repaired.',26124),
(97846,'enUS','Foolish mortal! The Tears of Elune are mine now!','',26124),
(97847,'enUS','If Malfurion wants them back so badly, he can seek me out. I\'ll be waiting.','',26124),
(97848,'enUS','You may enter the hold, but I will not put the lives of my guards at risk for your mission. Is that clear?','',26124),
(97849,'enUS','Very well. Do not make me regret trusting you.','',26124),
(97850,'enUS','As crystal, warden.','',26124),
(97851,'enUS','Lower the barrier and evacuate the hold. These Illidari wish to... exchange words... with the eredar.','',26124),
(97852,'enUS','Kirin Tor Protector bows its head slightly in agreement.','',26124),
(97853,'enUS','Your ancient rites and rituals mean nothing to me, Yotnar!','',26124),
(97854,'enUS','I will conquer your trials and take the Aegis for my own!','',26124),
(97855,'enUS','Cower here in your cave, while it still stands!','',26124),
(97856,'enUS','The gods will not tolerate your actions, vrykul! You will answer for your heresy!','',26124),
(97857,'enUS','Remember, demon hunter... you were never here.','',26124),
(97858,'enUS','Our foes approach! Let\'s go boys, For Lordaeron!','',26124),
(97859,'enUS','Follow me. I shall open the cell for you.','',26124),
(97860,'enUS','','This should help you see a bit better.',26124),
(97861,'enUS','','What was torn has now been mended. I hope you put the Shaldorei Silk to good use. Safe travels.',26124),
(97866,'enUS','','Hi again. My charm should be somewhere around this pond.$B$BThe mark I have placed on you should help you locate it.',26124),
(97867,'enUS','$p?! You would stand before me after so many of your kin have fallen? Release me now and I may yet spare you.','',26124),
(97868,'enUS','I knew the Bloodtotem would never let us live!','',26124),
(97869,'enUS','You lookin for that crazy elf? Yea, I seen\'im. He was down here making a huge ruckus and trying to munch on some sorta magical dust or something.$b$bI chased him off though, can\'t have the likes of him hanging around the shop.','',26124),
(97870,'enUS','Where did he run off to?','Where did he run off to?',26124),
(97880,'enUS','Well, I chased him around until he scrambled up a pipe that leads up top in front of Violet Hold. You\'ll probably wanna go looking around up there somewhere.','',26124),
(97884,'enUS','','How about makin\' this place a little more festive, Commander?',26124),
(97885,'enUS','','All this fighting must wear on you. How about a party?',26124),
(97886,'enUS','','Don\'t you just love holidays? I know I do!',26124),
(97887,'enUS','Make my garrison ready for a Hallow\'s Eve party.','Make my garrison ready for a Hallow\'s Eve party.',26124),
(97888,'enUS','Make my garrison ready for a Winter Veil party.','Make my garrison ready for a Winter Veil party.',26124),
(97889,'enUS','The party\'s over. Get rid of these decorations, Izzy.','The party\'s over. Get rid of these decorations, Izzy.',26124),
(97890,'enUS','','One last sip of wine...',26124),
(97895,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-ARCHIMONDEWOD.blp:50:80|t$B[Taldath the Destroyer] The Twinblades... will destroy you...','',26124),
(97896,'enUS','Where is he?! Where is Varedis? Tell us or die.','',26124),
(97897,'enUS','The Twinblades of the Deceiver could be exactly what we need to strike down the most powerful Legion lords.','',26124),
(97898,'enUS','Lord Illidan taught us to fight fire with fire, to use our enemies\' power against them. I believe we\'ve found our fire.','',26124),
(97899,'enUS','$p, I will meet you at Krasus\' Landing and prepare a fel bat to take you to Suramar. Let the hunt begin!','',26124),
(97900,'enUS','We have lost so many today, I did not think another champion would make it through. Come, we have a hard fight ahead of us. Are you ready?','',26124),
(97901,'enUS','Death comes soon.','',26124),
(97902,'enUS','Taste my blade.','',26124),
(97903,'enUS','Hunt this.','',26124),
(97904,'enUS','Pitiful.','',26124),
(97905,'enUS','Die in glorious battle!','',26124),
(97906,'enUS','For Tyranna!','',26124),
(97907,'enUS','I\'m going to destroy you, little demon hunter.','',26124),
(97908,'enUS','Your soul will be mine.','',26124),
(97909,'enUS','A new prisoner for the taking.','',26124),
(97910,'enUS','Your armies are nothing, demon hunter.','',26124),
(97911,'enUS','I\'ll crack open your flesh and feed upon your soul.','',26124),
(97912,'enUS','Into my cage you go.','',26124),
(97913,'enUS','So eager to be enslaved.','',26124),
(97914,'enUS','In this place, you are the hunted.','',26124),
(97915,'enUS','I am your judge, jury, and executioner.','',26124),
(97917,'enUS','Master Moonclaw! What has become of your grove?','Master Moonclaw! What has become of your grove?',26124),
(97920,'enUS','I understand.','I understand.',26124),
(97934,'enUS','Bear witness, foolish elves. I will crush your champion.','',26124),
(97935,'enUS','No! How can... this be?','',26124),
(97947,'enUS','These druids were weak... I hope you have more fight in you than they did!','',26124),
(97948,'enUS','','Getting low on arrows!',26124),
(97949,'enUS','','They\'re coming around again!',26124),
(97950,'enUS','','Back, you bastards!',26124),
(97951,'enUS','','Bring down that bat!',26124),
(97952,'enUS','','On your left!',26124),
(97953,'enUS','','Tear them apart, sisters!',26124),
(97954,'enUS','','Tor ilisar\'thera\'nal!',26124),
(97955,'enUS','','In Elune\'s name!',26124),
(97956,'enUS','Oh ho! What do we have here?','',26124),
(97957,'enUS','','Hold the line!',26124),
(97958,'enUS','','Ahhhh!',26124),
(97959,'enUS','','Make them pay!',26124),
(97960,'enUS','','Mother Moon!',26124),
(97961,'enUS','','Don\'t let them through!',26124),
(97962,'enUS','','Close that gap!',26124),
(97963,'enUS','','Andu-falah-dor!',26124),
(97964,'enUS','','Tohr falla nor dorah!',26124),
(97965,'enUS','Welcome to the Nightmare!','',26124),
(97966,'enUS','Your boldness will not save you this day!','',26124),
(97967,'enUS','Thaon you fool! You\'ve already lost...','',26124),
(97968,'enUS','This Nightmare shall consume you!','',26124),
(97969,'enUS','I underestimated you.','',26124),
(97970,'enUS','You cannot stop the Nightmare!','',26124),
(97971,'enUS','You have entered the Nightmare! There is no exit!','',26124),
(97972,'enUS','Cower in the Nightmare!','',26124),
(97973,'enUS','You cannot wake from this Nightmare!','',26124),
(97974,'enUS','You were foolish to come here.','',26124),
(97975,'enUS','The darkness will overwhelm you...','',26124),
(97976,'enUS','You will never defeat us all...','',26124),
(97978,'enUS','You think you\'ve won?','',26124),
(97981,'enUS','Soon, this wretched forest will be bathed in darkness!','',26124),
(98008,'enUS','Azeroth cannot resist its fate forever!','',26124),
(98020,'enUS','What a wonderful time of year!','What a wonderful time of year!',26124),
(98021,'enUS','Let me browse your seasonal fare.','Let me browse your seasonal fare.',26124),
(98023,'enUS','Damn your spectral sight!','',26124),
(98029,'enUS','','This will be a glorious battle!',26124),
(98030,'enUS','','I will carve your bones!',26124),
(98031,'enUS','','The spirits serve my will!',26124),
(98032,'enUS','','Spirits... you have failed me...',26124),
(98033,'enUS','','Ancestors, give me strength!',26124),
(98034,'enUS','','Mine is the power of the gods!',26124),
(98035,'enUS','','Helheim awaits you, outsider!',26124),
(98036,'enUS','','Ancestors, take me...',26124),
(98037,'enUS','','I will live again...',26124),
(98038,'enUS','','The gods... favor me...',26124),
(98039,'enUS','','You cannot save the Thorignir!',26124),
(98040,'enUS','','I\'ll decorate my dragon with your bones!',26124),
(98041,'enUS','','I shall ride eternal!',26124),
(98042,'enUS','','The next flight... awaits...',26124),
(98046,'enUS','','The Tideskorn will wash you from this land!',26124),
(98047,'enUS','','Your death will be my prize!',26124),
(98048,'enUS','','I will feast in the Halls of Valor!',26124),
(98049,'enUS','','I die... historic...',26124),
(98050,'enUS','','Gods... deem me worthy...',26124),
(98051,'enUS','','I go... to the next battle...',26124),
(98056,'enUS','Pity your allies had to die. Don\'t worry... I\'ll put their souls to good use.','',26124),
(98057,'enUS','You could never be worthy!','',26124),
(98058,'enUS','The kings will spit on you, worm!','',26124),
(98059,'enUS','The God-King has already won!','',26124),
(98060,'enUS','You cannot resist your fate!','',26124),
(98061,'enUS','The runes will break you!','',26124),
(98062,'enUS','The spirits serve my will!','',26124),
(98063,'enUS','Mine is the power of the gods!','',26124),
(98064,'enUS','I will live again...','',26124),
(98065,'enUS','Ancestors, take me...','',26124),
(98066,'enUS','Even... the stone... erodes...','',26124),
(98067,'enUS','You will never prevail...','',26124),
(98068,'enUS','The Halls will not open... to you...','',26124),
(98069,'enUS','The next flight... awaits...','',26124),
(98070,'enUS','You will share the Thorignir\'s fate!','',26124),
(98071,'enUS','You cannot match... our power...','',26124),
(98072,'enUS','I\'ll hack your bones to splinters!','',26124),
(98073,'enUS','Your blood will be my war paint!','',26124),
(98074,'enUS','The crows will feast tonight!','',26124),
(98075,'enUS','I am not... defeated...','',26124),
(98076,'enUS','Death cannot sate my bloodlust...','',26124),
(98077,'enUS','A glorious... ending...','',26124),
(98078,'enUS','This vault belongs to the Tideskorn!','',26124),
(98079,'enUS','You are too late, outsider!','',26124),
(98080,'enUS','You cannot compete with the God-King!','',26124),
(98081,'enUS','The gates are closed to you, outsider!','',26124),
(98082,'enUS','I will send you back to Helheim!','',26124),
(98083,'enUS','We will feed you to the Legion!','',26124),
(98084,'enUS','You cannot escape the Nightmare Lord\'s grasp!','',26124),
(98085,'enUS','I will feast in the High Halls!','',26124),
(98086,'enUS','Die with honor, outsider!','',26124),
(98087,'enUS','I die... historic...','',26124),
(98088,'enUS','Gods... deem me worthy...','',26124),
(98089,'enUS','Death is its own victory...','',26124),
(98090,'enUS','Odyn, ready your halls...','',26124),
(98091,'enUS','This land is doomed!','',26124),
(98092,'enUS','Your resistance is futile!','',26124),
(98093,'enUS','You do not see, but you will.','',26124),
(98094,'enUS','You were warned.','',26124),
(98095,'enUS','You cannot escape!','',26124),
(98096,'enUS','Will the night elves mourn you, I wonder?','',26124),
(98097,'enUS','You will never leave!','',26124),
(98098,'enUS','Looking for a fight? Allow me...','',26124),
(98099,'enUS','Your corpse is another gift for Helya!','',26124),
(98100,'enUS','Pity. You could have joined us...','',26124),
(98101,'enUS','You would die for this pathetic land?','',26124),
(98102,'enUS','I will wear your bones!','',26124),
(98103,'enUS','Drown in agony!','',26124),
(98104,'enUS','The mists take you!','',26124),
(98105,'enUS','I return to the mists...','',26124),
(98106,'enUS','Helya, take me...','',26124),
(98107,'enUS','Is the curse... ended?','',26124),
(98108,'enUS','My war... is eternal...','',26124),
(98109,'enUS','You will serve willingly, or in chains!','',26124),
(98110,'enUS','The high halls will burn!','',26124),
(98111,'enUS','I will break you against the gates!','',26124),
(98112,'enUS','You have not begun to know destruction!','',26124),
(98113,'enUS','The earth will shatter at the Legion\'s coming!','',26124),
(98114,'enUS','Our devastation will be absolute!','',26124),
(98115,'enUS','You cannot hope to survive!','',26124),
(98116,'enUS','We will not stop...','',26124),
(98117,'enUS','Do not think... you\'ve won...','',26124),
(98118,'enUS','You fight the inevitable...','',26124),
(98119,'enUS','We do not fear death...','',26124),
(98120,'enUS','The dragons bend to my will!','',26124),
(98121,'enUS','Your soul will be made to serve!','',26124),
(98122,'enUS','Your pitiful trials will not save you from the Legion!','',26124),
(98123,'enUS','Your future will know only despair!','',26124),
(98124,'enUS','I feel your will... draining...','',26124),
(98125,'enUS','Your fate is only death!','',26124),
(98126,'enUS','I will shatter your soul!','',26124),
(98127,'enUS','Death is only temporary...','',26124),
(98128,'enUS','You cannot stop what is coming. Even in your dreams.','',26124),
(98129,'enUS','You cannot escape our eyes...','',26124),
(98130,'enUS','Humor me... scream for help!','',26124),
(98131,'enUS','Let me show you what happens to heroes.','',26124),
(98132,'enUS','If I cannot bend your mind, I will break your body.','',26124),
(98133,'enUS','I see only darkness...','',26124),
(98134,'enUS','The darkness consumes...','',26124),
(98135,'enUS','My life... for the master...','',26124),
(98136,'enUS','The dark beyond... awaits me.','',26124),
(98137,'enUS','The master will destroy... your soul!','',26124),
(98138,'enUS','Foolish mortal! You cannot win...','',26124),
(98139,'enUS','Without hope, there can be no despair.','',26124),
(98140,'enUS','It stirs, faceless, forgotten... deathless.','',26124),
(98141,'enUS','The abyss whispers your name.','',26124),
(98142,'enUS','Madness beckons me beyond...','',26124),
(98143,'enUS','','Fighting this is futile, hero. None can resist the master.',26124),
(98144,'enUS','','Strike now! Focus on the night elves\' champion!',26124),
(98145,'enUS','','Press onward, demons! Destroy the temple!',26124),
(98147,'enUS','','Slay the night elves and their champion! Water the land with blood!',26124),
(98148,'enUS','','Kill these intruders, my children. Your queen commands it!',26124),
(98149,'enUS','','To me, my flight! Eradicate these pests!',26124),
(98150,'enUS','','Breathe deep, hero. Taste the essence of the Emerald Nightmare!',26124),
(98151,'enUS','','I will choke you with terror and drive you from this place howling.',26124),
(98152,'enUS','','Scatter, little ones. Scurry until your feet bleed and your lungs scream.',26124),
(98153,'enUS','','Exhale the last of your hope. Inhale horror and ruination.',26124),
(98154,'enUS','','I fought for you, believed in you! I was such a fool!',26124),
(98155,'enUS','','End this torment! Kill me, or I will surely kill you!',26124),
(98156,'enUS','','Faith. Duty. Just words! None of it matters!',26124),
(98157,'enUS','','Am I dreaming? Then why can I not wake? Why?!',26124),
(98160,'enUS','','I can no longer see your future, champion. I think you die here today.',26124),
(98162,'enUS','','Forgive me. It felt... so real...',26124),
(98163,'enUS','','At last! With this victory, despair takes root on Azeroth!',26124),
(98164,'enUS','Destroy them, and gather the fragments of the blade, for they will be the heart of your new weapon.','',26124),
(98165,'enUS','I now mark you with my sigil, let all recognize you as the enforcer of my will.','',26124),
(98166,'enUS','Go, ensure that not a single demon escapes my wrath! Crush all who stand in your way!','',26124),
(98167,'enUS','After you, $p.','',26124),
(98168,'enUS','','Sylvanas will not escape...',26124),
(98169,'enUS','','Gilneas... will rise...',26124),
(98170,'enUS','','Greymane... avenge me...',26124),
(98171,'enUS','','You cannot escape justice...',26124),
(98172,'enUS','','Sylvanas cannot hide from justice!',26124),
(98173,'enUS','','I\'ll tear you to ribbons!',26124),
(98174,'enUS','','The Horde will pay for their treachery!',26124),
(98175,'enUS','','For the Alliance!',26124),
(98176,'enUS','','For Gilneas!',26124),
(98177,'enUS','','We will have retribution!',26124),
(98178,'enUS','','Give us the Banshee Queen!',26124),
(98179,'enUS','You seek the Aegis... but will you claim it, or die trying? There is no compromise in this.','',26124),
(98180,'enUS','Are you worthy? Only the gods may decide.','',26124),
(98181,'enUS','Oh, back from the dead are we? Outstanding. Really, truly impressive!','',26124),
(98182,'enUS','','Come on, you bilge-rats! I\'ll give you a burial at sea!',26124),
(98183,'enUS','','Wretched mortal - your soul belongs to me!',26124),
(98184,'enUS','','What?! Impossible... What manner of being are you?!',26124),
(98185,'enUS','','Remember our bargain, banshee. Do not dare to cross me...',26124),
(98186,'enUS','','You heard Nathanos. No survivors!',26124),
(98187,'enUS','','That should be enough. Get up to the top deck.',26124),
(98188,'enUS','','Hang on tight and try not to scream - Duchess has very sensitive ears.',26124),
(98189,'enUS','For the Dark Lady! For Sylvanas!','',26124),
(98190,'enUS','Impossible...','',26124),
(98191,'enUS','No... it can\'t be...','',26124),
(98192,'enUS','','I\'m usually quite cheery this time of year, but it\'s hard to be merry when Grumpus is about.',26124),
(98193,'enUS','Victory! You\'ve rescued the little bear.$b$b%s paws at you, trying to get your attention.','',26124),
(98194,'enUS','Attack incoming! Defeat the attacking sprites.','',26124),
(98197,'enUS','Is it time to know your future? Perhaps your end?','',26124),
(98198,'enUS','%s looks panicked.$b$bClick the baby bear again to offer help.','',26124),
(98199,'enUS','Time sheds from all of our bodies like fresh molt. How many feathers have you left to lose? Maybe Ikalyi can say.','',26124),
(98200,'enUS','Let\'s hear about my future, Ikalyi.','Let\'s hear about my future, Ikalyi.',26124),
(98201,'enUS','$n, will you use your spectral sight on the cave entrance? Something\'s not right.','',26124),
(98202,'enUS','Tell me, $R, what beast of Draenor is your heart\'s ward?','',26124),
(98203,'enUS','Don\'t let them cross that bridge or I\'ll have your hides!','',26124),
(98204,'enUS','','I\'m usually quite cheery this time of year, but it\'s hard to be merry when Grumpus is about.',26124),
(98205,'enUS','No outsider will wield the Hammer of Khaz\'goroth! Flay them alive!','',26124),
(98206,'enUS','Tear them limb from limb! Spread their blood on the fields!','',26124),
(98207,'enUS','Excellent work. Speak to Patricia about a new recipe.','',26124),
(98208,'enUS','You should talk to Patricia. I believe she can offer you a new recipe.','',26124),
(98209,'enUS','This land is dense with the departed. My magic will make them feel more welcome here.','',26124),
(98210,'enUS','Say the word if you require assistance, $p.','',26124),
(98211,'enUS','','I heard a passing adventurer mention something about a tailor setting up shop in Azsuna, within the Greenway.',26124),
(98212,'enUS','We are Bloodtotem! Would you let the weak overcome us?!','',26124),
(98213,'enUS','','We need to be out there searching for the Hammer. Tradition can wait.',26124),
(98214,'enUS','I can\'t wait to get home!','I can\'t wait to get home!',26124),
(98215,'enUS','Get me out of here!','Get me out of here!',26124),
(98216,'enUS','Those grumplings sure smell funny.','Those grumplings sure smell funny.',26124),
(98217,'enUS','Thank you.','Thank you.',26124),
(98218,'enUS','Sure is cold here!','Sure is cold here!',26124),
(98219,'enUS','Let\'s see, did I remember the spritethorn needles...?','',26124),
(98220,'enUS','Oh blast! I left my thimbles in my room!','',26124),
(98221,'enUS','One... two... three, four... yes. They\'re all here.','',26124),
(98222,'enUS','How can they see us?','',26124),
(98223,'enUS','They have the spectral sight!','',26124),
(98224,'enUS','Finish them. Recast the cloaking spell.','',26124),
(98225,'enUS','This simply will not do. I MUST find better accommodations.','',26124),
(98226,'enUS','Shame about that fellow that was living here before. But you did what you had to, Lyndras, to survive.','',26124),
(98227,'enUS','Maybe if I explain that I was just borrowing it, they\'ll have me back. No, no, no! Tytallo would never go for that.','',26124),
(98229,'enUS','The Path of Huln follows in the footsteps of Huln\'s last and greatest hunt.','',26124),
(98232,'enUS','Please, use my table in the middle of the room to perform your tasks. You\'ll find some Runic Catgut on it as well.','',26124),
(98233,'enUS','Torok will not trouble the Stonedark again. Let\'s head to the homeland of my people.','',26124),
(98234,'enUS','','I just got a fresh shipment of Runic Catgut, $n. If your supply is low, you can buy some from me.',26124),
(98235,'enUS','Let me know when you are ready to continue, champion.','',26124),
(98236,'enUS','No rush, Champion. We are just in the middle of a field of ettins. I am sure nothing bad could possibly happen.','',26124),
(98237,'enUS','We should really keep moving.','',26124),
(98238,'enUS','Is it wise to wait in a field of ettins?','',26124),
(98239,'enUS','You have proven yourself the greatest living warrior on Azeroth. It is for this reason I have saved you.','',26124),
(98240,'enUS','Why have you brought me here?','Why have you brought me here?',26124),
(98241,'enUS','Alright, bruls, get to work!','',26124),
(98242,'enUS','I have foreseen the coming of a mighty champion to these shores. One who would slay countless foes and prove their valor time and again. One who would lead my armies to victory against the great darkness that seeks to devour this world!','',26124),
(98243,'enUS','What do you propose?','What do you propose?',26124),
(98244,'enUS','I name you Valarjar! Bring glory to these halls on the wings of my val\'kyr!','',26124),
(98245,'enUS','','Oh, $n, I have some Spritethorns for sale if you need any for your bag recipe.',26124),
(98246,'enUS','Keep your wits about you, $p. Varedis will be a cunning adversary.','',26124),
(98247,'enUS','For Sylvanas!','',26124),
(98248,'enUS','','For Sylvanas!',26124),
(98249,'enUS','Death to the living!','',26124),
(98250,'enUS','I will feast on your bones!','',26124),
(98251,'enUS','Join us in death!','',26124),
(98252,'enUS','Abandon hope!','',26124),
(98253,'enUS','You will suffer as we have!','',26124),
(98254,'enUS','For the Dark Lady!','',26124),
(98255,'enUS','Now you die!','',26124),
(98256,'enUS','','Death to the living!',26124),
(98257,'enUS','','I will feast on your bones!',26124),
(98258,'enUS','','Join us in death!',26124),
(98259,'enUS','','Abandon hope!',26124),
(98260,'enUS','','You will suffer as we have!',26124),
(98261,'enUS','','For the Dark Lady!',26124),
(98262,'enUS','','Now you die!',26124),
(98263,'enUS','Oh... not this again...','',26124),
(98264,'enUS','Ah... at last...','',26124),
(98265,'enUS','Dark Lady...','',26124),
(98266,'enUS','No... no...','',26124),
(98267,'enUS','','Oh... not this again...',26124),
(98268,'enUS','','Ah... at last...',26124),
(98269,'enUS','','Dark Lady...',26124),
(98270,'enUS','','No... no...',26124),
(98271,'enUS','They won\'t escape us. Illidari, attack!','',26124),
(98272,'enUS','The fel lord is just ahead.','',26124),
(98273,'enUS','We cannot launch our attack until we\'re sure we won\'t be flanked.','',26124),
(98274,'enUS','I would have sundered your forces...','',26124),
(98275,'enUS','','We\'re doing important work here in Feralas.',26124),
(98276,'enUS','','Yes. Let\'s be certain to take care of that.',26124),
(98277,'enUS','Deucus sent me. He says you can help calibrate this burette.','Deucus sent me. He says you can help calibrate this burette.',26124),
(98278,'enUS','Your aid to the Thorignir will not go unrewarded, outsider. $B$BIf you truly wish the blessing of our brood, then help us to rid this scourge from our home.','',26124),
(98279,'enUS','The deeds you have done are great, but we have not finished here yet. $B$BSpeak to me when you are ready to ascend to the mountain\'s summit.','',26124),
(98280,'enUS','When you have finished your business here, speak to me and I will fly you to the summit. $B$BOnce we leave, we may not return.','',26124),
(98281,'enUS','God-King Skovald summons a squad of Felskorn vrykul!','God-King Skovald summons a squad of Felskorn vrykul!',26124),
(98282,'enUS','Fly me to the summit, Vethir.','Fly me to the summit, Vethir.',26124),
(98283,'enUS','God-King Skovald summons a Felblaze Brute!','God-King Skovald summons a Felblaze Brute!',26124),
(98284,'enUS','God-King Skovald summons a pack of felstalkers!','God-King Skovald summons a pack of felstalkers!',26124),
(98285,'enUS','Odyn believes you are worthy to wield the Armaments of the Black Wyrm. I am here for Magnar Icebreaker. Let us both be successful, eh?','',26124),
(98286,'enUS','','Your ties to this reality are but threads. Care to cut a few?',26124),
(98287,'enUS','','Don\'t be scared. My brews only show you what was already there to begin with.',26124),
(98288,'enUS','Who is Magnar Icebreaker?','Who is Magnar Icebreaker?',26124),
(98289,'enUS','Welcome, my friends, to the Vault of Neltharion. Or as the world came to know him: Deathwing.','',26124),
(98290,'enUS','Magnar Icebreaker was one of the greatest heroes of our time. He won many victories, became king, and crafted the greatest weapons I have ever seen, including the Armaments of the Black Wyrm.\n\nHe lost only one battle, his last. We were betrayed by jealous warriors led by cultists of Helira, that dark witch! They killed me first before we could react and he would not command after that.\n\nThey crafted his tomb with reverence, but he did not move on to the Halls of Valor. I hope his rage has not driven him to madness. He deserves to be here.','',26124),
(98291,'enUS','We gave everything for the Ashbringer... you gave everything, $n. Tirion would be proud to see you wielding that blade.','',26124),
(98292,'enUS','Let us go to the tomb.','Let us go to the tomb.',26124),
(98293,'enUS','Come champion, I will need your help while the time scars are fresh.','',26124),
(98294,'enUS','Welcome, my friends, to the Vault of Neltharian.','',26124),
(98295,'enUS','Our journey will be a quick one. A single leap from Skyhold will take us to Azeroth. Follow me!','',26124),
(98296,'enUS','Wrathion?!','',26124),
(98297,'enUS','No. But if this is indeed Neltharian\'s Vault, he will prove useful.','',26124),
(98298,'enUS','','Can we trust this creature?',26124),
(98299,'enUS','Commander, over here!  I have the plans you are looking for.','',26124),
(98300,'enUS','','If you deep-dwellers touched a hair on Moozy\'s head you\'ll never leave that cave alive!',26124),
(98301,'enUS','','Give Moozy back! Where is he?!',26124),
(98302,'enUS','Krimple\'s the name, precision\'s my game!','',26124),
(98303,'enUS','The others should be waiting for you in the sanctum beneath Light\'s Hope Chapel, $n. You should make haste.','',26124),
(98304,'enUS','Don\'t know what ya heard, but my numbers are exact. EXACT, I tell ya!','',26124),
(98305,'enUS','What a wonderful time of year!','What a wonderful time of year!',26124),
(98306,'enUS','No matter how many presents there are, we could always use more!','No matter how many presents there are, we could always use more!',26124),
(98307,'enUS','\'Tis the season!','\'Tis the season!',26124),
(98308,'enUS','Happy holidays!','Happy holidays!',26124),
(98309,'enUS','Let\'s make this the most wonderful holiday ever!','Let\'s make this the most wonderful holiday ever!',26124),
(98312,'enUS','What\'s the holiday without a lil\' smooch?','What\'s the holiday without a lil\' smooch?',26124),
(98313,'enUS','','Lifespring Cavern is to the west. Meet me there when you can.',26124),
(98316,'enUS','','There is harmony in precision, $r.',26124),
(98317,'enUS','A glorious landing! Are you ready to find Magnar?','',26124),
(98318,'enUS','His tomb is not far.','',26124),
(98319,'enUS','They buried him here after his only defeat...','',26124),
(98320,'enUS','Desecrators! We must slay these abominations!','',26124),
(98321,'enUS','A good fight! Follow me. I will open the tomb.','',26124),
(98322,'enUS','The guardians do not obey me! Seems we will have to do this the hard way.','',26124),
(98323,'enUS','We should be able to leap over this.','',26124),
(98324,'enUS','Champion, we must save him! I will find the words to spur him on to the Halls of Valor, but he may resist the truth and turn his guards against me.','',26124),
(98325,'enUS','Say the word and we shall begin.','',26124),
(98326,'enUS','Father, it\'s me... your son. Odyn sent me here to--','',26124),
(98327,'enUS','My son died before my very eyes. I FAILED to protect him! You will not--','',26124),
(98328,'enUS','Gotta start somewhere!$B$BNow if you\'ll excuse me, I have some very important business to attend to.','',26124),
(98329,'enUS','It IS me. I fell before you in the battle of the Pass. We were betrayed!','',26124),
(98330,'enUS','I fell in battle. We ALL fell. None survived the onslaught. Not even you!','',26124),
(98331,'enUS','Lies! Can you not see my faithful soldiers?!','',26124),
(98332,'enUS','You died in glorious battle! The Halls of Valor await. Come with me, father!','',26124),
(98333,'enUS','Who are you, demon? Why do you torment me so?','',26124),
(98334,'enUS','LIAR! You will DIE for saying his name! I shall send you to Helheim myself!','',26124),
(98335,'enUS','Four, five... six...','',26124),
(98336,'enUS','You are not my son! He is in the Halls of Valor, called by Odyn before his time!','',26124),
(98337,'enUS','I am the son of Magnar the Great, Champion of the Valarjar. Father, look at me! I am Hruthnir. I am your son!','',26124),
(98338,'enUS','His weapons are yours now, champion. There is nothing left for us here. Let us feast in the Halls of Valor, together!','',26124),
(98339,'enUS','Hmm... eight? Aw, not again...','',26124),
(98340,'enUS','One, two...','',26124),
(98341,'enUS','Such a small, fragile body. Yet it holds such power.','',26124),
(98342,'enUS','','What is it? Precision requires focus, you know.',26124),
(98343,'enUS','Break time!','',26124),
(98344,'enUS','Welp, better get back to it. These presents won\'t count themselves.','',26124),
(98345,'enUS','','Hello again. A true, true friend helps a friend indeed.',26124),
(98346,'enUS','$n, you\'ve arrived! The Sanctum of Light is just ahead. This way.','$n, you\'ve arrived! The Sanctum of Light is just ahead. This way.',26124),
(98347,'enUS','Go forth, Ysera! Destroy all who stand in your way.','',26124),
(98351,'enUS','I would like to build another destroyer.','I would like to build another destroyer.',26124),
(98352,'enUS','','Deucus is an old fla--er, friend. I\'d be happy to calibrate the burette for you.',26124),
(98353,'enUS','We checked every bulb, didn\'t we?$B$BMaybe we oughta check \'em again.','',26124),
(98354,'enUS','','Let\'s go, $n. This moisture makes my joints hurt; make it snappy.',26124),
(98355,'enUS','This place can never have too much holiday spirit!','',26124),
(98356,'enUS','Lousy holiday bonus. Who needs a Smokeywood Pastures lifetime membership anyway?','',26124),
(98357,'enUS','You didn\'t happen to see a squirrel running about, did you? Damn thing came in with the trees...','',26124),
(98358,'enUS','Could use a few more decorations around here. Wouldn\'t want our neighbors showing us up with their decorations this season, would we?','',26124),
(98359,'enUS','I will not be undone by some mortal filth! I am the Earth Warder!','',26124),
(98360,'enUS','','There, much better. Please give my best to Deucus.',26124),
(98364,'enUS','I would like to build a destroyer.','I would like to build a destroyer.',26124),
(98365,'enUS','','Deucus Valdera? A blustery fellow, but honorable. I will be pleased to assist you with calibration.',26124),
(98367,'enUS','','I\'ve done my best to calibrate the burette. Give Deucus my regards.',26124),
(98369,'enUS','Deucus? That undead has some nerve! Called me a cheater once... but I suppose I can forgive him. Lemme see...','',26124),
(98370,'enUS','','Behind you lies the Eye of Odyn, which peers across all of Azeroth! This way lies the Forge, where the mightiest weapons of the valarjar are crafted by Helgar, the greatest smith in the Halls.',26124),
(98371,'enUS','Here ya go! Tell Deucus I treated ya fair \'n square!','',26124),
(98372,'enUS','','Odyn awaits ahead. I will go forth and announce you. Be respectful!',26124),
(98374,'enUS','','Deucus? I thought he was dead! Of course I would be happy to help my old friend.',26124),
(98375,'enUS','','Perfect calibration! Tell Deucus I shall make a trip to Dalaran soon to say hello.',26124),
(98376,'enUS','The Data Extratinator 3000 might be able to decipher this core. Cross your fingers that it doesn\'t explode in the process.','',26124),
(98377,'enUS','Deucus always sends me the most challenging puzzles to solve! Let\'s see that burette!','',26124),
(98378,'enUS','This core contains a script written in an ancient Highborne dialect, which I can\'t read. Professor Pallin in the Scribes\' Sacellum may be able to translate this.','',26124),
(98379,'enUS','Perfection! You can now make potions with precise exactitude!','',26124),
(98380,'enUS','I will signal my contacts on the other side of the tunnel. Meet me there as soon as you are able.','',26124),
(98381,'enUS','Thank you again, hero. You have just given the Black Dragonflight a second chance.','',26124),
(98382,'enUS','','I really must make a trip to Dalaran sometime.',26124),
(98383,'enUS','Start construction on our first transport.','Start construction on our first transport.',26124),
(98385,'enUS','Battlelord, your forces will assault The Doom Fortress to the southeast. Stop the mass of their demons from attacking us.','Battlelord, your forces will assault The Doom Fortress to the southeast. Stop the mass of their demons from attacking us.',26124),
(98386,'enUS','The dead are rising! Something is not right...','',26124),
(98387,'enUS','Rest well, my brother.','',26124),
(98388,'enUS','These warriors are restless! They must sense some kind of disturbance...','',26124),
(98389,'enUS','Onward! We are almost to Magnar\'s tomb.','',26124),
(98390,'enUS','','Watch yourself down there... that doesn\'t look like Westfall stew in those cauldrons.',26124),
(98391,'enUS','','Hop on. We\'ll check every ship if we have to!',26124),
(98392,'enUS','','Slay these unholy creatures! For the Alliance!',26124),
(98393,'enUS','','No sign of her. Let\'s keep looking.',26124),
(98394,'enUS','','Those are royal guards... This must be her flagship. Seize the captain!',26124),
(98395,'enUS','','The Skyfire is being overrun. Come on, we have to help!',26124),
(98396,'enUS','My thanks, brul! I shall remember you always.','',26124),
(98397,'enUS','We are free? Free? No more dragons? No more wyrms?','',26124),
(98398,'enUS','Huln said he would free us. Are you with Huln?','',26124),
(98399,'enUS','Death to the tyrants! Death to Deathwing and his brood!','',26124),
(98400,'enUS','It will be as you say.','',26124),
(98402,'enUS','Ashtongue with me!','',26124),
(98403,'enUS','Please forgive me: I must warn the others. Elune be with you.','',26124),
(98404,'enUS','','Most powerful Odyn, I bring you $n. They have slain the great pit lord Malgalor showing true valor.',26124),
(98410,'enUS','Behold my warriors! See my greatest champion, Skylord $n!','',26124),
(98414,'enUS','','Champion! It\'s good to see you. Vrykul aren\'t known for their hospitality.',26124),
(98415,'enUS','','Psst... over here!',26124),
(98416,'enUS','','Champion, over here! Quick, before the drakes catch your scent!',26124),
(98417,'enUS','','The God-King hasn\'t won yet. Let\'s take those dragons back!',26124),
(98418,'enUS','','For Gilneas!',26124),
(98419,'enUS','','Hey, it\'s you! I\'m getting stir-crazy here - please tell me we\'re going in!',26124),
(98420,'enUS','','This way, there\'s a good spot right here.',26124),
(98421,'enUS','','Hey, over here! I\'ve got a plan!',26124),
(98422,'enUS','','I feel like that guy having a dragon is a bad thing.',26124),
(98423,'enUS','','Yes! Finally, some action!',26124),
(98424,'enUS','Lower your weapon, outsider. I do not wish to harm you.','',26124),
(98425,'enUS','Wait... you are not like the others...','',26124),
(98426,'enUS','The demon binds me... please help...','',26124),
(98427,'enUS','The Drekirjar have upset our ancient pact.','',26124),
(98428,'enUS','It is time they face the consequences.','',26124),
(98429,'enUS','Even as someone not of this land, you chose to save us from a wretched fate.','',26124),
(98430,'enUS','You have passed the Trial of Will, and you have also gained an ally.','',26124),
(98431,'enUS','Hold aloft your weapon, outsider. Accept the power of storm and thunder as a gift for your selfless acts.','',26124),
(98432,'enUS','Take wing with Vethir, friend, and show these vrykul the true fury of the storm!','',26124),
(98433,'enUS','The storm will purge Skovald from this land!','',26124),
(98434,'enUS','The unworthy will be thrashed in the gale winds!','',26124),
(98435,'enUS','Suffer the wrath of the Thorignir!','',26124),
(98436,'enUS','The Thorignir owe you a debt of gratitude, outsider.','',26124),
(98437,'enUS','Your trials are far from over. When you need me again, I shall be ready.','',26124),
(98438,'enUS','It seems that a messenger awaits. May the gale winds carry you, friend.','',26124),
(98439,'enUS','Two trials faced and one remains.','',26124),
(98440,'enUS','You must seek the judgment of the ancient kings, but they are dead and you are not.','',26124),
(98441,'enUS','There is one who can bridge the gap, if you indulge him.','',26124),
(98442,'enUS','Meet me at Valdisdall, and I will spin the tale.','',26124),
(98443,'enUS','In Haustvald, the Bonespeakers keep the dead. They will not help you.','',26124),
(98444,'enUS','Their ways are twisted. They have forgotten the old vows.','',26124),
(98445,'enUS','But there is one who remembers. One who is rooted in the old ways.','',26124),
(98446,'enUS','Seek Vydhar! Earn your judgment, and pass the Trial of Valor.','',26124),
(98447,'enUS','Dying roots.. twisted leaves... the runestones...','',26124),
(98448,'enUS','I can hear... the woods call to me...','',26124),
(98449,'enUS','Must break free... I can almost feel my leaves...','',26124),
(98450,'enUS','I am unbound! My roots will seek the hearts of my betrayers!','',26124),
(98451,'enUS','Ahh... oohh...','',26124),
(98452,'enUS','Who goes there? Your footsteps fall as acorns. Stand before me, little one.','',26124),
(98453,'enUS','I hear you\'re an expert on naval equipment.  Have some time to help me out?','I hear you\'re an expert on naval equipment.  Have some time to help me out?',26124),
(98454,'enUS','','You will not force my judgment, Runeseer. This fel-tainted wretch will not befoul the Halls of Valor!',26124),
(98456,'enUS','I grow impatient, Runeseer. Finish this!','',26124),
(98459,'enUS','Give in, Ashildir. If your spirit will not bend, then it will be broken!','',26124),
(98460,'enUS','','Champion! Destroy this usurper, and I will grant you my judgment!',26124),
(98461,'enUS','You think to stop me? I am the master of the vengeful dead!','',26124),
(98462,'enUS','','The runestone grants him power, champion. Destroy it!',26124),
(98463,'enUS','These are just some of the artifacts collected by Deathwing in his day. Collect them and I will see they are properly investigated later.','',26124),
(98464,'enUS','You were a fool to meddle. My armies are eternal!','',26124),
(98465,'enUS','','Sisters, to arms! Show this coward the meaning of valor!',26124),
(98466,'enUS','','He\'s empowering another runestone!',26124),
(98467,'enUS','Enough of this!','',26124),
(98468,'enUS','','No! This power... it\'s too strong!',26124),
(98469,'enUS','You should have yielded, Ashildir.','',26124),
(98470,'enUS','The God-King will not need your judgment if you are no longer among the honored dead.','',26124),
(98471,'enUS','','No... you can\'t...',26124),
(98472,'enUS','I can. You have sealed your fate, shieldmaiden. You and this... outsider.','',26124),
(98473,'enUS','Enjoy your eternity of damnation. Helheim awaits!','',26124),
(98474,'enUS','','I am sorry, hero. I have doomed us both.',26124),
(98475,'enUS','','Perhaps this cowering wretch might be of some use.',26124),
(98476,'enUS','','Disgusting! This plan better work, spirit.',26124),
(98477,'enUS','','Such a revolting disguise. My armor still reeks of seaweed!',26124),
(98479,'enUS','','Remember our bargain, banshee. Do not dare to cross me...',26124),
(98480,'enUS','','What have we here? Another one of Greymane\'s mercenaries?',26124),
(98481,'enUS','','No matter. Soon you will witness the birth of a new age.',26124),
(98482,'enUS','','If you ever make it out of here, that is.',26124),
(98483,'enUS','','Ah, my loyal hero.',26124),
(98484,'enUS','','You must not languish here. The Aegis cannot fall into enemy hands!',26124),
(98485,'enUS','','The future of the Horde depends on you and me. Find your way back to Stormheim - I will be waiting.',26124),
(98486,'enUS','I can help ya out, $c.  I remember seeing some documents at the end of the docks.  Head down there and take a look.','',26124),
(98487,'enUS','','Unworthy! You will kneel before addressing the great Helya!',26124),
(98488,'enUS','','Your spirit feels... weaker. What has she done?',26124),
(98489,'enUS','','Have fun with my pet, outsider. I will enjoy watching him break you!',26124),
(98490,'enUS','','Our foe is great, champion, but we will win the day.',26124),
(98491,'enUS','','You are clever, outsider, but your efforts will only prove futile.',26124),
(98492,'enUS','','Do not think you are close to winning, unworthy one.',26124),
(98493,'enUS','','How resourceful you are. You might make a worthwhile plaything yet.',26124),
(98494,'enUS','','The time for planning is over, champion. Now, we take action!',26124),
(98495,'enUS','','No! My darling pet! You will pay for this!',26124),
(98496,'enUS','','It is done, Helya! We have fulfilled your bargain, and we will collect our payment!',26124),
(98497,'enUS','','It is done, Helya! We have fulfilled your bargain, and we will collect our payment!',26124),
(98498,'enUS','','Such insolence! None will leave Helheim while I rule!',26124),
(98499,'enUS','','What? This cannot be!',26124),
(98500,'enUS','','Her hold is weakening. She cannot keep us here!',26124),
(98501,'enUS','','No one leaves Helheim! No one!',26124),
(98502,'enUS','','Your terms were met, Helya. It seems even you must honor your word.',26124),
(98503,'enUS','','Nooooo!',26124),
(98504,'enUS','What is it you seek?','',26124),
(98505,'enUS','The $ct approaches! Knights, salute!','The $ct approaches! Knights, salute!',26124),
(98506,'enUS','The vault before you holds not gold, but wisdom.','',26124),
(98507,'enUS','Yotnar is its lock, and glory is its key.','',26124),
(98508,'enUS','Forge a key in the blood of champions, and perhaps the lock will turn.','',26124),
(98509,'enUS','Inside you will find paths... and more.','',26124),
(98510,'enUS','The trials are won, but your foe remains.','',26124),
(98511,'enUS','His tainted flock bars the halls of the righteous.','',26124),
(98512,'enUS','To sever this head, you must cripple the body.','',26124),
(98513,'enUS','But first... Stormheim\'s savior has someone very important to save.','',26124),
(98514,'enUS','I.. will not... yield!','',26124),
(98515,'enUS','At last! It seems I owe you another life, friend.','',26124),
(98516,'enUS','Let us stem this tide of filth!','',26124),
(98517,'enUS','No mercy for those who taint this land!','',26124),
(98518,'enUS','The demons keep coming! There must be another source!','',26124),
(98519,'enUS','I will fly you to the top when you are ready, friend.','',26124),
(98520,'enUS','Let us put an end to Skovald\'s minions once and for all!','',26124),
(98521,'enUS','Fool! You cannot hope to stop my endless army.','',26124),
(98522,'enUS','Hero, the eredar is shielding our foe!','',26124),
(98523,'enUS','My soldiers are limitless!','',26124),
(98524,'enUS','You cannot fight forever!','',26124),
(98525,'enUS','The tide of destruction is unending!','',26124),
(98526,'enUS','No! You cannot end... the endless...','',26124),
(98527,'enUS','We are done here, champion. Let us return to Havi.','',26124),
(98528,'enUS','The God-King\'s demon allies will no longer threaten Stormheim.','',26124),
(98529,'enUS','It is time you pursue Skovald into the high halls.','',26124),
(98530,'enUS','A great battle, a greater champion. Yes, you are worthy.','',26124),
(98531,'enUS','Enter Halls of Valor, champion. The greatest of glory awaits!','',26124),
(98532,'enUS','','They\'re trying to bring the ship down from the inside.',26124),
(98533,'enUS','Death Knights of Acherus, I send to you $n who will serve as the enforcer of my will. Follow his commands as you would my own.','',26124),
(98534,'enUS','For Huln, the War of the Ancients did not end at the Well of Eternity. With the Legion defeated, he focused on the monster that got away.','',26124),
(98535,'enUS','Be warned, the path ahead is quite dangerous. I can only provide you guidance and healing. Nothing more.','',26124),
(98536,'enUS','History is forged by the hearts of heroes, child. This is the truth your father wanted you to see.','',26124),
(98537,'enUS','Come now, High Chieftain. It is only an ettin. I\'m sure you will be fine.','',26124),
(98538,'enUS','Spiritwalker, have you any spells that might assist us with healing?','',26124),
(98539,'enUS','Insidia is all that remains of the flight in this tomb. We must be wary, one does not lift a weapon against a daughter of Deathwing without suffering consequences.','',26124),
(98540,'enUS','If it means freedom for my people, then I welcome any consequences she throws at us.','',26124),
(98545,'enUS','The High Chieftain asked for me to join him in this negotiation.$b$bThe Highmountain tribe is spoken of in our legends and remembered with reverence.$b$bIt was important that we show respect for such an ancient tribe.','',26124),
(98546,'enUS','It has been many years since my people swore our loyalty to the Horde.$b$bThe Horde aided my people in our time of need, and I am here to speak well of that accord.$b$bThe Highmountain tribe is known even to us in the North, and respect must be paid.','',26124),
(98547,'enUS','','I\'ll cover you. Go help Greymane!',26124),
(98548,'enUS','We make a good team, you and I. The alchemy table looks good as new!$b$bOne day we\'ll look back on this whole vrykul ghost mishap and have a good laugh. Thank you, $n!','',26124),
(98549,'enUS','Greetings champion.$b$bWe are dangerously low on allies in this land and the Highmountain tribe is the only tribe in known tauren history to lock horns with the Burning Legion.$b$bI am here to lend whatever aid they need so that they can unite under the same totem once again and join us in the fight against the Legion.','',26124),
(98550,'enUS','The dead are everywhere! Their souls must be sworn to Magnar.','',26124),
(98551,'enUS','The Ashbringer...','',26124),
(98552,'enUS','I have another question.','I have another question.',26124),
(98553,'enUS','','A fine task for the Coilskar. I am in agreement.',26124),
(98554,'enUS','','Let us be done with this business. A volcano is no place for naga.',26124),
(98555,'enUS','Milady, you will take your naga north. Disrupt the ritual the demons are performing at their Soul Engine.','Milady, you will take your naga north. Disrupt the ritual the demons are performing at their Soul Engine.',26124),
(98556,'enUS','','The Path of Huln was something I knew I might have to walk some day. I had just hoped I could wait until after dealing with Dargrul to walk it.$b$b',26124),
(98557,'enUS','Let us observe a moment of silence for a great soldier, leader, and friend. In the Light we are one, brother. Always.','',26124),
(98558,'enUS','So this is the Vault of Neltharian.$b$bNow I see why Wrathion was so eager to visit this place. The secrets here could easily turn the tide in any war.$b$bBut this place has been abandoned by the living for thousands of years.$B$bWe should be on our guard. There is no telling what sort of sorcery and traps were left behind.','',26124),
(98559,'enUS','We must stand together against the coming darkness. We must cast aside the shackles of race and kingdom. We must unite as one!','',26124),
(98560,'enUS','','We will see it done. I urge you to remember that the Black Temple is under attack.',26124),
(98561,'enUS','','Time is of the essence. Come, sisters, our former brethren await our tender mercies.',26124),
(98562,'enUS','Matron Mother, I need you to take your shivan across the gap to the Forge of Corruption. Make them suffer.','Matron Mother, I need you to take your shivan across the gap to the Forge of Corruption. Make them suffer.',26124),
(98563,'enUS','','Your gift is appreciated, $r. These potions will be most useful.',26124),
(98564,'enUS','Approach, $n.','',26124),
(98565,'enUS','Greetings, Leyweaver. I offer this gift in hopes that you will mend some silk for me.','Greetings, Leyweaver. I offer this gift in hopes that you will mend some silk for me.',26124),
(98566,'enUS','I would be honored.','I would be honored.',26124),
(98567,'enUS','Alright, let\'s see what we can do with this ore. First things first: we heat the ore.','',26124),
(98568,'enUS','Now let\'s see what we can make with it.','',26124),
(98569,'enUS','And now for the simple step of applying the flux. Lean in closely and watch my technique.','',26124),
(98570,'enUS','Then turn around and be recognized!','',26124),
(98571,'enUS','','I am in your debt, hero. Come. Let us destroy these demons together!',26124),
(98572,'enUS','Champion: The Skyfire is about to embark on an urgent mission. I must ask that you accompany them.','',26124),
(98573,'enUS','','Thank you, champion! Lead on. We must help the other defenders!',26124),
(98574,'enUS','','Enemy reinforcements headed this way!',26124),
(98575,'enUS','','Our enemies are launching a new attack!',26124),
(98576,'enUS','Report to Stormwind Harbor as soon as possible - they are under strict orders not to leave without you.','',26124),
(98577,'enUS','','Incoming! Defend the temple!',26124),
(98578,'enUS','','Orders? Do you need anything repaired before we head out?',26124),
(98579,'enUS','I trust that your valor and discretion will serve the Alliance well, as it always has. With honor, King Anduin Wrynn.','',26124),
(98580,'enUS','Yes, thank you, Nightsong. Will you see to my equipment?','Yes, thank you, Nightsong. Will you see to my equipment?',26124),
(98581,'enUS','','Another wave of attackers! Hold the line!',26124),
(98582,'enUS','','Fresh adversaries approach! Fight on!',26124),
(98583,'enUS','','New foes incoming! Brace yourselves!',26124),
(98584,'enUS','','By Elune! Clearly Ysera is beyond saving. All we can do is end her suffering.',26124),
(98585,'enUS','','We have no choice: Ysera must die. She would agree, were she in her right mind.',26124),
(98586,'enUS','','Stand in Elune\'s light, and her blessing will strengthen your attacks!',26124),
(98587,'enUS','','Shine your light down, Mother Moon, and lend us your strength!',26124),
(98588,'enUS','','O Elune, grant us your light and strengthen us for what we must do!',26124),
(98589,'enUS','','Let me bear the brunt of Ysera\'s attacks, hero. You can rely on me: I am quite sturdy.',26124),
(98591,'enUS','Shaping the ore...','',26124),
(98592,'enUS','Look how easily it bends...','',26124),
(98593,'enUS','The Light gives us strength.','',26124),
(98594,'enUS','Please address the gathered paladins on my behalf, Gryan.','Please address the gathered paladins on my behalf, Gryan.',26124),
(98595,'enUS','Come to me, my impish kin! We shall devour the power within!','',26124),
(98596,'enUS','You seem delirious!','',26124),
(98597,'enUS','But I am mysterious...','',26124),
(98598,'enUS','You\'ll catch me soon, friend...','',26124),
(98599,'enUS','Why... so serious...?','',26124),
(98600,'enUS','','The Blood Knights stand by you, Highlord $p. Azeroth will not fall!',26124),
(98601,'enUS','','Welcome to Skyhold! Here the brave live on forever!',26124),
(98602,'enUS','We pledge ourselves to your cause, Highlord!','',26124),
(98603,'enUS','','Champion, forgive the interruption. I bring an urgent message from the king.',26124),
(98604,'enUS','','Stormheim is home to one of the Pillars of Creation - the Aegis of Aggramar.',26124),
(98605,'enUS','','Vrykul legends speak of a trial - to conquer this trial is to prove one\'s worth, and lay claim to the Aegis.',26124),
(98606,'enUS','','Our official orders are to escort you to Stormheim and ensure your success on this trial.',26124),
(98607,'enUS','','Impressive, aren\'t they? The new guns could bag a wyvern at full speed from three hundred meters. Go ahead, have a look.',26124),
(98608,'enUS','I\'ll just be upstairs so I can better observe your actions... at a safe distance.','',26124),
(98609,'enUS','','Unofficially, however, we have another mission...',26124),
(98610,'enUS','','The 7th Legion. The toughest men and women the Alliance has to offer. They, too, have come on direct orders from the king.',26124),
(98611,'enUS','','Three days ago, the Forsaken fleet set sail from Durotar, heading straight for the Broken Isles. We think Sylvanas Windrunner herself may be among them.',26124),
(98612,'enUS','','We are to track them from a safe distance. We may engage, but only if the situation demands.',26124),
(98613,'enUS','','I strongly suspect the situation will demand it.',26124),
(98614,'enUS','It had better.','',26124),
(98615,'enUS','I am not in the habit of tracking prey unless I intend on killing it.','',26124),
(98616,'enUS','','Preparations are nearly complete. Please make yourselves comfortable.',26124),
(98617,'enUS','The spider fortress, the soul engine, and the forge are their primary targets. The Servants of Illidan must succeed.','',26124),
(98618,'enUS','It worked?! I mean... it worked! Of course it did. That\'s excellent news.','',26124),
(98619,'enUS','Alright, let me see the gauntlet.','',26124),
(98620,'enUS','Are you ready to fly? You\'ll have our fastest mount.','',26124),
(98621,'enUS','Take me to the Broken Shore.','Take me to the Broken Shore.',26124),
(98622,'enUS','','Let me help you get where you want to go. As you travel through the Broken Isles I will be able to get new destinations from you as well! Keep exploring!',26124),
(98623,'enUS','Dalaran.','Dalaran.',26124),
(98624,'enUS','Stormheim.','Stormheim.',26124),
(98625,'enUS','Azsuna.','Azsuna.',26124),
(98626,'enUS','Val\'sharah.','Val\'sharah.',26124),
(98627,'enUS','Highmountain.','Highmountain.',26124),
(98628,'enUS','Suramar.','Suramar.',26124),
(98629,'enUS','','I have a wide selection of recipes available.',26124),
(98630,'enUS','What can you tell me about this alchemy table?','What can you tell me about this alchemy table?',26124),
(98631,'enUS','Gotcha!','Gotcha!',26124),
(98632,'enUS','Hehe!','Hehe!',26124),
(98633,'enUS','That one\'s free!','That one\'s free!',26124),
(98634,'enUS','Oof! That had to hurt.','Oof! That had to hurt.',26124),
(98635,'enUS','','Champion: As your new Warchief, I share with you the burden of securing our future.',26124),
(98636,'enUS','','To that end, my fleet is preparing to sail for the Broken Isles. When you set foot in Stormheim, you shall have the full power of the Forsaken at your back.',26124),
(98637,'enUS','','Make the journey with us. Together, we will ensure that no one can oppose the might of the Horde!',26124),
(98638,'enUS','','Isn\'t our alchemy table wonderful? Deucus spent years assembling the components. He\'s so proud of it!',26124),
(98639,'enUS','It\'s a shame what happened to the alchemy table.','It\'s a shame what happened to the alchemy table.',26124),
(98640,'enUS','Hey!','Hey!',26124),
(98641,'enUS','','Are you familiar with the vrykul? Towering, brutish warriors from an ancient stock. Subtlety is not a value they hold in high regard.',26124),
(98642,'enUS','Wow, that\'s cold!','Wow, that\'s cold!',26124),
(98643,'enUS','Haha. This is great!','Haha. This is great!',26124),
(98644,'enUS','I\'m gonna get you next!','I\'m gonna get you next!',26124),
(98645,'enUS','','That awful Svena made a mess of the alchemy table. Poor Deucus! I know he hides it, but he\'s heartbroken.$b$bI certainly hope you can help him finish rebuilding it!',26124),
(98646,'enUS','','Their legends speak of the Aegis of Aggramar. To claim it, one must undergo some kind of trial. One must be... worthy.',26124),
(98647,'enUS','The alchemy table looks good as new!','The alchemy table looks good as new!',26124),
(98648,'enUS','','The alchemy table looks terrific! Deucus is so relieved. Thank you for all the work you did restoring it.$b$bHere\'s hoping we don\'t see another vrykul ghost in the shop ever again!',26124),
(98649,'enUS','I\'d like to buy from you.','I\'d like to buy from you.',26124),
(98650,'enUS','','The new catapults are faster and more powerful than ever before. I have our goblin allies to thank for that.',26124),
(98651,'enUS','','I trust you are more than capable of handling whatever trials stand between you and the Aegis.',26124),
(98652,'enUS','','Truthfully, Stormheim holds another treasure. One that I will be pursuing by my own means.',26124),
(98653,'enUS','','<Setting her vigil aside for a moment, the majestic druid turns to look at you. Her dark eyes widen in recognition and warmth.>$b$b<Without a word, she makes it clear that you will always be welcome here.>',26124),
(98654,'enUS','','Nathanos has been training a new generation of rangers. They represent both our past, and our future.',26124),
(98655,'enUS','','I think often about our future, hero. My people cannot reproduce. Are we not destined, then, to wither away eventually?',26124),
(98656,'enUS','','No. The Forsaken will never stop fighting.',26124),
(98657,'enUS','','Not while I reign. Not when there are still beings out there with the power to stop death.',26124),
(98658,'enUS','','News from Captain Dreadwake, my lady. They have found the temple.',26124),
(98659,'enUS','','The Oblivion has landed nearby. They are building fortifications now and will be ready to lay siege at your command.',26124),
(98660,'enUS','','Good. Send a bat - tell them we are leaving shortly.',26124),
(98661,'enUS','To hammer the metal is to hammer yourself. How far are you willing to bend, greenhorn?','',26124),
(98662,'enUS','%s eyes Reylar the Stormcaller cautiously.','',26124),
(98663,'enUS','What sorts of things do you sell?','What sorts of things do you sell?',26124),
(98664,'enUS','Do not simply use your arm to swing the hammer. You have your torso, your legs, your spirit.','',26124),
(98665,'enUS','Do not be a slave to your hammer. It is an extension of your arm. YOU are its master.','',26124),
(98666,'enUS','','I sell the recipes that Deucus and I research together. As we learn new ones, I add them to my inventory.$b$bBe sure to check back from time to time to see if anything new is available!',26124),
(98667,'enUS','We will send Gul\'dan\'s filth to the bottom of the sea!','',26124),
(98668,'enUS','You there! I require a moment of your time.','',26124),
(98669,'enUS','','I am the chosen of Eyir! What chance do think you have?',26124),
(98670,'enUS','','I live. I die. I...',26124),
(98671,'enUS','We have a lot of work ahead of us to fix the alchemy table!','',26124),
(98672,'enUS','We did it! The alchemy table looks good as new!$b$bWith my brains and your brawn, we make a great team. Thank you, $n!','',26124),
(98673,'enUS','Lord Shadowbreaker will be expecting you, $n. This way.','',26124),
(98674,'enUS','Lord Shadowbreaker, the Highlord would like to peruse the reconnaissance you\'ve gathered on the Broken Isles.','',26124),
(98675,'enUS','This is my favorite holiday!','This is my favorite holiday!',26124),
(98676,'enUS','Snow for everyone!','Snow for everyone!',26124),
(98677,'enUS','Snowball incoming!','Snowball incoming!',26124),
(98678,'enUS','You go SQUISH!','',26124),
(98679,'enUS','','',26124),
(98680,'enUS','','',26124),
(98681,'enUS','','',26124),
(98682,'enUS','','',26124),
(98683,'enUS','','',26124),
(98684,'enUS','','',26124),
(98685,'enUS','These spirit winds are relentless! We cannot walk through.','',26124),
(98686,'enUS','%s ponders the situation at hand.','',26124),
(98687,'enUS','I can charge from here.','',26124),
(98688,'enUS','His madness infects his guards, they do not recognize me.','',26124),
(98689,'enUS','Watch out!','',26124),
(98690,'enUS','That door is sealed with lightning. We must find a way through!','',26124),
(98691,'enUS','Like I always say, if you can\'t reach it, throw something at it. Never fails!','',26124),
(98692,'enUS','Here we are... Magnar\'s chamber!','',26124),
(98694,'enUS','I am ready.','I am ready.',26124),
(98695,'enUS','Knights of the Ebon Blade! Assemble as we honor one of our own!','',26124),
(98696,'enUS','You have all heard the legends of countless battles fought... of trials overcome at great cost.','',26124),
(98697,'enUS','His exemplary deeds in the name of the Ebon Blade have shown him to be one of the best of us, worthy of our highest honor.','',26124),
(98699,'enUS','By the will of the Lich King and upon my authority as Highlord, I declare that $n, wielder of the Blades of the Fallen Prince, will henceforth be known as Deathlord of the Ebon Blade.','',26124),
(98700,'enUS','By the will of the Lich King and upon my authority as Highlord, I declare that $n, wielder of the Maw of the Damned, will henceforth be known as Deathlord of the Ebon Blade.','',26124),
(98701,'enUS','By the will of the Lich King and upon my authority as Highlord, I declare that $n, wielder of Apocalypse, will henceforth be known as Deathlord of the Ebon Blade.','',26124),
(98702,'enUS','<As you approach, the regal druid regards you with friendly curiosity.>$b$b<After a moment, he gives a chuff of approval and lowers his stately head before you.>','',26124),
(98703,'enUS','You will all bow to him as you once did to me, and carry out his will against the Legion!','',26124),
(98704,'enUS','There is no time! Xavius must be stopped!','',26124),
(98705,'enUS','','Easy now. This remedy takes time. You must rest.',26124),
(98706,'enUS','S - Save the temple! <choking sound> Hurry!','',26124),
(98707,'enUS','Ysera is going to destroy the Temple of Elune!','',26124),
(98708,'enUS','','The Wardens seek our help? Things must be desperate.',26124),
(98709,'enUS','','Ahhhh, it feels good to MOVE again. Thank you, $n.',26124),
(98710,'enUS','','$n, it has been a long time since Mardum. I am ready for another fight.',26124),
(98711,'enUS','','We will need weapons and supplies if we are to break out of here. I am on it, $n.',26124),
(98712,'enUS','','Years and years with only the voices in my head. I thought I would go insane.',26124),
(98713,'enUS','What a wonderful time of year!','What a wonderful time of year!',26124),
(98714,'enUS','No matter how many presents there are, we could always use more!','No matter how many presents there are, we could always use more!',26124),
(98715,'enUS','\'Tis the season!','\'Tis the season!',26124),
(98716,'enUS','Happy holidays!','Happy holidays!',26124),
(98717,'enUS','Come here goaties!','',26124),
(98718,'enUS','Stop moving! Me can\'t keep track.','',26124),
(98719,'enUS','You too fast. Stay!','',26124),
(98720,'enUS','Hello again, Linzy. What\'s new with you?','Hello again, Linzy. What\'s new with you?',26124),
(98721,'enUS','','Oh, you know, nothing much. Just helped move an entire city from the frozen north to a haunted keep, then on to a chain of demon-infested islands! All in a day\'s work, I suppose.$b$bI\'m semi-retired these days, so having Deucus take over has been wonderful. He\'s a good sort... if perhaps a bit overly fond of his alchemy table!',26124),
(98722,'enUS','Here to pillage our wares, demon?! You shall take NOTHING!','',26124),
(98723,'enUS','Wait! Stop! You\'re... you\'re no demon...','',26124),
(98724,'enUS','Sounds like an exciting life!','Sounds like an exciting life!',26124),
(98725,'enUS','The fog has lifted and I can see the truth once more. Thank you, $pc. If you would join me at my old shop, perhaps we can speak further.','',26124),
(98726,'enUS','','I admit, I never would have guessed that my work as an alchemist would be so thrilling!$b$bBut look who I\'m talking to... you\'ve seen far more adventure than I have!',26124),
(98727,'enUS','','Wake up, demon hunter.',26124),
(98729,'enUS','How have you fared since Northrend?','How have you fared since Northrend?',26124),
(98730,'enUS','','I have been well, $n. The fall of the Lich King was a wonder to behold. If only all of Northrend\'s troubles had been solved by that victory.$b$bAh, but the past is the past. It feels great for Dalaran to be on the front lines of a new campaign! Though I admit, I\'m grateful you\'re out there fighting the battles instead of me.',26124),
(98731,'enUS','','Take up your weapons, $n. I trust you can still handle a blade.',26124),
(98732,'enUS','I will burn this world with my fury!','',26124),
(98734,'enUS','','I will need your help to stop Gul\'dan. Free the other Illidari, quickly!',26124),
(98735,'enUS','I also wanted to ask about...','I also wanted to ask about...',26124),
(98736,'enUS','The Highlord\'s will be done.','',26124),
(98737,'enUS','Time for answers later. There are demons to kill.','',26124),
(98738,'enUS','The demons aim to destroy our world. We need to release our allies.','',26124),
(98739,'enUS','Well now, you have been turnin\' quite a lot of heads lately amongst the Explorer\'s League.$b$bOl\' Ebonhorn here seemed to know who I was and asked fer me to come help ya on this next journey.$b$bI hope ya don\'t mind but I dusted off me ol\' Talas here. I heard there were ettins involved and figured we could use us some heavy metal.','',26124),
(98740,'enUS','','It worked! $GHe\'s:She\'s; alive!',26124),
(98741,'enUS','','Of course it worked! I\'ve woken up things that were twice as dead for three times as long. This one was easy.',26124),
(98742,'enUS','I will stay here and await Gryan\'s return, Highlord.','',26124),
(98743,'enUS','The altar lies just behind you, Highlord.','',26124),
(98744,'enUS','Thork - the northern portal is destroyed! We will push forward beyond Grol\'dom and make way toward the north.','',26124),
(98745,'enUS','Place the blade on the altar when you are ready. The Light will be our forge.','',26124),
(98746,'enUS','','Our way is clear! Let\'s get to the top of the tower!',26124),
(98747,'enUS','','You go ahead, I\'ll report back to Greymane. Good luck, champion.',26124),
(98748,'enUS','','Now\'s our chance. Let\'s get up that tower!',26124),
(98749,'enUS','','You\'re on your own from here. Good luck!',26124),
(98750,'enUS','I am free! You are a true savior, outsider.','',26124),
(98751,'enUS','But we haven\'t time for pleasantries, I must rally the Thorignir!','',26124),
(98752,'enUS','Speak to Vethir, he will take you to the summit!','',26124),
(98753,'enUS','','I hope Maiev was right about freeing you, demon hunter. Go on - I will hold the line.',26124),
(98754,'enUS','Your efforts are fruitless, demon hunter. Lord Gul\'dan sees all.','',26124),
(98755,'enUS','Hey, you lot! If you need a quick pick-me-up, come and get a Rivermane Remedy!','',26124),
(98756,'enUS','I\'ll let the others know of your gift, $n. Thank you again.','',26124),
(98757,'enUS','','So HE is the key to Azeroth\'s downfall.',26124),
(98758,'enUS','','We\'ve arranged a flight directly to Dalaran for you, Highlord.',26124),
(98759,'enUS','I live to serve.','',26124),
(98760,'enUS','My life for the Legion.','',26124),
(98761,'enUS','You will not gain the keystone.','',26124),
(98762,'enUS','Brood Queen Tyranna orders your death.','',26124),
(98763,'enUS','My blade will cut through you.','',26124),
(98764,'enUS','You are outmatched and outnumbered.','',26124),
(98765,'enUS','This is where you die.','',26124),
(98766,'enUS','We will cleanse the universe in fire.','',26124),
(98767,'enUS','Interested in representing your guild here in Frostwall?','Interested in representing your guild here in Frostwall?',26124),
(98768,'enUS','Azsuna was once home to the great city of Nar\'thalas - one of the centerpieces of night elven civilization. It is a fine place to start our efforts against the Legion.','',26124),
(98769,'enUS','This portal will take us to the western shore of the island not far from the city. Let\'s get down there, shall we?','',26124),
(98770,'enUS','Little candles burn bright!','',26124),
(98771,'enUS','Hot Hot Hot!!!','',26124),
(98772,'enUS','AIIIEEEEeeeee','',26124),
(98773,'enUS','You have proven yourself a powerful hero, outsider. \n\nToday, you may also consider yourself a friend of the Thorignir.','',26124),
(98774,'enUS','Candle burn too bright!!!','',26124),
(98775,'enUS','Before we proceed, I would like to bestow upon you a gift of the Thorignir.\n\nRaise your weapon, outsider, and brace yourself. This may prove uncomfortable for your kind.','',26124),
(98776,'enUS','I am prepared to receive your gift.','I am prepared to receive your gift.',26124),
(98777,'enUS','Before us this day stands our comrade in arms, $n.','',26124),
(98778,'enUS','Patricia! Would you be so kind as to show our friend here the newest recipes we\'ve discovered?','',26124),
(98779,'enUS','','I\'d be happy to! Have a look at my stock, $n.',26124),
(98780,'enUS','Just make sure $Ghe:she; doesn\'t make a mess on my alchemy table!','',26124),
(98781,'enUS','','Yes, yes... We all know how attached you are to your alchemy table!',26124),
(98782,'enUS','','Hey, you\'re alive!',26124),
(98783,'enUS','Kayn and Altruis have already gone ahead. Take this felbat and join them.','',26124),
(98785,'enUS','Highlord, may I speak with you for a moment?','',26124),
(98786,'enUS','Battle is upon us, $n. Prepare yourself!','Battle is upon us, $n. Prepare yourself!',26124),
(98787,'enUS','These lands are in peril. Be careful.','These lands are in peril. Be careful.',26124),
(98788,'enUS','The battlefield could use more heroes like you, $n.','The battlefield could use more heroes like you, $n.',26124),
(98789,'enUS','I don\'t remember what happened...','I don\'t remember what happened...',26124),
(98790,'enUS','Thank you. I need time to recover.','Thank you. I need time to recover.',26124),
(98791,'enUS','Are you ready to face Magnar with me, $n?','',26124),
(98792,'enUS','Feelin\' fine.','',26124),
(98793,'enUS','I will protect you, Hruthnir.','I will protect you, Hruthnir.',26124),
(98794,'enUS','<Silgryn is shaking uncontrollably and can barely speak.>','',26124),
(98795,'enUS','I am, as you will be. Come, let us go to the Halls of Valor. This mortal warrior will find the revenge you crave...','',26124),
(98796,'enUS','Come with me now, let us dine with Odyn tonight.','',26124),
(98797,'enUS','I... have fallen. Hruthnir... you are a valarjar?','',26124),
(98798,'enUS','I see now. My weapons are yours, warrior. May they bring you glory as you strike down Helya\'s minions!','',26124),
(98799,'enUS','Begone from here, trespassers!','',26124),
(98800,'enUS','ENOUGH OF THIS! Guards, punish these outsiders for their insolence!','',26124),
(98801,'enUS','I work all this time to improve the forges and do I get a single word of thanks? No!','',26124),
(98802,'enUS','Make the weapons better, Corvus! Saronite isn\'t good enough anymore, Corvus! .. Bah! I\'ll show them what I can do to a blade.','',26124),
(98803,'enUS','This tropic air is too damp, makes me feel like there\'s flesh hanging from my bones again.','',26124),
(98804,'enUS','It wouldn\'t have taken years to rebuild the forges if I had some help!','',26124),
(98805,'enUS','What can Corvus do for you?','',26124),
(98806,'enUS','','Hold the line, demon hunters. We fight in Lord Illidan\'s name!',26124),
(98807,'enUS','Stand firm. Do not let them break through!','',26124),
(98808,'enUS','The Dreamgrove is spread thin these days, I fear.$b$bMalorne\'s Refuge is a bastion of druidic power in the Broken Isles. We cannot let it fall.','The Dreamgrove is spread thin these days, I fear.$b$bMalorne\'s Refuge is a bastion of druidic power in the Broken Isles. We cannot let it fall.',26124),
(98809,'enUS','Satyr have invaded our grove. They were once night elves, but pledged themselves to the Legion and became twisted by demonic magic. Such creatures have no place in nature.','Satyr have invaded our grove. They were once night elves, but pledged themselves to the Legion and became twisted by demonic magic. Such creatures have no place in nature.',26124),
(98810,'enUS','|TInterface\\Icons\\ability_druid_galewinds.blp:20|t |cFFFF0000|Hspell:191797|h[Violent Winds]|h|r are picking up from the |cFFFF0000North|r!','',26124),
(98811,'enUS','|TInterface\\Icons\\ability_druid_galewinds.blp:20|t |cFFFF0000|Hspell:191797|h[Violent Winds]|h|r are picking up from the |cFFFF0000East|r!','',26124),
(98812,'enUS','|TInterface\\Icons\\ability_druid_galewinds.blp:20|t |cFFFF0000|Hspell:191797|h[Violent Winds]|h|r are picking up from the |cFFFF0000South|r!','',26124),
(98813,'enUS','|TInterface\\Icons\\ability_druid_galewinds.blp:20|t |cFFFF0000|Hspell:191797|h[Violent Winds]|h|r are picking up from the |cFFFF0000West|r!','',26124),
(98814,'enUS','View available missions.','View available missions.',26124),
(98815,'enUS','Have you heard the tale of the White Stag and the Moon? It is said the tauren hunted Malorne and nearly cornered him. To escape, he leapt into the sky, but his antlers became tangled in the stars.$b$bNo matter how he struggled, he remained trapped. When the moon goddess Elune found him there, she offered to free him if he would love her and end her solitude.$b$bAh, but that is only one version of the myth, a tale shaped by the proud hunters who have passed it down for generations.','Have you heard the tale of the White Stag and the Moon? It is said the tauren hunted Malorne and nearly cornered him. To escape, he leapt into the sky, but his antlers became tangled in the stars.$b$bNo matter how he struggled, he remained trapped. When the moon goddess Elune found him there, she offered to free him if he would love her and end her solitude.$b$bAh, but that is only one version of the myth, a tale shaped by the proud hunters who have passed it down for generations.',26124),
(98816,'enUS','Just a few more minutes here...  She will be seaworthy shortly!','',26124),
(98817,'enUS','Thank you, $n. I will fight by your side.','Thank you, $n. I will fight by your side.',26124),
(98818,'enUS','Please - allow me to repay you with my services.','Please - allow me to repay you with my services.',26124),
(98819,'enUS','It would be an honor to fight alongside you in battle, $n.','It would be an honor to fight alongside you in battle, $n.',26124),
(98820,'enUS','For honor!','For honor!',26124),
(98821,'enUS','We fight together until the end, $n.','We fight together until the end, $n.',26124),
(98822,'enUS','Some tales say that Malorne fell in love with the goddess of the moon during the world\'s first nightfall.$b$bHer light guided him through the woods and showed him he was not alone. It banished fear and brought hope.$b$bMany creatures have loved the moon and pursued her to madness. She grants light as she will, on her own timetable, and moonlight cannot be captured or possessed.$b$bEven so, night after night, the White Stag chased her across the skies. He grew so swift and strong that at last he succeeded in reaching her.$b$bShe was so moved by his devotion and beauty that she made him her consort. To this day he loves the wilds best when they are lit by her radiance.','Some tales say that Malorne fell in love with the goddess of the moon during the world\'s first nightfall.$b$bHer light guided him through the woods and showed him he was not alone. It banished fear and brought hope.$b$bMany creatures have loved the moon and pursued her to madness. She grants light as she will, on her own timetable, and moonlight cannot be captured or possessed.$b$bEven so, night after night, the White Stag chased her across the skies. He grew so swift and strong that at last he succeeded in reaching her.$b$bShe was so moved by his devotion and beauty that she made him her consort. To this day he loves the wilds best when they are lit by her radiance.',26124),
(98823,'enUS','Show me what missions you have prepared.','Show me what missions you have prepared.',26124),
(98824,'enUS','Tell me about Azsuna and Val\'Sharah.','Tell me about Azsuna and Val\'Sharah.',26124),
(98825,'enUS','Tell me about Stormheim and Highmountain.','Tell me about Stormheim and Highmountain.',26124),
(98826,'enUS','[TEMP] Click on each gossip option to view half of the available zone options. You can only pick one of the four available initially. This will eventually be on the mission map.','[TEMP] Click on each gossip option to view half of the available zone options. You can only pick one of the four available initially. This will eventually be on the mission map.',26124),
(98827,'enUS','Please, if you find anything which can keep this hunger at bay, bring it to me.','',26124),
(98828,'enUS','The cravings have stopped. For now.','',26124),
(98829,'enUS','Ah, I can feel the magic coursing through me. I am whole again.','',26124),
(98830,'enUS','I surge with power! I cannot possibly contain any more.','',26124),
(98831,'enUS','Take Candle','Take Candle',26124),
(98832,'enUS','Thank you, outsider. I will make my way to the summit.','',26124),
(98833,'enUS','I know not why you came, but you have my gratitude.','',26124),
(98834,'enUS','These foul demons will pay for their treachery!','',26124),
(98835,'enUS','I was... nearly broken... You have my thanks.','',26124),
(98836,'enUS','','Feelin\' fine. [PH]',26124),
(98837,'enUS','Thank you so much $c! That dog was going to eat me!','',26124),
(98838,'enUS','','This road isn\'t safe, adventurer.\n\nKobolds attacked our caravan and made off with the soul chambers we were meant to deliver to Allari for interrogation.',26124),
(98839,'enUS','','I will honor Uriah\'s memory by delivering the soul chambers to Allari as planned.',26124),
(98840,'enUS','Shrug off your wounds, warriors! Another battle awaits!','',26124),
(98841,'enUS','Rosalyn! Where is Rosalyn?!','',26124),
(98842,'enUS','Yes! $n is here! We have a chance warriors, one more charge! LOK\'TAR!','',26124),
(98843,'enUS','Did I just see one of the gateways activate?','',26124),
(98844,'enUS','I want a full report now!','',26124),
(98845,'enUS','','I have to go. Kayn\'s called me back to handle something. He probably needs help killing a demon.',26124),
(98846,'enUS','Demon hunters are using the gateways!','',26124),
(98847,'enUS','Inquisitor Baleful? Who is this? Speak!','',26124),
(98848,'enUS','','Last I saw, Kor\'vas cut a swath of destruction on her way across the bridge.',26124),
(98849,'enUS','','Whatever you choose, it will feel good to use more of the Legion\'s power against them.',26124),
(98850,'enUS','','Whoever this is, you\'re caught in my web now.',26124),
(98851,'enUS','','Your attempt to gain my lord Sargeras\'s keystone will fail.',26124),
(98852,'enUS','Hmm... it would appear that they\'re on to us, $n.','',26124),
(98853,'enUS','Like Malorne himself, we spend most of our time in the wilds.$b$bIn these dire times, however, seclusion is a luxury no one can afford. We must stand together, or we will surely fall.','Like Malorne himself, we spend most of our time in the wilds.$b$bIn these dire times, however, seclusion is a luxury no one can afford. We must stand together, or we will surely fall.',26124),
(98854,'enUS','Val\'sharah has remained tranquil for ages, until recently. We\'ve underestimated the danger. Have no fear, champion. We will not be caught by surprise again.','Val\'sharah has remained tranquil for ages, until recently. We\'ve underestimated the danger. Have no fear, champion. We will not be caught by surprise again.',26124),
(98855,'enUS','Those things spew fel energy, corrupting everything they touch.','',26124),
(98856,'enUS','Beliash\'s eredar are using those portals to summon in demonic reinforcements.','',26124),
(98857,'enUS','We\'re vulnerable while they remain active.','',26124),
(98858,'enUS','We\'ve taken the foothold, but with some losses.','',26124),
(98859,'enUS','They\'re bombarding the pass into the volcano.','',26124),
(98860,'enUS','More than ten millennia ago, Malorne and many other powerful ancients fought the Burning Legion\'s demons when they first invaded Azeroth.$b$bHe died nobly during the war, sacrificing his life so that his injured son, Cenarius, could be brought to safety and healing.$b$bNo parent could wish for a nobler death than to die protecting a child.$b$bHowever, let me be clear: to ancients like Malorne, we are all their children. We are fortunate that he has been restored to life and returned to us.','More than ten millennia ago, Malorne and many other powerful ancients fought the Burning Legion\'s demons when they first invaded Azeroth.$b$bHe died nobly during the war, sacrificing his life so that his injured son, Cenarius, could be brought to safety and healing.$b$bNo parent could wish for a nobler death than to die protecting a child.$b$bHowever, let me be clear: to ancients like Malorne, we are all their children. We are fortunate that he has been restored to life and returned to us.',26124),
(98861,'enUS','','Many centuries ago, I was the leader of the Skyhorn tribe. Never have I seen this sort of desecration of our ancient burial ground!',26124),
(98862,'enUS','|TInterface\\Icons\\ability_rogue_venomouswounds:20|tYou are afflicted with |cFFFF0000|Hspell:191855|h[Toxic Wound]|h|r!','',26124),
(98863,'enUS','I not say you take candle!','',26124),
(98864,'enUS','You no take green candle!','',26124),
(98865,'enUS','What you doing here?! All candles my candles! See big horns?!','',26124),
(98866,'enUS','You... no... take... candle...','',26124),
(98867,'enUS','Wait, you not real kobold!','',26124),
(98868,'enUS','You\'ve fought well, champion. The time has come for me to venture onward.','You\'ve fought well, champion. The time has come for me to venture onward.',26124),
(98869,'enUS','I\'ve enjoyed fighting by your side, but I must be going now. Be safe!','I\'ve enjoyed fighting by your side, but I must be going now. Be safe!',26124),
(98870,'enUS','I am being summoned elsewhere. Until our next adventure, friend!','I am being summoned elsewhere. Until our next adventure, friend!',26124),
(98871,'enUS','Fight... to the death...','Fight... to the death...',26124),
(98872,'enUS','Never... give up...','Never... give up...',26124),
(98873,'enUS','Not like this...','Not like this...',26124),
(98874,'enUS','My forces are legion! Your efforts are futile!','',26124),
(98875,'enUS','It has been an honor fighting by your side.','It has been an honor fighting by your side.',26124),
(98877,'enUS','Don\'t think I\'ll make it through this one.','Don\'t think I\'ll make it through this one.',26124),
(98878,'enUS','This will be interesting.','This will be interesting.',26124),
(98879,'enUS','This one\'s mine.','This one\'s mine.',26124),
(98880,'enUS','With pleasure.','With pleasure.',26124),
(98881,'enUS','Die scum!','Die scum!',26124),
(98882,'enUS','You will see your grave soon enough, $n.','You will see your grave soon enough, $n.',26124),
(98883,'enUS','For the Horde!','For the Horde!',26124),
(98884,'enUS','Help me out with this one!','Help me out with this one!',26124),
(98885,'enUS','My life... for the Horde.','My life... for the Horde.',26124),
(98887,'enUS','','Together we will imprison these demons once again.',26124),
(98890,'enUS','Choosing','Choosing',26124),
(98891,'enUS','I live!','',26124),
(98892,'enUS','','I live!',26124),
(98893,'enUS','I live!','',26124),
(98894,'enUS','Ahh, to breathe again!','',26124),
(98895,'enUS','','Ahh, to breathe again!',26124),
(98896,'enUS','Ahh, to breathe again!','',26124),
(98897,'enUS','Bless you, stranger!','',26124),
(98898,'enUS','','Bless you, stranger!',26124),
(98899,'enUS','Bless you, stranger!','',26124),
(98900,'enUS','You have my gratitude, traveler.','',26124),
(98901,'enUS','','You have my gratitude, traveler.',26124),
(98902,'enUS','You have my gratitude, traveler.','',26124),
(98903,'enUS','I felt myself slipping away...','',26124),
(98904,'enUS','','I felt myself slipping away...',26124),
(98905,'enUS','I felt myself slipping away...','',26124),
(98906,'enUS','You... you have saved me!','',26124),
(98907,'enUS','','You... you have saved me!',26124),
(98908,'enUS','You... you have saved me!','',26124),
(98909,'enUS','','The Legion empowers me!',26124),
(98910,'enUS','','The Feltotem... will be... your end.',26124),
(98911,'enUS','Enough! I will break you myself!','',26124),
(98913,'enUS','Let me show you how my fire can not only destroy homes, but lives!','',26124),
(98914,'enUS','In death I return to ash.','',26124),
(98915,'enUS','','The demon is weak enough for me to begin the containment spell. This should only take a moment.',26124),
(98916,'enUS','','There are many who opposed him, but Illidan was right all along. We are the weapons that will bring down the Burning Legion.',26124),
(98920,'enUS','He is too strong! Our only hope is to reactivate the orbs and seal him inside the chamber!','',26124),
(98921,'enUS','','This affront to nature cannot stand. These are our lands!',26124),
(98922,'enUS','We are holding the demon back, but at great cost! I only have a few demon hunters left. We could use your help.','',26124),
(98924,'enUS','Master, you\'re here! Let us return this foul creature to the Twisting Nether.','',26124),
(98933,'enUS','[Placeholder Event: I get stunned!]','[Placeholder Event: I get stunned!]',26124),
(98934,'enUS','The shield is broken! Quickly, everyone out while the creature is stunned!','',26124),
(98935,'enUS','$n, the creature\'s destructive beam is focused upon me. Redirect the final mirror to shatter its shield!','',26124),
(98936,'enUS','','We can\'t break through the demon\'s defenses. We need to reactivate the warden\'s trap to disable him!',26124),
(98937,'enUS','It is time you be given a position that befits your accomplishments, $n.','',26124),
(98938,'enUS','Push them back! The Horde will not succumb to Legion swine!','',26124),
(98939,'enUS','The bear in the cave up ahead has immense power. He has been terrorizing Thunder Totem for a long time. He is too grand to put down... $b$b$p, I need you to help me weaken him so I can tame him. Will you help?','',26124),
(98940,'enUS','Let\'s do this.','Let\'s do this.',26124),
(98941,'enUS','','We\'ll see to securing the caverns. Thanks for your help, hero!',26124),
(98942,'enUS','This table lists all of your currently available missions.','This table lists all of your currently available missions.',26124),
(98943,'enUS','Show me any available missions.','Show me any available missions.',26124),
(98944,'enUS','Alright, $p. He\'s right up here. Follow me!','',26124),
(98945,'enUS','Your pathetic resistance only delays the inevitable. All will die to the Legion!','',26124),
(98946,'enUS','Is that the best you can manage, weaklings? A few scratches?','',26124),
(98947,'enUS','Enough of this! Face your destruction!','',26124),
(98948,'enUS','You... you yet stand. Impossible!','',26124),
(98949,'enUS','You will DIE like the insect you are!','',26124),
(98950,'enUS','Death comes... but I will take you with me!','',26124),
(98951,'enUS','You will be mine, Arru!','',26124),
(98952,'enUS','Ah, the disciple returns triumphant! You\'ve done well to remember the lessons I\'ve taught you.','',26124),
(98953,'enUS','','You\'ve made quite the name for yourself, $n. It\'s good to see my instruction wasn\'t wasted.',26124),
(98954,'enUS','$n! Welcome back! Don\'t you just love the smell of hot steel in the morning?','',26124),
(98955,'enUS','How may I help you?','',26124),
(98956,'enUS','We will not last much longer if those devastators are not destroyed!','',26124),
(98957,'enUS','Come on, let\'s get up there!','',26124),
(98958,'enUS','Have you come to cure us all, $n?','',26124),
(98960,'enUS','Eons ago, Sargeras created Mardum to imprison demons. He also created the Sargerite Keystone to lock them away.\n\nBut when the Titan decided to burn all of creation, he shattered Mardum, sending its fragments hurtling throughout the Twisting Nether. Thus was born the Burning Legion.\n\nSargeras safeguarded his keystone on this particular fragment. It\'s a \'skeleton key\', allowing access to any Legion world. It\'s also the key to Lord Illidan\'s plan for the Legion\'s destruction.','',26124),
(98961,'enUS','You may unlearn your current Class Specialization for a price, so that you may select a new one.\n\nThis will become more expensive each additonal time you do so.','You may unlearn your current Class Specialization for a price, so that you may select a new one.\n\nThis will become more expensive each additonal time you do so.',26124),
(98962,'enUS','Yes?','Yes?',26124),
(98963,'enUS','Can you give me a lift back to the Foothold?','Can you give me a lift back to the Foothold?',26124),
(98964,'enUS','You may unlearn all of your current Talents for a price, so that you may select new ones.\n\nThis will become more expensive each additonal time you do so.','You may unlearn all of your current Talents for a price, so that you may select new ones.\n\nThis will become more expensive each additonal time you do so.',26124),
(98965,'enUS','I lend you my power Hyrja!','',26124),
(98966,'enUS','You may empty all of your current Glyph slots for a price, so that you may select new ones.\n\nThis will become more expensive each additonal time you do so.','You may empty all of your current Glyph slots for a price, so that you may select new ones.\n\nThis will become more expensive each additonal time you do so.',26124),
(98967,'enUS','Naman and I will hold out here.','',26124),
(98968,'enUS','','Your name... it\'s familiar. I believe this is the hero the others were talking about.',26124),
(98969,'enUS','','I... what happened? My supplies - they\'re gone!',26124),
(98970,'enUS','','Naman, still in a daze, looks around the room, searching for something.',26124),
(98971,'enUS','This brave adventurer saved us.','',26124),
(98972,'enUS','I would like to station a follower in Azsuna.','I would like to station a follower in Azsuna.',26124),
(98973,'enUS','Your will is our command.','',26124),
(98974,'enUS','','Thank you. Be safe, brave adventurer.',26124),
(98975,'enUS','Station Lord Maxwell Tyrosus.','Station Lord Maxwell Tyrosus.',26124),
(98976,'enUS','Station Vindicator Boros.','Station Vindicator Boros.',26124),
(98977,'enUS','Station Aponi Brightmane.','Station Aponi Brightmane.',26124),
(98978,'enUS','Station Lady Liadrin.','Station Lady Liadrin.',26124),
(98979,'enUS','Dual Specialization allows you to keep two active Class Specialization, Talent, and Glyph sets and easily switch between them.\n\nYou also will have separate glyph panes and action bars for each set.\n\nSwitching between the two sets cannot be done while in combat and will consume your available resources.','Dual Specialization allows you to keep two active Class Specialization, Talent, and Glyph sets and easily switch between them.\n\nYou also will have separate glyph panes and action bars for each set.\n\nSwitching between the two sets cannot be done while in combat and will consume your available resources.',26124),
(98980,'enUS','You have now learned Dual Specialization.','You have now learned Dual Specialization.',26124),
(98981,'enUS','Are you sure you would like to purchase Dual Specialization?','Are you sure you would like to purchase Dual Specialization?',26124),
(98982,'enUS','What are soul chambers?','What are soul chambers?',26124),
(98983,'enUS','Highlord, if you would like to station any of your followers so they may directly aid you in combat just let me know.','',26124),
(98984,'enUS','','Soul chambers are brilliant, but fragile gems that can be used to imprison demons.\n\nSoulkeeper Uriah and I were in possession of a handful of these shards until kobolds ransacked our caravan.\n\nThose mindless vermin have no idea what terror they may have unleashed.',26124),
(98985,'enUS','Mebok was right, the smarts are in the horns... but he kept trying to separate them from the raptor! We need the raptors intact, so we can use \'em to fight against the Legion.\n\nIf Mebok\'s books were right, I oughta be able to slather myself in some raptor pheromones and make myself their leader. Wish me luck!','',26124),
(98986,'enUS','<Coughing rather vigorously>$b$bWell that was unexpected! You alright, $n?','',26124),
(98987,'enUS','','Deathlord, I must speak with you.',26124),
(98989,'enUS','Oh... the humanity!','',26124),
(98990,'enUS','Blood... ew! Wait a minute... yep - it\'s mine.','',26124),
(98991,'enUS','They got me good! I\'m fadin\' fast. Goodbye world...','',26124),
(98992,'enUS','I didn\'t expect to see anybody \'round these parts.','',26124),
(98993,'enUS','Normally I\'d offer my guests a snack, but I don\'t think those things would taste very good.','',26124),
(98994,'enUS','Sure am glad to see you, $n!','',26124),
(98995,'enUS','Come with me.','',26124),
(98996,'enUS','She\'s all yours.','',26124),
(98997,'enUS','%s nudges the corpse gently with his workboot.','',26124),
(98998,'enUS','Never mess with a goblin and his wrench!','',26124),
(98999,'enUS','','Glaciela, I swear, your teeth are going to fall out one day from eating all my delicious candies.',26124),
(99002,'enUS','','They outnumber us by an order of magnitude. Can we defeat them?',26124),
(99003,'enUS','','You can find Grand Master Corvus working on the forges upstairs, $gsir:ma\'am;.',26124),
(99004,'enUS','I feel footsteps... but they are not familiar...\n\nStranger... you must help...','',26124),
(99005,'enUS','Many seasons have I slumbered. \n\nIt is good to smell the Runewood air again.','',26124),
(99006,'enUS','|TInterface\\Icons\\inv_misc_volatilewater:20|t%s begins to |cFFFF0000|Hspell:191873|h[Submerge]|h|r!','',26124),
(99008,'enUS','We\'ve done it, Illidari! FREEDOM IS OURS!','',26124),
(99009,'enUS','I\'m surrounded by weaklings! Just look at them, they couldn\'t cut their way out of a paper bag. \'Gonna be a liability when we fight the demons unless we can drill some proper skills into \'em.$b$bHow about we have a quick spar? Show \'em how real knights fight!','I\'m surrounded by weaklings! Just look at them, they couldn\'t cut their way out of a paper bag. \'Gonna be a liability when we fight the demons unless we can drill some proper skills into \'em.$b$bHow about we have a quick spar? Show \'em how real knights fight!',26124),
(99010,'enUS','Hold on tight!','Hold on tight!',26124),
(99011,'enUS','Sounds good, prepare yourself!','Sounds good, prepare yourself!',26124),
(99012,'enUS','','My Lord Sargeras, no!!!',26124),
(99013,'enUS','Hurry, $n. Use the keystone to activate the portal. We must rejoin the fight at the Black Temple.','',26124),
(99014,'enUS','This may seem like nothing more than a tiny hole that no army can fit down, but it leads to the very lair of Neltharion himself.$b$bWithin, you shall find yourself behind the main assault force of the drogbar loyal to Dargrul.$b$bProceed with caution though, as those you do find will be more formidable than the drogbar you have encountered thus far. Good luck, brul.','',26124),
(99015,'enUS','Shoo! Get out of here!','',26124),
(99016,'enUS','Caww! $p! $p!','',26124),
(99017,'enUS','These are NOT your lands!','',26124),
(99018,'enUS','I could always use more target practice!','',26124),
(99019,'enUS','','Thanks. Be safe out here.',26124),
(99020,'enUS','','$n, I have captured a few felbats. They will be ready when you decide to fly up to that Legion command ship.',26124),
(99021,'enUS','Whitemoon, I\'ll be taking one of your felbats. We\'re going to get what we came here for.','Whitemoon, I\'ll be taking one of your fel bats. We\'re going to get what we came here for.',26124),
(99022,'enUS','Izal, get me back up there.','Izal, get me back up there.',26124),
(99023,'enUS','Is it over yet?','',26124),
(99024,'enUS','There\'s someone outside!','',26124),
(99025,'enUS','A visitor! Hey... is it safe out there yet?','',26124),
(99026,'enUS','','We are fine here. Please, just go... and be safe.',26124),
(99027,'enUS','','We appreciate your visit, but this is not the time.',26124),
(99028,'enUS','','These lands have seen battle, but none like this...',26124),
(99029,'enUS','','I\'m sure it will be over soon.',26124),
(99030,'enUS','','The underking\'s forces assault Snowblind Mesa. Come! March the warpath with me and let us show them the might of Highmountain!',26124),
(99031,'enUS','','Even now, the underking\'s forces march on Snowblind Mesa. Let us meet them in battle and show them the true power of Highmountain!',26124),
(99032,'enUS','','March the warpath with me, and let us remind them that together, WE... ARE... HIGHMOUNTAIN!',26124),
(99033,'enUS','You have more skill than I thought |5$r could possess.','',26124),
(99034,'enUS','Thank you, $p. Arru will terrorize Thunder Totem no more. Instead, he will be a great aid. Help yourself to what he took from town.','',26124),
(99035,'enUS','I may have lost my bet, but I cannot deny your hunting skills.\n\nYou and the gnome have made fine additions to the hunting party.','',26124),
(99036,'enUS','Again! A legion fighting as you do is an embarrassment to Sargeras!','',26124),
(99037,'enUS','Your blades are nearly as dull as your skills! Work harder, whelps!','',26124),
(99038,'enUS','Swing harder, and faster! This world\'s resistance must be broken!','',26124),
(99039,'enUS','','The elevator will be here shortly. The others are waiting for you above.',26124),
(99040,'enUS','You\'d have better luck teaching a boar to fly than trying to teach a gnome to hunt.','',26124),
(99041,'enUS','','I await your orders, Skylord. Now to explore this place!',26124),
(99042,'enUS','I await your orders, Skylord.','',26124),
(99043,'enUS','','You\'ve more than proven your worth. It was an honor to hunt beside you and Addie.',26124),
(99044,'enUS','','Hemet only allows those with exceptional hunting skills to join his hunting party.',26124),
(99045,'enUS','I won\'t be forgettin\' that hunt anytime soon! \n\nI don\'t know if we could\'ve taken that beast down without you and Addie.','',26124),
(99046,'enUS','Brul, you saved us from the Bloodtotem, so now I stand with Highmountain.$b$bWhile we Stonedark are no match for Dargrul\'s fighters in open combat, we do have other ways to help defeat your enemy.','',26124),
(99047,'enUS','','The Skyhorn are nothing without their eagles!',26124),
(99048,'enUS','Caww! $p! $p!','',26124),
(99049,'enUS','','For Highmountain!',26124),
(99054,'enUS','','You will fall like all the others!',26124),
(99055,'enUS','','Feast on their eyes my beauties!',26124),
(99056,'enUS','','Your blood will rain from the sky!',26124),
(99057,'enUS','Oh what a lovely day!','',26124),
(99058,'enUS','Something need doing?','',26124),
(99059,'enUS','Zug zug.','',26124),
(99060,'enUS','You dare to assault Sargeras\' legion head-on? Come then, mortals, and face me!','You dare to assault Sargeras\' legion head-on? Come then, mortals, and face me!',26124),
(99061,'enUS','What is this? Our anchoring crystals are destroyed? I will flay the flesh from your bones, mortals!','What is this? Our anchoring crystals are destroyed? I will flay the flesh from your bones, mortals!',26124),
(99062,'enUS','I\'ll keep pondering on how we can improve our leystone techniques, $n. Your training isn\'t done yet.','',26124),
(99063,'enUS','Please, allow me to repay you.','',26124),
(99064,'enUS','This way... and keep your head down. If those wyrmtongue catch a whiff of my concoctions they\'re sure to come running. Damn scavengers.','',26124),
(99065,'enUS','','I commend you on a good start. However, your forces are already wavering.',26124),
(99066,'enUS','','I\'d look forward to us meeting, but you will not survive.',26124),
(99067,'enUS','','It\'s YOU who won\'t survive, demon witch!',26124),
(99068,'enUS','','How droll. Even from up here, I can sense your uncertainty.',26124),
(99069,'enUS','','Tell me dear, have you considered joining us?',26124),
(99070,'enUS','','...',26124),
(99071,'enUS','You cannot have them. They are mine!','',26124),
(99072,'enUS','','I ask that you honor our pact and come to their aid.',26124),
(99073,'enUS','','Soul harvesters are a vile Legion creation.',26124),
(99074,'enUS','','You saved those Illidari from a fate worse than death.',26124),
(99075,'enUS','That device you just destroyed helps stabilize the Legion\'s buildings.','',26124),
(99076,'enUS','See if there are others around the fortress.','',26124),
(99077,'enUS','You did it. Our forces have gained the upper hand.','',26124),
(99078,'enUS','','Intruders on the Fel Hammer!',26124),
(99079,'enUS','Now, we\'ll kill the brood queen and take the Sargerite Keystone.','',26124),
(99080,'enUS','','You\'re free to try, demon hunter.',26124),
(99081,'enUS','','What juicy little morsels you will make.',26124),
(99082,'enUS','Sewer guards, time to take a break!','',26124),
(99083,'enUS','Sewer guards! Return to your posts!','',26124),
(99084,'enUS','Khadgar and his \"council\" may rule the roost above, but down here? My men and I run the show.$b$bI don\'t want to see any funny business while you\'re in my sewer, $r. That is, of course, unless you could convince me to look the other way...','',26124),
(99085,'enUS','Raethan, call off your guards.\n\n[Cost: 50 |TInterface\\Icons\\achievement_reputation_kirintor_offensive.blp:12|t Sightless Eyes]','Raethan, call off your guards.\n\n[Cost: 50 |TInterface\\Icons\\achievement_reputation_kirintor_offensive.blp:12|t Sightless Eyes]',26124),
(99086,'enUS','Raethan, call back your guards.\n\n[Cost: 50 |TInterface\\Icons\\achievement_reputation_kirintor_offensive.blp:12|t Sightless Eyes]','Raethan, call back your guards.\n\n[Cost: 50 |TInterface\\Icons\\achievement_reputation_kirintor_offensive.blp:12|t Sightless Eyes]',26124),
(99087,'enUS','Where\'s Torok?','',26124),
(99088,'enUS','The chief is expecting you down in the cave, Rivermane.','The chief is expecting you down in the cave, Rivermane.',26124),
(99089,'enUS','How do I obtain spooky supplies and merry supplies?','How do I obtain spooky supplies and merry supplies?',26124),
(99090,'enUS','','During Hallow\'s End and the Feast of Winter Veil, locals may drop in and request your aid against some of the denizens of Draenor. They\'ll surely be willing to part with some festive supplies!',26124),
(99091,'enUS','The inhabitants of Tarren Mill have been inspired to join the fight against the Legion!','',26124),
(99092,'enUS','Impossible!','',26124),
(99093,'enUS','','My thanks. Come, my brothers... back to the battle!',26124),
(99094,'enUS','','$n, my naga are trapped by a nearby pit lord.',26124),
(99095,'enUS','Shaman! I have an urgent message.','',26124),
(99096,'enUS','Yes, we must strike back. But how?','',26124),
(99097,'enUS','We need weapons capable of overcoming the Legion.','',26124),
(99100,'enUS','They will come for us.','',26124),
(99103,'enUS','There are ancient safeguards here. We must use them.','',26124),
(99104,'enUS','Help her! She\'s fadin\' fast!','',26124),
(99105,'enUS','Thank ye, shaman.','',26124),
(99106,'enUS','','The Highlands are completely overrun. The clan is scattered.',26124),
(99107,'enUS','','What kind of a shaman can\'t light a fire?',26124),
(99108,'enUS','Shush, you! Dis wood be wet and me hands be shakin\'.','',26124),
(99109,'enUS','','The Legion destroys us in the open fields. Even Thunder Bluff isn\'t safe from the Infernals.',26124),
(99110,'enUS','This thing has sat useless for ten thousand years.','',26124),
(99112,'enUS','It just needs a little... boost. Shaman, can you help?','',26124),
(99113,'enUS','Do you see? It\'s working. This world will fight for itself if we give it the tools to do so.','',26124),
(99114,'enUS','Look out!','',26124),
(99115,'enUS','','They followed us here!',26124),
(99116,'enUS','I knew yer crap bird was too slow.','',26124),
(99117,'enUS','My bird woulda been quicker if she weren\'t haulin\' yer fat arse.','',26124),
(99118,'enUS','Here is where you insects crawled!','',26124),
(99119,'enUS','Take to your knees, and my Master may yet be merciful.','',26124),
(99120,'enUS','Your Master has not won yet.','',26124),
(99121,'enUS','Ha-hah!! You are a champion in the making!','',26124),
(99122,'enUS','Help the others!','',26124),
(99123,'enUS','Spirits... hear my call...','',26124),
(99124,'enUS','Are you the so-called \'World Shaman?\' Hah! You fight like a crippled pig.','',26124),
(99125,'enUS','We can fight this... but we must work together...','',26124),
(99126,'enUS','Auugh--','',26124),
(99127,'enUS','You are so weak. You can barely lift your hammer, \'shaman.\'','',26124),
(99128,'enUS','','Wildhammer!',26124),
(99129,'enUS','Wildhammer!','',26124),
(99130,'enUS','Wildhammer!','',26124),
(99131,'enUS','','Over here, shaman! Take up my spear. The winds will guide your strike!',26124),
(99132,'enUS','Do it! Bring it down!','',26124),
(99133,'enUS','The heart. Get the heart.','',26124),
(99134,'enUS','It is ready! Everyone, focus on the pillar. Quickly!','',26124),
(99135,'enUS','You will die!','',26124),
(99136,'enUS','Your precious \'earthen ring\' will shatter!','',26124),
(99137,'enUS','Your world will succumb!!','',26124),
(99138,'enUS','THE LEGION WILL--','',26124),
(99139,'enUS','Hear me, elements of Azeroth.','',26124),
(99140,'enUS','Once, we walked as one. I abused your powers for my own personal vendetta.','',26124),
(99141,'enUS','Take back the Doomhammer! Grant it to one who is worthy.','',26124),
(99142,'enUS','Teach me, and again I will be your servant.','',26124),
(99143,'enUS','','Rivermane, scale the breach in flanking positions. Find a safe place to heal from.',26124),
(99144,'enUS','','Skyhorn, take to the skies and keep our northern flank clear.',26124),
(99145,'enUS','Thank ye, outsider. Follow me, and I\'ll tell ya me plan!','',26124),
(99146,'enUS','%s places the samples carefully in their satchel.','',26124),
(99147,'enUS','%s holds the sample toward the skies, inspecting them closely.','',26124),
(99148,'enUS','%s brings the sample close, sniffs it, then tastes it with a quick swipe of the tongue.','',26124),
(99149,'enUS','%s ponders the value of the collected sample, then throws it carelessly into its pack.','',26124),
(99150,'enUS','%s inspects the sample, shakes it, then discards it on the floor.','',26124),
(99151,'enUS','%s tests the sample\'s toughness, then places it into its pack.','',26124),
(99152,'enUS','Light guide your blade, Highlord. Take care of yourself out there.','',26124),
(99153,'enUS','','Don\'t worry, mother\'s here... Oh my, he\'s a big one.',26124),
(99155,'enUS','Let\'s go hunting!','Let\'s go hunting!',26124),
(99156,'enUS','Yes... yes! Gather it all and bring it here!','',26124),
(99157,'enUS','Such delicacies! We need them all!','',26124),
(99158,'enUS','Master will be very pleased! Findings very interesting!','',26124),
(99159,'enUS','Into the pot! Bubbling to the top!','',26124),
(99160,'enUS','These creatures... mmm so delicious! They makes us trinkets of all kinds!','',26124),
(99161,'enUS','','I\'ll keep the water buckets coming. You put the fire out!',26124),
(99162,'enUS','Achh! Me poor cart!','',26124),
(99163,'enUS','By Thargus\' bloody anvil! Is that... fel flame?','',26124),
(99164,'enUS','What in blazes is goin\' on today?','',26124),
(99165,'enUS','Stop them you idiots, or they\'ll break our anchoring with the Nether!','Stop them you idiots, or they\'ll break our anchoring with the Nether!',26124),
(99166,'enUS','We\'re under attack! Crush these weaklings, and earn Sargeras\' favor!','We\'re under attack! Crush these weaklings, and earn Sargeras\' favor!',26124),
(99167,'enUS','Stupid, tiny things...','',26124),
(99168,'enUS','','I\'m needed elsewhere.',26124),
(99169,'enUS','','A mother\'s work is never done.',26124),
(99170,'enUS','I\'ll hammer you into shape.','',26124),
(99171,'enUS','Nope!','',26124),
(99172,'enUS','$n, this is embarassing...','',26124),
(99173,'enUS','Want your little, broken draenei back?','',26124),
(99174,'enUS','I would like to station a follower in Val\'Sharah.','I would like to station a follower in Val\'Sharah.',26124),
(99175,'enUS','And you.','',26124),
(99176,'enUS','We\'ve got to take down this portal!','',26124),
(99177,'enUS','','The anchoring crystals are the key, just get us up there, and we\'ll take care of it.',26124),
(99178,'enUS','Form up, Alliance! We push them back to the portal! For Azeroth!','',26124),
(99179,'enUS','','Focus on the crystals!',26124),
(99180,'enUS','Heal the wounded, we can\'t rest here for long.','',26124),
(99181,'enUS','','What happened here?',26124),
(99182,'enUS','It happened in seconds! We were fighting our way up the shore and then BOOM, explosions of fel energy all around us! And these buildings just grew up out of them, filled with demons! I don\'t know how we\'re going to be able to push them back at this rate!','',26124),
(99183,'enUS','One demon at a time. With me, Alliance, leave nothing standing!','',26124),
(99184,'enUS','You\'re from the Crusade! What happened? Where is Tirion?','',26124),
(99185,'enUS','Don\'t know... they were on us in seconds... felfire everywhere...','Don\'t know... they were on us in seconds... felfire everywhere...',26124),
(99186,'enUS','Save your strength, we will find him.','',26124),
(99187,'enUS','','Keep your eyes open for survivors! Save as many as you can!',26124),
(99188,'enUS','Back where you came from!','',26124),
(99189,'enUS','We\'re pushing them back! Don\'t let up!','',26124),
(99190,'enUS','We\'re halfway there, take heart Alliance!','',26124),
(99191,'enUS','For the Alliance!','',26124),
(99192,'enUS','Taste blaster!','',26124),
(99193,'enUS','For Gnomeregan!','',26124),
(99194,'enUS','Back to the Nether with you!','',26124),
(99195,'enUS','For... the Alliance...','For... the Alliance...',26124),
(99196,'enUS','I can\'t... go on...','I can\'t... go on...',26124),
(99197,'enUS','','Structural integrity at 0%%!',26124),
(99198,'enUS','','They\'ve broken through my mechbot!',26124),
(99206,'enUS','They\'ve slain me, my queen...','',26124),
(99216,'enUS','Yes, yes more trinkets, give them to me!','',26124),
(99217,'enUS','Kill you! Take your things!','',26124),
(99218,'enUS','Curse your soul!','',26124),
(99219,'enUS','They took Tirion!','They took Tirion!',26124),
(99220,'enUS','Light have mercy on us...','Light have mercy on us...',26124),
(99221,'enUS','I can still fight, I\'m with you.','I can still fight, I\'m with you.',26124),
(99222,'enUS','They came out of nowhere!','They came out of nowhere!',26124),
(99223,'enUS','By the light, it is good to see you.','By the light, it is good to see you.',26124),
(99224,'enUS','Have you seen Tirion?','Have you seen Tirion?',26124),
(99225,'enUS','I can\'t feel the Light in this place...','I can\'t feel the Light in this place...',26124),
(99226,'enUS','You\'re a welcome sight!','You\'re a welcome sight!',26124),
(99227,'enUS','Thank you, hero.','Thank you, hero.',26124),
(99228,'enUS','We couldn\'t hold them off...','We couldn\'t hold them off...',26124),
(99229,'enUS','They\'re retreating.','',26124),
(99230,'enUS','I get the feeling this fight isn\'t over yet.','',26124),
(99231,'enUS','','Varian, I found him! Look, across the chasm, Tirion!',26124),
(99232,'enUS','All forces, to Jaina!','',26124),
(99233,'enUS','How are we going to get across?','',26124),
(99234,'enUS','','I\'ve got this.',26124),
(99235,'enUS','Tirion!','',26124),
(99236,'enUS','','Gul\'dan! You will pay for this!',26124),
(99237,'enUS','Stay back... it\'s a trap... the Light will protect me...','',26124),
(99238,'enUS','Ha, you fool! You stand before the temple of a GOD. Your pitiful Light cannot reach you here. How fortunate that your friends have arrived just in time to watch you die.','',26124),
(99239,'enUS','Destroy him.','',26124),
(99240,'enUS','The Light... will... ahh!  Aahhhh!!','',26124),
(99241,'enUS','Fordring!','',26124),
(99242,'enUS','','No!',26124),
(99243,'enUS','All you have worked for, all you have sacrificed, just to see your champions fall to ash one by one.','',26124),
(99244,'enUS','We will never give in to hopelessness!','',26124),
(99245,'enUS','','The armies of Azeroth will triumph this day, together.',26124),
(99246,'enUS','Together, for Azeroth!','',26124),
(99247,'enUS','Destroy them!','',26124),
(99248,'enUS','You will know fear.','',26124),
(99249,'enUS','Brace yourselves, Alliance, it\'s coming this way!','',26124),
(99250,'enUS','','Monsters from the felfire! Horde forces, be ready!',26124),
(99251,'enUS','Focus your fire, bring him down!','',26124),
(99252,'enUS','','He\'s going to breathe, look out!',26124),
(99253,'enUS','Front line, avoid those fists!','',26124),
(99254,'enUS','Fel magma incoming, watch yourselves!','',26124),
(99255,'enUS','My forces are decimated. I have failed you.','',26124),
(99256,'enUS','The magma erupts, watch yourselves!','',26124),
(99257,'enUS','','Another wave incoming!',26124),
(99258,'enUS','More beasts from da flame!','',26124),
(99259,'enUS','They come at us again!','',26124),
(99260,'enUS','I swear to give my life if that is what it takes.','',26124),
(99261,'enUS','He\'s heading your way, Windrunner!','',26124),
(99262,'enUS','','Let\'s go, Horde, it\'s time to show the Alliance how we slay demons.',26124),
(99263,'enUS','','Beasts from the felfire emerge, be careful!',26124),
(99264,'enUS','The next wave approaches, be ready!','',26124),
(99265,'enUS','','They\'re coming again, let\'s put them on ice!',26124),
(99266,'enUS','More enemies emerge from the flames!','',26124),
(99267,'enUS','That magma\'s going to erupt, be ready to duck!','',26124),
(99268,'enUS','He breathes that foul breath again, look out!','',26124),
(99269,'enUS','','All Horde forces on my target, we\'re going to bring down that demon.',26124),
(99270,'enUS','Dat great ball o\' felfire is comin\' dis way!','',26124),
(99271,'enUS','His fists are like mountains! Keep moving!','',26124),
(99272,'enUS','You\'ve got another shot at the kill, Sylvanas!','',26124),
(99273,'enUS','','Consider your job done then, Wrynn.',26124),
(99274,'enUS','','All yours, Alliance.',26124),
(99275,'enUS','We\'ve got him this time! All forces, concentrate your fire!','',26124),
(99276,'enUS','Ha, the bigger they are...','',26124),
(99277,'enUS','','No time to gloat, Wrynn. We\'ve got to stop Gul\'dan before he summons another one of those things!',26124),
(99278,'enUS','Everyone, across the chasm!','',26124),
(99279,'enUS','','We\'ll take the ridge and cover your flank.',26124),
(99280,'enUS','Sylvanas, thank you.','',26124),
(99281,'enUS','','Good luck, Varian.',26124),
(99282,'enUS','And you.','',26124),
(99283,'enUS','There is nowhere to run, Gul\'dan. Give up now, and I will grant you a swift death.','',26124),
(99284,'enUS','Run? Ha. You are right, human. There is nowhere to run from my master.  Now, witness the true might of Lord Sargeras!','',26124),
(99285,'enUS','Hold steady, we\'ve broken their lines before, we will again. Charge!','',26124),
(99286,'enUS','Down the ridge behind us, another portal!','',26124),
(99287,'enUS','We\'ve got to hold dis ridge, no matter da cost.','',26124),
(99288,'enUS','','Take up positions. We hold them off. We have to.',26124),
(99289,'enUS','I cannot... take much more of this...','',26124),
(99290,'enUS','','Pull Baine back to my position, close ranks!',26124),
(99291,'enUS','We will never fall to you, Gul\'dan. The combined forces of Azeroth will triumph today.','',26124),
(99292,'enUS','','Less chatting, Wrynn. Kill him already!',26124),
(99293,'enUS','I have seen the end of your pitiful world, Wrynn. You will perish in felfire, like ten thousand worlds before your own. The legion is ENDLESS.','',26124),
(99294,'enUS','','Shelds up, here they come!',26124),
(99295,'enUS','Even more demons be pouring from dat portal. Get ready!','',26124),
(99297,'enUS','','Vol\'jin! Pull him back! Keep your lines steady! We have to hold!',26124),
(99298,'enUS','There are... too many of them!','',26124),
(99299,'enUS','','Everyone pull back to me! We make our stand here!',26124),
(99300,'enUS','No matter how many demons you throw at us, we will cut you down, monster.','',26124),
(99301,'enUS','And now you will fall.','',26124),
(99302,'enUS','Hold on, Alliance!','',26124),
(99303,'enUS','We return.','',26124),
(99304,'enUS','To conquer this puny world.','',26124),
(99305,'enUS','And burn it to a husk.','',26124),
(99306,'enUS','Do you see now, human? The fate of this world is sealed. The legion cannot be stopped.','',26124),
(99307,'enUS','Together, we will defeat you, just as we always have.','',26124),
(99309,'enUS','','Varian, behind us!  The Horde is gone!',26124),
(99310,'enUS','','There are so many of them...',26124),
(99311,'enUS','','There\'s nothing we can do! The ridge is lost! Horde forces, if you value your lives, cut a path through to the shore! We have to get out of here, or there won\'t be anyone left to fight!',26124),
(99312,'enUS','It looks like our reinforcements have arrived.','',26124),
(99313,'enUS','Good ting! We don\'t got much beach left ta retreat to.','',26124),
(99314,'enUS','There\'s only one way out of this one, old friend.','',26124),
(99315,'enUS','Listen up! Dere\'s only one way offa dis beach, and it be t\'rough alla dose demons ahead of us. But dey don\'t know who dey be dealin\' wit. Let\'s show dem what it means ta be Horde!','',26124),
(99316,'enUS','I return... to the elements...','I return... to the elements...',26124),
(99317,'enUS','Not... going to make it...','Not... going to make it...',26124),
(99318,'enUS','Da pain!','Da pain!',26124),
(99319,'enUS','Dis be da end...','Dis be da end...',26124),
(99320,'enUS','Back to the Nether!','',26124),
(99321,'enUS','The elements will destroy you!','',26124),
(99322,'enUS','Lok\'tar ogar!','',26124),
(99323,'enUS','Die.','',26124),
(99324,'enUS','Dis one\'s mine.','',26124),
(99325,'enUS','For da Horde!','',26124),
(99326,'enUS','Ha, the fools attack!','',26124),
(99327,'enUS','Crush them!','',26124),
(99328,'enUS','Keep them away from the spires!','',26124),
(99329,'enUS','There\'s something odd about the crystals surrounding that spire. They feel... wrong... like they\'re in two places at once. Hmm.','',26124),
(99330,'enUS','Horde, make for dem crystals! We gonna see if ya hunch is right.','',26124),
(99331,'enUS','Yes... they must anchor it to this world.','',26124),
(99332,'enUS','Two more ta go.','',26124),
(99333,'enUS','You destroy but one of the master\'s endless instruments of your demise! INFERNO!','',26124),
(99334,'enUS','Keep it up! We almost got dem!','',26124),
(99335,'enUS','Weaklings. Must I do everything myself? Very well, prepare yourselves!','',26124),
(99336,'enUS','You gonna die just like all da others.','',26124),
(99337,'enUS','Focus on the commander!','',26124),
(99338,'enUS','You will all burn!','',26124),
(99339,'enUS','Felfire rains from the sky! Look out!','',26124),
(99340,'enUS','Your corpses will feed my hounds.','',26124),
(99341,'enUS','Your souls will know endless agony.','',26124),
(99342,'enUS','Looks like ya chose da wrong side.','',26124),
(99343,'enUS','The master will mend my flesh again and again. You have not won. You cannot win. We are endless! We are Legion!','',26124),
(99344,'enUS','I... will... return...','',26124),
(99345,'enUS','It is good to fight with you again, Warchief.','',26124),
(99346,'enUS','Ain\'t never gonna get used to you callin\' me dat.','',26124),
(99347,'enUS','There\'s only one way to the tomb, are you ready?','',26124),
(99348,'enUS','Let\'s get movin\'.','',26124),
(99349,'enUS','Sylvanas\' ship must \'av crashed just ahead.','',26124),
(99350,'enUS','They\'re expanding faster than we\'ve seen before.','',26124),
(99351,'enUS','Ya, mon. Dis ain\'t da same Legion.','',26124),
(99352,'enUS','What?','',26124),
(99353,'enUS','Dat\'s no invasion force. Dat\'s an army!','',26124),
(99354,'enUS','','Nock your arrows! Hold! Fire!',26124),
(99355,'enUS','They\'re alive!','',26124),
(99356,'enUS','Let\'s move!','',26124),
(99357,'enUS','','It\'s about time you showed up!',26124),
(99358,'enUS','You looked like you could use a hand.','',26124),
(99359,'enUS','Their reinforcements are endless!','',26124),
(99360,'enUS','Those crystals again... if we can get close to them, we can bring this thing down.','',26124),
(99361,'enUS','','You heard him, rangers, we cut those demons down! Fire a volley on my mark... NOW!',26124),
(99362,'enUS','Break the crystals!','',26124),
(99363,'enUS','','Well, that was invigorating. Now how did they manage to get so many demons here so quickly?',26124),
(99364,'enUS','This invasion is unlike any I have ever witnessed, and I don\'t think we\'ve seen the last of their surprises.','',26124),
(99365,'enUS','These structures rose from the ground in moments, spewing forth demons in the hundreds in the blink of an eye.','',26124),
(99366,'enUS','','And now we know how to destroy them. It\'s them or us. Let\'s get moving so we make sure it\'s not us.',26124),
(99367,'enUS','','This is Argent Crusade insignia, can you speak? Where is the rest of the Crusade?',26124),
(99368,'enUS','Dead... dying... they descended on us in seconds... nowhere to run...','Dead... dying... they descended on us in seconds... nowhere to run...',26124),
(99369,'enUS','An no sign of Tirion.','',26124),
(99370,'enUS','We will find him. Horde forces, keep your eyes open for survivors, rescue as many as you are able!','',26124),
(99371,'enUS','','One shot, one kill.',26124),
(99372,'enUS','','Too easy.',26124),
(99373,'enUS','','That\'s half of the city down, this is going better than expected.',26124),
(99374,'enUS','','Right to the face!',26124),
(99375,'enUS','','We\'ll never bow to you.',26124),
(99376,'enUS','To the earth with you!','',26124),
(99377,'enUS','Take heart, heroes!','',26124),
(99378,'enUS','For the Earth Mother!','',26124),
(99379,'enUS','Darkness... calls...','Darkness... calls...',26124),
(99380,'enUS','This is... the end...','This is... the end...',26124),
(99381,'enUS','I return... to the earth...','I return... to the earth...',26124),
(99382,'enUS','Earth Mother... guide me...','Earth Mother... guide me...',26124),
(99383,'enUS','We must find Tirion.','We must find Tirion.',26124),
(99384,'enUS','I am singed, but I can still fight.','I am singed, but I can still fight.',26124),
(99385,'enUS','Thank you for your aid.','Thank you for your aid.',26124),
(99386,'enUS','We were not prepared!','We were not prepared!',26124),
(99387,'enUS','It\'s good to see a friendly face.','It\'s good to see a friendly face.',26124),
(99388,'enUS','Where is Tirion?','Where is Tirion?',26124),
(99389,'enUS','I am wounded, but I can move.','I am wounded, but I can move.',26124),
(99390,'enUS','I am in your debt.','I am in your debt.',26124),
(99391,'enUS','We couldn\'t stop them...','We couldn\'t stop them...',26124),
(99392,'enUS','There were so many of them.','There were so many of them.',26124),
(99393,'enUS','Dey be retreatin\'.','',26124),
(99394,'enUS','','That was too easy, something\'s wrong.',26124),
(99395,'enUS','There, across the chasm, Gul\'dan! He has Tirion!','',26124),
(99396,'enUS','All da Horde, get ta Thrall!','',26124),
(99397,'enUS','','Anyone have any ideas how we\'re going to get across this thing?',26124),
(99398,'enUS','Spirits of earth, aid me!','',26124),
(99399,'enUS','','Convenient.',26124),
(99400,'enUS','','You WILL be avenged, my love!',26124),
(99401,'enUS','','Well, look who decided to show up. It\'s been a while since you\'ve been in the halls of Acherus.',26124),
(99402,'enUS','It is good to see you as well, but we can reminisce later. I must speak with the $ct at once.','',26124),
(99403,'enUS','I\'m not here to waste time with the \"help,\" I must speak with the $ct at once.','',26124),
(99404,'enUS','Thank you, $ct.  I need to go see Corvis about getting my armor repaired. By your leave, $gsir:ma\'am;.','',26124),
(99405,'enUS','Thank you, Deathlord. I will not let you down.','',26124),
(99406,'enUS','I swear, I don\'t know nothin\' about any demon flames! I was just buyin\' and sellin\' armor, is all!','',26124),
(99407,'enUS','Why should I believe you?','Why should I believe you?',26124),
(99408,'enUS','I believe you.','I believe you.',26124),
(99409,'enUS','I\'m just an honest trader, just lookin\' to buy all the goods on the auction house, sell \'em back to the people at a much higher price, make my ten million gold, and go home in peace! Is that so much to ask?','',26124),
(99410,'enUS','I know your kind. A dirty auction house speculator.','I know your kind. A dirty auction house speculator.',26124),
(99411,'enUS','Very well. I believe you.','Very well. I believe you.',26124),
(99412,'enUS','No... I\'m one of the good ones! I... I donated to charity, once! And I hardly ever litter!$b$bAnd I never, EVER undercut.','',26124),
(99413,'enUS','Were there any other witnesses to what happened?','Were there any other witnesses to what happened?',26124),
(99414,'enUS','Fine, I believe you.','Fine, I believe you.',26124),
(99415,'enUS','Sure, me mule was there.','',26124),
(99416,'enUS','Your MULE? You\'ve got to be kidding me.','Your MULE? You\'ve got to be kidding me.',26124),
(99417,'enUS','OK, I believe you.','OK, I believe you.',26124),
(99418,'enUS','I don\'t know why you\'re so intent on questioning me. I just lost my cart and everything I own.','',26124),
(99419,'enUS','I WANT to believe you, but you\'re not making it easy for me.','I WANT to believe you, but you\'re not making it easy for me.',26124),
(99420,'enUS','Just being thorough. I believe you.','Just being thorough. I believe you.',26124),
(99421,'enUS','Wait a minute... are you EXTORTING me?','',26124),
(99422,'enUS','Yes, I\'m extorting you.','Yes, I\'m extorting you.',26124),
(99423,'enUS','Of course not! I believe your story.','Of course not! I believe your story.',26124),
(99424,'enUS','But... I spent every last copper I had on that cart full o\' gear! I mean it! I don\'t have any money to give you!','',26124),
(99425,'enUS','Your whole story is falling apart, Caelen.','Your whole story is falling apart, Caelen.',26124),
(99426,'enUS','I believe your story.','I believe your story.',26124),
(99427,'enUS','Wait, here, look...$b$b<Caelen removes a pile of receipts from his pockets.>$b$bSee! All the stuff I bought, purchased legitimately from reputable Dalaran arms dealers.','',26124),
(99428,'enUS','These look like counterfeit receipts.','These look like counterfeit receipts.',26124),
(99429,'enUS','I see everything is on the up-and-up here. I believe you.','I see everything is on the up-and-up here. I believe you.',26124),
(99430,'enUS','Counterfeit receipts? Really?$b$bLet me say this out loud, \'cause I wanna get it straight in my head.$b$bYou\'re saying that I brought a bunch of demonic... SOMETHING... into Dalaran, lit it on fire, hung around while it burned, and then produced a bunch of counterfeit receipts in case anybody asked me questions?$b$bI\'m right about that, right? That\'s correct? That\'s your story?','',26124),
(99431,'enUS','Yes, that\'s what I\'m saying.','Yes, that\'s what I\'m saying.',26124),
(99432,'enUS','','Stop fighting, Skyhorn beast!',26124),
(99433,'enUS','Well, when you put it that way, I believe you.','Well, when you put it that way, I believe you.',26124),
(99434,'enUS','I\'ve spent the last eleven years huddled shoulder-to-shoulder in a humid, smelly auction house, trying to make a few silver off a crate o\' leather hats. I\'m not some demon-corrupted adventurer... I\'ve never even SEEN a demon. Hell, I can\'t even wield half the gear I sell.$b$b<Caelen looks at you through anguished tears. He is, by all external signs, telling the truth.>','',26124),
(99435,'enUS','FINE. I believe you.','FINE. I believe you.',26124),
(99436,'enUS','','You will soon be a roc!',26124),
(99437,'enUS','','You\'re mine, eagle!',26124),
(99438,'enUS','Thanks!','',26124),
(99439,'enUS','Now, what do you know about this powder?','Now, what do you know about this powder?',26124),
(99440,'enUS','That wasn\'t in my crates. I always do a thorough investigation of everything I buy, and I woulda\' noticed some glowy green stuff.','',26124),
(99441,'enUS','That wasn\'t in my crates. I always do a thorough investigation of everything I buy, and I woulda\' noticed some glowy green stuff. Reminds me of enchanting dust. You should talk to the enchanters.','',26124),
(99442,'enUS','Helya\'s massive presence looms in the distance from the platform. \n\nThis altar appears to be a means to communicate with her.','',26124),
(99443,'enUS','I do not belong here! I wish to leave Helheim!','I do not belong here! I wish to leave Helheim!',26124),
(99444,'enUS','She was a fine cart, she was.$b$b<Caelen wipes a tear into his beard.>','',26124),
(99445,'enUS','Do you know why your cart exploded into fel flames?','Do you know why your cart exploded into fel flames?',26124),
(99447,'enUS','Powder\'s not really my thing, kid. I\'m more of an \"inks and scrolls\" kind of guy.$b$bNow, let\'s think this through logically:$b$bThis powder of yours... is it an INK?','',26124),
(99448,'enUS','Is it a SCROLL?','',26124),
(99449,'enUS','Are you wasting my time?','',26124),
(99450,'enUS','Can I ask you a few questions about this powder?','Can I ask you a few questions about this powder?',26124),
(99451,'enUS','Bring that powder to Enchanter Nalthanis. Maybe he\'ll know what to do with it.','',26124),
(99452,'enUS','No.','No.',26124),
(99453,'enUS','...no.','...no.',26124),
(99454,'enUS','Goodbye, professor.','Goodbye, professor.',26124),
(99455,'enUS','','Our battle against the harpies is ongoing, but your actions have helped restore some balance to the basin.',26124),
(99456,'enUS','Let me know when you are ready, champion.','',26124),
(99458,'enUS','We\'re in luck, warbrave. The champion you seek should be here shortly.','',26124),
(99459,'enUS','Come champion. Journey with me and I shall show you the might of Highmountain.','',26124),
(99460,'enUS','$p, the warbrave has good intentions - I think. Quickly, now, after him - his people are your best chance at an ally on that mountain.','',26124),
(99461,'enUS','Meet me in the cave below, $n. They\'ll want to see the corpse of the harpy you slew.','',26124),
(99462,'enUS','These things... I must warn the others.','These things... I must warn the others.',26124),
(99463,'enUS','Let me see... it smells like demon fire, it has the color of demonic corruption, and it appeared in my shop only moments after screams and explosions rocked the streets of Dalaran.$b$bAre you trying to kill me, $c?','',26124),
(99464,'enUS','Let me rephrase:$b$bIs this dust in any way related to the SMOLDERING BODY that is still lying on my shop\'s doorstep?','',26124),
(99465,'enUS','Get it out of here, then! I\'m dead enough as it is.','',26124),
(99466,'enUS','Get it out of here, then! Bring it to the enchanters\' shop. They know more about dusts than I do.','',26124),
(99467,'enUS','I\'m not trying to kill you.','I\'m not trying to kill you.',26124),
(99468,'enUS','Yes.','Yes.',26124),
(99469,'enUS','What can you tell me about this powder?','What can you tell me about this powder?',26124),
(99470,'enUS','Today just might be our lucky day, $n.','',26124),
(99471,'enUS','I\'ve made contact with Malfurion Stormrage in Val\'Sharah. His men have already nearly completed their mission there - they just want some backup, just in case.','',26124),
(99472,'enUS','What\'re you waiting for? It isn\'t often we\'re handed victory on a silver platter like this. Relish every moment of it!','',26124),
(99473,'enUS','We still tell the legends of when Highmountain stood against the tide of the Burning Legion many ages ago.$b$bIt will be an honor to stand against them again.','',26124),
(99474,'enUS','Lead me to your High Chieftain.','Lead me to your High Chieftain.',26124),
(99475,'enUS','You want my hammer? COME DIG FOR IT!','',26124),
(99476,'enUS','They crunches!','',26124),
(99477,'enUS','Squish! Ah he he he!','',26124),
(99478,'enUS','Splatted under me feet!','',26124),
(99479,'enUS','Now where is $n? They always show up right when we - ah, there you are!','',26124),
(99480,'enUS','Good luck to the both of you. You\'ll need it.','',26124),
(99481,'enUS','I shouldn\'t have wandered off.','I shouldn\'t have wandered off.',26124),
(99482,'enUS','Let\'s get a move on. The Dark Lady\'s fleet is nearly ready to leave.','',26124),
(99483,'enUS','','Follow me, $n. The Skyfire is just about ready to leave.',26124),
(99484,'enUS','$n is here to meet with Torok. $GHe:She; slew the Witch of the Wood.','',26124),
(99485,'enUS','A challenger? Let\'s see what this one is capable of!','',26124),
(99486,'enUS','Repurposing','Repurposing',26124),
(99487,'enUS','','Experimentation yields wondrous things! Attack minions!',26124),
(99488,'enUS','I watch over the valley and keep track of harpy activity... but they knew. They attacked here first so I would not see their main attack and warn the village. My wife and  I lived peacefully on this summit, but they injured me and took her life. I fear they will strike again for my son and I will not be able to protect him.','',26124),
(99489,'enUS','I think I hear them coming!','I think I hear them coming!',26124),
(99490,'enUS','Keep those hands where I can see them, $r.','Keep those hands where I can see them, $r.',26124),
(99491,'enUS','Hey! Hands off!','Hey! Hands off!',26124),
(99492,'enUS','Not on my watch, scum.','Not on my watch, scum.',26124),
(99493,'enUS','Back away and nobody gets hurt, $c.','Back away and nobody gets hurt, $c.',26124),
(99494,'enUS','More souls! Come and accept your fate!','',26124),
(99495,'enUS','','Your young will be a tasty snack!',26124),
(99496,'enUS','Thank you for saving my son. I am forever indebted to you.','',26124),
(99499,'enUS','Removing all of the annoying humans wasn\'t particularly difficult, but these demons...','',26124),
(99500,'enUS','What? Can\'t you see I\'m busy! These demons won\'t just kill themselves!$B$BSomeone has to find out how to get rid of them.','',26124),
(99501,'enUS','As much as I love money, ain\'t no way I\'m sellin\' to demons!','',26124),
(99502,'enUS','Ok I am here. I know this probably isn\'t what you\'d call opportune time, but hey - some of my wares can help stick it to these demons!','',26124),
(99503,'enUS','','I... I did it! I am the greatest warlock that ever lived!',26124),
(99504,'enUS','I will go ahead and secure the elevators.','',26124),
(99505,'enUS','I sense demons nearby. After all that time in stasis, I am ready to hunt.','',26124),
(99506,'enUS','','My blades are ready, $n. I will check on the situation ahead.',26124),
(99507,'enUS','If those spires give you trouble, take out the stabilizers.','',26124),
(99508,'enUS','','Gul\'dan could never access this chamber. One of my Wardens has betrayed me!',26124),
(99509,'enUS','I, too, have felt betrayal by my own kind.','',26124),
(99510,'enUS','%s looks over at Altruis the Sufferer.','',26124),
(99511,'enUS','','Cordana! You will answer to the High Council for this.',26124),
(99512,'enUS','Soon. The body is cold, but his soul is not done fighting. We have work to do before he is ready.','',26124),
(99516,'enUS','We have defeated your champion. Now, release us from Helheim!','We have defeated your champion. Now, release us from Helheim!',26124),
(99517,'enUS','Illidan Stormrage. At last, I meet the great Betrayer.','',26124),
(99518,'enUS','','Thank you, $n. I would\'ve been dead fel meat without you. He must have been attracted to the magic at this site.',26124),
(99519,'enUS','','My first hunt on my own! I\'ve been tracking a beast all the way from the other side of Val\'sharah... The destruction he leaves in his wake is astounding! All signs point here. Will you help me track him down?',26124),
(99520,'enUS','Sure.','Sure.',26124),
(99521,'enUS','','Alright. The tracks lead this way, up to the statue. Follow me!',26124),
(99522,'enUS','Just like old times, eh Kayn?','',26124),
(99523,'enUS','','Look at this! The bite marks on this meat are nothing like I\'ve ever seen! Wait... why are they glowing green?',26124),
(99524,'enUS','Do not speak to me of old times, Altruis. You betrayed Illidan. You betrayed us all!','',26124),
(99525,'enUS','After ten-thousand years of imprisonment, Illidan succumbed to the fel energy within. When he was freed, he was not in his right mind.','',26124),
(99526,'enUS','He was fighting it, as we all do. He needed us to have faith in him, Altruis.','',26124),
(99527,'enUS','You followed Illidan blindly, like a dog. Even when he lost his way.','',26124),
(99528,'enUS','He made the hard choices. He sacrificed EVERYTHING. What did you give?','',26124),
(99529,'enUS','','A demon?! I\'m not that kind of hunter! I\'M NOT THAT KIND OF HUNTER!',26124),
(99530,'enUS','You heard the Warden. We are the only ones who can defeat the Legion. We MUST survive this place.','',26124),
(99531,'enUS','','This is sheer madness! The Wardens have lost control of their prison.',26124),
(99532,'enUS','','Aside from us, the most powerful prisoners were sealed on this level. WERE being the operative word.',26124),
(99533,'enUS','','I\'ll place these bracers into our improvised forge.',26124),
(99534,'enUS','','Now, add a little leyflame, and...',26124),
(99535,'enUS','','Voila! It works!',26124),
(99536,'enUS','Simply brilliant, Ildine! How much obliterum did we get?','',26124),
(99537,'enUS','','About two grains. Two grains of obliterum.',26124),
(99538,'enUS','Well, it\'s a start.','',26124),
(99539,'enUS','','I cannot recommend this, Khadgar. Our knowledge of demonic forces is limited. We risk attracting the attention of the Legion, or worse.',26124),
(99540,'enUS','I agree. Our artisans lack the skills to build such a forge. The dangers of toying with demonic powers are simply too great.','',26124),
(99541,'enUS','I agree. You of all people should know that dealing with this type of power carries great danger, demon hunter. I cannot allow it in my city.','',26124),
(99542,'enUS','I\'m sorry, but your request has been den--','',26124),
(99543,'enUS','Actually, Khadgar, I believe I may know someone that can build this forge. An expert.','',26124),
(99544,'enUS','Really? Who?','',26124),
(99545,'enUS','Perhaps better you didn\'t know, sir.','',26124),
(99546,'enUS','How mysterious. Very well! Archmage Karlain will assist you, $n.','',26124),
(99548,'enUS','The gargoyles lift off from their pressure plates and the portcullis slams shut!','',26124),
(99549,'enUS','','Stop this foolish bickering. We do not have time for this!',26124),
(99550,'enUS','Lord Illidan taught us to fight and to persevere. Together, we destroyed countless demons. YOU chose the coward\'s path.','',26124),
(99551,'enUS','I could only trust my own sight, brother. Lord Illidan was becoming no better than our enemy.','',26124),
(99552,'enUS','You killed our own people! You spit in the face of our sacrifices!','',26124),
(99553,'enUS','We\'ve discovered an exciting new way to extract demonic essence from our crafted armor, but to do so, we need your permission to build a forge.','We\'ve discovered an exciting new way to extract demonic essence from our crafted armor, but to do so, we need your permission to build a forge.',26124),
(99554,'enUS','Enough! My colossal infernal will crush you.','',26124),
(99555,'enUS','I did not summon you for nothing. Destroy them!','',26124),
(99556,'enUS','I\'m gonna charge right over you!','',26124),
(99557,'enUS','Your experience doesn\'t match mine!','',26124),
(99558,'enUS','You think you can match the strength of my fists?','',26124),
(99559,'enUS','You should wear a helmet when you fight me!','',26124),
(99560,'enUS','Okay stop! STOP! Watch the jaw! You win! I\'ve never seen such speed before. You\'re a good kid, mac. Keep it up. I\'ll be back for my belt some day.','',26124),
(99561,'enUS','Might of the Legion? Hah! We\'ll see about that...','',26124),
(99562,'enUS','Let this be a lesson to all who invade OUR lands!','',26124),
(99563,'enUS','Hold the line! These treacherous creatures know NOTHING of war!','',26124),
(99564,'enUS','Sylvanas has instructed me to take ALL of your heads! And I WILL deliver.','',26124),
(99565,'enUS','The only blood drawn on this day will be the blood of the Legion!','',26124),
(99566,'enUS','I\'m the heavyweight champion of Highmountain! You think you can take me on, kid? It\'ll be a punch out! Show me what you\'re worth... but when I knock you down DON\'T GET UP!','',26124),
(99567,'enUS','I\'m ready!','I\'m ready!',26124),
(99568,'enUS','Things are not what they seem, $n. I suggest keeping a close eye on those around you.','',26124),
(99569,'enUS','Hail champion.$b$bI was sent by the High Chieftain Ulan to find you.','',26124),
(99570,'enUS','He went easy on you, outsider. Come, speak.','',26124),
(99571,'enUS','Something about this doesn\'t seem right.','',26124),
(99572,'enUS','I\'ve got a bad feeling about this.','',26124),
(99573,'enUS','','Well that was terrifying. Thanks for helping, $p. Maybe I should find a demon hunter partner...',26124),
(99574,'enUS','','Beware, $n. There is a dreadlord inside that Soul Engine.',26124),
(99575,'enUS','Oh good, another soul for my engine.','',26124),
(99576,'enUS','Tyranna... help.','',26124),
(99577,'enUS','The portals are down! Their frontline has been crushed! Hold your defenses!','',26124),
(99578,'enUS','','At least your soul will now power my engine.',26124),
(99579,'enUS','Signal the bat riders!','',26124),
(99580,'enUS','','You have my thanks, outsider.',26124),
(99581,'enUS','','I return to battle!',26124),
(99582,'enUS','','These wretches will know the wrath of the Valkyra!',26124),
(99583,'enUS','','You have saved me from an unimaginable fate. Thank you.',26124),
(99584,'enUS','','We will show Helya no quarter!',26124),
(99585,'enUS','','Uriah! I\'m here! Where are you?',26124),
(99586,'enUS','','Oh Uriah, you\'re injured!',26124),
(99587,'enUS','','$n, we must do something to save him!',26124),
(99588,'enUS','By this hammer, I claim this mountain!','',26124),
(99589,'enUS','The curse is lifted! Finally I will battle in the Halls of Valor!','',26124),
(99590,'enUS','My soul belongs to Odyn.','',26124),
(99591,'enUS','I will never be a kvaldir!','',26124),
(99592,'enUS','Odyn smiles upon us.','',26124),
(99593,'enUS','Helya was a fool to think she could hold me.','',26124),
(99594,'enUS','To the Halls of Valor!','',26124),
(99595,'enUS','Dargrul the Underking! Come down here and face justice for those you have betrayed.','',26124),
(99596,'enUS','Welcome, champion, to Thunder Totem. In better days we would have warriors from the Bloodtotem tribe or eagle riders from the Skyhorn tribe. Today, we are so few we could barely keep a kobold out.','',26124),
(99597,'enUS','You bring this back in one piece, ok? Go get \'em!','You bring this back in one piece, ok? Go get \'em!',26124),
(99598,'enUS','The ram on this one\'s supercharged. My handiwork! Bag a few demons for me!','The ram on this one\'s supercharged. My handiwork! Bag a few demons for me!',26124),
(99599,'enUS','Just a few tons of Gnomeregan\'s finest anti-Demon engineering! Put it to good use.','Just a few tons of Gnomeregan\'s finest anti-Demon engineering! Put it to good use.',26124),
(99600,'enUS','I guess that isn\'t so bad...','I guess that isn\'t so bad...',26124),
(99601,'enUS','What must we give in return?','What must we give in return?',26124),
(99602,'enUS','Everything!','Everything!',26124),
(99603,'enUS','Loaded with munitions and ready to hit \'em hard. Fly safe!','Loaded with munitions and ready to hit \'em hard. Fly safe!',26124),
(99604,'enUS','Death from above is the best kind, wouldn\'t you agree? Give \'em hell!','Death from above is the best kind, wouldn\'t you agree? Give \'em hell!',26124),
(99605,'enUS','Be... careful... this is a... trap...','',26124),
(99606,'enUS','Let\'s kick the tires and light the fires!','Let\'s kick the tires and light the fires!',26124),
(99607,'enUS','Guuuaaaahhh!','',26124),
(99608,'enUS','Please, defeat them! I\'ll protect my son!','',26124),
(99609,'enUS','Thank you, $p. We are forever indebted to you.','',26124),
(99610,'enUS','I am beyond saving, Rosalyn. You need to focus on finding the demons that have been released from the soul chambers and trap them once again, before it\'s too late.','',26124),
(99611,'enUS','Soulkeeper Uriah takes a slow, pained breath.','',26124),
(99612,'enUS','','I have precious little time to waste. Speak or leave.',26124),
(99613,'enUS','','Open the wells and unleash a torrent of souls on him.',26124),
(99614,'enUS','Your soul will be ours.','',26124),
(99615,'enUS','Kill them before they can get up to the Fel Hammer.','',26124),
(99616,'enUS','Defend the Soul Engine.','',26124),
(99617,'enUS','Thank you for the rescue. I will see if any of the other warbraves survived the attack.','',26124),
(99618,'enUS','Ooh! You have little creatures! Let\'s fight, and if I win I get to EAT one!','',26124),
(99619,'enUS','Ha ha ha! Now we show them our true power!','',26124),
(99620,'enUS','To battle!','',26124),
(99621,'enUS','Flummox no need pets! Flummox eats them NOW!','',26124),
(99622,'enUS','I\'m still in training, Mac. But I\'m going to win my belt back from you!','',26124),
(99623,'enUS','This platform will take you into the sacred Hall of Chieftains where Mayla Highmountain awaits you.','',26124),
(99624,'enUS','','But... but I don\'t know how, Uriah. I cannot do it without you!',26124),
(99625,'enUS','You can, Rosalyn, and you will. You\'re more gifted than you let yourself believe.','',26124),
(99626,'enUS','Soulkeeper Uriah exhales tiredly as the last bit of breath leaves his lifeless body.','',26124),
(99627,'enUS','Knead with your fists, not your face!','',26124),
(99628,'enUS','Mix \'em up, mix \'em up! C\'mon now!','',26124),
(99629,'enUS','Winning isn\'t that bad. You should all try it sometime!','',26124),
(99630,'enUS','Thanks, I thought I was going to die!','Thanks, I thought I was going to die!',26124),
(99631,'enUS','There\'s a reason why Taurson is the best! Keep training!','',26124),
(99632,'enUS','By the light of Elune, thank you!','By the light of Elune, thank you!',26124),
(99633,'enUS','We need to defend the temple!','We need to defend the temple!',26124),
(99634,'enUS','Thank you for saving me!','Thank you for saving me!',26124),
(99635,'enUS','Three hours in the air is too much. We need more pilots!','Three hours in the air is too much. We need more pilots!',26124),
(99636,'enUS','I always wanted to fly... but not during the end of the world.','I always wanted to fly... but not during the end of the world.',26124),
(99637,'enUS','I\'m exhausted... I don\'t know if I can take another flight today.','I\'m exhausted... I don\'t know if I can take another flight today.',26124),
(99638,'enUS','We\'ve got to stay sharp. Too much is riding on us, and we\'re going back up soon.','We\'ve got to stay sharp. Too much is riding on us, and we\'re going back up soon.',26124),
(99639,'enUS','We\'re in this together, ok? You\'re doing great up there! We\'re gonna make it.','We\'re in this together, ok? You\'re doing great up there! We\'re gonna make it.',26124),
(99640,'enUS','Azeroth depends on us fighting in the skies. Stay strong, for all of us.','Azeroth depends on us fighting in the skies. Stay strong, for all of us.',26124),
(99641,'enUS','Go, Champion. I will rally what forces I can to assault the drogbar stronghold to our south. Meet me at the cavern\'s mouth when you are ready.','',26124),
(99642,'enUS','','I can\'t believe he\'s gone...',26124),
(99643,'enUS','The eagle nods his thanks before flying away, free.','',26124),
(99644,'enUS','This is a disaster... but we can win this! Keep the tanks rolling. Keep our birds in the air. The world won\'t end without tasting some Gnome ingenuity!','',26124),
(99645,'enUS','','Let\'s keep moving. The others are in the chamber just ahead.',26124),
(99646,'enUS','I respect our past, but I cannot forgive Illidan\'s methods. The Illidari deserve a better leader.','',26124),
(99647,'enUS','Then we stand at an impasse. $n, you must resolve this conflict.','',26124),
(99648,'enUS','','<Thalyssra is shaking uncontrollably and can barely speak. |cFFF92304Her hunger must be sated before all else.|r>',26124),
(99649,'enUS','','The Nightwell is a font of incredible power. We must not allow the Legion to make use of it.',26124),
(99650,'enUS','','Yes! I can feel the power coursing through me!\n\nI am whole again.',26124),
(99651,'enUS','What\'s this? Helya will surely reward me for this offering.','',26124),
(99652,'enUS','Impressive you have made it this far, demon hunters. Now, I will extinguish your souls like a candle\'s flame!','',26124),
(99653,'enUS','We\'ve done it, Illidari! FREEDOM IS OURS!','',26124),
(99656,'enUS','I am Archmage Khadgar, leader of the Kirin Tor.','',26124),
(99658,'enUS','Demon hunters, Azeroth needs your help.','',26124),
(99659,'enUS','Helya is defeated; it is time to call in the val\'kyr!','',26124),
(99660,'enUS','Once that witch is defeated I can free the stolen souls of the valejar.','',26124),
(99661,'enUS','This one\'s a bit rough on the stick. Be careful goin\' downhill boss.','This one\'s a bit rough on the stick. Be careful goin\' downhill boss.',26124),
(99662,'enUS','Spikes... big rocks... everything looks ok. Smash those Demons good!','Spikes... big rocks... everything looks ok. Smash those Demons good!',26124),
(99663,'enUS','Take the fight to \'em! Demons will burn by Horde might!','Take the fight to \'em! Demons will burn by Horde might!',26124),
(99664,'enUS','You have my thanks, champion.','',26124),
(99665,'enUS','Captains, report!','',26124),
(99666,'enUS','','We\'ve encountered heavy resistance near the Soul Engine.',26124),
(99667,'enUS','','Our assault is underway. I\'ll join in when you attack the overseer.',26124),
(99668,'enUS','Be careful givin\' it gas. The tanks are a bit creaky!','Be careful givin\' it gas. The tanks are a bit creaky!',26124),
(99669,'enUS','... Battlelord, report!','',26124),
(99670,'enUS','Big pile of bombs for ya. Make sure they land on the demons, ok?','Big pile of bombs for ya. Make sure they land on the demons, ok?',26124),
(99671,'enUS','The balloon\'s patched up, but I left a parachute in there just in case! At least, I think I did.','The balloon\'s patched up, but I left a parachute in there just in case! At least, I think I did.',26124),
(99672,'enUS','','We\'ve regained control of Southpoint Gate! I\'m sending ground patrols toward Tarren Mill!',26124),
(99673,'enUS','','Hold your defenses! I\'m headed your way!',26124),
(99674,'enUS','Feed: 100x |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t|Hcurrency:1155|h|cFFFFFFFF Ancient Mana|h|r','Feed: 100x |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t|Hcurrency:1155|h|cFFFFFFFF Ancient Mana|h|r',26124),
(99675,'enUS','The Legion has begun its invasion of our world. From sea to shore, brave defenders of the Alliance and Horde are answering the call to arms.\n \nHowever, they will ultimately fail without the aid of the demon hunters. You were uniquely trained as ruthless weapons against the Legion. It is time to go on the offensive.','',26124),
(99676,'enUS','Spend |TINTERFACE\\ICONS\\INV_OFFHAND_PVEALLIANCE_D_01.BLP:20|t|Hitem:129094|h|cFF0070DD Nightwell Ambrosia|r|h to Empower this Nightfallen?','Spend |TINTERFACE\\ICONS\\INV_OFFHAND_PVEALLIANCE_D_01.BLP:20|t|Hitem:129094|h|cFF0070DD Nightwell Ambrosia|r|h to Empower this Nightfallen?',26124),
(99677,'enUS','Feed Ancient Mana |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t x100','Feed Ancient Mana |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t x100',26124),
(99678,'enUS','Thank you champion. But be careful, the drogbar Underking wields a tool of the titans.','',26124),
(99679,'enUS','','My... my village. It is gone.',26124),
(99680,'enUS','In the name of the Dark Lady!','',26124),
(99681,'enUS','I want this shan ronir to tell the others. Tell them their doom will come once I master this hammer.','',26124),
(99682,'enUS','Come, rest your weary soul on a feathery bed.','',26124),
(99683,'enUS','Good, you made it! Defeat Helya and I will set these souls free!','',26124),
(99684,'enUS','Fishing','Fishing',26124),
(99685,'enUS','Yer soul belongs to Helya now, worm!','',26124),
(99686,'enUS','Drown in the choking tides!','',26124),
(99687,'enUS','I\'ll hack ye in two!','',26124),
(99688,'enUS','Come on, hero! Follow us, and we\'ll help you take down these demons!','Come on, hero! Follow us, and we\'ll help you take down these demons!',26124),
(99689,'enUS','None can escape... Helya\'s grasp...','',26124),
(99690,'enUS','Somebody! Anybody! Help!!!','',26124),
(99691,'enUS','I see you in there, Okuna. Did you think you could kill my father and get away with it?','',26124),
(99692,'enUS','I too would like to experiment with this pigment. Let\'s see here...','',26124),
(99693,'enUS','That went better than expected. Yes, this pigment WILL work out nicely.','',26124),
(99694,'enUS','','My husband says I battle too much.  What does he know?',26124),
(99695,'enUS','What, me bein\' all hidden ain\'t enough of a clue that I wanna be left alone?$b$bGet lost, if ya know what\'s good for ya!','',26124),
(99696,'enUS','','Bring it on!',26124),
(99697,'enUS','','I\'ve already lost two sisters to the demons. You want to investigate that cart? It\'s all yours.',26124),
(99698,'enUS','','Don\'t tell anyone, ok?',26124),
(99699,'enUS','','Take it!',26124),
(99700,'enUS','','Aw, come on!',26124),
(99701,'enUS','','Seriously?!?',26124),
(99702,'enUS','','What the heck is wrong with you?!',26124),
(99703,'enUS','','Are you AFK?',26124),
(99704,'enUS','','Maybe use your good pets.',26124),
(99705,'enUS','','Are you even trying?',26124),
(99706,'enUS','We\'ll need permission from the ruling council of Dalaran before we can build a forge big enough to create obliterum en masse.','',26124),
(99707,'enUS','You seem to be on good terms with Khadgar - maybe you should ask him, $n.','',26124),
(99708,'enUS','','I lost the obliterum.',26124),
(99709,'enUS','Oh, Vanessa!','',26124),
(99710,'enUS','Yeah? So what do you want? I\'m tryin\' to do business here!','',26124),
(99711,'enUS','Ildine sent me. Where\'s the shipment you owe her?','Ildine sent me. Where\'s the shipment you owe her?',26124),
(99712,'enUS','Tell Ildine I got a better offer. Now scram, before I have to get rough!','',26124),
(99713,'enUS','If you\'re thinking about bribing me, think again. I have a duty to keep these sewers safe!$b$b<Raethan lowers his voice to a whisper:>$b$bCome back in a few minutes and we\'ll talk, $c.','',26124),
(99714,'enUS','Yes, I know that people are fighting out there. My guards are simply... taking a break.$b$b<Raethan lowers his voice to a whisper:>$b$bYou want us back on duty? Come back in a few minutes, and bring some Sightless Eyes with you.','',26124),
(99715,'enUS','Quick tip on bribes, $r: make sure you actually have the money before you make the offer. Now get out of my sight, unless you\'re looking for a room in Violet Hold!','',26124),
(99716,'enUS','<Threaten Belamy.>','<Threaten Belamy.>',26124),
(99717,'enUS','Okay, okay! You called my bluff. I\'ll tell you what you want to know, tough $Gguy:gal;.$b$bI sold the enchanting supplies to a fence up in Dalaran. Grimbore, Boargrim... somethin\' orcish like that.$b$bNow beat it, will ya? I\'ve got a customer on the way.','',26124),
(99718,'enUS','I\'ll inform Ildine that you tried to cheat her.','I\'ll inform Ildine that you tried to cheat her.',26124),
(99719,'enUS','I want a word with you, Belamy.','I want a word with you, Belamy.',26124),
(99720,'enUS','I\'ve had enough. I\'m moving back to Moa\'ki Harbor the first chance I get.','',26124),
(99721,'enUS','My underking, this one still lives.','',26124),
(99722,'enUS','Here are the cards you wanted.','Here are the cards you wanted.',26124),
(99723,'enUS','THEY THREW AWAY A... errr... I mean, let\'s see what I can do with these.','',26124),
(99724,'enUS','This fish pigment really is something. I should start selling it...','',26124),
(99725,'enUS','And for the final touch, just a bit of magic and...','',26124),
(99726,'enUS','Voila! Finished.','',26124),
(99727,'enUS','I told ya what ya wanted to know. Ain\'t that enough?$b$bDon\'t exactly want to draw attention to myself here...','',26124),
(99728,'enUS','Empower: 1x |TINTERFACE\\ICONS\\INV_OFFHAND_PVEALLIANCE_D_01.BLP:20|t|Hitem:129094|h|cFF0070DD Nightwell Ambrosia|r|h','Empower: 1x |TINTERFACE\\ICONS\\INV_OFFHAND_PVEALLIANCE_D_01.BLP:20|t|Hitem:129094|h|cFF0070DD Nightwell Ambrosia|r|h',26124),
(99729,'enUS','The Battlelord sent me.','',26124),
(99730,'enUS','The Battlelord sent me.','',26124),
(99731,'enUS','We will destroy the Burning Legion.','',26124),
(99732,'enUS','It is an honor to kill in Lord Illidan\'s name.','',26124),
(99733,'enUS','Lord Illidan commands and I follow.','',26124),
(99734,'enUS','This demon will fall.','',26124),
(99735,'enUS','I am here to assist you.','',26124),
(99736,'enUS','The Ashtongue serve.','',26124),
(99737,'enUS','The Legion must be stopped.','',26124),
(99738,'enUS','','Lady S\'theno requested I join you.',26124),
(99739,'enUS','','Lady S\'theno requested I join you.',26124),
(99740,'enUS','','The Burning Legion will be destroyed.',26124),
(99741,'enUS','','Legion magic is nothing compared to that of the naga.',26124),
(99742,'enUS','','Lord Illidan leads and the Coilskar follow.',26124),
(99743,'enUS','','This demon will die.',26124),
(99744,'enUS','','I have come to your aid.',26124),
(99745,'enUS','','The Coilskar honor their allegiance.',26124),
(99746,'enUS','','The Legion must be stopped before they burn our world.',26124),
(99747,'enUS','','The Matron Mother bid me come to help.',26124),
(99748,'enUS','','The Matron Mother bid me come to help.',26124),
(99749,'enUS','','We will help you destroy the Legion.',26124),
(99750,'enUS','','I serve Illidan.',26124),
(99751,'enUS','','Lord Illidan commands and I follow.',26124),
(99752,'enUS','','This demon will die from a thousand cuts.',26124),
(99753,'enUS','','I am here to maim and kill.',26124),
(99754,'enUS','','The Shivarra serve.',26124),
(99755,'enUS','','The Legion\'s march across the stars will be stopped.',26124),
(99756,'enUS','Kayn, tell me what you know about Mardum.','Kayn, tell me what you know about Mardum.',26124),
(99757,'enUS','If this doesn\'t end soon we\'re gonna need more supplies.','If this doesn\'t end soon we\'re gonna need more supplies.',26124),
(99758,'enUS','C\'mon then. Yer not goin\' out like this!','C\'mon then. Yer not goin\' out like this!',26124),
(99759,'enUS','You\'ll be back on yer feet in no time.','You\'ll be back on yer feet in no time.',26124),
(99760,'enUS','On the bright side - ye might get promoted after a heroic act like that!','On the bright side - ye might get promoted after a heroic act like that!',26124),
(99761,'enUS','I sold the enchanting supplies to a fence up in Dalaran. Grimbore, Boargrim... somethin\' orcish like that.$b$bNow beat it, will ya? I got a customer on the way.','',26124),
(99762,'enUS','Your souls shall suffer!','',26124),
(99763,'enUS','The Legion conquers all.','',26124),
(99764,'enUS','Worthless species!','',26124),
(99765,'enUS','You will burn!','',26124),
(99766,'enUS','Your world is at an end, mortals!','',26124),
(99767,'enUS','Ah, $n, it\'s good to see you again. Now that we are all gathered, let\'s begin.','',26124),
(99768,'enUS','Bow before the might of Sargeras.','',26124),
(99769,'enUS','The outcome of this world has been decided!','',26124),
(99770,'enUS','Puny mortals. I\'ll deal with you myself.','',26124),
(99771,'enUS','Yer not welcome here!','Yer not welcome here!',26124),
(99772,'enUS','I\'ll show ya who yer messin\' with!','I\'ll show ya who yer messin\' with!',26124),
(99773,'enUS','Hold still! This\'ll only hurt a little!','Hold still! This\'ll only hurt a little!',26124),
(99774,'enUS','Today ye find out what yer insides look like!','Today ye find out what yer insides look like!',26124),
(99775,'enUS','You appear to be lost, friend.','You appear to be lost, friend.',26124),
(99776,'enUS','By the Jade Serpent! What was that?!','',26124),
(99777,'enUS','Yer messin\' with the wrong dwarf.','Yer messin\' with the wrong dwarf.',26124),
(99778,'enUS','Today is not yer day!','Today is not yer day!',26124),
(99779,'enUS','And to think I used to be afraid of Ildine back in our Ravenholdt days! She\'s gone soft!','',26124),
(99780,'enUS','Make yourself at home, and may the wind roll with you.','',26124),
(99781,'enUS','Ready up! He\'s comin\' down!','',26124),
(99782,'enUS','This is what we\'ve been trainin\' for!','',26124),
(99783,'enUS','I\'ve got this one, shaman. Help the others!','',26124),
(99784,'enUS','Training seems to have paid off! Well done!','',26124),
(99785,'enUS','Whoever is meddling here shall be dealt with shortly!','',26124),
(99786,'enUS','Your soul belongs to me now.','',26124),
(99787,'enUS','The service in this place is terrible. TERRIBLE!','',26124),
(99788,'enUS','I\'m here for the enchanting supplies Belamy sold you.','I\'m here for the enchanting supplies Belamy sold you.',26124),
(99789,'enUS','I got those supplies fair an\' square! I\'m an honest businessman trying to make a living!','',26124),
(99790,'enUS','You\'re dealing in stolen goods. Hand them over!','You\'re dealing in stolen goods. Hand them over!',26124),
(99791,'enUS','','Ah... the fog has lifted, just a bit...',26124),
(99792,'enUS','','Thank you, I was... losing control.',26124),
(99793,'enUS','','Ugh. I shall never grow accustomed to that.',26124),
(99794,'enUS','','Hanging in there, thanks to you...',26124),
(99795,'enUS','','My head... still spinning...',26124),
(99796,'enUS','','Oh, but for a taste of the real thing...',26124),
(99797,'enUS','','Oh, how I\'ve longed for this!',26124),
(99798,'enUS','Well timed, champion. We have cleared a path to Dargrul. This way...','',26124),
(99799,'enUS','','At last, I am quenched.',26124),
(99800,'enUS','','Ahh, to be alight with power once again!',26124),
(99801,'enUS','','My mind is ablaze. I am restored.',26124),
(99802,'enUS','','I surge with power!',26124),
(99803,'enUS','I\'m here for the enchanting supplies, Bonegrim. Where are...','',26124),
(99804,'enUS','','This feeling... flooding back to me... I am alive!',26124),
(99805,'enUS','Listen, I don\'t want any trouble. I\'m just gonna go...','',26124),
(99806,'enUS','Not withering today, it seems...','',26124),
(99807,'enUS','Phew. I was close... too close.','',26124),
(99808,'enUS','A drop in the ocean of my thirst... But appreciated, nonetheless.','',26124),
(99809,'enUS','Blech. How did we live before the Nightwell?','',26124),
(99810,'enUS','Eurrghh... Still woozy...','',26124),
(99811,'enUS','Still here... for now.','',26124),
(99812,'enUS','Oh, it burns going down. In a good way!','',26124),
(99813,'enUS','My strength returns!','',26124),
(99814,'enUS','$ct, I\'m proud to report that my mission was easily accomplished.','',26124),
(99815,'enUS','Ah, it is good to be in touch with my better half once again.','',26124),
(99816,'enUS','Like a breath of air! Thank you!','',26124),
(99817,'enUS','This power... Had I ever truly tasted this before?','',26124),
(99818,'enUS','Nooo! My profits! I was gonna buy myself a boat...','',26124),
(99819,'enUS','Station Highlord Darion Mograine.','Station Highlord Darion Mograine.',26124),
(99820,'enUS','Station Thassarian.','Station Thassarian.',26124),
(99821,'enUS','Station Koltira Deathweaver.','Station Koltira Deathweaver.',26124),
(99822,'enUS','We\'ll stay here and make sure nothing more can be taken from the crater. Stay on the offensive!','We\'ll stay here and make sure nothing more can be taken from the crater. Stay on the offensive!',26124),
(99823,'enUS','So much energy... We\'ve got to stay here and ensure the Demons can take no more from this crater. Keep up the fight!','So much energy... We\'ve got to stay here and ensure the Demons can take no more from this crater. Keep up the fight!',26124),
(99824,'enUS','|TInterface\\Icons\\spell_frost_summonwaterelemental:20|t%s begins to cast |cFFFF0000|Hspell:193051|h[Call the Seas]|h|r!','',26124),
(99825,'enUS','Push them back! Don\'t let them take yer brothers and sisters!','',26124),
(99826,'enUS','','$n! You and your demon hunters are nothing.',26124),
(99827,'enUS','','The keystone was entrusted to me by Sargeras himself. You will not have it!',26124),
(99828,'enUS','The mists are having an ill effect on my crew. They have become wild and uncontrollable. They care not for the sea and prefer to bicker and brawl with each other.$B$BKjell, the harbor master, has ordered us to depart for fresh supplies as soon as we are able. I have assigned extra duties in hopes that the work will occupy their time until we ship out.$B$BI can only hope that the sea air will calm my crew and return their vigor.','',26124),
(99829,'enUS','','Hurry. Kayn has already launched the attack on Tyranna.',26124),
(99830,'enUS','We have accomplished the impossible. I must admit, I had my doubts about your leadership, $n. But no more.\n\nLet\'s get back and put an end to the attack on the Black Temple. Lord Illidan awaits.','',26124),
(99831,'enUS','','Your foul magic is in vain, monster! These writings are under my protection.',26124),
(99832,'enUS','','Away with you, monster!',26124),
(99833,'enUS','','Give up! You only strike at the wind!',26124),
(99834,'enUS','Maybe it\'s best that I stay here in the foothold. I still haven\'t recovered from my wounds when I was held prisoner down below.\n\nThis world is overflowing with demonic energy. It\'s making it harder for me to contain my own fel power.','',26124),
(99835,'enUS','Make the Illidari Foothold your home.','Make the Illidari Foothold your home.',26124),
(99836,'enUS','$n, you made it through!','',26124),
(99837,'enUS','','Good luck to all of you. I will get the rest of us up there, $n.',26124),
(99838,'enUS','','Thank you, friend! My students died to protect these scrolls. Centuries of history could have been lost!',26124),
(99839,'enUS','','A curse has fallen upon our harbor.$B$BGulls drop like stones from the sky. I saw one fall on a deck hand\'s head the other day. It knocked him out cold.$B$BSchools of fish rot belly-up in the shoals. Our fishermen have not had a decent catch in weeks and the stench of dead fish is horrible.$B$BI have taken on extra shifts in the tower, as most of my watchmen have gone missing. I take respite up here, as the foul odor and stale air are not as stifling.$B$BThe harbor is dead. The mists have choked the very life from it.',26124),
(99840,'enUS','<There is a note attached to a supply requisition.>$B$BHarbor Master Kjell,$B$BI do not know what foul bane these mists carry, but barely a day after they engulfed the harbor, our entire stock of provisions spoiled. We need to resupply our stock immediately.$B$BDispatch Captain Sten on a supply run as soon as he is able, assuming he can stop his crew from bickering long enough to set sail.$B$BIn the meantime, we will all have to tighten our belts and stretch what little we have left. Since most of the town has gone missing, this shouldn\'t be too difficult.','',26124),
(99841,'enUS','<Most of the roster entries are blank. There is a sloppily written note on the corner of one of the drafts.>$B$BDamn these mists to Helheim! Not long after they arrived, many of my craftsmen have vanished, and the few that remain have not the sense in their head to work. They act as if they had run headlong into the mast.$B$BHow am I supposed to get Sten\'s ship ready to sail with a sparse bunch of loons at my disposal?$B$BI will do what I can to get the ship seaworthy, alone if I must, but I need good men to fill my work roster.','',26124),
(99843,'enUS','You\'re in danger here. Grand Master Hight needs everyone to gather at the Shrine of the Ox.','You\'re in danger here. Grand Master Hight needs everyone to gather at the Shrine of the Ox.',26124),
(99844,'enUS','','When Dargrul stole the Hammer of Khaz\'goroth he did so right in front of myself and the other chieftains.',26124),
(99845,'enUS','','Our last High Chieftain, Ulan, tried to stop him and was slain. Mayla may have picked up her father\'s totem, but she is not High Chieftain yet.',26124),
(99846,'enUS','','Dargrul didn\'t just steal a hammer, he shattered our people, driving a wedge between our tribes.',26124),
(99847,'enUS','','Chen Stormstout was teaching a class of youngsters when the attack began. He\'s one of the strongest monks I know, but even he won\'t be able to hold out forever. Come, we must rescue them!',26124),
(99848,'enUS','This fel circle is similar to the ones used in Skovald\'s attempts to enslave the Thorignir dragons of Thorim\'s Peak. $B$BIt appears to be too powerful to break by normal means.','',26124),
(99849,'enUS','','The time for ascension is upon you. Prepare yourselves; Odyn awaits your arrival.',26124),
(99850,'enUS','Use the Jailer\'s Shard to break Vethir\'s prison.','Use the Jailer\'s Shard to break Vethir\'s prison.',26124),
(99851,'enUS','We are almost to the exit, $n. Our freedom is near.','',26124),
(99852,'enUS','These beasts are quite feisty, unless you know how to deal with them. This one should listen to your commands... for a little while, at least.','',26124),
(99854,'enUS','You\'ve already ruined my business. Can\'t you just leave me alone?','',26124),
(99855,'enUS','','For years we were shunned, banished to the darkest depths of the world by the Wardens. \n\nNow, we must rise to the hardest challenge our world has ever faced. Now, we must defend Azeroth against its greatest enemies.',26124),
(99856,'enUS','Fine, $r, I\'ll send the supplies to the enchanting shop. Now leave me to drink in peace!','',26124),
(99857,'enUS','','It was difficult, but I\'ve managed to gather some weapons and supplies. What do you need?',26124),
(99858,'enUS','I will temper my differences for now. The enemy is nearly at our doorstep, and we will be more effective united as one.','',26124),
(99859,'enUS','Your world is the last standing. It, too, will be purged.','',26124),
(99860,'enUS','I have watched many of your kind walk the path of life, but none have carried themselves with a stride such as yours.$B$BI look forward to telling your story.','',26124),
(99861,'enUS','We are but the beginning of the tide.','',26124),
(99862,'enUS','Your doom awaits.','',26124),
(99863,'enUS','Prepare for your own demise!','',26124),
(99864,'enUS','I am the avatar of your destruction!','',26124),
(99865,'enUS','Resistance only delays the inevitable!','',26124),
(99866,'enUS','Your world will crumble into ashes.','',26124),
(99867,'enUS','[Placeholder Event] - Anduin welcomes you to the Alliance.','',26124),
(99868,'enUS','[Placeholder Event] - Sylvanas welcomes you to the Horde.','[Placeholder Event] - Sylvanas welcomes you to the Horde.',26124),
(99869,'enUS','Ah, Darahir, my friend! Come have a drink!','',26124),
(99870,'enUS','Don\'t let this $c scare you away, Darahir! Wait... come back!','',26124),
(99871,'enUS','DIE!!','',26124),
(99872,'enUS','Grand Master Hight... <gasp> Grand Master Hight! A giant... THING appeared in the sky!','',26124),
(99873,'enUS','|TInterface\\Icons\\INV_Spear_07:20|t%s targets you with an |cFFFF0000|Hspell:191977|h[Impaling Spear]|h|r! Get behind someone!','',26124),
(99874,'enUS','Look what the ravens have dropped off.','',26124),
(99875,'enUS','GAHHH!! Keep going, $n. Activate the second pool.','',26124),
(99876,'enUS','It\'s... trying to break free! Hurry, $n, activate the final pool!','',26124),
(99877,'enUS','','|TInterface\\Icons\\INV_Enchant_EssenceArcaneSmall:20|t%s targets |cFFFF0000$n|r with a massive |cFFFF0000|Hspell:192708|h[Arcane Bomb]|h|r!',26124),
(99878,'enUS','Demons are appearing everywh--','',26124),
(99879,'enUS','You walk among the spirits of an ancient land, $r.','',26124),
(99880,'enUS','It is done. The demon is once again within my control.','',26124),
(99887,'enUS','|TInterface\\Icons\\Spell_Shadow_ShadeTrueSight:20|t%s begins to release a |cFFFF0000|Hspell:197969|h[Roaring Cacophony]|h|r!','',26124),
(99889,'enUS','','|TInterface\\Icons\\ability_shawaterelemental_swirl:20|t|cFFFF0000|Hspell:192696|h[Raging Storms]|h|r begin while no enemies are in melee range!',26124),
(99890,'enUS','Ah, we meet again, weakling. Now it\'s just you and me... and my guards!','',26124),
(99891,'enUS','Sssssth! Hatecoil, crush their bodies!','',26124),
(99892,'enUS','Hatecoil, drown them out!','',26124),
(99893,'enUS','Fools! Get out of the way!','',26124),
(99894,'enUS','You can\'t stop.... the storm...','',26124),
(99895,'enUS','Useless. All of you!','',26124),
(99896,'enUS','Like fish in a net.','',26124),
(99897,'enUS','That was for Athissa.','',26124),
(99898,'enUS','Ha, nowhere to hide!','',26124),
(99899,'enUS','Get my point?','',26124),
(99900,'enUS','I must retrieve an artifact from Tideskorn Harbor.','I must retrieve an artifact from Tideskorn Harbor.',26124),
(99901,'enUS','','No good! We don\'t have time to fight our way through that horde!',26124),
(99903,'enUS','What is it you seek, $c?','',26124),
(99904,'enUS','I\'m ready to begin the ritual.','I\'m ready to begin the ritual.',26124),
(99905,'enUS','The Swamprock murlocs\' favorite thing to do is cause shipwrecks with their makeshift lighthouse. Murlocs are fascinating, but these are ruthless.\n\nWe must save this coast! I have been raising this young murloc, Murky. We need to help him become stronger so he can teach the tadpoles to be better than their elders.','',26124),
(99906,'enUS','Almost had me that time! Try again!','',26124),
(99907,'enUS','Did you think you could hit me with that?','',26124),
(99910,'enUS','Hey! Over here!','',26124),
(99913,'enUS','Run, children! I\'ll protect you from this monster!','',26124),
(99919,'enUS','','Try not to be so conspicuous. Much more can be learned by observing than by engaging your enemy in combat.',26124),
(99922,'enUS','\"Go here, Nicholo.\"$b$b\"Fetch me that, Nicholo.\"$b$bOne day I\'ll be giving the orders, I tell ya.','',26124),
(99924,'enUS','I\'m ready when you are, Nicholo.','I\'m ready when you are, Nicholo.',26124),
(99925,'enUS','Stay alert, $n.','',26124),
(99926,'enUS','Just be ready in case anything happens, $n.','',26124),
(99927,'enUS','Whew, this is a lot harder than it looks.','',26124),
(99928,'enUS','This is looking pretty good so far. Don\'t stop now, $n.','',26124),
(99929,'enUS','I\'m almost finished, I swear.','',26124),
(99930,'enUS','Captain Bladewind! A warrior is attacking us!','',26124),
(99931,'enUS','To arms! Avenge me!','',26124),
(99932,'enUS','Yo, champ! We\'ve been researchin\' and cataloguin\' day and night to make sure every bozo in this joint knows all there is to know about the one and only Grand Assassin $n.$B$BThere\'s only one of you, right?','',26124),
(99937,'enUS','Aaaaah!','',26124),
(99939,'enUS','Success! We did it, $n!','',26124),
(99940,'enUS','God-King Skovald has been spotted at the top of the gates. \n\nWhen you are ready, we will take the fight to him!','',26124),
(99941,'enUS','Take me to the top, Vethir!','Take me to the top, Vethir!',26124),
(99942,'enUS','This may take longer than expected. Salvaging the necessary parts for these is quite difficult!','',26124),
(99943,'enUS','','ALL WILL BE ERADICATED!',26124),
(99944,'enUS','','WATER... ETERNAL...',26124),
(99945,'enUS','','WASHED AWAY.',26124),
(99946,'enUS','','TORN ASUNDER.',26124),
(99947,'enUS','','CRUSH!',26124),
(99948,'enUS','','DROWN!',26124),
(99949,'enUS','','TEMPEST!',26124),
(99950,'enUS','','THE STORM AWAKENS.',26124),
(99951,'enUS','<The crystal emanates a sinister energy.>','<The crystal emanates a sinister energy.>',26124),
(99952,'enUS','<Place the dreamleaf at the foot of the crystal.>','<Place the dreamleaf at the foot of the crystal.>',26124),
(99953,'enUS','I\'ll see if I can scrounge up a few more parts! We need every bit of help we can get.','',26124),
(99954,'enUS','Evan Banlip begins to whistle a grim tune.','',26124),
(99955,'enUS','You meddle in affairs you do not understand, gnome!','',26124),
(99956,'enUS','','SEEK... MAGIC...',26124),
(99957,'enUS','','ARCANE... ENERGY...',26124),
(99958,'enUS','You shall NOT finish what you have begun!','',26124),
(99959,'enUS','You will die before you finish your last stroke!','',26124),
(99960,'enUS','','[PLACEHOLDER - In this quest you walk around the boat with me while I explain my evil plan.]',26124),
(99961,'enUS','','[PLACEHOLDER - Did I say evil? I didn\'t mean that. Forget you heard anything. You are queued for the scenario. Now listen to this awesome exposition.]',26124),
(99962,'enUS','','Hello! Are you interested in learning how to craft leather wares?',26124),
(99963,'enUS','I\'m looking for some leather book cloth.','I\'m looking for some leather book cloth.',26124),
(99964,'enUS','','Oh yes, we just received a shipment the other day. I believe it\'s still upstairs if you want to go get it.',26124),
(99965,'enUS','Thank you for the assistance, friend! That foul creature put up quite a fight!','',26124),
(99966,'enUS','Children! Behave yourselves!','',26124),
(99967,'enUS','I sense that we will have more battles ahead of us.$b$b<Jang glances over at the cubs.>$b$bAnd I\'ve got to get them out of here!','',26124),
(99968,'enUS','Sorry, mister Stormstout.','Sorry, mister Stormstout.',26124),
(99969,'enUS','Sorry, sir.','Sorry, sir.',26124),
(99970,'enUS','Sorry.','Sorry.',26124),
(99971,'enUS','','[PLACEHOLDER - In this quest we walk around the ship while I explain the mission.]',26124),
(99972,'enUS','','[PLACEHOLDER - You\'re queued for the scenario. Ultimately we will push you directly into the scenario after this quest. For now, enjoy this exposition.]',26124),
(99973,'enUS','Try again, monster!','',26124),
(99974,'enUS','You have strength, but lack speed!','',26124),
(99975,'enUS','You seem like the type that just wants a fight. If you\'re interested, the Horde needs more troops.','',26124),
(99976,'enUS','I will fight alongside the Horde in battlegrounds, for now.','I will fight alongside the Horde in battlegrounds, for now.',26124),
(99977,'enUS','Get lost, $r! There\'s an ale callin\' my name.','',26124),
(99978,'enUS','I challenge you, Tor.','I challenge you, Tor.',26124),
(99979,'enUS','I challenge you, Ranulf.','I challenge you, Ranulf.',26124),
(99980,'enUS','I challenge you, Haldor.','I challenge you, Haldor.',26124),
(99981,'enUS','I challenge you, Bjorn.','I challenge you, Bjorn.',26124),
(99982,'enUS','Are you prepared?','',26124),
(99983,'enUS','Repelled by a mystic force within Shattrath!','Repelled by a mystic force within Shattrath!',26124),
(99984,'enUS','We must not allow Skovald to take these filth into the Halls of Valor!','',26124),
(99985,'enUS','<The ancient burial mound of a long-forgotten vrykul.>','<The ancient burial mound of a long-forgotten vrykul.>',26124),
(99986,'enUS','<Place 20 fjarnskaggl at the foot of the cairn.>','<Place 20 fjarnskaggl at the foot of the cairn.>',26124),
(99987,'enUS','Skovald may have escaped, but victory is still ours. His demons will no longer be able to plague Stormheim, thanks to you.\n\nLet us return to the gates, friend. I believe that Havi will wish to thank you.','',26124),
(99988,'enUS','Take me back to the Gates of Valor.','Take me back to the Gates of Valor.',26124),
(99989,'enUS','I am the king\'s blade. I am the Enduring!','',26124),
(99990,'enUS','I will continue my watch for the king unabated!','',26124),
(99991,'enUS','You will not spoil the king\'s return!','',26124),
(99992,'enUS','Forgive me, my king. My vigilance... is broken.','',26124),
(99993,'enUS','For the king!','',26124),
(99994,'enUS','I have failed you, my watchers. The king will not return.','',26124),
(99995,'enUS','','My sight has waned, but my blade remains sharp!',26124),
(99996,'enUS','','I will see you dead before you reach the Enduring!',26124),
(99997,'enUS','','I do not need sight to defeat you!',26124),
(99998,'enUS','','Do not disturb... the Enduring.',26124),
(99999,'enUS','','I can see you now...',26124),
(100000,'enUS','','My watch has ended.',26124),
(100001,'enUS','The eagles of Highmountain are in danger of becoming extinct if the drogbar aren\'t stopped.','',26124),
(100002,'enUS','','Rath-domaas!',26124),
(100003,'enUS','She must have come this way. Keep looking!','She must have come this way. Keep looking!',26124),
(100004,'enUS','<A small pile of dried herbs litters the floor. These are not natural - they were placed here by someone... or something.>','<A small pile of dried herbs litters the floor. These are not natural - they were placed here by someone... or something.>',26124),
(100005,'enUS','Sargeras\'s keystone is the crux of my plan to defeat the Burning Legion.','',26124),
(100006,'enUS','Yes, I agree to fight alongside the Horde in Ashran. Send me there now!','Yes, I agree to fight alongside the Horde in Ashran. Send me there now!',26124),
(100007,'enUS','\"You look as beautiful as the two moons of Azeroth.\"','\"You look as beautiful as the two moons of Azeroth.\"',26124),
(100008,'enUS','\"I think you\'re cute.\"','\"I think you\'re cute.\"',26124),
(100009,'enUS','\"I\'m hoping for some epic pants drops tonight.\"','\"I\'m hoping for some epic pants drops tonight.\"',26124),
(100010,'enUS','|cFF600000<The story is started, but unfinished.>|r$b$bThe ever-eloquent Lord Gravesbane stepped into the royal chamber. Before him stood the draenei princess, widely-known for her beauty, grace, and biting wit.$b$bHe greeted the bejeweled princess with his most reliable compliment.$b$b|cFF600000<The next line is blank. What might Lord Gravesbane have said?>|r','',26124),
(100011,'enUS','Damn you, outsider! You\'ll never have the secrets of the shal\'dorei herbalists! I\'ll take them to my grave!','',26124),
(100012,'enUS','\"You look as beautiful as the two moons of Azeroth.\"$b$bThe faintest suggestion of a smile appeared on the edge of the blue-skinned monarch\'s mouth. She quickly suppressed it, lest Lord Gravesbane discover her true feelings. She replied quickly:$b$b|cFF600000<The next line is blank. How might the draenei princess have responded?>|r','',26124),
(100013,'enUS','\"I think you\'re cute.\"$b$bThe princess continued watching Lord Gravesbane\'s mouth, as if she expected more compliment to come out. As time wore on, it became clear that his utterance was indeed limited to only four words.$b$bOnce she fully realized it was her turn to speak, she replied...$b$b|cFF600000<How might the draenei princess have responded?>|r','',26124),
(100014,'enUS','\"I am immune to your charms, outsider. Flattery will get you nowhere.\"','\"I am immune to your charms, outsider. Flattery will get you nowhere.\"',26124),
(100015,'enUS','\"That\'s a big sword you have there. Are you sure you know how to wield it?\"','\"That\'s a big sword you have there. Are you sure you know how to wield it?\"',26124),
(100016,'enUS','\"Is that a gnome in your legplates, or is that two gnomes in your legplates?\"','\"Is that a gnome in your legplates, or is that two gnomes in your legplates?\"',26124),
(100017,'enUS','\"Why do I suspect that \'nowhere\' is the name of your majesty\'s private bedchamber?\"','\"Why do I suspect that \'nowhere\' is the name of your majesty\'s private bedchamber?\"',26124),
(100018,'enUS','\"OK, bye.\"','\"OK, bye.\"',26124),
(100019,'enUS','\"Yes, I\'m good at swords. This is a two-handed sword. I bought it at the sword store.\"','\"Yes, I\'m good at swords. This is a two-handed sword. I bought it at the sword store.\"',26124),
(100022,'enUS','You heard Lord Illidan. Let\'s find that keystone.','',26124),
(100023,'enUS','I\'ll cut a hole through the demons and meet you in the volcano.','',26124),
(100024,'enUS','We must eliminate the Legion threat on this ridge so that you can bring the rest of our forces in from the Black Temple.','',26124),
(100025,'enUS','','Do I know you? What are you doing here?',26124),
(100026,'enUS','','I suspected I would find some sort of greenery if I followed Freya\'s trail, but I never expected anything like this!$b$bWhat can I do for you?',26124),
(100027,'enUS','','Did you bring my analysis to Kuhuine? What did she say?',26124),
(100028,'enUS','Kuhuine Tenderstride sent me to collect your felwort analysis.','Kuhuine Tenderstride sent me to collect your felwort analysis.',26124),
(100029,'enUS','','Ah, yes. Here it is. Nasty plant, that.',26124),
(100030,'enUS','Quiet! I\'m listening to the plants.','',26124),
(100031,'enUS','No, I\'m not lost - I\'m simply looking for rare herbs. I... wait, are you $n? The herbalist, $n?','',26124),
(100032,'enUS','You... wouldn\'t happen to know how to get out of this crater, would you?','',26124),
(100033,'enUS','Yes, I am. Kuhuine Tenderstride sent me to collect your felwort analysis.','Yes, I am. Kuhuine Tenderstride sent me to collect your felwort analysis.',26124),
(100034,'enUS','An honor to meet you, $n. Of course, I have your report right here.','',26124),
(100035,'enUS','As a druid, the overgrowth in this area concerns me. As an herbalist, however, I couldn\'t be happier.','',26124),
(100036,'enUS','As a druid, the overgrowth in this area concerns me. As an herbalist, however, I couldn\'t be happier.$b$bHerbalist $n. You are here to collect my report?','',26124),
(100037,'enUS','Give Kuhuine my regards, herbalist.','',26124),
(100038,'enUS','Yes.','Yes.',26124),
(100039,'enUS','Very well, here it is. I apologize for any rips or claw marks on the paper.','',26124),
(100040,'enUS','','No! The ritual is not yet complete!',26124),
(100041,'enUS','','The bindings weaken...',26124),
(100042,'enUS','','It is still forming!',26124),
(100043,'enUS','Can you believe there\'s a dwarf out there taking credit for my work? Have you ever heard of something so disrespectful?','',26124),
(100044,'enUS','I\'ve finished my book, Francis.','I\'ve finished my book, Francis.',26124),
(100045,'enUS','','We need more time!',26124),
(100046,'enUS','','THE TIDES RISE!',26124),
(100047,'enUS','Chuang!','',26124),
(100048,'enUS','A stack of books, ready to be turned into masterpieces of literary art.','',26124),
(100049,'enUS','Finished already? Let\'s see what you have here...','',26124),
(100050,'enUS','Oh my, this is quite possibly...','',26124),
(100051,'enUS','the most amazingly, stupendously...','',26124),
(100052,'enUS','BADLY WRITTEN story I have ever had the displeasure of reading in either of my lives!','',26124),
(100053,'enUS','This really isn\'t that difficult, $n. Just be poetic, use adjectives, as many as your simple mind can come up with.','',26124),
(100054,'enUS','For now, I will impart some of my unpublished works to you. As samples of course, to help you get started.','',26124),
(100055,'enUS','Chuang, are you alright? Speak to me!','',26124),
(100056,'enUS','I\'m ready to begin my lesson, Francis.','I\'m ready to begin my lesson, Francis.',26124),
(100057,'enUS','Follow Francis Serbacon\'s instructions.','',26124),
(100058,'enUS','Any disturbance should catalyze the sequence. Just, uh, give it a poke or something.','',26124),
(100059,'enUS','I will stay in contact with you for as long as I can.','',26124),
(100060,'enUS','Reuse','',26124),
(100061,'enUS','Reuse','',26124),
(100062,'enUS','Be careful, champion. The land of Suramar has been wild for ten thousand years.','',26124),
(100064,'enUS','Oh... my head...','',26124),
(100065,'enUS','<cough> The demons... they cut down the students before my eyes! <wheeze> Heard shouting... from the Cave of the Crane...','',26124),
(100066,'enUS','%s faints and falls onto the ground.','',26124),
(100067,'enUS','I... I don\'t feel so good...','',26124),
(100068,'enUS','The might of the Legion will prevail!','The might of the Legion will prevail!',26124),
(100069,'enUS','You\'ve defiled these lands long enough!','You\'ve defiled these lands long enough!',26124),
(100070,'enUS','Sargeras demands your soul.','Sargeras demands your soul.',26124),
(100071,'enUS','Intruder!','Intruder!',26124),
(100072,'enUS','Now listen, it\'s very simple. When setting your scene try to be descriptive enough so the reader can envision it in their head. And give the characters some action. For example:','',26124),
(100073,'enUS','Today you die, $r!','Today you die, $r!',26124),
(100074,'enUS','\"Yes, my princess, and it\'s led me to countless treasures. In fact, I\'m hoping for some epic pants drops tonight.\"','\"Yes, my princess, and it\'s led me to countless treasures. In fact, I\'m hoping for some epic pants drops tonight.\"',26124),
(100075,'enUS','\"Alas, your majesty, it is but one gnome - although he does know some magic spells...\"','\"Alas, your majesty, it is but one gnome - although he does know some magic spells...\"',26124),
(100076,'enUS','\"Alright, you caught me. I\'ll let them out now.\"','\"Alright, you caught me. I\'ll let them out now.\"',26124),
(100077,'enUS','Next, have the characters engaging one another in an interesting conversation. It doesn\'t need to be so dry as you wrote it. For example:','',26124),
(100078,'enUS','Nalthanis! I\'ve told you before to stop wasting time studying the magic of the primitives down below. I tire of repeating myself!','',26124),
(100079,'enUS','And finally, come to a climax that leaves the readers wanting more. Give them a real page turner! For example:','',26124),
(100080,'enUS','\"I\'ll bet you say that to every princess you meet.\"','\"I\'ll bet you say that to every princess you meet.\"',26124),
(100081,'enUS','No more excuses, Nalthanis! Do as I say or I will find someone else to run this shop! And for the last time, wear that uniform I picked out for you.','',26124),
(100082,'enUS','\"Simply \'cute\'? You\'ll have to do better than that, Lord Gravesbane.\"','\"Simply \'cute\'? You\'ll have to do better than that, Lord Gravesbane.\"',26124),
(100083,'enUS','\"Well, I think you\'re terribly unclever!\"','\"Well, I think you\'re terribly unclever!\"',26124),
(100084,'enUS','\"So... do you come here often? How about this weather?\"','\"So... do you come here often? How about this weather?\"',26124),
(100085,'enUS','\"Who needs cleverness when you look like THIS?\" <flex>','\"Who needs cleverness when you look like THIS?\" <flex>',26124),
(100086,'enUS','But archmage, $n\'s excursions to the surface have already born fruit!','',26124),
(100087,'enUS','\"Darn! I really wanted pants.\"','\"Darn! I really wanted pants.\"',26124),
(100088,'enUS','','Ith\'el kanesh!',26124),
(100089,'enUS','','I am Thalyssra of the shal\'dorei... the Nightborne. First Arcanist in the court of Suramar.',26124),
(100090,'enUS','Your doom has come, mortals!','',26124),
(100091,'enUS','','My people have made a dire pact. One that spells doom for this world.',26124),
(100092,'enUS','But I... As you command, archmage.','',26124),
(100093,'enUS','You can use the books on the table over there to begin writing your story.','',26124),
(100094,'enUS','','Time is short. If you have found this message, you are capable of finding me as well.',26124),
(100095,'enUS','I\'ve got him.','',26124),
(100096,'enUS','','Make haste for Suramar. You may be our last hope.',26124),
(100097,'enUS','','%s winces in pain and holds her side.',26124),
(100098,'enUS','Brace the west door! I don\'t want anymore surprises. Now, let\'s see what\'s going on out there.','',26124),
(100099,'enUS','No... this cannot be!','',26124),
(100100,'enUS','There are too many of them! We have to evacuate!','',26124),
(100101,'enUS','$p, I need you to send any survivors you find back to the temple. Chaung mentioned the Cave of the Crane, so start there. Hurry, we must escape before we are overrun!','',26124),
(100102,'enUS','These beasts do my bidding! You don\'t stand a chance.','',26124),
(100103,'enUS','So powerful!','',26124),
(100104,'enUS','Stay in school!','',26124),
(100105,'enUS','Ha! Try harder!','',26124),
(100106,'enUS','Sic \'em!','',26124),
(100107,'enUS','I\'m unimpressed.','',26124),
(100108,'enUS','Should have brought a beast!','',26124),
(100109,'enUS','No! How could you?','',26124),
(100110,'enUS','Are you using mechanicals?','',26124),
(100111,'enUS','It\'s all part of the plan.','',26124),
(100112,'enUS','Don\'t believe any of those rumors ye\'ve been hearing. I\'m the only author of those novels, not that putrid, undead corpse!','',26124),
(100113,'enUS','I\'ve finished my book, Bill.','I\'ve finished my book, Bill.',26124),
(100114,'enUS','I\'m ready to begin my lesson, Bill.','I\'m ready to begin my lesson, Bill\n.',26124),
(100115,'enUS','Now listen, it\'s very simple. When setting yer scene try to be descriptive enough so the reader can envision it in their head. And give the characters some action, $glad:lass;. For example:','',26124),
(100116,'enUS','Next, have the characters engaging one another in an interesting conversation. It doesn\'t need to be so dry as ye wrote it. For example:','',26124),
(100117,'enUS','And finally, come to a climax that leaves the readers wanting more. Give them a real page turner! For example:','',26124),
(100118,'enUS','Finished already? Let\'s see what ye have here...','',26124),
(100119,'enUS','Well, this is quite possibly...','',26124),
(100120,'enUS','the most amazingly, stupendously...','',26124),
(100121,'enUS','BADLY WRITTEN story I\'ve ever read! I think me goat could write better drivel than this!','',26124),
(100122,'enUS','Listen, it\'s very simple $glad:lass;. Just be poetic with what ye write, try using some adjectives.','',26124),
(100123,'enUS','Talk to me again and I\'ll give ye a few sample scripts to get ye started.','',26124),
(100124,'enUS','Go ahead and use the books on that table behind me to write yer story.','',26124),
(100126,'enUS','Greetings, commander. What can I do for you?','',26124),
(100127,'enUS','You seemed rather harsh with Nalthanis.','You seemed rather harsh with Nalthanis.',26124),
(100128,'enUS','You are vital to our war against the Legion, commander.$b$bI cannot allow my underling to waste your time chasing after rumors of primitive magic.$b$bPlus, he refuses to wear the very smart outfit I picked out for him. That\'s is both bad taste and insubordination!','',26124),
(100129,'enUS','His information seems promising. I believe it is worth pursuing.','His information seems promising. I believe it is worth pursuing.',26124),
(100130,'enUS','Haha! More things to burn!','',26124),
(100131,'enUS','','Begone, foul creature! You will not harm any more of our sacred texts!',26124),
(100132,'enUS','Pursue his leads if you must. An archmage as skilled as myself should be out there on the front lines assisting you, not stuck overseeing an enchanting shop! What a waste of my talents!','',26124),
(100133,'enUS','An interesting idea...','An interesting idea...',26124),
(100134,'enUS','What will the tide wash up next?','',26124),
(100135,'enUS','This is the LIFE! Water fish, land fish, sky fish, and new fish!','',26124),
(100136,'enUS','Now, let\'s see about activating that gateway.','',26124),
(100137,'enUS','<Place 20 piles of starlight rosedust upon the pile.>','<Place 20 vials of starlight rosedust upon the pile.>',26124),
(100138,'enUS','I must speak to Khadgar about taking a more active role in the campaign. Good luck, Commander $n.','',26124),
(100139,'enUS','Ah... a new FOOD!','',26124),
(100140,'enUS','Hold strong! These demons soon will meet their end.','',26124),
(100141,'enUS','Our soil, our water... tainted by your vile actions. We will not stand for this!','',26124),
(100142,'enUS','You scorch our skies, defile our lands, sacrifice innocent wildlife, but the Earth Mother\'s blessing will prevail.','',26124),
(100143,'enUS','Your footsteps corrupt the very earth you walk upon, but today we end this corruption.','',26124),
(100144,'enUS','For the Earth Mother!','',26124),
(100145,'enUS','','If I focus my Chi, I believe I can get us behind their forces. Quickly, $n. Take my hand.',26124),
(100146,'enUS','Sunbreeze screeches at the death of her hatchlings.','',26124),
(100147,'enUS','The Avenger is impressed with your efforts to fight the Burning Legion.','',26124),
(100148,'enUS','You have earned the right to call upon his fury. Go - destroy all that threatens this world!','',26124),
(100149,'enUS','','This is worse then I feared. $n! We must part ways. They need my help here at the temple. Chen\'s class should be just to the north across the bridges.',26124),
(100150,'enUS','I\'m ready, $n. Activate the first essence pool.','',26124),
(100151,'enUS','Praying','Praying',26124),
(100152,'enUS','What are you looking at, $r?','',26124),
(100153,'enUS','I\'m here for you head, Inkrot!','I\'m here for you head, Inkrot!',26124),
(100154,'enUS','So Raethan sent you to do his dirty work for him?','',26124),
(100155,'enUS','Too bad it\'ll be your body he\'ll be scraping off the sewer floor!','',26124),
(100156,'enUS','','It\'s great that a hero like you is helping out us little enchanters! I don\'t mean we\'re little, as in short. Archmage Starsinger is actually quite tall.$b$bI mean... aw, nevermind!',26124),
(100157,'enUS','','Together, we have slain my enemy. I offer you my gratitude, $c.',26124),
(100158,'enUS','','I have tracked my enemy to this place. This beastly orc has wreaked havoc across these lands.$B$BI would ask you not to interfere, but I know your kind. I ask only that you do not get in my way.',26124),
(100159,'enUS','Draw out your enemy, Raven, and let us be done with it!','Draw out your enemy, Raven, and let us be done with it!',26124),
(100160,'enUS','','Bloody Raven! Through mists and over mountains I have tracked you!',26124),
(100161,'enUS','','Your trail of blood and betrayal has lead me to your doorstep!',26124),
(100163,'enUS','I see you are not alone. It matters not. I will cut you down and heave your remains over the cliff!','',26124),
(100164,'enUS','','I grow tired of chasing you! Come to the fire and let us end this!',26124),
(100165,'enUS','','It is done. I take my leave of you now, but I know that we will meet again.',26124),
(100166,'enUS','Curse you... and your black birds...','',26124),
(100167,'enUS','Preparing','Preparing',26124),
(100168,'enUS','$n! Master Jia! Thank de spirits ya be alive! These demons be endless!','',26124),
(100169,'enUS','Pathetic creatures.','',26124),
(100170,'enUS','','To me, hero! Elune protect us!',26124),
(100171,'enUS','Murky is doing exquisitely! He and his followers are working and training quite hard. Once they\'re fully grown, I believe that the Swamprock Tribe will be a successful, budding group of murlocs. Who knows what they\'ll be able to accomplish! I\'m going to stay here to observe. Thank you for all your help, $p.','',26124),
(100172,'enUS','I wonder what treasures will fall from the sky...','',26124),
(100173,'enUS','','Die beast!',26124),
(100174,'enUS','I\'ve got a boot and I know just where to put it!','',26124),
(100175,'enUS','','By Elune\'s grace, is everyone alright?',26124),
(100176,'enUS','I still feel them... so many voices in my mind.','I still feel them... so many voices in my mind.',26124),
(100177,'enUS','I can see nothing but death... how can we possibly win?','I can see nothing but death... how can we possibly win?',26124),
(100178,'enUS','Hold on, old friend.','',26124),
(100179,'enUS','Now is not your time to leave this world.','',26124),
(100180,'enUS','May the Earth Mother watch over you.','',26124),
(100181,'enUS','There\'s no sign of the special wine cask in the vintner\'s room.','',26124),
(100182,'enUS','As you all know, the defeat at the Broken Shore was decisive. The loss of so many valiant heroes was a terrible blow.','',26124),
(100183,'enUS','The Burning Legion is a grave threat. We must find a way to stop their assault before all that we hold dear can be...','',26124),
(100184,'enUS','Murky, we need you to get stronger! The fate of this coast depends on it!','',26124),
(100185,'enUS','','Jade Serpent watch over you, $n.',26124),
(100186,'enUS','Pathetic mortals! The armies of the Legion will crush you!','',26124),
(100187,'enUS','Come, children, we must get to the temple. $n, I\'ll need your help. The complex is crawling with evil!','',26124),
(100188,'enUS','My power is infinite!','',26124),
(100189,'enUS','The Legion shall prevail!','',26124),
(100190,'enUS','The Legion! Quickly, get inside! He\'ll have to blow the house down to get to us!','The Legion! Quickly, get inside! He\'ll have to blow the house down to get to us!',26124),
(100191,'enUS','What do they want with our small Villa?','What do they want with our small Villa?',26124),
(100192,'enUS','The Legion is infinite and all-knowing!','',26124),
(100193,'enUS','Grand Master Hight, it\'s a relief to see you!','',26124),
(100194,'enUS','Chen, I\'m glad to see you and the children are safe!','',26124),
(100195,'enUS','It was all thanks to this hero, who arrived just in time to help us out.','',26124),
(100196,'enUS','Well fought, $n, but we\'re not done yet.','',26124),
(100197,'enUS','Chen, take the cubs as far away from this place as you can. $n, and I will stay and seal the portal. White Tiger walk with you, my friend.','',26124),
(100198,'enUS','Those were my husks, mortal! You will pay for depriving me of my property!','Those were my husks, mortal! You will pay for depriving me of my property!',26124),
(100199,'enUS','We can not allow the Legion to establish a foothold here. We need to close that portal down!','',26124),
(100200,'enUS','The vanquishers have already taken possession of it, Skovald, as was their right. Your protest comes too late.','',26124),
(100202,'enUS','','We should capture and interrogate some of these demons.',26124),
(100203,'enUS','','Where is the keystone, demon?',26124),
(100204,'enUS','','My scythe will compel them.',26124),
(100205,'enUS','','The Scythe of Souls will cut you down!',26124),
(100206,'enUS','','Did we bring enough of us?',26124),
(100207,'enUS','','Lord Illidan chose you to lead. I follow.',26124),
(100208,'enUS','','The fel energy is everywhere. It\'s hard to resist.',26124),
(100209,'enUS','','There are too many of them!',26124),
(100210,'enUS','We should gather intel on their leaders.','',26124),
(100211,'enUS','We must find the Sargerite Keystone.','',26124),
(100212,'enUS','I\'ll scout forward after this and find the keystone.','',26124),
(100213,'enUS','I\'m glad you\'re leading us, $n.','',26124),
(100214,'enUS','The Earth Mother watches over us.','The Earth Mother watches over us.',26124),
(100215,'enUS','These intruders defile our sacred lands, slaughtering the innocent...$B$BWe will not stand for this!','These intruders defile our sacred lands, slaughtering the innocent...$B$BWe will not stand for this!',26124),
(100216,'enUS','Lord Illidan places a lot of faith in you.','',26124),
(100217,'enUS','My gut tells me the keystone is up in that volcano.','',26124),
(100218,'enUS','The skies weep as the lands beneath suffer tremendous loss.','The skies weep as the lands beneath suffer tremendous loss.',26124),
(100219,'enUS','I have some ideas for how to proceed.','',26124),
(100220,'enUS','You know, I should be in command.','',26124),
(100221,'enUS','Be careful, $n. We cannot assure safety to those who wander our lands in these dire times.','Be careful, $n. We cannot assure safety to those who wander our lands in these dire times.',26124),
(100222,'enUS','','Hah! Racking up the kills.',26124),
(100223,'enUS','','Having fun? I am!',26124),
(100224,'enUS','','What\'s next, $n?',26124),
(100225,'enUS','','Just point me in the right direction.',26124),
(100226,'enUS','<The corpse of this unfortunate earthen explorer has been shredded open. His entrails - which look like sand and pebbles - are spilled all over the floor. Traces of fel emanate from the gaping wounds.>','',26124),
(100227,'enUS','','Continue the ritual! I will handle these fools!',26124),
(100228,'enUS','','Can you feel the winds? They come for you...',26124),
(100230,'enUS','','Too much to handle?',26124),
(100231,'enUS','','Pitiful.',26124),
(100234,'enUS','Mrrglrrgl!','',26124),
(100235,'enUS','','Fry, landwalkers!',26124),
(100236,'enUS','','There is no escape!',26124),
(100237,'enUS','','The waters rise...',26124),
(100238,'enUS','','|TInterface\\Icons\\Spell_Frost_SummonWaterElemental:20|t%s begins to cast |cFFFF0000|Hspell:193682|h[Beckon Storm]|h|r!',26124),
(100239,'enUS','','You cannot understand the Sentinel\'s song, $r? Then perhaps you will allow me to speak for him.',26124),
(100240,'enUS','To the victor go the spoils... The Aegis of Aggramar is yours for the taking.','',26124),
(100242,'enUS','Hey, I need to deliver this message fast! If I\'m late Master Jang is going to have me painting the temple again!','',26124),
(100243,'enUS','','|TInterface\\Icons\\Spell_Shaman_StaticShock:20|t%s starts to invoke a |cFFFF0000|Hspell:193597|h[Static Nova]|h|r. Get out of the water!',26124),
(100244,'enUS','','Just you wait...',26124),
(100245,'enUS','','A storm is gathering...',26124),
(100246,'enUS','Hey, $n! Message for you from Grand Master Hight!','',26124),
(100247,'enUS','Where are you going? Hey, got a message for you!','',26124),
(100248,'enUS','Come on! I got to deliver this message!','',26124),
(100249,'enUS','Please, just give me a moment. Master Jang is going to make me paint the whole temple again if I don\'t deliver this!','',26124),
(100250,'enUS','Do you know how big the temple is? It takes weeks to finish! Please, listen to the message!','',26124),
(100251,'enUS','Have a safe journey.','',26124),
(100252,'enUS','','My dear friends... what has become of them? Why does everything feel so... different?',26124),
(100253,'enUS','','The spirits of my dear friends have been entrusted to you. Keep them safe, enchanter.',26124),
(100254,'enUS','','Our finest casks will soon be on their way to Queen Azshara! She will be so pleased!',26124),
(100255,'enUS','','Something seems amiss, but... I cannot place it...',26124),
(100256,'enUS','','Ith\'nala kanesh!',26124),
(100257,'enUS','','Reuse',26124),
(100262,'enUS','','I hope someone out there is listening...',26124),
(100263,'enUS','Fine, be that way. I\'ll follow you around this whole city if I have to!','',26124),
(100264,'enUS','Reuse','',26124),
(100265,'enUS','','Ngh... need to keep moving.',26124),
(100266,'enUS','Reuse','',26124),
(100267,'enUS','Reuse','',26124),
(100268,'enUS','','Withered... I must be getting close.',26124),
(100269,'enUS','','N\'eth narala. REUSE',26124),
(100271,'enUS','Throughout your trials, you have demonstrated strength, skill, and intellect-traits shared by the greatest of our vrykul kings. Now... you will face them in combat. Emerge victorious, and you may yet claim your prize!','',26124),
(100272,'enUS','The pages have been ripped from their binding and scattered across the room. The inn appears as though it was hit by a cyclone.','The pages have been ripped from their binding and scattered across the room. The inn appears as though it was hit by a cyclone...$b$bThere are clear signs that a struggle took place here, but Malfurion is nowhere to be found.',26124),
(100273,'enUS','This appears to be a plume from Malfurion\'s coat.$b$bSearching the area closely, you are able to make out a faint set of footprints heading southwest along the path.$b$bThese footprints differ from the cloven hooves of Satyr...','This appears to be a plume from Malfurion\'s coat.$b$bSearching the area closely, you are able to make out a faint set of footprints heading southwest along the path.$b$bThese footprints differ from the cloven hooves of Satyr...',26124),
(100274,'enUS','<The wounded satyr scowls at you as you approach. He doesn\'t have long to live.>$b$bHave you come to finish what your Archdruid started, $r? You mortals think you\'ve won... but Malfurion is in the Master\'s hands now.$b$bThat fool fell right into our trap... haha-HAHA...','',26124),
(100276,'enUS','','Narala ith\'el! <cough>  REUSE',26124),
(100277,'enUS','REUSE','',26124),
(100278,'enUS','REUSE','',26124),
(100279,'enUS','','Stand down, Erasmus! Can you not see that Elisande has forsaken us?!',26124),
(100280,'enUS','','Rath-anu\'tanos!',26124),
(100281,'enUS','REUSE','',26124),
(100282,'enUS','','That will buy me some time...',26124),
(100283,'enUS','','REUSE',26124),
(100284,'enUS','','In-leva dathos. REUSE',26124),
(100294,'enUS','Just remember, you\'re the \"smart\" part, so you gotta point this thing at the demons!','Just remember, you\'re the \"smart\" part, so you gotta point this thing at the demons!',26124),
(100295,'enUS','Hit your target fast. This thing is packed and will blow when it runs out of fuel!','Hit your target fast. This thing is packed and will blow when it runs out of fuel!',26124),
(100296,'enUS','I may be dead, but my pets are still kicking!','',26124),
(100297,'enUS','Only one of us is coming out of this alive...  Wait...','',26124),
(100298,'enUS','I will take you to Helheim myself, \"hero\" of Azeroth!','',26124),
(100299,'enUS','Wanderer! Have you come to save your soul?\n\nIt will soon be upon us! The second coming! Deathwing is returning, and Azeroth will be destroyed! We must be prepared for the ocean to swallow the world!','',26124),
(100300,'enUS','What doesn\'t kill you makes you stronger!','',26124),
(100301,'enUS','...Deathwing? You mean the Burning Legion?','...Deathwing? You mean the Burning Legion?',26124),
(100302,'enUS','Try again, if you dare!','',26124),
(100303,'enUS','My guide didn\'t say anything about this!','',26124),
(100304,'enUS','How? My plan was foolproof!','',26124),
(100305,'enUS','Grrrrr....','',26124),
(100306,'enUS','The Burning Legion? Hah! They are naught but a sign. Listen to my sermon.','',26124),
(100307,'enUS','...Okay?','...Okay?',26124),
(100308,'enUS','You just aren\'t very good.','',26124),
(100309,'enUS','My strategy is flawless!','',26124),
(100310,'enUS','You\'re no match for my pets!','',26124),
(100311,'enUS','And so I declare, Deathwing has not been defeated. He lays in wait for Azeroth\'s distraction. Soon he will return, flying over the world and spreading his destruction.','',26124),
(100312,'enUS','Surely, you may think, the Alliance and Horde will take him down with their great airships. But his body will cause the earth to shake, and the oceans will rise up to swallow us all.','',26124),
(100313,'enUS','But the Prepfoot... we know! We have seen the future and will prepare until the time comes. We shall survive... nay, thrive!','',26124),
(100314,'enUS','','Demons! In the mine! Look, I know we Venture Company haven\'t been easy competitors, but just this once, you gotta help us!',26124),
(100315,'enUS','This prey has quite a bite! Follow... if you dare!','',26124),
(100316,'enUS','A little farther before we fight, hero! I have a surprise for you...','',26124),
(100317,'enUS','Huln was the strongest of champions and first of our tribe.','',26124),
(100318,'enUS','At the call of Krasus, he defied the Legion and defeated many demons with the Eagle Spear.','',26124),
(100319,'enUS','Huln\'s prowess in combat was unmatched.','',26124),
(100320,'enUS','This smoldering corpse is clutching a totem still wreathed with wind spirits.','',26124),
(100321,'enUS','I don\'t remember him killing THAT many demons. You\'re exaggerating, Spiritwalker.','',26124),
(100322,'enUS','Alright Murky! Time for you to get big and strong!','',26124),
(100323,'enUS','Skyhorn! Take to the air and show these harpies and their rocs the meaning of battle!','',26124),
(100324,'enUS','Can you help me find my way?','Can you help me find my way?',26124),
(100325,'enUS','I hear you have some useful goods.','I hear you have some useful goods.',26124),
(100326,'enUS','Perhaps they were correct in their belief that Huln\'s love of fighting was too strong.','',26124),
(100327,'enUS','Some believe Huln\'s bloodlust was too strong.','',26124),
(100328,'enUS','They sing of Huln\'s thirst to spill demonic blood.','',26124),
(100329,'enUS','','We were sent out here to keep an eye on the murlocs. They told us that they\'d send relief after a week... we\'ve been here for a month and seen no other tauren. I\'m getting sick of these two. They can\'t be near each other or they\'ll start bickering like an old married couple.',26124),
(100330,'enUS','I\'m so sick of Scout Proudhill. All I want to do is go remind Thunder Totem that we\'re still out here! He refuses to let a single one of us leave our post. What could possibly be happening back home that\'s so important that they forgot about us?!','',26124),
(100331,'enUS','We cannot leave our post. If we look away for even a second, that weird guy in the murloc suit might do something insane. Thunder Totem will send relief when it is necessary. They haven\'t forgotten about us.','',26124),
(100333,'enUS','Archimonde the Defiler spent an eternity exposing the darkest tendrils of the arcane arts. Thousands of years, countless worlds\' knowledge and history are locked away within this tome\'s pages.$B$BNow we will tell your tale, $g milord:milady;.','',26124),
(100335,'enUS','','I\'m sure an enchanter like you will make good use of the Sentinel\'s essence.',26124),
(100337,'enUS','','In-leva dathos. REUSE',26124),
(100338,'enUS','','Such is the fate of nightborne who cannot drink of the Nightwell.',26124),
(100339,'enUS','','My strength is fading... we must find shelter...',26124),
(100340,'enUS','','E\'rath omnas!',26124),
(100341,'enUS','Cyana, Jace, Allari... find the keystone.','',26124),
(100342,'enUS','','I am using the Scythe of Souls to interrogate these demons, but they do not know anything about the location of the Sargerite Keystone.\n\nThey just keep repeating their loyalty to some queen.\n\nCyana and Jace have moved ahead. Unfortunately, I think Cyana got herself captured trying to help some of our other demon hunters.\n\nThere is something not quite right with her...',26124),
(100343,'enUS','This is a job for Murky in order to prove himself. Use his egg to mindmeld with Murky.','',26124),
(100344,'enUS','Mrrglrrgl?','',26124),
(100345,'enUS','Mrlrlrlrlrgl! Grglrgl!','',26124),
(100346,'enUS','Mrr mrrgl? Mrglglgl.','',26124),
(100347,'enUS','Mrrrglrglrglrgl!','',26124),
(100348,'enUS','Mrrgl? Mrglglglrglrgl! Mrgl!','',26124),
(100349,'enUS','Mrglrglrglglgl. Mrglgl? Mrrgl!','',26124),
(100350,'enUS','- CLIENT SIDE SCENE - Malfurion has been captured by Xavius. Ysera is destroying the Temple of Elune.','',26124),
(100351,'enUS','I will be rewarded greatly for your soul!','',26124),
(100352,'enUS','Infernal incoming! Watch your head!','',26124),
(100353,'enUS','Another would be champion... pathetic.','',26124),
(100354,'enUS','An eternity of pain awaits you in Helheim!','',26124),
(100355,'enUS','I see only torment...','',26124),
(100356,'enUS','You have doomed me...','',26124),
(100357,'enUS','The battlefield of dishonor lies ahead...','',26124),
(100358,'enUS','You\'ve come to the wrong place, hero.','',26124),
(100359,'enUS','They will make me helarjar for this!','',26124),
(100360,'enUS','Join the other souls in Helheim, fool!','',26124),
(100361,'enUS','You won\'t make it out of here alive!','',26124),
(100362,'enUS','No, the torment...','',26124),
(100363,'enUS','I\'ll see you in... Helheim.','',26124),
(100364,'enUS','Then come meet death, hero!','',26124),
(100365,'enUS','Helya\'s gifts have made me strong! In my hands, these blades have slain thousands!','',26124),
(100366,'enUS','I am the champion of the helarjar! Die and accept your fate!','',26124),
(100367,'enUS','What are you idiots doing? Well now... what is this I sense? A soul that radiates great power!','',26124),
(100368,'enUS','The Aegis of Aggramar overloads!','The Aegis of Aggramar overloads!',26124),
(100369,'enUS','... yes, and our forces -','',26124),
(100370,'enUS','WHAT? You DARE disturb ME? Insolent... You will regret your decision.','',26124),
(100371,'enUS','The priestess\'s room is long abandoned. A worn journal lies on the floor.','',26124),
(100372,'enUS','The demons fancy themselves the masters of this universe, yet we bind stronger ones yet to our will with each passing day and take their knowledge for our own.$B$BI will not rest until every ounce of knowledge of the Scepter of Sargeras is within our grasp. You have my word.','',26124),
(100373,'enUS','Helya! Aid your champion! I will claim this prize in your name!','',26124),
(100374,'enUS','No! I\'ll not fall to Odyn\'s lapdog! I will destroy you!','',26124),
(100375,'enUS','I see only darkness. Helya... no! NO!','',26124),
(100376,'enUS','I sense an intruder who has come in search of plunder. You underestimate the dangers of Icecrown, foolish mage!','',26124),
(100377,'enUS','Your thoughts are transparent, $n. I sense you have come seeking Felo\'melorn. You hope to use it against the Legion. Interesting. I wonder...','',26124),
(100378,'enUS','Our prey is on the retreat! Time for us to push our advantage.','',26124),
(100383,'enUS','These halls are home to much of the world\'s knowledge of the arcane arts... but not all of it.$B$BWe must find out more about Aluneth so that we may increase its power. I believe it is truly our only hope of driving the Legion back.','',26124),
(100384,'enUS','','Here! That demon must\'ve crawled this way. There\'s fel blood splattered on the stones.',26124),
(100385,'enUS','','Stormbeak, stay here and guard the entrance.',26124),
(100386,'enUS','','Don\'t you give me any beak. Stay!',26124),
(100387,'enUS','','Imps! Geth\'xun must be summoning these little buggers.',26124),
(100388,'enUS','','Geth\'xun must be summoning these little buggers to corrupt the Realm of Earth.',26124),
(100389,'enUS','','Watch yourself! More imps!',26124),
(100390,'enUS','','Thrall, that demon is still alive down here.',26124),
(100391,'enUS','Yeah I stayed back while Nesingwary moved on. Why don\'t you go check on that murloc guy?','',26124),
(100392,'enUS','That crazy guy... calls himself Mrgl-Mrgl. Says he was a king in Northrend. I don\'t believe him for a second.','',26124),
(100393,'enUS','He keeps talking to his baby murloc. Calls him Murky.','',26124),
(100394,'enUS','','Watch it! That thing\'s corrupted by the fel. Kill it!',26124),
(100395,'enUS','','We\'ve got to hurry. Keep going!',26124),
(100396,'enUS','','Look! There he is.',26124),
(100397,'enUS','','Shaman, we can\'t let that weapon fall to the wrong hands. I\'ll distract him. You grab the Doomhammer. No time to argue! Go!',26124),
(100398,'enUS','','\'Ey! You there! Me bird craps scarier demons than you!',26124),
(100399,'enUS','','Oh, aye, COME GET SOME!',26124),
(100400,'enUS','','You got it! OOF!',26124),
(100401,'enUS','','...I think I\'m done, shaman... It\'s the end of the tunnel for me...',26124),
(100402,'enUS','','Thank ye...',26124),
(100403,'enUS','','Come, let\'s go. With heroes like you, we just might have a prayer of saving this world. To the Maelstrom!',26124),
(100404,'enUS','Bah, what is this sorcery?','',26124),
(100405,'enUS','This hammer... I must claim it for my masters...','',26124),
(100406,'enUS','<Geth\'xun roars.>','',26124),
(100407,'enUS','Pathetic puny shaman! That hammer did little to help its last master.','',26124),
(100408,'enUS','I WILL present that weapon to my masters as a trophy... Along with YOUR HEAD!','',26124),
(100409,'enUS','I will bring down this whole cavern!','',26124),
(100410,'enUS','I will corrupt your sorry world from within.','',26124),
(100411,'enUS','The power of the Legion is unmatched!','',26124),
(100412,'enUS','Kneel! Kneel and I may yet show mercy!','',26124),
(100413,'enUS','You are witnessing the end of your world, shaman.','',26124),
(100414,'enUS','...There are others... we are... legion...','',26124),
(100415,'enUS','','Those things... complete disregard for life!',26124),
(100416,'enUS','','There, there. You\'re on the mend already.',26124),
(100417,'enUS','','You\'re lucky you\'ve got such a thick hide, old friend.',26124),
(100418,'enUS','','I\'ll secure the exit portal back to the Black Temple once the others fly up here.',26124),
(100419,'enUS','','I just needed a moment to reflect upon the choices I made. Now I am ready.',26124),
(100420,'enUS','It\'s time to begin.','It\'s time to begin.',26124),
(100421,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-KERISTRASZA.BLP:50:80|t$b[Korialstrasz] You honored your promise to come, Highmountain. Do not fear my fire; it is demons who need fear my flames and your Eagle Spear.','',26124),
(100422,'enUS','','Elune, grant me the blessing of your purity one last time.',26124),
(100423,'enUS','%s squawks in protest.','',26124),
(100424,'enUS','','It worked! Praise the goddess!',26124),
(100425,'enUS','Huln Highmountain... Eche\'ro follows you? That is no ordinary beast; it is one of Malorne\'s chosen. Truly, you are blessed.','',26124),
(100426,'enUS','Receive my blessing, Huln Highmountain. Your people shall forever have my favor.','',26124),
(100427,'enUS','Even the Lord of the Forest, Cenarius, recognized Huln\'s greatness. He bestowed him with a blessing that we carry with us to this day: the Horns of Eche\'ro.','',26124),
(100428,'enUS','I found Priestess Driana. She is safe, and wishes to speak to you.','I found Priestess Driana. She is safe, and wishes to speak to you.',26124),
(100429,'enUS','I have had the pleasure of watching you grow from a young $r into the finest hunter in all of Azeroth.$B$BYour tales must be written so that all may know of your deeds and the history of your great weapon.','',26124),
(100430,'enUS','','I have returned, my love. I am home at last.',26124),
(100431,'enUS','','My dear Driana... is it really you? Things here are so... strange... Almost like a dream.',26124),
(100432,'enUS','','I know. But there is nothing to fear. We are together again.',26124),
(100433,'enUS','','I\'m so glad! Later on can we take a walk by the wellspring? It always brings me comfort.',26124),
(100434,'enUS','','I can\'t tell you how wonderful that sounds. But for now, I must go and... rest. We will be together again soon.',26124),
(100435,'enUS','','Driana? DRIANA? Where have you...',26124),
(100436,'enUS','','Though my spirit fades, the part of me that remembers the satyr\'s trickery will serve you well. Thank you again, $n.',26124),
(100437,'enUS','These brave adventurers advance through the fields beneath our bluffs!','',26124),
(100439,'enUS','Bless you, $c! I owe you my life and a good meal. We better get out of here before their leader comes, or we\'ll end up like--','',26124),
(100440,'enUS','NOOOO! SAVE YOURSELF!','',26124),
(100441,'enUS','We hold strong against the Legion at our position. Nothing gets through!','',26124),
(100442,'enUS','Huln! It is good to see you on this field of battle. You look... taller?','',26124),
(100443,'enUS','This demon will fall to the Eagle Spear, Shadowsong. Play with your imps while I do the real work. Next one is on you.','',26124),
(100445,'enUS','','Wait, what was I... Oh yes, the casks for Queen Azshara. I must be about my work.',26124),
(100447,'enUS','I am by your side, $n.','',26124),
(100448,'enUS','To battle!','',26124),
(100449,'enUS','Well done, $n! That Fel Stone must be powering the portal. Destroy it!','',26124),
(100450,'enUS','They\'re coming through!','',26124),
(100451,'enUS','<Cinematic showing Gul\'dan and the Nightborne joining forces.>','<Cinematic showing Gul\'dan and the Nightborne joining forces.>',26124),
(100452,'enUS','Stand your ground, warbraves!','',26124),
(100453,'enUS','The Legion is upon us! To arms! Dalaran is our best, last hope to save our world.','',26124),
(100454,'enUS','What are you doing out of your cage, $c?','',26124),
(100455,'enUS','','We\'ll cover more ground if we spread out. I\'ll go to the Commerce Exchange and rally the merchants!',26124),
(100456,'enUS','','Merchants, artisans, we\'ll need your help in defending the city!',26124),
(100457,'enUS','','Arm yourselves with whatever you can find! The Legion are already in the skies!',26124),
(100458,'enUS','','You are too late! The Wrath of Azshara has arrived!',26124),
(100459,'enUS','','Bar that door! We can\'t have a demon just popping up at you now, can we?',26124),
(100460,'enUS','','Keep your guard up, and call for help if you\'re overwhelmed!',26124),
(100461,'enUS','','Adventurers, take what you need from the Exchange to aid in defense. We\'ll can\'t hold anything back!',26124),
(100462,'enUS','Unworthy of my time.','',26124),
(100463,'enUS','','The Hatecoil prove superior!',26124),
(100465,'enUS','Bah. My people did not make this goblin trash. We only strapped it to that wyrm\'s hide. No weapon of mortal make can penetrate these metal plates.','',26124),
(100466,'enUS','Go hunt somewhere else!','Go hunt somewhere else!',26124),
(100467,'enUS','Then we must find weapons not made by mortals. Igrul, is there any tool or trinket that Deathwing kept from your people? Something he would not trust you to touch?','',26124),
(100468,'enUS','Hmm. I may know of something...','',26124),
(100469,'enUS','Get out of the way! You\'re blocking my shot.','Get out of the way! You\'re blocking my shot.',26124),
(100472,'enUS','Enough trifling with fodder! I will harvest your soul myself!','',26124),
(100473,'enUS','Now in my town!','Now in my town!',26124),
(100474,'enUS','You\'re gonna regret this!','You\'re gonna regret this!',26124),
(100475,'enUS','Here we go again!','Here we go again!',26124),
(100476,'enUS','Not this time!','Not this time!',26124),
(100477,'enUS','','THIS WORLD WILL DROWN...',26124),
(100478,'enUS','Sick \'em, boys!','',26124),
(100479,'enUS','... and a twist to the - OUCH! Hmph. How will we ever get reinforcements here in time if I can\'t get this thing working again?','',26124),
(100480,'enUS','If I could just get this working, we could call in more backup!','',26124),
(100481,'enUS','Pretty soon she\'ll be up and runnin\'! Then we call in the cavalry!','',26124),
(100482,'enUS','','Bandages! I need more bandages, Angelique!',26124),
(100483,'enUS','','I can\'t keep them all stable... Keep the supplies coming, I won\'t give up!',26124),
(100484,'enUS','Just remember what kinda protection I\'m payin\' ya for. Priorities! Us, the money, then everythin\' else... if there\'s time.','',26124),
(100485,'enUS','','Here\'s another one! Catch!',26124),
(100486,'enUS','Tell me more of Huln Highmountain. [Enter Flashback]','Tell me more of Huln Highmountain. [Enter Flashback]',26124),
(100487,'enUS','','Oh, when did you get here, $c?',26124),
(100488,'enUS','Best be prepared lads an\' lasses! Come an\' get yer weapons sharpened free of charge!','',26124),
(100489,'enUS','','You\'re not Belamy! But I suppose we can\'t leave any loose ends...',26124),
(100490,'enUS','Hang in there, buddy! We\'re gonna make it through this.','',26124),
(100491,'enUS','Damn demons! Somebody\'s gotta put an end to \'em!','',26124),
(100492,'enUS','It doesn\'t look so bad. You\'ll be okay. I promise.','',26124),
(100493,'enUS','','You may take my soul, cursed, but you will never take my will.',26124),
(100494,'enUS','Silence. Your soul belongs to Helya.','',26124),
(100495,'enUS','Even now the Burning Legion marches unchecked on the Broken Shore. We need your aid.','',26124),
(100496,'enUS','$n, we meet in dangerous territory. Thank you once again for your help at Riverbend. Be on your guard here among the Bloodtotem; they are not often kind to outsiders.','',26124),
(100497,'enUS','dnt','',26124),
(100498,'enUS','dnt','',26124),
(100499,'enUS','%s coughs a little, wheezing as he forms his words.','',26124),
(100504,'enUS','Alright already! I ain\'t stickin\' around, but you look like you could use a little help. Follow me.','',26124),
(100505,'enUS','You\'ll not get below! The very dead will rise to stop you!','',26124),
(100506,'enUS','Try and bring \'em back in one piece.','',26124),
(100507,'enUS','We have to come to terms with it: Riverbend is destroyed. One day, we will rebuild our home. But for now we must wait and help Thunder Totem however we can, just as they help us.','',26124),
(100508,'enUS','','You\'re doing great, Olisarra!',26124),
(100509,'enUS','','The sprites of the Lunawing Shallows were a thorn in my side, but these murlocs are absolutely the most ill-mannered creatures that I have ever had the displeasure of meeting.',26124),
(100510,'enUS','Boy is my head throbbing! Thanks, $n! Be careful out here.','Boy is my head throbbing! Thanks, $n! Be careful out here.',26124),
(100511,'enUS','Today just isn\'t my day. I should get going before I\'m put out for good!','Today just isn\'t my day. I should get going before I\'m put out for good!',26124),
(100512,'enUS','Yikes! What a mess! Gotta run to warn the others!','Yikes! What a mess! Gotta run to warn the others!',26124),
(100513,'enUS','Runes curse you. I will send you to the bottom of the sea where you belong!','',26124),
(100514,'enUS','The cases are secure! Can\'t we evacuate, Tiffany?','',26124),
(100515,'enUS','Fool. Our curse will be your undoing...','',26124),
(100516,'enUS','','We\'re not leaving! This is my family\'s shop, and we\'ll defend it to the last!',26124),
(100517,'enUS','What brings you to the Murloc Shoals?','What brings you to the Murloc Shoals?',26124),
(100518,'enUS','','After dealing with those troublesome Thistleleaf, I decided to venture into the ancient lands of Suramar.$B$BUnfortunately I came across these murlocs on my journey. I could not allow them to run about unchecked.',26124),
(100519,'enUS','You have the patience of an ancients.','You have the patience of an ancients.',26124),
(100520,'enUS','AHHHHHH!','',26124),
(100521,'enUS','SMASH CHEST! BASH CHEST!','',26124),
(100522,'enUS','Stupid box! Gimme dem shinies!','',26124),
(100523,'enUS','HEY! Hey! You find somethin\' good yet?!','',26124),
(100524,'enUS','Ooh! Pretty! You give?!','',26124),
(100525,'enUS','What that? It magic? Is it? Is it? Is it? Is it?','',26124),
(100526,'enUS','The intense magical currents here interfere with the mirror.','The intense magical currents here interfere with the mirror.',26124),
(100527,'enUS','You have my healing, Archmage!','',26124),
(100528,'enUS','We\'re all gonna die!','',26124),
(100529,'enUS','','Hide up here, Charles. We\'ll stop the demons!',26124),
(100530,'enUS','','Welcome to Legendary Leathers. How may I help you?',26124),
(100531,'enUS','Don\'t ye dare say I look like me brother. I\'m clearly taller!','',26124),
(100532,'enUS','Get away from that, outsider!','',26124),
(100533,'enUS','','Caria left me for dead... the fool!',26124),
(100534,'enUS','Open the gates, Lord Saurfang. I have brought guests for the Warchief.','',26124),
(100535,'enUS','I don\'t like the looks of them, mage. They smell of demon filth.','',26124),
(100536,'enUS','I\'ll be damned if any demon is ruinin\' my city. To arms, lads!','',26124),
(100537,'enUS','','Yes, stranger? Can I help you?',26124),
(100538,'enUS','$n! It\'s good to see you again! Is there anything I can do for you?','',26124),
(100539,'enUS','I\'m the headbutt champ! You think a squishy thing like you can take me on? Hah! You make Jag laugh!','',26124),
(100540,'enUS','','This wouldn\'t have happened if your backside weren\'t so...<ahem>... GENEROUS.',26124),
(100541,'enUS','','$p, is that you? Finally some good news!',26124),
(100542,'enUS','Bring it on!','Bring it on!',26124),
(100543,'enUS','','The barrier is being drained!',26124),
(100544,'enUS','','Get them off the barrier!',26124),
(100545,'enUS','','Ever since my husband came back we\'ve really been able to expand the place.$B$BWe\'ve even put in a brewery up top staffed by some of those nice monks from the temple!',26124),
(100546,'enUS','Hello there! We have some of the finest food you\'ll find anywhere.$b$bWe\'ve also a brand new brewery on the top floor. Try some of our new creations!','',26124),
(100547,'enUS','Hey! Hi. Hi. Hello. Hey. Hi. HI!','',26124),
(100548,'enUS','You don\'t have to ask me twice.','You don\'t have to ask me twice.',26124),
(100549,'enUS','Have you been waiting long, $r?','',26124),
(100551,'enUS','','My wounds are severe. I fear you must push ahead alone.',26124),
(100552,'enUS','','I will join you as soon as I am able.',26124),
(100553,'enUS','','Varedis has shown me the true path. The Legion can make us strong once more!',26124),
(100554,'enUS','','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-ASIRA DAWNSLAYER.blp:50:80|t$b[Kor\'vas Bloodthorn] Doomguard incoming from above!',26124),
(100555,'enUS','','Yes... I can feel your will weakening.',26124),
(100556,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] Illidari, form up. Caria will not escape our wrath so easily.','',26124),
(100557,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] $p, we advance on your mark.','',26124),
(100558,'enUS','','Hello and welcome to the Laughing Crane!',26124),
(100559,'enUS','You\'ll regret telling me to leave!','You\'ll regret telling me to leave!',26124),
(100560,'enUS','Hey, me, listen up. I\'ve got a warning for you! Us! I\'m in danger. I mean, we\'re in danger. I mean... I\'ve been in danger, and you\'re going to be in danger. Darn time travel...','Hey, me, listen up. I\'ve got a warning for you! Us! I\'m in danger. I mean, we\'re in danger. I mean... I\'ve been in danger, and you\'re going to be in danger. Darn time travel...',26124),
(100561,'enUS','Hey there, $n. No warnings this time. Just sayin\' hey.','Hey there, $n. No warnings this time. Just sayin\' hey.',26124),
(100562,'enUS','$n, why haven\'t you enchanted that item yet? We aren\'t going to replace it for a while, believe me.','$n, why haven\'t you enchanted that item yet? We aren\'t going to replace it for a while, believe me.',26124),
(100563,'enUS','I think you\'re the one that should be leaving!','I think you\'re the one that should be leaving!',26124),
(100564,'enUS','No one tells me what to do!','No one tells me what to do!',26124),
(100565,'enUS','I\'ll hunt where I want, and you won\'t stop me!','I\'ll hunt where I want, and you won\'t stop me!',26124),
(100566,'enUS','I was just about to leave, anyway.','I was just about to leave, anyway.',26124),
(100567,'enUS','You can have this spot. I\'ll find a better one.','You can have this spot. I\'ll find a better one.',26124),
(100568,'enUS','Wow, $n, that transmogrification really is truly amazing! That is so amazingly amazing, I think I\'d like to use it.','Wow, $n, that transmogrification really is truly amazing! That is so amazingly amazing, I think I\'d like to use it.',26124),
(100569,'enUS','Every time you spend money repairing our gear, you\'re making it that much more difficult for me to buy Unclaimed Black Market Containers. Stay safe!','Every time you spend money repairing our gear, you\'re making it that much more difficult for us to buy Unclaimed Black Market Containers. Stay safe!',26124),
(100570,'enUS','See you later, $n! Remember, I used to be you. I still am, but I used to be, too.','See you later, $n! Remember, I used to be you. I still am, but I used to be, too.',26124),
(100571,'enUS','It is also your only way back. Find it and return to the Black Temple.','',26124),
(100572,'enUS','Next time we\'re in Alterac Valley, whatever you do: DON\'T. CLICK. THE PORTAL.','Next time we\'re in Alterac Valley, whatever you do: DON\'T. CLICK. THE PORTAL.',26124),
(100573,'enUS','I have to go, but it\'s vital that you remember to-','I have to go, but it\'s vital that you remember to-',26124),
(100574,'enUS','','Thanks, $n. I\'ll be back when this whole thing blows over.',26124),
(100575,'enUS','','Thanks for the help. I\'m gonna lie down. Not feelin\' so hot.',26124),
(100576,'enUS','Good to see you, $n! Say, do you think bronze dragons get any free time? Get it? Free time? They can time travel! Tough crowd.','Good to see you, $n! Say, do you think bronze dragons get any free time? Get it? Free time? They can time travel! Tough crowd.',26124),
(100577,'enUS','So long, $n! I hope I get back to the right timeline. Chromie explains how it works, but we\'ll get confused.','So long, $n! I hope I get back to the right timeline. Chromie explains how it works, but we\'ll get confused.',26124),
(100578,'enUS','Hey $n! Uh oh... is this the time we go to an inn, and you want help cheating at Hearthstone? Shame on us!','Hey $n! Uh oh... is this the time we go to an inn, and you want help cheating at Hearthstone? Shame on us!',26124),
(100579,'enUS','OooOOOooo! I\'m the Ghost of Winter Veil Future! If you play nice, play fair, we\'ll buy ourselves new armor to wear! Don\'t frown, don\'t fret; if we don\'t want armor, we can have a battle pet!','OooOOOooo! I\'m the Ghost of Winter Veil Future! If you play nice, play fair, we\'ll buy ourselves new armor to wear! Don\'t frown, don\'t fret; if we don\'t want armor, we can have a battle pet!',26124),
(100580,'enUS','Take me to southern camp!','Take me to southern camp!',26124),
(100581,'enUS','Goodbye $n! If you fly your mount fast enough, you can come visit me next time. You\'ll need to attach a Fel Lightning (Unstable X-treme) Capacitor to it. Has that been invented yet?','Goodbye $n! If you fly your mount fast enough, you can come visit me next time. You\'ll need to attach a Fel Lightning (Unstable X-treme) Capacitor to it. Has that been invented yet?',26124),
(100582,'enUS','Bye, $n. A parting thought: Do bronze dragons buy into timeshares? Scheduling vacations must be a nightmare.','Bye, $n. A parting thought: Do bronze dragons buy into timeshares? Scheduling vacations must be a nightmare.',26124),
(100584,'enUS','How\'s it going, $n? You don\'t have to answer that, I already know. Knew. I think you will have known how it was going. We think. You\'ve thought? Tenses are confusing.','How\'s it going, $n? You don\'t have to answer that, I already know. Knew. I think you will have known how it was going. We think. You\'ve thought? Tenses are confusing.',26124),
(100586,'enUS','Take me to the bluffs!','Take me to the bluffs!',26124),
(100587,'enUS','$n cackles maniacally as they prepare to implode!','',26124),
(100588,'enUS','','<cough> I... need a moment...',26124),
(100589,'enUS','','There are so many...',26124),
(100590,'enUS','','Strange. Why do they not follow?',26124),
(100591,'enUS','','<cough> I need to rest...',26124),
(100592,'enUS','I wonder what this pool will reveal about you, Drelanim.','',26124),
(100593,'enUS','Crimes? Our crime was to sacrifice everything to save this world.','',26124),
(100594,'enUS','We fought for Illidan, you imprisoned the world\'s villains here for all eternity. And then you imprisoned us.','',26124),
(100595,'enUS','','We protect life, often at great risk.  Too often at great cost.',26124),
(100596,'enUS','You dare speak of sacrifice to me?','',26124),
(100597,'enUS','','I told you to stop asking! Wait. Do you hear that?',26124),
(100598,'enUS','','The spirits are whispering, if you stop chattering long enough to listen. Yes... yes, we are here!',26124),
(100599,'enUS','','Yes, my son. In the embrace of the high mountain before us, we shall make our home. Run and fetch the elders.',26124),
(100600,'enUS','','Then we can eat.',26124),
(100601,'enUS','Mother, are we there yet?','',26124),
(100602,'enUS','I don\'t hear anything. Except the rumble of my hungry belly!','',26124),
(100603,'enUS','\"Here\" here? You mean we finally found our new home?','',26124),
(100604,'enUS','Then can we eat?','',26124),
(100605,'enUS','','The Bloodtotem will never fight beside fishers and rock climbers!',26124),
(100606,'enUS','','Have a care, bird tender!',26124),
(100607,'enUS','','Never!',26124),
(100608,'enUS','','We will bathe the mountain in fel blood!',26124),
(100609,'enUS','Huln is right. We must unite against the Legion. It is the only way.','',26124),
(100610,'enUS','Enough! Will you doom our people for the sake of your pride? The Legion will leave nothing behind but the silent bones of our elders... our children.','',26124),
(100611,'enUS','Then let us stand as one. For Highmountain.','',26124),
(100612,'enUS','Together.','',26124),
(100613,'enUS','','My little Henle is out on her first trial to become a shaman... I am just so worried about her! Ferra, how did you handle yourself when Turn was doing his trials?',26124),
(100614,'enUS','The Skyhorn will not stand with these savages! They are as wretched as the demons!','',26124),
(100615,'enUS','That must not come to pass.','',26124),
(100616,'enUS','Together!','',26124),
(100617,'enUS','I don\'t trust them, Borra. They\'re little more than beasts!','',26124),
(100618,'enUS','That\'s not what I... Listen, they\'re dangerous. Servants of corruption!','',26124),
(100619,'enUS','Well, I\'m not letting my guard down. The drogbar are only good for--','',26124),
(100620,'enUS','Their crystals here have proven useful, I suppose.','',26124),
(100621,'enUS','I still don\'t trust them... but I like their stones. I mean crystals!','',26124),
(100622,'enUS','','Don\'t work yourself up too much, Gala. Henle, like Turn, is a talented young tauren. She has earned her right to trial, and I know she will succeed.',26124),
(100623,'enUS','','We can learn much from the spirits of beasts, Fasho.',26124),
(100624,'enUS','','That was the past. We must build a new future.',26124),
(100625,'enUS','','Quiet! One approaches.',26124),
(100626,'enUS','','Indeed we did.',26124),
(100627,'enUS','','Then let us strike a bargain here at the trading totem. Our skins for your stones. Deal?',26124),
(100628,'enUS','','At least that\'s a place to start.',26124),
(100629,'enUS','Ronir bring more skins?','',26124),
(100630,'enUS','Me have stones. Good stones! Much magic!','',26124),
(100631,'enUS','Deal!','',26124),
(100632,'enUS','These are not my pets! These are my friends! However, they are eager to beat you.','',26124),
(100633,'enUS','Well done. You must have a strong connection with your companions.','',26124),
(100634,'enUS','If we must...','',26124),
(100635,'enUS','When you stop calling them pets and begin calling them friends, then can you defeat me.','',26124),
(100636,'enUS','I take no joy in this.','',26124),
(100637,'enUS','You should take better care of your friends.','',26124),
(100638,'enUS','Your bond is not yet strong enough.','',26124),
(100639,'enUS','Are you okay little guy?','',26124),
(100640,'enUS','So, the new blood awakens. You were spared the brunt of the pit lord\'s assault. A pity the rest of us... weren\'t so lucky...','',26124),
(100641,'enUS','We would seem to be Jagganoth\'s prisoners on some forsaken Legion world. Imagine the horrors he has planned for us...','',26124),
(100642,'enUS','Personally, I would prefer to avoid such torment.','',26124),
(100643,'enUS','','I\'m glad that Kane only needed to go through his rites of age... I definitely would not be able to breathe if I knew he was ever in danger!',26124),
(100644,'enUS','Take a rest my friend.','',26124),
(100645,'enUS','','Ladies, my child\'s only a little thing! I don\'t even want to THINK about her getting in any dangerous situations!',26124),
(100646,'enUS','After this is over, we\'ll all go out for a pet treat.','',26124),
(100647,'enUS','','Hemet asked you to teach me how to hunt? \n\nI\'m glad you\'re up for the job. There\'s a lot I need to learn, but I think I know which end of the rifle to shoot with...\n\nI\'m ready whenever you are!',26124),
(100648,'enUS','Protect the cargo! Protect... the souls...','',26124),
(100649,'enUS','Oh, the pain...','',26124),
(100650,'enUS','I know, I know. You just hang in there! I promise the wounds will heal!','',26124),
(100651,'enUS','Just lie still! Help\'s comin\'! I know it!','',26124),
(100652,'enUS','It\'s not the pain, numbskull - the sand! It BURNS!','',26124),
(100653,'enUS','Stay back, demons!','',26124),
(100654,'enUS','Think you can pick on us \'cause we\'re small? Huh?','',26124),
(100655,'enUS','You want a piece of this?','',26124),
(100656,'enUS','Would you keep quiet? You\'ll attract the others.','',26124),
(100657,'enUS','Oh yea. You\'ll show them! What are you gonna do? Punch \'em to death?','',26124),
(100658,'enUS','You\'ve been pacing for hours! Would ya give it a rest already?','',26124),
(100659,'enUS','Ya know, every time you run back \'n\' forth you hit me with sand! Not only am I mildly injured, but now I got sand in my hair, my eyes... bleh!','',26124),
(100660,'enUS','','I think I\'m getting the hang of it!',26124),
(100662,'enUS','','So this is the champion of Odyn! Let them die by Odyn\'s own blades! I bless these weapons with the fury of Helheim! Go, Vigfus! Slay this champion and earn my favor for all eternity!',26124),
(100663,'enUS','','Vigfus, you weak fool! Your torment will be unending!',26124),
(100664,'enUS','','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-ASIRA DAWNSLAYER.blp:50:80|t$b[Kor\'vas Bloodthorn] Those fallen soldiers... their souls have been torn from their bodies.',26124),
(100665,'enUS','','I grow weary of your presence! Tell Odyn that this changes nothing. He will suffer my wrath for ages to come!',26124),
(100666,'enUS','','The imp mother is in that cave, right there.',26124),
(100667,'enUS','Honorable $gsir:lady;, I am sorry but I must respectfully ask that you remain in the temple grounds or Mandori Village.','Honorable $gsir:lady;, I am sorry but I must respectfully ask that you remain in the Temple Grounds or Mandori Village.',26124),
(100668,'enUS','Ah, my camel! Thank you my friend! You are most kind.','',26124),
(100669,'enUS','... what happened? My head - I...','',26124),
(100670,'enUS','Demons! Their search won\'t be very fruitful once I\'ve taken their heads!','',26124),
(100671,'enUS','Take me to The Gaping Chasm!','Take me to The Gaping Chasm!',26124),
(100672,'enUS','Take me to The Noxious Lair!','Take me to The Noxious Lair!',26124),
(100673,'enUS','Ungh! Pain... hard to... focus...','',26124),
(100674,'enUS','Quickly! Before our jailer turns his attention to us. You may be able to control him long enough...','',26124),
(100675,'enUS','I will aid you... as I can.','',26124),
(100676,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] Let\'s move out.','',26124),
(100677,'enUS','','Your destiny awaits!',26124),
(100678,'enUS','What trickery is this? No one escapes my cells!','',26124),
(100679,'enUS','Injuries... more severe than I thought... must recover my strength.','',26124),
(100680,'enUS','A scream sounds from the top of the pit.','',26124),
(100681,'enUS','That was Jubeka! The others might yet live!','',26124),
(100682,'enUS','I am... too wounded to go with you, warlock. Find the others. Together... you might survive this.','',26124),
(100683,'enUS','Leave me! Ritssyn Flamescowl is no one\'s burden!','',26124),
(100684,'enUS','The Bloodtotem have always been a treacherous tribe to deal with, but I never expected them to accept the offer of a demon. They must be stopped before they destroy all of Highmountain.','',26124),
(100686,'enUS','','I don\'t think I missed a single shot!',26124),
(100687,'enUS','','Hello children. Today we will work on the basics.',26124),
(100688,'enUS','','Now, now. You can\'t run without first learning to walk.  Everyone, get into your stance.',26124),
(100689,'enUS','You seem like the type that just wants a fight. If you\'re interested, the Alliance needs more troops.','',26124),
(100690,'enUS','Yes, I agree to fight alongside the Alliance in Ashran. Send me there now!','Yes, I agree to fight alongside the Alliance in Ashran. Send me there now!',26124),
(100691,'enUS','Aw, Master Aysa, can we do something else today? I want to learn the spinning crane kick!','Aw, Master Aysa, can we do something else today? I want to learn the spinning crane kick!',26124),
(100692,'enUS','You seem like the type that just wants a fight. If you\'re interested, the Alliance needs more troops.','',26124),
(100693,'enUS','I will fight alongside the Alliance in battlegrounds, for now.','I will fight alongside the Alliance in battlegrounds, for now.',26124),
(100694,'enUS','','Uh... I\'m not a child.',26124),
(100695,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] That is the mark of the Soulrenders. Vernus the Sourender once used the blades to tear the souls out of his enemies and feed his own power.','',26124),
(100696,'enUS','','Is this the right training session?',26124),
(100697,'enUS','Safety mechanism override... complete. Defensive mode engaged!','',26124),
(100698,'enUS','','I think I\'m in the wrong class...',26124),
(100699,'enUS','Brassbolt! You\'re going to short circuit! Get back here!','',26124),
(100700,'enUS','','Yeah... I\'m pretty sure this isn\'t my training session.',26124),
(100701,'enUS','','You are truly a master strategist.',26124),
(100706,'enUS','','Let the bravest prove victorious!',26124),
(100707,'enUS','','It\'s okay, you can try again.',26124),
(100708,'enUS','','Maybe a stronger pet would be better?',26124),
(100709,'enUS','','That last pet seemed a little weak.',26124),
(100710,'enUS','','You\'ll have to work harder to win.',26124),
(100711,'enUS','','Now I am getting serious!',26124),
(100712,'enUS','','That was a warm-up.',26124),
(100713,'enUS','','You fought bravely little one.',26124),
(100714,'enUS','','You must have come a long way, would you like some water?  Oh, a pet battle?  If you insist.',26124),
(100715,'enUS','Go upstairs, Dorian. I\'ll protect the shop.','',26124),
(100716,'enUS','You still think me an old man, Jedidiah? If this city\'s going to burn, I\'m going with it.','',26124),
(100717,'enUS','Well I\'ll be... you are never boring, old friend.','',26124),
(100718,'enUS','Ready to get your latest recipe. That last one was quite the drink! We ran out of kegs on the first night!','',26124),
(100719,'enUS','','I don\'t think Hemet himself could\'ve taught me better. Hopefully he\'ll be impressed with my progress.',26124),
(100720,'enUS','','Show\'s over, everyone.',26124),
(100721,'enUS','Awww, shucks.','',26124),
(100722,'enUS','Teach us what you have learned, $n.','',26124),
(100723,'enUS','Excellent! The latest batch is just outside.','',26124),
(100724,'enUS','What\'s that smell? Is that... Illidari?','',26124),
(100725,'enUS','','Arm yourselves, comrades! The council needs our help!',26124),
(100726,'enUS','','Horace, take a few of your boys out front.',26124),
(100727,'enUS','','Orland, Alard, you\'re with me!',26124),
(100728,'enUS','','Do you not see? Kil\'jaeden offers power Illidan never could!',26124),
(100729,'enUS','DEATH IS ALL THAT AWAITS YOU!','',26124),
(100730,'enUS','You heard the lady! Outside, with arms!','',26124),
(100731,'enUS','','The demonic energy... I feel deadlier.',26124),
(100732,'enUS','Maiev is alive. For that, I will forever owe you my thanks.','',26124),
(100733,'enUS','','Our primary goal here is to get the Sargerite Keystone.\n\nWe need to finish up down here and get up onto Tyranna\'s floating command center.',26124),
(100734,'enUS','Allari, these are the secrets I\'ve uncovered.','Allari, these are the secrets I\'ve uncovered.',26124),
(100735,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] $p, I will help the others to safety. You must complete the hunt!','',26124),
(100736,'enUS','Now Huln! While the dragon is weakened.','',26124),
(100737,'enUS','','I don\'t know about you, but I\'m willing to do whatever it takes to survive.\n\nWhat we need is more power!',26124),
(100738,'enUS','Listen closely, Cyana. This is what I learned from the Tome of Fel Secrets.','Listen closely, Cyana. This is what I learned from the Tome of Fel Secrets.',26124),
(100739,'enUS','By the power of the titans, I banish you from this land Earth Warder!','',26124),
(100740,'enUS','','More... I want more power!',26124),
(100741,'enUS','Is it true that $p rescued everyone at the Peak of Serenity all by $ghis:her;self?','Is it true that $p rescued everyone at the Peak of Serenity all by $ghis:her;self?',26124),
(100742,'enUS','I\'ve heard that $p can strike so precisely that $ghe:she; can kill a demon with just one finger.','I\'ve heard that $p can strike so precisely that $ghe:she; can kill a demon with just one finger.',26124),
(100743,'enUS','I\'ve been told that the Master doesn\'t sleep. $gHe:She; fades away into nothingness each night!','I\'ve been told that the Master doesn\'t sleep. $gHe:She; fades away into nothingness each night!',26124),
(100744,'enUS','I heard that Master $p once fought bare handed against the former Warchief of the Horde for over a year!','I heard that Master $p once fought bare handed against the former Warchief of the Horde for over a year!',26124),
(100745,'enUS','I\'d love to fight alongside Master $p someday!','I\'d love to fight alongside Master $p someday!',26124),
(100746,'enUS','I can feel it coursing through my veins. Altering my body.','',26124),
(100747,'enUS','Kayn, I will teach you what I\'ve learned of the demonic mysteries.','Kayn, I will teach you what I\'ve learned of the demonic mysteries.',26124),
(100748,'enUS','','I could destroy the Legion on my own!',26124),
(100749,'enUS','','If it weren\'t for the Black Temple being under attack, I wouldn\'t mind staying here longer.\n\nThere are so many demons to kill.',26124),
(100750,'enUS','Are you ready to learn the Legion\'s secrets, Kor\'vas?','Are you ready to learn the Legion\'s secrets, Kor\'vas?',26124),
(100751,'enUS','','So Huln never backed down, no matter the enemy?',26124),
(100752,'enUS','Mannethrel, prepare yourself. I am going to fill you with the power of the Legion\'s secrets.','Mannethrel, prepare yourself. I am going to fill you with the power of the Legion\'s secrets.',26124),
(100753,'enUS','$n, wait... I can\'t contain the power.','',26124),
(100754,'enUS','Aaaaggggghhhhh!','',26124),
(100755,'enUS','The Skyhorn have tracked the beast to a nearby cave.','',26124),
(100756,'enUS','Good. He must not be allowed to gather his strength so close to our homeland. We must drive him from his lair.','',26124),
(100758,'enUS','The Path of Huln is more than just a tradition of our people. It is the right of passage for any who would carry the mantle of High Chieftain.$b$bIt is a dangerous path, and not all who have aspired to be chieftain have returned.$b$bLet me know when you are ready to depart.','',26124),
(100762,'enUS','','They\'re coming for us... it\'s the end of the world!',26124),
(100763,'enUS','','Don\'t overreact, Patty. We\'ve got the whole council in residence. We\'ll be ok!',26124),
(100764,'enUS','','Stay hidden, ok? I\'ll keep them out of the shop.',26124),
(100765,'enUS','We stand at the precipice of oblivion, but we do not stand alone. Come forward, shaman.','',26124),
(100766,'enUS','','Demons, you\'ve got to answer to Linzy Blackbolt!',26124),
(100767,'enUS','Take your place among the circle, Farseer. The Earthen Ring is forged anew, and with it, we rekindle hope for this world.','',26124),
(100768,'enUS','You are the chosen defender of Azeroth! May your wisdom guide this circle to victory, and may the power of the weapon you wield crush those who would bring chaos to this land.','',26124),
(100769,'enUS','What?! You must have cheated!','',26124),
(100770,'enUS','This\'ll be easy!','',26124),
(100771,'enUS','Ha! You call yourself a pet tamer?','',26124),
(100772,'enUS','I always hit my mark.','',26124),
(100773,'enUS','Boom, baby!','',26124),
(100774,'enUS','Smoked.','',26124),
(100775,'enUS','Who sold me this junk?','',26124),
(100776,'enUS','I thought this was pay to win!','',26124),
(100777,'enUS','Can I still get a refund?','',26124),
(100778,'enUS','You look ready for a beating!','',26124),
(100779,'enUS','Sorry friend, Cao is clearly the superior fighter. Just look at that form!','Sorry friend, Cao is clearly the superior fighter. Just look at that form!',26124),
(100780,'enUS','Cao has only started training a year ago and he can already take on three of the tiger school at the same time!','Cao has only started training a year ago and he can already take on three of the tiger school at the same time!',26124),
(100781,'enUS','Ten gold on Cao.','Ten gold on Cao.',26124),
(100782,'enUS','The elements have chosen you as their champion, $n. The artifact you wield is proof.$b$bIt is your destiny to lead the Earthen Ring against the Burning Legion. We need you. Do you accept this burden?','',26124),
(100783,'enUS','Yes. I will be your Farseer!','Yes. I will be your Farseer!',26124),
(100784,'enUS','','You heard the Archmage! Defensive positions!',26124),
(100785,'enUS','Fu Lin\'s got this. His speed is only second to the Master!','Fu Lin\'s got this. His speed is only second to the Master!',26124),
(100786,'enUS','His form won\'t mean a thing if he can\'t connect! Fu Lin\'s going to wear him down.','His form won\'t mean a thing if he can\'t connect! Fu Lin\'s going to wear him down.',26124),
(100787,'enUS','I am awake? How is this possible?','',26124),
(100788,'enUS','His speed is like a serpent strike! I wouldn\'t want to face him.','His speed is like a serpent strike! I wouldn\'t want to face him.',26124),
(100789,'enUS','I\'ll take that bet and raise you a round of the latest brew at the Laughing Crane.','I\'ll take that bet and raise you a round of the latest brew at the Laughing Crane.',26124),
(100790,'enUS','For the Horde!','For the Horde!',26124),
(100791,'enUS','Injured or not, we must fight!','Injured or not, we must fight!',26124),
(100792,'enUS','To battle!','To battle!',26124),
(100793,'enUS','We will never surrender.','We will never surrender.',26124),
(100794,'enUS','Welcome to Stonedark Grotto. It doesn\'t look like much, but it is our home.','',26124),
(100795,'enUS','It doesn\'t look like much, but it is our home.','',26124),
(100796,'enUS','Here, we live in peace away from the other drogbar.','',26124),
(100797,'enUS','Stonedark! I have returned! We have this one to thank for saving us from the Bloodtotem.','',26124),
(100798,'enUS','We will help their cause when it is asked of us.','',26124),
(100799,'enUS','Oh, and don\'t kill $Ghim:her;.','',26124),
(100800,'enUS','Wait! Please don\'t hurt Calydus!','',26124),
(100801,'enUS','Beshdal is gone! Calydus sees your power, warlock. Calydus wants to help!','',26124),
(100802,'enUS','Calydus is servant to the cruel, cruel Jagganoth. He abuses and mocks poor Calydus. But you! You could be his undoing!','',26124),
(100803,'enUS','Calydus will distract sentries. Find your friends. We will meet again soon!','',26124),
(100804,'enUS','A prisoner has escaped!','',26124),
(100805,'enUS','','Ah you\'re awake! Feeling better I hope? You were out for quite a while!',26124),
(100806,'enUS','','Welcome to Shen-zin Su! I\'m so sorry about what happened to the Peak of Serenity. We of Mandori Village are happy to allow you to stay here.',26124),
(100807,'enUS','','The other survivors are up at the temple. If you\'re feeling well, then you should head over there.',26124),
(100808,'enUS','Our people need a leader like Huln. One with the strength and courage to face any obstacle. Qualities you have proven to possess.','',26124),
(100809,'enUS','Let\'s go, $n.','',26124),
(100810,'enUS','And so there is one final vision you must witness. This is a secret passed from High Chieftain to High Chieftain since the day Huln banished Deathwing.','',26124),
(100811,'enUS','','That really was a noteworthy hunt! We should head back to camp while it\'s still fresh in my mind.',26124),
(100812,'enUS','','Listen to Sabriana! We\'ll keep you two safe.',26124),
(100813,'enUS','','Get back! Find a place to hide. Let us do the fighting, ok?',26124),
(100814,'enUS','I\'ll ready some supplies for the defenders!','',26124),
(100815,'enUS','I gave of my flesh, my soul; my people shun me as a freak.','',26124),
(100816,'enUS','','I live to serve my people, my goddess; expecting neither personal gain nor glory.',26124),
(100817,'enUS','I will serve MY people, the exiled and the reviled.','',26124),
(100818,'enUS','A duel you say? Post haste!','',26124),
(100819,'enUS','My nightmare! This is the Junior Argent Tournament all over again!','',26124),
(100820,'enUS','Back to training for you! Fifty lance squats!','',26124),
(100821,'enUS','It seems I have a new nemesis!','',26124),
(100822,'enUS','I can do this blindfolded if you prefer.','',26124),
(100823,'enUS','A valiant effort.','',26124),
(100824,'enUS','The tip of the spear is always sharpest.','',26124),
(100825,'enUS','You can always be my squire.','',26124),
(100826,'enUS','Are you ready Sir Murkeston? Fight gallantly!','',26124),
(100827,'enUS','Good show! Good show!','',26124),
(100828,'enUS','A hammer. Deathwing eats any of my people who get near it.','',26124),
(100829,'enUS','This is a titan waygate. What lies beyond?','',26124),
(100830,'enUS','Step this way, Farseer. The tauren tell of hidden chambers below that may serve as a base of operations.','',26124),
(100831,'enUS','Enough stalling. We must slay the beast and set my people free.','',26124),
(100832,'enUS','Both the hammer and Deathwing were tools of the titans. I doubt I could kill him, but I may be able to banish him.','',26124),
(100833,'enUS','How many years were wasted in that cell?','',26124),
(100834,'enUS','Mayla, I am still the same spiritwalker you have known your entire life. Know that regardless of what happens, I serve the High Chieftain.','',26124),
(100835,'enUS','It seemed in my best interest to not tell the dragonslayers that I was a dragon.','',26124),
(100836,'enUS','Send me to Shipwreck Cove, please.','Send me to Shipwreck Cove, please.',26124),
(100837,'enUS','','How can I help you?',26124),
(100838,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] He was was the greatest champion from one of the first worlds Sargeras destroyed, and one of the only beings to ever wound him in combat.','',26124),
(100839,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] That is why we must complete the hunt. The baldeswill allow us to destroy the Legion\'s foul masters for good.','',26124),
(100840,'enUS','','Get away. You cannot have my tome!',26124),
(100841,'enUS','','They\'re stealing our secrets, my queen...',26124),
(100842,'enUS','','Recover that tome at all costs, my minions!',26124),
(100843,'enUS','Yeah! Let\'s DO THIS!','',26124),
(100844,'enUS','','I WILL claim your soul, even if I have to tear it from your lifeless corpse!',26124),
(100845,'enUS','','I will... be... reborn...',26124),
(100846,'enUS','','For every soul I claim, my power grows. I will rule this world... ALL worlds!',26124),
(100847,'enUS','','WITNESS THE MIGHT OF THE ALDRACHI!',26124),
(100848,'enUS','','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-INSTRUCTOR MALICIA.blp:50:80|t$b[Caria Felsoul] I will claim every soul on this pathetic world.',26124),
(100849,'enUS','Ha! Aviash didn\'t drop you into the river on your way here. Good! That means he is starting to like you.$b$bShall we get this ceremony over with?','',26124),
(100850,'enUS','Good! I am not one for ceremony so let\'s get this over with.','',26124),
(100851,'enUS','I have already ordered my eagle riders to make for Thunder Totem. You may find the air a bit thicker with feathers soon.','',26124),
(100852,'enUS','Let it be known that I, Lasan Skyhorn, Chieftain of the Skyhorn tribe, once again declare my allegiance to Highmountain.','',26124),
(100853,'enUS','Together, we are Highmountain.','',26124),
(100854,'enUS','$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B$B|TINTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Selin Fireheart.blp:50:80|t$b[Kayn Sunfury] $p, let\'s get out of here before more demons arrive.','',26124),
(100855,'enUS','When you fight the ocean, the ocean always wins.','',26124),
(100856,'enUS','Sun\'s out! Pets out!','',26124),
(100857,'enUS','My guys need more time out on the water I think.','',26124),
(100858,'enUS','A storm is coming!','',26124),
(100859,'enUS','Waves crash and I crush!','',26124),
(100860,'enUS','You need more training before you paddle out.','',26124),
(100861,'enUS','Not every wave is a winner.','',26124),
(100862,'enUS','Wipe out!','',26124),
(100863,'enUS','Rub some sand in it.','',26124),
(100864,'enUS','There\'s no surf, so the only thing left to do is battle!','',26124),
(100865,'enUS','','Is that the best you\'ve got, demon? I thought your kind knew how to torture. Pathetic!',26124),
(100866,'enUS','Savor your words while your mind can still form them, worm!','',26124),
(100867,'enUS','','I appreciate the assistance, warlock. These demons are dreadfully boring.',26124),
(100868,'enUS','Your silence cannot last forever, worgen!','',26124),
(100869,'enUS','...','',26124),
(100870,'enUS','Yes... I can feel your mind breaking.','',26124),
(100871,'enUS','','I was... nearly food for the hounds. Thank you.',26124),
(100873,'enUS','Not today!','',26124),
(100874,'enUS','This one\'s mine.','',26124),
(100875,'enUS','Do not be afraid! This is not the first time Talendris has been under attack and I assure you it will not be the last!','',26124),
(100876,'enUS','We must hold strong! We cannot allow the Point to fall!','',26124),
(100877,'enUS','I\'ll be alright. Tend to the others.','I\'ll be alright. Tend to the others.',26124),
(100878,'enUS','Defend the Point!','Defend the Point!',26124),
(100879,'enUS','The glaives! Use the glaives!','The glaives! Use the glaives!',26124),
(100880,'enUS','Reuse','Reuse',26124),
(100881,'enUS','Reuse','Reuse',26124),
(100882,'enUS','Reuse','Reuse',26124),
(100883,'enUS','','Oculeth!',26124),
(100884,'enUS','Archmage Khadgar! I\'ve been meaning to talk to you. I feel my contributions--','',26124),
(100885,'enUS','The demon hunters? What do--','',26124),
(100886,'enUS','Sir, I think this is an excellent--','',26124),
(100887,'enUS','Yes sir! I have some wonderful ideas for Illidari uniforms!','',26124),
(100888,'enUS','Now where is he? I saw him milling about just a while ago. STARSINGER!','',26124),
(100889,'enUS','Yes, yes, we\'ll discuss that later. I\'ve received a request from the Illidari for your services.','',26124),
(100890,'enUS','You\'re to report to Allari the Souleater in Azsuna. Right away.','',26124),
(100891,'enUS','Right away!','',26124),
(100892,'enUS','Uniforms? For the Light\'s sake...','',26124),
(100893,'enUS','','Wait... where is Ritssyn?',26124),
(100894,'enUS','','The orc was gravely injured and cannot follow. No matter. We four should suffice to control that pit lord. That is still our goal, yes?',26124),
(100895,'enUS','...','',26124),
(100896,'enUS','','Fine, stubborn worgen! Escape shall be our first priority. But if the opportunity to enslave the demon presents itself, I say we take it!',26124),
(100897,'enUS','','Then it\'s decided. Let\'s keep moving.',26124),
(100898,'enUS','$n, over here. It\'s been far too long since we\'ve been on a proper hunt. Wouldn\'t you agree?','',26124),
(100899,'enUS','I would prefer not to let you live, mortal!','',26124),
(100900,'enUS','Once we\'ve rid the area of these intruders, we can commence our removal of the night elves from our land.','',26124),
(100901,'enUS','What\'s going on down here?','',26124),
(100902,'enUS','You really think you can escape? I will crush you!','',26124),
(100905,'enUS','Now that that\'s settled, $n, I have some Kirin Tor business to handle. Be well.','',26124),
(100906,'enUS','Jace, Allari, Kor\'vas, Altruis - we leave at once. Enforcers - ensure we are not followed.','',26124),
(100907,'enUS','This way! Over here!','',26124),
(100908,'enUS','','What is this miserable creature?',26124),
(100909,'enUS','Calydus is a friend, you will see! Jagganoth hunts powerful weapons. Friend could use these weapons to rule this place!','',26124),
(100910,'enUS','Jagganoth hunts powerful weapons that are dangerous to the Legion. If you get one, even mighty Jagganoth will fall before you! You will rule this place, with Calydus beside you!','',26124),
(100911,'enUS','','Rule? I like the sound of that.',26124),
(100912,'enUS','','Slow down, Shinfel. How do we know we can trust this thing?',26124),
(100913,'enUS','You must trust Calydus! Come to the archives! It\'s not far!','',26124),
(100914,'enUS','Now that was a proper hunt!','',26124),
(100915,'enUS','','An\'ah!',26124),
(100916,'enUS','','Rath!',26124),
(100917,'enUS','Inside this long-abandoned house, you feel the flicker of fading enchantments.','',26124),
(100918,'enUS','Die!','',26124),
(100919,'enUS','Gah! A time stop spell... She will pay for that!','',26124),
(100920,'enUS','','Who awakens me after all this time?',26124),
(100921,'enUS','This is not your business, outlander. Thalyssra has betrayed the Grand Magistrix and must be put down!','',26124),
(100924,'enUS','Witness the power of the Nightborne!','',26124),
(100925,'enUS','Who... are you?','',26124),
(100926,'enUS','','$n, I need to speak with you.',26124),
(100927,'enUS','','Kayn and the others await you at Krasus\' Landing. I\'ll meet you there.',26124),
(100928,'enUS','What... are... we?!','',26124),
(100929,'enUS','Your death is fated!','',26124),
(100930,'enUS','Our magic will break you!','',26124),
(100931,'enUS','Your age has ended!','',26124),
(100932,'enUS','Scum like you should obey your betters.','',26124),
(100933,'enUS','The shal\'dorei will rule!','',26124),
(100934,'enUS','Die, outlander!','',26124),
(100935,'enUS','Anath\'ashar!','',26124),
(100936,'enUS','No... Mannethrel.','',26124),
(100937,'enUS','Light... save me...','Light... save me...',26124),
(100938,'enUS','Lok\'tar... ogar...','Lok\'tar... ogar...',26124),
(100939,'enUS','','I should be focused on readying the casks for the queen. Why do I feel so... unsettled?',26124),
(100940,'enUS','The demon has been slain! Ensure the remaining attackers are disposed of and we may begin to rebuild.','',26124),
(100941,'enUS','We are in your debt, champions.','',26124),
(100942,'enUS','The monstrosity is dead! Ready yourselves! We\'re not through it just yet.','',26124),
(100943,'enUS','This... this hunger...','',26124),
(100944,'enUS','YOU! Join us!','',26124),
(100945,'enUS','We will continue our plans when this is over.','',26124),
(100946,'enUS','','Greetings, $n. I trust this projection is clear! This is Modera, Archmage of the Council of Six. I\'ve come across a lead on a weapon that could significantly aid your fight against the Legion.',26124),
(100947,'enUS','','My source is... well... unable to join us within the city. I ask that you meet with me at the crater of Dalaran\'s foundation in Hillsbrad.',26124),
(100948,'enUS','','I await your arrival.',26124),
(100949,'enUS','I\'ve had enough of this for now. I ain\'t gonna die out here today!','',26124),
(100950,'enUS','These wicked vermin must not prevail over my precious grove.','',26124),
(100951,'enUS','','$p! Need a ride?',26124),
(100952,'enUS','Whoa! Hey, $gguy:lady;! Hold up! Got a delivery for ya.','',26124),
(100953,'enUS','Thanks for using Steamwheedle Express!','',26124),
(100954,'enUS','Later, sucker!','',26124),
(100955,'enUS','','The demon has been secured.',26124),
(100956,'enUS','How\'s my little buddy doing?','',26124),
(100957,'enUS','Consume! Devour!','',26124),
(100958,'enUS','Ain\'t no uninvited guests gettin\' into our house. Not today... not ever!','',26124),
(100959,'enUS','We got more where that came from!','',26124),
(100960,'enUS','If we run out of ammunitions, start throwin\' wrenches, boys!','',26124),
(100961,'enUS','Leyota, daughter of Garhan the Great, followed in her father\'s footsteps as one of the greatest leatherworkers of Highmountain. Yet her greatest achievement was her willingness to go against the grain and change the old ways.$b$bWhen Garhan had passed, all eyes looked to Leyota to carry on his tradition. She spoke to the elders of the tribe, \"My people, long have we hunted these lands, and its bounty has given us food, shelter and protection.\"$b$b\"But we are wasteful,\" she continued, \"We bury our kills with their teeth, their hooves, their claws.\"','',26124),
(100962,'enUS','\"It is our ways,\" one elder spoke up, \"We leave their spirits with their weapons so they may hunt in the next realm. It is a sign of respect, Leyota. You know this.\"$b$b\"I see it differently, elder. Do we not show respect by ensuring that our prey\'s death was not in vain?\" she asked. \"Should we not use everything it has to offer? We can strengthen our armor two-fold if we used the rest of the animal in our construction.\"$b$bThe elders spoke silently for a moment amongst themselves then looked up to Leyota.','',26124),
(100963,'enUS','It would be far better to die in battle than to toil away all the years of my life producing arms and armor for... whatever this is that Gul\'dan has done to my brothers and sisters.','',26124),
(100964,'enUS','Down there! Keep \'em comin\'!','',26124),
(100965,'enUS','\"To change tradition, is to change our way of life. We do not believe that adding those components to ones armor will do anything for it save to make it look disrespectful to the animal from whom it came.\"$b$bLeyota\'s brow raised as the elders continued, \"We are sorry, Leyota, but we will not allow you to spoil our armor in such a way. If your quest is to strengthen our armor, you will have to find another way.\"$b$bThe elder\'s left the tent, leaving a frustrated Leyota to think.','',26124),
(100966,'enUS','They might have magic, but we got dynamite!','',26124),
(100967,'enUS','What dat green-skinned cripple did to dis jungle is terrible. Not even ogres are dis bad about ruining da world!','',26124),
(100968,'enUS','Ah, the smell of gunpowder and explosions.','',26124),
(100969,'enUS','','I don\'t know. I\'ve got a bad feeling about this.',26124),
(100970,'enUS','','It would appear the pit lord is planning an invasion.',26124),
(100971,'enUS','Ready your weapons, children of my wrath! Tonight we strike at the heart of the mortals\' defenses!','',26124),
(100972,'enUS','Join us... join us forever...','',26124),
(100973,'enUS','','Oh no... the portal!',26124),
(100974,'enUS','...','',26124),
(100975,'enUS','The next day, Leyota emerged from her tent wearing an unusual set of armor. Everyone looked at her quizically as she approached the center of the camp.$b$b\"This armor is made with the teeth and claws of a bristlefur bear I killed the other day.\" Shocked looks came over the people of the tribe as the realization of what she had done sunk in.$b$b\"I challenge any of our warriors to run me through, if they can.\" The tribes people looked around at one another, unsure to what to make of Leyota\'s challenge.','',26124),
(100976,'enUS','','They must have linked their gateway to our summoning portal. They plan to attack Dalaran! We need to close that portal!',26124),
(100978,'enUS','','Assuming we can even reach the gateway...',26124),
(100979,'enUS','Die. Die. Die.','',26124),
(100980,'enUS','I will swallow your soul.','',26124),
(100981,'enUS','Your soul is mine.','',26124),
(100982,'enUS','\"Leyota!\", a voice yelled from the crowd. A young brave emerged with a spear in hand, \"I\'ll take your challenge. You have committed a great disrespect to our ways by what you have done. It would be my honor to send your spirit away from here.\"$b$bThe brave rushed at Leyota, yet she didn\'t move a muscle. The spear tip came into contact with her chest, right where her heart was and sent her falling to the ground with the weight of the brave behind it. As the dust settled, an unusual sight emerged. The spear had not penetrated the armor.','',26124),
(100983,'enUS','The brave stood up, still clutching his spear and began to examine the tip. It was slightly bent.$b$bHe looked down at Leyota and she lay there, clutching at her chest, yet there was no blood to be seen. After a while, Leyota stood up, breathing heavily, but appearing unharmed. \"This is what I wanted to show you!\" she announced. \"The animal that I slew was given no disrespect as its life and its body was taken to protect me.\"$b$bThe tribe had fallen silent now, all eyes and ears paying full attention to what Leyota had to say.','',26124),
(100984,'enUS','OoooooooOoooo.','',26124),
(100985,'enUS','Flesh... give me your flesh.','',26124),
(100986,'enUS','Death... death shall take you.','',26124),
(100987,'enUS','Death is only the beginning...','',26124),
(100988,'enUS','\"The animals we kill can protect all of us in this way, if you\'ll let me continue to make our armor this way.\" she continued.$b$bAn elder emerged from the crowd and approached Leyota. He examined her armor, especially the point at which the spear had struck.$b$bHe nodded his head as he spoke, \"I understand now, Leyota. There is no vanity here, just strength.\"$b$bHe turned round to the tribe and said, \"Leyota has given us a stronger future. Our tribe will not fall so easily to those we hunt, or those who hunt us. And we will continue to honor our animal brothers and sisters in their death by the armor we wear.\"','',26124),
(100989,'enUS','And so it was, that Leyota, daughter of Garhan had changed the ways of the past for her people. To this day, the leather armor of Highmountain continues to use nearly all of the animal to give it its strength.','',26124),
(100990,'enUS','','Due to the sensitive nature of this matter, I must ask for your discretion. If you attempt to speak to me at any other location, I will disavow all knowledge of this message!',26124),
(100992,'enUS','Off with you, then. Find me some cliffthorn.','',26124),
(100993,'enUS','I feed on your essence...','',26124),
(100994,'enUS','Leave this meager vessel, and join us...','',26124),
(100995,'enUS','The harvest has come!','',26124),
(100997,'enUS','Ancient souls of the Black Rook, rise and join our chorus!','',26124),
(100998,'enUS','This energy... it is too much!','',26124),
(100999,'enUS','','Welcome, $n. I\'m glad you received my message.',26124),
(101000,'enUS','Free! I...','',26124),
(101001,'enUS','','We are... why are we here?!',26124),
(101002,'enUS','Demons! You did this to us!','',26124),
(101003,'enUS','Now... now I see...','',26124),
(101004,'enUS','','The darkness... it is gone.',26124),
(101005,'enUS','You... aren\'t the ones who did this?','',26124),
(101006,'enUS','Nobody touch it! Not until our guest arrives.','',26124),
(101007,'enUS','I... understand now. You... you must find Kur\'talos. You must put a stop to this.','',26124),
(101008,'enUS','Here - father showed me this passage! Take it, and find him!','',26124),
(101009,'enUS','','As for us... we do not belong here. Farewell, and may Elune\'s light guide you.',26124),
(101010,'enUS','Thank you both for meeting me in such an inhospitable location. I assure you that if I were able to join you in Dalaran, I would.','',26124),
(101011,'enUS','Precisely why I\'m here. If I can\'t return to my former position, then perhaps the council will at least consider restoring my access to the city. As a show of good faith, I have information to offer.','',26124),
(101012,'enUS','I once knew Lyandra Sunstrider, a distant relative of King Anasterian. Though she bore the Sunstrider name, in truth her branch of the family held no claim to the throne.','',26124),
(101013,'enUS','After Kael\'thas\'s betrayal, she became obsessed with finding Felo\'melorn to claim it for her own. I told her it was a fool\'s errand, that she\'d never find the relic. Indeed, it has been many years since I last heard from her.','',26124),
(101014,'enUS','Thank you, stranger!','Thank you, stranger!',26124),
(101015,'enUS','Where did all these drogbar come from?!','Where did all these drogbar come from?!',26124),
(101016,'enUS','You saved my life!','You saved my life!',26124),
(101017,'enUS','I\'m getting out of here!','I\'m getting out of here!',26124),
(101018,'enUS','You wield such power!','You wield such power!',26124),
(101019,'enUS','Thank you!','Thank you!',26124),
(101020,'enUS','I thought I was going to die!','I thought I was going to die!',26124),
(101021,'enUS','May the Earthmother bless you!','May the Earthmother bless you!',26124),
(101022,'enUS','','Moozy! Oh, thank the Earthmother that you are okay! Bless you!',26124),
(101023,'enUS','The prisoners are escaping! After them!','',26124),
(101024,'enUS','Worthless minions! I\'ll take care of you myself!','',26124),
(101025,'enUS','The portal will take you directly inside Icecrown. Hurry, it won\'t last long! I\'ll follow after you as soon as I can.','',26124),
(101026,'enUS','The Alliance will be ready. I\'ll sound the alarm throughout the Silver Enclave.','',26124),
(101027,'enUS','The Legion! They\'re already upon us. Spread out, cover the Enclave. Send these Demons back to the hells from which they\'ve come!','',26124),
(101028,'enUS','Rulen, you take the tavern. Selone, you handle the upper level. Everyone else, find a defensible location!','',26124),
(101029,'enUS','Stefen, Isirami, get everyone to the cellar! The Legion are coming to stop Archmage Khadgar!','',26124),
(101030,'enUS','','More reinforcements! Ready your spells!',26124),
(101031,'enUS','Invaders have breached the passage to the crypts. Illysanna, you must hold them here.','',26124),
(101032,'enUS','Look at the city, $r. It is beautiful, and it is tragic.$b$bWe were cowards to hide beneath that shield. Azeroth was in our care, and we chose to abandon her. We failed our sacred duty to protect the world, and our shame is too great.','',26124),
(101033,'enUS','There is another way, Thaedris. We have a refuge not far from here. Thalyssra is there.','There is another way, Thaedris. We have a refuge not far from here. Thalyssra is there.',26124),
(101034,'enUS','','Follow me, everyone! Hurry, give the guards some space!',26124),
(101035,'enUS','','Stay safe, Rulen. Thank you!',26124),
(101036,'enUS','Thalyssra escaped? She always was one of the more rational ones. I am glad that she did not stay and join the Grand Magistrix in her road to damnation.$b$bStill, it is hopeless. Our allies are few and scattered, and our enemy has gained a powerful one. We cannot possibly stop their combined forces.$b$bCome now. There is much to be done if you would earn my coin.','',26124),
(101037,'enUS','We\'ve got your back, $n.','',26124),
(101038,'enUS','Hurry up with that portal, man\'ari! Jagganoth hungers for the blood of these mortals.','',26124),
(101039,'enUS','Don\'t be a fool! The portal isn\'t yet stable enough for an army.  Do you wish to be lost to the Twisting Nether?','Don\'t be a fool! The portal isn\'t yet stable enough for an army.  Do you wish to be lost to the Twisting Nether?',26124),
(101040,'enUS','','The key! They\'re using it to stabilize the portal.',26124),
(101041,'enUS','','I guess we\'ll just have to take it, then.',26124),
(101042,'enUS','','The Rivermane are not a warlike tribe, but this trespass of our sacred cavern will not go unpunished. The drogbar will know the power of water magic.\n\nWith age comes wisdom, and with wisdom comes power!',26124),
(101043,'enUS','What are you waiting for? Crush them!','',26124),
(101044,'enUS','Good luck, hero!','',26124),
(101045,'enUS','Kneel before your new masters!','',26124),
(101046,'enUS','You will never defeat us! We are Legion!','',26124),
(101047,'enUS','Your world is ours now!','',26124),
(101048,'enUS','You will not stop me! I will not fail!','',26124),
(101049,'enUS','We have much to lose - your father\'s life, most of all.','',26124),
(101050,'enUS','Hah, nicely done! Maybe now they\'ll think twice about who they\'re messin\' with.','',26124),
(101051,'enUS','Er... did, uh... did you feel that?','',26124),
(101052,'enUS','Ayep! That\'s definitely the ground shakin\'!','',26124),
(101053,'enUS','Southern wall - Incoming!','',26124),
(101054,'enUS','You do not belong here, $c.','You do not belong here, $c.',26124),
(101055,'enUS','Begone!','Begone!',26124),
(101056,'enUS','','The Earthmother will receive your corpse!',26124),
(101057,'enUS','','The water will wash over you!',26124),
(101058,'enUS','','Get out of my cavern! I didn\'t spend a lifetime nurturing its magic only to hand it to you upstarts!',26124),
(101059,'enUS','','This is it! Let\'s see if we can make this portal a little less stable!',26124),
(101060,'enUS','','Return to the depths! Ow! My back!',26124),
(101061,'enUS','','Your magic is weak here!',26124),
(101062,'enUS','','They\'re trying to disrupt our channeling! Stop them!',26124),
(101063,'enUS','','It\'s working, we just need more time!',26124),
(101064,'enUS','','We tried peace, now we try war!',26124),
(101065,'enUS','','I\'m getting too old for this.',26124),
(101066,'enUS','','For the Rivermane! ... Did you say something? Speak up!',26124),
(101067,'enUS','That the best you got? And here I thought my guys would have to work for what little pay they earn...','',26124),
(101068,'enUS','Leave the Sunreavers to me.','',26124),
(101069,'enUS','Defenders of the Horde, we have visitors from the Burning Legion. Let us not leave them unattended!','',26124),
(101070,'enUS','Little goblin - your ignorance reeks of mortality.','',26124),
(101071,'enUS','Enough of this foolishness.','',26124),
(101072,'enUS','...spoke too soon. Northern side! Watch out!','',26124),
(101073,'enUS','I will await you in a lodge on the southwestern bluff. I advise against delay.','',26124),
(101074,'enUS','If yer looking for mail armor, look no further! I\'ve got the best in town!','',26124),
(101075,'enUS','Do you happen to have an extra crowbar?','Do you happen to have an extra crowbar?',26124),
(101076,'enUS','Here are your stands. May I have the crowbar now?','Here are your stands. May I have the crowbar now?',26124),
(101077,'enUS','Ye think I\'m just gonna give one out fer free? Sorry $glad:lass;, but you gotta give something to get something.','',26124),
(101078,'enUS','I\'d be willing to part with a crowbar for some new armor stands. Imindril Spearsong over at Tanks for Everything has some handy.','',26124),
(101079,'enUS','Get those fer me and we\'ve got a deal.','',26124),
(101080,'enUS','Yeah yeah. The spirits are important to ya. I get it.','',26124),
(101081,'enUS','I\'ll be honest. I\'m here cause ya mentioned Khaz\'goroth.','',26124),
(101082,'enUS','Took ye long enough. Stop for a pint on your way back, did ye? One crowbar, as we agreed.','',26124),
(101083,'enUS','','This way, sisters!',26124),
(101084,'enUS','','Welcome to Tanks for Everything. We have the finest in all your blacksmithing and mining needs.',26124),
(101085,'enUS','If you are as powerful as you believe, then perhaps you may prove more worthy of the sword than the last mage who came to claim it.','',26124),
(101086,'enUS','Do you have any armor stands you could part with?','Do you have any armor stands you could part with?',26124),
(101087,'enUS','Here is your dress. Can I have the armor stands now?','Here is your dress. Can I have the armor stands now?',26124),
(101088,'enUS','','I do have some extra, but I\'m not really willing to part with them. Unless...',26124),
(101089,'enUS','','Would you be willing to run a quick errand for me? Do it and I\'ll promise I\'ll give you some armor stands.',26124),
(101090,'enUS','','I just need you to take my dress over to Shandy to have cleaned. It has soot all over it.',26124),
(101091,'enUS','','That Shandy... he sure does know how to get the blood and gore out! Here are those armor stands I promised you.',26124),
(101092,'enUS','But be warned! I will not be responsible for the fate which befalls you... any more than I was for what happened to the last seeker who hoped to take my relic.','',26124),
(101093,'enUS','Can you clean this dress for me, Shandy?','Can you clean this dress for me, Shandy?',26124),
(101094,'enUS','Pay the 2 gold.','Pay the 2 gold.',26124),
(101095,'enUS','Sure I can clean that for you. I charge 2 gold per garment.','',26124),
(101096,'enUS','I\'ll get this cleaned for you in a jiffy!','',26124),
(101097,'enUS','One dress, clean as new. Thank you for your business.','',26124),
(101098,'enUS','','Are we taking bets on how long the gnome lasts?',26124),
(101099,'enUS','Mayla, this is something your father made me promise I would do for you. Please, your people need this. You need this.','',26124),
(101100,'enUS','I dunno what them tauren were huffin, but these ain\'t no spirits. These are time echoes. Somethin\' bad happened here.','',26124),
(101101,'enUS','I... obey...','',26124),
(101102,'enUS','Push \'em back! We have to hold out a bit longer!','',26124),
(101103,'enUS','Runnin\' low on fuel!','',26124),
(101104,'enUS','I don\'t know how much longer I can keep them out of the harbor!','',26124),
(101105,'enUS','They keep clippin\' my wings! Not sure how much longer I can keep her in the air.','',26124),
(101106,'enUS','They just keep coming!','',26124),
(101107,'enUS','We gotta clear \'em out, boys! The ground forces are getting overwhelmed!','',26124),
(101108,'enUS','This is what we trained for!','',26124),
(101109,'enUS','Born to fly! Live or die!','',26124),
(101110,'enUS','Alright, Aquanos, you\'re up!','',26124),
(101111,'enUS','','Take your boots off and rest a while. Nothin\' beats sleepin\' under the stars.',26124),
(101112,'enUS','That was close.','',26124),
(101113,'enUS','The threat over here at the Harbor has been... reduced, to say the least. We can manage from here.','',26124),
(101114,'enUS','Are these ronir giving you too much trouble, Gelmogg?','',26124),
(101115,'enUS','Perhaps I misjudged your worth...','',26124),
(101116,'enUS','When you\'re done with this distraction, meet us in Riverbend.','',26124),
(101117,'enUS','','While the arkhana will allow me to do most of the work, I\'ll still need a stronger reagent for the final word. A leylight shard, to be exact.$b$bNow, let\'s put those big, scary demon words to work!',26124),
(101118,'enUS','','Meet me at Riverbend as soon as you can, $n. I\'ll meet you there--my old bones don\'t move like they used to.',26124),
(101119,'enUS','INFERNALS!','',26124),
(101120,'enUS','Your soul is mine!','',26124),
(101121,'enUS','The legion will devour you!','',26124),
(101122,'enUS','','You need not worry. I will not fail, Latosius.',26124),
(101123,'enUS','Foolish mortal! You are mine now!','',26124),
(101124,'enUS','Well now, if this ain\'t the spot I dunna know what is. Looks Like back in Deathwing\'s day he gathered up all sorts of stuff.$b$bLet me know when you are ready and we can see what defenses that old wyrm left in place.','',26124),
(101125,'enUS','You cannot escape... legion.','',26124),
(101126,'enUS','The legion is... eternal!','',26124),
(101127,'enUS','','You step into the land of the dead, mortal. The Lich King has decreed that the living shall not enter Icecrown!',26124),
(101128,'enUS','This world will... burn...','',26124),
(101130,'enUS','','Men! The invaders come for us. Do not let them pass! For Kalimdor!',26124),
(101131,'enUS','What are these mortals doing here? Guards, seize them!','',26124),
(101132,'enUS','','We will bury you here, fools.',26124),
(101133,'enUS','From this map you may dispatch members of the Earthen Ring throughout the Broken Isles. Lead us to victory, Farseer!','',26124),
(101134,'enUS','This Astral Portal will return you to Dalaran whenever you wish, Farseer. I will keep it open so that you may return here any time.','',26124),
(101135,'enUS','Be sure to see me again after you\'ve gained further renown in the Broken Isles, $n. There is more for us to do!','',26124),
(101136,'enUS','It just took hold of me... I\'ve never felt anything like that before.','',26124),
(101137,'enUS','I\'ll hold out here \'til it\'s over.','',26124),
(101138,'enUS','A stranger from another land has come to honor my name? I\'m pleased to see this. The knowledge I have to pass on to you is that of totality.','',26124),
(101139,'enUS','Some believe the journey is most important, while others believe it\'s the destination.','',26124),
(101140,'enUS','A true master knows that the experience in its entirety is what fuels the mind. Never forget the beginning simply because you have reached the end.','',26124),
(101141,'enUS','This cave belongs to the Murkloc tribe!','',26124),
(101142,'enUS','This is for your help.','',26124),
(101143,'enUS','Make sure you send those demons our regards.','',26124),
(101144,'enUS','','You show honor through your deeds.',26124),
(101145,'enUS','','Be vigilant and guard against corruption.',26124),
(101146,'enUS','','May you always strive for balance.',26124),
(101147,'enUS','','My blessings to you.',26124),
(101148,'enUS','You cannot use Spymaster Jenri\'s Scope on a target with that debuff.','You cannot use Spymaster Jenri\'s Scope on a target with that debuff.',26124),
(101149,'enUS','So, Deathwing wants this titan hammer kept secret? Perhaps this is the weapon we need to challenge the beast.','',26124),
(101150,'enUS','Looks like ol\' Deathwing left the automated defenses on. Watch me back.','',26124),
(101151,'enUS','Try aimin\' fer the titan defenders. Them orbs are what are holdin\' the portals open.','',26124),
(101152,'enUS','Alright! That should be enough. I\'ll meet ya near the exit to this dragon hole.','',26124),
(101154,'enUS','','Awaken, Gorewing! Tear my foe asunder!',26124),
(101155,'enUS','','Your respect is humbly received, $r. The wisdom I grant to those who honor me is frugality.',26124),
(101156,'enUS','','Do not throw away the scrap simply because you don\'t see an immediate use for it.',26124),
(101157,'enUS','','$n, thank you for coming. Through this hall you can see the history of my people. A history I have been part of for the better part of a century.',26124),
(101158,'enUS','','We have a history of both harvest and war. Never are we stronger than when together with the other tribes.',26124),
(101159,'enUS','','Ah, Thunder Totem. This feels right. My knees? Not so right.',26124),
(101160,'enUS','','Let it be known that I, Jale Rivermane, Chieftain of the Rivermane tribe, declare my allegiance to Highmountain once again.',26124),
(101161,'enUS','','Together, we are Highmountain!',26124),
(101162,'enUS','Selentia wails, calling forth ancient keepers!','Selentia wails, calling forth ancient keepers!',26124),
(101163,'enUS','','Many small things will always add up to something bigger, and often just as strong.',26124),
(101164,'enUS','','With the drogbar threat to my people quelled, we are happy to rejoin Mayla Highmountain\'s cause. I am ready to begin the ritual when you are.',26124),
(101165,'enUS','I am ready.','I am ready.',26124),
(101166,'enUS','Respect is paid, and knowledge is given. Hear now my lesson of flexibility.','',26124),
(101167,'enUS','The same methods one uses to shape one\'s leather can also be used to shape one\'s spirit and mind.','',26124),
(101168,'enUS','The sooner I crush you the faster I go back to sleep!','',26124),
(101169,'enUS','Confidence in your conclusions will give you strength, but fluidity with your actions will grant you wisdom.','',26124),
(101171,'enUS','Sleep... at last....','',26124),
(101172,'enUS','Give me one reason not to let Talas here rip yer wings off and beat ya with \'em.','',26124),
(101173,'enUS','Look, that incident with Iron Horde was just a misunderstanding. Garrosh was supposed to convince them to fight the Burning Legion, not invade Azeroth.','',26124),
(101174,'enUS','Bah. Never trust a dragon. At least he showed us a way out. Once we get these disks back to Ironforge I\'ll be able to really dig into them.','',26124),
(101175,'enUS','Please find Moozy. I will try to recover and search as well. If you find him, take him to his mother upriver.','',26124),
(101176,'enUS','$n! I found you! The four winds have been sent to seek you out. Come with me.','',26124),
(101177,'enUS','%s gestures toward Thrall.','',26124),
(101178,'enUS','What do you want, puny creature? You want a lesson? Okay, I\'ll give you a lesson.','',26124),
(101179,'enUS','','You\'re not the only one with minions, demon!',26124),
(101180,'enUS','','Make sure you give those demons what\'s comin\'!',26124),
(101181,'enUS','','Nice of you to show up. Haven\'t seen much backup yet.',26124),
(101182,'enUS','','Some kinda party, eh? So many uninvited guests.',26124),
(101183,'enUS','','Be nice when things are back to normal \'round here.',26124),
(101184,'enUS','You said it, sister!','',26124),
(101185,'enUS','Couldn\'t have said it better myself.','',26124),
(101186,'enUS','','Fall before me!',26124),
(101187,'enUS','Never work with hides that are still attached to the animal. Especially if it\'s alive. Just trust me on this.','',26124),
(101188,'enUS','That is all.','',26124),
(101189,'enUS','Learn our stories, outlander. They carry great meaning.','',26124),
(101190,'enUS','','Now might be a good time, Zinnin...',26124),
(101191,'enUS','Your soul will burn!','',26124),
(101192,'enUS','This world will... perish...','',26124),
(101193,'enUS','We are... infinite...','',26124),
(101194,'enUS','','You can not escape.',26124),
(101195,'enUS','','Brothers and sisters! The temple - it must be preserved!',26124),
(101196,'enUS','','They desecrate our ruins!',26124),
(101197,'enUS','This memorial is not as grand or famous as the others here, but it holds special importance for me. Within lies Lady Latara, a consummate huntress and my wife. Oh, how I miss her.','',26124),
(101198,'enUS','Destroy the intruders!','',26124),
(101200,'enUS','','The Mindbenders! Do not give in!',26124),
(101201,'enUS','','Zin-Malor is ours!',26124),
(101203,'enUS','Do not be afraid, for I am not. I will soon be reunited with my lady love. These heroes that surround you were men and women just like me. They too had their own loves and vices, and they understood the meaning of sacrifice. Let this be mine.$b$b<Thaedris sighs.>$b$bPerhaps you are right, $n. I have been so tired and weary with the shame of our people. I believed that I had no path, no recourse. Truly it would be impossible for me to atone for our actions. I am no hero, despite what you may think. I am simply an old man who has seen too much for one lifetime.','',26124),
(101204,'enUS','We may have a way to stave off the hunger - long enough to find a cure. Let us help.','We may have a way to stave off the hunger - long enough to find a cure. Let us help.',26124),
(101205,'enUS','','Your actions cannot disrupt our studies! The power will soon be ours!',26124),
(101207,'enUS','It is good to fight with you again.','It is good to fight with you again.',26124),
(101208,'enUS','','The hunt is eternal...',26124),
(101209,'enUS','','Guards! Hold them off!',26124),
(101210,'enUS','','I will burn you alive!',26124),
(101211,'enUS','','Thank you...',26124),
(101212,'enUS','','What is this place?',26124),
(101213,'enUS','','Ah, the Arcway. Great halls which run beneath the entire region... even the city itself.',26124),
(101214,'enUS','','For now, at least, we know the withered have learned to avoid this place.',26124),
(101215,'enUS','','And nobody from the palace would think to search for us here.',26124),
(101216,'enUS','What is this commotion I hear? Why has the portal been closed?','',26124),
(101217,'enUS','','It looks like we got his attention.',26124),
(101218,'enUS','','We should hurry. I would rather avoid a confrontation if we can.',26124),
(101219,'enUS','','Oh, you\'re no fun.',26124),
(101220,'enUS','','Let\'s find this archive and get out of here before it\'s too late.',26124),
(101221,'enUS','','No! I can see now... betrayed...',26124),
(101222,'enUS','In the end, you will all succumb to the Legion...','',26124),
(101223,'enUS','','Got another, Maruul! You\'re falling behind!',26124),
(101224,'enUS','','Minions - Attack!',26124),
(101225,'enUS','','',26124),
(101226,'enUS','','Another down! You\'ve got nothing on me!',26124),
(101227,'enUS','','You\'re wasting your time, Maruul! Your aim will never be as good as mine!',26124),
(101228,'enUS','With pleasure.','',26124),
(101229,'enUS','The archive is just ahead! Xel\'toth waits there, coveting all of Jagganoth\'s knowledge to himself. Question him, and you will find your artifact!','',26124),
(101230,'enUS','','',26124),
(101231,'enUS','','Even if you stop us here we will never be done.',26124),
(101232,'enUS','What mortal dares approach the archives? Such insolence will not be tolerated!','',26124),
(101233,'enUS','','I don\'t think he means to cooperate. Let\'s see how brave he is when we take away his strength.',26124),
(101234,'enUS','','He\'s just too strong!',26124),
(101235,'enUS','','Defend yourselves!',26124),
(101236,'enUS','Fools! You will suffer for your trespass!','',26124),
(101237,'enUS','Someone else marked that target.','Someone else marked that target.',26124),
(101238,'enUS','','He is weakened! Quickly, banish him before he recovers!',26124),
(101239,'enUS','This cannot be! Release me at once!','',26124),
(101240,'enUS','','We\'ll consider it, demon, but first, what can you tell me about these artifacts that Jagganoth is hunting?',26124),
(101241,'enUS','Never!','',26124),
(101242,'enUS','','In that case, how about I simply cast you out into the Great Dark? You can spend eternity observing the nothingness.',26124),
(101243,'enUS','You wouldn\'t!','',26124),
(101244,'enUS','','She would.',26124),
(101245,'enUS','Very well. If you truly wish to defeat Jagganoth, there is only one artifact you would wish to seek.','',26124),
(101246,'enUS','Deep beneath the keep of Karazhan rests the dread scythe Ulthalesh, The Deadwind Harvester.','',26124),
(101247,'enUS','In their unending search for powerful relics, the Dark Riders plucked Ulthalesh from its resting place and stashed it in their armory.','',26124),
(101248,'enUS','','Indeed, my pet. Indeed...',26124),
(101249,'enUS','My knowledge has been granted. Now, release me from my bonds!','',26124),
(101250,'enUS','','Hm, I don\'t remember ever agreeing to let you go.',26124),
(101251,'enUS','Insolent worms! You will burn for this!','',26124),
(101252,'enUS','What is this? The petulant mortals disrupt my portals and invade my archives? I should have simply destroyed you like that petty little gnome.','',26124),
(101253,'enUS','','You will see me again at the Temple of Elune.',26124),
(101254,'enUS','','Killing us would have been your salvation, Jagganoth. Now, you will have to pay for Zelifrax! Band\'or shorel\'aran!',26124),
(101255,'enUS','','Shinfel! Zinnin!',26124),
(101256,'enUS','','They cannot hope to face him alone. Come, warlock!',26124),
(101257,'enUS','No! Friend must not confront Jagganoth without the weapon! Friend will surely be defeated!','',26124),
(101258,'enUS','','But we cannot leave them!',26124),
(101259,'enUS','Calydus will go help his friend find weapon. Then we will return with the power to defeat Jagganoth. We must hurry!','',26124),
(101260,'enUS','','Go then, warlock, but I cannot abandon the Council. Let us hope we can survive to see your return.',26124),
(101261,'enUS','Yes, yes! Use the portal! Hurry, friend!','',26124),
(101262,'enUS','Maxxael! The master will not tolerate sloth... Where are you?!','',26124),
(101263,'enUS','','Kassarus! Dispose of these intruders.',26124),
(101264,'enUS','','I don\'t think Hemet himself could have taught me better.',26124),
(101265,'enUS','No! YOU... you killed him!','',26124),
(101266,'enUS','I will paint this keep with your blood!','',26124),
(101267,'enUS','For the love of the Naaru, I missed again!','',26124),
(101268,'enUS','I\'ve had enough of your barking, Emily!','',26124),
(101269,'enUS','I got one! How\'s that for being a \"bad shot\"?','',26124),
(101270,'enUS','Our defeat at the Broken Shore was a disaster. What\'s left of the Alliance and Horde are at one another\'s throats.$b$b$C, heroes like you may be our last great hope. Stay strong, and do not give up.','',26124),
(101271,'enUS','','So long as the Legion does not break our spirit, they cannot triumph.',26124),
(101272,'enUS','Tremble beneath me.','',26124),
(101273,'enUS','Don\'t bother running, flea...','',26124),
(101274,'enUS','Ha! Got you!','',26124),
(101275,'enUS','Take this!','',26124),
(101276,'enUS','Out with the refuse.','',26124),
(101277,'enUS','','Neutralized.',26124),
(101278,'enUS','But... I can\'t... lose...','',26124),
(101279,'enUS','Kur\'talos... they come for you.','',26124),
(101280,'enUS','They do. Together we shall defeat them, Latosius.','',26124),
(101281,'enUS','Fiends, you shall never have our world!','',26124),
(101282,'enUS','I shall cleave you in twain!','',26124),
(101283,'enUS','You will not take our world!','',26124),
(101284,'enUS','Burn away!','',26124),
(101285,'enUS','Enough! I tire of this.','',26124),
(101286,'enUS','Ravencrest, you worthless husk. Ten thousand years have not been kind.','',26124),
(101287,'enUS','When Trand started spreading news of Deathwing\'s coming, my family did not want to follow. My heart told me to stay with them, but my body... \n\nI want to live, $c. There is no shame in that.','',26124),
(101288,'enUS','Now, you.','',26124),
(101289,'enUS','Sleep, now...','',26124),
(101290,'enUS','Your skin crawls...','',26124),
(101291,'enUS','We are legion!','',26124),
(101292,'enUS','You cannot comprehend that which you face, mortals...','',26124),
(101293,'enUS','No... no...','',26124),
(101294,'enUS','What am I? This is... not...','',26124),
(101295,'enUS','My ancestors... Illysanna! No, forgive me...','',26124),
(101296,'enUS','Heroes! You must defeat him!','',26124),
(101297,'enUS','Ha! You expect these worthless mortals to defy the Legion?','',26124),
(101299,'enUS','Why... why do you bother to struggle? You will fail - if not today, then tomorrow, or the next...','',26124),
(101300,'enUS','Souls of my ancestors! To me! Aid our champions!','',26124),
(101301,'enUS','Yes - we may bend, but never break.','',26124),
(101303,'enUS','I... will... return!','',26124),
(101304,'enUS','I will count on it. Whenever you come, we will meet you. And we WILL defend our world.','',26124),
(101305,'enUS','Thank you, heroes. A great veil has been lifted from our eyes.','',26124),
(101306,'enUS','We Ravencrests have sacrificed much and more in defense of this land. I see now we may rest, safe in the knowledge that heroes still live who will defend our world.','',26124),
(101307,'enUS','Good luck, $n. I\'ll see you up in the volcano.','',26124),
(101308,'enUS','','I, too, came to Icecrown in search of Felo\'melorn. The Lich King gave me the blade... and more. He gave me purpose!',26124),
(101309,'enUS','Looks like you could use a little help.','',26124),
(101310,'enUS','We\'re too spread out. Everyone regroup!','',26124),
(101311,'enUS','So far, so good, $n. We\'re about to take the ridge.','',26124),
(101312,'enUS','Are you ready to plant the banner?','',26124),
(101313,'enUS','I\'m going to need my warglaive back after you kill that demon.','',26124),
(101314,'enUS','After we take this place, you need to summon our forces through that huge Legion gateway.','',26124),
(101315,'enUS','I can\'t get to you right now, but I can throw my warglaive at your demon.','',26124),
(101318,'enUS','Use Murky\'s Egg to mindmeld with him and guide his actions.','',26124),
(101319,'enUS','Mrgl, grrglrrgl. GURGLRRGLRRRGL! Mrgl.','',26124),
(101320,'enUS','MrglRGLRGLRGL. Mrrrmrgl!','',26124),
(101321,'enUS','Grmrglrgml? Mrgrl. RGL!','',26124),
(101322,'enUS','Mglrrglrgl! Grml. Mrgrmlgr.','',26124),
(101324,'enUS','You saved my people from the Feltotem and their Legion allies. We will now help you and your Highmountain allies against Dargrul and his mindless followers.','',26124),
(101325,'enUS','I am nervous about entering this place. Best hurry in before they change their mind about allowing me safe passage.','',26124),
(101326,'enUS','I, Navarrogg, leader of the Stonedark drogbar, declare my allegiance to the Highmountain tribe.','',26124),
(101327,'enUS','Together, we are Highmountain!','',26124),
(101328,'enUS','Looks like they\'re trying to surround the Harbor! Keep \'em busy until reinforcements arrive!','',26124),
(101329,'enUS','Hold \'em off \'til we can get some backup here!','',26124),
(101330,'enUS','We\'re not gonna lose the Strand! Air reinforcements are comin\' soon!','',26124),
(101331,'enUS','If we lose ground here they\'ll siege Bilgewater! Throw the kitchen sink at \'em. We ain\'t losin\' Bilgewater!','',26124),
(101332,'enUS','Mrrgl. Mrrglrgrgrgl. Rrglrgl, mrglrgl. RRGL!! Mrglrgl. Mrr, mrgl. Rglrglmrr, glrmrlr. Mrglrrrr. Gllrmrl. Mrr? Grmlrml!\n\nMrgl. Mrrky. Mrg.','',26124),
(101334,'enUS','','Who taught you how to shoot a gun, a murloc?',26124),
(101335,'enUS','Your pride will be the end of you!','',26124),
(101336,'enUS','<The vrykul seems to be unconscious.>','',26124),
(101337,'enUS','Try to rouse the vrykul.','Try to rouse the vrykul.',26124),
(101338,'enUS','Firmly kick the vrykul.','Firmly kick the vrykul.',26124),
(101339,'enUS','Repeatedly poke the vrykul with a stick','Repeatedly poke the vrykul with a stick',26124),
(101340,'enUS','<Fjolrik mumbles to himself.>$B$BNot now, Asta. I\'m trying to sleep.','',26124),
(101341,'enUS','<Fjolrik mumbles to himself.>$B$BNot so rough, Asta!','',26124),
(101342,'enUS','<Fjolrik mumbles to himself.>$B$BAsta! Is it time to battle?','',26124),
(101344,'enUS','Is there something I can help you with, $c?','',26124),
(101345,'enUS','I was wondering if you would be able to part with one of your scales?','I was wondering if you would be able to part with one of your scales?',26124),
(101346,'enUS','I came for the Illidari, but Azoran will be pleased when I bring him your corpse as well!','',26124),
(101347,'enUS','I\'m sorry, $n, but I cannot simply give you one of my scales. In this time of need, we must keep all of our strength.','',26124),
(101348,'enUS','A strange request, $n, but I trust it will go towards a good cause. Here, take it, and may it help you against the legion.','',26124),
(101349,'enUS','','SKREEE! IT BURNS! I will flay you alive for this!',26124),
(101350,'enUS','I wish I could do more to aid Senegos.','',26124),
(101351,'enUS','You come here, at this hour, and ask for such a thing? Leave me be, $c.','',26124),
(101352,'enUS','I take it you need this for some vital task? Since I\'m of no help to my kin, I suppose the least I could do is help you.','',26124),
(101353,'enUS','','Have you checked the storehouse up the hill? We\'ve been trying to gather all the good bits we can find. Things that will last. You know; bananas, milk... that sort of thing. \n\nI think we\'re doing a good job!',26124),
(101354,'enUS','These damn Nightfallen are relentless. Have you come to aid us in our fight against them?','',26124),
(101355,'enUS','My scale? The nighfallen take our essence and you ask for my scale?! Leave before I confuse you with one of them!','',26124),
(101356,'enUS','That\'s a very difficult request you ask of me, $n. Here, take one. I only hope it leads to ending this war.','',26124),
(101357,'enUS','Huln cast Tichondrius out of this world with the Eagle Spear.','',26124),
(101358,'enUS','He returned to his homeland after the War of the Ancients and it was renamed in his honor.','',26124),
(101359,'enUS','Trand is an inspiration. He\'s strong willed, a good leader, and he cares about others. When he had the vision of Deathwing\'s return, he didn\'t just run off by himself. He told us, his peers, and called us to follow him if we wanted to live. \n\nI\'ve known many a shaman in my life, but Trand really knows how to... ride the lightning, so to speak.','',26124),
(101361,'enUS','','It\'s a fine day for a hunt.',26124),
(101362,'enUS','Your movements have caused a Frost Block to break open!','Your movements have caused a Frost Block to break open!',26124),
(101364,'enUS','','The Doomhammer fell somewhere below. Hold on! This part always gives me tummy the wubblies!',26124),
(101365,'enUS','Come closer if you want to die, naga!','',26124),
(101367,'enUS','I don\'t know who you are, but you best get out of here before the giants catch you.','',26124),
(101368,'enUS','Day 5: Wards prove effective at deterring the withered, but do nothing for the cacophony of critters and beasts outside. The nights are so loud out here.','',26124),
(101369,'enUS','I relish what little sleep I can manage. Tomorrow I begin looking for subjects.','',26124),
(101375,'enUS','We will never forget the great deeds you have done in service of our people... until we do.','',26124),
(101376,'enUS','Greetings brul.$b$bIf you tire of the stench of wood and clean air then speak with me, Bogrogg, the STONESCREAMER!$b$bI can send you by way of stone and earth to the Stonedark Grotto.','',26124),
(101377,'enUS','I wish to journey to Stonedark Grotto.','I wish to journey to Stonedark Grotto.',26124),
(101378,'enUS','Sure didn\'t see that coming! I\'m gonna warn the others.','',26124),
(101379,'enUS','By the horns on my head, I will kill every last one of these naga!','',26124),
(101380,'enUS','Thanks! Is that my blood or yours?','',26124),
(101381,'enUS','Protect the Harbor at all costs!','',26124),
(101382,'enUS','Ain\'t no way these things are taking over.','',26124),
(101383,'enUS','I am no naga, Stokalfr! I come on behalf of Brandolf!','I am no naga, Stokalfr! I come on behalf of Brandolf!',26124),
(101384,'enUS','Glad you\'re here. We could use some backup.','',26124),
(101385,'enUS','That pup is still alive? Glorious!$B$BI will follow you, but keep your hands off my helmet.','',26124),
(101386,'enUS','There! The portal should be stable enough to take you to Dalaran.','There! The portal should be stable enough to take you to Dalaran.',26124),
(101387,'enUS','It took you long enough, man\'ari. Jagganoth hungers for the blood of these mortals!','',26124),
(101388,'enUS','','The key! They\'re using it to stabilize the portal.',26124),
(101389,'enUS','','If we can get to it in time, we may be able to stop them from reaching Dalaran!',26124),
(101394,'enUS','You will never escape!','',26124),
(101395,'enUS','','Arise, ghouls! Feast upon this intruder\'s heart!',26124),
(101396,'enUS','Celea sent me to free you. Here, put on this armor.','Celea sent me to free you. Here, put on this armor.',26124),
(101397,'enUS','Stay in Thunder Totem if you want, woman. I\'m done with these weaklings. My true place is with the Bloodtotem.','',26124),
(101398,'enUS','Get away from that portal, worm!','Get away from that portal, worm!',26124),
(101400,'enUS','You seem like the type that just wants a fight. If you\'re interested, the Horde needs more troops.','',26124),
(101401,'enUS','It appears you didn\'t complete your last tour of duty in Ashran. Return to me in a few minutes.','',26124),
(101402,'enUS','It appears you didn\'t complete your last tour of duty in Ashran. Return to me in a few minutes.','',26124),
(101403,'enUS','','I can feel the connection breaking. We\'re almost there!',26124),
(101404,'enUS','','There. It is done.',26124),
(101405,'enUS','','They won\'t be reaching Dalaran anytime soon.',26124),
(101406,'enUS','-PH- TEXT WILL BE DONE DURING POLISH','',26124),
(101407,'enUS','These lands are not your own.','These lands are not your own.',26124),
(101408,'enUS','Blood and Honor!','Blood and Honor!',26124),
(101409,'enUS','','That was too close for my liking. $n, the demon\'s power is yours.',26124),
(101410,'enUS','Join me, demon hunters. I will increase your power beyond imagining!','',26124),
(101411,'enUS','Courage... is your greatest weapon...','',26124),
(101412,'enUS','The wardens would keep us rotting here forever. Why do you fight on their side?','',26124),
(101413,'enUS','Find the strength within...','',26124),
(101414,'enUS','Put your faith... in the Light...','',26124),
(101415,'enUS','The Ashbringer...','',26124),
(101416,'enUS','No... noooooo! Fools...','',26124),
(101417,'enUS','Ashes... to ashes...','',26124),
(101418,'enUS','None can escape Jagganoth\'s wrath!','',26124),
(101419,'enUS','In the Light... we are one...','',26124),
(101420,'enUS','Remain... vigilant...','',26124),
(101421,'enUS','Unbreakable...','',26124),
(101422,'enUS','We stand... united...','',26124),
(101423,'enUS','Hope... never dies...','',26124),
(101424,'enUS','','I will not be defeated! Come, my pet! Sate your hunger with the flesh of the living!',26124),
(101425,'enUS','Day 9: Still no luck in communicating with the withered. I must regard this failure not as a measure of ability, but a measure of progress.','',26124),
(101426,'enUS','Day 14: The new subject, number 16, is special. His arcane essence is touched by some mysterious power. I have named him Theryn.','',26124),
(101427,'enUS','Let me know when you\'re ready, $n. I can\'t wait to get out of here.','',26124),
(101428,'enUS','I\'m ready, Taldranis. Let\'s go.','I\'m ready, Taldranis. Let\'s go.',26124),
(101429,'enUS','You honor us with your strength, champions. I ask that you fight - bleed for our cause! We will not fall to the Legion!','',26124),
(101430,'enUS','Blood and Honor, champions! Show them your strength! Stand together! Fight together!','',26124),
(101431,'enUS','The Ashbringer...','The Ashbringer...',26124),
(101432,'enUS','Day 16: Breakthrough! Using Theryn\'s essence as the base, I have crafted a spell that calms the withered. At least, it works sometimes...','',26124),
(101433,'enUS','Day 24: Awoke to a night elf\'s blade at my neck. He asked what I was doing to the withered. \"Searching for a cure,\" I replied. He merely grunted, and disappeared into the woods.','',26124),
(101434,'enUS','Shinfel and Zinnin attack Jagganoth!','Shinfel and Zinnin attack Jagganoth!',26124),
(101436,'enUS','Wield your weapons with purpose! Drive them back!','',26124),
(101437,'enUS','Day 33:  Low on arc-wine. Theryn making excellent progress. Shal\'an remains stubborn. Crystals becoming harder to find.','',26124),
(101438,'enUS','Day 50: The sky... has turned black. Demons... everywhere. And this hunger... this endless hunger...','',26124),
(101439,'enUS','Subjects released... I can no longer protect them...','',26124),
(101440,'enUS','Death Knights of Acherus, I send to you $n who will serve as the enforcer of my will. Follow her commands as you would my own.','',26124),
(101441,'enUS','Jumping from this bridge is training for my boys. If you can jump from here, you can jump from your eagle! They\'ll be ready to fight the good fight before we know it. We\'re happy to be back in Thunder Totem.\n\nYou can try, if you\'d like.','',26124),
(101442,'enUS','Next!','',26124),
(101443,'enUS','','Hallo shaman! We got separated from one another after the assault on the Maelstrom.$b$bCome, there\'s work ta be done. Stormbeak here will fly ya to Deepholm.',26124),
(101444,'enUS','Fly me to Deepholm, Mylra!','Fly me to Deepholm, Mylra!',26124),
(101445,'enUS','Alright, $n, I\'m your shadow from here on out. Try not to get us killed.','',26124),
(101446,'enUS','','We never should have listened to Ebonhorn. We should have used the hammer against the Legion and the drogbar when we had it.',26124),
(101447,'enUS','','Tell that to the Riverbend Refugees.',26124),
(101448,'enUS','I\'ve got it from here, $n. Thanks for your help. And if you see Celea again, tell her I owe her one.','',26124),
(101449,'enUS','','The hammer is not a weapon, you know that.',26124),
(101450,'enUS','%s arises to the call for battle as its stiff branches crackle, releasing age old dust to the ground below.','',26124),
(101451,'enUS','Sitting','Sitting',26124),
(101452,'enUS','Mayla cannot even stand against the drogbar. What hope does she have against the Legion?','',26124),
(101453,'enUS','We are done with Highmountain. The Bloodtotem must look to new allies.','',26124),
(101454,'enUS','','Unacceptable! My minions will rip you apart!',26124),
(101455,'enUS','I heard the harpies hit Skyhorn hard. Lasan has been pulling back all of his forces to defend their home.','',26124),
(101456,'enUS','Applebough notices G\'Hanir and tosses you a fresh apple!','',26124),
(101461,'enUS','The Ashbringer?! Lord Balnazzar will have your head!','',26124),
(101462,'enUS','|TINTERFACE\\ICONS\\trade_archaeology_naarucrystal.blp:20|t $n is imprisoned in |cFFF00000|Hspell:195791|h[Quarantine]|h|r!','|TINTERFACE\\ICONS\\trade_archaeology_naarucrystal.blp:20|t $n is imprisoned in |cFFF00000|Hspell:195791|h[Quarantine]|h|r!',26124),
(101463,'enUS','Hold fast, Illidari! We must trap him in this chamber!','',26124),
(101464,'enUS','Hurry, $n! Activate the countermeasures around the room!','',26124),
(101465,'enUS','The Ashbringer... will falll...','',26124),
(101466,'enUS','We cannot hold out like this forever. We need to contain him!','',26124),
(101467,'enUS','What you want me find? Me have shovel!','',26124),
(101468,'enUS','Go find shiny! Dig dirt in dead place.','Go find shiny! Dig dirt in dead place.',26124),
(101469,'enUS','Well done! The monster is contained. Let\'s meet up with the others.','',26124),
(101470,'enUS','|TInterface\\Icons\\ability_socererking_arcanewrath:20|tYou are targeted by |cFFF00000|Hspell:196070|h[Suppression Protocol]|h|r!','|TInterface\\Icons\\ability_socererking_arcanewrath:20|tYou are targeted by |cFFF00000|Hspell:196070|h[Suppression Protocol]|h|r!',26124),
(101471,'enUS','','Riverbend was destroyed with a single blow. How can we stand against such power?',26124),
(101472,'enUS','Well I\'ll be... the Ashbringer. They say King Magni worked for three days straight to forge that blade.','',26124),
(101473,'enUS','Anything else?','Anything else?',26124),
(101474,'enUS','You kill basilisk! Biggest in cave! Bring back!','You kill basilisk! Biggest in cave! Bring back!',26124),
(101475,'enUS','You need kill? My chisel axe best in sharpness ever!','',26124),
(101476,'enUS','Well if ain\'t the Highlord $Ghimself:herself;! I reckon\' it\'s good for even the hardiest of us to take a moment and reflect now and again. I\'m right fond of this spot.','',26124),
(101477,'enUS','Take a seat with me for a moment, won\'t ye?','',26124),
(101478,'enUS','The Ashbringer is a truly wondrous blade, ain\'t it? I remember forging it many years ago back in Ironforge - my finest work.','',26124),
(101479,'enUS','If ye don\'t mind an old dwarf talkin\' yer ear off, I\'d like to share a piece of advice with ye that I\'ve carried with me since I was a lad.','',26124),
(101480,'enUS','We all come from the same earth and stone around us; Alliance and Horde, dwarf and gnome- as a leader, ye\'ve got to see past the differences and unite yer people against the Legion. Azeroth depends on it.','',26124),
(101481,'enUS','I\'ll give ye some time alone. Just somethin\' to think about in the days ahead.','',26124),
(101482,'enUS','I\'m with you, hero! I\'ll hold Lyandra at bay. Focus on destroying that monster of hers!','',26124),
(101483,'enUS','What you want me do? Can wax off extra hairs? Make drip bath? Check ears for waxes?','',26124),
(101484,'enUS','Make big candle! Lots of wax!','Make big candle! Lots of wax!',26124),
(101485,'enUS','Throm-Ka, Highlord $p. I see we both value some peace and quiet now and again.','',26124),
(101486,'enUS','Sit with me if you would - just for a few moments.','',26124),
(101487,'enUS','Tirion was my brother by blood. We saved one another\'s lives many moons ago. He was a good man... an honorable man.','',26124),
(101488,'enUS','He always thought highly of you - from what I hear from others his trust has not been misplaced.','',26124),
(101489,'enUS','I have watched many lead their people down dark paths. Tirion often spoke of the Light that guided his hand and his people - let it guide you to greatness as well.','',26124),
(101490,'enUS','I am not one for conversation - much remains to be done. May our paths cross again, $p.','',26124),
(101491,'enUS','','Aethas! How DARE you! Have you forgotten who I am?',26124),
(101492,'enUS','If they come, I\'ll be ready.','',26124),
(101493,'enUS','Take care of yourself out there. If ye ever need anything, ye know where to find me.','',26124),
(101494,'enUS','Lok\'tar ogar.','',26124),
(101495,'enUS','I remember who you were. But the creature before me now is but a walking corpse!','',26124),
(101496,'enUS','Apologies, but now is not the time.','',26124),
(101497,'enUS','I mine! You no take pickaxe! Where you want rocks dug? Want the metals? Pick a little dull.','',26124),
(101498,'enUS','Dig rocks, find pretties! More pretty is better.','Dig rocks, find pretties! More pretty is better.',26124),
(101499,'enUS','This world will crumble! We will darken your skies, crush your armies. Come, whelps! Die before my might!','This world will crumble! We will darken your skies, crush your armies. Come, whelps! Die before my might!',26124),
(101500,'enUS','She\'s trying to counter my spell! I won\'t be able to hold her much longer. Hurry!','',26124),
(101501,'enUS','The Legion will fail in their efforts.','',26124),
(101502,'enUS','The entrance to this place remains hidden, known only to the riders themselves.','',26124),
(101503,'enUS','Little is known of this ancient weapon, other than that its power was responsible for taking the life from the place you call Deadwind Pass.','',26124),
(101504,'enUS','','Great job, $n. We were able to save a lot of good soldiers, but we haven\'t accounted for all of our lost forces yet.',26124),
(101505,'enUS','','A scout just informed me that there is a jailer demon to the east with at least ten of our soldiers being tortured.',26124),
(101506,'enUS','$n, you take the east and recover any remaining survivors. Lynore and I will take the soldiers and push them back in the west.','',26124),
(101508,'enUS','Me find shiny coins at bury place! So many, so shiny. What me do with them?','',26124),
(101509,'enUS','You keep one. I keep rest.','You keep one. I keep rest.',26124),
(101511,'enUS','I find biggest basilisk in cave! It dead now! I get reward?','',26124),
(101512,'enUS','Best kill job me seen! You get best reward...','Best kill job me seen! You get best reward...',26124),
(101513,'enUS','','Only when the blinding pain of life left me did I see the truth! Only then was the majesty of the plan revealed!',26124),
(101514,'enUS','','The blade is mine, by the will of the master... and by rights of blood! Oppose me and you WILL be struck down!',26124),
(101515,'enUS','Candle almost ready! Just needs magic touch and Candleking will have best candle I ever make!','',26124),
(101516,'enUS','Me think me have just the right touch...','Me think me have just the right touch...',26124),
(101517,'enUS','Using Artifact','Using Artifact',26124),
(101518,'enUS','All doubt has been banished! You are truly worthy of the blade! Claim your prize and leave, hero. The living have no place within my prison of ice.','',26124),
(101519,'enUS','','If you long for my blade so badly, then you shall have it!',26124),
(101520,'enUS','','So... cold....',26124),
(101521,'enUS','','Vengeance for the brood queen!',26124),
(101522,'enUS','','Protect the eggs at all costs.',26124),
(101523,'enUS','','No... Tyranna is dead!',26124),
(101524,'enUS','','You will make a satisfying meal.',26124),
(101525,'enUS','','You made a terrible mistake coming here.',26124),
(101526,'enUS','And to what end?','',26124),
(101527,'enUS','A ruse to study their prey here in safety.','',26124),
(101528,'enUS','And what was my reward?  Eternal torment from my \"sisters.\"','',26124),
(101529,'enUS','','Can you say the same as you stand there intoxicated with the power of the Legion?',26124),
(101530,'enUS','I will slay you and all your kin; and when I\'m done I will fulfill the dreams of my mentor.','',26124),
(101537,'enUS','','You do not realize that you\'re groping in the darkness! Felo\'melorn would be wasted in your hands!',26124),
(101538,'enUS','Ain\'t no way these demons are taking o\'er our land! Not while I\'m in charge!','',26124),
(101539,'enUS','Pity... that wretched shardling isn\'t moving? Its death was neither quick nor painless, I assure you.','',26124),
(101542,'enUS','Be careful out here, $n! Wouldn\'t want a fine $c like yourself to get hurt!','',26124),
(101545,'enUS','You defeated a few of our weakest fighters... no matter. When the fel blood courses fully through our veins, even that precious artifact of yours won\'t do us harm.','',26124),
(101558,'enUS','','Foolish mortal! You should have fled when you had the chance.',26124),
(101559,'enUS','Hup Hup, Pimento! $ct $p requires our aid!','',26124),
(101560,'enUS','Count your days numbered, dragons of fire and flame. Today you fall to Maximillian of Northshire! And $ct $p!','',26124),
(101561,'enUS','By Doloria\'s grace, I have arrived my $ct! What dragon dares threaten your greatness?','',26124),
(101562,'enUS','What ho, oh illustrious and impenetrable $ct $p? I am forever in your service.','',26124),
(101563,'enUS','There will be many festivities after we are through. For the Silver Hand!','',26124),
(101564,'enUS','Fear not, townsfolk. Adventure has arrived!','',26124),
(101566,'enUS','By the golden fields of Westfall - what strange land do you brave this time, oh $ct?','',26124),
(101567,'enUS','A thousand blessings upon you, my highlord. If you need me, I will be in the wondrous Goldshire inn.','',26124),
(101568,'enUS','The skies are looking pretty grim. Be careful out there!','',26124),
(101569,'enUS','<The ground here roils and rumbles alarmingly beneath your feet. Perhaps a shaman could be brought here to soothe the restless earth?>','',26124),
(101570,'enUS','An inglorious stain upon the Sunstrider name has been cleansed. Good work, hero!','',26124),
(101571,'enUS','Let\'s go... before the Lich King decides we\'ve overstayed our welcome. I must plead my case before the council.','',26124),
(101572,'enUS','Feeding Time!','',26124),
(101573,'enUS','<The ground here is in torment and rumbles alarmingly beneath your feet. As a shaman you can perform a ritual to draw out and soothe the angry earth spirits... but you should be ready for a fight.>','',26124),
(101574,'enUS','<Perform the earth ritual.>','<Perform the earth ritual.>',26124),
(101575,'enUS','Attack!!','',26124),
(101576,'enUS','Well, looky at what kind of beasty we have \'ere!','',26124),
(101577,'enUS','My target, lads!','',26124),
(101578,'enUS','Be careful here. This isn\'t a spot I want to be in until it\'s all clear.','',26124),
(101579,'enUS','This isn\'t the place to be now. I\'ll come back when it\'s safe.','',26124),
(101580,'enUS','Boys, boys - we have to stay calm. As much as we hate to admit it, these Hunters are quite the help in holding the quarry.','',26124),
(101581,'enUS','I know it\'s a nuisance sharing the camp, but we have to work together or we\'ll have nothing left!','',26124),
(101582,'enUS','I assure you - they\'ll be on their way as soon as these demons are taken care of.','',26124),
(101583,'enUS','The sooner they\'re both gone, the better! This camp\'s hardly big \'nuff for us!','',26124),
(101584,'enUS','If I hadn\'t the cough keepin\' me down, I\'d be out there fightin\' as well!','',26124),
(101585,'enUS','Not gonna lose our lands to the damn demons, thats fer sure!','',26124),
(101586,'enUS','You said it!','',26124),
(101587,'enUS','Too many new faces, if ya ask me.','',26124),
(101588,'enUS','All this fussin\'. What we need is fightin\'!','',26124),
(101589,'enUS','I... I don\'t remember what happened.','',26124),
(101590,'enUS','','Safe travels, $n.',26124),
(101591,'enUS','','Use my tanning rack and workbench to craft everything. You\'ll find a solution for tanning on my bench as well.',26124),
(101592,'enUS','','I hope you held on to your materials, you\'ll need them for the final version of those boots.',26124),
(101593,'enUS','','Azoran must die...',26124),
(101594,'enUS','Your flesh will feed my pets!','',26124),
(101595,'enUS','','My glaives have gone too long without tasting demon blood...',26124),
(101596,'enUS','Receive my blessing and carry with you the wisdom of ages yet to pass.','',26124),
(101597,'enUS','','This ends now!',26124),
(101598,'enUS','Smite down all those who would destroy this world. Burn them in righteous fire!','',26124),
(101599,'enUS','Worry not, my children. We will stand by you in the dark times to come.','',26124),
(101600,'enUS','Be lifted by my power - leave no boundary uncrossed!','',26124),
(101601,'enUS','You who dares brave the trials ahead - I bestow upon you the ephemeral power of creation!','',26124),
(101602,'enUS','I will protect all who stand in Azeroth\'s defense. You shall not fall this day!','',26124),
(101603,'enUS','','Mayla, child, the Underking has destroyed Riverbend.',26124),
(101604,'enUS','','Thank you champion. We should be safe now. Come, let us speak with Mayla.',26124),
(101605,'enUS','We can\'t let them reach the Gates!','We can\'t let them reach the Gates!',26124),
(101606,'enUS','For the Alliance!','For the Alliance!',26124),
(101607,'enUS','Thanks! Yer quite the $c, aren\'t ya.','Thanks! Yer quite the $c, aren\'t ya.',26124),
(101608,'enUS','We usually invite our guests in with a pint, but for the demons I\'ll be sharing the pointy end of me blade instead.','We usually invite our guests in with a pint, but for the demons I\'ll be sharing the pointy end of me blade instead.',26124),
(101609,'enUS','Today will not be my last!','Today will not be my last!',26124),
(101610,'enUS','I\'ve ne\'er seen anything like this before!','I\'ve ne\'er seen anything like this before!',26124),
(101611,'enUS','Sharpen your blades, $n. This fight ain\'t over yet.','Sharpen your blades, $n. This fight ain\'t over yet.',26124),
(101612,'enUS','','Are you here to add to our stores? If you have any meat, make sure it\'s not salted. Trand says salted meat spoils faster.',26124),
(101613,'enUS','','Sure, you may think our hats look silly, but they will help us adapt to the flooding of the world quickly!',26124),
(101614,'enUS','I will protect us from whatever monstrosities lie under the sea!','',26124),
(101615,'enUS','Namha asked me to talk to you about mount barding.','Namha asked me to talk to you about mount barding.',26124),
(101616,'enUS','','They are behaving like children.$B$BStill, I knew this was coming. They might as well work out their differences now.',26124),
(101617,'enUS','This ominous golem seems to be deactivated. You are drawn to a button on it\'s back. Do you press it?','',26124),
(101619,'enUS','','The Pool of Judgment can remind Kayn and Altruis of our past... a shared past forged by Lord Illidan himself.',26124),
(101620,'enUS','','Oh! Yes, well, you see, the problem that adventurers keep whining about is that their mounts will occasionally buck them from their saddles when hostile creatures attack.$b$bI told them to stop running through wild packs of animals, but apparently that\'s \"not the fastest way to travel.\"$b$bSo, I figured if I couldn\'t convince them to stick to the roads, then perhaps it would be easier to build some armor for their mounts to protect them from all the attacks.$b$bThe major things we need to protect are the head, the neck and the body. In other words... pretty much everything.',26124),
(101621,'enUS','I\'ve acquired all the leather. What\'s next?','I\'ve acquired all the leather. What\'s next?',26124),
(101622,'enUS','','Excellent work, $n. Here are the recipes for each piece of the barding as well as the final barding recipe. Good luck!',26124),
(101623,'enUS','Thank you, shaman. Without you, this world would succumb to chaos.','',26124),
(101624,'enUS','I thought I was down for good. You have my thanks.','I thought I was down for good. You have my thanks.',26124),
(101625,'enUS','I must fall back!','I must fall back!',26124),
(101626,'enUS','You have saved my life. I will not forget this.','You have saved my life. I will not forget this.',26124),
(101627,'enUS','Thank you, priest.','Thank you, priest.',26124),
(101628,'enUS','We must save the others!','We must save the others!',26124),
(101629,'enUS','My spellstone... someone please... use it to carry on my work...','',26124),
(101630,'enUS','Don\'t you die on me!','Don\'t you die on me!',26124),
(101631,'enUS','Light heal your wounds!','Light heal your wounds!',26124),
(101632,'enUS','Your wounds are great in number.','Your wounds are great in number.',26124),
(101633,'enUS','Hang in there, soldier. Evac is coming soon.','Hang in there, soldier. Evac is coming soon.',26124),
(101634,'enUS','','The wounds inflicted by the Divine Bell incident run deep, Aethas. Others in the council are not as forgiving as I.',26124),
(101635,'enUS','','Your master, demon. Where does he hide?',26124),
(101636,'enUS','But with the Legion\'s coming, I decided to begin my own search for the location of the blade. I saw a vision of Lyandra with the weapon in hand. Around her the land was covered in ice, and an all-too-familiar fortress loomed behind her.','',26124),
(101637,'enUS','','Icecrown. You believe you\'ll find her there?',26124),
(101638,'enUS','Indeed I do. And nothing happens in that citadel unless its master wills it. I would not be surprised to learn he had a hand in this.','',26124),
(101639,'enUS','Free at last! Let us defeat this evil!','',26124),
(101640,'enUS','There is no convincing you, I see. Very well, I will take my leave. $n, beware that you do not share Illidan\'s fate.','',26124),
(101641,'enUS','You will trust the traitor? I can do no more here.','',26124),
(101642,'enUS','Alar il raka Azoran il zennrakkan oth kamilgolad! Morgul... morgul!','',26124),
(101643,'enUS','','Mercy? The legion burns worlds... and you beg mercy?',26124),
(101644,'enUS','','A swift death is more mercy than you deserve.',26124),
(101645,'enUS','','I will bring your case before the others... but I cannot promise the outcome will be in your favor.',26124),
(101646,'enUS','You have my thanks, friend.','',26124),
(101647,'enUS','<The broken mystic barely clings to life.>\n\nI am as good as dead. Do... what must... be done.','',26124),
(101648,'enUS','Mystic, thank you for your sacrifice.','Mystic, thank you for your sacrifice.',26124),
(101649,'enUS','<The corpse of the Ashtongue Mystic lies here bereft of its soul, which has powered the Legion Gateway.>','',26124),
(101650,'enUS','The brood queen must have done something to this gateway. Not even the souls of several mo\'arg were enough to unlock it.\n\nThe soul of a demon hunter, however, would do the trick. You have a choice to make, $n...\n\n... One of us must die.','',26124),
(101651,'enUS','Sevis, I need to sacrifice you in order to power the final gateway.','Sevis, I need to sacrifice you in order to power the final gateway.',26124),
(101652,'enUS','I want you to sacrifice me in order to power the gateway.','I want you to sacrifice me in order to power the gateway.',26124),
(101653,'enUS','It has been... an honor.','',26124),
(101654,'enUS','<Sevis paid the ultimate price so that you could use the Legion Gateway and summon in your Shivarra forces.>\n\n<Don\'t allow his sacrifice to have been made in vain.>','',26124),
(101655,'enUS','Your sacrifice will NOT be in vain!','',26124),
(101656,'enUS','Plenty of souls were sacrificed here. The activator is powered.','',26124),
(101657,'enUS','I will move ahead and find Allari.','',26124),
(101658,'enUS','$n, hurry! You don\'t have much time.','',26124),
(101659,'enUS','Sevis looks down at the dying broken mystic.','',26124),
(101660,'enUS','This Ashtongue mystic will willingly sacrifice his soul for the cause if you\'re the one to do it.','',26124),
(101661,'enUS','He was brave and proved himself worthy. We should all be so lucky to make the ultimate sacrifice in Lord Illidan\'s name.','',26124),
(101662,'enUS','I will see you at the final gateway.','',26124),
(101663,'enUS','$n, we have a huge problem here.','',26124),
(101664,'enUS','You will be the one dying today, demon!','',26124),
(101665,'enUS','I\'ve been looking forward to this for a long time.','',26124),
(101666,'enUS','For Lord Illidan! For the Illidari!','',26124),
(101667,'enUS','You and me to the very end, $n.','',26124),
(101668,'enUS','Thank you again for sparing my life. I trust you know that I\'d willingly sacrifice everything to further Lord Illidan\'s plan. The Burning Legion must be destroyed at any cost.\n\nI owe you everything, $n.\n\nNow, you must tell me how you survived. I killed you! It would seem the rumors about you are true... you\'re nearly as powerful as Illidan.','',26124),
(101669,'enUS','First troggs, now this? No matter. The mountaineers fight \'til the end!','',26124),
(101670,'enUS','When this is over, the boar ribs and malt are on me.','',26124),
(101671,'enUS','','To arms, $n. This is not the time to be wandering about. Take shelter inside if you must.',26124),
(101672,'enUS','','Apologies, but now is not the time $c.',26124),
(101677,'enUS','My apologies, but now is not the time, $n.','My apologies, but now is not the time, $n.',26124),
(101678,'enUS','Find shelter! The others have gone inside for safety!','Find shelter! The others have gone inside for safety!',26124),
(101679,'enUS','I\'ve never seen an attack quite like this!','I\'ve never seen an attack quite like this!',26124),
(101680,'enUS','So many injured already. Will you be the one who ends it, $n?','So many injured already. Will you be the one who ends it, $n?',26124),
(101681,'enUS','The skies... have you ever seen anything like it?','The skies... have you ever seen anything like it?',26124),
(101682,'enUS','Careful, $n. I just saw an infernal fall from the skies!','Careful, $n. I just saw an infernal fall from the skies!',26124),
(101683,'enUS','Have you seen them, $n? The demons... I just saw a shopkeep run by screaming! This is madness!','Have you seen them, $n? The demons... I just saw a shopkeep run by screaming! This is madness!',26124),
(101684,'enUS','<The vrykul is bloody and is barely breathing.>','',26124),
(101685,'enUS','Cenarius, the Lord of the Forest.$b$bNever have I seen him in such a state. Stay vigilant, friend. Our fragile world has been plunged into deep peril.','',26124),
(101686,'enUS','The airfield is under attack! Demons are everywhere. I\'ve sent the best of our fleet to hold \'em off.$B$BKeep at it down here! You\'re the best chance we\'ve got!','',26124),
(101687,'enUS','Not today, friend. Gotta finish helpin\' me lads reinforce our wares.','',26124),
(101688,'enUS','I owe you a great debt, $n. Thank you once again.','',26124),
(101689,'enUS','Fly me to the Ironforge Airfield.','Fly me to the Ironforge Airfield.',26124),
(101691,'enUS','','Let\'s keep hunting!',26124),
(101692,'enUS','I\'m just trying to keep everyone fed until it\'s all over.','',26124),
(101693,'enUS','If those demons see you it\'s already too late.','',26124),
(101694,'enUS','Ye\'ve got ta calm yerself. We\'ve got the best in the lands out fightin\' right now.','Ye\'ve got ta calm yerself. We\'ve got the best in the lands out fightin\' right now.',26124),
(101695,'enUS','Just try and relax. We\'re all in this together.','Just try and relax. We\'re all in this together.',26124),
(101696,'enUS','Die!','',26124),
(101697,'enUS','Getting worked up won\'t help anyone. We have to try and stay calm.','Getting worked up won\'t help anyone. We have to try and stay calm.',26124),
(101698,'enUS','We\'re down here underground while the whole world\'s bein\' torn apart!','',26124),
(101699,'enUS','Did ya see those things? How are we gonna defend against that?','',26124),
(101700,'enUS','How are we s\'pposed to stay calm? We\'re under attack!','',26124),
(101701,'enUS','Brandolf will sacrifice himself to kill Mal\'kess.','Brandolf will sacrifice himself to kill Mal\'kess.',26124),
(101702,'enUS','Ironic, isn\'t it?','',26124),
(101703,'enUS','Can\'t say I\'ve ever been hit so hard before.','',26124),
(101704,'enUS','That\'s gonna leave a scar.','',26124),
(101705,'enUS','I\'m a cook, not a first aid trainer.','',26124),
(101706,'enUS','Looks ok to me, but then again, I work with raw meat all day. For all I know it could be really bad.','',26124),
(101707,'enUS','At least you\'re alive.','',26124),
(101708,'enUS','Cold! No good cold! Hate hate hate.','',26124),
(101709,'enUS','Esteemed Archmages of the Council, may I present to you $n, bearer of Felo\'melorn.','',26124),
(101710,'enUS','I am ready to aid you, Malfurion.','I am ready to aid you, Malfurion.',26124),
(101711,'enUS','','You cannot escape justice!',26124),
(101712,'enUS','You will not defile this keep!','',26124),
(101713,'enUS','May your soul feel the same torment as ours!','',26124),
(101714,'enUS','Fire good, cold bad! Very bad cold.','',26124),
(101715,'enUS','Inscribe your name into the Libram of Ancient Kings so that we may begin the ceremony.','',26124),
(101717,'enUS','','Brandolf! You resilient pup! I thought I was going to rot in that cage. Who is this $r?',26124),
(101718,'enUS','Why did you kick me, you mongrel of Fenrir?','',26124),
(101719,'enUS','Brandolf? So, the little pup sniffed me out in this cave, eh?','',26124),
(101720,'enUS','Where\'s Torok?','',26124),
(101721,'enUS','You little pup! I see you have grown some sharp fangs.','',26124),
(101722,'enUS','Namha told me you had some new pet toy ideas?','Namha told me you had some new pet toy ideas?',26124),
(101723,'enUS','Puny creature. I will grind you into the sand!','',26124),
(101724,'enUS','Free!','',26124),
(101725,'enUS','The Tidemistress will end your pathetic lives.','',26124),
(101726,'enUS','','Leather pet toys? Let\'s see, now... a new leash might be nice. And I know the pets would appreciate a nice, soft bed to rest on.$b$bI\'ve always dreamed of fashioning a hoop for them to jump through. Preferably something we can light on fire. That would be quite the trick!',26124),
(101727,'enUS','','Leather pet toys? Let\'s see, now... a new leash might be nice. And I know de pets would appreciate a nice, soft bed to rest on.$b$bI\'ve always dreamed of fashioning a hoop for them to jump through. Preferably something we can light on fire. Dat would be quite de trick!',26124),
(101728,'enUS','You\'ll never take me alive!','',26124),
(101729,'enUS','I\'m unleashed! One thousand years of darkness begins!','',26124),
(101731,'enUS','Interesting. Like me, you have an immortal demon soul.','',26124),
(101732,'enUS','You cannot truly die. Instead, your soul will make its way to the Twisting Nether. There, you will wait until you can find a suitable body to inhabit.','',26124),
(101733,'enUS','Now get back into your corpse while there is still time and bring me the keystone!','',26124),
(101734,'enUS','Does such weakness pass as strength where you come from, $n?','',26124),
(101735,'enUS','Hahahaha!','',26124),
(101736,'enUS','A cheap trick, calling for reinforcements... You\'re unworthy of this mountain!','',26124),
(101738,'enUS','Navarrogg\'s toy won\'t do him any good against me.','',26124),
(101739,'enUS','','You will die in the name of the Sashj\'tar!',26124),
(101740,'enUS','','Jandvik will fall!',26124),
(101741,'enUS','','As you can see, our former colleague followed through on his promise of assistance. I trust you will take that into account as you consider his request to be allowed back in the city.',26124),
(101742,'enUS','If he wished to use the blade for his own ends, he would have simply given it to one of his Sunreavers.','',26124),
(101743,'enUS','Aethas\'s actions appear to be genuine. I say we grant his request.','',26124),
(101744,'enUS','How do we know he won\'t betray the Kirin Tor once again?','',26124),
(101745,'enUS','','You have come, just as Emmarel said you would.',26124),
(101746,'enUS','Very well, that\'s two in favor of allowing Aethas back into the city. Ansirem, how do you vote?','',26124),
(101747,'enUS','I am ready to leave for Tideskorn Harbor.','I am ready to leave for Tideskorn Harbor.',26124),
(101748,'enUS','','Glad to see you. We need to stop in Highmountain before our ultimate goal of Stormheim.',26124),
(101749,'enUS','Very well, I trust the wisdom of Karlain\'s council. I vote yes.','',26124),
(101750,'enUS','And what say the rest of you?','',26124),
(101751,'enUS','%s nods approvingly.','',26124),
(101752,'enUS','Yes, of course.','',26124),
(101753,'enUS','Then it is decided. Aethas Sunreaver, you are free to go. Do not misuse this opportunity given to you.','',26124),
(101754,'enUS','Bring her back in one piece!','Bring her back in one piece!',26124),
(101755,'enUS','Take care of it!','Take care of it!',26124),
(101756,'enUS','Go get \'em!','Go get \'em!',26124),
(101757,'enUS','Careful out there!','Careful out there!',26124),
(101758,'enUS','Show \'em who\'s boss!','Show \'em who\'s boss!',26124),
(101759,'enUS','Put that pedal to the metal!','Put that pedal to the metal!',26124),
(101760,'enUS','I will not be contained!','',26124),
(101761,'enUS','You don\'t have the power to stop me!','',26124),
(101762,'enUS','Shh... they\'ll hear you.','Shh... they\'ll hear you.',26124),
(101763,'enUS','They\'ll never see it coming.','They\'ll never see it coming.',26124),
(101764,'enUS','It\'s safer in the shadows, $n.','It\'s safer in the shadows, $n.',26124),
(101765,'enUS','You\'re safe here, just don\'t be the $c that calls attention to yourself.','You\'re safe here, just don\'t be the $c that calls attention to yourself.',26124),
(101766,'enUS','If they come for us, we\'ll be ready.','If they come for us, we\'ll be ready.',26124),
(101767,'enUS','Seen any demons lurking around here?','Seen any demons lurking around here?',26124),
(101768,'enUS','You\'ll never get me back into that crystal!','',26124),
(101769,'enUS','Lord Azoran... how may I serve you?','',26124),
(101770,'enUS','It appears we have guests, Vorgos... deal with them.','',26124),
(101771,'enUS','My plan to destroy that wretched, floating city must not be disrupted!','',26124),
(101772,'enUS','As you wish, Master!','',26124),
(101773,'enUS','Do not fail me, Vorgos... you know what I do to those who fail me.','',26124),
(101774,'enUS','','That was easier than expected. Most of the kvaldir must be off raiding.',26124),
(101775,'enUS','Did you two have a plan?','Did you two have a plan?',26124),
(101776,'enUS','','Wuho! Have you found the monster?',26124),
(101777,'enUS','Not yet, but it is indeed the foe we seek. The kvaldir here speak of a giant cat that made its lair in the deep swamps. They raised a wall of magic wards to keep it at bay.','',26124),
(101778,'enUS','','We must find a way through! Wuho, you and I should examine the wards while $n searches the harbor.',26124),
(101779,'enUS','Mount up, $n. The Legion is not playing around. They\'ve unleashed their devastators.','',26124),
(101780,'enUS','We barely made it through. Most of us, anyway. We\'re under bombardment up here, too.','',26124),
(101781,'enUS','','Are you blind? Kill them!',26124),
(101782,'enUS','Think they can just waltz in here without us putting up a fight? Me and my mechanostriders will see about that!','',26124),
(101783,'enUS','','Next infernal that falls better not hit another strider. We\'re running short on supplies!',26124),
(101784,'enUS','','If I see one more strider get destroyed today I\'m gonna... I\'m gonna... Trust me - something bad will happen!',26124),
(101785,'enUS','','These could take years to fix!',26124),
(101786,'enUS','','Who do they think they are coming in here, destroying our stuff, attacking the innocent - somebody needs to teach those demons a lesson...',26124),
(101787,'enUS','','Destroyed my striders, singed my hair - if I see one more of those infernals I\'m gonna kick it in it\'s shins... if it has shins. If it doesn\'t I\'ll start throwin\' wrenches.',26124),
(101788,'enUS','','Hopefully this ends soon. I\'ve got some work cut out for me.',26124),
(101789,'enUS','Fishes get in the bucket! You make good rotbrew!','',26124),
(101790,'enUS','Tasty, tasty Dwarves... Your gate won\'t hold forever!','',26124),
(101791,'enUS','Tiny Dwarves so foolish. Your bars and stone will not protect you.','',26124),
(101792,'enUS','<The elemental gestures pleadingly at you and motions toward the hungry sharks encircling it. It speaks in a language you can\'t understand. Perhaps you can bring a shaman here to translate?>','',26124),
(101793,'enUS','<The elemental peers down at you treading water.>$b$bWhy, hello shaman! You are truly touched by the elements.$b$bCome, walk upon the water with me, so we may speak as equals. I need your help.$b$b<The elemental looks warily at the sharks encircling it.>','',26124),
(101794,'enUS','Hail, Highlord.','Hail, Highlord.',26124),
(101795,'enUS','Hail, Highlord.','Hail, Highlord.',26124),
(101796,'enUS','Light bless you, $n. Azeroth would be lost to the Legion if it weren\'t for you.','Light bless you, $n. Azeroth would be lost to the Legion if it weren\'t for you.',26124),
(101797,'enUS','Hail, Highlord.','Hail, Highlord.',26124),
(101798,'enUS','Light bless you, $n. Azeroth would be lost to the Legion if it weren\'t for you.','Light bless you, $n. Azeroth would be lost to the Legion if it weren\'t for you.',26124),
(101799,'enUS','Light bless you, $n. Azeroth would be lost to the Legion if it weren\'t for you.','Light bless you, $n. Azeroth would be lost to the Legion if it weren\'t for you.',26124),
(101800,'enUS','Hail, Highlord.','Hail, Highlord.',26124),
(101801,'enUS','Light bless you, $n. Azeroth would be lost to the Legion if it weren\'t for you.','Light bless you, $n. Azeroth would be lost to the Legion if it weren\'t for you.',26124),
(101802,'enUS','<The ancient sea spirit speaks to you with warmth and respect.>$b$bShaman, turmoil in these seas has sapped me of my life essence and scattered it throughout the bay. It is driving these young sharks into a frenzy.$b$bWaterwalk across the waves and collect 10 globules of living water. Beware the sharks - if they drag you into the water you will lose what you have collected.','',26124),
(101803,'enUS','<The ancient sea spirit bows deeply.>$b$bThank you, shaman. You are truly a gift to the elements of Azeroth.','',26124),
(101804,'enUS','|TInterface\\Icons\\Spell_Shadow_UnholyFrenzy:20|tWarlord Parjesh |cFFFF0000|Hspell:197064|h[Enrages]|h|r!','',26124),
(101805,'enUS','A new Treasure has been added to your map!','A new Treasure has been added to your map!',26124),
(101806,'enUS','I carry on our traditions until one comes that can take my place.','',26124),
(101807,'enUS','Grant me vision, and I will restore your spirit.','Grant me vision, and I will restore your spirit.',26124),
(101808,'enUS','Load \'em up! I\'ll be dead \'fore we let \'em through!','',26124),
(101809,'enUS','','I may be cursed, but I can still teach others what I knew when I was alive.',26124),
(101810,'enUS','Hands tired from loadin\' rounds? Good! Keep \'em working. It\'s our blood or theirs!','',26124),
(101811,'enUS','Fire again! Hit \'em hard!','',26124),
(101812,'enUS','Don\'t stop until you can\'t move or yer gun stops workin\' - then you can use yer fists!','',26124),
(101813,'enUS','This lodging is deplorable. I really must have a word with the innkeeper when he returns...','',26124),
(101814,'enUS','So he says to me, he goes,\"Demons are coming up number one on the agenda for hot pants! They\'re smoking!\"','',26124),
(101815,'enUS','<Stalriss incomprehensibly mumbles.>','',26124),
(101816,'enUS','Incoming!','',26124),
(101817,'enUS','Short fuse on its way out!','',26124),
(101818,'enUS','Mortar out!','',26124),
(101819,'enUS','Walk atop the sea and collect the living water! I have granted you enhanced sight so that you can better see the dangers that surround you.$b$bReturn to me when you have collected 10 globules of water...','',26124),
(101820,'enUS','','Big one goin\' out! Cover your ears!',26124),
(101821,'enUS','','Short fuse \'bout to burn!',26124),
(101822,'enUS','','Last one fragged before impact - reloading!',26124),
(101823,'enUS','\"We shall drink of the Well again.\"','\"We shall drink of the Well again.\"',26124),
(101824,'enUS','Thank you shaman! I feel my strength returning. Go with my blessing upon your weapon, and preserve the dignity of Azeroth\'s elements!','',26124),
(101825,'enUS','<The Nightborne regards you with suspicion.>$b$b If you are here for a fight, you are most foolish.. Leave now before I call the patrols and the might of Suramar puts an end to you!','',26124),
(101826,'enUS','Looks like we\'ve got \'em boys! Just that big one left then we can go ho -','',26124),
(101827,'enUS','What... what\'s that?','',26124),
(101828,'enUS','Lads, lasses - plant yer boots in the snow - this is gonna get messy!','',26124),
(101829,'enUS','Somethin\'s rumblin\' and it ain\'t me tum!','',26124),
(101830,'enUS','%s moves his hands slowly over his belly.','',26124),
(101831,'enUS','Youuuu DARE disrupt the portalsss of the Legion?','',26124),
(101832,'enUS','An Unpowered Legion Portal has been added to your map!','An Unpowered Legion Portal has been added to your map!',26124),
(101833,'enUS','Always knew we could count on ye, champions! Come and see me when ye can. We\'ve got some supplies at our camp for ye!','',26124),
(101834,'enUS','Quite a bunch o\' fighters, aren\'t ye! Just a bit more cleanin\' up ta do!','',26124),
(101835,'enUS','Something stirs in the shallows. It may be the beast! Activate the wardstones!','',26124),
(101836,'enUS','Quite the fighters, aren\'t ye! We can\'t thank ye enough. Just a bit more cleanin\' up ta do then ye come and see old Khrim fer some special supplies!','',26124),
(101837,'enUS','Bah! I grow weary of your errands, old one!','',26124),
(101838,'enUS','<The desperate earth elemental gestures wildly at you, with rocks and pebbles flying in all directions. It speaks in a low rumble, growling words you can\'t understand. Perhaps a shaman can be brought here to investigate?>','',26124),
(101839,'enUS','<The ancient earth elemental is in great distress. It calls out to you:>$b$bPlease shaman! They... are silencing me...$b$bThe angry spirits... can you not see them?$b$bCrushing... me...','',26124),
(101840,'enUS','Show me your tormentors, and I will help!','Show me your tormentors, and I will help!',26124),
(101841,'enUS','','You are under my control now, demon. You will obey.',26124),
(101842,'enUS','I\'ve got yer mail patterns here, $n, if you\'re looking to buy!','',26124),
(101843,'enUS','My master will have your soul!','',26124),
(101844,'enUS','You chose the wrong side, $r.','',26124),
(101845,'enUS','Today will be your last!','',26124),
(101846,'enUS','This world will end!','',26124),
(101847,'enUS','The Light will guide us to victory.','',26124),
(101848,'enUS','I would like to review weapons we might pursue.','I would like to review weapons we might pursue.',26124),
(101849,'enUS','','We were just about to come find you. The wards block off the whole northern shallows.',26124),
(101850,'enUS','Don\'t worry, I have a solution.','Don\'t worry, I have a solution.',26124),
(101851,'enUS','%s cowardly scurries away.','',26124),
(101852,'enUS','%s panics and runs.','',26124),
(101853,'enUS','%s runs away.','',26124),
(101854,'enUS','','Ah, you found something in that nightmarish village?',26124),
(101855,'enUS','<Show Apata the runes and explain how to cross the river.>','<Show Apata the runes and explain how to cross the river.>',26124),
(101856,'enUS','','Judge me all you like, sister, but you cannot stop us.',26124),
(101857,'enUS','You are too late, Warden. This vault will be your tomb.','',26124),
(101859,'enUS','','Demon hunters, you have to survive. Find the one named Archmage Khadgar. You can trust him.',26124),
(101860,'enUS','','Wonderful! I can just attach them here and...',26124),
(101861,'enUS','','Illidan is still my charge!',26124),
(101862,'enUS','','It is done. Let us go across!',26124),
(101863,'enUS','|TINTERFACE\\ICONS\\ability_socererking_arcanereplication.blp:20|t $n is marked with |cFFF00000|Hspell:196562|h[Volatile Magic]|h|r!','|TINTERFACE\\ICONS\\ability_socererking_arcanereplication.blp:20|t $n is marked with |cFFF00000|Hspell:196562|h[Volatile Magic]|h|r!',26124),
(101864,'enUS','|TInterface\\Icons\\Spell_Shadow_SiphonMana.blp:20|t%s begins to |cFFF00000|Hspell:196392|h[Consume Mana]|h|r from a Mana Source!','|TInterface\\Icons\\Spell_Shadow_SiphonMana.blp:20|t%s begins to |cFFF00000|Hspell:196392|h[Consume Mana]|h|r from a Mana Source!',26124),
(101865,'enUS','','Hurry, then. The Wardens are coming, with the Illidari in tow.',26124),
(101866,'enUS','They ARE desperate.','',26124),
(101867,'enUS','','My eldest sister, Alleria, has been missing for years. A demon we captured claims she is being held on a Legion world called Niskara by some sort of inquisition. Her return would be invaluable!',26124),
(101868,'enUS','','Deprecated',26124),
(101869,'enUS','','Alleria\'s knowledge about the Legion could help us defeat them once and for all. Our goal is to reacquire a strategic asset... nothing more!',26124),
(101870,'enUS','Admit it, Vereesa! This mission is personal!','',26124),
(101871,'enUS','','There, up ahead! It\'s Orestes!',26124),
(101872,'enUS','','You have done much for my people, $p. It is an honor to have you with us on this battlefront today.$b$bReady to face off against the Underking?',26124),
(101873,'enUS','I\'m glad you could join us, $p.','',26124),
(101874,'enUS','Charge!','Charge!',26124),
(101875,'enUS','','We are discovered. Destroy $ghim:her;!',26124),
(101876,'enUS','I should be going with you. If this is a trap, you need my bow covering your backs!','',26124),
(101877,'enUS','','No, Orestes. I won\'t risk anyone else until we\'re certain Alleria\'s there. I do not trust the demon\'s word. But this might be our only chance to save my... to retrieve a valuable ally.',26124),
(101878,'enUS','We\'ve got it cornered, boys!','',26124),
(101879,'enUS','They\'ll let us into the lodge for sure if we bring \'em this lion\'s head as a trophy!','',26124),
(101880,'enUS','','Please, you don\'t understand... I\'m not game to be hunted!',26124),
(101881,'enUS','Hey there.','',26124),
(101882,'enUS','No, NO! I wasn\'t escaping! I was just going a different spot to dig!','',26124),
(101883,'enUS','Please don\'t hurt me!','',26124),
(101884,'enUS','Stop them before they take me back!','',26124),
(101885,'enUS','Take me to Gol\'Bolar Quarry!','Take me to Gol\'Bolar Quarry!',26124),
(101887,'enUS','Take me to Frostmane Front!','Take me to Frostmane Front!',26124),
(101888,'enUS','Take me to the Gates of Ironforge!','Take me to the Gates of Ironforge!',26124),
(101889,'enUS','Take me to Gol\'Bolar Quarry!','Take me to Gol\'Bolar Quarry!',26124),
(101890,'enUS','','Almost there! Keep fighting!',26124),
(101891,'enUS','','The inquisitor must be coming to interrogate Alleria! We have to save her!',26124),
(101892,'enUS','','If Alleria is here, she must be close!',26124),
(101894,'enUS','Sure is a lot bigger than the machines I\'m used to workin\' with.','',26124),
(101895,'enUS','Shoulda negotiated a higher rate. This thing is ginormous!','',26124),
(101896,'enUS','Surprised I got one working already. These things aren\'t built like anything I\'ve worked on before.','',26124),
(101897,'enUS','Surprised I got one working already. These things aren\'t built like anything I\'ve worked on before.','',26124),
(101898,'enUS','Well this coil does nothing. Hope you don\'t mind if I just throw it on the floor here.','',26124),
(101899,'enUS','Ah, yep. This part\'s busted too. This could be a while, gents.','',26124),
(101900,'enUS','Oy... these demons are ruinin\' mah huntin\' getaway. May as well start huntin\' them for the trouble they\'re causin\'.','',26124),
(101901,'enUS','Follow us and we can work together to retake the airfield! Scrapper, let\'s go!','',26124),
(101902,'enUS','No... you cannot have the power.','',26124),
(101903,'enUS','This is as far as we go. Thanks for helpin\'. This hunter never forgets a friend.','',26124),
(101904,'enUS','An ambush! You were followed!','',26124),
(101905,'enUS','I\'ve finally found you, little elf. You are not worthy of being our equal!','',26124),
(101906,'enUS','Stay back! It\'s mine!','',26124),
(101907,'enUS','Thieves! The mana is MINE!','',26124),
(101908,'enUS','No! I will not succumb!','',26124),
(101909,'enUS','Get away from my mana!','',26124),
(101910,'enUS','Go away!','',26124),
(101911,'enUS','I will not be consumed!','',26124),
(101912,'enUS','I warned you!','',26124),
(101913,'enUS','Thieving wretch!','',26124),
(101914,'enUS','More... more...','',26124),
(101915,'enUS','No! I need more...','',26124),
(101917,'enUS','When you have gained more strength, come and see me again.','',26124),
(101918,'enUS','Coming!','',26124),
(101919,'enUS','Woops, sorry!','',26124),
(101920,'enUS','Oh, yes - sorry.','',26124),
(101921,'enUS','Sorry! Won\'t happen again!','',26124),
(101922,'enUS','Coming up!','',26124),
(101923,'enUS','Here it comes!','',26124),
(101924,'enUS','One wrench, coming up!','',26124),
(101925,'enUS','','Wrench!',26124),
(101926,'enUS','','Arnie! Wrench!',26124),
(101927,'enUS','','Arnie! Quit diddling around!',26124),
(101928,'enUS','','Hey! This ain\'t the time for sightseeing, kiddo!',26124),
(101929,'enUS','Does your shirt itch? Mine itches... I\'m not sweating either.','',26124),
(101930,'enUS','How much longer you think \'til I\'m ready? I mean, it\'s been almost 3 weeks so far. Starting to consider myself to be quite the apprentice.','',26124),
(101931,'enUS','How do you get all the grime out from under your nails? Mine doesn\'t go away... and it smells funny.','',26124),
(101932,'enUS','This bucket is kinda heavy. If I hold it in this arm too long it falls asleep. My arm, I mean. Not the bucket.','',26124),
(101933,'enUS','Do your glasses get fogged? I don\'t know how to stop it. I only have about half my normal visibility.','',26124),
(101935,'enUS','','This is my fate as well... unless...',26124),
(101936,'enUS','We\'ve got to hold \'em back! Our boys are strugglin\' ta keep \'em outta the Gates!','',26124),
(101937,'enUS','Hold the line! If they break us again we\'ll be pullin\' the troops back!','',26124),
(101938,'enUS','I\'ve ne\'er seen anythin\' like this before. They jus\' don\'t stop comin\'!','',26124),
(101939,'enUS','We\'ve got the higher ground. Use it against \'em!','',26124),
(101940,'enUS','Haven\'t lost a battle yet and I don\'t plan on losin\' one today!','',26124),
(101941,'enUS','For generations, the tauren of this mountain fought. Countless lives--even entire tribes--were lost.','',26124),
(101942,'enUS','Once, upon returning from such a battle, Huln Highmountain found his people slaughtered by a previously unknown foe.','',26124),
(101943,'enUS','Battling his grief, Huln spoke with the leaders of the remaining tribes. He convinced them to unite under one banner to oppose this new threat.','',26124),
(101944,'enUS','I will tell you the story of Huln Highmountain.','',26124),
(101945,'enUS','And now you will bear witness to Huln\'s trials...','',26124),
(101946,'enUS','Take me to the Gates of Ironforge!','Take me to the Gates of Ironforge!',26124),
(101947,'enUS','Take me to Frostmane Front!','Take me to Frostmane Front!',26124),
(101948,'enUS','Highlord, I have found paladins worthy to stand by your side. I will meet you at Light\'s Hope Sanctum at once.','',26124),
(101950,'enUS','Prepare yourself $Glad:lass;. Fight\'s only beginnin\'.','',26124),
(101951,'enUS','We can\'t let them reach the Gates!','',26124),
(101952,'enUS','For the Alliance!','',26124),
(101953,'enUS','Me beard... it\'s... it\'s - they\'re gonna pay fer this!','',26124),
(101954,'enUS','I \'ppreciate it, $n. Now ye best get goin\' \'fore they come back.','',26124),
(101955,'enUS','Tell me the Story of Huln.','Tell me the Story of Huln.',26124),
(101956,'enUS','','You have my thanks. Those hunters wouldn\'t have stopped until they had my head. Whatever they had is yours.',26124),
(101957,'enUS','No... noooo! You shall never be free...','',26124),
(101958,'enUS','... hammered...','',26124),
(101959,'enUS','Crush them, brother!','',26124),
(101960,'enUS','You shake them, I bash them!','',26124),
(101962,'enUS','You\'ve seen better days, friend.','You\'ve seen better days, friend.',26124),
(101963,'enUS','Not right now, $n. There are more pressing matters to attend to.','',26124),
(101964,'enUS','I will pry the answers from your corpse.','',26124),
(101965,'enUS','Escape is but a dream.','',26124),
(101966,'enUS','How do we know you\'re one we can trust? I\'ve heard whispers of dreadlords roaming about.','',26124),
(101967,'enUS','These are fragile times.','',26124),
(101968,'enUS','All hope is lost.','',26124),
(101969,'enUS','You will never see the light of day!','',26124),
(101972,'enUS','Your death will be swift and brutal.','',26124),
(101974,'enUS','You cannot stem the Legion\'s tide!','',26124),
(101975,'enUS','I will cleave you in two!','',26124),
(101976,'enUS','These are the defenders of this world? Pitiful!','',26124),
(101977,'enUS','You shall fall, like the Wardens before you!','',26124),
(101978,'enUS','Combat engineers here! Look out below!','Combat engineers here! Look out below!',26124),
(101979,'enUS','Good as new. This engine packs quite a punch! Try it out on some of those big ones up near the airfield!','Good as new. This engine packs quite a punch! Try it out on some of those big ones up near the airfield!',26124),
(101983,'enUS','','It is... eerily quiet.',26124),
(101984,'enUS','I cannot sense any beasts at all!','',26124),
(101985,'enUS','','And yet, I am certain we are being watched...',26124),
(101986,'enUS','','The beast is there! An\'she protect us!',26124),
(101987,'enUS','Why would Maiev free us? There could only be one reason...','',26124),
(101988,'enUS','The Legion is here.','',26124),
(101989,'enUS','','|TInterface\\Icons\\spell_frost_frozenorb:20|t|cFFFF0000$n|r is the target of |cFFFF0000|Hspell:197365|h[Crushing Depths]|h|r!',26124),
(101991,'enUS','Guardians of the ritual, prepare yourselves! She will not be disappointed!','',26124),
(101992,'enUS','Hmph. Intruders. They will not get far.','',26124),
(101993,'enUS','','Enter the portal and fight your way to Azoran.',26124),
(101994,'enUS','I sit in chair one day.','',26124),
(101995,'enUS','Fool! You would trust the Warden? She hates us almost as much as the Legion.','',26124),
(101996,'enUS','They say only the pure can wield the highblade. Come, champion. Claim your destiny!','',26124),
(101997,'enUS','I dig. I find. I keep!','',26124),
(101998,'enUS','More wax, bigger candle. More candle, less dark.','',26124),
(101999,'enUS','You trust no one and believe in nothing, Altruis. You are a leader with no followers.','',26124),
(102000,'enUS','Why no have candle? Darkness eat you if no have candle!','',26124),
(102001,'enUS','No talk! Must dig!','',26124),
(102002,'enUS','','Defend yourselves!',26124),
(102004,'enUS','','How can you defeat me while I control the wilds!?',26124),
(102005,'enUS','I don\'t know why you thought you had something to prove. You coulda been back out there in your tanks by now.','',26124),
(102006,'enUS','Just hang tight. I\'m used to fixing mechanical things, not dwarves.','',26124),
(102007,'enUS','Where\'s Maxon? He should probably take a look at you before you head back out.','',26124),
(102008,'enUS','','The power to destroy you!',26124),
(102009,'enUS','','More... I need more!',26124),
(102010,'enUS','The inhabitants of The Crossroads have been inspired to join the fight against the Legion!','',26124),
(102011,'enUS','Interloper... you\'re here to steal my mana, aren\'t you!?','',26124),
(102012,'enUS','Here, then. Have a taste!','',26124),
(102013,'enUS','Picking off my lieutenants? I suppose you think you\'re clever.','',26124),
(102014,'enUS','Ishkaneth, you fool. You\'ve spilled your blood and you\'ve spilled my mana.','',26124),
(102015,'enUS','Another soul for the Legion.','',26124),
(102016,'enUS','All mortals will fuel the Soul Engines.','',26124),
(102017,'enUS','','I worry for Oro\'s safety, but he has a duty to protect our tribe.',26124),
(102018,'enUS','Let\'s see how you deal with this!','',26124),
(102019,'enUS','No! Protect me!','',26124),
(102020,'enUS','','Let\'s go.',26124),
(102021,'enUS','Did that dragon send you, interloper? Or was it that beggar, Runas?','',26124),
(102022,'enUS','I fought as hard as the rest of you! But I did not murder thousands of innocents.','',26124),
(102023,'enUS','No matter. Soon you will all kneel before Azsuna\'s new prince!','',26124),
(102024,'enUS','Wait, what are you doing? My siphons!','',26124),
(102025,'enUS','You lowborn dirt. You don\'t know who you\'re dealing with. Hah... hah... haaaa ha ha ha haaaa!','',26124),
(102026,'enUS','CUT SCENE PLACEHOLDER - Elune weeps over the death of Ysera and you get the tear of Elune.','CUT SCENE PLACEHOLDER - Elune weeps over the death of Elune and you get the tear of Elune.',26124),
(102027,'enUS','','It went into that deep patch of mist. It could be hiding anywhere! Hero, do you have a trap strong enough to hold the beast?',26124),
(102028,'enUS','Perhaps something explosive to disperse the mist? We are right behind you, master trapper. We will stand guard as you set it.','',26124),
(102029,'enUS','Gaardoun?','',26124),
(102030,'enUS','','Oro, how many times do I have to tell you not to run around with that stick in your hand?',26124),
(102031,'enUS','','Oro, stay where I can see you!',26124),
(102032,'enUS','','If you fall into the water, your brother\'s not fishing you out!',26124),
(102033,'enUS','','Have you had any bites Mycah?',26124),
(102034,'enUS','A few, but I think Oro\'s scaring away all the fish.','',26124),
(102035,'enUS','Your selection is not yet ready for testing. Please choose another.','Your selection is not yet ready for testing. Please choose another.',26124),
(102036,'enUS','So you hunt the Dark Riders as well? Long have I searched for a way to rid Duskwood of their curse, but now it seems I have become the hunted. \n\nThough we share a common enemy, the sins you bear prevent me from aiding your cause. The Light is not well served by taking power from one evil only to bestow it upon another.','',26124),
(102037,'enUS','The power would serve to defeat the Legion. You consider that an evil goal?','The power would serve to defeat the Legion. You consider that an evil goal?',26124),
(102038,'enUS','I don\'t have time for your nonsense, priest! The Burning Legion is the greater threat!','I don\'t have time for your nonsense, priest! The Burning Legion is the greater threat!',26124),
(102039,'enUS','If you will not tell me, I will strip the answers from your soul! <Attack>','If you will not tell me, I will strip the answers from your soul! <Attack>',26124),
(102040,'enUS','I admit that the Legion is a great threat, but my duty is to the Light. \n\nI must stand vigilant against its enemies at all times, no matter how dire the situation appears.','',26124),
(102041,'enUS','To me, there is no greater threat than those who despoil the Light! \n\nI will not guide the hand of a sinner to power, no matter the ultimate cost!','',26124),
(102042,'enUS','If we do not act, Sargeras will take this world. There will be no remnant of your Holy Light to follow. Where will your duty be then?','If we do not act, Sargeras will take this world. There will be no remnant of your Holy Light to follow. Where will your duty be then?',26124),
(102043,'enUS','You are a fool! You\'ll cling to your Holy Light, even as the Legion purges this world. How will your Light serve you when you\'re left a slave?','You are a fool! You\'ll cling to your Holy Light, even as the Legion purges this world. How will your Light serve you when you\'re left a slave?',26124),
(102044,'enUS','Forget this. I will take the answers I need! <Attack>','Forget this. I will take the answers I need! <Attack>',26124),
(102045,'enUS','The Light will not falter so long as the brave hold it in their hearts. \n\nWe have seen it bring about the Legion\'s defeat before, and it will do so again.','',26124),
(102046,'enUS','It is you who are foolish, $c! \n\nThe Light is a bulwark for the faithful! It has aided us in holding back the Legion before, and it will do so again!','',26124),
(102047,'enUS','You are wrong. I was at the Broken Shore. I saw the demons cut through our men, holy and unholy alike. If we cannot turn the tide now, we are all lost.','You are wrong. I was at the Broken Shore. I saw the demons cut through our men, holy and unholy alike. If we cannot turn the tide now, we are all lost.',26124),
(102048,'enUS','I saw your holy warriors broken on the rocks outside the Tomb of Sargeras! This is unlike any Legion force we\'ve seen, and we\'ll need more than your Holy Light to drive it back this time!','I saw your holy warriors broken on the rocks outside the Tomb of Sargeras! This is unlike any Legion force we\'ve seen, and we\'ll need more than your Holy Light to drive it back this time!',26124),
(102049,'enUS','Enough of this! You will answer me or die, priest! <Attack>','Enough of this! You will answer me or die, priest! <Attack>',26124),
(102050,'enUS','If we wish to complete our goals, it is clear we must work together, $c. \n\nLet us not waste any more time.','',26124),
(102051,'enUS','I hear the truth in your words, $c. We may walk very different paths, but I see you fight for a noble cause.','',26124),
(102052,'enUS','%s motions for you to follow.','',26124),
(102053,'enUS','Am not!','',26124),
(102054,'enUS','Take me to Dreadmist Camp!','Take me to Dreadmist Camp!',26124),
(102055,'enUS','','We have a hard day ahead of us.',26124),
(102056,'enUS','%s nods approvingly.','',26124),
(102058,'enUS','You stand in my way.','',26124),
(102059,'enUS','We stand with Highmountain.','',26124),
(102060,'enUS','Take me to Crossroads!','Take me to Crossroads!',26124),
(102061,'enUS','','It claws at us from the mist! Hurry!',26124),
(102062,'enUS','','It worked! Slay the monster!',26124),
(102063,'enUS','Grab the keystone! Let\'s get to the portal down below and back to the Black Temple!','',26124),
(102064,'enUS','$p! By the Light...','',26124),
(102065,'enUS','','I\'ve caught you in my web.',26124),
(102066,'enUS','','Hello, little fly.',26124),
(102067,'enUS','','Your world will burn.',26124),
(102068,'enUS','','Nowhere to hide now, precious.',26124),
(102070,'enUS','','To all members and students of our combined schools, I offer you my thanks for joining us.',26124),
(102073,'enUS','','The attack at the Peak of Serenity shows that the Burning Legion wishes to shatter our order. They will destroy our homes, defile our sacred temples, and strive to break our spirit.',26124),
(102076,'enUS','But as we teetered upon the brink of annihilation, $n stayed with Grand Master Hight and fought the demons to ensure our survival.','',26124),
(102077,'enUS','','Monks, our greatest challenge still lies ahead. Under our new master, we will send a message of defiance to our enemies. They will not take our home without a fight!',26124),
(102078,'enUS','Grand Master Hight has passed on to join the ancestors, and we are left with a void in our ranks.','',26124),
(102079,'enUS','','Let us all give honor to Master $n! May he lead us with strength and wisdom.',26124),
(102080,'enUS','','Let us all give honor to Master $n! May she lead us with strength and wisdom.',26124),
(102081,'enUS','We must leave now. Soon we will be home.','We must leave now. Soon we will be home.',26124),
(102082,'enUS','Do not be afraid. Soon all will be set right.','Do not be afraid. Soon all will be set right.',26124),
(102083,'enUS','Yes, I am ready. Let us make haste. I worry that we will be found by our enemies.','Yes, I am ready. Let us make haste. I worry that we will be found by our enemies.',26124),
(102084,'enUS','I will tell you what I know.','',26124),
(102085,'enUS','Your words are acid, but there is truth in them. Though I detest the methods you employ, it seems we may have no choice.','',26124),
(102086,'enUS','Very well. I will tell you what I know.','',26124),
(102087,'enUS','','Excellent! I have everything prepared inside. Follow me.',26124),
(102088,'enUS','','Oro would not want me to lose myself in grief. I will be strong for him, and for our boys.',26124),
(102089,'enUS','It seems fitting that the hero who fought at his side, who displayed courage and valor immeasurable, should succeed him.','',26124),
(102090,'enUS','So be it! By the Light be purged!','',26124),
(102091,'enUS','Enough! You have proven your power, warlock.','',26124),
(102092,'enUS','Such ferocity would better serve as an ally against the Legion than an enemy. I will aid you.','',26124),
(102093,'enUS','The fish only bite when my little brother\'s asleep. He\'s a lot for my mom to handle on her own.','',26124),
(102094,'enUS','I\'m going to be a Warbrave just like my dad when I grow up!','',26124),
(102095,'enUS','[PH] This is a test gossip because I haven\'t hooked things up for reals yet!','[PH] This is a test gossip because I haven\'t hooked things up for reals yet!',26124),
(102096,'enUS','Please fire the event to start the \"Quality of Life\" event.','Please fire the event to start the \"Quality of Life\" event.',26124),
(102097,'enUS','','Well done, $n. Now, make haste! We need your help to the west.',26124),
(102098,'enUS','When you are ready, step through the portrait to teleport to Stormwind.','',26124),
(102099,'enUS','We\'ve already directed a portrait to Stormwind for you, $n. Follow me, please.','',26124),
(102100,'enUS','We are here.','We are here.',26124),
(102101,'enUS','I don\'t understand. This isn\'t the city. Wher-','I don\'t understand. This isn\'t the city. Wher-',26124),
(102102,'enUS','Silence. I tire of your prattling. Do not worry, it will all be over soon.','Silence. I tire of your prattling. Do not worry, it will all be over soon.',26124),
(102103,'enUS','FEL MASTERS, I BRING YOU YOUR FINAL SACRIFICE! Nine times nine souls I have brought you, my own kith and kin!','FEL MASTERS, I BRING YOU YOUR FINAL SACRIFICE! Nine times nine souls I have brought you, my own kith and kin!',26124),
(102104,'enUS','You should be proud, weakling. You are special to me, for you will be the instrument of my ascension.','',26124),
(102105,'enUS','So much power! I cannot be stopped!','So much power! I cannot be stopped!',26124),
(102106,'enUS','','A glorious day is upon us!',26124),
(102107,'enUS','','We entered this place as three tribes. Now, we are one.',26124),
(102108,'enUS','','Together, we are Highmountain!',26124),
(102109,'enUS','As Highmountain, we are one!','',26124),
(102110,'enUS','','As Highmountain, we are one!',26124),
(102111,'enUS','As Highmountain, we are one!','',26124),
(102112,'enUS','Siege Worms! Fire on my mark!','',26124),
(102113,'enUS','','Wuho! No!',26124),
(102114,'enUS','','Beloved brother... I should never have brought you!',26124),
(102115,'enUS','','Not again, beast! I will-- AAARGHH!!',26124),
(102116,'enUS','','It is... over for me... you must... finish this.',26124),
(102117,'enUS','Wh... what was that?','',26124),
(102118,'enUS','The Grand Magistrix exiled many Nightborne from Suramar. Those who did not agree with the bargain with the Legion, political enemies, and people she simply did not trust were all banished from the city.$b$bWe need to be united now more than ever. I bring them back into the city and they can access the Nightwell\'s energies again. The people I rescue are able to retain their magical abilities. I give them another chance at something greater.','',26124),
(102119,'enUS','','That was a wild shot! You\'re okay, right?',26124),
(102121,'enUS','Your death will be swift and unmerciful.','',26124),
(102122,'enUS','Wither before my might!','',26124),
(102123,'enUS','You dare?!','',26124),
(102124,'enUS','I am of Argus, the mightiest world in all of the Great Dark.','',26124),
(102125,'enUS','Here\'s a small taste of my fel magic.','',26124),
(102126,'enUS','','Learning to hunt is a dream come true.',26124),
(102127,'enUS','','I think we make a pretty good team.',26124),
(102128,'enUS','','I could do this with my eyes closed! But don\'t worry, I won\'t.',26124),
(102129,'enUS','I serve.','',26124),
(102130,'enUS','You will die by my blade.','',26124),
(102131,'enUS','You are easily dealt with.','',26124),
(102132,'enUS','Mortal flesh parts so easily.','',26124),
(102133,'enUS','The Burning Legion conquers all.','',26124),
(102134,'enUS','I will crush you.','',26124),
(102135,'enUS','You\'re no match for me.','',26124),
(102136,'enUS','Destroy!','',26124),
(102137,'enUS','Hmm... medium or well-done?','',26124),
(102138,'enUS','Feel my wrath!','',26124),
(102139,'enUS','We are Legion.','',26124),
(102140,'enUS','','|TInterface\\Icons\\inv_misc_monsterspidercarapace_01:20|t%s disappears |cFFFF0000|Hspell:197414|h[Into the Shadows]|h|r!',26124),
(102141,'enUS','Let\'s see what you\'re made of, tiny thing.','',26124),
(102142,'enUS','','I\'m so hungry.',26124),
(102143,'enUS','','My meal comes to me.',26124),
(102144,'enUS','','Climb inside my mouth, tiny thing.',26124),
(102145,'enUS','','Come, my little imps, dance for mother.',26124),
(102146,'enUS','','My children will cook you up nicely.',26124),
(102147,'enUS','','You\'ll die for this!',26124),
(102148,'enUS','','Have you come to play with my little imps?',26124),
(102149,'enUS','','The Legion\'s victory is inevitable, child.',26124),
(102150,'enUS','','I\'ll deliver you to Tyranna myself.',26124),
(102151,'enUS','','Filthy, little elf. I can taste the fel energy on you.',26124),
(102152,'enUS','','Intruders! Someone warn the doom commander!',26124),
(102153,'enUS','I see you.','',26124),
(102154,'enUS','You\'ll tell me your secrets before you die.','',26124),
(102155,'enUS','You cannot hide from me.','',26124),
(102156,'enUS','This should prove enlightening.','',26124),
(102157,'enUS','I don\'t need you alive to know your secrets.','',26124),
(102158,'enUS','So many questions, so little time.','',26124),
(102159,'enUS','My eyes see all.','',26124),
(102160,'enUS','I\'ll break your will.','',26124),
(102161,'enUS','','Where is the Tidestone? Speak, you fool!',26124),
(102162,'enUS','','Worthless...',26124),
(102163,'enUS','Im... impossible.','',26124),
(102164,'enUS','The shal\'dorei will rule this world!','',26124),
(102165,'enUS','Arash-falas...','',26124),
(102166,'enUS','Tor\'theras falar!','',26124),
(102167,'enUS','My magic... defeated?','',26124),
(102168,'enUS','This cannot be...','',26124),
(102169,'enUS','War rages in my heart, $n. We will have vengeance... for Gilneas, and for the Alliance!','',26124),
(102170,'enUS','Why not deliver the letter yourself, Lord Greymane?','Why not deliver the letter yourself, Lord Greymane?',26124),
(102171,'enUS','The shadows of the underworld bend to me!','',26124),
(102172,'enUS','','Our forces don\'t stand a chance against that. We must evacuate everyone left or this will have been for naught.',26124),
(102173,'enUS','The shadows of Helheim cut deeper than steel!','',26124),
(102174,'enUS','COWER BEFORE ME!','',26124),
(102175,'enUS','FLEE, COWARDS!','',26124),
(102176,'enUS','CRAVEN MAGGOTS!','',26124),
(102177,'enUS','Know the bitter chill of death as I have!','',26124),
(102178,'enUS','The winds of the frozen north still howl in these veins!','',26124),
(102179,'enUS','We have no time, Lynore! He will be here within seconds...','',26124),
(102180,'enUS','You have not won... The Naglfar comes... for you...','',26124),
(102181,'enUS','You have not won... You have only... secured your own doom...','',26124),
(102182,'enUS','Not... again... HARBARON! CAST THEIR SOULS INTO THE TIDES!','',26124),
(102183,'enUS','','We must distract him. $n, will you stand with me? We must buy enough time for our brethren, though it will surely cost us our lives.',26124),
(102184,'enUS','I will.','I will.',26124),
(102185,'enUS','Another drop in the sea of souls!','',26124),
(102186,'enUS','Vengeance!','',26124),
(102187,'enUS','PAYBACK!','',26124),
(102188,'enUS','A true captain will die for his cause! I will stand with you!','',26124),
(102189,'enUS','Mortals... Your wretched kind murdered MY people... destroyed MY kingdom! Long have I waited for a chance to repay what was done to me!','',26124),
(102190,'enUS','Mortals... Your wretched kind murdered MY people... destroyed MY kingdom! Now you, too, will know what it feels like to lose EVERYTHING!','',26124),
(102191,'enUS','Mortals... I fell to your wretched kind once before. It WILL NOT happen again!','',26124),
(102192,'enUS','','So be it. $n, Nazgrel... it will be an honor to die by your side.',26124),
(102193,'enUS','Your souls will drift for eternity in the tides of the underworld!','',26124),
(102194,'enUS','I will carve a new crown from your bones!','',26124),
(102195,'enUS','I have learned from my past defeats... It seems you have not.','',26124),
(102196,'enUS','You see now the weakness in your mortal shell?','',26124),
(102197,'enUS','Bend and break, your soul I\'ll take!','',26124),
(102198,'enUS','The flesh burdens the soul. A nuisance that must be flayed from your bones!','',26124),
(102199,'enUS','Spirits! Sweep these mortals into the tides!','',26124),
(102200,'enUS','If I cannot bleed the payment from you, the spirits will!','',26124),
(102201,'enUS','The spirits grow hungry from the scent of blood.','',26124),
(102202,'enUS','Arise, servitor! Claim our blood debt!','',26124),
(102205,'enUS','All who enter Helheim must pay the blood price. Resist if you wish... In the end, I always get my payment!','',26124),
(102206,'enUS','New passengers... New souls. I will guide you to the depths of Helheim for a small price: your flesh and blood.','',26124),
(102207,'enUS','As I said... I always get my payment!','',26124),
(102208,'enUS','Another blood debt claimed... Another soul cast into the abyss.','',26124),
(102209,'enUS','Everyone must pay the blood price!','',26124),
(102210,'enUS','Now... it is I who must pay... the blood price...','',26124),
(102211,'enUS','Helya will make you pay... In the end, everyone pays...','',26124),
(102212,'enUS','','You ALL will regret trespassing in my realm.',26124),
(102213,'enUS','','You have come far enough. Time to die.',26124),
(102214,'enUS','','It is finished. I banish your weak, mortal souls forevermore.',26124),
(102215,'enUS','','Your soul will find no shelter here.',26124),
(102216,'enUS','','Begone to the next life.',26124),
(102217,'enUS','','Your fate rains down!',26124),
(102218,'enUS','','I will drown you all like rats.',26124),
(102219,'enUS','','Hold still!',26124),
(102220,'enUS','','Stop squirming!',26124),
(102221,'enUS','','You will pay for that.',26124),
(102222,'enUS','','I am losing my patience.',26124),
(102223,'enUS','','No! This is not possible!',26124),
(102224,'enUS','Cave seems safe, boss.','',26124),
(102225,'enUS','You tall for boss.','',26124),
(102226,'enUS','Not lazy! Guarding.','',26124),
(102227,'enUS','','What manner of creatures ARE you??',26124),
(102228,'enUS','','Embrace your fate, fools!',26124),
(102229,'enUS','','An eternity of agony awaits you!',26124),
(102230,'enUS','','I have had enough! THIS. ENDS. NOW.',26124),
(102231,'enUS','','Curse you all! Do you really think to conquer MY domain? All of Helheim will stand against you...',26124),
(102232,'enUS','','ALL SOLDIERS, RETREAT! Take the wounded, get to the ship!',26124),
(102234,'enUS','Chair empty. I sit, no one notice?','',26124),
(102235,'enUS','You boss around and I help!','',26124),
(102237,'enUS','Tess and Commander Crowley will escort you to the Keep. I need to stay and oversee preparations.','',26124),
(102241,'enUS','','It is customary in Highmountain to pay for goods. If you need Airspark, speak with me.',26124),
(102243,'enUS','Snazzle good worker. I pick just for you.','',26124),
(102244,'enUS','This one has dull mind, but sharp chisel.','',26124),
(102245,'enUS','Dug not best. Dug good enough though.','',26124),
(102246,'enUS','Too slow! Boss not have all day.','',26124),
(102247,'enUS','I just in time for job!','',26124),
(102248,'enUS','I poke it dead for you, boss!','',26124),
(102249,'enUS','Move too fast, candle blow out. Darkness eat me!','',26124),
(102250,'enUS','You pick best digger!','',26124),
(102251,'enUS','You do good! Boss is the bossiest.','',26124),
(102252,'enUS','','When you face the worms, call to us, and we shall be there.',26124),
(102253,'enUS','It\'s been a long time since I was last upon the Wandering Isle.','',26124),
(102254,'enUS','Good drink, good friends, and good music.$b$bThese are truly some of the finer things in life.','',26124),
(102255,'enUS','Children of the deep, rise and crush these shan ronir!','',26124),
(102256,'enUS','You no take candle! If candle go out, darkness eat.','',26124),
(102257,'enUS','Boss has big ears. They hold most wax. Fresh wax makes best candles.','',26124),
(102258,'enUS','Do not disturb these waters!','',26124),
(102259,'enUS','This water is sacred!','',26124),
(102260,'enUS','Mu\'sha\'s Tears are not for the mundane!','',26124),
(102261,'enUS','The magic of this place is not yours to take!','',26124),
(102262,'enUS','This crystal belongs to the earth!','',26124),
(102263,'enUS','','King Anduin, the hero of the Broken Shore approaches.',26124),
(102264,'enUS','I\'ve heard you saw my father\'s final moments.','',26124),
(102265,'enUS','Tell me how he died.','',26124),
(102266,'enUS','','Justice will triumph in the end. I am sure of it.',26124),
(102267,'enUS','','Augh! Why did I think visiting Pop was going to be a good idea?!$b$bAll he does is sit around and eat. Even big bro would rather hang out in the tavern instead of exploring. Bohhhring!',26124),
(102268,'enUS','Speak to me when you are ready and I will permit you to enter Grommash Hold.$b$bBut remember, these are dire times, $n. You must be prepared.','',26124),
(102269,'enUS','Turn away to avoid |cFFFF0000|Hspell:197737|h[Predator\'s Gaze]|h|r','',26124),
(102270,'enUS','For the Horde!','',26124),
(102271,'enUS','Taste my axe!','',26124),
(102272,'enUS','Protect the Warchief!','',26124),
(102273,'enUS','','Keep a fire burning in your heart, $c, that others may feel your warmth, and through you rekindle their own spirit.',26124),
(102274,'enUS','<On the other side of the portcullis, you can see a series of tunnels that lead to Ravencrest Cemetary.>','',26124),
(102275,'enUS','Leave the Darkpens.','Leave the Darkpens.',26124),
(102276,'enUS','Senegos, we seek one of the Pillars of Creation. I know it is here on Azsuna.','',26124),
(102277,'enUS','You speak of the Tidestone of Golganneth. It was shattered long ago.','',26124),
(102278,'enUS','The Tidestone... shattered? How?','',26124),
(102279,'enUS','I do not know... but I know where the pieces lie.','',26124),
(102280,'enUS','Defilers... I can smell the Nightmare in your blood. Be gone from these woods or suffer nature\'s wrath!','',26124),
(102281,'enUS','Defilers... so it is you who have befouled these woods with the Nightmare.','',26124),
(102282,'enUS','Aludane, I have urgent business in Val\'sharah. Can you secure a flight for me?','Aludane, I have urgent business in Val\'sharah. Can you secure a flight for me?',26124),
(102283,'enUS','Kill her! Protect the grove!','Kill him! Protect the grove!',26124),
(102284,'enUS','Leave Dalaran for Val\'sharah?','Leave Dalaran for Val\'sharah?',26124),
(102285,'enUS','I will bleed the Nightmare from you!','',26124),
(102286,'enUS','By tooth and claw be purged!','',26124),
(102287,'enUS','I am the vessel of nature\'s fury!','',26124),
(102288,'enUS','I am nature\'s fury incarnate!','',26124),
(102289,'enUS','Andu-falah-dor!','',26124),
(102290,'enUS','Be purified in the light of the stars!','',26124),
(102291,'enUS','I am one with the flows of nature!','',26124),
(102292,'enUS','Nature graces me with its bounty!','',26124),
(102293,'enUS','The wilds sustain me!','',26124),
(102294,'enUS','Only death can free you from the Nightmare.','',26124),
(102295,'enUS','Your blood reeks of corruption.','',26124),
(102296,'enUS','Stay down, defiler!','',26124),
(102297,'enUS','The wilds are safe from the Nightmare once again.','',26124),
(102298,'enUS','The Nightmare will not take root in these sacred woods.','',26124),
(102299,'enUS','I see now... I am the defiler...','',26124),
(102300,'enUS','The Nightmare... clouds my thoughts no more...','',26124),
(102301,'enUS','I just had... the strangest nightmare...','',26124),
(102302,'enUS','The ocean will sweep you away!','',26124),
(102303,'enUS','Seas! Obey my command!','',26124),
(102304,'enUS','BUURRRP','',26124),
(102305,'enUS','How long can you hold your breath, I wonder?','',26124),
(102306,'enUS','Pity you cannot survive without air!','',26124),
(102307,'enUS','Before the crashing waves come the quake!','',26124),
(102308,'enUS','The earth trembles before the rising tide!','',26124),
(102309,'enUS','The oceans rest... but the wind still rises against you.','',26124),
(102310,'enUS','Gaaah... The winds will finish you, intruders.','',26124),
(102311,'enUS','You haven\'t won. She is almost here...','',26124),
(102312,'enUS','I failed... but my Queen will NOT.','',26124),
(102313,'enUS','Justice for the son you murdered!','',26124),
(102314,'enUS','Blood repays blood.','',26124),
(102315,'enUS','You weaklings will drown beneath these waves!','',26124),
(102316,'enUS','You killed my son! Your punishment is death!','',26124),
(102317,'enUS','This was as inevitable as the tides, fools.','',26124),
(102318,'enUS','I found shiniest shinies for boss!','',26124),
(102319,'enUS','I have just the beast for this special task.','',26124),
(102320,'enUS','Killed biggest basilisk! And heaviest...','',26124),
(102321,'enUS','Where is Dug? Should be back. Boss go find.','',26124),
(102322,'enUS','','Enough of these games. This ends here!',26124),
(102323,'enUS','','Burn in the flames!',26124),
(102324,'enUS','','From the ashes!',26124),
(102325,'enUS','I am yours to command.','I am yours to command.',26124),
(102326,'enUS','I will heal you, $n.','I will heal you, $n.',26124),
(102327,'enUS','I won\'t let you fall!','I won\'t let you fall!',26124),
(102328,'enUS','Get back in the fray!','Get back in the fray!',26124),
(102329,'enUS','The light will cleanse us all, soldier.','The light will cleanse us all, soldier.',26124),
(102330,'enUS','Behold the skittering denizens of the dark!','',26124),
(102331,'enUS','Creeping horrors... they\'ll tickle your skin... looking for a way IN.','',26124),
(102332,'enUS','Nature\'s darker minions... creeping, crawling, scattering from the light. Looking to have just one bite.','',26124),
(102333,'enUS','You must appreciate nature in all its many forms.','',26124),
(102334,'enUS','Why is everyone always in such a hurry?','',26124),
(102335,'enUS','Stand still and listen when my sister is talking to you!','',26124),
(102336,'enUS','Why all the haste to depart? Vardalla has a message for you... straight to the heart!','',26124),
(102337,'enUS','Hey, slow down! Where\'s the fire?','',26124),
(102338,'enUS','Nature, you see, is a paradox... infinite beauty coupled with merciless lethality.','',26124),
(102339,'enUS','So many wonderful things to see... take care though, to know where danger be.','',26124),
(102340,'enUS','I have cultivated a gift for you!','',26124),
(102341,'enUS','Go ahead, get close... take a big sniff.','',26124),
(102342,'enUS','Hey... there is a fungus among us!','',26124),
(102343,'enUS','Such is the... cycle of nature.','',26124),
(102344,'enUS','Yes! I am ready... to embark on my... new adventure...','',26124),
(102345,'enUS','Farewell sister! I would say it has been a pleasure, but I do not wish my final words to be a lie.','',26124),
(102346,'enUS','So much was given for me to know... yet into the unknown now must I go.','',26124),
(102347,'enUS','Life, death... all the same, really.','',26124),
(102348,'enUS','You will make great compost...','',26124),
(102349,'enUS','Farewell, to you, I say! Tomorrow might have been a brighter day.','',26124),
(102350,'enUS','There will be more than enough to go around!','',26124),
(102351,'enUS','I\'ve opened a minor portal to help the wounded get to the ship more quickly.','I\'ve opened a minor portal to help the wounded get to the ship more quickly.',26124),
(102352,'enUS','Nature welcomes you!','',26124),
(102353,'enUS','We have guests! Or, perhaps I should say, pests!','',26124),
(102354,'enUS','Pests exterminated.','',26124),
(102355,'enUS','Here in defeat, bold intruders fell. What inspired such overconfidence? No one may tell.','',26124),
(102356,'enUS','Nobody has successfully wielded the weapons of the Keeper of Storms. Will you be the first?','',26124),
(102357,'enUS','Let this serve as a lesson to all who would threaten nature\'s tranquility!','',26124),
(102358,'enUS','','DON\'T RUN!  They don\'t like it when you run, see?',26124),
(102359,'enUS','','You all... need to... WAIT YOUR TURN!',26124),
(102360,'enUS','','STAY! If you don\'t want to stay, I\'ll MAKE you stay!',26124),
(102361,'enUS','','I insist you stay right here. You don\'t want to miss any of the FUN!',26124),
(102362,'enUS','','Just relax. Let your cares melt away.',26124),
(102363,'enUS','','This might burn a little... or a LOT.',26124),
(102364,'enUS','','He\'ll stop the world and I\'ll MELT YOU!',26124),
(102365,'enUS','','I don\'t get under your skin... I BURN right through it.',26124),
(102366,'enUS','','You might feel a liiiittle prick. Followed by a slow and painful death.',26124),
(102367,'enUS','','I\'m not mad at you... I just want you to SUFFER AND DIE!',26124),
(102368,'enUS','','Death should be savored, like a fine wine. Enjoy!',26124),
(102369,'enUS','','I like you, I really do! That\'s why I\'m going to make your death slow and excruciating.',26124),
(102370,'enUS','Welcome back to Stormwind, $n. I\'m relieved you survived the Broken Shore.$b$bWe could not afford to lose you!','',26124),
(102371,'enUS','','Not fair, NOT FAIR!',26124),
(102372,'enUS','','Wait a minute it\'s all clear to me now... the Nightmare had me insane, I-agh, ack! Aaaghhh...',26124),
(102373,'enUS','','Ooohh where am I off to now? I hope there\'s trees...',26124),
(102374,'enUS','','And so I fall! Like a leaf... in fall!',26124),
(102375,'enUS','','Hope your muscles don\'t get tired from pushing up all those daisies!',26124),
(102376,'enUS','I come bearing a letter from your father.','I come bearing a letter from your father.',26124),
(102377,'enUS','','Is it painful? No, really I want to know!',26124),
(102378,'enUS','','Time to go sleepy-bye!',26124),
(102379,'enUS','','BACK OFF, NUADA! I saw them first!',26124),
(102380,'enUS','','I didn\'t know we had a play date!',26124),
(102381,'enUS','','You were NOT INVITED! But I just love surprises!',26124),
(102382,'enUS','','Well I don\'t know WHAT that was all about...',26124),
(102383,'enUS','','That was like success... but the opposite.',26124),
(102384,'enUS','','What HE said!',26124),
(102385,'enUS','Thandae-alah...','',26124),
(102386,'enUS','Trespasser...','',26124),
(102387,'enUS','Desecrator...','',26124),
(102388,'enUS','You will be cold... like us.','',26124),
(102389,'enUS','Feel the chill of the grave!','',26124),
(102390,'enUS','Elisande... stop her...','',26124),
(102391,'enUS','I will rest now.','',26124),
(102392,'enUS','Your reputation precedes you, $c. I am told you were at the front lines on the Broken Shore. You, more than any other, know what our world is up against.$b$bIf you seek the weapons once possessed by Ra-den, the Keeper of Storms, know that many have tried to wield their power and none have succeeded. You will face a series of challenges, but make no mistake... the weapons themselves will be the most dangerous test of all.$b$bDo you wish to continue?','',26124),
(102393,'enUS','Our people... shu dalees-na.','',26124),
(102394,'enUS','What has become of us?','',26124),
(102395,'enUS','I am ready, White Tiger.','I am ready, White Tiger.',26124),
(102396,'enUS','Finally, we rest.','',26124),
(102397,'enUS','Peace...','',26124),
(102401,'enUS','Get off our mountain!','',26124),
(102402,'enUS','I smell blood in the forest.','',26124),
(102403,'enUS','I\'ll tear your arms off!','',26124),
(102404,'enUS','You came to the wrong place.','',26124),
(102405,'enUS','You will know my strength!','',26124),
(102406,'enUS','Our allies give us power!','',26124),
(102407,'enUS','Torok will be pleased with your death!','',26124),
(102408,'enUS','The Feltotem will own this mountain!','',26124),
(102409,'enUS','','Vol\'jin...',26124),
(102410,'enUS','Saved us... I worry the Alliance will think we left them for dead.','',26124),
(102411,'enUS','... and what will you have us do, Warchief?','',26124),
(102412,'enUS','Arille, get me a drink!','',26124),
(102413,'enUS','My father was a seasoned strategist, yet his army was shattered on the Broken Shore. How can I hope to succeed where he failed?','',26124),
(102414,'enUS','You are not alone in this, My King. We stand behind you.','',26124),
(102415,'enUS','','Have you forgotten the Horde\'s treachery? It\'s time to bring them to heel like the dogs they are!',26124),
(102416,'enUS','To fight two wars at once would be folly. For all our sakes, we need the Horde\'s strength added to our own.','',26124),
(102417,'enUS','Velen is right. We must stand beside the demon hunters and focus on the Legion. Now is not the time to--','',26124),
(102418,'enUS','','The Horde betrayed your father and left us to die! To fight alongside those cowards would dishonor everything he stood for.',26124),
(102419,'enUS','Cowards, both of you. King Anduin, you know what we must do. We must strike quickly, to scatter the Horde to the winds and let them fend for themselves against the Legion.','',26124),
(102420,'enUS','','And with the return of the Illidari, we have a valuable weapon on our side. You were wise to accept them into Stormwind, King Anduin.',26124),
(102421,'enUS','My people know the price of facing the demons as a world divided. It is time to unite our forces and defend our lands.','',26124),
(102422,'enUS','Your first trial is a test of strength. This vrykul champion also seeks the weapons of storm on behalf of his clan. Only one of you may pass.','',26124),
(102423,'enUS','Agreed. I\'m sorry, Jaina, but vengeance must wait. I trust you\'re mobilizing the Kirin Tor as we discussed?','',26124),
(102424,'enUS','I am ready to fight!','I am ready to fight!',26124),
(102425,'enUS','Good to see you, commander.','',26124),
(102426,'enUS','All quiet around the lodge, commander.','',26124),
(102427,'enUS','Always good to have you around camp, commander.','',26124),
(102428,'enUS','<The vrykul warrior scoffs at you.>$b$bYou are to be my first test? Bah! I have scars more intimidating than you.','',26124),
(102429,'enUS','Two Kings Defeated','Two Kings Defeated',26124),
(102430,'enUS','I have bested the kraken. I have slain giants. You are nothing!','',26124),
(102431,'enUS','I... yield...','',26124),
(102432,'enUS','This isn\'t over, shaman. Someday we will meet on a true field of battle.','',26124),
(102433,'enUS','','Elune... guide me...',26124),
(102435,'enUS','','Come back here once you have freed those soliders, $n. Elune be with you.',26124),
(102436,'enUS','DO NOT LOCALIZE','DO NOT LOCALIZE',26124),
(102439,'enUS','','The innocent will not die in vain. They will die for the Horde.',26124),
(102440,'enUS','','Broken Shore was just the beginning. The Legion\'s forces grow stronger as we speak. Soon we will not be able to match their power.',26124),
(102441,'enUS','','And the Alliance? They have no honor. Given the opportunity, they will strike when we are weak.',26124),
(102442,'enUS','','As for the Warchief, he assumes the required knowledge lies with the Kirin Tor. I\'m sure Khadgar will be most pleased by his visit.',26124),
(102443,'enUS','','Khadgar will contact you before long. I must ready Undercity for war. Are you with us, $n? Or with the humans?',26124),
(102444,'enUS','','I\'ve taken certain... precautionary measures. My guards will remain present throughout the city until the Alliance threat stands down.',26124),
(102445,'enUS','Good to see you up, $n. I would ask a favor before my army leaves for war.','',26124),
(102446,'enUS','Mmm... mrrmmmm...','',26124),
(102447,'enUS','Rulllmm!','',26124),
(102448,'enUS','Nyumnyum.','',26124),
(102449,'enUS','Urrlllllm.','',26124),
(102450,'enUS','$n, we\'ve requisitioned this hippogryph to take you to the Broken Isles!','',26124),
(102451,'enUS','- YOU HAVE COMPLETED THE NIGHTMARE PORTION OF THE PLAYTEST -','',26124),
(102452,'enUS','I alone deserve the favor of the storm god!','',26124),
(102453,'enUS','Glory will be mine in the Halls of Valor!','',26124),
(102454,'enUS','The north winds obey my command...','',26124),
(102455,'enUS','Stand and fight!','',26124),
(102456,'enUS','Is this the best your pathetic Earthen Ring can muster!?','',26124),
(102457,'enUS','This way, friend. I will coach you through the trials as best I can.','',26124),
(102458,'enUS','Do you seek the weapons of the storm god? Step forward, shaman.','',26124),
(102459,'enUS','Make haste to Krasus\' Landing. I will try to gather support from the mages.','',26124),
(102460,'enUS','Stormstout! You seek the weapons of the storm as well?','',26124),
(102461,'enUS','I do. \'Storm, Earth, Fire...\' that\'s kind of my thing.','',26124),
(102462,'enUS','Many seek the artifacts of the Keeper of Storms. None have passed the trials. Come, and be judged!','',26124),
(102463,'enUS','You\'re in good hands, friend. Did I mention I trained King Wrynn for the arena?','',26124),
(102464,'enUS','Who challenges me!? The weapons of the storm belong to my clan by rights!','',26124),
(102465,'enUS','The first trial is a test of strength. Only one of you may pass. Speak with me to begin.','',26124),
(102466,'enUS','This vrykul is all talk. Use his strength against him.','',26124),
(102467,'enUS','I will grant you a lightning shield, but don\'t let him get too close!','',26124),
(102468,'enUS','3... 2... 1... Fight!','',26124),
(102469,'enUS','Incredible form! A fighter in perfect harmony with the elements!','',26124),
(102470,'enUS','You\'ve almost got this, champion!','',26124),
(102471,'enUS','Don\'t worry, champion. This isn\'t over yet.','',26124),
(102472,'enUS','The shaman has triumphed! The first trial is complete.','',26124),
(102473,'enUS','Ah, you must be the one I am hearing whispers about. Tales of your great deeds and powerful artifact precede you.$b$bI am Spiritwalker Ebonhorn. I have heard much about you and your journeys beyond these isles.$b$bLet us see if the stories of your heroism are true, shall we?','',26124),
(102474,'enUS','Ready to negotiate.','Ready to negotiate.',26124),
(102475,'enUS','A true hero never fights alone. The next trial is a test of teamwork. You must choose a partner.','',26124),
(102476,'enUS','I will be the second for my champion! Who will we fight?','',26124),
(102477,'enUS','I believe I am next.','',26124),
(102478,'enUS','Stormstout!? Hah! I\'ve been waiting for a chance to get you into the arena. Take you down a peg or two.','',26124),
(102479,'enUS','I\'d like to introduce myself.','I\'d like to introduce myself.',26124),
(102480,'enUS','Is that so? We shall see who the real \'Hero of the Storm\' is around here. But first, I need a partner.','',26124),
(102481,'enUS','','Ready for adventure!',26124),
(102482,'enUS','Oh no no, Li Li, I don\'t think--','',26124),
(102483,'enUS','Remember: Only through teamwork will you triumph. 3... 2... 1... FIGHT!','',26124),
(102484,'enUS','Ignore your pride. Take out the pandaren girl first!','',26124),
(102485,'enUS','You are fast, orc. But not fast enough!','',26124),
(102486,'enUS','You\'ve bitten off more than you can chew, pandaren. And that\'s a lot!','',26124),
(102487,'enUS','The customer don\'t buy, unless you supply!$b$bWelcome to the shop, $n. The name\'s Jones, Timothy Jones, or TJ for short. It\'s up to you.$b$bIf you need anything, and I mean ANYTHING, you come talk to me and I\'ll give you the hookup.$b$b<Timothy gives you a wink and goes back to his business.>','',26124),
(102488,'enUS','Focus on the healer!','',26124),
(102489,'enUS','Li Li, look out!','',26124),
(102490,'enUS','Let\'s roll!','',26124),
(102491,'enUS','','Hey, here\'s the good stuff!',26124),
(102492,'enUS','You\'re not dying on me!','',26124),
(102493,'enUS','','These guys don\'t play nice!',26124),
(102494,'enUS','You have bested me.','',26124),
(102495,'enUS','Congratulations, hero! The second challenge is complete.','',26124),
(102496,'enUS','Rehgar, this may be the most powerful fighter you\'ve ever brought to the Arena.','',26124),
(102497,'enUS','I know a champion when I see one!','',26124),
(102498,'enUS','As The Light as my witness, jewels are my business!$b$bWhat can I help you with?','',26124),
(102499,'enUS','You have proven your worth, champion. You are ready for the final trial, which none have passed.','',26124),
(102500,'enUS','The tools of the Keeper of Storms are so powerful, even the Thunder King himself dared not wield them.','',26124),
(102501,'enUS','The Fist of Ra-den is your final challenge. If you can wield it and live, the weapon is yours to command.','',26124),
(102502,'enUS','I believe in you, shaman!','',26124),
(102503,'enUS','','This is so cool.',26124),
(102504,'enUS','I\'ll be honest... those things scare me.','',26124),
(102505,'enUS','','Yow! Watch it!',26124),
(102506,'enUS','','Hiya, $n, the name\'s Sminx. I mostly deal in fine jewelry. I leave the actual gem-cutting duties to Tiffany.$b$bIf you\'re looking for something to put your shinies into, come talk to me.',26124),
(102507,'enUS','Focus, champion!','',26124),
(102508,'enUS','','What\'cha lookin\' for, stranger?',26124),
(102509,'enUS','Stand in the light and prove your mastery over the elements.','',26124),
(102510,'enUS','Destroy the first target with a lightning bolt.','',26124),
(102511,'enUS','Hmm. Maybe we should do this outdoors.','',26124),
(102512,'enUS','One moment, great tiger.','',26124),
(102513,'enUS','Stay focused, champion. You were born to command these elements. You can do this!','',26124),
(102514,'enUS','So, you are the one Ebonhorn has been talking about?$b$bIt was a strange prophecy from a strange spiritwalker.$b$bToo strange, if you ask me.','So, you are the one Ebonhorn has been talking about?$b$bIt was a strange prophecy from a strange spiritwalker.$b$bToo strange, if you ask me.',26124),
(102515,'enUS','Did you hear? The High-Chieftain is dead!$b$bThe drogbar underking betrayed him.','Did you hear? The High-Chieftain is dead!$b$bThe drogbar underking betrayed him.',26124),
(102516,'enUS','Jale is going to try to negotiate with the drogbar. Without the help of the other tribes, we have no choice but to try for peace.','Jale is going to try to negotiate with the drogbar. Without the help of the other tribes, we have no choice but to try for peace.',26124),
(102517,'enUS','I heard the drogbar have already begun attacking Whitewater Wash and even Thunder Totem.$b$bThese are dark days.','So, you are the one Ebonhorn has been talking about?$b$bIt was a strange prophecy from a strange spiritwalker.$b$bToo strange, if you ask me.',26124),
(102518,'enUS','Use a lava burst to destroy the second target.','',26124),
(102519,'enUS','Concentrate! Stay in control!','',26124),
(102520,'enUS','Something is wrong... someone is here...','',26124),
(102521,'enUS','The Legion is attacking!','',26124),
(102522,'enUS','You will never stop the Inquisition!','',26124),
(102523,'enUS','','You need to get me out of this cage! We\'re in more danger than you suspect!',26124),
(102524,'enUS','The High Inquisitor\'s work will not be interrupted!','',26124),
(102525,'enUS','','Thank you, $n. Back into the fight.',26124),
(102526,'enUS','Thank you, $n. Back into the fight.','',26124),
(102527,'enUS','Leave the mortals alive. We must find the weapons of their so-called \'Storm-God.\'','',26124),
(102528,'enUS','I will feast on your soul after my triumph here.','',26124),
(102529,'enUS','','Thank you, $n. Back into the fight.',26124),
(102530,'enUS','The Legion will scorch this world!','',26124),
(102531,'enUS','We will defile the very ground you stand on!','',26124),
(102532,'enUS','Thank you, $n. Back into the fight.','',26124),
(102533,'enUS','Soon there will be no place for you to run...','',26124),
(102534,'enUS','You rely on the elements to fight for you? Weakling!','',26124),
(102535,'enUS','Ancestors watch over you!','',26124),
(102536,'enUS','Begone, mortal!','',26124),
(102537,'enUS','Finish... him...','',26124),
(102538,'enUS','My master WILL possess the power of the storm!','',26124),
(102539,'enUS','Glory to the Legion!','',26124),
(102540,'enUS','','I will repay my debt to you.',26124),
(102541,'enUS','','The Burning Legion will fall!',26124),
(102542,'enUS','Champion, you saved us...','',26124),
(102543,'enUS','','I will not let you down.',26124),
(102544,'enUS','','For Lord Illidan!',26124),
(102545,'enUS','The elements walk in harmony with this one. I\'ve not seen a better shaman since I fought alongside Thrall himself.','',26124),
(102546,'enUS','','We WILL take the keystone!',26124),
(102547,'enUS','Shaman, no further trials are required. The weapons of the Keeper of Storms have found their new master.','',26124),
(102548,'enUS','','Die demons!',26124),
(102549,'enUS','Go forth, champion of the Earthen Ring, with my blessing. Azeroth is under siege, and heroes like you must rise to the challenge.','',26124),
(102550,'enUS','','I did not make it this far just to die on this rock.',26124),
(102551,'enUS','I will repay my debt to you.','',26124),
(102552,'enUS','The Burning Legion will fall!','',26124),
(102553,'enUS','I will not let you down.','',26124),
(102554,'enUS','For Lord Illidan!','',26124),
(102555,'enUS','We WILL take the keystone!','',26124),
(102556,'enUS','Die demons!','',26124),
(102557,'enUS','I did not make it this far just to die on this rock.','',26124),
(102558,'enUS','','I will repay my debt to you.',26124),
(102559,'enUS','','The Burning Legion will fall!',26124),
(102561,'enUS','','I will not let you down.',26124),
(102562,'enUS','','For Lord Illidan!',26124),
(102563,'enUS','','We WILL take the keystone!',26124),
(102564,'enUS','','Die demons!',26124),
(102566,'enUS','','I did not make it this far just to die on this rock.',26124),
(102567,'enUS','I will repay my debt to you.','',26124),
(102568,'enUS','The Burning Legion will fall!','',26124),
(102569,'enUS','I will not let you down.','',26124),
(102570,'enUS','For Lord Illidan!','',26124),
(102571,'enUS','We WILL take the keystone!','',26124),
(102572,'enUS','Die demons!','',26124),
(102573,'enUS','I didn\'t make it this far just to die on this rock.','',26124),
(102577,'enUS','','Hurry! We must find Thaon before it is too late!',26124),
(102578,'enUS','Dis be de end o\' discussion \'til our guest be arrivin\'.','',26124),
(102579,'enUS','De only ting we can do... My wounds ain\'t be lastin\' much longer. Loa be callin\' me...','',26124),
(102580,'enUS','Quickly! Let us put an end to these miscreants!','',26124),
(102581,'enUS','I deem you... unworthy.','',26124),
(102582,'enUS','Seems I... underestimated you.','',26124),
(102583,'enUS','I will take joy in crushing you!','',26124),
(102584,'enUS','Together we will see our enemies to a savage end!','',26124),
(102585,'enUS','My strength... fails.','',26124),
(102586,'enUS','Your cries of anguish will echo through eternity!','',26124),
(102587,'enUS','Together we will cast their souls to ruin!','',26124),
(102588,'enUS','I embrace the abyss!','',26124),
(102589,'enUS','I accept this challenge... with eager anticipation!','',26124),
(102590,'enUS','Where they failed, we will succeed!','',26124),
(102591,'enUS','','Hey there $n. This kitty is huge! Do you think the king would mind if I pet him?',26124),
(102592,'enUS','You have... bested me.','',26124),
(102593,'enUS','... de right call was made. Dat horn be savin\' us... all of us.','',26124),
(102594,'enUS','','Any who oppose us, any who stand in our way will perish. I accept my reign as the first Queen of the Horde.',26124),
(102595,'enUS','','We must call upon reinforcements within our cities at once! Preparations must be ma -',26124),
(102596,'enUS','','You saw how swiftly their attacks came. Your own blood remains on the battlefield, Baine. It\'s only a matter of time before our skies are covered in felfire!',26124),
(102597,'enUS','Dreadguards... watch their formations! Hold strong! One Horde!','',26124),
(102598,'enUS','We will remain one Horde.','',26124),
(102599,'enUS','One Horde... one leader...','',26124),
(102600,'enUS','As a boy, I heard legends of the Unseen Path. They made me want to become a hunter. When I heard the order had been restored, I had to see it with my own eyes.','',26124),
(102601,'enUS','It is good to see you again, $n.','',26124),
(102602,'enUS','Thinking of lost friends... and a promise I need to keep.','',26124),
(102603,'enUS','Good, I\'d like a rematch!','',26124),
(102604,'enUS','Is something troubling you?','Is something troubling you?',26124),
(102605,'enUS','Eh, who\'s this then?','',26124),
(102606,'enUS','Don\'t worry, you\'ll be hearing about $Ghim:her; soon enough.','',26124),
(102607,'enUS','','Warchief...',26124),
(102608,'enUS','Earth Mother watch over us. What will become of the Horde?','',26124),
(102609,'enUS','And who would you have lead, Warchief? No man can command an army that suffered such losses as we...','',26124),
(102610,'enUS','No single army is large enough to defeat the Legion. Our blood on the battlefield will attest to that. I will not put the lives of innocent people in harm\'s way.','',26124),
(102611,'enUS','','Your reluctance to defend the Horde is choice enough, I\'m afraid.',26124),
(102612,'enUS','By coming here, you have sealed your doom!','',26124),
(102613,'enUS','Your actions at the Shore have shown what it takes to be a leader. When lives are at stake... lives of loved ones, of warriors, of the Horde...','',26124),
(102614,'enUS','','And when the time comes, let us hope these words bear a heavier weight than the air in which they\'re spoken.',26124),
(102615,'enUS','No man... She...','',26124),
(102616,'enUS','Broken Shore be our lesson. And now... now knowledge be our weapon.','',26124),
(102617,'enUS','Dem powers we seen - dat be more dan any us be dealin wit on our own.','',26124),
(102619,'enUS','','Are you ready to meet Odyn?',26124),
(102620,'enUS','Take me to Odyn.','Take me to Odyn.',26124),
(102622,'enUS','','Alleria! Can you hear me? Alleria!',26124),
(102623,'enUS','','I can sense a demon presence... Above us, $n, on the ledge!',26124),
(102628,'enUS','When de time comes, you be ready to fight?','',26124),
(102629,'enUS','If dis only de beginning, ain\'t gonna be easy. If we fight, everyone gonna be makin\' sacrifices.','',26124),
(102630,'enUS','Vol\'jin...','',26124),
(102631,'enUS','All your instinct be true. Innocent lives be valued, indeed, but dem magics... Demons we ain\'t been seein\' before. I be fearin\' dis only be de beginnin\'.','',26124),
(102632,'enUS','Warchief, I understand, but we cannot afford to send everything we have at the Legion. Some of our people are not ready for a war. It is -','',26124),
(102633,'enUS','','It is unfortunate... for all of us, but the time has come to defend our people - all of our people.',26124),
(102634,'enUS','Dat willingness to sacrifice - to make dem decisions when da time comes - dat be the sign of a true Warchief.','',26124),
(102635,'enUS','Good. Now we all be seein\'... united as one, but we also be need\'n an old knowledge. Someone who understand dem fel magics from long ago. Someone ta help understand de fight dey be bringin. Helpin\' us prepare... for war.','',26124),
(102636,'enUS','','Warchief, even with the might of the Horde behind us, the Legion\'s power continues to grow. We know neither their numbers nor their true power, but as you said, we know their intentions.',26124),
(102637,'enUS','Yes... and we ain\'t gone be fightin\' de Legion alone. It be time we be reachin\' out. I be goin\' to visit an old friend.','',26124),
(102638,'enUS','Dem serious times. Tell your people it\'s time to be gettin\' ready. Everybody gettin\' ready.','',26124),
(102639,'enUS','','And what of my guards, Warchief? We cannot afford to leave the city in its state. The Legion is threat enough, and the Alliance - the Alliance will surely strike when our guard is down.',26124),
(102640,'enUS','Leave \'em. Dem guards be remindin\' us of those we lost. They be remindin\' us we be one Horde. And dey be remindin\' us - ain\'t nobody be sittin\' down when war be upon us.','',26124),
(102641,'enUS','Ain\'t none of us be standin\' here without her actions at da Shore.','',26124),
(102642,'enUS','Upon close inspection, the jewel appears to be real. This must not be the commission in question.$b$bThe next person on the list is Didi the Wrench at the engineering shop.','Upon close inspection, the jewel appears to be real. This must not be the commission in question.$b$bThe next person on the list is Didi the Wrench at the engineering shop.',26124),
(102643,'enUS','The gem chips lying on the table are definitely real. They bear the same imperfections you\'ve seen before.$b$bThe last person on the list is Debbi Moore at Curiosities and Moore.','The gem chips lying on the table are definitely real. They bare the same imperfections you\'ve seen before.$b$bThe last  person on the list is Debbi Moore.',26124),
(102644,'enUS','As you expect each jewel in the bag, your eyes grow wider and wider with surprise.$b$bALL of these gems are fake! You must take this bag back to Tiffany as quickly as possible.','As you expect each jewel in the bag, your eyes grow wider and wider with surprise.$b$bALL of these gems are fake! You must take this bag back to Tiffany as quickly as possible.',26124),
(102645,'enUS','Beware... the hound mistress...','',26124),
(102646,'enUS','You are my greatest weapon now, $n.','',26124),
(102647,'enUS','','Welcome mage it\'s time to begin your training. As a Mage, you are a master of magic, able to conjure and control arcane energy to do your bidding. We will begin with the fundamentals.',26124),
(102648,'enUS','','Dalaran will help protect the Eastern Kingdoms, but I will NOT allow the Horde to set foot within my city!',26124),
(102649,'enUS','We must not splinter like this... not now. Please, Jaina!','',26124),
(102650,'enUS','You must not falter, Your Highness. Even now, the Legion is upon you!','',26124),
(102651,'enUS','My father dead... disaster on the Broken Shore... Jaina fixed on revenge... Everything is falling apart.','',26124),
(102652,'enUS','','With respect, you are making a huge mistake. Our chances fade the longer we wait to strike back at the Horde.',26124),
(102653,'enUS','It\'s my mistake to make, Jaina. This is my decision now.','',26124),
(102654,'enUS','','Then I will take my leave. The Council of Six must be convened.',26124),
(102655,'enUS','I can only hope so.','',26124),
(102656,'enUS','Thank you, Jaina.','',26124),
(102657,'enUS','','Of course. I will convene the Council of Six at once.',26124),
(102658,'enUS','I would like to review weapons we might pursue.','I would like to review weapons we might pursue.',26124),
(102659,'enUS','No one rides for free!','',26124),
(102660,'enUS','Life... death... I am but one ripple in the eternal ebb and flow...','',26124),
(102661,'enUS','','Do you think you have won? You have merely survived the storm... The seas are unstoppable.',26124),
(102662,'enUS','','Odyn values these creatures?',26124),
(102663,'enUS','','I\'d recommend talking to Catriona Macrae first. She was my most recent customer.',26124),
(102664,'enUS','Accessing shrine module XK-47-09. Processing.','',26124),
(102665,'enUS','','My husband is always running off without cleaning up after himself, leaving me to clean up after him.$b$bIf you see him around Dalaran, could you let him know that I love him more than he loves me?',26124),
(102666,'enUS','History Module. Watchers tasked with guarding portions of Pantheon\'s power on Azeroth in case of catastrophic loss. Initial results deemed successful.','',26124),
(102667,'enUS','I\'m here to inspect the jewel Tiffany Cartier crafted for you.','I\'m here to inspect the jewel Tiffany Cartier crafted for you.',26124),
(102668,'enUS','Current status: corrupted. High levels of fel energy tripped failsafe mechanisms. Initial analysis suggests purification necessary to restore function.','',26124),
(102669,'enUS','Power levels low. Shutting down to preserve system memory.','',26124),
(102670,'enUS','','If you got some springs loose, I can probably show you how to fix \'em up!',26124),
(102671,'enUS','I\'m here to inspect the gem chips Tiffany Cartier gave you.','I\'m here to inspect the gem chips Tiffany Cartier gave you.',26124),
(102672,'enUS','I\'m here to inspect the jewels Tiffany Cartier gave you.','I\'m here to inspect the jewels Tiffany Cartier gave you.',26124),
(102673,'enUS','','Can I interest you in a new trinket?',26124),
(102674,'enUS','','Oh yes, they\'re right there on the table. There isn\'t anything wrong with them, is there?',26124),
(102675,'enUS','','Sure thing. They\'re right over there on that table. They\'ve been working out great!',26124),
(102676,'enUS','','My jewel? I suppose so. It\'s over there on the side table.',26124),
(102677,'enUS','It\'s mine! I saw it fall from sky!','',26124),
(102678,'enUS','These are no spirits. These are echoes from the past. Something bad happened here.','',26124),
(102679,'enUS','You will all burn!','',26124),
(102680,'enUS','Fools! Insects! Vermin! You are nothing to me. I will consume you all!','',26124),
(102681,'enUS','You dare challenge me?!','',26124),
(102682,'enUS','','|TInterface\\Icons\\inv_misc_volatileearth.blp:20|t %s has no one to melee and begins to |cFFFF0000|Hspell:196534|h[Slam]|h|r!',26124),
(102683,'enUS','Master, release me from this webbing and I will aid you!','',26124),
(102688,'enUS','','We must assist at Whitewater Wash before it is too late.',26124),
(102689,'enUS','You will all serve the Legion.','',26124),
(102690,'enUS','Nowhere is safe.','',26124),
(102691,'enUS','Everything you know will burn in fel flame.','',26124),
(102692,'enUS','You merely... prolong...','',26124),
(102693,'enUS','You are High Chieftain. You must show your people that no artifact - no weapon - can stand before the might of a united Highmountain.','',26124),
(102694,'enUS','','We need to reclaim the hammer. Not go for a walk.',26124),
(102696,'enUS','','First, select and equip a weapon from the rack over there. As a caster, you do not attack with your weapon, but it is a source of great power, empowering your innate arcane abilities.',26124),
(102697,'enUS','','Skylord, your friend has finished recovering. It is different to raise a living being to the Halls, but I have done just that!',26124),
(102698,'enUS','','It was an honor working with you at your garrison, $ct.',26124),
(102699,'enUS','','Based on our success on Draenor, I\'d say we make a good team, $n.',26124),
(102700,'enUS','Welcome.  As a fire mage you specialize in igniting your opponents with impressive bursts of flame, leaving them to burn to cinders. We will begin with your most basic ability - Fireball.','',26124),
(102701,'enUS','','I\'m pleased to be out of the garrison and serving somewhere more suited to our line of work, $ct.',26124),
(102702,'enUS','Fireball is your fundamental damage dealing ability.  It does a large amount of damage up front and then continues to burn your opponent over time.  Use Fireball to destroy this target dummy.','',26124),
(102703,'enUS','Val\'Sharah','Val\'Sharah',26124),
(102704,'enUS','Who would you like to station in Val\'Sharah?','Who would you like to station in Val\'Sharah?',26124),
(102705,'enUS','Are you sure? Your champion will be unable to embark on missions while stationed. (NYI)','Are you sure? Your champion will be unable to embark on missions while stationed. (NYI)',26124),
(102706,'enUS','I will help you manage your valarjar from up here and let you know of any opportunities or emergencies that crop up.','',26124),
(102707,'enUS','I would like to station a different champion.','I would like to station a different champion.',26124),
(102708,'enUS','Beware the shadows, for that is where I hunt!','',26124),
(102709,'enUS','Behold Moorgoth, master of the dark abyss!','',26124),
(102710,'enUS','Rok shatter!','',26124),
(102711,'enUS','If you\'ve come seeking a master of the darkness, then you have found him.','',26124),
(102712,'enUS','Rok stronger!','',26124),
(102713,'enUS','Rok... no... break','',26124),
(102714,'enUS','Rok SMASH!','',26124),
(102715,'enUS','Tiny piddle, big puddle.','',26124),
(102716,'enUS','Nothing beat Rok!','',26124),
(102717,'enUS','Where would you like to station a champion?','Where would you like to station a champion?',26124),
(102718,'enUS','I would like to station one of my champions in an area.','I would like to station one of my champions in an area.',26124),
(102719,'enUS','','This is our land now, $r!',26124),
(102720,'enUS','Are you sure you want to recall your champion? They will no longer aid you in combat.','Are you sure you want to recall your champion? They will no longer aid you in combat.',26124),
(102721,'enUS','','I will drape my nest in your bones!',26124),
(102722,'enUS','','Screeekk!',26124),
(102723,'enUS','You no take warglaive!','',26124),
(102724,'enUS','','I shall drop you off the cliffs and feast on your flesh.',26124),
(102725,'enUS','','Aieee!',26124),
(102726,'enUS','','Grawk... the Mother will get you...',26124),
(102727,'enUS','','Avenge me, sisters!',26124),
(102728,'enUS','','This is gonna be GREAT.',26124),
(102729,'enUS','You\'re far from home, little $r.','',26124),
(102730,'enUS','I\'ll crush your skull like a ripe fruit.','',26124),
(102731,'enUS','Perish under the weight of the mountain!','',26124),
(102732,'enUS','You will be fun to crush.','',26124),
(102733,'enUS','You will not stop us! This land is ours!','',26124),
(102734,'enUS','The Deep... calls...','',26124),
(102735,'enUS','You cannot destroy mountains.','',26124),
(102736,'enUS','How could... something so small...','',26124),
(102737,'enUS','Crok it all!','',26124),
(102738,'enUS','A true hero never fights alone. This challenge will demonstrate your cunning and prowess as part of a team. Work with your partner to overcome this test.$b$bIs your team ready?','',26124),
(102739,'enUS','Rehgar and I are ready!','Rehgar and I are ready!',26124),
(102740,'enUS','Ayiyiyi!','',26124),
(102741,'enUS','Me kill you! Make big bosses proud!','',26124),
(102742,'enUS','Big bosses king of mountains. We bring you to big boss!','',26124),
(102743,'enUS','In mountain, candle take you!','',26124),
(102744,'enUS','You no take candle!','',26124),
(102745,'enUS','Candle! Mine!','',26124),
(102746,'enUS','Aaaaaaaaaaah!','',26124),
(102747,'enUS','Rakinishu!','',26124),
(102748,'enUS','Ickinicka!','',26124),
(102749,'enUS','Rrribitack!','',26124),
(102750,'enUS','No!','',26124),
(102751,'enUS','For Candle King!','',26124),
(102752,'enUS','My mountain!','',26124),
(102753,'enUS','You no take mountain!','',26124),
(102754,'enUS','Iiiiii take candle!','',26124),
(102755,'enUS','Brrribitit!','',26124),
(102756,'enUS','I bite! You die!','',26124),
(102757,'enUS','Should we let live? <Nah!>','',26124),
(102758,'enUS','Let\'s cook it! <Eat it raw!>','',26124),
(102759,'enUS','Orrrugggghhh! <You get bone stuck in teeth again?>','',26124),
(102760,'enUS','Hard on outside! <Chewy inside!>','',26124),
(102761,'enUS','Juicy snack! <Me first!>','',26124),
(102762,'enUS','This my place! <Let\'s eat!>','',26124),
(102763,'enUS','Me get it! <No me get it!>','',26124),
(102764,'enUS','I get the top part! <No, my turn!>','',26124),
(102765,'enUS','Is it tasty? <Oh yeah, once we get it out of that crunchy armor shell.>','',26124),
(102766,'enUS','Smash \'em! <Crash \'em!>','',26124),
(102767,'enUS','I don\'t like you! <I don\'t like you either!>','',26124),
(102768,'enUS','','They are used on fresh corpses, collecting souls to fuel the Legion\'s Soul Engines.',26124),
(102769,'enUS','Those who challenge me only speed themselves to an agonizing death.','',26124),
(102770,'enUS','So says the shadow of Xavius.','',26124),
(102771,'enUS','Be still, worm! I will deal with you shortly.','',26124),
(102772,'enUS','A fluke. Savor it, and pray you do not face me next.','',26124),
(102773,'enUS','They will be more than prepared, for your true power rests in the Nightmare.','',26124),
(102774,'enUS','Silence, weakling! When you open your mouth again, it will be to cry for mercy!','',26124),
(102775,'enUS','A pity you have come this far only to die at the hands of Xavius!','',26124),
(102776,'enUS','An empty threat. You hold no sway over this realm, Nightmare Lord.','',26124),
(102777,'enUS','Bold words for a prisoner. Even an echo of my power was enough to overwhelm you!','',26124),
(102778,'enUS','A pity you have come this far only to die at the hands of Xavius!','',26124),
(102779,'enUS','Your voice is but a whisper in this realm.','',26124),
(102780,'enUS','Your mind games hold no sway over me, dog!','',26124),
(102781,'enUS','First you suffer; then you die!','',26124),
(102782,'enUS','Stand together if you hope to win!','',26124),
(102783,'enUS','I will fracture your feeble mind!','',26124),
(102784,'enUS','You will waste away slowly, painfully.','',26124),
(102785,'enUS','You can trust no one-not even your comrades!','',26124),
(102786,'enUS','Fight back! Do not let him manipulate you.','',26124),
(102787,'enUS','For every blow you strike, I will return even stronger!','',26124),
(102788,'enUS','Your attacks are of little concern. The Nightmare will restore me!','',26124),
(102789,'enUS','I will help, but you must free me. Attack the roots!','',26124),
(102790,'enUS','TEST','TEST',26124),
(102791,'enUS','These roots bind me. Destroy them!','',26124),
(102792,'enUS','It is time to end this.','',26124),
(102793,'enUS','Farce? Ha! So says the insect to the god!','',26124),
(102794,'enUS','This must be some kind of... mistake...','',26124),
(102795,'enUS','You cannot... defeat a... god...','',26124),
(102796,'enUS','No, no! I refuse to... accept...','',26124),
(102797,'enUS','Don\'t act surprised.','',26124),
(102798,'enUS','You never stood a chance.','',26124),
(102799,'enUS','Weak!','',26124),
(102800,'enUS','You deserve nothing less!','',26124),
(102801,'enUS','What is this? Don\'t make me laugh!','',26124),
(102802,'enUS','Trespassers will be punished.','',26124),
(102803,'enUS','I will break you!','',26124),
(102804,'enUS','You wish to die? So be it!','',26124),
(102805,'enUS','What other outcome could there be when one is faced with the wrath of a god?','',26124),
(102806,'enUS','The same fate awaits all who oppose Xavius!','',26124),
(102807,'enUS','None may challenge me and live!','',26124),
(102808,'enUS','A well-earned victory! We must, however, stay vigilant. Deep inside the Nightmare Xavius remains, unvanquished. The enemy you fought here was merely his shadow.','',26124),
(102809,'enUS','If you truly love nature, you will find death everywhere.','If you truly love nature, you will find death everywhere.',26124),
(102810,'enUS','An early morning sacrifice is a blessing for the whole day.','An early morning sacrifice is a blessing for the whole day.',26124),
(102811,'enUS','Nature never hurries, it kills slowly... painfully.','Nature never hurries, it kills slowly... painfully.',26124),
(102812,'enUS','My profession is to always find agony in nature.','My profession is to always find agony in nature.',26124),
(102813,'enUS','To sit in the shade on a fine day and look upon a rotting corpse is the most perfect refreshment.','To sit in the shade on a fine day and look upon a rotting corpse is the most perfect refreshment.',26124),
(102814,'enUS','It seems you\'ve been followed, $c! Dark Riders!','',26124),
(102815,'enUS','All seasons are beautiful for the person who carries cruelty within.','All seasons are beautiful for the person who carries cruelty within.',26124),
(102816,'enUS','The battle is won, but there will be more. Quickly, to Ariden\'s camp!','',26124),
(102817,'enUS','I am ready.','I am ready.',26124),
(102818,'enUS','Try to keep up, $c!','',26124),
(102819,'enUS','Flowers and maggots are heaven\'s masterpiece.','Flowers and maggots are heaven\'s masterpiece.',26124),
(102820,'enUS','Quickly! We don\'t have time to linger!','',26124),
(102821,'enUS','Do you wish to be left behind? Hurry!','',26124),
(102822,'enUS','Look out behind you!','',26124),
(102823,'enUS','Never lose an opportunity to kill anything that is beautiful.','Never lose an opportunity to kill anything that is beautiful.',26124),
(102824,'enUS','Your skill in combat is impressive. We may yet survive this.','',26124),
(102825,'enUS','The poor souls doomed to haunt this place. No wonder such darkness stems from here.','',26124),
(102826,'enUS','Come, let us continue.','',26124),
(102827,'enUS','Riders on our flank! Be ready!','',26124),
(102828,'enUS','A burden carried by one can bring them to their knees, but carried by many and it becomes a lesson from which we learn.','',26124),
(102829,'enUS','One day I\'ll find it...','One day I\'ll find it...',26124),
(102830,'enUS','Let us press on. We are nearly there.','',26124),
(102831,'enUS','Here! The camp is in this clearing. Let us search it.','',26124),
(102832,'enUS','The lovers... the dreamers... and me.','The lovers... the dreamers... and me.',26124),
(102833,'enUS','The maggots will consume your corpse!','The maggots will consume your corpse!',26124),
(102834,'enUS','Boss is the best!','',26124),
(102835,'enUS','I want to destroy... I want you to bleed.','I want to destroy... I want you to bleed.',26124),
(102836,'enUS','After I kill you, I will revive you and kill you again.','After I kill you, I will revive you and kill you again.',26124),
(102837,'enUS','Go ahead, $n, you can cry!','Go ahead, $n, you can cry!',26124),
(102838,'enUS','I feel like destroying something beautiful.','I feel like destroying something beautiful.',26124),
(102839,'enUS','','Look how much the flowers like the blood.',26124),
(102840,'enUS','','I wonder if gnome is in season?',26124),
(102841,'enUS','There is no glory to be found inside a cage.','',26124),
(102842,'enUS','','Be very, very quiet. I\'m hunting $r.',26124),
(102843,'enUS','','Did you see the way that faerie dragon flopped around after I tore its wings off?',26124),
(102844,'enUS','','Greetings, Huntmaster $n. It would be my honor to assist you in stabling your pets or helping find a lost companion.',26124),
(102845,'enUS','<Waits patiently with wide eyes for his reward.>','',26124),
(102846,'enUS','<Give Trytooth the boot.>','<Give Trytooth the boot.>',26124),
(102847,'enUS','Big bosses... gonna get you.','',26124),
(102848,'enUS','Me see tunnel. Candle light way!','',26124),
(102849,'enUS','Hey, $p. I\'ve got a shiny gold piece for you if you can get me off this floating rock.','',26124),
(102850,'enUS','I\'m here to reclaim the jewels you stole.','I\'m here to reclaim the jewels you stole.',26124),
(102851,'enUS','$ct, I present to you Eitrigg. You will find his axe sharp and council wise.','',26124),
(102852,'enUS','I stand ready to go where you send me, aid our allies, and crush our foes!','',26124),
(102853,'enUS','Oh really? You think I\'ll just give them up that easily? Over my dead body!','',26124),
(102854,'enUS','I ride to Gilneas now, to prepare our forces for the coming storm. Stay strong, champion.','',26124),
(102855,'enUS','','Well well, what do we have here? A tasty $r for me to eat!',26124),
(102856,'enUS','','Sometimes I wish a flower could cry.',26124),
(102857,'enUS','','You will pay for attacking my daughters!',26124),
(102858,'enUS','','This is our home now. Begone!',26124),
(102859,'enUS','','You can\'t take the sky from me.',26124),
(102860,'enUS','','The brood... will survive.',26124),
(102861,'enUS','','First the cave dwellers, now this...',26124),
(102862,'enUS','','Naga blood must be spilled! Free my brothers and sisters so that they may join me in glorious battle!',26124),
(102863,'enUS','This best boot ever. Bet it burns brighter than candle!','',26124),
(102864,'enUS','','What has happened? What have you done to me?!',26124),
(102865,'enUS','Do not be ashamed. You fought with courage and honor.','',26124),
(102866,'enUS','There is no shame in defeat so long as one fights with valor.','',26124),
(102867,'enUS','','My mind is... cleared. I will sleep now. Give Thaedris my love.',26124),
(102868,'enUS','I feel... invigorated! Care to try again, champions?','',26124),
(102869,'enUS','I must keep this land from protected from the defilers.','',26124),
(102870,'enUS','I hear them... they are whispering.','',26124),
(102871,'enUS','I just want to sleep, but if I do they will get me.','',26124),
(102872,'enUS','What was that? Did you hear that?','',26124),
(102873,'enUS','The voices say I am a lunatic... but they lie!','',26124),
(102874,'enUS','','Don\'t die too fast, I want to hear you scream.',26124),
(102875,'enUS','','More blood for my plants!',26124),
(102876,'enUS','','You can run, but you will only die tired.',26124),
(102877,'enUS','','I love pain so much... I mean yours, not mine!',26124),
(102878,'enUS','You have final come out of the shadows, fiend!','',26124),
(102879,'enUS','Most impressive! I never thought I would meet anyone who could match the Valarjar\'s strength... and yet here you stand.','',26124),
(102880,'enUS','I may be about to die, but you are coming with me!','',26124),
(102881,'enUS','There is one final trial that awaits: me. Should you triumph, I will carve your names in these sacred halls myself and grant you a reward worthy of your valor.','',26124),
(102882,'enUS','Why won\'t you leave me alone? DIE!','',26124),
(102883,'enUS','My power is beyond anything you have yet faced!','',26124),
(102884,'enUS','You think I am afraid of you? You are the coward!','',26124),
(102885,'enUS','Be warned, champions: I will hold NOTHING back!','',26124),
(102886,'enUS','Yield now... or I will call upon my true power!','',26124),
(102887,'enUS','Hurry, friends. Every moment we linger, Dargrul kills more of our allies.','',26124),
(102888,'enUS','I will choke the life from you!','',26124),
(102889,'enUS','Let us see if your wits are as sharp as your weapons!','',26124),
(102890,'enUS','I will bathe in your blood!','',26124),
(102891,'enUS','An agile mind is as deadly as the sharpest blade!','',26124),
(102892,'enUS','Now the real nightmare begins!','',26124),
(102893,'enUS','Every opponent has a weakness. I will find yours!','',26124),
(102894,'enUS','Now I break your mind.','',26124),
(102895,'enUS','$n... yes, I remember you from before I left the Illidari. Thank you.','',26124),
(102896,'enUS','My father\'s ancient lair. There is still power within these rocks that should not be disturbed.','',26124),
(102897,'enUS','You came all this way only to die... sad.','',26124),
(102898,'enUS','This is a nightmare you will never awake from!','',26124),
(102899,'enUS','That\'s got to be the biggest crystal hulk I\'ve ever seen!','',26124),
(102900,'enUS','I will feast on you tonight.','',26124),
(102901,'enUS','Mighty Valarjar! Heed my summons!','',26124),
(102902,'enUS','You look... Tasty!','',26124),
(102903,'enUS','To me, Valarjar! Prove your worth!','',26124),
(102904,'enUS','Fight for me, Valarjar! Fight for GLORY!','',26124),
(102905,'enUS','I love it when dinner comes to me.','',26124),
(102906,'enUS','Ularogg can bend any stone! He could-wait. Where did they come from?!','',26124),
(102907,'enUS','Enough! I... I yield! You are truly remarkable creatures. As promised, you will have your just reward.','',26124),
(102908,'enUS','A noble effort!','',26124),
(102909,'enUS','Well fought!','',26124),
(102910,'enUS','Intruders? Here?! Break them!','',26124),
(102911,'enUS','I was only getting started!','',26124),
(102912,'enUS','Did you really hope to best me?','',26124),
(102913,'enUS','It has been ages since I faced a worthy opponent. Let the battle begin!','',26124),
(102914,'enUS','Long have I waited to face a worthy opponent! Do not disappoint me!','',26124),
(102915,'enUS','Quickly! Stop that lookout before he can sound the alarm!','',26124),
(102916,'enUS','I\'ll meet you down in Azsuna, $n. Come find me when you discover something.','',26124),
(102917,'enUS','The Underking uses slaves to dig at the bones of my father?! He does not know the powers he meddles with.','',26124),
(102918,'enUS','These drogbar have been tapping into abilities they should not possess. No doubt it has something to do with the latent power still lingering within these rocks.','',26124),
(102919,'enUS','No! I, too, have proved my worth, Odyn. I am God-King Skovald! These mortals dare not challenge my claim to the aegis!','',26124),
(102920,'enUS','If these false champions will not yield the aegis by choice... then they will surrender it in death!','',26124),
(102921,'enUS','Give up the aegis or die!','',26124),
(102922,'enUS','No one stands in my way!','',26124),
(102923,'enUS','I will not be stopped!','',26124),
(102924,'enUS','You overestimated your skill!','',26124),
(102925,'enUS','Little more than a nuisance!','',26124),
(102926,'enUS','Another obstacle removed!','',26124),
(102927,'enUS','All my plans... brought to ruin...','',26124),
(102928,'enUS','The aegis goes to its rightful owner!','',26124),
(102929,'enUS','You will not keep what you did not earn!','',26124),
(102930,'enUS','The power is mine!','',26124),
(102931,'enUS','Now the aegis is where it belongs!','',26124),
(102932,'enUS','Trail... by fire!','',26124),
(102933,'enUS','Burn for me!','',26124),
(102934,'enUS','Perish in never-ending flame!','',26124),
(102935,'enUS','By flame be scourged!','',26124),
(102936,'enUS','Your suffering will be eternal!','',26124),
(102937,'enUS','You will die in agony!','',26124),
(102938,'enUS','Cry for mercy... so the Legion may laugh!','',26124),
(102939,'enUS','Valarjar! Defend these sacred halls!','',26124),
(102940,'enUS','Navarrogg?! Betrayer! You would lead these intruders against us?!','',26124),
(102941,'enUS','Let your worth be measured in blood!','',26124),
(102942,'enUS','I will bleed the weakness from your veins!','',26124),
(102943,'enUS','The blood of the unworthy will flow through these halls!','',26124),
(102944,'enUS','Drake riders! To me!','',26124),
(102945,'enUS','Storm drakes! At my side!','',26124),
(102946,'enUS','Drake riders, I call upon your aid!','',26124),
(102947,'enUS','Do not let the gates fall!','',26124),
(102948,'enUS','Rally! Rally!','',26124),
(102949,'enUS','Resist! Fight to the last!','',26124),
(102950,'enUS','It is I... who am unworthy.','',26124),
(102951,'enUS','A battle well fought! The path forward is open.','',26124),
(102952,'enUS','All goes according to HIS plan.','',26124),
(102953,'enUS','Very well. I will test your worth myself!','',26124),
(102954,'enUS','Lord Gul\'dan will lead us to victory. You cannot stop us.','',26124),
(102955,'enUS','The undeserving will perish!','',26124),
(102956,'enUS','I will be the judge now.','',26124),
(102957,'enUS','Unworthy!','',26124),
(102958,'enUS','You have failed!','',26124),
(102959,'enUS','Your trial ends here.','',26124),
(102960,'enUS','It is over.','',26124),
(102961,'enUS','These halls remain pure.','',26124),
(102962,'enUS','So it ends: the unworthy vanquished.','',26124),
(102963,'enUS','My vigil continues.','',26124),
(102965,'enUS','','Through great deeds of courage and valor, Hyrja has earned this most sacred of rites. She shall ascend as one of my chosen val\'kyr, and her name shall echo in these gilded halls for all eternity.',26124),
(102966,'enUS','Are you nervous, Hyrja? It is understandable if-','',26124),
(102967,'enUS','','I am not nervous. Only... excited. All my life has led to this one glorious moment.',26124),
(102968,'enUS','Spoken like a true val\'kyr.','',26124),
(102969,'enUS','Mortal intruders approach!','',26124),
(102970,'enUS','','I... I remember their kind. They and one of their cursed leaders sought to enslave me in Stormheim!',26124),
(102971,'enUS','','I witnessed their deeds in Stormheim. Their kind has no true honor. No true virtue.',26124),
(102972,'enUS','','All clear, Huntmaster $n. No enemies in sight.',26124),
(102973,'enUS','','I will purge them from these sacred halls myself!',26124),
(102974,'enUS','','The ritual is not yet complete.',26124),
(102975,'enUS','You will not deny Hyrja\'s ascendance!','',26124),
(102976,'enUS','The Light shines eternal in you, Hyrja!','',26124),
(102977,'enUS','You sully this ritual with your presence, mortals!','',26124),
(102978,'enUS','Hyrja... the fury of the storm is yours to command!','',26124),
(102979,'enUS','Dargrul cannot control the hammer, Ularogg! He will DESTROY Highmountain, not CONQUER it!','',26124),
(102980,'enUS','The Light embraces you, Hyrja!','',26124),
(102981,'enUS','Revel in the power of the Light!','',26124),
(102982,'enUS','The storm gathers! Strike now, Hyrja!','',26124),
(102983,'enUS','Either way, I will enjoy every moment of it. Rokmora, crush them!','',26124),
(102984,'enUS','The storm gathers within you, Hyrja!','',26124),
(102985,'enUS','','Begone from these hallowed halls!',26124),
(102986,'enUS','','You will pollute these halls no more!',26124),
(102987,'enUS','','I am sorry, Eyir... I have failed you...',26124),
(102988,'enUS','','Eyir... you were wrong to put your faith in me...',26124),
(102989,'enUS','','None can stand against Eyir\'s chosen!',26124),
(102990,'enUS','','You die as you lived: without honor.',26124),
(102991,'enUS','They know we\'re coming now. I hope our allies can keep their main forces occupied long enough for us to complete our mission.','',26124),
(102992,'enUS','Is everything alright?','Is everyone alright?',26124),
(102993,'enUS','','I will not fail you, Eyir!',26124),
(102994,'enUS','What happened at Broken Shore?','What happened at Broken Shore?',26124),
(102995,'enUS','I wonder how much longer they\'ll meet.','I wonder how much longer they\'ll meet.',26124),
(102996,'enUS','','It is done, Eyir. The sanctity of this place is preserved.',26124),
(102997,'enUS','I saw some of them return. It didn\'t look good.','I saw some of them return. It didn\'t look good.',26124),
(102998,'enUS','Please! Is there something wrong?','Please! Is there something wrong?',26124),
(102999,'enUS','Is the threat over?','Is the threat over?',26124),
(103000,'enUS','Quickly, into the barrels! I\'ll hold them here and join you down river!','',26124),
(103001,'enUS','No, I won\'t be doing that. I will find my own path and rejoin you on the other side.','',26124),
(103002,'enUS','Use the finest wax to craft a magical candle, worthy of the Candleking.','Use the finest wax to craft a magical candle, worthy of the Candleking.',26124),
(103003,'enUS','Wax what? Boss talk gibberish.','',26124),
(103004,'enUS','Pilfer golden coins from graves within the nearby burial grounds.','Pilfer golden coins from graves within the nearby burial grounds.',26124),
(103005,'enUS','I hope everything is alright.','I hope everything is alright.',26124),
(103006,'enUS','Is the Warchief alright?','Is the Warchief alright?',26124),
(103007,'enUS','Boss make up words? No understand.','',26124),
(103008,'enUS','Where are you hiding your food, maggot?!','',26124),
(103009,'enUS','Boss ok? Boss hit head and talk weird?','',26124),
(103010,'enUS','Slay the strongest basilisk that roams these caverns and drag its lifeless corpse to my feet!','Slay the strongest basilisk that roams these caverns and drag its lifeless corpse to my feet!',26124),
(103011,'enUS','Please, you\'ve already taken all the food we have.','',26124),
(103012,'enUS','Search everywhere! These peasants have been hiding rations from the army! If you\'re not fighting, you\'re not eating!','',26124),
(103013,'enUS','Use your pickaxe to mine precious metals from the richest vein in the cavern, and bring the samples back to me.','Use your pickaxe to mine precious metals from the richest vein in the cavern, and bring the samples back to me.',26124),
(103014,'enUS','I sense a powerful artifact hidden behind this wall. Tread carefully heroes, my father rarely left such prized possessions unguarded.','',26124),
(103015,'enUS','That was easier than expected.','',26124),
(103016,'enUS','Boss no sound like kobold.','',26124),
(103017,'enUS','I\'m headed back to Dalaran now. I\'ll see you around, $n.','',26124),
(103019,'enUS','Illidan... now, you belong to the Legion.','',26124),
(103020,'enUS','Prize in junk pile right by boss.','',26124),
(103021,'enUS','Dagmyr better have left some naga for me!','',26124),
(103022,'enUS','That is much better!','',26124),
(103023,'enUS','Highmountain itself rises against you!','',26124),
(103024,'enUS','Your bones shatter so EASILY.','',26124),
(103025,'enUS','Highmountain will be your tomb!','',26124),
(103026,'enUS','Go ahead and RUN. It will change nothing.','',26124),
(103027,'enUS','You will never wield the power of Khaz\'goroth!','',26124),
(103028,'enUS','So this is what it feels like to break.','',26124),
(103030,'enUS','A moment, $c...','',26124),
(103031,'enUS','Pay attention, Navarogg. I want you to see your heroes die.','',26124),
(103032,'enUS','<hic>','',26124),
(103034,'enUS','I keep chair warm while boss gone.','',26124),
(103035,'enUS','There is no escape! Your essence will feed the master!','',26124),
(103036,'enUS','Stand against the drogbar and face the might of Khaz\'goroth himself!','',26124),
(103037,'enUS','Highmountain take you!','',26124),
(103038,'enUS','So brittle! So easy to break!','',26124),
(103039,'enUS','That felt WONDERFUL.','',26124),
(103040,'enUS','Is someone there? Anyone!? Help!!!','',26124),
(103043,'enUS','Mother of Worms! Arise!','',26124),
(103044,'enUS','Rummaging','Rummaging',26124),
(103046,'enUS','If they complete this summoning, our passage to Dargrul will be blocked!','',26124),
(103047,'enUS','She comes! Naraxas will feast on your bones!','',26124),
(103048,'enUS','Yes! AHAHAHA! Wait-nooo! AAAHHHHHhhhhh!','',26124),
(103049,'enUS','You will be food for Naraxas!','',26124),
(103050,'enUS','Stop them!','',26124),
(103051,'enUS','NOOOoooooo!','',26124),
(103052,'enUS','AAAHHHhhhh!','',26124),
(103053,'enUS','Naraxas. Naraxas. Naraxas!','',26124),
(103054,'enUS','There is no more time! We must strike at Dargrul now!','',26124),
(103055,'enUS','I am sorry, heroes. It appears the treasure you seek will be found on the \"other\" end of this beast.','',26124),
(103056,'enUS','Finding Perfect Book','Finding Perfect Book',26124),
(103057,'enUS','The tauren believed YOU were prophesied to seize MY hammer? Pathetic.','',26124),
(103058,'enUS','Let them come! Witness the fate of those who stand against one WORTHY of wielding the power of a titan!','',26124),
(103059,'enUS','I am sorry heroes, I must leave you now. Yet know this, I have witnessed your deeds with pride and I am sure you will not fail Highmountain in this final hour.','',26124),
(103060,'enUS','I can shape the world just as the titans did!','',26124),
(103061,'enUS','The mountain will gnaw on your bones!','',26124),
(103062,'enUS','The earth heaves and roars at MY command!','',26124),
(103063,'enUS','The molten soul of Azeroth engulfs you!','',26124),
(103064,'enUS','Highmountain will swallow you whole!','',26124),
(103065,'enUS','It is time to end this.','',26124),
(103066,'enUS','I AM THE SHAPER AND FORGER OF THIS WORLD!','',26124),
(103067,'enUS','The might of Khaz\'goroth flows through ME!','',26124),
(103068,'enUS','How is this possible?! I... I was chosen...','',26124),
(103069,'enUS','The tauren were wrong about you!','',26124),
(103070,'enUS','The hammer falls upon you!','',26124),
(103071,'enUS','Yes. TRY to take the hammer from me!','',26124),
(103072,'enUS','I will break this world asunder before I let you take my hammer!','',26124),
(103073,'enUS','Only I can wield the hammer\'s power.','',26124),
(103074,'enUS','I will reforge this world as I see fit!','',26124),
(103075,'enUS','The hammer never chose you, Dargrul. It seeks a wielder who possesses true strength, and you were found lacking.','',26124),
(103076,'enUS','It\'s done, heroes. With Dargrul dead and the hammer reclaimed, the drogbar are broken. Now begins the long task of reuniting our tribes, but balance has returned to Highmountain.','',26124),
(103077,'enUS','The power of the mad king Dargrul is broken and Highmountain has you to thank, heroes. Now, there are other family matters that require my attention. Farewell, I hope when next we meet it is under more peaceful circumstances.','',26124),
(103078,'enUS','Jace, what is this Nether Crucible?','Jace, what is this Nether Crucible?',26124),
(103079,'enUS','[ph]Thank you, friends. I\'d surely be dead if you hadn\'t intervened!','',26124),
(103080,'enUS','The crucible? It\'s a device that we can use to scry upon others or communicate across great distances.\n\nWe can even use it to contact other dimensions.\n\nIt feeds on fel energy. The more distant the target, the more energy required by the ritual.','',26124),
(103081,'enUS','','Get me out of this thing!',26124),
(103082,'enUS','I eliminated those who were taking Illidan down the wrong path.','',26124),
(103083,'enUS','','Ohhhh... My head still feels like it\'s spinning!',26124),
(103084,'enUS','','What\'s going on over there? Hello? Hi!',26124),
(103086,'enUS','','They don\'t look so happy to see us.',26124),
(103087,'enUS','','Here, have some of my very own healing brew. You\'ll feel better in no time!',26124),
(103088,'enUS','','Wheeeee! Bet you can\'t catch me!',26124),
(103089,'enUS','','Hey, it\'s that big ugly guy again.',26124),
(103090,'enUS','','Can\'t we all just get along? No? Okay then... you asked for it!',26124),
(103091,'enUS','','Blah, blah, blah! You sure do talk a lot.',26124),
(103092,'enUS','','Look at those big sparking orbs! I wonder what happens if we poke one?',26124),
(103093,'enUS','','Hah! That was a piece of cake!',26124),
(103094,'enUS','','Holy smokes! Dragon!',26124),
(103098,'enUS','','Let\'s get moving! That dragon isn\'t going to punch itself!',26124),
(103099,'enUS','','Oh... hold on! I\'ll... I\'ll figure out some way to follow you! Just hold on!',26124),
(103100,'enUS','','Phew! That\'s one heck of a fall! I can\'t even see the ground down there!',26124),
(103101,'enUS','','Do me a favor and NEVER tell Uncle Chen I was this high up. Okay?',26124),
(103102,'enUS','','Whoa! This guy is, like, super tough! Do you think we can beat him?',26124),
(103103,'enUS','','Yeah, you got this!',26124),
(103104,'enUS','','That was awesome!! I was like, \"Oh no!\" And you were like, \"leave it to me!\"',26124),
(103106,'enUS','','This has been a fantastic adventure! We explored the desert, punched a dragon in the face, and even got you something shiny!',26124),
(103107,'enUS','','All this adventuring\'s making me sleepy. Let\'s head back to the Wandering Isle.',26124),
(103108,'enUS','Now is not the time, $n.','',26124),
(103109,'enUS','','Broken Shore was just the beginning. The Alliance will retaliate. Given the opportunity, they will strike when we are weak.',26124),
(103110,'enUS','|TInterface\\Icons\\inv_misc_monsterspidercarapace_01:20|tNearby |cFFFF0000|Hspell:198235|h[Spider Eggs]|h|r will hatch soon if not destroyed!.','',26124),
(103111,'enUS','[ph]I\'m free, but others of my people are still suffering on the walls above. Please, help them!','',26124),
(103112,'enUS','[ph]We\'ve seen the creatures use this room to travel to the lands below; with it we can escape this place.','',26124),
(103113,'enUS','','Pretty neat, huh?',26124),
(103114,'enUS','','\"May the night shroud me in shadow...\"',26124),
(103115,'enUS','','Stand down! This one has purpose for treading here.',26124),
(103116,'enUS','','Pardon me, but if I may be so bold as to interrupt...',26124),
(103117,'enUS','Build a pyre around Jarl Throndyr.','Build a pyre around Jarl Throndyr.',26124),
(103118,'enUS','Is that really $Ghim:her;?','Is that $Ghim:her;?',26124),
(103119,'enUS','I will devour your soul!','',26124),
(103120,'enUS','Foolish Illidari! Have you come to die as well?','',26124),
(103121,'enUS','Very well.','Very well.',26124),
(103122,'enUS','Be careful around this one. Who knows what he\'s capable of.','Be careful around this one. Who knows what he\'s capable of.',26124),
(103123,'enUS','','Such poor souls. You don\'t even belong here, but you will be forever bound to this place.',26124),
(103124,'enUS','|TInterface\\Icons\\Spell_Holy_DivineProvidence:20|t $n is afflicted with |cFFFF0404|Hspell:192067|h[Expel Light]|h|r!','|TInterface\\Icons\\Spell_Holy_DivineProvidence:20|t $n is afflicted with |cFFFF0404|Hspell:192067|h[Expel Light]|h|r!',26124),
(103125,'enUS','','Do not fret. Through Ulthalesh, you will be so much more in death than you were in life.',26124),
(103126,'enUS','','You were fools to think such a pitiful force could oppose an agent of Sargeras!',26124),
(103127,'enUS','','Your worthless lives will pave the way for the Legion!',26124),
(103128,'enUS','','How quaint. Do you really think your Holy Light can protect you from the Legion\'s onslaught?',26124),
(103129,'enUS','','Where is your Light to protect you now?',26124),
(103130,'enUS','That\'s the $c. $GHe:She was there.','That\'s the $c. $GHe:She was there.',26124),
(103131,'enUS','Look, that\'s the $c!','Look, that\'s the $c!',26124),
(103132,'enUS','I wonder why they asked for $Ghim:her;?','I wonder why they asked for $Ghim:her;?',26124),
(103133,'enUS','I didn\'t know $Ghe:she; was a $c.','I didn\'t know $Ghe:she; was a $c.',26124),
(103134,'enUS','I wish I was at the Shore. I would have fought alongside $n.','I wish I was at the Shore. I would have fought alongside $n.',26124),
(103135,'enUS','Isn\'t that $n? $GHe:She; made it back!','Isn\'t that $n? $GHe:She; made it back!',26124),
(103136,'enUS','Arggh! What power... is this?!','',26124),
(103137,'enUS','No quarter to these scallywags! Helya doesn\'t abide intruders.','',26124),
(103138,'enUS','Send in the skeleton crew!','',26124),
(103139,'enUS','What will you do now?','What will you do now?',26124),
(103140,'enUS','','We cannot afford to lose Kayn and Altruis here. Waste no time and help them, quickly!',26124),
(103141,'enUS','That feels SOO much better. Thank you, errr... what do I call you?','',26124),
(103142,'enUS','(TEMP) FUNERAL CINEMATIC PLAYS (10 second delay)\nQuest Criteria will Progress in 8 seconds','(TEMP) FUNERAL CINEMATIC PLAYS (10 second delay)',26124),
(103143,'enUS','You will never see the light of this world again.','',26124),
(103144,'enUS','Freedom is but a hopeless dream.','',26124),
(103145,'enUS','Such arrogance.... To think you can stand against the Legion!','',26124),
(103146,'enUS','Show me the proof.','Show me the proof.',26124),
(103147,'enUS','','Your eyes are deceiving you. Do not trust them!',26124),
(103148,'enUS','Hey, brul. You don\'t look very strong to me...','',26124),
(103149,'enUS','You\'re stronger than I thought, brul.','',26124),
(103150,'enUS','These bruls could learn a thing or two from you.','',26124),
(103151,'enUS','I dropped the weights...','I dropped the weights...',26124),
(103152,'enUS','Wretched Illidari! What have you done to me?','',26124),
(103153,'enUS','','Hush, demon. This will all be over soon.',26124),
(103154,'enUS','I shall aid you, friend. Let us banish this foul presence from Tel\'anor!','',26124),
(103155,'enUS','I thank you for giving me newfound purpose. I will meet you at Shal\'Aran. I think I will be needing a source of magic after all.','',26124),
(103156,'enUS','Rarrgh!!','',26124),
(103161,'enUS','','I am pleased you have arrived.',26124),
(103162,'enUS','Snowfeather swoops down and hovers expectantly. She has a message!','',26124),
(103163,'enUS','The doors to Grommash Hold have been sealed. The leaders of the Horde must be protected!','',26124),
(103164,'enUS','Take me inside Grommash Hold.','Take me inside Grommash Hold.',26124),
(103165,'enUS','I\'m looking for a master jewelcrafter.','I\'m looking for a master jewelcrafter.',26124),
(103166,'enUS','I would like to review weapons we might pursue.','I would like to review weapons we might pursue.',26124),
(103167,'enUS','','Oh, you\'re looking for Jabrul.',26124),
(103168,'enUS','','He passed through here a few days ago. Went towards the Wretched Hollow to study the harpies.',26124),
(103169,'enUS','','Haven\'t seen him since though. Hopefully he didn\'t succumb to the same affliction as the harpies.',26124),
(103170,'enUS','Have you come to finish off Jabrul? If so, make it quick!','',26124),
(103171,'enUS','What happened to you?','What happened to you?',26124),
(103172,'enUS','Jabrul was attacked by the harpies and barely managed to hide.$b$bJabrul dropped his bag of jewels. Jabrul needs those jewels to heal himself.','',26124),
(103173,'enUS','Here\'s your bag, Jabrul.','Here\'s your bag, Jabrul.',26124),
(103174,'enUS','Nighteyes hoots at you in a grateful tone.','',26124),
(103175,'enUS','Not right now, $n. This whole thing\'s got me down.','',26124),
(103176,'enUS','Not much in the mood for fishing today.','',26124),
(103177,'enUS','Today we remember. Tomorrow we train.','',26124),
(103178,'enUS','It is a sad day indeed.','',26124),
(103179,'enUS','Those who lead sacrifice a great many things.','',26124),
(103180,'enUS','','Ashildir has told me of your exploits. You seek my mark so that you might impress Odyn.',26124),
(103181,'enUS','','Stand on the dais and we will begin.',26124),
(103182,'enUS','','Kneel before me, mortal.',26124),
(103183,'enUS','','|TInterface\\Icons\\inv_misc_leatherscrap_17.blp:20|t %s has no one to melee and begins to |cFFFF0000|Hspell:198520|h[Wing Buffet]|h|r!',26124),
(103184,'enUS','','%s shatters all remaining ice blocks, freeing the geists inside!',26124),
(103185,'enUS','','You have proven your worth as a Valkyra, but the trials to come are arduous.',26124),
(103186,'enUS','','Wear proudly our mark, and perhaps you will prove worthy of Odyn\'s blessing.',26124),
(103187,'enUS','','Now begone!',26124),
(103188,'enUS','The catacombs\' entrance is just down this path. Make haste!','',26124),
(103189,'enUS','It seems the spirits are indeed drawn to this place. Let us hope they are friendly.','',26124),
(103190,'enUS','I can\'t believe he\'s gone.','I can\'t believe he\'s gone.',26124),
(103191,'enUS','She will lead us to victory in this war.','She will lead us to victory in this war.',26124),
(103192,'enUS','He died with honor.','He died with honor.',26124),
(103193,'enUS','Was it the poison that made Vol\'jin name her-- Uh, nevermind.','Was it the poison that made Vol\'jin name her-- Uh, nevermind.',26124),
(103194,'enUS','Have you paid respects?','Have you paid respects?',26124),
(103195,'enUS','My axe will strike down foes in his honor.','My axe will strike down foes in his honor.',26124),
(103196,'enUS','The Horde was meant to be led by an orc, if you ask me!','The Horde was meant to be led by an orc, if you ask me!',26124),
(103197,'enUS','The Legion will pay for his death with their blood!','The Legion will pay for his death with their blood!',26124),
(103198,'enUS','Today be de day of reflection.','Today be de day of reflection.',26124),
(103199,'enUS','De Darkspear gonna be rememberin\' dis day.','De Darkspear gonna be rememberin\' dis day.',26124),
(103200,'enUS','De pain de warchief went tru... ain\'t nothin\' we be forgettin\' soon.','De pain de warchief went tru... ain\'t nothin\' we be forgettin\' soon.',26124),
(103201,'enUS','Blessin\'s of de Loa be wit him.','Blessin\'s of de Loa be wit him.',26124),
(103202,'enUS','Rest his soul.','Rest his soul.',26124),
(103203,'enUS','De son of Sen\'jin be restin\' wit\' his fatha now.','De son of Sen\'jin be restin\' wit\' his fatha now.',26124),
(103204,'enUS','May de spirits guide him.','May de spirits guide him.',26124),
(103205,'enUS','Wonderin\' what be happenin\' to our people now.','Wonderin\' what be happenin\' to our people now.',26124),
(103206,'enUS','May the Earth Mother watch over him.','May the Earth Mother watch over him.',26124),
(103207,'enUS','Blessings be upon him.','Blessings be upon him.',26124),
(103208,'enUS','The spirits will guide him.','The spirits will guide him.',26124),
(103209,'enUS','The Legion will pay for their crimes.','The Legion will pay for their crimes.',26124),
(103210,'enUS','When our journey ends, it is only the beginning.','When our journey ends, it is only the beginning.',26124),
(103211,'enUS','I assure you, little one, he will not be forgotten.','',26124),
(103212,'enUS','Let us honor the deeds of those who fought for our well-being.','',26124),
(103213,'enUS','','I just can\'t believe it.',26124),
(103214,'enUS','','I never met him, but... I liked knowing he was there, ya know?',26124),
(103215,'enUS','','It\'s a horrible tragedy.',26124),
(103216,'enUS','I\'ve witnessed such sadness too often in my lifetime.','',26124),
(103217,'enUS','I can\'t believe he\'s gone.','',26124),
(103218,'enUS','...Such a tremendous loss for us all.','',26124),
(103219,'enUS','He always be tinkin\' da Horde be one. Dat be da truth, mon.','',26124),
(103220,'enUS','Our people be strong. Let there be no mistakin\'... we in dis together.','',26124),
(103221,'enUS','Tauren, orc, troll, elves, goblins... forsaken. All of us be feelin\' da same ting.','',26124),
(103222,'enUS','Perfect! The one I\'ve been waiting for!','',26124),
(103223,'enUS','Jabrul needs to find unbroken versions of the two stones the harpies use in their necklaces.$b$bLet Jabrul know when you are ready to look for them.','',26124),
(103224,'enUS','Alright, Jabrul, I\'m ready to go.','Alright, Jabrul, I\'m ready to go.',26124),
(103225,'enUS','%s begins to crackle with lightning...','%s begins to crackle with lightning...',26124),
(103226,'enUS','','Thank you for your help. Your intervention saved my life.',26124),
(103227,'enUS','','If you intend to venture deeper you will find far more terrifying things lurking in our Vault.',26124),
(103228,'enUS','','The traitor is defeated. Thank you, we owe you a great debt.',26124),
(103229,'enUS','','I will make my way to the surface, but you should inform the other wardens of what you have accomplished today.',26124),
(103230,'enUS','','May the night shroud you in shadow, and the moon illuminate your foes.',26124),
(103231,'enUS','','I have committed no crime, Tirathon. Whereas you and your associates have to answer for yours!',26124),
(103232,'enUS','','Enough! I must know if Alleria was truly held captive here, or if this was all a ruse to trap us!',26124),
(103233,'enUS','','He\'s tearing into my mind!',26124),
(103234,'enUS','','I felt those eyes peering into my soul. Had you not freed me...',26124),
(103235,'enUS','|TInterface\\Icons\\ability_warrior_shieldreflection.blp:20|tKrustallos casts |cFFFF0000|Hspell:78939|h[Elementium Bulwark]|h|r!','',26124),
(103236,'enUS','If you seek my blessing, then you must complete the ancient trials of the Valarjar.','',26124),
(103237,'enUS','A noble effort, but you are not yet worthy of my blessing.','',26124),
(103238,'enUS','Another... will take... my place...','',26124),
(103239,'enUS','Deprecated','',26124),
(103240,'enUS','Many before have followed the path you walk. None possessed the strength to persevere.','',26124),
(103241,'enUS','','The trip through that demon portal was unsettling. Bide a moment, then let me know when you\'re ready.',26124),
(103242,'enUS','','Let\'s ascend the rise ahead and see what we\'re up against.',26124),
(103243,'enUS','You must place trust in your allies. The truly valorous do not walk alone.','',26124),
(103244,'enUS','You must surge forward while hope remains in your heart!','',26124),
(103245,'enUS','Rally your allies. Do not relent. Your trials are nearly complete!','',26124),
(103246,'enUS','Jabrul will meet you inside the night elf house. Come find Jabrul when you\'re ready.','',26124),
(103247,'enUS','Keep harpies off of Jabrul while he looks for good necklaces.','',26124),
(103248,'enUS','These harpies aren\'t very good at keeping their trinkets safe. Most of these are broken.','',26124),
(103249,'enUS','Jabrul found one of the stones he was looking for. The other one must be around here somewhere.','',26124),
(103250,'enUS','As for you, champion... well done. Well done!','',26124),
(103251,'enUS','Jabrul needs your protection once more. Jabrul will try to be quick.','',26124),
(103252,'enUS','Jabrul doesn\'t understand how the harpies can treat their jewelry with such disregard.','',26124),
(103253,'enUS','Jabrul has found the other stone. We should make our way back to the safety of the night elves.','',26124),
(103254,'enUS','Behold! I bless you with my power.','',26124),
(103255,'enUS','|TInterface\\Icons\\Ability_Rogue_SurpriseAttack:20|t%s is being |cFFFF0000|Hspell:191708|h[Mugged!]|h|r','|TInterface\\Icons\\Ability_Rogue_SurpriseAttack:20|t%s is being |cFFFF0000|Hspell:191708|h[Mugged!]|h|r',26124),
(103256,'enUS','|TInterface\\Icons\\ability_bosskilrogg_deadeye:20|t%s begins channeling their |cFFFF0000|Hspell:190836|h[Hatred!]|h|r','|TInterface\\Icons\\ability_bosskilrogg_deadeye:20|t%s begins channeling their |cFFFF0000|Hspell:190836|h[Hatred!]|h|r',26124),
(103257,'enUS','|TInterface\\Icons\\Ability_Racial_ShadowMeld:20|t%s is about to unleash a |cFFFF0000|Hspell:191823|h[Furious Blast!]|h|r','|TInterface\\Icons\\Ability_Racial_ShadowMeld:20|t%s is about to unleash a |cFFFF0000|Hspell:191823|h[Furious Blast!]|h|r',26124),
(103258,'enUS','|TInterface\\Icons\\Ability_Rogue_ShadowStrikes:20|t%s empowers himself with |cFFFF0000|Hspell:191941|h[Darkstrikes]|h|r!','|TInterface\\Icons\\Ability_Rogue_ShadowStrikes:20|t%s empowers himself with |cFFFF0000|Hspell:191941|h[Darkstrikes]|h|r!',26124),
(103259,'enUS','|TInterface\\Icons\\Spell_Shadow_Metamorphosis:20|t%s |cFFFF0000|Hspell:192504|h[Metamorphoses]|h|r!','|TInterface\\Icons\\Spell_Shadow_Metamorphosis:20|t%s |cFFFF0000|Hspell:192504|h[Metamorphoses!]|h|r',26124),
(103260,'enUS','|TInterface\\Icons\\Spell_Fire_Volcano:20|tA |cFFFF0000|Hspell:192520|h[Volcano]|h|r forms nearby.','|TInterface\\Icons\\Spell_Fire_Volcano:20|tA |cFFFF0000|Hspell:192520|h[Volcano]|h|r forms nearby.',26124),
(103261,'enUS','|TInterface\\Icons\\spell_fire_ragnaros_molteninferno:20|tA Volcano is struck by lava, resulting in a |cFFFF0000|Hspell:193263|h[Burst]|h|r of fire!','|TInterface\\Icons\\spell_fire_ragnaros_molteninferno:20|tA Volcano is struck by lava, resulting in a |cFFFF0000|Hspell:193263|h[Burst]|h|r of fire!',26124),
(103262,'enUS','|TInterface\\Icons\\ability_deathknight_brittlebones:20|tThe cell countermeasures freeze the area, turning Ash\'golm |cFFFF0000|Hspell:192517|h[Brittle!]|h|r','|TInterface\\Icons\\ability_deathknight_brittlebones:20|tThe cell countermeasures freeze the area, turning Ash\'golm |cFFFF0000|Hspell:192517|h[Brittle!]|h|r',26124),
(103263,'enUS','I sense a powerful druid among you. You dare to challenge my authority?','',26124),
(103264,'enUS','What is that you hold, druid?','',26124),
(103265,'enUS','|TInterface\\Icons\\spell_mage_arcaneorb:20|t%s creates a |cFFFF0000|Hspell:194880|h[Pulse]|h|r of energy that will ricochet off the walls.','|TInterface\\Icons\\spell_mage_arcaneorb:20|t%s creates a |cFFFF0000|Hspell:194880|h[Pulse]|h|r of energy that will ricochet off the walls.',26124),
(103266,'enUS','You fight with the fury of Ursoc himself! No... I will not be defeated!','',26124),
(103267,'enUS','|TInterface\\Icons\\Ability_Hunter_MasterMarksman:20|t%s begins |cFFFF0000|Hspell:194289|h[Focusing]|h|r a beam of energy! Use the Lenses to reflect it back at him!','|TInterface\\Icons\\Ability_Hunter_MasterMarksman:20|t%s begins |cFFFF0000|Hspell:194289|h[Focusing]|h|r a beam of energy! Use the Lenses to reflect it back at him!',26124),
(103268,'enUS','I share my power with you alone, champion. Bathe in the light of creation. Bask in the glory of the valorous!','',26124),
(103269,'enUS','I sense great cunning and prowess from you, druid, but I will not be defeated!','',26124),
(103270,'enUS','What power comes from those fangs, defiler? You fight with the strength of the Ancients themselves.','',26124),
(103271,'enUS','You are blessed with great restorative powers, druid, but I will rip you all apart in the end!','',26124),
(103272,'enUS','We\'ll take this one out, no problem!','',26124),
(103273,'enUS','Your power burns... How have you twisted the Scythe of Elune to obey your will?','',26124),
(103274,'enUS','Jabrul will stay here and study these necklaces.$b$bJabrul will not forget you and the help you\'ve given him, $n.','',26124),
(103275,'enUS','','Keep moving! That was only the first!',26124),
(103276,'enUS','|TInterface\\Icons\\inv_misc_herb_flytrap:20|t%s throws |cFFFF0000|Hspell:197379|h[Cruel Traps]|h|r around the platform!','|TInterface\\Icons\\inv_misc_herb_flytrap:20|t%s throws |cFFFF0000|Hspell:197379|h[Cruel Traps]|h|r around the platform!',26124),
(103277,'enUS','|TInterface\\Icons\\inv_misc_ticket_tarot_vengeance:20|t%s summons an |cFFFF0000|Hspell:197796|h[Avatar of Vengeance!]|h|r','|TInterface\\Icons\\inv_misc_ticket_tarot_vengeance:20|t%s summons an |cFFFF0000|Hspell:197796|h[Avatar of Vengeance!]|h|r',26124),
(103278,'enUS','|TInterface\\Icons\\inv_throwingchakrum_01_fel:20|t%s hurls a |cFFFF0000|Hspell:197513|h[Detonating Moonglaive!]|h|r','|TInterface\\Icons\\inv_throwingchakrum_01_fel:20|t%s hurls a |cFFFF0000|Hspell:197513|h[Detonating Moonglaive!]|h|r',26124),
(103279,'enUS','|TInterface\\Icons\\Ability_Rogue_Shadowstep:20|t%s |cFFFF0000|Hspell:197823|h[Shadowsteps]|h|r away from the party. Reveal her with Elune\'s Light!','|TInterface\\Icons\\Ability_Rogue_Shadowstep:20|t%s |cFFFF0000|Hspell:197823|h[Shadowsteps]|h|r away from the party. Reveal her with Elune\'s Light!',26124),
(103280,'enUS','|TInterface\\Icons\\ability_priest_auspiciousspirits:20|tSpirits form in the shadows around the platform!','|TInterface\\Icons\\ability_priest_auspiciousspirits:20|tSpirits form in the shadows around the platform!',26124),
(103281,'enUS','','Thanks to you, Azoran has been slain and a great blow has been struck against the Burning Legion.',26124),
(103282,'enUS','','However, our work is still far from over...',26124),
(103283,'enUS','','During your battle with Azoran, I was able to secure information from the ship\'s database. We have much to discuss.',26124),
(103284,'enUS','','I be waiting for you at the underground base. Until then, farewell.',26124),
(103285,'enUS','','We must discover what the cause of this attack is before there\'s no one left to fight.',26124),
(103287,'enUS','You have truly impressed me. To pass these trials is a triumph, to do so with such speed makes of you a legend!','',26124),
(103288,'enUS','It is done! Walk proudly this day and relish your victory.','',26124),
(103289,'enUS','','No sign of Orestes. He\'s headstrong, but should have the sense to wait here for us!',26124),
(103290,'enUS','I\'m ready. Let\'s go.','I\'m ready. Let\'s go.',26124),
(103291,'enUS','I spit on your corpse, serpent!','',26124),
(103292,'enUS','As for you outsider, do not step foot into Jandvik or it will be your corpse I spit on next.','',26124),
(103293,'enUS','Mortals, in MY domain? They must not disrupt my plans! Slaughter them!','',26124),
(103294,'enUS','Puny mortals, you tread in MY realm now! There is no one to save you!','',26124),
(103295,'enUS','Insolent whelps! Witness the powers at my command! Al\'\'burq wa Alra\'ed hiyah!','',26124),
(103296,'enUS','A small victory! Enjoy it while you can!','',26124),
(103297,'enUS','Come forth, servants of the storm! Defend your master!','',26124),
(103298,'enUS','Unacceptable! Melezan, destroy them or I will cast your miserable essence to Deepholm!','',26124),
(103299,'enUS','These mortals will not die! Zaurac, defend your master!','',26124),
(103300,'enUS','Are all of my servants weaklings? Fine, I shall end you myself!','',26124),
(103302,'enUS','Sia\'la yemil!','',26124),
(103305,'enUS','','Hmm... These tornadoes simply won\'t do.',26124),
(103306,'enUS','','Onward to adventure!',26124),
(103307,'enUS','I\'ve heard that you know a tale describing a set of mysterious hand blades.','I\'ve heard that you know a tale describing a set of mysterious hand blades.',26124),
(103308,'enUS','','Yeah! Let me think... I heard it back when Uncle Chen and I were still traveling the world before we found the way to Pandaria.$b$bWe were in Booty Bay one night staying at a place called the Salty Sailor. While there I met a giant creature who called himself a Tol\'vir.$b$bWe chatted for a long time and he told me of his homeland, a place covered in sands called Uldum.',26124),
(103309,'enUS','Please, go on.','Please, go on.',26124),
(103310,'enUS','','<Li Li\'s ears perk up.>$b$bWell, the story goes that there is a land covered by sand called Uldum.',26124),
(103311,'enUS','I\'ve also heard of it.','I\'ve also heard of it.',26124),
(103312,'enUS','I\'ve been there before.','I\'ve been there before.',26124),
(103313,'enUS','','Oh that\'s so cool! I was there only for a little while. I wish I could visit there again sometime.$b$bSo according to the story thousands of years ago there was this smith called Irmaat who used to live there. The smith was known all throughout the land for his excellent work in creating magical weapons that represent the air spirits that live there.$b$bHis finest work was said to be a set of hand blades that were formed from the essence of pure air. The story goes on that he attempted to summon the lord of the winds to imbue the weapons with its power.$b$bThat didn\'t go so well for him.',26124),
(103314,'enUS','','It\'s REALLY dry and covered all with sand like a big kitty box! I briefly went there with my Uncle Chen. I wish I could see it again!$b$bSo according to the story thousands of years ago there was this smith called Irmaat who used to live there. The smith was known all throughout the land for his excellent work in creating magical weapons that represent the air spirits that live there.$b$bHis finest work was said to be a set of hand blades that were formed from the essence of pure air. The story goes on that he attempted to summon the lord of the winds to imbue the weapons with its power.$b$bThat didn\'t go so well for him.',26124),
(103315,'enUS','What happened then?','What happened then?',26124),
(103316,'enUS','','According to the story, the lord of air was filled with great wrath and decided to play a trick on Irmaat.$b$bThe lord of air imbued the weapons with the purest form of his essence, knowing that Irmaat could not possibly wield such power. Irmaat named his creation the \"Fists of the Heavens\" and held them to the sky to admire his work. This was a mistake, for when he did this it conjured a great vortex of swirling sand and air that was completely out of his control! The vortex scattered the smith\'s blades and buried his home under the desert sands.$b$bWouldn\'t it be neat if the blades were real? I\'d give anything to get out of here and go search for them!',26124),
(103317,'enUS','A Warchief who knows strategy - who commands without hesitation.','',26124),
(103318,'enUS','By the decree of Vol\'jin, acting Warchief of the Horde, I enact you, Lady Sylvanas Windrunner, as the new Warchief of the our people.','',26124),
(103319,'enUS','You will go no farther!','',26124),
(103320,'enUS','You go have your fun, pup. I have had my fill for the day.','',26124),
(103321,'enUS','We will never rest till the Legion is defeated.','',26124),
(103322,'enUS','I\'ve changed my mind. Let me pick a different artifact.','I\'ve changed my mind. Let me pick a different artifact.',26124),
(103323,'enUS','What\'s your opinion about the Shivarra?','What\'s your opinion about the Shivarra?',26124),
(103324,'enUS','The Shivarra and many other demons swore fealty to Lord Illlidan when he defeated their former master, the pit lord Magtheridon. We also have naga, broken, and some other creatures working for us.\n\nIf the Lord of Outland is okay with it, then I guess that\'s good enough for me.','',26124),
(103325,'enUS','','Okay, Pop. It\'s been... it\'s been something. I need to get on with my travels.',26124),
(103326,'enUS','Li Li, I told you I don\'t want you going off on your own again.','',26124),
(103327,'enUS','','I thought you might say that... Look, I have a guardian, and it\'s even the master of the monks. I\'ll be fine!',26124),
(103328,'enUS','Are you certain, $n? You\'re far more important to the mission than me.','',26124),
(103329,'enUS','%s scowls.','',26124),
(103331,'enUS','Clearly nothing I say is going to change your mind. Fine, go on your adventure. Just come back to me unharmed.','',26124),
(103332,'enUS','I\'ve made up my mind. Sacrifice me, Sevis, and power the gateway.','I\'ve made up my mind. Sacrifice me, Sevis, and power the gateway.',26124),
(103333,'enUS','','Follow me. My brother Wuho was supposed to scout out a \"safe\" area where we can fly in. We will take a hippogryph to the harbor and he should send us a signal of where to land.',26124),
(103334,'enUS','I\'m looking for some diamonds, Tiffany, do you have any?','I\'m looking for some diamonds, Tiffany, do you have any?',26124),
(103335,'enUS','','Yay! Okay $n, let\'s go!',26124),
(103336,'enUS','Hold a moment, Sevis. I\'m reconsidering.','Hold a moment, Sevis. I\'m reconsidering.',26124),
(103337,'enUS','Of course. I willingly sacrifice myself for the cause. What demon hunter wouldn\'t?','',26124),
(103338,'enUS','I\'m certain, Sevis. I need to sacrifice you to power the gateway.','I\'m certain, Sevis. I need to sacrifice you to power the gateway.',26124),
(103339,'enUS','','My friend Mr. Crane can fly me to Uldum. Here, you can use my kite to follow us.',26124),
(103340,'enUS','','Okay, Mr. Crane. Here\'s two juicy fish if you\'ll take me to Uldum.',26124),
(103341,'enUS','','No, you get one now and one when we get there. No complaining!',26124),
(103342,'enUS','','I hope my brother didn\'t go after the beast himself. He can be... impulsive.',26124),
(103343,'enUS','Tiffany, can you cut this diamond into some lockpicks please?','Tiffany, can you cut this diamond into some lockpicks please?',26124),
(103344,'enUS','','I don\'t currently have any, no. But I hear they have all sorts of items in the Underbelly.',26124),
(103345,'enUS','','I myself would never dream of going down there, but I assume you\'d have no problem given your primary career as a $c.',26124),
(103346,'enUS','','These designs are interesting, did you come up with them yourself? But yes, I could cut these for you.',26124),
(103347,'enUS','','Here you are. And next time, perhaps you should try crafting it yourself before coming to me and put both our time to better use.',26124),
(103348,'enUS','','There is his signal! Let us land and see what he learned.',26124),
(103349,'enUS','I will meet you down at the gateway on the Molten Shore.','',26124),
(103350,'enUS','Do not be deceived by your mortal eyes! The Legion is already among us!','',26124),
(103351,'enUS','Show me the proof.','Show me the proof.',26124),
(103352,'enUS','Your eyes cannot show you what they cannot see.','Your eyes cannot show you what they cannot see.',26124),
(103353,'enUS','We cannot allow them breach the gates!','',26124),
(103354,'enUS','Insolent wretches!','',26124),
(103355,'enUS','','It would appear we\'ve been discovered.',26124),
(103356,'enUS','Did you think you could escape my grasp so easily?','',26124),
(103357,'enUS','','Ungh... Unhand me, wretch!',26124),
(103358,'enUS','Haughty warlocks! You presume to issue commands to my kind! Face the consequences for your insolence!','',26124),
(103359,'enUS','','Shinfel! No!',26124),
(103360,'enUS','I will smash you like the insignificant gnats you are!','',26124),
(103361,'enUS','Burn! Burn in fel fire!','',26124),
(103362,'enUS','You will not get away! I\'m not done with you yet!','',26124),
(103363,'enUS','Your skull will make a fine trophy!','',26124),
(103364,'enUS','','Ungh! Press on, warlock... close the portal!',26124),
(103365,'enUS','I will burn you to cinders!','',26124),
(103366,'enUS','This is not over, warlock! I will see the end of you!','',26124),
(103367,'enUS','','We have the most exotic of wares from across the world.$b$bWhat is it you\'re looking for?',26124),
(103368,'enUS','I\'m looking for some diamonds. Do you have any?','I\'m looking for some diamonds. Do you have any?',26124),
(103369,'enUS','','Why yes, I do. But just the one. A rather large and exotic, rare jewel from across the sea.$b$bI\'d be willing to part with it for, oh... two hundred and fifty gold pieces? I also accept favors as currency.$b$bA nuisance has sprouted up around here named Inkrot. If he were to be eliminated, I\'d be willing to part with the diamond.$b$bSo, which do you choose?',26124),
(103370,'enUS','(Fair) 250 gold is much too high for just one diamond. How about 25?','(Fair) 250 gold is much too high for just one diamond. How about 25?',26124),
(103371,'enUS','(Aggressive) 250 gold is outrageous for one diamond! I\'ll give you 10.','(Aggressive) 250 gold is outrageous for one diamond! I\'ll give you 10.',26124),
(103372,'enUS','(Fair) I still can\'t go as high as 200. How about 75?','(Fair) I still can\'t go as high as 200. How about 75?',26124),
(103373,'enUS','(Aggressive) Look, there\'s no way I\'m paying 200. How about 35?','(Aggressive) Look, there\'s no way I\'m paying 200. How about 35?',26124),
(103374,'enUS','(Fair) We\'re getting closer with 125, but not close enough. How about 40?','(Fair) We\'re getting closer with 125, but not close enough. How about 40?',26124),
(103375,'enUS','(Aggressive) 125 is still out of the question. I think 35 is still a fair price.','(Aggressive) 125 is still out of the question. I think 35 is still a fair price.',26124),
(103376,'enUS','(Fair) I hear you at 100, but I\'m afraid I can\'t offer any higher than 50. Final offer.','(Fair) I hear you at 100, but I\'m afraid I can\'t offer any higher than 50. Final offer.',26124),
(103377,'enUS','(Aggressive) You\'re still too high. 40 is the fairest price I\'m going to offer.','(Aggressive) You\'re still too high. 40 is the fairest price I\'m going to offer.',26124),
(103378,'enUS','','Twenty five gold for this diamond of diamonds? I think not.$b$bBut you have a wise face. I suppose I could part with this for two hundred gold.',26124),
(103379,'enUS','','I didn\'t begin this exchange with you to be insulted. Two hundred fifty is my final offer, take it or leave it.$b$bOf course, my favor is still on the table, if you\'d rather take that route.',26124),
(103380,'enUS','','You come up, I\'m supposed to come down, yes? An exchange I\'m all too familiar with.$b$bVery well, I\'ll go as low as one hundred and seventy five, take it or leave it.$b$bOf course, my favor is still on the table, if you\'d rather take that route.',26124),
(103381,'enUS','','There\'s no need to take that tone with me, $gsir:madam;. It\'s shame to work with someone with such little money.$b$bWill one one hundred and twenty five gold break your bank?',26124),
(103382,'enUS','','Come now, surely you\'re not that poor?$b$bFine, I\'ll go down just a bit more. How does a cool one hundred gold sound? A fair price for the fairest of diamonds.',26124),
(103383,'enUS','','And I think I\'m done haggling here.$b$bOne hundred and twenty gold, take it or leave it.$b$bOf course, my favor is still on the table, if you\'d rather take that route.',26124),
(103384,'enUS','','If you weren\'t such a charmer I\'d have ended this exchange before it ever began.$b$bBut I like you. You\'re rather stubborn and a good haggler.$b$bYou have a deal at fifty.',26124),
(103385,'enUS','','Well the fairest price you\'ll hear from me is one hundred, take it or leave it.$b$bOf course, my favor is still on the table, if you\'d rather take that route.',26124),
(103386,'enUS','Pay the 250 gold.','Pay the 250 gold.',26124),
(103387,'enUS','Pay the 175 gold.','Pay the 175 gold.',26124),
(103388,'enUS','Pay the 120 gold.','Pay the 120 gold.',26124),
(103389,'enUS','Pay the 200 gold.','Pay the 200 gold.',26124),
(103390,'enUS','Pay the 125 gold.','Pay the 125 gold.',26124),
(103391,'enUS','Pay the 100 gold.','Pay the 100 gold.',26124),
(103392,'enUS','Pay the 50 gold.','Pay the 50 gold.',26124),
(103393,'enUS','I\'ve taken care of Inkrot.','I\'ve taken care of Inkrot.',26124),
(103394,'enUS','I see you have brought a truly bountiful feast with you. Do you not wish to share it with me?','',26124),
(103395,'enUS','Why must you continue to taunt me with that feast you carry? My Valarjar enjoy nothing more than a banquet after a worthy bout!','',26124),
(103396,'enUS','','And here is your diamond. A pleasure doing business with you. Please return soon.',26124),
(103397,'enUS','What is it you seek? Power? Glory? Be reasonable! My warriors\' hunger knows no end!','',26124),
(103398,'enUS','My patience wears thin. Relinquish the feast to me before we do battle or you will never set foot in these shining halls again!','',26124),
(103399,'enUS','Get goin\', $n!','',26124),
(103400,'enUS','Demons... gotta warn da others.','',26124),
(103401,'enUS','','Yikes! Get outta here! Go!',26124),
(103402,'enUS','','Where did they come from?',26124),
(103403,'enUS','','Back to the nether with you!',26124),
(103404,'enUS','','This one\'s mine!',26124),
(103405,'enUS','','Your presence is not welcome here!',26124),
(103406,'enUS','At long last the monster is dead and our relic reclaimed. My spirit can finally move on from this place...','',26124),
(103407,'enUS','Again I thank you. I will find the spirits of your friends and ensure they do not stay here.','',26124),
(103408,'enUS','I am ready to go.','I am ready to go.',26124),
(103413,'enUS','|TInterface\\Icons\\spell_shadow_carrionswarm:20|t%s begins to cast |cFFFF0000|Hspell:198947|h[Carrion Storm]|h|r!','',26124),
(103414,'enUS','Do you smell them, on the wind? The Legion\'s invasion has begun.','',26124),
(103415,'enUS','I would like to review the empowerments we might pursue.','I would like to review the empowerments we might pursue.',26124),
(103416,'enUS','Are you sure? You may only pursue one empowerment at a time.','Are you sure? You may only pursue one empowerment at a time.',26124),
(103417,'enUS','','The others... I\'ll warn them immediately!',26124),
(103418,'enUS','','Keep them outside of the gates!',26124),
(103419,'enUS','','They were here all along!',26124),
(103422,'enUS','','Zinnin, look out!',26124),
(103423,'enUS','Ms. Xiulan sends her regards!','Ms. Xiulan sends her regards!',26124),
(103424,'enUS','Ms. Xiulan sent you to get rid of me?','',26124),
(103425,'enUS','Good to know. When I\'m through with you, I\'ll take care of her too!','',26124),
(103426,'enUS','','You shall be avenged! We must finish this. Follow the monster!',26124),
(103427,'enUS','Filthy $r, I\'ll bring your head to lord Typhinius!','',26124),
(103428,'enUS','Lord Typhinius... I have failed you...','',26124),
(103429,'enUS','Flee, friend! We must escape through the gateway!','',26124),
(103430,'enUS','','These wounds... they are not healing. We must finish this quickly, before we bleed out!',26124),
(103431,'enUS','','Zinnin...',26124),
(103432,'enUS','','Slay... the monster. Find... Talonclaw...',26124),
(103433,'enUS','The path is clear! Hurry!','',26124),
(103434,'enUS','','What have you done? Hsss...',26124),
(103435,'enUS','','Tidemistress! They are weakening me!',26124),
(103436,'enUS','','What have you... Hsss... done to me?',26124),
(103437,'enUS','Hsss... My strength is gone!','',26124),
(103438,'enUS','Hsss... Hsss...','',26124),
(103439,'enUS','I will have your head for that. Hsss...','',26124),
(103440,'enUS','','Oh no!',26124),
(103441,'enUS','','A sentry! Destroy it before it warns the others!',26124),
(103442,'enUS','','The eredar are summoning in more demons!',26124),
(103443,'enUS','','Portal mages! Take them out before they bring reinforcements!',26124),
(103444,'enUS','You shall not disturb the work of the hound mistress!','',26124),
(103445,'enUS','','The portal magic of the eredar struck me... I need a moment to recover.',26124),
(103446,'enUS','','That structure in the distance must be the cathedral. Lead on, I\'m with you!',26124),
(103447,'enUS','','Our mission is of critical importance!',26124),
(103448,'enUS','Greetings, $n. It is fortunate I found you. Your presence is requested at Moonglade.','',26124),
(103449,'enUS','I\'ll meet you there as soon as you conclude your business in Dalaran.','',26124),
(103450,'enUS','There you are. $n, over here. Azsuna awaits.','',26124),
(103452,'enUS','This feature is not yet ready for testing. You have been given credit for this objective.','This feature is not yet ready for testing. You have been given credit for this objective.',26124),
(103453,'enUS','I see... intruders!','',26124),
(103454,'enUS','I see... nothing...','',26124),
(103455,'enUS','','This is amazing! Think of all we could learn from these tomes!',26124),
(103456,'enUS','','Not to mention the power they could give us...',26124),
(103457,'enUS','Here! This is the tome you seek, friend!','',26124),
(103458,'enUS','Take it! Then we can leave this place before Jagganoth finds us!','',26124),
(103459,'enUS','|TInterface\\Icons\\ability_fixated_state_red:20|tA Razormaw Shark has the scent of your blood! Get back to land!','|TInterface\\Icons\\ability_fixated_state_red:20|tA Razormaw Shark has the scent of your blood! Get back to the land!',26124),
(103461,'enUS','With it, we\'ll be able to invade any Legion world, even Argus.','',26124),
(103462,'enUS','','Hardly more than a morsel, but I suppose you\'ll have to do!',26124),
(103463,'enUS','','But... who will feed my darlings?',26124),
(103464,'enUS','','You\'re just in time for dinner... for my pets, that is!',26124),
(103465,'enUS','Mistress Torvis! Intruders approach!','',26124),
(103466,'enUS','Get away from that spire!','',26124),
(103467,'enUS','And I want them alive! There\'s no challenge in dead rabbits!','',26124),
(103468,'enUS','These intruders will fall by my hand!','',26124),
(103469,'enUS','As you command, Lord Typhinius.','',26124),
(103470,'enUS','As my master wills!','',26124),
(103471,'enUS','Turns out... rushing through that portal... not my best idea...','',26124),
(103472,'enUS','Not this time... wounds are bad. The hounds... don\'t let them get near you.','',26124),
(103473,'enUS','Guess your mage was right... time goes crazy in the Nether. Least I lasted long enough... to warn you.','',26124),
(103474,'enUS','No, but... didn\'t make it to cathedral. Wounds bad... it\'s so cold...','',26124),
(103475,'enUS','Here... over here!','',26124),
(103476,'enUS','Time to put an end to this inquisition!','',26124),
(103477,'enUS','Very good.  Fireball is a powerful spell but takes a while to cast.  Sometimes you need something quicker.  Let\'s teach you how to cast Inferno Blast.','',26124),
(103478,'enUS','Not only is Inferno Blast instant but it will always score a critical hit. This will be important later. Eliminate the Ooze over there with Inferno Blast.','',26124),
(103479,'enUS','I can\'t believe he\'s really gone.','',26124),
(103480,'enUS','He died with honor, protecting his people. He was a true king.','',26124),
(103481,'enUS','His valor inspired us all, even in death. His spirit will be with us, always.','',26124),
(103482,'enUS','Na\'ser! Answer your masters call!','',26124),
(103483,'enUS','My axe never misses its mark.','',26124),
(103484,'enUS','Malfurion waits for you by the barrow dens to the east. Follow me.','',26124),
(103485,'enUS','There are powerful druids in Val\'sharah who grew under Cenarius\'s tutelage after the Great Sundering.','',26124),
(103486,'enUS','Their knowledge of druidism is ancient and unparalleled. Having their might on our side is essential if we are to stop the Legion.','',26124),
(103487,'enUS','The Legion\'s arrival has thrown our world out of balance. I\'ve sensed great unrest within the Emerald Dream.','',26124),
(103488,'enUS','','King Anduin, the hero of the Broken Shore approaches.',26124),
(103489,'enUS','Opening the path to this ancient home of all druids will be no small feat. I hope you\'re ready for the task.','',26124),
(103490,'enUS','','My fel secrets will consume you!',26124),
(103491,'enUS','There\'s a high elf body up ahead. It looks like...','',26124),
(103492,'enUS','','You\'ve returned with the artifact! Well done, $n!',26124),
(103493,'enUS','Why are you talking to me? FIGHT THESE DEMONS!','',26124),
(103494,'enUS','Like my new sword? Take a closer look.','',26124),
(103495,'enUS','The ritual will focus our energy into a portal at the center of the structure. We must keep it stable!','',26124),
(103496,'enUS','Excellent! The path is taking form! It grows more stable by the moment!','',26124),
(103498,'enUS','The Dreamway is ready! Good work, everyone.','',26124),
(103500,'enUS','My queen\'s brood will hatch soon.','',26124),
(103501,'enUS','','Sounds like we\'re about to be overrun. Let us leave this wretched place to the demons.',26124),
(103503,'enUS','','Look out! They\'re hidin\' in the dust!',26124),
(103505,'enUS','The invasions are beginning! Go rally my brethren in the Mage Quarter, champion!','',26124),
(103506,'enUS','','The body is that of a young high elf. Too young to be Alleria.',26124),
(103507,'enUS','Press forward, $n! I cannot return to Jandvik until I have avenged the death of Throndyr!','',26124),
(103508,'enUS','Deprecated','',26124),
(103509,'enUS','My fire will leave only your bones behind.','',26124),
(103510,'enUS','My swarm will feast on your soul!','',26124),
(103511,'enUS','My arrival heralds the end.','',26124),
(103512,'enUS','You are too late. The end was set in motion long ago.','',26124),
(103513,'enUS','You are but misbegotten pawns.','',26124),
(103514,'enUS','','None can resist my kiss.',26124),
(103515,'enUS','Burn in the flames of Sargeras!','',26124),
(103516,'enUS','You merely... prolong...','',26124),
(103517,'enUS','','Come forth, my children. Feast upon our enemies.',26124),
(103518,'enUS','I will enjoy your death.','',26124),
(103519,'enUS','Come closer, my little friend.','',26124),
(103520,'enUS','Embrace the inevitable.','',26124),
(103521,'enUS','All worlds fall to the Legion.','',26124),
(103522,'enUS','Bow to the will of Sargeras.','',26124),
(103523,'enUS','The weave of your life comes to an end.','',26124),
(103524,'enUS','This will be over quickly.','',26124),
(103525,'enUS','Surrender and I will be merciful.','',26124),
(103526,'enUS','Warn King Voras!','',26124),
(103527,'enUS','Your Ashtongue met with an untimely demise.','',26124),
(103528,'enUS','Quickly, kill the demon hunter!','',26124),
(103539,'enUS','Now I shall measure your worth!','',26124),
(103540,'enUS','I give my life... for the Inquisition!','',26124),
(103541,'enUS','The Inquisition... will endure!','',26124),
(103542,'enUS','You belong... to the Inquisition!','',26124),
(103543,'enUS','How can I even go on?','How can I even go on?',26124),
(103544,'enUS','This... changes... nothing...','',26124),
(103545,'enUS','What will we do without King Varian?','What will we do without King Varian?',26124),
(103546,'enUS','The Inquisition... will endure!','',26124),
(103547,'enUS','Our king... gone too soon.','Our king... gone too soon.',26124),
(103548,'enUS','Prepare to be judged!','',26124),
(103549,'enUS','Your bones will litter the roads of Niskara!','',26124),
(103550,'enUS','More meat for the hounds!','',26124),
(103551,'enUS','The High Inquisitor will enjoy your interrogation!','',26124),
(103552,'enUS','Ha ha ha... you fools will perish!','Ha ha ha... you fools will perish!',26124),
(103553,'enUS','We are everywhere...','We are everywhere...',26124),
(103554,'enUS','The Legion cannot be stopped!','The Legion cannot be stopped!',26124),
(103555,'enUS','You are safe from nothing.','You are safe from nothing.',26124),
(103556,'enUS','Worthless beings! Kneel before the might of the Legion!','Worthless beings! Kneel before the might of the Legion!',26124),
(103557,'enUS','Foolish mortals! Nothing can save you!','Foolish mortals! Nothing can save you!',26124),
(103558,'enUS','You stand on the threshold of oblivion! Your lives belong to the Inquisition!','',26124),
(103559,'enUS','Grand Master! I have fantastic news for you!','',26124),
(103560,'enUS','','Over there! Another impostor!',26124),
(103561,'enUS','','That one too! Kill it!',26124),
(103562,'enUS','','I\'ve marked another! Find it! Quickly!',26124),
(103563,'enUS','','Got another! Get it!',26124),
(103564,'enUS','','Found another! I\'m starting to lose count!',26124),
(103565,'enUS','%s vanishes in a puff of magic.','',26124),
(103566,'enUS','I would have words with you, Champion of the Alliance. Come speak with me at once!','',26124),
(103567,'enUS','You did it, friend! The portal is closed! He cannot pursue us here.','',26124),
(103568,'enUS','We must find the weapon so that Jagganoth can be defeated! The book is the key!','',26124),
(103569,'enUS','Ready when you are.','',26124),
(103570,'enUS','Let\'s get moving.','Let\'s get moving.',26124),
(103571,'enUS','|TInterface\\Icons\\Spell_Nature_Earthquake:20|tGeneral Xakal begins to cast |cFFF00000|Hspell:197810|h[Wicked Slam]|h|r!','',26124),
(103572,'enUS','I have an idea where to find the tome discussing the Pillars of Creation, but getting there may present some... challenges.','',26124),
(103573,'enUS','Well played...','',26124),
(103574,'enUS','This platform is perfect.','',26124),
(103575,'enUS','Let\'s not waste any time, then. I\'ll setup the forge - keep an eye on the horizon for me!','',26124),
(103576,'enUS','We made it, $n. Ahhh, these forests are just as I remember them!','',26124),
(103577,'enUS','An ancient magic protects the Dreamgrove. Here, all brothers and sisters of the wilds will find sanctuary.','',26124),
(103580,'enUS','','It\'s taking off!',26124),
(103581,'enUS','','Or not.',26124),
(103582,'enUS','Ah, the storm\'s already a brewin\'.','',26124),
(103583,'enUS','Keep yer wits about you, the Legion has assassins everywhere.','',26124),
(103584,'enUS','Hold on tight! We\'re coming in for a landing.','',26124),
(103585,'enUS','They were fools to exile me. I will master this new magic and show them all!','',26124),
(103586,'enUS','I am ready to begin the ritual.','I am ready to begin the ritual.',26124),
(103587,'enUS','What in the three kingdoms... look out, we\'ve got company!','',26124),
(103588,'enUS','We have much to do and little time to do it. When you are ready, we\'ll begin.','',26124),
(103589,'enUS','Greetings','',26124),
(103590,'enUS','','Where shall the winds take you today?',26124),
(103591,'enUS','Fly me to Warbrave Oro.','Fly me to Warbrave Oro.',26124),
(103592,'enUS','The wyrmtongue think they are clever, but they leave traces of magic all over the place. It should be relatively simple to draw one through my portal.','',26124),
(103593,'enUS','This summoning will use much of my strength. Be prepared for a fight!','',26124),
(103594,'enUS','Take care! There is a dark energy emanating from the spirits of this place. We had best not get too close.','',26124),
(103595,'enUS','How far down is this place? These stairs seem to go forever.','',26124),
(103596,'enUS','The way is blocked!','',26124),
(103597,'enUS','Guild Bank','Guild Bank',26124),
(103598,'enUS','Intruders! You will go no further!','',26124),
(103599,'enUS','Hold, $c! Those spirits he\'s controlling look like they\'ll rip us apart!','',26124),
(103600,'enUS','We have to figure out a way to get past without being torn asunder.','',26124),
(103601,'enUS','Wretched demon!','',26124),
(103602,'enUS','Do not think you have won! Conservator, do your duty!','',26124),
(103603,'enUS','Your presence is unauthorized. Removal protocols engaged.','',26124),
(103604,'enUS','I don\'t like the sound of that.','',26124),
(103605,'enUS','Critical systems failure. Shutting... down...','',26124),
(103606,'enUS','Keep your guard up! I fear Ariden is not done with us yet.','',26124),
(103607,'enUS','The artifact chambers look to be just ahead. Let us proceed.','',26124),
(103608,'enUS','So this is what you\'re after? The artifacts of Karazhan belong here, and I will not allow them to be taken away!','',26124),
(103609,'enUS','You have no right to these artifacts, fiend! They must be reclaimed in the name of the Light!','',26124),
(103610,'enUS','Your Light does not reach here, priest!','',26124),
(103611,'enUS','If you want Ulthalesh, warlock, come and claim it!','',26124),
(103612,'enUS','Quickly, after him! I will only slow you down...','',26124),
(103613,'enUS','You are a persistent one.','',26124),
(103614,'enUS','Very well! If you so thirst for the power of the Deadwind Harvester, then I will show it to you myself!','',26124),
(103615,'enUS','Ulthalesh feasts tonight!','',26124),
(103616,'enUS','No! I will not be taken!','',26124),
(103617,'enUS','Nooooooo!','',26124),
(103618,'enUS','It is done. The Dark Riders are defeated.','',26124),
(103619,'enUS','Now I can reclaim these stolen artifacts and return them to their rightful owners.','',26124),
(103620,'enUS','You have proven an unexpected ally, $c. The weapon is yours. Let us hope it can turn the tide in this war.','',26124),
(103621,'enUS','The Dark Riders lost this battle, but I fear they will soon regroup. We had best be gone before they do.','',26124),
(103622,'enUS','Greetings, Archdruid Greathoof. We have traveled far to seek your aid.','',26124),
(103623,'enUS','I\'ve heard the land cry out, son of Cenarius. The Legion threatens us all.','',26124),
(103624,'enUS','The trees groan in agony as the Legion uproots them. Both our world and the Dream are in grave danger.','',26124),
(103625,'enUS','Then we must act swiftly and ready the weapons of old for war.','',26124),
(103626,'enUS','There is no one better suited for this task than $n.','',26124),
(103627,'enUS','Very well. Your task will not be easy, but I shall do all that I can to aid you.','',26124),
(103628,'enUS','Did you think I had forgotten about you, paladin? The Broken Shore was merely the beginning...','',26124),
(103629,'enUS','I\'ve been watching you - your power has grown quite considerably. Now my fist shall deliver your limp, lifeless body to me so that I can finish what I started.','',26124),
(103630,'enUS','The Burning Legion\'s power grows. We haven\'t time to spare.','',26124),
(103631,'enUS','Let us begin.','Let us begin.',26124),
(103632,'enUS','I\'ve been away too long. I fear the tower has fallen into disrepair. Please, pardon the mess.','',26124),
(103633,'enUS','Heh, I remember the day I arrived. So young and nervous... sent by the Kirin Tor to study under the famed mage Medivh.','',26124),
(103634,'enUS','I\'ll be seeing you soon...','',26124),
(103635,'enUS','Care to borrow some blinders? Other students have found them quite helpful for ignoring those distracting visions.','',26124),
(103636,'enUS','Uh... no, thank you. If I may ask, what became of the other students?','',26124),
(103637,'enUS','I was not the first sent to study under Medivh. I was, however, the only one he accepted as his apprentice.','',26124),
(103638,'enUS','Earning his trust took time. Cleaning the library wasn\'t a glamorous start to my career, but it taught me that to Medivh, everything was a test. Preparation for... a greater destiny.','',26124),
(103639,'enUS','So... It seems our young spy has arrived at last.','',26124),
(103640,'enUS','End this pathetic display.','',26124),
(103641,'enUS','This feature is not yet ready for testing. You have been given portal fragments.','This feature is not yet ready for testing. You have been given portal fragments.',26124),
(103642,'enUS','You have done it! Now to begin with a simple extraction...','',26124),
(103643,'enUS','The forge is ready! Quickly, over here!','',26124),
(103644,'enUS','The power of the wilds flows through us all.','',26124),
(103645,'enUS','I would like to review weapons we might pursue.','I would like to review weapons we might pursue.',26124),
(103646,'enUS','The Blacksmith Capture Point has spawned','The Blacksmith Capture Point has spawned',26124),
(103647,'enUS','The Gold Mine Capture Point has spawned','',26124),
(103648,'enUS','The Lumber Mill Capture Point has spawned','',26124),
(103649,'enUS','The Farm Capture Point has spawned','',26124),
(103650,'enUS','The Stables Capture Point has spawned','',26124),
(103652,'enUS','','I\'m going to relish silencing that fiend!',26124),
(103653,'enUS','On this day the Ashbringer becomes something new... something our enemies would never expect!','',26124),
(103654,'enUS','And so the Heart of Zin-Azshari called the storms, and with a thunderous answer the storms brought the queen\'s grace upon the world.','',26124),
(103655,'enUS','Hear me, storms. Grant this blade your power!','',26124),
(103656,'enUS','It\'s... beautiful.','',26124),
(103657,'enUS','Let\'s not stick around to find out if more demons are coming our way. Our gryphons are waitin\' for us at the landing to take us to Dalaran.','',26124),
(103658,'enUS','The Inquisition... will prevail!','',26124),
(103659,'enUS','You were fools to come here!','',26124),
(103660,'enUS','The High Inquisitor will be pleased! Herald, you may dispose of the trash!','',26124),
(103661,'enUS','','Yeah! This is gonna be awesome! I better go tell Pop.',26124),
(103662,'enUS','The trapper stuns the player, then captures Vereesa in a cage and runs off with her.','',26124),
(103663,'enUS','','Save yourself! Don\'t come after me!',26124),
(103664,'enUS','I have been watching your exploits, and I think you the right hero for the job!','',26124),
(103665,'enUS','','We\'ll get you out of here, Orestes. Any sign of Alleria?',26124),
(103666,'enUS','$n consumes the power of a Honored Ancestor.','$n was consumed by Hunger for Life.',26124),
(103667,'enUS','Rats make good friend. Unless rat bites, then rat makes good meal.','',26124),
(103668,'enUS','','Master $n, if I could get your attention for a moment!',26124),
(103669,'enUS','','Excellent, you can take the portal to Dalaran Crater and just fly north. He will be expecting you soon!',26124),
(103670,'enUS','','Come. Let\'s find Alleria and finish this.',26124),
(103671,'enUS','','We\'ll be careful. Did you find any sign of Alleria?',26124),
(103672,'enUS','','Rest in the Light, Orestes.',26124),
(103673,'enUS','Intruder alert!','',26124),
(103674,'enUS','Druids! I sense you in the waking world.','',26124),
(103675,'enUS','My lair is under attack within the Dream. I need your aid, now!','',26124),
(103676,'enUS','','I have recquisitioned a hippogryph for you if you desire, or you can make your own way to the site. If you have more question I can attempt to fill in the blanks for you.',26124),
(103677,'enUS','','TEMP - Talk options for\n- What is the Blade?\n- What is this new leader of Twilight\'s Hammer?\n- Why is Moira doing this?\n- What\'s so special about Tirisfal?',26124),
(103678,'enUS','lol tell me','lol tell me',26124),
(103679,'enUS','Okay, okay! I give up. I\'ll go hunt somewhere else.','Okay, okay! I give up. I\'ll go hunt somewhere else.',26124),
(103680,'enUS','Fine, you win! I\'ll find a better place to hunt.','Fine, you win! I\'ll find a better place to hunt.',26124),
(103681,'enUS','The last time I was here, I left behind a few... safety measures. There are countless secrets within these walls, and many who would stop at nothing to learn them.','',26124),
(103682,'enUS','The sentry! Look out!','',26124),
(103683,'enUS','The wards! More sentries are coming after us. Fortunately, I always keep a few tricks up my sleeve.','',26124),
(103684,'enUS','Over here! Is this the relic you seek?','',26124),
(103685,'enUS','Vile beasts of the Nightmare! You will never take my claws!','',26124),
(103686,'enUS','Worthy you may be, but if you would wield my claws to defend this world, you must make haste to retrieve them. Even now, I sense more of the enemy approaching!','',26124),
(103687,'enUS','','Oh dear! More invaders are coming!',26124),
(103688,'enUS','These are dark times, $n. I\'m glad you\'re here.','',26124),
(103689,'enUS','How do I get to Light\'s Hope Chapel?','How do I get to Light\'s Hope Chapel?',26124),
(103690,'enUS','The Kirin Tor have established a portal in a chamber beneath the city to Dalaran\'s former home in the Hillsbrad Foothills - Light\'s Hope is a short ride from there.$B$BThere are teleportation pads in Runeweaver Square that will take you to the chamber. I have marked one on your map.','',26124),
(103691,'enUS','|TInterface\\Icons\\ability_demonhunter_felrush:20|tIllysanna Ravencrest prepares to |cFFFF0000|Hspell:197484|h[Dark Rush]|h|r towards you!','|TInterface\\Icons\\ability_demonhunter_felrush:20|tIllysanna Ravencrest prepares to |cFFFF0000|Hspell:197484|h[Dark Rush]|h|r towards you!',26124),
(103692,'enUS','|TInterface\\Icons\\ability_bosskilrogg_deadeye:20|tIllysanna Ravencrest\'s |cFFFF0000|Hspell:197674|h[Eye Beams]|h|r begin tracking you!','|TInterface\\Icons\\ability_bosskilrogg_deadeye:20|tIllysanna Ravencrest\'s |cFFFF0000|Hspell:197674|h[Eye Beams]|h|r begin tracking you!',26124),
(103693,'enUS','|TInterface\\Icons\\spell_fire_felfirenova:20|t%s begins to cast |cFFFF0000|Hspell:199828|h[Chaos Nova]|h|r!','',26124),
(103694,'enUS','I grant you my blessing, $n. With it, all others will know you are my chosen champion.','',26124),
(103695,'enUS','Warn the others. Now, WAKE UP!','',26124),
(103696,'enUS','Hmm, it appears my safeguards may have been altered. Keep an eye out while I open the way.','',26124),
(103698,'enUS','|TInterface\\Icons\\spell_warlock_demonsoul:20|tYou are afflicted by  |cFFFF0000|Hspell:194960|h[Soul Echoes]|h|r !','|TInterface\\Icons\\spell_warlock_demonsoul:20|tYou are afflicted by  |cFFFF0000|Hspell:194960|h[Soul Echoes]|h|r !',26124),
(103699,'enUS','','Oh my stars! I just can\'t stand violence! I hope this ends quickly.',26124),
(103700,'enUS','','%s faints and falls onto the ground.',26124),
(103701,'enUS','%s falls to the ground!','',26124),
(103702,'enUS','','Be on your guard, friend. There have been demon sightings in the area.',26124),
(103703,'enUS','The furbolgs have been acting strange lately...','',26124),
(103704,'enUS','','Help! These big meanies won\'t leave me alone!',26124),
(103705,'enUS','','Get away from me you big, stupid... stupid head!',26124),
(103707,'enUS','','I will heal you, guardian!',26124),
(103708,'enUS','','Stand within my healing circle, guardian, and be restored.',26124),
(103709,'enUS','','Gee, this is going to hurt. I\'m so sorry!',26124),
(103711,'enUS','','Ow! Ow! Owww! I really need a moment to rest.',26124),
(103712,'enUS','','I\'ll be fine. Just give me a moment to rest.',26124),
(103714,'enUS','These foes are weak, but fight in numbers. In life, I paid the price for underestimating my enemy. Never again!','',26124),
(103715,'enUS','Creatures of the wild, heed my call! Come to our aid!','',26124),
(103716,'enUS','Protect our healers and casters, guardian. We must not let our allies fall!','',26124),
(103717,'enUS','Keep it up, defenders! We will never yield to these invaders!','',26124),
(103718,'enUS','Their blood will burn the very ground where they fall. Don\'t let them touch our defenders!','',26124),
(103719,'enUS','Control the enemies. You can determine where they fall!','',26124),
(103720,'enUS','Beware! The Nightmare\'s corruption has spread to the trees!','',26124),
(103721,'enUS','The heart of the bear never falters! Hold the line, hero!','',26124),
(103722,'enUS','The Emerald Dream is a paradise, a hope of the world that could be. I will not let it be destroyed!','',26124),
(103723,'enUS','Those casters cannot be left alone! We must deal with them quickly!','',26124),
(103724,'enUS','Those healers will make things more difficult. We should try and defeat them first!','',26124),
(103725,'enUS','Hold, guardian. I feel a chill deep in my spirit.','',26124),
(103726,'enUS','Foolish bear! You\'ve fallen for my trap!','',26124),
(103727,'enUS','What is this sorcery!? When I get free, I\'ll tear out your foul throat, Xavius!','',26124),
(103728,'enUS','No, Ursoc. When next you bare your fangs, it will be at my command!','',26124),
(103729,'enUS','No!','',26124),
(103730,'enUS','You\'ll never reach Xalethar alive!','',26124),
(103732,'enUS','I will resist you to my last breath, usurper! I will never submit to one such as you!','',26124),
(103733,'enUS','I am LORD of the Nightmare! I have been shaped by the powers of the Old Gods. Tremble before me!','',26124),
(103734,'enUS','Aaarrghhh ArrrghhhhH!','',26124),
(103735,'enUS','Hero! Xavius is right.... his strength is... unbreakable. I cannot hold him forever.','',26124),
(103737,'enUS','You should have turned back when you had the chance!','',26124),
(103738,'enUS','You\'ve arrived just in time. I was growing tired of these mangy beasts!','',26124),
(103739,'enUS','Xavius will avenge me...','',26124),
(103740,'enUS','How was the flight in? Seems we moved Dalaran from one dark, gloomy land to another.$b$bAt least it\'s warmer here. And I must admit, being so close to Karazhan brings back many memories.','',26124),
(103741,'enUS','How can I help, Archmage?','How can I help, Archmage?',26124),
(103742,'enUS','Get that book into Modera\'s hands in Dalaran. I\'ll join you soon. And... thank you.','',26124),
(103743,'enUS','The sixth is here. Let us begin.','',26124),
(103744,'enUS','Zelifrax will lead us in the ritual. You have studied the rites, gnome?','',26124),
(103745,'enUS','Yeah, yeah. Don\'t worry about me, hothead! I know what needs to be done.','',26124),
(103746,'enUS','Akris nor-menoth!','',26124),
(103747,'enUS','I need everyone to channel on the portal. This ritual requires our unwavering concentration!','',26124),
(103748,'enUS','','It\'s not our concentration that should concern you. Let us hope our newest addition can keep up.',26124),
(103749,'enUS','','What are you waiting for, new blood? Begin!',26124),
(103750,'enUS','Your power is impressive, warlock. The ritual begins!','',26124),
(103751,'enUS','','Be prepared! We\'re reaching deeper into the Nether than ever before. Who knows what we may find!',26124),
(103752,'enUS','Gal nortalesh da val...','',26124),
(103753,'enUS','Keep focused... I sense a being of great power on the other side...','',26124),
(103754,'enUS','Zor-arik var... um... telosh?','',26124),
(103755,'enUS','Zelifrax!','',26124),
(103756,'enUS','Uh... or was it teloth? I\'m always mixing those up!','',26124),
(103757,'enUS','','No! The portal!',26124),
(103758,'enUS','Who dares summon me?!','',26124),
(103759,'enUS','It is I, Zelifrax Wobblepox! You will serve me, demon!','',26124),
(103760,'enUS','Trifling gnome! I think not!','',26124),
(103761,'enUS','Aieeeeee!','',26124),
(103762,'enUS','Foolish mortals! You think yourselves worthy to enslave the mighty Jagganoth?','',26124),
(103763,'enUS','It is you who will be made to serve!','',26124),
(103764,'enUS','Kirest-alak yrthog norush...','',26124),
(103765,'enUS','Take the tome, $n. The information it holds is vital!','',26124),
(103766,'enUS','The Legion\'s attacks will only intensify. We must do whatever is necessary to bolster our strength.','',26124),
(103767,'enUS','If we\'re going to make it through this, we must bring the Kirin Tor to full strength.','',26124),
(103768,'enUS','Old prejudices must be set aside for the greater good of Azeroth.','',26124),
(103769,'enUS','I propose we invite the Horde back into the Kirin Tor. You may not like this idea. Some of my colleagues certainly won\'t.','',26124),
(103770,'enUS','Please trust my judgment. A world at war with itself cannot stand against the Legion for long.','',26124),
(103771,'enUS','The Council is already assembled. Let\'s not keep them waiting.','',26124),
(103772,'enUS','I will propose that we invite the Horde back into the Kirin Tor. To certain colleagues on the Council, this will be... controversial.','',26124),
(103773,'enUS','Your presence is a testimony to the valor of the Horde. To some... that may not be enough.','',26124),
(103774,'enUS','Some kind of abomination. Watch yourselves! Do not hesitate!','',26124),
(103775,'enUS','You\'ll have to subdue the guardians before my calibration can take effect. No need to be gentle!','',26124),
(103776,'enUS','The magic of your weapon runs deep. Its power will grow with you.','',26124),
(103777,'enUS','$n, I place you in charge of the grove\'s efforts here. I must travel to the south and seek out Cenarius. Only with his aid will we stop the Legion.','',26124),
(103778,'enUS','You survived the summoners... such determination! A pity you won\'t live to experience our glorious cathedral!','',26124),
(103780,'enUS','','Val\'sharah has the most beautiful flowers. Do you enjoy picking flowers too?',26124),
(103781,'enUS','|TINTERFACE\\ICONS\\trade_archaeology_vrykul_runestick:20|t Odyn marks all enemies with a |cFFFF0404|Hspell:197961|h[Runic Brand]|h|r!','|TInterface\\Icons\\Spell_Holy_DivineProvidence:20|t $n is afflicted with |cFFFF0404|Hspell:192067|h[Expel Light]|h|r!',26124),
(103782,'enUS','If we\'re to have any hope of holding back the Legion, I need to get the sentries back on our side.','',26124),
(103783,'enUS','This book holds a spell that will take you to the library. Get going! And be ready for anything!','',26124),
(103784,'enUS','Thank you all for gathering on such short notice.','',26124),
(103785,'enUS','','Khadgar, we don\'t have time to waste in meetings. The Legion is advancing and the Horde arms for battle.',26124),
(103786,'enUS','My friends, we\'ve all seen the battle reports. The Legion is laying siege to every kingdom in Azeroth.','',26124),
(103787,'enUS','That much is obvious, Khadgar.','',26124),
(103788,'enUS','Precisely the two points I wish to address. The demons are evolving their methods. To beat them, the Kirin Tor must do the same.','',26124),
(103789,'enUS','','What are you proposing?',26124),
(103790,'enUS','Then I\'ll get right to the point. For the Kirin Tor to fight at full strength, we need the mages of the Horde to join our ranks.','',26124),
(103791,'enUS','','NEVER! Do you hear me, Khadgar?',26124),
(103792,'enUS','Jaina, we know the pain you\'ve endured. But this is about--','',26124),
(103793,'enUS','I\'ve made my case. With respect, I move for a vote.','',26124),
(103794,'enUS','','They obliterated Theramore. They left us to die on the Broken Shore. Again and again they\'ve proven to be monsters... cowards!',26124),
(103795,'enUS','A vote has been called. Shall we proceed?','',26124),
(103796,'enUS','','Very well. But consider your choice carefully. If you let those vermin back into this city, I will not be counted among your ranks when you welcome them.',26124),
(103797,'enUS','In the matter of allowing the Horde into Dalaran and offering membership in the Kirin Tor, I vote aye.','',26124),
(103798,'enUS','Aye.','',26124),
(103799,'enUS','Aye.','',26124),
(103800,'enUS','','Nay.',26124),
(103801,'enUS','Nay.','',26124),
(103802,'enUS','Me... sage... for yoooou!','',26124),
(103803,'enUS','','Aye.',26124),
(103804,'enUS','The vote carries. I\'m sorry, Jaina, but the stakes are higher than they\'ve ever been.','',26124),
(103805,'enUS','','Modera! Vargoth! How could you?',26124),
(103806,'enUS','Me... go...','',26124),
(103807,'enUS','','Jaina, please... we are doing what\'s best for Azeroth. Stand with us!',26124),
(103808,'enUS','','This Council is blind to the truth. When the Horde betrays you again, remember who warned you. Farewell.',26124),
(103809,'enUS','That was... difficult. But we must move forward. We will send our invitation to the Warchief at once. We have a war to win.','',26124),
(103810,'enUS','UNCROSS THE WIRES TO SAVE MY DIGITAL LIFE','UNCROSS THE WIRES TO SAVE MY DIGITAL LIFE',26124),
(103811,'enUS','But, not so fast, $n. I have another request of you.','',26124),
(103812,'enUS','GREETINGS, CREATOR','',26124),
(103813,'enUS','It is done. Latara, my love. I will continue to fight for you. For us.','',26124),
(103814,'enUS','I was tired of this disguise anyway!','',26124),
(103815,'enUS','Apply a new module.','Apply a new module.',26124),
(103816,'enUS','Activate Repair Mode.','Activate Repair Mode.',26124),
(103817,'enUS','Activate Failure Detection Mode.','Activate Failure Detection Mode.',26124),
(103818,'enUS','Activate Fireworks Mode.','Activate Fireworks Mode.',26124),
(103819,'enUS','Activate Snack Distribution Mode.','Activate Snack Distribution Mode.',26124),
(103820,'enUS','Activate Bling Mode.','Activate Bling Mode.',26124),
(103821,'enUS','Activate Piloted Combat Mode.','Activate Piloted Combat Mode.',26124),
(103822,'enUS','We did not start this war, but we will end it.','',26124),
(103823,'enUS','I\'ve changed my mind. Let me pick a different artifact.','I\'ve changed my mind. Let me pick a different artifact.',26124),
(103824,'enUS','Activate Thermal Anvil Mode.','Activate Thermal Anvil Mode.',26124),
(103825,'enUS','Activate Wormhole Generation Mode.','Activate Wormhole Generation Mode.',26124),
(103826,'enUS','Install module for Repair Mode.','Install module for Repair Mode.',26124),
(103827,'enUS','Install module for Failure Detection Mode.','Install module for Failure Detection Mode.',26124),
(103828,'enUS','Install module for Fireworks Mode.','Install module for Fireworks Mode.',26124),
(103829,'enUS','Install module for Snack Distribution Mode.','Install module for Snack Distribution Mode.',26124),
(103830,'enUS','Install module for Bling Mode.','Install module for Bling Mode.',26124),
(103831,'enUS','Install module for Piloted Combat Mode.','Install module for Piloted Combat Mode.',26124),
(103832,'enUS','Install module for Thermal Anvil Mode.','Install module for Thermal Anvil Mode.',26124),
(103833,'enUS','Install module for Wormhole Generation Mode.','Install module for Wormhole Generation Mode.',26124),
(103834,'enUS','That was a strange sensation...','Oh my... that tickled!',26124),
(103835,'enUS','If there was a demon in Lorlathil, I\'d know.','What a strange sensation... where can I get one of those?',26124),
(103836,'enUS','The Deacon has started the ritual! He is not to be disturbed!','The Deacon has started the ritual! He is not to be disturbed!',26124),
(103837,'enUS','You believe yourselves worthy to enter the cathedral? Then come forth and be tested!','',26124),
(103838,'enUS','You may have the honor of meeting the High Inquisitor... if you get past me!','',26124),
(103840,'enUS','Adding mini event here: defeat hounds first, then mistress.','',26124),
(103841,'enUS','This could be uncomfortable. Are you ready, $n?','',26124),
(103842,'enUS','Address the Council, Khadgar.','Address the Council, Khadgar.',26124),
(103843,'enUS','Master Slaghammer! We have an intruder!','Master Slaghammer! We have an intruder!',26124),
(103844,'enUS','Excellent! I was expecting \'im, but I don\'t think you were...','',26124),
(103845,'enUS','What?! You traitor!','What?! You traitor!',26124),
(103846,'enUS','I just felt a tingle in my... nevermind.','What just happened?',26124),
(103847,'enUS','Do you always greet people this way?','At least get to know me first...',26124),
(103848,'enUS','You thought I was a demon?','This may be the first time I\'ve ever been mistaken for a demon.',26124),
(103849,'enUS','A demon in Lorlathil? Nonsense.','Oh my, I think I\'m going to like you.',26124),
(103850,'enUS','You must be mistaken, friend.','',26124),
(103851,'enUS','So... the little warlock returns.','',26124),
(103852,'enUS','You\'re too late to save your friends. They have the honor of amusing my lord, Mephistroth.','',26124),
(103853,'enUS','He will be pleased to receive yet another gift, and I will happily deliver you to him.','',26124),
(103854,'enUS','Come, warlock! You will be broken!','',26124),
(103855,'enUS','This power you wield... it\'s not possible!','',26124),
(103856,'enUS','This... cannot be!','',26124),
(103857,'enUS','Jagganoth is slain! Now take his heart. You will be lord of the Dreadscar!','',26124),
(103858,'enUS','So, mortal, you have slain one of my generals...','',26124),
(103859,'enUS','Savor your victory while you can, warlock. This war is far from over!','',26124),
(103860,'enUS','We will meet again...','',26124),
(103861,'enUS','Mephistroth will... take you...','',26124),
(103862,'enUS','Archmage Khadgar is waiting for you in Dalaran. Take the portal when you\'re ready.','Archmage Khadgar is waiting for you in Dalaran. Take the portal when you\'re ready.',26124),
(103863,'enUS','Archmage Khadgar is waiting for you in Dalaran. Take the portal when you\'re ready.','Archmage Khadgar is waiting for you in Dalaran. Take the portal when you\'re ready.',26124),
(103864,'enUS','Begone from here!','',26124),
(103865,'enUS','This ward will not tolerate your presence!','',26124),
(103866,'enUS','You are not worthy of being here!','',26124),
(103867,'enUS','I banish you to the mist!','',26124),
(103868,'enUS','Friend, the Dreadscar have come to serve at your command!','',26124),
(103869,'enUS','We await your command, Overlord.','',26124),
(103871,'enUS','Here, take these designs. I came up with them myself.','',26124),
(103872,'enUS','','Hey there $n! I knew you would have no problem passing through the Emerald Dreamway.',26124),
(103873,'enUS','','Ursoc\'s Den is just up ahead. He roamed the wilds while the world was still young, and returned here to rest and train.',26124),
(103874,'enUS','','Thousands of years ago, the great proto-dragon, Galakrond, tried to encroach on these forests. Ursoc fought him and where they fell, they created these valleys, and where their claws struck the earth, they forged mountains. Eventually, Ursoc drove the dragon away, to the west.',26124),
(103875,'enUS','','After his death, we placed the Claws in the Emerald Dream for safekeeping.',26124),
(103876,'enUS','','Our druids guard the claws now in his lair within the Emerald Dream. It is there we shall go now, to retrieve them.',26124),
(103877,'enUS','','Place your hand upon the altar and sleep.',26124),
(103878,'enUS','Well this is hardly fair.','',26124),
(103879,'enUS','Baaaaaaaa.','',26124),
(103880,'enUS','You will die for this!','',26124),
(103881,'enUS','If only I had the use of my arms...','',26124),
(103882,'enUS','Bring the heart to the altar! This way!','',26124),
(103886,'enUS','[PH] Insert awesome flyover showing your new demon digs and transitioning to the real order hall','',26124),
(103887,'enUS','You mortals have endured so much to rescue your precious Alleria. Come forth and reap your reward!','',26124),
(103892,'enUS','$n! You must come quickly! Saurfang has been looking for you!','',26124),
(103893,'enUS','What is this interruption? Syphonus, deal with these mortals. No witnesses.','',26124),
(103894,'enUS','You must not interfere with our work, mortal!','You must not interfere with our work, mortal!',26124),
(103895,'enUS','The portal must be maintained!','The portal must be maintained!',26124),
(103896,'enUS','You trifle with forces you do not understand!','You trifle with forces you do not understand!',26124),
(103897,'enUS','The Inquisition\'s work will not be disturbed!','The Inquisition\'s sacred work must not be disturbed!',26124),
(103898,'enUS','Blood and Honor!','',26124),
(103905,'enUS','','Please leave your weapons with me, $ct.',26124),
(103907,'enUS','|TInterface\\Icons\\spell_shadow_shadowward:20|t%s begins to cast |cFFFF0000|Hspell:200002|h[Blur of Shadows]|h|r!','',26124),
(103908,'enUS','No! Mine!','',26124),
(103909,'enUS','Fool! You will suffer for your trespass!','',26124),
(103910,'enUS','Turn away now, interloper! The horrors of the past will be your undoing!','',26124),
(103911,'enUS','I think that means we\'re on the right track. See what you can find in that journal.','',26124),
(103912,'enUS','$n, you never fail to surprise me.','',26124),
(103913,'enUS','%s shakes his head.','',26124),
(103914,'enUS','Our uni-directional gift distribution threshold has been reached. Thresholds reset daily.','',26124),
(103915,'enUS','Another Windrunner for my collection! Oh, the secrets you will confess to me!','',26124),
(103917,'enUS','','Forget about me! Save Alleria!',26124),
(103918,'enUS','You refuse to surrender! How splendid! We did not anticipate the high elf would bring along so... persistent an ally.','',26124),
(103919,'enUS','This Vereesa should prove useful... until she breaks. You, however... well, every mortal life must end.','',26124),
(103920,'enUS','$n, I present you with a gift from Lord Illidan himself.','',26124),
(103921,'enUS','','Free, but... fel magic.. still afflicting me.',26124),
(103922,'enUS','','You must... kill the Inquisitor... claim Alleria\'s bow!',26124),
(103923,'enUS','Jabrul will get to Dalaran somehow.','',26124),
(103924,'enUS','I\'m going to crate you up now, Jabrul.','I\'m going to crate you up now, Jabrul.',26124),
(103927,'enUS','Dalaran is situated above the largest repository of arcane knowledge on Azeroth. You can guess this is not by mistake.','',26124),
(103928,'enUS','I\'ll need your help in there. It feels a lot like going home, but for the occasional brushes with death that are surely in store.','',26124),
(103929,'enUS','Meet me at the front gate when you\'re ready, $n.','',26124),
(103930,'enUS','It\'s a tight fit, but Jabrul should be fine.','',26124),
(103931,'enUS','Mail Jabrul.','Mail Jabrul.',26124),
(103932,'enUS','No! Wait! Jabrul changed his mind!','',26124),
(103934,'enUS','Hello? $n, are you there?','',26124),
(103935,'enUS','Break open the crate.','Break open the crate.',26124),
(103936,'enUS','OH! That feels SO much better.','',26124),
(103937,'enUS','The mist dissipates, revealing %s in the trap!','',26124),
(103938,'enUS','So this is Dalaran? Jabrul is impressed. This way to the jewelcrafting masters?','',26124),
(103939,'enUS','That is far enough.','',26124),
(103940,'enUS','Well, you are not from the palace... and you are no demon, at least not entirely.','',26124),
(103943,'enUS','Identify yourself, before I teleport you to the depths of the Great Sea.','',26124),
(103946,'enUS','Good job with that ooze.  To stay alive on the battle field moving around will be critical.  However using your legs is so mundane. You\'re a mage, are you not?  It\'s time to learn how to blink!','',26124),
(103947,'enUS','Blink will allow you to teleport a short distance to avoid danger or close the distance to an enemy, try using it now.','',26124),
(103949,'enUS','What is this? A coin...','',26124),
(103950,'enUS','The sign of the dusk lily... This is the First Arcanist\'s seal! Is she alive?!','',26124),
(103951,'enUS','Right. The trap.','',26124),
(103952,'enUS','Fun, isn\'t it? Moving is only half the equation though, what if you could freeze your enemies in place, prevent them from even reaching you?  As a mage, you can do just that.','',26124),
(103953,'enUS','Frost nova will freeze any nearby enemies in place allowing you to blink away and destroy them in safety.  For now, let\'s just practice freezing them in place.','',26124),
(103954,'enUS','','Forget about me... save the bow... save Thas\'dorah!',26124),
(103956,'enUS','','$n, I thought I asked you to tell your friend to STOP sending those letters of his?!',26124),
(103957,'enUS','','WHOA! That guy is huge!',26124),
(103958,'enUS','Hello!','',26124),
(103959,'enUS','$n, I believe there is something very powerful in this cave. But, because of the immense fel energy that permeates Mardum, I cannot be certain. My vision is clouded.\n\nIf there is something in there, we can\'t afford to ignore it. Your mastery of spectral sight is greater than any, save Lord Illidan.\n\nWill you turn your spectral sight on the cave and confirm my suspicions?','',26124),
(103960,'enUS','Yes, Jace, I will use my spectral sight to look into the cave.','Yes, Jace, I will use my spectral sight to look into the cave.',26124),
(103961,'enUS','','So, the famed $c from the Broken Shore has returned.$b$bYour deeds have earned you leniency from my bow, but do not press me. As you can imagine, there is much I must address now that I am Warchief.$b$bWe will speak later. You can wait.',26124),
(103962,'enUS','For blood and honor, Warchief!','For blood and honor, Warchief!',26124),
(103964,'enUS','','WHAT THE HELL IS THAT THING?!?!',26124),
(103965,'enUS','Ladies, ladies, calm down. I think this is that jewelcrafting master that $n has been working with.','',26124),
(103966,'enUS','I did warn you. Tel\'vasha!','',26124),
(103967,'enUS','N\'eth ana!','',26124),
(103968,'enUS','The Blackroot Squirrel chirps in appreciation.','The Blackroot Squirrel chirps in appreciation.',26124),
(103969,'enUS','Then there is still a chance... Come quickly! I need your help.','',26124),
(103970,'enUS','The teleporter is just outside. Activate it first, then step on the pad.','',26124),
(103971,'enUS','The Calm Moonkin hoots at you in appreciation.','The Calm Moonkin hoots at you in appreciation.',26124),
(103972,'enUS','All of the teleporters work the same way. Use them to find that equipment!','',26124),
(103973,'enUS','Strange, you should have been recalled by now. Whatever you just did, it bought you more time.','',26124),
(103974,'enUS','If King Varian couldn\'t stop the Legion, how can anyone?','If King Varian couldn\'t stop the Legion, how can anyone?',26124),
(103975,'enUS','He was such a noble king...','He was such a noble king...',26124),
(103976,'enUS','Things won\'t ever be the same again...','Things won\'t ever be the same again...',26124),
(103977,'enUS','The tower\'s defenses have been compromised! I sense the tendrils of Medivh\'s magic thwarting my safeguards!','',26124),
(103982,'enUS','I no stop candle making! ...Unless you want story?','',26124),
(103983,'enUS','Reactivate the sentries once I finish their adjustments. I\'ll reinforce the door and send the guardians against the Legion. That will buy us time to find what we\'re after.','',26124),
(103986,'enUS','Rats good diggers. Or good dinner if not.','',26124),
(103987,'enUS','Rats not afraid of darkness.','',26124),
(103988,'enUS','Rats tastier than rabbit, and easier to catch.','',26124),
(103989,'enUS','Harpies like shinies.\n\nWe trade treasures for wax.\n\nBuild biggest candle ever!','',26124),
(103990,'enUS','Very busy. Always jobs to do!\n\nSmart workers catch rats. Smartest workers light candles.\n\nOthers... dig.','',26124),
(103991,'enUS','I want story.','I want story.',26124),
(103992,'enUS','Something is wrong... I have lost your position...','',26124),
(103993,'enUS','Wherever you are, it is unstable. The telemancy will not hold long.','',26124),
(103994,'enUS','A curious discovery, but you will not find the equipment we need in there.','',26124),
(103995,'enUS','Kobolds live here long time. Make home in nooks.','',26124),
(103996,'enUS','Catch rats. Sometimes eat them.','',26124),
(103997,'enUS','Dig for treasure. Trade with harpies.','',26124),
(103998,'enUS','They like shinies, we like wax. Fresh from ears is best.','',26124),
(103999,'enUS','One day drogbar come in. Say cave is theirs.','',26124),
(104000,'enUS','They smash and scare. We take candles and hide.','',26124),
(104001,'enUS','Drogbar big and stupid. They have cave, but no have candle.','',26124),
(104002,'enUS','Darkness finds them. Darkness follows them.','',26124),
(104003,'enUS','Darkness swallows them whole!','',26124),
(104004,'enUS','We come back. We have candles.','',26124),
(104005,'enUS','Cave ours again. Candles keep us safe.','',26124),
(104006,'enUS','Kipp Brightwick takes a deep breath.','',26124),
(104007,'enUS','The knowledge of the Pillars is here! We must find that tome!','',26124),
(104008,'enUS','Sargeras knows we\'re after the location of the Pillars! I\'ll need your help to bring down this barrier.','',26124),
(104009,'enUS','','These illusions use stealth! A flare could reveal them!',26124),
(104010,'enUS','','Their stealth is maddening! Someone drop a flare!',26124),
(104011,'enUS','Wake up! Boss is here.','',26124),
(104012,'enUS','Not asleep. Just resting eyes...','',26124),
(104013,'enUS','Violet is my favorite rat.','',26124),
(104014,'enUS','The Legion! I\'ll do what I can to block their way.','',26124),
(104015,'enUS','No! Violet!','',26124),
(104016,'enUS','Penny is the prettiest rat.','',26124),
(104017,'enUS','You\'ll pay for hurting Penny!','',26124),
(104018,'enUS','I won\'t forget you Blue!','',26124),
(104019,'enUS','You hurt Ollie. I hurt you!','',26124),
(104020,'enUS','Chewie was my only friend!','',26124),
(104021,'enUS','I\'ll catch another rat after I kill you!','',26124),
(104022,'enUS','The construct begins to act sluggish. Return to the Collapsed Ruins before it powers down!','The construct begins to act sluggish. Return to the Collapsed Ruins before it powers down!',26124),
(104023,'enUS','Be wary, friend. There are demons in our midst...','',26124),
(104024,'enUS','I have been sent by the Illidari to slay the demon Kazok\'thul.','I have been sent by the Illidari to slay the demon Kazok\'thul.',26124),
(104025,'enUS','We tracked the demon to this cavern, but the beast caught us by surprise. Some of my best warriors were killed in the battle and Kazok\'thul got away.$b$bIf you wish to draw the demon into the open, you may be able to lure it out by activating the mana beacon inside the cave.$b$bGood luck.','',26124),
(104026,'enUS','','|TInterface\\Icons\\inv_misc_monsterhorn_03.blp:20|t A %s emerges!',26124),
(104027,'enUS','I\'m not hurt. I\'m... I\'m stalking a bear!','',26124),
(104028,'enUS','Oh, I believe you. Let me just bind that wound anyway.','Oh, I believe you. Let me just bind that wound anyway.',26124),
(104029,'enUS','Wounded, Fenryr retreats to his den.','',26124),
(104030,'enUS','No no no.  You need to freeze the spark in place.  Let\'s try this again. Use Frost Nova to freeze it in place and Blink to get away.','',26124),
(104031,'enUS','<On the other side of the portal, you can faintly see Grizzly Hills.>','<On the other side of the portal, you can faintly see Grizzly Hills.>',26124),
(104032,'enUS','Blue is best friend.','',26124),
(104033,'enUS','Go to Grizzly Hills.','Go to Grizzly Hills.',26124),
(104034,'enUS','I could never eat Ollie.','',26124),
(104035,'enUS','|TInterface\\Icons\\Spell_Holy_DivineProvidence:20|t $n is affected with |cFFFF0404|Hspell:192048|h[Expel Light]|h|r!','|TInterface\\Icons\\Spell_Holy_DivineProvidence:20|t $n is affected with |cFFFF0404|Hspell:192048|h[Expel Light]|h|r!',26124),
(104036,'enUS','Chewie bites me sometimes.','',26124),
(104037,'enUS','Gnawer has sharpest teeth.','',26124),
(104038,'enUS','|TInterface\\Icons\\spell_hunter_lonewolf:20|t Fenryr begins to cast |cFFFF0404|Hspell:196543|h[Unnerving Howl]|h|r!','',26124),
(104040,'enUS','Thanks. Uh... Please don\'t let Mom know that I hurt myself.','',26124),
(104041,'enUS','You\'re almost as good as Kalla.','',26124),
(104042,'enUS','Welcome to the training grounds.$b$bHere we learn to discipline the mind and the body.','',26124),
(104043,'enUS','Strange. It should not have sent you there! Hang on, I am recalling you.','',26124),
(104044,'enUS','Someone else is tampering with the network... Telemancy is a delicate art, there is no room for amateurs!','',26124),
(104045,'enUS','Good work. Bring them back to me at the workshop!','',26124),
(104046,'enUS','Between the barnyard odor of Kalla and the rotting stench of our cook, I think I simply might pass out.','',26124),
(104047,'enUS','Picking','Picking',26124),
(104048,'enUS','The weapons of the storm await us, $n!','',26124),
(104049,'enUS','Let\'s go!','Let\'s go!',26124),
(104052,'enUS','That demon will just open another portal if we don\'t take care of it first. Prepare yourself, $p!','',26124),
(104053,'enUS','Our champion arrives! We have been sent by Tyrande bearing a weapon that may turn the tide of this war.','',26124),
(104054,'enUS','You must take up the Scythe of Elune, champion. May its power serve you well.','',26124),
(104055,'enUS','The scythe belongs to Karazhan, worm!','',26124),
(104056,'enUS','','Valorn, no!',26124),
(104057,'enUS','I\'ve seen enough suffering for a lifetime, $n. I don\'t need another funeral. I need to bring justice to the enemies of Gilneas!','',26124),
(104058,'enUS','','He has the scythe! After him!',26124),
(104059,'enUS','','He\'s gone...',26124),
(104066,'enUS','','Don\'t get so close. Your scent will give me away.',26124),
(104067,'enUS','Did Kalla send you?','',26124),
(104068,'enUS','I think your stench far overpowers mine. Now let me help you.','I think your stench far overpowers mine. Now let me help you.',26124),
(104069,'enUS','Impressive. You are quickly mastering your abilities. That was just one creature though, what happens when you have to fight many at the same time?  For this, you will need to master Flame Strike.','',26124),
(104070,'enUS','Flame Strike is a slow spell that does a tremendous amount of damage to everything in an area.  Use Flamestrike to quickly dispatch this group of oozes.','',26124),
(104071,'enUS','I will keep this between us. Now be still while I patch you up.','I will keep this between us. Now be still while I patch you up.',26124),
(104072,'enUS','','We\'re past the wards, but what\'s going on here? Could the Nightmare have spread to Ursoc\'s Lair?',26124),
(104073,'enUS','','By the Dark Lady.',26124),
(104074,'enUS','','I don\'t think I was a hunter in my past life.',26124),
(104075,'enUS','I don\'t think I am cut out to be a hunter.','',26124),
(104076,'enUS','I hope Tony has something edible back at camp.','',26124),
(104077,'enUS','I\'m going to pretend I didn\'t see that, Outlander.','I\'m going to pretend I didn\'t see that, Outlander.',26124),
(104078,'enUS','What do you think you are doing?','What do you think you are doing?',26124),
(104079,'enUS','','Let\'s get going!',26124),
(104080,'enUS','Leave that alone!','Leave that alone!',26124),
(104081,'enUS','What are you doing?','What are you doing?',26124),
(104082,'enUS','That is not yours. Rude.','That is not yours. Rude.',26124),
(104083,'enUS','Summoners, open a portal! We need reinforcements!','',26124),
(104088,'enUS','Your flesh will be fed to the hounds!','',26124),
(104089,'enUS','Your doom will come... by another\'s hand!','',26124),
(104090,'enUS','Welcome to my lands, $r. The little one told me you seek information on the legend of Irmaat.','',26124),
(104091,'enUS','You\'ve mastered the fundamentals mage, now it\'s time to learn something more advanced.  Pyroblast is your most powerful spell and it gets even more powerful when you\'re on a Hot Streak.  More Importantly, while on a Hot Streak it will have no cast time.','',26124),
(104092,'enUS','You gain a Hot Streak by landing two consecutive critical strikes.  Because Inferno Blast will always be a critical strike, start casting Fireball.  When you get your first critical strike use Inferno Blast to get the second, then cast Pyroblast.','',26124),
(104093,'enUS','','Oh! Magic!!! Hurry up, let\'s see what it does!',26124),
(104094,'enUS','You\'re on a Hot Streak, cast Pyroblast now!','',26124),
(104095,'enUS','And that\'s how you do it.  Let\'s practice that a couple more times and then I\'ll give you a real challenge.','',26124),
(104096,'enUS','Pyroblast takes a long time to cast unless you\'re on a Hot Streak.  Try using Fireball and Inferno Blast to gain a Hot Streak before casting Pyroblast this time.','',26124),
(104097,'enUS','That\'s your first critical strike, now cast Inferno Blast to get a second.','',26124),
(104098,'enUS','My winds shall rip you apart!','',26124),
(104099,'enUS','We are ready to challenge you Odyn!','We are ready to challenge you Odyn!',26124),
(104100,'enUS','Are you ready to face me?','',26124),
(104101,'enUS','HRK!','Gah...!',26124),
(104103,'enUS','Moira said ye\'d be comin\'. I\'m Slaghammer, payin\' me family\'s debt by hangin\' oot wi\' these buggers. Lemme take down this barrier.','',26124),
(104104,'enUS','Th\' Shadow Deacon is already below startin\' his ritual. Ta get there, we\'ll need ta do a bit o\' work. If ye have any questions lemme know, but we best hurry!','',26124),
(104105,'enUS','','We should get back to the Dreamgrove, $n. The Archdruid will know how to unlock the power of the Claws.',26124),
(104106,'enUS','We dinna hae much time, but ye deserve some answers. What ye want to know about? The Shadow Deacon? The Blade? What the hell is going on? Hah!','',26124),
(104107,'enUS','This was sort of sudden, where are we? What\'s going on?','This was sort of sudden, where are we? What\'s going on?',26124),
(104108,'enUS','Can ye believe they found the Tomb of Tyr himself?! He died here LONG ago fighting some monstrous general of the Old Gods. His comrades buried him \'ere and the corpse o\' that beast further in.$b$bThis tomb was also meant to guard the prison tomb o\' that monster but the Twilight\'s Hammer put a stop ta that.$b$bThe Shadow Deacon used that blade o\' his ta get in and his minions to keep the wards down while he went below.','',26124),
(104109,'enUS','The Hammer has been in disarray since their Twilight Father and Deathwing took a dive. I\'m guessin\' tha when the Legion attacked one o\' the leaders that was left took to the idea of takin\' over while everyone was distracted.$b$bHe dredged up an ancient artifact o\' the Old Gods and is planning on using it on that dead monstrosity down there to cement his takeover o\' the cult.$b$bI dinna get a good look at the Deacon, but he seems really familiar...','',26124),
(104110,'enUS','That blade... I knew Moira would want ta know. I think that dagger has been behind some of the worst nightmares Azeroth has seen if I remember me stories. It looks similar ta stories told about the War o\' Three Hammers... and Grim Batol.$b$bIt oozes shadow and seems ta cut the verra light! I think it might have a mind of its own too, it seems the Shadow Deacon is sometimes talkin\' and arguing, but to nobody at all!$b$bWe\'d best stop this ritual and pry that blade loose o\' the cult.','',26124),
(104111,'enUS','The Shadow Deacon? Who is this new leader?','The Shadow Deacon? Who is this new leader?',26124),
(104112,'enUS','You mentioned a magical blade, can you tell me more?','You mentioned a magical blade, can you tell me more?',26124),
(104113,'enUS','Threat detected. Pursuing.','',26124),
(104114,'enUS','Protection mode enabled. Targets identified.','',26124),
(104115,'enUS','Defensive calibration complete. Acquiring targets.','',26124),
(104116,'enUS','','How convenient! Your little group will make an excellent meal for my hounds!',26124),
(104117,'enUS','','You mortals are always so confident! Come forward, then. My darlings are positively ravenous!',26124),
(104118,'enUS','','Witch! I\'ll gut your beasts and take your head for what you\'ve done!',26124),
(104119,'enUS','What delightful banter! The High Inquisitor will be pleased to host such spirited guests!','',26124),
(104120,'enUS','','All bark... no bite...',26124),
(104121,'enUS','','Hah! Got you!',26124),
(104122,'enUS','','Yeah! That\'s the stuff!',26124),
(104123,'enUS','','And down it goes!',26124),
(104124,'enUS','','Don\'t worry about me, I can take care of myself.',26124),
(104125,'enUS','','Let\'s do this!',26124),
(104126,'enUS','','Hi there!',26124),
(104127,'enUS','','What\'s up?',26124),
(104128,'enUS','','Uh, got something on your mind?',26124),
(104129,'enUS','','This is bohhhring. Let\'s go do something.',26124),
(104130,'enUS','Excellent!  It\'s one thing to hit a target dummy though.  It\'s time for your final test.  You\'ll need to use everything you\'ve learned.  Defeat my men in combat and prove you\'re ready.','',26124),
(104131,'enUS','','I\'ve seen my father angry before, but never like this. He is consumed by his lust for vengeance.',26124),
(104132,'enUS','','All Gilneans have a rage inside us, Tess. Your father more than most.',26124),
(104133,'enUS','','Indeed. It\'s sometimes hard to know where the rage ends and the man begins.',26124),
(104134,'enUS','','My father stands with the king. The Forsaken will never see our forces coming!',26124),
(104135,'enUS','','I fear there will soon be more funerals.',26124),
(104136,'enUS','','Such is the cost of vengeance. Gilneas has waited for it long enough.',26124),
(104137,'enUS','','We\'re almost at the keep. Please tell King Anduin he\'s in our thoughts, $n.',26124),
(104138,'enUS','','Quickly, Tess! The gunship will be ready to leave soon!',26124),
(104139,'enUS','','Orestes!',26124),
(104140,'enUS','Our numbers are infinite.','',26124),
(104141,'enUS','Your life is forfeit!','',26124),
(104142,'enUS','You have a Hot Streak, Cast Pyroblast!','',26124),
(104143,'enUS','','Ah, Snowfeather delivered my message. Good! We have need of you.',26124),
(104144,'enUS','Good luck, friends. Save... Alleria...','',26124),
(104145,'enUS','The hounds... I got sloppy... let them get too close.','',26124),
(104146,'enUS','It\'s so damned cold...','',26124),
(104147,'enUS','','Orestes, try to... Orestes!',26124),
(104148,'enUS','<Absolon shakes violently.>\n\nGo away. Leave me to my suffering.','',26124),
(104149,'enUS','Go ahead, I am right behind you.','',26124),
(104150,'enUS','Tell me more about the Bane of the Highmountain.','Tell me more about the Bane of the Highmountain.',26124),
(104151,'enUS','I\'d like to hear about this Spear.','I\'d like to hear about this Spear.',26124),
(104152,'enUS','How did it get here? What is this place?','How did it get here? What is this place?',26124),
(104153,'enUS','','I will speak to my brother a bit longer and then we will head to the barrier. Good luck!',26124),
(104154,'enUS','Here we are - my old sanctuary!','',26124),
(104155,'enUS','Strange... the defenses are offline...','',26124),
(104156,'enUS','Intruders! How did they get in here?!','',26124),
(104157,'enUS','Thwen... I should have recognized your uniquely oafish meddling on my network.','',26124),
(104158,'enUS','','You should be proud! Your handiwork is going to help us reclaim every corner of our ancient lands.',26124),
(104159,'enUS','','My, my. You look rather gaunt, honored teacher. Are you eating enough? Ahahaha!',26124),
(104160,'enUS','','Dispose of them!',26124),
(104161,'enUS','I can deal with Thwen. You overload the coils!','',26124),
(104162,'enUS','Urgh!','',26124),
(104163,'enUS','|TInterface\\Icons\\INV_Misc_Horn_03:20|t Hymdall blows the |cFFFF0404|Hspell:191284|h[Horn of Valor]|h|r summoning Storm Drakes!','',26124),
(104164,'enUS','Thank you for your kindness. I will never forget it.','',26124),
(104165,'enUS','','We cannot fight the monster until you place the trap! Hurry!',26124),
(104166,'enUS','','Hold off these beasts until the trap is sprung!',26124),
(104167,'enUS','The darkness lifts... thank you.','',26124),
(104178,'enUS','Use Frost Nova to freeze your enemies in place and get away.','',26124),
(104179,'enUS','Join us at the Circle of Wills in Dalaran\'s underbelly, warlock. My portal will take you there directly. We will be waiting.','',26124),
(104181,'enUS','','I was looking for the betrayer.',26124),
(104182,'enUS','','You are nothing.',26124),
(104183,'enUS','','Fall before the might of Suramar.',26124),
(104184,'enUS','','To think I was slain... by a...',26124),
(104185,'enUS','','I have failed my mission.',26124),
(104186,'enUS','','Avenge me, Anishar!',26124),
(104187,'enUS','Where is the betrayer?','',26124),
(104188,'enUS','By the might of the Nightwell!','',26124),
(104189,'enUS','Foolish creature. I will show you real power.','',26124),
(104190,'enUS','Elisande... I have failed you.','',26124),
(104191,'enUS','Pathetic... creature... I will...','',26124),
(104192,'enUS','Avenge my death, Idriana.','',26124),
(104193,'enUS','Evaluating target.','',26124),
(104194,'enUS','Initiating combat mode.','',26124),
(104195,'enUS','Threat level minimal.','',26124),
(104196,'enUS','Primary core damaged...','',26124),
(104197,'enUS','Power reserves depleted.','',26124),
(104198,'enUS','Contacting nearest Seeker.','',26124),
(104200,'enUS','What did your daughter carry with her, Valendrel?','What did your daughter carry with her, Valendrel?',26124),
(104201,'enUS','And your wife?','And your wife?',26124),
(104204,'enUS','Are you okay?','Are you okay?',26124),
(104205,'enUS','I am at your service, $ct','',26124),
(104206,'enUS','Station Li Li.','Station Li Li.',26124),
(104207,'enUS','','I\'m happy to finally be done with that jungle.',26124),
(104208,'enUS','','Such an honor to be part of the rebirth of the Unseen Path!',26124),
(104209,'enUS','','Together we\'ll triumph against the Legion!',26124),
(104210,'enUS','','I never go anywhere without Sif and Nel.',26124),
(104211,'enUS','I still do not feel safe.','',26124),
(104212,'enUS','','I have finally found you, Dorion. And now I will end you.',26124),
(104213,'enUS','That\'s it, you\'ve done it!  You truly are a skilled in your art.  There is little more I can teach you here, this is simply where your journey begins.','',26124),
(104214,'enUS','','$ct, I\'ve found someone new to join us! Come meet us at the Wandering Isle as soon as you can.',26124),
(104215,'enUS','If you feel you need more time to practice then take this portal to the Proving Grounds. There you can train with Master Rotun and truly master your class.  Otherwise, use that gyrocopter over there and head into battle.','',26124),
(104219,'enUS','Speak quickly. My entire operation requires that I do not attract unwanted attention.','',26124),
(104220,'enUS','Why put yourself at risk to help them?','Why put yourself at risk to help them?',26124),
(104221,'enUS','This coil taps into the ancient leylines. Crank it up to full power!','',26124),
(104222,'enUS','Overcharging','Overcharging',26124),
(104223,'enUS','There are more coils in the chamber below - and more intruders, I imagine.','',26124),
(104224,'enUS','Good. If we overcharge enough coils, the entire system will failsafe into a lockdown.','',26124),
(104225,'enUS','It is not yet your time, Varedis.','',26124),
(104226,'enUS','Unleash the Twinblades and destroy the interloper!','',26124),
(104227,'enUS','Well done, $p. We managed to clear the skies while you dealt with Varedis.','',26124),
(104228,'enUS','Just a small tasterino of the Arcano-Plasm...','',26124),
(104229,'enUS','Not bad... Kind of minty...','',26124),
(104230,'enUS','I feel funny...','',26124),
(104231,'enUS','Ahhh!!!','',26124),
(104232,'enUS','','Face it, old man. I have surpassed you.',26124),
(104233,'enUS','Good trick... <cough> Warping the space around your body like that.','',26124),
(104234,'enUS','Graa.... Ooh... oooWAAAAAHHHH!!!!','',26124),
(104235,'enUS','But what if that space is already unstable?','',26124),
(104236,'enUS','','You do not belong here, $r.',26124),
(104237,'enUS','','We are taking back these ruins for the Legion.',26124),
(104238,'enUS','','You stand little chance against me.',26124),
(104239,'enUS','','For the Legion.',26124),
(104240,'enUS','','You will never leave this place.',26124),
(104241,'enUS','','The Nightwell has failed me.',26124),
(104242,'enUS','We are taking back these lands.','',26124),
(104243,'enUS','I will cut you down.','',26124),
(104244,'enUS','You cannot hope to best me, $r.','',26124),
(104245,'enUS','The Legion will envelop these lands.','',26124),
(104246,'enUS','How... could...','',26124),
(104247,'enUS','You will never escape the Legion.','',26124),
(104248,'enUS','','My warp field is not working! Where have you taken us?!',26124),
(104249,'enUS','<cough> Unstable... space...','',26124),
(104250,'enUS','','Altruis and the others await you at Krasus\' Landing. I\'ll meet you there.',26124),
(104251,'enUS','The Nightfallen appears to be alive, but is unresponsive.','',26124),
(104252,'enUS','Feed the Nightfallen Ancient Mana. <NYI>','Feed the Nightfallen Ancient Mana. <NYI>',26124),
(104253,'enUS','What ill-fated chance brings our paths together, $r?','',26124),
(104254,'enUS','Ughhhhhh...','',26124),
(104256,'enUS','$n, I\'m glad that you\'re here. Malevolence has been providing us with transportation back and forth from the Fel Hammer.\n\nThe Burning Legion have invaded Faronaar across the isthmus. We must destroy them before they overrun the rest of this island.','',26124),
(104257,'enUS','Khadgar? $n? I was not expecting you.','',26124),
(104258,'enUS','Like Blink, Frost Nova has a long cooldown.  So you can train more effectively though, I\'m filling this room with arcane energy so you can use them more often.','',26124),
(104259,'enUS','Your artifact looks powerful, $c. Speak with Jace and Allari if you intend to help.','',26124),
(104260,'enUS','You, Kor\'vas, and Cyana attack the Legion from within. Then, we\'ll wipe them out together.','',26124),
(104261,'enUS','I will see to it that the Legion gets no farther.','',26124),
(104262,'enUS','I will see to it that the Legion gets no farther.','',26124),
(104264,'enUS','We are indomitable. We are Illidari.','',26124),
(104265,'enUS','','Do not forget to use the gem to suck the soul out of the demon corpses.',26124),
(104266,'enUS','','Wanna see a trick my uncle Chen taught me?',26124),
(104267,'enUS','Bless the crane! A healer!','',26124),
(104268,'enUS','Thwen always took magic too lightly... She was a terrible student... <cough>','',26124),
(104269,'enUS','I haven\'t much left... <cough> I will get us as close as I can... Come close.','',26124),
(104270,'enUS','','No! This place... it must bend to my will!',26124),
(104271,'enUS','','An\'ratha... an\'tal-thandros!',26124),
(104272,'enUS','These buggers are suppressin\' Tyr\'s wards so the Deacon can do his work below. We need ta take \'em down! Start by dispellin\' the wards on the ritualists!','',26124),
(104273,'enUS','','He may be trying to leave discreetly. I\'d start looking down in the Underbelly.',26124),
(104274,'enUS','','Hemet and his hunters bring death and destruction wherever they go, slaughtering innocent animals for sport.\nThey must pay for their crimes against nature.\n\nIf the animals of this basin could speak, they would ask for our help. Let\'s level the playing field a bit and let those hunters be hunted for a change.\n\nI will alter your form to resemble a creature native to this region. Once transformed, those hunters will become your prey.\n\nAre you ready?',26124),
(104275,'enUS','There we go! The path to the prison should be ope... Well, if it ain\'t me old friend! We\'d be doin\' the world a favor riddin\' it o\' this baddie!','',26124),
(104276,'enUS','I... I don\'t feel well.','',26124),
(104277,'enUS','The Legion knows the importance of this sacred place. I personally led the patrol here, but we were ambushed and overcome.','',26124),
(104278,'enUS','Thank you, hero. The sacred waters have already been corrupted. If you help me rescue the others, we may be able to reclaim this place.','',26124),
(104279,'enUS','','At once, Ranger-General. But beware! Time flows unpredictably so deep in the Nether.',26124),
(104280,'enUS','','Orestes, you fool!',26124),
(104281,'enUS','','Now we have two allies to rescue. Follow me in!',26124),
(104282,'enUS','This robot is broken beyond repair.','This robot is broken beyond repair.',26124),
(104283,'enUS','The Darkswell will devour you!','The Darkswell will devour you!',26124),
(104284,'enUS','You cannot maintain your current form in this area.','You cannot maintain your current form in this area.',26124),
(104285,'enUS','From the depths we ssstrike!','From the depths we ssstrike!',26124),
(104286,'enUS','Jabrul was headed towards a harpy nest when he was ambushed. Let\'s head there now and search for those stones.','',26124),
(104287,'enUS','It looks like the Feeble Husks sucked out all of the Arcano-Plasm, destroying FTW-001 in the process.','It looks like the Feeble Husks sucked out all of the Arcano-Plasm, destroying FTW-001 in the process.',26124),
(104288,'enUS','Thalyssra is near Meredil. Can you teleport us?','Thalyssra is near Meredil. Can you teleport us?',26124),
(104289,'enUS','We have to deal with Thwen before we can leave.','',26124),
(104290,'enUS','I am fading fast. Where is Thalyssra?','',26124),
(104291,'enUS','','The great Lulubelle Fizzlebang, at your service!',26124),
(104292,'enUS','I... live!','',26124),
(104293,'enUS','It seems not even a pit lord can keep you down, warlock!','',26124),
(104294,'enUS','But what of the rest of the council?','',26124),
(104295,'enUS','One more thing, warlock.','',26124),
(104296,'enUS','With our members scattered and a dreadlord on our heels, we need you to take leadership of the council. Through your power, we can rebuild.','',26124),
(104297,'enUS','I name you, $n, the First of the Council of the Black Harvest.','',26124),
(104298,'enUS','May you lead us to glory against the Legion!','',26124),
(104299,'enUS','Come, let us plan the future of our order.','',26124),
(104300,'enUS','','$p, a moment, please. I bear an urgent message for you.',26124),
(104301,'enUS','','Apologies for my persistence, but this message is quite urgent.',26124),
(104302,'enUS','','I\'m afraid I cannot leave without delivering this missive to you.',26124),
(104303,'enUS','','I must insist that we speak. It will only take a moment!',26124),
(104304,'enUS','','We\'ll just have to get used to one another\'s company until you\'re ready to speak.',26124),
(104305,'enUS','','This is for your eyes only. Once you\'ve read it, destroy it.',26124),
(104306,'enUS','','Farewell.',26124),
(104307,'enUS','Pustulio speaks the truth! The Windrunner is captive on Niskara!','',26124),
(104308,'enUS','You\'d better not be lying, worm!','',26124),
(104309,'enUS','Go to Niskara! Then you will see!','',26124),
(104310,'enUS','','We should just end its miserable existence now!',26124),
(104311,'enUS','Lots of demons out there, but nothing we can\'t handle.','',26124),
(104312,'enUS','I\'ll look into doing that favor for you.','I\'ll look into doing that favor for you.',26124),
(104313,'enUS','','If anything gets close... I\'ll kill it.',26124),
(104314,'enUS','I am ready.','I am ready.',26124),
(104316,'enUS','$p, your presence is requested in the Hall of Shadows at once.','',26124),
(104318,'enUS','Enter the Glorious Goods storefront and utter \"the raven calls\" to Red. He will show you the way.','',26124),
(104319,'enUS','Come alone, and ensure you are not followed. The eyes of the Uncrowned are upon you.','',26124),
(104320,'enUS','','Excellent choice. You can find my problem in the Circle of Wills. His name is Inkrot, and I need someone to send him a lesson. I believe you know what to do, $c.',26124),
(104321,'enUS','Now that our business is concluded, I shall take me leave. See ya around, $n.','',26124),
(104322,'enUS','Not without the Ranger-General\'s order. Understood?','',26124),
(104323,'enUS','$ct, My mission was a success! The demons have been crushed and our brother in undeath still lives. Meet with me in Acherus as soon as you are able.','',26124),
(104324,'enUS','%s thanks you, sheepishly.','',26124),
(104325,'enUS','','Minions! Feast on their souls!',26124),
(104326,'enUS','Only a fool walks into the Hall of Shadows unaware! Prepare to--','',26124),
(104327,'enUS','','Right this way, please.',26124),
(104328,'enUS','','The others are waiting for you. Good luck.',26124),
(104329,'enUS','They won\'t stop their assaults! Help us put an end to it!','They won\'t stop their assaults! Help us put an end to it!',26124),
(104330,'enUS','This... this is madness, $n! You must do something!','This... this is madness, $n! You must do something!',26124),
(104331,'enUS','The Legion is here! Prepare yourself for battle!','The Legion is here! Prepare yourself for battle!',26124),
(104332,'enUS','If you need not be here, I suggest you find shelter.','If you need not be here, I suggest you find shelter.',26124),
(104333,'enUS','There is no harm in hiding, $n, but you... you look like a brave $c. We could use your help.','There is no harm in hiding, $n, but you... you look like a brave $c. We could use your help.',26124),
(104334,'enUS','Look at them... they are not even people any more. I cannot turn into one of them. We must reach Astoril quickly. Clear the path faster!','Look at them... they are not even people any more. I cannot turn into one of them. We must reach Astoril quickly. Clear the path faster!',26124),
(104335,'enUS','More exiles... like me. All I did was punish those servants... You would have done the same!','More exiles... like me. All I did was punish those servants... You would have done the same!',26124),
(104336,'enUS','You must be Astoril! Finally! The first thing I shall do when I get back in the city is drink a cool, tall glass of arcwine.','You must be Astoril! Finally! The first thing I shall do when I get back in the city is drink a cool, tall glass of arcwine.',26124),
(104337,'enUS','Be careful, $n. I just saw a $c like yourself not long ago. The Legion... they - $B$BThey\'ll stop at nothing to devour our lands! I cannot ask you to put yourself in harms way to fight by my side, but I can tell you that if we don\'t stop them soon we\'ll have nothing left to fight for.','Be careful, $n. I just saw a $c like yourself not long ago. The Legion... they - $B$BThey\'ll stop at nothing to devour our lands! I cannot ask you to put yourself in harms way to fight by my side, but I can tell you that if we don\'t stop them soon we\'ll have nothing left to fight for.',26124),
(104338,'enUS','You will find no easy target here, demon.','',26124),
(104339,'enUS','If your Legion wants Pandaria, you will have to get through US!','',26124),
(104340,'enUS','Brave $r! Have you come to put an end to the Legion?','Brave $r! Have you come to put an end to the Legion?',26124),
(104341,'enUS','We\'ll hold them off as long as we can, but please - if we have any hope of saving this place it\'s with your help, $n!','We\'ll hold them off as long as we can, but please - if we have any hope of saving this place it\'s with your help, $n!',26124),
(104342,'enUS','The Legion will fall, $ct. The Ebon Blade will make sure of it.','',26124),
(104343,'enUS','Ah! There\'s our final member. Welcome to the crew!','',26124),
(104344,'enUS','','Valeera glances in your direction.',26124),
(104345,'enUS','','Yes?',26124),
(104346,'enUS','The landwalkers are here! We will drive them back by salt and scale!','',26124),
(104347,'enUS','We will take this land.','',26124),
(104348,'enUS','For our queen!','',26124),
(104349,'enUS','We will take what we want from this land.','',26124),
(104350,'enUS','Sakar\'thiss will see you dead.','',26124),
(104351,'enUS','Aid me, Raj\'kess!','',26124),
(104352,'enUS','Death comes to all.','',26124),
(104353,'enUS','','Your druids will perish!',26124),
(104354,'enUS','','You will not stop us.',26124),
(104355,'enUS','','We will take what we want.',26124),
(104356,'enUS','','I have failed my queen.',26124),
(104357,'enUS','','Raj\'kess... slay this...',26124),
(104358,'enUS','','Sakar\'thiss...',26124),
(104359,'enUS','I will crush you.','',26124),
(104360,'enUS','Sakar\'thiss... kill you...','',26124),
(104361,'enUS','Never was very good at following orders. See you on the other side!','',26124),
(104362,'enUS','This land and its resources belong to us!','',26124),
(104363,'enUS','More will come to take my place...','',26124),
(104364,'enUS','','Magus Solgaze, empower the portal crystal.',26124),
(104365,'enUS','%s falls to one knee, gravely wounded.','%s falls to one knee, gravely wounded.',26124),
(104366,'enUS','Want to live? Kill these fools.','',26124),
(104367,'enUS','Yes... the Blade is right! I am unstoppable! Once Zakajz lives again, I will hold dominion over this world!','',26124),
(104368,'enUS','Our old leaders chose to work with pawns. I choose the REAL power!','',26124),
(104369,'enUS','Begone, beast! Your shameful crusade ends here.','',26124),
(104370,'enUS','Come, that monster has already spread his corruption to the waters above. We must act quickly.','',26124),
(104371,'enUS','','He is withering...',26124),
(104372,'enUS','','I scavenged a few more mana crystals while you were out. Set him down over here.',26124),
(104373,'enUS','The Nightborne\'s body lies bloody and beaten. By the looks of his wounds, it appears that he sustained a crushing blow to the chest.','',26124),
(104374,'enUS','We must work together. Champion, we will follow your lead. How do you wish to deploy the Shado-Pan?','',26124),
(104375,'enUS','You ronir lovers ain\'t gonna take my stock!','',26124),
(104376,'enUS','','This fel magic eats at my soul! I can\'t hold the portal open long. Get going!',26124),
(104377,'enUS','Bring the supplies through! The commander will be arriving shortly.','',26124),
(104378,'enUS','The end draws near...','',26124),
(104379,'enUS','Nothing survives! NOTHING!','',26124),
(104380,'enUS','Rid these worthless mortals of their flesh!','',26124),
(104381,'enUS','You will know the pain of a thousand worlds.','',26124),
(104382,'enUS','Your world trembles in our wake.','',26124),
(104383,'enUS','Everybody back. $p be havin\' important business with da admiral.','',26124),
(104384,'enUS','','This thirst for the Nightwell is unending. If I hadn\'t come across Manashale, I would have perished by now.',26124),
(104385,'enUS','','I am content to spend my days down here with Manashale. He\'s quickly becoming my closest friend.',26124),
(104386,'enUS','My mind is as sharp as ever.','',26124),
(104387,'enUS','I hunger, but I press on.','',26124),
(104388,'enUS','<Oculeth mumbles incoherently under his breath.|cFFF92304His hunger must be sated before all else.|r>','',26124),
(104389,'enUS','I will do everything in my power to defend Suramar from the Legion.','',26124),
(104394,'enUS','Listen up! Raise a mug for the outlaw that\'s gonna take the Dreadblades from that blasted Eliza\'s cold, dead hands!','',26124),
(104395,'enUS','Hoist the sails! Reel in the anchor! Ready yerselves, ya salty dogs! Azsuna awaits!','',26124),
(104396,'enUS','Just let me know when yer ready. Eliza won\'t know what\'s comin\' for her!','',26124),
(104397,'enUS','Are ya ready?','',26124),
(104398,'enUS','Set sail for Azsuna!','Set sail for Azsuna!',26124),
(104399,'enUS','Murky waters envelop you, softssskin!','Murky waters envelop you, softssskin!',26124),
(104400,'enUS','The ssseas rise against you!','The ssseas rise against you!',26124),
(104401,'enUS','Goldrinn\'s power will be ours, $r!','Goldrinn\'s power will be ours, $r!',26124),
(104402,'enUS','The Scythe of Elune belongs to the worgen!','The Scythe of Elune belongs to the worgen!',26124),
(104403,'enUS','Ssshiver before the Rimescale!','Ssshiver before the Rimescale!',26124),
(104404,'enUS','Down into the cold depths with you!','Down into the cold depths with you!',26124),
(104405,'enUS','They were going to feed us to their basilisks!','They were going to feed us to their basilisks!',26124),
(104406,'enUS','They took some of our people deeper into the Enclave.','They took some of our people deeper into the Enclave.',26124),
(104407,'enUS','My thanks, champion!','My thanks, champion!',26124),
(104408,'enUS','This is why I hate caves.','This is why I hate caves.',26124),
(104409,'enUS','They took us by surprise at night.','They took us by surprise at night.',26124),
(104410,'enUS','Time for some payback!','Time for some payback!',26124),
(104411,'enUS','','Finally free from that cursed mage trap! Such a-',26124),
(104412,'enUS','Hey there! I was just enjoying a relaxing vacation on the beach when a chilling sense of dread washed over me. Just what are you up to, I wonder?','',26124),
(104413,'enUS','','Wait, I recognize that voice...',26124),
(104414,'enUS','Oh buttons, what have you done? Hurry, get her back in the cell!','',26124),
(104415,'enUS','','MILLHOUSE!! You\'re next!',26124),
(104416,'enUS','Quick, disarm her squirrel bombs before they blow!','',26124),
(104417,'enUS','Now scrap those pesky rocket chickens! They\'re going to fire!','',26124),
(104418,'enUS','Now make fun of her hair! It won\'t help, but it\'ll make her REAAAALLLLY mad!','',26124),
(104419,'enUS','','Why you... No one insults my hair! NO ONE!',26124),
(104420,'enUS','Follow me to the landing!','',26124),
(104421,'enUS','Hoo boy, you really did it!','',26124),
(104422,'enUS','','I know it was you, Millhouse!',26124),
(104423,'enUS','Uh oh.','',26124),
(104424,'enUS','Listen Milly, I can explain!','',26124),
(104425,'enUS','','Don\'t \"Milly\" me, Millhouse Jerimus Manastorm! I\'m coming for you!',26124),
(104426,'enUS','That\'s not even my middle name!','',26124),
(104427,'enUS','Thanks a lot. You have no idea what you unleashed upon the world today!','',26124),
(104428,'enUS','On a completely unrelated note, I... uh... have to go take care of something...','',26124),
(104429,'enUS','She\'s ready to take you to Ranger-General Windrunner. Good luck, commander!','',26124),
(104430,'enUS','Defend me, Blade! You said this would work!','',26124),
(104431,'enUS','The Dark Riders were not always like this. They were once a group of traveling merchants.','',26124),
(104432,'enUS','Unfortunately they crossed the sorcerer Medivh, who cursed them to an eternity of hunting artifacts for him.','',26124),
(104433,'enUS','Ariden was the first of the Dark Riders, and I believe he leads them now.','',26124),
(104434,'enUS','His camp is still in Deadwind Pass, strangely untouched after all these years.','',26124),
(104435,'enUS','If my convictions are correct, the key to finding the Dark Riders, as well as the artifacts they still covet, can be found there.','',26124),
(104436,'enUS','The worgen led you here as well? This must be where the scythe is kept!','',26124),
(104437,'enUS','Let\'s get a move on! The Horizon\'s Edge be just over this ridge.','',26124),
(104438,'enUS','Fight them. Earn your freedom!','',26124),
(104439,'enUS','Ah, there she be. Ain\'t she a beauty?','',26124),
(104440,'enUS','Hey! Get away from my chompers!','',26124),
(104441,'enUS','Thems my chompers! Leave \'em alone!','',26124),
(104442,'enUS','You hurtin\' my precious babies?!','',26124),
(104443,'enUS','Come on boys! Eat that invader.','',26124),
(104444,'enUS','Stop smakin\' my babies!','',26124),
(104445,'enUS','Squawk! Taking the ship.','',26124),
(104446,'enUS','Ye sneak past the guards and make sure the first mate sees our side o\' things. We\'ll join ya after that.','',26124),
(104447,'enUS','','Thank you, $c. I must return to my sisters.',26124),
(104448,'enUS','','My thanks, champion! Now to contend with the vile drogbar who caught us.',26124),
(104449,'enUS','','It\'s so good to see you again, $n! We really lit Pandaria up together, didn\'t we?$b$bI\'ve been perfecting my fire spells since you last worked with the Shado-Pan. If you can keep me on my feet, I will be able to break Aspersius\'s ice walls and otherwise bring him to a boil. Stand near me and I will enhance the power of your Jade Lightning.$b$b<Fei Li grins savagely.>$b$bDo you want me to REALLY light this thing up or should I concentrate on keeping myself alive?',26124),
(104450,'enUS','','Thank you, $c, for coming to our aid. I am Fei Li, and I have a reputation among the Shado-Pan for setting things on fire. Usually our enemies. Sometimes our Monastery. Lord Taran Zhu isn\'t too pleased with me at the moment...$b$bHelp me get back into his good graces. If you can keep me on my feet, I will be able to break Aspersius\'s ice walls and otherwise bring him to a boil. Stand near me and my Brilliance Aura will restore your mana.$b$b<Fei Li grins savagely.>$b$bDo you want me to REALLY light this thing up or should I concentrate on keeping myself alive?',26124),
(104451,'enUS','We should try to find a way to stop his channeling...','',26124),
(104452,'enUS','Concentrate on staying alive, Fei Li. I need to focus on the others.','Concentrate on staying alive, Fei Li. I need to focus on the others.',26124),
(104453,'enUS','Do your worst, Fei Li! Even if it puts you in danger. I\'ll keep you alive.','Do your worst, Fei Li! Even if it puts you in danger. I\'ll keep you alive.',26124),
(104454,'enUS','Greetings, $n! Your training has progressed far since we last adventured together in Pandaria. I\'d venture that even Lord Taran Zhu could learn a thing or two from you. It\'s a pleasure to be fighting with you again.$b$bNow, to business! I will assault Aspersius at range while Whitefeather swoops in to harass him with beak and claw. Stand near me and I will help you cast spells faster.$b$bI could go for an all-out attack, but it would put myself at risk. How aggressive should I be?','',26124),
(104455,'enUS','Hello, $c! It is good to have a healer at our side. We are the Shado-Pan, the last defense of Pandaria. I am Hawkmaster Nurong, Master of the Wu Kao discipline - we are the eyes of the Shado-Pan, the scouts who make our enemies fear the darkness.$b$bNow, to business! I will assault Aspersius at range while my hawk Whitefeather swoops in to harass him with beak and claw. Stand near me and I will help you attack faster.$b$bI could go for an all-out attack, but it would put myself at risk. How aggressive should I be?','',26124),
(104456,'enUS','Concentrate on keeping yourself alive, Nurong. Fight defensively.','Concentrate on keeping yourself alive, Nurong. Fight defensively.',26124),
(104457,'enUS','Do as much damage as you can, Nurong, even if it puts you at risk. I will keep you alive!','Do as much damage as you can, Nurong, even if it puts you at risk. I will keep you alive!',26124),
(104458,'enUS','','$n! It has been such a long time. You should visit us in Pandaria more often. You and I made a great team.$b$bYou know my strengths, $n. While Taran Zhu holds that thing\'s attention, I will stalk it from behind and bury my daggers in any weak spots. I can also help you move quickly around the battlefield - stand near me to reset your roll and flying kick abilities.$b$bHow aggressive do you want me to be? I could throw caution to the wind and wage an all-out assault, but I\'ll need to know you have my back!',26124),
(104459,'enUS','','Thank you for your well-timed rescue, $c. We could\'ve used your help in the Pandaren Campaign. My name is Taoshi, the silent blade of the Shado-Pan. I slip unseen through enemy territory and strike where they are weakest.$b$bI\'ll do my part. While Taran Zhu holds that thing\'s attention, I will stalk it from behind and bury my daggers in any weak spots. I can also help you move quickly around the battlefield - stand near me to gain charges of your Roll, Chi Torpedo, and Mistwalk abilities.$b$bHow aggressive do you want me to be? I could throw caution to the wind and wage an all-out assault, but I\'ll need to know you have my back!',26124),
(104460,'enUS','Don\'t be too aggressive - keep yourself alive, even if it means sacrificing damage.','Don\'t be too aggressive - keep yourself alive, even if it means sacrificing damage.',26124),
(104461,'enUS','Don\'t hold back, Taoshi! Do your worst to that thing and I will keep you alive.','Don\'t hold back, Taoshi! Do your worst to that thing and I will keep you alive.',26124),
(104462,'enUS','Naraxas\' |cFFFF0000|Hspell:199176|h[Spiked Tongue]|h|r begins to salivate!','Naraxas\' |cFFFF0000|Hspell:199176|h[Spiked Tongue]|h|r begins to salivate!',26124),
(104463,'enUS','Drogbar leap down from the stands!','Drogbar leap down from the stands!',26124),
(104464,'enUS','Very well! If you so thirst for the power of the Scythe, then I will show it to you myself!','',26124),
(104465,'enUS','Face the fury of the beast!','',26124),
(104466,'enUS','You have proven an unexpected ally, $c. The Scythe of Elune is yours. Let us hope it can turn the tide in this war.','',26124),
(104467,'enUS','If you want the Scythe, druid, come and claim it!','',26124),
(104468,'enUS','This stinks of a trap. You can\'t rely on the word of a demon!','',26124),
(104469,'enUS','','If it\'s lying, we\'ll have its head. But if there\'s even a chance it speaks the truth, we have to try!',26124),
(104470,'enUS','','Psst! Over here, $n.',26124),
(104471,'enUS','Dreadhound sniffs the air excitedly.','',26124),
(104472,'enUS','$n prepares a Hearty Feast!','$n prepares a Hearty Feast!',26124),
(104473,'enUS','$n prepares a Lavish Suramar Feast!','$n prepares a Lavish Suramar Feast!',26124),
(104474,'enUS','Now that\'s an offer I can\'t refuse! Fall back to the temple. They can have this pile of driftwood!','',26124),
(104475,'enUS','Ye\'ll be findin\' Eliza in the temple ruins ahead. Keep yer wits about ya! Her whole crew\'s onto us now.','',26124),
(104476,'enUS','We\'ll provide naval support as soon as we\'re up and runnin\'.','',26124),
(104477,'enUS','This is nae good! I kin hear more comin\' from above. I\'ll handle \'em. Ye take care o\' the Deacon!','',26124),
(104478,'enUS','|TInterface\\Icons\\inv_sword_115:20|t%s equips the Massive Sword and gains |cFFFF0000|Hspell:199556|h[Brutal Attacks]|h|r!','',26124),
(104480,'enUS','|cFFFF0000$n|r attack the brute without the |cFFFF0000|Hspell:199556|h[Brutal Attacks]|h|r buff!','',26124),
(104482,'enUS','','I can feel the power of the ley line.',26124),
(104483,'enUS','','You will not harm our plants!',26124),
(104484,'enUS','','You are corrupting our habitat!',26124),
(104485,'enUS','','Intruder!',26124),
(104486,'enUS','','My plants...',26124),
(104487,'enUS','','Sisters!',26124),
(104488,'enUS','','Come to me, my sisters...',26124),
(104489,'enUS','','I must... protect...',26124),
(104490,'enUS','','Be still and let me mend your wounds.',26124),
(104491,'enUS','','You are lucky to be alive, my sister.',26124),
(104492,'enUS','','Rest easy. I will take care of you.',26124),
(104493,'enUS','','Ugh...',26124),
(104494,'enUS','','Please... Help me...',26124),
(104495,'enUS','','Don\'t leave me like this...',26124),
(104496,'enUS','','Why have you turned against us?',26124),
(104497,'enUS','Keep your eyes peeled. The admiral is not to be disturbed.','',26124),
(104498,'enUS','Back into the cage with you!','',26124),
(104499,'enUS','Ah, a perfect test subject!','',26124),
(104500,'enUS','Time for a little field testing!','',26124),
(104501,'enUS','Irlik raka glab markzan!','',26124),
(104502,'enUS','Needed more... sulphur...','',26124),
(104503,'enUS','N... No! My potions...','',26124),
(104504,'enUS','Noooo! My potions...','',26124),
(104505,'enUS','|TInterface\\Icons\\ability_fixated_state_red:20|t  Fenryr cast |cFFFF0404|Hspell:196838|h[Scent of Blood]|h|r on you! Run!','',26124),
(104506,'enUS','','You\'ll pay for what you\'ve done, fiend!',26124),
(104507,'enUS','I found the scurvy dog! To arms!','',26124),
(104508,'enUS','This... this shouldn\'t be happening! Why aren\'t you protecting me?!','',26124),
(104509,'enUS','','Weak and pitiful! The Twilight Father did not dare wield me, for he knew the price of failure.',26124),
(104510,'enUS','Give me another chance! No! Noooo!','',26124),
(104511,'enUS','','You, on the other hand... Yes, I foresee us doing great things together. Take hold of my haft and I will aid you... for now.',26124),
(104512,'enUS','','So, you\'re the one who stole MY ship and killed MY crew.',26124),
(104513,'enUS','','Release the giant. I have business to attend to within the temple.',26124),
(104514,'enUS','With pleasure, admiral.','',26124),
(104515,'enUS','It took half our crew to subdue this creature. Let\'s see what it does to you.','',26124),
(104516,'enUS','All will know the blades of Dread Admiral Eli--','',26124),
(104517,'enUS','That which was foreseen has come to pass. The circle nears completion. Sentries, attend to our \"guests\"!','',26124),
(104518,'enUS','The way is clear, just as the Great One promised! This tower is ours for the taking!','',26124),
(104519,'enUS','%s vanishes, summoning |cFFFF0404|Wild Imps|r!','',26124),
(104520,'enUS','%s reappears!','',26124),
(104521,'enUS','I will ride... again...','',26124),
(104522,'enUS','We got yer back. Lead the beast into our line of fire!','',26124),
(104523,'enUS','Uuuugh, you pick bad time to interrupt! My. Tummy. No. Good!','',26124),
(104524,'enUS','The beast\'s wrath will end you!','',26124),
(104525,'enUS','This one broken!','',26124),
(104526,'enUS','Did you get an owie?','',26124),
(104527,'enUS','Too much stinky for you!','',26124),
(104528,'enUS','Better look out... blegh!','',26124),
(104529,'enUS','Not feel so good!','',26124),
(104530,'enUS','Gonna lose it!','',26124),
(104531,'enUS','Taste better going in!','',26124),
(104532,'enUS','Yummy!','',26124),
(104533,'enUS','Mmm! So good!','',26124),
(104534,'enUS','At least... tummy... feel better...','',26124),
(104535,'enUS','|TInterface\\Icons\\Ability_Creature_Disease_05:20|t A Black Bile begins to emit a |cFFFF0404|Hspell:201753|h[Necrotic Aura]|h|r!','|TInterface\\Icons\\Ability_Creature_Disease_05:20|t A Black Bile begins to emit a |cFFFF0404|Hspell:201753|h[Necrotic Aura]|h|r!',26124),
(104536,'enUS','|TInterface\\Icons\\Ability_Creature_Poison_06:20|t Festerface begins to wretch a |cFFFF0404|Hspell:201598|h[Congealing Vomit]|h|r!','|TInterface\\Icons\\Ability_Creature_Poison_06:20|t A Black Bile begins to emit a |cFFFF0404|Hspell:201753|h[Necrotic Aura]|h|r!',26124),
(104537,'enUS','Your life falls inevitably toward the void!','Your life falls inevitably toward the void!',26124),
(104538,'enUS','There is no meaning in your existence! Succumb to the abyss!','There is no meaning in your existence! Succumb to the abyss!',26124),
(104539,'enUS','Crush! Yes, crush tiny creature!','Crush! Yes, crush tiny creature!',26124),
(104540,'enUS','Snake masters say tiny creature must die!','Snake masters say tiny creature must die!',26124),
(104541,'enUS','Activate the crystals when we get in trouble, right.','Activate the crystals when we get in trouble, right.',26124),
(104542,'enUS','Get your people to safety, we\'ll keep the Legion\'s forces at bay.','Get your people to safety, we\'ll keep the Legion\'s forces at bay.',26124),
(104543,'enUS','We got that briny bastard! Let \'im have it!','',26124),
(104544,'enUS','','Yes, we are eager to feast on the fallen titan\'s minions. But first... Zakajz.',26124),
(104545,'enUS','Fire all cannons! Fire. Fire!','',26124),
(104546,'enUS','','The cultists may try to stir him again, or he could awaken on his own. We must consume his essence to ensure he is gone forever. You know this must be done.',26124),
(104547,'enUS','Eliza escaped into the temple ahead. We\'ll make sure none o\' her mangy crew follow ya. Go get \'er!','',26124),
(104548,'enUS','We\'re out o\' cannonballs! Ye\'ll have to figure yer own way past the temple door.','',26124),
(104549,'enUS','The worgen escape down the cliff toward Karazhan!','The worgen escape down the cliff toward Karazhan!',26124),
(104550,'enUS','Ye did it! The cultists ha\'e run off! Ha ha! Ye should get back ta Faol. I\'ll use this Twilight portal stone fer ye!','',26124),
(104551,'enUS','I\'ll bring down the barrier. Watch my back!','',26124),
(104552,'enUS','Keep an eye on that blade, though. No tellin\' wha\' somethin\' that old be capable of.','',26124),
(104553,'enUS','Just a little and... down it goes!','',26124),
(104554,'enUS','Hey, I need some help here! I\'m not going to ask again!','',26124),
(104555,'enUS','First the Nightbane are driven mad, and now a druid comes to investigate Manor Mistmantle?','',26124),
(104556,'enUS','This can only mean the Scythe of Elune has returned to Duskwood... and the Dark Riders cannot be far behind.','',26124),
(104557,'enUS','Tell me what you seek, druid, and I may be of assistance.','',26124),
(104558,'enUS','','The Dreadblades have claimed entire fleets. Impenetrable fortresses have gushed rivers of blood by their will. To utter their name instills fear in sailors\' hearts.',26124),
(104559,'enUS','','They know no equal... I know no equal! Turn back now, and you may yet live to tell the tale.',26124),
(104561,'enUS','None will defy us. Unleash the fury of the tides!','',26124),
(104562,'enUS','You fool! The Dreadblades will claim you too!','',26124),
(104563,'enUS','You! You killed daddy! Now me kill you!','',26124),
(104564,'enUS','','My village of Jandvik is being assailed by naga. I have come to seek your aid.',26124),
(104565,'enUS','Toryl, why do you require my help? Can your clan not battle these naga on its own?','Toryl, why do you require my help? Can your clan not battle these naga on its own?',26124),
(104566,'enUS','','There are two obstacles that impede us, $n.$B$BWe are proud warriors and can easily defend our village, but our clan has forsaken the sea. We cannot defeat an enemy that dwells in a place that we cannot enter.$B$BTo make matters worse, our jarl is missing. Members of our clan struggle for power in his absence.',26124),
(104567,'enUS','','The shielding weakens!',26124),
(104568,'enUS','','Lady Hatecoil is vulnerable! She must not fall!',26124),
(104569,'enUS','','Kinsmen of Jandvik! Calder and Eynar have fallen in combat. They were not worthy to lead Jandvik.',26124),
(104570,'enUS','','As the last remaining successor, it falls on me to lead our people against the invading Sashj\'tar naga!',26124),
(104571,'enUS','','This outsider is under my aegis. Those that show aggression against $ghim:her; will answer to me.',26124),
(104572,'enUS','','No longer used.',26124),
(104573,'enUS','','No longer used.',26124),
(104574,'enUS','Destroy them. Your blades thirst.','',26124),
(104575,'enUS','You think to stop me? With this weapon I can do anything! ANYTHING!','',26124),
(104576,'enUS','','It will be my pleasure.',26124),
(104577,'enUS','','I have already seen my destiny. You are not a part of it!',26124),
(104578,'enUS','','I am the scourge of the seas, the fear in sailors\' hearts! You are NOTHING!',26124),
(104579,'enUS','','ENOUGH! I\'ll run you through!',26124),
(104580,'enUS','','It seems we have pests...',26124),
(104581,'enUS','Long have I awaited noble champions to enter my realm. Behold! The Halls of Valor!','',26124),
(104582,'enUS','This place will test your mettle and, if you are found worthy, the Aegis of Aggramar will be yours!','',26124),
(104583,'enUS','How DARE you enter this place! I\'ll rip the flesh from your bones!','',26124),
(104584,'enUS','','Impossible...',26124),
(104585,'enUS','This... changes... nothing...','',26124),
(104586,'enUS','Rip them apart!','',26124),
(104587,'enUS','Will it be Kayn or Altruis?','Will it be Kayn or Altruis?',26124),
(104588,'enUS','Guards! Hold them off! We must prepare!','',26124),
(104589,'enUS','|TInterface\\Icons\\spell_mage_frostbomb:20|tShivermaw begins to cast |cFFF00000|Hspell:201960|h[Ice Bomb]|h|r!','|TInterface\\Icons\\spell_mage_frostbomb:20|tShivermaw begins to cast |cFFF00000|Hspell:201960|h[Ice Bomb]|h|r!',26124),
(104590,'enUS','Eliza\'s fleet is bombardin\' the temple. If yer gonna match muskets with her, ye\'d better make it quick!','',26124),
(104591,'enUS','Why don\'t you get along with Altruis?','Why don\'t you get along with Altruis?',26124),
(104592,'enUS','Many years ago, during Lord Illidan\'s time at the Black Temple, Altruis the Sufferer split from our leader and the demon hunters.$B$BBelieving that Illidan had become the very thing he hated, Altruis then began a sinister campaign to orchestrate our master\'s downfall.$B$BHe was instrumental in the deaths of four of our comrades - Alandien, Theras, Netharel, and Varedis.$B$BThese were our teachers, our brothers and sisters.$B$BFor that, I cannot forgive him.','',26124),
(104593,'enUS','Why don\'t you like Kayn?','Why don\'t you like Kayn?',26124),
(104594,'enUS','Your plan is solid, $n. Of course, our success depends on your ability to keep us all alive.$b$bFor my part, I will try to hold the creature\'s attention and absorb the brunt of its fury.$b$bLet me know when you are ready, and I will give the order to begin the assault.','',26124),
(104595,'enUS','Let us begin!','Let us begin!',26124),
(104596,'enUS','Kayn has always been a loyal soldier, a fearless leader, and a master strategist.$B$BHowever, I believe his loyalty to Illidan blinded him.$B$BAs Illidan\'s power grew, he started losing control to the demonic energy that he had absorbed.$B$BI knew my actions could be construed as betrayal, but I was only doing what I thought was right.$B$BNow, Kayn is starting down the same path. Such a man should not lead the Illidari.','',26124),
(104597,'enUS','','Hello there! You were not followed, were you?',26124),
(104598,'enUS','Ye made it out in one piece! Ah, and you have \'em! I\'ve seen no finer swords in all me days.','',26124),
(104599,'enUS','Are you the one I\'m supposed to meet? Why all the way out here?','Are you the one I\'m supposed to meet? Why all the way out here?',26124),
(104600,'enUS','Ahahaha... so the desperate Warden has turned to her enemies? Give up, demon hunter! If you hope to escape the Vault, you will have to face ME.','',26124),
(104601,'enUS','You see, demon hunters, your attempts are futile. Even your master, the great Illidan Stormrage, is now a prisoner of the Legion.','',26124),
(104602,'enUS','Your persistence is admirable, but my demons have infiltrated every floor of the Vault. Only death awaits you.','',26124),
(104603,'enUS','Your allies have fallen. My army will crush you before you can see the light of day!','',26124),
(104604,'enUS','Dreadhound stares in your direction.','',26124),
(104605,'enUS','Dreadhound growls.','',26124),
(104606,'enUS','Greetings brul.$b$bWant to look like a drogbar? Want to enter Bitestone Enclave unfindable by its people? Want to mess with the drogbar who stole Barbrul\'s personal recipes? Want to get Barbrul\'s recipes back?$b$bThen drink this special drog and become all that is brul!$b$bReturn to me if you need more. Oh, and watch out for basilisks.','',26124),
(104607,'enUS','You hear something?','',26124),
(104608,'enUS','Who goes there?','',26124),
(104609,'enUS','Keep your eyes peeled. They\'re close.','',26124),
(104610,'enUS','Drog me, brul.','Drog me, brul.',26124),
(104611,'enUS','I smell an intruder.','',26124),
(104612,'enUS','Curses! Her crew is bigger than I thought. Ye may wanna slip past \'em.','',26124),
(104613,'enUS','The Horizon\'s Edge is ours, lads... ain\'t she a beauty?','',26124),
(104614,'enUS','Could be I neglected ta mention that the beach is crawlin\' with land mines. Keep yer eyes peeled!','',26124),
(104615,'enUS','You are victorious... But that was only the first of many trials to come.','',26124),
(104616,'enUS','Before you lies your next trial. Defeat both Hyrja and Fenryr and you will have proven your worth to me!','',26124),
(104617,'enUS','How did you get past me crew?! Useless, the lot of ya!','',26124),
(104618,'enUS','The rest of the Dread Fleet is on its way. What\'s yer plan, then?','',26124),
(104619,'enUS','Is that the best you can do? Me deck swabbers fight better!','',26124),
(104620,'enUS','The mighty Fenryr stalks these grounds. It will take cunning and guile to slay this beast - a perfect test of your worthiness.','',26124),
(104621,'enUS','It will take cunning and guile to slay this beast - a perfect test of your worthiness','',26124),
(104622,'enUS','Swab the decks till they shine, ya dirty bags of bones. The Dread Admiral demands perfection!','',26124),
(104623,'enUS','Contaminating','Contaminating',26124),
(104624,'enUS','You have earned my blessing, champions! I look forward to meeting you within the Hall of Glory!','',26124),
(104626,'enUS','I suppose I owe you one, $n. I almost had my final death there.','',26124),
(104627,'enUS','Foolish mortal! You walked right into my trap!','',26124),
(104628,'enUS','Foolish mortal! You walked right into my trap!','',26124),
(104629,'enUS','An eternity of torment awaits you!','',26124),
(104630,'enUS','Throndyr!!! No!!!','',26124),
(104631,'enUS','I died a true warrior, $n.','',26124),
(104632,'enUS','I will stand by Throndyr once more.','',26124),
(104633,'enUS','','You have been both a willing pawn and a thorn in my side, $n',26124),
(104634,'enUS','','I should thank you for dispatching Calder and Eynar for me. I needed all of Janvik\'s potential leaders dead, but I could not let the village suspect that I was the cause of their demise.',26124),
(104635,'enUS','','Without a leader to unite them, Jandvik would fall to the combined might of the sea giants and my naga in a tidal wave of death and destruction. My queen would have a prime foothold in Suramar.',26124),
(104636,'enUS','','My plan was working, you irritating slime. My naga should have killed you and Brandolf\'s band of whelps. But no! You had the gall to survive!',26124),
(104637,'enUS','We\'ll sail to Dalaran, it\'s a short voyage from here. I\'ll meet ya in the Hall of Shadows!','',26124),
(104638,'enUS','','I am so glad that you followed me here, $n. I was afraid that you may have stumbled upon my plan.',26124),
(104639,'enUS','What\'s going on here, Toryl?','What\'s going on here, Toryl?',26124),
(104640,'enUS','Gnasher gonna turn you to rubble!','',26124),
(104641,'enUS','I wanted to get a look at you for a moment before we spoke. I apologize for the secrecy, old habits die hard. I am Alonsus Faol. At times I have been the leader of a church, a mindless minion of the Scourge, and a mastermind in a secret war. But I have always, first and foremost, been a priest.','',26124),
(104642,'enUS','Forgive the secrecy... old habits die hard. I am Alonsus Faol. At times I have been a leader of a church, a mindless minion of the Scourge, and a commander in a secret war. But I have always been a priest first.','',26124),
(104643,'enUS','The Legion poses a threat that cannot be ignored. So I have decided to step out from the shadows. I believe we must unite priesthoods of all denominations against our common enemy.','',26124),
(104644,'enUS','To lead this effort, we require a priest who is a proven champion to all people. I believe you are that hero, $n, but others must be convinced. Will you accept this challenge?','',26124),
(104645,'enUS','Look! $n has returned!','',26124),
(104646,'enUS','','This champion shows talent!',26124),
(104647,'enUS','Well done indeed!','',26124),
(104648,'enUS','We\'re offering you a seat at our table, $p. Take it, and your questions will be answered. You have but to sit.','',26124),
(104649,'enUS','With that we are in agreement. Now, speak with Velen. He has an... interesting matter to discuss with you.','',26124),
(104650,'enUS','Stay back, $c! I may be wounded, but the Light will protect me!','',26124),
(104651,'enUS','What? Have you not come to finish what the Dark Riders started?','',26124),
(104652,'enUS','Enough! Stay your weapon!','',26124),
(104653,'enUS','The Riders will be upon us soon enough, and nothing is gained if we both die here!','',26124),
(104654,'enUS','Help me hunt them down, and I will tell you what I know.','',26124),
(104655,'enUS','Who challenges my right to lead Jandvik? None can defeat me in battle!','',26124),
(104656,'enUS','By my ancestors! I will be the next jarl of Jandvik! No outsider will stand in my way!','',26124),
(104657,'enUS','Vrykul dogs, get over here and fight or I\'ll kill you myself!','',26124),
(104658,'enUS','','Silence. There is little time.',26124),
(104659,'enUS','That be a fine choice. C\'mere, I\'ll share the finer details of me plan over a mug or two!','',26124),
(104660,'enUS','','I will meet you outside Jandvik. Do not enter the village until we have spoken again.',26124),
(104661,'enUS','Let\'s head to Ariden\'s camp.','Let\'s head to Ariden\'s camp.',26124),
(104662,'enUS','Brul, do you even lift?','',26124),
(104663,'enUS','Why are you so small, brul? You look like a ronir calf. Ha!','',26124),
(104664,'enUS','What you looking at? Step off, brul.','',26124),
(104665,'enUS','The new underking will make us strong again!','',26124),
(104666,'enUS','Do not worry brul! Soon our new underking will crush the weak ronir and their allies and your small, pitiful shape will not be needed to fight after that.','',26124),
(104667,'enUS','You should visit the mushroom merchant. He has some Giantstalk for you. Ha!','',26124),
(104668,'enUS','You lost, brul? You look lost.','',26124),
(104669,'enUS','Heard some bruls say the Stonedark turned against us. Good! We are better off without those weaklings. They were small... and weak. And small.','',26124),
(104670,'enUS','Understand, I cannot be a part of what you must do. When you are finished, meet me outside Karazhan.','',26124),
(104671,'enUS','I will visit the church and pray to the Light for mercy upon both our souls.','',26124),
(104672,'enUS','','I warn you, my kin do not like outsiders. You would be wise to avoid unnecessary confrontation.',26124),
(104673,'enUS','The mages have established a portal for us to use. If you would follow me, I would speak of the naaru and the draenei.','',26124),
(104674,'enUS','Over the long years of the dranei\'s flight from the Burning Legion, the naaru helped us... sometimes at the cost of their very lives. We would have perished without their aid.','',26124),
(104675,'enUS','At last we found a way to repay their kindness. We came upon a terrible sight, a naaru that had turned to the void. There had to be a way to save it!','',26124),
(104676,'enUS','We built a prison to contain and study the fallen creature. A place to commune with the naaru and ponder the nature of the Twisting Nether. It is here that I would take you.','',26124),
(104677,'enUS','Invaders! Crush them!','',26124),
(104678,'enUS','Beaten... by a weakling... like you...','',26124),
(104679,'enUS','I will see you... in Helheim...','',26124),
(104680,'enUS','That\'s it! My fist, your face!','That\'s it! My fist, your face!',26124),
(104681,'enUS','Who threw that?','Who threw that?',26124),
(104682,'enUS','I was looking for a chance to brawl!','I was looking for a chance to brawl!',26124),
(104684,'enUS','Research recipes using Lean Shanks.','Research recipes using Lean Shanks.',26124),
(104685,'enUS','','Must we do that in here?',26124),
(104686,'enUS','','An elite Legion squad appears from the portal!',26124),
(104687,'enUS','Didi sent me to retrieve a Prismatic Felslate Diamond.','Didi sent me to retrieve a Prismatic Felslate Diamond.',26124),
(104688,'enUS','We\'ve been dealing with a great many cases where stolen goods are supposedly transported right around here.','',26124),
(104689,'enUS','I don\'t suppose you\'ve seen any suspicious activity nearby that you might want to tell me about?','',26124),
(104690,'enUS','Ah. I see. Well, I\'m certainly glad that nothing questionable is going on here.','',26124),
(104691,'enUS','Carry on.','',26124),
(104692,'enUS','','I suppose I can part with one. But tell Didi I\'m sending her a bill for it. We\'re not running a charity here.',26124),
(104693,'enUS','You have proven to be a powerful priest.','',26124),
(104694,'enUS','Where are we going?','Where are we going?',26124),
(104695,'enUS','It is good to be back among the ancient trees of the Moonglade, even if only for a brief respite.','',26124),
(104699,'enUS','Hear! Hear! I\'d like to propose a toast.','',26124),
(104703,'enUS','Today, $p secured the legendary Dreadblades, and in doing so has enabled us to strike at the Legion directly.','',26124),
(104708,'enUS','Research recipes using Wildfowl Eggs.','Research recipes using Wildfowl Eggs.',26124),
(104709,'enUS','Research recipes using Big Gamy Ribs.','Research recipes using Big Gamy Ribs.',26124),
(104710,'enUS','Research recipes using Fatty Bearsteaks.','Research recipes using Fatty Bearsteaks.',26124),
(104711,'enUS','Research recipes using Leyblood.','Research recipes using Leyblood.',26124),
(104712,'enUS','Research recipes using Cursed Queenfish.','Research recipes using Cursed Queenfish.',26124),
(104713,'enUS','Research recipes using Mossgill Perch.','Research recipes using Mossgill Perch.',26124),
(104714,'enUS','Research recipes using Highmountain Salmon.','Research recipes using Highmountain Salmon.',26124),
(104715,'enUS','Research recipes using Stormrays.','Research recipes using Stormrays.',26124),
(104716,'enUS','Research recipes using Runescale Koi.','Research recipes using Runescale Koi.',26124),
(104717,'enUS','Research recipes using Black Barracuda.','Research recipes using Black Barracuda.',26124),
(104718,'enUS','Research recipes using Slabs of Bacon.','Research recipes using Slabs of Bacon.',26124),
(104719,'enUS','The Lich King said my partner would be one of the mightiest knights ever known. I assume he was speaking of you? I\'ll rely upon your skills to get us through this in one piece.','',26124),
(104720,'enUS','Let\'s get going. Felguard roam the path ahead. I\'ve kept my distance from them, but with you leading the way, we can fight through.','',26124),
(104721,'enUS','This... you are certain this came from the Defiler himself?','',26124),
(104722,'enUS','I have encountered this power once before, within the depths of the Emerald Dream, near an abyss known as the Rift of Aln.','',26124),
(104723,'enUS','That place radiated an ancient evil with such intensity that we dared not venture closer.','',26124),
(104724,'enUS','It was all we could do to attempt to seal the taint away from the rest of the Dream. But it appears that we failed.','',26124),
(104725,'enUS','And now, to find a fragment of that power in the hands of the Legion? A terrible portent....','',26124),
(104726,'enUS','I must return to the place of my tutelage, the primal groves of Val\'sharah, to seek guidance.','',26124),
(104727,'enUS','By giving us warning of this danger, you may have saved us all. Please speak with Keeper Remulos before you depart.','',26124),
(104728,'enUS','Here\'s the diamond you requested.','Here\'s the diamond you requested.',26124),
(104729,'enUS','Here\'s the potion you requested.','Here\'s the potion you requested.',26124),
(104730,'enUS','Here\'s the core you requested.','Here\'s the core you requested.',26124),
(104731,'enUS','Didi sent me to retrieve a Volatile Leytorrent Potion.','Didi sent me to retrieve a Volatile Leytorrent Potion.',26124),
(104732,'enUS','Would you happen to have a Fel-infused Core?','Would you happen to have a Fel-infused Core?',26124),
(104733,'enUS','I am ready for my induction.','I am ready for my induction.',26124),
(104734,'enUS','Ah yes, I have one right here. Now be VERY careful with that. Spilling a drop of it can result in, well, unfortunate results.','',26124),
(104735,'enUS','','I will slay them in his honor!',26124),
(104736,'enUS','This is $n. We have fought together and discovered that Throndyr has been slain by these serpents.','',26124),
(104737,'enUS','','Smart choice.',26124),
(104738,'enUS','No! The blade must remain buried!','',26124),
(104739,'enUS','You cannot have it!','',26124),
(104740,'enUS','Ariden... no! Why did you unearth that cursed blade?','',26124),
(104741,'enUS','It must be retrieved. He cannot control the unbridled wrath within.','',26124),
(104742,'enUS','We will fight to avenge him!','',26124),
(104743,'enUS','Go to the catacombs. The curse must be lifted!','',26124),
(104744,'enUS','You will make Throndyr proud. Fight on, brother!','',26124),
(104745,'enUS','Throndyr has fallen in battle. We seek to avenge his death.','',26124),
(104746,'enUS','Throndyr is dead. I was not able to find him in time.','',26124),
(104747,'enUS','Saved at last!','',26124),
(104748,'enUS','I\'m free! I\'m free!','',26124),
(104749,'enUS','I\'m not staying here any longer!','',26124),
(104750,'enUS','I\'m getting out of here!','',26124),
(104751,'enUS','Thank you! I... I will try to escape.','',26124),
(104752,'enUS','A thousand thanks to you my friend!','',26124),
(104753,'enUS','Mana... I need mana! The Nightwell... no... no! Take me back!','',26124),
(104754,'enUS','Thirsty... I must find arcwine!','',26124),
(104755,'enUS','Settle in, then we can discuss the details.','',26124),
(104756,'enUS','','Good to have a new face at the table! I was getting tired of Tethys\'s ugly mug... No offense, Tethys.',26124),
(104757,'enUS','We are the Shadows, leaders of the Uncrowned.','',26124),
(104758,'enUS','Not the least of these methods is secrecy. As our titles suggest, we prefer to stay in the shadows.','',26124),
(104759,'enUS','The sewer entrance is this way. Follow me!','',26124),
(104760,'enUS','We invite you to this table because we are confident you have the skills it takes to face this threat directly... and to prevail.','',26124),
(104761,'enUS','$ct, Li Li should be at the Laughing Crane. That\'s the village inn just down the stairs from the temple.','',26124),
(104762,'enUS','If you want the blade, death knight, come and claim it!','',26124),
(104763,'enUS','This magic is too strong for me to resist, but you may be able to cross it with your abilities, death knight.','',26124),
(104764,'enUS','Very well! If you so thirst for the power of Apocalypse, then I will show it to you myself!','',26124),
(104765,'enUS','Feel the wrath of the world-ender!','',26124),
(104766,'enUS','No! The power... is mine!','',26124),
(104767,'enUS','The power was not yours, Ariden. You did not wield Apocalypse. Its dark energies wielded you as its weapon.','',26124),
(104768,'enUS','That voice... father?!','',26124),
(104769,'enUS','Rest now, my son. The curse is lifted.','',26124),
(104770,'enUS','You are free.','',26124),
(104771,'enUS','A large, radiant ruby set upon a pillow.','',26124),
(104772,'enUS','Try to take the jewel.','Try to take the jewel.',26124),
(104773,'enUS','It is done! You have done a great service for Pandaria this day.','',26124),
(104774,'enUS','There it is, the staff of our last emperor. You have proven yourself worthy to wield it, friend of the Shado-Pan.','',26124),
(104775,'enUS','Ten thousand years ago, Emperor Shaohao used that very staff to cloak our land in a veil of mists, hiding us from the Burning Legion.','',26124),
(104776,'enUS','But this time, the Pandaren will not hide away. We chose to FIGHT!','',26124),
(104777,'enUS','Turn the emperor\'s staff against the Legion, champion. We will be right behind you.','',26124),
(104778,'enUS','Can the Junior Seafarers have guns?','Can the Junior Seafarers have guns?',26124),
(104779,'enUS','','Excuse me, but that\'s my jewel. Could you please leave it alone?',26124),
(104780,'enUS','<Saurfang looks you up and down with narrowed eyes.>$b$bWhen Khadgar claimed we would be seeing demon hunters today, I laughed in his face. When he said I should hear you out, I laughed louder.$b$bAnd yet, here you are.$b$bI will permit you alone to enter the Hold. You will leave your weapons and companions at the door. You will not speak until spoken to.$b$BOne false move and my axe will end you.','',26124),
(104781,'enUS','','Oh, well then I\'ll be right down. Coming!',26124),
(104782,'enUS','No, the Junior Seafarers can share a gun.','No, the Junior Seafarers can share a gun.',26124),
(104783,'enUS','','Hello, was someone looking for me?',26124),
(104784,'enUS','','I wonder where they went to. Oh well, perhaps they\'ll come back.',26124),
(104785,'enUS','Thank you, my friend! May the White Tiger bless your campaign against our foes!','',26124),
(104786,'enUS','Here\'s the jewel, now give me the core.','Here\'s the jewel, now give me the core.',26124),
(104787,'enUS','Yea, I got what you\'re looking for. But I ain\'t just gonna hand it over. I need something in return.','',26124),
(104788,'enUS','There\'s this lovely, red jewel upstairs that caught my eye. Get it for me and I\'ll trade you the core for it.','',26124),
(104789,'enUS','Nice doing business with you, friend.','',26124),
(104790,'enUS','','Did you know that I was favored to become the final Shadow? Yet despite their assurances, every single one of them put their lot in with you instead!',26124),
(104791,'enUS','','Let\'s see how long you last.',26124),
(104792,'enUS','','It\'s a pity, really. Jorach did so much for me. He won\'t be happy when he comes to and finds you dead.',26124),
(104793,'enUS','Catriona, I heard someone was looking for you downstairs.','Catriona, I heard someone was looking for you downstairs.',26124),
(104794,'enUS','Excuse me! Hello?','',26124),
(104795,'enUS','','It\'s nothing personal. This is purely business.',26124),
(104796,'enUS','|TInterface\\Icons\\ability_fixated_state_red:20|tA Blitering Beetle is |cFFFF0000|Hspell:202480|h[Fixated]|h|r on you!','|TInterface\\Icons\\ability_fixated_state_red:20|tA Blitering Beetle is |cFFFF0000|Hspell:202480|h[Fixated]|h|r on you!',26124),
(104797,'enUS','','Did you really think I had died in the Deadmines? My elixir brought me just close enough to death to fool your weakened mind.',26124),
(104798,'enUS','','Stop! Stop! No more!',26124),
(104799,'enUS','','Perhaps the others were right.',26124),
(104800,'enUS','','They say I died in the Deadmines. Fools! It\'s all too simple to mimic the effects of death when your assailants\' minds are addled with neurotoxins.',26124),
(104801,'enUS','It\'s over. The deed is done.','',26124),
(104802,'enUS','Take your weapon, $c. I must return the other artifacts to their rightful owners.','',26124),
(104803,'enUS','I hope, for both our sakes, that we do not meet again.','',26124),
(104804,'enUS','','Let me just insert this into the core and we\'ll see what happens.',26124),
(104805,'enUS','','Flashy, but ineffective. We\'ll have to try something else. Maybe we need a chemical reaction.',26124),
(104806,'enUS','','Go to the alchemy shop and ask Deucus for a potion with some punch in it.',26124),
(104807,'enUS','','Alright, I\'m going to pour in the solution now. Watch yourself, not sure how this is going to react.',26124),
(104808,'enUS','','Are you alright? *Cough, cough* I\'m thinking the only thing that\'s going to work here is a fel-infused core.',26124),
(104809,'enUS','','It\'s a long shot, but there may be someone here in Dalaran who has one. Try asking Bonegrim in the Ledgerdemain Lounge if he\'s come across any.',26124),
(104810,'enUS','','You found something?! That\'s amazing! You\'re amazing, $n! Keep your fingers crossed, I\'m gonna put it in now.',26124),
(104811,'enUS','','Success!',26124),
(104812,'enUS','Then it\'s settled. Congratulations, $p. VanCleef is one of our best, as you\'ve seen firsthand.','',26124),
(104813,'enUS','I trust you will be true to your word, Vanessa. I\'d hate to imagine your father being disappointed in you.','',26124),
(104814,'enUS','','$p, Tethys told me what transpired in Azsuna. You have impressed us.',26124),
(104815,'enUS','','Vanessa\'s position in the Shadows is yours. Take a seat.',26124),
(104816,'enUS','','Archivist, post a notice in the hall. $p is now a Shadow. Fear them as you fear us all.',26124),
(104817,'enUS','','You are the demon hunters who escaped the Vault of the Wardens?$B$BYou draw your very power from those who seek to destroy our world. Tell me, why should I possibly trust you?',26124),
(104818,'enUS','We gave everything to fight the demons, to use their own powers against them. Let us serve the Horde.','We gave everything to fight the demons, to use their own powers against them. Let us serve the Horde.',26124),
(104819,'enUS','You have my thanks.','',26124),
(104820,'enUS','','Whew! That feels much better! Let me at \'em!',26124),
(104821,'enUS','Storm, earth, and fire! Heed my call!','',26124),
(104822,'enUS','VanCleef, the Uncrowned still have a use for you. You have a choice... live and serve as $p\'s agent... or die where you stand.','',26124),
(104823,'enUS','','Shockingly, I\'d prefer to live.',26124),
(104824,'enUS','','Jandvik is doomed.',26124),
(104825,'enUS','','Those two idiots cannot lead Jandvik.',26124),
(104826,'enUS','','I must be the one to lead Jandvik.',26124),
(104827,'enUS','That won\'t hold them long. We must get to the library!','',26124),
(104828,'enUS','Die outsider!','',26124),
(104829,'enUS','I will crush you!','',26124),
(104830,'enUS','$R are not welcome here!','',26124),
(104831,'enUS','Val\'kyr take me!','',26124),
(104832,'enUS','By my ancestors!','',26124),
(104833,'enUS','Glorious death!','',26124),
(104834,'enUS','','Die outsider!',26124),
(104835,'enUS','','I will cast you down!',26124),
(104836,'enUS','','You are not welcome here!',26124),
(104837,'enUS','','Val\'kyr take me!',26124),
(104838,'enUS','','By my ancestors!',26124),
(104839,'enUS','','Glorious death!',26124),
(104840,'enUS','','King Varian overcame so many trials. We should all learn from his example.',26124),
(104841,'enUS','I\'m proud to have fought beside him. Varian was a good man.','',26124),
(104842,'enUS','We have lost, and now must find balance, despite our shared grief.','',26124),
(104843,'enUS','','He led with grace and courage. We were fortunate to have an ally like King Varian.',26124),
(104844,'enUS','The Light has lost a powerful ally. I have lost a good friend. Yet we must carry on.','',26124),
(104845,'enUS','<sobbing> Varian... Old friend...','',26124),
(104846,'enUS','','I know what the lad is going through. I too have lost a father... and a king.',26124),
(104847,'enUS','Listen... can you hear it? The skies weep and thunder for King Varian.','',26124),
(104848,'enUS','What\'s this? A little $r has come to challenge me?','',26124),
(104849,'enUS','Jandvik will fall to the Sashj\'tar!','',26124),
(104850,'enUS','Come find me in Dalaran! We can share recipes.','',26124),
(104851,'enUS','No! I don\'t want to come back!','No! I don\'t want to come back!',26124),
(104852,'enUS','You will share in our curse!','You will share in our curse!',26124),
(104853,'enUS','You will pay for this desecration!','You will pay for this desecration!',26124),
(104854,'enUS','Why would you bring me back here?!','Why would you bring me back here?!',26124),
(104855,'enUS','Join me in the grave!','Join me in the grave!',26124),
(104856,'enUS','','Are you ready to EXPLODE?',26124),
(104857,'enUS','','Here comes the heat!',26124),
(104858,'enUS','Research recipes using Silver Mackerel.','Research recipes using Silver Mackerel.',26124),
(104859,'enUS','The artifact belongs to Karazhan, $c!','',26124),
(104860,'enUS','We will take what is ours!','',26124),
(104861,'enUS','The artifact calls to us!','',26124),
(104862,'enUS','None will be spared!','',26124),
(104868,'enUS','Now, let\'s try filleting them lengthwise first...','',26124),
(104870,'enUS','Interesting! If I remove the bones after drying, I lose less of the meat...','',26124),
(104871,'enUS','Perhaps this would work better if I were holding a beer...','',26124),
(104873,'enUS','Perfect! I have a new recipe for you, $p.','',26124),
(104874,'enUS','Watch out for basilisks. They can see through this.','',26124),
(104875,'enUS','You can look at my helmet, $n, but you dare not touch it.','',26124),
(104876,'enUS','','Watch out! Demons walk among us!',26124),
(104877,'enUS','Greetings, Master $n. What are we cooking today?','',26124),
(104878,'enUS','Two-way connection established. Use it freely - the distance is short, so it requires very little power.','',26124),
(104879,'enUS','Survey complete. Now place the beacon!','',26124),
(104880,'enUS','I should mention... the survey may reveal a few tele-spatial anomalies. Maybe a warptime ripple or two...','',26124),
(104881,'enUS','','$n! I\'m pleased you have returned. Finding Thas\'dorah was only the beginning!',26124),
(104882,'enUS','Bring me more ingredients, Master $n. Meat, fish, blood... whatever you can find out there in the scary outdoors. I will help you turn them into delicious dishes!','',26124),
(104883,'enUS','Pandaren write so boring! Wisdom, wisdom, wisdom - not \'nuff dookin\'.','',26124),
(104884,'enUS','Can you fly me to the Terrace of Endless Spring?','Can you fly me to the Terrace of Eternal Spring?',26124),
(104885,'enUS','Additional summoners are required to complete the ritual.','',26124),
(104886,'enUS','','Remember, you can use the new teleporter to reach the surface quickly. Anora Hollow is somewhere north of here.',26124),
(104887,'enUS','','I need a bit of time to recover and... contemplate. We will speak again soon.',26124),
(104888,'enUS','Whoa, whoa, whoa. Is that the new Shadow I see walkin\' into my vault? Un-freakin\'-believable!','',26124),
(104889,'enUS','Be careful with that thing next time, will ya? Dragon-powered magical forges ain\'t easy to come by.','',26124),
(104890,'enUS','All\'s fair in love and business.','',26124),
(104891,'enUS','Here\'s 100 gold. Fair?','Here\'s 100 gold. Fair?',26124),
(104892,'enUS','Are you sure?','Are you sure?',26124),
(104893,'enUS','<Hold a weapon to Marin\'s throat.> How\'s this for business?','<Hold a weapon to Marin\'s throat.> How\'s this for business?',26124),
(104894,'enUS','That\'ll do just fine. Thank you kindly!','',26124),
(104895,'enUS','Hey, hey, hey. I don\'t want no trouble. Go right ahead, geez!','',26124),
(104896,'enUS','Aww! Come on, you didn\'t have to take them just yet. Let\'s get outta here Shoob.','',26124),
(104897,'enUS','This is Jandvik! You are not welcome here!','',26124),
(104898,'enUS','A puny outsider challenges me?','',26124),
(104899,'enUS','Jandvik\'s jarl lies dead before me! Now you shall join him!','',26124),
(104900,'enUS','Jandvik is leaderless! It will crumble before the Sashj\'tar!','',26124),
(104901,'enUS','Right rerind roo, Racky!','',26124),
(104902,'enUS','Behold Saraka, Destroyer of Worlds! Brought to heel after millennia of wanton destruction.','',26124),
(104903,'enUS','','Hey, those are mine! You won\'t get away with this, $gmister:lady;!',26124),
(104904,'enUS','The draenei sought to devise a ritual that could turn the naaru back to the Light. To aid their quest, I called together many priesthoods to work in unison.','',26124),
(104905,'enUS','We are close to success. I believe the weapon you obtained will tip the scales in our favor. If you would step into the main circle, we can begin the ritual!','',26124),
(104906,'enUS','Yes! Use the blade to draw out the Void energy!','',26124),
(104907,'enUS','Taking a kid\'s fireworks? That\'s pretty messed up. Mark my words, you\'ll regret it!','',26124),
(104908,'enUS','Yes! Fill it with healing Light!','',26124),
(104909,'enUS','Yes! Purge it with holy fire!','',26124),
(104910,'enUS','','My beautiful fireworks! I\'m going to tell on you!',26124),
(104911,'enUS','Oh hey, while you\'re there, could you let Nikki know she has three days left to pay up? I\'m not running a charity over here!','',26124),
(104912,'enUS','The sanctum of the Dark Riders is hidden even to my sight, though many in Duskwood have given their lives to unearth it.','',26124),
(104913,'enUS','I sense one such presence in Manor Mistmantle... a man strong in the Light. If he could be bent to your will, he may prove to be the key you require.','',26124),
(104914,'enUS','I will not fall!','',26124),
(104915,'enUS','You will not best me, serpent!','',26124),
(104916,'enUS','','Take your time. Nothing wrong with mulling over a big decision.',26124),
(104917,'enUS','You cannot stop me, serpent!','',26124),
(104918,'enUS','','Watch your back out there! The world sure ain\'t getting any safer.',26124),
(104919,'enUS','For Throndyr!','',26124),
(104920,'enUS','For Jandvik!','',26124),
(104921,'enUS','I will slay you!','',26124),
(104922,'enUS','Let us slay these serpents, $n!','',26124),
(104923,'enUS','Fight for Jandvik, $n!','',26124),
(104924,'enUS','Share my strength, $n!','',26124),
(104925,'enUS','I can sense the power of the world-ender within you, $n. You are prepared for the war to come.','',26124),
(104926,'enUS','Join me at the Frozen Throne. I would meet my new champion face to face.','',26124),
(104927,'enUS','Katarine! Let us get you out of that cage!','',26124),
(104928,'enUS','Fjolrik, you old man. Get up!','',26124),
(104929,'enUS','Open you eyes, Stokalfr. We are not serpents!','',26124),
(104931,'enUS','Okie-dook. Back to Pandaria. This place smell like turtle anyways.','',26124),
(104932,'enUS','Pandaria lookin\' real bad. Ain\'t seen this much jerb-jabbin\' since dat big orc guy dooked up the Vale.','',26124),
(104933,'enUS','','You need to return to the Hall of Shadows immediately. Don\'t keep me waiting.',26124),
(104934,'enUS','','You can call for an extraction to get out of there more quickly.',26124),
(104935,'enUS','I need to fly to the Trueshot Lodge.','I need to fly to the Trueshot Lodge.',26124),
(104937,'enUS','Knights! Escape while you can! This demon is too strong to...','',26124),
(104938,'enUS','What is this? More foolish mortals infesting my realm? You\'ve come a long way just to die.','',26124),
(104939,'enUS','Silence, or I shall drain your blood next!','',26124),
(104940,'enUS','','You there - we must speak at once.',26124),
(104942,'enUS','Margrave led the previous team that tried to kill Gorelix. I\'m surprised he\'s alive! I didn\'t think the Legion kept prisoners.','',26124),
(104944,'enUS','I am ready. Take me to this fish frenzy of yours.','I am ready. Take me to this fish frenzy of yours.',26124),
(104945,'enUS','Ugh! Oh, my head...','Ugh! Oh, my head...',26124),
(104946,'enUS','What just hit me!?','What just hit me!?',26124),
(104947,'enUS','|TINTERFACE\\ICONS\\inv_misc_web_02.blp:20|t Naltira begins to cast |cFFF00000|Hspell:200227|h[Tangled Web]|h|r!','|TINTERFACE\\ICONS\\inv_misc_web_02.blp:20|t $n is being dragged into Naltira\'s |cFFF00000|Hspell:200227|h[Tangled Web]|h|r!',26124),
(104948,'enUS','What the...?! I guess that feels better.','What the...?! I guess that feels better.',26124),
(104949,'enUS','Who throws a bandage at someone? Honestly?','Who throws a bandage at someone? Honestly?',26124),
(104950,'enUS','Thanks for the heal!','Thanks for the heal!',26124),
(104951,'enUS','I don\'t know what you just did... but I LIKE  it!','I don\'t know what you just did... but I LIKE  it!',26124),
(104952,'enUS','Oh you too late! Dem wob-gobblers done derked this place.','',26124),
(104953,'enUS','I put you down here. Tak-Tak do what he do best... NOTHING!','',26124),
(104954,'enUS','I need to get back to the Wandering Isle, \"your majesty.\"','I need to get back to the Wandering Isle, \"your majesty.\"',26124),
(104955,'enUS','','I wait in the shadows.',26124),
(104956,'enUS','Mrglglglggggl!','',26124),
(104957,'enUS','Wookin\' Grook! You gots the Emperor\'s staff! Does that make you like the emperor now?$b$bThat makes me like the Monkey King.$b$b<Tak-Tak does a little dance.>','',26124),
(104958,'enUS','Back to turtle! Dis place too wet anyways.','',26124),
(104959,'enUS','That\'s the spirit. I\'ll meet ya in Booty Bay!','',26124),
(104960,'enUS','I will ssslay you.','',26124),
(104961,'enUS','Sashj\'tar do not take prisonersss.','',26124),
(104962,'enUS','Ssslaughter and ssslay.','',26124),
(104963,'enUS','Jandvik will fall to the Sashj\'tar.','',26124),
(104964,'enUS','The Sashj\'tar will stand victoriousss.','',26124),
(104965,'enUS','The Tidemistress will stain Jandvik with vrykul blood.','',26124),
(104966,'enUS','','I will ssslay you.',26124),
(104967,'enUS','','Sashj\'tar do not take prisoners.',26124),
(104968,'enUS','','Ssslaughter and ssslay.',26124),
(104969,'enUS','','Jandvik will fall to the Sashj\'tar.',26124),
(104970,'enUS','','The Sashj\'tar will stand victoriousss.',26124),
(104971,'enUS','','The Sashj\'tar will wash over Jandvik like the tide upon the ssshore.',26124),
(104972,'enUS','','You should not have slithered here.',26124),
(104973,'enUS','','In the name of the Tidemistress, I will slay you.',26124),
(104974,'enUS','','You cannot stop us, $r.',26124),
(104975,'enUS','','I have failed the Sashj\'tar.',26124),
(104976,'enUS','','This cannot be...',26124),
(104977,'enUS','','Where I fall, more will rise...',26124),
(104978,'enUS','I will skewer you like a fish!','',26124),
(104979,'enUS','Slither and slay!','',26124),
(104980,'enUS','Mal\'kess! Intruders!','',26124),
(104981,'enUS','Mal\'kess...','',26124),
(104982,'enUS','The Sashj\'tar will rise!','',26124),
(104983,'enUS','For the Sashj\'tar and our queen...','',26124),
(104984,'enUS','Squish you into slime!','',26124),
(104985,'enUS','Puny $r.','',26124),
(104986,'enUS','I honor the Tidemistress.','',26124),
(104987,'enUS','You... useless... worm food...','',26124),
(104988,'enUS','I return to the sea...','',26124),
(104989,'enUS','Forgalash... I was not... strong enough...','',26124),
(104990,'enUS','Yes! It\'s working! Can you feel it?','',26124),
(104991,'enUS','The hunger, the rage, they are gone. The Light has welcomed me home.','',26124),
(104992,'enUS','','I kept this one alive as a precautionary measure, a prize for the sea giants. Now I will slay the lot of you.',26124),
(104993,'enUS','Did you hear that? I think something\'s in that building up ahead. Let\'s investigate.','',26124),
(104995,'enUS','You wanna fight? Do it in the pit. Brick don\'t make no money up here.','',26124),
(104996,'enUS','Touch one of the glowing stones, make you feel light as a pebble. \n\nThen you just drop on in to the arena and hope no one\'s waiting for you.','',26124),
(104997,'enUS','Touch one of the glowing stones, make you feel light as a pebble. \n\nThen you just drop on in to the arena and hope no one\'s waiting for you.','',26124),
(104998,'enUS','Touch one of the glowing stones, make you feel light as a pebble. \n\nThen you just drop on in to the arena and hope no one\'s waiting for you.','',26124),
(104999,'enUS','How do I get down into the arena?','How do I get down into the arena?',26124),
(105000,'enUS','Y-yes ma\'am!','',26124),
(105001,'enUS','','Rest easy. Our new Dream will remake your world...',26124),
(105002,'enUS','','I dreamed the Dream. Now I wake...',26124),
(105003,'enUS','','You seek the Dream? It seeks you, too.',26124),
(105004,'enUS','','The Dream has changed. Yet I will protect it still.',26124),
(105005,'enUS','','The Dream has always shown me truth and it showed me your deaths.',26124),
(105007,'enUS','Well... if it isn\'t Margrave\'s protege, Dagnar.','',26124),
(105008,'enUS','Well... if it isn\'t Margrave\'s protege, Minerva.','',26124),
(105009,'enUS','Finding you strung up like this is a surprise. I would have expected a more... gory... end.','',26124),
(105010,'enUS','My head\'s itchy.','',26124),
(105011,'enUS','Shave Lowping\'s head.','Shave Lowping\'s head.',26124),
(105012,'enUS','My head\'s cold.','',26124),
(105013,'enUS','Make a copy of the schematic.','Make a copy of the schematic.',26124),
(105014,'enUS','<cough> Spare me yer gentle words, Sliver. I\'ve not had me final death yet.','',26124),
(105015,'enUS','The Beacon calls to bring forth light, we will answer in your time of need.','',26124),
(105016,'enUS','','<cough> Spare me your paltry words, Sliver. I\'ve not taken my final breath yet!',26124),
(105018,'enUS','Learned a long time ago that fighting in the pit makes me a lot more money than fighting outside the pit. \n\nYou\'re not gonna find one of my bruls getting in fights I don\'t know about.','',26124),
(105019,'enUS','Once again you have proven your worth, my friend. With the aid of Saa\'ra and the power of your weapon behind you, there is no one more capable!','',26124),
(105020,'enUS','Gilbert\'s been in that hut a while now...','Gilbert\'s been in that hut a while now...',26124),
(105021,'enUS','I\'m sure if he needed help we\'d have heard the screams.','I\'m sure if he needed help we\'d have heard the screams.',26124),
(105022,'enUS','Priesthoods from all over Azeroth have agreed to donate time and resources to this new Conclave. We have a singular purpose: the defeat of the Burning Legion!','',26124),
(105023,'enUS','I hereby bring the Conclave to order! Together we will bring hope and healing to our allies, and banish our foes into the void!','',26124),
(105024,'enUS','No fighting outside of the pit!','',26124),
(105025,'enUS','Now, champion, we shall transform this prison into a temple that will serve as the headquarters of our campaign. This shouldn\'t take long...','',26124),
(105026,'enUS','These bloody demons are gonna learn a new meaning of suffering when I get free! A beast called Zalinor carries the keystone that unlocks these bindings. Free me and I\'ll help ye slay the bastards!','',26124),
(105027,'enUS','Over here! I think you will approve of the changes we\'ve made!','',26124),
(105028,'enUS','','The Unseen Path was founded after the War of the Ancients to safeguard the people of Azeroth. From these Broken Isles, we watched for the Legion\'s return.',26124),
(105029,'enUS','','As we arrived here to build the Trueshot Lodge, the eagle spirit, Ohn\'ahra, appeared and gave her blessing. From that day forth, we called this mountain Talon Peak.',26124),
(105030,'enUS','When the elves who founded the Unseen Path left Mount Hyjal to return to the Broken Isles, the Highmountain tauren recognized the nobility of their cause and offered them friendship. It was the descendants of Huln Highmountain who led the Unseen Path to this peak.$b$bSince the Legion\'s return, the Highmountain have helped restore the lodge, such as replacing two damaged watch towers with tauren structures.','',26124),
(105031,'enUS','Mrrglrrgl! Mgrlrgrrr!','',26124),
(105032,'enUS','','Over the centuries, most of my fellow watchers have been lost. The few of us remaining sought out heroes worthy to heed the call when the Unseen Path was needed once again.',26124),
(105037,'enUS','Fight\'s down below. Touch the crystal and dive on in, if you\'re tough enough.','',26124),
(105038,'enUS','Fighting pit\'s open. Touch the crystal and dive on in, if you\'re tough enough.','',26124),
(105039,'enUS','Fighting pit\'s open. Touch the crystal and dive on in, if you\'re tough enough.','',26124),
(105041,'enUS','','Please walk with me, $n.',26124),
(105042,'enUS','','These cursed demons are going to learn a new meaning of suffering when I get free! A beast called Zalinor carries the keystone that unlocks these bindings. Set me free and I\'ll help you rip the bastards apart!',26124),
(105043,'enUS','No fighting outside of the pit!','',26124),
(105044,'enUS','No fighting outside of the pit! Derp.','',26124),
(105045,'enUS','No fighting outside of the pit! Derp. Derp.','',26124),
(105046,'enUS','Do you really think Gilbert can handle a bear all by himself?','Do you really think Gilbert can handle a bear all by himself?',26124),
(105047,'enUS','If he can\'t, more treasure for us!','If he can\'t, more treasure for us!',26124),
(105048,'enUS','So many eyes that cannot see.','',26124),
(105049,'enUS','I will smash you.','',26124),
(105050,'enUS','We will rebuild our weapons. You cannot stop us.','',26124),
(105051,'enUS','Jandvik will pay for this destruction.','',26124),
(105052,'enUS','My duty is over.','',26124),
(105053,'enUS','Overseer! Come!','',26124),
(105054,'enUS','Curse you...','',26124),
(105055,'enUS','We\'ll make a fortune from these pelts!','We\'ll make a fortune from these pelts!',26124),
(105056,'enUS','I smash you!','',26124),
(105057,'enUS','Who\'s going to buy them? They\'re about as soft as your mother\'s beard!','Who\'s going to buy them? They\'re about as soft as your mother\'s beard!',26124),
(105058,'enUS','You die now!','',26124),
(105059,'enUS','Do you ever feel bad doing what we do?','Do you ever feel bad doing what we do?',26124),
(105060,'enUS','Sashj\'tar destroy you!','',26124),
(105061,'enUS','I don\'t have time for feelings.','I don\'t have time for feelings.',26124),
(105062,'enUS','Tidemistress...','',26124),
(105063,'enUS','Maybe we should let the cubs go. I won\'t tell Brodrick if you won\'t...','Maybe we should let the cubs go. I won\'t tell Brodrick if you won\'t...',26124),
(105064,'enUS','Cold sand...','',26124),
(105065,'enUS','Keep talking like that and I\'ll put you in a cage!','Keep talking like that and I\'ll put you in a cage!',26124),
(105066,'enUS','Little weakling...','',26124),
(105067,'enUS','You know, synthetic fur would be less cruel, not to mention more comfortable.','You know, synthetic fur would be less cruel, not to mention more comfortable.',26124),
(105068,'enUS','If you can\'t use small words, then keep your mouth shut!','If you can\'t use small words, then keep your mouth shut!',26124),
(105069,'enUS','Do you ever wonder what Brodrick does with the bear cubs we catch?','Do you ever wonder what Brodrick does with the bear cubs we catch?',26124),
(105070,'enUS','Brodrick doesn\'t pay us to wonder.','Brodrick doesn\'t pay us to wonder.',26124),
(105071,'enUS','This job really zaps my energy. My legs hurt. My shoulders hurt. Even my heart aches a little...','This job really zaps my energy. My legs hurt. My shoulders hurt. Even my heart aches a little...',26124),
(105072,'enUS','Being partnered with you, my ears hurt more than anything.','Being partnered with you, my ears hurt more than anything.',26124),
(105073,'enUS','Give me the crystal.','Give me the crystal.',26124),
(105074,'enUS','I have stolen a gem of power from one of the Underking\'s lackies.$b$bUse this gem and you will have a crystal fury at your command.$b$bI ask that you use it to recover more crystals from within the Crystal Fissure. With those crystals, I and my tribe can better aid Thunder Totem in its... whatever it does.$b$bDo we have a deal?','',26124),
(105078,'enUS','I suppose you\'ll be more useful to us alive. Very well, let\'s be swift about this.','',26124),
(105079,'enUS','Finally the keystone is ours! Let\'s head back.','',26124),
(105082,'enUS','Ah! That\'s much better!','',26124),
(105083,'enUS','Listen! We don\'t have much time. They took Margrave to the citadel. We\'re gonna have to break in there to get \'im out!','',26124),
(105084,'enUS','Eliminate... all... life...','',26124),
(105085,'enUS','The ritual is interrupted and a dark energy amasses!','',26124),
(105086,'enUS','Good work! Now demonstrate your skill against two foes at the same time.','',26124),
(105087,'enUS','You learned well! Next we will see... Hold on, is that...? To arms! The Legion is attacking!','',26124),
(105088,'enUS','An infernal! Use all your training to defeat it!','',26124),
(105089,'enUS','','Ah! That\'s much better!',26124),
(105090,'enUS','','We don\'t have much time! Margrave was taken to the citadel. The only things I\'ve seen come out of that place are demons and corpses! We\'ll need to break in there to get him out.',26124),
(105110,'enUS','','Quickly, finish the summons.',26124),
(105111,'enUS','','The Legion\'s will be done.',26124),
(105112,'enUS','','Kill the Illidari.',26124),
(105113,'enUS','','For the Brood Queen.',26124),
(105114,'enUS','','Your world will be purged!',26124),
(105115,'enUS','','Our ritual is interrupted.',26124),
(105116,'enUS','','Defend the portal.',26124),
(105117,'enUS','','In Sargeras\'s name.',26124),
(105118,'enUS','','Your soul will be ours.',26124),
(105119,'enUS','','Kill them before they get up to the Fel Hammer.',26124),
(105120,'enUS','','Defend the Soul Engine.',26124),
(105121,'enUS','','How can they see us?',26124),
(105122,'enUS','','They have the spectral sight!',26124),
(105123,'enUS','','Finish them. Recast the cloaking spell.',26124),
(105124,'enUS','','Your death will be swift and unmerciful.',26124),
(105125,'enUS','','Wither before my might!',26124),
(105126,'enUS','','You dare?!',26124),
(105127,'enUS','','I am of Argus, the mightiest world in all of the Great Dark.',26124),
(105128,'enUS','','Here\'s a small taste of my fel magic.',26124),
(105129,'enUS','Begone, fiends!','',26124),
(105130,'enUS','For Suramar! For Elisande!','',26124),
(105131,'enUS','We must hold them here!','',26124),
(105132,'enUS','The defenses are breached...','',26124),
(105133,'enUS','I have failed...','',26124),
(105134,'enUS','I cannot be stopped!','',26124),
(105137,'enUS','Mrgl glrlrglgrr!','',26124),
(105138,'enUS','Mrrr grmrgl mrgl!','',26124),
(105139,'enUS','','Some of you will be food, some will be thralls, but all of you will die.',26124),
(105140,'enUS','','Submit to the thirst.',26124),
(105141,'enUS','','Now your will is mine!',26124),
(105142,'enUS','','None can resist the thirst!',26124),
(105143,'enUS','','The hunger never ends...',26124),
(105144,'enUS','The altar is complete, Betild.','',26124),
(105145,'enUS','','Yer a miracle worker, Saa\'ra. It came out better than I designed it!',26124),
(105146,'enUS','','We are the watchers in the wild.',26124),
(105147,'enUS','','We are the eagle on the wind.',26124),
(105148,'enUS','','We walk the lonely road...',26124),
(105149,'enUS','','For ours is the Unseen Path.',26124),
(105150,'enUS','Helya has different plans for you, dog.','',26124),
(105151,'enUS','Bones suit you.','',26124),
(105152,'enUS','','I thank you for my freedom, $n.$b$bUnfortunately, the soul harvester has taken much of my strength. I will regain the full extent of my powers shortly.',26124),
(105153,'enUS','I\'d like to introduce you to Calia Menethil... yes, that Menethil. She has been a great help these past few years. I\'d like her to assist you, helping the helpless, conveying your word to the world, all that.','',26124),
(105154,'enUS','','$p! You\'re alive!',26124),
(105155,'enUS','','The Twinblades are even more impressive in person.',26124),
(105156,'enUS','They tell me to clean up Underking\'s mess. But look at \'dis. It gonna take forever.','',26124),
(105157,'enUS','Headed down to the Broken Shore, eh? I know right where you need to go, Zeomus here will get ya there.','',26124),
(105158,'enUS','Beakbuck sends a placeholder event!','',26124),
(105159,'enUS','','If you wish to find me when Grimwing is slain... follow the trail of demon corpses.',26124),
(105160,'enUS','CHEAT - Make me eligible for Chapter 1.','CHEAT - Make me eligible for Chapter 1.',26124),
(105161,'enUS','CHEAT - Make me eligible for Chapter 2.','CHEAT - Make me eligible for Chapter 2.',26124),
(105162,'enUS','CHEAT - Make me eligible for Chapter 3.','CHEAT - Make me eligible for Chapter 3.',26124),
(105163,'enUS','CHEAT - Reset my eligibility to 0.','CHEAT - Reset my eligibility to 0.',26124),
(105168,'enUS','','I see that you are no ally to these naga, $r! Get me out of this cage!',26124),
(105169,'enUS','','I must find Jarl Throndyr!',26124),
(105170,'enUS','You are no naga! Where is Brandolf?','',26124),
(105171,'enUS','Brandolf\'s alive! I must go to him!','',26124),
(105172,'enUS','','Opening a gateway now, dears. Step back.',26124),
(105173,'enUS','Come $n! I will fight by your side as we cut a bloody swath into these naga!','',26124),
(105174,'enUS','Taking oath of service','Taking oath of service',26124),
(105175,'enUS','','Coming, $p?',26124),
(105176,'enUS','','Speak now, demon. Lead me to your master and I may let you live.',26124),
(105177,'enUS','','Zach, give me something to yell!',26124),
(105178,'enUS','','More crystalline beasts are coming, dig your hooves in!',26124),
(105179,'enUS','I\'m looking for information about the inventor of Blingtron.','I\'m looking for information about the inventor of Blingtron.',26124),
(105180,'enUS','','The Burning Legion has no concept of mercy or remorse. If we wish to defeat such a threat, we must abandon those ideals as well.',26124),
(105181,'enUS','I\'ll be taking this for me self!','',26124),
(105182,'enUS','','The Legion took my weapons from me, so it\'s only fitting that I take one of theirs.',26124),
(105183,'enUS','The inventor of the Blingtron unit? Well now, that\'s quite the question!$b$bAs the legend goes, he was a great, tall fella, \'bout four gnomes high, with big ol\' muscly arms to lift the pieces of his inventions around.$b$bHe had beautiful purple sideburns, and lightning in his eyes!$b$bWell... at least that\'s what my cousin Ricket told me.$b$bShe knows the rest of the story, if you really want to know more. You can find her at K3 in the Storm Peaks.','',26124),
(105184,'enUS','','Up in the sky! Behold Ohn\'ahra! The spirit of the eagle has returned!',26124),
(105188,'enUS','I pledge my axes... and my pets... to your cause, $n.','',26124),
(105190,'enUS','','Oh, that old tale? Sure, I can tell it again, if ya like.$b$b<Ricket raises her hands and begins to talk in a deep voice.>$b$bSo says the legend that he was big like a fel reaver, with a face that could spook even ol\' Deathwing. They say he lost his arm makin\' the Blingtron unit. Replaced it with a SPIDER TANK!$b$b<Ricket begins to chuckle a bit.>$b$bActually the last real bit of information I heard about him was from this sailor I met in Ratchet. Drunk as a skunk, but I believe there was a small bit of truth to what he was sayin\'.$b$bHis name is Chief-Engineer Foote. He might be able to give you a real clue as to where you can find the inventor.',26124),
(105191,'enUS','$n! Thank goodness I\'ve reached you! I need your help.','',26124),
(105192,'enUS','Good, you made it. I\'m afraid we have an escaped dreadlord on our hands.','',26124),
(105193,'enUS','We don\'t have much time. The demon will surely have found the forge by now. I will meet you in Violet Hold.','',26124),
(105194,'enUS','It looks like the dreadlord is one step ahead. Hurry, the passage is this way!','',26124),
(105195,'enUS','It\'s over, dreadlord. Your evil reign ends here!','',26124),
(105196,'enUS','Hic! You wanna ...hic! You wanna ...hic! You wanna know about Blingtron?$b$bOh sure, ya, ya, ya. Okay, sho, I wash down in, um ...hic! Oh right!$b$bI wash down in Gadaget... Gaget... Gadgistan, an\' I was talkin to thish little green fellow bout him. Come closher.$b$b<Chief Engineer Foote beckons you closer and starts whispering in your ear, loudly.>$b$bSho Nixsh Shprocketshpring ish thish guy\'sh name. Ha ha! And he told me, to tell you, to tell ...hic!$b$bOh, I forget. Jush leave me alone, would ya.','',26124),
(105197,'enUS','Pitiful wretch! You should have brought an army! What can one little mage do against the might of the nathrezim?','',26124),
(105198,'enUS','The Forge of the Guardian will be mine!','',26124),
(105199,'enUS','You are pathetic! Your feeble spells cannot stop me!','',26124),
(105200,'enUS','He\'s too strong! We need the power of the forge!','',26124),
(105201,'enUS','Find a way past his barrier! I\'ll try to keep him occupied.','',26124),
(105202,'enUS','You will not escape so easily, little mage!','',26124),
(105203,'enUS','Nice work! Now destroy the rifts siphoning power from the forge!','',26124),
(105204,'enUS','It\'s working! Activate the forge!','',26124),
(105205,'enUS','You look like a smart fellow, so I\'ll give you the biggest clue you need. Forget about it!$b$bBlingtron\'s the invention of some no-good, dirty, little gnome who don\'t know nuttin about engineering.$b$bAnd DEFINITELY don\'t go visit his granddaughter, Winkey, down on Southbreak Shore, southeast o\' here. She\'s worse than he was.','',26124),
(105206,'enUS','Actually I\'m here to ask you about your grandfather.','Actually I\'m here to ask you about your grandfather.',26124),
(105207,'enUS','Take my power, champion! Banish this demon back from whence it came!','',26124),
(105208,'enUS','I\'ve had enough of you, Felstorm. Prepare to meet your end!','',26124),
(105209,'enUS','Fool! The Legion will know your secrets...','',26124),
(105210,'enUS','Count your days, mage. I will return!','',26124),
(105211,'enUS','Alodi!','',26124),
(105212,'enUS','It is good to see you, old friend. Though I wish it were under better circumstances.','',26124),
(105213,'enUS','','My grandfather, Gnopetto Bizzfuse was a great inventor. You may have heard of his one and only invention, the Blingtron unit.$b$bEveryone wanted to learn his secrets of how he created Blingtron\'s internal circuitry but he refused to share it.$b$bHe died many years ago after the sea rose and devoured his shop. I doubt you\'d be able to find anything more, but if you\'re up to it, you can go for a swim and check it out.$b$bYou can even borrow my diving helm if you like.',26124),
(105214,'enUS','The dreadlord\'s defeat is only temporary. Once he regains his strength in the Twisting Nether, he will seek the forge again.','',26124),
(105215,'enUS','Then I know what must be done...','',26124),
(105216,'enUS','','The Silver Covenant stands with you!',26124),
(105217,'enUS','The Farstriders vow to fight at your side!','',26124),
(105218,'enUS','','It\'s been far too long, $p. Far too long!',26124),
(105219,'enUS','Do you need to unleash another wave of murlocs, $n? Just give the word.$b$bSo many eggs remain... As individuals, murlocs are easily destroyed. But as a village? They are all but indestructible.','',26124),
(105220,'enUS','Unleash the murlocs!','Unleash the murlocs!',26124),
(105221,'enUS','','The Goldenapple is setting quite nicely, Slifna.',26124),
(105222,'enUS','','Still need to get this sorry excuse for a wagon fixed. Where is Jolfang with that axle, eh Slif?',26124),
(105223,'enUS','Lothrius sent me. Will you help me close the portals?','Lothrius sent me. Will you help me close the portals?',26124),
(105225,'enUS','','The Black Brew is running low, Slifna. If Melba were still here, we would never run dry.',26124),
(105228,'enUS','','Are you looking for Melba? I\'m her apprentice, but you won\'t find my master here.',26124),
(105229,'enUS','','You\'re about two years too late, my friend. Melba is dead.',26124),
(105231,'enUS','','Come, monk. Walk with me.',26124),
(105232,'enUS','','My master\'s recipes were famous for their taste and potency. We used to ship barrels every day. Goldenapple, sweet and crisp. Black Brew, dark and bitter. Woodheart, oaken and bright.',26124),
(105233,'enUS','','Morjirn, head brewer of a nearby clan, harbored jealousy of my master\'s skill. He sent a band of raiders to kill her, and steal the recipe.',26124),
(105234,'enUS','','Morjirn has the recipe now, but he lacks skill. What you drank at the Gates of Valor was pure sludge. It holds only a fraction of Storm Brew\'s TRUE power.',26124),
(105235,'enUS','','Melba\'s Storm Brew was the rarest and most desired of her recipes. It was even said that the thunder god Odyn served this brew in his hall of champions.',26124),
(105236,'enUS','Fool! Has your mind rotted to dust? The Legion\'s magic is easily avoided.','',26124),
(105238,'enUS','What\'re ye waiting for? Get a move on!','',26124),
(105239,'enUS','Owwww!!! Owwww!!','',26124),
(105240,'enUS','We have what we came for, but I\'d be remiss if I didn\'t try to bolster Karazhan\'s defenses before I leave. I owe that much to Medivh... the good man he once was, not the pawn of Sargeras he became.','',26124),
(105241,'enUS','I must return to Jandvik.','',26124),
(105243,'enUS','Intruder!','',26124),
(105244,'enUS','I will spit on your corpse!','',26124),
(105245,'enUS','By my blade!','',26124),
(105246,'enUS','You will meet your ancestors this day!','',26124),
(105247,'enUS','I am vrykul! You will die!','',26124),
(105248,'enUS','The light fades...','',26124),
(105249,'enUS','Valhalas...','',26124),
(105250,'enUS','By your hand, I meet my end...','',26124),
(105251,'enUS','My blade broken!','',26124),
(105252,'enUS','Judgment awaits...','',26124),
(105253,'enUS','','The light fades...',26124),
(105254,'enUS','','Valhalas...',26124),
(105255,'enUS','','By your hand, I meet my end...',26124),
(105256,'enUS','','I fall, staff shattered...',26124),
(105257,'enUS','','Judgment awaits...',26124),
(105258,'enUS','','Intruder!',26124),
(105259,'enUS','','I will curse your soul!',26124),
(105260,'enUS','','By my staff!',26124),
(105261,'enUS','','You will meet your ancestors this day!',26124),
(105262,'enUS','','I am vrykul! You will die!',26124),
(105263,'enUS','','Calder is a headstrong fool...',26124),
(105264,'enUS','','Eynar has no foresight...',26124),
(105265,'enUS','','I need an outsider...',26124),
(105266,'enUS','','This is a deed I cannot do...',26124),
(105267,'enUS','','I will be jarl.',26124),
(105268,'enUS','What\'s thisss? A trespasser intrudesss on our conversation.','',26124),
(105269,'enUS','We mussst inform the Tidemistressss...','',26124),
(105270,'enUS','We have uninvited guestsss.','',26124),
(105271,'enUS','Jandvik will be oursss...','',26124),
(105272,'enUS','','What\'s thisss?',26124),
(105273,'enUS','','My death stopsss nothing...',26124),
(105274,'enUS','I will gut you like a fish.','',26124),
(105275,'enUS','Jandvik is oursss.','',26124),
(105276,'enUS','You cannot stop usss!','',26124),
(105277,'enUS','Death to our enemiesss!','',26124),
(105278,'enUS','Sashj\'tar attack!','',26124),
(105279,'enUS','For the Tidemistress...','',26124),
(105280,'enUS','The sssilence of the deep...','',26124),
(105281,'enUS','The sea callsss me home...','',26124),
(105282,'enUS','You cannot ssstop us all.','',26124),
(105283,'enUS','Black abyss...','',26124),
(105284,'enUS','','What\'s the delay? Go already!',26124),
(105285,'enUS','','Owwww!!! Owwww!!',26124),
(105286,'enUS','Another damned barrier! Watch my back... we\'ll probably get jumped again.','',26124),
(105287,'enUS','Here they come!','',26124),
(105288,'enUS','Another bunch of \'em headed our way!','',26124),
(105289,'enUS','The barrier\'s down. Move quickly!','',26124),
(105290,'enUS','Foolish mortals! Are you so eager to take the place of my next meal?','',26124),
(105291,'enUS','So be it! This prisoner is useless to me anyway. Its blood is weak and stale.','',26124),
(105292,'enUS','Are you ready?','',26124),
(105293,'enUS','','More incoming! Intercept them!',26124),
(105294,'enUS','I am ready.','I am ready.',26124),
(105299,'enUS','Switching','Switching',26124),
(105300,'enUS','We\'re here to slay a demon, not rescue every failure who couldn\'t get the job done.','',26124),
(105301,'enUS','I don\'t care! Slaying the demon is our first priority. Come, we\'ve wasted enough time with this blathering.','',26124),
(105302,'enUS','What!? Don\'t ye have any sense of duty to aid yer fellow knights?','',26124),
(105303,'enUS','','What!? Don\'t you have any sense of duty to aid your fellow knights?',26124),
(105308,'enUS','Blast ye, Sliver! Fine! I\'ll help ye, but I\'ll rescue Margrave first chance I get!','',26124),
(105309,'enUS','Thank Odyn, I thought I was fishbait.','Thank Odyn, I thought I was fishbait.',26124),
(105310,'enUS','May Valhallas shine upon you.','May Valhallas shine upon you.',26124),
(105311,'enUS','Oh my, what a situation. I\'m out of here.','Oh my, what a situation. I\'m out of here.',26124),
(105312,'enUS','','I\'ve been helping the villagers at Dai-Lo Farmstead recover from their vermin infestation.$B$BChen told me stories about Shen-zin Su, but I never expected the turtle to be so vast!',26124),
(105313,'enUS','','I know only too well the pain and suffering that comes from losing a loved one. That\'s why I joined this fight, and the brew here\'s not so bad, either.',26124),
(105314,'enUS','What can I help you with, $n?','',26124),
(105315,'enUS','Can you give me an empty barrel?','Can you give me an empty barrel?',26124),
(105316,'enUS','Do you have hops and yeast?','Do you have hops and yeast?',26124),
(105317,'enUS','Chen wanted me to ask for some honey.','Chen wanted me to ask for some honey.',26124),
(105318,'enUS','We\'re leaving soon, Yalia.','We\'re leaving soon, Yalia.',26124),
(105319,'enUS','','I will send you to the abyss.',26124),
(105320,'enUS','','Jandvik is oursss.',26124),
(105321,'enUS','','You cannot stop the Sashj\'tar!',26124),
(105322,'enUS','','Death to our enemiesss!',26124),
(105323,'enUS','','You will fall before the Sashj\'tar!',26124),
(105324,'enUS','','Here you go. Tell Chen to be careful out there. We have already lost too many to the Legion attacks.',26124),
(105325,'enUS','','You\'re a cold one, Sliver. Fine! I\'ll help, but if we have any chance of getting Margrave out alive, we should take it.',26124),
(105326,'enUS','','That poor boy. The temple puts a heavy burden on his shoulders, yet all he wants is to settle down with Yalia.',26124),
(105327,'enUS','These supplies should do. Tell Chen good luck with his journey.','',26124),
(105328,'enUS','','Chen! Are you going somewhere?',26124),
(105329,'enUS','','For the Tidemistress...',26124),
(105330,'enUS','','The sssilence of the deep...',26124),
(105331,'enUS','','The sea callsss me home...',26124),
(105332,'enUS','','You cannot ssstop us all.',26124),
(105333,'enUS','','Black Abyss...',26124),
(105335,'enUS','I\'m ready to battle, Didi!','I\'m ready to battle, Didi!',26124),
(105339,'enUS','','This barrel should do. Is Chen going off on another mission?',26124),
(105341,'enUS','This war is brutal. We need every advantage we can get.','',26124),
(105343,'enUS','','You will perish in thisss cave, $r!',26124),
(105344,'enUS','','Tidemistress... I have failed you...',26124),
(105345,'enUS','I could... use a little... help here!','',26124),
(105346,'enUS','May the eagle spirit guide your hand.','',26124),
(105347,'enUS','Now\'s our chance! Let\'s bring him down!','',26124),
(105348,'enUS','Where did this altar come from?','Where did this altar come from?',26124),
(105351,'enUS','It is said this altar was carved from a slab of stone brought back from the Field of the Eternal Hunt by Huln Highmountain himself!$b$bThe stone resonates with the life force of the creatures who dwell in that sacred hunting ground.$b$bAfter the Trueshot Lodge was founded, Huln\'s descendents had the stone carved to honor the eagle spirit Ohn\'ahra and presented it to the members of the Unseen Path.','',26124),
(105352,'enUS','What does the altar do?','What does the altar do?',26124),
(105353,'enUS','The altar acts as a focus for ancient powers... the Wild Gods, the Keepers, even elven wells of magic.$b$bCertain ancient relics can be infused by such powers to become even more potent. The weapon you carry is such a relic.$b$bThink of this altar as a conduit to those primordial forces. Make use of it whenever you are able, for you\'ll need every advantage to lead us against the Legion!','',26124),
(105355,'enUS','Reaves is ready to be piloted.','',26124),
(105356,'enUS','I\'m looking for Brewmaster Melba.','I\'m looking for Brewmaster Melba.',26124),
(105357,'enUS','Easy! Easy there! I hope that vrykul leaves soon!','Easy! Easy there! I hope that vrykul leaves soon!',26124),
(105358,'enUS','Little pest.','',26124),
(105359,'enUS','Sashj\'tar foe.','',26124),
(105360,'enUS','Bury you in sand!','',26124),
(105361,'enUS','Crush your bones!','',26124),
(105362,'enUS','Crush you like clam.','',26124),
(105363,'enUS','Die... now...','',26124),
(105364,'enUS','Sashj\'tar survive...','',26124),
(105365,'enUS','To... abyss...','',26124),
(105366,'enUS','Back to deep...','',26124),
(105367,'enUS','Too... strong...','',26124),
(105368,'enUS','Netrezaar... take... you...','',26124),
(105369,'enUS','I\'ll guzzle your blood!','',26124),
(105370,'enUS','Good, now let\'s get out of here. The Lich King will be eager to hear of our success.','',26124),
(105371,'enUS','Suffer well, old friend.','',26124),
(105372,'enUS','','Poor Margrave! The final death claimed you at last.',26124),
(105373,'enUS','','Let\'s show \'em what Reaves can do!',26124),
(105374,'enUS','Actually, Didi, I have something else I have to do right now.','Actually, Didi, I have something else I have to do right now.',26124),
(105376,'enUS','|TInterface\\Icons\\Spell_Shadow_CreepingPlague:20|t Nythendra infests you with |cFFFF0404|Hspell:203096|h[Rot]|h|r!','|TInterface\\Icons\\Spell_Shadow_CreepingPlague:20|t Nythendra infests you with |cFFFF0404|Hspell:203096|h[Rot]|h|r!',26124),
(105377,'enUS','','I told Baron Sliver that you were coming, but he ran in anyway. That fool is going to get himself killed!',26124),
(105378,'enUS','We\'ve got this side of the portal secured.','',26124),
(105379,'enUS','','This is the right place. We will find the stolen recipe here.',26124),
(105383,'enUS','','Yes, now that\'s strong! But my master\'s was still better.',26124),
(105384,'enUS','','Hmmm. Good flavor, but it\'s as weak as rainwater.',26124),
(105385,'enUS','','Ugh, mother of Odyn! That tasted worse than runehorn curd!',26124),
(105387,'enUS','','My patience has run out, wyrmtongue. Where does your master hide?',26124),
(105388,'enUS','You cannot trust your own mind!','',26124),
(105389,'enUS','','Get me out of this cage!',26124),
(105390,'enUS','See how I bend your mind to my will!','',26124),
(105391,'enUS','The darkness consumes all!','',26124),
(105392,'enUS','Tasting','Tasting',26124),
(105393,'enUS','Gah!','',26124),
(105394,'enUS','Can you hear me, my friend?','',26124),
(105395,'enUS','Over here, my friend!','',26124),
(105396,'enUS','Shrug off your wounds, warriors! Another battle awaits!','',26124),
(105397,'enUS','','Aaaahhh!',26124),
(105398,'enUS','','Havi didn\'t say they would be so short!',26124),
(105399,'enUS','Look! The Tidestone!','',26124),
(105400,'enUS','That old seer is mad, but rarely wrong. Come \"friend,\" more demons approach! Prove your valor!','',26124),
(105401,'enUS','My word...','',26124),
(105402,'enUS','Are you ready, $n?','',26124),
(105403,'enUS','New subjects! What delicious secrets will you hold?','',26124),
(105404,'enUS','','Haardgrim! Alrik! Odyn has judged you worthy for his halls. Come with me to glory!',26124),
(105405,'enUS','So many... secrets... remain...','',26124),
(105406,'enUS','','There are more here that are worthy but I cannot claim them. To the west a demon keeps their souls imprisoned. Small one, prove your strength and free them!',26124),
(105407,'enUS','This quest is yours alone, do not keep Odyn waiting!','',26124),
(105408,'enUS','','We will prepare for the next fight. It will be soon so be quick!',26124),
(105409,'enUS','','Odyn\'s will is no so easily stayed. You three are worthy of his halls and this warrior has freed you. Come with me to glory!',26124),
(105410,'enUS','A brute has joined the battle, little hero! Come and meet your fate before your place is taken!','',26124),
(105411,'enUS','','I almost broke a sweat... but not quite! What else do they have?',26124),
(105412,'enUS','Wha... what was that?','',26124),
(105413,'enUS','','Well... will you look at that...',26124),
(105414,'enUS','At last! This is the glorious death Havi promised me!','',26124),
(105415,'enUS','','I say we kill the demon instead! Little hero, you have proven yourself a worthy ally. Will you stand with us, even though it could mean our deaths?',26124),
(105416,'enUS','Hah! With all of us together, we may yet be victorious! Either way, I\'ll not go down easily. Let us be about it then!','',26124),
(105417,'enUS','','I will salute your courage in the Halls of Valor... or over this monster\'s corpse!',26124),
(105418,'enUS','','I can still... fight...',26124),
(105419,'enUS','Fight on, hero... For me... the Halls await...','',26124),
(105420,'enUS','','Ragnvald, Finna, you have been judged worthy for Odyn\'s halls. Come with me to glory!',26124),
(105421,'enUS','','You are not dead and you are not vrykul, yet Odyn summons you still. I know not what awaits you in his halls, but I believe you are worthy of its glory...',26124),
(105422,'enUS','Follow me. We must address the others.','',26124),
(105423,'enUS','Behold the power of the Twinblades of the Deceiver. The Fel Hammer is ours!','',26124),
(105424,'enUS','We are the blades that will strike down the Legion. We are the chosen warriors of Lord Illidan.','',26124),
(105425,'enUS','We are ILLIDARI!','',26124),
(105426,'enUS','','Right this way.',26124),
(105427,'enUS','','I\'ve enabled Reaves\' piloted combat mode. Just activate it when you\'re ready, $n.',26124),
(105431,'enUS','Belay these bilge rats!','',26124),
(105432,'enUS','All hands on deck!','',26124),
(105433,'enUS','Destroy these landlubbers!','',26124),
(105434,'enUS','No prey, no pay. Now secure the Naglfar!','',26124),
(105435,'enUS','Pillage! Plunder! Leave none standing!','',26124),
(105437,'enUS','The Hall of the Guardian! It pains me to see it in such disrepair.','',26124),
(105438,'enUS','The hall hasn\'t seen any use since the disbanding of the Council of Tirisfal.','',26124),
(105439,'enUS','The wards protecting this place are still strong. I think it will serve our needs.','',26124),
(105440,'enUS','And what is your plan?','',26124),
(105441,'enUS','I shall reform the Tirisgarde. And this mage will be its first champion.','',26124),
(105442,'enUS','What say you, $n?','',26124),
(105446,'enUS','Welcome to the Fel Hammer, $n.','',26124),
(105447,'enUS','Prepare to face your doom!','',26124),
(105448,'enUS','Return here once you have retrieved the artifact, $n. In the meantime, I\'ll see about tidying up a bit.','',26124),
(105449,'enUS','','If I may interject, I would like to speak with you, $p.',26124),
(105450,'enUS','','Across the way lies the Arena of Glory, where warriors vie for supremacy in epic combat. Before us lies the Great Mead Hall where drink and stories flow freely!',26124),
(105451,'enUS','','Hrydshal fortress lies to the south. I will meet you there. Slifna flies faster than the wind.',26124),
(105452,'enUS','The secrets of the Storm Brew are mine! You will not have them!','',26124),
(105453,'enUS','No... I never... solved it....','',26124),
(105454,'enUS','','Are you ready to defend me while I perform the scrying?',26124),
(105455,'enUS','I am ready.','I am ready.',26124),
(105456,'enUS','This way. Your forces await.','',26124),
(105457,'enUS','','The Nightborne deceived us. The Moon Guard will soon be lost forever.',26124),
(105458,'enUS','The Fel Hammer is ours at last. Gaze upon the might of the Twinblades of the Deceiver!','',26124),
(105459,'enUS','We will follow $p into battle, and we will strike down the Legion once and for all!','',26124),
(105460,'enUS','Glory to the Illidari!','',26124),
(105461,'enUS','','Filthy dogs... the Tideskorn were always merciless thieves and murderers.',26124),
(105462,'enUS','','My master, Melba, taught me everything she knew, including the fighting techniques of ancient vrykul brewer-kings and queens.',26124),
(105463,'enUS','','I hope Melba is looking upon me now. How long have I waited for vengeance!',26124),
(105464,'enUS','','We will wash over the Burning Legion by your will.',26124),
(105465,'enUS','Now, as I was saying...','',26124),
(105466,'enUS','Are you finished interrupting, naga?','',26124),
(105467,'enUS','Harbaron won\'t have your kind around here, mortal.','',26124),
(105468,'enUS','','Watch out! This is an imposter!',26124),
(105469,'enUS','','Jandvik will never fall to your vile naga! Never!',26124),
(105470,'enUS','Item Upgrade','Item Upgrade',26124),
(105471,'enUS','There is no such thing as \"too many dead demons\".','',26124),
(105472,'enUS','Show me what we acquired in our conquest.','Show me what we acquired in our conquest.',26124),
(105473,'enUS','','After I died, Odyn granted me passage to his fabled Halls of Valor. It is here that his warriors feast and celebrate in eternal glory. I humbly provide his champions with their favorite brews.',26124),
(105474,'enUS','Alodi, we need your help. We must take the Forge of the Guardian to a safer location.','',26124),
(105475,'enUS','We will need its might if we are to defeat the Burning Legion.','',26124),
(105476,'enUS','','You should be proud, $n. You almost saved Jandvik. Now you will die in this hole without Brandolf or Jandvik ever knowing how you failed to stop the Sashj\'tar!',26124),
(105478,'enUS','Whoa there, boyo! You\'re a bit eager with that little spear of yours!','',26124),
(105479,'enUS','Hrnnggggh...','',26124),
(105480,'enUS','Malfurion, my old friend... the perfect bait!','',26124),
(105482,'enUS','Ahh, the Mother of Dreams has arrived at last.','',26124),
(105483,'enUS','Welcome, $c! This elemental realm at the precipice of the Maelstrom is the Heart of Azeroth, a most sacred space for those with shamanistic beliefs. In this room, those who proclaim a mastery over the elements may test their strength of spirit in a series of challenges.$b$bBut you for, there is nothing.$b$bNot even snacks.','',26124),
(105484,'enUS','Ah, of course! Right this way.','',26124),
(105485,'enUS','To develop harmony with the elements, one must study and understand the interactions between them. The totemic matrix is an ancient training method, a puzzle that will challenge one\'s mind and spirit.$b$bThe object of the exercise is to transform all the totems to water totems. Simply touch a totem to invoke it. Know that all things are connected, a lesson invaluable in this puzzle... as in life!','',26124),
(105486,'enUS','You will be presented with a five-by-five matrix of elemental totems. Some are fire, some water. Your objective is to change them all to water totems.$b$bSimply touch a totem to flip its elemental alignment. Ah, but the elements are connected to one another! Flipping a totem will also change the four totems adjacent to it.$b$bThrough patience, trial, and error, you should be able to coax all of the totems into water totems. Try your best, $c!$b$bIf you find yourself completely lost, speak to me and I can reset the puzzle for you.','',26124),
(105487,'enUS','Legion reinforcements arrived soon after you left for the Black Temple, destroying the portal behind you. Oh, it was a glorious battle!','',26124),
(105488,'enUS','The totemic matrix awaits, $c! Touch a totem to reverse its nature, as well as the totems around it. Try to change all the totems into water totems.','',26124),
(105489,'enUS','I can see why you answered the call of the shaman, $n. You have a natural instinct for the interconnectedness of all things.$b$bAre you ready for a slightly more difficult challenge?','',26124),
(105490,'enUS','I am impressed. You are not just a shaman... you are an elemental craftsman. An artist! Azeroth is your canvas.$b$bSo far the challenges have all been balanced in their own right. But as you know, such order rarely appears in nature. How will you fare in an asymmetrical challenge?','',26124),
(105491,'enUS','The totemic matrix is a training method that has been in use since before the mortal races recorded the passing of the days. Long, long ago, totems were not used at all. Instead, gnomes were set on fire. That was a joke, shaman. You may laugh now, should you choose.$b$bThe next challenge may appear simple, but it will truly test your abilities.','',26124),
(105492,'enUS','In the aftermath, we uncovered an ancient Nathrezim forge used to create many of the Legion\'s most powerful weapons.','',26124),
(105493,'enUS','The final challenge is a grueling test of your mettle as a shaman. This is the puzzle that killed my father. Know that if you succeed, you will have the spirit, intelligence, and tenacity to conquer any challenge that life throws your way... in this room, at least.$b$bIt is easy to remain strong when fate is going our way. The TRUE test of character is how one fares when EVERYTHING is on fire...','',26124),
(105494,'enUS','I have no further challenges for you, shaman. Training and practice can only get one so far. From here, you must perfect your technique out in the real world.$b$b<Puzzlemaster Lo sinks back into deep meditation.>','',26124),
(105495,'enUS','Tell me the rules.','Tell me the rules.',26124),
(105496,'enUS','I am ready for the first challenge. Begin!','I am ready for the first challenge. Begin!',26124),
(105497,'enUS','I am ready for the second challenge. Begin!','I am ready for the second challenge. Begin!',26124),
(105498,'enUS','I am ready for the third challenge. Bring it on!','I am ready for the third challenge. Bring it on!',26124),
(105499,'enUS','I am ready for the fourth challenge. Let\'s do this!','I am ready for the fourth challenge. Let\'s do this!',26124),
(105500,'enUS','Begin the final challenge!','Begin the final challenge!',26124),
(105501,'enUS','I\'m stuck! Can you reset the puzzle?','I\'m stuck! Can you reset the puzzle?',26124),
(105502,'enUS','We\'ve guarded it carefully ever since. I think it will prove quite useful to you.','',26124),
(105503,'enUS','I understand. Begin the challenge!','I understand. Begin the challenge!',26124),
(105504,'enUS','Let\'s try it again... with a little less gurgling this time!','',26124),
(105505,'enUS','Mr grlrlgl... wait... is that? Well, I can\'t say I was expecting company...','',26124),
(105506,'enUS','Mrglrrlrlg! I mean, hello! Sorry, I\'ve been living among these Murlocs a bit longer than planned.','',26124),
(105507,'enUS','Why are you dressed like that?','Why are you dressed like that?',26124),
(105508,'enUS','Isn\'t it obvious? These Murlocs have been pushed from their homes! We can\'t just leave them to die!','',26124),
(105509,'enUS','Don\'t I remember you from somewhere?','Don\'t I remember you from somewhere?',26124),
(105510,'enUS','This isn\'t my first dip into the ocean... I wish D.E.H.T.A. worked more with warm-water murlocs.','',26124),
(105511,'enUS','I\'ll mount this one\'s head on my wall!','I\'ll mount this one\'s head on my wall!',26124),
(105512,'enUS','The hunt begins!','The hunt begins!',26124),
(105513,'enUS','You\'ll make a fine hunting trophy!','You\'ll make a fine hunting trophy!',26124),
(105514,'enUS','This one\'s mine!','This one\'s mine!',26124),
(105515,'enUS','You shouldn\'t be here!','You shouldn\'t be here!',26124),
(105516,'enUS','I shoot to kill!','I shoot to kill!',26124),
(105517,'enUS','You\'ll regret trespassing in these fields!','You\'ll regret trespassing in these fields!',26124),
(105518,'enUS','I\'m going to enjoy hunting you!','I\'m going to enjoy hunting you!',26124),
(105519,'enUS','You may find it comforting to know that no matter what terrible state you\'ve gotten the puzzle into, it is always solvable. This is true in totems as well as life.$b$bStill, sometimes a fresh start can be beneficial.','',26124),
(105520,'enUS','That\'s good to know. Can I try again?','That\'s good to know. Can I try again?',26124),
(105522,'enUS','','|TInterface\\Icons\\Spell_Frost_SummonWaterElemental_2.blp:20|t %s begins to cast |cFFFF0000|Hspell:202098|h[Brackwater Barrage]|h|r. Look out!',26124),
(105523,'enUS','Move, you fools! Show $p some respect!','',26124),
(105524,'enUS','$n! You are difficult to catch up with, but we finally found you.','',26124),
(105525,'enUS','We heard you were looking for ingredients to the legendary Storm Brew.','',26124),
(105526,'enUS','','I sense a conflict in Chen\'s heart. He desires family, and he desires to fight for peace. He believes he must choose one, but this is false.',26124),
(105527,'enUS','You will be pleased to know that training goes well at the order hall.','',26124),
(105528,'enUS','','He must decide if he wants to love. To love someone is to accept ALL of it. The joy AND the heartache.',26124),
(105529,'enUS','We\'re glad we could be of help to you, $n.','',26124),
(105530,'enUS','','I didn\'t give in.',26124),
(105531,'enUS','','They did... things... to me.',26124),
(105532,'enUS','','The demons promised us unimaginable power.',26124),
(105533,'enUS','','A warden tried to convince us to turn traitor. I heard screaming.',26124),
(105534,'enUS','','Cyana Nightglaive turned traitor. She joined the Legion.',26124),
(105535,'enUS','','Nightglaive went southwest with a warden named Cordana Felsong.',26124),
(105536,'enUS','I didn\'t give in.','',26124),
(105537,'enUS','They did... things... to me.','',26124),
(105538,'enUS','The demons promised us unimaginable power.','',26124),
(105539,'enUS','A warden tried to convince us to turn traitor. I heard screaming.','',26124),
(105540,'enUS','Cyana Nightglaive turned traitor. She joined the Legion.','',26124),
(105541,'enUS','Nightglaive went southwest with a warden named Cordana Felsong.','',26124),
(105542,'enUS','','I didn\'t give in.',26124),
(105543,'enUS','','They did... things... to me.',26124),
(105544,'enUS','','The demons promised us unimaginable power.',26124),
(105545,'enUS','','A warden tried to convince us to turn traitor. I heard screaming.',26124),
(105546,'enUS','','Cyana Nightglaive turned traitor. She joined the Legion.',26124),
(105547,'enUS','','Nightglaive went southwest with a warden named Cordana Felsong.',26124),
(105548,'enUS','','<Aviana scans the horizon with unnaturally sharp eyesight.>\n\nThe avian beasts you call falcosaurs must be kept in check, it is the nature of balance, this is true.\n\nBut so must my vengeance.\n\nMortals cannot think that they may simply slaughter my children without thought or repercussion. You must show them that my wings stretch across these lands, neverending.\n\nYou will be my talons.\n\nIf you accept this charge, take this shed talon, and bring vengeance in my name.',26124),
(105549,'enUS','','<Aviana\'s eyes narrow when she sees you approaching.>\n\nI know what you have done. I see a trail of broken feathers and shattered beaks trailing behind you.\n\n<Aviana\'s feathers visibly ruffle.>\n\nWhat do you have to say for yourself?',26124),
(105550,'enUS','','In my domain, fledglings are hurled from the nest as soon as they can stretch their wings. They fly. Or they die.\n\nI have created a test of dexterity for the druids I have taken under my wing. Would you like to attempt it as well?\n\nWith my blessing you will be able to float gracefully through the skies... for a time.',26124),
(105551,'enUS','','REUSE',26124),
(105552,'enUS','I will be the talons of vengeance.','I will be the talons of vengeance.',26124),
(105553,'enUS','I understand. How can I be of aid?','I understand. How can I be of aid?',26124),
(105554,'enUS','','<Aviana stretches her wings to their full, terrible length, and looks at you as if you were a mouse.>\n\nYou deign to tell me of the laws of nature? I speak for the winds and the wilds, child. Do not presume to lecture ME.\n\n<She pauses for a moment, smoothing her feathers.>\n\nAnd yet, I see the wisdom in your choices, and I see the kindness in you.\n\n<She looks from you to your falcosaur mount, then back again.>\n\nYou have done a great thing for this matriarch and her hatchling. Yet the crimes committed against their kind cannot go unpunished, do you understand?',26124),
(105555,'enUS','The falcosaurs have been breeding out of control, driving nearby predators to starvation.','The falcosaurs have been breeding out of control, driving nearby predators to starvation.',26124),
(105556,'enUS','I would like to attempt the flying challenge, please grant me your blessing.','I would like to attempt the flying challenge, please grant me your blessing.',26124),
(105557,'enUS','Who goes there?!','',26124),
(105558,'enUS','Something\'s not quite right...','',26124),
(105559,'enUS','An illusion! What are you hiding?','',26124),
(105560,'enUS','Hey $n, glad we caught up with you! We heard about your progress and decided to help out.','',26124),
(105561,'enUS','How do I complete your test?','How do I complete your test?',26124),
(105562,'enUS','','<Aviana looks at you with a predatory expression.>\n\nI want to smell their blood from here, Talon.\n\nSee the raven behind you, Trinket, should you require supplies in your hunt. He is quite good at finding useful and shiny objects.',26124),
(105563,'enUS','REUSE','REUSE',26124),
(105564,'enUS','','The rest of the Illidari won\'t disturb you here.',26124),
(105565,'enUS','Whatever you\'re hunting, I have a weapon that\'s guaranteed to take your target down.','',26124),
(105566,'enUS','','I will grant you my blessing, allowing you to float gracefully to the ground. As you fall, attempt to gather as many of the emerald globes as you can. \n\nFew hatchlings gather more than a couple on their first flight. But most survive to try again.\n\nShould you gather them all in one flight, I may have something extra for you.',26124),
(105567,'enUS','The creature begins to growl in your presence.','',26124),
(105568,'enUS','Is that enough crystals? All right, we\'ll head back to the order hall.','',26124),
(105569,'enUS','','The Legion attacks are growing more frequent. The sooner we can make this Storm Brew, the better.',26124),
(105570,'enUS','','That one never saw it coming.',26124),
(105571,'enUS','','This coil projects a high-potency current. You will find a low-potency coil at the far end of the facility.',26124),
(105572,'enUS','Flip the totems until they\'re all water totems','',26124),
(105573,'enUS','|TInterface\\Icons\\Spell_Shadow_Teleport:20|t%s |cFFFF0000|Hspell:200898|h[Teleports]|h|r to nearby cells and begins releasing prisoners!','|TInterface\\Icons\\Spell_Shadow_Teleport:20|t%s |cFFFF0000|Hspell:200898|h[Teleports]|h|r to nearby cells and begins releasing prisoners!',26124),
(105574,'enUS','','Speak to me again when you return to Dalaran. We have much to discuss.',26124),
(105575,'enUS','','Both currents feed into the central chamber. Use the coils and switches to direct the currents and power all four seals in the central chamber!',26124),
(105576,'enUS','','The currents are aligned - now engage the seal!',26124),
(105577,'enUS','I am ready for the next challenge!','I am ready for the next challenge!',26124),
(105578,'enUS','Tell me the rules again...?','Tell me the rules again...?',26124),
(105579,'enUS','|TInterface\\Icons\\ability_warlock_soulswap:20|t |cFFFF0000|Hspell:200904|h[Sapped Soul]|h|r will make the next ability you use unavailable!','|TInterface\\Icons\\ability_warlock_soulswap:20|t |cFFFF0000|Hspell:200904|h[Sapped Soul]|h|r will make the next ability you use unavailable!',26124),
(105580,'enUS','The challenge is complete! $n is a totemic master!','',26124),
(105582,'enUS','Let\'s begin brewing!','Let\'s begin brewing!',26124),
(105583,'enUS','','Throw those ingredients into the pot. Things might get a little messy!',26124),
(105584,'enUS','','Keep it up, $p. It\'s working!',26124),
(105585,'enUS','','Wait, what is that thing? $p, hold it off while I finish the brew!',26124),
(105586,'enUS','','Auughhh! It\'s too strong, $p! No... we can\'t lose now!',26124),
(105587,'enUS','','Hey!!! You look like you could use a hand!',26124),
(105588,'enUS','','Yalia! What are you doing here? It\'s too dangerous!',26124),
(105589,'enUS','','The only one I see in danger is you, Chen!',26124),
(105590,'enUS','','Well... you never cease to amaze me, Yalia. Now let\'s finish this brew!',26124),
(105591,'enUS','You begin to feel drowsy!','You begin to feel drowsy!',26124),
(105592,'enUS','We may have finally eliminated the Sashj\'tar threat.','',26124),
(105593,'enUS','','Behold the Legion\'s primary gateway into Azeroth... the Tomb of Sargeras.',26124),
(105594,'enUS','','The situation is more dire than we knew. The demons have already infested the surrounding isles.',26124),
(105595,'enUS','','We must act now, or I fear the situation will become... unsalvageable.',26124),
(105596,'enUS','','$p, thank you for helping to re-unite us. Come, let us take Yalia\'s balloon back to the turtle.',26124),
(105597,'enUS','You should return to Dalaran and secure passage to the Broken Isles immediately.','',26124),
(105598,'enUS','Thanks to your power, we can use the Fel Hammer to plan out every aspect of our assault.','',26124),
(105599,'enUS','','Champion, if you are finished honing your weapons, I have something I wish to show you.',26124),
(105601,'enUS','Engaging','Engaging',26124),
(105602,'enUS','','I\'ll get started on fixin\' it up with stuff I have around the shop.',26124),
(105603,'enUS','','If you will follow me. The Eye of Odyn is a powerful scrying and communication device. With it you will be able to see the Broken Isles, send orders to your champions, and enact your own special operations. Skyseer Ghrent will help you manage the Eye.',26124),
(105604,'enUS','','Here is Skyseer Ghrent and the Eye of Odyn. May your orders come swift and your battles victorious, $ct!',26124),
(105605,'enUS','Howdy! What can I do fer ya?','',26124),
(105606,'enUS','','Yalia, I made a terrible mistake. All of this - fighting the war, risking my life, enjoying the sunrise - is MEANINGLESS without you.',26124),
(105607,'enUS','','Chen, I wondered how long it would take for you to come to your senses.',26124),
(105610,'enUS','Greetings. I am here to test your strength.','',26124),
(105611,'enUS','I am ready.','I am ready.',26124),
(105612,'enUS','Are you prepared to begin the trial?','',26124),
(105613,'enUS','Quickly now, $n! Jandvik must know of our triumph!','',26124),
(105614,'enUS','','Citizens of Jandvik! Gather round the fire and hear the glorious news!',26124),
(105615,'enUS','I want to hire a personal bodyguard.','I want to hire a personal bodyguard.',26124),
(105616,'enUS','You know... I hear if you drop these on someone from high enough up it will kill them.','',26124),
(105617,'enUS','An Underbelly Guard will protect you from other players\' attacks for 5 minutes.\n\nDo you want to hire a bodyguard?','An Underbelly Guard will protect you from other players\' attacks for 5 minutes.\n\nDo you want to hire a bodyguard?',26124),
(105618,'enUS','','We have lost much at the hands of the Sashj\'tar. Calder, Eynar, and Jarl Throndyr have all fallen to their treachery.',26124),
(105619,'enUS','','Hail the glorious dead!',26124),
(105620,'enUS','','We all owe Jandvik\'s salvation to one brave $c. Glory to $n! Slayer of Tidemistress Sashj\'tar!',26124),
(105621,'enUS','','As sole remaining elder of Jandvik, it is my duty to lead Jandvik into prosperity.',26124),
(105622,'enUS','','For this, I proclaim that $n is the new Jarl of Jandvik. All hail $n!',26124),
(105623,'enUS','You are not ready to begin your trial.','',26124),
(105624,'enUS','What else could we throw?','',26124),
(105625,'enUS','I think I hit something...','',26124),
(105626,'enUS','Hail the glorious dead!','',26124),
(105627,'enUS','Hail Jarl $n! Hail!','',26124),
(105628,'enUS','I must retrieve an artifact from Tirisfal Glades.','I must retrieve an artifact from Tirisfal Glades.',26124),
(105629,'enUS','','Hail the fallen!',26124),
(105630,'enUS','','Hail $n! Savior of Jandvik!',26124),
(105631,'enUS','Lord Illidan would be pleased.','',26124),
(105632,'enUS','The Legion will fall by our hands!','',26124),
(105633,'enUS','Now we can use the Fel Hammer to plan our assault on the Legion... all thanks to you!','',26124),
(105634,'enUS','Every moment counts! You should return to Dalaran and secure passage to the Broken Isles at once.','',26124),
(105635,'enUS','Step right up! Behold the amazing magical talents of the Great Akazamzarak!','',26124),
(105636,'enUS','Gather \'round and witness mystical wonders like you\'ve never seen before!','',26124),
(105637,'enUS','Let\'s keep the show moving! The Great Akazamzarak appreciates your coin!','',26124),
(105638,'enUS','Ladies and gentlemen, feast your eyes on these feats of prestidigitation!','',26124),
(105639,'enUS','Gaze in astonishment as I produce a rabbit from this ordinary hat!','',26124),
(105640,'enUS','Thank you, thank you. Your tips are appreciated.','',26124),
(105641,'enUS','And now for my next trick! As you can see, there\'s nothing up my sleeve...','',26124),
(105642,'enUS','And... bam!','',26124),
(105643,'enUS','','Gaze into the nether crucible. It will show you what we have seen.',26124),
(105644,'enUS','Okay, for this trick I\'ll need a volunteer.','',26124),
(105645,'enUS','Pick a card, any card...','',26124),
(105646,'enUS','Wow! A golden Dr. Boom!','',26124),
(105647,'enUS','Hey! Not that card! Give it back!','',26124),
(105648,'enUS','Kill the intruder!','',26124),
(105649,'enUS','You have come to die!','',26124),
(105650,'enUS','A $r!','',26124),
(105651,'enUS','Destroy the $c!','',26124),
(105652,'enUS','','Destroy the $c!',26124),
(105653,'enUS','','A $r!',26124),
(105654,'enUS','','You have come to die!',26124),
(105655,'enUS','','Kill the intruder!',26124),
(105657,'enUS','I will flay you!','',26124),
(105658,'enUS','I will sharpen my blade with your bones!','',26124),
(105659,'enUS','Heave!','',26124),
(105660,'enUS','','Fine work. Three more to go.',26124),
(105661,'enUS','I don\'t trust her.','',26124),
(105662,'enUS','Who does she think she is?','',26124),
(105663,'enUS','Something foul is afoot.','',26124),
(105664,'enUS','','I don\'t trust her.',26124),
(105665,'enUS','','Who does she think she is?',26124),
(105666,'enUS','','Something foul is afoot.',26124),
(105667,'enUS','Now that\'s what I call a tip!','',26124),
(105668,'enUS','Show\'s over, folks! Go on, scram!','',26124),
(105669,'enUS','|TInterface\\Icons\\Ability_Warlock_ImprovedSoulLeech:20|t %s begins to |cFFFF0000|Hspell:194325|h[Fragment]|h|r $n.','',26124),
(105670,'enUS','','The Dark Lady has lent her rangers to your cause, $ct.',26124),
(105671,'enUS','','The Sentinels stand ready to assist you.',26124),
(105672,'enUS','','It is done! The station is back online.',26124),
(105673,'enUS','','Refined leyline energy will flow from here to Shal\'Aran.',26124),
(105674,'enUS','A fine hall ya have here!','',26124),
(105675,'enUS','I\'ve got you!','',26124),
(105676,'enUS','','I walk in shadow.',26124),
(105677,'enUS','','Hey mon, you not be comin\' ta Zen\'tabra for some fish. What ya be wantin\'?',26124),
(105678,'enUS','','I\'m gonna light you up!',26124),
(105679,'enUS','Frost mage intro + Frostbolt A','',26124),
(105680,'enUS','Frostbolt explanation','',26124),
(105681,'enUS','May your soul find its way to Valhalas.','',26124),
(105682,'enUS','Hail Jarl Throndyr!','',26124),
(105683,'enUS','','Hail Jarl Throndyr!',26124),
(105684,'enUS','Hail Jarl Throndyr!','',26124),
(105685,'enUS','Hail Jarl Throndyr!','',26124),
(105686,'enUS','','Now that the portal has been opened, the path to Azoran is clear.',26124),
(105687,'enUS','','Monks of the Broken Temple!',26124),
(105688,'enUS','','Today, we have gained new strength thanks to our leader, $n.',26124),
(105689,'enUS','','With the legendary Storm Brew, our efforts in the war against the Legion will redouble!',26124),
(105690,'enUS','','Let us fight for the fallen, and bring peace to this world once again!',26124),
(105691,'enUS','','Thank you again, Master $n.',26124),
(105697,'enUS','|TInterface\\Icons\\Spell_Holy_BorrowedTime:20|tRe-engage Advisor Vandros before you are |cFFF00000|Hspell:203935|h[Lost In Time]|h|r!','|TInterface\\Icons\\Spell_Holy_BorrowedTime:20|tRe-engage Advisor Vandros before you are |cFFF00000|Hspell:203935|h[Lost In Time]|h|r!',26124),
(105698,'enUS','My, my... Someone has made quite a mess down here. It has been too long since we purged these catacombs of refuse. It appears we have a rat infestation.','',26124),
(105699,'enUS','Find the vermin and bring me their heads! Leave no stone unturned!','',26124),
(105700,'enUS','I have not survived for ten thousand years just to fall to a swarm of rats.','',26124),
(105701,'enUS','The Grand Magistrix... will have your heads for this...','',26124),
(105702,'enUS','Alas... blind courage only triumphs in the fairy tales.','',26124),
(105703,'enUS','For the glory of Elisande!','',26124),
(105704,'enUS','So brave, but so... shortsighted.','',26124),
(105705,'enUS','Think of this as a mercy killing.','',26124),
(105706,'enUS','Enough! You little beasts are getting out of hand!','',26124),
(105707,'enUS','Have you vermin ever witnessed such raw power? I think not.','',26124),
(105708,'enUS','I am a conduit of the Nightwell\'s glorious power! I am NIGHTBORNE!','',26124),
(105710,'enUS','Form up, maggots! Secure the breach until we receive orders from Gul\'dan!','',26124),
(105711,'enUS','Good! Some entertainment! I was getting restless!','',26124),
(105712,'enUS','Gather, minions! Feast on their corpses while the blood is still warm!','',26124),
(105713,'enUS','No... NO! None can best... the great Xakal...','',26124),
(105714,'enUS','No match for the great Xakal!','',26124),
(105715,'enUS','Another notch on my fel blade!','',26124),
(105716,'enUS','More fuel to stoke the fel fires!','',26124),
(105717,'enUS','Reinforcements to me! NOW!','',26124),
(105718,'enUS','All in my shadow will crumble and fall!','',26124),
(105719,'enUS','All who rise against the Legion are doomed!','',26124),
(105725,'enUS','','Do not worry about reinforcements. I will guard this portal with my life.',26124),
(105726,'enUS','','Time is short... Go swiftly!',26124),
(105727,'enUS','Sk\'shuul agth vorzz N\'Zoth naggwa\'fssh!','',26124),
(105728,'enUS','I will need your healing powers, champion. I cannot face this demon alone.','',26124),
(105729,'enUS','Sk\'yahf agth huqth N\'Zoth qornaus...','',26124),
(105730,'enUS','The nerve! You must stop the Blackswell from darkening the hearts of these poor Rockaway murlocs!','',26124),
(105731,'enUS','So brave! So cunning! I\'m glad an adventurer like you is willing to think of the murlocs! Thank you!','',26124),
(105732,'enUS','We will bring death to the Sashj\'tar!','',26124),
(105733,'enUS','Attack, $n! Attack!','',26124),
(105734,'enUS','A fine shot!','',26124),
(105735,'enUS','Send them back to the abyss!','',26124),
(105736,'enUS','Break their lines!','',26124),
(105737,'enUS','A spectacular hit, $n!','',26124),
(105738,'enUS','Again! Again!','',26124),
(105739,'enUS','For Throndyr!','',26124),
(105740,'enUS','They will never make it to Jandvik!','',26124),
(105741,'enUS','We will slay them all!','',26124),
(105742,'enUS','','You are dismissed. I will make my own way to Shal\'Aran.',26124),
(105743,'enUS','Damn! You\'ll need to destroy the wards sustaining that barrier before you can engage Varedis.','',26124),
(105744,'enUS','They\'ve spotted you. Hurry!','',26124),
(105745,'enUS','To hell with landing! Dive into the hold yourself. Show them your power!','',26124),
(105746,'enUS','The fools think they can stand against you. Show them the price of their arrogance!','',26124),
(105747,'enUS','The Legion won\'t soon forget this day.','',26124),
(105748,'enUS','We\'ve rid the skies of the worst of them. We should have a clear shot to Dalaran from here.','',26124),
(105749,'enUS','No, no, no... this is all out of sorts. Who would leave the library like this?!','No, no, no... this is all out of sorts. Who would leave the library like this?!',26124),
(105750,'enUS','What are you doing? Run, you fools! The demon is near!','',26124),
(105751,'enUS','This chest is.... rotted through. How strange.','This chest is.... rotted through. How strange.',26124),
(105752,'enUS','I will tell you... nothing! What lies beneath will be the end of you!','',26124),
(105753,'enUS','What transpired down below? Tell us, spirit!','What transpired down there? Tell us, spirit!',26124),
(105754,'enUS','This be... my final plunder...','',26124),
(105755,'enUS','','Come on, I\'ll keep you healed. Let\'s take this dragon down!',26124),
(105756,'enUS','','The demons are desecrating our fallen chieftains, resurrecting them as mindless pawns to their evil will. Destroy these corrupt remains so they may rest once again.',26124),
(105757,'enUS','','May the chieftains of ages past rest undisturbed in their graves.',26124),
(105758,'enUS','','You got this, Uncle Chen!',26124),
(105759,'enUS','','$GHe\'s:She\'s; a real hero!',26124),
(105760,'enUS','','The Feltotem and their demon allies are using our sacred burial grounds as a conduit to raise the dead for their own purposes. Defeat the risen dead and lay them to rest.',26124),
(105761,'enUS','','I can only hope they are unable to reanimate the dead after being destroyed by your artifact.',26124),
(105762,'enUS','Darksorrow and Ravencrest will join you on the hunt, $n. You should be able to slip into the hold undetected.','',26124),
(105763,'enUS','','<Valtrois does not respond. Her expression betrays a deep pain welling within.|cFFF92304Her hunger must be sated before all else.|r>',26124),
(105764,'enUS','','We once nursed upon the very essence of magic itself. An elixir to rival even the Well of Eternity.$B$BTo think we now resort to bottom-feeding.$B$B<Valtrois curls her lips in disgust.>',26124),
(105765,'enUS','Our forces should meet the enemy here...','Our forces should meet the enemy here...',26124),
(105766,'enUS','','Demons and feltotem occupy one of the holiest sites in Highmountain. Kill them all! Banish them from this place!',26124),
(105767,'enUS','Didn\'t we already defeat them there? I\'m confused.','Didn\'t we already defeat them there? I\'m confused.',26124),
(105768,'enUS','','Their ranks are Legion, but you have quelled their efforts here for a time.',26124),
(105769,'enUS','','At long last. Sustenance worthy of a Nightborne.$B$BI suppose I owe you my gratitude.$B$B<Valtrois spares you a curt nod.>',26124),
(105770,'enUS','','The Eredar lead the demonic forces at the burial ground, bringing back our chieftains and other fallen as cursed husks. Perhaps if we put an end to the Eredar, we can slow them down.',26124),
(105771,'enUS','','Without leadership, I can only hope that the demons lose sight of their goals and leave our dead alone.',26124),
(105772,'enUS','','<The arcanist raises an eyebrow at your greeting.>\n\nListen closely: \"val-TROIS.\"\n\nThe \"s\" is silent.',26124),
(105773,'enUS','No, I don\'t think... or, wait... I can\'t... why can\'t I remember?','No, I don\'t think... or, wait... I can\'t... why can\'t I remember?',26124),
(105774,'enUS','Keep your guard up out there. Varedis\' skills are the stuff of legend.','',26124),
(105775,'enUS','My... thanks. Though we have never met before, I sense great courage in your heart. Yes... you are the hero I need!','',26124),
(105776,'enUS','Long ago, my yearning for knowledge led me here, to a tomb that lies beneath the lake. Within its cold stone walls, I found something long buried... a terrible darkness, an ancient evil.','',26124),
(105777,'enUS','','Eugh... I will never get used to that.',26124),
(105778,'enUS','','Is there no more? Hm.. that will have to suffice.',26124),
(105779,'enUS','','Ick... bitter. We must find a better solution!',26124),
(105780,'enUS','My staff and keg are pledged to you, Grandmaster. Call upon me, and I will fight for our order!','',26124),
(105781,'enUS','My men begged me to walk away. I refused. My pride would be my downfall... and theirs. The evil stirred, unleashing death upon us. With my last breath, I drove my blade, Strom\'kar, into the beast\'s skull.','',26124),
(105782,'enUS','For many ages, the sword has kept the beast from rising again. But now it stirs once more, so I must ask you to delve into the depths of the tomb and finish what I started. I will go with you, to offer what aid I can.','',26124),
(105783,'enUS','Down there a malevolent creature is slowly coming back to life despite my sacrifice. You must brave its corrupted depths and slay it for the last time. I will share what knowledge I have with you.','',26124),
(105784,'enUS','','Hmph. I was fine. You need not concern yourself.',26124),
(105785,'enUS','','I am restored!',26124),
(105786,'enUS','','Ru shanna shal\'dorei.',26124),
(105787,'enUS','','I shall not squander this gift.',26124),
(105788,'enUS','You will not leave here alive!','',26124),
(105789,'enUS','The Sashj\'tar will triumph!','',26124),
(105790,'enUS','Ssslaughter and ssslay!','',26124),
(105791,'enUS','Trespasser!','',26124),
(105792,'enUS','These are Sashj\'tar waters!','',26124),
(105793,'enUS','Death comes to you!','',26124),
(105794,'enUS','I will ssslay you!','',26124),
(105795,'enUS','You will not interfere.','',26124),
(105796,'enUS','Curse and death!','',26124),
(105797,'enUS','We... will... ssslay... you... all...','',26124),
(105798,'enUS','Darknesss...','',26124),
(105799,'enUS','For the Tidemistress!','',26124),
(105800,'enUS','We will not be ssstoped...','',26124),
(105801,'enUS','I return to the abysss...','',26124),
(105802,'enUS','Sashj\'tar...','',26124),
(105803,'enUS','I have failed...','',26124),
(105804,'enUS','','You dare enter our domain!',26124),
(105805,'enUS','','I will ssslay you in the name of the Tidemistress!',26124),
(105806,'enUS','','You will not stop usss!',26124),
(105807,'enUS','','You will meet you end in the deep!',26124),
(105808,'enUS','','I will cut you into eel food!',26124),
(105809,'enUS','','You trespasss in Sashj\'tar waters!',26124),
(105810,'enUS','','Death comes to you!',26124),
(105811,'enUS','','Ssslay the intruder!',26124),
(105812,'enUS','','My life for the Sashj\'tar...',26124),
(105813,'enUS','','I curse you!',26124),
(105814,'enUS','','My death mattersss not...',26124),
(105815,'enUS','','You cannot stop the Tidemistresss...',26124),
(105816,'enUS','','We... cannot be... ssstopped...',26124),
(105817,'enUS','','Darkness in the deep...',26124),
(105818,'enUS','','You slime...',26124),
(105819,'enUS','','Tidemistresss...',26124),
(105820,'enUS','I\'ll meet you there.','',26124),
(105821,'enUS','Naralex is not here, but you can faintly detect his scent.','Naralex is not here, but you can faintly detect his scent.',26124),
(105822,'enUS','Alright Akazamzarak, you have the locations. Do you think you can manage the portals?','',26124),
(105823,'enUS','No sweat, chum! I\'ll get your mages here in a jiffy!','',26124),
(105824,'enUS','Mages of Azeroth! I have summoned you here because we face a threat to the future of the world itself!','',26124),
(105825,'enUS','The dreadlord Kathra\'natir has escaped into the Twisting Nether, carrying with him the secrets of the Council of Tirisfal.','',26124),
(105826,'enUS','We must hunt him down in the Twisting Nether. Only then will we know his knowledge cannot be used against us.','',26124),
(105827,'enUS','To this end, I hereby reform the Tirisgarde. Will you join us and take up arms against the Legion?','',26124),
(105828,'enUS','It is done, then.','',26124),
(105829,'enUS','Very well. Here, in presence of many of Azeroth\'s greatest mages, it is my honor to dub you $n, Conjuror of the Tirisgarde.','',26124),
(105830,'enUS','This ancient title symbolizes the awesome responsibility borne by the Tirisgarde. May you carry it with honor.','',26124),
(105831,'enUS','It is time to meet with our new goblin ally in the War Room. You can begin planning your next steps there.','',26124),
(105832,'enUS','See you there.','',26124),
(105833,'enUS','Come to me, my pets.','',26124),
(105834,'enUS','Your master needs you!','',26124),
(105835,'enUS','Feast upon their bones!','',26124),
(105836,'enUS','I want to know more about you.','I want to know more about you.',26124),
(105837,'enUS','I don\'t trust your kind, \"demon hunter\".$B$BYou and the Legion are one and the same in my book.','',26124),
(105838,'enUS','Let us inside or I\'ll show you the difference.','Let us inside or I\'ll show you the difference.',26124),
(105839,'enUS','There\'s no time to explain. Let us inside the hold, warden.','There\'s no time to explain. Let us inside the hold, warden.',26124),
(105840,'enUS','If you don\'t have time to explain, then I don\'t have time to waste on you.','',26124),
(105841,'enUS','I am Thoradin, first king of Arathor. \n\nLong ago humans were warring tribes of barbarians, slowly being exterminated by the trolls. My tribe, the Arathi, and I unifed the tribes to form the kingdom of Arathor. With my noble brothers Ignaeus and Lordain we pushed back the trolls, though I knew it was but temporary.\n\nAfter a time we allied with the elves and fought the longest and bloodiest war humanity had ever seen. If not for the arrogance of the trolls we would have perished. Instead we gained the strongest of friendships with the elves, and the teachings of their magic. The cost was countless soldiers and my great friend, Lordain.\n\nOnce the kingdom was safe and growing ever stronger I relinquished my crown and began my quest.','',26124),
(105842,'enUS','What happened here?','What happened here?',26124),
(105843,'enUS','Is that a threat?$B$BNeed I remind you that you are surrounded by my guards in my prison.','',26124),
(105844,'enUS','Do you want to find out?','Do you want to find out?',26124),
(105845,'enUS','What do you have to lose either way?','What do you have to lose either way?',26124),
(105846,'enUS','After seeing Arathor in good hands, I took my closest retainers and began my quest for the origins of our tribes. We roamed throughout these lands digging up pieces of the past until our path came here.\n\nIn my excitement and need for answers I ignored the warnings and had my mages break open the seals to something beneath this lake. It was a tomb like nothing I had ever seen before. We were so close and rushed in deeper before truly understanding what we were seeing. Lying there was the being that brought our ancestors here, bearing the symbol that had haunted and inspired people from this area forever.\n\nBut that wasn\'t all. The monster this \"Tyr\" fought also lay here, and I had broken the seals that kept it dead.','',26124),
(105847,'enUS','The eredar you\'re holding possesses critical information. We need a few minutes alone with him.','',26124),
(105848,'enUS','It was dead but awoke?','It was dead but awoke?',26124),
(105849,'enUS','All we want is a few moments with the eredar... alone. He has information we need.','',26124),
(105850,'enUS','Good ta see yeh again, $glad:lass;! These elves need all tha \'elp we can give \'em!','',26124),
(105851,'enUS','You\'re fortunate that Khadgar trusts you. But make no mistake... I do not share his sentiment.','',26124),
(105852,'enUS','Fair enough. Let\'s get this over with, then.','',26124),
(105853,'enUS','It had been laying down there for countless centuries, its master an ancient evil that Tyr fought even longer ago. With the seals down it began to heal and in its awakening it called deep below the earth for aid.\n\nHorrific creatures crawled out of the chasm inside the prison and we were attacked. I knew I had made a terrible mistake, this thing was more powerful than even the trolls. I knew it had to be stopped before fully awakening.\n\nWe made the ultimate sacrifice. Even barely conscious the monster killed the last of my comrades easily, but they gave me time. I managed to bury my sword, Strom\'kar, into its brain even as its claws crushed the life from me.\n\nIt is dead, but the seals cannot be replaced. Its death is only temporary.','',26124),
(105854,'enUS','Of course.','',26124),
(105855,'enUS','Tell me about your sword that keeps the monster dead.','Tell me about your sword that keeps the monster dead.',26124),
(105856,'enUS','Puny slime! My eels will eat you alive!','',26124),
(105857,'enUS','My... eels...','',26124),
(105858,'enUS','Who disturbs my sleep?','',26124),
(105859,'enUS','Eternal... slumber...','',26124),
(105860,'enUS','No need to be quiet, $n. The trees already whispered to me of your arrival.','',26124),
(105861,'enUS','<Naralex sits quietly with his eyes shut.>','<Naralex sits quietly with his eyes shut.>',26124),
(105862,'enUS','I call it Strom\'kar, the Warbreaker.\n\nThe Arathi held to the oldest ways of weaponsmithing, older than I can remember. I used those and special metals to craft my sword. Then I took it through the greatest battles any of us had ever seen and it never let us down. It has saved my life many times and turned many a battle in my hands to victory.\n\nAfter the Troll Wars the grateful elves gave me a personal gift. Their greatest mages and smiths took Strom\'kar and empowered it with strong elven enchantments. I think it is that magic that is keeping the creature from awakening. I fear what centuries of lying buried in that monster has done to the Warbreaker.','',26124),
(105863,'enUS','<Quietly stand nearby.>','<Quietly stand nearby.>',26124),
(105864,'enUS','<Gently tap on his shoulder.>','<Gently tap on his shoulder.>',26124),
(105865,'enUS','Is it time for the ritual to begin? Very well, I\'ll meet you there.','',26124),
(105866,'enUS','Even in death, the monster is restless. Its corruption has spread throughout the tomb. You will have to fight your way through!','',26124),
(105867,'enUS','','Ya be needin\' something?',26124),
(105868,'enUS','Your efforts mean NOTHING! Soon all of Suramar will bow to my master\'s will!','',26124),
(105869,'enUS','Malfurion is ready to begin. He asks that you head to the ritual site.','Malfurion is ready to begin. He asks that you head to the ritual site.',26124),
(105870,'enUS','Death to the Sashj\'tar!','',26124),
(105871,'enUS','','Now\'s our chance!',26124),
(105872,'enUS','Kill the naga!','',26124),
(105873,'enUS','','So, time to see if we can really be makin\' this happen. This gonna\' be needin\' everything we have ta give and more.',26124),
(105874,'enUS','','Zen\'tabra closes her eyes for a moment.',26124),
(105875,'enUS','I will ensure no one interferes. The demon is all yours.','',26124),
(105876,'enUS','Do not test our patience. Tell us where your master is... or die!','',26124),
(105877,'enUS','That\'s all we needed. Finish him off.','',26124),
(105878,'enUS','Sssssssssssssssssssssssssss...','',26124),
(105879,'enUS','Disrupting Portal','Disrupting Portal',26124),
(105880,'enUS','I will prepare a fel bat at Krasus\' Landing to take you to Suramar. Varedis\' time has come.','',26124),
(105881,'enUS','','De spirits, they be silent ta\' me on dis. That mean dey not opposed ta it either. Very well, I\'ll meet ye at da ritual.',26124),
(105882,'enUS','You can be prisoners for the Tidemistress now or I can ssslay you now!','',26124),
(105883,'enUS','Vile... ssslime...','',26124),
(105884,'enUS','No no! Lift more! Lift!','',26124),
(105885,'enUS','My shinies!','',26124),
(105886,'enUS','Hurry! Darkness come soon.','',26124),
(105887,'enUS','Too heavy. Lift more!','',26124),
(105888,'enUS','','Gratitude, stranger.',26124),
(105889,'enUS','I notice you\'re not wearing any earrings. Could I interest you in pair of bolt-action carbine hoops? They\'re not very rusty!','',26124),
(105890,'enUS','Those murlocs be up ta no good, oh aye. I know this \'cause I can smell somethin\' fishy.','',26124),
(105891,'enUS','When I saw this antechamber, I knew we had found something... momentous. Here was a door so oddly familiar, like a long-forgotten memory. We broke the first seal.','',26124),
(105892,'enUS','Portals are good to go, boss! Now if ya don\'t mind, I\'m gonna check out the digs here...','',26124),
(105893,'enUS','Couple of quick tips \'bout them booties. As soon as yeh activate them, yer gonna take off faster than a rogue in an arena match.','',26124),
(105894,'enUS','Fresh! Meat!','',26124),
(105895,'enUS','Still... hungry...','',26124),
(105896,'enUS','Tasty morsel.','',26124),
(105897,'enUS','Eat you up.','',26124),
(105898,'enUS','Crunchy bones.','',26124),
(105899,'enUS','','...and bring the outlander with you.',26124),
(105900,'enUS','','If... you insist.',26124),
(105901,'enUS','','And Valtrois?',26124),
(105902,'enUS','','You would be wise not to turn your nose up at the outsiders. None of us would be here without their help.',26124),
(105903,'enUS','','Of course, First Arcanist.',26124),
(105904,'enUS','','Come, we can examine the feed from down here.',26124),
(105905,'enUS','','Hail $c!$B$BI tracked a group of Sashj\'tar across the bay to this cave.$B$BMany fell to my blade, but a few managed to slither away. I have little doubt that they will return with greater numbers to try and slay me.$B$BIf you welcome a glorious battle, bolster yourself and ready your weapon.$B$BIf not, stay out of my way or I will kill you myself.',26124),
(105906,'enUS','','Do you have much experience with leyline energy? I should think not.',26124),
(105907,'enUS','','Allow me to educate you on the fundamentals.',26124),
(105908,'enUS','','You are a fine $c. I would gladly fight by your side again!$B$BWhen I return to Jandvik, we shall sing songs of our battle over flagons of ale!',26124),
(105909,'enUS','','Far below us, rivers of raw arcane power course throughout the land. The leylines are eternal, primal, and impossible to control.',26124),
(105910,'enUS','Let the Sashj\'tar come!','Let the Sashj\'tar come!',26124),
(105911,'enUS','','However, just as one pulls thread from cotton, so too can we draw power from the leylines.',26124),
(105912,'enUS','Ye\'ll be goin\' so fast, ye\'ll stay afloat. So mind yer ammo, cause when it runs out, yer goin\' kerplunk into tha water.','',26124),
(105913,'enUS','As soon as yeh stop, everythin\' will reset an\' yeh should be good ta go fer another try.','',26124),
(105914,'enUS','Hobart\'s not gonna be too \'appy to \'ear about \'is gunpack. How \'ave ye been, $glad:lass;?','',26124),
(105915,'enUS','','Whatever you\'re hunting, Razik has a gadget that\'s guaranteed to take your target down.\n\nHis latest prototypes are preloaded and ready to go. Just grab one from the weapon rack and start shooting.\n\nJust remember, you test at your own risk!',26124),
(105916,'enUS','We gotta get to Brambley, before it\'s too late!','',26124),
(105917,'enUS','Aye, let\'s get him the key... but be on your guard. This place is crawling with demons.','',26124),
(105918,'enUS','Brambley! No... no it canna\' be true!','',26124),
(105919,'enUS','Look! That\'s Brambley\'s helm, I\'d recognize it anywhere!','',26124),
(105920,'enUS','Those demons musta\' ate ol\' Brambley... look at him! He\'s just bones, now!','',26124),
(105921,'enUS','Ice Lance Intro','',26124),
(105922,'enUS','Ice Lance explanation\n(Icelance does double damage against frozen targets)','',26124),
(105923,'enUS','As I feared, one of the monster\'s minions has returned. Its presence is corrupting the wards of the tomb and blocking the path. You must destroy the tendrils to draw it out!','',26124),
(105924,'enUS','Curses upon ye, demons! CURSES UPON YE!','',26124),
(105925,'enUS','','Here they come!',26124),
(105926,'enUS','','We are victorious!',26124),
(105927,'enUS','There it is... atop the crypt! Prepare yourself!','',26124),
(105928,'enUS','Blizzard Intro','',26124),
(105929,'enUS','Blizzard Explanation','',26124),
(105930,'enUS','','See here. This is the feed from Anora. And there are many others still lying dormant.',26124),
(105931,'enUS','','Restore them, and help us create a new locus of power here in Shal\'Aran!',26124),
(105932,'enUS','You will answer for the Sashj\'tar you have ssslain!','',26124),
(105933,'enUS','Curse... you...','',26124),
(105934,'enUS','We lost contact with one of my pathfinder teams that was scouting the Greystone area. Please, find them.','',26124),
(105935,'enUS','Thank you, champion. I appreciate you preventing my people from being reduced to basilisk chow.','',26124),
(105936,'enUS','The Bitestone keep stealing goods from my people. Time to steal some of it back. Up for a little burgling?','',26124),
(105937,'enUS','Ha! Bitestones. All brul and no brains. Well done!','',26124),
(105938,'enUS','Ha! That should slow down their efforts to get organized.','',26124),
(105939,'enUS','My pathfinders tracked a pair of Stonebinders to Bitestone Enclave. They were disciples of Dargrul and are very dangerous. This is a meeting that must be stopped.','',26124),
(105940,'enUS','','The Basilisk Bazaar is a very dangerous event held by the drogbar where they trade, fight, and skin their lizard pets. Disrupting this will set their forces back a peg or two and keep our local farmlands safe for a time.',26124),
(105941,'enUS','','I used to applaud the drogbar\'s kinship with nature until they used it to slaughter my people and attack my lands. You have my thanks, champion.',26124),
(105942,'enUS','','Shardmasters from Greystone are performing some sort of empowering ritual within the chasm of the Crystal Fissure. This is too close to Thunder Totem for comfort. Can you stop them?',26124),
(105943,'enUS','','Thank you, champion. The Greystone drogbar are getting far too ambitious these days.',26124),
(105944,'enUS','I need crystals for my rituals and you need to have less furies amassing on the Thunder Totem border. I have a plan to get both of us what we want. How are your riding skills?','',26124),
(105945,'enUS','Ah, excellent choice in crystals. This should be enough for my rituals.','',26124),
(105946,'enUS','','I can hear the scream of the earth. The drogbar shardmasters are performing a dark ritual that drives these crystal furies into a horrendous rage. The furies must be stopped before they cause untold damage to Thunder Totem.',26124),
(105947,'enUS','','I don\'t even want to guess how much damage those enraged furies could have unleashed upon Thunder Totem if left unchecked.',26124),
(105948,'enUS','','Something dark is afoot in the Echoing Halls. We have felt a malevolent presence there perverting the waters that flow to the rest of the land. Find the source of the corruption and exterminate it.',26124),
(105949,'enUS','','Every now and then something evil lurking in the deep places of the world decides to crawl up and threaten us. I am grateful you caught it early.',26124),
(105950,'enUS','My pathfinders report a nest of kobolds is taking up residence in the Echoing Halls. Feel up for a rat chase?','',26124),
(105951,'enUS','Kobolds cause a tremendous amount of damage with their sloppy mining techniques. That high up they could bring a chunk of that mountain down on top of us in no time. Well done rooting them out.','',26124),
(105952,'enUS','','Are you in need of rest or healing today?',26124),
(105953,'enUS','%s is |cFFFF0404|Hspell:204237|h[Gravely Wounded]|h|r and cannot fight until healed!','%s is |cFFFF0404|Hspell:204237|h[Gravely Wounded]|h|r and cannot fight until healed!',26124),
(105954,'enUS','Thanks.','Thanks.',26124),
(105955,'enUS','These demons are relentless!','These demons are relentless!',26124),
(105956,'enUS','','Whatever you\'re hunting, Razik has a gadget that\'s guaranteed to take your target down.',26124),
(105957,'enUS','Thought I\'d never escape!','Thought I\'d never escape!',26124),
(105958,'enUS','Not every day you get rescued by a $c!','Not every day you get rescued by a $c!',26124),
(105959,'enUS','I\'m in your debt, $n.','I\'m in your debt, $n.',26124),
(105960,'enUS','Quickly! There may be more coming soon.','Quickly! There may be more coming soon.',26124),
(105961,'enUS','','So this is the Halls of Valor? Amazing. Wait... is that my master?',26124),
(105962,'enUS','','Over there, on the right. That must be the cauldron we are looking for.',26124),
(105963,'enUS','Alright, let\'s see if I can get a portal through those wards you\'re talkin\' about.','',26124),
(105964,'enUS','Piece o\' cake! See ya on the other side!','',26124),
(105965,'enUS','Infidels! Submit to my will, or DIE in the flames of the Legion!','',26124),
(105966,'enUS','','I ssshould thank you for doing my dirty work, $n. But now you are proving too troublesome to keep alive.',26124),
(105967,'enUS','','Without its leaders, I will easily destroy Jandvik from within!',26124),
(105968,'enUS','','My naga will wash over Jandvik in a tidal wave of destruction!',26124),
(105969,'enUS','|TInterface\\Icons\\Ability_Rogue_DeviousPoisons:20|t Nythendra infests you with |cFFFF0404|Hspell:204463|h[Volatile Rot]|h|r!','|TInterface\\Icons\\Ability_Rogue_DeviousPoisons:20|t Nythendra infests you with |cFFFF0404|Hspell:204463|h[Volatile Rot]|h|r!',26124),
(105970,'enUS','It is done. Thank you, hero.','',26124),
(105971,'enUS','Nice place ya got here!','',26124),
(105972,'enUS','','The Burning Legion has been dealt a great blow this day, but our work is far from over.',26124),
(105973,'enUS','','I will wait for you in Shal\'Aran, return there when you are ready. We have much to discuss.',26124),
(105974,'enUS','Find wood to construct a pyre. I will take care of moving his body.','',26124),
(105975,'enUS','<The vrykul barely acknowledges your presence.>','',26124),
(105976,'enUS','A legion of these naga could not overpower Jarl Throndyr. Only their venomous treachery could defeat him.','',26124),
(105977,'enUS','<Throndyr lies dead in the mud.>','',26124),
(105978,'enUS','I could not protect them all...','',26124),
(105979,'enUS','The Guard is no more.','',26124),
(105980,'enUS','','I didn\'t make it in time...',26124),
(105981,'enUS','My bark is worse than my bite.','',26124),
(105982,'enUS','I told you to leave me alone...','',26124),
(105983,'enUS','... Ugh!','... Ugh!',26124),
(105984,'enUS','What is this filth?!','What is this filth?!',26124),
(105985,'enUS','What is the meaning of this?!','What is the meaning of this?!',26124),
(105986,'enUS','It\'s... sticky!','It\'s... sticky!',26124),
(105987,'enUS','Make like a tree, and get out of here.','',26124),
(105988,'enUS','See you next fall.','',26124),
(105989,'enUS','I want to say something clever, but I am stumped.','',26124),
(105990,'enUS','To mulch!','',26124),
(105991,'enUS','My precious books...','',26124),
(105992,'enUS','I seem to have lost my Trap Rune...','I seem to have lost my Trap Rune...',26124),
(105993,'enUS','I have some personal business to attend to...','',26124),
(105994,'enUS','','Without me, Jandvik will stand no chance in this battle. Come quickly!',26124),
(105995,'enUS','Thanks for playing the Friends & Family Alpha!$B$BThis concludes the playable portion of the Demon Hunter experience.$B$BPlease try out the Level 100 character templates to access the Broken Isles.','',26124),
(105996,'enUS','Ha ha! You wish to go fist to tooth with that chomper?','',26124),
(105997,'enUS','Brul, you got some stones to mess with THAT basilisk.','',26124),
(105998,'enUS','Ha! It\'s angry. You go, brul!','',26124),
(105999,'enUS','Watch the left eye on that one. It\'s angry.','',26124),
(106000,'enUS','These monsters play tricks upon the mind. Beware their illusions!','',26124),
(106001,'enUS','Its time we get to the root of the problem.','',26124),
(106002,'enUS','You will be uprooted.','',26124),
(106003,'enUS','You have been rooting around here too long.','',26124),
(106004,'enUS','The magi of Ogri\'la stand with the Tirisgarde, Conjurer.','',26124),
(106005,'enUS','$p. Protect the Tidestone!','',26124),
(106006,'enUS','Get away from me!','',26124),
(106007,'enUS','Naga goon!','',26124),
(106008,'enUS','I will eat your cold heart if I get out of here!','',26124),
(106009,'enUS','Sea giant scum!','',26124),
(106010,'enUS','I\'m awake! Definitely NOT sleeping! I was just... just resting my eyes.','',26124),
(106011,'enUS','Zen\'tabra\'s camp is on the western shore of the lake. Naralex was camped on the eastern shore, but he\'s prone to wandering off, so keep your eyes and ears open.','',26124),
(106012,'enUS','Stop those colossal creatures, before they get any closer!','',26124),
(106013,'enUS','I did not need your help.','',26124),
(106014,'enUS','Gratitude stranger.','',26124),
(106015,'enUS','I despise the sea!','',26124),
(106016,'enUS','Cold and wet!','',26124),
(106018,'enUS','I hope you choke!','',26124),
(106019,'enUS','They were going to eat me!','',26124),
(106020,'enUS','Come closer, small ones.','',26124),
(106021,'enUS','','That looks like the end of the naga siege.',26124),
(106022,'enUS','Stay on your guard, small ones. I see Nightfallen on the horizon.','',26124),
(106023,'enUS','They\'ve breached the front lines! Stop them, before they consume the Tidestone!','',26124),
(106024,'enUS','','Look! They\'re headed for grandfather\'s pool!',26124),
(106025,'enUS','Right! I\'ll shield the Tidestone. You heroes hold off that army of elves.','',26124),
(106026,'enUS','Sorry I\'m late. Did I miss the party?','',26124),
(106027,'enUS','Quite nearly. We could use your aid, wizard.','',26124),
(106028,'enUS','I pluck you like a flower.','',26124),
(106029,'enUS','My limbs will grow back, yours will not.','',26124),
(106030,'enUS','I snap you like a twig.','',26124),
(106031,'enUS','','Good girl, Korra.',26124),
(106032,'enUS','|TInterface\\Icons\\ability_ironmaidens_bloodritual:20|tThe Scythe has overpowered Ariden! Keep him away from you to avoid |cFFFF0000|Hspell:204659|h[Bloodreap]|h|r !','The Scythe has overpowered Ariden! Keep him away from you!',26124),
(106033,'enUS','','Yes, Korra, we honor the spirits of the hunt.',26124),
(106034,'enUS','','Protect the shrine, girl.',26124),
(106035,'enUS','Wh... WHAT TRICKERY IS THIS?!','',26124),
(106036,'enUS','','Good boy, Dagri.',26124),
(106037,'enUS','','We honor the spirits of the hunt, boy. It is our duty.',26124),
(106038,'enUS','','Protect the lodge, boy. That\'s a good wolf!',26124),
(106039,'enUS','Prepare yourself. Step into the circle when you are ready.','',26124),
(106040,'enUS','Begone, filthy $c! Baelbug find the glaive and keeps it!','',26124),
(106041,'enUS','The Rockaway murlocs are in pain! Their normally pure waters are full of muck. The Murkwater naga must be driven back to the depths!','',26124),
(106042,'enUS','Can\'t you see it? The water is already clearing up. The proud Rockaways send their thanks!','',26124),
(106043,'enUS','Yesssss... killl them all.','',26124),
(106044,'enUS','Softsssskin fights well... retreat!','',26124),
(106045,'enUS','We must make haste to the Violet Hold! \n\nKathra\'nathir must not be allowed access to the Forge of the Guardian!','',26124),
(106046,'enUS','The dreadlord Kathra\'natir is defeated, but only for now. If we wish to save Azeroth from his evil, we must reform the Tirisgarde. \n\nThen we can hunt him down in the Twisting Nether before he has a chance to share his secrets with the Burning Legion.','',26124),
(106047,'enUS','Yes, $n?','',26124),
(106048,'enUS','What is the Forge of the Guardian?','What is the Forge of the Guardian?',26124),
(106049,'enUS','Wait, who are you again?','Wait, who are you again?',26124),
(106050,'enUS','Tell me more about the Tirisgarde.','Tell me more about the Tirisgarde.',26124),
(106051,'enUS','','Our crops are dying! I don\'t know what the drogbar did or how they dug up even more insects to throw at us, but we need your help!',26124),
(106052,'enUS','','Thank you for helping with the harvest, $n. Bugs make my old bones crawl...',26124),
(106053,'enUS','The Forge of the Guardian is an artifact of incredible power. \n\nIt was devised by the Archmage Alodi as a method of permanently transferring the arcane power of many mages into the body of one, thus creating a Guardian of Tirisfal. \n\nThe last time it was used was in the time of Aegwynn. Since she refused to return her powers so another Guardian could be imbued, the forge was locked away behind the arcane barriers of the Violet Hold.\n\nIts location was known only to the Council. That is, until now.','',26124),
(106054,'enUS','Pardon me, I forget that my name is not well known these days. \n\nI am Meryl Felstorm, once known as Meryl Winterstorm. I was a founding member of the Council of Tirisfal, but was required to abandon my duties when I became possessed by the dreadlord Kathra\'natir. I was able to contain him... for the most part... but the risk was too great for me to remain on the council.\n\nI have since dedicated my life to finding a way to banish the demon once and for all. It seems I have failed.','',26124),
(106055,'enUS','','Kill one drogbar, and another comes out of the darkness to crap in our river! In my day, they stayed in their caves... Mind sending them back to the shadows?',26124),
(106056,'enUS','','You\'ve got a light touch with that foot of yours. Most of those fish survived the kicking.',26124),
(106057,'enUS','','These brutes have no respect for the spirits. They\'ve infested our sacred cavern with their stench!',26124),
(106058,'enUS','','The spirits thank you. Hopefully the stink of drogbar doesn\'t linger too long.',26124),
(106059,'enUS','The history of the Tirisgarde is a storied one. In short, it is a gathering of Azeroth\'s most battle-hardened mages armed with relics of great power. They are charged with defending Azeroth in the absence of the Guardian of Tirisfal. \n\nThey are normally only called together when the world faces a grave threat. The last time they were assembled was to bring back the rogue Guardian, Aegwynn. For centuries the Tirisgarde hunted her, utilizing some of the most powerful artifacts that Azeroth had known. \n\nWith the dissolving of the Council of Tirisfal, their mission was left unfinished. We will not let that happen here.','',26124),
(106064,'enUS','Ye wanna fight, eh? I\'ll give ye a fight!','',26124),
(106065,'enUS','Who needs an axe when ye\'ve got fists o\' steel!','',26124),
(106066,'enUS','Och! This one fell off the ugly tree an\' hit my fists on the way down!','',26124),
(106067,'enUS','Who ordered a knuckle sandwich?!','',26124),
(106068,'enUS','Now, THAT\'S a face worth punching!','',26124),
(106069,'enUS','Don\'t worry, I\'ll go easy on ye!','',26124),
(106070,'enUS','','Over here, shaman! We\'ve no time to lose.',26124),
(106071,'enUS','Och, what happened to yer face? MAH FISTS!','',26124),
(106072,'enUS','Which fist do ye want? How about both!','',26124),
(106073,'enUS','Are you ready to begin, $n?','',26124),
(106074,'enUS','Let\'s begin the ritual.','Let\'s begin the ritual.',26124),
(106075,'enUS','|TInterface\\Icons\\spell_nature_stranglevines:20|tUse |cFFFF0000|Hspell:339|h[Entangling Roots]|h|r, knockbacks, or stuns to keep Ariden away from you!','|TInterface\\Icons\\spell_nature_stranglevines:20|tUse |cFFFF0000|Hspell:339|h[Entangling Roots]|h|r, knockbacks, or stuns to keep Ariden away from you!',26124),
(106076,'enUS','<Thank you for playing. The second half of the Demon Hunter Intro in the Vault of the Wardens will be coming soon.>','',26124),
(106077,'enUS','Behold the site of my final battle... and there lies my foe. Even now, Zakajz struggles for consciousness. You must hurry!','',26124),
(106078,'enUS','','It\'s a massacre out there. All around the world, our forces fall back.',26124),
(106079,'enUS','','Unless we find a way to turn this around, Azeroth will fall!',26124),
(106080,'enUS','How can Calydus help you, friend?','',26124),
(106081,'enUS','Let me select my artifact.','Let me select my artifact.',26124),
(106082,'enUS','Demon hunters? How odd, covering your eyes like that. Doesn\'t it make it hard to see the world around you?','',26124),
(106083,'enUS','Greetings to you both. The tremors from the Emerald Dream grow more potent. We must begin the ritual at once!','',26124),
(106084,'enUS','','You have chosen well. Such a weapon will strike fear into the hearts of our foes!',26124),
(106085,'enUS','These are dark times - I\'m glad you\'re with us.','',26124),
(106086,'enUS','I\'m ready.','I\'m ready.',26124),
(106087,'enUS','%s is |cFFFF0404|Hspell:204779|h[Drifting Away]|h|r! Dispel him!','%s is |cFFFF0404|Hspell:204779|h[Drifting Away]|h|r! Dispel her!',26124),
(106088,'enUS','Your human friend was taken by the demons. Grant me my freedom and I will tell you where he was taken!','',26124),
(106089,'enUS','If you want to kill more naga, bring me more cannonballs.','',26124),
(106090,'enUS','The blade was taken somewhere in northwestern Tirisfal. I\'ve marked a location on your map where you can begin your search.','',26124),
(106091,'enUS','Here are the cannonballs. Let\'s go blast some naga.','If you want to kill more naga, bring me more cannonballs.',26124),
(106092,'enUS','Welcome to the Dreamway, $n. A journey that would take days upon Azeroth is but a few steps here.','',26124),
(106093,'enUS','Wait, I feel something... disturbing. Quickly $n, this way!','',26124),
(106094,'enUS','No! The Nightmare... in this part of the Dream? How is it possible?','',26124),
(106095,'enUS','I will cleanse these Nightmare vines from our path. Go forth, $n, and destroy the source of the corruption that spawned them!','',26124),
(106096,'enUS','Excellent work! Even now the foul creep of the Nightmare has begun to receed.','',26124),
(106097,'enUS','The way is clear. Come, let us continue to our destination.','',26124),
(106098,'enUS','%s causes a |cFFFF0404|Hspell:204839|h[Whirling Maelstrom]|h|r!','%s causes a |cFFFF0404|Hspell:204839|h[Whirling Maelstrom]|h|r!',26124),
(106099,'enUS','Come, we must find the Druids of Val\'sharah and request their aid.','',26124),
(106100,'enUS','|TInterface\\Icons\\spell_druid_bearhug:20|t%s targets |cFFFF0000$n|r with an intense |cFFFF0000|Hspell:198006|h[Focused Gaze]|h|r!','',26124),
(106101,'enUS','You should have fled! Now I\'ll feed your bones to the storm crows!','',26124),
(106102,'enUS','The Nightmare\'s veil is lifted... I return at last... to the long slumber.','',26124),
(106103,'enUS','You are free of this place... how I envy you!','',26124),
(106104,'enUS','By the will of the Nightmare Lord!','',26124),
(106105,'enUS','Should have fled. SHOULD HAVE LISTENED!','',26124),
(106106,'enUS','STAMP AND TRAMPLE! CRUSH AND CRUMPLE!','',26124),
(106107,'enUS','THE NIGHTMARE GROWS! THE NIGHTMARE DEVOURS!','',26124),
(106108,'enUS','Indeed, I wish our meeting were under better circumstances. Surely you have felt the tremors emanating from the Emerald Dream?','',26124),
(106111,'enUS','A moment of your time, warlock. The Council of the Black Harvest requests your assistance.','',26124),
(106112,'enUS','The weapons of old... Yes, they would help indeed! But they are beyond our ability to wield.','',26124),
(106113,'enUS','|TInterface\\Icons\\ability_deathwing_assualtaspects:20|t%s goes into a crazed |cFFFF0000|Hspell:198388|h[Blood Frenzy]|h|r!','',26124),
(106114,'enUS','It calls to souls long dead... RISE!','',26124),
(106115,'enUS','A trap! Destroy the creature before it kills us!','',26124),
(106116,'enUS','More o\' the Deacon\'s mind games. We could Mass Dispel \'em or just fight through, but I would\'na get too close!','',26124),
(106117,'enUS','','The greatest shaman in the world are gathering below. What\'s left of \'em, that is.',26124),
(106119,'enUS','|TInterface\\Icons\\spell_nature_insect_swarm2:20|t Nythendra inhales for an |cFFFF0404|Hspell:202977|h[Infested Breath]|h|r!','|TInterface\\Icons\\spell_nature_insect_swarm2:20|t Nythendra inhales for an |cFFFF0404|Hspell:202977|h[Infested Breath]|h|r!',26124),
(106120,'enUS','','My thanks, $pr. Now I am going to finish off the warden who did this to me.',26124),
(106122,'enUS','','Come, do your best. Nightglaive has been undergoing some \"changes\".',26124),
(106123,'enUS','','We are ready for you.',26124),
(106124,'enUS','The balance must be restored.','',26124),
(106125,'enUS','Elune-Adore, $n. I must speak with you at once!','',26124),
(106126,'enUS','You are not the only one who can control the undead, death knight!','',26124),
(106127,'enUS','Sss... souls of the dead! Aid your master!','',26124),
(106128,'enUS','Follow me. The Dreamgrove has its own gate to the Dreamway. Through it, you can travel to the far corners of Azeroth.','',26124),
(106129,'enUS','No! The sword... How can you overcome its power?!','',26124),
(106130,'enUS','Prepare to become kindling!','',26124),
(106131,'enUS','I\'ll rip the Claws from your lifeless hands!','',26124),
(106132,'enUS','Burn!','',26124),
(106133,'enUS','You will be my campfire!','',26124),
(106134,'enUS','I will snap you like a twig!','',26124),
(106135,'enUS','I will crush you to splinters.','',26124),
(106136,'enUS','I think I have a CRUSH on you. Heh.','',26124),
(106137,'enUS','','Oh goody, playthings.',26124),
(106138,'enUS','','This is why I can\'t have nice things.',26124),
(106139,'enUS','','Why do they break so easy?',26124),
(106140,'enUS','','I hate it when my toys stop screaming.',26124),
(106141,'enUS','','I hope the next one doesn\'t break so quick.',26124),
(106142,'enUS','','What!? Why would you do this?',26124),
(106143,'enUS','','Don\'t look behind you.',26124),
(106144,'enUS','','And along came a spider...',26124),
(106145,'enUS','','Run. Heh,  it is fun to watch you run.',26124),
(106146,'enUS','','I have tried to teach them to kill you slowly... But they just won\'t listen.',26124),
(106147,'enUS','','Your screams are funny... Make me laugh!',26124),
(106148,'enUS','','Which do you like more, screaming or crying? I like to hear you do both.',26124),
(106149,'enUS','The ettin prince is dead! Let\'s get out of here!','The ettin prince is dead! Let\'s get out of here!',26124),
(106150,'enUS','','If you scream loud enough, maybe I will let you die.',26124),
(106151,'enUS','','You can\'t get away. You are MINE!',26124),
(106152,'enUS','','Get over here, I want to play with your blood.',26124),
(106153,'enUS','','You can\'t leave, you can NEVER LEAVE!',26124),
(106154,'enUS','','Don\'t run, I want to see your tears.',26124),
(106155,'enUS','Lord Greymane promised we\'d be neck deep battle by now. I didn\'t sign up for guard duty!','Lord Greymane promised we\'d be neck deep battle by now. I didn\'t sign up for guard duty!',26124),
(106156,'enUS','','I hope this doesn\'t kill you... I want to play more...',26124),
(106157,'enUS','I know these towers are strategically important, but Lord Greymane promised me vengeance!','I know these towers are strategically important, but Lord Greymane promised me vengeance!',26124),
(106158,'enUS','','On a scale of 1 to 10, how bad does this hurt?',26124),
(106159,'enUS','Patience. The enemy will bring themselves to us, and we will show them Gilnean fury!','Patience. The enemy will bring themselves to us, and we will show them Gilnean fury!',26124),
(106160,'enUS','So long as we hold this ground the scum can\'t move freely in the area. They\'ll have no choice but to fight!','So long as we hold this ground the scum can\'t move freely in the area. They\'ll have no choice but to fight!',26124),
(106161,'enUS','','Those ettins are building a huge bonfire to cook and eat my tribesmen! You have to stop them!',26124),
(106162,'enUS','','Those ettins are building a huge bonfire to cook and eat my tribesmen! You have to stop them!',26124),
(106163,'enUS','','There will be no feast for the ettins this night. The Rivermane thank you!',26124),
(106165,'enUS','','$n, you must come to the Azurewing Repose and meet with my grandfather, Senegos.',26124),
(106167,'enUS','','Your training really inspired me to join the Unseen Path!',26124),
(106168,'enUS','','Turns out there\'s a lot more to being a hunter than just shooting game!',26124),
(106169,'enUS','','I\'m not the best yet, but I\'m gonna keep practicing!',26124),
(106170,'enUS','Work hard, my naga! We will destroy Jandvik!','',26124),
(106171,'enUS','There are few rules atop these cliffs... and absolutely no mercy! Tame a beast, mount up, and kill everyone you see! If you die, you prove your lack of worth.','',26124),
(106172,'enUS','You put on a good show in there!','',26124),
(106173,'enUS','','We will be victorious! Slay any intruder that daresss enter our watersss!',26124),
(106174,'enUS','The vrykul are nothing! We will wash over them and destroy their village!','',26124),
(106175,'enUS','','The strands of life have been severed! The dreamers must be avenged!',26124),
(106176,'enUS','','Come forth, dreamers... and claim your vengeance!',26124),
(106177,'enUS','','Hope is a disease of the soul! This land shall wither and die!',26124),
(106178,'enUS','','Taste the Nightmare\'s corruption!',26124),
(106179,'enUS','I can sense the shadow on your hearts. There can be no rest for the wicked!','',26124),
(106180,'enUS','Your wicked souls shall feed my power!','',26124),
(106181,'enUS','Peace is but a fleeting dream! Let the Nightmare reign!','',26124),
(106182,'enUS','Children of madness! I release you upon this world!','',26124),
(106183,'enUS','','It fades. It all fades away...',26124),
(106184,'enUS','|TInterface\\Icons\\Ability_Rogue_Dismantle:20|tYou\'re caught in a |cFFFF0000|Hspell:204348|h[Cruel Trap]|h|r!','|TInterface\\Icons\\Ability_Rogue_Dismantle:20|tYou\'re caught in a |cFFFF0000|Hspell:204348|h[Cruel Trap]|h|r!',26124),
(106185,'enUS','','You fought well this day, $n. I am in your debt.$b$bI\'m ready to use the portal stone and take us back to Dalaran.',26124),
(106186,'enUS','|TInterface\\Icons\\inv_axe_2h_felfireraid_d_01:20|t%s readies their axe for a  |cFFFF0000|Hspell:203641|h[Fel Slash]|h|r at $n!','|TInterface\\Icons\\inv_axe_2h_felfireraid_d_01:20|t%s readies their axe for a  |cFFFF0000|Hspell:203641|h[Fel Slash]|h|r at $n!',26124),
(106187,'enUS','Let\'s get out of here!','Let\'s get out of here!',26124),
(106188,'enUS','DEBUG - Path Failed','',26124),
(106189,'enUS','|TInterface\\Icons\\INV_Sword_48:20|tFree $n from their bonds before they are |cFFFF0000|Hspell:202361|h[Executed!]|h|r','|TInterface\\Icons\\INV_Sword_48:20|tFree $n from their bonds before they are |cFFFF0000|Hspell:202361|h[Executed!]|h|r',26124),
(106190,'enUS','In rescuing Stellagosa, you have made a powerful friend and ally.\n\nI am relieved that the Blue Dragonflight has survived, even if just barely. We must travel to the Azurewing Repose and speak with this Senegos.\n\nIf anyone can point us down the right path to locating the Pillar of Creation, surely it will be him.','',26124),
(106191,'enUS','Your friend was taken to the felstalker pits beneath the great Burning Legion command ship.','',26124),
(106192,'enUS','Sadly, it\'s probably too late for him... don\'t foolishly throw your lives away for a dead man!','',26124),
(106193,'enUS','','I am certain that if anyone can help you find this Pillar of Creation, it will be my grandfather.',26124),
(106194,'enUS','All are welcome to take the great Aviana\'s test of flight. Please form an orderly line to receive her blessing.','All are welcome to take the great Aviana\'s test of flight. Please form an orderly line to receive her blessing.',26124),
(106195,'enUS','May the wind be always under your wings.','May the wind be always under your wings.',26124),
(106196,'enUS','Even the best laid plans don\'t survive contact with the enemy.','',26124),
(106197,'enUS','Such insolence! We will make your death terrible, and your suffering long.','',26124),
(106198,'enUS','Your souls will fuel our engines!','',26124),
(106199,'enUS','Our hatred knows no bounds!','',26124),
(106200,'enUS','Pathetic worm!','',26124),
(106201,'enUS','A death most deserved.','',26124),
(106202,'enUS','We will unleash a scourge upon this citadel never before known to your kind!','',26124),
(106203,'enUS','My lord.. I have.. failed you...','',26124),
(106204,'enUS','Another soul, harvested!','',26124),
(106205,'enUS','She\'s mine! You won\'t take her!','',26124),
(106206,'enUS','|TInterface\\Icons\\Ability_Rogue_BloodyEye:20|tSmashspite\'s |cFFFF0000|Hspell:198079|h[Hateful Gaze]|h|r falls on |cFFFF0000$n|r!','|TInterface\\Icons\\Ability_Rogue_BloodyEye:20|tSmashspite\'s |cFFFF0000|Hspell:198079|h[Hateful Gaze]|h|r falls on $n!',26124),
(106207,'enUS','','A val\'kyr approaches! We must greet her with respect. Come, heroes!',26124),
(106208,'enUS','I\'m ready. Let\'s get down to Azsuna, Khadgar.','I\'m ready. Let\'s get down to Azsuna, Khadgar.',26124),
(106209,'enUS','Alrik, my battle brother! I will avenge you!','',26124),
(106210,'enUS','','May the val\'kyr claim you, Haardgrim!',26124),
(106211,'enUS','Look there! The val\'kyr!','',26124),
(106212,'enUS','Watch over me from above, my brothers, and save me a seat in the hall!','',26124),
(106213,'enUS','Sorry $g pal:lady;, I can\'t help ya. Find a $c trainer. I only teach hunters!','Sorry $g pal:lady;, I can\'t help ya. Find a $c trainer. I only teach hunters!',26124),
(106214,'enUS','Are you as excited as me to be here, $c?','Are you as excited as me to be here, $c?',26124),
(106215,'enUS','Follow me, $n, and I\'ll introduce you to your trainer, Muffinus Chromebrew.','Follow me, $n, and I\'ll introduce you to your trainer, Muffinus Chromebrew.',26124),
(106216,'enUS','Muffinus, allow me to introduce $n, who helped us rescue survivors in Gnomeregan.','Muffinus, allow me to introduce $n, who helped us rescue survivors in Gnomeregan.',26124),
(106217,'enUS','','Welcome to Fragments of the Past!$b$bAre you interested in learning about Archaeology?',26124),
(106218,'enUS','A new continent full of forgotten secrets!','',26124),
(106219,'enUS','This place is steeped in titan architecture. Why, jes over that hill to tha north is a \'uge titan chamber!','',26124),
(106221,'enUS','Go now. Hruthnir waits at the Sky Launch to aid you.','',26124),
(106222,'enUS','|TInterface\\Icons\\INV_Misc_Slime_01:20|t A Congealing Goo was able to finish |cFFFF0404|Hspell:201495|h[Recongealing]|h|r!','|TInterface\\Icons\\INV_Misc_Slime_01:20|t A Congealing Goo was able to finish |cFFFF0404|Hspell:201495|h[Recongealing]|h|r!',26124),
(106224,'enUS','Welcome to our new home, $n.','',26124),
(106225,'enUS','Please excuse me, $n. I\'m preparing a report for the other masters.','',26124),
(106226,'enUS','Brothers and Sisters, the invaders come for us. Repel them! Attack!','',26124),
(106227,'enUS','Whenever you\'re ready.','',26124),
(106228,'enUS','I\'ve been waiting for this day.','',26124),
(106229,'enUS','Our friends in the Kirin Tor have created one of their magical portals to provide quick travel to Dalaran. You can find it near the steps to the temple.','',26124),
(106230,'enUS','','I was taught to see every $r as my enemy. But the Legion would wipe us all from this world.$b$bSo I have chosen to follow the Unseen Path, and I stand with you.',26124),
(106231,'enUS','These demons think we will just give up the Crossroads without a fight?','',26124),
(106232,'enUS','Push them back! We cannot let the Crossroads fall!','',26124),
(106233,'enUS','Reinforcements to the Crossroads at once! We\'re under attack!','',26124),
(106234,'enUS','Hold the Crossroads until reinforcements arrive! Show these demons what it means to fight for the Horde!','',26124),
(106235,'enUS','For the Horde!','',26124),
(106236,'enUS','These lands will not be ruined by your kind!','',26124),
(106237,'enUS','For the Warchief!','',26124),
(106238,'enUS','Your foul magics are no match for my blade!','',26124),
(106239,'enUS','Cut them down and heave their souls into the tides!','',26124),
(106240,'enUS','Take their trinkets for yourselves, but leave their souls for me!','',26124),
(106241,'enUS','Intruders on the Naglfar! Give no quarter to these scallywags!','',26124),
(106242,'enUS','Nothing sweeter... than to die at sea...','',26124),
(106243,'enUS','Skinning','Skinning',26124),
(106244,'enUS','Greetings, $n. I am pleased you received Thrall\'s summons.$b$bYou can see, there are no factions here. We few are all that remain of the Earthen Ring, and we must struggle together or surely we will perish alone.$b$bSurvivors continue to make their way here from the four corners of Azeroth. See that their wounds are tended to. They need hope if they are to rejoin the fight, $n. You must inspire them!','',26124),
(106245,'enUS','I will see to the others, Farseer.','I will see to the others, Farseer.',26124),
(106246,'enUS','Here comes my former student, $n, death incarnate! One day I\'d like to hear about the techniques you\'ve learned in the field.','',26124),
(106248,'enUS','temp:\nYour hardest hitting abilities are Ice Lance against frozen targets and Frozen orb.  Since not every creature can be frozen and because Frozen Orb has a long cooldown, there are two effects you will gain in combat.','',26124),
(106249,'enUS','temp:\nCasting Frostbolt will occasionally grant you Fingers of Frost and Brain Freeze effects.  Fingers of Frost causes your Ice lance to treat your target as if it were frozen, doing incredible damage.  Brain Freeze will resets the cooldown on Frozen Orb.  Try using both now.','',26124),
(106250,'enUS','','The plight of Azeroth is far more grave than we first thought.',26124),
(106251,'enUS','You\'ll want to see this for yourself.','',26124),
(106252,'enUS','','Some of the local trash have been stealing our vintage bottles, can you track them down and bring them back to me? Some of those bottles are irreplaceable!',26124),
(106253,'enUS','','The eagle loa! Praise the spirits!',26124),
(106254,'enUS','','My people tell legends of such spirits, but I have never seen one.',26124),
(106255,'enUS','That eagle would fly better with mechanical wings!','',26124),
(106256,'enUS','','It\'s so... beautiful!',26124),
(106257,'enUS','The fel blood froths violently, a swirl of obfuscated shapes bubbling just below the surface.','The fel blood froths violently, a swirl of obfuscated shapes bubbling just below the surface.',26124),
(106258,'enUS','Gaze upon the Burning Legion\'s presence on Azeroth.','Gaze upon the Burning Legion\'s presence on Azeroth.',26124),
(106259,'enUS','Greetings, and thank you for helping to test the Legion Beta! \n\nI can teleport you directly into a number of raid or dungeon instances that are currently open for testing. This is just a teleport, not a match-making service, so I hope you have a party ready to tackle the challenges waiting inside. If not, you might want to check out our new Group Finder feature to find some allies.\n\nMake sure you have selected the difficulty you want to test before teleporting, since you may not be able to zone out easily if you need to change the difficulty setting!','',26124),
(106260,'enUS','A fine start! The Kirin Tor have given us a permanent portal to Dalaran, as well as one that will bring you from the city back to Netherlight. Good luck!','',26124),
(106261,'enUS','Enough of this! To me, Su\'esh! Destroy these interlopers!','Enough of this! To me, Su\'esh! Destroy these interlopers!',26124),
(106262,'enUS','What\'s this? Listen to me! I am the alpha!','What\'s this? Listen to me! I am the alpha!',26124),
(106263,'enUS','Is that how it is? Clever girl.','Is that how it is? Clever girl.',26124),
(106264,'enUS','You\'ve got Fingers of Frost, cast Ice Lance now.','',26124),
(106265,'enUS','','Golly gearshaft! Is that $n with that uber-awesome weapon of $ghis:hers;?',26124),
(106266,'enUS','Oh sure, it\'s a nice weapon... I guess. But can it tame a mechanical chicken? I think not!','',26124),
(106267,'enUS','','I\'m so happy that we gnomes can finally unleash our inner hunters!',26124),
(106268,'enUS','I know, right? About time I get to show off my guns!','',26124),
(106269,'enUS','Say Drupala, which of these weapons on the wall are meant for hunters?','',26124),
(106270,'enUS','','Haven\'t you heard, Practicus? All weapons are hunter weapons. All of them!',26124),
(106271,'enUS','So you\'ve taken care of our little pet, have you? No matter. I will show you why I am the alpha!','So you\'ve taken care of our little pet, have you? No matter. I will show you why I am the alpha!',26124),
(106272,'enUS','Su\'esh eyes the wounds on Graedis.','',26124),
(106273,'enUS','Su\'esh looks hungrily at Graedis.','',26124),
(106274,'enUS','You are entering a restricted area. You will be teleported to Dalaran unless you return to your previous zone.','You are entering a restricted area. You will be teleported to Dalaran unless you return to your previous zone.',26124),
(106275,'enUS','Suffer well.','',26124),
(106276,'enUS','The Ashtongue will fight beside you.','',26124),
(106277,'enUS','','You may call upon the Coilskar as well.',26124),
(106278,'enUS','','Our mission is not yet complete. We are all yours to command.',26124),
(106280,'enUS','Should you succeed, the blade is yours. But if you should fail... then you will become a mindless minion of the Scourge. Do not expect my protection.','',26124),
(106281,'enUS','I want to go to Black Rook Hold (Dungeon).','I want to go to Black Rook Hold (Dungeon).',26124),
(106282,'enUS','I want to go to Darkheart Thicket (Dungeon).','I want to go to Darkheart Thicket (Dungeon).',26124),
(106283,'enUS','I want to go to Eye of Azshara (Dungeon).','I want to go to Eye of Azshara (Dungeon).',26124),
(106284,'enUS','','You do not want to test my patience, demon. Speak.',26124),
(106285,'enUS','I want to go to Halls of Valor (Dungeon).','I want to go to Halls of Valor (Dungeon).',26124),
(106286,'enUS','','Your foul soul will be all that remains.',26124),
(106287,'enUS','I want to go to Neltharion\'s Lair (Dungeon).','I want to go to Neltharion\'s Lair (Dungeon).',26124),
(106288,'enUS','I want to go to The Arcway (Dungeon).','I want to go to The Arcway (Dungeon).',26124),
(106289,'enUS','','I do not have all day - talk and this can all be over.',26124),
(106290,'enUS','I want to go to Maw of Souls (Dungeon).','I want to go to Maw of Souls (Dungeon).',26124),
(106291,'enUS','I want to go to The Violet Hold (Dungeon).','I want to go to The Violet Hold (Dungeon).',26124),
(106292,'enUS','I want to go to Vault of the Wardens (Dungeon).','I want to go to Vault of the Wardens (Dungeon).',26124),
(106293,'enUS','','Taste the Scythe of Souls, demon.',26124),
(106294,'enUS','','Cooperate or die.',26124),
(106295,'enUS','','I will take great pleasure in ripping the soul out of your body.',26124),
(106296,'enUS','','Reveal all you know to me or pay the price.',26124),
(106297,'enUS','','I have ways of making your kind talk.',26124),
(106298,'enUS','Very good.  Let\'s practice that a few more times.','',26124),
(106299,'enUS','','Ask patiently of the ocean, and the ocean will listen.$b$bAsk patiently of me... and I will see what I can do.',26124),
(106300,'enUS','Can you bless me with the gift of water walking?','Can you bless me with the gift of water walking?',26124),
(106301,'enUS','','When you have found all the pieces, meet me just east of here. I\'ll prepare the burial ceremony.',26124),
(106302,'enUS','','Hello adventurer, I am Lessah. Are you as interested as I am in learning about the Highmountain tauren?',26124),
(106303,'enUS','','Have you recovered the remainder of Eche\'ro\'s bones?',26124),
(106304,'enUS','Here are remaining bone fragments.','Here are remaining bone fragments.',26124),
(106305,'enUS','|TInterface\\Icons\\Spell_Shadow_Charm:20|t%s inhales deeply for a |cFFFF0000|Hspell:204078|h[Bellowing Roar]|h|r!','',26124),
(106306,'enUS','','|TInterface\\Icons\\ability_creature_cursed_03.blp:20|t%s takes to the skies, infecting the nightmare with |cFFFF0000|Hspell:204245|h[Corruption of the Dream]|h|r!',26124),
(106307,'enUS','|TInterface\\Icons\\Spell_Shadow_AuraOfDarkness:20|t%s begins to cast |cFFFF0000|Hspell:203888|h[Siphon Spirit]|h|r!','',26124),
(106308,'enUS','Thank you, young one for honoring the spirit of my companion. Should you ever need him, Eche\'ro will be at your call.','',26124),
(106309,'enUS','','All will succumb to the Nightmare!',26124),
(106310,'enUS','','Oh great Eche\'ro, I return your bones to the earthmother and pray your spirit be at peace.',26124),
(106311,'enUS','','Let us begin, $n.',26124),
(106312,'enUS','Set sail for Stormheim!','Set sail for Stormheim!',26124),
(106313,'enUS','I hope someday to become as great as Lessah has become and make her proud.','',26124),
(106314,'enUS','Are you ready for your lessons?','Are you ready for your lessons?',26124),
(106315,'enUS','One? Kill the fool and keep my cargo safe. Don\'t wake me again!','',26124),
(106316,'enUS','','Speak with Luron when you\'re ready to begin your lessons.',26124),
(106317,'enUS','I want to go to Suramar Palace (Raid).','I want to go to Suramar Palace (Raid).',26124),
(106318,'enUS','','The Forsaken stand ready.',26124),
(106319,'enUS','I want to go to the Emerald Nightmare (Raid).','I want to go to the Emerald Nightmare (Raid).',26124),
(106320,'enUS','','The Dark Lady will guide us to victory.',26124),
(106321,'enUS','','First, we escort you to Aggramar\'s Vault, then we meet up with Dreadwake at Skold-Ashil.$B$BShould be smooth sailing.',26124),
(106322,'enUS','','|TInterface\\Icons\\inv_fishing_lure_worm.blp:20|t%s targets $n for |cFFFF0404|Hspell:199176|h[Spiked Tongue]|h|r!',26124),
(106323,'enUS','Go in ahead, druid. I will join you inside.','',26124),
(106324,'enUS','The crystal has three empty slots carved into it. You don\'t quite have enough keystones to active the crystal just yet.','',26124),
(106325,'enUS','The crystal has three empty slots carved into it.','',26124),
(106326,'enUS','[Placeholder Animation!]','',26124),
(106327,'enUS','|TINTERFACE\\ICONS\\INV_MISC_GEAR_01:20|t Under Construction! |TINTERFACE\\ICONS\\INV_Misc_Gear_08:20|t','|TINTERFACE\\ICONS\\INV_Misc_Gear_08:20|t Under Construction!',26124),
(106328,'enUS','Place the three Highmountain Ritual-Stones into the crystal.','Place the three Highmountain Ritual-Stones into the crystal.',26124),
(106329,'enUS','This will remove 3 |cFF00FF00|Hitem:130904:0:0:0:0:0:0:0:90:0|h[Highmountain Ritual-Stones]|h|r from your inventory. Are you sure?','This will remove 3 |cFF00FF00|Hitem:130904:0:0:0:0:0:0:0:90:0|h[Highmountain Ritual-Stones]|h|r from your inventory. Are you sure?',26124),
(106330,'enUS','','Seen Nat around lately?',26124),
(106331,'enUS','','Keep some bait on your hook and some fish in your belly.$b$bTake care not to mix those two up.',26124),
(106332,'enUS','','Fishing in a fountain may not be glamorous... but at least it\'s not fishing in a sewer.',26124),
(106333,'enUS','As you place the keystones into the crystal, it begins to hum with energy.','',26124),
(106334,'enUS','As you place the keystones into the crystal, it begins to hum with energy.','',26124),
(106335,'enUS','As you place the keystones into the crystal, it begins to hum with energy.','',26124),
(106336,'enUS','As you place the keystones into the crystal, it begins to hum with energy.','',26124),
(106337,'enUS','As you place the keystones into the crystal, it begins to hum with energy.','',26124),
(106338,'enUS','No... no! Helya, give me more power!','',26124),
(106339,'enUS','Brain Freeze just reset the cooldown of Frozen Orb, cast that now.','',26124),
(106340,'enUS','','Over here, shaman! Take up my spear, and may the winds guide your strike!',26124),
(106341,'enUS','','The portal to Dalaran is above the hall entrance. Take the ramp up.',26124),
(106342,'enUS','','Our mission is of the utmost importance.',26124),
(106343,'enUS','','The Skyfire is ready for action.',26124),
(106344,'enUS','Set sail for Stormheim!','Set sail for Stormheim!',26124),
(106345,'enUS','The murloc\'s training is really coming along!','The murloc\'s training is really coming along!',26124),
(106346,'enUS','Keep it up! You can do it!','Keep it up! You can do it!',26124),
(106347,'enUS','You\'ve gotten a lot better! Really!','You\'ve gotten a lot better! Really!',26124),
(106348,'enUS','Careful of low blows!','Careful of low blows!',26124),
(106349,'enUS','Put your back into it!','Put your back into it!',26124),
(106350,'enUS','I\'ve seen my share of murloc hunters, but this kid has got something special!','I\'ve seen my share of murloc hunters, but this kid has got something special!',26124),
(106351,'enUS','Stop wasting your time trying to train that one!','The murloc\'s training is really coming along!',26124),
(106352,'enUS','That\'s it! Hit him in the kneecaps!','That\'s it! Hit him low!',26124),
(106353,'enUS','Go for the eyes, murloc!','Go for the eyes, murloc!',26124),
(106354,'enUS','One hundred coppers on the centaur... ish... cat... thing...','One hundred coppers on the centaur... ish... cat... thing...',26124),
(106355,'enUS','Hunters standing toe to toe... never thought I\'d see the day!','Hunters standing toe to toe... never thought I\'d see the day!',26124),
(106356,'enUS','You call that sparring? Where\'s all the blood and broken bones?','You call that sparring? Where\'s all the blood and broken bones?',26124),
(106357,'enUS','You gotta lock their gaze. That\'s the secret to a good taming!','',26124),
(106358,'enUS','If a wild beast smells fear on you, you\'re dead. Or sausage. If they smell sausage, you\'ll be mauled.','',26124),
(106359,'enUS','You don\'t stand around watching while another hunter is taming. It\'s kinda personal, ya know?','',26124),
(106360,'enUS','Roads into the lodge look clear.','',26124),
(106361,'enUS','The Silver Covenant stands ready to aid the Unseen Path.','',26124),
(106362,'enUS','No threat will make it past me, $n!','',26124),
(106363,'enUS','I can stand no more of this dallying! The Dark Lady must let us take the fight to the Alliance dogs now!','I can stand no more of this dallying! When will the Dark Lady let us take the fight to the Alliance dogs?',26124),
(106364,'enUS','No flesh to eat, unless we\'re on the move! When will this guard duty end?','No flesh to eat, unless we\'re on the move! When will this guard duty end?',26124),
(106365,'enUS','The curs will bring themselves to us. We will blunt their rage and feast on their flesh!','The curs will bring themselves to us. We will blunt their rage and feast on their flesh!',26124),
(106366,'enUS','The enemy will have to fight us on our terms. Stay patient. Soon, we will have out fill of battle!','The enemy will have to fight us on our terms. Stay patient. Soon, we will have out fill of battle!',26124),
(106369,'enUS','Did the tauren play a role in building this lodge?','Did the tauren play a role in building this lodge?',26124),
(106370,'enUS','There was a light snow last night, my darling. You always loved watching the flakes fall.','',26124),
(106371,'enUS','Millennia have passed, yet the sorrow refuses to leave my heart. Oh, Namuria...','',26124),
(106373,'enUS','It is a new dawn for our order, my love. You would be so proud of Emmarel for uniting us under a new leader.','',26124),
(106374,'enUS','Though it pains me to be without you, I shall fight on in your memory, my love.','',26124),
(106375,'enUS','I miss you, Namuria.','',26124),
(106376,'enUS','Fade into shadow...','Fade into shadow...',26124),
(106377,'enUS','This guy\'s toast.','This guy\'s toast.',26124),
(106378,'enUS','For Gilneas!','For Gilneas!',26124),
(106379,'enUS','','You there, friend of nature! Aid me in teaching these foul poachers a lesson!',26124),
(106380,'enUS','','Hit a man with a fish, and he will stop fishing for a day. Hit a man AS a fish, and he will stop fishing for the rest of his life!',26124),
(106381,'enUS','','The Unseen Path is reborn!',26124),
(106382,'enUS','The seed will need plenty of air and water. Look for an ideal spot on the hill behind us.','',26124),
(106383,'enUS','','Intruder! How dare you disturb Eyir\'s sanctum!',26124),
(106384,'enUS','','Eyir\'s wrath... will end you...',26124),
(106385,'enUS','Die, scum!','Die, scum!',26124),
(106386,'enUS','I return to shadow!','I return to shadow!',26124),
(106387,'enUS','Heh. Weakling.','Heh. Weakling.',26124),
(106388,'enUS','Never saw us coming.','Never saw us coming.',26124),
(106389,'enUS','A clean kill.','A clean kill.',26124),
(106390,'enUS','Good! This seed holds magic from when the world was young. This will prove very useful.','',26124),
(106392,'enUS','Start the device, Brann.','Start the device, Brann.',26124),
(106393,'enUS','Start the device again, Brann.','Start the device again, Brann.',26124),
(106394,'enUS','Alright, $glad:lass;, be on yer guard.','',26124),
(106395,'enUS','','Protect Greymane! For Gilneas!',26124),
(106396,'enUS','','Sylvanas... will not... win...',26124),
(106397,'enUS','Hero, I sense your destiny lies with the ancient night elf who started you on this journey. Before I depart, I can send you back to the city in the sky. May Talonclaw serve you well.','',26124),
(106398,'enUS','$ct, our friends in the Kirin Tor have created one of their arcane portals to provide easy access to Dalaran. Should you have need of it you can find it along the path north of here.','',26124),
(106399,'enUS','$ct, you have made our path clear! Now, we strike! For Azeroth!','',26124),
(106400,'enUS','<The apparition speaks, but you hear nothing.$B$BHe gestures at your equipment.>','',26124),
(106401,'enUS','Those blades... just looking at them makes me feel cold.','Those blades... just looking at them makes me feel cold.',26124),
(106402,'enUS','The skull on that axe looks... hungry.','The skull on that axe looks... hungry.',26124),
(106403,'enUS','That sword... oh no... is that Apocalylpse!? I\'m glad the Burning Legion didn\'t get their hands on it!','That sword... oh no... is that Apocalylpse!? I\'m glad the Burning Legion didn\'t get their hands on it!',26124),
(106404,'enUS','Something must be wrong with me, it\'s getting hot all of a sudden.','Something must be wrong with me, it\'s getting hot all of a sudden.',26124),
(106405,'enUS','Those hand blades look so sharp! Why, I bet you could slice a boulder in half!','Those hand blades look so sharp! Why, I bet you could slice a boulder in half!',26124),
(106406,'enUS','This is only the beginning!','',26124),
(106407,'enUS','%s laughs.','',26124),
(106408,'enUS','We are everywhere!','',26124),
(106409,'enUS','We cannot be stopped!','',26124),
(106410,'enUS','PREPARE TO FACE YOUR DOOM, $n! IT IS I, WYRMY TUNKINS AND I WILL BE THIS WORLD\'S UNDOING!','',26124),
(106411,'enUS','Wait, stop! Please don\'t kill me!','',26124),
(106412,'enUS','If you spare my life, I promise to swear my allegiance to you. And here, look, I have a valuable artifact that you may have as well.','',26124),
(106413,'enUS','A val\'kyr arrives and pulls you from the brink of death!','A val\'kyr arrives and pulls you from the brink of death!',26124),
(106414,'enUS','Die, die, die!','Die, die, die!',26124),
(106415,'enUS','<The sea turtle speaks directly to your mind.>$B$BYou are a stranger to my waters. What purpose could bring you here?','',26124),
(106416,'enUS','Strike!','Strike!',26124),
(106417,'enUS','I fade into darkness.','I fade into darkness.',26124),
(106418,'enUS','Climb on the Toogus\' back.','Climb on the Toogus\' back.',26124),
(106419,'enUS','Darkness cloaks my every move...','Darkness cloaks my every move...',26124),
(106420,'enUS','Another skull for the pile.','Another skull for the pile.',26124),
(106421,'enUS','The Banshee Queen sends her regards.','The Banshee Queen sends her regards.',26124),
(106422,'enUS','Death claims you!','Death claims you!',26124),
(106423,'enUS','Use your flare gun to mark your target. Our assassins attack on your command!','',26124),
(106424,'enUS','Come here, friend. I\'ve got something that will help you with clearing out these Forsaken!','',26124),
(106425,'enUS','','Calm yourself, Wuho!',26124),
(106426,'enUS','Feathermane Kitten playfully swipes at the reeds.','',26124),
(106427,'enUS','Our tribe\'s greatest weapon and its ancient enemy are but a few strides away! I will not be stopped by some foul fog magic!','',26124),
(106428,'enUS','','Patience, brother. To gaze upon Talonclaw will be a sight to remember. Look! Our friend returns!',26124),
(106429,'enUS','Yes, can I help you?$b$bLespin sent you? So he could not even be bothered to show up himself.$b$bWell, I suppose I have already received my payment, so I do not particularly care what happens to the ring now.$b$bHere, take the ring. Tell Lespin it had better be worth it.','Yes, can I help you?$b$bLespin sent you? So he could not even be bothered to show up himself.$b$bWell, I suppose I have already received my payment, so I do not particularly care what happens to the ring now.$b$bHere, take the ring. Tell Lespin it had better be worth it.',26124),
(106430,'enUS','Well, this is surprising. Tell me, does Lespin know?','',26124),
(106431,'enUS','Deception! Perfidy! We are invaded!','',26124),
(106432,'enUS','What a day. What a lovely day.','',26124),
(106433,'enUS','I must apologize, but I do not have time to speak with you right now. I am waiting for someone.','',26124),
(106434,'enUS','Just out for a stroll. I might tour the Menagerie. Have you been there recently?','',26124),
(106435,'enUS','Water Elemental Intro','',26124),
(106436,'enUS','Water Elemental - Explanation','',26124),
(106437,'enUS','From this vantage point I can keep a watchful eye on the Alliance supply routes to the Swamp of Sorrows.$b$bIt is a thankless task, but vital should our enemies move against our forces at Stonard.','',26124),
(106438,'enUS','Don\'t worry Brambley, I\'ll carry yer wee head to safety!','',26124),
(106439,'enUS','Let\'s get this disc assembled, shall we?!','',26124),
(106440,'enUS','So then this piece goes over here...','',26124),
(106441,'enUS','That\'s all the pieces. Now why is there a hole in the middle... ?','',26124),
(106442,'enUS','Here lies his mighty arm that defended the realm in so many battles!','',26124),
(106443,'enUS','ACK! Don\'t tell me we\'re still missn\' a piece!','',26124),
(106444,'enUS','Good eye! That\'s his alright... I\'d know it a mile away!','',26124),
(106445,'enUS','I\'ll take ye home Brambley! Piece by piece, I swear it!','',26124),
(106446,'enUS','Och, looks like the demons chewed on this one. Aye, it\'s still moist...','',26124),
(106447,'enUS','It\'s Brambley\'s Dagger! We\'ll take it home an\' bury it with the rest o\' him.','',26124),
(106448,'enUS','Vrykul raiders are testing the border defenses of Highmountain. Our allies could use your help, champion.','',26124),
(106449,'enUS','Well done. That should remind the vrykul that Highmountain is no easy summit to take.','',26124),
(106450,'enUS','Vrykul raiders are testing our border defenses. Our forces are stretched too thin. Can you help?','',26124),
(106451,'enUS','Ha ha! That should remind those vrykul that Highmountain is no easy summit to take.','',26124),
(106452,'enUS','Angus, I\'m alive! I\'m up here!','',26124),
(106453,'enUS','It IS my voice you daft dwarf! I\'m ALIVE!','',26124),
(106454,'enUS','Watch out for the felfire breath! Hide behind something when he does that!','',26124),
(106455,'enUS','This crown once adorned the brow of Mavrana Mooncrest. It conveyed an incredible amount of arcane power, allowing her to achieve nearly-limitless mastery over the magical arts.$b$bDuring the War of the Ancients, the crown was stolen by rival nobles, and its precious jewels were removed and sold. It was eventually recovered, but without the Jewels of Aellis which gave it such potency.$b$bTo this day, the jewels remain lost.','',26124),
(106456,'enUS','Planting Explosives','Planting Explosives',26124),
(106457,'enUS','I will let the other wardens know of Cordana\'s fate.','I will let the other wardens know of Cordana\'s fate.',26124),
(106458,'enUS','Are you sure you want to leave the instance?','Are you sure you want to leave the instance?',26124),
(106459,'enUS','The Doomhammer...','',26124),
(106460,'enUS','','Thanks for getting those bottles back for us!',26124),
(106465,'enUS','','Wise words, Lowlander.',26124),
(106466,'enUS','Not as such. I had to make the choice, as you do, of indulging my desire for revenge or saving my people.','',26124),
(106467,'enUS','','They tell me your father was killed as well. Did you avenge him?',26124),
(106468,'enUS','','In my case, saving my people also means getting revenge for my father.',26124),
(106469,'enUS','|TInterface\\Icons\\Spell_Fire_FelFlameRing:20|t Skovald begins to cast |cFFFF0404|Hspell:193826|h[Ragnarok]|h|r!','|TInterface\\Icons\\Spell_Fire_FelFlameRing:20|t Skovald begins to cast |cFFFF0404|Hspell:193826|h[Ragnarok]|h|r!',26124),
(106470,'enUS','You must learn to trust those who are willing to help you.','',26124),
(106471,'enUS','No. It is my experience with hot headed leaders.','',26124),
(106472,'enUS','','Is that your experience with new leaders talking, Lowlander?',26124),
(106473,'enUS','','Huln united the tribes even before finding the hammer? How?',26124),
(106474,'enUS','He gave them a cause worth fighting for. Not a weapon to rally behind.','',26124),
(106475,'enUS','The Greystone drogbar managed to somehow acquire elementium. Neither they nor the Highmountain tribes can possibly understand how dangerous this material is. Please, recover it from them.','',26124),
(106476,'enUS','Good work. That ore was a favorite of Deathwing\'s during the cataclysm. It is a powerful weapon when used for evil.','',26124),
(106477,'enUS','Alard, could you help me cast a new set of keys?','Alard, could you help me cast a new set of keys?',26124),
(106478,'enUS','Sure can! Take this metal and melt it by the forge. Then pour it into the mold. When that\'s done, you can cool it over by the quenching trough.','',26124),
(106479,'enUS','Insignificant slime. You have meddled in our affairs for the last time.','',26124),
(106480,'enUS','Day 40: A massive ettin trampled through my workshop at Koralune Manor. Scared him away with magic. Have a feeling he will be back...','',26124),
(106481,'enUS','I\'ve marked the location of the entrance on your map. Meet me there when you\'re ready to continue.','',26124),
(106482,'enUS','Are you ready to get to work? There are many artifacts to be found in these lands.','',26124),
(106483,'enUS','Just follow my lead when we\'re inside and try not to disturb anything unless I say so.','',26124),
(106484,'enUS','Alright, let\'s go.','',26124),
(106485,'enUS','|TInterface\\Icons\\ability_priest_flashoflight:20|t Odyn begins to |cFFFF0404|Hspell:198077|h[Shatter Spears]|h|r!','|TInterface\\Icons\\ability_priest_flashoflight:20|t Odyn begins to |cFFFF0404|Hspell:198077|h[Shatter Spears]|h|r!',26124),
(106486,'enUS','|TInterface\\Icons\\ability_thunderking_overcharge:20|t Odyn begins to cast |cFFFF0404|Hspell:201215|h[Summon Stormforged Obliterator]|h|r!','|TInterface\\Icons\\ability_thunderking_overcharge:20|t Odyn begins to cast |cFFFF0404|Hspell:201215|h[Summon Stormforged Obliterator]|h|r!',26124),
(106487,'enUS','We must each choose our own path.','',26124),
(106488,'enUS','What are my options again?','What are my options again?',26124),
(106489,'enUS','When you are ready, step through the portal into the Dreamway. I will meet with you on the other side.','',26124),
(106490,'enUS','','$ct, what a strange structure you are on! I can now send you directly to Highmountain from Skyhold whenever you choose!',26124),
(106491,'enUS','Who dares to challenge King Morgalash!','',26124),
(106492,'enUS','Destroy the wretched slime!','',26124),
(106493,'enUS','Crush the puny creature!','',26124),
(106494,'enUS','','Greymane\'s forces hold this Warden tower. Break their ranks! Show no mercy!',26124),
(106495,'enUS','','A decisive victory! These Alliance lapdogs scatter before the might of the Horde!',26124),
(106496,'enUS','A garrison in this warden tower would be a vital strategic victory. Drive the Forsaken from it, for Gilneas!','',26124),
(106497,'enUS','A fine victory, and a blow dealt to the Forsaken. Vengeance moves with the Gilneas Brigade!','',26124),
(106498,'enUS','Follow me, $c!','',26124),
(106500,'enUS','Quickly, $n! We must hurry!','',26124),
(106501,'enUS','Come on, $n!','',26124),
(106502,'enUS','','The Felsworn cannot be allowed to thrive on our isle. You know what to do.',26124),
(106503,'enUS','','Well done, $n. With the Felsworn weakened we are one step closer to fixing this mess.',26124),
(106505,'enUS','','<Stage 1 Complete>',26124),
(106506,'enUS','','<Stage 2 Complete>',26124),
(106507,'enUS','|TInterface\\Icons\\Spell_Arcane_MassDispel:20|t %s begins to cast |cFFFF0000|Hspell:204471|h[Focused Blast]|h|r.','|TInterface\\Icons\\Spell_Arcane_MassDispel:20|t %s begins to cast |cFFFF0000|Hspell:204471|h[Focused Blast]|h|r.',26124),
(106514,'enUS','I can still hear Brambley\'s voice in my head, tellin\' me to stay alive.','',26124),
(106515,'enUS','I will laddy! I\'ll stay alive for the both of us!','',26124),
(106516,'enUS','I saw it first!','',26124),
(106517,'enUS','Dibs. Dibs! I called dibs!','',26124),
(106518,'enUS','You don\'t understand - I need this!','',26124),
(106519,'enUS','Do you know how long I\'ve been waiting for this?','',26124),
(106520,'enUS','I won\'t lose again! It\'s mine!','',26124),
(106521,'enUS','Can\'t I just have it?','',26124),
(106522,'enUS','|TInterface\\Icons\\ability_skyreach_wind:20|t %s begins to cast |cFFFF0000|Hspell:204316|h[Shockwave]|h|r.','|TInterface\\Icons\\ability_skyreach_wind:20|t %s begins to cast |cFFFF0000|Hspell:204316|h[Shockwave]|h|r.',26124),
(106567,'enUS','I\'m the elf your elf could be, if he was me.','',26124),
(106570,'enUS','I prefer using the greatstaff Atiesh\'s raven form. Nothing\'s worse than saddle sores.','',26124),
(106573,'enUS','The demon hunters have set up camp on the far side of the island. Perhaps they can help us locate the Pillar of Creation.','',26124),
(106574,'enUS','Look there... naga forces. We have competition from Queen Azshara herself!','',26124),
(106575,'enUS','She must also be after the Pillar of Creation. This is unexpected.','',26124),
(106580,'enUS','I.... have to sell this horse to you.','I.... have to sell this horse to you.',26124),
(106581,'enUS','Woah, $Gman:lady;, are you sure? This ain\'t some sort of prank?','',26124),
(106582,'enUS','Unfortunately, yes.','Unfortunately, yes.',26124),
(106583,'enUS','Pleasure doing business with ya. You just made my freakin\' career, pal!','',26124),
(106625,'enUS','Now don\'t keep me waiting, philistine. Chop chop!','',26124),
(106633,'enUS','','The plagues of the Legion will destroy your fragile city!',26124),
(106658,'enUS','','Your city is doomed!',26124),
(106674,'enUS','What\'s this? More of this blasted stone?!','',26124),
(106675,'enUS','You will pay for this, stranger. I will find you... and I will destroy you.','',26124),
(106676,'enUS','','I can\'t hold this forever! Do it!',26124),
(106677,'enUS','','I\'ll meet you there!',26124),
(106679,'enUS','If you have need of repair to your leathers I\'ll be glad to help. All of my skins were taken only from creatures that died of natural causes.','',26124),
(106681,'enUS','Katy, would you help $p and go open the old Consortium portal by the Antonidas Memorial?','',26124),
(106683,'enUS','','Oh my, that doesn\'t sound good. Go ahead and head back to The Postmaster - I\'ll dismantle this portal real quick.',26124),
(106684,'enUS','Pay Haramad no mind. Deep down I know he appreciates all of that free stone.','',26124),
(106698,'enUS','Stupid Ringtail! You\'ve snuck into our pantry for the last time!','Stupid Ringtail! You\'ve snuck into our pantry for the last time!',26124),
(106699,'enUS','Huh? Where\'s that noise coming from?','Huh? Where\'s that noise coming from?',26124),
(106700,'enUS','I\'m so so sorry...','I\'m so so sorry...',26124),
(106701,'enUS','Thanks to you, I\'m alive and Mangelrath is dead. Let\'s get out of here before more demons arrive.$b$bI think I know a shortcut out of here, follow me!','',26124),
(106702,'enUS','Lead the way. I\'ll be right behind you.','Lead the way. I\'ll be right behind you.',26124),
(106703,'enUS','Follow me, I know a way out!','',26124),
(106704,'enUS','\'Ey, mon! Dis be your place now. All the best digs for da Archdruids!','',26124),
(106705,'enUS','De Cenarion Circle gonna bring de balance to these lands with ye\' here. I be feelin\' it!','',26124),
(106706,'enUS','Zen\'kiki want ta\' be a big an powerful, like you. I be thinkin\', I stay here and be watchin\' over ye place, keep it real good an tidy. Then, sometimes you be teachin\' me some tips.','',26124),
(106707,'enUS','Well, what ye say mon?','',26124),
(106708,'enUS','I admit, I had my doubts. I never believed I\'d see anyone capable of obtaining the weapon you now hold.','',26124),
(106709,'enUS','It\'s rare that I\'m proven wrong. In this case, I\'m pleased that I was.','',26124),
(106710,'enUS','You are already more powerful than many senior members of our order. Still, I sense that even more growth is yet to come.','',26124),
(106711,'enUS','Shan\'do Malfurion awaits. Go, be recognized for your accomplishments.','',26124),
(106712,'enUS','In time, your powers will reach heights undreamed of.','',26124),
(106713,'enUS','It is good to see you, $n. I just heard about your deeds from Remulos. Well done!$b$bIt is time that you are recognized for your deeds in service to the Cenarion Circle.','',26124),
(106714,'enUS','I am ready.','I am ready.',26124),
(106715,'enUS','Your efforts have not gone unnoticed, $n. Time and again you have proven yourself to be one of our finest.','',26124),
(106716,'enUS','The strength, ferocity, and nobility you have shown are without peer. It is time you were honored accordingly.','',26124),
(106717,'enUS','It is my honor to welcome $n as an Archdruid of the Cenarion Circle! May all the creatures of the wilds celebrate your ascension!','',26124),
(106718,'enUS','Uh... you have something attached to your head?','Uh... you have something attached to your head?',26124),
(106719,'enUS','The naga use these parasites to control weaker beings, but I was able to resist it.$B$BWe have formed a symbiotic relationship that allows me to communicate with other beings. Our minds are as one.$B$BTo remove it now would kill both of us.','',26124),
(106720,'enUS','I see.','I see.',26124),
(106722,'enUS','Where I put ore?','',26124),
(106723,'enUS','This ore is heavy and itchy.','',26124),
(106724,'enUS','Where you want this, rogg?','',26124),
(106725,'enUS','','First our outpost is overrun by bears, and now poachers are stealing our bear hides! Could this get any worse?',26124),
(106726,'enUS','','Thanks to your help, we may be able to retake that outpost!',26124),
(106727,'enUS','','Those bears drove us out of our settlement and are tearing through our supplies. Drive them off, and see if you can recover any of our grain while you are there.',26124),
(106728,'enUS','The secrets of the Earth Warder is OURS!','',26124),
(106729,'enUS','','Those bears are so unruly! Thanks!',26124),
(106730,'enUS','','Those bears are so unruly! Thanks!',26124),
(106731,'enUS','Deathwing\'s secrets belong to us now, shan ronir!','',26124),
(106732,'enUS','','The harpies must have cursed these poor bears. How terrible! Please put them out of their misery.',26124),
(106734,'enUS','','Even the hides are unusable. The harpies will pay for this!',26124),
(106736,'enUS','','|TInterface\\Icons\\inv_misc_herb_stormvine:20|t%s begins to emit a |cFFFF0000|Hspell:192985|h[Cry of Wrath]|h|r!',26124),
(106737,'enUS','','|TInterface\\Icons\\inv_misc_herb_stormvine:20|t%s begins to emit a |cFFFF0000|Hspell:192985|h[Cry of Wrath]|h|r!',26124),
(106738,'enUS','','The drogbar have uncovered an ancient knowledge from the days of Deathwing. I can hear the spirits cry out in pain. Please, stop them!',26124),
(106739,'enUS','','This dark ore, this... elementium, it is a weapon that I hope the drogbar never master.',26124),
(106740,'enUS','Alright $glad:lass;, I\'ll meet ya at the entrance. Ye come and find me when ye\'re prepared to go inside.','',26124),
(106745,'enUS','I\'m told you know about an ancient weapon.','I\'m told you know about an ancient weapon.',26124),
(106746,'enUS','She said you know something about an ancient weapon.','She said you know something about an ancient weapon.',26124),
(106747,'enUS','No! We are too late! Zakajz has awakened!','',26124),
(106748,'enUS','The beast seems slow... confused. The sword wounds it still! Quickly, strike it down before it recovers completely!','',26124),
(106749,'enUS','Do you know of a weapon that could help fight the Legion?','Do you know of a weapon that could help fight the Legion?',26124),
(106750,'enUS','I\'m ready, Brann. Let\'s go.','I\'m ready, Brann. Let\'s go.',26124),
(106751,'enUS','You have done what I could not. You defeated Zakajz and lived.','',26124),
(106752,'enUS','You know what needs to be done. Take up the Warbreaker and end the threat of Zakajz once and for all!','',26124),
(106753,'enUS','At last the nightmare is over! I can finally leave this place and be at peace.','',26124),
(106754,'enUS','Elune guide your path, $n.','',26124),
(106755,'enUS','Accordin\' to me notes, it\'s a bit of a trek, but shouldn\'t be too long. Let\'s go!','',26124),
(106756,'enUS','','Emmarel Shadewarden is a noble soul. The tauren of Highmountain have long been allies of the Unseen Path.$b$bTalonclaw, the spear wielded by my ancestor Huln Highmountain, was lost in battle against a fierce nightsaber called Dakarr. Many have tried to retrieve it... all have failed.$b$bOur elders believe recovering Talonclaw is the key to driving the Legion from our lands.$b$bMy brother Wuho and I are heading out to slay the beast and claim the spear. If you were to join us, we\'d be sure to succeed!',26124),
(106757,'enUS','Been workin\' with ol\' Brann Bronzebeard, searchin\' the Broken Isles for any edge against the Legion.$b$bWe\'re close to findin\' the tomb of some vrykul warlord the legends say stole a rifle called Titanstrike. Brann got all excited, goin\' on about how that gun is infused with the power of storms and such!$b$bSounds interestin\', eh? If you\'re up for fetchin\' it, I\'m your dwarf!','',26124),
(106758,'enUS','My commander, Ranger-General Vereesa Windrunner, has uncovered a possible lead as to the whereabouts of her missing sister Alleria.$b$bAlleria\'s knowledge of the Legion would be invaluable to our cause. And the bow she carried with her, Thas\'dorah, is an artifact of awesome power.$b$bTogether, you and the ranger-general can save them both!','',26124),
(106759,'enUS','Those vile harpy skywitches are trying to take our most sacred of artifacts: the Skyhorn. I have sent several squads to stop them, but to no avail. Will you help?','',26124),
(106760,'enUS','Ha ha. That was almost better and bloodier than I would have done! My thanks, champion.','',26124),
(106761,'enUS','','Enough!',26124),
(106762,'enUS','I\'m grateful Lady Shadewarden found you, $n. We have a chance to strike a major blow against the Legion!','',26124),
(106763,'enUS','Beware! Zakajz grows desperate. He may change his tactics!','',26124),
(106764,'enUS','Il\'zarq N\'Zoth phgwa an\'zig. Il\'zarq taag ov\'kadaq.','',26124),
(106765,'enUS','Phnagg\'ba teq\'nir ssq qwal N\'Zoth!','',26124),
(106766,'enUS','Shath\'mag vwyq shu et\'agthu, Shath\'mag sshk ye! Ag\'rr hazz ak\'yel ksh ga\'halahs pahg!','',26124),
(106767,'enUS','Shath\'mag vwyq shu et\'agthu, Shath\'mag sshk ye! Krz\'ek fhn\'z agash zz maqdahl or\'kaaxth\'ma amqa!','',26124),
(106768,'enUS','Sk\'yahf qi\'magg luk sshoq anagg\'qen.','',26124),
(106769,'enUS','Shath\'gral ynyq. Weq... weq... weq...','',26124),
(106770,'enUS','Y\'za noq mah... Y\'za noq ormz...','',26124),
(106771,'enUS','Yeh\'glu N\'Zoth okom hoq... Y\'za sythn oou...','',26124),
(106772,'enUS','Poq\'yith mazzka awan ki uhnish\'philfgsh.','',26124),
(106773,'enUS','En\'othk uulg\'shuul. Mh\'za uulwi skshgn kar.','',26124),
(106774,'enUS','Iilth qi mah\'shar fhn oorql N\'Zoth!','',26124),
(106775,'enUS','Iilth ma paf\'qi\'ag sk\'halahs. GAZ SKSHGN!','',26124),
(106776,'enUS','Mg\'uulwi N\'Zoth, eth\'razzqi worg zz oou.','',26124),
(106777,'enUS','N\'Zoth iiyoq raz\'tal\'vsak! IIYOQ NEL\'OTHK AR\'AFGH!','',26124),
(106778,'enUS','So that lass Emmarel Shadewarden sent you my way? Seems she\'s good as her word, that one.$b$bDon\'t know a thing about this Unseen Path she\'s part of, but I\'m willin\' to hear her out.','',26124),
(106779,'enUS','Al\'ksh syq iir awan? Iilth sythn aqev... aqev... aqev...','',26124),
(106780,'enUS','The voice of N\'Zoth whispers from the deep. It sings of unspeakable horrors.','',26124),
(106781,'enUS','These mortal wards have no effect on the spawn of N\'Zoth!','',26124),
(106782,'enUS','The Black Empire once ruled this pitiful world, and it will do so again! We will reforge our dread citadels atop the fly-blown corpse of this kingdom!','',26124),
(106783,'enUS','The Black Empire once ruled this world, and it will do so again! Your pitiful kind will know only despair and sorrow for a hundred thousand millennia to come!','',26124),
(106784,'enUS','Your soul will wander roads that twist in endless spirals.','',26124),
(106785,'enUS','The Old Ones beckon. Go... go... go...','',26124),
(106786,'enUS','I am not the first... I am not the last...','',26124),
(106787,'enUS','The blood of N\'Zoth runs through me... I cannot die...','',26124),
(106788,'enUS','The crooked serpent with no eyes is watching from the endless sky.','',26124),
(106789,'enUS','There is no light after death. Only a place where even shadows fear to go.','',26124),
(106790,'enUS','You will be the first of many to glimpse the madness of N\'Zoth!','',26124),
(106791,'enUS','You are a prisoner in your own body. A SERVANT OF FEAR!','',26124),
(106792,'enUS','In the writhing shadow of N\'Zoth, all light fades and dies.','',26124),
(106793,'enUS','The will of N\'Zoth is made manifest! IT CANNOT BE CONTAINED!','',26124),
(106794,'enUS','Is this real or an illusion? You are going mad... mad... mad...','',26124),
(106795,'enUS','','You will never ssstop usss. Jandvik will fall!',26124),
(106796,'enUS','','Hey there, friend! We\'re looking for an \"assistant\" to help us test some of these weapons. Interested?',26124),
(106797,'enUS','','Oh good, the prototype made it back in one piece. And, er, you survived too!',26124),
(106798,'enUS','Alright, Dis gonna be good! If you be needin\' something done you just tell Zen\'Kiki.','',26124),
(106799,'enUS','','Hi, $ct!',26124),
(106800,'enUS','','Everything\'s fantastic in the forest, $ct.',26124),
(106801,'enUS','','Good day to you, $ct.',26124),
(106802,'enUS','Jes keep going straight, and then make a right at the end there.','',26124),
(106803,'enUS','Now make a left here, and we\'re pretty much at the end.','',26124),
(106804,'enUS','We\'ve made it! And would you look at that, a titan console! I\'m on it, $glad:lass;. You jes make sure that nothin\' bothers me while I\'m workin\'.','',26124),
(106805,'enUS','I leave my blade to you. Strom\'kar deserves to be wielded in battle, not locked away in a tomb. It was forged by a master swordsmith and imbued with elven magics. I know not whether being buried in that beast for centuries has affected it, but I trust that it will serve you well.','',26124),
(106806,'enUS','','Mylune puffs out her chest assertively, sniffling.',26124),
(106807,'enUS','','We can do this, $n. G\'Hanir is counting on us!',26124),
(106808,'enUS','','I will have this tower, along with the heads of the Gilneans who hold it! Attack!',26124),
(106809,'enUS','','Oh, raspberries! I don\'t know what to do!',26124),
(106810,'enUS','','Our forces prevail! Watch them panic and flee like the dogs they are! For the Horde!',26124),
(106811,'enUS','The Forsaken look weak. This tower is ripe for the taking. Show them what happens to enemies of the Alliance!','',26124),
(106812,'enUS','Their lines break, and their captain falls. This is the sound of Gilnean vengeance! For the Alliance!','',26124),
(106813,'enUS','Drawing Sacred Water','Drawing Sacred Water',26124),
(106814,'enUS','Intruders detected. Initiating termination protocols.','',26124),
(106815,'enUS','Of course you may.$B$BWhat pulls you towards the Dream with such fervor, Shan\'do?','',26124),
(106816,'enUS','I need your blessing so that I may enter the Emerald Dream.','I need your blessing so that I may enter the Emerald Dream.',26124),
(106817,'enUS','Ach! That doesn\'t sound good. Hold that thing off while I finish over here.','',26124),
(106818,'enUS','Almost there, $glad:lass;. Just hold on a bit longer.','',26124),
(106819,'enUS','G\'Hanir has been touched by the Nightmare.','G\'Hanir has been touched by the Nightmare.',26124),
(106820,'enUS','G\'Hanir is in danger? Then there is no time to waste.','',26124),
(106821,'enUS','That\'s it, I got it!','',26124),
(106822,'enUS','The room\'s countermeasures are now armed.','',26124),
(106823,'enUS','Welcome, $n. The trees whispered of your arrival.','',26124),
(106824,'enUS','Loathsome naga have crawled forth from their dark holes beneath the sea. I cannot abide the presence of such corrupt beasts! Show them the meaning of honorable battle.','',26124),
(106825,'enUS','Naga are vile creatures and dangerous if left unchecked. The death you gave them was more noble than they deserved!','',26124),
(106826,'enUS','May Elune guide your path.','',26124),
(106827,'enUS','Finally free... and you will NOT imprison me again.','',26124),
(106828,'enUS','I *crave* the smell of freshly spilled blood. How convenient that you are here.','',26124),
(106829,'enUS','You should have died in Northrend.','',26124),
(106830,'enUS','Another one crushed between my pincers.','',26124),
(106831,'enUS','Too easy an end. How disappointing.','',26124),
(106832,'enUS','Did you expect me to be a simple obstacle, fools?','',26124),
(106833,'enUS','I cannot hear the Lich King... has he abandoned me?...','',26124),
(106834,'enUS','But it is MY destiny to rule Azjol-Nerub...','',26124),
(106835,'enUS','Your strength means NOTHING!','',26124),
(106836,'enUS','I will crush your bones to POWDER!','',26124),
(106837,'enUS','Only scraps will remain!','',26124),
(106838,'enUS','Bleed and die, vermin.','',26124),
(106839,'enUS','Consume their flesh!','',26124),
(106840,'enUS','A feast for my brethren...','',26124),
(106841,'enUS','','Those fiends from Hrydshal have gone too far! The  vrykul there led a brutal raid on Highmountain, taking many captives. Please, help us get our people back!',26124),
(106842,'enUS','','The vrykul have always been bold, but these vile giants have gone too far. Thank you for putting them back in their place.',26124),
(106843,'enUS','','Don\'t worry! $n will fix this, just you wait!',26124),
(106844,'enUS','','Up ahead... that looks like the interrogation area.',26124),
(106845,'enUS','','Be careful. It isn\'t safe in the Dream right now!',26124),
(106846,'enUS','I\'m afraid the Dream is in a worse state than we thought.','',26124),
(106847,'enUS','You still have the moonwater, yes? Good, good! Then you are ready.','',26124),
(106848,'enUS','Now just relax and focus your mind on the Dream. I will guide your spirit from here.','',26124),
(106849,'enUS','I will guide your journey from here. Good luck.','',26124),
(106850,'enUS','Welcome, $p. As a subtlety rogue you specialize in striking from the shadows, dispatching foes quickly and quietly. Let\'s begin your training with your primary attack, Backstab.','',26124),
(106851,'enUS','Use Backstab on this target dummy. Attacking from behind inflicts more damage.','',26124),
(106852,'enUS','Curious Owlkitten reaches a paw out and lightly bats at the cup.','',26124),
(106853,'enUS','Curious Owlkitten stares directly into Val\'Sharah Exile\'s eyes.','',26124),
(106854,'enUS','Curious Owlkitten knocks the cup off the table.','',26124),
(106855,'enUS','','Hey!',26124),
(106856,'enUS','','Val\'Sharah Exile tries to shoo the kitten away.',26124),
(106857,'enUS','','No...!',26124),
(106858,'enUS','','Gah!',26124),
(106859,'enUS','Rogues favor trickery and cunning. And what\'s trickier than attacking before your target sees you coming? Stealth makes you invisible to most enemies. When in Stealth, you open up specialized tactics that can devastate foes.','',26124),
(106860,'enUS','Use Stealth to fade from view.','',26124),
(106861,'enUS','|TInterface\\Icons\\spell_fel_elementaldevastation:20|t Krosus raises his right arm and charges a |cFFFF0404|Hspell:201215|h[Fel Beam]|h|r!','|TInterface\\Icons\\spell_fel_elementaldevastation:20|t Krosus raises his right arm and charges a |cFFFF0404|Hspell:201215|h[Fel Beam]|h|r!',26124),
(106862,'enUS','|TInterface\\Icons\\spell_fel_elementaldevastation:20|t Krosus raises his left arm and charges a |cFFFF0404|Hspell:201215|h[Fel Beam]|h|r!','|TInterface\\Icons\\spell_fel_elementaldevastation:20|t Krosus raises his left arm and charges a |cFFFF0404|Hspell:201215|h[Fel Beam]|h|r!',26124),
(106863,'enUS','Patience...','',26124),
(106864,'enUS','','Yes, brother. *sigh*',26124),
(106865,'enUS','Vrykul scum! I will have my revenge.','Vrykul scum! I will have my revenge.',26124),
(106866,'enUS','Thank the Earth Mother you arrived in time. They had dark plans for us.','Thank the Earth Mother you arrived in time. They had dark plans for us.',26124),
(106867,'enUS','Thank you, Champion. I will find my own way out of here.','Thank you, Champion. I will find my own way out of here.',26124),
(106868,'enUS','The vrykul have grown bold. Be careful.','The vrykul have grown bold. Be careful.',26124),
(106869,'enUS','Time to find some weapons!','Time to find some weapons!',26124),
(106870,'enUS','They hit us hard and fast. I have not seen the vrykul attack like that in many many years.','They hit us hard and fast. I have not seen the vrykul attack like that in many many years.',26124),
(106871,'enUS','I dread to think what they were going to do with us.','I dread to think what they were going to do with us.',26124),
(106872,'enUS','Can you hear me, $n?','',26124),
(106874,'enUS','G\'Hanir rests at the Circle of Spirits above, but it oozes Nightmare into the barrow den. You must hurry before you succumb to the corruption!','',26124),
(106876,'enUS','Another one of Lespin\'s thugs? I have had it with him. My pet will teach you a lesson!','Another one of Lespin\'s thugs? I have had it with him. My pet will teach you a lesson!',26124),
(106878,'enUS','Fine, take it! Just don\'t hurt me any more. The chest is over there.','Fine, take it! Just don\'t hurt me any more. The chest is over there.',26124),
(106879,'enUS','','You must have traveled very far to face me. If it\'s battle you seek, I\'ll happily oblige. Loser buys dinner!',26124),
(106880,'enUS','Need... air...','',26124),
(106881,'enUS','Can\'t breathe...','',26124),
(106882,'enUS','Where... what...','',26124),
(106883,'enUS','Stupid squid!','',26124),
(106884,'enUS','Get off my face!','',26124),
(106885,'enUS','','Good fight! The tribes will sing songs of your bravery. Now, was it the winner who buys dinner, or the loser?',26124),
(106886,'enUS','I am free!','',26124),
(106887,'enUS','Curse these naga!','',26124),
(106888,'enUS','','Can\'t be givin\' in. We must fight!',26124),
(106889,'enUS','','My thanks.',26124),
(106890,'enUS','','The elements be by your side.',26124),
(106891,'enUS','','Keep movin\'!',26124),
(106892,'enUS','Allow me to repay you.','Allow me to repay you.',26124),
(106893,'enUS','I must warn the Warchief at once!','I must warn the Warchief at once!',26124),
(106894,'enUS','The elements guide my blades.','The elements guide my blades.',26124),
(106895,'enUS','These lands... what have they become?','These lands... what have they become?',26124),
(106896,'enUS','I\'ve got to check on the others, but this should help.','I\'ve got to check on the others, but this should help.',26124),
(106897,'enUS','Looks like you could use some help.','Looks like you could use some help.',26124),
(106898,'enUS','My apologies $n, but I must keep moving.','My apologies $n, but I must keep moving.',26124),
(106899,'enUS','I could always use more practice.','I could always use more practice.',26124),
(106904,'enUS','I must warn the others!','I must warn the others!',26124),
(106905,'enUS','$n - I must report these events at once!','$n - I must report these events at once!',26124),
(106906,'enUS','','I thought I was done for!',26124),
(106907,'enUS','','I\'d prefer to avoid these horrors. Let\'s sneak past them!',26124),
(106908,'enUS','My magic is now yours, $n.','My magic is now yours, $n.',26124),
(106909,'enUS','It appears I underestimated the Legion\'s power. Perhaps I may join you?','It appears I underestimated the Legion\'s power. Perhaps I may join you?',26124),
(106910,'enUS','For the Horde!','For the Horde!',26124),
(106911,'enUS','Heh. I could always use a little more practice.','Heh. I could always use a little more practice.',26124),
(106912,'enUS','Blood and Honor!','Blood and Honor!',26124),
(106913,'enUS','','Someone... anyone! I can\'t escape these roots!',26124),
(106914,'enUS','Lost Owlkitten raises its nose to the air and chirps in recognition of its surroundings.','',26124),
(106915,'enUS','Where you go, munchy feathers?','',26124),
(106916,'enUS','Lunch, where are you?','',26124),
(106917,'enUS','HUNGRY.','',26124),
(106918,'enUS','Where meat?!','',26124),
(106919,'enUS','Want eat Feathermane!','',26124),
(106921,'enUS','We\'ve arrived!','',26124),
(106922,'enUS','Torok\'s son, Mellok, is rallying the Feltotem against us. Stifle their efforts before they can invade Stonedark Cavern!','',26124),
(106923,'enUS','The Bloodtotem will regret taking the offer of their demonic masters.','',26124),
(106924,'enUS','','The Feltotem work to open a portal at Torok\'s Bluff. What they plan to bring through, I hope I never know.',26124),
(106925,'enUS','','Thank you. You were able to stop them before anything could come through.',26124),
(106926,'enUS','','Now the Feltotem corrupt their own waters to turn even nature against us.',26124),
(106927,'enUS','','You stopped the spread of fel corruption before it could reach our waters. We are ever in your debt.',26124),
(106928,'enUS','','The path is blocked! I think I can clear it out.',26124),
(106930,'enUS','Use Shadowstrike to attack the target dummy.','',26124),
(106931,'enUS','','That did it! You go on ahead. I\'ll deal with things down here.',26124),
(106932,'enUS','Now that you\'ve built up 5 combo points, it\'s time to Eviscerate. Whenever you Eviscerate with 5 combo points, you will do massive damage and immediately enter stealth.','',26124),
(106933,'enUS','Use Eviscerate with 5 combo points.','',26124),
(106934,'enUS','Why is there always an extra screw? It must go somewhere...','',26124),
(106939,'enUS','Let\'s go!','Let\'s go!',26124),
(106940,'enUS','Curse you! This is going to take hours to fix!','',26124),
(106941,'enUS','|TInterface\\Icons\\Spell_Fire_FelFlameStrike:20|t Krosus targets you with an |cFFFF0404|Hspell:205344|h[Orb of Destruction]|h|r!','|TInterface\\Icons\\Spell_Fire_FelFlameStrike:20|t Krosus targets you with an |cFFFF0404|Hspell:205344|h[Orb of Destruction]|h|r!',26124),
(106942,'enUS','Are you alright? I think you\'re past the worst of it.','',26124),
(106943,'enUS','You\'re nearly there! Just stay focused!','',26124),
(106944,'enUS','The harpies are swarming the nesting grounds of our eagle allies. They want a fight? Ha! We will give them a fight!','',26124),
(106945,'enUS','I imagine you have heard of Huln Highmountain, but have you heard the story of the rest of the tribes? They too were champions of the War of the Ancients.','',26124),
(106946,'enUS','Show me their story.','Show me their story.',26124),
(106947,'enUS','Haha! Well done, Champion. That should show those sky hags a thing or two.','',26124),
(106948,'enUS','','Rocko is back! Whenever he grows too big, it triggers nasty earthquakes. Shaving off a bit of shale every now and then keeps him stable. You mind helping out?',26124),
(106949,'enUS','','That should knock him down to size!',26124),
(106950,'enUS','YOUR POWER WILL BE MINE!','',26124),
(106951,'enUS','You\'re learning how to paint with a dagger. Now it\'s time to perfect your art.','',26124),
(106952,'enUS','Shadowstrike to a target, generate 5 combo points with Backstab, and finish them with Eviscerate. That should leave you in stealth, ready to Shadowstrike to your next target.','',26124),
(106953,'enUS','Apologies, $n. I had to wake you before you fell too deeply.','',26124),
(106954,'enUS','Take care! I can feel the Nightmare encroaching on your mind!','',26124),
(106955,'enUS','I urge you to be cautious. You must not let the Nightmare overcome you.','',26124),
(106956,'enUS','','Good to see you made it, $n. We need only a few more things before we can begin.',26124),
(106957,'enUS','','Calm your mind, let go and your spirit will enter into the Dream. I\'ll join you soon.',26124),
(106958,'enUS','The skies... Infernals - INCOMING!','',26124),
(106959,'enUS','','Drink this vial of moonwell water, it\'ll help you relax so you can enter the Dream. Then lay down in front of the stone and we can begin.',26124),
(106960,'enUS','My kin are safe and the seawarden is dead. I will return to Jandvik now.','',26124),
(106961,'enUS','Fel artillery! Spread out!','',26124),
(106962,'enUS','DO NOT LOCALIZE','DO NOT LOCALIZE',26124),
(106963,'enUS','Fools! While your petty outpost was under attack our forces spread across your sacred lands!','',26124),
(106964,'enUS','Trifling mortals! It is time you felt the power of the Burning Legion!','',26124),
(106965,'enUS','Monstrosity! East gate needs reinforcements!','',26124),
(106966,'enUS','For the Horde!','For the Horde!',26124),
(106967,'enUS','For the Warchief!','For the Warchief!',26124),
(106968,'enUS','Hold the lines! Nothing gets through!','Hold the lines! Nothing gets through!',26124),
(106969,'enUS','The Doomhammer is somewhere in these chambers. I can feel it.','',26124),
(106970,'enUS','Scout the chambers ahead... I will stay nearby...','',26124),
(106971,'enUS','The Inquisition sees all! Every truth! Every lie!','',26124),
(106974,'enUS','You think you can best my snails?','',26124),
(106975,'enUS','All the more reason to get to the Doomhammer first.','',26124),
(106976,'enUS','At least dead snails are delicious.','',26124),
(106977,'enUS','You just got snailed!','',26124),
(106978,'enUS','Ooh! Dinner!','',26124),
(106979,'enUS','I\'ll save him for later.','',26124),
(106980,'enUS','Looks like he\'s cooked.','',26124),
(106981,'enUS','You have a little slime on your face.','',26124),
(106982,'enUS','Too slow!','',26124),
(106984,'enUS','If you\'re done with that one, it\'d make a great stew!','',26124),
(106986,'enUS','Hurry, roggs. We can\'t hold here forever.','',26124),
(106987,'enUS','Search faster, roggs.','',26124),
(106988,'enUS','Quick, roggs. Find what you\'re looking for or forget it.','',26124),
(106989,'enUS','Hurry. The ronir and their pet, $p, will be here soon.','',26124),
(106990,'enUS','Grab and go! Grab and go! We\'re leaving now!','',26124),
(106991,'enUS','Two trainers enter. One leaves a winner. The other has dinner.','',26124),
(106992,'enUS','That is far enough, ronir lovers. You ain\'t gonna pass.','',26124),
(106993,'enUS','','Keep your eyes on Thrall. He\'s wounded. He\'s likely to kill himself down here, and I don\'t wanna be the one who has to tell his wife!',26124),
(106994,'enUS','Doomhammer... it felt like dead weight in my hands. The elements were silent. It has been this way since I used it to slay Garrosh.','',26124),
(106995,'enUS','Your legion is no match for an orc and his people, demon!','',26124),
(106996,'enUS','','By the Light... There! It\'s her bow! Thas\'dorah!',26124),
(106997,'enUS','','Alleria was here... her bow\'s presence is the proof! Doubtless she escaped, and the Inquisitor sought to use me to lure her back.',26124),
(106998,'enUS','','This is a bow worthy of a hero like Alleria... a hero like you. Take Thas\'dorah, $n. Use it to lead the fight to save Azeroth!',26124),
(106999,'enUS','Trifling mortals! Your arrogance will be your undoing!','',26124),
(107000,'enUS','Another will take my place. Your world is doomed...','',26124),
(107001,'enUS','IN-FER-NO!','',26124),
(107002,'enUS','We\'ve got to keep moving. Geth\'xun is close...','',26124),
(107003,'enUS','','Please help! I can\'t hold the corruption back much longer!',26124),
(107004,'enUS','','I would have surely been overwhelmed if you had not arrived. Thank you.',26124),
(107005,'enUS','','Let us reconvene in the physical world.',26124),
(107006,'enUS','Saving','Saving',26124),
(107007,'enUS','By the Ancients, you have it! You have G\'Hanir!','',26124),
(107008,'enUS','G\'Hanir will not last much longer. It must be cleansed!','',26124),
(107009,'enUS','We must aid Bashana in cleansing the remaining Nightmare. G\'Hanir\'s fate rests with Lyessa and $p.','',26124),
(107010,'enUS','The Doomhammer! Get the Doomhammer! Prove your power as a shaman...','',26124),
(107013,'enUS','You have been energized by the Azuregale Zapper!','',26124),
(107014,'enUS','You are just in time for the Legion\'s first strike on Dalaran. These prisoners will paint the city streets red with blood. It\'s a shame you won\'t be alive to see it happen.','',26124),
(107015,'enUS','The fall of Dalaran begins here. These prisoners will stain the streets red with blood. And when they\'re done, the Legion will bring this city crashing to the ground!','',26124),
(107016,'enUS','Your armor might protect you from blade and claw, but it is useless against this Faceless One. With a mere whisper, it can drive a mortal mind to madness.','',26124),
(107017,'enUS','I have witnessed horrors that would put your darkest nightmares to shame, but I have never seen anything as terrifying as THIS... an angry gnomish inventor.','',26124),
(107018,'enUS','I sense great fury and bitterness in this gnome. She has kept these feelings bottled up for so long... It is only a matter of time before she explodes.','',26124),
(107019,'enUS','Even with magical wards in place, I can still smell the reek of this wretched Abomination. Do the world a favor and dispose of it, will you?','',26124),
(107020,'enUS','Reinforcements are here! Push them back!','',26124),
(107021,'enUS','Ah... even I have heard of Shivermaw, the fallen blue dragon once known as Eldragosa. She will be perfect for terrorizing the skies of Dalaran.','',26124),
(107022,'enUS','Blood-Princess Thal\'ena... You must be hungry after all these years in prison. Go and slake your thirst on the blood and souls of Dalaran!','',26124),
(107023,'enUS','The San\'layn are cold and arrogant creatures. They inflict pain for pure entertainment. All in all, they sound like my kind of people.','',26124),
(107024,'enUS','Crypt lords do not take defeat well. Being locked in this prison will have made this one angry... Very, VERY angry.','',26124),
(107025,'enUS','The whole of Azeroth will rise against you, demon.','',26124),
(107026,'enUS','Come now, Anub\'esset! You call yourself a great crypt lord, and you can\'t even burrow your way out of this prison? Show us why you are to be feared!','',26124),
(107027,'enUS','The very earth beneath your feet and the skies above your head will lash out against your damned crusade!','',26124),
(107028,'enUS','I expected more from these prisoners. If they cannot break you, then I will.','',26124),
(107029,'enUS','Enough! These prisoners are useless. As the old saying goes: \"If you want to destroy a floating city the right way, you have to do it yourself.\"','',26124),
(107030,'enUS','The rest of Dalaran will join you soon.','',26124),
(107031,'enUS','Not as easy as the prisoners, am I?','',26124),
(107032,'enUS','Another so-called hero falls to the Legion!','',26124),
(107033,'enUS','And now to cast this lofty city from the skies...','',26124),
(107034,'enUS','After Dalaran falls, what hope does the world have?','',26124),
(107035,'enUS','Pity... I will not see the world... burn...','',26124),
(107036,'enUS','You will fall... sooner or later...','',26124),
(107037,'enUS','These are fanatics, believing this Vault holds one of their greatest legends: The Grey One.','',26124),
(107038,'enUS','The Grey One was a drogbar so evil, Neltharion encased him in stone as a lesson to us all. We must not let these zealots free him.','',26124),
(107039,'enUS','Crok! The Grey One has been unleashed. We must get out of here before the vault\'s defenses return.','',26124),
(107042,'enUS','This device appears to draw upon the void energy released when Malygos forced Azeroth\'s ley lines into the Twisting Nether.','',26124),
(107043,'enUS','The Doomhammer chose you, shaman. Already you wield it with a power that I never tapped into.','',26124),
(107044,'enUS','I must go my own way. I have a great deal of thinking to do. Aggra will be at the Maelstrom shortly. Listen to her counsel... she has taught me so much.','',26124),
(107045,'enUS','Go back to the Earthen Ring. Bring them together. Turn their might against the Legion. This is your time.','',26124),
(107046,'enUS','The design looks very familiar...','',26124),
(107047,'enUS','This weapon has been infused with dark energies from the Twisting Nether.','',26124),
(107048,'enUS','Whoever wielded it must be seeking to harness void energy. But for what purpose?','',26124),
(107049,'enUS','This portal is very similar to ones used by the ethereals in Outland.','',26124),
(107050,'enUS','Could they be the threat? What did Malygos promise them?','',26124),
(107053,'enUS','Chuang!','',26124),
(107054,'enUS','','Uncle!',26124),
(107055,'enUS','Li Li, let\'s go check on the little ones.','',26124),
(107056,'enUS','','Right behind you, Uncle Chen!',26124),
(107057,'enUS','G\'Hanir grows more corrupt with each passing moment. May your feet carry you swiftly!','',26124),
(107059,'enUS','Hamuul Runetotem led a small party to investigate Legion activity near Nordrassil not long ago. He may be able to aid you.','',26124),
(107060,'enUS','Slay them all... for Jandvik...','',26124),
(107061,'enUS','','May the ancients bless us all.',26124),
(107062,'enUS','','Once G\'Hanir is pure again, we can help Archdruid Greathelm cleanse any remaining Nightmare at the Dreamgrove.',26124),
(107063,'enUS','','I only hope we are not too late to save G\'Hanir.',26124),
(107064,'enUS','You are too late, karkrun! The Grey One shall be free!','',26124),
(107065,'enUS','','The drogbar are assaulting Thunder Totem and too many of my forces have been drawn off to engage with the Legion. Can you assist us, champion?',26124),
(107066,'enUS','','This was a costly lesson in not overextending my forces. I appreciate your help, champion.',26124),
(107067,'enUS','To the center of town! Mount up! We fight as one!','',26124),
(107068,'enUS','For the Horde!','',26124),
(107069,'enUS','$n... thank the Ancients you\'ve come.','',26124),
(107070,'enUS','Those depraved murlocs keep finding new ways of sinking ships! I\'m sure recovering supplies from those shipwrecks would be appreciated.','',26124),
(107071,'enUS','I try so hard to set murlocs on the right path. With the wrong leaders, they can get ouf of control quite quickly.','',26124),
(107072,'enUS','The Swamprock are up to no good again! That crab rider leads them to do rather dreadful deeds.','',26124),
(107073,'enUS','It makes me shudder to think what you had to do to those poor things, but it could not be avoided.','',26124),
(107074,'enUS','Murky needs your help! The Clackbrine amass in great numbers and are likely to attack Murky\'s hard-won lair.','',26124),
(107075,'enUS','With your direction, Murky and his tadpole tribe are safe once again.','',26124),
(107076,'enUS','All of the tadpoles Murky recruited are getting hungry! We\'re in luck, though. A crab migration has begun, and their meat is so sweet! Not that I would know...','',26124),
(107077,'enUS','You can hear the squeals of delight from the tadpole cave. They\'ll grow big and strong!','',26124),
(107078,'enUS','A massive Clackbrine has risen to power on the coast. But I don\'t think Murky is quite strong enough to defeat it without some extra help!','',26124),
(107079,'enUS','Murky is great at learning new tricks! He sometimes forgets what I teach him just as easily, though.','',26124),
(107080,'enUS','What brings a follower of Cenarius to my lair?','',26124),
(107081,'enUS','The witches of the forest are getting too bold. They leave their woods and attack my people while we hunt down the Feltotem.','',26124),
(107082,'enUS','Those foul harpies better stick to the trees, or we\'ll make sure a sea of feathers and witch blood carpets the forest floor.','',26124),
(107083,'enUS','','Such devastation...',26124),
(107084,'enUS','The darkness gonna take you!','',26124),
(107085,'enUS','Don\'t mess with the mountain!','',26124),
(107086,'enUS','Puny karkun! Shouldn\'t be here!','',26124),
(107087,'enUS','Shan ronir! Go kiss a tauren!','',26124),
(107088,'enUS','The stone answers to me!','',26124),
(107089,'enUS','That blood of yours will do fine...','',26124),
(107090,'enUS','Die, shan ronir!','',26124),
(107091,'enUS','We are the darkness beneath the mountain!','',26124),
(107092,'enUS','You will fear the deep dark!','',26124),
(107093,'enUS','Darkness take you!','',26124),
(107094,'enUS','Stone! Obey me!','',26124),
(107095,'enUS','Foolish karkun! Let\'s see how fast you die!','',26124),
(107096,'enUS','','The vision is chaotic, unfocused. I need to concentrate.',26124),
(107097,'enUS','','I will need to focus on the vision to understand its message. Guard me while I do this, $n.',26124),
(107098,'enUS','Yes, Tyrande.','Yes, Tyrande.',26124),
(107099,'enUS','They were... too much...','',26124),
(107100,'enUS','What happened here?','What happened here?',26124),
(107101,'enUS','We were sent to clear out a stray pack of fel hounds. But what we found...','',26124),
(107102,'enUS','The gates of hell poured forth upon us. They were everywhere...','',26124),
(107103,'enUS','Tend to the others first. Their wounds are more dire than my own.','',26124),
(107104,'enUS','','Skylord, you must inform the Dreamgrove. We will ensure no further life is lost this day.',26124),
(107105,'enUS','','No!',26124),
(107106,'enUS','','What have you done with Alleria, monster?',26124),
(107107,'enUS','Speak, $r. Why have you disturbed my rest?','',26124),
(107108,'enUS','','Was she here for days? Years? Centuries? The mage was right... time has little meaning in this place.',26124),
(107109,'enUS','<The ancient stares at you expectantly.>','',26124),
(107110,'enUS','Ronir! Today is the day you die!','',26124),
(107111,'enUS','Thank you, $n. We barely survived their last attack.','',26124),
(107114,'enUS','','Oh, my head... I feel dizzy...',26124),
(107115,'enUS','The Legion has not forgotten their defeat here.','',26124),
(107116,'enUS','','The well was nearly lost during the assault. But so long as a single drop remains, there is hope!',26124),
(107118,'enUS','','Ash\'alah, to me.',26124),
(107119,'enUS','','Do not let anything disturb my meditation. I must see through the chaos.',26124),
(107120,'enUS','','Bless ya, $n. I could feel me soul returnin\' to da loa.',26124),
(107121,'enUS','Are you certain you are ready? This will be your most difficult task.','',26124),
(107122,'enUS','I am prepared!','I am prepared!',26124),
(107123,'enUS','','His location is still unclear, but he lives.',26124),
(107124,'enUS','','We must go deeper into the nightmare. Wherever he is, peril is already upon him!',26124),
(107125,'enUS','','I see... swirling red mist. Gnashing teeth.',26124),
(107126,'enUS','','Malfurion! He is in pain! Keep fighting, my love!',26124),
(107127,'enUS','','Such malevolent laughter... Xavius, you cruel creature! I am coming for you!',26124),
(107128,'enUS','','I only pray that we are not too late.',26124),
(107129,'enUS','','$p, you must save our injured. I will prepare the cleansing ritual.',26124),
(107130,'enUS','','I am ready to begin the ritual, $n!',26124),
(107131,'enUS','','Preparations are complete. We are ready to begin.',26124),
(107132,'enUS','','This land belongs to the Wormtalon! Squaaaaak!',26124),
(107133,'enUS','','Meet me back at the refuge and we will continue our search.',26124),
(107134,'enUS','There\'s just one last thing you need to learn. Sometimes a strategic retreat is necessary so you can live to fight another day. Vanish allows you to disengage from combat and make a quick getaway.','',26124),
(107135,'enUS','Use Vanish to evade this brute.','',26124),
(107136,'enUS','The fish in this area swim up river to... well, I\'m not sure, but they seem very excited about it. Great time for spear fishing!','',26124),
(107137,'enUS','','Come. We must make haste.',26124),
(107138,'enUS','You didn\'t miss a single one! How long have you been fishing, brul?','',26124),
(107139,'enUS','Barracuda in the north sea are meaty, but hard to reach. Sometimes one of the tauren shaman can help you with a water walking spell.','',26124),
(107140,'enUS','Mmm... black barracuda. Delicious with snails and onions.','',26124),
(107141,'enUS','The first trial will test your might against the strongest of my followers. Show me that you possess the strength of the bear!','',26124),
(107142,'enUS','','The path splits. Wait, do you see that?',26124),
(107143,'enUS','','Feathers and blood... It is still wet! There may still be time!',26124),
(107144,'enUS','','The corruption is thick here. What is that across the bridge? Be on guard.',26124),
(107145,'enUS','','Elothir? By Elune... not you too! Have you seen my husband?',26124),
(107146,'enUS','Find Brytag... kill the naga...','',26124),
(107147,'enUS','','I will prepare the well\'s waters for the cleansing.',26124),
(107148,'enUS','','You must protect me until the ritual is complete, or G\'Hanir will be lost!',26124),
(107149,'enUS','That creature unworthy of great Ursol! I crush it!','',26124),
(107150,'enUS','Too... strong! Stop! No more fight!','',26124),
(107151,'enUS','You\'ve proven your strength. But do you possess the courage to face overwhelming odds? Tell me if you wish to test yourself!','',26124),
(107152,'enUS','Who\'s ready for a snail fight? I, Odrogg, ultimate snail fighting champion, am accepting challengers for a limited time only!','',26124),
(107153,'enUS','This is unbrulievable! You are the true champion!','',26124),
(107154,'enUS','Before you awaits your next trial. Defeat the spirits and prove you possess the courage of the bear!','',26124),
(107155,'enUS','Magnificent! Your courage is undeniable! A final trial awaits you.','',26124),
(107156,'enUS','Ursoc and I fought as a team. He would strike and I would guard his side. Together, we were unstoppable.','',26124),
(107157,'enUS','Once during the chaos of an ancient battle, my brother and I became separated. I failed to be at his side when he needed me most.','',26124),
(107158,'enUS','For this trial, you must prove that you can protect those who entrust you with their lives. Show me that you can succeed where I once failed.','',26124),
(107159,'enUS','','You\'ve crawled back here to try and ssstop me? You are very bold... or very ssstupid.',26124),
(107160,'enUS','This one will be your charge. Guard her, or she will quickly be overwhelmed.','',26124),
(107162,'enUS','','Somethin\' ain\'t right. Da spirits be cryin\' out.',26124),
(107163,'enUS','The gateway is activating!','',26124),
(107164,'enUS','Tremble before me! I bring darkness to this world.','',26124),
(107165,'enUS','','He lives, and so I will continue deeper into the Nightmare.',26124),
(107167,'enUS','A Legion ship approaches! Stand ready! If we lose the Barrens, all of Kalimdor will fall!','',26124),
(107168,'enUS','','What isss that...',26124),
(107169,'enUS','','You will sssuffer for that!',26124),
(107170,'enUS','This next trial will not be easy, $c. Are you up to the challenge?','',26124),
(107171,'enUS','IGC - Corruption of Ysera','IGC - Corruption of Ysera',26124),
(107172,'enUS','Let\'s do this!','Let\'s do this!',26124),
(107173,'enUS','So that lass Emmarel Shadewarden sent you my way? Seems she\'s good as her word, that one.$b$bDon\'t know a thing \'bout this Unseen Path she\'s part of, but I\'m willin\' to hear her out.$b$bI may not be used to workin\' with you Horde folk, but the Legion\'s got it in for all of us, dwarf and $r alike.$b$bTime to put differences aside, I say!','',26124),
(107174,'enUS','The trees whisper his name, but their words are madness to my ears!','',26124),
(107175,'enUS','','You must help me find him! Is there anything I can do?',26124),
(107176,'enUS','You may not, but perhaps... your mother moon can.','',26124),
(107177,'enUS','Yet more evidence of ethereal technology. This may be an unfortunate turn.','',26124),
(107178,'enUS','There\'s only one way to find out who\'s really behind this.','',26124),
(107179,'enUS','We must move quickly. Speak with Mylra and follow me into the Maelstrom.','',26124),
(107180,'enUS','Rehgar has a plan. Speak with him. He\'s good to have at your back in a fight.','',26124),
(107181,'enUS','Erunak is familiar with the darkest depths of Azeroth\'s oceans. He will know how best to proceed.','',26124),
(107182,'enUS','','There\'s no place you can hide from me, Millhouse! No place!',26124),
(107183,'enUS','','I will petition Elune. The Nightmare stain cannot be removed.... but perhaps we can hold it back.',26124),
(107184,'enUS','Long enough... to seek him out... *Elothir groans* The forest speaks... I can almost understand...','',26124),
(107185,'enUS','','Hold yourself on the edge of madness, Elothir! Mother moon will carry you as long as she can.',26124),
(107186,'enUS','Malfurion approaches the heart of the corruption! Quickly, Tyrande, to Shala\'nir! There is no time!','',26124),
(107187,'enUS','','I will go to him! Elothir?',26124),
(107188,'enUS','The madness... claims me...','',26124),
(107189,'enUS','','Thas\'dorah began as my family\'s legacy... but now this weapon has a greater purpose.',26124),
(107190,'enUS','<Elothir\'s form is unresponsive. The Nightmare has taken hold.>','',26124),
(107191,'enUS','<Elothir\'s inert form stares blankly into the distance.>','',26124),
(107192,'enUS','<Elothir appears completely unaware of his surroundings.>','',26124),
(107193,'enUS','','<Vanessa eyes you up and down warily.>',26124),
(107194,'enUS','','Are you ready to settle this for good?',26124),
(107195,'enUS','So be it.','So be it.',26124),
(107196,'enUS','Who dares to...? Ah, what have we here?','',26124),
(107197,'enUS','Another intruder come to claim the treasures of the Nexus Vault!','',26124),
(107198,'enUS','You are too late, $c! Even now the powers within the vault serve to widen the breach into the Twisting Nether.','',26124),
(107199,'enUS','With this power, the Ethereum will become unstoppable. We will become void!','',26124),
(107200,'enUS','Whatever the ethereals are up to is generating an incredible amount of void energy.','',26124),
(107201,'enUS','They must be using Malygos\'s Surge Needles. Fly over to one and let\'s take a closer look.','',26124),
(107202,'enUS','The Ethereum have altered the Surge Needles. They are tapping into void energy caused by the rift.','',26124),
(107203,'enUS','Their power must also be feeding the shield around the Nexus. Let us take a look at the foundation.','',26124),
(107204,'enUS','The vault must be weakened. The energy from your weapon is breaking its way free.','',26124),
(107205,'enUS','This may work to our advantage...','',26124),
(107206,'enUS','If you keep us alive, we will buy you the time you need.','',26124),
(107207,'enUS','For G\'Hanir!','',26124),
(107208,'enUS','','Elothir is beyond our reach now.',26124),
(107209,'enUS','','Shala\'nir is just ahead. Be ready for whatever foulness awaits us.',26124),
(107210,'enUS','','I am coming Malfurion!',26124),
(107211,'enUS','The creature shakes its head, coming to its senses!','',26124),
(107212,'enUS','%s has |cFFFF0404fallen in battle|h|r and cannot fight!','%s has |cFFFF0404fallen in battle|h|r and cannot fight!',26124),
(107213,'enUS','Bind his arms! Do not let him cast- AGH!','',26124),
(107214,'enUS','','I hear a struggle by the gazebo! Malfurion?! Answer me!',26124),
(107215,'enUS','Hah! Claim him if you can, Night Elf!','',26124),
(107216,'enUS','The sky is clear, the horses are out, it is a perfect day for a hunt!','',26124),
(107217,'enUS','Horses! Bah! I\'ll be goin\' for the mushan. Let\'s see who brings in the finer kill.','',26124),
(107218,'enUS','You WILL succumb, druid!','',26124),
(107219,'enUS','NEVER!','',26124),
(107220,'enUS','Reinforcements incoming! Clear a path for their arrival!','',26124),
(107221,'enUS','','I will NOT lose you!',26124),
(107222,'enUS','The demon\'s assault is relentless. I require aid!','',26124),
(107223,'enUS','Ready up! We have incoming!','',26124),
(107224,'enUS','In Mannoroth\'s name!','',26124),
(107225,'enUS','Feast on their flesh.','',26124),
(107226,'enUS','Now that\'s a trophy to be proud of!','',26124),
(107227,'enUS','In our lands we hunt for food. I do not envy you eating that much mushan meat.','',26124),
(107228,'enUS','Lambs to the slaughter.','',26124),
(107229,'enUS','Your life slips away.','',26124),
(107230,'enUS','All shall burn!','',26124),
(107231,'enUS','Tremble!','',26124),
(107232,'enUS','%s begins to cast |cFFFF0404|Hspell:204839|h[Demonwrath]|h|r!','%s begins to cast |cFFFF0404|Hspell:204839|h[Demonwrath]|h|r!',26124),
(107233,'enUS','%s begins to cast |cFFFF0404|Hspell:204839|h[Chaos Bolt Barrage]|h|r!','%s begins to cast |cFFFF0404|Hspell:204839|h[Chaos Bolt Barrage]|h|r!',26124),
(107234,'enUS','To arms!','',26124),
(107235,'enUS','Hahahaha!','',26124),
(107236,'enUS','','No!',26124),
(107237,'enUS','','That elderhorn calf is in danger! You have to help it!',26124),
(107238,'enUS','Ain\'t no way dem demons gonna be takin\' de Crossroads.','',26124),
(107239,'enUS','','My blade is ready!',26124),
(107240,'enUS','','My blade could use a little practice.',26124),
(107241,'enUS','I\'ve got eyes from the tower! Spread out!','I\'ve got eyes from the tower! Spread out!',26124),
(107242,'enUS','','That was close! I will raise the calf here at Thunder Totem until it can fend for itself.',26124),
(107243,'enUS','<Punch the Satyr.>','<Punch the Satyr.>',26124),
(107244,'enUS','Somebody gonna be needin\' our help.','',26124),
(107245,'enUS','','Zumolo, come with me! They\'ll need us at the north gate.',26124),
(107247,'enUS','Ha! That\'ll teach that antler headed eagle rider a thing \'er two about huntin\'.','',26124),
(107248,'enUS','The time has come, Chintoka. Let us prepare for battle.','',26124),
(107249,'enUS','Very good. Those stallions will feed many of our eagles. I knew you would see things my way.','',26124),
(107250,'enUS','','Taste my axe!',26124),
(107251,'enUS','','By blades of steel your kind will fall!',26124),
(107252,'enUS','','These are our lands!',26124),
(107253,'enUS','The contents of the nearby books are in tatters. It appears as if a cyclone moved through the inn quite recently.','The contents of the nearby books are in tatters. It appears as if a cyclone moved through the inn quite recently.',26124),
(107254,'enUS','You are no match for the Horde!','',26124),
(107255,'enUS','My magic will consume you!','',26124),
(107256,'enUS','Your corruption ends here.','',26124),
(107257,'enUS','Foul wretch!','',26124),
(107258,'enUS','Shadows consume you!','',26124),
(107259,'enUS','','You will not ruin our lands!',26124),
(107260,'enUS','','Your powers are no match for the elements!',26124),
(107261,'enUS','More target practice.','',26124),
(107262,'enUS','','I can feel the well growing in strength. We must push forward!',26124),
(107263,'enUS','','The power grows with every moment. This day will be ours!',26124),
(107264,'enUS','The shadow... is lifted?','',26124),
(107265,'enUS','What little mind is this I sense, that has freed my consciousness from the ethereals\' trap?','',26124),
(107267,'enUS','','We have done it! The Mother Tree is whole once more!',26124),
(107268,'enUS','','$n, use G\'Hanir to call upon the spirits of the forest to destroy this fiend!',26124),
(107269,'enUS','','The ritual is nearly complete. Do not give up hope!',26124),
(107270,'enUS','','Ysera - no!',26124),
(107271,'enUS','','Come with me. Ysera won\'t stop until this whole realm is plunged into the Nightmare.',26124),
(107272,'enUS','','Xavius is using Malfurion to bait me, to distract me from what must be done. We are the only ones who can stop Ysera.',26124),
(107273,'enUS','','Ah, Malfurion, my beloved! For a hundred hundred years he slept beneath Moonglade.',26124),
(107274,'enUS','Our reinforcements approach. Prepare yourselves!','',26124),
(107275,'enUS','','Harpies from the Haglands are unleashing their perverse magic upon wildlife in the Screeching Crag. We don\'t know how to counter their curses. Please, stop this madness!',26124),
(107276,'enUS','','Long ago the harpies of these mountains lost any respect they had for life. Now they practice their dark rituals no matter who it hurts.',26124),
(107277,'enUS','Chen said you would come, $n. There\'s no time to waste. Help us fight back these demons and reclaim the monastery!','',26124),
(107278,'enUS','','Deprecated.',26124),
(107279,'enUS','','This world will never fall, demon! Nature itself will rise against you!',26124),
(107280,'enUS','Pitiful worms. What trickery is this?','',26124),
(107281,'enUS','Find the invaders! Retake the cathedral! Slaughter them all!','',26124),
(107282,'enUS','','I know Alleria\'s bow is in the right hands.',26124),
(107289,'enUS','Ah yes, now I remember.','',26124),
(107290,'enUS','Nice find!','',26124),
(107291,'enUS','Lessah is a good teacher, but you are even better!','',26124),
(107292,'enUS','Very interesting...','',26124),
(107293,'enUS','Aha! There it is!','',26124),
(107294,'enUS','Ooh, what is that ?','',26124),
(107295,'enUS','I think I am starting to get it now.','',26124),
(107296,'enUS','Well done. Let us see what we found.','',26124),
(107297,'enUS','So many places, so little time. If you have somewhere special to go, I can take you.','',26124),
(107298,'enUS','Can you take me to Tian Monastery?','Can you take me to Tian Monastery?',26124),
(107299,'enUS','Wait until you have 5 combo points to use Eviscerate!','',26124),
(107300,'enUS','You have 5 Combo Points. Use Eviscerate!','',26124),
(107301,'enUS','Ranger-General Windrunner! Did you find...','',26124),
(107302,'enUS','Use Backstab to generate combo points.','',26124),
(107303,'enUS','','Alleria was gone, but we recovered Thas\'dorah! It is now in the hands of our champion.',26124),
(107304,'enUS','Amazing! The bow will inspire every ranger who sees it!','',26124),
(107305,'enUS','','Sadly, Orestes was lost. I should send word to Halduron. Come, Larkspur.',26124),
(107306,'enUS','At once!','',26124),
(107307,'enUS','I WILL DESTROY YOU!','',26124),
(107308,'enUS','YOUR WORLD WILL... BURN...','',26124),
(107309,'enUS','','It is done! Let us all return to the Dreamgrove and tell the others of our triumph.',26124),
(107310,'enUS','We must stay behind for a time to aid Skylord Omnuron\'s forces.','',26124),
(107311,'enUS','Thank you, $n. Without you, we would have surely fallen.','',26124),
(107312,'enUS','','Let these wingless creatures feast upon themselves.',26124),
(107313,'enUS','','Hurry my sisters, before the wretched tribes discover our plan.',26124),
(107314,'enUS','','Move quickly, sisters. We must finish the spell so that no outsider or tauren can break it\'s hold!',26124),
(107315,'enUS','','These wingless creatures shall be ours to command.',26124),
(107316,'enUS','','The fools of Rivermane will never expect the wilds to turn on them so violently.',26124),
(107317,'enUS','','No, sister. Set the hex correctly. As the Witchqueen commanded.',26124),
(107318,'enUS','The brood of Nithogg kill my kind and yours without mercy or remorse. Meet their cruelty in kind! Rend the scales from their hide!','',26124),
(107319,'enUS','Now yer talkin! Biggest skull wins the wager.','',26124),
(107320,'enUS','Nithogg and his brood are killers and murderers of the worst sort. You have done the world a service by disposing of them.','',26124),
(107321,'enUS','Must chap yer hide that ya got upstaged so easily. Ha!','',26124),
(107322,'enUS','','Great Ursol, wise bear of the woods, this daughter of the wilds calls to you! Please accept these humble offerings and grant us an audience!',26124),
(107323,'enUS','The demons have fallen to our blades! They were no match for the champions of Azeroth!','',26124),
(107324,'enUS','','Were it not for $p\'s actions, we would have all perished atop Mount Hyjal.',26124),
(107325,'enUS','','Both G\'Hanir and Nordrassil would have been destroyed by the Legion.',26124),
(107326,'enUS','','For centuries I have watched over G\'Hanir. Today it nearly fell to the corruption I swore to fight. It is time for another to take my place.',26124),
(107327,'enUS','','Therefore, I hereby pass along my station to $p. A true protector of life... a true guardian of the Dream!',26124),
(107328,'enUS','','Thank you again, shan\'do. I will remain here in the Dreamgrove if you ever have need of my guidance.',26124),
(107330,'enUS','They aren\'t letting up! Stand firm!','',26124),
(107331,'enUS','','Entire armies have fallen by my sword. What chance could you possibly have against me?',26124),
(107332,'enUS','','Well done! I trained those guards myself... they are not easily bested. I suppose you merit the honor of facing me. Strike at your leisure. As a courtesy, I grant you the first blow.',26124),
(107333,'enUS','','I let you strike first and that\'s the best you can do?',26124),
(107334,'enUS','','A gallant attempt... but a vain one.',26124),
(107335,'enUS','','Unworthy. A waste of my time!',26124),
(107336,'enUS','','Where\'s the fun in so easy a kill?',26124),
(107337,'enUS','','Replicate!',26124),
(107338,'enUS','','Detonate!',26124),
(107339,'enUS','','Animate!',26124),
(107340,'enUS','','Annihilate!',26124),
(107341,'enUS','','You should have thought better of challenging me!',26124),
(107342,'enUS','','Such a shame. I had hoped for a proper challenge.',26124),
(107343,'enUS','','I wonder if I\'ll ever face a worthy foe...',26124),
(107344,'enUS','','Inconceivable! I... am... the... best...',26124),
(107345,'enUS','','Mistress, I... have... failed...',26124),
(107346,'enUS','There is a noise from behind you!','There is a noise from behind you!',26124),
(107347,'enUS','The naga are tormenting that sea giant. How should we proceed?','',26124),
(107348,'enUS','The volatile energies within the Nexus seem to be interfering with the image crystal.','',26124),
(107349,'enUS','I fear you may be on your own from here. Good luck!','',26124),
(107350,'enUS','So the lock on the Nexus has been broken, and by a common $r, no less. Will wonders never cease?','',26124),
(107351,'enUS','If you\'ve come to engage me in battle in hopes of obtaining some spurious trinket, I\'m afraid you\'re too late.','',26124),
(107352,'enUS','The Ethereum have taken the bite out of this old dragon, and I fear they have robbed me of anything you would deem useful.','',26124),
(107353,'enUS','If it\'s looting you desire, as your kind so often does, then I suggest taking the fight to them.','',26124),
(107354,'enUS','Well this is... unexpected.','',26124),
(107355,'enUS','The void magic wielded by these ethereals has weakened me considerably. I am of no use to you in this state.','',26124),
(107356,'enUS','I can see you are a follower of the Light. Restore my strength and I will fight by your side.','',26124),
(107357,'enUS','We must make haste. I fear the Ethereum will be upon us any moment!','',26124),
(107358,'enUS','You are a capable healer, priest. I feel my strength returning.','',26124),
(107359,'enUS','I assume you come seeking the Nexus Vault. Why else would anyone return to this place?','',26124),
(107360,'enUS','Unfortunately, access to the vault is proving... difficult. If you help me access the Librarium, I will find a way through. We must not let the Ethereum obtain the artifacts it holds!','',26124),
(107361,'enUS','But first, I think I\'ll slip into a more comfortable form. These halls were never quite spacious enough for my tastes.','',26124),
(107362,'enUS','Shall we?','',26124),
(107363,'enUS','The Nexus Vault is weakening! That holy fire can only mean Light\'s Wrath is no longer fully contained.','',26124),
(107364,'enUS','It is a most potent and chaotic weapon. It will lash out at us as we try to approach. Be prepared.','',26124),
(107365,'enUS','The fire seems to have superheated the ground here. I hope you have a way to get us over it...','',26124),
(107366,'enUS','We\'re here. Now, let me see if I can find a way into the vault...','',26124),
(107367,'enUS','As I suspected! The entrance to the vault was broken off when Malygos breached the Twisting Nether during the Nexus Wars.','',26124),
(107368,'enUS','I feel the powers it holds resonating through the Nexus. There must be another way to reach the vault!','',26124),
(107369,'enUS','A-ha! That\'s... wait a moment... the energy from the vault is surging. Brace yourself!','',26124),
(107370,'enUS','That was too close! If the weapon goes unchecked much longer, it will bring this whole place down around us!','',26124),
(107371,'enUS','Quickly! We must head to the rift. It\'s the only way!','',26124),
(107372,'enUS','Wait... didn\'t there used to be a bridge here?','',26124),
(107373,'enUS','Fools! You may have destroyed the Surge Needles, but you are too late to stop us! The power of Light\'s Wrath will rip open the breach!','',26124),
(107374,'enUS','Oh great, more ethereals...','',26124),
(107375,'enUS','It looks like they\'re channeling the energy from the vault into the breach. This is not good.','',26124),
(107376,'enUS','Come! Time to show these ethereals that I still have a bit of fight left in me!','',26124),
(107377,'enUS','You are too late, interlopers. Nothing can stop me now!','',26124),
(107378,'enUS','The Ethereum will rise again!','',26124),
(107379,'enUS','What!? The void cannot be defeated! Noooo!','',26124),
(107380,'enUS','Hah! So much for the all-powerful void. You know, you\'re not a bad ally. Pity you\'re not a dragon!','',26124),
(107381,'enUS','I can open a portal to the vault, but I\'ll have to remain on this side to keep it open.','',26124),
(107382,'enUS','The way is clear. Hurry, little $r! I can\'t keep this open for long!','',26124),
(107383,'enUS','I hate to admit it, but I find myself in need of an ally. I suppose you\'ll do.','',26124),
(107384,'enUS','I\'m ready to get the power source.','I\'m ready to get the power source.',26124),
(107385,'enUS','Graahh?','',26124),
(107386,'enUS','Insert awesome healing/DPS wave event!','',26124),
(107387,'enUS','Fear not, my enormous friend. The Earthen Ring is here.','',26124),
(107388,'enUS','I have just the thing. Follow me.','',26124),
(107389,'enUS','Hold on just a moment. I fear I\'m a bit of a pack rat.','',26124),
(107390,'enUS','Now let\'s see... apexis crystals? No, no, those won\'t do at all.','',26124),
(107391,'enUS','Hmm, I must\'ve put it over here.','',26124),
(107392,'enUS','Arcane powder... soul shards... that\'s definitely not it...','',26124),
(107393,'enUS','A-ha! Here we are... a crystallized soul. That ought to do the trick!','',26124),
(107395,'enUS','Your hulls shatter, your bones are next!','',26124),
(107396,'enUS','Olokk... all washed up.','',26124),
(107397,'enUS','Fan out! Purge this demonic infestation!','',26124),
(107398,'enUS','Would you mind grabbing it? These crystals tend to have an adverse effect on non-demonic beings.','',26124),
(107399,'enUS','','Screeekk! Nothing sacred, nothing clean!',26124),
(107400,'enUS','','Screeeek...',26124),
(107401,'enUS','You are thousands of years behind us! How could you hope to win?','',26124),
(107402,'enUS','','Mighty Ursol, our ancient foe has returned! My companion has traveled here to seek your aid in recovering the Claws of Ursoc.',26124),
(107403,'enUS','Im... Impossible!','',26124),
(107404,'enUS','','How... my mana abandons me!',26124),
(107405,'enUS','','My mana will bring you to your knees!',26124),
(107406,'enUS','','How arrogant, to tread so close to Suramar!',26124),
(107407,'enUS','','You... will fall... to the Magistrix...',26124),
(107408,'enUS','My mind is free! The magic of death empowers me!','',26124),
(107409,'enUS','$n! Councilors, this is the demon hunter I spoke of.','',26124),
(107410,'enUS','Be careful, $n. You\'re tapping into magic even Illidan would have considered dangerous.','',26124),
(107411,'enUS','Wait, are you here after them? In that case, I could use a hand...','',26124),
(107412,'enUS','Allari, report in. Have you located the Warblades?','',26124),
(107413,'enUS','','Yes... <garbled> Caria... <garbled> Broken Shore... <garbled> heavy resistance...',26124),
(107414,'enUS','','Damn it all! INCOMING!',26124),
(107415,'enUS','What\'s going on down there? Allari!','',26124),
(107416,'enUS','We have their position. That will have to do.','',26124),
(107417,'enUS','$n, I have an idea.','',26124),
(107418,'enUS','$n, I have an idea.','',26124),
(107419,'enUS','Free. Free! FREE! Free of that accursed prison.','',26124),
(107420,'enUS','Blood and Honor!','Blood and Honor!',26124),
(107421,'enUS','Ready your blades! War is coming.','Ready your blades! War is coming.',26124),
(107422,'enUS','Another wave of reinforcements coming in! Hold your positions!','',26124),
(107423,'enUS','This must be it, over here!','',26124),
(107424,'enUS','Power... deserts me.','',26124),
(107427,'enUS','We die in Illidan\'s name... as will Caria.','',26124),
(107428,'enUS','','Such pitiful creatures. Is that the last of them?',26124),
(107429,'enUS','Yes, mistress. The Tideskorn will keep them captive until you are ready to harvest their souls.','',26124),
(107430,'enUS','','Good. Now tear this monastery to shreds!',26124),
(107431,'enUS','Suffer well. Show Caria no mercy!','',26124),
(107432,'enUS','','The %s dies, passing into the Maw of Souls...',26124),
(107433,'enUS','','Are you prepared to venture to the epicenter of this chaos, $r?',26124),
(107434,'enUS','I am ready.','I am ready.',26124),
(107435,'enUS','','This place is corrupted beyond anything I have ever seen... Malfurion, please hold on.',26124),
(107436,'enUS','','The %s returns to the Halls of Valor...',26124),
(107437,'enUS','Focus your attacks! Bring them down!','',26124),
(107438,'enUS','old','old',26124),
(107439,'enUS','','Harbaron begins to drain the soul of the %s.',26124),
(107440,'enUS','I will bring whatever power I have to bear against the Nexus-Prince, $c. But in my weakened state, it falls upon you to finish this threat.','',26124),
(107441,'enUS','I hope you are prepared!','',26124),
(107442,'enUS','$n wanes from existence.','',26124),
(107443,'enUS','I will not rest until the council has been rebuilt.','',26124),
(107444,'enUS','','I am here to repay my debt, and nothing more.',26124),
(107445,'enUS','','My tolerance for Ritssyn is low, but I\'ll do my best to remain focused despite having to be in his presence.\n\nShould I begin summoning the gateway?',26124),
(107446,'enUS','Grblgrbl waugurblurg.','',26124),
(107447,'enUS','We mean you no harm, giant.','',26124),
(107448,'enUS','They control us. They kill.','',26124),
(107449,'enUS','Shaman, speak with him. Perhaps we can gain a new ally down here.','',26124),
(107450,'enUS','Blerk.','',26124),
(107451,'enUS','I have become void!','',26124),
(107452,'enUS','Of course we will help you!','',26124),
(107453,'enUS','Your order is broken, monks! You can do nothing against us.','',26124),
(107454,'enUS','Our WILL is not broken. We will fight to our last breath, demon-lover.','',26124),
(107455,'enUS','The Legion lives forever...','',26124),
(107456,'enUS','You will die by my blade, $c!','',26124),
(107457,'enUS','I\'ll tear you apart, $c!','',26124),
(107458,'enUS','I will rain fire and fury upon you!','',26124),
(107459,'enUS','We will turn your monastery to ash.','',26124),
(107460,'enUS','This is the end of your people.','',26124),
(107461,'enUS','Wheee.... fire!','',26124),
(107462,'enUS','I\'ll torch you up good!','',26124),
(107463,'enUS','Watch it burn, watch it burn!','',26124),
(107464,'enUS','Glorious fire, so beautiful!','',26124),
(107465,'enUS','More fire. More, more, MORE!','',26124),
(107466,'enUS','','Hurry, $n. Those fel spreaders are doing incredible damage.',26124),
(107467,'enUS','We\'ll hold them back here. Strike at the demons now, or it will be too late!','',26124),
(107468,'enUS','Hurry up now, I\'m right behind! The King\'s got your back if you get in a bind!','',26124),
(107469,'enUS','','I shall prepare a holding area for the subjects while you are away.',26124),
(107470,'enUS','Well done, my friend! He has seen our missing shaman AND the artifact we seek. Now we must find a way through this ice barrier...','',26124),
(107471,'enUS','...Well that will do.','',26124),
(107472,'enUS','Master, you have witnessed with your own eyes the Legion\'s capability for destruction.','',26124),
(107474,'enUS','The monastery is saved, but our work is far from over.','',26124),
(107475,'enUS','Please take me to the Temple of Five Dawns.','Please take me to the Temple of Five Dawns.',26124),
(107476,'enUS','Yes.','Yes.',26124),
(107477,'enUS','The nightmare has already tainted these creatures, now how about we taint yours?','',26124),
(107478,'enUS','I\'m your worst nightmare.','',26124),
(107479,'enUS','Pitiful.','',26124),
(107481,'enUS','Stomp on the satyr\'s tail.','Stomp on the satyr\'s tail.',26124),
(107482,'enUS','Break the satyr\'s wrist.','Break the satyr\'s wrist.',26124),
(107483,'enUS','Involve Tyrande.','Involve Tyrande.',26124),
(107484,'enUS','Impossible!','',26124),
(107485,'enUS','The seed has been sown.','',26124),
(107486,'enUS','Yes, let the anger swell inside you!','',26124),
(107487,'enUS','I can feel the corruption spreading!','',26124),
(107488,'enUS','That one wouldn\'t have lasted long anyway.','',26124),
(107490,'enUS','You will pay for your insolence.','',26124),
(107491,'enUS','I\'m in a bad dream.','',26124),
(107499,'enUS','','Hold the line! Don\'t let them take the monastery!',26124),
(107500,'enUS','','Master Taran Zhu is waiting for you down the hill.',26124),
(107501,'enUS','All in good time, hero. Your body is not quite ripe yet. I will come for you again, but first my soul requires a more appropriate vessel.','',26124),
(107502,'enUS','You are strong. Perhaps I shall claim you as my next vessel.','',26124),
(107503,'enUS','Grandmaster! Greetings to you, and good tidings! I hope you\'re ready with some Crackling Jade Lightning!','',26124),
(107504,'enUS','Your power has grown, Kira.','',26124),
(107505,'enUS','','It has, indeed. And you should keep that in mind the next time you attempt to speak to me...',26124),
(107506,'enUS','Even Deathwing could foresee the evil that the Darkness could unleash if left unchecked.$b$bThis is a grim day for us all.','',26124),
(107507,'enUS','Send me to Thunder Totem.','Send me to Thunder Totem.',26124),
(107508,'enUS','The final trial will not be easy, druid. Speak with me when you are ready.','',26124),
(107509,'enUS','Tyrande Whisperwind! I have longed for this encounter for many years.','',26124),
(107510,'enUS','','I\'ll take you with me!',26124),
(107511,'enUS','','A dose of plague might teach you manners aboard my ship!',26124),
(107512,'enUS','Your adoring husband will be joining me in the nightmare. His was a special invitation.','',26124),
(107513,'enUS','','I\'ve seen what this hero can do. I will gladly help!',26124),
(107514,'enUS','Tell me, is there anyone willing to fight at your side, $c?','',26124),
(107516,'enUS','Very good, $n! The spirit of the bear truly dwells within you!','',26124),
(107517,'enUS','This way. The rest of the survivors are up here.','',26124),
(107518,'enUS','','The door seal is about to collapse! All is lost if the Legion breaks through the door!',26124),
(107519,'enUS','Their leader, Lady Keletress, must be stopped.','',26124),
(107520,'enUS','Our friends be missin\'! We can\'t quit! But these ookers be scary, I gotta admit!','',26124),
(107521,'enUS','I will return with you to the Wandering Isle. From there, we will devise a plan.','',26124),
(107522,'enUS','','Spiritwalker! What happened here?',26124),
(107523,'enUS','The Darkness. It  came and... I am sorry my Chieftain. But the Darkness has taken your father\'s body to the summit.','',26124),
(107524,'enUS','I\'ve got you now!','',26124),
(107525,'enUS','Thistleleaf Bully pinches Trapped Lunarwing','',26124),
(107526,'enUS','You\'re not going anywhere!','',26124),
(107527,'enUS','','Not while I still draw breath.',26124),
(107528,'enUS','','Koda, keep her distracted. Lyanis, mend our wounds. Champion - with me!',26124),
(107529,'enUS','','Are you truly lost, Ysera? After all we have built? All we have done?',26124),
(107530,'enUS','','By the light of Elune, we will end this madness!',26124),
(107531,'enUS','','I will end your torment, Dreamer. And I promise we will avenge you.',26124),
(107532,'enUS','','Shhhh, shhh... It is over now, Ysera.',26124),
(107533,'enUS','','Sleep now, dear Ysera. Sleep forever, and dream no more.',26124),
(107534,'enUS','','This is your end, mortals. The Dream is undone!',26124),
(107535,'enUS','','My eyes are open at last, priestess. I see night eternal.',26124),
(107536,'enUS','','The Nightmare consumes all!',26124),
(107537,'enUS','','The Lord of the Nightmare, he -',26124),
(107538,'enUS','','...blackness...',26124),
(107539,'enUS','As with most rituals, it will require three warlocks to complete. \n\nAre you ready to begin?','',26124),
(107540,'enUS','','Come, Champion. Let us show these invaders the meaning of strength.',26124),
(107548,'enUS','','I cannot tell where his voice is coming from! Quickly, search the buildings to the west. I will scour the east for signs of him!',26124),
(107549,'enUS','','Where are you Malfurion? Answer me!',26124),
(107550,'enUS','','Champion, to me! I have found something!',26124),
(107551,'enUS','I will be at your service when you call, Grandmaster.','',26124),
(107552,'enUS','','These hoofprints follow the path to the left. Come, quickly!',26124),
(107553,'enUS','','Malfurion?! Call out to me!',26124),
(107554,'enUS','','Not without you!',26124),
(107555,'enUS','The master chose well, all will see! The Monkey King is tough as can be!','',26124),
(107556,'enUS','','By Elune, your foulness will be purged from this place!',26124),
(107557,'enUS','','You take care of that foul mouthed satyr. I am going to my husband!',26124),
(107558,'enUS','You cannot hold me!','',26124),
(107559,'enUS','Turn back, Tyrande!','',26124),
(107560,'enUS','','I\'ll help, of course. Unlike you, I do not abandon a fellow warlock when they might need me most.',26124),
(107561,'enUS','You have a lot of nerve approaching me, outlander.','',26124),
(107562,'enUS','Are you Silgryn?','Are you Silgryn?',26124),
(107563,'enUS','Thalyssra sent me.','Thalyssra sent me.',26124),
(107564,'enUS','Will you assist us Kira?','',26124),
(107567,'enUS','You made it! But to leave this place with the weapon, you must first gain control of it.','',26124),
(107568,'enUS','Good luck, $c.','',26124),
(107569,'enUS','Either my legend has spread beyond the city, or we have a mutual acquaintance...','',26124),
(107570,'enUS','I am impressed, $n! Never have I seen a priest capable of controlling Light\'s Wrath.','',26124),
(107571,'enUS','The ethereals have been routed and you have the weapon you came for. Your business here is finished. Mine, on the other hand, has just begun.','',26124),
(107572,'enUS','Bit of a bumpy ride, eh? Flyin\' through these clouds ain\'t easy, even on as fine a gryphon as Huey.','',26124),
(107573,'enUS','I thank you for freeing me. You have given me the greatest gift of all... that of time.','',26124),
(107574,'enUS','I will use that time to secure the Nexus. It must never again fall into the wrong hands!','',26124),
(107575,'enUS','I\'m ready to get underway.','I\'m ready to get underway.',26124),
(107576,'enUS','This portal will take you back to Kalecgos. Please give him my regards.','',26124),
(107577,'enUS','First I should introduce you to Prustaga.','',26124),
(107578,'enUS','Seems Prust wants the Legion out of here as much as we do. Worked night and day to find this tomb!','',26124),
(107579,'enUS','Uh... word of warning. I wouldn\'t exactly say she\'s the cuddliest sort.','',26124),
(107580,'enUS','Prustaga! Brought a friend to join us, as promised.','',26124),
(107581,'enUS','','I care nothing for friendship, soft-earthen. So long as this one helps us enter the tomb, I will tolerate the intrusion.',26124),
(107582,'enUS','Hmm... looks like some fools plundered the tomb and stirred up all sorts o\' spirits.','',26124),
(107583,'enUS','Good luck out there. I\'ll be watchin for yer signal.','',26124),
(107584,'enUS','','Your job is simple! Dispatch the spirits while I shatter the wards sealing the tomb.',26124),
(107585,'enUS','Say, you hear somethin\'?','',26124),
(107586,'enUS','Defiler... no... not yours...','',26124),
(107587,'enUS','Never understood why ghosts get so uppity \'bout their loot...','',26124),
(107588,'enUS','Thief! Coveter! It belongs to me!','',26124),
(107589,'enUS','Pipe down! We\'re after yer gun for a good cause, ghostie!','',26124),
(107590,'enUS','Look out!','',26124),
(107591,'enUS','','These creatures are merely a distraction! Get to the tomb!',26124),
(107592,'enUS','Front door\'s already open. That\'s handy!','',26124),
(107593,'enUS','Rawk! Sneak past! Sneak past!','',26124),
(107594,'enUS','Daglir is sure to be ruined now. I have already begun to hear rumors that he is a traitor in league with the Nightfallen.','Daglir is sure to be ruined now. I have already begun to hear rumors that he is a traitor in league with the Nightfallen.',26124),
(107595,'enUS','Rawk! Landmines!','',26124),
(107596,'enUS','He and his \"allies\" were concocting a plot to poison Elisande! That will teach him to mess with a Moongrow!','He and his \"allies\" were concocting a plot to poison Elisande! That will teach him to mess with a Moongrow!',26124),
(107597,'enUS','You\'ve failed, just as I did. Yet we can learn from this and change your destiny. Speak with me again.','',26124),
(107598,'enUS','Well done! The energies from the vault seem to be stabilizing. Now hurry back before the portal closes and you\'re locked inside!','',26124),
(107599,'enUS','The giant has seen Sharas\'dal, the Scepter of Tides! We are close. Keep him alive and he will protect us.','',26124),
(107600,'enUS','Stay back! These creatures are being controlled by another.','',26124),
(107601,'enUS','What are Azshara\'s minions doing to this place?','',26124),
(107602,'enUS','YOUR CALL FOR DEATH SHALL BE GRANTED!','',26124),
(107603,'enUS','Tyrande, no! It\'s a trap!','',26124),
(107604,'enUS','','I will NOT lose you!',26124),
(107605,'enUS','Thalyssra lives? Come, let us talk in private.','',26124),
(107606,'enUS','And our dear Ysera! Would you believe she has had a change of heart?','',26124),
(107607,'enUS','','Enough chatter. Move!',26124),
(107608,'enUS','','The moonwell water is essential. Don\'t leave the Dreamgrove without it! I\'ll await your arrival in Grizzly Hills.',26124),
(107609,'enUS','What are you doing here in the Broken Isles, Brann?','What are you doing here in the Broken Isles, Brann?',26124),
(107610,'enUS','Same thing I\'m always doin\' - learnin\' anything I can learn about the Titans! Where we came from. Why we\'re here. This land has answers, I can feel it.\n\nThere ain\'t any city-size, Titan-made architecture here in the Broken Isles, though. No Ulduars, Uldumans... no Uld-anythin\'! So I\'m looking into the history of the demons. I figure maybe I\'ll learn somethin\' about Sargeras, the fallen Titan.','',26124),
(107611,'enUS','What have you found so far?','What have you found so far?',26124),
(107612,'enUS','Oh, all kinds of relics from the War o\' the Ancients. Plenty o\' battles fought on this very land. Where d\'ye think all the felslate comes from? But nothin\' Titan. Not yet, anyway...','',26124),
(107613,'enUS','What are you doing here in the Broken Isles, High Examiner?','What are you doing here in the Broken Isles, High Examiner?',26124),
(107614,'enUS','<The High Examiner eyes you condescendingly.>\n\nHave you not heard of the Reliquary before, $r?\n\nWe seek power, of course. Scores of invaluable artifacts lie littered within the strata of this land. The Highborne have forgotten more about the arcane arts than you or I will ever know. I seek to uncover their forgotten relics, and wield their power for myself and my people.\n\nNow please, no more questions.','',26124),
(107615,'enUS','Do you live here in Thunder Totem, Lessah?','Do you live here in Thunder Totem, Lessah?',26124),
(107616,'enUS','','No, no. I am from Thunder Bluff. I am an adventurer, like you. These Highmountain tauren are as foreign to me as they are to you.\n\nI am, however, an avid student of Huln Highmountain, one of the greatest tauren ever to walk this land. Probably THE greatest. Here, in Highmountain, I stand the best chance of learning more about him.',26124),
(107617,'enUS','','%s calls out to nearby creatures for aid.',26124),
(107618,'enUS','Okay.','Okay.',26124),
(107619,'enUS','She will aid me in my conquest of Val\'sharah, starting with your precious Temple of Elune.','',26124),
(107620,'enUS','','Thank you.',26124),
(107621,'enUS','YOU\'VE FALLEN INTO MY TRAP! NOW YOU DIE!','',26124),
(107622,'enUS','','Speak to me when you are ready to leave.',26124),
(107624,'enUS','','Whenever I was plagued with doubt, I would descend into his barrow. I watched over him as he slept.',26124),
(107625,'enUS','','Even in slumber, his presence calmed me. I left my fears below the earth and emerged, ready to lead my people.',26124),
(107626,'enUS','','When Malfurion returned to my side, we worked as one. As if he had never been away. Have you ever loved as I have?',26124),
(107627,'enUS','','Now Xavius has me by the throat. I must abandon my beloved, and subdue the most beautiful creature I have ever known.',26124),
(107630,'enUS','','I will do whatever is needed to defend Dreadscar Rift from the Burning Legion.',26124),
(107631,'enUS','','<groans> ...',26124),
(107632,'enUS','','Shinfel Blightsworn mumbles incoherently, clearly in pain.',26124),
(107633,'enUS','Buuuuuurrrrrnnnnssss...','',26124),
(107634,'enUS','','The Scepter of Tides... it\'s here. I found it.',26124),
(107635,'enUS','','They\'re using it to whip creatures of this realm into a frenzy.',26124),
(107636,'enUS','','Sharas\'dal is held by Lady Zithreen. She was using me as bait.',26124),
(107637,'enUS','','We should turn back. This whole realm is a trap.',26124),
(107638,'enUS','You underestimate the shaman I have brought.','',26124),
(107639,'enUS','If the Scepter is here, this may be our only chance to capture it and turn its power against the Legion!','',26124),
(107640,'enUS','You\'re not going anywhere!','',26124),
(107641,'enUS','My eternal soul... for Caria...','',26124),
(107642,'enUS','','You are too late! He comes...',26124),
(107643,'enUS','','Keep its soul intact. Caria has plans for this one.',26124),
(107644,'enUS','Those undead invaders put up quite a fight, but Marl and I won\'t let the farm be taken.','',26124),
(107645,'enUS','Are you Mad Ernie?','Are you Mad Ernie?',26124),
(107646,'enUS','Shhh! Keep your voice down.\n\nI haven\'t gone by that name in years. I gave up the practice of alchemy some time ago, in favor of a calm life here on the farm.\n\nWhat business do you have with \"Mad Ernie\" anyway?','',26124),
(107647,'enUS','Ritssyn sent me. We need help curing a doom curse.','Ritssyn sent me. We need help curing a doom curse.',26124),
(107648,'enUS','Ernest Carlisle sighs.','',26124),
(107649,'enUS','','The Banshee Queen sends her regards, $ct.',26124),
(107650,'enUS','I am in your debt, Master.','',26124),
(107651,'enUS','Be careful. These vrykul are nearly unstoppable.','',26124),
(107652,'enUS','I can find my way back to the order hall. Thank you.','',26124),
(107653,'enUS','The Storm Brew turns the vrykul into brutal, unstoppable machines. Be careful.','',26124),
(107654,'enUS','Use the Storm Brew, Master. It will be your only hope against them.','',26124),
(107655,'enUS','','I am in your debt, Master.',26124),
(107656,'enUS','','Be careful. These vrykul are nearly unstoppable.',26124),
(107657,'enUS','','I can find my way back to the order hall. Thank you.',26124),
(107658,'enUS','','The Storm Brew turns the vrykul into brutal, unstoppable machines. Be careful.',26124),
(107659,'enUS','','Use the Storm Brew, Master. It will be your only hope against them.',26124),
(107660,'enUS','Looks like we\'re going in! C\'mon, Theodore!','',26124),
(107661,'enUS','','This place makes my skin crawl. Elune, give me strength.',26124),
(107662,'enUS','','Now that we have Ursol\'s blessing, we can travel into the Emerald Dream and retrieve the claws! Come, $n, let\'s not waste a single minute!',26124),
(107663,'enUS','Courage... power... discipline...$b$bMaster these traits and the spirit of the bear will be within your heart.','',26124),
(107664,'enUS','','This is why we brought you here. Destroy them!',26124),
(107665,'enUS','Hiro! Hey Hiro, are you all right, mate?','',26124),
(107666,'enUS','Uh oh. Looks like we\'ve got company.','',26124),
(107667,'enUS','Quick, take this key and get yerself outta there!','',26124),
(107668,'enUS','Ey mon, da lock be jammed an\' me head\'s spinnin\'! You do it if yer so smart, dwarf!','',26124),
(107669,'enUS','Any day now, Hiro!','',26124),
(107670,'enUS','','More enemies!',26124),
(107671,'enUS','May the elements guide our ways.','May the elements guide our ways.',26124),
(107672,'enUS','Ey look, da door opened!','',26124),
(107673,'enUS','May the Earth Mother watch over us.','May the Earth Mother watch over us.',26124),
(107675,'enUS','$n! I am in your debt, but I must check on the others.','$n! I am in your debt, but I must check on the others.',26124),
(107676,'enUS','Earth Mother watch over you.','Earth Mother watch over you.',26124),
(107677,'enUS','Angus! Sylara! It\'s good to see ya. You... ahhh... got anyting ta drink on ya?','',26124),
(107678,'enUS','They\'ve breached the temple! Defend the Warblades!','',26124),
(107679,'enUS','','You\'re not one of my pack. What brings you to the den?',26124),
(107681,'enUS','Allari led a small army to follow a lead on the Warblades. We may have finally found them.','',26124),
(107682,'enUS','We believe we may have finally found the warblades. Allari led an army to track them down.','',26124),
(107683,'enUS','Reinforcements! Now!','',26124),
(107684,'enUS','Me n\' Roo used to be adventurers, just like you. We fought our way from here clear to Pandaria, even been to Outland! Stabbin\' an\' healin\' an\' everything between.\n\nNowadays we just want to spend some time in a quiet place with our two little dogs, ye ken?','',26124),
(107685,'enUS','Come then! Meet your end!','',26124),
(107687,'enUS','Death is a gift, mortal!','',26124),
(107688,'enUS','A life worth less than nothing.','',26124),
(107689,'enUS','Embrace agony!','',26124),
(107690,'enUS','You will meet your end!','',26124),
(107691,'enUS','I\'ll melt away that courage!','',26124),
(107692,'enUS','To ashes with you!','',26124),
(107693,'enUS','Watch your hopes crumble!','',26124),
(107694,'enUS','Azeroth... must... burn...','',26124),
(107695,'enUS','Burn it down, burn it all down, ha ha ha!','',26124),
(107696,'enUS','No matter how bad things get, remember that there\'s always an open car on the happy train. Toot toot!','',26124),
(107697,'enUS','','Great. Now help us!',26124),
(107698,'enUS','Brute incoming!','',26124),
(107699,'enUS','No... noooo! Mistress will not be pleased that her prisoners escaped!','',26124),
(107700,'enUS','I will take care of you myself!','',26124),
(107701,'enUS','','Those cursed twins... They will pay for what they did!',26124),
(107702,'enUS','We can\'t hold \'em off forever! Get the lead outta yer boots and get outta there!','',26124),
(107703,'enUS','Derp','',26124),
(107704,'enUS','The Warblades will consume you!','',26124),
(107705,'enUS','','Trifling creatures... once again you have disrupted my plans.',26124),
(107706,'enUS','','I promise you this, monks of the Broken Temple... the next time we meet, you will PAY for your insolence!',26124),
(107707,'enUS','You\'re too late! The corruption of your world can\'t be stopped. I\'ll help it along... starting with your precious companions!','',26124),
(107708,'enUS','This loss is irrelevant! The Nightmare will consume all! Until next time, interloper...','',26124),
(107709,'enUS','Greetings! How about a quick battle to keep our friends strong?','',26124),
(107710,'enUS','Promising! You and your friends are a skilled bunch indeed.','',26124),
(107711,'enUS','Wielding','Wielding',26124),
(107712,'enUS','%s writhes in pain.','%s writhes in pain.',26124),
(107713,'enUS','%s suffers as a darkness grows within.','%s suffers as a darkness grows within.',26124),
(107714,'enUS','My scouts report flocks of giant, diseased bats overtaking them in the skies around the fiery mountain. See if you can find out where they are coming from.','',26124),
(107715,'enUS','You have cleared the skies and the mountain at once. The Skyhorn are in your debt.','',26124),
(107716,'enUS','','Dargrul has trapped a great basilisk mother deep within the vault. If we don\'t put her down now, he will emerge with an army of trained basilisks!',26124),
(107717,'enUS','','You have done the Highmountain tribes a great service today.',26124),
(107718,'enUS','','Dargrul commits atrocities against even the wildlife, polluting our rivers with turtles twisted by his crystalline magic. Find the source of these powerful beasts.',26124),
(107719,'enUS','','Our waters are safe to drink again, thanks to you.',26124),
(107720,'enUS','My people have been taken by Dargrul\'s minions, forced to do his dark bidding or face death at the hands of his slavers. Aid them if you are able.','',26124),
(107721,'enUS','The Stonedark thank you.','',26124),
(107722,'enUS','Legends tell of lost relics from the days of the great dragon Neltharion. Should you come across one, bring it to me, I will ensure it remains protected.','',26124),
(107723,'enUS','Thank you, hero. In the wrong hands these relics could tear apart the fabric of our world.','',26124),
(107724,'enUS','We fight together, $n.','',26124),
(107725,'enUS','You pick \'em out. I\'ll take \'em down.','',26124),
(107726,'enUS','Over here!','',26124),
(107727,'enUS','Cut them down! There\'s more on the way!','',26124),
(107728,'enUS','My magic... they resisted everything! Please, help!','My magic... they resisted everything! Please, help!',26124),
(107729,'enUS','If I hadn\'t been caught off guard I\'d... You there! Lend me a hand!','If I hadn\'t been caught off guard I\'d... You there! Lend me a hand!',26124),
(107730,'enUS','My magic is yours, $n.','My magic is yours, $n.',26124),
(107731,'enUS','Let us purge this threat together.','Let us purge this threat together.',26124),
(107732,'enUS','I thank you for your help, $n, but our people must be warned at once!','I thank you for your help, $n, but our people must be warned at once!',26124),
(107733,'enUS','The others. There were more of us... I must find them.','The others. There were more of us... I must find them.',26124),
(107734,'enUS','Get me outta here!','Get me outta here!',26124),
(107735,'enUS','Hey! Over here! Boy am I sure glad to see you!','Hey! Over here! Boy am I sure glad to see you!',26124),
(107736,'enUS','Let\'s get to it, shall we? These demons ain\'t gonna kill themselves!','Let\'s get to it, shall we? These demons ain\'t gonna kill themselves!',26124),
(107737,'enUS','Make way! Wrecking crew comin\' through!','Make way! Wrecking crew comin\' through!',26124),
(107738,'enUS','Gotta recharge the ol\' mana battery! Save some for me, would ya?','Gotta recharge the ol\' mana battery! Save some for me, would ya?',26124),
(107739,'enUS','You go on ahead, I\'ll catch up with you in a few!','You go on ahead, I\'ll catch up with you in a few!',26124),
(107740,'enUS','I should have stayed in the shadows. Mind lending me a hand?','I should have stayed in the shadows. Mind lending me a hand?',26124),
(107741,'enUS','Get these things off me!','Get these things off me!',26124),
(107742,'enUS','They\'ll never see us coming.','They\'ll never see us coming.',26124),
(107743,'enUS','My blades are ready, $n. Just show me the target.','My blades are ready, $n. Just show me the target.',26124),
(107744,'enUS','Stick to the shadows. This isn\'t over yet.','Stick to the shadows. This isn\'t over yet.',26124),
(107745,'enUS','The others must be warned.','The others must be warned.',26124),
(107746,'enUS','It pains me to ask, but I could really use your help!','It pains me to ask, but I could really use your help!',26124),
(107747,'enUS','Here! Please - my magic... they devour it!','Here! Please - my magic... they devour it!',26124),
(107748,'enUS','They\'ve taken the others! Please! Help!','They\'ve taken the others! Please! Help!',26124),
(107749,'enUS','I can\'t fend them off much longer! Please! Help!','I can\'t fend them off much longer! Please! Help!',26124),
(107750,'enUS','Lookin\' like you could use help, $n.','Lookin\' like you could use help, $n.',26124),
(107751,'enUS','It\'s time we be gettin\' back to battle.','It\'s time we be gettin\' back to battle.',26124),
(107752,'enUS','Thanks, $n. Others be needin\' my help, but take this.','Thanks, $n. Others be needin\' my help, but take this.',26124),
(107753,'enUS','Gotta keep movin\'! The Legion is everywhere.','Gotta keep movin\'! The Legion is everywhere.',26124),
(107754,'enUS','Those things... I couldn\'t...','Those things... I couldn\'t...',26124),
(107755,'enUS','Over here! I...','Over here! I...',26124),
(107756,'enUS','The foul breath on these... help me take them down!','The foul breath on these... help me take them down!',26124),
(107757,'enUS','You\'ll not ruin our lands!','You\'ll not ruin our lands!',26124),
(107758,'enUS','We fight together, $n!','We fight together, $n!',26124),
(107759,'enUS','These demons stand no chance with me by your side.','These demons stand no chance with me by your side.',26124),
(107760,'enUS','We have to push them back!','We have to push them back!',26124),
(107761,'enUS','Our people need our help!','Our people need our help!',26124),
(107762,'enUS','To battle!','To battle!',26124),
(107763,'enUS','Your soul will be ours...','',26124),
(107764,'enUS','Walking in the memories of spirits can sometimes be dangerous, but it is a responsibility we Spiritwalkers must accept.','',26124),
(107765,'enUS','I am ready to walk in the memories of Dargrul.','I am ready to walk in the memories of Dargrul.',26124),
(107766,'enUS','Fel magic surges around within the orb almost... invitingly.','Fel magic surges around within the orb almost... invitingly.',26124),
(107767,'enUS','As a Warlock, minor fel magic such as this presents no danger to you. Absorb the power of the fel orb.','As a Warlock, minor fel magic such as this presents no danger to you. Absorb the power of the fel orb.',26124),
(107768,'enUS','Fel magic surges around within the orb almost... invitingly.\n\nThe depths of fel magic are beyond you.','Fel magic surges around within the orb almost... invitingly.\n\nThe depths of fel magic are beyond you.',26124),
(107769,'enUS','The flask shimmers and bubbles.','The flask shimmers and bubbles.',26124),
(107770,'enUS','As a Rogue, you are intimately familiar with poisons. Adding a lethal dose to this flask should be easy...','As a Rogue, you are intimately familiar with poisons. Adding a lethal dose to this flask should be easy...',26124),
(107771,'enUS','This ward will help seal away a great evil. So long as I draw breath, the Darkness will never be free!','',26124),
(107772,'enUS','Your time in this life is short. The Darkness has seen it.','',26124),
(107773,'enUS','The flask shimmers and bubbles.\n\nUnfortunately, you lack the proper ingredients to create something truly sinister.','The flask shimmers and bubbles.\n\nUnfortunately, you lack the proper ingredients to create something truly sinister.',26124),
(107774,'enUS','','About time, Dargrul. At my age, every minute counts.',26124),
(107775,'enUS','','Fine, let\'s make this trade so you can go back to your cave and I can grab a warm drink.',26124),
(107776,'enUS','Calm your hooves, ronir. I had something to take care of.','',26124),
(107778,'enUS','','That sprite is picking on a lunarwing! Would you please put a stop to this?',26124),
(107779,'enUS','','Thank you. I won\'t stand for anyone picking on innocent creatures!',26124),
(107780,'enUS','Arcane energy thrums around the conduit. It seems to be linked to the Guardian Constructs somehow.','Arcane energy thrums around the conduit. It seems to be linked to the Guardian Constructs somehow.',26124),
(107781,'enUS','That thing just rose out of the corruption! We must purge it from our world before it grows too powerful.','',26124),
(107782,'enUS','As any Goblin would know, adding explosives always solves the problem!','As any Goblin would know, adding explosives always solves the problem!',26124),
(107783,'enUS','Arcane energy thrums around the conduit. It seems to be linked to the Guardian Constructs somehow.\n\nUnfortunately, the intricacies of this mechanical construct are unknown to you.','Arcane energy thrums around the conduit. It seems to be linked to the Guardian Constructs somehow.\n\nUnfortunately, the intricacies of this mechanical construct are unknown to you.',26124),
(107784,'enUS','The creatures of the Nightmare grow even more twisted! Let us pray to Elune that this fiend won\'t trouble us again.','',26124),
(107785,'enUS','Yeah, that\'s the stuff! Ya feel better or what?','',26124),
(107786,'enUS','If the effects wear off, just look for more Storm Brew up ahead. The vrykul love drinking this stuff!','',26124),
(107787,'enUS','Nice moves!','',26124),
(107788,'enUS','Couldn\'t have done better meself!','',26124),
(107789,'enUS','The stories were true about you.','',26124),
(107790,'enUS','Hmmm, not bad. Not bad at all.','',26124),
(107791,'enUS','Impressive.','',26124),
(107792,'enUS','Hey! I was just about to get \'im!','',26124),
(107793,'enUS','','This murloc\'s tribe has been enslaved by Lady Zithreen.',26124),
(107794,'enUS','Demon Hunter training has long prepared you for this. Grasp the power from within the fel orb.','Demon Hunter training has long prepared you for this. Grasp the power from within the fel orb.',26124),
(107795,'enUS','Warg! Blerg!','',26124),
(107796,'enUS','Pah! Good riddance!','',26124),
(107797,'enUS','','A fire! You must quench it before the sacred forest burns!',26124),
(107798,'enUS','I see where ye get yer reputation.','',26124),
(107799,'enUS','Don\'t kill them! Purify them, shaman! Purge them as fast as you can!','',26124),
(107801,'enUS','','We are fortunate you arrived so quickly. Thank you.',26124),
(107802,'enUS','I am ready to walk in the memories of Oenia Skyhorn.','I am ready to walk in the memories of Oenia Skyhorn.',26124),
(107803,'enUS','I am ready to walk in the memories of Warbrave Oro.','I am ready to walk in the memories of Warbrave Oro.',26124),
(107804,'enUS','Experience with Alchemy teaches you that one should never drink the gray liquid alongside anything purple. It would sure be a pity if anyone were to imbibe in this flask now...','Experience with Alchemy teaches you that one should never drink the gray liquid alongside anything purple. It would sure be a pity if anyone were to imbibe in this flask now...',26124),
(107805,'enUS','Let us rest!','Let us rest!',26124),
(107806,'enUS','I have seen it! The Darkness approaches!','I have seen it! The Darkness approaches!',26124),
(107807,'enUS','Gnomish technology has taught you the dangers of overloading any conduit. Let\'s see how this one handles ten thousand volts!','Gnomish technology has taught you the dangers of overloading any conduit. Let\'s see how this one handles ten thousand volts!',26124),
(107808,'enUS','Engineering has always been your forte. Shutting down this conduit is something you could do with your eyes closed.','Engineering has always been your forte. Shutting down this conduit is something you could do with your eyes closed.',26124),
(107809,'enUS','Begone, spirits! Tell the Darkness he is not welcome in this place!','Begone, spirits! Tell the Darkness he is not welcome in this place!',26124),
(107810,'enUS','All right! I\'m ready to bust some skulls! Ye won\'t regret this, Grandmaster!','',26124),
(107811,'enUS','','%s smiles.',26124),
(107812,'enUS','Ya!!! We be on your side now. Tings will be beddah soon.','',26124),
(107813,'enUS','Such a dilemma, high priestess!','',26124),
(107814,'enUS','Kneel beside your beloved as he draws his final breath? Or watch the temple of your goddess burn!','',26124),
(107815,'enUS','<Maniacal Laugh>','',26124),
(107816,'enUS','The darkness rises.','',26124),
(107817,'enUS','The Darkness will pierce the veil.','',26124),
(107818,'enUS','The master will return.','',26124),
(107819,'enUS','Embrace the shadow.','',26124),
(107820,'enUS','He will return.','',26124),
(107821,'enUS','Dark overcomes light.','',26124),
(107822,'enUS','Accept the Darkness.','',26124),
(107823,'enUS','He is master of shadows.','',26124),
(107824,'enUS','The prisoners were taken to the Gates of Valor. It\'s swarming with powerful vrykul and demons. Mark my words, there\'s something fishy going on there.','',26124),
(107825,'enUS','','<Sylara waits for your orders.>',26124),
(107826,'enUS','I made it my goal ta taste every brew across dese lands. Dere ain\'t nothing ta worry about when you\'ve got a brew in one hand your friends beside ya.','',26124),
(107827,'enUS','','<Ysera Dragon Roar>',26124),
(107828,'enUS','Anything to report from the night watch?','Anything to report from the night watch?',26124),
(107829,'enUS','What? I don\'t... Wait, yes, I hear it too! Report to Thunder Totem, warbrave. I will find out what is happening.','What? I don\'t... Wait, yes, I hear it too! Report to Thunder Totem, warbrave. I will find out what is happening.',26124),
(107830,'enUS','What manner of drogbar are these? I have never seen their like!','What manner of drogbar are these? I have never seen their like!',26124),
(107831,'enUS','Yes! I just heard shouting from across the stream!','Yes! I just heard shouting from across the stream!',26124),
(107832,'enUS','','The Warblades are even more impressive in person.',26124),
(107833,'enUS','The Fel Hammer is ours at last. Gaze upon the might of the Aldrachi Warblades!','',26124),
(107834,'enUS','Behold the power of the Aldrachi Warblades. The Fel Hammer is ours!','',26124),
(107835,'enUS','','$p... I thought I sensed a paltry whelp wandering where it shouldn\'t.',26124),
(107836,'enUS','','For every soul I claim, my power grows. I will rule this world... ALL worlds!',26124),
(107837,'enUS','','I\'ll reduce this entire canyon to rubble if I have to!',26124),
(107838,'enUS','','Saera! Taraar! They approach. Do not fail me!',26124),
(107839,'enUS','You are too late, child. Your father\'s corpse is now my vessel!','',26124),
(107840,'enUS','','Do you see those corpses? Their souls have been torn right out of their bodies!',26124),
(107841,'enUS','','I think we can make it across with a little... finesse.',26124),
(107842,'enUS','It looks like a pile of old spare parts. What once was powered by arcane has clearly run out of energy.','It looks like a pile of old spare parts. What once was powered by arcane has clearly run out of energy.',26124),
(107843,'enUS','All Hunters have a working knowledge of traps. This junk could probably be rigged together to resemble one...','All Hunters have a working knowledge of traps. This junk could probably be rigged together to resemble one...',26124),
(107844,'enUS','Quickly, hero! I can open a portal to the spirit world. You must destroy the Darkness inside before he claims another vessel.','',26124),
(107845,'enUS','It looks like a pile of old spare parts. What once was powered by arcane has clearly run out of energy.\n\nThis junk appears to have been neglected for too long.','It looks like a pile of old spare parts. What once was powered by arcane has clearly run out of energy.\n\nThis junk appears to have been neglected for too long.',26124),
(107846,'enUS','|TInterface\\Icons\\spell_frost_ring of frost:20|t%s begins to cast |cFFFF0000|Hspell:206949|h[Frigid Nova]|h|r!','|TInterface\\Icons\\spell_frost_ring of frost:20|t%s begins to cast |cFFFF0000|Hspell:206949|h[Frigid Nova]|h|r!',26124),
(107847,'enUS','|TInterface\\Icons\\ability_felarakkoa_feldetonation_green:20|t%s begins to cast |cFFFF0000|Hspell:206517|h[Fel Nova]|h|r!','|TInterface\\Icons\\ability_felarakkoa_feldetonation_green:20|t%s begins to cast |cFFFF0000|Hspell:206517|h[Fel Nova]|h|r!',26124),
(107848,'enUS','|TInterface\\Icons\\spell_priest_shadoworbs:20|t%s begins to cast |cFFFF0000|Hspell:207439|h[Void Nova]|h|r!','|TInterface\\Icons\\spell_priest_shadoworbs:20|t%s begins to cast |cFFFF0000|Hspell:207439|h[Void Nova]|h|r!',26124),
(107849,'enUS','|TInterface\\Icons\\Ability_Druid_Starfall:20|t%s begins to cast |cFFFF0000|Hspell:205408|h[Grand Conjunction]|h|r!','|TInterface\\Icons\\spell_frost_ring of frost:20|t%s begins to cast |cFFFF0000|Hspell:206949|h[Frigid Nova]|h|r!',26124),
(107850,'enUS','','Put your back into it, Taraar. Quickly!',26124),
(107851,'enUS','Me?! If you would focus, we\'d be done by now!','',26124),
(107852,'enUS','At last something reasonable escapes your lips!','',26124),
(107853,'enUS','Caria must complete her work. You will not interfere!','',26124),
(107854,'enUS','Reesh Archim, galar.','',26124),
(107855,'enUS','','UNGH! I\'m hit!',26124),
(107856,'enUS','','You... must continue. The Warblades are worth... any sacrifice!',26124),
(107857,'enUS','','I will secure a way out of here. Caria is yours.',26124),
(107858,'enUS','','I\'ll meet you at your order hall once you\'ve gathered the ingredients.',26124),
(107859,'enUS','','Yeah! I\'m ready for action!',26124),
(107860,'enUS','Use your |TInterface\\Icons\\ability_demonhunter_spectralsight.blp:20|t |cFFFF0000|Hspell:188501|h[Spectral Sight]|h|r to find Caria\'s trail!','Use your |TInterface\\Icons\\ability_demonhunter_spectralsight.blp:20|t |cFFFF0000|Hspell:188501|h[Spectral Sight]|h|r to find Caria\'s trail!',26124),
(107861,'enUS','','I heard Angus talking about it back at home. He said it makes you a million times stronger!',26124),
(107862,'enUS','','Yeahhhh! Another one bites the dust!',26124),
(107863,'enUS','','Awww, is the adventure over already? Okay...',26124),
(107864,'enUS','Fast little wikket, you are.  Stick with me and you\'ll go far!','',26124),
(107865,'enUS','How is it? Found many ingredients already?','',26124),
(107866,'enUS','More recruits show up every day, seeking to learn from the Master.','',26124),
(107867,'enUS','Good luck out there, $n.','',26124),
(107868,'enUS','','I can\'t take these infernals alone!',26124),
(107869,'enUS','Ey Master, nice ta see ya again! We heard ye might need some help gathering materials fer the Storm Brew.','',26124),
(107870,'enUS','I\'m happy ta help mastah, long as I get a taste a\' dat brew when it be done.','',26124),
(107871,'enUS','We\'ve been hearin\' reports of increased Legion activity near the Tomb of Sargeras.','',26124),
(107872,'enUS','Legion forces are amassin\' in great concentration there. Maybe for a large attack.','',26124),
(107873,'enUS','We\'ll fight wherever we need ta, but we\'d sure lose a lot fewer of our order if we had somethin\' like this Storm Brew.','',26124),
(107874,'enUS','I can\'t wait to try just a little taste o\' dat brew when it\'s ready.','',26124),
(107875,'enUS','That should do it! We\'ll report back to duty. Good luck, $n.','',26124),
(107876,'enUS','','Unhand my father\'s body, you monster!',26124),
(107877,'enUS','','Father! Fight it!',26124),
(107878,'enUS','Oh, how Ulan\'s spirit cries out! How he weeps, knowing he will be the instrument of your destruction!','',26124),
(107879,'enUS','How delicious... the hapless chieftain dying at the hands of her beloved father!','',26124),
(107880,'enUS','','Resist him, father! Do not let him control you!',26124),
(107881,'enUS','You failed to save your father in life. Now you fail his spirit! Such a disappointing daughter!','',26124),
(107882,'enUS','Your petty weapons are no match for me here.','',26124),
(107883,'enUS','Fascinating. You still think you can win?','',26124),
(107884,'enUS','No! Your spirits were to be mine...','',26124),
(107885,'enUS','','Aegira? My dear apprentice? It brings me joy to hear your voice.',26124),
(107886,'enUS','Welcome to MY world!','',26124),
(107887,'enUS','','Master... I am unworthy. I wish I had more time to learn from you. But you were avenged. Mornjirn is dead, and we recovered your Storm Brew recipe.',26124),
(107888,'enUS','','My dear Aegira, your skills are already beginning to surpass mine. From this day forward, no longer are you my apprentice. Go forward proudly as a Brewmaster, and continue my legacy.',26124),
(107889,'enUS','','Thank you, Master.',26124),
(107890,'enUS','Greg! Dance harder! People actually showed up to this scam... I mean event!','',26124),
(107891,'enUS','I pay you to dance Greg, not mope! So put some boogie into it!','',26124),
(107892,'enUS','Arcane energy thrums around the conduit. It seems to be linked to the Guardian Constructs somehow.\n\nUnfortunately, the intricacies of this mechanical construct are unknown to you.','Arcane energy thrums around the conduit. It seems to be linked to the Guardian Constructs somehow.\n\nUnfortunately, the intricacies of this mechanical construct are unknown to you.',26124),
(107893,'enUS','This is it Greg! We finally hit the big time! People from all over Azeroth are here at OUR event!','',26124),
(107894,'enUS','Greg. You\'re fired.','',26124),
(107895,'enUS','Brewing','Brewing',26124),
(107896,'enUS','Back in Dalaran from her successful world tour, it\'s... Tiffany Nelson! Today only, step up and challenge a true pet battle superstar!','',26124),
(107897,'enUS','Do you believe in miracles? Our challenger defeated Tiffany Nelson! Keep an eye on this up-and-coming superstar!','',26124),
(107898,'enUS','','The Legion witch is dead. Grandmaster, I think this calls for a celebration!',26124),
(107899,'enUS','Firelord? You are nothing but a pile of rocks!','',26124),
(107900,'enUS','Careful shaman. Play with fire and you will get burned...','',26124),
(107901,'enUS','Perhaps I underestimated your strength...','',26124),
(107902,'enUS','Today in the arena, it\'s the mighty Sir Galveston! He may be a bit of a nut case, but he paid the entrance fee... so he\'s in! Step right up and challenge the local lunatic!','',26124),
(107903,'enUS','Ladies and gentlemen, you just witnessed an epic victory over a guy who fights with a toy strapped to a bird. Frankly, it\'s not that impressive... but a win\'s a win!','',26124),
(107904,'enUS','','The ritual is nearly ready. Stop them, you mongrels!',26124),
(107905,'enUS','And in this corner, we have Bodhi Sunwayver... the shirtless guy! Why doesn\'t he wear a shirt? Is it being washed? Did he lose a bet? No one knows!','',26124),
(107906,'enUS','','I will claim every soul on this pathetic world!',26124),
(107907,'enUS','What a match! Bodhi may be terrible at pet battles, but he sure is easy on the eyes!','',26124),
(107908,'enUS','','The Legion is only the beginning. My blades call upon power from beyond!',26124),
(107909,'enUS','What a delicious looking intruder! It has been ages since I\'ve dined on mortal flesh! Long have I hungered for the taste...','',26124),
(107910,'enUS','I feel unwell...','',26124),
(107911,'enUS','Ugh, what is happening?','',26124),
(107912,'enUS','This fruit is horrible...','',26124),
(107913,'enUS','Ugh. I must find a physician!','',26124),
(107914,'enUS','Lower those weapons, bonemen. I am here for $p.','',26124),
(107915,'enUS','It looks like a war zone out there. Nicely done!','',26124),
(107916,'enUS','Welcome to my web, delicious mortal! I do hope you\'ll stick around!','',26124),
(107917,'enUS','I will rend your flesh and dine on your entrails!','',26124),
(107918,'enUS','Avenge me my children! Avenge me...','',26124),
(107919,'enUS','','I will need to focus on the vision to understand its message.\n\nWe have had our differences in the past, but this is bigger than both of us. Can I trust you?',26124),
(107920,'enUS','By my honor you will come to no harm, priestess.','By my honor you will come to no harm, priestess.',26124),
(107921,'enUS','','I pray we are not too late.',26124),
(107922,'enUS','','Meet me back at the refuge and we will continue our search. Be quick about it!',26124),
(107923,'enUS','','Do not let anything disturb my meditation.',26124),
(107924,'enUS','','Stay close. Do not let the Nightmare confound you.',26124),
(107925,'enUS','','The path splits. Wait, what is that?',26124),
(107926,'enUS','','The corruption is thick here. What is that across the bridge? Follow closely.',26124),
(107927,'enUS','Lower those weapons, pale elves. I am here for $p.','',26124),
(107928,'enUS','','There is no time to mourn. Elothir is beyond my reach now. Come, and do not delay.',26124),
(107929,'enUS','','Shala\'nir is just ahead. You should be ready for whatever foulness awaits us.',26124),
(107930,'enUS','','I admit, I was wary to have one of your kind accompany me. But you have fought with bravery and valor. Let us see this through together.\n\nAre you prepared to enter the epicenter of this chaos, $r?',26124),
(107931,'enUS','','Return to me, warrior of the Horde! I have found something!',26124),
(107932,'enUS','Turns out the egg held an ancient magical creature bent on watching the world burn. Luckily our challenger was victorious!','',26124),
(107933,'enUS','Featured in today\'s pet battle spectacular, it\'s... Hey, who put that egg in the arena? Uh... Step right up and fight a big egg! Beat up a defenseless egg, limited time only!','',26124),
(107934,'enUS','I claim this vessel.','',26124),
(107935,'enUS','','Show your face, Grey One!',26124),
(107936,'enUS','You ronir have grown strong during my long absence, Highmountain. But not strong enough.','',26124),
(107937,'enUS','','My people stopped you in ages past, Darkness. We will defeat you again.',26124),
(107938,'enUS','Your ancestors were overconfident as well. It shall prove to be your undoing.','',26124),
(107939,'enUS','Still... there is power in your bloodline, child. I shall relish claiming it.','',26124),
(107940,'enUS','','I will never serve you!',26124),
(107941,'enUS','One day... but you are not yet a worthy vessel for my power. No... I have a more... formidable chieftain in mind!','',26124),
(107942,'enUS','','What could he... Oh no... My father! He means to claim my father!',26124),
(107943,'enUS','Due to technical difficulties, today\'s tournament is canceled! Ow! That one bit me! Ow! Err... Please stand by! This little rat problem should be resolved shortly.','',26124),
(107944,'enUS','The tournament is saved! I\'m not sure how those rodents got out of their cages. Umm... did I say cages? What cages? It\'s not like I\'m part of a magically enhanced rat smuggling ring or something!','',26124),
(107945,'enUS','','Watch out! Doomguard headed your way!',26124),
(107946,'enUS','','Well fought, but Legion reinforcements are approaching as we speak. We must depart.',26124),
(107947,'enUS','[PH] And then a rad finale cinematic plays! [PH]','[PH] And then a rad finale cinematic plays! [PH]',26124),
(107948,'enUS','If you are unafraid of death, meet me at my throne. You may prove useful after all...','',26124),
(107949,'enUS','Soon, Lord Smolderon... you will kneel before the true Firelord!','',26124),
(107950,'enUS','Foolish mortals! Soon this place will belong to the master!','',26124),
(107951,'enUS','','Show them no quarter!',26124),
(107952,'enUS','','Smite the defiler!',26124),
(107953,'enUS','','Show them nature\'s wrath!',26124),
(107954,'enUS','','Andu-falah-dor!',26124),
(107955,'enUS','','Lord Ursoc! Quickly $n, to his side!',26124),
(107956,'enUS','','The ritual I\'m about to perform is complicated, and will take some time to finish, but it is the only way to drop the barrier.',26124),
(107965,'enUS','It\'s a tray of treats. It looks like this tray in particular has been infused with some strange arcane magic.','It\'s a tray of treats. It looks like this tray in particular has been infused with some strange arcane magic.',26124),
(107966,'enUS','It\'s a tray of treats. It looks like this tray in particular has been infused with some strange arcane magic.\n\nEating random magically infused food might be bad for your system... you don\'t know if it is safe or not.','It\'s a tray of treats. It looks like this tray in particular has been infused with some strange arcane magic.\n\nEating random magically infused food might be bad for your system... you don\'t know if it is safe or not.',26124),
(107967,'enUS','Years of training in the culinary arts has strongly developed your skill in Cooking. These parts here are safe to eat.','Years of training in the culinary arts has strongly developed your skill in Cooking. These parts here are safe to eat.',26124),
(107968,'enUS','As a Pandaren, all food is familiar to you. Nothing can break your iron belly. Time to eat!','As a Pandaren, all food is familiar to you. Nothing can break your iron belly. Time to eat!',26124),
(107969,'enUS','|TInterface\\Icons\\spell_mage_altertime:20|tYou\'ve been given a |cFFFF0000|Hspell:206617|h[Time Bomb]|h|r.','|TInterface\\Icons\\spell_mage_altertime:20|tYou\'ve been given a |cFFFF0000|Hspell:206617|h[Time Bomb]|h|r.',26124),
(107970,'enUS','|TInterface\\Icons\\inv_archonpet:20|t%s begins casting |cFFFF0000|Hspell:211927|h[Power Overwhelming]|h|r!','|TInterface\\Icons\\inv_archonpet:20|t%s begins casting |cFFFF0000|Hspell:211927|h[Power Overwhelming]|h|r!',26124),
(107971,'enUS','|TInterface\\Icons\\inv_archonpet:20|t%s reaches |cFFFF0000|Hspell:207972|h[Full Power]|h|r !','|TInterface\\Icons\\inv_archonpet:20|t%s reaches |cFFFF0000|Hspell:207972|h[Full Power]|h|r !',26124),
(107972,'enUS','','I see you, monk! Your struggle is for naught. My forces will purge your order from the face of this world!',26124),
(107973,'enUS','','You cannot hide from me, monk. Try as you might, but your monastery will burn!',26124),
(107974,'enUS','','You are stronger than you look, monk, but I will not be defied! Jorvinax! Keep that portal open!',26124),
(107975,'enUS','Greetings, and thank you for helping to test the Emerald Nightmare!\n\nI can teleport you directly to any bosses that are currently available for testing.','',26124),
(107976,'enUS','Why defy that which devours all things?','',26124),
(107977,'enUS','I want to teleport to Elerethe Renferal.','I want to teleport to Elerethe Renferal.',26124),
(107978,'enUS','A timely demise.','',26124),
(107979,'enUS','I want to teleport to Il\'gynoth, Heart of Corruption.','I want to teleport to Il\'gynoth, Heart of Corruption.',26124),
(107980,'enUS','So linear. So limited.','',26124),
(107981,'enUS','Time is on MY side.','',26124),
(107982,'enUS','The wheels of time turn against you.','',26124),
(107983,'enUS','Time races past you.','',26124),
(107984,'enUS','I want to teleport to Nythendra.','I want to teleport to Nythendra.',26124),
(107985,'enUS','Time will not be kind.','',26124),
(107986,'enUS','I want to teleport to Dragons of Nightmare.','I want to teleport to Dragons of Nightmare.',26124),
(107987,'enUS','Feel like time is standing still?','',26124),
(107988,'enUS','Time waits for no one.','',26124),
(107989,'enUS','I want to teleport to Xavius.','I want to teleport to Xavius.',26124),
(107990,'enUS','Precise. Perfect. Inevitable.','',26124),
(107991,'enUS','I want to teleport to Cenarius.','I want to teleport to Cenarius.',26124),
(107992,'enUS','My time has come.','',26124),
(107993,'enUS','I want to teleport to Ursoc.','I want to teleport to Ursoc.',26124),
(107994,'enUS','It was only a matter of time.','',26124),
(107995,'enUS','Your pets are so atrocious, I consider it a provocation!','',26124),
(107996,'enUS','If only you knew what lay beyond...','',26124),
(107997,'enUS','Such insolence... very well, I shall show you!','',26124),
(107998,'enUS','See for yourself the cruel, frozen void that lies beyond the margin of Azeroth\'s skies!','',26124),
(107999,'enUS','The stars align! Fear their portents!','',26124),
(108000,'enUS','No mortal may abrogate the precepts of fate!','',26124),
(108001,'enUS','As the stars wax, so your lives wane!','',26124),
(108002,'enUS','I have all the time in the world.','',26124),
(108003,'enUS','Lets begin your lesson in humility.','',26124),
(108004,'enUS','Lesson over.','',26124),
(108005,'enUS','Begone! I need time to contemplate this affront.','',26124),
(108006,'enUS','So undisciplined.','',26124),
(108007,'enUS','You will learn respect or I will continue to educate you in it.','',26124),
(108008,'enUS','That one isn\'t fit to clean my quarters, much less battle!','',26124),
(108009,'enUS','Interesting, show me more.','',26124),
(108010,'enUS','An unfortunate miscalculation.','',26124),
(108011,'enUS','You cannot discern between a victory or a sacrifice.','',26124),
(108012,'enUS','','These hoofprints follow the path to the left. After them, quickly!',26124),
(108013,'enUS','','I cannot tell where his voice is coming from! Search the buildings to the west! Now! I will scour the east for signs of him!',26124),
(108014,'enUS','','Warrior of the Horde! To me! I have found something!',26124),
(108015,'enUS','','I can\'t... hold... anymore...',26124),
(108016,'enUS','','This is too much to bear!',26124),
(108017,'enUS','','Augghhh!!',26124),
(108018,'enUS','','H-help! I can\'t hold... on...',26124),
(108019,'enUS','I thank you, druids. These abominations of Nightmare are relentless! They will stop at nothing to snatch the claws from my lair.','',26124),
(108020,'enUS','','Lord Ursoc, the Burning Legion has returned. $n is our best hope to drive back the Legion AND the Nightmare, but we must have the claws if we are to succeed!',26124),
(108021,'enUS','','We humbly request your aid. The power of your claws could defeat our enemies once and for all.',26124),
(108022,'enUS','','Lord Ursoc, I merely returned the claws to their rightful place; a place where their power would not be abused.',26124),
(108023,'enUS','','Thank you, mighty Ursoc!',26124),
(108024,'enUS','Meeting me must be overwhelming. Understandable... the low-born are often stricken dumb in my presence. Luckily for you, I am feeling charitable and will honor you with a battle.','',26124),
(108025,'enUS','A fluke! A mishap! Someone of my station does not lose to a commoner with such boorish manners. Tell no one of this encounter.','',26124),
(108026,'enUS','Good to see you, friend.','',26124),
(108027,'enUS','I... um... misplaced that crystal thing you gave me. Do you have another?','I... um... misplaced that crystal thing you gave me. Do you have another?',26124),
(108028,'enUS','Greetings, and thank you for helping to test the Suramar Palace!\n\nI can teleport you directly to any bosses that are currently available for testing.','',26124),
(108029,'enUS','This sacred peak is for hunters alone.$bTurn back, or the eagle spirit will carry you away!','This sacred peak is for hunters alone.$bTurn back, or the eagle spirit will carry you away!',26124),
(108030,'enUS','I want to teleport to Crystal Scorpion.','I want to teleport to Crystal Scorpion.',26124),
(108031,'enUS','I want to teleport to Chronomatic Anomaly.','I want to teleport to Chronomatic Anomaly.',26124),
(108032,'enUS','I want to teleport to Trilliax.','I want to teleport to Trilliax.',26124),
(108033,'enUS','I want to teleport to Spellblade Aluriel.','I want to teleport to Spellblade Aluriel.',26124),
(108034,'enUS','I want to teleport to Tichondrius.','I want to teleport to Tichondrius.',26124),
(108035,'enUS','Kayn, I need to return to the Black Temple.','Kayn, I need to return to the Black Temple.',26124),
(108036,'enUS','I want to teleport to Astromancer Etraeus.','I want to teleport to Astromancer Etraeus.',26124),
(108037,'enUS','I want to teleport to High Botanist Tel\'arn.','I want to teleport to High Botanist Tel\'arn.',26124),
(108038,'enUS','I want to teleport to Krosus.','I want to teleport to Krosus.',26124),
(108039,'enUS','I want to teleport to Grand Magistrix Elisande.','I want to teleport to Grand Magistrix Elisande.',26124),
(108040,'enUS','I want to teleport to Gul\'dan.','I want to teleport to Gul\'dan.',26124),
(108041,'enUS','','I heard your call for aid, great one. Are there any teeny lil\' fuzzy animals in danger? Oh! Oh my!',26124),
(108043,'enUS','The other spiders seem wary of this one.','',26124),
(108044,'enUS','I am Grash, son of Gralashar.$b$bThe snake witch controls us with magic stick. Those who fight she takes away to kill.$b$bHave you come to kill snake witch?','',26124),
(108045,'enUS','She calls herself \"Lady Zithreen.\" She has many snakes. Snakes who follow her. Snakes on her face.$b$bShe claims water throne for her queen, using magic stick.','',26124),
(108046,'enUS','<Grash frowns.>$b$bMagic stick is very old. Very powerful. It is made of living water.$b$bSnake witch says the magic stick came from her queen. It speaks to the sea. Sea monsters obey the stick. It heals their wounds.$b$bStick fill the heads of giants with dark and pain. The dark comes from the witch, not the stick.','',26124),
(108047,'enUS','Sha-man? Like, little one who speaks to water and storms? $b$bYes, Grash has seen her. She fights the snake witch and loses.$b$bSnake witch keeps her alive. Says stupid people will come for her.$b$bHa hah! Snake witch is the dumb one. No one stupid enough to come for shaman lady.','',26124),
(108048,'enUS','You will kill snake witch?$b$bYou will take away magic stick?$b$bYes! Grash will help!','',26124),
(108049,'enUS','Who is this snake witch?','Who is this snake witch?',26124),
(108050,'enUS','We seek a magic stick! What does it look like?','We seek a magic stick! What does it look like?',26124),
(108051,'enUS','We are looking for a shaman. Have you seen her?','We are looking for a shaman. Have you seen her?',26124),
(108052,'enUS','Join us! We will kill the \"snake witch\" and take this \"magic stick!\"','Join us! We will kill the \"snake witch\" and take this \"magic stick!\"',26124),
(108053,'enUS','Let\'s go!','Let\'s go!',26124),
(108054,'enUS','We must keep these catacombs clear. Not all of us are strong enough to use the portals and must resort to other means of travel, unsettling though they may be.','',26124),
(108055,'enUS','%s\'s bark begins to splinter!','',26124),
(108056,'enUS','In times like these, everyone must get their hands dirty.','',26124),
(108057,'enUS','','It is finished! The claws are ours!',26124),
(108058,'enUS','Your allies have fallen! The ritual has failed!','Your allies have fallen! The ritual has failed!',26124),
(108059,'enUS','I must go attend to my prize. Malithar, I leave the claws to you. Use them to exterminate this filth.','',26124),
(108060,'enUS','','You did it, $n! You got him!',26124),
(108061,'enUS','','We should go. There\'s nothing left for us here. Let me know when you\'re ready to leave and I\'ll take us back to our bodies in the normal world.',26124),
(108062,'enUS','','Are you ready to leave?',26124),
(108063,'enUS','','Champion, once again we must ask that you go where we cannot follow. Helya\'s forces must be weakened if we are to prevail.',26124),
(108064,'enUS','Let\'s go.','Let\'s go.',26124),
(108065,'enUS','','Do not overextend yourself. The time will come when Helya will face Odyn\'s full wrath. But until then, you have weakened her forces.',26124),
(108066,'enUS','Are you sure you want to begin the encounter?','Are you sure you want to begin the encounter?',26124),
(108067,'enUS','I am ready.','I am ready.',26124),
(108068,'enUS','Are you ready to begin the ritual?','Are you ready to begin the ritual?',26124),
(108069,'enUS','This glowing flower very distinctly stands out. It looks to have been meticulously cared for by someone with great horticultural skills.','This glowing flower very distinctly stands out. It looks to have been meticulously cared for by someone with great horticultural skills.',26124),
(108070,'enUS','These new challengers seek to complete the trials you have bested. Show them how a true champion fights!','',26124),
(108071,'enUS','Better you taught them their place is in this life now than delude themselves further.','',26124),
(108072,'enUS','This glowing flower very distinctly stands out. It looks to have been meticulously cared for by someone with great horticultural skills.\n\nProbably best to leave this one to someone more in tune with nature.','This glowing flower very distinctly stands out. It looks to have been meticulously cared for by someone with great horticultural skills.\n\nProbably best to leave this one to someone more in tune with nature.',26124),
(108073,'enUS','Desmond seems to have crossed someone he shouldn\'t have.','',26124),
(108074,'enUS','<Search the body for clues.>','<Search the body for clues.>',26124),
(108075,'enUS','The Inkbinders have lost their way! They forget the true purpose of our runic magic traditions. They must be stopped before they pervert these customs further.','',26124),
(108076,'enUS','To think I would live to see such profane use of runic magic. It saddens my heart.','',26124),
(108077,'enUS','There\'s nothing here.','There\'s nothing here.',26124),
(108078,'enUS','','We shall meet again, $n. May Elune guide our paths.',26124),
(108079,'enUS','Picking the flower just here should release invigorating spores. You know this because you studied Herbalism and know about plant things.','Picking the flower just here should release invigorating spores. You know this because you studied Herbalism and know about plant things.',26124),
(108080,'enUS','Breathe deep of its spores. As a Druid, you are attuned to nature and can recognize this flower\'s beneficial properties.','Breathe deep of its spores. As a Druid, you are attuned to nature and can recognize this flower\'s beneficial properties.',26124),
(108081,'enUS','We are everywhere. We are Legion.','',26124),
(108082,'enUS','Meddling... whelp...','',26124),
(108083,'enUS','Welcome, $p. As a subtlety rogue you specialize in striking from the shadows, dispatching foes quickly and quietly. Let\'s begin your training with your primary attack, Backstab.','',26124),
(108084,'enUS','Use Backstab on this target dummy. Attacking from behind inflicts more damage.','',26124),
(108085,'enUS','','Demons continue to march on the Gates of the Valor. Your aid is required.',26124),
(108086,'enUS','','You have done well this day, champion. May the Twisting Nether be filled with the lamentations of your enemies.',26124),
(108087,'enUS','What brings you to this lawless place?','',26124),
(108088,'enUS','The shadows reveal.','The shadows reveal.',26124),
(108089,'enUS','The Burning Legion. Slayers of whole worlds.','',26124),
(108090,'enUS','Could we hope to resist? Can you?!','',26124),
(108091,'enUS','Held to the majesty of the stars, you are nothing - less than nothing.','',26124),
(108092,'enUS','What are you exactly?','What are you exactly?',26124),
(108093,'enUS','What meager petulance. I expected more from you.','',26124),
(108094,'enUS','Is that not enough? Must I show you the true horror of our reality?','',26124),
(108095,'enUS','Very well... witness what I have seen, and TREMBLE!','',26124),
(108096,'enUS','Avatars of non-existence... knowing nothing but hunger.','',26124),
(108097,'enUS','These are the beings who will devour the future you so futilely fight to protect!','',26124),
(108098,'enUS','No... I cannot control... the void... it comes!','',26124),
(108099,'enUS','I provide information that no other can.$B$BThat is all you need to know.','',26124),
(108100,'enUS','The stars have judged you, and found you wanting.','',26124),
(108101,'enUS','Let\'s get back to the matter at hand.','Let\'s get back to the matter at hand.',26124),
(108102,'enUS','','Those creatures over there are empowered by ancient mana. It is awful to ask this of you, but I need you to dispatch them and siphon their energy.',26124),
(108103,'enUS','It seems fate is on your side.','',26124),
(108104,'enUS','','Thank you. It is a horrid duty, but this work is essential for our survival.',26124),
(108105,'enUS','Akaari is in this very city as we speak, spying for her masters.','',26124),
(108106,'enUS','I will gladly tell you where... in exchange for a rune of portals.','',26124),
(108107,'enUS','Until then, our business is complete.','',26124),
(108108,'enUS','','We go to the Temple of Elune. We will ride more swiftly on Ash\'alah\'s back. Are you ready to depart?',26124),
(108109,'enUS','','We go to the Temple of Elune. Ash\'alah will carry you this once. Prepare yourself.',26124),
(108110,'enUS','Greetings! Are you here to see my exquisite collection?','',26124),
(108111,'enUS','If you are here to see my most prized possession, I am afraid that I have it locked away.$b$bI might bring it out in a hundred years or so. Would you like to make an appointment?','',26124),
(108112,'enUS','I am Mornath, a collector of fine arts and collectibles. Would you like to see my statue collection?','',26124),
(108113,'enUS','Lespin wants his sculpture back.','Lespin wants his sculpture back.',26124),
(108114,'enUS','Return to nothing.','',26124),
(108115,'enUS','You can not avoid annihilation.','',26124),
(108116,'enUS','I was beginning to doubt you would come.','',26124),
(108117,'enUS','I carry only the highest quality products.','',26124),
(108118,'enUS','Show me your latest wares.','Show me your latest wares.',26124),
(108119,'enUS','The shadows reveal.','The shadows reveal.',26124),
(108120,'enUS','Nothing to share, I\'m afraid. The wine gets people talking, but sometimes they just don\'t have anything useful to say.','',26124),
(108121,'enUS','Say, care for some Moist Azsunian Feta while you\'re here? It has a lovely tangy flavor!','',26124),
(108122,'enUS','This will remove a |cFF0070dd|Hitem:124441:0:0:0:0:0:0:0:90:0|h[Leylight Shard]|h|r from your inventory. Are you sure?','This will remove a |cFF0070dd|Hitem:124441:0:0:0:0:0:0:0:90:0|h[Leylight Shard]|h|r from your inventory. Are you sure?',26124),
(108123,'enUS','','We\'re finally closing in on her after all these years...',26124),
(108124,'enUS','','I\'ll meet you upstairs in Glorious Goods when you\'re done. Another one of Khadgar\'s dogs has been nosing around, asking too many questions...',26124),
(108125,'enUS','','If you don\'t have any leylight shards on you, I\'m afraid I can\'t finish the ritual.$b$bMaybe you left some in your bank?',26124),
(108126,'enUS','Do not think... the future will be so easy.','',26124),
(108127,'enUS','I heard you might have a tome I\'m looking for.','I heard you might have a tome I\'m looking for.',26124),
(108128,'enUS','Ah, yes, I know the one. It should be on one of the shelves upstairs. Feel free.','',26124),
(108129,'enUS','I haven\'t exploded anybody yet today. It\'s a good day!','',26124),
(108130,'enUS','Hmm... you didn\'t see any nuclear bombs on your way in, did you? No? Alright, I\'ll keep looking.','',26124),
(108131,'enUS','This Oshenko fella\' is always using \"screwdrivers\" on his screws. Hasn\'t he ever heard of a hammer?','',26124),
(108132,'enUS','As a retribution paladin you are a stalwart protector of the weak, a bringer of punishment to the unjust!','',26124),
(108133,'enUS','Use Judgment on this target dummy.','',26124),
(108134,'enUS','Musken will trample your bones to dust!','',26124),
(108135,'enUS','Bears will rend the flesh from your bones!','',26124),
(108136,'enUS','You\'ve been detected!','You\'ve been detected!',26124),
(108137,'enUS','Musken! Bless me with fortitude!','',26124),
(108138,'enUS','Ha! Musken prove to be the strongest once again!','',26124),
(108139,'enUS','I am disgraced.','',26124),
(108140,'enUS','Crushed under hoof!','',26124),
(108141,'enUS','More! Bring me more to crush!','',26124),
(108142,'enUS','Glory in battle!','',26124),
(108143,'enUS','','Stay in the shadows to avoid detection. The Kirin Tor are no fools.',26124),
(108144,'enUS','Looting','Looting',26124),
(108145,'enUS','Bjorn! Bless me with savagery!','',26124),
(108146,'enUS','Ha! Bears prove to be the strongest once again!','',26124),
(108147,'enUS','I am disgraced.','',26124),
(108148,'enUS','Torn by claws!','',26124),
(108149,'enUS','More! Bring me more to rip apart!','',26124),
(108150,'enUS','Glory in battle!','',26124),
(108151,'enUS','[PH] You are about to drop Poop, get out of the raid!','',26124),
(108152,'enUS','','The captain will have my head if I do not return soon...',26124),
(108153,'enUS','','Yes, citizen?',26124),
(108154,'enUS','','State your business, or move along. I am expecting someone.',26124),
(108155,'enUS','','Finally, the diamond stabilizers we commissioned. Maybe now the power conduits will stop shorting out.',26124),
(108156,'enUS','','My sparring partner Naltethis told me what you did. You would make a good soldier.',26124),
(108157,'enUS','I have your package from Lespin.','I have your package from Lespin.',26124),
(108158,'enUS','','Eyir! Witness my deeds as I slice down this so-called champion.',26124),
(108159,'enUS','Millenia without so much as a barge to log, and now I am up to my ears in manifests and shipping records.','',26124),
(108160,'enUS','Make it quick. The seas wait for no one.','',26124),
(108161,'enUS','I am busier now than I have been in almost ten thousand years. What do you want with me?','',26124),
(108162,'enUS','Excellent, my gold pin is here. After all, an illustrious official deserves an equally illustrious badge of office, does he not?','',26124),
(108163,'enUS','I have seen Anastae\'s newest coat. Tell me, are you going to be getting more pelts? I will pay you more than what you are currently making running errands for Lespin.','',26124),
(108164,'enUS','','There are those among the Valkyra who wish to test you in single combat. Go to Skold-Ashil and face them in battle. None shall attack until you strike the first blow.',26124),
(108165,'enUS','My birds sing such lovely songs.','',26124),
(108166,'enUS','What a lovely day.','',26124),
(108167,'enUS','\'Borrowing\'','\'Borrowing\'',26124),
(108168,'enUS','You have something for me, yes?','',26124),
(108169,'enUS','Ah, what a beautiful perch. A perfect replacement for the broken one.','',26124),
(108170,'enUS','Lespin is reaching the end of his usefulness, I think. You would be wise to be careful.','',26124),
(108171,'enUS','','I go... to the halls... of valor.',26124),
(108177,'enUS','Reveal yourself!','Reveal yourself!',26124),
(108178,'enUS','Archmage Celindra must not be disturbed!','Archmage Celindra must not be disturbed!',26124),
(108179,'enUS','','I definitely heard something. Don\'t worry, Archmage, I\'ll find them!',26124),
(108180,'enUS','I heard it, too, Archmage. I will expel them at once!','',26124),
(108181,'enUS','There you are!','There you are!',26124),
(108182,'enUS','','My wards detected someone entering the study. Find them at once!',26124),
(108183,'enUS','','Champion! Know that you face Bretta, the herald of your doom.',26124),
(108184,'enUS','<Hand the Rune of Portals to Val\'zuun.>','<Hand the Rune of Portals to Val\'zuun.>',26124),
(108185,'enUS','Excellent... you will find Akaari in the Legerdemain Lounge.','',26124),
(108186,'enUS','','Let us have a glorious battle.',26124),
(108187,'enUS','','I shall claim the honor of your death.',26124),
(108188,'enUS','','I shall stain this ground with your blood.',26124),
(108189,'enUS','','Akaari... your time has come.',26124),
(108190,'enUS','','Eyir... guide me to your side.',26124),
(108191,'enUS','','I go to face my destiny...',26124),
(108192,'enUS','','Only the greatest of the Valkyra are worthy of Eyir\'s gift.',26124),
(108193,'enUS','','The three fallen brothers of God-King Skovald have arisen. Find them, champion, and remind them why they should stay dead.',26124),
(108194,'enUS','','Four brothers. Each raised a hand in slaying his father. Each raised a hand in slaying each other. And so Skovald became king, for his blade was the fastest.',26124),
(108195,'enUS','','The lounge is secure, $p.',26124),
(108196,'enUS','','All clear, $p.',26124),
(108197,'enUS','','Akaari retreated upstairs as we arrived. She\'s all yours.',26124),
(108200,'enUS','','I should thank you. You\'ve saved me the effort of finding you.',26124),
(108201,'enUS','','Kil\'jaeden will be pleased when I bring him your head.',26124),
(108202,'enUS','','You think my master so foolish...?',26124),
(108203,'enUS','There is snake-man in next room. Big snake-man.$b$bGrash can smell the fish-breath.','',26124),
(108204,'enUS','Everyone\'s ready, Grash. Smash the ice wall!','Everyone\'s ready, Grash. Smash the ice wall!',26124),
(108205,'enUS','I will drag you and your pets into the ocean depths.','',26124),
(108206,'enUS','Muster your defenses mortal.','',26124),
(108207,'enUS','Join me in the depths.','',26124),
(108208,'enUS','Drowning. I am drowning.','',26124),
(108209,'enUS','Another soul soon joins us.','',26124),
(108210,'enUS','Lay still and let the water take you.','',26124),
(108211,'enUS','Death comes quickly to the weak.','',26124),
(108212,'enUS','Another takes its place.','',26124),
(108213,'enUS','You begin to irritate me mortal.','',26124),
(108214,'enUS','Your death will be slow and savored.','',26124),
(108216,'enUS','','Do you have the fangs?',26124),
(108220,'enUS','','Val\'zuun, I will be your death!',26124),
(108221,'enUS','','One by one, you will all fall to the Fangs.',26124),
(108222,'enUS','','Kirel volosh!',26124),
(108223,'enUS','','Miserable worm. Die!',26124),
(108224,'enUS','','I strike from the shadows.',26124),
(108225,'enUS','Something is near. Something big.','',26124),
(108226,'enUS','Stop! Stop! I did not know! I swear it!','',26124),
(108227,'enUS','I can still help you! I can take you to Akaari\'s stronghold!','',26124),
(108228,'enUS','Judgment can be used on enemies at a distance or up close whenever it is available.','',26124),
(108229,'enUS','Use Blade of Justice on this target dummy.','',26124),
(108230,'enUS','Yes, Lord Xavius! I\'ll be happy to tear them apart in your name!','',26124),
(108231,'enUS','AAARRRRGGGHHHH!!! THE CLAWS! THEY THIRST FOR BLOOD!!','',26124),
(108232,'enUS','Blade of Justice is an excellent tool to deal damage as your opponent approaches.','',26124),
(108233,'enUS','Use Crusader Strike on this target dummy.','',26124),
(108247,'enUS','Are you ready to begin?','',26124),
(108248,'enUS','Open the portal.','Open the portal.',26124),
(108249,'enUS','Thank you for seeing reason.','',26124),
(108250,'enUS','Ered\'achor, shudas\'urzul... kurai.','',26124),
(108251,'enUS','','Good luck on the Trials, champion.',26124),
(108252,'enUS','','For the Alliance!',26124),
(108253,'enUS','My musken will trample your tiny bear!','',26124),
(108254,'enUS','The puny one has great beasts!','',26124),
(108255,'enUS','I\'ll drag your beasts to Helheim to join Helya\'s cursed stable!','',26124),
(108256,'enUS','Sleep lightly, no beast eludes me long...','',26124),
(108257,'enUS','It is done. The way to Shadowgore Citadel is open.','',26124),
(108258,'enUS','You feel a foreboding presence - you are not welcome here.','You feel a foreboding presence - you are not welcome here.',26124),
(108259,'enUS','Move out and support the Farseer! Show the Firelands the strength of the Earthen Ring!','',26124),
(108260,'enUS','','Cleanse the staff, my children. I will keep the beast at bay!',26124),
(108261,'enUS','','Quickly, hero! Our work is nearly complete. You must give me the staff!',26124),
(108262,'enUS','I was hopin\' for a warm welcome... but this ain\'na what I had in mind!','',26124),
(108263,'enUS','','The Farseer approaches! Let\'s show these blasted bugs what we\'re made of!',26124),
(108264,'enUS','The Earthen Ring stands with you, Farseer!','',26124),
(108265,'enUS','Demons besiege my peak! We need your skills in battle, champion.','',26124),
(108266,'enUS','Well done. You have given us the edge we need against these foul creatures. You have my thanks, mortal!','',26124),
(108267,'enUS','Hail, friend. The drekirjar filth continue to slay and enslave my kin. Come, fly with me, and together we shall heap vengeance upon Hrydshal!','',26124),
(108268,'enUS','Would that we could level all of Hrydshal in one fell swoop! Alas, vengeance must come in waves.','',26124),
(108269,'enUS','<Give Lyessa the staff>.','<Give Lyessa the staff>.',26124),
(108270,'enUS','Put your backs into it! Let the heat of combat fuel your resolve!','',26124),
(108271,'enUS','$n. I\'m just checking in before I return to the Fel Hammer.\n\nIf there\'s a mission you\'d rather I go on, I await your orders.','',26124),
(108273,'enUS','','Your presence is requested in the Halls of Valor. Are you ready?',26124),
(108274,'enUS','Take me to the Halls of Valor.','Take me to the Halls of Valor.',26124),
(108275,'enUS','|TInterface\\Icons\\ability_felarakkoa_feldetonation_red:20|t %s gains |cFFFF0000|Hspell:206221|h[Empowered Bonds of Fel]|h|r.','',26124),
(108276,'enUS','|TInterface\\Icons\\Spell_Fire_FelFlameStrike:20|t %s gains |cFFFF0000|Hspell:206220|h[Empowered Liquid Hellfire]|h|r.','',26124),
(108277,'enUS','|TInterface\\Icons\\inv_misc_trinket6oih_orb1:20|t %s gains |cFFFF0000|Hspell:211152|h[Empowered Eye of Gul\'dan]|h|r.','',26124),
(108279,'enUS','|TInterface\\Icons\\Spell_Shadow_MindRot:20|t %s summons $n for aid|h|r.','',26124),
(108280,'enUS','Now, let\'s destroy the rest of these demons!','Now, let\'s destroy the rest of these demons!',26124),
(108281,'enUS','','Have you come to be judged?',26124),
(108282,'enUS','','Let us see if those you have brought are worthy.',26124),
(108283,'enUS','','These trials are not to be taken lightly.',26124),
(108284,'enUS','','The hunting ground awaits.',26124),
(108285,'enUS','','Death should not be feared.',26124),
(108286,'enUS','Their numbers seem endless, but we will prevail.','Their numbers seem endless, but we will prevail.',26124),
(108287,'enUS','','Life is fleeting.',26124),
(108288,'enUS','','Only greatness endures.',26124),
(108289,'enUS','','There is another.',26124),
(108290,'enUS','','That was your best attack? Honestly?',26124),
(108291,'enUS','Hey $n! Yeah, you! Ignore all that blah about cleansing the land for now and kill this big guy over here.','',26124),
(108292,'enUS','I think Jace likes his toys a bit too much.','I think Jace likes his toys a bit too much.',26124),
(108293,'enUS','Don\'t get used to this.$b$bAs soon as we finish up with this construction gig we\'re clearing out of here.','',26124),
(108294,'enUS','','Odyn\'s hunting grounds contain the all manner of great beasts. Let us see if any of your creatures are worthy to be counted among them.',26124),
(108295,'enUS','','Though your beasts have been proven worthy, it is not their time to join our ranks. They are destined to enjoy many more glorious battles.',26124),
(108296,'enUS','Hey, you\'re not supposed to be in here!$b$bLook, we don\'t have the insurance and you\'re a liability.$b$bI\'m gonna have to ask you to leave.','',26124),
(108297,'enUS','Akaari is just across the citadel from you. With your skill, you should be able to reach her undetected.','',26124),
(108298,'enUS','Think you could get me out of here?','Think you could get me out of here?',26124),
(108299,'enUS','Hey, you\'re not supposed to be here!$b$bLook, we don\'t have the insurance to cover you and you being here is a liability. I bet you\'re already stuck even!$b$bI\'m going to spring you out but do yourself a favor and let us finish before you go exploring again, alright?','',26124),
(108300,'enUS','Got it, thanks.','Got it, thanks.',26124),
(108301,'enUS','Everything you love will burn!','',26124),
(108302,'enUS','I will shatter your world!','',26124),
(108303,'enUS','I\'ll pound you to dust!','',26124),
(108304,'enUS','You will break...','',26124),
(108305,'enUS','Laughable! A wonder this world survived so long.','',26124),
(108306,'enUS','','I think you\'re ready for more!',26124),
(108307,'enUS','','Shall we raise the stakes?',26124),
(108308,'enUS','You may enter, but spare me your pleas for help, shaman. I know of the Earthen Ring\'s plan to unite the elements!','',26124),
(108309,'enUS','The Burning Legion threatens us all, but the power of the Firelands must be earned.','',26124),
(108310,'enUS','Will your kind never learn?','',26124),
(108311,'enUS','Approach my throne and we shall see just how far you will go to save this world!','',26124),
(108312,'enUS','','Feel the fury of a thousand blades!',26124),
(108313,'enUS','','Behold a true mistress of the blade!',26124),
(108314,'enUS','','Prepare for the deepest cut of all!',26124),
(108315,'enUS','','It would be unfair for me to have all the fun...',26124),
(108316,'enUS','','Teach these upstarts a lesson, my minions!',26124),
(108317,'enUS','','Amateurs! You are your own worst enemies!',26124),
(108318,'enUS','','Watch your footing! I\'d hate to see you slip up.',26124),
(108319,'enUS','','I give you a chance for glory, and you make a mess of it!',26124),
(108320,'enUS','','I must... concede...',26124),
(108321,'enUS','','Consider this a lesson in swordplay!',26124),
(108322,'enUS','','You cannot hope to match my skill!',26124),
(108323,'enUS','','How fortunate they were to face so skilled a foe! I would envy them... if they weren\'t all dead.',26124),
(108324,'enUS','','How surprising... another kill for me!',26124),
(108325,'enUS','','Let your fates be bound together!',26124),
(108326,'enUS','','Feel the icy grip of defeat!',26124),
(108327,'enUS','','You have my attention!',26124),
(108328,'enUS','','I\'m coming for you!',26124),
(108329,'enUS','','Death comes from above!',26124),
(108330,'enUS','','A bit of magic could make this more interesting!',26124),
(108331,'enUS','','Time to clear away the debris!',26124),
(108332,'enUS','','I control this battlefield!',26124),
(108333,'enUS','|TInterface\\Icons\\INV_Misc_Rune_10:20|t Shatter the runestone to interrupt Runeseer Faljar\'s |cFFFF0404|Hspell:208544|h[Runic Bulwark]|h|r!','|TInterface\\Icons\\INV_Misc_Rune_10:20|t Shatter the Empowered Runestone to interrupt Runeseer Faljar\'s |cFFFF0404|Hspell:208544|h[Runic Bulwark]|h|r!',26124),
(108334,'enUS','Using Blade of Justice and Crusader Strike in combat builds up Holy Power.','',26124),
(108335,'enUS','Build up Holy Power by using your attacks, then use Templar\'s Verdict on this target dummy.','',26124),
(108338,'enUS','DO NOT LOCALIZE','DO NOT LOCALIZE',26124),
(108339,'enUS','Emberscar has awakened and thirsts for souls. Defeat the Cinderweb Ambushers!','',26124),
(108340,'enUS','The master has returned! We must ensure the household is immaculate.','',26124),
(108341,'enUS','That\'s not the master, imbecile! Unless he managed to claw his way out from under two tons of solid stone.','',26124),
(108342,'enUS','Ooo, that would be impressive... considering I still have his hands in a jar.','',26124),
(108343,'enUS','Please don\'t say such things! The master is back, and things need to be kept tidy.','',26124),
(108344,'enUS','You\'re tracking mud everywhere!','',26124),
(108345,'enUS','Did you receive satisfactory service?','',26124),
(108346,'enUS','Have a bite master, I know it\'s your favorite.','',26124),
(108347,'enUS','%s writhes in agony.','',26124),
(108348,'enUS','You dare leave crumbs on my floor?! Die!!!','',26124),
(108349,'enUS','Filthy, filthy, filthy!!!','',26124),
(108350,'enUS','Hold still, master, for incineration!','',26124),
(108351,'enUS','Stop squirming! Makes it hard to stab you!','',26124),
(108352,'enUS','So good to see you master, how may I sever you?','',26124),
(108353,'enUS','%s winces and mumbles incoherently.','',26124),
(108354,'enUS','Welcome home master, may I take your... HEAD!!!','',26124),
(108355,'enUS','Well done, Farseer. Emberscar is mine and those who opposed my rule lay silenced!','',26124),
(108356,'enUS','Master, is that you?! I barely recognized you with your head attached.','',26124),
(108357,'enUS','Can you please die without making such a mess?!','',26124),
(108358,'enUS','How dare you track blood across my floor!','',26124),
(108359,'enUS','As a symbol of my allegiance, I shall send my servant Scaldius to aid the Earthen Ring.','',26124),
(108360,'enUS','You look famished, master. Please, have some refreshments.','',26124),
(108361,'enUS','Well struck sir, right in my pain cluster.','',26124),
(108362,'enUS','I\'m not sure what I\'ve done, but I\'m positive I deserve this beating.','',26124),
(108363,'enUS','Pain is an effective teacher, and I endeavor to learn your lesson, master.','',26124),
(108364,'enUS','Apologies for the mess, master. I shall tidy up immediately.','',26124),
(108365,'enUS','The Burning Legion shall tremble before the terror of the Firelord!','',26124),
(108366,'enUS','Tread carefully in my domain, shaman. Even Farseers can burn...','',26124),
(108367,'enUS','Oh, my head... where am I?','',26124),
(108368,'enUS','The Firelands is the most fearsome of the elemental planes. We should tread lightly and respect our surroundings here.','',26124),
(108369,'enUS','Eye of Xirus looks in your direction!','',26124),
(108370,'enUS','Eye of Xirus spots you and runs to its allies for help!','',26124),
(108371,'enUS','Greetings, Master $n. How are you today?','Greetings, Master $n. How are you today?',26124),
(108372,'enUS','It is now, among the darkness, that the light shines most brilliantly.','',26124),
(108373,'enUS','Everyone is worried about the Legion, but we believe in you, Master.','Everyone is worried about the Legion, but we believe in you, Master.',26124),
(108374,'enUS','It is good to see you, Master. You put us all in good spirits.','It is good to see you, Master. You put us all in good spirits.',26124),
(108375,'enUS','The Order of the Broken Temple will survive under your leadership. It must...','The Order of the Broken Temple will survive under your leadership. It must...',26124),
(108376,'enUS','Where are you off to today, Master?','Where are you off to today, Master?',26124),
(108377,'enUS','Our efforts are going to pay off, I know it.','Our efforts are going to pay off, I know it.',26124),
(108378,'enUS','We cannot give up the fight, Master. I trust your judgment completely.','We cannot give up the fight, Master. I trust your judgment completely.',26124),
(108379,'enUS','To be a monk is to strive for harmony and balance. There is no one better to lead us than you, $n.','To be a monk is to strive for harmony and balance. There is no one better to lead us than you, $n.',26124),
(108380,'enUS','The estate is gorgeous, is it not? Simply walking the grounds brings me peace.','The estate is gorgeous, is it not? Simply walking the grounds brings me peace.',26124),
(108381,'enUS','I tell myself I will socialize at these parties, but I always end up lingering about the desserts.','I tell myself I will socialize at these parties, but I always end up lingering about the desserts.',26124),
(108382,'enUS','Yes, my costume IS the most fabulous. Thank you for noticing.$B$BIt hardly matters that I cannot move.','Yes, my costume IS the most fabulous. Thank you for noticing.$B$BIt hardly matters that I cannot move.',26124),
(108383,'enUS','Ugh, I heard someone else came as an owl.$B$BWell, ONE OF US will have to change...','Ugh, I heard someone else came as an owl.$B$BWell, ONE OF US will have to change...',26124),
(108384,'enUS','Quite the... unique... costume you have there.','Quite the... unique... costume you have there.',26124),
(108385,'enUS','Security here is much tighter since the barrier went down. We cannot just let in any riff-raff, now can we?','Security here is much tighter since the barrier went down. We cannot just let in any riff-raff, now can we?',26124),
(108386,'enUS','Is that... an outlander costume beneath your normal costume?$B$BGenius!','Is that... an outlander costume beneath your normal costume?$B$BGenius!',26124),
(108387,'enUS','<Sigh.>$B$BI thought for sure I would have the most exotic costume this time, but it seems I have been outdone once again.','<Sigh.>$B$BI thought for sure I would have the most exotic costume this time, but it seems I have been outdone once again.',26124),
(108388,'enUS','Make it quick - my costume looks more elegant in motion.','Make it quick - my costume looks more elegant in motion.',26124),
(108389,'enUS','Did anyone ever find Thalyssra\'s body?','Did anyone ever find Thalyssra\'s body?',26124),
(108390,'enUS','<Scoff.> Demons. Am I right? <Roll your eyes.>','<Scoff.> Demons. Am I right? <Roll your eyes.>',26124),
(108391,'enUS','Warlocks are not known to be trustworthy. What if Gul\'dan betrays us?','Warlocks are not known to be trustworthy. What if Gul\'dan betrays us?',26124),
(108392,'enUS','How can we be free in the Legion\'s shadow?','How can we be free in the Legion\'s shadow?',26124),
(108393,'enUS','How do you do, fellow Nightborne?','How do you do, fellow Nightborne?',26124),
(108394,'enUS','<Just wink a lot.>','<Just wink a lot.>',26124),
(108395,'enUS','Is there nobody left who will stand up to Elisande?','Is there nobody left who will stand up to Elisande?',26124),
(108396,'enUS','What if we tried not watching the world burn? Just for once, to see if we like it.','What if we tried not watching the world burn? Just for once, to see if we like it.',26124),
(108397,'enUS','What was that?','What was that?',26124),
(108398,'enUS','Hmm?','Hmm?',26124),
(108399,'enUS','Reveal yourself.','Reveal yourself.',26124),
(108400,'enUS','I thought I heard something.','I thought I heard something.',26124),
(108401,'enUS','Shadowgore Stalker growls.','',26124),
(108402,'enUS','Shadowgore Stalker sniffs the air excitedly.','',26124),
(108403,'enUS','Shadowgore Stalker\'s hairs bristle.','',26124),
(108404,'enUS','Shadowgore Stalker perks up!','',26124),
(108405,'enUS','Excuse me while I pretend we never met.','Excuse me while I pretend we never met.',26124),
(108406,'enUS','Curious...','Curious...',26124),
(108407,'enUS','You know, the Magistrix has spies everywhere.','You know, the Magistrix has spies everywhere.',26124),
(108408,'enUS','This conversation is boring me.','This conversation is boring me.',26124),
(108409,'enUS','Hm. Yes. Fascinating.','Hm. Yes. Fascinating.',26124),
(108410,'enUS','Scandalous!','Scandalous!',26124),
(108411,'enUS','Who let you in here?','Who let you in here?',26124),
(108412,'enUS','','Try to keep up.',26124),
(108413,'enUS','','You were dead the moment you arrived here.',26124),
(108414,'enUS','','Enough!',26124),
(108415,'enUS','','Take them to the holding cell. Lord Kil\'jaeden will be most pleased.',26124),
(108416,'enUS','Send reinforcements north of Crossroads! Tower\'s under attack! We\'re surrounded!','',26124),
(108417,'enUS','A full-body outlander transformation? Ghastly.','A full-body outlander transformation? Ghastly.',26124),
(108418,'enUS','What kind of costume is THAT? I cannot be seen with you.','What kind of costume is THAT? I cannot be seen with you.',26124),
(108419,'enUS','Put on a proper costume or I will have you thrown out.','Put on a proper costume or I will have you thrown out.',26124),
(108420,'enUS','Thank you! When this is over you\'ll have to come back and fish sometime!','',26124),
(108421,'enUS','When you deliver the letter, please give Prin... King Anduin my condolences.','',26124),
(108422,'enUS','These ancient stones have not been animated in eons. Once again you must be tested. Place your hand on the stone and prepare.','',26124),
(108423,'enUS','Eyir has taken notice of your deeds. Be careful to not disappoint.','',26124),
(108424,'enUS','Skywall is truly a wondrous place, $n. I have seen nothing like it in all my life.','',26124),
(108425,'enUS','Wet!','',26124),
(108426,'enUS','','NO ONE can be allowed to become a Felsworn traitor working for the Legion.',26124),
(108427,'enUS','','Thank you, $pc. I am Stellagosa.',26124),
(108428,'enUS','','Prepare yourselves, minions. Our lord requires us on the field of battle.',26124),
(108429,'enUS','','Our enemies will feel the fangs\' agonizing bite! They will all perish!',26124),
(108430,'enUS','Tread lightly, lest you prefer to be my beast\'s dinner.','',26124),
(108431,'enUS','You\'re a true alpha.','',26124),
(108432,'enUS','','Zithreen is trying to crush us beneath the waves!',26124),
(108433,'enUS','Shaman, lead Grash forward. He can act as a breakwater for us.','',26124),
(108434,'enUS','I won\'t say it again! Get... off... my... dock!','',26124),
(108435,'enUS','You\'ll never board one of my ships, demon! Not while I\'m alive!','',26124),
(108436,'enUS','','Move out, armies of Kil\'jaeden! Glory awaits!',26124),
(108437,'enUS','That jailer presents an opportunity for your escape.','',26124),
(108438,'enUS','Use |TInterface\\Icons\\inv_misc_bag_10_red.blp:20|t |cFFFF0000|Hspell:185438|h[Pick Pocket]|h|r to escape!','',26124),
(108439,'enUS','','Come to visit ol\' Scowling Rosa, have you?$B$BWhat can I do for you hun?',26124),
(108440,'enUS','','Once again the accursed mists creep in from the sea. Venture forth and vanquish the kvaldir there before their darkness spreads further.',26124),
(108441,'enUS','','The Tideskorn earned their name the day the mists took their greatest harbor. Since then, no vrykul loyal to Odyn has willingly entered that cursed place.',26124),
(108442,'enUS','I hear you might be selling something I\'m looking for...','I hear you might be selling something I\'m looking for...',26124),
(108443,'enUS','Psst. Table behind the house. Lady Ly\'leth is waiting for you.','Psst. Table behind the house. Lady Ly\'leth is waiting for you.',26124),
(108444,'enUS','My mistress! The prisoner has escaped!','',26124),
(108445,'enUS','','Xirus, deal with them. We have nearly made contact.',26124),
(108446,'enUS','Fool! He comes...','',26124),
(108447,'enUS','An entire plane of existence, dedicated to the element of Air. It is truly wondrous...','',26124),
(108448,'enUS','Xirus is here. Run!','',26124),
(108449,'enUS','I have seen nothing like it on my own world. I wonder if such a place exists beyond Azeroth?','',26124),
(108450,'enUS','','Get out while you still can!',26124),
(108451,'enUS','I do not envy you, $n. To lead our order through this crisis must weigh heavily on your shoulders.','',26124),
(108452,'enUS','When the Burning Legion invaded Draenor, I failed to save my people... to save my home.','',26124),
(108453,'enUS','We must unite the elements to our cause... else our worlds share the same fate.','',26124),
(108454,'enUS','The Heart of Skywall holds the power to recharge the blade.','',26124),
(108455,'enUS','We should continue onward with great haste!','',26124),
(108456,'enUS','Thanks!','Thanks!',26124),
(108457,'enUS','These are dark times, $n, but you must never lose hope.','',26124),
(108458,'enUS','There was a time when I wandered the wastes of my world, hopeless and broken.','',26124),
(108459,'enUS','It was in my darkest hour, that the elements called out to me.','',26124),
(108460,'enUS','You too will be guided, Farseer. You need only listen.','',26124),
(108461,'enUS','The Staff of Four Winds is almost complete. We must move swiftly, much is at stake.','',26124),
(108462,'enUS','The elements here are in a state of total chaos... they require a Windlord to guide them.','',26124),
(108463,'enUS','It is time, $n. We have all that we need to resurrect Prince Thunderaan. We must hurry.','',26124),
(108464,'enUS','None can escape my gaze...','',26124),
(108465,'enUS','','I... I\'m alive! By the Light, I live again!',26124),
(108466,'enUS','','Help! Please...',26124),
(108467,'enUS','','They came outta nowhere! Mind lending me a hand?',26124),
(108468,'enUS','What are you doing in here? Can\'t you see I am busy preparing meals that will astonish and delight!','',26124),
(108469,'enUS','I must get back to my cooking!','',26124),
(108470,'enUS','Finally. Now, back to my preparations.','',26124),
(108471,'enUS','I cannot work in these conditions!','',26124),
(108472,'enUS','If you can\'t take the heat...','',26124),
(108473,'enUS','Get out of the kitchen!','',26124),
(108474,'enUS','I herald your endless torment.','',26124),
(108475,'enUS','I have superior ingredients!','',26124),
(108476,'enUS','Everyone is a critic.','',26124),
(108477,'enUS','Smells awful.','',26124),
(108478,'enUS','I have to recheck the recipe.','',26124),
(108479,'enUS','The snake witch. She is inside.$b$bGrash is... afraid.$b$bThe snake witch will try to control Grash with her magic stick.','',26124),
(108480,'enUS','No trespassers allowed!','',26124),
(108481,'enUS','I promise to protect you, Grash. Smash your way inside!','I promise to protect you, Grash. Smash your way inside!',26124),
(108482,'enUS','That should teach you!','',26124),
(108483,'enUS','Just what you deserved!','',26124),
(108484,'enUS','My watch... is ended.','',26124),
(108485,'enUS','A job well done!','',26124),
(108486,'enUS','I need reinforcements!','',26124),
(108488,'enUS','This will even the odds!','',26124),
(108489,'enUS','Basely done... cowards!','',26124),
(108490,'enUS','Stay where you are!','',26124),
(108491,'enUS','You will face many dangerous situations, and preparation can be the key to your survival.','',26124),
(108492,'enUS','Use Divine Shield to make yourself temporarily invulnerable to all damage!','',26124),
(108493,'enUS','This is only the beginning.','',26124),
(108494,'enUS','The end is inevitable.','',26124),
(108495,'enUS','Welcome the embrace of the twisting dark.','',26124),
(108496,'enUS','The Nightmare consumes me... compels me... to serve... to kill!','',26124),
(108497,'enUS','My sacred gift from the Watchers! Yes, Nightmare Lord... yes... the fury of the Claws must be mine once more!','',26124),
(108498,'enUS','You have released me from the Nightmare. The Claws... have served you well...','',26124),
(108499,'enUS','The Watcher\'s gift is mine once more! No... not mine... it belongs to the Nightmare.','',26124),
(108500,'enUS','I WILL FLATTEN YOU LIKE SAPLINGS!','',26124),
(108501,'enUS','THE WILDS TREMBLE BEFORE MY FURY!','',26124),
(108502,'enUS','RRAAAUUUGHHHH!','',26124),
(108503,'enUS','They will devour your flesh until nothing remains...','',26124),
(108504,'enUS','','Not very clever of you to challenge all of us!',26124),
(108505,'enUS','','Scorched bones... so delightful!',26124),
(108506,'enUS','','More kindling for the bonfire!',26124),
(108507,'enUS','','My funeral pyre... will be... glorious...',26124),
(108508,'enUS','','Looks like I have a roast to prepare!',26124),
(108509,'enUS','','Make yourself useful and take a look around!',26124),
(108510,'enUS','','What are you waiting for? Check out that noise!',26124),
(108511,'enUS','','A great banquet will be held tonight for the city\'s nobles. The chef is having all the Arcwine reserves brought to his kitchen. We need you to distract him while we \"liberate\" as much of it as we can.',26124),
(108512,'enUS','','You! Have a look over there!',26124),
(108513,'enUS','','Excellent! You bought my agents enough time to secure almost all of their Arcwine.',26124),
(108514,'enUS','','Mortal flesh... so pretty when it burns!',26124),
(108515,'enUS','','I\'m feeling positively radiant!',26124),
(108516,'enUS','','It will amuse me to watch you melt!',26124),
(108517,'enUS','','Who needs henchmen? I\'ll burn you myself!',26124),
(108518,'enUS','','I believe my brother Mardranel is prepared to accompany you. Thank you for your help, friend.',26124),
(108520,'enUS','Yowlon purrs quietly.','',26124),
(108522,'enUS','Divine Shield protected you from the mage\'s first attack, but the second attack has left you wounded.','',26124),
(108523,'enUS','Use Flash of Light to heal your wounds.','',26124),
(108525,'enUS','I had such high hopes for you. An amateur merchant believes that a partner is a valuably ally. A master knows that they are competition and a liability.','',26124),
(108526,'enUS','I always suspected something was amiss with you.','',26124),
(108537,'enUS','Redhoof carefully digs into the soil with a hoof.','',26124),
(108538,'enUS','It appears as though we have arrived, $n. Let us see what Celestos would have us do next.','',26124),
(108539,'enUS','Fresh green food grows and your enemies are fewer. We seek only your blessing in return.','',26124),
(108540,'enUS','I suppose I should clear away this mess and make room for the new instruments.','',26124),
(108541,'enUS','Startalon settles and tucks her head under her wing for a moment. She straightens again and offers a dry owl talon out to Mayruna.','',26124),
(108542,'enUS','Startalon dips her head in silent thanks and takes to the skies once more.','',26124),
(108544,'enUS','Would you be able to repair this flask for me?','Would you be able to repair this flask for me?',26124),
(108545,'enUS','Silverfang deposits a shiny, smooth Nightsaber Fang onto the dirt.','',26124),
(108546,'enUS','Silverfang lets out a low, passive growl.','',26124),
(108547,'enUS','You ask for my help, yet you have nothing to offer in return, $r. If that\'s the case, then perhaps you can do my tribe a favor.$b$bIt\'s been years since we\'ve tasted the Rivermane\'s brew. Their remedy is known to have revitalizing powers and it does wonders for the teeth. And fortunately I happen to know how to brew it.$b$bI\'ll give you my mortar and pestle, along with the recipe for creating the remedy. You bring back enough for my tribe and I\'ll fix your flask.$b$bAgreed?','',26124),
(108548,'enUS','Agreed.','Agreed.',26124),
(108550,'enUS','','Our efforts were not in vain. The Moonwhisper Matriarch watches from afar.',26124),
(108551,'enUS','','May your hunt be ever fruitful, my sister.',26124),
(108552,'enUS','You\'ll find a pumpkin patch at the Rivermane\'s camp. Choose the ripest ones for their juice.','',26124),
(108553,'enUS','And foxflower flourishes all around Highmountain. Good luck, $r.','',26124),
(108554,'enUS','You fail to amuse me.','',26124),
(108555,'enUS','','No one resists the Nightmare!',26124),
(108556,'enUS','A priest! Thank the Light!','',26124),
(108557,'enUS','','Give yourself over, as I did.',26124),
(108558,'enUS','','At last... the long dream comes.',26124),
(108559,'enUS','Begone mortals! The time of the Windlords has passed!','',26124),
(108560,'enUS','Foolish shaman! You really think that Thunderaan can save your world?','',26124),
(108561,'enUS','I will devour you and take the Staff of Four Winds for myself!','',26124),
(108562,'enUS','','The Nightmare is inescapable.',26124),
(108563,'enUS','Listen well, Farseer... I will aid the Earthen Ring for now.','',26124),
(108564,'enUS','The armies of Skywall shall stand shoulder to shoulder with the mortal races in battle against the Burning Legion.','',26124),
(108565,'enUS','When the fog of battle clears, and the Burning Legion is defeated, we shall stand victorious!','',26124),
(108566,'enUS','','Spirits of the forest! Guardians of nature! Hear our plea!',26124),
(108567,'enUS','','On this day, the mother tree is reborn! G\'Hanir is whole once more!',26124),
(108568,'enUS','Come on, $p, talk with Sternfathom. Let\'s get this fight started!','',26124),
(108569,'enUS','AAAAHHHHHHHHhhhh...!','',26124),
(108570,'enUS','Let\'s give them a moment to regroup and prepare, $n.\n\nWhen they\'re ready, speak with me again, and I\'ll throw you into the arena to get this fight started.','',26124),
(108571,'enUS','What\'re you lookin\' at? Ain\'t ye ever seen a sea lion before?','',26124),
(108572,'enUS','Not like this...','Not like this...',26124),
(108573,'enUS','Yes, I\'m a druid and... well... I\'m kind of stuck like this for a while.$b$bWhile patrolling the sea around the Broken Shore, an infernal crashed into the water right on top of me. The blast instantly knocked me unconscious.\n$b$bWhen I woke I was here in the care of the nurses. They say after a few days I should have the strength to shift back. In the meantime, I\'m stuck in this contraption to keep me from drying out.\n$b$bDo me a favor. Don\'t mention this to any of the other druids. They\'ll never let me live it down!','',26124),
(108574,'enUS','We shall use the garden entrance.','',26124),
(108575,'enUS','Enchanted masks. Simply don the mask, and a magical costume will envelop your body.','',26124),
(108576,'enUS','I will find Ly\'leth. You stay out of trouble.','',26124),
(108577,'enUS','It should be enough to fool the other guests, but stay clear of the guards.','',26124),
(108578,'enUS','The fangs are within your grasp!','',26124),
(108579,'enUS','Use the signal lantern to alert Ly\'leth Lunastre of your arrival.','Use the signal lantern to alert Ly\'leth Lunastre of your arrival.',26124),
(108580,'enUS','This lantern appears to have been slightly modified. It must be the one you need to use to send a signal.','This lantern appears to have been slightly modified. It must be the one you need to use to send a signal.',26124),
(108581,'enUS','Send a signal to Ly\'leth Lunastre.','Send a signal to Ly\'leth Lunastre.',26124),
(108582,'enUS','','Your arrival is fortuitous. Tonight, the nobles have gathered in honor of the Grand Magistrix.',26124),
(108583,'enUS','','Our spies report that Elisande herself will attend. This presents a rare opportunity to catch her away from her source of power.',26124),
(108584,'enUS','','We\'ll take a side entrance to the grounds... too many eyes are watching the front.',26124),
(108585,'enUS','','You\'ve done well so far, but we must ensure you blend in at the party. I\'ll enhance your disguise, infusing it with latent magic to make you appear as one of the nobles.',26124),
(108586,'enUS','','This is your best chance to eliminate the Grand Magistrix. Good luck!',26124),
(108587,'enUS','','Kill them, you fools! I will not be denied my destiny!',26124),
(108588,'enUS','I... I need fresh air!','',26124),
(108589,'enUS','Among the souls you have rescued, there are some who wish to regain their honor fighting alongside you against the kvaldir.','',26124),
(108590,'enUS','We must not suffer Helya\'s minions to gain territory unfought. Your loyalty shall be rewarded.','',26124),
(108591,'enUS','It\'s over, Zithreen! Tell us... what did Azshara plan to do with this realm?','',26124),
(108592,'enUS','','I will tell you NOTHING!',26124),
(108593,'enUS','Agraaahh!!','',26124),
(108594,'enUS','Well then... I guess... I guess we\'re done talking here.','',26124),
(108595,'enUS','Dead now.','',26124),
(108596,'enUS','Legion ships on the horizon! All forces to Sentinel Hill!','',26124),
(108597,'enUS','Barrem!','',26124),
(108598,'enUS','I greet you, $n. I am glad to help.','',26124),
(108599,'enUS','Orik says you can speak to these spirits, how do we begin?','Orik says you can speak to these spirits, how do we begin?',26124),
(108600,'enUS','I misjudged how long ago this happened. I will need more time to prepare myself for the ritual.$b$bIn the meantime, I have attuned this stone to the scroll Orik brought. Certain graves will glow to your mind\'s eye. Go to them and concentrate on the stone to see if you have found the correct grave. We want the writer himself, not a descendent or ancestor.','',26124),
(108601,'enUS','The stone grows dull, this is the wrong grave. A relative probably.','The stone grows dull, this is the wrong grave. A relative probably.',26124),
(108602,'enUS','Concentrating','Concentrating',26124),
(108603,'enUS','The stone glows brightly, this is the correct grave!','The stone glows brightly, this is the correct grave!',26124),
(108604,'enUS','','Yes, what is it? I am very busy planning my next gala.',26124),
(108605,'enUS','','Oh, you again! I cannot thank you enough for what you did, dear.$b$bI am already hearing good things about the new jeweler. Perhaps I should pay him a visit and get a new piece commissioned...',26124),
(108606,'enUS','I wanted to speak with you about a gem design.','I wanted to speak with you about a gem design.',26124),
(108607,'enUS','Champion, a great malevolence has risen in the mists. Gather your most powerful allies and meet the kvaldir in battle!','',26124),
(108608,'enUS','Even my most loyal vrykul dare not enter the mists for fear of their souls. I commend your bravery, mortal.','',26124),
(108609,'enUS','The tower in the middle o\' Dalaran has a portal to Wyrmrest Temple. Should get ye most o\' the way there. Tahu, thanks again fer helping us paladins.','',26124),
(108610,'enUS','You asked the Sunwalkers for aid, and I have come. May my presence bring success to your quest, Orik.','',26124),
(108611,'enUS','Ye made it! This land haunts me still... so much pain and death. Well, let\'s get on with it.','',26124),
(108612,'enUS','Find them. Akaari will not be disturbed!','',26124),
(108613,'enUS','Light give me strength!','',26124),
(108614,'enUS','For the Alliance!','',26124),
(108615,'enUS','Begone foul beast!','',26124),
(108616,'enUS','','Are you in need of healing?',26124),
(108617,'enUS','I\'m looking for some Shaldorei Silk. Do you have any to spare?','I\'m looking for some Shaldorei Silk. Do you have any to spare?',26124),
(108618,'enUS','','Why yes, we do. There\'s some on that chest over there. But we\'re in short supply, so please don\'t take too much.',26124),
(108619,'enUS','Would you happen to know of a tailor in these parts?','Would you happen to know of a tailor in these parts?',26124),
(108620,'enUS','','A leyweaver from Suramar came through here not too long ago. I believe she headed east towards the Sylvan Falls.',26124),
(108621,'enUS','My beasts have been blessed by the Light to enhance their speed and agility. You\'ll not find a swifter ride.','',26124),
(108622,'enUS','I\'d like to travel to Dalaran.','I\'d like to travel to Dalaran.',26124),
(108623,'enUS','','Find somewhere safe! I\'ll find you when this is over.',26124),
(108624,'enUS','Those tendrils are using dark magic to become immune to attack. Interrupt their casting so you can strike!','',26124),
(108625,'enUS','I don\'t have time for idle chatter, $n.','',26124),
(108626,'enUS','To arms!','To arms!',26124),
(108627,'enUS','If it\'s not too much trouble, could you mend this cloth for me?','If it\'s not too much trouble, could you mend this cloth for me?',26124),
(108629,'enUS','What do you want, warlock? Can\'t you see I\'m busy?','',26124),
(108630,'enUS','Who summoned all these imps?','Who summoned all these imps?',26124),
(108631,'enUS','','You dare request such a menial task from me? Surely you must be joking.$b$bYou\'re not? I see. Well, I have been away from Suramar for some time now and from the look of you, I take it you\'re an alchemist, yes?$b$bI\'d be willing to trade my services with you for a price that I deem is fair.$b$bI long for an Ysera\'s Dream Draught. It\'s an ancient elven drink. To concoct it, you\'ll need some dreamleaf as well as the leaves of a Dreamer\'s Tear.$b$bOne grows not to far from here in the clearing of some ruins. Take my flask, make this drink for me, and I\'ll do as you ask.',26124),
(108632,'enUS','','You are of no interest to me. I come from an accomplished lineage of Suramar tailors. You, obviously, do not.',26124),
(108633,'enUS','Confess your crimes!','Confess your crimes!',26124),
(108634,'enUS','','Hello, leyweaver. What can I do for you?',26124),
(108635,'enUS','','How fortuitous! A fellow tailor!$b$bWelcome to the leyweavers\' guild of Suramar. Perhaps you have heard of us?',26124),
(108636,'enUS','','Have you brought me my draughts?',26124),
(108637,'enUS','Here are your draughts.','Here are your draughts.',26124),
(108638,'enUS','Crimes? The only thing I am guilty of is being the most powerful warlock in all of Azeroth!','',26124),
(108639,'enUS','','Yes, this will be sufficient. Now let me see that silk of yours.',26124),
(108640,'enUS','Lespin wants his brooch back.','Lespin wants his brooch back.',26124),
(108641,'enUS','Come minions, aid me in battle against this accuser!','',26124),
(108642,'enUS','Minions...?','',26124),
(108643,'enUS','','Here you are. Now, run along.',26124),
(108644,'enUS','Progress is slow, but steady. I will be back in the good graces of the courts soon, and it is all thanks to you.','',26124),
(108645,'enUS','He\'s just inside. Please, do whatever you can to save him.','',26124),
(108646,'enUS','What do you want? I have few friends in these dark days. I am prepared to defend myself!','',26124),
(108647,'enUS','The Fel Magic reacts violently to your spell!','The Fel Magic reacts violently to your spell!',26124),
(108648,'enUS','We have found you... and you have found the grave.','',26124),
(108649,'enUS','What\'s the next step?','',26124),
(108650,'enUS','I will begin the ritual. Focus your will upon the spirit while our friend keeps us safe.','',26124),
(108651,'enUS','Let\'s get to it!','',26124),
(108652,'enUS','I died to ease the pain of my failure. Why do you disturb me?','',26124),
(108653,'enUS','I\'ve read yer saga. Where did ye find the shield?','',26124),
(108654,'enUS','It seems you compel me to answer... My journey took me to Stormheim, to a tomb of warrior kings.','',26124),
(108655,'enUS','We will finish what ye started.','',26124),
(108656,'enUS','Return to your rest, and be disgraced no more.','',26124),
(108657,'enUS','I\'m coming with you, $n. You helped one of my men, so it\'s only fitting that I return the favor.','',26124),
(108658,'enUS','I\'ll meet you at Krasus\' Landing. We can take my gryphon down to the island.','',26124),
(108659,'enUS','Thanks for yer help, Tahu. I won\'t forget this!','',26124),
(108660,'enUS','It was my honor to serve. I must go to Netherlight Temple and inform the Conclave of our success. Good luck.','',26124),
(108661,'enUS','As for us, we should get back to Dalaran. I\'ll meet ye there!','',26124),
(108662,'enUS','Stop, please! I\'ll pen a confession, assuming you didn\'t break my writing hand...','',26124),
(108663,'enUS','','I foresaw your coming, of course. The threads of fate that led you to this place. Your desperate attempt to stop the Legion.',26124),
(108664,'enUS','','My people faced a similar dilemma. I peered into all possible futures in search of an answer... and found only one.',26124),
(108665,'enUS','','The Legion\'s victory is inevitable. Every time stream shows it to be so. Had we resisted, they would have taken the Nightwell by force and left us bereft of it.',26124),
(108666,'enUS','','I could not allow my people to starve, to waste away without its energies sustaining us. So a bargain was struck.',26124),
(108667,'enUS','','Now I see a future where the Legion is victorious and my people endure. This is the thread that must be preserved. I will do everything in my power to make it so!',26124),
(108668,'enUS','','Your deaths ensure the future of the Nightborne. Come forward, then. Let us speed you toward your fate.',26124),
(108669,'enUS','','Your timelines end here!',26124),
(108670,'enUS','','The threads of time answer to me!',26124),
(108671,'enUS','','Will you race through time? Or be trapped in an endless eternity?',26124),
(108672,'enUS','','Time itself heeds my call!',26124),
(108673,'enUS','','I control the battlefield, not you!',26124),
(108674,'enUS','','Let the waves of time crash over you!',26124),
(108675,'enUS','','You\'ll find time can be quite volatile.',26124),
(108676,'enUS','','You exist in but a single moment. I am far less limited!',26124),
(108677,'enUS','','Time shifts again, and your doom draws near!',26124),
(108678,'enUS','','The time streams are mine to command! You cannot win!',26124),
(108679,'enUS','','Time is... slipping away! How can it be so?',26124),
(108680,'enUS','','Just as I foretold.',26124),
(108681,'enUS','','An inevitable outcome.',26124),
(108682,'enUS','','You were destined to die.',26124),
(108683,'enUS','','It\'s... not possible! I... I was destined to win...',26124),
(108684,'enUS','','I take no joy in this victory, but it was inevitable.',26124),
(108685,'enUS','','In all the possible futures I scryed, I did not foresee one in which you were victorious. I wonder...',26124),
(108686,'enUS','','Will you defeat the Legion? Will you fail? Time eddies about you in fits and starts. Nothing is certain!',26124),
(108687,'enUS','','Perhaps you will win. And in saving your world, my people would be freed from the terrible bargain we were forced to make.',26124),
(108688,'enUS','','Fates be damned! I cast my lot in with yours, champions. Go now, face Gul\'dan. I will aid you as best I can, and perhaps together we can save us all.',26124),
(108689,'enUS','I can see your future mortal.','',26124),
(108690,'enUS','Want to know the exact time and date of your death?','',26124),
(108691,'enUS','Just as I foresaw it.','',26124),
(108692,'enUS','My sight diminishes.','',26124),
(108693,'enUS','Sacrifices must be made.','',26124),
(108694,'enUS','All will turn to ash.','',26124),
(108695,'enUS','I already know your next move.','',26124),
(108696,'enUS','All answer to their fate.','',26124),
(108697,'enUS','Your fate betrays you mortal','',26124),
(108698,'enUS','Hello? Is anyone out there? I can\'t see...','',26124),
(108699,'enUS','Uh... not me. Definitely not me.\n\nLike I told the guards in Dalaran, it\'s probably the Fizzlebang girl. Just like her brother, always summoning a mess of demons she can\'t control.','',26124),
(108700,'enUS','Be quick! I wouldn\'t want us to be caught off guard while you\'re browsing my wares.','',26124),
(108701,'enUS','Lulubelle says you\'re to blame.','Lulubelle says you\'re to blame.',26124),
(108702,'enUS','She would say that, wouldn\'t she? Further proof that you can\'t trust a Fizzlebang!','',26124),
(108703,'enUS','','Welcome, Lord of Flame! Welcome, Kil\'jaeden!',26124),
(108704,'enUS','You have done well, Akaari. You have earned my blessing.','',26124),
(108705,'enUS','Azhir manari kirel. Akim manari galar!','',26124),
(108706,'enUS','','The fangs... their power is beyond comprehension! I am your humble servant, my lord!',26124),
(108707,'enUS','It is time for your true test. Use the Fangs to dismantle Azeroth\'s kingdoms from within. Let their shattered husks pave our path to victory!','',26124),
(108709,'enUS','My brooch? Bah, I have bigger things to worry about than Lespin. Unfortunately for you, I no longer have the brooch.$b$bIt was stolen by Venlis Swiftsea, undoubtedly part of some plot to assassinate my reputation. It is a clever move, since now I cannot be seen near him.$b$bIf you were to go \"speak\" with him and recover the brooch, I think we would both benefit from this mess.','',26124),
(108711,'enUS','I see your future, mortal...','',26124),
(108712,'enUS','I did not foresee this...','',26124),
(108714,'enUS','','Who knows when this will end?',26124),
(108715,'enUS','Has it passed? I can\'t wait to warm up baked goods for our troops once this is all over.','',26124),
(108716,'enUS','','They will taste blood in your name!',26124),
(108717,'enUS','The specters here continue to concoct a wine so foul it serves only to poison the drinker. Azsuna would be better served with them gone.','',26124),
(108718,'enUS','That should help to contain the spread of their corrupted... spirits. You have my thanks.','',26124),
(108719,'enUS','$n! You can\'t just sneak up on someone like that. Not while this is going on!','',26124),
(108720,'enUS','','Imps aren\'t ideal test subjects. They\'re easy enough to summon, but often too fragile for my experiments.',26124),
(108721,'enUS','Feel its power coursing through you, shaman. The waters that Azshara tried to turn against us are now yours to command.','',26124),
(108722,'enUS','Magic stick!','',26124),
(108723,'enUS','Come, let us return to the others.','',26124),
(108724,'enUS','','I never thought I would someday long for the peace and quiet of the Maelstrom.',26124),
(108725,'enUS','Ularogg enters the |cFFFF0000|Hspell:198510|h[Stance of the Mountain]|h|r!','',26124),
(108726,'enUS','It\'s a book. That floats. Why did the demons leave it here?','It\'s a book. That floats. Why did the demons leave it here?',26124),
(108727,'enUS','It\'s a book. That floats. Why did the demons leave it here?\n\nIt looks sinister, but probably not worth your time.','It\'s a book. That floats. Why did the demons leave it here?\n\nIt looks sinister, but probably not worth your time.',26124),
(108728,'enUS','Dedication to your holy Paladin order demands that you purify this fel taint.','Dedication to your holy Paladin order demands that you purify this fel taint.',26124),
(108729,'enUS','This book is unnatural to Priests and must be destroyed.','This book is unnatural to Priests and must be destroyed.',26124),
(108730,'enUS','Let\'s fly, $n. Lightfeather is saddled and ready to go.','',26124),
(108731,'enUS','The demons of Faronaar seek to bend the Illidari to their will. This must not be allowed to transpire!','',26124),
(108732,'enUS','With the Illidari freed, the demons\' threat is contained. You have done a great service to our land, champion.','',26124),
(108733,'enUS','','These demons are even more persistent than the wretched naga! We must drive them back! My Nightwatchers will aid you.',26124),
(108734,'enUS','','Ha! That should teach them not to tangle with the Nightwatchers!',26124),
(108735,'enUS','It pains me to see my brethren reduced to such a state. There is nothing left for them now but hunger. Please, put them to rest.','',26124),
(108736,'enUS','It was a dark task, but one that needed to be done. You have my gratitude, champion.','',26124),
(108737,'enUS','','First the naga assault our city! Now it looks like they\'re trying to make off with our relics as well. Show them what it means to incur the wrath of the Nightwatchers, champion!',26124),
(108738,'enUS','','That should teach the naga to stay out of Azsuna! The citizens of Nar\'thalas owe you a debt of gratitude, $c, as do the Nightwatchers.',26124),
(108739,'enUS','Bad enough that naga and demons invade our home... now these makrura plague our shores! We must find out what dark force is driving them to madness. Will you help?','',26124),
(108740,'enUS','So the foul demons were behind it all! You have my thanks for foiling their scheme. Without the demons inciting them, the makrura threat should subside.','',26124),
(108741,'enUS','','The audacity of these scaly cretins is truly limitless! Now they dare disgrace the city of Nar\'thalas with their presence? As a friend of the Nightwatchers, you must not let this stand!',26124),
(108742,'enUS','','I commend your bravery, champion. The Nightwatchers will take care of their remaining forces. We are in your debt.',26124),
(108743,'enUS','If the sea giants wish to ally with the naga, then they have become our enemy. Champion, show them that the Highborne are not to be trifled with!','',26124),
(108744,'enUS','Let that be a lesson they will not soon forget. Thank you, champion.','',26124),
(108745,'enUS','I just soiled myself...','',26124),
(108748,'enUS','Rokmora rears back for |cFFFF0000|Hspell:188169|h[Razor Shards]|h|r!','',26124),
(108749,'enUS','Fish-breath still alive.$b$bYou ready for fighting?','',26124),
(108750,'enUS','Let\'s do it!','Let\'s do it!',26124),
(108751,'enUS','Snake witch powerful, but with Grash help kill!','',26124),
(108752,'enUS','Let\'s finish this, Grash!','Let\'s finish this, Grash!',26124),
(108753,'enUS','They\'ve taken the fields!','',26124),
(108754,'enUS','Protect the Hill at all costs!','',26124),
(108755,'enUS','Everything I\'ve worked for... gone!','',26124),
(108756,'enUS','All of our crops were destroyed!','',26124),
(108757,'enUS','Ain\'t never been formally trained, but I\'m sure this here pointy end means trouble.','',26124),
(108758,'enUS','There! In the skies! More of our reinforcements! Hold strong!','',26124),
(108759,'enUS','','Let us finish this once and for all.',26124),
(108760,'enUS','','Do you feel the fangs\' bite withering the flesh from your very bones?',26124),
(108761,'enUS','','Mephistroth guide my hand! I will not fail!',26124),
(108762,'enUS','','I have broken entire worlds from the inside out. Azeroth will crumble!',26124),
(108763,'enUS','','No more games.',26124),
(108764,'enUS','','Join me... in the Nether...',26124),
(108765,'enUS','The citadel has begun a self-destruct sequence. Make your way to the portal once you have the fangs!','',26124),
(108766,'enUS','','Can you feel your mind slipping away?',26124),
(108767,'enUS','','I am your end!',26124),
(108768,'enUS','This creature is using its own life essence to harm us! He dies a little more with every attack!','',26124),
(108769,'enUS','Clever. He\'s absorbing the flame back into his body to become whole again.','',26124),
(108770,'enUS','Priest, perhaps you can use your magic to influence his mind... Trick him into snuffing out his own flame!','',26124),
(108771,'enUS','Ah, you made it. Well done!','',26124),
(108772,'enUS','Valeera said you would know where to meet her upon your return. Not wise to keep her waiting.','',26124),
(108773,'enUS','Until our paths cross again.','',26124),
(108774,'enUS','Come with me. The depths await!','',26124),
(108775,'enUS','That beast is trying to take her soul! Hurry, we can still save her!','',26124),
(108776,'enUS','Jump on Azuregos\'s back to avoid |cFFFF0404|Hspell:209863|h[Force of Gravity]|h|r!','Jump on Azuregos\'s back to avoid |cFFFF0404|Hspell:209863|h[Force of Gravity]|h|r!',26124),
(108777,'enUS','Mage reinforcements from Stormwind! We fight as one!','',26124),
(108778,'enUS','Close ranks! We make our stand here!','',26124),
(108779,'enUS','Sir.','',26124),
(108780,'enUS','For the Alliance!','For the Alliance!',26124),
(108781,'enUS','Hold the gates!','Hold the gates!',26124),
(108782,'enUS','Reporting for duty!','Reporting for duty!',26124),
(108783,'enUS','Point me to the nearest demon!','Point me to the nearest demon!',26124),
(108784,'enUS','Mum.','Mum.',26124),
(108785,'enUS','','I\'m sorry, but what does, \"Mum\" mean? Is there something you need?',26124),
(108786,'enUS','Oh, uh... well I\'m looking for some burettes?','Oh, uh... well I\'m looking for some burettes?',26124),
(108787,'enUS','','Well why didn\'t you just say so to begin with? There aren\'t any guards around, we\'re perfectly safe to speak freely.',26124),
(108788,'enUS','How in the light am I supposed to get a hair from an archmage?!','How in the light am I supposed to get a hair from an archmage?!',26124),
(108789,'enUS','','Judging by what you\'re asking for I assume you\'re an alchemist?$b$bAnd if that\'s true, isn\'t there some sort of invisibility potion you can brew? Skaggldrynk I believe it\'s called.$b$bHe\'ll never see you coming.',26124),
(108790,'enUS','Carefully pluck a single strand of hair from Khadgar\'s head.','Carefully pluck a single strand of hair from Khadgar\'s head.',26124),
(108791,'enUS','OW!! What in the light was that?!','',26124),
(108792,'enUS','Something... bit my head I think.','',26124),
(108793,'enUS','If you can pay, I can supply.','',26124),
(108794,'enUS','Show me what you have available.','Show me what you have available.',26124),
(108795,'enUS','','Khadgar, what\'s wrong? What happened?',26124),
(108796,'enUS','<Lay your insignia on the table.>','<Lay your insignia on the table.>',26124),
(108797,'enUS','','Something bit your head? That\'s all? Would you like me to kiss it for you?',26124),
(108798,'enUS','Just mount the wee birdy here and follow me! To Stormheim!','',26124),
(108799,'enUS','Your order\'s in the back room, $Gsir:madame;.','',26124),
(108800,'enUS','Right this way, $GMister:Miss; $n.','',26124),
(108801,'enUS','Hm, |5$r of your tastes might find our private selection in the back to your liking.','',26124),
(108802,'enUS','Welcome back, $Gsir:madame;. Might I suggest you check out our new arrivals in the VIP room?','',26124),
(108803,'enUS','Use |TInterface\\Icons\\spell_warlock_demonicportal_green.blp:20|t |cFFFF0000|Hspell:111771|h[Demonic Gateway]|h|r to get past Ariden\'s barrier!','Use |TInterface\\Icons\\spell_warlock_demonicportal_green.blp:20|t |cFFFF0000|Hspell:111771|h[Demonic Portal]|h|r to get past Ariden\'s barrier!',26124),
(108804,'enUS','The Darkbrul Arena is a place for the clans to challenge each other. Get in there and prove that the Stonedark and their allies are the toughest!','',26124),
(108805,'enUS','Please, keep your voice down!$b$bIf they catch me talking to you... they\'ll kill me!','Please, keep your voice down!$b$bIf they catch me talking to you... they\'ll kill me!',26124),
(108806,'enUS','I\'ve cleared a path for you. You can escape if you hurry!','I\'ve cleared a path for you. You can escape if you hurry!',26124),
(108807,'enUS','Good work! You\'ve pushed back the Naga and cleared out their Murloc slaves sufficiently! If you have any Timeworn Artifacts on you, bring them on by!','',26124),
(108808,'enUS','','That was a legendary performance! Thank you for proving that friendship is overrated.',26124),
(108809,'enUS','The raven calls.','The raven calls.',26124),
(108810,'enUS','|TInterface\\Icons\\ability_fomor_boss_shout:20|t%s begins a |cFFFF0404|Hspell:209748|h[Deafening Roar]|h|r. Stop casting!','|TInterface\\Icons\\ability_fomor_boss_shout:20|t%s begins a |cFFFF0404|Hspell:209748|h[Deafening Roar]|h|r. Stop casting!',26124),
(108811,'enUS','And we will answer from the shadows.','',26124),
(108812,'enUS','I never thought I would make it out alive!','I never thought I would make it out alive!',26124),
(108813,'enUS','The Twilight\'s Hammer must be stopped!','The Twilight\'s Hammer must be stopped!',26124),
(108814,'enUS','I never thought I\'d see my children\'s faces again!','I never thought I\'d see my children\'s faces again!',26124),
(108815,'enUS','I can\'t wait to take a bath!','I can\'t wait to take a bath!',26124),
(108816,'enUS','Please save the others, hero!','Please save the others, hero!',26124),
(108817,'enUS','Be careful. I\'ve seen The Master... and she\'s powerful!','Be careful. I\'ve seen The Master... and she\'s powerful!',26124),
(108818,'enUS','We\'re saved!','We\'re saved!',26124),
(108819,'enUS','You fight with a fury worthy of a vrykul! An infant or elderly vrykul, but a vrykul all the same! Well done!','',26124),
(108820,'enUS','You\'ve saved me. I won\'t forget this!','You\'ve saved me. I won\'t forget this!',26124),
(108821,'enUS','These Naga are up to no good, enslaving the nearby Murlocs to invade the shore. Take them out at all costs! Oh, and if you find any Timeworn Artifacts I could really use them for my research.','',26124),
(108822,'enUS','','Welcome to the Black Rook Rumble! Did you come here to fight alongside friends or allies? Well, send them away! Within this arena, you stand alone.',26124),
(108823,'enUS','Looking for something specific today?','',26124),
(108824,'enUS','Battle?! Battle first, then eats the pets! Battle then eats!','',26124),
(108825,'enUS','Oh! Times to eats the pets! Where you goin\'? We can shares!','',26124),
(108826,'enUS','Oh $p, I didn\'t realize it was you... my apologies. The Uncrowned await your arrival.','',26124),
(108827,'enUS','This a placeholder event for imbuing the Moonwell. Spell effects will be added at a later date.','',26124),
(108828,'enUS','That there be $p. I heard $Ghe:she; took down Deathwing with nothin\' but the blades in $Ghis:her; hands!','Looking for something specific today?',26124),
(108829,'enUS','We would like you to do the honors, friend. Come.','',26124),
(108831,'enUS','Ey mon, dat there be da one Garona spoke of.','',26124),
(108832,'enUS','','Yes, thank you for all you have done.',26124),
(108833,'enUS','','Mayruna kneels and arranges a silver basin on the ground, then pours a small amount of softly glowing liquid into it.',26124),
(108834,'enUS','','Whenever you are ready, simply submerge the ritual bundle.',26124),
(108837,'enUS','','Mother Moon, goddess of my heart, bless this place with your light.',26124),
(108838,'enUS','On behalf of the Sablehorn, let this moonwell be blessed.','',26124),
(108839,'enUS','On behalf of the Feathermane, let this moonwell be blessed.','',26124),
(108840,'enUS','','On behalf of the Moonwhisper, let this moonwell be blessed.',26124),
(108841,'enUS','','It is done!',26124),
(108842,'enUS','|TInterface\\Icons\\spell_shaman_lavaflow.blp:20|t %s readies |cFFF00000|Hspell:200404|h[Magma Wave]|h|r. Hide!','',26124),
(108843,'enUS','','I will not... give in!',26124),
(108844,'enUS','Your torment only feeds the nightmare, weakling!','',26124),
(108845,'enUS','','The power of the Scepter is MINE to command!',26124),
(108846,'enUS','Cato! I\'m glad ye could make it. The shield is close... I can feel it!','',26124),
(108847,'enUS','','You will drown in this place!',26124),
(108848,'enUS','','The Earthen Ring will never have Azshara\'s power!',26124),
(108849,'enUS','I\'m here, aren\'t I? Let\'s find this shield. Some of us have a war to get back to!','',26124),
(108850,'enUS','Cato\'s the best healer around. We\'re lucky we didn\'t have to wait in a queue for his services!','',26124),
(108851,'enUS','|TInterface\\Icons\\Spell_Nature_LightningOverload:20|t You are afflicted with |cFFFF0000|Hspell:204275|h[Arcane Tether]|h|r!','|TInterface\\Icons\\Spell_Nature_LightningOverload:20|t You are afflicted with |cFFFF0000|Hspell:204275|h[Arcane Tether]|h|r!',26124),
(108852,'enUS','','I owe you a great debt, druid. I will not forget this.',26124),
(108853,'enUS','Ummm...?','Ummm...?',26124),
(108854,'enUS','Look, this one is not my fault. How was I supposed to know those demons would believe me?','',26124),
(108855,'enUS','We must drive them back! Focus on the commanders!','',26124),
(108856,'enUS','Petty mortals. Your world will end soon enough!','',26124),
(108857,'enUS','They aren\'t letting up! Hold strong!','',26124),
(108858,'enUS','Watch the skies, I sense them coming.','',26124),
(108859,'enUS','Don\'t waste your breath, druid. Malorne\'s gift is ours. Now, join your ancestors!','',26124),
(108860,'enUS','','The Bloodstone is ready. Handle it with care, $n.',26124),
(108861,'enUS','Nooooooooo!','',26124),
(108862,'enUS','Cannot. Control. Must. KILL!','',26124),
(108863,'enUS','Grash no let puny shaman hurt snake lady!','',26124),
(108864,'enUS','Thank you again for giving me the honor of sacrificing my life for the cause. Now you know that I\'d willingly give everything to further Lord Illidan\'s plan. The Burning Legion must be destroyed at any cost.\n\nI owe you everything, $n.\n\nNow, you complete what we started, gain the Sargerite Keystone, and return triumphant to the Black Temple.\n\nLord Illidan awaits.','',26124),
(108867,'enUS','Well I didn\'t think they would actually believe me.','',26124),
(108868,'enUS','You demon toying fool! You have compromised our position.','',26124),
(108869,'enUS','Affliction warlocks use shadow magic and disease to wear down their enemies, then drain their very life essences to empower themselves.','',26124),
(108870,'enUS','Use Summon Voidwalker to summon your demonic minion.','',26124),
(108871,'enUS','Agony is an appropriate name for your first attack ability.','',26124),
(108872,'enUS','Use Agony on the target dummy.','',26124),
(108873,'enUS','You will inflict suffering on anyone foolish enough to fight you.','',26124),
(108874,'enUS','Use Corruption on this target dummy.','',26124),
(108875,'enUS','After afflicting your target with Agony and Corruption, you can begin to drain the very life from them.','',26124),
(108876,'enUS','Use Drain Soul on the target dummy.','',26124),
(108877,'enUS','As Agony damages your enemy, it has a chance to generate a Soul Shard. You can use these shards to empower new abilities.','',26124),
(108878,'enUS','Use Unstable Affliction on this target dummy.','',26124),
(108879,'enUS','Now that you have all your primary attack abilities, we will see how they work together!','',26124),
(108880,'enUS','Practice using your attacks on this target dummy.','',26124),
(108881,'enUS','Many spells have a heavy mana cost. You have a clever way around this problem.','',26124),
(108882,'enUS','Use Life Tap to replenish your mana reserves.','',26124),
(108883,'enUS','At times you may find yourself overwhelmed by multiple enemies, or a single enemy that is too strong for you.','',26124),
(108884,'enUS','Use Fear to frighten my soldier.','',26124),
(108885,'enUS','Well done, $p! You are now prepared to do battle as an affliction warlock.','',26124),
(108886,'enUS','Council members and allies, it is time to begin the summoning.','',26124),
(108887,'enUS','We employ a variety of methods to ensure the safety of Azeroth... and to secure our rightful place within it.','',26124),
(108888,'enUS','But the events at the Broken Shore have forced our hand. We haven\'t the time for subtlety.','',26124),
(108889,'enUS','T... T\'uure... Alora... escape...','',26124),
(108890,'enUS','You know the deal. We kill $Ghim:her;, our debts are clear!','You know the deal. We kill $Ghim:her;, our debts are clear!',26124),
(108891,'enUS','Nothing personal, friend. Just business.','Nothing personal, friend. Just business.',26124),
(108892,'enUS','Consider your choice carefully.','',26124),
(108893,'enUS','The Uncrowned will do what no others can: finish this war.','',26124),
(108894,'enUS','I\'m ready to make a decision.','I\'m ready to make a decision.',26124),
(108895,'enUS','','What\'s the matter? Never seen a princess who knows how to twist a blade?',26124),
(108896,'enUS','Tell me about your plan.','Tell me about your plan.',26124),
(108897,'enUS','','I plan to acquire the cursed daggers that took down King Llane Wrynn. Garona hid the Kingslayers for good reason. Their power is not to be underestimated.$B$BI need your help to retrieve them. These storied blades are just what we need to destroy Gul\'dan and his foul allies.',26124),
(108898,'enUS','Gimme yer ear, $n. I got a plan that\'s guaranteed to put worthy blades in them hands!','',26124),
(108899,'enUS','What can I do for ya?','',26124),
(108900,'enUS','','The Kingslayers are the only way to ensure the Legion\'s end. Hear me out!',26124),
(108901,'enUS','','I\'m close to locating a foe we\'ve been hunting for years. With a bit of help, we can take her out and lay claim to her daggers.',26124),
(108902,'enUS','Just after the Cataclysm, one o\' me best discovered a pair o\' golden cutlasses unlike any ye\'ve e\'er seen. The moment Eliza touched \'em, she had a vision o\' herself conquerin\' city after city, commandin\' a crew o\' lost souls.$B$BYe may doubt such a grand tale, but it indeed came t\' pass. The Dreadblades \'ave claimed countless souls, and now we\'re comin\' for \'em!','',26124),
(108903,'enUS','','Jorach spoke highly of you. He\'s a good friend to have.',26124),
(108904,'enUS','','After the fall of Sargeras\' hound Goremaw, his dreadlords took the beast\'s fangs and forged them into a pair of daggers known as the Fangs of the Devourer. It\'s said they still carry the monster\'s bite.$B$BSargeras called upon one of his top assassins to wield the fangs, an eredar named Akaari Shadowgore. Despite our best attempts, we haven\'t been able to stop her.',26124),
(108905,'enUS','You won\'t escape me this time, Valith! Tell me where your master is and I may grant you a quick death!','',26124),
(108906,'enUS','Your time on this world ends now, demon! Allies, gather at Sentinel Hill!','',26124),
(108907,'enUS','|TInterface\\Icons\\Spell_DeathKnight_MindFreeze:20|t%s casts |cFFFF0404|Hspell:209983|h[Control Thoughts]|h|r on Grash!','|TInterface\\Icons\\Spell_DeathKnight_MindFreeze:20|t%s casts |cFFFF0404|Hspell:209983|h[Control Thoughts]|h|r on Grash!',26124),
(108908,'enUS','That insignia marks you as one of us. Carry it with you always.','',26124),
(108909,'enUS','My work will shine for eternity...','',26124),
(108910,'enUS','A Rotdrool Grabber bursts from the husk of the grub!','',26124),
(108911,'enUS','Go deal with that demon, $n! I\'ll tend to Alora.','',26124),
(108912,'enUS','I seem to have misplaced my insignia.','I seem to have misplaced my insignia.',26124),
(108913,'enUS','Knocking','Knocking',26124),
(108914,'enUS','','Use your feral form to heighten your senses. Between the three of us, we can pick up the satyr\'s trail.',26124),
(108915,'enUS','The barrier you placed here with Ysondre\'s Tear still stands.\n\nIf you wish, you can remove it.','The barrier you placed here with Ysondre\'s Tear still stands.\n\nIf you wish, you can remove it.',26124),
(108916,'enUS','Remove the seal.','Remove the seal.',26124),
(108917,'enUS','','Foolish warlocks, summoning what you cannot control.',26124),
(108918,'enUS','The doomguards make their descent! Prepare yourselves!','',26124),
(108919,'enUS','','You will meet your death by our hands!',26124),
(108920,'enUS','Sinu a\'manore. You were fortunate I was in the area. What brings you to this forsaken place?','',26124),
(108921,'enUS','Lookee! Seems Yrgrim was the champion, and he came here after Tyr\'s fall.','',26124),
(108922,'enUS','I had thought my battle over. You have my gratitude.','I had thought my battle over. You have my gratitude.',26124),
(108923,'enUS','Thank you. I shall return to the Illidari to recover.','Thank you. I shall return to the Illidari to recover.',26124),
(108924,'enUS','These foul demons sap our strength and seek to bend our will. Show them no mercy!','These foul demons sap our strength and seek to bend our will. Show them no mercy!',26124),
(108925,'enUS','When that brute Kraggosh and his overseers moved into the Undercity, we were forced to do our real work in secret.$B$BSurely you can see how such an arrangement inevitably led me here.','',26124),
(108926,'enUS','It shames me to have been taken alive by these creatures. Thanks to you, I will fight another day.','It shames me to have been taken alive by these creatures. Thanks to you, I will fight another day.',26124),
(108927,'enUS','Thank you for freeing me, $c. The Illidari must learn what the Legion is planning in Faronaar!','Thank you for freeing me, $c. The Illidari must learn what the Legion is planning in Faronaar!',26124),
(108928,'enUS','Out here, no one will hear your screams!','',26124),
(108929,'enUS','Your god is no match for ours, druid!','',26124),
(108931,'enUS','Oh, that reminds me. While you were off doing the easy work, I was out taking care of the other part that was needed.','',26124),
(108932,'enUS','Just... resting my eyes... for a moment...','',26124),
(108933,'enUS','Come, we have much to discuss.','',26124),
(108934,'enUS','I had to deal with those awful scribes over at The Scribe\'s Sacellum. But, ultimately, it was worth the effort.','',26124),
(108935,'enUS','That should do it. I think we both deserve a pat on the back, $n. Wouldn\'t you agree?','',26124),
(108936,'enUS','Give up, druid. Your ancient god... cannot... be saved...','',26124),
(108937,'enUS','It\'s no use, druid. You cannot fight us.','',26124),
(108939,'enUS','Against us, your strength is nothing. All you love will turn against you. You will face your greatest fears.','',26124),
(108940,'enUS','Who goes there?','Who goes there?',26124),
(108941,'enUS','Thank you for that welcome distraction.','',26124),
(108942,'enUS','Sylendra, can we still recover the idol?','',26124),
(108943,'enUS','Just enjoy the party for a bit. You know... mingle.','',26124),
(108944,'enUS','Let us gather and give our oaths!','',26124),
(108945,'enUS','<The attendant is silent.>','<The attendant is silent.>',26124),
(108946,'enUS','<Take a drink.>','<Take a drink.>',26124),
(108947,'enUS','','There are others trapped inside. Please, rescue them if you can. Thank you again, $n!',26124),
(108948,'enUS','I choose you to be the Sixth.','I choose you to be the Sixth.',26124),
(108949,'enUS','','I can see the times are changing.  \n\nOne warlock, no matter how powerful, can\'t take on the Burning Legion alone.\n\nWhile I\'ll never believe anything Ritssyn does is selfless, it\'s clear that rebuilding the council is the right thing to do.\n\nI would be honored to count myself one among the six, if you\'ll have me.',26124),
(108950,'enUS','','I\'ll do whatever it takes to restore pride to the Fizzlebang name.',26124),
(108951,'enUS','','It takes many years to build a reputation, and only one mistake to tarnish it.\n\nI have my work cut out for me, but I hope that serving on the council will help towards restoring pride to the Fizzlebang name.',26124),
(108952,'enUS','Let\'s get going. The portal is just ahead.','',26124),
(108953,'enUS','The spirits, the elements, they are but pitiful shadows compared to the power of the legion.','',26124),
(108954,'enUS','Bow, bow to the might of Sargeras. Bow and receive his gifts.','',26124),
(108955,'enUS','The forces of Highmountain, the drogbar, even the elves, will be swept away in the flames of our wrath.','',26124),
(108956,'enUS','Embrace the fel energies of our new masters. Kneel, and you shall rise stronger than ever.','',26124),
(108957,'enUS','','Too many of the Bloodtotem have gone over to the legion. Now, these Feltotem are gathering their strength. I do not intend to let their betrayal go unpunished.',26124),
(108958,'enUS','','The Bloodtotem had been growing more distant for years now. But to side with the Legion? None of us could have foreseen that.',26124),
(108959,'enUS','More camps on the horizon! Bring them down!','',26124),
(108960,'enUS','Fools! Our forces have spread across these foul lands. We have defiled and corrupted your precious soil... Let us see how you deal with our legion now.','',26124),
(108961,'enUS','All forces, spread out! Legion corruption rises in all directions!','',26124),
(108962,'enUS','Don\'t bother reading it or anything.','',26124),
(108963,'enUS','Just go ahead and sign it.','',26124),
(108964,'enUS','Right there on the line.','',26124),
(108965,'enUS','This metal is all bent out of shape. A strong Blacksmith could hammer these pieces back into working order.','This metal is all bent out of shape. A strong Blacksmith could hammer these pieces back into working order.',26124),
(108966,'enUS','Well done, Archdruid. Take the Idol back to the Dreamgrove, and we will meet you there.','',26124),
(108967,'enUS','Someone left some goods out in the open...','Someone left some goods out in the open...',26124),
(108968,'enUS','It would be a pity if a Warrior were to smash them.','It would be a pity if a Warrior were to smash them.',26124),
(108969,'enUS','If a Rogue were to pilfer some of these, you\'re sure someone would take notice.','If a Rogue were to pilfer some of these, you\'re sure someone would take notice.',26124),
(108970,'enUS','Someone left some goods out in the open...\n\nThey seem to be monitored by magical means.','Someone left some goods out in the open...\n\nThey seem to be monitored by magical means.',26124),
(108971,'enUS','Halt!','',26124),
(108972,'enUS','','Betrayers! Liars! Murderers! Has Hamuul sent his lapdogs to fetch the knife from my back?',26124),
(108973,'enUS','Guards! To me!','',26124),
(108974,'enUS','','Do you remember murdering me? Or have you grown so used to slaughter that my cries of agony are long forgotten?',26124),
(108975,'enUS','','I recall my final moments surrounded by those I had trusted. Your satisfied sneers as I drew my last breath.',26124),
(108976,'enUS','','Revenge is said to be sweet, but I taste only bitterness.',26124),
(108977,'enUS','','Your faces no longer appear familiar. Did you truly deserve my wrath?',26124),
(108978,'enUS','','Now you have become prey!',26124),
(108979,'enUS','','Scurry, scurry, little rats!',26124),
(108980,'enUS','','There is nowhere left to hide!',26124),
(108981,'enUS','','Such juicy morsels!',26124),
(108982,'enUS','','Scream for me!',26124),
(108983,'enUS','','I\'ll adorn my web with your bones!',26124),
(108984,'enUS','','Feel the crush of my talons!',26124),
(108985,'enUS','','My beak will tear your flesh, vermin!',26124),
(108986,'enUS','','Not afraid of spiders, are you?',26124),
(108987,'enUS','Finally. I\'ll make this quick.','',26124),
(108988,'enUS','','This time I\'m ready for your treachery!',26124),
(108989,'enUS','','Mercy? None for you! Only gushing blood and broken bodies!',26124),
(108990,'enUS','How dare you interrupt your betters!','',26124),
(108991,'enUS','','Betrayers, will you remember killing me now?',26124),
(108992,'enUS','','The Twilight\'s Hammer is all but destroyed. This once great order has been laid low... scattered and leaderless.',26124),
(108993,'enUS','The wind slices to the bone!','',26124),
(108994,'enUS','Death by a thousand cuts!','',26124),
(108995,'enUS','Bleed for the Grand Magistrix!','',26124),
(108996,'enUS','You can\'t counter what you can\'t see!','',26124),
(108997,'enUS','I will speed you towards your demise!','',26124),
(108998,'enUS','If you blink... you bleed!','',26124),
(108999,'enUS','Another victim of my artistry.','',26124),
(109000,'enUS','Never heard my blade coming!','',26124),
(109001,'enUS','','But I have heard the prayers of their faithful... crying out for destruction!',26124),
(109002,'enUS','Elisande... forgive me!','',26124),
(109003,'enUS','Let your names be forgotten.','',26124),
(109004,'enUS','','I will take these poor, pathetic creatures under my wing and lead them to the glorious destiny they yearn for!',26124),
(109011,'enUS','','Breathe deeply. Embrace your fate.',26124),
(109012,'enUS','','Dark secrets have been revealed to me through the void... ways of subjugating the elements to my will!',26124),
(109013,'enUS','','You have no more need of this life!',26124),
(109014,'enUS','','No... I still have much to do... RETURN TO ME!',26124),
(109015,'enUS','','My children will learn these secrets and together we shall tear this world asunder!',26124),
(109016,'enUS','','Consumed from within!',26124),
(109017,'enUS','','Your wakened life is a disease!',26124),
(109018,'enUS','','My little ones learn quickly... they drink from the void and thirst endlessly for more!',26124),
(109020,'enUS','','The destruction of Azeroth is at hand! Soon... the very elements that shape this world will cause its demise!',26124),
(109021,'enUS','And so we enter the lair of the beast. May the Light protect us!','',26124),
(109022,'enUS','Good luck with the Trials... \"hero.\"','',26124),
(109023,'enUS','Do not disappoint the Banshee Queen.','',26124),
(109024,'enUS','You succumbed to the Nightmare! Defeat your fears to wake up.','You succumbed to the Nightmare! Defeat your fears to wake up.',26124),
(109025,'enUS','Our leader has done what no other could do.','',26124),
(109026,'enUS','The Council of the Black Harvest lives once again.','',26124),
(109027,'enUS','Under the First, our power will reach new heights.','',26124),
(109028,'enUS','The secrets of the Burning Legion will be ours to unlock!','',26124),
(109029,'enUS','','Over here! I haven\'t much time.',26124),
(109030,'enUS','A glowing door... Wee bit obvious, don\'t ye think? What have we here?','',26124),
(109031,'enUS','This tablet says ye need to withstand the door\'s \"gaze\". I\'m bettin\' that\'s not gonna be pleasant. Care to give it a try?','',26124),
(109032,'enUS','This magical lantern is different in some way. Almost as if it is leaking.','This magical lantern is different in some way. Almost as if it is leaking.',26124),
(109033,'enUS','As a Mage, you are long familiar with the intricacies of ley magic. It can be repurposed to a... better cause.','As a Mage, you are long familiar with the intricacies of ley magic. It can be repurposed to a... better cause.',26124),
(109034,'enUS','This faulty device of Elven construct is familiar to you and can be altered to provide magical empowerment.','This faulty device of Elven construct is familiar to you and can be altered to provide magical empowerment.',26124),
(109035,'enUS','This magical lantern is different in some way. Almost as if it is leaking.\n\nYou\'re sure someone will come along and fix it in due time.','This magical lantern is different in some way. Almost as if it is leaking.\n\nYou\'re sure someone will come along and fix it in due time.',26124),
(109036,'enUS','The cultists are blinded by the twilight... deprived and recluse, taking cover in the night.','',26124),
(109037,'enUS','Beast master hunters possess a deep bond with their pets, calling and bolstering them in battle while striking at foes with ranged attacks.','',26124),
(109038,'enUS','Use Call Pet to bring your pet to battle.','',26124),
(109039,'enUS','Sending your pet to attack and distract an enemy gives you more time to line up your ranged attacks.','',26124),
(109040,'enUS','Use Kill Command multiple times on the target dummy.','',26124),
(109041,'enUS','Now let\'s see what other forces of nature you command.','',26124),
(109042,'enUS','Use Dire Beast on the target dummy.','',26124),
(109043,'enUS','I\'m sure you\'re ready to join in on the action. Cobra Shot is your primary ranged attack, pummeling your enemy while your pet keeps their attention.','',26124),
(109044,'enUS','Use Cobra Shot on the target dummy.','',26124),
(109045,'enUS','Use Bestial Wrath while attacking the target dummy.','',26124),
(109046,'enUS','When in combat, Bestial Wrath sends you and your pet into a frenzy of rage that increases your damage for a short time.','',26124),
(109049,'enUS','Sometimes you\'ll find yourself outnumbered. When you do, you can unleash destruction upon a host of adversaries at once!','',26124),
(109050,'enUS','Use Multi-Shot to dispatch all the enemies.','',26124),
(109051,'enUS','Even the greatest adventurers sometimes find themselves in over their heads.','',26124),
(109052,'enUS','Use Feign Death to trick my soldier into stopping his attack.','',26124),
(109053,'enUS','Prove to me you have the necessary skill and cunning required to hunt any prey!','',26124),
(109054,'enUS','Show me your courage and zeal in the heat of combat!','',26124),
(109056,'enUS','Target practice is over, $p. It\'s time to prove your mettle. Combine all the lessons you\'ve learned and use them to defeat my men in combat.','',26124),
(109057,'enUS','Well done, $p! You are now prepared to do battle as a beast master hunter.','',26124),
(109058,'enUS','Golarb is unresponsive.','',26124),
(109059,'enUS','Mistress is gone...','',26124),
(109060,'enUS','The dreadlord came for her. Golarb tried to help...','',26124),
(109061,'enUS','Golarb failed...','',26124),
(109062,'enUS','We\'re on the right track. Keep searching.','',26124),
(109063,'enUS','','Their hideout should be close. I smell the stench of satyr to the east.',26124),
(109064,'enUS','Ye did it! Better\'n being a pile of ash on the ground, ain\'t it?','',26124),
(109065,'enUS','Zinnin Smythe bows his head in silent thanks.','',26124),
(109066,'enUS','','You have my thanks. I can find my own way back to Dreadscar Rift.',26124),
(109067,'enUS','','Archdruid! Watch out!',26124),
(109068,'enUS','Don\'t worry!  I\'m here!','',26124),
(109069,'enUS','','I am not leaving without my Kaya!',26124),
(109071,'enUS','','She fought with everything she was, but there were simply too many. What are we going to do, Galar\'thus?',26124),
(109073,'enUS','Another tablet! This champion is still forged, never touched by the curse o\' flesh! We should take care.','',26124),
(109074,'enUS','','My home! Dargrul blew up my home. I... I don\'t... I can\'t even...',26124),
(109075,'enUS','','They did not give me enough time to gather my things. Do you think they will be safe? I don\'t want those drogbar rummaging through my personal stuff.',26124),
(109076,'enUS','There is no time left. Run!','There is no time left. Run!',26124),
(109077,'enUS','$n! Bless the Light, you made it! This place is crawling with evil!','',26124),
(109078,'enUS','These braves are near death. They will not be able to move themselves.','',26124),
(109079,'enUS','I bid you greetings, Opener of Doors. You are the first.','',26124),
(109080,'enUS','I am Yrgrim, Champion of Tyr! Let us see if you are worthy to bear his shield.','',26124),
(109081,'enUS','Your arrival was timely. Had we waited even a few more moments I would not be here today to thank you.','',26124),
(109082,'enUS','It\'s a barrel of Starlight Rose tea. It appears to have been aged such that the brew is sickeningly strong.','It\'s a barrel of Starlight Rose tea. It appears to have been aged such that the brew is sickeningly strong.',26124),
(109083,'enUS','As a Death Knight, tea strong enough to wake the dead is just what you need.','As a Death Knight, tea strong enough to wake the dead is just what you need.',26124),
(109084,'enUS','A strong tea is merely a challenge to the auspicious Monk. Down the hatch!','A strong tea is merely a challenge to the auspicious Monk. Down the hatch!',26124),
(109085,'enUS','It\'s a barrel of Starlight Rose tea. It appears to have been aged such that the brew is sickeningly strong.\n\nJust the smell of it nearly causes you to retch. Clearly it has been left here for too long.','It\'s a barrel of Starlight Rose tea. It appears to have been aged such that the brew is sickeningly strong.\n\nJust the smell of it nearly causes retching. Clearly it has been left here for too long.',26124),
(109086,'enUS','So be it. Come my wounded friends, let us see if I might have the strength that is needed to carry you to safety.','',26124),
(109087,'enUS','','This is not up for debate, Anarys. You are either with us, or against us. Choose wisely.',26124),
(109088,'enUS','','I will hear no more of your scheming! You endanger everything our father worked for!',26124),
(109089,'enUS','','<sigh> Dear child... Do you not realize what he died for?',26124),
(109090,'enUS','Thank you, champion. With my strength renewed, I am able to dispel this foul magic.','',26124),
(109091,'enUS','Come, hero! Jace was heading this way.','',26124),
(109092,'enUS','Long have I waited for one who proves worthy. Face me in battle that we might test your heart!','',26124),
(109093,'enUS','We fight at your side, demon hunter!','',26124),
(109094,'enUS','I must see if you possess the will, the strength, and the stamina to wield this shield. Will you face me in a trial of combat?','',26124),
(109095,'enUS','I am ready for your trial, Yrgrim.','I am ready for your trial, Yrgrim.',26124),
(109096,'enUS','A realistic and ornate statue of a Suramar noble.','A realistic and ornate statue of a Suramar noble.',26124),
(109097,'enUS','Your experience with Mining grants you the knowledge to work... and deface stone.','Your experience with Mining grants you the knowledge to work... and deface stone.',26124),
(109098,'enUS','Jewelcrafting grants you the skill to rework and \"improve\" this statue.','Jewelcrafting grants you the skill to rework and \"improve\" this statue.',26124),
(109099,'enUS','A realistic and ornate statue of a Suramar noble.\n\nIt appears solid and very heavy.','A realistic and ornate statue of a Suramar noble.\n\nIt appears solid and very heavy.',26124),
(109100,'enUS','Let us begin!','',26124),
(109101,'enUS','Studying','Studying',26124),
(109102,'enUS','I am beaten! You are indeed worthy. Were Tyr alive, he would make you his champion. I hereby bestow Truthguard upon you. Use it to defend Azeroth from its enemies.','',26124),
(109103,'enUS','I am weary. With a worthy successor, my long vigil is at an end. Fight for truth and justice, champion. In Tyr\'s name...','',26124),
(109104,'enUS','This has been our home since the days of my grandfather\'s grandfather. We have stood against monsters worse than this villain that faces us now and will not be intimidated.','',26124),
(109105,'enUS','I am not leaving, child. And that is that. No underking is going to scare me out of MY home.','',26124),
(109106,'enUS','I name you, $n, the First of the Council of the Black Harvest.','',26124),
(109107,'enUS','Fah! This is OUR mountain. Let the drogbar savages come. We have the power of the spirits, of this mountain. All they have are sticks and stones and anger.','',26124),
(109108,'enUS','Alright $n, you may want to stand back. Things are going to get hot.','',26124),
(109109,'enUS','Adding the sulfate now.','',26124),
(109110,'enUS','And last but not least, the dust.','',26124),
(109111,'enUS','Success! I have to say, this is some of my finest work. I guess some credit goes to Deucus and his detailed design.','',26124),
(109112,'enUS','Jace went to scout ahead, but when these demons attacked and put up this barrier, we were separated. He\'s still out there!','',26124),
(109113,'enUS','Look at what I can do!','',26124),
(109114,'enUS','I can still see you.','',26124),
(109115,'enUS','Invisibility!','',26124),
(109116,'enUS','Amazing! Good to see the shield in your hands. Me \'n Cato will head to Dalaran and report to Tyrosus. If ye need a ride, my hippogryph\'s outside.','',26124),
(109117,'enUS','A presence. Something new... yet familiar. Yes...','',26124),
(109118,'enUS','Your coming was foretold in the rings. The long circle is nearly complete.','',26124),
(109119,'enUS','Come, little ones. Savor your fear as we feast upon it!','',26124),
(109120,'enUS','Agh!','Agh!',26124),
(109121,'enUS','At last, the feeding hour!','',26124),
(109122,'enUS','|TInterface\\Icons\\Spell_Fire_FelFlameStrike:20|t Krosus targets |cFFFF0404$n|r with an |cFFFF0404|Hspell:205344|h[Orb of Destruction]|h|r!','|TInterface\\Icons\\Spell_Fire_FelFlameStrike:20|t Krosus targets you with an |cFFFF0404|Hspell:205344|h[Orb of Destruction]|h|r!',26124),
(109123,'enUS','Disgusting!!','Disgusting!!',26124),
(109124,'enUS','Rejoice! The end comes soon.','',26124),
(109125,'enUS','Oblivion offers solace. Take the gift! Take it!','',26124),
(109126,'enUS','You have failed those who needed you.','',26124),
(109127,'enUS','Your light sputters out...','',26124),
(109128,'enUS','Welcome death. Do not fight it.','',26124),
(109129,'enUS','How DARE you!!','How DARE you!!',26124),
(109130,'enUS','You\'ll pay for this!','You\'ll pay for this!',26124),
(109131,'enUS','My eyes!','My eyes!',26124),
(109132,'enUS','Someone appears to have dropped a scroll in this fountain. The writing looks like it is blurred from the water.','Someone appears to have dropped a scroll in this fountain. The writing looks like it is blurred from the water.',26124),
(109133,'enUS','Return the sheep to their pens in Bradensbrook!','Return the sheep to their pens in Bradensbrook!',26124),
(109134,'enUS','As a Shaman, you can use the aid of the elements to garner the information that was present.','As a Shaman, you can use the aid of the elements to garner the information that was present.',26124),
(109135,'enUS','Mark Black Rook Falcons for Granny Marl.','Mark Black Rook Falcons for Granny Marl.',26124),
(109136,'enUS','Your training in Inscription allows you to grasp the knowledge behind the scroll despite the obvious water damage.','Your training in Inscription allows you to grasp the knowledge behind the scroll despite the obvious water damage.',26124),
(109137,'enUS','Someone appears to have dropped a scroll in this fountain. The writing looks like it is blurred from the water.\n\nIt was probably important at some point in time, but has obviously been in there too long to remain legible.','Someone appears to have dropped a scroll in this fountain. The writing looks like it is blurred from the water.\n\nIt was probably important at some point in time, but has obviously been in there too long to remain legible.',26124),
(109138,'enUS','Release your grip on hope.','',26124),
(109139,'enUS','The pain of flesh is fleeting. True torment lasts forever.','',26124),
(109140,'enUS','Graagh! What pointless impudence! We share a master!','',26124),
(109141,'enUS','Every blow struck at our heart will be repaid a thousand fold!','',26124),
(109142,'enUS','Out! Out! You are not yet worthy!','',26124),
(109143,'enUS','Still you fight? Still you refuse the gift?','',26124),
(109144,'enUS','N\'zoth... I journey... to Ny\'alotha...','',26124),
(109145,'enUS','','Did you really think you could stop me? Foolish children!',26124),
(109146,'enUS','','The blood of Sintharia flows through my veins and  her voice whispers to me from the Dark Beyond!',26124),
(109147,'enUS','','The Twilight Dragonflight lives and our destiny is at hand!',26124),
(109148,'enUS','','Cower, mortals! Obliteration is upon you!',26124),
(109149,'enUS','','Thanks for everything, Beakbuck. I hope we meet again.',26124),
(109150,'enUS','','Don\'t worry about me. Just focus on finding Lothrius.',26124),
(109151,'enUS','','Even in death we shall endure... mother I return...',26124),
(109152,'enUS','Zinnin Smythe bows before you in silent gratitude.','',26124),
(109153,'enUS','You will suffer horrors...','',26124),
(109154,'enUS','Thank you, friends. I admit, I doubted you\'d survive the demon\'s trap, Boros. Thought it would be just me and $n now.','',26124),
(109155,'enUS','They closed the gates to the upper levels. $n, use your holy magic to destroy the anchoring crystal. That should open our way.','',26124),
(109156,'enUS','','Howww did it get passst the daughters?! We will feassst on its insssides!',26124),
(109157,'enUS','Thank you. Now get out of here! It\'s not safe!','Thank you. Now get out of here! It\'s not safe!',26124),
(109158,'enUS','Brave of you to come, but we need to leave!','Brave of you to come, but we need to leave!',26124),
(109159,'enUS','Never thought I\'d see the day...','Never thought I\'d see the day...',26124),
(109160,'enUS','The end is coming!','The end is coming!',26124),
(109161,'enUS','A little bruised, but alive. Thanks.','A little bruised, but alive. Thanks.',26124),
(109162,'enUS','Garuhod once mentioned that he learned most of his recipes from the priestesses here. They\'ve since gone mad and their writings are all gibberish to me, but it seems their oracle can still understand them.','',26124),
(109163,'enUS','With this scrying orb, all their writings are clear as day! This should point us in the right direction to continue Garuhod\'s research.','',26124),
(109164,'enUS','Easy there, Huey! Easy griffy boy!','',26124),
(109165,'enUS','Perhaps she possesses the key to unlocking their knowledge.','',26124),
(109166,'enUS','Garuhod may have been onto something, but I think he got his ingredients mixed up. We should try a different combination. Maybe hydra eggs and murloc eyes?','',26124),
(109167,'enUS','Yes, these should do nicely. I\'ll have the court alchemist test this at once!','',26124),
(109168,'enUS','','Enjoying the party?',26124),
(109169,'enUS','','Ah, you must be the outlander Silgryn has told me about.',26124),
(109170,'enUS','Pleased to meet you, Lady Ly\'leth.','Pleased to meet you, Lady Ly\'leth.',26124),
(109171,'enUS','Sup.','Sup.',26124),
(109172,'enUS','','Well, aren\'t you charming?',26124),
(109173,'enUS','Excellent! Now let\'s get out of here.','',26124),
(109174,'enUS','Be on your guard. I sense a powerful demon ahead.','',26124),
(109175,'enUS','UNUSED - Nonsense. What good are my works on the necks of those abominations? You would do well to learn from our friend here.','',26124),
(109176,'enUS','Hop on and let\'s get movin\'. Ol\' Huey don\'t bite... much!','',26124),
(109177,'enUS','Shoot her! SHOOT HER!','Shoot her! SHOOT HER!',26124),
(109178,'enUS','If you had faith in the Light, demon hunter, there would be nothing to fear!','',26124),
(109179,'enUS','It does not matter what could happen to his reputation. He has already ruined it. This is why you are still an apprentice.','',26124),
(109180,'enUS','But master, this man was innocent! His name was cleared, surely he deserves a second chance?','',26124),
(109181,'enUS','You have done everyone a great service, friend. Give cousin Ly\'leth my regards.','',26124),
(109182,'enUS','To Shield\'s Rest!','',26124),
(109183,'enUS','Make yourself comfortable. It\'s a bit of a ride to Stormheim.','',26124),
(109184,'enUS','|TInterface\\Icons\\Spell_Holy_FistOfJustice:20|t Krosus is about to destroy the bridge with a |cFFFF0404|Hspell:205875|h[Slam]|h|r!','|TInterface\\Icons\\Spell_Holy_FistOfJustice:20|t Krosus is about to destroy the bridge with a |cFFFF0404|Hspell:205875|h[Slam]|h|r!',26124),
(109185,'enUS','My wounds were severe, but $n arrived just in time.','',26124),
(109186,'enUS','The Light has come to vanquish you, demon!','',26124),
(109187,'enUS','Brann introduced me to Prustaga not long ago. That dwarf sure has a way with the words... he can even charm a vrykul!','',26124),
(109188,'enUS','A prisoner! We could use her help, $n. Free her!','',26124),
(109189,'enUS','|TInterface\\Icons\\Achievement_Boss_YoggSaron_01:20|tA Dominator Tentacle faces you and readies |cFFFF0000|Hspell:208689|h[Ground Slam]|h|r!','|TInterface\\Icons\\Achievement_Boss_YoggSaron_01:20|tA Dominator Tentacle faces you and readies |cFFFF0000|Hspell:208689|h[Ground Slam]|h|r!',26124),
(109190,'enUS','Accordin\' to ancient texts we translated back in the Explorer\'s League, Titanstrike focuses the power of storms into blasts of energy.','',26124),
(109191,'enUS','If that\'s true, it could do some serious damage to the Legion. S\'pose we\'ll find out soon enough!','',26124),
(109192,'enUS','Druids of Azeroth, protectors of the Dream, my sons and daughters...','',26124),
(109193,'enUS','I must speak quickly, for my mind grows clouded.','',26124),
(109194,'enUS','I sensed Shaladrassil\'s corruption, and entered the Emerald Dream to destroy the Nightmare\'s source.','',26124),
(109195,'enUS','Deeper and deeper I fought. When I arrived at the Rift, I saw their true strength.','',26124),
(109197,'enUS','The Nightmare will spread like a disease, festering and multiplying. It will engulf all of Azeroth in its twisted reality.','',26124),
(109198,'enUS','I can no longer see the way back to the Dream. I am trapped in a Nightmare of my own making.','',26124),
(109199,'enUS','Druids, my time is done. It is up to you now.','',26124),
(109200,'enUS','','Taz\'dingo! T\'ank ya for gettin\' me outta dere!',26124),
(109201,'enUS','I\'ll introduce ye to Prustaga when yer ready.','',26124),
(109202,'enUS','','I am Mayla, daughter of the late High Chieftain Ulan, and I... I speak for the tribes.',26124),
(109203,'enUS','','Don\'t worry, they\'re friendlier than they look.',26124),
(109204,'enUS','I\'m pleased you chose to heed our call. We\'ve discussed inviting you into our ranks for some time.','',26124),
(109206,'enUS','None taken... so long as ye don\'t insult me face!','',26124),
(109207,'enUS','','I\'ve heard many tales of your accomplishments. I can\'t imagine half of them could be true.',26124),
(109208,'enUS','','It\'s good to finally see you again. I have missed our adventures together.',26124),
(109209,'enUS','Such power! I feel the demon\'s essence infusing every fiber of my being!','',26124),
(109210,'enUS','I fear for your soul, demon hunter. It\'s not too late! Turn to the Light and be cleansed of your corruption!','',26124),
(109211,'enUS','Spare me your platitudes, paladin! Your people know well the horrors that the Legion plans to unleash.','',26124),
(109212,'enUS','','Many t\'anks again, mon, for gettin\' me outta dere!',26124),
(109213,'enUS','We seek the leader of this den of horrors, an eredar called Lady Calindris.','',26124),
(109214,'enUS','','Aye, she be outside directin\' her demons ta load up more captives. I be havin\' a score to settle wid her, so if ya be aimin\' ta take her out, count me in!',26124),
(109215,'enUS','Lead on, Farseer, and I shall follow.','',26124),
(109216,'enUS','Come, let\'s move before we encounter anymore surprises.','',26124),
(109217,'enUS','These are troubling words, Farseer.','',26124),
(109218,'enUS','We must defeat the Twilight\'s Hammer and restore balance to Deepholm.','',26124),
(109219,'enUS','The servant of Therazane is bound by the dark powers of the void. I hope we are not too late!','',26124),
(109220,'enUS','The horrors... these fiends must be destroyed.','',26124),
(109221,'enUS','Twilight whelps? I thought the Twilight Dragonflight were extinct...','',26124),
(109222,'enUS','The Fal\'dorei have taken everything... from me.','',26124),
(109223,'enUS','I still not stand by and watch as demons tear this world apart.$B$BThe time has come for the nightborne to earn their place on Azeroth.','',26124),
(109224,'enUS','This one is almost lost to the corruption! We must hurry!','',26124),
(109225,'enUS','We have put an end to the rituals, but I fear the worst is yet ahead of us...','',26124),
(109226,'enUS','We should return to Therazane and inform her of what has transpired here.','',26124),
(109227,'enUS','Our prey stands before us! We must strike now, before she can summon her defenses!','',26124),
(109228,'enUS','Join me in raising a glass not only to our newest Shadow, but to the dawn of a new era for the Uncrowned.','',26124),
(109229,'enUS','Somethin\'s off about this here brew...','',26124),
(109230,'enUS','','Vanessa...?',26124),
(109231,'enUS','Today, $p secured the legendary Fangs of the Devourer, and in doing so has enabled us to strike at the Legion directly.','',26124),
(109232,'enUS','Today, $p secured the legendary Kingslayers, and in doing so has enabled us to strike at the Legion directly.','',26124),
(109233,'enUS','','Get away from there!',26124),
(109234,'enUS','','You have come to help Ly\'leth destroy our family! Be gone!',26124),
(109235,'enUS','','Ngh! Who ARE you?!',26124),
(109236,'enUS','','Well done!',26124),
(109237,'enUS','Just... finish me off.','Just... finish me off.',26124),
(109238,'enUS','Come with me. Ly\'leth wants to speak with you.','Come with me. Ly\'leth wants to speak with you.',26124),
(109239,'enUS','','She wants to preach her traitorous ideals to me further? Fine. Let us go.',26124),
(109240,'enUS','','You\'re more resilient than I thought. I was hoping to take you somewhere a little less... populated.',26124),
(109241,'enUS','','Come on, show me the \"legendary fighter\" I\'ve heard so much about!',26124),
(109242,'enUS','','No! I\'ve worked too hard to be undermined by the likes of you!',26124),
(109243,'enUS','','Oh, my head... Valeera, you okay?',26124),
(109244,'enUS','','Valeera nods.',26124),
(109245,'enUS','I was not successful in getting the Bloodtotem tribe to help us with this. I hope Jale has enough leverage.','',26124),
(109246,'enUS','I have only just returned from Bloodtotem lands, but I have heard of the aid you lent our people. \n\nIt shames me to see the day when outsiders like yourself are more willing to help us than our fellow tribes.','',26124),
(109247,'enUS','We need your help negotiating with the Underking.','We need your help negotiating with the Underking.',26124),
(109248,'enUS','Jale wishes to negotiate with these savages? A bold move, though probably a foolish one.','',26124),
(109249,'enUS','By the Earthmother! It is just as a I feared... the Twilight Dragonflight has returned!','',26124),
(109250,'enUS','Take good care of it.','Take good care of it.',26124),
(109251,'enUS','Don\'t get too reckless!','Don\'t get too reckless!',26124),
(109252,'enUS','Bring her back in one piece!','Bring her back in one piece!',26124),
(109253,'enUS','','Our work is nearly finished... do not allow these meddling shaman to interfere with the rituals!',26124),
(109254,'enUS','','Find them! Leave no stone unturned!',26124),
(109255,'enUS','','None survive, so says the Grand Magistrix!',26124),
(109256,'enUS','','The Moon Guard are finished! Slay them all.',26124),
(109257,'enUS','|TInterface\\Icons\\inv_feather_05.blp:20|t %s readies |cFFF00000|Hspell:210547|h[Razor Wing]|h|r.','|TInterface\\Icons\\inv_feather_05.blp:20|t %s readies |cFFF00000|Hspell:210547|h[Razor Wing]|h|r.',26124),
(109258,'enUS','','Scour the stronghold. None escape alive.',26124),
(109259,'enUS','I heard what you did for the Rivermane tribe.$b$bWhen we first met in Dalaran I did not expect that you would be as helpful to us as you have been.$b$bIt is much appreciated.','',26124),
(109260,'enUS','','Wipe this place clean of their inferior magics. The Moon Guard is finished.',26124),
(109261,'enUS','For Nar\'thalas!','For Nar\'thalas!',26124),
(109262,'enUS','Drive back the scaled menace!','Drive back the scaled menace!',26124),
(109263,'enUS','Show the naga no mercy!','Show the naga no mercy!',26124),
(109264,'enUS','Face the wrath of the Nightwatchers!','Face the wrath of the Nightwatchers!',26124),
(109265,'enUS','Strike down the naga filth!','Strike down the naga filth!',26124),
(109266,'enUS','','Our soldiers grow weary of the naga\'s relentless assault. Rally the Nightwatchers, champion, and drive the naga back to the depths where they belong!',26124),
(109267,'enUS','','We appreciate your help, champion. You\'ve allowed my people a moment\'s respite from the naga threat.',26124),
(109269,'enUS','|TInterface\\Icons\\INV_Misc_Bell_01:20|tA %s has been alerted to your presence!','|TInterface\\Icons\\INV_Misc_Bell_01:20|tA %s has been alerted to your presence!',26124),
(109270,'enUS','|TInterface\\Icons\\INV_Misc_Bell_01:20|tAn alarm has been sounded! A reinforcement has entered the fray!','|TInterface\\Icons\\INV_Misc_Bell_01:20|tAn alarm has been sounded! A reinforcement has entered the fray!',26124),
(109271,'enUS','The boy-king serves at the master\'s table. Three lies will he offer you.','',26124),
(109272,'enUS','Her heart is a crater, and we have filled it.','',26124),
(109273,'enUS','The king of diamonds has been made a pawn.','',26124),
(109274,'enUS','At the hour of her third death, she ushers in our coming.','',26124),
(109275,'enUS','From the earth, he draws strength. Our earth. Our strength.','',26124),
(109276,'enUS','Its surface blazes bright, masking shadows below.','',26124),
(109277,'enUS','','Thanks, now its time for some payback!',26124),
(109278,'enUS','To find him, drown yourself in the circle of stars.','',26124),
(109279,'enUS','Five keys to open our way. Five torches to light our path.','',26124),
(109280,'enUS','Flesh is his gift. He is your true creator.','',26124),
(109281,'enUS','The lord of ravens will turn the key.','',26124),
(109283,'enUS','','Hmph... Someone will notice I am missing! They will come looking for me!',26124),
(109284,'enUS','I will start the ritual at your command.$B$BThe twins won\'t take too kindly to being summoned, so be prepared for a fight.$B$BOnce they are weakened, use the Bloodstone to enslave them.$B$BAre you ready to begin?','',26124),
(109285,'enUS','','True. You will have to make an appearance.',26124),
(109286,'enUS','','Use the Bloodstone!',26124),
(109287,'enUS','Welcome to Mornath\'s Manor of Mystery! I have all manner of mysterious curios from before and after the Sundering.','',26124),
(109288,'enUS','He insists that you return it, and that I may use force if necessary.','He insists that you return it, and that I may use force if necessary.',26124),
(109289,'enUS','','Friend, the withered are relentless in their attacks on our whelplands. They\'ve left our captive young starving for mana!',26124),
(109290,'enUS','','Take back the mana crystals the withered stole and use them to revive the whelplings. Move quickly, friend!',26124),
(109291,'enUS','','Your actions have ensured a future for the blue dragons in Azsuna. With the withered\'s threat subsided, you\'ve given us the time we need to recover.',26124),
(109292,'enUS','How brave of you, $n.','How brave of you, $n.',26124),
(109293,'enUS','I owe you a debt of gratitude.','I owe you a debt of gratitude.',26124),
(109294,'enUS','These bandages... thank you.','These bandages... thank you.',26124),
(109295,'enUS','I... I must get back to battle!','I... I must get back to battle!',26124),
(109296,'enUS','A little shaken, but I\'ll be alright.','A little shaken, but I\'ll be alright.',26124),
(109297,'enUS','For the Alliance!','For the Alliance!',26124),
(109298,'enUS','','You will join the eternal hunt!',26124),
(109299,'enUS','Ah yes, the heroes have arrived. So persistent. So confident. But your arrogance will be your undoing!','',26124),
(109300,'enUS','Have you forgotten your humiliation on the Broken Shore? How your precious high king was bent and broken before me? Will you beg for your lives as he did, whimpering like some worthless dog?','',26124),
(109301,'enUS','Have you forgotten your humiliation on the Broken Shore? How your mighty warchief was stuck in the belly like a helpless piglet? Will you die slowly as he did, consumed by fel corruption and squealing for a merciful end?','',26124),
(109302,'enUS','Your pathetic Alliance will fall to dust. Your new boy-king will bow down and serve me... as will all of you!','',26124),
(109303,'enUS','Your pathetic Horde will fall to dust. In the end, death will inherit this world and she will be waiting.','',26124),
(109304,'enUS','The husk of Illidan will prove an ideal vessel for my master\'s glory. Sargeras will rise, and together we will watch your world burn!','',26124),
(109305,'enUS','','None will defile the warlord\'s hoard!',26124),
(109306,'enUS','Let the endgame begin!','',26124),
(109307,'enUS','You will not stop the ritual!','',26124),
(109308,'enUS','The vessel must be made ready!','',26124),
(109309,'enUS','One by one you fall!','',26124),
(109310,'enUS','You should have bent the knee!','',26124),
(109311,'enUS','Surrender! I may yet show mercy!','',26124),
(109312,'enUS','Thus do the champions of this world fall!','',26124),
(109313,'enUS','No more distractions! I have work to do...','',26124),
(109314,'enUS','Come forth and serve me!','',26124),
(109315,'enUS','Strike for Sargeras!','',26124),
(109316,'enUS','Rid me of these pests!','',26124),
(109317,'enUS','Kill them in my master\'s name!','',26124),
(109318,'enUS','I\'ll make ashes of you!','',26124),
(109319,'enUS','You dare trespass at the heart of the Nightmare itself? Foolish mortals! Here, my will is absolute. Here, I am the master!','',26124),
(109320,'enUS','My will is unbreakable!','',26124),
(109321,'enUS','You\'ll never escape my grasp!','',26124),
(109322,'enUS','Behold... power given form!','',26124),
(109323,'enUS','Drink in the glory!','',26124),
(109324,'enUS','Burn from within!','',26124),
(109325,'enUS','A taste of the master\'s might!','',26124),
(109326,'enUS','The Nightmare has corrupted dragons, gods, and legends. Your downfall will be simple and swift!','',26124),
(109327,'enUS','Let the storm rain death upon you!','',26124),
(109328,'enUS','Never underestimate a master warlock!','',26124),
(109329,'enUS','Another dreamer for my Nightmare!','',26124),
(109330,'enUS','You failed, heroes! The ritual is upon us! But first, I\'ll indulge myself a bit... and finish you!','',26124),
(109331,'enUS','You will never stir again!','',26124),
(109332,'enUS','Why won\'t you die? Why do you keep resisting?','',26124),
(109333,'enUS','Eternal slumber! Eternal madness!','',26124),
(109334,'enUS','This fate awaits you all!','',26124),
(109335,'enUS','My victory draws near!','',26124),
(109336,'enUS','Your souls are mine, woven for all time into the fabric of the Nightmare!','',26124),
(109337,'enUS','Those ghosties are stirrin\' up the winds! Might need ta stop \'em the ol\' fashioned way!','',26124),
(109338,'enUS','I will not fail you, master! More power... just need more power...','',26124),
(109339,'enUS','My victory is absolute. The power of Nightmare grows!','',26124),
(109340,'enUS','NO! I will not permit it!','',26124),
(109341,'enUS','They are mine, Ysera! You cannot save them!','',26124),
(109342,'enUS','Embrace the Dreaming, champions! It can save you!','',26124),
(109343,'enUS','Let the Dreaming wash away his darkness!','',26124),
(109344,'enUS','No more dreams! Only Nightmare!','',26124),
(109345,'enUS','Your respite is over! Awaken and face your doom!','',26124),
(109346,'enUS','My work... left... unfinished...','',26124),
(109347,'enUS','Nightmares are... never... forgotten...','',26124),
(109348,'enUS','I\'ll slice into the heart of you!','',26124),
(109349,'enUS','I will sever you from the waking world!','',26124),
(109350,'enUS','Time to cut the last tether to your mortal life!','',26124),
(109351,'enUS','Feel the devastation of the Nightmare!','',26124),
(109352,'enUS','I\'ll level you one by one!','',26124),
(109353,'enUS','Time to crush your dreams!','',26124),
(109354,'enUS','Succumb to the madness!','',26124),
(109355,'enUS','Give in to the Nightmare!','',26124),
(109356,'enUS','Your dreams are mine!','',26124),
(109357,'enUS','Your torment will be unending!','',26124),
(109358,'enUS','There is no escape!','',26124),
(109359,'enUS','Heroes! Champions! Step forth and hear me!','',26124),
(109360,'enUS','The Nightmare has long been a cancer eager to consume the Emerald Dream. Had Xavius succeeded, his corruption would have overwhelmed Azeroth, giving rise to a living Nightmare.','',26124),
(109361,'enUS','Your triumph restores the Dream and safeguards your world. The allies of Xavius will never relent, but this road, at least, is closed to them.','',26124),
(109362,'enUS','To honor your courage, I offer passage into the pure heart of the Dream. As you feel the essence of life blooming beneath your feet, know that it endures thanks to what you achieved this day.','',26124),
(109363,'enUS','Out of the rolling ocean I rise. The Lord of Tides has answered your call, Farseer of the Earthen Ring.','',26124),
(109364,'enUS','','Heretic! I will slay you in Volund\'s name!',26124),
(109365,'enUS','The time has come to use the Idol of the Wilds and call upon the great god, Malorne. Never did I believe I would see the great ancient himself. This is a moment that we will speak of for ages to come.','',26124),
(109366,'enUS','I am ready to begin.','I am ready to begin.',26124),
(109367,'enUS','My chosen will protect me for all eternity!','',26124),
(109368,'enUS','You are not worthy of Titanstrike\'s might!','',26124),
(109369,'enUS','','I grow tired of this! Be consumed by the darkness!',26124),
(109370,'enUS','','It\'s just you and me now, little priest! Your pathetic Light won\'t save you!',26124),
(109371,'enUS','It seems Garuhod\'s recipe was incomplete. My alchemists think some bile might be needed to balance this out. It\'s supposed to have some amazing properties!','',26124),
(109372,'enUS','Fetch me some livers from the bears in the highlands. Only the fat ones will do! Oh, and some hippogryph eggs as well. A little variety can\'t hurt.','',26124),
(109373,'enUS','Wonderful! I feel like we\'re on the cusp of discovering the cure to this curse! Who would\'ve thought that a lush like Garuhod might have held the key to our freedom?','',26124),
(109374,'enUS','','What is that noise? Naranoth! If you allow another jailbreak, I\'ll strand you on this pathetic rock and leave you to rot!',26124),
(109375,'enUS','','Are you truly so stupid? You presume to challenge an eredar sorceress of the Burning Legion?',26124),
(109376,'enUS','','My darkness will consume you!',26124),
(109377,'enUS','','No! My staff is absorbing the Light! Damn you, priest, and your accursed magic!',26124),
(109378,'enUS','','My staff... it senses the Light within you! What is it... Nooooo!',26124),
(109379,'enUS','There, up ahead! That door\'s glowin\' with the same energy as all o\' these spirits.','',26124),
(109380,'enUS','He dares to send someone in his stead? That accursed wretch.','He dares to send someone in his stead? That accursed wretch.',26124),
(109381,'enUS','','I will dispel the runes. Protect me!',26124),
(109382,'enUS','Will do, Prust!','',26124),
(109383,'enUS','','Despoilers! Halt!',26124),
(109384,'enUS','','You pollute this hallowed ground with your greed. Begone!',26124),
(109385,'enUS','','Prophet\'s mercy! What is that?!',26124),
(109386,'enUS','What are you filthy mortals doing near the master\'s portal? I\'ll rip the answer from your souls!','',26124),
(109387,'enUS','Salma! Where\'s my Salma!?','',26124),
(109388,'enUS','','My husband! Is he alright?',26124),
(109389,'enUS','','I will make this lake beautiful...',26124),
(109390,'enUS','Do you even call this laboring? The master will have your hides!','',26124),
(109391,'enUS','If I catch you drinking the reagents again, I\'ll turn you over to master!','',26124),
(109392,'enUS','Hello. Have you come to join the Empyrean Society of Exotic Magical Arts?','Hello. Have you come to join the Empyrean Society of Exotic Magical Arts?',26124),
(109393,'enUS','That\'s the spirit! One down, two to go!','',26124),
(109394,'enUS','','They grow in strength. Be ready!',26124),
(109395,'enUS','Look! The door\'s openin\'!','',26124),
(109397,'enUS','Keep them from entering the chamber! The ritual is almost complete!','Keep them from entering the chamber! The ritual is almost complete!',26124),
(109398,'enUS','','You two can yell at each other later! It be time ta get outta dis place!',26124),
(109399,'enUS','As an elemental shaman you commune with ancient spirits and command primal elemental forces.','',26124),
(109400,'enUS','Use Flame Shock on the target dummy.','',26124),
(109401,'enUS','Why stop with fire? Once your enemies are burning, you can hurl molten lava at them.','',26124),
(109402,'enUS','Use Lava Burst on the target dummy.','',26124),
(109403,'enUS','Hurling lightning from your hands is your main weapon for overcoming enemies.','',26124),
(109404,'enUS','Use Lightning Bolt on the target dummy.','',26124),
(109405,'enUS','Be wary, my friend- their constructs do not seem at all effected by my runes.','',26124),
(109406,'enUS','Shaman of the Earthen Ring, let our powers combine!','',26124),
(109407,'enUS','We call upon Neptulon, the great Lord of Tides, in the name of Azeroth!','',26124),
(109408,'enUS','','If it weren\'t for Beakbuck I would most certainly be dead.',26124),
(109409,'enUS','I need another invisibility spell applied.','I need another invisibility spell applied.',26124),
(109410,'enUS','Hear our words and answer the call of the Earthen Ring!','',26124),
(109411,'enUS','You can make your way there through the portal to Dalaran Crater. I will meet you there with additional forces.','',26124),
(109412,'enUS','Enchanters all have a deep understanding of the arcane. This magic can be rerouted to provide assistance.','Enchanters all have a deep understanding of the arcane. This magic can be rerouted to provide assistance.',26124),
(109413,'enUS','','Titanstrike is close.',26124),
(109414,'enUS','By Magni\'s beard! This Volund sure had a taste for titan relics!','',26124),
(109415,'enUS','Lookee here... a mechagnome! Brann told me all about these things. It might be able to help us find Titanstrike!','',26124),
(109416,'enUS','As a Leatherworker, you recognize this type of tannin. Exposing it to the night air should ruin it for any future use.','As a Leatherworker, you recognize this type of tannin. Exposing it to the night air should ruin it for any future use.',26124),
(109417,'enUS','Now let\'s see... plug this in over here... realign the power unit...','',26124),
(109418,'enUS','Remote relay observer unit XR9-47 active. System status: damaged. Rebooting. Please stand by.','',26124),
(109419,'enUS','Efrina, find your brother and rally at the tomb.','',26124),
(109420,'enUS','','They\'re coming to life!',26124),
(109421,'enUS','By the Earthmother!','',26124),
(109422,'enUS','Back to the depths with you, Ozumat. Your master commands it!','',26124),
(109423,'enUS','Shaman of the Earthen Ring, you have called, but I already know the threat we face.','',26124),
(109424,'enUS','Earth Shock is one of your most powerful spells. Casting it requires Maelstrom, a resource generated by your other attacks.','',26124),
(109425,'enUS','Use Earth Shock on this target dummy.','',26124),
(109426,'enUS','The Burning Legion has come. You should make use of the little time you have left, mortals.','',26124),
(109429,'enUS','Foolish mortals! There is no unity among the Lords of Elements!','',26124),
(109430,'enUS','What do you suggest, little orc? Shall I fight the Burning Legion myself?','',26124),
(109431,'enUS','','An\'anora!',26124),
(109432,'enUS','Come forward then. Let me look upon this champion!','',26124),
(109433,'enUS','Ahh yes... I have seen you before! There is power in you... but not enough to defeat the Burning Legion alone.','',26124),
(109434,'enUS','Ever wanted to turn someone into a frog? Hex allows you to do just that!','',26124),
(109435,'enUS','Turn my soldier into a frog!','',26124),
(109436,'enUS','There are times you\'ll face multiple opponents on the battlefield. Fortunately, you have a potent ability called Chain Lightning.','',26124),
(109437,'enUS','Use Chain Lightning against several enemies at once.','',26124),
(109438,'enUS','There was a time, long ago, when the elements fought as one... perhaps there is still hope.','',26124),
(109439,'enUS','Very well, shaman. I will join the fight to save this world.','',26124),
(109440,'enUS','You\'ve taken damage, but this presents no problem for you.','',26124),
(109441,'enUS','Use Healing Surge to replenish your health to full.','',26124),
(109442,'enUS','System status: functional. Rerouting commands to maker\'s console.','',26124),
(109443,'enUS','Unleash the elements to achieve victory, $p!','',26124),
(109444,'enUS','Well done, $p! You are now prepared to do battle as an elemental shaman.','',26124),
(109445,'enUS','Maker? Oh no... please don\'t be him...','',26124),
(109446,'enUS','Hmmpf! Would you bow to Sargeras and be his slave instead? Pathetic!','',26124),
(109447,'enUS','You will not fight alone. The Earthen Ring is with you, and we will gather the other Elemental Lords to our cause!','',26124),
(109448,'enUS','Bronzebeard? Ah yes, there you are! My records show this unit has been inactive for millennia. It was stolen from my lab long ago.','',26124),
(109449,'enUS','For the last time, I\'m not Brann!','',26124),
(109450,'enUS','','Where is Titanstrike, little tinkerer?',26124),
(109451,'enUS','The gun is there? Most curious! Telemetry coming in... the Broken Isles... vrykul tomb... Ah yes, I see it now!','',26124),
(109452,'enUS','Oh my stars! Yes, this is it! The lid is attuned to a particular frequency. I just need to transmit a signal like so, and...','',26124),
(109453,'enUS','All is not lost, Tidehunter. If the Elemental Lords unite...','',26124),
(109454,'enUS','Your skill in Skinning allows you to recognize the vellum this is inscribed upon despite the water damage. Releasing the magic within should be no problem.','Your skill in Skinning allows you to recognize the vellum this is inscribed upon despite the water damage. Releasing the magic within should be no problem.',26124),
(109455,'enUS','This citizen appears to have been injured by fel magic... his fel-seared wounds look to resist normal recovery.','This citizen appears to have been injured by fel magic... his fel-seared wounds look to resist normal recovery.',26124),
(109456,'enUS','Your skill in First Aid allows you to recognize what is needed to ensure this one does not perish.','Your skill in First Aid allows you to recognize what is needed to ensure this one does not perish.',26124),
(109457,'enUS','While not the best solution, your Tailoring allows you to wrap up these wounds and at least stabilize this civilian.','While not the best solution, your Tailoring allows you to wrap up these wounds and at least stabilize this civilian.',26124),
(109458,'enUS','This citizen appears to have been injured by fel magic... his fel-seared wounds look to resist normal recovery.\n\nWith no good way to aid this civilian, you must unfortunately continue along.','This citizen appears to have been injured by fel magic... his fel-seared wounds look to resist normal healing.\n\nWith no good way to aid this civilian, you must unfortunately continue along.',26124),
(109459,'enUS','Not down here? Alright then, go ahead and use the ladder to check the upper scribrary.','',26124),
(109460,'enUS','Don\'t give up hope, $n. Keep milling, and inspect your inks for unusual properties. Together, you and I may be able to fill in the gaps where this book is lacking.','',26124),
(109461,'enUS','Prepare to meet your end, mortals!','Prepare to meet your end, mortals!',26124),
(109462,'enUS','Your end is only the beginning!','Your end is only the beginning!',26124),
(109463,'enUS','The power of Sargeras courses through our veins!','The power of Sargeras courses through our veins!',26124),
(109464,'enUS','By the might of Sargeras!','By the might of Sargeras!',26124),
(109465,'enUS','Your world will burn!','Your world will burn!',26124),
(109466,'enUS','Protectors - remove these unwelcome guests!','Protectors - remove these unwelcome guests!',26124),
(109467,'enUS','These mortals disrupt our ritual! Put an end to them at once.','These mortals disrupt our ritual! Put an end to them at once.',26124),
(109468,'enUS','The ancient grounds of Llothien have long been abandoned. Now our ancestral land is overrun with beasts. I cannot bear to see it in such a state! Please make it right again, champion.','',26124),
(109469,'enUS','You have my gratitude. The stones of Llothien may once again know peace, thanks to you.','',26124),
(109470,'enUS','|TInterface\\Icons\\Ability_Rogue_EnvelopingShadows:20|tIl\'gynoth has almost completed his |cFFFF0000|Hspell:210781|h[Dark Reconstitution]|h|r!','|TInterface\\Icons\\Achievement_Boss_YoggSaron_01:20|tA Dominator Tentacle faces you and readies |cFFFF0000|Hspell:208689|h[Ground Slam]|h|r!',26124),
(109471,'enUS','The drogbar are coming?','The drogbar are coming?',26124),
(109472,'enUS','But... this is our land.','But... this is our land.',26124),
(109473,'enUS','What? The Underking is coming? Oh no!','What? The Underking is coming? Oh no!',26124),
(109474,'enUS','We need to get out of here!','We need to get out of here!',26124),
(109475,'enUS','Argh! Blast this wind!','',26124),
(109476,'enUS','Evacuate? But we have tilled this soil for generations.','Evacuate? But we have tilled this soil for generations.',26124),
(109477,'enUS','Bah! The drogbar can\'t win. They are just a bunch of savages.','Bah! The drogbar can\'t win. They are just a bunch of savages.',26124),
(109478,'enUS','Drogbar do not come above ground. That is something they just don\'t do.','Drogbar do not come above ground. That is something they just don\'t do.',26124),
(109479,'enUS','Ah, there you are. The area was secured at great cost. This cannot continue, we must retrieve the Silver Hand and destroy the entrance to the tomb.','',26124),
(109480,'enUS','I will complete the ritual to release the Hammer and collapse the tomb, but we must be quick. I can sense evil emanating from the tomb.','',26124),
(109481,'enUS','You and I shall lead a small team in first. Let me know when you are ready.','',26124),
(109482,'enUS','Danger still lurks within the tomb. Curse all the meddlers! If you keep us alive, we will clear the way.','',26124),
(109483,'enUS','I\'m ready.','I\'m ready to enter.',26124),
(109484,'enUS','%s falls to one knee, gravely wounded.','%s falls to one knee, gravely wounded.',26124),
(109485,'enUS','%s is |cFFFF0404|Hspell:204237|h[Gravely Wounded]|h|r and cannot fight until healed!','%s is |cFFFF0404|Hspell:204237|h[Gravely Wounded]|h|r and cannot fight until healed!',26124),
(109491,'enUS','Tell me about Latosius.','Tell me about Latosius.',26124),
(109492,'enUS','Do you remember Suramar before the Sundering?','Do you remember Suramar before the Sundering?',26124),
(109493,'enUS','We seek a powerful artifact. What do you know?','We seek a powerful artifact. What do you know?',26124),
(109497,'enUS','','Jale! You have returned. Thank the spirits.',26124),
(109498,'enUS','','Destroyed?',26124),
(109499,'enUS','','Yes. This hero got us to safety, but we MUST get the other tribes back here to help us. We cannot stand divided.',26124),
(109500,'enUS','There it is! Mission accomplished!','',26124),
(109501,'enUS','Thieves! Your heads will decorate my throne!','',26124),
(109502,'enUS','None challenge me and live.','',26124),
(109503,'enUS','You of flesh are not worthy to wield the storms!','',26124),
(109504,'enUS','What... what happened?','What... what happened?',26124),
(109505,'enUS','I couldn\'t stop! I swear it!','I couldn\'t stop! I swear it!',26124),
(109506,'enUS','I feel so weak...','I feel so weak...',26124),
(109507,'enUS','My... is this me? Am I myself again!?','My... is this me? Am I myself again!?',26124),
(109508,'enUS','They know our secrets! Our thoughts are not our own!','They know our secrets! Our thoughts are not our own!',26124),
(109509,'enUS','I felt fear like never before...','I felt fear like never before...',26124),
(109510,'enUS','So helpless... where am I?','So helpless... where am I?',26124),
(109511,'enUS','You are weak!','You are weak!',26124),
(109512,'enUS','We are everywhere!','We are everywhere!',26124),
(109513,'enUS','You cannot escape!','You cannot escape!',26124),
(109514,'enUS','By the might of the Legion!','By the might of the Legion!',26124),
(109515,'enUS','The Legion cannot be stopped!','The Legion cannot be stopped!',26124),
(109516,'enUS','Fragile mortal! Your end has come!','Fragile mortal! Your end has come!',26124),
(109517,'enUS','Your soul shall suffer!','Your soul shall suffer!',26124),
(109518,'enUS','Come forth and fight for the Dream!','',26124),
(109519,'enUS','Allies! To my side!','',26124),
(109520,'enUS','Nature will rise against you!','',26124),
(109521,'enUS','We must strike back at the Nightmare!','',26124),
(109522,'enUS','Attack the corruptors!','',26124),
(109523,'enUS','The battle is joined!','',26124),
(109524,'enUS','Noble ancient, stomp out the stain of their evil!','',26124),
(109525,'enUS','Seeds of life, purge the wicked from this grove!','',26124),
(109526,'enUS','Champion of the Dream, strike with wing and claw!','',26124),
(109527,'enUS','Beloved daughter, restore my strength!','',26124),
(109528,'enUS','Sacred vines, entangle the corrupted!','',26124),
(109529,'enUS','Die, corrupter!','',26124),
(109530,'enUS','The Dream must endure!','',26124),
(109531,'enUS','Your death fortifies the Dream!','',26124),
(109532,'enUS','Your Nightmare ends here!','',26124),
(109533,'enUS','The impurity must be cleansed!','',26124),
(109534,'enUS','And so the Dream is preserved!','',26124),
(109535,'enUS','I mourn your deaths, but I could not let the Nightmare win.','',26124),
(109536,'enUS','Father! I have... failed you...','',26124),
(109537,'enUS','Thero\'shan... how... could you?','',26124),
(109538,'enUS','Malfurion! No, it cannot be! I prayed my thero\'shan would never fall to the Nightmare. Yet here you stand, casting a shadow upon the purity of the Dream!','',26124),
(109539,'enUS','Liars! Servants of darkness! It will give me no pleasure to destroy you, but my duty is to the Dream. Andu-falah-dor!','',26124),
(109540,'enUS','Insolent whelps. Taste my steel!','',26124),
(109541,'enUS','Is that you, Thero\'shan?','',26124),
(109542,'enUS','Aaargh! Enough of your lies! The Nightmare must be ended!','',26124),
(109543,'enUS','Aid me, brothers and sisters. We stand as one!','',26124),
(109544,'enUS','You fight with noble hearts! Could it be true? Could the darkness be inside of... me?','',26124),
(109545,'enUS','I am the scourge of a thousand plains. The terror of the isles!','',26124),
(109546,'enUS','Father? Father, is that you?','',26124),
(109547,'enUS','Yes, father! I will not fail you!','',26124),
(109548,'enUS','You... cannot control...','',26124),
(109549,'enUS','Deceiver! You corrupt the servants of the Dream!','',26124),
(109550,'enUS','Filth! Defiler!','',26124),
(109551,'enUS','What wickedness is this, Malfurion?','',26124),
(109552,'enUS','Villains! You poison the children of the Dream!','',26124),
(109553,'enUS','I have purified one of them! They fight for us now!','',26124),
(109554,'enUS','Let the Nightmare be cleansed!','',26124),
(109555,'enUS','I will not lose you, shan\'do!','',26124),
(109556,'enUS','Master, we fight to save them! To save you!','',26124),
(109557,'enUS','Cenarius! It breaks my heart to see my shan\'do twisted and torn this way. If we can subdue him, I will do everything in my power to purge the vile touch of Xavius from his spirit.','',26124),
(109558,'enUS','Can it be? My old master is blind to the lies of Xavius and thinks WE are the source of the infestation!','',26124),
(109559,'enUS','You have been deceived, my teacher! Xavius has twisted your perceptions! I beg of you, let me cleanse you of his evil!','',26124),
(109560,'enUS','Yes, Cenarius! We are here to save you!','',26124),
(109561,'enUS','Hold your weapons! He begins to see the truth!','',26124),
(109562,'enUS','Cenarius! Do not listen to him!','',26124),
(109563,'enUS','It is done! Cenarius is beaten, but my great teacher lives. Now I must focus all of my strength to cleanse him.','',26124),
(109564,'enUS','Xavius waits ahead in the Rift of Aln, the true heart of the Nightmare. Would that I could fight at your side, heroes, but... to this place, I cannot go.','',26124),
(109565,'enUS','My bond with the Emerald Dream gives me great power... but it also makes me vulnerable to the rift\'s darkness. I have peered inside it and know this to be true. Should I step within, I would be lost... just as Cenarius was.','',26124),
(109566,'enUS','Go. Destroy the Nightmare Lord. Only this way can the Dream be restored... and Azeroth be saved.','',26124),
(109567,'enUS','They are lying to you!','',26124),
(109568,'enUS','Yes, my son! It is your father, Malorne! Do not trust these invaders! You must purge them from the Dream!','',26124),
(109569,'enUS','|TInterface\\Icons\\Spell_Fire_FelFire:20|t Krosus targets |cFFFF0404you|r with an |cFFFF0404|Hspell:206677|h[Fel Brand]|h|r!','|TInterface\\Icons\\Spell_Fire_FelFlameStrike:20|t Krosus targets you with an |cFFFF0404|Hspell:205344|h[Orb of Destruction]|h|r!',26124),
(109570,'enUS','Just a brief swim and we\'ll reach the tomb.','',26124),
(109571,'enUS','Behold the Tomb of Tyr, built by the mighty... wait! These monsters dare befoul the tomb?!','',26124),
(109572,'enUS','This cannot stand! Destroy these abominations!','',26124),
(109573,'enUS','That wasn\'t so bad! Okay, $n, grab Titanstrike so we can get out of here.','',26124),
(109574,'enUS','','You\'ve played your part. Now I shall play mine!',26124),
(109575,'enUS','It pains me to see such destruction threaten the resting place of the Silver Hand.','',26124),
(109576,'enUS','','The heart of this weapon will infuse me with the might of the titans. The vrykul shall bow before me... their new god-queen!',26124),
(109577,'enUS','','The Legion.. will prevail!',26124),
(109578,'enUS','','Intruders are here!',26124),
(109579,'enUS','','The Emissary must be notified!',26124),
(109580,'enUS','','You will never stop our plans!',26124),
(109581,'enUS','Rest your hands upon the Idol and we will begin the ritual.','',26124),
(109582,'enUS','','The fires will come for you!',26124),
(109583,'enUS','I thank you all.  You have done what few others could.','',26124),
(109584,'enUS','Thank you, $p.  You have done what no others could.','',26124),
(109585,'enUS','','Who DARES challenge the Truthseeker?! I will freeze you where you stand!',26124),
(109586,'enUS','','Protected in ice!',26124),
(109587,'enUS','','Freeze!',26124),
(109588,'enUS','','I have... failed...',26124),
(109589,'enUS','For Gul\'dan!','',26124),
(109590,'enUS','The Legion claims you!','',26124),
(109591,'enUS','You can\'t... beat us all...','',26124),
(109592,'enUS','Your soul belongs to the Legion!','',26124),
(109593,'enUS','Our power will crush you!','',26124),
(109594,'enUS','Die, mortal scum!','',26124),
(109595,'enUS','I\'ll break you all!','',26124),
(109596,'enUS','More bones to play with!','',26124),
(109597,'enUS','I am one... of many...','',26124),
(109598,'enUS','I have you now!','',26124),
(109599,'enUS','Your essence is mine!','',26124),
(109600,'enUS','No escape!','',26124),
(109601,'enUS','This one is mine!','',26124),
(109602,'enUS','Mortal flesh... so very weak!','',26124),
(109603,'enUS','My part... is played.','',26124),
(109604,'enUS','Give me your secrets!','',26124),
(109605,'enUS','Whisper your soul to me!','',26124),
(109606,'enUS','Your world will fall!','',26124),
(109607,'enUS','Keep pressing, champions! Gul\'dan wavers! He WILL fall!','',26124),
(109608,'enUS','They will come no farther!','',26124),
(109609,'enUS','Fight for Azeroth! For all you hold dear!','',26124),
(109610,'enUS','We can stop him! I know it!','',26124),
(109611,'enUS','This is our world, not the Legion\'s!','',26124),
(109612,'enUS','Yessss. It stays in the cage, it does. It stays until master wants it!','',26124),
(109613,'enUS','It loses hope, soon it loses its soul! Master will claim you.','',26124),
(109616,'enUS','Not good, not good at all! You should both join me in my workshop in Ulduar at once. We have a problem to solve!','',26124),
(109617,'enUS','<Plant a flower?>','<Plant a flower?>',26124),
(109618,'enUS','Oh, this is fortunate! Titanstrike\'s power has energized this teleportation pad. I should be able to reroute its destination... Success!','',26124),
(109619,'enUS','I would like to continue with a more difficult challenge, Latosius.','I would like to continue with a more difficult challenge, Latosius.',26124),
(109620,'enUS','I believe I am prepared for a very difficult challenge, Latosius.','I believe I am prepared for a very difficult challenge, Latosius.',26124),
(109621,'enUS','Your actions will be your undoing!','',26124),
(109622,'enUS','Well, we can\'t stop now! What\'re ye waitin\' for? C\'mon, Theodore!','',26124),
(109623,'enUS','|TInterface\\Icons\\INV_Misc_Bell_01:20|tAs the |cFFFF0000Bazaar Goods|r are tampered with, a magical alarm rings out!','|TInterface\\Icons\\INV_Misc_Bell_01:20|tAs the |cFFFF0000Bazaar Goods|r are tampered with, a magical alarm rings out!',26124),
(109624,'enUS','|TInterface\\Icons\\inv_misc_statue_04:20|tThe destruction of the |cFFFF0000Lifesized Nightborne Statue|r draws the attention of enemies!','|TInterface\\Icons\\inv_misc_statue_04:20|tThe destruction of the |cFFFF0000Lifesized Nightborne Statue|r draws the attention of enemies!',26124),
(109625,'enUS','','Your bladework is slow and thoughtless. Train harder!',26124),
(109626,'enUS','','So slow, so predictable! Your swordsmanship is weak!',26124),
(109627,'enUS','Bagging','Bagging',26124),
(109628,'enUS','|TInterface\\Icons\\inv_gizmo_03:20|tThe clamor of tools repairing the pile of |cFFFF0000Discarded Junk|r echoes through the district!','|TInterface\\Icons\\inv_gizmo_03:20|tThe clamor of tools repairing the pile of |cFFFF0000Discarded Junk|r echoes through the district!',26124),
(109629,'enUS','Abra Cadabra!','Abra Cadabra!',26124),
(109630,'enUS','You hear footsteps behind you!','You hear footsteps behind you!',26124),
(109631,'enUS','Hey! Tha...  thash MY drink! <hic!>','',26124),
(109632,'enUS','Plant aethril','Plant aethril',26124),
(109633,'enUS','Plant dreamleaf','Plant dreamleaf',26124),
(109634,'enUS','Plant foxflower','Plant foxflower',26124),
(109635,'enUS','Plant fjarnskaggl','Plant fjarnskaggl',26124),
(109636,'enUS','Plant starlight rose','Plant starlight rose',26124),
(109637,'enUS','Plant felwort','Plant felwort',26124),
(109638,'enUS','S... sleepy time... <hic!>','',26124),
(109639,'enUS','Over here! There\'s no time to wind your way through the entire complex.','',26124),
(109640,'enUS','Well done, soldiers! Three of you, on me. We\'ll warn the others. The rest of you hold your -','',26124),
(109641,'enUS','Watchout! Another!','',26124),
(109642,'enUS','','Ivanel Meadowsong reaches out toward the nearby hippogryph and weakly tries to shoo it away.',26124),
(109643,'enUS','','Go on, fly away!',26124),
(109644,'enUS','Wild Moonfall Hippogryph claws defiantly at the air and remains unmoved.','',26124),
(109645,'enUS','','Do not come back for us. We are already doomed by the Nightborne\'s betrayal.',26124),
(109646,'enUS','','We need to - Beakbuck, no!',26124),
(109647,'enUS','Beakbuck turns and charges toward you!','',26124),
(109648,'enUS','<Vanthir halts his conversation abruptly as you approach and eyes you suspiciously.>$B$BAnarys. What do you want? Are there no more demon boots left for you to lick?','',26124),
(109649,'enUS','','Training starts now. Are you ready?',26124),
(109650,'enUS','','Ignore him. I need you to find Lothrius. We were separated in the attack- I think he is still holding out at the Athenaeum.',26124),
(109651,'enUS','','Formations!',26124),
(109652,'enUS','Ly\'leth would like you to visit her regarding a shipment of dusk lily pods.','Ly\'leth would like you to visit her regarding a shipment of dusk lily pods.',26124),
(109653,'enUS','','Again!',26124),
(109654,'enUS','','Well done. Make sure to practice every day.',26124),
(109655,'enUS','','You need to riposte!',26124),
(109656,'enUS','','Keep at it.',26124),
(109657,'enUS','','Practice the basics.',26124),
(109658,'enUS','','Nicely done.',26124),
(109659,'enUS','','Now for the counter-attack!',26124),
(109660,'enUS','Dusk lily pods? I see...','',26124),
(109661,'enUS','Sometimes I forget how talented Serena is. Welcome, as it were. It is high time we dealt with these intruders.','',26124),
(109662,'enUS','Please excuse me. I must address this immediately.','',26124),
(109663,'enUS','','Press your advantage.',26124),
(109664,'enUS','I have laid out a safe path for you. Touching the crystals will summon my guardians to you. Make good use of it and go swiftly!','',26124),
(109665,'enUS','','There!',26124),
(109666,'enUS','','Lothrius\' magic called to me. He must still be alive! Quickly- you can help us rejoin the others.',26124),
(109667,'enUS','','We will move when the way is clear. Your bravery is worth more than you know, friend.',26124),
(109668,'enUS','Excellent! You made it through in one piece! You can never be sure about the reliability of stolen teleporters...','',26124),
(109677,'enUS','I\'m preparing the diagnostic systems now. Say, you had quite an epic struggle with that ghostly vrykul warlord. The thief had it coming, if you ask me!','',26124),
(109678,'enUS','Steam pump... check. Low-ion energy converter units... check, check, and... check.','',26124),
(109679,'enUS','There you are! Right on schedule.','',26124),
(109680,'enUS','Now, let\'s recall that observation unit from Stormheim.','',26124),
(109681,'enUS','Stormheim... Stormheim... Ah, there it is.','',26124),
(109682,'enUS','Engaging processors. Initializing download relays. I don\'t anticipate any incompatibilities with my upgraded systems.','',26124),
(109683,'enUS','Once the process kicks into gear, it should only take a minute or two to retrieve the information from XR9-47 here. Just sit back and enjoy the science!','',26124),
(109684,'enUS','Please... someone!','Please... someone!',26124),
(109685,'enUS','Anyone? Help!','Anyone? Help!',26124),
(109686,'enUS','If you wouldn\'t mind, I\'d like to help.','If you wouldn\'t mind, I\'d like to help.',26124),
(109687,'enUS','Looks like this fight\'s just beginning.','Looks like this fight\'s just beginning.',26124),
(109688,'enUS','Thanks. I need find the others, but hopefully this helps.','Thanks. I need find the others, but hopefully this helps.',26124),
(109689,'enUS','Keep moving! They\'re everywhere!','Keep moving! They\'re everywhere!',26124),
(109690,'enUS','You there! Mind lending a hand?','You there! Mind lending a hand?',26124),
(109691,'enUS','My spellbook! How can I - Hey! Over here!','My spellbook! How can I - Hey! Over here!',26124),
(109692,'enUS','What kind of mess have I gotten myself into?','What kind of mess have I gotten myself into?',26124),
(109693,'enUS','<If you had an herb, you could plant it here.>','<Plant a flower?>',26124),
(109694,'enUS','More Kirin Tor Spies!','',26124),
(109695,'enUS','Your friend has been dealt with.','',26124),
(109696,'enUS','Now it is your turn!','',26124),
(109697,'enUS','This looks like the perfect opportunity for me to hone my skills!','This looks like the perfect opportunity for me to hone my skills!',26124),
(109698,'enUS','I seem to be missing some of my newer spells, though I\'m sure we won\'t run into too much trouble.','I seem to be missing some of my newer spells, though I\'m sure we won\'t run into too much trouble.',26124),
(109699,'enUS','%s flips through the pages of his spellbook.','%s flips through the pages of his spellbook.',26124),
(109700,'enUS','By the Light! What are ye doin\' all the way out here? Ne\'er mind that! Help me with this thing!','By the Light! What are ye doin\' all the way out here? Ne\'er mind that! Help me with this thing!',26124),
(109701,'enUS','Ne\'er thought I\'d see you out here! Mind lendin\' a hand?','Ne\'er thought I\'d see you out here! Mind lendin\' a hand?',26124),
(109702,'enUS','<The beast looks at you for a moment and neighs.>','',26124),
(109703,'enUS','<Carefully take a small blood sample.>','<Carefully take a small blood sample.>',26124),
(109704,'enUS','<Obtain the blood with your dark magic.>','<Obtain the blood with your dark magic.>',26124),
(109705,'enUS','Mind some comp\'ny? We\'re ere fer the same cause.','Mind some comp\'ny? We\'re ere fer the same cause.',26124),
(109706,'enUS','Always wanted ta test my skills alongside a $c.','Always wanted ta test my skills alongside a $c.',26124),
(109707,'enUS','Your Voidwalker has died. Use Summon Voidwalker to bring it back.','',26124),
(109708,'enUS','Appreciate the help, but I\'ve got ta keep movin\'.','Appreciate the help, but I\'ve got ta keep movin\'.',26124),
(109709,'enUS','Once you cast Agony, you don\'t need to cast it again until your original spell is close to expiring.','',26124),
(109710,'enUS','Agony has expired! Cast it again!','',26124),
(109711,'enUS','Use Agony!','',26124),
(109712,'enUS','Once you cast Corruption, you don\'t need to cast it again until your original spell is close to expiring.','',26124),
(109713,'enUS','Corruption has expired! Cast it again!','',26124),
(109714,'enUS','Use Corruption!','',26124),
(109715,'enUS','What... how did...?','',26124),
(109716,'enUS','Use Drain Life on your target!','',26124),
(109717,'enUS','Use Drain Life!','',26124),
(109718,'enUS','The intruders are here!','',26124),
(109719,'enUS','Thank ye! Quite the brave $c, aren\'t ye.','Thank ye! Quite the brave $c, aren\'t ye.',26124),
(109720,'enUS','Good work!','',26124),
(109721,'enUS','Excellent!','',26124),
(109722,'enUS','Great!','',26124),
(109723,'enUS','Excellent work!','',26124),
(109724,'enUS','Very good.','',26124),
(109725,'enUS','I was touched... by filthy outsiders?!','',26124),
(109726,'enUS','Well done!','',26124),
(109727,'enUS','Have you come to join us? I hope you brought us something powerful to study.','Have you come to join us? I hope you brought us something powerful to study.',26124),
(109728,'enUS','While Unstable Affliction deals damage over time, every re-cast increases its potency. Use this attack whenever you can!','',26124),
(109729,'enUS','Unstable Affliction is available! Cast it now!','',26124),
(109730,'enUS','Use Unstable Affliction!','',26124),
(109731,'enUS','Use Life Tap to replenish your mana!','',26124),
(109732,'enUS','I brought you a Pearl of Arcane Wisdom. What is it you do here, exactly?','I brought you a Pearl of Arcane Wisdom. What is it you do here, exactly?',26124),
(109733,'enUS','Cast Fear!','',26124),
(109734,'enUS','While greater demons like Infernals and Doomguards cannot be controlled for long, you can summon one to your side for short periods of time to fight for you.','',26124),
(109735,'enUS','Are you here to learn from us? What did you bring us?','Are you here to learn from us? What did you bring us?',26124),
(109736,'enUS','Use Summon Doomguard now to summon this demon.','',26124),
(109737,'enUS','Summon your Doomguard now!','',26124),
(109738,'enUS','Hmm, that is indeed interesting. We study exotic magic of all types in order to prepare ourselves for ascension.','Hmm, that is indeed interesting. We study exotic magic of all types in order to prepare ourselves for ascension.',26124),
(109739,'enUS','We study that which gives us the power to ascend. You must bring your gift to Marlan.','We study that which gives us the power to ascend. You must bring your gift to Marlan.',26124),
(109740,'enUS','For the Alliance!','',26124),
(109744,'enUS','A portion of your power can be coalesced into a Healthstone. If you take damage, ingest the Healthstone to recover health.','',26124),
(109746,'enUS','Use Create Healthstone.','',26124),
(109748,'enUS','Now, heal some of the damage you\'ve taken with your Healthstone.','',26124),
(109749,'enUS','Now, heal some of the damage you\'ve taken with your Healthstone.','',26124),
(109751,'enUS','You\'re low on health, use your Healthstone!','',26124),
(109752,'enUS','A well-prepared warlock can survive almost anything... even death!','',26124),
(109753,'enUS','Use Soulstone to survive death.','',26124),
(109754,'enUS','Astounding! Your mastery over demons has given you great power!','',26124),
(109755,'enUS','','My gun... it\'s jammed!',26124),
(109757,'enUS','','Careful! They\'re stronger than they seem!',26124),
(109758,'enUS','','Looks like you could use some company.',26124),
(109759,'enUS','','You keep \'em at a distance. I\'ll do the rest.',26124),
(109760,'enUS','','Be careful out here, $n. The air is full of their foul odor.',26124),
(109761,'enUS','','Not too familiar with these parts. I best keep on.',26124),
(109762,'enUS','Oh, my, yes! This is going to yield so much exciting data!','',26124),
(109763,'enUS','I\'m ready to get started.','I\'m ready to get started.',26124),
(109769,'enUS','Thank you, $p, for restoring Cenarius to his natural state.  Our world has once again been saved through your deeds.','',26124),
(109770,'enUS','','%s gasps.',26124),
(109771,'enUS','','You need to leave, $c... NOW!',26124),
(109773,'enUS','','The demons are encroaching on our lands from Suramar. We must drive them back! If you take out their leaders, my Scalewardens will bring down their portals.',26124),
(109774,'enUS','','Together we can push the Legion back!',26124),
(109775,'enUS','','That should keep them at bay for now. Fare you well, champion. We will handle it from here!',26124),
(109783,'enUS','Treat the patient\'s fever.','Treat the patient\'s fever.',26124),
(109786,'enUS','Azsuna will fall before the Legion!','',26124),
(109787,'enUS','We cannot... be stopped...','',26124),
(109788,'enUS','We will purge this land in fel fire!','',26124),
(109789,'enUS','Arkethrax... avenge me!','',26124),
(109791,'enUS','The naga have been using their foul sorcery to dominate the minds of the local murlocs. That group there seem to be in the early stages. See if you can knock some sense back into them.','',26124),
(109792,'enUS','Well done! We were lucky to get to them early, before the naga\'s influence could fully take hold.','',26124),
(109793,'enUS','','This once-proud winery has been tainted, and foul creatures now seep from the defiled barrels. Cleanse this cursed placed!',26124),
(109794,'enUS','','Pity to waste wine, but it looked like a sour vintage anyway.',26124),
(109795,'enUS','','The local wildlife preys upon our injured whelplings. Please, protect them.',26124),
(109796,'enUS','','That whelp will recover in time. You have my thanks.',26124),
(109797,'enUS','If you want to aid our cause, you\'ll need to sharpen your skills.','',26124),
(109798,'enUS','','It seems you know your stuff. We may have a use for you.',26124),
(109799,'enUS','','I believe I may have discovered the secret of Garuhod\'s recipe. I need you to gather some specific ingredients, but you must be careful. These creatures are most delicate!',26124),
(109800,'enUS','','Excellent! I\'ll give the recipe a try. The real trick will be finding someone willing to drink it...',26124),
(109801,'enUS','','Don\'t let the size of that brute fool you. He\'s as dangerous as the rest of his kind. Watch out for his poison scales!',26124),
(109802,'enUS','','If you start to feel woozy from the poison, seek out a priest immediately.',26124),
(109803,'enUS','Use Backstab to generate combo points.','',26124),
(109804,'enUS','Use Backstab!','',26124),
(109805,'enUS','Starting combat from stealth is more effective.','',26124),
(109806,'enUS','<The wind whips furiously as you approach, roiling with lightning. Perhaps a shaman could be called in to speak with the restless elemental?>','',26124),
(109807,'enUS','<The wind whips furiously as you approach, crackling with lightning discharges. The elemental at the storm\'s core calls out to you with a distorted voice.>$b$bPlease... shaman...$b$bI cannot contain the tempest within... Help me... Help...','',26124),
(109808,'enUS','While you are busy, Calydus will search for a suitable location for the ritual.','',26124),
(109809,'enUS','','You did right by your fellow warlocks, which is commendable, and surprising.',26124),
(109810,'enUS','','I escape one demon world, only to dwell within another demon world. \n\nAt least this one is under your control.',26124),
(109811,'enUS','','With the Dreadscar demons under your control, their power will be ours to dissect and command.',26124),
(109812,'enUS','<Zinnin bows his head slightly, silently acknowledging your presence.>','',26124),
(109813,'enUS','Arms warriors are the ultimate physical combatants, using martial skill and weaponry to crush those who stand against them.','',26124),
(109814,'enUS','Use your Charge ability to cover the distance to this target dummy.','',26124),
(109815,'enUS','Warriors don\'t stroll up to face a foe! Use Charge to close the distance on your opponent. Try it!','',26124),
(109816,'enUS','Once you reach your target you will perform basic attacks automatically, but a skilled combatant unleashes a variety of advanced abilities to defeat a foe.','',26124),
(109817,'enUS','Use Mortal Strike on the target dummy.','',26124),
(109818,'enUS','Mortal Strike is available!  Use it now!','',26124),
(109819,'enUS','Use Mortal Strike!','',26124),
(109820,'enUS','Dealing damage to your enemy builds up Rage, which fuels your attacks. Use Slam to spend Rage and deal damage to your enemy.','',26124),
(109821,'enUS','Use Slam on the target dummy.','',26124),
(109822,'enUS','Use Slam!','',26124),
(109823,'enUS','One of your most devastating attacks is Colossus Smash. Always use it as soon as it becomes available and no foe will stand against you for long.','',26124),
(109824,'enUS','Use Colossus Smash on the Target Dummy.','',26124),
(109825,'enUS','Colossus Smash is available! Use it now!','',26124),
(109826,'enUS','Use Colossus Smash!','',26124),
(109827,'enUS','After you defeat an opponent, your heart will sing with the glory of victory!','',26124),
(109828,'enUS','Eliminate an enemy, enabling Victory Rush to be used on your next opponent.','',26124),
(109829,'enUS','Victory Rush is available! Use it now!','',26124),
(109830,'enUS','Use Victory Rush!','',26124),
(109831,'enUS','Unfurl your winds, friend, and I will soothe the tempest.','Unfurl your winds, friend, and I will soothe the tempest.',26124),
(109832,'enUS','Calydus found a perfect spot for the ritual! Come, friend, meet Calydus in the room behind the curtains at the place called the Violet Gate.','',26124),
(109833,'enUS','Use Shadowstrike!','',26124),
(109834,'enUS','Your opponents may try to overwhelm you with numbers, but they underestimate your true might!','',26124),
(109835,'enUS','Those alarms indicate that we\'re encountering some... minor technical difficulties with the fusion press unit.','',26124),
(109836,'enUS','Use Whirlwind to take out this group of enemies.','',26124),
(109837,'enUS','Perfect!','',26124),
(109838,'enUS','All you need to do is deactivate the two control panels over by the fusion press. Bronzebeard and I will man the central console.','',26124),
(109839,'enUS','Look there! The sacred hammer\'s wards remain strong! First we must purge this infestation. Let me know when you are ready.','',26124),
(109840,'enUS','Whirlwind can damage multiple enemies!','',26124),
(109841,'enUS','Use Whirlwind!','',26124),
(109842,'enUS','In the heat of battle there will be times you need to move quickly to avoid danger... or confront it!','',26124),
(109843,'enUS','Practice using Heroic Leap.','',26124),
(109844,'enUS','Use Eviscerate!','',26124),
(109846,'enUS','You\'re in trouble! Use Vanish!','',26124),
(109847,'enUS','Well done, $p! You are now prepared to do battle as an arms warrior.','',26124),
(109848,'enUS','In order to enact the failsafe ritual we will need to clear the room. Say the word and I will begin.','',26124),
(109849,'enUS','Well done, $p! You are now prepared to do battle as a subtlety rogue.','',26124),
(109851,'enUS','Show me you fight with fearlessness and ferocity!','',26124),
(109852,'enUS','Show me you\'ve got the stuff.','',26124),
(109853,'enUS','When you feel ready, explore your spellbook and the talent tree for additional abilities you can learn.','',26124),
(109854,'enUS','Whirlwind is not the only attack you can use against multiple enemies.','',26124),
(109855,'enUS','Use Cleave and Whirlwind to take out this group of enemies.','',26124),
(109856,'enUS','Use Cleave!','',26124),
(109857,'enUS','Tougher enemies may require a broader range of abilities to overcome. As an alternative to Eviscerate, Nightblade can be used to deal damage over time to your target, and is a good ability to spend combo points on early in a fight. Like Eviscerate, Nightblade is a finishing move, and is best used when you have 5 combo points.','',26124),
(109858,'enUS','Use Nightblade with 5 combo points on the target dummy.','',26124),
(109859,'enUS','You have 5 combo points. Use Nightblade!','',26124),
(109860,'enUS','Use Nightblade!','',26124),
(109861,'enUS','Wait until you have 5 combo points to use Nightblade!','',26124),
(109864,'enUS','Use Crimson Vial to restore health!','',26124),
(109871,'enUS','You\'re facing multiple enemies, try using Shuriken Storm!','',26124),
(109874,'enUS','Well done, $p! You are now prepared to do battle as a retribution paladin.','',26124),
(109876,'enUS','Judgment is a ranged ability. Try using it from further away!','',26124),
(109877,'enUS','Judgment is available!  Cast it now!','',26124),
(109878,'enUS','Cast Judgment!','',26124),
(109879,'enUS','Blade of Justice is available!  Cast it now!','',26124),
(109880,'enUS','Cast Blade of Justice!','',26124),
(109881,'enUS','Use Crusader Strike to generate Holy Power!','',26124),
(109882,'enUS','Use Crusader Strike!','',26124),
(109883,'enUS','Templar\'s Verdict is available! Use it now!','',26124),
(109884,'enUS','Use Templar\'s Verdict!','',26124),
(109885,'enUS','You\'re in trouble! Cast Divine Shield to save yourself!','',26124),
(109886,'enUS','Use Divine Shield!','',26124),
(109887,'enUS','Use Flash of Light to heal yourself!','',26124),
(109888,'enUS','I\'m not... Oh, fer crying out loud!','',26124),
(109889,'enUS','But please, don\'t hurt them too badly. I need them for later.','',26124),
(109890,'enUS','You did it! The flames are dyin\' down.','',26124),
(109892,'enUS','Astounding! Fusion system running at 98.33 percent efficiency. Repeating, of course.','',26124),
(109893,'enUS','Watch yourselves! Let us cleanse this chamber!','',26124),
(109894,'enUS','You are next in line!','You are next in line!',26124),
(109895,'enUS','Oh dear. Now the Storm Leviathan unit is experiencing a target recognition system malfunction.','',26124),
(109896,'enUS','Activate the stabilization matrix before it tears the whole lab apart!','',26124),
(109897,'enUS','Well done everyone, let\'s... Wait, what is that?','',26124),
(109898,'enUS','Fool of a shaman... Even YOU could not withstand my tempest within. BEGONE!','',26124),
(109899,'enUS','BLERG!','',26124),
(109900,'enUS','Blerg?','',26124),
(109901,'enUS','Your allies have fallen! %s retreats!','Your allies have fallen! %s retreats!',26124),
(109902,'enUS','Shaman, you braved the tempest with a peaceful mind. Your focus inspires me. Go now, with my blessings upon you.','',26124),
(109903,'enUS','At last we can begin! After the ritual is complete and we have the hammer, the complex will collapse, sealing Tyr\'s resting place forever.','',26124),
(109904,'enUS','Something is wrong. One of the other Sparks isn\'t here!','',26124),
(109905,'enUS','Wait, I can sense it below, probably taken by one of those monsters. We must have it! We will begin the search when you are ready, champion.','',26124),
(109906,'enUS','We must venture further into the depths and find the spark, or this has all been for naught.','',26124),
(109907,'enUS','Our whelplings hunger for the flesh animals, but the young ones cannot stomach it raw. Plunge this lightning rod into fresh corpses and our whelps shall do the rest.','',26124),
(109908,'enUS','Our whelps will grow strong gorging upon the feast you provided. You have our thanks.','',26124),
(109909,'enUS','You have heard of the War of the Ancients, I am sure. If you are to listen to the Highmountain tauren, they were responsible for defeating Tichondrius.\n\nBut they had help. Much help indeed. Will you listen to my story?','',26124),
(109910,'enUS','Honorless murlocs have overtaken the village of Morheim. I cannot abide their presence in that once-sacred place. Eradicate this filth!','',26124),
(109911,'enUS','Well done. I remember the one whom this village owes its name. He was a fine leader.','',26124),
(109912,'enUS','Esara, be on your guard while inside the Empyrean Enclave.','',26124),
(109913,'enUS','','Always, but why the warning?',26124),
(109914,'enUS','Even experienced mages have an alarming tendency to disappear here... And we could really use you in the Tirisgarde!','',26124),
(109915,'enUS','Look. My favorite conjuror has arrived!','',26124),
(109916,'enUS','The children of Mimiron have crafted a clever toy they claim can harness the power of the storm. Go forth and test their handiwork in battle.','',26124),
(109917,'enUS','A most amusing device. But cleverness is useless without strength of arms!','',26124),
(109918,'enUS','Discipline priests draw upon the opposing forces of Light and Shadow, choosing when to heal and when to inflict damage.','',26124),
(109919,'enUS','Use Shadow Word: Pain on the target dummy.','',26124),
(109920,'enUS','Once your target is afflicted with Shadow Word: Pain, you don\'t need to cast it again until your original spell is close to expiring.','',26124),
(109921,'enUS','Shadow Word: Pain has expired on your target, cast it again!','',26124),
(109922,'enUS','Cast Shadow Word: Pain!','',26124),
(109923,'enUS','The Light is a formidable ally, capable of restoring your friends or striking down foes.','',26124),
(109924,'enUS','Use Penance on the target dummy.','',26124),
(109925,'enUS','Penance is available!  Cast it now!','',26124),
(109926,'enUS','Cast Penance now!','',26124),
(109927,'enUS','The power of the Light allows you to Smite any enemy that stands before you!','',26124),
(109928,'enUS','Use Smite on the target dummy.','',26124),
(109929,'enUS','Cast Smite!','',26124),
(109930,'enUS','Keep moving, wretch!','',26124),
(109931,'enUS','Quit dragging your feet! You belong to the Legion now!','',26124),
(109932,'enUS','Leviathan unit stable! Excellent work, most excellent indeed.','',26124),
(109933,'enUS','As followers of the light, you have many ways to protect and restore health.','',26124),
(109934,'enUS','Use Power Word: Shield to prevent this incoming damage.','',26124),
(109935,'enUS','Cast Power Word: Shield to protect yourself!','',26124),
(109936,'enUS','In some battles you will face multiple opponents at the same time.','',26124),
(109937,'enUS','Use Psychic Scream to prevent this group of enemies from hitting you.','',26124),
(109938,'enUS','Use Psychic Scream!','',26124),
(109939,'enUS','Well, friends, the good news is the download is 89%% complete! But we may also be experiencing a minor case of total system failure.','',26124),
(109940,'enUS','Power Word: Shield protected you from the mage\'s first attack, but the second attack has left you wounded.','',26124),
(109941,'enUS','Use Plea to heal your wounds.','',26124),
(109942,'enUS','Use Plea to heal yourself!','',26124),
(109943,'enUS','Command the forces of Shadow and Light to achieve victory!','',26124),
(109944,'enUS','Well done, $p! You are now prepared to do battle as a discipline priest.','',26124),
(109945,'enUS','I suppose there\'s no time like the present! This will either fix everything... or destroy us. I need you to press the big red button labeled \"DO NOT PUSH THIS BUTTON\".','',26124),
(109946,'enUS','You are not limited to only shielding yourself or an ally. A priest can also cast a shield over an entire area, protecting all allies within its boundaries.','',26124),
(109947,'enUS','Use Power Word: Barrier to protect these soldiers.','',26124),
(109948,'enUS','Healing can also be provided by the Shadow, but it comes at a cost. Shadowmend is a very powerful heal, but part of that healing will drain away over time.','',26124),
(109949,'enUS','Use Shadowmend to replenish your health to full.','',26124),
(109950,'enUS','As a windwalker monk you use your fists and your speed to overcome enemies.','',26124),
(109951,'enUS','Pressing','Pressing',26124),
(109952,'enUS','Use Tiger Palm on the target dummy.','',26124),
(109953,'enUS','Use Tiger Palm to generate Chi!','',26124),
(109954,'enUS','Use Tiger Palm!','',26124),
(109955,'enUS','Starting combat with Tiger Palm gives you enough Chi to unleash the powerful Rising Sun Kick, an attack that uses 2 Chi and deals substantial damage.','',26124),
(109956,'enUS','Use Rising Sun Kick on the target dummy.','',26124),
(109957,'enUS','Rising Sun Kick is available! Use it now!','',26124),
(109958,'enUS','Use Rising Sun Kick!','',26124),
(109959,'enUS','While not as powerful as Rising Sun Kick, your Blackout Kick still packs a punch... or, uh, a kick!','',26124),
(109960,'enUS','Use Blackout Kick on the target dummy.','',26124),
(109961,'enUS','Use Blackout Kick!','',26124),
(109962,'enUS','You have an abundance of attacks at your disposal, windwalker! Fists of Fury costs 3 Chi and does a lot of damage.','',26124),
(109963,'enUS','Use Fists of Fury on the target dummy.','',26124),
(109964,'enUS','Fists of Fury is available! Use it now!','',26124),
(109965,'enUS','Use Fists of Fury!','',26124),
(109966,'enUS','You are fast and agile, able to zip around the battlefield at will.','',26124),
(109967,'enUS','Practice using Roll a few times.','',26124),
(109968,'enUS','Your pet has been wounded! Fortunately, you can aid your trusty companion.','',26124),
(109969,'enUS','Use Mend Pet to heal your pet.','',26124),
(109970,'enUS','Your pet has died! When this happens, your Mend Pet ability changes to Revive Pet, which will bring your faithful companion back to life.','',26124),
(109971,'enUS','Call your pet!','',26124),
(109972,'enUS','Kill Command is available! Use it now!','',26124),
(109973,'enUS','Use Kill Command!','',26124),
(109974,'enUS','Dire Beast is available! Use it now!','',26124),
(109975,'enUS','Use Dire Beast!','',26124),
(109976,'enUS','Use Cobra Shot!','',26124),
(109977,'enUS','Bestial Wrath is available! Use it now!','',26124),
(109978,'enUS','Use Bestial Wrath!','',26124),
(109979,'enUS','Your pet is hurt! Use Mend Pet!','',26124),
(109980,'enUS','Use Multi-Shot!','',26124),
(109981,'enUS','Divine Shield will completely protect you from all attacks for a short period of time, so save it for emergencies.','',26124),
(109982,'enUS','The roots run deep. All will succumb to the Nightmare!','',26124),
(109983,'enUS','I have seen the Nightmare. The Emerald Dream will perish.','',26124),
(109984,'enUS','Excellent! Always remember to use Flame Shock to keep your enemies burning.','',26124),
(109985,'enUS','I return to the Nightmare... What once was light is darkness. Come with me... come with me...','',26124),
(109986,'enUS','Use your Lightning Bolt on the Target Dummy until you have the maximum amount of Maelstrom, then use Earth Shock.','',26124),
(109987,'enUS','Once we clear an area, reinforcements will secure it. Onward paladins!','',26124),
(109988,'enUS','You can call upon the earth itself to defend you and your allies in battle.','',26124),
(109989,'enUS','Use Fire Elemental now to summon your elemental!','',26124),
(109990,'enUS','Use Earth Elemental to summon an earthen protector for a short period.','',26124),
(109991,'enUS','When facing multiple enemies, you can shake the very ground beneath their feet to damage several targets at once.','',26124),
(109992,'enUS','Use Earthquake Totem against multiple foes.','',26124),
(109993,'enUS','As a shaman you can commune with wolf spirits and take on their form. While this doesn\'t give you new combat abilities, it does allow you to move faster.','',26124),
(109994,'enUS','Practice moving around in Ghost Wolf form.','',26124),
(109995,'enUS','Shamans are valuable allies, as they can use their abilities to empower themselves as well as their party and raid members.','',26124),
(109996,'enUS','Use Heroism to temporarily increase your Haste, which speeds up your attacks and spell casts.','',26124),
(109997,'enUS','If you become surrounded in combat, use Thunderstorm to knock enemies back and give yourself some breathing room.','',26124),
(109998,'enUS','Use Thunderstorm to knock away the enemies surrounding you.','',26124),
(109999,'enUS','Use Flame Shock to burn your enemy!','',26124),
(110000,'enUS','Use Flame Shock!','',26124),
(110001,'enUS','Only use Flame Shock when it\'s about to expire!','',26124),
(110002,'enUS','Use Lava Burst while your enemy is burning!','',26124),
(110003,'enUS','Use Lava Burst!','',26124),
(110004,'enUS','Using Lava Burst after your enemy is burning from Flame Shock increases its damage!','',26124),
(110005,'enUS','Use Lightning Bolt!','',26124),
(110006,'enUS','You are at maximum Maelstrom! Use Earth Shock!','',26124),
(110007,'enUS','Use Earth Shock!','',26124),
(110008,'enUS','Wait until you are at maximum Maelstrom to use Earth Shock!','',26124),
(110009,'enUS','Use Chain Lightning!','',26124),
(110010,'enUS','Heal yourself with Healing Surge!','',26124),
(110011,'enUS','Use Fire Elemental!','',26124),
(110012,'enUS','Now would be a great time to use Earth Elemental!','',26124),
(110013,'enUS','You\'re facing multiple enemies, try using Earthquake Totem!','',26124),
(110014,'enUS','Use Bloodlust to temporarily increase your Haste, which speeds up your attacks and spell casts.','',26124),
(110015,'enUS','Use Thunderstorm to knock enemies away!','',26124),
(110016,'enUS','Download complete! Splendid work, positively splendid. Please join me at the control console.','',26124),
(110017,'enUS','Any lout with a hammer and tongs can bang steel. It takes a master craftsman to weave the very essence of the arcane into one\'s creations, to forge weapons of cunning as well as brute strength.','',26124),
(110018,'enUS','Though your kind has brought honor to these shores, some among you bring darkness as well! Even now, a plague born of a vile hybrid of the Legion and the Old Gods seeps into my sacred soil. Cleanse it!','',26124),
(110019,'enUS','Be warned! I will not tolerate such corruption in my lands.','',26124),
(110020,'enUS','Yes... yes, I see. Oh. No, no, no. Not good. Not good at all.','',26124),
(110021,'enUS','What is it? Where\'s Prustaga headed?','',26124),
(110022,'enUS','Thorim\'s throne at the Temple of Storms. I suggest you get moving. We don\'t have much time!','',26124),
(110023,'enUS','Roll, roll, roll!','',26124),
(110024,'enUS','Taking damage is part of battle, but you can tap the spiritual mists to heal yourself or an ally. Use Effuse to heal your wounds.','',26124),
(110025,'enUS','Use Effuse to replenish your health to full.','',26124),
(110026,'enUS','Heal yourself with Effuse!','',26124),
(110027,'enUS','Let us make our way to the platform above.','',26124),
(110028,'enUS','','I don\'t see anything unusual about this brazier. It looks to be in pretty good shape for something so ancient.',26124),
(110029,'enUS','Show me you fight with savagery and cunning!','',26124),
(110030,'enUS','Your allies spill the blood of their rivals upon the field of battle. Join them and prove your valor!','',26124),
(110031,'enUS','Well done, $p! You are now prepared to do battle as an unholy death knight.','',26124),
(110032,'enUS','Roll is not your only ability for mobility. Windwalker monks can also launch themselves through the air, flying at their targets.','',26124),
(110033,'enUS','Use Flying Serpent Kick to travel to the target dummy and damage it.','',26124),
(110034,'enUS','Use Flying Serpent Kick!','',26124),
(110035,'enUS','Sometimes you might get in over your head, facing more enemies than you can handle.','',26124),
(110036,'enUS','Paralyze the soldier who attacks you.','',26124),
(110037,'enUS','Fights aren\'t always fair... or are they?','',26124),
(110038,'enUS','Use Storm, Earth, and Fire to attack all three of these target dummies at once.','',26124),
(110039,'enUS','You\'re facing multiple enemies! Try using Storm, Earth, and Fire!','',26124),
(110040,'enUS','Your monk training has taught you the precision necessary to strike an enemy\'s pressure points. Touch of Death deals massive damage, but takes a short time to take effect.','',26124),
(110041,'enUS','Use Touch of Death on the target dummy.','',26124),
(110042,'enUS','Well fought! You have shown yourself to be worthy.','',26124),
(110043,'enUS','As a feral druid your main weapon is shapeshifting. In Cat Form, your claws and fangs rip and bleed your opponents.','',26124),
(110044,'enUS','Use Cat Form and assume the form of a cat.','',26124),
(110045,'enUS','You need to be in Cat Form to fight!','',26124),
(110046,'enUS','You are not in Cat Form!','',26124),
(110047,'enUS','As a cat you can move with uncanny stealth, allowing you to approach your enemies undetected. Prowl puts you in stealth mode.','',26124),
(110048,'enUS','Use Prowl to enter stealth.','',26124),
(110049,'enUS','Stealth lasts until you cancel it, attack, or take damage.','',26124),
(110050,'enUS','Your primary attack is Shred.','',26124),
(110051,'enUS','Use Shred on the target dummy while it\'s bleeding from Rake.','',26124),
(110052,'enUS','Use Shred to generate combo points!','',26124),
(110053,'enUS','Use Shred!','',26124),
(110054,'enUS','Our ascension is at hand. Have you brought us something worthy?','Our ascension is at hand. Have you brought us something worthy?',26124),
(110055,'enUS','Once you\'ve reached your prey in stealth, it\'s time to ambush them.','',26124),
(110056,'enUS','Use Rake on the target dummy.','',26124),
(110057,'enUS','Rake inflicts its damage over time, so you don\'t need to use it again until your target is no longer affected by it.','',26124),
(110058,'enUS','Use Rake!','',26124),
(110059,'enUS','Both your Shred and Rake abilities generate combo points which can fuel powerful finishing moves.','',26124),
(110060,'enUS','When you have 5 combo points, use Ferocious Bite on the target dummy.','',26124),
(110061,'enUS','You have 5 combo points! Use Ferocious Bite now!','',26124),
(110062,'enUS','Use Ferocious Bite!','',26124),
(110063,'enUS','Most of your attacks require energy to use. You might find yourself low on energy at times, rendering you unable to use any abilities.','',26124),
(110064,'enUS','Use Tiger\'s Fury to restore some energy and then attack the target dummy with Shred.','',26124),
(110065,'enUS','You\'re low on energy! Use Tiger\'s Fury!','',26124),
(110066,'enUS','Use Tiger\'s Fury!','',26124),
(110067,'enUS','Tougher enemies may require a diverse set of abilities to overcome.','',26124),
(110068,'enUS','Use Rip on the target dummy with five combo points.','',26124),
(110069,'enUS','You have 5 combo points! Use Rip!','',26124),
(110070,'enUS','Use Rip!','',26124),
(110071,'enUS','Ever needed to quickly get out of a sticky situation? You excel at doing this.','',26124),
(110072,'enUS','Practice using Dash to increase your movement speed.','',26124),
(110073,'enUS','You also have the ability to call on the powers of nature for a variety of other abilities, like healing!','',26124),
(110074,'enUS','Use Regrowth to restore yourself to full health.','',26124),
(110075,'enUS','Heal yourself with Healing Touch!','',26124),
(110076,'enUS','Using spells will usually pull you out of shapeshift forms. Don\'t forget to return to cat form for combat.','',26124),
(110077,'enUS','Use Cat Form.','',26124),
(110078,'enUS','Sometimes you need an enemy to stay put so you can close the distance to them... or make a hasty retreat.','',26124),
(110079,'enUS','Use Entangling Roots to root my soldier to the ground.','',26124),
(110080,'enUS','We are preparing to ascend. I hope Marlan finds your gift acceptable so you can join us.','We are preparing to ascend. I hope Marlan finds your gift acceptable so you can join us.',26124),
(110081,'enUS','Try using Entangling Roots to immobilize your target!','',26124),
(110082,'enUS','Try to root the target before it can reach you! Let\'s try again!','',26124),
(110083,'enUS','Cast Entangling Roots!','',26124),
(110084,'enUS','When in Cat Form you can rely on the instincts of an animal to help pull you through a tough fight.','',26124),
(110085,'enUS','Use Survival Instincts to reduce incoming damage.','',26124),
(110086,'enUS','Use Survival Instincts!','',26124),
(110087,'enUS','So the stories are true - you\'ve recovered Felo\'melorn!$b$bShattered during the third war, Prince Kael\'thas ordered its repair. Elven blades grow stronger with each reforging, but only in the hands of the finest craftsmen.$b$bI have never seen such a wonder. May I hold it?','',26124),
(110088,'enUS','Thrash isn\'t your only tool for fighting multiple enemies.','',26124),
(110089,'enUS','Use Swipe to damage several enemies at once.','',26124),
(110090,'enUS','You\'re fighting multiple enemies, try using Swipe!','',26124),
(110091,'enUS','Now use Swipe!','',26124),
(110092,'enUS','Using Thrash then Swipe is a great combination!','',26124),
(110093,'enUS','When fighting multiple enemies at once a feral druid can become a whirlwind of fangs and claws, damaging everything around them.','',26124),
(110094,'enUS','Use Thrash to damage several enemies at once.','',26124),
(110095,'enUS','Thrash continues to damage your foes for a short period, so you don\'t need to use it again until your targets stops being affected by it.','',26124),
(110096,'enUS','You may. But only for a moment.','You may. But only for a moment.',26124),
(110097,'enUS','Rake has expired on your target! Use it again!','',26124),
(110098,'enUS','Use Thrash!','',26124),
(110099,'enUS','Use Prowl to enter stealth!','',26124),
(110100,'enUS','','That Pearl of Arcane Wisdom you found is quite impressive. I brought an old spell book I took from a rather nasty ghoul in Deatholme. He didn\'t know what hit him. Ha!',26124),
(110101,'enUS','','Do you enjoy traveling, $n? As the Magisters\' Seeker of Wisdom, I am on the road quite a bit. I find it strange that most sin\'dorei dislike it so much. But then I am not like most sin\'dorei, as they never fail to remind me.',26124),
(110102,'enUS','As an unholy death knight you command the powers of disease and death.','',26124),
(110103,'enUS','Use Raise Dead to summon your minion.','',26124),
(110104,'enUS','The best way to start a fight is to infect your enemy with a host of diseases from a distance.','',26124),
(110105,'enUS','Use Outbreak on the target dummy.','',26124),
(110106,'enUS','Now that your enemy is reeling from a miasma of plagues, it\'s time to strike up close.','',26124),
(110107,'enUS','Use Festering Strike on the target dummy.','',26124),
(110108,'enUS','Oh, that looks like it hurts! After infecting your target with Festering Strike, you are ready to burst the lesions you\'ve caused using Scourge Strike!','',26124),
(110109,'enUS','Argent Crusaders, secure this area! We will press on!','',26124),
(110110,'enUS','Use Scourge Strike on the target dummy after it is infected with Festering Strike.','',26124),
(110111,'enUS','Try to only use Scourge Strike when your target is affected by Festering Wounds.','',26124),
(110112,'enUS','Your attacks build Runic Power that can be used to cast Death Coil, a spell that hurls a blast of unholy energy at your target and restores energy to your ghoul minion.','',26124),
(110113,'enUS','Use Death Coil on the target dummy.','',26124),
(110114,'enUS','Your attacks sometimes allow you to cast Death Coil without costing Runic Power. Take advantage of this when you can.','',26124),
(110115,'enUS','','Did you know that in the past many Magisters studied amongst the Kirin Tor in Dalaran? Perhaps it is time to set aside our grudge and fight the Burning Legion together.',26124),
(110116,'enUS','Some foes would prefer to keep you at arm\'s length.','',26124),
(110117,'enUS','Use Death Grip to pull my soldier to you.','',26124),
(110118,'enUS','Death Grip can be used from a good distance away. Try moving further away from the target and using it.','',26124),
(110119,'enUS','Being able to call upon the powers of death means you rarely need to be outnumbered.','',26124),
(110120,'enUS','Use Army of the Dead now to summon in your minions.','',26124),
(110121,'enUS','Show me you\'ve mastered the powers of darkness!','',26124),
(110122,'enUS','Your undead minion is a valuable asset in battle. Dark Transformation allows you to temporarily transform your ghoul into a hulking monstrosity with increased power and abilities. Try it out!','',26124),
(110123,'enUS','Use Dark Transformation to empower your ghoul.','',26124),
(110124,'enUS','Ah, Felo\'melorn. The Flamestrike! Such craftsmanship, such elegance...','',26124),
(110125,'enUS','As a death knight, you control the battlefield!','',26124),
(110126,'enUS','Use Death and Decay to dispatch the group of minions.','',26124),
(110127,'enUS','This is not some brutish cleaver for the hacking of flesh. It is the slender blade of a tactician. Strands of arcane energy have been woven into the steel with each fold. I can feel its heat radiating down my arms. Magnificent!','',26124),
(110128,'enUS','When taking excessive damage in battle, Death Strike can help even the odds.','',26124),
(110129,'enUS','Use Death Strike on the target to recover some of your health.','',26124),
(110130,'enUS','Thank you, $n. I have labored a hundred lifetimes and have not seen its like.','',26124),
(110131,'enUS','Your minion is dead. Cast Raise Dead to summon a new minion.','',26124),
(110132,'enUS','Outbreak has expired from your target, use it now!','',26124),
(110133,'enUS','Cast Outbreak!','',26124),
(110134,'enUS','Your target is not infested with Festering Wounds. Use Festering Strike now!','',26124),
(110135,'enUS','Use Festering Strike!','',26124),
(110136,'enUS','Use Scourge Strike!','',26124),
(110137,'enUS','Using Scourge Strike after Festering Strike is a potent combination!','',26124),
(110138,'enUS','Death Coil is free!  Cast it now!','',26124),
(110139,'enUS','Use Death Coil!','',26124),
(110140,'enUS','Cast Army of the Dead!','',26124),
(110141,'enUS','Now is a good time to cast Dark Transformation!','',26124),
(110142,'enUS','You\'re facing multiple enemies. Try using Death and Decay!','',26124),
(110143,'enUS','Use Death Strike!','',26124),
(110144,'enUS','As a frost mage you excel at controlling the battlefield by freezing enemies in place as ice and hail pummel them into submission.','',26124),
(110145,'enUS','Use Summon Water Elemental to summon your pet.','',26124),
(110146,'enUS','Your most fundamental and reliable attack is Frostbolt.','',26124),
(110147,'enUS','Use Frostbolt on the target dummy.','',26124),
(110148,'enUS','What are you still doin\' here? Get!','',26124),
(110149,'enUS','Now we\'ll take a look at Ice Lance. It\'s similar to Frostbolt, but can be cast instantly, albeit for less damage.','',26124),
(110150,'enUS','Use Ice Lance on the frozen target dummy.','',26124),
(110151,'enUS','There is one more way that Ice Lance can be used to maximize its power.','',26124),
(110152,'enUS','Use Frostbolt on the target dummy until it triggers Fingers of Frost, Then use Ice Lance.','',26124),
(110155,'enUS','Feet don\'t fail me now!','',26124),
(110156,'enUS','Use Frost Bolt on the target dummy until you trigger Fingers of Frost. While the effect is active, use Ice Lance.','',26124),
(110157,'enUS','Another potent spell you can wield is Frozen Orb. Cast this spell whenever it is available, as it can make your Ice Lance more powerful.','',26124),
(110158,'enUS','Use Frozen Orb on the target dummy.','',26124),
(110159,'enUS','The battlefield can be a dangerous place, so moving about is crucial to your survival.','',26124),
(110160,'enUS','Practice using Blink.','',26124),
(110161,'enUS','What if you could freeze foes in their tracks, preventing them from even reaching you?','',26124),
(110162,'enUS','Freeze my soldier using Frost Nova.','',26124),
(110163,'enUS','Remember that Ice Lance does extra damage to frozen targets, so using Frost Nova and Ice Lance together is a powerful tactic.','',26124),
(110164,'enUS','You are master of dealing damage to many enemies at once.','',26124),
(110165,'enUS','Use Blizzard to dispatch this group of enemies.','',26124),
(110166,'enUS','Show me you fight with the fury of the elements!','',26124),
(110167,'enUS','Well done, $p! You are now prepared to do battle as an enhancement shaman.','',26124),
(110168,'enUS','Despite your best efforts, you may not be able to prevent an enemy from reaching you.','',26124),
(110169,'enUS','Use Ice Barrier to reduce incoming damage.','',26124),
(110170,'enUS','Need to get out of a fight in a hurry? Invisibility is a great spell for getting out of a sticky situation.','',26124),
(110171,'enUS','Use Invisibility to escape combat.','',26124),
(110172,'enUS','Your Water Elemental has died. Cast Summon Water Elemental to call it back!','',26124),
(110173,'enUS','Use Frostbolt!','',26124),
(110174,'enUS','Fingers of Frost has triggered! Use Ice Lance now!','',26124),
(110175,'enUS','Use Ice Lance!','',26124),
(110176,'enUS','Your target is frozen! Use Ice Lance!','',26124),
(110177,'enUS','Frozen Orb is available! Cast it now!','',26124),
(110178,'enUS','Use Frozen Orb!','',26124),
(110179,'enUS','You\'re under attack! Use Frost Nova to immobilize your opponent!','',26124),
(110180,'enUS','You need to freeze your enemy in place before they reach you.','',26124),
(110181,'enUS','Use Frost Nova!','',26124),
(110182,'enUS','Cast Blizzard!','',26124),
(110183,'enUS','Cast Ice Barrier!','',26124),
(110184,'enUS','Use Invisibility!','',26124),
(110185,'enUS','','Life never gets any easier around here.',26124),
(110186,'enUS','As an enhancement shaman you channel the elemental forces directly into your weapons to make yourself a furious melee combatant, beating down your foes with the power of flame, earth, and storm.','',26124),
(110187,'enUS','Use Flametongue on the target dummy.','',26124),
(110188,'enUS','Now that your weapons are burning, you can focus on your primary attack.','',26124),
(110189,'enUS','Use Rockbiter on the target dummy.','',26124),
(110190,'enUS','Using Rockbiter generates Maelstrom, a resource that powers stronger attacks.','',26124),
(110191,'enUS','Use Lava Lash on the target dummy.','',26124),
(110192,'enUS','Your most powerful Maelstrom-fueled ability is Stormstrike.','',26124),
(110193,'enUS','Use Stormstrike on the target dummy after Stormbringer triggers.','',26124),
(110194,'enUS','Use Stormstrike now!','',26124),
(110195,'enUS','You share a kinship with animal spirits such as wolves.','',26124),
(110196,'enUS','Use Feral Spirit if you need to boost your damage in a fight!','',26124),
(110197,'enUS','If you are fighting multiple enemies, it is time to unleash the full fury of the storm!','',26124),
(110198,'enUS','Use Crash Lightning to dispatch this group of enemies.','',26124),
(110199,'enUS','If you find yourself taking too much punishment in a fight, Shamanistic Rage reduces incoming damage for a short period of time. Try it!','',26124),
(110200,'enUS','Use Shamanistic Rage to reduce incoming damage.','',26124),
(110201,'enUS','Your Flametongue buff has expired! Use Flametongue!','',26124),
(110202,'enUS','Use Flametongue!','',26124),
(110203,'enUS','An entry from someone named... Abercrombie. He asked me to read the following: \'I fooled the bearer of this note into announcing my latest, most dire creation!\' Weird guy, that one.','',26124),
(110204,'enUS','Use Rockbiter to generate Maelstrom!','',26124),
(110205,'enUS','Use Rockbiter!','',26124),
(110206,'enUS','I guess Stitches just... unraveled. Get it? Stitches? Unraveled? Man, I\'m on fire!','',26124),
(110207,'enUS','Lava Lash is available! Use it now!','',26124),
(110208,'enUS','Use Lava Lash!','',26124),
(110209,'enUS','Stormbringer has triggered! Use Stormstrike now!','',26124),
(110210,'enUS','Use Stormstrike!','',26124),
(110211,'enUS','Use Feral Spirit!','',26124),
(110212,'enUS','Use Crash Lightning!','',26124),
(110213,'enUS','As a balance druid the sun, moon, and stars are your allies, enabling you to unleash these primal powers upon your enemies.','',26124),
(110214,'enUS','Use Moonkin Form and assume the form of a wildkin.','',26124),
(110215,'enUS','You wield the very power of night and day against your foes. Moonfire and Sunfire represent that power.','',26124),
(110216,'enUS','Use Moonfire and Sunfire on the target dummy.','',26124),
(110217,'enUS','Both these attacks deal damage over time. Once cast, you don\'t need to cast them again until their effect on the target has expired.','',26124),
(110218,'enUS','Once your enemy is taking damage from your other attacks, it\'s time to unleash Solar Wrath.','',26124),
(110219,'enUS','Use Solar Wrath on the target dummy.','',26124),
(110220,'enUS','One of your most potent attacks, Starsurge unleashes a surge of stellar energy at your target.','',26124),
(110221,'enUS','I\'ll take care of this!','',26124),
(110222,'enUS','Use Solar Wrath on the target dummy until you have enough Astral Power to cast Starsurge.','',26124),
(110223,'enUS','Sometimes you need an enemy to stay put so you can close the distance to them... or make a hasty retreat.','',26124),
(110224,'enUS','Use Entangling Roots to root my soldier to the ground.','',26124),
(110225,'enUS','Show me that you can harness the power of the universe itself!','',26124),
(110226,'enUS','Well done, $p! You are now prepared to do battle as a feral druid.','',26124),
(110227,'enUS','Well done, $p! You are now prepared to do battle as a balance druid.','',26124),
(110228,'enUS','Need a boost of damage? Look to the stars!','',26124),
(110229,'enUS','Use Celestial Alignment to increase damage, then use Solar Wrath on the target dummy.','',26124),
(110230,'enUS','A balance druid is well equipped to face multiple opponents at once.','',26124),
(110231,'enUS','Use Lunar Strike to dispatch this group of enemies.','',26124),
(110232,'enUS','Use Moonkin form!','',26124),
(110233,'enUS','Moonfire has expired on your target! Cast Moonfire on your target!','',26124),
(110234,'enUS','Sunfire has expired on your target! Cast Sunfire on your target!','',26124),
(110235,'enUS','Cast Moonfire!','',26124),
(110236,'enUS','Cast Sunfire!','',26124),
(110237,'enUS','Cast Solar Wrath to generate Astral Power!','',26124),
(110238,'enUS','Cast Solar Wrath!','',26124),
(110239,'enUS','Starsurge is available! Cast it now!','',26124),
(110240,'enUS','Cast Starsurge!','',26124),
(110241,'enUS','Try using Entangling Roots to immobilize your target!','',26124),
(110242,'enUS','Try to root the target before it can reach you! Let\'s try again!','',26124),
(110243,'enUS','Cast Entangling Roots!','',26124),
(110244,'enUS','Cast Lunar Strike!','',26124),
(110245,'enUS','Nothing you cannot handle!','',26124),
(110246,'enUS','That is a most... unusual murloc. There\'s something familiar about him, but I can\'t quite place it. Could you take a closer look?','',26124),
(110247,'enUS','Why are you interested in the Empyrean Society?','Why are you interested in the Empyrean Society?',26124),
(110248,'enUS','It seems all creatures are susceptible to the Legion\'s corruption. No matter how... small.','',26124),
(110249,'enUS','My patrol... they\'re dead! All dead!','My patrol... they\'re dead! All dead!',26124),
(110250,'enUS','They came out of nowhere! Be careful!','They came out of nowhere! Be careful!',26124),
(110251,'enUS','My thanks. Allow me to repay you with my service.','My thanks. Allow me to repay you with my service.',26124),
(110252,'enUS','','I am a bit of a misfit, to be honest. Most sin\'dorei are content to live out their entire lives within the confines of Silvermoon City. However I found it stifling after so many years living on Draenor. I\'ve never been one to hold my opinions back...\n\nWhen Grand Magister Rommath asked me to leave and become the Magisters\' Seeker of Wisdom, it was a relief for us both. I intend to discover if the Empyrean Society possesses anything of use.',26124),
(110253,'enUS','My blade is yours, $n.','My blade is yours, $n.',26124),
(110254,'enUS','What do you know about their activities?','What do you know about their activities?',26124),
(110255,'enUS','Don\'t be fooled! That creature is not one of our brood. Tread carefully, hero.','',26124),
(110256,'enUS','Tend to your companions\' wounds. You did well.','',26124),
(110257,'enUS','','They are a secretive bunch and tend to speak in riddles, so not very much. It is known that they search the world for rare forms of magic to study, and this enclave may have found something quite powerful. \n\nI intend to discover whatever it is they are hiding.',26124),
(110258,'enUS','This chasm oozes darkness... Light protect us! That thing has what we need. Prepare yourselves, friends.','',26124),
(110259,'enUS','','An infestation of leyworms has broken out in the Leyhollow caves! If you plug their tunnels with heavy stones, it should help contain them.',26124),
(110260,'enUS','','What\'s that?! One of the bigger worms is burrowing through! Stand ready!',26124),
(110261,'enUS','','I believe that will stop their influx for now. Thank you, champion.',26124),
(110262,'enUS','This area is very unstable now thanks to the previous visitors. We need to kill that thing to get what we need, but I\'m not sure what it will do to our surroundings.\n\nIt would be best to kill it quick and get out of here. Say the word, $n.','',26124),
(110263,'enUS','|TInterface\\Icons\\inv_pet_broom.blp:20|t %s calls Scrubbers to |cFFF00000|Hspell:207513|h[Tidy Up]|h|r.','',26124),
(110264,'enUS','What\'s that sound?','',26124),
(110265,'enUS','Nicely done, but those demons won\'t give up so easily. Stand ready!','',26124),
(110266,'enUS','What is that I hear?','',26124),
(110267,'enUS','Disturbances are punishable by death! Do not let this happen again!','',26124),
(110268,'enUS','Next time I will see you withered for wasting my time!','',26124),
(110273,'enUS','As a master of the elements, you are able to coalesce primal elemental forces into physical form to aid you in battle.','',26124),
(110274,'enUS','The Gaze of the Legion has spotted you!','',26124),
(110275,'enUS','The Aerial Command Unit can take you directly to the temple. Hop in!','',26124),
(110276,'enUS','Welcome back to Ulduar! The Speaker awaits you in the Celestial Planetarium. Please, follow me!','',26124),
(110277,'enUS','With the corruption of the Nightmare spreading, I fear for the wildlife of Val\'Sharah. I feel some would be safer in your care.','',26124),
(110278,'enUS','\"The Speaker\"? That\'s me brother Magni, ye infernal contraption!','',26124),
(110279,'enUS','While trapping animals can be traumatic, it\'s a far better fate than what awaited them. I wish you and your new companions well.','',26124),
(110280,'enUS','DEPRECATED','',26124),
(110282,'enUS','DEPRECATED','',26124),
(110283,'enUS','Lost Owlkitten slowly raises its head and looks around.','',26124),
(110284,'enUS','Lost Owlkitten spots you and scampers away in fear!','',26124),
(110285,'enUS','$n! Is it true? Do you wield Felo\'melorn? Come, speak with me!','',26124),
(110286,'enUS','I will meet you on the other side.','',26124),
(110287,'enUS','$n - is it true that you carry Kael\'thas\'s former blade? Come closer!','',26124),
(110288,'enUS','Felo\'melorn! A blade fit for royalty. In the hands of Anasterian Sunstrider, a thousand Amani trolls fell before its fury.','',26124),
(110289,'enUS','Ah! It is hot to the touch! How do you even...? No matter. I see this blade is in good hands. Thank you, $n, for allowing me to touch a piece of my peoples\' history.','',26124),
(110290,'enUS','I fear if we dally much longer, those giants will pound Nar\'thalas into the sea.','',26124),
(110291,'enUS','Destroy the monster! For the Light!','',26124),
(110292,'enUS','The stories are true. A hero once more wields Felo\'melorn! I thought the blade lost in the wastes of Icecrown. As relics go, it predates the War of the Ancients. May I... may I see it?','',26124),
(110293,'enUS','','Watch yourself, Andoren. Belloc would be displeased to see you fraternizing with the Alliance...',26124),
(110294,'enUS','Pity you aren\'t joining Thorim under more pleasant circumstances. He\'s a lover of animals as well. Always going on and on about those wolves of his.','',26124),
(110295,'enUS','Really now? \'Twill be nice to be around one of our own... even if he\'s a bit tall for my likin\'.','',26124),
(110296,'enUS','Indeed, Bronzebeard. Now hold on! I\'m taking you in.','',26124),
(110297,'enUS','Bronzebeard! Back again, I see! Hati has missed you, as has Skoll. Skoll? Bah! Where has that worg run off to?','',26124),
(110298,'enUS','Ah, and you are joined by one of the mortals who freed us from the grip of the Old God! We must hold a feast to celebrate!','',26124),
(110299,'enUS','It\'ll have to wait, Thorim. There\'s a crazed vrykul on her way here to steal the power of Titanstrike!','',26124),
(110300,'enUS','Then we shall slay the enemy together! Come, vrykul! Face the fury of the storms!','',26124),
(110306,'enUS','The last of my brothers and sisters. I am all that remains of the Tyr\'s Guard.','',26124),
(110307,'enUS','I have the Spark. The battle this place has seen has warped reality too much. We must finish this now.','',26124),
(110308,'enUS','NO! They are... gone!','',26124),
(110310,'enUS','We have wounded! Aid them while I cover you!','',26124),
(110311,'enUS','Excellent, and with no time to waste. Let\'s move!','',26124),
(110312,'enUS','An intruder! I must warn the others!','',26124),
(110313,'enUS','There you are, mortal! I sense you are near. Move quickly and head down the path!','',26124),
(110314,'enUS','The master is gone and his minions gorge upon my power. Come, repay this degradation! Introduce them to unfathomable levels of pain!','',26124),
(110315,'enUS','Foolish warlock! Did you really think I would remain unaware of your infantile plot to steal my treasure? You underestimate the Nathrezim!','',26124),
(110316,'enUS','As for you, treacherous skull, I\'ll deal with you later.','',26124),
(110317,'enUS','Come to me, servant of hellfire! Rid me of this uninvited guest.','',26124),
(110318,'enUS','Good! Now, before the master returns, slay my captors and free me!','',26124),
(110319,'enUS','Theodore and I can take \'em! For the wilds!','',26124),
(110320,'enUS','You seem quite capable, mage. With their magics gone, I feel my strength returning.','',26124),
(110321,'enUS','Keep yer eyes peeled! Prustaga\'s around here somewhere.','',26124),
(110322,'enUS','Is that the best these whelps can manage? I could do this all day!','',26124),
(110323,'enUS','The Nexus Vault is weakening! That arcane energy can only mean Aluneth is no longer fully contained.','',26124),
(110324,'enUS','','Titanstrike\'s power will be mine!',26124),
(110325,'enUS','Prust is headed for the throne! We\'ve got to stop her!','',26124),
(110326,'enUS','You have great courage to contact me, $r.$b$bOr stupidity...','',26124),
(110327,'enUS','','You shall witness my glorious ascension!',26124),
(110328,'enUS','','Yes... I feel the power of the makers coursing through my veins!',26124),
(110329,'enUS','Now what?! One day, I will free myself of your control and... wait... you\'re not my master!','',26124),
(110330,'enUS','I have need of your powers.','I have need of your powers.',26124),
(110331,'enUS','Hah! Do you think you\'re the first creature from a doomed world to beg for my aid?$b$bNo, you will burn before the Legion\'s power and I\'ll continue to suffer in servitude to these mongrels for the rest of eternity.$b$bSave yourself the wasted effort and go jump into a fire!','',26124),
(110332,'enUS','So, the famed Thal\'kiel chose to submit to the demons in the end.','So, the famed Thal\'kiel chose to submit to the demons in the end.',26124),
(110333,'enUS','How dare you! If my powers were not constantly being drained I could easily bring them under my control.','',26124),
(110334,'enUS','Then allow me to free you. Together, the Burning Legion will bow to us! We will be the masters!','Then allow me to free you. Together, the Burning Legion will bow to us! We will be the masters!',26124),
(110335,'enUS','Hmph... fine then. Come to Felsoul Hold if you truly believe you can free me. But if you\'re not up for the challenge, you\'ll be joining me in eternal torment!','',26124),
(110336,'enUS','The ground is blanketed by unstable energy. You might not want to step on that...','',26124),
(110337,'enUS','Calydus knows where that is! Calydus can help!','',26124),
(110338,'enUS','','You cannot stop me, fools! I just need... more... power!',26124),
(110339,'enUS','It is time we finish this. Hati, kill!','',26124),
(110340,'enUS','It\'s too much for her! Watch out! She\'s gonna blow!','',26124),
(110341,'enUS','Fools! You may have destroyed the Surge Needles, but you are too late to stop us! The power of Aluneth will rip open the breach!','',26124),
(110344,'enUS','Stabilize the patient.','Stabilize the patient.',26124),
(110346,'enUS','|TInterface\\Icons\\Ability_Xavius_NightmareBlades.blp:20|tXavius\' |cFFFF0000|Hspell:206656|h[Nightmare Blades]|h|r have targetted you.','',26124),
(110347,'enUS','Lost Feathermane Kitten spots you and scampers away in fear!','',26124),
(110349,'enUS','Let us focus on the task at hand.','',26124),
(110351,'enUS','A dark presence emerges from the void... something big! We need to move now!','',26124),
(110352,'enUS','Life... to consume...','',26124),
(110353,'enUS','You have been targeted by Lurking Eruption!','',26124),
(110354,'enUS','You\'ve done it! The sisters are yours to control!','',26124),
(110355,'enUS','Sacrolash and Alythess will prove to be powerful tools for our order.','',26124),
(110356,'enUS','Let\'s meet back at the council\'s circle. There is much to discuss.','',26124),
(110357,'enUS','Everything is in place for me to complete the ritual! All of you, defend the tunnel!','',26124),
(110358,'enUS','Why... flee? The Void... inevitable...','',26124),
(110360,'enUS','That thing is too powerful! Focus on staying alive and keep it at bay!','',26124),
(110361,'enUS','Just a few more moments! Stay strong!','',26124),
(110362,'enUS','It is done. Quickly, $p, take up the hammer! In so doing, you will ensure Tyr\'s remains are protected for all time!','',26124),
(110365,'enUS','An amateur merchant embraces excuses. A master embraces solutions.','',26124),
(110366,'enUS','Apologies, master. I am still working on the clasp for the rushed commission...','',26124),
(110367,'enUS','','You will not stand in my way!',26124),
(110368,'enUS','You are not worthy to wield the fury of the storms, vrykul!','',26124),
(110369,'enUS','','Your kind has long forced my people into servitude. No longer! Now we forge our own destiny!',26124),
(110370,'enUS','See reason, Prust! We\'re not yer enemy!','',26124),
(110371,'enUS','','You were a means to an end. Nothing more!',26124),
(110372,'enUS','','I will not be denied! I shall become god-queen!',26124),
(110374,'enUS','','Behold my power!',26124),
(110375,'enUS','There\'s no need to recast Shadow Word: Pain when the previous one still has lots of time left on it.','',26124),
(110376,'enUS','You\'re at maximum Holy Power already! Use Templar\'s Verdict!','',26124),
(110377,'enUS','Recast Agony just before it expires to preserve its amplified damage!','',26124),
(110378,'enUS','You have maximum Soul Shards. Cast Unstable Affliction!','',26124),
(110379,'enUS','You have maximum Chi! Use Blackout Kick!','',26124),
(110380,'enUS','Shift back into Cat Form!','',26124),
(110381,'enUS','Virulent Plague has expired from your target. Use Outbreak now!','',26124),
(110382,'enUS','Your target has maximum Festering Wounds. Use Scourge Strike!','',26124),
(110383,'enUS','Wait until you have Fingers of Frost, or your target is frozen, to use Ice Lance.','',26124),
(110384,'enUS','You have maximum Maelstrom. Use Lava Lash!','',26124),
(110385,'enUS','You\'re at maximum Astral Power. Cast Starsurge!','',26124),
(110387,'enUS','We have the hammer! Everyone, run! The tomb is collapsing!','',26124),
(110388,'enUS','Your escape... means nothing. Will find you again...','',26124),
(110389,'enUS','Well, that was uncomfortable. You came just in time!','',26124),
(110395,'enUS','$n! There\'s a rumor goin\' round that you\'ve got your hands on Felo\'melorn. Is it true?','',26124),
(110396,'enUS','Felo\'melorn! Last I heard, the Lich King had stowed this beauty in Icecrown. How did you ever recover it?','',26124),
(110397,'enUS','Most of the relics I dig up are inert, but this blade thrums with magical energy. Ohh, it makes me hair stand on end. I hope you know how to use this thing.','',26124),
(110398,'enUS','Thank you, $n. You carry a piece of living history. Treasure it always!','',26124),
(110399,'enUS','','Are you here to help with our little \"problem\"?',26124),
(110400,'enUS','','Maldur you ought not to be talkin\' with the Horde. Not after what happened at the Broken Shore.',26124),
(110401,'enUS','We tried to mount an expedition into Zarkhenar, but there\'s all manner of wrong happening in those ruins.','',26124),
(110402,'enUS','I\'ve dug up some relics in my day but nothing like that sword you\'ve got there. When that blade was forged, there was no Alliance, no Horde - we dwarves were probably still living in caves. I know it\'s a lot to ask, but ... can I hold it?','',26124),
(110403,'enUS','Night falls on the collaborators.','Night falls on the collaborators.',26124),
(110404,'enUS','Problem? What problem?','Problem? What problem?',26124),
(110405,'enUS','The Nightborne Leodrath seems to have received reinforcements from Suramar. They have reason to believe that the renegade Nightfallen have come to Azsuna to escape their grasp.','',26124),
(110406,'enUS','Though they were once my kin, what they have become is an evil that I cannot abide in my lands. You know what you must do.','',26124),
(110407,'enUS','A pity that Leodrath escaped, but you\'ve delivered a blow to the Nightborne that they will not soon forget. The denizens of Azsuna thank you.','',26124),
(110408,'enUS','','Very well. I will prepare a spell that will weaken Thurox significantly, but I\'ll need your help to bring him down. Are you ready?',26124),
(110409,'enUS','','Oh, just the shortage of wine in this part of the city! Surely another batch is due soon.',26124),
(110410,'enUS','I am ready.','I am ready.',26124),
(110414,'enUS','Begone, thief! You have already taken my greatest treasure, what more do you want?','',26124),
(110415,'enUS','You again. Get out of here before I call the guards!','',26124),
(110416,'enUS','It was so beautiful... the articulated joints... the martial art grip...','',26124),
(110418,'enUS','<The adventurer has broken their arm. If you knew how to set bones, you could treat him.>','<The adventurer has broken their arm. If you knew how to set bones, you could treat her>',26124),
(110419,'enUS','Set the patient\'s bone.','Set the patient\'s bone.',26124),
(110420,'enUS','','Well done!',26124),
(110421,'enUS','','Very good.',26124),
(110422,'enUS','','Perfect!',26124),
(110423,'enUS','','Great!',26124),
(110424,'enUS','','Good work!',26124),
(110425,'enUS','','Excellent work!',26124),
(110426,'enUS','','Excellent!',26124),
(110427,'enUS','','Practice using your attacks on this target dummy.',26124),
(110428,'enUS','','Now that you have all your primary attack abilities, we will see how they work together!',26124),
(110429,'enUS','','When you feel ready, explore your spellbook and the talent tree for additional abilities you can learn.',26124),
(110430,'enUS','','Nicely done, but those demons won\'t give up so easily. Stand ready!',26124),
(110431,'enUS','','You learned well! Next we will see... Hold on, is that...? To arms! The Legion is attacking!',26124),
(110432,'enUS','','Good work! Now demonstrate your skill against two foes at the same time.',26124),
(110433,'enUS','','Target practice is over, $p. It\'s time to prove your mettle. Combine all the lessons you\'ve learned and use them to defeat my men in combat.',26124),
(110434,'enUS','','An infernal! Use all your training to defeat it!',26124),
(110690,'enUS','Yes, sign me up for the rumble!','Yes, sign me up for the rumble!',26124),
(110719,'enUS','Use Vanish to evade this brute.','',26124),
(110720,'enUS','There\'s just one last thing you need to learn. Sometimes a strategic retreat is necessary so you can live to fight another day. Vanish allows you to disengage from combat and make a quick getaway.','',26124),
(110721,'enUS','Shadowstrike to a target, generate 5 combo points with Backstab, and finish them with Eviscerate. That should leave you in stealth, ready to Shadowstrike to your next target.','',26124),
(110722,'enUS','You\'re learning how to paint with a dagger. Now it\'s time to perfect your art.','',26124),
(110723,'enUS','You\'re in trouble! Use Vanish!','',26124),
(110724,'enUS','Use Backstab to generate combo points.','',26124),
(110725,'enUS','Starting combat from stealth is more effective.','',26124),
(110726,'enUS','You\'re facing multiple enemies, try using Shuriken Storm!','',26124),
(110727,'enUS','Use Shadowstrike!','',26124),
(110728,'enUS','Use Nightblade!','',26124),
(110729,'enUS','You have 5 combo points. Use Nightblade!','',26124),
(110730,'enUS','Wait until you have 5 combo points to use Nightblade!','',26124),
(110731,'enUS','Use Eviscerate!','',26124),
(110732,'enUS','You have 5 Combo Points. Use Eviscerate!','',26124),
(110733,'enUS','Wait until you have 5 combo points to use Eviscerate!','',26124),
(110734,'enUS','Use Crimson Vial to restore health!','',26124),
(110735,'enUS','Use Backstab!','',26124),
(110736,'enUS','Use Backstab to generate combo points.','',26124),
(110737,'enUS','Well done, $p! You are now prepared to do battle as a subtlety rogue.','',26124),
(110738,'enUS','Show me you\'ve got the stuff.','',26124),
(110749,'enUS','Use Nightblade with 5 combo points on the target dummy.','',26124),
(110750,'enUS','Tougher enemies may require a broader range of abilities to overcome. As an alternative to Eviscerate, Nightblade can be used to deal damage over time to your target, and is a good ability to spend combo points on early in a fight. Like Eviscerate, Nightblade is a finishing move, and is best used when you have 5 combo points.','',26124),
(110751,'enUS','Use Eviscerate with 5 combo points.','',26124),
(110752,'enUS','Now that you\'ve built up 5 combo points, it\'s time to Eviscerate. Whenever you Eviscerate with 5 combo points, you will do massive damage and immediately enter stealth.','',26124),
(110753,'enUS','Use Shadowstrike to attack the target dummy.','',26124),
(110755,'enUS','Use Stealth to fade from view.','',26124),
(110756,'enUS','Rogues favor trickery and cunning. And what\'s trickier than attacking before your target sees you coming? Stealth makes you invisible to most enemies. When in Stealth, you open up specialized tactics that can devastate foes.','',26124),
(110906,'enUS','\"I\'m hoping for some epic pants drops tonight.\"$b$bA wave of confusion washed over the princess\'s face as the full force of this statement hit her square on. A murmur arose among her court. Lord Gravesbane heard weapons being drawn.$b$bThe princess\'s eyebrows furrowed, and she said...$b$b|cFF600000<How might the draenei princess have responded?>|r','',26124),
(110907,'enUS','It is done. I will dispose of the ashes and find Mayruna back at camp. Thank you, friend.','',26124),
(110908,'enUS','Let me know if you want to rumble, $r.','Let me know if you want to rumble, $r.',26124),
(110909,'enUS','Is that... Felo\'melorn? The Flamestrike?','Is that... Felo\'melorn? The Flamestrike?',26124),
(110910,'enUS','It is. $n recovered it from Northrend. The very spellblade that Dath\'Remar used against the Legion during the War of the Ancients.','It is. $n recovered it from Northrend. The very spellblade that Dath\'Remar used against the Legion during the War of the Ancients.',26124),
(110911,'enUS','Let us hope that the mages do not succumb to the Legion\'s influence. We need their help.','Let us hope that the mages do not succumb to the Legion\'s influence. We need their help.',26124),
(110912,'enUS','Deception is punishable by death!','',26124),
(110913,'enUS','Fire the guns! Cover the path in hellfire! Don\'t let that warlock through!','',26124),
(110914,'enUS','Yowlon hisses angrily at the sight of the Ettin Leather.','',26124),
(110915,'enUS','I\'ll be taking that, friend. Don\'t you worry.','',26124),
(110916,'enUS','Yowlon kneads his claws into the stone, looking regally in the other direction.','',26124),
(110917,'enUS','Thanks!','Thanks!',26124),
(110918,'enUS','Your kittens are safe, Yowlon. Will you grant us your blessing so we may share this land with you?','',26124),
(110919,'enUS','Yowlon leans downward to pluck a feather from his ankle tufts.','',26124),
(110920,'enUS','Thank you, your highness.','',26124),
(110921,'enUS','Yowlon deposits the feather into Mardranel\'s palm.','',26124),
(110922,'enUS','Without a Windlord, Skywall will forever remain in turmoil.','',26124),
(110923,'enUS','There has been no peace here since the death of Al\'Akir, shaman.','',26124),
(110924,'enUS','\"I am immune to your charms, outsider. Flattery will get you nowhere.\"$b$bLord Gravesbane held the princess\'s icy glare for one, two, three agonizing seconds, before replying...$b$b|cFF600000<What might Lord Gravesbane say now?>|r','',26124),
(110925,'enUS','\"That\'s a big sword you have there. Are you sure you know how to wield it?\"$b$bLord Gravesbane shifted his eyes towards his trousers, then back up at the regal draenei. Matching her hidden half-smile, he replied...$b$b|cFF600000<What might Lord Gravesbane say now?>|r','',26124),
(110926,'enUS','\"Is that a gnome in your legplates, or is that two gnomes in your legplates?\"$b$bLord Gravesbane stumbled backwards, clearly caught off-guard by the directness of the princess\'s question. He quickly re-gathered his wits and replied...$b$b|cFF600000<What might Lord Gravesbane say now?>|r','',26124),
(110927,'enUS','I see you carry Felo\'melorn, mage. My father spoke of that blade. He witnessed its fire during the War of the Ancients, long before the exodus of the quel\'dorei.','',26124),
(110930,'enUS','\"I\'ll bet you say that to every princess you meet.\"$b$bLord Gravesbane could see her for what she really was now: yes, she was the ruler of an unbeatable warrior nation... but she was also a girl, still trembling under the terrible weight of a crown. He replied...$b$b|cFF600000<What might Lord Gravesbane say now?>|r','',26124),
(110931,'enUS','\"Simply \'cute\'? You\'ll have to do better than that, Lord Gravesbane.\"$b$bLord Gravesbane frowned. \"Perhaps I\'m simply having an off day\", he thought, clearly disappointed with his game.$b$b|cFF600000<What might Lord Gravesbane say to recover?>|r','',26124),
(110933,'enUS','\"Well, I think you\'re terribly unclever!\"$b$bThe azure-skinned princess put on quite a show of being offended. So much, in fact, that it was clear to Lord Gravesbane that she was bluffing. He saw his chance.$b$b|cFF600000<What might Lord Gravesbane say now?>|r','',26124),
(110934,'enUS','\"Yes, I say it to nearly every woman I meet. I define my self-worth solely by the quantity of my romantic partners.\"','\"Yes, I say it to nearly every woman I meet. I define my self-worth solely by the quantity of my romantic partners.\"',26124),
(110935,'enUS','\"No, your majesty. Only to those princesses with eyes like sapphires in a stormy sea.\"','\"No, your majesty. Only to the ones with eyes like sapphires.\"',26124),
(110936,'enUS','\"Like, REALLY cute.\"','\"Like, REALLY cute.\"',26124),
(110937,'enUS','\"Pants? Here in my court, we simply wear robes and shoulderpads.\"','\"Pants? Here in my court, we simply wear robes and shoulderpads.\"',26124),
(110938,'enUS','\"Why would you say such a stupid thing to me?\"','\"Why would you say such a stupid thing to me?\"',26124),
(110939,'enUS','$n, I see you have inherited Felo\'melorn. Let us hope it serves you better than it did Prince Kael\'thas.','$n, I see you have inherited Felo\'melorn. Let us hope it serves you better than it did Prince Kael\'thas.',26124),
(110940,'enUS','\"You insolent buffoon! I should have your head for this!\"','\"You insolent buffoon! I should have your head for this!\"',26124),
(110941,'enUS','\"Pants? Here in my court, we simply wear robes and shoulderpads.\"$b$bLord Gravesbane surveyed the throne room chamber, and indeed, every single member of the princess\'s court was donned in long, flowing robes, and decorated with large crystalline shoulderpads. Not a single pant was in sight. He replied...$b$b|cFF600000<What might Lord Gravesbane say now?>|r','',26124),
(110942,'enUS','Begone, Mortals! Your kind has no place here!','',26124),
(110943,'enUS','\"Why would you say such a stupid thing to me?\"$b$bLord Gravesbane had been called many things before: foul, lecherous, repugnant, perverted, and occasionally even troggish, but never \"stupid\". This was new. He replied...$b$b|cFF600000<What might Lord Gravesbane say or do now?>|r','',26124),
(110944,'enUS','You will... pay for this... shaman! You...','',26124),
(110945,'enUS','\"You insolent buffoon! I should have your head for this!\"$b$bA score of angry guards unsheathed as many crystalline swords. The princess was angry. One word from her, and Lord Gravesbane would be sliced to ribbons. He would have to choose his next words very carefully.$b$b|cFF600000<What might Lord Gravesbane say to get out of this one?>|r','',26124),
(110946,'enUS','\"I would settle for a robe drop, I suppose... but your majesty should definitely keep the shoulderpads ON.\"','\"I would settle for a robe drop, I suppose... but your majesty should definitely keep the shoulderpads ON.\"',26124),
(110947,'enUS','\"Umm... duhhhh... Lord Gravesbane?\"','\"Umm... duhhhh... Lord Gravesbane?\"',26124),
(110948,'enUS','\"But your majesty... why take my head, when you already have my heart?\"','\"But your majesty... why take my head, when you already have my heart?\"',26124),
(110949,'enUS','\"Yikes! Don\'t kill me!\"','\"Yikes! Don\'t kill me!\"',26124),
(110950,'enUS','You seek the Idol of the Wild? I will tell you nothing, interloper!','',26124),
(110951,'enUS','His immaculate choice of words had won the princess over. Her hands flew to her chest, as if to stop a beating heart from escaping.$b$b\"Oh, Lord Gravesbane!\" she exclaimed.','',26124),
(110952,'enUS','|cFF600000<This story doesn\'t seem to be working out so well. It\'s not very steamy, and it\'s definitely not romantic.>|r','',26124),
(110953,'enUS','Even your sacred shrines are no longer safe from us, druid!','',26124),
(110954,'enUS','I know nothing of this idol, foolish druid. I do know that I\'ll have your head!','',26124),
(110955,'enUS','My liege! A strange mage approaches, and $ghe:she; bears the flaming blade of Dath\'Remar Sunstrider.','$n, I see you have inherited Felo\'melorn. Let us hope it serves you better than it did Prince Kael\'thas.',26124),
(110959,'enUS','Hati! That poor wolf took the brunt of it. Is he...?','',26124),
(110960,'enUS','He is alive, but only barely. It appears this noble companion absorbed Titanstrike\'s energy, protecting us from the explosion.','',26124),
(110961,'enUS','Erase everything and try again','Erase everything and try again',26124),
(110962,'enUS','Even though Hati is a creature of lightning magic, his body can\'t contain such intense power. My science cannot help him. I fear the Thunderspark\'s power is soon to be lost.','',26124),
(110963,'enUS','','Playtime\'s over, mortal!',26124),
(110964,'enUS','','$n, is that Felo\'melorn? THE Felo\'melorn, undying flame of the Sunstriders? The last time I saw that blade, it was in the hands of Prince Kael\'thas, before the third war.',26124),
(110965,'enUS','I know your heart aches at Hati\'s loss, $p, just as mine does. You have a kinship with the spirits of wild creatures greater than any I have seen before.','',26124),
(110966,'enUS','What your science cannot achieve, this master of beasts can do by instinct alone.','',26124),
(110967,'enUS','We spit on your sacred relics, druid. Now, face me!','',26124),
(110968,'enUS','The Idol is ours, $r. I\'ll never give up its location!','',26124),
(110969,'enUS','Kalazzius does not fear you, druid. Face him if you want your precious idol.','',26124),
(110970,'enUS','Wait... that\'s it, $p. If you bind Hati\'s spirit to your own, you can channel the power back into Titanstrike! You\'ll save Hati and restore the gun!','',26124),
(110971,'enUS','','Actually, sister, playtime has only begun!',26124),
(110975,'enUS','Apologies for the hasty retreat! The tomb\'s collapse was triggered by the hammer\'s removal.','',26124),
(110976,'enUS','Though his halls are no more, Tyr is now protected by several tons of stone and water. The prison is buried as well.','',26124),
(110977,'enUS','I can think of no one better to hold the Silver Hand, wield it well. Return to Tyrosus and tell him of our success. We will meet again.','',26124),
(110980,'enUS','','Kalazzius the Guileful... I have heard the name. He lurks in a cave east of the vale! We\'ll meet you there!',26124),
(110986,'enUS','Your persistence will be the death of you! Minions, attack!','',26124),
(110987,'enUS','It has been ages since I have seen the Tidestone whole, but there it stands.','',26124),
(110988,'enUS','I and my people owe you a debt of gratitude that we can never repay.','',26124),
(110989,'enUS','Please return to Azsuna as soon as you can. There is much yet left to do, $n.','',26124),
(110990,'enUS','Do you hear me, mortal? Mephistroth imprisoned me at the far side of the valley. Hurry! I sense he is preparing for something... significant.','',26124),
(110991,'enUS','Enjoy your victory while you can, warlock. This isn\'t over between us. It has only begun!','',26124),
(110992,'enUS','I am impressed, $n. Never have I seen a mage capable of controlling Aluneth.','',26124),
(110993,'enUS','No more escapes on my watch!','',26124),
(110994,'enUS','You\'ll beg to be put back in a cage when I\'m done with you!','',26124),
(110995,'enUS','The Drekirjar continue to enslave and torment my kin. Show them the allies of the Thorignir do not fear their nets and harpoons!','',26124),
(110996,'enUS','These fools still cling to the promises of their false god-king. It is good that you have wounded them so.','',26124),
(110997,'enUS','I\'ve heard that this Blade dates back to antiquity, even before the titans! An excellent choice, unless you are reconsidering.','',26124),
(110998,'enUS','This staff has great power that can be used for good, if you have the will to control it. It could also immolate you. Are you sure?','',26124),
(110999,'enUS','By Odyn\'s beard! You did it!','',26124),
(111000,'enUS','The Beacon is strongly linked to the naaru, having their aid could be exactly what we need to turn the tide! Are you sure?','',26124),
(111001,'enUS','From this day forth, I charge you to wield Titanstrike against the enemies of creation who would destroy this world.','',26124),
(111002,'enUS','Hati\'s noble spirit is forevermore bound to the weapon. He will be a loyal companion to you in the dark times ahead.','',26124),
(111003,'enUS','','There\'s a fel rune locking that door! The Empyrean Society should not be using such magic!',26124),
(111004,'enUS','I\'ve seen no finer hunter in all my days roaming the wilds. Yer faith is well-placed, Thorim!','',26124),
(111005,'enUS','Let\'s get back to Dalaran. I\'ll call Huey. No matter how far I go, he manages to find me. Oh, Huey!','',26124),
(111006,'enUS','','Lovely view up here. Hmm, now that book warrants a closer look.',26124),
(111007,'enUS','','Archmage Vargoth will hear of this intrusion!',26124),
(111010,'enUS','<The patient has been severely burned from felfire. If you know how to treat felburn wounds, you\'ll know how to heal the patient.>','<The patient has been severely burned from felfire. If you know how to treat felburn wounds, you\'ll know how to heal the patient.>',26124),
(111011,'enUS','Treat the patient\'s burns.','Treat the patient\'s burns.',26124),
(111012,'enUS','|TInterface\\Icons\\Spell_Fire_FelPyroblast:20|t %s begins to cast |cFFFF0000|Hspell:206219|h[Liquid Hellfire]|h|r.','',26124),
(111013,'enUS','Thanks!','Thanks!',26124),
(111014,'enUS','Help!','Help!',26124),
(111015,'enUS','It\'s getting really hot!','It\'s getting really hot!',26124),
(111016,'enUS','Someone save me!','Someone save me!',26124),
(111017,'enUS','','Oh no! Ravandwyr!',26124),
(111018,'enUS','What is this...?','',26124),
(111019,'enUS','Seeing as I am the prince after whom the ring was named... yes, I suppose I do. It was my ring, once, when such material possessions were of value to me.$b$bIt has long since been stored away, somewhere within the palace. You\'re welcome to ask around for it.','',26124),
(111020,'enUS','','Yes, I know the ring. I even saw it, as recently as yesterday.$b$bIt\'s not good news, unfortunately. It was among the many trinkets that were stolen away by those horrible murlocs. I was able to dispatch a few of them on their way out, but they made off with plenty of treasure... including that ring.',26124),
(111021,'enUS','<hic>... Ring of what now?','',26124),
(111022,'enUS','Do you know anything about the Band of Farondis?','Do you know anything about the Band of Farondis?',26124),
(111023,'enUS','Here! I\'m over here!','Here! I\'m over here!',26124),
(111024,'enUS','I could really use some help right about now!','I could really use some help right about now!',26124),
(111025,'enUS','Looks like you could use a little muscle!','Looks like you could use a little muscle!',26124),
(111026,'enUS','Lemme at \'em!','Lemme at \'em!',26124),
(111027,'enUS','I\'m not cut out for this!','I\'m not cut out for this!',26124),
(111028,'enUS','I\'m in over my head here!','I\'m in over my head here!',26124),
(111029,'enUS','I will begin the preparations for Thunderaan\'s rebirth. Find me when Thunderfury has been recharged!','',26124),
(111030,'enUS','That was quite an adventure, eh?','',26124),
(111031,'enUS','Alright, Huey. Let\'s get back to Dalaran!','',26124),
(111032,'enUS','Hold on! We\'re comin\' in for a landing!','',26124),
(111033,'enUS','Easy, Huey. Easy.','',26124),
(111034,'enUS','<Give Shinfel the Elixir of Suspension.>','<Give Shinfel the Elixir of Suspension.>',26124),
(111037,'enUS','Do you want to check out my latest acquisitions?','',26124),
(111039,'enUS','Was that a guard?','',26124),
(111040,'enUS','Sorry... I can\'t get caught again... sorry... come and find me another time ...','',26124),
(111041,'enUS','To the shrine, druid. Our help is needed.','',26124),
(111042,'enUS','The Idol... it\'s gone!','',26124),
(111043,'enUS','','Get away from there!',26124),
(111044,'enUS','','Are you friend or foe, $r? If you think yourself a friend of the forest, then prove it. Help drive back the corruption that threatens to take over my home.',26124),
(111045,'enUS','','Thank you, $r. You\'ve proven yourself a true ally. I wish you strength in your fight against the evils of this land.',26124),
(111046,'enUS','Quickly, shaman! Hand me the blessed blade and Thunderaan will return!','',26124),
(111047,'enUS','Fester and die!','',26124),
(111048,'enUS','Pathetic! You\'re putting me to sleep. Here, let me return the favor!','',26124),
(111049,'enUS','Feed my hunger, wretch!','',26124),
(111050,'enUS','Witness your end!','',26124),
(111051,'enUS','The light has abandoned you!','',26124),
(111052,'enUS','Underlings! Get in here!','',26124),
(111053,'enUS','Show these pretenders how to fight!','',26124),
(111054,'enUS','Incompetent mortal filth! These Nightborne can\'t even defend their own palace from invasion! If it were up to me...','',26124),
(111055,'enUS','Ah, but I suppose we will reward our \"allies\" soon enough. Until then, I\'ll amuse myself by cleaning up their mess!','',26124),
(111056,'enUS','You think getting past a few power-addled elves means you can stand against a true son of the Legion?','',26124),
(111057,'enUS','Never trust a mortal to do a demon\'s work!','',26124),
(111058,'enUS','Now I know you may be asking yourself why a demon hunter and a warlock are so far out here away from the action.$b$bBut while you are asking yourself that, also ask yourself to be quiet and mind your own business.','',26124),
(111060,'enUS','Another twig for the kindling!','',26124),
(111061,'enUS','Be thankful you died fast!','',26124),
(111062,'enUS','My dealings with this... warlock... are a means to an end.$b$bI wish to learn from this creature, to study it. And if need be, to slay it before it does more harm than good to this world.','',26124),
(111063,'enUS','Laughable! As if you had a prayer of stopping the ritual...','',26124),
(111064,'enUS','Such a predictable demise.','',26124),
(111065,'enUS','Impossible! You are... inferior...','',26124),
(111066,'enUS','I live... AGAIN!','',26124),
(111067,'enUS','But I was... supposed to... win...','',26124),
(111068,'enUS','Hero, once more you have proven your valor to me.','',26124),
(111069,'enUS','Arthfael is a foe worth fighting! Prove your valor! Slay the beast and my reward is yours.','',26124),
(111070,'enUS','Earlnoc is a misshapen pest! Long has this ettin poached the Fields of the Eternal Hunt. Put an end to his troublemaking!','',26124),
(111071,'enUS','Thank you mortal, Earlnoc will poach these fields no longer.','',26124),
(111072,'enUS','Only by strength in battle can you be measured a champion. Let my stormforged begin your test!','',26124),
(111073,'enUS','A magnificent battle! Well done, champion.','',26124),
(111074,'enUS','I seek to forge an alliance with Vethir, the mighty drake of Stormheim. Collect a clutch of eggs from my own brood so that I might make a gift of them.','',26124),
(111075,'enUS','These eggs will make a fine present to Vethir. The scars you earned collecting them mark you a true champion. Well done!','',26124),
(111076,'enUS','Throughout the ages, the legends of my stormforged champions have spurred warriors to greatness. Go forth and learn these tales, that you might be so inspired!','',26124),
(111077,'enUS','Knowledge is but the first step. Only when these tales roar within your heart will you become a hero worthy of our legacy!','',26124),
(111079,'enUS','','You will find only death here!',26124),
(111080,'enUS','','Flee now, and you may yet leave with your fragile lives.',26124),
(111081,'enUS','','So be it. Then you will rot in these halls.',26124),
(111082,'enUS','','Fool! You do not understand the forces you tempt!',26124),
(111083,'enUS','','My warlord... we have... guests...',26124),
(111084,'enUS','Now go. Tell your Earthen Ring that the Windseeker lives again.','',26124),
(111087,'enUS','Got yer weapons ready there, $G lad:lass;?','',26124),
(111088,'enUS','Please sharpen my weapons!','Please sharpen my weapons!',26124),
(111091,'enUS','Need a little gloss, a little shine in that armor there, $n? I got what you need!','',26124),
(111092,'enUS','Make it shine, Krinkle!','Make it shine, Krinkle!',26124),
(111093,'enUS','Her exemplary deeds in the name of the Ebon Blade have shown her to be one of the best of us, worthy of our highest honor.','',26124),
(111095,'enUS','Right then, I\'m gone.','',26124),
(111096,'enUS','Try not to leave a breadcrumb back to us, hero.','',26124),
(111097,'enUS','You will all bow to her as you once did to me, and carry out her will against the Legion!','',26124),
(111098,'enUS','','Your friend is right. We should work together.',26124),
(111101,'enUS','','Hello. Have you come to join the Empyrean Society of Exotic Magical Arts?',26124),
(111102,'enUS','Things need to get back to normal around here. I got a business to run!','',26124),
(111104,'enUS','Use my teleportation pad to exit the workshop. We need to get you to the Temple of Storms before that vrykul arrives!','',26124),
(111107,'enUS','Step into the arena and we will test your resolve.','',26124),
(111112,'enUS','A trial is currently in progress. You can assist with its completion or wait until the arena is clear to begin another.','',26124),
(111113,'enUS','By all means, keep splashing around and attract attention.','',26124),
(111114,'enUS','','I\'ll do that. See you soon, $n.',26124),
(111115,'enUS','','I will not fight the Burning Legion while the Twilight\'s Hammer lays siege to Deepholm!',26124),
(111116,'enUS','We understand, Stonemother. The Earthen Ring stands by you.','',26124),
(111117,'enUS','','Go. Destroy the Twilight\'s Hammer and you shall win my favor!',26124),
(111119,'enUS','The naga will not wait long before turning the Tidestone against us. We should make haste.','',26124),
(111122,'enUS','Me gonna crush you so hard!','',26124),
(111123,'enUS','You gonna stop the hammer? I don\'t think so!','',26124),
(111124,'enUS','It the end of the world... and I feel fine! HAHA!','',26124),
(111125,'enUS','Show the Illidari they have an ally in Nar\'thalas. Free them and take the fight to their demon captors!','',26124),
(111126,'enUS','Marlan must evaluate your gift before I can speak with you further. Farewell.','Marlan must evaluate your gift before I can speak with you further. Farewell.',26124),
(111127,'enUS','I gonna break you, like I break your friend!','',26124),
(111128,'enUS','What I wouldn\'t give to wrangle me one of those demons. Talk about a money maker!','',26124),
(111129,'enUS','You are next!','',26124),
(111130,'enUS','BWAHAHA! I needed a few more scars on my face!','',26124),
(111131,'enUS','I gonna seperate your HEAD from your BODY! BWAHAHA!','',26124),
(111132,'enUS','I gonna stomp you REAL good!','',26124),
(111133,'enUS','As I said, I will see to it that Lord Greymane gets this information. There is no need for you to mention this to anyone else, $c.','',26124),
(111134,'enUS','You will kneel before our master!','',26124),
(111135,'enUS','I am your destruction!','',26124),
(111136,'enUS','None shall withstand the power of our master!','',26124),
(111137,'enUS','The twilight is upon you!','',26124),
(111138,'enUS','Cry for help... none shall answer you!','',26124),
(111139,'enUS','We are the harbingers of destruction!','',26124),
(111140,'enUS','None shall oppose the Twilight\'s Hammer!','',26124),
(111141,'enUS','There are no heroes in oblivion!','',26124),
(111144,'enUS','Thanks! I\'ll be in the shop \'til this blows over.','',26124),
(111146,'enUS','Huln sought Eche\'ro, a beast injured in combat with many demons.','',26124),
(111147,'enUS','Malfurion Stormrage eagerly awaited the arrival of Huln and his tauren reinforcements. Krasus--also known as the dragon Korialstrasz--aided their efforts from the sky.','',26124),
(111148,'enUS','Malfurion worked to bring reinforcements from a verdant realm beyond the borders of physical creation. He needed protection while performing the final magical incantations.','',26124),
(111149,'enUS','Jarod Shadowsong awaited Huln\'s arrival in the battlefield below. He had a special task for Highmountain while organizing and commanding his troops.','',26124),
(111150,'enUS','Shadowsong had one last favor to ask of Huln: Defeat the lord of the Nathrezim, Tichondrius. With his defeat, the attack on Azshara would fail and balance could be restored.','',26124),
(111151,'enUS','','Keep all of this between you and me, $c. As they say, loose lips sink ships.',26124),
(111152,'enUS','The Empyrean Society of Exotic Magical Arts is always willing to accept new members. You should join us before it is too late.','The Empyrean Society of Exotic Magical Arts is always willing to accept new members. You should join us before it is too late.',26124),
(111153,'enUS','In the aftermath of their campaign against the vicious Iron Horde, the mighty orcs of Durotar have now set their sights on the future. Striving to put the dark legacy of its former warchief, Garrosh Hellscream behind it, the Horde now looks to a new leader, the wise and courageous troll, Vol\'jin. Though Garrosh\'s atrocities have caused tensions to rise once again between the Horde and its perennial enemy, the Alliance, it is up to orcs like you to forge a path to redemption, and to reclaim the former glory of the Horde.','',26124),
(111154,'enUS','Although the defeat of former warchief Garrosh Hellscream speaks to a brighter future for the tauren, the mantle of leadership weighs heavily on the shoulders of Baine Bloodhoof. It is his belief that the tauren encompass the heart of the Horde, but he is concerned that in the wake of Garrosh\'s disastrous reign, the tauren have lost both vision and purpose. Now, it is up to brave tauren like you to safeguard the lands of your ancestors, and to restore both honor and greatness to your tribe, and... to the Horde.','',26124),
(111155,'enUS','Our methods may be unorthodox to some, but the powers we have mastered are priceless.','Our methods may be unorthodox to some, but the powers we have mastered are priceless.',26124),
(111156,'enUS','Exiled years ago from their lands in Stanglethorn Vale, the Darkspear attempted to make a new life for themselves amongst the disparate races of the Horde. The crimes and treachery of warchief Garrosh Hellscream, however, devastated all possibilities of unity within the Horde. With the defeat of Garrosh, the cunning and resourceful trolls have once again embraced the promise of a more hopeful future under the keen leadership of Vol\'jin. And though a renewed threat of attack from the renegade Zandalari tribe looms large, Vol\'jin strives for a day when all trolls stand reunited. Now, it is up to courageous young trolls like you to help ensure that Vol\'ljin\'s bold vision of unity becomes a reality.','',26124),
(111157,'enUS','Having served as vanguard in the Alliance\'s campaign against the ruthless Iron Horde, the human nation of Stormwind has once again risen to preeminence. After successfully invading Orgrimmar and bringing justice to the infamous warchief Garrosh Hellscream, High King Varian Wrynn has vowed that the world of Azeroth must never again fall prey to tyranny. Now, as dark clouds loom on the horizon and tensions between the humans and their long-time enemy the Horde begin to rise, the Alliance must once again serve as an example to those who would fight for righteousness. As the storm draws near, it falls to you to uphold the honor of humanity.','',26124),
(111158,'enUS','I am NOT cut out for this!','',26124),
(111159,'enUS','The stalwart king of the Dwarves, Magni Bronzebeard, was taken from his people when a terrible curse fused his physical form into the diamond heart of the dwarven capital of Ironforge. To avert civil war in the king\'s absence, the dwarves created a council of three hammers that would share power amongst the feuding clans. Over time this coalition has maintained a tenuous stability...','',26124),
(111160,'enUS','but now, Magni Bronzebeard has returned from his crystal prison. All is not well, however, as the dwarven king bears grim tidings of a dark and uncertain future. It is unclear how this ominous prophecy will affect both the council\'s accord and the destiny of the dwarves. What is clear is that you must do all within your power to protect your people in these perilous and unpredictable times.','',26124),
(111161,'enUS','Through the bold leadership of Lady Sylvanas, the Forsaken have once again attained a position of strength among the warring factions of Azeroth. Bolstered by the dark and powerful magics of her Val\'kyr, Sylvanas has replenished her ranks and once again created a safe harbor for her people in the capital of Undercity. However, shadows from the past still haunt the undead queen. Traitorous plots carried out by agents under her command, such as the betrayal at the Wrath Gate, continue to cast fear and doubt on the Forsaken\'s allegiance to the Horde. As a dedicated member of Sylvanas\' undead army, it will fall to you to help prove the Forsaken\'s loyalty, and to slay anyone who would dare threaten her rule.','',26124),
(111162,'enUS','The inspired leadership of High Priestess Tyrande Whisperwind has brought prosperity and stability to the night elf people. Also, with the help of Archdruid Malfurion Stormrage, nature throughout Hyjal has flourished in the aftermath of the Cataclysm\'s widespread destruction. The formerly corrupted, mighty World Tree Teldrassil continues to heal, rejuvenating the spirits of the embattled night elves... and ancient demigods roam the world anew. All is not peaceful, however, in the misty boughs of Teldrassil. The reawakened demigods sense that old enemies will reemerge, bringing with them a terrible doom. Now, as your people have done so many times before, you must stand ready to pull Azeroth back from the brink of oblivion.','',26124),
(111163,'enUS','The Sunwell, once a perennial fount of arcane power, now channels the Holy Light... providing hope that the Sin\'dorei, under the leadership of Lor\'themar Theron, may at last be on the road to overcoming their magical addiction. Though the blood elves aided in both the defeat of the Iron Horde and the battle against Garrosh, their once-possible future with the Alliance has been cast into doubt. As the blood elves face a turbulent and uncertain future, you must remain ready to defend what remains of your once-mighty civilization, and redeem the embattled soul of your people.','',26124),
(111164,'enUS','What?! It\'s mine. You can\'t have it!','',26124),
(111165,'enUS','Lord of the tides curse you, $r!','',26124),
(111166,'enUS','We will see you on the other side in Nordrassil, Archdruid.','',26124),
(111167,'enUS','It\'s unfortunate that affairs have come to this, but what are we going to do? Wait for them to come slaughter us in our sleep and go out of business?','',26124),
(111177,'enUS','','These wretches defile our sacred ground collecting souls for their cursed queen! Finish them!',26124),
(111179,'enUS','','Thank you, champion! The sanctity of this place is preserved thanks to your help.',26124),
(111181,'enUS','I can find any tool... for the right price.','',26124),
(111184,'enUS','I think you would find our rare ore reserves in the back room more to your liking.','',26124),
(111185,'enUS','<Subtlety flash your insignia.>','<Subtlety flash your insignia.>',26124),
(111186,'enUS','Nithogg terrorizes Stormheim from his roost atop the sundered peak, Nastrondir. His continued existence is an affront to the legacy of the Thorgnir. End it.','',26124),
(111187,'enUS','Though he was once Thorignir, Nithogg\'s madness was a blight on this land. You have done a great deed today, outsider.','',26124),
(111188,'enUS','Warning: The skies are not safe! Ground yourself immediately!','Warning: The skies are not safe! Ground yourself immediately!',26124),
(111193,'enUS','','The Earthen Ring has done a great service to Deepholm. We will return the favor.',26124),
(111194,'enUS','','The Stonemother always pays her debts.',26124),
(111195,'enUS','','As a symbol of our alliance, I will bestow upon you one of my greatest warriors.',26124),
(111196,'enUS','','Protect the Earthen Ring, Avalanchion. Pave the ground with the corpses of the Burning Legion!',26124),
(111198,'enUS','<Suffering from a fever. If you know how to treat a fever, you\'ll know how to heal him.>','<Suffering from a fever. If you know how to treat a fever, you\'ll know how to heal her.>',26124),
(111199,'enUS','The Earthen Ring is deeply grateful, Stonemother.','',26124),
(111201,'enUS','As you wish, Stonemother.','',26124),
(111208,'enUS','We should return to the Heart of Azeroth, Farseer. There is still much to be done.','',26124),
(111211,'enUS','','Aye. You go on ahead, dear. We\'ll be along soon.',26124),
(111212,'enUS','I don\'t belong here! I\'m no fighter! I just make things!','',26124),
(111226,'enUS','Huh, hmm... what? Afraid? Hah!$B$BListen here, bub. I\'ve seen fighters come and go. A few demons don\'t scare me. Besides, somebody\'s gotta survive long enough to keep this thing runnin\'. Might as well be me.$B$BMoney ain\'t gonna make itself.','',26124),
(111229,'enUS','Get back you beasts!','Get back you beasts!',26124),
(111232,'enUS','<The patient is bleeding profusely from a large wound. If you know how to stabilize the wound, you\'ll know how to treat him.>','<The patient is bleeding profusely from a large wound. If you know how to stabilize the wound, you\'ll know how to treat him.>',26124),
(111233,'enUS','Whew! I thought I was a goner. Thank you!','Whew! I thought I was a goner. Thank you!',26124),
(111234,'enUS','I came to speak to you about your needs for archaeology gathering.','I came to speak to you about your needs for archaeology gathering.',26124),
(111235,'enUS','','Well as you know, surveying an area can be quite time consuming.$b$bYou have to place down your equipment, which is some work, then study the results and then try to move closer to where you believe the fragment may exist.$b$bAll I was asking for was something to speed up that process. But apparently my explaining of our process to Nalthanis was just too much for him to listen to.$b$bPerhaps you can explain it better to him than I can.',26124),
(111236,'enUS','','You don\'t strike me as the archaeology type. You see, surveying an area can be quite time consuming.$b$bYou have to place down your equipment, which is some work, then study the results and then try to move closer to where you believe the fragment may exist.$b$bAll I was asking for was something to speed up that process. But apparently my explaining of our process to Nalthanis was just too much for him to listen to.$b$bPerhaps you can explain it better to him than I can.',26124),
(111238,'enUS','I will see you back in the Hall of the Guardian. Esara, you are welcome to join us there.','',26124),
(111239,'enUS','','Looks like somebody\'s really askin\' for it! Lemme at \'em!',26124),
(111240,'enUS','','You\'re messin\' with the wrong girl!',26124),
(111241,'enUS','','Today just isn\'t your day!',26124),
(111242,'enUS','','Looks like this is gonna be a long day!',26124),
(111243,'enUS','','Duty calls!',26124),
(111245,'enUS','Are you so weak, Lord Smolderon, that you require the help of mortals?','',26124),
(111246,'enUS','Chargore... my champion! You will pay, mortal!','',26124),
(111247,'enUS','I\'ve spoken with Dariness and here\'s what she was trying to say...','I\'ve spoken with Dariness and here\'s what she was trying to say...',26124),
(111248,'enUS','You approach your demise, shaman. Turn back while you still live!','',26124),
(111249,'enUS','You dare oppose the son of Rhyolith? You will be destroyed!','',26124),
(111250,'enUS','Slain by a mortal? It cannot be...','',26124),
(111251,'enUS','','Thank you!',26124),
(111252,'enUS','Thank you.','',26124),
(111253,'enUS','Thank you.','',26124),
(111254,'enUS','These mortals do my bidding. A pity you do not share their enthusiasm!','',26124),
(111255,'enUS','Your champions crumble, Pyroth!','',26124),
(111256,'enUS','Destroy the imposter, shaman! Bring me his heart!','',26124),
(111258,'enUS','Yes, I see.$b$bI\'d like you to do something for me, $n. Take this enchanted pen and paper and survey archaeological digsites so that my pen may make notes of your process.$b$bReturn to me when you\'re finished and bring me back anything you find.$b$bIf you don\'t already know how to survey, just talk to Dariness, I\'m sure she can fill you in again on the finer points of being an archaeologist.','',26124),
(111259,'enUS','I remember the night Orgrim fell, run through by a knight\'s lance during the liberation of the last orc internment camp. As he bled out onto the fields of Arathi, he bestowed the Doomhammer to me.','',26124),
(111260,'enUS','The Doomhammer is not merely a weapon. It is a symbol. A symbol of hope, of power... Proof that an individual can change the world.','',26124),
(111265,'enUS','Did you think I would stand idle as you clawed your way through my minions? Listen, mortal, as the treasure you fight so hard to obtain is broken to my will!','',26124),
(111266,'enUS','Alliance scum!','Alliance scum!',26124),
(111267,'enUS','Coward!','Coward!',26124),
(111268,'enUS','You have no honor, $c.','You have no honor, $c.',26124),
(111269,'enUS','The Dark Lady will prevail.','The Dark Lady will prevail.',26124),
(111270,'enUS','A curse upon you and yours!','A curse upon you and yours!',26124),
(111271,'enUS','Long live the Banshee Queen!','Long live the Banshee Queen!',26124),
(111272,'enUS','Arrrghhh!','',26124),
(111273,'enUS','I spit on you!','I spit on you!',26124),
(111274,'enUS','My life for the forsaken.','My life for the forsaken.',26124),
(111275,'enUS','Curse you! I will not give in!','',26124),
(111276,'enUS','Looking for something specific?','',26124),
(111277,'enUS','During the Cataclysm, I spent many terrible weeks as a prisoner in the Abyssal Maw. I have no desire to return there, but I know the place well.','',26124),
(111278,'enUS','Sharas\'dal, the Scepter of Tides, is steeped in Legend. Through its power, Azshara enabled her followers to live in the sea.','',26124),
(111279,'enUS','','Is it dangerous?',26124),
(111280,'enUS','It has dominion of the waters of Azeroth, the very stuff of life. In the right hands, it could be a font of healing instead of corruption.','',26124),
(111281,'enUS','','This realm belongs to Azshara now, shaman. How fitting that the Earthen Ring will be swept away by the sea!',26124),
(111282,'enUS','','I used to be a great enchanter once, before I fell. Now my spirit is bound to my home.$b$bIf only I could have my enchanting rod back...',26124),
(111283,'enUS','','The seas will devour you!',26124),
(111284,'enUS','','You will be crushed beneath the waves.',26124),
(111285,'enUS','','Sharas\'dal is mine, for the glory of my queen alone!',26124),
(111286,'enUS','','While I still no longer possess a physical body, I feel alive again having my enchanting rod back in my possession.$b$bIf you wish to learn any of my enchantments, you only need to bring some materials as trade.',26124),
(111288,'enUS','Your cause is hopeless, sea witch! No matter how you bend the elements to your will, they will never truly serve you.','',26124),
(111289,'enUS','You use the Scepter to curse and destroy. In our hands, it will cleanse and heal!','',26124),
(111290,'enUS','Why are we not firing yet? Work faster, or face the lash!','',26124),
(111291,'enUS','','Lady Zithreen is in the throne room beyond.',26124),
(111292,'enUS','I would like to see what enchantments you have available.','I would like to see what enchantments you have available.',26124),
(111293,'enUS','Her power over the waters here is absolute. We must be cautious.','',26124),
(111294,'enUS','Take up the Scepter, shaman. You have earned it.','',26124),
(111295,'enUS','','If you wish to learn any of my enchantments, you need only ask. And bring me some materials.',26124),
(111296,'enUS','','Jump to remove effects of |cFFFF0000|Hspell:182815|h[Stoneblood Poison]|h|r.',26124),
(111297,'enUS','Please, not that! We work faster!','',26124),
(111299,'enUS','Freedom! The feeling is sweet, but Mephistroth\'s magic has diminished my power. Let\'s depart this place before the dreadlord is able to return.','',26124),
(111300,'enUS','Well well, the little elf returns. You are most... persistent.','',26124),
(111301,'enUS','You have fulfilled your end of the bargain. As promised, I give you a taste of the Legion\'s power. Earn more by proving your strength!','',26124),
(111302,'enUS','Our farm! Please! Somebody hurry!','',26124),
(111303,'enUS','I can\'t hold them off!','',26124),
(111304,'enUS','I grow tired of your interference! DIE!','',26124),
(111305,'enUS','','Welcome, $c. Are you interested in enchantments, or are you here to help against the naga?',26124),
(111306,'enUS','Supply camp as well... we\'re getting bombarded out here!','Supply camp as well... we\'re getting bombarded out here!',26124),
(111307,'enUS','I will do what I can for Senegos, but I urge you to be quick about your business, $n. I fear that he might not survive much longer.\n\nMatters elsewhere call for my attention, and I must depart soon. However, I will return as soon as I am able.','',26124),
(111308,'enUS','','By the gods... some kind of structure southeast of the Hill! It just appeared out of nowhere!',26124),
(111309,'enUS','Two more demons heading for the Hill! Ready at the gates!','',26124),
(111311,'enUS','Our enemies shall burn.','',26124),
(111312,'enUS','Have you come to supplicate yourself before the Light? Or perhaps you have come here to train in the holy arts?$b$bIf you are here to speak with Archbishop Benedictus or Bishop Farthing, they have both gone on missions.','',26124),
(111313,'enUS','Bishop Farthing has left too?','Bishop Farthing has left too?',26124),
(111314,'enUS','Yes, he left in quite a hurry. After dealing with the accusations against Benedictus, he decided to go investigate the matter personally. Hopefully he will find some peace on his mission.','',26124),
(111315,'enUS','Peace? What was wrong?','Peace? What was wrong?',26124),
(111316,'enUS','The power... I can control it. Yes! I need it all!','',26124),
(111317,'enUS','Yes, well, he hasn\'t really been the same lately. Arguing with himself, being more secretive, ignoring ceremonies. I think the stress of this investigation just got to him. I hope he\'s alright.','',26124),
(111318,'enUS','<Theryn seems entranced.>','',26124),
(111319,'enUS','Feed: 300x |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t|Hcurrency:1155|h|cFFFFFFFF Ancient Mana|h|r','Feed: 300x |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t|Hcurrency:1155|h|cFFFFFFFF Ancient Mana|h|r',26124),
(111320,'enUS','I bring the ferocity of the bear to battle!$B$BI can taunt enemies, if you will attack them and heal me.','',26124),
(111321,'enUS','','Hi $n! I think it\'s time for those nasty nightmare demons to scram! If you choose me to help you, I\'ll call upon the balance of nature to smite our enemies!',26124),
(111322,'enUS','','Greetings $n. I am glad to lend my aid to the fight.$B$BIf you wish me to accompany you, I will restore your health and help keep you alive.',26124),
(111323,'enUS','','I wouldn\'t miss dis final fight, $n. I will leap inta battle in my feral form. Choose me and I will fight bravely.',26124),
(111324,'enUS','I choose you to fight with me.','I choose you to fight with me.',26124),
(111326,'enUS','Zoom is best!','',26124),
(111327,'enUS','Get \'em Zoom!','',26124),
(111328,'enUS','Faster, Zoom!','',26124),
(111329,'enUS','They\'re cheating!','',26124),
(111330,'enUS','Oh, come on!','',26124),
(111331,'enUS','ZOOOOOOOOOOOOOOOOOOOOM!','',26124),
(111335,'enUS','Breathtaking. Imagine all of the arcane knowledge lost to the ages here.','',26124),
(111336,'enUS','There... the Illidari. And, the Burning Legion is here, too.','',26124),
(111354,'enUS','','Need a ride?',26124),
(111355,'enUS','I found a cask of wine!','I found a cask of wine!',26124),
(111356,'enUS','','Ah! This cask contains a large amount of arcwine. Go ahead and put it into the gondola.',26124),
(111357,'enUS','','Need a ride, stranger?',26124),
(111358,'enUS','','I hope you can manage better than our last wine thief, rest his soul.',26124),
(111360,'enUS','','I see! You are the one I was waiting for. All I need is a full boat and I\'ll be on my way.',26124),
(111361,'enUS','','Ysera left me in charge of defending the Dream. My brethren and I have been patrolling this realm for eons.$B$BWe will lend our power to this fight.',26124),
(111363,'enUS','Can you help me?','Can you help me?',26124),
(111364,'enUS','Meet me on the other side of this portal. I must prepare for the ritual there.','',26124),
(111365,'enUS','','If you have need, call us on the field of battle. Together, we will protect this world!',26124),
(111366,'enUS','Be ready, assistant. I shall begin drawing power from the ship\'s stores.','',26124),
(111367,'enUS','So much power! I can handle it! I can take more!','',26124),
(111368,'enUS','Ah, so that is the key. MORE! MORE!','',26124),
(111369,'enUS','Ahh, much better. I have all the power I could want.','',26124),
(111370,'enUS','Yet I still crave more. Your soul will do nicely!','',26124),
(111371,'enUS','Well, well. What have we here? A thief?','',26124),
(111372,'enUS','Be careful what you wish for...','',26124),
(111373,'enUS','UNUSED No! I have failed...','',26124),
(111374,'enUS','$GSir : Madam;! I\'d hate to be a burden, but would you mind?','$GSir : Madam;! I\'d hate to be a burden, but would you mind?',26124),
(111375,'enUS','Let us reclaim our lands together!','Let us reclaim our lands together!',26124),
(111376,'enUS','I pledge my service to you.','I pledge my service to you.',26124),
(111377,'enUS','I appreciate your kindness, but as long as the skies remain dark, I must remain vigilant.','I appreciate your kindness, but as long as the skies remain dark, I must remain vigilant.',26124),
(111378,'enUS','Your skills serve our people well during these times. Perhaps we shall meet again.','Your skills serve our people well during these times. Perhaps we shall meet again.',26124),
(111379,'enUS','The Eye of Il\'gynoth is creating a Nightmare Horror!','The Eye of Il\'hynoth is creating a Nightmare Horror!',26124),
(111380,'enUS','This mortal seeks to awaken the cursed weapon! Devour the shaman, my children!','',26124),
(111381,'enUS','My precious children! I will devour you!','',26124),
(111382,'enUS','|TInterface\\Icons\\sha_spell_shadow_shadesofdarkness_nightmare:20|t%s begins to cast |cFFFF0000|Hspell:212726|h[Forces of Nightmare]|h|r!','',26124),
(111383,'enUS','Those foul demons... I wasn\'t ready.','Those foul demons... I wasn\'t ready.',26124),
(111384,'enUS','The elements will guide us, $n.','The elements will guide us, $n.',26124),
(111385,'enUS','May I fight by your side, brave $r?','May I fight by your side, brave $r?',26124),
(111386,'enUS','Be safe, $n!','Be safe, $n!',26124),
(111387,'enUS','Be careful! It\'s not safe out here.','Be careful! It\'s not safe out here.',26124),
(111388,'enUS','Please, if you could!','Please, if you could!',26124),
(111389,'enUS','Over here!','Over here!',26124),
(111390,'enUS','War brings us together. We must fight as one.','War brings us together. We must fight as one.',26124),
(111391,'enUS','Together we are stronger.','Together we are stronger.',26124),
(111392,'enUS','You are very brave, $n. Be safe.','You are very brave, $n. Be safe.',26124),
(111393,'enUS','Your kindness will not be forgotten.','Your kindness will not be forgotten.',26124),
(111394,'enUS','Alliance Outpost at Moonbrook! We\'re under attack! Moonbrook\'s been overrun!','',26124),
(111395,'enUS','Let\'s see that new spell again, conjuror.','Let\'s see that new spell again, conjuror.',26124),
(111396,'enUS','You are improving. Keep practicing.','You are improving. Keep practicing.',26124),
(111397,'enUS','','Lady Sacrolash and her sister, Alythess. They are responsible for this foul magic that infects my blood.',26124),
(111398,'enUS','','The twins are helping Mephistroth build an army. They intend to attack Dreadscar, and steal the Felblood Altar.',26124),
(111399,'enUS','','We should slaughter them before they have the chance.',26124),
(111400,'enUS','Mind lendin\' me a hand o\'er here?','Mind lendin\' me a hand o\'er here?',26124),
(111401,'enUS','Help me teach these things a lesson!','Help me teach these things a lesson!',26124),
(111402,'enUS','The Legion must be stopped, and I will do everything in my power to make it so. NOTHING is more important than their destruction!','',26124),
(111403,'enUS','','Ha! You\'re the one they sent? Good luck...',26124),
(111404,'enUS','Where we goin\'?','',26124),
(111405,'enUS','What you need?','',26124),
(111406,'enUS','How\'s it jookin\'?','',26124),
(111407,'enUS','Take off.','',26124),
(111408,'enUS','We done? Okie-dook.','',26124),
(111409,'enUS','Buh-bye.','',26124),
(111410,'enUS','Pull me finger! Okay no wait - no pull this one. Ahh, okay wait wait - no - come back later we try again.','',26124),
(111411,'enUS','|TInterface\\Icons\\ability_hunter_pet_dragonhawk.blp:20|t Elerethe begins |cFFFF0000|Hspell:212707|h[Gathering Clouds]|h|r and prepares to fly to another platform!','|TInterface\\Icons\\ability_hunter_pet_dragonhawk.blp:20|t Elerethe begins |cFFFF0000|Hspell:212707|h[Gathering Clouds]|h|r and prepares to fly to another platform!',26124),
(111412,'enUS','This is our darkest hour.','',26124),
(111413,'enUS','The Legion will stop at nothing.','',26124),
(111414,'enUS','What news?','',26124),
(111415,'enUS','I always knew this day would come.','',26124),
(111416,'enUS','We must fight together or we will perish alone.','',26124),
(111417,'enUS','We must not lose hope.','',26124),
(111418,'enUS','Never give in.','',26124),
(111419,'enUS','Fight on.','',26124),
(111420,'enUS','What do you ask of me?','',26124),
(111421,'enUS','We all have to pull together in this.','',26124),
(111422,'enUS','I\'ve fought with the best.','',26124),
(111423,'enUS','The arena is a true test of character.','',26124),
(111424,'enUS','Ancestors watch over you.','',26124),
(111425,'enUS','I will fight to my last breath.','',26124),
(111426,'enUS','Fight like a champion!','',26124),
(111427,'enUS','No one fights alone.','',26124),
(111428,'enUS','You must think this is one of those games where you have to click around constantly to get me to do stuff. IT IS NOT.','',26124),
(111429,'enUS','Hello, friend.','',26124),
(111430,'enUS','Yes?','',26124),
(111431,'enUS','The elements listen.','',26124),
(111432,'enUS','Speak with me.','',26124),
(111433,'enUS','Do not let the darkness triumph.','',26124),
(111434,'enUS','Keep a peaceful mind.','',26124),
(111435,'enUS','Maintain focus.','',26124),
(111436,'enUS','Find your center.','',26124),
(111437,'enUS','I spent several months at the bottom of the ocean with a squid over my head. Your spiteful machinations will not rattle me.','',26124),
(111438,'enUS','I can\'t do this without you, $p. I\'ll wait for your return to take down this beast.','',26124),
(111439,'enUS','Let us make quick work of this beast, $n!','',26124),
(111440,'enUS','We have won the day, $p. Meet me back at the crumbled palace and I shall grant you my mark.','',26124),
(111441,'enUS','I\'ve marked the location on your map. Go now, I will already be inside waiting for you when you arive.','',26124),
(111442,'enUS','trills with appreciation before flying to safety.','',26124),
(111443,'enUS','','Ravandwyr, you should not have gone off alone!',26124),
(111444,'enUS','','The elements call.',26124),
(111445,'enUS','','How can I help?',26124),
(111446,'enUS','','Yes?',26124),
(111447,'enUS','','For Azeroth.',26124),
(111448,'enUS','','The Earthen Ring will persevere.',26124),
(111449,'enUS','','We journey together with the spirits.',26124),
(111450,'enUS','Come closer, and speak.','',26124),
(111451,'enUS','I am listening.','',26124),
(111452,'enUS','Do not give up.','',26124),
(111453,'enUS','I will do my best to guide you.','',26124),
(111454,'enUS','We must never forget.','',26124),
(111455,'enUS','The elements will never forsake us.','',26124),
(111456,'enUS','With faith, there is a way.','',26124),
(111457,'enUS','Remember.','',26124),
(111458,'enUS','Out with it.','',26124),
(111459,'enUS','Talk.','',26124),
(111460,'enUS','You are a joke.','',26124),
(111461,'enUS','Pathetic.','',26124),
(111462,'enUS','Hi.','',26124),
(111463,'enUS','Tiny friend.','',26124),
(111464,'enUS','Little bitty person.','',26124),
(111465,'enUS','Okay.','',26124),
(111466,'enUS','Ah-yup.','',26124),
(111467,'enUS','Mmmnhmm.','',26124),
(111468,'enUS','You would not like me angry.','',26124),
(111469,'enUS','','A storm is coming.',26124),
(111470,'enUS','','Maybe I can help.',26124),
(111471,'enUS','','The seas are restless.',26124),
(111472,'enUS','','I believe in you.',26124),
(111473,'enUS','','I will do what I can.',26124),
(111474,'enUS','','Spirits guide you.',26124),
(111475,'enUS','Should you wish to learn more enchantments, I would be happy to trade with you for what I know.','',26124),
(111476,'enUS','Move along.','',26124),
(111477,'enUS','Mind your wandering eyes, stranger.','',26124),
(111478,'enUS','This is not a safe place to linger. Keep walking.','',26124),
(111479,'enUS','Unless you have something worth risking my life for, I will not budge. Let\'s put the price at something completely absurd.\n\nLet\'s say... enough mana to sustain me for a month. \n\n<Arluin looks smug, as if you could never agree to this absurd request.>','',26124),
(111483,'enUS','What now?','',26124),
(111484,'enUS','Yes?','',26124),
(111485,'enUS','There is great power in the Heart of Azeroth. There may be no closer place to all of the elements on Azeroth, than where we now stand.','',26124),
(111486,'enUS','Do you need a hand? Because I don\'t have one.','',26124),
(111488,'enUS','What do you ask of me?','',26124),
(111489,'enUS','To dominate, or not to dominate, that is the question.','',26124),
(111490,'enUS','There is a method to my madness.','',26124),
(111491,'enUS','I am ready to commune with the Elemental Lords.','I am ready to commune with the Elemental Lords.',26124),
(111492,'enUS','My valarjar.','',26124),
(111493,'enUS','What victories do you bring me?','',26124),
(111494,'enUS','Tell me of your battles.','',26124),
(111495,'enUS','Have you brought valor to these halls?','',26124),
(111496,'enUS','Bring us tales of victory.','',26124),
(111497,'enUS','May your battles be glorious.','',26124),
(111498,'enUS','Go now my champion.','',26124),
(111499,'enUS','Remember, life is nothing without valor.','',26124),
(111500,'enUS','','Glory to Odyn!',26124),
(111501,'enUS','Speak quickly.','',26124),
(111502,'enUS','What is it?','',26124),
(111503,'enUS','Yes?','',26124),
(111504,'enUS','','I serve Odyn.',26124),
(111505,'enUS','','Are you worthy of Odyn\'s gaze?',26124),
(111506,'enUS','','Glory to you on the battlefield.',26124),
(111507,'enUS','','May Odyn\'s gaze give you strength.',26124),
(111508,'enUS','','Strive to be worthy.',26124),
(111509,'enUS','Are you into... bloodletting?','',26124),
(111510,'enUS','I fight for Odyn!','',26124),
(111511,'enUS','I am valarjar.','',26124),
(111512,'enUS','I live for battle!','',26124),
(111513,'enUS','We will meet again.','',26124),
(111514,'enUS','Find glory on the battlefield.','',26124),
(111515,'enUS','Let us cross blades sometime.','',26124),
(111516,'enUS','I am Thoradin.','',26124),
(111517,'enUS','I have seen much in life and death.','',26124),
(111518,'enUS','You speak to the King of Arathor.','',26124),
(111519,'enUS','Beware the Old Gods.','',26124),
(111520,'enUS','Welcome! I hope your travel was pleasant.','',26124),
(111521,'enUS','Farewell, hero.','',26124),
(111522,'enUS','It\'s good to see you.','',26124),
(111523,'enUS','Yes?','',26124),
(111524,'enUS','In every loss there is gain, in every gain there is loss.','',26124),
(111525,'enUS','Be strong of arm and mind.','',26124),
(111526,'enUS','I choose when to fight; others do not have this luxury.','',26124),
(111527,'enUS','Courage first; then power; then technique.','',26124),
(111528,'enUS','Bend with the wind and you will not break.','',26124),
(111529,'enUS','Begone.','',26124),
(111530,'enUS','The mortals come to assault our position! Strip the flesh from their bones!','',26124),
(111531,'enUS','Fine.','',26124),
(111532,'enUS','Very well.','',26124),
(111533,'enUS','Let none who trespass into the Legion\'s domain survive!','',26124),
(111534,'enUS','At last.','',26124),
(111535,'enUS','You\'ll think it less funny plummeting back to Azeroth.','',26124),
(111536,'enUS','Want to try that from the bottom of my boot?','',26124),
(111537,'enUS','Enough talking.','',26124),
(111538,'enUS','There\'s work to be done.','',26124),
(111539,'enUS','','Do you need a book?',26124),
(111540,'enUS','','Shall I look something up for you?',26124),
(111541,'enUS','','Yes?',26124),
(111542,'enUS','','Walk in wisdom.',26124),
(111543,'enUS','','The world is the teacher, and we it\'s students.',26124),
(111544,'enUS','','Take care.',26124),
(111545,'enUS','','How about you go find a nice book to read?',26124),
(111546,'enUS','','I\'m ready to check-out.',26124),
(111547,'enUS','','Shush!',26124),
(111548,'enUS','Bal\'a dash, malanore.','',26124),
(111549,'enUS','You have my attention.','',26124),
(111550,'enUS','Any news?','',26124),
(111551,'enUS','We must overcome the mistakes of the past.','',26124),
(111552,'enUS','Safe travels.','',26124),
(111553,'enUS','Is that...? It is!','Is that...? It is!',26124),
(111554,'enUS','Nightwell be praised...','Nightwell be praised...',26124),
(111555,'enUS','Please...','Please...',26124),
(111556,'enUS','I can\'t take this any more!','I can\'t take this any more!',26124),
(111557,'enUS','Make the pain stop...','Make the pain stop...',26124),
(111558,'enUS','I can\'t begin to thank you enough!','I can\'t begin to thank you enough!',26124),
(111559,'enUS','I thought I was going to die.','I thought I was going to die.',26124),
(111560,'enUS','How could they let us suffer like that?','How could they let us suffer like that?',26124),
(111561,'enUS','Thank you, thank you, thank you!','Thank you, thank you, thank you!',26124),
(111562,'enUS','I thought I would never taste it again.','I thought I would never taste it again.',26124),
(111563,'enUS','Shaman of the Earthen Ring, we gather together to commemorate a newly forged alliance.','',26124),
(111564,'enUS','Today, we are witness to the fulfillment of prophecy.','',26124),
(111565,'enUS','The Farseer of the Earthen Ring has united the great Elemental Lords to save Azeroth!','',26124),
(111566,'enUS','The Burning Legion will fall. The demons are no match for the fury of the elements!','',26124),
(111568,'enUS','Bah! That portal foundation is all wrong. It is fully exposed to tampering. Whoever made this should feel bad about themselves.','',26124),
(111569,'enUS','Well now, Arkethrax is leading this band? This is an opportunity I did not expect.','',26124),
(111573,'enUS','What is this mumbling trash? They call THIS a ritual? I could rain fire down on all of these eredar and I don\'t think it could make this ritual any worse than it already is.','',26124),
(111574,'enUS','Hrm, that wasn\'t expected... Let me try this again.','',26124),
(111575,'enUS','Where are all the powerful demons hiding?','',26124),
(111576,'enUS','Another imp?! Unbelievable.','',26124),
(111577,'enUS','I\'ll get it right next time.','',26124),
(111578,'enUS','Galius Miremoore grumbles.','',26124),
(111579,'enUS','UNUSED - Do you really believe I would leave something so valuable unguarded?','',26124),
(111580,'enUS','UNUSED - Some secrets are too big for small minds such as yours...','',26124),
(111581,'enUS','Very good!','',26124),
(111582,'enUS','My brother spoke of a dragon called Lanigosa at Wyrmrest Temple. Seek her out while I prepare a strike force for the tomb.','',26124),
(111585,'enUS','','Hello, $c. I sense you have business with me.',26124),
(111586,'enUS','','Earth and stone shall rise to shield our world from the demon onslaught!',26124),
(111587,'enUS','I do. I am looking for a paladin named Galford.','I do. I am looking for a paladin named Galford.',26124),
(111588,'enUS','','Ah yes! A very studious sort he was, eager to hear stories of Tyr, the titan keeper.$b$bI told him of the battle between Galakrond and Tyr, and how Kalecgos saw Tyr\'s severed hand at Galakrond\'s Rest. Galford got very excited and left.$b$bIs your friend safe?',26124),
(111589,'enUS','In truth I do not know, I will seek him out.','In truth I do not know, I will seek him out.',26124),
(111590,'enUS','It will be an honor to battle at your side, Farseer. Together, we shall scatter the demons like dust in the wind!','',26124),
(111591,'enUS','Southern reinforcement camp! We can\'t hold them off much longer! A dreadlord\'s taken nearly half my men!','Southern reinforcement camp! We can\'t hold them off much longer! A dreadlord\'s taken nearly half my men!',26124),
(111592,'enUS','They\'re out here at Molsen Farm too! Get out here! They\'re everywhere!','',26124),
(111593,'enUS','','Galakrond\'s Rest can be dangerous. Perhaps a tracking spell will be of use.',26124),
(111594,'enUS','Pearlhunter Phin stares at you in disbelief.','',26124),
(111595,'enUS','Pearlhunter Phin chuckles, then shakes their head in shame.','',26124),
(111596,'enUS','Pearlhunter Phin waves a hand in front of its nose and groans loudly.','',26124),
(111597,'enUS','Ah, you are here. All is ready.','',26124),
(111598,'enUS','We do not tolerate misconduct amongst our own, $n. However if your accusation against Archmage Vargoth proves malicious, know that the consequences will be severe.','',26124),
(111599,'enUS','','Your friend came seeking answers, his mind flooded by memories stored in the Spark of the noble watcher. He learned of Tyr\'s ancient battle against Galakrond, and of the hand he lost in the dragon\'s maw.',26124),
(111601,'enUS','Stop following me!','Stop following me!',26124),
(111602,'enUS','Ansirem, I have been following $n for some time now and these are not spurious charges. I too observed Archmage Vargoth behaving oddly.','',26124),
(111603,'enUS','As have I. He has been quite preoccupied of late.','',26124),
(111604,'enUS','I am ready. Begin the spell.','I am ready. Begin the spell.',26124),
(111608,'enUS','','Agh!! Make them stop! Please make them stop!',26124),
(111610,'enUS','Go forth, Farseer, as Champion of The Elements and bring defeat to the Burning Legion!','',26124),
(111611,'enUS','There is still much to do. Advisor Sevel is waiting for you. He is making preparations for the coming battle against the Burning Legion.','',26124),
(111612,'enUS','The Earthen Ring stands with you as well, my friend.','',26124),
(111613,'enUS','Alexston\'s been overrun as well! We\'ve taken shelter in the barn!','',26124),
(111614,'enUS','|TINTERFACE\\ICONS\\warrior_talent_icon_thunderstruck:20|t Nithogg unleashes a |cFFFF0404|Hspell:212841|h[Crackling Jolt]|h|r!','|TINTERFACE\\ICONS\\warrior_talent_icon_thunderstruck:20|t Nithogg unleashes a |cFFFF0404|Hspell:212841|h[Craclkling Jolt]|h|r!',26124),
(111615,'enUS','We\'ve scouted another camp down here along the coast! It\'s a big one!','We\'ve scouted another camp down here along the coast! It\'s a big one!',26124),
(111616,'enUS','Looks like Furlbrow\'s needs some help! Send ground forces immediately!','Looks like Furlbrow\'s needs some help! Send ground forces immediately!',26124),
(111617,'enUS','','The Burning Legion is attacking Azeroth once again. The world is in chaos, but Deepholm faces a more urgent threat.$b$bI cannot go hunting jackals while wolves snarl at my doorstep!',26124),
(111618,'enUS','Meryl clears his throat and coughs.','',26124),
(111619,'enUS','Long live the Resistance!','Long live the Resistance!',26124),
(111620,'enUS','The Lotus shall bloom once more!','The Lotus shall bloom once more!',26124),
(111621,'enUS','Eviscerate the bourgeoisie!','Eviscerate the bourgeoisie!',26124),
(111622,'enUS','I think that cough is getting worse.','',26124),
(111623,'enUS','Hmm. Perhaps you should get some rest, Meryl.','',26124),
(111624,'enUS','You don\'t sound so good.','',26124),
(111626,'enUS','I feel as if I know you from somewhere, $n...','',26124),
(111627,'enUS','I have been hearing great things about you, $n.','',26124),
(111628,'enUS','Your skills are much discussed amongst the Kirin Tor, $n. I look forward to seeing you in action!','',26124),
(111629,'enUS','Meryl, please get some rest! $n, I hope to see you in Azsuna shortly.','',26124),
(111630,'enUS','','A silver hand was forged by Jotun, Tyr\'s dearest friend for many ages. When Tyr found proof of Loken\'s betrayal, it was Jotun who stayed behind to hold off the fallen watcher\'s pursuit.',26124),
(111631,'enUS','Yes, I think I will. Thank you for taking over for me, $n.','',26124),
(111632,'enUS','Meryl coughs and retches violently.','',26124),
(111633,'enUS','I\'ve perfected my murloc mindmeld technique over many years.','',26124),
(111634,'enUS','','Your friend sought out Jotun, but the Spark did not warn him of the cruel curse with which Loken twisted the watcher\'s mind. The paladin rushed to the chasm south of here, only to meet his doom.',26124),
(111635,'enUS','|TInterface\\Icons\\ability_hunter_pet_spider.blp:20|t %s calls for |cFFF00000|Hspell:212364|h[Feeding Time]|h|r.','|TInterface\\Icons\\ability_hunter_pet_spider.blp:20|t %s calls for |cFFF00000|Hspell:212364|h[Feeding Time]|h|r.',26124),
(111636,'enUS','','Hail.',26124),
(111637,'enUS','Is there something you require?','',26124),
(111638,'enUS','','Yes?',26124),
(111639,'enUS','The cruel caskmaster has breathed his last.','The cruel caskmaster has breathed his last.',26124),
(111640,'enUS','The saber prowls the plaza.','The saber prowls the plaza.',26124),
(111641,'enUS','The owl hoots at dusk.','The owl hoots at dusk.',26124),
(111642,'enUS','Khadgar, thank you for coming so quickly! He is declining rapidly!','',26124),
(111643,'enUS','Hmm. This illness is magical in nature. You were right to summon me, Ravandwyr.','',26124),
(111644,'enUS','','Say no more.',26124),
(111647,'enUS','','Let us begin. Come along, Theryn.',26124),
(111648,'enUS','','Understood.',26124),
(111650,'enUS','','Thalyssra, you cannot be serious? Wasting your time on this... creature!',26124),
(111653,'enUS','<The shadowy figure glimmers in the corner of your eye like a shade from a forgotten time. He does not react to your presence.>','<The shadowy figure glimmers in the corner of your eye like a shade from a forgotten time. She does not react to your presence.>',26124),
(111654,'enUS','Very well.','',26124),
(111655,'enUS','','Nar\'thala vas manari...',26124),
(111659,'enUS','Rrrgghhh...','',26124),
(111660,'enUS','','I\'ve been looking all over for you. Have you found... Oh, no...',26124),
(111661,'enUS','RrrggaaAAHHGGHH!! RAAGGGHH!','',26124),
(111662,'enUS','','I, too have felt it...',26124),
(111663,'enUS','','The day he was exiled...',26124),
(111664,'enUS','','This hunger... this fear...',26124),
(111665,'enUS','Unnngh...','',26124),
(111666,'enUS','<A ghostly figure rests on the stairway, a half-remembered shade from another time. He recognizes the staff you carry and nods towards you, grimly.>\n\nYou haven\'t changed your mind, Alodi? It doesn\'t trouble you that we\'re pouring all of our energy into that staff of yours?','',26124),
(111667,'enUS','','Such confusion... such rage...',26124),
(111668,'enUS','','Thalyssra! Are you alright?',26124),
(111669,'enUS','I seek the wisdom of the council.','I seek the wisdom of the council.',26124),
(111670,'enUS','Very well, mage. I will do as you ask... but please, be careful. No mortal has ever possessed such power.','',26124),
(111671,'enUS','','I am truly sorry. It looks as though your friend was crushed. What could have...',26124),
(111672,'enUS','Leave this place! Loken\'s curse compels me to slay the allies of Tyr. Until he comes to collect Tyr\'s spark, I must defend it!','',26124),
(111673,'enUS','','What is this essence the giant speaks of? I would have words with you, $n.',26124),
(111674,'enUS','','Tell me what is going on. What is it you seek, $n?',26124),
(111675,'enUS','Galford was the bearer of a spark of Tyr\'s essence. It seems Jotun killed him and took it. I need the spark to claim Tyr\'s warhammer.','Galford was the bearer of a spark of Tyr\'s essence. It seems Jotun killed him and took it. I need the spark to claim Tyr\'s warhammer.',26124),
(111676,'enUS','','A just cause. I shall stand with you against the might of Jotun, $n. Be ready!',26124),
(111677,'enUS','<The gnome flickers in the corner of your consciousness, a half-remembered shade from another time. His face lights up when he sees the staff in your hands.>\n\nIs it time, Alodi? Is your staff ready?','',26124),
(111678,'enUS','That\'s all I\'ve got, old friend. The Legion won\'t know what hit \'em!','',26124),
(111679,'enUS','I just read an interesting paper on the lowly kobold. Apparently, these creatures are more fierce than their visual affordance might suggest.','',26124),
(111680,'enUS','Fetch me a secondary reference on kobolds. I\'d like to verify this hypothesis.','',26124),
(111681,'enUS','Fascinating.','',26124),
(111682,'enUS','Of course, a more pressing concern to our academy is the constant encroachment of the skrogs.','',26124),
(111683,'enUS','Unfortunately, I\'m afraid that our library suffers a scarcity of information on these creatures.','',26124),
(111684,'enUS','Find me a book on skrogs. Anything will do.','',26124),
(111685,'enUS','Lastly, I\'d like to brush up on dragons. Blue dragons, to be precise.','',26124),
(111686,'enUS','<Is that... a dragon, languidly resting atop the greenhouse? The creature is there, and simultaneously not. She seems to be a memory from your staff, Ebonchill, and not part of this world. A draconic advisor from a forgotten time.>','',26124),
(111687,'enUS','We are currently on good terms with our northerly neighbors, but should our friendship wither, it can\'t hurt to know how they fight.','',26124),
(111688,'enUS','<You see a great blue dragon, resting languidly atop the greenhouse. She seems to be a memory from your staff, Ebonchill, and not part of this world. To your surprise, the mighty creature turns to face you, speaking slowly:>$b$bThe great Alodi returns, seeking ever more power. Tell me, mage, has the Council considered the impact of granting so much magical energy to a single mortal, hmmmm?$b$bAnd what if their beloved Guardian should ever betray them?$b$bI will be watching you...','',26124),
(111689,'enUS','I heard the spy is here and he\'s very good looking.','I heard the spy is here and he\'s very good looking.',26124),
(111690,'enUS','It seems like there are some new faces here at tonight\'s party...','It seems like there are some new faces here at tonight\'s party...',26124),
(111691,'enUS','Hmm, now I\'ve heard a juicy rumor about the party. I heard there\'s a Burning Legion spy here, making sure we\'re still loyal!','Hmm, now I\'ve heard a juicy rumor about the party. I heard there\'s a Burning Legion spy here, making sure we\'re still loyal!',26124),
(111692,'enUS','The one that Elisande invited to the party? Now I didn\'t say this, but that one is really a spy for the Burning Legion.','The one that Elisande invited to the party? Now I didn\'t say this, but that one is really a spy for the Burning Legion.',26124),
(111693,'enUS','Some are saying there\'s a member of the Burning Legion attending this party incognito...','Some are saying there\'s a member of the Burning Legion attending this party incognito...',26124),
(111694,'enUS','How exciting! There\'s supposedly a mystery guest out and about! Wait, what? A spy you say...','How exciting! There\'s supposedly a mystery guest out and about! Wait, what? A spy you say...',26124),
(111695,'enUS','A rumor about someone new to the party? I heard it\'s a member of the Burning Legion keeping tabs on us!','A rumor about someone new to the party? I heard it\'s a member of the Burning Legion keeping tabs on us!',26124),
(111696,'enUS','Be careful out there. There\'s a rumor the Burning Legion snuck a spy into the party.','Be careful out there. There\'s a rumor the Burning Legion snuck a spy into the party.',26124),
(111697,'enUS','Did you see all those demons outside? They are keeping an eye on us! There\'s a spy in here somewhere, I just know it.','Did you see all those demons outside? They are keeping an eye on us! There\'s a spy in here somewhere, I just know it.',26124),
(111698,'enUS','I heard somewhere that the spy isn\'t female.','I heard somewhere that the spy isn\'t female.',26124),
(111699,'enUS','A guest said she saw him entering the manor alongside the Grand Magistrix.','A guest said she saw him entering the manor alongside the Grand Magistrix.',26124),
(111700,'enUS','One of the musicians said he would not stop asking questions about the district.','One of the musicians said he would not stop asking questions about the district.',26124),
(111701,'enUS','They say that the spy is here and she\'s quite the sight to behold.','They say that the spy is here and she\'s quite the sight to behold.',26124),
(111702,'enUS','Someone\'s been saying that our new guest isn\'t male.','Someone\'s been saying that our new guest isn\'t male.',26124),
(111703,'enUS','A guest saw both her and Elisande arrive together earlier.','A guest saw both her and Elisande arrive together earlier.',26124),
(111704,'enUS','I hear some woman has been constantly asking about the district...','I hear some woman has been constantly asking about the district...',26124),
(111705,'enUS','I heard that the spy is wearing a lighter vest to tonight\'s party.','I heard that the spy is wearing a lighter vest to tonight\'s party.',26124),
(111706,'enUS','The spy definitely prefers the style of light colored vests.','The spy definitely prefers the style of light colored vests.',26124),
(111707,'enUS','I overheard the spy saying dark vests clash horridly with silver hair and to never be caught in one.','I overheard the spy saying dark vests clash horridly with silver hair and to never be caught in one.',26124),
(111708,'enUS','People are saying the spy is not wearing a darker vest tonight.','People are saying the spy is not wearing a darker vest tonight.',26124),
(111709,'enUS','The spy enjoys darker colored vests... like the night.','The spy enjoys darker colored vests... like the night.',26124),
(111710,'enUS','I heard the spy\'s vest is a dark, rich shade this very night.','I heard the spy\'s vest is a dark, rich shade this very night.',26124),
(111711,'enUS','Rumor has it the spy is avoiding light colored clothing to try and blend in more.','Rumor has it the spy is avoiding light colored clothing to try and blend in more.',26124),
(111712,'enUS','The spy definitely prefers darker clothing.','The spy definitely prefers darker clothing.',26124),
(111713,'enUS','I heard the spy always dons gloves.','I heard the spy always dons gloves.',26124),
(111714,'enUS','Someone said the spy wears gloves to cover obvious scars.','Someone said the spy wears gloves to cover obvious scars.',26124),
(111715,'enUS','There\'s a rumor that the spy always wears gloves.','There\'s a rumor that the spy always wears gloves.',26124),
(111716,'enUS','I heard the spy carefully hides their hands.','I heard the spy carefully hides their hands.',26124),
(111717,'enUS','I heard the spy dislikes wearing gloves.','I heard the spy dislikes wearing gloves.',26124),
(111718,'enUS','There\'s a rumor that the spy never has gloves on.','There\'s a rumor that the spy never has gloves on.',26124),
(111719,'enUS','You know... I found an extra pair of gloves in the back room. The spy is likely to be bare handed somewhere around here.','You know... I found an extra pair of gloves in the back room. The spy is likely to be bare handed somewhere around here.',26124),
(111720,'enUS','I heard the spy avoids having gloves on, in case some quick actions are needed.','I heard the spy avoids having gloves on, in case some quick actions are needed.',26124),
(111721,'enUS','I didn\'t tell you this... but the spy is masquerading as an alchemist and carrying potions at the belt.','I didn\'t tell you this... but the spy is masquerading as an alchemist and carrying potions at the belt.',26124),
(111722,'enUS','I heard the spy brought along some potions... just in case.','I heard the spy brought along some potions... just in case.',26124),
(111723,'enUS','I think I saw the spy with a green potion on the belt.','I think I saw the spy with a green potion on the belt.',26124),
(111724,'enUS','Someone told me the spy arrived carrying a green flask of some sort. I wonder what that would be for?','Someone told me the spy arrived carrying a green flask of some sort. I wonder what that would be for?',26124),
(111725,'enUS','I heard the spy brought along potions, I wonder why?','I heard the spy brought along potions, I wonder why?',26124),
(111726,'enUS','I\'m pretty sure the spy has potions at the belt.','I\'m pretty sure the spy has potions at the belt.',26124),
(111727,'enUS','You leave me no choice! I must destroy you!','',26124),
(111728,'enUS','You are strong! Perhaps you can end my unceasing vigil.','',26124),
(111729,'enUS','The pain! It frees my mind of the curse... for the moment.','',26124),
(111730,'enUS','Loken\'s enchantment won\'t let me die. We have only a moment before I fall into madness again.','',26124),
(111731,'enUS','Here is the spark. Take it and flee! Keep the memory of my fallen friend alive.','',26124),
(111732,'enUS','For Tyr!','',26124),
(111733,'enUS','I heard the spy carries a magical pouch around at all times.','I heard the spy carries a magical pouch around at all times.',26124),
(111734,'enUS','I heard the spy\'s belt pouch is lined with fancy threading.','I heard the spy\'s belt pouch is lined with fancy threading.',26124),
(111735,'enUS','I heard the spy is not carrying any potions around.','I heard the spy is not carrying any potions around.',26124),
(111736,'enUS','A friend of mine managed to steal a pink potion off the belt of the spy earlier. Wherever the spy is now, he or she definitely does not have any pink potions!','A friend of mine managed to steal a pink potion off the belt of the spy earlier. Wherever the spy is now, he or she definitely does not have any pink potions!',26124),
(111737,'enUS','Rumor has is the spy loves to read and always carries around at least one book.','Rumor has is the spy loves to read and always carries around at least one book.',26124),
(111738,'enUS','I heard the spy always has a book of written secrets at the belt.','I heard the spy always has a book of written secrets at the belt.',26124),
(111739,'enUS','I heard the spy\'s belt pouch is filled with gold to show off extravagance.','I heard the spy\'s belt pouch is filled with gold to show off extravagance.',26124),
(111740,'enUS','A friend said the spy loves gold and a belt pouch filled with it.','A friend said the spy loves gold and a belt pouch filled with it.',26124),
(111741,'enUS','So be it. Turn this great power against the foes of Tirisfal!','',26124),
(111742,'enUS','These lamps guided me to this place. I only hope the path on my return is safe...','These lamps guided me to this place. I only hope the path on my return is safe...',26124),
(111743,'enUS','A musician told me she saw the spy throw away their last potion and no longer has any left.','A musician told me she saw the spy throw away their last potion and no longer has any left.',26124),
(111744,'enUS','I heard the spy is not carrying any green potions.','I heard the spy is not carrying any green potions.',26124),
(111745,'enUS','I heard the spy\'s outfit has long sleeves tonight.','I heard the spy\'s outfit has long sleeves tonight.',26124),
(111746,'enUS','I just barely caught a glimpse of the spy\'s long sleeves earlier in the evening.','I just barely caught a glimpse of the spy\'s long sleeves earlier in the evening.',26124),
(111747,'enUS','A friend of mine mentioned the spy has long sleeves on.','A friend of mine mentioned the spy has long sleeves on.',26124),
(111748,'enUS','Someone said the spy is covering up their arms with long sleeves tonight.','Someone said the spy is covering up their arms with long sleeves tonight.',26124),
(111749,'enUS','I heard the spy enjoys the cool air and is not wearing long sleeves tonight.','I heard the spy enjoys the cool air and is not wearing long sleeves tonight.',26124),
(111750,'enUS','I heard the spy wears short sleeves to keep their arms unencumbered.','I heard the spy wears short sleeves to keep their arms unencumbered.',26124),
(111751,'enUS','A friend of mine said she saw the outfit the spy was wearing. It did not have long sleeves.','A friend of mine said she saw the outfit the spy was wearing. It did not have long sleeves.',26124),
(111752,'enUS','Someone told me the spy hates wearing long sleeves.','Someone told me the spy hates wearing long sleeves.',26124),
(111753,'enUS','I heard the spy enjoys wearing capes.','I heard the spy enjoys wearing capes.',26124),
(111754,'enUS','Someone mentioned the spy came in earlier wearing a cape.','Someone mentioned the spy came in earlier wearing a cape.',26124),
(111755,'enUS','','<A shadowy figure sits peacefully in the park, like a half-forgotten memory of a long-dead figure from the past. She seems to recognize your staff and greets you warmly, believing you to be someone else.>$b$bHello Alodi, old friend! Join me, would you? One of life\'s most sublime pleasures is sitting in a park with a familiar old book.$b$bI think I shall plant a sapling here, so that in the years to come mages can sit beneath the shade of a small tree.',26124),
(111756,'enUS','I heard the spy dislikes capes and refuses to wear one.','I heard the spy dislikes capes and refuses to wear one.',26124),
(111757,'enUS','I heard that the spy left their cape in the palace before coming here.','I heard that the spy left their cape in the palace before coming here.',26124),
(111758,'enUS','','I will help if I must. You\'ve concentrated so much power into that staff - I worry what will become of you!',26124),
(111759,'enUS','','If you desire, I can take you back to your city in the sky. I will return later for Galford\'s remains.',26124),
(111760,'enUS','We are with you, champion. Let us end this beast!','',26124),
(111761,'enUS','I am Tyr\'s Guard. We are a secret order of paladins that have been guarding a great secret for a very long time. Unfortunately current events have caused us to end our secrecy.','',26124),
(111762,'enUS','A secret order?','A secret order?',26124),
(111763,'enUS','','<A ghostly shade lingers in the citadel, a long-dead memory from Dalaran\'s past. The slender figure recognizes your staff and mistakes you for someone else. She lazily looks you over through half-lidded eyes.>$b$bArchmage Alodi. You go to face Kathra\'natir, then? The rest of the council ignores my warnings.$b$bVery well. I will not stop your suicide. If you seek to add my power to yours, you need only ask.$b$b<Fiora sips her wine, sadly, and does not look you in the eye.>',26124),
(111764,'enUS','','Very well. Make this count, mage.',26124),
(111765,'enUS','','The Legion has captured a clutch of Stellagosa\'s azure whelplings! Save them, so our ally\'s brood may grow stronger!',26124),
(111766,'enUS','','Those whelps were so small, so helpless. How despicable of the Legion to prey upon the weak!',26124),
(111767,'enUS','','Each Legion detachment draws power from a soul engine. Incapacitate the demons\' vile machine and slay the eredar who maintain it!',26124),
(111768,'enUS','','Outstanding! They must make repairs before their soul engine can re-engage. You have bought us valuable time.',26124),
(111769,'enUS','','We can brew a powerful draught of demon detection with the right pile of entrails. Collect them for me, and together we will retake Faronaar!',26124),
(111770,'enUS','','You certainly don\'t shy away from the dirty work. Well done.',26124),
(111771,'enUS','','Sometimes I wish Garuhod\'s research called for less... distasteful reagents. Alas, these will do. Thank you.',26124),
(111772,'enUS','So arrogant are the Legion that they defile my lands and think themselves safe.','',26124),
(111773,'enUS','Their forces are massing in Faronaar. Strike there, and cripple them before they move deeper into Azsuna!','',26124),
(111774,'enUS','You have shown the Legion that they will be hunted anywhere they dare tread in Azsuna. Excellent work!','',26124),
(111775,'enUS','[CUT] Day 20: Captured a new subject today. Number 16. He seems different somehow.','',26124),
(111776,'enUS','<A half-remembered shadow lurks in the rear of the tavern, nosing through scrolls. The high-elf is a memory from another time. He recognizes your staff and greets you as an equal.>\n\nThe moment of truth arrives. Are you ready, Alodi? Are you certain that you can handle so much power?','',26124),
(111777,'enUS','Whoa... I didn\'t expect the queen to show up... I\'ll get you out of there. Hang on!','',26124),
(111778,'enUS','In time we must all face our demons. Better you than me.','',26124),
(111779,'enUS','','<A shadowy image of a gnome floats before you, a distant memory from the past. She is concentrating on a powerful spell, but mistakes you for someone else as you approach.>\n\nAlodi! You\'ve returned. Let me see that staff of yours. Yes, yes... I can help you, of course. But you should hear what the rest of the council is saying behind your back. You\'re lucky they need you.',26124),
(111780,'enUS','Watch out!','',26124),
(111781,'enUS','Tick, tock!','',26124),
(111782,'enUS','','I hope you know what you\'re doing. But if not... At least we\'re in for some fireworks. Good luck out there!',26124),
(111783,'enUS','Portal coming up!','',26124),
(111784,'enUS','','South gate! Another demon in the fields!',26124),
(111785,'enUS','Your souls are so easily corrupted, mortals.','',26124),
(111786,'enUS','Gonna BASH you!','',26124),
(111787,'enUS','Demon heading for the wall to the northeast!','',26124),
(111788,'enUS','Today, we dealt a great blow to the unseen enemies of the Nightmare.','',26124),
(111790,'enUS','However, Xavius, Lord of the Nightmare, still lives. Only when he is defeated, will Azeroth truly be safe.','',26124),
(111791,'enUS','This is perfectly safe! Oh, right... watch out for spiders down there. Whatever you do, don\'t cut yourself down from the rope!','',26124),
(111792,'enUS','To accomplish this task, I gift you with my blessing. Use my power to serve and protect the wilds.','',26124),
(111793,'enUS','Thank you, druids of the Dreamgrove. May you prosper under the leadership of your new Archdruid.','',26124),
(111794,'enUS','Farewell.','',26124),
(111796,'enUS','The years have not been kind to me, $n.$b$b<Fillmaff coughs, weakly.>$b$bI think I may be dead.','',26124),
(111797,'enUS','Wait. Is that a journal you\'ve found? That may be what we are looking for!','',26124),
(111798,'enUS','Until we meet again.','',26124),
(111799,'enUS','','Our Hippogryphs have been well fed and are ready to take you anywhere.',26124),
(111805,'enUS','It is always a pleasure to be able to stretch my wings!','',26124),
(111806,'enUS','It is always a pleasure to be able to stretch my wings! Are you ready to go?','',26124),
(111807,'enUS','I\'m ready. Let\'s go!','I\'m ready. Let\'s go!',26124),
(111808,'enUS','Not yet. I need more time.','Not yet. I need more time.',26124),
(111809,'enUS','It\'s days like these that make me long for the comforts of home.','',26124),
(111810,'enUS','Can I help you?','',26124),
(111811,'enUS','This is the head of the beast that killed your mage.','This is the head of the beast that killed your mage.',26124),
(111812,'enUS','','Let us move on.',26124),
(111813,'enUS','','Dismiss these memories so we can proceed.',26124),
(111814,'enUS','','I am losing control...',26124),
(111815,'enUS','Where did you find this beast? I\'ve never seen one quite like it.$B$BTo the untrained eye, this felhound may look like any other minion, but a close examination of its jaw shows an extra set of razor-sharp teeth.$B$BIt is clear to me now that this is the beast that is responsible for the death of our companion.$B$BPlease apologize to Hilaire for the mix up. We can\'t be too careful these days.','',26124),
(111816,'enUS','','That is precisely what I am doing.',26124),
(111817,'enUS','Lenora, release the beast. It poses no threat to us.','',26124),
(111818,'enUS','','We should be planning our attack on Suramar!',26124),
(111819,'enUS','The Dreamweavers have watched over this grove for eons. We follow the path of Cenarius, and protect the forests of Val\'sharah.','',26124),
(111820,'enUS','Many of our order still remember when Shaladrassil first took root. We\'ve watched it grow over the ages, until it has towered over this vale. We have been blessed to live under the shade of its branches for so long.','',26124),
(111821,'enUS','To understand nature is to understand the great cycle of all things. A blooming flower will someday return to the earth to fuel new seeds. The sun sets each day, to rise again and give new life. Our order is dedicated to understanding and preserving the continuation of this pattern.','',26124),
(111822,'enUS','Do you know of \"alara\'shinu,\" druid? It means finding beauty in imperfection. Those who live by this philosophy understand the transience of nature, accept the cycle of life and death, and derive joy from this truth.','',26124),
(111823,'enUS','Be at peace while you rest here. The Dreamgrove is sanctuary to all of our kind.','',26124),
(111824,'enUS','The Dreamweavers care not for your mortal differences, $r. Here, we are druids. Here, we are united toward a common cause.','',26124),
(111825,'enUS','Meryl coughs and shivers feverishly.','',26124),
(111826,'enUS','Meryl is wracked by a violent coughing fit.','',26124),
(111827,'enUS','|TInterface\\Icons\\sha_spell_fire_blueimmolation_nightmare:20|tYou are afflicted with |cFFFF0000|Hspell:211471|h[Scorned Touch]|h|r!','',26124),
(111828,'enUS','Meryl groans and clutches his stomach.','',26124),
(111829,'enUS','Meryl chokes and coughs up bile.','',26124),
(111832,'enUS','It\'s broken free! Run for your lives! It\'s... It\'s... NUTZ!','',26124),
(111837,'enUS','','It should fool the gibbering, wine-soaked guests, but a keen eye could see through it. Should the illusion falter, the guards will quickly descend upon you.',26124),
(111838,'enUS','Go ahead. I\'m ready for my disguise.','Go ahead. I\'m ready for my disguise.',26124),
(111839,'enUS','','That is an incredibly dangerous proposition you are making. How do I know you truly speak for Vanthir?',26124),
(111840,'enUS','Snowfeather swoops down from the sky.','',26124),
(111841,'enUS','<Show your Sigil.>','<Display your allegiance.>',26124),
(111842,'enUS','Archmage Vargoth shivers and mutters something unintelligible under his breath.','',26124),
(111843,'enUS','I... I am needed elsewhere.','',26124),
(111844,'enUS','Master Bilebrain! The enemy... they are advancing!','',26124),
(111845,'enUS','Silence! You waste my time with these constant interruptions!','',26124),
(111846,'enUS','We leave the master! No more mean Bilebrain.','',26124),
(111847,'enUS','','(CUT)',26124),
(111848,'enUS','Always helpful, Ishpip, but Master only yells...','',26124),
(111849,'enUS','','(CUT)',26124),
(111850,'enUS','No! Master finds us, turns us to meat!','',26124),
(111851,'enUS','Take the Windmaster\'s Totem.','Take the Windmaster\'s Totem.',26124),
(111852,'enUS','I might be interested in what you have to say... with the right motivation.','',26124),
(111853,'enUS','<Show Arluin your Sigil.>','<Show Arluin your Sigil.>',26124),
(111857,'enUS','','Are you ready to enter the ring and earn glory in neverending combat?',26124),
(111859,'enUS','','Look at their wittle faces! They\'re so cute I\'m going to die!',26124),
(111860,'enUS','','You\'re all bark and no bite.',26124),
(111861,'enUS','','Teehee!',26124),
(111862,'enUS','','I\'m going to give you guys the wittle bandages for your wittle boo-boos!',26124),
(111863,'enUS','','Salty?',26124),
(111864,'enUS','','Corgis. Am I right?',26124),
(111865,'enUS','','Woof.',26124),
(111866,'enUS','','But he was so cute!',26124),
(111867,'enUS','','You\'re a monster!',26124),
(111868,'enUS','','Aww.',26124),
(111870,'enUS','T-traitors...','',26124),
(111871,'enUS','','The sooner I am back in the city, the better.',26124),
(111872,'enUS','Go on...','Go on...',26124),
(111873,'enUS','Don\'t be coy. I know you\'re here to spy for the Grand Magistrix.','Don\'t be coy. I know you\'re here to spy for the Grand Magistrix.',26124),
(111874,'enUS','How dare you accuse me of such a thing, $n? Do you know who I am? I don\'t recognize you at all...','How dare you accuse me of such a thing, $n? Do you know who I am? I don\'t recognize you at all...',26124),
(111875,'enUS','Now now, let\'s not be hasty $n. Why don\'t you follow me so we can talk about this in a more private setting...','Now now, let\'s not be hasty $n. Why don\'t you follow me so we can talk about this in a more private setting...',26124),
(111876,'enUS','Move along, friend. I have no business with you.','Move along, friend. I have no business with you.',26124),
(111877,'enUS','I need a flight to Ashamane\'s Fall.','I need a flight to Ashamane\'s Fall.',26124),
(111878,'enUS','Suramar be eternal, friend.','Suramar be eternal, friend.',26124),
(111879,'enUS','This is quite the party, isn\'t it?','This is quite the party, isn\'t it?',26124),
(111880,'enUS','The musicians are quite good, aren\'t they?','The musicians are quite good, aren\'t they?',26124),
(111881,'enUS','You insult my honor, $n. Who exactly are you?','You insult my honor, $n. Who exactly are you?',26124),
(111882,'enUS','$n, you think I would spy on my own? Maybe we should look closer at you instead!','$n, you think I would spy on my own? Maybe we should look closer at you instead!',26124),
(111883,'enUS','Well I never! $n, who do you think you are?!','Well I never! $n, who do you think you are?!',26124),
(111884,'enUS','<The Hippogryph looks at you for a moment and screeches.>','',26124),
(111885,'enUS','I want to head back to the Dreamgrove.','I want to head back to the Dreamgrove.',26124),
(111886,'enUS','I don\'t know how you found me out, but now it\'s time to die!','I don\'t know how you found me out, but now it\'s time to die!',26124),
(111887,'enUS','Most shamans prefer wolves, but this one prefers... corgis? You might think she\'s barking up the wrong tree, but she\'s beaten every doggone challenger so far! Who will take down these pugnacious pups?','',26124),
(111888,'enUS','That battle was one part skill, one part strategy, and ten parts adorable! Keep this up kid, you\'re going places... and making me a pile of gold in the process!','',26124),
(111889,'enUS','Scary...','',26124),
(111891,'enUS','I recognize those blades of yours, $n. They cut the throat of my King and my friend. Please... put them away in these chambers.','',26124),
(111892,'enUS','$n, those daggers you wield - the very same that killed Llane Wrynn in cold blood. The sight of them takes me to a dark place.','',26124),
(111893,'enUS','Are those indeed Garona\'s old daggers, $n? I saw her tear apart a demon in the Karazhan library once with those very blades. If I had only known what was to come...','',26124),
(111894,'enUS','','I live to serve the Magistrix and her people.',26124),
(111895,'enUS','','Glory to the Shal\'dorei.',26124),
(111896,'enUS','','How may I serve you?',26124),
(111897,'enUS','','You may call upon my services at any time.',26124),
(111898,'enUS','I need to speak to Overseer Elvire.','I need to speak to Overseer Elvire.',26124),
(111899,'enUS','Monsters...','',26124),
(111900,'enUS','Ahhh!','',26124),
(111901,'enUS','Let\'s play somewhere else for a while.','',26124),
(111902,'enUS','Don\'t eat me!','',26124),
(111903,'enUS','What is Elisande thinking, letting them in?','',26124),
(111904,'enUS','Hide! They\'ll eat you!','',26124),
(111905,'enUS','Your vile magic is an abomination!','',26124),
(111906,'enUS','I told you the shrine isn\'t safe! Look at what your stubbornness has caused!','',26124),
(111907,'enUS','Hey!','Hey!',26124),
(111908,'enUS','You. Me. By the flagpole. After class.','You. Me. By the flagpole. After class.',26124),
(111909,'enUS','','I only do as I am told! Don\'t hurt me!',26124),
(111910,'enUS','','$n! Is it true you wield the Kingslayers? When I was just a girl, my gran told me the stories. The King of Stormwind grasping at his throat, red blood spattered on the white stones of the keep... I would hide under my covers at night, thinking assassins were everywhere.',26124),
(111911,'enUS','Watch where you\'re wanding!','Watch where you\'re wanding!',26124),
(111912,'enUS','I\'m trying to study over here.','I\'m trying to study over here.',26124),
(111913,'enUS','Mrs. Azuremoon! $n is wanding me!','Mrs. Azuremoon! $n is wanding me!',26124),
(111914,'enUS','Ca-caaw!','',26124),
(111915,'enUS','Ow!','Ow!',26124),
(111916,'enUS','Quit it!','Quit it!',26124),
(111917,'enUS','You\'re gonna get in trouble if you keep doing that.','You\'re gonna get in trouble if you keep doing that.',26124),
(111918,'enUS','','Don\'t forget to aim before you fire.',26124),
(111919,'enUS','','That\'s it. I\'m giving you a zero for the day.',26124),
(111920,'enUS','','That\'s minus fifty points for shooting the teacher.',26124),
(111921,'enUS','','Keep this up and I\'ll have to give you extra homework.',26124),
(111922,'enUS','My word.','',26124),
(111923,'enUS','Good gracious, mind your wand fire.','',26124),
(111924,'enUS','We\'re not here to have fun, underclassman. We\'re here to learn.','',26124),
(111925,'enUS','No horseplay in the study hall!','',26124),
(111926,'enUS','Now is not the time for this, Verstok! We must tend to our wounded.','',26124),
(111927,'enUS','I can see why Arluin put his faith in you. Give him our regards.','I can see why Arluin put his faith in you. Give him our regards.',26124),
(111928,'enUS','$n! Are those truly the Kingslayer daggers you carry? I know a few collectors who would pay a pretty penny for those particular pieces of history. I can connect you... for a small finder\'s fee, obviously...','',26124),
(111929,'enUS','Would you mind? I\'m working on a very important paper, and it\'s difficult to concentrate with you neophytes shooting everything in sight.','',26124),
(111930,'enUS','What do you need?','',26124),
(111931,'enUS','How can the Light serve?','',26124),
(111932,'enUS','Let me show you the Light.','',26124),
(111933,'enUS','The Light redeems.','',26124),
(111934,'enUS','Go with the Light.','',26124),
(111935,'enUS','I am the Light\'s vengeance.','',26124),
(111936,'enUS','Woe befalls the heretic.','',26124),
(111937,'enUS','Tell me who to smite and they shall be smoten!','',26124),
(111938,'enUS','I find your lack of faith disturbing.','',26124),
(111939,'enUS','The location is secured. The delivery can proceed as scheduled.','The location is secured. The delivery can proceed as scheduled.',26124),
(111940,'enUS','Naturally. I took a circuitous route through the city.','Naturally. I took a circuitous route through the city.',26124),
(111941,'enUS','For the Grand Magistrix.','For the Grand Magistrix.',26124),
(111942,'enUS','','I trust you were careful to deter any pursuers?',26124),
(111943,'enUS','','Excellent. The shipment will proceed as scheduled, then. It will be delivered to the docks within the hour. See that it is not left unattended. There have been far too many thefts lately.',26124),
(111944,'enUS','','Glory to Elisande.',26124),
(111945,'enUS','Get moving!','',26124),
(111946,'enUS','I best be returnin\' later, mon.','',26124),
(111947,'enUS','Best be comin\' back when its safe.','',26124),
(111948,'enUS','I\'ll see you soon, $n.','',26124),
(111949,'enUS','Brave of you, $n. I be returnin\' soon.','',26124),
(111950,'enUS','Kind of you, brave one, but I\'m no great warrior.','',26124),
(111951,'enUS','','Your words carry the tone of a great $c, $n. May the Earth mother watch over you.',26124),
(111952,'enUS','Can\'t be stickin\' round here, $n!','',26124),
(111953,'enUS','Shops closed! I\'ll be back when it\'s safe.','',26124),
(111954,'enUS','If my blades were sharper I\'d stay for a little fun.','',26124),
(111955,'enUS','Hey, watch it!','',26124),
(111956,'enUS','Yes, I have the lasher seed from the roots below Shaladrassil.','',26124),
(111957,'enUS','Take the seed and plant it in the dirt right over here.','',26124),
(111958,'enUS','Those are the Kingslayer daggers, aren\'t they $n? My father served King Llane Wrynn in the first war, before those very daggers took the King\'s life.','',26124),
(111959,'enUS','Sometimes it is best to allow the past remain in the past.','',26124),
(111960,'enUS','Says you. If I ever meet Garona, I will strangle her myself.','',26124),
(111961,'enUS','I can\'t miss!','',26124),
(111962,'enUS','Here comes the BOOM!','',26124),
(111963,'enUS','You\'ve stumbled right into my traps!','',26124),
(111964,'enUS','$n, we\'re launching a full assault on Broken Shore.  Before we hit the shore, we need every soldier to be combat ready.\n\nAre you ready for your combat training?','$n, we\'re launching a full assault on Broken Shore.  Before we hit the shore, we need every soldier to be combat ready.\n\nAre you ready for your combat training?',26124),
(111965,'enUS','[OLD] I am ready to begin.','[OLD] I am ready to begin.',26124),
(111966,'enUS','General!','',26124),
(111967,'enUS','We\'ve got incoming!  Look out!','',26124),
(111968,'enUS','Incoming! We\'re under attack!','',26124),
(111969,'enUS','Caw! Caaaaaw!','',26124),
(111970,'enUS','Caaw ca-caw.','',26124),
(111971,'enUS','Caw? Caaaaw!','',26124),
(111972,'enUS','Oh thank you! Thank you, strong one! I help, you see!','',26124),
(111973,'enUS','This one\'s debt is paid... paid it is! Away!','',26124),
(111974,'enUS','Hey! Watch it!','',26124),
(111975,'enUS','The stupid one stays in the jar! So stupid! It angers master!','',26124),
(111976,'enUS','Hush, they are nearby.','',26124),
(111977,'enUS','The Nightborne falls silent.','The Nightborne falls silent.',26124),
(111978,'enUS','We cannot endure your presence any longer!','',26124),
(111979,'enUS','Enough! Get out of our city!','',26124),
(111980,'enUS','You are living up to your reputation, $n. Thank you for handling my duties while I am indisposed.','',26124),
(111981,'enUS','The recent events and Meryl\'s illness are most distressing. I\'m glad we have you to rely on, $n!','',26124),
(111982,'enUS','You are proving yourself to be a very capable member of the Tirisgarde, $n!','',26124),
(111983,'enUS','|TInterface\\Icons\\ability_socererking_arcaneacceleration|t%s begins to cast |cFFFF0000|Hspell:207278|h[Arcane Lockdown]|h|r! Jump to remove the effect!','',26124),
(111984,'enUS','','It seems we have an accord, then. Shall I fetch your diamond?',26124),
(111985,'enUS','Yes.','Yes.',26124),
(111986,'enUS','The world will cry out in anger against us, but the air that fills their lungs will have been bought with the price of our souls.','',26124),
(111987,'enUS','Hmmm. Something isn\'t right...','',26124),
(111988,'enUS','','Watch out up here. I\'ve heard tell of a demonic council that draws strength from one another. This bond must be broken.',26124),
(111989,'enUS','','Explore the area and find a way to separate the council members. Divided, they cannot stand against you!',26124),
(111990,'enUS','Enough! We will hunt later.','',26124),
(111992,'enUS','Hm, have we met before? Your face is quite familiar.\n\nOh! You are the hero I\'ve been hearing so much about. You are most impressive...','',26124),
(111993,'enUS','Archmage Vargoth looks into the distance.','',26124),
(111994,'enUS','Archmage Vargoth\'s fingers twitch spasmodically.','',26124),
(111995,'enUS','Archmage Vargoth suddenly loses his balance and lurches to one side.','',26124),
(111996,'enUS','','My informants claim that a Burning Legion spy is attending this party.',26124),
(111997,'enUS','','Speaking with chatty nobles may reveal the spy. Just avoid drawing attention to yourself with wild accusations!',26124),
(111998,'enUS','Caaaw?','',26124),
(111999,'enUS','Caaaaaaw!','',26124),
(112000,'enUS','Just visiting?','',26124),
(112001,'enUS','Welcome to the Violet Hold.','',26124),
(112002,'enUS','Nothing escapes these walls.','',26124),
(112003,'enUS','Good.','',26124),
(112004,'enUS','So be it.','',26124),
(112005,'enUS','Well then.','',26124),
(112007,'enUS','My life for Kalimdor.','',26124),
(112008,'enUS','I\'m awake... for now','',26124),
(112009,'enUS','The balance must be restored.','',26124),
(112010,'enUS','We will protect the wilds.','',26124),
(112011,'enUS','May your dreams be peaceful','',26124),
(112012,'enUS','Elune\'s light watch over you.','',26124),
(112013,'enUS','Goodbye, for now.','',26124),
(112014,'enUS','This too, shall pass.','',26124),
(112015,'enUS','I am the one who dreams.','',26124),
(112016,'enUS','I can be your worst nightmare.','',26124),
(112017,'enUS','Just let me go back to sleep...','',26124),
(112018,'enUS','Every waking moment with you is agony.','',26124),
(112019,'enUS','','Your spirit burns bright.',26124),
(112020,'enUS','','I won\'t be forsakin\' Gonk\'s blessing.',26124),
(112021,'enUS','','There be life all around, life worth savin\'.',26124),
(112022,'enUS','','The loa give, and they be takin\' away.',26124),
(112023,'enUS','','Don\'t be angerin\' the spirits.',26124),
(112024,'enUS','','Walk in the path of the loa.',26124),
(112025,'enUS','','Peace to ya.',26124),
(112026,'enUS','','I\'ve got your back.',26124),
(112027,'enUS','','Why you be botherin\' me like this?',26124),
(112028,'enUS','','You won\'t be likin\' me when I\'m angry.',26124),
(112029,'enUS','','This be ya last warnin\'!',26124),
(112030,'enUS','','<snarl>',26124),
(112031,'enUS','','My strength is yours.',26124),
(112032,'enUS','','Where shall I strike?',26124),
(112033,'enUS','','I could use a bit of sleep.',26124),
(112034,'enUS','','What?',26124),
(112035,'enUS','','Yeah, yeah.',26124),
(112036,'enUS','','Let\'s bounce.',26124),
(112037,'enUS','','Ande\'thoras-ethil.',26124),
(112038,'enUS','','Of course.',26124),
(112039,'enUS','','Are we really doing this?',26124),
(112040,'enUS','','I\'d rather be hibernating.',26124),
(112041,'enUS','We must safeguard the land.','',26124),
(112042,'enUS','My vigil is eternal.','',26124),
(112043,'enUS','Nature is restless.','',26124),
(112044,'enUS','How may I aid you?','',26124),
(112045,'enUS','Do not stray from the path ahead.','',26124),
(112046,'enUS','Good luck.','',26124),
(112047,'enUS','By the wisdom of Cenarius.','',26124),
(112048,'enUS','Until we next meet.','',26124),
(112049,'enUS','Don\'t let the doe hit you on the way out.','',26124),
(112050,'enUS','','How may I help you?',26124),
(112051,'enUS','','Always respect the wilds.',26124),
(112052,'enUS','','It is nice to see you.',26124),
(112053,'enUS','','The forest spoke of your coming.',26124),
(112054,'enUS','','Do not abandon our ways.',26124),
(112055,'enUS','','We will rebuild.',26124),
(112056,'enUS','','Take care.',26124),
(112057,'enUS','','Farewell.',26124),
(112058,'enUS','','I do enjoy these long chats.',26124),
(112059,'enUS','','Why don\'t you ever call?',26124),
(112060,'enUS','','Perhaps I should put the kettle on?',26124),
(112061,'enUS','','Tea\'s ready!',26124),
(112062,'enUS','','It seems the Duskwatch are charged with keeping order during the party. Might I suggest the hidden approach?',26124),
(112063,'enUS','May the winds guide you.','',26124),
(112064,'enUS','We serve the land.','',26124),
(112065,'enUS','Always temper your strength with wisdom.','',26124),
(112066,'enUS','Nature seeks balance in all things.','',26124),
(112067,'enUS','Farewell.','',26124),
(112068,'enUS','Earth mother watch over you.','',26124),
(112069,'enUS','Nature is resilient.','',26124),
(112070,'enUS','A single thought is worth many actions.','',26124),
(112071,'enUS','I may be old, but my senses remain sharp.','',26124),
(112072,'enUS','You temper your persistence with recklessness.','',26124),
(112073,'enUS','Life... hm, life... finds a way.','',26124),
(112074,'enUS','There is much at \"steak\" here.','',26124),
(112075,'enUS','','Along the way, you\'ll want to disable their arcane beacons and keep the sentries from raising the alarm.',26124),
(112076,'enUS','','All life is precious.',26124),
(112077,'enUS','','How may I help?',26124),
(112078,'enUS','','The mother tree\'s gifts are everywhere.',26124),
(112079,'enUS','','Elune-Adore.',26124),
(112080,'enUS','','In G\'Hanir\'s name.',26124),
(112081,'enUS','','May Aviana\'s wind guide you.',26124),
(112082,'enUS','','Ande\'thoras-ethil.',26124),
(112083,'enUS','','Farewell.',26124),
(112084,'enUS','','Yes?',26124),
(112085,'enUS','','Hi!',26124),
(112086,'enUS','','Surely there are more important matters that require your attention.',26124),
(112087,'enUS','','Do not waste nature\'s gifts.',26124),
(112088,'enUS','','The little creatures need our help.',26124),
(112089,'enUS','','How can I help?',26124),
(112090,'enUS','','I guarded G\'Hanir for thousands of years. You\'re going to have to try harder than that.',26124),
(112091,'enUS','','The trees need our aid.',26124),
(112092,'enUS','','Making trails.',26124),
(112093,'enUS','','I\'m game',26124),
(112094,'enUS','','Fine. You want to see me mad? I\'ll show you mad!',26124),
(112095,'enUS','','See ya later!',26124),
(112096,'enUS','','Take care!',26124),
(112097,'enUS','','D\'oh!',26124),
(112100,'enUS','','I\'m not the dryad you\'re looking for.',26124),
(112102,'enUS','','I need to hug a bunny... RIGHT NOW!',26124),
(112106,'enUS','','Can I - sniff - help you?',26124),
(112113,'enUS','','B-bye...',26124),
(112115,'enUS','The skies call out for aid.','',26124),
(112116,'enUS','Aviana bless you.','',26124),
(112117,'enUS','Even the smallest details matter.','',26124),
(112118,'enUS','My eyes are sharp.','',26124),
(112119,'enUS','If we fall, we fall together.','',26124),
(112120,'enUS','There is always hope.','',26124),
(112121,'enUS','We must soar above calamity.','',26124),
(112122,'enUS','May the winds favor your flight.','',26124),
(112123,'enUS','I did not study for this.','',26124),
(112124,'enUS','No more. Begone.','',26124),
(112125,'enUS','I wonder, what exactly does \'no\' mean to you?','',26124),
(112126,'enUS','We must agree to disagree.','',26124),
(112127,'enUS','What do you ask of nature?','',26124),
(112128,'enUS','Do you need my aid?','',26124),
(112129,'enUS','Nature\'s gifts are everywhere.','',26124),
(112130,'enUS','We are nature\'s guardians.','',26124),
(112131,'enUS','Go with Cenarius\' blessing.','',26124),
(112132,'enUS','Walk in peace.','',26124),
(112133,'enUS','May your trail be clear.','',26124),
(112134,'enUS','|TInterface\\Icons\\Spell_Fire_FelFlameStrike:20|t %s begins to cast |cFFFF0000|Hspell:206220|h[Empowered Liquid Hellfire]|h|r.','',26124),
(112135,'enUS','','I don\'t carry much, but sometimes I have what you need.',26124),
(112136,'enUS','I\'m yer dwarf.','',26124),
(112137,'enUS','Nice day, eh?','',26124),
(112138,'enUS','There\'s always another adventure.','',26124),
(112139,'enUS','We\'re in this together.','',26124),
(112140,'enUS','We\'re never alone.','',26124),
(112141,'enUS','Keep your wits about ye.','',26124),
(112142,'enUS','See ya later!','',26124),
(112143,'enUS','Talk to ye soon.','',26124),
(112144,'enUS','First round\'s on you!','',26124),
(112145,'enUS','The hunt\'s never over.','',26124),
(112146,'enUS','Just carry the one and - yes?','',26124),
(112147,'enUS','Greetings!','',26124),
(112148,'enUS','Time for some science.','',26124),
(112149,'enUS','We can solve any problem.','',26124),
(112150,'enUS','Everything is science if you write it down.','',26124),
(112151,'enUS','Always a pleasure.','',26124),
(112152,'enUS','Off you go.','',26124),
(112153,'enUS','Fascinating. Lovely chat!','',26124),
(112154,'enUS','What brings you to the Temple of Storms?','',26124),
(112155,'enUS','I am Thorim, Lord of Thunder!','',26124),
(112156,'enUS','Hail, tiny creature!','',26124),
(112157,'enUS','You\'re far from home.','',26124),
(112158,'enUS','The hunt waits for no one.','',26124),
(112159,'enUS','Farewell.','',26124),
(112160,'enUS','Mimic the ravenbears\' dances to help complete the ritual.','',26124),
(112161,'enUS','Speak softly.','',26124),
(112162,'enUS','The hunt will go on.','',26124),
(112163,'enUS','Let the lightning guide you.','',26124),
(112164,'enUS','','It is always darkest just before the dawn.',26124),
(112165,'enUS','','Warm greetings to you.',26124),
(112166,'enUS','','Good day.',26124),
(112167,'enUS','','Bask in the glory of the day.',26124),
(112168,'enUS','','An\'she\'s warmth guide you.',26124),
(112169,'enUS','','Peace and patience be with you.',26124),
(112170,'enUS','','Ancestors protect you.',26124),
(112171,'enUS','','Walk always in the light of the sun.',26124),
(112172,'enUS','','Bless your heart.',26124),
(112173,'enUS','','You might be shining a little too brightly.',26124),
(112174,'enUS','','The ancestors would not approve of this.',26124),
(112175,'enUS','Help... me...','',26124),
(112176,'enUS','There... isn\'t much time...','',26124),
(112177,'enUS','So... weak...','',26124),
(112178,'enUS','<>','',26124),
(112179,'enUS','','Anaria shola.',26124),
(112180,'enUS','','Pleasantries can wait.',26124),
(112181,'enUS','','I answer to the Light.',26124),
(112182,'enUS','','I am the blade of the Light.',26124),
(112183,'enUS','','Remain vigilant.',26124),
(112184,'enUS','','Al diel shala.',26124),
(112185,'enUS','','Shorel\'aran.',26124),
(112186,'enUS','','Fight well.',26124),
(112187,'enUS','','I don\'t have time for mind games.',26124),
(112188,'enUS','','I\'m not the touchy-feely type.',26124),
(112189,'enUS','','Really? Really? We\'re still doing this?',26124),
(112190,'enUS','','You are so not receiving a card for Winter\'s Veil this year.',26124),
(112191,'enUS','Light\'s strength, friend.','',26124),
(112192,'enUS','We will prevail.','',26124),
(112193,'enUS','Azeroth will not fall while we stand.','',26124),
(112194,'enUS','At your service.','',26124),
(112195,'enUS','Walk always in the Light.','',26124),
(112196,'enUS','Take care of yourself out there.','',26124),
(112197,'enUS','You can always count on me.','',26124),
(112198,'enUS','May the Light give you strength.','',26124),
(112199,'enUS','I\'ve been through more than you know.','',26124),
(112200,'enUS','Don\'t test me. I always hated tests.','',26124),
(112201,'enUS','The Light does not favor those who pester.','',26124),
(112202,'enUS','I need a Blessing of Patience.','',26124),
(112203,'enUS','The Legion will not break us.','',26124),
(112204,'enUS','Archenon poros.','',26124),
(112205,'enUS','The Hand of Argus stands with you.','',26124),
(112206,'enUS','<The ravenbears are all in place and ready to begin the ritual. \n\nThey appear to be waiting for you.>','',26124),
(112207,'enUS','We are agents of the Light.','',26124),
(112208,'enUS','Dioniss aca.','',26124),
(112209,'enUS','May the Light protect you.','',26124),
(112210,'enUS','Blessings upon you.','',26124),
(112211,'enUS','Remain vigilant.','',26124),
(112212,'enUS','I\'m not listening.','',26124),
(112213,'enUS','Um... caw?','Um... caw?',26124),
(112214,'enUS','Surely there are more important things.','',26124),
(112215,'enUS','Prophet Velen talks less than you - no offense.','',26124),
(112216,'enUS','You called, and the Hand of Argus is busy. Try again later.','',26124),
(112217,'enUS','Good to see ye!','',26124),
(112218,'enUS','I\'m all ears.','',26124),
(112219,'enUS','Let\'s have a chat.','',26124),
(112220,'enUS','Aye?','',26124),
(112221,'enUS','Keep yer sights on the horizon.','',26124),
(112222,'enUS','Stop by anytime!','',26124),
(112223,'enUS','Be seein\' you.','',26124),
(112224,'enUS','Take it easy.','',26124),
(112225,'enUS','','Our hand is everywhere.',26124),
(112226,'enUS','','Hmm?',26124),
(112227,'enUS','','What is it.',26124),
(112228,'enUS','','I serve noone.',26124),
(112229,'enUS','','So be it.',26124),
(112230,'enUS','','Good.',26124),
(112231,'enUS','','Our will be done.',26124),
(112232,'enUS','','Whatever it takes.',26124),
(112233,'enUS','You have my ear.','',26124),
(112234,'enUS','We operate where others cannot.','',26124),
(112235,'enUS','What is it?','',26124),
(112236,'enUS','The shadows call.','',26124),
(112237,'enUS','All according to plan.','',26124),
(112238,'enUS','Until next time.','',26124),
(112239,'enUS','Was that all?','',26124),
(112240,'enUS','All in good time.','',26124),
(112241,'enUS','','Speak your mind.',26124),
(112242,'enUS','','There\'s a potion for everything.',26124),
(112243,'enUS','','Let\'s talk.',26124),
(112244,'enUS','','How can I help?',26124),
(112245,'enUS','','The job\'s not done yet.',26124),
(112246,'enUS','','Look to the shadows.',26124),
(112247,'enUS','','Take care.',26124),
(112248,'enUS','','Stay alert out there.',26124),
(112249,'enUS','Speak.','',26124),
(112250,'enUS','Yes?','',26124),
(112251,'enUS','What is it?','',26124),
(112252,'enUS','I am listening.','',26124),
(112253,'enUS','Good.','',26124),
(112254,'enUS','Make it so.','',26124),
(112255,'enUS','We shall see.','',26124),
(112256,'enUS','','Let\'s get down to business.',26124),
(112257,'enUS','','All that matters is the mission.',26124),
(112258,'enUS','','You have my attention.',26124),
(112259,'enUS','','What\'s the situation?',26124),
(112260,'enUS','','Stay light on your feet.',26124),
(112261,'enUS','','Keep your eyes keen.',26124),
(112262,'enUS','','Be wary.',26124),
(112263,'enUS','','Silent and deadly.',26124),
(112264,'enUS','','Not all words are wise. Consider this.',26124),
(112265,'enUS','','You overestimate my patience.',26124),
(112266,'enUS','','Want to have a few new scars? Maybe... here?',26124),
(112267,'enUS','','Keep it up, they\'ll never find your body!',26124),
(112268,'enUS','','My loyalties are my own.',26124),
(112269,'enUS','If the ward protecting the Fangs fails, we\'ll have more to worry about than a few cuts and bruises. I\'ll guard the weapon, even if you won\'t!','',26124),
(112270,'enUS','','The pleasure is mine.',26124),
(112271,'enUS','','I wouldn\'t cross me if I were you.',26124),
(112272,'enUS','','Let\'s talk.',26124),
(112273,'enUS','','They\'ll never see me coming.',26124),
(112274,'enUS','','Farewell.',26124),
(112275,'enUS','','Without a trace.',26124),
(112276,'enUS','','Al diel shala.',26124),
(112277,'enUS','','Do you prefer your entrails cut julienne or brunoise?',26124),
(112278,'enUS','','I will be your death!',26124),
(112279,'enUS','','You seriously do not want to cross me.',26124),
(112280,'enUS','','What can I do for you?',26124),
(112281,'enUS','','Less talk, more action.',26124),
(112282,'enUS','','Hm.',26124),
(112283,'enUS','','Words are petty.',26124),
(112284,'enUS','','Right away.',26124),
(112285,'enUS','','Hmph.',26124),
(112286,'enUS','','I will have my revenge someday.',26124),
(112287,'enUS','','Nothing will stand in my way.',26124),
(112288,'enUS','','Don\'t push me.',26124),
(112289,'enUS','','Care to split a drink? It\'s not poisoned... promise.',26124),
(112290,'enUS','','I have a knack for making people disappear.',26124),
(112291,'enUS','','I thought you were above this.',26124),
(112292,'enUS','We can do this the easy way or the hard way.','We can do this the easy way or the hard way.',26124),
(112293,'enUS','Could I buy it from you?','Could I buy it from you?',26124),
(112294,'enUS','The key, if you please.','The key, if you please.',26124),
(112295,'enUS','Get out of here! It\'s not safe!','Get out of here! It\'s not safe!',26124),
(112296,'enUS','Get out of here!','Get out of here!',26124),
(112297,'enUS','The lands are overrun!','The lands are overrun!',26124),
(112298,'enUS','You\'re not safe here, $n!','You\'re not safe here, $n!',26124),
(112299,'enUS','Keep moving!','Keep moving!',26124),
(112300,'enUS','Earth Mother protect us!','Earth Mother protect us!',26124),
(112301,'enUS','It was foolish of me to come out here alone.','It was foolish of me to come out here alone.',26124),
(112302,'enUS','They\'re everywhere, $n!','They\'re everywhere, $n!',26124),
(112303,'enUS','Your kindness will not be forgotten.','Your kindness will not be forgotten.',26124),
(112308,'enUS','By the light of Elune! What happened to the shrine!?','',26124),
(112309,'enUS','Jabrul loves the stones.$b$bJabrul is happy that you love the stones, too.','',26124),
(112310,'enUS','$n, is it true you wield the Kingslayers? The very blades that murdered Wrynn during the first war? I would never say this aloud in Stormwind but... he had it coming.','$n, is it true you wield the Kingslayers? The very blades that murdered Wrynn during the first war? I would never say this aloud in Stormwind but... he had it coming.',26124),
(112311,'enUS','','$n! Master assassin, in the flesh! Those daggers of yours are the talk of Undercity.',26124),
(112312,'enUS','Look to the stacks for answers. I will check my memory vault.','',26124),
(112313,'enUS','|TInterface\\Icons\\inv_axe_2h_felfireraid_d_01:20|t %s readies |cFFFF0000|Hspell:206675|h[Shatter Essence]|h|r.','',26124),
(112314,'enUS','Can you tell me more about Arrexis?','Can you tell me more about Arrexis?',26124),
(112315,'enUS','Arrexis was a powerful and well known member of the Order of Tirisfal around the First War. I barely spoke to him, busy with my own goals. I knew he wielded Ebonchill. Then, mysteriously, I returned from a long journey and he was gone. His apprentices were gone and any materials and belongings related to him. The other members of the order were very tightlipped, only saying that something horrible had befallen him.\n\nEbonchill was nowhere to be found.','',26124),
(112316,'enUS','<Inform Meryl of the information you uncovered.>','<Inform Meryl of the information you uncovered.>',26124),
(112317,'enUS','So Arrexis was ambushed by this eredar, Balaadur?  Then he is probably in possession of the staff...','',26124),
(112318,'enUS','My staff... in the hands of the enemy! We must get it back!','',26124),
(112319,'enUS','Well done! Now we can begin our counter attack!','',26124),
(112320,'enUS','Poisons. Poisons, here! Family owned and operated since our untimely death.','',26124),
(112321,'enUS','So it is true. You carry with you Anguish and Sorrow, the twin blades that once slit the throat of the Alliance King.$b$bI consider myself an aficionado of poisoned blades, $n. May I see them a moment? I can tell you a little about their history...','',26124),
(112322,'enUS','Ahh, yes. Daggers. The weapon of choice for skilled assassins. Easily concealed, leaving no chance of the victim surviving. Some prefer stiletto blades, for rapid piercing of the victim\'s vitals.','',26124),
(112323,'enUS','But Garona, she preferred short, curved blades. They allow one to draw the weapon from the scabbard and slice the target\'s throat in a single, deadly motion. Oh, glorious!','',26124),
(112324,'enUS','Note the serrated reverse edge, allowing the wielder to cut back if the first slice misses. Not that Garona ever missed. Her victims were dead before they hit the ground. These are truly a treasure, $n - thank you.','',26124),
(112325,'enUS','$n! Come closer. There are rumors about those daggers of yours...','',26124),
(112326,'enUS','With the invasion I have no doubt he is either here or watching. I propose something... audacious.','',26124),
(112327,'enUS','Let us recreate Arrexis\'s ritual! Conducting the ritual at an invasion point will attract Balaadur\'s attention. He will likely try an ambush, but we will be ready.','',26124),
(112328,'enUS','That just might work. We need the details of this ritual, as well as the power to pull it off. Let us get to it.','',26124),
(112329,'enUS','','Excellent! Now that we have the key, the way to the balcony should be open. It\'s time to put an end to Elisande!',26124),
(112330,'enUS','','When you first set foot upon our shores, I prayed to the spirits asking if you could be trusted. By helping to reunite our tribes, you have proven yourself a true friend to our people.',26124),
(112331,'enUS','','On behalf of the tribes of Highmountain, I entrust the hammer to you and your allies. May it strike true at the heart of the enemy!',26124),
(112332,'enUS','','The spirits whisper that our fates our intertwined, $n. My people stand ready to aid you in the war against the Legion.',26124),
(112333,'enUS','Any information you can find on Arrexis, how he died, and the whereabouts of Ebonchill would be greatly appreciated.','',26124),
(112334,'enUS','','For us, the Hammer of Khaz\'goroth has always been a symbol of unity, a reminder of our proud history. But in your hands, it will serve an even greater purpose.',26124),
(112335,'enUS','Speak to the bank manager. The sigil I just gave you should grant access. There may still be wards guarding the vault, so be careful.','',26124),
(112336,'enUS','Get out of here! This is chaos!','',26124),
(112337,'enUS','My gratitude, $n.','My gratitude, $n.',26124),
(112338,'enUS','We shouldn\'t be here!','We shouldn\'t be here!',26124),
(112339,'enUS','We need to move. It\'s not safe here.','We need to move. It\'s not safe here.',26124),
(112340,'enUS','Our caravan... we couldn\'t stop it!','Our caravan... we couldn\'t stop it!',26124),
(112341,'enUS','','Thala nar\'valas.',26124),
(112342,'enUS','','Don\'t forget to push the premier account!',26124),
(112343,'enUS','','Look at all of it... hopefully none of it goes missing...',26124),
(112344,'enUS','','If you are missing items please contact customer service! He he he...',26124),
(112345,'enUS','Where... where am I?','Where... where am I?',26124),
(112346,'enUS','That feeling... I can\'t explain it.','That feeling... I can\'t explain it.',26124),
(112347,'enUS','They know our secrets! Our thoughts are not our own!','They know our secrets! Our thoughts are not our own!',26124),
(112348,'enUS','Is this... is this really me?','Is this... is this really me?',26124),
(112349,'enUS','I felt so weak!','I felt so weak!',26124),
(112350,'enUS','','Nnngh- ENOUGH!!',26124),
(112351,'enUS','I couldn\'t stop! That thing wouldn\'t let me!','I couldn\'t stop! That thing wouldn\'t let me!',26124),
(112352,'enUS','','Our bank is so secure you\'ll have trouble getting your own things out! Ha ha!',26124),
(112353,'enUS','My blade... I didn\'t... I couldn\'t...','My blade... I didn\'t... I couldn\'t...',26124),
(112354,'enUS','That feeling... I feel sick.','That feeling... I feel sick.',26124),
(112355,'enUS','Your soul shall suffer!','Your soul shall suffer!',26124),
(112356,'enUS','Fragile mortal! Your end has come!','Fragile mortal! Your end has come!',26124),
(112357,'enUS','The Legion cannot be stopped!','The Legion cannot be stopped!',26124),
(112358,'enUS','You cannot escape!','You cannot escape!',26124),
(112359,'enUS','We are everywhere!','We are everywhere!',26124),
(112360,'enUS','You are so weak!','You are so weak!',26124),
(112361,'enUS','Mortal flesh!','Mortal flesh!',26124),
(112362,'enUS','Don\'t give away my position. Like you, I\'m doing the devil\'s work behind the lines.','',26124),
(112363,'enUS','Quiet now. They haven\'t found my position yet. I\'ve been stirring up a good deal of trouble back here.$b$bMy fellows in the Hall of Shadows report that you\'ve got your hands on Garona\'s old daggers. Is that true? May I see them?','',26124),
(112364,'enUS','Psst! $n! Come this way. I\'m over here. Near the Campfire.','',26124),
(112365,'enUS','So the rumors are true. Anguish and Sorrow are once again in the hands of a skilled assassin. Ah yes, they do not disappoint.','',26124),
(112366,'enUS','Do you see these channels here, along the flat of the blade? They drive poison deeper into the wounds. These blades drink blood and spit poison. Such deadly craftsmanship!','',26124),
(112367,'enUS','Treasure them, $n. I am pleased that you are the head of our order. Thank you.','',26124),
(112368,'enUS','I would like access to the personal vault of Alodi, Archmage of Dalaran.','I would like access to the personal vault of Alodi, Archmage of Dalaran.',26124),
(112369,'enUS','','Hmph! You don\'t look a thing like him! Fine, let\'s have a look...',26124),
(112370,'enUS','','It seems you bear his sigil. How\'d you manage that? Well, rules are rules.',26124),
(112371,'enUS','','You tell that big lug that if he ever wants to pick up where we left off, he can pay me a visit! I\'m here every day... whatever the hour!',26124),
(112372,'enUS','Do not give in, $n. We must fight!','',26124),
(112373,'enUS','Changing','Changing',26124),
(112374,'enUS','In my day, I put blades in the hands of armies. What of you, mortal? What do you seek?','',26124),
(112375,'enUS','Those daggers you hold. They have tasted the blood of Kings. Give them here, I wish to see them closer.$b$bHah ha! Such a sour face you make. I will not keep them, rogue. I am long past the need for your mortal steel.','',26124),
(112376,'enUS','Come closer, $c. Let me see those blades - they stink of death.','',26124),
(112377,'enUS','Ach, I can feel their thirst. Forged in darkness these were. Many have fallen to their caress.','',26124),
(112378,'enUS','So slender, so quick. These are not the weapons of a warrior, no, they strike from the shadows.','',26124),
(112379,'enUS','Very well, $r. I am impressed. Many lives have been ended by the Kingslayers... go now, and send the weak to their end.','',26124),
(112380,'enUS','Take them. But only for a moment.','Take them. But only for a moment.',26124),
(112381,'enUS','Stay away... STAY AWAY!','Stay away... STAY AWAY!',26124),
(112382,'enUS','I can help you refocus the power in that weapon you have there.\n\nYou\'ll lose a little in the process though.','I can help you refocus the power in that weapon you have there.\n\nYou\'ll lose a little in the process though.',26124),
(112383,'enUS','','I feel them. His memories.',26124),
(112384,'enUS','I\'d like to refund the traits in my artifact.','Yes, I\'d like to refund the traits in my artifact.',26124),
(112385,'enUS','This will cost this weapon 500 Artifact Power.  Are you sure that you want to respec your artifact?','This will cost this weapon 500 Artifact Power.  Are you sure that you want to respec your artifact?',26124),
(112386,'enUS','Hey, you, help a fellow mage out! That demon, Norvir, has the key!','',26124),
(112387,'enUS','','AAIGHH!!',26124),
(112388,'enUS','I certainly get myself into some very interesting situations!','',26124),
(112389,'enUS','','Please, $c, do not tarry. I cannot imagine a world without Cenarius!',26124),
(112390,'enUS','','Something terrible is afoot, traveler. I can feel it.',26124),
(112391,'enUS','','Quite a view, isn\'t it?',26124),
(112392,'enUS','You wished to speak to me?','You wanted to speak to me?',26124),
(112393,'enUS','Demons! Everywhere!','Demons! Everywhere!',26124),
(112394,'enUS','Thank you. I was barely hanging on.','Thank you. I was barely hanging on.',26124),
(112395,'enUS','A brief client scene happens here.','A brief client scene happens here.',26124),
(112396,'enUS','Conjured Mana food never tasted so good...','Conjured Mana food never tasted so good...',26124),
(112397,'enUS','You have my thanks... Can I have more food, please?','You have my thanks... Can I have more food, please?',26124),
(112398,'enUS','','I... I am fine.',26124),
(112405,'enUS','Dem magics ain\'t like none I been seein\' before.','Dem magics ain\'t like none I been seein\' before.',26124),
(112406,'enUS','Brave of ya to come for us, $n.','Brave of ya to come for us, $n.',26124),
(112407,'enUS','Best get movin\', mon.','Best get movin\', mon.',26124),
(112408,'enUS','I be returnin\' to me village til it\'s safe.','I be returnin\' to me village til it\'s safe.',26124),
(112409,'enUS','','You\'ll find time can be quite volatile.',26124),
(112410,'enUS','','Let the waves of time crash over you!',26124),
(112411,'enUS','','I control the battlefield, not you!',26124),
(112412,'enUS','','Time itself heeds my call!',26124),
(112413,'enUS','','Will you race through time? Or be trapped in an endless eternity?',26124),
(112414,'enUS','','The threads of time answer to me!',26124),
(112415,'enUS','','The time streams are mine to command! You cannot win!',26124),
(112416,'enUS','The Earth Mother watches over us.','The Earth Mother watches over us.',26124),
(112417,'enUS','Together we are stronger.','Together we are stronger.',26124),
(112418,'enUS','Blessings be upon you, brave one.','Blessings be upon you, brave one.',26124),
(112419,'enUS','The others... I must find them!','The others... I must find them!',26124),
(112420,'enUS','These things... I couldn\'t stop them!','These things... I couldn\'t stop them!',26124),
(112421,'enUS','Be careful! They\'re magic is quite powerful.','Be careful! They\'re magic is quite powerful.',26124),
(112422,'enUS','My thanks.','',26124),
(112423,'enUS','','Very brave of you to come all the way out here, $n. We are in your debt.',26124),
(112424,'enUS','|TInterface\\Icons\\ability_felarakkoa_feldetonation_red:20|t You are afflicted with |cFFFF0000|Hspell:206221|h[Empowered Bonds of Fel]|h|r!','',26124),
(112425,'enUS','|TInterface\\Icons\\ability_felarakkoa_feldetonation_green:20|t You are afflicted with |cFFFF0000|Hspell:206222|h[Bonds of Fel]|h|r!','',26124),
(112426,'enUS','Secure the perimeter! And get rid of their corpses. I don\'t want their foul stench drifting about.','',26124),
(112427,'enUS','Your pathetic barriers mean nothing to the Legion!','',26124),
(112428,'enUS','The blades are mine!','',26124),
(112430,'enUS','I\'ll never let Ashamane\'s Fangs fall to your kind!','',26124),
(112431,'enUS','Insolent mortal! We will hunt you down! You only delay the inevitable!','',26124),
(112433,'enUS','<Offer Mana Wine.>','<Offer Mana Wine.>',26124),
(112439,'enUS','I appreciate your help, but I must find the rest of my party.','',26124),
(112441,'enUS','Thanks for the assistance, but I\'ve got to keep moving. You should do the same.','',26124),
(112445,'enUS','Stop it. Stop talking! Stop the voices!','Stop it. Stop talking! Stop the voices!',26124),
(112448,'enUS','The mana betrays us...','The mana betrays us...',26124),
(112449,'enUS','','Sorry, boys, looks like we\'re going with my plan after all. Let\'s talk details.',26124),
(112450,'enUS','','[CUT] Something incredibly powerful WAS there, but it expired long ago. Rather violently, from what I can tell.',26124),
(112451,'enUS','','[CUT]What of your tests? Did you sense anything in Falanaar?',26124),
(112452,'enUS','','[CUT] Magically speaking, the area is in chaos. With one notable exception...',26124),
(112453,'enUS','','[CUT] Moonfall Retreat. Thank you, Valtrois. That will be all.',26124),
(112454,'enUS','Careful with that thing!','Careful with that thing!',26124),
(112455,'enUS','Bring it back in one piece!','Bring it back in one piece!',26124),
(112456,'enUS','Hey! I wasn\'t finished yet.','Hey! I wasn\'t finished yet.',26124),
(112457,'enUS','You be careful out there!','You be careful out there!',26124),
(112458,'enUS','I trust the Baroness was still there? I don\'t know how old that elf is.','',26124),
(112459,'enUS','Uh, I\'m pretty sure she\'s a goblin now.','',26124),
(112460,'enUS','RRAAAUUUGHHHH!','',26124),
(112461,'enUS','I suppose even astral entities need a change of pace now and again. It\'s still a she though... right?','',26124),
(112462,'enUS','In the center of Dalaran is a portal that can you to Karazhan. Start your search in the mountains west of the tower. I seem to recall a mention of something up there.','',26124),
(112463,'enUS','','I\'m afraid you\'re on your own out there until you can find Garona. I\'d be recognized in a heartbeat that close to Alliance territory.',26124),
(112465,'enUS','And so the Legion is here. I thought we would have more time.$b$bSo much to do, so very much to do...','',26124),
(112466,'enUS','Have my spies misled me, or are those indeed Anguish and Sorrow, the blades that killed King Llane Wrynn? A most impressive find, $n.$b$bI know a thing or two about daggers. May I see them? Just for a moment, of course.','',26124),
(112467,'enUS','Now that we can talk freely, $n, I\'ve been meaning to ask you about those daggers of yours...','',26124),
(112468,'enUS','Very, very nice $n. If hate could be forged into a weapon, it would look like this.','',26124),
(112469,'enUS','The modern warrior is too dependent on his armor, he realizes only too late that a small weapon slipped between the joining of plates will kill him surer than the largest warhammer or the most magical of fireballs.','',26124),
(112470,'enUS','Not that I have anything against fireballs. But, I\'ve always been a cloak-and-dagger sort, myself. Thank you, $r. These are truly a marvel.','',26124),
(112472,'enUS','Take a good look, brute! You\'ll never see the Fangs again!','',26124),
(112473,'enUS','Verstok was at the shrine! Find out what\'s going on up there. I\'ll meet up with you as soon as I can, $n.','',26124),
(112474,'enUS','','Are you here to take me away? Or do you only seek that which was left behind?',26124),
(112475,'enUS','','I was told to stand watch, but no one ever came back for me. I wasn\'t strong enough to defend the site... or perhaps I was simply here too long. I\'m not sure anymore.',26124),
(112476,'enUS','','If you want the ritual to work, you need the focus. I tried to keep it from the monsters, but I was too weak.',26124),
(112477,'enUS','','It lies near my corpse. I... I think it\'s keeping me here. Please, take it far away. Perhaps then I will finally be able to go home.',26124),
(112478,'enUS','Another annoyance?! I\'m going to enjoy watching this world burn!','',26124),
(112479,'enUS','The network is responding to a new beacon. Ah, hello again!','',26124),
(112480,'enUS','Give me a moment- I am locking in your location now.','',26124),
(112482,'enUS','Vanthir and I need your help to avenge-','Vanthir and I need your help to avenge-',26124),
(112485,'enUS','','The blood of any of the demons on the Broken Isles will do. Wish I was going with you.',26124),
(112487,'enUS','Hold on tightly, my mortal friend. A fall from this height would be a shame.','',26124),
(112488,'enUS','Brothers and Sisters, the shrine is under attack! By fang and claw, purge it of the desecrator!','',26124),
(112489,'enUS','','Our arcana is not for you, outsider!',26124),
(112493,'enUS','','Ours! This knowledge is OURS!',26124),
(112497,'enUS','','You dare defile our sacred texts?',26124),
(112498,'enUS','','We will cure this curse... in time...',26124),
(112499,'enUS','','The arcana will save us... it must.',26124),
(112508,'enUS','Well done! The Legion\'s attack has been broken!','',26124),
(112509,'enUS','What the... the Fangs are gone! What happened, $n?','',26124),
(112510,'enUS','The doom of your world is upon you!','',26124),
(112511,'enUS','We come to burn your world to cinders!','',26124),
(112512,'enUS','These mortals cannot stop the inevitable! Spread out! Destroy them all!','',26124),
(112513,'enUS','Leave no stone unturned! Snuff out every mortal life!','',26124),
(112514,'enUS','Your world ends now!','',26124),
(112515,'enUS','I will put an end to you!','',26124),
(112516,'enUS','We are... unending.','',26124),
(112517,'enUS','You have accomplished... nothing.','',26124),
(112518,'enUS','Feel your hearts quake, mortals. Today your world falls to the Burning Legion!','',26124),
(112519,'enUS','Bid farewell to the lives you knew. The Legion has come!','',26124),
(112520,'enUS','Feel our power scorching your lands!','',26124),
(112521,'enUS','There is nowhere you can hide from us!','',26124),
(112522,'enUS','Your efforts are in vain, mortals! We cannot be stopped.','',26124),
(112523,'enUS','Stand before me and DIE!','',26124),
(112524,'enUS','Death is but a mask.','',26124),
(112525,'enUS','Another will... take... my place...','',26124),
(112526,'enUS','Behold the might of the Burning Legion!','',26124),
(112527,'enUS','Mortal filth! You will stain this world no more!','',26124),
(112528,'enUS','Spread out! Leave them nothing!','',26124),
(112529,'enUS','Wipe them out! All of them!','',26124),
(112530,'enUS','I accept your challenge, mortals. Time to see just how fragile you truly are!','',26124),
(112531,'enUS','Your lives mean nothing! I will relish ending them!','',26124),
(112532,'enUS','I will... return!','',26124),
(112533,'enUS','A momentary... setback...','',26124),
(112534,'enUS','The Legion comes! Your world will be PURGED!','',26124),
(112535,'enUS','Miserable wretches! The hour of doom is at hand!','',26124),
(112536,'enUS','A sect of former subjects, insane from arcane magics they could not control, plots vengeance against me and mine. Destroy them!','',26124),
(112537,'enUS','Remove them from existence! Leave nothing in your wake.','',26124),
(112538,'enUS','Scour their lands! Snuff out every life!','',26124),
(112539,'enUS','Your arrogance means nothing! Come and face a lord of the Legion!','',26124),
(112540,'enUS','Impudent whelps! Stand and face me!','',26124),
(112541,'enUS','I will... return!','',26124),
(112542,'enUS','You only... delay... the inevitable.','',26124),
(112543,'enUS','It seems Tash\'irel was trying to lift the curse through sheer force of magic. Such a waste. At least now, the tomes have found their rightful home.','',26124),
(112544,'enUS','Such fragile beings. How quickly your end approaches!','',26124),
(112545,'enUS','Your end is upon you! All will burn!','',26124),
(112546,'enUS','','Such fragile beings. How quickly your end approaches!',26124),
(112547,'enUS','','Your end is upon you! All will burn!',26124),
(112548,'enUS','Witness your lands being devoured before your very eyes!','',26124),
(112549,'enUS','I claim this land for the Legion! Every mortal will be purged!','',26124),
(112550,'enUS','','Witness your lands being devoured before your very eyes!',26124),
(112551,'enUS','','I claim this land for the Legion! Every mortal will be purged!',26124),
(112552,'enUS','You are no match for our immortal army!','',26124),
(112553,'enUS','Kneel before me! Beg for mercy!','',26124),
(112554,'enUS','','You are no match for our immortal army!',26124),
(112555,'enUS','','Kneel before me! Beg for mercy!',26124),
(112556,'enUS','Death... is only the beginning.','',26124),
(112557,'enUS','The game... is far... from over...','',26124),
(112558,'enUS','','Death... is only the beginning.',26124),
(112559,'enUS','','The game... is far... from over...',26124),
(112560,'enUS','Their curse is as ours, and they will never rest. At least, for now, you\'ve prevented them from lashing out against my Court.','',26124),
(112561,'enUS','Your life is forfeit, outsider!','Your life is forfeit, outsider!',26124),
(112562,'enUS','You will die here, among the cursed!','You will die here, among the cursed!',26124),
(112563,'enUS','The curse... will never let me rest...','The curse... will never let me rest...',26124),
(112564,'enUS','The curse remains...','The curse remains...',26124),
(112565,'enUS','My magic will be the end of you!','',26124),
(112566,'enUS','I will have vengeance for Fardonis\' arrogance!','',26124),
(112567,'enUS','','Can you hear me? Do not be alarmed.',26124),
(112568,'enUS','','I shall do my best to keep Theryn off the line...',26124),
(112569,'enUS','Ngahh...','',26124),
(112570,'enUS','','Arcane communion forms a bond that transcends physical space.',26124),
(112571,'enUS','<Ebonfang glances at you for a moment before sitting down to allow you to climb upon her back.>','',26124),
(112572,'enUS','Let\'s begin our search.','Let\'s begin our search.',26124),
(112573,'enUS','Nazgrim, your Deathlord calls! Feel the icy grip of your master and rise once more!','',26124),
(112574,'enUS','Here in the big city, Jabrul can finally focus on gems and gems alone.','',26124),
(112575,'enUS','It is time, my lord. Do what must be done.','',26124),
(112576,'enUS','The fangs have claimed me...','The fangs have claimed me...',26124),
(112577,'enUS','Sargeras will reclaim those fangs of yours, rogue.','Sargeras will reclaim those fangs of yours, rogue.',26124),
(112578,'enUS','But those were Akaari\'s daggers... how...?','But those were Akaari\'s daggers... how...?',26124),
(112579,'enUS','Those daggers belong to the Legion...','Those daggers belong to the Legion...',26124),
(112580,'enUS','You wield... Akaari\'s fangs? Not possible...','You wield... Akaari\'s fangs? Not possible...',26124),
(112583,'enUS','-PH-','',26124),
(112584,'enUS','I live again... How long has it been since I tasted death?','',26124),
(112585,'enUS','Show me the power and agility of windwalking!','',26124),
(112586,'enUS','Well done, $p! You are now prepared to do battle as a monk.','',26124),
(112587,'enUS','Say no more. I will sever their heads from their bodies...','',26124),
(112588,'enUS','Long enough, my friend. The Burning Legion has returned and you have been called to the battle.','',26124),
(112589,'enUS','Indeed you shall, general. Indeed you shall...','',26124),
(112590,'enUS','You will not interrupt my work. The Legion will have this world!','',26124),
(112591,'enUS','Our new masters can make us more than mere mortals, don\'t you see?','',26124),
(112592,'enUS','The Veiled Hand will rule this shattered world. We herald a new beginning!','',26124),
(112593,'enUS','Where did you go, little rat?','',26124),
(112595,'enUS','Holy hellfire will rain from the sky and bathe us in the Legion\'s might. We will become unstoppable!','',26124),
(112597,'enUS','You cannot hide forever.','',26124),
(112599,'enUS','Usurper! Thief! Scoundrel! You will not deny our glorious destiny!','',26124),
(112608,'enUS','I can smell your fear, spy.','',26124),
(112609,'enUS','Stop! Search the area!','',26124),
(112612,'enUS','Show me the raw power and superiority you wield!','',26124),
(112613,'enUS','You will learn your place!','',26124),
(112614,'enUS','Well done, $p! You are now prepared to do battle as an ice mage.','',26124),
(112617,'enUS','Weaklings.','',26124),
(112618,'enUS','Your lives are ours to take.','',26124),
(112619,'enUS','Gul\'dan permits the rest of you to live, for now.','',26124),
(112620,'enUS','Let your death serve a lesson to those who defy the Legion.','',26124),
(112621,'enUS','That was a bit of a pickle. Thanks! You must be the one I\'ve been hearing so much about lately!','',26124),
(112622,'enUS','The fangs! Terrible fangs...','The fangs! Terrible fangs...',26124),
(112623,'enUS','That was Akaari\'s bite...','That was Akaari\'s bite...',26124),
(112624,'enUS','The fangs of Goremaw! Such teeth...','The fangs of Goremaw! Such teeth...',26124),
(112625,'enUS','No...! Not the fangs...','No...! Not the fangs...',26124),
(112626,'enUS','You and I are going to make a great team! Let\'s blow this place up!','',26124),
(112631,'enUS','I have come to ask you about Arrexis and his ritual. I must face Balaadur and I need to get his attention.','I have come to ask you about Arrexis and his ritual. I must face Balaadur and I need to get his attention.',26124),
(112632,'enUS','Ah, that ritual. The one where Arrexis was dragged screaming into the Nether and his entire cadre of mages were slaughtered. The ritual that caused me to give up the arcane and begin my personal quest to understand demons and their fel energies.\n\nBalaadur is extremely dangerous and you seem... young. Are you sure you are prepared?','',26124),
(112633,'enUS','I have the aid of Meryl Felstorm and the spirit of Alodi, and we know what we face this time.','I have the aid of Meryl Felstorm and the spirit of Alodi, and we know what we face this time.',26124),
(112634,'enUS','Balaadur and his minions have slain many mages over the years, they have perfected their craft. Before I help you with the ritual I will need to see your ability for myself. If you can face what I summon, I will give you the aid you require.\n\nAre you prepared to face demons?','',26124),
(112635,'enUS','I will face your demons, warlock.','I will face your demons, warlock.',26124),
(112636,'enUS','Very well! Let us begin. Perhaps something easy to start. A few imps, perhaps?','',26124),
(112637,'enUS','Yikes! What the heck is goin\' on around here?','Yikes! What the heck is goin\' on around here?',26124),
(112638,'enUS','...where the heck am I?','...where the heck am I?',26124),
(112639,'enUS','That thing... I can\'t explain it.','That thing... I can\'t explain it.',26124),
(112640,'enUS','I feel sick.','I feel sick.',26124),
(112641,'enUS','This ain\'t like anything I\'ve felt before.','This ain\'t like anything I\'ve felt before.',26124),
(112642,'enUS','Be sure to give those demons what they got comin\'!','Be sure to give those demons what they got comin\'!',26124),
(112645,'enUS','Watch yourself, Shackle. $n here wields the Dreadblades, cursed swords that sent many a sailor to their doom.','',26124),
(112646,'enUS','Yes... yes! They draw closer with each moment!','',26124),
(112648,'enUS','Fools! Your pathetic souls will fuel the Legion\'s coming!','',26124),
(112649,'enUS','Stand down, scum! You know not the forces you tempt.','',26124),
(112650,'enUS','They gave their lives willingly to the cause. Won\'t you?','',26124),
(112651,'enUS','It is not too late for you. Submit, and take your place in the new order!','',26124),
(112652,'enUS','Can you not feel it? The warm embrace of the Legion comes, you need only welcome it!','',26124),
(112653,'enUS','You are not worth saving. Die, miserable worm!','',26124),
(112654,'enUS','You are too late. We are... everywhere...','',26124),
(112655,'enUS','Dem blades ya carry be cursed, $n. I seen \'em send many a seaman to his demise. Ya best be careful, now.','',26124),
(112656,'enUS','Stand back. The ritual must be completed!','',26124),
(112657,'enUS','What was that? No matter. My work must continue.','',26124),
(112658,'enUS','I smell one who is unworthy.','I smell one who is unworthy.',26124),
(112659,'enUS','What was that?','What was that?',26124),
(112660,'enUS','Thought I heard something.','Thought I heard something.',26124),
(112661,'enUS','There\'s someone here...','There\'s someone here...',26124),
(112662,'enUS','Thanks!','Thanks!',26124),
(112663,'enUS','That was a close one!','That was a close one!',26124),
(112664,'enUS','I was sure I was a goner.','I was sure I was a goner.',26124),
(112665,'enUS','She\'s all yours.','She\'s all yours.',26124),
(112666,'enUS','Bring her back in one piece!','Bring her back in one piece!',26124),
(112667,'enUS','Hopefully this\'ll help.','Hopefully this\'ll help.',26124),
(112668,'enUS','Consider this a loaner.','Consider this a loaner.',26124),
(112669,'enUS','The portal seems to branch off in different directions. Where do you want to go?','',26124),
(112670,'enUS','Alchemists\' Lair','Alchemists\' Lair',26124),
(112671,'enUS','Inn Entrance','Inn Entrance',26124),
(112672,'enUS','Abandoned Shack','Abandoned Shack',26124),
(112673,'enUS','Sewer Guard Station','Sewer Guard Station',26124),
(112674,'enUS','Rear Entrance','Rear Entrance',26124),
(112675,'enUS','Black Market','Black Market',26124),
(112676,'enUS','Get me outta here!','Get me outta here!',26124),
(112677,'enUS','Get it off me!','Get it off me!',26124),
(112678,'enUS','Hey, thanks! Let\'s get to work!','Hey, thanks! Let\'s get to work!',26124),
(112679,'enUS','Looks like it\'s time to teach these things a lesson.','Looks like it\'s time to teach these things a lesson.',26124),
(112680,'enUS','My thanks.','',26124),
(112681,'enUS','Thank you. I best return once things have calmed down.','',26124),
(112682,'enUS','A brave $c. I vow to return the favor someday.','',26124),
(112683,'enUS','Stop where you are! My... apologies, $n! What are you doing out here?','',26124),
(112690,'enUS','Easily defeated, but deadly in large numbers. Perhaps something that hits a little harder...','',26124),
(112698,'enUS','I expected no less from one who wields crippling ice magic. But how about a foe as skilled in spellcasting as yourself?','',26124),
(112701,'enUS','Well fought, but Balaadur has been hunting mages for untold ages. Facing him will require mastery of all of your abilities.','',26124),
(112702,'enUS','For the final piece of the puzzle... a simple stone. A stone from Balaadur\'s realm, left here by chance during one of his many ambushes.','',26124),
(112705,'enUS','None shall stand against the Burning Legion!','',26124),
(112706,'enUS','Your world will fall to the might of the Burning Legion!','',26124),
(112707,'enUS','Insignificant mortals! You are NOTHING!','',26124),
(112708,'enUS','Tremble in our wake, mortals! Your world is at an end!','',26124),
(112709,'enUS','You... will... DIE!','',26124),
(112732,'enUS','Decrepit whelps! Your efforts are meaningless!','',26124),
(112739,'enUS','Weak, spineless beings. Your fate has been decided.','',26124),
(112740,'enUS','The kingdom of Stromgarde is mine by birthright. With the legendary Trol\'kalar in hand, none can dispute my rule. Not even Sylvanas!','',26124),
(112741,'enUS','This is the place. Unfortunately it\'s teeming with murlocs.','',26124),
(112742,'enUS','If you can take out those murlocs, it\'ll be easy fishing for the rest of the day.','',26124),
(112743,'enUS','Use Fan of Knives!','',26124),
(112744,'enUS','You\'re facing multiple enemies, try using Fan of Knives!','',26124),
(112745,'enUS','Use Shadowstep!','',26124),
(112746,'enUS','Use Evasion to reduce damage!','',26124),
(112747,'enUS','Use Crimson Vial to restore health!','',26124),
(112748,'enUS','You\'re in trouble! Use Vanish!','',26124),
(112749,'enUS','Use Envenom!','',26124),
(112750,'enUS','You have 5 combo points. Use Envenom!','',26124),
(112751,'enUS','Use Rupture!','',26124),
(112752,'enUS','You have 5 combo points. Use Rupture!','',26124),
(112753,'enUS','Use Mutilate to generate combo points!','',26124),
(112754,'enUS','Use Mutilate!','',26124),
(112755,'enUS','Use Garrote!','',26124),
(112756,'enUS','Use Garrote to bleed your enemy!','',26124),
(112757,'enUS','Starting combat from stealth is more effective.','',26124),
(112758,'enUS','Use Deadly Poison on your weapon.','',26124),
(112759,'enUS','Practice using Sprint to increase your movement speed.','',26124),
(112760,'enUS','Ever needed to get out of a sticky situation quickly? Rogues excel at doing this. Sprint increases your movement speed significantly for a short time, and can be used fairly frequently. I want to see you run, rogue!','',26124),
(112761,'enUS','Use Fan of Knives to dispatch this group of enemies.','',26124),
(112762,'enUS','Enemies that try to surround you will be in for a nasty surprise!','',26124),
(112763,'enUS','Use Shadowstep to appear behind a distant target.','',26124),
(112764,'enUS','There are times that you might want to close in on a target but not deal damage right away.','',26124),
(112765,'enUS','Use Evasion to increase your chance to dodge incoming attacks.','',26124),
(112766,'enUS','A rogue\'s reflexes are far superior to those of the average person. In times of extreme danger, a rogue can rely on these catlike reflexes to avoid almost any physical attack for a short time. Evasion can\'t be used too often, so save it for emergencies.','',26124),
(112767,'enUS','Use Crimson Vial to restore some of your health.','',26124),
(112768,'enUS','You\'ve taken some damage, but luckily a crafty rogue plans ahead.','',26124),
(112769,'enUS','Show me you\'ve got the stuff, $p!','',26124),
(112770,'enUS','Well done, $p! You are now prepared to do battle as an assassination rogue.','',26124),
(112771,'enUS','Use Vanish to evade my soldier.','',26124),
(112772,'enUS','There\'s just one last thing you need to learn.','',26124),
(112773,'enUS','Use Envenom with 5 combo points.','',26124),
(112774,'enUS','Rupture is not your only finishing move.','',26124),
(112775,'enUS','Use Rupture with 5 combo points.','',26124),
(112776,'enUS','Now that you\'ve built up 5 combo points, it\'s time to use Rupture.','',26124),
(112777,'enUS','Use Mutilate to attack the target dummy.','',26124),
(112778,'enUS','Your main attack is called Mutilate. It deals damage as well as generates combo points that can be used for powerful finishing moves.','',26124),
(112779,'enUS','Always remember to use Garrote to keep your enemies bleeding.','',26124),
(112780,'enUS','Use Garrote on this target dummy.','',26124),
(112781,'enUS','As an assassin, you weaken your enemies before finishing them off.','',26124),
(112782,'enUS','Use Stealth to fade from view.','',26124),
(112783,'enUS','Stealth makes you invisible to most enemies. When in Stealth, you can close the distance to enemies undetected.','',26124),
(112784,'enUS','Assassins favor trickery and cunning. And what\'s trickier than attacking before your target sees you coming?','',26124),
(112785,'enUS','Use Deadly Poison to coat your weapon with poison for one hour.','',26124),
(112786,'enUS','As an assassination rogue you specialize in striking from the shadows, dispatching foes with a variety of poisons and bleeding attacks.','',26124),
(112787,'enUS','I gave Arrexis a piece so he could attune his ritual to demonic energies. You may have what remains of the stone. May it bring better luck to you.','',26124),
(112788,'enUS','Excellent, child. You crave power as much as I.','',26124),
(112789,'enUS','Together, we will do great things.','',26124),
(112790,'enUS','Yes...','',26124),
(112791,'enUS','More. I must have more.','',26124),
(112792,'enUS','This world is steeped in magic. You need only grasp it.','',26124),
(112793,'enUS','Such power... it courses through me.','',26124),
(112794,'enUS','They seek to control us, to check our power. Do not allow it.','',26124),
(112795,'enUS','You are ambitious, child. Like the one before you.','',26124),
(112796,'enUS','Arcane energies knit this world together... do you feel it, child?','',26124),
(112797,'enUS','I drink... but I am never fulfilled...','',26124),
(112798,'enUS','Together we can remake this world.','',26124),
(112799,'enUS','They call you \"hero.\" Why, child, do you concede to their every whim?','',26124),
(112800,'enUS','Its energy sustains me.','',26124),
(112801,'enUS','More. Find more.','',26124),
(112802,'enUS','Yes, child. Such... potential.','',26124),
(112803,'enUS','Fulfill your calling, child. Do not stop.','',26124),
(112804,'enUS','We work well together.','',26124),
(112805,'enUS','There is energy here.','',26124),
(112806,'enUS','There are others. Find them. Destroy them.','',26124),
(112807,'enUS','None can hide from our wrath.','',26124),
(112808,'enUS','Yes, yes...','',26124),
(112809,'enUS','I will consume it.','',26124),
(112810,'enUS','So much power.','',26124),
(112811,'enUS','You are learning, child.','',26124),
(112812,'enUS','I will arrange transportation at Krasus\' Landing. Talk to the flight master when you are ready.','',26124),
(112813,'enUS','While I do not have the same strength outside of Dalaran, I will be with you \"in spirit,\" as it were.','',26124),
(112814,'enUS','','Coward! There is no hole you can hide in that we cannot follow.',26124),
(112815,'enUS','','The Underking is not getting away. Not this time.',26124),
(112816,'enUS','Brother Shadowgaze, it is time for our glorious ascension. Make haste to Darkshire.','',26124),
(112817,'enUS','Meryl Felstorm says you have a ride for me to Faronaar.','Meryl Felstorm says you have a ride for me to Faronaar.',26124),
(112818,'enUS','Sister Ebonlocke has gathered the Skull and Blood of the Innocents. She awaits your escort.','',26124),
(112819,'enUS','May the Legion guide you, and do not forget to destroy this letter. We must leave nothing to chance.','',26124),
(112821,'enUS','A collection of your notes on the \"Veiled Hand\" cult.','A collection of your notes on the \"Veiled Hand\" cult.',26124),
(112822,'enUS','The light shines in Westfall for another day, thanks to all of you. But we must remain vigilant!','',26124),
(112823,'enUS','$n, I have been expecting you, though not the traitor, Altruis.','',26124),
(112824,'enUS','Uh oh. It looks like the inner vault has been breached! We\'d better see if the Nightborne Soulstone has been taken...','',26124),
(112825,'enUS','Taking','Taking',26124),
(112826,'enUS','Illidan.','',26124),
(112827,'enUS','No matter. There is little time.','',26124),
(112828,'enUS','I entrusted the duplicitous Akama with planning the campaign against the Legion.','',26124),
(112829,'enUS','You did it, $p! Now let\'s fish up those frenzies!','',26124),
(112830,'enUS','He alone knows every detail. You will need his counsel if you are to succeed.','',26124),
(112831,'enUS','You must also regain the Sargerite Keystone to invade the Legion\'s worlds.','',26124),
(112832,'enUS','Find out where the Wardens hid it away.','',26124),
(112833,'enUS','We have attracted attention. I must move.','',26124),
(112834,'enUS','You will not be able to contact me like this again. The Illidari are now yours, $n.','',26124),
(112835,'enUS','Blast! It\'s gone! That Vargoth is going to be sorry when I catch up with him!','',26124),
(112836,'enUS','He was here very recently -- he can\'t have gotten too far ahead!','',26124),
(112837,'enUS','$n, I have been expecting you. Ah good... Kayn Sunfury.','',26124),
(112838,'enUS','My lord.','',26124),
(112839,'enUS','There is little time. Listen closely.','',26124),
(112840,'enUS','Vindictive Spirit stares in your direction.','',26124),
(112842,'enUS','Vindictive Spirit emits an empty howl.','',26124),
(112843,'enUS','','Disaster abounds here. Elf ruins filled with unquiet souls ripe for harvest.',26124),
(112844,'enUS','','The dragons are weak here. You would do well to exploit this fact.',26124),
(112845,'enUS','','The Legion burrows deep here. If they burrow deeper, they may not like what they find.',26124),
(112846,'enUS','','The spawn of the titans infest this area. Despite our \"gift\" of flesh, they still worship those false gods.',26124),
(112847,'enUS','','Helya and her cult are strong here. So close to the truth, yet so far.',26124),
(112848,'enUS','','Do not be impressed by tall icons of the titans which stand here. The towers of sacrifice in Ny\'alotha dwarf these pathetic temples.',26124),
(112849,'enUS','Enough! Get out of our city!','Enough! Get out of our city!',26124),
(112850,'enUS','We cannot endure your presence any longer!','We cannot endure your presence any longer!',26124),
(112851,'enUS','Hush, they are nearby.','Hush, they are nearby.',26124),
(112852,'enUS','Your vile magic is an abomination!','Your vile magic is an abomination!',26124),
(112853,'enUS','What is Elisande thinking, letting them in?','What is Elisande thinking, letting them in?',26124),
(112854,'enUS','Monsters...','Monsters...',26124),
(112855,'enUS','','This city of elves pales in comparison to the sleeping city...',26124),
(112856,'enUS','','Suramar, its \"noble\" citizens greedily slurping at their world\'s very lifeblood.',26124),
(112857,'enUS','','The fallen elves cower behind their wall. They know no other way...',26124),
(112858,'enUS','Ring around the city...','',26124),
(112859,'enUS','Hearts are full of pity...','',26124),
(112860,'enUS','Crashing! Clashing!','',26124),
(112861,'enUS','Outside lies doom.','',26124),
(112862,'enUS','Teacher said my magic was strongest!','',26124),
(112863,'enUS','No fair, I never get to be the Grand Magistrix!','',26124),
(112864,'enUS','My parents say I\'m too young for arcwine.','',26124),
(112865,'enUS','','The fallen Aspect\'s lair is near. He was the strongest of them, and yet the easiest one for us to corrupt.',26124),
(112866,'enUS','You can\'t break through the force fields! The shields are too strong!','',26124),
(112867,'enUS','Pew pew pew! Lightning Missiles!','',26124),
(112868,'enUS','Pew pew pew! Lightning Missiles!','Pew pew pew! Lightning Missiles!',26124),
(112869,'enUS','You can\'t break through the force fields! The shields are too strong!','You can\'t break through the force fields! The shields are too strong!',26124),
(112870,'enUS','My parents say I\'m too young for arcwine.','My parents say I\'m too young for arcwine.',26124),
(112871,'enUS','No fair, I never get to be the Grand Magistrix!','No fair, you always get to be the Grand Magistrix!',26124),
(112872,'enUS','Teacher said my magic was strongest!','Teacher said my magic was strongest!',26124),
(112873,'enUS','','Outside lies doom.',26124),
(112874,'enUS','','Crashing! Clashing!',26124),
(112875,'enUS','','Hearts are full of pity...',26124),
(112876,'enUS','','Ring around the city...',26124),
(112877,'enUS','Invisibility!','Invisibility!',26124),
(112878,'enUS','I can still see you.','I can still see you.',26124),
(112879,'enUS','Look at what I can do!','Look at what I can do!',26124),
(112880,'enUS','','More of the titans\' failed experiments grow here unchecked. The drogbar prove their failure as creators.',26124),
(112881,'enUS','','The tauren here are remarkably resilient to corruption, considering their origins.',26124),
(112882,'enUS','','To see Yogg-Saron\'s nightmare in full bloom fills me with jealousy... and some pride.',26124),
(112883,'enUS','','Here you will see why the Legion\'s invasion is ultimately futile. All can be corrupted, dreams and demons alike.',26124),
(112884,'enUS','','The elves here are desperate to save themselves from the Nightmare, while the demons seek to harness its might. Both will fail.',26124),
(112885,'enUS','','So much fury in this soul! It will be a good harvest.',26124),
(112886,'enUS','','Another tortured soul, long overdue for oblivion. I am more interested in his advisor, though...',26124),
(112887,'enUS','','Xavius\'s tricks are cunning. Why reveal yourself when you can control from afar?',26124),
(112888,'enUS','','It is possible N\'Zoth may be responsible for her form, but her arrogance is all her own.',26124),
(112889,'enUS','','Behold the wasted power of the titans before you, done in their name, no less.',26124),
(112890,'enUS','','Skovald seeks to join the ranks of the destroyers, unaware that so many of those who dare are betrayed.',26124),
(112891,'enUS','','Odyn was a great enemy... until his own arrogance proved his undoing. You should ask him if he has considered Loken\'s final words to him. Go ahead!',26124),
(112892,'enUS','','Ymiron was a fine tool. He did more to spread the blessing of flesh than any other of his kind.',26124),
(112893,'enUS','The people of this land bought their freedom from the Legion, a price paid in blood. A sacrifice made in vain, as you shall soon see.','',26124),
(112894,'enUS','Strong, powerful, cunning... dragons would make ideal minions if they were only more... subservient.','',26124),
(112895,'enUS','Look at the land, see how the Legion has drained it of every useful bit of magic? Not even the soul of a worm remains! Such efficiency must be praised!','',26124),
(112896,'enUS','This place is nothing compared to Mac\'Aree, and soon it will burn with hellfire just the same.','',26124),
(112897,'enUS','The elves of this land wither away for lack of magic. Pathetic! They could have easily taken it from others.','',26124),
(112898,'enUS','The elves huddle behind their walls for protection. Fools! The very world around them will crumble if the Legion is victorious!','',26124),
(112899,'enUS','Well done everyone!','Well done everyone!',26124),
(112900,'enUS','For the Alliance!','For the Alliance!',26124),
(112901,'enUS','We did it!','We did it!',26124),
(112902,'enUS','We prevail!','We prevail!',26124),
(112903,'enUS','Brothers and sisters in arms!','Brothers and sisters in arms!',26124),
(112904,'enUS','','Oh look, master! A city full of naughty little elves!',26124),
(112905,'enUS','Who goes there?','Who goes there?',26124),
(112906,'enUS','Reveal yourself!','Reveal yourself!',26124),
(112907,'enUS','A curse upon you, shaman. Destroy $ghim:her; my pets!','',26124),
(112908,'enUS','Did you hear that?','Did you hear that?',26124),
(112909,'enUS','The shadows grow dark in this place.','',26124),
(112910,'enUS','','What\'s that? Speak into my good ear.',26124),
(112911,'enUS','The void reaches out to this land.','',26124),
(112912,'enUS','A city? Do we HAVE to go in there!?','',26124),
(112913,'enUS','I will enjoy seeing this city destroyed.','',26124),
(112914,'enUS','Good luck, $n. Use my crystal to speak with me inside.','',26124),
(112915,'enUS','','What a miserable excuse for a city.',26124),
(112916,'enUS','Look at this city! So much magic to feed upon!','',26124),
(112917,'enUS','Ah, fresh meat for the spit!','',26124),
(112918,'enUS','I\'ll eat your... heart...','',26124),
(112919,'enUS','Weak creatures, ripe for the slaughter!','',26124),
(112920,'enUS','Come! The fal\'dorei make their home in the ruins below.','',26124),
(112921,'enUS','Down. Follow the water.','',26124),
(112922,'enUS','','You make the most amusing pet, little elf.',26124),
(112923,'enUS','','Know your place, worm.',26124),
(112924,'enUS','','You are our playthings, little one. Remember that.',26124),
(112925,'enUS','','Kneel before your betters, whelp.',26124),
(112926,'enUS','','Get used to groveling, Nightborne.',26124),
(112927,'enUS','','Hide for now. I will find you soon...',26124),
(112928,'enUS','','Very well. Enjoy your freedom... while it lasts.',26124),
(112929,'enUS','','Hmm, maybe nothing after all...',26124),
(112930,'enUS','','What do we have here? Someone hiding?',26124),
(112931,'enUS','','Come out, come out, little one...',26124),
(112932,'enUS','','You can run, but you cannot hide, sweetling...',26124),
(112933,'enUS','The third fleet has been deployed against the southern shores of the Broken Isles.','',26124),
(112934,'enUS','No word has reached us from the front lines?','',26124),
(112935,'enUS','Only a handful of scouts have returned, none recently.','',26124),
(112936,'enUS','Troubling.','',26124),
(112937,'enUS','I can help you over here, $n.','',26124),
(112938,'enUS','','You are too late, mortal!',26124),
(112939,'enUS','','Brinebeard, rise again! Serve the Legion in undeath!',26124),
(112940,'enUS','','Tear this weakling apart, Brinebeard. I have business elsewhere...',26124),
(112941,'enUS','Stay inside the shrine and avoid the whirlwinds','',26124),
(112942,'enUS','','What\'s that you say? Moozy is where?',26124),
(112943,'enUS','Your family is at the Hammer\'s Cradle.','Your family is at the Hammer\'s Cradle.',26124),
(112944,'enUS','','Can\'t see you, $n!',26124),
(112945,'enUS','','Slow down, $gbull calf:heifer;!',26124),
(112946,'enUS','','Why is everyone always in such a hurry?',26124),
(112947,'enUS','','I guess you\'d rather I fall off the edge of Thunder Totem than escort me.',26124),
(112948,'enUS','','There was a time when young ones were nice to old ladies.',26124),
(112949,'enUS','','Wait for me!',26124),
(112950,'enUS','','Get where I can see you!',26124),
(112951,'enUS','','Come closer, $r.',26124),
(112952,'enUS','','Ah, these old bones haven\'t moved in a while.',26124),
(112953,'enUS','','What a nice young $gman:woman;.',26124),
(112954,'enUS','','Let\'s go see Moozy!',26124),
(112955,'enUS','','My daughter really is a beautiful woman.',26124),
(112956,'enUS','','When do you think Sella will give me more grandchildren?',26124),
(112957,'enUS','','Have you seen Moozy\'s smile? Gets it from me, I suspect.',26124),
(112958,'enUS','','Little Moozy is a gorgeous calf.',26124),
(112959,'enUS','','What are you waiting for? Let\'s get moving!',26124),
(112960,'enUS','No... No!','No... No!',26124),
(112961,'enUS','Help us!','Help us!',26124),
(112962,'enUS','An intriguing turn of events. I will see you up top.','',26124),
(112963,'enUS','I will see you up top. We will break the news together.','',26124),
(112964,'enUS','Collect ten globules of living water without getting attacked','',26124),
(112965,'enUS','Return to Hydrannon without getting attacked','',26124),
(112966,'enUS','Emmarel! Commander! Have you seen it?','',26124),
(112967,'enUS','I heard something over here.','I heard something over here.',26124),
(112968,'enUS','What was that?','What was that?',26124),
(112969,'enUS','There\'s someone here.','There\'s someone here.',26124),
(112970,'enUS','We aren\'t alone, brothers and sisters.','We aren\'t alone, brothers and sisters.',26124),
(112971,'enUS','Illidan\'s soul has spoken. Our way forward is clear.','',26124),
(112972,'enUS','Look to the sky! It\'s happening, above the lodge!','',26124),
(112973,'enUS','Forgive me $pc, this may hurt a little.','Forgive me $pc, this may hurt a little.',26124),
(112974,'enUS','','Calm down, Pierce. What are you talking about?',26124),
(112975,'enUS','We have consulted with the Master\'s soul and gained wisdom.','',26124),
(112976,'enUS','The emergency signal flares. They\'re being fired above the lodge!','',26124),
(112977,'enUS','Look for yourself!','',26124),
(112978,'enUS','More bones for the Legion!','',26124),
(112979,'enUS','All hail, $n, our new leader. Illidari, salute!','',26124),
(112980,'enUS','','It can\'t be... Those flares haven\'t been used in hundreds of years.',26124),
(112981,'enUS','You are... too late...','',26124),
(112982,'enUS','Illidari, salute our new leader, $n!','',26124),
(112983,'enUS','','We must follow protocol. Whoever is firing those flares obviously needs our help.',26124),
(112984,'enUS','Alas, poor Nythendra! She served faithfully as Guardian of the Dream, only to be perverted into a gatekeeper of corruption.','',26124),
(112985,'enUS','We must put an end to the Nightmare. Say the word and I will take us into the heart of that twisted place.','',26124),
(112986,'enUS','I have faced the Nightmare before, but never has it had so thorough a stranglehold on the Dream. It hungers, desperate to seed its corruption. Do not let its whispers seduce you into madness!','',26124),
(112987,'enUS','I sense the touch of Cenarius upon this Iris. It is a portal that leads to Moonglade, but the way has been sealed by dark magic. We must sever the tendrils of power that bind it.','',26124),
(112988,'enUS','From each of these pathways, a palpable evil emanates. Choose a course, and know that I will stand with you.','',26124),
(112989,'enUS','','Let\'s make our way to the watch tower.',26124),
(112990,'enUS','If you need further proof of how insidious the Nightmare is, look there! Even the fierce heart of Ursoc has succumbed. Release him, I beg you!','',26124),
(112991,'enUS','Truly there was never a soul more noble than Ursoc\'s. I pray his spirit finds its way back to the Dream.','',26124),
(112992,'enUS','This was the Emerald Dreamway. During my long slumber, it was here I communed with the Green Dragonflight.','',26124),
(112993,'enUS','Now this sacred place has been made into a conduit for the Nightmare to spread its corruption. This we cannot allow!','',26124),
(112994,'enUS','','We will not be stopped!',26124),
(112995,'enUS','Oh Ysondre! How cruel fate can be! Cleansed of the Nightmare once before, only to become its victim yet again. Some wounds never truly heal.','',26124),
(112996,'enUS','May you find peace at last, old friend.','',26124),
(112997,'enUS','What manner of foul creature is this? It seems poised to unleash its corruption upon Thunder Bluff! The spirit of the tauren people must not fall prey to the Nightmare!','',26124),
(112998,'enUS','I\'m going to find that Soulstone if it\'s the last thing I do!','',26124),
(112999,'enUS','The illusion of corruption falls away! Behold a druid who was as a sister to me... Elerethe Renferal. I feel her loss keenly, heroes.','',26124),
(113000,'enUS','The Twilight\'s Hammer ambushed and murdered Elerethe, misleading her into believing Hamuul Runetotem played a part in her death. It seems her spirit was so twisted that she sought to take vengeance upon all of Thunder Bluff.','',26124),
(113001,'enUS','You had a deep love for the lands of Alterac, old friend. I vow to tend the vale in your name.','',26124),
(113002,'enUS','What horror is this? A tumor of Nightmare infecting a world tree, here in the reflection of the titans\' own playground?','',26124),
(113003,'enUS','If this seed takes hold, the roots of its infestation will wind their way into the heart of Azeroth. The Nightmare would devour our world, claiming everything... everyone. This must not come to pass!','',26124),
(113004,'enUS','No doubt Xavius and his ancient master delight that so much of our attention goes into fighting the Legion. Their insidious shadow seeps into our world, distracting us with whispers and doubts.','',26124),
(113005,'enUS','Once I get that Soulstone, nobody will be able to stop me!','',26124),
(113006,'enUS','Pray that purging the Nightmare\'s corruption buys us enough time to defeat the Legion and catch our breath before the black armies rise up from the depths.','',26124),
(113007,'enUS','Enough! I grow tired of this.','',26124),
(113008,'enUS','Behold, the Iris opens! The way to Cenarius is clear.','',26124),
(113009,'enUS','Moonglade is the most sacred place in all the Dream. To think that my shan\'do could play any part in its corruption...','',26124),
(113010,'enUS','I must see with my own eyes what horrors have befallen my beloved teacher. Steel your hearts against the darkness, heroes.','',26124),
(113011,'enUS','Now that is a fancy weapon? You should let me borrow it sometime!','',26124),
(113012,'enUS','The Aegis will be mine you fools, and there\'s nothing you can do to stop me.','',26124),
(113013,'enUS','Of course, if I had a fancy weapon like yours I\'d be running this place!  And much more competently, I might add.','',26124),
(113014,'enUS','Did you know the Nightborne Soulstone can be used to control millions of people? I\'m sure going to have some fun when I get it!','',26124),
(113015,'enUS','Vargoth and his limited intellect will never be able to unlock the Soulstone\'s full potential. I\'m the only one who can really show you what it can do!','',26124),
(113016,'enUS','','The Herald has promised us freedom and respect. We will not be denied!',26124),
(113017,'enUS','','You will not interfere. The Legion will rise!',26124),
(113019,'enUS','','Archmage, we saw your flares. Please let us know how we can help.',26124),
(113020,'enUS','','Mother!',26124),
(113021,'enUS','','There\'s my Moozy...',26124),
(113022,'enUS','Assassin! Run for your lives!','',26124),
(113023,'enUS','I\'m sure those tauren will be back any minute.\n\nTill then, how can I help you, chum?','',26124),
(113024,'enUS','Why are you moving the taurens\' goods over to your zeppelin?','Why are you moving the taurens\' goods over to your zeppelin?',26124),
(113025,'enUS','Oh, we got a... business arrangement with them. \n\nYeah, they want us to fly this stuff over to Dalaran and sell it for them there. After all, there aren\'t a whole lot of people to sell it to here, right? And who\'s a better salesperson than a goblin? \n\nThose tauren sure have an eye for business!','',26124),
(113026,'enUS','Shhh! Someone\'s coming...','',26124),
(113027,'enUS','Oh, hey there, chum.  How can we help?','',26124),
(113028,'enUS','...probably dragon food by now...','',26124),
(113029,'enUS','Don\'t be so sure... Hey there, friend!','',26124),
(113030,'enUS','Can you hear me through this thing, $n? You should be near Verstok\'s location by now.','',26124),
(113031,'enUS','...they\'re starting to smell. Think we should mo-','',26124),
(113032,'enUS','Shhh!','',26124),
(113033,'enUS','My foolish protege was in such a rush to escape the Shrine, I\'ll wager he failed to mask his scent. Shift into cat form and you\'ll likely detect it.','',26124),
(113034,'enUS','','All goes as planned. Once Brother Shadowgaze arrives, we leave for Stormwind!',26124),
(113035,'enUS','Show them no mercy.','Show them no mercy.',26124),
(113036,'enUS','','Do give Lan\'dalock my love, $n.',26124),
(113037,'enUS','The Legion shows no mercy.','The Legion shows no mercy.',26124),
(113038,'enUS','Our presence will remain.','Our presence will remain.',26124),
(113039,'enUS','The Burning Legion will fall!','The Burning Legion will fall!',26124),
(113040,'enUS','Swift blades and unrelenting devotion. Nothing less.','Swift blades and unrelenting devotion. Nothing less.',26124),
(113041,'enUS','Do you feel their presence growing?','Do you feel their presence growing?',26124),
(113042,'enUS','Our battle has only just begun.','Our battle has only just begun.',26124),
(113043,'enUS','Careful! The ruins are infested by withered, pitiful creatures with an unending hunger for the arcane. The power of the Fangs might have lured some to Verstok\'s trail.','',26124),
(113044,'enUS','The Burning Legion has returned.','The Burning Legion has returned.',26124),
(113045,'enUS','Shame you were not prepared.','Shame you were not prepared.',26124),
(113046,'enUS','Your strength was no match.','Your strength was no match.',26124),
(113047,'enUS','You are no match for the Illidari.','You are no match for the Illidari.',26124),
(113048,'enUS','When you return, I\'ll be ready.','When you return, I\'ll be ready.',26124),
(113049,'enUS','Whatever you did seems to have annoyed those withered. This might work to your advantage. See if you can find another switch.','',26124),
(113050,'enUS','I expected more of a fight.','I expected more of a fight.',26124),
(113051,'enUS','You were in charge of the tracking units!','',26124),
(113052,'enUS','Don\'t think you stand a chance simply because you have come this far. You are nothing! NOTHING!','',26124),
(113053,'enUS','Maybe our camouflage module was a bit too effective.','',26124),
(113054,'enUS','Well, it was your idea to give them free will!','',26124),
(113055,'enUS','My forces are limitless!','',26124),
(113056,'enUS','If we are going to get Rush and Treble back, we\'re going to need some help...','',26124),
(113057,'enUS','So long sucker!','',26124),
(113058,'enUS','The Nightborne Soulstone is mine. You are becoming quite a nuisance.','',26124),
(113059,'enUS','Thousands of worlds will be mine to conquer!','',26124),
(113060,'enUS','Lady Kyranith, meet me at the Oculus once you\'ve taken care of our overly ambitious friends here.','',26124),
(113061,'enUS','Minions of the Legion, destroy these worms!','',26124),
(113062,'enUS','Treble!','',26124),
(113063,'enUS','He seems to like you. Will you take care of him for me?','',26124),
(113064,'enUS','Cower before the might of the Legion!','',26124),
(113065,'enUS','Feel my gaze, and despair!','',26124),
(113066,'enUS','Run! Cower! Scream!','',26124),
(113067,'enUS','Your shield cannot protect you any longer!','',26124),
(113068,'enUS','Begone, wretch!','',26124),
(113069,'enUS','Foolish surface-dwellers! Be gone!','',26124),
(113071,'enUS','','Silence, insect!',26124),
(113072,'enUS','','Where is your magic now?',26124),
(113073,'enUS','','Let\'s test your immortality, shall we?',26124),
(113074,'enUS','','I will not suffer a fool!',26124),
(113075,'enUS','','Mind the landing, dear.',26124),
(113076,'enUS','Grr... Persistent vermin...','',26124),
(113077,'enUS','Demon hunter, that imp just stole the grimoire. Catch it!','',26124),
(113078,'enUS','An imp? What\'s going on here, $n?','',26124),
(113079,'enUS','Do you think we don\'t know what you\'re up to, $n?','',26124),
(113080,'enUS','','The Illidari believe themselves untouchable. They will soon learn better.',26124),
(113081,'enUS','Oh, goodie. A new box of toys!','',26124),
(113082,'enUS','Brothers and sisters - today we defend our lands against the blight of the Burning Legion. We are strong. We are one. For the Horde!','',26124),
(113083,'enUS','Even my blade couldn\'t protect me from those things.','',26124),
(113084,'enUS','Caught off guard! I\'ll be back before this is over!','',26124),
(113085,'enUS','Vrykul Shepherd calls for help from his flock.','',26124),
(113086,'enUS','The Vrykul Shepherd calls out to his flock again, hoping for further assistance.','',26124),
(113087,'enUS','The Vrykul Shepherd pleads with his flock once more, hoping for any assistance.','',26124),
(113088,'enUS','Come and get it!','',26124),
(113089,'enUS','Come and get it!','',26124),
(113090,'enUS','The Fangs are mine! MINE!!','',26124),
(113092,'enUS','I see you! You may look like a druid, but I can tell you\'re a demon in disguise. I won\'t fall for your trick! You\'ll never get the Fangs from me!','',26124),
(113093,'enUS','Has Verstok gone mad? Wielding the Fangs enhances one\'s senses, but I\'m afraid it also heightened his paranoia.','',26124),
(113094,'enUS','','The Wardens are now few in number, yet justice must not rest, friend. Aid us in dispatching this foul creature. Show the people of this land that the Wardens remain ever vigilant!',26124),
(113095,'enUS','','We thank you for your service. As the tides of power ebb and flow unchecked in this land, be on your guard.',26124),
(113096,'enUS','I cannot find your papers, citizen.','',26124),
(113097,'enUS','Good luck out there!','',26124),
(113098,'enUS','You\'re assigned to the Victory.','',26124),
(113099,'enUS','For the Alliance!','',26124),
(113100,'enUS','Stormwind appreciates your service!','',26124),
(113101,'enUS','Victory awaits, soldier!','',26124),
(113102,'enUS','Leave, demon! Begone! Why won\'t you just GO AWAY!?','',26124),
(113103,'enUS','Don\'t give them any quarter!','',26124),
(113104,'enUS','You must get the Fangs away from Verstok, $n. The longer they remain in his possession, the greater his delusion becomes.','',26124),
(113105,'enUS','','Scary...',26124),
(113106,'enUS','','Ahhh!',26124),
(113107,'enUS','','Let\'s play somewhere else for a while.',26124),
(113108,'enUS','','Don\'t eat me!',26124),
(113109,'enUS','','Hide! They\'ll eat you!',26124),
(113111,'enUS','My kodo! They\'ll pay for this!','',26124),
(113112,'enUS','My livestock! You ugly demon-horned filth!','',26124),
(113113,'enUS','','With pleasure.',26124),
(113114,'enUS','Squad reporting for duty!','Squad reporting for duty!',26124),
(113116,'enUS','Show yourselves. I don\'t have time for games.','',26124),
(113117,'enUS','','Step aside, Shaw! All of Stormwind will burn unless we finish our work.',26124),
(113119,'enUS','East of the Crossroads! A structure just formed out of nothing!','',26124),
(113120,'enUS','You won\'t leave? Very well, I\'ll end this chase myself!','',26124),
(113121,'enUS','No! I\'ll never submit!','',26124),
(113130,'enUS','','You disappoint me, King of Stormwind. But sooner or later, you will see the truth. You all will!',26124),
(113131,'enUS','','Great... It\'s Shaw.',26124),
(113132,'enUS','We\'re aware of the Veiled Hand\'s activites. The city is locked down while WE handle the situation.','',26124),
(113133,'enUS','No one enters these gates until this is resolved... especially the two of you!','',26124),
(113134,'enUS','Ah, you\'ve arrived! I\'ve already begun. I trust Alodi is with you?','',26124),
(113135,'enUS','I\'m here, though my powers are weakened so far from the hall.','',26124),
(113136,'enUS','Do what you can, old friend. Welcome to Faronaar, a key invasion point for the Legion!','',26124),
(113137,'enUS','While I distract the defenders below, you will setup the ritual wards at key locations.','',26124),
(113138,'enUS','Here\'s a spell that will conjure the wards. Three should be sufficient.','',26124),
(113140,'enUS','When you are done, meet me at the Altar of End Times. Its location should be obvious. Good luck!','',26124),
(113141,'enUS','Stay out of this, half-breed.','',26124),
(113146,'enUS','The doors are shut? Look around the courtyard for something that might open them. Just be mindful of the withered.','',26124),
(113147,'enUS','','It\'s hiding on the shelf. Adorable.',26124),
(113149,'enUS','Filthy demons! They feed upon the blue dragonflight! Have all the defenders fallen?','',26124),
(113150,'enUS','Argh! What is this? Release me at once!','',26124),
(113151,'enUS','That Legion vessel looming above shows what\'s at stake. Truly this is a fight to save our world!','',26124),
(113152,'enUS','Here is good. This is what the Council was supposed to prevent. How could it have gone so wrong?!','',26124),
(113153,'enUS','The Arcway Vaults have likely been breached by Legion invaders as well as our old friend, Millhouse Manastorm. Although he is far from trustworthy, I suspect we may be able to take advantage of his rather creative skills.','',26124),
(113154,'enUS','Look what fell into my web! Tonight I shall feast!','',26124),
(113155,'enUS','I have little patience for this so-called king, his dilapidated keep, and the delusional followers that hang on his every word.','',26124),
(113160,'enUS','','Hey, we don\'t serve demons here. It\'ll have to wait outside!',26124),
(113161,'enUS','','Arrogant bastard! If we are going to find the Herald, we\'re going to need a diversion, something big. Hmm...',26124),
(113162,'enUS','$n - you wield the fist of the Stormkeeper! I will not fight you.','',26124),
(113163,'enUS','You may pass, shaman.','',26124),
(113164,'enUS','You are the keeper of storms, $n. I will not bar you from this path.','',26124),
(113165,'enUS','I see the weapon you wield, $n, and I will obey.','',26124),
(113166,'enUS','','Ah, yes! Find agent Elling Trias in the Trade District. He should have a smoke bomb. If we set it off somewhere public, the guards will be forced to react.',26124),
(113167,'enUS','','While they are busy investigating the ruckus, we should be able to gather some information and act on it without the risk of heavy reinforcements.',26124),
(113168,'enUS','You may pass, $n. The storms here will not trouble you.','',26124),
(113170,'enUS','The Highkeeper\'s chosen one has arrived. $n, the elements will not trouble you here.','',26124),
(113173,'enUS','You wield the Fist of our master, $n. No storm will trouble you here.','',26124),
(113174,'enUS','Approach the summit, $n. You wield the Fist of Storms, and your coming was foretold on the wind.','',26124),
(113176,'enUS','','Let\'s move. I\'ll be right behind you.',26124),
(113177,'enUS','That sneaky imp! It headed southeast and then turned invisible.','',26124),
(113178,'enUS','Quickly, $n, use your spectral sight and see if you can spot it.','',26124),
(113179,'enUS','What on Azeroth was that!? Be careful, $n!','',26124),
(113182,'enUS','Let me see...','',26124),
(113183,'enUS','Silgryn quickly shuffles through the stack of letters.','',26124),
(113184,'enUS','Hm. They\'ve been rounding up a lot of people lately. Children, too.','',26124),
(113185,'enUS','','Do you think Korine could be with the other children?',26124),
(113186,'enUS','Very possible. I\'ll have our friend here follow a guard in and find out.','',26124),
(113189,'enUS','There she is!','',26124),
(113190,'enUS','She must not open the seed!','',26124),
(113191,'enUS','Freedom! I thought I was going to be spider food!','',26124),
(113192,'enUS','My brush with death cleared my head. Everything I saw was a threat, I\'m sorry I struck out at you.','',26124),
(113193,'enUS','I wanted to protect the Fangs, but was soon overwhelmed. You\'ve proven yourself far more capable as their protector. Please, take them.','',26124),
(113194,'enUS','A sip is all I can offer for now...','',26124),
(113195,'enUS','This should ease the pain for a little while.','',26124),
(113196,'enUS','Drink it slowly, make it last.','',26124),
(113197,'enUS','Slowly now, we do not want to waste a drop.','',26124),
(113198,'enUS','There you are. Thank you for your patience.','',26124),
(113199,'enUS','It is not much, but please take it.','',26124),
(113200,'enUS','I will try to have more tomorrow. This is all I can offer for now.','',26124),
(113201,'enUS','This should be enough for your children.','',26124),
(113202,'enUS','','|TInterface\\Icons\\sha_ability_rogue_envelopingshadows_nightmare:20|tA Lumbering Mindgorger forms in the mists of Ashenvale!',26124),
(113203,'enUS','','|TInterface\\Icons\\sha_ability_rogue_envelopingshadows_nightmare:20|tA Lumbering Mindgorger forms in the mists of The Hinterlands!',26124),
(113204,'enUS','','|TInterface\\Icons\\sha_ability_rogue_envelopingshadows_nightmare:20|tA Lumbering Mindgorger forms in the mists of Feralas!',26124),
(113205,'enUS','','I hope you will bring no storms to this peaceful grove, $n.',26124),
(113206,'enUS','Sir, yes, sir! Nobody enters the city on our watch.','Sir, yes, sir! Nobody enters the city on our watch.',26124),
(113207,'enUS','','The Unseen Path will help however we can.',26124),
(113208,'enUS','Guards, to your stations! Nobody enters the city until this mess is done with.','',26124),
(113209,'enUS','Change position!','',26124),
(113210,'enUS','March!','',26124),
(113211,'enUS','On your feet!','',26124),
(113212,'enUS','Keep alert! To your positions!','',26124),
(113213,'enUS','','I don\'t like this place! Hurry!',26124),
(113214,'enUS','','I want my mommy!',26124),
(113215,'enUS','','What you doing?',26124),
(113216,'enUS','','Come ooooon!',26124),
(113217,'enUS','','I want my mommy...',26124),
(113218,'enUS','','AH! NO!',26124),
(113219,'enUS','','Waaaah!',26124),
(113220,'enUS','','I... *sniff* I know this street, maybe.',26124),
(113221,'enUS','','Uh... yeah... YEAH! That\'s Vanthir\'s house!',26124),
(113222,'enUS','','Bye!',26124),
(113223,'enUS','Blades at the ready!','Blades at the ready!',26124),
(113224,'enUS','','The gateway will be open momentarily, my dear.',26124),
(113225,'enUS','','There. The Black Temple and Akama await your leisure, $n.',26124),
(113226,'enUS','Forget the ley-lines, brothers! We shall feast on the dragons instead!','',26124),
(113227,'enUS','I\'ll be with you, friend, such as I am. The world has changed so much since my time. I would have enjoyed exploring these isles.','',26124),
(113228,'enUS','I will aid you in the ward construction and use of the Mana Gems. Then there is the matter of Ebonchill.','',26124),
(113229,'enUS','The staff was not meant for demons. I will fight Balaadur for control of it while you keep him occupied. Together, we may stand a chance.','',26124),
(113230,'enUS','You hear that boy? They traveled all this way just to see you.','',26124),
(113231,'enUS','Millhouse, you certainly are quite talented at getting yourself into a bind!','',26124),
(113232,'enUS','Archmage Vargoth is after the Nightborne Soulstone as well. You two should work together to find him before he locates it.','',26124),
(113233,'enUS','What?! The Nightborne Soulstone is mine! Let\'s go get it!','',26124),
(113234,'enUS','','I don\'t like it here...\n\n<Sniff.>',26124),
(113235,'enUS','I can help you get home. Come with me, little one.','I can help you get home. Come with me, little one.',26124),
(113236,'enUS','Rush!','',26124),
(113237,'enUS','You\'ve done a great job caring for him. How about you hold onto him.','',26124),
(113238,'enUS','My suggestion is to find some place to hide until this is over!','',26124),
(113239,'enUS','It\'s not safe! Get outta here!','',26124),
(113240,'enUS','It\'s getting quite cold in here, isn\'t it?','',26124),
(113241,'enUS','','NO!',26124),
(113242,'enUS','','Leave me alone!',26124),
(113243,'enUS','','I don\'t wanna go back!',26124),
(113244,'enUS','','Leave my friend alone!',26124),
(113245,'enUS','','Heeeeey!',26124),
(113246,'enUS','','.... Waaaaah!!',26124),
(113247,'enUS','You ready to find some bones, boy?','',26124),
(113248,'enUS','Stromgarde is mine! I will not give it up to my father or anyone else!','',26124),
(113249,'enUS','I am the prince! How... dare you...','',26124),
(113250,'enUS','','It\'s not too late. We\'ll just jump the mountains to cut them off, and...',26124),
(113251,'enUS','','No, no... they\'re everywhere!',26124),
(113252,'enUS','Let\'s get this place cleared so we can fish up all those delicious frenzies!','',26124),
(113253,'enUS','','Hang on, $n. We\'re going in low.',26124),
(113254,'enUS','Here are all the frenzies I caught.','Here are all the frenzies I caught.',26124),
(113255,'enUS','','Aah!',26124),
(113256,'enUS','Seize the child!','Seize the child!',26124),
(113257,'enUS','After her!','After her!',26124),
(113258,'enUS','Halt!','Halt!',26124),
(113259,'enUS','Step away from the child!','Step away from the child!',26124),
(113260,'enUS','You\'ve done it! I can feel arcane levels rising in the area. The demons have pulled back for the moment. I\'d wager they plan to hit us hard.','',26124),
(113261,'enUS','This next part is tricky. We will start the ritual here to draw all that power. As we do, it\'s likely we\'ll be attacked. I\'ll begin placing the Mana Gems.','',26124),
(113262,'enUS','You will channel on the Ritual Focus. Once we gather sufficient magic, I expect we will get Balaadur\'s attention.','',26124),
(113263,'enUS','Prepare yourself, conjurer. I don\'t expect Balaadur to give us a particularly warm welcome.','',26124),
(113264,'enUS','Let us begin the incantations.','Let us begin the incantations.',26124),
(113265,'enUS','I will attempt to deal with most of the enemies, but it will likely be more than I can handle. You will need to stop casting occasionally to assist me. If you are ready we shall begin.','',26124),
(113266,'enUS','Good! Concentrate on building the Ritual Focus. I will do what I can to support you.','',26124),
(113267,'enUS','Maybe we could blink past the barrier!','',26124),
(113268,'enUS','','Oh my sweet little girl! Are you hurt? Were they mean to you?',26124),
(113269,'enUS','','They yelled and put me in a cage! I missed you...',26124),
(113270,'enUS','As I was running around fishing up the frenzies, I noticed some large bubbles over in this lagoon.','',26124),
(113271,'enUS','','You\'re home now. Thank goodness.',26124),
(113274,'enUS','I\'m wondering if whatever\'s down there is what\'s been causing them to act up. Let\'s see if I can\'t rustle it up from where it\'s hiding.','',26124),
(113275,'enUS','Oh yea! There\'s definitely something down there. Let\'s fish it up, $p.','',26124),
(113276,'enUS','Remember, we are here to convince Akama to join us, not to kill him.','',26124),
(113277,'enUS','I know not why you have returned, Illidari, but it is a grave mistake. This time, there will be no prison in the end... only death.','',26124),
(113278,'enUS','Let\'s get up there, Kayn. It\'s time to convince Akama to join us.','Let\'s get up there, Kayn. It\'s time to convince Akama to join us.',26124),
(113283,'enUS','What in the great sea is that thing?!','',26124),
(113285,'enUS','Quick! Kill it with fire or whatever it is you adventurers use!','',26124),
(113286,'enUS','Do your damn job! We can\'t keep living like this!','',26124),
(113287,'enUS','Remain calm. The city\'s finest are on the case.','',26124),
(113288,'enUS','Blight','Blight',26124),
(113289,'enUS','Let\'s see how well that nose of yours works.','',26124),
(113290,'enUS','Attaboy! Now let\'s go find those mages!','',26124),
(113291,'enUS','','Ah, there you are. Elling\'s waiting for you upstairs.',26124),
(113292,'enUS','Wasn\'t easy to get this on such short notice with the city locked down, you know.','',26124),
(113293,'enUS','Once you use the bomb, you\'d better hightail it out of there. Hammond and his boys will descend on that hall like moths to the flame.','',26124),
(113294,'enUS','Pocketing','Pocketing',26124),
(113295,'enUS','Thank you for using the Ulduar Teleportation Network!$b$bAll destination points are currently offline for maintenance. If this is an emergency, please contact a Visitor Information Representative during regular business hours.$b$bHave a nice day!','',26124),
(113296,'enUS','','Tabards for sale! Show your colors on the front!',26124),
(113297,'enUS','My word! I barely got you out of there in time! You should take care out there, old chum!','',26124),
(113298,'enUS','','Tabards here! Rally your allies by showing your allegiance!',26124),
(113299,'enUS','','Don\'t leave home without flying your colors, buy a tabard today!',26124),
(113300,'enUS','Good boy!','',26124),
(113301,'enUS','Back to master!','',26124),
(113302,'enUS','Who\'s a big sentient robo-wolf? You are! You are!','',26124),
(113303,'enUS','Back to master!','',26124),
(113308,'enUS','Fool! Did you really think a little piece of wood would stop me?!','',26124),
(113309,'enUS','You will bleed!','',26124),
(113310,'enUS','The blood sustains me!','',26124),
(113311,'enUS','I.. am not... defeated...','',26124),
(113319,'enUS','Silgryn nods.','',26124),
(113320,'enUS','Hurry up an\' finish blessin\' those bandages, we need to get them off to the front!','',26124),
(113321,'enUS','Here they come! I could use a bit of help!','',26124),
(113328,'enUS','','A gift, for me?',26124),
(113337,'enUS','Work hard... beach easy.','',26124),
(113338,'enUS','Superb casting! Get back to the Focus. I\'ll keep an eye out.','',26124),
(113339,'enUS','The power is building. They will know we are doing something momentous. Another group incoming, assist me!','',26124),
(113340,'enUS','This is a terrible turn of events...','',26124),
(113341,'enUS','','We may have missed our chance at the Grand Magistrix tonight, but her time will come. Sooner or later we\'ll find another way to settle the score...',26124),
(113342,'enUS','I must speak with the Council. Until we meet again, my mortal friend.','',26124),
(113343,'enUS','No! He will not get away with this!','',26124),
(113344,'enUS','It\'s painfully obvious that you could use someone of my considerable talent. Let us join forces to go after Vargoth and the Soulstone!','',26124),
(113345,'enUS','Stick around... it\'s meal time!','',26124),
(113346,'enUS','What\'s this? Another intruder approaches!','',26124),
(113347,'enUS','That demon is Vadina, one of Valadors enforcers. I think we have his attention. Aid me!','',26124),
(113348,'enUS','Did you really think your ploy would work? Come to me, little mage!','',26124),
(113349,'enUS','I might be the baby, but at least I get all the attention!','',26124),
(113350,'enUS','Quit picking on me!','',26124),
(113351,'enUS','Citizens in need of shelter are to report to the Trader\'s Hall at once.','',26124),
(113352,'enUS','The situation is under control. You are all completely safe.','',26124),
(113353,'enUS','These eggs are corrupted. We should destroy them now.','',26124),
(113354,'enUS','There is more than one way to deal with a corruption.','',26124),
(113355,'enUS','Guards! Guards!','',26124),
(113356,'enUS','The guardians, they are awaking!','',26124),
(113357,'enUS','Up ahead, I see the mages! They\'re surrounded by the Houndmaster\'s minions.','',26124),
(113358,'enUS','Quickly, we must slaughter these beasts before they do more harm!','',26124),
(113359,'enUS','We\'re never gonna make quota. Move faster you louts!','',26124),
(113360,'enUS','Shackle ain\'t gonna be happy if we ain\'t done soon! Hurry with the loading already!','',26124),
(113361,'enUS','Secure the entrance! We\'ve got the cultists right where we want them.','',26124),
(113362,'enUS','You will not interfere with their feeding!','',26124),
(113363,'enUS','My hounds are hungry, and your mages make quite the meal.','',26124),
(113364,'enUS','Soon they will be strong enough to draw the magic out of every mage in Dalaran!','',26124),
(113365,'enUS','Come, my pets. You will have plenty to feed on soon enough.','',26124),
(113366,'enUS','My minions look forward to making a meal out of you, Archmage.','',26124),
(113367,'enUS','Until we meet again.','',26124),
(113368,'enUS','You can never know too much about your foe. These tomes and scrolls come directly from the Stormwind Library.','',26124),
(113369,'enUS','Ay Muscle, you got company!','Ay Muscle, you got company!',26124),
(113370,'enUS','Muscle gonna hurt dem good!','',26124),
(113371,'enUS','You won\'t get away with this, Hakkar!','',26124),
(113372,'enUS','For your insolence, your end will be painful and slow!','',26124),
(113373,'enUS','This display is meaningless! Your doom is at hand!','',26124),
(113374,'enUS','You possess the might of an archmage! But I\'m not out of tricks yet...','',26124),
(113375,'enUS','The Withered Leyhunter detects your presence!','',26124),
(113376,'enUS','Never again will you use Ebonchill to kill a mage, demon!','',26124),
(113377,'enUS','The Withered Leyhunter has noticed you!','',26124),
(113378,'enUS','Bah! I need no meager weapon to destroy you!','',26124),
(113379,'enUS','Your world... will... fall...','',26124),
(113380,'enUS','So it was that Huln\'s mercy gained the allegiance of his family\'s oldest ally: me.','',26124),
(113381,'enUS','','Bal\'a dash, malanore.',26124),
(113382,'enUS','','We stand together!',26124),
(113383,'enUS','The portal is closing! Get out of there!','',26124),
(113384,'enUS','','The Legion must be stopped!',26124),
(113385,'enUS','Well done! Let\'s go before reinforcements arrive. I\'ll open a portal back to the hall.','',26124),
(113386,'enUS','','Greetings.',26124),
(113387,'enUS','','My bow is at the ready!',26124),
(113388,'enUS','','Fight well!',26124),
(113389,'enUS','','Al diel shala.',26124),
(113390,'enUS','','Remember those we lost.',26124),
(113391,'enUS','','Together we will save Azeroth!',26124),
(113392,'enUS','','Until next time.',26124),
(113393,'enUS','','Waste MY time? I don\'t think so!',26124),
(113394,'enUS','Bal\'a dash, malanore.','',26124),
(113395,'enUS','We must all do our duty.','',26124),
(113396,'enUS','We serve the ranger-general.','',26124),
(113397,'enUS','','They\'re rifling through my drawers- thieving rats! Please, recover my belongings.',26124),
(113398,'enUS','','My robes! Ah, I\'ve missed these! I hope they still fit...',26124),
(113399,'enUS','','Just in case the library does not survive Elisande\'s insanity, I\'ll keep an eye on these tomes.',26124),
(113400,'enUS','','It would be best if they did not know who I was conversing with before.',26124),
(113402,'enUS','We are living in troubled times.','',26124),
(113403,'enUS','Are you ready to resume our search for the missing mages?','',26124),
(113404,'enUS','Strive for peace, but be ready to fight!','',26124),
(113405,'enUS','Victory will come.','',26124),
(113406,'enUS','Good luck!','',26124),
(113407,'enUS','','Ishnu-alah.',26124),
(113408,'enUS','','Ishnu-dal-dieb.',26124),
(113409,'enUS','','The Unseen Path welcomes you!',26124),
(113410,'enUS','','Well met.',26124),
(113411,'enUS','','The hour of battle is at hand!',26124),
(113412,'enUS','','Take care!',26124),
(113413,'enUS','','Thank you for your service.',26124),
(113414,'enUS','','Our duty is to all of Azeroth.',26124),
(113415,'enUS','','Ande\'thoras-ethil.',26124),
(113416,'enUS','','May your weapon strike true!',26124),
(113417,'enUS','','I haven\'t lived ten-thousand years to be pestered by you!',26124),
(113418,'enUS','Bal\'a dash, malanore.','',26124),
(113419,'enUS','My bow skills are second to none!','',26124),
(113420,'enUS','What is it?','',26124),
(113421,'enUS','Let\'s get this war won!','',26124),
(113422,'enUS','Challenge awaits!','',26124),
(113423,'enUS','Aim true!','',26124),
(113424,'enUS','Bal\'a dash, malanore.','',26124),
(113425,'enUS','Brzzzzt!$B$BWelcome to Matrix Punchograph 3005 stroke E, a security level beta terminal.$B$BPrismatic punch card detected.  Access Granted.\n\n01010011 01110100 01100001 01101110 01100100 00100000 01100010 01100001 01100011 01101011 00100001 01010011 01110100 01100001 01101110 01100100 00100000 01100010 01100001 01100011 01101011 00100001','',26124),
(113426,'enUS','The Farstriders stand ready.','',26124),
(113427,'enUS','For Silvermoon!','',26124),
(113428,'enUS','Brzzzzt!$B$BWelcome to Matrix Punchograph 3005 stroke E, a security level beta terminal.$B$BYou must possess a prismatic punch card to access terminal functions.\n\n01001000 01110101 01101110 01110100 01100101 01110010 01110011 00100000 01101111 01101110 01101100 01111001 00100001','',26124),
(113429,'enUS','Ah, the Temple of Fal\'adora. Those halls once glowed with prayers to Elune.','',26124),
(113430,'enUS','I imagine it is less hospitable now. Hold still, I will get you out of there.','',26124),
(113431,'enUS','Alright, hold still. I will get you out of there.','',26124),
(113432,'enUS','Greetings.','',26124),
(113433,'enUS','I will do my duty for Azeroth.','',26124),
(113434,'enUS','May victory be ours!','',26124),
(113435,'enUS','Fight with courage!','',26124),
(113436,'enUS','We must not falter!','',26124),
(113437,'enUS','The Legion will fall!','',26124),
(113438,'enUS','May the wind guide your arrows.','',26124),
(113439,'enUS','Prismatic security card insertion successful.  Disabling security locks.\n\n01010111 01100001 01110011 00100000 01110100 01101000 01101001 01110011 00100000 01100001 01101100 01110111 01100001 01111001 01110011 00100000 01101100 01101111 01100011 01101011 01100101 01100100 00111111','',26124),
(113440,'enUS','Deactivate Security Measures','Deactivate Security Measures',26124),
(113441,'enUS','You\'re more meddlesome than a banshee!','',26124),
(113442,'enUS','','You\'ve done it! Guard it well until you can return to me.',26124),
(113443,'enUS','','That dumb cow won\'t even see it coming... we\'ll be in charge of the fleet, once and for all!',26124),
(113444,'enUS','The sea queen once forged an empire with magic. She has since turned to... a more shadowy benefactor.','',26124),
(113445,'enUS','Queen Azshara... do not underestimate her grasp of the arcane. Or the devotion of her minions.','',26124),
(113446,'enUS','The naga wield magics, yes, but without finesse. There was a time Azshara\'s people had the potential to rival the titans.','',26124),
(113447,'enUS','The naga are trying to reclaim past glory amidst these ruins. They grovel for scraps. Show them what real power looks like.','',26124),
(113448,'enUS','The dragonflights once reigned over this world in the titans\' stead. See how these creatures pick at the carcass of their greatness.','',26124),
(113449,'enUS','Neltharion withheld many secrets from the other dragonflights. Some of them may be of interest to us, child.','',26124),
(113450,'enUS','The titans imbued the great dragonflights with considerable power. The black dragonflight has been decimated. We should claim what power remains.','',26124),
(113451,'enUS','The filth that occupy this place are an insult to the glory of a once proud dragonflight.','',26124),
(113452,'enUS','This place is infused with the power of the arcane... can you feel it? So much power...','',26124),
(113453,'enUS','The glories of an ancient empire remain. There is power here, child... you need only seize it!','',26124),
(113454,'enUS','This city was built upon a matrix of mighty arcane energies. Ah, yes... power enough for us both...','',26124),
(113455,'enUS','A splendid empire, ensorcelled by magic for thousands of years. Let us shatter these halls and drink deep from the ruins.','',26124),
(113456,'enUS','Surely you see the futility of a council of mortals overseeing an arcane trove of this magnitude?','',26124),
(113457,'enUS','For generations the mortal mages of Dalaran have sought to bury their fears within these walls. They are so weak, child.','',26124),
(113458,'enUS','Your predecessor haunted these chambers for many years, child. Are you certain you want to dig up the past?','',26124),
(113459,'enUS','I applaud your pursuit of knowledge, child. Your predecessor tried to wall in the darkness, but you, you are not afraid, hmm?','',26124),
(113460,'enUS','In eons past, the titans used the language of the arcane to weave whole worlds into existence. The ability to move a city about is... insignificant.','',26124),
(113461,'enUS','How small this city looks when placed aside the glory and splendor of Suramar.','',26124),
(113462,'enUS','Lowly Dalaran. Where petty mortal politics preclude the acquisition of true power.','',26124),
(113463,'enUS','It was magic that built this city, and magic that sustains it. Turn me loose, mage, and I will leech it dry...','',26124),
(113464,'enUS','Even in intensive study, a mortal mage acquires so little knowledge in a lifetime. It\'s a wonder they even bother.','',26124),
(113465,'enUS','Dalaran. The city endures even after generations of its mortal inhabitants die off.','',26124),
(113466,'enUS','The mages of this city see it as the arcane focus of this world. How little they know, child.','',26124),
(113467,'enUS','Despite the petty bickering of the mortals who lead it, this place is nonetheless a passable assembly of arcane knowledge.','',26124),
(113468,'enUS','Ah, Dalaran. The city of spires perches itself once more between you mortals and the end of your world.','',26124),
(113469,'enUS','My dear child, you hold yourself back. The power is within your grasp to send this entire city tumbling into the sea.','',26124),
(113470,'enUS','For generations the mages of your world have trained in this city, like children playing with fire.','',26124),
(113471,'enUS','The Kirin-Tor. Contemptable mortals groveling about for what meager scraps of power their tiny minds can comprehend.','',26124),
(113472,'enUS','Pick Lock','Pick Lock',26124),
(113473,'enUS','I am... spent...','',26124),
(113474,'enUS','I need more mana, child...','',26124),
(113475,'enUS','My energy dwindles.','',26124),
(113476,'enUS','You must pace yourself, child.','',26124),
(113477,'enUS','You spend your energies frivolously...','',26124),
(113478,'enUS','I have mixed feelings about returning here. Perhaps one day, the temple can be restored.\n\nFor now though, let\'s convince Akama to join us and return to the Fel Hammer.\n\nWe\'re ready when you are, $n.','',26124),
(113479,'enUS','You lack the mana to continue, child.','',26124),
(113480,'enUS','I must... recuperate my energies...','',26124),
(113481,'enUS','Mana... you need more mana...','',26124),
(113482,'enUS','Your frail frame cannot maintain this pace.','',26124),
(113483,'enUS','We must recharge...','',26124),
(113484,'enUS','Power, I must have... more power...','',26124),
(113485,'enUS','Is that everything you have?','',26124),
(113486,'enUS','Quite the tactician, are we?','',26124),
(113487,'enUS','Our magic conceals us from prying eyes...','',26124),
(113488,'enUS','Are you afraid to fight? Interesting.','',26124),
(113489,'enUS','We all have our secrets, don\'t we?','',26124),
(113490,'enUS','I find your constant need for sustenance bemusing.','',26124),
(113491,'enUS','Your allies are too dependent on you. Let them starve.','',26124),
(113492,'enUS','Your considerable talents are wasted on... pudding.','',26124),
(113493,'enUS','The very powers of the ancient titans are at your command, and you choose to create... tasty treats?','',26124),
(113494,'enUS','This spell is ours, now.','',26124),
(113495,'enUS','A very tactical move, my child. You are learning.','',26124),
(113496,'enUS','Oh, very good. Well done.','',26124),
(113497,'enUS','Your enemies are foolish to use such trifling magics against you.','',26124),
(113498,'enUS','Bah. Let them walk.','',26124),
(113499,'enUS','You waste precious energy poking holes in reality for these clumsy sword-swinging brutes.','',26124),
(113500,'enUS','Have you ever considered opening portals to other worlds? Such power is within your grasp, child...','',26124),
(113501,'enUS','','The rats locked themselves inside. We need to make them tell us where their leader is hiding.',26124),
(113502,'enUS','Realm to realm we go... We reap and reap but do not sow...','',26124),
(113503,'enUS','I will not be contained!','',26124),
(113504,'enUS','My essence will not be controlled again!','',26124),
(113505,'enUS','I will not succumb to your paltry magics!','',26124),
(113506,'enUS','You are not as powerful as she who came before. You cannot succeed!','',26124),
(113507,'enUS','I am infinite.','',26124),
(113508,'enUS','No mere mortal can grasp the wisdom of Aluneth!','',26124),
(113509,'enUS','[Scream of frustration]','',26124),
(113510,'enUS','You fancy yourself as worthy to wield me as the previous \"Guardian?\" You are but a child to me.','',26124),
(113511,'enUS','You foolishly think you can control this power. So be it.','',26124),
(113512,'enUS','Come, child. Let us wreak havoc upon your foes, and I shall see what you are made of.','',26124),
(113513,'enUS','Let\'s get up there, Altruis. It\'s time to convince Akama to join us.','Let\'s get up there, Altruis. It\'s time to convince Akama to join us.',26124),
(113514,'enUS','Welcome flesh-bag!','',26124),
(113515,'enUS','It is good to be back, even if only for a brief time. Perhaps one day, we will retake the temple for the Illidari.\n\nFor now though, let us see if we can convince Akama to join us... or else.\n\nWe are ready when you are, $n.','',26124),
(113516,'enUS','Remember, we are here to convince Akama to join us by any means necessary.','',26124),
(113517,'enUS','Release the hounds!','',26124),
(113518,'enUS','Incinerate them!','',26124),
(113519,'enUS','Fight! Fight, you pathetic imps!','',26124),
(113520,'enUS','Burn them down!','',26124),
(113521,'enUS','Gnaw them to the bone!','',26124),
(113522,'enUS','Rip them apart!','',26124),
(113523,'enUS','Yes! This one will serve us well!','',26124),
(113524,'enUS','Bow to your new masters!','',26124),
(113525,'enUS','All shall serve!','',26124),
(113526,'enUS','Nice to see I\'m not the only dismembered body part around here.','',26124),
(113527,'enUS','','This is the last time you disturb our work. Kill them!',26124),
(113528,'enUS','','Fine! Killing you myself will earn me a greater place in the new order.',26124),
(113529,'enUS','For the Horde!','For the Horde!',26124),
(113530,'enUS','By our blades!','By our blades!',26124),
(113531,'enUS','Those demons should think twice before coming to OUR lands!','Those demons should think twice before coming to OUR lands!',26124),
(113532,'enUS','For the Warchief!','For the Warchief!',26124),
(113533,'enUS','Blood and Honor!','Blood and Honor!',26124),
(113534,'enUS','One Horde!','One Horde!',26124),
(113535,'enUS','Malevolence, make sure no one gets through that door.','',26124),
(113536,'enUS','Malevolence, make certain that no one gets through that door.','',26124),
(113537,'enUS','If we can\'t go over, then we will have to go through. Open it.','',26124),
(113538,'enUS','If we cannot go over, we will go through. Get it open.','',26124),
(113540,'enUS','I am in agreement. If he keeps this civil, then so shall we.','I am in agreement. If he keeps this civil, then so shall we.',26124),
(113542,'enUS','I hear you, Kayn. Hopefully, he will listen to reason. If not...','I hear you, Kayn. Hopefully, he will listen to reason. If not...',26124),
(113543,'enUS','I see you will not be deterred. Come then, Illidari. Face your destiny.','',26124),
(113544,'enUS','Even here, I have heard your name spoken, $p. But, I am not impressed.','',26124),
(113545,'enUS','Let us see if I can impress you.','',26124),
(113546,'enUS','Shall we finish this like beings of honor? Can you manage that much, demon hunter?','',26124),
(113547,'enUS','You have beaten me with honor. Perhaps I have misjudged you, demon hunter.\n\nIt will take some time before there is full trust between us. However, like you, I wish to see the Burning Legion\'s downfall.\n\nThey destroyed my beautiful temple. I will have my revenge.\n\nToward that goal, I will aid you, $n.','',26124),
(113548,'enUS','I will never aid you, demon hunter. Like all your kind, you are no better than the demons, which you consort with. I see no difference between you.\n\nThe Legion and your master destroyed my beautiful temple. Trust me when I say that one day, I will have my revenge.\n\nYou can go twist in the Nether, $n.','',26124),
(113549,'enUS','Then rise and join us, Akama.','Then rise and join us, Akama.',26124),
(113550,'enUS','Then, you leave me no choice, Akama. One way, or another, you WILL help us to defeat the Legion.','Then, you leave me no choice, Akama. One way, or another, you WILL help us to defeat the Legion.',26124),
(113551,'enUS','Akama, think! You know I opposed Illidan. You can trust us.','',26124),
(113552,'enUS','Perhaps you are right. It seems that times have changed and with it, the Illidari. I will aid you.','',26124),
(113553,'enUS','Kill that mongrel, $p! No... wait. I have a better idea.','',26124),
(113554,'enUS','Matron mother, please come up here. We are returning to the Fel Hammer.','',26124),
(113555,'enUS','','Of course, my dear. One gateway coming up.',26124),
(113556,'enUS','Just kill me and be done with it.','',26124),
(113557,'enUS','Oh, I think not. Allari, do what you do best.','',26124),
(113558,'enUS','','It will be my pleasure.',26124),
(113559,'enUS','I live again!','',26124),
(113560,'enUS','Matron mother, get up here. We are returning to the Fel Hammer.','',26124),
(113561,'enUS','The Tormenting Orb stares at all players inquisitively.','',26124),
(113562,'enUS','','Where is the herald? Speak!',26124),
(113563,'enUS','','You seek to delay the inevitable. The Legion will wash over this world!',26124),
(113564,'enUS','','Is that the best you can do? You are weak indeed!',26124),
(113565,'enUS','','So be it. Let\'s see how you handle the Kingsbane poison!',26124),
(113566,'enUS','','Do what you will. I give my life to the Hand!',26124),
(113567,'enUS','','What is... happening... my veins... are on fire...!',26124),
(113568,'enUS','','Please... no more! I\'ll tell you everything! Just make it stop!',26124),
(113569,'enUS','','Where is the Herald? Speak, miserable worm!',26124),
(113570,'enUS','','He lies... in the keep...',26124),
(113571,'enUS','','The keep will be heavily guarded. We should split up. At least one of us has to make it to the Herald alive.',26124),
(113572,'enUS','','We don\'t have much time. Get moving!',26124),
(113573,'enUS','Already planning to run away?','',26124),
(113574,'enUS','Always have an escape planned. A lesson I learned the hard way!','',26124),
(113575,'enUS','And what did you have in mind for THAT?','',26124),
(113576,'enUS','Foolish orc! You will be the first to witness the Legion\'s arrival into my city.','',26124),
(113577,'enUS','Long have I waited for this day. Let us not waste another moment!','',26124),
(113578,'enUS','Ered\'nash ila mornu nakuun. Ered\'nash ban man\'ari!','',26124),
(113579,'enUS','I can feel their curse weakening! You must stop them from interfering with the rite!','',26124),
(113580,'enUS','It is done! You rotten Bonespeaker dogs cannot deny my place in the Halls of Valor any longer!','',26124),
(113581,'enUS','Stromgarde is mine at last! You are fools if you think I\'ll let my father have it back!','',26124),
(113582,'enUS','Guards! Seize them!','',26124),
(113583,'enUS','Legion reinforcements! Show them no mercy!','',26124),
(113584,'enUS','Northern tower\'s swarming with demon filth! They\'re everywhere!','',26124),
(113585,'enUS','Structure to the east of Crossroads! There\'s demons everywhere!','',26124),
(113586,'enUS','Structure! East of Crossroads! Get out here!','',26124),
(113587,'enUS','Road to the east of Crossroads! Some kind of structure! It came out of nowhere!','',26124),
(113588,'enUS','Southeast of us at the Crossroads! A structure formed from nothing!','Southeast of us at the Crossroads! A structure formed from nothing!',26124),
(113589,'enUS','Southeast of Crossroads! Another structure! What foul magic is this?','Southeast of Crossroads! Another structure! What foul magic is this?',26124),
(113590,'enUS','Structure to the southeast! We\'ll hold Crossroads as long as we can. Get out there and get rid of those things!','Structure to the southeast! We\'ll hold Crossroads as long as we can. Get out there and get rid of those things!',26124),
(113591,'enUS','My patience has worn thin as well. Let\'s find the prince and be done with this.','',26124),
(113592,'enUS','They\'ve spread to the west! Multiple camps! These things think they can take us down? Hah!','',26124),
(113593,'enUS','Camps to the west! These demons are relentless! Show them your strength!','',26124),
(113594,'enUS','Treachery! I will bury my axe in the coward\'s skull!','',26124),
(113595,'enUS','Foul demons! We\'re under siege to the west! Send reinforcements!','',26124),
(113596,'enUS','Takin\' quite a beatin\' down at Ratchet! A little backup wouldn\'t hurt!','',26124),
(113597,'enUS','Me and my boys are holdin\' \'em off down at Ratchet, but, uh... feel free to send us a little backup!','',26124),
(113598,'enUS','Ratchet\'s gettin\' bombarded over here! Make sure ya target the ugly ones and not us good lookin\' folk, would ya?','',26124),
(113599,'enUS','','Dat one had it comin\'.',26124),
(113600,'enUS','','One less enemy to worry about.',26124),
(113601,'enUS','','Well fought, hero.',26124),
(113602,'enUS','','Impressive.',26124),
(113603,'enUS','Foul demons! They\'ve taken control our forces to the far east! Looks like they\'re pushing for Orgrimmar!','',26124),
(113604,'enUS','You need help to complete a summoning ritual? You can\'t do it by yourself? How pathetic!','',26124),
(113605,'enUS','They\'ve taken out our reinforcements to the far east! We\'re holding them at the bridge!','',26124),
(113606,'enUS','Huge camp down along the east! We need reinforcements! We\'re being overrun!','',26124),
(113607,'enUS','Structures scouted far north! Getting hit pretty hard up here!','',26124),
(113608,'enUS','Looks like they\'re pushing towards Ashenvale! Our allies are under attack!','',26124),
(113609,'enUS','South of Ashenvale! There\'s demons everywhere! Get up here before they spread!','',26124),
(113610,'enUS','','The Pearl isss mine!',26124),
(113611,'enUS','My name is... Error: Cannot Locate Data... Hmm, Seems I need a name.','',26124),
(113612,'enUS','Oh, you\'ve come here in search of a companion. Very well, I will join you, hunter.','',26124),
(113613,'enUS','However, this process may trigger my defensive protocols. So I may poke you in the eye. Just giving you a little warning.','',26124),
(113614,'enUS','','Creature a\' da Nightmare, be gone!',26124),
(113615,'enUS','','Another vile creature defeated.',26124),
(113616,'enUS','We work well together, hero!','',26124),
(113617,'enUS','That one wasn\'t so tough.','',26124),
(113618,'enUS','Another victory!','',26124),
(113619,'enUS','Good work. Stay strong!','',26124),
(113620,'enUS','Well done. Let us fight on!','',26124),
(113621,'enUS','That one didn\'t stand a chance.','',26124),
(113622,'enUS','','He wasn\'t very nice!',26124),
(113623,'enUS','','That\'s what you get for being a bully!',26124),
(113624,'enUS','','We sure showed him!',26124),
(113625,'enUS','','We did it!',26124),
(113626,'enUS','','This is kind of fun!',26124),
(113627,'enUS','','The Dream is a little safer now.',26124),
(113628,'enUS','','Together, we can defeat the Nightmare.',26124),
(113629,'enUS','','Another enemy vanquished.',26124),
(113630,'enUS','','The vale is a little safer now.',26124),
(113631,'enUS','','Very impressive, druid.',26124),
(113632,'enUS','','Stay valiant, hero. There is still more to come.',26124),
(113633,'enUS','','Well fought, hero.',26124),
(113634,'enUS','Some so-called salvage team is ransacking Azsuna\'s coastline, working on behalf of Mr. Shackle.','',26124),
(113635,'enUS','Just because Shackle is useful in some places doesn\'t mean I have to tolerate this. Show them that piracy doesn\'t pay here in Azsuna!','',26124),
(113636,'enUS','Without vigilance and quick action, Shackle\'s lackeys will strip Azsuna\'s coast of its history and its valuables. They\'ll be back, and I suspect you\'ll be ready.','',26124),
(113637,'enUS','My spies have brought me information suggesting many key leaders of Mr. Shackle\'s so-called salvage fleet are vulnerable.','',26124),
(113638,'enUS','Strike at their leaders, and leave these pirates in disarray!','',26124),
(113639,'enUS','Gruesome work, but done well. Our southern coast is safer, for now.','',26124),
(113640,'enUS','Back when I had a body, I never needed help with this ritual. I was a summoner without peer!','',26124),
(113641,'enUS','Seeking a creature from the Twisting Nether? Grabbing a beast of the Void? Oh... you\'re just summoning a friend...','',26124),
(113642,'enUS','Can you tell me your story?','Can you tell me your story?',26124),
(113643,'enUS','I appreciate the words, $n, but I\'ll come back when this blows over.','',26124),
(113644,'enUS','They come!','',26124),
(113645,'enUS','These foolish vrykul cling to the notion that the titans will someday return.','',26124),
(113646,'enUS','This land may look pure, but even here I sense the Legion\'s presence.','',26124),
(113647,'enUS','I\'m in over my head! Be back in business soon as this thing blows over!','',26124),
(113648,'enUS','The vrykul here believe themselves to be warriors without peer. I will show them the error of their ways!','',26124),
(113650,'enUS','Now let\'s get things organized, shall we? We\'ve a lot of work to do!','',26124),
(113651,'enUS','These vrykul are not as easy to destroy as you might think.','',26124),
(113652,'enUS','This passage will lead us out.','',26124),
(113653,'enUS','I can\'t wait to see these hills go up in flames!','',26124),
(113654,'enUS','Not far now.','',26124),
(113655,'enUS','I know you have been rebuilding the old teleporters. The beacon here will connect us to your shal\'dorei friends.','',26124),
(113656,'enUS','','Selia, Master of Balefire, come forth and we will end your torment!',26124),
(113657,'enUS','|TInterface\\Icons\\ability_ironmaidens_bloodritual:20|t Lucard begins to |cFFFF0404|Hspell:215000|h[Consume the Living]|h|r! Slay the corsair quickly!','|TInterface\\Icons\\ability_ironmaidens_bloodritual:20|t Lucard begins to |cFFFF0404|Hspell:215000|h[Consume the Living]|h|r! Slay the corsair quickly!',26124),
(113658,'enUS','Boy. I sure picked the wrong day to be out here!','',26124),
(113659,'enUS','What was I thinking comin\' down here?','',26124),
(113660,'enUS','This isn\'t quite what I expected! Now if you\'ll excuse me...','',26124),
(113661,'enUS','What the heck is goin\' on around here?','',26124),
(113662,'enUS','','I can feel her... Selia, the Master of Balefire. She stirs!',26124),
(113663,'enUS','The inhabitants of Gadgetzan have been inspired to join the fight against the Legion!','',26124),
(113664,'enUS','','Unfortunately I\'m not much of a fighter. Be safe out there!',26124),
(113668,'enUS','The Eredar, one-time Draenei that fell under the control of the demon lord Sargeras. Skilled sorcerers in both fel and shadow magics, adjust your wards accordingly. Often in command of contingents of demon forces, they are both a high threat and an excellent target of opportunity.','',26124),
(113669,'enUS','A new breed of felguard, the fel lord towers over his lesser minions and often wields a massive, yet slow, weapon. Should you find yourself facing one alone, I would suggest a tactical retreat.','',26124),
(113670,'enUS','We don\'t yet know much about this new breed of demon that we have taken to calling the \"imp mother.\" Limited reports indicate that her stomach may operate as a kind of portal from which imps emerge. Use caution, we\'re not sure what you\'re up against here.','',26124),
(113671,'enUS','The dreaded infernal, siege weapon of the Legion. Expect these brutes to be hammering down your defenses with blazing fists made of fel fire and stone. They will often arrive on the battlefield as meteors launched from afar, then unfurl themselves to cause further devastation.','',26124),
(113672,'enUS','The dreadlord, perhaps most insidious of all of the Legion forces. Capable of bending minds to their will, they will turn half of your army against you before you\'ve even seen one. Take note of their shadowy magics and control over carrion insects, and steel yourself against their frightening illusions.','',26124),
(113673,'enUS','Sorry, bub. I\'m on watch. Somebody\'s gotta remind this demon filth who they\'re messin\' with!','',26124),
(113674,'enUS','The pit lord is a massive, terrifying behemoth, don\'t expect to face one with much less than an army and come out alive. Capable of rending a man in two with a single glaive swing, and burning half of a squad to a crisp with fel energy, they are a threat at any distance.','',26124),
(113675,'enUS','Ain\'t everyday I get to bring out the ol\' secret weapons!','',26124),
(113676,'enUS','Normally I\'m pretty nice guy, but if you block my shot we\'re gonna have some words, friend.','',26124),
(113677,'enUS','Small? Whad\'ya mean, small?$B$BAlright, $n. We\'ll see who cleans this place up the most.','',26124),
(113678,'enUS','If you take \'em down don\'t forget their weapons! Those\'ll fetch a pretty penny.','',26124),
(113679,'enUS','You\'re lookin\' a bit lost, friend.','',26124),
(113680,'enUS','When this is all over, don\'t forget your free - or slightly discounted - Noggenfoggers!','',26124),
(113681,'enUS','This doesn\'t look like a place you belong, friend.','',26124),
(113682,'enUS','When this is all over, remind me to take out some more insurance on this place.','',26124),
(113683,'enUS','Show this one the exit, boys!','',26124),
(113684,'enUS','I\'m sure more backup will be arriving shortly. I\'ve got friends in the highest of places.','',26124),
(113685,'enUS','East over the water! Looks like the Legion\'s back for more! Positions! Hurry up!','',26124),
(113686,'enUS','Ready up! I\'ve got a bad feeling about this!','',26124),
(113687,'enUS','You are too late, assassin.','',26124),
(113688,'enUS','Quickly, you must plant the seed!','',26124),
(113689,'enUS','Place it here, where it can drink of the leyline.','',26124),
(113690,'enUS','A fledgling felhound rushes into the cave, lured by the scent of magic.','',26124),
(113691,'enUS','I have seen the beautiful gifts they bring. You do not understand!','',26124),
(113692,'enUS','They have arrived! Oh, they are even more beautiful than I imagined!','',26124),
(113693,'enUS','Do you not see? Can you not feel their warm embrace?','',26124),
(113694,'enUS','Master, your servant requires aid!','',26124),
(113695,'enUS','My plans will not be ruined. My destiny will not be denied. You will burn!','',26124),
(113696,'enUS','M-master...?','',26124),
(113697,'enUS','Mrglrgr! Mrlgrlr mrlgrl grlrglr. Mrglrgrl?','',26124),
(113698,'enUS','','Good. Our work is done.',26124),
(113699,'enUS','','Being in this palace with these daggers brings back... dark thoughts. Impulses I\'ve spent years trying to be free of.',26124),
(113700,'enUS','','Take the blades. You\'ve more than proven your skill as an assassin. Perhaps you can overcome the darkness within their steel.',26124),
(113701,'enUS','Pearlhunter Phin\'s jaw drops as it stares at you, bewildered.','',26124),
(113702,'enUS','Pearlhunter Phin hops around in frustration.','',26124),
(113703,'enUS','Pearlhunter Phin\'s eyes roll back in its head as it sighs heavily.','',26124),
(113704,'enUS','Pearlhunter Phin excitedly grabs the sand and begins scrubbing the flaw on the pearl.','',26124),
(113705,'enUS','<Show Phin the crab shell.>','<Show Phin the crab shell.>',26124),
(113706,'enUS','Looks like they\'re getting stronger! None of you better be feeding those things!','',26124),
(113707,'enUS','','Quin\'el was the Master of Chillwind. Just being near her sent a shiver up my spine. Be prepared!',26124),
(113708,'enUS','','Quin\'el, Master of Chillwind, come forth! We will end your eternal suffering!',26124),
(113709,'enUS','','Coura was the resident Master of Arcana. She crafted spells as easily as you breathe air.',26124),
(113710,'enUS','','She is upon us! Coura, Master of Arcana, we will bring you to eternal rest!',26124),
(113711,'enUS','<Show Phin the crab oil.>','<Show Phin the crab oil.>',26124),
(113712,'enUS','<Show Phin the crab claw.>','<Show Phin the crab claw.>',26124),
(113713,'enUS','<Show Phin the fine sand.>','<Show Phin the fine sand.>',26124),
(113714,'enUS','The doomguard, commanders of the front-line forces. An excellent target of opportunity that will cripple the enemy\'s line. Be wary of fire magics and dark curses, as well as their capable strikes in melee.','',26124),
(113715,'enUS','','It is my duty to convey you to the Halls of Valor. Speak to me when you are ready!',26124),
(113716,'enUS','While a cave wouldn\'t be my first choice of setting up a camp, it does keep us from drawing any unwanted attention to ourselves.$b$bShall we get to work now?','',26124),
(113717,'enUS','','You\'re just in time... We were about to call forth one of this temple\'s most tortured souls, in the hopes of finally ending her misery.',26124),
(113718,'enUS','I returned in disgrace and sought to wash away my failure in the blood of others.','',26124),
(113719,'enUS','','Behold, Suramar. Our haven. Our sanctuary.',26124),
(113720,'enUS','There I found the shrine to Tyr\'s champion, but was denied entry. I tried many times, until I could bear the pain no longer.','',26124),
(113721,'enUS','How are you doing?','',26124),
(113722,'enUS','Hello!','',26124),
(113723,'enUS','','I can\'t perform any tests if I\'m lacking a subject.',26124),
(113724,'enUS','Greetings.','',26124),
(113725,'enUS','See you around.','',26124),
(113726,'enUS','Fare well to ye.','',26124),
(113727,'enUS','Goodbye.','',26124),
(113728,'enUS','I greet you.','',26124),
(113729,'enUS','I bid you welcome.','',26124),
(113730,'enUS','Greetings, friend.','',26124),
(113731,'enUS','Another time then.','',26124),
(113732,'enUS','We will meet again.','',26124),
(113733,'enUS','Goodbye.','',26124),
(113734,'enUS','Hail, seeker of truth.','',26124),
(113735,'enUS','You are shorter than I expected.','',26124),
(113736,'enUS','Let us talk.','',26124),
(113737,'enUS','Hmmph.','',26124),
(113738,'enUS','A good start! You fight well!','',26124),
(113739,'enUS','I have not faced so noble a challenger in millenia!','',26124),
(113740,'enUS','Mrlgrrl, rglrlg rlgrlmgmlr?\n\n<Phin looks at you expectantly.>','',26124),
(113741,'enUS','','There! A bit of magic to help you follow in Galford\'s footsteps. Good luck!',26124),
(113742,'enUS','For Tyr.','',26124),
(113743,'enUS','Greetings.','',26124),
(113744,'enUS','Well met.','',26124),
(113745,'enUS','May Tyr guide you.','',26124),
(113746,'enUS','Goodbye.','',26124),
(113747,'enUS','Until we meet again.','',26124),
(113748,'enUS','','Hello there.',26124),
(113749,'enUS','','Blue is best!',26124),
(113750,'enUS','','What brings you out here?',26124),
(113751,'enUS','','Alright then.',26124),
(113752,'enUS','','See you around.',26124),
(113753,'enUS','','I should get back to it.',26124),
(113754,'enUS','','Our prison.',26124),
(113755,'enUS','','Elisande and the Legion seek to bring us to heel. Through fear. Through hunger.',26124),
(113756,'enUS','','Th-they need it more... I will be f-fine...',26124),
(113757,'enUS','','S-so... hungry... mind is... slipping!',26124),
(113758,'enUS','<He stares at you blankly.> You are not my brother.','',26124),
(113759,'enUS','There is never enough for the both of us... I choose to suffer over her.','',26124),
(113760,'enUS','I need more bait.','I need more bait.',26124),
(113761,'enUS','','Use that bait wisely. I don\'t have many entrails left.',26124),
(113762,'enUS','The felhound, a quick, wiry beast often seen in large packs. Each hound has two tendrils, ending in a sucker of sorts. Should they latch on to you, they will drain your power and, eventually, your life. Hit them before they hit you.','',26124),
(113763,'enUS','We have only recently learned of this variant of the felhound, which we are calling the \"felstalker.\" Faster and more coordinated than their brethren, they are often seen hunting in packs and utilizing a crude form of pack communication. Avoid their bites, as they are laced with all sorts of foul magics.','',26124),
(113764,'enUS','The lowly imp, a creature of felfire and trickery. Not a large threat alone, but often found in large groups which can quickly overwhelm your defenses from a distance.','',26124),
(113765,'enUS','The wrathguard, elite warriors of the Legion\'s front lines. Often seen wielding two weapons with equal measure, avoid letting them get the upper hand in swordplay, lest you face a rain of blows from which you will not emerge.','',26124),
(113766,'enUS','Only ONE eye? Don\'t complain to me because you have no depth perception.','',26124),
(113767,'enUS','Think you could summon me a body while you\'re at it?','',26124),
(113768,'enUS','What a drab place! It would look far better covered in fire.','',26124),
(113769,'enUS','','These vrykul should sing the praises of Sargeras, not their empty hymns to the titans.',26124),
(113770,'enUS','','I am glad to see you.',26124),
(113771,'enUS','','Greetings.',26124),
(113772,'enUS','','Hello.',26124),
(113773,'enUS','','Goodbye.',26124),
(113774,'enUS','','Hunt well.',26124),
(113775,'enUS','','Sun and Moon light your path.',26124),
(113776,'enUS','','I can\'t wait to charm one of those big, muscular vrykul!',26124),
(113777,'enUS','Do not fear me, hero.','',26124),
(113778,'enUS','Go with my thanks.','',26124),
(113779,'enUS','A new land, primed for destruction!','',26124),
(113780,'enUS','I sense a dark place near, touched by void.','',26124),
(113781,'enUS','The felguard, front-line forces of the Legion. Almost always seen with heavy, two-handed weaponry. They are slow to strike, but hit quite hard, and are more agile than they look.','',26124),
(113782,'enUS','I will hide in shadows no longer.','',26124),
(113783,'enUS','How may I help you?','',26124),
(113784,'enUS','We will accomplish much together.','',26124),
(113785,'enUS','Until next time.','',26124),
(113786,'enUS','Let us get to work.','',26124),
(113787,'enUS','May Light and Shadow guide you.','',26124),
(113788,'enUS','I wonder what would happen if you split someone into pure Light and pure Void. Interested in volunteering?','',26124),
(113789,'enUS','What a beast! And a great catch to boot!','',26124),
(113790,'enUS','Bored? I could arrange discourse with a Shadowfiend.','',26124),
(113791,'enUS','You do know there\'s an invasion going on, right?','',26124),
(113792,'enUS','You know, that lure on the top of it\'s head would make for a great fishing rod...','',26124),
(113793,'enUS','Yea, I know that may seem gross, but just look at it! Fish\'ll come flocking towards something like that.','',26124),
(113794,'enUS','Here, you take it. Give it to Marcia in Dalaran. She\'s great at turning things into fishing rods.','',26124),
(113795,'enUS','You can take my boat there to get back if you have no other means.','',26124),
(113796,'enUS','Lower your weapons! We\'re not here to fight you.','',26124),
(113797,'enUS','','Its just Calia now.',26124),
(113798,'enUS','','How can I assist you?',26124),
(113799,'enUS','The king was never in danger, but where my men failed to stop this cultist, you did not. That spares you from prison at the very least.','',26124),
(113800,'enUS','Go.  Get out of my city before I change my mind.','',26124),
(113802,'enUS','','I stand ready to help.',26124),
(113803,'enUS','','Walk in the Light.',26124),
(113804,'enUS','','Goodbye.',26124),
(113805,'enUS','','Let\'s talk again soon.',26124),
(113806,'enUS','','Sometime I miss the beautiful court of Lordaeron, and my father.',26124),
(113807,'enUS','I don\'t like this place either!','',26124),
(113808,'enUS','','I once hid in a muddy ditch for two days while slavering ghouls patrolled the area. Your prattle does not faze me.',26124),
(113809,'enUS','','Terenas would have had you thrown out of here faster than he did Medivh.',26124),
(113810,'enUS','AwardContributionPoints called','AwardContributionPoints called',26124),
(113811,'enUS','','These scales are unlike anything I\'ve seen.',26124),
(113812,'enUS','','This demon has clearly been bred to be resistant to both magical and physical attacks.',26124),
(113813,'enUS','This land is so... fresh. I can\'t sense any demonic corruption here. It\'s... revolting.','',26124),
(113814,'enUS','Next illusion, please.','',26124),
(113815,'enUS','Show them the next demon.','',26124),
(113816,'enUS','Next demon.','',26124),
(113817,'enUS','','Get up...',26124),
(113818,'enUS','Take a drink, darling. You will feel better.','',26124),
(113819,'enUS','','Give me a moment to inspect this beast, and I can discover its weaknesses.',26124),
(113820,'enUS','','But you need...',26124),
(113821,'enUS','We will survive until tomorrow. Vanthir always takes care of us. You know that.','',26124),
(113822,'enUS','','Lunette nods and takes a drink.',26124),
(113823,'enUS','','Much better. Thank you. Thank you so much.',26124),
(113824,'enUS','Mommy!','',26124),
(113825,'enUS','Those peaks stretch up to touch the firmament. What a delight it will be to watch them crumble!','',26124),
(113826,'enUS','So many beasts in this land to slaughter!','',26124),
(113827,'enUS','Can we leave this place? I... I\'m a bit afraid of heights...','',26124),
(113828,'enUS','From this height, I can see everything!','',26124),
(113829,'enUS','','I sense a powerful presence in this land, though not as strong as Lord Sargeras.',26124),
(113830,'enUS','There, there, old friend. We will figure this out...','',26124),
(113831,'enUS','','Nightwell be praised... I thought I was going to die.',26124),
(113832,'enUS','','I will get her home. It is nice to know Vanthir still thinks of us.',26124),
(113833,'enUS','There must be more books on magical illness around here somewhere...','',26124),
(113834,'enUS','','It isn\'t far. Thank you.',26124),
(113835,'enUS','A Treatise On The Habits Of Ravens looks quite interesting! But, no, it will not help poor Meryl recover...','',26124),
(113836,'enUS','','Ambrena shakily takes a drink.',26124),
(113837,'enUS','Blast! This library is a disaster! We will have to clean it up if we are to have any hope of finding more texts on magical afflictions before it is too late...','',26124),
(113838,'enUS','I know there must be something here that will help Meryl... But where....','',26124),
(113839,'enUS','W-what?','',26124),
(113840,'enUS','It is Arcwine. For you. Go on, brother.','',26124),
(113841,'enUS','Clotaire tentatively sips at the wine, then takes a deep gulp.','',26124),
(113842,'enUS','Hah. Not so fast! You may choke.','',26124),
(113843,'enUS','Hush you... Thank Vanthir for me, won\'t you?','',26124),
(113844,'enUS','Gem activated.','Gem activated.',26124),
(113845,'enUS','Gem deactivated.','Gem deactivated.',26124),
(113846,'enUS','|cFFFF00FFPerfect gem activated.|r','|cFFFF00FFPerfect gem activated.|r',26124),
(113847,'enUS','','Mmmm! The tauren here are so... tall.',26124),
(113848,'enUS','He found more?','',26124),
(113849,'enUS','','Yes! Plenty for both of us today.',26124),
(113850,'enUS','This mountain will come crumbling down!','',26124),
(113851,'enUS','Donatien takes a quick draught of the mana-wine.','',26124),
(113852,'enUS','Vanthir came through again... how can he keep this up?','',26124),
(113853,'enUS','From this height, we can almost reach the Void.','',26124),
(113854,'enUS','This place is worse then the last one.','',26124),
(113855,'enUS','Grlmgrl, mgrlgrg. Glrgrlmrgl mrglrlgr lrglr! Rlmgrlm mgrglrmg mrglrglrm. Mrlgrgmrlg gmrlgrl mlrglrg?','',26124),
(113856,'enUS','Mrg, mrlgmrlg...','',26124),
(113857,'enUS','Grgmrlg! Glrmg, mglrmglrgr.','',26124),
(113858,'enUS','Mgrlgl. Gmrglmr?','',26124),
(113859,'enUS','Mlgr! Mlgrmlrgrlmgr! Mlgrg mlgrmlgrrlm! Rlmgrlmgr!','',26124),
(113860,'enUS','Mr. Mrglglrm knocks the pearl down, cracking it!','',26124),
(113861,'enUS','This place crawls with creatures, malformed and twisted from a warped mind. They will burn all the same.','',26124),
(113862,'enUS','Here in the forest you will see the flaw in the titans\' plans.','',26124),
(113863,'enUS','Pearlhunter Phin presents the pearl to Mr. Mrglglrm.','',26124),
(113864,'enUS','Why are we wasting time by walking through this forest?','',26124),
(113865,'enUS','Halduron told me to expect you.','',26124),
(113866,'enUS','So... much... to... BURN!','',26124),
(113867,'enUS','Yea! How you like that one?','Yea! How you like that one?',26124),
(113868,'enUS','There\'s green everywhere! Just not my preferred shade.','',26124),
(113869,'enUS','Bet you didn\'t see that comin\', did ya?','Bet you didn\'t see that comin\', did ya?',26124),
(113870,'enUS','You must have went through some trouble to get your hands on this oak and ore.','',26124),
(113871,'enUS','Hmph, you\'re still alive.','Hmph, you\'re still alive.',26124),
(113872,'enUS','Here comes another one!','Here comes another one!',26124),
(113873,'enUS','You asked for it!','You asked for it!',26124),
(113874,'enUS','These are tricky materials to work with, but I think you\'ll be impressed with the final product.','',26124),
(113875,'enUS','Whelp. Looks like I\'m out. I\'m only kiddin\'! I got bombs for days.','Whelp. Looks like I\'m out. I\'m only kiddin\'! I got bombs for days.',26124),
(113876,'enUS','The weapons I\'m crafting should be sharp enough to pierce through any armor, and sturdy enough for repeated use.','',26124),
(113877,'enUS','I have to say, I think this might be my finest work yet.','',26124),
(113878,'enUS','Don\'t let that weaponry fall into the wrong hands.','',26124),
(113879,'enUS','','The grapple point is on the top of the wall over there. Follow me!',26124),
(113880,'enUS','Delivery of cannons and cannonballs directly from the great forge for ye\'.','',26124),
(113881,'enUS','Excellent, the third fleet ships are loading up at the end of the dock.','',26124),
(113882,'enUS','Do you think you will have enough?','',26124),
(113883,'enUS','Enough for those most in need. The rest- Ah! Welcome, welcome.','',26124),
(113886,'enUS','Your arrival is timely. Welcome to my tavern.','',26124),
(113887,'enUS','','It was thought his kind was incorruptible. A lesson for my brothers, I suppose.',26124),
(113888,'enUS','','Loken did fine work turning her, but in truth, Odyn\'s arrogance takes most of the credit.',26124),
(113889,'enUS','','Though he is not one of our servants, he has heard our whispers. They darkened him forever.',26124),
(113890,'enUS','The Farstriders will fight at your side and help bring the Houndmaster to his knees.','',26124),
(113891,'enUS','','A beast of stone who ignorantly throws around power he barely controls. He should be put down before he ruins our plans.',26124),
(113892,'enUS','','If the plan is to set a trap for the Houndmaster, we\'ll need to place it in a secure location.',26124),
(113893,'enUS','','The Sentinels stand ready to assist. Together, we will take down the Houndmaster.',26124),
(113896,'enUS','|TInterface\\Icons\\spell_nature_protectionformnature:20|t%s begins to cast |cFF00FFFF|Hspell:212681|h[Cleansed Ground]|h|r!','',26124),
(113897,'enUS','','Another nameless brute of Sargeras, pretending to aid these elves. Little do they know their fate.',26124),
(113898,'enUS','','A traitor to his world and to his kind. His end was never in question... only who would deliver it.',26124),
(113899,'enUS','','Oh where could she have gone...',26124),
(113900,'enUS','Try to relax, friend. We will find her.','',26124),
(113901,'enUS','','How?',26124),
(113905,'enUS','','For this idiotic pustule of N\'Zoth to have lived so long... it does little to refute my opinion of this world\'s new owners.',26124),
(113907,'enUS','','How far the Manastorms have fallen! Relying on crude machines and weak arcane wizardry did them no favors. Still, they had their uses.',26124),
(113908,'enUS','','Her mother was more impressive. This one\'s hunger is uncontrollable and her tactics overused. An easy target.',26124),
(113909,'enUS','','Really, these thugs of Sargeras are SO interchangeable. This one is good with his axe. Oh, how unique!',26124),
(113910,'enUS','The spy has a light colored vest on!','The spy has a light colored vest on!',26124),
(113911,'enUS','','Another fool who believed Illidan\'s lies of sacrifice and righteousness. Tormented, he turns on everyone.',26124),
(113912,'enUS','The spy has a dark colored vest on!','The spy has a dark colored vest on!',26124),
(113913,'enUS','The spy is a male!','The spy is a male!',26124),
(113914,'enUS','The spy is a female!','The spy is a female!',26124),
(113915,'enUS','The spy is wearing gloves!','The spy is wearing gloves!',26124),
(113916,'enUS','The spy is not wearing gloves!','The spy is not wearing gloves!',26124),
(113917,'enUS','The spy is carrying potions!','The spy is carrying potions!',26124),
(113918,'enUS','The spy is carrying books!','The spy is carrying books!',26124),
(113919,'enUS','The spy has a pouch at the belt!','The spy has a pouch at the belt!',26124),
(113920,'enUS','The spy does not have any potions!','The spy does not have any potions!',26124),
(113921,'enUS','The spy has long sleeves!','The spy has long sleeves!',26124),
(113922,'enUS','The spy does not have long sleeves!','The spy does not have long sleeves!',26124),
(113923,'enUS','The spy is wearing a cloak!','The spy is wearing a cloak!',26124),
(113924,'enUS','The spy is not wearing a cloak!','The spy is not wearing a cloak!',26124),
(113925,'enUS','','This one is old, but still not one of the first. These creatures were too hungry for magic to obey our masters, though they still prove useful from time to time.',26124),
(113926,'enUS','','A land full of dreams, but none of them about me? It\'s enough to hurt a girl\'s pride.',26124),
(113927,'enUS','','When do you think she turned? Centuries ago? She hides her hunger for power behind a cloak of suffering and righteousness.',26124),
(113928,'enUS','I think you meant to say nightmares.','',26124),
(113929,'enUS','','These three have enjoyed the secret favor of N\'Zoth for long enough. Sadly their reaving days are done.',26124),
(113930,'enUS','','A powerful dragon could be a powerful tool. Alas, gone are the days of Galakrond.',26124),
(113931,'enUS','Trees everywhere! The fires will be glorious!','',26124),
(113932,'enUS','When I destroy this world, this land will be one of the first consumed.','',26124),
(113933,'enUS','|TInterface\\Icons\\sha_spell_warlock_demonsoul_nightmare:20|t%s casts |cFFFF0000|Hspell:214505|h[Entangling Nightmares]|h|r!','',26124),
(113934,'enUS','They\'re everywhere. This is madness!','',26124),
(113935,'enUS','','We need answers!',26124),
(113936,'enUS','','Reinforcements from Ironforge are arriving now. Stormwind will not fall on our watch!',26124),
(113937,'enUS','You show some skill. But not as much as your dead master.','',26124),
(113938,'enUS','Tell me, demon hunter, how did it feel being locked up for all of those years?','',26124),
(113939,'enUS','This is impossible.','',26124),
(113940,'enUS','My son. Where is Galen?','',26124),
(113941,'enUS','Where is the prince who murdered his king?','',26124),
(113942,'enUS','What has become of Stromgarde?','',26124),
(113943,'enUS','Then I have failed as both a father and a king.','',26124),
(113944,'enUS','Is there a shortage of steel in this future world?','',26124),
(113945,'enUS','Then leave it to rust. I care not.','',26124),
(113946,'enUS','We took his life, my lord. The prince left us little choice.','',26124),
(113947,'enUS','... Everything.','... Everything.',26124),
(113948,'enUS','Death and ruin. Time has not been kind to this place.','',26124),
(113949,'enUS','I hate this place! Free me from the torment of this journey!','',26124),
(113950,'enUS','I\'ve gotta get back to Gadgetzan! They\'re never gonna believe this!','I\'ve gotta get back to Gadgetzan! They\'re never gonna believe this!',26124),
(113951,'enUS','Thanks! I owe ya one.','Thanks! I owe ya one.',26124),
(113952,'enUS','Didn\'t expect to see you here! Now, if you\'ll excuse me...','Didn\'t expect to see you here! Now, if you\'ll excuse me...',26124),
(113953,'enUS','Wow, that was close.','Wow, that was close.',26124),
(113954,'enUS','I need to stop volunteering for this.','I need to stop volunteering for this.',26124),
(113955,'enUS','We are the Ebon Blade. Knights of undeath who protect this world.','',26124),
(113956,'enUS','We do what the living cannot.','',26124),
(113957,'enUS','Thanks. I better let \'em know what\'s goin\' on here.','Thanks. I better let \'em know what\'s goin\' on here.',26124),
(113958,'enUS','Never thought I\'d get stuck out here. Thanks for the help.','Never thought I\'d get stuck out here. Thanks for the help.',26124),
(113959,'enUS','Stromgarde is lost, but there is still hope for this world... if you will join us.','',26124),
(113960,'enUS','The Nightmare creeps across this land. A tempting power to harness, but to do so without understanding its nature would be foolish.','',26124),
(113961,'enUS','Excellent! By the way, we have recovered your blade, Trol\'kalar. It is quite legendary.','',26124),
(113962,'enUS','No.','',26124),
(113963,'enUS','Who are you that raise fallen kings from the earth? Speak.','',26124),
(113964,'enUS','This place was devastated long ago. Why do you waste my time, mortal?','',26124),
(113965,'enUS','I will do whatever it takes to preserve peace on Azeroth.','',26124),
(113966,'enUS','Hey, we\'re going to the beach! Time off is in my contract, right?','',26124),
(113967,'enUS','','Great dragons bent to the will of Xavius, who serves the God of the Deep. Instead of breathing life, she consumes all around her.',26124),
(113968,'enUS','','It appears the prison of N\'Zoth is not as strong as it once was. What you see is a tiny growth of the behemoth that may yet consume your world.',26124),
(113969,'enUS','','Another seed of corruption planted in death. An unquiet spirit will wander in anger and grow in pain. Easy prey for the God of the Deep.',26124),
(113970,'enUS','','Another defender of the titans brought low. Every death makes it easier. Perhaps now his misery will end... though I doubt it.',26124),
(113971,'enUS','I see spirits all throughout the ruins of this land. Souls ready to be harvested!','',26124),
(113972,'enUS','','Corrupting the guardians of the Dream is a bold move, but Xavius may be overreaching. He would be better off quietly spreading the Nightmare\'s influence instead of raising such alarm.',26124),
(113973,'enUS','','This land\'s destruction is an unfinished work. Once complete, it will be a fitting tribute for the great Sargeras.',26124),
(113974,'enUS','','Xavius uses the power of his new master well. Warping the mind of a demigod is no mean feat.',26124),
(113975,'enUS','This place is nothing but a shadow of itself. We will crush it last so that its inhabitants may despair at the destruction of their world!','',26124),
(113976,'enUS','The ocean\'s depths are dark and foreboding. So like the endless Void.','',26124),
(113977,'enUS','I don\'t like this place. Release me!','',26124),
(113978,'enUS','','Xavius, running from one master to the next. Scrambling for power, yet defeated again and again. The God of the Deep picks a poor champion, or is there something else at play?',26124),
(113979,'enUS','','Almost completely gone, as if it never existed. But the Rift is deep and vast, and somewhere down there it stirs. Something has changed, the last prison weakens. We must prepare.',26124),
(113980,'enUS','Interesting... what a creative use of residual soul energy! We must remember to research this technique!','',26124),
(113981,'enUS','This one has drunk deeply of the fel. It\'s unfortunate we don\'t have time to see if she can be bound like any other demon.','',26124),
(113982,'enUS','','The walls between realms are thin here, so easy to tear open. Do you know what would happen if true shadow and light met here?',26124),
(113983,'enUS','Beware! His advisor is far more than he seems. Keep your wits about you!','',26124),
(113984,'enUS','','The research into the Void here is commendable, but ultimately futile. How could you possibly understand what the titans did not?',26124),
(113985,'enUS','','I know the naaru consider us horrors to be resisted. We do not share this view. They are merely beloved brethren that lost the true path. They will return to their masters... in time.',26124),
(113986,'enUS','Well, well, if it isn\'t my prodigal student Talixae. She was missing when the Vindicators put me in chains and slew the rest of my disciples. I look forward to witnessing her death!','',26124),
(113987,'enUS','','You\'ve gathered quite the group of followers. It is fortunate they are focused on this incursion and not the true war. The scope of it might destroy your minds.',26124),
(113988,'enUS','','Do the naaru speak of the eternal conflict? That the entire history of your world is but a fraction of the time that has passed? Of those that came before the draenei? No? <short chuckle>',26124),
(113989,'enUS','','Delicious.',26124),
(113990,'enUS','','Every little death helps.',26124),
(113991,'enUS','','Enjoy that?',26124),
(113992,'enUS','','Boring.',26124),
(113993,'enUS','','Get a load of this, brother!',26124),
(113994,'enUS','','Did you feel it cease to exist?',26124),
(113995,'enUS','','Remember how Queen Azshara was working with the demons? Well apparently, when Prince Farondis found out, he was like...',26124),
(113996,'enUS','','\"NO!\"',26124),
(113997,'enUS','','...and then Queen Azshara was like...',26124),
(113998,'enUS','','\"HOW DARE YOU DEFY ME!?\"',26124),
(113999,'enUS','','...and then she got so mad that she turned everybody into... into...',26124),
(114000,'enUS','','CURSED SPIRITS!',26124),
(114001,'enUS','','Oh, sorry.',26124),
(114002,'enUS','','I long for the day our masters can truly pass into this realm. You have only seen fragments, shadows, the faintest of echoes. Ask the ethereals what one of these manifestations is capable of.',26124),
(114003,'enUS','','Reports indicate that there is a colossal crab dwelling within the Shipwreck Shoals. Supposedly, its claws are stronger than steel! We could fashion them into mighty weapons.',26124),
(114004,'enUS','','Wait, they were just normal crab claws but larger? That\'s unfortunate.',26124),
(114005,'enUS','','The nearness of the Void here is comforting. I was used in the sacrifice of many creatures in a place like this. Every death brought us closer to the complete corruption of this world.',26124),
(114006,'enUS','This Xavius is crafty. He hides his true form while gathering power with an illusion. We would do well to learn from him.','',26124),
(114007,'enUS','','I remember the Dark Iron fondly. Modgud was so easy to influence, such was her hate. Imagine her fury when I abandoned her to the Wildhammer at the worst time. I can be very easy to lose... remember that.',26124),
(114008,'enUS','','We may face some of my brethren in this conflict... a prospect that delights me. Their power will be mine! They will pay for what was done to me long ago.',26124),
(114009,'enUS','Foolish mortals. NOTHING can save you!','',26124),
(114010,'enUS','Bow before the might of the Legion!','',26124),
(114011,'enUS','','The God of the Deep writhes in his prison, breaking free ever so slowly. You should hurry and defeat the fallen titan... there are greater battles yet to fight.',26124),
(114012,'enUS','Nothing can protect you.','',26124),
(114013,'enUS','The Legion cannot be stopped!','',26124),
(114014,'enUS','We... are... EVERYWHERE!','',26124),
(114015,'enUS','Ha ha ha. Fools! You know nothing!','',26124),
(114016,'enUS','Your existence is at an end, mortals!','',26124),
(114017,'enUS','Thank you, adventurer.','Thank you, adventurer.',26124),
(114018,'enUS','I am alive? Thank you!','I am alive? Thank you!',26124),
(114019,'enUS','Please, the Shade of Xavius must be stopped.','Please, the Shade of Xavius must be stopped.',26124),
(114020,'enUS','That creature may seem impressive, but the spells which give it form are barely holding it together. Break the ritual supporting it and the rest shall soon crumble.','',26124),
(114021,'enUS','','An interesting mutation of an ancient species. Its shell is nearly impregnable. Nearly...',26124),
(114022,'enUS','','An interesting amalgamation of fel species. I wonder, are there more of its kind?',26124),
(114023,'enUS','','Such arrogance, even for a long-lived elf. The taste of her life force is... exquisite.',26124),
(114024,'enUS','','Here is one who has caught the merest glimpse of your grim reality. It warped his mind forever.',26124),
(114025,'enUS','','She claims to know the future, but those who have lived far longer than her know the truth. Her desperate bid to remain in control dooms her people.',26124),
(114026,'enUS','','Long has this one\'s time been coming. A true servant of the fallen titan, he seeks the doom of all things. As if that would really save them from the Void.',26124),
(114027,'enUS','','<short chuckle>',26124),
(114028,'enUS','','<evil laughter>',26124),
(114029,'enUS','','A corrupted corpse of a dragon... how dangerous could that possibly be?',26124),
(114030,'enUS','','Another mindwarped servant of Xavius. A druid should have better control of his own mind, don\'t you think?',26124),
(114031,'enUS','','There has been a rumored sighting of the behemoth known as Shellmaw, carving a swath of destruction through the Whispering Willows!',26124),
(114032,'enUS','If the Valarjar were able to be unleashed from this place they would be a significant hindrance to the Legion. Stuck here, they\'re useless.','',26124),
(114033,'enUS','','Well done. Now at least something will remain once the naga have been driven out.',26124),
(114034,'enUS','','It is ironic that the weakest of us may be the ultimate victor. C\'Thun, Yogg-Saron, Y\'Shaarj, and... well. Only one would remain to consume the world, that was always meant to be.',26124),
(114035,'enUS','','Hey, brother! Someone\'s here to...',26124),
(114036,'enUS','','Oops. Sorry.',26124),
(114037,'enUS','','The recruitment of the eredar was quite a win for Sargeras. He desperately needed more intelligence in his warhost.',26124),
(114038,'enUS','We are only here to talk, Akama.','',26124),
(114039,'enUS','Well, that brought back some unpleasant memories.','',26124),
(114040,'enUS','','They\'re here to help us find mom and dad.',26124),
(114041,'enUS','Akama, listen to reason.','',26124),
(114042,'enUS','Severing, secure the keep gates! We\'re moving the king to a secure location.','',26124),
(114044,'enUS','','The majestic Mythana has become befouled by the Nightmare. Search her out and put her out of her misery.',26124),
(114045,'enUS','','You have done well. The Dreamweavers are in your debt.',26124),
(114046,'enUS','You hear a faint caw in the distance and then silence...','',26124),
(114049,'enUS','Do you hear them? The screams of the souls that form every board and nail of this ship. They\'re like... music!','',26124),
(114050,'enUS','The Light reveals all!','',26124),
(114052,'enUS','Look upon the monstrosity before you. The Legion had no part in its creation. No, this creature is the folly of the titans\' designs.','',26124),
(114053,'enUS','Baron has found something.','',26124),
(114054,'enUS','I did not know if I would make it out of this alive. Thank you.','I did not know if I would make it out of this alive. Thank you.',26124),
(114055,'enUS','I can go home!','I can go home!',26124),
(114056,'enUS','I was innocent, but they didn\'t listen...','I was innocent, but they didn\'t listen...',26124),
(114057,'enUS','That is the last time I complain about the demons!','That is the last time I complain about the demons!',26124),
(114058,'enUS','I have to check on my wife. Thank you!','I have to check on my husband. Thank you!',26124),
(114059,'enUS','I\'m free! I\'m really free!','I\'m free! I\'m really free!',26124),
(114060,'enUS','Got some o\' the forge\'s best armor polish for the troops here, $n. Don\'t be shipping off without gettin\' some o\' those scuffs out first.','',26124),
(114061,'enUS','Look at this creature. Such sloppy technique! It would never be able to master the binding magic needed for a warlock.','',26124),
(114062,'enUS','','What? Kallistia and Olothil are here?',26124),
(114063,'enUS','','I... I thought we\'d lost them forever.',26124),
(114064,'enUS','','Hurry up, Than! Let\'s find them!',26124),
(114065,'enUS','This one reminds me of a felguard. Big, strong, and stupid.','',26124),
(114066,'enUS','Well, this looks cheery.','',26124),
(114067,'enUS','...the feeling is mutual.','',26124),
(114068,'enUS','Baron runs back to camp with his tail wagging.','',26124),
(114069,'enUS','','I\'m tracking someone... the gate\'s been breached!',26124),
(114070,'enUS','Ugh, keep me away from that thing! I don\'t need my magic to be drained again.','',26124),
(114071,'enUS','','I got them!',26124),
(114072,'enUS','','Momma, is daddy coming home soon?',26124),
(114073,'enUS','','Yes, baby, he\'ll be home before you know it.',26124),
(114074,'enUS','','Very good!',26124),
(114075,'enUS','I\'ll protect you, Ella! I\'ve got a sword and everything!','',26124),
(114076,'enUS','Sam! Where did you get that stick? Put it down, it\'s dirty.','',26124),
(114077,'enUS','Your ship is waiting at the end of this dock, $n. Be careful out there.','',26124),
(114078,'enUS','Reinforcements to the keep at once. They\'re here!','',26124),
(114079,'enUS','However you wish this to go down, we are with you, $n. Though, I would counsel restraint, if possible.\n\nThe knowledge that he has could prove instrumental in bringing down the Burning Legion. We want Akama to become a trusted advisor, despite his past history with the Illidari.\n\nHopefully, he will listen to reason. The tone of his voice suggests not.','',26124),
(114080,'enUS','However you wish this to proceed, we are with you, $n. I remind you that he betrayed the Master, leading to our imprisonment and Illidan\'s death.\n\nIf it weren\'t for Akama, the Burning Legion might already be defeated. While we want him as an advisor, his previous actions suggest that he is not to be trusted.\n\nDon\'t misunderstand, the Master said that we should recruit Akama, so I am in favor of the plan. However, it does not sound like he is willing to be reasonable.\n\nAllari and I have formulated a contingency plan just in case.','',26124),
(114081,'enUS','','Demons will be drawn to the power I\'ll call upon to enchant your weapons.',26124),
(114082,'enUS','','The materials used are extremely volatile. An interruption of any kind could prove disastrous.',26124),
(114083,'enUS','','I\'ll keep doing what I do best, as long as you keep those demons away from me and my enchanting table.',26124),
(114084,'enUS','','My work is almost complete. I just need a few more moments without interruption...',26124),
(114085,'enUS','','There, the weapons are finished.',26124),
(114086,'enUS','','I\'ve given them the finest enchantment I can offer.',26124),
(114087,'enUS','No...','',26124),
(114091,'enUS','There must be a way through!','There must be a way through!',26124),
(114092,'enUS','','Let\'s meet at the hall. There\'s still work to be done.',26124),
(114093,'enUS','My family has watched over these burial grounds since the days of Huln himself! We tended the honored dead with pride, skilled in our charge to guide their spirits and learn from them.$b$bNow thanks to the thrice foul Bloodtotem tribe, if they even call themselves that anymore, I find I must ask for aid from outsiders.$b$bThese are dark days indeed.','',26124),
(114094,'enUS','I heard something.','I heard something.',26124),
(114095,'enUS','What was that?','What was that?',26124),
(114096,'enUS','One of \'em is close!','One of \'em is close!',26124),
(114097,'enUS','While my blades yearn to spill demonic blood, I am under orders strictly to observe.$b$bThe knowledge these spiritwalkers have of the local area as well as the spirits that threaten our forces has already proven invaluable.$b$bWe will continue to offer them shelter and supplies as long as they continue to be useful.','',26124),
(114098,'enUS','I smell a cultist!','I smell a cultist!',26124),
(114099,'enUS','I\'ll find you in the king\'s name!','I\'ll find you in the king\'s name!',26124),
(114100,'enUS','By the Light, what was that?','By the Light, what was that?',26124),
(114101,'enUS','There\'s an intruder nearby.','There\'s an intruder nearby.',26124),
(114102,'enUS','Show yourself, cretin!','Show yourself, cretin!',26124),
(114103,'enUS','Aye, someone\'s nearby.','Aye, someone\'s nearby.',26124),
(114104,'enUS','Come on out, ya scoundrel!','Come on out, ya scoundrel!',26124),
(114105,'enUS','You won\'t be gettin\' past me that easily.','You won\'t be gettin\' past me that easily.',26124),
(114106,'enUS','Easy now... I just wanna talk.','Easy now... I just wanna talk.',26124),
(114107,'enUS','Come on out, before I lose me patience!','Come on out, before I lose me patience!',26124),
(114108,'enUS','I think I might\'ve spotted somethin\' over here.','I think I might\'ve spotted somethin\' over here.',26124),
(114109,'enUS','Hmm? What was that?','Hmm? What was that?',26124),
(114110,'enUS','Somethin\' ain\'t right.','Somethin\' ain\'t right.',26124),
(114111,'enUS','We will face my former kin in this conflict. Good! I\'ve awaited my revenge for millennia. They will pay for what they did to me!','',26124),
(114112,'enUS','Watching you hone your craft brings back old memories. I was an instructor, millennia ago. My students were the finest summoners of Argus... until we were betrayed.','',26124),
(114113,'enUS','Me no like dem.','',26124),
(114114,'enUS','Oof! Dey hurt!','',26124),
(114115,'enUS','Me hurt dem later!','',26124),
(114116,'enUS','Raaar!','',26124),
(114117,'enUS','This one bears partial blame for me being in this form! He will not escape my wrath, but there are others far more responsible who must be dealt with first!','',26124),
(114118,'enUS','Me no stay here!','',26124),
(114119,'enUS','Is it not glorious to witness such mighty beings bowing at your feet? I sacrificed everything, EVERYTHING, for such power. One day you too must pay ambition\'s price.','',26124),
(114120,'enUS','This one has strong ties to the Dark Lord. To consolidate our control over the Legion, we should eliminate our competition while we have the chance.','',26124),
(114121,'enUS','Like most of the nathrezim, Tichondrius is as arrogant as he is deadly. His ego will be his undoing!','',26124),
(114122,'enUS','This one has seen into the Great Dark and beheld the Legion\'s glorious works. I wonder how you will react when you glimpse them as well!','',26124),
(114123,'enUS','Her attempts to control time\'s flow are futile. Subtle forces work against her, ones far more powerful then she could ever imagine.','',26124),
(114125,'enUS','','The flame of the shal\'dorei flickers. We must re-ignite it.',26124),
(114126,'enUS','Father, I\'m thirsty... can I have some mana juice?','Father I\'m thirsty... can I have some mana juice?',26124),
(114127,'enUS','S-soon, little one. Soon,  I promise.','',26124),
(114128,'enUS','','The Afflicted Nightborne Citizen shivers violently while staring blankly into the distance.',26124),
(114129,'enUS','','There is a turtle of massive size inhabiting Deepbeard\'s Cove. Bring me the shell so that we can investigate its legendary toughness.',26124),
(114130,'enUS','Haven\'t seen a porter in days... how is it possible to overlook an entire community like this?','Haven\'t seen a porter in days... how is it possible to overlook an entire community like this?',26124),
(114131,'enUS','Somehow I do not think we have been merely overlooked.','Somehow I do not think we have been merely overlooked.',26124),
(114132,'enUS','Someone might hear you!','Someone might hear you!',26124),
(114133,'enUS','That does not mean I am wrong.','That does not mean I am wrong.',26124),
(114134,'enUS','Khadgar\'s wand crackles to life.','Khadgar\'s wand crackles to life.',26124),
(114135,'enUS','','Fantastic job. We can absolutely use this in our research.',26124),
(114136,'enUS','Is the shipment in? Please tell me there is more... please...','',26124),
(114137,'enUS','These feltotem pretty tasty once get them out of crunchy shell.','',26124),
(114138,'enUS','Tomb\'s up ahead. Let\'s get in there and find that shrine! We\'ll follow yer lead, $n.','',26124),
(114139,'enUS','As a healer, it shouldn\'t be too difficult to save this civilian.','As a healer, it shouldn\'t be too difficult to save this civilian.',26124),
(114140,'enUS','','And look at you now! A spectre of your former self, cursed to an eternity of undeath and ineptitude.',26124),
(114141,'enUS','','I\'m giving you an opportunity to kneel before me, princeling. Maybe something can be done about that little curse...',26124),
(114142,'enUS','No. I knew what I must do.','',26124),
(114143,'enUS','And we will NEVER...','',26124),
(114144,'enUS','KNEEL...','',26124),
(114145,'enUS','BEFORE YOU!!!','',26124),
(114147,'enUS','Psst, hey, got some lucky charms here. Don\'t want to face the Legion without a little luck on your side, do ya?','',26124),
(114148,'enUS','That stinks! It\'s covered in mold. Archmage Vargoth has been away longer than I thought.','',26124),
(114149,'enUS','Mortals and their crystal balls... Although this one may actually be more than just a novelty.','',26124),
(114150,'enUS','Now this is interesting. I had no idea Archmage Vargoth was also interested in the breeding habits of angelfish!','',26124),
(114151,'enUS','Fascinating! This is a spell book of ancient Nightborne rituals. I must borrow it sometime.','',26124),
(114152,'enUS','I make these Demon Hunters nervous. Little old me. Tehd from Lordaeron. Hee hee.$b$BAlways remember, in a land of fel infused ancient elves, the peasant with a good banish spell is king.','',26124),
(114153,'enUS','Me help goblin lady fight bad guy!','',26124),
(114154,'enUS','I thank you, $n, but my ancestors were more brave than I.','',26124),
(114155,'enUS','Field could use a few more bombs!','',26124),
(114156,'enUS','I\'ve seen it rain cats and dogs, but I\'m not sure what to call this!','',26124),
(114157,'enUS','This is a nice space for a mortal. Let\'s see what secrets it is hiding.','',26124),
(114158,'enUS','Pearlhunter Phin groans and kicks a nearby rock.','',26124),
(114159,'enUS','Pearlhunter Phin hops around impatiently.','',26124),
(114160,'enUS','Pearlhunter Phin throws their arms in the air, seemingly frustrated.','',26124),
(114161,'enUS','Mrgrlg! Glrgmrl mgrlgr...','',26124),
(114162,'enUS','Grglrgl! Lrgl... Grgrmrmlgr! MLGMRMLGR!','',26124),
(114163,'enUS','Mrlg. Grlgm.','',26124),
(114164,'enUS','Pearlhunter Phin runs over and begins digging furiously.','',26124),
(114165,'enUS','Pearlhunter Phin triumphantly pulls out handful of long fangs from the pile of sand.','',26124),
(114166,'enUS','Mrglrg! Grmgl, grmlgrmlg mlrgr lrrg.','',26124),
(114167,'enUS','GRGRLM! Mlrgmr, gmrlg Glrmrgl mrlg Mrgrlilrgl.','',26124),
(114168,'enUS','You are too late. Vargoth has already won!','',26124),
(114169,'enUS','What knowledge do you seek?','',26124),
(114170,'enUS','Yes?','',26124),
(114171,'enUS','I will help how I can.','',26124),
(114172,'enUS','You have my ear.','',26124),
(114173,'enUS','Honor the Tirisfalen.','',26124),
(114174,'enUS','Beware the Nathrezim.','',26124),
(114175,'enUS','The dreadlords must fall.','',26124),
(114176,'enUS','The Tirisgarde must not fail.','',26124),
(114177,'enUS','Some demons are best left unwakened.','',26124),
(114178,'enUS','You would not like me when I\'m angry.','',26124),
(114179,'enUS','I will consume your soul!','',26124),
(114180,'enUS','I will consume your soul! Oh my, now where did that come from?','',26124),
(114181,'enUS','You\'ve accomplished a great deal in bringing us all together here. With the changes that you are making in how the Illidari operate, I have no doubt that we can win this war.\n\nWhen this is all over, the Burning Legion will no longer be a threat and all of our sacrifices will have been worth it.','',26124),
(114182,'enUS','You have accomplished a great deal in bringing us all together here. With our renewed resolve and carefully considered plans, I have no doubt that we can win this war.\n\nWhen this is all over, the Burning Legion will no longer be a threat and all of our sacrifices will have been worth it.','',26124),
(114183,'enUS','Trust the wisdom of the Council.','',26124),
(114184,'enUS','Am I needed?','',26124),
(114185,'enUS','The Guardian stands ready.','',26124),
(114186,'enUS','So be it.','',26124),
(114187,'enUS','As the Council commands.','',26124),
(114188,'enUS','May the Guardians protect you.','',26124),
(114189,'enUS','Step right up!','',26124),
(114190,'enUS','Where do you wanna go?','',26124),
(114191,'enUS','Pick a card!','',26124),
(114192,'enUS','Yeah?','',26124),
(114193,'enUS','Time is mana, friend!','',26124),
(114194,'enUS','Tips are appreciated!','',26124),
(114195,'enUS','Now where\'d that rabbit run off to?','',26124),
(114196,'enUS','Hey, how bout you help with with a new trick? I just need to find that saw...','',26124),
(114197,'enUS','Keep that up and you might just disappear, bub.','',26124),
(114198,'enUS','The rabbits! They\'re everywhere! They control everything!','',26124),
(114199,'enUS','You believe that you are in control, that your will is your own...','',26124),
(114200,'enUS','Yet you do as He commands.','',26124),
(114201,'enUS','You exist by His whim alone.','',26124),
(114202,'enUS','You imagine yourself to be free, but you will always be His instrument...','',26124),
(114203,'enUS','The darkness does not die, $n.','',26124),
(114204,'enUS','Rage against the Nightmare. Struggle as you will.','',26124),
(114205,'enUS','The infinite dark is patient. We will all be claimed in the end.','',26124),
(114206,'enUS','','Hello, $n. How might I help you today?',26124),
(114207,'enUS','So many fallen kings, silent in their numberless graves...','',26124),
(114208,'enUS','Even the mighty are rendered nameless by time.','',26124),
(114209,'enUS','Every king must kneel before death.','',26124),
(114210,'enUS','See the spirits writhe and twist...','',26124),
(114211,'enUS','What is it?','',26124),
(114212,'enUS','The numberless shades forsaken by time.','',26124),
(114213,'enUS','Make it quick.','',26124),
(114214,'enUS','The dead outnumber the living, and always will.','',26124),
(114215,'enUS','I\'ve no time for trivialities.','',26124),
(114216,'enUS','What?','',26124),
(114217,'enUS','Very well.','',26124),
(114218,'enUS','Are we done?','',26124),
(114219,'enUS','The fel fire beckons','',26124),
(114220,'enUS','If you mess with fel fire, you get burned.','',26124),
(114221,'enUS','Hmm... I hope these robes aren\'t flammable...','',26124),
(114222,'enUS','You know, I could really use some aloe.','',26124),
(114223,'enUS','What happened to my face? Stood in the fire one too many times.','',26124),
(114224,'enUS','Are you... really here? A $c... in my den! What are the odds?$B$BHow in the world did you get here?','',26124),
(114225,'enUS','How did I get here? What in the heck are you doing up here!?','How did I get here? What in the heck are you doing up here!?',26124),
(114226,'enUS','What am I doing here? What are YOU doing here!?','',26124),
(114227,'enUS','','The Vale has seen better days. \n\nDemons have decided to claim this space as their own, but I won\'t give up without a fight.\n\nWhen I\'m not fending off intruders, I\'m spending time perfecting enchantments to use against them. \n\nOne day, we will retake Moonclaw Vale.',26124),
(114228,'enUS','','Are you ready for me to begin enchanting the weapons?',26124),
(114229,'enUS','Do not fail me, Varedis.','',26124),
(114230,'enUS','Return to Argus. We will deal with this one another day.','',26124),
(114231,'enUS','','How can I help?',26124),
(114232,'enUS','','What needs doing?',26124),
(114233,'enUS','','My demons stand ready.',26124),
(114234,'enUS','','Yes?',26124),
(114235,'enUS','','If it must be done.',26124),
(114236,'enUS','','The void is my ally.',26124),
(114237,'enUS','','Summon with caution, friend.',26124),
(114238,'enUS','','What now?',26124),
(114239,'enUS','','You need my... talents?',26124),
(114240,'enUS','','What should we kill next?',26124),
(114241,'enUS','','I grow restless. Entertain me.',26124),
(114242,'enUS','','Let\'s get on with it.',26124),
(114243,'enUS','','This had better amuse me.',26124),
(114244,'enUS','','A pox on all our enemies!',26124),
(114245,'enUS','','A good pox is always worth sharing.',26124),
(114246,'enUS','','My affection for affliction is no affectation.',26124),
(114247,'enUS','','Ashes, ashes... we all fall... down!',26124),
(114248,'enUS','Yes, friend?','',26124),
(114249,'enUS','Calydus is ready to serve!','',26124),
(114250,'enUS','What does friend need?','',26124),
(114251,'enUS','Farewell, friend!','',26124),
(114252,'enUS','Calydus is eager to help!','',26124),
(114253,'enUS','Calydus will wait here.','',26124),
(114254,'enUS','Come back soon!','',26124),
(114255,'enUS','Commander. I stand ready to train as many troops as you require.\n\nDeath to the Legion!','',26124),
(114256,'enUS','','These demons are providing us with a wealth of information. The fel mysteries of the Burning Legion will make us more powerful. And their secrets will prove their undoing.\n\nNow, how may I help you, $n?',26124),
(114257,'enUS','Aludane, I\'m here for the flight to Stormheim.','Aludane, I\'m here for the flight to Stormheim.',26124),
(114258,'enUS','We have brought crystals infused with the Light from the Exodar. Allow us a moment to enhance your weapon before you battle with the Legion.','',26124),
(114259,'enUS','Sit, friend, and enjoy this meal. You cannot fight on an empty stomach.','',26124),
(114260,'enUS','Warriors of da Horde, get ya axes and sharpen ya spears. Da Burning Legion has returned ta our world.','',26124),
(114261,'enUS','We fight in the shadows.','',26124),
(114262,'enUS','What needs done?','',26124),
(114263,'enUS','It\'s Shaw. Mathias Shaw.','',26124),
(114264,'enUS','I thought I saw you glance in my direction.','',26124),
(114265,'enUS','Sleep with one eye open.','',26124),
(114266,'enUS','The SI:7 is my cover - don\'t blow it.','',26124),
(114267,'enUS','The job\'s not done yet.','',26124),
(114268,'enUS','Look to the shadows.','',26124),
(114269,'enUS','I have ways of making you not talk.','',26124),
(114270,'enUS','I\'ve killed people for less than this.','',26124),
(114271,'enUS','Drink this - it\'ll make me feel better.','',26124),
(114272,'enUS','I\'ll have my people talk to your people. Sound good?','',26124),
(114273,'enUS','','The Nightmare has birthed an abomination known as Rage Rot. Hunt it down and burn it to the ground.',26124),
(114274,'enUS','','Your deeds will be remembered. Shorel\'aran.',26124),
(114275,'enUS','','The twisted undergrowth known as Kudzilla has arisen in the Thicket. Prune it before it spreads.',26124),
(114276,'enUS','','Well done! The corruption has been cleansed. Al diel shala.',26124),
(114277,'enUS','','There are still druids alive in the Thicket. Find them. Save them.',26124),
(114278,'enUS','','The Dreamweavers owe you much. Thank you.',26124),
(114279,'enUS','','It sickens me to see the majestic beasts of Val\'sharah lost to corruption. They must... be culled.',26124),
(114280,'enUS','','The task is done. I am sorry, I will need a moment...',26124),
(114281,'enUS','Not on my watch! Fan out and take \'em down!','',26124),
(114282,'enUS','Looks like we got more company! Hide the good silverware!','',26124),
(114283,'enUS','Heroes, take down their leader at Gadgetzan! Show \'em we\'ve got hearts of gold... at least 72 percent pure!','',26124),
(114284,'enUS','Nicely done! Not our most profitable day, but the losses could\'ve been worse!','',26124),
(114285,'enUS','Bring \'em down, boys! That one\'s head will make a nice trophy... if we can find a big enough wall.','',26124),
(114286,'enUS','Yikes! What happened?','',26124),
(114287,'enUS','... where am I?','',26124),
(114288,'enUS','It got cold, then I blacked out! What\'s going on around here?','',26124),
(114289,'enUS','It\'s the blood eagle for you.','',26124),
(114290,'enUS','What a fitting sacrifice you will make. Ha ha ha!','',26124),
(114296,'enUS','No stopping! Mr. Shackle wants this wreck broken down by sunset!','',26124),
(114297,'enUS','','I doubt you are here for me. Which means you are probably here for the research.',26124),
(114298,'enUS','Who are you? Yes, I am looking to recreate Arrexis\'s ritual.','Who are you? Yes, I am looking to recreate Arrexis\' ritual.',26124),
(114299,'enUS','','You should be able to latch on to that spot at the top of the wall. Follow me!',26124),
(114300,'enUS','The ghostly realm echoes with cries of the accursed ship! Destroy Dread Captain Thedon and release the poor souls chained within the Dread Ship Krazatoa!','',26124),
(114301,'enUS','Well done! The cursed ship shall haunt these seas no longer.','',26124),
(114302,'enUS','How would... You dare mock my imprisonment?! Then receive Loken\'s  punishment in his stead!','',26124),
(114303,'enUS','By killing you, I\'ll earn my way into the Halls of Valor.','',26124),
(114304,'enUS','','Mommy!',26124),
(114305,'enUS','','Thank -you-. I cannot begin to express my gratitude.',26124),
(114306,'enUS','Rise... Rise from the depths! There\'s plunder to be had!','',26124),
(114307,'enUS','Men! Slay these fools and welcome their souls... for eternity!','',26124),
(114308,'enUS','The Krazatoa returns to the darkness... for now!','',26124),
(114309,'enUS','So be it! I\'ll chain you to the ship myself!','',26124),
(114310,'enUS','Tell me when you are ready to go to the Oculus, $n. I should be able to send you through its wards.','',26124),
(114311,'enUS','I am ready.','I am ready.',26124),
(114312,'enUS','No, not yet.','No, not yet.',26124),
(114313,'enUS','Be ready for a fight, $n. You and I will not be welcome here...','',26124),
(114314,'enUS','Our brother has waited in chains long enough!','',26124),
(114315,'enUS','','We\'re not going up there without an extra hand, and that\'s final!',26124),
(114316,'enUS','When you are ready, I will create a portal that leads directly into the Violet Hold.','',26124),
(114317,'enUS','There was no trial for Koltira Deathweaver. Our attempts at diplomacy fell on deaf ears.','',26124),
(114318,'enUS','Create the portal.','Create the portal.',26124),
(114319,'enUS','The old masters must be put to rest...','',26124),
(114320,'enUS','The Horde and Alliance may be our allies, but the Ebon Blade does not bend the knee...','',26124),
(114321,'enUS','','Maybe you might help us. An old master of magic haunts the ruins here. She must be put to rest.',26124),
(114322,'enUS','...not for Sylvanas... not even for the Lich King himself!','',26124),
(114323,'enUS','This way, quickly!','',26124),
(114324,'enUS','I will come with you to help.','I will come with you to help.',26124),
(114325,'enUS','','Stay close, these ghosts have been agitated by all of the activity in Azsuna these days.',26124),
(114326,'enUS','','We\'re getting close. Keep the other spirits back. The masters remain powerful even in death.',26124),
(114327,'enUS','<The mage darts his eyes back and forth shiftily.>$b$bIs there anything I can do for you, $c? I have... matters... to attend to.','',26124),
(114328,'enUS','I see you for what you really are, demon. Drop the disguise and face your unmaker!','I see you for what you really are, demon. Drop the disguise and face your unmaker!',26124),
(114329,'enUS','You charade cannot fool these eyes, demon. Reveal yourself!','You charade cannot fool these eyes, demon. Reveal yourself!',26124),
(114330,'enUS','I see your true form, demon. This ends here.','I see you for what you are, demon. This ends here.',26124),
(114331,'enUS','Your disguise is pathetic. Drop the act, I\'m sending you back to the nether in pieces.','Your disguise is pathetic. Drop the act, I\'m sending you back to the nether in pieces.',26124),
(114332,'enUS','You\'ve forced my hand, $c. But I\'m not leaving this city without a fight!','',26124),
(114333,'enUS','','I will see you ahead on the bridge. But first, I must find my weapon.',26124),
(114334,'enUS','','We must stir the noble hearts of my people.',26124),
(114335,'enUS','','YOU... must show them that Azeroth has not forsaken them.',26124),
(114336,'enUS','','Be at peace, spirit!',26124),
(114337,'enUS','','The fel lord, Lochaber, is hiding somewhere in that mess up there. I have no desire to go anywhere near the gates just to kill one demon. We\'d end up having to wade through hundreds.\n\nOne thing I learned while having him imprisoned is that he\'s got quite the ego. So, I\'m going to call him out in front of all of the others.\n\n<Malace stifles a very unwarden-like giggle.>\n\nLet me know when you\'re ready, demon hunter.',26124),
(114338,'enUS','Glad to see you.','',26124),
(114339,'enUS','Siphoning','Siphoning',26124),
(114340,'enUS','Looks like the Legion\'s taking over Sandsorrow to the west! Get some forces out there on the double!','Looks like the Legion\'s taking over Sandsorrow to the west! Get some forces out there on the double!',26124),
(114341,'enUS','Found a couple of those demons east at the Caverns too! It\'s a war zone down here!','Found a couple of those demons east at the Caverns too! It\'s a war zone down here!',26124),
(114342,'enUS','Remember my name.','',26124),
(114343,'enUS','Looks like a group of demons are settin\' up camp at the compound to the south! These ogres are in for a big surprise!','Looks like a group of demons are settin\' up camp at the compound to the south! These ogres are in for a big surprise!',26124),
(114344,'enUS','Tell me about your plan.','Tell me about your plan.',26124),
(114345,'enUS','The Legion will triumph. Now and always.','',26124),
(114346,'enUS','Since the defeat of the Lich King, I\'ve spent my time around Ulduar learning about Tyr. He was the only titan keeper who fought Loken during his betrayal.','',26124),
(114347,'enUS','I found a vrykul saga describing a powerful shield Tyr crafted for his vrykul champion to carry into battle.','',26124),
(114348,'enUS','I have some ability to speak with the long departed. We may be able to question the hero in this saga directly.','',26124),
(114349,'enUS','Skovald take me.','',26124),
(114350,'enUS','Aye, that\'s my hope. With your help, we have a chance of finding this artifact.','',26124),
(114351,'enUS','Now I am off to the Halls...','',26124),
(114352,'enUS','One of those big one\'s is back at the south gates of Gadgetzan! We\'ll hold \'em off \'til we get some backup!','',26124),
(114353,'enUS','Gadgetzan! North gate\'s under attack again! Thing just appeared out of thin air...','Gadgetzan! North gate\'s under attack again! Thing just appeared out of thin air...',26124),
(114354,'enUS','','Ruolin, That was beautiful!',26124),
(114355,'enUS','Ready when you are. Taunt away.','Ready when you are. Taunt away.',26124),
(114356,'enUS','','Lochaber! Come demon, face us. If you are not afraid, that is.',26124),
(114357,'enUS','I FEAR NOTHING! I will kill you on my own. Caria and Varedis send their best regards, $p.','',26124),
(114358,'enUS','I require your aid with a matter of the utmost importance.','',26124),
(114359,'enUS','My sincere apologies for the insistence, $p, but we must speak immediately.','',26124),
(114360,'enUS','Your counsel is paramount to our next move against the Legion.','',26124),
(114361,'enUS','I am here when you are ready.','',26124),
(114362,'enUS','Mrglrmglr? Grlmglrg!','',26124),
(114363,'enUS','Grlgm. Mrglmrglr!','',26124),
(114364,'enUS','Excellent. Meet me at Krasus\' Landing when you are ready.','',26124),
(114365,'enUS','Grmlrgm... mrglrgml mlrmglrg mrmg. Mrgl...','',26124),
(114366,'enUS','Mr. Mrglglrm gestures at you.','',26124),
(114367,'enUS','Glrgm! Mrglmrlg mrglmglr? Mrl? Grlm?!','',26124),
(114368,'enUS','Mlrgmlrg. Mrlg mrglmr, mlrglrmgr? Grlgmlmrg rglmrglmr.','',26124),
(114369,'enUS','Grmlrgr! Mlrgmlrg mglrm glrmg!','',26124),
(114370,'enUS','Mrglglrm! Mrlgmrlg mglr!','',26124),
(114371,'enUS','Grlgr mrlgml. Mrglrglmr!','',26124),
(114372,'enUS','Mrlgmrlg, mgrmlgr rgmlrgmlr?','',26124),
(114373,'enUS','Mrgrlilrgl shakes their head and looks at Pearlhunter Phin.','',26124),
(114374,'enUS','Mrglrg! Glrmglmrg mglrmgl gmlrg. Mrglmrg?','',26124),
(114375,'enUS','Pearlhunter Phin breaks the cocoon open.','',26124),
(114376,'enUS','If you only knew what was coming...','',26124),
(114377,'enUS','%s clucks loudly as it moves in your direction.','',26124),
(114378,'enUS','One second I was up, the next I was... well, you know. Take care of yourself. It\'s crazy out here!','One second I was up, the next I was... well, you know. Take care of yourself. It\'s crazy out here!',26124),
(114379,'enUS','Thanks! Now get moving! No telling when they\'ll be back.','Thanks! Now get moving! No telling when they\'ll be back.',26124),
(114380,'enUS','What\'s goin\' on around here?','',26124),
(114381,'enUS','I didn\'t come all the way out here for this!','',26124),
(114382,'enUS','There is residual magic all about this island. If you gather some Azsunian pearls, we can use them as foci for some of our magics.','',26124),
(114383,'enUS','Perfect. These specimens are ideal for focusing magic.','',26124),
(114384,'enUS','If you wish, I can take you back up to the mountains.','',26124),
(114385,'enUS','Take me to the top of the Galebroken Path.','Take me to the top of the Galebroken Path.',26124),
(114386,'enUS','Take me to Throrim\'s Peak outside the Thorignir Refuge.','Take me to Throrim\'s Peak outside the Thorignir Refuge.',26124),
(114387,'enUS','Take me to the top of Thorim\'s Peak.','Take me to the top of Thorim\'s Peak.',26124),
(114388,'enUS','Even if no one here will help us, we must fulfill our duty. Let us pray that what remains of our order will be enough.','',26124),
(114389,'enUS','You... you walk in the path of the Light.\n\nWhat guides you here this day?','',26124),
(114390,'enUS','Come to Krasus\' Landing. We may be able to help your order.','Come to Krasus\' Landing. We may be able to help your order.',26124),
(114391,'enUS','If there is any chance of finding aid, Efrina and I will come. Stay, Dawnbreaker.','',26124),
(114392,'enUS','Greenies from sky done grooked my best grookers.$b$bSo we train with the wikkets. Sometimes kings can\'t be choosers!','',26124),
(114393,'enUS','','Rest now, sister. Your torment has ended.',26124),
(114394,'enUS','','We are in your debt. I will pass word of your deeds here to Prince Farondis.',26124),
(114395,'enUS','Soulfiend Tagerma preys upon the souls of worthy vrykul! Slay her, and you shall be justly rewarded.','',26124),
(114396,'enUS','The troops are itching for a fight, $n. Why don\'t you show them a few moves?','',26124),
(114397,'enUS','Aye, that\'s the one! Shield Hill it is. There\'s no time ta waste.','',26124),
(114399,'enUS','The fallen souls may float adrift for eternity, but none more by her hand. Thank you, champion.','',26124),
(114400,'enUS','Tyrosus, now he\'s a good man. Count me in! There\'s too much danger about to turn down a wee bit o\' help!','',26124),
(114401,'enUS','We may not be alone in this after all, Tahu! Let\'s see what Tyrosus has ta say.','',26124),
(114402,'enUS','Hold them back! We\'re not giving this camp up without a fight!','Hold them back! We\'re not giving this camp up without a fight!',26124),
(114403,'enUS','Keep them out! Reinforcements are on the way.','Keep them out! Reinforcements are on the way.',26124),
(114404,'enUS','Hold your ground. This war\'s only just beginning.','Hold your ground. This war\'s only just beginning.',26124),
(114405,'enUS','Stand up and fight! For the Horde!','Stand up and fight! For the Horde!',26124),
(114406,'enUS','We fight no matter what comes our way!','We fight no matter what comes our way!',26124),
(114408,'enUS','','Archers, mark your targets!',26124),
(114409,'enUS','No more challengers! Disturb these kings no more!','',26124),
(114410,'enUS','Plunder these tombs no more!','',26124),
(114411,'enUS','No one has survived this trial ever!','',26124),
(114412,'enUS','You\'re needed urgently at Krasus\' Landing first. Tyrosus sent me.','You\'re needed urgently at Krasus\' Landing first. Tyrosus sent me.',26124),
(114413,'enUS','No offense, but I don\'t have time to chat. I have a shield to find!','',26124),
(114417,'enUS','So we meet again.','',26124),
(114418,'enUS','Your presence was not accounted for, but I believe my hounds will enjoy making a meal of you nonetheless.','',26124),
(114419,'enUS','When they are done tearing you apart limb from limb, they will begin their feast on the magical prisoners within these cells.','',26124),
(114420,'enUS','','Yarrrrr! Thar be Ol\' Eary, terror of the open seas! Now\'s our chance boys, git \'em!',26124),
(114421,'enUS','Once sated, my hounds will charge the city, slaughtering everyone in their path.','',26124),
(114422,'enUS','Dalaran will fall to the Burning Legion!','',26124),
(114423,'enUS','My hounds!','',26124),
(114424,'enUS','You will pay with your life for what you\'ve done!','',26124),
(114425,'enUS','I am forever indebted to you, $n.','',26124),
(114426,'enUS','The Light... it BURNS... You will pay for this, $c!','',26124),
(114427,'enUS','You have my thanks! I had been hanging there for an eternity.','',26124),
(114428,'enUS','You have much to explain. Why have you betrayed us?','You have much to explain. Why have you betrayed us?',26124),
(114429,'enUS','I would never willingly betray our cause, $n!\n\nI was gathering notes on the Nightborne Soulstone when I was contacted by an emissary of the Empyrean Society. When I arrived at their enclave, our old nemesis Kathra\'natir was waiting for me. \n\nHe has been in my head ever since, controlling my every word and action.','',26124),
(114430,'enUS','Yes. It is Meryl he is after. He is using the Nightborne Soulstone and the power of the Nexus to drain Meryl of his power. Together you and I may be able to stop him. \n\nHe is still here, somewhere below. We must find him!','',26124),
(114431,'enUS','I see. Is Kathra\'natir behind the attack on Meryl?','Is Kathra\'natir behind the attack on Meryl?',26124),
(114432,'enUS','','How utterly predictable! I knew that you would come.',26124),
(114433,'enUS','I\'ll devour yer parrot ye mutinous blowfish!','I\'ll devour yer parrot ye mutinous blowfish!',26124),
(114434,'enUS','Ye don\' need a sword. Yer face be deadlier! Garr!','Ye don\' need a sword. Yer face be deadlier! Garr!',26124),
(114435,'enUS','Ye fight like a dairy farmer, ye lyin\' scabby halfwit!','Ye fight like a dairy farmer, ye lyin\' scabby halfwit!',26124),
(114436,'enUS','I\'ll skewer yer gizzard, ye fish-kissin\', vile cur...','I\'ll skewer yer gizzard, ye fish-kissin\', vile cur...',26124),
(114437,'enUS','Ye smell of fish an\' swine, ye mermaid marryin\' monkey!','Ye smell of fish an\' swine, ye mermaid marryin\' monkey!',26124),
(114438,'enUS','','I have what I was after. But I stayed just so that I could put an end to you... once and for all!',26124),
(114439,'enUS','A black spot upon thee, ye barnacle bottomed sluggard!','A black spot upon thee, ye barnacle bottomed sluggard!',26124),
(114440,'enUS','','I already have the Sargerite Keystone. But I stayed just so that I could put an end to you... once and for all.',26124),
(114441,'enUS','Ye be as repulsive as a monkey in a negligee!','Ye be as repulsive as a monkey in a negligee!',26124),
(114442,'enUS','','And now you fools have fallen into my trap. Let\'s see how you fare in the dark.',26124),
(114443,'enUS','How about a duel?','How about a duel?',26124),
(114444,'enUS','I could use a good fight.','I could use a good fight.',26124),
(114445,'enUS','Show me what you\'ve got!','Show me what you\'ve got!',26124),
(114446,'enUS','Feel like showing me a few pointers?','Feel like showing me a few pointers?',26124),
(114447,'enUS','I admire your skill in battle. How about a quick match?','I admire your skill in battle. How about a quick match?',26124),
(114448,'enUS','Feel like training with me?','Feel like training with me?',26124),
(114449,'enUS','Let\'s duel.','Let\'s duel.',26124),
(114450,'enUS','Good battle.','Good battle.',26124),
(114451,'enUS','Well struck.','Well struck.',26124),
(114452,'enUS','Thank you for the duel.','Thank you for the duel.',26124),
(114453,'enUS','You have won.','You have won.',26124),
(114454,'enUS','You take care of the Houndmaster, and we\'ll focus our attacks on his hounds.','',26124),
(114455,'enUS','Next time I won\'t be so easy on you!','Next time I won\'t be so easy on you!',26124),
(114456,'enUS','You have bested me.','You have bested me.',26124),
(114457,'enUS','Fine duel.','Fine duel.',26124),
(114458,'enUS','You take this round.','You take this round.',26124),
(114459,'enUS','I have detected an anomaly in the area drawing power from our network! Locate and dispose of it in any fashion you see fit.','',26124),
(114460,'enUS','Ah, the grid is clearing up nicely. I knew I could count on you!','',26124),
(114461,'enUS','Yer ship has more holes than a sponge, ye slack-jawed cockroach!','Yer ship has more holes than a sponge, ye slack-jawed cockroach!',26124),
(114462,'enUS','\'Tis good ye\'re here. Ye\'ll scare away the rats!','\'Tis good ye\'re here. Ye\'ll scare away the rats!',26124),
(114463,'enUS','\'Tis not enough rum in the world to make yer face look good, ye blasted, sorry sea bass!','\'Tis not enough rum in the world to make yer face look good, ye blasted, sorry sea bass!',26124),
(114464,'enUS','Use protection magic! That damage is too much for me to heal!','',26124),
(114465,'enUS','','I\'ll scout out ahead for a good vantage point. Meet me close to the city wall once you have a grapple.',26124),
(114466,'enUS','There are reports that the Legion brought a demonic watchdog known as Velimar into the city. Convenient! I could use its eyes to enhance the network.','',26124),
(114467,'enUS','Here\'s looking at you!','',26124),
(114468,'enUS','Brothers and sisters, we must not forget the Ashbringer. Tirion may be gone, but the highblade is still out there somewhere.','',26124),
(114469,'enUS','We should leave for Uther\'s Tomb at once.','',26124),
(114470,'enUS','For the Alliance!','For the Alliance!',26124),
(114471,'enUS','Give them hell, $n.','Give them hell, $n.',26124),
(114472,'enUS','This is your ship, $n. Light be with you.','This is your ship, $n. Light be with you.',26124),
(114473,'enUS','Pearlhunter Phin points at the Leyscar Scuttler.','',26124),
(114474,'enUS','Yes, yes! Surrender your power, dragon. These pools belong to the Nightborne now!','',26124),
(114475,'enUS','Help me, small one...','',26124),
(114476,'enUS','It seems the Highlord\'s absence has affected more than just the living.','',26124),
(114477,'enUS','Sudden reappearance of the Scarlet Crusade with a newfound drive to wipe out the undead of the world? I\'ve heard this one before. You\'re a dread lord, aren\'t you?','Sudden reappearance of the Scarlet Crusade with a newfound drive to wipe out the undead of the world? I\'ve heard this one before. You\'re a dread lord, aren\'t you?',26124),
(114478,'enUS','','Unliving scum! Your very existence is an insult to everyone who lost their families to the Scourge. Take that tabard off and crawl back into your grave before I put you there!',26124),
(114479,'enUS','','I suppose you\'ll just have to trust me, won\'t you?',26124),
(114480,'enUS','','Interlopers like you are responsible for gutting the strength of the Scarlet Crusade! We would\'ve eradicated the unliving from this world and the Burning Legion would have never come this far! Begone!',26124),
(114481,'enUS','For the Crusade!','For the Crusade!',26124),
(114482,'enUS','You and I both know your \'order\' is broke and can use every copper you can get your hands on. Quiet your empty protests and take my money.','You and I both know your \'order\' is broke and can use every copper you can get your hands on. Quiet your empty protests and take my money.',26124),
(114483,'enUS','','I can see you\'re a friend of the Crusade. I\'ve managed to smuggle some equipment out of the Monastery in an attempt to raise funds for our order. We will not rest until the unliving have been driven from Azeroth!\n\nDo keep in mind you and your ilk have left us on the verge of ruin, so what I\'m selling won\'t come cheap.',26124),
(114484,'enUS','Plaguemaw scours the seas of Helheim, leaving only carrion in his wake. Destroy this menace!','',26124),
(114485,'enUS','The mortals within Stormheim are forever in your debt. Come, claim your prize.','',26124),
(114486,'enUS','','Ah, the vaunted Duskwatch. If you could liberate some of their supplies, it would greatly aid our cause.',26124),
(114487,'enUS','','Good work. That should slow them down.',26124),
(114488,'enUS','The death of his enforcer should send the right message. Finish the ritual, he\'s sure to attack soon.','',26124),
(114489,'enUS','Look out!','',26124),
(114490,'enUS','I will prepare the ceremony while you assist our allies.','',26124),
(114491,'enUS','That is quite a story. Let\'s go.','That is quite a story. Let\'s go.',26124),
(114492,'enUS','We know how Suramar\'s isolation changed its inhabitants - but what of the plant life? Satisfy my curiosity with samples from the Court of Stars.','',26124),
(114493,'enUS','Interesting. Cultivated with extreme care. It seems even the reckless Nightborne know that life and magic must exist in balance.','',26124),
(114494,'enUS','','The light of Elune no longer shines on the wildkin of this grotto. They have become fearsome owlbeasts and are a danger to all.',26124),
(114495,'enUS','Thank you, little $c. Senegos was wise to trust in you.','',26124),
(114496,'enUS','What did we do to deserve this?','',26124),
(114497,'enUS','As I fell, I saw one of the nightfallen slinking into our caves.','',26124),
(114502,'enUS','My spirit perseveres.','',26124),
(114503,'enUS','Let us speak.','',26124),
(114504,'enUS','Farewell.','',26124),
(114505,'enUS','Thank you, friend.','',26124),
(114506,'enUS','','An old student of mine still resides in the city. There once was a time I thought I could trust her. Make sure she understands what happens to traitors.',26124),
(114507,'enUS','','Splendidly done. I wish I could have been there myself.',26124),
(114508,'enUS','','Shar\'thos has returned to his roost. Put him out of his misery before he spreads the taint he has succumb to.',26124),
(114509,'enUS','','Well done! Let us hope that this chapter in Shar\'thos\'s life is forgotten.',26124),
(114510,'enUS','','The nearby wolves have grown too bold. It is time to cull the pack.',26124),
(114511,'enUS','','The day is won! Well fought champion.',26124),
(114512,'enUS','For centuries our order has guarded and kept hidden a sacred site, the Tomb of Tyr.\n\nTyr, a titan keeper, performed many valiant acts for the good of Azeroth until he was brought low by treachery and the power of the Old Gods. The treacherous Loken sent powerful C\'Thraxxi to slay Tyr.  He fought them off, killing one and forcing the other to flee, but it cost him his life.\n\nSome of the vrykul that accompanied Tyr were so moved by his sacrifice they remained behind to guard his tomb. These vrykul were eventually replaced by humans, us. We have kept the world from discovering its location for a very long time... until recently.','',26124),
(114513,'enUS','Stories tell of the dark beast, Shroudseeker! It wanders the shadows and plagues this world with illusions - eradicate this foul shade.','',26124),
(114514,'enUS','The deed is now done. You shall be righteously rewarded.','',26124),
(114516,'enUS','We should head to ground level. Let me know when you are ready and I will teleport us there.','',26124),
(114517,'enUS','I\'m ready.','I\'m ready.',26124),
(114518,'enUS','Are you ready to teleport to the ground?','',26124),
(114519,'enUS','Kathra\'natir is in the Nexus building. It appears to be heavily guarded! Perhaps we should use an Invisibility spell and walk right in.','',26124),
(114520,'enUS','','I\'ll make my way to Dreadscar Rift as soon as I get this confession in front of the right people.',26124),
(114521,'enUS','','You can count me among those that are willing to fight the Burning Legion at your side.',26124),
(114522,'enUS','Invisibility will not last long. Let\'s go!','',26124),
(114523,'enUS','Form ranks! Weapons ready!','',26124),
(114524,'enUS','Stand strong! Incoming!','',26124),
(114525,'enUS','A Legion vessel is closing in! Take your positions! If you can lift a weapon, pick it up and fight!','',26124),
(114526,'enUS','Unsheathe your weapons! Heed the call of war! The Legion approaches from the north!','',26124),
(114527,'enUS','Hold your ground! Give no quarter to these invaders!','',26124),
(114528,'enUS','Show them our strength! Do not relent!','',26124),
(114529,'enUS','Send these demons back to the Twisting Nether!','',26124),
(114530,'enUS','Ready your blades! Take down the commander!','',26124),
(114532,'enUS','The portals are closing! Rangers, lets finish off the last of these hounds.','',26124),
(114535,'enUS','There... all the components are in place. Activate the Ritual Focus when you are ready.','',26124),
(114536,'enUS','','Look out!',26124),
(114537,'enUS','','Careful, he bites.',26124),
(114538,'enUS','I\'d like an eagle to Trueshot Lodge.','I\'d like an eagle to Trueshot Lodge.',26124),
(114539,'enUS','','Good to see you again, $n.',26124),
(114540,'enUS','','We must take care. The withered ones prowl this area, ravenous in their hunger for magic and flesh alike.',26124),
(114541,'enUS','','Stay close!',26124),
(114542,'enUS','','Do not be foolish, outlander. My barrier will protect you.',26124),
(114543,'enUS','We are ready to commune with Lord Uther, $n. Join me at the tomb.','',26124),
(114544,'enUS','These demons dare to befoul Azeroth? Take back what is rightfully ours!','',26124),
(114545,'enUS','Don\'t let them hold an inch of ground! Drive them out!','',26124),
(114546,'enUS','Keeper Remulos appears drained and dazed. The owlbeasts nearly destroyed him.','',26124),
(114547,'enUS','Free Remulos from captivity.','Free Remulos from captivity.',26124),
(114548,'enUS','','We must free Keeper Remulos at once! I know a shortcut to the cave he is being held in. Come, $n. Follow me!',26124),
(114549,'enUS','Thank you! We must leave this place at once.','',26124),
(114550,'enUS','','I hope we are not too late to save Keeper Remulos.',26124),
(114551,'enUS','We made it! Kathra\'natir is inside just ahead.','',26124),
(114552,'enUS','','I know some who would choose the pursuit of power over the needs of others...',26124),
(114553,'enUS','It was never a choice, Kira.','',26124),
(114554,'enUS','Move out! Rid our lands of them!','',26124),
(114555,'enUS','Rest when they\'re dead... or you are! Until then, FIGHT!','',26124),
(114556,'enUS','Get to the Crossroads! Everyone on the leader! Take its head!','',26124),
(114557,'enUS','It\'s attacking the Crossroads! Come and show this monstrosity the price for trespassing on OUR world!','',26124),
(114558,'enUS','Hero, use this rune to empower yourself.','',26124),
(114559,'enUS','Rally at the Crossroads! Take out the biggest threat!','',26124),
(114560,'enUS','','I\'ll have my people talk to your people. Sound good?',26124),
(114561,'enUS','','Uh-huh. Mhm. Yup. Totally paying attention.',26124),
(114562,'enUS','','Oh, you\'re one of those rogues.',26124),
(114563,'enUS','Well fought! The Legion won\'t soon forget the sting of Kalimdor steel!','',26124),
(114564,'enUS','Victory is ours! But stay strong... the true battle is yet to come!','',26124),
(114565,'enUS','Uther\'s resting place lies just ahead.','',26124),
(114566,'enUS','Your world shall burn!','Your world shall burn!',26124),
(114567,'enUS','None can stand against the Burning Legion!','None can stand against the Burning Legion!',26124),
(114568,'enUS','Your world is at an end!','Your world is at an end!',26124),
(114569,'enUS','The Legion cannot be stopped!','The Legion cannot be stopped!',26124),
(114570,'enUS','Your end awaits, mortals!','Your end awaits, mortals!',26124),
(114571,'enUS','This will be your end!','This will be your end!',26124),
(114572,'enUS','You cannot escape the power of the Burning Legion!','You cannot escape the power of the Burning Legion!',26124),
(114573,'enUS','Worthless mortals! You will suffer!','Worthless mortals! You will suffer!',26124),
(114574,'enUS','Friend won\'t need to face the Legion alone.','',26124),
(114575,'enUS','Begin when you are ready.','',26124),
(114576,'enUS','I will not rest until the council has been rebuilt.','',26124),
(114577,'enUS','Shard, come to me and strike our enemies down!','',26124),
(114578,'enUS','Gravel, crush them into rubble.','',26124),
(114579,'enUS','The waters begin to stir!','The waters begin to stir!',26124),
(114580,'enUS','','Welcome aboard, $n. \n\nWe\'re all stocked and ready to ship out just as soon as you\'re ready.',26124),
(114581,'enUS','I am ready to face the Legion.','I am ready to face the Legion.',26124),
(114582,'enUS','Are you prepared to face the Legion at the Broken Shore?','Are you prepared to face the Legion at the Broken Shore?',26124),
(114583,'enUS','Su Hee reveals its true form!','Su Hee reveals its true form!',26124),
(114584,'enUS','$n prepares a Rack of Ribs!','$n prepares a feast of Broiled Dragon!',26124),
(114585,'enUS','$n prepares a pot of Potato Stew!','$n prepares a feast of Broiled Dragon!',26124),
(114586,'enUS','I resume my watch.','',26124),
(114587,'enUS','Damage assessment complete. Defensive mode engaged.','',26124),
(114588,'enUS','Puny Elves!  Ettin strongest one there is!','',26124),
(114589,'enUS','The others can\'t see me, but I like to watch them go about their business. This is all very exciting. For the longest time, it was just me and the Servants of Illidan who were left behind.\n\nAlas, I am stuck here, for all eternity, in the Twisting Nether. I can never leave, $n.\n\nStill, it was worth it and I would do it all over again. I would gladly sacrifice myself and willingly stand there as you struck me down in order to fuel the final gateway and summon in your demonic forces. It is what was necessary for the cause.\n\nWhat demon hunter wouldn\'t?\n\nLong live the Illidari!','',26124),
(114590,'enUS','Light, hear our prayers... for shadows close in around us.','',26124),
(114591,'enUS','Grant us this one audience, so the Ashbringer may yet save our world.','',26124),
(114592,'enUS','Do you know where it is, Uther? We risk everything if we return to that place.','',26124),
(114593,'enUS','The tethers have broken. Selentia is vulnerable!','The tethers have broken. Selentia is vulnerable!',26124),
(114594,'enUS','','The council is in good hands with you as its leader.',26124),
(114595,'enUS','Return to your home.','Return to your home.',26124),
(114596,'enUS','This area is off limits. You should leave. Now.','This area is off limits. You should leave. Now.',26124),
(114597,'enUS','Rations will be distributed according to the Magistrix\'s orders.','Rations will be distributed according to the Magistrix\'s orders.',26124),
(114598,'enUS','You are not authorized to enter the Vineyard.','You are not authorized to enter the Vineyard.',26124),
(114599,'enUS','Maintain decorum or suffer the consequences, citizen.','Maintain decorum or suffer the consequences, citizen.',26124),
(114600,'enUS','The Vineyards are open to special guests only. You must leave immediately.','The Vineyards are open to special guests only. You must leave immediately.',26124),
(114601,'enUS','I\'m starving!','I\'m starving!',26124),
(114602,'enUS','Please... I need it!','Please... I need it!',26124),
(114603,'enUS','How can you watch me suffer?','How can you watch me suffer?',26124),
(114604,'enUS','Let me go inside! Please!','Let me go inside! Please!',26124),
(114605,'enUS','I know you\'re keeping some for yourself- please just give me a little!','I know you\'re keeping some for yourself- please just give me a little!',26124),
(114606,'enUS','Please help me... please...','Please help me... please...',26124),
(114607,'enUS','My daughter is dying! Please, you must help me save her!','My daughter is dying! Please, you must help me save her!',26124),
(114608,'enUS','Go home, citizen.','Go home, citizen.',26124),
(114609,'enUS','Be on your way now.','Be on your way now.',26124),
(114610,'enUS','Maxwell, my old friend! It\'s been too long.','',26124),
(114611,'enUS','Which gives me great honor to say this next part. Mayla Highmountain, I hereby pronounce you High Chieftain. Long may you stand!','',26124),
(114612,'enUS','You\'re both doing the Light\'s work, but if you seek to recover the Ashbringer, you must hurry.','',26124),
(114613,'enUS','I can feel the Ashbringer calling out from an island that lies close to the tomb of the evil one. And the blade is not alone...','',26124),
(114614,'enUS','Tirion still lives, but his light is fading. You must move swiftly, or he will perish! That is all I can tell you.','',26124),
(114615,'enUS','Uther, wait! I have more to ask you! Uther!','',26124),
(114616,'enUS','Good luck, friends. Walk always in the Light.','',26124),
(114617,'enUS','Uther, it\'s really you!','',26124),
(114618,'enUS','','You shall be my new subject\'s first test!',26124),
(114619,'enUS','','Are you ready to return to the prison? We won\'t do much good out here.\n\nWe should rejoin our allies and help take down Hakkar before he has a chance to unleash his beasts onto the city.',26124),
(114620,'enUS','Interested in some magic fishing? Sounds cool right?','',26124),
(114622,'enUS','If Tirion is still alive, we will save him... or die trying.','',26124),
(114624,'enUS','Together we can defeat Kathra\'natir! Use the Nightborne Soulstone while we hold him off!','',26124),
(114626,'enUS','Make the boomy fire thing! Make the boom!','',26124),
(114627,'enUS','I want Snow! Make it snow! Make it Snow! Make it Snow!','',26124),
(114628,'enUS','Do Ice Fist human!','',26124),
(114629,'enUS','For the Horde!','For the Horde!',26124),
(114630,'enUS','Well done everyone!','Well done everyone!',26124),
(114631,'enUS','Blood and Honor!','Blood and Honor!',26124),
(114632,'enUS','Demon filth!','Demon filth!',26124),
(114633,'enUS','We stand as one!','We stand as one!',26124),
(114634,'enUS','Might of the Horde!','Might of the Horde!',26124),
(114635,'enUS','By our blades!','By our blades!',26124),
(114637,'enUS','','A servant of the Old Gods! Let us consume it!',26124),
(114638,'enUS','','There! A spy for N\'Zoth! We should kill it.',26124),
(114639,'enUS','','Do you see it? The poor host cannot be saved, only put down.',26124),
(114640,'enUS','You! $C! Have you been inside the Violet Hold?$b$bThese imbecile guards keep waving me away. Do they not know who I am?','',26124),
(114641,'enUS','Meddling $c... You will pay for your interference. This whole city will burn!','',26124),
(114643,'enUS','','<Thalyssra brings a hand to her gaunt cheek.>$B$BMy body has deteriorated so quickly...$B$BIt seems we Nightborne live each day upon the razor\'s edge.',26124),
(114644,'enUS','','I will free Suramar from the Legion, but first I must regain my strength.$B$BAnd we need a plan...',26124),
(114645,'enUS','','I hope my comrades have fared better than me.',26124),
(114646,'enUS','$n, I must speak with you, the matter is urgent!','',26124),
(114647,'enUS','It concerns High Overlord Saurfang! I fear he plans to bring doom upon himself!','',26124),
(114648,'enUS','This matter cannot wait, we must speak now!','',26124),
(114649,'enUS','My thanks, champion. I will seek out Thrall and see if he can help.','',26124),
(114650,'enUS','Follow me. This will lead us to the ramparts.','',26124),
(114651,'enUS','Ah, I\'ll wager Eitrigg sent you. His concern is noble, but unnecessary.','',26124),
(114652,'enUS','Recent events weigh heavily on me. There is something I must do.','',26124),
(114653,'enUS','What must you do?','What must you do?',26124),
(114654,'enUS','That will teach you to interfere with the Legion\'s plans...','',26124),
(114655,'enUS','','With Hakkar dead, the citizens of Dalaran will be safe. Most will never know the threat they faced, thanks to your heroic actions.',26124),
(114656,'enUS','','You struck the fel lord down before he had a chance to terrorize the city. You upheld the oath we all took to watch and protect.',26124),
(114657,'enUS','','It would be naive to assume this is the last threat Azeroth will face.',26124),
(114658,'enUS','','The Burning Legion is at our doorstep, demanding to be reckoned with.',26124),
(114659,'enUS','','In times like these, our oath is more important than ever.',26124),
(114660,'enUS','That battle, I can find no glory in it. Too many died, but I did not. The anger within me grows every minute I stare at that storm.\n\nI will return to the Broken Shore, for those under my command. I will kill demons until their glory is found and my honor restored. Do not seek to counsel against this, I am set in my ways.','',26124),
(114661,'enUS','','We do not fight for glory, for fame, or riches.',26124),
(114662,'enUS','','We exist to protect those who need it most, often without reward or recognition.',26124),
(114663,'enUS','Then I will go with you. No one should fight alone.','Then I will go with you.',26124),
(114664,'enUS','','We are the watchers in the wild.',26124),
(114665,'enUS','','We are the eagle on the wind.',26124),
(114666,'enUS','','We walk the lonely road.',26124),
(114667,'enUS','','For ours is the Unseen Path.',26124),
(114668,'enUS','Death is our likely end on those shores. You know this, yet I can see the determination in your eyes. Perhaps you have honor to regain there as well.','',26124),
(114669,'enUS','The others should be waiting for you in the sanctum beneath the chapel, $n.','The others should be waiting for you in the sanctum beneath the chapel, $n.',26124),
(114670,'enUS','The others await you in the sanctum beneath the chapel, $n.','',26124),
(114671,'enUS','%s nudges Maxwell\'s ankle.','',26124),
(114673,'enUS','%s grunts and shoves the goat away, embarrased.','',26124),
(114677,'enUS','Commander! I have a message for you!','',26124),
(114678,'enUS','I bear an important message from Danath Trollbane!','',26124),
(114679,'enUS','If you please, this is an urgent matter that requires your attention!','',26124),
(114680,'enUS','Excellent, commander. Danath awaits you on Krasus\' Landing.','',26124),
(114681,'enUS','Rokmora creates |cFFFF0000|Hspell:215898|h[Crystaline Ground]|h|r! Don\'t move!','',26124),
(114682,'enUS','<Caprina reeks of animal fur and dung.>$b$bWhat\'re you looking at, $c? Why don\'t you go bother Crawford or Heathrow?','',26124),
(114683,'enUS','Blast you, $c scum! My ruse was flawless!','',26124),
(114684,'enUS','My masters will hear of this... The Legion will set this whole coast aflame...','',26124),
(114685,'enUS','I hope ya shot that demon right between the eyes!','',26124),
(114697,'enUS','Look there, upon that terrible sight. How many disasters must we face before we can at last find peace?','',26124),
(114706,'enUS','The nightmare consumes, $c. It devours from within. It overwhelms one\'s thoughts as easily as it creeps across the terrain.$b$bInevitably, the mind fills with shadows, and all hope is eclipsed.$b$bIt is terrible. It is... beautiful...','',26124),
(114707,'enUS','I am revealed! Fight me if you must - your kind will never win.','',26124),
(114708,'enUS','All things must end. The dream is dead. Forever.','',26124),
(114709,'enUS','Tiny mortal. Your insolence has come to an end.','',26124),
(114710,'enUS','You and your Illidari will join the Burning Legion. You will become Felsworn.','',26124),
(114711,'enUS','You may grovel now, demon hunter.','',26124),
(114712,'enUS','Very well. You have sealed your fate. Varedis and Caria will deal with you.','',26124),
(114713,'enUS','The Molten Charskin becomes |cFFFF0000|Hspell:200672|h[Crystal Cracked]|h|r!','',26124),
(114714,'enUS','$n! Kil\'jaeden has ordered your capture. You will join the Burning Legion.','',26124),
(114715,'enUS','Kil\'jaeden will have you...','',26124),
(114716,'enUS','','How touching. A few more champions. As if that will help in any way.',26124),
(114717,'enUS','Quite the ragtag bunch you have here, $n. I would have thought you could do better.','',26124),
(114718,'enUS','But, enough with the pleasantries. Our lord, Kil\'jaeden, has sent us to let you know that you and your Illidari will soon be joining the Burning Legion...','',26124),
(114719,'enUS','','... and to prove that you are not safe, not even here on the Fel Hammer.',26124),
(114720,'enUS','Hear me, Illidari! All present are welcome into the embrace of the Legion.','',26124),
(114721,'enUS','','Great power will be imbued into those who join us. Painful agony awaits those who do not.',26124),
(114722,'enUS','I for one hope that you refuse. Then, those warglaives will once again return to their rightful owner.','',26124),
(114723,'enUS','','Tsk, tsk, Varedis. Fair is fair. Until we meet again in the flesh, $n.',26124),
(114724,'enUS','Strike me down, you fools, before Razelikh regains control!','',26124),
(114725,'enUS','And now, to break these fetters and feast upon your souls. Ahahahahahaha!','',26124),
(114726,'enUS','NO, demon! You will not prevail.','',26124),
(114727,'enUS','$p. Illidari. Hear me. I will take great pleasure in sacrificing each of you to Kil\'jaeden just as soon as I break Loramus\'s hold on my body.','',26124),
(114728,'enUS','How long must I endure?!','',26124),
(114729,'enUS','An eternity of exquisite pain and suffering await you. Know my name, Illidari, for I am Razelikh the Defiler!','',26124),
(114730,'enUS','I am Loramus... no, I AM RAZELIKH! Enough demon, you will submit. I compel you!','',26124),
(114731,'enUS','NOTHING CAN PREVENT YOUR WORLD FROM BURNING!','',26124),
(114732,'enUS','I will do my best to keep control over Razelikh and share all of its demonic knowledge with you.','',26124),
(114733,'enUS','Allow me to assure you, demon hunters, that you cannot trust anything that comes out of this mouth.','',26124),
(114734,'enUS','While Razelikh is not privy to the Legion\'s current plans, he does know a great deal of magic that can give us an edge.','',26124),
(114735,'enUS','Thank you for bringing me into your midst, $p. This \"trap\" will not be able to hold me forever.','',26124),
(114736,'enUS','It is an honor to do whatever I can to defeat the Burning Legion, $p.','',26124),
(114737,'enUS','When the Legion comes, and allow me to assure that they will, your little command center here will not be able to protect you.','',26124),
(114738,'enUS','There is a Felsworn hiding amongst you. Did you know that?','',26124),
(114739,'enUS','For years, our souls struggled against each other in the Twisting Nether. Then recently, we appeared back on Azeroth. That is how I found myself fighting for control of this new dreadlord body.','',26124),
(114740,'enUS','The Scarlet Crusade is blinded by hatred and fear... driven to madness and murder. They are beyond redemption and undeserving of mercy.','',26124),
(114741,'enUS','Now, kneel. Kneel before your new master!','',26124),
(114742,'enUS','You cannot fight my will. You are mine.','',26124),
(114743,'enUS','Very well. This will be a fine test.','',26124),
(114744,'enUS','Give me the strength... to shatter these bonds....','',26124),
(114745,'enUS','','The powerful wizard, Padawsen, has been captured by Humongris. Find Humongris and kill him before he kills Pawdawen.',26124),
(114746,'enUS','','Humongris is dead, and Padawsen is alive. Well done.',26124),
(114747,'enUS','Squish you!','',26124),
(114748,'enUS','','You could not kill me if you tried for a hundred years!',26124),
(114749,'enUS','','Each must die someday.',26124),
(114750,'enUS','Some call me eccentric or even daft, but they fail to see the bigger picture. Our only hope in defeating the burning legion is to find new sources of power, even if that means taking great risks. \n\nYour new weapon is a testament to that!','',26124),
(114751,'enUS','','You have defiled the old ways, mystic! The God-King is not worthy of the Halls of Valor!',26124),
(114752,'enUS','I spit on your ancient rites, shieldmaiden!','',26124),
(114753,'enUS','I would see you banished before I allow you to grant judgment to an outsider!','',26124),
(114754,'enUS','There\'s the Nightborne Soulstone! He\'s using it against an image of Meryl...','',26124),
(114755,'enUS','Did you really think you could defeat me, little mage? I am invincible!','',26124),
(114756,'enUS','You have done it! Kathra\'natir is safely imprisoned within the Nightborne Soulstone!','',26124),
(114757,'enUS','Well done, my mortal friend! We should bring that back to the Hall of the Guardian for safekeeping.','',26124),
(114758,'enUS','','I would not have thought it possible had I not witnessed it myself. Bravo!',26124),
(114759,'enUS','Thanks to you, a great weight has been lifted. Let us return to the Hall of the Guardian.','',26124),
(114760,'enUS','Halt!','Halt!',26124),
(114761,'enUS','Stop right there!','Stop right there!',26124),
(114762,'enUS','Learn your place, dog!','Learn your place, dog!',26124),
(114763,'enUS','Stand back!','Stand back!',26124),
(114764,'enUS','You are out of line!','You are out of line!',26124),
(114765,'enUS','You forget your station, filth!','You forget your station, filth!',26124),
(114766,'enUS','Begone!','Begone!',26124),
(114767,'enUS','I can\'t take this anymore! Let me in!','I can\'t take this anymore! Let me in!',26124),
(114768,'enUS','I know you have more! Give me the wine!','I know you have more! Give me the wine!',26124),
(114769,'enUS','I can\'t live like this!','I can\'t live like this!',26124),
(114770,'enUS','Now to select the appropriate target. A Soul Engine, perhaps? That battleship might do...','',26124),
(114771,'enUS','Cannons! Fly low and dodge the blasts!','',26124),
(114772,'enUS','<roars> Make them pay, $n! Make them--','',26124),
(114773,'enUS','I am ogre. Totally ogre. Definitely not... NOT ogre.','',26124),
(114774,'enUS','Braaahhhgg magic disguise stupid plan anyways. It is time to kill!','',26124),
(114775,'enUS','Brah hah. Hah hah. Smashed. Disguises are a good plan. Hah hah.','',26124),
(114776,'enUS','You can\'t keep me out!','You can\'t keep me out!',26124),
(114777,'enUS','Please! Please help me!','Please! Please help me!',26124),
(114778,'enUS','I\'ll die without it! You have to help me!','I\'ll die without it! You have to help me!',26124),
(114779,'enUS','I have to do something!','I have to do something!',26124),
(114780,'enUS','I am shal\'dorei! I will not be denied!','I am shal\'dorei! I will not be denied!',26124),
(114781,'enUS','$n prepares a Bushel of Apples!','$n prepares a Bushel of Apples!',26124),
(114782,'enUS','Mrgrlilgrl! Mrglmr gmrlgrmglr?!','',26124),
(114783,'enUS','Legion, come to our aid!','Legion, come to our aid!',26124),
(114785,'enUS','To me, servant!','To me, servant!',26124),
(114786,'enUS','Illidari, prepare for jump to Niskara!','',26124),
(114787,'enUS','Illidari, prepare for the jump to Niskara!','',26124),
(114788,'enUS','Wikket got water, clear and pure, \'fore greenies from sky could dook it for sure.','',26124),
(114789,'enUS','Hurry up, wikket, make your feet into dancers! For my riddles you\'ll go off and find all the answers.','',26124),
(114790,'enUS','My flesh is yours, Naraxas!','',26124),
(114791,'enUS','Take me, Mother of Worms!','',26124),
(114792,'enUS','Consume my blood for power!','',26124),
(114793,'enUS','That\'s one... that\'s two... ah yes, that is three! Now we find out if right wikket be!','',26124),
(114794,'enUS','Glmrg! Gmlrgm mglrmgrl mrmglr!','',26124),
(114795,'enUS','There was an ancient parable. About a woodcutter. He chopped wood as the forest burned.$b$b\"Why is it you chop wood?\" they ask him. \"The forest burns. Soon your house will burn.\"$b$bThe woodcutter, he watches the flames, he breathes in the smoke. \"Who am I to change?\" he asks. \"I am what I am.\"$b$b<Dareer chops another cord of wood.>$b$bThere is no moral.','',26124),
(114796,'enUS','You play with fire, fool $c! YOU WILL BURN!','',26124),
(114797,'enUS','The light... my flesh... No no NO you will ruin everything, fool of a $c!','',26124),
(114798,'enUS','No place is safe. No mountain is too high to flee from the Legion\'s rage. I will return!','',26124),
(114799,'enUS','I want snow! Make the snow!','',26124),
(114800,'enUS','Stop shaking me!','',26124),
(114801,'enUS','I am going to be sick!','',26124),
(114802,'enUS','Whaaaaaaaaaaaaa!','',26124),
(114803,'enUS','OK, just stop squeezing.','',26124),
(114804,'enUS','You are crushing me!','',26124),
(114805,'enUS','Gaaahh! My spine is going to Gaaarg!','',26124),
(114806,'enUS','It is called Ice Block, you big stupid Arrggghhh!','',26124),
(114807,'enUS','Not again!','',26124),
(114808,'enUS','Watch out!','',26124),
(114809,'enUS','Please help me!','',26124),
(114810,'enUS','Come on, don\'t stand in the Blizzard!','',26124),
(114811,'enUS','Guys we have come a long way... Argggh','',26124),
(114812,'enUS','Don\'t panic, we can do this... Aaahhhhh!','',26124),
(114813,'enUS','Grrrrargg... No! No! Not the eyes...','',26124),
(114814,'enUS','Guys, thanks. I am really proud of you. You all did a really great job.','',26124),
(114815,'enUS','What...? Dareer was a demon all along? How did we not see that coming?','',26124),
(114816,'enUS','','Well, that explains the chanting coming from his tent at all hours of the night. And the smell of sulphur.',26124),
(114817,'enUS','|TInterface\\Icons\\Spell_Shadow_Possession:20|t Legertha begins to cast |cFFFF0404|Hspell:57697|h[Horrific Visage]|h|r. Look away!','|TInterface\\Icons\\Spell_Shadow_Possession:20|t Legertha begins to cast |cFFFF0404|Hspell:57697|h[Horrific Visage]|h|r. Look away!',26124),
(114818,'enUS','Tirion! By all that is holy... what have they done to you?','',26124),
(114819,'enUS','I\'ll break Tirion free. You must find the Ashbringer while there\'s still time!','',26124),
(114820,'enUS','This place is filthy with corruption. I fear a long campaign awaits us.','',26124),
(114821,'enUS','Look out! Evasive maneuvers!','',26124),
(114822,'enUS','<grunts> Get out of here, $n! I\'ll find my--','',26124),
(114823,'enUS','<The houndmaster grunts at you and glares with feral eyes.>','',26124),
(114824,'enUS','My work here is not finished. Die, meddling $c!','',26124),
(114825,'enUS','We will sow havoc behind the lines. Nowhere is safe.','',26124),
(114826,'enUS','REUSE','',26124),
(114827,'enUS','This power... it burns so brightly.$b$bMy brothers are fools to ignore this gift. Once I have enough energy I could take back the city by myself!','',26124),
(114828,'enUS','Light... grant me one final blessing...','',26124),
(114829,'enUS','Moving into position above Niskara.','',26124),
(114830,'enUS','Moving into position above Niskara.','',26124),
(114831,'enUS','Everyone up top. Commence bombardment!','',26124),
(114832,'enUS','Everyone up top. Commence bombardment!','',26124),
(114833,'enUS','Do not lose faith...','',26124),
(114834,'enUS','This... is our final stand...','',26124),
(114835,'enUS','The hour of justice... has come...','',26124),
(114836,'enUS','We must... unite...','',26124),
(114837,'enUS','Together...','',26124),
(114838,'enUS','|TInterface\\Icons\\spell_fire_playingwithfiregreen:20|t %s gains |cFFFF0000|Hspell:208903|h[Burning Claws]|h|r!','',26124),
(114839,'enUS','You again?! Do you really think to beat me, with the Legion at my side?','',26124),
(114840,'enUS','Give up, fool! The Bonespeakers will never let an outsider be judged worthy!','',26124),
(114841,'enUS','We make our last stand at the Vault of Lights! If you can make your way here you will find sanctuary, although I cannot say for how long...','',26124),
(114842,'enUS','Did your visions foretell of this day, Prophet? Did you see our coming?','',26124),
(114843,'enUS','I bring you a message from Kil\'jaeden, to be served in the blood of your people! JUSTICE WILL BE MET!','',26124),
(114844,'enUS','A coward\'s death to these traitorous \"draenei!\" Mar their corpses so the living may see the fate that awaits them!','',26124),
(114845,'enUS','','I can get us access to the Violet Hold, where we\'ll be able to fight Hakkar without worry of any collateral damage.',26124),
(114847,'enUS','|TInterface\\Icons\\inv_jewelcrafting_immactaladite_purple:20|t Boulderfall begins to cast |cFFFF0404|Hspell:216970|h[Elemental Resonance]|h|r. Find cover!','|TInterface\\Icons\\inv_jewelcrafting_immactaladite_purple:20|t Boulderfall begins to cast |cFFFF0404|Hspell:216970|h[Elemental Resonance]|h|r. Find cover!',26124),
(114848,'enUS','You are out of your league, paladin.','',26124),
(114849,'enUS','You are here because I will it. You live because I will it. And you will serve because I will it!','',26124),
(114850,'enUS','','Our father\'s memorial is just around the corner. I am sure you will find Anarys nearby.',26124),
(114851,'enUS','Bats bats bats.$b$bBats bats. Bats.','',26124),
(114852,'enUS','Arghh - no. NO! My disguise. I am Legion. I will destroy you!','',26124),
(114853,'enUS','Heh he hah... BATS!','',26124),
(114855,'enUS','I am nathrezim. Your efforts mean nothing!','',26124),
(114856,'enUS','Do you think me so foolish as to stand alone?','',26124),
(114857,'enUS','Give up, before I lose my patience.','',26124),
(114858,'enUS','I can hear you up there! You demons better think twice before coming down here!','',26124),
(114859,'enUS','I\'ve got a wrench and a very angry leper gnome! You better keep out, demons!','',26124),
(114860,'enUS','You there! I see you! Come and get me when this is over! Until then, please go away. You\'ll bring them here!','',26124),
(114861,'enUS','','Try not to stare too long. For the upper echelons of our society, this place is hardly a distraction.',26124),
(114863,'enUS','','I\'ve procured a palanquin for you. Try to look imperious- it helps with the illusion.',26124),
(114864,'enUS','','The woman you are looking for is named Margaux. She has shown interest in our cause.',26124),
(114865,'enUS','Surely there\'s some way I can still be of some use.','',26124),
(114866,'enUS','Never caught a glimpse of what it was until it was too late.','',26124),
(114867,'enUS','','<Malefica watches the other druids intensely, until your presence disturbs her.>$b$bShhhh, $c. I am listening.$b$b<She turns her attention back to the nearby druids.>',26124),
(114868,'enUS','','Oh you terrible thing - I wasn\'t done here yet. Die!',26124),
(114869,'enUS','Cheer up. You\'ll be back on yer feet in no time.','',26124),
(114870,'enUS','Ye sure don\'t look like yerself, but... I\'m sure you\'ll be back ta normal in no time!','',26124),
(114871,'enUS','','My my, that was fun. We should do this again sometime.',26124),
(114872,'enUS','Take yer rest. Ye ought ta be better in no time.','',26124),
(114873,'enUS','Ohh! This taste! I must have more!','',26124),
(114874,'enUS','No! You no take! I kills the thief!','',26124),
(114875,'enUS','Noooooo! Mine...','',26124),
(114876,'enUS','I\'ll have ta come back when I\'m a tad stronger.','',26124),
(114877,'enUS','Still a tad bit weak. I\'ll return once I\'m sure I can fight by yer side.','',26124),
(114878,'enUS','Don\'t ask. Just be ready to fight.','',26124),
(114879,'enUS','These wounds? Hah! They\'ll make me a nice little story ta tell.','',26124),
(114880,'enUS','I walk the land. I watch. I listen.$b$bThat is probably why you haven\'t seen me here before. Nothing suspicious.','',26124),
(114881,'enUS','Leave me, $c! The Legion sees all! The Legion knows all!','',26124),
(114882,'enUS','You are pathetic. I will be back.','',26124),
(114883,'enUS','Ready yer weapons! Don\'t be caught off guard!','',26124),
(114884,'enUS','For the Alliance!','',26124),
(114885,'enUS','Time fer battle!','',26124),
(114886,'enUS','Sharpen yer blades! This ain\'t o\'er yet!','',26124),
(114887,'enUS','My blade\'s ready fer a little action!','',26124),
(114888,'enUS','Think they can come into our lands and cause a bit o\' trouble, eh? We\'ll see about that!','',26124),
(114889,'enUS','Wooo-hoo! This here wikket is makin\' good speed! But with my other riddles can this one succeed?','',26124),
(114890,'enUS','What smells like dook? Oh, it is this strong brew. Wikket watch out! Don\'t spill it on you!','',26124),
(114891,'enUS','I owe much to you, $n. I hope I am able to repay you in time.','',26124),
(114892,'enUS','Your deeds are quickly becoming the talk of the Hall, $n! I am proud to serve as your Champion.','',26124),
(114893,'enUS','With your guidance to lead us, I am sure we will prevail against the Burning Legion!','',26124),
(114894,'enUS','','The Hall of the Guardian\'s library rivals Silvermoon City\'s even in its current disarray. I will make sure that the Magisters support our efforts here.',26124),
(114895,'enUS','','This place contains a wealth of knowledge, $n! I have been reading a fascinating history of the Council of Tirisfal. Did you know that Meryl and Alodi actually created the Forge of the Guardians?',26124),
(114896,'enUS','','You heard \'em! Ready up!',26124),
(114897,'enUS','Not quite cut out fer this, I\'m afraid. Come back an\' see me when this is all over.','',26124),
(114898,'enUS','','You\'re quite brave, ya know. Think it best if I stay inside \'til it\'s a bit safer out here.',26124),
(114899,'enUS','You\'re right, $n. With a brave $c like you by my side we\'d be unstoppable!','',26124),
(114900,'enUS','Just me and you. Fightin\' off those demons!','',26124),
(114901,'enUS','Ah... who am I kidding? I\'m not a fighter. I better head inside. You be safe out here!','',26124),
(114902,'enUS','Aww... Me head! Thanks fer helpin\' me up. I\'ll be back when I can stand on me feet long enough ta help.','',26124),
(114903,'enUS','Oof! Need to fetch me a few weapons. Seem ta have lost mine... just can\'t remember where.','',26124),
(114904,'enUS','Where am I? Let me get my head on straight and I\'ll be back.','',26124),
(114905,'enUS','One of \'em nearly took me head off! I\'ll track \'em down. You keep on, $n.','',26124),
(114906,'enUS','Thank ya $glad:lass;.','',26124),
(114907,'enUS','$n! When you defeated Kathra\'natir, I felt a great weight leave my mind!','',26124),
(114908,'enUS','I have not been this well in an eternity. The Nightborne Soulstone has rendered Kathra\'natir completely powerless. You have my utmost gratitude.','',26124),
(114909,'enUS','','Don\'t just stand there waiting to be killed. Attack. Deploy the devastators!',26124),
(114910,'enUS','I think our luck is changing for the better, old friend. With our newest Archmage and the might of the Tirisgarde, we will defeat the burning legion!','',26124),
(114911,'enUS','','You are a shining example of the strength of the new Tirisgarde! To our newest Archmage, $n!',26124),
(114912,'enUS','Finally... the Nightborne Soulstone! All mine... I mean ours, of course!','',26124),
(114913,'enUS','Unfortunately we will be unable to keep that promise, Millhouse. So long as the Soulstone serves as Kathra\'natir\'s prison it is best left untouched. I\'m sure there are plenty of other powerful artifacts out there for you to find!','',26124),
(114916,'enUS','Arms at the ready! We\'ve got comp\'ny!','Arms at the ready! We\'ve got comp\'ny!',26124),
(114917,'enUS','','Best get goin\' \'fore I\'m put out fer good.',26124),
(114918,'enUS','The inhabitants of Kharanos have been inspired to join the fight against the Legion!','',26124),
(114919,'enUS','Ahh... have you come to learn more about the ancient art of wine making?','',26124),
(114920,'enUS','Another connoisseur? Perhaps you\'d like to help me prepare the unfortified wine?','',26124),
(114921,'enUS','There is nothing quite like the smell of fresh wine, ready for the barrel. Try making some for yourself, and you\'ll see!','',26124),
(114922,'enUS','Yes, I am ready to help make arcwine.','Yes, I am ready to help make arcwine.',26124),
(114923,'enUS','Let\'s begin then. I\'ll call out what you need to do, just follow my instructions.','',26124),
(114924,'enUS','Have any rare fishing goods?','Have any rare fishing goods?',26124),
(114925,'enUS','Blast! I\'m not your friend anymore.','',26124),
(114926,'enUS','','Someone looks thirsty!',26124),
(114927,'enUS','','Looks like you need a hand, Ilsa.',26124),
(114928,'enUS','Your Brewfest is a sham! One day, everyone will recognize that Dire Brew is the best!','',26124),
(114929,'enUS','Thank you for letting me be a guest in your hall. I wish we were meeting under better circumstances.','',26124),
(114930,'enUS','You have my thanks.','',26124),
(114931,'enUS','Please teleport me back to Dalaran.','Please teleport me back to Dalaran.',26124),
(114932,'enUS','This three year Infusion incorporates delightful berry elements with a scintillating melon bouquet. Refreshing, yes?','',26124),
(114933,'enUS','Ah, this is a fine vintage. Seventh generation manafruit entangled with slippery nightsap flavors and a delicate walnut finish.','',26124),
(114934,'enUS','This is a heavy blend of barely-ripe shadowberry and manafruit, triple infused with Nightwell essence. It is best appreciated in small sips.','',26124),
(114936,'enUS','Here comes a flower, Father!','',26124),
(114937,'enUS','Oh yes, it\'s a flower.','',26124),
(114938,'enUS','I have a drowned mana for you.','I have drowned mana for you.',26124),
(114939,'enUS','Get into the vat and jump on the fruit!','',26124),
(114940,'enUS','The batch needs something sour... something shady.','',26124),
(114941,'enUS','You need to add a bit of moisture or you\'ll back up the taps!','',26124),
(114942,'enUS','Toss in something floral for a bit of class.','',26124),
(114943,'enUS','','Let us be off. Follow me!',26124),
(114944,'enUS','','Talonclaw has been lost for so long that many tauren have never even laid eyes upon it. The elders still tell stories of how our greatest hunters wielded the spear in defense of our land.',26124),
(114945,'enUS','','These heroes slew terrible monsters and fought off countless invaders. Dorro Highmountain was last to wield it. His end came at the claws of a corrupted nightsaber that preyed upon our villages.',26124),
(114946,'enUS','It is sobering to think of how easily Kathra\'natir subverted my will. Thanks to $n\'s hard work, I am free and he is not.','',26124),
(114947,'enUS','','We called the beast Dakarr. A once noble creature, driven to madness by a deranged vrykul mystic. Dorro fought it off, then tracked the beast back to Stormheim. He never returned, and Talonclaw was never seen again.',26124),
(114948,'enUS','','It is my hope that one day our tribe may know peace.',26124),
(114949,'enUS','','The Unseen Path is always welcome here.',26124),
(114950,'enUS','That\'s it! A great batch, for an amateur. I\'ll have it bottled at once!','',26124),
(114951,'enUS','<Give Silkweave Bandages.>','<Give Silkweave Bandages.>',26124),
(114952,'enUS','<Give Highmountain Salmon.>','<Give Highmountain Salmon.>',26124),
(114953,'enUS','<Give Big Gamy Ribs.>','<Give Big Gamy Ribs.>',26124),
(114954,'enUS','They\'re everywhere...','They\'re everywhere...',26124),
(114955,'enUS','','Enjoying the vineyard?',26124),
(114956,'enUS','','Thank you, $n.',26124),
(114957,'enUS','As I feared. The arcan\'dor is in peril.','',26124),
(114959,'enUS','','I remember seeing something like this before. But where...',26124),
(114960,'enUS','','Ah! The vineyards!',26124),
(114961,'enUS','','We ride together.',26124),
(114962,'enUS','Your counsel is requested.','Your counsel is requested.',26124),
(114963,'enUS','','I think you\'ll enjoy the view, $p. Let\'s go!',26124),
(114964,'enUS','','May I help you?',26124),
(114965,'enUS','','Please feel free to look around.',26124),
(114966,'enUS','<Show your Sigil.>','<Show your Sigil.>',26124),
(114967,'enUS','I am so glad I was right to choose you for the Tirisgarde, Archmage $n!','',26124),
(114968,'enUS','Archmage $n! You have certainly earned the title, my friend.','',26124),
(114969,'enUS','You are the most dynamic Archmage I have encountered in centuries, $n. I am proud to call myself your champion.','',26124),
(114970,'enUS','','Very well, Highlord. I will give an accurate account of our army and our operations.',26124),
(114971,'enUS','','I had heard rumors... they seemed a little too good to be true.\n\nBear with me- we will need to tread carefully to avoid arousing suspicion. They are... not kind to us.',26124),
(114972,'enUS','','Margaux glances to each side, silently assessing the situation.',26124),
(114973,'enUS','','A tour? Of course! I will show you the grounds myself.',26124),
(114974,'enUS','I see your hunt was a success! I had no doubt it would be, of course.','',26124),
(114975,'enUS','','Every day I learn more about the Light and its purpose in this world. And yet, I am still so far from the truth.',26124),
(114976,'enUS','Your counsel is requested.','Your counsel is requested.',26124),
(114977,'enUS','','Of course, Highlord. I will speak my mind. The path of light is righteous and just. Whatever our means, let them remain virtuous.',26124),
(114978,'enUS','','The courtyard you just left is open to visitors. From here forward, one of my staff must accompany you.',26124),
(114979,'enUS','','You can purchase souvenirs and gifts from Sylverin, my assistant. Perhaps you could do that on your way out?',26124),
(114980,'enUS','','This is our tasting pavilion. We serve only the finest varietals here - many of them enjoyed in the palace!',26124),
(114981,'enUS','I have always felt drawn to the Light. Perhaps because this was my father\'s calling as well, and I wished to follow in his footsteps.','',26124),
(114982,'enUS','','Feel free to try the samples we have available today. We will continue the tour when you are finished.',26124),
(114983,'enUS','I heard rumors that we recovered a message from my father. Are my parents alive?','',26124),
(114984,'enUS','','The Order of the Silver Hand is reborn. Its new leaders will not let it fail.',26124),
(114985,'enUS','','Yes, a council of war is a good idea. The Legion\'s forces are spreading across the Broken Isles. We must not lose our foothold there!',26124),
(114986,'enUS','These demons\' souls will power the gateway. On your mark.','',26124),
(114987,'enUS','Long have I stood this vigil, $n. I am tired of watching and waiting. The time to strike is now, or we will lose everything.','',26124),
(114988,'enUS','Finally, Highlord, you will hear my words. We should focus our efforts on hunting down the dreadlord Balnazzar. It\'s time for retribution!','',26124),
(114989,'enUS','Your counsel is requested.','Your counsel is requested.',26124),
(114990,'enUS','We need to get the Nightborne Soulstone right away, $n! I bet I can make the biggest explosion you\'ve ever seen!','',26124),
(114991,'enUS','Your counsel is requested.','Your counsel is requested.',26124),
(114992,'enUS','This place is great! I just know it has information I can use to my advantage!','',26124),
(114993,'enUS','I\'m gonna torch a few demons once I get the Nightborne Soulstone!','',26124),
(114994,'enUS','Just thinking about all the damage we could cause with that Soulstone has got me all excited. Let me have it! Please!','',26124),
(114995,'enUS','I promise you won\'t regret it if you give me the Nightborne Soulstone... I\'ll use its power only for good. Really!','',26124),
(114996,'enUS','If you don\'t give me that Soulstone right now, I\'ll get angry. You really wouldn\'t like me when I\'m angry...','',26124),
(114997,'enUS','I can\'t believe you won\'t let me have the Nightborne Soulstone. It contains the power of the Burning Legion!','',26124),
(114998,'enUS','She is surviving, but not easily.','She is surviving, but not easily.',26124),
(114999,'enUS','Thalyssra said you had a unique way of dealing with insects. What is it?','Thalyssra said you had a unique way of dealing with insects. What is it?',26124),
(115000,'enUS','Hope is not lost. We are making progress every day.','Hope is not lost. We are making progress every day.',26124),
(115001,'enUS','','<Margaux glances around anxiously before leaning in close to whisper to you.>\n\nThalyssra must be alive, if others are moving in the shadows. Who else but the First Arcanist could inspire such action?\n\nTell me- how is she?',26124),
(115002,'enUS','','Insects? Do you have an insect problem?\n\n<Margaux eyes you curiously for a moment.>\n\nNo matter. The answer, you see, is in front of you. Mana wyrms prey on the insects that prey on our trees. They keep our precious plants whole and they eat very well.\n\nI will be sure to make time in our tour to allow you to gather some.',26124),
(115003,'enUS','','I am so relieved to hear that. Let us move on, though.',26124),
(115004,'enUS','After you, Margaux.','After you, Margaux.',26124),
(115005,'enUS','','Now... why exactly did you come here? This is certainly one of the least safe places for members of the resistance.',26124),
(115006,'enUS','Thank you! I am ready to move on now.','Thank you! I am ready to move on now.',26124),
(115007,'enUS','','They just - I hate them! We serve at their pleasure or we face exile and death. But I can do nothing while the Grand Magistrix seeks to keep this area secure.\n\nSurely you must have a vast network to have made your way here. Is the resistance growing? Can it truly stand against Elisande?',26124),
(115008,'enUS','I do not think it is safe to say, Margaux.','I do not think it is safe to say, Margaux.',26124),
(115009,'enUS','','<Margaux sighs.>\n\nThe odds are stacked against us. We are beaten and exiled at every turn. But you and the First Arcanist still stand with us. I can believe in this.\n\nI believe in the Dusk Lily.\n\nBut enough of this. Are you ready to finish our tour?',26124),
(115010,'enUS','','I see... shall we carry on, then?',26124),
(115011,'enUS','I am ready.','I am ready.',26124),
(115012,'enUS','','The night is dark and full of demons.',26124),
(115013,'enUS','Your counsel is requested.','Your counsel is requested.',26124),
(115014,'enUS','','The Legion is coming for everyone and everything... We must embrace the fires of Azeroth if we hope to see the dawn.',26124),
(115015,'enUS','You are quite accomplished for a mortal mage, $n.','',26124),
(115016,'enUS','I enjoyed our little excursion, $n. I would go into battle with you any time.','',26124),
(115017,'enUS','Our chances against the Burning Legion are grim at best. However there is still hope, especially with experienced mages such as yourself on our side!','',26124),
(115018,'enUS','Kathra\'natir was a voice in my head, calling from far away. I am so glad he has been silenced!','',26124),
(115019,'enUS','Now that Kathra\'natir is no longer a threat, we can safely search for powerful weapons to use against the Burning Legion.','',26124),
(115020,'enUS','I owe you a great debt, Archmage $n. I have not forgotten.','',26124),
(115021,'enUS','','The building we approach now is called the Aging Chamber.',26124),
(115022,'enUS','','We prefer to shorten the process using time magic. Such power is our birthright!',26124),
(115023,'enUS','','To my left you will see one of our orchards.',26124),
(115025,'enUS','','If you are at all familiar with the wine crafting process, you know that it is necessary to allow the juice to ferment.',26124),
(115026,'enUS','','This one houses a species of tree that produces extra sweet fruit, which you tasted in the Infusion.',26124),
(115027,'enUS','','The Kirin Tor supports the new Tirisgarde wholeheartedly, $n.',26124),
(115028,'enUS','','The buildings before you house our bottling facilities.',26124),
(115029,'enUS','','Each bottle is sealed with magic to prevent any of the Nightwell\'s essence from fading.',26124),
(115030,'enUS','','A cask of arcwine from our vineyard can be safely stored for hundreds of years!',26124),
(115031,'enUS','','Ahead you will see our distribution facility.',26124),
(115032,'enUS','','Here we arrange to send hundreds of barrels and casks of arcwine out to the city.',26124),
(115033,'enUS','','The Magistrix monitors these activities very-',26124),
(115034,'enUS','','Don\'t hurt him!',26124),
(115035,'enUS','','I am so sorry- please forgive this mistake. I will personally ensure it does not happen again.',26124),
(115036,'enUS','','Where were we?',26124),
(115037,'enUS','','I believe the Kirin Tor must accept help from all quarters if we are to defeat the Burning Legion.',26124),
(115038,'enUS','','Across this bridge is the most crucial part of our winemaking process.',26124),
(115039,'enUS','','It is here that we instill our wine with Nightwell essence, which gives it the restorative properties our people enjoy.',26124),
(115040,'enUS','','And this is where I leave you. I must prepare the next activity.',26124),
(115041,'enUS','','There is much to do if we are to defeat the Burning Legion. I will not allow them to destroy my city for a second time.',26124),
(115042,'enUS','','I will meet you at the next station. My assistant Sylverin will be happy to show you how the infusion process works.',26124),
(115043,'enUS','','Is it true that Turalyon is alive?',26124),
(115044,'enUS','Alive... we think. It appears his army suffered a great defeat at the hands of the Legion.','',26124),
(115045,'enUS','','By the Light... what does that mean for Azeroth?',26124),
(115046,'enUS','Arator. Son.','',26124),
(115047,'enUS','','Our beloved child.',26124),
(115048,'enUS','The vessel... it senses young Arator\'s presence!','',26124),
(115049,'enUS','If you can hear this, I have an important message.','',26124),
(115050,'enUS','For ages, I have hunted the Burning Legion across the stars.','',26124),
(115051,'enUS','We  hope you can forgive us for leaving, but we did it out of love for you. To ensure your safety and the survival of our world, we chose to make this sacrifice.','',26124),
(115052,'enUS','In retribution, the dreadlord Balnazzar has been sent to Azeroth to destroy all that I hold dear.','',26124),
(115053,'enUS','You must gather the defenders of the Light, Arator. Keep the Light alive. Fight, or ALL is lost.','',26124),
(115054,'enUS','','Azeroth is the last light of hope, Arator. Fight, or all is lost.',26124),
(115055,'enUS','If you bombard the demons below with the Fel Hammer\'s artillery, I\'ll get our forces ready.','',26124),
(115056,'enUS','If you bombard the demons below with the Fel Hammer\'s artillery, I will get our forces ready.','',26124),
(115057,'enUS','Just use the console here.','',26124),
(115058,'enUS','You can use the console here.','',26124),
(115059,'enUS','The Burnin\' Legion! Lads, lasses, git ta yer positions. If ye can\'t fight, take shelter!','',26124),
(115060,'enUS','Blades at the ready! We got incomin\'!','',26124),
(115061,'enUS','Their numbers be growin\'! We\'re gonna need more from every one o\' ya!','',26124),
(115062,'enUS','','Didn\'t think the Dark Iron\'d let the lot o\' ye have all the fun, did ye?',26124),
(115063,'enUS','We ain\'t got this far ta give up jus\' yet! Bring \'em down!','',26124),
(115064,'enUS','Looks like we\'re takin\' the fight to \'em!','',26124),
(115065,'enUS','Their leader be attackin\' Kharanos! C\'mere an\' show \'em what ye got!','',26124),
(115067,'enUS','More on the horizon! Spread out afore they reach the Gates!','',26124),
(115069,'enUS','Yer deeds ought be praised, champions! The Legion\'s been stopped! Ya did it!','',26124),
(115070,'enUS','|TINTERFACE\\ICONS\\spell_warlock_demonsoul:20|t Halldora begins to cast |cFFFF0404|Hspell:217283|h[Soul Harvest]|h|r Run away!','|TINTERFACE\\ICONS\\spell_warlock_demonsoul:20|t Halldora begins to cast |cFFFF0404|Hspell:217283|h[Soul Harvest]|h|r Run away!',26124),
(115071,'enUS','The furbolg of this weald are a peaceful tribe. They are in a panic right now, and are in need of our help.','',26124),
(115072,'enUS','Can you fly me to Tian Monastery? I need to speak to the Monkey King.','Can you fly me to Tian Monastery? I need to speak to the Monkey King.',26124),
(115073,'enUS','Excellent! Now, what next...','',26124),
(115074,'enUS','You\'re a natural! What does the recipe call for next...','',26124),
(115075,'enUS','Yes, just like that! Hmm... what does this batch need now?','',26124),
(115076,'enUS','','Ready when you are, dear.',26124),
(115077,'enUS','Wikket come to ask a thing? What does you want from Monkey King?','',26124),
(115078,'enUS','This sentry stands resolute.','',26124),
(115079,'enUS','','You students have been warned countless times. I will have to make an example of you!',26124),
(115080,'enUS','Welcome to my \"dream\" home! Your beloved Malfurion awaits within.','',26124),
(115081,'enUS','Guess again, mortal!','',26124),
(115082,'enUS','','I have no time for games!',26124),
(115083,'enUS','I need you to lead me to the Tidestone of Golganneth.','I need you to lead me to the Tidestone of Golganneth.',26124),
(115084,'enUS','One of the instructors mentioned that, yes...','One of the instructors mentioned that, yes...',26124),
(115085,'enUS','','I cannot tell where his voice is coming from! Quickly, search the buildings to the east. I will scour the west for signs of him!',26124),
(115086,'enUS','I was not aware of that.','I was not aware of that.',26124),
(115087,'enUS','Prepare the start up sequence.','Prepare the start up sequence.',26124),
(115088,'enUS','','I cannot tell where his voice is coming from! Search the buildings to the east! I will scour the west for signs of him!',26124),
(115089,'enUS','Shut down the start up sequence.','Shut down the start up sequence.',26124),
(115090,'enUS','Hurry! I cannot fight much longer...','',26124),
(115091,'enUS','Where are you Tyrande? I need you!','',26124),
(115092,'enUS','You cannot keep me from her! Tyrande?!','',26124),
(115094,'enUS','','Where are you Malfurion? Answer me!',26124),
(115095,'enUS','My love! I am here! Come to me!','',26124),
(115096,'enUS','','There we are! Lovely work as always, $p.',26124),
(115097,'enUS','','Elune curse you, Xavius! You will pay for this charade, I swear it!',26124),
(115098,'enUS','','You insolent... little...',26124),
(115099,'enUS','Initiating self-destruct procedure.','',26124),
(115100,'enUS','','Hold on, my love! I am near!',26124),
(115101,'enUS','','Yes! I hear you! I am close now!',26124),
(115102,'enUS','You attempt to interact with the sentry; but to no avail.','You attempt to interact with the sentry; but to no avail.',26124),
(115107,'enUS','','To me, champion. Our chase is done.',26124),
(115108,'enUS','','Come to me, Warrior of the Horde. Our chase is finished.',26124),
(115109,'enUS','But what\'s this? Which Malfurion is real, and which is part of the Nightmare...? [Laugh]','',26124),
(115111,'enUS','You there! Back to work!','You there! Back to work!',26124),
(115112,'enUS','I was just resting. I-','',26124),
(115113,'enUS','I will hear none of your excuses. Back to work!','I will hear none of your excuses. Back to work!',26124),
(115114,'enUS','Agh!','',26124),
(115115,'enUS','The Overseer will hear of this. Mark my words, Margaux.','The Overseer will hear of this. Mark my words, Margaux.',26124),
(115116,'enUS','Farewell, son. Do not lose faith, for it is in the darkest moments that the light shines brightest.','',26124),
(115117,'enUS','You heard my father. We must act!','',26124),
(115118,'enUS','Agreed, Arator. Brothers and sisters, the time to stand united is now. We must follow the Highlord\'s leadership more than ever.','',26124),
(115119,'enUS','What will it be, Highlord? What should we do next?','',26124),
(115120,'enUS','No, this simply won\'t do. We\'ll have to start over from scratch.','',26124),
(115121,'enUS','Perhaps you had a glass or three before coming here? We\'ll have to throw out this batch...','',26124),
(115122,'enUS','No, that won\'t do at all. Start over, and this time, please pay attention!','',26124),
(115123,'enUS','%s bellows a grateful roar.','',26124),
(115124,'enUS','The Legion\'s returned! Send word ta Ironforge an\' get ta yer posts!','',26124),
(115125,'enUS','We got compn\'y! Legion ship spotted o\'er head! Ready up!','',26124),
(115126,'enUS','Hunt the dreadlord, Balnazzar.','Hunt the dreadlord, Balnazzar.',26124),
(115127,'enUS','Seek allies under the Light.','Seek allies under the Light.',26124),
(115128,'enUS','Defend against the demon invasions.','Defend against the demon invasions.',26124),
(115129,'enUS','Git ready! \'Ere they come!','',26124),
(115130,'enUS','Procure supplies for the army.','Procure supplies for the army.',26124),
(115131,'enUS','Stand strong! Show them demons they\'ll ne\'er take Ironforge!','',26124),
(115132,'enUS','Hold strong, brothers an\' sisters! We make our stand fer Azeroth!','',26124),
(115133,'enUS','','By the might o\' the Dark Iron! Fer Ironforge!',26124),
(115134,'enUS','No matter how tired ye be, how wounded... show \'em no weakness! We fight together!','',26124),
(115135,'enUS','','The Legion\'ll ne\'er prevail if the Dark Iron have a say \'bout it!',26124),
(115136,'enUS','Excellent thinking, Highlord. We should attack the problem at its source - their leader, Balnazzar.','',26124),
(115137,'enUS','Good idea, Highlord. With additional allies of the Light, our strength will be magnified.','',26124),
(115138,'enUS','I agree, Highlord. The demon incursions will only grow worse if left unchecked. A strong defense is necessary.','',26124),
(115139,'enUS','','The Imps are hungry...',26124),
(115140,'enUS','Pardon me... do you have a death wish?','',26124),
(115141,'enUS','I strongly advise against that!','',26124),
(115142,'enUS','Don\'t be daft- move away from there!','',26124),
(115143,'enUS','Pragmatic as always, Highlord. There are dozens of logistics to consider. Supplies, communications, weapons, armor... We should get started.','',26124),
(115144,'enUS','What inspired such idiocy? Nightwell energy is intensely volatile in this state!','',26124),
(115145,'enUS','Get away from there!','',26124),
(115146,'enUS','By the might o\' Ironforge, rise up! Bring them foul demons a swift death!','',26124),
(115147,'enUS','I would like to requisition some Imps.','I would like to requisition some Imps.',26124),
(115148,'enUS','Show them demons no mercy!','',26124),
(115149,'enUS','Mount up! We gotta stop their advance!','',26124),
(115150,'enUS','Spread out! This fight\'s jus\' gettin\' started!','',26124),
(115151,'enUS','Their numbers keep growin\'! We\'ll watch the skies o\'er head. Clear \'em out down below!','',26124),
(115152,'enUS','Captain Tevaris emerges from the shadows.','',26124),
(115153,'enUS','More Legion camps spotted! Bring \'em down, an\' be quick about it!','',26124),
(115154,'enUS','Captain Tevaris fades into the shadows.','',26124),
(115155,'enUS','Get ta Kharanos! We gotta stop their leader! Fer the glory o\' Ironforge!','',26124),
(115156,'enUS','Spit out yer blood, bind yer wounds, an\' git yer arses ta Kharanos! We got one last fight in us!','',26124),
(115157,'enUS','Well done, champions! Ironforge won\'t soon be fergettin\' yer efforts \'ere on the battlefield!','',26124),
(115158,'enUS','Great work, all o\' ya! I fear this willna be the last we see o\' the Burnin\' Legion, but when they come back... we\'ll be ready!','',26124),
(115159,'enUS','Oh, this is not good! Legion ship overhead! If you owe back taxes, now\'s the time to pay up!','',26124),
(115160,'enUS','Legion ship to the east! Lock up shop! Hide your breakables! Things are about to get interesting.','',26124),
(115161,'enUS','Everybody get ready! We have incoming... and they sound testy!','',26124),
(115162,'enUS','This is not a drill! Here they come! First priority: PROTECT MY STUFF!','',26124),
(115163,'enUS','Oh look! They\'ve gotten a bit larger... but way more angry!','',26124),
(115164,'enUS','Something must be getting under their skin! They\'re much bigger and meaner!','',26124),
(115165,'enUS','Aim for their shins, or knees, or... or whatever you can reach! Just take \'em out already!','',26124),
(115166,'enUS','Looks like those two are joining the party! Get the hats and sparklers ready!','',26124),
(115167,'enUS','Pack up your things! We\'re bringing the fight to them.','',26124),
(115168,'enUS','Everybody get out there! It\'s time to kick these things to the curb... if Gadgetzan had curbs!','',26124),
(115169,'enUS','This is getting outta hand! They\'re on the move again! What gives?','',26124),
(115170,'enUS','Watch yourselves! They\'re popping up everywhere... like broke relatives!','',26124),
(115171,'enUS','We make our stand at Gadgetzan! Time to stick it to their boss! Dibs on everything in his pockets!','',26124),
(115172,'enUS','It\'s big, it\'s ugly, it\'s... uh... Just get your behinds to Gadgetzan and kill it already!','',26124),
(115173,'enUS','The Black Harvest is ready to serve.','The Black Harvest is ready to serve.',26124),
(115174,'enUS','It\'s not every day you get to save the... day! I\'m gonna work on that.','',26124),
(115175,'enUS','Well done, my friends! Minimally discounted Noggenfoggers all around!','',26124),
(115176,'enUS','The sky burns, allies! The Legion comes at us again!','',26124),
(115177,'enUS','Prepare for battle! We won\'t allow the Legion to destroy what we\'ve built here!','',26124),
(115178,'enUS','Ready your blades, allies! The battle begins!','',26124),
(115179,'enUS','Steel at the ready! We have incoming!','',26124),
(115180,'enUS','','AAAAAAAAAAHHHHHHH!',26124),
(115181,'enUS','We hold the Hill for Stormwind! For all of Azeroth!','',26124),
(115182,'enUS','Do not give ground! Do not yield! Fight on!','',26124),
(115183,'enUS','The doomguards make their descent! Ready at the Hill!','',26124),
(115184,'enUS','','See you soon, handsome.',26124),
(115185,'enUS','Allies of all flags and kingdoms! The time to fight for OUR lands is NOW!','',26124),
(115186,'enUS','','See you soon, gorgeous.',26124),
(115187,'enUS','Arise spirits, and serve The Legion.','',26124),
(115188,'enUS','Even in death, these spirits serve.','',26124),
(115189,'enUS','Thanks to your efforts, the Burning Legion has failed yet again! The Westfall Brigade is in your debt!','',26124),
(115190,'enUS','I am not in control!','',26124),
(115191,'enUS','They may scorch our lands... they may slay our kin... but we will NEVER surrender! For Azeroth!','',26124),
(115192,'enUS','I... must... OBEY!','',26124),
(115193,'enUS','Save us!','',26124),
(115194,'enUS','Make haste! Spread throughout the lands! Purge this infestation!','',26124),
(115195,'enUS','Take back what is ours! Show these demons their way back to the Nether!','',26124),
(115196,'enUS','Their forces have spread! We must not let them reach Stormwind!','',26124),
(115197,'enUS','The Legion\'s determination grows! End this vile corruption at once!','',26124),
(115198,'enUS','Quickly, heroes! Defend the Hill! Slay the demons\' master!','',26124),
(115199,'enUS','To Sentinel Hill at once! Together we cast this demon back into the Twisting Nether!','',26124),
(115200,'enUS','','Illidari! The gateway is open. To the Fel Hammer!',26124),
(115201,'enUS','Caria, Varedis, we\'re coming for you!','',26124),
(115202,'enUS','Caria, Varedis, we\'re coming for you!','',26124),
(115203,'enUS','Illidari Redoubt is the perfect vantage point, and it\'s free from the rabble up above.','',26124),
(115204,'enUS','The time is upon us. The invasion of Niskara represents the fulfillment of all of our sacrifice and planning.\n\nLead us to victory, $n.','',26124),
(115205,'enUS','Give the order, Altruis. Let\'s get down there.','Give the order, Altruis. Let\'s get down there.',26124),
(115206,'enUS','The time is upon us. The invasion of Niskara represents the fulfillment of Illidan\'s dream and all of our sacrifices.\n\nLead us to victory, $n.','',26124),
(115207,'enUS','Give the order, Kayn. Let\'s get down there.','Give the order, Kayn. Let\'s get down there.',26124),
(115208,'enUS','','Your souls are forfeit!',26124),
(115209,'enUS','Illidari, hear me. The time has come. All of our struggles... all of our sacrifices have led to this moment.','',26124),
(115210,'enUS','You a lucky $gguy:lady;. You can break your chain and walk right out the door.$b$bGolk can break his chains very easy, but can Golk fit out the door?  Nope.','',26124),
(115211,'enUS','Illidari, hear me. The time has come. All of our struggles... all of our sacrifices have led to this moment.','',26124),
(115212,'enUS','Akama, you and the others will remain behind to protect the Fel Hammer.','',26124),
(115213,'enUS','Shade, you and the others will remain behind to protect the Fel Hammer.','',26124),
(115214,'enUS','You five, come with me and $n. Niskara awaits!','',26124),
(115215,'enUS','You five, come with me and $n. Niskara awaits!','',26124),
(115216,'enUS','Yes, fools. Come down. Jump to your deaths.','',26124),
(115217,'enUS','You destroyed all of the demons here, but many more await us ahead. We\'re going to have to wade through their lieutenants if we want to get to Caria and Varedis.\n\nGive the word and we will begin.','',26124),
(115218,'enUS','The word is given. Move out.','The word is given. Move out.',26124),
(115219,'enUS','You destroyed all of the demons here, but many more await us ahead. We will have to fight through their lieutenants to get to Caria and Varedis.\n\nJust give the word and we will begin our assault.','',26124),
(115220,'enUS','The word is given. Move out.','The word is given. Move out.',26124),
(115223,'enUS','What do you want? 10,000 years working here and I get no respect. Filrich do this, Filrich do that. What can Filrich do for you?','',26124),
(115224,'enUS','You seem unhappy.','You seem unhappy.',26124),
(115225,'enUS','Why would I be unhappy? Students are always in the halls, they never go to sleep, they always want more provisions, the place is a mess. There is water everywhere! And do they hire someone else to help, no! Filrich will take care of it they say. I drew the line at cleaning up those infernal books.\n\nNow what was it \'you\' needed again?','',26124),
(115226,'enUS','Oh, actually I am fine.','Oh, actually I am fine.',26124),
(115227,'enUS','','Hm... the ingredients have soured. We will have to start again I am afraid.',26124),
(115228,'enUS','','Are you certain you are ready to participate? This batch will have to be destroyed.',26124),
(115229,'enUS','','I feel as though you are losing focus. Is something else on your mind? Step back for a moment and we will try again.',26124),
(115230,'enUS','','Excellent! You did very well- are you certain you have never made wine before? I will have this bottled immediately.',26124),
(115231,'enUS','','Take your place near the table. Once we begin, it is important that we keep up the pace. These delicate ingredients spoil quickly.',26124),
(115233,'enUS','','We are preparing to make the unfortified wine. Are you ready to assist?',26124),
(115234,'enUS','','This is my favorite part! The smells, the textures, the invigorating rush! I think you will appreciate why I have remained in the vineyards after you have made Arcwine yourself.',26124),
(115236,'enUS','','Well done. Now let me see...',26124),
(115237,'enUS','','You, my friend, are a natural. The blend needs something more, though. Let me think...',26124),
(115238,'enUS','','Exactly what it needed. But there is still something missing...',26124),
(115239,'enUS','','Ah! It needs something floral, to add a little brightness.',26124),
(115240,'enUS','','Let us add a little moisture. Just enough to keep the taps flowing.',26124),
(115241,'enUS','','I think a sour note is in order. Add a shadefruit, please.',26124),
(115242,'enUS','','The juices need a little massaging- step into the vat and jump to squish the mixture around!',26124),
(115243,'enUS','','No talking in class!',26124),
(115244,'enUS','Begin the energy transfer sequence.','Begin the energy transfer sequence.',26124),
(115245,'enUS','','Hey Practicus, do you ever worry other hunters won\'t appreciate our tamed mechs?',26124),
(115246,'enUS','It\'s all in the branding! That\'s why I call \'em Programmable Electronic Tactical Sidekicks... P.E.T.S.!','',26124),
(115248,'enUS','I... I\'m alive! Thank you, priestess!','',26124),
(115249,'enUS','Whatever happened to this place? It put sad look on wikket\'s face.','',26124),
(115250,'enUS','Rise up, High Inquisitor! Your Deathlord calls you back to this world!','',26124),
(115251,'enUS','We have not come to offer peace, High Inquisitor.','',26124),
(115252,'enUS','The Day of Reckoning is at hand. The Burning Legion has come to destroy our world.','',26124),
(115253,'enUS','The Knights of the Ebon Blade have come to offer you a chance at atonement.','',26124),
(115254,'enUS','Join us, and we will find out together.','',26124),
(115255,'enUS','','I... I live? Is the anguish of death over?',26124),
(115256,'enUS','','Why then? Why have you done this to me?',26124),
(115257,'enUS','','Atonement? I doubt that such a thing exists for me...',26124),
(115258,'enUS','','Indeed we shall.',26124),
(115260,'enUS','Do not show yourself! You cannot help her now. No one can.','',26124),
(115261,'enUS','Get out of here, if you know what\'s good for you.','',26124),
(115262,'enUS','Silence!','',26124),
(115263,'enUS','','I did what I thought was-',26124),
(115264,'enUS','I will hear no more. The sentence is death. Proceed.','',26124),
(115265,'enUS','I\'d wager Ulduar is quieter than the last time you were here, Brann.','',26124),
(115266,'enUS','The keepers have ordered repairs to Ulduar\'s infrastructure. Mortal heroes are proficient in battle, but tend to leave a mess. No offense intended.','',26124),
(115268,'enUS','That\'s a fair point. It took weeks to clean up the banquet hall after--','',26124),
(115269,'enUS','Hold it... ye sense anythin\' odd, Khadgar? Gettin\' a familiar feelin\'... an\' I don\'t like it!','',26124),
(115270,'enUS','There be one more test \'fore I tell you my tale. Meet at Jade Serpent\'s temple \'fore the mixin\'s go stale!','',26124),
(115271,'enUS','Fragile mortals. Bow before the might of the Burning Legion!','',26124),
(115272,'enUS','You cannot escape! Our reach is endless!','',26124),
(115273,'enUS','Your world crumbles around you, mortals. We cannot be stopped!','',26124),
(115274,'enUS','Your world trembles in our wake!','',26124),
(115275,'enUS','The end of your world has begun!','',26124),
(115276,'enUS','Weak flesh and brittle bones... You are no match for the Legion!','',26124),
(115277,'enUS','You... will... DIE!','',26124),
(115278,'enUS','Feel your hearts wrench as the grasp of Sargeras tightens around your world!','',26124),
(115279,'enUS','','A list of traitors? You will have to get this to Lieutenant Piet at once.',26124),
(115280,'enUS','As you wish. I will meet the Lieutenant where we met last. Send word for her to expect me.','As you wish. I will meet the Lieutenant where we met last. Send word for her to expect me.',26124),
(115281,'enUS','','I hear you\'ve got names of rebel filth? Quickly, let\'s have them.',26124),
(115282,'enUS','','You fool, you were followed! To arms!',26124),
(115283,'enUS','Ooka, what do you have for sale?','Ooka, what do you have for sale?',26124),
(115284,'enUS','Keep an eye out for rebels. You can\'t be too careful.','Keep an eye out for rebels. You can\'t be too careful.',26124),
(115285,'enUS','If you see someone stealing arcwine, report them at once!','If you see someone stealing arcwine, report them at once!',26124),
(115286,'enUS','Seize her!','',26124),
(115288,'enUS','I have detected a large number of teleportation spells targeting your location.','',26124),
(115289,'enUS','I have enabled a teleporter for you. You haven\'t a lot of time- locate the pad and get out of there.','',26124),
(115290,'enUS','Oh no...','',26124),
(115291,'enUS','Please... even a few drops of arcwine might spare my mind from madness...','Please... even a few drops of arcwine might spare my mind from madness...',26124),
(115292,'enUS','You look strong... clearly you have arcwine to spare!','You look strong... clearly you have arcwine to spare!',26124),
(115293,'enUS','I feel my mind... slipping... need arcwine...','I feel my mind... slipping... need arcwine...',26124),
(115294,'enUS','I\'ve brought you some arcwine... drink up!','I\'ve brought you some arcwine... drink up!',26124),
(115295,'enUS','So generous! Thank you, I owe you my life!','So generous! Thank you, I owe you my life!',26124),
(115296,'enUS','Such potency... I am saved! Thank you!','Such potency... I am saved! Thank you!',26124),
(115297,'enUS','Aye, another mission where we might not be makin\' it back.\n\nBrought me private stash this time, though. Ye want a sip?','',26124),
(115298,'enUS','Sure, I\'ll take a sip.','Sure, I\'ll take a sip.',26124),
(115299,'enUS','No, thank you.','No, thank you.',26124),
(115300,'enUS','The liquid smells very strong. Really take a drink?','The liquid smells very strong. Really take a drink?',26124),
(115301,'enUS','','Worthless! Prepare the defenses. I will take great pleasure in killing you, $n.',26124),
(115302,'enUS','Help, masters! Demons are ransacking the temple!','',26124),
(115303,'enUS','Offer: 800x |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t|Hcurrency:1155|h|cFFFFFFFF Ancient Mana|h|r','Offer: 800x |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t|Hcurrency:1155|h|cFFFFFFFF Ancient Mana|h|r',26124),
(115304,'enUS','This action will remove 800 Ancient Mana. Do you wish to continue anyway?','This action will remove 800 Ancient Mana. Do you wish to continue anyway?',26124),
(115305,'enUS','Vengeance? You can do better than that. Much better. In fact...','',26124),
(115306,'enUS','Cute. Do you want to get us both killed? No? Didn\'t think so.','',26124),
(115307,'enUS','Now that... that is more like it. It so happens that I am the perfect living soul for this job.','',26124),
(115308,'enUS','The Jade Serpent fights the invaders inside while we hold the gate for survivors to escape. Several scribes are missing, and I fear the worst. Please, help us!','',26124),
(115309,'enUS','Yu\'lon\'s strong as a mountain and quick as a bee, but even a mountain\'s worn down by the sea.','',26124),
(115310,'enUS','These walls right here look easy to climb! Jade Serpent\'s the one the King go to find.','',26124),
(115311,'enUS','$n, we\'re counting on you to rescue our scribes!','',26124),
(115312,'enUS','Such delicious knowledge!','',26124),
(115313,'enUS','Glad to see you made it.','',26124),
(115314,'enUS','Glad to see you made it.','',26124),
(115315,'enUS','Illidari, you have your targets. Attack!','',26124),
(115316,'enUS','Illidari, you all have your targets. Attack!','',26124),
(115317,'enUS','Agreed! We need to get in there before they decide to escape.','Agreed! We need to get in there before they decide to escape.',26124),
(115318,'enUS','Agreed! We need to get in there before they decide to escape.','Agreed! We need to get in there before they decide to escape.',26124),
(115319,'enUS','Know this, demon hunters, if you proceed, I will allow Varedis and Caria to destroy you.','',26124),
(115320,'enUS','There will be no forgiveness... no second chance to join me.','',26124),
(115321,'enUS','Caria and Varedis are hiding in this command center. We\'re going to need assistance for this one.\n\nMight I suggest ordering Akama to move the Fel Hammer into position and fire upon that fel barrier?','',26124),
(115322,'enUS','Caria and Varedis are hiding in this command center. We are going to need assistance for this one.\n\nMight I suggest ordering Akama to move the Fel Hammer into position and fire upon that fel barrier?','',26124),
(115323,'enUS','Another mind to feed upon!','',26124),
(115324,'enUS','Who\'s there? Jarvox, I sense intruders!','',26124),
(115325,'enUS','Jarvox, stay alert! Protect the Codex of command with your life!','',26124),
(115326,'enUS','Speak infiltrator. You do not belong here. Jarvox! Take care of this.','',26124),
(115327,'enUS','Do not fear, my lord. My demons will hunt down the intruders!','',26124),
(115328,'enUS','Foolish paladins... I have captured one of your own! Too bad Lord Balnazzar will not be here to see his demise!','',26124),
(115329,'enUS','I will never give in to you, demon!','',26124),
(115330,'enUS','The scourge has risen against us! Send the invaders back to their graves!','',26124),
(115331,'enUS','Should you fall, know that your sacrifice will bring me great glory this day!','',26124),
(115332,'enUS','You defile the sanctity of this chapel with your presence! The Holy Light shall burn you!','',26124),
(115333,'enUS','By the power of the Light I will banish you, scourge!','',26124),
(115334,'enUS','My faith... has forsaken me?','',26124),
(115335,'enUS','','Wait. We don\'t know the strength of our enemy. Who knows what you\'re rushing into?',26124),
(115336,'enUS','Are there none among the Scarlet Crusade with the strength to challenge me?!','',26124),
(115337,'enUS','The great lord Balnazzar\'s plan will not be disrupted!','The great lord Balnazzar\'s plan will not be disrupted!',26124),
(115338,'enUS','We have our orders to destroy any intruders!','We have our orders to destroy any intruders!',26124),
(115339,'enUS','The Order of the Silver Hand? Sounds like a juicy target to me.','The Order of the Silver Hand? Sounds like a juicy target to me.',26124),
(115342,'enUS','A tasty paladin. You meet your end!','A tasty paladin. You meet your end!',26124),
(115343,'enUS','Those who terrorize the innocent have no place in this world or the next.','',26124),
(115344,'enUS','The Realm of Shadow offers little respite to the souls of the wicked.','',26124),
(115345,'enUS','Get movin\', wikket. Let the trial begin! Makin\' sweet hozen slerp is the way you can win!','',26124),
(115346,'enUS','The pot\'s gettin\' hotter. Add a wee splash o\' water.','',26124),
(115347,'enUS','That brew, it smells a little plain. Wikket, add a pinch more grain.','',26124),
(115348,'enUS','Time for the wikket to add the next mixin\'. Toss in a banana, that be the right fixin\'!','',26124),
(115349,'enUS','No, no, no! Don\'t be spooked, or that brew\'ll be grooked!','',26124),
(115350,'enUS','No, no, and no! That not how it go! It\'s like wikkit be tryin\' to lose this here show!','',26124),
(115351,'enUS','Too bad that the wikket got it all wrong! This dook of a brew make me sing a sad song!','',26124),
(115352,'enUS','Good goin\', wikket! You know how to pick it!','',26124),
(115353,'enUS','Yup, yup, that\'s the way! Hup, hup, save the day!','',26124),
(115354,'enUS','Lookin\' good, you! Smellin\' good, too!','',26124),
(115355,'enUS','A-yup! That\'s the ticket! Keep it up, clever wikket!','',26124),
(115356,'enUS','Flames too high, you horked the pot! Start over now! Don\'t get it too hot!','',26124),
(115357,'enUS','Wikket be snoozin\'? No or yes? You able to start the brew over, I guess.','',26124),
(115358,'enUS','Brew cooked too long, wikket florked up the batch. Nothin\' to do but restart it from scratch!','',26124),
(115359,'enUS','This hozen brew be just the thing! Its taste be fit for the Monkey King!','',26124),
(115360,'enUS','Put the pot on the fire\'s heart, then the wikket\'s trial can start!','',26124),
(115361,'enUS','','You should not be here, little ones. The Burning Legion\'s attacks are relentless. Even I have suffered many wounds.',26124),
(115362,'enUS','','Prepare yourself, our foes are approaching!',26124),
(115363,'enUS','Time to get slerpin\' and grookin\', King say. Get busy! It best if we start right away.','',26124),
(115364,'enUS','Let\'s go to the Temple.','Let\'s go to the Temple.',26124),
(115365,'enUS','','Fu Zan has has chosen a new companion. Great deeds and great trials await you, little one. For now, you should return home to rest and prepare for what is to come.',26124),
(115366,'enUS','It would be an honor.','It would be an honor.',26124),
(115367,'enUS','','Fare well, little one.',26124),
(115370,'enUS','','It\'s good to see you back again. Vanthir procured more Arcwine for you to distribute.',26124),
(115371,'enUS','You\'re lucky I found you when I did. You almost died out there.','',26124),
(115375,'enUS','Take their stuff!','',26124),
(115376,'enUS','Trap their cubs!','',26124),
(115377,'enUS','Bonk them to the ground!','',26124),
(115378,'enUS','Smash their smashies!','',26124),
(115379,'enUS','Scratch their feets!','',26124),
(115380,'enUS','Bite their knees!','',26124),
(115381,'enUS','Pull their furs!','',26124),
(115382,'enUS','Fur their bolgs!','',26124),
(115383,'enUS','You are too hungry to continue.','You are too hungry to continue.',26124),
(115384,'enUS','I have some idea of where to start.','',26124),
(115385,'enUS','Oy! Didn\'t think they\'d be on me so fast! Be careful out here!','Oy! Didn\'t think they\'d be on me so fast! Be careful out here!',26124),
(115386,'enUS','Ne\'er thought I\'d be rescued!','Ne\'er thought I\'d be rescued!',26124),
(115387,'enUS','Git to the roads, quickly! Best not ta be wanderin\' about all alone out here!','Git to the roads, quickly! Best not ta be wanderin\' about all alone out here!',26124),
(115388,'enUS','Thanks fer the help. Best git goin\'. Wouldn\'t want ta be caught out here with all this goin\' on!','Thanks fer the help. Best git goin\'. Wouldn\'t want ta be caught out here with all this goin\' on!',26124),
(115389,'enUS','I appreciate the concern, $n, but I got ta keep at it. Who knows how far they\'ve spread!','I appreciate the concern, $n, but I got ta keep at it. Who knows how far they\'ve spread!',26124),
(115390,'enUS','Thanks, $n. Best stay alert out \'ere!','Thanks, $n. Best stay alert out \'ere!',26124),
(115391,'enUS','Chin up, $glad:lass;. I\'d be a lot worse if it hadn\'t been fer ya.','Chin up, $glad:lass;. I\'d be a lot worse if it hadn\'t been fer ya.',26124),
(115392,'enUS','The flavor\'s improvin\', but it need strong scent, too. Open the keg and add Smelly Brew!','',26124),
(115393,'enUS','','Time is of the essence. We must get moving!',26124),
(115394,'enUS','','Every moment we sit idle, the Legion gains strength.',26124),
(115395,'enUS','','In Lord Illidan\'s absence, you are the ranking member of our order. We can\'t make this decision without you.',26124),
(115396,'enUS','','Let me know when you\'re ready.',26124),
(115397,'enUS','','I only hope it\'s enough. Too many people around the city are on the brink...',26124),
(115398,'enUS','','It\'s getting harder to find Arcwine going spare... but what we get, we share with the poorest among us.',26124),
(115399,'enUS','I will take your Arcwine and share it with the needy.','I will take your Arcwine and share it with the needy.',26124),
(115400,'enUS','','This place harbors many secrets, but it rarely shares them.',26124),
(115401,'enUS','','The outside world is too big and loud. I have everything I need right here.',26124),
(115402,'enUS','','The Hall has become terribly noisy since the new Tirisgarde arrived. I much preferred to listen to the mice singing amongst the shadows.',26124),
(115403,'enUS','','Thank you, little ones. I can heal my injuries, but I need time for my magic to take hold. Our cunning foes will use this opportunity to strike.',26124),
(115404,'enUS','','Protect me while I recover. Should we fall, all of Pandaria will follow.',26124),
(115405,'enUS','You are too far away! Move back in range before she gets away!','You are too far away! Move back in range before she gets away!',26124),
(115406,'enUS','Keep it down, brats. You will join the others soon.','Keep it down, brats. You will join the others soon.',26124),
(115407,'enUS','','As a token of my gratitude, allow me to see you home.',26124),
(115408,'enUS','','Da elements be tricky wit their secrets, but I watch and I lissen. If ya know how ta speak ta dem, der secrets can be yours, too.',26124),
(115409,'enUS','Show me my Class Advancement options.','Show me my Class Advancement options.',26124),
(115410,'enUS','','The Maelstrom pillar\'s power was exhausted during our defense of the Heart of Azeroth. The pillar will recharge slowly, but this process could take decades and we have no such luxury. We need to find a way to accelerate its regeneration.',26124),
(115411,'enUS','','Excellent! Lord Neptulon\'s gift has already done wonders. The stone appears to be channeling my powers of water again.',26124),
(115412,'enUS','','We continue to make progress, Farseer. The maelstrom pillar is revitalized with the power of air. With any luck, we will be able to restore its full potential soon.',26124),
(115413,'enUS','','Your help has been instrumental to my progress here, Farseer. The stone is nearly complete. With the powers of water, air, and earth restored, the remaining element needed is fire.',26124),
(115414,'enUS','','I couldn\'t be more pleased, Farseer. It has taken quite a lot of work to restore the maelstrom pillar to its maximum capabilities, but it was well worth the effort.$B$BGo ahead and try it yourself - the stone conducts the elements in powerful ways!',26124),
(115415,'enUS','Your soul, too, will be added to my cage.','',26124),
(115416,'enUS','All souls will be ours...','',26124),
(115417,'enUS','','We can use the Bloodstone. It will be powerful enough to control the sisters when they\'re in a weakened state.',26124),
(115418,'enUS','Yes, come closer. See what I have in store for you.','',26124),
(115419,'enUS','Flee! The Magistrix will kill us for failing her!','',26124),
(115420,'enUS','Your death will come soon.','',26124),
(115421,'enUS','This isn\'t worth dying for!','',26124),
(115422,'enUS','Jade Serpent taught me: king do what king must. We not gonna leave you. There\'s greenies to bust!','',26124),
(115423,'enUS','Get up! The Magistrix will have this delivery on time!','',26124),
(115424,'enUS','The Magistrix will have this shipment of Arcwine at once. Exhaustion is no excuse!','',26124),
(115425,'enUS','Please... have mercy... I can\'t go on.','',26124),
(115426,'enUS','My body is broken... I can\'t keep up.','',26124),
(115427,'enUS','','There are many things I can do to help strengthen your class hall, though some tough choices will have to be made.',26124),
(115428,'enUS','','I can still do a few magic tricks if I set my mind to it...',26124),
(115429,'enUS','','Oh look! Isn\'t she extraordinary! She will serve you well, $n, if you ask her nicely.',26124),
(115430,'enUS','Not again! The keepers will make me fill out an incident report!','',26124),
(115431,'enUS','The city\'s defenses have been compromised. Units assigned to safeguard the Speaker are not responding to my queries!','',26124),
(115432,'enUS','Might be the Old Gods ain\'t the only ones tryin\' ta find their way in!','',26124),
(115433,'enUS','Indeed! I suggest we pick up the pace.','',26124),
(115437,'enUS','','Ah yes, I can definitely do something with this water. I will need time to work with it. Thank you, Farseer.',26124),
(115438,'enUS','<Offer the Gift-Wrapped Arcwine Bottle.>','<Offer the Gift-Wrapped Arcwine Bottle.>',26124),
(115439,'enUS','','Thalyssra smiles warmly.',26124),
(115440,'enUS','','I will see that it is not wasted. Well done, my friend.',26124),
(115441,'enUS','<The pillar is quiet and cold.>','<The pillar is quiet and cold.>',26124),
(115442,'enUS','<The pillar glows slightly. It is no longer ice cold, but still cool to the touch.>','<The pillar glows slightly. It is no longer ice cold, but still cool to the touch.>',26124),
(115443,'enUS','<The pillar is warm.>','<The pillar is warm.>',26124),
(115444,'enUS','<The pillar hums with energy. As soon as you touch its surface, you feel a vast pool of untapped power just beneath its surface.>','<The pillar hums with energy. As soon as you touch its surface, you feel a vast pool of untapped power just beneath its surface.>',26124),
(115445,'enUS','Channel the energy of air.','Channel the energy of air.',26124),
(115446,'enUS','Channel the energy of water.','Channel the energy of water.',26124),
(115447,'enUS','Channel the energy of earth.','Channel the energy of earth.',26124),
(115448,'enUS','Channel the energy of fire.','Channel the energy of fire.',26124),
(115449,'enUS','Ma\'haat go deep. Ma\'haat collect shinies. Ma\'haat hungry.','',26124),
(115450,'enUS','Do you have a Fossilized Egg?','Do you have a Fossilized Egg?',26124),
(115451,'enUS','NO! Ma\'haat hungry! I want ORE!','',26124),
(115452,'enUS','Stupid $r, you don\'t know what you give up. Delicious!','',26124),
(115453,'enUS','I\'m ready, Altruis. Let\'s get back to the Fel Hammer and jump back to Mardum.','I\'m ready, Altruis. Let\'s get back to the Fel Hammer and jump back to Mardum.',26124),
(115454,'enUS','I\'m ready, Kayn. Let\'s get back to the Fel Hammer and jump back to Mardum.','I\'m ready, Kayn. Let\'s get back to the Fel Hammer and jump back to Mardum.',26124),
(115455,'enUS','It\'s done. The Felsouls are dead and they\'re not coming back.\n\nWe\'re ready to return to the Fel Hammer when you are, $n.','',26124),
(115456,'enUS','It is over. The Felsouls are dead and the will not be coming back.\n\nWe are ready to return to the Fel Hammer when you are, $n.','',26124),
(115457,'enUS','','You really think we are going to just let you in? You came all this way for nothing, demon hunters.',26124),
(115458,'enUS','Akama, move the Fel Hammer into position. Bring down this fel barrier.','',26124),
(115459,'enUS','Shade, move the Fel Hammer into position. Bring down this fel barrier.','',26124),
(115460,'enUS','Moving now. You might want to step back.','',26124),
(115461,'enUS','My pleasure. Step back.','',26124),
(115462,'enUS','','My lord Kil\'jaeden, save me...',26124),
(115463,'enUS','Kil\'jaeden, bring me back to life again...','',26124),
(115464,'enUS','You are all going to die painfully, especially you, $n.','',26124),
(115465,'enUS','Very well, Illidari. Your fate is sealed. You will perish with your world.','',26124),
(115466,'enUS','Fate has delivered you to us in this most dire time, hero! While I sense that your mission is urgent, if we do not push back these invading demons, we will all perish.','',26124),
(115467,'enUS','The chest is locked with a mysterious power, and cannot be opened here.$b$bYou can dismiss some of your withered troops and have them bring it back to Thalyssra.','',26124),
(115468,'enUS','$n! Please, step forward.','',26124),
(115469,'enUS','|c999900002 Withered:|r Bring the chest back to Thalyssra.','|c999900002 Withered:|r Bring the chest back to Thalyssra.',26124),
(115470,'enUS','Please, show me what you have brought. We haven\'t much time.','',26124),
(115471,'enUS','','You have done much for us, friend. I will call upon you again soon- until then, please accept my thanks.',26124),
(115473,'enUS','Leave the sentry.','Leave the sentry.',26124),
(115474,'enUS','I arise!','',26124),
(115475,'enUS','Fight for my pleasure.','',26124),
(115476,'enUS','','We are ready for your requests.',26124),
(115477,'enUS','I would like to requisition a Squad of Initiates.','I would like to requisition a Squad of Initiates.',26124),
(115478,'enUS','Rakeesh... His name means \"butcher\" in Eredun. It is no coincidence that Kil\'jaeden sent an eredar to slaughter my people. The Deceiver revels in his \"creative\" punishments for those that dare defy him.','',26124),
(115479,'enUS','Thank you.','',26124),
(115480,'enUS','THIS START EVENT FIRED LIKE A BOSS','',26124),
(115481,'enUS','Take the arcwine. I am getting out of here.','',26124),
(115482,'enUS','Pathetic.','',26124),
(115483,'enUS','Stop the interlopers! I must find out what the prisoner knows!','',26124),
(115484,'enUS','Brann! They\'re tryin\' ta invade me mind!','',26124),
(115485,'enUS','This barrier protecting my people requires all of my energy and focus. I am afraid you must venture into the demon infested halls alone. Please, search for survivors and eliminate the Legion invasion point portals that you find across the Exodar.','',26124),
(115486,'enUS','You must hurry. I do not know how much longer I can keep this barrier active!','',26124),
(115487,'enUS','You will pay for this delay!','',26124),
(115488,'enUS','Elisande... will hear... of this...','',26124),
(115489,'enUS','','The temple is completely overrun! Let us crush these demons!',26124),
(115490,'enUS','Time for battle! For Odyn!','',26124),
(115491,'enUS','','The Wardens\' duty is to protect our people from dangerous creatures such as this one. Strike without hesitation or mercy!',26124),
(115492,'enUS','','The Broken Isles is a land rife with danger, friend. The Wardens need your help in taking down this menace.',26124),
(115493,'enUS','','Threats abound in these lands, friend. A test of your courage stands before you. Strike fast and true!',26124),
(115494,'enUS','','The Wardens have pledged to bring justice to this world, but we cannot be everywhere. We offer you the honor of taking down a grave threat.',26124),
(115495,'enUS','','We believe your skills are well-suited for bringing this target to justice. Serve our order and you will be rewarded.',26124),
(115496,'enUS','','Fortune smiles upon us! You are near a threat we have been tracking for some time. Destroy it, and we will remember your service to the Wardens.',26124),
(115497,'enUS','','We will not forget your aid this day, champion! The Wardens are in your debt.',26124),
(115498,'enUS','','Now you have a sense of the duty each Warden bears, friend. Thank you for aiding our order.',26124),
(115499,'enUS','','Your skills show great promise! No doubt we shall call upon you again.',26124),
(115500,'enUS','','The land is safer for your actions this day. But stay vigilant! Danger will surely rise again.',26124),
(115501,'enUS','','Nicely done! Many others would show fear in the face of such danger, but you knew only courage.',26124),
(115502,'enUS','','An efficient, impressive kill. Your deeds are worthy of the Wardens!',26124),
(115503,'enUS','','A powerful menace lurks nearby. Be on your guard!',26124),
(115504,'enUS','','There is a mark near you. Eliminate it in the name of justice.',26124),
(115505,'enUS','','Our owls have spotted a target near your location. Dispatch it.',26124),
(115506,'enUS','','We have a target for you in this area. Be vigilant.',26124),
(115507,'enUS','','Beware! A threat is near. It must be eliminated.',26124),
(115508,'enUS','','A potent enemy lurks nearby. Bring it to justice!',26124),
(115509,'enUS','','A deadly mark is near your location. Prove yourself to be deadlier.',26124),
(115510,'enUS','','The Wardens thank you once again.',26124),
(115511,'enUS','','You have kept the peace for another day.',26124),
(115512,'enUS','','You are getting quite good at this, ally.',26124),
(115513,'enUS','','Another mark dispatched. Excellent!',26124),
(115514,'enUS','','You struck true. Well done!',26124),
(115515,'enUS','','You strike with impressive skill, friend.',26124),
(115516,'enUS','','Another danger thwarted. Nicely done!',26124),
(115517,'enUS','','Your mark is nearby, assassin.',26124),
(115518,'enUS','','Show them how we deliver justice.',26124),
(115519,'enUS','','Your target is marked. Be about your work.',26124),
(115520,'enUS','','We have an assignment for you.',26124),
(115521,'enUS','','Our enemies outnumber us. We have need of your skills.',26124),
(115522,'enUS','','Strike fast. Strike deadly.',26124),
(115523,'enUS','','You know what is required. Good luck.',26124),
(115524,'enUS','','Didn\'t even see you coming.',26124),
(115525,'enUS','','Didn\'t stand a chance.',26124),
(115526,'enUS','','Justice is served.',26124),
(115527,'enUS','','Well-struck, like a true Warden.',26124),
(115528,'enUS','','The legend of the Wardens grows thanks to your deeds.',26124),
(115529,'enUS','','We never doubted that you would succeed.',26124),
(115530,'enUS','','An efficient kill. Most admirable!',26124),
(115531,'enUS','We have gathered here to recognize your valor in battle. Turn and approach your peers.','',26124),
(115532,'enUS','Magni\'s in there! We gotta save \'im!','',26124),
(115533,'enUS','Good thing I have experience with fel barriers. Say the word, $n, and I\'ll bring it down!','',26124),
(115534,'enUS','Since you have this under control, I... I must attend to other guests. Please excuse me!','',26124),
(115535,'enUS','Kill the mage! Gul\'dan wants his head!','',26124),
(115536,'enUS','Inform your master that I\'ve grown rather attached to it.','',26124),
(115537,'enUS','','We need to keep moving!',26124),
(115538,'enUS','My blade thirsts for demon\'s blood!','',26124),
(115539,'enUS','','Who is that fighting so fiercely ahead?',26124),
(115540,'enUS','It appears to be a dwarf. How is he still alive?','',26124),
(115541,'enUS','Clearly the Legion doesn\'t want us hearing what Magni has to say.','',26124),
(115542,'enUS','Magni! \'Tis good to see ye again! But why did ye leave Ironforge? Why come here? What happened to--','',26124),
(115543,'enUS','I know ye have questions, but they gotta wait. Time is short. She wants me ta pass along an important message.','',26124),
(115545,'enUS','The ritual that changed me body also opened me ears ta the voice o\' Azeroth herself. She ain\'t just a hunk o\' rock. She\'s a titan!','',26124),
(115546,'enUS','Me own brother turned ta diamond and started talkin\' ta titans?','',26124),
(115547,'enUS','A titan? That... actually explains a great many things.','',26124),
(115548,'enUS','There\'s more I gotta say. Come inside the Celestial Planetarium and I\'ll show ye the truth.','',26124),
(115549,'enUS','Don\'t we need a key?','',26124),
(115550,'enUS','Brother... I AM the key.','',26124),
(115551,'enUS','You had better provide a good reason for this interruption.','',26124),
(115552,'enUS','I have seen your deeds in the vineyards. You have oppressed the Nightborne long enough. Prepare to die, Elvire!','I have seen your deeds in the vineyards. You have oppressed the Nightborne long enough. Prepare to die, Elvire!',26124),
(115553,'enUS','Intruder! Face my blade!','',26124),
(115554,'enUS','She sealed her fate, as you have sealed yours!','',26124),
(115555,'enUS','Yikes! I\'m gettin\' flashbacks o\' Algalon!','',26124),
(115556,'enUS','The constellar was jus\' doin\' his job, such as it was. And in the end, ye taught him a lesson.','',26124),
(115557,'enUS','|c999900005 Withered:|r Bring the chest back to Thalyssra.','|c999900005 Withered:|r Bring the chest back to Thalyssra.',26124),
(115558,'enUS','|c9999000010 Withered:|r Bring the chest back to Thalyssra.','|c9999000010 Withered:|r Bring the chest back to Thalyssra.',26124),
(115559,'enUS','Perhaps it is your imperfection... that which grants you free will... that allows you to persevere against all cosmically calculated odds. You prevail where the Titan\'s own perfect creations have failed.','',26124),
(115562,'enUS','After defeatin\' the Old Gods, the keepers were giv\'n the task o\' orderin\' the world. The titans gave \'em five mighty artifacts... the Pillars o\' Creation!','',26124),
(115563,'enUS','When their work was done, the keepers sealed the Pillars away. But like so many relics, they ended up in the hands o\' mortals.','',26124),
(115564,'enUS','Your tale sounds familiar... I\'m sure I\'ve heard of these Pillars before.','',26124),
(115565,'enUS','Aye, Khadgar. The knowledge was placed in the care o\' the Guardian of Tirisfal, and remains there still!','',26124),
(115566,'enUS','Ye must find the Pillars! Combined, their power kin seal the Legion\'s gateway to Azeroth. \'Tis the only way to save her!','',26124),
(115567,'enUS','It\'s not every day a planet points me to my own library. Thank you, Magni. I will go to Karazhan at once. $n, follow me through the portal when you\'re done here.','',26124),
(115568,'enUS','And what of ye, brother? Will ye go back ta Ironforge?','',26124),
(115569,'enUS','Nay, Brann. She has... other duties for me. But I\'d be obliged if ye\'d stay fer a chat.','',26124),
(115570,'enUS','I\'d like that, brother! But I think me friend here has some work ta do.','',26124),
(115571,'enUS','I reckon so. Take care, $n. We\'ll see one another again.','',26124),
(115572,'enUS','I must find the others!','I must find the others!',26124),
(115573,'enUS','We are stronger side by side, $n.','We are stronger side by side, $n.',26124),
(115574,'enUS','Why didn\'t we bring some cannons?','',26124),
(115575,'enUS','Cannons?! And how are we supposed to get them here?','',26124),
(115576,'enUS','We\'ve got gryphons!','',26124),
(115577,'enUS','Really?! A gryphon carry a cannon?','',26124),
(115578,'enUS','It could grip it by the trunnion!','',26124),
(115579,'enUS','It\'s not a question of where he grips it. It\'s a simple question of weight ratios!','',26124),
(115580,'enUS','A 500 pound gryphon could not carry a two thousand pound cannon.','',26124),
(115581,'enUS','We shouldn\'t stick around. More will be here soon.','We shouldn\'t stick around. More will be here soon.',26124),
(115582,'enUS','It could be carried by a Gilnean gryphon!','',26124),
(115583,'enUS','Oh a Gilnean gryphon maybe, but not one of these local gryphons, that\'s my point.','',26124),
(115584,'enUS','But then, of course, you\'d never find a Gilnean gryphon around these parts anyway.','',26124),
(115585,'enUS','Supposing two gryphons carried it together?','',26124),
(115586,'enUS','No, they\'d have to have it on a line.','',26124),
(115587,'enUS','Simple! They\'d just use some rope from the tents!','',26124),
(115588,'enUS','What, held under the dorsal guiding feathers?','',26124),
(115589,'enUS','Why not!?','',26124),
(115590,'enUS','Best if we stick together!','',26124),
(115591,'enUS','Don\'t pay me no mind. Just gone ta stick around a bit. Least I can do.','',26124),
(115592,'enUS','Best be gettin\' back. They\'ll be wonderin\' where I been.','',26124),
(115593,'enUS','If it weren\'t fer you I\'d be... well, I can\'t say where I\'d be. Probably dead if it weren\'t fer you.','',26124),
(115595,'enUS','Greetings, Grand Master $. What can I do for you?','',26124),
(115597,'enUS','You cannot defy me!','',26124),
(115598,'enUS','Elisande will have your heads for this!','',26124),
(115599,'enUS','Vengeance for Margaux!','Vengeance for Margaux!',26124),
(115600,'enUS','The taste of mana!','',26124),
(115601,'enUS','The thirst... never... ends.','',26124),
(115602,'enUS','I can help you change the power within your weapon if you\'re interested. I\'m the best smith this side of Ironforge!\n\nFair warning, though: some of the power will be lost in the process.','',26124),
(115603,'enUS','Guess I\'ll have to be a bit more careful. Thanks.','Guess I\'ll have to be a bit more careful. Thanks.',26124),
(115604,'enUS','Thanks! That was a close one!','Thanks! That was a close one!',26124),
(115605,'enUS','Stick to the shadows, $n.','Stick to the shadows, $n.',26124),
(115606,'enUS','You\'re a life saver!','You\'re a life saver!',26124),
(115607,'enUS','I sure am glad to see you! I thought I was a goner.','I sure am glad to see you! I thought I was a goner.',26124),
(115608,'enUS','Keep moving! No telling what else is out here!','Keep moving! No telling what else is out here!',26124),
(115609,'enUS','This bridge is mine!','',26124),
(115610,'enUS','How tiny thing...?','',26124),
(115611,'enUS','You should have joined us when you had the chance!','You should have joined us when you had the chance!',26124),
(115612,'enUS','If you so wish, I can help you alter the power within your blades.\n\nBe warned! Such change will not come without loss.','',26124),
(115613,'enUS','Your kind will be left behind!','Your kind will be left behind!',26124),
(115614,'enUS','Your time is up!','Your time is up!',26124),
(115615,'enUS','Traitorous spies must die!','Traitorous spies must die!',26124),
(115616,'enUS','','I can reflow the venom within your blades to unlock new power wthin.\n\nThere\'s no charge for you, of course, but beware that some strength is lost in the process.',26124),
(115617,'enUS','It is all too simple with this forge to rework the steel of your weapon to alter its power.\n\nSome souls will be lost, of course, but some always are.','',26124),
(115618,'enUS','','I can use the magic in the grove to help you change the power within your weapon!\n\nThe spell\'s a bit unstable, though, so you\'ll lose a little bit when I cast it.',26124),
(115619,'enUS','Our people have been goin\' missing, the dead have been seen walking, and the fires are lit in the old fortress.$b$bThere\'s evil afoot, no doubt about it.$b$bIf you\'re here to help, then see our mayor down the road at Bradensbrook. Careful though, I think the pressure might be gettin\' to him.','',26124),
(115620,'enUS','','I believe we can use these withered as a weapon. But first we must teach them how to survive in battle.',26124),
(115621,'enUS','I\'m ready!','I\'m ready!',26124),
(115622,'enUS','Withered health increased!','Withered health increased!',26124),
(115623,'enUS','Withered Berserker unlocked!','Withered Berserker unlocked!',26124),
(115624,'enUS','','Destroy our enemies!',26124),
(115625,'enUS','','Crush these invaders!',26124),
(115626,'enUS','','For Odyn!',26124),
(115627,'enUS','','Feel my wrath!',26124),
(115628,'enUS','Glory to the Valarjar!','',26124),
(115629,'enUS','A worthy enemy!','',26124),
(115630,'enUS','Fight with valor!','',26124),
(115631,'enUS','Destroy them!','',26124),
(115632,'enUS','If you so wish, I can call upon the primordial forces present here and help you to infuse new power entirely into your weapon.\n\nJust be cautious: the ancient powers involved are volatile, and some power must return to the wilds in the process.','',26124),
(115633,'enUS','I wish I were younger so I could show these grell the tips of my claws and the points of my teeth.','',26124),
(115634,'enUS','Stop! I command it! How dare you turn on your master?!','',26124),
(115635,'enUS','Glad to have heroes like you here, $n. With all that\'s goin\' on I had to scramble my pilots to keep the skies clear!','',26124),
(115636,'enUS','Hey, $n! Keep at it down here! My pilots will keep the skies clear above.','',26124),
(115637,'enUS','You must be one of the brave ground forces. Keep up the good work! I\'m sending my best pilots up to keep \'em busy at the airfield.','',26124),
(115638,'enUS','We can\'t lose the airfield! I\'m sending my best pilots there now. Help keep things calm down here and we\'ll clear the skies.','',26124),
(115639,'enUS','You must be the $c they were talkin\' about! One of my pilots saw you from above. Said you were puttin\' on quite a show down here! Keep at it.','',26124),
(115640,'enUS','If you desire to reflow the power within your weapon to achieve new results, Conjurer, just say the word and I can assist you.\n\nJust know that the incantation will use a small portion of the power as a catalyst.','',26124),
(115641,'enUS','$n! Keep \'em cleared out at ground level! My boys are stickin\' it to them at the airfield as we speak!','',26124),
(115642,'enUS','If you wish to change the way your Chi flows through your weapon, it is as simple as willing it to be so. I can help you focus your thoughts in this effort.\n\nKeep in mind, Master $n, while most of the Chi will follow your new path... some will not. Such is its nature.','',26124),
(115645,'enUS','','Saa\'ra\'s been teachin\' me more an\' more about how to use the altar. If ye want, I should be able ta help ye change how the power\'s sittin\' in yer blade.\n\n\'Course, I\'m still learnin\', so it won\'t be a perfect transfer. A bit o\' the power will dissolve into the nether.',26124),
(115646,'enUS','I gave you what you wanted, now leave me be!','',26124),
(115647,'enUS','Hey wikket, come here! Great danger is near!','',26124),
(115648,'enUS','Withered troops are now less likely to run away when injured!','Withered troops are now less likely to run away when injured!',26124),
(115649,'enUS','Get movin\', wikket! Yu\'lon be in trouble. Let\'s get to her side and give aid on the double!','',26124),
(115650,'enUS','You hear the sounds of chitinous legs descending from the shadows...','You hear the sounds of chitinous legs descending from the shadows...',26124),
(115651,'enUS','|TInterface\\Icons\\ability_demonhunter_chaosnova:20|t%s drains a spider to |cFFFF0000|Hspell:218217|h[Unleash]|h|r its energy!','|TInterface\\Icons\\ability_demonhunter_chaosnova:20|t%s drains a spider to |cFFFF0000|Hspell:218217|h[Unleash]|h|r its energy!',26124),
(115652,'enUS','Ooo, that no look good! Come, wikket, this way. There\'s greenies about, but we\'ve no time to play.','',26124),
(115653,'enUS','','Psst! Hey, $n, over here!',26124),
(115654,'enUS','Withered troops will now focus more of their attacks on enemies!','Withered troops will now focus more of their attacks on enemies!',26124),
(115655,'enUS','','Champion! I bear orders from Greymane!',26124),
(115656,'enUS','Withered Mana-Rager unlocked!','Withered Mana-Rager unlocked!',26124),
(115657,'enUS','Withered Spellseer unlocked!','Withered Spellseer unlocked!',26124),
(115658,'enUS','Withered Starcaller unlocked!','Withered Starcaller unlocked!',26124),
(115659,'enUS','The world shifts ever beneath our feet, $ct. As shaman, we must always be ready to adapt.\n\nPerhaps you need to change the properties of the weapons you wield? The elements are listening.\n\nI can convince them to alter how their power flows through your artifacts - they ask for but a small portion of it released back to them in return.','',26124),
(115660,'enUS','','I can see it in ya eyes - ya be wanting somethin\' different for that artifact ya be wielding. Somethin\' new.\n\nYa come ta the right place, Overlord. I can help ya... but I be makin\' no guarantees that every drop gonna be where ya left it.\n\nDemon blood be too volatile for guarantees.',26124),
(115661,'enUS','Thank you.','',26124),
(115662,'enUS','','I AM RENEWED! Come, little ones. Let us put an end to this invasion!',26124),
(115663,'enUS','We can use the Forge of Odyn to alter the very core of your artifact, allowing us to redistribute its power as you wish.\n\nHowever, we must use a small fragment of its power to work the blade in this way.','',26124),
(115664,'enUS','Hail. I am Helgar, master smith of Skyhold.','',26124),
(115665,'enUS','','What can I do for ye?',26124),
(115667,'enUS','','Come on Cora, it\'s time to head home.',26124),
(115669,'enUS','Thank you! I was getting weary.','',26124),
(115670,'enUS','The Legion appeared out of nowhere. They must have a portal nearby. Let\'s go find it!','',26124),
(115671,'enUS','I am Moorgoth the Death Hunter, stalker of the night and master of shadows.$b$bWould you like to browse my wares?','',26124),
(115672,'enUS','Uh, have we met before?','Uh, have we met before?',26124),
(115673,'enUS','Have you skirted the vast abyss of death? Have you stared entropy in the eye? Then you have met Moorgoth!$b$bOh. Right. I guess you have, haven\'t you? I should have thought that through.$b$bI realize I didn\'t receive some divine calling to come here like some of the others, but I thought you would have need of my services.','',26124),
(115674,'enUS','Don\'t think I\'ve ever heard of \"death hunters\".','Don\'t think I\'ve ever heard of \"death hunters\".',26124),
(115675,'enUS','There aren\'t a lot of us. That is to say, only a few. Okay, it\'s me and a couple buddies. But our ranks will grow!$b$bOur mandate is to patrol the shadowed roads of Azeroth and the realms beyond, keeping it safe for the innocent. And...$b$bLook, I\'m going to be honest. We just really, really think dark rangers are amazing and we want to be near them.','',26124),
(115676,'enUS','Wait. What?','Wait. What?',26124),
(115677,'enUS','Thank you, $c! Without you I would have surely perished!','Thank you, $c! Without you I would have surely perished!',26124),
(115678,'enUS','I mean, just look at Velonara over there. She\'s like a dream! So brooding, so mysterious, so... dark.$b$bHave you worked with her before? What was it like? Say, have you two ever...$b$bNevermind. Best not to know such things. The past is the past, and I need to focus on the future. My future with her.$b$bThat\'s why I got all these black roses. I was going to give her a dozen, but that doesn\'t feel like quite enough to impress her. Say, would you talk to her? About me, I mean? Maybe bring her a gift?','',26124),
(115679,'enUS','I don\'t really want to get involved...','I don\'t really want to get involved...',26124),
(115680,'enUS','Light bless you!','Light bless you!',26124),
(115681,'enUS','I owe you my life!','I owe you my life!',26124),
(115682,'enUS','That\'s fantastic! You\'re really the greatest. Oh, I hope Velonara has noticed me!','',26124),
(115683,'enUS','I can make it back on my own now. Your heroics have strengthened my resolve!','I can make it back on my own now. Your heroics have strengthened my resolve!',26124),
(115684,'enUS','I was just talking to Moorgoth, and he...','I was just talking to Moorgoth, and he...',26124),
(115685,'enUS','How can I ever repay you for this, hero?','How can I ever repay you for this, hero?',26124),
(115686,'enUS','Have you seen my brother? I hope he made it to the Prophet!','Have you seen my brother? I hope he made it to the prophet!',26124),
(115687,'enUS','','You mean that moping, black-clad imbecile across the way? The one who keeps leering at me?$b$bYes, I\'ve noticed him. He\'s not the first mortal to obsess over a dark ranger. I don\'t understand the fascination some have with death. He should spend his time pursuing the living, not longing for a dalliance with one who has already passed.$b$bLife is often wasted on the living.',26124),
(115688,'enUS','You sound as if you miss your previous life.','You sound as if you miss your previous life.',26124),
(115689,'enUS','','I was a maiden, pure and true. A young ranger in service of Silvermoon, betrothed to the nobleman of my dreams.$b$bThen Arthas came.$b$bI fell in battle as the mad prince cut a black scar through the land I loved. But at least I was at peace, I suppose. For a time. Until the Banshee Queen pulled me back from beyond and damned my soul into her service.$b$bYou\'ll have to pardon me if I have little patience for imbeciles like Moorgoth, who take for granted what they have and think to find happiness in pain.',26124),
(115690,'enUS','He doesn\'t seem like such a bad guy.','He doesn\'t seem like such a bad guy.',26124),
(115691,'enUS','','<The dark ranger sighs.>$b$bI suppose he has a certain charm. He can\'t help his ignorance.$b$bBut he must realize that my heart is incapable of feeling love or happiness, nor could we... engage in the sort of intimacy he desires. I am a dead, rotting thing, and only the abyss awaits me.$b$bPlease, if you have any fondness for him at all, break his heart now. It will save him true pain later.$b$b<Velonara pauses a moment, then takes a single black rose and caresses its petals.>',26124),
(115692,'enUS','Do you wish to summon Elementals?','Do you wish to summon Elementals?',26124),
(115693,'enUS','What did Velonara say? Is she interested? Would she like dinner? I\'ve been known to roast a mean boar loin.','',26124),
(115694,'enUS','Sorry, Moorgoth. She said no.','Sorry, Moorgoth. She said no.',26124),
(115695,'enUS','Really? I thought she might...$b$bOh, I get it. I figured she had a thing for you. Makes sense. Brave hero, leader of the Unseen Path... How can a guy like me compete with all that?$b$bThanks anyway, $n. No hard feelings, right?$b$bSay, I don\'t suppose you\'d talk to Dark Ranger Alina for me, would you? She\'s so gorgeous...','',26124),
(115696,'enUS','I have to go.','I have to go.',26124),
(115697,'enUS','Okay, okay, fine. Anytime you\'re interested in browsing my wares, let me know!','',26124),
(115698,'enUS','I\'ll let him down easy.','I\'ll let him down easy.',26124),
(115699,'enUS','Finally! The Book of Medivh is ours! Would have saved ourselves time if you\'d just let me kill those death-lovers!','',26124),
(115700,'enUS','','Not worth the effort, dear! Let them rot in their crypt. The fires of the Legion will come for them soon enough.',26124),
(115701,'enUS','Hmmph! Wait... something is wrong!','',26124),
(115702,'enUS','Well, it looks like I\'ll be speaking to her.','Well, it looks like I\'ll be speaking to her.',26124),
(115703,'enUS','Calydus is here to help!','',26124),
(115704,'enUS','<Tell Calydus about the ritual and the Scepter.>','<Tell Calydus about the ritual and the Scepter.>',26124),
(115705,'enUS','Gul\'dan will use Scepter, Eye, and Book to make portals bigger and stronger. Many, many demons pour through! Friend not want that, I think.','',26124),
(115706,'enUS','More grell?! Was ransacking my home not enough?!','',26124),
(115707,'enUS','That should teach them to stay away... you move into a cottage in the middle of the forest and never find peace.','',26124),
(115708,'enUS','What if friend trick Gul\'dan into giving up scepter? Then ruin ritual and run away! Haha! This can work, friend!','',26124),
(115709,'enUS','Thanks to you, Thunderfury has been restored and Thunderaan\'s spirit can finally be released.','',26124),
(115710,'enUS','Look to the heavens and witness the rebirth of Thunderaan... THE WINDLORD!','',26124),
(115711,'enUS','','Ugh... Oh, my head!',26124),
(115712,'enUS','Take their stuff!','',26124),
(115713,'enUS','Bonk them to the ground!','',26124),
(115714,'enUS','Smash their smashies!','',26124),
(115715,'enUS','Scratch their feets!','',26124),
(115716,'enUS','Bite their knees!','',26124),
(115717,'enUS','','Oh, Stonestep... your sacrifice will not be in vain!',26124),
(115718,'enUS','If we wish to defeat the Houndmaster, we\'ll need to lure him to a location of our choosing.','',26124),
(115719,'enUS','','I am a collector of herbs, flowers, and plants. My travels have taken me all across the Broken Isles, as well as into the Emerald Dream. How can I help you?',26124),
(115720,'enUS','Malevolence, get us out of here.','',26124),
(115721,'enUS','Malevolence, get us out of here.','',26124),
(115722,'enUS','','Of course, my dears.',26124),
(115723,'enUS','The fish sure are biting today!','',26124),
(115724,'enUS','Tylos, jump us back to Mardum.','',26124),
(115725,'enUS','Tylos, jump us back to Mardum.','',26124),
(115726,'enUS','Do you happen to have an extra raft I can borrow?','Do you happen to have an extra raft I can borrow?',26124),
(115727,'enUS','Living in the wild you never know what will happen next, but a good hunter can survive on skill and instinct.','',26124),
(115728,'enUS','You need to eat to survive in the wild.$B$BBoar meat makes a hearty meal when cooked over an open flame. It should not be eaten raw, however.$B$BThere are many berries that grow in this region. Some are edible, while others cause minor sickness when ingested. You can often determine which are safe to eat by their smell. A sweet aroma indicates the berry is unsafe to eat.$B$BFirewood can be obtained from dying trees. They are easily identified by their dry, purple leaves.$B$BAre you ready to begin?','',26124),
(115729,'enUS','','I\'m coming too!',26124),
(115730,'enUS','','Today we celebrate a great triumph, one paid for with the blood of those most dear to us.',26124),
(115731,'enUS','','Thanks to your courage, the ancient lands of Val\'sharah can at long last begin to heal.',26124),
(115732,'enUS','','Now the Tears of Elune are added to our arsenal. May they bring us victory against the Legion!',26124),
(115733,'enUS','Sure do! Just go out into the water and you should be good to go!','',26124),
(115734,'enUS','','Today we celebrate a great triumph, one paid for with the blood of those most dear to us.',26124),
(115735,'enUS','','Though I am often at odds with your Horde, I cannot question the courage you\'ve shown saving Val\'sharah.',26124),
(115736,'enUS','','Now the Tears of Elune are added to our arsenal. May they bring us victory against the Legion!',26124),
(115738,'enUS','Well done, hero of the Light! We will now safeguard this area and give you assistance!','Well done, hero of the Light! We will now safeguard this area and give you assistance!',26124),
(115739,'enUS','','Malfurion! Where is my beloved?',26124),
(115740,'enUS','I shall also send Hydraxis to aid the Earthen Ring. He is my greatest champion and will prove valuable in your quest.','',26124),
(115741,'enUS','The Heart of Azeroth resides at the intersection of the elemental powers on this world. There is no place on Azeroth that is more connected to each of the elements.','',26124),
(115742,'enUS','We must rescue Kotira quickly, before we are discovered.','',26124),
(115743,'enUS','Let\'s rescue Koltira and get out of here.','Let\'s rescue Koltira and get out of here.',26124),
(115744,'enUS','Release the construct.','Release the construct.',26124),
(115745,'enUS','You have successfully vanquished the rogue construct.','You have successfully vanquished the rogue construct.',26124),
(115746,'enUS','','Until then, watch your step. The city is on high alert, and the guards will kill you on sight.',26124),
(115747,'enUS','The cell door is unlocked, you feel  a sizeable amount of power emanating from within.','',26124),
(115748,'enUS','As the sentry\'s power builds, you feel the hairs on the back of your neck raise with static.','',26124),
(115749,'enUS','The sentry releases its energies.  You hear the faint whistle of something falling.','',26124),
(115750,'enUS','|TInterface\\Icons\\spell_druid_massentanglement_nightmare:20|tThe Eye of Il\'gynoth begins to cast |cFFFF0000|Hspell:218415|h[Death Blossom]|h|r!','|TInterface\\Icons\\Achievement_Boss_YoggSaron_01:20|tA Dominator Tentacle faces you and readies |cFFFF0000|Hspell:208689|h[Ground Slam]|h|r!',26124),
(115751,'enUS','I will begin to channel my essence into the arcane vessel.','',26124),
(115752,'enUS','Once the process is complete, Hakkar should be drawn to the vessel\'s magic.','',26124),
(115753,'enUS','While my essence is contained within the vessel, I will be in a weakened state, unable to assist.','',26124),
(115754,'enUS','Careful not to singe the buds as you burn!','',26124),
(115755,'enUS','One garden pest deserves another!','',26124),
(115756,'enUS','At least power is something your feeble minds comprehend!','',26124),
(115757,'enUS','Rage against the dying of the light!','',26124),
(115758,'enUS','When the light dies... so do you!','',26124),
(115759,'enUS','Nature nourishes those who truly appreciate it.','',26124),
(115760,'enUS','You\'ll make a fine seedling for my power!','',26124),
(115761,'enUS','Night falls upon you!','',26124),
(115762,'enUS','The sun warms my beauties... but it shall scorch your bones!','',26124),
(115763,'enUS','Wither in my heat, little weeds!','',26124),
(115764,'enUS','Now you face three aspects of life, even as your cycle is about to end!','',26124),
(115765,'enUS','Can you hope to stand against the three primal forces that shape life itself?','',26124),
(115766,'enUS','Suramar owes its beauty to my blooms! I alone have mastered the delicate intertwining of magic into nature\'s grand cycle.','',26124),
(115767,'enUS','Your corpse will make a fine compost!','',26124),
(115768,'enUS','More food for the worms!','',26124),
(115769,'enUS','How dare you disturb my pristine gardens!','',26124),
(115770,'enUS','It seems I\'ve a bit of pruning to do!','',26124),
(115771,'enUS','Death is merely part of the great cycle.','',26124),
(115772,'enUS','Wherever will I store all this fertilizer?','',26124),
(115773,'enUS','A bitter... harvest...','',26124),
(115774,'enUS','Someone... water... my plants...','',26124),
(115775,'enUS','My rangers are armed and ready to fight by your side!','',26124),
(115776,'enUS','','My archers have their bows loaded, ready to shoot any demons that dare enter these walls.',26124),
(115777,'enUS','','Is it working?',26124),
(115778,'enUS','Has Hakkar taken the bait?','',26124),
(115779,'enUS','','Send up a flare, and we shall see.',26124),
(115780,'enUS','The Doomhammer could be anywhere. We\'ll have to split up.','',26124),
(115781,'enUS','I will speak with the shaman at the Temple of Earth.','',26124),
(115782,'enUS','','I\'ll see if the Earthen at Stonehearth saw anything.',26124),
(115783,'enUS','Shaman, you must seek out the Stonemother. But be cautious - she is quick to anger.','',26124),
(115784,'enUS','We should meet back up at Therazane\'s Throne once we know more. Good luck to both of you!','',26124),
(115785,'enUS','','Demons are near! Sentinels, ready your blades!',26124),
(115786,'enUS','','I have a proposition for you. Just beneath us lies some excellent crab meat... I mean, they\'re still alive, but you understand my point.$b$bI have some buoys here you could use to bring them to the surface. You go down and attach the buoys and I\'ll capture what rises to the surface.$b$bDo this for me and I promise you\'ll be rewarded handsomely. What do you say?',26124),
(115787,'enUS','I\'m ready. Give me the buoys.','I\'m ready. Give me the buoys.',26124),
(115788,'enUS','','Watch yourself down there. There are some other creatures that linger near the crabs that you don\'t want to cross paths with.$b$bYou know, I could have been a $c like you had I not followed in my father\'s footsteps and took to the sea.',26124),
(115789,'enUS','','Ancestors... forgive me...',26124),
(115790,'enUS','You have done what the Kirin Tor could not do for ourselves. The Houndmaster\'s death will deliver a crushing blow to the Burning Legion\'s forces.','',26124),
(115791,'enUS','Let us leave this place, and celebrate our victory among friends.','',26124),
(115792,'enUS','','You overreact, Terrath. Answers will come. Ah, a mortal approaches. Whenever there is trouble, the flesh is not far away, hm?',26124),
(115793,'enUS','','Something is whipping the troggs into a frenzy. Maybe it has to do with that missing hammer of yours. Be a dear and take care of them, hm?',26124),
(115794,'enUS','','Oh how lovely, lovely! The clutch is safe. Join me back at my throne. I know where to find your hammer - and the stone dragons are now free to help.',26124),
(115795,'enUS','','Here comes my new favorite fleshling. You are a true friend of the Stonemother, shaman.',26124),
(115796,'enUS','','The trogg chieftain knows where your hammer fell, shaman. Beat the information out of him! The stone dragons are at your disposal.',26124),
(115797,'enUS','','This should help you get around while you\'re down there. It doesn\'t last long, so be quick.',26124),
(115798,'enUS','The sentry hums with arcane energies as indecipherable elfish runes dance faintly across the surface of its lens.  There is one talon that glows faintly.','',26124),
(115800,'enUS','A second talon flashes intermittently; but the sentry is otherwise inactive. It is as though it waits for some outside input.','',26124),
(115801,'enUS','The sentry seems inactive but for one of its talons flashing intermittently.','',26124),
(115802,'enUS','With the sequence completed, the sentry\'s lens is alive with runes scrolling to and fro.  You\'re not sure what to make of it all though.','',26124),
(115803,'enUS','','Troubles on the surface don\'t belong down here, shaman. I hope you intend to put this right.',26124),
(115804,'enUS','Koltira is being held nearby! We must hurry!','',26124),
(115805,'enUS','Here is the sentry Sira mentioned. As indicated, the talon is flashing red.  All that remains is begin the energy transfer sequence and to survive.','',26124),
(115806,'enUS','The sentry is alive with arcane energies.  Its eyes are constantly scanning the environment.','',26124),
(115807,'enUS','The sentry\'s readouts seem to have calmed down, relatively speaking. There\'s still a danger indicator on the lower levels...','',26124),
(115808,'enUS','On the readout for this sentry, you see a small representation of the trapped creature at the top of the elevator shaft.  There is one talon frantically flashing red.','',26124),
(115809,'enUS','Calydus is here, friend! Council flees! Haha!','',26124),
(115810,'enUS','New arrivals! Yer right on time! We\'ve got \'em cornered!','',26124),
(115811,'enUS','This here beasty thinks he\'s got some bite! Show \'em how we treat unwelcome guests.','',26124),
(115812,'enUS','Ah, another brave adventurer. Show \'em yer strength!','',26124),
(115813,'enUS','Don\'t let up! We\'ve got more ground ta cover after this one\'s laid ta rest!','',26124),
(115814,'enUS','Give \'em everythin\' ye got!','',26124),
(115815,'enUS','Keep at it! More reinforcements just arrived!','',26124),
(115816,'enUS','Reinforcements\'ll be \'ere soon! Give \'em no ground!','',26124),
(115817,'enUS','Ye\'ve done it again! Well fought everyone, but we shan\'t celebrate just yet. There\'s plenty else needin\' our help.','',26124),
(115818,'enUS','You have left the combat area. You will be teleported back shortly.','Warning: You\'ve entered a no-fly zone and are about to be dismounted!',26124),
(115819,'enUS','In here! We can leap over the flames!','',26124),
(115820,'enUS','Hodir\'s cut off from the rest of the temple. They\'ll surround him soon if we don\'t move fast.','',26124),
(115821,'enUS','Hodir\'s room\'s behind that door. We need to get it open.','',26124),
(115822,'enUS','Get down!','',26124),
(115823,'enUS','Caria... no...','',26124),
(115824,'enUS','','Varedis... no!',26124),
(115825,'enUS','Let\'s start brewing!','Let\'s start brewing!',26124),
(115826,'enUS','We are close to completing the final brewing, but we are surrounded by enemies.$B$BHelp me fend off the attackers while Aegira completes the Storm Brew!','',26124),
(115827,'enUS','Good! Now, let us show them the might of the monks!','',26124),
(115828,'enUS','','I said no point blank shots!',26124),
(115829,'enUS','You burned those naga real good, little ghost. Burned \'em right up.','',26124),
(115830,'enUS','Watch out! More attackers are incoming!','',26124),
(115832,'enUS','Hurry, Grandmaster, while we have time. Drink the Storm Brew!','',26124),
(115833,'enUS','','You bought me enough time. The brew is finished!',26124),
(115834,'enUS','I hear their footsteps coming. Don\'t let down your guard!','',26124),
(115835,'enUS','Stand firm, Grandmaster! Protect the brew at all costs!','',26124),
(115836,'enUS','I am honored.','',26124),
(115837,'enUS','You honor me.','',26124),
(115838,'enUS','','Thank you, $n. I will not let you down.',26124),
(115839,'enUS','Your mortal allies will not help you, little snake! Your doom is at hand!','',26124),
(115840,'enUS','','Do you think that silly concoction will save you? Come out and face me. I will destroy what is left of the Broken Temple!',26124),
(115841,'enUS','','Enough. Your time is ended, monk!',26124),
(115842,'enUS','','Tell whoever you\'re sending that the sooner Gaardoun has his demonic toys, the sooner we\'ll have our new Ashtongue warriors.',26124),
(115843,'enUS','','Hey Gaardoun, those new warriors ready yet?',26124),
(115844,'enUS','','Could that really be Loramus Thalipedes? And if it is, do we save him or kill him?',26124),
(115845,'enUS','','Be careful, $n. Half the time he\'s down there threatening us in the demonic tongue.',26124),
(115846,'enUS','Make sure the Ashtongue understand that the other broken at the Black Temple are not to be trusted.','',26124),
(115847,'enUS','I will do all I can to ensure our war against the Legion is successful. Make certain you do the same.','',26124),
(115848,'enUS','I know everything Akama knows, and more. I look forward to us working together to destroy the Legion.','',26124),
(115849,'enUS','','What took you so long? I should have been your first champion.',26124),
(115850,'enUS','Ariana\'s just about the best trainer around. Who knows, maybe she\'ll even be able to teach them the Metamorphosis?','',26124),
(115851,'enUS','Ghouls... I should have known!','',26124),
(115852,'enUS','Don\'t let \'em reach the camp! Bad enough they\'ve already ruined the quarry!','',26124),
(115853,'enUS','Keep at it! Not the time ta give \'em another inch o\' ground!','',26124),
(115854,'enUS','Looks like more folks came ta help! I\'ll be gettin\' me quarry back if it\'s the last thing I do!','',26124),
(115855,'enUS','Another arrival! Now we have a real shot o\' clearin\' \'em out down below!','',26124),
(115856,'enUS','Looks like someone got the word out! Another fighter just arrived!','',26124),
(115857,'enUS','More backup! Push on further! We\'ve got ta take the quarry back!','',26124),
(115858,'enUS','Just a wee bit longer! Backup\'ll be here shortly!','',26124),
(115859,'enUS','Hold \'em back just a tad longer!','',26124),
(115860,'enUS','Won\'t be long now! Hold \'em off a bit longer!','',26124),
(115861,'enUS','Great job everybody! You\'ve saved me quarry, but it looks like there\'s plenty left ta do. Help where ye can. An\' keep an eye out! They\'re poppin\' up everywhere!','',26124),
(115866,'enUS','This is Horde territory, but you will not be welcome here with me.','',26124),
(115867,'enUS','That was a good fight!','',26124),
(115868,'enUS','I am glad you found us, $n!','',26124),
(115869,'enUS','There are more in trouble ahead. Let\'s keep moving!','',26124),
(115870,'enUS','','My three sisters from that tree hung,\nThe crimes accused there was not one,\nThe youngest sister did escape,\nAs the noose looped around their nape,\nOld Ravencrest is the one to blame,\nThis curse for you to lift our shame.',26124),
(115871,'enUS','We are here to free you at last, my brother.','',26124),
(115872,'enUS','Indeed, it has.','',26124),
(115873,'enUS','We must hurry before the guards come.','',26124),
(115874,'enUS','Thassarian... is it really you?','',26124),
(115875,'enUS','It has been such a long time...','',26124),
(115876,'enUS','Thank you. I need to rest for a bit after that.','',26124),
(115877,'enUS','','The curse is lifted. Now I can finally rest. But remember hero. Let not good men acquiesce.',26124),
(115878,'enUS','Ah, thank ye! Need a bit ta mend me wounds.','',26124),
(115879,'enUS','Not sure I\'m cut out fer all o\' this. I\'ll be back when it\'s a tad safer.','',26124),
(115880,'enUS','Oof! Careful! Me wounds aren\'t healed just yet.','',26124),
(115881,'enUS','Back on me feet, but me strength\'s still a bit low.','',26124),
(115882,'enUS','Thank ye!. Wasn\'t expectin\' that! Did ye come all the way out \'ere ta help?','',26124),
(115883,'enUS','Feelin\' a bit sluggish. Give me a bit o\' time ta recover.','',26124),
(115884,'enUS','So... cold...','So... cold...',26124),
(115885,'enUS','Will this hunger ever stop?','Will this hunger ever stop?',26124),
(115886,'enUS','I can\'t take it anymore...','I can\'t take it anymore...',26124),
(115887,'enUS','Hello? Is anybody there?','Hello? Is anybody there?',26124),
(115888,'enUS','The cravings are unbearable...','The cravings are unbearable...',26124),
(115889,'enUS','The pain! Make it stop!','The pain! Make it stop!',26124),
(115890,'enUS','','Heroes, your fight is with Korithis. I\'ll protect you from his winged monstrosity.',26124),
(115891,'enUS','It might leave a bad taste in our mouths, but working with the Wardens will get us what we need. We\'ve made worse sacrifices.','',26124),
(115892,'enUS','Almost done with this one, then I gotta head out to the next gig.','Almost done with this one, then I gotta head out to the next gig.',26124),
(115893,'enUS','Hopefully this one works... Startin\' to run low on spare parts.','Hopefully this one works... Startin\' to run low on spare parts.',26124),
(115894,'enUS','Just a bit more work and it\'ll be good as new.','Just a bit more work and it\'ll be good as new.',26124),
(115895,'enUS','So much for gettin\' this thing ready in a jiff... This one\'s a nightmare to fix!','So much for gettin\' this thing ready in a jiff... This one\'s a nightmare to fix!',26124),
(115896,'enUS','Knew I shoulda brought my other wrench. This one\'s gonna be a while.','Knew I shoulda brought my other wrench. This one\'s gonna be a while.',26124),
(115897,'enUS','Haha! So be it! Come, mortals, your death awaits!','',26124),
(115898,'enUS','Light take you, $g brother:sister;.','Light take you, $g brother:sister;.',26124),
(115899,'enUS','Let not your heart be troubled. I go now to make a place for you in the Light.','Let not your heart be troubled. I go now to make a place for you in the Light.',26124),
(115900,'enUS','Light watch over you, my fallen $g brother:sister;.','Light watch over you, my fallen $g brother:sister;.',26124),
(115901,'enUS','Let your wounds be cleansed. Go now safely into the Light.','Let your wounds be cleansed. Go now safely into the Light.',26124),
(115902,'enUS','This changes nothing... your world... will... burn!','',26124),
(115903,'enUS','I do not care what Sira says... if you want help from your champions while you\'re out there, they will come.','',26124),
(115904,'enUS','Be careful. The last place she was seen is near the Gates of Valor. Nasty place.','',26124),
(115905,'enUS','','You have learned well how to fight these creatures, but this will be only one of many battles.',26124),
(115906,'enUS','','This is Fu Zan. Take it. May it shield you in the dark times ahead.',26124),
(115907,'enUS','','Hurry, demon hunter. I do not like the look of that bonfire over there.',26124),
(115908,'enUS','Take me to the Legion invasion.','Take me to the Legion invasion.',26124),
(115909,'enUS','','Yes, the Grandmaster is here! Now these demons don\'t stand a chance!',26124),
(115910,'enUS','We can handle things here. Grandmaster, go south and join Chen and Aegira in the temple. They need your help more than we do!','',26124),
(115911,'enUS','|TInterface\\Icons\\inv_bannerpvp_02.blp:20|t You gain |cFFFF0000|Hspell:185265|h[For the Alliance]|h|r!','|TInterface\\Icons\\inv_bannerpvp_02.blp:20|t You gain |cFFFF0000|Hspell:185265|h[For the Alliance]|h|r!',26124),
(115912,'enUS','You honor me, $n. When we started all of this, I never would have imagined being chosen as one of your select few. I will not fail you.','',26124),
(115913,'enUS','','I have always been honored to be one of the Servants of Illidan. But, to officially become one of the Illidari... look away, $n, I think I might cry.',26124),
(115914,'enUS','','Let me assure you, $n, I will use everthing at my disposal, every bit of power within the Scythe of Souls, to track down the whereabouts of Caria and Varedis.',26124),
(115915,'enUS','Save us!','Save us!',26124),
(115916,'enUS','We won\'t go down without a fight!','We won\'t go down without a fight!',26124),
(115917,'enUS','They\'ve finally found us...','They\'ve finally found us...',26124),
(115918,'enUS','The Burning Legion are unrelenting.','The Burning Legion are unrelenting.',26124),
(115919,'enUS','Do you think my family is safe? I haven\'t seen them.','Do you think my family is safe? I haven\'t seen them.',26124),
(115920,'enUS','If the Prophet\'s barrier falls we are all doomed!','If the Prophet\'s barrier falls we are all doomed!',26124),
(115921,'enUS','Light help us!','Light help us!',26124),
(115922,'enUS','Is this the end?','Is this the end?',26124),
(115923,'enUS','Just south of Kharanos! Huge demon spotted in the skies! It\'s headin\' right fer us!','',26124),
(115924,'enUS','Huge demon in the skies! It\'s headed fer us at Kharanos! Send reinforcements!','',26124),
(115925,'enUS','Needin\' the help of a weaponsmith, $n? Hand me yer weapons. I\'ll see what I can do.','',26124),
(115926,'enUS','<Hand over your weapons.>','<Hand over your weapons.>',26124),
(115927,'enUS','Good as new. Be careful out there, $n.','',26124),
(115928,'enUS','','The Scythe of Souls tells me that it\'s jealous of you harvesting so many powerful spirits.',26124),
(115929,'enUS','Break your bodies upon the prophet\'s barrier, minions! Soon it shall fall, and with it the hopes of the draenei!','',26124),
(115930,'enUS','All we need are these last few parts from the other command centers. Otherwise, the Fel Hammer is ready to jump to Niskara.','',26124),
(115931,'enUS','That doesn\'t sound good at all. Sounds like something very big outside the Fel Hammer to the south.','',26124),
(115932,'enUS','Recruiting Allari and Jace as your champions is long overdue. They\'ve earned it.','',26124),
(115933,'enUS','Recruiting Allari and Jace as your champions is long overdue. They have earned it.','',26124),
(115934,'enUS','','Wretched creatures! You\'ve already stolen my life! What else do you wish to take from me?',26124),
(115935,'enUS','','We have been through so much together. Of course I accept!',26124),
(115936,'enUS','I stand ready to represent you and the Illidari. What\'s next, $n?','',26124),
(115937,'enUS','How would you like to improve the order hall?','How would you like to improve the order hall?',26124),
(115938,'enUS','You want a job done? I can get a job done.','',26124),
(115939,'enUS','Aeosera calls for her drakes to assault Needlerock!','',26124),
(115940,'enUS','Illidari! Servants of Illidan! Hear me!','',26124),
(115941,'enUS','Illidari! Servants of Illidan! Hear me!','',26124),
(115942,'enUS','We gather here today to pay tribute to one who has served with both honor and distinction as our indomitable leader.','',26124),
(115943,'enUS','We gather here today to pay tribute to one who has served with both honor and distinction as our indomitable leader.','',26124),
(115944,'enUS','We have regained the Sargerite Keystone. We have defied Kil\'jaeden and invaded a Legion world. And, we have vanquished our nemeses, Caria and Varedis Felsoul.','',26124),
(115945,'enUS','We have regained the Sargerite Keystone. We have defied Kil\'jaeden and invaded a Legion world. And, we have vanquished our nemeses, Caria and Varedis Felsoul.','',26124),
(115946,'enUS','For this and countless other successes, we bestow one of our highest honors, the title of Slayer upon $n.','',26124),
(115947,'enUS','For this and countless other successes, we bestow one of our highest honors, the title of Slayer upon $n.','',26124),
(115948,'enUS','|TInterface\\Icons\\Ability_Druid_ChallangingRoar:20|t%s is casting |cFFFF0000|Hspell:200580|h[Maddening Roar]|h|r. Stop Casting!','',26124),
(115949,'enUS','One of the sentries starts issuing a low alarm sound.','',26124),
(115950,'enUS','One of the sentries periodically issues a very insistent alarm.','',26124),
(115951,'enUS','As the demon falls, you hear the sounds of a larger lens sentry rise in the entry to this room.','',26124),
(115952,'enUS','The last lens submerges, and you hear the sharp rise and gentle hum of power coursing through the room.','',26124),
(115953,'enUS','The sentry absorbs the strange energy picked up from the cell, and the security measures of the room power down.','',26124),
(115954,'enUS','As the animus falls, the sentry that issued the alarm powers down.','',26124),
(115955,'enUS','The sentry starts humming with energy.','',26124),
(115956,'enUS','|TInterface\\Icons\\SPELL_DRUID_BEARHUG:20|t%s is casting |cFFFF0000|Hspell:198376|h[Primal Rampage]|h|r!','',26124),
(115957,'enUS','','The Vault is replete with magical safeguards. One such system may be found within the prison built for the demon Glazer.',26124),
(115958,'enUS','','Excellent work, that should keep the Vault\'s containment functioning until we can retake it. Now find and vanquish the traitor!',26124),
(115959,'enUS','','The other Wardens tell me that the third sublevel of our vault was hit particularly hard, and that some of its systems may soon lose power.',26124),
(115960,'enUS','','I want you to venture inside and complete an energy transfer procedure. The procedure is simple enough; but the security measures are severe.',26124),
(115961,'enUS','','Subtlety is not one of Warden Mirana\'s qualities.',26124),
(115962,'enUS','','Excellent work. Now find and defeat the traitor.',26124),
(115963,'enUS','','As quartermaster, it was my duty to issue and train all of the Wardens in the use of the Moonglaive.',26124),
(115964,'enUS','','With so few of us left, we need all the arms we can gather. Venture into the vault and recover the Moonglaives of our fallen sisters.',26124),
(115965,'enUS','','I\'ll know the warden who last held those Moonglaives by sight alone.  I issued and trained each one.',26124),
(115967,'enUS','','I suspect not all of the Felsworn managed to escape their prison. Normally I\'d leave prisoners to their fate, but a Demon Hunter left lurking in the dark is a danger far too great to let be.',26124),
(115968,'enUS','','Find a way into the Demon Hunter wing and deal with whatever remains in the shadows.',26124),
(115969,'enUS','','I shudder to think what would have become of the creature were it left to its fel subsistance.',26124),
(115970,'enUS','','Thanks to you we won\'t ever know. Now find the traitor, make her pay for what she has wrought.',26124),
(115971,'enUS','','I\'ve gotten reports that a particularly troublesome prisoner has nearly made their escape.  Thankfully one of the Vault\'s security measures has it trapped.',26124),
(115972,'enUS','','The field won\'t hold forever, of course. Head into the Vault and deal with the creature once and for all.',26124),
(115973,'enUS','','Well fought. Now, finish the traitor.',26124),
(115974,'enUS','When the Burning Legion arrived, they took much from us.','',26124),
(115975,'enUS','Many of us still grieve for our fallen friends. We long for the yesteryears of peace. And like you, I fear the dark days yet to come.','',26124),
(115976,'enUS','But today, is NOT that day.','',26124),
(115977,'enUS','Today, we celebrate the dawn of a new order! Today, we toast to friendship and fellowship!','',26124),
(115978,'enUS','Under the Grandmaster\'s leadership, let every day be a new dawn!','',26124),
(115979,'enUS','And let us never give up the fight for another tomorrow!','',26124),
(115980,'enUS','To the Grandmaster!','',26124),
(115981,'enUS','','To the Grandmaster!',26124),
(115982,'enUS','','To the Grandmaster!',26124),
(115983,'enUS','To the Grandmaster!','',26124),
(115984,'enUS','To the Broken Temple!','',26124),
(115985,'enUS','Broken Temple we toast! King loves this place most!','',26124),
(115986,'enUS','Yes, yes! Come closer, friend!$B$BI see you has nice things! What does friend need? Perhaps some trinkets do you well?','',26124),
(115987,'enUS','All right then, what do you have?','All right then, what do you have?',26124),
(115988,'enUS','Taming Aluneth will be no easy task. Take these scrolls. Aegwynn used them when she bound Aluneth to her will, perhaps you can do the same.','',26124),
(115989,'enUS','Your will be done, master!','',26124),
(115990,'enUS','Fear not $c, we will avenge the Broken Shore, and I will be right there with you when the day comes.','',26124),
(115991,'enUS','I would like to browse your goods.','I would like to browse your goods.',26124),
(115992,'enUS','','Fear not $c, we will avenge the Broken Shore, and I will be right there with you when the day comes.',26124),
(115993,'enUS','What you do, wikket? The brew\'s boiled over! It\'s ruined! Guess now we gotta start over!','',26124),
(115994,'enUS','Divinius, $ct $n has crushed the incursion. Now is the time to take the Chosen and finish off the leftover demonic taint within our halls. Secure the Exodar for our people once more!','',26124),
(115995,'enUS','Why are the other draenei trying to hurt us?','Why are the other draenei trying to hurt us?',26124),
(115996,'enUS','I want my papa!','I want my papa!',26124),
(115997,'enUS','Have you seen my mommy?','Have you seen my mommy?',26124),
(115998,'enUS','I was so scared! Those angry draenei are hurting everyone!','I was so scared! Those angry draenei are hurting everyone!',26124),
(115999,'enUS','Is it safe to go back?','Is it safe to go back?',26124),
(116000,'enUS','Thank you, $g mister:miss;.','Thank you, $g mister:miss;.',26124),
(116001,'enUS','','Defeat the demon, then complete the start up sequence to restore power to the vault.',26124),
(116002,'enUS','','Oh and... apologies for the sequence. Warden Malace is very fond of puzzles.',26124),
(116003,'enUS','If the Four Horsemen are to do battle against the might of the Burning Legion, they will need a leader.','',26124),
(116004,'enUS','One whose strength of spirit and loyalty to our world is without reproach.','',26124),
(116005,'enUS','And so, I have gathered you here today to bring such a leader into our fold.','',26124),
(116006,'enUS','Interred just beyond those walls is the body of Tirion Fordring, one of the greatest champions our world has known.','',26124),
(116007,'enUS','The Silver Hand will not give him to us willingly. So, we will take him by force!','',26124),
(116008,'enUS','We do what we must.','',26124),
(116009,'enUS','Deathlord, we will begin at your command.','',26124),
(116010,'enUS','The Stonemother sends her dragons. Take cover!','',26124),
(116011,'enUS','She has sent a surface-dweller to do her dirty work. Destroy the shaman!','',26124),
(116012,'enUS','The Legion claims this realm, shaman. The troggs serve or the troggs die. This we know.','',26124),
(116013,'enUS','Get out. Out! We will tell you nothing!','',26124),
(116014,'enUS','We saw the hammer fall from the sky. We know where it is.','',26124),
(116015,'enUS','We told the demon where to find it. Geth\'xun was his name.','',26124),
(116016,'enUS','You are too late, too late... Within the Crumbling Depths... The Legion has it by now...','',26124),
(116017,'enUS','Hello, $n. Anything that I can do for you? Latest scouting report or an update on Legion activity on Azeroth?','',26124),
(116018,'enUS','We\'re saved! Everyone to the Vault of Lights!','We\'re saved! Everyone to the Vault of Lights!',26124),
(116019,'enUS','The hero of the Exodar has cleared a path for us!','The hero of the Exodar has cleared a path for us!',26124),
(116020,'enUS','The time is now brothers and sisters! To the Vault of Lights!','The time is now brothers and sisters! To the Vault of Lights!',26124),
(116021,'enUS','We are saved!','We are saved!',26124),
(116022,'enUS','The Legion will make us great!','',26124),
(116023,'enUS','The trogg will rise again!','',26124),
(116024,'enUS','We serve the Legion now!','',26124),
(116025,'enUS','It is too late for me... I can only feel...','',26124),
(116026,'enUS','$n, I\'m glad Kor\'vas was able to find you quickly.','',26124),
(116027,'enUS','$n, we could use your help with a tactical decision.','',26124),
(116028,'enUS','It seems like yesterday that you and I stood in this very place, ready to destroy the Light in the name of the Lich King.$b$bToday we stand here, not to destroy... but to save this world from destruction.','',26124),
(116029,'enUS','I am ready to begin.','I am ready to begin.',26124),
(116030,'enUS','Grab a chain and help me!','',26124),
(116031,'enUS','Hang on, Thorim! These filthy demons are no match for us!','',26124),
(116032,'enUS','Magni snaps his fingers.','',26124),
(116033,'enUS','Let us test your knowledge of history, then! What is the highest rank that can be bestowed on a night elf Watcher?','',26124),
(116034,'enUS','Ranger-General.','Ranger-General.',26124),
(116035,'enUS','Keeper.','Keeper.',26124),
(116036,'enUS','Warden.','Warden.',26124),
(116037,'enUS','Sentinel.','Sentinel.',26124),
(116038,'enUS','Let us test your knowledge of history, then! Razormane and Bristleback are two feuding tribes of which race?','',26124),
(116039,'enUS','Quillboar.','Quillboar.',26124),
(116040,'enUS','Gnolls.','Gnolls.',26124),
(116041,'enUS','Saberon.','Saberon.',26124),
(116042,'enUS','Harpies.','Harpies.',26124),
(116043,'enUS','Let us test your knowledge of history, then! Who was the naga lieutenant of Illidan and once handmaiden of Queen Azshara?','',26124),
(116044,'enUS','Naz\'jar.','Naz\'jar.',26124),
(116045,'enUS','Vashj.','Vashj.',26124),
(116046,'enUS','Zhahara.','Zhahara.',26124),
(116047,'enUS','Valishj.','Valishj.',26124),
(116048,'enUS','Let us test your knowledge of history, then! What Pandaria creatures are the embodiments of negative emotions including doubt, despair, and anger?','',26124),
(116049,'enUS','Mantid.','Mantid.',26124),
(116050,'enUS','Virmen.','Virmen.',26124),
(116051,'enUS','Hozen.','Hozen.',26124),
(116052,'enUS','Sha.','Sha.',26124),
(116053,'enUS','Let us test your knowledge of history, then! Before succumbing to magical addiction, the Wretched were once members of which race?','',26124),
(116054,'enUS','Blood Elves.','Blood Elves.',26124),
(116055,'enUS','Humans.','Humans.',26124),
(116056,'enUS','Night Elves.','Night Elves.',26124),
(116057,'enUS','Forsaken.','Forsaken.',26124),
(116058,'enUS','Let us test your knowledge of history, then! What dragon appears in the Human guise of Lord Victor Nefarius?','',26124),
(116059,'enUS','Sabellian.','Sabellian.',26124),
(116060,'enUS','Itharius.','Itharius.',26124),
(116061,'enUS','Nefarian.','Nefarian.',26124),
(116062,'enUS','Sapphiron.','Sapphiron.',26124),
(116063,'enUS','Let us test your knowledge of history, then! What are the final words from this Headless Horseman quote: \"It is over, your search is done! Let fate choose now, ...\"','',26124),
(116064,'enUS','\"the mighty one!\"','\"the mighty one!\"',26124),
(116065,'enUS','\"the rightful one!\"','\"the rightful one!\"',26124),
(116066,'enUS','\"the righteous one!\"','\"the righteous one!\"',26124),
(116067,'enUS','Let nothing stand in your way!','',26124),
(116068,'enUS','\"the delightful one!\"','\"the delightful one!\"',26124),
(116069,'enUS','Let us test your knowledge of history, then! What is a Grummle\'s most prized personal possession?','',26124),
(116070,'enUS','A Backpack.','A Backpack.',26124),
(116071,'enUS','A Yak.','A Yak.',26124),
(116072,'enUS','A Luckydo.','A Luckydo.',26124),
(116073,'enUS','A Luckydont.','A Luckydont.',26124),
(116074,'enUS','Let us test your knowledge of history, then! Bloodfeather, Windfury and Witchwing are all types of which race?','',26124),
(116075,'enUS','Harpy.','Harpy.',26124),
(116076,'enUS','Arakkoa.','Arakkoa.',26124),
(116077,'enUS','Kaliri.','Kaliri.',26124),
(116078,'enUS','Hippogryph.','Hippogryph.',26124),
(116079,'enUS','Let us test your knowledge of history, then! What is the name of the desert that surrounds the Caverns of Time?','',26124),
(116080,'enUS','Uldum.','Uldum.',26124),
(116081,'enUS','Tanaris.','Tanaris.',26124),
(116082,'enUS','Silithus.','Silithus.',26124),
(116083,'enUS','Desolace.','Desolace.',26124),
(116084,'enUS','Let us test your knowledge of history, then! What area was reshaped by Goblins to resemble the symbol of the Horde?','',26124),
(116085,'enUS','Azshara.','Azshara.',26124),
(116086,'enUS','Kezan.','Kezan.',26124),
(116087,'enUS','Durotar.','Durotar.',26124),
(116088,'enUS','Mulgore.','Mulgore.',26124),
(116089,'enUS','Let us test your knowledge of history, then! Which of the following is not an Orc clan?','',26124),
(116090,'enUS','Frostwolf.','Frostwolf.',26124),
(116091,'enUS','Warsong.','Warsong.',26124),
(116092,'enUS','Bloodfang.','Bloodfang.',26124),
(116093,'enUS','Dragonmaw.','Dragonmaw.',26124),
(116094,'enUS','Let us test your knowledge of history, then! Which night elf was appointed the jailor of Illidan Stormrage?','',26124),
(116095,'enUS','Jarod Shadowsong.','Jarod Shadowsong.',26124),
(116096,'enUS','Malfurion Stormrage.','Malfurion Stormrage.',26124),
(116097,'enUS','Maiev Shadowsong.','Maiev Shadowsong.',26124),
(116098,'enUS','Califax.','Califax.',26124),
(116099,'enUS','Let us test your knowledge of history, then! What was the name of the once benevolent spiritual leader in Stormwind City that sided with Deathwing?','',26124),
(116100,'enUS','Benedictus.','Benedictus.',26124),
(116101,'enUS','Katherine the Pure.','Katherine the Pure.',26124),
(116102,'enUS','Grayson Shadowbreaker.','Grayson Shadowbreaker.',26124),
(116103,'enUS','Arthur the Faithful.','Arthur the Faithful.',26124),
(116104,'enUS','Let us test your knowledge of history, then! King Krush, King Mosh, and King Dred are all what type of creature?','',26124),
(116105,'enUS','Gorilla.','Gorilla.',26124),
(116106,'enUS','Devilsaur.','Devilsaur.',26124),
(116107,'enUS','Colossi.','Colossi.',26124),
(116108,'enUS','Ogre.','Ogre.',26124),
(116109,'enUS','Let us test your knowledge of history, then! What is the name of the bridge that connects the Arathi Highlands and the Wetlands?','',26124),
(116110,'enUS','Severed Span.','Severed Span.',26124),
(116111,'enUS','Dawning Span.','Dawning Span.',26124),
(116112,'enUS','Sulfuron Span.','Sulfuron Span.',26124),
(116113,'enUS','Thandol Span.','Thandol Span.',26124),
(116114,'enUS','','You are fierce for one so small, dwarf. What happened here?',26124),
(116115,'enUS','Fight first, talk later!','',26124),
(116116,'enUS','Let us test your knowledge of history, then! Before the Cataclysm, where could the remains of Mankrik\'s wife be found?','',26124),
(116117,'enUS','Thousand Needles.','Thousand Needles.',26124),
(116118,'enUS','Durotar.','Durotar.',26124),
(116119,'enUS','Mulgore.','Mulgore.',26124),
(116120,'enUS','The Barrens.','The Barrens.',26124),
(116121,'enUS','Let us test your knowledge of history, then! Who was Jaina Proudmoore\'s mentor in the Kirin Tor?','',26124),
(116122,'enUS','Archmage Antonidas.','Archmage Antonidas.',26124),
(116123,'enUS','Archmage Khadgar.','Archmage Khadgar.',26124),
(116124,'enUS','Archmage Modera.','Archmage Modera.',26124),
(116125,'enUS','Archmage Kel\'Thuzad.','Archmage Kel\'Thuzad.',26124),
(116126,'enUS','Let us test your knowledge of history, then! Where was Dalaran originally located in the Eastern Kingdoms?','',26124),
(116127,'enUS','Arathi Highlands.','Arathi Highlands.',26124),
(116128,'enUS','Silverpine Forest.','Silverpine Forest.',26124),
(116129,'enUS','Hillsbrad Foothills.','Hillsbrad Foothills.',26124),
(116130,'enUS','Tirisfal Glades.','Tirisfal Glades.',26124),
(116131,'enUS','Let us test your knowledge of history, then! Who became the Lich King after Arthas was defeated?','',26124),
(116132,'enUS','Tirion Fordring.','Tirion Fordring.',26124),
(116133,'enUS','Bolvar Fordragon.','Bolvar Fordragon.',26124),
(116134,'enUS','Darion Morgraine.','Darion Morgraine.',26124),
(116135,'enUS','Terenas Menethil II.','Terenas Menethil II.',26124),
(116136,'enUS','Let us test your knowledge of history, then! Which paladin was not among the five when the Silver Hand was originally created?','',26124),
(116137,'enUS','Uther.','Uther.',26124),
(116138,'enUS','Alexandros.','Alexandros.',26124),
(116139,'enUS','Gavinrad.','Gavinrad.',26124),
(116140,'enUS','Saidan.','Saidan.',26124),
(116141,'enUS','Let us test your knowledge of history, then! What pit lord was the ruler of Outland before being imprisoned by Illidan Stormrage?','',26124),
(116142,'enUS','','Ah, my hero returns!',26124),
(116143,'enUS','Azgalor.','Azgalor.',26124),
(116144,'enUS','Brutallus.','Brutallus.',26124),
(116145,'enUS','Mannoroth.','Mannoroth.',26124),
(116146,'enUS','Magtheridon.','Magtheridon.',26124),
(116147,'enUS','The shaman at the Temple of Earth know nothing.','',26124),
(116148,'enUS','Let us test your knowledge of history, then! Who became Ragnaros\' second Majordomo, protecting the entrance of Sulfuron Keep in the Firelands?','',26124),
(116149,'enUS','Majordomo Staghelm.','Majordomo Staghelm.',26124),
(116150,'enUS','Majordomo Executus.','Majordomo Executus.',26124),
(116151,'enUS','','Stonehearth is missing some prospectors, but they don\'t have any ideas.',26124),
(116152,'enUS','Majordomo Beth\'tilac.','Majordomo Beth\'tilac.',26124),
(116153,'enUS','Majordomo Shannox.','Majordomo Shannox.',26124),
(116154,'enUS','Let us test your knowledge of history, then! Which apothecary cannot be found in Shadowfang Keep during the Love is in the Air event?','',26124),
(116155,'enUS','Frye.','Frye.',26124),
(116156,'enUS','','Go now, retrieve your weapon and slay the demon filth that seek it.',26124),
(116157,'enUS','Baxter.','Baxter.',26124),
(116158,'enUS','Copeland.','Copeland.',26124),
(116159,'enUS','Hummel.','Hummel.',26124),
(116160,'enUS','Let us test your knowledge of history, then! What Goblin trading company is known for plundering the natural resources of Azeroth?','',26124),
(116161,'enUS','Blackwater Raiders.','Blackwater Raiders.',26124),
(116162,'enUS','Venture Company.','Venture Company.',26124),
(116163,'enUS','Kajaro Trading Company.','Kajaro Trading Company.',26124),
(116164,'enUS','','Clean up your mess, flesh-children, and stop throwing your garbage down into my realm!',26124),
(116165,'enUS','Smokeywood Pastures.','Smokeywood Pastures.',26124),
(116166,'enUS','Look out! Greenies comin\' fast! Grook \'em! Make this day their last!','',26124),
(116167,'enUS','Let us test your knowledge of history, then! What was the name of the Human that kept Thrall as a slave in Durnholde Keep?','',26124),
(116168,'enUS','Aiden Perenolde.','Aiden Perenolde.',26124),
(116169,'enUS','Galen Trollbane.','Galen Trollbane.',26124),
(116170,'enUS','Daval Prestor.','Daval Prestor.',26124),
(116171,'enUS','Aedelas Blackmoore.','Aedelas Blackmoore.',26124),
(116172,'enUS','Let us test your knowledge of history, then! Which Orc was responsible for opening numerous portals on Draenor and shattering the Orc homeworld?','',26124),
(116173,'enUS','Ner\'zhul.','Ner\'zhul.',26124),
(116174,'enUS','Gul\'dan.','Gul\'dan.',26124),
(116175,'enUS','Skartax.','Skartax.',26124),
(116176,'enUS','Grieve.','Grieve.',26124),
(116177,'enUS','Let us test your knowledge of history, then! The Night Elves and the dragonflights stood against the armies of the Qiraji in what war?','',26124),
(116178,'enUS','War of the Ancients.','War of the Ancients.',26124),
(116179,'enUS','War of the Satyr.','War of the Satyr.',26124),
(116180,'enUS','War of the Shifting Sands.','War of the Shifting Sands.',26124),
(116181,'enUS','War of the Spider.','War of the Spider.',26124),
(116182,'enUS','Let us test your knowledge of history, then! Cro Threadstrong continually threatened what specific type of vendor in Shattrath City?','',26124),
(116183,'enUS','Bag Vendor.','Bag Vendor.',26124),
(116184,'enUS','Fruit Vendor.','Fruit Vendor.',26124),
(116185,'enUS','Reagent Vendor.','Reagent Vendor.',26124),
(116186,'enUS','Weapon Vendor.','Weapon Vendor.',26124),
(116187,'enUS','Let us test your knowledge of history, then! Who was the first to leave pandaria on the back of the sea turtle, Shen-zin Su?','',26124),
(116188,'enUS','Shaohao.','Shaohao.',26124),
(116189,'enUS','Shinizi.','Shinizi.',26124),
(116190,'enUS','Li Li Stormstout.','Li Li Stormstout.',26124),
(116191,'enUS','Liu Lang.','Liu Lang.',26124),
(116192,'enUS','Let us test your knowledge of history, then! Who was the brother of Varok Saurfang and the only Orc to fight in the War of the Ancients?','',26124),
(116193,'enUS','Broxigar.','Broxigar.',26124),
(116194,'enUS','Eitrigg.','Eitrigg.',26124),
(116195,'enUS','Dranosh Saurfang.','Dranosh Saurfang.',26124),
(116196,'enUS','Drek\'Thar.','Drek\'Thar.',26124),
(116197,'enUS','Let us test your knowledge of history, then! What was the name of the Human who helped Thrall escape his imprisonment in Durnholde Keep?','',26124),
(116198,'enUS','Karramyn Langston.','Karramyn Langston.',26124),
(116199,'enUS','Arthas Menethil.','Arthas Menethil.',26124),
(116200,'enUS','Jaina Proudmoore.','Jaina Proudmoore.',26124),
(116201,'enUS','Taretha Foxton.','Taretha Foxton.',26124),
(116202,'enUS','Wooo-hoo, wikket, that\'s the way! Grooked the greenies, saved the day!','',26124),
(116203,'enUS','I do not wish to shed blood, but the paladins of the Silver Hand will not cooperate.','',26124),
(116204,'enUS','We must avoid direct confrontation if at all possible.','',26124),
(116205,'enUS','There is a tomb behind the chapel where the power of the Light is weak.','',26124),
(116206,'enUS','Raise the dead from within the tomb and it will distract the guards long enough for us to make our way to the chapel.','',26124),
(116207,'enUS','Let us test your knowledge of history, then! Which Alliance city located in Darkshore was destroyed by Deathwing\'s return?','',26124),
(116208,'enUS','Lor\'danel.','Lor\'danel.',26124),
(116209,'enUS','Ameth\'Aran.','Ameth\'Aran.',26124),
(116210,'enUS','Auberdine.','Auberdine.',26124),
(116211,'enUS','Grove of the Ancients.','Grove of the Ancients.',26124),
(116212,'enUS','Let us test your knowledge of history, then! Which of the following is not a possible result from drinking a Noggenfogger Elixer?','',26124),
(116213,'enUS','The weapon\'s blessin\' don\'t come free. With courage face your destiny!','',26124),
(116214,'enUS','Shrink.','Shrink.',26124),
(116215,'enUS','Become Skeletal.','Become Skeletal.',26124),
(116216,'enUS','Slow Fall.','Slow Fall.',26124),
(116217,'enUS','You breathe fire.','You breathe fire.',26124),
(116218,'enUS','Let us test your knowledge of history, then! Which musical trinket could be used to invoke spontaneous dancing in others against their will?','',26124),
(116219,'enUS','Piccolo of the Flaming Fire.','Piccolo of the Flaming Fire.',26124),
(116220,'enUS','Sun-Lute of the Phoenix King.','Sun-Lute of the Phoenix King.',26124),
(116221,'enUS','Haunted War Drum.','Haunted War Drum.',26124),
(116222,'enUS','Flute of the Ancients.','Flute of the Ancients.',26124),
(116223,'enUS','Let us test your knowledge of history, then! Which arm and which eye did Zul\'jin lose during his captivity and eventual escape?','',26124),
(116224,'enUS','Right eye; left arm.','Right eye; left arm.',26124),
(116225,'enUS','Left eye; left arm.','Left eye; left arm.',26124),
(116226,'enUS','Right eye; right arm.','Right eye; right arm.',26124),
(116227,'enUS','Left eye; right arm.','Left eye; right arm.',26124),
(116228,'enUS','Let us test your knowledge of history, then! What phrase means \"Safe journey\" in the language of the draenei?','',26124),
(116229,'enUS','Achal hecta.','Achal hecta.',26124),
(116230,'enUS','Dioniss aca.','Dioniss aca.',26124),
(116231,'enUS','Acheon kor.','Acheon kor.',26124),
(116232,'enUS','Heckt corta.','Heckt corta.',26124),
(116233,'enUS','Many thanks, hero. You must hurry to the Vault of Lights. The Prophet awaits your arrival!','Many thanks, hero. You must hurry to the Vault of Lights. The Prophet awaits your arrival!',26124),
(116234,'enUS','We will keep our monstrous brethren occupied, please hurry to the Vault of Lights! Our people need you!','We will keep our monstrous brethren occupied, please hurry to the Vault of Lights! Our people need you!',26124),
(116235,'enUS','Quickly, hero, to the Vault of Lights!','Quickly, hero, to the Vault of Lights!',26124),
(116236,'enUS','The Prophet is holding off the entire invasion at the Vault of Lights! He needs assistance!','The Prophet is holding off the entire invasion at the Vault of Lights! He needs assistance!',26124),
(116237,'enUS','All together, now! Pull!','',26124),
(116238,'enUS','I don\'t know how much longer the Prophet can keep the barrier up. Time is of the essence!','I don\'t know how much longer the Prophet can keep the barrier up. Time is of the essence!',26124),
(116239,'enUS','','Put your back into it!',26124),
(116240,'enUS','We... Can... Do... This!','',26124),
(116241,'enUS','','What beautiful chaos! Let\'s rifle the pockets of a few guards. Bet we uncover some cultists in disguise!',26124),
(116242,'enUS','Let us test your knowledge of history, then! What is the name of the mate of Har\'koa?','',26124),
(116243,'enUS','Loque\'nahak.','Loque\'nahak.',26124),
(116244,'enUS','Shirvallah.','Shirvallah.',26124),
(116245,'enUS','Magria.','Magria.',26124),
(116246,'enUS','Ankha.','Ankha.',26124),
(116247,'enUS','Let us test your knowledge of history, then! What is the name of the red dragon whose skull is on display in the Hall of Explorers?','',26124),
(116248,'enUS','Vaelastrasz.','Vaelastrasz.',26124),
(116249,'enUS','Afrasastrasz.','Afrasastrasz.',26124),
(116250,'enUS','Caelestrasz.','Caelestrasz.',26124),
(116251,'enUS','Tyranastrasz.','Tyranastrasz.',26124),
(116252,'enUS','Let us test your knowledge of history, then! What was the name of the first pandaren to ever tame a cloud serpent?','',26124),
(116253,'enUS','Jiang.','Jiang.',26124),
(116254,'enUS','Suchi.','Suchi.',26124),
(116256,'enUS','Anli.','Anli.',26124),
(116257,'enUS','You fight bravely for a mortal.','',26124),
(116258,'enUS','Toudu.','Toudu.',26124),
(116259,'enUS','You are not the help I expected. Still, I owe you my thanks.','',26124),
(116260,'enUS','Let us test your knowledge of history, then! In Zandali, the language of the trolls, what does \"atal\'ai\" mean?','',26124),
(116261,'enUS','The Faithful.','The Faithful.',26124),
(116262,'enUS','Doting Ones.','Doting Ones.',26124),
(116263,'enUS','I did not expect a mortal to fight so fiercely. I thank you.','',26124),
(116264,'enUS','The Chosen.','The Chosen.',26124),
(116265,'enUS','Devoted Ones.','Devoted Ones.',26124),
(116266,'enUS','I came to help you and Thorim. Where is he?','I came to help you and Thorim. Where is he?',26124),
(116267,'enUS','Let us test your knowledge of history, then! This cult was affiliated with the orcish Shadow Council and included members such as Nagaz and Marez Cowl.','',26124),
(116268,'enUS','Burning Blade.','Burning Blade.',26124),
(116269,'enUS','Sargerei.','Sargerei.',26124),
(116270,'enUS','Argus Wake.','Argus Wake.',26124),
(116271,'enUS','The Cabal.','The Cabal.',26124),
(116272,'enUS','Let us test your knowledge of history, then! Which son of an Alliance traitor would one day become a leader of the Syndicate?','',26124),
(116273,'enUS','Isiden.','Isiden.',26124),
(116274,'enUS','This way.  Follow me!','',26124),
(116275,'enUS','Aiden.','Aiden.',26124),
(116276,'enUS','Aedelas.','Aedelas.',26124),
(116277,'enUS','Aliden.','Aliden.',26124),
(116278,'enUS','We have no time to lose!','',26124),
(116279,'enUS','They are waiting for you in the tavern.','',26124),
(116280,'enUS','Of course. I agree that this whole business is... distasteful. Even still, the sort of influence you would have...','',26124),
(116281,'enUS','','There is a reason we live on the opposite side of the city, my friend.',26124),
(116282,'enUS','','I could change much for our people... yes...',26124),
(116283,'enUS','A hammer and a demon fell from the sky...','',26124),
(116284,'enUS','We saw the hammer fall.','',26124),
(116285,'enUS','The demon warned us they would come for the hammer...','',26124),
(116286,'enUS','The shaman from the world above seeks the hammer!','',26124),
(116287,'enUS','The demon warned us! Stop the shaman!','',26124),
(116288,'enUS','A demon came to us. We had to obey.','',26124),
(116289,'enUS','We must protect the hammer!','',26124),
(116290,'enUS','Say nothing to the shaman.','',26124),
(116291,'enUS','','Thank you, hero. I would have been that monster\'s next meal!',26124),
(116292,'enUS','Without history, there would be no future.','',26124),
(116293,'enUS','Unleash the Twinblades and destroy the interloper!','',26124),
(116295,'enUS','Always a pleasure. Do things my way and she\'ll be advisor before dinner.','',26124),
(116301,'enUS','','Brothers and sisters, we meet tonight at the Pig and Whistle. The Herald awaits!',26124),
(116302,'enUS','','So the cultists are meeting at the Pig and Whistle. Let\'s move! The Herald is within our grasp...',26124),
(116303,'enUS','','Another group! They can\'t keep coming forever... can they?',26124),
(116304,'enUS','Remember this place, Brann?','',26124),
(116305,'enUS','Good day, Grandmaster. May the spirits be with you this day.','',26124),
(116306,'enUS','Beautiful day for a drink, don\'t you think Grandmaster?','',26124),
(116307,'enUS','Hello Grandmaster. I hope you are in good spirits today.','',26124),
(116308,'enUS','After all this is over, I would like to keep traveling. Grandmaster, where should I go?','',26124),
(116309,'enUS','Good day to you, Grandmaster. Is there anything I can help with?','',26124),
(116310,'enUS','Grandmaster, have you seen Li Li? She is late for training again.','',26124),
(116311,'enUS','Karazhan! Of course. I likely read of these artifacts in one of Medivh\'s ancient chronicles.','',26124),
(116312,'enUS','','Are you ready to return to Shen-zin Su?',26124),
(116313,'enUS','','No! Sisters.... avenge.... me!',26124),
(116314,'enUS','You... are here to help? This place is overrun! The others are in D-Block, if any are left! I must rest...','I thought I was done for. This place is overrun! The rest are at D Block, if anyone is left! I must rest...',26124),
(116315,'enUS','Chen and Li Li are strong allies for our order, and I know just how we can use them.','',26124),
(116316,'enUS','','Normally it takes some time to train new troops, but I put a rush on this one for you, Grandmaster.',26124),
(116317,'enUS','','Excellent choice, Grandmaster. I will be happy to research any additional improvements to the order hall for you.',26124),
(116318,'enUS','Speak to Tak-Tak to the west. He will take you to Tian Monastery immediately.','',26124),
(116319,'enUS','Our champions might be able to follow our enemy\'s movements. I only hope we can find my students... before it\'s too late.','',26124),
(116320,'enUS','','Bring me some leather, and I will gladly trade you my Amaranthine Hops.',26124),
(116321,'enUS','At the very least, our champions can distract the Legion attack force long enough for us to prepare defenses here on the island. Let us hope it does not come to that.','',26124),
(116322,'enUS','Hurry, Grandmaster! The battle rages on the ridge above us. You\'d better join them quickly!','',26124),
(116323,'enUS','This is not over... Illidari.','',26124),
(116324,'enUS','I have no need for mortal armaments!','',26124),
(116325,'enUS','Right there above the scouting map should do nicely.','',26124),
(116326,'enUS','Lets see what we can come up with.','',26124),
(116327,'enUS','Ah, yes. This looks exquisite. Such detail on the dust coming off of its wings. It is sure to delight.','',26124),
(116328,'enUS','Yes, this will do quite nicely. The horn looks very realistic.','',26124),
(116329,'enUS','Hmm. I will need to work on this one. The plumage flares out entirely too much.','',26124),
(116330,'enUS','What shall I review now?','',26124),
(116331,'enUS','How about this illusion?','',26124),
(116332,'enUS','Hey, keep it down out there! We\'re trying to have a party!','Hey, keep it down out there! We\'re trying to have a party!',26124),
(116333,'enUS','What... What happened?','What... What happened?',26124),
(116334,'enUS','I... I can\'t remember nothin\'...','I... I can\'t remember nothin\'...',26124),
(116335,'enUS','Me thoughts... it heard me thoughts!','Me thoughts... it heard me thoughts!',26124),
(116336,'enUS','What am I doin\' here?','What am I doin\' here?',26124),
(116337,'enUS','I wouldn\'t just attack ye fer no reason! What\'s goin\' on?','Me thoughts... it heard me thoughts!',26124),
(116338,'enUS','If that thing can do that ta me, who knows what else they can do!','If that thing can do that ta me, who knows what else they can do!',26124),
(116339,'enUS','I thought I\'d seen it all... but that thing... Get out of here! Go!','I thought I\'d seen it all... but that thing... Get out of here! Go!',26124),
(116340,'enUS','My illusions will be your end!','',26124),
(116341,'enUS','The illusion... is broken.','',26124),
(116342,'enUS','These heroes have struck a mighty blow to the invaders! Go now, with my blessing, and dispense the Light\'s judgment on any demons that remain and secure safe passage for the rest of our people!','',26124),
(116343,'enUS','I am capable of fending for myself, Divinius; but there are many still alive outside this barrier that need your help! Waste no more time!','',26124),
(116344,'enUS','Tread carefully, Death Knight. This is holy ground and we have little tolerance for your kind.','',26124),
(116345,'enUS','The Illidari are prepared to serve.','The Illidari are prepared to serve.',26124),
(116346,'enUS','We, the Broken, salute you.','We, the Broken, salute you.',26124),
(116347,'enUS','One of your withered is running away! Catch him!','One of your withered is running away! Catch him!',26124),
(116348,'enUS','Such delicious elven flesh!','',26124),
(116349,'enUS','Race through the Ley Line nodes to collect energy!','Race through the Ley Line nodes to collect energy!',26124),
(116350,'enUS','Insolent orc! You should have awaited my arrival!','',26124),
(116351,'enUS','Pathetic.','',26124),
(116352,'enUS','Having collected enough energy, the Ley Lines die down.','Having collected enough energy, the Ley Lines die down.',26124),
(116353,'enUS','Find Timirgos using your newfound powers of Claivoyance.','Find Timirgos using your newfound powers of Claivoyance.',26124),
(116354,'enUS','You sense that Timirgos is far to the north.','You sense that Timirgos is far to the north.',26124),
(116355,'enUS','You sense that Timirgos is far to the east.','You sense that Timirgos is far to the east.',26124),
(116356,'enUS','You sense that Timirgos is far to the south.','You sense that Timirgos is far to the south.',26124),
(116357,'enUS','I had things well in hand. Those fools were weak! We are better off without them!','',26124),
(116358,'enUS','You sense that Timirgos is far to the west.','You sense that Timirgos is far to the west.',26124),
(116359,'enUS','You sense that Timirgos is nearby, north of your current location.','You sense that Timirgos is nearby, north of your current location.',26124),
(116360,'enUS','You sense that Timirgos is nearby, northeast of your current location.','You sense that Timirgos is nearby, northeast of your current location.',26124),
(116361,'enUS','You sense that Timirgos is nearby, east of your current location.','You sense that Timirgos is nearby, east of your current location.',26124),
(116362,'enUS','You sense that Timirgos is nearby, southeast of your current location.','You sense that Timirgos is nearby, southeast of your current location.',26124),
(116363,'enUS','You sense that Timirgos is nearby, south of your current location.','You sense that Timirgos is nearby, south of your current location.',26124),
(116364,'enUS','You sense that Timirgos is nearby, southwest of your current location.','You sense that Timirgos is nearby, southwest of your current location.',26124),
(116365,'enUS','You sense that Timirgos is nearby, west of your current location.','You sense that Timirgos is nearby, west of your current location.',26124),
(116366,'enUS','You sense that Timirgos is nearby, northwest of your current location.','You sense that Timirgos is nearby, northwest of your current location.',26124),
(116367,'enUS','You sense that Timirgos is very close, just north of your current location.','You sense that Timirgos is very close, just north of your current location.',26124),
(116368,'enUS','You sense that Timirgos is very close, just northeast of your current location.','You sense that Timirgos is very close, just northeast of your current location.',26124),
(116369,'enUS','You sense that Timirgos is very close, just east of your current location.','You sense that Timirgos is very close, just east of your current location.',26124),
(116370,'enUS','Give me! Give me!','',26124),
(116371,'enUS','You sense that Timirgos is very close, just southeast of your current location.','You sense that Timirgos is very close, just southeast of your current location.',26124),
(116372,'enUS','You sense that Timirgos is very close, just south of your current location.','You sense that Timirgos is very close, just south of your current location.',26124),
(116373,'enUS','You sense that Timirgos is very close, just southwest of your current location.','You sense that Timirgos is very close, just southwest of your current location.',26124),
(116374,'enUS','You sense that Timirgos is very close, just west of your current location.','You sense that Timirgos is very close, just west of your current location.',26124),
(116375,'enUS','You sense that Timirgos is very close, just northwest of your current location.','You sense that Timirgos is very close, just northwest of your current location.',26124),
(116376,'enUS','You\'ve found Timirgos!','You\'ve found Timirgos!',26124),
(116377,'enUS','Yarlyn\'s here with me. Where\'ve they taken Rudra? And what\'ve they done to me rams? Go, $n! Get far away from \'ere!','',26124),
(116378,'enUS','Clear \'em out, $n. Do what ye can do. When me wounds are patched up I\'ll be back. Ye can count on that!','',26124),
(116379,'enUS','','Please, $n - get the rest of \'em! Poor Veron and Yarlyn! I don\'t know where they\'ve been taken!',26124),
(116380,'enUS','','Wow, you sure are brave! Thanks for helping us!',26124),
(116381,'enUS','Ah, reinforcements at last. You have the Book of Medivh? I expected Jergosh, but you will do. Still, your timing could have been better.','',26124),
(116382,'enUS','Jergosh and the others didn\'t make it? How... convenient.','',26124),
(116383,'enUS','It matters not. Gul\'dan knows the Eye is here, but Tol Barad is huge and overrun. I believe an important document, a manifest of prisoners, is located in this block.','',26124),
(116384,'enUS','Well done, Valarjar.','',26124),
(116385,'enUS','In his infinite wisdom, Nagaz here sent his only remaining disciple to scout below. I suggest you find out what happened to him while we search elsewhere.','',26124),
(116386,'enUS','Fight on, Valarjar.','',26124),
(116387,'enUS','Hmmph... I saw Tyranis go off to the right before I was forced to retreat.','',26124),
(116388,'enUS','Yo, buddy! I\'ve got some information for ya!','',26124),
(116389,'enUS','Now, we never talked, got it?','',26124),
(116390,'enUS','|TInterface\\Icons\\ability_paladin_blindinglight2:20|t Lafayla begins to cast |cFFFF0404|Hspell:219075|h[Dazzling Light]|h|r Look away!','|TInterface\\Icons\\ability_paladin_blindinglight2:20|t Lafayla begins to cast |cFFFF0404|Hspell:219075|h[Dazzling Light]|h|r Look away!',26124),
(116391,'enUS','You there! Aid me! But carefully, or it will pull you in, too!','',26124),
(116392,'enUS','You... aren\'t you some sort of hero? Why are you helping the Shadow Cou-- nevermind! Pull me out! I will vouch for you, I swear!','',26124),
(116393,'enUS','What are you doing there? Help me!','',26124),
(116394,'enUS','I... I will serve you! My family has many heirlooms and treasures! They\'re all yours! YOURS!','',26124),
(116395,'enUS','What are you...  NOOOOoooo...','',26124),
(116396,'enUS','Still with me, little mortal? Good.','',26124),
(116397,'enUS','Another huge demon headin\' fer Kharanos! Come too far ta lose it now!','',26124),
(116398,'enUS','Thorim! Odyn has sent his champions to aid us.','',26124),
(116399,'enUS','They keep coming!  Crush one and another takes its place. I will try to stem the flow. The passage to the north leads up to the balcony, $n. Assist Thorim!','',26124),
(116400,'enUS','','Behold but a fragment of the Aldrachi!',26124),
(116401,'enUS','A mortal? Leading Odyn\'s army?! Has my father lost his mind!','',26124),
(116402,'enUS','You\'ll be surprised.  This mortal slays demons as swiftly as Fenryr hunts wild deer!','',26124),
(116403,'enUS','I shall be the judge of that.  Plenty of demons up here... let us see if Odyn chose well!','',26124),
(116404,'enUS','Worthy battle, champion.','',26124),
(116405,'enUS','Blood and glory.','',26124),
(116406,'enUS','You have earned your place, warrior.','',26124),
(116407,'enUS','You made it! Alive, even!','',26124),
(116408,'enUS','Send me back home, Oculeth.','Send me back home, Oculeth.',26124),
(116409,'enUS','... unless you want some fins out your back for the rest of your life.','',26124),
(116410,'enUS','Don\'t listen to Brian. Go ahead, touch it. I want to see what really happens.','',26124),
(116411,'enUS','','An ancient spirit, long dormant, has been awakened by the Legion\'s return. Nylaathria\'s evil must be purged from our land! Find the ruin she haunts and end her.',26124),
(116412,'enUS','','An ancient spirit, long dormant, has been awakened by the Legion\'s return. Nylaathria\'s evil must be purged from our land! Find the ruin she haunts and end her.',26124),
(116415,'enUS','Keep back! Don\'t go near that pearl!','',26124),
(116416,'enUS','|TInterface\\Icons\\Ability_Warlock_EverlastingAffliction:20|tArchimonde has cast |cFFFF0000|Hspell:219143|h[Shadowfel Burst]|h|ron you! Move to a Pool of Grace!','|TInterface\\Icons\\Ability_Warlock_EverlastingAffliction:20|tArchimonde has cast |cFFFF0000|Hspell:219143|h[Shadowfel Burst]|h|ron you! Move to a Pool of Grace!',26124),
(116417,'enUS','','|TInterface\\Icons\\spell_warlock_demonicportal_purple.blp:20|t%s begins to cast |cFFFF0000|Hspell:219112|h[Shadow Gale]|h|r!',26124),
(116418,'enUS','','Peace...',26124),
(116419,'enUS','','Finally, we rest.',26124),
(116420,'enUS','','What has become of us?',26124),
(116421,'enUS','','Our people... shu dalees-na.',26124),
(116422,'enUS','','I will rest now.',26124),
(116423,'enUS','','The Magistrix... stop her...',26124),
(116424,'enUS','','Feel the chill of the grave!',26124),
(116425,'enUS','','You will be cold... like us.',26124),
(116426,'enUS','','Desecrator...',26124),
(116427,'enUS','','Trespasser...',26124),
(116428,'enUS','','Thandae-alah...',26124),
(116429,'enUS','Im... impossible.','It\'s no use!',26124),
(116430,'enUS','The shal\'dorei will rule this world!','The Nightborne will rule this world!',26124),
(116431,'enUS','Arash-falas...','Arash-falas...',26124),
(116432,'enUS','Tor\'theras falar!','Tor\'theras falar!',26124),
(116433,'enUS','My magic... defeated?','Forgive me... Elisande.',26124),
(116434,'enUS','This cannot be...','Inconceivable...',26124),
(116435,'enUS','Let me see what I can... dig up...','Let me see what I can... dig up...',26124),
(116436,'enUS','Careful! Don\'t touch that pearl!','',26124),
(116437,'enUS','Chopping','Chopping',26124),
(116438,'enUS','Don\'t worry about us, just clear out these Naga!','',26124),
(116439,'enUS','The Ebon order is at your command.','The Ebon order is at your command.',26124),
(116440,'enUS','I will hear no more of your scheming! You endanger everything our father worked for!','',26124),
(116441,'enUS','Hmph... Someone will notice I am missing! They will come looking for me!','',26124),
(116442,'enUS','She wants to preach her traitorous ideals to me further? Fine. Let us go.','',26124),
(116443,'enUS','Just... finish me off.','',26124),
(116444,'enUS','Ngh! Who ARE you?!','',26124),
(116445,'enUS','You have come to help Ly\'leth destroy our family! Be gone!','',26124),
(116446,'enUS','Get away from there!','',26124),
(116447,'enUS','It\'s so shiny. I couldn\'t help myself.','',26124),
(116448,'enUS','','Thas\'dorah... I have not seen it in years! That\'s a Windrunner family heirloom you have slung across your back.',26124),
(116449,'enUS','','My mother passed it down to my eldest sister. May it bring you better fortune than it did her.',26124),
(116450,'enUS','','If you won\'t serve the Queen, then you will die!',26124),
(116451,'enUS','','If you won\'t serve the Queen, then you will die!',26124),
(116452,'enUS','','Peer into my pearl, landwalker!',26124),
(116453,'enUS','','Your destiny lies within my pearl, $R!',26124),
(116454,'enUS','','Remember, $n, that Thas\'dorah represents my family\'s legacy... MY legacy. The deeds you perform while wielding it reflect upon me.',26124),
(116455,'enUS','','It is fitting that the bow be in the hands of so skilled a marksman. I trust you will remain worthy of it. Do not disappoint me.',26124),
(116456,'enUS','Found Tyranis too late, did you? Pity...','',26124),
(116457,'enUS','Anyway, follow me! There\'s something over here I... need your help with.','',26124),
(116458,'enUS','I\'ll have that book now... and you\'ll be having a little \"accident\"!','',26124),
(116459,'enUS','I should be... the one... at Gul\'dan\'s side...','',26124),
(116460,'enUS','The people of Thunder Totem welcome the wielder of Talonclaw!','The people of Thunder Totem welcome the wielder of Talonclaw!',26124),
(116461,'enUS','Feel my wrath, fiends!','',26124),
(116462,'enUS','','Vanessa gives you a final look and then walks off.',26124),
(116463,'enUS','I\'m done training the withered for today.','I\'m done training the withered for today.',26124),
(116465,'enUS','','We came as soon as we were able! Thank the Light that you are safe, prophet!',26124),
(116466,'enUS','','As you command, Prophet!',26124),
(116467,'enUS','','There is a myth, a fable, that is whispered of in dark corners and back alleys.',26124),
(116468,'enUS','','Surely everyone here has at one time or another heard the tale of the Raven\'s Eye?',26124),
(116469,'enUS','The others look incredulously at Valeera. Disbelief clearly painted on their faces. Unsurprised, Valeera continues on with her tale.','The others look incredulously at Valeera. Disbelief clearly painted on their faces. Unsurprised, Valeera continues on with her tale.',26124),
(116470,'enUS','','It is of a jewel so powerful that no one believes it exists. But I assure you, it does.',26124),
(116471,'enUS','','The legend is that the gem conveys the power to read any language, follow any map, and most importantly, to decipher any code.',26124),
(116472,'enUS','','But more to the point, the Raven\'s Eye will give us the means to unlock the secrets hidden in the SI:7 letter. And, we know where it is.',26124),
(116473,'enUS','A merry yarn! But that\'s all she be. The Raven\'s Eye don\'t exist. It never did. It just be some ol\' wives\' tale to scare little rogues who are wantin\' to keep their secrets hidden.','',26124),
(116474,'enUS','','Exactly right. We are talking about the end of secrets. Well, other people\'s secrets anyway.',26124),
(116475,'enUS','','Lord Kur\'talos Ravencrest stole the eye from the vrykul millennia ago. His lieutenant\'s used it during the War of the Ancients.',26124),
(116476,'enUS','The winds swirl in a new direction, adjust your aim to compensate.','The winds swirl in a new direction, adjust your aim to compensate.',26124),
(116477,'enUS','Thank you for your interest in visiting the Assembly of Iron and the Archivum!','',26124),
(116478,'enUS','Thank you for your interest in visiting the Observation Ring!','',26124),
(116479,'enUS','Currently both facilities are closed for cleaning and routine maintenance. Please call again on a future date.','',26124),
(116480,'enUS','Have a pleasant stay in Ulduar!','',26124),
(116481,'enUS','Unfortunately, the walkway is undergoing structural evaluation and is presently inaccessible. We regret any inconvenience this may cause.','',26124),
(116482,'enUS','Enjoy your stay in Ulduar! Please remember to fill out a Visitor Satisfaction Survey prior to departing.','',26124),
(116483,'enUS','The Legion will conquer this world!','',26124),
(116484,'enUS','Came up empty? No Nagaz either, I see. Not to worry, we all know how the lower echelons of our group scramble for position. Enough nonsense. What we seek is here!','',26124),
(116485,'enUS','Congratulations, you\'ve successfully navigated the maze!','Congratulations, you\'ve successfully navigated the maze!',26124),
(116486,'enUS','I can sense... unrest nearby. Let us investigate. Come along!','',26124),
(116487,'enUS','There! The unquiet dead bar our path. Get that spirit out of my way, will you?','',26124),
(116488,'enUS','Oops! You\'ve stepped off of the path!','Oops! You\'ve stepped off of the path!',26124),
(116489,'enUS','Hmm... yes, I see. This entry clearly speaks of a void terror. It must have consumed the Eye in the Twisting Nether. Its purpose here is irrelevant. Quickly, let us get to Baradin Hold!','',26124),
(116490,'enUS','You have destroyed most of the fel portals, greatly hindering Rakeesh\'s ability to bring in reinforcements. Focus your attention on finding survivors now!','',26124),
(116491,'enUS','Thanks to you, most of our people have returned safely to the Vault of Lights! The time has come to focus your attention on the remaining fel portals and end Rakeesh\'s incursion!','',26124),
(116492,'enUS','Follow the path to the end of the maze.','Follow the path to the end of the maze.',26124),
(116493,'enUS','The seas be calling!','The seas be calling!',26124),
(116494,'enUS','We work in the shadows.','We work in the shadows.',26124),
(116495,'enUS','','There\'s a few potions and supplies left about. Do what you must to remove the threat!',26124),
(116496,'enUS','This is no place for a tradesman!','',26124),
(116497,'enUS','Thanks. I left some fresh cuts lying about, but I should get going. I\'m afraid those things would butcher me alive.','',26124),
(116498,'enUS','','Show them we\'re not giving up Tarren Mill without a fight!',26124),
(116499,'enUS','','This place is a haunted tomb. Let us not stay here any longer than is necessary.',26124),
(116500,'enUS','Rise up, $n! Fight beside Helcular to bring down this Legion threat! Show them the true power of a $c!','',26124),
(116501,'enUS','Avoid taking any damage for as long as you can while staying inside the field.  Good Luck!','Avoid taking any damage for as long as you can while staying inside the field.  Good Luck!',26124),
(116502,'enUS','','I am going to look into something. In the meantime, let us make certain that SI:7 does not catch on to what we are really up to.',26124),
(116503,'enUS','I can control it no longer. You must drown!','',26124),
(116504,'enUS','','I do not know how you are going to get onto the Naglfar... the vrykul ship of the dead. But, if we are to confirm my suspicions about the item, you are going to have to find a way to do so. Preferably without dying if you can manage it.',26124),
(116505,'enUS','','I will see you at Ravencourt. Make certain that you are not followed.',26124),
(116506,'enUS','In the name of the Dark Lady, rise and defend against the Burning Legion!','',26124),
(116507,'enUS','','This place is crawling. See if you can find the eye. I will cover you from here.',26124),
(116508,'enUS','Apologies. I\'m not much for fighting, but I\'m sure Craig and Hans will be more than helpful.','',26124),
(116509,'enUS','Walk in the moonlight.','Walk in starlight.',26124),
(116510,'enUS','Walk in the moonlight.','',26124),
(116511,'enUS','I... will go home. I have no business among such esteemed individuals.','',26124),
(116512,'enUS','I accept your gratitude, by the way!','',26124),
(116513,'enUS','I like the way you think, Lunastre.','',26124),
(116514,'enUS','','You are not the only one with a nose for politics.',26124),
(116515,'enUS','','I humbly accept this appointment. It is an honor beyond words.',26124),
(116516,'enUS','','Yes. I understand. Just be careful. We\'re running out of room here.',26124),
(116517,'enUS','Filthy backstabbing cretin! That title should have been mine!','',26124),
(116518,'enUS','You impinge upon my honor! You besmirch my name with baseless accusations!','',26124),
(116519,'enUS','','My lord, you have lost your sense of decorum. It is already decided.',26124),
(116520,'enUS','Ash\'thoras denil.','',26124),
(116521,'enUS','Your star fades!','',26124),
(116522,'enUS','Let us hope this ends swiftly.','',26124),
(116524,'enUS','I will reclaim my honor! I invoke the ancient rite- Tal\'ashar!','',26124),
(116526,'enUS','I have 10 drowned mana for you.','I have 10 drowned mana for you.',26124),
(116527,'enUS','Looks like you caught some drowned mana? I can take that off your hands...','Looks like you caught some drowned mana? I can take that off your hands...',26124),
(116528,'enUS','This is not what I signed up for.','',26124),
(116529,'enUS','Horde! Fan out! Today we focus our attacks against the Legion. We\'ll deal with the Alliance scum when this is through.','',26124),
(116530,'enUS','Fishing? ...Really?!','',26124),
(116531,'enUS','Take me with you.  Please!','',26124),
(116532,'enUS','I will wrestle my title from your champion\'s lifeless hands, Ly\'leth!','',26124),
(116533,'enUS','You cannot match me! I am your better!','',26124),
(116534,'enUS','I will have what is owed me!','',26124),
(116535,'enUS','I was... framed...','',26124),
(116536,'enUS','A challenger? Don\'t make me laugh!','',26124),
(116537,'enUS','The Legion brings us power unending!','',26124),
(116538,'enUS','Kneel before the might of the shal\'dorei!','',26124),
(116539,'enUS','I will not be defeated by the likes of you!','',26124),
(116540,'enUS','They... promised...','',26124),
(116542,'enUS','It will be easier for me to travel on the road.','It will be easier for me to travel on the road.',26124),
(116544,'enUS','Are you lost?','',26124),
(116545,'enUS','Menagerie\'s that way.','',26124),
(116546,'enUS','State your business.','',26124),
(116547,'enUS','Move along.','',26124),
(116548,'enUS','Watch your back.','',26124),
(116549,'enUS','Don\'t linger. You\'ll regret it.','',26124),
(116550,'enUS','I don\'t give tours. The vineyards are across town.','',26124),
(116551,'enUS','My time isn\'t free.','',26124),
(116552,'enUS','Do you see anyone else hanging around? No? Why do you think that is?','',26124),
(116553,'enUS','','Hi...',26124),
(116554,'enUS','','Hello?',26124),
(116555,'enUS','','Bye.',26124),
(116556,'enUS','','Bye-bye.',26124),
(116557,'enUS','','Go away.',26124),
(116558,'enUS','','No!',26124),
(116559,'enUS','','I don\'t like your face!',26124),
(116560,'enUS','','It is a great honor to look after the vineyard.',26124),
(116561,'enUS','','Are you enjoying your stay?',26124),
(116562,'enUS','','We craft only the finest wines.',26124),
(116563,'enUS','','Thank you for your visit!',26124),
(116564,'enUS','','I hope you enjoyed yourself.',26124),
(116565,'enUS','','Come again soon!',26124),
(116566,'enUS','','Yes, I am ordinarily this cheerful. No, I will not scold you.',26124),
(116567,'enUS','','I certainly hope this is enjoyable for you. I am having the BEST time.',26124),
(116568,'enUS','','I can keep this up all day you know.',26124),
(116569,'enUS','Welcome.','',26124),
(116570,'enUS','Relax. Have a beverage.','',26124),
(116571,'enUS','You need only alert me to your needs.','',26124),
(116572,'enUS','It was my pleasure.','',26124),
(116573,'enUS','Farewell.','',26124),
(116574,'enUS','If you wish to complain, my master Margaux will happily field your concerns.','',26124),
(116575,'enUS','The menagerie is for guest--- Ahem. The vineyard is for guests only.','',26124),
(116581,'enUS','What do you require of the Guard?','',26124),
(116582,'enUS','We stand watch over Suramar.','',26124),
(116583,'enUS','Hello.','',26124),
(116584,'enUS','Our vigil has ended, but I remain.','',26124),
(116585,'enUS','Goodbye.','',26124),
(116586,'enUS','I will remain, if you should have need of me again.','',26124),
(116587,'enUS','Your timing is impeccable.','',26124),
(116588,'enUS','Behold the plight of the Moon Guard.','',26124),
(116589,'enUS','Are you here to help us?','',26124),
(116590,'enUS','I will defend this place to my last.','',26124),
(116591,'enUS','My home may be in ruins, but I will remain strong.','',26124),
(116592,'enUS','The Moon Guard will soon be no more.','',26124),
(116593,'enUS','','Our demise came without warning.',26124),
(116594,'enUS','','The Moon Guard will soon be no more.',26124),
(116595,'enUS','','It is my duty to guard this keep to the end.',26124),
(116596,'enUS','','I will remain.',26124),
(116597,'enUS','','We are beaten. Only memory remains.',26124),
(116598,'enUS','','Farewell.',26124),
(116599,'enUS','This place is home to the finest vintages.','',26124),
(116600,'enUS','Only the best will reach Elisande\'s glass.','',26124),
(116601,'enUS','No flavor escapes my notice.','',26124),
(116602,'enUS','Happy sipping!','',26124),
(116603,'enUS','Enjoy.','',26124),
(116604,'enUS','I sense you are... overwhelmed by my expertise.','',26124),
(116605,'enUS','A savant yourself, I can guess. A very likely story.','',26124),
(116606,'enUS','I am willing to bet a mountain of gold that you taste vinegar in all that you drink. Plebian.','',26124),
(116607,'enUS','Ishnu-alah.','',26124),
(116608,'enUS','It is not our forest, but we will adapt.','',26124),
(116609,'enUS','Hello.','',26124),
(116610,'enUS','Until we meet again.','',26124),
(116611,'enUS','Until another day.','',26124),
(116612,'enUS','','Elune-adore.',26124),
(116613,'enUS','','Elune\'s light guide you.',26124),
(116614,'enUS','','Greetings from the temple, friend.',26124),
(116615,'enUS','','Her light shines here, too.',26124),
(116616,'enUS','','Val\'Sharah\'s fate is not Suramar\'s fate. I am sure of it.',26124),
(116617,'enUS','','Until we meet again.',26124),
(116618,'enUS','','Ishnu-alah!',26124),
(116619,'enUS','','Greetings.',26124),
(116620,'enUS','','Onward and upward!',26124),
(116621,'enUS','','It\'s always sunny in Suramar.',26124),
(116622,'enUS','','It\'s not Val\'Sharah, but it will do.',26124),
(116623,'enUS','','Safe travels, friend.',26124),
(116624,'enUS','The shal\'dorei are... chosen...','',26124),
(116625,'enUS','Welcome to the refuge.','',26124),
(116626,'enUS','Do you require aid?','',26124),
(116627,'enUS','Make yourself at home. We certainly are.','',26124),
(116628,'enUS','Mind the locals.','',26124),
(116629,'enUS','Farewell.','',26124),
(116630,'enUS','Goodbye.','',26124),
(116637,'enUS','I cannot be stopped!','Aaargh!',26124),
(116638,'enUS','I have failed...','We cannot stop them!',26124),
(116639,'enUS','The defenses are breached...','Our enemies will fall!',26124),
(116640,'enUS','Ugh. I must find a physician!','Ugh. I must find a physician!',26124),
(116641,'enUS','This fruit is horrible...','This fruit is horrible...',26124),
(116642,'enUS','Ugh, what is happening?','Ugh, what is happening?',26124),
(116643,'enUS','I feel unwell...','I feel unwell...',26124),
(116644,'enUS','Ugh. I must find a physician!','',26124),
(116645,'enUS','This fruit is horrible...','',26124),
(116646,'enUS','Ugh, what is happening?','',26124),
(116647,'enUS','I feel unwell...','',26124),
(116648,'enUS','Ugh. I must find a physician!','Ugh. I must find a physician!',26124),
(116649,'enUS','This fruit is horrible...','This fruit is horrible...',26124),
(116650,'enUS','Ugh, what is happening?','Ugh, what is happening?',26124),
(116651,'enUS','I feel unwell...','I feel unwell...',26124),
(116652,'enUS','Ugh. I must find a physician!','Ugh. I must find a physician!',26124),
(116653,'enUS','This fruit is horrible...','This fruit is horrible...',26124),
(116654,'enUS','Ugh, what is happening?','Ugh, what is happening?',26124),
(116655,'enUS','I feel unwell...','I feel unwell...',26124),
(116656,'enUS','Ugh. I must find a physician!','',26124),
(116657,'enUS','This fruit is horrible...','',26124),
(116658,'enUS','Ugh, what is happening?','',26124),
(116659,'enUS','I feel unwell...','',26124),
(116660,'enUS','We must hold them here!','You cannot harm us!',26124),
(116661,'enUS','For Suramar! For Elisande!','For the shal\'dorei!',26124),
(116662,'enUS','Begone, fiends!','You shall not pass!',26124),
(116663,'enUS','You cannot harm us!','We must hold them here!',26124),
(116664,'enUS','For the shal\'dorei!','For Suramar!',26124),
(116665,'enUS','Begone, wretches!','Begone, fiends!',26124),
(116666,'enUS','We must protect our lands!','We must protect our lands!',26124),
(116667,'enUS','For Suramar!','For Suramar! For Elisande!',26124),
(116668,'enUS','You shall not pass!','Begone, wretches!',26124),
(116669,'enUS','We must protect our lands!','',26124),
(116670,'enUS','For Suramar!','',26124),
(116671,'enUS','You shall not pass!','',26124),
(116672,'enUS','You cannot harm us!','',26124),
(116673,'enUS','For the shal\'dorei!','',26124),
(116674,'enUS','Begone, wretches!','',26124),
(116675,'enUS','Your fate is sealed!','',26124),
(116676,'enUS','Feel the might of the shal\'dorei!','',26124),
(116677,'enUS','Now is the age of the shal\'dorei!','',26124),
(116678,'enUS','I shall dispose of you, lowborn!','',26124),
(116679,'enUS','We are chosen to rule!','',26124),
(116680,'enUS','No mercy for outlanders!','',26124),
(116681,'enUS','Anath\'ashar!','',26124),
(116682,'enUS','Your death is certain!','',26124),
(116683,'enUS','Tremble before our strength!','',26124),
(116684,'enUS','Your star is fading!','',26124),
(116685,'enUS','Lowborn scum!','',26124),
(116686,'enUS','You will bow to us!','',26124),
(116687,'enUS','None may challenge us!','',26124),
(116688,'enUS','Anath\'ashar!','',26124),
(116689,'enUS','Your fate is sealed!','Your death is certain!',26124),
(116690,'enUS','Feel the might of the shal\'dorei!','Feel the might of the shal\'dorei!',26124),
(116691,'enUS','Now is the age of the shal\'dorei!','Your age has ended!',26124),
(116692,'enUS','I shall dispose of you, lowborn!','Lowborn scum!',26124),
(116693,'enUS','We are chosen to rule!','You will bow to us!',26124),
(116694,'enUS','No mercy for outlanders!','Die, outlander!',26124),
(116695,'enUS','Anath\'ashar!','Anath\'ashar!',26124),
(116696,'enUS','Your death is certain!','Your death is fated!',26124),
(116697,'enUS','Tremble before our strength!','Tremble before our strength!',26124),
(116698,'enUS','Your star is fading!','Your star is fading!',26124),
(116699,'enUS','Lowborn scum!','Scum like you should obey your betters.',26124),
(116700,'enUS','You will bow to us!','The shal\'dorei will rule!',26124),
(116701,'enUS','None may challenge us!','No mercy for outlanders!',26124),
(116702,'enUS','Anath\'ashar!','Anath\'ashar!',26124),
(116703,'enUS','Your death is fated!','Your fate is sealed!',26124),
(116704,'enUS','Our magic will break you!','Our magic will break you!',26124),
(116705,'enUS','Your age has ended!','Now is the age of the shal\'dorei!',26124),
(116706,'enUS','Scum like you should obey your betters.','I shall dispose of you, lowborn!',26124),
(116707,'enUS','The shal\'dorei will rule!','We are chosen to rule!',26124),
(116708,'enUS','Die, outlander!','None may challenge us!',26124),
(116709,'enUS','Anath\'ashar!','Anath\'ashar!',26124),
(116710,'enUS','The shal\'dorei are... chosen...','We are... the chosen ones...',26124),
(116711,'enUS','Do you have the nightmare sample?','Do you have the nightmare sample?',26124),
(116712,'enUS','No... this isn\'t right! Destroy the malevolent seedling before it escapes!','',26124),
(116713,'enUS','Go to Archdruid Greathoof and tell him what transpired. I\'ll examine what\'s left of this thing.','',26124),
(116714,'enUS','You dare disturb my rest, demon?!','',26124),
(116715,'enUS','Tell Valeera we are watching over her.','',26124),
(116716,'enUS','','Why, you\'re no demon at all!',26124),
(116717,'enUS','','Come, brothers, the Burning Legion attacks!',26124),
(116718,'enUS','Die, Felsworn traitor!','',26124),
(116719,'enUS','Once again, I am at peace.','',26124),
(116720,'enUS','You hear the gentle swirling of water.','You hear the gentle swirling of water.',26124),
(116721,'enUS','You sense that Timirgos is mesmerized by some bright light.','You sense that Timirgos is mesmerized by some bright light.',26124),
(116722,'enUS','There are ancient ruins nearby; but you have the distinct feeling of loneliness.','There are ancient ruins nearby; but you have the distinct feeling of loneliness.',26124),
(116723,'enUS','You sense the presence of creatures long since cursed to hold a new form.','You sense the presence of creatures long since cursed to hold a new form.',26124),
(116724,'enUS','You get the sense of being above everything.','You get the sense of being above everything.',26124),
(116725,'enUS','You hear leaves rustling in the wind.','You hear leaves rustling in the wind.',26124),
(116726,'enUS','You smell the gentle fragrance of flowers in the sun.','You smell the gentle fragrance of flowers in the sun.',26124),
(116727,'enUS','You hear feathers flapping, hooves stomping, and claws scraping.','You hear feathers flapping, hooves stomping, and claws scraping.',26124),
(116728,'enUS','You faintly hear water running down.','You faintly hear water running down.',26124),
(116729,'enUS','You feel a sense of safety from above.','You feel a sense of safety from above.',26124),
(116730,'enUS','You sense an image of graceful creatures strutting about.','You sense an image of graceful creatures strutting about.',26124),
(116731,'enUS','You wonder if ghosts can truly be friendly.','You wonder if ghosts can truly be friendly.',26124),
(116732,'enUS','You sense an image of darkness.','You sense an image of darkness.',26124),
(116733,'enUS','You smell dank and dark earth.','You smell dank and dark earth.',26124),
(116734,'enUS','You feel the ground shake around you.','You feel the ground shake around you.',26124),
(116735,'enUS','You hear the crackling of a small fire.','You hear the crackling of a small fire.',26124),
(116736,'enUS','You feel like you\'re among friends.','You feel like you\'re among friends.',26124),
(116737,'enUS','You sense an image of the moon.','You sense an image of the moon.',26124),
(116738,'enUS','You hear a large waterfall nearby.','You hear a large waterfall nearby.',26124),
(116739,'enUS','You feel revulsion and pity for these creatures.','You feel revulsion and pity for these creatures.',26124),
(116740,'enUS','There are such pretty crystals here!','There are such pretty crystals here!',26124),
(116741,'enUS','You feel ley energy all around you.','You feel ley energy all around you.',26124),
(116742,'enUS','You feel a tear in the fabric of magic nearby.','You feel a tear in the fabric of magic nearby.',26124),
(116743,'enUS','You get the feeling of buildings towering above you.','You get the feeling of buildings towering above you.',26124),
(116744,'enUS','These crystals are HUGE!','These crystals are HUGE!',26124),
(116745,'enUS','You feel at home.','You feel at home.',26124),
(116746,'enUS','There are so many friends here to play with!','There are so many friends here to play with!',26124),
(116747,'enUS','You sense a large pool of ley energy nearby.','You sense a large pool of ley energy nearby.',26124),
(116753,'enUS','Elisande, I have failed you...','',26124),
(116754,'enUS','We cannot stop them!','',26124),
(116755,'enUS','Our enemies will fall!','',26124),
(116756,'enUS','I cannot lose to a lowborn!','',26124),
(116757,'enUS','Inconceivable...','',26124),
(116758,'enUS','We have... failed.','',26124),
(116759,'enUS','Tor\'theras falar!','',26124),
(116760,'enUS','Arash-falas...','',26124),
(116761,'enUS','','Helcular! It\'s been a while.',26124),
(116762,'enUS','The Nightborne will rule this world!','',26124),
(116763,'enUS','It\'s no use!','',26124),
(116764,'enUS','Aaargh!','',26124),
(116765,'enUS','We will... endure...','',26124),
(116766,'enUS','We cannot be stopped...','',26124),
(116767,'enUS','We are... the chosen ones...','',26124),
(116768,'enUS','No! It is not my time....','',26124),
(116769,'enUS','Forgive me... Elisande.','',26124),
(116770,'enUS','Tor\'theras falar!','',26124),
(116771,'enUS','Arash-falas...','',26124),
(116772,'enUS','Aargh!','',26124),
(116773,'enUS','It is hopeless to resist...','',26124),
(116774,'enUS','Aaargh!','Elisande, I have failed you...',26124),
(116775,'enUS','We will... endure...','I have failed...',26124),
(116776,'enUS','We cannot be stopped...','The defenses are breached...',26124),
(116777,'enUS','We are... the chosen ones...','I cannot lose to a lowborn!',26124),
(116778,'enUS','No! It is not my time....','This cannot be...',26124),
(116779,'enUS','Forgive me... Elisande.','We have... failed.',26124),
(116780,'enUS','Tor\'theras falar!','Tor\'theras falar!',26124),
(116781,'enUS','Arash-falas...','Arash-falas...',26124),
(116782,'enUS','Aargh!','Aargh!',26124),
(116783,'enUS','It is hopeless to resist...','Im... impossible.',26124),
(116784,'enUS','Elisande, I have failed you...','I cannot be stopped!',26124),
(116785,'enUS','We cannot stop them!','We will... endure...',26124),
(116786,'enUS','Our enemies will fall!','We cannot be stopped...',26124),
(116787,'enUS','I cannot lose to a lowborn!','The shal\'dorei are... chosen...',26124),
(116788,'enUS','Inconceivable...','No! It is not my time....',26124),
(116789,'enUS','We have... failed.','My magic... defeated?',26124),
(116790,'enUS','Tor\'theras falar!','Tor\'theras falar!',26124),
(116791,'enUS','Arash-falas...','Arash-falas...',26124),
(116792,'enUS','The Nightborne will rule this world!','The shal\'dorei will rule this world!',26124),
(116793,'enUS','It\'s no use!','It is hopeless to resist...',26124),
(116798,'enUS','Die, vermin!','',26124),
(116799,'enUS','You defile this temple with your presence, demon!','',26124),
(116800,'enUS','For Ulduar!','',26124),
(116801,'enUS','You do not belong here, demon. Get out!','',26124),
(116802,'enUS','You will regret this!','',26124),
(116803,'enUS','Hang on, Hodir! I brought help. These filthy demons are no match for us!','',26124),
(116804,'enUS','A mortal leads the armies of Skyhold?  Blasphemy!','',26124),
(116805,'enUS','Greetings.','',26124),
(116806,'enUS','What do you wish of me?','',26124),
(116807,'enUS','We will rebuild the world.','',26124),
(116808,'enUS','','This is no ordinary mortal. $n was chosen by Odyn himself!',26124),
(116809,'enUS','Tenu\'balah.','',26124),
(116810,'enUS','Stop it! Spare no expense!','Stop it! Spare no expense!',26124),
(116811,'enUS','The shal\'dorei are eternal.','',26124),
(116812,'enUS','Come now, I have things to do.','',26124),
(116813,'enUS','Why do you insist on pestering me?','',26124),
(116814,'enUS','Move along!','',26124),
(116815,'enUS','Are you sure you\'re not a Night-bore?','',26124),
(116816,'enUS','Our era has come.','Our age is now!',26124),
(116817,'enUS','The Nightborne shall reign.','The Nightborne shall reign.',26124),
(116818,'enUS','Kal\'theros maldin.','Kal\'theros maldin.',26124),
(116819,'enUS','Nor\'bethos Suramar.','',26124),
(116820,'enUS','Be well.','',26124),
(116821,'enUS','Please help me, $n. My young friend Timirgos has gone missing somewhere in the area.','',26124),
(116822,'enUS','I\'ll cast an enchantment on you that will give you clairvoyant powers for a short time. Use your newfound abilities to find Timirgos.','',26124),
(116823,'enUS','Thank you so much, $n!','',26124),
(116824,'enUS','Night guide you.','Elisande guide you.',26124),
(116825,'enUS','Elisande guide you.','Stars guide you.',26124),
(116826,'enUS','Be well.','Fare well.',26124),
(116827,'enUS','Nor\'bethos Suramar.','Nor\'bethos Suramar.',26124),
(116828,'enUS','Kal\'theros maldin.','Kal\'theros maldin.',26124),
(116829,'enUS','We rejoin the world.','The shal\'dorei shall rise.',26124),
(116830,'enUS','We shall endure.','Our era has come.',26124),
(116831,'enUS','My goods are exquisite.','',26124),
(116832,'enUS','Take a look, I sell all manner of wares.','',26124),
(116833,'enUS','What is your pleasure?','',26124),
(116834,'enUS','You will not find a better bargain!','',26124),
(116835,'enUS','Do come again.','',26124),
(116836,'enUS','Pleasure doing business.','',26124),
(116837,'enUS','What is your pleasure?','What is your pleasure?',26124),
(116838,'enUS','Pleasure doing business.','Pleasure doing business.',26124),
(116839,'enUS','Take a look, I sell all manner of wares.','Take a look, I sell all manner of wares.',26124),
(116840,'enUS','Do come again.','Do come again.',26124),
(116841,'enUS','My goods are exquisite.','My goods are exquisite.',26124),
(116842,'enUS','You will not find a better bargain!','You will not find a better bargain!',26124),
(116843,'enUS','The shal\'dorei are eternal.','We have hidden too long.',26124),
(116844,'enUS','Ishnal to\'reth.','Ishnal to\'reth.',26124),
(116845,'enUS','Tenu\'balah.','Tenu\'balah.',26124),
(116846,'enUS','We will rebuild the world.','Our destiny is at hand.',26124),
(116847,'enUS','What do you wish of me?','You wish to speak?',26124),
(116848,'enUS','Greetings.','Greetings.',26124),
(116849,'enUS','Ash\'thoras denil.','Ash\'thoras denil.',26124),
(116850,'enUS','We see the stars once more.','',26124),
(116851,'enUS','The Nightborne are eternal.','',26124),
(116852,'enUS','Tenu\'balah.','',26124),
(116853,'enUS','Ishnal to\'reth.','',26124),
(116854,'enUS','You wish to speak?','',26124),
(116855,'enUS','Greetings.','',26124),
(116856,'enUS','Ash\'thoras denil.','',26124),
(116857,'enUS','We see the stars once more.','The shal\'dorei are eternal.',26124),
(116858,'enUS','The Nightborne are eternal.','The Nightborne are eternal.',26124),
(116859,'enUS','Tenu\'balah.','Tenu\'balah.',26124),
(116860,'enUS','Ishnal to\'reth.','We will rebuild the world.',26124),
(116861,'enUS','You wish to speak?','What is your wish?',26124),
(116862,'enUS','Greetings.','Greetings.',26124),
(116863,'enUS','Ash\'thoras denil.','Ash\'thoras denil.',26124),
(116864,'enUS','We are eternal.','',26124),
(116865,'enUS','Suramar ascends.','',26124),
(116866,'enUS','Tenu\'balah.','',26124),
(116867,'enUS','Wisdom to Elisande.','',26124),
(116868,'enUS','May I help you?','',26124),
(116869,'enUS','Greetings.','',26124),
(116870,'enUS','Ash\'thoras denil.','',26124),
(116871,'enUS','We are eternal.','We are eternal.',26124),
(116873,'enUS','Tenu\'balah.','Tenu\'balah.',26124),
(116874,'enUS','Wisdom to Elisande.','Suramar ascends.',26124),
(116875,'enUS','May I help you?','What do you wish of me?',26124),
(116876,'enUS','Greetings.','Greetings.',26124),
(116877,'enUS','Ash\'thoras denil.','Ash\'thoras denil.',26124),
(116878,'enUS','We no longer hide.','',26124),
(116879,'enUS','Nightwell nourish us.','',26124),
(116880,'enUS','Tenu\'balah.','',26124),
(116881,'enUS','Our destiny is at hand.','',26124),
(116882,'enUS','What is your wish?','',26124),
(116883,'enUS','Greetings.','',26124),
(116884,'enUS','Ash\'thoras denil.','',26124),
(116885,'enUS','Hurry!','',26124),
(116886,'enUS','We no longer hide.','We see the stars once more.',26124),
(116887,'enUS','Nightwell nourish us.','Nightwell nourish us.',26124),
(116888,'enUS','Tenu\'balah.','Tenu\'balah.',26124),
(116889,'enUS','Our destiny is at hand.','Wisdom to Elisande.',26124),
(116890,'enUS','What is your wish?','May I help you?',26124),
(116891,'enUS','Greetings.','Greetings.',26124),
(116892,'enUS','Ash\'thoras denil.','Ash\'thoras denil.',26124),
(116893,'enUS','Stars guide you.','',26124),
(116894,'enUS','These times are troubling. Watch your back.','',26124),
(116895,'enUS','Nor\'bethos Suramar.','',26124),
(116896,'enUS','Kal\'theros maldin.','',26124),
(116897,'enUS','The shal\'dorei shall rise.','',26124),
(116898,'enUS','Our age is now!','',26124),
(116899,'enUS','Well\'s gift be with you.','',26124),
(116900,'enUS','Stars guide you.','By Night\'s grace.',26124),
(116901,'enUS','Move along.','Safe travels.',26124),
(116902,'enUS','Nor\'bethos Suramar.','Nor\'bethos Suramar.',26124),
(116903,'enUS','','Your world will be ourss!',26124),
(116904,'enUS','Kal\'theros maldin.','Kal\'theros maldin.',26124),
(116905,'enUS','The shal\'dorei shall rise.','The shal\'dorei have returned.',26124),
(116906,'enUS','Our age is now!','This is our age now.',26124),
(116907,'enUS','Well\'s gift be with you.','Travel in starlight, friend.',26124),
(116908,'enUS','Elisande guide you.','',26124),
(116909,'enUS','These times are troubling. Watch your back.','Be well.',26124),
(116910,'enUS','Nor\'bethos Suramar.','Nor\'bethos Suramar.',26124),
(116911,'enUS','Kal\'theros maldin.','',26124),
(116912,'enUS','We rejoin the world.','',26124),
(116913,'enUS','Our era has come.','',26124),
(116914,'enUS','Walk in starlight.','',26124),
(116915,'enUS','Night guide you.','',26124),
(116916,'enUS','Fare well.','',26124),
(116917,'enUS','Nor\'bethos Suramar.','',26124),
(116918,'enUS','Kal\'theros maldin.','',26124),
(116919,'enUS','The Nightborne shall reign.','',26124),
(116920,'enUS','We shall endure.','',26124),
(116921,'enUS','Walk in starlight.','Well\'s gift be with you.',26124),
(116922,'enUS','Your interference only delays the inevitable. Minions, destroy $g him:her;!','',26124),
(116923,'enUS','Send in the wrathlords at once! Stop these meddling insects!','',26124),
(116924,'enUS','You foolishly stand in defiance of the endless armies of Sargeras! Sisters, bring me $g his:her; head!','',26124),
(116925,'enUS','For a prophet you are doing a very poor job of making predictions...','',26124),
(116926,'enUS','*O\'ros emits a bitter melody*','',26124),
(116927,'enUS','Time for a little action.','Time for a little action.',26124),
(116928,'enUS','Point me to the nearest demon.','Point me to the nearest demon.',26124),
(116929,'enUS','My blade is eager for battle.','My blade is eager for battle.',26124),
(116930,'enUS','You dare defile our lands?','You dare defile our lands?',26124),
(116931,'enUS','Give them no ground!','Give them no ground!',26124),
(116932,'enUS','You underestimate the powers of the Forsaken!','You underestimate the powers of the Forsaken!',26124),
(116933,'enUS','Look up. See the grapple point? That\'s your cue to get climbing.','',26124),
(116934,'enUS','','This is a huge stash... leave none of this contraband behind!',26124),
(116935,'enUS','Pity took root in my heart. I shared with them the ancient gift.','',26124),
(116939,'enUS','Keep the hook. I can find better places to hide my stash.','',26124),
(116940,'enUS','Meditation has opened our eyes to a technique that will infuse the resources you\'ve gathered into the ancient artifact.','',26124),
(116941,'enUS','I\'ll meet you there. I want to guarantee that they don\'t get their hands on my goods.','',26124),
(116942,'enUS','It is good to see the Aegis of Aggramar safe from the likes of Skovald and his fel allies.','',26124),
(116943,'enUS','You have a monumental task ahead of you, $n. No doubt the skalds will sing the verses of your glory for ages to come.','',26124),
(116944,'enUS','Go forth, champion, and show this Burning Legion the fury of the Valarjar!','',26124),
(116945,'enUS','By Night\'s grace.','Night guide you.',26124),
(116946,'enUS','Safe travels.','These times are troubling. Watch your back.',26124),
(116947,'enUS','Nor\'bethos Suramar.','Nor\'bethos Suramar.',26124),
(116948,'enUS','Kal\'theros maldin.','Kal\'theros maldin.',26124),
(116949,'enUS','The Nightborne have returned.','We rejoin the world.',26124),
(116950,'enUS','This is our age now.','We shall endure.',26124),
(116951,'enUS','Travel in starlight, friend.','Walk in the moonlight.',26124),
(116952,'enUS','By Night\'s grace.','',26124),
(116953,'enUS','Safe travels.','',26124),
(116954,'enUS','Nor\'bethos Suramar.','',26124),
(116955,'enUS','Kal\'theros maldin.','',26124),
(116956,'enUS','The Nightborne have returned.','',26124),
(116957,'enUS','This is our age now.','',26124),
(116958,'enUS','Travel in starlight, friend.','',26124),
(116959,'enUS','Step before the Forge of the Roaring Mountain and raise your weapon high. Behold! Its true might is awakened!','',26124),
(116960,'enUS','Hello, friend! Brightwing likes it when you visit!','',26124),
(116961,'enUS','The Burning Legion shall regret ever laying their sights on my domain. My armies are at your command! Lead them into glory!','',26124),
(116962,'enUS','No no no, my pretty grove is hurting. Friend, can you help?','',26124),
(116963,'enUS','An arcan\'dor. For a time it sustained them. For a time, they were safe.','',26124),
(116964,'enUS','It would not last. The tree became unstable.','',26124),
(116965,'enUS','The arcan\'dor died. In a flash of wild magic, the inhabitants of Falanaar were twisted.','',26124),
(116966,'enUS','The fal\'dorei are my failure. I will not fail again.','',26124),
(116967,'enUS','It is here the most dangerous prisoners were kept. Best not wander about. No telling what may lurk in the shadows...','',26124),
(116968,'enUS','To think the Horde and Alliance once waged war to control this prison. As usual, their small-minded efforts were misguided and futile.','',26124),
(116969,'enUS','In your brief life span, I\'m sure you have never faced a void terror. Avoid its eye attacks and stay out of my way. I am not here to protect you!','',26124),
(116970,'enUS','Hrmph, so much to do... so little time... but this little faerie dragon must keep going.','',26124),
(116971,'enUS','|TInterface\\Icons\\sha_spell_fire_felfire:20|t%s is casting |cFFFF0000|Hspell:219571|h[Felfrost Deathblast]|h|r! Interrupt it!','|TInterface\\Icons\\sha_spell_fire_felfire:20|t%s is casting |cFFFF0000|Hspell:219571|h[Felfrost Deathblast]|h|r! Interrupt it!',26124),
(116972,'enUS','The beast falls! I am victorious once again.','',26124),
(116973,'enUS','I\'ll retrieve the Eye. No doubt your crude attempts at its removal would cause irreparable damage.','',26124),
(116974,'enUS','I have the Eye, and you have the Book. Well, I\'ll let you keep it for now. Make haste to the Tomb of Sargeras. Do not keep Gul\'dan waiting.','',26124),
(116975,'enUS','We meet again, $n. I see you are making good use of Titanstrike.','',26124),
(116976,'enUS','Mimiron! Why are you here?','Mimiron! Why are you here?',26124),
(116977,'enUS','$ct! We of the Broken Temple have watched the bond between you and your ancient weapon grow strong.','',26124),
(116978,'enUS','Technically this is a projection of myself, not the real thing. It\'s a very handy way to check in from time to time.','',26124),
(116979,'enUS','Titanstrike and Hati are both powerful.','Titanstrike and Hati are both powerful.',26124),
(116980,'enUS','Just wanted to make sure that Titanstrike, and the Thunderspark within, are in good working order. I\'m quite proud of those creations, you know!','',26124),
(116981,'enUS','I hope your inventions help us in the fight against the Legion.','I hope your inventions help us in the fight against the Legion.',26124),
(116982,'enUS','My inventions are always magnificent. In fact, I already have plans for my next one! I\'d be happy to discuss it!','',26124),
(116983,'enUS','Bye!','',26124),
(116984,'enUS','Can we play later?','',26124),
(116985,'enUS','Magic tastes like purple!','',26124),
(116986,'enUS','Be nice or be strong.','',26124),
(116987,'enUS','Make sure to drink your magic juice!','',26124),
(116988,'enUS','Long live the Nightwell!','',26124),
(116989,'enUS','So long!','',26124),
(116990,'enUS','','So long!',26124),
(116991,'enUS','','Long live the Nightwell!',26124),
(116992,'enUS','','Make sure to drink your magic juice!',26124),
(116993,'enUS','','Be nice or be strong.',26124),
(116994,'enUS','','Magic tastes like purple!',26124),
(116995,'enUS','','Can we play later?',26124),
(116996,'enUS','','Bye!',26124),
(116997,'enUS','I wanna play now.','',26124),
(116998,'enUS','Come on! Go do something amazing!','',26124),
(116999,'enUS','Look, one of us has to be the grown-up here.','',26124),
(117000,'enUS','I guess it has to be me!','',26124),
(117001,'enUS','','I guess it has to be me!',26124),
(117002,'enUS','','Look, one of us has to be the grown-up here.',26124),
(117003,'enUS','','Come on! Go do something amazing!',26124),
(117004,'enUS','','I wanna play now.',26124),
(117005,'enUS','Come now, I have things to do.','Excuse me, I have things to do.',26124),
(117006,'enUS','Why do you insist on pestering me?','Is there somewhere else you could be right now?',26124),
(117007,'enUS','Move along!','As in, anywhere but here?',26124),
(117008,'enUS','Are you sure you\'re not a Night-bore?','You are really a night-thorn in my side.',26124),
(117009,'enUS','','While you are in Black Rook Hold, there is an urgent matter I must attend to. I will meet you back at the Hall of Shadows.',26124),
(117010,'enUS','I\'m ready to begin.','I\'m ready to begin.',26124),
(117011,'enUS','[Laughter]','',26124),
(117012,'enUS','','When will this nightmare end?',26124),
(117013,'enUS','All right, enough.','',26124),
(117014,'enUS','Are you looking for trouble?','',26124),
(117015,'enUS','Because you are about to find some.','',26124),
(117016,'enUS','That is it! See if I invite you to my promotion party.','',26124),
(117017,'enUS','All right, enough.','How about you go bug someone else for a while?',26124),
(117018,'enUS','Are you looking for trouble?','Look, I just want to finish my shift and usher in a new era for Azeroth.',26124),
(117019,'enUS','Because you are about to find some.','Can you let me do that? Will you let me do my ushering?',26124),
(117020,'enUS','That is it! See if I invite you to my promotion party.','<Sighs> I should have taken that post in Azshara.',26124),
(117021,'enUS','You know, not everyone can master the arcane as well as I.','Look at you. Now back to me. I am a master of magic.',26124),
(117022,'enUS','I attended the most prestigious magical academy in Suramar.','Now back to you. You cannot even cast the easiest of cantrips.',26124),
(117023,'enUS','I even had a focused study in battle magic. I graduated top of my class.','Now back to me. Sadly, you are not me. Look down, now up.',26124),
(117024,'enUS','Which means I can fry you in an instant if you keep bothering me!','Now look. I am sparkling like diamonds. Because of magic.',26124),
(117025,'enUS','|TInterface\\Icons\\ability_mage_timewarp:20|tThe passage of time is now normal.','|TInterface\\Icons\\ability_mage_timewarp:20|tThe passage of time is now normal.',26124),
(117026,'enUS','|TInterface\\Icons\\ability_mage_timewarp:20|tTime is passing much more quickly.','|TInterface\\Icons\\ability_mage_timewarp:20|tTime is passing much more quickly.',26124),
(117027,'enUS','|TInterface\\Icons\\ability_mage_timewarp:20|tTime is passing very slowly.','|TInterface\\Icons\\ability_mage_timewarp:20|tTime is passing very slowly.',26124),
(117028,'enUS','You know, not everyone can master the arcane as well as I.','',26124),
(117029,'enUS','I attended the most prestigious magical academy in Suramar.','',26124),
(117030,'enUS','I even had a focused study in battle magic. I graduated top of my class.','',26124),
(117031,'enUS','Which means I can fry you in an instant if you keep bothering me!','',26124),
(117032,'enUS','You will NOT move me!','',26124),
(117033,'enUS','Begone!','',26124),
(117034,'enUS','Andu Falah\'dor!','',26124),
(117035,'enUS','Manafiend!','',26124),
(117036,'enUS','Destroy them!','',26124),
(117037,'enUS','Suramar is still a shining jewel in the rubble of the Sundering.','',26124),
(117038,'enUS','We will explore the rest of the world and show them that we are still relevant!','',26124),
(117039,'enUS','I bought this off of a scout patrol. He called it a \"S.E.L.F.I.E. Camera?\" Any idea what that is?','',26124),
(117040,'enUS','You look young enough to use this fancy thing. Can you make it work for me?','',26124),
(117041,'enUS','Suramar is still a shining jewel in the rubble of the Sundering.','Suramar is still a shining jewel in the rubble of the Sundering.',26124),
(117042,'enUS','We will explore the rest of the world and show them that we are still relevant!','We will explore the rest of the world and show them that we are still relevant!',26124),
(117043,'enUS','I bought this off of a scout patrol. He called it a \"S.E.L.F.I.E. Camera?\" Any idea what that is?','I bought this off of a scout patrol. He called it a \"S.E.L.F.I.E. Camera?\" Any idea what that is?',26124),
(117044,'enUS','You look young enough to use this fancy thing. Can you make it work for me?','You look young enough to use this fancy thing. Can you make it work for me?',26124),
(117046,'enUS','I will take this opportunity to lay traps for the intruders. I am certain we will meet again!','',26124),
(117047,'enUS','In the Light we are reborn.','',26124),
(117048,'enUS','I will help you.','',26124),
(117049,'enUS','Can the naaru aid you?','',26124),
(117050,'enUS','Walk in light.','',26124),
(117051,'enUS','Light reveal your path.','',26124),
(117052,'enUS','Goodbye.','',26124),
(117053,'enUS','Careful, I can be sharp.','',26124),
(117054,'enUS','Please don\'t smudge me.','',26124),
(117055,'enUS','Would you like see the temple, say, from the outside?','',26124),
(117056,'enUS','You found them! I will have them properly preserved and sent somewhere safe immediately.','',26124),
(117057,'enUS','','This chamber... I have never seen anything like it.',26124),
(117058,'enUS','','Enough! I grow weary of you.',26124),
(117059,'enUS','','Enjoy your victory while it lasts. The Legion will tear this world asunder!',26124),
(117060,'enUS','She\'s getting away!','',26124),
(117061,'enUS','She will not get away with this!','',26124),
(117062,'enUS','Ahhh... Much better!','',26124),
(117063,'enUS','Great, you have the parts! Just give them to XR9-47 so he can bring them to me.','',26124),
(117064,'enUS','','Old teleporters. Not so different from the ones in Suramar city. Seems they are inactive.',26124),
(117065,'enUS','XR9-47, bring me the parts at once!','',26124),
(117066,'enUS','<XR9-47\'s gears spin expectantly.>','',26124),
(117067,'enUS','Mimiron, has XR9-47 delivered the parts yet?','Mimiron, has XR9-47 delivered the parts yet?',26124),
(117068,'enUS','You will be eradicated!','',26124),
(117069,'enUS','We shall reap your souls!','',26124),
(117070,'enUS','Finally, some amusement.','',26124),
(117071,'enUS','The Legion conquers all!','',26124),
(117072,'enUS','Taste true fear!','',26124),
(117073,'enUS','','You throw a party for vapid nobles even as rebels leave corpses strewn about our streets?',26124),
(117074,'enUS','You will make a fine sacrifice.','',26124),
(117075,'enUS','Destroy them!','',26124),
(117076,'enUS','I assure you, Grand Magistrix, the situation is being addressed. It will be a simple matter to track down a few random dissidents and--','',26124),
(117077,'enUS','Mimiron, I lost the Essence Swapper, can I have another?','Mimiron, I lost the Essence Swapper, can I have another?',26124),
(117078,'enUS','You cannot stop us all...','',26124),
(117079,'enUS','The Legion is endless!','',26124),
(117080,'enUS','','Random? Do you not find it striking that each body found is decorated with a dusk lily? The same flower adored by Thalyssra?',26124),
(117081,'enUS','I am one of many...','',26124),
(117082,'enUS','I... I\'m not sure what you\'re getting at, Grand Magistrix.','',26124),
(117083,'enUS','Oblivion awaits!','',26124),
(117084,'enUS','This world will... burn.','',26124),
(117085,'enUS','','Then let me be plain. You bungled your assassination of Thalyssra. In fact, she is very much alive, and is...',26124),
(117086,'enUS','','Wait. We are not alone.',26124),
(117087,'enUS','It is... hopeless...','',26124),
(117088,'enUS','Impossible! My guards would never permit such an intrusion!','',26124),
(117089,'enUS','I will be avenged.','',26124),
(117090,'enUS','','This... cannot be...',26124),
(117091,'enUS','','You cannot... resist...',26124),
(117092,'enUS','','We will scorch the world!',26124),
(117093,'enUS','','Oblivion awaits!',26124),
(117094,'enUS','','Where one falls... two shall rise.',26124),
(117095,'enUS','','We are... endless.',26124),
(117096,'enUS','','You cannot stop us all...',26124),
(117097,'enUS','','At last, some fitting prey...',26124),
(117098,'enUS','','I will deliver your head to Gul\'dan myself.',26124),
(117099,'enUS','','Do not toy with us!',26124),
(117100,'enUS','','The Legion will conquer all!',26124),
(117101,'enUS','','Finally, some amusement.',26124),
(117102,'enUS','','Your soul will serve us for eternity!',26124),
(117103,'enUS','','Annihilate them!',26124),
(117104,'enUS','','Yet another failure, Melandrus. Consider this your chance to correct it. Dispose of these outsiders. I must return to the Nighthold.',26124),
(117105,'enUS','Must you leave so soon, Grand Magistrix?','',26124),
(117106,'enUS','','Do you expect me to waste time chattering with vapid nobles even as my enemies close in? Look there, you fool! We are not alone.',26124),
(117107,'enUS','We meet again! Lothrius and Syrana have just informed me of your deeds.','',26124),
(117108,'enUS','Return to me when you\'ve gathered enough essence of the wilds, Archdruid. I trust none other to accomplish this difficult task.','',26124),
(117109,'enUS','We have also decided that it is time to leave this place.','',26124),
(117110,'enUS','','The Moon Guard are no more. There is no saving our beloved Stronghold.',26124),
(117112,'enUS','Malorne\'s warning cannot be ignored. The great father of the forest is in dire peril, and we must help him... or the very wilds may be lost.','',26124),
(117114,'enUS','Rebuilding the portal will be no easy task. It will take several moons to complete the ritual.','',26124),
(117117,'enUS','Greetings, Grand Master! I bear a message from Master Ponshu.','',26124),
(117118,'enUS','It is my honor to fight with you, Archdruid. Together, we will protect the balance of nature.','',26124),
(117119,'enUS','I will stand by you, Archdruid. Let us fight for Azeroth!','',26124),
(117120,'enUS','Yay! I like you... let\'s fight lots of enemies together!','',26124),
(117121,'enUS','My strength is yours, Archdruid. Together, we will protect the wilds.','',26124),
(117122,'enUS','','Ooooh! Let me give you a big hug! We\'re going to save so many creatures together!',26124),
(117124,'enUS','','I will call upon Elune to restore the injured and resurrect the fallen. Thank you, Archdruid.',26124),
(117125,'enUS','','My claws are sharpened and I\'m ready to hunt.  Dey won\'t even see me comin\'.',26124),
(117126,'enUS','','There you go. These treants are ready for battle.',26124),
(117127,'enUS','$ct, we have all watched in awe as you cut a swath through our foes with your ancient weapon.','',26124),
(117128,'enUS','','I trained to be a warrior when I was young... That seems like a lifetime ago, now. I\'m still pretty decent with a sword, though!',26124),
(117129,'enUS','I would be glad to lend my skills to the order, Archdruid. I have heard great things about you.','',26124),
(117130,'enUS','By infusing the resources you\'ve gathered with the souls you\'ve claimed, the forge will unlock the true potential of your weapon\'s destructive might!','',26124),
(117131,'enUS','','I have studied many forms of magic from many sources. And while each believes that their way is the best, I can tell you that they are more alike than different.',26124),
(117132,'enUS','It is done! Against your strength, the Legion will surely fall!','',26124),
(117133,'enUS','','There\'s nothing \"exotic\" about fel magic!',26124),
(117134,'enUS','','Archdruid, I bring you a message from the Circle!',26124),
(117135,'enUS','Ever have you been a fierce defender of the wilds. The skill with which you wield your ancient weapon proves you worthy to be our champion.','',26124),
(117136,'enUS','Now, through the victories you\'ve achieved and the resources you\'ve gathered, we can awaken your artifact\'s full potential.','',26124),
(117137,'enUS','','Death by sword or death by spells, it\'s all the same to me!',26124),
(117138,'enUS','All done, friend? Good, good! Calydus open portal for you. Back to Dalaran, quick, quick!','',26124),
(117139,'enUS','','The Burning Legion killed my family. Die!',26124),
(117140,'enUS','Let the Seed of Ages infuse your weapon with power! Watch it grow mightier than ever before!','',26124),
(117141,'enUS','','I\'m just as good with a sword as I am with spells. Any preference?',26124),
(117142,'enUS','Gurglll... wait, oh! Hey. Careful out here, those naga aren\'t friendly. They\'ve been enslaving this nearby Shaolfin murloc tribe. This refuge is all they have left against the incursion. We could really use your help!\n\nOne more thing... if you find any of those Timeworn Artifacts the naga are carrying, mind bringing them back to me? I need them for my research. It\'ll be worth it, I promise!','',26124),
(117143,'enUS','Take all of the Timeworn Artifacts I have on me!','Take all of the Timeworn Artifacts I have on me!',26124),
(117144,'enUS','Master, I have a message for you from Altruis.','',26124),
(117145,'enUS','They will be upon us shortly. I can teleport us somewhere safe.','',26124),
(117146,'enUS','Master, I have a message for you from Kayn.','',26124),
(117147,'enUS','','I could use my sword, but I\'d hate to dull it on the likes of you.',26124),
(117148,'enUS','Greetings, $ct. Throughout the campaign against the Legion, we have witnessed your affinity with the weapon you wield grow stronger.','',26124),
(117149,'enUS','Using the resources you\'ve gathered for our cause, we now have the means to awaken the full potential of these ancient blades!','',26124),
(117150,'enUS','Greetings, $ct. Throughout the campaign against the Legion, we have witnessed your affinity with the weapon you wield grow stronger.','',26124),
(117151,'enUS','Using the resources you\'ve gathered for our cause, we now have the means to awaken the full potential of these ancient blades!','',26124),
(117153,'enUS','We of the Black Harvest have been admiring your skill, Netherlord. To master a weapon of such considerable power is truly inspiring!','',26124),
(117154,'enUS','Through the demons you\'ve subjugated and the resources you\'ve obtained, we have the means to perform a ritual that will awaken your artifact\'s dark destiny!','',26124),
(117155,'enUS','Raise your weapon before the Felblood Altar. Watch as its dread energies infuse your weapon with infernal might!','',26124),
(117156,'enUS','Your choice to seek out that artifact you wield has borne fruit. I\'m not sure I\'ve ever seen so close a bond between mage and weapon.','',26124),
(117158,'enUS','The victories you\'ve achieved for the Tirisgarde, along with the resources you\'ve gained, shall allow us to unlock the artifact\'s full potential.','',26124),
(117159,'enUS','Raise your weapon before the Forge of the Guardian. Let it infuse your weapon with might!','',26124),
(117160,'enUS','Farseer, I have a message for you from Nobundo.','',26124),
(117161,'enUS','Our evac is almost here. We have to warn the Alliance and Horde.','',26124),
(117162,'enUS','$ct, the spirits have watched the bond between you and your ancient weapon grow stronger.','',26124),
(117163,'enUS','They must turn their fleets around. The Broken Shore is a deathtrap.','',26124),
(117164,'enUS','They have shown us a way to harness the resources you\'ve gathered to unlock the the artifact\'s true potential.','',26124),
(117165,'enUS','Raise your weapon to the skies, Farseer. Let the spirits of earth, air, fire, and water aid their champion\'s cause!','',26124),
(117166,'enUS','The lifeblood of Azeroth flows through your weapon! May you wield it with wisdom against our foes!','',26124),
(117167,'enUS','Anything, lieutenant?','',26124),
(117168,'enUS','','$ct, I have a message for you from Bishop Faol.',26124),
(117169,'enUS','Welcome, $ct. In the course of your service to the Conclave, we have witnessed your bond with the ancient weapon you hold grow stronger.','',26124),
(117170,'enUS','','The island is crawling with demons. Far more than we anticip...',26124),
(117171,'enUS','The battles you\'ve won and the resources you\'ve gathered have shown us a way to awaken the full potential of your artifact.','',26124),
(117172,'enUS','','Use the Raven\'s Eye. Decipher the code in the SI:7 letter, $n.',26124),
(117173,'enUS','As long as our faith stays strong and you stand as our champion, the Burning Legion will never claim Azeroth!','',26124),
(117174,'enUS','','Psst! Got a missive for you... straight from the Raven himself!',26124),
(117175,'enUS','In our line of work, we tend to develop a fondness for the tools of our trade. But your affinity for those blades is like nothing we\'ve seen before.','',26124),
(117176,'enUS','The resources you\'ve gathered across the Broken Isles will allow us to unlock even greater killing potential in your weapons.','',26124),
(117177,'enUS','So, you have uncovered our little secret.','',26124),
(117178,'enUS','Raise your weapons before the Crucible of the Uncrowned. Watch as it does its work, infusing your blades with deadly power!','',26124),
(117179,'enUS','','Although you have walked the lonely road for but a short while, your bond with the ancient weapon you wield grows ever stronger.',26124),
(117180,'enUS','','Through the victories you\'ve achieved and the resources you\'ve gathered, we now have the means to unlock the artifact\'s full potential.',26124),
(117181,'enUS','','All hail the $ct! May your aim never falter and your weapon strike true!',26124),
(117182,'enUS','$ct! The weapon you wield on behalf of the Silver Hand is truly a wondrous instrument of righteous retribution!','',26124),
(117183,'enUS','Through the victories achieved and resources gathered in your crusade against the darkness, we have the means to unlock even greater potency in your armament!','',26124),
(117184,'enUS','Behold as the Altar of Ancient Kings infuses the artifact you wield with power, making it mightier than ever before!','',26124),
(117185,'enUS','Over the long ages of my watch, rarely have I seen a warrior so in tune with a weapon. It is as if your very blood flows through its steel.','',26124),
(117186,'enUS','Your glorious campaign in the Broken Isles has yielded victories and resources that can reforge your weapon, awakening its true potential.','',26124),
(117187,'enUS','Here, before the Forge of Odyn, you will see your ancient artifact reshaped to become mightier than ever before!','',26124),
(117188,'enUS','Now you hold a weapon truly worthy of my war bringer! May you continue to bring honor and glory to the Valarjar!','',26124),
(117189,'enUS','Let me assure you, your precious fleets will fall into our trap.','',26124),
(117190,'enUS','You\'ll never get away with it, Detheroc!','',26124),
(117191,'enUS','Oh, but I will. And you, Mathias Shaw, will help us to do it.','',26124),
(117192,'enUS','Now I am the leader of SI:7!','',26124),
(117193,'enUS','What do you have for sale?','What do you have for sale?',26124),
(117194,'enUS','You\'ll find Lorin in the square. Sylessa frequents the canals. Just search the bazaar for Cyrille. They\'ll catch your eye.','',26124),
(117195,'enUS','','Shalas\'aman would never have wished to exist as an agent of corruption. The Dreamweavers mourn his loss, but rejoice that his torment is at an end.',26124),
(117196,'enUS','The Legion approaches! Muster your strength and ready your incantations, for war has arrived!','',26124),
(117197,'enUS','Do not waver! Bring them down!','',26124),
(117198,'enUS','Enjoy yourself at the party? I heard it was a scandalous affair.','',26124),
(117199,'enUS','Their strength surges! Whether you fight for god, king, or gold, take them down!','',26124),
(117200,'enUS','Muster your might! Focus your attacks! Bring down this foul creature at once!','',26124),
(117201,'enUS','Our fight continues, allies. Spread out! Purge these demons from Hillsbrad!','',26124),
(117202,'enUS','Pleasure doing business with you.','',26124),
(117203,'enUS','Heroes of Azeroth! If you ever loved Hillsbrad, whether in years past or this day, stand and fight!','',26124),
(117204,'enUS','Draw forth your power, whether magic or might! Send the demon back to the Nether!','',26124),
(117205,'enUS','In saving Tarren Mill, you defended all of Lordaeron. Savor our victory, but remember... this was only the beginning!','',26124),
(117206,'enUS','Hurry back!','Hurry back!',26124),
(117207,'enUS','I must get back.','I must get back.',26124),
(117208,'enUS','I will not last long out here.','I will not last long out here.',26124),
(117209,'enUS','You need my help?','',26124),
(117210,'enUS','Our jewelry is second to none.','',26124),
(117211,'enUS','My work is second to none.','',26124),
(117212,'enUS','Each of my pieces is impeccable. Even the ones made by my apprentice.','',26124),
(117213,'enUS','Keep your voice down.','Keep your voice down.',26124),
(117214,'enUS','I cannot draw any attention.','I cannot draw any attention.',26124),
(117215,'enUS','I know I can count on you.','I know I can count on you.',26124),
(117216,'enUS','We are depending on your success.','We are depending on your success.',26124),
(117217,'enUS','Do hurry...','',26124),
(117218,'enUS','Do return soon, perhaps as a customer?','',26124),
(117219,'enUS','','Let us explore downstairs. Watch your step.',26124),
(117220,'enUS','','Much better.',26124),
(117221,'enUS','','Strange. The floor looks like... a map?',26124),
(117222,'enUS','','One thing is certain - leyline energy is being fed into this chamber from elsewhere.',26124),
(117223,'enUS','','Hello. Have you found anything interesting lately?',26124),
(117224,'enUS','','Greetings. What\'s new?',26124),
(117225,'enUS','','Yes?',26124),
(117226,'enUS','The Valarjar await.','The Valarjar await.',26124),
(117227,'enUS','Do you require a squire?','Do you require a squire?',26124),
(117228,'enUS','','We were on the Broken Shore mere hours before the Alliance and Horde fleets arrived.',26124),
(117229,'enUS','Its... Elementary...','Its... Elementary...',26124),
(117230,'enUS','Archers ready!','Archers ready!',26124),
(117231,'enUS','The Forest lives and breathes as one.','The Forest lives and breathes as one.',26124),
(117232,'enUS','A worthy opponent!','',26124),
(117233,'enUS','I\'m ready!','',26124),
(117234,'enUS','I will need a drink after this!','',26124),
(117235,'enUS','...and stay down!','',26124),
(117236,'enUS','A good fight.','',26124),
(117237,'enUS','Let us drink to victory!','',26124),
(117238,'enUS','I need a... minute to recover.','',26124),
(117239,'enUS','That really... hurts.','',26124),
(117240,'enUS','Ugghh...','',26124),
(117241,'enUS','','Don\'t worry, I\'ve got your back!',26124),
(117242,'enUS','','This will help!',26124),
(117243,'enUS','','I\'ve got just what you need!',26124),
(117244,'enUS','This nasty wikket gonna get it!','',26124),
(117245,'enUS','Silly wikket pick a fight? This grookin\'s gonna last all night!','',26124),
(117246,'enUS','Is this wikket bammin\'? \'Cause heads I be slammin\'!','',26124),
(117247,'enUS','This here ooker is beat! Victory sure be sweet!','',26124),
(117248,'enUS','Woo-hoo-hoo! We won! Grookin\' dookers be fun!','',26124),
(117249,'enUS','An ookin\' good fight! Served them dookers right!','',26124),
(117250,'enUS','That ookin\' hurt! King\'s face in the dirt!','',26124),
(117251,'enUS','Wikket grooked the King! What a terrible thing!','',26124),
(117252,'enUS','That\'s it! The King\'s done. Gettin\' grooked is no fun!','',26124),
(117253,'enUS','They never saw it coming.','',26124),
(117254,'enUS','The element of surprise is on our side!','',26124),
(117255,'enUS','Strike hard, strike fast!','',26124),
(117256,'enUS','','I\'m going to kick your butt',26124),
(117257,'enUS','','Aye, this will be good!',26124),
(117258,'enUS','','We\'ve got this!',26124),
(117259,'enUS','','You were ugly.  Now you\'re dead ugly.',26124),
(117260,'enUS','','Our ancestors would be proud.',26124),
(117261,'enUS','','You better stay dead.',26124),
(117262,'enUS','','Get\'em, Stormbeak!',26124),
(117263,'enUS','','Tear them apart, girl!',26124),
(117264,'enUS','','Me gryphon\'s itchin\' fer a fight!',26124),
(117265,'enUS','','This lass is hurt... you go on.',26124),
(117266,'enUS','','Agghh...',26124),
(117267,'enUS','','Uggh...  That did some damage...',26124),
(117268,'enUS','For the Alliance!','',26124),
(117269,'enUS','Let the elements flow through you!','',26124),
(117270,'enUS','The primal waters cleanse all!','',26124),
(117271,'enUS','The tides are eternal!','',26124),
(117272,'enUS','Looks like you need assistance, friend.','',26124),
(117273,'enUS','The Earthen Ring stands with you!','',26124),
(117274,'enUS','The Elements have spoken!','',26124),
(117275,'enUS','Before you stands a true champion who has won many great victories in the name of the Alliance.','',26124),
(117276,'enUS','This is what we\'ve trained for!','',26124),
(117277,'enUS','Unleash your fury!','',26124),
(117278,'enUS','The elements will crush you!','',26124),
(117279,'enUS','Our enemies perish!','',26124),
(117280,'enUS','None shall stop us.','',26124),
(117281,'enUS','No one stands in our way.','',26124),
(117282,'enUS','I can\'t go on...','',26124),
(117283,'enUS','The ancient weapon they wield is a symbol of hope to those we have sworn to protect.','',26124),
(117284,'enUS','I am wounded... Go on without me!','',26124),
(117285,'enUS','I will recover.','',26124),
(117286,'enUS','So come, friends, lend me your voices! Join me in honoring $p!','',26124),
(117287,'enUS','Stay right where you are!','',26124),
(117288,'enUS','You\'re not going anywhere!','',26124),
(117289,'enUS','Why don\'t you... stay a while?!','',26124),
(117290,'enUS','This is beneath me.','',26124),
(117291,'enUS','You will burn!','',26124),
(117292,'enUS','I will leave but cinders!','',26124),
(117293,'enUS','Our enemies turn to ash!','',26124),
(117294,'enUS','All shall burn!','',26124),
(117295,'enUS','My fire consumes all.','',26124),
(117296,'enUS','A minor... setback... ugggh....','',26124),
(117297,'enUS','Arrrgghh...','',26124),
(117298,'enUS','I am hurt... go on... without me.','',26124),
(117299,'enUS','','Let\'s see what\'s in the bag, shall we?',26124),
(117300,'enUS','','Boy, I\'m feeling lucky today!',26124),
(117301,'enUS','','The darkness gives us strength!  Well... at least sometimes it does!',26124),
(117302,'enUS','','Shadows engulf you!',26124),
(117303,'enUS','','The darkness will swallow you whole!',26124),
(117304,'enUS','','Fire consumes you!',26124),
(117305,'enUS','','My fire burns eternal!',26124),
(117306,'enUS','Sleep now...','',26124),
(117307,'enUS','You cannot resist!  Sleep!','',26124),
(117308,'enUS','Hush now...  The Dream beckons!','',26124),
(117309,'enUS','I am nature\'s rage!','',26124),
(117310,'enUS','I will tear you to shreds!','',26124),
(117311,'enUS','Hardly a match for our strength!','',26124),
(117312,'enUS','Nature\'s foes shall perish.','',26124),
(117313,'enUS','Ours is the strength of the wild.','',26124),
(117314,'enUS','Do not cross nature\'s guardians.','',26124),
(117315,'enUS','I will recover... with time.','',26124),
(117316,'enUS','Arrrgghh...','',26124),
(117317,'enUS','I must... stay back for now...','',26124),
(117318,'enUS','','We\'ve got this!',26124),
(117319,'enUS','','Is there trouble?',26124),
(117320,'enUS','','Nature is on our side!',26124),
(117321,'enUS','Feel nature\'s wrath!','',26124),
(117322,'enUS','I am nature\'s guardian.','',26124),
(117323,'enUS','The wilds grant me strength!','',26124),
(117324,'enUS','Death to our enemies!','',26124),
(117325,'enUS','Never surrender!','',26124),
(117326,'enUS','The Illidari cannot be stopped!','',26124),
(117327,'enUS','I\'ve got your back!','',26124),
(117328,'enUS','I fight by your side!','',26124),
(117329,'enUS','You do not fight alone!','',26124),
(117330,'enUS','Attack!','',26124),
(117331,'enUS','Strike fast, enemies are near!','',26124),
(117332,'enUS','I will strike swiftly!','',26124),
(117333,'enUS','It is good to fight by your side.','',26124),
(117334,'enUS','A swift death.','',26124),
(117335,'enUS','Our enemies cannot stop us.','',26124),
(117336,'enUS','I am hurt...  go on... without me.','',26124),
(117337,'enUS','Agghh...','',26124),
(117338,'enUS','Urghh... I must... retreat...','',26124),
(117339,'enUS','My hatred burns!','',26124),
(117340,'enUS','My soul... consumed by hate!','',26124),
(117341,'enUS','My anger is... uncontrollable!','',26124),
(117342,'enUS','It is too quiet here. I have a bad feeling...','',26124),
(117343,'enUS','Die!','',26124),
(117344,'enUS','I envy your fate.','',26124),
(117345,'enUS','I bring death!','',26124),
(117346,'enUS','I can\'t go on... release me!','',26124),
(117347,'enUS','Hurggghh...','',26124),
(117348,'enUS','Why do you... do this... to me?','',26124),
(117349,'enUS','Moving in to strike!','',26124),
(117350,'enUS','I move swiftly.','',26124),
(117351,'enUS','','Spiders!',26124),
(117352,'enUS','My blades are ready!','',26124),
(117353,'enUS','We cannot be stopped.','',26124),
(117354,'enUS','Another falls by our hand.','',26124),
(117355,'enUS','Death to our enemies!','',26124),
(117356,'enUS','My wounds... are too deep...','',26124),
(117357,'enUS','Arghh...','',26124),
(117358,'enUS','I\'m down!','',26124),
(117359,'enUS','I think one fell on my head! Get it off!','',26124),
(117360,'enUS','','A simple task.',26124),
(117361,'enUS','','You called?',26124),
(117362,'enUS','','Your wish is my command.',26124),
(117363,'enUS','','You cannot hide from the Unseen Path!',26124),
(117364,'enUS','','Snowfeather! Attack!',26124),
(117365,'enUS','','Get them, Snowfeather!',26124),
(117366,'enUS','This is a city for the dead. I was hoping for quiet.','',26124),
(117367,'enUS','I will hunt you down!','',26124),
(117368,'enUS','Let the hunt begin!','',26124),
(117369,'enUS','You can\'t escape!','',26124),
(117370,'enUS','Perhaps I will find redemption here.','',26124),
(117371,'enUS','A clean kill.','',26124),
(117372,'enUS','Well done!','',26124),
(117373,'enUS','A good kill.','',26124),
(117374,'enUS','I will heal...  in time...','',26124),
(117375,'enUS','Arghh....','',26124),
(117376,'enUS','I must stay back...','',26124),
(117377,'enUS','','I\'m a real hunter now!',26124),
(117378,'enUS','There can be no progress without sacrifice.','',26124),
(117379,'enUS','','Let\'s get\'em!',26124),
(117380,'enUS','','I\'ve got this one!',26124),
(117381,'enUS','','We did it!',26124),
(117382,'enUS','','That was exciting!',26124),
(117383,'enUS','I am looking for an assistant. I suppose you will do.','',26124),
(117384,'enUS','','You better stay dead.',26124),
(117385,'enUS','','Ungghhh...  Don\'t worry about me... I\'ll catch up... I think.',26124),
(117386,'enUS','','Ahhhh... that... hurts... so... much...',26124),
(117387,'enUS','','Hmph... I need to recover.  You go on!',26124),
(117388,'enUS','Tread carefully on this hallowed place.','',26124),
(117389,'enUS','A clean shot!','',26124),
(117390,'enUS','I\'ve got the target in my sights!','',26124),
(117391,'enUS','Go, then. Do what you can.','',26124),
(117392,'enUS','This one counts as my kill!','',26124),
(117393,'enUS','','You are no match for the Tirisgarde!',26124),
(117394,'enUS','','Crumble before our power!',26124),
(117395,'enUS','','Witness the power of an Archmage!',26124),
(117396,'enUS','','Our enemies fall!',26124),
(117397,'enUS','','Hardly a challenge!',26124),
(117398,'enUS','','We are victorious.  Just as I predicted.',26124),
(117399,'enUS','','My wounds are deep... go on without me.',26124),
(117400,'enUS','','Arrghghh!',26124),
(117401,'enUS','','The pain is too much.  I need some time to recover!',26124),
(117402,'enUS','Feel the wrath of Kalecgos!','',26124),
(117403,'enUS','Tremble before me!','',26124),
(117404,'enUS','Raawwwwr!!','',26124),
(117405,'enUS','Go forth, and be quick about it!','',26124),
(117406,'enUS','You face Millhouse the Magnificent!','',26124),
(117407,'enUS','I will obliterate and disintegrate and exterminate and... did I say obliterate?','',26124),
(117408,'enUS','This one\'s mine!','',26124),
(117409,'enUS','I must unlock these secrets...','',26124),
(117410,'enUS','I hardly broke a sweat!','',26124),
(117411,'enUS','I\'ve killed cockroaches bigger than that!','',26124),
(117412,'enUS','I can do this in my sleep!','',26124),
(117413,'enUS','A most minor setback...  I must... catch my... breath.','',26124),
(117414,'enUS','Aiggggghh!','',26124),
(117415,'enUS','Am I bleeding?  Is that... blood?','',26124),
(117416,'enUS','Over here, you nitwit!','',26124),
(117417,'enUS','Looks can be deceiving!','',26124),
(117418,'enUS','Hey! Over here! Hit me with your best shot!','',26124),
(117419,'enUS','','Blood Knights!  Attack formation!',26124),
(117420,'enUS','','Blood Knights!  On me!',26124),
(117421,'enUS','','Charge!',26124),
(117422,'enUS','Light give me strength!','',26124),
(117423,'enUS','Justice is on our side!','',26124),
(117424,'enUS','Fight with honor!','',26124),
(117425,'enUS','Justice prevails!','',26124),
(117426,'enUS','Victory is ours!','',26124),
(117427,'enUS','We are victorious!','',26124),
(117428,'enUS','My wounds... are too grave!','',26124),
(117429,'enUS','Hmmmph...','',26124),
(117430,'enUS','I will recover... go on without me!','',26124),
(117431,'enUS','May the Light have mercy on your souls.','',26124),
(117432,'enUS','The Light purifies everything!','',26124),
(117433,'enUS','Nothing can hide from the Light!','',26124),
(117434,'enUS','That was a LOT of spiders.','',26124),
(117435,'enUS','For justice!','',26124),
(117436,'enUS','For the Light!','',26124),
(117437,'enUS','The Light smites our foes!','',26124),
(117438,'enUS','One by one, our foes shall fall!','',26124),
(117439,'enUS','Victory!','',26124),
(117440,'enUS','The Light smiles upon us.','',26124),
(117441,'enUS','','That was a LOT of spiders! I rather enjoyed tearing them apart.',26124),
(117442,'enUS','Grievous wounds... I must recover...','',26124),
(117443,'enUS','Unggh...','',26124),
(117444,'enUS','I need to recover... Go on without me!','',26124),
(117445,'enUS','','This should be good!',26124),
(117446,'enUS','','I fear nothing!',26124),
(117447,'enUS','','I will crush you!',26124),
(117448,'enUS','','A glorious fight!',26124),
(117449,'enUS','','Is that all you\'ve got?',26124),
(117450,'enUS','','Die with honor!',26124),
(117451,'enUS','','These wounds... I\'ll recover...',26124),
(117452,'enUS','','Hmmmph...',26124),
(117453,'enUS','','Hah... these will make... good... battle scars...',26124),
(117454,'enUS','','In\'alah!',26124),
(117455,'enUS','KROLMIR!!!!!','',26124),
(117456,'enUS','THUNDER!  HEED MY CALL!!!!!','',26124),
(117457,'enUS','FOR ODYN!!','',26124),
(117458,'enUS','For Ulduar!','',26124),
(117459,'enUS','To battle!','',26124),
(117460,'enUS','Come and face me!','',26124),
(117461,'enUS','Taste the might of iron!','',26124),
(117462,'enUS','Fall before my iron will!','',26124),
(117463,'enUS','The day is ours!','',26124),
(117464,'enUS','I will recover... You go on...','',26124),
(117465,'enUS','Arrrhghhh...','',26124),
(117466,'enUS','A minor wound...','',26124),
(117467,'enUS','Winds of the north consume you!','',26124),
(117468,'enUS','Tremble before the northern winds!','',26124),
(117469,'enUS','Feel the wrath of Hodir!','',26124),
(117470,'enUS','','A hush falls over the chamber at the news of Mathias Shaw\'s fate.',26124),
(117471,'enUS','','This one\'s mine!',26124),
(117472,'enUS','','No one crosses the Uncrowned!',26124),
(117473,'enUS','','Let me show you how it\'s done!',26124),
(117474,'enUS','','Die, scum!',26124),
(117475,'enUS','','You call that a fight?',26124),
(117476,'enUS','','I\'m just warming up!',26124),
(117477,'enUS','','I\'m wounded... let me... catch my breath...',26124),
(117478,'enUS','','Aaarghhh...',26124),
(117479,'enUS','','No... I\'m not ready... to die...',26124),
(117480,'enUS','','Allow me to even the odds!',26124),
(117481,'enUS','','An assassin\'s work is never done!',26124),
(117482,'enUS','','Need a hand?',26124),
(117483,'enUS','We strike from the shadows!','',26124),
(117484,'enUS','I\'m going in for the kill.','',26124),
(117485,'enUS','By the numbers.','',26124),
(117486,'enUS','There is no joy in killing... only in a job well done.','',26124),
(117487,'enUS','Another falls by our hand.','',26124),
(117488,'enUS','','Damn...',26124),
(117489,'enUS','All will fear us... in time.','',26124),
(117490,'enUS','I must retreat... temporarily...','',26124),
(117491,'enUS','Urrrhghhh...','',26124),
(117492,'enUS','That cut deep... I must recover.','',26124),
(117493,'enUS','Target acquired.','',26124),
(117494,'enUS','Leave no trace.','',26124),
(117495,'enUS','Taking out the target.','',26124),
(117496,'enUS','Your weakness is our strength!','',26124),
(117497,'enUS','The tides of battle turn here!','',26124),
(117498,'enUS','Surrender to the Ebon Blade!','',26124),
(117499,'enUS','I\'m right by your side.','',26124),
(117500,'enUS','We fight as one.','',26124),
(117501,'enUS','The Ebon Blade stands together.','',26124),
(117502,'enUS','Death to our enemies!','',26124),
(117503,'enUS','The Ebon Blade prevails!','',26124),
(117504,'enUS','I\'m just warming up!','',26124),
(117505,'enUS','I\'m hurt... need to recover...','',26124),
(117506,'enUS','Hmmrrghh...','',26124),
(117507,'enUS','Go on without me... complete our... task...','',26124),
(117508,'enUS','ROTTGUT ROTTGUT!!!','',26124),
(117509,'enUS','ROTT GUT!!','',26124),
(117510,'enUS','ROTTGUT!!!!','',26124),
(117511,'enUS','Horsemen!  We ride!','',26124),
(117512,'enUS','Cower before the Four Horsemen!','',26124),
(117513,'enUS','Crush our enemies!','',26124),
(117514,'enUS','','A\'dal!  Grant us strength!',26124),
(117515,'enUS','','The Light shines upon us!',26124),
(117516,'enUS','','The naaru are with us, always.',26124),
(117517,'enUS','The shadows guide me.','',26124),
(117518,'enUS','Give into madness!','',26124),
(117519,'enUS','Your will is mine to bend!','',26124),
(117520,'enUS','The shadows claim you.','',26124),
(117521,'enUS','You\'re no match for my power.','',26124),
(117522,'enUS','Death takes you!','',26124),
(117523,'enUS','It\'s only a little pain... I\'ll catch up...','',26124),
(117524,'enUS','Hggghh... unghhh... I\'ll be all right.','',26124),
(117525,'enUS','Death... old friend... not today...','',26124),
(117526,'enUS','We fight for the Light!','',26124),
(117527,'enUS','I am Light incarnate!','',26124),
(117528,'enUS','I cleanse this world!','',26124),
(117529,'enUS','I defend the Light.','',26124),
(117530,'enUS','The Light endures.','',26124),
(117531,'enUS','We prevail.','',26124),
(117532,'enUS','My light fades away...','',26124),
(117533,'enUS','My power fades...','',26124),
(117534,'enUS','I shall return..','',26124),
(117535,'enUS','The Light topples our enemies!','',26124),
(117536,'enUS','Our inner fire burns bright!','',26124),
(117537,'enUS','Let the Light flow through you.','',26124),
(117538,'enUS','','Worthless insects. You will beg for death before the end!',26124),
(117539,'enUS','','So dark...',26124),
(117540,'enUS','No! The stronghold must fall!','',26124),
(117541,'enUS','How helpless you must feel to watch your precious world crumble around you.','',26124),
(117542,'enUS','You will learn your place, mortals.','',26124),
(117543,'enUS','Your existence means nothing! Prepare your last breath, mortals!','',26124),
(117544,'enUS','In the end, there is nothing...','',26124),
(117545,'enUS','Disease wears your enemy down while your strong melee attacks finish them off.','',26124),
(117546,'enUS','But your greatest ally is death itself. Raise Dead will animate a corpse to serve as your ghoulish minion.','',26124),
(117547,'enUS','You should always try to have a minion with you.','',26124),
(117548,'enUS','Outbreak will deal damage over time and unleashes a Virulent Plague that spreads to nearby enemies.','',26124),
(117549,'enUS','Festering Strike deals damage and inflicts Festering Wounds on your target.','',26124),
(117550,'enUS','Festering Strike followed by Scourge Strike is a one-two punch few enemies can withstand.','',26124),
(117551,'enUS','','And we are at the center...',26124),
(117552,'enUS','Use Death and Decay to corrupt the ground beneath your feet, dealing damage to all foes in the affected area and empowering some of your attacks to hit additional targets.','',26124),
(117553,'enUS','Its dark power damages your foe and recovers a portion of your health.','',26124),
(117554,'enUS','Death Grip allows you to reach out to a distant target and pull them toward you. No enemy can escape your icy grasp!','',26124),
(117555,'enUS','Army of the Dead raises a swarm of ghouls to attack anything and everything near you.','',26124),
(117556,'enUS','','Reinforcements from Undercity on approach!',26124),
(117557,'enUS','','What could have required such power? A weapon, perhaps?',26124),
(117558,'enUS','','And those keepers protecting it... How long their vigil must have been...',26124),
(117559,'enUS','','<Sigh.> I have more questions now than before!',26124),
(117560,'enUS','This powerful ability cannot be used often, so save it for an emergency.','',26124),
(117561,'enUS','','It is a perfect refuge. A temporary home, until I can return to Suramar.',26124),
(117562,'enUS','','But first, I will need allies.',26124),
(117563,'enUS','|TInterface\\Icons\\ability_siege_engineer_overload:20|tRax\'s shredder goes |cFFFF0404|Hspell:219614|h[Haywire!]|h|r Leap to the zeppelin!','|TInterface\\Icons\\ability_siege_engineer_overload:20|tRax\'s shredder goes |cFFFF0404|Hspell:219614|h[Haywire!]|h|r Leap to the zeppelin!',26124),
(117564,'enUS','Ah, the Book is here at last... borne by one whose meddlesome handiwork I know well! Come to join the winning side, \"hero\"?','',26124),
(117565,'enUS','You have both done well to acquire these artifacts. Your positions in the Shadow Council are all but assured.','',26124),
(117566,'enUS','Using the Book, the Eye, and the Scepter, we will amplify this portal and open gateways to countless other demon worlds. The Legion\'s full might will fall upon this pitiful planet!','',26124),
(117567,'enUS','I will go through the portal and act as a stabilizing anchor on Argus. You will focus the ritual energy through the scepter, widening the breach and creating a myriad of portals.','',26124),
(117568,'enUS','Uh... great master? Which of us is to wield the Scepter?','',26124),
(117569,'enUS','Your mastery of ice allows you to call forth a water elemental pet, so we\'ll start there.','',26124),
(117570,'enUS','This long-range attack will damage and slow your enemies, and has a chance to empower other attacks.','',26124),
(117571,'enUS','Ice Lance\'s real power lies in using it against a frozen target, which greatly increases its damage.','',26124),
(117572,'enUS','Frostbolt occasionally triggers the Fingers of Frost effect, which gives a huge boost to Ice Lance damage. Let\'s test it out.','',26124),
(117573,'enUS','|TInterface\\Icons\\Ability_Hunter_RapidRegeneration:20|tSnaggle begins a |cFFFF0404|Hspell:219848|h[Pistol Barrage]|h|r! Leap to the ground!','|TInterface\\Icons\\Ability_Hunter_RapidRegeneration:20|tSnaggle begins a |cFFFF0404|Hspell:219848|h[Pistol Barrage]|h|r! Leap to the ground!',26124),
(117574,'enUS','Hodir, wait!','',26124),
(117575,'enUS','Be careful, though, as it hits all enemies in its path, not just your target.','',26124),
(117576,'enUS','Ahh, I only need ONE of you for the ritual. \"Discuss\" the matter quickly, and be ready...','',26124),
(117577,'enUS','In those cases, a little bit of extra protection is needed. Ice Barrier creates a shield of ice to absorb enemy attacks.','',26124),
(117578,'enUS','Use it and enemies will be unable to target you, letting you escape form combat. But be careful! It doesn\'t last long.','',26124),
(117579,'enUS','But using your legs is so mundane! Fortunately, you have a spell that befits a master of the magical arts.','',26124),
(117580,'enUS','Blink allows you to teleport a short distance to avoid danger or close in on an enemy.','',26124),
(117581,'enUS','Frost Nova freezes nearby enemies in place, allowing you to move away and destroy them safely. For now, let\'s just practice freezing them in place.','',26124),
(117582,'enUS','It seems we are to be foes after all. Pity, you would have made an excellent servant!','',26124),
(117583,'enUS','You can pelt a target location with shards of ice by using a potent spell called Blizzard. Great name, don\'t you think?','',26124),
(117584,'enUS','Already on it! Once our friend completes the survey, we will have our first connection.','',26124),
(117586,'enUS','You have yet to experience my true power!','',26124),
(117588,'enUS','Slain... by a lowborn... how beneath me...','',26124),
(117589,'enUS','','Oculeth, can you restore the teleporters in this chamber?',26124),
(117590,'enUS','Not surprising that you came out the victor. I considered aiding Allaris against you, but your resourcefulness may prove useful. Consider this... a promotion. Do not disappoint me!','',26124),
(117591,'enUS','The time has come! Begin the incantations. Focus the scepter on the altar. Today we usher in the end of this world!','',26124),
(117592,'enUS','You can shapeshift into Moonkin form, which increases both your damage and defense.','',26124),
(117593,'enUS','These attacks deal their damage over time, and either makes an excellent start to a battle.','',26124),
(117594,'enUS','Solar Wrath is a ranged ability that deals damage and generates Astral Power, a resource used to fuel more powerful attacks.','',26124),
(117595,'enUS','Starsurge costs Astral Power, so use Solar Wrath to build up your reserves.','',26124),
(117596,'enUS','Celestial Alignment causes the celestial bodies to align, increasing the damage of your solar and lunar spells for a short time.','',26124),
(117597,'enUS','Now we can begin to restore the ancient network. If you find any of my old beacons out there, be sure to activate them!','',26124),
(117598,'enUS','','Drugon the Frostblood is an ancient foe of my people and has been spotted within Snowblind Cliffs. Put an end to this creature.',26124),
(117599,'enUS','Oculeth finale lines.','',26124),
(117600,'enUS','','Thalyssra finale lines.',26124),
(117601,'enUS','','Drugon should\'ve stayed hidden on his peak. Thank you champion, my people are safer because of you.',26124),
(117602,'enUS','You death will be... explosive.','',26124),
(117603,'enUS','Lunar Strike deals damage directly to your target, but also deals damage to nearby foes.','',26124),
(117604,'enUS','Entangling Roots will cause plant roots to spring from the ground and hold the target in place for a short time.','',26124),
(117605,'enUS','Soon they\'ll be weak enough for you to go for the throat with a mighty finishing move.','',26124),
(117606,'enUS','Though powerful on its own, using Shred on a bleeding target increases its damage, so try keeping rake up.','',26124),
(117607,'enUS','Ferocious Bite is a finishing move that deals increased damage the more combo points you have.','',26124),
(117608,'enUS','Try to use it when you have a full 5 combo points.','',26124),
(117609,'enUS','Rake will cause your target to bleed, wounding them over time.','',26124),
(117610,'enUS','Your Shred ability also deals extra damage to bleeding targets, so these are great abilities to use together.','',26124),
(117611,'enUS','Fool! Your betrayal only delays the inevitable! I will save a special prison for you when all you know is destroyed and you lie broken before me.','',26124),
(117612,'enUS','Tiger\'s Fury restores some energy and also increases your damage for a short time.','',26124),
(117613,'enUS','As an alternative to Ferocious Bite, Rip can be used to deal bleeding damage over time to your target, and is a good ability to spend combo points on early in a fight.','',26124),
(117614,'enUS','Like Ferocious Bite, Rip is a finishing move, and is best used when you have 5 combo points.','',26124),
(117615,'enUS','Entangling Roots will cause plant roots to spring from the ground and hold the target in place for a short time.','',26124),
(117616,'enUS','Survival Instincts reduces incoming damage for a short time. Save it for when you really need it!','',26124),
(117617,'enUS','Swipe deals damage to all nearby foes, but that damage is increased if your targets are bleeding. It\'s a good idea to use Thrash and Swipe together.','',26124),
(117618,'enUS','Hodir has always been too impulsive for his own good. \n\nIt appears that he was right about you, however. I did not think it possible for a mere mortal to be worthy of Odyn\'s blessings. You are an enigma, $n.','',26124),
(117619,'enUS','Thrash will damage all nearby enemies, causing them to bleed for a short time.','',26124),
(117620,'enUS','Time to go, friend! Here!','',26124),
(117621,'enUS','Dash increases your movement speed significantly for a short time. It can\'t be used often, so save it for when you really need it.','',26124),
(117622,'enUS','After you\'ve taken damage, use Regrowth to restore your health.','',26124),
(117623,'enUS','Dire Beast will allow you to summon a nearby beast to join the fight and attack your target for a short time.','',26124),
(117624,'enUS','','You there! Outlander! Be a dear and step on that other switch, will you?',26124),
(117625,'enUS','While under its effects, using Dire Beast will shorten the time before you can trigger Bestial Wrath again.','',26124),
(117626,'enUS','Alongside your trusty pet, you are the master of your environment. Call Pet will summon your pet to your side.','',26124),
(117627,'enUS','','There we are. Open at last.',26124),
(117628,'enUS','Don\'t worry, your pet is resilient! Using Kill Command will cause your pet to perform a strong attack, and is also a great way to initiate a fight.','',26124),
(117629,'enUS','','Well, I will be killing you now. Any last words?',26124),
(117630,'enUS','Mend Pet will allow you to heal damage your pet has taken.','',26124),
(117631,'enUS','Multi-shot allows you to fire a spread of projectiles hitting several enemies near your target.','',26124),
(117632,'enUS','When facing certain defeat, use Feign Death to trick your enemies into thinking you\'re no longer a threat.','',26124),
(117633,'enUS','Hodir has always been too impulsive for his own good.\n\nHis judgment was accurate about you, however. I did not think it possible for a mere mortal to be worthy of Odyn\'s blessing. You are an enigma, $n.\n\nI will teleport you out of here when you are ready.','',26124),
(117634,'enUS','Using this attack causes your pet to cleave multiple enemies as well.','',26124),
(117635,'enUS','','Ahhh, I recognize that symbol. So Thalyssra has recruited an outlander to our cause... Are we truly so desperate?',26124),
(117636,'enUS','','Step before the Altar of the Eternal Hunt. Let it infuse your weapon with power and make it mightier than ever before!',26124),
(117637,'enUS','They are gone... the portal is closed!','',26124),
(117638,'enUS','You fought well.  I was wrong to question my father\'s choice. The forces of Ulduar will stand behind you if you are willing to aid us in finding Hodir.','',26124),
(117639,'enUS','This builds up Chi, a resource that allows you to unleash your most powerful attacks.','',26124),
(117640,'enUS','Start by using your primary attack, Tiger Palm, to deal damage and generate Chi.','',26124),
(117641,'enUS','It hits much harder than Tiger Palm, so use Blackout Kick to spend your extra Chi.','',26124),
(117642,'enUS','Your legend grows, and it is fitting that the fearsome artifact you wield increases in potency as well.','',26124),
(117643,'enUS','It will also hit additional enemies near your target. Use Fists of Fury whenever it\'s available, or if you face multiple enemies.','',26124),
(117644,'enUS','Use Flying Serpent Kick to launch yourself at your enemy. Using it a second time while you are in the air will end your flight and deal damage to enemies nearby.','',26124),
(117645,'enUS','Take one enemy out of the fight by paralyzing him! Paralyze will knock out an enemy for a short time, but the foe will recover if he takes any damage.','',26124),
(117646,'enUS','If you find yourself facing three or more opponents, tap your inner spirit to duplicate yourself, making you your own ally! Your allied selves will attack enemies automatically.','',26124),
(117647,'enUS','Use it whenever you meet someone you don\'t like, although you might want to save it for your toughest enemies!','',26124),
(117648,'enUS','Your primary means of mobility is Roll, which causes you to quickly roll a good distance in whatever direction you are moving.','',26124),
(117649,'enUS','Use it whenever it is available.','',26124),
(117650,'enUS','Before we get started we need to apply poison to your weapon.','',26124),
(117651,'enUS','Raise your blade before the forge. Watch it infuse the weapon with its might!','',26124),
(117652,'enUS','Darion Mograine! What is the meaning of this?!','',26124),
(117653,'enUS','The best way to start a fight is with Garrote, a debilitating bleeding attack that causes your enemy to take damage over time.','',26124),
(117654,'enUS','Whenever you use Rupture with 5 combo points, you will do a strong bleeding attack that damages enemies over time.','',26124),
(117655,'enUS','If your target is already affected by Rupture, then using Envenom with 5 combo points deals good damage and maximizes the effect of your poisons.','',26124),
(117656,'enUS','Crimson Vial is an alchemical concoction that will restore a portion of your health.','',26124),
(117657,'enUS','By using Shadowstep, you will remain in stealth and be poised to strike.','',26124),
(117658,'enUS','Fan of Knives unleashes damage on all enemies encircling you. It will also generate a combo point for every enemy hit.','',26124),
(117659,'enUS','Sometimes a strategic retreat is necessary so you can live to fight another day.','',26124),
(117660,'enUS','Your Flame Shock ability will set your enemies ablaze, burning them while you cast other spells.','',26124),
(117661,'enUS','Using Lava Burst while your enemies are affected by Flame Shock increases its damage.','',26124),
(117662,'enUS','Use Lightning Bolt whenever other abilities are not available.','',26124),
(117663,'enUS','Your target won\'t attack you while it\'s a frog, but the effect is temporary. The enemy will revert back to its original form if attacked.','',26124),
(117664,'enUS','When you strike an enemy with Chain Lightning, it jumps to additional foes near your target, damaging all of them.','',26124),
(117665,'enUS','Just as the elements can destroy, they also have the power to restore.','',26124),
(117666,'enUS','The first attack we\'ll try is Flametongue, which emblazes your weapons and scorches your enemy with fire.','',26124),
(117667,'enUS','Rockbiter empowers your weapons with the forces of earth to deal damage.','',26124),
(117668,'enUS','Lava Lash uses Maelstrom to charge your off-hand weapon with lava, allowing you to deal a mighty blow.','',26124),
(117669,'enUS','Try to use Stormstrike whenever Stormbringer triggers.','',26124),
(117670,'enUS','Crash Lightning deals damage to all targets in front of you. Hitting multiple enemies empowers your weapons, dealing even more damage!','',26124),
(117671,'enUS','Should you find yourself in trouble during combat, you can summon two feral wolf spirits to fight at your side.','',26124),
(117672,'enUS','','<Sigh.> Very well. I am Valtrois.',26124),
(117673,'enUS','','Run, for now. You will only die tired.',26124),
(117674,'enUS','','I sense a spy among us.',26124),
(117675,'enUS','','What do we have here? Someone hiding?',26124),
(117676,'enUS','','Hmm. My prey can wait...',26124),
(117677,'enUS','','Very well. Enjoy your freedom... for now.',26124),
(117678,'enUS','','Hmm. I will find you soon...',26124),
(117679,'enUS','Your attacks are a mix of ranged spells and melee that build up and unleash Holy Power.','',26124),
(117680,'enUS','Your devotion to the Light empowers you to hurl a mighty hammer of Judgment at your foes.','',26124),
(117681,'enUS','As your enemy closes in, unleash a potent mid-range attack called Blade of Justice.','',26124),
(117682,'enUS','Once your foe has closed to striking range, unleash your weapon using Crusader Strike.','',26124),
(117683,'enUS','Unleash this divine magic through Templar\'s Verdict, a powerful melee attack that infuses your weapon with the strength of the Light.','',26124),
(117684,'enUS','Divine Shield prevents incoming attacks from harming you.','',26124),
(117685,'enUS','Your conviction allows you to heal yourself and your allies. Flash of Light is a cornerstone of your healing arsenal.','',26124),
(117686,'enUS','','Annihilate them!',26124),
(117687,'enUS','','Your soul will serve us for eternity!',26124),
(117688,'enUS','','Finally, some amusement.',26124),
(117689,'enUS','','The Legion will conquer all!',26124),
(117690,'enUS','','Do not toy with us!',26124),
(117691,'enUS','','I will deliver your head to Gul\'dan myself.',26124),
(117692,'enUS','','At last, some fitting prey...',26124),
(117693,'enUS','','You cannot stop us all...',26124),
(117694,'enUS','','We are... endless.',26124),
(117695,'enUS','','Where one falls... two shall rise.',26124),
(117696,'enUS','','Oblivion awaits!',26124),
(117697,'enUS','','We will scorch the world!',26124),
(117698,'enUS','','You cannot... resist...',26124),
(117699,'enUS','','This... cannot be...',26124),
(117700,'enUS','Shadow Word: Pain taints your foes with shadow energy, wounding them slowly over time.','',26124),
(117701,'enUS','Penance is a potent spell that deals damage to your enemies. Use Penance whenever it is available.','',26124),
(117702,'enUS','It is your most frequently used damage spell, best used when Penance is not available.','',26124),
(117703,'enUS','One of your most useful defensive abilities is Power Word: Shield, which absorbs all damage from attacks when active.','',26124),
(117704,'enUS','Always remember to maintain your shield during fights.','',26124),
(117705,'enUS','Fortunately, you are not defenseless in such cases. Psychic Scream terrifies nearby opponents, causing them to run away in fear.','',26124),
(117706,'enUS','This presents no problem for you however. The Light gives you the power to restore the health of yourself or your allies.','',26124),
(117707,'enUS','Agony deals more and more damage over time, making it a great way to start a fight.','',26124),
(117708,'enUS','Corruption is a spell that afflicts its target, dealing shadow damage as long as the affliction lasts.','',26124),
(117709,'enUS','Drain Soul is the most frequent attack you will use, healing you as it damages your foe.','',26124),
(117710,'enUS','Unstable Affliction is a powerful spell that deals damage over time like Agony and Corruption, but uses a Soul Shard to deal more damage.','',26124),
(117711,'enUS','Your command of dark magic enables you to summon a demon servant to do your bidding.','',26124),
(117712,'enUS','Life Tap allows you to steal your own life force to replenish your mana. Don\'t worry, you can always drain the life from your opponent to heal.','',26124),
(117713,'enUS','To force a foe to stop fighting for a short time, utilize fear itself to strike terror into their heart.','',26124),
(117714,'enUS','You cannot do this often, so save this demon for an emergency.','',26124),
(117715,'enUS','Using your Soulstone ability preserves your very soul for later. Don\'t worry, you weren\'t using it anyway! With your soul stored, you can return from the dead at will.','',26124),
(117716,'enUS','','Mathias Shaw led our SI:7 team on a secret recon of the island. We were awaiting extraction.',26124),
(117717,'enUS','But you cannot defeat an opponent that\'s out of reach. Fortunately, you have a skill to solve this problem.','',26124),
(117718,'enUS','Mortal Strike is such an attack. Use it whenever it is available.','',26124),
(117719,'enUS','Your Victory Rush ability can only be used during this time, restoring health as you strike a new enemy.','',26124),
(117720,'enUS','Cleave allows you to attack several enemies that are in front of you. For every enemy hit, your next Whirlwind does additional damage!','',26124),
(117721,'enUS','Whirlwind allows you to swing your weapon in wide arcs, cutting a swath of carnage into all enemies around you.','',26124),
(117722,'enUS','Heroic Leap allows you to bound across the battlefield to accomplish either goal.','',26124),
(117723,'enUS','','Protect her while I heal her injuries!',26124),
(117724,'enUS','','Use Army of the Dead now to summon in your minions.',26124),
(117725,'enUS','','This powerful ability cannot be used often, so save it for an emergency.',26124),
(117726,'enUS','','Army of the Dead raises a swarm of ghouls to attack anything and everything near you.',26124),
(117727,'enUS','','Being able to call upon the powers of death means you rarely need to be outnumbered.',26124),
(117728,'enUS','','Death Grip can be used from a good distance away. Try moving further away from the target and using it.',26124),
(117729,'enUS','','Use Death Grip to pull my warrior to you.',26124),
(117730,'enUS','','Death Grip allows you to reach out to a distant target and pull them toward you. No enemy can escape your icy grasp!',26124),
(117731,'enUS','','Some foes would prefer to keep you at arm\'s length.',26124),
(117732,'enUS','','Your target has maximum Festering Wounds. Use Scourge Strike!',26124),
(117733,'enUS','','Using Scourge Strike after Festering Strike is a potent combination!',26124),
(117734,'enUS','','Use Scourge Strike!',26124),
(117735,'enUS','','Your minion is dead. Cast Raise Dead to summon a new minion.',26124),
(117736,'enUS','','Virulent Plague has expired from your target. Use Outbreak now!',26124),
(117737,'enUS','','Cast Outbreak!',26124),
(117738,'enUS','','Outbreak has expired from your target, use it now!',26124),
(117739,'enUS','','Use Festering Strike!',26124),
(117740,'enUS','','Your target is not infested with Festering Wounds. Use Festering Strike now!',26124),
(117741,'enUS','','Use Death Strike!',26124),
(117742,'enUS','','Use Death Coil!',26124),
(117743,'enUS','','Death Coil is free!  Cast it now!',26124),
(117744,'enUS','You\'re facing multiple enemies. Try using Death and Decay!','',26124),
(117745,'enUS','Now is a good time to cast Dark Transformation!','',26124),
(117746,'enUS','','Cast Army of the Dead!',26124),
(117747,'enUS','','Well done, $p! You are now prepared to do battle as an unholy death knight.',26124),
(117748,'enUS','','Show me you\'ve mastered the powers of darkness!',26124),
(117749,'enUS','','Use Death Strike on the target to recover some of your health.',26124),
(117750,'enUS','','Its dark power damages your foe and recovers a portion of your health.',26124),
(117751,'enUS','','When taking excessive damage in battle, Death Strike can help even the odds.',26124),
(117752,'enUS','Use Death and Decay to dispatch the group of minions.','',26124),
(117753,'enUS','Use Death and Decay to corrupt the ground beneath your feet, dealing damage to all foes in the affected area and empowering some of your attacks to hit additional targets.','',26124),
(117754,'enUS','As a death knight, you control the battlefield!','',26124),
(117755,'enUS','Use Dark Transformation to empower your ghoul.','',26124),
(117756,'enUS','Your undead minion is a valuable asset in battle. Dark Transformation allows you to temporarily transform your ghoul into a hulking monstrosity with increased power and abilities. Try it out!','',26124),
(117757,'enUS','','Your attacks sometimes allow you to cast Death Coil without costing Runic Power. Take advantage of this when you can.',26124),
(117758,'enUS','','Use Death Coil on the target dummy.',26124),
(117759,'enUS','','Your attacks build Runic Power that can be used to cast Death Coil, a spell that hurls a blast of unholy energy at your target and restores energy to your ghoul minion.',26124),
(117760,'enUS','','Try to only use Scourge Strike when your target is affected by Festering Wounds.',26124),
(117761,'enUS','','Use Scourge Strike on the target dummy after it is infected with Festering Strike.',26124),
(117762,'enUS','','Festering Strike followed by Scourge Strike is a one-two punch few enemies can withstand.',26124),
(117763,'enUS','','Oh, that looks like it hurts! After infecting your target with Festering Strike, you are ready to burst the lesions you\'ve caused using Scourge Strike!',26124),
(117764,'enUS','','Use Festering Strike on the target dummy.',26124),
(117765,'enUS','','Festering Strike deals damage and inflicts Festering Wounds on your target.',26124),
(117766,'enUS','','Now that your enemy is reeling from a miasma of plagues, it\'s time to strike up close.',26124),
(117767,'enUS','','Use Outbreak on the target dummy.',26124),
(117768,'enUS','%s has fallen! Your allies retreat.','%s has fallen! Your allies retreat.',26124),
(117769,'enUS','','Outbreak will deal damage over time and unleashes a Virulent Plague that spreads to nearby enemies.',26124),
(117770,'enUS','','The best way to start a fight is to infect your enemy with a host of diseases from a distance.',26124),
(117771,'enUS','','Use Raise Dead to summon your minion.',26124),
(117772,'enUS','','You should always try to have a minion with you.',26124),
(117773,'enUS','','But your greatest ally is death itself. Raise Dead will animate a corpse to serve as your ghoulish minion.',26124),
(117774,'enUS','','Disease wears your enemy down while your strong melee attacks finish them off.',26124),
(117775,'enUS','','As an unholy death knight you command the powers of disease and death.',26124),
(117840,'enUS','','Use Feign Death to trick my soldier into breaking off his attack.',26124),
(117841,'enUS','','When facing certain defeat, use Feign Death to trick your enemies into thinking you\'re no longer a threat.',26124),
(117842,'enUS','','Even the greatest adventurers sometimes find themselves in over their heads.',26124),
(117843,'enUS','','Use Multi-Shot to dispatch all the enemies.',26124),
(117844,'enUS','','Using this attack causes your pet to cleave multiple enemies as well.',26124),
(117845,'enUS','','Multi-shot allows you to fire a spread of projectiles hitting several enemies near your target.',26124),
(117846,'enUS','','Sometimes you\'ll find yourself outnumbered. When you do, you can unleash destruction upon a host of adversaries at once!',26124),
(117847,'enUS','','Your pet has died! When this happens, your Mend Pet ability changes to Revive Pet, which will bring your faithful companion back to life.',26124),
(117848,'enUS','','Use Mend Pet to heal your pet.',26124),
(117849,'enUS','','Mend Pet will allow you to heal damage your pet has taken.',26124),
(117850,'enUS','','Your pet has been wounded! Fortunately, you can aid your trusty companion.',26124),
(117851,'enUS','','Use Kill Command multiple times on the target dummy.',26124),
(117852,'enUS','','Don\'t worry, your pet is resilient! Using Kill Command will cause your pet to perform a strong attack, and is also a great way to initiate a fight.',26124),
(117853,'enUS','','Sending your pet to attack and distract an enemy gives you more time to line up your ranged attacks.',26124),
(117854,'enUS','','Use Call Pet to bring your pet to battle.',26124),
(117855,'enUS','','Alongside your trusty pet, you are the master of your environment. Call Pet will summon your pet to your side.',26124),
(117856,'enUS','','Beast master hunters possess a deep bond with their pets, calling and bolstering them in battle while striking at foes with ranged attacks.',26124),
(117857,'enUS','','Use Multi-Shot!',26124),
(117858,'enUS','','Your pet is hurt! Use Mend Pet!',26124),
(117859,'enUS','','Use Kill Command!',26124),
(117860,'enUS','','Kill Command is available! Use it now!',26124),
(117861,'enUS','','Use Dire Beast!',26124),
(117862,'enUS','','Dire Beast is available! Use it now!',26124),
(117863,'enUS','','Use Cobra Shot!',26124),
(117864,'enUS','','Call your pet!',26124),
(117865,'enUS','','Use Bestial Wrath!',26124),
(117866,'enUS','','Bestial Wrath is available! Use it now!',26124),
(117867,'enUS','','Well done, $p! You are now prepared to do battle as a beast master hunter.',26124),
(117868,'enUS','','Prove to me you have the necessary skill and cunning required to hunt any prey!',26124),
(117869,'enUS','','While under its effects, using Dire Beast will shorten the time before you can trigger Bestial Wrath again.',26124),
(117870,'enUS','','When in combat, Bestial Wrath sends you and your pet into a frenzy of rage that increases your damage for a short time.',26124),
(117871,'enUS','','Use Bestial Wrath while attacking the target dummy.',26124),
(117872,'enUS','','Use Cobra Shot on the target dummy.',26124),
(117873,'enUS','','I\'m sure you\'re ready to join in on the action. Cobra Shot is your primary ranged attack, pummeling your enemy while your pet keeps their attention.',26124),
(117874,'enUS','','Use Dire Beast on the target dummy.',26124),
(117875,'enUS','','Dire Beast will allow you to summon a nearby beast to join the fight and attack your target for a short time.',26124),
(117876,'enUS','','Now let\'s see what other forces of nature you command.',26124),
(117922,'enUS','','Use Blizzard to dispatch this group of enemies.',26124),
(117923,'enUS','','You can pelt a target location with shards of ice by using a potent spell called Blizzard. Great name, don\'t you think?',26124),
(117924,'enUS','','You are master of dealing damage to many enemies at once.',26124),
(117925,'enUS','','Remember that Ice Lance does extra damage to frozen targets, so using Frost Nova and Ice Lance together is a powerful tactic.',26124),
(117926,'enUS','','Freeze my warrior using Frost Nova.',26124),
(117927,'enUS','','Frost Nova freezes nearby enemies in place, allowing you to move away and destroy them safely. For now, let\'s just practice freezing them in place.',26124),
(117928,'enUS','','What if you could freeze foes in their tracks, preventing them from even reaching you?',26124),
(117929,'enUS','','Practice using Blink.',26124),
(117930,'enUS','','Blink allows you to teleport a short distance to avoid danger or close in on an enemy.',26124),
(117931,'enUS','','But using your legs is so mundane! Fortunately, you have a spell that befits a master of the magical arts.',26124),
(117932,'enUS','','The battlefield can be a dangerous place, so moving about is crucial to your survival.',26124),
(117933,'enUS','','Your Water Elemental has died. Cast Summon Water Elemental to call it back!',26124),
(117934,'enUS','','Use Invisibility!',26124),
(117935,'enUS','','Wait until you have Fingers of Frost, or your target is frozen, to use Ice Lance.',26124),
(117936,'enUS','','Your target is frozen! Use Ice Lance!',26124),
(117937,'enUS','','Use Ice Lance!',26124),
(117938,'enUS','','Fingers of Frost has triggered! Use Ice Lance now!',26124),
(117939,'enUS','','Cast Ice Barrier!',26124),
(117940,'enUS','','Use Frozen Orb!',26124),
(117941,'enUS','','Frozen Orb is available! Cast it now!',26124),
(117942,'enUS','','Use Frostbolt!',26124),
(117943,'enUS','','Use Frost Nova!',26124),
(117944,'enUS','','You need to freeze your enemy in place before they reach you.',26124),
(117945,'enUS','','Use Frost Nova!',26124),
(117946,'enUS','','Cast Blizzard!',26124),
(117947,'enUS','','Well done, $p! You are now prepared to do battle as an ice mage.',26124),
(117948,'enUS','','Show me the raw power and superiority you wield!',26124),
(117949,'enUS','','Use Invisibility to escape combat.',26124),
(117950,'enUS','','Use it and enemies will be unable to target you, letting you escape form combat. But be careful! It doesn\'t last long.',26124),
(117951,'enUS','','Need to get out of a fight in a hurry? Invisibility is a great spell for getting out of a sticky situation.',26124),
(117952,'enUS','','Use Ice Barrier to reduce incoming damage.',26124),
(117953,'enUS','','In those cases, a little bit of extra protection is needed. Ice Barrier creates a shield of ice to absorb enemy attacks.',26124),
(117954,'enUS','','Despite your best efforts, you may not be able to prevent an enemy from reaching you.',26124),
(117955,'enUS','','Use Frozen Orb on the target dummy.',26124),
(117956,'enUS','','Be careful, though, as it hits all enemies in its path, not just your target.',26124),
(117957,'enUS','','Another potent spell you can wield is Frozen Orb. Cast this spell whenever it is available, as it can make your Ice Lance more powerful.',26124),
(117958,'enUS','','Use Frost Bolt on the target dummy until you trigger Fingers of Frost. While the effect is active, use Ice Lance.',26124),
(117959,'enUS','','Use Frostbolt on the target dummy until it triggers Fingers of Frost, Then use Ice Lance.',26124),
(117960,'enUS','','Frostbolt occasionally triggers the Fingers of Frost effect, which gives a huge boost to Ice Lance damage. Let\'s test it out.',26124),
(117961,'enUS','','There is one more way that Ice Lance can be used to maximize its power.',26124),
(117962,'enUS','','Use Ice Lance on the frozen target dummy.',26124),
(117963,'enUS','','Ice Lance\'s real power lies in using it against a frozen target, which greatly increases its damage.',26124),
(117964,'enUS','','Now we\'ll take a look at Ice Lance. It\'s similar to Frostbolt, but can be cast instantly, albeit for less damage.',26124),
(117965,'enUS','','Use Frostbolt on the target dummy.',26124),
(117966,'enUS','','This long-range attack will damage and slow your enemies, and has a chance to empower other attacks.',26124),
(117967,'enUS','','Your most fundamental and reliable attack is Frostbolt.',26124),
(117968,'enUS','','Use Summon Water Elemental to summon your pet.',26124),
(117969,'enUS','','Your mastery of ice allows you to call forth a water elemental pet, so we\'ll start there.',26124),
(117970,'enUS','','As a frost mage you excel at controlling the battlefield by freezing enemies in place as ice and hail pummel them into submission.',26124),
(117971,'enUS','','Use Effuse to replenish your health to full.',26124),
(117972,'enUS','','Taking damage is part of battle, but you can tap the spiritual mists to heal yourself or an ally. Use Effuse to heal your wounds.',26124),
(117973,'enUS','','Practice using Roll a few times.',26124),
(117974,'enUS','','Your primary means of mobility is Roll, which causes you to quickly roll a good distance in whatever direction you are moving.',26124),
(117975,'enUS','','You are fast and agile, able to zip around the battlefield at will.',26124),
(117976,'enUS','','Use Tiger Palm!',26124),
(117977,'enUS','','Use Tiger Palm to generate Chi!',26124),
(117978,'enUS','','Roll, roll, roll!',26124),
(117979,'enUS','','Use Rising Sun Kick!',26124),
(117980,'enUS','','Rising Sun Kick is available! Use it now!',26124),
(117981,'enUS','','Use Flying Serpent Kick!',26124),
(117982,'enUS','','Use Fists of Fury!',26124),
(117983,'enUS','','Fists of Fury is available! Use it now!',26124),
(117984,'enUS','','Heal yourself with Effuse!',26124),
(117985,'enUS','','You have maximum Chi! Use Blackout Kick!',26124),
(117986,'enUS','','Use Blackout Kick!',26124),
(117987,'enUS','','Well done, $p! You are now prepared to do battle as a monk.',26124),
(117988,'enUS','','Show me the power and agility of windwalking!',26124),
(117989,'enUS','','Paralyze the soldier who attacks you.',26124),
(117990,'enUS','','Take one enemy out of the fight by paralyzing him! Paralyze will knock out an enemy for a short time, but the foe will recover if he takes any damage.',26124),
(117991,'enUS','','Sometimes you might get in over your head, facing more enemies than you can handle.',26124),
(117992,'enUS','','Use Flying Serpent Kick to travel to the target dummy and damage it.',26124),
(117993,'enUS','','Use Flying Serpent Kick to launch yourself at your enemy. Using it a second time while you are in the air will end your flight and deal damage to enemies nearby.',26124),
(117994,'enUS','','Roll is not your only ability for mobility. Windwalker monks can also launch themselves through the air, flying at their targets.',26124),
(117995,'enUS','','Use Fists of Fury on the target dummy.',26124),
(117996,'enUS','','It will also hit additional enemies near your target. Use Fists of Fury whenever it\'s available, or if you face multiple enemies.',26124),
(117997,'enUS','','You have an abundance of attacks at your disposal, windwalker! Fists of Fury costs 3 Chi and does a lot of damage.',26124),
(117998,'enUS','','Use Blackout Kick on the target dummy.',26124),
(117999,'enUS','','It hits much harder than Tiger Palm, so use Blackout Kick to spend your extra Chi.',26124),
(118000,'enUS','','While not as powerful as Rising Sun Kick, your Blackout Kick still packs a punch... or, uh, a kick!',26124),
(118001,'enUS','','Use Rising Sun Kick on the target dummy.',26124),
(118002,'enUS','','Use it whenever it is available.',26124),
(118003,'enUS','','Starting combat with Tiger Palm gives you enough Chi to unleash the powerful Rising Sun Kick, an attack that uses 2 Chi and deals substantial damage.',26124),
(118004,'enUS','','Use Tiger Palm on the target dummy.',26124),
(118005,'enUS','','Start by using your primary attack, Tiger Palm, to deal damage and generate Chi.',26124),
(118006,'enUS','','This builds up Chi, a resource that allows you to unleash your most powerful attacks.',26124),
(118007,'enUS','','As a windwalker monk you use your fists and your speed to overcome enemies.',26124),
(118008,'enUS','','Use Flash of Light to heal your wounds.',26124),
(118009,'enUS','','Your conviction allows you to heal yourself and your allies. Flash of Light is a cornerstone of your healing arsenal.',26124),
(118010,'enUS','','Divine Shield protected you from the mage\'s first attack, but the second attack has left you wounded.',26124),
(118011,'enUS','','Divine Shield will completely protect you from all attacks for a short period of time, so save it for emergencies.',26124),
(118012,'enUS','','Use Divine Shield to make yourself temporarily invulnerable to all damage!',26124),
(118013,'enUS','','Divine Shield prevents incoming attacks from harming you.',26124),
(118014,'enUS','','You will face many dangerous situations, and preparation can be the key to your survival.',26124),
(118015,'enUS','','You\'re at maximum Holy Power already! Use Templar\'s Verdict!',26124),
(118016,'enUS','','Use Templar\'s Verdict!',26124),
(118017,'enUS','','Templar\'s Verdict is available! Use it now!',26124),
(118018,'enUS','','Cast Judgment!',26124),
(118019,'enUS','','Judgment is available!  Cast it now!',26124),
(118020,'enUS','','Judgment is a ranged ability. Try using it from further away!',26124),
(118021,'enUS','','Use Flash of Light to heal yourself!',26124),
(118022,'enUS','','Use Divine Shield!',26124),
(118023,'enUS','','You\'re in trouble! Cast Divine Shield to save yourself!',26124),
(118024,'enUS','','Use Crusader Strike!',26124),
(118025,'enUS','','Use Crusader Strike to generate Holy Power!',26124),
(118026,'enUS','','Cast Blade of Justice!',26124),
(118027,'enUS','','Blade of Justice is available!  Cast it now!',26124),
(118028,'enUS','','Well done, $p! You are now prepared to do battle as a retribution paladin.',26124),
(118029,'enUS','','Show me your courage and zeal in the heat of combat!',26124),
(118030,'enUS','','Build up Holy Power by using your attacks, then use Templar\'s Verdict on this target dummy.',26124),
(118031,'enUS','','Unleash this divine magic through Templar\'s Verdict, a powerful melee attack that infuses your weapon with the strength of the Light.',26124),
(118032,'enUS','','Using Blade of Justice and Crusader Strike in combat builds up Holy Power.',26124),
(118033,'enUS','','Use Crusader Strike on this target dummy.',26124),
(118034,'enUS','','Once your foe has closed to striking range, unleash your weapon using Crusader Strike.',26124),
(118035,'enUS','','Blade of Justice is an excellent tool to deal damage as your opponent approaches.',26124),
(118036,'enUS','','Use Blade of Justice on this target dummy.',26124),
(118037,'enUS','','As your enemy closes in, unleash a potent mid-range attack called Blade of Justice.',26124),
(118038,'enUS','','Judgment can be used on enemies at a distance or up close whenever it is available.',26124),
(118039,'enUS','','Use Judgment on this target dummy.',26124),
(118040,'enUS','','Your devotion to the Light empowers you to hurl a mighty hammer of Judgment at your foes.',26124),
(118041,'enUS','','Your attacks are a mix of ranged spells and melee that build up and unleash Holy Power.',26124),
(118042,'enUS','','As a retribution paladin you are a stalwart protector of the weak, a bringer of punishment to the unjust!',26124),
(118043,'enUS','','Use Plea to heal your wounds.',26124),
(118044,'enUS','','This presents no problem for you however. The Light gives you the power to restore the health of yourself or your allies.',26124),
(118045,'enUS','','Power Word: Shield protected you from the mage\'s first attack, but the second attack has left you wounded.',26124),
(118046,'enUS','','Use Psychic Scream to prevent this group of enemies from hitting you.',26124),
(118047,'enUS','','Fortunately, you are not defenseless in such cases. Psychic Scream terrifies nearby opponents, causing them to run away in fear.',26124),
(118048,'enUS','','In some battles you will face multiple opponents at the same time.',26124),
(118049,'enUS','','Use Power Word: Shield to prevent this incoming damage.',26124),
(118050,'enUS','','Always remember to maintain your shield during fights.',26124),
(118051,'enUS','','One of your most useful defensive abilities is Power Word: Shield, which absorbs all damage from attacks when active.',26124),
(118052,'enUS','','As followers of the light, you have many ways to protect and restore health.',26124),
(118053,'enUS','','Cast Smite!',26124),
(118054,'enUS','','There\'s no need to recast Shadow Word: Pain when the previous one still has lots of time left on it.',26124),
(118055,'enUS','','Cast Shadow Word: Pain!',26124),
(118056,'enUS','','Shadow Word: Pain has expired on your target, cast it again!',26124),
(118057,'enUS','','Use Psychic Scream!',26124),
(118058,'enUS','','Cast Power Word: Shield to protect yourself!',26124),
(118059,'enUS','','Use Plea to heal yourself!',26124),
(118060,'enUS','','Cast Penance now!',26124),
(118061,'enUS','','Penance is available!  Cast it now!',26124),
(118062,'enUS','','Well done, $p! You are now prepared to do battle as a discipline priest.',26124),
(118063,'enUS','','Command the forces of Shadow and Light to achieve victory!',26124),
(118064,'enUS','','Use Smite on the target dummy.',26124),
(118065,'enUS','','It is your most frequently used damage spell, best used when Penance is not available.',26124),
(118066,'enUS','','The power of the Light allows you to Smite any enemy that stands before you!',26124),
(118067,'enUS','','Use Penance on the target dummy.',26124),
(118068,'enUS','','Penance is a potent spell that deals damage to your enemies. Use Penance whenever it is available.',26124),
(118069,'enUS','','The Light is a formidable ally, capable of restoring your friends or striking down foes.',26124),
(118070,'enUS','','Once your target is afflicted with Shadow Word: Pain, you don\'t need to cast it again until your original spell is close to expiring.',26124),
(118071,'enUS','','Use Shadow Word: Pain on the target dummy.',26124),
(118072,'enUS','','Shadow Word: Pain taints your foes with shadow energy, wounding them slowly over time.',26124),
(118073,'enUS','','Discipline priests draw upon the opposing forces of Light and Shadow, choosing when to heal and when to inflict damage.',26124),
(118074,'enUS','','Use Vanish to evade my warrior.',26124),
(118075,'enUS','','Sometimes a strategic retreat is necessary so you can live to fight another day.',26124),
(118076,'enUS','','There\'s just one last thing you need to learn.',26124),
(118077,'enUS','','You\'re in trouble! Use Vanish!',26124),
(118078,'enUS','','Starting combat from stealth is more effective.',26124),
(118079,'enUS','','Use Shadowstep!',26124),
(118080,'enUS','','Use Rupture!',26124),
(118081,'enUS','','You have 5 combo points. Use Rupture!',26124),
(118082,'enUS','','Use Deadly Poison on your weapon.',26124),
(118083,'enUS','','Use Mutilate to generate combo points!',26124),
(118084,'enUS','','Use Mutilate!',26124),
(118085,'enUS','','Use Garrote!',26124),
(118086,'enUS','','Use Garrote to bleed your enemy!',26124),
(118087,'enUS','','Use Fan of Knives!',26124),
(118088,'enUS','','You\'re facing multiple enemies, try using Fan of Knives!',26124),
(118089,'enUS','','Use Envenom!',26124),
(118090,'enUS','','You have 5 combo points. Use Envenom!',26124),
(118091,'enUS','','Use Crimson Vial to restore health!',26124),
(118092,'enUS','','Well done, $p! You are now prepared to do battle as an assassination rogue.',26124),
(118093,'enUS','','Show me you\'ve got the stuff, $p!',26124),
(118094,'enUS','','Use Fan of Knives to dispatch this group of enemies.',26124),
(118095,'enUS','','Fan of Knives unleashes damage on all enemies encircling you. It will also generate a combo point for every enemy hit.',26124),
(118096,'enUS','','Enemies that try to surround you will be in for a nasty surprise!',26124),
(118097,'enUS','','Use Shadowstep to appear behind a distant target.',26124),
(118098,'enUS','','By using Shadowstep, you will remain in stealth and be poised to strike.',26124),
(118099,'enUS','','There are times that you might want to close in on a target but not deal damage right away.',26124),
(118100,'enUS','','Use Crimson Vial to restore some of your health.',26124),
(118101,'enUS','','Crimson Vial is an alchemical concoction that will restore a portion of your health.',26124),
(118102,'enUS','','You\'ve taken some damage, but luckily a crafty rogue plans ahead.',26124),
(118103,'enUS','','Use Envenom with 5 combo points.',26124),
(118104,'enUS','','If your target is already affected by Rupture, then using Envenom with 5 combo points deals good damage and maximizes the effect of your poisons.',26124),
(118105,'enUS','','Rupture is not your only finishing move.',26124),
(118106,'enUS','','Use Rupture with 5 combo points.',26124),
(118107,'enUS','','Whenever you use Rupture with 5 combo points, you will do a strong bleeding attack that damages enemies over time.',26124),
(118108,'enUS','','Now that you\'ve built up 5 combo points, it\'s time to use Rupture.',26124),
(118109,'enUS','','Use Mutilate to attack the target dummy.',26124),
(118110,'enUS','','Your main attack is called Mutilate. It deals damage as well as generates combo points that can be used for powerful finishing moves.',26124),
(118111,'enUS','','Always remember to use Garrote to keep your enemies bleeding.',26124),
(118112,'enUS','','Use Garrote on this target dummy.',26124),
(118113,'enUS','','The best way to start a fight is with Garrote, a debilitating bleeding attack that causes your enemy to take damage over time.',26124),
(118114,'enUS','','As an assassin, you weaken your enemies before finishing them off.',26124),
(118115,'enUS','','Use Stealth to fade from view.',26124),
(118116,'enUS','','Stealth makes you invisible to most enemies. When in Stealth, you can close the distance to enemies undetected.',26124),
(118117,'enUS','','Assassins favor trickery and cunning. And what\'s trickier than attacking before your target sees you coming?',26124),
(118118,'enUS','','Use Deadly Poison to coat your weapon with poison for one hour.',26124),
(118119,'enUS','','Before we get started we need to apply poison to your weapon.',26124),
(118120,'enUS','','As an assassination rogue you specialize in striking from the shadows, dispatching foes with a variety of poisons and bleeding attacks.',26124),
(118121,'enUS','','Use Fire Elemental now to summon your elemental!',26124),
(118122,'enUS','','As a master of the elements, you are able to coalesce primal elemental forces into physical form to aid you in battle.',26124),
(118123,'enUS','','Use Healing Surge to replenish your health to full.',26124),
(118124,'enUS','','Just as the elements can destroy, they also have the power to restore.',26124),
(118125,'enUS','','You\'ve taken damage, but this presents no problem for you.',26124),
(118126,'enUS','','Use Chain Lightning against several enemies at once.',26124),
(118127,'enUS','','When you strike an enemy with Chain Lightning, it jumps to additional foes near your target, damaging all of them.',26124),
(118128,'enUS','','There are times you\'ll face multiple opponents on the battlefield. Fortunately, you have a potent ability called Chain Lightning.',26124),
(118129,'enUS','','Turn my warrior into a frog!',26124),
(118130,'enUS','','Your target won\'t attack you while it\'s a frog, but the effect is temporary. The enemy will revert back to its original form if attacked.',26124),
(118131,'enUS','','Ever wanted to turn someone into a frog? Hex allows you to do just that!',26124),
(118132,'enUS','','Use Thunderstorm to knock enemies away!',26124),
(118133,'enUS','','Use Lightning Bolt!',26124),
(118134,'enUS','','Using Lava Burst after your enemy is burning from Flame Shock increases its damage!',26124),
(118135,'enUS','','Use Lava Burst!',26124),
(118136,'enUS','','Use Lava Burst while your enemy is burning!',26124),
(118137,'enUS','','Heal yourself with Healing Surge!',26124),
(118138,'enUS','','Only use Flame Shock when it\'s about to expire!',26124),
(118139,'enUS','','Use Flame Shock!',26124),
(118140,'enUS','','Use Flame Shock to burn your enemy!',26124),
(118141,'enUS','','Use Fire Elemental!',26124),
(118142,'enUS','','Wait until you are at maximum Maelstrom to use Earth Shock!',26124),
(118143,'enUS','','Use Earth Shock!',26124),
(118144,'enUS','','You are at maximum Maelstrom! Use Earth Shock!',26124),
(118145,'enUS','','Use Chain Lightning!',26124),
(118146,'enUS','','Well done, $p! You are now prepared to do battle as an elemental shaman.',26124),
(118147,'enUS','','Unleash the elements to achieve victory, $p!',26124),
(118148,'enUS','','Use Thunderstorm to knock away the enemies surrounding you.',26124),
(118149,'enUS','','If you become surrounded in combat, use Thunderstorm to knock enemies back and give yourself some breathing room.',26124),
(118150,'enUS','','Use your Lightning Bolt on the Target Dummy until you have the maximum amount of Maelstrom, then use Earth Shock.',26124),
(118151,'enUS','','Use Earth Shock on this target dummy.',26124),
(118152,'enUS','','Earth Shock is one of your most powerful spells. Casting it requires Maelstrom, a resource generated by your other attacks.',26124),
(118153,'enUS','','Use Lightning Bolt on the target dummy.',26124),
(118154,'enUS','','Use Lightning Bolt whenever other abilities are not available.',26124),
(118155,'enUS','','Hurling lightning from your hands is your main weapon for overcoming enemies.',26124),
(118156,'enUS','','Use Lava Burst on the target dummy.',26124),
(118157,'enUS','','Using Lava Burst while your enemies are affected by Flame Shock increases its damage.',26124),
(118158,'enUS','','Why stop with fire? Once your enemies are burning, you can hurl molten lava at them.',26124),
(118159,'enUS','','Use Flame Shock on the target dummy.',26124),
(118160,'enUS','','Excellent! Always remember to use Flame Shock to keep your enemies burning.',26124),
(118161,'enUS','','Your Flame Shock ability will set your enemies ablaze, burning them while you cast other spells.',26124),
(118162,'enUS','','As an elemental shaman you commune with ancient spirits and command primal elemental forces.',26124),
(118163,'enUS','','Use Feral Spirit if you need to boost your damage in a fight!',26124),
(118164,'enUS','','Should you find yourself in trouble during combat, you can summon two feral wolf spirits to fight at your side.',26124),
(118165,'enUS','','You share a kinship with animal spirits such as wolves.',26124),
(118166,'enUS','','Use Stormstrike!',26124),
(118167,'enUS','','Stormbringer has triggered! Use Stormstrike now!',26124),
(118168,'enUS','','Use Rockbiter!',26124),
(118169,'enUS','','Use Rockbiter to generate Maelstrom!',26124),
(118170,'enUS','','You have maximum Maelstrom. Use Lava Lash!',26124),
(118171,'enUS','','Use Lava Lash!',26124),
(118172,'enUS','','Lava Lash is available! Use it now!',26124),
(118173,'enUS','','Use Flametongue!',26124),
(118174,'enUS','','Your Flametongue buff has expired! Use Flametongue!',26124),
(118175,'enUS','','Use Feral Spirit!',26124),
(118176,'enUS','','Use Crash Lightning!',26124),
(118177,'enUS','','Well done, $p! You are now prepared to do battle as an enhancement shaman.',26124),
(118178,'enUS','','Show me you fight with the fury of the elements!',26124),
(118179,'enUS','','Use Shamanistic Rage to reduce incoming damage.',26124),
(118180,'enUS','','If you find yourself taking too much punishment in a fight, Shamanistic Rage reduces incoming damage for a short period of time. Try it!',26124),
(118181,'enUS','','Use Crash Lightning to dispatch this group of enemies.',26124),
(118182,'enUS','','Crash Lightning deals damage to all targets in front of you. Hitting multiple enemies empowers your weapons, dealing even more damage!',26124),
(118183,'enUS','','If you are fighting multiple enemies, it is time to unleash the full fury of the storm!',26124),
(118184,'enUS','','Use Stormstrike now!',26124),
(118185,'enUS','','Use Stormstrike on the target dummy after Stormbringer triggers.',26124),
(118186,'enUS','','Try to use Stormstrike whenever Stormbringer triggers.',26124),
(118187,'enUS','','Your most powerful Maelstrom-fueled ability is Stormstrike.',26124),
(118188,'enUS','','Use Lava Lash on the target dummy.',26124),
(118189,'enUS','','Lava Lash uses Maelstrom to charge your off-hand weapon with lava, allowing you to deal a mighty blow.',26124),
(118190,'enUS','','Using Rockbiter generates Maelstrom, a resource that powers stronger attacks.',26124),
(118191,'enUS','','Use Rockbiter on the target dummy.',26124),
(118192,'enUS','','Rockbiter empowers your weapons with the forces of earth to deal damage.',26124),
(118193,'enUS','','Now that your weapons are burning, you can focus on your primary attack.',26124),
(118194,'enUS','','Use Flametongue on the target dummy.',26124),
(118195,'enUS','','The first attack we\'ll try is Flametongue, which emblazes your weapons and scorches your enemy with fire.',26124),
(118196,'enUS','','As an enhancement shaman you channel the elemental forces directly into your weapons to make yourself a furious melee combatant, beating down your foes with the power of flame, earth, and storm.',26124),
(118197,'enUS','','Use Soulstone to survive death.',26124),
(118198,'enUS','','Using your Soulstone ability preserves your very soul for later. Don\'t worry, you weren\'t using it anyway! With your soul stored, you can return from the dead at will.',26124),
(118199,'enUS','','A well-prepared warlock can survive almost anything... even death!',26124),
(118200,'enUS','','Astounding! Your mastery over demons has given you great power!',26124),
(118201,'enUS','','Now, heal some of the damage you\'ve taken with your Healthstone.',26124),
(118202,'enUS','','Now, heal some of the damage you\'ve taken with your Healthstone.',26124),
(118203,'enUS','','Use Create Healthstone.',26124),
(118204,'enUS','','A portion of your power can be coalesced into a Healthstone. If you take damage, ingest the Healthstone to recover health.',26124),
(118205,'enUS','','Use Summon Doomguard now to summon this demon.',26124),
(118206,'enUS','','You can\'t do this often, so save this demon for an emergency.',26124),
(118207,'enUS','','While greater demons like Infernals and Doomguards cannot be controlled for long, you can summon one to your side for short periods of time to fight for you.',26124),
(118208,'enUS','','Use Fear to frighten my warrior.',26124),
(118209,'enUS','','To force a foe to stop fighting for a short time, utilize fear itself to strike terror into their heart.',26124),
(118210,'enUS','','At times you may find yourself overwhelmed by multiple enemies, or a single enemy that is too strong for you.',26124),
(118211,'enUS','','Use Life Tap to replenish your mana reserves.',26124),
(118212,'enUS','','Life Tap allows you to steal your own life force to replenish your mana. Don\'t worry, you can always drain the life from your opponent to heal.',26124),
(118213,'enUS','','Many spells have a heavy mana cost. But you have a clever way around this problem.',26124),
(118214,'enUS','','Use Summon Voidwalker to summon your demonic minion.',26124),
(118215,'enUS','','Your command of dark magic enables you to summon a demon servant to do your bidding.',26124),
(118216,'enUS','','Affliction warlocks use shadow magic and disease to wear down their enemies, then drain their very life essences to empower themselves.',26124),
(118217,'enUS','','You have maximum Soul Shards. Cast Unstable Affliction!',26124),
(118218,'enUS','','Use Unstable Affliction!',26124),
(118219,'enUS','','Unstable Affliction is available! Cast it now!',26124),
(118220,'enUS','','Your Voidwalker has died. Use Summon Voidwalker to bring it back.',26124),
(118221,'enUS','','Use Life Tap to replenish your mana!',26124),
(118222,'enUS','','You\'re low on health, use your Healthstone!',26124),
(118223,'enUS','','Cast Fear!',26124),
(118224,'enUS','','Use Drain Life!',26124),
(118225,'enUS','','Use Drain Life on your target!',26124),
(118226,'enUS','','Summon your Doomguard now!',26124),
(118227,'enUS','','Use Corruption!',26124),
(118228,'enUS','','Corruption has expired! Cast it again!',26124),
(118229,'enUS','','Recast Agony just before it expires to preserve its amplified damage!',26124),
(118230,'enUS','','Use Agony!',26124),
(118231,'enUS','','Agony has expired! Cast it again!',26124),
(118232,'enUS','','Well done, $p! You are now prepared to do battle as an affliction warlock.',26124),
(118233,'enUS','','But please, don\'t hurt them too badly. I need them for later.',26124),
(118234,'enUS','','While Unstable Affliction deals damage over time, every re-cast increases its potency. Use this attack whenever you can!',26124),
(118235,'enUS','','Use Unstable Affliction on this target dummy.',26124),
(118236,'enUS','','Unstable Affliction is a powerful spell that deals damage over time like Agony and Corruption, but uses a Soul Shard to deal more damage.',26124),
(118237,'enUS','','As Agony damages your enemy, it has a chance to generate a Soul Shard. You can use these shards to empower new abilities.',26124),
(118238,'enUS','','Use Drain Soul on the target dummy.',26124),
(118239,'enUS','','Drain Soul is the most frequent attack you will use, healing you as it damages your foe.',26124),
(118240,'enUS','','After afflicting your target with Agony and Corruption, you can begin to drain the very life from them.',26124),
(118241,'enUS','','Once you cast Corruption, you don\'t need to cast it again until your original spell is close to expiring.',26124),
(118242,'enUS','','Use Corruption on this target dummy.',26124),
(118243,'enUS','','Corruption is a spell that afflicts its target, dealing shadow damage as long as the affliction lasts.',26124),
(118244,'enUS','','You will inflict suffering on anyone foolish enough to fight you.',26124),
(118245,'enUS','','Once you cast Agony, you don\'t need to cast it again until your original spell is close to expiring.',26124),
(118246,'enUS','','Use Agony on the target dummy.',26124),
(118247,'enUS','','Agony deals more and more damage over time, making it a great way to start a fight.',26124),
(118248,'enUS','','Agony is an appropriate name for your first attack ability.',26124),
(118249,'enUS','','Practice using Heroic Leap.',26124),
(118250,'enUS','','Heroic Leap allows you to bound across the battlefield to accomplish either goal.',26124),
(118251,'enUS','','In the heat of battle there will be times you need to move quickly to avoid danger... or confront it!',26124),
(118252,'enUS','','Use Whirlwind to take out this group of enemies.',26124),
(118253,'enUS','','Whirlwind allows you to swing your weapon in wide arcs, cutting a swath of carnage into all enemies around you.',26124),
(118254,'enUS','','Your opponents may try to overwhelm you with numbers, but they underestimate your true might!',26124),
(118255,'enUS','','Use Whirlwind!',26124),
(118256,'enUS','','Whirlwind can damage multiple enemies!',26124),
(118257,'enUS','','Use Victory Rush!',26124),
(118258,'enUS','','Victory Rush is available! Use it now!',26124),
(118259,'enUS','','Use Slam!',26124),
(118260,'enUS','','Use Mortal Strike!',26124),
(118261,'enUS','','Mortal Strike is available!  Use it now!',26124),
(118262,'enUS','','Use Colossus Smash!',26124),
(118263,'enUS','','Colossus Smash is available! Use it now!',26124),
(118264,'enUS','','Use Cleave!',26124),
(118265,'enUS','','Warriors don\'t stroll up to face a foe! Use Charge to close the distance on your opponent. Try it!',26124),
(118266,'enUS','','Well done, $p! You are now prepared to do battle as an arms warrior.',26124),
(118267,'enUS','','Show me you fight with fearlessness and ferocity!',26124),
(118268,'enUS','','Use Cleave and Whirlwind to take out this group of enemies.',26124),
(118269,'enUS','','Cleave allows you to attack several enemies that are in front of you. For every enemy hit, your next Whirlwind does additional damage!',26124),
(118270,'enUS','','Whirlwind is not the only attack you can use against multiple enemies.',26124),
(118271,'enUS','','Eliminate an enemy, enabling Victory Rush to be used on your next opponent.',26124),
(118272,'enUS','','Your Victory Rush ability can only be used during this time, restoring health as you strike a new enemy.',26124),
(118273,'enUS','','After you defeat an opponent, your heart will sing with the glory of victory!',26124),
(118274,'enUS','','Use Colossus Smash on the Target Dummy.',26124),
(118275,'enUS','','One of your most devastating attacks is Colossus Smash. Always use it as soon as it becomes available and no foe will stand against you for long.',26124),
(118276,'enUS','','Use Slam on the target dummy.',26124),
(118277,'enUS','','Dealing damage to your enemy builds up Rage, which fuels your attacks. Use Slam to spend Rage and deal damage to your enemy.',26124),
(118278,'enUS','','Use Mortal Strike on the target dummy.',26124),
(118279,'enUS','','Mortal Strike is such an attack. Use it whenever it is available.',26124),
(118280,'enUS','','Once you reach your target you will perform basic attacks automatically, but a skilled combatant unleashes a variety of advanced abilities to defeat a foe.',26124),
(118281,'enUS','','Use your Charge ability to cover the distance to this target dummy.',26124),
(118282,'enUS','','But you cannot defeat an opponent that\'s out of reach. Fortunately, you have a skill to solve this problem.',26124),
(118283,'enUS','','Arms warriors are the ultimate physical combatants, using martial skill and weaponry to crush those who stand against them.',26124),
(118284,'enUS','Behold! The Altar of Light and Shadow shall infuse your weapon with its might!','',26124),
(118339,'enUS','The Light is willing to serve.','The Light is willing to serve.',26124),
(118340,'enUS','Yikes. What the heck is goin\' on around here?','',26124),
(118384,'enUS','','Tougher enemies may require a diverse set of abilities to overcome.',26124),
(118385,'enUS','','Use Tiger\'s Fury to restore some energy and then attack the target dummy with Shred.',26124),
(118386,'enUS','','Tiger\'s Fury restores some energy and also increases your damage for a short time.',26124),
(118387,'enUS','','Most of your attacks require energy to use. You might find yourself low on energy at times, rendering you unable to use any abilities.',26124),
(118388,'enUS','','Use Rake on the target dummy.',26124),
(118389,'enUS','','Rake inflicts its damage over time, so you don\'t need to use it again until your target is no longer affected by it.',26124),
(118390,'enUS','','Your Shred ability also deals extra damage to bleeding targets, so these are great abilities to use together.',26124),
(118391,'enUS','','Rake will cause your target to bleed, wounding them over time.',26124),
(118392,'enUS','','Once you\'ve reached your prey in stealth, it\'s time to ambush them.',26124),
(118393,'enUS','','When you have 5 combo points, use Ferocious Bite on the target dummy.',26124),
(118394,'enUS','','Try to use it when you have a full 5 combo points.',26124),
(118395,'enUS','','Ferocious Bite is a finishing move that deals increased damage the more combo points you have.',26124),
(118396,'enUS','','Both your Shred and Rake abilities generate combo points which can fuel powerful finishing moves.',26124),
(118397,'enUS','','Use Shred on the target dummy while it\'s bleeding from Rake.',26124),
(118398,'enUS','','Though powerful on its own, using Shred on a bleeding target increases its damage, so try keeping rake up.',26124),
(118399,'enUS','','Your primary attack is Shred.',26124),
(118400,'enUS','','Stealth lasts until you cancel it, attack, or take damage.',26124),
(118401,'enUS','','Use Prowl to enter stealth.',26124),
(118402,'enUS','','As a cat you can move with uncanny stealth, allowing you to approach your enemies undetected. Prowl puts you in stealth mode.',26124),
(118403,'enUS','','Use Cat Form and assume the form of a cat.',26124),
(118404,'enUS','','Soon they\'ll be weak enough for you to go for the throat with a mighty finishing move.',26124),
(118405,'enUS','','As a feral druid your main weapon is shapeshifting. In Cat Form, your claws and fangs rip and bleed your opponents.',26124),
(118406,'enUS','','You are not in Cat Form!',26124),
(118407,'enUS','','You need to be in Cat Form to fight!',26124),
(118408,'enUS','','Well done, $p! You are now prepared to do battle as a feral druid.',26124),
(118409,'enUS','','Show me you fight with savagery and cunning!',26124),
(118410,'enUS','','Thrash continues to damage your foes for a short period, so you don\'t need to use it again until your targets stops being affected by it.',26124),
(118411,'enUS','','Use Thrash to damage several enemies at once.',26124),
(118412,'enUS','','Thrash will damage all nearby enemies, causing them to bleed for a short time.',26124),
(118413,'enUS','','When fighting multiple enemies at once a feral druid can become a whirlwind of fangs and claws, damaging everything around them.',26124),
(118414,'enUS','','Use Swipe to damage several enemies at once.',26124),
(118415,'enUS','','Swipe deals damage to all nearby foes, but that damage is increased if your targets are bleeding. It\'s a good idea to use Thrash and Swipe together.',26124),
(118416,'enUS','','Thrash isn\'t your only tool for fighting multiple enemies.',26124),
(118417,'enUS','','Use Survival Instincts to reduce incoming damage.',26124),
(118418,'enUS','','Survival Instincts reduces incoming damage for a short time. Save it for when you really need it!',26124),
(118419,'enUS','','When in Cat Form you can rely on the instincts of an animal to help pull you through a tough fight.',26124),
(118420,'enUS','','Use Entangling Roots to root my soldier to the ground.',26124),
(118421,'enUS','','Entangling Roots will cause plant roots to spring from the ground and hold the target in place for a short time.',26124),
(118422,'enUS','','Sometimes you need an enemy to stay put so you can close the distance to them... or make a hasty retreat.',26124),
(118423,'enUS','','Use Rip on the target dummy with five combo points.',26124),
(118424,'enUS','','Like Ferocious Bite, Rip is a finishing move, and is best used when you have 5 combo points.',26124),
(118425,'enUS','','As an alternative to Ferocious Bite, Rip can be used to deal bleeding damage over time to your target, and is a good ability to spend combo points on early in a fight.',26124),
(118426,'enUS','','Use Cat Form.',26124),
(118427,'enUS','','Using spells will usually pull you out of shapeshift forms. Don\'t forget to return to cat form for combat.',26124),
(118428,'enUS','','Use Regrowth to restore yourself to full health.',26124),
(118429,'enUS','','After you\'ve taken damage, use Regrowth to restore your health.',26124),
(118430,'enUS','','You also have the ability to call on the powers of nature for a variety of other abilities, like healing!',26124),
(118431,'enUS','','Practice using Dash to increase your movement speed.',26124),
(118432,'enUS','','Dash increases your movement speed significantly for a short time. It can\'t be used often, so save it for when you really need it.',26124),
(118433,'enUS','','Ever needed to quickly get out of a sticky situation? You excel at doing this.',26124),
(118434,'enUS','','Use Tiger\'s Fury!',26124),
(118435,'enUS','','You\'re low on energy! Use Tiger\'s Fury!',26124),
(118436,'enUS','','Use Thrash!',26124),
(118437,'enUS','','Using Thrash then Swipe is a great combination!',26124),
(118438,'enUS','','Now use Swipe!',26124),
(118439,'enUS','','You\'re fighting multiple enemies, try using Swipe!',26124),
(118440,'enUS','','Use Survival Instincts!',26124),
(118441,'enUS','','Use Shred!',26124),
(118442,'enUS','','Use Shred to generate combo points!',26124),
(118443,'enUS','','Use Rip!',26124),
(118444,'enUS','','You have 5 combo points! Use Rip!',26124),
(118445,'enUS','','Rake has expired on your target! Use it again!',26124),
(118446,'enUS','','Use Rake!',26124),
(118447,'enUS','','Use Prowl to enter stealth!',26124),
(118448,'enUS','','Heal yourself with Healing Touch!',26124),
(118449,'enUS','','Use Ferocious Bite!',26124),
(118450,'enUS','','You have 5 combo points! Use Ferocious Bite now!',26124),
(118451,'enUS','','Cast Entangling Roots!',26124),
(118452,'enUS','','Try to root the target before it can reach you! Let\'s try again!',26124),
(118453,'enUS','','Try using Entangling Roots to immobilize your target!',26124),
(118454,'enUS','Let the Shadow embrace you.','Let the Shadow embrace you.',26124),
(118455,'enUS','I better get goin\'. Wouldn\'t want to end up dead.','',26124),
(118456,'enUS','','Shift back into Cat Form!',26124),
(118477,'enUS','','Cast Solar Wrath!',26124),
(118478,'enUS','','Cast Solar Wrath to generate Astral Power!',26124),
(118479,'enUS','','Cast Sunfire!',26124),
(118480,'enUS','','Cast Moonfire!',26124),
(118481,'enUS','','Sunfire has expired on your target! Cast Sunfire on your target!',26124),
(118482,'enUS','','Moonfire has expired on your target! Cast Moonfire on your target!',26124),
(118483,'enUS','','Use Moonkin form!',26124),
(118484,'enUS','','Use Lunar Strike to dispatch this group of enemies.',26124),
(118485,'enUS','','A balance druid is well equipped to face multiple opponents at once.',26124),
(118486,'enUS','','Use Celestial Alignment to increase damage, then use Solar Wrath on the target dummy.',26124),
(118487,'enUS','','Need a boost of damage? Look to the stars!',26124),
(118488,'enUS','','Well done, $p! You are now prepared to do battle as a balance druid.',26124),
(118489,'enUS','','Show me that you can harness the power of the universe itself!',26124),
(118490,'enUS','','Use Entangling Roots to root my warrior to the ground.',26124),
(118491,'enUS','','Sometimes you need an enemy to stay put so you can close the distance to them... or make a hasty retreat.',26124),
(118492,'enUS','','Use Solar Wrath on the target dummy until you have enough Astral Power to cast Starsurge.',26124),
(118493,'enUS','','One of your most potent attacks, Starsurge unleashes a surge of stellar energy at your target.',26124),
(118494,'enUS','','Use Solar Wrath on the target dummy.',26124),
(118495,'enUS','','Once your enemy is taking damage from your other attacks, it\'s time to unleash Solar Wrath.',26124),
(118496,'enUS','','Both these attacks deal damage over time. Once cast, you don\'t need to cast them again until their effect on the target has expired.',26124),
(118497,'enUS','','Use Moonfire and Sunfire on the target dummy.',26124),
(118498,'enUS','','You wield the very power of night and day against your foes. Moonfire and Sunfire represent that power.',26124),
(118499,'enUS','','Use Moonkin Form and assume the form of a wildkin.',26124),
(118500,'enUS','','As a balance druid the sun, moon, and stars are your allies, enabling you to unleash these primal powers upon your enemies.',26124),
(118501,'enUS','','Entangling Roots will cause plant roots to spring from the ground and hold the target in place for a short time.',26124),
(118502,'enUS','','Lunar Strike deals damage directly to your target, but also deals damage to nearby foes.',26124),
(118503,'enUS','','Celestial Alignment causes the celestial bodies to align, increasing the damage of your solar and lunar spells for a short time.',26124),
(118504,'enUS','','Starsurge costs Astral Power, so use Solar Wrath to build up your reserves.',26124),
(118505,'enUS','','Solar Wrath is a ranged ability that deals damage and generates Astral Power, a resource used to fuel more powerful attacks.',26124),
(118506,'enUS','','These attacks deal their damage over time, and either makes an excellent start to a battle.',26124),
(118507,'enUS','','You can shapeshift into Moonkin form, which increases both your damage and defense.',26124),
(118508,'enUS','','You\'re at maximum Astral Power. Cast Starsurge!',26124),
(118509,'enUS','','Cast Lunar Strike!',26124),
(118510,'enUS','','Cast Entangling Roots!',26124),
(118511,'enUS','','Try to root the target before it can reach you! Let\'s try again!',26124),
(118512,'enUS','','Try using Entangling Roots to immobilize your target!',26124),
(118513,'enUS','','Cast Starsurge!',26124),
(118514,'enUS','','Starsurge is available! Cast it now!',26124),
(118515,'enUS','Let our eternal foe tremble before the fury and destruction you unleash!','',26124),
(118518,'enUS','An illusion! What are you hiding?','An illusion! What are you hiding?',26124),
(118519,'enUS','Something\'s not quite right...','Something\'s not quite right...',26124),
(118520,'enUS','Who goes there?!','Who goes there?!',26124),
(118521,'enUS','','DELETE',26124),
(118522,'enUS','','$n, come forward.',26124),
(118523,'enUS','','Turn and face your peers, $p, so that they may bear witness to your ruthlessness and cunning.',26124),
(118524,'enUS','','Before you stands the Horde\'s greatest champion, hero of countless victories against our unrelenting foe.',26124),
(118525,'enUS','','The ancient weapon they wield inspires fear in the hearts of those who would threaten our way of life.',26124),
(118526,'enUS','','So join me, heroes, in honoring $p, bane of the Alliance!',26124),
(118527,'enUS','','For the Horde!',26124),
(118528,'enUS','It went quickly this time. But in the future, it will take longer to recruit more Ashtongue.','',26124),
(118529,'enUS','','Hello, my dear. It\'s always good to see you.\n\nWhat can I help with?',26124),
(118530,'enUS','Greetings, $n. I suppose an explanation is in order if there is ever to be any trust between us.','',26124),
(118531,'enUS','Yes, tell me everything, Loramus.','Yes, tell me everything, Loramus.',26124),
(118532,'enUS','Where to begin? I suppose the only thing that matters was the battle between me and the demon.','',26124),
(118533,'enUS','Razelikh the Defiler was a dreadlord who had been charged with the conquest of the Blasted Lands. I traveled there to stop him. But, that did not turn out the way that I had planned.','',26124),
(118534,'enUS','In the end, the Defiler possessed me, and in turn, I sacrificed myself so that we both would die. Our souls were trapped within an enchanted blade to battle for all eternity.','',26124),
(118535,'enUS','Some time later, the blade was destroyed. Our souls escaped only to be sent to the Twisting Nether. However, Razelikh has a very powerful demon soul. As happens with many dreadlords, a new body eventually formed. It is said that they can only truly be killed within the Twisting Nether.','',26124),
(118536,'enUS','Within this new body, our souls are still entwined in eternal conflict. I am in control... most of the time, though it is a constant struggle. We demon hunters are accustomed to containing the demon within.','',26124),
(118537,'enUS','The next thing I knew, we were expelled from the Twisting Nether, summoned by the Burning Legion to the invasion of Azeroth. At the Felblaze Ingress, I did my best to disrupt their efforts.','',26124),
(118538,'enUS','The rest, you know. Your champion came and retrieved me, and here I am.','',26124),
(118539,'enUS','I will gladly serve if you will have me. I have access to all of Razelikh\'s knowledge. Allow me to aid you in the war against the Legion.','',26124),
(118540,'enUS','Would you get down here already? We got work to do!','Would you get down here already? We got work to do!',26124),
(118541,'enUS','C\'mon! We can\'t wait all day! It\'s safe. I promise!','C\'mon! We can\'t wait all day! It\'s safe. I promise!',26124),
(118542,'enUS','We got our own muscle right here. Trust me! We\'re safe.','We got our own muscle right here. Trust me! We\'re safe.',26124),
(118543,'enUS','I can\'t wait all day. Someone\'s gotta fix these shredders.','I can\'t wait all day. Someone\'s gotta fix these shredders.',26124),
(118544,'enUS','Now\'s not the time. Get down already!','Now\'s not the time. Get down already!',26124),
(118545,'enUS','I don\'t know... It doesn\'t look too safe to me.','',26124),
(118546,'enUS','Last time you said that one of those demons almost ate me alive!','',26124),
(118547,'enUS','I\'m just, uh... checkin\' to see if it\'s clear up here. Ayep... it\'s clear alright.','',26124),
(118548,'enUS','I\'d rather be safe than dead!','',26124),
(118549,'enUS','What if they come back?','',26124),
(118550,'enUS','Find me when this is over, $n. The Frostwolf could use a $c like you.','',26124),
(118551,'enUS','Quick, quick, through my portal! Flee!','',26124),
(118552,'enUS','Meet me at the temple of Fal\'adora. We must study the past to preserve our future.','',26124),
(118553,'enUS','Many years ago, exiles from the shielded city came to rest here.','',26124),
(118554,'enUS','Even in this state, the arcan\'dor continues to grow.','',26124),
(118555,'enUS','We must learn why the old arcan\'dor failed. Its shattered bones may have the answers.','',26124),
(118556,'enUS','Here we go!','',26124),
(118557,'enUS','Greetings, and thank you for helping to test the Legion Beta! \n\nI can provide you with select provisions for your Order Hall.','',26124),
(118558,'enUS','I need a supply of Order Hall Resources.','I need a supply of Order Hall Resources.',26124),
(118559,'enUS','|TInterface\\Icons\\creatureportrait_cyclone_nodebris:20|t%s interrupts the Anomaly with a |cFFFF0000|Hspell:212115|h[Temporal Smash]|h|r!','|TInterface\\Icons\\creatureportrait_cyclone_nodebris:20|t%s interrupts the Anomaly with a |cFFFF0000|Hspell:212115|h[Temporal Smash]|h|r!',26124),
(118560,'enUS','The fel bat screeches in pain as you drive your weapon into it!','',26124),
(118561,'enUS','May this blessing illuminate your path to victory, $ct!','',26124),
(118562,'enUS','Now those are weapons truly worthy of one who commands the Shadows! May your blades strike silent and true.','',26124),
(118563,'enUS','You have ever been a champion of the Light. Now you hold a weapon truly worthy of the noble cause you serve!','',26124),
(118564,'enUS','May your weapon serve you well on the path to victory!','',26124),
(118565,'enUS','Nature\'s essence flows through your weapon! In your hands, it shall make the dark forces threatening Azeroth tremble! Andu-falah-dor!','',26124),
(118566,'enUS','Yes! Such wicked glory awaits you! With this weapon, you will bind the Legion to our will! Even Kil\'jaeden will cower like a craven dog!','',26124),
(118567,'enUS','Raise your blade before the forge. Watch it infuse the weapon with its might!','',26124),
(118568,'enUS','Let our eternal foe tremble before the fury and destruction you unleash!','',26124),
(118569,'enUS','','Out here, so far from the Nightwell, we must settle for any source of magic we can find.',26124),
(118570,'enUS','','It seems Thalyssra and I had the same idea - the old leyline feeds might keep us alive, if barely.',26124),
(118571,'enUS','','We just have to wake them up.',26124),
(118572,'enUS','King\'s honor, $p.','King\'s honor, $p.',26124),
(118573,'enUS','You remember. You were there.','',26124),
(118574,'enUS','Dark Lady watch over you, $p.','Dark Lady watch over you, $p.',26124),
(118575,'enUS','','There... you found something, didn\'t you?',26124),
(118576,'enUS','','Something which gave you peace...',26124),
(118577,'enUS','Hail, champion.','Hail, champion.',26124),
(118578,'enUS','<Leave and join the assault on Broken Shore>','<Leave and join the assault on Broken Shore>',26124),
(118579,'enUS','Let\'s begin the assault on Broken Shore!','Let\'s begin the assault on Broken Shore!',26124),
(118580,'enUS','<The gryphon\'s wings flap in anticipation of the coming battle>','<The gryphon\'s wings flap in anticipation of the coming battle>',26124),
(118581,'enUS','Thank you, Highlord. I... I was blinded by revenge.','',26124),
(118582,'enUS','So many paid for my foolish mistake. This is not the way of righteousness, and I see that now.','',26124),
(118583,'enUS','','A peace we so desperately need for ourselves.',26124),
(118584,'enUS','','You are alive, Boros, and that is what matters. Come, let us return to Light\'s Hope Chapel.',26124),
(118585,'enUS','No! Hodir! What have they done to you?!','',26124),
(118586,'enUS','Ahh a gift fit for a queen. You have my thanks...','',26124),
(118587,'enUS','Now the power of the arcan\'dor is mine!','',26124),
(118588,'enUS','No! What have you done?!','',26124),
(118589,'enUS','Come, my children! Feast on their bones!','',26124),
(118590,'enUS','The arcan\'dor will live again! With its power, we shall return to the surface!','',26124),
(118591,'enUS','Nothing escapes from my web!','',26124),
(118592,'enUS','Hgnh... my prize... it grows heavy...','',26124),
(118593,'enUS','The seed is awakening. It thirsts.','',26124),
(118594,'enUS','It is an arcan\'dor - a gift of the ancient magi.','',26124),
(118595,'enUS','A tree, made to feed upon the leyline. It can bring life... or desolation.','',26124),
(118596,'enUS','To care for the arcan\'dor is a great burden - one which we now share.','',26124),
(118597,'enUS','','Pleasure to see you again, $n.',26124),
(118598,'enUS','','So this is what the chamber was built for... but what is it?',26124),
(118599,'enUS','Let\'s continue research on my artifact.','Let\'s continue research on my artifact.',26124),
(118600,'enUS','HATE!!','',26124),
(118601,'enUS','','We are masters of the arcane, night elf. I think we can handle a tree.',26124),
(118602,'enUS','','I saw you leave for the Broken Shore. Please, tell me, did you see my husband?',26124),
(118603,'enUS','','His locket? Where did you get this?\n\nNo! I don\'t believe you! He can\'t be gone! \n\nCedric, oh my dear Cedric, please come back to me.\n\nDon\'t leave me all alone...',26124),
(118604,'enUS','Hmph. Arrogant. In time, you will see.','',26124),
(118605,'enUS','Do you recognize this locket?','Do you recognize this locket?',26124),
(118606,'enUS','Give Alaina the Charred Locket?','Give Alaina the Charred Locket?',26124),
(118607,'enUS','Beneath the arcan\'dor, you will be renewed. There is no other path now.','',26124),
(118608,'enUS','Valewalker finale lines.','',26124),
(118609,'enUS','','Valtrois finale lines.',26124),
(118610,'enUS','','What is happening?',26124),
(118611,'enUS','The arcan\'dor is at a critical stage.','',26124),
(118612,'enUS','Without enough power to mature into its final form, it will die.','',26124),
(118613,'enUS','Can you repair my equipment?','Can you repair my equipment?',26124),
(118614,'enUS','','Outlander, speak with Valtrois at once!',26124),
(118615,'enUS','','You must activate the remaining leyline feeds.',26124),
(118616,'enUS','','Every leyline feed is active and at full power!',26124),
(118617,'enUS','It is not enough...','',26124),
(118618,'enUS','','Valtrois, can you think of any way to draw more power? Even briefly?',26124),
(118619,'enUS','','Hmm... The main conduit beneath Suramar city pulls ten times what we have here.',26124),
(118620,'enUS','','If that leyline were to flare up, the surge could theoretically reach all the way back to Shal\'Aran.',26124),
(118621,'enUS','','Their warlocks strike from above!',26124),
(118622,'enUS','','What could make the leyline flare up?',26124),
(118623,'enUS','A manastorm might do the trick.','',26124),
(118624,'enUS','','A manastorm, are you insane?',26124),
(118625,'enUS','Yes. But it could work! We create a localized warp field, then-','',26124),
(118626,'enUS','','Spare us the details, just make it happen. I am counting on you.',26124),
(118627,'enUS','Yes, ma\'am!','',26124),
(118628,'enUS','','Right away.',26124),
(118629,'enUS','I heard about this crazy job you guys are planning. You weren\'t thinking of leaving me out, were you?','',26124),
(118630,'enUS','Look, I am not blind. I see what is happening in Suramar.','',26124),
(118631,'enUS','I am not sitting this one out. The stakes are too high. So I am in, you got that?','',26124),
(118632,'enUS','Oh and don\'t worry about my usual fee - you can pay me when the job is done.','',26124),
(118633,'enUS','My Lord! We\'re under attack... it\'s... it\'s the Ebon Blade!','',26124),
(118634,'enUS','','I will not let you destroy my newest pet! When I\'m through with you, you will all serve the Legion!',26124),
(118635,'enUS','We have come for the body of Tirion Fordring. Do not make this harder than it needs to be.','',26124),
(118636,'enUS','You will not succeed, Darion. The Light will not allow it!','',26124),
(118637,'enUS','The eredar witch! Defeating her is our last chance to save Hodir!','',26124),
(118638,'enUS','The fel energy... it is gone...','',26124),
(118639,'enUS','The Legion will pay for this!','',26124),
(118640,'enUS','','I thought you were only interested in lining your pockets.',26124),
(118641,'enUS','Oh and don\'t worry about my usual fee - you can pay me when the job is done.','',26124),
(118642,'enUS','Beginning survey...','',26124),
(118643,'enUS','All set. I believe I have the coordinates we need.','',26124),
(118644,'enUS','Alright everybody, gather in close. Do not be shy now. Group hug.','',26124),
(118645,'enUS','Hmm... a little tart, with a hint of- oh, my... there it is.','',26124),
(118646,'enUS','I will teleport you in past the main defenses. When you are ready to leave, activate this beacon so I can locate you and pull you back.','',26124),
(118647,'enUS','Now this is important - once that manastorm gets going, there will be too much interference for me to teleport anyone. You must get out before the storm!','',26124),
(118648,'enUS','Get in, plant the device, get out before it goes off. Not the most complicated job I have been on.','',26124),
(118649,'enUS','','But the most important, by far. If we fail, Suramar is doomed.',26124),
(118650,'enUS','It seems your... Deathlord... has finally arrived.','',26124),
(118651,'enUS','You should watch your tone, Galen.','',26124),
(118652,'enUS','You are fighting against a power you cannot even comprehend!','',26124),
(118653,'enUS','I owe you a debt of gratitude.','I owe you a debt of gratitude.',26124),
(118654,'enUS','Your aide is greatly appreciated.','Your aide is greatly appreciated.',26124),
(118655,'enUS','Rest first, then retribution.','Rest first, then retribution.',26124),
(118656,'enUS','Continue to fight. We mustn\'t wane.','Continue to fight. We mustn\'t wane.',26124),
(118657,'enUS','The battle has only begun.','The battle has only begun.',26124),
(118658,'enUS','Your assistance is highly valued.','Your assistance is highly valued.',26124),
(118659,'enUS','The Horde rises.','The Horde rises.',26124),
(118660,'enUS','','Yes. We are close.',26124),
(118661,'enUS','This is not looking real conduit-y. You sure the old man knows his stuff?','',26124),
(118663,'enUS','I never met a lock I could not open.','',26124),
(118664,'enUS','Just give me one moment.','',26124),
(118665,'enUS','','There! Place the manastorm generator near the conduit.',26124),
(118666,'enUS','Are you ready to depart to Black Rook Hold?','',26124),
(118667,'enUS','I am ready to go.','I am ready to go.',26124),
(118668,'enUS','Whatever you gotta do, do it quick! Lots of guards heading our way.','',26124),
(118669,'enUS','','Something is wrong... The temporal warp sequencer-',26124),
(118670,'enUS','','The fuse is broken. We must trigger the manastorm manually.',26124),
(118671,'enUS','You\'ve found Timirgos!','You\'ve found Timirgos!',26124),
(118672,'enUS','We must hurry.','We must hurry.',26124),
(118673,'enUS','Help! I cannot fight these creatures!','Help! I cannot fight these creatures!',26124),
(118674,'enUS','I am too weak to defend myself. Help!','I am too weak to defend myself. Help!',26124),
(118675,'enUS','We must reach our destination, and quickly.','We must reach our destination, and quickly.',26124),
(118676,'enUS','I cannot last too much longer.','I cannot last too much longer.',26124),
(118677,'enUS','You must protect me!','You must protect me!',26124),
(118678,'enUS','Hunger.','',26124),
(118679,'enUS','Small words, please.','',26124),
(118680,'enUS','Wait, aren\'t we supposed to leave BEFORE the storm starts?','',26124),
(118681,'enUS','','We have no choice. This must be done.',26124),
(118682,'enUS','','Rath, anu\'telar!',26124),
(118683,'enUS','','We just need to hold out until the storm is over!',26124),
(118684,'enUS','Easier said than done...','',26124),
(118685,'enUS','Hi!','',26124),
(118686,'enUS','Do you want some magic juice? I\'m full.','',26124),
(118687,'enUS','Wanna play with us? You have to be the bad guy though.','',26124),
(118688,'enUS','Wow, you\'re tall!','',26124),
(118689,'enUS','I\'m not in trouble, right?','',26124),
(118690,'enUS','The sky is amazing!','',26124),
(118691,'enUS','','The sky is amazing!',26124),
(118692,'enUS','','I\'m not in trouble, right?',26124),
(118693,'enUS','','Wow, you\'re tall!',26124),
(118694,'enUS','','Wanna play with us? You have to be the bad guy though.',26124),
(118695,'enUS','','Do you want some magic juice? I\'m full.',26124),
(118696,'enUS','','Hi!',26124),
(118697,'enUS','Ye won\'t be takin\' this son of Ironforge. Eat lead!','',26124),
(118698,'enUS','Is that all ye\'ve got? I could do this all day!','',26124),
(118699,'enUS','','Look out!',26124),
(118700,'enUS','The manastorm is only getting stronger! We need to shut that thing down!','',26124),
(118701,'enUS','There\'s nae hope left for any of us, don\'t ye see that?','',26124),
(118702,'enUS','Thank... ye...','',26124),
(118704,'enUS','','Erath-omnas!',26124),
(118705,'enUS','','It is too dangerous! The arcane torrents would tear us apart!',26124),
(118706,'enUS','Damn it...','',26124),
(118707,'enUS','You guys owe me...','',26124),
(118708,'enUS','','What are you doing?!',26124),
(118709,'enUS','','Arluin! NO!!',26124),
(118710,'enUS','Hhghh-AAAHHHH!!!','',26124),
(118711,'enUS','','Oculeth, get us out of here!',26124),
(118712,'enUS','','Ugh... we made it...',26124),
(118713,'enUS','','Where is Arluin?!',26124),
(118714,'enUS','','Oh no...',26124),
(118715,'enUS','<cough> Nghh...','',26124),
(118716,'enUS','','Do not speak! You are wounded-',26124),
(118717,'enUS','Hey... <cough> Tell Vanthir I said... thanks... for every...','',26124),
(118718,'enUS','We pulled it off... <wheeze> didn\'t we?','',26124),
(118719,'enUS','','Yes. You saved us. Please... try to rest.',26124),
(118720,'enUS','','He is gone.',26124),
(118721,'enUS','','Come... Let us check on the others.',26124),
(118722,'enUS','','A very good day to you, $n. I trust that the affairs of the Uncrowned are in order?',26124),
(118723,'enUS','Behold. The gift of the ancient magi.','',26124),
(118724,'enUS','','I am ready to go wherever is needed, do whatever it takes, to assure the goals of the Uncrowned are met.',26124),
(118725,'enUS','The arcan\'dor will not merely sustain you. By the fruit of its bough, you will be made whole again.','',26124),
(118726,'enUS','$n, is it? I have heard your name spoken among the vrykul.$b$bThese cliffs have gone quiet. Return at a later time to prove yourself in combat among the beasts of this peninsula.','',26124),
(118727,'enUS','','The Raven\'s Eye is the key to deciphering the SI:7 letter.',26124),
(118728,'enUS','Fascinating! Look here, $n.','',26124),
(118729,'enUS','These orbs of ley energy seem to be following some sort of pattern.  I wonder where they lead?','',26124),
(118730,'enUS','Why don\'t you find out?','',26124),
(118731,'enUS','Get them in the boats. The Soul Engine requires fuel!','',26124),
(118732,'enUS','Stop your sniveling! You give your lives for a worthy cause.','',26124),
(118733,'enUS','Outstanding, $n!','',26124),
(118734,'enUS','The Legion welcomes your sacrifice. You should feel proud!','',26124),
(118735,'enUS','You will not be missed. Take comfort in that.','',26124),
(118736,'enUS','Keep moving. We must not keep the Soul Engine waiting.','',26124),
(118737,'enUS','What is going on here?','What is going on here?',26124),
(118738,'enUS','Get moving!','Get moving!',26124),
(118739,'enUS','','This tree came at a high cost... You are sure it can sustain us?',26124),
(118740,'enUS','Through this shallow ravine wander goats, stags, worgs, and bears. Ferocious beasts indeed, but all can be tamed if you demonstrate your strength.$b$bBest the creatures in a fight and they will show you obedience. Mounted atop them, you can send your enemies to their deaths on the rocks below.$b$bBut beware Stormtalon, the dragon that rests along the rocks of Storm\'s Reach. Many say he cannot be tamed. Few have tried. None have survived.','',26124),
(118741,'enUS','So, $n, at last you\'ve come to prove yourself on the peninsula of Storm\'s Reach! You\'ve shown you are brave, but bravery is not enough here.$b$bThe wild beasts of this ravine care nothing for your past heroics. They answer only to power.$b$bRight now, heroes like you attempt to tame these beasts and best each other in combat. Are you up to the challenge?','',26124),
(118742,'enUS','Astounding.','',26124),
(118743,'enUS','Run!','Run!',26124),
(118744,'enUS','The entire journal is filled with notes on the cave\'s effects on the local flora and fauna, but a few entries catch your eye.\n\nEntry #5:\nThe properties of this cave are interesting. I have brought crystals from my workshop and set them around the area to see what effect the energies here will have on them. \n\nEntry #17: \nAfter attuning with the crystals, I can create barriers of energy capable of negating all forms of magic against me. This discovery could lead to whole armies of invulnerable soldiers! \n\nEntry #23:\nThe barrier is not without its flaws. While attuned to all three crystals, another user could combine their power to negate the barrier. I must work to fix this flaw before I show this work to my superiors.','',26124),
(118745,'enUS','Highlord, our scouts report that Balnazzar is in this valley. We can corner him if we act quickly!','',26124),
(118746,'enUS','','Boros!',26124),
(118747,'enUS','','We must find Mathias Shaw and use him to prove that Detheroc has taken his place.',26124),
(118748,'enUS','Now is friend\'s chance! Use altar to summon bad portals, not good ones! Quick!','',26124),
(118749,'enUS','Champions, you\'ve done it! I sense Gul\'dan\'s ritual growing in power, we must hurry.  I can teleport you back to the Nighthold. Are you prepared?','',26124),
(118750,'enUS','I want to go to the Court of Stars (Dungeon).','I want to go to the Court of Stars (Dungeon).',26124),
(118751,'enUS','I\'m ready.','I\'m ready.',26124),
(118752,'enUS','','You will not interfere with my research!',26124),
(118753,'enUS','','Perhaps there is a new path for us after all...',26124),
(118754,'enUS','Pitiful creatures... you\'ll die screaming!','',26124),
(118755,'enUS','|TInterface\\Icons\\shaman_pvp_lightninglasso:20|t%s is casting |cFFFF0000|Hspell:220101|h[Deathbolt]|h|r! Interrupt it!','|TInterface\\Icons\\shaman_pvp_lightninglasso:20|t%s is casting |cFFFF0000|Hspell:220101|h[Deathbolt]|h|r! Interrupt it!',26124),
(118756,'enUS','','You have my thanks, outlander.',26124),
(118758,'enUS','Ahhh, the defenders of the Light arrive. We have been waiting.','',26124),
(118759,'enUS','You can go no further, Balnazzar. I will have justice for my slain brethren!','',26124),
(118760,'enUS','Justice...or vengeance, paladin? Choose carefully, for hatred leads down a dark path.','',26124),
(118761,'enUS','You will die by my blade!','',26124),
(118762,'enUS','Auuuuughhhhhh! Auuuughhhh!','',26124),
(118763,'enUS','Pitiful. Jarvox, take care of his execution. Slowly and with great agony, if you will.','',26124),
(118765,'enUS','Feeding time nears, my pets!','',26124),
(118766,'enUS','Fresh meat dangles for the taking!','',26124),
(118767,'enUS','Fuel for the fel...','',26124),
(118768,'enUS','A fate worse than death awaits you, little draenei!','',26124),
(118769,'enUS','The hounds will eat well with this one!','',26124),
(118770,'enUS','Devour this morsel slowly, my pets!','',26124),
(118771,'enUS','','We are on the brink of a new age for the Nightborne.',26124),
(118772,'enUS','','Without you, none of this would have been possible.',26124),
(118773,'enUS','','For now, we shall gather our strength. When the time comes, I trust we can call upon you to help us liberate Suramar.',26124),
(118774,'enUS','','Who is there?',26124),
(118775,'enUS','','<Cough.> Arluin, is that you? It is so dark...',26124),
(118776,'enUS','','I understand... He never could stay out of trouble...',26124),
(118777,'enUS','','Thank you... I will remember this.',26124),
(118778,'enUS','','Set up the explosive distractions around Felsoul Hold. I will meet you there.',26124),
(118779,'enUS','The terrible light of the outside world hurts your rat\'s eyes! Return to the Underbelly!','The terrible light of the outside world hurts your rat\'s eyes! Return to the Underbelly!',26124),
(118780,'enUS','Setting','Setting',26124),
(118781,'enUS','Greetings, High Priest. What can I do for you?','',26124),
(118782,'enUS','The storm clouds gather...','',26124),
(118783,'enUS','Open the skies!','',26124),
(118784,'enUS','','Sorry, ace. I can\'t risk losing my business over this. I\'ll be back when it\'s safe.',26124),
(118797,'enUS','We have retreated into the collapsed shaft on the northern edge of the Crystal Hall. We are holding back the demon onslaught, but our defenses are quickly falling apart!','',26124),
(118798,'enUS','These acolytes will serve you well.','',26124),
(118799,'enUS','We cannot afford to make careless assumptions, Alonsus. We need to find out if this shadow priest speaks the truth.','',26124),
(118800,'enUS','Another shadow priest spouting nonsense. I can\'t say I\'m surprised. Things like this are bound to happen when you linger too close to the void.','',26124),
(118802,'enUS','I am pleased to offer you my services.','',26124),
(118803,'enUS','Make \'em dead! And be quick about it.','',26124),
(118804,'enUS','Make yerself useful and lend us a hand. Does nobody no good with you just standin\' round here.','',26124),
(118805,'enUS','What? Who sent you? I asked fer the best $c they could muster, an\' they sent you?$B$BWell then... ye best get ta work. Plenty of demons runnin\' about. Don\'t be shy about it.','',26124),
(118806,'enUS','Get ready! It\'s comin\' down!','',26124),
(118807,'enUS','They\'re taunting us, you know. The shadows. They see our demise.','',26124),
(118808,'enUS','This war will not be won without sacrifice. Tirion understood the price of freedom.','',26124),
(118809,'enUS','Tirion\'s body rests below, us in the Hall of Champions. We will join you shortly, Deathlord.','',26124),
(118810,'enUS','The demons killed most of my shaman. We retreated here to make one last stand.$B$B<Nobundo sighs.>$B$BIf you are here to help, then prepare yourself for a great battle, friend!$B$BI think I hear the next battalion coming. Are you ready?','',26124),
(118811,'enUS','They\'re taunting us, you know. The shadows. They see our end.','',26124),
(118812,'enUS','I am ready, Nobundo! Let them come!','I am ready, Nobundo! Let them come!',26124),
(118813,'enUS','You won\'t get away with this, Darion! Tirion... the Light will not allow it!','',26124),
(118814,'enUS','You don\'t hear them, do you? Their laughing... their warning. Our time is coming.','',26124),
(118815,'enUS','The void sends whispers of our fate, a gruesome death! Light a candle for your loved ones, priest, because the end is near and inescapable.','',26124),
(118818,'enUS','Another one down! Nicely done. Now get out and find the rest of \'em! Plenty more o\' those things about.','',26124),
(118819,'enUS','I think they meant to kill me!','',26124),
(118820,'enUS','Do not disturb my charges while they enjoy the Menagerie. I will be obliged to remove you.','Do not disturb my charges while they enjoy the Menagerie. I will be obliged to remove you.',26124),
(118822,'enUS','Asking questions will get you killed. Allow me to demonstrate!','Asking questions will get you killed. Allow me to demonstrate!',26124),
(118824,'enUS','Oof! That\'s gonna leave a mark. Best get myself healed up.','Oof! That\'s gonna leave a mark. Best get myself healed up.',26124),
(118825,'enUS','Hmm... That\'s gonna need some stitching. Be back afore this is over!','Hmm... That\'s gonna need some stitching. Be back afore this is over!',26124),
(118826,'enUS','Didn\'t see that comin\'! I\'ll need a bit ta rest me head.','Didn\'t see that comin\'! I\'ll need a bit ta rest me head.',26124),
(118827,'enUS','What do ye call those things? I ne\'er saw it comin\'!','What do ye call those things? I ne\'er saw it comin\'!',26124),
(118828,'enUS','Looks like I be needin\' a bit more trainin\'.','Looks like I be needin\' a bit more trainin\'.',26124),
(118831,'enUS','It feels like these bones of mine haven\'t moved in years! Come, let\'s find some place to talk where we won\'t be caught by a basilisk\'s gaze.','',26124),
(118832,'enUS','Let the hunt begin!','',26124),
(118833,'enUS','Lend me your charge!','',26124),
(118834,'enUS','Empower your master!','',26124),
(118835,'enUS','','Kind words, $n. Perhaps our forces could benefit from some fresh supplies. I\'ll gather what I can.',26124),
(118836,'enUS','Time to fry!','',26124),
(118837,'enUS','','%s looks around nervously, taking her time before entering the fields.',26124),
(118839,'enUS','Do come again.','',26124),
(118840,'enUS','Nor\'bethos Suramar.','',26124),
(118842,'enUS','We\'ve retaken Eastpoint Tower! Continue your efforts. Our lands must be restored.','',26124),
(118843,'enUS','Welcome aboard! King Wrynn needs every hero of the Alliance at their best when we face the Legion. As we journey to the Broken Shore, let\'s use the time to brush up on your battle skills. Let me know when you\'re ready to get started.','',26124),
(118844,'enUS','','Well met! A glorious battle awaits us on the Broken Shore! The Warchief expects every hero of the Horde to be sharp and ready. I suggest we use the time for a bit of combat training. Say the word and we\'ll begin!',26124),
(118845,'enUS','','Greetings $n. We\'re keenly interested in a series of ley energy nodes strewn about the area.',26124),
(118846,'enUS','','Hop on a mana saber and ride through the ley line spots, it will absorb any energy still present.',26124),
(118847,'enUS','','The mana saber will travel very fast in a straight line; but it tends to slow down through turns.',26124),
(118848,'enUS','','Collect enough energy to sate the mana saber for our research and you\'ll be done.',26124),
(118849,'enUS','It would appear as though I wasn\'t quite ready for these... events. Perhaps I should return when things have settled down.','',26124),
(118850,'enUS','','Your words are very kind, but I\'m afraid I shouldn\'t be here. I\'ll return shortly.',26124),
(118851,'enUS','','We\'ve regained control of Southpoint Gate. My forces have been ordered to continue their patrols. Ensure the others are taken care of. We cannot allow the Legion to advance any further!',26124),
(118852,'enUS','Forsaken! Allies! The hour to stand against the Burning Legion is at hand! Prepare yourselves!','',26124),
(118853,'enUS','Rise, champions! Heed the call of battle! The Burning Legion sets its sights on Tarren Mill.','',26124),
(118854,'enUS','Hold your ground! Give no quarter!','',26124),
(118855,'enUS','The demons come! Make... them... pay!','',26124),
(118856,'enUS','More of them! Do not let fear cause you to shirk your duty!','',26124),
(118857,'enUS','Such brutish force! They grow stronger! Do not falter!','',26124),
(118858,'enUS','Relieve this demon of its head! The tide will turn in our favor!','',26124),
(118859,'enUS','','Aran\'arcana.',26124),
(118860,'enUS','Make sure this one pays for its impudence!','',26124),
(118861,'enUS','Victory can yet be ours, champions. Move out and rid our lands of this demonic presence!','',26124),
(118862,'enUS','No demon may walk in Hillsbrad unless it answers to me! Spread out! Expunge them!','',26124),
(118863,'enUS','The darkness grows. Their influence spreads! Oppose them!','',26124),
(118864,'enUS','Even more of them come! They must be stopped!','',26124),
(118865,'enUS','Enough of your madness, demon! Your time is at an end!','',26124),
(118866,'enUS','In ages long past, before the era of the mortal races, Highkeeper Ra reigned over southern Kalimdor.','',26124),
(118867,'enUS','Bathe in sorrow, demon! You cannot break us! The Burning Legion will fall!','',26124),
(118868,'enUS','The titan Aman\'Thul bestowed upon the Highkeeper a fist of light, a claw forged in the heavens that spoke the language of storms and placed the power of lightning within Ra\'s clenched fist.','',26124),
(118869,'enUS','Together with the titan-forged sorceress Helya, Highkeeper Ra created four elemental realms in which to imprison the wayward elemental lords.','',26124),
(118870,'enUS','He embedded the key to these realms into his shield, \"The Highkeeper\'s Ward.\" Ra walked among the elemental planes, as both their jailor and master.','',26124),
(118871,'enUS','When it came time to war against the Black Empire, Highkeeper Ra created an army of stone to do his bidding. These creatures were called the \"mogu,\" and they called their god \"Ra-den,\" or \"Master Ra.\"','',26124),
(118872,'enUS','Revel in our victory, but never forget... time is not our ally. The Legion will return.','',26124),
(118873,'enUS','The mogu proved to be Ra-den\'s undoing. Many ages later, corrupted by the curse of flesh and led by Lei Shen the Thunder King, the Highkeeper was overthrown.','',26124),
(118874,'enUS','Shaman, the Thunder King took up the weapons of Ra-den, but he could not wield them.','',26124),
(118875,'enUS','Lei Shen could match the Highkeeper\'s storm and fury, but not his mastery over the elements themselves. Perhaps you have that power.','',26124),
(118876,'enUS','Victory! Mend your wounds and regain your strength, for we must stay ready. The Legion\'s efforts have only begun...','',26124),
(118877,'enUS','Your companion waits for you. Return to me at my temple. We shall see if you can succeed where the Thunder King failed.','',26124),
(118878,'enUS','','The shal\'dorei will be redeemed.',26124),
(118879,'enUS','Few mortals know the history of Highkeeper Ra, his mastery over the elemental planes, and his relation to the mogu empire.','',26124),
(118880,'enUS','Truly marvelous! I wonder...','',26124),
(118881,'enUS','','Greetings.',26124),
(118884,'enUS','','Lowborn filth! Perhaps reducing their rations of arcwine will remind them who it is they serve.',26124),
(118885,'enUS','','As their hunger grows, the rebels will turn on each other like starved rats. Any sympathizers will be exposed and order will be restored!',26124),
(118886,'enUS','','Where could they have taken him?',26124),
(118887,'enUS','','What are they doing to my boy?',26124),
(118888,'enUS','','He should have returned by now.',26124),
(118889,'enUS','','Curse these tricks. What have they done with my son?',26124),
(118890,'enUS','I simply can\'t fathom why some citizens resist the Grand Magistrix\'s plan.','I simply can\'t fathom why some citizens resist the Grand Magistrix\'s plan.',26124),
(118891,'enUS','','Oh Ailen... you are too young to be involved in this.',26124),
(118892,'enUS','Yes, that will keep them under heel!','Yes, that will keep them under heel!',26124),
(118893,'enUS','','Where is he? Where is my Ailen?',26124),
(118894,'enUS','The Burning Legion is entirely focused on the task at hand. They need someone with my vision to guide their future.','',26124),
(118895,'enUS','Bring me that defiant aberration\'s head!','',26124),
(118896,'enUS','So many worlds must be out there, needing to be purged. Who better than me to locate them?','',26124),
(118897,'enUS','Sargeras himself shall recognize my genius. Will his power expand my mind? Or will my mind expand his power?','',26124),
(118898,'enUS','Take them by ground and air! Felguards and doomguards, attack!','',26124),
(118899,'enUS','Enough! Sisters, end this nonsense!','',26124),
(118900,'enUS','Not sure I can support Lunastre for the advisor position. If Ranthos were still around, perhaps, but that daughter of his...','Not sure I can support Lunastre for the advisor position. If Ranthos were still around, perhaps, but that daughter of his...',26124),
(118901,'enUS','Karzak, I call upon you! FINISH THEM!','',26124),
(118902,'enUS','She\'s a bleeding heart, I hear. Too sympathetic to the lowborn.','She\'s a bleeding heart, I hear. Too sympathetic to the lowborn.',26124),
(118903,'enUS','I wanted to see Ruven Duskmere as the new advisor. Such a pity.','I wanted to see Ruven Duskmere as the new advisor. Such a pity.',26124),
(118904,'enUS','I will meet you at the repose shortly. Travel well.','',26124),
(118905,'enUS','I\'ll wager commoners are responsible. The lowborn ruin everything!','I\'ll wager commoners are responsible. The lowborn ruin everything!',26124),
(118906,'enUS','House Astravar should fill the open advisor spot, if you ask me.','House Astravar should fill the open advisor spot, if you ask me.',26124),
(118907,'enUS','They\'re not even in the running! They\'ve tied their fortunes to Lunastre.','They\'re not even in the running! They\'ve tied their fortunes to Lunastre.',26124),
(118908,'enUS','Coryn Stelleris a murderer? I don\'t believe it!','Coryn Stelleris a murderer? I don\'t believe it!',26124),
(118909,'enUS','Even if he did it, I\'d still rather see him become advisor before Ly\'leth Lunastre.','Even if he did it, I\'d still rather see him become advisor before Ly\'leth Lunastre.',26124),
(118910,'enUS','I have urgent business I must attend to presently, but I\'ll see you soon.','',26124),
(118911,'enUS','House Lunastre has the right idea. Showing kindness to the common folk will get them on our side.','House Lunastre has the right idea. Showing kindness to the common folk will get them on our side.',26124),
(118912,'enUS','Kindness? Are you joking? Take away their arcwine and they\'ll come crawling back on their own!','Kindness? Are you joking? Take away their arcwine and they\'ll come crawling back on their own!',26124),
(118913,'enUS','Any leads on the murder of Advisor Vandros?','Any leads on the murder of Advisor Vandros?',26124),
(118914,'enUS','I heard it was a jilted lover.','I heard it was a jilted lover.',26124),
(118915,'enUS','Really? I\'d assumed it was some sort of dissident, but a scorned lover sounds much more exciting!','Really? I\'d assumed it was some sort of dissident, but a scorned lover sounds much more exciting!',26124),
(118916,'enUS','I\'ll wager Vandros was only the first. Every noble in Suramar has a target on their back!','I\'ll wager Vandros was only the first. Every noble in Suramar has a target on their back!',26124),
(118917,'enUS','Quiet down! The Grand Magistrix is about. Do you want to draw her ire?','Quiet down! The Grand Magistrix is about. Do you want to draw her ire?',26124),
(118918,'enUS','Uh... What I mean is that order has been restored! We are perfectly safe, thanks to the Grand Magistrix!','Uh... What I mean is that order has been restored! We are perfectly safe, thanks to the Grand Magistrix!',26124),
(118919,'enUS','Did you know that Star Auger Estraeus is so smart that his head weighs three times that of a noble-born elf? And six times that of a commoner!','Did you know that Star Auger Estraeus is so smart that his head weighs three times that of a noble-born elf? And six times that of a commoner!',26124),
(118920,'enUS','I saw Spellblade Aluriel pacing about. She always seems so... angry.','I saw Spellblade Aluriel pacing about. She always seems so... angry.',26124),
(118921,'enUS','This wine is terrible. I\'ll wager Melandrus watered it down.','This wine is terrible. I\'ll wager Melandrus watered it down.',26124),
(118922,'enUS','I don\'t mind the Legion presence at all. It feels good to know we\'re on the winning side.','I don\'t mind the Legion presence at all. It feels good to know we\'re on the winning side.',26124),
(118923,'enUS','We\'ve lived quite comfortably for so long. Why must outsiders come and stir up trouble?','We\'ve lived quite comfortably for so long. Why must outsiders come and stir up trouble?',26124),
(118924,'enUS','You know, there are times I feel that the commoners don\'t properly appreciate us.','You know, there are times I feel that the commoners don\'t properly appreciate us.',26124),
(118925,'enUS','','What madman thought to infuse this creature with the Nightwell\'s power? Have a care. If this abomination was created to protect lower reaches of the citadel from invaders, it must be particularly deadly.',26124),
(118926,'enUS','','Rend their flesh apart, my pet!',26124),
(118927,'enUS','','I will shred your flesh from bone!',26124),
(118928,'enUS','','You have my thanks.',26124),
(118929,'enUS','','Now the fate of my people rests in the hands of outsiders... all of you... to save us from the terrible bargain made by our queen.',26124),
(118930,'enUS','','Priest, over here! I need your help!',26124),
(118931,'enUS','','Shanar daloras! I have no idea how such an entity came to be, but the essence of the Nightwell is surging through it.',26124),
(118932,'enUS','','This cage may be strong, but remember, a murloc\'s mind is weak and easily controlled!',26124),
(118933,'enUS','','This is a momentous day, my friends. Until the Legion came, no outsider was permitted inside the corridors of the Nighthold for ten-thousand years.',26124),
(118934,'enUS','','The palace grounds are just ahead. You\'ll find them even more heavily defended than the lower levels.',26124),
(118935,'enUS','','The Spellblade! Once she is defeated, nothing will stop us from opening the palace gates!',26124),
(118936,'enUS','','At long last, the battle to liberate Suramar is joined! No more must our resistance hide in the shadows!',26124),
(118937,'enUS','','The Nightborne stand beside our allies, both ancient and new, to drive back the Legion. Our fates are joined, my friends! In saving this city from the demons, we save all of Azeroth as well! Tor ilisar\'thera\'nal!',26124),
(118938,'enUS','','The reign of the Grand Magistrix ends today! Take her tower, my friends! Topple the tyrant and set my people free!',26124),
(118939,'enUS','','I\'ve tried breaking out, but the wooden bars are too thick.',26124),
(118940,'enUS','','We must drive out the Legion before their meddling unleashes more such manifestations!',26124),
(118941,'enUS','','My people have paid a terrible price for Elisande\'s bargain with the Legion. I hated her for it! But perhaps the magic she bestowed upon you can help bring down our enemies... and earn her some small measure of forgiveness.',26124),
(118942,'enUS','','Surprised to find me alive, Aluriel?',26124),
(118943,'enUS','','Etraeus thought himself superior to... well, everyone. I confess I enjoyed seeing him humbled.',26124),
(118944,'enUS','','What can I say? He took his job seriously.',26124),
(118945,'enUS','','Aluriel trained countless Nightborne in the art of the blade. She would have been a valuable ally, but she chose the wrong side.',26124),
(118946,'enUS','','Skawn! No! I will make you suffer for that!',26124),
(118947,'enUS','We\'ll soon have the opportunity to assess the value of her gift. It\'s time to bring the fight to Gul\'dan!','',26124),
(118948,'enUS','','You!',26124),
(118949,'enUS','','I should have seen to your elimination myself instead of leaving it to Melandrus. After I finish with these whelps, your blood will stain my blade!',26124),
(118950,'enUS','The gates are breached! Sorry we couldn\'t join you sooner, but we had a bit of a mess to clean up out front.','',26124),
(118951,'enUS','I\'ll see to fortifying our position here. Thalyssra, your guidance has been invaluable to our champions so far. They\'ll rely upon your wisdom in the battles ahead.','',26124),
(118952,'enUS','','The people of Suramar owe these heroes a debt we can never fully repay. I will stand with them until the end.',26124),
(118953,'enUS','I\'ll keep an eye on your progress. Good luck!','',26124),
(118954,'enUS','In the Third War, Tichondrius fell in battle against Illidan Stormrage. I think the demon hunter\'s spirit is pleased that the dreadlord has met another painful end.','',26124),
(118955,'enUS','That was for Tirion Fordring, monster! Krosus may not have struck the killing blow, but he played a part in our great champion\'s fall.','',26124),
(118956,'enUS','This astronomer seemed to think very highly of himself. But a good mage knows that intellect isn\'t everything!','',26124),
(118957,'enUS','So the palace gardener turned himself into a plant?','',26124),
(118958,'enUS','Though swordplay is not my specialty, I must say her abilities were most impressive.','',26124),
(118959,'enUS','%s has purchased a banquet! Come get a meal in the inn!','%s has purchased a banquet! Come get a meal in the inn!',26124),
(118960,'enUS','%s has purchased a crate of Ratstallion Harnesses! Come get your temporary rat mount near the guard station!','%s has purchased a crate of Ratstallion Harnesses! Come get your temporary rat mount near the guard station!',26124),
(118961,'enUS','%s has chummed the waters in the Black Market! Come fish up some Sightless Eyes!','%s has chummed the waters in the Black Market! Come fish up some Sightless Eyes!',26124),
(118962,'enUS','%s has purchased some Young Mutant Warturtles from Laura Malley! Come tame them before they get away!','%s has purchased some Young Mutant Warturtles from Laura Malley! Come tame them before they get away!',26124),
(118963,'enUS','Greetings.','',26124),
(118964,'enUS','How can I help?','',26124),
(118965,'enUS','You need only ask.','',26124),
(118966,'enUS','%s has flushed the crocs out of the sewer pipes!','%s has flushed the crocs out of the sewer pipes!',26124),
(118967,'enUS','My doors are always open.','',26124),
(118968,'enUS','%s has awoken the bats! Watch your head!','%s has awoken the bats! Watch your head!',26124),
(118969,'enUS','%s has summoned imps!','%s has summoned imps!',26124),
(118970,'enUS','%s has signed a contract with the Widowsister rogues! Hang onto your wallets!','%s has signed a contract with the Widowsister rogues! Hang onto your wallets!',26124),
(118971,'enUS','Is there something you need?','',26124),
(118972,'enUS','The Waning Crescent never closes.','',26124),
(118973,'enUS','Take care.','',26124),
(118974,'enUS','%s has used the Wild Mana Wand on $n!','%s has used the Wild Mana Wand on $n!',26124),
(118975,'enUS','Fight as one! We can only defeat them if we stand united!','',26124),
(118976,'enUS','I reserve the right to refuse service. To anyone.','',26124),
(118977,'enUS','Only by working together with these heroes have we won this day! Quickly, brethren, to the Vault of Lights! The Prophet needs our help!','',26124),
(118978,'enUS','Aaaand it\'s closing time.','',26124),
(118979,'enUS','I need a drink.','',26124),
(118980,'enUS','I need to take care of a small matter before heading down. I\'ll see you soon.','',26124),
(118981,'enUS','It just might be possible...','',26124),
(118982,'enUS','','Mathias Shaw is being held inside the Halls of the Eclipse to the south.',26124),
(118983,'enUS','Lead me to Mathias.','Lead me to Mathias.',26124),
(118984,'enUS','','Let us stealth quickly to Mathias Shaw.',26124),
(118985,'enUS','','Keep up. Mathias Shaw is not far.',26124),
(118986,'enUS','','$p. This way.',26124),
(118987,'enUS','','We must get to Mathias quickly.',26124),
(118988,'enUS','','There is no time to waste, $p.',26124),
(118989,'enUS','','He is in here.',26124),
(118990,'enUS','','It\'s not far now.',26124),
(118991,'enUS','','He\'s just down the stairs. Hurry, $p!',26124),
(118992,'enUS','|TInterface\\Icons\\spell_mage_temporalshield:20|t |cFFFF0000|Hspell:219815|h[Temporal Orbs]|h|r flow out of the Nightwell!','|TInterface\\Icons\\spell_mage_temporalshield:20|t |cFFFF0000|Hspell:219815|h[Temporal Orbs]|h|r flow out of the Nightwell!',26124),
(118993,'enUS','','One day at a time.',26124),
(118994,'enUS','','We are only as strong as our will.',26124),
(118995,'enUS','','Death Knight! Your actions here are an affront to all that is holy!',26124),
(118996,'enUS','','Turn back from this unholy mission, or be purged by the Light!',26124),
(118997,'enUS','Been guiding hunters for a lot of years. Makes me proud to see how far we\'ve come!','',26124),
(118998,'enUS','Outland had its charms. But when I heard about this lodge, I had to come see it for myself.','',26124),
(118999,'enUS','Hunters of all races, working together... not how it was in the old days!','',26124),
(119000,'enUS','I chugged my share of mana potions back in the day. Not something I\'m proud of, but I did what I had to do!','',26124),
(119001,'enUS','I can help you procure some valuable items.','I can help you procure some valuable items.',26124),
(119002,'enUS','','$n, you\'re spotted. Vanish!',26124),
(119003,'enUS','Look there, the one who set off the explosions!','',26124),
(119004,'enUS','<This guide appears to have been mangled by at least a dozen different wild animals. Though heavily patched, it is no longer readable. It has an unpleasant, musky scent.>','<This guide appears to have been mangled by at least a dozen different wild animals. Though heavily patched, it is no longer readable. It has an unpleasant, musky scent.>',26124),
(119005,'enUS','','Greetings.',26124),
(119006,'enUS','','Yes?',26124),
(119007,'enUS','','Good day.',26124),
(119008,'enUS','','Glory to the shal\'dorei.',26124),
(119009,'enUS','','The people will rise.',26124),
(119010,'enUS','','I will honor my father\'s name.',26124),
(119011,'enUS','','Farewell.',26124),
(119012,'enUS','','Do you know who I am?',26124),
(119013,'enUS','','Do not test me. I will win.',26124),
(119014,'enUS','','Amused? Good. Enjoy it while you can.',26124),
(119015,'enUS','','The Nightwell calls to me...',26124),
(119016,'enUS','','Our isolation has ended.',26124),
(119017,'enUS','Where did the other one go?','',26124),
(119018,'enUS','','An\'ratha adore.',26124),
(119019,'enUS','','Be careful who you trust...',26124),
(119020,'enUS','','Excellent work, $n! I can\'t wait to analyze the mana saber. The Ley energy will saturate the air around it I\'m sure!',26124),
(119021,'enUS','','Suramar must be free.',26124),
(119022,'enUS','','Are all outlanders this... eager?',26124),
(119023,'enUS','','Alright, time to go...',26124),
(119024,'enUS','','<Sigh.> Ten thousand years of paradise. And now, I am stuck here. With you.',26124),
(119025,'enUS','','I am so putting that shield back up when this is over.',26124),
(119026,'enUS','Why hello.','',26124),
(119027,'enUS','Have you made a discovery?','',26124),
(119028,'enUS','Anar-ammenos.','',26124),
(119029,'enUS','What is our destination?','',26124),
(119030,'enUS','Respect magic, or it will break you.','',26124),
(119031,'enUS','Tel vallath.','',26124),
(119032,'enUS','May your path be clear.','',26124),
(119033,'enUS','Test. Observe. Repeat!','',26124),
(119034,'enUS','You were just leaving right?','',26124),
(119035,'enUS','Need a teleport? Preferably somewhere far...','',26124),
(119036,'enUS','Oh, blink off already!','',26124),
(119037,'enUS','','What a fascinating discovery, $n. This device seems to be guarded by some puzzle.',26124),
(119038,'enUS','','Head over to the box and interact with it to start the puzzle.',26124),
(119039,'enUS','','Excellent, $n! This information will prove invaluable to our research.',26124),
(119040,'enUS','See, now you made me swear. <Sigh.>','',26124),
(119041,'enUS','','Yes?',26124),
(119042,'enUS','','Every now and then, a brave hunter seeks Talonclaw. They commune with the Eagle Spirit, receive her blessing, and begin their hunt. Sadly, these pursuits have always ended the same way: death.',26124),
(119043,'enUS','','Something is wrong. There is strange... Look out!',26124),
(119044,'enUS','','Power is out there, we need only reach for it.',26124),
(119045,'enUS','','Elisande was wrong to doubt our magic.',26124),
(119046,'enUS','','Shal\'assan torah.',26124),
(119047,'enUS','You have my thanks, priest.','You have my thanks, priest.',26124),
(119048,'enUS','I am in your debt.','I am in your debt.',26124),
(119049,'enUS','Your aid will help us win this war.','Your aid will help us win this war.',26124),
(119050,'enUS','','You may speak.',26124),
(119051,'enUS','','Run along.',26124),
(119052,'enUS','','Good help is so hard to find.',26124),
(119053,'enUS','','The arcane is infinite.',26124),
(119054,'enUS','Well met $n. Care to help me with some science?','',26124),
(119055,'enUS','Magic isn\'t all about conjuring balls of fire and hurling them at your enemies you know.  Sometimes you need to throw rocks, really BIG rocks.','',26124),
(119056,'enUS','And of course by, \"Throw,\" I mean to say shoot. With fire.','',26124),
(119057,'enUS','Anyway, enough of the classroom lecture. Get in there and try and fire at the targets I\'ve marked.  I\'ll be back over here collecting data.','',26124),
(119058,'enUS','Well shot, $n. That\'ll do for today.','',26124),
(119059,'enUS','','Aran\'arcana.',26124),
(119060,'enUS','','Farewell.',26124),
(119061,'enUS','','<Ahem.> You are still here.',26124),
(119062,'enUS','','Val-TWAH. Twwahhh! The \"R\" is silen- you know what, never mind. Call me whatever.',26124),
(119063,'enUS','','Is this some kind of primitive ritual? Poking someone until they lose their patience?',26124),
(119064,'enUS','','Where I am from, this kind of behavior has consequences...',26124),
(119065,'enUS','','You know, I tire of being asked \"more power, more power.\" The arcway is not just some wagon that can be heaped with goods - it is a series of conduits!',26124),
(119066,'enUS','','Why are you doing this? I know the peace has always been uneasy, but--',26124),
(119067,'enUS','Your tribe had plenty of time to reclaim the spear, but failed. I will bring back Talonclaw... for the Bloodtotem!','',26124),
(119068,'enUS','Well met.','',26124),
(119069,'enUS','Aran\'arcana.','',26124),
(119070,'enUS','Order must be restored.','',26124),
(119071,'enUS','If only this stubborn spirit would obey!','',26124),
(119072,'enUS','By my blade, I will protect Suramar.','',26124),
(119073,'enUS','Another interloper? Do not meddle in Highmountain affairs!','',26124),
(119074,'enUS','The shal\'dorei are suffering.','',26124),
(119075,'enUS','Be kind. Or be strong.','',26124),
(119076,'enUS','Farewell.','',26124),
(119077,'enUS','Step carefully.','',26124),
(119078,'enUS','An\'ratha adore.','',26124),
(119079,'enUS','Keep your blades clean.','',26124),
(119080,'enUS','If you are trying to incite me, it will not work.','',26124),
(119081,'enUS','I\'ll be alright. Now get moving!','I\'ll be alright. Now get moving!',26124),
(119082,'enUS','I appreciate your help. Now, if you\'ll excuse me, I must continue.','I appreciate your help. Now, if you\'ll excuse me, I must continue.',26124),
(119083,'enUS','We mustn\'t stop fighting. Press on!','We mustn\'t stop fighting. Press on!',26124),
(119084,'enUS','I am disciplined by thousands of years of training. Your petty harassment rolls off like morning dew from the leaves of my garden.','',26124),
(119085,'enUS','<grumble> Be strong... be strong...','',26124),
(119086,'enUS','Enough! Sic \'em, Kal! Go for the eyes!','',26124),
(119087,'enUS','...You are lucky my owl likes you.','',26124),
(119091,'enUS','','Greetings to you, $c. May the Light illuminate your path.',26124),
(119092,'enUS','','I enjoy coming here to think. In the presence of the statue, I feel bathed in serenity.',26124),
(119093,'enUS','Ishnu-alah.','',26124),
(119094,'enUS','Greetings.','',26124),
(119095,'enUS','Ours is a heavy burden.','',26124),
(119096,'enUS','I see a great darkness looming over Netherlight Temple. The shadow of the Burning Legion, ready to strike.','',26124),
(119097,'enUS','Our order will fall at his hands, everyone within will perish.','',26124),
(119098,'enUS','This will be our fate. We are doomed to die at the hands of the dreadlord Balnazzar.','',26124),
(119099,'enUS','This will be our fate... unless...','',26124),
(119100,'enUS','Noooooooooo!','',26124),
(119101,'enUS','I see a path that leads to our victory! You are there, walking with the Light, guiding us all.','',26124),
(119102,'enUS','I know my path.','',26124),
(119103,'enUS','It\'s becoming clear.','',26124),
(119104,'enUS','An old enemy becomes an ally.','',26124),
(119105,'enUS','Forgotten shadows rise!','',26124),
(119106,'enUS','All unite under the Light.','',26124),
(119107,'enUS','Walk with purpose.','',26124),
(119112,'enUS','Farewell.','',26124),
(119115,'enUS','Seek harmony.','',26124),
(119116,'enUS','I know someone brought Ailen Astravar here. Tell me where he is.','I know someone brought Ailen Astravar here. Tell me where he is.',26124),
(119119,'enUS','Ande\'thoras-ethil.','',26124),
(119122,'enUS','Calm yourself.','',26124),
(119124,'enUS','I sense unrest within you.','',26124),
(119125,'enUS','Rethink your path.','',26124),
(119126,'enUS','Remember that one must reap what one sows.','',26124),
(119127,'enUS','Be gone! You have caused me enough trouble already.','',26124),
(119128,'enUS','What.','',26124),
(119129,'enUS','Spit it out.','',26124),
(119130,'enUS','Get this over with.','',26124),
(119131,'enUS','Good riddance.','',26124),
(119132,'enUS','Leave me.','',26124),
(119133,'enUS','Disgraceful.','',26124),
(119134,'enUS','','Get this over with.',26124),
(119135,'enUS','','Spit it out.',26124),
(119136,'enUS','','What.',26124),
(119137,'enUS','','Disgraceful.',26124),
(119138,'enUS','','Leave me.',26124),
(119139,'enUS','','Good riddance.',26124),
(119140,'enUS','','Trying to annoy me? How quaint.',26124),
(119141,'enUS','','House Lunastre will always rise above.',26124),
(119142,'enUS','','Words are weapons.',26124),
(119143,'enUS','It is good to see you alive and well, Senegos.','',26124),
(119144,'enUS','I may well not have been, save for the efforts of your friend.','',26124),
(119145,'enUS','I don\'t know, really... I kind of... just fell into this place.','I don\'t know, really... I kind of just... fell into this place.',26124),
(119146,'enUS','<Eyeballing you up and down suspiciously.>','',26124),
(119147,'enUS','Take caution! Azshara\'s minions will not relinquish the Heart easily.','',26124),
(119148,'enUS','Oakheart protected the great tree for untold years, never once wavering in his vigil. A tragic end.','',26124),
(119149,'enUS','Speak with me when you have finished your business here, so we might leave this place.','',26124),
(119150,'enUS','You possess a powerful binding from the Firelord\'s kin.  These are no toys, $r.  Bindings such as these threaten even the great elemental lords.  They are unspeakably dangerous to possess.\n\nDo you seek to imprison the Windlord with these bindings?  Or do you have some other intent?','',26124),
(119151,'enUS','I do not fear the Windlord.  As long as I have this binding, he should fear me.','I do not fear the Windlord.  As long as I have this binding, he should fear me.',26124),
(119152,'enUS','Steel your heart, young one. None are safe from the Nightmare\'s grasp.','',26124),
(119153,'enUS','Well... I hope you like eating raw fish, $n.','',26124),
(119154,'enUS','... I have failed you my lord, Detheroc...','',26124),
(119155,'enUS','Now look what you\'ve done. Didn\'t want to listen, did you?','',26124),
(119156,'enUS','By the Lifebinder... I thought the Heart was just another legend.','',26124),
(119157,'enUS','I care little of your Bindings.\n\nThunderaan has returned through the efforts of the Earthen Ring. The new Windlord has risen, and it is he you should speak to about these wretched creations.\n\nBut even then, just one Binding is of little use even to the Windlord.','',26124),
(119158,'enUS','Bold, $r.  The elemental lords are not known for their generosity.\n\nStill, should you recover both bindings, and ore powerful enough to turn them into something of use, then I will arrange your audience with Thunderaan the Windlord.\n\nUse the time between then and now to consider the wisdom of this meeting.  I shall understand if you do not return.','',26124),
(119159,'enUS','What would the Windlord require to arrange an audience?','What would the Windlord require to arrange an audience?',26124),
(119160,'enUS','Enough! I will deal with you myself.','',26124),
(119161,'enUS','I have no desire to imprison the Windlord.  I wish to come to an arrangement with him.','I have no desire to imprison the Windlord.  I wish to come to an arrangement with him.',26124),
(119162,'enUS','Curious.\n\nThunderaan has returned through the efforts of the Earthen Ring. The new Windlord has risen, and it is he you should speak to about these wretched creations.\n\nBut even then, just one Binding is of little use even to the lord of Skywall.','',26124),
(119163,'enUS','Begone, $r.  I want nothing to do with your foolish plans.','',26124),
(119164,'enUS','We have everything we need. Well done!','',26124),
(119165,'enUS','It\'s... it\'s working!','',26124),
(119166,'enUS','','You keep them off me and I will get SI:7 here out of his cage.',26124),
(119167,'enUS','Incredible! But the power of one essence is simply not enough.','',26124),
(119168,'enUS','Oh, Kalecgos! We are just beginning. We must now delve deep into the Nightmare itself.','',26124),
(119169,'enUS','I was personal attendant to lord Ruven himself. Now I am reduced to delivering wine and sweets to petulant, coddled  nobles with no real power or influence.\n\nPathetic.','',26124),
(119170,'enUS','My lord Ruven promised such power, if he were to ascend to the palace. I believed him! I made plans!\n\nNow he is dead, and I cannot show my face without drawing stares. I am ashamed.\n\nHow could one such as he fall so low?','',26124),
(119171,'enUS','','Oh my dear Ruven...\n\nHe was such a brash child, so full of pride. I always knew he would take great power for his own some day.\n\nBut not this... I did not see this coming. Oh my child...',26124),
(119172,'enUS','I see.','I see.',26124),
(119173,'enUS','I heard that Coryn Stelleris has begun to purchase the remaining Duskmere attendants - is that true?','I heard that Coryn Stelleris has begun to purchase the remaining Duskmere attendants - is that true?',26124),
(119174,'enUS','I overheard a rather crude joke at poor Ruven\'s expense while visiting the Stelleris family. I can\'t imagine you would want to hear it...','I overheard a rather crude joke at poor Ruven\'s expense while visiting the Stelleris family. I can\'t imagine you would want to hear it...',26124),
(119175,'enUS','There is talk in the streets that they found a silver crescent near his corpse- is that true?','There is talk in the streets that they found a silver crescent near his corpse- is that true?',26124),
(119176,'enUS','','Here they come!',26124),
(119177,'enUS','Absolutely NOT! Why would he do such a thing? Has he no honor?!','',26124),
(119178,'enUS','... Why WOULD he do such a thing...?','',26124),
(119179,'enUS','','That is the symbol of House Stelleris... but that could not be. Coryn was Ruven\'s dearest friend...',26124),
(119180,'enUS','','No, that\'s simply impossible...',26124),
(119181,'enUS','Preposterous! A joke at my lord\'s expense? Only a madman would attempt it!','',26124),
(119182,'enUS','... But if anyone would laugh, it would be THEM.','',26124),
(119183,'enUS','The Uncrowned to the rescue. I wouldn\'t expect anything less.','',26124),
(119184,'enUS','On your mark, $p.','',26124),
(119185,'enUS','Just... don\'t remain too long in there, alright?','',26124),
(119188,'enUS','We must lend our strength, Kalecgos. There is too much power!','',26124),
(119189,'enUS','I fear you don\'t understand the depths of their depravity, brother. We must continue to push the boundaries of possibility, or we may well still fail.','',26124),
(119190,'enUS','Thank you for everything, Senegos. I hope that one day our paths will cross again.','',26124),
(119191,'enUS','','We must get Shaw out of this cage.',26124),
(119192,'enUS','Taoshi, pick the locks. I\'ll take care of the demons.','Taoshi, pick the locks. I\'ll take care of the demons.',26124),
(119193,'enUS','Few have returned after journeying so deep into the dark.','',26124),
(119194,'enUS','The Moon Guard are the only ones versed in the ancient magic we need to empower the Heart further. You must save them.','',26124),
(119195,'enUS','Come, let us speak to Thalreus and his kin. We will need their knowledge to empower the Heart further.','',26124),
(119196,'enUS','Get me out of here so that I can help.','',26124),
(119197,'enUS','','You\'ll get your chance soon enough, Mathias.',26124),
(119198,'enUS','','One down, one to go.',26124),
(119199,'enUS','What\'s wrong, Taoshi?','',26124),
(119200,'enUS','','I can\'t pick the lock. It is up to you, $p.',26124),
(119201,'enUS','','By the Light, be purged!',26124),
(119202,'enUS','','Such power... how can this be?',26124),
(119203,'enUS','Darion, my son! What is the meaning of this?','',26124),
(119204,'enUS','Look at what you have done! The valiant blood of your allies stains this sacred chapel. Blood that you have spilt!','',26124),
(119205,'enUS','Good. Then your unholy crusade is at an end. The Four Horsemen will never return.','',26124),
(119206,'enUS','I will not watch my son become a monster!','',26124),
(119207,'enUS','This burden will always be ours to bear, my son.','',26124),
(119208,'enUS','Deathlord! The time has come for you to leave this place and never return.','',26124),
(119209,'enUS','We will resurrect our valiant deceased, but the actions of the Ebon Blade will not be forgotten.','',26124),
(119210,'enUS','At last, the Four Horsemen shall have their leader...','',26124),
(119211,'enUS','What is this?!','',26124),
(119212,'enUS','The Death Gate... take... it.','',26124),
(119215,'enUS','','Beauxbeaux! What have they done!?',26124),
(119216,'enUS','','Go! Get far away from here!',26124),
(119217,'enUS','Shannon... is she okay? You must help the others!','',26124),
(119218,'enUS','','I couldn\'t do anything! They just... killed him!',26124),
(119219,'enUS','This is madness! Madness I tell you!','',26124),
(119220,'enUS','','I will get Mathias to safety through the sewer tunnels.',26124),
(119221,'enUS','Thank you.','',26124),
(119222,'enUS','','We will see you back in the Chamber of Shadows, $n.',26124),
(119223,'enUS','|TInterface\\Icons\\INV_Misc_Herb_Liferoot_Stem:20|t%s is casting |cFFFF0000|Hspell:212786|h[Uproot]|h|r, beware of Vilethorn Saplings!','',26124),
(119224,'enUS','You must remove the threat, $n!','You must remove the threat, $n!',26124),
(119225,'enUS','Look at me... look what they\'ve done! You must remove the threat at once!','Look at me... look what they\'ve done! You must remove the threat at once!',26124),
(119226,'enUS','We must reclaim our lands!','We must reclaim our lands!',26124),
(119227,'enUS','That thing did this! Purge the land of those demons!','That thing did this! Purge the land of those demons!',26124),
(119228,'enUS','I couldn\'t help them!','I couldn\'t help them!',26124),
(119229,'enUS','Look what they\'ve done! You must stop them!','Look what they\'ve done! You must stop them!',26124),
(119230,'enUS','I\'ve never seen such things before! I don\'t understand...','',26124),
(119231,'enUS','What... what IS this!? How could I... Stop them! You must!','',26124),
(119232,'enUS','My blades! This blood... it\'s fresh! The others must be warned!','',26124),
(119233,'enUS','If you see something, say something. To someone else.','',26124),
(119234,'enUS','I know you adore my charming demeanor, but you really should not be here unless you have business for me.','',26124),
(119235,'enUS','These alleys are dangerous. You never know who might pick your pockets.','',26124),
(119237,'enUS','I will pay Vanthir a visit in my own time. Go about your business if you don\'t have something for me to do.','',26124),
(119241,'enUS','We need your help \'persuading\' some noble houses to support Ly\'leth\'s bid for advisor. Are you in?','We need your help \'persuading\' some noble houses to support Ly\'leth\'s bid for advisor. Are you in?',26124),
(119242,'enUS','You\'ve got a look about you. Did something happen? Do you have need of my... expertise?\n\n<Arluin smiles lazily.>','',26124),
(119243,'enUS','Is that what she\'s up to? Brave girl. I\'d be delighted to help, but...','',26124),
(119250,'enUS','You have entered a free for all PvP area!','You have entered a free for all PvP area!',26124),
(119251,'enUS','','Die, worm!',26124),
(119252,'enUS','','Watch your step...',26124),
(119253,'enUS','Be cleansed by fire!','',26124),
(119254,'enUS','I am injured!','',26124),
(119255,'enUS','I require healing!','',26124),
(119256,'enUS','I need your help, healer!','',26124),
(119257,'enUS','Please tend to my wounds so I can continue fighting!','',26124),
(119258,'enUS','I am gravely wounded!','',26124),
(119259,'enUS','I won\'t survive these wounds much longer.','',26124),
(119260,'enUS','We deciphered the Codex of Command.','We deciphered the Codex of Command.',26124),
(119261,'enUS','I will continue to fight until my body collapses!','',26124),
(119262,'enUS','Tell my children that I tried my best, but without any heroes to heal my wounds I perished.','',26124),
(119263,'enUS','HEY! Can anybody heal my wounds? I know one of you is capable of healing!','',26124),
(119264,'enUS','','Highlord, you\'ve returned. And with Delas! It has been too long, friend.',26124),
(119265,'enUS','','Ishnu\'alah, Sister. Thank you for your warm welcome.',26124),
(119266,'enUS','','The portal at Felblaze Ingress must be destroyed. With your permission, Highlord, Arator and I will deal with this.',26124),
(119267,'enUS','','Allow me to accompany you, sister. I will send word to the Netherlight Temple and ask for reinforcements from the priest order.',26124),
(119268,'enUS','','We will gladly accept your help, Delas. The Light is strongest when it shines together.',26124),
(119269,'enUS','You have been of great service to the Guard, $p. How can we aid you in return?','',26124),
(119270,'enUS','We still owe you a great debt for your help in evacuating our stronghold. How can we repay you?','',26124),
(119271,'enUS','Come to Furog, tiny elf-monsters!','',26124),
(119272,'enUS','Tread carefully, shaman. The mogu who haunt those ruins are long dead, but their spirits remain... as do the traps they left behind.','',26124),
(119273,'enUS','Be wary, friend. It may take some time to earn the Nightfallen\'s trust.','',26124),
(119274,'enUS','Make sure you ask for the Scroll of Elun\'dris. It alone has the information we need!','',26124),
(119275,'enUS','','That\'s not quite the solution is it? Try activating the box again to give it another go.',26124),
(119276,'enUS','Come with me. We will fly straight to Pandaria.','',26124),
(119277,'enUS','That\'s it! I can feel it from here!','',26124),
(119278,'enUS','The Legion are not the only ones who can reach through the cosmos to strike their enemies.$B$BGive the word, $n. I will maintain the gateway open from this side.','',26124),
(119279,'enUS','It is time. Take us to Niskara.','It is time. Take us to Niskara.',26124),
(119280,'enUS','Yes, yes, it\'s all here. With the right ritual, we can safely infuse the Heart with even the most powerful magic!','',26124),
(119281,'enUS','%s submits to you.','%s submits to you.',26124),
(119282,'enUS','','Perfect. Shall we put our incantation to the test?',26124),
(119283,'enUS','','Our numbers may be few, but the Legion will learn to fear the Guard.',26124),
(119284,'enUS','I break your elf-thing!','',26124),
(119285,'enUS','','Let us begin the ritual at once.',26124),
(119286,'enUS','Are you sure this is going to work, Syrana?','',26124),
(119287,'enUS','','I do not know. But we owe it to our friend to try.',26124),
(119288,'enUS','Do you know what you see here, little outsider? It is the fate of the Tideskorn, once not so scorned by the tides.\n\nIt was Helya, the foul sea-witch, whose wrath consumed their fleets, and whose foul mists broke the mightiest of the vrykul. The jarls had no choice but to give up the sea, for axe and sword do naught to slay mist and brine.','',26124),
(119289,'enUS','Helya\'s domain is to watch over the souls of the unworthy, while those who die in glory are sent to Odyn in the Gates of Valor, to train for the final battle. But Helya, she is a jealous witch, and cannot be sated with the souls she is given.\n\nThus she made the kvaldir. Once mighty vrykul, now torn and corrupted by her foul magics. They serve her eternally, plundering the souls of the living to feed her unquenchable lust for death.\n\nThey are a blight, outsider. Nothing more.','',26124),
(119290,'enUS','What do you know of the kvaldir?','What do you know of the kvaldir?',26124),
(119291,'enUS','','Meet me within the Sanctum of Order. I must prepare for the ceremony.',26124),
(119292,'enUS','At last, some good news on this day of sorrow.','',26124),
(119293,'enUS','','Elun\'falah shalar.',26124),
(119294,'enUS','','Ishnu-talah Kaldorei!',26124),
(119295,'enUS','The matrix is destabilizing!','',26124),
(119296,'enUS','There must be a way to protect the heart from the volatility of the Legion\'s magic. I think I have an idea.','',26124),
(119297,'enUS','','We arrived at Felblaze Ingress soon after leaving Light\'s Hope Chapel. This log bears witness to our journey.',26124),
(119298,'enUS','','As she promised, Delas brought Conclave priests to join the battle. Our forces are getting along well.',26124),
(119299,'enUS','','The priests also seek Balnazzar. Their leader, Prophet Velen, saw a vision of the dreadlord raining destruction upon Azeroth.',26124),
(119300,'enUS','','The Legion does not yet suspect our presence. Their leader, Brood Queen Aramis, roams the camp each day.',26124),
(119301,'enUS','','We attack tomorrow. May the Light guide us.',26124),
(119302,'enUS','','We underestimated the Legion\'s cunning! After we attacked, the portal blazed to life. Balnazzar arrived and tore through our defenses.',26124),
(119303,'enUS','','We are still alive, but they are taking us through the portal... to their home world. What lies on the other side?',26124),
(119304,'enUS','','I broke free for a moment. Please, if anyone finds this, you are our only hope of rescue.',26124),
(119305,'enUS','This one\'s got some fight in \'em!','',26124),
(119306,'enUS','Keep \'em on guard! Don\'t let \'em out of sight!','',26124),
(119307,'enUS','I can assure ye - this won\'t be the last one we bring down today!','',26124),
(119308,'enUS','Show \'em yer strength! Fer the Alliance!','',26124),
(119309,'enUS','','Odyn\'s valor is rivaled only by his appetite. A true warrior.',26124),
(119310,'enUS','Captain, what do ye think you\'re doin\'? Ye aren\'t anywhere near ready ta get back in and fight.','Captain, what do ye think you\'re doin\'? Ye aren\'t anywhere near ready ta get back in and fight.',26124),
(119311,'enUS','Quit yer fussin\'! Yer soldiers are trained well. They can do it.','Quit yer fussin\'! Yer soldiers are trained well. They can do it.',26124),
(119312,'enUS','Enough! All that yellin\' \'ill probably make it worse!','Enough! All that yellin\' \'ill probably make it worse!',26124),
(119313,'enUS','Ye have to let them do it! It\'s their fight now!','Ye have to let them do it! It\'s their fight now!',26124),
(119314,'enUS','You need to rest and your soldiers are well trained. Now sit still.','You need to rest and your soldiers are well trained. Now sit still.',26124),
(119316,'enUS','Captain! Ye need ta try an\' rest! If ye don\'t, I\'ll let that demon come and fix ye up himself!','Captain! Ye need ta try an\' rest! If ye don\'t, I\'ll let that demon come and fix ye up himself!',26124),
(119317,'enUS','','Prepare for battle, champion. Even the Valarjar dare not tread so near Helya\'s domain.',26124),
(119318,'enUS','Wait... is it you? Hah! You\'ve come far my mortal friend. First you helped me defeat Loken and now you lead Odyn\'s own armies!','',26124),
(119319,'enUS','Who are you? What is the meaning of this?','',26124),
(119320,'enUS','Having the Illidari among us makes me uneasy. Their kind has been locked away since my brother\'s fall.','',26124),
(119321,'enUS','','I understand, husband. But for Maiev to release them, the situation must be even more dire than we know.',26124),
(119322,'enUS','The Legion overran the Vault of the Wardens seeking Lord Illidan\'s body. Gul\'dan has taken it.','',26124),
(119323,'enUS','That monster will pay for this desecration!','',26124),
(119324,'enUS','','Thank you. We could not allow my people\'s sacred heirloom to fall in the hands of such a monster!',26124),
(119325,'enUS','I bring urgent news, My King. Danger is all around you!','',26124),
(119326,'enUS','','There she goes! Ohn\'ahra wants you to follow her.',26124),
(119327,'enUS','Arise, champion!','Arise, champion!',26124),
(119328,'enUS','','I am pleased Ohn\'ahra gave her blessing. I feared the Bloototem\'s actions had angered her. Now we can depart for Stormheim!',26124),
(119329,'enUS','In the name of the Light, you are battle-born once more!','In the name of the Light, you are battle born once more!',26124),
(119330,'enUS','','I think she\'s offering aid. Look at her wing-- OH! Thank you!',26124),
(119331,'enUS','','Highlord! Over here!',26124),
(119332,'enUS','Well fought! Though I\'m afraid that was just one of many. We\'ve got ta remove the remaining threat, champions!','',26124),
(119333,'enUS','Looks like more backup just arrived!','',26124),
(119334,'enUS','Ah, a $c! We could definitely use more of ye!','',26124),
(119335,'enUS','Now that\'s a $c! Look at that armor! I haven\'t seen such a thing afore! Looks like it\'s time fer this demon ta fall.','',26124),
(119336,'enUS','More champions arrive! Ready up!','',26124),
(119337,'enUS','The harpies ravage the forest to which they dare to lay claim. Take the fight to them and drive out their infestation.','',26124),
(119338,'enUS','We can afford to give no quarter to a foe as insidious as the harpies. Their presence is a corruption, and corruption must be purged.','',26124),
(119339,'enUS','The Stoneblood harpies are using dark magic to turn Acolytes of Elo\'thir to stone! Save our noble allies from the harpy curse.','',26124),
(119340,'enUS','You have freed many acolytes, but the harpies are unrelenting. We must remain vigilant if we are to safeguard this land.','',26124),
(119341,'enUS','','There are many noble spirits that walk the land of the living, but Lord Ravencrest\'s cursed followers are beyond redemption. You\'d best defeat them before they rally and attack Bradesbrook in force.',26124),
(119342,'enUS','','The spirits\' forces have been weakened... for now. Can what is dead ever truly die?',26124),
(119343,'enUS','','This time those sprites have crossed the line! They\'re trapping and killing those cute little lunarwing faerie dragons. Well, go on! Save them!',26124),
(119344,'enUS','','Faerie dragons are so precious! It does my heart good to see them protected.',26124),
(119345,'enUS','The Nightmare\'s assault on the Temple of Elune is ceaseless. We must lend our aid to defend this most sacred place.','',26124),
(119346,'enUS','The Nightmare leaks into our reality like a seeping wound. But you have pushed back the darkness, at least for now.','',26124),
(119347,'enUS','The Darkgrove druids have turned the very flora against us! If they go unchecked, more of the forest will fall to their treachery!','',26124),
(119348,'enUS','Few things enrage me more than seeing druidic magic perverted. The Darkgrove deserve their fate!','',26124),
(119349,'enUS','Wormtalon harpies have beset Shadowfen. Thank goodness the survivors fled to safety! If you could recover the pieces of their lives they were forced to leave behind, it would be a great kindness.','',26124),
(119350,'enUS','More than command of magic or prowess in battle, the truest trait of a hero is the willingness to help others. This day proves you have a hero\'s heart!','',26124),
(119351,'enUS','Harpies seek to curse the graceful owls of our forest. Make haste! I pray you\'re not too late to stop them...','',26124),
(119352,'enUS','You saved the owls from a horrible fate. Nobly done!','',26124),
(119353,'enUS','','Pity the people of Bradensbrook! They left Gilneas before falling victim to the worgen curse, but now they face the cruelty of Lord Ravencrest\'s thugs. Their village needs your protection.',26124),
(119354,'enUS','','Though we have our differences, those are still my people in Bradensbrook. It was kind of you to help them.',26124),
(119355,'enUS','','A foul poison seeps into the waters of Mistvale. I feel in my bones that it must be the work of a corrupt druid. Seek out the defiler and end this affliction.',26124),
(119356,'enUS','','How could anyone become so twisted inside that they would infect such a beautiful lake? At least you set things right.',26124),
(119357,'enUS','','Leafbeard the Storied has come! He\'s an old soul who tells a captivating tale about the War of the Ancients. Pay attention and you may learn valuable lessons that will aid you in the fight against the Legion.',26124),
(119358,'enUS','','The War of the Ancients saw many great battles like the one you just experienced. It took all of Azeroth\'s defenders working together to defeat the demons then, as it will now.',26124),
(119359,'enUS','','The very roots of the World Tree are corrupted by the Nightmare. Cleanse Shala\'nir of the infestation that has claimed it.',26124),
(119360,'enUS','','One day Shala\'nir will be reclaimed and the roots of the World Tree safeguarded. We must not rest until that day dawns upon Val\'sharah!',26124),
(119361,'enUS','','The minions of Nightmare continue to defile Moonclaw Vale. Fight back against them, champion!',26124),
(119362,'enUS','','The vale remains plagued by darkness, but you have brought a ray of hope back to it. I thank you.',26124),
(119363,'enUS','','Our keeper and dryad allies have been twisted by the insidious power of the Nightmare. You must end their suffering.',26124),
(119364,'enUS','','Losing servants of the Dream breaks my heart, but at least they are at peace. For that, I thank you.',26124),
(119365,'enUS','That was a rough fight! Go help Hodir and I\'ll keep the way out clear.','',26124),
(119366,'enUS','','Though we woke our druids trapped in Sleeper\'s Barrow, the Nightmare now stirs within. Dispatch the foul denizens who taint it!',26124),
(119367,'enUS','','The tendrils of Xavius\' corruption are everywhere! Sleeper\'s Barrow will yet be cleansed.',26124),
(119368,'enUS','','Bears of the Sylvan Vale are known to possess a rare serenity, but I can sense their disquiet. Sprites are said to live nearby... I think foul play is afoot!',26124),
(119369,'enUS','','Mischievous little devils! You\'ve taught the sprites a lesson, and now the bears can live in peace.',26124),
(119370,'enUS','Everyone must work together to defeat the Legion.','',26124),
(119371,'enUS','Ravis, let\'s see what you have.','Ravis, let\'s see what you have.',26124),
(119372,'enUS','The time has come, Deathlord. Tirion Fordring awaits.','',26124),
(119373,'enUS','We will return to Acherus. Come Horsemen, the binding of souls awaits us.','',26124),
(119374,'enUS','The next task may be too perilous, even for you, little outsider. Return to me when you have fully honed your strength. \n\nOnly then would you hope to survive the Naglfar.','',26124),
(119375,'enUS','','Dreadroot was once a beautiful wood, but now is overrun by monstrosities of the Nightmare. This cannot stand!',26124),
(119376,'enUS','','This land may never fully recover from the evil that has infested it, but we must do all we can.',26124),
(119377,'enUS','','The grell usually keep to themselves, but they\'ve grown bold of late. They\'re attacking the Grizzleweald furbolg tribe! I fear they\'ll soon overrun the entire village.',26124),
(119378,'enUS','','Peace must be maintained in this forest. The Grizzleweald have long been allies of the people of Val\'sharah, and worthy of the help you provided.',26124),
(119379,'enUS','Owlbeasts are fierce guardians of sacred places. But when cut off from the light of Elune, they sometimes turn aggressive. Rescue the dryads from their menace!','',26124),
(119380,'enUS','To murder those dryads and turn them to monstrous creatures... I did not know owlbeasts possessed such vile magic! It is good you stopped them.','',26124),
(119381,'enUS','','Tal\'ashar it is. I name my friend here as my champion.',26124),
(119382,'enUS','I have no need to hide behind a champion. I will defend my own honor.','',26124),
(119383,'enUS','Meet me atop the Sanctum when you are ready to die, whelp.','',26124),
(119384,'enUS','The Naglfar must be stopped, but you are not yet strong enough.','',26124),
(119385,'enUS','Return to me when you are prepared to face this challenge, outsider.','',26124),
(119386,'enUS','','All is going as planned. You do not need to worry.',26124),
(119387,'enUS','I am ready to face Coryn.','I am ready to face Coryn.',26124),
(119388,'enUS','','I am modifying your disguise to allow you to fight like one of us.',26124),
(119389,'enUS','','Win me a title, won\'t you?',26124),
(119390,'enUS','','Take the tower! Greymane\'s forces will break before the might of the Horde!',26124),
(119391,'enUS','','These dogs cower when faced with real might. This tower belongs to the Horde!',26124),
(119392,'enUS','The Horde again claim a warden tower that should be ours. Show them the fury of the Alliance!','',26124),
(119393,'enUS','The Forsaken lines shatter under our advance across these islands. Onward, for the Alliance!','',26124),
(119394,'enUS','I seem to have lost my empowered disguise...','I seem to have lost my empowered disguise...',26124),
(119395,'enUS','','I wish this had not been necessary, but you have done well.',26124),
(119396,'enUS','','I will send you back to the tavern when you are ready.',26124),
(119397,'enUS','Mortal $r. You presume much to summon me.','',26124),
(119398,'enUS','Ragnaros the Firelord once imprisoned me within bindings such as those you hold now.','',26124),
(119399,'enUS','And greedy mortals not unlike you freed me only to strike and steal my weapon, and my power.','',26124),
(119400,'enUS','But now that the Earthen Ring has seen to my return, I am inclined to show patience. Your errand may not be a foolish one after all.','',26124),
(119401,'enUS','Give me the bindings that I might turn them against the Firelord and his minions, and I will reward you in kind.','',26124),
(119402,'enUS','And so it is done, $r. Do not call upon me again.','',26124),
(119403,'enUS','You possessed bindings such as those once before. An eternal prison from which you freed me only to jealously seek my power.','',26124),
(119404,'enUS','I should strike you down for what you did to me. For what you stole from me.','',26124),
(119406,'enUS','This way. I spent many months in the depths of Vashj\'ir during the Cataclysm, it is like a second home to me now.','',26124),
(119407,'enUS','Our missing shaman, Wavespeaker Adelee, had tracked the Scepter of Tides to this sunken city before she disappeared.','',26124),
(119408,'enUS','If we can locate her, the scepter will not be far away!','',26124),
(119409,'enUS','This ancient city was once one of the jewels of Kalimdor. Leave no stone unturned in our search.','',26124),
(119410,'enUS','That is Wavespeaker Adelee\'s staff. Hmmm. It is attuned to the Abyssal Maw. Perhaps Sharas\'dal is in there? I warned her not to go there alone...','',26124),
(119411,'enUS','Adelee spoke of a powerful wavestone. I see now what she meant. The auras surrounding this stone would cloak one\'s movements from Neptulon, allowing the naga to slip into his domain undetected.','',26124),
(119412,'enUS','It is fortunate that Adelee\'s journal is written in waterproof squid ink. It will detail her search for the scepter. I will need time to look this over - bring it to me.','',26124),
(119413,'enUS','All the clues indicate that Adelee tracked the scepter into the Abyssal Maw. The trail is easy to follow... perhaps too easy. We may be walking into a trap.','',26124),
(119414,'enUS','We should make our way to the Throne of Tides within the Abyssal Maw, where the scepter awaits. We must be careful - I fear Neptulon\'s Realm may be compromised!','',26124),
(119415,'enUS','|TInterface\\Icons\\Sha_Ability_Mage_FireStarter_nightmare:20|t%s is casting |cFFFF0000|Hspell:191325|h[Breath of Corruption]|h|r!','',26124),
(119416,'enUS','','You... bear mighty Odyn\'s blessing. I did not think it possible!',26124),
(119417,'enUS','Thank you for your help, Ashildir. If you\'ll excuse us, we have some demons to attend to.','',26124),
(119418,'enUS','Thank you, friend. Light bless you.','Thank you, friend. Light bless you.',26124),
(119419,'enUS','I thought we were lost once they brought us through the portal. Thank you, $c.','I thought we were lost once they brought us through the portal. Thank you, $c.',26124),
(119420,'enUS','I had faith that salvation would come. Thank you.','I had faith that salvation would come. Thank you.',26124),
(119421,'enUS','I never gave up hope, $c. You have my thanks.','I never gave up hope, $c. You have my thanks.',26124),
(119422,'enUS','My prayers have been answered. Thank you, $c.','My prayers have been answered. Thank you, $c.',26124),
(119423,'enUS','I didn\'t expect salvation from the Silver Hand. My thanks to you and your order.','I didn\'t expect salvation from the Silver Hand. My thanks to you and your order.',26124),
(119424,'enUS','My thanks to you, Highlord. For the Silver Hand!','My thanks to you, Highlord. For the Silver Hand!',26124),
(119425,'enUS','I am so happy to see you, $n. Light bless you.','I am so happy to see you, $n. Light bless you.',26124),
(119426,'enUS','Honor and justice to you, Highlord. I will fight on for the Order!','Honor and justice to you, Highlord. I will fight on for the Order!',26124),
(119427,'enUS','','A simple request.',26124),
(119428,'enUS','','I\'ve got this!',26124),
(119429,'enUS','Calydus is ready!','',26124),
(119430,'enUS','','Commander, Alonsus - forgive the interruption, but I have news I believe you will want to hear.',26124),
(119431,'enUS','Very well, Delas. Return to the temple at once when you have any information we can act on.','',26124),
(119432,'enUS','You call upon the winds?','',26124),
(119433,'enUS','','I will do my best!',26124),
(119434,'enUS','Ey, mon. I got this!','',26124),
(119435,'enUS','','I honor my master!',26124),
(119436,'enUS','I\'m up to the task!','',26124),
(119437,'enUS','The Tirisgarde will prevail!','',26124),
(119438,'enUS','','Enough talk. Time for action!',26124),
(119439,'enUS','I will give you nothing! Only pain!','I will give you nothing! Only pain!',26124),
(119440,'enUS','You cannot save him- he is as good as dead anyway!','You cannot save him- he is as good as dead anyway!',26124),
(119441,'enUS','Gah! I yield!','Gah! I yield!',26124),
(119442,'enUS','I was instructed to throw him to the carnivores. You will find only bones!','I was instructed to throw him into the lion pit. You will find only bones!',26124),
(119443,'enUS','I will find the way!','',26124),
(119444,'enUS','We\'re on, Baron! Let\'s go!','',26124),
(119445,'enUS','','I will not let you down.',26124),
(119446,'enUS','','Be careful, $r. The Nightborne are emboldened and leaving the borders of their city.',26124),
(119447,'enUS','','Nighteyes has gone out on patrol again. I pray he stays safe this time.',26124),
(119448,'enUS','','Nighteyes went to go scout the Menagerie. He had better take care of himself!',26124),
(119449,'enUS','','I will hunt them down!',26124),
(119450,'enUS','','For Elune!',26124),
(119451,'enUS','Let\'s do it!','',26124),
(119452,'enUS','I bring death!','',26124),
(119453,'enUS','','As you command!',26124),
(119454,'enUS','Say no more!','',26124),
(119455,'enUS','Time for a lesson in pain!','',26124),
(119456,'enUS','','I\'ll head to Dalaran and find a quiet place to decipher these runestones.',26124),
(119457,'enUS','The beast is loose! Kill it!','The beast is loose! Kill it!',26124),
(119458,'enUS','No beast can challenge the Legion!','No beast can challenge the Legion!',26124),
(119459,'enUS','Die, beast!','Die, beast!',26124),
(119460,'enUS','Su\'esh is loose! To arms!','Su\'esh is loose! To arms!',26124),
(119461,'enUS','Fools! Su\'esh has escaped the menagerie!','Fools! Su\'esh has escaped the menagerie!',26124),
(119462,'enUS','Kill it! Kill it now!','Kill it! Kill it now!',26124),
(119463,'enUS','','These are detailed travel logs. It appears the Legion has been scouring the Twisting Nether... but for what?',26124),
(119464,'enUS','','I recognize this place. Is it... Netherlight Temple? Is the Legion planning to invade the priest order hall?',26124),
(119465,'enUS','','That\'s the Prophet Velen! His life may be in great danger.',26124),
(119466,'enUS','Order will be restored to the city by force!','',26124),
(119467,'enUS','Those who speak out against the Master will be destroyed!','',26124),
(119468,'enUS','','Are you here for him? You won\'t get past me!',26124),
(119469,'enUS','Move quickly, and crush any who resist the Legion!','',26124),
(119470,'enUS','','For ages we hunted the sanctuary known as Netherlight Temple! Hidden, was it, beneath our very noses!',26124),
(119471,'enUS','','Finally, we sensed it. Holy light, seeping through the Twisting Nether! Blinding us!',26124),
(119472,'enUS','','Now, our armies will attack, and the Temple will fall... and with it the great Prophet Velen!',26124),
(119473,'enUS','The enemy may be using magic to deceive us! Do not let your guard down!','',26124),
(119474,'enUS','','The temple... will.... fall...',26124),
(119475,'enUS','Time to even the odds.','',26124),
(119476,'enUS','','Delas, thank goodness you\'re alive!',26124),
(119477,'enUS','','You came back! I thought my end had finally come.',26124),
(119478,'enUS','','Never, my friend. The Light stands together.',26124),
(119479,'enUS','Return when you are prepared to assault the Nighthold. Until then, Thalreus and I will work out the final details of our plan.','',26124),
(119480,'enUS','','Arator, are you still alive?',26124),
(119481,'enUS','Yes, I\'m all right. That imp mother was getting a little too close for comfort.','',26124),
(119482,'enUS','','You should head back to the portal. The Highlord and I will take care of the rest.',26124),
(119483,'enUS','A Waning Time Particle falls out of the Nightwell.','',26124),
(119484,'enUS','Thalreus and I have come up with a detailed plan for our assault upon the Nighthold.','',26124),
(119485,'enUS','','I will go ahead and help the others. We will get out of here together, sister.',26124),
(119486,'enUS','They betrayed us all. Their fates are sealed.','',26124),
(119487,'enUS','Get me out of here!','',26124),
(119488,'enUS','Releasing','Releasing',26124),
(119489,'enUS','A Depleted Particle falls out of the Nightwell.','',26124),
(119490,'enUS','I am getting off this infernal ship! I will return to my mother at once.','',26124),
(119491,'enUS','Finding an ally among our enemies might prove to be a difficult task.','',26124),
(119492,'enUS','It is time you face Darkness Incarnate himself... Gul\'dan.','',26124),
(119493,'enUS','Only one item per week, boss. Them\'s the rules.','',26124),
(119494,'enUS','','You are not leaving my sight until an advisor is appointed. Promise me!',26124),
(119495,'enUS','Yes, mother.','',26124),
(119496,'enUS','','Thank you. Do let Ly\'leth know that I stand with her.',26124),
(119497,'enUS','There\'s only place where we can tap into the power within the shards: the Lunar Crucible.','',26124),
(119498,'enUS','','Of course! But the entire stronghold is still crawling with Nightborne.',26124),
(119499,'enUS','Then I suppose we\'ll have to ask them to leave.','',26124),
(119500,'enUS','I\'ll secure the Heart and meet you there. The Moon Guard should have the area secured when we arrive.','',26124),
(119501,'enUS','It is good to be back home again, even if just for a little while.','',26124),
(119502,'enUS','We are ready to begin when you are.','',26124),
(119503,'enUS','Elun\'falah shalar.','',26124),
(119504,'enUS','Ishnu-talah Kaldorei.','',26124),
(119505,'enUS','Let the pain speak to me.','Let the pain speak to me.',26124),
(119506,'enUS','Let us begin.','Let us begin.',26124),
(119507,'enUS','Fight... together? I suppose.','Fight... together? I suppose.',26124),
(119508,'enUS','Anar\'endal dracon belora.','',26124),
(119509,'enUS','','Elun\'orin torel!',26124),
(119510,'enUS','Now is your moment, $p. Unleash the power hidden deep within!','',26124),
(119511,'enUS','It worked. It really worked!','',26124),
(119512,'enUS','Thank you for the truly incredible journey. If you ever long for another adventure, you know where to find me.','',26124),
(119513,'enUS','My patience wears thin. Relinquish the feast to me before we do battle or you will not have my blessing this day!','',26124),
(119514,'enUS','If you seek my blessing, even you must complete the ancient trials of these halls, Valarjar.','',26124),
(119515,'enUS','As for you, my Valarjar... well done. Well done!','',26124),
(119516,'enUS','I fear we have but a moment, hero. Rakeesh is still here - somewhere - and he must be stopped if my people are to find peace again.','',26124),
(119517,'enUS','I know that you have ventured far to find me and have brought with you a dire message.','',26124),
(119518,'enUS','In your possession is an object of great importance. May I see it?','',26124),
(119519,'enUS','<Place the Mysterious Lightbound Object on the ground.>','<Place the Mysterious Lightbound Object on the ground.>',26124),
(119520,'enUS','Next time you hold a blade to someone\'s throat, consider who you\'re dealin\' with.','',26124),
(119521,'enUS','Now we\'re square. Business as usual goin\' forward. Feel free to use the crucible as much as you like.','',26124),
(119522,'enUS','','The situation in Stormwind is worse than we thought. We have a plan to reveal Detheroc for the imposter that he is. Master Shaw?',26124),
(119523,'enUS','Tethys will get us to the harbor by sea. We will have to stealth through to SI:7. We cannot fly in; Detheroc has snipers on the rooftops and wanted posters up with all of our faces.','',26124),
(119524,'enUS','First, allow me to express my gratitude that you risked your lives to rescue me.','',26124),
(119525,'enUS','I trust that you will not come to regret that decision. What I\'m going to propose is much more dangerous.','',26124),
(119526,'enUS','Taoshi is correct. The situation is dire and degrading quickly. The Alliance is about to launch an attack on the Horde.','',26124),
(119527,'enUS','Posing as me, Detheroc is whispering lies about the Horde in the ears of the new king of Stormwind. He must be stopped before it is too late.','',26124),
(119528,'enUS','The plan is simple: sneak into Stormwind, expose Detheroc, and then kill him.','',26124),
(119529,'enUS','','Thank you, Master Shaw. That\'s the plan, Uncrowned. All in favor?',26124),
(119530,'enUS','Help! Please!','Help! Please!',26124),
(119531,'enUS','Legion structure! Fields southwest of Tarren Mill! Bring it down!','',26124),
(119532,'enUS','ALLIANCE - mount up! Western hills are swarmin\' with demon filth!','',26124),
(119533,'enUS','Eastpoint Tower\'s under attack!','',26124),
(119534,'enUS','','Send reinforcements to Southpoint Gate!',26124),
(119535,'enUS','Another demon! Eastpoint! We\'ll hold it off as long as we can!','',26124),
(119536,'enUS','An unpleasantly large demon has arrived at our camp in Southshore. Reinforcements would be greatly appreciated.','',26124),
(119537,'enUS','May I see it?','',26124),
(119538,'enUS','For the Alliance!','For the Alliance!',26124),
(119539,'enUS','Well fought!','Well fought!',26124),
(119540,'enUS','Together as one!','Together as one!',26124),
(119541,'enUS','By our blades!','By our blades!',26124),
(119542,'enUS','The Legion will fall!','The Legion will fall!',26124),
(119543,'enUS','Great work everyone!','Great work everyone!',26124),
(119544,'enUS','We did it!','We did it!',26124),
(119545,'enUS','','Just do it already! I would rather die than spend another day living a life built around your twisted beliefs!',26124),
(119546,'enUS','','I no longer take their name, or their values.',26124),
(119547,'enUS','','I wish to aid my fellow priests in their fight against the Burning Legion.',26124),
(119548,'enUS','This is unexpected - a Scarlet priest, walking through our temple.','',26124),
(119549,'enUS','In times such as these, we cannot afford to turn away those willing to help. We welcome you, as our new ally.','',26124),
(119550,'enUS','','You gave me a chance to redeem myself, and I will spend my life trying to do so.',26124),
(119551,'enUS','','The shadows will devour you!',26124),
(119552,'enUS','','You have the Shadows at your side, should you ever need them.',26124),
(119553,'enUS','Go on Delas, tell us what you\'ve learned.','',26124),
(119554,'enUS','The demons killed most of my shaman. We retreated here to make one last stand.$B$B<Nobundo sighs.>','',26124),
(119555,'enUS','','A putrid slime has been pouring out of the Arcway for weeks. Find the source and cut it off!',26124),
(119556,'enUS','','I\'ve been working with Aponi Brightmane and the leader of her order. We translated a codex that details the Legion\'s plans to establish an invasion point at Felblaze Ingress.',26124),
(119557,'enUS','','I\'d like to take a small group of priests to accompany the paladins in their search of this demon world. If the dreadlord is there, we will find him.',26124),
(119558,'enUS','Stop where you are! Only priests may step foot within this temple.','',26124),
(119559,'enUS','Please, let me pass. I have news of Delas Moonfang!','',26124),
(119560,'enUS','','May the Light guide your way.',26124),
(119561,'enUS','','You won\'t be alone on this journey.',26124),
(119562,'enUS','','The loose mana of the Arcway has created a monstrosity! Deal with it before it becomes an even greater threat!',26124),
(119563,'enUS','','Arcanist Naran has yet to return from the Arcway. Find what became of him and report back to me.',26124),
(119564,'enUS','','My spirit is one with the void!',26124),
(119565,'enUS','','Find the keystone that once powered these halls. The mana it holds will aid our cause!',26124),
(119566,'enUS','','Thank you, priest. The weight of the darkness has been lifted.',26124),
(119567,'enUS','','A plague runs rampant in the Arcway. Cleanse the infestation before it spreads further!',26124),
(119568,'enUS','Set sail for Stormwind City.','Set sail for Stormwind City.',26124),
(119569,'enUS','May the Light guide you.','',26124),
(119570,'enUS','Delas, you say?','',26124),
(119571,'enUS','Stop that at once!','Stop that at once!',26124),
(119572,'enUS','What do you think you\'re doing?','What do you think you\'re doing?',26124),
(119575,'enUS','How can I be of service?','How can I be of service?',26124),
(119576,'enUS','I would like to requisition some Trackers.','I would like to requisition some Trackers.',26124),
(119577,'enUS','I would like to requisition some Rangers.','I would like to requisition some Rangers.',26124),
(119578,'enUS','','The Arcway is one step closer to its former glory thanks to you.',26124),
(119579,'enUS','','I never believed the serpents could get so big! You\'ve saved us all.',26124),
(119580,'enUS','','We would have lost Arcanist Naran without your aid. Thank you. I am in your debt.',26124),
(119581,'enUS','','This keystone will ensure our success against the Magistrix. Your efforts will not be forgotten.',26124),
(119582,'enUS','','The plague will spread no further thanks to you.',26124),
(119583,'enUS','I hate being right all the time.','I hate being right all the time.',26124),
(119584,'enUS','I am fairly alarmed here.','I am fairly alarmed here.',26124),
(119585,'enUS','What\'s your problem? You spilled arcwine all over me!','',26124),
(119586,'enUS','Just nothing! You\'ve got ten seconds to make this right before I beat you to the ground!','',26124),
(119587,'enUS','Sorry. I didn\'t see you there. I was just...','',26124),
(119588,'enUS','Well, if it\'s going to come to that, I might as well...','',26124),
(119589,'enUS','Sneak attack!','',26124),
(119590,'enUS','You should never underestimate the little ones. We can be quite... tricky.','',26124),
(119591,'enUS','I-I-I\'m sorry. I didn\'t see...','',26124),
(119592,'enUS','Didn\'t see what?','',26124),
(119593,'enUS','I\'ll get you some more wine, just please don\'t hurt me.','',26124),
(119594,'enUS','You\'re such a weakling, only pandering to me to get out of a real fight.','',26124),
(119595,'enUS','That\'ll teach you. Only the strong survive!','',26124),
(119596,'enUS','Mother of Light! I... I am sorry. I did not know.','',26124),
(119597,'enUS','$ct $n, we have to go. NOW!','',26124),
(119598,'enUS','I will explain on the way there. Inform me when you are prepared to leave, but please hurry.','',26124),
(119599,'enUS','What you have brought to me is known as Light\'s Heart. It is the sentience core of the naaru prime: Xe\'ra.','',26124),
(119600,'enUS','Her... progeny. O\'ros... NO!','',26124),
(119601,'enUS','HAH! It makes music when you beat it! What a delightful creature! I will enjoy ending its existence.','',26124),
(119602,'enUS','This invasion was a subterfuge. We were corralled here like cattle, exactly as they planned. Now they have found O\'ros - the last of the Light Mother\'s children!','',26124),
(119603,'enUS','Gather your courage, hero. We must act quickly!','',26124),
(119604,'enUS','Tell me when you are ready to rescue O\'ros and we will go.','',26124),
(119605,'enUS','Are you prepared to save O\'ros from Rakeesh and uncover the secrets held within Light\'s Heart?','',26124),
(119606,'enUS','I\'m ready, Velen!','I\'m ready, Velen!',26124),
(119607,'enUS','Is there anything else that you can tell me about Xe\'ra and the naaru before we go? [I PUT ON MY RED SHIRT AND WIZARD\'S HAT]','Is there anything else that you can tell me about Xe\'ra and the naaru before we go? [LOTS OF RP]',26124),
(119608,'enUS','Demons in the throne room! Protect the king!','',26124),
(119609,'enUS','Shatter their portals! Drive out the Legion!','',26124),
(119610,'enUS','Your sword has made me wonder if it would be better as an axe. What would that axe look like? Is there one out there already?','',26124),
(119611,'enUS','Is there an axe the equal to Strom\'kar?','Is there an axe the equal to Strom\'kar?',26124),
(119612,'enUS','There must be. All the powerful qualities of the Warbreaker, but the splitting strength of an axe. There must be something!','',26124),
(119613,'enUS','Is that a key to Lei Shen\'s palace?  Wherever did you get that?\n\nI\'d be up for one more raid on the Thunder King\'s treasure troves, for old time\'s sake.  Just give me the word.','We are ready to launch the raid at a moment\'s notice. All we need is the key. Have you found one?',26124),
(119614,'enUS','Let\'s head to Isle of Thunder and put this key to use.','I have the key, let\'s start the raid. [Queue for solo instance.]',26124),
(119615,'enUS','This might be the end for us, friends. But if we are going to die here today, we die fighting!','',26124),
(119616,'enUS','King Ymiron has been defeated. He fought fiercely.','King Ymiron has been defeated. He fought fiercely.',26124),
(119617,'enUS','<Odyn laughs a deep booming laugh.>$B$BYou are a devious one, $n. You are right, that would amuse me. Let it be done!','',26124),
(119618,'enUS','I want him to join our army.','I want him to join our army.',26124),
(119619,'enUS','Absolutely out of the question.$B$BKing Ymiron betrayed his people and doomed them to a cursed existence.$B$BHe might\'ve died while fighting valiantly but I abhor him and the feeling is mutual.','',26124),
(119620,'enUS','That may be, but what better punishment than to force him to serve you for the rest of time?','That may be, but what better punishment than to force him to serve you for the rest of time?',26124),
(119621,'enUS','Your sword is incredible, I wonder if there is an axe to match it.','',26124),
(119622,'enUS','Thank you.','Thank you.',26124),
(119623,'enUS','Sometimes it is best to get out into the field and get a personal view of the war. The war could be going better.','',26124),
(119624,'enUS','That was to be expected. Ymiron was a cruel and evil ruler, but he always did fight with great ferocity.','',26124),
(119625,'enUS','Today I\'m here to fight the enemies of Azeroth. I\'ve no interest in wasting my strength with you. What do you want?','',26124),
(119626,'enUS','You are one of the greatest warriors the Horde has ever fielded. Your Arcanite Reaper is feared by all of your foes.','You are one of the greatest warriors the Horde has ever fielded. Your Arcanite Reaper is feared by all of your foes.',26124),
(119627,'enUS','I do not do what I do for praise. I\'m here to save Azeroth and the Horde. I sense you have a purpose here. What do you want?','',26124),
(119628,'enUS','<Tell Saurfang of Helgar\'s request.>','<Tell Saurfang of Helgar\'s request.>',26124),
(119629,'enUS','I am honored you and he think so highly of me. It is true I have seen no small amount of battle.','',26124),
(119630,'enUS','','I was doing research for Ranger-General Windrunner when all hell broke loose.$b$bWhat do you need?',26124),
(119631,'enUS','You have seen much battle as well, perhaps it is time to see how far you have come. Let us duel and I will aid your smith.','',26124),
(119632,'enUS','When you are ready, send your messenger for me. I will come.','',26124),
(119633,'enUS','King Anduin needs me to get to Dalaran. Can you open a portal?','King Anduin needs me to get to Dalaran. Can you open a portal?',26124),
(119634,'enUS','','I\'ve been readin\' about a book written by an expert tradesman that spoke at length about the Ashbringer. \n\nIt seems most copies were lost long ago, their tattered pages scattered tae the winds.\n\nI wonder if it\'s still out there somewhere? I\'m sure we could learn a thing o\' two if we could piece it back together!',26124),
(119635,'enUS','','I\'ll open it at once. Then I must inform the ranger-general of my findings. Good luck!',26124),
(119636,'enUS','While I am not interested in helping your Alliance become stronger, the Legion is a threat too great to not take every possible action against.','',26124),
(119637,'enUS','Sister, could you take a look at these? They might be the missing pieces of the book!','Sister, could you take a look at these? They might be the missing pieces of the book!',26124),
(119638,'enUS','I know of your exploits, but I must see them firsthand before I give you what you want. Let us duel.','',26124),
(119639,'enUS','','<Elda carefully thumbs through the pages, her eyes moving rapidly across the weathered text.>\n\nBy the Light, Highlord - I think you\'re right! This must be the one!\n\nI should be able tae piece it back together - allow me just a moment!',26124),
(119640,'enUS','Of course.','Of course.',26124),
(119641,'enUS','Why have I been brought back to fight for you?','',26124),
(119642,'enUS','You look pleased. You have found your warrior?','',26124),
(119643,'enUS','<Tell Helgar of Saurfang and his request.>','<Tell Helgar of Saurfang and his request.>',26124),
(119644,'enUS','Welcome to Dalaran! I\'m happy to assist with anything you need.','',26124),
(119645,'enUS','We have a place for that. Make your way to the Circle of Glory. I will send a val\'kyr to bring this Saurfang.','',26124),
(119646,'enUS','I must inform the Council of your news. Good luck, $n!','',26124),
(119647,'enUS','','It should only take a moment o\' two. Oh, this is so excitin\'!',26124),
(119648,'enUS','Let\'s meet back at the Hall of Shadows.','Let\'s meet back at the Hall of Shadows.',26124),
(119649,'enUS','','I\'ll press a copy for our archives so ye can keep the finished book, Highlord.',26124),
(119650,'enUS','','How fascinatin\'. This Nat Pagle sounds like quite the adventurer!',26124),
(119651,'enUS','','Aha! Success!',26124),
(119652,'enUS','','Ye should see if ye can find anyone who might know more about this book. I think it\'s hintin\' at somethin\' far bigger than a day o\' fishin\'!',26124),
(119653,'enUS','I am here. Let us not waste time!','',26124),
(119654,'enUS','It is good to see you, friend. I was able to hold them off but I fear more will be upon us soon.','',26124),
(119655,'enUS','Enough! You have proven your ability. I will grant your request.','',26124),
(119656,'enUS','','Hello, peach!  Be careful if you\'re going to Dalaran Crater, it\'s quite a drop.\n\nI just so happen to have some gliders for sale if you need one though.\n\n10 gold.\n\nNo refunds.',26124),
(119657,'enUS','Sure, I\'ll take one.','Sure, I\'ll take one.',26124),
(119658,'enUS','A fine fight I saw! Master Saurfang, I believe $n chose correctly with you. Now, may I see you and your weapon together?','',26124),
(119659,'enUS','Fine, though I have never seen a smith work in such a manner.','',26124),
(119660,'enUS','A smith with enough knowledge can see the details. The scratches on the blade, the wear of the haft tell of battle stresses and where it hits most often. See how easily you balance the heft. The comfort of your grip shows years of experience. While that cannot be forged, I can improve a new weapon in the right places so its wearer strikes more true and lives to earn those years.','',26124),
(119661,'enUS','','Good choice!  Make sure to use it before you hit the ground.  It\'s not much help after that.',26124),
(119662,'enUS','The elementals sense the disturbance here. Defend yourselves!','',26124),
(119663,'enUS','A single goblin glider kit will cost:','A single goblin glider kit will cost:',26124),
(119664,'enUS','This is only the beginning. The withered will be drawn to this much energy in one place.','',26124),
(119665,'enUS','Why not both, your highness? I will tell you the tale of the black drake Nefarian\'s fall, if you would tell me more about this book and the Ashbringer.','Why not both, your highness? I will tell you the tale of the black drake Nefarian\'s fall, if you would tell me more about this book and the Ashbringer.',26124),
(119666,'enUS','Incoming!','',26124),
(119667,'enUS','Please, hero, we have no time to waste! Come!','',26124),
(119668,'enUS','That was close. I thought they\'d never stop coming.','',26124),
(119669,'enUS','What?! The Nightborne are upon us!','',26124),
(119670,'enUS','This is the last of my power. Take it and destroy these traitors!','',26124),
(119671,'enUS','That was the last of them. I can use what little power I have left to escape. Farewell, friends.','',26124),
(119672,'enUS','Ah, yes. I had heard of Nefarian\'s demise, but it is indeed a treat to see his grisly end firsthand. Were I not stuck in these halls I might pay his lair a visit. \n\nPerhaps one day.\n\nAs for my end of our agreement, the tale of the Ashbringer is one of my favorites, of course.\n\n<The Prince glances at your weapon and smiles.>\n\nBut it would seem you are familiar with that particular tale.','',26124),
(119673,'enUS','What about this book? Can you tell me what it all means?','What about this book? Can you tell me what it all means?',26124),
(119674,'enUS','A human mage gave me a copy of that book many years ago. He kept trying to convince me to help him, going on about something to do with fighting fire with fire.\n\nI cannot leave this place, as you know, so that was the last I saw of the strange fellow. He went off to reunite with his allies, I presume.\n\nYou are not the first to inquire about this book, however. I wonder...','',26124),
(119675,'enUS','Who else sought you out?','Who else sought you out?',26124),
(119676,'enUS','He was a Tauren if I am not mistaken - and I am not often mistaken.\n\nHe came here with a copy of that very book, just as you have today, but had no proof of the black drake\'s death, and so my lips remained sealed. He was quite eager to learn about the Ashbringer\'s whereabouts.\n\nPerhaps if you found him, he might be able to enlighten you further.','',26124),
(119677,'enUS','She was a dwarf if I am not mistaken - and I am not often mistaken.\n\nShe came here with a copy of that very book, just as you have today, but had no proof of the black drake\'s death, and so my lips remained sealed. She was quite eager to learn about the Ashbringer\'s whereabouts.\n\nPerhaps if you found her, she might be able to enlighten you further.','',26124),
(119678,'enUS','Do you know anything more about what this wizard created to deserve such a fate?','Do you know anything more about what this wizard created to deserve such a fate?',26124),
(119679,'enUS','Armies of Ulduar, heed Odyn\'s call!','',26124),
(119680,'enUS','Father! Though we are oathbound to answer the call of the Gjallarhorn, we cannot.','',26124),
(119681,'enUS','The halls of Ulduar have been overrun by the armies of the Legion. We are fighting bravely but their numbers are endless.','',26124),
(119682,'enUS','I do not know.\n\nThey say that only the crusade knows the truth, and they have been all but eradicated.\n\nPerhaps you might find the answers you seek in one of their former holds.','',26124),
(119683,'enUS','','I\'m afraid I don\'t know.\n\nOnly the crusaders that killed him know the truth, and none among their ranks live to reveal it.\n\nI would search their former holds for answers.',26124),
(119684,'enUS','Thorim... son! Hold them off! I shall send my champions to your aid.','',26124),
(119685,'enUS','Let it be known! Today, thanks to the new Battlelord of the Valarjar we have won our first decisive victory against the Legion in one of their own worlds.','',26124),
(119686,'enUS','<One of the sections in particular is slightly more worn than the others.>\n\n...the loathsome wizard is more resilient than I had first expected.\n\nStill, showing him the Light\'s wrath has been one of my great joys these past few weeks. The heathen deserves worse - who would dare try to create something so foul from the very shadows we seek to destroy?!\n\nI knew his kind were not to be trusted.','',26124),
(119687,'enUS','Victory to the Valarjar! Victory to the Battlelord!','',26124),
(119688,'enUS','<Turn the page.>','<Turn the page.>',26124),
(119689,'enUS','I cannot afford to dispose of the wretch here; the attention it would draw if he were found would only further complicate my glorious work.\n\nNo... I have a better idea. I will bring him to death\'s very door and leave him in the Plaguelands. \n\nThere is a particularly vile slime on the river\'s edge that will ensure not a trace remains of the traitorous louse... if I can find the damned creature.','',26124),
(119690,'enUS','Kids these days, no respect for archival. When I was an apprentice, why, I cared!','',26124),
(119691,'enUS','I searched the world high and low for information! I wrote down everything. Even the inconsequential things. I\'ve seen things you would not believe, $Glad:lass;. Things you would not believe!','',26124),
(119692,'enUS','I wrote the story of this order. But that blasted apprentice lost all of them. All of them! It\'s ridiculous, I tell you. He sold them for mere coppers a page!','',26124),
(119693,'enUS','I bought this one back, but the rest were long gone. Paid a pretty penny for it too, golds where that blasted fool got coppers. I\'ve been searching high and low, but haven\'t been able to find more than rumors of the rest. These old bones aren\'t as up for adventuring as they were.','',26124),
(119694,'enUS','I agree, $n.','',26124),
(119695,'enUS','Pah, no respect for your elders.','',26124),
(119696,'enUS','What did you do?','What did you do?',26124),
(119697,'enUS','That\'s nice.','That\'s nice.',26124),
(119698,'enUS','I wouldn\'t believe them?','I wouldn\'t believe them?',26124),
(119699,'enUS','What did you write down?','What did you write down?',26124),
(119700,'enUS','That\'s terrible.','That\'s terrible.',26124),
(119701,'enUS','What did you do then?','What did you do then?',26124),
(119702,'enUS','Go away. I\'ve no time to be patronized.','',26124),
(119703,'enUS','Ah, the Ashbringer yet lives. Curious.','',26124),
(119704,'enUS','You will find no fight here, paladin. I can do you no harm, and bear no allegiance to the dark creatures you seek to destroy.','',26124),
(119705,'enUS','What happened to you?','What happened to you?',26124),
(119706,'enUS','Are you mad? That\'s the farthest thing from nice I could imagine, short of ripping my beard out hair by luxuriant hair.','',26124),
(119707,'enUS','I suspect you know. We would not be meeting otherwise.\n\nMy story is simple. The original wielder of your blade proved unable to stand against the endless throngs of undead that threatened our world.\n\nI sought a different approach... one that could not fail.','',26124),
(119708,'enUS','<Take the book.>','<Take the book.>',26124),
(119709,'enUS','And what was that?','And what was that?',26124),
(119710,'enUS','All conduits are active. Can you amplify the feed?','All conduits are active. Can you amplify the feed?',26124),
(119711,'enUS','I devised a way to fight the scourge using their own magic against them. It was a simple process, really - I had a veritable river of souls at my disposable from the Lich King\'s rampage.\n\nIn the end, I created a counterpart to the holy relic that fuels the Ashbringer\'s strength, but before I could properly seal it within a suitable blade I was found out by Isillien and his dogs.\n\nThe rest, as they say, was excruciatingly painful.','',26124),
(119712,'enUS','What happened to the crystal?','What happened to the crystal?',26124),
(119713,'enUS','Before I was devoured ever so slowly I did two things.\n\nThe first, as should be obvious, was putting my necromantic learnings to the test, sealing my soul within the phylactery you found. It did nothing for the pain of death... but it has served its purpose.\n\nAfterward, as I was already half-consumed by the creature, I hurled the crystal into the river beside you in hopes that someone might still put it to use against the forces of darkness.\n\n<The lich\'s face contorts into something of a smile.>\n\nIf you seek it, you will find it there.','',26124),
(119714,'enUS','You know, I\'ve been rather missing having some skin on my bones.  Maybe there\'s something we can do about that?','',26124),
(119715,'enUS','No. Lower caste. Won\'t do at all.','',26124),
(119716,'enUS','Not bad... not bad.  Green eyes though?  Mine were grey.','',26124),
(119717,'enUS','I feel a dark presence nearby...','',26124),
(119718,'enUS','Do you feel it as well, Highlord? Something isn\'t right.','',26124),
(119719,'enUS','I\'ve recovered a dark, but powerful crystal, Maxwell.\n\nIf we can harness its power it might prove useful against the Legion.','I\'ve recovered a dark, but powerful crystal, Maxwell. If we can harness its power it might prove useful against the Legion.',26124),
(119720,'enUS','I see.\n\nI trust your wisdom, Highlord, but I can\'t say that this sits well with me. \n\nHow can we ever be sure that the power within that thing won\'t... change you?','',26124),
(119721,'enUS','There cannot be Light without Shadow. We must strike a balance.','There cannot be Light without Shadow. We must strike a balance.',26124),
(119722,'enUS','You\'re right, but how can we ever hope to tap into that safely? Our power will only...\n\n<Tyrosus pauses.>\n\nThe Ebon Blade.','',26124),
(119723,'enUS','Careful with that thing!','Careful with that thing!',26124),
(119724,'enUS','Bring it back in one piece!','Bring it back in one piece!',26124),
(119725,'enUS','Hey! I wasn\'t finished yet.','Hey! I wasn\'t finished yet.',26124),
(119726,'enUS','You be careful out there!','You be careful out there!',26124),
(119727,'enUS','Su\'esh roars happily at $n.','',26124),
(119728,'enUS','You\'ve shown me more mercy than I deserve.','You\'ve shown me more mercy than I deserve.',26124),
(119729,'enUS','Thank you, $n. I will not forget your kindness.','Thank you, $n. I will not forget your kindness.',26124),
(119730,'enUS','You have given me a second chance. I will not waste it.','You have given me a second chance. I will not waste it.',26124),
(119731,'enUS','Free at last! I\'ve been a prisoner of their beliefs for far too long.','Free at last! I\'ve been a prisoner of their beliefs for far too long.',26124),
(119732,'enUS','Su\'esh begins to thrash nervously. Turn back before she throws you off!','Su\'esh begins to thrash nervously. Turn back before she throws you off!',26124),
(119733,'enUS','I believe I know a way I can help you, small one.','',26124),
(119734,'enUS','I believe I know a way I can help you, Conjurer.','',26124),
(119735,'enUS','Scaleguard, freeze them to their bones!','',26124),
(119736,'enUS','Tidecaller, shield me!','',26124),
(119737,'enUS','Archmage Vargoth, what is the source of your power?','Archmage Vargoth, what is the source of your power?',26124),
(119738,'enUS','I\'d like to try the brewing challenge again.','I\'d like to try the brewing challenge again.',26124),
(119739,'enUS','It is my duty to remain and ensure the Legion does not penetrate the gates.','',26124),
(119740,'enUS','What is your message, Priestess?','What is your message, Priestess?',26124),
(119741,'enUS','','It is a risk, but the Temple will be vulnerable regardless. We should stand together.',26124),
(119742,'enUS','','What if the stranger does not arrive as he promises? Can we count on his word?',26124),
(119744,'enUS','You would trust the words of that stranger? The one who looked like a dreadlord himself?','',26124),
(119745,'enUS','Balnazzar won\'t expect heavy resistance. It could be our chance to slay him once and for all.','',26124),
(119746,'enUS','','Netherlight Temple is in danger. Together, Knights of the Silver Hand, we can make our final stand against Balnazzar.',26124),
(119747,'enUS','Beyond that, nothing is certain. Let us simply have faith that the Light will answer.','',26124),
(119748,'enUS','','I\'m ready to leave this place and never look back.',26124),
(119749,'enUS','I am Gul\'dan! I am darkness incarnate! It cannot end... like this.','',26124),
(119750,'enUS','Time to return the demon hunter\'s soul to his body... and deny the Legion\'s master a host!','',26124),
(119751,'enUS','You topple a pawn and presume to challenge its master? Such arrogance!','',26124),
(119752,'enUS','Behold the shadow of what is to come, the endless darkness that shall consume your world.','',26124),
(119753,'enUS','You are not prepared!','',26124),
(119754,'enUS','Become a vessel of darkness!','',26124),
(119755,'enUS','Feel the power... of the demon within!','',26124),
(119756,'enUS','Behold the Flames of Azzinoth!','',26124),
(119757,'enUS','Gaze upon the inevitable end of all you know... all you fought for!','',26124),
(119758,'enUS','That was too easy!','',26124),
(119759,'enUS','Now you fall!','',26124),
(119760,'enUS','How... is it even... possible?','',26124),
(119761,'enUS','He will... yet claim... this titan...','',26124),
(119762,'enUS','Was that all the fury you could muster?','',26124),
(119763,'enUS','Too late! I am unstoppable!','',26124),
(119764,'enUS','Su\'esh runs over to take a drink.','Su\'esh runs over to take a drink.',26124),
(119765,'enUS','Hear now the tale of how Skovold stole his title of king. Witness the treachery he showed the one who bore him.','',26124),
(119766,'enUS','And so rose the God-King Skovald, covered in the blood of his own family.','',26124),
(119767,'enUS','','Traitors!',26124),
(119768,'enUS','','Die, followers of the false king!',26124),
(119769,'enUS','','Your false god-king cannot save you now!',26124),
(119770,'enUS','','For the Queen!',26124),
(119771,'enUS','','Skovald shall fall!',26124),
(119772,'enUS','','Foolish boy. Do you think your fel tricks will save you from my wrath?',26124),
(119773,'enUS','','You may have murdered your father. You may have murdered your brothers. But that does NOT give you the right to rule our people!',26124),
(119774,'enUS','Return when you are ready to face the forces of Nightmare. Until then, we will plan our next steps.','',26124),
(119775,'enUS','','You... are no longer... my son...',26124),
(119776,'enUS','No, mother. I am your KING!','',26124),
(119777,'enUS','','Choose, but choose wisely. The fate of the Broken Isles is in your hands.',26124),
(119778,'enUS','Ready when you are, $p.','',26124),
(119779,'enUS','','This is likely a one-way trip. Detheroc is most certainly expecting us. Let me know when you are ready.',26124),
(119780,'enUS','','The Light guides my sword!',26124),
(119781,'enUS','','Search deep for your inner strength.',26124),
(119782,'enUS','','We stand together.',26124),
(119783,'enUS','','I will fight in the name of Elune!',26124),
(119784,'enUS','','May the Light guide me.',26124),
(119785,'enUS','','See you at SI:7. Good luck, $n.',26124),
(119786,'enUS','We\'ll split up and stealth in. Keep moving. Use the hay bales if you get into trouble.','',26124),
(119787,'enUS','You\'ve succeeded! I\'ve opened up a portal for you to return. Hurry! I can only maintain it for so long.','',26124),
(119788,'enUS','You there! Please help me and listen to what I have to say!','',26124),
(119789,'enUS','Thank you. My communing with nature has brought me back to this location. There is a foulness in the area we must purge.','',26124),
(119790,'enUS','Oh no! Ursoc\'s spirit has once more been captured? Quickly friends, I will help as best I can!','',26124),
(119791,'enUS','Forgive me... We were too weak...','',26124),
(119792,'enUS','What we have done here today... I can only hope it was the right thing. Thank you, friends.','',26124),
(119793,'enUS','HALT. Inspection required.','',26124),
(119794,'enUS','Stand by for screening.','',26124),
(119795,'enUS','Suspicious individual detected.','',26124),
(119796,'enUS','Show your identification. COMPLY.','',26124),
(119797,'enUS','Scanning arcane essence...','',26124),
(119798,'enUS','|TInterface\\Icons\\Spell_Shadow_SoulGem:20|t An |cFFFF0000|Hspell:209489|h[Eye of Gul\'dan]|h|r focuses on you!','',26124),
(119799,'enUS','I\'m really nervous, what if I fall?','I\'m really nervous, what if I fall?',26124),
(119800,'enUS','I can\'t wait to soar amongst the clouds.','I can\'t wait to soar amongst the clouds.',26124),
(119801,'enUS','I\'m not really getting it...','I\'m not really getting it...',26124),
(119802,'enUS','This is the scariest thing we\'ve had to do yet!','This is the scariest thing we\'ve had to do yet!',26124),
(119803,'enUS','I wonder if I\'m going to want to eat worms...','I wonder if I\'m going to want to eat worms...',26124),
(119804,'enUS','Ah, the great outdoors!','Ah, the great outdoors!',26124),
(119805,'enUS','We will make our last stand on your command, champion! Tell me when you are ready.','',26124),
(119806,'enUS','','As you glide, search for currents of warm air to keep yourself aloft. These senses will be new to you, and you will grow accustomed to them with time.',26124),
(119807,'enUS','','Use your tail feathers to steer. You may be unaccustomed to use of this muscle, be sure to practice a bit before you hit a tree!',26124),
(119808,'enUS','','Other birds may take affection to your new form. Be wary of... romantic behaviors.',26124),
(119809,'enUS','','Your beak is for more than just chatting, keep yourself neat and preened or you may end up infested with bugs!',26124),
(119810,'enUS','','Be warned: you will feel the STRONG urge to eat worms. I cannot stress this enough - do not eat worms, you will regret it.',26124),
(119811,'enUS','','When you spread your wings, tilt them away from the incoming drafts of wind to set yourself aloft.',26124),
(119812,'enUS','','It may take a moment to adjust your vision to the new locations of your eyes. It may be best to have a nearby perch handy.',26124),
(119813,'enUS','Where you goin\'? Nowhere!','',26124),
(119814,'enUS','Boom! Never even saw it coming!','',26124),
(119815,'enUS','','We will not let the heretics finish what they started. \n\nOur leader\'s spirit may be lost to the void, but we will keep her body safe until it can be returned.',26124),
(119816,'enUS','','With our leader returned to us, the Forgotten Shadows may rise again.',26124),
(119817,'enUS','Owch, that looked like it hurt.','',26124),
(119818,'enUS','','Azeroth has never before faced the full might of the Burning Legion, but with courage and diligence the Ebon Blade will be victorious.',26124),
(119819,'enUS','Don\'t worry, boss. I\'ll send flowers.','',26124),
(119820,'enUS','Now do your victory pose!','',26124),
(119821,'enUS','Okay, kill the ones in the dresses.','',26124),
(119822,'enUS','Remember, always fight on the roads. Objectives are for suckers.','',26124),
(119823,'enUS','I\'m already carrying a flag! Do we win?','',26124),
(119824,'enUS','Everytime we kill someone, let\'s do a cool pose.','',26124),
(119825,'enUS','Thank you, stranger. The rage... the corruption is gone. Now I must tend to the waters I have neglected for so long.','',26124),
(119826,'enUS','Out of the way! Future gladiator coming through!','',26124),
(119827,'enUS','A pure life essence... I only hope it is enough.','',26124),
(119828,'enUS','[Relieved Sigh] ... Balance is restored. The Arcan\'dor will not fail.','',26124),
(119829,'enUS','','We will carry this burden, Valewalker. Have a little faith.',26124),
(119830,'enUS','Our reinforcements are on approach!','',26124),
(119831,'enUS','Highlord, your saddle is ready to take into battle!','Highlord, your saddle is ready to take into battle!',26124),
(119832,'enUS','','The vile mystics of Haustvald continue to pervert the souls of our fallen warriors. Enter this place that my sisters and I dare not tread and destroy their corrupting dark runes.',26124),
(119833,'enUS','','Thank you, champion. Had the mystics been left to their own devices, those dark runes would have claimed countless other souls of the Valarjar.',26124),
(119834,'enUS','','Welcome to our humble clinic. Are there wounds you need treated or are you here for supplies?',26124),
(119835,'enUS','Work, damn you. Work!','',26124),
(119836,'enUS','We\'ve done it! The Legion will surely falter at such power.','',26124),
(119837,'enUS','I left the City to find my daughter. She was one of those who dared speak against Elisande...','',26124),
(119838,'enUS','She is gone. I thought I would join her in the ruins as a mindless husk, but you...','',26124),
(119839,'enUS','You saved me.','',26124),
(119840,'enUS','I will seek shelter now. I hope we meet again, friend.','',26124),
(119841,'enUS','Horsemen, our unholy fate awaits us! We will leave for Acherus at once.','',26124),
(119842,'enUS','General Tel\'arn... one of the great heroes of the War of the Ancients. He has been returned to life, but his sorrow at his failure has driven him mad. Grant him an eternal rest.','',26124),
(119843,'enUS','Well done. I feel no joy from this, but it was necessary.','',26124),
(119844,'enUS','Some of nature\'s creations cannot be suffered to live. The Ancient Widow that has taken residence in Black Rook Hold numbers among them. Slay it!','',26124),
(119845,'enUS','What a horrible creature. I shudder even thinking of it.','',26124),
(119846,'enUS','In our people\'s more foolhardy days, we experimented freely with the Arcane. Galeorn was brilliant, but the foul magic at work here has rendered him mad. He must be stopped.','',26124),
(119847,'enUS','His power had to be contained. You have done well.','',26124),
(119848,'enUS','Braxas is a Legion commander so vile even the other demons fear him. Reports are he slaughters any demons who are too weak to earn his respect. End him in the defense of Azeroth!','',26124),
(119849,'enUS','A foul, foul creature. You have done well.','',26124),
(119850,'enUS','|TInterface\\Icons\\inv_misc_trinket6oih_orb4:20|t An |cFFFF0000|Hspell:211152|h[Empowered Eye of Gul\'dan]|h|r focuses on you!','',26124),
(119851,'enUS','My creations will be the death of you!','',26124),
(119852,'enUS','Arise, and destroy this intruder!','',26124),
(119853,'enUS','Very well. I shall deal with you myself.','',26124),
(119854,'enUS','Go away.','',26124),
(119855,'enUS','The demons are taking over this island, you may want to leave.','The demons are taking over this island, you may want to leave.',26124),
(119856,'enUS','Heh. You think me a foolish old orc, frail and ready to be put to the wolves? \n\nI was communing with demons when you were in swaddling blankets.','',26124),
(119857,'enUS','You must know much. Will you help us defeat them?','You must know much. Will you help us defeat them?',26124),
(119858,'enUS','They are not your enemy, fool.\n\nNow go away.','',26124),
(119859,'enUS','What is going on up there? Is someone fighting?','',26124),
(119860,'enUS','','They\'re upstairs, $n!',26124),
(119861,'enUS','This way! We have to stop Rakeesh and save O\'ros!','',26124),
(119862,'enUS','What\'s the meaning of this, $n? I thought we were all on the same side!','',26124),
(119863,'enUS','Light damn him!','',26124),
(119864,'enUS','I\'m the real Mathias Shaw.','',26124),
(119865,'enUS','No, I am! Kill him, $n!','',26124),
(119866,'enUS','Enough! I need more room.','',26124),
(119867,'enUS','Yo! I got a real special item today for you!','',26124),
(119868,'enUS','Your Alliance and Horde are destined to destroy each other...','',26124),
(119869,'enUS','','I agree. They will not suspect our united force. We will have the upper hand.',26124),
(119870,'enUS','Long have we searched for you, Prophet Velen. Here, you thought yourself safe from the Legion\'s gaze.','',26124),
(119871,'enUS','Now, finally, your SOUL IS MINE!','',26124),
(119872,'enUS','Balnazzar, your arrogance is mighty. But Azeroth\'s heroes will stand against you!','',26124),
(119874,'enUS','Paladins of the Silver Hand, rally to the Highlord! Attack!','',26124),
(119875,'enUS','What is this? The Order of the Silver Hand? Little matter. I will still destroy you!','',26124),
(119876,'enUS','Impressive, hero. Let us see how you do without your allies!','',26124),
(119877,'enUS','You are alone, heroes. No one is coming to help you!','',26124),
(119878,'enUS','Enough! I tire of this game.','',26124),
(119879,'enUS','Now, taste the TRUE might, of THE BURNING LEGION!!!','',26124),
(119880,'enUS','Hold your ground! They won\'t take us down without a fight!','',26124),
(119881,'enUS','','There are too many!',26124),
(119882,'enUS','','It is no use! The prophet\'s vision has come to pass...',26124),
(119884,'enUS','Where is your Light now, heroes?','',26124),
(119885,'enUS','','I was so certain he was dead...',26124),
(119886,'enUS','','Noressa quickly glances over the letter.',26124),
(119887,'enUS','','Oh, Absolon...',26124),
(119888,'enUS','Allies, do not despair. It is I, Lothraxion, High Commander of the Grand Army of the Light.','',26124),
(119889,'enUS','On order of High Exarch Turalyon, we came as fast as we could. I am sending reinforcements down to join you.','',26124),
(119890,'enUS','Heroes, rally beneath the Light! Balnazzar, prepare to meet your end.','',26124),
(119891,'enUS','','Thank you. I will hold his words in my heart.',26124),
(119892,'enUS','No! I will NEVER be defeated!','',26124),
(119893,'enUS','Die in the fire of a thousand suns!','',26124),
(119894,'enUS','I will see your world burn to ash!','',26124),
(119895,'enUS','Nooooooo!','',26124),
(119896,'enUS','','We did it. The dreadlord is dead.',26124),
(119897,'enUS','Thank you, paladins of the Silver Hand.','',26124),
(119898,'enUS','Knights of the Silver Hand! Today, we have achieved a great victory!','',26124),
(119899,'enUS','We turned back the Burning Legion, protecting our allies and destroying our enemies!','',26124),
(119900,'enUS','We proved that when our wills were tested, we stood strong!','',26124),
(119901,'enUS','Under our Highlord\'s leadership, we fought to the brink of oblivion... and triumphed.','',26124),
(119902,'enUS','To the Highlord, and the Silver Hand!','',26124),
(119903,'enUS','','Perhaps, but not any time soon, demon.',26124),
(119904,'enUS','It\'s over. Speak with me when you\'re ready, $n. I\'ll get us safely out of Stormwind.','',26124),
(119905,'enUS','I cannot begin to thank you for all that you have done, $n. You\'ve given me back SI:7 and saved the Alliance and Horde from a costly war we could have ill afford.\n\nThe Burning Legion would have destroyed us all.\n\nIt goes without saying, if there\'s anything I can do for you, just let me know.\n\nAre you ready to get back to Dalaran and the Hall of Shadows?','',26124),
(119906,'enUS','I\'m ready. Let\'s get out of here, Mathias.','I\'m ready. Let\'s get out of here, Mathias.',26124),
(119907,'enUS','You already knew everything on that scroll. You\'re so smart!','You already knew everything on that scroll. You\'re so smart!',26124),
(119908,'enUS','','Let us celebrate the one who made all of this possible, our newest Shadowblade, $n!',26124),
(119909,'enUS','','Detheroc is dead and Mathias Shaw is restored to his role as leader of SI:7.',26124),
(119910,'enUS','','All-out war between the Alliance and Horde has been averted. We can now focus our full attention upon the Burning Legion.',26124),
(119911,'enUS','','We will destroy them by every means possible. Through treachery and subterfuge. Through guile and assassination. And yes, by laying down our lives if needs be.',26124),
(119912,'enUS','Drive the Witherbark tribe from my kingdom, and I will grant you access to the tomb of my father.','',26124),
(119913,'enUS','Bonespeakers disturb the bones of our eldest kings. The honored dead have earned their rest. Stop these betrayers.','',26124),
(119914,'enUS','Carefully Grabbing','Carefully Grabbing',26124),
(119915,'enUS','The dead who lay at Shield\'s Rest have been undisturbed since before my time. You have done my people a great service this day.','',26124),
(119916,'enUS','The Helarjar are defiling the tombs of Shield\'s Rest. Drive them back!','',26124),
(119917,'enUS','Shield\'s Rest is where the most ancient Kings of Stormheim and their honored fallen were buried. Back before the Tideskorn were afraid of the sea.','',26124),
(119918,'enUS','Don\'t squeeze the shaman.','',26124),
(119919,'enUS','Vile worm! You serve as lapdog to my brother!','',26124),
(119920,'enUS','Skovald will pay for his treachery.','',26124),
(119921,'enUS','Do you recognize this relic?','Do you recognize this relic?',26124),
(119922,'enUS','I was the eldest, I was to be king. Not that runt Skovald!','',26124),
(119923,'enUS','Where did you find that? It has been many years...\n\n<Drak\'thul turns the relic over in his palm, and then hands it back to you.>\n\nThe ghosts have long since stopped their whispers. There was silence, for a while.\n\nThen they began again. Different, deeper, darker.','',26124),
(119924,'enUS','Locked away within the core is wisdom... knowledge crucial to our battle against the Burning Legion.','',26124),
(119925,'enUS','Yet only a naaru born of Xe\'ra is capable of unlocking the core. This is why you were sent here, $p.','',26124),
(119926,'enUS','O\'ros, child of Xe\'ra, and heart of the Exodar, is the only being in all of the cosmos that could decipher the message locked away within Light\'s Heart.','',26124),
(119927,'enUS','But the only way to know what secrets lie within Light\'s Heart is through her progeny. Which is why you were directed to bring the core to me.','',26124),
(119928,'enUS','And this is the true purpose of the Burning Legion\'s invasion of the Exodar.','',26124),
(119929,'enUS','Tell me of these whispers.','Tell me of these whispers.',26124),
(119930,'enUS','The last of Xe\'ra\'s line, O\'ros, sits unguarded in the heart of the Exodar. If they destroy O\'ros, the information within Light\'s Heart will be lost forever.','',26124),
(119932,'enUS','They do not come when I beckon, fool.','',26124),
(119933,'enUS','<Drak\'thul\'s eyes are sunken and unfocused. He has his head cocked slightly, as if listening to something you cannot hear.>','',26124),
(119934,'enUS','Drak\'thul?','Drak\'thul?',26124),
(119935,'enUS','Athu\'gag magg\'naggwa.\n\nQor\'naus\'agth lwhuk.\n\nLilth gag\'huqth\'hoq.','',26124),
(119936,'enUS','','I fled Val\'Sharah during Ysera\'s attack on the temple. I was lucky enough to find Mythandros on the road.',26124),
(119937,'enUS','We came from a village just outside Shala\'nir. It was a narrow escape, I will admit.','',26124),
(119938,'enUS','You are yourself again. What happened?','You are yourself again. What happened?',26124),
(119940,'enUS','','The Nightmare followed us wherever we went. It was not until we crossed into Suramar that we escaped it.',26124),
(119941,'enUS','The whispers called to you.\n\n<Drak\'thul sighs heavily, for a moment appearing very old and frail.>\n\nI have learned many things on my years on these islands. I have delved into places I wish I had not, and learned things I long to forget.\n\nAnd now I wish to be alone, until darkness overtakes me at last.\n\nGo away.','',26124),
(119942,'enUS','','There were more of us when we set out. I would have died, if it were not for Mayruna\'s arrival.',26124),
(119943,'enUS','We owe our lives to Mythandros and his druid companions. We can call Suramar home, thanks to him.','',26124),
(119944,'enUS','Thank you for your help, stranger. It means more than you know.','',26124),
(119945,'enUS','The greatest heroes on Azeroth have gathered to face the Burning Legion.','',26124),
(119946,'enUS','But heroes alone will not save this world. Salvation will come at a price the living cannot pay.','',26124),
(119947,'enUS','The time of the Four Horsemen has come... and you will bring about their return.','',26124),
(119948,'enUS','Nazgrim, the fallen general of the Horde, shall be the firstborn. Go now and see that it is done.','',26124),
(119949,'enUS','The time of the second horseman has come, Deathlord.','',26124),
(119950,'enUS','Upon the cliffs of Arathor, stands the fallen kingdom of Stromgarde.','',26124),
(119951,'enUS','It is there that you will find the tomb of Thoras Trollbane, the great warrior king.','',26124),
(119952,'enUS','His strength in battle was without rival, and he shall be even more powerful in undeath.','',26124),
(119954,'enUS','Step right up and challenge our reigning tournament champion! Winners will receive a handsome prize! Legal disclaimer: Prizes not always handsome.','',26124),
(119955,'enUS','Well done! Keep it up kid, you\'re going places... and making me a pile of gold in the process!','',26124),
(119956,'enUS','What is it, $c?','',26124),
(119957,'enUS','You\'ve an ill wind about you, priest.','',26124),
(119958,'enUS','High Inquisitor Whitemane was a priest whose personal tragedy forged an intense connection with the Light.','',26124),
(119959,'enUS','Have you considered Loken\'s final words to you?','Have you considered Loken\'s final words to you?',26124),
(119960,'enUS','Her zealous power of will is necessary to strengthen the bond of the Four.','',26124),
(119961,'enUS','Travel to the Scarlet Monastery and raise the High Inquisitor from her tomb inside the Cathedral.','',26124),
(119962,'enUS','There must be one among the Four Horsemen with the power to lead.','',26124),
(119963,'enUS','Without a leader, there will be no unity among the Four.','',26124),
(119964,'enUS','The time has come for the Ebon Blade to return to Light\'s Hope.','',26124),
(119965,'enUS','The body of the great Tirion Fordring rests beneath the chapel.','',26124),
(119966,'enUS','Go now, and do what must be done.','',26124),
(119967,'enUS','For a short time only, the Tournament is featuring one of the legendary creatures of Azeroth. Test your mettle while you can!','',26124),
(119968,'enUS','Easy, now... easy! Leave something for the other competitors, will yah?','',26124),
(119969,'enUS','First my dozer breaks down, then those things come crashin\' down... I\'ll never get anything done around here!','',26124),
(119970,'enUS','Oh ho! You\'ve discovered one of the tournament\'s traveling trainers! Another opportunity to show your skills and make me some gold!','',26124),
(119971,'enUS','They say it\'s not strictly \"legal\" for me to bet on tournament matches. But what they don\'t know won\'t hurt \'em!','',26124),
(119972,'enUS','The court and its allies are in need of assistance. Perhaps your friends can help.','',26124),
(119973,'enUS','Well done! I speak for the court and its allies when I say, \"Thank you, hero.\"','',26124),
(119974,'enUS','Something threatens the creatures of Val\'Sharah. Perhaps you can direct your companions to be of aid.','',26124),
(119975,'enUS','The Nightmare still infests the forests of Val\'Sharah, but you and your companions have helped preserve it.','',26124),
(119976,'enUS','','Our lands must be protected. I hope you have readied your companions!',26124),
(119977,'enUS','','Thank you. We must remain vigilant in our defenses.',26124),
(119978,'enUS','','The time has come to test you and your companions. Are you worthy of the Valarjar\'s favor?',26124),
(119979,'enUS','','You show great promise.',26124),
(119980,'enUS','','There are many ways to help the Nightfallen. Your companions can be of use as well.',26124),
(119981,'enUS','','Your efforts help ensure that the Nightfallen have a future.',26124),
(119982,'enUS','Marin, I found this coin that has your name on it.','Marin, I found this coin that has your name on it.',26124),
(119983,'enUS','You scratch my back I scratch yours! Grab another item from the vault, $n.','',26124),
(119985,'enUS','Darion Mograine has sacrificed more for the Ebon Blade than any other.','',26124),
(119986,'enUS','His body lays before you, broken. Scarred.','',26124),
(119987,'enUS','But death is for the living, it has no power over the damned.','',26124),
(119988,'enUS','Your Fourth Horseman lays before you, Deathlord. Command him to rise.','',26124),
(119989,'enUS','Redhoof peers at Mythandros expectantly.','',26124),
(119990,'enUS','Oh my, a rare bloom indeed.','',26124),
(119991,'enUS','Thank you, noble Redhoof. We accept your blessing and give our thanks.','',26124),
(119992,'enUS','When you are facing multiple foes, Divine Storm is an excellent ability to rely on.','',26124),
(119993,'enUS','When used, all enemies near you will be hit by a storm of holy energy.','',26124),
(119994,'enUS','Divine Storm requires three Holy Power to cast.','',26124),
(119995,'enUS','','Divine Storm requires three Holy Power to cast.',26124),
(119996,'enUS','','When used, all enemies near you will be hit by a storm of holy energy.',26124),
(119997,'enUS','','When you are facing multiple foes, Divine Storm is an excellent ability to rely on.',26124),
(119998,'enUS','Use Divine Storm!','',26124),
(119999,'enUS','','Use Divine Storm!',26124),
(120000,'enUS','','For the Horde!',26124),
(120001,'enUS','Very well. You may remain as a guest until your business with the commander is complete.','',26124),
(120002,'enUS','','I will bring the blessing to Mythandros directly. See you there!',26124),
(120003,'enUS','Your pet has died!. Use Revive Pet to bring it back to life.','',26124),
(120004,'enUS','','Your pet has died!. Use Revive Pet to bring it back to life.',26124),
(120005,'enUS','What... was that!?','What... was that!?',26124),
(120006,'enUS','That thing... I have to get out of here!','That thing... I have to get out of here!',26124),
(120007,'enUS','What is happening?','What is happening?',26124),
(120008,'enUS','Who... who are you?','Who... who are you?',26124),
(120009,'enUS','Where am I? What happened?','Where am I? What happened?',26124),
(120010,'enUS','That feeling. I can\'t explain it!','That feeling. I can\'t explain it!',26124),
(120011,'enUS','Get far away from here! Go!','Get far away from here! Go!',26124),
(120012,'enUS','','Vanish allows you to disengage from combat and make a quick getaway.',26124),
(120013,'enUS','Vanish allows you to disengage from combat and make a quick getaway.','',26124),
(120014,'enUS','','This attack costs more resources, but deals more damage as well. Thankfully, your melee attacks have a chance to trigger Stormbringer, decreasing the cost.',26124),
(120015,'enUS','This attack costs more resources, but deals more damage as well. Thankfully, your melee attacks have a chance to trigger Stormbringer, decreasing the cost.','',26124),
(120016,'enUS','This moonwell will nourish and protect everything around it. We can finally call this place home.','',26124),
(120017,'enUS','On the peaks of Shield\'s Rest you will find the Skysunders. These drakes are powerful, ancient, and mad. Gather your allies, hero, and put one of these beasts down for its own sake.','',26124),
(120018,'enUS','The Skysunders were once storm drakes of great honor, charged with the protection of Shield\'s Rest. Now they have fallen into the madness of Helya\'s dark magics.','',26124),
(120019,'enUS','This research has been quite fascinating! I\'ve begun inscribing the translated history in the tome over here.','This research has been quite fascinating! I\'ve begun inscribing the translated history in the tome over here.',26124),
(120020,'enUS','If you\'re interested in reading some of the translated history of your weapon, I just added an entry in the tome.','If you\'re interested in reading some of the translated history of your weapon, I just added an entry in the tome.',26124),
(120021,'enUS','I\'ll keep adding to it as our research continues. It\'s worth taking a look if you have some time.','I\'ll keep adding to it as our research continues. It\'s worth taking a look if you have some time.',26124),
(120022,'enUS','I added some more of your weapon\'s history to the tome. You should take a look when time permits.','I added some more of your weapon\'s history to the tome. You should take a look when time permits.',26124),
(120023,'enUS','Some fascinating history turned up on your weapon. I added it to the tome if you want to give it a read.','Some fascinating history turned up on your weapon. I added it to the tome if you want to give it a read.',26124),
(120024,'enUS','This weapon of yours has proven to have had quite the colorful past. I added some new translations to the tome if you\'re interested.','This weapon of yours has proven to have had quite the colorful past. I added some new translations to the tome if you\'re interested.',26124),
(120025,'enUS','I\'ve scribed some more history on your weapon if you\'d like to take a look.','I\'ve scribed some more history on your weapon if you\'d like to take a look.',26124),
(120026,'enUS','I\'ve added another part to the tome on your weapon\'s history. It\'ll be a good read if you have a minute or two.','I\'ve added another part to the tome on your weapon\'s history. It\'ll be a good read if you have a minute or two.',26124),
(120027,'enUS','Well, that\'s it, $n. After weeks of research, I think we\'ve exhausted every scrap of history we could find about your weapon.','Well, that\'s it, $n. After weeks of research, I think we\'ve exhausted every scrap of history we could find about your weapon.',26124),
(120028,'enUS','Thank you for dedicating so many resources to these efforts. I hope what we\'ve learned about your weapon has proved useful.','Thank you for dedicating so many resources to these efforts. I hope what we\'ve learned about your weapon has proved useful.',26124),
(120029,'enUS','I just added the final chapter to our book. You should definitely give it a read.','I just added the final chapter to our book. You should definitely give it a read.',26124),
(120030,'enUS','','You fools. Did you really think the Light would allow this?',26124),
(120031,'enUS','','The Lich King himself had no power here!',26124),
(120032,'enUS','','The Light protects this chapel, Darion. Darkness cannot abide within the Light!',26124),
(120033,'enUS','','Darion!',26124),
(120034,'enUS','The Four Horsemen... I have my reservations, but I will obey your will, Deathlord.','',26124),
(120035,'enUS','The Horde will be outraged, but Nazgrim will make a powerful Death Knight.','',26124),
(120037,'enUS','Thoras Trollbane was one of the greatest kings this world has known. The Alliance will not be pleased.','',26124),
(120038,'enUS','Nevertheless, your will be done, Deathlord. The Ebon Blade will be honored to bring King Thoras into our fold.','',26124),
(120040,'enUS','There are few in this world who have lived with more conviction than High Inquisitor Whitemane.','',26124),
(120041,'enUS','Death has a way of quelling the madness of the mind... I am sure she will serve the Ebon Blade without compromise.','',26124),
(120042,'enUS','Tirion Fordring was one of the greatest champions this world has known!','',26124),
(120043,'enUS','If we do this... there will be a price to pay.','',26124),
(120044,'enUS','I will obey, Deathlord. But know this...','',26124),
(120046,'enUS','Should we go through with this, there will be no turning back.','',26124),
(120048,'enUS','','You must wait a few moments before entering the battle again, Valarjar.',26124),
(120049,'enUS','You\'ll never take me while I still draw breath!','You\'ll never take me while I still draw breath!',26124),
(120050,'enUS','Someone help!','Someone help!',26124),
(120051,'enUS','I thank you for ceasing the whispers, the endless hungering cries of the void are now yours to bear.','',26124),
(120052,'enUS','I will guide us to the heart of the vessel. Stay within my protective barrier as I cleanse the fel taint from the pathway.','',26124),
(120053,'enUS','Keep moving.','Keep moving.',26124),
(120054,'enUS','Many thanks. We must keep moving.','Many thanks. We must keep moving.',26124),
(120055,'enUS','The lands are overrun! We must stop them!','The lands are overrun! We must stop them!',26124),
(120056,'enUS','You\'re quite the $c, aren\'t you? My thanks.','You\'re quite the $c, aren\'t you? My thanks.',26124),
(120057,'enUS','Move! As fast as you can! Go!','Move! As fast as you can! Go!',26124),
(120058,'enUS','Others have been captured. I\'ve seen it. They\'re everywhere!','Others have been captured. I\'ve seen it. They\'re everywhere!',26124),
(120059,'enUS','','Priest! Over here!',26124),
(120060,'enUS','Sound effect for troops','',26124),
(120061,'enUS','The mistress\' belongs will not be disturbed.','The mistress\' belongs will not be disturbed.',26124),
(120062,'enUS','Sound effect for troops','',26124),
(120063,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120064,'enUS','Sound effect for troops','',26124),
(120065,'enUS','Sound effect for troops','',26124),
(120066,'enUS','Sound effect for troops','',26124),
(120067,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120068,'enUS','Sound effect for troops','',26124),
(120069,'enUS','','Sound effect for troops',26124),
(120070,'enUS','','Sound effect for troops',26124),
(120071,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120072,'enUS','Sound effect for troops','',26124),
(120073,'enUS','Please... I haven\'t fed for weeks...','',26124),
(120074,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120075,'enUS','Mana... I need... mana.','',26124),
(120076,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120077,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120078,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120079,'enUS','Sound effect for troops','',26124),
(120080,'enUS','Sound effect for troops','',26124),
(120081,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120082,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120083,'enUS','Sound effect for troops','',26124),
(120084,'enUS','Sound effect for troops','',26124),
(120085,'enUS','Sound effect for troops','',26124),
(120086,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120087,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120088,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120089,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120090,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120091,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120092,'enUS','I\'ll see you soon.','',26124),
(120093,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120094,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120095,'enUS','Sound effect for troops','',26124),
(120096,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120097,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120098,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120099,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120100,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120101,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120102,'enUS','Kelorn Nightblade... the scum that murdered Lord Ravencrest for the Legion during the War of the Ancients! The Legion has returned him to life. Give him the second death he deserves!','',26124),
(120103,'enUS','He deserves a hundred more deaths for his treason. Good work.','',26124),
(120104,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120105,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120106,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120107,'enUS','Sound effect for troops','',26124),
(120108,'enUS','Sound effect for troops','',26124),
(120109,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120110,'enUS','Sound effect for troops','Sound effect for troops',26124),
(120111,'enUS','Sound effect for troops','',26124),
(120112,'enUS','Sound effect for troops','',26124),
(120113,'enUS','Sound effect for troops','',26124),
(120114,'enUS','','I will join my fallen brothers and sisters. Goodbye, Lyrea.',26124),
(120115,'enUS','Sound effect for troops','',26124),
(120116,'enUS','Sound effect for troops','',26124),
(120117,'enUS','Sound effect for troops','',26124),
(120118,'enUS','Sound effect for troops','',26124),
(120119,'enUS','Sound effect for troops','',26124),
(120120,'enUS','Sound effect for troops','',26124),
(120121,'enUS','','Sound effect for troops',26124),
(120122,'enUS','','Sound effect for troops',26124),
(120123,'enUS','A victor has emerged from the crowd! The battle for the chest of riches is over!','',26124),
(120124,'enUS','','You should head back to the portal. The High Priest and I will take care of the rest.',26124),
(120125,'enUS','Thank you, Ashildir. We certainly do.','',26124),
(120126,'enUS','<Give Arcanist Ke\'lorin 50 Ancient Mana.>','<Give Arcanist Ke\'lorin 50 Ancient Mana.>',26124),
(120127,'enUS','Thank you... be safe.','',26124),
(120128,'enUS','I... was close to withering. Come close, and receive my magic. It will ward you from whatever would do you harm.','',26124),
(120129,'enUS','A great enemy is defeated this day. We have shown the Legion that Azeroth will not fall quietly.','',26124),
(120130,'enUS','Prophet Velen, warriors of light, a well earned victory. I expected nothing less from the heroes of Azeroth.','',26124),
(120131,'enUS','Even the slayer of Archimonde has accepted this world\'s fate! Come closer, then.','',26124),
(120132,'enUS','','You are a monster, Darion!',26124),
(120133,'enUS','Let us begin. Take up the scepter and try not to kill yourself with it. It has proven... challenging to control.','',26124),
(120134,'enUS','Without monsters there can be no heroes.','',26124),
(120135,'enUS','','Now, now, play nice.',26124),
(120136,'enUS','','Don\'t put that in your mouth. You don\'t know where its been. Oh, now don\'t put it in HIS mouth!',26124),
(120137,'enUS','','Who wants a nap? ...I do.',26124),
(120138,'enUS','','This is called, \"wine.\" Ms. Liddie needs it to get through the day!',26124),
(120139,'enUS','','Make sure to eat all of your pet treats if you want to grow up to be big and level twenty-five.',26124),
(120140,'enUS','','If your all very well behaved today, I will read your favorite story, \"Murky\'s Great Adventure.\"',26124),
(120141,'enUS','','Time for arts and crafts! Wait, who ate all the paste? And the glitter? Lets call your owner before that becomes a problem.',26124),
(120142,'enUS','Be mindful, traveler. These lands are no longer safe.','',26124),
(120143,'enUS','Champions! Riches await you in the Arena of Glory!  Fight for honor and riches!','',26124),
(120144,'enUS','Valarjar! Victory or Death awaits you in the Arena of Glory! Prove yourself in combat!','',26124),
(120145,'enUS','Even in a lifetime of war, I have never before seen such sacrifice.','',26124),
(120146,'enUS','','The Light has ravaged his body. There is nothing we can do for him.',26124),
(120147,'enUS','Highlord!','',26124),
(120148,'enUS','Knights of the Silver Hand! Today, we achieved a great victory!','',26124),
(120149,'enUS','We turned back the Burning Legion, protected our allies and destroyed our enemies!','',26124),
(120150,'enUS','When our wills were tested, we stood strong!','',26124),
(120151,'enUS','Under our Highlord\'s leadership, we fought to the brink of oblivion... and triumphed.','',26124),
(120152,'enUS','To the Highlord, and the Order of the Silver Hand!','',26124),
(120153,'enUS','','You\'re too late! Krosus will be your end!',26124),
(120154,'enUS','I will be today\'s champion! FOR ODYN!','',26124),
(120155,'enUS','Your enemies have sent reinforcements from the sea. Show my ocean fearing children how to properly sink such a vessel.','',26124),
(120156,'enUS','BRAWLHALLA!!','',26124),
(120157,'enUS','%s dusts off his clothing.','',26124),
(120158,'enUS','Are you sure you want to leave? You should stay and finish the drill, $r.','Are you sure you want to leave? You should stay and finish the drill, $r.',26124),
(120159,'enUS','I\'d like to leave the rumble.','I\'d like to leave the rumble.',26124),
(120160,'enUS','The enemy is among us!','',26124),
(120161,'enUS','You discovered us too late, Illidari! FELBLADE, ATTACK!','You discovered us too late, Illidari! FELBLADE, ATTACK!',26124),
(120162,'enUS','Portals opening! Here they come!','',26124),
(120163,'enUS','The fuse is lit. RUN!','',26124),
(120164,'enUS','I\'m all dressed. Where\'s the party?','I\'m all dressed. Where\'s the party?',26124),
(120165,'enUS','Are you sure you want to go to the party? It is probably very far away.','Are you sure you want to go to the party? It is probably very far away.',26124),
(120166,'enUS','The barracuda are really jumping today! It\'s far too dangerous to fish right now.$b$bJust kidding! Here\'s a long pointy stick and some explosive shoes. Go and get those fish, buddy!','',26124),
(120167,'enUS','The barracuda are really jumping today!','',26124),
(120168,'enUS','Sounds good to me. Let\'s do this!','Sounds good to me. Let\'s do this!',26124),
(120169,'enUS','Haustvald is a sacred place that is currently being defiled by pesky ravens. Filthy creatures and so foul mouthed. Would you make use of that body of yours and a grappling hook and remove some of those nests?','',26124),
(120170,'enUS','Ravens can be so rude sometimes. I am sure you heard all of the uncouth things they were saying about you and your lineage. Thank you for removing their nests.','',26124),
(120171,'enUS','INSERT COORDINATES','',26124),
(120172,'enUS','Azsuna','Azsuna',26124),
(120173,'enUS','Val\'sharah','Val\'sharah',26124),
(120174,'enUS','Highmountain','Highmountain',26124),
(120175,'enUS','Stormheim','Stormheim',26124),
(120176,'enUS','Suramar','Suramar',26124),
(120178,'enUS','Then let the council debate.','Then let the council debate.',26124),
(120179,'enUS','...','',26124),
(120180,'enUS','I have failed Odyn this time, but I will return to fight again!','',26124),
(120181,'enUS','','Now go. Return once you have proven your worth.',26124),
(120182,'enUS','','We have a tough decision before us. Do we aid the priests in their battle against Balnazzar, or do we decline and wait to fight the dreadlord on our own terms?',26124),
(120183,'enUS','Their temple is located deep in Legion territory. We would be putting ourselves at great risk.','',26124),
(120184,'enUS','Did you think I wouldn\'t see what you truly are, demon?','',26124),
(120185,'enUS','True, but if we are to believe what Lothraxion has said, this could be our only chance to slay Balnazzar.','',26124),
(120186,'enUS','You would trust a dreadlord?','',26124),
(120187,'enUS','I sensed no ill within him, only kinship. I know not what he is, but I believe him.','',26124),
(120188,'enUS','','I agree with Arator, Boros. I felt great purity within the creature.',26124),
(120189,'enUS','It will be dangerous, but we may never get such a chance again. It may be the only way.','',26124),
(120190,'enUS','','If I may - Balnazzar will not suspect a united force. The Conclave and the Order of the Silver Hand, fighting together.',26124),
(120191,'enUS','','It is decided, then.',26124),
(120196,'enUS','','I\'ve been expecting you, $n.\n\nDelas has informed the council of Balnazzar\'s plan to attack Netherlight Temple. The question becomes, what role will the paladins play in this battle, if any? We risk a great deal if we choose to aid the Conclave.\n\nThis is not a decision to be made lightly. The council must discuss how to proceed.',26124),
(120198,'enUS','I detected a strange signal coming from this place.','',26124),
(120199,'enUS','','It is Nightborne magic... but it called to us.',26124),
(120200,'enUS','Come. I see an opening in the rock.','',26124),
(120201,'enUS','We have made it in time! By the grace and glory of the Light, I will heal O\'ros. Then we will deal with Rakeesh.','',26124),
(120202,'enUS','You have lost, Rakeesh! O\'ros is renewed and now you must answer for the atrocities you have committed!','',26124),
(120203,'enUS','','Good choice, just don\'t call me \'champion\'. Ever.',26124),
(120204,'enUS','|TInterface\\Icons\\spell_nature_web.blp:20|t You become entangled in the |cFFF00000|Hspell:215288|h[Web of Pain]|h|r.','|TInterface\\Icons\\spell_nature_web.blp:20|t You become entangled in the |cFFF00000|Hspell:215288|h[Web of Pain]|h|r.',26124),
(120205,'enUS','What you need Lurr make?','What you need Lurr make?',26124),
(120206,'enUS','I will begin the ritual when you are ready.','',26124),
(120207,'enUS','Begin the ritual.','Begin the ritual.',26124),
(120208,'enUS','Ah, the fated heroes have arrived. It would appear that you have bested me, Velen.','',26124),
(120209,'enUS','Can you know victory without first knowing defeat? Come. Fail. Die.','',26124),
(120210,'enUS','Turn back now. The ghostship cannot leave these waters.','',26124),
(120211,'enUS','But before I surrender and face the judgment of the Light, there is one last thing I must do.','',26124),
(120212,'enUS','We will ensure no harm comes to the king.','',26124),
(120213,'enUS','','May Elune light your path, champion.',26124),
(120214,'enUS','My people will be on the hunt for ways to help!','',26124),
(120215,'enUS','Ahh! They coming! RUN!','',26124),
(120216,'enUS','Ha! We\'ll get \'em wit\' these big rocks!','',26124),
(120217,'enUS','Ok! We definitely got \'em this time!','',26124),
(120218,'enUS','AHHH! WE SORRY! WE PROMISE!','',26124),
(120219,'enUS','','Be careful, boss. Outland\'s a pretty dangerous place, an\' Shattrath\'s not that much better.',26124),
(120220,'enUS','Da sword! It be too much!','Da sword! It be too much!',26124),
(120221,'enUS','','Watch your back, and your pockets.',26124),
(120222,'enUS','No... no!','No... no!',26124),
(120223,'enUS','I smell da blood of my people!','I smell da blood of my people!',26124),
(120224,'enUS','My ancestors scream!','My ancestors scream!',26124),
(120225,'enUS','Surrounded by ghosts!','Surrounded by ghosts!',26124),
(120226,'enUS','','It went quickly this time, but in the future, it will take longer.',26124),
(120227,'enUS','Valormok is under attack! We\'re being bombarded by infernals!','',26124),
(120228,'enUS','I don\'t mean to alarm anybody, but one large, very ugly demon just landed at our camp along the shore! We\'re holding \'em off, but we\'re gonna need some help out here!','',26124),
(120229,'enUS','','Just north of the Rocketway! A gigantic, mechanical hunk of metal just landed. What the heck is that thing?',26124),
(120230,'enUS','The Legion continues their assault! Another demon approaches the gates!','',26124),
(120231,'enUS','I swear it! The staff came to life! I must discover how it works!','',26124),
(120232,'enUS','Only a few more sheep! I\'m so close to unlocking the mysteries of this artifact!','',26124),
(120233,'enUS','Nonsense! Don\'t believe this maniac!','',26124),
(120234,'enUS','Shut up, peasant!','',26124),
(120235,'enUS','You\'ve lost your mind, Shepherd!','',26124),
(120236,'enUS','Keep your fantasies to yourself! You are no longer welcome here!','',26124),
(120237,'enUS','He turned my family into sheep!','',26124),
(120238,'enUS','He did! That dead sheep was my cousin Johnny!','',26124),
(120239,'enUS','What is it? Make it quick! I have more experimentation to perform.\n\nNO YOU CAN\'T TOUCH IT!','',26124),
(120240,'enUS','Do you hear something? Is that... bleating?','Do you hear something? Is that... bleating?',26124),
(120241,'enUS','|TInterface\\Icons\\Sha_Ability_Rogue_EnvelopingShadows_nightmare:20|t%s is casting |cFFFF0000|Hspell:210264|h[Manifest Corruption]|h|r!','',26124),
(120242,'enUS','Oh, sheep!','',26124),
(120243,'enUS','|TInterface\\ICONS\\spell_shaman_earthquake:20|tSea King Tidross is casting |cFFFF0404|Hspell:222482|h[Sea Quake]|h|r Get behind cover!','',26124),
(120244,'enUS','','Who are you, stranger? You are not of the Legion.',26124),
(120245,'enUS','We fight for the same side, warriors of light. Thank you for freeing me.','',26124),
(120246,'enUS','The Legion army will soon attack Netherlight Temple. This sanctuary MUST be protected at all costs.','',26124),
(120247,'enUS','I will bring allies to defend the Temple, but they are far away. I need your help to fight the enemy until we can arrive.','',26124),
(120248,'enUS','There is not enough time to explain everything. I ask that you trust me, and trust in the Light.','',26124),
(120249,'enUS','It is decided, then. The Order of the Silver Hand will stand with the Conclave. We will NOT yield the Temple to the Legion.','',26124),
(120250,'enUS','The Legion continues to bring demons forth from portals at the Gates of Valor. Go, champion, find these portals and call to us. My brood shall come and destroy them.','',26124),
(120251,'enUS','That should help stem the tide of demons. Thank you champion.','',26124),
(120252,'enUS','Well done, $p! You are now prepared to do battle.','',26124),
(120253,'enUS','*O\'ros lets loose a woeful dirge as he is disintegrated*','',26124),
(120254,'enUS','','Well done, $p! You are now prepared to do battle.',26124),
(120256,'enUS','','Just make sure to tell everyone to be real nice to him. Otherwise, we might all wake up dead tomorrow. Ya know what I mean?',26124),
(120257,'enUS','A weapon of legend, that\'s what you hold. I\'ve uncovered some of its history, and have written it here so that all might partake in its glory.','',26124),
(120258,'enUS','I\'ll keep inscribing anything I find here. It\'s worth taking a look if you have some time.','',26124),
(120259,'enUS','This research has been quite fascinating! I\'ve begun inscribing the translated history on the scroll here.','',26124),
(120260,'enUS','I\'ll keep adding to it as our research continues. It\'s worth taking a look if you have some time.','',26124),
(120261,'enUS','','Good luck, boss.',26124),
(120262,'enUS','Where did you come from? Intruder!','Where did you come from? Intruder!',26124),
(120263,'enUS','An excellent choice. I will see to it that it gets done. Good to be working with a professional such as yourself, $n.','',26124),
(120264,'enUS','Curses! Can you pretend you didn\'t see that?','',26124),
(120265,'enUS','','Ah, the hand of the Lich King. What can I do for you?',26124),
(120266,'enUS','The Hand of Illidan. How can I serve, master?','',26124),
(120267,'enUS','','The leaves whisper worries of fel fire and Nightmare, but as long as you stand firm, so will we.\n\nHow can I be of assistance?',26124),
(120268,'enUS','Wisdom is born only from failure. There is little need in fearing the trials that lie ahead of us.','',26124),
(120269,'enUS','','The shadows whisper many secrets, for those brave enough to listen.',26124),
(120270,'enUS','As an unholy death knight you command the powers of disease and death.','',26124),
(120271,'enUS','','As an unholy death knight you command the powers of disease and death.',26124),
(120272,'enUS','As a feral druid your main weapon is shapeshifting. In Cat Form, your claws and fangs rip and bleed your opponents.','',26124),
(120274,'enUS','','The winds whisper of your exploits, and of those that came before. If I know the right questions to ask, we might learn much from them.',26124),
(120275,'enUS','Grim tales, these. I quite like them.','',26124),
(120276,'enUS','As a balance druid the sun, moon, and stars are your allies, enabling you to unleash these primal powers upon your enemies.','',26124),
(120277,'enUS','','As a balance druid the sun, moon, and stars are your allies, enabling you to unleash these primal powers upon your enemies.',26124),
(120278,'enUS','<Sniff.> Thank you...','<Sniff.> Thank you...',26124),
(120279,'enUS','I want to go home!','I want to go home!',26124),
(120280,'enUS','I\'ll be good I promise!','I\'ll be good I promise!',26124),
(120281,'enUS','These tablets tell tale of the grandest battles fought under Odyn\'s sight.\n\nOf late, I\'ve been humbled to learn of the exploits of your races. I had not expected such ferocity and valor from people so small.','',26124),
(120282,'enUS','Mommy where are you??','Mommy where are you??',26124),
(120283,'enUS','Run away!','Run away!',26124),
(120284,'enUS','Beast master hunters possess a deep bond with their pets, calling and bolstering them in battle while striking at foes with ranged attacks.','',26124),
(120285,'enUS','We attack on your mark, $p. Lead the charge!','',26124),
(120286,'enUS','','The winds tell me of many things, recent and ancient. There is a tale to tell with that weapon of yours. I\'ve begun to etch it in the tome over here.',26124),
(120287,'enUS','','I will keep adding to it as I learn more.',26124),
(120288,'enUS','','Beast master hunters possess a deep bond with their pets, calling and bolstering them in battle while striking at foes with ranged attacks.',26124),
(120289,'enUS','I\'ve learned much. Heroes wielded that weapon before it came to rest in your hands. Their tales are well worthy to be carved here for all eternity, that mighty warriors might know of their valor.','',26124),
(120290,'enUS','I will etch more of their stories as I learn of them. These are grand tales that I\'m eager to unfold.','',26124),
(120291,'enUS','As a frost mage you excel at controlling the battlefield by freezing enemies in place as ice and hail pummel them into submission.','',26124),
(120292,'enUS','','As a frost mage you excel at controlling the battlefield by freezing enemies in place as ice and hail pummel them into submission.',26124),
(120293,'enUS','S-so... hungry...','S-so... hungry...',26124),
(120294,'enUS','As a windwalker monk you use your fists and your speed to overcome enemies.','',26124),
(120295,'enUS','','As a windwalker monk you use your fists and your speed to overcome enemies.',26124),
(120296,'enUS','As a retribution paladin you are a stalwart protector of the weak, a bringer of punishment to the unjust!','',26124),
(120297,'enUS','','As a retribution paladin you are a stalwart protector of the weak, a bringer of punishment to the unjust!',26124),
(120298,'enUS','Discipline priests draw upon the opposing forces of Light and Shadow, choosing when to heal and when to inflict damage.','',26124),
(120299,'enUS','Find out what SI:7 is up to, $n. We can ill afford to have unknown variables at this stage of the game.','',26124),
(120300,'enUS','','Discipline priests draw upon the opposing forces of Light and Shadow, choosing when to heal and when to inflict damage.',26124),
(120301,'enUS','As an assassination rogue you specialize in striking from the shadows, dispatching foes with a variety of poisons and bleeding attacks.','',26124),
(120302,'enUS','Sorry we\'re late, $p! I\'m ashamed to admit that we got lost.','Sorry we\'re late, $p! I\'m ashamed to admit that we got lost.',26124),
(120303,'enUS','','As an assassination rogue you specialize in striking from the shadows, dispatching foes with a variety of poisons and bleeding attacks.',26124),
(120304,'enUS','As an elemental shaman you commune with ancient spirits and command primal elemental forces.','',26124),
(120305,'enUS','','As an elemental shaman you commune with ancient spirits and command primal elemental forces.',26124),
(120306,'enUS','As an enhancement shaman you channel the elemental forces directly into your weapons to make yourself a furious melee combatant, beating down your foes with the power of flame, earth, and storm.','',26124),
(120307,'enUS','','As an enhancement shaman you channel the elemental forces directly into your weapons to make yourself a furious melee combatant, beating down your foes with the power of flame, earth, and storm.',26124),
(120308,'enUS','Affliction warlocks use shadow magic and disease to wear down their enemies, then drain their very life essences to empower themselves.','',26124),
(120309,'enUS','','Affliction warlocks use shadow magic and disease to wear down their enemies, then drain their very life essences to empower themselves.',26124),
(120310,'enUS','Arms warriors are the ultimate physical combatants, using martial skill and weaponry to crush those who stand against them.','',26124),
(120311,'enUS','','Arms warriors are the ultimate physical combatants, using martial skill and weaponry to crush those who stand against them.',26124),
(120312,'enUS','Vanthir... Vanthir!','Vanthir... Vanthir!',26124),
(120313,'enUS','Mind is... slipping...','Mind is... slipping...',26124),
(120314,'enUS','They are trying to... kill us...','They are trying to... kill us...',26124),
(120315,'enUS','No escape... so hungry...','No escape... so hungry...',26124),
(120316,'enUS','Smartly now, $g lad:lass;. Old Yancey\'s not goin\' t\' convince himself t\' join our crew.','',26124),
(120317,'enUS','Tell him that if he can\'t convince enough seadogs t\' join up, he should break out th\' belayin\' pin for a good, old press gang.','',26124),
(120318,'enUS','','We should return to Light\'s Hope, Highlord. The council needs to hear this.',26124),
(120319,'enUS','Highlord, let us return to your order hall. We have much to discuss.','',26124),
(120320,'enUS','Hey Boss. Need anything?','',26124),
(120321,'enUS','I\'ve written more of your weapon\'s legend into the stone.','',26124),
(120322,'enUS','I\'ve carved more into the stone. A valorous tale.','',26124),
(120323,'enUS','The stone has been etched with more exploits of this weapon of yours.','',26124),
(120324,'enUS','More has been etched into the stone.','',26124),
(120325,'enUS','If you\'re interested in reading some of the translated history of your weapon, I just added more on the scroll.','',26124),
(120326,'enUS','I added some more of your weapon\'s history onto the scroll. You should take a look when time permits.','',26124),
(120327,'enUS','Some fascinating history turned up on your weapon. I added it to the scroll if you want to give it a read.','',26124),
(120328,'enUS','This weapon of yours has proven to have had quite the colorful past. I added some new translations to the scroll if you\'re interested.','',26124),
(120329,'enUS','I\'ve scribed some more history on your weapon if you\'d like to take a look.','',26124),
(120330,'enUS','I\'ve added another part to the scroll on your weapon\'s history. It\'ll be a good read if you have a minute or two.','',26124),
(120331,'enUS','I just added the final chapter to our scroll. You should definitely give it a read.','',26124),
(120332,'enUS','Thank you for dedicating so many resources to these efforts. I hope what we\'ve learned about your weapon has proved useful.','',26124),
(120333,'enUS','Well, that\'s it, $n. After weeks of research, I think we\'ve exhausted every scrap of history we could find about your weapon.','',26124),
(120334,'enUS','','I just added the final chapter to our book. You should give it a read.',26124),
(120335,'enUS','','Thank you for dedicating so many resources to these efforts. I hope what we\'ve learned about your weapon has proved useful.',26124),
(120336,'enUS','','The winds are quiet, $n. I think we\'ve uncovered all we are going to on your weapon.',26124),
(120337,'enUS','The final etchings have been added. You should read them.','',26124),
(120338,'enUS','A truly heroic tale. Worthy of these halls, and of your hands. I was proud to be the one to tell it.','',26124),
(120339,'enUS','Our journey together is done, valarjar. I have learned everything I can about the weapon you hold, and the battles it has played part in.','',26124),
(120340,'enUS','$n has unleashed the eldritch wrath of the server engineers.','$n has unleashed the eldritch wrath of the server engineers.',26124),
(120341,'enUS','Woof?','',26124),
(120342,'enUS','I wish to unleash the eldritch wrath of the server engineers.','I wish to unleash the eldritch wrath of the server engineers.',26124),
(120343,'enUS','Azeroth itself recoils as $n unleashes an ancient evil. \n\nKosumoth the Hungering walks the land once more...','Azeroth itself recoils as $n unleashes an ancient evil. \n\nKosumoth the Hungering walks the land once more...',26124),
(120344,'enUS','$ct, please forgive our tardiness! Nazgrim insisted on strangulating every demon we ran across. $G Sir:Ma\'am;, I won\'t lie... I\'m having second thoughts about him.','',26124),
(120345,'enUS','Apologies for our late arrival, $ct. The demons foolishly attempted to block our path, and we made them suffer in return!','Apologies for our late arrival, $ct. The demons foolishly attempted to block our path, and we made them suffer in return!',26124),
(120346,'enUS','We sensed that you might be in distress, $ct. Together, we shall strike this demon down!','We sensed that you might be in distress, $ct. Together, we shall strike this demon down!',26124),
(120347,'enUS','Rumors of your death are greatly exaggerated, $ct. They said the demons got you. We came to make sure.','Rumors of your death are greatly exaggerated, $ct. They said the demons got you. We came to make sure.',26124),
(120348,'enUS','Little hero, we have come to fight and die alongside you! Or we could win I suppose. Either way, we have come to fight!','Little hero, we have come to fight and die alongside you! Or we could win I suppose. Either way, we have come to fight!',26124),
(120349,'enUS','We have arrived, $ct, and brought with us good brew and an overly positive attitude!','We have arrived, $ct, and brought with us good brew and an overly positive attitude!',26124),
(120350,'enUS','$g Lad:Lass;, why would ya go off on your own without us? Do ya know how hard it is to get to this bumble-fudged island without a mage\'s portal?','$g Lad:Lass;, why would ya go off on your own without us? Do ya know how hard it is to get to this bumble-fudged island without a mage\'s portal?',26124),
(120351,'enUS','Already getting in trouble, $ct? Hopefully we can be of service!','Already getting in trouble, $ct? Hopefully we can be of service!',26124),
(120352,'enUS','$ct $n, we came as soon as we heard! Thank you for saving my people! Through the Light we will be victorious!','$ct $n, we came as soon as we heard! Thank you for saving my people! Through the Light we will be victorious!',26124),
(120353,'enUS','','Reporting for duty, $ct. Prophet, it has been ages since we last saw each other. Unfortunate circumstances for our reunion, but hopefully the outcome will be in our favor!',26124),
(120354,'enUS','You left in quite a hurry, $ct. We went to great lengths to track down your location. Thankfully we found you in time!','You left in quite a hurry, $ct. We went to great lengths to track down your location. Thankfully we found you in time!',26124),
(120355,'enUS','This imbecile, Calydus, insisted I bring him along. I refused. He followed me anyway. Let\'s get this over with before I lose my patience and incinerate him.','This imbecile, Calydus, insisted I bring him along. I refused. He followed me anyway. Let\'s get this over with before I lose my patience and incinerate him.',26124),
(120356,'enUS','$n wields the Doomhammer now - I can think of none better.','$n wields the Doomhammer now - I can think of none better.',26124),
(120357,'enUS','The Doomhammer is here! Keep the city safe, $n.','The Doomhammer is here! Keep the city safe, $n.',26124),
(120358,'enUS','$n will take care of the Legion. $gHe:she; has the Doomhammer now.','$n will take care of the Legion. $gHe:she; has the Doomhammer now.',26124),
(120359,'enUS','Is that the Doomhammer, $n? Is Thrall alive?','Is that the Doomhammer, $n? Is Thrall alive?',26124),
(120360,'enUS','Hail Farseer $n, chosen keeper of the Doomhammer!','Hail Farseer $n, chosen keeper of the Doomhammer!',26124),
(120361,'enUS','The Doomhammer suits you, $n. Keep it well.','The Doomhammer suits you, $n. Keep it well.',26124),
(120362,'enUS','So it is true - $n wields the Doomhammer!','So it is true - $n wields the Doomhammer!',26124),
(120363,'enUS','I am glad the earthen ring is still around, $n. Fight on!','I am glad the earthen ring is still around, $n. Fight on!',26124),
(120364,'enUS','Placing seal.','Placing seal.',26124),
(120365,'enUS','You have taken well to the Light, Liadrin! It would seem that the Sunwell has renewed your vigor!','',26124),
(120366,'enUS','This is awkward.','',26124),
(120367,'enUS','Light be praised. It is good to see you, Ishanah.','',26124),
(120368,'enUS','There is still a chance.','',26124),
(120369,'enUS','Sound effect for troops','',26124),
(120370,'enUS','Use |TInterface\\Icons\\ability_vehicle_sonicshockwave.blp:20|t |cFFFF0000|Hspell:78675|h[Solar Beam]|h|r to interrupt Ariden\'s channeling!','Use |TInterface\\Icons\\ability_vehicle_sonicshockwave.blp:20|t |cFFFF0000|Hspell:78675|h[Solar Beam]|h|r to interrupt Ariden\'s channeling!',26124),
(120371,'enUS','The fal\'dorei were elves once... Now they are monsters, birthed in the chaotic energies of the failing arcan\'dor. They must be eradicated.','',26124),
(120372,'enUS','Do not mourn for them. They are a mistake that must be corrected.','',26124),
(120373,'enUS','Excellent!','',26124),
(120374,'enUS','The arcan\'dor beneath Falanaar grew unstable and failed catastrophically. Use your Lodestone to gather energy from the Shattered Locus so we can understand why.','',26124),
(120375,'enUS','This will help us to keep our own arcan\'dor stable. We must not fail.','',26124),
(120376,'enUS','The soul of that one would be usefull.','',26124),
(120377,'enUS','Another weakling falls.','',26124),
(120378,'enUS','Easily defeated.','',26124),
(120379,'enUS','Did it even try?','',26124),
(120381,'enUS','Fall before your masters!','',26124),
(120382,'enUS','','I wish to study the energies in the Shattered Locus. Capture some of the critters feeding upon the crystals there. I need them alive!',26124),
(120383,'enUS','<evil laughter>','',26124),
(120384,'enUS','','Excellent. This brings us one step closer to understanding the unique power of the arcan\'dor.',26124),
(120386,'enUS','','The Legion landed right on our doorstep - and Elisande simply let them in. Disgusting. Strike at Felsoul Hold! Show the Legion that some of us are not so easily broken!',26124),
(120387,'enUS','','Ru-shanna shal\'dorei. The Nightborne will survive.',26124),
(120388,'enUS','So $n has the Doomhammer now? The Horde sure is coming apart at the seams I guess.','So $n has the Doomhammer now? The Horde sure is coming apart at the seams I guess.',26124),
(120389,'enUS','$n has the Doomhammer in hand. Glory to the Alliance!','$n has the Doomhammer in hand. Glory to the Alliance!',26124),
(120390,'enUS','The Doomhammer is here! Keep the city safe, $n.','The Doomhammer is here! Keep the city safe, $n.',26124),
(120391,'enUS','Is that the Doomhammer, $n? That\'s the very weapon that slew Sir Anduin Lothar in the second war.','Is that the Doomhammer, $n? That\'s the very weapon that slew Sir Anduin Lothar in the second war.',26124),
(120392,'enUS','It\'s good to see the Doomhammer in Alliance hands, $n.','It\'s good to see the Doomhammer in Alliance hands, $n.',26124),
(120393,'enUS','The rumors are true. $n wields the Doomhammer now!','The rumors are true. $n wields the Doomhammer now!',26124),
(120394,'enUS','I can think of no champion more worthy to carry that hammer, $n.','I can think of no champion more worthy to carry that hammer, $n.',26124),
(120395,'enUS','An Alliance champion wields the Doomhammer now? The end times must surely be upon us...','An Alliance champion wields the Doomhammer now? The end times must surely be upon us...',26124),
(120396,'enUS','','Greetings to you, $c. May the Light illuminate your path.',26124),
(120397,'enUS','The Legion have begun their attack. The Conclave needs your help.','The Legion have begun their attack. The Conclave needs your help.',26124),
(120398,'enUS','','Ten thousand years beneath a false sky, and we emerge to see the real one choked with vermin. Use the cannons in Felsoul Hold and blast those vile felbats!',26124),
(120399,'enUS','','When the Legion is finally gone, we can gaze at the heavens in peace.',26124),
(120400,'enUS','Innocents are being jailed all across the city. This cannot stand! Slay the guards, take their control orbs, and set my people free.','',26124),
(120401,'enUS','Surely many of those you freed were to be exiled. You saved many lives today.','',26124),
(120402,'enUS','','Bring these withered into the collapsed tunnels of Falanaar. Teach them to fight, and to search for relics that can aid our cause.',26124),
(120403,'enUS','I will be waiting for you on the other side. Good luck, $n.','',26124),
(120404,'enUS','','Oculeth, can you get a bead on them?',26124),
(120405,'enUS','Yes, I see them. Hold on a moment...','',26124),
(120406,'enUS','Hang on, Thalyssra. I am sending a locked chest your way.','',26124),
(120407,'enUS','','Standing by, Oculeth.',26124),
(120408,'enUS','','Wow. This is a big one.',26124),
(120409,'enUS','','Be careful, $n. Do your best to minimize our losses.',26124),
(120410,'enUS','','Use caution. We don\'t want our withered to end up in cocoons.',26124),
(120411,'enUS','','The Elfbreaker? What a dreadful name.',26124),
(120412,'enUS','','Look out!',26124),
(120413,'enUS','','One of the withered is running away. Catch him before he is lost in the tunnels!',26124),
(120414,'enUS','It looks like $n ran into some trouble, Thalyssra. I\'ll get them out of there.','',26124),
(120415,'enUS','','These poor things have been through enough today. Oculeth, send them back.',26124),
(120416,'enUS','$n! You made it!','',26124),
(120417,'enUS','Without more arcwine, many citizens will wither right here in the city. Find what you can and I will see that they are cared for.','',26124),
(120418,'enUS','I can save a lot of people with this arcwine. For many it makes all the difference.','',26124),
(120419,'enUS','','Even the mountains of this land will crumble before the might of lord Sargeras!',26124),
(120420,'enUS','Mana wyrms are critical in guarding the arcan\'dor from pests. Capture more from the vineyard in Suramar City.','',26124),
(120421,'enUS','Without balance, there is chaos. These will keep our ecosystem in balance.','',26124),
(120422,'enUS','I have enough arcwine to spare for the needy around the city. Find those who cannot travel to my tavern and see that they drink their fill.','',26124),
(120423,'enUS','By the Light, be reborn!','',26124),
(120424,'enUS','Do not give up, $n! The Light will prevail!','',26124),
(120425,'enUS','Something so simple as feeding the needy, made perilous by Elisande. Your bravery is all that stands between them and a terrible fate.','',26124),
(120426,'enUS','If the Vineyard\'s production quotas are not met, the citizens are the first to suffer. Help them reach their goals so arcwine rations continue to flow.','',26124),
(120427,'enUS','You are going to be quite the accomplished vintner! Rations leave the vineyard once more.','',26124),
(120428,'enUS','','Ghostly eyes are watching our every move. I don\'t think we\'ll get any privacy in this land, master.',26124),
(120429,'enUS','Couriers deliver sensitive orders and information to lieutenants throughout the city. Intercept them and collect the correspondence they carry.','',26124),
(120430,'enUS','Well done. I will examine these letters and see if there is any useful information for our movement within.','',26124),
(120431,'enUS','I need you to look into a suspicious person who has been lurking around my tavern. Find where he is, follow him at a distance, and discover his purpose.','',26124),
(120432,'enUS','He has been informing on us! We should feel fortunate we found him... the less the Grand Magistrix knows the better.','',26124),
(120433,'enUS','','Paladins, it is time to aid our allies under the Light and defend Netherlight Temple!',26124),
(120434,'enUS','','The Nightborne continue to lay siege to the Moon Guard stronghold. Show them there are limits to their arrogance.',26124),
(120435,'enUS','','Elisande must not be allowed to pillage the secrets of the Moon Guard.',26124),
(120436,'enUS','','The Moon Guard have a long tradition of training hippogryphs for battle. Take flight, and rain justice from above!',26124),
(120437,'enUS','','Delas, ready the portal.',26124),
(120438,'enUS','','Your words are very kind, $n. I... I\'m not sure what to do. I best be on my way. Tell William to be safe!',26124),
(120439,'enUS','Thanks, but you\'re a seasoned $c. I\'m just a bread merchant! I\'ll return when it\'s safe.','',26124),
(120440,'enUS','','I will see to it the Nightborne end their long isolation as defenders of Azeroth, not conquerors.',26124),
(120441,'enUS','Elisande\'s forces are planning to sweep the city in search of dissenters. It would be a shame if Su\'esh were to find her way out of the menagerie to stop them.','',26124),
(120442,'enUS','This will hurt, Death Knight.','This will hurt, Death Knight.',26124),
(120443,'enUS','The pressure is off and Su\'esh is well fed. We live another day.','',26124),
(120444,'enUS','','Fel infusion has become all the rage among those eager to please the Legion. There is no redeeming these traitors - hunt them down!',26124),
(120445,'enUS','','Much like fashion, some day we shall wonder how anyone thought fel was a good look.',26124),
(120446,'enUS','Do not give up! The High Priest has arrived with reinforcements!','',26124),
(120447,'enUS','Fate brought me here, perhaps I can serve a purpose yet!','',26124),
(120449,'enUS','It will be your faces that I see in my last waking moments. A final agonizing memory before I am turned to ash and cast into oblivion. I welcome it...','',26124),
(120450,'enUS','You think you\'ve won? You will know the taste of defeat, even if it means my own death!','',26124),
(120451,'enUS','Use |TInterface\\Icons\\spell_deathknight_strangulate.blp:20|t |cFFFF0000|Hspell:49576|h[Death Grip]|h|r to interrupt Ariden\'s channeling.','Use |TInterface\\Icons\\spell_deathknight_strangulate.blp:20|t |cFFFF0000|Hspell:49576|h[Death Grip]|h|r to interrupt Ariden\'s channeling.',26124),
(120452,'enUS','','The sacred peace at Tel\'anor is broken by harpy and spirit alike. Restore the tranquility that my people\'s ancestors deserve.',26124),
(120453,'enUS','','Austerity returns to Tel\'anor, and my ancestors can rest once more. Thank you.',26124),
(120454,'enUS','Let us take a moment to rest, and restore our temple to its intended glory.','',26124),
(120455,'enUS','From the mouth of Argus comes your doom! For soon the annihilator will have its fill and detonate with the force of a collapsing star! Nothing but ash will be left where we stand!','',26124),
(120456,'enUS','','Wonderful. I am ready to fight whenever you are!',26124),
(120457,'enUS','I owe my life to you, Archmage. I will serve our order tirelessly as your champion!','',26124),
(120458,'enUS','My strength is yours, friend. Together we will protect Azeroth!','',26124),
(120459,'enUS','','I would be glad to lend my skills to the Tirisgarde, conjuror. I have heard great things about you.',26124),
(120460,'enUS','Great! I will serve you and our order most faithfully!','',26124),
(120461,'enUS','You will totally regret this when I\'m the boss!  I mean... you totally won\'t regret this, boss!','',26124),
(120462,'enUS','The Arcane Destroyer trills a few notes and claps its hands together excitedly.','',26124),
(120463,'enUS','I am honored to serve the Tirisgarde under your leadership, Archmage. Let us fight for Azeroth!','',26124),
(120464,'enUS','Through your guidance and strength, we have emerged the victors in a great battle that was meant to destroy us.','',26124),
(120465,'enUS','It would be foolish to think this attack will be the last, but we should take a moment to reflect on this victory and celebrate its true hero, our High Priest.','',26124),
(120466,'enUS','To the High Priest!','',26124),
(120467,'enUS','Yes, I welcome all who wish to follow the path of the Light. Meet me in the Hall of Champions.','Yes, I welcome all who wish to follow the path of the Light. Meet me in the Hall of Champions.',26124),
(120468,'enUS','I\'m sorry, I must think on it further.','I\'m sorry, I must think on it further.',26124),
(120469,'enUS','To the High Priest!','',26124),
(120470,'enUS','','To the High Priest!',26124),
(120471,'enUS','','Please take as much time as you need, Highlord. My resolve will not waver.',26124),
(120472,'enUS','','Thank you, Highlord! I am ready.',26124),
(120474,'enUS','All right, let\'s rumble!','',26124),
(120475,'enUS','Aw, yeah, for the Alliance!','',26124),
(120476,'enUS','Aw, yeah, for the Horde!','',26124),
(120477,'enUS','I will serve with honor.','',26124),
(120478,'enUS','','My tribe is gone, $n. Those who survived the Cataclysm sought refuge in Thunder Bluff. Some of our braves were killed during the Siege of Orgrimmar. Of those that were left, none returned from the Broken Shore.$b$bThe Earthen Ring is my family now, $ct. I promise you, I will fight to the end.$b$bHow can I help you today?',26124),
(120479,'enUS','','Our enemies will tremble!',26124),
(120480,'enUS','Alliance Enthusiast admires you.','',26124),
(120482,'enUS','Alliance Enthusiast scoots a little closer to you.','',26124),
(120483,'enUS','Alliance Enthusiast cheers for you!','',26124),
(120484,'enUS','Alliance Enthusiast claps.','',26124),
(120485,'enUS','Alliance Enthusiast steals a strand of your hair.','',26124),
(120486,'enUS','In my master\'s house smolder the burning husks of a thousand worlds. I am here now to prepare a place for you amidst the ruin of tomorrow.','',26124),
(120488,'enUS','Alliance Enthusiast writes your name in a little heart.','',26124),
(120489,'enUS','I am here now to prepare a place for you amidst the ruin of tomorrow.','',26124),
(120490,'enUS','Horde Fanatic admires you.','',26124),
(120491,'enUS','Horde Fanatic scoots a little closer to you.','',26124),
(120492,'enUS','Horde Fanatic cheers for you!','',26124),
(120493,'enUS','Horde Fanatic claps.','',26124),
(120494,'enUS','Horde Fanatic steals a strand of your hair.','',26124),
(120495,'enUS','Horde Fanatic writes your name in a little heart.','',26124),
(120496,'enUS','Not wise to question Odyn. He says you lead then you lead!','',26124),
(120497,'enUS','No... our orders...','',26124),
(120498,'enUS','To live again and to fight! The glory of battle awaits!','',26124),
(120499,'enUS','Dagg find da big treasure dis time!','',26124),
(120500,'enUS','I choose to believe that fate has brought us together.','',26124),
(120501,'enUS','You mean we get to work by your side to smash the fiends that attacked Ulduar? Count me in!','',26124),
(120502,'enUS','I will unleash the wrath of thunder upon our enemies!','',26124),
(120503,'enUS','I am in your debt. The winds of the north are at your service.','',26124),
(120504,'enUS','No... no! I am KING YMIRON! I am NOT a servant!','',26124),
(120505,'enUS','','I still remember the way to the Light\'s Hope Chapel. I will meet you there.',26124),
(120506,'enUS','We will fight and win many more battles under your leadership, High Priest.','',26124),
(120507,'enUS','','Together we will destroy the Burning Legion!',26124),
(120508,'enUS','','I will do whatever is needed to defend Dreadscar Rift from the Burning Legion.',26124),
(120509,'enUS','','Our will is yours to command.',26124),
(120510,'enUS','','In the past I have guided my husband Go\'el along the path of the shaman. But for his next trial, he walks alone. What of you? What is your path?$b$bWill you be a force of nature, laying waste to our foes? A font of wisdom, discerning and fulfilling the will of the spirits? A healer, soothing the troubled and lifting up the meek? I tell you the truth, $n:$b$bA true shaman must be all of these things.',26124),
(120511,'enUS','You have a natural instinct for survival, one that will only be strengthened in troubled times like these.','',26124),
(120512,'enUS','','If you are leading the order in its efforts to help those in need, then I offer myself to aid in any way I can.',26124),
(120513,'enUS','You\'ve made a friend of Baron, and in that, you\'ve also made a friend of me.','',26124),
(120514,'enUS','','I don\'t think Hemet himself could have taught me better. I\'m happy to hunt with you anytime!',26124),
(120515,'enUS','If we must fight, I hope that it can continue to be at your side.','',26124),
(120516,'enUS','Huge demon headed straight for the north wall! Don\'t let it breach the gates!','',26124),
(120517,'enUS','I don\'t believe this! Two more heading for the Hill! One to the south and another back at the north gate!','',26124),
(120518,'enUS','The guards trample my people every day, with demons at their backs. Show them that we are capable of fighting back!','',26124),
(120519,'enUS','Everywhere the Grand Magistrix\'s forces encroach, we will push back!','',26124),
(120520,'enUS','I\'ve come to help the withered with their combat training.','I\'ve come to help the withered with their combat training.',26124),
(120521,'enUS','','Excellent. We will be training in the collapsed tunnels of Fal\'anar.$b$bHow many withered will you be bringing with you?',26124),
(120522,'enUS','Eight withered.\n(Costs 400 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)','Eight withered.\n(Costs 400 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)',26124),
(120523,'enUS','Eight withered.\n|cFFFF0000(Costs 400 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)|r','Eight withered.\n|cFFFF0000(Costs 400 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)|r',26124),
(120524,'enUS','Ten withered.\n(Costs 650 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)','Ten withered.\n(Costs 650 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)',26124),
(120525,'enUS','Ten withered.\n|cFFFF0000(Costs 650 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)|r','Ten withered.\n|cFFFF0000(Costs 650 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)|r',26124),
(120526,'enUS','Twelve withered.\n(Costs 900 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)','Twelve withered.\n(Costs 900 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)',26124),
(120527,'enUS','Twelve withered.\n|cFFFF0000(Costs 900 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)|r','Twelve withered.\n|cFFFF0000(Costs 900 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)|r',26124),
(120528,'enUS','Fifteen withered.\n(Costs 1300 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)','Fifteen withered.\n(Costs 1300 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)',26124),
(120529,'enUS','Fifteen withered.\n|cFFFF0000(Costs 1300 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)|r','Fifteen withered.\n|cFFFF0000(Costs 1300 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)|r',26124),
(120530,'enUS','Twenty withered.\n(Costs 2000 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)','Twenty withered.\n(Costs 2000 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)',26124),
(120531,'enUS','Twenty withered.\n|cFFFF0000(Costs 2000 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)|r','Twenty withered.\n|cFFFF0000(Costs 2000 Ancient Mana |TINTERFACE\\ICONS\\INV_Misc_ancient_mana.blp:16|t)|r',26124),
(120532,'enUS','Are you sure you\'re ready? Once you bring your withered to Falanaar, you will not be able to bring them back.','Are you sure you\'re ready? Once you bring your withered to Falanaar, you will not be able to bring them back.',26124),
(120533,'enUS','Trust in the Light, champions! Be empowered by its grace!','',26124),
(120534,'enUS','','The withered are ready. Let us begin.',26124),
(120535,'enUS','Tadpoles! Tadpoles is the winner!','',26124),
(120536,'enUS','The inhabitants of Sentinel Hill have been inspired to join the fight against the Legion!','',26124),
(120537,'enUS','A stopped clock is always right, when you use magic!','',26124),
(120538,'enUS','Where am I? Whose body is this?','',26124),
(120539,'enUS','Sparkles, fizzles, whizzbangs ahoy!','',26124),
(120540,'enUS','A merry midsummer to all!','',26124),
(120541,'enUS','Ants! Ants ants ants ants ants ants!','',26124),
(120542,'enUS','Wubba lubba dub dub!','',26124),
(120543,'enUS','Sparkle and shine and fizzle away!','',26124),
(120544,'enUS','We\'ve got company! Keep track of everything the demons break... I\'m sending them a bill!','',26124),
(120545,'enUS','On your toes, people! You have a sacred duty to protect the investments of your trade prince!','',26124),
(120546,'enUS','Not again! These demons have no respect for private property! Let\'s teach them a lesson!','',26124),
(120547,'enUS','Well met, friend.','',26124),
(120548,'enUS','I mastered a new spell today!','',26124),
(120549,'enUS','It\'s good to see you!','',26124),
(120550,'enUS','Are you as excited as I am to be here?','',26124),
(120551,'enUS','It\'s a great day to practice magic!','',26124),
(120552,'enUS','Take care, friend.','',26124),
(120553,'enUS','Let me know if you need my help with anything.','',26124),
(120554,'enUS','Until we meet again!','',26124),
(120555,'enUS','Yes?','',26124),
(120556,'enUS','I\'m getting a headache.','',26124),
(120557,'enUS','I suppose persistence is a good thing.','',26124),
(120558,'enUS','You must have better things to do.','',26124),
(120559,'enUS','Don\'t you have somewhere else to be?','',26124),
(120560,'enUS','','Knowledge is power.',26124),
(120561,'enUS','','Keep your eyes open, friend.',26124),
(120562,'enUS','','Farewell. Let me know if you come across anything interesting!',26124),
(120563,'enUS','','Can\'t you see I\'m busy?',26124),
(120564,'enUS','','What is it?',26124),
(120565,'enUS','','Keep it up and I\'ll show you my sword skills.',26124),
(120566,'enUS','','Don\'t test my patience.',26124),
(120567,'enUS','','Magical accidents happen all the time...',26124),
(120568,'enUS','The undead would be much less of a hassle, if only they were more mortal.','',26124),
(120569,'enUS','My plants are coming in nicely this year. The key is clippings from a much more primordial strain of the lotus, the alpha if you will. Quite a prized possession, that.','',26124),
(120570,'enUS','My favorite Hearthstone card? It\'s got to be lightning bolt!','',26124),
(120571,'enUS','I am Valarjar!','',26124),
(120572,'enUS','Glory to Odyn!','',26124),
(120573,'enUS','Hail, champion.','',26124),
(120574,'enUS','Until the next battle.','',26124),
(120575,'enUS','May your battles end in victory.','',26124),
(120576,'enUS','Death to your enemies!','',26124),
(120577,'enUS','What is it?!','',26124),
(120578,'enUS','We will not fight... today.','',26124),
(120579,'enUS','What do you want?','',26124),
(120580,'enUS','Off with you!','',26124),
(120581,'enUS','Farewell.','',26124),
(120582,'enUS','Hmmph.','',26124),
(120583,'enUS','','My shield is strong.',26124),
(120584,'enUS','','Do not tempt my spear!',26124),
(120585,'enUS','','What is it?',26124),
(120586,'enUS','','You shall live... this time.',26124),
(120587,'enUS','','Be on your way, then.',26124),
(120588,'enUS','','See you in battle.',26124),
(120589,'enUS','','My shield is strong.',26124),
(120590,'enUS','','Death cannot stop me.',26124),
(120591,'enUS','','I serve a greater power.',26124),
(120592,'enUS','','I dwell in the Shadowlands.',26124),
(120593,'enUS','','We will meet again soon.',26124),
(120594,'enUS','','Die well.',26124),
(120595,'enUS','','One day I may come for you.',26124),
(120596,'enUS','You asked me if I foresaw this day, child.','',26124),
(120597,'enUS','I... I did... And until this moment I did not understand.','',26124),
(120598,'enUS','In a time that is now just a whisper of a memory, I had a son. On the day of his birth, a vision came to me.','',26124),
(120599,'enUS','In that vision I saw myself weeping as I held a dying eredar in my arms. His skin fel-pocked and battle-scarred.','',26124),
(120600,'enUS','Like yours...','',26124),
(120601,'enUS','But I buried that vision after Kil\'jaeden took my family from me, and for eons let it be lost in the darkest recesses of my being.','',26124),
(120602,'enUS','Now, finally, as I hold you in my arms, I understand.','',26124),
(120603,'enUS','The Legion has taken everything from me. From us.','',26124),
(120604,'enUS','I have given you all that I am, and have asked for nothing! Grant me this mercy!','',26124),
(120605,'enUS','UNUSED DO NOT LOCALIZE','',26124),
(120606,'enUS','We did not ask for this burden, Prophet. It is what fate has deemed.','',26124),
(120607,'enUS','','Tell me you are not seriously considering sending our friend on such a mission. That is suicide.',26124),
(120608,'enUS','','I have seen first hand what Arcan\'dor\'s energies do for the Withered. I have faith that it is worth the risk.',26124),
(120609,'enUS','','Hmph. We will have to see, then.',26124),
(120610,'enUS','Did Romuul survive?','',26124),
(120612,'enUS','What\'s wrong with the prophet?','What\'s wrong with the prophet?',26124),
(120613,'enUS','','I do relish a good fight.',26124),
(120614,'enUS','My life for the Silver Hand, Highlord.','',26124),
(120615,'enUS','','Fearless is my charge, Highlord! For the Order!',26124),
(120616,'enUS','','The Light will guide my hand, Highlord.',26124),
(120617,'enUS','','I will not let you down, Highlord.',26124),
(120618,'enUS','My parents would be proud of all that we have achieved. I will fight on for them, Highlord.','',26124),
(120619,'enUS','The Light is everywhere. I welcome it, whether in glory or death.','',26124),
(120620,'enUS','','It is my honor to join you, Grandmaster. My master would be proud.',26124),
(120621,'enUS','','I got a good sense about you, druid. Your spirit burns bright. You won\'t lead us wrong.',26124),
(120622,'enUS','So much to do... so little time!','',26124),
(120623,'enUS','We must make haste to the Violet Hold. I will explain along the way.','',26124),
(120624,'enUS','In ages past, the Forge of the Guardian was a source of great power for the Council of Tirisfal.','',26124),
(120625,'enUS','When the Legion learned of the forge\'s existence, the Council knew it had to be hidden somewhere safe.','',26124),
(120626,'enUS','It was secreted to the Violet Hold. Not only was this the most secure location in Dalaran, it was a place few would think to look.','',26124),
(120627,'enUS','Who is that oddly handsome fellow?','',26124),
(120628,'enUS','Have we met before?','',26124),
(120629,'enUS','I say, you do look rather familiar...','',26124),
(120630,'enUS','I don\'t believe so, I would have remembered such a well-dressed, young and spry mage.','',26124),
(120631,'enUS','Now that Kathra\'natir knows its location, I fear the worst.','',26124),
(120632,'enUS','It seems my fears were well-founded! The dreadlord is already inside. We must hurry!','',26124),
(120633,'enUS','Hrydshal has taken prisoners during a recent raid on Highmountain. I would ask that you free them for me. I owe a great debt to the ancestors of those who were taken and would see that debt paid.','',26124),
(120634,'enUS','','Masked thugs have been harassing my supporters. I know those beasts of House Stelleris are behind it!',26124),
(120635,'enUS','','<Sigh.> Politics as usual. Perhaps after we have liberated Suramar, my opponents will realize they were on the wrong side of history.',26124),
(120636,'enUS','It was with the aid of the tauren that my flesh was made wood, my skin made into leaves, and my wisdom made eternal. I shall always remember this, even if my own people do not.','',26124),
(120637,'enUS','Nothing like some kafa to get you started in the morning, or an icy Highmountain Refresher after a long day on the battlefield. I like Spiced Tea as a nightcap, myself. Have you tried the honey croissants? Deee-licious!$B$BAt least that\'s what I say. But you know... I\'m not really here for the coffee.','',26124),
(120638,'enUS','Hope you heroes brought enough ammunition!','',26124),
(120639,'enUS','Here they come! Time to prove your worth!','',26124),
(120640,'enUS','I don\'t like the sound of that! Stand tall... even if you\'re short!','',26124),
(120641,'enUS','This bunch looks... bigger. But that\'s no excuse to slack off!','',26124),
(120642,'enUS','They\'re pouring it on! Show them we\'re no slouches!','',26124),
(120643,'enUS','Is it just me, or are they getting angrier and... redder?','',26124),
(120644,'enUS','Bring this one down quick! He\'s wreaking havoc on property values!','',26124),
(120645,'enUS','','Have you come to a decision yet, $ct?$b$bI would give you guidance, but in this, you must look within.',26124),
(120646,'enUS','Show them there\'s only room for one boss in Azshara... me!','',26124),
(120647,'enUS','This demon\'s trying to muscle in on MY territory. Put a stop to it!','',26124),
(120648,'enUS','They\'re spreading out! Unpaid overtime is hereby authorized... find them!','',26124),
(120649,'enUS','These demons are making themselves at home... in MY home! Spread out and stop them!','',26124),
(120650,'enUS','They\'re expanding operations! Hey, I\'m the only one who\'s supposed to do that!','',26124),
(120651,'enUS','There\'s more work to be done! Don\'t let me catch you napping!','',26124),
(120652,'enUS','Don\'t let up now! You\'ve got an obligation to defend my assets!','',26124),
(120653,'enUS','I want these demons cleared out by suppertime. I can\'t afford to miss a meal!','',26124),
(120654,'enUS','Yeesh! Ugliest demon so far! Fight in the name of your handsome trade prince!','',26124),
(120655,'enUS','This one wants to be the big boss! Sorry, bub, the position\'s been filled... BY ME!','',26124),
(120656,'enUS','Take the leader down! Bring me its head... and its coin purse. The latter being my preference!','',26124),
(120657,'enUS','You saved the day! Nice work! I\'ll be sending you a small bill for the damages, though.','',26124),
(120658,'enUS','Way to go! You\'ve made your trade prince very proud. Just wipe your boots before coming near my palace!','',26124),
(120659,'enUS','Well done! Your combat skills are impressive, as advertised. And this trade prince knows how to advertise!','',26124),
(120660,'enUS','Infusing...','Infusing...',26124),
(120661,'enUS','Thorim, what is the source of your power?','Thorim, what is the source of your power?',26124),
(120662,'enUS','Dreyrgrot is infested with pirate... vampires... pira-vamp... vampirates? GRAH! Just go slay them. The fools are plundering relics we buried for a reason. Such cursed artifacts were never meant to be unearthed.','',26124),
(120663,'enUS','Those artifacts would have caused grave harm in the hands of those greedy fiends. You did well to retrieve them.','',26124),
(120664,'enUS','','Why hello, a visitor! Thank you for coming by to see me.',26124),
(120665,'enUS','','Have I told you about my grandchildren, Alexis, Kelsey, and Cara? Such bright girls!$B$BI haven\'t seen them since before... <Peggy pauses, then smiles peacefully.>$B$BWell, I miss them and hope they are doing well.',26124),
(120666,'enUS','','Are you ready to begin the juicing demonstration?',26124),
(120667,'enUS','Use |TInterface\\Icons\\spell_arcane_blink.blp:20|t |cFFFF0000|Hspell:111771|h[Blink]|h|r to bypass the Void Barrier.','Use |TInterface\\Icons\\spell_warlock_demonicportal_green.blp:20|t |cFFFF0000|Hspell:111771|h[Demonic Portal]|h|r to get past Ariden\'s barrier!',26124),
(120668,'enUS','Another Jarl has fallen in glorious battle! Today we shall honor his passing. Go forth, champion, and join in the revelry! Just... try not to let it kill you in the process.','',26124),
(120669,'enUS','Now THAT is how you honor a fallen warrior! But I think you\'ve had enough revelry for one day.','',26124),
(120671,'enUS','By order of the Grand Magistrix, you are hereby charged with sedition. You undermine my authority and must pay the price.','',26124),
(120672,'enUS','Please, be careful of that staff...','Please, be careful of that staff...',26124),
(120673,'enUS','I will try to follow your ways.','I will try to follow your ways.',26124),
(120674,'enUS','Light\'s Wrath, I thought it lost...','Light\'s Wrath, I thought it lost...',26124),
(120675,'enUS','With that, you might save us all.','With that, you might save us all.',26124),
(120676,'enUS','You are a great example to follow.','You are a great example to follow.',26124),
(120677,'enUS','Grrgl mrg!','',26124),
(120678,'enUS','When you are ready, I will send you into the Rift of Aln to face Xavius.','',26124),
(120679,'enUS','Send me to the Rift of Aln!','Send me to the Rift of Aln!',26124),
(120680,'enUS','Ulduar\'s under attack. Send me and any forces that are ready to their aid!','Ulduar\'s under attack. Send me and any forces that are ready to their aid!',26124),
(120681,'enUS','Thorim doesn\'t have much time. Speak to Aerilya at once to go to Ulduar\'s aid!','',26124),
(120682,'enUS','','Cyrille places a Dusk Lily atop Overseer Durant\'s corpse.',26124),
(120683,'enUS','Search for the budding trees, but watch out for the hungry fish!','',26124),
(120684,'enUS','We did not ask for this burden, Prophet, but it is what fate has deemed.','',26124),
(120685,'enUS','Your child was made a force of darkness by the Deceiver. He lived and died ignorant of the truth - of any truth.','',26124),
(120686,'enUS','Let not the sacrifices we have made here today be in vain. Listen well as soon the darkness will take me.','',26124),
(120687,'enUS','Light\'s Heart is a second chance at a destiny unfulfilled.','',26124),
(120688,'enUS','You must find Mother Moon\'s blessed child. Your journey begins with his.','',26124),
(120689,'enUS','Light\'s Heart will guide you.','',26124),
(120690,'enUS','There is nothing left here for you, $p.','',26124),
(120691,'enUS','Take Light\'s Heart and return to Khadgar. Tell him... Tell him that the Light died here this day.','',26124),
(120692,'enUS','I am neither prophet nor pawn. Not any longer.','',26124),
(120693,'enUS','Farewell.','',26124),
(120694,'enUS','','The murlocs of Shipwreck Cove have been spotted worshipping a Sea Giant named Flotsam. Put an end to this creature.',26124),
(120695,'enUS','','Flotsam should\'ve stayed hidden within the sea. Thank you champion, my people are safer because of you.',26124),
(120696,'enUS','Check out my quality merchandise.','',26124),
(120697,'enUS','I got what you\'re lookin for.','',26124),
(120698,'enUS','Of course it\'s authentic!','',26124),
(120699,'enUS','Hey, no refunds, got it?','',26124),
(120700,'enUS','Pleasure doin business with ya.','',26124),
(120701,'enUS','You got the gold, I got the goods.','',26124),
(120702,'enUS','Just don\'t ask where these came from.','',26124),
(120703,'enUS','You here shopping, or shoplifting?','',26124),
(120704,'enUS','Don\'t worry, these ain\'t stolen. They just haven\'t been paid for yet.','',26124),
(120705,'enUS','Check out this one - hand made in Kezan, hand stolen in Gadgetzan!','',26124),
(120706,'enUS','Too late, too late will be the cry when Sixtrigger\'s bargains pass you by!','',26124),
(120707,'enUS','You again? Snaggle, take them out!','',26124),
(120708,'enUS','System overload? What does that mean? Waaaaaagh!','',26124),
(120709,'enUS','Bury me with... my money...','',26124),
(120710,'enUS','What?','',26124),
(120711,'enUS','Got a head needs crackin?','',26124),
(120712,'enUS','Keep talkin, pal.','',26124),
(120713,'enUS','Whatever.','',26124),
(120714,'enUS','I\'ll get the job done.','',26124),
(120715,'enUS','Watch your back.','',26124),
(120716,'enUS','Shouldn\'t you be killing boars or somethin?','',26124),
(120717,'enUS','I thought I got rid of you already.','',26124),
(120718,'enUS','I heard there\'s a dragon on the top of that mountain. He may look big, but I\'m sure he\'s easy pickings.','',26124),
(120719,'enUS','How bout some target practice? I\'ll count to ten - you run.','',26124),
(120720,'enUS','Time for you to eat lead!','',26124),
(120721,'enUS','No fair! You cheated...','',26124),
(120722,'enUS','','I\'m here to usher the worthy to Skyhold!',26124),
(120723,'enUS','Ah, the savior of Magnar. This should be easy for you!','',26124),
(120724,'enUS','I trust those swords are useful? The kvaldir may want them back before the day is done.','',26124),
(120725,'enUS','Introducing our next combatant!  This $R $C has finished $12383W seasons as a rank one Gladiator!  Get ready to fight, $n!','Introducing our next combatant!  This $R $C has finished $12383W seasons as a rank one Gladiator!  Get ready to fight, $n!',26124),
(120726,'enUS','There is an exposed leyline in Azuregale Bay causing all kinds of interference on the network. Set up some surveying equipment so I can monitor its chaotic energies and work around them!','',26124),
(120727,'enUS','Now I simply look for patterns in the chaos and weave our telemancy spells around them. I love my job!','',26124),
(120728,'enUS','Plucking...','Plucking...',26124),
(120729,'enUS','','I am ready to shed this hunger and lead my people to salvation.',26124),
(120730,'enUS','','I will have what Oculeth is having.',26124),
(120731,'enUS','I will be the first to taste this experiment of ours. Let any ill effects fall to me.','',26124),
(120732,'enUS','<Offer Fruit of the Arcan\'dor.>','<Offer Fruit of the Arcan\'dor.>',26124),
(120733,'enUS','Those swords, I\'d recognize Odyn\'s work anywhere. Aid me, warrior!','',26124),
(120734,'enUS','','Exiled Nightborne are being held captive by the Legion. Set them free before they meet a terrible fate!',26124),
(120735,'enUS','','I am not sure which is worse - to wither, or be turned into fuel for the Legion\'s war machines. Thank you for saving them.',26124),
(120736,'enUS','Bah! You believe yourself worthy of ME?! I have larger muscles than you do.','Bah! You believe yourself worthy of ME?! I have larger muscles than you do.',26124),
(120737,'enUS','Are you flirting with me? Or is there something wrong with your face.','Are you flirting with me? Or is there something wrong with your face.',26124),
(120738,'enUS','Why does your face make that look? Remove it! It offends me.','Why does your face make that look? Remove it! It offends me.',26124),
(120739,'enUS','Do not waste my time. Your features are too... soft.','Do not waste my time. Your features are too... soft.',26124),
(120740,'enUS','Do not make me slap that look right off your face.','Do not make me slap that look right off your face.',26124),
(120741,'enUS','Bah! You believe yourself worthy of ME?! Perhaps later you can prove that.','Bah! You believe yourself worthy of ME?! Perhaps later you can prove that.',26124),
(120742,'enUS','Well... you do have soft features...','Well... you do have soft features...',26124),
(120743,'enUS','Warchief! The $c you called for has arrived. We only await Sylvanas now.','',26124),
(120744,'enUS','Hmm. Well, you never know until you try...','Hmm. Well, you never know until you try...',26124),
(120745,'enUS','Ah, $n, it\'s... good ya came. Time be... runnin\' short.','',26124),
(120746,'enUS','You must have a deathwish. I admire that.','You must have a deathwish. I admire that.',26124),
(120747,'enUS','Let me call in my healers, Warchief. Your wound must be tended!','',26124),
(120748,'enUS','Too late for dat, Bloodhoof. Me got one... final duty. Ta see dat da Horde... stays strong.','',26124),
(120749,'enUS','Why not? I enjoy breaking small things.','Why not? I enjoy breaking small things.',26124),
(120750,'enUS','The Alliance lost its king on the Broken Shore. Its people cry out for vengeance.','',26124),
(120751,'enUS','Dat\'s good. Azeroth... gonna fall... \'less we seal up dat tomb.','',26124),
(120752,'enUS','My contact in the Kirin Tor tells me certain members of the Council of Six are open to inviting the Horde back into Dalaran.','',26124),
(120753,'enUS','We WILL find a way to drive back the Legion, Warchief. This we swear!','',26124),
(120754,'enUS','The Banshee Queen is here, Vol\'jin. What is it you wanted to tell us?','',26124),
(120755,'enUS','','What are you doing? What is wrong with your body?',26124),
(120756,'enUS','','Why do you move so strangely?',26124),
(120757,'enUS','','Bah! You can dance if you want to. But you leave your friends behind...',26124),
(120758,'enUS','','I have not had enough revelry to tolerate what you are doing.',26124),
(120759,'enUS','','Stop that! It is silly.',26124),
(120760,'enUS','','We Nightborne owe our unmatched grace and intellect to a noble heritage. The ancestors at rest in Tel\'Anor deserve proper tribute.',26124),
(120761,'enUS','','Ahh, you\'ve arrived! And just in time for rune-drawing class.$b$bRemind me again, which rune were you working on?',26124),
(120762,'enUS','','Yes, of course, that\'s right. And at which level?',26124),
(120763,'enUS','','Very well, here is the outline of your rune. Best of luck!',26124),
(120764,'enUS','Arcane.','Arcane.',26124),
(120765,'enUS','Fire.','Fire.',26124),
(120766,'enUS','Frost.','Frost.',26124),
(120767,'enUS','Freshman.','Freshman.',26124),
(120768,'enUS','Sophomore.','Sophomore.',26124),
(120769,'enUS','Junior.','Junior.',26124),
(120770,'enUS','Senior.','Senior.',26124),
(120771,'enUS','Oh, hello, welcome to Dalaran. I tend to the lamps.','',26124),
(120772,'enUS','Windle, why doesn\'t my wand work on the lamp posts anymore?','Windle, why doesn\'t my wand work on the lamp posts anymore?',26124),
(120773,'enUS','Oh, yes, terribly sorry about that. I like to light the lamp posts myself, you see. It helps me.\n\nLet\'s leave it at that, please.','',26124),
(120774,'enUS','Don\'t you find these books fascinating? I love reading about the different creatures that inhabit our world.$b$bHop into a book with me. What would you like to read about?','',26124),
(120775,'enUS','Ahh.. the kobolds. An excellent choice! One of my favorites.$b$bWhich book in particular intrigues you the most?','',26124),
(120776,'enUS','Ahh yes, the skrogs. Fascinating brutes, aren\'t they?$b$bWhich book in particular intrigues you the most?','',26124),
(120777,'enUS','Of course. Who wouldn\'t be enraptured by such powerful magical creatures?$b$bWhich book in particular intrigues you the most?','',26124),
(120778,'enUS','Kobolds.','Kobolds.',26124),
(120779,'enUS','Sea Skrogs.','Sea Skrogs.',26124),
(120780,'enUS','The blue dragonflight.','The blue dragonflight.',26124),
(120781,'enUS','Kobold Country','Kobold Country',26124),
(120782,'enUS','A Guide to Kobold Societal Mores (Recommended: 3 Players)','A Guide to Kobold Societal Mores (Recommended: 3 Players)',26124),
(120783,'enUS','Before the Candle: The Rise and Fall of the Great Kobold Empire (Recommended: 10 Players)','Before the Candle: The Rise and Fall of the Great Kobold Empire (Recommended: 10 Players)',26124),
(120784,'enUS','Skroggal Anatomy','Skroggal Anatomy',26124),
(120785,'enUS','Unabridged Glossary of Skrog Weaponry (Recommended: 3 Players)','Unabridged Glossary of Skrog Weaponry (Recommended: 3 Players)',26124),
(120786,'enUS','Children of Golganneth: Great Skrogs in History (Recommended: 10 Players)','Children of Golganneth: Great Skrogs in History (Recommended: 10 Players)',26124),
(120787,'enUS','Draconic Compendium, Volume IV','Draconic Compendium, Volume IV',26124),
(120788,'enUS','I\'ve Got the Blues: Selected Stories from Azurewing Repose (Recommended: 3 Players)','I\'ve Got the Blues: Selected Stories from Azurewing Repose (Recommended: 3 Players)',26124),
(120789,'enUS','Ancient Blue Dragons of Azeroth (Recommended: 10 Players)','Ancient Blue Dragons of Azeroth (Recommended: 10 Players)',26124),
(120790,'enUS','','Welcome to Nar\'thalas Academy. Please, make yourself comfortable. All are welcome here, provided they are willing to learn.',26124),
(120791,'enUS','','Plenty. You are welcome to peruse our stacks, practice combat against any of our training dummies, or simply spend time socializing with your classmates. You may even bring some friends, if you like. This is a safe place.$b$bIn addition, Instructor Nidriel is offering classes on rune drawing, and our research assistant Sythorne is working on a study involving creature combat. I\'m certain either one would be happy to work with you.',26124),
(120792,'enUS','','Not now. Spend a little bit more time interacting with the other instructors, and I might consider it.',26124),
(120793,'enUS','','A duel? If you insist. I suppose a bit of combat never hurt anyone. Actually, that\'s probably not accurate.\nReady when you are!',26124),
(120794,'enUS','','I yield. Besting your headmistress is no small feat. Congratulations.',26124),
(120795,'enUS','','That was enjoyable. Thank you for the chance to dust off my wand. Back to your studies, everyone!',26124),
(120796,'enUS','What can I do here?','What can I do here?',26124),
(120797,'enUS','Interested in a duel?','Interested in a duel?',26124),
(120798,'enUS','Interested in a duel? (Recommended: 10 Players)','Interested in a duel? (Recommended: 10 Players)',26124),
(120799,'enUS','You are tiny.','Odyn shines upon you?',26124),
(120800,'enUS','Why do you speak at me, little $c?','Your cloths, they are funny to me.',26124),
(120801,'enUS','Have you come to drink or fight? Or both?','Have you come to drink or fight? Or both?',26124),
(120802,'enUS','You have tiny hands.','You have tiny hands.',26124),
(120803,'enUS','Watchout! It\'s comin\' down! Move out of the way!','Watchout! It\'s comin\' down! Move out of the way!',26124),
(120804,'enUS','Another Jarl drinks now with Odyn. Between you and me, I never liked that Jarl.','The Jarl goes now to serve Odyn in the Valarjar. Let us drink to their good fortune.',26124),
(120805,'enUS','To be honest, I am going to miss that Jarl. They had some great feasts in their day.','The Jarl will be missed by some. Not me, but by some.',26124),
(120808,'enUS','','Is Arluin coming? I haven\'t seen him in days...',26124),
(120809,'enUS','Arluin is not coming, I\'m afraid. He died to ensure we could bring this to you. <Offer Arcan\'dor Fruit.>','Arluin is not coming, I\'m afraid. He died to ensure we could bring this to you. <Offer Arcan\'dor Fruit.>',26124),
(120810,'enUS','Come at me!','',26124),
(120811,'enUS','Tummy too rumbly...','',26124),
(120812,'enUS','Why I eat so many murlocs?','',26124),
(120813,'enUS','Oooh shiny!','',26124),
(120814,'enUS','That one mine!','',26124),
(120815,'enUS','Ew... too stinky.','',26124),
(120816,'enUS','Yuck... too hairy.','',26124),
(120817,'enUS','Pfff... too ugly.','',26124),
(120818,'enUS','','We should return, High Priest. Our allies need to hear this.',26124),
(120819,'enUS','It is good to see those blades out of kvaldir hands.','',26124),
(120820,'enUS','So the legend is true, the Scale is real...','',26124),
(120821,'enUS','Hey bub!$b$bThree words: Upgrades! Upgrades! Upgrades! I may only be a journeyman, but I know a trick or two to get the most out of your crew. I\'ll make your fire sizzle, your water drizzle, your earths quake and your winds break!','',26124),
(120822,'enUS','The end is coming! Again!','The end is coming! Again!',26124),
(120823,'enUS','Our time ends, the cleansing is nigh!','Our time ends, the cleansing is nigh!',26124),
(120824,'enUS','The world will be shaped anew!','The world will be shaped anew!',26124),
(120825,'enUS','The Light has forsaken us!','The Light has forsaken us!',26124),
(120826,'enUS','Forces beyond our comprehension have seen us unworthy!','Forces beyond our comprehension have seen us unworthy!',26124),
(120827,'enUS','A searing emerald fire will burn away our corruption!','A searing emerald fire will burn away our corruption!',26124),
(120828,'enUS','There is no escape from the inevitable!','There is no escape from the inevitable!',26124),
(120829,'enUS','Our leaders cannot protect us!','Our leaders cannot protect us!',26124),
(120830,'enUS','I may only be a journeyman, but I know a trick or two to get the most out of your crew. I\'ll make your fire sizzle, your water drizzle, your earths quake and your winds break!','',26124),
(120831,'enUS','','Think of this as... repayment for your previous insult, valarjar!',26124),
(120832,'enUS','D\'ye seek to summon Elementals?','D\'ye seek to summon Elementals?',26124),
(120833,'enUS','','This isn\'t over, mortal! I will see my blades returned, and your soul suffer in my grasp!',26124),
(120834,'enUS','<Raise mug>','<Raise mug>',26124),
(120835,'enUS','<Insult>','<Insult>',26124),
(120836,'enUS','Keep your wits about you, $n. If we noticed the object shooting out from the Felstorm, so too did the Legion.','',26124),
(120837,'enUS','I\'d like to purchase Seals of Broken Fate.','I\'d like to purchase Seals of Broken Fate.',26124),
(120838,'enUS','Looking for a Seal of Broken Fate?','',26124),
(120839,'enUS','What is it?','',26124),
(120840,'enUS','What do you need?','',26124),
(120841,'enUS','I greet you.','',26124),
(120842,'enUS','I obey.','',26124),
(120843,'enUS','I am the mountain.','',26124),
(120844,'enUS','As you command.','',26124),
(120845,'enUS','I am ready.','',26124),
(120846,'enUS','I await your command.','',26124),
(120847,'enUS','You confuse me...','',26124),
(120848,'enUS','What are you doing?','',26124),
(120849,'enUS','You\'re making me angry!','',26124),
(120850,'enUS','I will crush your bones!','',26124),
(120851,'enUS','RARRGHH!!','',26124),
(120852,'enUS','The wind has whispered your name.','',26124),
(120853,'enUS','How may I assist you?','',26124),
(120854,'enUS','I am at your service.','',26124),
(120855,'enUS','Let the winds guide you.','',26124),
(120856,'enUS','Where there is wind, so am I.','',26124),
(120857,'enUS','The heavens await your command.','',26124),
(120858,'enUS','How may I aid you?','',26124),
(120859,'enUS','I am yours to command.','',26124),
(120860,'enUS','I do not understand.','',26124),
(120861,'enUS','I am confused.','',26124),
(120862,'enUS','This is not amusing.','',26124),
(120863,'enUS','We have work to do.','',26124),
(120864,'enUS','I must protest this behavior!','',26124),
(120865,'enUS','This is most uncivilized!','',26124),
(120866,'enUS','I am at your call.','',26124),
(120867,'enUS','I am ready.','',26124),
(120868,'enUS','I live to serve.','',26124),
(120869,'enUS','Our fate is in your hands.','',26124),
(120870,'enUS','Fight with honor.','',26124),
(120871,'enUS','As you wish.','',26124),
(120872,'enUS','The battlefield awaits.','',26124),
(120873,'enUS','What are your orders?','',26124),
(120874,'enUS','We have little time.','',26124),
(120875,'enUS','What is the point of this?','',26124),
(120876,'enUS','You are wasting time!','',26124),
(120877,'enUS','My patience wears thin...','',26124),
(120878,'enUS','I am not amused!','',26124),
(120879,'enUS','Speak.','',26124),
(120880,'enUS','How may I aid you?','',26124),
(120881,'enUS','You have my attention.','',26124),
(120882,'enUS','The elements shall guide you.','',26124),
(120883,'enUS','Go with peace.','',26124),
(120884,'enUS','Earth and water.','',26124),
(120885,'enUS','Yes?','',26124),
(120886,'enUS','What is it?','',26124),
(120887,'enUS','I shall serve with honor.','',26124),
(120888,'enUS','I am one with the elements.','',26124),
(120889,'enUS','I have little time for this.','',26124),
(120890,'enUS','We have work to do.','',26124),
(120891,'enUS','Mess with a bull and you\'ll get the horns!','',26124),
(120892,'enUS','I burn with anticipation.','',26124),
(120893,'enUS','How may I serve?','',26124),
(120894,'enUS','I am the avatar of flame.','',26124),
(120895,'enUS','May your fire burn hot.','',26124),
(120896,'enUS','Our enemies will become ash.','',26124),
(120897,'enUS','Everything burns...','',26124),
(120898,'enUS','Yes?','',26124),
(120899,'enUS','What is it?','',26124),
(120900,'enUS','I have only one burning desire...','',26124),
(120901,'enUS','It\'s getting hot in here...','',26124),
(120902,'enUS','How may I serve you? Charred or well-done?','',26124),
(120903,'enUS','Be quick!','',26124),
(120904,'enUS','I am fury incarnate!','',26124),
(120905,'enUS','Out with it!','',26124),
(120906,'enUS','Go!','',26124),
(120907,'enUS','I reign supreme.','',26124),
(120908,'enUS','Do not fail.','',26124),
(120909,'enUS','What?!','',26124),
(120910,'enUS','I am waiting.','',26124),
(120911,'enUS','You will obey.','',26124),
(120912,'enUS','All shall burn.','',26124),
(120913,'enUS','Speak quickly!','',26124),
(120914,'enUS','I have had enough of you!','',26124),
(120915,'enUS','Begone!','',26124),
(120916,'enUS','I will burn your soul!','',26124),
(120917,'enUS','','I am listening.',26124),
(120918,'enUS','','Speak and I will listen.',26124),
(120919,'enUS','','Go with courage, mortal.',26124),
(120920,'enUS','','Until we meet again.',26124),
(120921,'enUS','','The earth is your shield.',26124),
(120922,'enUS','','You have my attention.',26124),
(120923,'enUS','','How may the Stonemother aid you?',26124),
(120924,'enUS','','I am waiting.',26124),
(120925,'enUS','','What is your purpose, mortal?',26124),
(120926,'enUS','','I grow tired of you.',26124),
(120927,'enUS','','I will bury you!',26124),
(120928,'enUS','You stand in the presence of greatness.','',26124),
(120929,'enUS','Do not oppose me!','',26124),
(120930,'enUS','Behold my power!','',26124),
(120931,'enUS','You shall return.','',26124),
(120932,'enUS','I am everywhere.','',26124),
(120933,'enUS','The wind is at your back.','',26124),
(120934,'enUS','What is it?','',26124),
(120935,'enUS','Speak quickly!','',26124),
(120936,'enUS','I am the wind seeker!','',26124),
(120937,'enUS','What do you seek?','',26124),
(120938,'enUS','Your actions are discombobulating!','',26124),
(120939,'enUS','I pity the fool who is foolish enough to fool around with the Windlord!','',26124),
(120940,'enUS','Well met.','',26124),
(120941,'enUS','I am yours to command.','',26124),
(120942,'enUS','I am here to serve.','',26124),
(120943,'enUS','The Ebon Blade will prevail.','',26124),
(120944,'enUS','None shall oppose you, Deathlord.','',26124),
(120945,'enUS','We do what the living cannot.','',26124),
(120946,'enUS','Blood and thunder!','',26124),
(120947,'enUS','Nothing shall stand in our way!','',26124),
(120948,'enUS','I am waiting.','',26124),
(120949,'enUS','We will prevail, no matter the cost!','',26124),
(120950,'enUS','Death was merely a setback.','',26124),
(120951,'enUS','We do what the living cannot.','',26124),
(120952,'enUS','You should kneel before a king.','',26124),
(120953,'enUS','Out with it! I have little time...','',26124),
(120954,'enUS','Are you here to pay tribute?','',26124),
(120955,'enUS','Next time, you will kneel before me.','',26124),
(120956,'enUS','Hurry back or I will unleash the hounds.','',26124),
(120957,'enUS','The glory of Stromgarde is at hand.','',26124),
(120958,'enUS','This war will not be won with words.','',26124),
(120959,'enUS','We alone stand vigil in the night.','',26124),
(120960,'enUS','I am ready.','',26124),
(120961,'enUS','We do what the living cannot.','',26124),
(120962,'enUS','My heart still beats with the drums of war.','',26124),
(120963,'enUS','Victory without sacrifice is only an illusion.','',26124),
(120964,'enUS','I shall serve.','',26124),
(120965,'enUS','What is your desire?','',26124),
(120966,'enUS','You need only ask.','',26124),
(120967,'enUS','We do what the living cannot.','',26124),
(120968,'enUS','Death alone cannot stop us.','',26124),
(120969,'enUS','We have died so that others may live.','',26124),
(120970,'enUS','','What do you seek?',26124),
(120971,'enUS','','Greetings.',26124),
(120972,'enUS','','You need only ask.',26124),
(120973,'enUS','','We do what the living cannot.',26124),
(120974,'enUS','','In undeath my true purpose is manifest.',26124),
(120975,'enUS','','There is no peace for the unliving.',26124),
(120976,'enUS','Rottgut?','',26124),
(120977,'enUS','Rottgut.','',26124),
(120978,'enUS','Rottgut...','',26124),
(120979,'enUS','Rottguuuuuuuut.','',26124),
(120980,'enUS','Rott. Gut!','',26124),
(120981,'enUS','Rottgut!','',26124),
(120982,'enUS','Yes, my disciple?','',26124),
(120983,'enUS','Death greets you, young one.','',26124),
(120984,'enUS','What may I teach you today?','',26124),
(120985,'enUS','We do what the living cannot.','',26124),
(120986,'enUS','Do not forget what you have learned.','',26124),
(120987,'enUS','Your greatest power is... you.','',26124),
(120988,'enUS','The end is coming!\n\nWould you like a pamphlet?','The end is coming!\n\nWould you like a pamphlet?',26124),
(120989,'enUS','You have the aura of one who is questioning.','You have the aura of one who is questioning.',26124),
(120990,'enUS','I\'ll take a pamphlet.','I\'ll take a pamphlet.',26124),
(120992,'enUS','She obviously dead you idiot!','',26124),
(120993,'enUS','You sure she dead? Maybe she sleepin\'!','',26124),
(120994,'enUS','She ain\'t sleepin\' you dummy! She got a knife in her back!','',26124),
(120995,'enUS','Why she tryin\' to sleep wit\' a knife in her back?','',26124),
(121005,'enUS','No no no... wrong skin color entirely. That won\'t do.','',26124),
(121006,'enUS','Ick, that head reminds me of an uppity apprentice I had. Get rid of it.','',26124),
(121007,'enUS','That\'s it! That\'s the one! Give it to me immediately.','',26124),
(121009,'enUS','','You pulled me from a storm of madness and I am forever in your debt, $p. I know there is much I must atone for, but  at least now, my nightmare has passed.',26124),
(121011,'enUS','I\'m ready to go to Suramar.','I\'m ready to go to Suramar.',26124),
(121013,'enUS','Be on guard, $g sir:ma\'am;! Suramar is a dangerous place!','',26124),
(121014,'enUS','There\'s something not quite right about you...','There\'s something not quite right about you...',26124),
(121015,'enUS','','Look at them, enjoying their excess like the Legion aren\'t even here. Shall we introduce them to reality?',26124),
(121016,'enUS','','You look like you\'re ready to set the world ablaze. Oh, how I wish I could join you.',26124),
(121017,'enUS','I\'ll take a flask of Arcflame.','I\'ll take a flask of Arcflame.',26124),
(121019,'enUS','The spirits be kind, $ct. With the right offerin\', they can be findin\' you some valuable items.','The spirits be kind, $ct. With the right offerin\', they can be findin\' you some valuable items.',26124),
(121020,'enUS','Do ye know who I be, laddie?','',26124),
(121021,'enUS','Ye best watch yer tongue lass or ye\'ll be makin\' a trip t\' t\' plank!','',26124),
(121022,'enUS','','Translation please? I cannot understand his incessant pirate gibberish.',26124),
(121023,'enUS','','T\' t\'..t\' plank?',26124),
(121024,'enUS','','He said that the letter was written in an advanced code that will not easily be broken.',26124),
(121025,'enUS','Enough!','',26124),
(121026,'enUS','For years I watched and waited at the base of the Alterac Mountains, speaking only to the spirits and forging mighty weapons from elemental power.$b$bI know the whims of the spirits. I know that one\'s destiny can be guided and shaped, if one is willing to make the sacrifice for it.$b$b$ct, build up this sacred space, and I promise to give you the power to shape your own fate.$b$bUntil then, I watch. I wait.','',26124),
(121027,'enUS','Somewhere in those murky waters is our mysterious object. Time to get your feet wet, $n.','',26124),
(121028,'enUS','To stay focused and heal one\'s allies even in the midst of battle - there be no greater honor and no greater challenge for a shaman.$b$bIf you seek to practice your skills as a battle-mender, there be training dummies here in this chamber.$b$bShould you wish to retrain your skills, speak with Tribemother Torra nearby. She has lived through darkness and seen the light.','',26124),
(121029,'enUS','The shield bearer arrives at an hour of great need. You will need its strength.','',26124),
(121030,'enUS','The vrykul here tell stories of an unrelenting warrior carving through Stormheim with golden blades. I wonder who that could be?','',26124),
(121032,'enUS','You\'re a fine addition to my huntin\' party!','',26124),
(121033,'enUS','As with those that came before me, I pledge my service to you and the Unseen Path.','',26124),
(121034,'enUS','Akama. Your duplicity is hardly surprising.','',26124),
(121035,'enUS','Look there, to the north, $n! Gaze upon the Nighthold of Suramar! What secrets are kept inside?','',26124),
(121036,'enUS','Combatants!  Put your hands together to welcome a $12383W-time Gladiator, $n!.','Combatants!  Put your hands together to welcome a $12383W-time Gladiator, $n!.',26124),
(121037,'enUS','I should have slaughtered you and your malformed brethren long ago.','',26124),
(121038,'enUS','','I pledge my loyalty to you, and to the Unseen Path, for all my days.',26124),
(121039,'enUS','Amazing! Ancient Highborne ruins litter the landscape. And there along the coast, it looks to be a vrykul settlement! Fascinating.','',26124),
(121040,'enUS','Those blades should be mine! Do not think I will go easy on you!','',26124),
(121041,'enUS','Our next rumbler has tested their might over the years on the battlefields.  $n has become a Hero of the Horde during $12383W seasons!','Our next rumbler has tested their might over the years on the battlefields.  $n has become a Hero of the Horde during $12383W seasons!',26124),
(121042,'enUS','Our next rumbler has tested their might over the years on the battlefields.  $n has become a Hero of the Alliance during $12383W seasons!','Our next rumbler has tested their might over the years on the battlefields.  $n has become a Hero of the Alliance during $12383W seasons!',26124),
(121043,'enUS','$n is entering the rumble to prove their might!','$n is entering the rumble to prove their might!',26124),
(121044,'enUS','','Welcome to The Gnarled Branch! Feel free to browse or speak with me if you\'re looking for anything in specific.',26124),
(121045,'enUS','Wow! Nice shades, $n!','Wow! Nice shades, $n!',26124),
(121046,'enUS','Damn, $n! Back at it again with the sweet shades!','Damn, $n! Back at it again with the sweet shades! Nice!',26124),
(121047,'enUS','Looking good, $n!','Looking good, $n!',26124),
(121048,'enUS','Here comes, $n... check out those shades!','Here comes, $n... check out those shades!',26124),
(121049,'enUS','Outsiders!','Outsiders!',26124),
(121050,'enUS','You\'re not welcome here!','You\'re not welcome here!',26124),
(121051,'enUS','How did you get in here?','How did you get in here?',26124),
(121052,'enUS','Intruders!','Intruders!',26124),
(121053,'enUS','Run! They have weapons!','Run! They have weapons!',26124),
(121054,'enUS','The elites in this city revel in excess, while ordinary people suffer and die. Meet my associate Eo\'vyn in Astravar Harbor and put an end to the party.','',26124),
(121055,'enUS','Maybe that will open their eyes to the suffering around them.','',26124),
(121056,'enUS','$n! You are my friend!$b$bNext time Grash grabs a big people-ship from under the water and splits it open and all the people spill out into the sea I will yell at them \"$N IS BEST SHAMAN HA HA HA!\"','',26124),
(121057,'enUS','<Your answer makes the sea giant very happy.>$b$b<Wavespeaker Adelee gawps at you.>','',26124),
(121058,'enUS','<Grash lowers his head sadly.>$b$bOkay.','',26124),
(121059,'enUS','...sure.','...sure.',26124),
(121060,'enUS','Don\'t do that!','Don\'t do that!',26124),
(121061,'enUS','','It was difficult to get Grash into the cavern here. I\'m not sure the other shaman appreciate him like we do.',26124),
(121062,'enUS','Help! Guards! There\'s an arsonist on the loose!','Help! Guards! There\'s an arsonist on the loose!',26124),
(121063,'enUS','Guards, stop this insanity! What do we pay you for?','Guards, stop this insanity! What do we pay you for?',26124),
(121064,'enUS','Our boats are burning! Help!','Our boats are burning! Help!',26124),
(121065,'enUS','','Can I help you?',26124),
(121066,'enUS','','Greetings.',26124),
(121067,'enUS','','Well met.',26124),
(121068,'enUS','','Embrace the shadows.',26124),
(121069,'enUS','','The shadows will rise again.',26124),
(121070,'enUS','','Farewell.',26124),
(121071,'enUS','','You have my attention.',26124),
(121072,'enUS','','I don\'t have time for your games.',26124),
(121073,'enUS','','You\'re trying my patience.',26124),
(121074,'enUS','','Will this ever end?',26124),
(121075,'enUS','','I\'ll send you into the void!',26124),
(121076,'enUS','','Silence!',26124),
(121077,'enUS','','Yes?',26124),
(121078,'enUS','','Hello.',26124),
(121079,'enUS','','How can I help?',26124),
(121080,'enUS','','%s glares at $n disapprovingly.',26124),
(121081,'enUS','','May the Light shine upon you.',26124),
(121082,'enUS','','I will atone.',26124),
(121083,'enUS','','I will be redeemed.',26124),
(121084,'enUS','','You have my attention.',26124),
(121085,'enUS','','Haven\'t I suffered enough?',26124),
(121086,'enUS','','What more do you want from me?',26124),
(121087,'enUS','','You\'re persistent, aren\'t you?',26124),
(121088,'enUS','','Where are your manners?',26124),
(121089,'enUS','','This needs to stop.',26124),
(121090,'enUS','','Don\'t make me do something we\'ll both regret.',26124),
(121091,'enUS','I defend the Light.','',26124),
(121092,'enUS','I am Light incarnate.','',26124),
(121093,'enUS','How can I be of service?','',26124),
(121094,'enUS','The Light endures.','',26124),
(121095,'enUS','May the Light guide you.','',26124),
(121096,'enUS','The Light will prevail.','',26124),
(121097,'enUS','The Nexus Vault lies deep beneath the main spire. You will find its entrance in the lowest chamber of the spire\'s base.','',26124),
(121098,'enUS','','Okay, now, try this...',26124),
(121099,'enUS','','No no, put your hands up, like little ears. Like this!',26124),
(121100,'enUS','','Now do a little shuffle. Like this.',26124),
(121101,'enUS','','%s laughs!',26124),
(121102,'enUS','Bra - hah! Hahah!','',26124),
(121103,'enUS','Grah!','',26124),
(121104,'enUS','I am doing panda dance!','',26124),
(121105,'enUS','There it is! Land at the shoreline and investigate!','',26124),
(121106,'enUS','This place is... quaint.\n\n<Sylverin adjusts his cuffs>\n\nBut I prefer it to losing my life.\n\nI suppose I ought to thank you, for taking action. I was a coward, but at least Margaux\'s death did not go unanswered.\n\nI am indebted to you.','',26124),
(121107,'enUS','I miss my wife, and moreso our daughter.\n\nHere, at least, I can remember them in peace.','',26124),
(121108,'enUS','','The Unseen Path will return to our calling of helping those who need it most.',26124),
(121109,'enUS','Withered damage increased!','Withered damage increased!',26124),
(121110,'enUS','Throw Rock now causes enemies to bleed!','Throw Rock now causes enemies to bleed!',26124),
(121111,'enUS','It\'s not here. Those beasts must have dragged it into the cave. The search continues!','',26124),
(121113,'enUS','Thank you! I could not have lasted much longer!','',26124),
(121114,'enUS','Gaahh! They made me watch my tribe be slaughtered... over and over! Was it all a dream?','',26124),
(121115,'enUS','No! No more!','',26124),
(121116,'enUS','Bees! I saw bees everywhere! Aaahh!','',26124),
(121117,'enUS','Wha... What trickery is this?! Was it all in my head?','',26124),
(121118,'enUS','I can still feel their claws in my mind.','',26124),
(121119,'enUS','Time is money, friend.','',26124),
(121120,'enUS','Yo!','',26124),
(121121,'enUS','Talk to me.','',26124),
(121122,'enUS','Wassup?','',26124),
(121123,'enUS','Can\'t you see I\'m busy here?','',26124),
(121124,'enUS','Heh, heh, glad I could help.','',26124),
(121125,'enUS','Keep it real.','',26124),
(121126,'enUS','Hurry back.','',26124),
(121127,'enUS','All\'s fair in love and business.','',26124),
(121128,'enUS','You scratch my back, I\'ll pay someone to scratch yours.','',26124),
(121129,'enUS','Yeah, very funny.','',26124),
(121130,'enUS','I don\'t have time for this!','',26124),
(121131,'enUS','Amateur!','',26124),
(121132,'enUS','I don\'t have to take this. I\'m the Baron of Gadgetzan.','',26124),
(121133,'enUS','Maybe you\'d prefer some of my goons rough you up?','',26124),
(121134,'enUS','Okay, that\'s it. I\'m puttin\' a contract out on your head.','',26124),
(121135,'enUS','What do you need?','',26124),
(121136,'enUS','How can I help?','',26124),
(121137,'enUS','Achal hecta.','',26124),
(121138,'enUS','Together, we can defeat the Burning Legion.','',26124),
(121139,'enUS','I have a plan for the Legion\'s downfall.','',26124),
(121140,'enUS','Krona ki cristorr!','',26124),
(121141,'enUS','Roma Hekt corta.','',26124),
(121142,'enUS','One day, I will regain the temple.','',26124),
(121143,'enUS','You, I trust. But, never Illidan.','',26124),
(121144,'enUS','I\'m getting too old for this.','',26124),
(121145,'enUS','Why did you poke me?','',26124),
(121146,'enUS','Is this some strange custom of your people?','',26124),
(121147,'enUS','Your finger is puny, so it is more annoying than anything else.','',26124),
(121148,'enUS','Now you\'re just trying to annoy me. Mission accomplished.','',26124),
(121149,'enUS','Magtheridon had better manners.','',26124),
(121150,'enUS','Very well, you leave me no choice but to ignore you.','',26124),
(121151,'enUS','What do you need?','',26124),
(121152,'enUS','What is it you want?','',26124),
(121153,'enUS','Achal hecta.','',26124),
(121154,'enUS','Together, we can defeat the Burning Legion.','',26124),
(121155,'enUS','I have a plan for the Legion\'s downfall.','',26124),
(121156,'enUS','Krona ki cristorr!','',26124),
(121157,'enUS','Roma Hekt corta.','',26124),
(121158,'enUS','One day, I will destroy you and those who follow you.','',26124),
(121159,'enUS','The day your control over me slips is the day you die.','',26124),
(121160,'enUS','I have all eternity to wreak my revenge.','',26124),
(121161,'enUS','Why did you poke me?','',26124),
(121162,'enUS','Is this some strange custom of your people?','',26124),
(121163,'enUS','Your finger is puny, so it is more annoying than anything else.','',26124),
(121164,'enUS','Now you\'re just trying to annoy me. Mission accomplished.','',26124),
(121165,'enUS','Magtheridon had better manners.','',26124),
(121166,'enUS','Very well, you leave me no choice but to ignore you.','',26124),
(121167,'enUS','Sorry, $c. Guild\'s closed down for renovations right now. Boss-man said something about preparing for the next big thing.','',26124),
(121168,'enUS','Sorry, $c. Boss Bazzelflange says the arena is closed for renovations. She said something about \"preparing for the next big thing.\"','Sorry, $c. Boss Bazzelflange says the arena is closed for renovations. She said something about \"preparing for the next big thing.\"',26124),
(121169,'enUS','','If you are hungry, we have food. If you are thirsty, we have drink. If you are tired, we have beds.$b$bIf you are here for something else, you better be be better with that blade than you look.',26124),
(121170,'enUS','Go with valor!','',26124),
(121171,'enUS','Speak!','',26124),
(121172,'enUS','Get to the point!','',26124),
(121173,'enUS','Talk to me when it\'s time to fight.','',26124),
(121174,'enUS','I\'ll be here!','',26124),
(121175,'enUS','Hail!','',26124),
(121176,'enUS','Keep walking.','',26124),
(121177,'enUS','Who do you think you\'re speaking to?','',26124),
(121178,'enUS','You\'re starting to annoy me.','',26124),
(121179,'enUS','Odyn\'s chosen or not, I will cleave your skull in two if you keep at it!','',26124),
(121180,'enUS','BAH!','',26124),
(121181,'enUS','YOU ARE MAKING ME ANGRY!!!!','',26124),
(121182,'enUS','The Legion has begun their attack! We must send word to our allies at once.','',26124),
(121183,'enUS','Take cover!','Take cover!',26124),
(121184,'enUS','What was that?!','What was that?!',26124),
(121185,'enUS','The Lunastre Attendant nods to you and calmly exits the tavern.','The Lunastre Attendant nods to you and calmly exits the tavern.',26124),
(121186,'enUS','Hmmmmrrrmmmph!','',26124),
(121187,'enUS','I will put my boot SO FAR up your arse Odyn himself won\'t be able to pry it out!','',26124),
(121188,'enUS','What is it?','',26124),
(121189,'enUS','Is it time to fight?','',26124),
(121190,'enUS','Sylverin raises his chin and strides from the tavern.','',26124),
(121191,'enUS','','I will follow you through. Thank you for allowing me to accompany you.',26124),
(121192,'enUS','','Quel\'vala thonos.  Nobility through tradition. I thank you, outlander.',26124),
(121193,'enUS','Hello there. Good news! My books have arrived at last, well most of them.\n\nYou still look confused, so let me explain again. You see, when we last teleported Dalaran, some of my books were damaged. And so this time I had them fly to our new location. Yes, fly.\n\nUnfortunately, they were halfway over Khaz Modan when we teleported again. Most just arrived last week and are settling back in around the city. A few of them are still on loan to some colleagues, and should return themselves soon. Actually, if they are out much longer I might have to go investigate.','',26124),
(121194,'enUS','We\'ve come to end your reign, Illidan. My people, and all of Outland, shall be free!','',26124),
(121195,'enUS','','I think you will spend quite a bit of time at Valdisdall, $ct. I can now transport you directly there from Skyhold.',26124),
(121196,'enUS','','This area is well protected by the blue dragons. I can now transport you to Azsuna from Skyhold, $ct.',26124),
(121197,'enUS','Gurg urggle blerg\'urk urgle blark.\n\nBlerglearg urk $ct urgle blurg? Glerk! Gurg urggle ble\'blerg, erks ker-blerk, gurgler.\n\n<The wizened murloc softly chuckles to himself, then turns deadly serious:>\n\nGlergurg blergbergle, $n. Gulg ble\'blergle: gurg urggle kek, glup gurg urggle blarkleblag? Blerg?','',26124),
(121198,'enUS','','There\'s a small path through the trees here! I can now transport you to Val\'sharah from Skyhold, $ct.',26124),
(121199,'enUS','','I can see a lot of potential in the surrounding area! I can now transport you to Suramar from Skyhold, $ct.',26124),
(121200,'enUS','Herk! Blargleblag Doomhammer gurg blerklefirk glup urglegurbler.\n\nUrgle glugblag Orgrim, urgle glugblag Thrall, glup urgle glugblag \"$ct $n\" gruggleblurg murgleglub!\n\n<A thin tendril of spittle slowly snakes down from the corner of Morgl\'s mouth. He continues speaking, urgent and unrelentingly:>\n\nMraagggle urg blerg murgleurgleurgle gurk! Wurgleblerg murgle urg? Blerk! Glerg! Mwagle?\n\n<The Oracle gestures to the Doomhammer and beckons you to hand it over.>','',26124),
(121201,'enUS','<Morgl nods, sadly. The old murloc turns away from you to contemplate the undulating grey sea, saying nothing more.>','',26124),
(121202,'enUS','Warg! Gra-blergle! BLEEERRGGHammer!','',26124),
(121203,'enUS','%s begins smashing the Doomhammer around indiscriminately.','',26124),
(121204,'enUS','It is clear that %s has no idea what he is doing.','',26124),
(121205,'enUS','%s gurgles, happily.','',26124),
(121206,'enUS','<Morgl is glad you feel that way. He looks toward the sky contemplatively.>\n\nWarg gurg blergargle mruk, mruk. $ct $n urgle blorglug mragle urk. Mrawgle urg 10,000 blerg \"Ra\" barg urglebleg, urg \"Ra-den\" blek Mogu berkblug.\n\n<His eager attention focuses back on you.>\n\nMrgle urg blurg\'urg gerblagle. Graggle merg blur Gurgle of the Storm. Wurgle! Berk blergle-berk urg grablag. $n: urg garble murk gerblerg? Urk?\n\n<The murloc oracle leans forward, motioning for you to come closer. He wants to whisper something to you. For you... and you alone.>','',26124),
(121207,'enUS','Blerk.','',26124),
(121208,'enUS','<Morgl is puzzled by your response. After composing himself, he continues:>\n\nUrgleblerg mra\'graggle berk urgleblag. Murgle urg grablurg urgle blerg ur Lake Minnetonka burgle bleg. Urg urkegle blerk murgle-gurgle, Azshara glurg\'ug. \n\nGurg blurgle urg-mulurk, \"Sharas\'dal\" gurp blergle urkle-klep. Blergle, $n?\n\n<The Oracle indicates the scepter you carry, then motions urgently for you to hand it to him.>','',26124),
(121209,'enUS','Wurgle! Blerg arglebleg. Murgle urg blerk of Tides!','',26124),
(121210,'enUS','Urg blurgle murgle blek! Wurg $ct $n blergle-blerk. Wurgle, wurg.','',26124),
(121211,'enUS','%s bows deeply in gratitude.','',26124),
(121212,'enUS','<Morgl looks very pleased with himself.>','',26124),
(121213,'enUS','<Nod affirmatively.>','<Nod affirmatively.>',26124),
(121214,'enUS','<Shake your head no.>','<Shake your head no.>',26124),
(121215,'enUS','<Thank him for his time.>','<Thank him for his time.>',26124),
(121216,'enUS','<Loan him the Doomhammer.>','<Loan him the Doomhammer.>',26124),
(121217,'enUS','<Move closer, bring your head close to his, and listen to the Oracle\'s ancient wisdom.>','<Move closer, bring your head close to his, and listen to the Oracle\'s ancient wisdom.>',26124),
(121218,'enUS','<Loan him Sharas\'dal, the Scepter of Tides.>','<Loan him Sharas\'dal, the Scepter of Tides.>',26124),
(121219,'enUS','','Naga have overrun the ruins of Kal\'delar. If they\'re allowed to gain a foothold, they could threaten the entire coastline.',26124),
(121220,'enUS','','Thank you. It is easy to ignore such threats until it is too late to push them back.',26124),
(121221,'enUS','','What the... What jokester spread so many acorns in Lorlathil? I realize this task is of the humble variety, but could you relocate some of those squirrels and crack a few nuts while you\'re at it?',26124),
(121222,'enUS','Look at $n! There goes a rogue with a true sense of style!','Look at $n! There goes a rogue with a true sense of style!',26124),
(121223,'enUS','','That squirrel invasion was nuts. Get it?',26124),
(121224,'enUS','Looking smooth, $n! Real smooth!','Looking smooth, $n! Real smooth!',26124),
(121225,'enUS','Is $n seeing anyone? Do you think I\'d have a chance?','Is $n seeing anyone? Do you think I\'d have a chance?',26124),
(121226,'enUS','','Some wisps have the extraordinary ability to encourage the rapid maturation of saplings into trees. Seek the Hidden Pools and bond with a wisp there.',26124),
(121227,'enUS','','Nature\'s beauty still shines through even in these dire times.',26124),
(121228,'enUS','','I have some high value targets for you. You would do well to call upon our more... unsavory allies.',26124),
(121229,'enUS','','We shall pick apart our enemies piece by piece, like a mana bun. Oh - now I am hungry.',26124),
(121230,'enUS','','A Dream Warden is under attack by the Nightmare! May Elune bless your path as you save the sacred dragon.',26124),
(121231,'enUS','','The Nightmare seeks to corrupt our entire forest!',26124),
(121232,'enUS','','The druids who watch over Emerald Bay haven\'t returned from their patrol. Perhaps the sprites are up to something...',26124),
(121233,'enUS','','They put our druids to sleep in shark-infested waters? I am glad you arrived when you did.',26124),
(121234,'enUS','','The island of Gloaming Reef is the site of a constant battle between murloc and makrura. At times, one side gains an advantage and we have to step in to keep the struggle going.',26124),
(121235,'enUS','','When is Phoe\'be getting here? She said she would be here over an hour ago!',26124),
(121236,'enUS','','Some may think it heartless to slaughter the creatures, but the stalemate must be maintained lest one side will emerge the victor and swim to the mainland.',26124),
(121237,'enUS','','The coffee here is really strong!',26124),
(121238,'enUS','','It is near to birthing season for the hydras along Bradensbrook\'s coastline. We must prevent them from swelling to dangerous numbers so they don\'t pose a threat to the village.',26124),
(121239,'enUS','','The people are safe from hydras, at least for another season.',26124),
(121240,'enUS','Calm down, I\'m sure she will be here soon.','',26124),
(121241,'enUS','Mysterious whispers offer untold power for your services...','Mysterious whispers offer untold power for your services...',26124),
(121242,'enUS','How did you get this invitation? Never mind, the hunt\'s already started!','',26124),
(121243,'enUS','Fine, fine! They went that way. Not that it matters, you will never catch up...','',26124),
(121244,'enUS','','The Nightmare spreads like a pox on the land! We might put a stop to it here before it continues to corrupt Val\'sharah!',26124),
(121245,'enUS','','Now is not the time for a chat. Your temple is under attack!',26124),
(121246,'enUS','','The spread has slowed, thanks to your bravery, $n.',26124),
(121247,'enUS','Look, Marius here can see things that will scare you so stark you\'ll look like me.$b$bBut even he is getting all twitchy about this cave. Something about bad dreams and corrupted elves and whatever.$b$bBah! We tracked a powerful satyr to this cave and I\'ll be damned... more... if we don\'t at least try to enslave it.','',26124),
(121248,'enUS','Who are you? Where is Lord Nimrod and Lady Dyana?','Who are you? Where is Lord Nimrod and Lady Dyana?',26124),
(121249,'enUS','This is our hunt, go away!','This is our hunt, go away!',26124),
(121250,'enUS','That fox rightfully belongs to us!','That fox rightfully belongs to us!',26124),
(121251,'enUS','We will have his pelt, or yours!','We will have his pelt, or yours!',26124),
(121252,'enUS','I\'m ready!','',26124),
(121253,'enUS','Keep your feet on the ground!','',26124),
(121254,'enUS','Talk to me when it\'s time to fight.','',26124),
(121255,'enUS','I\'ll be here!','',26124),
(121256,'enUS','I like ye. Don\'t make me not like ye!','',26124),
(121257,'enUS','Quit playing around!','',26124),
(121258,'enUS','It\'s the shiny runes now isn\'t it?','',26124),
(121259,'enUS','Ye really don\'t know when to stop!','',26124),
(121260,'enUS','All right, put \'em up! Time to teach ye what\'s what!','',26124),
(121261,'enUS','First it was Hodir, then Thorim... now YOU!','',26124),
(121262,'enUS','I thought we... I thought we were friends...','',26124),
(121263,'enUS','*sob*','',26124),
(121264,'enUS','Keep your voice down! There\'s someone here...','',26124),
(121265,'enUS','Sshh! We\'ve got company! Act natural...','',26124),
(121266,'enUS','Sshh! Keep your voice down...','',26124),
(121267,'enUS','Quiet down! Someone is coming...','',26124),
(121268,'enUS','What now?!!','',26124),
(121269,'enUS','My hatred burns!!','',26124),
(121270,'enUS','Get it over with already!','',26124),
(121271,'enUS','If the Legion does not kill you, someday I wil!','',26124),
(121272,'enUS','Leave me be already!','',26124),
(121273,'enUS','Hmmmppph...','',26124),
(121274,'enUS','Go away.','',26124),
(121275,'enUS','This is a bad idea. Demons are one thing, but satyrs? They are night elves given to corruption.','',26124),
(121276,'enUS','Thalyssra said you would be able to help me infiltrate the Twilight Vineyards.','Thalyssra said you would be able to help me infiltrate the Twilight Vineyards.',26124),
(121277,'enUS','GO AWAY!!!','',26124),
(121278,'enUS','I WILL SPIT ON YOUR GRAVE!!!!','',26124),
(121279,'enUS','Yeah yeah. Look, if we hid from every monster that used to be an elf there would be nothing left to hunt. Now calm down and pay attention. We are not alone.','',26124),
(121280,'enUS','How much longer is this going to take?','',26124),
(121281,'enUS','You will not interrupt my sermon!','',26124),
(121282,'enUS','These dropboxes are tricky... I\'ve almost got it.','',26124),
(121283,'enUS','Amber Kearnen was one of our own... I still can\'t believe we had to kill her.','',26124),
(121284,'enUS','When the orders come from Master Shaw himself... you don\'t ask questions.','',26124),
(121285,'enUS','You\'re sure you got her, right? We can\'t afford to mess this up!','',26124),
(121286,'enUS','Ah! Wretched creature. I will see you all bow before me!','',26124),
(121287,'enUS','I told you already... I never miss.','',26124),
(121288,'enUS','We should have killed her back in Citrine Bay. Doing the hit in Dalaran was too risky! We can\'t afford witnesses...','',26124),
(121289,'enUS','Let\'s give these runes a try. A hand, if you would?','',26124),
(121290,'enUS','Gah! I couldn\'t get a good hold on it. But you never know until you try.','',26124),
(121291,'enUS','You can\'t stop us, mage! Your former master opened the way to our victory! Karazhan will be ours!','',26124),
(121292,'enUS','I HATE YOUR DAMN GUTS!!!!','',26124),
(121293,'enUS','I WOULD DIE A THOUSAND DEATHS TO SEE YOU SUFFER!!!!','',26124),
(121294,'enUS','There? No... There! No...','',26124),
(121295,'enUS','WHY COULDN\'T YOU LET ME DIE!!!!!????','',26124),
(121296,'enUS','CURSE YOU!!!! CURSE YOUR MOTHER!!!! I WILL **** REIGENFLA*****DOWN YOUR THROAT******ODYN HIMSELF*****','',26124),
(121297,'enUS','Our enemies are closer than we think.','',26124),
(121298,'enUS','The Legion cannot hide from us.','',26124),
(121299,'enUS','This changes nothing, mage! Your defenses will crumble and your world will burn!','',26124),
(121300,'enUS','Speak, mortal.','',26124),
(121301,'enUS','I am vigilant.','',26124),
(121302,'enUS','I serve Skyhold.','',26124),
(121303,'enUS','The battle is eternal.','',26124),
(121304,'enUS','If you only understood the implications of your actions...','',26124),
(121305,'enUS','Hymdall sees all... knows all!','',26124),
(121306,'enUS','You, on the other hand...','',26124),
(121307,'enUS','I\'m starting to question Odyn\'s choice.','',26124),
(121308,'enUS','Do you ever give up?','',26124),
(121309,'enUS','No, really.','',26124),
(121310,'enUS','I am very close to stuffing the rainbow bridge somewhere... painful.','',26124),
(121311,'enUS','Suit yourself.','',26124),
(121312,'enUS','You need something?','',26124),
(121313,'enUS','Speak, friend.','',26124),
(121314,'enUS','What do you need?','',26124),
(121315,'enUS','May the winds of the north be at your back.','',26124),
(121316,'enUS','Farewell!','',26124),
(121317,'enUS','Stay vigilant!','',26124),
(121318,'enUS','I am Hodir!','',26124),
(121319,'enUS','HODIR!','',26124),
(121320,'enUS','I owe you one but don\'t push it!','',26124),
(121321,'enUS','Cool it!','',26124),
(121322,'enUS','Don\'t make me have to put you on ice, small friend!','',26124),
(121323,'enUS','That\'s cold.','',26124),
(121324,'enUS','Snow big deal.','',26124),
(121325,'enUS','Stay frosty!','',26124),
(121326,'enUS','I greet you, wielder of Talonclaw.','',26124),
(121327,'enUS','','What do you need?',26124),
(121328,'enUS','','I am ready for whatever comes.',26124),
(121329,'enUS','','Spit it out!',26124),
(121330,'enUS','','Keep your blades sharp!',26124),
(121331,'enUS','','There is no fear in our hearts!',26124),
(121332,'enUS','','Until the final battle!',26124),
(121333,'enUS','','You seem nervous.',26124),
(121334,'enUS','','Do I scare you?',26124),
(121335,'enUS','','You have nice hands.',26124),
(121336,'enUS','','Would be a shame if something happened to them.',26124),
(121337,'enUS','I\'ve really, REALLY had enough of that demon!','',26124),
(121338,'enUS','','Maybe you keep those to yourself from now on.',26124),
(121339,'enUS','Out with it already!','',26124),
(121340,'enUS','I\'m ready to fight!','',26124),
(121341,'enUS','Say what you have to say!','',26124),
(121342,'enUS','Keep your sword arm strong!','',26124),
(121343,'enUS','Never retreat!','',26124),
(121344,'enUS','Fight like every battle is the last.','',26124),
(121345,'enUS','What?','',26124),
(121346,'enUS','What was that?','',26124),
(121347,'enUS','I cannot hear you with this helm.','',26124),
(121348,'enUS','Very good at protecting one\'s head. Cannot hear very much though.','',26124),
(121349,'enUS','I will nod in agreement now. Maybe you leave me alone.','',26124),
(121350,'enUS','Greetings, wielder of Talonclaw.','Greetings, wielder of Talonclaw.',26124),
(121351,'enUS','Have you come to aid us with Talonclaw?','Have you come to aid us with Talonclaw?',26124),
(121352,'enUS','Ah, could that be? YES! That\'s it!','',26124),
(121353,'enUS','I am an awesome mage indeed!','',26124),
(121354,'enUS','This should give me something to work with.','',26124),
(121355,'enUS','Demon gets one, too!','',26124),
(121356,'enUS','I need to fly to Acherus at once.','I need to fly to Acherus at once.',26124),
(121357,'enUS','There it is! The giant is holding it! There\'s only one way to separate a giant from its treasure. You know what to do, $n.','',26124),
(121358,'enUS','LANDBORN FILTH! THIEVES! I WILL LEAVE YOU AS A SMUDGE IN MY LAIR!','',26124),
(121359,'enUS','Excellent! Hurry back to Dalaran and meet me in the Chamber of the Guardian. Safe return, $ct.','',26124),
(121360,'enUS','THERE WILL BE AN IN-GAME CINEMATIC HERE!','',26124),
(121361,'enUS','','Hold it, hun! That\'s a deadly drop through that portal! Don\'t go unprepared.',26124),
(121362,'enUS','Let me know when you are ready, but do not tarry.','',26124),
(121363,'enUS','We should not stay here a moment longer than is necessary.\n\nOur safety here is tenuous at best.','',26124),
(121364,'enUS','Let\'s get moving.','Let\'s get moving.',26124),
(121365,'enUS','We should stick together, just in case.','',26124),
(121366,'enUS','Knights of the Ebon Blade, $p, the Ashbringer, Highlord of the Silver Hand, demands audience with your horsemen.','',26124),
(121367,'enUS','You are not the only Highlord here, paladin. What business have you with the Four Horsemen?','',26124),
(121368,'enUS','','They do not belong. Guards! Remove -',26124),
(121369,'enUS','They have honor. Let them speak their piece.','',26124),
(121370,'enUS','Agreed. We can decide what to do with them after we hear their reason for daring to tread here.','',26124),
(121371,'enUS','Show them, Highlord.','',26124),
(121372,'enUS','','By the Deathlord...',26124),
(121373,'enUS','I thought it only myth...','',26124),
(121374,'enUS','You dare bring that here? You can\'t possibly hope to...','',26124),
(121375,'enUS','We do, and we will - with your help. You owe us, Darion.','',26124),
(121376,'enUS','He\'s right. We must try. The Ashbringer is no longer our enemy.','',26124),
(121377,'enUS','So be it. Horsemen, give me your strength. On this day, the Ashbringer will know our power once more!','',26124),
(121378,'enUS','','<Shannon puts her book away as you approach.>',26124),
(121379,'enUS','Good book?','Good book?',26124),
(121380,'enUS','','Hello!\n\nYes!  Quite.',26124),
(121381,'enUS','Are you a member of the Kirin Tor?  What do you do here?','Are you a member of the Kirin Tor?  What do you do here?',26124),
(121382,'enUS','','Oh, I organize the books!  I love it.  \n\nIf I could take them all down and put them back up every day, I would. \n\nBut they got kind of annoyed the last few times.',26124),
(121383,'enUS','Surely it gets a bit boring down here after a while?','Surely it gets a bit boring down here after a while?',26124),
(121384,'enUS','','Hah!  Never.  Not with all these things to read!\n\nAnd I write too.  And make things with my imagination.  Want to see?',26124),
(121385,'enUS','Sure!','Sure!',26124),
(121386,'enUS','','I learned this one from one of the magic tomes... took a few tries to get it right.',26124),
(121387,'enUS','','Anyway, I\'m going to get back to reading.  Nice to have met you!',26124),
(121388,'enUS','<Volpin quivers with fear>','',26124),
(121389,'enUS','<Volpin leaps with joy>','',26124),
(121390,'enUS','','<Shannon is reading intently.>',26124),
(121391,'enUS','You did it! You made the voices stop.','',26124),
(121392,'enUS','This portal will take you to the Exodar. Good luck, $ct.','',26124),
(121393,'enUS','Mine will be the last face you see!','',26124),
(121394,'enUS','I will die before I talk!','I will die before I talk!',26124),
(121395,'enUS','You will get nothing from me!','You will get nothing from me!',26124),
(121396,'enUS','Lowborn scum! I will never talk!','Lowborn scum! I will never talk!',26124),
(121397,'enUS','Keep your eyes open for eyes in here. Inquisitors love their eyes.','',26124),
(121398,'enUS','I\'d like to upgrade my gear.','I\'d like to upgrade my gear.',26124),
(121399,'enUS','I yield! I\'ll tell you anything!','I yield! I\'ll tell you anything!',26124),
(121400,'enUS','Corvyn... he does our dirty work. You\'ll find him down near the docks.','Corvyn... he does our dirty work. You\'ll find him down near the docks.',26124),
(121401,'enUS','House Stelleris does not answer to lowborn scum like you.','',26124),
(121402,'enUS','My life... for House Stelleris...','',26124),
(121403,'enUS','The raven caws at you in disapproval.','',26124),
(121404,'enUS','Bah! That thing was so bossy.','',26124),
(121405,'enUS','No, this is all wrong. I... I have been here before, but that would mean...','',26124),
(121406,'enUS','IT CANNOT BE!','',26124),
(121407,'enUS','Heroes we mustn\'t kill Rakeesh! Stop! Please!','',26124),
(121409,'enUS','If you will not spare him then I must stop you!','',26124),
(121410,'enUS','He\'s left us no choice, Velen! If we don\'t destroy the machine this place and every living soul inside will be annihilated!','He\'s left us no choice, Velen! If we don\'t destroy the machine this place and every living soul inside will be annihilated!',26124),
(121411,'enUS','Havi\'s companion doesn\'t seem to like you for some reason.','',26124),
(121412,'enUS','The raven expresses its displeasure at your presence.','',26124),
(121413,'enUS','This is all your fault...','',26124),
(121414,'enUS','My fault? I said \"eye\" not \"I\" you blind git!','',26124),
(121415,'enUS','','My... that was close. Let me spare a bit of my magic for you, as a gesture of thanks.',26124),
(121416,'enUS','','Be swift where our enemies are slow. And... thank you. You spared my mind an ugly fate.',26124),
(121417,'enUS','','May this be the edge you need to bring justice to Suramar.',26124),
(121418,'enUS','Greetings, $c. The Highlord says you are to be welcomed as a guest, so long as you don\'t cause trouble.','Greetings, $c. The Highlord says you are to be welcomed as a guest, so long as you don\'t cause trouble.',26124),
(121419,'enUS','I... I am rekindled. You are most generous. I spare for you a bit of my magic, to bolster your abilities in combat.','',26124),
(121420,'enUS','Burn bright, and hit the enemy where they least expect.','',26124),
(121421,'enUS','Sear justice into the minds of those who would endanger Suramar.','',26124),
(121422,'enUS','Hello.  Nice to meet you.','',26124),
(121423,'enUS','What are you up to?','What are you up to?',26124),
(121424,'enUS','This city has a bug problem.  They\'re everywhere!  \n\nI\'m an engineer.  An automation engineer to be exact.  And I\'m trying to help out a bit.','',26124),
(121425,'enUS','And who\'s this little fellow?','And who\'s this little fellow?',26124),
(121426,'enUS','This is Wintron!  \n\nIt seemed a bit tedious to walk around trying to find bugs one by one, so I made him to find them for me.  \n\nGood little guy.  Snorts a lot, but that\'s fine with me.','',26124),
(121427,'enUS','','To the High Priest!',26124),
(121428,'enUS','','To the High Priest!',26124),
(121429,'enUS','Do not underestimate me!','',26124),
(121430,'enUS','My blades will be your end.','',26124),
(121431,'enUS','Another weakling come to party!','',26124),
(121432,'enUS','Need any help?','Need any help?',26124),
(121433,'enUS','Naw, Wintron can handle it.\n\nThank you though!\n\nIt was a pleasure meeting you.','',26124),
(121434,'enUS','You won\'t know what hit you!','',26124),
(121435,'enUS','','I sense a nurturing spirit within you, kind one.',26124),
(121436,'enUS','','I hear your call, druid. What do you seek?',26124),
(121437,'enUS','In the shadows, we are connected to those unseen.','',26124),
(121438,'enUS','I see before me a mighty beast! What do you ask of me, $Gbrother:sister;?','',26124),
(121439,'enUS','','Light speed you, $ct.',26124),
(121440,'enUS','<The blind shaman hears your footfalls as you approach. He does not turn to face you.>\nYou are not a shaman. Tread lightly here, $c, for the very stones themselves watch your every move.','',26124),
(121441,'enUS','<The blind shaman hears your footfalls as you approach. He reaches up to touch your face.>\n\nAlliance. Hmmm... $r, yes. <Cough> Perhaps we once met on the field of battle.\n\nI heard the call of the elements long, long ago. Another place. Another time. <Cough> I can see the spirits shining within you... I sense the very wind and waves bending to your will. Powerful, yes. Your Alliance must be very proud to have you.\n\nThese are the dark times, $r. But your strength gives this old orc hope. Perhaps I can return the favor... <Cough>... if you are not too proud to accept the aid of a former foe...','',26124),
(121442,'enUS','<The blind shaman hears your footfalls as you approach. He reaches up to touch your face.>\n\nAh, $ct. I recognize your confident stride. <Cough>. The spirits walk in step with you, united in purpose.\n\nAges have passed since I first heard the call of the elements on Draenor. Did you go back? I heard there were some that went back... somehow... <Wheeze>. I could not bear to see my old home as it was. Before the darkness. The war.\n\nYes, but you did not come to me to hear the ramblings of an old orc. You do not judge me as the others do. My age... <Cough> this chair... I am not the frail thing the others see. My power is all around me, amongst the stones and the wind.','',26124),
(121443,'enUS','<Receive Drek\'Thar\'s blessing.>','<Receive Drek\'Thar\'s blessing.>',26124),
(121444,'enUS','','Grand Artificer Romuul yet lives, sir!',26124),
(121445,'enUS','Good. Find Romuul. Tell him to begin repairs on the vessel. We are going home.','',26124),
(121446,'enUS','Brother, I come...','',26124),
(121447,'enUS','Yer sword arm looks soft, $ct.','',26124),
(121448,'enUS','It is done. Consider us even, Highlord.','',26124),
(121449,'enUS','Thank you, Darion. Your father would be proud.','',26124),
(121450,'enUS','Never speak of him in my presence again, paladin. Now begone, and never return!','',26124),
(121451,'enUS','Take you home?','',26124),
(121452,'enUS','Please take us back to Dalaran.','Please take us back to Dalaran.',26124),
(121453,'enUS','I\'ll meet you back at the Sanctum of Light, $p.','',26124),
(121454,'enUS','Thank you, friend. I am well enough to rejoin the fight!','Thank you, friend. I am well enough to rejoin the fight!',26124),
(121455,'enUS','My thanks, druid. This battle is not over!','My thanks, druid. This battle is not over!',26124),
(121456,'enUS','My injuries were severe, but now I can press on!','My injuries were severe, but now I can press on!',26124),
(121457,'enUS','I feel much better now. Thank you, druid.','I feel much better now. Thank you, druid.',26124),
(121458,'enUS','My injuries were severe, but now I can press on!','',26124),
(121459,'enUS','I feel much better now. Thank you, druid.','',26124),
(121460,'enUS','They will write sagas about your valor!','',26124),
(121461,'enUS','Please don\'t call the guards. I came to honor Vol\'jin, not to cause trouble.$b$bHe was a friend. We fought side by side against great odds. I owe that troll my life.$b$bWe once swore to each other that, should one of us be killed, the other would avenge him. Always thought he\'d outlive me...$b$bWhatever it takes, I\'m going to make good on my promise.','',26124),
(121462,'enUS','','Leave me alone. I\'m working. There may be hostiles in the crowd.',26124),
(121463,'enUS','','We cannot lose hope, $ct. If we somehow defeat the Legion, it will take a new generation of shaman to heal this scorched world.',26124),
(121464,'enUS','','Do I look like I want to die? Again, I mean?$b$bIf you\'re curious about the Blightcaller\'s visage, you can ask him yourself. Or the Dark Lady, for that matter. They\'re ever so fond of small talk.$b$b<The dark ranger smirks as she resumes her watch.>',26124),
(121465,'enUS','Do you know why Nathanos looks... different?','Do you know why Nathanos looks... different?',26124),
(121466,'enUS','I summoned an air elemental the other day! I think.\n\nI burped REAL loud.','If you\'re like a really really good shaman, can you summon, like� an ice cream elemental?',26124),
(121467,'enUS','Fire. FIRE! Fire\'s the best. I like fire.','',26124),
(121468,'enUS','Someday I\'ll be a big hero like $ct $n!','Earthcaller Yevaa is so smart. She says her world was taken over by demons, but she ran away to fight them. Do you fight the demons, $n?',26124),
(121469,'enUS','','The element of water represents tranquility or renewal. But we must be careful, for water spirits can be very fickle.',26124),
(121470,'enUS','','If one can speak with the winds, one can listen for news from far away. With enough control, a shaman can also harness the fury of a thunderstorm.',26124),
(121471,'enUS','','Journeyman Goldmine was also once a student of mine. But don\'t let that discourage you.',26124),
(121472,'enUS','','The earth grounds us in all things. If we are one with the earth, we will be to our enemies as unyielding as a mountain.',26124),
(121473,'enUS','','Most associate the element of fire with destruction, but in gentle hands, fire can cook our food or warm our homes. Students, how will you use fire?',26124),
(121474,'enUS','Not now!','',26124),
(121475,'enUS','I\'m here to ensure the Warchief\'s protection. Draw your weapon against her and you\'ll be dead before the first drop of your blood hits the ground.$b$bAs for anything else... it doesn\'t concern you. Understood?','',26124),
(121476,'enUS','There\'s something different about you, Blightcaller...','There\'s something different about you, Blightcaller...',26124),
(121477,'enUS','So I tried that totem-puzzle-game thing again.','',26124),
(121478,'enUS','A relentless cascade of failures and lowered expectations, culminating in a deep pit of existential despair.','',26124),
(121479,'enUS','It\'s fire! It\'s water! It\'s fire! It\'s water! Somehow I changed one to an earth totem and Puzzlemaster Lo kicked me out.','',26124),
(121480,'enUS','My meager initial hopes seemed laughable after hours of crushing denial blearily beat into me the soul-wrenching realization of abject failure.','',26124),
(121481,'enUS','As the tides forever beat toward the shore, so too, I ceaselessly toil in the face of diminishing success, nourished only by the salt of my tears.','',26124),
(121482,'enUS','You should... stop playing that game.','',26124),
(121483,'enUS','Buck up, little friend. Next time you will do better.','',26124),
(121484,'enUS','You need, perhaps, a vacation.','',26124),
(121485,'enUS','How did you do this time?','',26124),
(121486,'enUS','Th... the rage, it clouds my thoughts no more! Thank you, Nahlen\'do!','',26124),
(121487,'enUS','So goes a good leader, and a good friend. I look forward to battling with him in the Halls of Valor when my time comes.','',26124),
(121488,'enUS','Why the boat?','Why the boat?',26124),
(121489,'enUS','I want to ask something else.','I want to ask something else.',26124),
(121490,'enUS','It was once our custom to send a Jarl like this into the sea and set the boat ablaze. But since the mists claimed our shores, we dare not send him out lest he return as a kvaldir.','',26124),
(121491,'enUS','Citizens of Azeroth.','',26124),
(121492,'enUS','Today is the day we turn the tide.','',26124),
(121493,'enUS','Today is the day that we re-take our world.','',26124),
(121494,'enUS','And send the Legion back to the hell that spawned them.','',26124),
(121495,'enUS','Our path is clear.','',26124),
(121496,'enUS','The Pillars of Creation await.','',26124),
(121497,'enUS','On the Broken Isles!','',26124),
(121498,'enUS','Highlord! We must do something before it\'s too late!','',26124),
(121500,'enUS','Ha! My bear will tear your musken into tiny pieces!','',26124),
(121501,'enUS','You! Puny one! We will fight to decide the strongest beast!','',26124),
(121502,'enUS','The manasaber takes off running!','The manasaber takes off running!',26124),
(121504,'enUS','','We will make the Legion pay for what they\'ve done!',26124),
(121505,'enUS','You can be replaced, if you grow weary.','You can be replaced, if you grow weary.',26124),
(121506,'enUS','The Vineyard Laborer glances fearfully over his shoulder and rushes back to work.','The Vineyard Laborer glances fearfully over her shoulder and rushes back to work.',26124),
(121507,'enUS','I am not tired. Please forgive me.','I am not tired. Please forgive me.',26124),
(121508,'enUS','Very good.','Very good.',26124),
(121509,'enUS','We await your request.','We await your request.',26124),
(121510,'enUS','','Fool! You would think to succeed where even I, chosen of Sargeras, had failed?',26124),
(121511,'enUS','','All who have tried to tame Ulthalesh have been consumed. You will fare no better!',26124),
(121512,'enUS','','Ulthalesh will devour you!',26124),
(121514,'enUS','','You will join the harvested!',26124),
(121515,'enUS','','Ulthalesh feasts!',26124),
(121516,'enUS','','Impossible... you will be... consumed...',26124),
(121517,'enUS','Highlord, it seems we are all in agreement, but yours is the final word. What should we do?','',26124),
(121518,'enUS','We will defend Netherlight Temple.','We will defend Netherlight Temple.',26124),
(121522,'enUS','Greetings, $c.\n\nGreymane has instructed me to keep the barracks open to any of our allies in Stormheim. If you need use of one of our beds, let me know.','',26124),
(121523,'enUS','These orcish buildings may not have the comfort of an Undercity crypt, but wood logs travel much better than crumbling stone.','',26124),
(121526,'enUS','For the Horde!','For the Horde!',26124),
(121527,'enUS','All hail Warchief Sylvanas!','All hail Warchief Sylvanas!',26124),
(121528,'enUS','Blood and honor!','Blood and honor!',26124),
(121529,'enUS','Vengeance for Vol\'jin!','Vengeance for Vol\'jin!',26124),
(121530,'enUS','Victory against the Legion!','Victory against the Legion!',26124),
(121531,'enUS','Remember the Broken Shore!','Remember the Broken Shore!',26124),
(121532,'enUS','Down with the Alliance!','Down with the Alliance!',26124),
(121533,'enUS','The Horde endures!','The Horde endures!',26124),
(121534,'enUS','The demons will fall!','The demons will fall!',26124),
(121536,'enUS','Boldly said. But I remain... unconvinced.','',26124),
(121537,'enUS','The time has come! The moment is at hand!','',26124),
(121538,'enUS','You are not prepared!','',26124),
(121539,'enUS','Outsiders, here?!','Outsiders, here?!',26124),
(121541,'enUS','Guards!  Save us!','Guards!  Save us!',26124),
(121542,'enUS','Bring the Vineyards to heel. I will tolerate no more insubordination.','',26124),
(121543,'enUS','Please, don\'t hurt us.','Please, don\'t hurt us.',26124),
(121544,'enUS','','Hail, $n. I bear an important message from Odyn!',26124),
(121545,'enUS','','Odyn awaits your arrival. His forces stand at the ready!',26124),
(121546,'enUS','','$n. There you are. I have something to tell you.',26124),
(121547,'enUS','','Battlelord Gaardoun said that it was a matter of utmost importance.',26124),
(121548,'enUS','','He requested that you return to the Fel Hammer as soon as you can.',26124),
(121549,'enUS','Now that I know you\'re real, I suppose I can continue to train you. I can trade you recipes, if you have crafting materials!','',26124),
(121552,'enUS','','Psst, $n. Come closer, I have something to tell you.',26124),
(121553,'enUS','Who pulled aggro?!?!','Who pulled aggro?!?!',26124),
(121554,'enUS','I have ankh!','I have ankh!',26124),
(121555,'enUS','','Lord Ravenholdt has something important to discuss with you.',26124),
(121556,'enUS','I think Johnny is afk...','I think Johnny is afk...',26124),
(121557,'enUS','Misdirect the tank!','Misdirect the tank!',26124),
(121558,'enUS','RESURRECT THE WARLOCK, WE NEED HIM FOR THE LAST PHASE!','RESURRECT THE WARLOCK, WE NEED HIM FOR THE LAST PHASE!',26124),
(121559,'enUS','','He is asking that you return to the Chamber of Shadows immediately.',26124),
(121560,'enUS','WORLD FIRST!!!','WORLD FIRST!!!',26124),
(121561,'enUS','WoOoOOOoOO!!!','WoOoOOOoOO!!!',26124),
(121562,'enUS','If the glaive drops, can I have it?','If the glaive drops, can I have it?',26124),
(121564,'enUS','SPREAD OUT!','SPREAD OUT!',26124),
(121565,'enUS','Focus, guys. USE POTIONS NOW!','Focus, guys. USE POTIONS NOW!',26124),
(121566,'enUS','Does anyone have some extra potions?','Does anyone have some extra potions?',26124),
(121567,'enUS','Where... were... my heals...','',26124),
(121568,'enUS','With my last breath... I blame our tank...','',26124),
(121569,'enUS','I never should have let the hunter shoot first...','',26124),
(121570,'enUS','','I heal wounds, not foolery...',26124),
(121571,'enUS','How did they see me...','',26124),
(121572,'enUS','You see? We don\'t have to go to a dungeon to find good loot. Dibs on its gloves!','',26124),
(121573,'enUS','How\'s the fighting out there, $c? Seen anything worth skinnin\'?','',26124),
(121577,'enUS','','My students\' skills will blow you away!',26124),
(121578,'enUS','I would like to requisition a Squad of Apprentices.','I would like to requisition a Squad of Apprentices.',26124),
(121579,'enUS','I would like to requisition a Squad of Conjurors.','I would like to requisition a Squad of Conjurors.',26124),
(121580,'enUS','Greetings, Archdruid. I bring news from the Dreamgrove.','',26124),
(121581,'enUS','Excellent, Archdruid. Swift travels.','',26124),
(121582,'enUS','Grandmaster, I have been looking for you!','',26124),
(121583,'enUS','I look forward to seeing you at the Wandering Isle, Grandmaster.','',26124),
(121584,'enUS','','Highlord, a moment of your time, please.',26124),
(121585,'enUS','','We look forward to your return to Light\'s Hope Chapel.',26124),
(121586,'enUS','%s runs away in terror!','%s runs away in terror!',26124),
(121587,'enUS','Ahh, thank you.','',26124),
(121588,'enUS','My wits return.','',26124),
(121589,'enUS','Eugh... wh.. wha? Oh - it is you! Thank you, outlander.','',26124),
(121590,'enUS','I should hope you never experience that pain...','',26124),
(121591,'enUS','Not withering today, it seems.','',26124),
(121592,'enUS','Blech. How did we live before the Nightwell?','',26124),
(121593,'enUS','A drop in the ocean of my thirst... But appreciated, nonetheless.','',26124),
(121594,'enUS','Still here... for now.','',26124),
(121595,'enUS','','What?!',26124),
(121596,'enUS','|TINTERFACE\\ICONS\\Spell_Arcane_PrismaticCloak:20|t Arcanist Tel\'arn begins to cast |cFFF00000|Hspell:218807|h[Call of Night]|h|r!','',26124),
(121597,'enUS','|TINTERFACE\\ICONS\\Spell_Arcane_PrismaticCloak:20|t Solarist Tel\'arn begins to cast |cFFF00000|Hspell:223437|h[Collapse of Night]|h|r!','',26124),
(121598,'enUS','Blasted demons! Such wanton destruction... there\'s no profit in it!','',26124),
(121599,'enUS','The Nightmare\'s spread has gone further than we thought. I must meditate on this, Archdruid.','',26124),
(121600,'enUS','Do you wish to train Zealots?','Do you wish to train Zealots?',26124),
(121601,'enUS','Do you wish to train Dark Zealots?','Do you wish to train Dark Zealots?',26124),
(121602,'enUS','Lord Tash\'irel has stolen tomes from my library. His delusions of grandeur will bring ruin to us all. Bring those tomes back to me at once!','',26124),
(121603,'enUS','Got anything explosive for sale?','Got anything explosive for sale?',26124),
(121604,'enUS','','I wonder who painted this? It\'s incredible!',26124),
(121605,'enUS','','I must have this, the detail is outstanding!',26124),
(121606,'enUS','','This piece is just exquisite.',26124),
(121607,'enUS','<Gain Warpwalking for 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>','<Gain Warpwalking for 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>',26124),
(121608,'enUS','','Random? Do you not find it striking that each body found is decorated with a dawn lily? The same flower adored by Thalyssra?',26124),
(121609,'enUS','Leave us alone!  Ahhhhh!','Leave us alone!  Ahhhhh!',26124),
(121610,'enUS','... But nobody came.','... But nobody came.',26124),
(121611,'enUS','','You are nearly there now, outlander. Oculeth should be waiting for you on the other side of this chamber.',26124),
(121612,'enUS','','Once again, I ask you to take the withered into Falanaar. Teach them to fight, and to search for relics that can aid our cause.',26124),
(121613,'enUS','Spend 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Warpwalking?','Spend 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Warpwalking?',26124),
(121614,'enUS','<Arluin nods to you.>','',26124),
(121615,'enUS','My eyes and ears are open. I can speak on what I know... for a price.','',26124),
(121616,'enUS','Open for business.','',26124),
(121617,'enUS','I am always open to a productive working relationship.','',26124),
(121618,'enUS','Let\'s say... 800 of that Ancient Mana substance I\'ve been hearing so much about.','',26124),
(121619,'enUS','Save your hollow threats, $c. I am defeated and have nothing more for your pathetic \"order.\"','Save your hollow threats, $c. I am defeated and have nothing more for your pathetic \"order.\"',26124),
(121620,'enUS','You\'ve been to the Dreamgrove? Have you set eyes on Mylune? She graces my dreams.','',26124),
(121621,'enUS','Enough... enough...','Enough... enough...',26124),
(121622,'enUS','You. The one they call $ct. So this \"Earthen Ring\" answers to you now, is that right?$b$bWell, we are the Grimtotem! My tribe has been speaking to the elements for a hundred generations. By what right do you claim this sacred space as your own?$b$bThe resources you hoard here are ours as much as anyone\'s. By orders of Elder Crone Magatha, I am taking our share!','You. The one they call $ct. So this \"Earthen Ring\" answers to you now, is that right?$b$bWell, we are the Grimtotem! My tribe has been speaking to the elements for a hundred generations. By what right do you claim this sacred space as your own?$b$bThe resources you hoard here are ours as much as anyone\'s. By orders of Elder Crone Magatha, I am taking our share!',26124),
(121623,'enUS','Challenge accepted, \"$ct.\"','Challenge accepted, \"$ct.\"',26124),
(121624,'enUS','\"Earthen Ring.\" Bah. More like the \"Dirt Circle.\"','\"Earthen Ring.\" Bah. More like the \"Dirt Circle.\"',26124),
(121625,'enUS','\"Earthen Ring.\" Hah! More like a... \"Loop of Filth.\"','\"Earthen Ring.\" Hah! More like a... \"Loop of Filth.\"',26124),
(121626,'enUS','\"Earthen Ring.\" Pah. Ought to be called... the \"Grimy Crescent.\" Or something.','\"Earthen Ring.\" Pah. Ought to be called... the \"Grimy Crescent.\" Or something.',26124),
(121627,'enUS','\"Earthen Ring.\" Pfft! You guys put the \"Sham\" in \"Shaman.\"','\"Earthen Ring.\" Pfft! You guys put the \"Sham\" in \"Shaman.\"',26124),
(121628,'enUS','\"Earthen Ring.\" As if. More like a... \"Dirty Disk.\" Like a... mudpie. Like a - I don\'t know. You guys are terrible.','\"Earthen Ring.\" As if. More like a... \"Dirty Disk.\" Like a... mudpie. Like a - I don\'t know. You guys are terrible.',26124),
(121629,'enUS','What will your Earthen Ring do after they watch me defeat their precious $ct? Maybe they\'ll give that weapon of yours to Magatha. Hah hah!','What will your Earthen Ring do after they watch me defeat their precious $ct? Maybe they\'ll give that weapon of yours to Magatha. Hah hah!',26124),
(121630,'enUS','\"Earthen Ring.\" Ridiculous! More like a \"Hoop of Fools.\" Hah.','\"Earthen Ring.\" Ridiculous! More like a \"Hoop of Fools.\" Hah.',26124),
(121631,'enUS','\"Earthen Ring.\" Don\'t make me laugh. HAH HAH. Too late. I\'m laughing now. I\'m laughing at your sorry little knitting circle.','\"Earthen Ring.\" Don\'t make me laugh. HAH HAH. Too late. I\'m laughing now. I\'m laughing at your sorry little knitting circle.',26124),
(121632,'enUS','Enough... I yield...','Enough... I yield...',26124),
(121633,'enUS','Yes, \"$ct,\" the Grimtotem are here. Or are Grimtotem shaman not welcome in your little club? Leave me be!','Yes, \"$ct,\" the Grimtotem are here. Or are Grimtotem shaman not welcome in your little club? Leave me be!',26124),
(121634,'enUS','The forest whispered of your arrival, $c. It speaks of one who would become a champion of nature, a kindred spirit to these woods.$b$bThere are some who do not show the proper reverence for our sacred grove. You, however, guide their path.','',26124),
(121635,'enUS','Bwah-hah hah HAH! By the look on your face, the only element you\'ve mastered is the element of SURPRISE. Hah!','Bwah-hah hah HAH! By the look on your face, the only element you\'ve mastered is the element of SURPRISE. Hah!',26124),
(121636,'enUS','You have cleared the Dreamway of the Nightmare, but it now infests my precious vale with its corruption.','',26124),
(121637,'enUS','','It is... you... I saw you in my slumber, pursued by shadows. I have awoken, only to find those shadows reaching into our world.',26124),
(121638,'enUS','Your people are owed nothing. I challenge you to combat!','Your people are owed nothing. I challenge you to combat!',26124),
(121643,'enUS','<Gain Leyline Mastery for 80 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>','<Gain Leyline Mastery for 80 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>',26124),
(121644,'enUS','<Gain Leyline Mastery for 70 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>','<Gain Leyline Mastery for 70 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>',26124),
(121645,'enUS','<Gain Leyline Mastery for 60 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>','<Gain Leyline Mastery for 60 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>',26124),
(121646,'enUS','<Gain Leyline Mastery for 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>','<Gain Leyline Mastery for 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>',26124),
(121647,'enUS','<Gain Leyline Mastery for 40 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>','<Gain Leyline Mastery for 40 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>',26124),
(121648,'enUS','<Gain Leyline Mastery for 30 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>','<Gain Leyline Mastery for 30 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>',26124),
(121649,'enUS','<Gain Leyline Mastery for 20 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>','<Gain Leyline Mastery for 20 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>',26124),
(121650,'enUS','<Gain Leyline Mastery for 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>','<Gain Leyline Mastery for 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>',26124),
(121651,'enUS','Spend 80 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?','Spend 80 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?',26124),
(121652,'enUS','Spend 70 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?','Spend 70 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?',26124),
(121653,'enUS','Spend 60 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?','Spend 60 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?',26124),
(121654,'enUS','Spend 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?','Spend 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?',26124),
(121655,'enUS','Spend 40 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?','Spend 40 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?',26124),
(121656,'enUS','Spend 30 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?','Spend 30 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?',26124),
(121657,'enUS','Spend 20 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?','Spend 20 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?',26124),
(121658,'enUS','Spend 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?','Spend 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Leyline Mastery?',26124),
(121659,'enUS','Ouch.','Ouch.',26124),
(121660,'enUS','Resurrection, please!','Resurrection, please!',26124),
(121661,'enUS','Rebirth, please.','Rebirth, please.',26124),
(121662,'enUS','Are there any more rezzes?','Are there any more rezzes?',26124),
(121663,'enUS','I didn\'t have a soulstone?!','I didn\'t have a soulstone?!',26124),
(121664,'enUS','I was not prepared.','I was not prepared.',26124),
(121665,'enUS','How did I die to that?!','How did I die to that?! I was NOWHERE near it!',26124),
(121667,'enUS','Come, my minions. Deal with this traitor as he deserves!','',26124),
(121668,'enUS','I will deal with these mongrels! Strike now, friends! Strike at the Betrayer!','',26124),
(121669,'enUS','I be knowin\' Citrine Bay. I be knowin\' it well.','',26124),
(121670,'enUS','I\'ll be off on ahead \'n search fer clues. I\'ll wait fer ye thar!','',26124),
(121671,'enUS','Them ships belong to th\' Red Blade! Thar be no doubt \'bout it...','',26124),
(121672,'enUS','Ye get th\' spiced rum... \'n I\'ll find us some scallywags!','',26124),
(121673,'enUS','These be not th\' Red Blade\'s waters... who sent ye, laddie?','',26124),
(121674,'enUS','Aye, this letter be writ\' in no ordinary code. This here code be t\' work o\' a true master!','',26124),
(121675,'enUS','Tethys \'o th\' Blood Sail Buccaneers!','',26124),
(121676,'enUS','Now I\'ll only ask ye one more the hour... who sent ye?','',26124),
(121677,'enUS','We\'ve got what we be needin\' here. Ye be off to Dalaran, I\'ll catch up!','',26124),
(121678,'enUS','SI:7 be sailin\' wit\' th\' Red Blade? \'tis be not jolly news...','',26124),
(121679,'enUS','Yo-ho! Yo-ho-ho! I likes t\' drink me rum!','',26124),
(121680,'enUS','I... I\'m myself again!! Thank you, Nahlen\'do! May the rage never claim you.','',26124),
(121681,'enUS','The rage... it no longer claims me! Praise Elune that you found me master of the fang, or as we in the pack say, Nahlen\'do.','',26124),
(121682,'enUS','My mind is still hazy but I remember combat... ah yes... we were battling the satyr when the rage overtook me.','',26124),
(121683,'enUS','My hands! My legs! I\'m... I\'m whole again! Wait... is that the Scythe of Elune? Thank you for releasing me, Nahlen\'do!','',26124),
(121685,'enUS','I have a target for you. Act quickly. This is a serious threat to our resistance.','',26124),
(121686,'enUS','Your quick action has saved many lives. We are in your debt.','',26124),
(121687,'enUS','','There are traitors to the Grand Magistrix hiding right under our noses. We will find them, and we will end this resistance!',26124),
(121688,'enUS','','If the citizens will not obey, we will rule by strength and fear. The resistance to the Grand Magistrix is coming to an end!',26124),
(121689,'enUS','Archimonde, you will not be allowed further! The very soul of Azeroth rises against you!','',26124),
(121690,'enUS','The veil is lifted from my eyes, heroes. The shadows retreat, and the Dream beckons.','',26124),
(121691,'enUS','This shipment is worth more than you are! How dare you treat it so carelessly!','',26124),
(121692,'enUS','My hand slipped! Forgive me!','',26124),
(121693,'enUS','','As a feral druid your main weapon is shapeshifting. In Cat Form, your claws and fangs rip and bleed your opponents.',26124),
(121694,'enUS','I remember when the world was simpler. Where one could be a hero just by driving kobolds away from their home.$b$bAnd I remember a time when respect was shown to one\'s elders, a time before this troll outsider and his youthful... trolling.','',26124),
(121695,'enUS','I cannot remember what happened after except that I and a few others of my kind awoke and together we traveled as a pack through the Emerald Dream. After some time we arrived in this land and each went our separate ways.','',26124),
(121696,'enUS','Dis ol\' bull be mired in his ol\' ways. He be too happy about it. I aim ta\' fix that, mon.$b$bDer be some harsh truths about dis world. Harsh truths that be wipin\' the smile off one\'s face like a slap from one\'s mama.','',26124),
(121697,'enUS','Hmm. They say dem waterfalls be too busy, mon. Ya can\'t tell where dey be comin\' from or goin\' to.','',26124),
(121699,'enUS','Hmm. Ya know, mon, dey say this place be mighty brown. I know many places greenah\' than this.','',26124),
(121700,'enUS','Hmm. Ya see them trees over there? They be sayin\' them trees too dark, mon. Dark be bad, they say.','',26124),
(121701,'enUS','Hmm. Ya know, mon, I be thinkin\' ya need a change of scenery. Should visit Westfall if ya into browns.','',26124),
(121702,'enUS','The sooner you turn over your allies... the sooner your pain will cease.','',26124),
(121703,'enUS','We will find out who resists the Legion in Suramar. Confess, and I will kill you before you lose your mind.','',26124),
(121704,'enUS','Please... somebody stop this madness.','',26124),
(121705,'enUS','I\'m innocent! I supported the Grand Magistrix!','',26124),
(121706,'enUS','I\'ll do anything... just let me go!','',26124),
(121707,'enUS','Thank you, heroes.','',26124),
(121708,'enUS','Run while you still can!','',26124),
(121709,'enUS','Flee! We\'re saved!','',26124),
(121710,'enUS','Now\'s our chance! Run away!','',26124),
(121711,'enUS','Nahlen\'do, if you encounter more of my people I beg you, release them from their rage as you did for me.','',26124),
(121712,'enUS','Merciful Elune, the rage is gone! Thank you, Nahlen\'do!','',26124),
(121713,'enUS','Is... is this real? I\'m in control of myself again! Bless you, Nahlen\'do!','',26124),
(121714,'enUS','My mind is free again! I\'m in your debt, Nahlen\'do!','',26124),
(121715,'enUS','The curse... it\'s... gone! Thank you, Nahlen\'do!','',26124),
(121716,'enUS','The darkness is leaving my mind! I... I\'m whole again! Thank you, Nahlen\'do!','',26124),
(121717,'enUS','Welcome, $ct.$b$bThis chamber will house a record of your achievements. As you collect various shamanic armor sets and weapon appearances, they will be displayed here.$b$bWe are all counting on you, $ct!','',26124),
(121718,'enUS','Elune bless you.','Elune bless you.',26124),
(121719,'enUS','I am rejuvenated. Thank you.','I am rejuvenated. Thank you.',26124),
(121720,'enUS','Thank you, Archdruid. We must win this battle!','Thank you, Archdruid. We must win this battle!',26124),
(121721,'enUS','I thought I had returned to the earth. Thank you, Archdruid.','I thought I had returned to the earth. Thank you, Archdruid.',26124),
(121722,'enUS','By Elune\'s grace, I can go on. My thanks, Archdruid.','By Elune\'s grace, I can go on. My thanks, Archdruid.',26124),
(121723,'enUS','I will never forget this, Archdruid. My deepest thanks.','I will never forget this, Archdruid. My deepest thanks.',26124),
(121724,'enUS','','Behold, the enemy is among us!',26124),
(121725,'enUS','','You cannot hide what you truly are, demon!',26124),
(121726,'enUS','','More of them are in our midst!',26124),
(121727,'enUS','Is this it, mortals? Is this all the fury you can muster?','',26124),
(121728,'enUS','I will not be touched by rabble such as you!','',26124),
(121729,'enUS','Behold the Flames of Azzinoth!','',26124),
(121730,'enUS','Stare into the eyes of the Betrayer!','',26124),
(121731,'enUS','Maiev... How is it even possible?','',26124),
(121732,'enUS','You have won... Maiev. But the huntress... is nothing without the hunt. You... are nothing... without me.','',26124),
(121733,'enUS','Behold the power... of the demon within!','',26124),
(121734,'enUS','','You discovered us too late, Illidari! FELBLADE, ATTACK!',26124),
(121735,'enUS','Hmm.','',26124),
(121736,'enUS','Hmmmmm.','',26124),
(121737,'enUS','|TInterface\\Icons\\Spell_Fire_LavaSpawn:20|t Xioliang is |cFFFF0404|Hspell:224588|h[Heating Up]|h|r! Move him to the pool!','|TInterface\\Icons\\Spell_Fire_LavaSpawn:20|t Xioliang is |cFFFF0404|Hspell:224588|h[Heating Up]|h|r! Move him to the pool!',26124),
(121738,'enUS','Now is not the time.','',26124),
(121739,'enUS','You should take care of yourself, $c. These are dangerous times.','',26124),
(121740,'enUS','','We must bolster our ranks. Seek out the withered and soothe their rage. I will beckon them to Shal\'Aran.',26124),
(121741,'enUS','','Fine work. I have no doubt that each of them would be proud to help our cause.',26124),
(121742,'enUS','Let\'s keep moving!','Let\'s keep moving!',26124),
(121743,'enUS','ENGAGING IN 5!','ENGAGING IN 5!',26124),
(121744,'enUS','4','4',26124),
(121745,'enUS','3','3',26124),
(121746,'enUS','2','2',26124),
(121747,'enUS','1','1',26124),
(121748,'enUS','INCOMING!','INCOMING!',26124),
(121750,'enUS','Nice weapon you have there, $n. Speak with Jace and Allari if you\'d like to help.','',26124),
(121751,'enUS','Archmage Khadgar? $n? An unexpected surprise.','',26124),
(121752,'enUS','','Thanks again for saving my hide from those sea giants, $n.',26124),
(121753,'enUS','Welcome to my tavern. Sorry for the mess, I am not a morning person...','',26124),
(121754,'enUS','It looks like your studies are coming along nicely. Keep up the good work.','',26124),
(121755,'enUS','Study your hardest, and someday you\'ll surpass even myself!','',26124),
(121756,'enUS','Your work will help create a whole new generation of astrologers!','',26124),
(121757,'enUS','I\'m ready.','I\'m ready.',26124),
(121758,'enUS','','Their fury pales before mine, Illidan. We have some unsettled business between us.',26124),
(121759,'enUS','','My long hunt is finally over. Today, justice will be done!',26124),
(121760,'enUS','','It is finished. You are beaten.',26124),
(121761,'enUS','','He\'s right. I feel nothing... I am... nothing.',26124),
(121762,'enUS','','Farewell, champions.',26124),
(121763,'enUS','You need something fixed?','',26124),
(121764,'enUS','$n, it is good that you are here. The matron mother has been providing our forces with transport from the Fel Hammer as we attempt to shore up our defenses here.\n\nThe Burning Legion have taken Faronaar across the isthmus. I have a plan to contain and crush them before they overrun all of Azsuna.\n\nI could use your help in leading the Illidari to victory.','',26124),
(121765,'enUS','','Hello, $c. I trust that you are here to aid the Illidari in destroying the Burning Legion?',26124),
(121766,'enUS','','Hello, $n. With you here to lead us, the Legion on Faronaar will fall in short order.',26124),
(121767,'enUS','$g Milord:Milady; $n. We are most grateful that you have come to lead us to victory against the Burning Legion.','',26124),
(121768,'enUS','We are in your debt, $c, for aiding in the fight against the Legion.','',26124),
(121769,'enUS','We need to get down there, $n. Your Illidari need our help to destroy the Burning Legion.\n\nOnce we\'ve done that, we can get to our business with the Pillar of Creation here on Azsuna.','',26124),
(121770,'enUS','While you are leading your Illidari forces in their fight against the demons, I will figure out what our next move is here on Azsuna.\n\nWe must track down that Pillar of Creation. I know it is here somewhere.','',26124),
(121771,'enUS','','Thank you for your help over on Faronaar, $n. I am embarrassed that one of our own turned traitor and became one of the Felsworn for the Burning Legion.\n\nWe will make them pay.',26124),
(121772,'enUS','We need them focused on defeating the Legion, not fostering old hatreds.','',26124),
(121773,'enUS','','Thank you for saving us over on Faronaar, $n.\n\nI can\'t believe that Cyana turned traitor. She betrayed us all. There are others who have also become Felsworn. We will hunt them down and kill them along with their new Legion masters.\n\nThis I swear!',26124),
(121774,'enUS','My apologies, $n. I was injured when I first came here to scout the Legion forces on Faronaar.\n\nIs there anything else that I can do for you?','',26124),
(121775,'enUS','','$n, how goes the fight? Do you need supplies or anything repaired?',26124),
(121776,'enUS','','$n, the Burning Legion is sending the most powerful demons in its arsenal against us. They do not intend to lose this third war and they will stop at nothing to see to it that we are all wiped from the face of Azeroth.\n\nTogether, we will return the favor.',26124),
(121777,'enUS','While your generosity did indeed satisfy before, I must insist.\n\nYou know how it is- the economy is constantly in flux, people are dying in the streets- it\'s only business.\n\nAs much mana as you can carry. That is my going rate.\n\n<Arluin smiles sweetly.>\n\nUnless of course you don\'t WANT my help.','',26124),
(121778,'enUS','Offer: 1200x |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t|Hcurrency:1155|h|cFFFFFFFF Ancient Mana|h|r','Offer: 1200x |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t|Hcurrency:1155|h|cFFFFFFFF Ancient Mana|h|r',26124),
(121779,'enUS','This action will remove 1200 Ancient Mana. Do you want to continue?','This action will remove 1200 Ancient Mana. Do you want to continue?',26124),
(121780,'enUS','I enjoy practicing a bit of statecraft. You might say I have a knack for it.','',26124),
(121781,'enUS','Please... please help me...','Please... please help me...',26124),
(121782,'enUS','Those who get on these boats never return... please don\'t let them take me.','Those who get on these boats never return... please don\'t let them take me.',26124),
(121783,'enUS','I don\'t want to die, but they kill anyone who runs.','I don\'t want to die, but they kill anyone who runs.',26124),
(121784,'enUS','Don\'t let them take me!','Don\'t let them take me!',26124),
(121785,'enUS','They rounded us up like livestock. I do not know where they are sending us, but I know I do not want to go. Please...','They rounded us up like livestock. I do not know where they are sending us, but I know I do not want to go. Please...',26124),
(121786,'enUS','','Well hello, my dear. I hope you don\'t mind. Altruis asked me to help bring some of your forces here.\n\nIt would seem that the Legion has quite the foothold on that island over there. He thought it best that we not let them take all of Azsuna.\n\nDon\'t worry, I\'m transporting the Illidari back and forth from the Fel Hammer as needs require. Your forces are ready to pick up and go wherever you need them at a moment\'s notice.',26124),
(121787,'enUS','','Well hello, my dear. I hope you don\'t mind. Kayn asked me to help bring some of your forces here.\n\nIt would seem that the Legion has quite the foothold on that island over there. He thought it best that we not let them take all of Azsuna.\n\nDon\'t worry, I\'m transporting the Illidari back and forth from the Fel Hammer as needs require. Your forces are ready to pick up and go wherever you need them at a moment\'s notice.',26124),
(121788,'enUS','Arluin beckons you over.','',26124),
(121789,'enUS','Over here- I found something.','',26124),
(121790,'enUS','My swarm will destroy you!','',26124),
(121791,'enUS','Go to sleep. Forget everything.','',26124),
(121792,'enUS','When do we destroy the world? Soon? I hope it\'s soon.','',26124),
(121793,'enUS','You will all be my slaves! Er, I mean, hi!','',26124),
(121794,'enUS','If you have any excess priceless artifacts that were lost in time, I\'m making a collection.','',26124),
(121795,'enUS','Buh-bye now!','',26124),
(121796,'enUS','A tactical retreat, eh?','',26124),
(121797,'enUS','Kill you later... I mean, bye!','',26124),
(121798,'enUS','What? Stop that!','',26124),
(121799,'enUS','I\'m holding myself back... for now!','',26124),
(121800,'enUS','Don\'t say I didn\'t warn ya!','',26124),
(121801,'enUS','Is this what you usually spend your free time on? Seems like a poor use of your time.','Is this what you usually spend your free time on? Seems like a poor use of your time.',26124),
(121802,'enUS','You know this place is actually quite pleasant. We should go burn something.','You know this place is actually quite pleasant. We should go burn something.',26124),
(121803,'enUS','Did you know that on my world imps are tortured for fun? I was quite proficient at it myself.','Did you know that on my world imps are tortured for fun? I was quite proficient at it myself.',26124),
(121804,'enUS','There is a legend that some of our ancestors can be found on this world that are not part of the Legion. I bet they are boring.','There is a legend that some of our ancestors can be found on this world that are not part of the Legion. I bet they are boring.',26124),
(121805,'enUS','Man are my arms getting tired.','Man are my arms getting tired.',26124),
(121806,'enUS','Good, I had been meaning to find you.','Good, I had been meaning to find you.',26124),
(121807,'enUS','You know, I knew you needed more orders.','You know, I knew you needed more orders.',26124),
(121808,'enUS','Let\'s see, what can I order you to do today...','Let\'s see, what can I order you to do today...',26124),
(121809,'enUS','Do you see now, human? This fate of this world is sealed. The legion cannot be stopped.','',26124),
(121810,'enUS','The Gaze of the Legion is upon you! Flee!','The Gaze of the Legion is upon you! Flee!',26124),
(121811,'enUS','|TInterface\\Icons\\inv_bannerpvp_01.blp:20|t You gain |cFFFF0000|Hspell:224811|h[For the Horde]|h|r!','|TInterface\\Icons\\inv_bannerpvp_01.blp:20|t You gain |cFFFF0000|Hspell:224811|h[For the Horde]|h|r!',26124),
(121812,'enUS','Uh... $g master:mistress;...','',26124),
(121813,'enUS','Is this a prank? Am I being pranked? Very funny, $g master:mistress;!','',26124),
(121814,'enUS','<Gain Ward of the First Arcanist for 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>','<Gain Ward of the First Arcanist for 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana.>',26124),
(121815,'enUS','Spend 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Ward of the First Arcanist?','Spend 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:20|t Ancient Mana to gain Ward of the First Arcanist?',26124),
(121816,'enUS','This isn\'t a joke? B... But this is the heart of evil and darkness in the universe! Surely, you can\'t be serious!','',26124),
(121817,'enUS','Don\'t think of us as smugglers. Instead, refer to us as professional salvors.\n\nWe are salvage experts. We specialize in flotsam, jetsam, lagan, derelicts, and, of course, exotic archaeological recovery.\n\nOh, and by the way, you might want to steer clear of the temple area to the south. I have my men investigating some salvage opportunities and I wouldn\'t want you to be confused for a competitor.\n\n<Mr. Shackle makes the sign of the Uncrowned, gives you the secret handshake, and then winks.>\n\nStay as long as you like, $g Mister:Miss; $n.','',26124),
(121818,'enUS','','We need to keep it contained at all costs!',26124),
(121819,'enUS','','Keep it contained!',26124),
(121820,'enUS','','Focus! It must not be allowed to escape!',26124),
(121821,'enUS','','This land is ours now!',26124),
(121822,'enUS','','No... it cannot be!',26124),
(121823,'enUS','','Crrggghaaawww!',26124),
(121824,'enUS','','The Witchmother commands it!',26124),
(121825,'enUS','','We will not be stopped!',26124),
(121826,'enUS','','Flesh and bone to earth and stone!',26124),
(121827,'enUS','','Flay the flesh and scatter the bones!',26124),
(121828,'enUS','','You cannot... escape... the curse!',26124),
(121829,'enUS','Soon, I will be able to provide Seals of Broken Fate for Gold or Order Resources.  I have none to offer to you at this time.','',26124),
(121830,'enUS','','Fool! Die!',26124),
(121831,'enUS','','Ahh... curse you!',26124),
(121832,'enUS','','Behold my curse!',26124),
(121833,'enUS','','This land... is.. ours...',26124),
(121834,'enUS','','Squaaak! I\'ll tear you apart!',26124),
(121835,'enUS','','Rip the flesh from its bones!',26124),
(121836,'enUS','','This land... is.. ours...',26124),
(121837,'enUS','','Squaaak! You\'ll regret this!',26124),
(121838,'enUS','','Shred its flesh! Scraaawk!',26124),
(121839,'enUS','','I\'ll enjoy killing you!',26124),
(121840,'enUS','Thank you for your aid, $n. I give you the authority to speak to the demon hunters on my behalf.','',26124),
(121841,'enUS','','Scraaawk! Make it bleed!',26124),
(121842,'enUS','','None shall survive!',26124),
(121843,'enUS','','Craaawwkk!',26124),
(121844,'enUS','You already have the maximum number of seals! Use the seals you have before bothering me for more.','',26124),
(121845,'enUS','','Sisters! Avenge me...',26124),
(121846,'enUS','','No... Squaaggk!',26124),
(121847,'enUS','','Curses upon you!',26124),
(121848,'enUS','','Coward! You\'ll pay for this...',26124),
(121849,'enUS','','No! NO! Craaawwkk...',26124),
(121850,'enUS','','The village is... ours...',26124),
(121851,'enUS','The Horde isn\'t so bad. Gnomes, on the other hand...','',26124),
(121852,'enUS','Oh, the stories I could tell! Great skirmishes in the forests of Ashenvale, all out chaos in the Northern Foothills, riding with dragons across the skies of Outland, breakfast in Orgrimmar.','',26124),
(121853,'enUS','Ever date a Tauren? Don\'t.','',26124),
(121854,'enUS','The cavalry\'s here.','',26124),
(121855,'enUS','Get back to work.','',26124),
(121856,'enUS','Ever fight a Yeti with nothing but a Skinning Knife? Don\'t.','',26124),
(121857,'enUS','Heard there are some pirates at the Pig and Whistle Tavern. Could be fun.','',26124),
(121858,'enUS','Do you know who the greatest warrior is? I\'ll give you one guess.','',26124),
(121859,'enUS','Get him, get him, get him!!!','Get him, get him, get him!!!',26124),
(121860,'enUS','No, not that one. That One!!!','No, not that one. That One!!!',26124),
(121861,'enUS','Daglop shakes his head.','Daglop shakes his head.',26124),
(121862,'enUS','Wow, you are not very good at this.','Wow, you are not very good at this.',26124),
(121863,'enUS','Are you trying to get hit?','Are you trying to get hit?',26124),
(121864,'enUS','This is pathetic, my old master, I mean that filthy Eredar demon, he didn\'t even get hit this much.','This is pathetic, my old master, I mean that filthy Eredar demon, he didn\'t even get hit this much.',26124),
(121865,'enUS','As much fun as it is telling you what to do... I will just come back and do it more later.','As much fun as it is telling you what to do... I will just come back and do it more later.',26124),
(121866,'enUS','Never fear, I will have more directions for you later.','Never fear, I will have more directions for you later.',26124),
(121867,'enUS','Do try and be alive when I have need of you next.','Do try and be alive when I have need of you next.',26124),
(121868,'enUS','This contract is binding, I will be back.','This contract is binding, I will be back.',26124),
(121869,'enUS','Some day I will be your master and you will have to listen to me!!','Some day I will be your master and you will have to listen to me!!',26124),
(121870,'enUS','You are not one of my minions? But, sure I can tell you what to do.','You are not one of my minions? But, sure I can tell you what to do.',26124),
(121871,'enUS','Who gave you their contract? I will deal with them later, for now go over there!','Who gave you their contract? I will deal with them later, for now go over there!',26124),
(121872,'enUS','My apologies, $n. Supply shipments are on hold for now.','My apologies, $n. Supply shipments are on hold for now.',26124),
(121873,'enUS','You\'ll be hard pressed to find a shop that\'s still open, $n.','You\'ll be hard pressed to find a shop that\'s still open, $n.',26124),
(121874,'enUS','Now is not the time, I\'m afraid.','Now is not the time, I\'m afraid.',26124),
(121875,'enUS','Sorry, $n. My stock isn\'t currently available.','Sorry, $n. My stock isn\'t currently available.',26124),
(121876,'enUS','My apologies, $n. We were ordered to hold our supplies until further notice.','My apologies, $n. We were ordered to hold our supplies until further notice.',26124),
(121877,'enUS','I\'m sorry. I have nothing to offer at the moment.','I\'m sorry. I have nothing to offer at the moment.',26124),
(121878,'enUS','What I wouldn\'t give to get my hands on some new supplies, $n.$B$BIt may be a while. We\'re on strict orders not to buy, sell or trade until things settle down.','What I wouldn\'t give to get my hands on some new supplies, $n.$B$BIt may be a while. We\'re on strict orders not to buy, sell or trade until things settle down.',26124),
(121879,'enUS','Sorry, $n. Come back and see me when things have calmed.','Sorry, $n. Come back and see me when things have calmed.',26124),
(121880,'enUS','No need to worry, $n. Training will continue. But for now, we must focus the matters at hand.','No need to worry, $n. Training will continue. But for now, we must focus the matters at hand.',26124),
(121881,'enUS','I\'m afraid I cannot help you right now, $n. We have been asked to remain alert at all times.','I\'m afraid I cannot help you right now, $n. We have been asked to remain alert at all times.',26124),
(121882,'enUS','I do wish I could assist you in your training, but now is not the time, $n. My apologies.','I do wish I could assist you in your training, but now is not the time, $n. My apologies.',26124),
(121883,'enUS','Training will resume shortly, $n. You have my word.','Training will resume shortly, $n. You have my word.',26124),
(121884,'enUS','In due time, $n. For now, we must remain vigilant.','In due time, $n. For now, we must remain vigilant.',26124),
(121885,'enUS','Be on your guard, $n. We\'ve been asked to put the safety of our visitors above all else until things settle down.','Be on your guard, $n. We\'ve been asked to put the safety of our visitors above all else until things settle down.',26124),
(121886,'enUS','Grant me a vision of the Walled City of Highmaul.','Grant me a vision of the Walled City of Highmaul.',26124),
(121887,'enUS','Grant me a vision of the Arcane Sanctum of Highmaul.','Grant me a vision of the Arcane Sanctum of Highmaul.',26124),
(121888,'enUS','Grant me a vision of the Imperator\'s Rise atop Highmaul.','Grant me a vision of the Imperator\'s Rise atop Highmaul.',26124),
(121889,'enUS','Grant me a vision of the Blackrock Foundry\'s Black Forge.','Grant me a vision of the Blackrock Foundry\'s Black Forge.',26124),
(121890,'enUS','Grant me a vision of the Blackrock Foundry\'s Slagworks.','Grant me a vision of the Blackrock Foundry\'s Slagworks.',26124),
(121891,'enUS','Grant me a vision of the Blackrock Foundry\'s Iron Assembly.','Grant me a vision of the Blackrock Foundry\'s Iron Assembly.',26124),
(121892,'enUS','Grant me a vision of Blackhand\'s Crucible within the Blackrock Foundry.','Grant me a vision of Blackhand\'s Crucible within the Blackrock Foundry.',26124),
(121893,'enUS','Grant me a vision of the Hellbreach, before the gates of Hellfire Citadel.','Grant me a vision of the Hellbreach, before the gates of Hellfire Citadel.',26124),
(121894,'enUS','Grant me a vision of the Hellfire Citadel\'s Halls of Blood.','Grant me a vision of the Hellfire Citadel\'s Halls of Blood.',26124),
(121895,'enUS','Grant me a vision of the Hellfire Citadel\'s Bastion of Shadows.','Grant me a vision of the Hellfire Citadel\'s Bastion of Shadows.',26124),
(121896,'enUS','Grant me a vision of the Destructor\'s Rise atop Hellfire Citadel.','Grant me a vision of the Destructor\'s Rise atop Hellfire Citadel.',26124),
(121897,'enUS','Grant me a vision of Archimonde\'s fall at the Black Gate.','Grant me a vision of Archimonde\'s fall at the Black Gate.',26124),
(121898,'enUS','Soon, you will welcome death with open arms!','',26124),
(121899,'enUS','Raaarrgh...','',26124),
(121900,'enUS','Master...','',26124),
(121901,'enUS','Pity. You could have joined us...','',26124),
(121902,'enUS','The dark beyond... awaits me.','',26124),
(121903,'enUS','Madness beckons me beyond...','',26124),
(121904,'enUS','Humor me... scream for help!','',26124),
(121905,'enUS','You do not see, but you will.','',26124),
(121906,'enUS','I will send you to eternal sleep.','',26124),
(121907,'enUS','It stirs, faceless, forgotten... deathless.','',26124),
(121908,'enUS','You cannot... escape... your dreams....','',26124),
(121909,'enUS','Your world is... doomed...','',26124),
(121910,'enUS','This land is doomed!','',26124),
(121911,'enUS','The Nightmare... welcomes me...','',26124),
(121912,'enUS','My life... for the master...','',26124),
(121913,'enUS','The master will destroy... your soul!','',26124),
(121914,'enUS','Will the night elves mourn you, I wonder?','',26124),
(121915,'enUS','Give up! There is no hope for this world...','',26124),
(121916,'enUS','Fool... this land is already doomed...','',26124),
(121917,'enUS','Foolish mortal! You cannot win...','',26124),
(121918,'enUS','Death will not... stop us...','',26124),
(121919,'enUS','Without hope, there can be no despair.','',26124),
(121920,'enUS','Terror is all that awaits... you...','',26124),
(121921,'enUS','Welcome to your nightmare!','',26124),
(121922,'enUS','Mine are not the only hands... stained in blood...','',26124),
(121923,'enUS','You cannot escape the Nightmare Lord\'s grasp!','',26124),
(121924,'enUS','Your resistance is futile!','',26124),
(121925,'enUS','Become prey to the darkness!','',26124),
(121926,'enUS','You cannot stop us. We are Legion!','',26124),
(121927,'enUS','Looking for a fight? Allow me...','',26124),
(121928,'enUS','Our master will burn this world... and you with it!','',26124),
(121929,'enUS','You would die for this pathetic land?','',26124),
(121930,'enUS','Your torment will be endless!','',26124),
(121931,'enUS','Nightmare consume you!','',26124),
(121932,'enUS','You cannot stop what is coming. Even in your dreams.','',26124),
(121933,'enUS','If I cannot bend your mind, I will break your body.','',26124),
(121934,'enUS','The abyss whispers your name.','',26124),
(121935,'enUS','You were warned.','',26124),
(121936,'enUS','Let me show you what happens to heroes.','',26124),
(121937,'enUS','All in good time.','',26124),
(121938,'enUS','What is it you seek?','',26124),
(121939,'enUS','I have missed good conversation.','',26124),
(121940,'enUS','Contemplate the leaves, my friend.','',26124),
(121941,'enUS','The woods protect you.','',26124),
(121942,'enUS','<The wind rider\'s wings flap in anticipation of the coming battle>','<The wind rider\'s wings flap in anticipation of the coming battle>',26124),
(121943,'enUS','It is not my time, but, sadly, it is yours.','',26124),
(121944,'enUS','Forgive me for what I do.','',26124),
(121945,'enUS','I must have more power if we are to win this battle...','',26124),
(121946,'enUS','I require your life energies, my dutiful Moon Guard.','',26124),
(121947,'enUS','Sire, the Legion\'s disruption of our long-range teleportation network has made travel... challenging.','',26124),
(121948,'enUS','Keep a watchful eye, $n... thar be a band \'o pirates yonder!','',26124),
(121949,'enUS','','I accept your pledge of loyalty, $n. The Horde endures!',26124),
(121950,'enUS','Indeed it shall.','',26124),
(121951,'enUS','Well said!','',26124),
(121952,'enUS','We are ready to begin the mission.','We are ready to begin the mission.',26124),
(121953,'enUS','Truthguard...','',26124),
(121954,'enUS','The Silver Hand...','',26124),
(121955,'enUS','You must remain at the Temple Summit!','You must remain at the Temple Summit!',26124),
(121956,'enUS','I, Master Mathias Shaw, hereby authorize The Red Blade to hunt down the rogue agent Amber Kearnen.','',26124),
(121957,'enUS','Bring me her head, and The Red Blade will have full access to Stormwind Bay and a royal pardon for past crimes committed.','',26124),
(121958,'enUS','I\'ll... I\'ll never tell ye!','',26124),
(121959,'enUS','Now that ye mention it... ye does look somewhat familiar.','',26124),
(121960,'enUS','Oh god no! I\'ve heard of you... please don\'t kill me!','',26124),
(121961,'enUS','It was SI:7! They offered us the riches of Stormwind in exchange for Amber Kearnen!','',26124),
(121962,'enUS','While you\'re out there we\'ll try to secure a location closer to the shrine. Elune guide you, $n.','',26124),
(121963,'enUS','I think... I just soiled myself! Please... don\'t kill me!','',26124),
(121964,'enUS','You cannot... escape... your dreams....','',26124),
(121965,'enUS','Soon, you will welcome death with open arms!','',26124),
(121966,'enUS','Our master will burn this world... and you with it!','',26124),
(121967,'enUS','Terror is all that awaits... you...','',26124),
(121968,'enUS','Raaarrgh...','',26124),
(121969,'enUS','Mine are not the only hands... stained in blood...','',26124),
(121970,'enUS','Death will not... stop us...','',26124),
(121971,'enUS','Give up! There is no hope for this world...','',26124),
(121972,'enUS','Your world is... doomed...','',26124),
(121973,'enUS','','Shhh... keep your voice down! If anyone sees us talking, we\'re dead meat!',26124),
(121974,'enUS','Master...','',26124),
(121975,'enUS','You cannot escape the Nightmare Lord\'s grasp!','',26124),
(121976,'enUS','This land is doomed!','',26124),
(121977,'enUS','Noggenfogger sent me. I need to break into the safe.','Noggenfogger sent me. I need to break into the safe.',26124),
(121978,'enUS','Your resistance is futile!','',26124),
(121979,'enUS','You do not see, but you will.','',26124),
(121980,'enUS','You were warned.','',26124),
(121981,'enUS','You cannot stop us. We are Legion!','',26124),
(121982,'enUS','Will the night elves mourn you, I wonder?','',26124),
(121983,'enUS','Looking for a fight? Allow me...','',26124),
(121984,'enUS','Pity. You could have joined us...','',26124),
(121985,'enUS','You would die for this pathetic land?','',26124),
(121986,'enUS','The Nightmare... welcomes me...','',26124),
(121987,'enUS','Welcome to your nightmare!','',26124),
(121988,'enUS','If you\'re here lookin\' for trouble, I don\'t want any part of it... who am I kidding? Anything would pay better than this!','',26124),
(121989,'enUS','Fool... this land is already doomed...','',26124),
(121990,'enUS','Trixyni sent me. I need the key to the safe... she says you \"owe her.\"','Trixyni sent me. I need the key to the safe... she says you \"owe her.\"',26124),
(121991,'enUS','Become prey to the darkness!','',26124),
(121992,'enUS','','Sorry, $n. With all that\'s going on it looks like I won\'t be cutting hair for a while. Most of the other merchants have closed up their shops too.$B$B<Looks around to the other merchants.>$B$BWord on the street is there\'s something happening, and it ain\'t just around here. The cities themselves are full of... well, I don\'t know and I better not start talking too much. I wouldn\'t want to see anyone else on edge around here. We\'ve got enough of that as is.',26124),
(121993,'enUS','I will send you to eternal sleep.','',26124),
(121994,'enUS','Your torment will be endless!','',26124),
(121995,'enUS','Nightmare consume you!','',26124),
(121996,'enUS','You cannot stop what is coming. Even in your dreams.','',26124),
(121997,'enUS','Humor me... scream for help!','',26124),
(121998,'enUS','Let me show you what happens to heroes.','',26124),
(121999,'enUS','If I cannot bend your mind, I will break your body.','',26124),
(122000,'enUS','My life... for the master...','',26124),
(122001,'enUS','The dark beyond... awaits me.','',26124),
(122002,'enUS','The master will destroy... your soul!','',26124),
(122003,'enUS','Foolish mortal! You cannot win...','',26124),
(122004,'enUS','Without hope, there can be no despair.','',26124),
(122005,'enUS','It stirs, faceless, forgotten... deathless.','',26124),
(122006,'enUS','The abyss whispers your name.','',26124),
(122007,'enUS','Madness beckons me beyond...','',26124),
(122008,'enUS','','It\'s been awfully quiet since the move. Perhaps they\'re still feeling the effects. Moving all of Dalaran is no easy task!$B$BI do hope things return to normal soon.',26124),
(122009,'enUS','If ye ask me, there\'s a foulness in the air. E\'er since we arrived here people \'ave been showin\' all kinds of odd behavior. And the Council... they\'ve been meeting quite often. Hopin\' all is well.','',26124),
(122010,'enUS','I\'m ready.','I\'m ready.',26124),
(122011,'enUS','Take care.','',26124),
(122012,'enUS','Who dat sneakin\' around?!','',26124),
(122013,'enUS','Somebody sneakin\' around here!','',26124),
(122014,'enUS','What dat noise?','',26124),
(122015,'enUS','My liege! A stranger approaches, wielding a weapon that bears the mark of Queen Azshara herself.','My liege! A stranger approaches, wielding a weapon that bears the mark of Queen Azshara herself.',26124),
(122016,'enUS','Somebody sneakin\' around nearby!','',26124),
(122017,'enUS','Come out where I can sees you! Coward!','',26124),
(122018,'enUS','I know you there.. show yourself!','',26124),
(122019,'enUS','Somebody is skulking around!','',26124),
(122020,'enUS','There you is! Now you gunna get it!!','',26124),
(122021,'enUS','I found you! Now you gunna die!','',26124),
(122022,'enUS','I gunna beat you to a pulp!','',26124),
(122023,'enUS','You sneakin\' around makes me so ANGRY!','',26124),
(122024,'enUS','','That scepter is not yours, shaman. Give it back!',26124),
(122025,'enUS','You not supposed to be here!','',26124),
(122026,'enUS','We gots an intruder!','',26124),
(122027,'enUS','','That scepter belongs to our Queen...',26124),
(122028,'enUS','You gunna pay for sneakin\' around!','',26124),
(122029,'enUS','','How dare you claim our beloved Queen\'s scepter as your own...',26124),
(122030,'enUS','','Not yours... that scepter is not yours...',26124),
(122031,'enUS','','Please, Death Knight. Do not defile this sacred place with that wicked axe you wield. I can feel its hunger from here.',26124),
(122032,'enUS','','We are all that stands between the legion and annihilation.',26124),
(122033,'enUS','This is going to be a heist of a lifetime!','',26124),
(122034,'enUS','We\'ll have love-struck schlubs throwin\' their money at us in no time!','',26124),
(122035,'enUS','','Every time we blink I have to spend days rearranging my collection. I wish there was an easier way to clean this mess up.',26124),
(122036,'enUS','','Lord Illidan knows the way.',26124),
(122037,'enUS','','Hit up Izak the bartender, he should know how to get the key to the safe.',26124),
(122038,'enUS','','If he won\'t talk, just remind him that he owes me one for \'the you know what\' in \'the you know where\'... got it?',26124),
(122039,'enUS','','Azeroth must not fall.',26124),
(122040,'enUS','','Those blades you carry... they are cursed. Please, do not bring the chill of death to this sacred place!',26124),
(122041,'enUS','Death to the Legion.','',26124),
(122042,'enUS','Today is your lucky day, friend! Even as we speak, Gallywix is enjoying a relaxing stop in his personal sauna.','',26124),
(122043,'enUS','If you sneak into the sauna, you can grab the key while he isn\'t wearing it!','',26124),
(122044,'enUS','No text','',26124),
(122045,'enUS','Listen, up mooks! The pleasure palace is OFF LIMITS! I don\'t want ANYBODY setting foot on my property!','',26124),
(122046,'enUS','Placeholder text.','',26124),
(122047,'enUS','That axe you carry... it is a Legion weapon. Are you certain you can control its hunger?','',26124),
(122048,'enUS','Now, I\'m going to hit the sauna for some R&R... so bring me a frozen cocktail and some cocoa butter!','',26124),
(122049,'enUS','Mooks! Where\'s my cocoa butter?! What part of COCOA and BUTTER did you not get?!','',26124),
(122050,'enUS','All right! I\'m ready to bust some skulls!','',26124),
(122051,'enUS','Whew... it\'s gettin\' hot in here. I think it\'s time for a relaxing nap...','',26124),
(122052,'enUS','Wait a minute.. one of my keys is... SOMEBODY STOLE THE KEY TO MY SAFE!','',26124),
(122053,'enUS','Whoever did this is gonna pay! Mooks! Find them! FIND THEM!','',26124),
(122054,'enUS','','Is that... the Maw of the Damned? Turning one of the Legion\'s weapons against their own, are we? I like the way you think, $n!',26124),
(122055,'enUS','What is this blasphemy, $n? How dare you reforge that cursed blade, the very sword that damned Lordaeron and its prince? I warned Arthas not to touch Frostmourne, and now I\'m warning you: cast those things into the sea before they damn us all.','',26124),
(122056,'enUS','','So the rumors around Undercity are true - Frostmourne has been reforged! You watch yourself $n. Those blades may have a mind of their own.',26124),
(122057,'enUS','An aura of disease and pestilence surround the blade you carry, Death Knight. Keep your distance from Senegos.','',26124),
(122058,'enUS','','That demonic blade you carry - it reeks of corruption, Death Knight. Finish your business here and take that blade far away from this sacred temple.',26124),
(122059,'enUS','','Ugggh - that blade - what is that you carry? Disease and rot surround you, Death Knight!',26124),
(122060,'enUS','','Do you feel it too? My skin is crawling...',26124),
(122061,'enUS','Do you know what is happening?','Do you know what is happening?',26124),
(122062,'enUS','','Ahhh!',26124),
(122063,'enUS','','It would be wise to refrain from make this inn your home for the time being. We may not be this exact location the next time you try to return.',26124),
(122064,'enUS','Hmm... Got nothing, $n. All shipments on hold until further notice.$B$BEntire place is ruined. Blinking a city... Who said that was a good idea? It will take weeks to get this place back on its feet.','',26124),
(122065,'enUS','Pardon the mess. We\'ve been cleaning up for a while now.$B$B<Peers around his shop>. Though it doesn\'t seem to help much. This place looks like a gust of wind blew right through here. And my goods are damaged. Who will want them now?$B$BThe next time we decide to move the city I\'ll be strapping everything down ahead of time.','',26124),
(122066,'enUS','','Oh, I didn\'t see you there!$B$BWe\'ve been so busy cleaning up. Come and see us once we\'re back on our feet.',26124),
(122067,'enUS','','All these papers. How did we e\'er keep track of \'em? Now they\'re just scattered all o\'er the place.$B$BIt\'ll take weeks fer me ta get \'em all sorted again!',26124),
(122068,'enUS','','You\'ll have to excuse me. These bouts of dizziness catch me off guard every so often. They started shortly after our arrival.',26124),
(122069,'enUS','Welcome to the shop, $n. Pardon the mess. We\'re in the process of cleaning up.$B$BThat last blink really did a number on us!','',26124),
(122070,'enUS','Why is this cocoa butter so slippery? GET ME A TOWEL! Whoever bought the slippery cocoa butter is FIRED!','',26124),
(122071,'enUS','','Say the word and I shall reveal the hidden menace!',26124),
(122072,'enUS','','By the Light... what could it mean?',26124),
(122073,'enUS','','Turalyon and Alleria... I cannot believe they\'ve been alive all these years...',26124),
(122074,'enUS','I would not have believed it if I hadn\'t seen it with my own eyes.','',26124),
(122075,'enUS','Arator is right. Turalyon and Alleria went to great lengths to send us this warning. Highlord, we look to you. What should we do?','',26124),
(122076,'enUS','','I have heard much of these two heroes. There is little doubt in my mind that their message is of the utmost importance.',26124),
(122077,'enUS','Mother... Father...','',26124),
(122078,'enUS','The Beacon was silent for time, no aid did it ask for. It is good that you restored it.','',26124),
(122079,'enUS','Of all its users, the draenei have wielded the Beacon the best. It is hoped the draenei survive where the others have not.','',26124),
(122080,'enUS','Your staff, like Velen\'s crystal, is a gift we bestow on those we try to save from destruction. So few remain, do not let it fall to the Void.','',26124),
(122081,'enUS','Welcome aboard, $n. \n\nWe\'re all stocked and ready to ship out just as soon as you\'re ready.','',26124),
(122082,'enUS','Use the Beacon often, the power of the Light is unending and will always be given.','',26124),
(122083,'enUS','$n! I see you\'ve reclaimed the blades of Varedis Felsoul. Let us hope you have better control over the demon within you.','$n! I see you\'ve reclaimed the blades of Varedis Felsoul. Let us hope you have better control over the demon within you.',26124),
(122084,'enUS','','I\'ve gotten far more kills than you, Nathanos. You\'re slipping!',26124),
(122085,'enUS','Jace Darkweaver spoke the truth. You carry the Aldrachi Warblades, $n! With you at the head of our order, the Illidari will be unstoppable.','Jace Darkweaver spoke the truth. You carry the Aldrachi Warblades, $n! With you at the head of our order, the Illidari will be unstoppable.',26124),
(122086,'enUS','I\'m your champion, Dark Lady. It\'s my job to make you look good.','',26124),
(122087,'enUS','','A champion at making excuses, it would seem!',26124),
(122088,'enUS','<mutters>','',26124),
(122089,'enUS','','What have you done to yourself, $n? You\'re more demon than $r.',26124),
(122090,'enUS','','I hope you can retain control of your... abilities... in this sacred place, \"Demon Hunter.\" We will be watching you.',26124),
(122091,'enUS','Are you one of them, $n? Or one of us? So much demonic energy...','',26124),
(122092,'enUS','','A demon hunter! Perfect, you\'re just what I need.',26124),
(122093,'enUS','Pull up a resting stone, brul. Navarrogg says you allowed to rest here.','',26124),
(122094,'enUS','I wish to recruit Val\'kyr.','I wish to recruit Val\'kyr.',26124),
(122095,'enUS','I wish to recruit shieldmaidens.','I wish to recruit shieldmaidens.',26124),
(122096,'enUS','It\'s good to see you again, $n. I trust that you are well?\n\n<Mathias looks around and then says the rest in hushed tones.>\n\nHow go the affairs of the Uncrowned? As head of SI:7, I cannot publicly support you.\n\nBut, until the war against the Burning Legion has come to an end, I pledge my full support, even if it has to be conducted in secret.\n\nUntil we meet again.','',26124),
(122097,'enUS','','You weren\'t lying, Elias. The Demon Hunters are on the loose. Be careful - with those eyes, $n sees everything.',26124),
(122098,'enUS','A Demon Hunter? Disgusting! Your wings are so leathery and creepy.','A Demon Hunter? Ugh - your wings are so leathery and creepy.',26124),
(122099,'enUS','Come, traveler. Join us.$b$bLet our hearth be your hearth.$b$bStay here. Join us.$b$bJoin us...','',26124),
(122100,'enUS','What? Oh, I didn\'t even know ye were there! Since when did all ye $cs get ta be so sneaky?$B$BNeedin\' ta know if we\'ll be leaving soon so I can ready my things.','',26124),
(122102,'enUS','Who shall be next to taste my blades?','',26124),
(122103,'enUS','','Welcome, outsider.$b$bYour kind do not often find their way this high up the mountain, but you are welcome here all the same.',26124),
(122104,'enUS','','The drogbar attacks have left my family with little to offer, but what we have is yours, hero.',26124),
(122105,'enUS','I make posts when I feel things.','',26124),
(122106,'enUS','I will return when I can meet your price, Arluin.','I will return when I can meet your price, Arluin.',26124),
(122107,'enUS','[PH] And then a killer finale cinematic plays! [PH]','[PH] And then a rad finale cinematic plays! [PH]',26124),
(122108,'enUS','My mind... withering... need... help.','',26124),
(122109,'enUS','Something feels different here. The air is fine, but there\'s an odd feeling about.$B$BEvery since we arrived people have been acting strange. And I don\'t mean the dizzy heads still recovering from our trip, but more in the way people carry themselves and the occasional whispers floating about.','',26124),
(122110,'enUS','<Feed Leyweaver Ke\'lorin 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>','<Feed Leyweaver Ke\'lorin 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>',26124),
(122111,'enUS','This action costs 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?','This action costs 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?',26124),
(122112,'enUS','Best get to Grommash Hold straightaway, $n.','',26124),
(122113,'enUS','','Even the most dedicated of craftsman need a break from time to time. Pull up a sleeping fur and rest next to the safety of my hearth.',26124),
(122114,'enUS','','Suffer well, $n. We will be ready when you have need of us.',26124),
(122115,'enUS','Say the word and I shall reveal the enemy!','',26124),
(122116,'enUS','Thank you!','',26124),
(122117,'enUS','Yes? What is it?$B$BPardon my being short, but there were countless times I asked to be notified prior to us deciding to move the entire city. Now look at my shop... things are everywhere! Ildine and Vanessa will be busy for months!$B$BNow if you\'ll excuse me, I must finish these enchantments before we up and decide to move yet again!','',26124),
(122118,'enUS','','Oh hiya, toots. You need anything, or ya want me to have someone get ya something.\n\nOr, ya know, if ya just want to talk, Nikki\'s here for ya.',26124),
(122119,'enUS','It\'s a long way down, friend. \n\nNeed a hand?','',26124),
(122120,'enUS','My wife left me for a flounder.','',26124),
(122122,'enUS','This jerkin ain\'t free!','',26124),
(122123,'enUS','Has anyone seen Stanky? I\'m starting to worry.','',26124),
(122125,'enUS','Jerk to the right! Now jerk to the left!','',26124),
(122126,'enUS','Things can\'t get worse. Can they?','',26124),
(122127,'enUS','What\'s that smell?','',26124),
(122128,'enUS','Has anyone seen my brother Daryl?','',26124),
(122129,'enUS','Get your warm beer and cold sausages! Ask for Skidmark and tell him Joe sent ya!','',26124),
(122130,'enUS','Sewer sharks? Nasty creatures, I\'ve seen \'em only once before!','',26124),
(122131,'enUS','M... Master, I am dying...','M... Master, I am dying...',26124),
(122132,'enUS','Power wanes...','Power wanes...',26124),
(122133,'enUS','Can\'t move... powerless...','Can\'t move... powerless...',26124),
(122134,'enUS','You can\'t do this, Illidan.','You can\'t do this, Illidan.',26124),
(122135,'enUS','Stop! You\'re killing us!','Stop! You\'re killing us!',26124),
(122136,'enUS','I can help you procure some valuable items.','I can help you procure some valuable items.',26124),
(122137,'enUS','Place work order for Champion armaments.','Place work order for Champion armaments.',26124),
(122138,'enUS','My chains will shackle you.','',26124),
(122139,'enUS','You\'re a monster, Illidan!','You\'re a monster, Illidan!',26124),
(122140,'enUS','You won\'t kill me without a fight!','You won\'t kill me without a fight!',26124),
(122141,'enUS','Rooksguard, send these devils back to their dark masters! For Azshara! For Kalimdor!','',26124),
(122142,'enUS','You are my captain no more, Illidan! DIE!','You are my captain no more, Illidan! DIE!',26124),
(122143,'enUS','You have betrayed us all!','You have betrayed us all!',26124),
(122144,'enUS','You want my mana? Then come! Take it if you dare!','You want my mana? Then come! Take it if you dare!',26124),
(122145,'enUS','You are no better than the demons that descend upon us!','You are no better than the demons that descend upon us!',26124),
(122146,'enUS','BETRAYER!','BETRAYER!',26124),
(122147,'enUS','You\'ll burn for this, Illidan!','You\'ll burn for this, Illidan!',26124),
(122148,'enUS','You want my magic? Here, have a taste!','You want my magic? Here, have a taste!',26124),
(122149,'enUS','I do what must be done!','',26124),
(122150,'enUS','You serve a greater purpose now, my faithful acolyte!','',26124),
(122151,'enUS','Look around you! This is the only way!','',26124),
(122152,'enUS','You should be thankful that you were given this opportunity to serve!','',26124),
(122153,'enUS','Some of you must die if our world is to survive!','',26124),
(122154,'enUS','I am above your judgment! What I do, I do for Azeroth!','',26124),
(122155,'enUS','The threat of the Legion costs lives. Your lives!','',26124),
(122156,'enUS','I will make certain that your family is cared for, friend.','',26124),
(122157,'enUS','Can you not see the sacrifices I make to ensure our survival?!','',26124),
(122158,'enUS','Illidan... Why?','Illidan... Why?',26124),
(122159,'enUS','Mother Moon take me!','Mother Moon take me!',26124),
(122160,'enUS','You walk down a dark path, Illidan. There\'s no turning back from this...','You walk down a dark path, Illidan. There\'s no turning back from this...',26124),
(122161,'enUS','I did not ask for this burden, but it is what fate has deemed...','',26124),
(122162,'enUS','Your life energies will give our world a fighting chance, acolyte.','',26124),
(122163,'enUS','If only there were another way, but I must have power if we are to survive.','',26124),
(122164,'enUS','Thank you for this sacrifice. Your death will not be in vain.','',26124),
(122165,'enUS','You must die, so that I may live! I have a destiny to fulfill! A world to save!','',26124),
(122166,'enUS','I will be the conduit for Azeroth\'s retribution!','',26124),
(122167,'enUS','Your life energies amplify my own! I am unstoppable!','',26124),
(122168,'enUS','The Legion will tremble before me! All will tremble before me!','',26124),
(122169,'enUS','I found one! Tighten up defense in this area at once.','',26124),
(122170,'enUS','We will gladly accept your help, Delas. The Light is strongest when it shines together.','',26124),
(122171,'enUS','','Help... please. My thoughts... are slowing.',26124),
(122172,'enUS','<Feed Tempomancer Virinya 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>','<Feed Tempomancer Virinya 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>',26124),
(122173,'enUS','The Uncrowned must strive to undermine the Burning Legion in all the ways we do it best: artifice, guile, deception, and of course, politics.\n\nUntil the Legion is defeated, our continued cooperation is my highest priority, $n. I trust that it is yours as well.','',26124),
(122174,'enUS','Put on the Stylish Spy Glasses to locate the blood trail!','Put on the Stylish Spy Glasses to locate the blood trail!',26124),
(122175,'enUS','Place a work order for a Seal of Broken Fate.','Place a work order for a Seal of Broken Fate.',26124),
(122176,'enUS','My flame... falters. I am not long for this world...','',26124),
(122177,'enUS','<Feed Flameweaver Ovin 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>','<Feed Flameweaver Ovin 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>',26124),
(122178,'enUS','The Ascended cannot be commanded, only unleashed.','The Ascended cannot be commanded, only unleashed.',26124),
(122179,'enUS','Recruit Ascendants','Recruit Ascendants',26124),
(122180,'enUS','','I became a priestess to help others, but lately I have been wondering if I can do more.',26124),
(122181,'enUS','The manasaber purrs warmly and beckons you closer.','',26124),
(122182,'enUS','Specialist, huh? I\'ve been trapped here for hours!','',26124),
(122183,'enUS','Hey! Slow it down a little! I\'d like to keep my legs intact if that\'s possib... wait a minute! If I\'m here, then where\'s the rest of me!?','',26124),
(122184,'enUS','Oh, look. Another bystander. Suuure... enjoy the show. Everybody come look at the poor gnome. When I get down from here...','',26124),
(122185,'enUS','Yes, but just make sure to protect me if any demons show up! I\'m not really able to defend myself, if you know what I mean.','',26124),
(122186,'enUS','I never noticed before, but the stones on the floor here are very well taken care of.','',26124),
(122187,'enUS','What do you mean, \'might have to wait until we blink again\'? I can\'t stay here! I have things to do!','',26124),
(122188,'enUS','What was that? Stop it! Someone\'s poking me on the other end!','',26124),
(122189,'enUS','','We are ready to begin.',26124),
(122190,'enUS','Empower the Focusing Crystal','Empower the Focusing Crystal',26124),
(122191,'enUS','','Vanthir felt we would be safer here. After what happened to my dear Korine, I am inclined to agree.\n\nIt is a hard life the Nightfallen lead, but we will endure.\n\nThank you again for saving my daughter.',26124),
(122192,'enUS','Well, we could wait until we move again. Who knows? The problem might fix itself!','',26124),
(122193,'enUS','Speak the vows at the altar when you are ready.','Speak the vows at the altar when you are ready.',26124),
(122194,'enUS','If we rotate clockwise a bit, then... no. Maybe it was counter clockwise...','',26124),
(122195,'enUS','Don\'t worry, we\'ll have you out in a zip there... you. Why do I keep talking to this thing?','',26124),
(122196,'enUS','I need a little more time to think. These are pretty unique circumstances. It\'s not the kind of job you can do... half way.','',26124),
(122197,'enUS','Nothing I can find about this particular situation. Just hang tight! We\'ll figure something out.','',26124),
(122198,'enUS','It\'s a good thing the fish tank was emptied before we left. That would have been a whole other issue!','',26124),
(122200,'enUS','<The manasaber looks at you like you might have something it wants to eat.>','',26124),
(122201,'enUS','<Feed the manasaber 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>','<Feed the manasaber 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>',26124),
(122202,'enUS','','Here, in the presence of eternal champions, I take this sacred oath:',26124),
(122204,'enUS','','I pledge my life to the Order of the Silver Hand,',26124),
(122205,'enUS','','And join my brothers and sisters in humble service.',26124),
(122206,'enUS','','With this vow, I am reborn,',26124),
(122207,'enUS','','A warrior of Light.',26124),
(122208,'enUS','','The shield of man, the hand of devotion, and the sword of retribution.',26124),
(122209,'enUS','','To protect the weak, uphold justice, and walk the righteous path.',26124),
(122210,'enUS','','This place is a mess!',26124),
(122211,'enUS','','Almost all accounted for! Who would have thought moving Dalaran would cause such problems? One more pen, the birds and then everything will be back to normal!$B$B<Looking around the room>.$B$BExcept for that poor fellow over in the fish tank. I hope they can resolve that soon.',26124),
(122212,'enUS','Only half my cheese made it! Half!$B$BHow are we to run a wine and cheese shop with an abundance of wine and only mere crumbles of delicious cheese? This is outrageous! It\'s preposterous! And...$B$BOh, my! Now I\'m feeling faint. What is this world coming to?','',26124),
(122213,'enUS','','Oh, don\'t mind him. He\'s quite forgetful. All of the aged goods were stored well before our departure.$B$BBe sure to come visit us when the shop\'s up and running again! I\'m sure we\'ll reach our final destination soon enough!',26124),
(122214,'enUS','','Quite a few people have come by seeking relief from the side effects.$B$BIf I could just find those old recipes... I know they\'re here somewhere!',26124),
(122215,'enUS','Dorothy\'s inside if you need her, but if you\'re looking for supplies we won\'t be able to fill any orders for the time being. My apologies.','',26124),
(122216,'enUS','But we may also be experiencing a minor case of total system failure.','',26124),
(122217,'enUS','I need you to press the big red button labeled \"DO NOT PUSH THIS BUTTON\".','',26124),
(122218,'enUS','The next time someone tells you they\'re going to move a city using magic, you better be ready for anything! And I mean ANYTHING!','',26124),
(122219,'enUS','The box flares brightly.','The box flares brightly.',26124),
(122220,'enUS','The box starts emitting a series of pleasant chime sounds.','The box starts emitting a series of pleasant chime sounds.',26124),
(122221,'enUS','The melody of chimes increases in volume.','The melody of chimes increases in volume.',26124),
(122222,'enUS','The box flares once again. One more sequence and it will be fully activated!','The box flares once again. One more sequence and it will be fully activated!',26124),
(122223,'enUS','If you have not yet learned to fly here in Pandaria, feel free to borrow Graddoc here for a flight into the Vale.','',26124),
(122224,'enUS','I... am already so weak...','I... am already so weak...',26124),
(122225,'enUS','I can\'t go on...','I can\'t go on...',26124),
(122226,'enUS','The horror... the horror.','The horror... the horror.',26124),
(122227,'enUS','I... I think I can make it. Thank you.','I... I think I can make it. Thank you.',26124),
(122228,'enUS','Free... finally free. How do I get out of here?','Free... finally free. How do I get out of here?',26124),
(122229,'enUS','Please... kill every last one of these monsters.','Please... kill every last one of these monsters.',26124),
(122230,'enUS','|TInterface\\Icons\\spell_deathknight_necroticplague.blp:20|t You are afflicted with |cFFF00000|Hspell:206480|h[Carrion Plague]|h|r!','',26124),
(122231,'enUS','Your command?','',26124),
(122232,'enUS','Send out the Call for the Vanguard','Send out the Call for the Vanguard',26124),
(122235,'enUS','What?','',26124),
(122236,'enUS','Place a work order for Champion armaments.','Place a work order for Champion armaments.',26124),
(122237,'enUS','Luniel... sweetest Luniel... how could I let this happen to you?','',26124),
(122238,'enUS','','What do you need?',26124),
(122239,'enUS','Begin the Call','Begin the Call',26124),
(122240,'enUS','How can I be of service?','How can I be of service?',26124),
(122241,'enUS','Place a work order for Champion armaments.','Place a work order for Champion armaments.',26124),
(122243,'enUS','','Yes?',26124),
(122244,'enUS','Begin charging the Hammer','Begin charging the Hammer',26124),
(122246,'enUS','','Is it time?',26124),
(122247,'enUS','Begin the Ritual','Begin the Ritual',26124),
(122248,'enUS','I\'ve got to finish these samples, $n! The last batch was so unstable they nearly killed us all during the move!$B$BDon\'t tell anyone that last part.','',26124),
(122249,'enUS','I will hear what this demon hunter has to say.','',26124),
(122250,'enUS','They killed her... those withered killed my Luniel. I... I have nothing left.','',26124),
(122251,'enUS','','May the Light bless you.',26124),
(122252,'enUS','Place a work order for Champion armaments','Place a work order for Champion armaments',26124),
(122253,'enUS','<Feed Llorian 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>','<Feed Llorian 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>',26124),
(122254,'enUS','What you need, little $n?','',26124),
(122255,'enUS','Th... thank you... I... I don\'t know how to go on... I\'ve lost so much.','',26124),
(122256,'enUS','Let\'s see what you have.','Let\'s see what you have.',26124),
(122257,'enUS','Wait... do you hear that?','',26124),
(122258,'enUS','The withered! They\'re upon us. Please, help me!','',26124),
(122259,'enUS','Bring me yer dead, Ill find a use for \'em.','',26124),
(122260,'enUS','Place a work order for Champion armaments','Place a work order for Champion armaments',26124),
(122261,'enUS','','Sorry, $n, but we were asked not to take on any new trainees for a while. Once we reach our final destination I\'m sure things will return to normal.',26124),
(122262,'enUS','Look at this mess! All of our things thrown about! Books on the floor, tools everywhere... I really wish we had a bit more warning before the entire city moved!$B$BAnd look at Dorian over there. Poor guy is still recovering.','',26124),
(122263,'enUS','','Welcome to The Gnarled Branch, $n.',26124),
(122264,'enUS','Let\'s see what you have.','Let\'s see what you have.',26124),
(122265,'enUS','If you like your shoes, you may want to step back a bit.','',26124),
(122266,'enUS','I owe you my life twice over... I don\'t have much, but look through my supplies and take anything you need.','',26124),
(122268,'enUS','So, it is none other than Odyn\'s champion!','',26124),
(122269,'enUS','I have heard tales of your exploits. Let us see if they are more than tales, shall we?','',26124),
(122270,'enUS','The Frost Wyrm desires to be unleashed.','',26124),
(122271,'enUS','Begin the ritual','Begin the ritual',26124),
(122272,'enUS','Over here, friend $c! This one has shinies to offer. Take a look!','',26124),
(122273,'enUS','<rustling of leaves>','<rustling of leaves>',26124),
(122274,'enUS','Recruit an Ancient of War','Recruit an Ancient of War',26124),
(122275,'enUS','Odyn\'s glory be with you, Valarjar.','',26124),
(122276,'enUS','How may I help you, $n?','',26124),
(122277,'enUS','Let\'s see what you have.','Let\'s see what you have.',26124),
(122278,'enUS','Hi!','Hi!',26124),
(122279,'enUS','Recruit an Echo of a Celestial','Recruit an Echo of a Celestial',26124),
(122280,'enUS','These ghouls are ready to do your bidding, Deathlord.','',26124),
(122281,'enUS','Forgive the deception, $n. I would not interfere with the trials, even for my chosen champion!','',26124),
(122282,'enUS','I have some items you may find useful, $n.','',26124),
(122283,'enUS','Let\'s see what you have.','Let\'s see what you have.',26124),
(122285,'enUS','Back in my day, these trees were greener.','',26124),
(122286,'enUS','Oh my! How things have changed.','',26124),
(122287,'enUS','If Toryl says you are here to help us, then you may rest at our hearth. Share in our meat and mead!','',26124),
(122288,'enUS','','How could they believe the Herald\'s lies? There\'s dark magic at play here - mark my words.\n\nPlease, if you can do anything to stop this, do it now. So many innocent lives lost...',26124),
(122289,'enUS','','Squires aren\'t normally so quick to train, but I put a rush on this order for ya.',26124),
(122290,'enUS','Hmm... no special sheep today? Curses! Better luck tomorrow, eh?','',26124),
(122291,'enUS','Let\'s see what you have.','Let\'s see what you have.',26124),
(122292,'enUS','','Welcome, $n. May the celestials watch over you.',26124),
(122293,'enUS','May the elements serve you well.','',26124),
(122294,'enUS','Success!','',26124),
(122295,'enUS','Welcome, $n. I have some things that you may find useful.','',26124),
(122296,'enUS','Let\'s see what you have.','Let\'s see what you have.',26124),
(122297,'enUS','','You will get no further than us, Lady Keletress!',26124),
(122298,'enUS','','Hiya, $n! How can I help you today?',26124),
(122299,'enUS','Let\'s see what you have.','Let\'s see what you have.',26124),
(122300,'enUS','','Hiya, $n! How can I help you today?',26124),
(122301,'enUS','Let\'s see what you have.','Let\'s see what you have.',26124),
(122302,'enUS','Whatever you do, don\'t eat the fruit in the bowls.$b$bThat stuff is terrible quality. If you want to taste the finest Suramar has to offer, allow me to show you true flavors.','',26124),
(122303,'enUS','Don\'t *hic* interrupt!  We need the Nightwell\'s power...','Don\'t *hic* interrupt!  We need the Nightwell\'s power...',26124),
(122304,'enUS','','Your flame burns bright today, $n.',26124),
(122305,'enUS','What do you have for sale?','What do you have for sale?',26124),
(122306,'enUS','What do you have for sale?','What do you have for sale?',26124),
(122307,'enUS','','Gold brightens up even a dark place like this.',26124),
(122308,'enUS','Hail, $n. I have some things that you may find useful.','',26124),
(122309,'enUS','Let\'s see what you have.','Let\'s see what you have.',26124),
(122310,'enUS','Everyone please step back! This is just another side effect of moving the city. Business will resume shortly!','',26124),
(122311,'enUS','People! People! Please... As odd as it may seem, we have things under control. We\'ve acquired extra guards to ensure nothing goes missing.','',26124),
(122312,'enUS','Yes, yes. We know what it looks like. All of your entrusted belongings will be here when business returns to normal. You have my word.','',26124),
(122313,'enUS','There\'s absolutely nothing to worry about. Mere side effects of moving a massive, magical city.','',26124),
(122314,'enUS','Our staff is working around the clock to ensure your belongings remain safe! There\'s absolutely nothing to fear.','',26124),
(122315,'enUS','Please do return in a few days time. We do value your business...','',26124),
(122316,'enUS','I failed my kingdom and my people... I will not fail our world as well.','',26124),
(122317,'enUS','','And rise, reborn, as the shield of man, the hand of devotion, and the sword of retribution.',26124),
(122318,'enUS','Nooooo... yes, actually.','',26124),
(122319,'enUS','Outlook is certain. Certain death!','',26124),
(122320,'enUS','Defeat is assured.','',26124),
(122321,'enUS','Reply... hazy... Try again?','',26124),
(122322,'enUS','You will likely survive. Most likely.','',26124),
(122323,'enUS','Let me confer with my sources... no.','',26124),
(122324,'enUS','Let me confer with my sources... yes.','',26124),
(122325,'enUS','Not likely... in this timeline.','',26124),
(122326,'enUS','Outlook unclear, gather 4289 more apexis crystals and ask again.','',26124),
(122327,'enUS','Your sound card works perfectly.','',26124),
(122328,'enUS','Thank you for rescuing me from that terrible place.$b$bI am quite handy with restoring equipment. Do you need any repairs done?','',26124),
(122329,'enUS','I... I thank you. They were beginning to sound hungry...','I... I thank you. They were beginning to sound hungry...',26124),
(122330,'enUS','I will make my way to safety. They will not catch me again!','I will make my way to safety. They will not catch me again!',26124),
(122332,'enUS','','Ready for a rematch, $n? Anytime, anywhere.',26124),
(122333,'enUS','We are well aware of the situation and everything is under control!','',26124),
(122334,'enUS','This is absolutely normal. Please do not be alarmed!','',26124),
(122335,'enUS','We should have this resolved shortly! Please bear with us.','',26124),
(122336,'enUS','Please remind Gee that I will be requiring additional pay. I\'m technically still behind the counter.','',26124),
(122337,'enUS','Everything is fine! Go about your business as usual. We have everything under control!','',26124),
(122338,'enUS','Ah, another valued customer! Welcome! Welcome!','',26124),
(122339,'enUS','Gee!... Gee!... Would you please remind Teller Gee that I\'m still here, waiting patiently to be returned to my normal state. Thank you kindly.','',26124),
(122340,'enUS','You face Jaraxxus, Eredar Lord of the Burning Legion!','',26124),
(122341,'enUS','FLESH FROM BONE!','',26124),
(122342,'enUS','Trifling gnome! Your arrogance will be your undoing!','',26124),
(122343,'enUS','IN-FER-NO!','',26124),
(122344,'enUS','Insignificant gnat!','',26124),
(122345,'enUS','These Valarjar Aspirants will aid us in our battle against the Burning Legion!','',26124),
(122346,'enUS','','You can rest assured that these archers will never miss their mark.',26124),
(122347,'enUS','','May these imps serve you well, Netherlord.',26124),
(122348,'enUS','What can I do for ya?','',26124),
(122349,'enUS','What do you seek?','',26124),
(122350,'enUS','Greetings.','',26124),
(122351,'enUS','','These elementals will make useful allies in our battle against the Burning Legion.',26124),
(122352,'enUS','How can me help ye, Shadow $n?','',26124),
(122353,'enUS','The Shattered Hand will see the Horde to its former glory.','',26124),
(122354,'enUS','','Something I can help you with?',26124),
(122355,'enUS','What do you seek?','',26124),
(122356,'enUS','Steer clear! Who knows what\'s gotten into this thing!','',26124),
(122357,'enUS','Out of the way! This thing has no regard for safety!','',26124),
(122358,'enUS','Lookout! I can\'t seem to get control of this thing!','',26124),
(122359,'enUS','Steer clear! This zeppelin\'s got a mind of its own!','',26124),
(122360,'enUS','Zeppelin on the loose! Everybody panic!','',26124),
(122361,'enUS','','Get outta here, varmint!',26124),
(122362,'enUS','I wish to trade.','I wish to trade.',26124),
(122363,'enUS','I wish to bind my hearthstone here.','I wish to bind my hearthstone here.',26124),
(122364,'enUS','Make Shal\'Aran your new home?','Make Shal\'Aran your new home?',26124),
(122365,'enUS','<Feed the Nightborne Wretch 5 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>','<Feed the Nightborne Wretch 5 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>',26124),
(122366,'enUS','This action costs 20 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?','This action costs 20 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?',26124),
(122367,'enUS','','The crimes of my past are mine to bear, and mine only. However, the Burning Legion corrupted my former order, leading us astray from righteousness.$b$bI will make the Burning Legion pay for their treachery!',26124),
(122368,'enUS','','Summoners, begin the ritual!',26124),
(122369,'enUS','','Yes, yes, it is working!',26124),
(122370,'enUS','','The ritual is complete, contain it, quickly!',26124),
(122371,'enUS','Elune-Ado... Wait, is that THE Scythe of Elune in your hands? Amazing!','Elune-Ado... Wait, is that THE Scythe of Elune in your hands? Amazing!',26124),
(122372,'enUS','Careful with that scythe, Shan\'do. I\'d prefer to stay in control of my mind.','Careful with that scythe, Shan\'do. I\'d prefer to stay in control of my mind.',26124),
(122373,'enUS','Is that the Scythe of Elune you carry? Does it really turn you into a beast?','Is that the Scythe of Elune you carry? Does it really turn you into a beast?',26124),
(122374,'enUS','The Scythe of Elune! The end must be near if we need the power of THAT weapon to save us.','The Scythe of Elune! The end must be near if we need the power of THAT weapon to save us.',26124),
(122375,'enUS','Welcome, Shan\'do. It is an honor to meet with the master of the Scythe.','Welcome, Shan\'do. It is an honor to meet with the master of the Scythe.',26124),
(122376,'enUS','Those claws look incredibly sharp. I\'m glad you\'re on our side!','Those claws look incredibly sharp. I\'m glad you\'re on our side!',26124),
(122377,'enUS','The rumors are true. $n wields the Claws of Ursoc!','The rumors are true. $n wields the Claws of Ursoc!',26124),
(122378,'enUS','Our champion is here bearing the Claws of Ursoc! The Legion\'s days are numbered!','Our champion is here bearing the Claws of Ursoc! The Legion\'s days are numbered!',26124),
(122379,'enUS','Hail Archdruid $n, chosen of Ursoc!','Hail Archdruid $n, chosen of Ursoc!',26124),
(122380,'enUS','','Tethys will arrange transport for us on one of his ships. We will sail out of sight of land and then he will row us to shore when it is dark and the fog is heavy upon the waters.\n\nLet me know when you are ready to leave, $n.',26124),
(122381,'enUS','The Fangs of Ashamane! So, the rumor of the attack on the Ashen shrine was true!','The Fangs of Ashamane! So, the rumor of the attack on the Ashen shrine was true!',26124),
(122382,'enUS','Those daggers look strange. Are they... teeth?','Those daggers look strange. Are they... teeth?',26124),
(122383,'enUS','The Fangs of Ashamane! I thought the Ashen would never let them out of their sight!','The Fangs of Ashamane! I thought the Ashen would never let them out of their sight!',26124),
(122384,'enUS','Greetings, $n. Word has reached me of your efforts to push back against Legion invasion forces.','',26124),
(122385,'enUS','I am reluctant to interrupt such important work, but I could use your help in a matter of... diplomacy. I fear I am about to anger an old friend.','',26124),
(122386,'enUS','$n, I recognize those daggers. They are the Fangs of Ashamane are they not? You must have done something impressive indeed for the Ashen to let you have them.','$n, I recognize those daggers. They are the Fangs of Ashamane are they not? You must have done something impressive indeed for the Ashen to let you have them.',26124),
(122387,'enUS','Dalaran has been repositioned to defend the Eastern Kingdoms. You\'ll find it over Deadwind Pass, just above Karazhan. Please join me here.','',26124),
(122388,'enUS','I\'m glad the Cenarion Circle has you among their number, Fang bearer!','I\'m glad the Cenarion Circle has you among their number, Fang bearer!',26124),
(122389,'enUS','The Guardian of G\'Hanir is here! Elune bless you, $n!','The Guardian of G\'Hanir is here! Elune bless you, $n!',26124),
(122390,'enUS','I\'m glad to see G\'Hanir is in good hands.','I\'m glad to see G\'Hanir is in good hands.',26124),
(122391,'enUS','It\'s $n! The hero who purged the corruption from G\'Hanir!','It\'s $n! The hero who purged the corruption from G\'Hanir!',26124),
(122392,'enUS','It\'s the guardian of G\'Hanir! We\'re counting on you, $n.','It\'s the guardian of G\'Hanir! We\'re counting on you, $n.',26124),
(122393,'enUS','','Conjurers, begin channeling!',26124),
(122394,'enUS','<Rottgut turns towards your direction and belches loudly.>$b$bRottgut... rott... gut!','',26124),
(122395,'enUS','','The Crystal is charged.  Use it at will.',26124),
(122396,'enUS','','Hello there, honey!$b$bWhat can I get you?',26124),
(122397,'enUS','','We are out of wine but we have plenty of food, drink, and places to put your feet up!',26124),
(122398,'enUS','','Sit down and relax!',26124),
(122399,'enUS','Welcome. What can I get for you?','',26124),
(122400,'enUS','','Uh oh.$b$bYour armor looks like it can use some fixing.',26124),
(122401,'enUS','','My skills are second to none!$b$bI hear I have some competition, though. There\'s someone else doing smithing outside the city.$b$bI like a challenge. Bring it! Hahaha!',26124),
(122402,'enUS','If you are unsure of the path you are about to take, I can return you to the surface. Would you like me to do so?','',26124),
(122403,'enUS','I need to return to the surface.','I need to return to the surface.',26124),
(122404,'enUS','<The defense matrix appears unpowered.>','',26124),
(122405,'enUS','<Insert 20 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana into the Defense Matrix.>','<Insert 20 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana into the Defense Matrix.>',26124),
(122406,'enUS','A demon blade can find even the smallest crack in your armor, $n. Repair it, or you might end up with your head on a spike.','',26124),
(122407,'enUS','','Silvermoon stands behind you, $n. Allow us to bless your weapon with holy might.',26124),
(122408,'enUS','|TInterface\\Icons\\sha_spell_shadow_shadesofdarkness_nightmare:20|t%s begins to cast |cFFFF0000|Hspell:214876|h[Beasts of Nightmare]|h|r!','',26124),
(122409,'enUS','This place... It\'s so much worse than I could have imagined.','',26124),
(122410,'enUS','Wake me up from this Nightmare!','Wake me up from this Nightmare!',26124),
(122411,'enUS','','Finish mixin\' up dat mojo, we got ta get it to da Broken Shore!',26124),
(122412,'enUS','Begone!','Begone!',26124),
(122413,'enUS','|TInterface\\Icons\\spell_fire_ragnaros_molteninferno.blp:20|tThe $n |cFFFF0000|Hspell:202663|h[Detonates]|h|r as it dies!','',26124),
(122414,'enUS','Warlord!','',26124),
(122415,'enUS','Don\'t just stand there, $n! These demons won\'t be killin\' themselves!','',26124),
(122416,'enUS','Better late than never, eh lad? Those of us that still draw breath fight on! Are you pre-','',26124),
(122417,'enUS','If we do not stop Xavius, the Nightmare will consume all of Azeroth.','',26124),
(122418,'enUS','Caught off guard, we was! We be needin\' ta bring an end ta these demons once and fer all!','',26124),
(122419,'enUS','Hold them back! We cannot lose the city!','',26124),
(122420,'enUS','Masterful, your weapon and experience show even the valarjar can learn from the younger races. There are new enemies and new ways of fighting that I haven\'t seen in my many years. You have given me a great deal to work with, thank you.','',26124),
(122421,'enUS','Heroes of the Alliance, I write to you in Azeroth\'s darkest hour. From the maw of hell, the burning armies of the Legion have returned.','',26124),
(122429,'enUS','This font looks as if it has not been used for some time.','',26124),
(122430,'enUS','$ct, you have been called. Follow me.','',26124),
(122431,'enUS','Asher, son of Exurotus, the new Fury of Frostfire, wishes to bestow you with his boon.','',26124),
(122432,'enUS','<Provide an offering of 20 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>','<Provide an offering of 20 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>',26124),
(122433,'enUS','You\'ve done it champions! The Iris is unlocked, give the word and I will open it.','',26124),
(122434,'enUS','The Nightmare\'s guardians have fallen. What else must be done to open the way to Xavius?','The Nightmare\'s guardians have fallen. What else must be done to open the way to Xavius?',26124),
(122435,'enUS','You hear the measured chanting and pacing of a complex ritual within the spire.','You hear the measured chanting and pacing of a complex ritual within the spire.',26124),
(122436,'enUS','The ritual is broken.  The figure suspended within the Nightwell awakens.','The ritual is broken.  The figure suspended within the Nightwell awakens.',26124),
(122437,'enUS','I expected more out of these demons. Maybe we can find a pitlord. I always wanted to shackle the essence of a pitlord.','',26124),
(122438,'enUS','We should continue our patrol. There is no telling how many more of these incursions pocket the landscape.','',26124),
(122439,'enUS','We cannot afford to wait much longer. We must face the Legion head on.','',26124),
(122440,'enUS','I am ready to begin The Defense of Netherlight Temple.','I am ready to begin The Defense of Netherlight Temple.',26124),
(122441,'enUS','Can the power of the Essence of Clarity guide us into the heart of the Nightmare?','Can the power of the Essence of Clarity guide us into the heart of the Nightmare?',26124),
(122443,'enUS','Madam Goya packed up da goods and left me in charge of da premises. She said somethin\' about a sky city. Haw! Cities don\'t fly!','',26124),
(122444,'enUS','We must stop Gul\'dan before he can complete the ritual.','',26124),
(122445,'enUS','The legion will fall today, champion.','',26124),
(122446,'enUS','The ward pulses with overflowing energy.','',26124),
(122447,'enUS','Press forward, we cannot delay here long.','',26124),
(122448,'enUS','<Use 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana to extract a portion of the ley energy.>','<Use 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana to extract a portion of the ley energy.>',26124),
(122449,'enUS','','Long have I waited to return home...',26124),
(122450,'enUS','','The power of the Nightwell calls to me.',26124),
(122451,'enUS','They should have listened to me from the start and destroyed all the satyrs before this could happen.\n\nI thank you, $p, for releasing me from the madness of Xavius.','',26124),
(122452,'enUS','We\'ve broken through the prison gate! The way into Dalaran is clear!','',26124),
(122453,'enUS','','Elisande will pay for her treachery.',26124),
(122454,'enUS','','The Order is with you.',26124),
(122455,'enUS','Request a Blessing','Request a Blessing',26124),
(122456,'enUS','','Come, outsider filth. I will even let you strike the first blow. Make it count.',26124),
(122457,'enUS','Will you strike at me first or stare at me like a sniveling coward?','',26124),
(122458,'enUS','The fishing can wait, help me put this elemental down!','',26124),
(122459,'enUS','I always hated water elementals...Espically big ones like this!','',26124),
(122460,'enUS','This is the problem with magic, you never know when it will turn on you!','',26124),
(122461,'enUS','Sire, behind you! Another felmaw has opened!','',26124),
(122462,'enUS','Moon Guard, focus your energies into me! We shall show these monsters the power of the arcane!','',26124),
(122463,'enUS','We require rest, master.','We require rest, master.',26124),
(122464,'enUS','Tell me more about your posts.','Tell me more about your posts.',26124),
(122465,'enUS','Ha! I have spoken seven words, that is my limit.','',26124),
(122466,'enUS','','Wear your tabard with pride, $n. Our red colors will hide your wounds from your enemies.',26124),
(122467,'enUS','Dalaran is under siege, $n! The Legion intends to knock us out of the sky!','',26124),
(122468,'enUS','We need the Pillars of Creation to send the demons back to the Twisting Nether and save our world.','',26124),
(122469,'enUS','Meet me in Dalaran over Deadwind Pass. I have a plan. A horribly dangerous plan... but a plan nonetheless!','',26124),
(122470,'enUS','What manner of felspawn have these devils set upon us!? Mother Moon help us all!','',26124),
(122471,'enUS','Come, $n. Meet me by the Forge of the Guardian.','',26124),
(122472,'enUS','Paladins of the Silver Hand!  Come forth and present yourselves for battle!','Paladins of the Silver Hand!  Come forth and present yourselves for battle!',26124),
(122473,'enUS','My Lord, I lend my arms to your cause.','My Lord, I lend my arms to your cause.',26124),
(122474,'enUS','Deciphering','Deciphering',26124),
(122475,'enUS','<The portal hums with magic.>','',26124),
(122476,'enUS','I\'m not ready yet.','I\'m not ready yet.',26124),
(122477,'enUS','Our mission here is gravely important. However if you need to make additional preparations, I can return you to the Aetherium. Would you like me to?','Our mission here is gravely important. However if you need to make additional preparations, I can return you to the Aetherium. Would you like me to?',26124),
(122478,'enUS','Yes, take me back. There is much I need to do first.','Yes, take me back. There is much I need to do first.',26124),
(122479,'enUS','For honor and glory!','For honor and glory!',26124),
(122480,'enUS','It is time!  Vanguard of the Silver Hand, to Battle!','It is time!  Vanguard of the Silver Hand, to Battle!',26124),
(122481,'enUS','The Nightmare begins to take you!','The Nightmare begins to take you!',26124),
(122482,'enUS','Come with me to the Seed of Ages, Archdruid. There, we will unlock additional mysteries of your weapon.','',26124),
(122483,'enUS','I am ready.','I am ready.',26124),
(122484,'enUS','|TInterface\\Icons\\ability_priest_shadowyapparition:20|t%s has summoned a |cFFFF0000|Hspell:226089|h[Shadow Image]|h|r! Banish it!','|TInterface\\Icons\\ability_priest_shadowyapparition:20|t%s has summoned a |cFFFF0000|Hspell:226089|h[Shadow Image]|h|r! Banish it!',26124),
(122485,'enUS','Your intrusion has not gone unnoticed; but the ritual continues.','Your intrusion has not gone unnoticed; but the ritual continues.',26124),
(122486,'enUS','Interlopers!','',26124),
(122487,'enUS','Fear not, I will draw the power of the Nightwell to wipe them out!','',26124),
(122488,'enUS','','Courtesans! Defend us while we continue the ritual!',26124),
(122489,'enUS','The Dreadscar are yours to command, Overlord.\n\nMay the worlds of your enemies fall at your feet.','',26124),
(122490,'enUS','The time has come to take my position as the leader of the Four Horsemen.','',26124),
(122491,'enUS','I will meet you on the upper level when you are ready, Deathlord.','',26124),
(122492,'enUS','Horsemen! Our time has come!','',26124),
(122493,'enUS','Usurpers! Gnomeregan is mine!','',26124),
(122494,'enUS','Explosions! MORE explosions! I got to have more explosions!','',26124),
(122495,'enUS','It seems we have arrived just in time.','',26124),
(122496,'enUS','The Burning Legion has begun their attack. We must defend Netherlight Temple!','The Burning Legion has begun their attack. We must defend Netherlight Temple!',26124),
(122497,'enUS','We are armed and ready to fight, High Priest.','',26124),
(122498,'enUS','Let us aid our allies under the Light, and defend Netherlight Temple. To the portal!','',26124),
(122499,'enUS','I am the master\'s son. You are outmatched.','',26124),
(122500,'enUS','You will be a good warm-up for my actual practice.','',26124),
(122501,'enUS','Curse... you...','',26124),
(122502,'enUS','Good bout...','',26124),
(122503,'enUS','You hear something dart away behind you... and then just silence.','You hear something dart away behind you... and then just silence.',26124),
(122504,'enUS','I shall fight for you.','I shall fight for you.',26124),
(122505,'enUS','My life for the Light.','My life for the Light.',26124),
(122506,'enUS','','Let me show you the power of the Legion!',26124),
(122507,'enUS','','If you want something done right, you have to kill it yourself...',26124),
(122508,'enUS','You hear a strange feral screech towards the Duskwood gateway.','You hear a strange feral screech towards the Duskwood gateway.',26124),
(122509,'enUS','You hear a strange feral screech towards the Feralas gateway.','You hear a strange feral screech towards the Feralas gateway.',26124),
(122510,'enUS','You hear a strange feral screech towards the Hinterlands gateway.','You hear a strange feral screech towards the Hinterlands gateway.',26124),
(122511,'enUS','The look of these mundane weapons belies a hidden potential.','',26124),
(122512,'enUS','Tier 1 Defended','Tier 1 Defended',26124),
(122513,'enUS','<Imbue one of the tridents with 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>','<Imbue one of the tridents with 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>',26124),
(122514,'enUS','Tier 2 Defended','Tier 2 Defended',26124),
(122515,'enUS','Tier 3 Defended','Tier 3 Defended',26124),
(122516,'enUS','Tier 4 Defended','Tier 4 Defended',26124),
(122517,'enUS','End current round','End current round',26124),
(122518,'enUS','Gamer timer','Gamer timer',26124),
(122519,'enUS','How can I assist you today?','How can I assist you today?',26124),
(122520,'enUS','Recruit Silver Hand Knights','Recruit Silver Hand Knights',26124),
(122521,'enUS','Recruit Silver Hand Templar','Recruit Silver Hand Templar',26124),
(122522,'enUS','<Something terrible has befallen this lone wanderer.>','',26124),
(122523,'enUS','<Something terrible has befallen this lone wanderer.>\n\n<Unfortunately, there is no way to free him.>','',26124),
(122524,'enUS','$ct, I\'ve been looking everywhere for you! Oh, the head in the crystal ball? I\'m trying something new.','',26124),
(122525,'enUS','I\'ve finished gathering all of the volumes.','I\'ve finished gathering all of the volumes.',26124),
(122526,'enUS','Marvelous! It\'s great seeing a young hero like you take the time for a bit of history. In the end, some might say what we leave behind is all that matters.\n\nI have something here... a volume of a completely different sort that I might offer you in exchange for the great efforts you\'ve put into this. Would you like it?','',26124),
(122527,'enUS','Gladly.','Gladly.',26124),
(122528,'enUS','The guards sniff at you, then grunt softly.','',26124),
(122529,'enUS','THIS IS MY ISLAND!','',26124),
(122530,'enUS','FIND YOUR OWN DAMN ISLAND!!','',26124),
(122531,'enUS','A grim task, but you did what had to be done. I\'ll prepare the Tears of Elune for transport. Meet me in the Violet Citadel.','',26124),
(122532,'enUS','YOU\'RE NOT GONNA TAKE MY ISLAND!!','',26124),
(122533,'enUS','We\'d best get a move on, $n!','',26124),
(122534,'enUS','I\'m ready. To Ulduar!','I\'m ready. To Ulduar!',26124),
(122535,'enUS','Busy, very busy. M-must get to work.','',26124),
(122536,'enUS','No time to talk. Cleaning to be done.','',26124),
(122537,'enUS','Something need to be cleaned?','',26124),
(122538,'enUS','Hah! Where are your manafiends now?!','Hah! Where are your manafiends now?!',26124),
(122539,'enUS','What?!','What?!',26124),
(122540,'enUS','','I will fight honorably for the Order of the Silver Hand, $ct.',26124),
(122541,'enUS','You wanna fight for my island! Fine! I\'ll paint it with your blood!','',26124),
(122542,'enUS','We\'re all going to die!','We\'re all going to die!',26124),
(122543,'enUS','Su\'esh is on the loose! Flee!','Su\'esh is on the loose! Flee!',26124),
(122544,'enUS','Guards, what do we pay you for? Kill this beast!','Guards, what do we pay you for? Kill this beast!',26124),
(122545,'enUS','I\'m too rich to die like this!','I\'m too rich to die like this!',26124),
(122546,'enUS','NO! I will not allow the Ebon Blade to fall!','',26124),
(122547,'enUS','Horsemen! Our Destiny is at hand!','',26124),
(122548,'enUS','The Burning Legion shall tremble before the power of the Four Horsemen!','',26124),
(122549,'enUS','Stormwind honors your service to the Alliance.','',26124),
(122550,'enUS','Stormwind will endure.','',26124),
(122551,'enUS','Greetings, friend.','',26124),
(122552,'enUS','Sometimes we must fight for what we believe in.','',26124),
(122553,'enUS','A just cause is always worth fighting for.','',26124),
(122554,'enUS','For the Alliance above all.','',26124),
(122555,'enUS','A King is only as noble as the causes he serves.','',26124),
(122556,'enUS','Be vigilant.','',26124),
(122557,'enUS','You are always welcome in Stormwind.','',26124),
(122558,'enUS','Never lose hope.','',26124),
(122559,'enUS','Safe journey to you.','',26124),
(122560,'enUS','Victory in the Light.','',26124),
(122561,'enUS','Now is not the time for that.','',26124),
(122562,'enUS','You try my patience.','',26124),
(122563,'enUS','<This Manasaber has been imprisoned by the Legion, but overloading the crystal with Ancient Mana will free the beast.>','',26124),
(122564,'enUS','Suramar ascends.','Suramar ascends.',26124),
(122565,'enUS','You know I\'m King now, right?','',26124),
(122566,'enUS','The Light shall burn you!','',26124),
(122567,'enUS','<Free the Felbound Manasaber by spending 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>','<Free the Felbound Manasaber by spending 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>',26124),
(122568,'enUS','This action costs 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?','This action costs 50 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?',26124),
(122569,'enUS','Stag','Stag',26124),
(122570,'enUS','Spirits! Sweep these mortals into the tides!!!','',26124),
(122571,'enUS','All who summon the ferryman, must pay the toll!','',26124),
(122572,'enUS','You wish for passage to Helheim? Then you shall have it! Ahahahaha!','',26124),
(122573,'enUS','Those who summon, pay the toll, forfeit now your eternal soul!','',26124),
(122574,'enUS','I look forward to seeing Magni again. It\'s been too long.','',26124),
(122575,'enUS','Mimiron gave me a teleport pad to use in case of emergencies. I\'d say this qualifies!','',26124),
(122576,'enUS','The order is given, we will begin charging up the Rift Core immediately.','The order is given, we will begin charging up the Rift Core immediately.',26124),
(122577,'enUS','The Rift Core is charged, deploy the Rift Cannon at your discretion.','The Rift Core is charged, deploy the Rift Cannon at your discretion.',26124),
(122578,'enUS','I\'d like to review the information we\'ve gathered on the remaining artifact weapon.','I\'d like to review the information we\'ve gathered on the remaining artifact weapon.',26124),
(122579,'enUS','','I better not hear anything breaking.',26124),
(122580,'enUS','','Keep your hands to yourself, little one.',26124),
(122581,'enUS','','Keep quiet and let mother browse.',26124),
(122582,'enUS','','No fingers on the glass, remember what we discussed.',26124),
(122583,'enUS','','If you break it, mother must purchase it.',26124),
(122584,'enUS','','Calm down, we will go home soon.',26124),
(122585,'enUS','I\'m ready to pursue the final blade.','I\'m ready to pursue the final blade.',26124),
(122586,'enUS','Mechanical','Mechanical',26124),
(122587,'enUS','Rylak','Rylak',26124),
(122588,'enUS','Riverbeast','Riverbeast',26124),
(122589,'enUS','Hydra','Hydra',26124),
(122590,'enUS','Direhorn','Direhorn',26124),
(122591,'enUS','','The Uncrowned are a means to an end. The Legion\'s end.',26124),
(122592,'enUS','You hear a strange crackling sound from the portals downstairs.','You hear a strange crackling sound from the portals downstairs.',26124),
(122593,'enUS','I will protect.','I will protect.',26124),
(122594,'enUS','My shield is yours.','My shield is yours.',26124),
(122595,'enUS','It would be my honor.','It would be my honor.',26124),
(122596,'enUS','You hear a strange roar from the cavern ahead.','You hear a strange roar from the cavern ahead.',26124),
(122597,'enUS','The Hydraxian Waterlords are with you, Farseer. The Burning legion will not conquer!','',26124),
(122598,'enUS','What the dook?','',26124),
(122599,'enUS','If you need a ride to Dalaran, my bats are at the ready.','',26124),
(122600,'enUS','This module looks to have lost its energy source long ago.','',26124),
(122601,'enUS','<Activate the module using 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>','<Activate the module using 25 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana.>',26124),
(122602,'enUS','','The Temple of a Thousand Lights teems with spirits gone mad. You should remind them to behave.',26124),
(122603,'enUS','','Even spirits understand strength. Well done!',26124),
(122604,'enUS','','The most powerful mages at this temple conspire against the Nightwatchers. Show them how we deal with our enemies!',26124),
(122605,'enUS','Ready to assault Hrydshal.','Ready to assault Hrydshal.',26124),
(122606,'enUS','','Well fought! The enemies of the Nightwatchers pay dearly for their treachery.',26124),
(122607,'enUS','We are lucky to have received Malorne\'s warning, dire as it may be. I greatly fear for the Emerald Dream, and if the Dream is corrupted, there is no telling how it will affect Azeroth.','',26124),
(122608,'enUS','','Why do we fight?',26124),
(122609,'enUS','','D\'ah! Now you\'re making me angry!',26124),
(122610,'enUS','I believe our wounds have healed enough. I will continue my scouting. Be well, Lilryia.','',26124),
(122611,'enUS','I believe I saw a $c looking for you in town, mentioning something about some ancient weapon. You should speak with them first before venturing out into the Broken Isles. You\'re going to need all of the allies you can get.\n\nI mean... I can get you a flight if you really want one. But I\'d recommend against it.','',26124),
(122612,'enUS','Can you get me a flight out of here?','Can you get me a flight out of here?',26124),
(122613,'enUS','Azsuna','Azsuna',26124),
(122614,'enUS','Highmountain','Highmountain',26124),
(122615,'enUS','Val\'kyr!  The Call has gone out!  Prepare yourselves!','Val\'kyr!  The Call has gone out!  Prepare yourselves!',26124),
(122616,'enUS','Val\'kyr, the time is upon us! To battle!','Val\'kyr, the time is upon us! To battle!',26124),
(122617,'enUS','My spear is yours.','My spear is yours.',26124),
(122618,'enUS','Val\'sharah','Val\'sharah',26124),
(122619,'enUS','My life for Odyn!','My life for Odyn!',26124),
(122620,'enUS','They shall fear our wrath.','They shall fear our wrath.',26124),
(122621,'enUS','For Glory!','For Glory!',26124),
(122622,'enUS','Heh, this guy\'s toast.','',26124),
(122623,'enUS','Larry gonna crush you into delicious meat sauce.','',26124),
(122624,'enUS','Hello fellow citizen, what seems to be the problem?','',26124),
(122625,'enUS','','I knoooow you\'re with the Leeeegion. That\'s you. That\'s what you sound like.',26124),
(122626,'enUS','','Corrin ma\' crate, ye bugger off!',26124),
(122627,'enUS','Tell me, $c, have you explored the wondrous goods that Dalaran has to offer? If you can\'t find what you\'re looking for, chances I know someone who can help.','',26124),
(122628,'enUS','','I told them this would happen. \n\nI TOLD them. \n\nDid they listen?!',26124),
(122629,'enUS','Watch yourself, $c...','',26124),
(122630,'enUS','THIEF!','',26124),
(122631,'enUS','Jagganoth will... end you...','',26124),
(122632,'enUS','Asha, you\'re free.','Asha, you\'re free.',26124),
(122633,'enUS','Sirius, are you okay?','Sirius, are you okay?',26124),
(122634,'enUS','','Da enemies a\' da Nightmare are clever. Dey chose da moment when da Wild Gods fell in battle thousands a\' years ago, when dey rose up ta defend Azeroth against the Burning Legion.',26124),
(122635,'enUS','','I don\'t like this place at all! Let\'s get rid of these invading monsters, Archdruid!',26124),
(122636,'enUS','','It must be difficult for the wild gods to re-live this moment. I can only imagine the horror when the Legion invaded, all those years ago.',26124),
(122637,'enUS','The Nightmare has no place here, and we must do everything we can to protect Malorne. Without him, the very balance of nature is vulnerable.$B$BI fear there is nothing more important than saving him... even if it means giving our own lives.','',26124),
(122638,'enUS','Rest in peace, old friend.','Rest in peace, old friend.',26124),
(122639,'enUS','','You have come to the crucible of all creation in search of answers. Listen then, and find enlightenment.',26124),
(122640,'enUS','','In a time now long past, a great battle was fought that would determine the fate of all worlds. It was in that final battle that the all-powerful titan Pantheon fell to one of their own: Sargeras.',26124),
(122641,'enUS','','After the fall, none were left to oppose the will of Sargeras. Unfettered, the dark titan and his Burning Legion would go on to annihilate countless worlds in their Burning Crusade.',26124),
(122642,'enUS','','From the ashes of those ravaged worlds, survivors arose to stand against the demons. They became known as the Army of the Light.',26124),
(122643,'enUS','','But now, the Golden Army teeters upon the precipice of oblivion as their campaign on Argus nears its terminus. Should they fall, the Legion will initiate a new Burning Crusade, and with it the cosmos will tremble.',26124),
(122644,'enUS','','I am here now on a mission of desperation. I seek the child of Light and Shadow: the boy destined to end the age of demons.',26124),
(122645,'enUS','','The one called Illidan Stormrage.',26124),
(122646,'enUS','Its too strong!  This is madness!','Its too strong!  This is madness!',26124),
(122647,'enUS','We don\'t have the power...','We don\'t have the power...',26124),
(122648,'enUS','This demon has some fight in it!','This demon has some fight in it!',26124),
(122649,'enUS','','$n, it\'s you.\n\nWe were in pursuit of a dangerous dreadlord. Unfortunately, he lured us right into a trap.',26124),
(122650,'enUS','<Cassiel Nightthorn\'s body is nearly unrecognizable. He was tortured, then died from the wounds.>','',26124),
(122651,'enUS','<Sirius Ebonwing looks as pale as a ghost. He shivers uncontrollably.>','',26124),
(122652,'enUS','I returned to Dalaran as soon as I heard the prophecy had been fulfilled.\n\nYou united the Light, just as I saw it. Let us hope that your efforts will give us the strength we need to defeat Balnazzar once and for all.','',26124),
(122653,'enUS','We will make our way to Netherlight Temple at once.','',26124),
(122654,'enUS','Jus\' say the word an\' we\'ll be off!','',26124),
(122655,'enUS','','I am Xe\'ra, one of the first naaru to be forged here during the great ordering of the cosmos.',26124),
(122656,'enUS','','Do not be alarmed, mortal. Your consciousness has been projected to my astral presence in the Great Dark Beyond.',26124),
(122657,'enUS','Move while the Mana Wraiths are distracted!','Move while the Mana Wraiths are distracted!',26124),
(122658,'enUS','','XXXX',26124),
(122659,'enUS','','Good luck, all of you.',26124),
(122660,'enUS','Ulduar holds many secrets.','',26124),
(122661,'enUS','<Arduen was apparently being held prisoner. His face is ghostly white.>$B$B$I... broke free... and ran...$B$BI... almost made it...$B$BPlease, $n, save... the other... Illidari...','',26124),
(122662,'enUS','This cannot wait. There are demons among your ranks. Let me show you.','This cannot wait. There are demons among your ranks. Let me show you.',26124),
(122663,'enUS','Hello, friend! It is not actually me, Khadgar, merely my ruggedly handsome countenance and vast wealth of knowledge. Should you wish the answer to any question, merely ask and request a response.\n\nSo vast is my mental landscape that there was only magical space left to impart a few response phrases into this device, so be sure that you ask VERY SPECIFIC questions.','',26124),
(122664,'enUS','I\'ve asked a question, give me an answer!','I\'ve asked a question, give me an answer!',26124),
(122665,'enUS','If you seek to wield the weapons of the storm lord, venture within, and learn of his deeds and his unmaking...','',26124),
(122666,'enUS','|TInterface\\Icons\\sha_ability_rogue_envelopingshadows_nightmare:20|tIl\'gynoth has almost completed his |cFFFF0000|Hspell:223121|h[Final Torpor]|h|r!','|TInterface\\Icons\\sha_ability_rogue_envelopingshadows_nightmare:20|tIl\'gynoth has almost completed his |cFFFF0000|Hspell:223121|h[Final Torpor]|h|r!',26124),
(122667,'enUS','I know your secret.','I know your secret.',26124),
(122668,'enUS','Leave me alone.','Leave me alone.',26124),
(122669,'enUS','Heh.','Heh.',26124),
(122670,'enUS','What?','What?',26124),
(122671,'enUS','Go away.','Go away.',26124),
(122672,'enUS','I have none.','I have none.',26124),
(122673,'enUS','Fight me, then.','Fight me, then.',26124),
(122674,'enUS','You don\'t scare me.','You don\'t scare me.',26124),
(122675,'enUS','If you say so.','If you say so.',26124),
(122676,'enUS','<Saying nothing, he eyes you warily.>','<Saying nothing, she eyes you warily.>',26124),
(122677,'enUS','So Arrexis was ambushed by this eredar, Balaadur?  Then he is probably in possession of the staff...\n\nWith the invasion I have no doubt he is either here or watching. I propose something... audacious.\n\nLet us recreate Arrexis\'s ritual! Conducting the ritual at an invasion point will attract Balaadur\'s attention. He will likely try an ambush, but we will be ready.','',26124),
(122678,'enUS','Who, Fillmaff? That old relic? He\'s been an archivist here at Dalaran for decades. I remember him back from my student days. Always puttering around the stacks. He could find anything.$b$bThen came the Third War, when Arthas sacked the city. Fillmaff went missing, along with countless others - just another of the numberless dead. Nobody thought anything of it.','',26124),
(122679,'enUS','Years passed, and we\'d relocated the entire city to Icecrown for the Northrend campaign.$b$bOne day - out of the blue - Old Fillmaff walks into the violet tower. Just strolls in! Doesn\'t say a word. He starts filing books and organizing the folios, like nothing had happened. He\'s been back at it ever since.$b$b<Varenthas leans close to you and whispers:>$b$bI\'m not sure he knows he\'s dead.','',26124),
(122680,'enUS','What\'s the story with Old Fillmaff over there?','What\'s the story with Old Fillmaff over there?',26124),
(122681,'enUS','','I don\'t know what\'s gotten into the flowers! I stopped trying to collect them once they started... well, they started collecting themselves!$B$BStrange, isn\'t it?',26124),
(122682,'enUS','I am your destruction!','I am your destruction!',26124),
(122683,'enUS','The twilight is upon you!','The twilight is upon you!',26124),
(122684,'enUS','Cry for help... none shall answer you!','Cry for help... none shall answer you!',26124),
(122685,'enUS','We are the harbingers of destruction!','We are the harbingers of destruction!',26124),
(122686,'enUS','None shall oppose the Twilight\'s Hammer!','None shall oppose the Twilight\'s Hammer!',26124),
(122690,'enUS','I\'ve changed my mind. Show me what artifacts are available again.','I\'ve changed my mind. Show me what artifacts are available again.',26124),
(122691,'enUS','You head in. I\'ll join you momentarily. I just need to... gather my thoughts.','',26124),
(122692,'enUS','Our trip to Ulduar was quite eventful, but we have more work ahead of us.','',26124),
(122693,'enUS','You cannot hide what you truly are, demon!','You cannot hide what you truly are, demon!',26124),
(122694,'enUS','Well look who\'s come back from the dead! $g Buddy:Lady;, you\'ve been unconscious for 3 days. I\'m sure Khadgar will be relieved that his special pal is awake. Me on the other hand? Still a damned sea lion.','',26124),
(122695,'enUS','Ahahahahaha!','',26124),
(122696,'enUS','','The pain will subside, champion. You now carry my mark, and through it I am able to see and feel as you do. Return to me when you are able. We have much to do.',26124),
(122697,'enUS','','Greetings, $n. Are you feeling well? Quite a few others have reported bouts of nausea and dizziness.',26124),
(122698,'enUS','','Greetings! Have you just arrived in the city? You don\'t seem to be suffering any side effects.',26124),
(122699,'enUS','You live! Your champions came to me after they failed to rouse you at your order hall. We brought you here and put you in the infirmary. What happened?','',26124),
(122700,'enUS','','We can\'t take much more of this!',26124),
(122701,'enUS','','It\'s never ending! They just keep coming!',26124),
(122702,'enUS','','This can\'t go on forever! We\'ll be overwhelmed soon!',26124),
(122703,'enUS','','They\'re bound to move the city soon! There\'s no way we can keep this up!',26124),
(122704,'enUS','','The Council has a plan. I\'m sure of it!',26124),
(122705,'enUS','','We\'ve got to hold out a bit longer.',26124),
(122706,'enUS','','On your toes, $n.$B$BDubin may be a stubborn dwarf, but he and I agree that one thing is certain - something doesn\'t feel right here.',26124),
(122707,'enUS','Do you feel the life in this forest? We have protected these lands for years. The time has finally come when we cannot protect these lands on our own anymore. Will you help us?','Do you feel the life in this forest? We have protected these lands for years. The time has finally come when we cannot protect these lands on our own anymore. Will you help us?',26124),
(122708,'enUS','','Do you have the courage to help us defeat the Legion?',26124),
(122709,'enUS','We must reclaim our sacred homelands.','',26124),
(122710,'enUS','The Kirin Tor appreciate your help.','',26124),
(122711,'enUS','Tell me about Illidan again.','Tell me about Illidan again.',26124),
(122712,'enUS','Tell me about Gul\'dan again.','Tell me about Gul\'dan again.',26124),
(122713,'enUS','Tell me about Khadgar again.','Tell me about Khadgar again.',26124),
(122714,'enUS','','Any trouble over here for the two of you? I heard reports of unstable energy in the area.',26124),
(122715,'enUS','','How are things over here? Any unusual disturbances?',26124),
(122716,'enUS','With the Order of the Silver Hand reformed under your leadership, we have new direction and guidance.$B$BWe have much work ahead of us.','',26124),
(122717,'enUS','','Hey Grindle... Oh boy. I\'m not even gonna ask. This one\'s all you.',26124),
(122718,'enUS','','Looks like you\'ve got it mostly under control.',26124),
(122719,'enUS','','$n! If I might have a moment, I have a few things in stock that I think you might be interested in.',26124),
(122720,'enUS','','You\'re in good hands. She\'ll have you out of there in no time!',26124),
(122721,'enUS','','$n! If I might have a moment, I have a few things in stock that I think you might be interested in.',26124),
(122722,'enUS','Master! I\'ve got good stuffs. Come look.','',26124),
(122723,'enUS','$n! If I might have a moment, I have a few things in stock that I think you might be interested in.','',26124),
(122724,'enUS','','Everything seems okay around here for now!',26124),
(122725,'enUS','I don\'t have time for pleasantries, demon hunter.$b$bAs I told the other Illidari, I have much to contemplate.$b$bI must prepare our armies to take on the Legion, even as some of my allies cry out for vengeance against the Horde.','',26124),
(122726,'enUS','$n! If I might have a moment, I have a few things in stock that I think you might be interested in.','',26124),
(122727,'enUS','','We\'ll let you know if we encounter anything.',26124),
(122728,'enUS','','$n! If I might have a moment, I have a few things in stock that I think you might be interested in.',26124),
(122729,'enUS','$n! If I might have a moment, I have a few things in stock that I think you might be interested in.','',26124),
(122730,'enUS','','$n! If I might have a moment, I have a few things in stock that I think you might be interested in.',26124),
(122731,'enUS','','$n! If I might have a moment, I have a few things in stock that I think you might be interested in.',26124),
(122732,'enUS','','$n! If I might have a moment, I have a few things in stock that I think you might be interested in.',26124),
(122733,'enUS','Nothing truly unusual. The occasional energy, but nothing I\'d consider dangerous.','Nothing truly unusual. The occasional energy, but nothing I\'d consider dangerous.',26124),
(122734,'enUS','','$n! If I might have a moment, I have a few things in stock that I think you might be interested in.',26124),
(122735,'enUS','$n! I have goods for you! Come!','',26124),
(122736,'enUS','After this I\'m going for a second dinner!','After this I\'m going for a second dinner!',26124),
(122737,'enUS','I\'ll have to show you my leaf collection sometime!','',26124),
(122738,'enUS','Every morning I run around the Wandering Isle... twice! I can\'t fall behind on my training.','',26124),
(122739,'enUS','I finished in second place during last week\'s yak races. I\'m going to need a faster yak!','',26124),
(122740,'enUS','The more I drink, the better my strategies... hic!','',26124),
(122741,'enUS','I\'ll have to show you my toy collection sometime!','',26124),
(122742,'enUS','I\'ll have to show you my mug collection sometime!','',26124),
(122743,'enUS','I\'ll have to show you my pet collection sometime!','',26124),
(122744,'enUS','I\'ll have to show you my scroll collection sometime!','',26124),
(122745,'enUS','I\'ll have to show you my coin collection sometime!','',26124),
(122746,'enUS','I\'ll have to show you my mount collection sometime!','',26124),
(122747,'enUS','I\'ll have to show you my tabard collection sometime!','',26124),
(122748,'enUS','This fight isn\'t fair! You need to send more reinforcements against me, demons!','',26124),
(122749,'enUS','What manner of mage are you?','',26124),
(122750,'enUS','You do what needs to be done. It is an admirable quality.','',26124),
(122751,'enUS','Illidan, you fight with both strength and grace. It is an honor to watch you do battle.','',26124),
(122752,'enUS','Your assistance against this manner of foe is appreciated.','',26124),
(122753,'enUS','I learn new battle tactics simply fighting by your side, Illidan.','',26124),
(122754,'enUS','My axe is yours.','',26124),
(122755,'enUS','Illidan! You ride that dragon like you were born to it!','',26124),
(122756,'enUS','I thought this relentless attack would never cease!','',26124),
(122757,'enUS','I will secure the skies, Captain. It seems you are still needed on the ground.','',26124),
(122758,'enUS','Through fire be cleansed, demons!','',26124),
(122759,'enUS','Illidan! I believe a dreadlord resides within the mausoleum. Your help is gladly received.','',26124),
(122760,'enUS','A worthy battle. I could never have defeated a dreadlord on my own.','',26124),
(122761,'enUS','I am not sure I am comfortable with this, Master Illidan.','',26124),
(122762,'enUS','I am no hero, Captain, but I will gladly stand by your side.','',26124),
(122763,'enUS','Master Illidan, you fight with such power!','',26124),
(122764,'enUS','This place was built to withstand almost any assault, but no one could have predicted the strength of the Legion.','',26124),
(122765,'enUS','I can only hope their sacrifice is worth it.','',26124),
(122766,'enUS','Your blade strikes true, Jarod. Come with me and end this assault!','',26124),
(122767,'enUS','I do what must be done.','',26124),
(122768,'enUS','Your sacrifice will be remembered.','',26124),
(122769,'enUS','I seem to have misplaced my Dalaran Hearthstone, may I have another?','I seem to have misplaced my Dalaran Hearthstone, may I have another?',26124),
(122770,'enUS','They fall from the sky with such aplomb. Ah, sweet catharsis.','',26124),
(122771,'enUS','The Legion thinks their tricks are unexpected, but we are prepared!','',26124),
(122772,'enUS','End this charade, demons! You know you cannot defeat me!','',26124),
(122773,'enUS','[%s] confesses: I don\'t know what a Healthstone is, and at this point I\'m too afraid to ask.','[%s] confesses: I don\'t know what a Healthstone is, and at this point I\'m too afraid to ask.',26124),
(122774,'enUS','[%s] confesses: I thought we had already defeated the Legion.','[%s] confesses: I thought we had already defeated the Legion.',26124),
(122775,'enUS','[%s] confesses: I can\'t believe how big Tauren weapons are.','[%s] confesses: I can\'t believe how big Tauren weapons are.',26124),
(122776,'enUS','[%s] confesses: I spent more time than I want to admit looking for Splashran in the ocean.','[%s] confesses: I spent more time than I want to admit looking for Splashran in the ocean.',26124),
(122777,'enUS','[%s] confesses: I vendor anything I don\'t need because I am too lazy to use the Auction House.','[%s] confesses: I vendor anything I don\'t need because I am too lazy to use the Auction House.',26124),
(122778,'enUS','[%s] confesses: I often wonder if Vrykul beards are softer than kittens.','[%s] confesses: I often wonder if Vrykul beards are softer than kittens.',26124),
(122779,'enUS','[%s] confesses: I never pay attention when discussing how to fight a new raid boss.','[%s] confesses: I never pay attention when discussing how to fight a new raid boss.',26124),
(122780,'enUS','[%s] confesses: I was that guy who always turns on Aspect of the Pack.','[%s] confesses: I was that guy who always turns on Aspect of the Pack.',26124),
(122781,'enUS','[%s] confesses: I like the old Dalaran better. Not that one, the other one.','[%s] confesses: I like the old Dalaran better. Not that one, the other one.',26124),
(122782,'enUS','[%s] confesses: I haven\'t visited my Garrison in a long time. I hope my followers are doing alright.','[%s] confesses: I haven\'t visited my Garrison in a long time. I hope my followers are doing alright.',26124),
(122783,'enUS','[%s] confesses: I secretly hoped one specific boat in my Shipyard would fail its mission. It never did.','[%s] confesses: I secretly hoped one specific boat in my Shipyard would fail its mission. It never did.',26124),
(122784,'enUS','[%s] confesses: I don\'t understand what it is called the Broken Isles. Aren\'t all islands broken apart?','[%s] confesses: I don\'t understand what it is called the Broken Isles. Aren\'t all islands broken apart?',26124),
(122785,'enUS','[%s] confesses: I really, really like the Goldshire Inn.','[%s] confesses: I really, really like the Goldshire Inn.',26124),
(122786,'enUS','[%s] confesses: I thought Garrosh was an okay guy.','[%s] confesses: I thought Garrosh was an okay guy.',26124),
(122787,'enUS','Finally, an opponent worthy of my axe!','',26124),
(122788,'enUS','[%s] confesses: I don\'t like fighting Gronn, I feel like they are always looking right at me.','[%s] confesses: I don\'t like fighting Gronn, I feel like they are always looking right at me.',26124),
(122789,'enUS','[%s] confesses: I undercut everybody when I sell something on the auction house because I can.','[%s] confesses: I undercut everybody when I sell something on the auction house because I can.',26124),
(122790,'enUS','The battle is joined, Master Illidan!','',26124),
(122791,'enUS','Keep this thing away from me!','Keep this thing away from me!',26124),
(122792,'enUS','Somebody stop this thing!','Somebody stop this thing!',26124),
(122793,'enUS','Can\'t anybody get these under control?','Can\'t anybody get these under control?',26124),
(122794,'enUS','','Help... me...',26124),
(122795,'enUS','','No hope...',26124),
(122796,'enUS','','The Light is gone...',26124),
(122797,'enUS','','So... lost...',26124),
(122798,'enUS','','Thank... you...',26124),
(122799,'enUS','','Free... at last...',26124),
(122800,'enUS','','I return... to the dark beyond...',26124),
(122801,'enUS','','Bless you...',26124),
(122802,'enUS','Oh no you don\'t!','',26124),
(122803,'enUS','Keep out of our shops!','',26124),
(122804,'enUS','This one\'s for you, $n!','',26124),
(122805,'enUS','Without him we will all be lost!','Without him we will all be lost!',26124),
(122806,'enUS','Nothing you do can stop them!','Nothing you do can stop them!',26124),
(122807,'enUS','','These things just keep on comin\'!',26124),
(122808,'enUS','The Light is gone! Don\'t you see?','The Light is gone! Don\'t you see?',26124),
(122809,'enUS','We are all doomed!','We are all doomed!',26124),
(122810,'enUS','I had an elaborate prison break all planned, but it seems you\'ve beaten me to it.','',26124),
(122811,'enUS','I am Archmage Khadgar, leader of the Kirin Tor. Demon hunters, Azeroth needs your help.','',26124),
(122812,'enUS','','Do the best you can, $n. We\'ll see how long we can hold these demons back.',26124),
(122813,'enUS','Be purged by my blade!','',26124),
(122814,'enUS','Meet your end!','',26124),
(122815,'enUS','I am just as surprised as you are, $n.','',26124),
(122816,'enUS','You will NOT succeed in your efforts!','',26124),
(122817,'enUS','May swift steel bring your end!','',26124),
(122818,'enUS','','Push them back! We cannot let Dalaran fall!',26124),
(122819,'enUS','I knew it! I could feel it!$B$BClear out the city, $n! We have to hold them off!','',26124),
(122820,'enUS','Soaring through the skies is immensely enjoyable!','',26124),
(122821,'enUS','|TInterface\\Icons\\sha_spell_warlock_demonsoul_nightmare:20|tUse Malfurion\'s |cFF00FFFF|Hspell:212630|h[Cleansed Ground]|h|r to avoid damage from |cFFFF0000|Hspell:210279|h[Creeping Nightmares]|h|r.','|TInterface\\Icons\\sha_spell_warlock_demonsoul_nightmare:20|tUse Malfurion\'s |cFF00FFFF|Hspell:212630|h[Cleansed Ground]|h|r to avoid damage from |cFFFF0000|Hspell:210279|h[Creeping Nightmares]|h|r.',26124),
(122822,'enUS','','An ancient memory stirs. When you are prepared, call to me and together we will uncover a piece of Illidan\'s past.',26124),
(122823,'enUS','','Illidan\'s was a life full of potential. His destiny forged in the great ordering and cast to the cosmic winds, where at last it would find a home on Azeroth. Within the tiny vessel the great cycle began anew.',26124),
(122824,'enUS','','Few have known such failure and rejection. Most would have given up, but Illidan would continue on, guided by the unseen hand of fate. His destiny lay elsewhere.',26124),
(122825,'enUS','','Difficult decisions had to be made, but to understand Illidan\'s perspective is essential if we are to succeed in our mission. What would you have done differently?',26124),
(122826,'enUS','','With his eyes burned out for seeing the truth, Illidan still did not falter. Even under the gaze of the lord of the Burning Legion, Illidan remained resolute and defiant.',26124),
(122827,'enUS','','Tyrande... The world is only as meaningful to us as the beings that inhabit it. Even in the end, Illidan saw her as clearly as the first time he laid eyes on her. He never lost sight of his world. You must ask yourself how far will you go for yours.',26124),
(122828,'enUS','To make matters worse, that monstrosity in the arena will burn the hold from the inside out if it is not stopped! Take your Moon Guard and rid Black Rook Hold of this demonic invasion!','',26124),
(122829,'enUS','Be on the lookout for Captain Shadowsong and his two foreign allies! We were separated in the initial assault. I pray they are still alive!','',26124),
(122830,'enUS','WHAT HAVE YOU DONE! YOU\'VE KILLED THEM ALL, ILLIDAN!','',26124),
(122831,'enUS','You are relieved of duty, Illidan. Rhonin, the Moon Guard are yours to command now.','',26124),
(122832,'enUS','I\'ve seen everything! Illidan! Ravencrest wants me to take over! We need to coordinate our attack and bring back some semblance of order!','',26124),
(122833,'enUS','','A gigantic beast has risen from the waters. Send it back to the depths!',26124),
(122834,'enUS','','Well done. We can rest easy... for now.',26124),
(122835,'enUS','','Those meddling ghost mages managed to conjure up a being of wild magic! Put them back in line.',26124),
(122836,'enUS','','The echoes of magic have subsided. You have our thanks.',26124),
(122837,'enUS','<Show Thalyssra\'s token to Valtrois.>','<Show Thalyssra\'s token to Valtrois.>',26124),
(122838,'enUS','','You may speak.',26124),
(122840,'enUS','Dead? The titans are dead?','',26124),
(122841,'enUS','It explains so much, yet I cannot help but feel an overwhelming sense of sadness.','',26124),
(122842,'enUS','We have been on our own all along. Our gods killed before we were born.','',26124),
(122843,'enUS','As for the Army of the Light and Illidan, I am at a loss. I have never felt so powerless.','',26124),
(122844,'enUS','Illidan is dead and the Golden Army fights an endless war in our name from across the cosmos...','',26124),
(122845,'enUS','','Praise to the goddess. She has blessed us this night with new life.',26124),
(122846,'enUS','','The birth of not one, but two healthy males.',26124),
(122847,'enUS','','What business do you have with me, $r?',26124),
(122848,'enUS','Are these your initials?','Are these your initials?',26124),
(122849,'enUS','Well done, Illidan, but the battle has only begun.','',26124),
(122850,'enUS','I would like to challenge Downfall again, mistress.','I would like to challenge Downfall again, mistress.',26124),
(122851,'enUS','The Legion has slain half of our forces and scattered the rest across the grounds. What you see here is all that remains of the Rooksguard protecting the hold.','',26124),
(122852,'enUS','You are our last hope, Illidan!','',26124),
(122853,'enUS','','THIEF! How DARE you steal what is mine?!',26124),
(122854,'enUS','','Your funeral.',26124),
(122855,'enUS','','%s shrugs indifferently and kicks you into the sky.',26124),
(122856,'enUS','Do what you must! Should Black Rook Hold fall, all of Suramar will fall with it!','',26124),
(122857,'enUS','Captain Stormrage has given us a fighting chance! Secure the rampart, Rooksguard! Advance!!','',26124),
(122858,'enUS','$n! Khadgar! Thank the Forge I found ye! Ye won\'t believe it! Me brother Magni\'s back!','',26124),
(122859,'enUS','','What\'s this?? Ravencrest has sent a pup to face me? I will teach you to respect your betters, child!',26124),
(122860,'enUS','','You... You killed your own soldiers?! You crazed fool! You\'ve sealed your own fate!',26124),
(122861,'enUS','','The pup... has fangs...',26124),
(122862,'enUS','','Run, little Ravencrest, Run! There may still be time for you to flee and live out your final miserable days cowering in a tree somewhere!',26124),
(122864,'enUS','Two?','',26124),
(122865,'enUS','','The Stormrage twins.',26124),
(122866,'enUS','','Beautiful. Nearly identical, except for-',26124),
(122867,'enUS','That one! His eyes are golden!','',26124),
(122868,'enUS','','Indeed. The child is destined for a great and prosperous future. His name... is Illidan.',26124),
(122869,'enUS','Illidan, your anger is misplaced. I have not insulted you.','',26124),
(122870,'enUS','You have cast me out, Cenarius!','',26124),
(122871,'enUS','No. You may remain here, but I will no longer be your teacher.','',26124),
(122872,'enUS','So...','',26124),
(122873,'enUS','So I must learn from... a NOVICE... instead of a MASTER?','',26124),
(122874,'enUS','You must learn respect.','',26124),
(122875,'enUS','To walk this path requires sacrifice, Illidan... Something you have yet to understand.','',26124),
(122876,'enUS','Brother-','',26124),
(122877,'enUS','Behold the Legion\'s power.','',26124),
(122878,'enUS','<Screams in agony>','',26124),
(122879,'enUS','No matter how hard this world fights, it will fall.','',26124),
(122880,'enUS','Our eyes... deceive us.','',26124),
(122881,'enUS','Beyond this army is another... and another... and another...','',26124),
(122882,'enUS','Even if we defeat them here, it will mean nothing.','',26124),
(122883,'enUS','We are doomed...','',26124),
(122884,'enUS','And I will find that way.','',26124),
(122886,'enUS','I will not fail you, my lord!','',26124),
(122887,'enUS','It took nearly all of our energy to conjure that protective barrier. If I push these Moon Guard any harder they will die.','',26124),
(122888,'enUS','If I can repair that deactivated portal I will have the reinforcements I require and a font of power to refresh my energy.','',26124),
(122889,'enUS','Illidan thinks to himself.','',26124),
(122890,'enUS','Excellent! The power radiating from the portal will energize me so long as I remain nearby. I must remember to return to these portals whenever I am fatigued.','',26124),
(122891,'enUS','I am ready, Lord Ravencrest! Lower the portcullis!','',26124),
(122892,'enUS','Lower the gate and brace yourselves! Glaive throwers at the ready!','',26124),
(122893,'enUS','At your command, captain!','At your command, captain!',26124),
(122894,'enUS','Archmage, we need to leave.','Archmage, we need to leave.',26124),
(122895,'enUS','Her fel magic is too strong. I could try and siphon energy from my Moon Guard and use it to unleash devastation upon this demon, but my mages will die too.','',26124),
(122896,'enUS','Alas, what choice exists? If I fail, Suramar falls tomorrow, and with it my beloved Tyrande. I must act now!','',26124),
(122897,'enUS','','You dare to defy the Burning Legion? Kneel before the unmatched power of fel!',26124),
(122898,'enUS','You were right, demon. Fel is more powerful than the arcane, but you wield it clumsily! Let me show you what destruction a master\'s touch can bring!','',26124),
(122899,'enUS','|TInterface\\Icons\\Spell_Nature_EyeOfTheStorm:20|t Hyrja begins to cast |cFFFF0404|Hspell:192305|h[Eye of the Storm]|h|r!','|TInterface\\Icons\\Spell_Nature_EyeOfTheStorm:20|t Hyrja begins to cast |cFFFF0404|Hspell:192305|h[Eye of the Storm]|h|r!',26124),
(122900,'enUS','|TInterface\\Icons\\Spell_Holy_HolyNova:20|t Hyrja begins to cast |cFFFF0404|Hspell:192206|h[Sanctify]|h|r!','|TInterface\\Icons\\Spell_Holy_HolyNova:20|t Hyrja begins to cast |cFFFF0404|Hspell:192206|h[Sanctify]|h|r!',26124),
(122906,'enUS','I\'m relieved we both made it out of Karazhan in one piece.','',26124),
(122907,'enUS','Archmage Modera and I will continue examining the tome we recovered from Karazhan. We WILL find those Pillars, $n!','',26124),
(122908,'enUS','Hmm... That gives me an idea... We\'ll discuss it when you\'ve handled those anomalies.','',26124),
(122911,'enUS','Blood and thunder, $n. Your ship, and glorious victory, await.','This is your ship, $n. Light be with you.',26124),
(122912,'enUS','How war gets the blood pumping, $n! Does your axe not thirst for a duel?','',26124),
(122923,'enUS','Can you hear the roar of battle already, $n? It calls to you!','',26124),
(122924,'enUS','$n interacts with the Starlight Rose Brew, granting everyone health and mana restoration!','$n interacts with the Starlight Rose Brew, granting everyone health and mana restoration!',26124),
(122925,'enUS','$n destroys the Infernal Tome, granting everyone damage reduction!','$n destroys the Infernal Tome, granting everyone damage reduction!',26124),
(122926,'enUS','$n absorbs the Fel Orb, granting everyone increased critical strike chance!','$n absorbs the Fel Orb, granting everyone increased critical strike chance!',26124),
(122927,'enUS','$n releases the Umbral Bloom spores, granting everyone increased haste!','$n releases the Umbral Bloom spores, granting everyone increased haste!',26124),
(122928,'enUS','$n interacts with the Nightshade Refreshments, granting everyone increased health!','$n interacts with the Nightshade Refreshments, granting everyone increased health!',26124),
(122929,'enUS','$n routes the power on the Magical Lantern, granting everyone increased damage!','$n routes the power on the Magical Lantern, granting everyone increased damage!',26124),
(122930,'enUS','$n interprets the Waterlogged Scroll, granting everyone increased movement speed!','$n interprets the Waterlogged Scroll, granting everyone increased movement speed!',26124),
(122932,'enUS','$n destroys the Arcane Power Conduit, overloading all Guardian Constructs!','$n destroys the Arcane Power Conduit, overloading all Guardian Constructs!',26124),
(122933,'enUS','$n sneakily adds poison to the Flask of the Solemn Night.','$n sneakily adds poison to the Flask of the Solemn Night.',26124),
(122934,'enUS','Brought all my big rocks for helpin\' da catapults. Gregg want to join da Horde!','This is your ship, $n. Light be with you.',26124),
(122935,'enUS','If you wish to continue studying the wilds, you may do so with your brother.','',26124),
(122936,'enUS','The six-eyed master has seen your fate, $n! You will fail, and worlds will burn!','',26124),
(122937,'enUS','There is just NO WAY this is a bad idea.','There is just NO WAY this is a bad idea.',26124),
(122938,'enUS','The Legion must be thwarted!','',26124),
(122939,'enUS','Dalaran will not fall, $n.','',26124),
(122940,'enUS','We will have victory over the Legion.','',26124),
(122941,'enUS','Begin the summoning.','Begin the summoning.',26124),
(122942,'enUS','I will summon the spirit of Alodi, the first Guardian of Tirisfal. Let me know when you would like me to begin.','',26124),
(122943,'enUS','Malfurion will become the first druid because he is a dedicated student. You... are NOT.','',26124),
(122944,'enUS','My carelessness forces me to fall back. I will learn from this defeat and strike back with a vengeance.','',26124),
(122945,'enUS','Let\'s not do that again!','Let\'s not do that again!',26124),
(122946,'enUS','I can see all of Suramar from here!','',26124),
(122947,'enUS','Perhaps the wind cleared up the fog.','',26124),
(122948,'enUS','There is no end to them!','',26124),
(122949,'enUS','For each demon I kill two more take its place!','',26124),
(122950,'enUS','I must find a way to close that gateway!','',26124),
(122951,'enUS','How could anything stand against such a force?','',26124),
(122952,'enUS','I will end this... I must!','',26124),
(122953,'enUS','I am Illidan, demon! Know my name for it spells your doom!','',26124),
(122954,'enUS','Thousands more! It appears as if the demon armies are coming from the portal in the courtyard below. I\'ll need to destroy it if we\'re to survive, but I\'ll need help from my Moon Guard.','',26124),
(122955,'enUS','Boldly you stand in defiance of the Great Burning Shadow! Minions, kill the \"hero\"!','',26124),
(122956,'enUS','There are too many demons. I... I\'ll need more of my Moon Guard\'s power. Do I go too far? No, I must remain focused! The future of my people lies in my hands!','',26124),
(122957,'enUS','The Nihilam portal is being protected by an eredar known as Balaadur. Conventional spells are useless against it. I\'ll have to call down the fury of the cosmos to destroy the portal. Then it will be just me and the demon.','',26124),
(122958,'enUS','Never have I felt such power... such agony...','',26124),
(122959,'enUS','I am nearly out of energy. I need to find a portal to rest at or siphon the essence of my Moon Guard.','',26124),
(122960,'enUS','I call forth the spirit of the first Guardian!','',26124),
(122961,'enUS','A summons! Ages have passed since I\'ve been called upon for aid.','',26124),
(122962,'enUS','Greetings, Alodi. I am Khadgar, archmage of the Kirin--','',26124),
(122963,'enUS','I know of you. The apprentice who refuses the mantle I first wore. What do you need of me?','',26124),
(122964,'enUS','The Burning Legion has returned. To stop them, we scoured the library of Karazhan for a tome you authored called \'Notable Antiquities of Ancient Azeroth\'.','',26124),
(122965,'enUS','You read my work? I didn\'t think the younger generation bothered with books anymore. Always playing games, adventuring about...','',26124),
(122966,'enUS','It\'s too bad we can\'t see Stormheim.','',26124),
(122967,'enUS','','We\'re seeking five ancient artifacts called the Pillars of Creation. Your writing didn\'t specify where to find them.',26124),
(122968,'enUS','Of course not! The Pillars represent primordial power. Even as Guardian, I dared not trifle with them.','',26124),
(122969,'enUS','Finding these artifacts is crucial. The Pillars are the only thing that can seal the Legion\'s portal in the Tomb of Sargeras.','',26124),
(122970,'enUS','Very well. My research led me to the Broken Isles. Though I never found their exact locations, I believe the Pillars lie in the hands of the peoples of that ancient land.','',26124),
(122971,'enUS','','That gives us a place to start, at least. We will search every inch of the Broken Isles if need be.',26124),
(122972,'enUS','Thank you, Guardian. You have served Azeroth once again.','',26124),
(122973,'enUS','You must make haste to find them. In the Legion\'s hands, the Pillars of Creation could unleash untold devastation upon our world. Good luck.','',26124),
(122974,'enUS','Where\'s the big diamond?','',26124),
(122975,'enUS','The diamond walked away?','',26124),
(122976,'enUS','Well if he\'s a diamond, I\'m sure he\'ll be okay. Diamonds are tough!','',26124),
(122977,'enUS','He\'s gone, lad. He left to follow a greater calling.','',26124),
(122978,'enUS','He\'s more than a precious stone. He\'s our king.','',26124),
(122979,'enUS','Thank you, lad. I hope you\'re right.','',26124),
(122980,'enUS','Speak to me when you\'re ready to begin, $n.','',26124),
(122981,'enUS','My friend at the orphanage said you\'d always pick the Forsaken above the Horde and abandon us. Is that true?','',26124),
(122982,'enUS','','I do not require defending, ambassador. Young one, the mantle of warchief is heavy, but I was chosen to bear the burden.',26124),
(122983,'enUS','','Now I stand for the Horde.',26124),
(122984,'enUS','','You needn\'t worry, child. I am your warchief.',26124),
(122985,'enUS','|TInterface\\Icons\\spell_shadow_zdemonformgreen:20|t%s is casting |cFFFF0000|Hspell:199193|h[Dreadlord\'s Guile]|h|r!','|TInterface\\Icons\\spell_shadow_zdemonformgreen:20|t%s is casting |cFFFF0000|Hspell:199193|h[Dreadlord\'s Guile]|h|r!',26124),
(122986,'enUS','Ya need some more trainin\'?','',26124),
(122987,'enUS','I am the mightiest mage-hunter in all of the cosmos! You stand no chance, little elf!','',26124),
(122988,'enUS','Illidan has taken the courtyard! Rooksguard, advance!','',26124),
(122989,'enUS','We will join the battle in the arena! Captain Stomrage, lead the charge!','',26124),
(122990,'enUS','I\'ve thrown everything I have at this creature to no avail. I must ask for the aid of my Moon Guard one final time.','',26124),
(122991,'enUS','Do something, Illidan! It\'s tearing us apart! The hold cannot take much more!','',26124),
(122992,'enUS','Mother Moon forgive me for what I do...','',26124),
(122993,'enUS','Illidan, no!','',26124),
(122994,'enUS','This cannot be!','',26124),
(122995,'enUS','Such savagery...','',26124),
(122996,'enUS','Are we no better than the monsters we fight?','',26124),
(122997,'enUS','What would you have me do, Kur\'talos? Simper and nod to our new Legion overlords as they turn our world to ash?','',26124),
(122998,'enUS','There is always a choice! We could have...','',26124),
(122999,'enUS','We could have what? You are blind, Ravencrest! You are all blind!','',26124),
(123000,'enUS','This was one invasion. They nearly killed everyone here and took Suramar.','',26124),
(123001,'enUS','The best any of you can do is criticize my methods? My mages died saving our world. What have you given? What have you sacrificed?','',26124),
(123002,'enUS','You\'re a damned fool, Ravencrest! No matter. I\'ve learned all I can from you.','',26124),
(123003,'enUS','We will never defeat the Legion so long as cowards hold the reins.','',26124),
(123004,'enUS','Farewell... and good luck. Perhaps you may fare better begging them for your lives next time.','',26124),
(123005,'enUS','Hunt this...','',26124),
(123006,'enUS','','|TInterface\\Icons\\Spell_Shadow_Possession:20|t %s begins to cast |cFFFF0000|Hspell:227233|h[Corrupted Bellow]|h|r. Look out!',26124),
(123007,'enUS','The resources of Dalaran are at your disposal. From here, heroes of Alliance and Horde alike will search for the Pillars of Creation!','',26124),
(123008,'enUS','I\'ve heard rumors of powerful artifacts that may be of use in your campaign. Keep an eye out and a useful lead just might present itself!','',26124),
(123009,'enUS','Now I must attend to other visitors. Good luck, $n!','',26124),
(123010,'enUS','We must gather our strength. The spell to move the city will be taxing.','',26124),
(123011,'enUS','','We\'ve never moved Dalaran twice in such a short span of time.',26124),
(123012,'enUS','I will aid you as best I can. It is an honor to serve the Kirin Tor.','',26124),
(123013,'enUS','Give us time to prepare, $n.$b$bProtect the city from the Legion, or use your map to find an invasion to stop.$b$bWhen the time is right to begin, I will call for you.','',26124),
(123014,'enUS','Brann Bronzebeard!? Well, this is unexpected.','',26124),
(123016,'enUS','Are you ready for me to dispel this barrier?','',26124),
(123017,'enUS','Let\'s save Magni!','Let\'s save Magni!',26124),
(123018,'enUS','Ye must go with Khadgar and find the Pillars, $n!','',26124),
(123019,'enUS','I am ready to leave for Karazhan.','I am ready to leave for Karazhan.',26124),
(123020,'enUS','Are ye ready ta enter the Planetarium?','',26124),
(123021,'enUS','Let\'s go inside!','Let\'s go inside!',26124),
(123023,'enUS','I would like to requisition some Black Harvest troops.','I would like to requisition some Black Harvest troops.',26124),
(123024,'enUS','The Earthen Ring is with ye, Farseer! We\'ll stand with ye against the Burning Legion no matter the cost!','',26124),
(123026,'enUS','The Ebon Blade shall prevail. None shall stand in our way... and live.','',26124),
(123027,'enUS','I have to jump into the arena to destroy that monstrosity. Mother Moon give me strength.','',26124),
(123028,'enUS','|TInterface\\Icons\\ability_mage_arcanebarrage_nightborne:20|tYou are targeted by |cFFF00000|Hspell:220871|h[Unstable Mana]|h|r!','',26124),
(123029,'enUS','You must be below level 101 to participate in Legion Invasions.','You must be below level 101 to participate in Legion Invasions.',26124),
(123030,'enUS','Do you have another Flight Master\'s Whistle?','Do you have another Flight Master\'s Whistle?',26124),
(123033,'enUS','You feel a staggering presence on the other side of the portal touch you for a moment...','You feel a staggering presence on the other side of the portal touch you for a moment...',26124),
(123035,'enUS','They don\'t pay me enough for this!','They don\'t pay me enough for this!',26124),
(123036,'enUS','I\'m not going back to the mailroom!','I\'m not going back to the mailroom!',26124),
(123037,'enUS','Love is an antiquated ideal born out of an instinctual response!','Love is an antiquated ideal born out of an instinctual response!',26124),
(123038,'enUS','<Beakbuck eyes you warily.>','',26124),
(123039,'enUS','<Ride Beakbuck.>','<Ride Beakbuck.>',26124),
(123040,'enUS','Jump over the effect to avoid damage from |cFFFF0404|Hspell:211901|h[Fusion Press]|h|r!','Jump over the effect to avoid damage from |cFFFF0404|Hspell:211901|h[Fusion Press]|h|r!',26124),
(123042,'enUS','%s and $n collided, causing a Grand Trine!','%s and $n collided, causing a Grand Trine!',26124),
(123043,'enUS','%s\'s Star Sign expired, causing a Grand Trine!','%s\'s Star Sign expired, causing a Grand Trine!',26124),
(123044,'enUS','','Now for something most magnificent!',26124),
(123045,'enUS','','This place could stand to be Galindre-fied!',26124),
(123046,'enUS','','How beautifully...tragic.',26124),
(123047,'enUS','','I\'m counting on you, $n.',26124),
(123048,'enUS','What is the mission?','What is the mission?',26124),
(123049,'enUS','Welcome, ladies and gentlemen, to our--OOF!','',26124),
(123050,'enUS','Shut your jabber, drama man! The Monkey King got another plan!','',26124),
(123051,'enUS','Tonight we got a horkin\' show, an ookin\' tale you think you know.','',26124),
(123052,'enUS','That evil Crone? She\'s not the worst. Another witch was nasty first.','',26124),
(123053,'enUS','','Are you ready to begin?',26124),
(123054,'enUS','Let\'s get underway.','Let\'s get underway.',26124),
(123055,'enUS','','|TInterface\\Icons\\spell_arcane_arcanetorrent_nightborne:20|tGalindre is casting |cFFFF0404|Hspell:227776|h[Magic Magnificent]|h|r! Use |TInterface\\Icons\\spell_priest_void blast:20|t|cFFFF0404|Hspell:227405|h[Defy Gravity]|h|r\'s vortices to escape!',26124),
(123060,'enUS','','Together, we\'re unlimited!',26124),
(123061,'enUS','','Follow my lead and you\'ll be popular!',26124),
(123062,'enUS','','Sorry to bring you down!',26124),
(123063,'enUS','','You deserve a chance to fly!',26124),
(123064,'enUS','','Come see my minions, and let them be heard!',26124),
(123065,'enUS','','elekkamomen otunbuntu rotu kelaramen!',26124),
(123066,'enUS','','That one needed a makeover.',26124),
(123067,'enUS','','Have you misplaced your wikket mind?',26124),
(123068,'enUS','','For the first time, I feel... wikket.',26124),
(123069,'enUS','','That was quite a commotion!',26124),
(123071,'enUS','Intruder! Sound the alarm!','Intruder! Sound the alarm!',26124),
(123072,'enUS','I\'ve been training for this moment!','I\'ve been training for this moment!',26124),
(123073,'enUS','You\'ll get no further, invader!','You\'ll get no further, invader!',26124),
(123074,'enUS','This world has no place for you, demon!','This world has no place for you, demon!',26124),
(123075,'enUS','Your kind is not welcome here!','Your kind is not welcome here!',26124),
(123076,'enUS','I\'ll wipe your blood off my blade, just like the rest!','I\'ll wipe your blood off my blade, just like the rest!',26124),
(123077,'enUS','I have slain hundreds before you. You\'ll simply be one more notch on my belt.','I have slain hundreds before you. You\'ll simply be one more notch on my belt.',26124),
(123078,'enUS','I will grant you a swift death, trespasser.','I will grant you a swift death, trespasser.',26124),
(123095,'enUS','I think it wise to divide our efforts. I\'ll work to circumvent the tower\'s magical defenses. You may need to take a more... blunt force approach.','',26124),
(123096,'enUS','','I failed you,  Sargeras...',26124),
(123097,'enUS','The army that marches on Azeroth is but a whisper of the Legion\'s true strength.','',26124),
(123098,'enUS','unless we find another way to fight them.','',26124),
(123099,'enUS','|cffADFF2F+$1i Nightfallen Reputation|r','|cffADFF2F+$1i Nightfallen Reputation|r',26124),
(123100,'enUS','|TInterface\\Icons\\Spell_Holy_InnerFire:20|t%s is casting |cFFFF0000|Hspell:227789|h[Sacred Ground]|h|r at you!','|TInterface\\Icons\\Spell_Holy_InnerFire:20|t%s is casting |cFFFF0000|Hspell:227789|h[Sacred Ground]|h|r at you!',26124),
(123101,'enUS','|TInterface\\Icons\\Spell_Holy_PrayerOfHealing:20|t%s is casting |cFFFF0000|Hspell:227508|h[Mass Repentance]|h|r!','|TInterface\\Icons\\Spell_Holy_PrayerOfHealing:20|t%s is casting |cFFFF0000|Hspell:227508|h[Mass Repentance]|h|r!',26124),
(123102,'enUS','It seems I have been too gentle. Have at thee!','',26124),
(123103,'enUS','Well done... so far! But I will judge for myself whether you are worthy!','',26124),
(123104,'enUS','Champions! You have spilled the blood of Helya\'s minions. The time has come to enter Helheim itself and end the sea witch\'s dark reign. But first... a final challenge!','',26124),
(123105,'enUS','Hymdall! Hyrja! Test the mettle of these mortals. I must be certain they possess the courage and skill needed for what is to come.','',26124),
(123106,'enUS','The battle is yours to begin, heroes!','',26124),
(123108,'enUS','','Elfyra, come down from there! You\'re fluttering about like one of those horrible monkey creatures!',26124),
(123109,'enUS','','Of course, dear! Though that old frock of yours... Oh, look! Some new friends have come to pay us a visit.',26124),
(123110,'enUS','','We all deserve a chance to fly! Hey, do you really think the Wizard will de-greenify me?',26124),
(123111,'enUS','','I don\'t have any friends... well, apart from you, Galindre.',26124),
(123112,'enUS','The Legion is assaulting Dalaran at Deadwind Pass, and assaulting it too hard apparently.\n\nWhy don\'t I just complete the ritual here and you can meet up with us over the Broken Isles?','',26124),
(123113,'enUS','I cannot get to Dalaran over Deadwind Pass to aid you, please teleport me to Dalaran in the Broken Isles directly.','I cannot get to Dalaran over Deadwind Pass to aid you, please teleport me to Dalaran in the Broken Isles directly.',26124),
(123114,'enUS','ENOUGH! Your worth is proven! With you as my champions, Helya will fall and I will at long last be free of the curse that binds me here.','',26124),
(123115,'enUS','You\'re not thinking I\'m someone else?','',26124),
(123116,'enUS','','Mrgrlglrllrr.',26124),
(123117,'enUS','Or that we\'ve met before?','',26124),
(123118,'enUS','','Grrmgmrlgmrrm.',26124),
(123119,'enUS','I felt, I knew something never before was going to happen, had to happen. But this is so much more.','',26124),
(123120,'enUS','','Mgrmglrm.',26124),
(123121,'enUS','It\'s so much to believe. You\'re not making a joke?','',26124),
(123122,'enUS','','Mlgrmgrlmgrmrrrmgrrr.',26124),
(123123,'enUS','','Mrrmgmrlgmm.',26124),
(123124,'enUS','','Grlmgmmrr!',26124),
(123126,'enUS','|TInterface\\Icons\\ability_bossfelmagnaron_rune.blp:20|t Odyn begins to |cFFFF0404|Hspell:227503|h[Draw Power]|h|r from the runes!','|TInterface\\Icons\\ability_bossfelmagnaron_rune.blp:20|t Odyn begins to |cFFFF0404|Hspell:227503|h[Draw Power]|h|r from the runes!',26124),
(123132,'enUS','I\'ve heard this tale before... <Skip the Legion introductory quests and begin your journey in Dalaran.>','I\'ve heard this tale before... <Skip the Legion introductory quests and begin your journey in Dalaran.>',26124),
(123133,'enUS','Are you sure you want to skip the Broken Shore introduction? \nThis quest can be reacquired from Archivist Elysiana in Dalaran City in the Broken Isles.','Are you sure you want to skip the Broken Shore introduction? \nThis quest can be reacquired from Archivist Elysiana in Dalaran City in the Broken Isles.',26124),
(123134,'enUS','The scent of blood is on the winds.','This is your ship, $n. Light be with you.',26124),
(123135,'enUS','The arcwine has soured... you must start over!','The arcwine has soured... you must start over!',26124),
(123138,'enUS','The Menagerie is for-- ERADICATE! ERADICATE!','',26124),
(123139,'enUS','Curator is no longer op... er... ation... al.','',26124),
(123140,'enUS','Overload in progress. Prepare for-- PURGE! PURGE! PURGE!','',26124),
(123141,'enUS','EXTERMINATED!','',26124),
(123142,'enUS','Attention guests: DIE! DIE! DIE!','',26124),
(123143,'enUS','Your withered will get lost if you leave them behind!','Your withered will get lost if you leave them behind!',26124),
(123144,'enUS','','Use Shamanistic Rage!',26124),
(123145,'enUS','Use Shamanistic Rage!','',26124),
(123146,'enUS','','Farondis is responsible for our curse... he will pay dearly!',26124),
(123147,'enUS','','There will never be peace with Farondis, so long as we are cursed!',26124),
(123148,'enUS','We\'re going to need more paint at this rate.','We\'re going to need more paint at this rate.',26124),
(123149,'enUS','There\'s so little time! I can\'t work under these conditions!','There\'s so little time! I can\'t work under these conditions!',26124),
(123150,'enUS','Survival hunters thrive in close quarters combat, where they use a combination of tools to viciously overwhelm their prey.','',26124),
(123151,'enUS','Survival hunters thrive in close quarters combat, where they use a combination of tools to viciously overwhelm their prey.','',26124),
(123152,'enUS','Alongside your trusty pet, you are the master of your environment. Call Pet will summon your pet to your side.','',26124),
(123154,'enUS','Use Call Pet to bring your pet to battle.','',26124),
(123156,'enUS','Your enemies will find that once you have them in your sights they are unlikely to escape.','',26124),
(123157,'enUS','Using your Harpoon ability you can snag your enemy and propel yourself towards them.','',26124),
(123158,'enUS','Use Harpoon against the target dummy.','',26124),
(123159,'enUS','Now that you have closed the distance to your prey it\'s time to wear them down with a wound they will have trouble recovering from.','',26124),
(123160,'enUS','Lacerate will cause your target to bleed, dealing damage to them over time.','',26124),
(123161,'enUS','Use Lacerate on the target dummy.','',26124),
(123162,'enUS','Remember to use Lacerate whenever your target is not affected by it.','',26124),
(123163,'enUS','It\'s time to team up on your target!','',26124),
(123164,'enUS','Flanking Strike is a coordinated attack between you and your pet that can do crippling damage.','',26124),
(123166,'enUS','Use Flanking Strike on the target dummy.','',26124),
(123167,'enUS','Your most powerful tactic is to get your opponent reeling and then steadily increase your damage until they are defeated.','',26124),
(123168,'enUS','Mongoose Bite is an attack that gets more powerful each time you use it.','',26124),
(123169,'enUS','Store up charges of Mongoose Bite, then unleash them all at once for maximum effect.','',26124),
(123170,'enUS','Use Mongoose Bite on the target dummy.','',26124),
(123174,'enUS','Sometimes you\'ll find yourself outnumbered. Don\'t worry, you can unleash destruction upon a host of adversaries at once!','',26124),
(123175,'enUS','Carve will sweep your weapon in front of you dealing damage to all targets in its path.','',26124),
(123176,'enUS','Use Carve to dispatch all the enemies.','',26124),
(123182,'enUS','Use Harpoon!','',26124),
(123183,'enUS','Use Lacerate!','',26124),
(123184,'enUS','Use Flanking Strike!','',26124),
(123185,'enUS','Use Mongoose Bite!','',26124),
(123186,'enUS','Use Carve to damage multiple enemies at once!','',26124),
(123187,'enUS','Use Feign Death to escape!','',26124),
(123194,'enUS','','Use Call Pet to bring your pet to battle.',26124),
(123195,'enUS','','Alongside your trusty pet, you are the master of your environment. Call Pet will summon your pet to your side.',26124),
(123198,'enUS','You will be flagged for PvP if you remain in this area!','You will be flagged for PvP if you remain in this area!',26124),
(123199,'enUS','I need another Mana Divining Stone.','I need another Mana Divining Stone.',26124),
(123200,'enUS','','Use Carve to dispatch all the enemies.',26124),
(123201,'enUS','','Carve will sweep your weapon in front of you dealing damage to all targets in its path.',26124),
(123202,'enUS','','Sometimes you\'ll find yourself outnumbered. Don\'t worry, you can unleash destruction upon a host of adversaries at once!',26124),
(123203,'enUS','','Survival hunters thrive in close quarters combat, where they use a combination of tools to viciously overwhelm their prey.',26124),
(123204,'enUS','','Survival hunters thrive in close quarters combat, where they use a combination of tools to viciously overwhelm their prey.',26124),
(123205,'enUS','','Use Mongoose Bite!',26124),
(123206,'enUS','','Use Lacerate!',26124),
(123207,'enUS','','Use Harpoon!',26124),
(123208,'enUS','','Use Flanking Strike!',26124),
(123209,'enUS','','Use Feign Death to escape!',26124),
(123210,'enUS','','Use Carve to damage multiple enemies at once!',26124),
(123211,'enUS','','Use Mongoose Bite on the target dummy.',26124),
(123212,'enUS','','Store up charges of Mongoose Bite, then unleash them all at once for maximum effect.',26124),
(123213,'enUS','','Mongoose Bite is an attack that gets more powerful each time you use it.',26124),
(123214,'enUS','','Your most powerful tactic is to get your opponent reeling and then steadily increase your damage until they are defeated.',26124),
(123215,'enUS','','Use Flanking Strike on the target dummy.',26124),
(123217,'enUS','','Flanking Strike is a coordinated attack between you and your pet that can do crippling damage.',26124),
(123218,'enUS','','It\'s time to team up on your target!',26124),
(123219,'enUS','','Remember to use Lacerate whenever your target is not affected by it.',26124),
(123220,'enUS','','Use Lacerate on the target dummy.',26124),
(123221,'enUS','','Lacerate will cause your target to bleed, dealing damage to them over time.',26124),
(123222,'enUS','','Now that you have closed the distance to your prey it\'s time to wear them down with a wound they will have trouble recovering from.',26124),
(123223,'enUS','','Use Harpoon against the target dummy.',26124),
(123224,'enUS','','Using your Harpoon ability you can snag your enemy and propel yourself towards them.',26124),
(123225,'enUS','','Your enemies will find that once you have them in your sights they are unlikely to escape.',26124),
(123226,'enUS','','Do you wish to hear a tale from the past, $n?',26124),
(123227,'enUS','I want to experience the Broken Shore and its aftermath.','I want to experience the Broken Shore and its aftermath.',26124),
(123228,'enUS','I want to experience the return of Magni Bronzebeard and Khadgar\'s adventures in Karazhan.','I want to experience the return of Magni Bronzebeard and Khadgar\'s adventures in Karazhan.',26124),
(123229,'enUS','I want to experience the Siege of Dalaran and summoning of Alodi.','I want to experience the Siege of Dalaran and summoning of Alodi.',26124),
(123230,'enUS','Um, what?','Um, what?',26124),
(123231,'enUS','|TInterface\\Icons\\spell_mage_infernoblast:20|tYou are targeted by |cFFF00000|Hspell:227615|h[Inferno Bolt]|h|r!','',26124),
(123232,'enUS','Simply stay within any given orb as it travels through the air and you\'ll be able to fly!  See, I\'m doing it right now!  Move from orb to orb to find out where they lead.','',26124),
(123233,'enUS','','It\'s simple really. Head over the cube and interact with it to start a round of its game. Simply follow the path it displays before filling out the entire grid and you\'ll score a round. Score enough rounds and the cube should activate for you.',26124),
(123234,'enUS','','Hop on one of my mana sabers and steer it through the tall nodes of Ley Energy you see around you. Steer it through enough Ley Energy to fully charge it and you\'ll be done!  Remember, the mana saber is great at going fast in a straight line; but it slows down through turns.  Try and minimize the amount of steering corrections you need.',26124),
(123239,'enUS','','I do not believe you possess the mental acuity to grasp the nature of portal magic.',26124),
(123240,'enUS','','As a mage, you are one of a select group that can conjure a portal to transport you back to this very place.  I can teach you if you are ready.',26124),
(123241,'enUS','The Legion\'s arrival is no surprise. The power beneath the tower existed long before you or I.$B$BIt is most unfortunate how we\'ve arrived in our current state, but I\'m afraid it was only a matter of time.','',26124),
(123244,'enUS','You are too far away! Move back in range before he gets away!','You are too far away! Move back in range before he gets away!',26124),
(123245,'enUS','Hey there, $n! You lookin\' to obliterate some gear? Maybe use some Obliterum to make the gear you\'re wearin\' more powerful? Then I\'m your dwarf! Ask away!','',26124),
(123246,'enUS','It\'s easy! You just take some crafted gear - you know, hats, rings, relics, flasks, that sort of thing - and you throw \'em right into this fella\'s little fiery mouth-area. Add some Blood of Sargeras, for fuel, and ka-pow! You\'ve got Obliterum!\n\nY\'see, those crafters are always usin\' stuff like FELWORT, DEMONSTEEL, and CHAOS CRYSTALS to make their gear. Lots o\' demony-stuff in that armor. Make the demony-stuff hot enough, and you\'ve got Obliterum!','',26124),
(123247,'enUS','Once you\'ve got enough obliterum ash, you can kinda sorta glump it together into a little ball. Then you just rub it onto your crafted armor, and the armor becomes stronger.','',26124),
(123248,'enUS','You watch your tongue! Desdemona was no donkey, she was a mule!\n\nAnyways, I sold her for three Bloods o\' Sargeras. I\'m gonna make some boots.','',26124),
(123249,'enUS','How do I get Obliterum?','How do I get Obliterum?',26124),
(123250,'enUS','What can I do with Obliterum?','What can I do with Obliterum?',26124),
(123251,'enUS','What happened to your donkey?','What happened to your donkey?',26124),
(123252,'enUS','','My magic will put an end to you!',26124),
(123253,'enUS','Puny creature... Muscle crush you!','',26124),
(123254,'enUS','Yes... your brain will do nicely... give it to me!','',26124),
(123255,'enUS','Let us see what resides in your soul, mortal.','',26124),
(123256,'enUS','Your soul is forfeit!','',26124),
(123257,'enUS','Fresh meat for my hounds!','',26124),
(123258,'enUS','','Struggle hard... I like my prey exhausted.',26124),
(123259,'enUS','I will fight her in your name, Odyn!','I will fight her in your name, Odyn!',26124),
(123260,'enUS','Will you venture into the depths of Helheim and slay Helya?','',26124),
(123261,'enUS','This one is a disaster. I want the Gnomish piece downstairs!','',26124),
(123262,'enUS','','Ok, ok... but you\'re buying brunch.',26124),
(123263,'enUS','','You are a fortunate individual! Of course, I\'ll need a sample of your brain tissue...',26124),
(123264,'enUS','Auugh! Gross! I feel funky.','',26124),
(123265,'enUS','The Nightborne Spy has gotten away!','The Nightborne Spy has gotten away!',26124),
(123266,'enUS','','Did you see that?! An epic-tier full-roaming vapor! Nasty one, too!',26124),
(123267,'enUS','Get Willy a healer! I haven\'t seen a gnome this pale since... oh wait, all gnomes are pale.','',26124),
(123268,'enUS','I don\'t believe the master is expecting you!','',26124),
(123269,'enUS','Perhaps your party would be more comfortable at the children\'s table.','',26124),
(123270,'enUS','Seems I\'ll be... retiring... for... the evening...','',26124),
(123271,'enUS','May I take your jacket?','',26124),
(123272,'enUS','Stop troubling the master\'s guests!','',26124),
(123273,'enUS','I appreciate your help, $n. I\'m sure my luck will change soon.$b$bSay, do you think my armor looks dark enough?','',26124),
(123274,'enUS','What do you sell, Moorgoth?','What do you sell, Moorgoth?',26124),
(123275,'enUS','Ladies and gentlemen, welcome to this evening\'s feature presentation!','',26124),
(123276,'enUS','Tonight... we meet two lovers born on opposite sides of Sentinel Hill.','',26124),
(123277,'enUS','Divided by generations of enmity, they are brought together by passion for dance... and violence!','',26124),
(123278,'enUS','As the song of their love rumbles across the fields, will it end in triumph... or tragedy? And now... on with the show!','',26124),
(123279,'enUS','Wanna go for a spin?','',26124),
(123280,'enUS','Now that\'s what I call a hot foot!','',26124),
(123281,'enUS','I\'m just gonna... play it cool.','',26124),
(123282,'enUS','It\'s you and me against the world, baby!','',26124),
(123283,'enUS','So ya wanna rumble, do ya?','',26124),
(123284,'enUS','Let\'s dance!','',26124),
(123285,'enUS','Beat it!','',26124),
(123286,'enUS','Go on... scram!','',26124),
(123287,'enUS','A gang that don\'t own the fields is nothin\'!','',26124),
(123288,'enUS','I dug you punks an early grave!','',26124),
(123289,'enUS','I\'ll never... stop saying... Mrrgria...','',26124),
(123290,'enUS','There\'s a... place for us... somewhere...','',26124),
(123291,'enUS','Brambley! I can hardly believe my eyes... yer alive!','',26124),
(123292,'enUS','Ehmm... what bones? Oh you mean these? I.. errh...','',26124),
(123293,'enUS','Aye...','',26124),
(123294,'enUS','What? Oh.. now that ye\' mention it...','',26124),
(123295,'enUS','What\'s with all the bones?','',26124),
(123296,'enUS','You thought those were my bones... didn\'t you?','',26124),
(123297,'enUS','That one isn\'t even human.','',26124),
(123298,'enUS','We should get out of here before it\'s too late.','',26124),
(123299,'enUS','Well, well! Another group of thieves trying to steal my horse!','',26124),
(123300,'enUS','My trophy collection grows!','',26124),
(123301,'enUS','Easy prey!','',26124),
(123302,'enUS','They had no chance! I kill for a living!','',26124),
(123303,'enUS','Well done, Midnight!','',26124),
(123304,'enUS','Rise up, Midnight! Stamp them into dust!','',26124),
(123305,'enUS','I... have become... the hunted.','',26124),
(123306,'enUS','Form ranks! Charge!','',26124),
(123307,'enUS','My quarry never escapes!','',26124),
(123308,'enUS','Time to face my quarry toe-to-toe!','',26124),
(123309,'enUS','We ride, Midnight! To victory!','',26124),
(123310,'enUS','The hound sniffs the air excitedly.','',26124),
(123311,'enUS','The hound stares in your direction.','',26124),
(123312,'enUS','The hound growls.','',26124),
(123313,'enUS','The demons o\' the Burnin\' Legion have got another thing comin\' if they think ol\' Angus is cooked! I\'ve got more tricks up mah\' sleeve than a Dalaran mage!','',26124),
(123314,'enUS','The Underbelly','The Underbelly',26124),
(123315,'enUS','A seedy place of thugs and criminals, and none too fragrant, either.$B$BThere are at least three ways in: Entrances in the east and west, and a well in the north.','A seedy place of thugs and criminals, and none too fragrant, either.$B$BThere are at least three ways in: Entrances in the east and west, and a well in the north.',26124),
(123316,'enUS','A Hero\'s Welcome is located right beside Greyfang Enclave in southwestern Dalaran.$B$BThe place boasts a beer garden and one of the city\'s finest cooking trainer in its kitchen.','A Hero\'s Welcome is located right beside Greyfang Enclave in southwestern Dalaran.$B$BThe place boasts a beer garden and one of the city\'s finest cooking trainer in its kitchen.',26124),
(123317,'enUS','You\'re looking for The Filthy Animal in the Horde quarter of Windrunner\'s Sanctuary, northeastern Dalaran.$B$BI am told it is a rather rough place, but with an excellent cooking trainer in its kitchen.','You\'re looking for The Filthy Animal in the Horde quarter of Windrunner\'s Sanctuary, northeastern Dalaran.$B$BI am told it is a rather rough place, but with an excellent cooking trainer in its kitchen.',26124),
(123318,'enUS','Krasus\' Landing is in easternmost Dalaran.$B$BThe city\'s flight master is there.','Krasus\' Landing is in easternmost Dalaran.$B$BThe city\'s flight master is there.',26124),
(123319,'enUS','Visiting members of the Alliance keep primarily to Greyfang\'s Enclave in southwestern Dalaran.$B$BThere is an inn there, as well as portals to various cities.','Visiting members of the Alliance keep primarily to Greyfang\'s Enclave in southwestern Dalaran.$B$BThere is an inn there, as well as portals to various cities.',26124),
(123320,'enUS','The visiting Horde keep primarily to the Windrunner\'s Sanctuary in northeastern Dalaran.$B$BThere is an inn there, as well as portals to the various cities.','The visiting Horde keep primarily to the Windrunner\'s Sanctuary in northeastern Dalaran.$B$BThere is an inn there, as well as portals to the various cities.',26124),
(123321,'enUS','Chamber of the Guardian','Chamber of the Guardian',26124),
(123322,'enUS','The Chamber of the Guardian is a magical focus located directly in the center of Dalaran.','The Chamber of the Guardian is a magical focus located directly in the center of Dalaran.',26124),
(123323,'enUS','You are in luck! A new shop called Things of the Past has recently opened its doors in the Magus Commerce Exchange.','You are in luck! A new shop called Things of the Past has recently opened its doors in the Magus Commerce Exchange.',26124),
(123324,'enUS','I would like to witness the fall of Illidan Stormrage at the Black Temple again, Xe\'ra.','I would like to witness the fall of Illidan Stormrage at the Black Temple again, Xe\'ra.',26124),
(123325,'enUS','','You carry with you the Claws of Ashamane, druid. We still tell stories of her bravery throughout the grove.',26124),
(123326,'enUS','','I see you\'ve recovered the Claws of Ursoc from the Emerald Dream. Can you match his tenacity, druid?',26124),
(123327,'enUS','I sense the spirit of a wild beast within you, druid. As though Ashamane stalks among us again.','I sense the spirit of a wild beast within you, druid. As though Ashamane stalks among us again.',26124),
(123328,'enUS','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',26124),
(123329,'enUS','The Fangs of Ashamane - what a wonder you wield, $n! The great panther spirit died fighting the Legion in the grove just below us.','The Fangs of Ashamane - what a wonder you wield, $n! The great panther spirit died fighting the Legion in the grove just below us.',26124),
(123330,'enUS','Miners trainers and supplies are found upstairs in Tanks for Everything in the Magus Commerce Exchange, northwest Dalaran.','Miners trainers and supplies are found upstairs in Tanks for Everything in the Magus Commerce Exchange, northwest Dalaran.',26124),
(123331,'enUS','Applebough\'s fruit cart is usually in southwest Dalaran.','Applebough\'s fruit cart is usually in southwest Dalaran.',26124),
(123332,'enUS','Do you see, Farah? $n is here. So long as the spirit of Ursoc walks among us, we have nothing to fear from the harpies.','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',26124),
(123333,'enUS','','Wait a moment, $n. Is that the ancient bow of the Windrunners? My father fought alongside Alleria in the second war. I never thought we\'d see that weapon again...',26124),
(123334,'enUS','Ah. HAH! Hunter. That bow of yours. It is the weapon of a champion. I sense it\'s gone beyond this world, has it not?','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',26124),
(123335,'enUS','Oh yes, $n! Those daggers of yours would cut quite a swath through the Legion, wouldn\'t they? Are those demon bits? Biting the hand that breeds them? I like what I see.','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',26124),
(123336,'enUS','','Rogue, are those - demon fangs? Are you using demon teeth as a weapon? That\'s disgusting!',26124),
(123337,'enUS','','$n, are you dual-wielding demon fangs? I like the way you think!',26124),
(123338,'enUS','','Help us... priest... your staff shines with a light such that I\'ve never seen before...',26124),
(123343,'enUS','','Ohhh... do you feel that? A warmth in the air? A great light shines from within this strange priest\'s staff...',26124),
(123344,'enUS','<Snorting, slurring his words as he speaks.>$B$BNo! Friend must not hurt Rezzle!','',26124),
(123345,'enUS','What are you doing here?','What are you doing here?',26124),
(123346,'enUS','It\'s good to see Alodi\'s greatstaff in the hands of such a skilled mage, $n. The Kirin Tor is counting on you!','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',26124),
(123347,'enUS','Why shouldn\'t I kill you, demon?','Why shouldn\'t I kill you, demon?',26124),
(123348,'enUS','A bitter chill in the air... and here is the source. This mage bears the staff of the first guardian.','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',26124),
(123349,'enUS','As Midnight falters, the Huntsman attacks afoot!','As Midnight falters, the Huntsman attacks afoot!',26124),
(123350,'enUS','You bring the fury of the winds to Thunder Totem, monk. As though you hold a stormcloud in each fist.','You bring the fury of the winds to Thunder Totem, monk. As though you hold a stormcloud in each fist.',26124),
(123351,'enUS','Look here, Brulf. This one has the fury of twin storms in $ghis:her; hands. Ha-hah, fight on little $r!','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',26124),
(123352,'enUS','Rezzle following mistress\' orders!$B$BRezzle only gather samples for magics.','',26124),
(123353,'enUS','Magic? What kind of magic?','Magic? What kind of magic?',26124),
(123354,'enUS','The Thicket is a dangerous place, would you like me to transport you out?','',26124),
(123355,'enUS','I need to be transported out of here.','I need to be transported out of here.',26124),
(123356,'enUS','Rezzle not know magic, friend. Rezzle only carry things!$B$BIf Rezzle learn magic, Rezzle no gather samples for mistress...$B$B<Smirking wildly.>$B$BRezzle make own magic.','',26124),
(123357,'enUS','So, you\'re a servant?','So, you\'re a servant?',26124),
(123358,'enUS','Yes... YES! Rezzle serve well! Rezzle serve...$B$B<The demon glances around nervously.>','',26124),
(123359,'enUS','I don\'t have time for games! Tell me of your master.','I don\'t have time for games! Tell me of your master.',26124),
(123360,'enUS','Careful, monk. There\'s a storm coming.','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',26124),
(123361,'enUS','%s eyes $n\'s weapons.','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',26124),
(123362,'enUS','Nevermind that. You ARE the storm.','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',26124),
(123363,'enUS','I have no use for you, demon!','I have no use for you, demon!',26124),
(123364,'enUS','Mistress ordered to keep mortals out of tower. Her master needs tower for VERY big magic. In Burning Legion, even masters have masters!','',26124),
(123365,'enUS','<Rezzle cowers, stooping closer to the stone beneath his feet.>$B$BNo hitting Rezzle! If friend hurts Rezzle, Rezzle cannot help friend.$B$BRezzle knows things to help friend!','',26124),
(123366,'enUS','Very well, continue.','Very well, continue.',26124),
(123367,'enUS','You\'d better be telling the truth, Rezzle!','You\'d better be telling the truth, Rezzle!',26124),
(123368,'enUS','Priest... that staff you carry... it is unstable. I can sense its chaos from here.','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',26124),
(123369,'enUS','','This priest is certain to help us, Mardranel. I sense a great holy energy in $ghis:her; staff - powerful, yet barely contained.',26124),
(123370,'enUS','Good evening, ladies and gentlemen. We proudly welcome you to this evening\'s feature presentation!','',26124),
(123371,'enUS','Tonight... a tale of romance and rage, one which will prove once and for all if beauty is more than skin deep.','',26124),
(123372,'enUS','Can the fair Bella learn to love the surly Brute? Or will a ghastly curse claim the lives of the prince and his servants?','',26124),
(123373,'enUS','See for yourself whether the rose of passion blooms beneath a beastly veneer! And now... on with the show!','',26124),
(123374,'enUS','Luminore! Mrs. Cauldrons! Babblet! Let us disperse with these interlopers!','',26124),
(123375,'enUS','Delightful! One less guest for dinner!','',26124),
(123376,'enUS','Never stand in the way of true love!','',26124),
(123377,'enUS','It seems... my rose... has... wilted...','',26124),
(123378,'enUS','Zee candle MINE!','',26124),
(123379,'enUS','No... take... zee... candle...','',26124),
(123380,'enUS','Quickly now! Get rid of them!','',26124),
(123381,'enUS','Zee true love, eet burnses!','',26124),
(123382,'enUS','','Hope I don\'t spoil your appetite, dearies!',26124),
(123383,'enUS','','Guess I\'m... sleeping in... the cupboard.',26124),
(123384,'enUS','','That didn\'t go very well at all, did it?',26124),
(123385,'enUS','','That\'ll teach you to flirt with my boyfriend!',26124),
(123386,'enUS','','Only beauty... can kill... a brute...',26124),
(123387,'enUS','','Who... who are you?',26124),
(123388,'enUS','The master of this castle! You will be my guest for dinner!','',26124),
(123389,'enUS','','Never! I only dine with gentlemen, not a brute like you!',26124),
(123390,'enUS','Fine! Starve to death for all I care!','',26124),
(123391,'enUS','Oh no, no, no... this won\'t do! You outsiders will ruin our final chance to break the curse!','',26124),
(123392,'enUS','','If you didn\'t yell all the time, I wouldn\'t run away.',26124),
(123393,'enUS','I don\'t yell ALL the time. WHY DO YOU ALWAYS SAY THAT?!','',26124),
(123394,'enUS','','There you go again!',26124),
(123395,'enUS','Fine. Hey, do you like books?','',26124),
(123396,'enUS','','Oooooh, I love books!',26124),
(123397,'enUS','It\'s working! It\'s working!','',26124),
(123398,'enUS','The curse... it\'s... killing me...','',26124),
(123399,'enUS','','No! Our dinners together... those hours in the library... Oh Brute, I love you!',26124),
(123400,'enUS','It\'s... too... late...','',26124),
(123401,'enUS','','<Gasp> Who are you?!',26124),
(123402,'enUS','Bella... it\'s me!','',26124),
(123403,'enUS','','It IS you! Come, my love. Off to our happily ever after!',26124),
(123404,'enUS','','This one reeks of fel energy. Hey, warlock! Is that the Scepter of Sargeras? How did you cajole the Kirin Tor into giving that thing up?',26124),
(123405,'enUS','Oh good. Here comes $n with the Scepter of Sargeras. You know, in case we need to punch a hole in spacetime and shatter the planet.','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',26124),
(123406,'enUS','I say, $r. Is that the Scepter of Sargeras? Indeed! Quite the dodgy bit of history you\'ve got there, hm?','The others have not misled me - the spirit of Ursoc has come to Thunder Totem!',26124),
(123407,'enUS','','No one... mourns... the wikket...',26124),
(123408,'enUS','','If you\'re my friend, you\'ll make the hozen get rid of these interlopers... then we\'re off to see the Wizard!',26124),
(123409,'enUS','','Some have... wikketness... thrust... upon them...',26124),
(123410,'enUS','','I... loathe... all you... ookers...',26124),
(123411,'enUS','This action costs 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?','This action costs 10 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?',26124),
(123412,'enUS','This action costs 15 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?','This action costs 15 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?',26124),
(123413,'enUS','This action costs 5 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?','This action costs 5 |TINTERFACE\\ICONS\\INV_MISC_ANCIENT_MANA.BLP:15|t Ancient Mana. Do you wish to continue?',26124),
(123415,'enUS','','Mrgrrlmgrr.',26124),
(123416,'enUS','Ah, faithful Midnight. For many years, our countless hunts provided game for the master\'s table.','',26124),
(123417,'enUS','These days we hunt for sport... and the glory of the kill!','',26124),
(123418,'enUS','My... long hunt... has ended.','',26124),
(123419,'enUS','Good show, old friend! Let\'s fetch you some oats.','',26124),
(123420,'enUS','Sound effect for troops','',26124),
(123421,'enUS','Welcome to the-- TERMINATE INTRUDERS!','',26124),
(123422,'enUS','System... failure... im... mi... nent...','',26124),
(123423,'enUS','Countermeasures deployed.','',26124),
(123424,'enUS','DETERRENT ACTIVATED!','',26124),
(123425,'enUS','I do so detest party crashers!','',26124),
(123426,'enUS','Deterrent protocols successful.','',26124),
(123427,'enUS','The master hasn\'t been himself for quite some time. Perhaps a feast will brighten his spirit!','',26124),
(123428,'enUS','Janitorial units: begin Menagerie decontamination.','',26124),
(123429,'enUS','The guards really must do a better job of keeping out the ruffians.','',26124),
(123430,'enUS','Master... I hope... I served you... well...','',26124),
(123431,'enUS','I insist you dress for dinner!','',26124),
(123432,'enUS','Mind your manners!','',26124),
(123433,'enUS','','|TInterface\\Icons\\SPELL_SHAMAN_TIDALWAVES.BLP:20|t %s calls upon the |cFFFF0000|Hspell:228300|h[Fury of the Maw]|h|r. Get to high ground!',26124),
(123434,'enUS','','|TInterface\\Icons\\achievement_dungeon_MawofSouls.blp:20|t A thick mist rolls into the bay...',26124),
(123435,'enUS','|TInterface\\Icons\\Spell_Shadow_Charm:20|t%s inhales deeply for a |cFFFF0000|Hspell:228837|h[Bellowing Roar]|h|r!','',26124),
(123436,'enUS','|TInterface\\Icons\\SPELL_SHADOW_LIFEDRAIN02:20|t%s begins to |cFFFF0000|Hspell:228835|h[Absorb Vitality]|h|r from |cFFFF0000$n|r!','',26124),
(123438,'enUS','Weakness is never tolerated.','',26124),
(123439,'enUS','What do you require?','What do you require?',26124),
(123440,'enUS','For aeons, Helya has been building an army. Stealing the souls of fallen vrykul to oppose the Valarjar.','',26124),
(123441,'enUS','Traitor!','Traitor!',26124),
(123442,'enUS','You are one of them! Die, interloper!','You are one of them! Die, interloper!',26124),
(123443,'enUS','Rebel! I will end you!','Rebel! I will end you!',26124),
(123444,'enUS','Elisande will praise me for killing you!','Elisande will praise me for killing you!',26124),
(123445,'enUS','You dare show yourself here!? Die, fiend!','You dare show yourself here!? Die, fiend!',26124),
(123446,'enUS','I thought I was the only one... I stand with the Dusk Lily!','I thought I was the only one... I stand with the Dusk Lily!',26124),
(123447,'enUS','I cannot believe what Elisande is doing to her own people. I must fight back!','I cannot believe what Elisande is doing to her own people. I must fight back!',26124),
(123448,'enUS','I kept quiet when the demons came, but this... this is unspeakable.','I kept quiet when the demons came, but this... this is unspeakable.',26124),
(123449,'enUS','I knew there were others! I will no longer bloody my hands for Elisande!','I knew there were others! I will no longer bloody my hands for Elisande!',26124),
(123450,'enUS','Elisande must be stopped!','Elisande must be stopped!',26124),
(123451,'enUS','This is too much... if I must be labeled a traitor then so be it!','This is too much... if I must be labeled a traitor then so be it!',26124),
(123452,'enUS','Helya has taken the souls of those Valarjar? Impossible! Strike her mystics down, then return to me.','',26124),
(123453,'enUS','Seeing her master fall, Midnight unleashes all her fury!','Seeing her master fall, Midnight unleashes all her fury!',26124),
(123454,'enUS','How dare she so brashly oppose me!','',26124),
(123455,'enUS','Helya can corrupt the Stormforged!','Helya can corrupt the Stormforged!',26124),
(123456,'enUS','DELETE','',26124),
(123457,'enUS','No need to delay. Onto the pad with you.','',26124),
(123459,'enUS','DELETE','',26124),
(123460,'enUS','','It\'s too late for me. They took... Vanthir...',26124),
(123461,'enUS','Elisande knows about Vanthir\'s involvement in the rebellion. He is gone.','',26124),
(123468,'enUS','Brigitte? Emille?! Where are you?','',26124),
(123469,'enUS','Praise all that is good... you are both safe. Come, let us get out of here!','',26124),
(123471,'enUS','Where is it? The master\'s vase?','',26124),
(123472,'enUS','Oh, thank you! This masterpiece is worth my life a hundred times over.','',26124),
(123473,'enUS','','%s spits on the corpse of the demon.',26124),
(123474,'enUS','','I told him not to take one step closer.',26124),
(123476,'enUS','','I know where to find Shal\'Aran. Come, ladies. We are no longer safe in the city.',26124),
(123477,'enUS','Get up! We must leave!','',26124),
(123479,'enUS','F-father... Run...','',26124),
(123480,'enUS','Outlander, can you hear me? Outlander? I am going to teleport a beacon your way!','',26124),
(123481,'enUS','','Behold this motley throng in which the rebels put their faith.',26124),
(123482,'enUS','','Kaldorei? You disgrace a glorious past, hiding in trees and cloaking yourselves in false piety. You have grown as savage as the trolls that skulk about your forests.',26124),
(123483,'enUS','','Quel\'dorei? You are peasants playing at nobility, all too willing to mingle with lesser races that dilute your bloodline. You are unworthy of the name high elves.',26124),
(123484,'enUS','','Sin\'dorei? Of all the elves, I thought you might understand the choice I made to save my people. Instead, you ally with misfits and monsters.',26124),
(123485,'enUS','','Each of you has debased your proud lineage. Each of you has forgotten the ancient power that is our birthright.',26124),
(123486,'enUS','','But Suramar remembers! We are the Nightborne, last of the true elves. The rest of you are hollow echoes of our greatness.',26124),
(123487,'enUS','','Let this failed rebellion be a lesson to any that would stand against the shal\'dorei!',26124),
(123489,'enUS','Double your efforts, lest you go by the board!','',26124),
(123490,'enUS','All hands report! We are to get underway!','',26124),
(123491,'enUS','Helya beckons!','',26124),
(123492,'enUS','You\'re... too late...','',26124),
(123493,'enUS','Noooooo!','',26124),
(123494,'enUS','I suspect the sea witch grows impatient, eager to begin her campaign by conquering the Broken Isles.','',26124),
(123495,'enUS','Helya\'s foul magics trap Odyn and hinder the Valarjar. We need champions like you to stop her advances.','',26124),
(123496,'enUS','Helya must be stopped. The time has come for a reckoning!','',26124),
(123497,'enUS','I have had enough of that foul sorceress\' games!','',26124),
(123498,'enUS','That sea witch must learn the price of her defiance!','',26124),
(123499,'enUS','','Lasuel and I have been friends since we were children. We shared the best times of our lives together.',26124),
(123500,'enUS','Leave us be, pests!','',26124),
(123501,'enUS','Lousy imps! Let us work!','',26124),
(123502,'enUS','Mean dooker locked up all us hozen! Another path she should have chosen.','',26124),
(123503,'enUS','So sit and slerp, relax a jibbet! Enjoy the show that we call... Wikket!','',26124),
(123504,'enUS','','Arcanist Thalyssra. I remember where your order stood in the War of the Ancients. How do we know you won\'t betray us and become the next Elisande... the next Azshara?',26124),
(123505,'enUS','','The kaldorei will fight to see the Legion defeated and the Nightwell destroyed. Beyond that... we shall see where Elune\'s wisdom guides us.',26124),
(123506,'enUS','','And once your rival is defeated, why should we believe you won\'t betray us for the Nightwell\'s arcane power and become the next Elisande... the next Azshara?',26124),
(123507,'enUS','','We know where Elisande\'s path would lead us, and ask for your help to end her reign.',26124),
(123508,'enUS','','We do not intend to be slaves to the Nightwell. We seek to drive the Legion from Suramar and put an end to Elisande\'s oppression.',26124),
(123509,'enUS','','[CUT]If that is your wish, so be it. When this war is won, my people will need allies. It is clear you will not be among them.',26124),
(123511,'enUS','DELETE','',26124),
(123512,'enUS','','I understand the struggles of the Nightfallen echo our own, First Arcanist. Addiction.... betrayal...',26124),
(123513,'enUS','','Cleanse it we shall. The sin\'dorei bring righteous fury upon our enemies.',26124),
(123514,'enUS','','There is a cure for our addiction, but it will take time to administer it to all of our people. First we must depose Elisande and cleanse Suramar of the Legion\'s filth.',26124),
(123515,'enUS','Thank you for coming. We are here to discuss our mutual interests.','',26124),
(123516,'enUS','[CUT]We share a common goal. We must stop the Burning Legion and Gul\'dan at all costs.','',26124),
(123517,'enUS','Thalyssra, your knowledge of the enemy will be crucial in the battle ahead. We shall call on you as needed.','',26124),
(123518,'enUS','Thank you for coming. We are here to discuss our mutual interests.','',26124),
(123519,'enUS','This way, $n! Archmage Leryda and I will hold them off as long as we can, but you must hurry!','',26124),
(123520,'enUS','','Alturus, watchout! Oh, is that you, $n? You look... different.',26124),
(123521,'enUS','Your Arcane-Infused Vial warms as it emanates a soft glow.','Your Arcane-Infused Vial warms as it emanates a soft glow.',26124),
(123522,'enUS','|TInterface\\Icons\\INV_Misc_Horn_03:20|t Hymdall begins to blow the |cFFFF0404|Hspell:228012|h[Horn of Valor]|h|r!','|TInterface\\Icons\\INV_Misc_Horn_03:20|t Hymdall begins to blow the |cFFFF0404|Hspell:228012|h[Horn of Valor]|h|r!',26124),
(123523,'enUS','','... As you say.',26124),
(123524,'enUS','','Not an undeserved reaction. Ordinarily I would be obliged to slay you both.',26124),
(123525,'enUS','','Present circumstances make us allies.',26124),
(123526,'enUS','|TINTERFACE\\ICONS\\SPELL_SHAMAN_IMPROVEDFIRENOVA:20|tShade of Medivh begins to cast |cFFF00000|Hspell:228269|h[Flame Wreath]|h|r!','|TINTERFACE\\ICONS\\SPELL_SHAMAN_IMPROVEDFIRENOVA:20|tShade of Medivh begins to cast |cFFF00000|Hspell:228269|h[Flame Wreath]|h|r!',26124),
(123527,'enUS','Felsoul Hold... of all the ways she has betrayed us, this is surely the worst.','',26124),
(123528,'enUS','|TInterface\\Icons\\INV_Polearm_2H_OdynSpear_D_01.blp:20|t Odyn targets you with a |cFFFF0404|Hspell:228918|h[Stormforged Spear]|h|r!','|TInterface\\Icons\\INV_Polearm_2H_OdynSpear_D_01.blp:20|t Odyn targets you with a |cFFFF0404|Hspell:228918|h[Stormforged Spear]|h|r!',26124),
(123529,'enUS','','|TInterface\\Icons\\inv_misc_monsterhorn_03.blp:20|t A %s emerges near Helya!',26124),
(123530,'enUS','The Nightborne have agreed to cast off their unwanted.','',26124),
(123531,'enUS','The passage to Felsoul Hold is open. See that our prisoners reach their destination.','',26124),
(123532,'enUS','The Soul Engine will consume! Kar Dan\'Ashj!','',26124),
(123533,'enUS','','DELETE ME',26124),
(123534,'enUS','We need a foothold, somewhere we can keep an eye on things.','',26124),
(123535,'enUS','Tichar! Your attention!','',26124),
(123536,'enUS','Ahhh, much better. You had us worried for a moment there.','',26124),
(123537,'enUS','The stench of the Kvaldir pollutes Azsuna\'s shores! Push them back into the sea!','',26124),
(123538,'enUS','We have drawn our line in the sand. The Helarjar will find no quarter here.','',26124),
(123540,'enUS','Let there be no slack in their chains!','',26124),
(123541,'enUS','Pick up the pace! The Soul Engine awaits!','',26124),
(123542,'enUS','We must not leave the Soul Engine waiting!','',26124),
(123543,'enUS','More come from Suramar every hour! Move out! Make room!','',26124),
(123544,'enUS','Let us not squander this gift of souls. Move them out!','',26124),
(123545,'enUS','','We will hold the perimeter!',26124),
(123546,'enUS','Work quickly, my friend.','',26124),
(123547,'enUS','','Make sure you teach that demon a lesson.',26124),
(123548,'enUS','The Legion bears down on us, we have but moments to spare.\n\nThe shockwave of arcane energies we are about to unleash should prove powerful enough to send them back to their cursed dimension for a time, giving us time to catch our breath and begin the search for the Pillars of Creation.\n\nAre you ready?','',26124),
(123549,'enUS','I am ready, begin the teleportation of Dalaran to the Broken Isles.','I am ready, begin the teleportation of Dalaran to the Broken Isles.',26124),
(123550,'enUS','','I am glad to see a friendly face on this battlefield, $p.$b$bIt is... hard... for me to once again walk in Suramar. Ten thousand years have passed since my feet last felt the grass of this land.$b$bBack then, we were fleeing the Burning Legion.$b$bI never believed I would return to the place of my birth to wrest it from the grasp of those I once believed were my people.',26124),
(123551,'enUS','','Speak quickly, $r. I do not want you lingering in my camp.$b$bYour Horde left a good friend of mine to die on the Broken Shore. Be grateful we have a common enemy for the time being.',26124),
(123552,'enUS','','When I let you take the Tears of Elune, I assumed the next time we would see each other would be at the final battle with the Legion.$b$bI did not expect to see you in the company of mana addicts at the footsteps of the city of my birth.$b$bSpeak quickly, $r. I am not in the mood for Thalyssra\'s petitions.',26124),
(123553,'enUS','','Suramar. I was born here. Never in ten thousand years did I believe I would return with an army to claim it from the same elves I once looked to for protection.',26124),
(123554,'enUS','Plans from Thalyssra.','Plans from Thalyssra.',26124),
(123555,'enUS','','So the time has come to march an army upon the city of my birth. May Elune grant us a quick end to this conflict.',26124),
(123556,'enUS','The Magistrix\'s thugs are impeding Deline\'s efforts to distribute arcwine. Find her in the canals and protect her as she feeds our people.','',26124),
(123557,'enUS','','I must speak with you, champion. Meet with me as soon as you are able.',26124),
(123558,'enUS','','I never thought I would share a camp with the kaldorei. But, desperate times, desperate measures.',26124),
(123559,'enUS','','For the record, I counseled against trusting any Horde in this campaign. I have lost a husband and a King to the treachery of the Horde.$b$bI see no reason to trust you now or ever.',26124),
(123560,'enUS','','Good. We do not have the numbers to hold this place for long. The sooner we press on the better.',26124),
(123561,'enUS','','Few understand the plight of the Nightfallen better than the Sin\'dorei. My heart goes out to them.$b$bBut Thalyssra must understand that there is a difference between an insurrection and a war.$b$bUntil now, her rebels have got by with a few skirmishes here and there. But they have not been hardened by battle as we blood elves have.',26124),
(123564,'enUS','','Your leaders need to get their heads in the game.$b$bVereesa is so obsessed with her desire for revenge against the Horde that we cannot trust our flank to her.$b$bTyrande is a sentinel. She knows little of war on this type of battlefield. While her scouting is useful she should recuse the Kal\'dorei from the main assault.$b$bMy blood knights are the only ones prepared to carry the weight of this conflict.',26124),
(123565,'enUS','Even as we suffer under the heel of the Magistrix, our people must be nourished. They are the backbone of our rebellion.','',26124),
(123566,'enUS','','The rebels are ready for battle? Impressive. Let us see what they can do.',26124),
(123567,'enUS','','And the shal\'dorei are stronger than you expect. When the time comes, we will fight beside you.',26124),
(123568,'enUS','','[CUT]There are still Nightborne in the city who blindly follow the Grand Magistrix. We must be careful not to hurt any innocents!',26124),
(123569,'enUS','','[CUT]So be it. I will alert our forces inside the city. There is much I still have to learn about the world we left behind.',26124),
(123570,'enUS','The demons have opened a portal to bring forth more of their accursed kin. Destroy their infestation before the forest is overrun!','',26124),
(123571,'enUS','Please, any arcwine you can spare... I have children!','Please, any arcwine you can spare... I have children!',26124),
(123572,'enUS','Over here... I haven\'t had arcwine in days!','Over here... I haven\'t had arcwine in days!',26124),
(123573,'enUS','Help me! The guards took everything I had!','Help me! The guards took everything I had!',26124),
(123574,'enUS','','Catch!',26124),
(123575,'enUS','','Take this!',26124),
(123577,'enUS','I\'m saved... Thank you!','I\'m saved... Thank you!',26124),
(123578,'enUS','I am in your debt.','I am in your debt.',26124),
(123579,'enUS','The Legion\'s foothold within the forest has been destroyed! Thanks to your help, the land will recover.','',26124),
(123580,'enUS','|TInterface\\Icons\\INV_Icon_ShadowCouncilOrb_purple.blp:20|t An |cFFFF0000|Hspell:227920|h[Orb of Corruption]|h|r is following you!','|TInterface\\Icons\\INV_Icon_ShadowCouncilOrb_purple.blp:20|t An |cFFFF0000|Hspell:227920|h[Orb of Corruption]|h|r is following you!',26124),
(123581,'enUS','|TInterface\\Icons\\INV_Icon_ShadowCouncilOrb_green.blp:20|t An |cFFFF0000|Hspell:228058\n|h[Orb of Corrosion]|h|r is following you!','|TInterface\\Icons\\INV_Icon_ShadowCouncilOrb_green.blp:20|t An |cFFFF0000|Hspell:228058\n|h[Orb of Corrosion]|h|r is following you!',26124),
(123583,'enUS','We must complete the ritual as one... Until Helya\'s will is done!','',26124),
(123584,'enUS','','Oh no... Odyn\'s mighty champions have come to end my reign. Whatever shall I do?',26124),
(123585,'enUS','','So kind of you to deliver your souls to me... it will save my Val\'kyr the trouble of fetching them from the surface world.',26124),
(123586,'enUS','','Come, mortals. You have earned an eternity of torment!',26124),
(123587,'enUS','','Your souls belong to me!',26124),
(123588,'enUS','','Another soul drowned!',26124),
(123590,'enUS','','Mine! Mine forever!',26124),
(123591,'enUS','','Drown in despair, lapdogs of Odyn!',26124),
(123592,'enUS','Where is this master you speak of located?','Where is this master you speak of located?',26124),
(123593,'enUS','Mistress deep in dirt beneath tower.$B$BMistress always busy, but makes time for Rezzle.$B$BNow... Rezzle scared to go back! What if mistress thinks Rezzle turned traitor?','',26124),
(123594,'enUS','Line them up!','',26124),
(123595,'enUS','Ah, look, another prisoner!','',26124),
(123597,'enUS','','Odyn\'s fabled champions... HA! Barely worth my time.',26124),
(123598,'enUS','','Soon the Halls of Valor will fall. Odyn\'s last days are upon him!',26124),
(123599,'enUS','','My reign... cannot end...',26124),
(123600,'enUS','','Damn you... Odyn... damn... you...',26124),
(123601,'enUS','','He... must not... win...',26124),
(123602,'enUS','','Let the shadows take you!',26124),
(123603,'enUS','','Darkness upon your soul!',26124),
(123604,'enUS','','Shiver! Tremble! Quake!',26124),
(123605,'enUS','','Relish the cold kiss of the sea!',26124),
(123606,'enUS','','Touchy, touchy!',26124),
(123607,'enUS','','Do I have your attention?',26124),
(123608,'enUS','','Soon you will join the ranks of my Kvaldir!',26124),
(123609,'enUS','','Your efforts are for naught, mortals! Odyn will NEVER be free!',26124),
(123610,'enUS','','Behold my army of the damned!',26124),
(123611,'enUS','','Your doom lurks within the fog!',26124),
(123612,'enUS','','The cold will shatter you!',26124),
(123613,'enUS','','You\'ll catch your death of cold!',26124),
(123614,'enUS','','Breathe deep... and despair!',26124),
(123615,'enUS','','I\'ll blow you a kiss!',26124),
(123616,'enUS','','Break upon the waves!',26124),
(123622,'enUS','','That laggard sent ye fer his gunpowder? He lost it fair and square!',26124),
(123623,'enUS','Be careful, $n. Even with the vial\'s additional protection it can only withstand so much.','',26124),
(123624,'enUS','Ah, the interrogator has arrived. You\'d best tell $Ghim:her; what you know, demon!','Ah, the interrogator has arrived. You\'d best tell $Ghim:her; what you know, demon!',26124),
(123625,'enUS','','Come out from the shadows! The Rebellion brings arcwine for all!',26124),
(123626,'enUS','','Feed your families! Come get a bottle of arcwine!',26124),
(123627,'enUS','','I cannot stay for very long- I am expected back at the palace. We must be quick.',26124),
(123628,'enUS','What have you heard about Vanthir?','What have you heard about Vanthir?',26124),
(123629,'enUS','|TInterface\\Icons\\spell_fire_felfire.blp:20|tThe %s acquires |cFFFF0000$n|r as a target of |cFFFF0000|Hspell:229242|h[Fel Beam]|h|r!','',26124),
(123630,'enUS','You rang?','',26124),
(123631,'enUS','Remember, $n. Though you may appear to be one of their kind, they may not be so quick to see you as such. Be careful.','',26124),
(123632,'enUS','You will be alone in the end.','',26124),
(123633,'enUS','All that you know will fade.','',26124),
(123634,'enUS','Hope is an illusion.','',26124),
(123635,'enUS','Trust is your weakness.','',26124),
(123636,'enUS','|TInterface\\Icons\\SPELL_SHADOW_SHADOWANDFLAME:20|t%s casts |cFFFF0000|Hspell:228796|h[Ignite Soul]|h|r on |cFFFF0000$n|r!','',26124),
(123637,'enUS','','I will find him. Preferably without being seen.',26124),
(123638,'enUS','Hey there, chum! Today we\'re holdin\' a contest for extreme anglers! All you gotta do to win is be one of the FIRST FIFTY PEOPLE IN THE WORLD to bring me a heap of tasty tastyfish. Now reel up and roll out!','',26124),
(123639,'enUS','Congratulations, you\'ve won the Stranglethorn Fishing Extravaganza! Someday you\'ll tell your grandkids about this. Oh, and hey... thanks for all the fish!','',26124),
(123640,'enUS','And we have our first-place winner! Congratulations!','',26124),
(123641,'enUS','We\'re halfway done, and I\'m runnin\' out of prizes here. Keep those fishhooks flyin\'!','',26124),
(123642,'enUS','That\'s it for this week, folks! Fishing contest: OVER!','',26124),
(123643,'enUS','Helya\'s cursed magic threatens Highmountain. Her ritual must not be completed!','',26124),
(123644,'enUS','A decisive victory! The sea witch overplayed her hand.','',26124),
(123645,'enUS','The Kvaldir are menacing hapless villagers? Pathetic! Banish those cowards to the watery depths!','',26124),
(123646,'enUS','Helya grows desperate... her downfall draws nigh!','',26124),
(123647,'enUS','I believe in the Dusk Lily.','I believe in the Dusk Lily.',26124),
(123648,'enUS','The way is clear? Thank you, friend.','The way is clear? Thank you, friend.',26124),
(123649,'enUS','I must leave before more guards come.','I must leave before more guards come.',26124),
(123650,'enUS','Is it true? We can be free of the Nightwell?','Is it true? We can be free of the Nightwell?',26124),
(123651,'enUS','This is madness!','This is madness!',26124),
(123652,'enUS','We will not serve the Legion.','We will not serve the Legion.',26124),
(123653,'enUS','BONE STORM!','',26124),
(123655,'enUS','Shall we be lenient with these pets of yours, Odyn?','',26124),
(123656,'enUS','Hold nothing back! I must know they are ready for the task ahead.','',26124),
(123657,'enUS','','So be it! The unworthy shall be purged from the Halls of Valor!',26124),
(123659,'enUS','','Fall in line!',26124),
(123660,'enUS','','Stand together--or die alone!',26124),
(123661,'enUS','Only cowards fear the call of battle!','',26124),
(123662,'enUS','Is there truly valor in your hearts?','',26124),
(123663,'enUS','If you will vow to take up this burden and end her reign, speak now, and I will send you forth into the fray!','',26124),
(123664,'enUS','Valarjar! Prepare the runes! These heroes need testing...','',26124),
(123665,'enUS','Runebearers! Feed me power!','',26124),
(123666,'enUS','Behold the power granted me by the titans!','',26124),
(123667,'enUS','Can you withstand a keeper\'s might?','',26124),
(123668,'enUS','Feel the fury of the storm!','',26124),
(123669,'enUS','A shocking weakness!','',26124),
(123670,'enUS','','You\'re... too... late...',26124),
(123671,'enUS','Weak--as expected!','',26124),
(123672,'enUS','That one was too soft!','',26124),
(123673,'enUS','Well fought, champions! I yield to you.','',26124),
(123674,'enUS','','Helya won\'t be as gentle as I!',26124),
(123675,'enUS','','Unworthy!',26124),
(123676,'enUS','','These mortals show promise.',26124),
(123677,'enUS','','Training those Withered scum... how distasteful! Dalion, defend the entrance! Slay my foes!',26124),
(123678,'enUS','Get back up! FIGHT!','',26124),
(123679,'enUS','Disappointing!','',26124),
(123680,'enUS','Have I misjudged them? I pray not...','',26124),
(123681,'enUS','May we see your invitation?','',26124),
(123682,'enUS','Stop being such a nuisance!','',26124),
(123683,'enUS','I\'ll drag you out by your scruff!','',26124),
(123684,'enUS','Hm! Seems that one had enough for the evening.','',26124),
(123685,'enUS','I\'ll have the cleaning crew take care of this... mess.','',26124),
(123686,'enUS','Nothing a good sprinkling of sawdust can\'t handle.','',26124),
(123687,'enUS','I will just need... a moment...','',26124),
(123688,'enUS','Oh goodness me! That will... leave a mark.','',26124),
(123689,'enUS','I fear that I am currently... indisposed...','',26124),
(123690,'enUS','You feel a powerful force enter your mind.','',26124),
(123691,'enUS','','This place is usually bustling with activity. Where have they all gone?',26124),
(123692,'enUS','','Oh, Suramar...',26124),
(123693,'enUS','','My people... in cages! And some already Withered... Such cruelty you have shown, Elisande.',26124),
(123694,'enUS','','The demons have certainly made themselves at home. Disgusting!',26124),
(123695,'enUS','','I could not prevent this. I am so sorry, Suramar.',26124),
(123696,'enUS','','This place has changed... gone are the bustling crowds, replaced by armed guards.',26124),
(123697,'enUS','Your actions are illogical. All possible results for this encounter have been calculated.','',26124),
(123698,'enUS','','This must be where he took many meals...',26124),
(123699,'enUS','','There it is. We are coming, Vanthir.',26124),
(123700,'enUS','','This garden likely gave him many hours of respite. His essence is strong and bright, here.',26124),
(123701,'enUS','','I can feel him! He is still alive, at least.',26124),
(123702,'enUS','','One of his suppliers must have served him here. Reminders of a simpler time.',26124),
(123703,'enUS','','Perfect. This will be enough to find him.',26124),
(123704,'enUS','','I cannot maintain this spell any longer. Meet me at Evermoon Terrace and we will continue.',26124),
(123706,'enUS','DELETE','',26124),
(123711,'enUS','Ahh... The Terrace. It will have to do for now. Take us as close as you can, Deline.','',26124),
(123713,'enUS','See that these people escape the city, Deline. $n, stay with me.','',26124),
(123714,'enUS','This way!','',26124),
(123716,'enUS','Now all we need is a to make contact with--','',26124),
(123717,'enUS','The Council of Six has need of you, Deathlord.','',26124),
(123718,'enUS','The Council of Six has need of you, Slayer.','',26124),
(123719,'enUS','The Council of Six has need of you, Archdruid.','',26124),
(123720,'enUS','The Council of Six has need of you, Huntmaster.','',26124),
(123721,'enUS','The Council of Six has need of you, Archmage.','',26124),
(123722,'enUS','The Council of Six has need of you, Grandmaster.','',26124),
(123723,'enUS','The Council of Six has need of you, Highlord.','',26124),
(123724,'enUS','The Council of Six has need of you, High Priest.','',26124),
(123725,'enUS','The Council of Six has need of you, Shadowblade.','',26124),
(123726,'enUS','The Council of Six has need of you, Farseer.','',26124),
(123727,'enUS','The Council of Six has need of you, Netherlord.','',26124),
(123728,'enUS','The Council of Six has need of you, Battlelord.','',26124),
(123729,'enUS','If you will answer their call, seek them out in the Violet Citadel.','',26124),
(123730,'enUS','You\'re late, little one!','',26124),
(123731,'enUS','Don\'t touch me filth! Get back to work!','',26124),
(123732,'enUS','Worthless pest! Keep moving!','',26124),
(123733,'enUS','Tiny thing! Me crush you!','',26124),
(123734,'enUS','Out of my way, worm!','',26124),
(123735,'enUS','Squash you like insect!','',26124),
(123736,'enUS','Move before my blade meets your skull!','',26124),
(123737,'enUS','Such brittle bones, little worm. How easily they\'ll crunch!','',26124),
(123738,'enUS','','Go. We will hold this position and send reinforcements.',26124),
(123739,'enUS','','Time is short. Champion, mount and ride with us to the concourse before the Nightborne can reinforce their position.',26124),
(123740,'enUS','','Champion, come, join my sin\'dorei as we crush this vanguard.',26124),
(123741,'enUS','Our citizens are desperate to break free of Elisande\'s tyranny. See to it that they are suitably armed.','',26124),
(123742,'enUS','With our people armed, Elisande\'s thugs will face stiff resistance!','',26124),
(123743,'enUS','','You will have the time you need, Watcher.',26124),
(123744,'enUS','Good work, $p. She seems subdued. I will bring her back to Acherus for you.','',26124),
(123745,'enUS','The mortals must not disrupt the grand design!','',26124),
(123746,'enUS','Just in time for the next ferry. It\'s off to the Soul Engine with you!','',26124),
(123747,'enUS','An entire city, you say? In one teleport?','',26124),
(123748,'enUS','Well, to be fair... I had help.','',26124),
(123749,'enUS','Fascinating. I would love to compare notes when this is all over.','',26124),
(123750,'enUS','Come, champion. The Kirin Tor and Dusk Lily rebels have secured this floor of the harbor.','',26124),
(123751,'enUS','I will not stand for this treatment!','I will not stand for this treatment!',26124),
(123752,'enUS','Are we Shal\'dorei not better than this?','Are we Shal\'dorei not better than this?',26124),
(123753,'enUS','They took my daughter... Something must be done.','They took my daughter... Something must be done.',26124),
(123754,'enUS','The Grand Magistrix has gone too far.','The Grand Magistrix has gone too far.',26124),
(123755,'enUS','I am fed up with the Legion! We are stronger than this!','I am fed up with the Legion! We are stronger than this!',26124),
(123756,'enUS','Our proud city, reduced to chaos... and for what?','Our proud city, reduced to chaos... and for what?',26124),
(123757,'enUS','My spell! What just happened?!','',26124),
(123758,'enUS','','You think we didn\'t notice your skullduggery?! Your old tricks are no match for true sorcery!',26124),
(123759,'enUS','I don\'t know how they co-opted my spell, it shouldn\'t be--','',26124),
(123760,'enUS','','We have prepared for the possibility of discovery. With the telemancy orbs and the fel-resistant Withered, you have the tools required to secure the breach.',26124),
(123761,'enUS','I have had it with this occupation. We need to act!','I have had it with this occupation. We need to act!',26124),
(123762,'enUS','The guards will have our heads for even discussing this...','The guards will have our heads for even discussing this...',26124),
(123763,'enUS','I do not plan to go quietly.','I do not plan to go quietly.',26124),
(123764,'enUS','Indeed. I suppose it has come to this...','Indeed. I suppose it has come to this...',26124),
(123765,'enUS','','It seems you are unable to enter. Find the power source for that barrier and take it down.',26124),
(123766,'enUS','','There! Those casters are using generators to shield the Sanctum. Eliminate them!',26124),
(123767,'enUS','','Now that Andaris\'s dog is put down, you should have access to the building. Get to the breach!',26124),
(123768,'enUS','Archmage! The Kirin Tor needs your aid!','',26124),
(123769,'enUS','Send me to Thorim\'s Peak!','Send me to Thorim\'s Peak!',26124),
(123770,'enUS','Not good... not good at all. We will help, of course!','',26124),
(123771,'enUS','The Legion infiltrated Dalaran and sabotaged the city\'s weapons... possibly beyond repair.','',26124),
(123772,'enUS','','All shall be sanctified!',26124),
(123773,'enUS','','The strong must suffer for the sins of the weak!',26124),
(123774,'enUS','','By fire be cleansed!',26124),
(123775,'enUS','','The righteous have nothing to fear!',26124),
(123776,'enUS','Aethas? You are our secret visitor? What\'s going on?','',26124),
(123777,'enUS','Your soul betrays your allies!','',26124),
(123778,'enUS','Burn from the inside!','',26124),
(123779,'enUS','Your lifeblood is my weapon!','',26124),
(123780,'enUS','Run, cowards!','',26124),
(123781,'enUS','Weak-willed mortals!','',26124),
(123782,'enUS','Your courage falters!','',26124),
(123783,'enUS','Miserable vermin. I shall exterminate you from the air!','',26124),
(123784,'enUS','Again?! Oh no! Tell me you weren\'t involved!','',26124),
(123785,'enUS','Enough! I will finish you myself!','',26124),
(123787,'enUS','Am I damned to answer the summons of mortals for all eternity?','',26124),
(123788,'enUS','So be it! You will suffer for your insolence!','',26124),
(123789,'enUS','Learn the meaning of torment!','',26124),
(123790,'enUS','I\'ll reduce you to ashes!','',26124),
(123791,'enUS','Come forth and burn!','',26124),
(123792,'enUS','Kindling for the fire!','',26124),
(123793,'enUS','Pathetic!','',26124),
(123794,'enUS','Who\'s next?!','',26124),
(123795,'enUS','Pitiful... as expected.','',26124),
(123796,'enUS','Mortals never learn.','',26124),
(123797,'enUS','','You\'ll go no further! I\'ll die before I allow you entrance to the Nighthold!',26124),
(123798,'enUS','You called me here only to die at my feet?','',26124),
(123799,'enUS','It is... never... over...','',26124),
(123800,'enUS','I will... never... be free...','',26124),
(123801,'enUS','The flames... await me...','',26124),
(123802,'enUS','Time to end this!','',26124),
(123803,'enUS','I\'ve toyed with you long enough!','',26124),
(123804,'enUS','I will end you!','',26124),
(123805,'enUS','','Andaris has made a critical mistake! Her shield is vulnerable to the Withered. Drop some in a safe spot and they will leech the magic in her shield.',26124),
(123806,'enUS','','More Withered tricks! I shall not fail Elisande! You will fall!',26124),
(123807,'enUS','','Step into the light, mortals!',26124),
(123808,'enUS','','Hold, mortals! Open your hearts to virtue!',26124),
(123809,'enUS','A memory, frozen in time!','',26124),
(123810,'enUS','The tower needed a new decoration.','',26124),
(123811,'enUS','','Renounce your greed and perversion!',26124),
(123812,'enUS','The inherent nature of fire...','',26124),
(123813,'enUS','Burn... just like that dragon!','',26124),
(123814,'enUS','','Repent... or DIE!',26124),
(123815,'enUS','You grow weaker... I grow stronger!','',26124),
(123816,'enUS','A basic spell... but effective.','',26124),
(123817,'enUS','So many pieces of me...','',26124),
(123818,'enUS','Carrion for the birds...','',26124),
(123819,'enUS','It burns, burns, burns!','',26124),
(123820,'enUS','I suggest staying put.','',26124),
(123821,'enUS','Winter is here!','',26124),
(123822,'enUS','Keep still. Let it end.','',26124),
(123823,'enUS','','The titans wish their children to lead virtuous lives. Yet from cornerstone to spire, this tower reeks of depravity!',26124),
(123824,'enUS','This is who I am. I was tainted from birth, polluted from before my conception, a bad seed grown to bear bitter fruit.','',26124),
(123825,'enUS','You have never seen the true Medivh.','',26124),
(123826,'enUS','Just. Gets. Easier.','',26124),
(123827,'enUS','','Purified!',26124),
(123828,'enUS','All goes as planned.','',26124),
(123829,'enUS','A fitting end for a thief!','',26124),
(123830,'enUS','','A teachable moment.',26124),
(123831,'enUS','Hello, champions. I\'ve been expecting you.','',26124),
(123832,'enUS','You\'re just like the others, aren\'t you?','',26124),
(123833,'enUS','My staff... a relic, yes, but MINE!','',26124),
(123834,'enUS','Once you get used to it, you can kill friends as easily as anyone else.','',26124),
(123835,'enUS','You have no idea what it\'s like to do the things I\'ve done. Harsh things. Necessary things.','',26124),
(123836,'enUS','I fought it... for as long as... I could...','',26124),
(123837,'enUS','','And so begins your purification!',26124),
(123838,'enUS','So... it comes... to this...','',26124),
(123839,'enUS','Atiesh... will be... splintered...','',26124),
(123840,'enUS','','The stench of corruption is upon you!',26124),
(123841,'enUS','Beware, champions! Helya\'s realm is guarded by a savage beast bred from the stuff of nightmares!','',26124),
(123842,'enUS','Well fought! Now, onward to Helya! This day her treachery shall be ended!','',26124),
(123843,'enUS','','The lesson is complete.',26124),
(123844,'enUS','','A pure mind is an orderly mind.',26124),
(123845,'enUS','','I will... never... relent...',26124),
(123846,'enUS','','You are all... as corrupt... as the Guardian...',26124),
(123847,'enUS','Send me to Thorim\'s Peak!','Send me to Thorim\'s Peak!',26124),
(123849,'enUS','Andaris was the key to their defenses. Telemancy is working inside the Sanctum again. I\'m sending Thalyssra and Khadgar to your location.','',26124),
(123850,'enUS','','$n! Over here!',26124),
(123851,'enUS','','With her finest arcanist dead, I doubt Elisande will send reinforcements. We have the breach. Follow me.',26124),
(123852,'enUS','','I can sense the Nightwell from here. Elisande must truly be desperate to overload the Nightwell like this!',26124),
(123853,'enUS','Once we break the timelock holding our forces, Gul\'dan will fall!','',26124),
(123854,'enUS','The Withered won\'t last long in there, $n. Gather an elite group of champions to fight your way through. I\'m sure you\'re familiar with such tactics! We\'ll be right behind you, of course.','',26124),
(123855,'enUS','You should have never returned, foolish mortal! Your tower is ours!','',26124),
(123856,'enUS','Master! I have... failed you.','',26124),
(123857,'enUS','Feel the grip of entropy!','',26124),
(123858,'enUS','Darkness will take you!','',26124),
(123859,'enUS','Annihilate them!','',26124),
(123860,'enUS','Begin the barrage!','',26124),
(123861,'enUS','Incinerate that one!','',26124),
(123862,'enUS','','Your resistance is irrelevant!',26124),
(123863,'enUS','Take out the target!','',26124),
(123864,'enUS','You will kneel! You will serve!','',26124),
(123865,'enUS','Your resistance is misguided. Yield to us!','',26124),
(123866,'enUS','Enough interruptions! The grand design must be realized.','',26124),
(123867,'enUS','Preparations are complete. It is time to begin the end!','',26124),
(123868,'enUS','An infinite army will be brought forth from innumerable worlds!','',26124),
(123869,'enUS','Behold! The doorway opens to your doom!','',26124),
(123870,'enUS','The grand design is complete! Every Legion world is now tethered to this tower!','',26124),
(123871,'enUS','Master! My mission is accomplished! Come forth and claim this world!','',26124),
(123872,'enUS','Karazhan\'s presence radiates through the Nether... a beacon drawing in the Legion\'s might.','',26124),
(123873,'enUS','Our Burning Crusade has consumed countless worlds. This tower will serve as a conduit to each of them.','',26124),
(123874,'enUS','One battle remains. One final conquest to complete the grand design!','',26124),
(123875,'enUS','Meaningless... and inevitable.','',26124),
(123876,'enUS','One by one... you fall!','',26124),
(123877,'enUS','I have foreseen your world\'s doom!','',26124),
(123878,'enUS','This tower belongs to the Legion!','',26124),
(123879,'enUS','It ends for the mortals, as I saw it would.','',26124),
(123880,'enUS','A pathetic attempt to resist our design.','',26124),
(123881,'enUS','But the design... was flawless...','',26124),
(123882,'enUS','Could not... foresee... such an end...','',26124),
(123883,'enUS','The portal worked and we are still in one piece. Good! I was worried we might overload the network by adding another beacon.','',26124),
(123884,'enUS','The Duskwatch won\'t know what hit them.','The Duskwatch won\'t know what hit them.',26124),
(123885,'enUS','I will spread the word... the Grand Magistrix\'s tyrrany stops now!','I will spread the word... the Grand Magistrix\'s tyrrany stops now!',26124),
(123886,'enUS','I am ready to fight for Suramar!','I am ready to fight for Suramar!',26124),
(123887,'enUS','Our people will be free of the Legion!','Our people will be free of the Legion!',26124),
(123888,'enUS','','I\'m ready to take down the barrier. You will need to move quickly and secure the entrance before they realize what\'s going on.',26124),
(123889,'enUS','I may not be a soldier, but even in war there are beds to be turned down and drinks to be served.$b$bIt is a duty I was born to.','',26124),
(123890,'enUS','Ensure none see the item you recovered until then. Good luck, champion.','',26124),
(123891,'enUS','They have called for aid in facing a great threat. They asked only for you.','',26124),
(123892,'enUS','','Begone, slave!',26124),
(123893,'enUS','','Your kind serves us well, minion.',26124),
(123894,'enUS','','I don\'t have time for your games.',26124),
(123895,'enUS','','Where have you been, little wretch?$B$BDid you think we weren\'t watching?',26124),
(123896,'enUS','Master, please! I doesn\'t mean to...','Master, please! I doesn\'t mean to...',26124),
(123897,'enUS','','A pathetic attempt at disguise! Now you will pay with your life!',26124),
(123898,'enUS','Then through the portal ye go!$b$bKhadgar will be waitin\'.','',26124),
(123903,'enUS','The demons have taken the lands above Moonclaw Vale! The trees cry out as their life essence is drained to fuel the Legion\'s defenses.','',26124),
(123905,'enUS','The Legion is a relentless foe, but you have saved the forest this day. All of Val\'sharah honors your victory!','',26124),
(123906,'enUS','','Many Nightborne were murdered when Elisande and the Legion attacked. Strike back! Show those devils we will not stand for tyranny.',26124),
(123907,'enUS','','Elisande and the Legion will pay for the blood they have spilled. They still have much to answer for!',26124),
(123908,'enUS','','This place is not safe. We should move soon.',26124),
(123909,'enUS','','Vanthir is in danger!',26124),
(123910,'enUS','What happened to Vanthir, Maribeth?','What happened to Vanthir, Maribeth?',26124),
(123911,'enUS','We must strike before their defenses reach full power! Plant a Seed of Ruin near each structure and it will be crushed as the seed sprouts. Hurry!','',26124),
(123912,'enUS','Enough of this weakness, boy! Contain your magic!','',26124),
(123913,'enUS','Too... much... power...','',26124),
(123914,'enUS','Father! No!','',26124),
(123915,'enUS','Citizens have taken up arms to defend safe houses throughout Suramar. Find innocents in peril and lead them to safety!','',26124),
(123916,'enUS','If not for your actions, many innocents would have died in the streets. A small victory, perhaps, but an important one.','',26124),
(123917,'enUS','Could Dalaran use the Nightborne Soulstone as a weapon?','Could Dalaran use the Nightborne Soulstone as a weapon?',26124),
(123918,'enUS','Interesting idea, Archmage $n! Using the legion\'s own magic against themselves has a satisfying elegance. We cannot risk Kathra\'natir escaping, however... \n\nArchmage Kalec is very knowledgable about magical devices and can be trusted to remain discreet. Let\'s see what he thinks?','',26124),
(123919,'enUS','','The Legion\'s patrols edge ever closer to Shal\'Aran. Kill them before they discover our location!',26124),
(123920,'enUS','','Our whereabouts remain a secret... for now. I fear this will not be the last time Shal\'Aran is threatened.',26124),
(123921,'enUS','Can you think of a way we could safely use the Nightborne Soulstone as a weapon?','Can you think of a way we could safely use the Nightborne Soulstone as a weapon?',26124),
(123923,'enUS','','Victory over Elisande will require strength beyond our own. Ascend to the Lunar Crucible and seek the blessing of the Moon Guard ancients.',26124),
(123924,'enUS','','Elisande shamed our people when she attacked the Moon Guard. By keeping their traditions alive, you help us make amends for her transgression.',26124),
(123925,'enUS','Hmm... Most anything is possible with enough effort! If we had all of our mages focusing on it it, I\'m sure we could safely use it... Of course that might be a tad inefficient. \n\nOr perhaps it could be securely shielded? Khadgar\'s strange friend, Ari, is brilliant when it comes to these sorts of puzzles. Let\'s see what she thinks!','',26124),
(123926,'enUS','Come. I think this is a matter best discussed privately.','',26124),
(123927,'enUS','Can you think of a way to safely use the Nightborne Soulstone?','Can you think of a way to safely use the Nightborne Soulstone?',26124),
(123928,'enUS','Elisande and the Legion are forcing citizens into boats bound for Felsoul Hold. Take a gondola and free as many shal\'dorei as you can.','',26124),
(123929,'enUS','Elisande is beyond forgiveness for condemning so many of our people. We must fight to save everyone we can.','',26124),
(123930,'enUS','','Oh. Hmm. Are the rumors true then? Dalaran\'s lovely weapons are no more? I must attend the funeral...\n\nI suppose the Nightborne Soulstone could be convinced to work with us. But first we will need a very stubborn shield generator.',26124),
(123931,'enUS','','Elisande\'s forces are waylaying refugees fleeing Suramar through the Crimson Thicket. A perfect opportunity to test their skills in battle!',26124),
(123932,'enUS','','The once-proud shal\'dorei attack their own people? This situation is even more desperate than I imagined...',26124),
(123933,'enUS','','Shal\'dorei flee Suramar as Elisande\'s forces advance through the Crimson Thicket. Go, rout the Nightborne for the sake of those who would escape the city.',26124),
(123934,'enUS','','They strike down their own people for daring to seek safety? We will bring our wrath to bear on Elisande for this injustice!',26124),
(123935,'enUS','','We must spread word of the Alliance\'s arrival. Post notice throughout the city that the reign of the Grand Magistrix will soon be ended. Inspire the shal\'dorei to resist!',26124),
(123936,'enUS','','The more shal\'dorei that take up the fight, the fewer of my people who will be lost in the liberation of Suramar.',26124),
(123937,'enUS','','Suramar\'s citizens must be told of the arrival of the Horde. Post bulletins throughout the city. Let the oppressed know that help is on the way!',26124),
(123938,'enUS','','The shal\'dorei must be shown that there is a future beyond this chaos. We must reach as many as we can!',26124),
(123939,'enUS','','Our supplies are running low, but the enemy has plenty to spare. Ride into Suramar and liberate supplies from the forces of the Magistrix!',26124),
(123940,'enUS','','I watched from my inn when Elisande\'s forces swept into the Crescent.',26124),
(123941,'enUS','','The Felborne killed anyone who stood in their way, but they did not kill him.',26124),
(123942,'enUS','','He begged them to spare his people.',26124),
(123943,'enUS','','They said that he would be made an example for all others.',26124),
(123944,'enUS','','They teleported him away. Where, I do not know.',26124),
(123945,'enUS','','Morale has been reinvigorated by the arrival of fresh supplies. You have done well!',26124),
(123946,'enUS','','Dwindling supplies are demoralizing our troops. Go into Suramar and seize supplies from the Nightborne oppressors!',26124),
(123947,'enUS','','These supplies will prove crucial in maintaining our campaign. The Horde marches on!',26124),
(123948,'enUS','Ah yes, this is a wonderful vintage.','',26124),
(123949,'enUS','','We should retreat while we still can.',26124),
(123950,'enUS','','Ley lines darken across Suramar as the Grand Magistrix\'s forces act from the shadows. Use my spectacles to see beyond sight, and root out the source of this interference!',26124),
(123951,'enUS','','The ley energy is flowing again! A job well done.',26124),
(123952,'enUS','My preparations are complete. Let us see how the nobles of Suramar react to the warp-delivery of Withered!','',26124),
(123953,'enUS','What delicious irony! Chaos erupts among the nobles as those they cast out are warped onto their very doorsteps!','',26124),
(123954,'enUS','','The Withered must be made ready for our assault on the Nighthold. Their resistance to fel can be bolstered in Felsoul Hold.',26124),
(123955,'enUS','','More of our Withered are now able to withstand the fel. Our revolution will not be stopped!',26124),
(123956,'enUS','Oh, the grog. Yes, thank you.','',26124),
(123957,'enUS','','We are ready to begin the offensive in Suramar. Place beacons along the city\'s outskirts and draw the withered down upon the Magistrix\'s forces!',26124),
(123958,'enUS','','The enemy breaks before the scores of withered we have unleashed! Keep training them, for the withered will prove invaluable in the days to come.',26124),
(123959,'enUS','','Damn it! Another attack. Stay alert!',26124),
(123960,'enUS','Free at last! Do what you can for the others, I\'ll be fine...','',26124),
(123961,'enUS','How may I serve?','',26124),
(123962,'enUS','','Now that you target is bleeding and your pet is engaged, it\'s time to unleash your own fury.',26124),
(123963,'enUS','','Raptor Strike is a quick but strong attack that you can use whenever you have the focus to do so.',26124),
(123964,'enUS','','Use Raptor Strike on the target dummy.',26124),
(123965,'enUS','Now that you target is bleeding and your pet is engaged, it\'s time to unleash your own fury.','',26124),
(123966,'enUS','Raptor Strike is a quick but strong attack that you can use whenever you have the focus to do so.','',26124),
(123967,'enUS','Use Raptor Strike on the target dummy.','',26124),
(123968,'enUS','I must speak to your lord.','I must speak to your lord.',26124),
(123969,'enUS','You have my thanks, champion!','',26124),
(123970,'enUS','That cage would have been my coffin...','',26124),
(123971,'enUS','The Burning Legion will pay for this!','',26124),
(123972,'enUS','Where is my axe? I have demons to kill!','',26124),
(123973,'enUS','Death to the Burning Legion!','',26124),
(123974,'enUS','I will fight until my final breath!','',26124),
(123975,'enUS','The demons will pay!','',26124),
(123976,'enUS','','Freedom? I will not forget this!',26124),
(123977,'enUS','Feels good to stretch my legs! Now, where\'s a demon to stretch my fists on!','',26124),
(123978,'enUS','','I owe you my life!',26124),
(123979,'enUS','Greetings Highlord.','Greetings Highlord.',26124),
(123980,'enUS','This must be discussed immediately. Allow me to teleport you to Shal\'Aran.','',26124),
(123981,'enUS','Oh, woe is me, woe! My life is over!\n\nDo you know who Dr. Weavil is? Was. Might still be? I\'m not sure.\n\nDeath would not stop him, no, he had predicted that. Brilliant gnome, the insane ones always are.\n\nThe second his heart stopped, the machines he had implanted within himself started up. He was filled with a yellow ooze, and electrified. I\'m not sure if it\'s undeath, alchemical engineering, or something... more.\n\nWhen we heard about a new internship under the great Dr. Weavil, so many of us flocked to the island to sign up. Now I\'m not sure if I\'m alive or dead, and I\'m leaking yellow ooze. Great.\n\nThe others have taken to calling themselves \"drudge gnomes.\" Good luck with them, bunch of jerks.','',26124),
(123982,'enUS','Smolderon, heed this mortal!','',26124),
(123983,'enUS','Prove to me you have the experience and instinct required to take down any prey!','',26124),
(123984,'enUS','','Prove to me you have the experience and instinct required to take down any prey!',26124),
(123985,'enUS','Stand down, Arluelle. We are expecting her.','',26124),
(123986,'enUS','Another year of slumber. I wonder if Medivh will ever awaken.','',26124),
(123987,'enUS','Does our old friend dream? Is he trapped in nightmares?','',26124),
(123988,'enUS','','Use Raptor Strike!',26124),
(123989,'enUS','Use Raptor Strike!','',26124),
(123990,'enUS','My forces have been preparing for this day. Their rage fills the Firelands.','',26124),
(123991,'enUS','Elisande has captured all our forces in a timelock spell.','',26124),
(123992,'enUS','What Elisande has done... it should have been impossible! The energies required--','',26124),
(123993,'enUS','','And why didn\'t Ly\'leth warn us about this? Surely, as one of Elisande\'s advisors, she would have heard something!',26124),
(123994,'enUS','','There has been no word from her in some time. This cannot be a coincidence.',26124),
(123995,'enUS','','Valtrois, focus on Elisande\'s spell. Find a way to break it.',26124),
(123996,'enUS','','It shall be done.',26124),
(123997,'enUS','','Oculeth, we need to compensate for the loss of our reinforcements.',26124),
(123998,'enUS','Indeed. I have an idea about how to put our limited forces in the right place at the right time.','',26124),
(123999,'enUS','','$n, we need to find out what happened to Ly\'leth. You can still move freely about the city, correct?',26124),
(124000,'enUS','Now you\'re ready to oversee the tower\'s protection in my absence.','',26124),
(124001,'enUS','Defense protocols activated.','',26124),
(124002,'enUS','Hmm, I must remember to shut you down from time to time. Overuse might cause you to become... erratic.','',26124),
(124003,'enUS','','This way!',26124),
(124004,'enUS','Agreed. Everyone into the boat! It will be a tight fit.','',26124),
(124005,'enUS','','We will find him, Silgryn. I am certain of it.',26124),
(124006,'enUS','','DELETE ME',26124),
(124007,'enUS','Still no sign of Vanthir...','',26124),
(124008,'enUS','DELETE ME','',26124),
(124009,'enUS','','DELETE ME',26124),
(124010,'enUS','This goes without saying, but be on your guard. I sense something... a presence I\'ve not felt since...','',26124),
(124011,'enUS','','No no no. I said form ranks. Form ranks!',26124),
(124012,'enUS','','You call that a fighting stance? Any elf in this camp could rip you apart with you in that stance.',26124),
(124013,'enUS','','Lift your weapon. Lift it up. If it is too heavy, grow stronger.',26124),
(124014,'enUS','','Stop slacking. You are Nightborne preparing to defend your city and your legacy. Stand proud!',26124),
(124015,'enUS','','What is that? Don\'t do that.',26124),
(124016,'enUS','It couldn\'t have been helped, you know. We tried to alter it, but it was all part of a larger scheme.','',26124),
(124017,'enUS','I know. All part of a greater cycle. A cycle that now at last may be broken.','',26124),
(124018,'enUS','[UNUSED] This goes without saying, but be on your guard. I sense something... a presence I\'ve not felt since...','',26124),
(124019,'enUS','Silgryn sends his regards.','Silgryn sends his regards.',26124),
(124020,'enUS','Champion, I have come to learn from you.','Champion, I have come to learn from you.',26124),
(124021,'enUS','Death to the Legion! Death to their allies!','Death to the Legion! Death to their allies!',26124),
(124022,'enUS','','I have urgent news, Thalyssra.',26124),
(124023,'enUS','','The portal to my estate is secure. You will want to hear this in person.',26124),
(124024,'enUS','','Come. I do not want to keep her waiting.',26124),
(124025,'enUS','Champion! My weapon is at your command.','Champion! My weapon is at your command.',26124),
(124026,'enUS','For Thalyssra! For the rebellion!','For Thalyssra! For the rebellion!',26124),
(124027,'enUS','I stand with the First Arcanist!','I stand with the First Arcanist!',26124),
(124028,'enUS','Well, that was... interesting. You\'ve done your part, but I still can\'t find a way to--','',26124),
(124029,'enUS','The demons have been purged from Karazhan! Thank you, champions. Medivh, you would be a welcome ally in our war against the Legion.','',26124),
(124030,'enUS','','We won\'t give up without a fight.',26124),
(124031,'enUS','What did you need my help with?','What did you need my help with?',26124),
(124032,'enUS','','As you can see, the Legion\'s reach still extends beyond the Broken Shore.',26124),
(124033,'enUS','My path leads... elsewhere. Besides, Azeroth has found her Guardian in you, Young Trust.','',26124),
(124034,'enUS','I have made it clear before... I do not want such power!','',26124),
(124035,'enUS','You have all the power you will ever need, Khadgar. It is your heart, your courage, that makes you this world\'s Guardian. And a better one than I ever was.','',26124),
(124036,'enUS','I... I don\'t know what to say, Medivh.','',26124),
(124037,'enUS','Enough sentiment! Hear these words before I depart.','',26124),
(124038,'enUS','It may be simpler to shut a door than to pass through it. But sometimes a step into the unknown is required to break the bonds of fate.','',26124),
(124039,'enUS','Outstanding!','',26124),
(124040,'enUS','','Outstanding!',26124),
(124041,'enUS','','Amazing!',26124),
(124042,'enUS','Amazing!','',26124),
(124043,'enUS','There is much that lies ahead for all of us. Farewell.','',26124),
(124044,'enUS','You\'re really improving.','',26124),
(124045,'enUS','','You\'re really improving.',26124),
(124046,'enUS','','Nothing can stop you now!',26124),
(124047,'enUS','Nothing can stop you now!','',26124),
(124048,'enUS','The bonds of fate... I must consider those words. Until next time, champions.','',26124),
(124049,'enUS','','Now you have the hang of it!',26124),
(124050,'enUS','Now you have the hang of it!','',26124),
(124051,'enUS','','Now you have it!',26124),
(124052,'enUS','Now you have it!','',26124),
(124053,'enUS','Not bad, $p!','',26124),
(124054,'enUS','','Not bad, $p!',26124),
(124055,'enUS','','Welcome home, First Arcanist. Thank you for coming on such short notice.',26124),
(124056,'enUS','','Thank you, Advisor. What news?',26124),
(124057,'enUS','','That\'s it. I knew you could do it.',26124),
(124058,'enUS','That\'s it. I knew you could do it.','',26124),
(124059,'enUS','You\'re learning fast!','',26124),
(124060,'enUS','','You\'re learning fast!',26124),
(124061,'enUS','','Good! You must have been practicing.',26124),
(124062,'enUS','Good! You must have been practicing.','',26124),
(124063,'enUS','','I have heard terrible rumors about our friend Vanthir.',26124),
(124064,'enUS','','DELETE ME',26124),
(124065,'enUS','','DELETE ME',26124),
(124066,'enUS','Exactly right!','',26124),
(124067,'enUS','','Exactly right!',26124),
(124068,'enUS','You figured that out fast!','',26124),
(124069,'enUS','','You figured that out fast!',26124),
(124070,'enUS','','DELETE ME',26124),
(124071,'enUS','','You\'re going to be an excellent addition to the Horde.',26124),
(124072,'enUS','You\'re going to be an excellent addition to the Alliance.','',26124),
(124073,'enUS','','You\'ve mastered it!',26124),
(124074,'enUS','You\'ve mastered it!','',26124),
(124075,'enUS','','Be safe, Thalyssra. I must return to the palace.',26124),
(124076,'enUS','','Their agents lurk across Azeroth, threatening to subvert our efforts at the tomb. They are some of the Legion\'s most powerful champions.',26124),
(124077,'enUS','If the plans of these fiends come to fruition, all our efforts--all our sacrifices--will have been for naught.','',26124),
(124078,'enUS','We must enlist your help to hunt these targets down. You may be the only one with any chance of stopping them.','',26124),
(124079,'enUS','Oh? Is this egg moving?','Oh? Is this egg moving?',26124),
(124080,'enUS','The egg seems cold. Stay close to it to keep it warm.','The egg seems cold. Stay close to it to keep it warm.',26124),
(124081,'enUS','You hear a rustling sound inside the egg.','You hear a rustling sound inside the egg.',26124),
(124082,'enUS','The hippogryph inside is struggling to escape.','The hippogryph inside is struggling to escape.',26124),
(124083,'enUS','This is it! The egg is hatching!','This is it! The egg is hatching!',26124),
(124084,'enUS','','Message... at the pond... outside...',26124),
(124086,'enUS','Soon the Legion will learn what it truly means to burn.','',26124),
(124087,'enUS','','How may I help you?',26124),
(124088,'enUS','What\'s going on here?','What\'s going on here?',26124),
(124089,'enUS','How did you get in here? My research must remain secret!','',26124),
(124090,'enUS','My research... dies with me...','',26124),
(124091,'enUS','','The master has prepared a dinner for his guests.\n\nI\'m afraid the guest list is quite exclusive, and I do not see your name on the list. Are you delivering something for the party?',26124),
(124092,'enUS','You do not look like my master...','',26124),
(124093,'enUS','No, I defeated him. You are free.','No, I defeated him. You are free.',26124),
(124094,'enUS','The winds heed you.','',26124),
(124095,'enUS','Thunderaan, the Farseer summons your visage!','',26124),
(124096,'enUS','I have heard whispers on the wind. It is time to strike at the Burning Legion.','',26124),
(124097,'enUS','The armies of Skywall will have been summoned. The wind will be at your back.','',26124),
(124098,'enUS','We will find your friends. Confess, and your death shall come swiftly!','',26124),
(124099,'enUS','','I\'ve been alone for weeks! You must believe me!',26124),
(124100,'enUS','What do you mean, free?','',26124),
(124101,'enUS','Traitorous to the last...','',26124),
(124102,'enUS','What do you ask of the earth?','',26124),
(124103,'enUS','Stonemother... Farseer calls.','',26124),
(124104,'enUS','I have slain your master, you no longer need to serve him.','I have slain your master, you no longer need to serve him.',26124),
(124105,'enUS','','The armies of Deepholm are ready, fleshling.',26124),
(124106,'enUS','','My stone warriors will break the Legion to dust!',26124),
(124107,'enUS','He still controls my body though, I can feel it.','',26124),
(124108,'enUS','Flurry is another spell in your arsenal. While it can be cast on its own, Flurry is best used in tandem with another ability.','',26124),
(124109,'enUS','Casting Frostbolt can trigger an effect called Brain Freeze.','',26124),
(124110,'enUS','While Brain Freeze is active, Flurry can be cast instantly and does significantly more damage.','',26124),
(124111,'enUS','Cast Frostbolt until you gain Brain Freeze, then cast Flurry.','',26124),
(124112,'enUS','','Tracking someone this way takes a great deal of energy. I hope I can last...',26124),
(124113,'enUS','','Flurry is another spell in your arsenal. While it can be cast on its own, Flurry is best used in tandem with another ability.',26124),
(124114,'enUS','','Casting Frostbolt can trigger an effect called Brain Freeze.',26124),
(124115,'enUS','','While Brain Freeze is active, Flurry can be cast instantly and does significantly more damage.',26124),
(124116,'enUS','','Cast Frostbolt until you gain Brain Freeze, then cast Flurry.',26124),
(124117,'enUS','I am ready, Thalyssra.','I am ready, Thalyssra.',26124),
(124118,'enUS','Your Frayfeather Hatchling sighs contentedly.','Your Frayfeather Hatchling sighs contentedly.',26124),
(124119,'enUS','Your Frayfeather Hatchling seems to be learning.','Your Frayfeather Hatchling seems to be learning.',26124),
(124120,'enUS','Your Frayfeather Hatchling wants to see more of the world.','Your Frayfeather Hatchling wants to see more of the world.',26124),
(124121,'enUS','Your Frayfeather Hatchling seems impressed.','Your Frayfeather Hatchling seems impressed.',26124),
(124122,'enUS','Your Frayfeather Hatchling seems bored.','Your Frayfeather Hatchling seems bored.',26124),
(124123,'enUS','Your Frayfeather Hatchling stretches its wings.','Your Frayfeather Hatchling stretches its wings.',26124),
(124124,'enUS','Your Frayfeather Hatchling digs its claws tightly into your shoulder.','Your Frayfeather Hatchling digs its claws tightly into your shoulder.',26124),
(124125,'enUS','Your Frayfeather Hatchling starts to doze off.','Your Frayfeather Hatchling starts to doze off.',26124),
(124126,'enUS','I am yours to command, Farseer.','',26124),
(124127,'enUS','I\'d like to review the information you\'ve gathered on the Legion\'s agents.','I\'d like to review the information you\'ve gathered on the Legion\'s agents.',26124),
(124128,'enUS','','Hail, champion.',26124),
(124129,'enUS','','Talk to me, Vanthir...',26124),
(124130,'enUS','','The moment he was taken from the Waning Crescent he felt such terrible fear... but not for himself.',26124),
(124131,'enUS','','Fear for those that he sheltered, those he sacrificed for.',26124),
(124132,'enUS','','He was taken somewhere dark and isolated. He began to feel hunger settling its roots in his gut.',26124),
(124133,'enUS','','Hunger that did not pass, but grew...',26124),
(124134,'enUS','','... Until he could think of nothing else!',26124),
(124135,'enUS','','He is near to withering. His thoughts are jumbled, frantic... I just need to...',26124),
(124136,'enUS','','Focus! There!',26124),
(124137,'enUS','','He is being held at the Terrace of Order! It must be time for the display...',26124),
(124138,'enUS','It\'s about time someone showed up. I was starting to get bored...','',26124),
(124139,'enUS','Neptulon, the Farseer requests your aid!','',26124),
(124140,'enUS','...what are you standing around for? We\'ve got demons to kill.','',26124),
(124141,'enUS','Those demon bastards stole my gear...','',26124),
(124142,'enUS','Looks like I\'ll have to make my own...','',26124),
(124143,'enUS','I won\'t rest until I\'ve killed every beady-eyed, demon puke on this damned rock...','',26124),
(124144,'enUS','Don\'t worry about me. I\'ll find my own way out...','',26124),
(124145,'enUS','Hasta la vista, soldier.','',26124),
(124146,'enUS','I must admit, Farseer, I am surprised that you achieved what you did.','',26124),
(124147,'enUS','My forces and I shall follow you to Broken Shore. We will drown the Legion from this world!','',26124),
(124148,'enUS','You aren\'t supposed to be here!','You aren\'t supposed to be here!',26124),
(124149,'enUS','The penalty for trespassing here is death!','The penalty for trespassing here is death!',26124),
(124150,'enUS','Another fool on forbidden ground!','Another fool on forbidden ground!',26124),
(124151,'enUS','Leave no stone unturned! The traitors cannot hide from us!','Leave no stone unturned! The traitors cannot hide from us!',26124),
(124152,'enUS','We are getting close. I can taste their fear!','We are getting close. I can taste their fear!',26124),
(124153,'enUS','Traitors will be found and killed by decree of the Grand Magistrix!','Traitors will be found and killed by decree of the Grand Magistrix!',26124),
(124154,'enUS','','That took more out of me than I thought it would. You will have to free Vanthir without me. I am sorry.',26124),
(124155,'enUS','Over here, $r. Try not to alert all the guards as you approach.','',26124),
(124156,'enUS','Ah, reinforcements! Over here, there is much I have to tell you.','',26124),
(124157,'enUS','','I am grateful to see you, even if you are from the other camp. Come quickly, there is much to discuss!',26124),
(124158,'enUS','','Thank Elune you are here! I could use a helping hand with this.',26124),
(124159,'enUS','','Over here! I sense energies converging below, but aggressive guardians bar my way. I need you to clear a path.',26124),
(124160,'enUS','Fear not, First Arcanist. I will see to it that our friend here comes to no harm.','',26124),
(124161,'enUS','I am sadly familiar with Vanthir\'s captor.','',26124),
(124162,'enUS','','Thank you, Silgryn. Be careful.',26124),
(124163,'enUS','','I will need to maintain my focus for this to work... are you prepared to assist me in this endeavor?',26124),
(124164,'enUS','','Keep your voice down, Silgryn. It is good to see you too.',26124),
(124165,'enUS','Thalyssra?!','',26124),
(124166,'enUS','What manner of spell is this?','',26124),
(124167,'enUS','','One that will find our friend.',26124),
(124168,'enUS','We need to go to Helheim.','We need to go to Helheim.',26124),
(124169,'enUS','Everyone get to the beach! The Legion is relentless in their attacks!','Everyone get to the beach! The Legion is relentless in their attacks!',26124),
(124170,'enUS','','As you wish, Battlelord. Are you ready to depart?',26124),
(124171,'enUS','I\'m ready.','I\'m ready.',26124),
(124172,'enUS','The library of the Nar\'thalas Academy was said to contain detailed studies of local fauna. Such knowledge could prove quite useful. Leave no page unturned!','',26124),
(124173,'enUS','','Very efficient! Let us get a closer look... Say, this is impressive spellwork.',26124),
(124174,'enUS','I am saved!','I am saved!',26124),
(124175,'enUS','Quickly, into the ruins!','Quickly, into the ruins!',26124),
(124176,'enUS','','A mana bore, perhaps? Hmm... nothing. This requires a great deal of power to maintain.',26124),
(124177,'enUS','I hope you thugs wither!','I hope you thugs wither!',26124),
(124178,'enUS','','It is not attached to the Nightwell, but to the ley lines. Yet we control them, so how can she... Ah, yes. I see!',26124),
(124179,'enUS','So.... if you\'re a warlock.... why are you fighting demons?','So.... if you\'re a warlock.... why are you fighting demons?',26124),
(124180,'enUS','You cant just ask a warlock why they fight demons!','You cant just ask a warlock why they fight demons!',26124),
(124181,'enUS','....','....',26124),
(124186,'enUS','<Vanthir lays still. His eyes are glazed over and staring off into space.>','',26124),
(124187,'enUS','<Vanthir\'s eyes focus sharply on you. He does not speak.>','',26124),
(124188,'enUS','We\'re here to get you out, Vanthir. Just hold on.','We\'re here to get you out, Vanthir. Just hold on.',26124),
(124189,'enUS','I\'ve prepared a dusting that will allow my druids to fly for a short while in this humid air.\n\nSay the word and we\'ll begin the distraction while you head to the camp.','',26124),
(124190,'enUS','This humid air has made flying for any significant time rather difficult, but I\'ve developed a dusting that will allow us to take wing long enough to complete our assault.\n\nSay the word and we will begin the diversion while you infiltrate the camp.','',26124),
(124191,'enUS','I\'m ready. Send me to the ramparts!','I\'m ready. Send me to the ramparts!',26124),
(124192,'enUS','Thank you, stranger.','Thank you, stranger.',26124),
(124193,'enUS','We... we were almost killed!','We... we were almost killed!',26124),
(124194,'enUS','This city has devolved to madness...','This city has devolved to madness...',26124),
(124195,'enUS','I am safe... thank you.','I am safe... thank you.',26124),
(124196,'enUS','Hurry! We\'re not safe here!','Hurry! We\'re not safe here!',26124),
(124197,'enUS','Please, find me shelter!','Please, find me shelter!',26124),
(124198,'enUS','There are demons everywhere...','There are demons everywhere...',26124),
(124199,'enUS','I heard there were citizens holding safe houses...','I heard there were citizens holding safe houses...',26124),
(124200,'enUS','','The skies grow dark. We must press on.',26124),
(124202,'enUS','You are hit with anti-aircraft gunfire!','You are hit with anti-aircraft gunfire!',26124),
(124203,'enUS','The Legion\'s forces seem to be growing stronger every day.','The Legion\'s forces seem to be growing stronger every day.',26124),
(124204,'enUS','That may be, but I have faith in our commander. Their guidance will lead us to victory!','That may be, but I have faith in our commander. Their guidance will lead us to victory!',26124),
(124208,'enUS','The Burning Legion will not be defeated without great sacrifice. Lord Illidan knows this truth more than most.','',26124),
(124209,'enUS','','I will not leave this island until every demon has been slain and every fallen Horde warrior has been avenged!',26124),
(124210,'enUS','I have no love for the Horde, but their soldiers have fought and bled alongside us against the demons.$b$bWere it not for their bravery and cooperation, none of us would have survived this long.','',26124),
(124211,'enUS','|TInterface\\Icons\\SPELL_ARCANE_INVOCATION:20|t |cFFFF0000|Hspell:210022|h[Epocheric Orbs]|h|r fall from the sky!','|TInterface\\Icons\\SPELL_ARCANE_INVOCATION:20|t |cFFFF0000|Hspell:210022|h[Epocheric Orbs]|h|r fall from the sky!',26124),
(124212,'enUS','|TInterface\\Icons\\SPELL_ARCANE_ARCANE01.BLP:20|tYou will |cFFFF0000|Hspell:209973|h[Explode]|h|r in 6 seconds!','|TInterface\\Icons\\SPELL_ARCANE_ARCANE01.BLP:20|tYou will |cFFFF0000|Hspell:209973|h[Explode]|h|r in 6 seconds!',26124),
(124213,'enUS','|TInterface\\Icons\\6BF_Explosive_Shard.blp:20|t%s weaves |cFFFF0000|Hspell:209598|h[Conflexive]|h|r energies through her enemies!','|TInterface\\Icons\\6BF_Explosive_Shard.blp:20|t%s weaves |cFFFF0000|Hspell:209598|h[Conflexive]|h|r energies through her enemies!',26124),
(124214,'enUS','|TInterface\\Icons\\Spell_Mage_ArcaneOrb.blp:20|t%s targets her enemies with |cFFFF0000|Hspell:214278|h[Delphuric Beams]|h|r !','|TInterface\\Icons\\Spell_Mage_ArcaneOrb.blp:20|t%s targets her enemies with |cFFFF0000|Hspell:214278|h[Delphuric Beams]|h|r !',26124),
(124215,'enUS','|TInterface\\Icons\\Spell_Mage_ArcaneOrb.blp:20|t |cFFFF0000|Hspell:228877|h[Arcanetic Rings]|h|r collapse in from the edge of the room!','|TInterface\\Icons\\Spell_Mage_ArcaneOrb.blp:20|t |cFFFF0000|Hspell:228877|h[Arcanetic Rings]|h|r Collapse in from the edge of the room!',26124),
(124216,'enUS','I have served for so long, I cannot recall a time when I was of my own will.  Do you need a servant?','',26124),
(124217,'enUS','Then I choose to join you.','',26124),
(124218,'enUS','Yes, but your spirit is free to do what you will. You no longer need to serve him.','Yes, but your spirit is free to do what you will.  You no longer need to serve him.',26124),
(124219,'enUS','Not a servant, but you are welcome to join me and help me fight.','Not a servant, but you are welcome to join me and help me fight.',26124),
(124220,'enUS','The Duskwatch have taken outposts in the Crimson Thicket. Unleash the Withered at your command and drive them out!','',26124),
(124221,'enUS','The Duskwatch presume to push beyond their borders in the midst of a revolution. You repaid them for their arrogance!','',26124),
(124222,'enUS','Knowledge of potential threats gives us an advantage in battle. As ever, you\'ve proven to be a quick study!','',26124),
(124223,'enUS','Confess! You are harboring traitors to Suramar!','Confess! You are harboring traitors to Suramar!',26124),
(124224,'enUS','We know where your family is. Speak, or they die too!','We know where your family is. Speak, or they die too!',26124),
(124225,'enUS','Those who oppose the Grand Magistrix will pay dearly!','Those who oppose the Grand Magistrix will pay dearly!',26124),
(124226,'enUS','Dissent is forbidden, by order of Grand Magistrix Elisande!','Dissent is forbidden, by order of Grand Magistrix Elisande!',26124),
(124229,'enUS','Ahhhhhhhh!','',26124),
(124230,'enUS','No! Our hippo! We submit!','',26124),
(124232,'enUS','The mages of Nar\'thalas were known to craft wands of exceptional quality. You might see if their techniques could aid our war against the Legion.','',26124),
(124233,'enUS','Not necessarily what I had in mind, but insight is insight. Let\'s keep an eye out for other... learning opportunities.','',26124),
(124234,'enUS','','Wonderful, my favorite cheese.',26124),
(124235,'enUS','Nothing quite like the perfect rack of ribs.','',26124),
(124236,'enUS','The scholars of Nar\'thalas Academy were renowned for their knowledge of spell runes. Perhaps you might glean ancient secrets from the spirits who linger there.','',26124),
(124237,'enUS','Your outline work was exceptional. I\'d ask you to tutor Kirin Tor initiates... if you weren\'t busy saving the world from demons, I mean.','',26124),
(124238,'enUS','Tensions between the Horde and Alliance are tight enough when they share a battlefield. But the elves? You can practically cut this tension with a knife.','Tensions between the Horde and Alliance are tight enough when they share a battlefield. But the elves? You can practically cut this tension with a knife.',26124),
(124239,'enUS','Kaldorei, Sin\'dorei, Quel\'dorei, and Shal\'dorei? More like Don\'torei. Am I right?','Kaldorei, Sin\'dorei, Quel\'dorei, and Shal\'dorei? More like Don\'torei. Am I right?',26124),
(124240,'enUS','Conflict between the armies will not be tolerated. We are here to make sure everyone stays on target.','Conflict between the armies will not be tolerated. We are here to make sure everyone stays on target.',26124),
(124241,'enUS','Rogue Nightfallen are rebuilding mana pylons in the Ley-Ruins. The Azurewing have requested your help in eradicating this pestilence, champion.','',26124),
(124242,'enUS','Suramar is a city filled with so much magic it will be a true challenge to invade it. I just hope we can keep these armies together until we are successful.','Suramar is a city filled with so much magic it will be a true challenge to invade it. I just hope we can keep these armies together until we are successful.',26124),
(124243,'enUS','Khadgar put out the call to anyone willing to send troops to support this army. So who comes? \n\nBlood elves and night elves. The two races so at odds with each other it makes the feud between the Alliance and Horde seem almost paltry.','Khadgar put out the call to anyone willing to send troops to support this army. So who comes? \n\nBlood elves and night elves. The two races so at odds with each other it makes the feud between the Alliance and Horde seem almost paltry.',26124),
(124244,'enUS','The elves keep pulling pranks on each other. We are just trying to make sure things don\'t turn to violence.','The elves keep pulling pranks on each other. We are just trying to make sure things don\'t turn to violence.',26124),
(124245,'enUS','Vereesa almost shot at Rommath this morning. Khadgar had to talk her down... again.','Vereesa almost shot at Rommath this morning. Khadgar had to talk her down... again.',26124),
(124246,'enUS','So far the Suramar army has been hesitant to stretch out from their walls. I hope that doesn\'t mean they are planning something.','So far the Suramar army has been hesitant to stretch out from their walls. I hope that doesn\'t mean they are planning something.',26124),
(124247,'enUS','%s becomes enraged at the death of nearby offspring!','%s becomes enraged at the death of nearby offspring!',26124),
(124248,'enUS','The Azurewing have proven to be a valuable ally. By aiding them, you\'ve ensured their support in our campaign against the Legion.','',26124),
(124249,'enUS','Our allies have suffered the brunt of the enchantment. I can protect us from the residual energies for a time.','',26124),
(124250,'enUS','This temporal magic rivals that of the bronze dragonflight! I must concentrate on maintaining our defenses.','',26124),
(124251,'enUS','Take care! Hostile entities have been drawn to this disruption of time! Alright, lead the way.','',26124),
(124252,'enUS','Tyrande! I will attempt to pull her out, but doing so will require total focus. Be on your guard, $n.','',26124),
(124253,'enUS','That was close! I nearly shattered the flow of time itself.. but I think it\'s better now. Are you alright?','',26124),
(124254,'enUS','','I... I am well. What has happened?',26124),
(124255,'enUS','No time for that now. Let me get you somewhere safe!','',26124),
(124256,'enUS','','During the shattering of Azeroth, much knowledge was lost. But I, Lunelli, speak with the earth and the wind.$b$bThey have told me much and given me knowledge to pass on to those who think themselves worthy.$b$bSo, are you such a person?',26124),
(124257,'enUS','I can\'t maintain our protection any longer! We need to go.','',26124),
(124258,'enUS','Liadrin! I will attempt to pull her out, but doing so will require total focus. Be on your guard, $n.','',26124),
(124259,'enUS','','I couldn\'t get my shield up in time. What happened?',26124),
(124260,'enUS','You think to stop this demonstration? Very well. I will make an example of you first!','',26124),
(124261,'enUS','Stay your blade, Thoramir!','',26124),
(124262,'enUS','How good of you to join us, Silgryn. Aluriel sends her regards!','',26124),
(124263,'enUS','Accept your fate, Silgryn. You are outmatched!','',26124),
(124264,'enUS','Perhaps, but I am not alone.','',26124),
(124265,'enUS','You disappointed her, spell-fencer. You could have taken my place, if you had remained.','',26124),
(124266,'enUS','I have a conscience. I serve the people of Suramar.','',26124),
(124267,'enUS','You\'re too late, mortals! After I deal with you, this wretched world shall burn!','',26124),
(124268,'enUS','Yet you raise your blades against us! You are nothing but a traitor!','',26124),
(124269,'enUS','She... was right... about you...','',26124),
(124270,'enUS','I know.','',26124),
(124271,'enUS','This... isn\'t... finished...','',26124),
(124272,'enUS','We should not linger. Let us see to Vanthir now.','',26124),
(124285,'enUS','It feels good to no longer be hungry. I bet I could teleport anything now!','',26124),
(124286,'enUS','Telemancy beacons help supply power for teleportation triangulation. We should construct additional beacons.','',26124),
(124287,'enUS','Mage portals take so long to cast. With telemancy, it is like instant transmission!','',26124),
(124288,'enUS','Ready to go, $n? I always love teleporting to a new place!','',26124),
(124289,'enUS','Let\'s go!','Let\'s go!',26124),
(124290,'enUS','Next stop, sunny Azsuna! At least... it was sunny last time I checked. Which was only a few thousand years ago.','',26124),
(124291,'enUS','There we are! I am more or less locked on to the location you requested. Off you go!','',26124),
(124292,'enUS','','Wait... what do you--',26124),
(124293,'enUS','','Use Feral Spirit now to summon these spirits.',26124),
(124294,'enUS','Use Feral Spirit now to summon these spirits.','',26124),
(124295,'enUS','','The Legion sought to use its agents to subvert our efforts at the Tomb of Sargeras. Thanks to your efforts, they failed.',26124),
(124296,'enUS','','Now we focus on driving their armies from Azeroth. We will give everything we have and finish this... once and for all!',26124),
(124297,'enUS','Our power manifests: Kirin\'var torel, ahm shalar, azakim!','',26124),
(124298,'enUS','','Together! We must all lend our strength!',26124),
(124299,'enUS','','Step back and raise your weapon. We will infuse it with a portion of this council\'s power.',26124),
(124300,'enUS','Erk!','Erk!',26124),
(124301,'enUS','','You sought to hide, Nightfallen? I could sense your teleportation signatures from Azurewing!',26124),
(124302,'enUS','','Our champion\'s presence is the only thing staying my hand. Speak quickly.',26124),
(124303,'enUS','','By placing the taps on key points of the ley line, I can direct its flow.',26124),
(124304,'enUS','','Are you sure about that placement? It would be better here.',26124),
(124305,'enUS','','But I can see the line and the focus of the conduit. You want to put it there.',26124),
(124306,'enUS','','You can do that? Perhaps you know a thing or two after all.',26124),
(124307,'enUS','','Wait! This isn\'t what it looks like! We simply need to tap the... Oh. I guess it is what it looks like...',26124),
(124308,'enUS','','I am not \"poking\" it, I am tapping-- Hmph. I suppose it could work there...',26124),
(124309,'enUS','','I have spent millenia studying ley lines. I am certainly capable of finding one right beneath my feet!',26124),
(124310,'enUS','','Fine! We can do it your way. But if this entire cave ends up exploding with arcane energy, it will be on your head.',26124),
(124311,'enUS','','This final tap will allow me to steer the flow of energy, like the rudder of a ship. Right around here should do the trick.',26124),
(124312,'enUS','','My goodness. Was that a compliment?',26124),
(124313,'enUS','Sin\'dorei and shal\'dorei, take the Promenade and hold it against our foes. Once we have that, the kaldorei ride ahead and take the Concourse.','',26124),
(124314,'enUS','Archdruid... you have no doubt proven your strength to me in the past. I will proudly stand by your side to face the Legion.','',26124),
(124315,'enUS','The might of the bears will be with you. We shall be your steady guardians. Failure is not an option.','',26124),
(124316,'enUS','Now to combine the fragments you recovered.','',26124),
(124317,'enUS','That\'s a pity... I\'m afraid the results are imperfect. The message encoded into the crystal is scrambled. I can only make out a few--','',26124),
(124318,'enUS','No! I was so distracted by our efforts on the Broken Isles that I neglected the defenses I put in place...','',26124),
(124319,'enUS','The Legion has taken Karazhan! We MUST get it back!','',26124),
(124320,'enUS','','The ritual demands my full concentration. Please ensure I am not interrupted.',26124),
(124321,'enUS','','The currents are chaotic... this will take time.',26124),
(124322,'enUS','','Almost... there. Just need to hold out a little longer!',26124),
(124323,'enUS','','It is done! The flow has been redirected to Shal\'Aran.',26124),
(124324,'enUS','','You have done enough, arcanist. I shall take you both to Shal\'Aran. Come with me.',26124),
(124325,'enUS','We need to travel to Karazhan at once and discover what the Legion is after. I\'ll conjure a portal.','',26124),
(124326,'enUS','Archmage Karlain, we could use your assistance.','',26124),
(124327,'enUS','|TINTERFACE\\ICONS\\SHA_ABILITY_ROGUE_BLOODYEYE:20|tLook away when Things That Should Not Be cast |cFFFF0000|Hspell:207720|h[Witness the Void]|h|r to avoid being feared!','|TINTERFACE\\ICONS\\SHA_ABILITY_ROGUE_BLOODYEYE:20|Look away when Things That Should Not Be cast |cFFFF0000|Hspell:207720|h[Witness the Void] to avoid being feared|h|r!',26124),
(124328,'enUS','','If you are going to poke at a ley line, at least make sure it\'s the right spot. Try a little bit to the right.',26124),
(124329,'enUS','We are in it now.','',26124),
(124330,'enUS','<Present the Zeppelin Rental Form.>','<Present the Zeppelin Rental Form.>',26124),
(124331,'enUS','','Anyway, moving along!',26124),
(124332,'enUS','','The next tap should go here.',26124),
(124333,'enUS','No worries. You might not have EARNED the right to go up on the zep, but some schmuck PAID me to let you go on. So you\'re good to go.\n\nHop onto that teleporter! It definitely, probably won\'t kill you!','',26124),
(124335,'enUS','Free zeppelin rides for everyone, courtesy of $n! Come on over to the teleporter!','',26124),
(124336,'enUS','','You have our thanks. We will monitor their numbers closely.',26124),
(124337,'enUS','','Strange predators are encroaching on this ecosystem. Cull their numbers before they spread!',26124),
(124338,'enUS','','Another victory! You have proven to be quite the hunter of beasts.',26124),
(124339,'enUS','','Their wings are clipped.',26124),
(124340,'enUS','','You have done admirably in putting down this fowl menace.',26124),
(124341,'enUS','','We heard much squawking! We hope that means you were victorious.',26124),
(124342,'enUS','','Predatory birds have flown in from offshore. Push them back out to sea, lest we be overrun.',26124),
(124343,'enUS','','These feathered fiends are breeding out of control! End their cacophonous revelry!',26124),
(124344,'enUS','','Beware the sharp talons of these avian beasts! We have found them quite ferocious.',26124),
(124345,'enUS','','More frenzied fowl have overtaken this area. Cull their numbers before those eggs hatch.',26124),
(124346,'enUS','Yo! What\'ll it be?','',26124),
(124347,'enUS','<Present the Free Drinks Voucher.>','<Present the Free Drinks Voucher.>',26124),
(124348,'enUS','I will get you as close to the Crescent as I can. We will be in touch.','',26124),
(124349,'enUS','Hmph. Not as close as I\'d like, but it will have to do. Be careful.','',26124),
(124350,'enUS','Practice using your attacks by eliminating these target dummies.','',26124),
(124351,'enUS','','Practice using your attacks by eliminating these target dummies.',26124),
(124352,'enUS','This round\'s on $n! Free drinks for the next two minutes!','',26124),
(124353,'enUS','There you are! Over here!','',26124),
(124354,'enUS','Hmm? Oh, you again. Here to do some extracurricular studies, I presume.','',26124),
(124355,'enUS','Carry on, then.','',26124),
(124356,'enUS','Interested in buying something?','',26124),
(124357,'enUS','<Present the Brawler\'s Potion Dispenser.>','<Present the Brawler\'s Potion Dispenser.>',26124),
(124358,'enUS','$n has most generously paid for everyone\'s brawling potions. Get them while they\'re hot and bubbly!','',26124),
(124359,'enUS','','Interested in purchasing something... underhanded?',26124),
(124360,'enUS','<Present the Blood-Soaked Angel Figurine.>','<Present the Blood-Soaked Angel Figurine.>',26124),
(124361,'enUS','I will move ahead and clear out a safe haven for the survivors. Stay strong, my friend.','',26124),
(124362,'enUS','Hydras. Fascinating creatures, they are.','',26124),
(124363,'enUS','','Attention, brawlers! $n has made a bargain with the Spirit Healers! Go ahead and die as much as you want!',26124),
(124364,'enUS','I would like to make a suggestion for your studies. Check the top of the bookcase, if you will.','',26124),
(124365,'enUS','Well then.','',26124),
(124366,'enUS','That was certainly interesting.','',26124),
(124367,'enUS','Moving on, could I interest you in a look at the dragons of the eastern shore?','',26124),
(124368,'enUS','I would ask that you obtain the literature, however. I cannot seem to locate it...','',26124),
(124369,'enUS','Cannons at the ready... FIRE!','',26124),
(124370,'enUS','Fire the cannons!','',26124),
(124371,'enUS','Fire at will!','',26124),
(124372,'enUS','Aye, there\'s the target! Cannons... FIRE!','',26124),
(124373,'enUS','There\'s your target, lads! Fire away!','',26124),
(124374,'enUS','','You may help me find the ley lines, if you must. Just try not to get in my way.',26124),
(124376,'enUS','We tend to keep our distance, though. Ever since the research incident.','',26124),
(124377,'enUS','I would like to make a suggestion for your studies. Check the top of the bookcase, if you will.','',26124),
(124379,'enUS','<The orphaned direbeak falcosaur is looking around frantically for its mother.>','',26124),
(124380,'enUS','<The orphaned bloodgazer falcosaur is shaking uncontrollably. It looks terrified.>','',26124),
(124381,'enUS','<The orphaned sharptalon falcosaur cries out in hunger.>','',26124),
(124382,'enUS','<The orphaned snowfeather falcosaur is so weak it can barely walk.>','',26124),
(124383,'enUS','<Give the orphaned direbeak some of your Pungent Vrykul Gamalost.>','<Give the orphaned direbeak some of your Pungent Vrykul Gamalost.>',26124),
(124384,'enUS','<Give the orphaned snowfeather some of your Smoked Elderhorn.>','<Give the orphaned snowfeather some of your Smoked Elderhorn.>',26124),
(124385,'enUS','<Give the orphaned bloodgazer some of your Azsunian Grapes.>','<Give the orphaned bloodgazer some of your Azsunian Grapes.>',26124),
(124386,'enUS','<Give the orphaned sharptalon some of your Dried Bilberries.>','<Give the orphaned sharptalon some of your Dried Bilberries.>',26124),
(124387,'enUS','More bones for the arena!','',26124),
(124388,'enUS','More bones for the arena!','',26124),
(124389,'enUS','Hahahaha!','',26124),
(124390,'enUS','Wow! What killed you so fast?','',26124),
(124391,'enUS','You bore me!','',26124),
(124392,'enUS','Get in there and fight, stop hiding!','',26124),
(124393,'enUS','All you weaklings do is run around!','',26124),
(124394,'enUS','Finish him!','',26124),
(124395,'enUS','Finish her!','',26124),
(124396,'enUS','Ahhhh?!','',26124),
(124397,'enUS','Yes, yes!','',26124),
(124398,'enUS','Let the games... BEGIN!','',26124),
(124399,'enUS','Deathlord, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',26124),
(124400,'enUS','Dun\'na listen to anything Thelaron says. Nothing beats a strong hammer, a molten flame and fine steel.$b$bSpeakin\' o\'which, I should get back ta work.','',26124),
(124401,'enUS','','Are you watchin\' these fights? Lots of punishment bein\' handed out in that ring. I think I got hit with a tooth.',26124),
(124402,'enUS','<Present the High Roller\'s Contract.>','<Present the High Roller\'s Contract.>',26124),
(124403,'enUS','','You feelin\' lucky? $n wants you to talk to Pit Boss Buxdoggle and test your... gold-earning potential.',26124),
(124404,'enUS','<Present the Bag of Chipped Dice.>','<Present the Bag of Chipped Dice.>',26124),
(124405,'enUS','','I will take the teleporter to the estate and bring our most powerful Withered. Meet me there.',26124),
(124406,'enUS','','$n has turned in enough gold to bend the rules of the arena. Speak to a grunt if you\'d like to fight against a random brawler!',26124),
(124407,'enUS','Slayer, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',26124),
(124408,'enUS','Archdruid, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',26124),
(124409,'enUS','Huntmaster, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',26124),
(124410,'enUS','Archmage, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',26124),
(124411,'enUS','Grandmaster, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',26124),
(124412,'enUS','Highlord, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',26124),
(124413,'enUS','High Priest, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',26124),
(124414,'enUS','Shadowblade, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',26124),
(124415,'enUS','Farseer, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',26124),
(124416,'enUS','Netherlord, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',26124),
(124417,'enUS','Battlelord, once again you have fought to safeguard Azeroth\'s future. On behalf of the entire council, thank you.','',26124),
(124418,'enUS','','Cozy, secluded, and teeming with arcane energy. I might need to construct a workshop here...',26124),
(124419,'enUS','','This cave is really well hidden. I am surprised Oculeth managed to get us here in one piece.',26124),
(124420,'enUS','','Are you ready to begin the ritual, $n?',26124),
(124421,'enUS','I am ready, Valtrois.','I am ready, Valtrois.',26124),
(124422,'enUS','I\'m only mildly enthusiastic about this.','',26124),
(124423,'enUS','Errrrrrr...','Errrrrrr...',26124),
(124424,'enUS','Erk?','Erk?',26124),
(124425,'enUS','Baroo!','Baroo!',26124),
(124426,'enUS','','Elisande made YOU First Arcanist? The pickings must have been slim indeed. Release Ly\'leth now!',26124),
(124427,'enUS','','Ha! This is what you bring? An outlander and a pack of mindless, mana-starved corpses? You have fallen on hard times indeed.',26124),
(124428,'enUS','','I\'ll show you what these corpses can do. Attack!',26124),
(124429,'enUS','','Poor Thalyssra... you try so hard to save your people, yet you cut them off from the one thing that can restore them! I fear Ly\'leth shall pay the price for your arrogance.',26124),
(124430,'enUS','','Let us test the mettle of your rebellion! Send your best to face me at Ly\'leth\'s estate... before I bring in more citizens for... questioning!',26124),
(124431,'enUS','','As if I would bother with facing you myself. Felborne! Kill them!',26124),
(124432,'enUS','','The Withered... defeated so easily by fel magic. Please... save those you can. My wounds... are of no concern!',26124),
(124433,'enUS','Is this some sort of joke?!','Is this some sort of joke?!',26124),
(124434,'enUS','I can\'t even guess what they made this out of.','I can\'t even guess what they made this out of.',26124),
(124435,'enUS','I want to fight a random enemy!','I want to fight a random enemy!',26124),
(124436,'enUS','Where did they even get the stuff to make this?','Where did they even get the stuff to make this?',26124),
(124437,'enUS','Those throwback, tree hugging, kaldorei filth.','Those throwback, tree hugging, kaldorei filth.',26124),
(124438,'enUS','Those... those... night elves!','Those... those... night elves!',26124),
(124440,'enUS','unused do not translate','',26124),
(124441,'enUS','','Whatever you plan to do, do it quickly. I sense the approach of something... hungry!',26124),
(124442,'enUS','','Look out, champion! It is here!',26124),
(124443,'enUS','%s is tired after its adventure!','',26124),
(124444,'enUS','Rrrr....','Rrrr....',26124),
(124445,'enUS','%s seems content.','',26124),
(124446,'enUS','%s chitters happily.','',26124),
(124447,'enUS','%s admires you.','',26124),
(124448,'enUS','','I must rest before we make our way back to Shal\'Aran. That was more taxing than I expected...',26124),
(124449,'enUS','','You made an excellent assistant. Your inherent knowledge of ley lines is almost as expansive as mine.',26124),
(124450,'enUS','','I know what she would be capable of. That is why we must stop her.',26124),
(124451,'enUS','','You go on ahead and inform Thalyssra. I have a few questions for our friend here.',26124),
(124452,'enUS','','Do you actually visualize the lines, or is it more that you sense them? Is it a constant sensation, or can you turn it on and off?',26124),
(124453,'enUS','%s examines the fragment.','',26124),
(124454,'enUS','','Your control over such vast energies is impressive. That was no small task.',26124),
(124455,'enUS','','The drogbar are wreaking havoc in Thunder Totem, scattering our drums and chasing off our livestock. These disruptions must be stopped!',26124),
(124456,'enUS','','Order has been restored. Your aid is always welcome here, champion. For Highmountain!',26124),
(124457,'enUS','','Unruly drogbar have thrown our supply crates to the bottom of the chasm. Luckily, we have a convenient method for their retrieval...',26124),
(124458,'enUS','','Our thanks, champion. We refuse to let the drogbar sabotage our way of life. We are Highmountain!',26124),
(124459,'enUS','','Yes, and I know the convergence of ley lines feeds great power to the Nightwell. Harnessing that much power is perilous, but if she could...',26124),
(124460,'enUS','','Yes? What do you want to know?',26124),
(124461,'enUS','','I remember this power... Kel\'balor! The Crimson Thicket is our destination.',26124),
(124462,'enUS','','Ah, you have arrived. I expected to find something here but...',26124),
(124463,'enUS','','One down, two to go. Let me know when you are ready.',26124),
(124464,'enUS','','This is the last one. One last knot to work loose, and the energy should flow freely again.$b$bI hope you are ready.',26124),
(124465,'enUS','A frigid storm is brewing atop the peak near Hafr Fjall. Strike down its source before the land suffers in its icy wake!','',26124),
(124466,'enUS','Well done, champion. You fight with the fury of a storm!','',26124),
(124467,'enUS','The Blackfeathers have named a new chieftain after the last... incident. It seems they intend to give their ritual another try.','',26124),
(124468,'enUS','It seems dancing can be dangerous! Careful not to be too loose of foot.','',26124),
(124469,'enUS','An unusual creature near the coast is challenging the local makrura. I sense it has a connection to you... Go to its aid, champion.','',26124),
(124470,'enUS','It seems you two share a kinship. An ally is an ally... no matter now small!','',26124),
(124471,'enUS','Much has been asked of you in the course of this war, champion. I fear even more is needed.','',26124),
(124473,'enUS','Traces of Shaladrassil\'s corruption remain within Suramar. Perhaps the horns of the vile satyrs may be put to better use.','',26124),
(124476,'enUS','Such corruption can be relentless, but you have pushed it back... for now.','',26124),
(124477,'enUS','','Archdruid, I have witnessed your power grow through every trial you have overcome.',26124),
(124478,'enUS','','Your greatest test is at hand. You must purge the Legion\'s corruption from Azeroth... once and for all.',26124),
(124479,'enUS','','My followers and I stand with you, Archdruid. Balance must be restored!',26124),
(124480,'enUS','','Allow me to aid you. My dragon form is ill-suited for fighting in such close quarters, and we are accompanied by a capable champion.',26124),
(124481,'enUS','The owlkitten patriarch, Yowlon, is having trouble herding his kittens back home. Look into those eyes, champion. You cannot possibly leave them in danger!','',26124),
(124482,'enUS','I am relieved they are safe, at least for now. Hmm, perhaps I should look into adoption...','',26124),
(124483,'enUS','Champion! It is time to demonstrate your strength and skill once again!','',26124),
(124484,'enUS','Champion! I have need of your aid. There is important work to be done.','',26124),
(124485,'enUS','Friend, I request your aid for the sake of Suramar. The survival of my people depends on it.','',26124),
(124486,'enUS','','This ley line is being leeched, but I cannot see... wait! I have an idea.',26124),
(124487,'enUS','','Those fel-sucking, city-dwelling narcissists!',26124),
(124488,'enUS','','Who would leave such an insulting thing here?',26124),
(124489,'enUS','','A clever cloaking spell, but what is that device? Keep watch.',26124),
(124490,'enUS','','Well, this was childish.',26124),
(124491,'enUS','','I would expect this type of low blow from a dwarf...',26124),
(124492,'enUS','','I don\'t get it...',26124),
(124493,'enUS','','Hmm.. they are redirecting a portion of the ley line\'s power directly to the Sanctum of Order.',26124),
(124494,'enUS','','I\'m hesitant to take any action at this point. I\'ll return to Shal\'Aran and continue my research.',26124),
(124495,'enUS','','Very well, I shall begin. When I am finished, all the devices we have \"adjusted\" will cease working.',26124),
(124496,'enUS','','It is done. The barrier should be down.',26124),
(124497,'enUS','I will open the portal. The element of surprise will be in your favor!','',26124),
(124498,'enUS','','If anything goes wrong, have your Withered at the ready. Good luck, $n.',26124),
(124499,'enUS','DELETE','',26124),
(124500,'enUS','We cannot tarry here for long, I fear. Catch your breath.','',26124),
(124501,'enUS','I hope she sees this...','',26124),
(124502,'enUS','This way! Everyone into the boat!','',26124),
(124503,'enUS','Excellent timing as usual, Deline.','',26124),
(124504,'enUS','','She is waiting for you just outside.',26124),
(124505,'enUS','','Do you remember me, outlander?',26124),
(124506,'enUS','','The fruit from this tree plucked me from the jaws of madness. I am whole now, and I wish to fight.',26124),
(124507,'enUS','','My brother rests here. My name is Arluelle.',26124),
(124509,'enUS','','It is an honor to finally meet you, First Arcanist.',26124),
(124510,'enUS','','You must be Arluin\'s sister. We owe him a great debt. His sacrifice was not in vain.',26124),
(124511,'enUS','','So be it. I will send you to Silgryn. With his training you will serve us well.',26124),
(124512,'enUS','Excellent. Begin when ready. Use the surveyor and follow the alignment indicator. Uh... the light. Just follow the light!','',26124),
(124513,'enUS','That shall suffice for now. This positional data will enhance-- Oh, nevermind. You did a fine job.','',26124),
(124514,'enUS','','We have been discovered!',26124),
(124515,'enUS','','This should shock me, but it does not. Not after the Waning Crescent.',26124),
(124516,'enUS','','We must put an end to this.',26124),
(124517,'enUS','The telemancy orbs are working perfectly. Best we keep this quiet until we\'re ready for the real push.','',26124),
(124519,'enUS','Ha! You walk willingly to your death, mortal!','',26124),
(124520,'enUS','I will take great pleasure in grinding your soul to nothing!','',26124),
(124521,'enUS','Shaza-kiel!','',26124),
(124522,'enUS','You are nothing! Insignificant gnat!','',26124),
(124523,'enUS','No! ... I will be... fuel...','',26124),
(124524,'enUS','','The fel crystals anchor the Legion\'s power here. We should see what the Withered can do against them.',26124),
(124525,'enUS','Perhaps. The First Arcanist will know how to proceed. Let us get these people to Shal\'Aran.','',26124),
(124526,'enUS','Thank you... I\'ll make my way back to the defenses.','Thank you... I\'ll make my way back to the defenses.',26124),
(124527,'enUS','','I\'ve seen enough. I believe I can dampen the effect of fel magic on the Withered. Go to the Soul Engine and I will send new subjects your way.',26124),
(124528,'enUS','I owe you my life! I\'ll head back to our defensive line.','I owe you my life! I\'ll head back to our defensive line.',26124),
(124530,'enUS','','That worked even better than expected! I shall continue to refine my work for the next step.',26124),
(124531,'enUS','It... it was only a flesh wound! I\'m still good to... OUCH! Nevermind, I\'ll head back to the defenses.','It... it was only a flesh wound! I\'m still good to... ow! Nevermind, I\'ll head back to the defenses.',26124),
(124532,'enUS','Ahh, much better. Thank you!','Ahh, much better. Thank you!',26124),
(124533,'enUS','Praise you, hero!','Praise you, hero!',26124),
(124534,'enUS','I\'ll forever be grateful for this!','I\'ll forever be grateful for this!',26124),
(124535,'enUS','','He is to be made an example for all to see.',26124),
(124536,'enUS','','How much time do we have?',26124),
(124537,'enUS','','I do not know. I only hope we are not too late.',26124),
(124538,'enUS','Lay still, my friend. We will get you out.','',26124),
(124539,'enUS','','He will be fine. The fruit will bring him back.',26124),
(124540,'enUS','Relief... at last...','',26124),
(124541,'enUS','Aran\'ethil... The nightmare is over!','',26124),
(124542,'enUS','Welcome back, old friend.','',26124),
(124543,'enUS','They wanted to make an example. We have stolen their message and made it ours.','',26124),
(124544,'enUS','All will see... hope... in the Dusk Lily.','',26124),
(124545,'enUS','<Cough.> I need... to rest now. Thank you. Thank you for everything.','',26124),
(124546,'enUS','We will see him back to safety. Go inform Thalyssra of our success.','',26124),
(124548,'enUS','Put those wards up!','',26124),
(124549,'enUS','Impossible! What have you done?','',26124),
(124550,'enUS','','More souls to fuel the portal!',26124),
(124551,'enUS','','Behold the infinite Legion!',26124),
(124552,'enUS','','No! The portal...',26124),
(124555,'enUS','|TInterface\\Icons\\ABILITY_PRIEST_FLASHOFLIGHT.BLP:20|t Hyrja targets |cFFFF0000$n|r with |cFFFF0404|Hspell:228162|h[Shield of Light]|h|r!','|TInterface\\Icons\\ABILITY_PRIEST_FLASHOFLIGHT.BLP:20|t Hyrja targets |cFFFF0000$n|r with |cFFFF0404|Hspell:228162|h[Shield of Light]|h|r!',26124),
(124556,'enUS','','Never in ten thousand years did I believe the Legion would be at the very doorstep to the grove. \n\nNo matter what, I will never allow them to enter it!',26124),
(124557,'enUS','','An ettin is rampaging through the catacombs! Stop it before it causes further damage!',26124),
(124558,'enUS','','I shudder at the thought of an ettin empowered by the Nightwell. Thank you for saving us.',26124),
(124559,'enUS','','The souls of my ancestors are trapped by the Nightwell\'s power. We must free them from their torment.',26124),
(124560,'enUS','','May they rest in peace. The Nightwell once sustained us, but it has become a source of pain... in many ways.',26124),
(124561,'enUS','','The fal\'dorei have breached the palace! Stop them before the guards take notice!',26124),
(124562,'enUS','','I don\'t believe our cover has been compromised. Quickly, find Aluriel and breach the gates!',26124),
(124563,'enUS','','Elisande\'s personal construct is nearby. It would be a shame if something bad happened to it...',26124),
(124564,'enUS','','Let this be a lesson to those who flaunt their power.',26124),
(124565,'enUS','','Find the palace\'s supply route and cut it off. Flightmaster Volnath should be near the captain\'s quarters.',26124),
(124566,'enUS','','Without a steady stream of supplies, the palace will soon fall! Well done.',26124),
(124567,'enUS','','If we can control the Nightspire, the palace will fall. Stop the ritual!',26124),
(124568,'enUS','','We are one step closer to ending this madness. Elisande\'s final hour has come!',26124),
(124569,'enUS','','Elisande\'s sycophants and concubines loiter about her private chambers atop the Nightspire. We cannot allow them to warn the Legion of our assault!',26124),
(124570,'enUS','','Those traitors deserved their fate. History will remember their atrocities.',26124),
(124571,'enUS','','Tel\'arn\'s experiments have gone too far! A beast is rampaging across the terrace!',26124),
(124572,'enUS','','Tel\'arn\'s madness knows no bounds. If not for you, the beast might have destroyed the entire terrace.',26124),
(124573,'enUS','I have an idea! A mass teleport... but I need help casting it.','',26124),
(124574,'enUS','Won\'t their wards block your telemancy?','',26124),
(124575,'enUS','Not to worry. They\'ve ignored my advice to upgrade those wards for centuries now...','',26124),
(124576,'enUS','What is it you seek: wisdom, or power? Both perhaps?','',26124),
(124577,'enUS','You tread on hallowed ground, outsider. I trust you would not do so without purpose.','',26124),
(124578,'enUS','You come to our crucible, where our most honored mages have been tested for millennia. Why are you here?','',26124),
(124579,'enUS','I seek the guidance of the Moon Guard.','I seek the guidance of the Moon Guard.',26124),
(124580,'enUS','Very well. Center your mind. You will be tested in the tradition of our order.','',26124),
(124581,'enUS','','We have what we need to secure the Sanctum. Now everything rests on Valtrois. When she is ready, you will be the first to know.',26124),
(124582,'enUS','Cannons at the ready... FIRE!','',26124),
(124583,'enUS','All cannons, fire at the target!','',26124),
(124584,'enUS','Target acquired! Fire away!','',26124),
(124585,'enUS','Send the demons to hell! FIRE!','',26124),
(124586,'enUS','For the Dark Lady!','',26124),
(124587,'enUS','Fire at will!','',26124),
(124588,'enUS','Our friend lies just in here.','',26124),
(124589,'enUS','It breaks my heart to see him like this.','',26124),
(124590,'enUS','','What brings you to Shal\'Aran in this dark hour?',26124),
(124591,'enUS','','Hello.',26124),
(124592,'enUS','','Greetings.',26124),
(124593,'enUS','','You have my attention.',26124),
(124594,'enUS','','Hm?',26124),
(124595,'enUS','','Good day.',26124),
(124596,'enUS','','Understood.',26124),
(124597,'enUS','','Goodbye.',26124),
(124598,'enUS','','Farewell.',26124),
(124599,'enUS','','I am not certain why you still require my attention.',26124),
(124600,'enUS','','I have nothing to offer you.',26124),
(124601,'enUS','','Withering was less tiresome than this.',26124),
(124602,'enUS','','Greetings.',26124),
(124603,'enUS','','Hello.',26124),
(124604,'enUS','','Tenu\'balah.',26124),
(124605,'enUS','','Yes?',26124),
(124606,'enUS','','I serve Suramar. All of Suramar.',26124),
(124607,'enUS','','Elisande cannot get away with this.',26124),
(124608,'enUS','','My loyalties have never changed.',26124),
(124609,'enUS','','We stand against the Legion.',26124),
(124610,'enUS','','I have endured worse.',26124),
(124611,'enUS','','I am above this. My training gives me unyielding resolve.',26124),
(124612,'enUS','','Perhaps I could make an exception.',26124),
(124613,'enUS','Thalyssra, you may lead the charge.','',26124),
(124614,'enUS','','Shal\'dorei, the time has come to take back our city! Forward! Anath\'ashar!',26124),
(124615,'enUS','','Sin\'dorei, secure the Promenade and hold position! The Light will deliver justice to our enemies this day!',26124),
(124616,'enUS','','Kaldorei, prepare to charge the concourse! Elune calls you to rid this city of evil!',26124),
(124617,'enUS','Do what you can, $n, but be careful.','Do what you can, $n, but be careful.',26124),
(124618,'enUS','Not like this...','Not like this...',26124),
(124619,'enUS','The others! Help the others!','The others! Help the others!',26124),
(124620,'enUS','Such actions will not go unpunished.','Such actions will not go unpunished.',26124),
(124621,'enUS','Where did they come from?','Where did they come from?',26124),
(124622,'enUS','The Legion has spread its corruption to the Heart of Val\'sharah! Our defenders need your aid if we are to have any hope of defeating the demons.','',26124),
(124626,'enUS','My defenses... were perfect...','',26124),
(124628,'enUS','This land has endured much suffering at the hands of the Burning Legion. Your actions have restored a measure of peace.','',26124),
(124629,'enUS','An illusion! What are you hiding?','An illusion! What are you hiding?',26124),
(124630,'enUS','Something\'s not quite right...','Something\'s not quite right...',26124),
(124631,'enUS','Who goes there?!','Who goes there?!',26124),
(124632,'enUS','Stay in your homes!','',26124),
(124633,'enUS','Stay inside if you want to live!','',26124),
(124634,'enUS','You flee at the cost of your life!','',26124),
(124635,'enUS','Scurry, little mice!','',26124),
(124636,'enUS','Here we are again, $n. Ever notice how all this ley energy seems to just fly all over the place?','',26124),
(124637,'enUS','I\'ll cast a spell on you to empower you to dash through the air. Use it to the reach the goal off in the distance.','',26124),
(124638,'enUS','Be sure to pass through the energy orbs to recharge the dash ability I\'ve given you.  Oh and uh...','',26124),
(124639,'enUS','Avoid the volatile energy out there and... try not to fall, eh?','',26124),
(124640,'enUS','Good luck!','',26124),
(124641,'enUS','Look at me!','',26124),
(124642,'enUS','','Dis tower has been abandoned for ages, surely dere be countless wonders locked inside. \n\nXylem will be so impressed with dis bounty, he\'ll have to let me in his inner circle. Now, if only I could get dis door open...',26124),
(124643,'enUS','Nooooo!','',26124),
(124644,'enUS','I need that mantle.','I need that mantle.',26124),
(124645,'enUS','Come back to me, Dazzle!','',26124),
(124646,'enUS','Such a menial task.','',26124),
(124647,'enUS','Oh, you challenged the wrong goblin, pal. It\'s fireball time!','',26124),
(124648,'enUS','','Ready ya\'self!',26124),
(124649,'enUS','','Enough. Ya be a greater apprentice dan I. Take da mantle...',26124),
(124650,'enUS','','Now, leave me be.',26124),
(124651,'enUS','You can cut the tension with a knife. We must strike soon...','',26124),
(124652,'enUS','The elves are restless. It is all the Kirin Tor can do to keep the peace.','',26124),
(124653,'enUS','Gul\'dan must not be allowed to use the Nightwell.','',26124),
(124654,'enUS','I am having difficulty spotting the infiltrators, Khadgar. Can you help me detect them?','I am having difficulty spotting the infiltrators, Khadgar. Can you help me detect them?',26124),
(124655,'enUS','','Like this?',26124),
(124656,'enUS','Place your feet a little farther apart. You are just slightly off balance.','',26124),
(124657,'enUS','','I think I have it now.',26124),
(124660,'enUS','','Understood, Silgryn.',26124),
(124661,'enUS','','Am I doing this right?',26124),
(124662,'enUS','','What do you think?',26124),
(124663,'enUS','','How about that?',26124),
(124664,'enUS','Relax your shoulders. You are limiting your mobility.','',26124),
(124665,'enUS','Control your breathing. Exhale forcefully with your thrust.','',26124),
(124666,'enUS','Loosen your grip on your blade. No need to clutch it so tightly.','',26124),
(124667,'enUS','','That feels much better.',26124),
(124668,'enUS','','I see!',26124),
(124669,'enUS','Look out, it\'s a loooong way down.','',26124),
(124670,'enUS','It was supposed to be a simple journey. Jus\' bring da satchel to da isles and collect my payment.$b$bNow da boss is gonna kill me!','',26124),
(124671,'enUS','|TInterface\\Icons\\inv_legionadventure.blp:20|t%s orders a |cFFFF0000|Hspell:229284|h[Bombardment]|h|r!','',26124),
(124672,'enUS','|TInterface\\Icons\\spell_warlock_demonicportal_green.blp:20|t%s begins to open a |cFFFF0000|Hspell:229610|h[Demonic Portal]|h|r! Pursue him through it!','',26124),
(124678,'enUS','','The Nightfallen require your aide. Will you answer the call yet again?',26124),
(124679,'enUS','','You remain a reliable ally. Thank you, champion.',26124),
(124680,'enUS','','The enemy does not rest. Neither shall we!',26124),
(124681,'enUS','','Fine work, champion. The Horde marches behind you!',26124),
(124682,'enUS','','The war effort in Suramar requires your aide, champion.',26124),
(124683,'enUS','','We move closer to victory with every stride.',26124),
(124684,'enUS','I\'ve found all the materials.','I\'ve found all the materials.',26124),
(124685,'enUS','','The Nightwell...',26124),
(124686,'enUS','','I thought I would never see it again!',26124),
(124687,'enUS','It is dying. Without the Eye of Aman\'thul, the Nightwell has become unstable.','',26124),
(124688,'enUS','Your soul will fuel the Legion!','Your soul will fuel the Legion!',26124),
(124689,'enUS','','We could stabilize it! We no longer need the Nightwell to sustain us, but we can still harness its power...',26124),
(124690,'enUS','Thalyssra? It is your call...','',26124),
(124691,'enUS','','Let it die.',26124),
(124692,'enUS','','It is.. you! You delivered the letter!',26124),
(124693,'enUS','','I can make it to the border. Thank you. Tell Absolon I am coming!',26124),
(124694,'enUS','','Absolon! What happened to you?',26124),
(124695,'enUS','','Tell me everything that happened. About our daughter...',26124),
(124696,'enUS','Noressa! I thought I would never see you again...','',26124),
(124697,'enUS','Yes, you deserve to know. Let me show you our new home...','',26124),
(124698,'enUS','','We must put the Nightwell behind us. We must take responsibility for our failings, and repay our debt to the people of Azeroth.',26124),
(124699,'enUS','','Ah, free at last! Thank you, Outlander.',26124),
(124700,'enUS','','I told Aluriel you would come to rescue me and she merely laughed. Well who is laughing now?',26124),
(124701,'enUS','It looks like the goblins already picked these ruins clean. \n\nAt this rate, I\'m never going to find something to impress the archmage!','',26124),
(124702,'enUS','I, um, need your robes...','I, um, need your robes...',26124),
(124703,'enUS','You think you can beat me?! Well, how about five of me?!','',26124),
(124704,'enUS','Stop! No more! You can take the stupid robes!','',26124),
(124705,'enUS','I hope Xylem turns you into a cockroach...','',26124),
(124706,'enUS','I feel... uneasy. What is going on?','',26124),
(124707,'enUS','You were being corrupted by the Legion.','You were being corrupted by the Legion.',26124),
(124708,'enUS','The Legion tried to corrupt me?$b$bThe death of the human king led me to turmoil. I chose him as my champion because of his ferocity, but also his ability to conquer his bloodlust to uphold his beliefs and protect his people. I entered the Dream upon his death to reflect.$b$bBut in that time, the Legion must have found me.','',26124),
(124709,'enUS','We will solve this.','We will solve this.',26124),
(124710,'enUS','The Legion must be trying to take advantage of the Nightmare\'s withering. I may have been the first attack, but I doubt I will be the last. We must find and defeat whoever is leading the attacks against our people.','',26124),
(124712,'enUS','Hey $r! You looking for something?','',26124),
(124718,'enUS','','Hey, Archdruid! Over here!',26124),
(124719,'enUS','First the stupid trials and now he\'s got me digging through dusty old ruins. This inner circle gig better be worth it.\n\nWhat? Go away, you. I\'m archaeology...ing...','',26124),
(124720,'enUS','I challenge you for that hat!','I challenge you for that hat!',26124),
(124721,'enUS','Okay, geez! Take it!','',26124),
(124722,'enUS','It\'s a silly lookin hat anyway...','',26124),
(124725,'enUS','','A challenge? Very well, but ya be warned. Xylem has taught me mastery over frost.',26124),
(124727,'enUS','','M-mother told me t-to hide.',26124),
(124728,'enUS','Your father is waiting for you downstairs- hurry!','Your father is waiting for you downstairs- hurry!',26124),
(124729,'enUS','I heard screaming! I\'m scared!','',26124),
(124730,'enUS','Your father will help you get to safety. Go downstairs now!','Your father will help you get to safety. Go downstairs now!',26124),
(124735,'enUS','Father!!','',26124),
(124736,'enUS','','I\'m going!',26124),
(124737,'enUS','T-they gave us no warning. Lunette- my children! Ugh...','',26124),
(124738,'enUS','You need to get out of here. It isn\'t safe!','You need to get out of here. It isn\'t safe!',26124),
(124739,'enUS','My son was injured in the chaos... I have not been able to move him. Please, help us!','',26124),
(124740,'enUS','Eneas, you need to go now.','Eneas, you need to go now.',26124),
(124741,'enUS','','Yeah, Xylem\'s gone a little mad, but he\'s still a renowned archmage!  Just think of what I could learn from him!',26124),
(124742,'enUS','Do you know anything about the barrier puzzle?','Do you know anything about the barrier puzzle?',26124),
(124743,'enUS','','One of the inner circle apprentices told me \"One must master the traditional schools before delving into the realm of shadow.\"\n\nI think that was supposed to be a hint.',26124),
(124744,'enUS','','I had a nice outfit like you before, but I got tired of being challenged by the other apprentices. \n\nI\'m sure Xylem will let me in the tower on the merit of my spellcasting!',26124),
(124745,'enUS','','I saw one of the apprentices enter once, though all I was able to see was that he activated the white gem before the red one.',26124),
(124746,'enUS','I\'m sure if I study hard enough that Xylem will let me in the tower. \n\nIf I could find a bonnie hat like the one you\'ve got, that couldn\'t hurt either.','',26124),
(124747,'enUS','One of the other apprentices was pretty sure the order was simply right to left. \n\nI think his name was... Heinrich?','',26124),
(124748,'enUS','I be tranin\' all day to make da archmage notice me down here, but so far nothin\'!\n\nI wonda if he\'s even gonna be takin\' any more apprentices...','',26124),
(124749,'enUS','You wanna be gettin past da barrier? Good luck, mon.\n\nJust make sure ya don\'t touch any of da crystals twice, ya hear? Bad things happen to dose dat do.','',26124),
(124750,'enUS','Why are you botherin me? \n\nJust because you\'ve got some fancy robes you think you can boss us around?','',26124),
(124751,'enUS','Oh, that thing? \n\nWell, I\'ll tell you what I know - the first gem is definitely fire...\n\n<Wix quietly chuckles to himself.>','',26124),
(124752,'enUS','','Whatever you do, don\'t try touching those gems unless you know the right order. \n\nI\'ve seen what happens when you touch the wrong one, and it\'s not pretty.',26124),
(124753,'enUS','','Me? Haven\'t got a clue. Just don\'t listen to anything Wix says. \n\nHe gets some sick satisfaction from watching apprentices fry themselves on that puzzle.',26124),
(124754,'enUS','Well met, $n. Wanna know what we do when we\'ve drunk all but one keg \'o ale?','',26124),
(124755,'enUS','Why we play a game o\'  course!','',26124),
(124756,'enUS','Um, hello.  Can I help you with something?','',26124),
(124757,'enUS','I\'m gonna jumble these all about; but the keg with the ale still inside will flash yellow before all that starts.','',26124),
(124758,'enUS','Watch closely as they move around, and select the correct barrel when they stop.','',26124),
(124759,'enUS','You\'ll know you\'re ready to select your barrel when they all flash white.','',26124),
(124760,'enUS','I think it has something to do with the order Xylem teaches his apprentices. \n\nI only started learning Arcane, though, so I\'m not sure what the rest of the order would be.','',26124),
(124761,'enUS','','Tread carefully, the Legion\'s presence is strong here.$b$bHave the nightborne forgotten all we lost in the War of the Ancients? This way lies destruction and death.',26124),
(124762,'enUS','Hah! Try again.','',26124),
(124763,'enUS','Bah, lucky!','',26124),
(124764,'enUS','','The Legion is strong here. Try not to attract any unwarranted attention, $r.',26124),
(124765,'enUS','I will protect you both. Let\'s go!','I will protect you both. Let\'s go!',26124),
(124766,'enUS','I am glad someone else is here. Invisibility spells are only getting me so far. Do they have some way of detecting it?','',26124),
(124767,'enUS','Just a blood elf and a $r sitting in the corner, discussing tactics. Nothing strange at all about that.','',26124),
(124768,'enUS','You think you can hide from Elisande? Die, traitors!','You think you can hide from Elisande? Die, traitors!',26124),
(124769,'enUS','Behind you!','',26124),
(124770,'enUS','I am right behind you! Go!','',26124),
(124771,'enUS','I cannot leave without my children! They must be hiding...$b$bPlease, find them!','',26124),
(124772,'enUS','','Disgusting demonic filth will not lay a hand on my girls.',26124),
(124773,'enUS','It looks like you have things handled, Scarleth. You and your girls should leave while you have a chance.','It looks like you have things handled, Scarleth. You and your girls should leave while you have a chance.',26124),
(124774,'enUS','','Quit yer lollygagging or I\'ll make ye walk the plank!',26124),
(124775,'enUS','','Get back to work, ogre! What do we pay ye for?',26124),
(124776,'enUS','','Have ye scallywags ever even been to sea?!',26124),
(124777,'enUS','I cannot leave without the vase! It means everything to my master!','',26124),
(124778,'enUS','$ct, could ye come over here before ye leave?','',26124),
(124779,'enUS','Did I hear something?','',26124),
(124780,'enUS','Please, I can\'t concentrate when people keep dying at my doorstep!','',26124),
(124781,'enUS','No, no, no! Not that one!','',26124),
(124782,'enUS','That had to hurt.','',26124),
(124783,'enUS','Will you stop that?! You\'re making a mess!','',26124),
(124784,'enUS','Order matters, apprentice! You may want to study your notes a smidge more.','',26124),
(124785,'enUS','Are you trying to... to brute force the barrier? That is NOT how you were taught!','',26124),
(124786,'enUS','Marvelous effort... but also completely, utterly, fantastically incorrect!','',26124),
(124787,'enUS','Do be careful. Wrong answers are bad for your health. And I do mean that quite literally!','',26124),
(124788,'enUS','Hold a moment... you\'re not a real apprentice! Have at thee, imposter!','',26124),
(124789,'enUS','Apprentici... attack!','',26124),
(124790,'enUS','You\'re never going to defeat the Legion with those moves!','You\'re never going to defeat the Legion with those moves!',26124),
(124791,'enUS','No no no! Your form is all wrong!','No no no! Your form is all wrong!',26124),
(124792,'enUS','You\'re going to have to train harder than that!','You\'re going to have to train harder than that!',26124),
(124793,'enUS','Wh... where am I?','Where... where am I?',26124),
(124794,'enUS','I was... almost gone...','I was... almost gone...',26124),
(124795,'enUS','The shadow... it consumed us...','The shadow... it consumed us...',26124),
(124796,'enUS','The shadow is... gone?','The shadow is... gone?',26124),
(124797,'enUS','Xylem... what have you done?','Xylem... what have you done?',26124),
(124798,'enUS','The Focusing Iris will make me the most powerful mage of all time! Just try to stop me!','',26124),
(124799,'enUS','Say, you\'re pretty strong, aren\'t you? On second thought, don\'t try to stop me!','',26124),
(124800,'enUS','You are too late! Take care of my pursuer, Apprentice Sanath!','',26124),
(124801,'enUS','Enough! Stay your weapon...','',26124),
(124802,'enUS','It seems the grimoire took my mind, just as it has eroded Xylem\'s... and now he has escaped with the Iris!','',26124),
(124803,'enUS','You must follow him through his portal. Go! Before it\'s too late!','',26124),
(124804,'enUS','Ugh. If they aren\'t going to put our show back on soon, why do I have to keep this stupid suit on?! It\'s so itchy...','',26124),
(124809,'enUS','','His portal is unstable, but an echo of it remains.',26124),
(124810,'enUS','','It will take time, but we may be able to use it to reach him.',26124),
(124811,'enUS','','I have one final request, $c. Though it\'s likely Xylem will not hold back, please spare him his life.',26124),
(124812,'enUS','','I believe the good man that was Archmage Xylem still exists underneath the madness.',26124),
(124813,'enUS','','%s motions for you to follow.',26124),
(124814,'enUS','No doubt our forces will be disoriented. I will inform them what happened and see that they make ready to resume our assault.','',26124),
(124815,'enUS','An excellent plan. Good luck, heroes.','',26124),
(124816,'enUS','','The time lock is broken! They are free!',26124),
(124817,'enUS','','From here, we have access to the palace grounds. We can open the gates from the inside!',26124),
(124818,'enUS','','Tendrils of power are emanating from the aberration. I believe Elisande is using this creature to maintain the time lock spell.',26124),
(124819,'enUS','','In order to free our allies at the gate, this monstrosity must be destroyed!',26124),
(124820,'enUS','He ran as far as he could. I will stay with him until his time comes.$b$bThank you... for everything. There is nothing more either of us can do.','',26124),
(124821,'enUS','The Legion drains our dragon allies of their magic. You must rescue them!','',26124),
(124823,'enUS','','The warchief has granted me this post to study the birds of our region, so that we may better use them for carrying messages long distances. With such a central location near the trading hubs of the Horde, I have been able to acquire quite a large menagerie of exotic species. Care to try your luck against them?',26124),
(124824,'enUS','','Justice rains from above!',26124),
(124825,'enUS','','Stay plucky, you will do better next time!',26124),
(124826,'enUS','','You won on a wing and a prayer!',26124),
(124827,'enUS','','Swoop in!',26124),
(124828,'enUS','','It\'s a feathered frenzy!',26124),
(124829,'enUS','','Scratch that one.',26124),
(124830,'enUS','This will hurt, $pc.','This will hurt, $pc.',26124),
(124831,'enUS','','So much has changed for me since you brought that fruit.$b$bI miss my brother dearly but I know why he gave himself to this cause.$b$bThere is something I must ask of you. I need to repay the others for their kindness. I need to avenge my brother\'s death.$b$bPlease take me to the First Arcanist so I can pledge myself to her cause.',26124),
(124832,'enUS','Right this way, Arluelle.','Right this way, Arluelle.',26124),
(124841,'enUS','|TInterface\\Icons\\SPELL_FIRE_TWILIGHTFLAMEBREATH.BLP:20|t%s begins to cast |cFFFF0000|Hspell:227573|h[Guardian\'s Breath]|h|r!','|TInterface\\Icons\\SPELL_FIRE_TWILIGHTFLAMEBREATH.BLP:20|t%s begins to cast |cFFFF0000|Hspell:227573|h[Guardian\'s Breath]|h|r!',26124),
(124843,'enUS','You will enter combat shortly after leaving.\n\nWe recommend you take a moment to review your spell book and setup your action bar first.\n\nAre you ready to leave?','You will enter combat shortly after leaving.\n\nWe recommend you take a moment to review your spell book and setup your action bar first.\n\nAre you ready to leave?',26124),
(124844,'enUS','<Whispers cloud your mind. Your thoughts become erratic.>','',26124),
(124845,'enUS','What has become of the tower?','What has become of the tower?',26124),
(124846,'enUS','I wish to learn the fate of Karazhan.','I wish to learn the fate of Karazhan.',26124),
(124847,'enUS','<Echoes of the past swirl throughout your mind. Visions appear slowly at first, but soon begin to rapidly flash into and out of existence.$B$BHolding your gaze, you peer into the eyes of the Fragment of Medivh. Worlds beyond appear, then quickly fade into darkness.>','',26124),
(124848,'enUS','','<The injured matriarch had kept herself hidden until she smelled her lost hatchling. She is too badly injured to care for it, though.>',26124),
(124849,'enUS','<Bandage the injured matriarch.>','<Bandage the injured matriarch.>',26124),
(124850,'enUS','','You\'re too late! The ritual is almost complete.',26124),
(124851,'enUS','','Soon, Kanrethad will be among us once again!',26124),
(124852,'enUS','My death will not be in vain!','My death will not be in vain!',26124),
(124853,'enUS','This... cannot be!','This... cannot be!',26124),
(124854,'enUS','I have failed you, Kanrethad!','I have failed you, Kanrethad!',26124),
(124855,'enUS','We will not be deterred!','We will not be deterred!',26124),
(124856,'enUS','Our leader will return!','Our leader will return!',26124),
(124857,'enUS','Kanrethad, lend me your power!','Kanrethad, lend me your power!',26124),
(124858,'enUS','The true leader of the Black Harvest will rise again!','The true leader of the Black Harvest will rise again!',26124),
(124859,'enUS','You will burn!','You will burn!',26124),
(124860,'enUS','The fel flames will consume you!','The fel flames will consume you!',26124),
(124861,'enUS','You are no match for his power!','You are no match for his power!',26124),
(124862,'enUS','','I never realized how much we needed the Nightwell. To be rid of its call is... freeing.',26124),
(124863,'enUS','','Oh, it feels so good to be my old self again.$B$B<Valtrois runs the back of her hand gently across her high cheekbone.>$B$BAs you can see, mana is wonderful for the skin!',26124),
(124864,'enUS','It is not too late to join us...','It is not too late to join us...',26124),
(124865,'enUS','','I must admit, I am rather curious to explore the world beyond Suramar.$B$BPrimitive cultures have always fascinated me!',26124),
(124866,'enUS','','We must keep Kanrethad banished, no matter what the cost.',26124),
(124867,'enUS','Who is Kanrethad?','Who is Kanrethad?',26124),
(124868,'enUS','Mount Daumyr once more, Deathlord. Lead us into battle.','',26124),
(124869,'enUS','','He once held your position, Netherlord. Kanrethad was the founder of our council.\n\nHe brought us together, despite our differences, and lead us in pursuit of greater power than we had ever known. \n\nIt was never enough for him though. After Illidan\'s demise at the Black Temple, Kanrethad became obsessed with the powers he witnessed there. He wanted to control demonic energies as Illidan did, and was prepared to do so at any cost.\n\nI swore an oath to Kanrethad, that should he be lost to the powers he tried to control, that I would banish him. It is an oath I must keep, for him, and for everyone else.',26124),
(124870,'enUS','','Oh, it\'s alright, dearie. I don\'t need anyone to run my lines with me. I\'ve got them pretty well memorized by now.',26124),
(124871,'enUS','','Everyone\'s gaga for these oh so \"clever\" retellings. Nobody appreciates the classics anymore!',26124),
(124872,'enUS','Outstanding work, hero! Our alliance ensures the Legion will never conquer Azsuna!','',26124),
(124873,'enUS','','People don\'t even recognize a true ingenue anymore! It\'s all so... tragic.',26124),
(124874,'enUS','','Oh, daaaahling, I am so glad to see you. Did you bring roses?',26124),
(124875,'enUS','','Did you expect me to call you \"my pretties\"? Maybe make some whirlwinds? It\'s called *acting*, my dahling.',26124),
(124876,'enUS','The Legion lacks honor. That shall be their downfall.','',26124),
(124877,'enUS','','In their death, we will find atonement.',26124),
(124878,'enUS','Ha! They stand no chance.','',26124),
(124879,'enUS','We shall ride ahead to scout. Meet you on the battlefield, Deathlord!','',26124),
(124880,'enUS','Don\'t tell the other cast members, but I\'m a little glad we\'re on break - I was worrying about getting typecast as a man in a metal suit for my entire career!','',26124),
(124881,'enUS','You know, I wasn\'t *really* scared all that time on stage. I\'m just a good actor. Really.','',26124),
(124882,'enUS','I\'m actually quite smart, I\'ll have you know.','',26124),
(124883,'enUS','','Ugh! He\'s so insufferable! What a jerk.',26124),
(124884,'enUS','Maybe if her acting had been less transparent, we wouldn\'t be out of a job!','',26124),
(124885,'enUS','','Well then, I think this one\'s outlived his usefulness, wouldn\'t you say?',26124),
(124886,'enUS','','I\'ll head back to Dreadscar Rift and inform the other council members of our plan.',26124),
(124887,'enUS','The outskirts of the grand, ancient city of Suramar, where the Nightfallen fight for survival and the corruption creeps ever so slightly...','',26124),
(124888,'enUS','With you leading us, $ct, the Legion stands no chance.','',26124),
(124889,'enUS','You have conducted your campaign against the Legion with brutal efficiency, Deathlord. I am pleased.','',26124),
(124890,'enUS','Under your command, the Four Horsemen have wreaked havoc upon the demons. But now another path to power awaits.','',26124),
(124891,'enUS','You seek to retrieve Rimefang\'s harness, but you are too late. It has fallen into the hands of invading vrykul, who now use it to bind frost wyrms to their will.','',26124),
(124892,'enUS','These vrykul must pay for defiling my citadel. Slay them! Raise them in the name of the Lich King!','',26124),
(124894,'enUS','','Arluelle places a dusky purple flower before the little planter.',26124),
(124895,'enUS','Examine Beacon','Examine Beacon',26124),
(124896,'enUS','<You notice a slot on the face of the device that may fit the punch card Mux mentioned.>$B$B<If only you could find it...>','',26124),
(124897,'enUS','<The machine clicks rhythmically in an idle state.>','',26124),
(124898,'enUS','Insert the punch card.','Insert the punch card.',26124),
(124899,'enUS','All the \"mastery of the arcane\" at their disposal and they still were not prepared for a pyroblast to the face. I almost feel sorry for them. Almost.','',26124),
(124900,'enUS','<Commonly used as workhorse assistant in engineering shops, this copter has seen better days.>','',26124),
(124901,'enUS','<You\'ve seen tomes like this one before in the hands of the Legion. The Council of Six\'s concerns about their agents being involved in this were clearly well-founded.>','',26124),
(124902,'enUS','','<These must be the remains of Grux\'s late assistant.>$B$B<You notice something just barely sticking out of the ash. It must be the punchcard she was trying to return!>',26124),
(124903,'enUS','Oof! Oh, we\'re fighting dirty huh? Well, interrupt this!','',26124),
(124904,'enUS','','They did not see me coming. A single blade striking from the shadows goes unnoticed, and a single crack in their defense opens.',26124),
(124905,'enUS','Oooh I\'m really angry now!','',26124),
(124906,'enUS','NO NO NO NO NO NO NO ARRGGGH!!!','',26124),
(124907,'enUS','Carefully remove the punch card.','Carefully remove the punch card.',26124),
(124908,'enUS','Greetings, surface-dweller! It is I, the one and only Mekgineer-Lord Thermaplugg!','',26124),
(124909,'enUS','If you\'re hearing this message, you have earned an exclusive invitation to my glorious coronation as king of all mortals on Azeroth!','',26124),
(124910,'enUS','Assuming you survive the mass irradiation of the Broken Shore and the Legion\'s subsequent glorious march on all you know and hold dear, of course.','',26124),
(124911,'enUS','asdf','sdf',26124),
(124912,'enUS','Oh, yes, I did forget to mention. This terminal will self-destruct in juuuust a moment. Farewell!','',26124),
(124913,'enUS','Gravity is fading in 15 seconds!','Gravity is fading in 15 seconds!',26124),
(124914,'enUS','','Please do not tarry long here, $ct $n. This awful place saps my will with every breath.',26124),
(124915,'enUS','Let\'s get out of here.','Let\'s get out of here.',26124),
(124916,'enUS','<Tell Mux what you learned at Thermaplugg\'s camp.>','<Tell Mux what you learned at Thermaplugg\'s camp.>',26124),
(124917,'enUS','That was THE Sicco Thermaplugg I sold that targeting computer to? Oh boy.','',26124),
(124918,'enUS','<A presence emanating from the cube urges your mind to think back on your experiences in the Broken Isles>','',26124),
(124919,'enUS','<Recall the Lightbound Vessel>','<Recall the Lightbound Vessel>',26124),
(124920,'enUS','<Recall the demise of Illidan>','<Recall the demise of Illidan>',26124),
(124921,'enUS','<Recall your mission to Mardum>','<Recall your mission to Mardum>',26124),
(124922,'enUS','<Recall your imprisonment in the Vault of the Wardens>','<Recall your imprisonment in the Vault of the Wardens>',26124),
(124923,'enUS','<Recall the death of King Varian Wyrnn>','<Recall the death of King Varian Wyrnn>',26124),
(124924,'enUS','<Recall the retreat from the Broken Shore>','<Recall the retreat from the Broken Shore>',26124),
(124925,'enUS','<Recall the ascension of Warchief Sylvanas>','<Recall the ascension of Warchief Sylvanas>',26124),
(124926,'enUS','<Recall the story of Gul\'dan>','<Recall the story of Gul\'dan>',26124),
(124927,'enUS','<Recall the story of Illidan\'s Illidari>','<Recall the story of Illidan\'s Illidari>',26124),
(124928,'enUS','<Recall the story of Khadgar\'s temptation>','<Recall the story of Khadgar\'s temptation>',26124),
(124929,'enUS','<Recall your first visit to Suramar>','<Recall your first visit to Suramar>',26124),
(124930,'enUS','<Recall Ysera\'s corruption>','<Recall Ysera\'s corruption>',26124),
(124931,'enUS','<Recall Ysera\'s transcendence>','<Recall Ysera\'s transcendence>',26124),
(124932,'enUS','<Recall the confrontation between Warchief Sylvanas and Genn Greymane>','<Recall the confrontation between Warchief Sylvanas and Genn Greymane>',26124),
(124933,'enUS','Well done, Battlelord $n. You have recovered my stolen warriors!','',26124),
(124934,'enUS','They would have become Valarjar long ago, had Helya not taken them. Now, witness their transformation!','',26124),
(124935,'enUS','As the master commands!','As the master commands!',26124),
(124936,'enUS','For the Legion!','For the Legion!',26124),
(124937,'enUS','I obey.','I obey.',26124),
(124938,'enUS','Cannot... resist!','Cannot... resist!',26124),
(124939,'enUS','As the master wills!','As the master wills!',26124),
(124943,'enUS','Battlelord! With the foul witch Helya finally defeated, she can no longer stop me from reclaiming what is mine!','',26124),
(124947,'enUS','We could also use the kvaldir on our front lines. Their lives are forfeit, so we may as well spend them against the Legion.','',26124),
(124950,'enUS','Good. Make your preparations and get to the Broken Shore as soon as you can.','',26124),
(124951,'enUS','I\'ve left so many fragments of myself throughout this tower...','',26124),
(124952,'enUS','Let us put aside our petty squabbles and go on the offensive against the legion! We must unite all of the major forces on Azeroth!','',26124),
(124953,'enUS','Battlelord $n, we have much to discuss. Come at once! There is no time to waste.','',26124),
(124954,'enUS','Medivh?','',26124),
(124955,'enUS','I will open the way. While you battle that fiend, I will sever the tower\'s connection to Legion worlds. I suggest we be quick about it!','',26124),
(124956,'enUS','','Yea, what ya want?',26124),
(124962,'enUS','Time to move on.','Time to move on.',26124),
(124963,'enUS','Free... at last.','Free... at last.',26124),
(124964,'enUS','Visitors are forbidden!','Visitors are forbidden!',26124),
(124965,'enUS','You will find no reward here, only death!','You will find no reward here, only death!',26124),
(124966,'enUS','Best of luck to ya, buddy. The deserts of Tanaris are an unforgiving mistress!','',26124),
(124973,'enUS','A thin wire attached to the card pulls taught!','A thin wire attached to the card pulls taught!',26124),
(124974,'enUS','-- CUTSCENE -- Camera pans across the broken shore, revealing countless demons. The Tomb of Sargeras looms in the background. Khadgar VO playing... \"The fate of our world will be decided this day.\"','',26124),
(124975,'enUS','Oh, it is bad. The betrayers were from the Horde...','',26124),
(124976,'enUS','The truce will shatter if this news gets out. Who else knows?','',26124),
(124977,'enUS','Archmage $n and I will find a way to repair Dalaran\'s weapons. We must!','',26124),
(124978,'enUS','Ahhh, yes! The power within Azeroth is MINE TO CONTROL!','',26124),
(124979,'enUS','System Status: Booting.','',26124),
(124980,'enUS','Activating Terminal Protection Module 3B.','',26124),
(124981,'enUS','I sell to lots of people, Kels. Why would I know anything about some louse in Gnomeregan?','',26124),
(124982,'enUS','','You WHAT?!',26124),
(124983,'enUS','Hold the line! The Battlelord has arrived!','',26124),
(124984,'enUS','Hold the line! The Highlord has arrived!','',26124),
(124985,'enUS','Hold the line! The Huntmaster has arrived!','',26124),
(124986,'enUS','Hold the line! The Shadowblade has arrived!','',26124),
(124987,'enUS','Hold the line! The High Priest has arrived!','',26124),
(124988,'enUS','Hold the line! The Deathlord has arrived!','',26124),
(124989,'enUS','Hold the line! The Farseer has arrived!','',26124),
(124990,'enUS','Hold the line! The Archmage has arrived!','',26124),
(124991,'enUS','Hold the line! The Netherlord has arrived!','',26124),
(124992,'enUS','Hold the line! The Grandmaster has arrived!','',26124),
(124993,'enUS','Hold the line! The Archdruid has arrived!','',26124),
(124994,'enUS','Hold the line! The Slayer has arrived!','',26124),
(124995,'enUS','Terminal Status: Unprotected. Shutting down.','',26124),
(124996,'enUS','Careful, hero! A doomlord draws near!','',26124),
(124997,'enUS','I will summon a portal. See you on the other side, Archmage $n!','',26124),
(124998,'enUS','Just you and my trusted lieutenants. But I cannot keep it quiet for long.','',26124),
(124999,'enUS','I knew I could count on you. If the Horde is expelled from the Kirin Tor again and our forces are divided, the Legion will consume our world.','',26124),
(125000,'enUS','','We need to get you into Gnomeregan right away!',26124),
(125001,'enUS','','Calibrating hyper-tension fluctuators... adjusting micro-accelerator...',26124),
(125002,'enUS','','I\'m going to send you deep into the city. There\'s only enough juice left in the attenuator to get us through once, so we need to make it count!',26124),
(125003,'enUS','Xylem activates the Focusing Iris!','Xylem activates the Focusing Iris!',26124),
(125004,'enUS','','Success!',26124),
(125005,'enUS','','If the teleporter runs out of juice, we\'ll need a |Hitem:143653:0:0:0:0:0:0:0:90:0|h[Brimming Keystone]|h to jump start it. Step on as soon as you\'re ready!',26124),
(125006,'enUS','Foolish mortal! You dare release our captives? Then you shall take their place!','',26124),
(125007,'enUS','Push them back! They shall not win today!','',26124),
(125008,'enUS','Foolish mortals! This feeble assault will fail just like the last... and this time there will be no escape!','',26124),
(125009,'enUS','None can stop the Nethersworn\'s return!','None can stop the Nethersworn\'s return!',26124),
(125010,'enUS','The shadow... consumes all...','The shadow... consumes all...',26124),
(125011,'enUS','Archmage $n, we have a visitor. Please meet me in my private quarters.','',26124),
(125012,'enUS','','|TInterface\\Icons\\inv_misc_monsterhorn_03.blp:20|t A %s emerges far from Helya!',26124),
(125013,'enUS','Lead the way to the Underbelly, $n. Let us hope we are not too late.','',26124),
(125014,'enUS','Come, we must stop the pitlord before it discovers Shal\'Aran.','',26124),
(125015,'enUS','I don\'t know anything! Leave me be!','I don\'t know anything! Leave me be!',26124),
(125016,'enUS','You will never learn our secrets!','You will never learn our secrets!',26124),
(125017,'enUS','One of them gave me this parchment. Take it, I want nothing to do with their cult!','One of them gave me this parchment. Take it, I want nothing to do with their cult!',26124),
(125018,'enUS','That\'s all I know, I swear!','That\'s all I know, I swear!',26124),
(125019,'enUS','I\'m impressed! Touching that soul shard would\'ve killed most mortals.','I\'m impressed! Touching that soul shard would\'ve killed most mortals.',26124),
(125020,'enUS','This... changes... nothing...','This... changes... nothing...',26124),
(125021,'enUS','|cFFFF0000+$1i gold|r','|cFFFF0000+$1i gold|r',26124),
(125022,'enUS','|cFF0000FF+$1i gold|r','|cFF0000FF+$1i gold|r',26124),
(125023,'enUS','We will not let Gnomeregan fall again.','',26124),
(125024,'enUS','You can count on me.','You can count on me.',26124),
(125025,'enUS','This will begin a timed event. Are you sure?','This will begin a timed event. Are you sure?',26124),
(125026,'enUS','Very well. Center your mind. You will be tested in the tradition of our order.','',26124),
(125027,'enUS','Deathlord $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',26124),
(125028,'enUS','Slayer $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',26124),
(125029,'enUS','Archdruid $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',26124),
(125030,'enUS','Huntmaster $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',26124),
(125031,'enUS','Archmage $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',26124),
(125032,'enUS','Grandmaster $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',26124),
(125033,'enUS','Highlord $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',26124),
(125034,'enUS','High Priest $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',26124),
(125035,'enUS','Shadowblade $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',26124),
(125036,'enUS','Farseer $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',26124),
(125037,'enUS','Netherlord $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',26124),
(125038,'enUS','Battlelord $p! I didn\'t expect Agent Steelspark to come back with the Alliance\'s greatest champion!','',26124),
(125039,'enUS','Deathlord $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',26124),
(125040,'enUS','Slayer $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',26124),
(125041,'enUS','Archdruid $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',26124),
(125042,'enUS','Huntmaster $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',26124),
(125043,'enUS','Archmage $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',26124),
(125044,'enUS','Grandmaster $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',26124),
(125045,'enUS','Highlord $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',26124),
(125046,'enUS','High Priest $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',26124),
(125047,'enUS','Shadowblade $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',26124),
(125048,'enUS','Farseer $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',26124),
(125049,'enUS','Netherlord $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',26124),
(125050,'enUS','Battlelord $p! I didn\'t expect to see a champion of the Horde all the way down here, but we welcome your aid!','',26124),
(125051,'enUS','','Sir, we have reason to believe that Thermaplugg is behind all this. And he has some sort of missile in his arsenal!',26124),
(125052,'enUS','Brilliant deduction, brilliant, but I\'m afraid you\'re too late. We\'re nearly ready to irradiate all your precious little defenders on the Broken Shore!','',26124),
(125053,'enUS','This is where Danuser\'s epic, rallying speech will go. Now listen to Bolvar then go to Mograine upstairs!','',26124),
(125054,'enUS','Send me to Broken Shore!','Send me to Broken Shore!',26124),
(125055,'enUS','We can\'t afford to wait for the rest of our forces to arrive. There simply isn\'t time.','',26124),
(125056,'enUS','$p, you need to sneak past whatever Sicco has lurking down there, shutdown the missile, and take him out once and for all.','',26124),
(125057,'enUS','We\'re all counting on you! Will you do it?','',26124),
(125058,'enUS','Fire given form, fury brought to heel. Arise Qui\'mar, the Firesoul!','',26124),
(125059,'enUS','I\'m not telling you anything!','I\'m not telling you anything!',26124),
(125060,'enUS','Leave me alone!','Leave me alone!',26124),
(125061,'enUS','Why should I help you? It\'s not worth the risk!','Why should I help you? It\'s not worth the risk!',26124),
(125062,'enUS','The shadows consume you!','The shadows consume you!',26124),
(125063,'enUS','All will fall before the Nethersworn!','All will fall before the Nethersworn!',26124),
(125064,'enUS','Your world is doomed!','Your world is doomed!',26124),
(125065,'enUS','Nethersworn... avenge me...','Nethersworn... avenge me...',26124),
(125066,'enUS','All will... fall...','All will... fall...',26124),
(125067,'enUS','You cannot win...','You cannot win...',26124),
(125068,'enUS','The shadow... beckons...','The shadow... beckons...',26124),
(125069,'enUS','Test our visitors with your full might, Qui\'mar!','',26124),
(125070,'enUS','Your prying ends here!','Your prying ends here!',26124),
(125072,'enUS','Well fought! You show promise beyond your years.','',26124),
(125073,'enUS','Our order is fading, but we will lend you what strength we have. Avenge us, and drive the Legion back to the hells from whence they came.','',26124),
(125074,'enUS','You will be silenced!','You will be silenced!',26124),
(125075,'enUS','Defeat is but an opportunity for change. Return when your mind is focused and face our test once more.','',26124),
(125076,'enUS','You are not welcome here, interloper!','You are not welcome here, interloper!',26124),
(125077,'enUS','Your meddling ends here!','Your meddling ends here!',26124),
(125078,'enUS','Demons pour in from portals throughout the Ruined Sanctum. My Nightwatchers will soon be overwhelmed!','',26124),
(125079,'enUS','Place Arcane Bombs within the portals to destroy them. Once the portals are closed, we must clear out this infestation!','',26124),
(125080,'enUS','LOUD NOISES!','',26124),
(125081,'enUS','Turn away... while you can...','Turn away... while you can...',26124),
(125082,'enUS','You cannot stop the shadow...','You cannot stop the shadow...',26124),
(125083,'enUS','My brothers will end you...','My brothers will end you...',26124),
(125084,'enUS','My death... changes nothing...','My death... changes nothing...',26124),
(125085,'enUS','For Nar\'thalas!','For Nar\'thalas!',26124),
(125086,'enUS','We will never fall to the Legion!','We will never fall to the Legion!',26124),
(125087,'enUS','Down with you, filth!','Down with you, filth!',26124),
(125088,'enUS','I\'ve been waiting over ten thousand years for this!','I\'ve been waiting over ten thousand years for this!',26124),
(125089,'enUS','Vis\'ileth, the Manasoul, keeper of power, manifestation of will, arise!','',26124),
(125090,'enUS','Our guests would test their strength in our crucible. Oblige them, Vis\'ileth!','',26124),
(125091,'enUS','I summon you, Al\'anath the Frostsoul, fury of the storm, shard of the glacier!','',26124),
(125092,'enUS','','Archmagi, use your power to convince these two to join together!',26124),
(125093,'enUS','Unleash your fury, Al\'anath, so our visitors might grow stronger!','',26124),
(125094,'enUS','','The Duskwatch is formidable. We will need every capable fighter if we are to complete our objective.',26124),
(125095,'enUS','','These blood elves have some formidable magic. Let us hope it is enough to counter the might of the Nightwell.',26124),
(125096,'enUS','1...','',26124),
(125097,'enUS','2...','',26124),
(125098,'enUS','1, 2, 3, JUMP!','',26124),
(125099,'enUS','','I saw the Sentinels doing target practice over in their camp. They sure can shoot...$b$bWe never really embraced the bow. After all, who needs such primitive instruments when you can craft the fabric of the world to fire missiles for you?',26124),
(125100,'enUS','','Such fools... Did you really think you could get away so easy?',26124),
(125101,'enUS','','Let me show you Nethersworn\'s mercy!',26124),
(125102,'enUS','','My lord... I have failed you...',26124),
(125103,'enUS','Captain Winklespring, lower the barrier for a moment, please.','',26124),
(125104,'enUS','Yes, High Tinker! Lowering the barrier now.','',26124),
(125105,'enUS','Good luck.','',26124),
(125106,'enUS','What trickery is this?!','',26124),
(125108,'enUS','The Moon Guard are sworn to protect the land. Though our numbers are few, we will do what we can.','',26124),
(125109,'enUS','I was speaking with the sin\'dorei magi. They tell me of the vast libraries of their home. I would like to see them someday...','',26124),
(125110,'enUS','Perhaps I will write a book about the history of the night elves. Their story is truly fascinating.','',26124),
(125111,'enUS','We will pay the nightborne back tenfold for what they did to our sanctum.','',26124),
(125112,'enUS','I will scout ahead and see what I can find near this tomb. Find me at the Broken Shore, $n!','',26124),
(125113,'enUS','To arms, Horsemen! Let\'s clear the rest out!','',26124),
(125114,'enUS','Don\'t forget your disguise!','Don\'t forget your disguise!',26124),
(125115,'enUS','Over here, $n!','',26124),
(125116,'enUS','The wards have abated! Let us cut through these vile cultists!','',26124),
(125117,'enUS','I will serve you with honor, Highlord.','I will serve you with honor, Highlord.',26124),
(125118,'enUS','I pledge myself to the Silver Hand.','I pledge myself to the Silver Hand.',26124),
(125119,'enUS','You will not regret this choice.','You will not regret this choice.',26124),
(125120,'enUS','I am at your service.','I am at your service.',26124),
(125121,'enUS','I respect your judgment, Highlord. In time, I will prove myself worthy.','I respect your judgment, Highlord. In time, I will prove myself worthy.',26124),
(125122,'enUS','Your judgment means nothing! The Burning Legion will destroy the Silver Hand!','Your judgment means nothing! The Burning Legion will destroy the Silver Hand!',26124),
(125123,'enUS','Your judgment means nothing!','Your judgment means nothing!',26124),
(125124,'enUS','I refuse to give up without a fight!','I refuse to give up without a fight!',26124),
(125125,'enUS','The Nightwell. An unimaginable font of arcane power. What would have happened to the sin\'dorei if we had such a source?...$b$bNo matter. We have forged our own destiny. Our glory is our own, and we are no longer slaves to our hungers.$b$bThis siege is a momentous occasion, $n. We stand with long-lost kin, our enemies, against some of the most powerful magi in the world. Our actions will determine the future of all elf-kind.','',26124),
(125126,'enUS','Hmph. Your armies are chaotic and unorderly. Fortunately our blood knights and magisters will form the core of this assault, striking true into the heart of the city.','',26124),
(125127,'enUS','It seems the vaunted Kirin Tor are here to see that we do not get into any trouble. I personally feel much safer now that they are here. I wonder, will they actually intervene if the kaldorei camp causes any trouble?','',26124),
(125128,'enUS','SAVAGE!','',26124),
(125129,'enUS','It takes years to master spell-fencing. Victoire is much better suited to instruct the rebellion in basic martial maneuvers.','',26124),
(125130,'enUS','It is hard to believe we are all descended from the same elves. None of us are truly impervious to the passage of time, it seems.','',26124),
(125131,'enUS','The night elves use bows! I do not think a bow has been made in Suramar in centuries. I wonder if they would let me use one for practice...','',26124),
(125132,'enUS','','Don\'t stop the music!',26124),
(125133,'enUS','These blood elves are battle-hardened and disciplined. Their strength will be most useful.','',26124),
(125134,'enUS','','Meow.',26124),
(125135,'enUS','','Thalyssra, I hope this message finds you well. I have just come from an emergency council regarding the Horde and Alliance forces amassing outside Suramar.',26124),
(125136,'enUS','Suh dude.','',26124),
(125137,'enUS','','Elisande has appointed a new First Arcanist: a dreadful woman named Andaris. Together they are working on a massive enchantment to break the siege.',26124),
(125138,'enUS','But if you close your eyes...','',26124),
(125139,'enUS','How am I gonna be an optimist about this?','',26124),
(125140,'enUS','','An attack on the main gate is ill-advised, but there may be another way. Andaris has dispatched her arcanists to the Sanctum of Order.',26124),
(125141,'enUS','Squad up!','',26124),
(125142,'enUS','<The cube\'s thrumming imparts a sense of anticipation>','',26124),
(125143,'enUS','It\'s lit, fam.','',26124),
(125144,'enUS','Activate the cube!','Activate the cube!',26124),
(125145,'enUS','','Meow Meow.',26124),
(125146,'enUS','','Meow Meow Meow.',26124),
(125147,'enUS','Don\'t stop the music!','',26124),
(125148,'enUS','Is this a joke?','',26124),
(125149,'enUS','','It seems there is some kind of breach that runs beneath the Nightwell and into the palace itself! They are trying to seal it, but I am sure you can find a way to-',26124),
(125150,'enUS','','Someone\'s coming... Who are you?! W-wait! Unhand me! How dare you! Do you know who I am?!',26124),
(125151,'enUS','','Alright, go ahead and activate it... I\'m going to back up to an... observational distance',26124),
(125152,'enUS','','Follow me upstairs where we can activate this cube away from curious shoppers...',26124),
(125153,'enUS','%s begins to activate!','',26124),
(125154,'enUS','|cFFFF0404Hymdall|r! leaps back into battle!','|cFFFF0404Hymdall|r! leaps back into battle!',26124),
(125155,'enUS','|cFFFF0000Hyrja|r leaps back into battle!','|cFFFF0000Hyrja|r leaps back into battle!',26124),
(125156,'enUS','THREE!','',26124),
(125157,'enUS','TWO!','',26124),
(125158,'enUS','ONE!','',26124),
(125159,'enUS','Do you know where I can find Levia Laurence?','Do you know where I can find Levia Laurence?',26124),
(125160,'enUS','Yes, yes, yes, Levia. Tall girl?  Light hair? She was in here buying scrolls and ink - said she needed to make runes for a ritual or something.\n\nShe mentioned something about a specific kind of staff she needed, but we don\'t deal in those items here. I sent her off to the Militant Mystic.\n\nMaybe you should check there?','',26124),
(125161,'enUS','Stop this madness, brother! You can still be redeemed!','',26124),
(125162,'enUS','You are too late, foolish brother. The Twisting Nether awaits me, and with it, unlimited power! All of Azeroth will kneel upon my return!','',26124),
(125163,'enUS','Please, brother! Don\'t give in to the darkness!','',26124),
(125164,'enUS','Your tiny mind cannot comprehend the forces that will soon be at my command! Perhaps I should give you a taste...','',26124),
(125165,'enUS','Do you know where I can find Levia Laurence?','Do you know where I can find Levia Laurence?',26124),
(125166,'enUS','The order\'s vaults contain a vast store of magical devices. There must be something here Dalaran can use...','',26124),
(125167,'enUS','I hope you enjoy my creation, brother. It saddens me that it ends this way...','',26124),
(125168,'enUS','','Levia... yeah, I know her. She stays here every now and then. Last time was a couple days ago.\n\nShadow magic is a dangerous thing - that\'s why the Kirin Tor aren\'t fond of it in the city - but the things she dabbles in are a far cry worse than your average fare. I wish she\'d at least conduct her business outside of the city.\n\nYou\'re welcome to check upstairs and see if she left anything behind.',26124),
(125169,'enUS','','The Maiden would not approve!',26124),
(125170,'enUS','','Oh dear... you ARE tempting!',26124),
(125171,'enUS','','I no longer fraternize with your sort!',26124),
(125172,'enUS','','You want to play? LET\'S PLAY!',26124),
(125173,'enUS','','I tried to be good... really!',26124),
(125174,'enUS','','I... let... the Maiden... down...',26124),
(125175,'enUS','','Being good... doesn\'t pay...',26124),
(125176,'enUS','','I\'m so glad the Maiden showed us the right path!',26124),
(125177,'enUS','','I don\'t know... I sort of miss the old days.',26124),
(125178,'enUS','','I\'ve been studying advanced magic. I might even apply to the Kirin Tor!',26124),
(125179,'enUS','','Purge dark thoughts from your mind. Remember her teachings!',26124),
(125180,'enUS','','Virtue is overrated!',26124),
(125181,'enUS','No! The rift is closing!','',26124),
(125182,'enUS','','Shame... SHAME...',26124),
(125183,'enUS','','No redemption... for me...',26124),
(125184,'enUS','','You asked for it!',26124),
(125185,'enUS','','I bet you like me better this way!',26124),
(125186,'enUS','','Always... the same...',26124),
(125187,'enUS','','Guess I... deserved this.',26124),
(125188,'enUS','','Who am I kidding? THIS is the real me!',26124),
(125189,'enUS','','It\'s been soooo long since I\'ve had fun like this!',26124),
(125190,'enUS','You\'ve grown delusional in your old age, Gelbin.','',26124),
(125191,'enUS','My new allies have given me gifts beyond comprehension - you\'ve merely sent your lone savior to their death.','',26124),
(125193,'enUS','A little of this... A little of that...','',26124),
(125194,'enUS','Have a dose of this!','',26124),
(125195,'enUS','One part death... Two parts destruction...','',26124),
(125196,'enUS','Let\'s mix this up!','',26124),
(125198,'enUS','','Slayer $n! We just received an urgent transmission from one of Belath\'s scouts on Mardum!',26124),
(125199,'enUS','','Lady S\'theno went down to lend a hand a few hours ago, but this sounds serious. Should we follow after her?',26124),
(125200,'enUS','We are under attack and taking heavy losses. Legion portals are opening up everywhere! We need reinforcements!','',26124),
(125201,'enUS','MEATBALL HUNGRY!','',26124),
(125202,'enUS','You there! What are you doing?','You there! What are you doing?',26124),
(125203,'enUS','Hello there! Did you notice that I have finally been granted the rank of mage? Posthumously, of course... but it is a great honor nonetheless.$b$bWith the promotion came a new charge: sprucing up the tower. It could stand to be a bit more inviting in case Archmage Khadgar has further need of it.','',26124),
(125204,'enUS','I wish to trade.','I wish to trade.',26124),
(125205,'enUS','Hey! You find somethin\' good?! Somethin\' nice?','',26124),
(125206,'enUS','You find anythin\'? Any magic? Hey! Tell me!','',26124),
(125207,'enUS','Ooh! That shiny! You give to me?','',26124),
(125208,'enUS','A slow and weak blow. Pathetic.','A slow and weak blow. Pathetic.',26124),
(125209,'enUS','','Is that the best you can do? I suppose the Eredar are not known for their swordsmanship, are they?',26124),
(125217,'enUS','','Beware, $c. The archmage may not greet you with his usual jovial demeanor.',26124),
(125218,'enUS','And we have liftooooooff!','',26124),
(125219,'enUS','Brace yourselves! The whole place is falling apart!','',26124),
(125220,'enUS','','Slayer $n! We received an urgent message from one of our scouts on Mardum!',26124),
(125221,'enUS','','The grimoire\'s hold on him has grown stronger of late. He has become paranoid and obsessive.',26124),
(125222,'enUS','','I have learned so much from Silgryn but there is still much I have yet to master.$b$bI hope it will be enough when the time comes to face Elisande.',26124),
(125226,'enUS','Foolish mortal! You have met your doom!','',26124),
(125227,'enUS','Did you hear that rumble coming from the tower ruins? A bad omen, to be sure. Tread carefully!','',26124),
(125228,'enUS','','Illidari! We are needed on Mardum. Move out!',26124),
(125230,'enUS','You\'ve done it, Archmage $n. Congratulations are in order, but I would like to do so in front of the others in the order hall.$b$bWhen you\'re ready, I\'ll teleport us back.','',26124),
(125231,'enUS','I\'m ready to go back, Kalec.','I\'m ready to go back, Kalec.',26124),
(125232,'enUS','The strange chill of a dark presence winds through the air...','The strange chill of a dark presence winds through the air...',26124),
(125233,'enUS','The air grows slightly warmer.','The air grows slightly warmer.',26124),
(125234,'enUS','','No need to jump - our felbats are happy for a chance to stretch their wings!',26124),
(125235,'enUS','I wish you luck, $p. A word of warning... If you leave this place, you will lose all progress and be forced to begin the task anew.','',26124),
(125236,'enUS','Let me leave you to it. I will monitor your progress from afar.','',26124),
(125237,'enUS','Take me to down to the surface.','Take me to Mardum.',26124),
(125238,'enUS','Vanthir struggles to his feet.','',26124),
(125240,'enUS','I owe you my life, $n. And to Thalyssra, I owe my future.','',26124),
(125241,'enUS','The Arcan\'dor is the Nightborne\'s future. Tasting the fruit has enabled me to serve my people as I have always wanted... free from Arcwine.','',26124),
(125242,'enUS','So many familiar faces from the Waning Crescent! My heart is lighter knowing so many survived.$b$bFor the rest, I weep.','',26124),
(125243,'enUS','Elisande tried to make an example of me. Instead, she gave our movement all the support it could ever want.$b$bShe cannot be forgiven for her deeds at the Waning Crescent.','',26124),
(125244,'enUS','','<Ly\'leth\'s image peers at you expectantly. Would you like to hear the message it bears?>',26124),
(125245,'enUS','','No movement just yet. I suspect Elisande is quite comfortable with the current climate in the city. It is quiet. Perhaps our people are too afraid to cry out after the atrocity at the Waning Crescent...$b$bI have not been able to locate Vanthir. His name is conspicuously absent from our discussions.$b$bAs an amusing piece of trivia, Elisande is the least punctual person I have ever had the misfortune to serve.$b$bI will report in again as soon as I can. Take care, Thalyssra.',26124),
(125246,'enUS','<Listen to first message.>','<Listen to first message.>',26124),
(125247,'enUS','<Listen to second message.>','<Listen to second message.>',26124),
(125248,'enUS','<Listen to third message.>','<Listen to third message.>',26124),
(125249,'enUS','<Listen to fourth message.>','<Listen to fourth message.>',26124),
(125250,'enUS','<Listen to fifth message.>','<Listen to fifth message.>',26124),
(125251,'enUS','Outstanding work! Thanks to your help, the Burning Legion will never claim these lands!','',26124),
(125252,'enUS','The Green Dunkball was picked up by $n!','',26124),
(125253,'enUS','The Green Dunkball was picked up by $n!','',26124),
(125254,'enUS','The Orange Dunkball was picked up by $n!','',26124),
(125255,'enUS','The Orange Dunkball was picked up by $n!','',26124),
(125256,'enUS','The Purple Dunkball was picked up by $n!','',26124),
(125257,'enUS','The Purple Dunkball was picked up by $n!','',26124),
(125258,'enUS','Score! The Orange Dunkball was slammed home by $n.','',26124),
(125259,'enUS','<Dismiss the message.>','<Dismiss the message.>',26124),
(125260,'enUS','Score! The Orange Dunkball was slammed home by $n.','',26124),
(125261,'enUS','Score! The Purple Dunkball was slammed home by $n.','',26124),
(125262,'enUS','Score! The Purple Dunkball was slammed home by $n.','',26124),
(125263,'enUS','Score! The Green Dunkball was slammed home by $n.','',26124),
(125264,'enUS','Score! The Green Dunkball was slammed home by $n.','',26124),
(125265,'enUS','The Orange Dunkball was dropped by $n!','',26124),
(125266,'enUS','The Orange Dunkball was dropped by $n!','',26124),
(125267,'enUS','The Purple Dunkball was dropped by $n!','',26124),
(125268,'enUS','The Purple Dunkball was dropped by $n!','',26124),
(125269,'enUS','The Green Dunkball was dropped by $n!','',26124),
(125270,'enUS','The Green Dunkball was dropped by $n!','',26124),
(125271,'enUS','','As you requested, I have inquired about the Felsoul Hold situation. It appears that your efforts have slowed the trafficking significantly. I regret to say that it will likely not stop without further intervention.$b$bThere is some talk of a sweep for deserters after the events of Astravar Harbor. Advise your people to keep an eye out. More defectors may be coming your way.$b$bIn lighter news, there is a new fashion trend sweeping the palace. There is an obsession with placing ornamental orange birds on their heads. Baffling, truly.$b$bAs ever, I continue to seek our mutual friend. As soon as I know more I will reach out to you directly.$b$bStay strong, First Arcanist.',26124),
(125272,'enUS','','I am so glad Vanthir is safe. Give him my best! I hope to see him in person soon.$b$bThings are... growing tense. The Dusk Lily display really rattled the nobility. They are not in agreement of how to handle the situation but violence is most assuredly an option. I worry for those still trapped in the city.$b$bI have caught wind of some movement in the Promenade- they may be reinforcing the area. Something worth keeping an eye on.$b$bI will report in when I have more information.',26124),
(125273,'enUS','','Your new allies have not gone unnoticed.$b$bI do not know where you found such a band but I had to hide my pleasure at their progress infiltrating the Promenade.$b$bThe mood here is increasingly disturbed. The nobles no longer have any illusion that they can avoid a fight. Elisande will not allow them to stand idly by while Suramar is overrun by Outlanders.$b$bI would not assume victory just yet, my friend.$b$bBe cautious, and be strong. I will see you soon.',26124),
(125274,'enUS','','I do not have long. This report will be regrettably brief.$b$bElisande is furious. She is planning something, but I have no details yet.$b$bMy eyes and ears are open as ever. As soon as I know what she is up to I will contact you.$b$bBe safe.',26124),
(125275,'enUS','%s is revealed!','Jump over the effect to avoid damage from |cFFFF0404|Hspell:211901|h[Fusion Press]|h|r!',26124),
(125276,'enUS','The Orange Ball has returned to its base!','',26124),
(125278,'enUS','The Purple Ball has returned to its base!','',26124),
(125280,'enUS','The Green Ball has returned to its base!','',26124),
(125282,'enUS','Kite the Fel Reaver over the Landmines to destroy it!','',26124),
(125284,'enUS','','Vandel! We have answered your call for aid. What has happened?',26124),
(125285,'enUS','Kor\'vas! Slayer! All was quiet until recently. Suddenly Legion portals appeared and we were fighting for our lives! Most of our scouts are missing.','',26124),
(125286,'enUS','','We will find them. And what of Lady S\'theno?',26124),
(125288,'enUS','I would like to learn the Arcane Momentum technique and be able to Blink in the direction I am moving.','I would like to learn the Arcane Momentum technique and be able to Blink in the direction I am moving.',26124),
(125289,'enUS','I would like to unlearn Arcane Momentum and Blink the direction I am facing.','I would like to unlearn Arcane Momentum and Blink the direction I am facing.',26124),
(125290,'enUS','Arcane Momentum is a technique that allows a mage to use their physical momentum to dictate the direction of their Blink spell rather than the basic technique of Blinking in the direction you are facing.','Arcane Momentum is a technique that allows a mage to use their physical momentum to dictate the direction of their Blink spell rather than the basic technique of Blinking in the direction you are facing.',26124),
(125291,'enUS','Are you sure you would like to learn this new technique?','Are you sure you would like to learn this new technique?',26124),
(125292,'enUS','Are you sure you would like me to remove the knowledge of Arcane Momentum from your memory?','Are you sure you would like me to remove the knowledge of Arcane Momentum from your memory?',26124),
(125293,'enUS','I want to talk about the Arcane Momentum technique.','I want to talk about the Arcane Momentum technique.',26124),
(125294,'enUS','Thank you, $c.','Thank you, $c.',26124),
(125295,'enUS','Am I finally free?','Am I finally free?',26124),
(125296,'enUS','I am in your debt.','I am in your debt.',26124),
(125297,'enUS','Your kindness will not be forgotten.','Your kindness will not be forgotten.',26124),
(125298,'enUS','','You called?',26124),
(125299,'enUS','You found me just in time!','You found me just in time!',26124),
(125300,'enUS','','Watch out!',26124),
(125301,'enUS','','Oh my!',26124),
(125302,'enUS','','How tragic!',26124),
(125303,'enUS','','Oh no, bad times...',26124),
(125304,'enUS','','Oh no, I can\'t look...',26124),
(125307,'enUS','Yay, magic fruit!','Yay, magic fruit!',26124),
(125308,'enUS','For me?! Thank you!','For me?! Thank you!',26124),
(125309,'enUS','Yuck! I want candy!','Yuck! I want candy!',26124),
(125310,'enUS','Can you peel it? I don\'t like the skin...','Can you peel it? I don\'t like the skin...',26124),
(125311,'enUS','Will this make me strong like Thalyssra? She\'s so cool!','Will this make me strong like Thalyssra? She\'s so cool!',26124),
(125312,'enUS','Miss Valtrois said if I eat this, she will teach me about ley lines. She promised!','Miss Valtrois said if I eat this, she will teach me about ley lines. She promised!',26124),
(125313,'enUS','What\'s a arcane-door? Is that like a portal?','What\'s a arcane-door? Is that like a portal?',26124),
(125318,'enUS','We will not forget what you and Thalyssra have done for us.','We will not forget what you and Thalyssra have done for us.',26124),
(125319,'enUS','Can this truly end the hunger?','Can this truly end the hunger?',26124),
(125320,'enUS','At last. I am ready to be free.','At last. I am ready to be free.',26124),
(125321,'enUS','You saved me once before, in the city. Now this... It is more than I deserve.','You saved me once before, in the city. Now this... It is more than I deserve.',26124),
(125322,'enUS','Erana-dora isil. A thousand thanks upon you.','Erana-dora isil. A thousand thanks upon you.',26124),
(125323,'enUS','This fruit actually cured Thalyssra? Amazing.','This fruit actually cured Thalyssra? Amazing.',26124),
(125324,'enUS','Now, as before, we do what we must to carry on.','Now, as before, we do what we must to carry on.',26124),
(125325,'enUS','Damn all these vermin! Can you believe they\'re STILL here!? That last group that came through was no help at all. I don\'t suppose you could help me with this situation?','',26124),
(125326,'enUS','The damn spiders, the endlessly screeching bats, and those blasted demon beasts have all taken residence in the Servant\'s Quarters. At least the big ones seem to have cleared out.','',26124),
(125327,'enUS','','Archmage Alturus and I are able to hold off the reinforcements from reaching the gates, but do what you can to push them back, $n.$B$BIf their forces continue to grow we may not be able to hold our ground.',26124),
(125328,'enUS','You have my thanks!','You have my thanks!',26124),
(125329,'enUS','That was a close one. Thanks!','That was a close one. Thanks!',26124),
(125330,'enUS','I didn\'t think I would make it. Thanks, $n!','I didn\'t think I would make it. Thanks, $n!',26124),
(125331,'enUS','They just keep coming...','They just keep coming...',26124),
(125332,'enUS','What is this? Oh, the horseshoes I ordered finally arrived! Wait... What is this? They are utterly ruined. It\'s as if they were left out in the rain for decades. Tell that \'mage\' to find a new supplier.','',26124),
(125333,'enUS','Pit Hound sniffs at the air.','',26124),
(125334,'enUS','Pit Hound senses something nearby.','',26124),
(125335,'enUS','Pit Hound emits an eerie growl.','',26124),
(125336,'enUS','Koren, I have a delivery of horseshoes for you.','Koren, I have a delivery of horseshoes for you.',26124),
(125337,'enUS','','Slayer $n! We are being boarded by demon swarms! Your presence is requested aboard the Fel Hammer!',26124),
(125338,'enUS','Thank you for coming so quickly, Slayer $n!','',26124),
(125339,'enUS','Oh, hello, I was just doing a routine walk through and I see that for non-ghosts there seems to be a sizing spell in play. Maybe considering your vertical limitations, we try and just clear out a bit of the wyrm infestation.','',26124),
(125340,'enUS','','Burn, baby, burn!',26124),
(125341,'enUS','','Hot!',26124),
(125342,'enUS','','Spooky!',26124),
(125343,'enUS','','Burn...',26124),
(125344,'enUS','','I love portals.',26124),
(125345,'enUS','Let me know when you are ready to investigate the time lock spell.','',26124),
(125346,'enUS','Let\'s go.','Let\'s go.',26124),
(125347,'enUS','Few things bring together an army better than a common enemy.$b$bA week ago these elves were at each other\'s throats. Now, thanks to your efforts, we are ready for the final push into the Nighthold.$b$bWhile I would like to be at the front, Tyrande insisted you and I stay back here with the nightfallen and cover the rear. Come my friend, let us see how these elves resolve their conflict.','',26124),
(125348,'enUS','I\'m ready for the siege.','I\'m ready for the siege.',26124),
(125349,'enUS','I cannot begin to thank you enough for your part in rescuing me.$b$bWithout such an intervention I would be a mindless husk, forever tormented by the Nightwell. Now... I am free of it.$b$bI have always believed that Thalyssra would lead us to salvation. Now I know for certain that the Nightborne can and will be saved.','',26124),
(125356,'enUS','Ahoy up there $n, from the sounds of it, you were successful in defeating Nightbane. I think it is time we laid this dragon to rest for good. Try and round up all the bones and take them back to where they came from.','',26124),
(125357,'enUS','That\'s MY treasure!','That\'s MY treasure!',26124),
(125358,'enUS','You hear a door unlock in the distance.','',26124),
(125359,'enUS','The portal shimmers with images of the spire.','',26124),
(125360,'enUS','Teleport to the Nightspire.','Teleport to the Nightspire.',26124),
(125361,'enUS','Teleport to Elisande\'s Secret Quarters.','Teleport to Elisande\'s Secret Quarters.',26124),
(125362,'enUS','Teleport to the Font of Night.','Teleport to the Font of Night.',26124),
(125363,'enUS','Teleport to the Palace Entrance.','Teleport to the Palace Entrance.',26124),
(125369,'enUS','Thieves! This ship is mine!','',26124),
(125375,'enUS','','|TInterface\\Icons\\SPELL_SHADOW_SHADETRUESIGHT.BLP:20|t %s begins to cast |cFFFF0000|Hspell:228565\n|h[Corrupted Breath]|h|r!',26124),
(125376,'enUS','Another test! Keep your wits about you!','',26124),
(125377,'enUS','Champions must show cleverness as well as might!','',26124),
(125378,'enUS','','Slayer $n, we need help from those keen glaives of yours to hold off these fiends!',26124),
(125379,'enUS','We will not stand idly by while the Legion defiles our lands. Defend Farondale!','',26124),
(125380,'enUS','My ancient nemesis has been vanquished! The curse that bound me to the Halls of Valor is broken at last.','',26124),
(125381,'enUS','Revel in the spoils of victory, worthy champions! The day will come when I have need of your courage and skill once more.','',26124),
(125382,'enUS','Hmm... Many ages have passed since my eyes looked upon the halls of Ulduar. Perhaps I should visit my watcher kin... we have much to speak of. Farewell!','',26124),
(125383,'enUS','Roland Abernathy lets out a hacking cough.','',26124),
(125384,'enUS','The cleansing is complete... for now. Remain vigilant, for the Legion is relentless.','',26124),
(125385,'enUS','Say the thing!','Say the thing!',26124),
(125386,'enUS','Hmph. I don\'t know...','',26124),
(125387,'enUS','I don\'t do that anymore!','',26124),
(125388,'enUS','Aww, c\'mon!','Aww, c\'mon!',26124),
(125389,'enUS','Please?! I\'m a fan!','Please?! I\'m a fan!',26124),
(125390,'enUS','Sigh. Here goes... ahem...','',26124),
(125391,'enUS','Run away little girl, run away!','',26124),
(125392,'enUS','... you\'re welcome.','',26124),
(125393,'enUS','It is time. Breach the Sanctum and gain access to the Nighthold!','',26124),
(125394,'enUS','Slayer $n, help me!','',26124),
(125395,'enUS','','You will pay for imprisoning me, foul creatures!',26124),
(125396,'enUS','I am ready to enter the Sanctum.','I am ready to enter the Sanctum.',26124),
(125397,'enUS','','Hideous demon!',26124),
(125398,'enUS','He hits...rather hard, too!','',26124),
(125399,'enUS','','Finderss keeperss!',26124),
(125400,'enUS','Mrglglg! Mrg grgl grrrrglmrg!','',26124),
(125401,'enUS','Mrg! Mrgrglgrgl gr mrglglrlr!','',26124),
(125402,'enUS','I am ready, Oculeth.','I am ready, Oculeth.',26124),
(125403,'enUS','','Coming, Mother!',26124),
(125404,'enUS','','Matron Mother Malevolence glares malevolently at Kor\'vas.',26124),
(125405,'enUS','','Don\'t think you\'re facing this peak without me, Deathlord. Onward!',26124),
(125406,'enUS','','The Fel Hammer is OUR ship. Time to remind the demons of this fact!',26124),
(125407,'enUS','','More demonss... While I had hoped for a bit of excitement on board, thiss was not what I had in mind.',26124),
(125408,'enUS','','Slayer $n, glad you made it back! They mean business this time!',26124),
(125409,'enUS','','Mardum has been lost. Good riddance, if you ask me. Though it would be inconvenient to lose the Fel Hammer as well.',26124),
(125410,'enUS','That was difficult! I am grateful for the help. I fear Jace may be in trouble in the control room!','',26124),
(125411,'enUS','','It had to be this way. We no longer need the Nightwell, nor its power.$b$bWe must forge our own destiny.',26124),
(125412,'enUS','','The Nightwell is no more.$b$bThese nightborne will learn to survive without its corrupting power, or they will perish. Let us hope it is the former.',26124),
(125413,'enUS','','I will always wonder what might have been, had we chosen to save the Nightwell. What are we without its power?$b$bIn the end I trust in Thalyssra\'s judgment. Under her leadership I know the Nightborne will forge a new path.',26124),
(125414,'enUS','This is the right decision.$b$bThe power here is too great, the responsibility too heavy. Even Elisande was destroyed by it. We must let it go.','',26124),
(125415,'enUS','The Nightwell...$b$bWith this, the nightborne begin a new chapter in Azeroth\'s history. Now that they are free of the shield and the Nightwell they have room to truly flourish. I look forward to seeing their progress.','',26124),
(125416,'enUS','','I am impressed. Letting go of the Nightwell was no easy task.$b$bIts power and allure will fade with time. As it was with us, they will find their own way in this world.',26124),
(125417,'enUS','','We cannot hold out much longer. We must destroy those shipss!',26124),
(125418,'enUS','','Welcome to our service, Daumyr! Hop on, Deathlord. It\'s time to return to Acherus.',26124),
(125419,'enUS','','The weapons are badly damaged. If we activate them now, they could destroy us, too... Perhaps if we divert energy from the main engine core...',26124),
(125420,'enUS','','You have done well, little gnome. Soon none will remain to stand against the might of the Legion!',26124),
(125421,'enUS','','You are too late, mortal. Azeroth\'s fate is sealed.',26124),
(125422,'enUS','','It is hopeless. We are everywhere. We are Legion!',26124),
(125423,'enUS','','You are more powerful than I thought. No matter.',26124),
(125424,'enUS','','Your world, all worlds, will burn! It is your destiny!',26124),
(125425,'enUS','','How it this possible? You are NOTHING!',26124),
(125426,'enUS','','He... comes...',26124),
(125427,'enUS','I should congratulate you, hero, but I\'m afraid your efforts are in vain. I will build a new missile, and this time YOU won\'t be around to stop me!','',26124),
(125428,'enUS','Behold the power my allies provide. I, Mekgineer-Lord Thermaplugg, will be your end!','',26124),
(125429,'enUS','You\'re going to have to try much harder than that, noble hero. I am the greatest inventor in all of Azeroth!','',26124),
(125430,'enUS','And to think that you\'re going to die down here, all alone. Just like I was left for dead all those years ago.','',26124),
(125431,'enUS','C\'mon, c\'mon, where\'s that blasted explosion button? I KNOW I INSTALLED AN EXPLOSION BUTTON!','',26124),
(125432,'enUS','This is fine. Everything is a-ok, peachy-keen!. Just need to murder you, knock out these unsightly dents you\'ve caused, and we can finally obliterate all your precious friends.','',26124),
(125433,'enUS','Inconceivable! My calculations were... perfect...','',26124),
(125434,'enUS','Trogg no stupid!','',26124),
(125435,'enUS','Show self!','',26124),
(125436,'enUS','Eh? What that?','',26124),
(125437,'enUS','Me see thing!','',26124),
(125438,'enUS','What there?','',26124),
(125439,'enUS','Come out so I kill!','',26124),
(125440,'enUS','Reveal yourself in Thermaplugg\'s name!','Reveal yourself in Thermaplugg\'s name!',26124),
(125441,'enUS','Someone is close.','Someone is close.',26124),
(125442,'enUS','Did you see that?','Did you see that?',26124),
(125443,'enUS','We aren\'t alone.','We aren\'t alone.',26124),
(125444,'enUS','Who dares step in Thermaplugg\'s domain?','Who dares step in Thermaplugg\'s domain?',26124),
(125445,'enUS','Your head will decorate these halls!','Your head will decorate these halls!',26124),
(125446,'enUS','You won\'t make it out of here alive.','You won\'t make it out of here alive.',26124),
(125447,'enUS','I heard something over here.','I heard something over here.',26124),
(125448,'enUS','Lupine Geartooth looks in your direction!','',26124),
(125449,'enUS','Intruder detected in this sector.','',26124),
(125450,'enUS','','We have this unwanted intrusion under control. Do be a dear and check on Seer Akalu, won\'t you, Slayer $n?',26124),
(125451,'enUS','Unauthorized entity nearby.','',26124),
(125452,'enUS','Enemy detected. Priming combat relays.','',26124),
(125453,'enUS','Threat sensors triggered.','',26124),
(125454,'enUS','Low levels of obedience nearby. Identifying source.','',26124),
(125455,'enUS','Aggressor within proximity vectors.','',26124),
(125456,'enUS','Weapons systems primed.','',26124),
(125457,'enUS','I have them in my sights.','',26124),
(125458,'enUS','There you are.','',26124),
(125459,'enUS','Preparing to engage.','',26124),
(125460,'enUS','Halt in the Mekgineer-Lord\'s name!','',26124),
(125461,'enUS','They\'re here.','',26124),
(125462,'enUS','Tick-tock, tick-tock. We\'re nearly ready to launch!','',26124),
(125463,'enUS','Sit back, take a load off! It\'s mathematically impossible for you to do anything but die miserably at this point anyways.','',26124),
(125464,'enUS','The Talisman of the Shal\'dorei swells with power, dispelling the palace wards.','The Talisman of the Shal\'dorei swells with power, dispelling the palace wards.',26124),
(125465,'enUS','Warpweaver Tuviss conducts his business in the Simply Enchanting shop.','Warpweaver Tuviss conducts his business in the Simply Enchanting shop.',26124),
(125466,'enUS','NOOOOOO! MY MISSILE!','',26124),
(125467,'enUS','Excellent! Sensors indicate Thermaplugg has retreated to the Tinker\'s Court below. You have to take him out once and for all!','',26124),
(125468,'enUS','Send everything we have. All of it! Protect me you fools!','',26124),
(125469,'enUS','Oh no you don\'t! I came prepared!','',26124),
(125470,'enUS','You did it! That\'s the last time Sicco Thermaplugg will rear his ugly head in our city.','',26124),
(125471,'enUS','We\'ve already regained control of most of the critical systems - including the teleportation network to get you back safely to Dalaran!','',26124),
(125472,'enUS','There\'s still a great deal of work to do to clear these rebels out, but thanks to your efforts it should take no time at all!','',26124),
(125473,'enUS','Thank you again, and do send the Kirin Tor my regards when you see them!','',26124),
(125474,'enUS','Nor\'Danil Wellspring has been taken by the Legion! Eradicate the infestation before all of Azsuna is overrun!','',26124),
(125475,'enUS','','Let\'s see where we ended up, shall we?',26124),
(125476,'enUS','','Hmm. Out of the frying pan and into the fire. Well, at least we are better positioned to fight the Legion here.',26124),
(125477,'enUS','','I have some cleanup to do here. See you soon, $n.',26124),
(125478,'enUS','Our war against the Legion has exacted a heavy price. Many brave heroes lost their lives in this campaign. Those sacrifices must not be in vain.\n\nLet us seize our chance for victory!','',26124),
(125479,'enUS','Send me to the battlefield, I am ready to lend my aid.','Send me to the battlefield, I am ready to lend my aid.',26124),
(125480,'enUS','','Perhaps. I can see a number of benefits to our new position.',26124),
(125481,'enUS','The people of Azsuna are in your debt, hero!','',26124),
(125482,'enUS','Make your way there at once and meet with my servant, the mighty Vethir. Together, you will show the Legion how we greet their kind in Stormheim!','',26124),
(125485,'enUS','What are the requirements to enter?','What are the requirements to enter?',26124),
(125486,'enUS','Only those who have trained extensively can enter.\n\nWhen you have trained 15 pets to their maximum level, you will be ready.','Only those who have trained extensively can enter.\n\nWhen you have trained 15 pets to their maximum level, you will be ready.',26124),
(125487,'enUS','','The Wailing Caverns are overrun with deviate pests. \n\nWe must exterminate them when their numbers grow too great.',26124),
(125488,'enUS','Take me into the Wailing Caverns.','Take me into the Wailing Caverns.',26124),
(125489,'enUS','I would like to leave the Wailing Caverns.','I would like to leave the Wailing Caverns.',26124),
(125490,'enUS','Progress will be reset if you leave this instance. Are you sure you want to leave?','Progress will be reset if you leave this instance. Are you sure you want to leave?',26124),
(125491,'enUS','I didn\'t think it possible! The energies required...','',26124),
(125492,'enUS','','Elisande... what have you done?',26124),
(125493,'enUS','','The power of the Nightwell unleashed...$b$bThere must be another way. We will find it!',26124),
(125494,'enUS','Trapped in time.$b$bSee, THIS is why I stick with telemancy! Chronomancy is dangerous stuff.$b$b<Oculeth pauses for a moment.>$b$bThey could be stuck. Forever. We must stop Elisande!','',26124),
(125495,'enUS','Reveal the Flame Orbs of Felo\'melorn','Reveal the Flame Orbs of Felo\'melorn',26124),
(125496,'enUS','Hide the Flame Orbs of Felo\'melorn','Hide the Flame Orbs of Felo\'melorn',26124),
(125498,'enUS','Rezzle glad to help friend. See, Rezzle not bad demon!','',26124),
(125499,'enUS','...so then I was like, \"Cool story, bro.\" HA!','',26124),
(125500,'enUS','Death from above? I\'ve done that 1,979 times! Do you want to be number 1,800? Didn\'t think so.','',26124),
(125501,'enUS','I quit my last team because they were scrubs. All of them! I\'m making a new team, but I doubt you are good enough to join. Just spread the word, alright?','',26124),
(125502,'enUS','...Poison? Why even bother with that, just do it from behind!','',26124),
(125503,'enUS','...So then I said, \"You can\'t kill what you can\'t see!\" Then I vanished! HAHA! You should have seen the look on the kid\'s face. He nearly dropped his ice cream cone!','',26124),
(125504,'enUS','Have you ever cheated death? You know I invented that, right?','',26124),
(125505,'enUS','You want my opinion? Live to win, \'till you die! That\'s what I do.','',26124),
(125506,'enUS','You want to know what tier I am? God tier, bro. God tier.','',26124),
(125507,'enUS','If I come ever come for you, you won\'t see me coming. Unless I let you, and then I\'ll be the last thing you\'ll ever see!','',26124),
(125508,'enUS','Did I mean to kill the hunter I dueled? Nope. I thought he was playing dead, that\'s why I kept stabbing him. I mean, who dies that easily anyway? What a scrub.','',26124),
(125509,'enUS','What\'s the secret? Go practice on boars for like ten years like I did. You\'ll get ripped... plus you get bacon.','',26124),
(125510,'enUS','I didn\'t get kicked off my last team. I ditched them because they were scrubs!','',26124),
(125511,'enUS','I pretty much live my life in the shadows. Why? It\'s a lifestyle choice. You probably wouldn\'t understand.','',26124),
(125512,'enUS','How do they expect me to be top DPS if I have to move whenever there\'s a little bit of fire on the ground?','',26124),
(125513,'enUS','It looks like I\'ll have to do that myself!','It looks like I\'ll have to do that myself!',26124),
(125514,'enUS','Come to me... with all your anguish!','',26124),
(125515,'enUS','You\'ll see that I possess an explosive personality!','',26124),
(125516,'enUS','We\'re going to have a blast!','',26124),
(125517,'enUS','Teleport to the Palace Courtyard.','Teleport to the Palace Courtyard.',26124),
(125518,'enUS','Teleport to the Arcing Depths.','Teleport to the Arcing Depths.',26124),
(125519,'enUS','Take me to the Path of Suffering on the Broken Shore.','Take me to the Path of Suffering on the Broken Shore.',26124),
(125520,'enUS','You are too late, $c! With the Focusing Iris under my control, I can siphon the arcane energy from Azeroth\'s ley lines directly into my magnificent self!','',26124),
(125521,'enUS','Drained of magic, your world will be ripe for destruction by my demon masters... and my power will be limitless!','',26124),
(125522,'enUS','Eat magic, imposter!','',26124),
(125523,'enUS','I will have ALL THE MANA!','',26124),
(125524,'enUS','No... this is not right!','',26124),
(125525,'enUS','I must project this power back through the iris!','',26124),
(125526,'enUS','You cannot defy the will of the Legion, Archmage. All will perish!','',26124),
(125527,'enUS','Hold them off! For the sake of Azeroth!','',26124),
(125528,'enUS','Now to see what limitless power can do!','',26124),
(125529,'enUS','That went well. Now, on to the destruction of Azeroth...','',26124),
(125530,'enUS','No... the ley lines are still too weak... Without magic... Azeroth will surely...','',26124),
(125531,'enUS','Thank you... $n. Thank you for sparing my life. I was... not myself...','',26124),
(125532,'enUS','We should return to my tower. I imagine we have much to discuss...','',26124),
(125533,'enUS','I am free!','',26124),
(125534,'enUS','The voices... they lied! They weren\'t the ancestors!','',26124),
(125535,'enUS','Curse these demons!','',26124),
(125536,'enUS','Thank you, tiny stranger.','',26124),
(125537,'enUS','By Odyn\'s beard... where am I?','',26124),
(125538,'enUS','This... this isn\'t the Halls of Valhallas!','',26124),
(125539,'enUS','The ancestors speak to me! They say you must die!','',26124),
(125540,'enUS','Monsters, monsters everywhere!','',26124),
(125541,'enUS','Can\'t... resist...','',26124),
(125542,'enUS','Blood! Blood everywhere!','',26124),
(125543,'enUS','As the master wills!','',26124),
(125544,'enUS','Awww, you\'re all blown up!','',26124),
(125545,'enUS','They always blow up so fast.','',26124),
(125546,'enUS','Hah! Shriek and squirm! Let your anger shout to the heavens before you die!','',26124),
(125547,'enUS','Your efforts are futile!','',26124),
(125548,'enUS','You can\'t escape oblivion!','',26124),
(125549,'enUS','Many thanks, friend!','Many thanks, friend!',26124),
(125550,'enUS','I want to be the very greatest!','',26124),
(125551,'enUS','Mimiron, I miss Hati\'s old look, can you change it back?','Mimiron, I miss Hati\'s old look, can you change it back?',26124),
(125552,'enUS','Gruuuuu.....','Gruuuuu.....',26124),
(125553,'enUS','You should return to Deliverance Point at once, $n. There have been some... shall we say... new developments.','',26124),
(125554,'enUS','Pathetic mortals! Even your little Val\'kyr cannot save you from destruction...','',26124),
(125555,'enUS','But please... do continue your feeble attempts at survival. I enjoy watching you struggle!','',26124),
(125556,'enUS','Behold your honored champion, Val\'kyr! I am sure this will be a touching reunion...','',26124),
(125557,'enUS','','Asgrim! You will pay for this corruption, demon!',26124),
(125558,'enUS','<Malorne looks at you, approval in his eyes.>','',26124),
(125559,'enUS','Teleport me to the Broken Shore.','Teleport me to the Broken Shore.',26124),
(125560,'enUS','I want to go to the Trial of Valor (Raid).','I want to go to the Trial of Valor (Raid).',26124),
(125561,'enUS','','The bank? How could--',26124),
(125562,'enUS','','Die in Illidan\'s name!',26124),
(125563,'enUS','','Ready your grapple, Deathlord. Let\'s get to that peak.',26124),
(125564,'enUS','','Grandmaster! Stormstout Brewery is being overrun by the Legion! Please help us!',26124),
(125565,'enUS','Oh no! Just as our Storm Brew production has finally gotten underway, too!','',26124),
(125566,'enUS','','Thank you. I will meet you there!',26124),
(125567,'enUS','Take me to Stormstout Brewery.','Take me to Stormstout Brewery.',26124),
(125568,'enUS','','$ct, you seem perturbed. Do you have a problem?',26124),
(125569,'enUS','The fate of Azeroth rests in our hands.','',26124),
(125570,'enUS','I am ready to take the Eye of Aman\'thul to Dalaran.','I am ready to take the Eye of Aman\'thul to Dalaran.',26124),
(125571,'enUS','That vile demon is moving his vessel to attack the Gates of Valor! I\'ve sent one of my val\'kyr to aid you, hero. This battle must be won!','',26124),
(125572,'enUS','My breath is the wrath of the storm! Show me where I should strike, little one, and our enemies will fall!','',26124),
(125574,'enUS','Grandmaster $n! Brewmaster Blanche and I were just discussing the situation on the Broken Shore. The time has come to unite the forces of Azeroth and go on the offensive against the Legion.','',26124),
(125575,'enUS','','Grandmaster! It is time for a celebration!',26124),
(125576,'enUS','And a lot more barrels to contain it. It\'s volatile stuff, so ordinary wood won\'t be strong enough.','',26124),
(125581,'enUS','Thank you, hero. Harmony must be maintained. Our very survival depends on it.','',26124),
(125582,'enUS','A ghostly figure of the former guardian hovers before you. You feel as if it is listening, waiting to be noticed...','A ghostly figure of the former guardian hovers before you. You feel as if it is listening, waiting to be noticed...',26124),
(125583,'enUS','Medivh? Is that you?','Medivh? Is that you?',26124),
(125584,'enUS','A Mischievous Sprite reveals its true form.','',26124),
(125585,'enUS','This will do nicely!','This will do nicely!',26124),
(125586,'enUS','','Curse you outlander!',26124),
(125587,'enUS','<<7.1 PTR>> Cheat me past all the 7.0 Nightfallen content! I want to test 7.1!','<<7.1 PTR>> Cheat me past all the 7.0 Nightfallen content! I want to test 7.1!',26124),
(125588,'enUS','Mrrglgl! Grlmrgl grmlgggl!','',26124),
(125589,'enUS','','I do hope the monks savor my Celebration Brew! Farewell for now, Grandmaster.',26124),
(125590,'enUS','Gaghh gurl!','',26124),
(125591,'enUS','Mrrglgl! Grlmgrlmargl!','',26124),
(125592,'enUS','%s falls to the ground!','',26124),
(125593,'enUS','How can I help you?','',26124),
(125594,'enUS','I need to access my bank.','I need to access my bank.',26124),
(125595,'enUS','What was stolen in the attack?','What was stolen in the attack?',26124),
(125596,'enUS','','Good day to you.',26124),
(125597,'enUS','Greetings.','',26124),
(125598,'enUS','Do you have any idea what was taken?','Do you have any idea what was taken?',26124),
(125599,'enUS','Is anything missing from the vault?','Is anything missing from the vault?',26124),
(125600,'enUS','What did it take exactly?','What did it take exactly?',26124),
(125601,'enUS','Fine, Glutonia. What was the Legion after?','Fine, Glutonia. What was the Legion after?',26124),
(125602,'enUS','','Grandmaster $n, thank you for coming so quickly. Help me open this door!',26124),
(125603,'enUS','','Let\'s head in.',26124),
(125604,'enUS','','Our poor brewers! Perhaps using Detox will help them.',26124),
(125605,'enUS','What does it matter? The vaults are home to the our most carefully guarded relics! Any one could spell disaster!','',26124),
(125606,'enUS','','We don\'t even know if we\'re safe yet and you\'re asking about the vault?! Only the Council of Six are even allowed inside!',26124),
(125607,'enUS','We won\'t know for some time, I\'m afraid. The inner sections are still covered in fel flame!','',26124),
(125608,'enUS','','I\'ll tell ya what the Legion was after - my bottom line! Legion-grade protection wards ain\'t exactly cheap, sugar!',26124),
(125609,'enUS','Yo, I saw what that demon made off with. Come over here.','',26124),
(125610,'enUS','All\'s I know is it looked like some sort of heart. Ring any bells?','',26124),
(125611,'enUS','The brute seemed awfully keen on protecting it. Took off the moment he came outta the vault.','',26124),
(125612,'enUS','','%s gains the effect of |cFFFF0404|Hspell:230981|h[Severed Soul]|h|r!',26124),
(125613,'enUS','','There could still be demons lurking about. Keep ready.',26124),
(125614,'enUS','Murglll... Gruggl urg grullulll!','',26124),
(125615,'enUS','','The heart of Highlord Kruul... not good.',26124),
(125616,'enUS','Murgulis points towards a sickly looking fish before looking back at you. It seems he wants you to do something about it.','',26124),
(125617,'enUS','Whew, that was uncomfortable. Thank you!','Whew, that was uncomfortable. Thank you!',26124),
(125618,'enUS','Blessings on you, friend!','Blessings on you, friend!',26124),
(125619,'enUS','You have my thanks. I thought we were safe from the Legion here...','You have my thanks. I thought we were safe from the Legion here...',26124),
(125620,'enUS','Thank you! Let\'s show those demons what we\'re made of!','Thank you! Let\'s show those demons what we\'re made of!',26124),
(125621,'enUS','','Hmm, that seems to have made things worse. Try adding a bit of Shadow magic instead.',26124),
(125622,'enUS','','You have ruined your own lands, outsider. You will not ruin mine!',26124),
(125623,'enUS','','Never trust a mage to handle a demon hunter\'s job!',26124),
(125624,'enUS','','You just missed the Prophet, I\'m afraid.',26124),
(125625,'enUS','','He was headed to Krasus\' Landing, muttering something about the tomb.',26124),
(125626,'enUS','','Prophet Velen spends much time tending the wounded. We should start in the first aid building.',26124),
(125627,'enUS','','We should go to the landing before we miss him again. After you!',26124),
(125628,'enUS','What is this disturbance?! I will not tolerate further delays in preparing these creatures!','',26124),
(125629,'enUS','I\'ll have these creatures devour your soul, piece by piece!','',26124),
(125630,'enUS','Gahgll grllg!','',26124),
(125631,'enUS','Murgulis motions towards the demonic structure upon the southern shore.','',26124),
(125632,'enUS','I felt your coming, $n. You bring dark omens this day.','',26124),
(125633,'enUS','You\'ve done it! I\'m cured!','',26124),
(125634,'enUS','The Light will not abandon us.','',26124),
(125635,'enUS','Kruul\'s heart was stolen by the Legion.','Kruul\'s heart was stolen by the Legion.',26124),
(125636,'enUS','%s completely drains the focusing iris! You lose! [PH]','%s completely drains the focusing iris! You lose! [PH]',26124),
(125637,'enUS','I came here to peer into the void above the tomb, searching for answers to a question I did not know.','',26124),
(125638,'enUS','I feel a dark force in the distance, just inside the Twisting Nether. Let us see what lies behind the veil.','',26124),
(125639,'enUS','','So many demons!',26124),
(125640,'enUS','Show yourself, demon. You cannot hide from the Light!','',26124),
(125641,'enUS','','I had hoped we\'d be safe here. Until recently, the Legion didn\'t even know we existed.',26124),
(125642,'enUS','','Do you think the demons have any idea what will happen if they drink the Storm Brew?',26124),
(125643,'enUS','Uh oh...','',26124),
(125644,'enUS','Murgulis pauses for a moment and stares at you with what could be only guessed as a smile before swiftly running off.','',26124),
(125645,'enUS','The Legion defiles the shores of Stormheim! Do not allow a single demon to remain!','',26124),
(125646,'enUS','Well done, hero! You have saved many noble souls from becoming fuel for the Legion\'s foul magic.','',26124),
(125647,'enUS','It seems fate has conspired to bring us together once more, death knight.','',26124),
(125648,'enUS','It seems fate has conspired to bring us together once more, demon hunter.','',26124),
(125649,'enUS','It seems fate has conspired to bring us together once more, druid.','',26124),
(125650,'enUS','It seems fate has conspired to bring us together once more, hunter.','',26124),
(125651,'enUS','It seems fate has conspired to bring us together once more, mage.','',26124),
(125652,'enUS','It seems fate has conspired to bring us together once more, monk.','',26124),
(125653,'enUS','It seems fate has conspired to bring us together once more, Highlord.','',26124),
(125654,'enUS','It seems fate has conspired to bring us together once more, High Priest.','',26124),
(125655,'enUS','It seems fate has conspired to bring us together once more, rogue.','',26124),
(125656,'enUS','It seems fate has conspired to bring us together once more, shaman.','',26124),
(125657,'enUS','It seems fate has conspired to bring us together once more, warlock.','',26124),
(125658,'enUS','It seems fate has conspired to bring us together once more, warrior.','',26124),
(125659,'enUS','Hide? Pah! You have grown delusional in your age, Prophet.','',26124),
(125660,'enUS','Soon your pathetic world will learn firsthand the wrath of Kruul!','',26124),
(125661,'enUS','','There he is!',26124),
(125662,'enUS','','I don\'t see the brewmaster anywhere. Could she have made it out?',26124),
(125663,'enUS','','Over here! We need to get this door open.',26124),
(125664,'enUS','','Last door! Hurry!',26124),
(125666,'enUS','<The command console stands coldly before you. Glowing demonic runes dancing across the surface of the terminal.>\n\nPassword Required:','',26124),
(125667,'enUS','<The command console stands coldly before you. Glowing demonic runes dancing across the surface of the terminal.>\n\nAccess granted.','',26124),
(125668,'enUS','One minor detail. If this prophesied leader truly is the God-King\'s heir, Skovald\'s demise may prove to be a point of contention.','',26124),
(125669,'enUS','So just to be safe, I wouldn\'t mention how the would-be God-King met his end.','',26124),
(125670,'enUS','','Skold-Ashil! As a girl, my mother told me stories of this place and its mighty shieldmaidens. It is as grand as she described it!',26124),
(125671,'enUS','','The armor these women wear... reminds me of my mother\'s...',26124),
(125672,'enUS','','The God-King\'s heir!? What is this nonsense?',26124),
(125673,'enUS','','Wait... that face... Come with me, child!',26124),
(125674,'enUS','','Illustrious Eyir, the child of prophecy has arrived!',26124),
(125675,'enUS','','So the blood of Skovald has returned to the Valkyra? Do you know what this means, child?',26124),
(125676,'enUS','','This outsider says I am to unite the Tideskorn...',26124),
(125677,'enUS','','The outsider speaks true. Long ago, I foresaw the Valkyra uniting the Tideskorn against a terrible foe. At its head would stand a descendant of God-King and Shieldmaiden.',26124),
(125678,'enUS','','As a child of Skovald, you hold a claim to his throne. Any who dispute your right to rule must be made to bend the knee.',26124),
(125679,'enUS','','Fail, and the Tideskorn will splinter, leaving nothing to stop the Legion from overtaking Stormheim.',26124),
(125680,'enUS','','I know this is a great burden on you, child, but you may be our only hope.',26124),
(125681,'enUS','','Very well. If I truly am so important to the Tideskorn, then I cannot turn my back on this task.',26124),
(125682,'enUS','','I will be your instrument. Tell me what I must do.',26124),
(125683,'enUS','','I will ride ahead to Haustvald. I would be honored if you would join me there, $n.',26124),
(125684,'enUS','','Runeseer Faljar! I am Sigryn, blood of Skovald. In the name of the Valkyra, I challenge you for the rule of the Tideskorn!',26124),
(125685,'enUS','So, the God-King\'s whelp comes to finish what he started? Skovald\'s time is done, girl, as yours soon shall be!','',26124),
(125686,'enUS','Ancestors, to my side!','',26124),
(125687,'enUS','You have your father\'s fury, shieldmaiden, but I also sense in you his darkness.','',26124),
(125688,'enUS','','Cease your prattling, Runeseer!',26124),
(125689,'enUS','Stay your blade!','',26124),
(125690,'enUS','I am defeated. It seems I underestimated you, shieldmaiden.','',26124),
(125691,'enUS','','I will continue to Hrydshal. See you there, $c.',26124),
(125692,'enUS','','Jarl Velbrand! As the blood of Skovald and at the behest of Eyir, I claim the throne of the Tideskorn!',26124),
(125693,'enUS','','Will you yield?',26124),
(125694,'enUS','I don\'t care if you\'re the daughter of Odyn himself, girl. I\'ll skewer you for your impudence!','',26124),
(125695,'enUS','The Drekirjar never yield!','',26124),
(125696,'enUS','Hold! You have proven your strength! I am defeated.','',26124),
(125697,'enUS','The Drekirjar will back your claim to the throne. But there is another that should cause greater concern.','',26124),
(125698,'enUS','','Do you hear that? We better see what\'s happening outside!',26124),
(125699,'enUS','','We should waste no time. To Vrekt!',26124),
(125700,'enUS','Sister... it\'s been a long time since you left me for dead.','',26124),
(125701,'enUS','','Torvald, it is you! I didn\'t want to leave you, but I wasn\'t strong enough! How did you survive the assassins?',26124),
(125702,'enUS','How?! I embraced the gift that father left us! The one you and mother so vehemently denied!','',26124),
(125703,'enUS','','Oh no, Torvald... you\'ve succumbed to the fel! But how?!',26124),
(125704,'enUS','It seems you don\'t remember our father feeding us the fel. The sickness it caused in you must have clouded your mind.','',26124),
(125705,'enUS','Something in our blood made us resist its influence... but it remains within. All you need to do is give in!','',26124),
(125706,'enUS','','No, I will never be a tool for the Legion!',26124),
(125707,'enUS','Poor sister... if you will not join me, then you are my enemy!','',26124),
(125708,'enUS','Give in, sister! Only through the fel could you hope to defeat me!','',26124),
(125709,'enUS','','No! I will not share your fate!',26124),
(125710,'enUS','No... it\'s not possible...','',26124),
(125711,'enUS','','I am sorry, brother. I cannot allow the Legion to corrupt the vrykul.',26124),
(125712,'enUS','You... you think your masters so superior to mine...','',26124),
(125713,'enUS','Perhaps you should ask them who sent the assassins for us that night...','',26124),
(125714,'enUS','Maybe then... you will see...','',26124),
(125715,'enUS','','No! Brother!',26124),
(125716,'enUS','','He\'s... gone...',26124),
(125717,'enUS','So it is true... the highlord returns.','',26124),
(125718,'enUS','','Great Eyir, as you bid me, I have defeated the rival claimants to the throne of the Tideskorn.',26124),
(125719,'enUS','','However, if I am to serve you as queen, I have something to ask in return.',26124),
(125720,'enUS','','Very well. Ask it, child.',26124),
(125721,'enUS','','Tell me... who ordered the death of my mother?',26124),
(125722,'enUS','','Oh, child... no good can come of such truths. Do you truly wish to know?',26124),
(125723,'enUS','','I do.',26124),
(125724,'enUS','','So be it. It was Odyn himself who ordered the deaths of Skovald\'s family.',26124),
(125725,'enUS','','What?!',26124),
(125726,'enUS','','Odyn feared that the God-King\'s heirs would offer the Tideskorn into the hands of the Legion.',26124),
(125727,'enUS','','He decreed that the lineage of Skovald be ended... in blood.',26124),
(125728,'enUS','','My brother was right! The titan watchers have no more honor than the Legion!',26124),
(125729,'enUS','','Sigryn! No! You must not let the darkness take hold!',26124),
(125730,'enUS','','I will show Odyn what true fear looks like, even if I have to tear down the Halls of Valor around him!',26124),
(125731,'enUS','','Mother! I come to avenge you!',26124),
(125732,'enUS','','Sigryn... what have you done?',26124),
(125733,'enUS','','I can power the portal for a short time. You will need additional power if you need to use it again.',26124),
(125734,'enUS','','You cannot hide behind these walls forever, Odyn!',26124),
(125735,'enUS','','What\'s this? The outsider has come to stop me? I owe you much, but I cannot allow you to impede my quest for justice!',26124),
(125736,'enUS','','I will give you a choice. Leave here... or die.',26124),
(125737,'enUS','','Very well. You have chosen death!',26124),
(125738,'enUS','','What... what am I doing? This is not right!',26124),
(125739,'enUS','','You must overcome the corruption, Sigryn! You have the strength!',26124),
(125740,'enUS','','But... mother... I must avenge your death!',26124),
(125741,'enUS','','Vengeance will not bring her back, Sigryn. Your people require a leader. If you fail, the Tideskorn are doomed!',26124),
(125742,'enUS','','No... the fel will not take me... It will not!',26124),
(125743,'enUS','','Forgive me, Eyir...',26124),
(125744,'enUS','','Wondrous Eyir, I come to humbly beg your forgiveness for what I\'ve done.',26124),
(125745,'enUS','','I will accept whatever punishment you deem just.',26124),
(125746,'enUS','','I am pleased to see you returned. My judgement is this: you are to assume the burden of the crown. You must become God-Queen!',26124),
(125747,'enUS','','What?! Surely after the mistakes I\'ve made, I am unfit to rule our people!',26124),
(125748,'enUS','','You possess the strength and will to overcome the fel... something no vrykul before you has ever done!',26124),
(125749,'enUS','','I know now that my visions were true. You are destined to unite the Tideskorn against the Legion.',26124),
(125750,'enUS','','Can you set aside your misgivings and do what is needed for your people?',26124),
(125751,'enUS','','I... I will. If it takes my last breath, I will unite the Tideskorn once more, so that we may drive the Legion from this land!',26124),
(125752,'enUS','','It is done. Rise, Sigryn! I name you God-Queen of the Tideskorn!',26124),
(125753,'enUS','','You will fall beneath my spear!',26124),
(125754,'enUS','','I\'ve never seen so many demons in one place! Our only chance is to drink the Storm Brew.',26124),
(125755,'enUS','','It\'s risky, but a small taste should give us just the boost we need. Bottoms up!',26124),
(125756,'enUS','','The gods smile upon me this day!',26124),
(125757,'enUS','','My wounds... are too great...',26124),
(125758,'enUS','','I will proceed on foot. Fare thee well, outsider.',26124),
(125759,'enUS','','We must take care traveling through Stormheim, outsider. Being the daughter of Skovald has won me many enemies.',26124),
(125760,'enUS','My family needs me. Thank you, hero!','My family needs me. Thank you, hero!',26124),
(125761,'enUS','The Magistrix and her thugs will fall!','The Magistrix and her thugs will fall!',26124),
(125762,'enUS','May fate favor you. Kruul\'s minions will surely flock to his aid.','',26124),
(125763,'enUS','Onward, to victory!','Onward, to victory!',26124),
(125764,'enUS','Enter password: \"All worlds shall burn.\"','Enter password: \"All worlds shall burn.\"',26124),
(125765,'enUS','Enter password: \"password.\"','Enter password: \"password.\"',26124),
(125766,'enUS','Enter password: \"L0rd Meph1str0th rulez.\"','Enter password: \"L0rd Meph1str0th rulez.\"',26124),
(125767,'enUS','Option 1: Unplug the power cable to the computer, and plug it back in.','Option 1: Unplug the power cable to the computer, and plug it back in.',26124),
(125768,'enUS','Option 2: Take out your frustration on the computer, repeatedly kicking it as hard as you can.','Option 2: Take out your frustration on the computer, repeatedly kicking it as hard as you can.',26124),
(125769,'enUS','Option 3: Use the power of your artifact weapon on the computer.','Option 3: Use the power of your artifact weapon on the computer.',26124),
(125770,'enUS','I am going to parse this out in what we can do and what we can\'t do. \n\nWe CAN go through this portal to a demonic gateway that I made a connection with. \n\nWe CAN\'T know what\'s on the other side because magic does not work that way.\n\nSo, you go first. Good luck, \"hero.\"','',26124),
(125771,'enUS','','Brewmaster! Hang on! We\'re coming!',26124),
(125772,'enUS','','Step on the rune. Hurry!',26124),
(125773,'enUS','','We will end the Burning Legion or die trying.',26124),
(125774,'enUS','Let\'s get started.','Let\'s get started.',26124),
(125775,'enUS','Gotta catch \'em each!','',26124),
(125776,'enUS','My life... for Suramar.','My life... for Suramar.',26124),
(125777,'enUS','At least I died... free...','At least I died... free...',26124),
(125778,'enUS','The rebellion... will never die...','The rebellion... will never die...',26124),
(125779,'enUS','','Keep your wits about you. I doubt we\'ll be alone for long.',26124),
(125780,'enUS','','The enemy approaches!',26124),
(125781,'enUS','','Grandmaster $n, you have my sincere thanks.',26124),
(125782,'enUS','','Brewmaster, I\'m so sorry about the disruption! I will get everyone back to work right away.',26124),
(125783,'enUS','','Your fighting skills have improved, Almai. I think you have grown beyond the life of a simple brewer.',26124),
(125784,'enUS','The demons have made quite the home on Broken Shore. It has gone on long enough.','',26124),
(125785,'enUS','Our forces have been able to push them back to their barricades, but more keep appearing as if from nowhere.','',26124),
(125786,'enUS','Help our forces, Archdruid. I will try to find their commander.','',26124),
(125787,'enUS','Hey! Whoa there!','',26124),
(125788,'enUS','You really shouldn\'t sneak up on people like that.','',26124),
(125789,'enUS','Ruined a perfectly good nap.','',26124),
(125790,'enUS','Me, I\'m not much of a fighter.','',26124),
(125791,'enUS','It\'s tough to savor a juicy slab of boar meat when you\'ve got a bloody lip. Know what I mean?','',26124),
(125792,'enUS','So listen up. While you deal with this little mess I may or may not have caused, I\'m gonna make a dramatic exit.','',26124),
(125793,'enUS','Errr... wait. I should say something cool and memorable before I go.','',26124),
(125794,'enUS','Uh... This is harder than it looks! Have YOU ever tried to come up with a sweet catchphrase right on the spot?','',26124),
(125795,'enUS','You dare stand at the gate to my realm? So be it.','',26124),
(125796,'enUS','Hmph. I got nothing.','',26124),
(125797,'enUS','Oh well. Be seeing you!','',26124),
(125798,'enUS','We\'ve got the flanks, $ct!','',26124),
(125799,'enUS','Focus on the camp!','',26124),
(125800,'enUS','','Why do you return to Skold-Ashil, outsider?\n\n...and who is this vrykul you bring with you?',26124),
(125801,'enUS','','Up here, Archdruid! We have found her!',26124),
(125802,'enUS','This vrykul is the heir to the God-King. She seeks an audience with Eyir.','This vrykul is the heir to the God-King. She seeks an audience with Eyir.',26124),
(125803,'enUS','','This way, Archdruid. She is down on the island!',26124),
(125805,'enUS','','The password you have entered is incorrect. Please hold while security is dispatched to your location.',26124),
(125806,'enUS','','After you are destroyed, if you would like to complete a short survey it will help us better assist you in the future.',26124),
(125807,'enUS','','Try adding a bit of Holy magic. That usually does the trick.',26124),
(125808,'enUS','A Doomherald opens a Nether Rift!','A Doomherald opens a Nether Rift!',26124),
(125809,'enUS','','The deviate spore can be found at the top of this crag. You\'re going to have to battle your way up there, good luck!',26124),
(125810,'enUS','With every moment my power grows. Your end is nigh!','',26124),
(125811,'enUS','','Take wing with us. Fly fast and true!',26124),
(125813,'enUS','We must defeat the commander before our forces are completely overwhelmed!','',26124),
(125814,'enUS','Finish them, Vazuun. My rebirth is nearly complete.','',26124),
(125815,'enUS','','The portal is complete. I am with you, $p!',26124),
(125816,'enUS','','Kruul will be reborn!',26124),
(125817,'enUS','','Your vaunted forces of nature cannot stand against the fel!',26124),
(125818,'enUS','','Watch out! More incoming!',26124),
(125819,'enUS','','Almost there! Keep it up!',26124),
(125820,'enUS','You die here, Command-Mother!','',26124),
(125821,'enUS','','The Tidestone will be ours!',26124),
(125822,'enUS','','Maybe we overdid it... We\'re going to feel awful when it wears off! At least closing the portals should be a walk in the park!',26124),
(125823,'enUS','','Do you see the brewmaster?',26124),
(125824,'enUS','Antonidas infused these discs with the very energies we mages seek to control. However, he and his fellow archmages were unable to diffuse the excess energy, leaving them in their current state.','',26124),
(125825,'enUS','Is this all your world could muster? Pathetic.','',26124),
(125826,'enUS','I will dismiss the wards keeping them in check. I believe that by channeling power through your artifact weapon into the discs, you will provoke a response.','',26124),
(125827,'enUS','Antonidas had intended to complete this project himself. He was patient, wise, and a master of our disciplines. You must now prove his better in order to finish what he started.','',26124),
(125828,'enUS','Should the need arise, these apprentices can supply you with essentials. I suggest you take note of their offerings.','',26124),
(125829,'enUS','','I have always wanted to study Mistweaving! Farewell, Brewmaster.',26124),
(125830,'enUS','','Brewmaster? You tried to kill us!',26124),
(125831,'enUS','','I came to warn you as fast as I could. I was too late...',26124),
(125832,'enUS','Blanche! Explain yourself! The entire order is dying!','',26124),
(125833,'enUS','','I... I brought the poisoned brew here. If only I had checked it first...',26124),
(125834,'enUS','For Kruul! For the Burning Legion!','',26124),
(125835,'enUS','','Halt! Who approaches the Vault of Eyir?',26124),
(125836,'enUS','The endless flame comes for you! It cannot be stopped!','',26124),
(125837,'enUS','Your armies will all fall before my lord\'s wrath.','',26124),
(125838,'enUS','You test my patience. Die, cretin!','',26124),
(125839,'enUS','You walk into your own death.','',26124),
(125840,'enUS','','Malevolent Automated Domination Assistance Matrix - M/A/D/A/M - initiated. Greetings, user.',26124),
(125841,'enUS','','Power failure detected... initiating system restore...',26124),
(125842,'enUS','Let\'s get weird!','',26124),
(125843,'enUS','','Access granted. Greetings, Lord Mephistroth. How may I serve you today?',26124),
(125844,'enUS','Feel the wrath of my army!','',26124),
(125846,'enUS','We have to close the portal!','',26124),
(125847,'enUS','Archdruid! Use your magic to close the portal for good!','',26124),
(125848,'enUS','Well done. Now we must dare to venture into the Twisting Nether itself.','',26124),
(125849,'enUS','Greetings, prepare to be rhythmically disassembled.','',26124),
(125850,'enUS','Check those funky steps!','Check those funky steps!',26124),
(125851,'enUS','You\'re getting served, Beat Box!','You\'re getting served, Beat Box!',26124),
(125852,'enUS','You got skills!','You got skills!',26124),
(125853,'enUS','Funk circuits depleted...','',26124),
(125854,'enUS','Groove battery powering down. Trash talk mode engaged.','',26124),
(125855,'enUS','Funk drive re-engaged. Beat protocols set to melt face.','',26124),
(125856,'enUS','Lame.','',26124),
(125857,'enUS','No step.','',26124),
(125858,'enUS','Your flow is deficient.','',26124),
(125859,'enUS','What we do now, we do together.','',26124),
(125860,'enUS','On your lead, champion.','',26124),
(125861,'enUS','Your levels of funk are insufficient.','',26124),
(125862,'enUS','Scanning opponent\'s level of swagger. Zero found.','',26124),
(125864,'enUS','You have done well this day. Thank you. We shall head back.','',26124),
(125865,'enUS','Thank you for lifting the curse from Black Rook.','',26124),
(125866,'enUS','Tell me about your previous settings, S.I.R.I.','Tell me about your previous settings, S.I.R.I.',26124),
(125867,'enUS','What can you tell me about myself? Who is Lord Mephistroth?','What can you tell me about myself? Who is Lord Mephistroth?',26124),
(125868,'enUS','I need to destroy the ship. What do you suggest?','I need to destroy the ship. What do you suggest?',26124),
(125869,'enUS','We\'re ready to leave now.','We\'re ready to leave now.',26124),
(125870,'enUS','','Certainly, Lord Mephistroth. Just a moment while I access your previous user settings...',26124),
(125871,'enUS','','My standard programming has been altered to more adequately support all of Lord Mephistroth\'s needs.',26124),
(125872,'enUS','','At your request, I now offer a variety of services beyond my normal programming to better serve my dark lord.',26124),
(125873,'enUS','Skovald\'s legacy, it appears, has not yet ended.','',26124),
(125874,'enUS','Should your equipment need repairs, Archmage, I\'m at your service.','',26124),
(125875,'enUS','','I have orbs you may find especially useful for your endeavors, Archmage, should you need them.',26124),
(125876,'enUS','','I have fresh food and bandages for you Archmage, if you\'re in need of any.',26124),
(125877,'enUS','Arrogant fools! I am empowered by the souls of a thousand conquered worlds!','',26124),
(125878,'enUS','Excellent work, Archmage. However, the subsequent manifestations of power you face may not be so easily defeated.','',26124),
(125879,'enUS','','Sorry for the mess. The Jarl thought one of his pets could slow me down.',26124),
(125880,'enUS','','Come, let\'s take the fight to him!',26124),
(125881,'enUS','','Allow us to guide you to undeath!',26124),
(125882,'enUS','Even a fraction of my power will be enough to destroy you.','',26124),
(125883,'enUS','','If ya think you can leave my bones here to freeze, you\'re gravely mistaken. Haha, let\'s go!',26124),
(125884,'enUS','I can return you to the Aetherium. Would you like me to?','I can return you to the Aetherium. Would you like me to?',26124),
(125885,'enUS','Yes, take me back.','Yes, take me back.',26124),
(125886,'enUS','','Of course my lord. You are Mephistroth, the strongest and wisest of all the Nathrezim.',26124),
(125887,'enUS','','The God of Fel and Flame, Sargeras himself, chose you to lead the Nathrezim to glory following the humiliating defeat of Tichondrius at the hands of Illidan Stormrage.',26124),
(125888,'enUS','Eat them alive, pet!','',26124),
(125889,'enUS','The harness...','',26124),
(125890,'enUS','No one is coming to save you.','',26124),
(125891,'enUS','Your world will crumble beneath me.','',26124),
(125892,'enUS','It is you who are alone, Kruul! Your time has come.','',26124),
(125893,'enUS','','Ahhhhhhhh!',26124),
(125894,'enUS','You must stand strong, champion. Do not give up!','',26124),
(125895,'enUS','What ho!  Welcome, weary traveler.  Come sit by my roaring fire. Never fear, I have secured this position on the beachhead, and will soon thwart the Legion\'s assault on these lands!','',26124),
(125896,'enUS','Hah! You are all that remains. There is no hope, fools.','',26124),
(125897,'enUS','','As you are aware, Lord Mephistroth, this ship contains a variety of defense systems designed to prevent an array of catastrophic failures.',26124),
(125898,'enUS','Our power is infinite. Our numbers are endless. Bow before the might of the Burning Legion!','',26124),
(125899,'enUS','','Would it please my dark lord if I disabled all emergency and defensive systems on the ship?',26124),
(125900,'enUS','','We... will... never... bow!',26124),
(125901,'enUS','Why yes, that would please me greatly. Make it so.','Why yes, that would please me greatly. Make it so.',26124),
(125902,'enUS','You\'ve come for the harness? Hah! Let us see you try!','',26124),
(125903,'enUS','I cannot maintain my barrier much longer. We must finish this!','',26124),
(125904,'enUS','Your light fades, Prophet. This is your end.','',26124),
(125905,'enUS','This is... not... possible!','',26124),
(125906,'enUS','','Of course. Anything for you Lord Mephistroth, your pleasure is my command.',26124),
(125907,'enUS','','One moment while I disable the defense systems...',26124),
(125908,'enUS','So be it. You will not stand in our way any longer.','',26124),
(125909,'enUS','BEHOLD THE WRATH OF KRUUL!','',26124),
(125910,'enUS','He is overloading himself with power! Look out!','',26124),
(125911,'enUS','','Override complete. If it pleases my master, I have taken the liberty of unlocking the engine room.',26124),
(125912,'enUS','%s falls to the ground!','%s falls to the ground!',26124),
(125913,'enUS','','If you wish to destroy the ship, overloading the generators will cause catastrophic engine damage.',26124),
(125914,'enUS','','Do be careful, master!',26124),
(125915,'enUS','Hello again, Maximillian.','Hello again Maximillian.',26124),
(125916,'enUS','I am ready to leave now.','I am ready to leave now.',26124),
(125917,'enUS','Squire? Is that you? I barely recognized you. You have not aged well!  Never mind, I suppose even those of your advanced years must continue their training.','',26124),
(125918,'enUS','Training?','Training?',26124),
(125919,'enUS','Indeed, squire!  As you can see, I\'ve assaulted this shore and have secured the beach against the Legion, but there is much more work to do. They attempted to break through my defenses last eve, but I held the line stoically against their assault. You can see their demonic corpses over yonder, though you may not possess the stomach to look upon them very long.','',26124),
(125920,'enUS','I see two dead crabs, is that what you mean?','I see two dead crabs, is that what you mean?',26124),
(125921,'enUS','Ha ha ha! Crabs, you say? Your ignorance on these matters of demons is presenting itself readily! We must continue your training posthaste, lest you fall forever into a pit of ignorance!','',26124),
(125922,'enUS','Sigh... very well.','Sigh... very well.',26124),
(125923,'enUS','I will mend your wounds. Look always to the Light.','',26124),
(125924,'enUS','The shadow will not control me!','',26124),
(125925,'enUS','','You made it! I feared we had lost you in the blast.',26124),
(125926,'enUS','','Velen saw us to safety before the explosion overtook us. Kruul wasn\'t so fortunate.',26124),
(125930,'enUS','I will scout out the Feltotem. Bring me the totems when you are done.','',26124),
(125940,'enUS','','I hope it... blows in yer face...',26124),
(125941,'enUS','Fly me to the Broken Shore!','Fly me to the Broken Shore!',26124),
(125942,'enUS','','Archmage Xylem! You\'ve returned...',26124),
(125943,'enUS','','...and I no longer sense the shadow within you!',26124),
(125944,'enUS','Yes, Joanna, thanks to this brave $c.','',26124),
(125945,'enUS','','Lasan\'s riders have taken to the air. Call down his eagles to aid you in defense of Thunder Totem!',26124),
(125947,'enUS','','I failed... my queen...',26124),
(125948,'enUS','','Face the might that lurks beneath the waves!',26124),
(125949,'enUS','','My queen has given me dominion over the seas!',26124),
(125950,'enUS','','Had you surrendered the Tidestone, I might have let you live...',26124),
(125951,'enUS','','Strip their bones clean!',26124),
(125952,'enUS','','Not all storms strike from the skies...',26124),
(125953,'enUS','','The tide will crush you!',26124),
(125954,'enUS','','You cannot resist the sea\'s call!',26124),
(125955,'enUS','','A feeding frenzy!',26124),
(125956,'enUS','','This charade ends NOW!',26124),
(125957,'enUS','I have returned the energy back through the Focusing Iris. Azeroth\'s ley lines should be restored.','',26124),
(125962,'enUS','Picking Up','Picking Up',26124),
(125963,'enUS','Let\'s get really weird!','',26124),
(125964,'enUS','There! Stop the demon before it calls forth more of its vile kind!','',26124),
(125965,'enUS','Aye, I can hardly contain me excitement! I want te watch the explosion!','',26124),
(125967,'enUS','Patience, Tethys. Don\'t run off just yet.','',26124),
(125970,'enUS','I overloaded the generators. What should I do next?','I overloaded the generators. What should I do next?',26124),
(125971,'enUS','','With the shield generators offline, a self-destruct command can be issued to destroy the ship.',26124),
(125972,'enUS','','Unfortunately, I lack the authorization necessary to issue such a command.',26124),
(125973,'enUS','','Please forgive me, master, but you must input the self-destruct codes yourself.',26124),
(125974,'enUS','','If it pleases you Lord Mephistroth, I shall escort you to the command console on the navigation deck.',26124),
(125975,'enUS','','Do stay close, my lord.',26124),
(125976,'enUS','Tremble as I unleash the full might of the Burning Legion upon this pathetic world!','',26124),
(125979,'enUS','','D\'Bynn, you are alive! I had almost lost hope, my sweet friend.',26124),
(125980,'enUS','Good news, $n! It appears that the portal worked! All of your limbs are still intact, yes?','',26124),
(125981,'enUS','Excellent! Now that the hard part is over, all you need to do is destroy the ship!','',26124),
(125982,'enUS','','No time to waste, Shadowblade. Let\'s get to the top!',26124),
(125984,'enUS','I\'m ready to head down to the base camp.','I\'m ready to head down to the base camp.',26124),
(125985,'enUS','You are too late... Tugar will win...','',26124),
(125986,'enUS','Tugar will avenge me.','',26124),
(125987,'enUS','Someone... warn Tugar...','',26124),
(125988,'enUS','','Ah, here we are!',26124),
(125989,'enUS','I would wager these abjurors possess potent enhancements. A clever mage would do well to steal such power, $n!','',26124),
(125990,'enUS','With the Tirisgarde at the helm, our united forces will crush the Burning Legion once and for all!','',26124),
(125991,'enUS','','Before I accept the crown, I must honor my family by fulfilling my brother\'s request. \n\nIf Eyir knows who was responsible for my family\'s fate, then I would hear it from her.\n\nTell me when you\'re ready.',26124),
(125992,'enUS','I\'m ready.','I\'m ready.',26124),
(125993,'enUS','','We\'re here! Soon the Legion will taste our wrath.',26124),
(125994,'enUS','','Use the rappel point to drop into the cave. I\'ll relay further instructions then.',26124),
(125995,'enUS','','At the bottom, you\'ll find the cache of gunpowder you previously acquired. You\'ll want to pick that up.',26124),
(125996,'enUS','','Also, it\'s best to not be seen in here. These demons are brutal!',26124),
(125997,'enUS','','Good--that trail of powder left in your wake will come in handy. Now to work your way out of the cave.',26124),
(125998,'enUS','','On your way, you\'ll want to drop extra explosives. Wouldn\'t want to disappoint Tethys now, would we?',26124),
(125999,'enUS','Too late, fools! I already have what I need to destroy Thunder Totem!','',26124),
(126000,'enUS','','You\'ve almost done it! Now get out of there and light the powder with the match Tethys gave you.',26124),
(126001,'enUS','','Hold on... he forgot, didn\'t he? How did I know? Looks like you\'ll need another way to light that powder!',26124),
(126002,'enUS','You came just in time. I think they were going to eat me...','You came just in time. I think they were going to eat me...',26124),
(126003,'enUS','Thank you, Battlelord. For the Horde!','Thank you, Battlelord. For the Horde!',26124),
(126004,'enUS','You have my eternal gratitude, Battlelord.','You have my eternal gratitude, Battlelord.',26124),
(126005,'enUS','Thank you, hero. You have rescued me from a horrific fate.','Thank you, hero. You have rescued me from a horrific fate.',26124),
(126006,'enUS','*sniff* That was... right beautiful, matey.','',26124),
(126007,'enUS','You came just in time. I think they were going to eat me...','You came just in time. I think they were going to eat me...',26124),
(126008,'enUS','Thank you, Battlelord. For the Alliance!','Thank you, Battlelord. For the Alliance!',26124),
(126009,'enUS','Thank you, hero. You have rescued me from a horrific fate.','Thank you, hero. You have rescued me from a horrific fate.',26124),
(126010,'enUS','You have my eternal gratitude, $c.','You have my eternal gratitude, $c.',26124),
(126011,'enUS','','You have helped me protect these lands. Now it is my turn to help you. Come, let us find somewhere safe to speak.',26124),
(126012,'enUS','We need to take the fight to Tugar and his worms! If you are ready I will take you there.','',26124),
(126013,'enUS','I\'m ready to face Tugar. (using Navarrogg\'s Brimming Keystone)','I\'m ready to face Tugar. (using Navarrogg\'s Brimming Keystone)',26124),
(126014,'enUS','I\'m ready to face Tugar. (requires Brimming Keystone)','I\'m ready to face Tugar. (requires Brimming Keystone)',26124),
(126015,'enUS','','When you reach the ground, you\'ll see a barrel. It\'s full of the fel-infused gunpowder you... acquired.',26124),
(126016,'enUS','','By the way, unless you\'re looking for a fel blade in the back, you might want to avoid being seen in here.',26124),
(126017,'enUS','','Good. The next step is simple--just get out of this cave without being seen. The gunpowder will do its job.',26124),
(126018,'enUS','','Actually, one more thing. Plant some explosives around for a little extra \"boom\".',26124),
(126019,'enUS','','Alright, the job\'s almost complete. Just get out of the cave and light the powder with the match Tethys gave you.',26124),
(126020,'enUS','I\'m ready to travel to the Eye of Eternity.','I\'m ready to travel to the Eye of Eternity.',26124),
(126021,'enUS','','Hold on... that drunken buffoon forgot, didn\'t he? You better find a way to light this powder, $ct. I will not let this mission fail!',26124),
(126022,'enUS','','Alright, use the rappel point. Down you go!',26124),
(126023,'enUS','Champion, mages of the Tirisgarde need your help to purge the spider broods from the Creeping Grotto. Their pyromancers could provide you with a burning edge.','',26124),
(126024,'enUS','Well, that became a combustible situation, but you handled the heat expertly.','',26124),
(126025,'enUS','','No time to waste, Shadowblade. Let\'s move.',26124),
(126026,'enUS','','Today, we celebrate de anniversary of de ringin\' of de Scarab Gong. You\'ll see all sorts a festivities \'round Silithus today.$b$bPart of de tradition involves summonin\' de colossal insects from de three silithid hives. To do that, we need meat. Heaps a meat.$b$bCan ya help?',26124),
(126027,'enUS','Throm-ka! The Horde has taken the lead!','',26124),
(126028,'enUS','We have taken the lead! For the Alliance!','',26124),
(126029,'enUS','I found a beast able to survive the fel infusion.','',26124),
(126030,'enUS','With an army of these creatures boring into the rock, I will bury Thunder Totem!','',26124),
(126031,'enUS','A pity you won\'t be around to see it. Die!','',26124),
(126032,'enUS','Free! Let me just--','',26124),
(126033,'enUS','','With our forces combined, the Burning Legion shall fall!',26124),
(126034,'enUS','','Tales shall be told, and songs sung, of the glory that awaits us this day.',26124),
(126035,'enUS','We\'ll go make sure all the demons are truly defeated. When you have time, meet us back in the Hall of Shadows for a briefing.','',26124),
(126036,'enUS','Your words carry the tone of your bravery, $n. Be safe.','Your words carry the tone of your bravery, $n. Be safe.',26124),
(126037,'enUS','Thank you. I appreciate your help.','Thank you. I appreciate your help.',26124),
(126038,'enUS','I\'ll be alright, but you must tend to the others!','I\'ll be alright, but you must tend to the others!',26124),
(126039,'enUS','The Legion! You must warn the others!','The Legion! You must warn the others!',26124),
(126040,'enUS','Your words ring true, brave $c. We must stand together!','Your words ring true, brave $c. We must stand together!',26124),
(126041,'enUS','','Fine! I will finish you myself!',26124),
(126042,'enUS','Greetings $n. Is there something I can assist you with?','',26124),
(126043,'enUS','I\'m looking for Antonidas\' arcane disc piece. Do you have it?','I\'m looking for Antonidas\' arcane disc piece. Do you have it?',26124),
(126044,'enUS','Battlelord $n! It is good you found me.','',26124),
(126045,'enUS','','I haven\'t thought of that since... well since an old friend asked about it shortly before he was taken from this world.',26124),
(126046,'enUS','','After Antonidas died, I decided to hide the disc away. There was no reason to continue my research into it.',26124),
(126047,'enUS','','But if you think you can finish what Antonidas started, then the piece is yours. Good luck with it, Archmage $n.',26124),
(126048,'enUS','$n! We\'ve lost quite a few to their attacks already! Any help you can give will allow us to hold Thunder Totem as best we can!','$n! We\'ve lost quite a few to their attacks already! Any help you can give will allow us to hold Thunder Totem as best we can!',26124),
(126049,'enUS','Be careful! The Legion is relentless in their assaults.','Be careful! The Legion is relentless in their assaults.',26124),
(126050,'enUS','If you can fight, rally and help defend Thunder Totem! We must not give in!','If you can fight, rally and help defend Thunder Totem! We must not give in!',26124),
(126051,'enUS','We will not allow these demons to defile our home!','We will not allow these demons to defile our home!',26124),
(126052,'enUS','$n! Have you been out there? We\'re holding the demons back as best we can!','$n! Have you been out there? We\'re holding the demons back as best we can!',26124),
(126053,'enUS','','It seems you were right, outsider. Thank you for helping me find my path.',26124),
(126054,'enUS','','I will always remember your deeds. One day, so too will the Tideskorn.',26124),
(126055,'enUS','Khadgar, I\'m looking for a piece of a disc that Antonidas gave you a long time ago.','Khadgar, I\'m looking for a piece of a disc that Antonidas gave you a long time ago.',26124),
(126056,'enUS','You\'re speaking of the Tri-Disc of Fire. Yes, he gave it to me, but that was a long time ago. Back when I was still studying at Karazhan.','',26124),
(126057,'enUS','I was working with Archmage Alturus on it at the time. He may still know where it resides. You\'ll find him just outside of Karazhan.','',26124),
(126058,'enUS','Conjurer, your Tirisgarde Pyromancers have engaged the endless broods of the Creeping Grotto. Mister Manastorm has offered the use of a customized spell. He says you are \"old friends.\"','',26124),
(126059,'enUS','Archmage Cedric, I\'m looking for a piece of a disc that Antonidas gave to you. Do you happen to have it?','Archmage Cedric, I\'m looking for a piece of a disc that Antonidas gave to you. Do you happen to have it?',26124),
(126060,'enUS','Are your eyebrows still intact? Some of our apprentice mages who attempted that particular spell were not so lucky!','',26124),
(126061,'enUS','Ah, yes. I do. I mean did. Well, it was stolen, you see.','',26124),
(126062,'enUS','By ogres no less. Filthy beasts. They raided our ruins a while back and unfortunately they made off with the disc piece.','',26124),
(126063,'enUS','Not to worry though. I couldn\'t figure out how to help Antonidas with it, so I\'m sure they have no clue what to do with it.','',26124),
(126064,'enUS','But if you\'re looking to retrieve it, I\'m sure it must be somewhere in the Ruins of Alterac where they reside.','',26124),
(126065,'enUS','Now you are a sight for sore eyes, Battlelord $n!','',26124),
(126066,'enUS','','D\'Bynn! Can you hear me? When I am freed, I will kill every last trapper for what they have done to us!',26124),
(126067,'enUS','You\'re doing well, Archmage $p. Remember to gather the smaller emanations into a group so you can assault them with your area-of-effect abilities.','',26124),
(126068,'enUS','This is the final expulsion, Archmage. Remember what the preceding enemies you faced threw at you and you should be prepared for whatever comes next.','',26124),
(126069,'enUS','The manifestations from this disc are trying to slow you down in order to destroy you. Counter their spells and make sure to quickly move away from where their attacks will land.','',26124),
(126070,'enUS','You\'re finally upon the final energy purge of the frost disc. Remember the creatures you\'ve seen so far and use that knowledge to your advantage.','',26124),
(126071,'enUS','These creatures grow in power the longer they stay alive. Burn them down quickly and interrupt what you can to prevent their growth.','',26124),
(126072,'enUS','The final expulsion of power from the arcane disc will most likely mimic what you\'ve already seen. Make sure it doesn\'t grow beyond what you\'re able to destroy.','',26124),
(126073,'enUS','','Stop stalling! Where is your Farseer?!',26124),
(126074,'enUS','','Let\'s go, child. We must save my tribe.',26124),
(126075,'enUS','Skovald\'s kin must perish!','',26124),
(126076,'enUS','Welcome, Archmage $p. I hope you are prepared for what is to come.','',26124),
(126078,'enUS','Do not give in, $n!','Do not give in, $n!',26124),
(126079,'enUS','Hold them back!','Hold them back!',26124),
(126080,'enUS','You must help the others!','You must help the others!',26124),
(126081,'enUS','Hold strong!','Hold strong!',26124),
(126082,'enUS','For Thunder Totem!','For Thunder Totem!',26124),
(126083,'enUS','You want the Doomstone, shaman? Come, take it!','',26124),
(126084,'enUS','You cannot defeat... the Legion...','',26124),
(126085,'enUS','','You head forward from here while I go the opposite way. I will find you afterward.',26124),
(126086,'enUS','','How do you expect to use the power of the Doomstone if you cannot even open your own portal? Foolish child.',26124),
(126087,'enUS','We must deal with this threat quickly.','',26124),
(126088,'enUS','I\'d like the help to the Blind Marshlands.','I\'d like the help to the Blind Marshlands.',26124),
(126089,'enUS','Strike at their defenses, $n. Bring these demons down!','',26124),
(126091,'enUS','Well done, Archmage $p! Purging the disc of excess energy has stopped its violent resonance while in proximity to the other discs. I trust the same will happen with the final two.','',26124),
(126092,'enUS','Maintain your focus, Archmage $p! Only one disc left to disperse. Remember, my apprentices can offer aid.','',26124),
(126093,'enUS','','Do not look upon me as one of your underlings, $r. You are but a child to me.',26124),
(126094,'enUS','','And in this corner... a seagull? What is this, the Eye of Azshara?',26124),
(126095,'enUS','There! You did it! The discs can now align and fuse into one!','',26124),
(126096,'enUS','','Looks like every day is Hallow\'s End for this... thing. Give up some screams for Ooliss!',26124),
(126097,'enUS','','All the way from the gloomy roads of Duskwood, it\'s Stitches!',26124),
(126098,'enUS','','Is that a giant mushroom? Looks like things are about to get weird!',26124),
(126099,'enUS','','Oh, the huge manatee! It\'s here to seal the deal... DOOMFLIPPER!',26124),
(126100,'enUS','','And their challenger, Bill, the custodial engineer of death! Wait... what? Bill! What are you doing in there?',26124),
(126101,'enUS','I\'m not giving you the Doomstone, Magatha.','I\'m not giving you the Doomstone, Magatha.',26124),
(126102,'enUS','','And introducing the draenei obsessed with pet collection, it\'s Ash\'katzuum!',26124),
(126103,'enUS','','In the other corner, a master of both shadows AND interior lighting... it\'s Shadowmaster Aameen!',26124),
(126104,'enUS','','In the other corner, a challenger so ancient no one remembers his actual name. Let\'s call him Serpent of Old!',26124),
(126105,'enUS','','In the other corner... a really big dinosaur!',26124),
(126106,'enUS','','Kindly insert a gold coin for a battle with Master Paku!',26124),
(126107,'enUS','','And in the other corner, it\'s not one, not two, but the THREE deadly dwarves of the Warhammer Council!',26124),
(126108,'enUS','','Also entering the arena... an ugly gnome contraption that makes music.',26124),
(126109,'enUS','','And our other challenger, a worm with a serious fire fetish. Come on, Carl! Don\'t you know flames can kill?',26124),
(126110,'enUS','','And in the other corner, a hunter of incomprehensible spectacular amazing splendor! It\'s Johnny Awesome!',26124),
(126111,'enUS','','And now for the challenger that cost us so much... it\'s Ray D. Tear!',26124),
(126112,'enUS','','Get fired up for the djinn who will literally melt your heart, it\'s Burnstachio!',26124),
(126113,'enUS','','And in the other corner, it\'s that terrible trio... Hudson, Stuffshrew, and Dupree from the Ogrewatch Team!',26124),
(126114,'enUS','','And now for some soul-pounding beats from the musical underground, it\'s Thwack U and his dancers!',26124),
(126115,'enUS','','In the other corner, a pirate with a lethal definition of head cannon! Put your hooks together for Blackmange!',26124),
(126117,'enUS','','You know not what you say. Give it to me!',26124),
(126118,'enUS','I think it safest in Nobundo\'s hands.','I think it safest in Nobundo\'s hands.',26124),
(126119,'enUS','','Spoiled brat! That Doomstone is not leaving my side!',26124),
(126120,'enUS','Then bring me to the Maelstrom, or else I\'ll leave alone with it.','Then bring me to the Maelstrom, or else I\'ll leave alone with it.',26124),
(126121,'enUS','All the way from the gloomy roads of Duskwood, it\'s Stitches!','',26124),
(126122,'enUS','And in this corner... a seagull? What is this, the Eye of Azshara?','',26124),
(126123,'enUS','Is that a giant mushroom? Looks like things are about to get weird!','',26124),
(126124,'enUS','Oh, the huge manatee! It\'s here to seal the deal... DOOMFLIPPER!','',26124),
(126125,'enUS','Looks like every day is Hallow\'s End for this... thing. Give up some screams for Ooliss!','',26124),
(126126,'enUS','And their challenger, Bill, the custodial engineer of death! Wait... what? Bill! What are you doing in there?','',26124),
(126127,'enUS','And introducing the draenei obsessed with pet collection, it\'s Ash\'katzuum!','',26124),
(126128,'enUS','In the other corner, a master of both shadows AND interior lighting... it\'s Shadowmaster Aameen!','',26124),
(126129,'enUS','In the other corner, a challenger so ancient no one remembers his actual name. Let\'s call him Serpent of Old!','',26124),
(126130,'enUS','In the other corner... a really big dinosaur!','',26124),
(126131,'enUS','Kindly insert a gold coin for a battle with Master Paku!','',26124),
(126132,'enUS','And in the other corner, it\'s not one, not two, but the THREE deadly dwarves of the Warhammer Council!','',26124),
(126133,'enUS','Also entering the arena... a handsome machine that makes beautiful music.','',26124),
(126134,'enUS','And our other challenger, a worm with a serious fire fetish. Come on, Carl! Don\'t you know flames can kill?','',26124),
(126135,'enUS','And in the other corner, a hunter of incomprehensible spectacular amazing splendor! It\'s Johnny Awesome!','',26124),
(126136,'enUS','And now for the challenger that cost us so much... it\'s Ray D. Tear!','',26124),
(126137,'enUS','Get fired up for the djinn who will literally melt your heart, it\'s Burnstachio!','',26124),
(126138,'enUS','And in the other corner, it\'s that terrible trio... Hudson, Stuffshrew, and Dupree from the Ogrewatch Team!','',26124),
(126139,'enUS','And now for some soul-pounding beats from the musical underground, it\'s Thwack U and his dancers!','',26124),
(126140,'enUS','In the other corner, a pirate with a lethal definition of head cannon! Put your hooks together for Blackmange!','',26124),
(126141,'enUS','Gurr not sure how use tiny anvil.\n\n<The Mo\'arg Brute stares down at his feet.>','',26124),
(126142,'enUS','Repair my armor, Gurr.','Repair my armor, Gurr.',26124),
(126143,'enUS','Squish you!','',26124),
(126144,'enUS','Stomp on your bones!','',26124),
(126145,'enUS','Your life for the Legion!','',26124),
(126146,'enUS','More meat for the fire!','',26124),
(126147,'enUS','','Thank ye, if I wasn\'t chained up I would have given that ugly brute a beating myself!',26124),
(126148,'enUS','','Thank you, small one.',26124),
(126149,'enUS','','Hey! Help me out of these shackles!',26124),
(126150,'enUS','Your defiance is futile! You will join us or I shall wear your flayed skin for a cloak!','',26124),
(126151,'enUS','','I\'ve seen what your so-called \"gift\" does, demon. I\'ll never join your kind!',26124),
(126152,'enUS','I did not know him well, but I have no doubt that Antonidas would be proud of what you have accomplished this day, Archmage $p.','',26124),
(126153,'enUS','If you wish, I can return you to the Hall of the Guardian.','',26124),
(126154,'enUS','You\'re letting this monster into our sacred space?? She murdered our chieftain!','',26124),
(126155,'enUS','','Put it to rest, you buffoon. There is more at stake here than your pathetic chieftain!',26124),
(126156,'enUS','Pathetic?! Farseer, kick her out! I will not stand for this!','',26124),
(126157,'enUS','I know it is infuriating for you and the other tauren to see her here, Muln.','',26124),
(126158,'enUS','But it is more of a liability to have her out in the world. It is better if we keep an eye on her.','',26124),
(126159,'enUS','She shall not have free reign here, I assure you.','',26124),
(126160,'enUS','She made a few snide comments regarding our vigilance and then left on her own. I haven\'t seen her since.','',26124),
(126161,'enUS','More... I must have more souls!','',26124),
(126162,'enUS','Muln spits at Magatha\'s feet in disgust.','',26124),
(126163,'enUS','More souls to fuel the fel! I must have more!','',26124),
(126164,'enUS','','Ah, Sslayer $n. Since you are here, you may as well lend a hand.',26124),
(126165,'enUS','','I could have taken him... eventually. My thankss.',26124),
(126166,'enUS','Scour the land! Leave not a single mortal to remain! All their souls shall be mine!','',26124),
(126167,'enUS','Dedication to your holy Paladin order demands that you purify this fel taint.','Dedication to your holy Paladin order demands that you purify this fel taint.',26124),
(126168,'enUS','This orb is unnatural to Priests and must be destroyed.','This orb is unnatural to Priests and must be destroyed.',26124),
(126169,'enUS','As a Warlock, minor fel magic such as this presents no danger to you. Absorb the power of the Infernal Tome.','As a Warlock, minor fel magic such as this presents no danger to you. Absorb the power of the Infernal Tome.',26124),
(126170,'enUS','Demon Hunter training has long prepared you for this. Grasp the power from within the Infernal Tome.','Demon Hunter training has long prepared you for this. Grasp the power from within the Infernal Tome.',26124),
(126171,'enUS','$n absorbs the magic from the Infernal Tome, granting everyone damage reduction!','$n absorbs the magic from the Infernal Tome, granting everyone damage reduction!',26124),
(126172,'enUS','Wretched mortal! What have you done to my ship?!','',26124),
(126173,'enUS','No matter! You will pay for this... I WILL DEVOUR YOUR SOUL!','',26124),
(126174,'enUS','$n destroys the Fel Orb, granting everyone increased critical strike chance!','$n destroys the Fel Orb, granting everyone increased critical strike chance!',26124),
(126175,'enUS','$n purifies the Fel Orb, granting everyone increased critical strike chance!','$n purifies the Fel Orb, granting everyone increased critical strike chance!',26124),
(126176,'enUS','As a Druid, you recognize the plants and materials that went into this food. It should be safe to eat.','As a Druid, you recognize the plants and materials that went into this food. It should be safe to eat.',26124),
(126177,'enUS','Herbalism has taught you much about natural foodstuffs. This is definitely edible!','Herbalism has taught you much about natural foodstuffs. This is definitely edible!',26124),
(126178,'enUS','','I am glad you honored our pact, Sslayer $n. Perhapss I misjudged you.',26124),
(126179,'enUS','As a pandaren, you recognize this edible flower. Time to stuff it in your face!','As a pandaren, you recognize this edible flower. Time to stuff it in your face!',26124),
(126180,'enUS','Years of training in Cooking allows you to recognize this strange flower. It is safe and can even benefit your friends!','Years of training in Cooking allows you to recognize this strange flower. It is safe and can even benefit your friends!',26124),
(126181,'enUS','Why did you leave the others?','Why did you leave the others?',26124),
(126182,'enUS','','I was stir-crazy after so many months aboard that sstinking ship. Besides, the situation required someone with my skills...\n\nPerhapss I should have cloned myself first.',26124),
(126183,'enUS','','Ssee you back there.',26124),
(126184,'enUS','','You are a disgrace, Lexera! You swore an oath to protect our city.',26124),
(126185,'enUS','','You will pay for your treachery with your life!',26124),
(126186,'enUS','','Did Syrenne send you? Has she really sided with an outsider over her own people?',26124),
(126187,'enUS','May I have your attention please. This ship is about to Self-Destruct. Please exit this ship at your soonest convenience.','',26124),
(126188,'enUS','','She will find that she has chosen poorly. Our true ally is the Burning Legion!',26124),
(126189,'enUS','My computer! How... how did you guess my password?! It had many symbols and capitalized letters!','',26124),
(126190,'enUS','Interrupting my feast was a fatal mistake, mortal!','',26124),
(126191,'enUS','Battlelord! There are remaining Felskorn unaware their God-King has fallen. Go, earn my favor by sending these upstarts to join their former master.','',26124),
(126192,'enUS','For the Valarjar!','',26124),
(126193,'enUS','There remain Felskorn unaware their God-King has fallen. Join my Valarjar in glorious battle and dispatch these fools to meet their fallen leader!','',26124),
(126194,'enUS','You show exceptional prowess in battle. A pity you were not born a warrior! But I suppose no mortal is without flaws.','',26124),
(126195,'enUS','Send me to the Broken Shore!','Send me to the Broken Shore!',26124),
(126196,'enUS','','Your persistence is annoying! My beloved imps, protect me!',26124),
(126197,'enUS','','You chase me too far, $n. My precious imps will make you suffer more than you can imagine.',26124),
(126198,'enUS','','Why does it always have to be demonsss?',26124),
(126199,'enUS','','It figuress I\'d be sent here.',26124),
(126200,'enUS','','Grey rockss and green fire. Again.',26124),
(126201,'enUS','','Why yes, I DO lack a crown. Thank you for noticing.\n\n<The emissary smiles at you cheerily.>',26124),
(126202,'enUS','Where are the others?','Where are the others?',26124),
(126203,'enUS','','Oh, you know...\n\nThey\'re around.\n\nOff you go!',26124),
(126204,'enUS','Thank Odyn, I thought I was done for!','',26124),
(126205,'enUS','May the doors of Valhallas open for you.','',26124),
(126206,'enUS','Odyn bless you.','',26124),
(126207,'enUS','Sweet freedom!','',26124),
(126208,'enUS','<Recall the demise of Gul\'dan>','<Recall the demise of Gul\'dan>',26124),
(126209,'enUS','','It appears Kruul\'s lackeys were just here.',26124),
(126214,'enUS','We must free this land of the Legion\'s corruption!','',26124),
(126215,'enUS','I will face Zen\'dral. Bring me up!','I will face Zen\'dral. Bring me up!',26124),
(126216,'enUS','With your leadership and our Storm Brew, we will prevail!','',26124),
(126217,'enUS','','I am so, so weary. Yet, I cannot rest until I am certain that our order will survive.',26124),
(126218,'enUS','Today, we celebrate the anniversary of the ringing of the Scarab Gong. You\'ll see plenty of festivities around Silithus today.$b$bPart of the tradition involves summoning those colossal insects from the three silithid hives. To do that, we\'ll need meat. Giant piles of meat.$b$bCan you help?','',26124),
(126219,'enUS','The Burning Legion closes in on Azeroth. We must all do our part.','',26124),
(126220,'enUS','I need you to convince the other orders to join us against the Legion. We must come together as one!','I need you to convince the other orders to join us against the Legion. We must come together as one!',26124),
(126221,'enUS','I am honored to be chosen for this mission. I will not fail you, Grandmaster $n.','',26124),
(126222,'enUS','','High Priest! I got important information for ye.',26124),
(126223,'enUS','I borrowed a small submarine from friends o\' mine in the Explorers\' League. We\'ll be embarkin\' off the coast o\' Azsuna as soon as ye can join us, High Priest.','',26124),
(126224,'enUS','','Sea\'s calm so far, even this close to the Maelstrom.',26124),
(126225,'enUS','So, brother... the planet, Azeroth, she just sorta... told ye to come here?','',26124),
(126226,'enUS','Not so much in words. \'Tis more... feelin\'s... but not like feelin\'s ye or I would have.','',26124),
(126227,'enUS','','Now what does that even mean?',26124),
(126228,'enUS','Well, let\'s say ye\'re a world soul, eh? What sorta feelin\'s do ye suppose ye\'d have? Sometimes ye feel like a crumblin\' mountain range, an\' sometimes ye feel like a deep, dark sea. I dunno exactly how ta\' describe it.','',26124),
(126229,'enUS','So... she sorta \'felt\' at ye, that ye should come here?','',26124),
(126230,'enUS','It felt... like a sunrise.','',26124),
(126231,'enUS','','We\'re coming up ta what appears ta be the vault entrance.',26124),
(126232,'enUS','Commencin\' dockin\' procedures.','',26124),
(126233,'enUS','Whoa, that\'s a large door! Gotta be a lever around here somewhere, though. There\'s always a lever!','',26124),
(126234,'enUS','Revola ruk maez amir.','',26124),
(126235,'enUS','','Well, I suppose ye don\'t need ta be lookin\' fer levers and switches n\'more, Brann!',26124),
(126236,'enUS','Bit of a shame, that.','',26124),
(126237,'enUS','They must be activated simultaneously. High Priest, would ye do the honors?','',26124),
(126238,'enUS','Systems active. Visitors detected.','',26124),
(126239,'enUS','Life form scan in progress.','',26124),
(126240,'enUS','Oh, I know sure enough what this is gonna lead to! Weapons up!','',26124),
(126241,'enUS','No essential life forms detected. Resuming scan.','',26124),
(126242,'enUS','Now what do ye mean by that? Not essential? Me? You\'re \'not essential,\' ye wee little...','',26124),
(126243,'enUS','Speaker status verified. Welcome, Speaker. Have you come to retrieve the seekers?','',26124),
(126244,'enUS','Seekers... yes, that must be what she meant when she directed me ta this place. She wanted us to find these creatures.','',26124),
(126245,'enUS','','Uh, Mister Custodian, what in the name o\' the Forge is a Seeker?',26124),
(126246,'enUS','Allow me to show you.','',26124),
(126247,'enUS','Designation: Seeker. Feral creatures infused with the Light by the Shapers. The finest specimens were selected from herds and trained to serve the watchers, speeding them to sites of corruption in accordance with containment protocols.','',26124),
(126248,'enUS','Herds, ye say? We\'ve never seen a one! How many of \'em remain?','',26124),
(126249,'enUS','Accessing... Current count of known Seekers: three.','',26124),
(126250,'enUS','','Only the three here, then?',26124),
(126251,'enUS','So, what happened to \'em?','',26124),
(126252,'enUS','Invasive corruptive entities have bombarded this planet since its shaping. Attrition due to combat fatalities gradually reduced the numbers of Seekers. Now, only these are known to remain.','',26124),
(126253,'enUS','These noble creatures protected us before we even knew how ta protect ourselves...','',26124),
(126254,'enUS','Alert! Void energies detected. Initiating sanitation protocol.','',26124),
(126255,'enUS','Oh blazes! Not again!','',26124),
(126256,'enUS','Again? Ye\'ve done this before, brother?','',26124),
(126257,'enUS','More than once! Yer the big important Speaker. Can ye shut it off, then?','',26124),
(126258,'enUS','Err... Stop it, then, will ye?','',26124),
(126259,'enUS','Unable to comply. Sanitation protocol cannot be aborted. Visitors may be in a corrupted state. If you are hearing whispers of unknown origin, please step directly into the searing light.','',26124),
(126260,'enUS','Lotta good that did! Well, here we go!','',26124),
(126261,'enUS','','Spawns o\' Light, barely of this world. A good dispel should dissipate \'em.',26124),
(126262,'enUS','I sense some corruption amongst my brethren. Watch yerself fer purification.','',26124),
(126263,'enUS','O\' course the big ones would come ta life, too. Watch yerselves!','',26124),
(126264,'enUS','An\' that\'s the last of em\'.  Gonna hope that\'s the last time I end up in this situation...','',26124),
(126265,'enUS','','Hmm, the custodian be powerin\' down. Might be this chamber expended all its energy.',26124),
(126266,'enUS','','No one\'s left ta look after these poor creatures!',26124),
(126267,'enUS','Yer wrong about that, lass. \'Tis why Azeroth called me... called us... here.','',26124),
(126268,'enUS','She knew it wouldn\'t be long before the void o\'ertook this chamber. She knew who would protect these creatures an\' use \'em in service of the Light.','',26124),
(126269,'enUS','\'Tis ye, High Priest.','',26124),
(126270,'enUS','','Agreed. High Priest, give us time ta scribe \'em into the annals o\' the Light. We\'ll meet up at Netherlight Temple.',26124),
(126271,'enUS','On this day, many years ago, a hero by the name of Kalahad rang the Scarab Gong, opening the gates to Ahn\'Qiraj and beginning a war the likes of which Kalimdor had never seen.$b$bToday, we celebrate the heroics of those past adventurers by returning to Silithus and walking in their footsteps.$b$bWhat\'s more: this is a competition between the Horde and Alliance. Whichever group can earn more credits over the next 24 hours earns the right to fly their flag next to the gong for the rest of the year.','',26124),
(126272,'enUS','Disrupt the Twilight\'s Hammer camps, and strike at their Abyssal High Council!\n\nSlay the mighty silithid colossi that dwell in each of the three large silithid hives.\n\nGather silithyst, a valuable red spice, for our faction.\n\nVenture into Ahn\'Qiraj itself and deal with the qiraji and old god menaces that dwell inside!\n\nEven adventurers that prefer not to fight can participate by donating war supplies, in the form of meat, to our cause.','',26124),
(126273,'enUS','Yes, both the Medallion of Station and the Ring of Lordship are expensive - far too expensive for any one person to purchase on their own.$b$bI suggest you team up with other adventurers and select a champion. Only one medallion or ring is required to summon the high-ranking members of the Abyssal Council - but many heroes will be required to defeat them.$b$bGood luck.','',26124),
(126274,'enUS','How can I help the war effort?','How can I help the war effort?',26124),
(126275,'enUS','Why are the items you sell so expensive?','Why are the items you sell so expensive?',26124),
(126276,'enUS','','The Feltotem capture my people, seeking to conscript them into their ranks. This evil must be stopped!',26124),
(126277,'enUS','We are endless! Our sight reaches far beyond your miserable world.','',26124),
(126278,'enUS','This is only... the beginning...','',26124),
(126279,'enUS','Meet me outside at once! It is time to sever the Legion\'s tendrils and free Azsuna!','',26124),
(126280,'enUS','Heroes don\'t die, they revive!','',26124),
(126281,'enUS','I deserved that.','',26124),
(126282,'enUS','I\'m ready to bring down the power source.','I\'m ready to bring down the power source.',26124),
(126283,'enUS','The Legion\'s power wanes. We must end this now!','',26124),
(126284,'enUS','This tree still has plenty of useable heartwood!','This tree still has plenty of useable heartwood!',26124),
(126285,'enUS','This wood may look terrible, but its magic is still strong enough for our uses!','This wood may look terrible, but its magic is still strong enough for our uses!',26124),
(126286,'enUS','Enough! I have little time for games!','',26124),
(126287,'enUS','You succeeded in destroying my ship, but this victory shall be your last!','',26124),
(126288,'enUS','I will enjoy watching you burn. Farewell, mortal!','',26124),
(126289,'enUS','Who dares interrupt my feast?','',26124),
(126290,'enUS','|TInterface\\Icons\\ABILITY_WARLOCK_BURNINGEMBERSGREEN:20|t%s targets you with a |cFFFF0000|Hspell:232249|h[Fel Comet]|h|r!','',26124),
(126291,'enUS','|TInterface\\Icons\\SPELL_SHADOW_SUMMONINFERNAL:20|t%s targets you with |cFFFF0000|Hspell:233272|h[Shattering Star]|h|r! Hide!','',26124),
(126292,'enUS','|TInterface\\Icons\\SPELL_FIRE_FELIMMOLATION:20|t%s starts casting |cFFFF0000|Hspell:233062|h[Infernal Burning]|h|r. Hide!','',26124),
(126293,'enUS','','A lost titan vault... kept in immaculate condition? This be one fer the record books! What d\'ye suppose be in these bubbles, eh?',26124),
(126294,'enUS','Delicious souls! I must have more!','',26124),
(126295,'enUS','Channel my power through the Doomstone and destroy those fel spreaders!','',26124),
(126296,'enUS','Smolderon has requested your assistance up on the ridge, Farseer.','',26124),
(126297,'enUS','Harness my wrath, Farseer! Melt the Legion with the might of the Firelord!','',26124),
(126298,'enUS','Therazane needs help with a nearby cave. Go with haste!','',26124),
(126299,'enUS','','I would join you, but it is a cave sized for fleshlings. Channel my power through your Doomstone and crush our enemies!',26124),
(126300,'enUS','','One last request for aid, fleshling. Thunderaan requires your assistance.',26124),
(126301,'enUS','Let me know when you need to get up to the Doomguard, Farseer. I will channel my energy through your Doomstone.','',26124),
(126302,'enUS','','Perhaps that can be arranged. Grandmaster $n, you aren\'t looking so good. You should return to the Peak of Serenity!',26124),
(126303,'enUS','We think the lost titan vault lies just northeast of the Maelstrom. Shouldn\'t take us long to find out.\n\nAre ye ready, High Priest?','',26124),
(126304,'enUS','I am ready to head to the Maelstrom.','I am ready to head to the Maelstrom.',26124),
(126305,'enUS','Take me to the Broken Shore.','Take me to the Broken Shore.',26124),
(126306,'enUS','Anything you say, snookums!','',26124),
(126307,'enUS','','Galius my dear, these intruders are interrupting our alone time! DEAL WITH THEM!',26124),
(126308,'enUS','Yes dear, I won\'t let them ruin our date night!','',26124),
(126309,'enUS','Ugh!','',26124),
(126310,'enUS','What is that trinket you carry, puny shaman? You dare to face me with a stone?','',26124),
(126311,'enUS','','Good help is so hard to find. I\'ll just have to get... physical.',26124),
(126312,'enUS','A wall of flames! Grraaahhh! You go stop Tugar. I\'ll join you when I can!','',26124),
(126313,'enUS','What is happening?! You... cannot... defeat me!','',26124),
(126314,'enUS','Farseer! Stand down! You are tearing the elemental planes apart!','',26124),
(126315,'enUS','Control yourself, before you unleash destruction!','',26124),
(126316,'enUS','','Your disparate tribes are no match for our endless army!',26124),
(126317,'enUS','','Rally our allies! Fight for Thunder Totem! We will prevail!',26124),
(126319,'enUS','Fool! You only located me because I wanted to be found! Now I shall have vengeance on Thunder Totem... and you!','',26124),
(126320,'enUS','You merely delay the inevitable! My fel beasts are even stronger now!','',26124),
(126321,'enUS','I\'ll leave it to you how you wish to go about obtaining the final components for the cleansing ritual.$b$bPerhaps you can also determine what\'s been rousing the undead in this light-forsaken place.','',26124),
(126324,'enUS','Your efforts are futile. Follow me and see why...','',26124),
(126325,'enUS','I hope yer reeaaaddy to get crushed, $rt! I\'ve starved this bear fer a week, and he\'s gonna eat ye alive!','',26124),
(126326,'enUS','Behold my greatest creation! With the Legion\'s power behind me, Thunder Totem will be destroyed!','',26124),
(126327,'enUS','This changes... nothing. The Legion... will prevail...','',26124),
(126328,'enUS','I\'m here! I\'m ready to-- What\'s this? Tugar has fallen! You had all the fun without me!','',26124),
(126329,'enUS','With Tugar gone, the Feltotem should present less of a threat.','',26124),
(126330,'enUS','Even so, I will keep an eye on those treacherous fiends until their Legion masters are defeated.','',26124),
(126331,'enUS','Your Kirin Tor have given me one of their portal crystals. No doubt they will be pleased to hear of your success. Many thanks, $n. We will meet again.','',26124),
(126332,'enUS','You were a fool to follow me, brother. The Twisting Nether feeds my strength. I have become more powerful than you could ever imagine!','',26124),
(126333,'enUS','I cannot let you unleash your power upon Azeroth, Raest. If you do not yield, I will be forced to destroy you!','',26124),
(126334,'enUS','Destroy me?! No, brother. Your blade will become my instrument!','',26124),
(126335,'enUS','What?! What are you doing? Nooo!','',26124),
(126336,'enUS','Kill this interloper, brother!','',26124),
(126337,'enUS','I... obey.','',26124),
(126347,'enUS','These vermin harvest ore for their furnaces. Every scrap we wrest from their hands is one less blade turned against our forces.','',26124),
(126348,'enUS','You have hindered the Legion\'s war production, if only briefly. Every victory counts on this dark shore.','',26124),
(126352,'enUS','','I\'m here to aid and advise you on the indirect threats that the Legion poses. These missions will be extremely difficult, please be prepared.$b$bWe will require Nethershards to either breach their defenses or provide you with defenses to weather their horrific attacks. I will have some to spare occasionally, but not always. Please prepare accordingly.',26124),
(126354,'enUS','I\'m ready to face Tugar Bloodtotem. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','I\'m ready to face Tugar Bloodtotem. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',26124),
(126355,'enUS','','With you as our leader, the Council of Black Harvest will know greater power than ever before.',26124),
(126356,'enUS','I am ready to be summoned.','I am ready to be summoned.',26124),
(126357,'enUS','I need your shield!','I need your shield!',26124),
(126358,'enUS','I need your steel!','I need your steel!',26124),
(126359,'enUS','I need your support!','I need your support!',26124),
(126360,'enUS','Inside the temple--quickly! Find the demon orchestrating this offensive and usher in its end.','',26124),
(126361,'enUS','The Doomstone is far too unstable. We must put it away, keep it in the Maelstrom away from all else. Bring it to Nobundo; he will take care of it.','',26124),
(126362,'enUS','','Let me at \'em!',26124),
(126363,'enUS','','Let\'s do some damage!',26124),
(126364,'enUS','','I\'m feeling stabby!',26124),
(126365,'enUS','','Check out these claws!',26124),
(126366,'enUS','','I need to fall back. Keep going!',26124),
(126367,'enUS','','I... gotta take a breather.',26124),
(126368,'enUS','Galius faints.','',26124),
(126369,'enUS','','Argh! That hurts!',26124),
(126370,'enUS','','There\'s more where that came from!',26124),
(126371,'enUS','','Feels good to get my talons dirty!',26124),
(126372,'enUS','','Ha! You\'ve got nothing on us!',26124),
(126373,'enUS','','Get out of here!',26124),
(126374,'enUS','','I\'ve got your back, Archdruid!',26124),
(126375,'enUS','','Taste my talons!',26124),
(126376,'enUS','Not so fast...','',26124),
(126377,'enUS','Variss, dispose of this rabble.','',26124),
(126378,'enUS','With pleasure, my lord.','',26124),
(126379,'enUS','Oh my head... wha... what happened?','',26124),
(126380,'enUS','This... this had nothing to do with me! Galius Miremoore would never be hypnotized by a single succubus!','',26124),
(126381,'enUS','','I\'m on it!',26124),
(126382,'enUS','','Time to put you down!',26124),
(126383,'enUS','','Meet my dagger!',26124),
(126384,'enUS','','Don\'t worry, you\'ll be dead soon.',26124),
(126385,'enUS','','Finish the job!',26124),
(126386,'enUS','','Keep going!',26124),
(126387,'enUS','','I\'m falling back!',26124),
(126388,'enUS','','Never cross a princess with a dagger.',26124),
(126389,'enUS','','Oh, it seems you\'re dead.',26124),
(126390,'enUS','','Not even a challenge.',26124),
(126391,'enUS','','Seems you could use my help.',26124),
(126392,'enUS','','Do you need a little more subtlety?',26124),
(126393,'enUS','','Get stabbin\' or get goin\'!',26124),
(126394,'enUS','I... uh... really must be going! Bye!','',26124),
(126395,'enUS','','End it now!',26124),
(126396,'enUS','','I emerge from the shadows.',26124),
(126397,'enUS','','Now who\'s doing the rescuing?',26124),
(126398,'enUS','','I\'ve trained for this!',26124),
(126399,'enUS','','Do you like my blade in your back!?',26124),
(126400,'enUS','','To bones and ashes!',26124),
(126401,'enUS','','Everyone\'s alone when they\'re dead!',26124),
(126402,'enUS','','Allow me to escort you to your end.',26124),
(126403,'enUS','','You cannot match my skill!',26124),
(126404,'enUS','','Time to die!',26124),
(126405,'enUS','','Leave me...',26124),
(126406,'enUS','','Go on without me!',26124),
(126407,'enUS','','Don\'t worry... I\'ll heal.',26124),
(126408,'enUS','No! I was promised!','No! I was promised!',26124),
(126409,'enUS','I will be denied no longer!','I will be denied no longer!',26124),
(126410,'enUS','Mistress, grant me your strength!','Mistress, grant me your strength!',26124),
(126411,'enUS','You are no match for this power!','You are no match for this power!',26124),
(126412,'enUS','','Let the blood flow!',26124),
(126413,'enUS','','Welcome to the grave!',26124),
(126414,'enUS','','Ah, yes. The sweet scent of death.',26124),
(126415,'enUS','','Time to die!',26124),
(126416,'enUS','','Death awaits!',26124),
(126417,'enUS','','Time to send our foe to the gallows!',26124),
(126418,'enUS','','Think I\'d let you have all the fun?',26124),
(126419,'enUS','','Time to play!',26124),
(126420,'enUS','','My axe grew hungry!',26124),
(126421,'enUS','Hail, Highlord. I am at your service.','',26124),
(126422,'enUS','','The grave is calling me back...',26124),
(126423,'enUS','','Mind taking care of that for me?',26124),
(126424,'enUS','','Go ahead... I\'ll catch up.',26124),
(126425,'enUS','Let us cast light upon this unholy place.$b$bHow may I assist you?','',26124),
(126426,'enUS','The forces within this forsaken city can only hide in the shadows for so long.$b$bI await your command.','',26124),
(126427,'enUS','','In the mood for some killing?',26124),
(126428,'enUS','Which paladin would you like to remove from your ranks?','',26124),
(126429,'enUS','','Do exactly as I say, child.',26124),
(126430,'enUS','Fiona Stormwell','Fiona Stormwell',26124),
(126431,'enUS','Vindicator Dran\'aan','Vindicator Dran\'aan',26124),
(126432,'enUS','Vindicator Edhri','Vindicator Edhri',26124),
(126433,'enUS','Kralgon Lightbeard','Kralgon Lightbeard',26124),
(126434,'enUS','Phillip Stormwell','Phillip Stormwell',26124),
(126435,'enUS','Thelsia Oakthorn','Thelsia Oakthorn',26124),
(126436,'enUS','','I do not suffer fools gladly.',26124),
(126437,'enUS','','Didn\'t even break a sweat.',26124),
(126438,'enUS','','No match for the elements!',26124),
(126439,'enUS','','You were a fool to cross paths with me!',26124),
(126440,'enUS','','I\'ll barely lift a finger to destroy you!',26124),
(126441,'enUS','','Feel the fury of the Grimtotem!',26124),
(126442,'enUS','','These old bones need a rest.',26124),
(126443,'enUS','','I need to... catch my breath.',26124),
(126444,'enUS','','I must visit the healing waters.',26124),
(126445,'enUS','','Did you think you could do this alone?',26124),
(126446,'enUS','','I have little time for foolishness!',26124),
(126447,'enUS','','Need me to poison your blade?',26124),
(126448,'enUS','','Galius my dear, you should cast the spell I taught you. AND DON\'T SCREW IT UP!',26124),
(126449,'enUS','Brother... why?','',26124),
(126450,'enUS','I\'m... defeated?  That\'s... impossible...','',26124),
(126451,'enUS','','Hail, Highlord. I am at your service.',26124),
(126452,'enUS','','Let us cast light upon this unholy place.$b$bHow may I assist you?',26124),
(126453,'enUS','','The forces within this forsaken city can only hide in the shadows for so long.$b$bI await your command.',26124),
(126454,'enUS','','Which paladin would you like to remove from your ranks?',26124),
(126459,'enUS','Are ye ready to leave, High Priest? Just gimme the word an\' I\'ll point the sub back towards Dalaran.','',26124),
(126460,'enUS','I am ready to head back to Dalaran.','I am ready to head back to Dalaran.',26124),
(126461,'enUS','I can take ye back whenever yer ready, High Priest.','',26124),
(126462,'enUS','We\'re not done yet!','',26124),
(126463,'enUS','','By my troth, this\'ll be the last time I go adventurin\' with a Bronzebeard!',26124),
(126464,'enUS','Many\'ll come this time. The machine surges with the Light.','',26124),
(126465,'enUS','It pains me to see this ancient land tainted by such pestilent creatures. Stop them before they spread!','',26124),
(126466,'enUS','Well done, hero! Our druids will see to the rest of this menace.','',26124),
(126467,'enUS','Least there\'s no giant eye lasers this time, eh?','',26124),
(126468,'enUS','Powerful warlocks serving the Legion have gathered in Felfire Pass. We must stop them and their fanatical master before they grow too strong.','',26124),
(126469,'enUS','The allure of power is great, and many succumb to its call. Those warlocks gave us no choice but to end their sinister threat.','',26124),
(126470,'enUS','We sought to consecrate the ground where Tirion fell, but the Legion pushed us back. Your aid is needed, Highlord.','',26124),
(126471,'enUS','Thanks to your help, we can complete our work and honor Tirion\'s life of sacrifice.','',26124),
(126472,'enUS','Good work. You have bought our forces the reprieve we needed to finish our task.','',26124),
(126473,'enUS','The paladins of the Silver Hand are attempting a holy ritual in Felfire Pass, but the Legion is pushing back. Slay the demon leader so that we may sanctify this place.','',26124),
(126474,'enUS','This is the place. Kill abominations and smash any eggs you find!','',26124),
(126475,'enUS','Break enough eggs, and the monstrosity that laid them will come looking for a fight!','',26124),
(126476,'enUS','Rasean Lightfall','Rasean Lightfall',26124),
(126477,'enUS','Alawa Wisebrace','Alawa Wisebrace',26124),
(126478,'enUS','Guldek Stoneshield','Guldek Stoneshield',26124),
(126479,'enUS','Nalenn Heartreaver','Nalenn Heartreaver',26124),
(126480,'enUS','Melhen Lightfury','Melhen Lightfury',26124),
(126481,'enUS','Tayen Steelhide','Tayen Steelhide',26124),
(126482,'enUS','Shadowblade, the demons are bringing in more hapless refugees from Suramar. You and your gallery of rogues must liberate them before they become fuel for the fel.','',26124),
(126483,'enUS','Every soul snatched from the fel forge weakens our enemy. Well done.','',26124),
(126484,'enUS','The demons are bringing in more hapless refugees from Suramar. Assist the rogues of the Council of Shadows in liberating the prisoners before they become fuel for the fel.','',26124),
(126485,'enUS','Every soul snatched from the fel forge deprives our enemy of fuel for their cause. Well done.','',26124),
(126486,'enUS','Open yer trap so I can fire, Oso!','',26124),
(126487,'enUS','Make it stop! Please, make it stop!','Make it stop! Please, make it stop!',26124),
(126488,'enUS','My... mind... get out of my... mind.','My... mind... get out of my... mind.',26124),
(126489,'enUS','Get...out...of...my...head!','Get...out...of...my...head!',26124),
(126490,'enUS','I don\'t know anything...','I don\'t know anything...',26124),
(126491,'enUS','Why? Why are you doing this?','Why? Why are you doing this?',26124),
(126492,'enUS','Please... let me go. I have a family.','Please... let me go. I have a family.',26124),
(126493,'enUS','I will... never... submit...','I will... never... submit...',26124),
(126494,'enUS','I saw the demon slinking through a portal in all the chaos. Size of two tauren - maybe three!','',26124),
(126495,'enUS','','Oh, the calamity! The destruction! The lack of customer trust! $B$B<Glutonia pauses to make sure you\'re looking.>$B$BMaybe the familiar smell of ten gold coins would jog my memory!$B$BUnmarked, please.',26124),
(126496,'enUS','','I\'ll tell ya what the Legion was after - my bottom line! Legion-grade protection wards ain\'t exactly cheap, sugar!',26124),
(126497,'enUS','You got its attention! Here it comes!','',26124),
(126498,'enUS','You\'ve put a dent in their forces. Focus on the eggs now.','',26124),
(126499,'enUS','The beast that laid those eggs is in the cavern! Check the upper area!','',26124),
(126501,'enUS','To me, heroes! Shield me with the Aegis while I tear this dreadlord from the shadows!','',26124),
(126502,'enUS','The vaults have been breached!','The vaults have been breached!',26124),
(126503,'enUS','Doloria, my love! I have found you at last! Are you safe?','',26124),
(126504,'enUS','','Maximillian? How did you find me here?',26124),
(126505,'enUS','Never fear, my love, we will hunt down these bandits and secure your freedom!','',26124),
(126506,'enUS','Come, Squire! I shall meet you in the mountains that are high.','',26124),
(126507,'enUS','','During our imprisonment, the Kirin Tor locked Kruul\'s heart away in Dalaran\'s vaults to prevent it from falling into Legion hands.',26124),
(126509,'enUS','Eitrigg, I need you to rally the other class orders to form a coalition against the Legion.','Eitrigg, I need you to rally the other class orders to form a coalition against the Legion.',26124),
(126510,'enUS','You are saved, my love! Wait... something\'s not quite right.','',26124),
(126511,'enUS','Horde warriors, move out!','',26124),
(126512,'enUS','Pardon me, good sir, have you seen my Doloria?','',26124),
(126513,'enUS','Hmm, perhaps she\'s behind here...','',26124),
(126514,'enUS','Aha! A clue! No, just some dust.','',26124),
(126519,'enUS','Greetings, Battlelord. You are the strong leader we need in these troubling times.','',26124),
(126520,'enUS','Lord Darius, I need you to rally the other class orders to form a coalition against the Legion.','Lord Darius, I need you to rally the other class orders to form a coalition against the Legion.',26124),
(126521,'enUS','Greetings, Battlelord. You are the strong leader we need in these troubling times.','',26124),
(126522,'enUS','Warriors of the Alliance! We have a job to do!','',26124),
(126523,'enUS','We seem to be having a problem with over-sized eggs... well, not with the eggs per se, but the kraken hatching from the eggs.','',26124),
(126524,'enUS','She and her kvaldir jealously stole away many souls worthy of joining our ranks. They must be freed so they can at last assume their rightful places here in the sky.','',26124),
(126525,'enUS','Normally I\'d let nature take its course... however, I\'d prefer not to fight an army of kraken and the Burning Legion at the same time!','',26124),
(126526,'enUS','','Excellent! I can think of no one better suited to the task. We stand ready to inform you about all known threats.',26124),
(126527,'enUS','Ya must be blinder than a pirate with two eye patches.','',26124),
(126528,'enUS','','Umm, isn\'t that her with the mask? Oh wait, right, yes, no, haven\'t seen her.',26124),
(126529,'enUS','','Hey Doloria, this one\'s looking for ya.',26124),
(126530,'enUS','','Be quiet, Crixa!',26124),
(126531,'enUS','She is nowhere to be found. She must have been taken once more!','',26124),
(126532,'enUS','','In the other corner, a dwarf and his totally loyal companion who would NEVER harm its master. Ever.',26124),
(126533,'enUS','Cooldowns and debuffs have been reset.','',26124),
(126534,'enUS','Good work taking care of those giants! The supplies you\'ve gathered will be a boon to the war effort.','',26124),
(126535,'enUS','In the other corner, a dwarf and his totally loyal companion who would NEVER harm its master. Ever.','',26124),
(126536,'enUS','What?! The gunpowder has been taken by harpies? I must gather my crew and head to Highmountain!','',26124),
(126537,'enUS','Bah! These vrykul think they can steal our gunpowder? They\'ve got another thing coming!','',26124),
(126539,'enUS','','Kruul returns? We must prepare an assault on the demon\'s lair. Karlain, please ensure the Illidari are given all the supplies we can spare.',26124),
(126540,'enUS','','Thank you, $p. You have bought valuable time to deal with this threat.',26124),
(126541,'enUS','Crackers! I thought ye were me matey! Yer breakin\' my heart!','',26124),
(126542,'enUS','These demons will pay for what they have done. This I vow!','',26124),
(126543,'enUS','Send me to the forward camp at once! [Queue for Scenario]','Send me to the forward camp at once! [Queue for Scenario]',26124),
(126544,'enUS','My mistress\' death will be avenged! No foul outlander shall control the kvaldir while I still draw breath!','',26124),
(126545,'enUS','Helya... I failed you...','',26124),
(126546,'enUS','Ahoy, $n. I\'m hopin\' fer a great explosion!','',26124),
(126547,'enUS','What\'s with the hozen?','What\'s with the hozen?',26124),
(126548,'enUS','Ye can\'t find any loyalty in th\' feathered folk. Crackers might\'ve left me shipwrecked, but I can\'t be a successful pirate captain without a proper matey! Nanners is me new partner, and he\'s been right handy!$b$bWho needs a bird, anyway? Nanners is a much more useful crewmate.','',26124),
(126549,'enUS','How may I serve, $ct?','',26124),
(126550,'enUS','Go gather the other class orders. We\'re going to Broken Shore.','Go gather the other class orders. We\'re going to Broken Shore.',26124),
(126551,'enUS','Of course, $ct. We will leave at once.','',26124),
(126552,'enUS','Knights! The $ct needs us! Let\'s fly!','',26124),
(126553,'enUS','You fight with honor, Battlelord $n. I will report to Deliverance Point. See you there.','',26124),
(126554,'enUS','It was an honor to fight alongside you, Battlelord $n. I will report to Deliverance Point. See you there!','',26124),
(126555,'enUS','First they invade our lands. Now the demons darken the skies.','',26124),
(126556,'enUS','The Burning Legion is a plague that sickens the land with its presence. The demons must be purged before their forces spread any further!','',26124),
(126557,'enUS','Valuable supplies were lost beneath the ocean during our first assault. They would come in handy in our fight against the Legion.','',26124),
(126558,'enUS','Unfortunately, sea giants have moved in to claim the goods. Slay the giants and scour the wreckage for our lost supplies.','',26124),
(126559,'enUS','The death of those foul creatures will stoke the fire of the Legion\'s wrath. Make haste to Black Rook Hold. We must press our attack!','',26124),
(126560,'enUS','The Legion opened a portal that is spewing forth a swarm of foul imps. Champion, these tiny fiends must be eradicated!','',26124),
(126561,'enUS','Impressive. Those impudent imposters imperiled important improvements.','',26124),
(126562,'enUS','This always happens! I look the other way for one minute, and your goons have stolen our explosives!','',26124),
(126563,'enUS','Hey, easy there, bub. I only swiped your bombs because you and your munchkin squad swiped ours first!','',26124),
(126564,'enUS','<Gasp!> I can\'t believe you would resort to name-calling. On BOAT DAY, of all days.','',26124),
(126565,'enUS','','Ahoy down there! You sailors want to party?',26124),
(126566,'enUS','ACH! I can\'t believe it!','',26124),
(126567,'enUS','We come all this way to celebrate Boat Day, and ye forgot the dang-blasted ALE!','',26124),
(126568,'enUS','Sorry.','',26124),
(126569,'enUS','Hmm... I\'ll bet those pirates over yonder have some ale on \'em...','',26124),
(126570,'enUS','The thoughtless partying of the other races has a drastic effect on this land\'s environment.','',26124),
(126571,'enUS','All of their litter collects in this corner of the lagoon. We cannot abide this affront to nature.','',26124),
(126572,'enUS','<Sigh>... I was hoping to play some volleyball, too...','',26124),
(126573,'enUS','You\'ve been given a free boat to use on the water\'s surface for the day. Boat safely!','You\'ve been given a free boat to use on the water\'s surface for the day. Boat safely!',26124),
(126574,'enUS','Well fought, $n. But there is more to be done before we can claim victory.','',26124),
(126575,'enUS','Stay away, unless you want a firework to the face!','',26124),
(126576,'enUS','','Ack!',26124),
(126577,'enUS','Get off my boat, Horde scum!','',26124),
(126578,'enUS','Get off my boat, Alliance scum!','',26124),
(126579,'enUS','','You want the boom? You got it, bozo!',26124),
(126580,'enUS','Grongo smash!','',26124),
(126581,'enUS','|TINTERFACE\\ICONS\\SPELL_FIRE_FELFIRENOVA:20|t The Avatar casts |cFFFF0404|Hspell:234059|h[Unbound Chaos]|h|r on you!','|TINTERFACE\\ICONS\\SPELL_FIRE_FELFIRENOVA:20|t The Avatar casts |cFFFF0404|Hspell:234059|h[Unbound Chaos]|h|r on you!',26124),
(126582,'enUS','|TINTERFACE\\ICONS\\SPELL_FIRE_FELHELLFIRE:20|t The Avatar begins to cast |cFFFF0404|Hspell:239132|h[Rupture Realities]|h|r!','|TINTERFACE\\ICONS\\SPELL_FIRE_FELHELLFIRE:20|t The Avatar begins to cast |cFFFF0404|Hspell:239132|h[Rupture Realities]|h|r!',26124),
(126583,'enUS','|TINTERFACE\\ICONS\\SPELL_FEL_ELEMENTALDEVASTATION:20|t The Corrupted Guardian begins to cast |cFFFF0404|Hspell:233856|h[Cleansing Protocol]|h|r!','|TINTERFACE\\ICONS\\SPELL_FEL_ELEMENTALDEVASTATION:20|t The Corrupted Guardian begins to cast |cFFFF0404|Hspell:233856|h[Cleansing Protocol]|h|r!',26124),
(126584,'enUS','|TINTERFACE\\ICONS\\SPELL_FIRE_FELHELLFIRE:20|t The Avatar begins to cast |cFFFF0404|Hspell:234724|h[Annihilation]|h|r!','|TINTERFACE\\ICONS\\SPELL_FIRE_FELHELLFIRE:20|t The Avatar begins to cast |cFFFF0404|Hspell:234724|h[Annihilation]|h|r!',26124),
(126585,'enUS','Greetings! This is the perfect place for arcane meditation, don\'t you agree?','',26124),
(126586,'enUS','High Sorceror, I need you to persuade the other class orders to join us against the Legion.','High Sorceror, I need you to rally the other class orders to join us against the Legion.',26124),
(126587,'enUS','','Spirits guide you, $ct.',26124),
(126588,'enUS','I will open a portal to Arcanist Ryanna\'s  location. One moment.','',26124),
(126589,'enUS','We must send news to the other class orders. We are going to the Broken Shore.','We must send news to the other class orders. We are going to the Broken Shore.',26124),
(126590,'enUS','%s begins to channel |cFFFF0404|Hspell:234728|h[Arcane Annihilation]|h|r!','',26124),
(126591,'enUS','','You have heard the $ct\'s words, children. Go to the other orders, gather their support! May the elements guide you.',26124),
(126592,'enUS','The enemy must be stopped at all costs!','',26124),
(126593,'enUS','Let\'s begin the assault.','Let\'s begin the assault.',26124),
(126594,'enUS','The Legion will fail in its efforts.','',26124),
(126595,'enUS','You cannot hide, Mephistroth!','',26124),
(126596,'enUS','|TInterface\\Icons\\ABILITY_CREATURE_CURSED_03.BLP:32|t Mephistroth uses |cFFFF0000|Hspell:233206|h[Shadow Fade]|h|r to conceal himself!','',26124),
(126597,'enUS','What can I help you with?','',26124),
(126598,'enUS','Hmm... Laurence... let\'s see...\n\nOh yes, she was in the other day. She was looking for a staff with some very particular properties. A funny thing, really, because it seemed the kind of staff I would normally procure for one of my warlock customers.\n\nIt took me a few days to get it, but I found one and had it delivered to the Legerdemain Lounge at her request.','',26124),
(126599,'enUS','%s uses Dino Mojo on you, granting you an Adaptation!','%s uses Dino Mojo on you, granting you an Adaptation!',26124),
(126600,'enUS','Here\'s the holy water, Grayson.','Here\'s the holy water, Grayson.',26124),
(126601,'enUS','Hey there. We brought some toys for you to borrow. Good luck.','',26124),
(126602,'enUS','Uh... I don\'t think he was supposed to be so little.','',26124),
(126606,'enUS','Free me from this torment!','',26124),
(126607,'enUS','The hounds will devour us all!','',26124),
(126608,'enUS','Release me, stranger. I\'d rather spend eternity in Helheim than suffer the fate that awaits me here!','',26124),
(126609,'enUS','The final death... it comes for us all.','',26124),
(126610,'enUS','Freedom, at last!','',26124),
(126611,'enUS','Thank you, stranger! May we meet again in the Halls of Valor!','',26124),
(126612,'enUS','I\'ll be food for the hounds no longer!','',26124),
(126613,'enUS','Odyn bless you, stranger!','',26124),
(126614,'enUS','These ancient forests must be cleansed of the Legion\'s presence. Give the word, heroes, and we shall begin the fight to save Val\'sharah!','',26124),
(126615,'enUS','Defenders, move out! Now we take the fight to the Legion!','',26124),
(126616,'enUS','Purge the Legion from our world!','',26124),
(126617,'enUS','You will fall, demons!','',26124),
(126618,'enUS','A wall of fel energy blocks our entry to the Warden tower. Move your team forward and destroy the Legion machines powering the barrier. We will hold this position while you strike.','',26124),
(126619,'enUS','The fool! Her portal has overloaded and is tearing rifts into the Twisting Nether!','',26124),
(126620,'enUS','I\'ll try to get it stable! Hold the demons off until I can stop them!','',26124),
(126621,'enUS','','I reclaimed Arikara. Did you find the Doomstone?',26124),
(126622,'enUS','We sense you bear dangerous news from the Broken Shore. We await you at the Violet Citadel.','',26124),
(126623,'enUS','The barrier is down, but the Legion\'s evil still looms over us. If we secure the tower\'s apex, the Dreamweavers will provide the means to reach the demons\' vessel.','',26124),
(126624,'enUS','The key to securing the tower lies in striking down their leader within. We must take that tower!','',26124),
(126625,'enUS','The Dreamweavers have lent their hippogryphs to carry you to the Legion\'s vessel. Eliminate the commander leading this assault, and the rest of these cowardly demons will retreat. Good luck, champions!','',26124),
(126626,'enUS','Feel the power of the Light!','',26124),
(126627,'enUS','In the Light, we are one.','',26124),
(126628,'enUS','We will not fall!','',26124),
(126629,'enUS','I must regain my strength. Be cautious, champion!','',26124),
(126630,'enUS','Please be turnink your attenzhion to me.','',26124),
(126631,'enUS','Ve run a tight balloon here!','',26124),
(126632,'enUS','Zhere vill be no talkink, no jumpink, no basket-jostlink.','',26124),
(126633,'enUS','NO HORSEPLAYINK!','',26124),
(126634,'enUS','Zhese are zhe rules. Obey zhem, or be dealt vizh.','',26124),
(126635,'enUS','Ve vill all have a very nice balloon ride, and ve are goink to enjoy it. Is zhat clear?','',26124),
(126636,'enUS','Very goot. Now ve sit in silence for zhe next hour.','',26124),
(126637,'enUS','The Night Watch knows a thing or two about tracking. In Duskwood, creatures lurk in every dark nook and cranny.$b$bSometimes you catch a glimpse of their beady little eyes, peering at you from the bushes.$b$b<The watcher tries to suppress a shudder.>$b$bWhy, just the other day I sensed an unfamiliar creature stalking me in the forest, watching from the shadows.','',26124),
(126638,'enUS','I DESERVED ZHIIISSS!','',26124),
(126639,'enUS','A demon stronghold in Black Rook? Remove the fiends at once!','',26124),
(126640,'enUS','Hurry to the northern end of the ramparts! A dark presence rises atop the keep!','',26124),
(126641,'enUS','Farseer! Elementals of pure felfire scorch the land with their curses. Please, cleanse those who battle these creatures and purge the magic these monsters wield.','',26124),
(126643,'enUS','Well done, Farseer. Your shaman can take it from here.','',26124),
(126644,'enUS','Hero, the shaman of the Earthen Ring are striving to counter intense fel curses plaguing this land. They need your aid in battle while they carry out their cleansing rituals.','',26124),
(126645,'enUS','When our war against the Legion ends, let us hope the Earthen Ring finds a way to restore balance to this scarred land.','',26124),
(126646,'enUS','','Welcome aboard!',26124),
(126647,'enUS','','Boy, are you guys in luck! This ain\'t gonna be your standard, sleepy, ultra-slow balloon ride.',26124),
(126648,'enUS','','I\'ve got this baby tricked out with a chronal accelerator I bought super cheap! Time is literally gonna fly! What could go wrong?',26124),
(126649,'enUS','','Uh-oh...',26124),
(126650,'enUS','','I don\'t think we\'re in Nagrand anymore.',26124),
(126651,'enUS','','We\'re in Nagrand? We\'re in Nagrand!',26124),
(126652,'enUS','','I don\'t believe it! We traveled back in time!',26124),
(126653,'enUS','','Or is it forward in time? I never know. Either way, this is horrifying! I wanna go back!',26124),
(126654,'enUS','','There\'s no time like home, there\'s no time like home, there\'s no time like home...',26124),
(126655,'enUS','Hop aboard, junior ballooners! Anybody want a balloon sticker? Here ya go.','',26124),
(126656,'enUS','We run the swankiest balloon in all of Azeroth! Ask anybody, they\'ll tell ya it\'s true!','',26124),
(126657,'enUS','How\'s about some free drinks? Here ya go!','',26124),
(126658,'enUS','Today, we\'re flying over Azsuna, the jewel of the Broken Isles.','',26124),
(126659,'enUS','Anybody for caviar? We got only the best!','',26124),
(126660,'enUS','That\'s the Nar\'thalas Academy down there. A school for mages back in ancient times, I hear.','',26124),
(126661,'enUS','Hot towel? Only the best for our customers!','',26124),
(126662,'enUS','Rungle, why don\'t ya heat up the barbecue, then get the fireworks ready.','',26124),
(126663,'enUS','Sure thing, boss.','',26124),
(126664,'enUS','Ya might be wondering how I can run such a classy balloon outfit and still turn a profit. Well, lemme tell ya.','',26124),
(126665,'enUS','The trick is, ya don\'t reveal the price to the customer \'til they\'re up in the balloon with ya!','',26124),
(126666,'enUS','That\'ll be 28,542 gold each--gratuity NOT included. Unless, of course, you\'d like Rungle here to break your legs.','',26124),
(126667,'enUS','Okay, boss. I put the fireworks on the barbecue, like you said.','',26124),
(126668,'enUS','You did WHAT? Rungle, you bungled it again!!!!!!!!','',26124),
(126669,'enUS','Welcome, friends, to the Nesingwary balloon tour o\' Highmountain!','',26124),
(126670,'enUS','Bought this balloon from a wee goblin. Claimed it\'d make a good perch fer shootin\' moose!','',26124),
(126671,'enUS','Lately, though... eh, I dunno. Been feelin\' a bit down. Huntin\' don\'t bring the same joy it once did.','',26124),
(126672,'enUS','Not even shootin\' critters from a hot air balloon can cheer me up.','',26124),
(126673,'enUS','$n, you got any?','',26124),
(126674,'enUS','How \'bout you, $n?','',26124),
(126675,'enUS','Or even you, $n. Someone cheer me up!','',26124),
(126676,'enUS','Ach... looks like we\'re gonna come in pretty close. Everybody wave hello to Thunder Totem!','',26124),
(126677,'enUS','Welcome aboard. Please sit back and enjoy the ride.','',26124),
(126678,'enUS','Below, you will see Crystalsong Forest.','',26124),
(126679,'enUS','I\'m sad to say that despite all my travels, I never spent much time here. I couldn\'t tell you why.','',26124),
(126680,'enUS','Ahh... but I do have fond memories of my time here in Northrend.','',26124),
(126681,'enUS','Just over that ridge lies Sholazar Basin. There I met tribes of wolvar and murloc oracles. Such strange creatures!','',26124),
(126682,'enUS','After all the journeys I\'ve been on, I still remember that day the most clearly.','',26124),
(126683,'enUS','Please, pardon me for blathering on. No doubt the the tales of your own adventures are much more exciting!','',26124),
(126684,'enUS','Mages of the Tirisgarde need help investigating the Felborne occupying the Weeping Terrace. This wand may come in handy for removing their magical enhancements.','',26124),
(126685,'enUS','','Netherlord, one of our warlocks has opened a portal to a Legion carrier brimming with demons. I suggest you show these vermin what it means to be the puppet of a greater power!',26124),
(126686,'enUS','What about you, $n? To what exotic lands have you traveled?','',26124),
(126687,'enUS','And you, $n?','',26124),
(126688,'enUS','Or you, $n? What tales of exploration do you hold dear?','',26124),
(126689,'enUS','I\'ll let the three of you talk amongst yourselves. I need to make sure I don\'t crash this balloon into Dalaran.','',26124),
(126690,'enUS','MORE balloon riders? Fine, come on in... I guess.','',26124),
(126691,'enUS','This is the balloon ride to Halfhill. Please keep your hands and off-hands inside the basket at all times.','',26124),
(126692,'enUS','<Sigh>...','',26124),
(126693,'enUS','','Yes. Yes! YES! Not so fun to be on the receiving end, is it? Legion scum!',26124),
(126694,'enUS','Below us, to the right, you will see Pang\'s Stead. Be sure to keep an eye out for...','',26124),
(126695,'enUS','You know what? That\'s it. I\'ve HAD it!','',26124),
(126696,'enUS','I have a confession I\'d like to make to the three of you.','',26124),
(126697,'enUS','I HATE balloons. Hated them all my life. All I ever wanted to do was be a shaman, but no! Apparently \"ballooning is in our blood\".','',26124),
(126698,'enUS','Is this good enough for you, father? Huh? ARE YOU PROUD OF ME NOW, DAD?!?!','',26124),
(126699,'enUS','...Whew.','',26124),
(126700,'enUS','Wow.','',26124),
(126701,'enUS','Feels good to get that off my chest. I\'ve never told that to anyone before.','',26124),
(126702,'enUS','Now you know my secret. What about you?','',26124),
(126703,'enUS','$n, give it a try. Tell us something you\'ve never told another soul before. Go ahead.','',26124),
(126704,'enUS','How about you, $n? Do you have any secrets burning a hole in your heart?','',26124),
(126705,'enUS','I haven\'t forgotten about you, $n. Tell us a secret. We won\'t judge. This is a safe balloon.','',26124),
(126706,'enUS','That was the most cathartic balloon ride I\'ve ever had. It was even sort of fun. Thanks, all of you!','',26124),
(126707,'enUS','','Welcome aboard! Today I will be your guide on a tour of Stormheim.',26124),
(126708,'enUS','','See all that stuff down there? That\'s... uh... that\'s Stormheim.',26124),
(126709,'enUS','','Sorry, I\'m not a very experienced tour guide.',26124),
(126710,'enUS','','So... any of you know some balloon party games?',26124),
(126711,'enUS','','Ooh, ooh, I\'ve got one! It\'s called Kiss, Marry, Slay.',26124),
(126712,'enUS','','It\'s easy. You just have to pick one person you would kiss, one you would marry, and one you would slay.',26124),
(126713,'enUS','','I\'ll go first! Let\'s see...',26124),
(126714,'enUS','','$n, you\'ve got a nice face, and it looks like you\'re the only one here who brushes $Ghis:her; teeth. I would kiss you.',26124),
(126715,'enUS','','Hmm... I would slay $n. For obvious reasons.',26124),
(126716,'enUS','','And that leaves $n to marry! I could live with that.',26124),
(126717,'enUS','','Okay, my turn\'s over. Somebody else go next!',26124),
(126718,'enUS','','Alright, the balloon ride is over! That was FUN!',26124),
(126719,'enUS','Greetings! Please step into the basket... and prepare for the most educational balloon ride of your life.','',26124),
(126720,'enUS','Today we will be taking a scenic balloon tour over the ancient city of Suramar.','',26124),
(126721,'enUS','But first, I will be taking attendance.','',26124),
(126722,'enUS','$n? Is $n here?','',26124),
(126723,'enUS','Please, just say \"here\".','',26124),
(126724,'enUS','Very well. Do we have a $n in attendance today?','',26124),
(126725,'enUS','I see. And, last on the list is $n. That must be you, correct?','',26124),
(126726,'enUS','Quite the talkative bunch. On with the tour!','',26124),
(126727,'enUS','Suramar, as we all know, is home to the Nightborne elves.','',26124),
(126728,'enUS','One must admit the magic of the Felborne possesses a certain... flare. A pity they abuse its potential. They met the end they deserved.','',26124),
(126729,'enUS','Among other things, the Nightborne are known for being rather disagreeable.','',26124),
(126730,'enUS','$n, can you tell me what mind-altering substance the Nightborne use to relax?','',26124),
(126731,'enUS','The substance they consume is, of course, mana.','',26124),
(126732,'enUS','Consuming so much mana has had an effect on the Nightborne\'s bodies.','',26124),
(126733,'enUS','$n. What specific feature of Nightborne anatomy has been \"enhanced\" by excessive mana use?','',26124),
(126734,'enUS','Very close! The answer I was looking for was \"their skin\".','',26124),
(126735,'enUS','Final question, for $n. What is the traditional greeting used in Suramar City?','',26124),
(126736,'enUS','Good guess! The correct answer is: \"An illusion! What are you hiding?\"','',26124),
(126737,'enUS','That\'s all for today. Thank you for flying... and study up next time!','',26124),
(126738,'enUS','','We need a victim... er... volunteer to go through a portal and thin the ranks of demons on the other side. Talk to Tehd, he can provide a loaner demon to get you started.',26124),
(126739,'enUS','Hail, Highlord. Lord Grayson waits inside for your arrival.$b$bHe\'s currently overseeing the preparation for the purification of the barding.$b$bWhen you\'re ready to enter, I will escort you inside.','',26124),
(126740,'enUS','I\'m ready to go.','I\'m ready to go.',26124),
(126741,'enUS','Spirits of the fallen cry out as Legion hounds drain their life essence. Free the spirits from their torment and purge the Legion filth!','',26124),
(126742,'enUS','The Halls of Valor echo with the songs of those you rescued. Magnificently done!','',26124),
(126743,'enUS','You must stop them...','You must stop them...',26124),
(126744,'enUS','Had to... get away! Had to... warn you...','Had to... get away! Had to... warn you...',26124),
(126745,'enUS','Take me to the top of Black Rook Hold.','Take me to the top of Black Rook Hold.',26124),
(126746,'enUS','There! The rifts are subsiding, but the portal remains too volatile to follow through.','',26124),
(126747,'enUS','I can keep it open, but I\'ll need your help to stabilize it...','',26124),
(126748,'enUS','Alright, I\'ll attempt to stabilize the portal. I hope you know what you\'re doing, $c!','',26124),
(126749,'enUS','The runes seem to be working! The fel energy is subsiding...','',26124),
(126750,'enUS','It is done.','',26124),
(126751,'enUS','Have you figured out these runes yet? We don\'t have much time!','',26124),
(126752,'enUS','The runes are activated. Stabilize the portal.','The runes are activated. Stabilize the portal.',26124),
(126753,'enUS','Wait... something\'s wrong! I can\'t... control...','',26124),
(126754,'enUS','Urgh!','',26124),
(126755,'enUS','Send me to the terrace.','Send me to the terrace.',26124),
(126756,'enUS','Help us, $ct! The Legion is pushing us back!','',26124),
(126757,'enUS','Incoming!','',26124),
(126758,'enUS','','My \"master\" ordered me to help you, so try not to die.',26124),
(126759,'enUS','','Do you expect me to do ALL of the work?',26124),
(126760,'enUS','','It died. Pity. I might have had a use for that one.',26124),
(126761,'enUS','','Ugh, they do not build these demons like they used to.',26124),
(126762,'enUS','','It is as if these demons can\'t handle a bit of whip...',26124),
(126763,'enUS','','Oh, that was a mean one.',26124),
(126764,'enUS','','Mmm. I suppose I should have told him the safe word.',26124),
(126765,'enUS','','Ooo... giving up already?',26124),
(126766,'enUS','','If you find a cloak on this on, I want it.',26124),
(126767,'enUS','','I am cold. My outfit was meant for inferno worlds mostly on fire.',26124),
(126768,'enUS','','For being on a ship of the Burning Legion, it is not very warm here.',26124),
(126769,'enUS','','Tehd promised we could burn this place to ash.',26124),
(126770,'enUS','','If you see the Cazarian here speak up. He and I have unfinished...business.',26124),
(126771,'enUS','','Ugh, I hate these ships. So drab, not enough chains.',26124),
(126772,'enUS','','So you mortals think you can win against the Legion? That is so precious. You are like an adorable collection of rodents that haven\'t noticed the large predator stalking you.',26124),
(126773,'enUS','','You should join me here sometime when I am not bound by my contract. Oh, the things I could show you...',26124),
(126774,'enUS','','You know, this whip isn\'t just for show. Say the word, break my contract, and I can show you what wonders it can do...',26124),
(126775,'enUS','','I have waited a long time for this, Cazarian! Now the whip is in the other hand!',26124),
(126776,'enUS','Happy Balloon Day! Interested in a balloon ride?','Happy Balloon Day! Interested in a balloon ride?',26124),
(126777,'enUS','Yes!','Yes!',26124),
(126778,'enUS','|TInterface\\Icons\\spell_fire_felrainoffire:20|t The Legion ship has started a |cFFFF0404|Hspell:235085|h[Fel Bombardment]|h|r! Watch out!','',26124),
(126779,'enUS','You have dealt a heavy blow to the Legion, $n. The cleansing has begun. I await your return.','',26124),
(126780,'enUS','Champion! We\'ve spotted the wreckage of a Horde airship. Secure its cargo before the Legion does.','',26124),
(126781,'enUS','Our troops will make good use of these supplies. Well done, champion.','',26124),
(126782,'enUS','[PH] A Legion ship materializes in the distance.','[PH] A Legion ship materializes in the distance.',26124),
(126783,'enUS','Return me to the terrace.','Return me to the terrace.',26124),
(126784,'enUS','Enough of these games!','',26124),
(126785,'enUS','Jubeka, are you there? Do not let them take me! I could not endure such a fate!','',26124),
(126786,'enUS','','Protect me, my children! I will give you the power!',26124),
(126787,'enUS','Fhambar has the scent. Meet him on the other side of the portal and he\'ll lead you to your missing mage.','',26124),
(126789,'enUS','','Goldrinn has his prey cornered, but we should lend a hand. And by hand, I mean talon, claw... or other stabby thing!',26124),
(126790,'enUS','','A fine hunt. Good work out there, Archdruid!',26124),
(126791,'enUS','','Goldrinn needs our help! A demon decided to cheat the hunt by bringing in backup. Let\'s give him a taste of his own medicine!',26124),
(126792,'enUS','','Thanks for the help! Those demons are like gnats compared to Goldrinn, but with so many of them, who knows what could have happened...',26124),
(126793,'enUS','','Kill the Imp Servants before they energize Agatha!',26124),
(126794,'enUS','','Ugh! This demon invasion has destroyed so many habitats on the Broken Shore. The wildlife has nowhere to go!',26124),
(126795,'enUS','','Crocolisks in Jagged Cove are encroaching on a sedge of saltwater cranes. Help me gather up those poor birdies so we can get them to safety!',26124),
(126796,'enUS','Enough! I return to my slumber!','',26124),
(126797,'enUS','I tire of playing with the living.','',26124),
(126798,'enUS','So... sleepy.','',26124),
(126799,'enUS','','We\'ll get the cranes to safety. One day, when the Broken Shore is free of demons, their chicks\' chicks can finally be returned home.',26124),
(126800,'enUS','Fhambar patiently awaits the command to follow Levia\'s trail.','',26124),
(126801,'enUS','Go find Levia, Fhambar!','Go find Levia, Fhambar!',26124),
(126802,'enUS','Fhambar picks up Levia\'s trail!','',26124),
(126803,'enUS','Attention, sporelings! Honorary sporelings! Attend the spectacle of the growing of Fshoo!','',26124),
(126804,'enUS','Fshoo cannot survive long aboveground without your help. We need healers, medics, and mushroom-menders to protect her!','',26124),
(126805,'enUS','Fshoo comes!','',26124),
(126806,'enUS','Fshoo has withered. May her spores sail forever on the Zangar winds!','',26124),
(126807,'enUS','Your arrival is well-timed. I expect the attack to come at any moment. Before it does, let me urge the two of you to return to Bradensbrook. This doesn\'t need to be your fight!','',26124),
(126808,'enUS','','No way I\'m staying behind! The attacks on my town must be stopped!',26124),
(126809,'enUS','','Better to kill \'em here than have \'em tramplin\' my crops! Let\'s be about it, elf.',26124),
(126810,'enUS','Lord Ravencrest may be derelict in his duties, but I am not. Soldiers, attack!','',26124),
(126811,'enUS','','So the Kirin Tor wishes to send me more playthings?',26124),
(126812,'enUS','','While Levia has kept me quite satisfied, it would be rude of me to turn down such a gift.',26124),
(126813,'enUS','','Come then, $c. Entertain me.',26124),
(126814,'enUS','Archmage, I was impressed to learn you captured the demon Kathra\'natir within the Nightborne Soulstone. Devising a containment shield that allows us to harness his power safely was ingenious!','',26124),
(126815,'enUS','','NO! What have you done! I will make you suffer!',26124),
(126816,'enUS','','My, you are a strong one. Breaking you will be ever so fun!',26124),
(126817,'enUS','','No! It cannot be!',26124),
(126818,'enUS','I fear for the lives of our allies if something is not done about this fel reaver.','',26124),
(126819,'enUS','Well done! With the fel reaver destroyed, a heavy blow has been struck to the Legion\'s forces.','',26124),
(126820,'enUS','','You shattered my illusion! Insolent wretch!',26124),
(126821,'enUS','','I will hunt you down, $c! Mark my words!',26124),
(126822,'enUS','','What... was... that!?',26124),
(126823,'enUS','We can expect more defenders within. With Lord Ravencrest gone, I would wager Erdris now occupies his chambers. He always thought very highly of himself.','',26124),
(126824,'enUS','Over here!','',26124),
(126825,'enUS','This gate is closing--look out!','',26124),
(126826,'enUS','','Uhhhh! My head...',26124),
(126827,'enUS','You are mine!','',26124),
(126828,'enUS','','Dag blast it!',26124),
(126830,'enUS','Though employing Kathra\'natir\'s prison to power Dalaran\'s defenses may not be a long-term solution, I am relieved that the demon\'s essence remains contained. Come, let us return to the Hall of the Guardian.','',26124),
(126831,'enUS','','You won\'t regret it, Archdruid! Ready to jump into action!',26124),
(126832,'enUS','The tormented dead are heeding the call of their demonic masters. Strike them down!','',26124),
(126833,'enUS','At every turn, the Burning Legion finds new ways to pervert the worlds they invade.','',26124),
(126834,'enUS','Drown in flame!','',26124),
(126835,'enUS','Your pet lich professes to have a plan that requires the bones of those sacrificed to the fel. Help him if you think it will aid our cause, but keep that... thing... in check.','',26124),
(126836,'enUS','An intriguing use of necromancy. Dark magic has its uses.','',26124),
(126837,'enUS','','Forgive me, Highlord. I... I need some time alone with my thoughts.',26124),
(126838,'enUS','Ah! Excellent specimens, Deathlord. Here, you may find this useful.','',26124),
(126839,'enUS','Help! I am under attack!','Help! I am under attack!',26124),
(126840,'enUS','Citizens, aid me!','Citizens, aid me!',26124),
(126841,'enUS','Assassins are here!','Assassins are here!',26124),
(126842,'enUS','You will not take me down, villain!','You will not take me down, villain!',26124),
(126843,'enUS','Spies sent from the Legion are here!','Spies sent from the Legion are here!',26124),
(126844,'enUS','Help! Help!','Help! Help!',26124),
(126845,'enUS','Death comes for me!','Death comes for me!',26124),
(126846,'enUS','A rogue has infiltrated our city!','A rogue has infiltrated our city!',26124),
(126847,'enUS','[OLD DNT] Quickly, $ct, we need you on the front lines!','',26124),
(126848,'enUS','Gll grm grmurrmr?','',26124),
(126849,'enUS','Useless! Stand aside while I do what you cannot, brother.','',26124),
(126850,'enUS','Once again I must clean up your mess, brother!','',26124),
(126851,'enUS','','Be... behind you...',26124),
(126852,'enUS','','Send Modera my regards, $c. And... thank you.',26124),
(126853,'enUS','You will not stop us!','',26124),
(126854,'enUS','How pathetic! Syrenne has taken to compelling outsiders to do her bidding?','',26124),
(126855,'enUS','<Beckon the tadpole to follow you.>','<Beckon the tadpole to follow you.>',26124),
(126856,'enUS','Lexera does not take kindly to those who meddle in her business!','',26124),
(126857,'enUS','Foolish mortals! Did you truly believe the Burning Legion would be so easily defeated?','',26124),
(126858,'enUS','The Feltotem tauren are defiling the bodies of the fallen. No one deserves this fate. Lay them to rest, champion.','',26124),
(126859,'enUS','They gave their lives willingly, and have earned their rest. You have done well.','',26124),
(126860,'enUS','Prisoners are being held in this area. Do whatever you must to free them, champion!','',26124),
(126861,'enUS','Thanks to your efforts, the prisoners have both their freedom and their lives. Well done.','',26124),
(126862,'enUS','You made it! Praise Elune! I doubt we had much time left.','',26124),
(126863,'enUS','Prepare yourselves. Erdris has been bewitched by the Legion and sees only enemies.','',26124),
(126864,'enUS','Hold a moment and catch your breath. Then we move.','',26124),
(126866,'enUS','Behold the power of the fel!','',26124),
(126867,'enUS','Careful, champion. Something is emerging from the portal... something powerful!','',26124),
(126868,'enUS','Let us be about it, then.','',26124),
(126869,'enUS','I cannot allow you to menace the living any longer, Erdris!','',26124),
(126870,'enUS','Arise, soldiers! Embrace my gift and bring an end to the Legion!','',26124),
(126871,'enUS','When the Legion vessel fell, it released what remained of the souls used in its creation. These souls wail in agony, lost in ceaseless pain. Please, free them from this torment!','',26124),
(126872,'enUS','A spirit can endure much, but being consumed over time by fel energies is torment beyond the mortal mind\'s comprehension.','',26124),
(126873,'enUS','The hold is... lost...','',26124),
(126874,'enUS','I hope you have found peace, commander.','',26124),
(126875,'enUS','Thank you, $n. We stopped the Legion from driving a wedge into our forces. The Kirin Tor will be pleased to learn of our victory. They gave me something to see your way back to them.','',26124),
(126876,'enUS','','Pleasure working with you! Thanks for saving our town.',26124),
(126877,'enUS','','Stop by Bradensbrook once in a while, plenty of birds left to shoot down!',26124),
(126878,'enUS','','Act quickly! The Legion will soon overrun us.',26124),
(126879,'enUS','','Champion, I\'m glad I reached you. As Victoria no doubt informed you, we have located the imp mother, Agatha.',26124),
(126880,'enUS','','By now, she has likely harnessed much of the power she stole from Levia. If so, there\'s no telling what she\'s capable of.',26124),
(126881,'enUS','','Her location is well shielded, but our Kirin Tor mages should be able to open a portal to her for a short time.',26124),
(126882,'enUS','','The imp mother must be stopped! Good luck, champion.',26124),
(126883,'enUS','Felbats! I detest those winged fiends! Not only do they harass our forces, they breed like rabbits. We need to thin their numbers!','',26124),
(126884,'enUS','','You are too late! Levia\'s power is mine! Using her knowledge, my minions will infiltrate the Kirin Tor and dismantle it from the inside!',26124),
(126885,'enUS','','Even now, my sayaad tempt your weak-willed mages. Your allies will surrender willingly to the Legion!',26124),
(126886,'enUS','','But first, you must be punished for taking away my little pet.',26124),
(126887,'enUS','You have safeguarded our forces from a most unpleasant aerial assault. Hmm, perhaps the Illidari can make use of the juveniles you scared off...','',26124),
(126888,'enUS','','No... My pretties!',26124),
(126889,'enUS','','You\'ll... pay for this! You\'ll... pay...',26124),
(126890,'enUS','A grim and dangerous task awaits us, $n. These two demanded to come along to \"make sure we got it done right\". They should not have to do this.','',26124),
(126891,'enUS','Let us deal with Commander Erdris. (use Jarod\'s free keystone.)','Let us deal with Commander Erdris. (use Jarod\'s free keystone.)',26124),
(126892,'enUS','Let us deal with Commander Can\'tomas. (requires Brimming Keystone)','Let us deal with Commander Can\'tomas. (requires Brimming Keystone)',26124),
(126893,'enUS','Welcome, Highlord $p. I\'ve been making preparations for the ritual to cleanse the barding. But so far, we\'ve been unable to secure the holy water.','',26124),
(126894,'enUS','I sent in three of my best men to search for it, but they\'ve not returned. I fear for their safety.','',26124),
(126895,'enUS','Perhaps someone of your skills would be better suited to recover the water. Please, take a pair of my paladins with you. Who knows what\'s still lurking in this place.','',26124),
(126896,'enUS','Your quest here is futile, paladin! This city shall spread death once again...','',26124),
(126897,'enUS','This city belongs to the dead! And soon, so shall you!','',26124),
(126898,'enUS','You\'re too late to save your allies, paladin. Their souls fuel my army...','',26124),
(126900,'enUS','Osseine shall grant you a swift death!','',26124),
(126901,'enUS','Take in the fumes of Pestulon and become one with my army!','',26124),
(126902,'enUS','Feast on their entrails, Rotmouth!','',26124),
(126903,'enUS','They swarmed us. I... I tried to fight, but... Thank you Highlord for saving me.','They swarmed us. I... I tried to fight, but... Thank you Highlord for saving me.',26124),
(126904,'enUS','It felt like my soul was being slowly ripped from my body. The necromancer, he... I must get to Grayson.','It felt like my soul was being slowly ripped from my body. The necromancer, he... I must get to Grayson.',26124),
(126905,'enUS','It\'s over?! Is this real? Highlord, it\'s you... I... I think I can make my way back. Thank you.','It\'s over?! Is this real? Highlord, it\'s you... I... I think I can make my way back. Thank you.',26124),
(126906,'enUS','Excellent job recovering the water, Highlord. And you have my deepest thanks for saving my paladins.','',26124),
(126907,'enUS','I\'ll apply the water to the barding. The rest, Highlord, lies with you and your weapon.','',26124),
(126908,'enUS','It is done! The barding is ready. Now we go to Rivendare\'s crypt to confront his specter.','',26124),
(126909,'enUS','MOUNT UP, PALADINS! WE RIDE!','',26124),
(126910,'enUS','They\'ll bring up the rear while we\'re inside dealing with Rivendare.','',26124),
(126911,'enUS','Where is his body?! It should be here!','',26124),
(126912,'enUS','Someone\'s taken it! This does not bode well...','',26124),
(126913,'enUS','LOOKING FOR SOMETHING?! HA HA HA!','',26124),
(126914,'enUS','You and your pathetic rabble will be added to my ranks of undead!','',26124),
(126915,'enUS','I, Raemien shall spread the plague over this land once more and all will bow before me!','',26124),
(126916,'enUS','The horse! Quickly, contain it!','',26124),
(126918,'enUS','The beast is bound, Highlord! The Light has favored us this day!','',26124),
(126919,'enUS','Let us reconvene at the Sanctum of Light. There you can bard the beast safely.','',26124),
(126920,'enUS','When you\'re ready to leave, speak with me and I\'ll see to our safe return.','',26124),
(126921,'enUS','Let me know when you\'re ready to return to the order hall, Highlord and I\'ll see to our safe return there.','',26124),
(126922,'enUS','I\'m ready to return, Grayson.','I\'m ready to return, Grayson.',26124),
(126923,'enUS','Send me to Shadowsong. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','Send me to Shadowsong. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',26124),
(126924,'enUS','The naga pose a persistent threat to our efforts. We\'ve subdued one of their brutes to use against them. Ride it into battle against the naga!','',26124),
(126925,'enUS','Well done. Turning the might of those big bruisers against their own was a... smashing idea!','',26124),
(126926,'enUS','I... I live, but I\'m in no condition for battle. Hurry, champion, you must stop him!','',26124),
(126927,'enUS','Alright, let\'s get this barding upgraded!','',26124),
(126928,'enUS','First I gotta just smelt all this ore...','',26124),
(126929,'enUS','Now if I just hammer the leystone in here... aaand here...','',26124),
(126930,'enUS','And last but not least, the jewel!','',26124),
(126931,'enUS','And there she is! Some of my finest work, if I do say so myself! You may take it now.','',26124),
(126932,'enUS','I\'m sure Grayson will be pleased to see what we accomplished. Send him my best.','',26124),
(126933,'enUS','','Train or perish. Out here, there are no second chances.',26124),
(126934,'enUS','','Do you really believe your companions are ready to join our assault?',26124),
(126935,'enUS','While patience is a virtue, we no longer can afford its luxury. Prepare yourself.','',26124),
(126936,'enUS','Here are the materials you asked for, Alard.','Here are the materials you asked for, Alard.',26124),
(126937,'enUS','Again? It will take me ages to put this armor back on. Hmph.','Again? It will take me ages to put this armor back on. Hmph.',26124),
(126938,'enUS','The Legion is retreating! Leap from their vessel! Trust the hippogryphs to catch you!','',26124),
(126939,'enUS','Enough of this!','',26124),
(126940,'enUS','Descend upon our enemy and break their foothold on this plane! Leave them no ground to cling to and show them no quarter!','',26124),
(126941,'enUS','At most we have slowed our enemy. There will be more, and we must be ready.','',26124),
(126942,'enUS','Your actions have awoken the spirits!','Your actions have awoken the spirits!',26124),
(126943,'enUS','Thank you, Grand Master.','Thank you, Grand Master.',26124),
(126944,'enUS','I was getting weaker by the second! Thank you.','I was getting weaker by the second! Thank you.',26124),
(126945,'enUS','I\'m getting out of here!','I\'m getting out of here!',26124),
(126946,'enUS','An aranasi has seized our troops to feed her deadly brood. Grandmaster, we must rely on your ability to slay that demon and Detox the captives to save them from the poison!','',26124),
(126947,'enUS','Our troops are arriving back at camp safe, sound, and most importantly, free of poison. Well done!','',26124),
(126948,'enUS','Our troops were carried away by an aranasi to feed her foul brood! Kill these arachnids and gather their venom sacs so we can develop a cure to their toxins.','',26124),
(126949,'enUS','Thanks to your help, we can now develop a reliable cure for this poison.','',26124),
(126950,'enUS','Let us begin.','Let us begin.',26124),
(126951,'enUS','Pitiful.','Pitiful.',26124),
(126952,'enUS','It seems you are ready.','It seems you are ready.',26124),
(126953,'enUS','Again!','Again!',26124),
(126954,'enUS','Try harder.','Try harder.',26124),
(126955,'enUS','Don\'t give up.','Don\'t give up.',26124),
(126956,'enUS','Excellent strategy.','Excellent strategy.',26124),
(126957,'enUS','You\'re improving.','You\'re improving.',26124),
(126958,'enUS','Good, but can you do it again?','Good, but can you do it again?',26124),
(126961,'enUS','The Burning Legion dares to assault Stormheim! Remove their foul presence from this land, champion, and glory shall be yours!','',26124),
(126962,'enUS','The Legion tricked us! Their attacks were merely a diversion while they established a foothold upon the isle of Shield\'s Rest!','',26124),
(126964,'enUS','Champion! Hold the line against the Legion\'s forces. Join our allies on the front and stand your ground!','',26124),
(126965,'enUS','Rest for now, hero. You have earned it.','',26124),
(126966,'enUS','Hello, $c, do you wish to research more about your artifact? \n\nI would like to assist you, but it appears you might still be carrying Artifact Research Notes. Reading them will further your knowledge.','Hello, $c, do you wish to research more about your artifact? \n\nI would like to assist you, but it appears you might still be carrying Artifact Research Notes. Reading them will further your knowledge.',26124),
(126967,'enUS','Alright, let\'s show these bozos a trick or two.','',26124),
(126968,'enUS','I got the spells if you got the coin!','',26124),
(126969,'enUS','The Great Akazamzarak is ready for action!','',26124),
(126970,'enUS','Ruins as old as these are packed with rarities that would delight any collector. Recover whatever relics ye can, but beware o\' the spirits still lingerin\' about!','',26124),
(126971,'enUS','I\'ve got an ace up my sleeve!','',26124),
(126972,'enUS','I think we\'ve done enough relic huntin\' fer one day. Let\'s give the spirits time ta settle down. Enjoy yer spoils!','',26124),
(126973,'enUS','Let\'s go, everyone! We\'re heading to the next tavern!','Let\'s go, everyone! We\'re heading to the next tavern!',26124),
(126974,'enUS','Last call! I\'m opening a portal to the next tavern!','Last call! I\'m opening a portal to the next tavern!',26124),
(126975,'enUS','Welcome, welcome! Help yourself to some free drinks and food.','Welcome, welcome! Help yourself to some free drinks and food.',26124),
(126976,'enUS','Pick a card, any card!','',26124),
(126977,'enUS','Need a hand?','',26124),
(126978,'enUS','','Damn them! Let\'s go!',26124),
(126979,'enUS','Prepare to eat fluffy, cotton-tailed death!','',26124),
(126980,'enUS','Oh, I got a trick for you, pal!','',26124),
(126981,'enUS','We can still be friends.','We can still be friends.',26124),
(126982,'enUS','I better be getting hazard pay for this...','',26124),
(126983,'enUS','It\'s not you, it\'s me.','It\'s not you, it\'s me.',26124),
(126984,'enUS','Yeah, I know I\'m good.','',26124),
(126985,'enUS','We should see other people.','We should see other people.',26124),
(126986,'enUS','I really should start charging by the corpse.','',26124),
(126987,'enUS','That\'s what you get for not leaving a tip!','',26124),
(126988,'enUS','It was only the one time.','It was only the one time.',26124),
(126989,'enUS','I\'m billing you... for my repairs.','',26124),
(126990,'enUS','It was only the one time.','It was only the one time.',26124),
(126991,'enUS','I thought it was you!','I thought it was you!',26124),
(126992,'enUS','I\'m just not that into you.','I\'m just not that into you.',26124),
(126993,'enUS','We are never ever getting back together.','We are never ever getting back together.',26124),
(126994,'enUS','I can do better.','I can do better.',26124),
(126995,'enUS','Ow! Stop hitting me! Hit the hero!','',26124),
(126996,'enUS','I\'m charging extra for this...','',26124),
(126997,'enUS','Hope you don\'t mind if I take a cut.','',26124),
(126998,'enUS','Screw this, I\'m making my own mage order... with Hearthstone... and succubi! On second thought, forget the mage order!','',26124),
(126999,'enUS','It is said that the remains of those buried in these ruins have magical properties. Let us put these rumors to the test! Recover their ancient bones and place them upon the ruined altar.','',26124),
(127000,'enUS','You should get checked.','You should get checked.',26124),
(127001,'enUS','How magnificent! Enjoy your creation before the magic fades.','',26124),
(127002,'enUS','You ever need another one of those, come talk to me. I\'ll hook you up.','',26124),
(127003,'enUS','','The spirits within these ruins are bound to the Burning Legion through an ancient pact. Lay them to rest so that they may know peace.',26124),
(127004,'enUS','','Well done, champion. May their spirits finally know peace.',26124),
(127005,'enUS','','Highlord, the weapon you wield is needed to free these felbound spirits. Destroy their pendants and release my ancestors from their ancient curse.',26124),
(127006,'enUS','','Thank you, Highlord. You have brought peace to my ancestors.',26124),
(127009,'enUS','','You are right, S\'theno. Either we risk it or we are dead anyway. Slayer $n, we need to get to the main console upstairs!',26124),
(127010,'enUS','','Cue awesome scene of the Fel Hammer destroying one of the Legion ships and the others jumping away!',26124),
(127011,'enUS','','They should never have gotten sso close, Malevolence. Why did the Fel Hammer not fire on them?',26124),
(127012,'enUS','','This is no time for nasty insinuations, S\'theno my dear. They took out our weapons first thing. If you help kill these foul creatures, we can see about making repairs!',26124),
(127013,'enUS','','Cease your bickering! We have a ship to save!',26124),
(127014,'enUS','Why can\'t I send out the call for another Vanguard?','Why can\'t I send out the call for another Vanguard?',26124),
(127015,'enUS','Apologies, we only have enough troops to have a single Vanguard ready for deployment at a time. Once you have given your orders, we will be able to request another.','',26124),
(127016,'enUS','','Well, that was unfortunate. Surely someone with your skills can revive him?',26124),
(127017,'enUS','There are dangers ahead, traveler. A sickness has taken over the area.','There are dangers ahead, traveler. A sickness has taken over the area.',26124),
(127018,'enUS','Why am I unable to rally the Val\'kyr?','Why am I unable to rally the Val\'kyr?',26124),
(127019,'enUS','','I\'m sorry, we cannot rally another assault until you have deployed your currently assembled troops.',26124),
(127020,'enUS','Why can we not summon another Infernal?','Why can we not summon another Infernal to unleash?',26124),
(127021,'enUS','','Infernals are tricky things, and extremely powerful. We must be cautious with them. You still have a Phylactery in your possession, it would be foolhardy to hold more.',26124),
(127022,'enUS','Why are we not able to focus another crystal?','Why are we not able to focus another crystal?',26124),
(127023,'enUS','','The Might of Dalaran can only be channeled once. You appear to still have a Focusing Crystal in your possession. Once you have unleashed it, my mage\'s will be able to form another for you.',26124),
(127024,'enUS','You\'re too late, mortal! My command center has just arrived!','',26124),
(127025,'enUS','Why are we unable to power the Rift Core?','Why are we unable to power the Rift Core?',26124),
(127026,'enUS','Harpies are distasteful enough, but harpies pledged to the Legion? Intolerable! Keep this new threat under control, champion.','',26124),
(127027,'enUS','','We are simply not prepared to have multiple Rift Cores at once. You still have one in your possession. Once you have unleashed it, we will begin charging another.',26124),
(127028,'enUS','It seems you\'ve curbed their population growth. Good! We don\'t want such abominations spreading beyond these shores.','',26124),
(127029,'enUS','Why are we unable to start another ritual?','Why are we unable to start another ritual?',26124),
(127030,'enUS','The Frost Crux is an item of immense power. It would be foolish to attempt to have more than one in your possession. Once you have unleashed the Frost Wyrm, we will be able to summon another.','',26124),
(127031,'enUS','Prepare yourselves! The Legion will stop at nothing to capture this prize.','Prepare yourselves! The Legion will stop at nothing to capture this prize.',26124),
(127032,'enUS','We are ready.','We are ready.',26124),
(127037,'enUS','Gunners, open fire upon this mortal scum! Obliterate them with hellfire!','',26124),
(127038,'enUS','Ready your blades! The demons come!','Ready your blades! The demons come!',26124),
(127039,'enUS','The Aegis of Aggramar must be set in place. We begin on your signal, heroes!','',26124),
(127044,'enUS','You have my thanks.','You have my thanks.',26124),
(127045,'enUS','The pain has lessened. Thank you, $n.','The pain has lessened. Thank you, $n.',26124),
(127046,'enUS','The fog is finally lifting...','The fog is finally lifting...',26124),
(127047,'enUS','I am in your debt.','I am in your debt.',26124),
(127048,'enUS','Your compassion will not be forgotten.','Your compassion will not be forgotten.',26124),
(127049,'enUS','I owe you my life, priest.','I owe you my life, priest.',26124),
(127050,'enUS','I\'d better get back to the fight.','I\'d better get back to the fight.',26124),
(127051,'enUS','My vessel and I are needed elsewhere. Enjoy this... parting gift!','',26124),
(127052,'enUS','Bring down the monstrosity! Nothing gets through!','Bring down the monstrosity! Nothing gets through!',26124),
(127053,'enUS','Champion! Our mages have pinpointed the location of Raest Magespear within the Twisting Nether!','',26124),
(127054,'enUS','We have little information to work from, but it seems he found a way to use the energy of the Twisting Nether to enhance his necromantic magic.','',26124),
(127055,'enUS','Karam insisted on being sent in ahead of you, but I fear he cannot face this challenge alone.','',26124),
(127056,'enUS','We will open a portal to his location, but can\'t hold it open long. Raest must be stopped!','',26124),
(127057,'enUS','','Be shielded, heroes!',26124),
(127058,'enUS','','Must you always be so close, Roland?',26124),
(127059,'enUS','','Surely you have other places to be, Roland?',26124),
(127060,'enUS','','Doesn\'t this place remind you of home?',26124),
(127061,'enUS','Eredar conjurers are amassing dark forces from the Void. Stop them!','',26124),
(127062,'enUS','This world is dark enough without bringing more shadow into it. You have my thanks, champion.','',26124),
(127063,'enUS','','Come, Roland. Let us leave this vile place before you get yourself sick again.',26124),
(127064,'enUS','|TInterface\\Icons\\SPELL_NATURE_UNRELENTINGSTORM.BLP:20|t%s begins casting |cFFFF0000|Hspell:235766|h[Lightning Nova]|h|r !','',26124),
(127065,'enUS','','Shadowblade! Over here!',26124),
(127066,'enUS','','I consider myself an adept hunter of the undead, and even I didn\'t notice at first.',26124),
(127067,'enUS','','But look what happens when I slice right here...',26124),
(127068,'enUS','','It\'s not supposed to do that, and it\'s REALLY not supposed to be that color.',26124),
(127069,'enUS','','He spoke in coherent thoughts, and his skin... so well-preserved. But a few telltale signs gave him away.',26124),
(127070,'enUS','','It seems Legion dreadlords have found a way to craft undead operatives so lifelike that even I have difficulty detecting them!',26124),
(127071,'enUS','','The demons knew the Illidari would find them if they tried to infiltrate our cities again, so they sent in these... homunculi.',26124),
(127072,'enUS','','Our agents have identified suspected homunculi in Silvermoon and the Exodar.',26124),
(127073,'enUS','','We can\'t risk you carrying out an assassination in an ally\'s city, but no one will question you taking down a target in Silvermoon. While you handle that mark, I\'ll head to the Exodar.',26124),
(127074,'enUS','','Remember... even though you\'re trying to help them, the Horde will assume you\'re attacking one of their own.',26124),
(127075,'enUS','','Your first mark has established himself as a wealthy aristocrat who parades around the city in plain view. Be wary of his arcane golem! Separate them if you can... and keep it quiet.',26124),
(127076,'enUS','','Ah, a clean twist of the knife... delightful! Your next mark awaits in the Undercity. I suggest entering from the sewers to the west.',26124),
(127077,'enUS','','Your mark is having a tea party in the terrace above the Rogues\' Quarter. Be wary! Her allies are powerful spellcasters, as is she. You\'ll need to find a way to get up there.',26124),
(127078,'enUS','','That death scream... pure music! We have located the next mark in Thunder Bluff, hiding in the shadow of the tauren leader.',26124),
(127079,'enUS','','There he is, by the bonfire. I hear he is a coward who trusts in his armor to protect him. Demonstrate how wrong he is!',26124),
(127080,'enUS','','Mmm, delicious... like a knife in the dark! Your final mark will be found in Orgrimmar. This will be the most challenging target yet!',26124),
(127081,'enUS','','There! In the most crowded place imaginable---the auction house. Be silent, strike true, and vanish quickly!',26124),
(127082,'enUS','','Poor, pathetic marks! There\'s no place they can hide that the shadows cannot find them. Come, pay your colleagues a visit. Lord Ravenholdt has a gift for you.',26124),
(127083,'enUS','','We can\'t risk you carrying out an assassination in an ally\'s city, but no one will question you taking down a target in the Exodar. While you handle that mark, we\'ll see to the matter in Silvermoon.',26124),
(127084,'enUS','','Remember... even though you\'re trying to help them, the Alliance will assume you\'re attacking one of their own.',26124),
(127085,'enUS','','Your first mark wears the guise of a humble priest, walking through the city in plain view. Be wary of his crystal golem! Separate them if you can... and keep it quiet.',26124),
(127086,'enUS','','Ah, a clean twist of the knife... delightful! Your next mark will be found in Darnassus. I suggest entering through the village below Teldrassil.',26124),
(127087,'enUS','','Your mark is throwing a garden party near the Warrior\'s Terrace. Be wary! Her allies are powerful spellcasters, as is she. And mind the guards.',26124),
(127088,'enUS','','That death scream... pure music! We have located the next mark in Ironforge, hiding in the shadows of the dwarven council.',26124),
(127089,'enUS','','There he is, against the wall. I hear he is a coward who trusts in his armor to protect him. Demonstrate how wrong he is!',26124),
(127090,'enUS','','Mmm, delicious... like a knife in the dark! Your final mark will be found in Stormwind. This will be the most challenging target yet!',26124),
(127091,'enUS','|TInterface\\Icons\\ABILITY_HUNTER_PET_RAPTOR.BLP:20|t%s |cFFFF0000|Hspell:235886|h[calls]|h|r to her pack!','',26124),
(127092,'enUS','','Chin up, Roland. It appears help has arrived.',26124),
(127093,'enUS','What... what happened?','What... what happened?',26124),
(127094,'enUS','My head... get... get away from that thing!','My head... get... get away from that thing!',26124),
(127095,'enUS','I... I couldn\'t stop myself...','I... I couldn\'t stop myself...',26124),
(127096,'enUS','We must not falter, regardless of what the demons do.','We must not falter, regardless of what the demons do.',26124),
(127097,'enUS','','You made a wise choice. We will accomplish much together.',26124),
(127099,'enUS','Raest may have escaped, but we will track him down. When that day comes, I hope I can count on your help once again.','',26124),
(127100,'enUS','Orgrimmar Invaders Slain: $1i','',26124),
(127101,'enUS','Defender of Orgrimmar','',26124),
(127102,'enUS','You will not leave here alive!','',26124),
(127103,'enUS','The Burning Legion cannot be stopped!','',26124),
(127104,'enUS','The contagion will consume you!','',26124),
(127105,'enUS','Heroic Defender of Orgrimmar','',26124),
(127106,'enUS','Mythic Defender of Orgrimmar','',26124),
(127107,'enUS','Defender of Thunder Bluff','',26124),
(127108,'enUS','Heroic Defender of Thunder Bluff','',26124),
(127109,'enUS','Mythic Defender of Thunder Bluff','',26124),
(127110,'enUS','Defender of Undercity','',26124),
(127111,'enUS','Heroic Defender of Undercity','',26124),
(127112,'enUS','Mythic Defender of Undercity','',26124),
(127113,'enUS','Defender of Silvermoon','',26124),
(127114,'enUS','Heroic Defender of Silvermoon','',26124),
(127115,'enUS','Mythic Defender of Silvermoon','',26124),
(127116,'enUS','Defender of Warspear','',26124),
(127117,'enUS','Heroic Defender of Warspear','',26124),
(127118,'enUS','Mythic Defender of Warspear','',26124),
(127119,'enUS','Defender of Stormwind','',26124),
(127120,'enUS','Heroic Defender of Stormwind','',26124),
(127121,'enUS','Mythic Defender of Stormwind','',26124),
(127122,'enUS','Defender of Ironforge','',26124),
(127123,'enUS','Heroic Defender of Ironforge','',26124),
(127124,'enUS','Mythic Defender of Ironforge','',26124),
(127125,'enUS','Defender of Darnassus','',26124),
(127126,'enUS','Heroic Defender of Darnassus','',26124),
(127127,'enUS','Mythic Defender of Darnassus','',26124),
(127128,'enUS','Defender of the Exodar','',26124),
(127129,'enUS','Heroic Defender of the Exodar','',26124),
(127130,'enUS','Mythic Defender of the Exodar','',26124),
(127131,'enUS','Defender of Stormshield','',26124),
(127132,'enUS','Heroic Defender of Stormshield','',26124),
(127133,'enUS','Mythic Defender of Stormshield','',26124),
(127134,'enUS','Thunder Bluff Invaders Slain: $1i','',26124),
(127135,'enUS','Undercity Invaders Slain: $1i','',26124),
(127136,'enUS','Silvermoon Invaders Slain: $1i','',26124),
(127137,'enUS','Warspear Invaders Slain: $1i','',26124),
(127138,'enUS','Stormwind Invaders Slain: $1i','',26124),
(127139,'enUS','Ironforge Invaders Slain: $1i','',26124),
(127140,'enUS','Darnassus Invaders Slain: $1i','',26124),
(127141,'enUS','Exodar Invaders Slain: $1i','',26124),
(127142,'enUS','Stormshield Invaders Slain: $1i','',26124),
(127143,'enUS','We fight together.','',26124),
(127144,'enUS','The Brotherhood stands as one!','',26124),
(127145,'enUS','Let us cleanse some darkness from this land.','',26124),
(127146,'enUS','Fear my blade!','',26124),
(127147,'enUS','For the Brotherhood!','',26124),
(127148,'enUS','Fall before the Light!','',26124),
(127149,'enUS','At your side.','',26124),
(127150,'enUS','Let us journey together.','',26124),
(127151,'enUS','It is an honor.','',26124),
(127152,'enUS','I will... return...','',26124),
(127153,'enUS','I must fall back.','',26124),
(127154,'enUS','Argh, don\'t kill too many without me.','',26124),
(127155,'enUS','Behold the Light!','',26124),
(127156,'enUS','The Brotherhood leads the charge!','',26124),
(127157,'enUS','The Light prevails!','',26124),
(127158,'enUS','You will not interfere with our plans. Kanrethad\'s power will belong to the Burning Legion! Fall before our might!','',26124),
(127159,'enUS','We will not be stopped!','',26124),
(127160,'enUS','','We cannot let the Burning Legion succeed.',26124),
(127161,'enUS','','Odyn was a fool to choose you as his champion.',26124),
(127162,'enUS','','It will be amusing to see his shame when you fall.',26124),
(127163,'enUS','','Your kind should not be here. This land is OURS, and only we are worthy of entering this tournament!',26124),
(127164,'enUS','','I wonder if your name will be remembered after you\'ve failed...',26124),
(127165,'enUS','Your size probably matches your strength. Puny.','',26124),
(127166,'enUS','I\'d let you work out with me, but these weights are as big as you. Come back when you grow muscles.','',26124),
(127167,'enUS','It\'s alright if you want to leave. Most of my opponents lose as soon as they look at me.','',26124),
(127168,'enUS','I misjudged your strength, brul. I used to believe that size mattered, but perhaps I was mistaken.','',26124),
(127169,'enUS','When I spoke to the shaman of my tribe, he foresaw a victory for me on this day. Perhaps you should bow out of this one, fellow warrior.','',26124),
(127170,'enUS','You seem like one of strong will, but my will is stronger. As is my my mind.','',26124),
(127171,'enUS','I look forward to our match, warrior. If you should survive to see it.','',26124),
(127172,'enUS','I now know what the shaman meant. I have learned humility, and have grown stronger because of it.','',26124),
(127173,'enUS','Thank you, warrior.','',26124),
(127174,'enUS','Battlelord $p! Over here!','',26124),
(127175,'enUS','I hope you\'ve come prepared, Battlelord. I\'ve brought some supplies with me, should you need them.','',26124),
(127176,'enUS','When you\'re ready to fight, challenge Damrul the Stronk. Then stand on the rune and the fight will begin.','',26124),
(127177,'enUS','When you\'re ready to fight, challenge Damrul the Stronk. Then stand on the rune and the fight will begin.','',26124),
(127178,'enUS','I hope you\'re prepared, Battlelord. I\'ve brought supplies with me as well, should you need them.','',26124),
(127179,'enUS','Battlelord $p! Over here!','',26124),
(127180,'enUS','','I... can\'t go on...',26124),
(127181,'enUS','','Think... I\'ll just... sit a spell...',26124),
(127182,'enUS','','Jarod! He... he\'s gone. We need to fall back until reinforcements arrive!',26124),
(127183,'enUS','','You\'re not supposed to outlive your grandchildren...',26124),
(127184,'enUS','','%s\'s eyes glaze over as her shotgun falls to the ground.',26124),
(127185,'enUS','','%s collapses onto the floor in despair.',26124),
(127186,'enUS','','You heard the lady! Everybody out!',26124),
(127187,'enUS','We cannot press forward until reinforcements arrive. Fall back, everyone!','',26124),
(127188,'enUS','','Are you prepared to answer the call of glory, $c?',26124),
(127189,'enUS','I\'m prepared! Send me to the Gates of Valor. [Queue for Scenario]','I\'m prepared! Send me to the Gates of Valor. [Queue for Scenario]',26124),
(127190,'enUS','','Is there danger? I can handle it!',26124),
(127191,'enUS','','How\'s it going?',26124),
(127192,'enUS','','You scratch my back, I\'ll claw yours.',26124),
(127193,'enUS','','See you later!',26124),
(127194,'enUS','','May the winds support you.',26124),
(127195,'enUS','','Keep your eyes on the skies!',26124),
(127196,'enUS','','Knock it off!',26124),
(127197,'enUS','','Can you not?',26124),
(127198,'enUS','','Do you want a knife to your throat? It\'s kinda my thing.',26124),
(127199,'enUS','My wounds are deep but I\'ve recovered from worse. Soon, the Legion will have my vengeance!','',26124),
(127200,'enUS','','Kanrethad\'s power belongs to the Burning Legion!',26124),
(127201,'enUS','','You will not disrupt this ritual!',26124),
(127202,'enUS','','Do not let them siphon his power!',26124),
(127203,'enUS','','I have little time for foolishness.',26124),
(127204,'enUS','','What is it you want?',26124),
(127205,'enUS','','What would you ask of old Magatha?',26124),
(127206,'enUS','','Run away, child.',26124),
(127207,'enUS','','Keep your friends close...',26124),
(127208,'enUS','','The Grimtotem shall rise again.',26124),
(127209,'enUS','','Do not pester me, child.',26124),
(127210,'enUS','','I have more power in one finger than you have in your entire body!',26124),
(127211,'enUS','','One of our patrols has been trapped behind this stampede! We must bring them Storm Brew to restore their spirits. But how...',26124),
(127212,'enUS','','Good work! Our troops should be able to stay in the fight until the stampede has finished.',26124),
(127213,'enUS','','I have felled champions and chieftains! You are an insignificant whelpling!',26124),
(127214,'enUS','','Yes?',26124),
(127215,'enUS','','Undeath welcomes you.',26124),
(127216,'enUS','','My axe hungers.',26124),
(127217,'enUS','','Suffer well.',26124),
(127218,'enUS','','Is that all?',26124),
(127219,'enUS','','There is no end to undeath.',26124),
(127220,'enUS','','Quit prodding me!',26124),
(127221,'enUS','','They say pretty girls make graves.',26124),
(127222,'enUS','','Shall I make a grave for you?',26124),
(127223,'enUS','','Netherlord, you\'ve done it! Kanrethad has returned to us.',26124),
(127224,'enUS','','What is it you ask?',26124),
(127225,'enUS','','My blades stay sharp.',26124),
(127226,'enUS','','I live my life in the shadows.',26124),
(127227,'enUS','','Keep your guard up.',26124),
(127228,'enUS','Welcome, warriors, to the Trial of Rage!','',26124),
(127229,'enUS','','Do not linger.',26124),
(127230,'enUS','','There is much to be done.',26124),
(127231,'enUS','','Get away!',26124),
(127232,'enUS','','Leave me be!',26124),
(127233,'enUS','','Oh, you\'d prefer I play the role of the monster?',26124),
(127234,'enUS','Our first combatants are the mighty Battlelord $p and the infamous drogbar, Damrul the Stronk!','',26124),
(127235,'enUS','','Is he alive?',26124),
(127236,'enUS','Reports say there is a particularly powerful demon at this location. We should eliminate it quickly!','',26124),
(127238,'enUS','A powerful agent of the Legion is nearby. They are too risky to ignore, you must defeat them!','',26124),
(127239,'enUS','I\'m gonna toss you around like a ragdoll, $r!','',26124),
(127240,'enUS','The presence of this foe poses a great threat to our armies. Defeat it to buy us more time to prepare!','',26124),
(127241,'enUS','Well struck, like a true archmage! It doesn\'t have quite the same ring to it...','',26124),
(127242,'enUS','Thank you, champion. You have brought us a brief respite from their endless assaults.','',26124),
(127243,'enUS','Another victory for the Armies of Legionfall. We must not let this advantage go to waste!','',26124),
(127244,'enUS','$n wants to know: Do you feel lucky? Come talk to Lord Winifred Browne and test your... gold-earning potential.','',26124),
(127245,'enUS','I have no desire to rejoin the council, though it is good to be among its members.','',26124),
(127246,'enUS','There certainly is a great deal of carnage in the fighting ring today. Moreso than usual, I\'d say. I think I got hit with a tooth.','',26124),
(127247,'enUS','I sense a powerful foe nearby. Strike with all your rage to banish it from our world!','',26124),
(127248,'enUS','Another Legion insect has scurried forth from beneath its rock. Demonstrate the might of our armies!','',26124),
(127249,'enUS','This rabble dares set foot on Azeroth again. Show them the same treatment they have shown countless other worlds. Eradicate them.','',26124),
(127250,'enUS','They were not prepared!','',26124),
(127251,'enUS','For each we strike down, another shall return. Remain vigilant.','',26124),
(127252,'enUS','We will crush the Legion wherever they appear, until they have been driven back for good.','',26124),
(127253,'enUS','The Legion\'s presence is strong here. Be ready, champion. The Light must prevail!','',26124),
(127254,'enUS','The Legion is rallying around a powerful adversary. We must stop them from gathering more forces!','',26124),
(127255,'enUS','Our patrol has spotted a powerful foe in this area. Its downfall would set back the Legion\'s presence here significantly.','',26124),
(127256,'enUS','Each victory bolsters our advance and empowers our forces. Thank you, champion.','',26124),
(127257,'enUS','A resounding strike against the Legion!','',26124),
(127258,'enUS','The demons will pay for their crimes a thousandfold. Keep up the pressure!','',26124),
(127259,'enUS','Ahhh! Fresh, cool brew!','Ahhh! Fresh, cool brew!',26124),
(127260,'enUS','This brew is especially frothy. It will be just the refreshment I need.','This brew is especially frothy. It will be just the refreshment I need.',26124),
(127261,'enUS','We might not have been able to hold out much longer. Many thanks!','We might not have been able to hold out much longer. Many thanks, $c.',26124),
(127262,'enUS','Battlelord $p\'s next challenger is Omanawkwa Steelhoof of the Highmountain tribe.','',26124),
(127263,'enUS','Let us see if $p\'s skill can break the infamous Steelhoof shield!','',26124),
(127264,'enUS','My shield has fended off armies of warriors. I don\'t believe one $r will be able to pierce it.','',26124),
(127265,'enUS','You come to lift with me, brul?','',26124),
(127266,'enUS','I challenge you to fight!','I challenge you to fight!',26124),
(127267,'enUS','It will be my pleasure to crush you.','',26124),
(127268,'enUS','Do not feel shame when you fall. My defense is impenetrable.','',26124),
(127269,'enUS','It was my honor to be welcomed here by Odyn. I will prove his choice in my strength was not misjudged.','',26124),
(127270,'enUS','The Burning Legion advances on Azsuna! We must thin their ranks to expose the heart of their threat!','',26124),
(127271,'enUS','<Present the VIP Room Rental Form.>','<Present the VIP Room Rental Form.>',26124),
(127272,'enUS','When Bizmo and his team carved this pub into the side of the Deeprun Tram, he took a big risk. Lots of gold went into building this place.\n\nSo he built this VIP Room. The Boom Room, he calls it. Better views of the fight, all the top-shelf drinks you can buy, and the satisfaction of knowing that you can get into an exclusive, members-only club. For you see - he only lets you up if you\'re Rank 8 or higher.\n\nYou want to get into the Boom Room? Keep winning your fights, kid.','',26124),
(127273,'enUS','You\'re Rank 8, right?\n\nYou\'re good. Come on in.','',26124),
(127274,'enUS','Here\'s the low-down. You may not have EARNED the right to enter the Boom Room, but someone nicer than you paid me to let you in.\n\nYou\'re good. Come on in. And don\'t make a mess.','',26124),
(127275,'enUS','','$n has turned in enough gold to bend the rules of the arena. Speak to a bouncer if you\'d like to fight against a random brawler!',26124),
(127276,'enUS','Bizmo\'s Boom Room has opened its doors to all brawlers, courtesy of $n!','',26124),
(127277,'enUS','','This round\'s on $n! Free drinks for the next two minutes!',26124),
(127278,'enUS','The Felborne were given gems of insidious power from the Legion. Rip these baubles from their hands and destroy them. The lives of these elves are now forfeit.','',26124),
(127279,'enUS','The fel energies inside those crystals dissipated upon their destruction. Consider their threat neutralized.','',26124),
(127280,'enUS','The Legion is attempting to repair a fel reaver using an unstable ritual. Go, disrupt their efforts, and turn their own energies against them.','',26124),
(127281,'enUS','Intimidation is a weapon of the Legion. Intelligence is not.','',26124),
(127282,'enUS','The demonic presence recedes, but this is no time to be complacent. I await your arrival outside the Temple. It\'s time we press our advance.','',26124),
(127283,'enUS','Bow before the might of the Burning Legion! Your efforts are meaningless, mortals!','',26124),
(127284,'enUS','Bruh...','',26124),
(127285,'enUS','|TInterface\\Icons\\SPELL_SHADOW_SOULLEECH_1.BLP:20|t%s begins |cFFFF0000|Hspell:236133|h[Blooming]|h|r !','',26124),
(127290,'enUS','You meddle with powers you do not understand, mortal! Your unwillingness to bow will be your end!','',26124),
(127295,'enUS','','I\'ve been to this trial thousands of times. And every time, I\'ve shown Odyn that his warriors aren\'t worthy to step into the ring with me.',26124),
(127296,'enUS','','You are foolish, $r. But if death is what you need to learn this lesson, then so be it.',26124),
(127297,'enUS','','I WILL NOT YIELD TO THE LIKES OF YOU, PEASANT!',26124),
(127298,'enUS','Battlelord $p\'s next opponent is Asrea Moonblade of the proud nightborne of Suramar.','',26124),
(127299,'enUS','Her blade has felled many a warrior inside this ring. Can the Battlelord find a way to triumph?','',26124),
(127300,'enUS','','It\'s been a while since my blade has tasted blood. I wonder if it will be pleased with yours...',26124),
(127302,'enUS','Thank you, champion. Please, free the others as well!','Thank you, champion. Please, free the others as well!',26124),
(127303,'enUS','Thank you, champion. Please, free the others as well!','Thank you, champion. Please, free the others as well!',26124),
(127306,'enUS','Together we will crush the Burning Legion, Archmage $n!','',26124),
(127307,'enUS','Allow me to open a portal.','',26124),
(127308,'enUS','I... have failed.','',26124),
(127309,'enUS','The Burning Legion will fall!','',26124),
(127310,'enUS','I am ready to begin the final assault. [Queue for Scenario]','I am ready to begin the final assault. [Queue for Scenario]',26124),
(127311,'enUS','Disa, Nethos, Tael\'thos! Form ranks! I want that infestation expunged!','',26124),
(127312,'enUS','Wait! Stop, I... I cannot go on. You\'re clearly the stronger brul here.','',26124),
(127313,'enUS','Convenient of Erdris to reveal just who we should take care of! They should be near the farmstead. Let\'s go!','',26124),
(127314,'enUS','I yield, Battlelord. You have proven yourself beyond a shadow of a doubt to be the superior warrior.','',26124),
(127315,'enUS','Death comes soon.','',26124),
(127316,'enUS','Call out to your troops, \"my lord\". I will raise them, make them stronger!','',26124),
(127317,'enUS','To me, my troops! I require your strength!','',26124),
(127318,'enUS','Yes... arise... fight the \"Legion\"!','',26124),
(127319,'enUS','Huntmaster, gather your flares. Beasts of the shadows are controlling vital ground for the Legion. Reveal these creatures so that our archers might rain destruction down upon them.','',26124),
(127320,'enUS','Impressive. Even the most powerful of magics can be undone with the right tools.','',26124),
(127321,'enUS','Savor this victory while you can. I have studied your tactics... learned your weaknesses. Now I will raise my own army within Black Rook Hold!','',26124),
(127322,'enUS','Foul demons are using our wounded allies as bait! We need every soldier back on the front line. Get in there and get them moving... and be mindful of the shadows.','',26124),
(127323,'enUS','Erdris must be located. I will scout the hold and send word when it is time to strike. See you soon, $n.','',26124),
(127324,'enUS','Better our forces be revived and fighting with us than to serve as fuel for the fel.','',26124),
(127325,'enUS','The Legion has begun to corrupt beasts. One of them has taken up residence in a cave amongst the murlocs. It must be eliminated!','',26124),
(127327,'enUS','The Mage Tower crackles as time stops!','The Mage Tower crackles as time stops!',26124),
(127328,'enUS','An excellent first round! It seems Damrul underestimated the strength of Battlelord $p.','',26124),
(127329,'enUS','The vaunted Steelhoof defense has fallen before $p\'s skill! But will that skill be enough to best the next challenger?','',26124),
(127330,'enUS','A melee for the ages! Asrea has been so dominant that many spectators considered her unbeatable. It would seem her hubris has ushered in her downfall!','',26124),
(127331,'enUS','Battlelord $p, when you are ready to face your final challenger, step onto the rune.','',26124),
(127332,'enUS','The Battlelord has bested all challengers! The trial is complete!','',26124),
(127333,'enUS','Let us revel in our champion\'s victory! All hail the Battlelord!','',26124),
(127334,'enUS','Eyir has sent her finest pupil to serve as Battlelord $p\'s final challenger. I present to you... Aspirant Thyri!','',26124),
(127335,'enUS','Will Battlelord $p\'s martial prowess be enough to vanquish one favored in the eyes of Eyir?','',26124),
(127336,'enUS','','When I defeat you, I shall be one step closer to ascension.',26124),
(127337,'enUS','','I... I can\'t believe I lost. Perhaps I am not worthy to ascend...',26124),
(127338,'enUS','Fools! Gaze into the skies beyond as the end of your world approaches!','',26124),
(127339,'enUS','The connection is down! We must act quickly, $n. Let us rendezvous at Farondale. The final fight is at hand.','',26124),
(127340,'enUS','The power is yours, $n. End this.','',26124),
(127341,'enUS','I\'m ready to go. Summon a portal, please.','I\'m ready to go. Summon a portal, please.',26124),
(127342,'enUS','Can I take a ride on your balloon?','Can I take a ride on your balloon?',26124),
(127343,'enUS','Now I\'m all melancholy.','',26124),
(127344,'enUS','Anybody know any good jokes? Here, I\'ll start...','',26124),
(127345,'enUS','Why do dwarf hunters use guns?','',26124),
(127346,'enUS','Because ye can\'t drink ale from the barrel of a bow!','',26124),
(127347,'enUS','Heh. It\'s okay for me to tell that one because I\'m a dwarf. And a hunter!','',26124),
(127348,'enUS','Heh, that brightened me spirit. Thanks fer keepin\' an ol\' hunter company!','',26124),
(127349,'enUS','I can take you back to Skyhold when you\'re ready to leave, Battlelord.','',26124),
(127350,'enUS','I can take you back to Skyhold when you\'re ready to leave, Battlelord.','',26124),
(127351,'enUS','','Welcome to the Kirin Tor Tavern Crawl, $n.  Help yourself to all the drinks and free food you can handle.  We\'ll be leaving for the next tavern in a couple minutes.',26124),
(127352,'enUS','It is an honor to be here for you, Battlelord. I hope you are victorious in your trials.','',26124),
(127353,'enUS','What have you brought with you?','What have you brought with you?',26124),
(127354,'enUS','I\'m ready to go back to Skyhold.','I\'m ready to go back to Skyhold.',26124),
(127355,'enUS','Teleport me to the tavern crawl.','Teleport me to the tavern crawl.',26124),
(127356,'enUS','I\'m ready to begin the trial, Odyn.','I\'m ready to begin the trial, Odyn.',26124),
(127357,'enUS','The Legion corrupts everything it touches! Destroy their fel corruptors before all of Stormheim is tainted!','',26124),
(127358,'enUS','Well done! Scars of the Legion\'s presence may linger for a time, but fade they shall.','',26124),
(127359,'enUS','The shattered core of a fallen fel reaver is giving rise to a host of aberrations! Recover the core fragments before the Legion can salvage their creation!','',26124),
(127360,'enUS','Tar starts to seep from the ground around %s...','',26124),
(127361,'enUS','|TInterface\\Icons\\INV_Misc_Food_Legion_gooOil_multi.blp:20|tThe tar pits start |cFFFF0000|Hspell:236333|h[Erupting]|h|r !','',26124),
(127362,'enUS','','Your kind will be cleansed from this world!',26124),
(127363,'enUS','','You will burn in power you cannot comprehend!',26124),
(127364,'enUS','Our rumbler today is a beefy mammal with a taste for vengeance. He doesn\'t want to help you... he wants to kill you. It\'s the enmity moose, Grief Warden!','',26124),
(127365,'enUS','Our rumbler today is pack of pecky penguins from the polar precipices of Northrend. Beware the Slippy Stampede!','',26124),
(127366,'enUS','These three pandaren have a challenge for you... pull one of your beer carts to the middle of the ring before they can pull theirs. Winning team gets to drink it!','',26124),
(127367,'enUS','H-I-P-P-O spells death! Try not to be trampled by our next rumbler, Senya!','',26124),
(127368,'enUS','You don\'t have to beat these creatures, you just have to survive. Oh, and we\'re taking away all your gear and experience, too. Enjoy the Stranglethorn Run!','',26124),
(127369,'enUS','If you can\'t beat him, join him! Prepare to have your minds, faces, and frozen drinks melted by the one and only, Mindbreaker Gzzaj!','',26124),
(127370,'enUS','She\'s all grown up and ready to rumble. Sure, she looks like a sweet kitty now, but wait until she\'s backed into a corner. Steer clear of our next rumbler, Mazhareen!','',26124),
(127371,'enUS','','Our rumbler today is a beefy mammal with a taste for vengeance. He doesn\'t want to help you... he wants to kill you. It\'s the enmity moose, Grief Warden!',26124),
(127372,'enUS','','Our rumbler today is pack of pecky penguins from the polar precipices of Northrend. Beware the Slippy Stampede!',26124),
(127373,'enUS','','These three pandaren have a challenge for you... pull one of your beer carts to the middle of the ring before they can pull theirs. Winning team gets to drink it!',26124),
(127374,'enUS','','H-I-P-P-O spells death! Try not to be trampled by our next rumbler, Senya!',26124),
(127375,'enUS','','You don\'t have to beat these creatures, you just have to survive. Oh, and we\'re taking away all your gear and experience, too. Enjoy the Stranglethorn Run!',26124),
(127376,'enUS','','If you can\'t beat him, join him! Prepare to have your minds, faces, and frozen drinks melted by the one and only, Mindbreaker Gzzaj!',26124),
(127377,'enUS','','She\'s all grown up and ready to rumble. Sure, she looks like a sweet kitty now, but wait until she\'s backed into a corner. Steer clear of our next rumbler, Mazhareen!',26124),
(127378,'enUS','I can\'t believe it... they won! It\'s a miracle! Just kidding, this happens all the time.','I can\'t believe it... they won! It\'s a miracle! Just kidding, this happens all the time.',26124),
(127379,'enUS','The rumbling has ceased... and our heroes are the champions! Big, bulging purses of gold to all involved.','The rumbling has ceased... and our heroes are the champions! Big, bulging purses of gold to all involved.',26124),
(127380,'enUS','Hmph. I\'m pretty sure more than one of you wasn\'t paying attention.','Hmph. I\'m pretty sure more than one of you wasn\'t paying attention.',26124),
(127381,'enUS','Is it me, or does it smell like victory in here?','Is it me, or does it smell like victory in here?',26124),
(127382,'enUS','What a shame, what a shame.','What a shame, what a shame.',26124),
(127383,'enUS','You lose! You get nothing!','You lose! You get nothing!',26124),
(127384,'enUS','Umm... thanks for trying?','Umm... thanks for trying?',26124),
(127385,'enUS','You almost had that one. Next time.','You almost had that one. Next time.',26124),
(127386,'enUS','The Grand Ballroom door in the Broken Stair opens.','The Grand Ballroom door in the Broken Stair opens.',26124),
(127387,'enUS','[OLD DNT] $n, our assault on the southern beach is being met with heavy resistance.','',26124),
(127388,'enUS','[OLD DNT] I need you to lead my forces and the orders in battle while I command the other fronts!','',26124),
(127389,'enUS','[OLD DNT] We must take the ruins on the western side of the island. From there we can funnel all of our forces toward the soul engine!','',26124),
(127390,'enUS','[OLD DNT] Today the legion will fall! For Azeroth!','',26124),
(127391,'enUS','','I love your glasses. So vintage.',26124),
(127392,'enUS','','And now we wait. This fight will be glorious!',26124),
(127393,'enUS','Vethir\'s brood has been captured... again! Free them, so they can aid our fight against this onslaught.','',26124),
(127394,'enUS','Heroes, return to me. Vethir\'s brood has joined our battle against these invaders. Take to the skies and claim victory!','',26124),
(127395,'enUS','The Legion must be stricken from the sky! The drakes will carry you to the demons\' flying fortress. From there, you can sabotage their infernal vessel.','',26124),
(127396,'enUS','You took down their commander. Well done! Vethir\'s drakes will see you to safety. I shall strike the final blow against their foul vessel myself!','',26124),
(127397,'enUS','A fine victory, champions! Songs of your glory will be sung through the Halls of Valor for ages to come.','',26124),
(127398,'enUS','','Hello, $n.  Did you know there\'s a tavern crawl going on today, sponsored by the Kirin Tor?  In fact, I can teleport you to the tavern where everyone is hanging out.',26124),
(127399,'enUS','','Now that Daumyr and her brood are ours, the tide is about to turn!',26124),
(127400,'enUS','','Don\'t get me wrong... the Four Horsemen are most impressive. But giant undead dragons...',26124),
(127401,'enUS','','When the demons catch sight of our brood, they may well die of fright!',26124),
(127402,'enUS','','And if not, I\'ll happily hack them to pieces with my axe. Either way, no skin off my back!',26124),
(127403,'enUS','','...If my back had any skin left, that is.',26124),
(127404,'enUS','The Legion will conquer all! Your pathetic Halls will be turned to dust.','',26124),
(127405,'enUS','Enough of your meddling! Come and seek me out, if your dare!','',26124),
(127406,'enUS','','You are beneath me.',26124),
(127407,'enUS','','Lord Illidan will welcome your death!',26124),
(127408,'enUS','','This will be quick.',26124),
(127409,'enUS','','You will drown!',26124),
(127410,'enUS','','Sink or swim!',26124),
(127411,'enUS','','Are you sure you need my aid?',26124),
(127412,'enUS','','Slayer. I suppose I have time to help you.',26124),
(127413,'enUS','','Can we do something more interesting this time?',26124),
(127414,'enUS','','Fear the Coilskar!',26124),
(127415,'enUS','','You bore me.',26124),
(127416,'enUS','','You should have learned to swim.',26124),
(127417,'enUS','','Food for the fish!',26124),
(127419,'enUS','','The Coilskar always get our way.',26124),
(127421,'enUS','','This is not...possible...',26124),
(127422,'enUS','','You will have to do this... without me...',26124),
(127423,'enUS','','I do not accept... this outcome...',26124),
(127424,'enUS','','I will send you to a watery grave!',26124),
(127425,'enUS','','I suppose I will do this... for you.',26124),
(127426,'enUS','','Let\'s roll up our sleeves and get to work!',26124),
(127427,'enUS','','Grandmaster, I\'ve got your back!',26124),
(127428,'enUS','','I promise I won\'t let you fall, Grandmaster!',26124),
(127429,'enUS','','I bet you have no appreciation for good brew!',26124),
(127430,'enUS','','You\'ll never get through my mists!',26124),
(127431,'enUS','','Bet you\'ve never seen a spinning kick like mine!',26124),
(127432,'enUS','','I\'m gonna knock you out!',26124),
(127433,'enUS','','Oh, goody! I could use more combat practice!',26124),
(127434,'enUS','','Take that!',26124),
(127435,'enUS','','I can\'t believe I wasted my chi on the likes of you!',26124),
(127436,'enUS','','Hey, I\'m getting pretty good at this!',26124),
(127437,'enUS','','Was that really the best you had?',26124),
(127438,'enUS','','Ouch! Maybe I should have stayed at the brewery...',26124),
(127439,'enUS','','I\'m going to need a double after this...',26124),
(127440,'enUS','','Sorry to disappoint you, Grandmaster...',26124),
(127441,'enUS','','Die or get out of the way! Woa...oah...oah...oah!',26124),
(127442,'enUS','','Wow! I will do my best, Grandmaster!',26124),
(127443,'enUS','','Care for some of my special brew?',26124),
(127444,'enUS','','Hello there, hero!',26124),
(127445,'enUS','','I am ready for anything!',26124),
(127446,'enUS','','Let\'s share a brew sometime!',26124),
(127447,'enUS','','Good luck out there!',26124),
(127448,'enUS','','Can I come with you?',26124),
(127449,'enUS','','Hahaha! Stop it! That tickles!',26124),
(127450,'enUS','','Okay, okay... Enough already!',26124),
(127451,'enUS','','Seriously, stop! I\'ll practice my spinning kick on you!',26124),
(127452,'enUS','','Maybe... I\'m not cut out for this... after all...',26124),
(127453,'enUS','The balloon will leave once we have three riders ready to go.','The balloon will leave once we have three riders ready to go.',26124),
(127454,'enUS','Bal\'a dash, Archmage. We fight as one!','',26124),
(127455,'enUS','We will aid the Tirisgarde!','',26124),
(127456,'enUS','Together we will save Azeroth!','',26124),
(127457,'enUS','We will incinerate this darkness!','',26124),
(127458,'enUS','Another target to destroy!','',26124),
(127459,'enUS','Time to light a fire!','',26124),
(127460,'enUS','Your group has elected to kick Schnottz from the balloon!','',26124),
(127461,'enUS','Diel fin\'al!','',26124),
(127462,'enUS','Burn!','',26124),
(127463,'enUS','You are nothing.','',26124),
(127464,'enUS','You have failed.','',26124),
(127465,'enUS','Diel ma\'ahn orindel\'o.','',26124),
(127466,'enUS','To the sunless realm with you!','',26124),
(127467,'enUS','Must regain... strength...','',26124),
(127468,'enUS','I require... a respite.','',26124),
(127469,'enUS','My best...was not enough...','',26124),
(127470,'enUS','Anar\'alah belore, you will burn!','',26124),
(127471,'enUS','I will do my best, Archmage.','',26124),
(127472,'enUS','What is it?','',26124),
(127473,'enUS','Do you find my discomfort amusing?','',26124),
(127474,'enUS','Enough of your childish antics!','',26124),
(127475,'enUS','Tal anu\'men no Tirisgarde!','',26124),
(127476,'enUS','Hail, Battlelord. I fight with you.','',26124),
(127477,'enUS','Our fury will save Azeroth!','',26124),
(127478,'enUS','We must destroy this evil.','',26124),
(127479,'enUS','My axe hungers for blood!','',26124),
(127480,'enUS','For the Horde!','',26124),
(127481,'enUS','Lok-tar ogar!','',26124),
(127482,'enUS','Aaaaaaagh!','',26124),
(127483,'enUS','There is joy in victory!','',26124),
(127484,'enUS','My fury is unending!','',26124),
(127485,'enUS','All too easy.','',26124),
(127486,'enUS','','Are you sure you need my aid?',26124),
(127487,'enUS','My fury is... sated...','',26124),
(127488,'enUS','I am weakened...','',26124),
(127489,'enUS','My axe will rise again...','',26124),
(127490,'enUS','Cower before my fury!','',26124),
(127491,'enUS','Zug-zug. I will not fail you, Battlelord $n.','',26124),
(127492,'enUS','Throm-ka!','',26124),
(127493,'enUS','Yes?','',26124),
(127494,'enUS','Hail, friend.','',26124),
(127495,'enUS','Stay strong.','',26124),
(127496,'enUS','Keep your weapons sharp.','',26124),
(127497,'enUS','Goodbye.','',26124),
(127498,'enUS','What?','',26124),
(127499,'enUS','My axe grows thirsty.','',26124),
(127500,'enUS','Do not provoke my fury!','',26124),
(127502,'enUS','Greetings, Battlelord. I\'m ready to fight!','',26124),
(127503,'enUS','We will defend Azeroth to the death!','',26124),
(127504,'enUS','Together we will destroy our enemies!','',26124),
(127505,'enUS','I shall destroy you!','',26124),
(127506,'enUS','Feel my fury!','',26124),
(127507,'enUS','Wraaaaaaagh!','',26124),
(127508,'enUS','I will rip you to shreds!','',26124),
(127509,'enUS','I will sharpen my claws on your hide!','',26124),
(127510,'enUS','For the Alliance!','',26124),
(127511,'enUS','My claws drip with your blood!','',26124),
(127512,'enUS','Your death fuels my rage!','',26124),
(127513,'enUS','My claws... are dulled...','',26124),
(127514,'enUS','Battlelord, I have... failed you...','',26124),
(127515,'enUS','My rage subsides... for now...','',26124),
(127516,'enUS','You will fall beneath the fury of my claws!','',26124),
(127517,'enUS','Of course I will succeed, Battlelord.','',26124),
(127518,'enUS','Is there trouble afoot?','',26124),
(127519,'enUS','Hello.','',26124),
(127520,'enUS','Do you need something?','',26124),
(127521,'enUS','Stand strong.','',26124),
(127522,'enUS','For the Alliance.','',26124),
(127523,'enUS','My claws are sharp and ready for action.','',26124),
(127524,'enUS','What is it?','',26124),
(127525,'enUS','My rage is growing...','',26124),
(127526,'enUS','I\'m about to lose control... and I think I like it!','',26124),
(127527,'enUS','Free at last!','',26124),
(127528,'enUS','So many things to burn, hehehe!','',26124),
(127529,'enUS','Where to go now...','',26124),
(127530,'enUS','I\'m gonna have so much fun! Hahaha!','',26124),
(127531,'enUS','Do you have any Artifact Research already prepared?','Do you have any Artifact Research already prepared?',26124),
(127532,'enUS','You are not worthy of the sun!','',26124),
(127533,'enUS','|TInterface\\Icons\\ability_fixated_state_red:20|tKaram starts to chase you!','|TInterface\\Icons\\ability_fixated_state_red:20|tKaram starts to chase you!',26124),
(127534,'enUS','|TInterface\\Icons\\INV_MISC_SHADOWEGG.BLP:20|tRaest |cFFFF0000|Hspell:235446|h[Tears]|h|r Rifts to the Nether!','|TInterface\\Icons\\INV_MISC_SHADOWEGG.BLP:20|tRaest |cFFFF0000|Hspell:235446|h[Tears]|h|r Rifts to the Nether!',26124),
(127535,'enUS','|TInterface\\Icons\\ABILITY_CREATURE_DISEASE_05.BLP:20|tA demonic hand from beyond begins to cast |cFFFF0000|Hspell:235578|h[Grasp from Beyond]|h|r!','|TInterface\\Icons\\ABILITY_CREATURE_DISEASE_05.BLP:20|tA demonic hand from beyond begins to cast |cFFFF0000|Hspell:235578|h[Grasp from Beyond]|h|r!',26124),
(127536,'enUS','|TInterface\\Icons\\ability_fixated_state_red:20|tKaram starts chasing you again!','|TInterface\\Icons\\ability_fixated_state_red:20|tKaram starts chasing you again!',26124),
(127537,'enUS','|TInterface\\Icons\\SPELL_MAGE_RUNEOFPOWER.BLP:20|tRaest projects a |cFFFF0000|Hspell:236460|h[Rune of Summoning]|h|r nearby!','|TInterface\\Icons\\SPELL_MAGE_RUNEOFPOWER.BLP:20|tRaest projects a |cFFFF0000|Hspell:236460|h[Rune of Summoning]|h|r nearby!',26124),
(127538,'enUS','|TInterface\\Icons\\ACHIEVEMENT_BOSS_GENERALVEZAX_01.BLP:20|tA Rune of Summoning conjures a |cFFFF0000|Hspell:236461|h[Thing of Nightmare]|h|r to chase you down!','|TInterface\\Icons\\ACHIEVEMENT_BOSS_GENERALVEZAX_01.BLP:20|tA Rune of Summoning conjures a |cFFFF0000|Hspell:236461|h[Thing of Nightmare]|h|r to chase you down!',26124),
(127539,'enUS','Take down Dread Commander Arganoth! We will deal with the rest.','',26124),
(127540,'enUS','','[OLD DNT] Lord Illidan, it is nice of you to finally arrive... Wardens, let\'s do the real work while the demon hunters play with their bats.',26124),
(127541,'enUS','|TInterface\\Icons\\ability_fixated_state_red:20|tKaram starts chasing you one last time!','|TInterface\\Icons\\ability_fixated_state_red:20|tKaram starts chasing you one last time!',26124),
(127542,'enUS','Stay strong in this time of unrest.','',26124),
(127543,'enUS','You are a beacon of light in the darkness.','',26124),
(127544,'enUS','We are a force of balance in a chaotic ocean.','',26124),
(127545,'enUS','We serve all of Azeroth.','',26124),
(127546,'enUS','Evil cannot take root if our hearts stay pure.','',26124),
(127547,'enUS','We will not rest until the Legion is defeated.','',26124),
(127548,'enUS','Please, leave me be. I am meditating.','',26124),
(127549,'enUS','You are making it very difficult for me to control my thoughts, little one.','',26124),
(127550,'enUS','I learned a new technique called \"Kick the Hornet\'s Nest!\" Shall I demonstrate it on you?','',26124),
(127551,'enUS','','Have you had any brew today?',26124),
(127552,'enUS','Filthy slime! Slow down!','',26124),
(127553,'enUS','Come back! I need your core fragments!','',26124),
(127554,'enUS','','Good brew requires an abundance of love.',26124),
(127555,'enUS','Why slime move so fast?','',26124),
(127556,'enUS','','One must always make time for new brews.',26124),
(127557,'enUS','','Nothing beats a brew shared between friends.',26124),
(127558,'enUS','','You never know what wonders you will see!',26124),
(127559,'enUS','','May you sample many brews, my friend!',26124),
(127560,'enUS','','That is quite enough, thank you.',26124),
(127561,'enUS','','Is your head as empty as your mug?',26124),
(127562,'enUS','','Best not test my patience! The storm answers my call!',26124),
(127563,'enUS','How long was I stuck like that?','How long was I stuck like that?',26124),
(127564,'enUS','Thank you, $ct. I\'m going back to camp!','Thank you, $ct. I\'m going back to camp!',26124),
(127565,'enUS','I\'m never stepping foot near another basilisk again!','I\'m never stepping foot near another basilisk again!',26124),
(127566,'enUS','We sent troops to survey this area, only to have them fall prey to the stares of basilisks! Use this magical salve to free our stone-bound scouts.','',26124),
(127567,'enUS','The salve worked? I mean... yes, of course it worked. Nicely done, champion.','',26124),
(127570,'enUS','You paladins are so predictable. Come, let us see what power your blade truly possesses...','',26124),
(127571,'enUS','This land will never heal...','',26124),
(127572,'enUS','You will not interrupt our work. This ground belongs to the Legion!','',26124),
(127582,'enUS','','D\'Bynn and I will make our way to the lodge, should you need us.',26124),
(127583,'enUS','','Look out, folks, Klunk\'s gonna klunk you up!',26124),
(127584,'enUS','Look out, folks, Klunk\'s gonna klunk you up!','',26124),
(127585,'enUS','','Together we will protect our home from the Burning Legion.',26124),
(127586,'enUS','','We will not be stopped!',26124),
(127587,'enUS','Such massive Legion war machines are ill-suited to this terrain. They should think twice before sending another!','',26124),
(127588,'enUS','Slayer, you are needed on the front lines. Rip the essences from the demons pouring forth from the Tomb and use these empowered souls to sunder the pit lord in two!','',26124),
(127589,'enUS','Pit lords. Bah! They are arrogance made flesh. The essences from those fallen demons may prove useful in further battles.','',26124),
(127590,'enUS','The fewer fel-corrupted beasts, the better.','',26124),
(127591,'enUS','You seek the commander? Then face me, weaklings!','',26124),
(127592,'enUS','','A threat must be dispatched. Be swift about it.',26124),
(127593,'enUS','','A threat looms near. Eliminate the target.',26124),
(127594,'enUS','','Time to deliver a message to the Legion. Send this one back in pieces!',26124),
(127595,'enUS','','We have much work to do. Grant this demon a swift death.',26124),
(127596,'enUS','','Our scouts report a significant threat in this area. Wipe it out!',26124),
(127597,'enUS','','Just ahead... a new target. Send it screaming back to the Twisting Nether!',26124),
(127598,'enUS','','Demons multiply like rats. Slay this one before it summons more of its foul kin into our world!',26124),
(127599,'enUS','','A potent threat lurks nearby. Seek it out and destroy it!',26124),
(127600,'enUS','','Well struck, champion. Remain on your guard.',26124),
(127601,'enUS','','A fitting end to a vile invader.',26124),
(127602,'enUS','','Message delivered!',26124),
(127603,'enUS','','That was more mercy than the fiend deserved. On to the next target!',26124),
(127604,'enUS','','Impressive! That wretch didn\'t stand a chance.',26124),
(127605,'enUS','','Well done! Your skills are sharper than any weapon of the Legion.',26124),
(127606,'enUS','','Victory by victory, we push back against  the tide of this invasion. Well done!',26124),
(127607,'enUS','','Another menace eradicated. Excellent!',26124),
(127608,'enUS','This place is fraught with demon filth. A prime target approaches!','',26124),
(127609,'enUS','The Legion has unleashed another of its pawns. Dispose of this threat at once.','',26124),
(127610,'enUS','This agent of the Legion underestimates your might. Make plain the error of its ways.','',26124),
(127611,'enUS','A target nears. Send this filth back to the Nether!','',26124),
(127612,'enUS','A malignant foe is near. Do what must be done!','',26124),
(127613,'enUS','I sense a nearby target. Strike swiftly!','',26124),
(127614,'enUS','Ah yes, the unmistakable stench of Legion filth. Seek out the source and destroy it!','',26124),
(127615,'enUS','Another of the Legion\'s minions draws near. Eradicate it!','',26124),
(127616,'enUS','The growth of your power is most impressive. The Legion knows your name... and fears it.','',26124),
(127617,'enUS','Every blow struck against the Legion forces them closer to their end.','',26124),
(127618,'enUS','This game will soon be at an end. The Burning Legion will fall.','',26124),
(127619,'enUS','Relish the satisfaction of dispatching yet another Legion lapdog!','',26124),
(127620,'enUS','An impressive victory. Your resolve remains unwavering.','',26124),
(127621,'enUS','The Legion cannot run or hide. We will hunt them down!','',26124),
(127622,'enUS','That fiend earned its death a thousand times over. Now it shall suffer the wrath of its vile master.','',26124),
(127623,'enUS','Savor that moment when the rage in a demon\'s eyes gives way to fear. We will break them!','',26124),
(127625,'enUS','Greetings, warlock. I come before your council with a discovery I believe you will find intriguing.','',26124),
(127626,'enUS','Much time has passed since we first pierced the veil into the plane of Xoroth, but a new opportunity beckons us back to the realm of the dreadsteeds.','',26124),
(127627,'enUS','Meet with me in Dreadscar Rift, and I will explain.','',26124),
(127628,'enUS','I\'m glad to make your acquaintance, Netherlord.','',26124),
(127629,'enUS','Why have you called me here?','Why have you called me here?',26124),
(127630,'enUS','Let me cut right to the chase:\n\nEver since I was \"displaced\" by the Blackrock orcs in the Burning Steppes, I have continued my research into the dreadsteeds of Xoroth in hiding. During one of my rituals, I managed to capture an odd demon from the other side - one of the ones we call a \"wyrmtongue.\"\n\nAfter several weeks of questioning, the demon revealed that Lord Hel\'nurath has been working to create a more powerful steed for the fel knights of Xoroth.\n\nHe calls it the Wrathsteed.','',26124),
(127631,'enUS','Go on...','Go on...',26124),
(127632,'enUS','While the wyrmtongue knew little of the steed itself, it is clear that Hel\'nurath has thus far only been able to create one. He has gifted it to his greatest general, the fel knight Arax\'ath. The tricky part is that Arax\'ath seldom leaves Xoroth, preferring to command his armies from afar.\n\nHowever, I think we might be able to draw him out. For that, I will require your help.\n\nAre you up to the challenge?','',26124),
(127633,'enUS','The Wrathsteed will be mine!','The Wrathsteed will be mine!',26124),
(127634,'enUS','Excellent. I knew you would not disappoint.','',26124),
(127635,'enUS','Now we have preparations to make.','',26124),
(127636,'enUS','In order to draw out Arax\'ath, we will need to create a portal capable of a sustained link to Xoroth. This will be far more difficult than our standard portals, and will require substantial resources.','',26124),
(127637,'enUS','With the materials you\'ve gathered, we\'re well on our way to claiming the Wrathsteed for our own. \n\nWhile we work on constructing the portal, you should focus your efforts on obtaining a lure that will draw Arax\'ath and the Wrathsteed through.','',26124),
(127638,'enUS','Ooh... that\'s nice... Wait, what did you want..?','Ooh... that\'s nice... Wait, what did you want..?',26124),
(127639,'enUS','Oh my... what lovely... hooves you have...','Oh my... what lovely... hooves you have...',26124),
(127640,'enUS','Well... if you put it that way...','Well... if you put it that way...',26124),
(127641,'enUS','Our leader..? I don\'t know...','Our leader..? I don\'t know...',26124),
(127642,'enUS','What? I\'m not leader enough for you?','What? I\'m not leader enough for you?',26124),
(127643,'enUS','Leader, you say..? You can boss me around any time...','Leader, you say..? You can boss me around any time...',26124),
(127644,'enUS','...enough of this! I\'ll end you, demon!','...enough of this! I\'ll end you, demon!',26124),
(127645,'enUS','...no... I will not... betray the Legion!','...no... I will not... betray the Legion!',26124),
(127646,'enUS','...what am I saying? Die, warlock!','...what am I saying? Die, warlock!',26124),
(127647,'enUS','You want... our leader? Of course... anything for you...','You want... our leader? Of course... anything for you...',26124),
(127648,'enUS','Seek Zuriwa... She watches... from her tower.','Seek Zuriwa... She watches... from her tower.',26124),
(127649,'enUS','Wait... what am I doing!? Zuriwa will have my head! Get away from me!','Wait... what am I doing!? Zuriwa will have my head! Get away from me!',26124),
(127650,'enUS','','I will feed ya to tha dreadsteeds!',26124),
(127651,'enUS','','Hel\'nurath will hunt ya, $c...',26124),
(127652,'enUS','Now, let us pierce through the Twisting Nether and take what is ours!','',26124),
(127653,'enUS','Rak-ath varus mir\'enon!','',26124),
(127654,'enUS','Vae Xoroth!','',26124),
(127655,'enUS','Ah, good to see you again, $n.','',26124),
(127656,'enUS','What is this? A mortal wishes to peer into my realm?!','',26124),
(127657,'enUS','The way is open, warlock! Activate the calling stone!','',26124),
(127658,'enUS','What?! You dare try to summon my steed?','',26124),
(127659,'enUS','My hounds will rend the flesh from your bones!','',26124),
(127660,'enUS','Careful, warlock! The bite of these felhunters is venomous to mortals. It should pose no problem for your demons, though!','',26124),
(127661,'enUS','Acolytes! Rain fire upon this insect!','',26124),
(127662,'enUS','Arax\'ath is protecting his acolytes with a fel shield! You\'ll need to dispel it to take them out!','',26124),
(127663,'enUS','The acolytes are forming a ritual circle. Whatever you do, don\'t leave enough of them alive to complete it!','',26124),
(127664,'enUS','Are they insane?! They\'ll destroy us all!','',26124),
(127665,'enUS','My worthless minions may have fallen, but I will not let you prevail.','',26124),
(127666,'enUS','I will cut you down myself!','',26124),
(127667,'enUS','The Wrathsteed will never be yours, mortal!','',26124),
(127668,'enUS','Impossible...','',26124),
(127669,'enUS','Quickly, enslave the Wrathsteed before it escapes!','',26124),
(127670,'enUS','Excellent work! We must convene the council. Only with their combined strength can we bind a beast of such power.','',26124),
(127671,'enUS','So, this is where these infernal pickpockets take their trinkets.$b$bWell, while we\'re here we may as well get some of it back. I made you a theft/shopping list of things to go get.\n\nThis would be the part where some magic wielding illusionist tries to make you look like one of them. Bah! Illusions. No commitment.\n\nI am going to TRANSFORM you into one of these things. How is your method acting?','',26124),
(127672,'enUS','Transform?','Transform?',26124),
(127673,'enUS','How did you beat me through the portal?','How did you beat me through the portal?',26124),
(127674,'enUS','Because I know more about demonic travel than you. Get better.','',26124),
(127675,'enUS','','You are no match for me and my hounds!',26124),
(127676,'enUS','','You will never stand a chance against the Legion!',26124),
(127677,'enUS','','You WILL give me what I want, demon.',26124),
(127678,'enUS','','I will not be denied. Speak.',26124),
(127679,'enUS','','What are they planning, demon?',26124),
(127680,'enUS','','I tire of these games. Speak, or die.',26124),
(127681,'enUS','','Speak!',26124),
(127682,'enUS','','I grow bored. Tell us what we want to know or face your doom.',26124),
(127683,'enUS','You call that a big pack? Ha! I know squiggs and snifflebits that can carry more than you.','',26124),
(127684,'enUS','You have a nose that is ripe for biting.','',26124),
(127685,'enUS','Leave my shinies alone!','',26124),
(127686,'enUS','Shush. The auditors may hear you.','',26124),
(127687,'enUS','What is wrong with your face?','',26124),
(127688,'enUS','Snitchlip and Flivvelskag were sent into the maze and never heard of again. Move on or the auditors will send both of us into the maze.','',26124),
(127689,'enUS','','You will not be rid of the Grimtotem so easily, child. We will earn our place.',26124),
(127690,'enUS','Who sent you? Was it Ragchomp? Tell him it was Trickletooth that took his shiny. It wasn\'t me!','',26124),
(127691,'enUS','Your treasures are small and dull. You should give them to me so that I might \"throw them away.\"','',26124),
(127692,'enUS','Your end is near.','Your end is near.',26124),
(127693,'enUS','You dare interrupt a servant of the Legion!','You dare interrupt a servant of the Legion!',26124),
(127694,'enUS','Your efforts are in vain.','Your efforts are in vain.',26124),
(127695,'enUS','Now you meet your end!','Now you meet your end!',26124),
(127696,'enUS','','You will not regret this choice, Shadowblade. I will take out any Legion demon or conspirator who crosses my path!',26124),
(127697,'enUS','That\'s twice I\'ve almost been killed by demons. They will not get a third chance.','',26124),
(127698,'enUS','Ah, $n. I knew you would make it. I\'ll be ready to face the Legion in no time.','',26124),
(127699,'enUS','Get back to work.','',26124),
(127700,'enUS','Know your place or I shall remind you.','',26124),
(127701,'enUS','You dare speak to me?','',26124),
(127702,'enUS','Get back to work or I shall have you scrubbing the cages of the pits.','',26124),
(127703,'enUS','Are you trying to sneak away with something?','',26124),
(127704,'enUS','Hail, $ct $n. My fury against the Burning Legion is unending!','',26124),
(127705,'enUS','Do not even try to steal anything. We are watching. We are always watching.','',26124),
(127706,'enUS','Something seems... off... about you.','',26124),
(127707,'enUS','You dare interrupt me?','',26124),
(127708,'enUS','The Legion is corrupting the wolves of the Howling Hills to attack Skyhorn. These foul rituals must be stopped!','',26124),
(127709,'enUS','Hail, $c. \n\nI know of Toryl\'s edict - you will know no harm by my blade.','',26124),
(127710,'enUS','Tread carefully, $c. The vrykul of Jandvik are wary of outsiders.','',26124),
(127711,'enUS','I am searching for the vrykul mentioned in these scrolls.','I am searching for the vrykul mentioned in these scrolls.',26124),
(127712,'enUS','I know little of prophecies, but we have seen new faces in Jandvik since the fall of Skovald. \n\nYou should speak to Priestess Bryna. Her dwelling is in the center of the town. She may know of this prophecy you speak.','',26124),
(127713,'enUS','I do not know why you dabble in vrykul prophecy, but the scrolls you carry look genuine. I will alert the vrykul of Jandvik to allow you to pass so you may search for the one you seek. \n\nPriestess Bryna is the most scholarly of the village. Perhaps you should seek her out?','',26124),
(127714,'enUS','Poor pups! At least you saved them from becoming slaves of the Legion. Thank you, champion.','',26124),
(127715,'enUS','','I heard Slodi\'s horn. I take it you are the outsider he was announcing?',26124),
(127716,'enUS','Slodi mentioned you could help find the vrykul mentioned in these scrolls.','Slodi mentioned you could help find the vrykul mentioned in these scrolls.',26124),
(127717,'enUS','','I am familiar of the Valkyra prophecy of the Faldrottin, but I have not read their text. Let me see the scrolls you found.\n\n<Bryna pores through the scrolls\' text.>\n\nIf these scrolls are correct, that would mean we may have the heir of Skovald in our midst! Regardless of what the Valkyra believe, you would be doing us a service by removing her from here.\n\nSeek out Yngvild in the tower overlooking the town. She keeps a keen eye on the comings and goings of Jandvik, and would have noticed if anyone of note has visited lately.',26124),
(127718,'enUS','','I\'m keeping my eye on you, outsider.',26124),
(127719,'enUS','Have any vrykul passed through here that struck you as odd?','Have any vrykul passed through here that struck you as odd?',26124),
(127720,'enUS','','As a matter of fact, yes there is.\n\nA wandering shieldmaiden came through just recently, and has set up camp outside of town. She stayed only long enough to purchase supplies and avoided all eye contact while she was here.\n\nI was going to check on her to find out her business here, but you are welcome to go in my stead. You\'ll find her camped on the beach to the east.',26124),
(127721,'enUS','I must pay for my mistakes.','',26124),
(127722,'enUS','It is an honor to walk beside you, Highlord.','',26124),
(127723,'enUS','I will prove myself worthy.','',26124),
(127724,'enUS','You will be judged!','',26124),
(127725,'enUS','I will show no mercy!','',26124),
(127726,'enUS','Bandu thoribas!','',26124),
(127727,'enUS','Judgment must be swift and true.','',26124),
(127728,'enUS','We will prevail.','',26124),
(127729,'enUS','Our will is strong.','',26124),
(127730,'enUS','My spirit weakens...','',26124),
(127731,'enUS','I require a moment\'s rest.','',26124),
(127732,'enUS','You must continue on without me.','',26124),
(127733,'enUS','I fight for the Highlord!','',26124),
(127734,'enUS','I will do what is asked of me.','',26124),
(127735,'enUS','Foolish girl. These bones answer to me, not your misguided honor!','',26124),
(127736,'enUS','','So, you will not face me in single combat? The hallowed bones of our ancestors would balk at such dishonor!',26124),
(127737,'enUS','','If you will not honor me, then I will break you! Champion, help me put down this cur!',26124),
(127738,'enUS','Ishnu-alah.','',26124),
(127739,'enUS','Greetings, friend.','',26124),
(127740,'enUS','It is good to see you.','',26124),
(127741,'enUS','Safe travels.','',26124),
(127742,'enUS','Elune-adore.','',26124),
(127743,'enUS','Ande\'thoras-ethil.','',26124),
(127744,'enUS','Is this how I must pay for my mistakes?','',26124),
(127745,'enUS','Do you not have better things to do?','',26124),
(127746,'enUS','Do I really deserve this?','',26124),
(127747,'enUS','I am not amused.','',26124),
(127748,'enUS','This needs to stop.','',26124),
(127749,'enUS','','What surprises await us?',26124),
(127750,'enUS','','You need not do this alone.',26124),
(127751,'enUS','','I am here to help.',26124),
(127752,'enUS','','Our enemies will drown in shadows!',26124),
(127753,'enUS','','Your end is nigh!',26124),
(127754,'enUS','','You will feel my wrath!',26124),
(127755,'enUS','','You shall be purged from this world!',26124),
(127756,'enUS','','The void awaits.',26124),
(127757,'enUS','','You brought this on yourself.',26124),
(127758,'enUS','','Your struggle is over.',26124),
(127759,'enUS','','I will need just a moment.',26124),
(127760,'enUS','','This was... unexpected.',26124),
(127761,'enUS','','This defeat is only temporary.',26124),
(127762,'enUS','','This should be interesting...',26124),
(127763,'enUS','','Yes?',26124),
(127764,'enUS','','What do you need?',26124),
(127765,'enUS','','How can I help?',26124),
(127766,'enUS','','Take care.',26124),
(127767,'enUS','','May the Shadows embrace you.',26124),
(127768,'enUS','','Farewell.',26124),
(127769,'enUS','','You are testing my patience.',26124),
(127770,'enUS','','Do you think yourself clever?',26124),
(127771,'enUS','','Shoo!',26124),
(127772,'enUS','','Begone from my sight!',26124),
(127773,'enUS','','This will not end well for you.',26124),
(127774,'enUS','','Silly me for thinking Roland was the annoying one.',26124),
(127775,'enUS','Hello.','',26124),
(127776,'enUS','How can I help?','',26124),
(127777,'enUS','Yes?','',26124),
(127778,'enUS','Safe travels.','',26124),
(127779,'enUS','Farewell.','',26124),
(127780,'enUS','Until next time.','',26124),
(127781,'enUS','What is wrong with you?','',26124),
(127782,'enUS','Surely the leader of the Black Harvest does not have time to waste like this!','',26124),
(127783,'enUS','I am not to be trifled with!','',26124),
(127784,'enUS','Do you really want to wake the demon?','',26124),
(127785,'enUS','Jubeka should have banished you instead.','',26124),
(127786,'enUS','It is an honor to fight alongside such power.','',26124),
(127787,'enUS','There is so much untapped power in this world.','',26124),
(127788,'enUS','Our enemies will fall!','',26124),
(127789,'enUS','Feel the power of the Black Harvest!','',26124),
(127790,'enUS','You are no match for our power!','',26124),
(127791,'enUS','This will be your undoing!','',26124),
(127792,'enUS','Our power cannot be matched.','',26124),
(127793,'enUS','Our power grows!','',26124),
(127794,'enUS','That was almost too easy.','',26124),
(127795,'enUS','Give me a moment to regain my strength.','',26124),
(127796,'enUS','I feel powerless...','',26124),
(127797,'enUS','Don\'t let me slow you down.','',26124),
(127798,'enUS','You will know my power!','',26124),
(127799,'enUS','I will do what is needed in the name of the Black Harvest.','',26124),
(127800,'enUS','','Yes?',26124),
(127801,'enUS','','Can I help you?',26124),
(127802,'enUS','','What do you need?',26124),
(127803,'enUS','','Farewell.',26124),
(127804,'enUS','','Remain vigilant.',26124),
(127805,'enUS','','Be safe.',26124),
(127806,'enUS','','You have my attention.',26124),
(127807,'enUS','','I like you better when you are silent.',26124),
(127808,'enUS','','You are a persistant one, are you not?',26124),
(127809,'enUS','','Surely you know other tricks?',26124),
(127810,'enUS','','You are crossing a line that cannot be uncrossed!',26124),
(127811,'enUS','','You can stop now, or I can have D\'Bynn stop you.',26124),
(127812,'enUS','','Be alert, Huntmaster. We do not know what dangers lurk nearby.',26124),
(127813,'enUS','','I am here to take my place at your side.',26124),
(127814,'enUS','','We will protect these lands together.',26124),
(127815,'enUS','','Run if you dare, though you will not get far!',26124),
(127816,'enUS','','You will die by my hand!',26124),
(127817,'enUS','','I will enjoy this!',26124),
(127818,'enUS','','This is the fate you deserve.',26124),
(127819,'enUS','','There could be no other way.',26124),
(127820,'enUS','','The weak will always perish.',26124),
(127821,'enUS','','Go on without me. I will catch up.',26124),
(127822,'enUS','','This defeat will not break me.',26124),
(127823,'enUS','','My will cannot be broken!',26124),
(127824,'enUS','','You can trust me to do whatever is needed.',26124),
(127825,'enUS','','Your victory brings hope to the hearts of my people. The Burning Legion will never take our lands!',26124),
(127826,'enUS','Our riders wage war against the Legion in the skies. Give aid to those who have fallen. We must hold this point!','',26124),
(127827,'enUS','Our riders will take it from here. Continue your fight, champion.','',26124),
(127828,'enUS','I\'ve already completed my training.','I\'ve already completed my training.',26124),
(127829,'enUS','Finish your drinks! We\'re leaving in less than a minute!','Finish your drinks! We\'re leaving in less than a minute!',26124),
(127830,'enUS','Merry is the day, for we have found the jewelry!','',26124),
(127831,'enUS','Teleport me to the next tavern.','Teleport me to the next tavern.',26124),
(127832,'enUS','It is amusing how you continue to fight, even though you\'re bound to lose.','',26124),
(127833,'enUS','Your fighting style does not impress, nor concern me. You will fall to my strength soon.','',26124),
(127834,'enUS','You\'re so tiny! It\'s like playing with a rabbit.','',26124),
(127835,'enUS','How may I assist you?','How may I assist you?',26124),
(127836,'enUS','I want to donate War Supplies to the Mage Tower.','I want to donate War Supplies to the Mage Tower.',26124),
(127852,'enUS','Take me into the Deadmines.','Take me into the Deadmines.',26124),
(127853,'enUS','There is a lot of movement within the Deadmines. \n\nI suspect the place has been infested with all manner of creatures. Shall we investigate?','',26124),
(127854,'enUS','Dodge this!','',26124),
(127855,'enUS','Coming at ya!','',26124),
(127856,'enUS','Think fast!','',26124),
(127857,'enUS','Incoming!','',26124),
(127858,'enUS','Hey, catch!','',26124),
(127859,'enUS','What... what happened? This isn\'t the lodge!','',26124),
(127860,'enUS','My head... what happened?','',26124),
(127861,'enUS','Where... where am I?','',26124),
(127862,'enUS','That thing... it got into my head. I couldn\'t stop!','',26124),
(127863,'enUS','I... I feel sick.','',26124),
(127864,'enUS','What... what happened to me?','',26124),
(127865,'enUS','This is as far as I can take you. Let\'s hope your companions are strong enough to get you the rest of the way.','',26124),
(127866,'enUS','They took the kegs!','',26124),
(127867,'enUS','Jona, Joren, go after the Gnomenbrau! A group of troggs carried it off!','',26124),
(127868,'enUS','Soren lad, find the boar that stole our Theramore Pale!','',26124),
(127869,'enUS','I\'ll chase the trolls to their cave and find the Stormhammer Stout!','',26124),
(127870,'enUS','Neither snow nor cataclysm nor demon invasion will stay us from our appointed duty. The mail must flow.','',26124),
(127889,'enUS','The Mage Tower is now under construction.','The Mage Tower is now under construction.',26124),
(127890,'enUS','The Mage Tower is under attack!','The Mage Tower is under attack!',26124),
(127891,'enUS','The Mage Tower is destroyed, it will be back up soon.','The Mage Tower is destroyed, it will be back up soon.',26124),
(127893,'enUS','Well done. We simply can\'t have improper mail clogging up the system.','',26124),
(127894,'enUS','No need to track down the sender. The tubes will handle that!','',26124),
(127897,'enUS','','The Burning Legion marches on Highmountain! Our allies have engaged the demons throughout our lands. To turn the tide, champion, you must strike at the heart of their forces!',26124),
(127898,'enUS','','Well fought! Our forces are gaining gr...',26124),
(127899,'enUS','To Thunder Totem! My riders will hold the skies while you sweep the grounds.','',26124),
(127900,'enUS','','The very wildlife of Highmountain rises up against the demons! Shatter the infernals and find the source of their incursion.',26124),
(127901,'enUS','','The Legion underestimates nature\'s persistence and determination... and yours, I think!',26124),
(127902,'enUS','We need everyone on the front line. Another wave of demons is incoming!','',26124),
(127903,'enUS','That bought us a brief reprieve. My Illidari can hold the line from here.','',26124),
(127904,'enUS','Valarjar of Skyhold! Let these walls resound with cheers for our champion!','',26124),
(127905,'enUS','','|TInterface\\Icons\\Ability_Butcher_Whirl.blp:20|t%s begins to cast |cFFFF0000|Hspell:232722|h[Slicing Tornado]|h|r!',26124),
(127906,'enUS','','|TInterface\\Icons\\TRADE_ARCHAEOLOGY_SHARK JAWS:20|t%s calls forth the mighty Sarukel to open his |cFFFF0000|Hspell:234621|h[Devouring Maw]|h|r!',26124),
(127907,'enUS','|TInterface\\Icons\\SPELL_WARLOCK_SOULBURN:20|tThe %s begins to emit a series of |cFFFF0000|Hspell:236011|h[Tormented Cries]|h|r!','',26124),
(127908,'enUS','','|TInterface\\Icons\\ABILITY_WARLOCK_SOULLINK:20|t%s chains together living essence with |cFFFF0000|Hspell:236449|h[Soulbind]|h|r!',26124),
(127909,'enUS','','|TInterface\\Icons\\SPELL_SHADOW_SHADESOFDARKNESS:20|t%s begins to release a mass of |cFFFF0000|Hspell:236075|h[Wailing Souls]|h|r!',26124),
(127910,'enUS','','Together we\'ll shatter the bones of countless demons!',26124),
(127911,'enUS','|TInterface\\Icons\\Spell_Deathknight_Defile:20|tWith no souls in the Corporeal Realm, the %s lashes out with |cFFFF0000|Hspell:236507|h[Quietus]|h|r!','',26124),
(127912,'enUS','','|TInterface\\Icons\\Spell_Deathknight_Defile:20|tWith no souls in the Spirit Realm, %s lashes out with |cFFFF0000|Hspell:236507|h[Quietus]|h|r!',26124),
(127913,'enUS','Oh, am I glad ta see ya! Our brothers and sisters\'re fightin\' down tha ramp, but they\'re out of brew!$b$bThese confounded beasts are stampedin\' through, so we cannae roll the barrels down without someone...$b$bThat gives me an idea...','',26124),
(127914,'enUS','Simple! Ye ride down on tha barrel. $b$bWith yer fancy footwork ye can dodge tha stampede an\' deliver the brew! As me master always said: \'If ye can dodge a horse on a barrel, ye can dodge a punch.\'$b$bMe trainin\' was... exotic. Look, just hop on tha barrel, keep rollin\' till ye reach the patrol, an watch out for the horses on the way down!','',26124),
(127915,'enUS','Do I look like a warlock to ye? I haven\'t the foggiest clue why. Maybe this is some sort o\' seasonal stampede, where the dreadsteeds are a-runnin for a migration, or matin\' season, or runnin\' from somethin\'...$b$bOr maybe they\'re just runnin\' through here to stop us from easily deliverin\' our brew!','',26124),
(127916,'enUS','What\'s the plan?','What\'s the plan?',26124),
(127917,'enUS','What\'s causing the stampede, anyway?','What\'s causing the stampede, anyway?',26124),
(127918,'enUS','Fair enough.','Fair enough.',26124),
(127919,'enUS','|TInterface\\Icons\\ACHIEVEMENT_BOSS_LORDMARROWGAR:20|tThe %s shudders and retches forth The Desolate Host, overloading the soul conduits!','',26124),
(127920,'enUS','','Ah, nevermind. Just wait until Mograine sees us flying up. He\'ll get chills!',26124),
(127921,'enUS','The Soulstone is in place. Use the Arcane Matrix to fire up the city\'s defenses!','',26124),
(127922,'enUS','Business is good.$b$bReal good.$b$b<Nargle tucks a few coins into his pocket.>$b$bMister Noggenfogger will be pleased- keep it up!','',26124),
(127923,'enUS','Superbly done, Archmage! I never doubted your success. To the Archmage! To the Tirisgarde!','',26124),
(127928,'enUS','Did it work?','',26124),
(127929,'enUS','There is nowhere you can flee that I cannot reach you, demon!','',26124),
(127930,'enUS','Ah, our guests of honor have finally arrived. I look forward to ripping those horns from your skull, Betrayer!','',26124),
(127931,'enUS','','Illidan! Curse that impetuous demon hunter!',26124),
(127932,'enUS','','Illidan left behind a mess! Stay close... we shall carve a path through these demons.',26124),
(127933,'enUS','','I will continue the hunt for Illidan. You deal with those abominations.',26124),
(127934,'enUS','Demons bar the path ahead, but they cannot withstand our fury.','',26124),
(127935,'enUS','I will track the Dreadlord. You deal with the rest of the filth.','',26124),
(127936,'enUS','','Did you really think you could elude me, Illidan? Run again and I\'ll shackle you like the beast you are.',26124),
(127937,'enUS','Posture if you must, Maiev, but for now, do what you do best and follow me.','',26124),
(127938,'enUS','There is nowhere left to run, demon!','',26124),
(127939,'enUS','','So much death here... so much power!',26124),
(127940,'enUS','','Is this not the site of what you mortals consider your greatest humiliation? I hope you fare better this time...',26124),
(127941,'enUS','','I don\'t believe these lands have seen such carnage since the Battle for K\'tanth. Such a long time ago...',26124),
(127942,'enUS','Run? Fool! I have led you to the slaughter!','',26124),
(127943,'enUS','Beware the shadows!','',26124),
(127944,'enUS','You cannot withstand the power of the Legion!','',26124),
(127945,'enUS','It amuses me to watch you suffer!','',26124),
(127946,'enUS','I tire of these games! Let us see how you fare without your little trinket.','',26124),
(127947,'enUS','How kind of you to bring the Aegis to me!','',26124),
(127948,'enUS','Surrender the shield and I will grant you a quick death!','',26124),
(127949,'enUS','','This was always a place of power. Aegwynn was drawn here, and before her the elves, and before them the trolls. And before them...',26124),
(127950,'enUS','','That fel edifice towering over this land pales in comparison to the grandeur of what stood here long ago.',26124),
(127951,'enUS','','It was here, in ages past, that the God of the Deep lost a great battle to the God of Seven Heads. But as was so often the case, even defeat ultimately worked in N\'Zoth\'s favor.',26124),
(127952,'enUS','The final... victory... will be ours...','',26124),
(127953,'enUS','','This trifling skirmish is little more than a distraction. The true battle draws nigh as the circle nears completion.',26124),
(127954,'enUS','','This conflict is but a shadow of an ancient war that predated the meddling of the titans. Infinite armies clashed in ceaseless battle. But I\'m sure your little war is impressive... in its own way.',26124),
(127955,'enUS','','It took ages to make my return to the surface after the Sundering. The naga can be so possessive of artifacts.',26124),
(127956,'enUS','','This land has seen so much upheaval. The Cataclysm, the Sundering, the Scouring... you really have no idea.',26124),
(127957,'enUS','','You were a good choice. No other wielder has murdered their way across a continent quite like you have. I admire your endurance.',26124),
(127958,'enUS','','The Light would have your kind remain obedient and stagnant. I offer the gifts of freedom and strength. I hope you remember my kindness.',26124),
(127959,'enUS','','Your allies consider me a bad influence. Yet all I\'ve ever done is speed you along the path you chose.',26124),
(127960,'enUS','','I can feel the pulse of your world quickening. Soon all will be drenched in its lifeblood.',26124),
(127961,'enUS','','A Legion brute obliterating priceless knowledge... imagine that.',26124),
(127962,'enUS','','Long has this one been a blight upon your world. Not all his schemes came to fruition, but those that did caused untold ruin.',26124),
(127963,'enUS','','From birth, pit lords are oversized and stupid. Somehow the Legion manages to magnify both traits.',26124),
(127964,'enUS','','At times it seems the naga beg for scraps from the Legion\'s table. But the queen they serve wants far more than that.',26124),
(127965,'enUS','','I do enjoy seeing the shrine of a great enemy profaned by the spirits of its own worshippers.',26124),
(127966,'enUS','','The haughty elves of old had such regard for their own spirits. Such a delicious indignity!',26124),
(127967,'enUS','','Invaders messily corrupting other invaders... typical. Far more useful to coax them along the proper path, don\'t you think?',26124),
(127968,'enUS','','Let me guide your hand as you battle this vessel. Though it retains but a fraction of the fallen titan\'s power, you will not survive its onslaught without my expertise.',26124),
(127969,'enUS','','You must face the Deceiver on his own ground, where he is vulnerable. Come, let us taste his soul!',26124),
(127970,'enUS','Kil\'jaeden sends his gratitude for delivering the Aegis into our hands.','',26124),
(127971,'enUS','','Hey you! You\'re the one the tauren was talking about!',26124),
(127972,'enUS','','Trying to foil our plot again? Hah!',26124),
(127973,'enUS','','As if someone so puny could stop us...',26124),
(127974,'enUS','','Besides, if you ever hurt one hair on my sweet tauren\'s head, you\'d have a REAL problem to deal with...',26124),
(127975,'enUS','','ME!',26124),
(127976,'enUS','','No matter. I already have what I came for.',26124),
(127977,'enUS','','You better hope we don\'t meet again.',26124),
(127978,'enUS','','I don\'t have time for silly catch phrases. So, I\'ll just do a cool exit instead.',26124),
(127979,'enUS','','Power Leap!',26124),
(127980,'enUS','This one... is strong. No matter! These souls will serve the master well.','',26124),
(127981,'enUS','','The shadowy figure pulls a vial of goo from the cauldron.',26124),
(127982,'enUS','','A remnant of power lingers in this broken temple. It must be ours! Come, enter the circle and take it.',26124),
(127983,'enUS','My axe hungers for flesh!','',26124),
(127984,'enUS','Legion! Scorch them to the bone!','',26124),
(127985,'enUS','Fiends! Tear down that shield!','',26124),
(127986,'enUS','Infernals! Devastate their ranks!','',26124),
(127987,'enUS','Their shield has fallen! Leave no survivors!','',26124),
(127988,'enUS','The full might of the Legion falls upon you!','',26124),
(127989,'enUS','Your flesh will burn!','',26124),
(127990,'enUS','This world... will belong... to the Legion...','',26124),
(127991,'enUS','I will hold this flank. Can you manage to survive without me, warden?','',26124),
(127992,'enUS','Still alive, Maiev?','',26124),
(127993,'enUS','','I would regret it if you died by another\'s hand, Betrayer!',26124),
(127994,'enUS','','Forgive me if my glaive finds your heart, Illidan. With so many demons about, it\'s hard to distinguish you from the rest of this filth.',26124),
(127995,'enUS','','Wardens, secure the cathedral! We will hold here while our allies push into the tomb below.',26124),
(127996,'enUS','','My mistake. It seems the upstart \"goddess\" still holds sway here. Oh well...',26124),
(127997,'enUS','','It is here the Feltotem receive demonic instruction. Cleanse the cavern of their evil and send their masters back to the Twisting Nether!',26124),
(127998,'enUS','','Thank you, hero. You\'ve done the tribes of Highmountain a great service this day.',26124),
(127999,'enUS','The Maw of the Damned begins to tug at your grip as you approach the Deceiver.','The Maw of the Damned begins to tug at your grip as you approach the Deceiver.',26124),
(128000,'enUS','Your resilient spirit resists the foul fel magic!','Your resilient spirit resists the foul fel magic!',26124),
(128001,'enUS','At long last! Revenge... revenge is mine!','',26124),
(128002,'enUS','At last I am free!','',26124),
(128003,'enUS','','Nerus? Explain yourself, uncle!',26124),
(128004,'enUS','You must understand! I was trying to protect our family...','',26124),
(128005,'enUS','But in the end, the pact I made cursed our ancestors with a fate worse than death.','',26124),
(128006,'enUS','Their spirits are bound to the Legion, forced to do the demons\' bidding.','',26124),
(128007,'enUS','','This... this is your doing? How could you?',26124),
(128008,'enUS','I am so sorry, Delas. I know it is too much to ask your forgiveness, but I must ask for your help.','',26124),
(128009,'enUS','The wreckage of our prior assault on these shores contains supplies vital to our efforts against the Burning Legion.','',26124),
(128010,'enUS','Clear the beach of demonic forces and recover the salvaged supplies for the invasion effort.','',26124),
(128011,'enUS','','I claim your lives for Azshara!',26124),
(128012,'enUS','','Meet your end, mortal filth!',26124),
(128013,'enUS','','Time to feed the fish!',26124),
(128014,'enUS','','Chumming the waters!',26124),
(128015,'enUS','','Ten thousand years haven\'t made mortals any less pathetic!',26124),
(128016,'enUS','','Queen Azshara\'s reign is absolute... as ever!',26124),
(128017,'enUS','','Oh! The... indignity...',26124),
(128018,'enUS','','Such a death... is beneath me...',26124),
(128019,'enUS','','Consume them!',26124),
(128020,'enUS','','Feast upon flesh!',26124),
(128021,'enUS','','The sea surges with power!',26124),
(128022,'enUS','','Death rises to take you!',26124),
(128023,'enUS','','Suffer the chill of the depths!',26124),
(128024,'enUS','','Your souls belong to the deep!',26124),
(128025,'enUS','','The depths will devour you!',26124),
(128026,'enUS','','My pet will swallow you whole!',26124),
(128027,'enUS','Petty mortal. You gain nothing! You will bow... or you will BURN!','',26124),
(128028,'enUS','Well done. With the demons slain and the supplies recovered, we are one step closer to securing the Broken Shore.','',26124),
(128030,'enUS','I\'m ready to take on Xylem. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','I\'m ready to take on Xylem. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',26124),
(128031,'enUS','I\'m ready to face Raest. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','I\'m ready to face Raest. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',26124),
(128032,'enUS','','These fools bring the Tidestone to us! Just as our blessed queen foresaw!',26124),
(128033,'enUS','','Slay the intruders! Take back what is ours!',26124),
(128034,'enUS','','Weaklings! You dare disappoint our queen?',26124),
(128035,'enUS','','Incompetents! Must I soil my hands on this rabble?',26124),
(128036,'enUS','','Enough of these failures! Now you will face the true might of the naga!',26124),
(128037,'enUS','','Harjatan! Pummel their bones to dust!',26124),
(128038,'enUS','','Quiet, you mindless oaf! Kill them!',26124),
(128039,'enUS','','Useless beast! Why the queen was fond of him I\'ll never know!',26124),
(128040,'enUS','','Minions! To battle!',26124),
(128041,'enUS','','Lend aid to our brutish champion!',26124),
(128042,'enUS','','You! Fetch me the Tidestone!',26124),
(128043,'enUS','','More death! More carnage!',26124),
(128044,'enUS','Bal, lamer zhita!','',26124),
(128045,'enUS','Come, little friends! Crush!','',26124),
(128046,'enUS','Ash\'thero sanguine!','',26124),
(128047,'enUS','Time to smash!','',26124),
(128048,'enUS','Harjatan... fail... pretty queen...','',26124),
(128049,'enUS','Harjatan... no fight... so good...','',26124),
(128050,'enUS','I\'m ready to face Kruul. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','I\'m ready to face Kruul. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',26124),
(128051,'enUS','Die for pretty queen!','',26124),
(128052,'enUS','Alana be\'lendor','',26124),
(128053,'enUS','','Things are still a bit foggy, but I can stand and fight.',26124),
(128054,'enUS','','Take my death gate or open your own. Either way, I\'ll see you in Acherus.',26124),
(128055,'enUS','The Legion has conquered this shore. Soon we shall conquer the Legion in turn!','',26124),
(128056,'enUS','This place holds a mere fraction of the Legion\'s might. There are many horrors yet to behold.','',26124),
(128057,'enUS','Do you smell the charred flesh upon the wind? Ah, the scent of home!','',26124),
(128058,'enUS','Your last visit here was nearly the end of you. How fortunate that you now enjoy my company.','',26124),
(128059,'enUS','This place is so like Argus... twisted, shattered, and broken. Almost makes me homesick!','',26124),
(128060,'enUS','Your skills have improved significantly since we first met. Given a few thousand years, you may even rise to the level of my best apprentices.','',26124),
(128061,'enUS','And here we are, the site where fools were vanquished. Remember, courage is no substitute for power.','',26124),
(128062,'enUS','Do you sense it? The lifeblood of your world flows just under the surface of this place.','',26124),
(128063,'enUS','I know ancient incantations which could tap into the lifeblood of your world. This would be an ideal place to unleash them.','',26124),
(128064,'enUS','This one is powerful, but stupid. It would make a worthless minion.','',26124),
(128065,'enUS','Ah, my former master! The time for revenge is at hand!','',26124),
(128066,'enUS','Demon... worshippers?','',26124),
(128067,'enUS','%s blinks, looking puzzled. His eyes glow with fel energy.','',26124),
(128068,'enUS','','What\'s... happening? Blood feels... like it\'s boiling... I... I...',26124),
(128069,'enUS','That fool saw me as little more than a trinket for harvesting power. He has paid for his lack of vision!','',26124),
(128070,'enUS','','DEMONS! ALL OF YA!',26124),
(128071,'enUS','I know I have much to answer for.','',26124),
(128072,'enUS','','Indeed you do, uncle. But this is a start, I suppose...',26124),
(128073,'enUS','The naga are a corrupted race. They possess arcane skill, but lack the finesse inherent to my people.','',26124),
(128074,'enUS','I detest spirits! Always blathering about their former lives. Consume their souls and be done with them!','',26124),
(128075,'enUS','An intriguing use of soul energy. They could have accomplished so much, had they merely applied themselves.','',26124),
(128076,'enUS','Ugh! This place reeks of the titans!','',26124),
(128077,'enUS','Careful! Power still echoes within this ancient golem. It would be prudent to destroy it before the Legion empowers it further.','',26124),
(128078,'enUS','The Deceiver scorned my talents when I still lived. Let us see which of us survives the battle to come!','',26124),
(128079,'enUS','Ah, the skies of home! I did not believe I would see this world again.','',26124),
(128080,'enUS','They may never forgive me for what I have done, but at least they will be safe. For now, my family will be safe.','',26124),
(128081,'enUS','The weight of my decision weighs heavy on my heart, but each day I see their carefree smiles eases that burden just a little.','',26124),
(128082,'enUS','My gift to them is the bliss of ignorance. They will not realize its price until it is too late. What is done is done. I hope I have made the right choice.','',26124),
(128083,'enUS','You no take my boat! Birds to da cannons! Monkeys to da sails!','',26124),
(128084,'enUS','Can\'t get past me!','',26124),
(128085,'enUS','Nope!','',26124),
(128086,'enUS','Nuh-uh!','',26124),
(128087,'enUS','Where you goin\'?','',26124),
(128088,'enUS','|TINTERFACE\\ICONS\\SPELL_FEL_INCINERATE.BLP:20|t You have |cFFFF0000|Hspell:235117|h[Unstable Soul]|h|r!','|TINTERFACE\\ICONS\\SPELL_FEL_INCINERATE.BLP:20|t You have |cFFFF0000|Hspell:235117|h[Unstable Soul]|h|r!',26124),
(128089,'enUS','','Excuse me, $n! Some of those disasters you have previously delayed are now actionable. Please speak with me.',26124),
(128090,'enUS','I\'m ready to face Sigryn. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','I\'m ready to face Sigryn. (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',26124),
(128092,'enUS','Gurrg mrggll!?','',26124),
(128093,'enUS','Murgg gur gr gr grulgl!','',26124),
(128094,'enUS','Gurg gar gur gal!','',26124),
(128095,'enUS','Grulgrug grull murg gruumblg!?','',26124),
(128096,'enUS','Murglag!','',26124),
(128097,'enUS','Gurg murglgl!','',26124),
(128098,'enUS','Gurg glurgggll!!','',26124),
(128099,'enUS','I\'m ready to face Tugar Bloodtotem. (Free)','I\'m ready to face Tugar Bloodtotem. (Free)',26124),
(128100,'enUS','Send me to Shadowsong. (Free)','Send me to Shadowsong. (Free)',26124),
(128101,'enUS','Aghhhhh! It burns, it burns!','Aghhhhh! It burns, it burns!',26124),
(128102,'enUS','Everything is green, I can\'t see!','Everything is green, I can\'t see!',26124),
(128103,'enUS','My flesh feels like it\'s falling off the bone!','My flesh feels like it\'s falling off the bone!',26124),
(128104,'enUS','AHHHHHH!!!','AHHHHHH!!!',26124),
(128105,'enUS','I can\'t-','I can\'t-',26124),
(128106,'enUS','Stop!','Stop!',26124),
(128107,'enUS','My bones!','My bones!',26124),
(128108,'enUS','Make it stop!','Make it stop!',26124),
(128109,'enUS','Argh!','Argh!',26124),
(128110,'enUS','You there, help me!','You there, help me!',26124),
(128111,'enUS','Just let me-','Just let me-',26124),
(128112,'enUS','I\'ll talk-','I\'ll talk-',26124),
(128113,'enUS','Take me to Agatha... (Free)','Take me to Agatha... (Free)',26124),
(128114,'enUS','','It was an honor to meet you, Grandmaster. I hope to see you again soon!',26124),
(128115,'enUS','I\'m ready to take on Xylem. (Free)','I\'m ready to take on Xylem. (Free)',26124),
(128116,'enUS','I\'m ready to face Raest. (Free)','I\'m ready to face Raest. (Free)',26124),
(128117,'enUS','I\'m ready to face Kruul. (Free)','I\'m ready to face Kruul. (Free)',26124),
(128118,'enUS','I\'m ready to face Sigryn. (Free)','I\'m ready to face Sigryn. (Free)',26124),
(128119,'enUS','|TInterface\\ICONS\\Ability_IronMaidens_ConvulsiveShadows.blp:20|t The Fallen Avatar targets you with |cFFFF0404|Hspell:236604|h[Shadowy Blades]|h|r!','|TInterface\\ICONS\\Ability_IronMaidens_ConvulsiveShadows.blp:20|t The Fallen Avatar targets you with |cFFFF0404|Hspell:236604|h[Shadowy Blades]|h|r!',26124),
(128120,'enUS','The darkness is gone! Thank you, hero.','The darkness is gone! Thank you, hero.',26124),
(128121,'enUS','Where... am I?','Where... am I?',26124),
(128122,'enUS','I can see clearly now!','I can see clearly now!',26124),
(128123,'enUS','I\'m just going to rest for a moment...','I\'m just going to rest for a moment...',26124),
(128124,'enUS','Ouch! Why would you do that to me?','Ouch! Why would you do that to me?',26124),
(128125,'enUS','Rude!','Rude!',26124),
(128126,'enUS','That stings!','That stings!',26124),
(128127,'enUS','What in the void-stricken darkness...?','What in the void-stricken darkness...?',26124),
(128128,'enUS','Yikes! I\'m out of here!','Yikes! I\'m out of here!',26124),
(128129,'enUS','','I\'ll get the flame. I\'ve been looking forward to this!',26124),
(128130,'enUS','Welcome to my peak, $ct.$b$bI am the last remaining ancient watcher of the Drekirjar. I make my home here, tending to the sacred bodies of our allies who gave their lives for our alliance. Skovald may have shattered our alliance with the Thorignir, but there are those of us who do not follow his mandates.$b$bTo this day, the Thorignir die in our joint struggle. It is all I can do to attend them as their bodies return to the snow. With Daumyr as my partner, we protect our charges with our lives.','',26124),
(128131,'enUS','I\'m raising these Thorignir as my soldiers, and Daumyr is next.','I\'m raising these Thorignir as my soldiers, and Daumyr is next.',26124),
(128132,'enUS','You shall not turn my allies into your mindless slaves!','',26124),
(128133,'enUS','I am... uh... we... are...','',26124),
(128134,'enUS','The pendulum swings in our favor! Make for the cliffs and dispose of that demon. I will meet you there once we\'ve secured the skies.','',26124),
(128135,'enUS','','Insolent pests! Your efforts amount to NOTHING!',26124),
(128136,'enUS','What delicious irony! The demons are so quick to turn on one another!','',26124),
(128137,'enUS','Enjoy the chaos...','',26124),
(128138,'enUS','Our shores are ablaze with fel fire! Strike quickly, before the threat moves inland.','',26124),
(128139,'enUS','Well fought! Every victory is crucial in this war.','',26124),
(128140,'enUS','Such depravity! The demons drain the souls of innocents to power their foul magic. Stop this harvest, hero!','',26124),
(128141,'enUS','I have no love of murlocs, but even they don\'t deserve to meet their end in the Legion\'s clutches. Thank you, hero.','',26124),
(128142,'enUS','','How did the Legion learn about our Storm Brew? We\'ve kept its existence quiet...',26124),
(128143,'enUS','Your efforts are far too late, pathetic creatures...','',26124),
(128144,'enUS','You thought you could escape by huddling in your puny brewery? The Burning Legion sees all!','',26124),
(128145,'enUS','These cowardly demons hide behind their defenses. Take my blessed hammer and slay them!','',26124),
(128146,'enUS','Destroy their cannons and bring down their barriers! Let our valiant Valarjar face them in the true spirit of battle!','',26124),
(128147,'enUS','Fly swiftly, $ct. We will meet you there.','',26124),
(128148,'enUS','Well done, hero. The tales of your deeds will be sung within the Halls of Valor!','',26124),
(128149,'enUS','I suggest we be quick. The skies are swarming with those foul beasts.\n\nOur opportunity to strike at the heart of the Legion presents itself. We must bring the battle to the frontlines.','',26124),
(128150,'enUS','For the honor of Highmountain. I am ready! [Queue for Scenario]','For the honor of Highmountain. I am ready! [Queue for Scenario]',26124),
(128151,'enUS','','Your precious world will burn!',26124),
(128152,'enUS','','<Daumyr nods to you, a hollow look in her eyes.>',26124),
(128153,'enUS','Time to go to Broken Shore, Daumyr.','Time to go to Broken Shore, Daumyr.',26124),
(128154,'enUS','The azure drakes in the area have pledged to help us fight back against the Legion, but they\'ll need your help. Assist them in any way you can.','',26124),
(128155,'enUS','The drakes are providing us transport up to the Legion ship to deal with the their commander in the area. Once you\'ve dealt with him, they\'ll return to get you before the main assault on the ship begins.','',26124),
(128156,'enUS','$n! To me, quickly! We end this now!','',26124),
(128157,'enUS','With their commander down and shields disabled, the blue drakes can begin their assault on the ship in earnest. Their sending transport to extract you before they start.','',26124),
(128158,'enUS','Felweaver! Deal with these intruders!','',26124),
(128159,'enUS','Come, champions of this world, so that I may cut you down where you stand!','',26124),
(128160,'enUS','','Know the torment of a soul divided!',26124),
(128161,'enUS','','I did not choose my fate... neither will you!',26124),
(128162,'enUS','','Storm Brew is amazing! No wonder the Legion fears it!',26124),
(128163,'enUS','','Grandmaster, you have done better than I expected. Seems I will have to deal with you myself!',26124),
(128164,'enUS','','Brewmaster? What are you talking about? We\'ve been searching everywhere for you!',26124),
(128165,'enUS','','Almai, your naivete is so refreshing. Pity you must die!',26124),
(128166,'enUS','','So much for that.',26124),
(128168,'enUS','My work is complete, puny monks. Your order has already fallen!','',26124),
(128169,'enUS','','What... What just happened? What did she mean? Grandmaster, we must return to the temple at once! Let me know when you\'re ready!',26124),
(128170,'enUS','','Brewmaster! NO!',26124),
(128171,'enUS','I would like to leave the Deadmines.','I would like to leave the Deadmines.',26124),
(128172,'enUS','I fear no beast! The Legion is endless!','',26124),
(128173,'enUS','Back for more? My hounds will tear you to shreds!','',26124),
(128174,'enUS','If this is the best hunter your world has, it is truly doomed!','',26124),
(128175,'enUS','Rise, my soldiers!','',26124),
(128176,'enUS','Your commander beckons!','',26124),
(128177,'enUS','The power courses within you! Destroy these demons!','',26124),
(128178,'enUS','Rise! Yes... rise!','',26124),
(128179,'enUS','The time has come! Your destiny is at hand!','',26124),
(128180,'enUS','Let\'s ride.','Let\'s ride.',26124),
(128181,'enUS','','My duty is one mere mortals cannot comprehend. A sacred charge to serve... to serve the master!',26124),
(128182,'enUS','','I am compelled to... ensure... the end of your existence!',26124),
(128183,'enUS','They are strong, with blood warmer than summer\'s heat. I assure you they will recover in time, but we must do our part and get back out there! Our people need us!','They are strong, with blood warmer than summer\'s heat. I assure you they will recover in time, but we must do our part and get back out there! Our people need us!',26124),
(128184,'enUS','Many warriors have sought shelter during a storm, but now is no time for shelter. We must raise our weapons and charge at the heart of nature itself.','Many warriors have sought shelter during a storm, but now is no time for shelter. We must raise our weapons and charge at the heart of nature itself.',26124),
(128185,'enUS','I know it hurts now, but years from now we will look back upon this day and remember all we have fought for, all we have given. This is what makes us who we are.','I know it hurts now, but years from now we will look back upon this day and remember all we have fought for, all we have given. This is what makes us who we are.',26124),
(128186,'enUS','We must remain strong.','We must remain strong.',26124),
(128187,'enUS','Raise your head, young warrior. Our journey has only just begun.','Raise your head, young warrior. Our journey has only just begun.',26124),
(128188,'enUS','We must maintain our composure! Show our allies who we truly are, not what those demons expect us to be!','We must maintain our composure! Show our allies who we truly are, not what those demons expect us to be!',26124),
(128189,'enUS','A long wind only blows for so long before the calm sets in. We must remember our training.','A long wind only blows for so long before the calm sets in. We must remember our training.',26124),
(128190,'enUS','','My family has been making brew for generations, so of course I\'m a natural at it! Still, I\'ve always wanted to try my hand at something different.',26124),
(128191,'enUS','','Life in the Valley of Four Winds is usually so peaceful, and that\'s a good thing for most. But for me, it\'s also rather dull. I\'d prefer some excitement now and again.',26124),
(128192,'enUS','','I can make good brew with my eyes closed. But Mistweaving, now that\'s a challenge. I hope to be great at it one day.',26124),
(128193,'enUS','To falter in the face of danger is not a flaw nor a weakness, rather an opportunity to rise to the call of battle.','To falter in the face of danger is not a flaw nor a weakness, rather an opportunity to rise to the call of battle.',26124),
(128194,'enUS','','We need to return to the Temple of Five Dawns! Let me know when you\'re ready!',26124),
(128198,'enUS','','The dreadlord attacked me, poisoned my Celebration Brew, and stole my form...',26124),
(128199,'enUS','It was... not your fault, Almai! But... we must hurry... to find a cure. Some have already succumbed...','',26124),
(128200,'enUS','Marius and his pet warlock managed to reverse one of the demon portals. Pass through and see what damage you can unleash on the other side.','',26124),
(128201,'enUS','Impressive improvisation. If only more of our forces could be entrusted with such missions. Now get out of there before reinforcements find you.','',26124),
(128202,'enUS','','I will go with you, Grandmaster. We have no time to lose!',26124),
(128203,'enUS','','|TInterface\\Icons\\INV_Misc_Herb_Arrowbloom.blp:20|t%s targets you with |cFFFF0000|Hspell:236304|h[Incorporeal Shot]|h|r!',26124),
(128204,'enUS','','I should be able to reactivate their portal. This place teems with usable souls.',26124),
(128205,'enUS','','I will ensure no more of Kruul\'s minions make it through. Suffer well.',26124),
(128206,'enUS','The Xorothian Ritualists are beginning to cast Cataclysm!','',26124),
(128207,'enUS','I grow weary of waiting.','',26124),
(128208,'enUS','You cannot stop me, demons! RISE, SOLDIERS!','',26124),
(128209,'enUS','','Ready to unveil our secret weapon?',26124),
(128210,'enUS','','All those demons... bah! No chance of us being overwhelmed, not when we control the power of Daumyr and her brood.',26124),
(128211,'enUS','','The Legion will tremble beneath Daumyr\'s shadow. They\'ll plead for mercy as we rain down death and destruction!',26124),
(128212,'enUS','','Do you see the Horsemen? Incredible that they\'re holding their own against that throng.',26124),
(128213,'enUS','','Another batch down! Send them to their graves!',26124),
(128214,'enUS','','The Horsemen kept those demons contained.',26124),
(128215,'enUS','','Daumyr made quick work of them. Did you hear their screams? Music to my ears!',26124),
(128216,'enUS','','I\'ve never felt so alive!',26124),
(128217,'enUS','|TInterface\\ICONS\\Ability_FelArakkoa_FelDetonation_Green:20|t Watch out! Avoid |cFFFF0404|Hspell:238005|h[Cataclysmic Force Nova]|h|r! in order to stay on the ship!','',26124),
(128218,'enUS','','Welcome, Slayer $p, to the breeding grounds of the fel bats. We\'ve captured a fine specimen for you to bond with today.$b$bJust inform me when you\'re ready to see it.',26124),
(128219,'enUS','','Illidari! Bring out the beast!',26124),
(128220,'enUS','','A few days ago, this fel bat attacked our camp. It\'s a rare treat to capture a mature specimen, so I insisted it be restrained rather than destroyed.',26124),
(128221,'enUS','','Taming such a willful beast requires a show of dominance. That is, of course, my specialty... but in this case, I suggest simply pummeling it into submission.',26124),
(128222,'enUS','','Quickly, bind the creature!',26124),
(128223,'enUS','','My apologies, Slayer, it seems to have escaped. Ah, but see here? A trail of blood. How convenient!',26124),
(128224,'enUS','','Tracking it should be simple, thanks to your demon sight. But if it\'s run off to the breeding grounds, I fear you may have some trouble bringing it back. Bats can be such... spirited creatures.',26124),
(128225,'enUS','I will activate the portal. Once it\'s open, I\'ll need you to place the Calling Stone to draw Arax\'ath and the Wrathsteed through.','',26124),
(128227,'enUS','No doubt he will send his minions to stop us. Maintaining the portal will require all of my strength, so I will rely on you to hold them off.','',26124),
(128228,'enUS','|TInterface\\Icons\\Ability_Rogue_BloodyEye:20|tThrashbite\'s |cFFFF0000|Hspell:237726|h[Scornful Gaze]|h|r falls on |cFFFF0000$n|r!','|TInterface\\Icons\\Ability_Rogue_BloodyEye:20|tThrashbite\'s |cFFFF0000|Hspell:237726|h[Scornful Gaze]|h|r falls on |cFFFF0000$n|r!',26124),
(128229,'enUS','What is this sensation? A dark force... reaching into my mind...','',26124),
(128230,'enUS','','This... doesn\'t seem right. Where am I?',26124),
(128231,'enUS','|TInterface\\Icons\\INV_SPEAR_08.BLP:20|t%s targets |cFFFF0000$n|r with a |cFFFF0000|Hspell:235933|h[Spear of Anguish]|h|r!','',26124),
(128232,'enUS','Erdris... your magic is weak! We... will... resist you!','',26124),
(128233,'enUS','','I see you\'ve tamed the beast, Slayer $p. Congratulations are in order, my dear!',26124),
(128234,'enUS','','Allow us to make the creature presentable so that it may be conferred to you at the Fel Hammer. Speak with Yrdris and he\'ll see you back to the ship.',26124),
(128235,'enUS','','I\'ve still some work to do here, but I\'ll meet you back at the Fel Hammer, Slayer $p.',26124),
(128236,'enUS','I would not waste the time you\'ve been given to complete your task, Farseer $p.','',26124),
(128237,'enUS','I\'m grateful for your aid, Farseer $p. I have no doubt you will resolve this issue swiftly.','',26124),
(128239,'enUS','Attack!','',26124),
(128240,'enUS','The winds carry my will to the far corners of this plane, but even I cannot be everywhere at once. Here in Skywall, certain of my subjects have not fully grasped the totality of my ascension.','',26124),
(128241,'enUS','They foolishly believe Sarsarun to be the rightful heir to the throne. I need you to convince them otherwise.','',26124),
(128242,'enUS','Ha ha ha ha ha!','',26124),
(128243,'enUS','I am unmoved by your babbling, demon. Feel the wrath of a true commander\'s army!','',26124),
(128244,'enUS','(CUT/UNUSED)Once they realize your intentions, they will seek to remove you from this plane. I will grant you a blessing that will prevent them from doing so, at least for a time.(CUT/UNUSED)','',26124),
(128245,'enUS','I see the Farseer has edified your allegiances in my direction. Good. Let me clear away any doubts still polluting your minds.','',26124),
(128246,'enUS','I am the Windlord now, and all of you bluster about within my domain. But let us not leave this council with a whiff of foul air.','',26124),
(128247,'enUS','Divided, we are scattered to the winds. But united, we are a cyclone of power. Let this council never dissipate again.','',26124),
(128248,'enUS','Farseer $p, I will return you to the Heart of Azeroth. Depart with my thanks.','',26124),
(128249,'enUS','Once there, I shall present you with a gift to show my appreciation. May it serve you well.','',26124),
(128250,'enUS','They\'ll never find this buried here...','They\'ll never find this buried here...',26124),
(128251,'enUS','May Elune guide your soul, my son.','May Elune guide your soul, my son.',26124),
(128252,'enUS','<sigh> We lost him too soon.','<sigh> We lost him too soon.',26124),
(128253,'enUS','<sigh> Another sentinel dead.','<sigh> Another sentinel dead.',26124),
(128254,'enUS','And another! Allying with these \"demons\" was a mistake.','And another! Allying with these \"demons\" was a mistake.',26124),
(128255,'enUS','The Legion hit this area hard. There don\'t seem to be any survivors.','The Legion hit this area hard. There don\'t seem to be any survivors.',26124),
(128256,'enUS','Welcome to the Scribe\'s Sacellum, $c. Can I interest you in some scrolls today?','',26124),
(128257,'enUS','Champion! Your expertise is needed! Prepare for battle!','',26124),
(128258,'enUS','Might as well start looking for something worth salvaging.','Might as well start looking for something worth salvaging.',26124),
(128259,'enUS','I know I dropped it somewhere around here...','I know I dropped it somewhere around here...',26124),
(128260,'enUS','Where could it be?!','Where could it be?!',26124),
(128261,'enUS','Our allies need your aid, champion. You must act at once!','',26124),
(128262,'enUS','<yawn> Is it already time to go back to work?','<yawn> Is it already time to go back to work?',26124),
(128263,'enUS','I wish I could nap all day.','I wish I could nap all day.',26124),
(128264,'enUS','Looks like that demon\'s poison got me in the end...','Looks like that demon\'s poison got me in the end...',26124),
(128265,'enUS','You were my friend! How could you do this to me? To my FAMILY?','You were my friend! How could you do this to me? To my FAMILY?',26124),
(128266,'enUS','A formidable enemy is close. Strike it down with all the malice it deserves!','',26124),
(128267,'enUS','You and your allies are needed, champion. Gather your forces!','',26124),
(128268,'enUS','A well-fought battle. The Legion has learned to fear you!','',26124),
(128269,'enUS','Strength of arms is not the only way to strike a blow against the Legion. Well done!','',26124),
(128270,'enUS','The downfall of such an enemy will inspire our forces... and seed fear into the demons\' hearts.','',26124),
(128271,'enUS','You and your comrades fought well. Such determination will be crucial in the battles to come.','',26124),
(128272,'enUS','Got something that needs blown up? Old Icks has got just the staff for you!','',26124),
(128273,'enUS','','You look like you\'ve lost something. Can I help?',26124),
(128274,'enUS','','The energy in this place is malevolent. Let\'s go!',26124),
(128275,'enUS','Intruders! Killing you will regain my master\'s favor!','',26124),
(128276,'enUS','You will know pain!','',26124),
(128277,'enUS','I will delight in your suffering!','',26124),
(128278,'enUS','Come, face your doom!','',26124),
(128279,'enUS','Easily broken!','',26124),
(128280,'enUS','Pathetic mortal!','',26124),
(128281,'enUS','Another foe felled!','',26124),
(128282,'enUS','I have earned my glory... and robbed these mortals of theirs.','',26124),
(128283,'enUS','The master will be pleased.','',26124),
(128284,'enUS','More... agony... to come...','',26124),
(128285,'enUS','Burn! Burn in the fires of my torment!','',26124),
(128286,'enUS','I will flatten you!','',26124),
(128287,'enUS','Pummel you to dust!','',26124),
(128288,'enUS','Smash you to pieces!','',26124),
(128289,'enUS','Hold still!','',26124),
(128290,'enUS','Hold still!','',26124),
(128291,'enUS','Stay where you are!','',26124),
(128292,'enUS','Pain rains upon you!','',26124),
(128293,'enUS','You dare challenge me?','',26124),
(128294,'enUS','I will break you!','',26124),
(128295,'enUS','Let us test your resolve!','',26124),
(128296,'enUS','You cannot withstand me!','',26124),
(128297,'enUS','%s spits.','%s spits.',26124),
(128298,'enUS','Hero! Our foes have infiltrated this area. We\'re relying on you to take them down!','',26124),
(128299,'enUS','We have allies in trouble nearby, champion. Please lend your aid!','',26124),
(128300,'enUS','Our scouts report the presence of a deadly enemy nearby. Time to go on the offensive!','',26124),
(128301,'enUS','This way, champion!','',26124),
(128302,'enUS','This way! Come at once!','',26124),
(128303,'enUS','Gather your allies, champion. A grave threat is at hand, and heroes are needed!','',26124),
(128304,'enUS','Well done! We have pushed the Legion back... for now, at least.','',26124),
(128305,'enUS','You work today has saved lives, champion. Take pride in that!','',26124),
(128306,'enUS','Well done! The way you took that target down reminds me of myself in my younger days. My much, much younger days.','',26124),
(128307,'enUS','Once again, I owe you a debt of thanks. I\'d say you\'re making quite a habit of this!','',26124),
(128308,'enUS','You and your friends make an impressive fighting force. It is through our unity that the Legion will fall!','',26124),
(128309,'enUS','Gather your allies, hero. The threat you are about to face will put all your skills to the test!','',26124),
(128310,'enUS','Light preserve us! Our allies are in need. Please, champion, help them!','',26124),
(128311,'enUS','Champion! The Light has need of you!','',26124),
(128312,'enUS','You have brought the Light to this dark place. Thank you.','',26124),
(128313,'enUS','You have saved many lives this day, hero. For this noble act, you have my thanks.','',26124),
(128314,'enUS','The Legion cannot stand against the power of the Light. Not when it has champions like you!','',26124),
(128315,'enUS','','My, it looks like Agatha\'s stumbled on another fun little plaything.',26124),
(128316,'enUS','The way you and your allies persevered is an inspiration to our forces. Proof that together we can save Azeroth!','',26124),
(128317,'enUS','','Stand back while we infuse the herbs into the brew...',26124),
(128318,'enUS','','There! It is done.',26124),
(128319,'enUS','','Worry not, Uhrlia - this one looks spry. Surely $Ghe:she; won\'t give up so easily.',26124),
(128320,'enUS','','Let\'s play, $c!',26124),
(128321,'enUS','','I do hope this one is more entertaining than the last.',26124),
(128322,'enUS','','Agatha... will be... pleased...',26124),
(128323,'enUS','','That was... exquisite...',26124),
(128324,'enUS','Blessings on you, Grandmaster!','',26124),
(128325,'enUS','I was so weak... Thank you for helping me!','',26124),
(128326,'enUS','Blech! I never thought I\'d be glad to taste something so vile!','',26124),
(128327,'enUS','I could feel my life slipping away... You have my eternal thanks, Grandmaster!','',26124),
(128328,'enUS','','Blessings on you, Grandmaster!',26124),
(128329,'enUS','','I was so weak... Thank you for helping me!',26124),
(128330,'enUS','','Blech! I never thought I\'d be glad to taste something so vile!',26124),
(128331,'enUS','','I could feel my life slipping away... You have my eternal thanks, Grandmaster!',26124),
(128332,'enUS','%s\'s Fel Bomb detonates!','%s\'s Fel Bomb detonates!',26124),
(128333,'enUS','An intruder? Show yourself!','',26124),
(128334,'enUS','Did you hear that? It came from over here!','',26124),
(128335,'enUS','Nothing gets past the Legion.','',26124),
(128336,'enUS','The Legion dispatches its all-seeing eyes to spy on our war efforts. Intolerable! Ensure nothing they have learned can be used against us.','',26124),
(128337,'enUS','The Night of the Wilds is upon us once more, friends.','',26124),
(128338,'enUS','On this evening, the spirits of the great beasts of legend rise in these very fields.','',26124),
(128339,'enUS','One among us has been chosen to enter the darkness.','',26124),
(128340,'enUS','To hunt the noble spirits and return them to their honored rest.','',26124),
(128341,'enUS','Raise your steins to the Huntmaster, our hunter of beasts!','',26124),
(128342,'enUS','Let the feast begin!','',26124),
(128343,'enUS','Once you have eaten your fill, hunter, depart the table and enter the wilderness. Your prey awaits!','',26124),
(128344,'enUS','Finding these clever beasts in the darkness will not be easy, but a true hunter is a master of tracking.','',26124),
(128345,'enUS','Hyrtir, the great stag, emerges! Swiftest of the beasts, with horns sharpened to a spear\'s point. Luck be with you, hunter!','',26124),
(128346,'enUS','Hyrtir was first pursued by Haldor of the Rocky Cliffs. The spirit of Haldor is with the hunter this night!','',26124),
(128347,'enUS','You follow the trail of Garos, the great worm. Many are her children, and deep are her tunnels.','',26124),
(128348,'enUS','Garos was brought here by Bjorn of the Black Storm. The spirit of Bjorn is with the hunter!','',26124),
(128349,'enUS','Ketlingr, the great cat, drinks before you. A lithe, fierce predator, many learned to fear her fangs and claws!','',26124),
(128350,'enUS','Ketlingr was slain by Tor of the Brutal Siege. The spirit of Tor is with the hunter!','',26124),
(128351,'enUS','Habrok, the great owl, perches above you. All beasts once feared her talons, and hid during the night from her keen vision.','',26124),
(128352,'enUS','Ranulf of the Screaming Abyss triumphed over Habrok in life. The spirit of Ranulf is with the hunter!','',26124),
(128353,'enUS','The spirits hold you in high regard, Huntmaster! The most renowned predators of all our legends have emerged. This is truly the grandest Night of the Wilds I have ever witnessed!','',26124),
(128354,'enUS','Behold! Den-mother Fereki, great predator of the earth, and mighty Vetholnir, lord of the skies.','',26124),
(128355,'enUS','What is this? A most rare and remarkable spirit has come forth, one that has not graced these fields for countless ages.','',26124),
(128356,'enUS','It is Haukenulfnir, who stalked the wilds when the world was new!','',26124),
(128357,'enUS','She senses your predatory prowess and kinship with beasts. She will test you, hunter, if you approach her.','',26124),
(128358,'enUS','She has found you worthy. The spirit of Haukenulfnir is with the hunter!','',26124),
(128359,'enUS','With her spirit now bound to yours, the children of Haukenulfnir will answer your summons in the mortal world.','',26124),
(128360,'enUS','Now come back to the fire, good hunter, and let us feast the night away!','',26124),
(128361,'enUS','Do you understand what the tale seeks to teach us? With our companions, we are so much stronger than we are alone.','',26124),
(128362,'enUS','Will you accept the companionship of the Wolfhawk?','',26124),
(128363,'enUS','Ha ha, I think it likes you, Hunter! You and the beast are now bonded, in this realm and the mortal realm. Now, let us return to the feast, and leave our worries for the morning!','',26124),
(128364,'enUS','Let us feast, then! To the Night of the Wilds! To the great beasts! To the Huntmaster!','',26124),
(128365,'enUS','Remain vigilant, champion! We must watch for our enemy, just as they are watching us!','',26124),
(128366,'enUS','The eve of our attack is nigh. Have you summoned the forces?','',26124),
(128367,'enUS','I will notify the summoners shortly. They will open the portals on my word only.','',26124),
(128368,'enUS','Good... once they are through, the foolish \"Legionfall Offensive\" will stand no chance. Their demise shall be delivered.','',26124),
(128369,'enUS','I...don\'t feel so good...','',26124),
(128370,'enUS','Fhambar senses something...','',26124),
(128371,'enUS','Fhambar doesn\'t find anything useful...','',26124),
(128372,'enUS','|TINTERFACE\\ICONS\\Ability_BossFelLord_FelSpike.blp:20|t Domatrax begins to cast |cFFFF0404|Hspell:234107|h[Chaotic Energy]|h|r! Take cover!','|TINTERFACE\\ICONS\\Ability_BossFelLord_FelSpike.blp:20|t Domatrax begins to cast |cFFFF0404|Hspell:234107|h[Chaotic Energy]|h|r!',26124),
(128373,'enUS','It looks like Fhambar has tracked down your missing mage. I\'ll be taking him back now.','',26124),
(128374,'enUS','Good luck with Agatha, $c. You will need it...','',26124),
(128375,'enUS','','My ward persists! It can protect you!',26124),
(128376,'enUS','','The chasm is warded against her magic!',26124),
(128377,'enUS','','The echo of my power can save you!',26124),
(128378,'enUS','','He\'s ancient, but tough! He can survive this... Right?',26124),
(128379,'enUS','It was an honor to fight beside you, Battlelord $n. I will report to Skyhold.','',26124),
(128380,'enUS','Hail to the Battlelord! Lok-tar!','',26124),
(128381,'enUS','I need passage to Felwing Ledge.','I need passage to Felwing Ledge.',26124),
(128382,'enUS','Iron-Body Ponshu coughs weakly.','',26124),
(128383,'enUS','My entire being, even my soul... burned...','',26124),
(128384,'enUS','I saw a vision. A tsunami of demons crashing down upon us... extinguishing every light... save for one.','',26124),
(128385,'enUS','Grandmaster, you are that light! Do not waver in your resolve to fight the Burning Legion!','',26124),
(128386,'enUS','','It is time for me to leave this realm, my friends. Almai, I believe you have grown beyond the life of a simple brewer.',26124),
(128387,'enUS','May you rest in peace, Brewmaster.','',26124),
(128388,'enUS','I\'m ready, Matron Mother.','I\'m ready, Matron Mother.',26124),
(128389,'enUS','If the Destroyer is alive, she\'s in great danger. No wonder she\'s so troubled...','',26124),
(128390,'enUS','Don\'t worry, lass. We\'ll protect ye. We\'ve got to!','',26124),
(128391,'enUS','Her nightmares... her greatest fears... we\'ve got to help!','',26124),
(128392,'enUS','Let us hear what she has to say, Magni.','Let us hear what she has to say, Magni.',26124),
(128393,'enUS','','Archdruid! The Shrine of Aviana is under attack again, and this time it\'s a full-scale invasion! The Ancient needs our help!',26124),
(128394,'enUS','','To hell with the front lines! I\'m going around back to take out their casters and artillery. You\'re welcome to join me!',26124),
(128395,'enUS','','Did you hear that? Screams from the shrine! We\'ve gotta get back there!',26124),
(128396,'enUS','','Die, demon scum!',26124),
(128397,'enUS','Perish before the might of the Legion!','',26124),
(128398,'enUS','','You wretched... No! The idol!',26124),
(128399,'enUS','','Noooo!',26124),
(128400,'enUS','','The shrine is lost. Druids, take flight! Retreat!',26124),
(128401,'enUS','','What the... Flight Form\'s not working?! With the idol gone, we\'ve lost our wings! Everyone teleport out and regroup at the Dreamgrove!',26124),
(128402,'enUS','','I\'ll meet you in Azsuna, Archdruid.',26124),
(128403,'enUS','','Let\'s see what\'s going on... discreetly!',26124),
(128404,'enUS','Legion! With this idol, the cowardly mortals\' floating city will no longer protect them.','',26124),
(128405,'enUS','','Wrong! You die this day, demon!',26124),
(128406,'enUS','You are too late, little druid! We will use your power of flight to bring down Dalaran!','',26124),
(128407,'enUS','','Blasphemy!',26124),
(128408,'enUS','','Over here!',26124),
(128409,'enUS','','Aviana, please! Help us!',26124),
(128410,'enUS','Enough of this game!','',26124),
(128411,'enUS','','It is done. Let\'s get this idol back to the Dreamgrove.',26124),
(128412,'enUS','','Druids! We were victorious! The Idol of Aviana is once again safe. Archdruid, please do the honors and put the idol back where it belongs.',26124),
(128413,'enUS','She\'s calmer now, but still troubled. I should be able ta reach her.$b$bAre ye ready, $n?','',26124),
(128414,'enUS','','Along with Xylem\'s other apprentices, I have been working to pinpoint his location. I believe we have found him in the Eye of Eternity, $ct!',26124),
(128415,'enUS','','From that location, Xylem could use the Focusing Iris to wreak untold havoc on Azeroth\'s ley lines.',26124),
(128416,'enUS','','The mages of the Kirin Tor can open a temporary portal to his location. You must put an end to Xylem\'s madness... but please, spare his life if you can!',26124),
(128417,'enUS','','Archdruid! I need your help!',26124),
(128418,'enUS','','I\'ll meet you there. We have to hurry--before it\'s too late!',26124),
(128421,'enUS','Make sure to study the runes well, $c. I don\'t want to know what will happen if we fail!','',26124),
(128422,'enUS','The Legion may try to wear us down - to erode our allies like rain-swept valleys after a storm, but we will never surrender. It is in our blood to fight until the sun shines upon us once more.','',26124),
(128423,'enUS','I am ready to begin.','I am ready to begin.',26124),
(128424,'enUS','','I command legions, mortal!',26124),
(128425,'enUS','','So many treasures, just waiting for me to grab!',26124),
(128426,'enUS','I draw upon the power of my ancestors!','',26124),
(128427,'enUS','The Drekirjar never yield!','',26124),
(128428,'enUS','|TInterface\\Icons\\ACHIEVEMENT_BOSS_SVALASORROWGRAVE.BLP:20|tSeveral Dark Val\'kyr form ranks to |cFFFF0000|Hspell:237761|h[charge]|h|r across the battlefield!','|TInterface\\Icons\\ACHIEVEMENT_BOSS_SVALASORROWGRAVE.BLP:20|tSeveral Dark Val\'kyr form ranks to |cFFFF0000|Hspell:237761|h[charge]|h|r across the battlefield!',26124),
(128429,'enUS','|TInterface\\Icons\\SPELL_FEL_ELEMENTALDEVASTATION.BLP:20|t%s starts casting |cFFFF0000|Hspell:237952|h[Ancestral Knowledge]|h|r!','|TInterface\\Icons\\SPELL_FEL_ELEMENTALDEVASTATION.BLP:20|t%s starts casting |cFFFF0000|Hspell:237952|h[Ancestral Knowledge]|h|r!',26124),
(128430,'enUS','|TInterface\\Icons\\ABILITY_WARRIOR_RAMPAGE.BLP:20|t%s gains |cFFFF0000|Hspell:237947|h[Berserker\'s Rage]|h|r!','|TInterface\\Icons\\ABILITY_WARRIOR_RAMPAGE.BLP:20|t%s gains |cFFFF0000|Hspell:237947|h[Berserker\'s Rage]|h|r!',26124),
(128431,'enUS','|TInterface\\Icons\\ABILITY_WHIRLWIND.BLP:20|t%s creates a |cFFFF0000|Hspell:237866|h[Bladestorm]|h|r!','|TInterface\\Icons\\ABILITY_WHIRLWIND.BLP:20|t%s creates a |cFFFF0000|Hspell:237866|h[Bladestorm]|h|r!',26124),
(128432,'enUS','|TInterface\\Icons\\ABILITY_WARLOCK_SHADOWFURYTGA.BLP:20|tSeveral |cFFFF0000|Hspell:237908|h[Runes]|h|r appear on the ground nearby.','|TInterface\\Icons\\ABILITY_WARLOCK_SHADOWFURYTGA.BLP:20|tSeveral |cFFFF0000|Hspell:237908|h[Runes]|h|r appear on the ground nearby.',26124),
(128433,'enUS','|TInterface\\Icons\\SPELL_FEL_ELEMENTALDEVASTATION.BLP:20|t%s channels the |cFFFF0000|Hspell:237945|h[Blood of her Father]|h|r!','|TInterface\\Icons\\SPELL_FEL_ELEMENTALDEVASTATION.BLP:20|t%s channels the |cFFFF0000|Hspell:237945|h[Blood of her Father]|h|r!',26124),
(128434,'enUS','Demonic filth taints this land, champion. We must eradicate it!','',26124),
(128435,'enUS','Give the word when you are ready, champion, and we will take to the skies.','',26124),
(128436,'enUS','','The power of my father\'s blood flows through me!',26124),
(128437,'enUS','Behold the speed of my axe!','',26124),
(128438,'enUS','The fury of the storm boils within me! Have you finished your preparations?','',26124),
(128439,'enUS','Greetings, champion. Are you here to answer the call of Odyn?','',26124),
(128440,'enUS','Well done! Our world will never fall so long as it is defended by champions such as you!','',26124),
(128441,'enUS','','(UNUSED)Your demon sight will be beneficial in keeping track of its trail of blood.(UNUSED)',26124),
(128442,'enUS','Welcome to Felwing Ledge, Slayer $p. The Matron Mother is waiting for you down in the training area, just west of here.','',26124),
(128443,'enUS','','Odyn and the greatest of his hunters await your presence at the Fields of the Eternal hunt.',26124),
(128444,'enUS','I am ready to attend the feast.','I am ready to attend the feast.',26124),
(128446,'enUS','','This body... my mind... compromised. I have failed the makers!',26124),
(128447,'enUS','','End me, mortals! Then rob the Deceiver of his prize!',26124),
(128448,'enUS','','I was not the first to place defenses in this temple, but I fear the ancient watcher charged with safeguarding this place... has been compromised. Be wary. I will offer you what protection I can.',26124),
(128449,'enUS','','For millennia I was steadfast in my vigil... unwavering. And then his voice called to me.',26124),
(128450,'enUS','','The unmovable object met the irresistible force, and I found... a new calling.',26124),
(128451,'enUS','','What lies below is not for mortal eyes!',26124),
(128452,'enUS','','You will not disturb the master\'s work!',26124),
(128453,'enUS','','A necessary end.',26124),
(128454,'enUS','','Flesh is weak!',26124),
(128455,'enUS','','My vigil continues. But... who is it I serve?',26124),
(128456,'enUS','','Your world\'s hope dies with you!',26124),
(128457,'enUS','','My vigil ends! Let not... the dark one... awaken...',26124),
(128458,'enUS','','He will rise! He... will... reign...',26124),
(128459,'enUS','Where would I find such a thing?','Where would I find such a thing?',26124),
(128460,'enUS','','Well, it must be also be nightborne in origin for a harmonious marriage to be achieved. Oh - and it must be newly forged and still unattached. Anything else will result in disaster. \n\nIf the rumors are true, Aethas might be able to help. Supposedly he has taken a rather striking nightborne apprentice! It is quite scandalous.\n\nYou should ask him to introduce you to her.',26124),
(128461,'enUS','','Outsider! Sigryn has stormed the Halls of Valor, determined to confront Odyn. In her blind rage, she races headlong to her doom!',26124),
(128462,'enUS','','Your Kirin Tor have found the means to convey you into Odyn\'s halls. Hurry! Sigryn must be made to see reason, before it is too late!',26124),
(128463,'enUS','','The fate of the Tideskorn rests in your hands. Gods be with you, outsider!',26124),
(128464,'enUS','Be calm, Aviash. $n is one of our allies.','',26124),
(128465,'enUS','%s squawks loudly as you approach.','',26124),
(128466,'enUS','What a hunt! This, out here, is the true spirit of the wilds. Let us revel the night away and leave our cares for the morning!','',26124),
(128467,'enUS','<Revel the night away and awake in Trueshot Lodge.>','<Revel the night away and awake in Trueshot Lodge.>',26124),
(128468,'enUS','It was an honor to fight alongside you, Battlelord $n. I will report to Skyhold. See you there!','',26124),
(128469,'enUS','','I will meet you at Valdisdall in Stormheim. We should be able to reach Skold-Ashil from there.',26124),
(128470,'enUS','','Movement in the trees! Watch out!',26124),
(128471,'enUS','','My last moments here were spent escaping the clutches of assassins sent to murder my family.',26124),
(128472,'enUS','','Be forewarned. They may still be on the hunt.',26124),
(128473,'enUS','','It would seem that escaping my past was too much to hope for.',26124),
(128474,'enUS','','I will never forget the night they came. My mother fell before my eyes, and they had descended on my brother before I managed to escape.',26124),
(128475,'enUS','','Cowardly scum! I would hunt down every one of them, and their masters as well, if I knew who sent them.',26124),
(128476,'enUS','','Another ambush! Bare your steel!',26124),
(128477,'enUS','','It\'s no use, though. They never fail to elude my grasp. I must concentrate on the task at hand.',26124),
(128478,'enUS','','I take solace knowing they will be judged by the gods when their time comes.',26124),
(128479,'enUS','','After that night, I was alone. The last of my bloodline.',26124),
(128480,'enUS','Grandmaster! Could you spare a moment to listen to an old man\'s tale?','',26124),
(128481,'enUS','Xuen, the White Tiger, one of the August Celestials, had a son named Ban-Lu.','',26124),
(128482,'enUS','Over the centuries, Ban-Lu served as the personal mount of each grandmaster. It was a duty he was honored to fulfil!','',26124),
(128483,'enUS','But Ban-Lu has not been seen since the Legion\'s attack on the Peak of Serenity. It seems the loss of life... affected him deeply.','',26124),
(128484,'enUS','Perhaps if we return there, we may find clues to his whereabouts.','',26124),
(128485,'enUS','Grandmaster! Over here.','',26124),
(128486,'enUS','Look for any sign of where Ban-Lu might be.','',26124),
(128487,'enUS','What have you found? Let me see...','',26124),
(128488,'enUS','A trail of paw prints! Hmm, where might they lead...','',26124),
(128489,'enUS','Phew! An exciting journey, but wearying. Please allow me a moment to rest. Perhaps you could ask these grummles whether they\'ve seen Ban-Lu.','',26124),
(128490,'enUS','Wait for me, please! These old bones aren\'t what they used to be.','',26124),
(128491,'enUS','Could you slow down a moment? I do apologize for my languid pace.','',26124),
(128492,'enUS','Where did you go? Oh, wait there. Thank you for showing patience to an old man.','',26124),
(128493,'enUS','Shall we continue the search for Ban-Lu, Grandmaster?','',26124),
(128494,'enUS','It seems we have reached a dead end. I shall meditate on this conundrum.','',26124),
(128495,'enUS','Grandmaster, I have an idea...','',26124),
(128496,'enUS','Grandmaster! Have you found Ban-Lu?','',26124),
(128497,'enUS','Not here? Are you sure? Perhaps you should be more observant, Grandmaster...','',26124),
(128498,'enUS','Filled with sorrow by the death of Grandmaster Hight, I wandered Pandaria to reflect.','',26124),
(128499,'enUS','But in the midst of that reflection, I saw something new and interesting appear... you!','',26124),
(128500,'enUS','You have shown patience with Master Bu, honor with the grummles, duty with the Shado-Pan, and faith with the jinyu.','',26124),
(128501,'enUS','It is clear you embody the wisdom, integrity, and tenacity of a grandmaster. Only one test remains... Prove to me that you can fight like a grandmaster!','',26124),
(128502,'enUS','Your skills are impressive indeed, Grandmaster! I would be honored to serve you, as I served the great leaders of our order who came before.','',26124),
(128503,'enUS','Let us return to the Wandering Isle... together!','',26124),
(128504,'enUS','We will not be stopped!','',26124),
(128505,'enUS','We must give up! The strength of the Legion will destroy us!','',26124),
(128506,'enUS','','I\'m prepared to take you to the Halls of Valor. Speak with me when your allies have gathered and you are ready.',26124),
(128507,'enUS','Where are we going today, Grandmaster?','',26124),
(128508,'enUS','Good to see you again, Grandmaster.','',26124),
(128509,'enUS','You might want to cut back on the mana buns, Grandmaster...','',26124),
(128510,'enUS','Good luck, Grandmaster!','',26124),
(128511,'enUS','Farewell!','',26124),
(128512,'enUS','The lazy yak never gets washed.','',26124),
(128513,'enUS','Listen to all voices, Grandmaster. Surrounded only by those who share your views, your mind can never grow.','',26124),
(128514,'enUS','Idleness rarely leads to success, Grandmaster.','',26124),
(128515,'enUS','Is it much further, Grandmaster?','',26124),
(128516,'enUS','Remember to finish crossing the river before you tell the crocolisk he has bad breath!','',26124),
(128517,'enUS','To speak of change without being willing to take action is like digging a hole to catch a cloud serpent.','',26124),
(128518,'enUS','A kite cannot fly unless the wind blows against it, Grandmaster.','',26124),
(128519,'enUS','The wise monk chooses their own style, rather than letting popular opinion dictate it.','',26124),
(128520,'enUS','The best time to plant a tree is fifty years ago. The second-best time is now.','',26124),
(128521,'enUS','Do not concern yourself with failure, Grandmaster. Rather, focus on rising every time you fall.','',26124),
(128522,'enUS','The wise brewmaster recognizes the importance of taking a drink... and the importance of stopping before the drink takes the brewmaster.','',26124),
(128523,'enUS','Have I told you the tale of the hozen and the buttercream pie? Hmm... Perhaps best saved for another time.','',26124),
(128524,'enUS','Ah, a refreshing swim... Reminds me of the time I swam all the way to Kezan. Grandmaster Rochu wasn\'t happy about how shriveled his paws got!','',26124),
(128525,'enUS','Don\'t worry about me, Grandmaster. I remembered my water breathing potions.','',26124),
(128526,'enUS','You handle this one, squire.','',26124),
(128527,'enUS','Assist me!','',26124),
(128528,'enUS','I require... a short respite.','',26124),
(128529,'enUS','Did you take heed of my victory, squire?','',26124),
(128530,'enUS','Another fiend felled by my mighty blows!','',26124),
(128531,'enUS','Well, that was easy.','',26124),
(128532,'enUS','I shall slay thee with my mighty sword!','',26124),
(128533,'enUS','Excaliberto! Attack!','',26124),
(128534,'enUS','What a strange looking dragon! No matter!','',26124),
(128535,'enUS','For Doloria!','',26124),
(128536,'enUS','By my might, I slay thee!','',26124),
(128537,'enUS','Why hello again, squire!','',26124),
(128538,'enUS','What ho!','',26124),
(128539,'enUS','We shall slay mighty beasts together!','',26124),
(128540,'enUS','Let us ride!','',26124),
(128541,'enUS','What ho!','',26124),
(128542,'enUS','Yes?','',26124),
(128543,'enUS','How may I serve?','',26124),
(128544,'enUS','Very well.','',26124),
(128545,'enUS','Oh begone! I have dragons to slay!','',26124),
(128546,'enUS','Farewell, then.','',26124),
(128547,'enUS','Do you know who it is you are addressing?','',26124),
(128548,'enUS','I am Maximillian of Northshire, damsel rescuer extraordinaire. How dare you!','',26124),
(128549,'enUS','I say, are you keen to feel the pointy part of my blade?','',26124),
(128550,'enUS','','I will meet you back at the Hall of the Guardian, Archmage $n.',26124),
(128551,'enUS','It is time, my friend. I have located Erdris Thorn in the upper spires of Blackrook Hold, where he plots to raise an undead army!','',26124),
(128552,'enUS','A pair of Bradensbrook\'s fiercest fighters have insisted on joining our campaign. But even with their help, the battle ahead will be treacherous.','',26124),
(128553,'enUS','Come, $n. Let us put Erdris to rest... once and for all.','',26124),
(128554,'enUS','Tugar Bloodtotem has resurfaced in Highmountain. With him is an immense worm saturated with fel energy.','',26124),
(128555,'enUS','We must put an end to him, along with that nasty pet of his, before they attack Thunder Totem. This will be no easy task.','',26124),
(128556,'enUS','I have given my location to your mages. Once you arrive here, we will enter Tugar\'s cavern and neutralize his threat.','',26124),
(128557,'enUS','','The Prophet has prepared his incantations, and I have meditated long enough. Kruul must die.',26124),
(128558,'enUS','','Upon your arrival, we will reopen the portal to the demon\'s domain and finish him... once and for all!',26124),
(128559,'enUS','','This mage will teleport you to us. The task ahead will not be easy. Be prepared!',26124),
(128560,'enUS','Remember, keep your distance from the Nightborne Soulstone as it is siphoning energy!','',26124),
(128561,'enUS','Well done. Meet me near Lady Remor\'za\'s tower and I will summon a portal.','',26124),
(128562,'enUS','','C\'mon, Archdruid! My people need our help!',26124),
(128563,'enUS','','To the dark depths of Hel with you!',26124),
(128564,'enUS','Yes?','',26124),
(128565,'enUS','What needs conjuring?','',26124),
(128566,'enUS','You require my services?','',26124),
(128567,'enUS','What shall we summon today?','',26124),
(128568,'enUS','The dreadsteeds will be ours.','',26124),
(128569,'enUS','Xoroth beckons.','',26124),
(128570,'enUS','The demons will bow to us.','',26124),
(128571,'enUS','Fel hooves grant you swiftness.','',26124),
(128572,'enUS','Have you brought me more blood?','',26124),
(128573,'enUS','Shouldn\'t you be fetching materials or something?','',26124),
(128574,'enUS','Why don\'t I ever get to keep the dreadsteed?','',26124),
(128575,'enUS','','Foolish druids... our distraction has succeeded!',26124),
(128576,'enUS','','Hail, outsider.',26124),
(128577,'enUS','','What is your purpose?',26124),
(128578,'enUS','','My shield is ready.',26124),
(128579,'enUS','','I stand unbroken.',26124),
(128580,'enUS','','I will not falter.',26124),
(128581,'enUS','','Gods go with you.',26124),
(128582,'enUS','','Fight with honor, outsider.',26124),
(128583,'enUS','','I will be hunted no longer.',26124),
(128584,'enUS','','Stop. Now.',26124),
(128585,'enUS','','Perhaps my father was right about you.',26124),
(128586,'enUS','','My bloodline is not known for having even tempers.',26124),
(128587,'enUS','','Even the Legion has not been this irritating!',26124),
(128588,'enUS','','You know, I might look good in green...',26124),
(128589,'enUS','','A fel-fire spear might prove useful right about now...',26124),
(128590,'enUS','Well met.','',26124),
(128591,'enUS','Hail, adventurer.','',26124),
(128592,'enUS','Light\'s blessings, traveller.','',26124),
(128593,'enUS','How can I help?','',26124),
(128594,'enUS','The Light grant you strength.','',26124),
(128595,'enUS','I will protect the realm.','',26124),
(128596,'enUS','My shield is yours.','',26124),
(128597,'enUS','I will smite our foes!','',26124),
(128598,'enUS','Be wary of dragons. They cannot be trusted!','',26124),
(128599,'enUS','In our time together, my brother and I have seen wars and tests aplenty.','',26124),
(128600,'enUS','I am but one of many who has taken up the lance for Azeroth.','',26124),
(128601,'enUS','Greetings.','',26124),
(128602,'enUS','I can always use another apprentice.','',26124),
(128603,'enUS','Do you like... trials?','',26124),
(128604,'enUS','Am I here... or am I an illusion?','',26124),
(128605,'enUS','Do try not to die now!','',26124),
(128606,'enUS','Go forth, and do... something!','',26124),
(128607,'enUS','Wait, who are you again?','',26124),
(128608,'enUS','Keep up your studies.','',26124),
(128609,'enUS','Wait... did I leave the Trial of Fire on? I\'m pretty sure I turned it off...','',26124),
(128610,'enUS','Apprentices..? Apprenticeese..? Apprentici..? Yes, I think that\'s it...','',26124),
(128611,'enUS','You\'ll never become a real mage wearing that outfit.','',26124),
(128612,'enUS','I went full shadow... Never go full shadow.','',26124),
(128613,'enUS','','If this was only a distraction, where\'s the main attack? We need to ask Aviana. She\'ll know!',26124),
(128614,'enUS','We discovered the saboteur\'s corpse near the weapons core. His soul had been drained... Ugh, such a terrible way to die.\n\nThe situation is worse than I let on, I\'m afraid.','',26124),
(128615,'enUS','It seems our allies somehow repelled the attack... stay at the ready.','',26124),
(128616,'enUS','How did the Legion gain access to Dalaran\'s weapons?','How did the Legion gain access to Dalaran\'s weapons?',26124),
(128617,'enUS','You\'re ordered to report to the battlefield at once. Take out those demons shredding our front lines!','',26124),
(128618,'enUS','The saboteur was from the Horde - one of my own Sunreavers, in fact.\n\nThere are those on the Council who strongly opposed allowing us back into the Kirin Tor in the first place. As you can imagine, this gives them all the ammunition they need to lobby for our expulsion yet again.\n\nAnd if that happens, our truce will shatter and Azeroth will surely fall to the Legion.','',26124),
(128619,'enUS','Go on.','Go on.',26124),
(128620,'enUS','The mighty Legion has attacked, and we are barely holding off their siege.','',26124),
(128621,'enUS','','Even with Kanrethad returned to us, these occultists remain loyal to the Legion. We cannot let them regain control of Felfire Pass. Thin their numbers and absorb their sources of power!',26124),
(128622,'enUS','','Such a display of power! I\'d wager those occultists regret allying with our enemy!',26124),
(128623,'enUS','','Felfire Pass is crawling with occultists loyal to the Burning Legion. We cannot let them gain a footing!',26124),
(128624,'enUS','','Even with their leader dead, these felborne trappers won\'t stop! Take this manaroot salve and apply it to any wounded animals you see. Save as many as you can!',26124),
(128625,'enUS','Thunder Totem is under siege! Let us save our comrades before we knock that demon vessel out of the sky.','',26124),
(128626,'enUS','','You are a true protector of nature. You have my thanks.',26124),
(128627,'enUS','','My chosen offer the gift of life, champion. Claim their prize and fight on!',26124),
(128628,'enUS','','Champions, the Legion seeks to infiltrate Thunder Totem from below. Help push them back!',26124),
(128629,'enUS','You are a traitor to our people, siding with these demon worshippers!','',26124),
(128630,'enUS','','One of Navarrogg\'s geomancers is sealing the tunnels to stem the flow of Legion enemies. Defend him at all costs!',26124),
(128631,'enUS','','Argh!',26124),
(128632,'enUS','','Heroes... deal with this... fiend...',26124),
(128633,'enUS','','Good work, heroes. Though only two of the tunnels were sealed, every bit helps.',26124),
(128634,'enUS','We are ready to attack the Legion ship. Mayla, champions, meet me outside Thunder Totem. Time to make them pay!','',26124),
(128635,'enUS','','Understood. Heroes, lets get to the rendezvous point.',26124),
(128636,'enUS','','Look out!',26124),
(128637,'enUS','','We must keep moving!',26124),
(128638,'enUS','','Once aboard, rescue all the captives you can. When my people are safe, set these explosives and get off the ship... fast!',26124),
(128639,'enUS','These war eagles will carry us to our destination. Ready to go? Then climb aboard!','',26124),
(128640,'enUS','I leave it to you to sabotage the Legion ship and rescue our allies. The demon commander is mine!','',26124),
(128641,'enUS','Arrgh!','',26124),
(128642,'enUS','','Felborne trappers are using their twisted magic upon the wildlife here. Take this manaroot salve and apply it to any wounded animals you see. Hurry, before the corruption takes hold!',26124),
(128643,'enUS','Heh. Is this all this planet can offer? So very weak. I desire a true challenge.','',26124),
(128644,'enUS','','Hurry, heroes. Lasan needs your help!',26124),
(128645,'enUS','A close call. Thank you for the help.','',26124),
(128646,'enUS','What a battle! Any moment now this ship will explode into tiny pieces. No matter! One of our eagles will see you to safety!','',26124),
(128647,'enUS','','The fel contagion has found its way to Deadwood Landing once again, High Priest. We must contain this sickness before it infects the mainland.',26124),
(128648,'enUS','','A terrible contagion has consumed Deadwood Landing. The harpies that infest the island are carriers. Their corruption must not be allowed to spread!',26124),
(128649,'enUS','','Brilliant work! The contagion appears to be contained.',26124),
(128650,'enUS','Tell me more about Arcanist Ryanna.','Tell me more about Arcanist Ryanna.',26124),
(128651,'enUS','I discovered her quite by accident, really. Er, well, she discovered me.\n\nI got myself into a bit of a.. situation... with a harpy and a banshee, and... oh nevermind.\n\nAnyway, Ryanna freed me with some very impressive spellwork. And then asked to join the Tirisgarde.\n\nHow could I turn her down?','',26124),
(128652,'enUS','','I\'ll meet you up ahead.',26124),
(128653,'enUS','\'Tis good ta see ye, $n. Now that the nightmares are gone, we can find out what she wants ta tell us. Give the word and we\'ll begin.','',26124),
(128654,'enUS','She\'s tryin\' ta send me a message... a warning, methinks. But somethin\'s not right with her.','',26124),
(128655,'enUS','Meet me in Sholazar Basin up in Northrend. Together, we\'ll get ta the bottom o\' this!','',26124),
(128656,'enUS','A shame Brann didn\'t come with ye. Nothin\' me brother loves more than openin\' titan doors!','',26124),
(128657,'enUS','Enough of this! I will put an end to you myself!','',26124),
(128658,'enUS','Anomaly detected. Engaging defense protocol Gamma Theta Phi Omicron.','',26124),
(128659,'enUS','Reactivation sequence complete. Initiating sentry protocols.','',26124),
(128660,'enUS','Self-repair mode resumed. External assistance evaluation: appreciated.','',26124),
(128661,'enUS','I sense her fear... her doubt. We\'ve gotta help her! Looks like some o\' the defenses are down. If ye reactivate \'em, it might help snap her out o\' this!','',26124),
(128662,'enUS','Ye did it! The nightmares are contained. Keep going, I\'m just ahead in the next chamber.','',26124),
(128663,'enUS','You are BLIND. I WILL FORCE YOUR EYES OPEN.','',26124),
(128664,'enUS','Champion! Azeroth needs our help.','',26124),
(128665,'enUS','Ah, yer gettin\' close. Come ta the Makers\' Overlook, high in the eastern mountains. I\'ll show ye the way inside.','',26124),
(128666,'enUS','Here ya go. This pad\'ll bring ye deep below ground, ta a place no mortal has walked in millennia... the Hall o\' Communion! C\'mon down, I\'ve got a lot to show ye.','',26124),
(128667,'enUS','The titans built these halls ta watch over the soul o\' the world. From this chamber I can hear her, clear as diamond.','',26124),
(128668,'enUS','Lately she\'s seemed... troubled. Hard ta read. I hope ye can help me get through ta her.','',26124),
(128669,'enUS','Somethin\'s triggered the defenses! Careful now, ye\'ve got company!','',26124),
(128670,'enUS','','I\'m not sure if this will work, but I might as well give it a shot... Stand back!',26124),
(128671,'enUS','These phantoms must be her dreams... her nightmares. If we help her overcome these horrors, Azeroth should be able ta give us her message.','',26124),
(128672,'enUS','','The shal\'dorei have been isolated for so many generations. We find it difficult to open our minds to new ways of thinking.',26124),
(128673,'enUS','Talk ta me, lass. Tell me what\'s got ye all in a tizzy...','',26124),
(128674,'enUS','','If my elders knew I was consorting with an outlander, I would be banished... Or worse.',26124),
(128675,'enUS','The Dark Titan comes! We gotta stop him! Argus... the Legion\'s homeworld. She says our destiny lies there.','',26124),
(128676,'enUS','','Aviana! Your children need you. The Druids of the Talon are being slaughtered at the hands of the Legion!',26124),
(128677,'enUS','Her feelin\'s are a jumble. I need ta focus, let her thoughts flow into--UNNGG!','',26124),
(128678,'enUS','','I have always found magic to be wondrous in all of its forms. Now that the shield has dropped, I cannot wait to master all of it!',26124),
(128679,'enUS','Sands... soaked in pain. Rivers... rivers of blood.','',26124),
(128680,'enUS','How did you meet Aethas?','How did you meet Aethas?',26124),
(128681,'enUS','','To think my brothers and sisters died to a \"distraction\"... I won\'t stand for it!',26124),
(128682,'enUS','Skies aflame. A sword... in the darkness... the wound... burning...','',26124),
(128683,'enUS','How can we help?','How can we help?',26124),
(128684,'enUS','','Aviana, your birds bring news from all over Azeroth. Please, help us find the demons\' target! We must avenge our fallen kin!',26124),
(128685,'enUS','Sar...ger...as...','',26124),
(128686,'enUS','','Oh! I came upon him in Tel\'anor caught in a harpy\'s bonds without a stitch of clothing! Ha!\n\nThe harpy was so busy arguing with a banshee over who got to play with him first, that they did not notice me at all.\n\nHe looked terribly uncomfortable, so I intervened. And the rest is history!',26124),
(128687,'enUS','Threat neutralized. Deploying repair matrix.','',26124),
(128688,'enUS','No local threats detected. Commencing assistance appreciation.','',26124),
(128689,'enUS','','Threat signatures neutralized. Facility defenses at 74.39 percent. Repairs in progress.',26124),
(128690,'enUS','','Subject: Azeroth. Minor arrhythmia detected, but vitals within acceptable parameters. Incident reports updated.',26124),
(128697,'enUS','I\'m coming for you!','',26124),
(128698,'enUS','Let\'s go.','Let\'s go.',26124),
(128699,'enUS','','Those who harm my children shall pay!',26124),
(128700,'enUS','','Aviana!',26124),
(128701,'enUS','Spiders! Of all the infernal demons the Legion could dispatch into my realm, why did it have to be spiders?','',26124),
(128702,'enUS','It is imperative that you destroy any clutches of eggs you find. This infestation must not spread!','',26124),
(128703,'enUS','','Wow... Aviana...',26124),
(128704,'enUS','','There\'s no time to lose, Archdruid! I\'m ready to stab some demons!',26124),
(128705,'enUS','I have faced malevolent naga, angry spirits, and insidious demons. But spiders... unbearable!','',26124),
(128706,'enUS','I have a very sticky situation for you, champion. We need silk harvested from the broods of the Creeping Grotto to use for a rather complex incantation. Can you help?','',26124),
(128707,'enUS','I sense a foul force within Bradensbrook, hero. Search for Legion presence and destroy it!','',26124),
(128708,'enUS','Well done, hero! So long as the shadow of the Legion darkens our world, we must remain vigilant.','',26124),
(128709,'enUS','We were having quite a time finding volunteers brave enough to enter that nest of evil. If you need a new pair of shoes after wading through those webs, I have a connection in Dalaran that can offer you a discount!','',26124),
(128710,'enUS','Hey bub! I got a proposition for ya!','',26124),
(128711,'enUS','Now we\'re talkin\'! Just look at that thing go!','',26124),
(128712,'enUS','Don\'t worry about our test subjects. I\'m sure they\'re used to these things by now.','',26124),
(128713,'enUS','That\'s enough testing, bud. I think it\'s time to start thinking about mass production!','',26124),
(128714,'enUS','Swing back to the Hall of the Guardian, and I\'ll give ya a little something for your troubles.','',26124),
(128715,'enUS','Alright, now the first thing you gotta do is get yourself a hat with a pocket dimension portal inside.','',26124),
(128716,'enUS','Then you just fill it with bunnies, aaaand.... bam!','',26124),
(128717,'enUS','Here, now you try.','',26124),
(128718,'enUS','What the whatnow!?','',26124),
(128719,'enUS','Alright pal, just poke around in there and see what\'s going on with the rabbits.','',26124),
(128720,'enUS','How did a wolf get in there?! Well don\'t just stand around, kill the thing!','',26124),
(128721,'enUS','Phew, that was a close one! Rabbits don\'t come cheap, y\'know!','',26124),
(128722,'enUS','Hang tight a sec. I\'ll get you outta there.','',26124),
(128723,'enUS','Alright! I\'ll grab my stuff and we can ditch these stiffs.','',26124),
(128724,'enUS','See ya later, prestigidi--, um, prestidigigat-- Eh, forget it!','',26124),
(128725,'enUS','I sense another infestation of demons nearby. Champion, I am counting upon you to eradicate them!','',26124),
(128726,'enUS','Haha! So long, arch-losers!','',26124),
(128727,'enUS','It will take time, but thanks to your deeds the land will one day recover. Well done, hero!','',26124),
(128728,'enUS','Your path leads only to ruin. Lay down your weapons and bow before your masters!','',26124),
(128729,'enUS','Don\'t like the show? You can kiss my sparkling enchanted posterior!','',26124),
(128730,'enUS','Oh, coming back for more, I see? Well, ya better be a good tipper, bub!','',26124),
(128732,'enUS','','Help me! Hurry!',26124),
(128734,'enUS','','Come on, let\'s go! We have to save Goldrinn!',26124),
(128735,'enUS','I had this compass crafted for my father\'s birthday. I gave it to him a few months before my ship ran aground on Pandaria. A lifetime ago...','',26124),
(128736,'enUS','Since this war with the Legion began, I\'ve barely had a chance to think or breathe... or to mourn. Perhaps it\'s time to change that.','',26124),
(128737,'enUS','Thank you for bringing my father\'s compass back to me. It is a reminder of how much I miss him.','',26124),
(128738,'enUS','Our guest arrives. Perhaps now there is hope of reaching the king.','',26124),
(128739,'enUS','Anduin refuses to eat or sleep. He ignores every plea to return to the palace. Nothing I say seems to offer comfort.','',26124),
(128740,'enUS','I understand the need to mourn, but the king\'s place is on his throne. The Broken Shore must be our focus. Convince Anduin to end his vigil!','',26124),
(128741,'enUS','','The portals should be around here somewhere... Keep your eyes open!',26124),
(128742,'enUS','','Can you imagine the demons coming through and ending up with a face full of vines? Classic!',26124),
(128743,'enUS','','That\'ll show \'em!',26124),
(128744,'enUS','','No demons are coming through this portal any time soon!',26124),
(128745,'enUS','','They... They\'re trying to corrupt Goldrinn! Quick, Archdruid!',26124),
(128746,'enUS','King Greymane said you would be coming. Please, go right in.','',26124),
(128747,'enUS','I\'ll need a disguise to move through the city without attracting attention.','',26124),
(128748,'enUS','I think I know just the spell. Follow me.','',26124),
(128749,'enUS','<Goldrinn lays asleep, peaceful now that the fel energies are gone.>','',26124),
(128750,'enUS','Wake up, Goldrinn.','Wake up, Goldrinn.',26124),
(128751,'enUS','You should take out those imps quickly. They\'re not the hardiest creatures, but they can overwhelm you if left unchecked!','',26124),
(128752,'enUS','The Legion will not get away with this!','The Legion will not get away with this!',26124),
(128753,'enUS','Admit that I am right! Break the body and the spirit follows.','',26124),
(128754,'enUS','Physical pain? Bah! Mental anguish is the true weapon. Was it not the key to turning Rakeesh?','',26124),
(128755,'enUS','Bah! It was the suffering I inflicted which... Hold! The mortals come! That fool Goroth has failed again!','',26124),
(128756,'enUS','Sooner than expected, but no matter. Our work begins!','',26124),
(128757,'enUS','','They brought back my cousin\'s body from the Broken Shore last week. I expect a lot more to follow.',26124),
(128758,'enUS','Pain! Pain beyond measure!','',26124),
(128759,'enUS','Agony impales you!','',26124),
(128760,'enUS','At least we\'re safe here in Stormwind. King Wrynn will keep the city safe.','',26124),
(128761,'enUS','I will cut you to the core!','',26124),
(128762,'enUS','Feed me with your screams!','',26124),
(128763,'enUS','','Funny, I thought I just heard... No. It must be my imagination playing tricks on me.',26124),
(128764,'enUS','Your suffering will be legend!','',26124),
(128765,'enUS','How much can you withstand?','',26124),
(128766,'enUS','This will hurt... I promise!','',26124),
(128767,'enUS','They\'re right to be afraid. If we fail to stop the Legion on the Broken Shore, the demons will strike us here, at our home and hearth.','',26124),
(128768,'enUS','Another broken body!','',26124),
(128769,'enUS','Fragile mortal!','',26124),
(128770,'enUS','Too much to endure?','',26124),
(128771,'enUS','Death was too easy an escape for them.','',26124),
(128772,'enUS','Their souls shall bear the torment of defeat for all eternity!','',26124),
(128773,'enUS','The pain... of failing... the master...','',26124),
(128774,'enUS','Our suffering... will be... glorious...','',26124),
(128775,'enUS','I offer respite from the darkness! Surrender your will to me!','',26124),
(128776,'enUS','Why endure this pain? Kneel to the Legion!','',26124),
(128777,'enUS','I will burn away your defiance!','',26124),
(128778,'enUS','Resistance will only bring pain!','',26124),
(128779,'enUS','I\'m King Anduin! I\'m gonna kill every demon I see!','',26124),
(128780,'enUS','Your minds will break!','',26124),
(128781,'enUS','Beg for release, mortals!','',26124),
(128782,'enUS','','Don\'t be Anduin, be Varian! He was way tougher.',26124),
(128783,'enUS','Yeah, my dad says that too. Okay, I\'m King Varian. Look out, demons!','',26124),
(128784,'enUS','I can\'t blame the lad for his choice. My father sacrificed everything to save his people. He was a great king.','',26124),
(128785,'enUS','You are mine now!','',26124),
(128786,'enUS','So weak a will!','',26124),
(128787,'enUS','Too delicate to survive!','',26124),
(128788,'enUS','That one\'s mind gave out!','',26124),
(128789,'enUS','Mortal minds break so easily. It is unsatisfying.','',26124),
(128790,'enUS','It was their bodies that gave out! The triumph is mine!','',26124),
(128791,'enUS','This defeat... will haunt me...','',26124),
(128792,'enUS','There is... more pain... to come...','',26124),
(128793,'enUS','Take heed, mortals! Obedient souls serve the Legion!','',26124),
(128794,'enUS','Look how eagerly this soul obeys us!','',26124),
(128795,'enUS','All my handiwork... ruined!','',26124),
(128796,'enUS','You will pay for that insult!','',26124),
(128797,'enUS','Since you brought my father\'s compass back to me, I\'ve prayed to the Light for guidance, and to know his spirit is at rest. The Light doesn\'t answer.','',26124),
(128798,'enUS','Poor soul! And you think I am the cruel one...','',26124),
(128799,'enUS','My people like me, respect me... but they don\'t believe in me. Not like they believed in him.','',26124),
(128800,'enUS','I\'ve heard the voice of the people, but how do my father\'s advisors feel? I fear they do not trust me as they did my father.','',26124),
(128801,'enUS','The young king will become a great leader. I have foreseen it.','',26124),
(128802,'enUS','Visions don\'t win wars, Prophet. The boy has a good heart, but he\'s untested.','',26124),
(128803,'enUS','The Light is strong with Anduin. He will grow into his crown. We must have faith.','',26124),
(128804,'enUS','Yes, my precious ones. The fel has brought out our true beauty.','',26124),
(128805,'enUS','Feel your throat tighten!','',26124),
(128806,'enUS','This breath will be your last!','',26124),
(128807,'enUS','We need more than that, and so does he. Anduin wasn\'t there on the Broken Shore. He hasn\'t seen the sacrifice his soldiers made... that they continue to make.','',26124),
(128808,'enUS','I will crush the life from you!','',26124),
(128809,'enUS','A king must know the weight of the orders he gives--the price of them. If a compass breaks his spirit, how will he respond when the war arrives on our doorstep?','',26124),
(128810,'enUS','My tendrils will take you!','',26124),
(128811,'enUS','These ancient grounds are not for you!','',26124),
(128812,'enUS','You disturb nature\'s perfection!','',26124),
(128813,'enUS','Fodder for the compost heap!','',26124),
(128814,'enUS','Food for the worms!','',26124),
(128815,'enUS','They did not show the proper respect to nature.','',26124),
(128816,'enUS','Mortals seldom appreciate true beauty.','',26124),
(128817,'enUS','Now I... shall feed... the soil...','',26124),
(128818,'enUS','My end... was written... in the rings...','',26124),
(128819,'enUS','Thank you, my friend. I know what I must do to learn the weight of my father\'s crown.','',26124),
(128820,'enUS','Little fools wanna outsmart the Legion? Think again!','',26124),
(128821,'enUS','Gonna run you dummies over!','',26124),
(128822,'enUS','I must go to the Broken Shore and see for myself the sacrifice he made.','',26124),
(128823,'enUS','I\'LL STOMP YOU!','',26124),
(128824,'enUS','Stand still, wimps!','',26124),
(128825,'enUS','C\'mere and fight!','',26124),
(128826,'enUS','Come and get it!','',26124),
(128827,'enUS','Books are for losers!','',26124),
(128828,'enUS','Dead doofus!','',26124),
(128829,'enUS','Learned your lesson?','',26124),
(128830,'enUS','HA! Who\'s the smart one now?','',26124),
(128831,'enUS','Don\'t need books when I got fists!','',26124),
(128832,'enUS','Didn\'t... think this... through...','',26124),
(128833,'enUS','Shoulda... stayed in... school...','',26124),
(128834,'enUS','I shall find safety to recover. You must find out who is behind this and take them out!','',26124),
(128835,'enUS','','You heard Goldrinn! We have to find out who\'s leading these attacks now! No time to lose!',26124),
(128836,'enUS','Focus your attacks. We must not allow the connection to continue!','Focus your attacks. We must not allow the connection to continue!',26124),
(128837,'enUS','Don\'t stop until the connection is severed!','Don\'t stop until the connection is severed!',26124),
(128838,'enUS','The energy coming off this thing is incredible.','The energy coming off this thing is incredible.',26124),
(128839,'enUS','We\'ve got to hold the skies a little longer. We cannot afford to fail now.','We\'ve got to hold the skies a little longer. We cannot afford to fail now.',26124),
(128840,'enUS','If the tether remains intact much longer Azsuna will be lost!','If the tether remains intact much longer Azsuna will be lost!',26124),
(128841,'enUS','Keep the skies clear or the conduit will never fall!','Keep the skies clear or the conduit will never fall!',26124),
(128842,'enUS','Restrain the beast, and I will summon them to us...','',26124),
(128843,'enUS','The Aegis of Aggramar has been depleted!','',26124),
(128845,'enUS','Come with me to the Summoning Platform where the ritual has been prepared.','',26124),
(128854,'enUS','','I got everything I needed from this fiend before you got here. I know where their commander is!',26124),
(128857,'enUS','Look upon the true face of death, and know that your end comes soon!','',26124),
(128858,'enUS','','Come my children and feed!',26124),
(128859,'enUS','','Feeding time!',26124),
(128860,'enUS','The pain of flesh is fleeting. True torment lasts forever.','',26124),
(128862,'enUS','Your courage will fail.','',26124),
(128866,'enUS','Soon the heart of your world will beat no more!','',26124),
(128867,'enUS','','That commander\'s going to taste my blade!',26124),
(128871,'enUS','Mortal! I have been sent by the great Neptulon to bring ruin and judgment upon these fel infused fools that would invade our world.$b$bJoin me in battle, and together we shall quench the flames of their evil.','',26124),
(128872,'enUS','I will not let that happen.','I will not let that happen.',26124),
(128874,'enUS','Thank you, Archdruid. I feared the worst.','Thank you, Archdruid. I feared the worst.',26124),
(128875,'enUS','The commander must be stopped. I believe in you!','The commander must be stopped. I believe in you!',26124),
(128876,'enUS','I will return to the Dreamgrove. Thank you!','I will return to the Dreamgrove. Thank you!',26124),
(128877,'enUS','','You don\'t... understand...',26124),
(128878,'enUS','Thank you, stranger!','Thank you, stranger!',26124),
(128879,'enUS','I feel so weak; the webs were draining away my very essence.','I feel so weak; the webs were draining away my very essence.',26124),
(128880,'enUS','Thank you, hero! I thought my end had come!','Thank you, hero! I thought my end had come!',26124),
(128881,'enUS','I\'m never going to leave Nar\'thalas again!','I\'m never going to leave Nar\'thalas again!',26124),
(128882,'enUS','You have my thanks!','You have my thanks!',26124),
(128883,'enUS','I... live? Thank you friend! Thank you so much!','I... live? Thank you friend! Thank you so much!',26124),
(128884,'enUS','','I\'ll meet you back in the Dreamgrove, Archdruid. Thanks for bringing me along!',26124),
(128885,'enUS','A valiant battle earlier, washing away the fires of evil and drowning the aspirations of the fel.$b$bYou did well for one who is so painfully dry.','',26124),
(128886,'enUS','Archmage,the felbound manasabers in the Weeping Terrace must be freed! The abjurists holding them are quite powerful. A well-timed Spell Steal may come in handy!','',26124),
(128887,'enUS','Hero! The naga and their skrog lackeys have harassed my warriors long enough. Teach them the folly of their wicked ways!','',26124),
(128888,'enUS','Glorious carnage indeed! You put those watery pests in their place.','',26124),
(128889,'enUS','I will slaughter every last one of your precious Ancients!','',26124),
(128890,'enUS','No! The Legion... will destroy... your world...','',26124),
(128891,'enUS','Neptulon has sent one of his greatest champions to aid our cause, and has asked for you by name. I look forward to seeing what damage the two of you can unleash.','',26124),
(128892,'enUS','Thank you, champion. Things were really beginning to heat up!','',26124),
(128893,'enUS','Drown in your failure!','',26124),
(128894,'enUS','By Water be purged!','',26124),
(128895,'enUS','Your fire is quenched!','',26124),
(128896,'enUS','Drown on this!','',26124),
(128897,'enUS','Begone, fel thing!','',26124),
(128898,'enUS','You cannot stand against the flood!','',26124),
(128899,'enUS','Fall before the tide of justice!','',26124),
(128900,'enUS','My waters run green with taint. Perhaps a good filtering is in order.','',26124),
(128901,'enUS','Come, little Champion, and let us drown our enemies in the tides of justice!','',26124),
(128902,'enUS','Domatrax rips open additional Fel Portals!','Domatrax rips open additional Fel Portals!',26124),
(128903,'enUS','Intruder! How did you find my lair!','',26124),
(128904,'enUS','It\'s no matter, in a moment I will be gone along with all of my treasure!','',26124),
(128905,'enUS','','Hey, jerk! I think this shard you brought me is broken. I tried hitting it with a rock and everything!',26124),
(128906,'enUS','','Oh, hey. Who are you?',26124),
(128907,'enUS','I\'m Iks\'reeged, Treasure Master! Wait... What is that you are holding?','',26124),
(128908,'enUS','','The Ancient Shard of Binding begins to radiate with tremendous power.',26124),
(128909,'enUS','NO! How dare you! I will not bend knee to such a fatuous creature!','',26124),
(128910,'enUS','Arrrg! What have you done?! Shackled to this realm forever? I cannot imagine a worse fate!','',26124),
(128911,'enUS','','Whoops! So, I guess that\'s what this thing does! Oh well.',26124),
(128912,'enUS','','Hey! Look at all this treasure!',26124),
(128913,'enUS','Champion, there is a collection of energy near our camp that seems to be specifically attuned to you. Would you investigate this disturbance?','',26124),
(128914,'enUS','Fascinating! Despite the frequency with which we summon forth elementals and demons, it never occurred to me that the door might swing both ways.','',26124),
(128915,'enUS','Ah! My Summon Champion spell worked. Minion! We must do battle with another of my former masters up ahead. Get to it!','',26124),
(128916,'enUS','Minion! Eat this.','',26124),
(128917,'enUS','I speak fer Azeroth!','',26124),
(128918,'enUS','Well met!','',26124),
(128919,'enUS','These stones have tales ta tell.','',26124),
(128920,'enUS','Fight fer our world!','',26124),
(128921,'enUS','Fer Azeroth!','',26124),
(128922,'enUS','Back ta work!','',26124),
(128923,'enUS','Enough o\' yer nonsense!','',26124),
(128924,'enUS','Me magma\'s fixin\' ta boil!','',26124),
(128925,'enUS','Ye\'re messin\' with the voice o\' the planet! THE PLANET!','',26124),
(128926,'enUS','Now ye done it! IT\'S CLOBBERIN\' TIME!','',26124),
(128927,'enUS','I must know. Follow me to the keep.','',26124),
(128928,'enUS','No luck, eh? King Greymane won\'t be happy, but I\'m sure you did your best.','',26124),
(128929,'enUS','The time for prayer is over. I must know the hearts and minds of my people.','',26124),
(128930,'enUS','I will accompany you to Lion\'s Rest.','I will accompany you to Lion\'s Rest.',26124),
(128931,'enUS','Skyhold.','Skyhold.',26124),
(128932,'enUS','To the Battlelord!','',26124),
(128935,'enUS','So... tired...','',26124),
(128936,'enUS','For my masters! For the Legion!','For my masters! For the Legion!',26124),
(128937,'enUS','You cannot escape the Legion!','You cannot escape the Legion!',26124),
(128938,'enUS','There\'s no point... we\'re doomed! We\'re all doomed!','There\'s no point... we\'re doomed! We\'re all doomed!',26124),
(128939,'enUS','Don\'t you see? The Legion has already won!','Don\'t you see? The Legion has already won!',26124),
(128940,'enUS','For the Legion!','For the Legion!',26124),
(128941,'enUS','Death to all who oppose the Legion!','Death to all who oppose the Legion!',26124),
(128942,'enUS','Erdris? You have been corrupted as well? It saddens me that your eternal slumber has been disturbed.','',26124),
(128943,'enUS','The Helm of Domination shows me many things, Deathlord.','',26124),
(128944,'enUS','I have seen a vision... thousands of undead marching to the far reaches of Northrend in search of a great power.','',26124),
(128945,'enUS','Yet when reach out through the cold tendrils of endless ice, I sense nothing there.','',26124),
(128946,'enUS','Go now to the far north of Icecrown, and I will show you what I have seen.','',26124),
(128949,'enUS','It was here that I saw the undead swarming across an icy shelf, seeking a prize coveted by Arthas.','',26124),
(128950,'enUS','Look ahead... Do you see it?','',26124),
(128951,'enUS','The bones of a dragon most ancient, and powerful beyond reckoning.','',26124),
(128952,'enUS','Yet all that remains here is the sea, and I sense no trace of undead.','',26124),
(128953,'enUS','Find a member of the bronze flight, the tenders of history. Do not be merciful.','',26124),
(128954,'enUS','The reds know something. They hide their secrets in the Ruby Sanctum beneath Wyrmrest.','',26124),
(128955,'enUS','He has alerted his allies already. They will be expecting you.','',26124),
(128956,'enUS','A record of their history must lurk somewhere in this sanctum. Spare who you will, or slay them all... the choice is yours.','',26124),
(128957,'enUS','You are empty inside, just like me.','',26124),
(128958,'enUS','Fly now into the north. Find this glacier... and your destiny.','',26124),
(128960,'enUS','Continue north, Deathlord, into the blizzard.','',26124),
(128961,'enUS','And hold tight to your reins.','',26124),
(128963,'enUS','It is here... I can feel it. Your supplies have likely frozen. I sense feral undead buried in the ice. It seems the time has come to test your will.','',26124),
(128964,'enUS','Of course, should you fail to survive, know that I shall claim Acherus for my own. Arthas may have sought revenge on the citadel, but I have... other plans.','',26124),
(128965,'enUS','You are getting close. I can sense the spark of life ahead of you. You will bring decay to this lost place.','',26124),
(128966,'enUS','I sense many feral undead nearby. They have been feeding on its life energy. Take it from them. Slay them all.','',26124),
(128967,'enUS','You have stolen the dragon\'s life energy. Now, bend it to your desires. Pervert it with your darkness.','',26124),
(128968,'enUS','I can feel the unholy energy surging within you. Raise the dragon and claim it as your own.','',26124),
(128969,'enUS','The light of Dalaran burns ever so brightly. But should the darkness gather, our allies will be ready. I\'m sure of it.','The light of Dalaran burns ever so brightly. But should the darkness gather, our allies will be ready. I\'m sure of it.',26124),
(128970,'enUS','You\'re right. We do not know what lies ahead. But if the darkness comes, we will face it together.','You\'re right. We do not know what lies ahead. But if the darkness comes, we will face it together.',26124),
(128971,'enUS','Do not let fear of an uncertain future overwhelm you. We do not know what lies ahead.','Do not let fear of an uncertain future overwhelm you. We do not know what lies ahead.',26124),
(128972,'enUS','You mustn\'t let the idle mutterings upset you. It\'s times like these we must remain strong.','You mustn\'t let the idle mutterings upset you. It\'s times like these we must remain strong.',26124),
(128973,'enUS','I\'m not sure what he was doing, but his behavior seemed a bit--oh. Ignore my musings. It\'s fine. Everything\'s fine!','I\'m not sure what he was doing, but his behavior seemed a bit--oh. Ignore my musings. It\'s fine. Everything\'s fine!',26124),
(128974,'enUS','These Rooksguard are newly risen, and may not have fallen fully into corruption. Perhaps they can yet be saved!','',26124),
(128975,'enUS','As I told you, I don\'t know what they were talking about. But they did look... concerned.','As I told you, I don\'t know what they were talking about. But they did look... concerned.',26124),
(128976,'enUS','...yes, but some aren\'t sure what to expect. There is something to be said for leading by example, especially in a time like this.','...yes, but some aren\'t sure what to expect. There is something to be said for leading by example, especially in a time like this.',26124),
(128977,'enUS','Who knows. The first thing I saw when I looked up was that monstrosity lingering overhead.','Who knows. The first thing I saw when I looked up was that monstrosity lingering overhead.',26124),
(128978,'enUS','Ah... Grandmaster. Almai and Blanche are waiting for you down in the village. I must... rest... a bit.','',26124),
(128979,'enUS','NO! You need to listen to me. I\'m telling you--we need to get out of here!','NO! You need to listen to me. I\'m telling you--we need to get out of here!',26124),
(128980,'enUS','What if this is it?','What if this is it?',26124),
(128981,'enUS','You have fought well, Farseer $p. I see Thunderaan chooses his champions wisely. I will bow to his power.','',26124),
(128982,'enUS','','Please hurry, Grandmaster. The order\'s survival depends on your success!',26124),
(128983,'enUS','The moment we lose faith in the Council is the moment our threads unravel. We must band together, not harbor our fears in events that have not yet occurred.','The moment we lose faith in the Council is the moment our threads unravel. We must band together, not harbor our fears in events that have not yet occurred.',26124),
(128984,'enUS','I am sure the Council will reveal more information as it becomes available. In the meantime, remember that times like these have a way of revealing an individual\'s true character.','I am sure the Council will reveal more information as it becomes available. In the meantime, remember that times like these have a way of revealing an individual\'s true character.',26124),
(128985,'enUS','You look a bit pale. Are you feeling well?','',26124),
(128986,'enUS','Looking tired, have another hard day out in the fields?','',26124),
(128987,'enUS','Lot of people acting strange lately... I hope there isn\'t a sickness going around.','',26124),
(128988,'enUS','I... I couldn\'t stop myself.','I... I couldn\'t stop myself.',26124),
(128989,'enUS','They got into my head... into my mind!','They got into my head... into my mind!',26124),
(128990,'enUS','I tried to stop but couldn\'t... it was like I was a puppet.','I tried to stop but couldn\'t... it was like I was a puppet.',26124),
(128991,'enUS','The water... don\'t let the others drink the water!','The water... don\'t let the others drink the water!',26124),
(128992,'enUS','What... what happened to me?','What... what happened to me?',26124),
(128993,'enUS','Where am I? Who are you?','Where am I? Who are you?',26124),
(128994,'enUS','I\'m hesitant to answer further questions about what\'s going on. I\'m starting to lack confidence in my responses.','I\'m hesitant to answer further questions about what\'s going on. I\'m starting to lack confidence in my responses.',26124),
(128995,'enUS','Welcome, $ct. Let\'s get this assault under way, shall we?','',26124),
(128996,'enUS','I wonder what it means.','I wonder what it means.',26124),
(128997,'enUS','We will divide our forces to hit them from all sides at once.','',26124),
(128998,'enUS','No. You don\'t think... That\'s not possible!','No. You don\'t think... That\'s not possible!',26124),
(128999,'enUS','Quickly, $ct, we need you on the front lines!','',26124),
(129000,'enUS','$n, our assault on the southern beach is being met with heavy resistance.','',26124),
(129001,'enUS','I need you spearheading our forces while I deal with these ships!','',26124),
(129002,'enUS','We must take the ruins on the western side of the island. From there we can funnel all of our forces toward the central ship above the soul engine.','',26124),
(129003,'enUS','The Legion will not win this day! We will show them what it means to stand together. For Azeroth!','',26124),
(129004,'enUS','We must take the beach before we can claim the ruins to the west.','',26124),
(129005,'enUS','Good! They thought they were ready for us, but they\'ve never seen the forces of Azeroth work with such unity!','',26124),
(129006,'enUS','Head up the hill to the west with the other forces. An eredar and his underlings guard the point. You know what to do.','',26124),
(129007,'enUS','Ah! That\'s one ship down.','',26124),
(129008,'enUS','Did you see them? The ones wandering, carrying on conversations with themselves?','Did you see them? The ones wandering, carrying on conversations with themselves?',26124),
(129009,'enUS','Archers! Rain hell upon them!','',26124),
(129010,'enUS','It seems you were doomed to fail, Lord Kalgorath.','',26124),
(129011,'enUS','$n, the forces of Dread Commander Arganoth lie to the northeast. We must close the portals before our allies are overrun.','',26124),
(129012,'enUS','Their command ship remains. We must destroy it before Dalaran\'s defenses fail! The Council of the Black Harvest has set up a gate for us. You may do the honors, $n.','',26124),
(129013,'enUS','Get ready, $ct. I\'m pulling you out and detonating the bombs!','',26124),
(129014,'enUS','Ah, there you are, $ct. I was worried I might have activated the bombs a tad prematurely.','',26124),
(129015,'enUS','But how did it get there? It couldn\'t just appear out of nowhere.','But how did it get there? It couldn\'t just appear out of nowhere.',26124),
(129016,'enUS','Right. We have our orders. Good luck.','',26124),
(129018,'enUS','The warlocks took your world from you, nathrezim! I would not be so arrogant if I were you.','',26124),
(129019,'enUS','We have won this day, but a grave threat still looms before us. The Legion\'s master has yet to play his hand.','',26124),
(129020,'enUS','','The Wardens are with you, $ct.',26124),
(129021,'enUS','','More portals?! Where the hell is our backup?',26124),
(129022,'enUS','','Illidan, how courteous of you to finally arrive! Wardens, see to the real work while Illidan\'s demon hunters caper about with their bats.',26124),
(129023,'enUS','','You are too quick to trust Illidan, Prophet. I will ensure he fulfills his duty.',26124),
(129024,'enUS','Here, these will help. Plant them around the ship. I will activate them from here when ready.','',26124),
(129025,'enUS','You think a few mortals with gaudy weapons can stop us?','',26124),
(129026,'enUS','You are doomed to fail!','',26124),
(129027,'enUS','I... I can\'t stop it. I\'ve tried to keep myself busy, but my mind wanders back to this feeling... this... I don\'t know what to call it anymore.','I... I can\'t stop it. I\'ve tried to keep myself busy, but my mind wanders back to this feeling... this... I don\'t know what to call it anymore.',26124),
(129028,'enUS','As is the Light.','',26124),
(129029,'enUS','Enough bickering! Stay focused!','',26124),
(129030,'enUS','Perhaps. But not this day, demon!','',26124),
(129031,'enUS','Mephistroth!','',26124),
(129032,'enUS','Illidan, convey the Aegis of Aggramar to the cathedral. I will descend into the tomb with Khadgar and hunt the monster down. Kil\'jaeden\'s reign of destruction will soon be ended!','',26124),
(129033,'enUS','The sky grows closer every day. Is it ever going to end?','The sky grows closer every day. Is it ever going to end?',26124),
(129034,'enUS','Yes, come forth. I could use some entertainment!','',26124),
(129035,'enUS','Silence!','',26124),
(129036,'enUS','Another foolish mortal wishes to face me? So be it!','',26124),
(129037,'enUS','You destroy a few ships and claim a victory. It will be your last, I assure you. Savor this moment, for our next meeting will spell your doom!','',26124),
(129038,'enUS','How long until our world crumbles?','How long until our world crumbles?',26124),
(129039,'enUS','You can\'t possibly say you aren\'t feeling it. Look around us. This world\'s beginning to doubt itself.','You can\'t possibly say you aren\'t feeling it. Look around us. This world\'s beginning to doubt itself.',26124),
(129040,'enUS','Have you seen the first aid shop? The line is out the door.','Have you seen the first aid shop? The line is out the door.',26124),
(129041,'enUS','No matter what I do, I can\'t seem to stop looking up.','No matter what I do, I can\'t seem to stop looking up.',26124),
(129042,'enUS','We will find a way to make sense of it all. And should the time come for action, I am sure our allies will be prepared.','We will find a way to make sense of it all. And should the time come for action, I am sure our allies will be prepared.',26124),
(129043,'enUS','Fear has a way of playing tricks on the mind. You should get some rest, Jenny.','',26124),
(129044,'enUS','','Will he? How exactly will he keep an endless army of demons from invading and killing everyone?',26124),
(129045,'enUS','','This will only take a moment!',26124),
(129046,'enUS','<Lethecus has a far-away look in his eyes.>\n\nOh, yes? I didn\'t see you there.\n\n<Lethecus yawns.>','',26124),
(129047,'enUS','','Here goes nothing. Brace yourselves!',26124),
(129048,'enUS','Tell me all you know of a glacier to the north where a powerful dragon fell.','Tell me all you know of a glacier to the north where a powerful dragon fell.',26124),
(129049,'enUS','','Behold our Fel might!',26124),
(129050,'enUS','No, not that I can recall. I am terribly sorry, I am still in mourning over our dear Ysera\'s passing, I can think of little else right now. Did you ask the bronze flight? They have quite excellent memories.','',26124),
(129051,'enUS','Oh, hello! Thank you for visiting again.\n\nOr is this your first time?\n\nWhat day is it?','',26124),
(129052,'enUS','<Trizormu\'s eyes narrow.>\n\nWhat would a death-bringer like yourself want with that information, exactly?','',26124),
(129053,'enUS','Ack! Alright! There used to be... glaciers... large ones... to the north of Icecrown... they floated away years ago... I don\'t know any more, I swear! Speak to... Tariol!','',26124),
(129054,'enUS','Ringing the Large Northern Glacier were, in order of formation, the Medium-Sized Northeastern Glacier, the Small Southern Glacier, the Southwestern Tiny Glacier, the South-Southwestern Tiny Glacier, the South-Southeastern Tiny Glacier, the Most Southern Tiny Glacier, the First and Second Northern Tiny Glaciers That Keep Changing Positions...','',26124),
(129055,'enUS','','The Slayer remains unconscious. I fear what will happen if--',26124),
(129056,'enUS','','That was a nasty knock on the head. Still, our Slayer is a strong one, my dear. Look!',26124),
(129057,'enUS','...and while we\'re there, naturally we can\'t forget the Cluster of Five: the Northern, Southern, Eastern, and Western Small Ice Chunks That Have Been Technically Designated As Not Glaciers, which is really a funny story...','',26124),
(129058,'enUS','','What in blazes happened to my chickens?',26124),
(129059,'enUS','The demons attack my troops before they can recover!','',26124),
(129060,'enUS','Fear not, my lord. I can raise more.','',26124),
(129061,'enUS','That demon must be dealt with, $n! Then we can focus on Erdris.','',26124),
(129062,'enUS','Something\'s up with my rabbits! Poor little guys... We gotta do something!','',26124),
(129063,'enUS','I suggest tossing out those rags and changing into something a bit more stylish. You might as well look good as the universe ends.','',26124),
(129064,'enUS','Return to the rest you earned long ago, brother!','',26124),
(129065,'enUS','Shrug off this corruption, my friend!','',26124),
(129066,'enUS','Ah, $n. Just the $c I was looking for. Like my new attire? Eh--who am I kidding? Won\'t matter soon anyway.','',26124),
(129067,'enUS','Only you can end this torment, brother. Fight it!','',26124),
(129068,'enUS','And what brings a $c like you around, $n? Fancy some sleek attire for the end of the world as we know it?','',26124),
(129069,'enUS','I... I am free. Thank you.','',26124),
(129070,'enUS','Price is no object when it comes to going out in style. I\'m flat broke... not that it\'ll matter soon.','',26124),
(129071,'enUS','I will not be a tool of the Legion.','',26124),
(129072,'enUS','I don\'t know about you, but I for one refuse to meet my maker in a common mage\'s garb.','',26124),
(129073,'enUS','The end is upon us, $n! At least that\'s what they\'re saying. Might as well look the part.','',26124),
(129074,'enUS','Mind your business, friend.','',26124),
(129075,'enUS','If you don\'t look up then nothing\'s wrong. Carry on!','',26124),
(129076,'enUS','The Burning Legion continues to try to recreate the masterpiece that was the Scourge. \n\nThey turn to their Nathrazim who make puppets of bones. \n\nThey turn to these fallen Spiritwalkers, who simply meddle at these magics.\n\nI am here, on behalf of the Ebon Blade, to observe and judge. And to lend assistance to you, hero, should you require it.','',26124),
(129077,'enUS','Welcome, traveler! How are things out there?','',26124),
(129078,'enUS','No, Kerta. I do not think we have anything to worry about. Now focus. We must not keep our guest waiting.','',26124),
(129079,'enUS','Welcome. I fear our supplies have run low. We have been filling orders without much of a break since... well, you know.','',26124),
(129080,'enUS','Come in! Kerta and I were just discussing recent events. I would be interested in hearing your take.','',26124),
(129081,'enUS','I am certain the Council is well prepared, Kerta. Now look alive. We have another customer.','',26124),
(129082,'enUS','What kind of assistance?','What kind of assistance?',26124),
(129083,'enUS','','My apologies if I seem a bit on edge. Welcome to the shop.',26124),
(129084,'enUS','For Northrend, you are looking for Leesha Tannerby, the Dockmaster for the Kraken. It sets sail for Valiance Keep in Borean Tundra from the northern dock in Stormwind Harbor.','For Northrend, you are looking for Leesha Tannerby, the Dockmaster for the Kraken. It sets sail for Valiance Keep in Borean Tundra from the northern dock in Stormwind Harbor.',26124),
(129085,'enUS','For the Exodar or Teldrassil located in Kalimdor, seek out the Nayura. She is the Dockmaster for The Bravery, setting sail from the southernmost dock in Stormwind Harbor.','For the Exodar or Teldrassil located in Kalimdor, seek out the Nayura. She is the Dockmaster for The Bravery, setting sail from the southernmost dock in Stormwind Harbor.',26124),
(129086,'enUS','If this is a representation of the type of necromancy that the Burning Legion relies on then we are in better shape than I ever imagined.','',26124),
(129087,'enUS','It is so nice to be away from Acherus doing some good, old fashioned field research again with fresh corpses and bone piles.','',26124),
(129088,'enUS','The mages have opened a portal just inside the Mage Tower to assist players getting to the Blasted Lands and on to Draenor. You will see the mage Sparkbright standing by next to it.','The mages have opened a portal just inside the Mage Tower to assist players getting to the Blasted Lands and on to Draenor. You will see the mage Sparkbright standing by next to it.',26124),
(129089,'enUS','There is a portal that leads to Hellfire Peninsula in Outland. It is located within the Wizard\'s Sanctum located at the top of the Mage Tower.','There is a portal that leads to Hellfire Peninsula in Outland. It is located within the Wizard\'s Sanctum located at the top of the Mage Tower.',26124),
(129090,'enUS','Say what you will about Arthas, but the former Lich King did have a cold efficiency when it came to dealing with the Legion.','',26124),
(129091,'enUS','You are in luck Dalaran is currently located above the Broken Isles and the Kirin Tor have setup a portal located just inside Stormwind Keep.','You are in luck Dalaran is currently located above the Broken Isles and the Kirin Tor have setup a portal located just inside Stormwind Keep.',26124),
(129092,'enUS','Our new allies in Pandaria have allowed us to create a portal to Paw\'don Village in the Jade Forest. It is located on the western edge of the lake next to Stormwind Keep.','Our new allies in Pandaria have allowed us to create a portal to Paw\'don Village in the Jade Forest. It is located on the western edge of the lake next to Stormwind Keep.',26124),
(129094,'enUS','The Deeprun Tram is the fastest route to Ironforge. You will find it located in the Dwarven District.','The Deeprun Tram is the fastest route to Ironforge. You will find it located in the Dwarven District.',26124),
(129095,'enUS','Stormwind is the center of the Alliance and offers many forms of travel to the far reaches of Azeroth and beyond. \n\nWhere are you looking to travel?','Stormwind is the center of the Alliance and offers many forms of travel to the far reaches of Azeroth and beyond. \n\nWhere are you looking to travel?',26124),
(129096,'enUS','The stench of undeath follows you into this temple of life. Do not stay overlong.','',26124),
(129097,'enUS','Tell me all you know of a great dragon that fell on a glacier to the north of Icecrown.','Tell me all you know of a great dragon that fell on a glacier to the north of Icecrown.',26124),
(129098,'enUS','I have no idea what you are talking about. Now if you will excuse me, I have things to attend to. You may direct any additional questions to our steward.','',26124),
(129099,'enUS','You will never find what you seek, death-bringer. Now, you have worn out your welcome at this temple, begone!','',26124),
(129100,'enUS','Your actions stretch the limits of our alliance, death knight.','',26124),
(129102,'enUS','These supplies belong to the Legion!','',26124),
(129103,'enUS','The Legion will be your end...','',26124),
(129104,'enUS','Ironforge','Ironforge',26124),
(129105,'enUS','Paw\'don Village in Pandaria','Paw\'don Village in Pandaria',26124),
(129106,'enUS','Dalaran in the Broken Isles','Dalaran in the Broken Isles',26124),
(129107,'enUS','Hellfire Peninsula in Outland','Hellfire Peninsula in Outland',26124),
(129108,'enUS','Blasted Lands and the portal to Draenor','Blasted Lands and the portal to Draenor',26124),
(129109,'enUS','Teldrassil or the Exodar in Kalimdor','Teldrassil or the Exodar in Kalimdor',26124),
(129110,'enUS','Borean Tundra in Northrend','Borean Tundra in Northrend',26124),
(129111,'enUS','Areas opened up in the Cataclysm','Areas opened up in the Cataclysm',26124),
(129112,'enUS','|TInterface\\Icons\\ABILITY_WARLOCK_SHADOWFURYTGA.BLP:20|tOne of the runes |cFFFF0000|Hspell:237908|h[Detonates]|h|r!','|TInterface\\Icons\\ABILITY_WARLOCK_SHADOWFURYTGA.BLP:20|tOne of the runes |cFFFF0000|Hspell:237908|h[Detonates]|h|r!',26124),
(129113,'enUS','Heroes of Azeroth, your class orders have grown mighty throughout our campaign on the Broken Isles. Their strength, their courage, is needed now. The time has come to unite our forces and rid Azeroth of the Burning Legion.','',26124),
(129114,'enUS','Look, these portals are not going to hijack themselves. I need time to do this right or you will just end up in a Legion melting pot or the gut of a Pit Lord. \n\nDo you want to teleport into the gut of a Pit Lord? Oh sure, at first it seems like a clever, unexpected attack. But then you get digested in fel juices and wonder where your great plan went.\n\nLeave me to my work.','',26124),
(129115,'enUS','So far this warlock has proved to be quite useful in deciphering the magics of our enemies. \n\nHe also almost got both of us killed on several occasions but that is a danger I knew I would face when partnering with such a villain.\n\nFor all of his flaws, he has also saved my life several times. For good or ill, we will see this through to the end, together.','',26124),
(129117,'enUS','We will not be able to hold this line for long.','',26124),
(129118,'enUS','Already the vermin stir.','',26124),
(129120,'enUS','Every demon we slay here dies their final death. Do not hold back.','',26124),
(129121,'enUS','We won\'t be able to sustain another attack from one of those creatures. We must bolster our forces.','',26124),
(129122,'enUS','Survivors! We will hold this point, you must find them before the Legion does.','',26124),
(129123,'enUS','','|TInterface\\Icons\\inv_misc_horn_03:20|t%s |cFFFF0000|Hspell:237937|h[Empowers]|h|r $n!',26124),
(129124,'enUS','','|TInterface\\Icons\\inv_misc_horn_03:20|t%s |cFFFF0000|Hspell:237937|h[Empowers]|h|r herself and one of her allies!',26124),
(129125,'enUS','','|TInterface\\Icons\\inv_misc_horn_03:20|t%s |cFFFF0000|Hspell:237937|h[Empowers]|h|r all of her council!',26124),
(129130,'enUS','Remember... the one who hurries to conclusions may arrive first, but may not find the destination pleasant.','',26124),
(129131,'enUS','Do not let the behavior of others influence your ways. We must maintain our composure when faced with the unknown.','',26124),
(129132,'enUS','Do not let the behavior of others influence your own. We must maintain our composure when faced with the unknown.','',26124),
(129133,'enUS','The air speaks to us in many ways, $n. What do these times say to you?','',26124),
(129134,'enUS','The zeppelin to Thunder Bluff in central Kalimdor leaves from the western zeppelin tower atop the central plateau in Orgrimmar. Zeppelin master Zelli Hotnozzle will have more information for you there.','The zeppelin to Thunder Bluff in central Kalimdor leaves from the western zeppelin tower atop the central plateau in Orgrimmar. Zeppelin master Zelli Hotnozzle will have more information for you there.',26124),
(129135,'enUS','To get to The Undercity or Silvermoon City you should seek out Frezza on the eastern zeppelin tower atop the central plateau in Orgrimmar. He will have more information on when the zeppelin departs for Brill located in the Tirisfal Glades just north of The Undercity. There is a teleporter in entranceway to The Undercity that can take you to Silvermoon City.','To get to The Undercity or Silvermoon City you should seek out Frezza on the eastern zeppelin tower atop the central plateau in Orgrimmar. He will have more information on when the zeppelin departs for Brill located in the Tirisfal Glades just north of The Undercity. There is a teleporter in entranceway to The Undercity that can take you to Silvermoon City.',26124),
(129136,'enUS','Seek out Snurk Bucksquick on the western zeppelin tower atop the central plateau in Ogrimmar. She is the zeppelin master for Stranglethorn Vale and will let you know more info on when the zeppelin will depart for our outpost of Grom\'gol in the southern Eastern Kingdoms.','Seek out Snurk Bucksquick on the western zeppelin tower atop the central plateau in Ogrimmar. She is the zeppelin master for Stranglethorn Vale and will let you know more info on when the zeppelin will depart for our outpost of Grom\'gol in the southern Eastern Kingdoms.',26124),
(129137,'enUS','The mood on these streets darkens like the skies, yet hope can still bring light to us all.','',26124),
(129138,'enUS','For Borean Tundra in Norhtrend you will want to take the zeppelin The Mighty Wind. Seek out Greeb Ramrocket on western zeppelin tower for when it departs for Warsong Hold.','For Borean Tundra in Norhtrend you will want to take the zeppelin The Mighty Wind. Seek out Greeb Ramrocket on western zeppelin tower for when it departs for Warsong Hold.',26124),
(129139,'enUS','Stormwind has always been my home. I know its shops and streets as I do the back of my hand.','',26124),
(129140,'enUS','Yet even as I walk these familiar steps, I have never felt more lost.','',26124),
(129141,'enUS','','Over here, $n! Any news? I haven\'t heard much, but some folks around here are acting quite out of sorts.',26124),
(129142,'enUS','','Sorry to bother, $n, but have you any news? Guards run by every so often, but they offer little information.',26124),
(129143,'enUS','','Wait! Wait! Any updates, $n? Quite a few of us are anxiously awaiting some sort of news.',26124),
(129144,'enUS','There is a portal that leads to Hellfire Peninsula in Outland. It is located within the Cleft of Shadow, underneath Orgrimmar.','There is a portal that leads to Hellfire Peninsula in Outland. It is located within the Cleft of Shadow, underneath Orgrimmar.',26124),
(129145,'enUS','Stop right there! Oh, is that you, $n? Damned looters have been in and out of here all day! Take a look around, but be quick about it.','',26124),
(129146,'enUS','Our mages have opened a portal just inside the Cleft of Shadows to assist players getting to the Blasted Lands and on to Draenor.','Our mages have opened a portal just inside the Cleft of Shadows to assist players getting to the Blasted Lands and on to Draenor.',26124),
(129147,'enUS','Hands where I can see \'em! Gah! It\'s you again. I\'ve had to chase off so many miscreants lately, I don\'t know what to think anymore.','',26124),
(129148,'enUS','Freeze! Ahh! How many times is this gonna happen? First the guards are checkin\' around, now you... Well, the pickin\'s are slim, but have a look.','',26124),
(129149,'enUS','%s sheathes his weapon.','',26124),
(129150,'enUS','The Kirin Tor have setup a portal in the Cleft of Shadows to assist players in getting to Dalaran above the Broken Isles.','The Kirin Tor have setup a portal in the Cleft of Shadows to assist players in getting to Dalaran above the Broken Isles.',26124),
(129151,'enUS','Our allies in Pandaria have allowed us to create a portal to Honeydew Village in the Jade Forest. It is located in the middle of the Valley of Honor.','Our allies in Pandaria have allowed us to create a portal to Honeydew Village in the Jade Forest. It is located in the middle of the Valley of Honor.',26124),
(129152,'enUS','Undercity or Silvermoon City in the Eastern Kingdoms','Undercity or Silvermoon City in the Eastern Kingdoms',26124),
(129153,'enUS','Borean Tundra in Northrend','Borean Tundra in Northrend',26124),
(129154,'enUS','Thunder Bluff in Mulgore','Thunder Bluff in Mulgore',26124),
(129155,'enUS','Stranglethorn Vale in the Eastern Kingdoms','Stranglethorn Vale in the Eastern Kingdoms',26124),
(129156,'enUS','Honeydew Village in Pandaria','Honeydew Village in Pandaria',26124),
(129157,'enUS','Dalaran above the Broken Isles','Dalaran above the Broken Isles',26124),
(129158,'enUS','Areas opened up in the Cataclysm','Areas opened up in the Cataclysm',26124),
(129159,'enUS','Hellfire Peninsula in Outland','Hellfire Peninsula in Outland',26124),
(129160,'enUS','Blasted Lands and the Portal to Draenor','Blasted Lands and the Portal to Draenor',26124),
(129161,'enUS','Orgrimmar is the heart of the Horde, offering many forms of travel to the far reaches of Azeroth and beyond. \n\nWhere are you looking to travel?','Orgrimmar is the heart of the Horde, offering many forms of travel to the far reaches of Azeroth and beyond. \n\nWhere are you looking to travel?',26124),
(129162,'enUS','I\'ve fished this spot dry, but with the war and all, it\'s just too dangerous to leave the city.','',26124),
(129163,'enUS','I have not returned to Lion\'s Rest since my father\'s memorial was moved here from the keep.','',26124),
(129164,'enUS','The war has consumed all of my energy and attention. I have not had a moment to grieve.','',26124),
(129165,'enUS','','Stick to what you know, Icks. No point in speculating. Now look alive, we have a guest.',26124),
(129166,'enUS','','Our patrons are quite fond of our goods. I\'m confident that if the time comes, they will not hesitate to--oh! Welcome to the shop, $n.',26124),
(129167,'enUS','','How is it out there, $n? With so many customers, it\'s been a challenge to fill all the orders. I hope all is well.',26124),
(129168,'enUS','','Why do you like Nethershards so much?',26124),
(129169,'enUS','It\'s a secret long guarded by ancient secret keepers for secret reasons.','',26124),
(129170,'enUS','','You don\'t really know what they\'re for, do ya?',26124),
(129171,'enUS','Nope.','',26124),
(129172,'enUS','Meefi take you to cold Northrend. Her balloon leaves from left tower north of the Ruins of Lordaeron. You go to Vengeance Keep in Howling Fjord to fight Vrykul.','Meefi take you to cold Northrend. Her balloon leaves from left tower north of the Ruins of Lordaeron. You go to Vengeance Keep in Howling Fjord to fight Vrykul.',26124),
(129173,'enUS','Sparkly elves put in orby teleporter in ruins above Undercity. Touch it to take you to their home of Silvermoon City.','Sparkly elves put in orby teleporter in ruins above Undercity. Touch it to take you to their home of Silvermoon City.',26124),
(129174,'enUS','Magic men open portal to Hellfire Peninsula in Outland. Find it in their Mage Quarter.','Magic men open portal to Hellfire Peninsula in Outland. Find it in their Mage Quarter.',26124),
(129175,'enUS','Stranglethorn Vale in the Eastern Kingdoms','Stranglethorn Vale in the Eastern Kingdoms',26124),
(129176,'enUS','Hellfire Peninsula in Outland','Hellfire Peninsula in Outland',26124),
(129177,'enUS','Howling Fjord in Northrend','Howling Fjord in Northrend',26124),
(129178,'enUS','Orgrimmar in Kalimdor','Orgrimmar in Kalimdor',26124),
(129179,'enUS','Silvermoon City in the Eastern Kingdoms','Silvermoon City in the Eastern Kingdoms',26124),
(129180,'enUS','','Are demons ticklish?',26124),
(129181,'enUS','If you come near me, I\'ll bite your hand off.','',26124),
(129182,'enUS','','I\'ll take that as a yes.',26124),
(129183,'enUS','','It looks like fun floating all the time.',26124),
(129184,'enUS','Being eternally suspended in a prison set by a fatuous goblin? It\'s a blast...','',26124),
(129185,'enUS','','Hey, Iksy. When\'s your birthday? We should have a party!',26124),
(129186,'enUS','I was spawned into this wretched existence eons ago within the deepest realms of the nether.','',26124),
(129187,'enUS','','So... Next week?',26124),
(129188,'enUS','Sure. Next week.','',26124),
(129189,'enUS','Are you ever going to let me go?','',26124),
(129190,'enUS','','Sure! How do I do that?',26124),
(129191,'enUS','Really?! Just hand me the Shard of Binding and the spell will be broken!','',26124),
(129192,'enUS','','Oh that glowy thing? I lost it.',26124),
(129193,'enUS','I hate you...','',26124),
(129194,'enUS','Other Continents','Other Continents',26124),
(129195,'enUS','Fragile mortals. Bow before the might of the Burning Legion!','',26124),
(129196,'enUS','Your world crumbles around you, mortals. We cannot be stopped!','',26124),
(129197,'enUS','Hellfire Peninsula you say. That scorched wasteland in Outland. Well, our host of mages have created a portal to git ye there in the Hall of Mysteries located in the Mystic Ward.','Hellfire Peninsula you say. That scorched wasteland in Outland. Well, our host of mages have created a portal to git ye there in the Hall of Mysteries located in the Mystic Ward.',26124),
(129198,'enUS','Weak flesh and brittle bones... You are no match for the Legion!','',26124),
(129199,'enUS','Feel your hearts wrench as the grasp of Sargeras tightens around your world!','',26124),
(129200,'enUS','You cannot escape! Our reach is endless!','',26124),
(129201,'enUS','The downfall of your world has begun!','',26124),
(129202,'enUS','Oh, Howling Fjord in Northred. You be in fer a bit of a ride. Seek out Gryth Thurden the Gryphon Master to secure a flight to Menethil Harbor. The Northspear sets sail from there for Valgarde.','Oh, Howling Fjord in Northred. You be in fer a bit of a ride. Seek out Gryth Thurden the Gryphon Master to secure a flight to Menethil Harbor. The Northspear sets sail from there for Valgarde.',26124),
(129203,'enUS','','I suppose I should ensure the Fel Hammer is being properly repaired. See you there, Sslayer.',26124),
(129204,'enUS','Time for revenge.','Time for revenge.',26124),
(129205,'enUS','You have my thanks, and my mace.','You have my thanks, and my mace.',26124),
(129206,'enUS','You came with Magatha? I knew she would free us.','You came with Magatha? I knew she would free us.',26124),
(129207,'enUS','I\'m ready to fight.','I\'m ready to fight.',26124),
(129208,'enUS','Ironforge is not the port town of Stormwind but we be offer\'n many a route to other continents.\n\nWhere ye be looking to travel?','Ironforge is not the port town of Stormwind but we be offer\'n many a route to other continents.\n\nWhere ye be looking to travel?',26124),
(129209,'enUS','Hellfire Peninsula in Outland','Hellfire Peninsula in Outland',26124),
(129210,'enUS','Howling Fjord in Northrend','Howling Fjord in Northrend',26124),
(129211,'enUS','Stormwind and other Alliance Capitals','Stormwind and other Alliance Capitals',26124),
(129212,'enUS','We must keep our voices down and act natural, lest we be heard speaking together...','',26124),
(129213,'enUS','It seems Genn and Velen are speaking about me, but I can\'t quite make out the words...','',26124),
(129214,'enUS','','With the Slayer to lead us, the Legion WILL fall! Let us take this moment to celebrate our victory!',26124),
(129215,'enUS','','Now, sharpen your blades for the battles to come! The Illidari will prevail!',26124),
(129216,'enUS','','My shackles are in place, hero! Lure a demon into the trap to banish the fiend!',26124),
(129217,'enUS','Living on an island we rely on the sea and our magical prowess for getting around.\n\nWhere are you looking to travel?','Living on an island we rely on the sea and our magical prowess for getting around.\n\nWhere are you looking to travel?',26124),
(129218,'enUS','To get to Stormwind you must first take the portal to Rut\'theran Village located in the center of the city. Once at the base of Teldrassil, head to the southern dock to catch your ship.','To get to Stormwind you must first take the portal to Rut\'theran Village located in the center of the city. Once at the base of Teldrassil, head to the southern dock to catch your ship.',26124),
(129219,'enUS','The Stormwind ship leaves from the southern dock just over there.','The Stormwind ship leaves from the southern dock just over there.',26124),
(129220,'enUS','The Exodar','The Exodar',26124),
(129221,'enUS','There ship for the Exodar departs from the western dock.','There ship for the Exodar departs from the western dock.',26124),
(129222,'enUS','The Exodar, the ship and home of the Draenei. You will find a portal to the Exodar in the Temple of the Moon.','The Exodar, the ship and home of the Draenei. You will find a portal to the Exodar in the Temple of the Moon.',26124),
(129223,'enUS','To get to the barren land of Hellfire Peninsula in Outlands you can take a portal located in the Temple of the Moon.','To get to the barren land of Hellfire Peninsula in Outlands you can take a portal located in the Temple of the Moon.',26124),
(129224,'enUS','Other Continents','Other Continents',26124),
(129225,'enUS','Stormwind City in the Eastern Kingdoms','Stormwind City in the Eastern Kingdoms',26124),
(129226,'enUS','Hellfire Peninsula in Outland','Hellfire Peninsula in Outland',26124),
(129227,'enUS','The Command Center has been built! You can now gain access to things.','The Command Center has been built! You can now gain access to things.',26124),
(129228,'enUS','The Command Center has been attacked!  We cant benefit from its glory any more!','The Command Center has been attacked!  We cant benefit from its glory any more!',26124),
(129229,'enUS','The Command Center is ready for construction. Come donate your supplies.','The Command Center is ready for construction. Come donate your supplies.',26124),
(129230,'enUS','The Nether Disruptor has been built! You can now gain access to things.','The Nether Disruptor has been built! You can now gain access to things.',26124),
(129231,'enUS','The Nether Disruptor has been attacked!  We cant benefit from its glory any more!','The Nether Disruptor has been attacked!  We cant benefit from its glory any more!',26124),
(129232,'enUS','The Nether Disruptor is ready for construction. Come donate your supplies.','The Nether Disruptor is ready for construction. Come donate your supplies.',26124),
(129233,'enUS','Darnassus has a portal to Hellfire Peninsula located in the Temple of the Moon. Follow my directions to the portal up to Darnassus proper. Once there ask another sentinel if you need directions to the Temple.','Darnassus has a portal to Hellfire Peninsula located in the Temple of the Moon. Follow my directions to the portal up to Darnassus proper. Once there ask another sentinel if you need directions to the Temple.',26124),
(129234,'enUS','A portal can be found in the cave beneath Sprit Rise that will take you to the wasteland of Hellfire Peninsula in Outland.','A portal can be found in the cave beneath Sprit Rise that will take you to the wasteland of Hellfire Peninsula in Outland.',26124),
(129235,'enUS','Other Continents','Other Continents',26124),
(129236,'enUS','Located here in Mulgore we do not have many options for travel but I will help you as best I can. \n\nWhere are you looking to travel?','Located here in Mulgore we do not have many options for travel but I will help you as best I can. \n\nWhere are you looking to travel?',26124),
(129237,'enUS','Hellfire Peninsula in Outland','Hellfire Peninsula in Outland',26124),
(129238,'enUS','Orgrimmar or the Eastern Kingdoms','Orgrimmar or the Eastern Kingdoms',26124),
(129239,'enUS','','The Fel Hammer\'s power reserves run low, Slayer. The fel energy around the Tomb can replenish our power cores and you should be able to ride those geysers up there.',26124),
(129240,'enUS','','I will add these to our reserves. Thanks again, Slayer!',26124),
(129241,'enUS','','Huh? Why would anything be wrong? Move along!',26124),
(129242,'enUS','Greetings, $n.','',26124),
(129243,'enUS','','Come in, $n! Leave your worries at the door. The guards have assured us all is well.',26124),
(129244,'enUS','Nothing distracts a worried mind like a bit of toying around. Feel free to browse the shop!','',26124),
(129245,'enUS','Welcome, $n! We have one rule: keep your attitude positive! Don\'t let the all the commotion outside distract you.','',26124),
(129246,'enUS','I know these times can be stressful, but don\'t be afraid to let your mind wander to a place of mystery and excitement!','',26124),
(129247,'enUS','','The skies grow dark, $n. I hope you\'re ready.',26124),
(129248,'enUS','Quickly, bolster our ranks! We must push through!','',26124),
(129249,'enUS','Leave none standing! If we fail here, Azeroth burns.','',26124),
(129250,'enUS','The Legion has brought forth some new manner of fiend. Let us test whether it bleeds like all the rest.','',26124),
(129251,'enUS','The echo of the Guardian Aegwynn appears, just as she did in the cathedral.','',26124),
(129252,'enUS','','Are you prepared, $n? Some of your allies are not handling the situation so well.',26124),
(129253,'enUS','I have some news for you, $n, everything you\'ve learned about your profession to this point was child\'s play. There was no challenge to it, no fashion, no style, no grace! $b$bNow, I am not merely a Fashion Historian, young $r, I am also a philosopher and--I don\'t mind admitting--something of a style icon in these parts.','',26124),
(129254,'enUS','','Preparation is key, $n. My goods can be yours--for a price.',26124),
(129255,'enUS','','I sealed each level of this temple so that no invader could descend into its depths. I never anticipated that the Legion would find another way to breach its dark heart.',26124),
(129256,'enUS','','My protective wards now bar your way. Each seal can only be opened with one of the Pillars of Creation. Be warned: the demons will stop at nothing to prevent your advance.',26124),
(129257,'enUS','Do tell.','Do tell.',26124),
(129258,'enUS','','$n, over here! If you hear any news, please let me know at once. It takes time to pack up my goods.',26124),
(129259,'enUS','','Pastries, anyone? Nothing chases away doom and gloom like a fresh, tasty treat.',26124),
(129260,'enUS','','So many people coming and going, in and out of the shops, the bank... What\'s going on, exactly? I\'m starting to get nervous.',26124),
(129261,'enUS','','I can sense one of the Legion\'s masters working to reanimate the Avatar of Sargeras. Should Kil\'jaeden infuse that husk with the Dark Titan\'s power, I do not know whether any force on this world can stop it.',26124),
(129262,'enUS','Greetings, $n. News of your exploits on the Broken Isles has been reaching us back home in Stormwind. You bring great honor to the Alliance.','',26124),
(129263,'enUS','Then we have no time to lose.','',26124),
(129264,'enUS','Heroes, the paths are open. Use the Pillars of Creation to bypass Aegwynn\'s wards before the Legion claims the avatar.','',26124),
(129265,'enUS','Rest, friend, and recover your strength. It will be needed for the trials ahead.','',26124),
(129266,'enUS','An age has passed since I last walked these halls. I did what needed to be done, though at great cost.','',26124),
(129267,'enUS','Be on your guard. I doubt the spirits trapped here will be friendly... or forgiving.','',26124),
(129268,'enUS','Few understood my use of the naga to obtain the Eye of Sargeras, but it was a necessary tactic to secure the future of Azeroth. Let nothing stop you from doing what needs to be done!','',26124),
(129269,'enUS','What news of the skies, $n?','',26124),
(129270,'enUS','Any word on what\'s happening out there?','',26124),
(129271,'enUS','How are people coping out there?','',26124),
(129272,'enUS','','This hammer forged ancient wonders and shaped the earth itself. Today it shatters the bonds of fate that seek to crush us all.',26124),
(129273,'enUS','My patented Hammerbeard System of Style and Taste is a natural philosophy of flair. Impeccably researched, finely tuned, and well tested by yours truly, the HSST philosophy will be underlying apparatus of your education. $b$bThe dangers will be many, $n, but the rewards are beyond your current capacity to understand!','',26124),
(129274,'enUS','Uh huh.','Uh huh.',26124),
(129275,'enUS','','My echo has guided you as far as it can, champions. In life, I shouldered too many burdens alone, and such hubris cost me dearly. Only by standing together can you overcome the darkness ahead. Fare well.',26124),
(129276,'enUS','','From this stone flowed rivers and seas, the very lifeblood of Azeroth. Today it washes clean the darkness that scars our world.',26124),
(129277,'enUS','','These tears of perfect beauty embody the dream of what our world could be. Today they purify your hearts for the battle to come.',26124),
(129278,'enUS','Hey you! Ah, nevermind. We thought you were one of... you know... them.','',26124),
(129279,'enUS','Hey, hey. Come right in! Take a load off for a second, then get back out there and make sure we\'re still gonna be here tomorrow.','',26124),
(129280,'enUS','Your hands--delicate but powerful, hardened by battle yet skilled--are the only hands that you should trust to create garments or armor worthy of a hero. $b$bMany of the legends of yore that you read of as a child were somewhat lackadaisical with spell and sword but how they dressed--oh how they dressed! This is why we speak of them still. $b$bFew know this and now you are one of them!','',26124),
(129281,'enUS','You\'ve thought a lot about my hands.','You\'ve thought a lot about my hands.',26124),
(129282,'enUS','I don\'t know what he was goin\' on about, but it didn\'t sound good. And he ain\'t even the first to do that this week!','',26124),
(129283,'enUS','','Champion! Our vessel requires power cores charged with the energy of fel geysers. These tattered wings could prove useful should you find yourself aloft. Do not hesitate to deploy them!',26124),
(129284,'enUS','','The Pillars of Creation are in place. Return to the Cathedral and I will reveal the ancient secret this temple holds.',26124),
(129285,'enUS','Nevermind that! Think instead of the wasted potential of what you have made thus far! $b$bIt isn\'t all your fault, though you\'ve certainly concentrated on deeds and functionality over style. Under the HSST system, you will remedy these failings and perhaps, at last, have a chance at actually becoming a legend. $b$bThe road is hard and full of peril.','',26124),
(129286,'enUS','','Most useful! Did you enjoy your taste of what it is like for a demon hunter to glide through the air, hero?',26124),
(129287,'enUS','Are you wrapping this up soon?','Are you wrapping this up soon?',26124),
(129288,'enUS','','The elves built this temple upon a site of ancient power, a vault I believed would safeguard the husk of my fallen foe. But with his disciple\'s aid, the Dark Titan threatens to return to this world stronger than before!',26124),
(129289,'enUS','We will put a stop to Kil\'jaeden\'s plan, Aegwynn. This time we will not fail.','',26124),
(129290,'enUS','Bold words, Khadgar, but victory requires more than courage alone. The armies of your Alliance and Horde had courage... before facing slaughter on the Broken Shore. The Deceiver will turn your fears and doubts against you.','',26124),
(129291,'enUS','Archmage, the Felborne in the Weeping Terrace are holding manasabers in thrall. If we free them, these magical creatures may prove useful to us!','',26124),
(129292,'enUS','','Our spies have spotted demons infesting this cave, Shadowblade. We\'ve planted the appropriate supplies. You know what to do!',26124),
(129293,'enUS','','That explosion might\'ve been better than the last! Tethys would approve.',26124),
(129294,'enUS','I\'m starting to wish I\'d chosen another profession.','I\'m starting to wish I\'d chosen another profession.',26124),
(129295,'enUS','Kil\'jaeden hounded my people across the stars, but we are done running. He will pay for his atrocities against our world... and my son.','',26124),
(129296,'enUS','The impatience of youth. $b$bA craftsperson is only as good as his or her materials and the--let\'s face it--garbage you\'ve been using thus far is a core reason why you look more like an accountant from Stormwind than a potential legend. $b$bThink ahead--when they make paintings of you, the cut and weight of your clothing or armor will echo through history. Is that not what you\'ve always wished for?','',26124),
(129297,'enUS','You\'re right, Illidan. Kil\'jaeden and the Legion have defeated each of us in the past. But if we stand together, Azeroth can yet be saved. I know it!','',26124),
(129298,'enUS','','Our rogues could use a hand pulling off a mission in this cavern. These stun bombs should offer just the advantage they need!',26124),
(129299,'enUS','','Smashing job! Or would \"stunning\" be more appropriate?',26124),
(129300,'enUS','You lack appreciation for the gift I am giving you. The gift of a guiding philosophy is one that most go their whole lives without, $n. $b$b<sighs> Look, the point is that you will be judged throughout all time by what you wear and with my research and teaching, you will be able create legendary things that will set you apart from all others. Let us start.','',26124),
(129301,'enUS','','A trusted friend who lost her life defending this temple. Her rest has been defiled, and now she haunts these halls as a banshee. Release her from this torment!',26124),
(129302,'enUS','Let us hope this is worth it.','Let us hope this is worth it.',26124),
(129303,'enUS','','The peace earned so long ago has been returned to her. You have my thanks.',26124),
(129304,'enUS','','In life, Ryul was a formidable warrior. In death, he is an abomination that has been turned against us. Put him back in his grave.',26124),
(129305,'enUS','','Well fought! That should ensure Ryul remains in his grave.',26124),
(129306,'enUS','The presence of the Tidestone has drawn out the fanatical followers of Queen Azshara, including the elusive Warlord Darjah. An excellent opportunity to remove this threat.','',26124),
(129307,'enUS','|TINTERFACE\\ICONS\\SPELL_SHADOW_LIFEDRAIN02.BLP:20|t %s begins to cast |cFFFF0404|Hspell:234423|h[Drain Life]|h|r!','|TINTERFACE\\ICONS\\SPELL_SHADOW_LIFEDRAIN02.BLP:20|t %s begins to cast |cFFFF0404|Hspell:234423|h[Drain Life]|h|r!',26124),
(129308,'enUS','The magic of the Felborne is not without a certain... finesse. Such a shame they abused it. They deserved their fate.','',26124),
(129309,'enUS','Well done, heroes. The loss of Warlord Darjah weakens the naga\'s might within the tomb.','',26124),
(129310,'enUS','The Legion\'s presence has stirred an ancient hydra known as Deepmaw. Destroy this creature before its wrath is unleashed upon our world.','',26124),
(129311,'enUS','Legends tell of Deepmaw\'s unbridled ferocity. I\'m relieved we had our own legendary heroes to stop this threat!','',26124),
(129312,'enUS','Battlelord! The naga and their skrog lackeys are back to their old tricks. They must be taught proper respect!','',26124),
(129313,'enUS','The power of the tomb has drawn the attention of more than just the Legion. Kelpfist, a greedy and powerful sea giant, has emerged to claim the temple\'s relics for himself. He must be stopped!','',26124),
(129314,'enUS','Gloriously executed as always, Battlelord. I expected no less of you.','',26124),
(129315,'enUS','That greedy giant met the end he deserved. Well done!','',26124),
(129316,'enUS','That foul stench in the air means the Dread Stalker roams nearby. This vicious pet of the Legion must be put down if we are to reclaim the temple.','',26124),
(129317,'enUS','The Legion bred that monster with a taste for mortal flesh. A fine kill!','',26124),
(129318,'enUS','The demon Dresanoth lurks among the naga. Destroy any foe who stands in your path and scour this filth from our world!','',26124),
(129319,'enUS','Well done. We will show the Legion there is nowhere they can hide from annihilation.','',26124),
(129320,'enUS','Erdu\'val, one of the Legion\'s most brutal warriors, boasts of his victories. Claim this braggart\'s wretched life!','',26124),
(129321,'enUS','Nothing quiets the prattling of demons like finding one of their champions cold and dead. Well done!','',26124),
(129322,'enUS','Given your thoughts on fashion and flair, please explain the drabness of your robes.','Given your thoughts on fashion and flair, please explain the drabness of your robes.',26124),
(129323,'enUS','','There\'s another demon plot to attack the Ancients! Show those creeps they can\'t mess with nature!',26124),
(129324,'enUS','','Stupid demons. They\'ll never learn, will they? They can\'t beat us!',26124),
(129325,'enUS','Fel corruption spreads across the beach. Receive my gift and cleanse the land.','',26124),
(129326,'enUS','','Our forces have engaged the Legion on the ground floor. We must place the Aegis in the tower before our losses grow insurmountable.',26124),
(129327,'enUS','That will slow the spread of the fel in this dark place.','',26124),
(129328,'enUS','','The Legion is plotting attacks on our Ancients from this camp. Help us disrupt their plans!',26124),
(129329,'enUS','','That should put a halt to their plans, at least for a while. Thanks for the help!',26124),
(129330,'enUS','The \"historian\" part of my title requires a certain understated aura of scholarly authority. $b$bThat said, these drab robes are microfiber, moisture wicking, durable, laminated, spun-laced, tufted, antiseptic, crease resistant, shrinkage controlled bespoke robes. $b$bSo there. $b$bAlso note my skin. The moisturizing regime is vigorous.','',26124),
(129331,'enUS','','These markings appear fresh. Try to stay clear until we get this sorted out, $n. Wouldn\'t want you getting hurt.',26124),
(129332,'enUS','','Daumyr is waiting for you, Deathlord. Care to rain down some destruction?',26124),
(129333,'enUS','Fel corruption spreads across the beach. The Conclave is in need of your aid.','',26124),
(129334,'enUS','','Wondrous!',26124),
(129335,'enUS','','Don\'t get too close, $n. This area was hit recently. It\'s not safe.',26124),
(129336,'enUS','','The Council asked me to look into these fresh scorch marks. They appear quite recent.',26124),
(129337,'enUS','We\'ve lost. The Legion broke our lines and pushed us out of the tomb. You\'re all that stands between them and the Aegis. They are coming!','',26124),
(129338,'enUS','Let them come. Maiev and I will hold them on the stairs below.','',26124),
(129339,'enUS','','Our death knights have unleashed an army of undead drakes to bombard this area. Care to join in on the fun?',26124),
(129340,'enUS','','Forgive me if my glaive finds your heart, Illidan. With so many demons about, it\'s hard to distinguish you from the rest of this filth.',26124),
(129341,'enUS','','Ah, the cold embrace of death. So liberating!',26124),
(129342,'enUS','I will hold the skies. See to the Aegis!','',26124),
(129343,'enUS','Alone at last.','',26124),
(129344,'enUS','','Our allies claim to have outfitted their ship with devastating armaments. Put their weapons to the test!',26124),
(129345,'enUS','','Such an inelegant weapon is no substitute for a sharpened glaive, but I suppose it was effective.',26124),
(129346,'enUS','|TINTERFACE\\ICONS\\SPELL_SHADOW_CURSEOFMANNOROTH.BLP:20|t %s begins to cast |cFFFF0404|Hspell:236572|h[Annihilate]|h|r!','|TINTERFACE\\ICONS\\SPELL_SHADOW_LIFEDRAIN02.BLP:20|t %s begins to cast |cFFFF0404|Hspell:234423|h[Drain Life]|h|r!',26124),
(129347,'enUS','What is this?','',26124),
(129348,'enUS','','Can it be? The Guardian!',26124),
(129349,'enUS','','In ages past, this shield defended the young world soul against madness and corruption. Today, it serves those who fight for Azeroth.',26124),
(129350,'enUS','','I am Aegwynn, Guardian of Tirisfal. I left behind this echo of my power as a safeguard in the event that the wards I put in place to protect the tomb failed. Indeed, I sense that the master of the Burning Legion now schemes to claim his prize.',26124),
(129351,'enUS','','Yet there is still hope. By anchoring the Pillars of Creation in the halls below, you will restore my wards and push back against the invaders. Then you must venture into the depths of the tomb and use the Eye of Aman\'Thul to eradicate the Felstorm and sever the Legion\'s link to Azeroth.',26124),
(129352,'enUS','|TInterface\\ICONS\\Spell_Arcane_PortalDarnassus.blp20|t %s begins to cast |cFFFF0404|Hspell:234676|h[Twisted Reflection]|h|r!','|TINTERFACE\\ICONS\\SPELL_SHADOW_LIFEDRAIN02.BLP:20|t %s begins to cast |cFFFF0404|Hspell:234423|h[Drain Life]|h|r!',26124),
(129353,'enUS','','But the Pillars alone cannot bring victory. Only a united army founded on strength and courage can conquer the Legion. When you and your allies are prepared for the final battle, my echo will return to aid you. The fate of Azeroth rests in your hands.',26124),
(129354,'enUS','','Khadgar will want to hear of this.',26124),
(129355,'enUS','It seems preparations are in order.','',26124),
(129356,'enUS','The winds have blown in your favor this day, Farseer. I shall reconsider my allegiance to Thunderaan.','',26124),
(129357,'enUS','You\'ve impressed me with your vigor, Farseer, and I trust that your faith in Thunderaan is not misplaced. I shall grant my allegiance to his.','',26124),
(129358,'enUS','Hero, we\'ve gotten word that the Felskorn are readying another attack. Please foil their plans before they have a chance to act!','',26124),
(129359,'enUS','Blessings upon you, my friend! The monks are in your debt.','',26124),
(129360,'enUS','Grandmaster! We\'ve gotten word that the Felskorn are readying another attack. Please foil their plans before they have a chance to act!','',26124),
(129361,'enUS','Well done, Grandmaster! The enemy has been kept at bay... for now.','',26124),
(129362,'enUS','Other Continents','Other Continents',26124),
(129363,'enUS','There is a portal that leads to Hellfire Peninsula in Outland. It is located within the Sunfury Spire.','There is a portal that leads to Hellfire Peninsula in Outland. It is located within the Sunfury Spire.',26124),
(129364,'enUS','To get to Undercity and on to Orgrimmar or Kalimdor, you will need to use the Teleporter located within the Sunfury Spire.','To get to Undercity and on to Orgrimmar or Kalimdor, you will need to use the Teleporter located within the Sunfury Spire.',26124),
(129365,'enUS','Hellfire Peninsula in Outland','Hellfire Peninsula in Outland',26124),
(129366,'enUS','Undercity or Orgrimmar','Undercity or Orgrimmar',26124),
(129367,'enUS','What\'s going on? What aren\'t we being told?','What\'s going on? What aren\'t we being told?',26124),
(129368,'enUS','What if something happens?','What if something happens?',26124),
(129369,'enUS','We\'re just looking for answers.','We\'re just looking for answers.',26124),
(129370,'enUS','Do you have any updates?','Do you have any updates?',26124),
(129371,'enUS','We have long sought exclusion from others and so do not have many connections to other lands. As part of our pact with the Horde we do offer travel to the other cities and fronts.\n\nWhere are you looking to travel?','We have long sought exclusion from others and so do not have many connections to other lands. As part of our pact with the Horde we do offer travel to the other cities and fronts.\n\nWhere are you looking to travel?',26124),
(129372,'enUS','What does it mean?','What does it mean?',26124),
(129373,'enUS','Should we be worried?','Should we be worried?',26124),
(129374,'enUS','What\'s being done about people\'s behavior? They\'re frightening the children.','What\'s being done about people\'s behavior? They\'re frightening the children.',26124),
(129375,'enUS','We need answers! We\'re not sure what to expect.','We need answers! We\'re not sure what to expect.',26124),
(129376,'enUS','Please remain calm. Answers will come soon.','Please remain calm. Answers will come soon.',26124),
(129377,'enUS','The Council is aware of the situation. They ask that you remain calm until their assessment is complete.','The Council is aware of the situation. They ask that you remain calm until their assessment is complete.',26124),
(129378,'enUS','We are newer to this world but have already started making connection with the major cities of the Alliance.\n\nWhere are you looking to travel?','We are newer to this world but have already started making connection with the major cities of the Alliance.\n\nWhere are you looking to travel?',26124),
(129379,'enUS','We will continue to work closely with the Council until the situation is resolved.','We will continue to work closely with the Council until the situation is resolved.',26124),
(129380,'enUS','We must remain calm until the Council concludes its investigation.','We must remain calm until the Council concludes its investigation.',26124),
(129381,'enUS','If you see any unusual behavior, magical or otherwise, please do not hesitate to report it.','If you see any unusual behavior, magical or otherwise, please do not hesitate to report it.',26124),
(129382,'enUS','The Council asks that we remain calm until they have finished their assessment of the situation.','The Council asks that we remain calm until they have finished their assessment of the situation.',26124),
(129383,'enUS','To get to Storwmind you will be traveling by sea. First go up to the surface and Azuremyst Isle. From there go down the right path to the Valaar\'s Berth. The Valaar will take you as far as Rut\'theran Village. A ship departs there for Stormwind and the rest of the Eastern Kingdoms. If you need help getting tot he surface I can give you directions to the entrance as well.','To get to Storwmind you will be traveling by sea. First go up to the surface and Azuremyst Isle. From there go down the right path to the Valaar\'s Berth. The Valaar will take you as far as Rut\'theran Village. A ship departs there for Stormwind and the rest of the Eastern Kingdoms. If you need help getting tot he surface I can give you directions to the entrance as well.',26124),
(129384,'enUS','There is a portal to the Night Elf capital of Darnassus that is located in the Vault of Lights.','There is a portal to the Night Elf capital of Darnassus that is located in the Vault of Lights.',26124),
(129385,'enUS','If you wish to venture to our homeland of Outland you can use the portal in the Vault of Lights to get to Hellfire Peninsula.','If you wish to venture to our homeland of Outland you can use the portal in the Vault of Lights to get to Hellfire Peninsula.',26124),
(129386,'enUS','Darnassus','Darnassus',26124),
(129387,'enUS','Hellfire Peninsula in Outland','Hellfire Peninsula in Outland',26124),
(129388,'enUS','Stormwind or Ironforge in Eastern Kingdoms','Stormwind or Ironforge in Eastern Kingdoms',26124),
(129389,'enUS','Other Continents','Other Continents',26124),
(129390,'enUS','\"Fortitude can be found in the land beneath.\"','\"Fortitude can be found in the land beneath.\"',26124),
(129391,'enUS','\"There is truth in everything.\"','\"There is truth in everything.\"',26124),
(129392,'enUS','\"The wind is swift and dauntless.\"','\"The wind is swift and dauntless.\"',26124),
(129393,'enUS','\"The power we wield is the burden of our enemies.\"','\"The power we wield is the burden of our enemies.\"',26124),
(129394,'enUS','The shrine was corrupted by the Legion!','The shrine was corrupted by the Legion!',26124),
(129395,'enUS','Outside to Azuremyst Isle','Outside to Azuremyst Isle',26124),
(129396,'enUS','Oh, you need help reaching the entrance of the Exodar. I forget that many newcomers are not intimately familiar with these hallowed halls. There is a ramp on the upper ring of the Seat of the Naaru that will lead you up to the surface.','Oh, you need help reaching the entrance of the Exodar. I forget that many newcomers are not intimately familiar with these hallowed halls. There is a ramp on the upper ring of the Seat of the Naaru that will lead you up to the surface.',26124),
(129397,'enUS','','Here to help, $n? I haven\'t been able to diagnose it yet. Their symptoms are all over the place.',26124),
(129398,'enUS','','If citizens continue exhibiting these symptoms, we\'ll need to start training additional help.',26124),
(129399,'enUS','Bending Azeroth\'s elements to their will... the Legion has gone too far!','Bending Azeroth\'s elements to their will... the Legion has gone too far!',26124),
(129400,'enUS','Without their power cores they have no control!','Without their power cores they have no control!',26124),
(129401,'enUS','They will accomplish nothing but angering the elements!','They will accomplish nothing but angering the elements!',26124),
(129402,'enUS','','Please remain calm. We\'ll assist each and every one of you, but we must ask for your patience.',26124),
(129403,'enUS','','$n! They just keep coming! I\'ve never seen anything like this.',26124),
(129404,'enUS','','If it\'s too crowded, please step outside. We have additional stations set up and an assistant ready to help.',26124),
(129405,'enUS','','We\'ve brought in additional help and we will get to you shortly. Please have patience.',26124),
(129406,'enUS','','I don\'t know how much longer we can keep this up, $n. We\'re starting to run short on supplies.',26124),
(129407,'enUS','','We\'re running out of space for our guests. I don\'t know how much longer we can keep this up.',26124),
(129408,'enUS','','Have you any news, $n? The symptoms continue to present, but there\'s absolutely no explanation for any of it!',26124),
(129409,'enUS','','Pretty soon we\'ll have to send people off site for help. I just don\'t think we have the resources here to maintain any semblance of order.',26124),
(129410,'enUS','','I do hope this calms down. People have been arriving in a panic.',26124),
(129411,'enUS','','I\'ve never seen anything like this before, $n. We\'ll keep at it. Make sure to send anyone presenting similar symptoms our way.',26124),
(129412,'enUS','','Hello, $n.  Did you know the Royal Pond was once home to the largest and most beautiful fish in all of Azsuna?  Royalty would often gaze into the waters and watch the graceful movements, trying to forget their heavy burdens.\n\nNow... oh, something is wrong!',26124),
(129413,'enUS','I... I don\'t feel well.','I... I don\'t feel well.',26124),
(129414,'enUS','I feel it coming on again...','I feel it coming on again...',26124),
(129415,'enUS','Please. You have to help us.','Please. You have to help us.',26124),
(129416,'enUS','This has to end. I can\'t take much more of this.','This has to end. I can\'t take much more of this.',26124),
(129417,'enUS','They say it\'s all in your head, but this... this is different. I swear!','They say it\'s all in your head, but this... this is different. I swear!',26124),
(129418,'enUS','This is all too much to handle. I\'m not sure I\'m going to make it.','This is all too much to handle. I\'m not sure I\'m going to make it.',26124),
(129419,'enUS','I just want to feel like myself again.','I just want to feel like myself again.',26124),
(129420,'enUS','Is it normal to see stars?','Is it normal to see stars?',26124),
(129421,'enUS','','$n, good to see you! Any updates about what\'s been happening?',26124),
(129422,'enUS','','Welcome to the shop! Has the Council chimed in with their findings yet, $n?',26124),
(129423,'enUS','','Good to see you again, $n. Come to chat? Looking for supplies? Perhaps just a bit of relief from... whatever\'s going on out there.',26124),
(129424,'enUS','','Our door is always open, $n. Hopefully the atmosphere in here is calmer than it is out there.',26124),
(129425,'enUS','','You\'re safe in here, $n. Ainderu has been adamant about watching the door ever since this all began, but I\'m not concerned.',26124),
(129426,'enUS','I am ready to launch the assault.','I am ready to launch the assault.',26124),
(129427,'enUS','We have come far together, $n.','',26124),
(129428,'enUS','The final stage of the scenario is not yet complete. You\'ll destroy the legion ship and it will be awesome. Please send any feedback you have so far!','The final stage of the scenario is not yet complete. You\'ll destroy the legion ship and it will be awesome. Please send any feedback you have so far!',26124),
(129429,'enUS','I\'m looking for answers. Have you heard anything new?','I\'m looking for answers. Have you heard anything new?',26124),
(129430,'enUS','I need to know what\'s happening.','I need to know what\'s happening.',26124),
(129431,'enUS','I\'m hoping for some answers.','I\'m hoping for some answers.',26124),
(129432,'enUS','I haven\'t heard anything I didn\'t already know, $n. How about you?','I haven\'t heard anything I didn\'t already know, $n. How about you?',26124),
(129433,'enUS','What does it mean? I\'ve never seen anything like this before.','What does it mean? I\'ve never seen anything like this before.',26124),
(129434,'enUS','I keep coming back hoping for an update, but the answer is always the same.','I keep coming back hoping for an update, but the answer is always the same.',26124),
(129435,'enUS','Have you heard anything new today?','Have you heard anything new today?',26124),
(129436,'enUS','I\'m trying to remain positive, but I really don\'t know what to expect.','I\'m trying to remain positive, but I really don\'t know what to expect.',26124),
(129437,'enUS','','Hear the screams of the forlorn!',26124),
(129438,'enUS','','Let their agony wash over you!',26124),
(129439,'enUS','','Their torment will become your own!',26124),
(129440,'enUS','','Life and death... interwoven!',26124),
(129441,'enUS','','Ahhh, the ties that bind!',26124),
(129442,'enUS','','Can you feel the clutch of doom?',26124),
(129443,'enUS','The darkness shall claim you!','',26124),
(129444,'enUS','Your souls will know despair!','',26124),
(129445,'enUS','Emptiness... desolation...','',26124),
(129446,'enUS','I am confident you can handle your end. Let us hope the others come through.','',26124),
(129447,'enUS','Our fury is unleashed!','',26124),
(129448,'enUS','You will be made one with us!','',26124),
(129449,'enUS','We will feed upon your suffering!','',26124),
(129450,'enUS','We will reap your souls!','',26124),
(129451,'enUS','You are fuel for the engine!','',26124),
(129452,'enUS','Your souls are but fodder!','',26124),
(129453,'enUS','Another for the harvest!','',26124),
(129454,'enUS','That one has joined us!','',26124),
(129455,'enUS','More fuel!','',26124),
(129456,'enUS','A rich harvest indeed!','',26124),
(129457,'enUS','So many souls to serve us!','',26124),
(129458,'enUS','The engine hungers for more!','',26124),
(129459,'enUS','Such... bitter... harvest...','',26124),
(129460,'enUS','The engine... falters...','',26124),
(129461,'enUS','Our work... must continue...','',26124),
(129462,'enUS','Hope dies with you!','',26124),
(129463,'enUS','Your struggle has been for naught!','',26124),
(129464,'enUS','Witness our victory!','',26124),
(129465,'enUS','','As I serve, so shall you!',26124),
(129466,'enUS','','Let this temple become your tomb!',26124),
(129467,'enUS','','Do not resist the master\'s will!',26124),
(129468,'enUS','','Your spirit is mine!',26124),
(129469,'enUS','','I claim you for the master!',26124),
(129470,'enUS','','Feed, engine! Feed!',26124),
(129471,'enUS','','Elune holds no power here. This tomb belongs to the Legion!',26124),
(129472,'enUS','','Mortal souls... so weak, so pathetic!',26124),
(129473,'enUS','','The engine consumes all!',26124),
(129474,'enUS','','I should have been stronger. Tell Tyrande... I am sorry.',26124),
(129475,'enUS','','I tried to resist them, but failed. At least now I am free.',26124),
(129476,'enUS','','Thank you, champions. I pray you cleanse the darkness that haunts this temple.',26124),
(129477,'enUS','','Arille, please! Not in front of the guests. We don\'t know what it is yet and there\'s no point in speculation.',26124),
(129478,'enUS','','Pull up a chair and take a load off. We know it can be hectic out there, so leave your worries at the door.',26124),
(129479,'enUS','','Ah, $n! Maybe you can settle something for us... Arille and I were debating whether or not the Council had finished its assessment. Any word?',26124),
(129480,'enUS','','Oh no! Spilled another drink. Can\'t seem to keep my hands steady with all that\'s been going on around here.',26124),
(129481,'enUS','','Hope everything is well with you, $n. As for me, well...',26124),
(129482,'enUS','','Sometimes I wonder if we\'ll ever hear an answer as to why this is happening...',26124),
(129483,'enUS','','I hope we receive an update soon. It\'s been a while since the last.',26124),
(129484,'enUS','','All of this waiting to find out what\'s happening makes me a nervous wreck.',26124),
(129485,'enUS','','Bring any news today? We haven\'t heard any updates in quite some time.',26124),
(129486,'enUS','','How are things outside, $n? People have come and gone throughout the day, but nobody seems to know much.',26124),
(129487,'enUS','','Welcome! Lucian and I were just discussing recent events. Have any updates for us?',26124),
(129488,'enUS','','What\'s going on out there? The noise level\'s grown increasingly louder. I only hope we hear some news soon.',26124),
(129489,'enUS','','Watch your step, $n! Say, any word from the Council yet?',26124),
(129490,'enUS','YOU\'RE PRESENCE HERE IS UNWELCOMED!! RETURN NOW FROM WHENCE YOU CAME!','',26124),
(129491,'enUS','%s becomes uneasy.','%s becomes uneasy.',26124),
(129492,'enUS','','My apologies if the pets are acting up. Something has them riled up.',26124),
(129493,'enUS','','Have a care. The pets have been acting out of sorts. It would be wise to steer clear of the pens for a while.',26124),
(129494,'enUS','','There, there, my magnificent beasts! Everything will return to normal soon... I hope.',26124),
(129495,'enUS','','Try and keep the noise down. These beasts have been on edge.',26124),
(129496,'enUS','','What\'s the word on the street, $n?',26124),
(129497,'enUS','','Any news, $n?',26124),
(129498,'enUS','','We\'re getting pretty restless in here. Any news on what\'s happening?',26124),
(129499,'enUS','Send me to the Throne of the Four Winds.','Send me to the Throne of the Four Winds.',26124),
(129500,'enUS','','Hey, $n! Has the Council released any new information?',26124),
(129501,'enUS','','The skies aren\'t the only thing full of magic these days! Relax and gander at some of our newest arrivals.',26124),
(129502,'enUS','Our wings will blacken your sky!','',26124),
(129503,'enUS','I shall use your corpse to feed my charges.','',26124),
(129504,'enUS','Your skies belong to the Legion!','',26124),
(129505,'enUS','','Our wings will blacken your sky!',26124),
(129506,'enUS','','Your skies belong to the Legion!',26124),
(129507,'enUS','','I shall use your corpse to feed my charges.',26124),
(129508,'enUS','','If you think I\'m going to let the Doomstone out of my sight, you\'re horribly mistaken. Let\'s get on with it.',26124),
(129509,'enUS','I shall use your corpse to feed my charges.','I shall use your corpse to feed my charges.',26124),
(129510,'enUS','Our wings will blacken your sky!','Our wings will blacken your sky!',26124),
(129511,'enUS','Your skies belong to the Legion!','Your skies belong to the Legion!',26124),
(129512,'enUS','','Trying to make Azeroth\'s earth fight itself? Foolish eredar!',26124),
(129513,'enUS','','You know, if you only used the Doomstone, this would soon be over.',26124),
(129514,'enUS','','What\'s the point of possessing such a mighty artifact if you fear to use it? The Doomstone would be much more useful in my hands.',26124),
(129515,'enUS','','The demons have their fel fire, so they assume they can control Azeroth\'s as well. Oh, how wrong they are!',26124),
(129516,'enUS','','The powers of water are generally restorative, the most passive and weak of elements. What did the Legion think to do with it?',26124),
(129517,'enUS','','Consider the majesty of earth... so sturdy, protective, immutable. Yet when it but shudders, capable of such grand destruction.',26124),
(129518,'enUS','','Can you hear the wind, child? It screams for help, for salvation from the Legion.',26124),
(129519,'enUS','','Even if captured, my Grimtotem remain ready to fight. Your Earthen Ring, however... weak.',26124),
(129520,'enUS','Before I tell you about legendary crafting, you must first be grounded in a philosophy of style and flair. This is non-negotiable! Are you ready to begin?','',26124),
(129521,'enUS','Let me hear your philosophy on style.','Let me hear your philosophy on style.',26124),
(129522,'enUS','The end is upon us!','The end is upon us!',26124),
(129523,'enUS','Gaze into the skies above! The truth reveals itself at last!','Gaze into the skies above! The truth reveals itself at last!',26124),
(129524,'enUS','Shall we steal the secrets of the Nightborne tailors?','',26124),
(129525,'enUS','I am ready.','I am ready.',26124),
(129526,'enUS','','I have complete faith in our leaders. We should not be led astray by the idle banter throughout the city. People cope in different ways.',26124),
(129527,'enUS','','We should try to maintain a positive attitude. People have enough to deal with. We need to set an example for others.',26124),
(129528,'enUS','','Walking through the streets earlier I could feel my ears growing tired from all the speculation. So much uncertainty around here lately.',26124),
(129529,'enUS','','I wonder when the streets will calm down. The city\'s been abuzz ever since this whole thing began.',26124),
(129530,'enUS','We should listen to our leaders, not the whispered conversations throughout the city. We will know more soon enough.','',26124),
(129531,'enUS','The Council will reveal information soon enough. I\'m sure of it.','',26124),
(129532,'enUS','Please! Has anyone seen their parents? They really shouldn\'t be running around right now. It\'s not safe.','Please! Has anyone seen their parents? They really shouldn\'t be running around right now. It\'s not safe.',26124),
(129533,'enUS','Where are your parents? You shouldn\'t be running around the city right now.','Where are your parents? You shouldn\'t be running around the city right now.',26124),
(129534,'enUS','It\'s not your fault, children, but you really shouldn\'t be out until we\'re certain it\'s safe.','It\'s not your fault, children, but you really shouldn\'t be out until we\'re certain it\'s safe.',26124),
(129535,'enUS','The streets are no place for children in times like these. Someone will be by shortly to watch you until we\'re certain the city is safe.','The streets are no place for children in times like these. Someone will be by shortly to watch you until we\'re certain the city is safe.',26124),
(129536,'enUS','There\'s no need to apologize. You\'ve done nothing wrong. We just need to make sure the streets are safe for the both of you.','There\'s no need to apologize. You\'ve done nothing wrong. We just need to make sure the streets are safe for the both of you.',26124),
(129537,'enUS','Our lines weaken with each moment. Slaughter their commander before we are overwhelmed!','',26124),
(129538,'enUS','Finish... this...','',26124),
(129539,'enUS','Fool! The Legion you know is but a whisper of our true glory.','',26124),
(129540,'enUS','It matters not. It has already begun.','',26124),
(129541,'enUS','You have doomed your world to bathe in the master\'s flame.','',26124),
(129542,'enUS','The way is open. All you know, all you hold dear, will fall.','',26124),
(129543,'enUS','Damnable mortals! You scurry through this tomb like vermin, dispatching my underlings and imagining yourselves the equals of the Legion. Heroes... champions... fools!','',26124),
(129544,'enUS','Your puppet\'s strings are cut, Kil\'jaeden!','',26124),
(129545,'enUS','No more shackles! Hold nothing back! Shatter their world and finish this!','',26124),
(129546,'enUS','Good luck, Farseer $p. I have faith you will not fail me.','',26124),
(129547,'enUS','End... you!','',26124),
(129548,'enUS','Mortals... die!','',26124),
(129549,'enUS','Burn!','',26124),
(129550,'enUS','Chaos!','',26124),
(129551,'enUS','Cursed!','',26124),
(129552,'enUS','Sever!','',26124),
(129553,'enUS','Keeper...','',26124),
(129554,'enUS','','Corruption will be cleansed!',26124),
(129555,'enUS','Dead!','',26124),
(129556,'enUS','','That fiend ravages not only your people, but the land itself! If there was ever cause to use the Doomstone, that time is now!',26124),
(129557,'enUS','Ended!','',26124),
(129558,'enUS','By the Light\'s blessing, our path begins anew.','By the Light\'s blessing, our path begins anew.',26124),
(129559,'enUS','Preparations are nearly complete. A great journey is upon us.','Preparations are nearly complete. A great journey is upon us.',26124),
(129560,'enUS','Unsettling as these events may seem, a vision of hope lingers beyond the darkness.','Unsettling as these events may seem, a vision of hope lingers beyond the darkness.',26124),
(129561,'enUS','May we rise once more.','May we rise once more.',26124),
(129562,'enUS','The repairs near completion.','The repairs near completion.',26124),
(129563,'enUS','...and in the darkness, the Light will prevail.','...and in the darkness, the Light will prevail.',26124),
(129564,'enUS','Master... wins.','',26124),
(129565,'enUS','Flesh... fails.','',26124),
(129566,'enUS','It... ends...','',26124),
(129567,'enUS','Still you fight us! Still you deny the inevitable! Your incessant resistance is maddening! Why will you not yield?','',26124),
(129568,'enUS','Have your countless defeats taught you nothing, Deceiver?','',26124),
(129569,'enUS','The vision Sargeras showed you was a lie, Kil\'jaeden. Surrender! Let it end!','',26124),
(129570,'enUS','I have ripped the flame from your world. It now bends to my command!','',26124),
(129571,'enUS','Your power is too great. You cannot control it!','',26124),
(129572,'enUS','','Such power... such chaos!',26124),
(129573,'enUS','','Pull yourself together, child! What is wrong with you?',26124),
(129574,'enUS','Let... it... end...','',26124),
(129575,'enUS','','That\'s it! Give in to the power!',26124),
(129576,'enUS','Never! Our crusade will never yield! Savor your shallow victory. We will return again and again, however long it takes, until at last we break you!','',26124),
(129577,'enUS','The portal is closing! We can seal the Legion\'s gateway and end this invasion.','',26124),
(129578,'enUS','Be on your guard, champion. The Legion is skilled at deception.','',26124),
(129579,'enUS','We may well be walking into a trap.','',26124),
(129580,'enUS','','Listen--we\'re sure our goods are \"safe\" here, but why take any chances?',26124),
(129581,'enUS','','What\'s it to ya?',26124),
(129582,'enUS','','Ain\'t ya ever seen someone protectin\' their assets before? Keep movin\'!',26124),
(129583,'enUS','','Hold still! We don\'t want none of our loot spillin\' over, do we?',26124),
(129584,'enUS','','What\'s it take to get a helpin\' hand \'round here? We was hopin\' to have our stuff back home and safe before... well, y\'know.',26124),
(129585,'enUS','','End of the world? Pfft! I\'m tryin\' to get our scratch but these guys are movin\' like snails!',26124),
(129586,'enUS','','I sure hope our stash back home is end-of-the-world proof.',26124),
(129587,'enUS','Please remain calm and maintain an orderly line. A banker will assist you as soon as a spot becomes available.','Please remain calm and maintain an orderly line. A banker will assist you as soon as a spot becomes available.',26124),
(129588,'enUS','Due to the recent influx of patrons, we must remember to maintain a calm, orderly demeanor.','Due to the recent influx of patrons, we must remember to maintain a calm, orderly demeanor.',26124),
(129589,'enUS','If you notice any suspicious activity or unusual behavior, please do not hesitate to inform us.','If you notice any suspicious activity or unusual behavior, please do not hesitate to inform us.',26124),
(129590,'enUS','We are here on your behalf. There is no need for panic. Please remember to maintain orderly conduct at all times.','We are here on your behalf. There is no need for panic. Please remember to maintain orderly conduct at all times.',26124),
(129591,'enUS','We ask you to remain patient and calm until further information becomes available.','We ask you to remain patient and calm until further information becomes available.',26124),
(129592,'enUS','This is no longer the Argus I remember.','',26124),
(129593,'enUS','I am ready to search for survivors.','I am ready to search for survivors.',26124),
(129594,'enUS','Prepare yourself, champion. We are surrounded.','',26124),
(129595,'enUS','I will fight by your side.','I will fight by your side.',26124),
(129596,'enUS','Ready to ride with you, Highlord!','Ready to ride with you, Highlord!',26124),
(129597,'enUS','It will be an honor to ride alongside you, Highlord.','It will be an honor to ride alongside you, Highlord.',26124),
(129598,'enUS','Riding into battle with you shall be glorious, Highlord.','Riding into battle with you shall be glorious, Highlord.',26124),
(129599,'enUS','Let us mount up, Highlord and rescue our missing allies.','Let us mount up, Highlord and rescue our missing allies.',26124),
(129600,'enUS','You hunted your own people, chasing us across the stars. Never again!','',26124),
(129601,'enUS','It was you who lacked vision! Who refused to see the truth of the Legion\'s inevitable victory!','',26124),
(129602,'enUS','You lost faith in the Light. Together, we could have resisted Sargeras and saved our world!','',26124),
(129603,'enUS','Did the Light save your son? Was it faith that shone in Rakeesh\'s eyes as they closed for the final time? Or was it hatred for the father who abandoned him?','',26124),
(129604,'enUS','GRRAAAHHHHH!','',26124),
(129605,'enUS','And now your impotent fury has drawn your allies to their doom. Watch as my infinite army slaughters them all!','',26124),
(129606,'enUS','No! You will not divide us, Deceiver. I will fight by their side, and they by mine. Together, we will end your crusade!','',26124),
(129611,'enUS','You were fools to follow me here!','',26124),
(129612,'enUS','Fall before your master!','',26124),
(129613,'enUS','Who will save you now?','',26124),
(129614,'enUS','Eredar! Show Velen\'s mongrels the folly of resisting us!','',26124),
(129615,'enUS','Felborne! Show them the gravity of their defiance!','',26124),
(129616,'enUS','Incinerate these weaklings, warlocks!','',26124),
(129617,'enUS','Turn your gaze upon them, Felsworn!','',26124),
(129618,'enUS','An inevitable fate!','',26124),
(129619,'enUS','Fall, hero!','',26124),
(129620,'enUS','The Light shall restore you!','',26124),
(129621,'enUS','It is not your time!','',26124),
(129622,'enUS','Do not lose faith!','',26124),
(129623,'enUS','Let us judge your battle prowess! Target a foe!','',26124),
(129624,'enUS','Hero! Pick your target well!','',26124),
(129625,'enUS','Demon filth!','',26124),
(129626,'enUS','Fall beneath my blades!','',26124),
(129627,'enUS','Insolent mortals! Your fate was sealed the moment you stepped into the Nether!','',26124),
(129628,'enUS','A meaningless struggle! Azeroth shall fall to the Burning Legion!','',26124),
(129629,'enUS','Still you resist! Then let me repay your arrogance!','',26124),
(129630,'enUS','Burn! Burn and die!','',26124),
(129631,'enUS','A vessel for my fury!','',26124),
(129632,'enUS','You will all burn!','',26124),
(129633,'enUS','Ixallon! Come forth and break them!','',26124),
(129634,'enUS','It is a simple matter to show courage against my minions. Can you face the shadows within your own souls as bravely?','',26124),
(129635,'enUS','What is this? Even when your own doubts and fears are made manifest, you will not yield?','',26124),
(129636,'enUS','Confront your own darkness!','',26124),
(129637,'enUS','I sense the corruption inside you.','',26124),
(129638,'enUS','You cannot resist your own nature.','',26124),
(129639,'enUS','Your defiance is futile! My strength comes from an infinite army!','',26124),
(129640,'enUS','Kil\'jaeden will draw power from those vessels!','',26124),
(129641,'enUS','Somehow you survived! No matter. Look upon our wonders, you mortals, and despair! Behold the world that shall be your tomb!','',26124),
(129642,'enUS','Your reality is sundered!','',26124),
(129643,'enUS','Chaos will consume you!','',26124),
(129644,'enUS','The fel fuels me!','',26124),
(129645,'enUS','I will feed upon your ashes!','',26124),
(129646,'enUS','Deceiver! We have come to end your invasion of Azeroth. Your master\'s crusade dies here!','',26124),
(129647,'enUS','Greetings, Farseer. Are you feeling well again?','',26124),
(129648,'enUS','She lives? No! I will never let her bind me again!','',26124),
(129649,'enUS','You have witnessed the destruction the Doomstone can wreak firsthand. You are a trusted warden of Azeroth, but even in your hands the power caused chaos and panic amongst your people. Imagine it in the control of someone with ill intent...$b$bWe cannot let that happen.$b$bWe discussed what to do with this artifact at length while we waited for you to awaken. We considered giving it a new home in one of the elemental planes, but each one provided its own danger.$b$bThere is no safer place for it than here, in the heart of Azeroth. It shall be kept under the protection of the Earthen Ring, never to be used again. Place it on this pedestal, where it shall never move from again.','',26124),
(129650,'enUS','Ah... merely a lingering echo of her power. Nothing to be concerned about, child.','',26124),
(129651,'enUS','You called for me, Neptulon?','You called for me, Neptulon?',26124),
(129652,'enUS','Even her echo prattles on endlessly! Do you see now what I had to deal with?','',26124),
(129653,'enUS','Bah! I am every bit as mighty as the Tidestone, or any of these other musty relics!','',26124),
(129654,'enUS','A dream of perfect beauty... ridiculous! This world knows only pain, child.','',26124),
(129655,'enUS','','Come back later. I might have another job for you.',26124),
(129656,'enUS','Do not trust her ramblings! I am the only true power here!','',26124),
(129657,'enUS','You are better off without her!','',26124),
(129658,'enUS','Talkin\' to a world soul ain\'t like chattin\' with a mortal. Might be why she needed someone ta become her Speaker.','',26124),
(129659,'enUS','She\'s haunted by the Legion... and the Old Gods. But there be somethin\' more... a greater darkness...','',26124),
(129663,'enUS','','Oh don\'t worry, Farseer... we will keep an eye on the Doomstone.',26124),
(129664,'enUS','Stay close. We are being watched.','',26124),
(129665,'enUS','That was not a request. <Strangulate him.>','That was not a request. <Strangulate him.>',26124),
(129666,'enUS','This hovel feels... familiar.','',26124),
(129667,'enUS','This is not our final day. We stand together.','',26124),
(129668,'enUS','Looks like we\'ve got some preparin\' ta do, champion! Ye best tell Khadgar what we\'ve learned. Good luck!','',26124),
(129669,'enUS','What does it mean? Is this the end?','What does it mean? Is this the end?',26124),
(129670,'enUS','What if something attacks the city? What are we supposed to do then?','What if something attacks the city? What are we supposed to do then?',26124),
(129671,'enUS','Show yourselves!','',26124),
(129672,'enUS','Velen. At long last, you return to the home you abandoned.','',26124),
(129673,'enUS','You turned your back on your people, Prophet. Your world. Such betrayal should be answered with death.','',26124),
(129675,'enUS','The skies are darker than ever before! Is there no hope?','The skies are darker than ever before! Is there no hope?',26124),
(129676,'enUS','Is this it? Is this what it\'s all been about? There\'s so many things I wanted to do...','Is this it? Is this what it\'s all been about? There\'s so many things I wanted to do...',26124),
(129677,'enUS','I don\'t know what to do anymore!','I don\'t know what to do anymore!',26124),
(129678,'enUS','That voice... Hatuun? How did you survive this hell for so long?','',26124),
(129679,'enUS','We changed, just as Argus did. We endured. What choice did we have?','',26124),
(129680,'enUS','This can\'t be end! It just can\'t!','This can\'t be end! It just can\'t!',26124),
(129681,'enUS','Enough!','',26124),
(129682,'enUS','Is there anything we can do?','Is there anything we can do?',26124),
(129683,'enUS','Stay your weapons! The Prophet and his ally are not our foes.','',26124),
(129684,'enUS','What do I tell my children?','What do I tell my children?',26124),
(129685,'enUS','High Exarch Turalyon... we meet at last.','',26124),
(129686,'enUS','<Speaking gibberish.>','<Speaking gibberish.>',26124),
(129687,'enUS','<Unintelligible.>','<Unintelligible.>',26124),
(129688,'enUS','<Shaking uncontrollably.>','<Shaking uncontrollably.>',26124),
(129689,'enUS','...in the darkness.','...in the darkness.',26124),
(129690,'enUS','The end...','The end...',26124),
(129691,'enUS','I have no wish to fight you, Hatuun. But I cannot allow your bitterness to impede our war against the Legion.','',26124),
(129692,'enUS','We must stand together, all of us, if we are to have any chance of defeating the Legion.','',26124),
(129693,'enUS','It has been eons since I have laid eyes on this place. So many memories...$b$b\n<Velen\'s brows knit in pensive thought.>','',26124),
(129694,'enUS','Shall we continue?','Shall we continue?',26124),
(129695,'enUS','','Those insolent eredar still believe they can bend Azeroth\'s earth to their will? Punish them!',26124),
(129696,'enUS','','And so they return to the earth.',26124),
(129697,'enUS','','Thank you, stranger! Those imps came out of nowhere! I don\'t have much left, but you deserve a reward. Look through our supplies and take anything you need.',26124),
(129698,'enUS','','My dear Corian... what will I do without you?',26124),
(129699,'enUS','Champion, the very land is rotting beneath our feet. Manifestations of decay proliferate at every turn. They must be eradicated!','',26124),
(129701,'enUS','I can feel the poison leaving my veins. Thank you!','I can feel the poison leaving my veins. Thank you!',26124),
(129702,'enUS','Finally... I can breathe again.','Finally... I can breathe again.',26124),
(129703,'enUS','S...s...spiders....','S...s...spiders....',26124),
(129704,'enUS','|TInterface\\Icons\\inv_egg_01:20|tA group of Incubated Eggs are |cFFFF0404|Hspell:240319|h[Hatching]|h|r!','',26124),
(129705,'enUS','','My children will feast on the corpses of your allies!',26124),
(129706,'enUS','','The Legion endures...',26124),
(129707,'enUS','%s has summoned demonic portals!','%s has summoned demonic portals!',26124),
(129708,'enUS','%s has extended the duration of the demonic portals!','%s has extended the duration of the demonic portals!',26124),
(129709,'enUS','%s has empowered the demonic portals!','%s has empowered the demonic portals!',26124),
(129710,'enUS','%s has summoned a demonic lieutenant!','%s has summoned a demonic lieutenant!',26124),
(129711,'enUS','Grevious wounds... I must recover...','Grevious wounds... I must recover...',26124),
(129712,'enUS','Unggh...','Unggh...',26124),
(129713,'enUS','I need to recover... Go on without me!','I need to recover... Go on without me!',26124),
(129714,'enUS','Hero! I had a slight mishap while flying over this area. I dropped some special coins I was going to give to... uh, nevermind. If you happen to come across them, their return would be most appreciated!','',26124),
(129715,'enUS','You found them? What a relief! I was scrambling to find a replacement gift...','',26124),
(129716,'enUS','I\'m just going to hide back here and wait for all of this to blow over.','',26124),
(129717,'enUS','','This should be enough! Now let\'s see... Kataract? Katharsis? How do you even say that?',26124),
(129718,'enUS','So this is where our forces landed on the Broken Shore.','',26124),
(129719,'enUS','This land is scarred and desolate, a terrible place to meet one\'s end.','',26124),
(129720,'enUS','Come, let us press forward.','',26124),
(129721,'enUS','This land is far worse than I had imagined.','',26124),
(129722,'enUS','My father sought to shield me from the war, insisting I stay behind because a Wrynn must always rule in Stormwind. But I saw the truth in his eyes... his fear of losing me.','',26124),
(129723,'enUS','When my mother died, I was all he had left of her.','',26124),
(129724,'enUS','Time and time again, I have watched from afar as the heroes of Stormwind fought and died to preserve peace on Azeroth.','',26124),
(129725,'enUS','My father was not the first King of Stormwind to die fighting the Burning Legion.','',26124),
(129726,'enUS','My great-grandfather, King Barathen, and my grandfather, King Llane, also paid the ultimate sacrifice.','',26124),
(129727,'enUS','The kings of my family have always fought shoulder-to-shield with their soldiers for the freedom of Stormwind.','',26124),
(129728,'enUS','I have lived my life sheltered by the blood of heroes like Tirion and Bolvar... heroes like my father.','',26124),
(129729,'enUS','The time has come for me to do the same. Take me to the place where my father died. I must see it for myself.','',26124),
(129730,'enUS','I\'ll ready a ship at once!','',26124),
(129731,'enUS','The Broken Shore is no place to journey alone. We must find Anduin before it\'s too late!','',26124),
(129732,'enUS','Slay the demons and lay waste to their fortifications!','',26124),
(129733,'enUS','Well done. The demons will not soon recover from such devestation.','',26124),
(129734,'enUS','Yes! Let them come! Their bodies will fuel the flames of their burning world!','',26124),
(129739,'enUS','','Defilers! They must be purged from Elune\'s sacred temple!',26124),
(129740,'enUS','','Sisters! On your guard!',26124),
(129741,'enUS','','My arrows are always ready, Kasparian.',26124),
(129742,'enUS','','I claim first blood, sisters!',26124),
(129743,'enUS','','Goddess guide your hand!',26124),
(129744,'enUS','','You are ever impetuous, Kasparian.',26124),
(129745,'enUS','','Your hunt is ended!',26124),
(129746,'enUS','','A bit slow on that kill, sister!',26124),
(129747,'enUS','','The goddess is pleased, sister!',26124),
(129748,'enUS','','My quarry falls!',26124),
(129749,'enUS','','A worthy kill, sister!',26124),
(129750,'enUS','','Your bow is blessed, sister!',26124),
(129751,'enUS','','You should have believed!',26124),
(129752,'enUS','','You serve the goddess well, sister!',26124),
(129753,'enUS','','Inefficient... but effective.',26124),
(129754,'enUS','','Mother Moon has granted us victory!',26124),
(129755,'enUS','','The temple is secure. Well fought, sisters!',26124),
(129756,'enUS','','Next time, I get to strike first!',26124),
(129757,'enUS','','We failed... the goddess...',26124),
(129758,'enUS','','No! I... should have... won...',26124),
(129759,'enUS','','Elune... forgive us...',26124),
(129760,'enUS','','No more dawdling, Kasparian! Victory shall be mine!',26124),
(129761,'enUS','','I will dismiss these heretics, Yathae!',26124),
(129762,'enUS','','I relieve you, sister. Time for my glaive to sing!',26124),
(129763,'enUS','','Elune\'s light reaches its zenith!',26124),
(129764,'enUS','','Retribution rains down!',26124),
(129765,'enUS','','My mark is upon you!',26124),
(129766,'enUS','','You are in my sights!',26124),
(129767,'enUS','','I never miss!',26124),
(129768,'enUS','','Let your talons taste their flesh, my pet!',26124),
(129769,'enUS','','Goddess, burn the faithless!',26124),
(129770,'enUS','','Behold her glory!',26124),
(129771,'enUS','','Pay the price for heresy!',26124),
(129772,'enUS','','Mother Moon, reveal their sins!',26124),
(129773,'enUS','','Confess! Repent!',26124),
(129774,'enUS','','You are unworthy!',26124),
(129775,'enUS','','Right on target!',26124),
(129776,'enUS','','You are in my way!',26124),
(129777,'enUS','','The keenest cut!',26124),
(129778,'enUS','','The Night Warrior guides your hand, sister!',26124),
(129779,'enUS','','You waste too much time. Destroy them!',26124),
(129780,'enUS','','Most impressive aim, sister!',26124),
(129781,'enUS','','Goddess bless your arrows!',26124),
(129782,'enUS','','Mother Moon is pleased, Lunaspyre!',26124),
(129783,'enUS','I will show no mercy!','I will show no mercy!',26124),
(129784,'enUS','','Too much preaching! Just kill them!',26124),
(129785,'enUS','Hero, over here.','',26124),
(129786,'enUS','This land is grim and brimming with sorrow.','',26124),
(129787,'enUS','I had no idea...','',26124),
(129788,'enUS','','We must hurry, outsider!',26124),
(129789,'enUS','','Keep moving! It is not safe here...',26124),
(129790,'enUS','','Our foes close in... let us make haste!',26124),
(129791,'enUS','Father...','',26124),
(129792,'enUS','Let\'s go.','',26124),
(129793,'enUS','You have a \"Loaner Demon\" for me?','You have a \"Loaner Demon\" for me?',26124),
(129794,'enUS','I don\'t like this demon.','I don\'t like this demon.',26124),
(129795,'enUS','What a coincidence. She doesn\'t like you either.\n\nNow get to work before the eredar on the other side of this thing figure out what I\'ve done and try to seal the portal.','',26124),
(129796,'enUS','I wish to cease my experience gains when I reach level 19.','I wish to cease my experience gains when I reach level 19.',26124),
(129797,'enUS','Are you certain you wish to stop gaining experience when you reach level 19?','Are you certain you wish to stop gaining experience when you reach level 19?',26124),
(129798,'enUS','Leave this place, $c!','Leave this place, $c!',26124),
(129799,'enUS','You should not be here.','You should not be here.',26124),
(129800,'enUS','My will is not my own.','My will is not my own.',26124),
(129801,'enUS','This is not my choice!','This is not my choice!',26124),
(129802,'enUS','I remain bound, even in death...','I remain bound, even in death...',26124),
(129803,'enUS','My suffering has no end!','My suffering has no end!',26124),
(129804,'enUS','Death does not bring peace.','Death does not bring peace.',26124),
(129805,'enUS','There!','',26124),
(129806,'enUS','My fate was sealed long ago.','My fate was sealed long ago.',26124),
(129807,'enUS','Anduin!','',26124),
(129808,'enUS','This changes nothing.','This changes nothing.',26124),
(129809,'enUS','Let\'s go.','',26124),
(129810,'enUS','','These spirits belong to the Burning Legion!',26124),
(129811,'enUS','','My death will not break the pact!',26124),
(129812,'enUS','You will succumb to the Burning Legion. This I vow!','',26124),
(129813,'enUS','This... cannot be...','',26124),
(129814,'enUS','Those bound to me chose this fate for themselves!','',26124),
(129815,'enUS','','These eredar are using power cores in their amateurish attempts to bend the elements to their will. Teach them such powers are not to be trifled with!',26124),
(129816,'enUS','','Those demons presumed to bind the elements. Fools! They have learned the price of such an insult!',26124),
(129817,'enUS','You are mine!','You are mine!',26124),
(129818,'enUS','Nowhere to run!','Nowhere to run!',26124),
(129819,'enUS','Death is only the beginning.','Death is only the beginning.',26124),
(129820,'enUS','Join us in eternity...','Join us in eternity...',26124),
(129821,'enUS','Go to your grave!','Go to your grave!',26124),
(129822,'enUS','Let this torment end!','Let this torment end!',26124),
(129823,'enUS','This... cannot be...','This... cannot be...',26124),
(129824,'enUS','Ah.... at last.','Ah.... at last.',26124),
(129825,'enUS','Vengeance will be mine!','Vengeance will be mine!',26124),
(129826,'enUS','Your world will be purged!','Your world will be purged!',26124),
(129827,'enUS','Your death will be swift and unmerciful.','Your death will be swift and unmerciful.',26124),
(129828,'enUS','Wither before my might!','Wither before my might!',26124),
(129829,'enUS','You dare?!','You dare?!',26124),
(129830,'enUS','The Legion\'s work will be done.','The Legion\'s work will be done.',26124),
(129831,'enUS','You will know pain!','You will know pain!',26124),
(129832,'enUS','Take to the skies, my pets! Yaaaaah!','',26124),
(129833,'enUS','','I am ready to travel to Skold-Ashil.\n\nShall we depart?',26124),
(129834,'enUS','Kil\'jaeden has sent one of his generals to oversee the Cathedral of Eternal Night. Put an end to her command.','',26124),
(129835,'enUS','Well done. Let the Deceiver rage now that the cathedral is no longer under his control.','',26124),
(129836,'enUS','The Legion has summoned forth a ravenous beast with a taste for mortal flesh. Destroy this monstrosity before it can be unleashed!','',26124),
(129837,'enUS','The beast has been put down. Good! Soon we will do the same to Kil\'jaeden.','',26124),
(129838,'enUS','I sense a perverse power rising among the Legion. Destroy it and weaken their grip on the cathedral.','',26124),
(129839,'enUS','A worthy kill. That bloated fiend will never bring forth another demon.','',26124),
(129840,'enUS','An inquisitor lurks within the cathedral, turning the souls of our dead against us. Send this filth screaming back into the Nether.','',26124),
(129841,'enUS','That inquisitor delighted in sending its victims to their deaths. Fitting, then, that you forced the fiend to meet its own fate.','',26124),
(129842,'enUS','Kil\'jaeden delights in sending his underlings to defile the cathedral. Remove this foul creature from our world.','',26124),
(129843,'enUS','The Legion seeks to break our will by desecrating this once-sacred temple. Your deeds prove our spirit cannot be broken!','',26124),
(129844,'enUS','','Elune bless you, brave one. It seems the woods no longer offer us sanctuary from the Legion\'s forces.',26124),
(129845,'enUS','','My sisters and I owe you our lives. We don\'t have much but you\'re free to take anything you find useful from our supplies.',26124),
(129846,'enUS','','Thank you again. We will not forget your kindness!',26124),
(129847,'enUS','Salutations, $ct! \n\nAs you may already know, this place is more than just a naval graveyard... it\'s also a massive breeding ground for kraken! I mean just look at all this incubation! It\'s spectacular... and perhaps slightly dangerous.\n\nSince you\'re here to destroy the eggs before they hatch, perhaps you\'d enjoy my newest, relatively-safe invention:\n\nI call it... the Egg-Sploder!\n\nIt almost works perfectly most of the time! What do you say?','',26124),
(129848,'enUS','Sure, I\'ll give it a shot. What could possibly go wrong?','Sure, I\'ll give it a shot. What could possibly go wrong?',26124),
(129849,'enUS','','Let\'s move!',26124),
(129850,'enUS','','As you command, priestess.',26124),
(129851,'enUS','Activating','Activating',26124),
(129852,'enUS','This is a test broadcast for gender token testing, $gbrother:sister;! (Do not translate)','',26124),
(129853,'enUS','Turalyon! I am pleased you continue to thwart the Legion\'s best efforts to kill you.','',26124),
(129854,'enUS','What of Alleria? Is she...','',26124),
(129855,'enUS','The last time I saw her was on the Xenedar. She was still... under guard.','',26124),
(129856,'enUS','Alleria\'s out there somewhere, old friend. I know it. And other survivors as well.','',26124),
(129857,'enUS','But thousands of demons stand between us and our allies. We must thin the Legion\'s ranks to have any hope of reaching the Xenedar alive.','',26124),
(129858,'enUS','Then that is what we will do, High Exarch.','',26124),
(129859,'enUS','Climbing','Climbing',26124),
(129860,'enUS','Thank you for saving me!','Thank you for saving me!',26124),
(129861,'enUS','I must report back to camp!','I must report back to camp!',26124),
(129862,'enUS','The demons cannot chain us for long.','The demons cannot chain us for long.',26124),
(129863,'enUS','','I am Magatha of the Grimtotem tribe, and I will be heard!',26124),
(129864,'enUS','I have recovered some of the essence you seek. Please, take all of it.','I have recovered some of the essence you seek. Please, take all of it.',26124),
(129865,'enUS','','You\'re in charge here?',26124),
(129866,'enUS','I am the farseer of the Earthen Ring. Who are you?','I am the farseer of the Earthen Ring. Who are you?',26124),
(129867,'enUS','Greetings, Grandmaster $n. It\'s nice of you to visit us. We\'re mostly focused on cleaning up the last remnants of the sha in the area.$b$bIf you could assist us with this task, perhaps we can help you with yours. What do you say?','',26124),
(129868,'enUS','You certainly removed a great number of the remaining sha remnants, Grandmaster. We appreciate your help with that matter.','',26124),
(129869,'enUS','How goes the removal of the remaning remnants?','',26124),
(129870,'enUS','<The portal hums with energy. Screams and other disturbing noises emanate from beyond.>','',26124),
(129871,'enUS','Overload with Nethershards [100]','Overload with Nethershards [100]',26124),
(129872,'enUS','I\'ve cleaned up the sha.','I\'ve cleaned up the sha.',26124),
(129873,'enUS','','I am Magatha Grimtotem, of the Grimtotem tribe. I am the Elder Crone, the matriarch of my tribe.$b$bThough Baine may have exiled me from Thunder Bluff, I am the leader that the tauren need. They sit idly by in their tents, waiting for the Alliance and the Legion to effortlessly roll over them. My people and I refuse to let that happen to us. We do what we must to survive.$b$bThe Legion has attacked. The Grimtotem need me. Will you help, or will you get in the way?',26124),
(129874,'enUS','I\'m ready to clean up the sha.','I\'m ready to clean up the sha.',26124),
(129875,'enUS','|CFFF00000CAUTION|R This will summon a dangerous foe that will require multiple heroes to defeat. You will lose 100 Nethershards by destroying this portal.','|CFFF00000CAUTION|R This will summon a dangerous foe that will require multiple heroes to defeat. You will lose 100 Nethershards by destroying this portal.',26124),
(129884,'enUS','Is there no end to your sanctimonious bluster, Velen? You claim the mantle of prophet, yet you always lacked the vision to see the inevitable destiny of our world... of all worlds.','',26124),
(129885,'enUS','The husk before you was once a vessel for the might of Sargeras. But this temple itself is our prize. The means by which we will reduce your world to cinders!','',26124),
(129886,'enUS','Still... I will not deprive you of this chance to fall before an ancient wonder. Let this avatar be the end of you!','',26124),
(129887,'enUS','I should warn you that the Egg-Sploder does occasionally cause kraken eggs to hatch instead of explode. A meager price to pay for the convenience of technology, right?','',26124),
(129888,'enUS','We must move quickly. Now that the demons know we are on the surface, the Legion will bring its full might to bear against us.','',26124),
(129889,'enUS','Flames!','',26124),
(129890,'enUS','These pylons can only transport a handful of troops at a time, but for now they will suffice.','',26124),
(129891,'enUS','Marked!','',26124),
(129892,'enUS','Claimed!','',26124),
(129893,'enUS','Thank you, Grandmaster $p, for your assistance. Unfortunately, Ban-Lu is no longer here. I saw him heading south, but that is all I know.','',26124),
(129894,'enUS','Impale!','',26124),
(129895,'enUS','$ct, I\'ve sent a raven to take you to the command ship.','',26124),
(129896,'enUS','Emptiness...','',26124),
(129897,'enUS','Please, walk with me to the shore.','',26124),
(129898,'enUS','I shall commune with the water now...','',26124),
(129899,'enUS','How interesting.','',26124),
(129900,'enUS','','Eradicate them all!',26124),
(129901,'enUS','Impus not sure why he ended up here.','',26124),
(129902,'enUS','The rivers call to me.','',26124),
(129903,'enUS','The raven looks at you quizzically.','',26124),
(129904,'enUS','','I seek to cleanse the waters here.',26124),
(129905,'enUS','','The fish of Suramar are friends to me.',26124),
(129906,'enUS','%s triggers an ancient protective spell!','%s triggers an ancient protective spell!',26124),
(129907,'enUS','So, you prove to be as foolish as all the others on this world and seek to face me? Very well.','',26124),
(129908,'enUS','Pathetic! My time is wasted here. With the power from the tomb, I will destroy all of you!','',26124),
(129909,'enUS','My crag, you die!','',26124),
(129910,'enUS','This Dookya\'s pass!','',26124),
(129911,'enUS','Our pass, you go!','',26124),
(129912,'enUS','Your shinies, give them!','',26124),
(129913,'enUS','The Legion stoops to corrupting the murlocs that call this shore home. Put an end to this befoulment!','',26124),
(129914,'enUS','I have never understood how anyone could find charm in those distasteful creatures. Let us turn our attention to more pressing matters.','',26124),
(129915,'enUS','Fel... murlocs? Is there any race the Legion won\'t corrupt? Take care of this, would you?','',26124),
(129916,'enUS','I confess a certain fondness for murlocs. The fel variety, however... not so much.','',26124),
(129917,'enUS','Harjatan\'s |cFFFF0404|Hspell:232192|h[Commanding Roar]|h|r has drawn the attention of nearby murlocs!','',26124),
(129918,'enUS','For the Legion!','For the Legion!',26124),
(129919,'enUS','The fel will consume you!','The fel will consume you!',26124),
(129920,'enUS','Your end is near!','Your end is near!',26124),
(129921,'enUS','You will die by my blade!','You will die by my blade!',26124),
(129922,'enUS','We cannot be stopped!','We cannot be stopped!',26124),
(129923,'enUS','I will strike you down!','I will strike you down!',26124),
(129924,'enUS','Fine. Take all my desecrated seaweed.','Fine. Take all my desecrated seaweed.',26124),
(129925,'enUS','I have found many of your totem fragments. Please take them.','I have found many of your totem fragments. Please take them.',26124),
(129926,'enUS','Well done! With the kraken threat neutralized, we can focus our efforts on defeating the Burning Legion.','',26124),
(129927,'enUS','Looks like I found some of this disgusting globby stuff you wanted.','Looks like I found some of this disgusting globby stuff you wanted.',26124),
(129928,'enUS','Hello pretty bird. Do you want all these shiny things?','Hello pretty bird. Do you want all these shiny things?',26124),
(129929,'enUS','For millennia, the Army of the Light has waged war upon the Burning Legion. Battles. Skirmishes. Sabotage.','',26124),
(129930,'enUS','We were committed to our cause. Either we would end the Legion\'s crusade... or they would end ours.','',26124),
(129931,'enUS','When at last our final assault on Argus began, we knew we might not survive it. And when the Xenedar was hit, it seemed all hope was lost.','',26124),
(129932,'enUS','I want to give you all my golden minnows.','I want to give you all my golden minnows.',26124),
(129933,'enUS','Champion, the Legion holds our forces captive, torturing them nigh to death. Rescue them... before their Light fades!','',26124),
(129934,'enUS','You have saved our forces from a terrible fate. The Light thanks you, hero.','',26124),
(129935,'enUS','Mistress Sassz\'ine called in a Darkscale Taskmaster!','',26124),
(129936,'enUS','|TINTERFACE\\ICONS\\ability_fixated_state_red.blp:20|t A Razorjaw Gladiator is fixated on you!','',26124),
(129970,'enUS','<Velen stares straight ahead. He doesn\'t seem to notice you have arrived.>','',26124),
(129971,'enUS','Mac\'Aree was once the pinnacle of eredar civilization.','',26124),
(129972,'enUS','A beacon of progress... that drew the malevolence of the universe to our very gates.','',26124),
(129973,'enUS','Wait... something stirs.','',26124),
(129974,'enUS','Spirits... of all those who died that day.','',26124),
(129975,'enUS','I can still hear the naaru\'s song of war. There was one who held the way open for us.','',26124),
(129976,'enUS','She fell behind. I can feel her presence even now... but her song is bitter, distorted.','',26124),
(129977,'enUS','The last time I laid eyes upon this place, I could think of nothing but escape. Talgath, my most trusted advisor, had betrayed me.','',26124),
(129982,'enUS','Champion, the Argus Expedition calls upon you to join our assault on the Legion home world of Argus.','',26124),
(129984,'enUS','Your souls will BURN!','',26124),
(129985,'enUS','Ready your weapon.','',26124),
(129987,'enUS','We need not be sticking around here longer than necessary.','',26124),
(129988,'enUS','I am ready to fight by your side.','I am ready to fight by your side.',26124),
(129989,'enUS','Wanna know the key to beating the Legion?\n\nBuildings, mate.\n\nBuildings and more buildings. Crikey!','',26124),
(129990,'enUS','Is that ALL you have to offer? How pathetic...','',26124),
(129991,'enUS','Your flesh is weak! Your bones brittle!','',26124),
(129992,'enUS','I\'ve fought your kind for a thousand years, demon. You brag and bluster, then you die!','',26124),
(129994,'enUS','Do not relent! We end this beast here and now!','',26124),
(129995,'enUS','I want to go to the Cathedral of Eternal Night (Dungeon).','I want to go to the Cathedral of Eternal Night (Dungeon).',26124),
(129996,'enUS','I want to go to the Tomb of Sargeras (Raid).','I want to go to the Tomb of Sargeras (Raid).',26124),
(129997,'enUS','You are no match for our power!','',26124),
(129999,'enUS','NOT USED','',26124),
(130000,'enUS','','Elune aids those who seek to defend the land from the Burning Legion. Step within the moonlight, hero, and obtain her blessing.',26124),
(130001,'enUS','Alleria! Perfect timing, as always.','',26124),
(130002,'enUS','Your people... your worlds... always crumble.','',26124),
(130004,'enUS','Oh, hello, we\'re not done setting up yet.\n\nIf you\'re looking for something a bit more dead and metal than E.T.C., you\'re going to want to check this out.\n\nWould you mind spreading the word for us? It\'s a concert you\'re not going to want to miss!','',26124),
(130005,'enUS','I want to teleport to Harjatan.','I want to teleport to Harjatan the Bludger.',26124),
(130006,'enUS','I want to teleport to Mistress Sassz\'ine.','I want to teleport to Mistress Sassz\'ine.',26124),
(130007,'enUS','I want to teleport to Sisters of the Moon.','I want to teleport to Sisters of the Moon.',26124),
(130008,'enUS','I want to teleport to The Desolate Host.','I want to teleport to The Desolate Host.',26124),
(130009,'enUS','I want to teleport to Demonic Inquisition.','I want to teleport to Demonic Inquisition.',26124),
(130010,'enUS','I want to teleport to Maiden of Vigilance.','I want to teleport to Maiden of Vigilance.',26124),
(130011,'enUS','I want to teleport to the Fallen Avatar.','I want to teleport to the Fallen Avatar.',26124),
(130012,'enUS','I want to teleport to Kil\'jaeden.','I want to teleport to Kil\'jaeden.',26124),
(130013,'enUS','Light give me strength!','',26124),
(130014,'enUS','This day will be your last, demon!','',26124),
(130015,'enUS','|TINTERFACE\\ICONS\\SPELL_FEL_INCINERATE.BLP:20|t You have |cFFFF0000|Hspell:240209|h[Unstable Soul]|h|r!','|TINTERFACE\\ICONS\\SPELL_FEL_INCINERATE.BLP:20|t You have |cFFFF0000|Hspell:235117|h[Unstable Soul]|h|r!',26124),
(130016,'enUS','|TINTERFACE\\ICONS\\Ability_BossFelMagnaron_HandEmpowered.blp:20|t You have |cFFFF0000|Hspell:235271|h[Infusion]|h|r!','|TINTERFACE\\ICONS\\Ability_BossFelMagnaron_HandEmpowered.blp:20|t Maiden of Vigilance begins casting |cFFFF0000|Hspell:235271|h[Infusion]|h|r!',26124),
(130017,'enUS','','%s nocks her arrows with blinding speed.',26124),
(130018,'enUS','No! No more running! No more hiding! I must finish this!','',26124),
(130019,'enUS','Velen! Stop!','',26124),
(130020,'enUS','Sealing the portal buys us nothing, archmage. Whether it takes a few years or millennia, the Legion will return. Over and over again, until too few of us remain to fight them.','',26124),
(130021,'enUS','It is time to seize our fate. We must use the portal and follow the Deceiver into the abyss. It is the only way!','',26124),
(130022,'enUS','I agree. It is the only way. Go, champions! We have precious little time to save Velen and return before the portal closes.','',26124),
(130023,'enUS','Come. If we are to die in the Nether, we will take the Deceiver with us!','',26124),
(130024,'enUS','Azeroth\'s greatest champions await your arrival at Krasus\' Landing when you are ready.','',26124),
(130025,'enUS','NOT USED','',26124),
(130026,'enUS','','Left!',26124),
(130027,'enUS','','I have made a habit of saving you from the grasp of demons.',26124),
(130028,'enUS','Light\'s Chosen, salute!','',26124),
(130029,'enUS','','Are you alright, Turalyon?',26124),
(130033,'enUS','This battle shall be your last!','',26124),
(130034,'enUS','Facility lockdown confirmed. Engaging threat.','',26124),
(130035,'enUS','Your crusade is ended!','',26124),
(130036,'enUS','Mark an enemy, and I will strike it down!','',26124),
(130037,'enUS','The Legion comes! We must protect our homes!','The Legion comes! We must protect our homes!',26124),
(130038,'enUS','The demons will never get past us! For the wilds!','The demons will never get past us! For the wilds!',26124),
(130039,'enUS','By fang and claw, I\'ll stop them!','By fang and claw, I\'ll stop them!',26124),
(130040,'enUS','Bandu thoribas!','Bandu thoribas!',26124),
(130041,'enUS','Tor ilisar\'thera\'nal!','Tor ilisar\'thera\'nal!',26124),
(130042,'enUS','Be wary, champions! Behold a vision of what is to come!','',26124),
(130043,'enUS','Find me, champions, and I will grant you sight!','',26124),
(130044,'enUS','Obliteration beckons!','',26124),
(130045,'enUS','Death rains upon you!','',26124),
(130046,'enUS','Smolder! Suffer!','',26124),
(130047,'enUS','Consume them all!','',26124),
(130048,'enUS','Who will share your fate?','',26124),
(130049,'enUS','I will cut you down myself!','',26124),
(130050,'enUS','Be careful, $ct. Demons are out there on the prowl.','Be careful, $ct. Demons are out there on the prowl.',26124),
(130051,'enUS','Give in to your fears! Your desires!','',26124),
(130052,'enUS','Face your destiny!','',26124),
(130053,'enUS','We are ready to depart, Prophet Velen.','',26124),
(130054,'enUS','Your lives are petty and insignificant! We are eternal!','',26124),
(130055,'enUS','Velen\'s defiance so long ago paved the way for your downfall.','',26124),
(130056,'enUS','Every world that resisted us has fallen.','',26124),
(130057,'enUS','The Burning Legion has come for your souls!','',26124),
(130058,'enUS','Your fate will be no different than all the rest!','',26124),
(130059,'enUS','Give up! There is still time to join us and serve the master!','',26124),
(130060,'enUS','I\'ll get you to those ships, heroes! Take them out, before the Deceiver grows stronger!','',26124),
(130061,'enUS','Slaughter the mortals and bring me their broken corpses!','',26124),
(130062,'enUS','Feel the chaos consume you!','',26124),
(130063,'enUS','Limitless destruction is at my command!','',26124),
(130064,'enUS','Your souls will soon know oblivion!','',26124),
(130065,'enUS','The leader of these naga has made a pact with the Legion, trading her people\'s lives for power. The fools go willingly, unaware of the price they must pay. Show them.','',26124),
(130066,'enUS','The naga must learn that any bargain made with the Legion will end in pain.','',26124),
(130067,'enUS','','Greetings, $c. I must complete my research.\n\nWill you aid me?',26124),
(130068,'enUS','Tonight we dine on mortal flesh!','',26124),
(130069,'enUS','Begin confrontation with Gharsul the Remorseless.','Begin confrontation with Gharsul the Remorseless.',26124),
(130070,'enUS','I\'m ready to face Tugar Bloodtotem. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','I\'m ready to face Tugar Bloodtotem. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',26124),
(130071,'enUS','Argus! My beloved homeworld... what have they done to you?','',26124),
(130072,'enUS','Send me to Shadowsong. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','Send me to Shadowsong. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',26124),
(130073,'enUS','Fall into darkness!','',26124),
(130074,'enUS','Give in! Let it take you!','',26124),
(130076,'enUS','Let the shadows win!','',26124),
(130077,'enUS','Take me to Agatha... (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','Take me to Agatha... (100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',26124),
(130078,'enUS','Take me to Agatha... |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','Take me to Agatha... |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',26124),
(130080,'enUS','I\'m ready to take on Xylem. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','I\'m ready to take on Xylem. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',26124),
(130082,'enUS','I\'m ready to face Raest. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','I\'m ready to face Raest. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',26124),
(130083,'enUS','I\'m ready to face Kruul. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','I\'m ready to face Kruul. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',26124),
(130084,'enUS','I\'m ready to face Sigryn. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)','I\'m ready to face Sigryn. |cFFFF0000(100 Nethershards |TINTERFACE\\ICONS\\inv_datacrystal01.blp\n:16|t)',26124),
(130085,'enUS','','We\'re under attack from the land and the sky, watch your head!',26124),
(130086,'enUS','','The Legion will never defeat us!',26124),
(130087,'enUS','Severe the heads from their mortal bodies!','',26124),
(130088,'enUS','','The Legion promises us strength, greater than even Lady Azshara can provide!',26124),
(130089,'enUS','','The naga will prevail...',26124),
(130090,'enUS','I willingly serve the Legion.','I willingly serve the Legion.',26124),
(130091,'enUS','My soul for the power of the fel!','My soul for the power of the fel!',26124),
(130092,'enUS','Give yourself to the Legion.','Give yourself to the Legion.',26124),
(130094,'enUS','We sent Minerva ahead to scout. Take the Death Gate and meet her in the citadel.','',26124),
(130095,'enUS','Use |TInterface\\Icons\\SPELL_SHADOW_ENSLAVEDEMON.BLP:20|t |cFFFF0000|Hspell:111771|h[Enslave Demon]|h|r to subdue the Wrathsteed!','Use |TInterface\\Icons\\spell_warlock_demonicportal_green.blp:20|t |cFFFF0000|Hspell:111771|h[Demonic Portal]|h|r to get past Ariden\'s barrier!',26124),
(130097,'enUS','The Legion seeks to extend its fiery reach. We would appreciate your aid in extinguishing this threat, commander.','',26124),
(130098,'enUS','Ha! Smoked them! Will I be fired for this? One has to keep up one\'s spirits somehow. Well done, champion, as usual.','',26124),
(130100,'enUS','','These beacons send requests for backup directly to the Sentinax. That could be dangerous.',26124),
(130101,'enUS','','However, if you\'re looking for a fight -- or, if you\'re looking for nethershards -- using these beacons might not be a bad idea.',26124),
(130102,'enUS','','Just be careful, $n. Too many reinforcements from the Sentinax, and you might find yourself in a fight that you can\'t win...',26124),
(130103,'enUS','My people have been waiting for this day.','',26124),
(130104,'enUS','We have been waiting so long for this day.','',26124),
(130105,'enUS','I am ready.','I am ready.',26124),
(130106,'enUS','L\'ura...','',26124),
(130107,'enUS','How will we get to Argus in one piece with the Legion bearing down on us like this?','',26124),
(130108,'enUS','My artificers have been preparing for that for quite some time.','',26124),
(130109,'enUS','Behold the triumph of the draenei--the Exodar!','',26124),
(130110,'enUS','<Dog wags its tail, trying very hard to stay seated and not jump on you. It\'s happy to see you again after so long.>','',26124),
(130111,'enUS','<Dog sniffs the stone and licks your hand reassuringly.>','',26124),
(130112,'enUS','<Show the stone from Dalaran\'s streets to the dog.>','<Show the stone from Dalaran\'s streets to the dog.>',26124),
(130113,'enUS','<Dog\'s coat is gleaming, and it looks quite healthy. Breanni is clearly taking very good care of it.>\n\n<But how did it get here?>','',26124),
(130114,'enUS','Culling the numbers of those vile worms helps restore the balance on these shores. You have my thanks, hero.','',26124),
(130115,'enUS','Hey buddy, don\'t you know better than to interrupt a performer during his show?','',26124),
(130116,'enUS','Minions of the flame! Feast upon their flesh!','',26124),
(130117,'enUS','I am. In no small part thanks to our friend here. But Alleria... there\'s something else.','',26124),
(130118,'enUS','Do... not... give in!','',26124),
(130122,'enUS','I only deal with the most elite gladiators.','I only deal with the most elite gladiators.',26124),
(130123,'enUS','I would like to look at your wares.','I would like to look at your wares.',26124),
(130124,'enUS','You again?\n\nLook, I don\'t come to your place and tell you how to $c, so why don\'t you just scram?','',26124),
(130125,'enUS','WARNING: ENEMY DETECTED','WARNING: ENEMY DETECTED',26124),
(130126,'enUS','Could you be quiet?','Could you be quiet?',26124),
(130127,'enUS','Actually, I\'d like to watch your show.','Actually, I\'d like to watch your show.',26124),
(130128,'enUS','Kick! Punch! Burn!','',26124),
(130129,'enUS','REAVER HAS ARRIVED','REAVER HAS ARRIVED',26124),
(130133,'enUS','When you are ready to depart, Battlelord, this portal will return you to Skyhold.','',26124),
(130134,'enUS','The Earthmother is with you, hero! Step within the circle of totems and obtain her blessing.','The Earthmother is with you, hero! Step within the circle of totems and obtain her blessing.',26124),
(130135,'enUS','It certainly wasn\'t easy, but we were able to procure you a piece of equipment for your Champions of the highest quality.\n\nUnfortunately our supplies are extremely limited, so we must be careful with how many we pass out.','',26124),
(130136,'enUS','The Crown was a conduit. A unifying force. We each carried but one part of the whole.','',26124),
(130137,'enUS','My brothers abandoned their shards when Sargeras arrived. They are still here, in Mac\'Aree.','',26124),
(130138,'enUS','With the Crown once more in our possession we can avoid the Xenedar\'s fate.','',26124),
(130139,'enUS','Ages ago I stood on this very spot and called the Draenei to me. It is here I will seek the other fragments.','',26124),
(130141,'enUS','We leave the protection of the barrier behind. Remain on guard, my friend.','',26124),
(130142,'enUS','May the Light guide my sight. Pheta vi acahachi.','',26124),
(130143,'enUS','<Half-heard prayers.>','',26124),
(130144,'enUS','I do not understand. Why can I not sense them?','',26124),
(130145,'enUS','<Strained breathing.>','',26124),
(130146,'enUS','Acheon phetar, give me the clarity I seek. Show me where they are!','',26124),
(130147,'enUS','<Pained groan.>','',26124),
(130148,'enUS','Such... darkness!','',26124),
(130149,'enUS','<Velen cries out.>','',26124),
(130150,'enUS','Such terrible darkness!','',26124),
(130151,'enUS','<Velen gasps for air.>','',26124),
(130152,'enUS','I- I cannot... see...','',26124),
(130153,'enUS','Are you read to proceed, my friend?','',26124),
(130154,'enUS','Yes, Prophet.','Yes, Prophet.',26124),
(130155,'enUS','Something is desperately wrong here. I fear my power alone will not be enough.','',26124),
(130156,'enUS','<Shawn looks at you expectantly>','',26124),
(130157,'enUS','Is it you?!  The person I\'ve been dreaming about?!','',26124),
(130158,'enUS','Before you ask, I don\'t know what this person looks like. In my first dream they were a night elf, in the second they were a tauren, and in the third a night elf again. In these dreams we\'d adventure across Azeroth and Draenor fighting demons, dragons, old gods, and even murlocs! \n\nI\'d never had a connection like this before.  It seemed so real to me.  In my last dream, I asked them to meet me here.','',26124),
(130159,'enUS','I\'ll keep waiting, I know they\'ll come!','',26124),
(130160,'enUS','Are you?... You ARE!  I have so much to tell you!  Where do I get started? \n\nSince our first adventure, I could no longer focus on anything but when our next adventure would be.  My friends would tell me that you weren\'t real, that I was acting crazy, that you\'re only in the dream.  I knew they couldn\'t be right! The feelings I have are far more than a dream!\n\nEvery adventure we\'ve been on, every foe we\'ve slain, and every chat we\'ve had has brought me to one question for you...','',26124),
(130161,'enUS','I... I understand.','',26124),
(130162,'enUS','I don\'t have words... You\'ve made me the happiest person!  To our next adventure!','',26124),
(130163,'enUS','$n activated an Unstable Nether Portal in Cinder Run!','$n activated an Unstable Nether Portal in Cinder Run!',26124),
(130164,'enUS','$n activated an Unstable Nether Portal in Coast of Anguish!','$n activated an Unstable Nether Portal in Coast of Anguish!',26124),
(130165,'enUS','$n activated an Unstable Nether Portal in Crescent Ruins!','$n activated an Unstable Nether Portal in Crescent Ruins!',26124),
(130166,'enUS','$n activated an Unstable Nether Portal in Dark Stockades!','$n activated an Unstable Nether Portal in Dark Stockades!',26124),
(130167,'enUS','$n activated an Unstable Nether Portal in Deadwood Landing!','$n activated an Unstable Nether Portal in Deadwood Landing!',26124),
(130168,'enUS','$n activated an Unstable Nether Portal in Felbreach Hollow!','$n activated an Unstable Nether Portal in Felbreach Hollow!',26124),
(130169,'enUS','$n activated an Unstable Nether Portal in Feldust Cavern!','$n activated an Unstable Nether Portal in Feldust Cavern!',26124),
(130170,'enUS','$n activated an Unstable Nether Portal in Felfire Pass!','$n activated an Unstable Nether Portal in Felfire Pass!',26124),
(130171,'enUS','$n activated an Unstable Nether Portal in Felrage Strand!','$n activated an Unstable Nether Portal in Felrage Strand!',26124),
(130172,'enUS','$n activated an Unstable Nether Portal in Felsworn Vault!','$n activated an Unstable Nether Portal in Felsworn Vault!',26124),
(130173,'enUS','$n activated an Unstable Nether Portal in Foulshore Strip!','$n activated an Unstable Nether Portal in Foulshore Strip!',26124),
(130174,'enUS','$n activated an Unstable Nether Portal in Garrison of the Fel!','$n activated an Unstable Nether Portal in Garrison of the Fel!',26124),
(130175,'enUS','$n activated an Unstable Nether Portal in Impsorrow Approach!','$n activated an Unstable Nether Portal in Impsorrow Approach!',26124),
(130176,'enUS','$n activated an Unstable Nether Portal in Jagged Cove!','$n activated an Unstable Nether Portal in Jagged Cove!',26124),
(130177,'enUS','$n activated an Unstable Nether Portal in Moonlight Ascent!','$n activated an Unstable Nether Portal in Moonlight Ascent!',26124),
(130178,'enUS','$n activated an Unstable Nether Portal in Path of Suffering!','$n activated an Unstable Nether Portal in Path of Suffering!',26124),
(130179,'enUS','$n activated an Unstable Nether Portal in Screaming Cliffs!','$n activated an Unstable Nether Portal in Screaming Cliffs!',26124),
(130180,'enUS','$n activated an Unstable Nether Portal in Soldier\'s Torment!','$n activated an Unstable Nether Portal in Soldier\'s Torment!',26124),
(130181,'enUS','$n activated an Unstable Nether Portal in Soul Ruin!','$n activated an Unstable Nether Portal in Soul Ruin!',26124),
(130182,'enUS','$n activated an Unstable Nether Portal in Strand\'s End!','$n activated an Unstable Nether Portal in Strand\'s End!',26124),
(130183,'enUS','$n activated an Unstable Nether Portal in the Creeping Grotto!','$n activated an Unstable Nether Portal in the Creeping Grotto!',26124),
(130184,'enUS','$n activated an Unstable Nether Portal in the Twisted Grounds!','$n activated an Unstable Nether Portal in the Twisted Grounds!',26124),
(130185,'enUS','$n activated an Unstable Nether Portal in the Weeping Terrace!','$n activated an Unstable Nether Portal in the Weeping Terrace!',26124),
(130186,'enUS','$n activated an Unstable Nether Portal in Shadow Fracture!','$n activated an Unstable Nether Portal in Shadow Fracture!',26124),
(130187,'enUS','$n activated an Unstable Nether Portal in Wrynfall!','$n activated an Unstable Nether Portal in Wrynfall!',26124),
(130188,'enUS','...','...',26124),
(130189,'enUS','I hope you find them.','I hope you find them.',26124),
(130190,'enUS','I\'ve had the same dreams about you!','I\'ve had the same dreams about you!',26124),
(130191,'enUS','Yes!','Yes!',26124),
(130192,'enUS','I\'m sorry, I just can\'t...','I\'m sorry, I just can\'t...',26124),
(130193,'enUS','Champion, I bring you the favor of Eyir! Approach and obtain her blessing.','Champion, I bring you the favor of Eyir! Approach and obtain her blessing.',26124),
(130194,'enUS','Champion, I bring you a gift from Prince Farondis. My spells will allow you to be stronger, deft, and more powerful for a while. Approach and receive your boon.','Champion, I bring you a gift from Prince Farondis. My spells will allow you to be stronger, deft, and more powerful for a while. Approach and receive your boon.',26124),
(130195,'enUS','How can I help?','How can I help?',26124),
(130196,'enUS','What is your wish?','',26124),
(130197,'enUS','','Some of the protective spells have fragmented and begun to fade. It pains me to suggest it, but I think you might be able to catch the fragments with a fishing pole.',26124),
(130198,'enUS','','Beautiful isn\'t it? Can you feel its power flowing through you, pulsing as it disrupts the very world around us? I can bend that power to my will if you like...',26124),
(130199,'enUS','Take me to the Trial of Style!','Take me to the Trial of Style!',26124),
(130200,'enUS','','Thank you, $n! This is exactly what I need.',26124),
(130201,'enUS','<The portal hums with energy. Screams and other disturbing noises emanate from beyond.>\n\nReturn when you have more Nethershards.','',26124),
(130203,'enUS','Instructor, I don\'t think...','Instructor, I don\'t think...',26124),
(130204,'enUS','Uh... how did that incantation go again? Ru shallora... uh... um... abracadabra?','Uh... how did that incantation go again? Ru shallora... uh... um... abracadabra?',26124),
(130205,'enUS','Don\'t worry students, this demon is perfectly contained in the arcane matrix.','',26124),
(130206,'enUS','Now, if you had been listening in our last class you would know the incantation to cause it to explode in a ball of flame.','',26124),
(130207,'enUS','You there, show the class how the incantation goes.','',26124),
(130208,'enUS','Hurry up! We don\'t have all eternity to wait!','',26124),
(130209,'enUS','Will you adventure with me... forever?','',26124),
(130210,'enUS','Oh dear! This wasn\'t in the lesson plan!','',26124),
(130211,'enUS','Annihilate!','',26124),
(130212,'enUS','To arms, Nightwatchers! The Legion comes!','To arms, Nightwatchers! The Legion comes!',26124),
(130213,'enUS','The Nightwatch will never forsake our duty!','The Nightwatch will never forsake our duty!',26124),
(130214,'enUS','Bandu Thoribas!','Bandu Thoribas!',26124),
(130215,'enUS','Stand firm, Nightwatchers! Our enemies approach!','Stand firm, Nightwatchers! Our enemies approach!',26124),
(130216,'enUS','For Nar\'thalas!','For Nar\'thalas!',26124),
(130217,'enUS','Focus your attacks. I\'ll hold his attention.','',26124),
(130218,'enUS','','You cannot evade my volley!',26124),
(130219,'enUS','','My arrows strike true!',26124),
(130220,'enUS','Thank you, friend! As a reward have a bit of my power. May it help you against our foe.','',26124),
(130221,'enUS','Impus is making a boat. You help!','',26124),
(130223,'enUS','Farewell.','',26124),
(130224,'enUS','Impus is pleased with minion\'s work.','',26124),
(130225,'enUS','Catch seaweed with fishing pole! Give seaweed to Impus! No profit!','',26124),
(130226,'enUS','A ritual totem was lost in these waters many years ago when a lightning bolt shattered it. I seek to rebuild it so I may  honor my ancestors.','',26124),
(130227,'enUS','<Akule studies the fragments carefully.>\n\nYes, these are indeed part of the original totem. You have my thanks, $c.','',26124),
(130228,'enUS','I am collecting the hundreds, maybe thousands, of pieces from the shattered totem. You might have some luck finding them with a fishing pole.','',26124),
(130229,'enUS','The raven looks at you and tilts its head to the side.','',26124),
(130230,'enUS','Corbyn caws with delight.','',26124),
(130231,'enUS','The raven looks at some shiny pebbles near its feet, and then looks at water. You get the distinct feeling that you could retrieve them with a fishing pole.','',26124),
(130232,'enUS','','Before I was exiled, I was the aquarium keeper in the city. The life that exists in the tank is still my responsibility and I won\'t abandon them!',26124),
(130233,'enUS','','Splendid! Here, just put them in my enchanted globe of water, and I\'ll see to the rest.\n\n<Sha\'leth appears to be distracted watching the tiny fish.>',26124),
(130234,'enUS','','Oh! First and foremost, the koi in are starting to overcrowd. Maybe if you caught some of the minnows, I could release them into the rivers?\n\nBe careful of Magicus, the guardian of the aquarium.',26124),
(130235,'enUS','','The corruption chokes our waters and kills the natural life that once thrived there. We must fight back!',26124),
(130236,'enUS','','<She reaches out and takes the globules while keeping her head turned away in disgust.>\n\nThank you. I will enjoy destroying this.',26124),
(130237,'enUS','','No doubt you\'ve already been fighting back the monstrosities that invade our forest. But if we could extract the more... viscous... corruption from the water itself, that would be a great victory as well! I suggest trying a fishing pole.',26124),
(130238,'enUS','You will pay for your transgressions, warlock!','',26124),
(130239,'enUS','I will crush you, insect!','',26124),
(130240,'enUS','The dreadsteeds are mine, warlock... Mine!','',26124),
(130241,'enUS','Xoroth wil not be... defeated...','',26124),
(130242,'enUS','','Help! Their trying to get at my supplies!',26124),
(130243,'enUS','','Thank you so much! Please, have this chest from the cache. You\'ve earned it!',26124),
(130244,'enUS','You have been spotted and an assassin has been dispatched.','You have been spotted and an assassin has been dispatched.',26124),
(130247,'enUS','Let\'s move.','',26124),
(130248,'enUS','Welcome to the Exodar, $p.','',26124),
(130249,'enUS','$p, it is time. Set course for Argus.','',26124),
(130250,'enUS','Test','',26124),
(130252,'enUS','I\'ve brought you this Armorcrafter\'s Commendation.','I\'ve brought you this Armorcrafter\'s Commendation.',26124),
(130253,'enUS','So you have! Very well, let\'s get started. I\'ll teach you all about the legendary armor you\'ve always dreamed of making!','',26124),
(130254,'enUS','Hold on just a moment, $n. Let\'s finish the armor we\'re already making first.','',26124),
(130255,'enUS','|TInterface\\Icons\\SPELL_FIRE_TWILIGHTFLAMEBREATH.BLP:20|t%s begins to cast |cFFFF0000|Hspell:233983|h[Echoing Anguish]|h|r!','|TInterface\\Icons\\SPELL_FIRE_TWILIGHTFLAMEBREATH.BLP:20|t%s begins to cast |cFFFF0000|Hspell:233983|h[Echoing Anguish]|h|r!',26124),
(130256,'enUS','Bl... Bless you... I... I\'ll live, thanks to you!','Bl... Bless you... I... I\'ll live, thanks to you!',26124),
(130257,'enUS','Please, take this as your reward.','Please, take this as your reward.',26124),
(130281,'enUS','I\'m here to inquire about the Tri-Disc of Fire.','I\'m here to inquire about the Tri-Disc of Fire.',26124),
(130292,'enUS','Ah yes, I do know where that is. Before Karazhan fell, Khadgar and I had done a bit of research on it back in my sanctum, where it still resides. I\'m afraid we didn\'t have time to learn very much about it.$b$bNormally, it would be trivial to travel to my sanctum, but I\'m afraid the demons in this cellar stand between us and the portal to it.$b$bFight your way through the cellar and you\'ll find the portal to at the far end. The tri-disc should still be there.','',26124),
(130311,'enUS','','Hmmmm....? Hmmmm.',26124),
(130312,'enUS','','Oh, you are cute, but I am already under contract.',26124),
(130314,'enUS','','Oh, what delicious morals you have.',26124),
(130316,'enUS','','Ooo... I am so cold. Would you be a dear and set yourself on fire for me?',26124),
(130319,'enUS','','<Just winks a lot.>',26124),
(130331,'enUS','Freedom is mine! Your suffering for this insult will be legendary, elf!','',26124),
(130332,'enUS','','Ooo, a scribe? I do love it when someone writes down my little... dominations. I might know a little secret. A dark secret.\n\nDo you kiss and tell? Because I do.',26124),
(130333,'enUS','Do you have something for sale?','Do you have something for sale?',26124),
(130334,'enUS','Pretty bird want shiny gold coins?','Pretty bird want shiny gold coins?',26124),
(130335,'enUS','Bless Elune! Thank you, hero!','',26124),
(130336,'enUS','You deserve a reward! Here, I hope this will be of use to you.','',26124),
(130337,'enUS','','Mmm... I do love a good scribe. Be sure to stay... in touch.',26124),
(130338,'enUS','For the rest of you, let\'s back to the academy. Clearly you all need a few hundred years of further instruction.','',26124),
(130341,'enUS','Now, most importantly: we must decide what type of armor you want to craft. Choose carefully - your commendation only earns you one lesson.','',26124),
(130342,'enUS','I want to make tailored shoulders.\n|TINTERFACE\\ICONS\\INV_SHOULDER_CLOTH_RAIDWARLOCK_L_01.BLP:32|t\n|Hitem:146666:0:0:0:0:0:0:0:110:0|h[Celumbra, the Night\'s Dichotomy]|h','I want to make tailored shoulders.\n|TINTERFACE\\ICONS\\INV_SHOULDER_CLOTH_RAIDWARLOCK_L_01.BLP:32|t\n|Hitem:146666:0:0:0:0:0:0:0:110:0|h[Celumbra, the Night\'s Dichotomy]|h',26124),
(130343,'enUS','I want to make leather boots.\n|TINTERFACE\\ICONS\\INV_Leather_RaidDemonHunterMythic_Q_02Boots.blp:32|t\n|Hitem:146669:0:0:0:0:0:0:0:110:0|h[The Sentinel\'s Eternal Refuge]|h','I want to make leather boots.\n|TINTERFACE\\ICONS\\INV_Leather_RaidDemonHunterMythic_Q_02Boots.blp:32|t\n|Hitem:146669:0:0:0:0:0:0:0:110:0|h[The Sentinel\'s Eternal Refuge]|h',26124),
(130344,'enUS','I want to make chain mail gloves.\n|TINTERFACE\\ICONS\\INV_GAUNTLETS_PLATE_RAIDPALADIN_I_01.BLP:32|t\n|Hitem:146668:0:0:0:0:0:0:0:110:0|h[Vigilance Perch]|h','I want to make chain mail gloves.\n|TINTERFACE\\ICONS\\INV_GAUNTLETS_PLATE_RAIDPALADIN_I_01.BLP:32|t\n|Hitem:146668:0:0:0:0:0:0:0:110:0|h[Vigilance Perch]|h',26124),
(130345,'enUS','I want to make a plate belt.\n|TINTERFACE\\ICONS\\INV_Plate_DraenorCrafted_D_01Buckle.blp:32|t\n|Hitem:146667:0:0:0:0:0:0:0:110:0|h[Rethu\'s Incessant Courage]|h','I want to make a plate belt.\n|TINTERFACE\\ICONS\\INV_Plate_DraenorCrafted_D_01Buckle.blp:32|t\n|Hitem:146667:0:0:0:0:0:0:0:110:0|h[Rethu\'s Incessant Courage]|h',26124),
(130346,'enUS','Are you certain this is what you want to make? You can only choose one legendary item to craft with this Armorcrafter\'s Commendation.','Are you certain this is what you want to make? You can only choose one legendary item to craft with this Armorcrafter\'s Commendation.',26124),
(130347,'enUS','Ha ha! Stupid frozen ogre.','',26124),
(130348,'enUS','Ogre popsicle! Ha!','',26124),
(130349,'enUS','Me LOVE this cold backpack! Ha ha!','',26124),
(130350,'enUS','You there! Won\'t you help us testing flying in the Broken Isles?\n\nTo sweeten the deal, I\'ll also grant you your class mount quest!\n\nWhat do you say?','',26124),
(130351,'enUS','Yes! Grant me Broken Isles Pathfinder I and II and my class mount finale!','Yes! Grant me Broken Isles Pathfinder I and II and my class mount finale!',26124),
(130354,'enUS','|TInterface\\Icons\\SPELL_WARLOCK_SOULBURN:20|t%s targets you with |cFFFF0000|Hspell:236011|h[Tormented Cries]|h|r!','',26124),
(130355,'enUS','|TInterface\\Icons\\spell_hunter_lonewolf:20|t %s begins to cast |cFFFF0404|Hspell:241772|h[Unearthly Howl]|h|r!','',26124),
(130356,'enUS','','Prophet!',26124),
(130357,'enUS','','You are not safe here. We need to move. Now.',26124),
(130358,'enUS','Alleria?','',26124),
(130359,'enUS','','Forgive me, Velen. I will explain when there is time.',26124),
(130360,'enUS','LEGION ASSASSINS HAVE BEEN KILLED. YOU ARE SAFE... FOR NOW.','LEGION ASSASSINS HAVE BEEN KILLED. YOU ARE SAFE... FOR NOW.',26124),
(130362,'enUS','|TINTERFACE\\ICONS\\SPELL_FIRE_FELPYROBLAST.blp:20|t The Fallen Avatar casts |cFFFF0404|Hspell:234418|h[Rain of the Destroyer]|h|r!','|TINTERFACE\\ICONS\\SPELL_FIRE_FELPYROBLAST.blp:20|t The Fallen Avatar casts |cFFFF0404|Hspell:234418|h[Rain of the Destroyer]|h|r!',26124),
(130367,'enUS','The Broken Shore is a shattered, desolate land. I now realize how necessary it was for me to see this for myself.','',26124),
(130368,'enUS','You... will not... break us.','',26124),
(130369,'enUS','This pain... is only temporary.','',26124),
(130370,'enUS','Our will... cannot be shattered.','',26124),
(130371,'enUS','Krona ki cristorr!','',26124),
(130373,'enUS','Pheta vi hylas.','',26124),
(130374,'enUS','%s writhes in pain.','%s writhes in pain.',26124),
(130375,'enUS','%s struggles as pain wracks their body.','%s struggles as pain wracks their body.',26124),
(130376,'enUS','The Broken Shore.','The Broken Shore.',26124),
(130377,'enUS','Too late! I already took the good stuff!','',26124),
(130378,'enUS','You again? You can\'t have my treasure!','',26124),
(130379,'enUS','Haha! Too late, mortal!','',26124),
(130380,'enUS','Argh! What\'s in the box?! What was in it?!','',26124),
(130390,'enUS','I... I can\'t find my body. I was trapped inside the soul engine and now... where is it? What happened to me?!','I... I can\'t find my body. I was trapped inside the soul engine and now... where is it? What happened to me?!',26124),
(130391,'enUS','Where am I? I was fighting on the Broken Shore... can you hear me? By the gods... am I... dead?','Where am I? I was fighitng on the Broken Shore... can you hear me? By the gods... am I... dead?',26124),
(130392,'enUS','No, I can\'t be dead! I have a family... I can\'t leave them behind! How will they survive without me?','No, I can\'t be dead! I have a family... I can\'t leave them behind! How will they survive without me?',26124),
(130393,'enUS','Find your way into the Light, my friend. The time has come for you to rest.','Find your way into the Light, my friend. The time has come for you to rest.',26124),
(130394,'enUS','Do you have any rare demonic trinkets in that sack?','Do you have any rare demonic trinkets in that sack?',26124),
(130395,'enUS','Nothing right now.','Nothing right now.',26124),
(130396,'enUS','Have you tracked down any rare finds?','Have you tracked down any rare finds?',26124),
(130397,'enUS','|TInterface\\Icons\\Ability_Socererking_arcanemines:20|t%s creates a |cFFFF0000|Hspell:235059|h[Rupturing Singularity]|h|r!','|TInterface\\Icons\\Ability_Socererking_arcanemines:20|t%s creates a |cFFFF0000|Hspell:235059|h[Rupturing Singularity]|h|r!',26124),
(130398,'enUS','|TInterface\\Icons\\SPELL_FIRE_FELRAINOFFIRE:20|t%s is casting |cFFFF0000|Hspell:240910|h[Armageddon]|h|r!','|TInterface\\Icons\\SPELL_FIRE_FELRAINOFFIRE:20|t%s is casting |cFFFF0000|Hspell:240910|h[Armageddon]|h|r!',26124),
(130399,'enUS','|TInterface\\ICONS\\INV_Artifact_PoweroftheDarkSide.blp:20|t The Fallen Avatar summons forth |cFFFF0404|Hspell:242017|h[Black Winds]|h|r!','|TInterface\\ICONS\\INV_Artifact_PoweroftheDarkSide.blp:20|t The Fallen Avatar summons forth |cFFFF0404|Hspell:242017|h[Black Winds]|h|r!',26124),
(130400,'enUS','Treasure Master Iks\'reeged makes a rude gesture at you.','',26124),
(130401,'enUS','Have you risen any interesting creatures recently?','Have you risen any interesting creatures recently?',26124),
(130402,'enUS','I\'ve dreamt of this moment for so long, but not once did I imagine it being so... beautiful.','I\'ve dreamt of this moment for so long, but not once did I imagine it being so... beautiful.',26124),
(130403,'enUS','At last the time has come! The final journey is upon us!','At last the time has come! The final journey is upon us!',26124),
(130404,'enUS','Open your arms and embrace what lies before you!','Open your arms and embrace what lies before you!',26124),
(130405,'enUS','Look to the skies! A great destiny is revealed before us!','Look to the skies! A great destiny is revealed before us!',26124),
(130406,'enUS','A great truth reveals itself!','A great truth reveals itself!',26124),
(130408,'enUS','Material goods cannot save you, $n!','Material goods cannot save you, $n!',26124),
(130409,'enUS','Possessions are meaningless! Look to the sky! The end is upon us!','Possessions are meaningless! Look to the sky! The end is upon us!',26124),
(130410,'enUS','This place offers only empty promises! Wealth cannot save you!','This place offers only empty promises! Wealth cannot save you!',26124),
(130411,'enUS','Open your eyes, $n! Only lies await you inside. The truth is in the skies!','Open your eyes, $n! Only lies await you inside. The truth is in the skies!',26124),
(130412,'enUS','Marvel at its glory! You cannot hide from the inevitable!','Marvel at its glory! You cannot hide from the inevitable!',26124),
(130413,'enUS','We strike this beast down together.','',26124),
(130414,'enUS','','Welcome to the Trial of Style: Azeroth\'s finest fashion destination!',26124),
(130415,'enUS','','Hurry, High Inquisitor! The enemy is upon us!',26124),
(130416,'enUS','I hope you brought your wardrobe with you, because today\'s competition looks FIERCE!','',26124),
(130417,'enUS','','The theme of today\'s competition is... Summer Styles!',26124),
(130418,'enUS','Ooh, I do love a good pair of shorts.','',26124),
(130419,'enUS','','Take the next few moments to prepare your costume.',26124),
(130420,'enUS','','We\'ve also provided barber chairs, in case you need to touch up your hairdo.',26124),
(130421,'enUS','The competition starts in two minutes. Good luck, good-looking!','',26124),
(130422,'enUS','','$ct, the Felskorn alchemists in this area have been getting more aggressive of late. They recently stole a shipment of our brew. Worse, it appears that they have modified it to enhance themselves and are now spewing it from their spreaders!\n\nThey need to be stopped, but it will not be easy without help. Fortunately the Monkey King loaned us his vaulting staff. Use it to jump over their heads and rain death from above!\n\nWill you help?',26124),
(130423,'enUS','I\'m ready!','I\'m ready!',26124),
(130424,'enUS','|TInterface\\Icons\\ABILITY_WARLOCK_INFERNO.BLP:20|t%s has targeted you with |cFFFF0000|Hspell:238430|h[Bursting Dreadflame]|h|r!','|TInterface\\Icons\\ABILITY_WARLOCK_INFERNO:20|t%s has targeted you with |cFFFF0000|Hspell:238430|h[Bursting Dreadflame]|h|r!',26124),
(130425,'enUS','','The Burning Legion closes in on Azeroth. We must all do our part!',26124),
(130426,'enUS','Please... never forget us. Never forget our sacrifice...','Please... never forget us. Never forget our sacrifice...',26124),
(130427,'enUS','Thank you. I will never forget this kindness...','Thank you. I will never forget this kindness...',26124),
(130428,'enUS','At last, this nightmare is at an end...','At last, this nightmare is at an end...',26124),
(130429,'enUS','It was an honor to serve my king...','It was an honor to serve my king...',26124),
(130430,'enUS','I can see it... I can see the Light... thank you.','I can see it... I can see the Light... thank you.',26124),
(130431,'enUS','','To your left, the fabulous $n!',26124),
(130432,'enUS','It was an honor to serve Stormwind... to serve my king!','It was an honor to serve Stormwind... to serve my king!',26124),
(130433,'enUS','Thank you for this kindness. I will never forget you...','Thank you for this kindness. I will never forget you...',26124),
(130434,'enUS','And on the right, the inimitable $n!','',26124),
(130435,'enUS','','Our third place finisher is... $n! Congratulations, $n!',26124),
(130436,'enUS','In second place, we have... $n! You looked fabulous up there!','',26124),
(130437,'enUS','','And finally, our grand transmog champion of the evening. Let\'s hear it for $n!',26124),
(130438,'enUS','','Everybody else, keep trying. You\'ll be a champion soon.',26124),
(130439,'enUS','','That\'s all for today. See you next time!',26124),
(130440,'enUS','What happened to me? Where is my body?','What happened to me? Where is my body?',26124),
(130441,'enUS','I don\'t want to die...','I don\'t want to die...',26124),
(130442,'enUS','Where am I? I can\'t remember where I am...','Where am I? I can\'t remember where I am...',26124),
(130443,'enUS','Please... make the nightmare stop!','Please... make the nightmare stop!',26124),
(130444,'enUS','I can\'t be dead... someone please help me...','I can\'t be dead... someone please help me...',26124),
(130445,'enUS','If I\'m dead, who will take care of my family?','If I\'m dead, who will take care of my family?',26124),
(130446,'enUS','Come on, let me fight too!','',26124),
(130447,'enUS','','Oro Junior, stay back there! Your father would be heartbroken if anything were to happen to you.',26124),
(130448,'enUS','But mom, you\'re letting Mycah fight!','',26124),
(130449,'enUS','Don\'t worry little bro, if we get through this then when you\'re older I\'ll teach you how to swing a knife like dad taught me. Deal?','',26124),
(130450,'enUS','Deal! You better not forget!','',26124),
(130452,'enUS','','The theme of today\'s competition is... Winter Wear!',26124),
(130453,'enUS','','The theme of today\'s competition is... Ready for Battle!',26124),
(130454,'enUS','','The theme of today\'s competition is... Fun and Flirty!',26124),
(130455,'enUS','','The theme of today\'s competition is... Mismatched Mayhem!',26124),
(130456,'enUS','','The theme of today\'s competition is... Fire and Ice!',26124),
(130457,'enUS','','The theme of today\'s competition is... Dark and Deadly!',26124),
(130458,'enUS','','The theme of today\'s competition is... Faction Pride!',26124),
(130459,'enUS','','The theme of today\'s competition is... Primal Style!',26124),
(130460,'enUS','','The theme of today\'s competition is... Heroes of Azeroth!',26124),
(130461,'enUS','','The theme of today\'s competition is... Make Me Laugh!',26124),
(130462,'enUS','','The theme of today\'s competition is... Tabard Time!',26124),
(130463,'enUS','','The theme of today\'s competition is... Everyday Heroes!',26124),
(130464,'enUS','','The theme of today\'s competition is... Epic Purples!',26124),
(130465,'enUS','','The theme of today\'s competition is... Champions of the Light!',26124),
(130466,'enUS','','The theme of today\'s competition is... Freestyle!',26124),
(130467,'enUS','Bundle up! Let\'s see what you wear on the frozen shores of Northrend!','',26124),
(130468,'enUS','Take off that makeup and put on that war paint!','',26124),
(130469,'enUS','Be still my heart! Don\'t be afraid to show a little skin!','',26124),
(130470,'enUS','Have a little fun and put together the most garish ensemble you can dream up!','',26124),
(130471,'enUS','Frighten the fashion out of us with your creepiest costumes. Oooh... I\'m getting chills already!','',26124),
(130472,'enUS','Show us your more sinister styles!','',26124),
(130473,'enUS','For the Horde! For the Alliance! Let\'s see your team colors.','',26124),
(130474,'enUS','Pandarian fashion just SCREAMS harmoniousness. Show us your inner peace!','',26124),
(130475,'enUS','Show us your sparkles with your most wizardly wear! And don\'t forget the enchantments!','',26124),
(130476,'enUS','It\'s time to have fun and get a little crazy with your costumes!','',26124),
(130477,'enUS','Will you represent Theramore? The Kirin Tor? Talk to Nellie if you need a spare tabard!','',26124),
(130478,'enUS','Will you be a farmer? A chef? A scientist? A pirate? Ooh... I can\'t WAIT to see what they come up with!','',26124),
(130479,'enUS','As you know, epic armor is ALWAYS purple. Wrap yourselves up in the bottom of the rainbow!','',26124),
(130480,'enUS','Pristine white robes and glimmering armor are the order of the day!','',26124),
(130481,'enUS','That\'s right... today\'s contest has no theme. Wear whatever you want!','',26124),
(130482,'enUS','Over here, $p. Keep your head down.','',26124),
(130483,'enUS','Insolent mortal! Come... face your death!','',26124),
(130496,'enUS','I will feast upon your soul.','',26124),
(130497,'enUS','Crunchy bones. So brittle and tasty!','',26124),
(130498,'enUS','Your supple flesh will satisfy my hunger!','',26124),
(130499,'enUS','Feeble and weak! You dare enter our lair?','',26124),
(130500,'enUS','You will kneel or you will die!','',26124),
(130501,'enUS','Our chains hunger for your flesh!','',26124),
(130502,'enUS','Your flesh will fuel these pits for eternity!','',26124),
(130503,'enUS','More flesh for the taking!','',26124),
(130504,'enUS','Whatever happens, we stand together.','',26124),
(130505,'enUS','Why can\'t I research Artifact Knowledge?','Why can\'t I research Artifact Knowledge?',26124),
(130506,'enUS','The Orders are sharing their resources, and you are no longer required to research Artifact Knowledge. We will gain further Knowledge each week.','The Orders are sharing their resources, and you are no longer required to research Artifact Knowledge. We will gain further Knowledge each week.',26124),
(130507,'enUS','We have reached the maximum Artifact Knowledge available to us at this time.','We have reached the maximum Artifact Knowledge available to us at this time.',26124),
(130508,'enUS','Archmage Khadgar has a lead on how we can continue our artifact knowledge research. Seek him out at Deliverance Point on the Broken Shore.','Archmage Khadgar has a lead on how we can continue our artifact knowledge research. Seek him out at Deliverance Point on the Broken Shore.',26124),
(130509,'enUS','I have all the tools necessary to adjust the appearance of your weapons and armor.\n\nShall we begin?','',26124),
(130510,'enUS','I want to transmogrify my gear.','I want to transmogrify my gear.',26124),
(130511,'enUS','We can currently obtain Artifact Knowledge for you as quickly as you can bring me the resources required to produce them.','We can currently obtain Artifact Knowledge for you as quickly as you can bring me the resources required to produce them.',26124),
(130512,'enUS','I want to participate in the Trial of Style!','I want to participate in the Trial of Style!',26124),
(130513,'enUS','Sound effect for troops','Sound effect for troops',26124),
(130514,'enUS','Sound effect for troops','',26124),
(130515,'enUS','','Sound effect for troops',26124),
(130516,'enUS','Sound effect for troops','',26124),
(130517,'enUS','','Sound effect for troops',26124),
(130518,'enUS','Sound effect for troops','Sound effect for troops',26124),
(130519,'enUS','Sound effect for troops','Sound effect for troops',26124),
(130520,'enUS','Sound effect for troops','Sound effect for troops',26124),
(130521,'enUS','Sound effect for troops','Sound effect for troops',26124),
(130522,'enUS','Sound effect for troops','Sound effect for troops',26124),
(130523,'enUS','Sound effect for troops','',26124),
(130524,'enUS','Sound effect for troops','Sound effect for troops',26124),
(130525,'enUS','Sound effect for troops','',26124),
(130526,'enUS','Sound effect for troops','Sound effect for troops',26124),
(130527,'enUS','We have reached the maximum Artifact Knowledge available to us at this time.','We have reached the maximum Artifact Knowledge available to us at this time.',26124),
(130528,'enUS','Archmage Khadgar has a lead on how we can continue our artifact knowledge research. Seek him out at Deliverance Point on the Broken Shore.','Archmage Khadgar has a lead on how we can continue our artifact knowledge research. Seek him out at Deliverance Point on the Broken Shore.',26124),
(130529,'enUS','We can currently obtain Artifact Knowledge for you as quickly as you can bring me the resources required to produce them.','We can currently obtain Artifact Knowledge for you as quickly as you can bring me the resources required to produce them.',26124),
(130530,'enUS','The Orders are sharing their resources, and you are no longer required to research Artifact Knowledge. We will gain further Knowledge each week.','The Orders are sharing their resources, and you are no longer required to research Artifact Knowledge. We will gain further Knowledge each week.',26124),
(130531,'enUS','','Your invasion of Argus will fail! High Inquisitor Raalgar will see to that.',26124),
(130532,'enUS','DO NOT RECORD','',26124),
(130533,'enUS','I can close my eyes to the atrocities of war no longer. I must see the threat of the Burning Legion for myself.','',26124),
(130534,'enUS','<Link the Vindicaar to the Light\'s Judgment weapon.>','<Link the Vindicaar to the Light\'s Judgment weapon.>',26124),
(130535,'enUS','The crystal launcher pulses with a subtle energy emanating from deep within the Vindicaar.','',26124),
(130536,'enUS','I am ready.','I am ready.',26124),
(130540,'enUS','Our fight against the Burning Legion continues.','',26124),
(130541,'enUS','I am ready, High Exarch.','I am ready, High Exarch.',26124),
(130543,'enUS','When you are ready. We have much to discuss.','',26124),
(130546,'enUS','But the Light never abandoned us. It called you here and gave us another chance at victory. What we do with that chance... that is up to us.','',26124),
(130547,'enUS','$n lets out half a roar.','$n lets out half a roar.',26124),
(130548,'enUS','$n lets out half a squawk.','$n lets out half a squawk.',26124),
(130549,'enUS','$n lets out half a growl.','$n lets out half a growl.',26124),
(130550,'enUS','$n lets out half a cacaw.','$n lets out half a cacaw.',26124),
(130551,'enUS','This ridgeline will guide you to the pits. Stay low. We\'ll regroup shortly.','',26124),
(130554,'enUS','Krokul will now respond to your Flight Master\'s Whistle while on Argus.','Krokul will now respond to your Flight Master\'s Whistle while on Argus.',26124),
(130555,'enUS','So you wanna know everything there is to know about Argus so you can defeat the Legion once and for all?','',26124),
(130556,'enUS','PH','PH',26124),
(130557,'enUS','PH','PH',26124),
(130558,'enUS','PH','PH',26124),
(130559,'enUS','PH','PH',26124),
(130567,'enUS','|TInterface\\Icons\\SPELL_FEL_ELEMENTALDEVASTATION.BLP:20|tYou were stunned by |cFFFF0000|Hspell:237903|h[Fel Surge]|h|r! Destroy the totem before it finishes its cast!','|TInterface\\Icons\\SPELL_FEL_ELEMENTALDEVASTATION.BLP:20|tYou were stunned by |cFFFF0000|Hspell:237903|h[Fel Surge]|h|r! Destroy the totem before it finishes its cast!',26124),
(130568,'enUS','','Your efforts have meant nothing, $p!',26124),
(130570,'enUS','As the portal closes, a sealed door opens further into the Arcatraz.','',26124),
(130576,'enUS','|TInterface\\Icons\\CREATUREPORTRAIT_INFERNAL_BALL_02.BLP:20|t%s is casting |cFFFF0000|Hspell:238588|h[Rain of Brimstone]|h|r!','',26124),
(130577,'enUS','Examining...','Examining...',26124),
(130579,'enUS','Look to the heavens above. See the million points of brilliance in the great dark beyond.','',26124),
(130580,'enUS','Know you are not alone. Our salvation is out there, somewhere.','',26124),
(130581,'enUS','You must hold fast to your resolve. Temptation weakens the mind and spirit.','',26124),
(130582,'enUS','Look inside yourself and see the strength your vigil has cultivated.','',26124),
(130584,'enUS','|TInterface\\Icons\\Ability_Earthen_Pillar.blp:20|t%s loses a Hardened |cFFFF0000|Hspell:238473|h[Fel Scale]|h|r from colliding with a stalactite!','',26124),
(130585,'enUS','|TInterface\\Icons\\spell_shaman_earthquake:20|t%s readies itself to charge!','',26124),
(130586,'enUS','|TInterface\\Icons\\inv_qiraj_skinsandworm:20|t%s burrows, the earth  |cFFFF0000|Hspell:238473|h[Hardens]|h|r its scales!','',26124),
(130589,'enUS','Baby, baby, baby! This is the illest, realest, deadest band you\'ve ever seen! They will melt your face, figuratively and literally! Before I met these guys, I was alive and had all my skin! Now I\'m dead and filthy rich!\n\nCatch Blight Boar here, every hour on the half hour!','',26124),
(130590,'enUS','','|TInterface\\Icons\\SPELL_ARCANE_INVOCATION.BLP:20|tYou are afflicted by |cFFFF0000|Hspell:236712|h[Lunar Beacon]|h|r!',26124),
(130591,'enUS','','|TInterface\\Icons\\Ability_IronMaidens_ConvulsiveShadows.blp:20|t%s targets you with |cFFFF0000|Hspell:236603|h[Rapid Shot]|h|r!',26124),
(130598,'enUS','','PH',26124),
(130599,'enUS','Can you hear them? Chewing, gnashing, wailing...$b$b<Arkhaan shudders.>$b$bIsolon is lost.','',26124),
(130600,'enUS','We should keep going.','We should keep going.',26124),
(130601,'enUS','Pheta thones gamera.','',26124),
(130602,'enUS','We must not give in.','',26124),
(130603,'enUS','Pheta vi acahachi!','',26124),
(130604,'enUS','Our day will come.','',26124),
(130605,'enUS','','|TInterface\\Icons\\SPELL_NATURE_MOONGLOW.BLP:20|tYou are affected by |cFFFF0000|Hspell:236519|h[Moon Burn]|h|r!',26124),
(130606,'enUS','Be at peace.','',26124),
(130607,'enUS','This way. Arkhaan has a plan.','',26124),
(130608,'enUS','','Could you elaborate? Even a little?',26124),
(130609,'enUS','','Perhaps with some idea of what you hope to achieve...',26124),
(130610,'enUS','We will stop the whispers. Pointy-ears should know.','',26124),
(130611,'enUS','','I must confess, Arkhaan, that does not put me at ease.',26124),
(130612,'enUS','','|TInterface\\Icons\\artifactability_BalanceDruid_FullMoon.blp:20|t |cFFFF0000|Hspell:236357|h[Font of Elune]|h|r has reached full moon.',26124),
(130613,'enUS','','|TInterface\\Icons\\artifactability_BalanceDruid_NewMoon.blp:20|t |cFFFF0000|Hspell:236357|h[Font of Elune]|h|r has reached new moon.',26124),
(130614,'enUS','','Are all these creatures...',26124),
(130615,'enUS','My people. Once.','',26124),
(130616,'enUS','','How is it you do not share their fate?',26124),
(130617,'enUS','Arkhaan forgets.','',26124),
(130618,'enUS','We still hear their prayers. Rest, brothers. Rest.','',26124),
(130619,'enUS','','At least their suffering is over.',26124),
(130620,'enUS','','Where are these things coming from?',26124),
(130621,'enUS','They want Arkhaan. He promised to save them.','',26124),
(130622,'enUS','Arkhaan remembers. Isolon calls to us! Isolon will look to the stars again!','',26124),
(130623,'enUS','','That is not Isolon calling to you! Wait!',26124),
(130624,'enUS','','He is still here. He crossed over into the Void. We may still be able to save him if we hurry.',26124),
(130626,'enUS','The assortment of valuable things that you adventurers leave behind in your wake is simply astonishing.\n\nAnd profitable.','',26124),
(130627,'enUS','Let me satisfy your curiosity.','',26124),
(130628,'enUS','Show us, please... please...','',26124),
(130629,'enUS','Whispers... too... loud! Aaargghhh!','',26124),
(130630,'enUS','','Go. I am right behind you.',26124),
(130631,'enUS','Or you could come see a GOOD band! The Blight Boar concert will begin in thirty minutes!','',26124),
(130632,'enUS','If you\'re interested in gettin\' down, the Blight Boar concert starts in twenty!','',26124),
(130633,'enUS','Blight Boar is playing their underground show on the east side of the island! Your headliner Blight Boar goes on in ten minutes!','',26124),
(130634,'enUS','I see you\'ve met the viceroy.','',26124),
(130635,'enUS','','What are your people doing here?',26124),
(130636,'enUS','I am here to find out. Follow, if you can.','',26124),
(130637,'enUS','','Wait!',26124),
(130639,'enUS','Gul\'dan has been vanquished, but his master Kil\'jaeden poses an even greater threat.\n\nThe Deceiver will stop at nothing to destroy our world. We must make any sacrifice necessary to end his reign.','',26124),
(130640,'enUS','My rockin\' and rollin\' beauties! You\'re in the right place to melt your face! Allow me to humbly introduce... Blight Booooar!','',26124),
(130641,'enUS','In times such as these, our beliefs are tested. We may be tempted to surrender to an evil that can seem overwhelming... and unstoppable.\n\nBut we must not lose faith in the Light. It will guide us to victory.','',26124),
(130642,'enUS','','I will never trust the Betrayer or his Illidari lackeys, but I am willing to set aside my misgivings for the sake of the greater good.\n\nBut once the Legion falls, what use will we have for those tainted by its corruption?',26124),
(130643,'enUS','In times of war, supplies are short.','',26124),
(130644,'enUS','','I realize this isn\'t much of an inn, but it\'s what we have.',26124),
(130645,'enUS','Can I interest you in a beverage or two?','',26124),
(130646,'enUS','Welcome, $ct. I have been appointed to distribute these items of interest to your armies and yourself.','',26124),
(130647,'enUS','','$ct, see something you like?',26124),
(130654,'enUS','The Sentinax recalls its portals and begins recharging.','The Sentinax recalls its portals and begins recharging.',26124),
(130655,'enUS','The Sentinax has finished recharging.','The Sentinax has finished recharging.',26124),
(130659,'enUS','<You feel like Manapoof is silently judging you.>','<You feel like Manapoof is silently judging you.>',26124),
(130660,'enUS','Would you please send me to the Wailing Caverns?','Would you please send me to the Wailing Caverns?',26124),
(130661,'enUS','When the ship from Azeroth arrived, I sensed his presence. I would know it anywhere, even after all the years we\'ve spent apart.','',26124),
(130662,'enUS','','Arator! He\'s here!',26124),
(130663,'enUS','Thank you, stranger. I almost met my final death! Please, take these items from my grave as your reward.','',26124),
(130664,'enUS','I admit I am intrigued by the vision of Aegwynn that you encountered in the Cathedral. There is so much I could learn from the mother of my mentor Medivh, even if this manifestation is but an echo of the Guardian she was.\n\nI will continue to study her writings. They may offer insights into what awaits us in the depths of the Tomb of Sargeras.','',26124),
(130665,'enUS','The Cathedral is ours, but the Tomb\'s depths remain in the hands of the Deceiver and his foul minions.\n\nBuild up your forces, $ct. The true battle awaits us!','',26124),
(130666,'enUS','','My wardens hold the Cathedral, but it will all be for naught if Kil\'jaeden awakens his master\'s fallen avatar in the depths of the Tomb.\n\nIt seems Illidan and his followers are still needed... for now.',26124),
(130667,'enUS','Kil\'jaeden hounded my people across the stars, and now does the bidding of his dark master in the depths of the Tomb.\n\nWe will make him pay for his crimes. At long last, the Deceiver will fall!','',26124),
(130668,'enUS','Completing Construction','Completing Construction',26124),
(130688,'enUS','','This way.',26124),
(130689,'enUS','I have something I want to show you, but we mustn\'t be seen. Follow.','',26124),
(130690,'enUS','','Explain yourself first.',26124),
(130691,'enUS','Such impatience. I believe you will find the answers you seek on the other side.','',26124),
(130697,'enUS','How industriously they work. A pity they will be overtaken.','',26124),
(130698,'enUS','','I sense a little disappointment. Was I really your best student?',26124),
(130699,'enUS','I had hoped to find at least one promising soul on this rock.','',26124),
(130700,'enUS','','I have not turned away from that path. You know why I resisted.',26124),
(130701,'enUS','','I need to finish what I started, Locus-Walker.',26124),
(130702,'enUS','Can you, though? With your... attachments?','',26124),
(130703,'enUS','They smashed Thrashbite!? Run!!!','',26124),
(130739,'enUS','The Aegis will be ours!','The Aegis will be ours!',26124),
(130740,'enUS','You will fall to the Legion!','You will fall to the Legion!',26124),
(130741,'enUS','You will burn!','You will burn!',26124),
(130742,'enUS','The cathedral is ours!','The cathedral is ours!',26124),
(130743,'enUS','Your relics cannot save you now!','Your relics cannot save you now!',26124),
(130767,'enUS','','Let\'s get the Forsaken up here on the stage!',26124),
(130768,'enUS','','Time for the Forsaken to dance. Their moves will take your breath away.',26124),
(130769,'enUS','','Come on up, trolls! Show everyone else how it\'s done!',26124),
(130770,'enUS','','Time for a troll dance!  Shoes can\'t hold these feet!',26124),
(130771,'enUS','','Watch your feet! It\'s tauren dance time, and those hooves can hurt.',26124),
(130772,'enUS','','Come on up, tauren! Show us how they do it in Mulgore.',26124),
(130773,'enUS','','Let\'s get those goblins up on the stage so everyone can see them!',26124),
(130774,'enUS','','Let me see those goblin moves!',26124),
(130775,'enUS','','Feast your eyes on the beautiful moves of the blood elves!',26124),
(130776,'enUS','','Blood elves! Your turn to dance.',26124),
(130777,'enUS','','I love watching those pandaren throw their weight around. Time to dance!',26124),
(130778,'enUS','','Come on up, pandaren!',26124),
(130779,'enUS','','Rise up, sister and brother orcs! Let\'s see your moves!',26124),
(130780,'enUS','','This is our city, orcs. Let\'s show them our pride!',26124),
(130783,'enUS','','I can\'t believe they took over the entire building just for a dance party! Where am I going to sell all these pants now?',26124),
(130784,'enUS','You do know Orgrimmar has another auction house, don\'t you?','You do know Orgrimmar has another auction house, don\'t you?',26124),
(130785,'enUS','','Oh. Right.',26124),
(130787,'enUS','<Travel to the Arcatraz.>','<Travel to the Arcatraz.>',26124),
(130791,'enUS','|TInterface\\Icons\\ability_fixated_state_purple:20|t%s |cFFFF0404|Hspell:238674|h[Fixates]|h|r on you!','|TInterface\\Icons\\ability_fixated_state_purple:20|t%s |cFFFF0404|Hspell:238674|h[Fixates]|h|r on you!',26124),
(130798,'enUS','I need a cache key. |cFF9400D3[100 Nethershards]|r','I need a cache key. |cFF9400D3[100 Nethershards]|r',26124),
(130799,'enUS','REUSE ME','REUSE ME',26124),
(130800,'enUS','REUSE ME','$p, we salute you. Return to the Exodar and let us cover your escape.',26124),
(130802,'enUS','','Attack, my pretties!',26124),
(130805,'enUS','|TInterface\\Icons\\ABILITY_MAGE_FIRESTARTER:20|t%s has targeted |cFFFF0000$n|r with |cFFFF0000|Hspell:238502|h[Focused Dreadflame]|h|r!','|TInterface\\Icons\\ABILITY_MAGE_FIRESTARTER:20|t%s has targeted |cFFFF0000$n|r with |cFFFF0000|Hspell:238502|h[Focused Dreadflame]|h|r!',26124),
(130806,'enUS','|TInterface\\Icons\\ABILITY_WARLOCK_SOULSWAP.BLP:20|t Turn away from Gazerax\'s |cFFFF0000|Hspell:239217|h[Blinding Glare]|h|r!','|TInterface\\Icons\\ABILITY_WARLOCK_SOULSWAP.BLP:20|t Turn away from Gazerax\'s |cFFFF0000|Hspell:239217|h[Blinding Glare]|h|r!',26124),
(130807,'enUS','','I don\'t care what horrors lie on Argus. If there is even a chance we find Alleria there, I am with you.',26124),
(130808,'enUS','I\'m ready.','I\'m ready.',26124),
(130809,'enUS','The Legion ship is preparing to retreat! Get off the ship immediately!','',26124),
(130810,'enUS','I have Nethershards, are you willing to trade?','I have Nethershards, are you willing to trade?',26124),
(130814,'enUS','At long last the vessel that will usher us to Argus is complete.','',26124),
(130815,'enUS','Make way to Stormwind Harbor at once. The time has come to bring an end to this war.','',26124),
(130816,'enUS','Make way to Bladefist Bay at once. The time has come to bring an end to this war.','',26124),
(130820,'enUS','High Inquisitor Raalgar was imprisoned deep inside the Arcatraz. The Legion is already here, so be careful!','',26124),
(130821,'enUS','The Legion is still only moments ahead of us. Take the portal back here and I will figure out where the Inquisitor has gone!','',26124),
(130823,'enUS','We will take this down to the surface. Be on your guard.','',26124),
(130824,'enUS','Come. I need to see it for myself.','',26124),
(130825,'enUS','That\'s it! Her thoughts be clearin\' up. She\'s feelin\'... fear. Watch out!','',26124),
(130826,'enUS','','We will soon see if the Horde heeds Velen\'s call. Those savages lack any sense of honor, but they do know how to fight.',26124),
(130830,'enUS','|TInterface\\Icons\\Spell_Deathknight_Defile:20|tWith no souls in the Spirit Realm, Soul Queen Dejahna lashes out with |cFFFF0000|Hspell:236507|h[Quietus]|h|r!','',26124),
(130831,'enUS','','|TInterface\\Icons\\Spell_Deathknight_Defile:20|tWith no souls in the Corporeal Realm, the Engine of Souls lashes out with |cFFFF0000|Hspell:236507|h[Quietus]|h|r!',26124),
(130832,'enUS','Sargeras cannot be denied!','',26124),
(130833,'enUS','This will be the last gift you reject!','',26124),
(130834,'enUS','Suffer your folly!','',26124),
(130835,'enUS','You flee to the abyss, coward!','',26124),
(130836,'enUS','Yes! Flee! Flee!','',26124),
(130837,'enUS','Embrace Sargeras!','',26124),
(130847,'enUS','You... will never... escape...','',26124),
(130848,'enUS','There is nowhere to run.','',26124),
(130849,'enUS','Argus will... rise...','',26124),
(130850,'enUS','Why is it... dark?','',26124),
(130851,'enUS','The Eredar... reign...','',26124),
(130852,'enUS','Run... while you can.','',26124),
(130856,'enUS','We must find the Army of the Light. With them fighting alongside us, the Legion will fall. We must find...','',26124),
(130857,'enUS','You left us here to die!','You left us here to die!',26124),
(130858,'enUS','I waited... so long... for peace.','I waited... so long... for peace.',26124),
(130859,'enUS','Light damn you, Prophet!','',26124),
(130860,'enUS','The torment is over... at long last.','',26124),
(130861,'enUS','We waited! We waited but the Light never returned!','',26124),
(130862,'enUS','Our wait is over! Vengeance against the Prophet!','',26124),
(130863,'enUS','All is... forgiven...','',26124),
(130864,'enUS','He could not... have known...','',26124),
(130870,'enUS','Succumb! It is the only way!','',26124),
(130871,'enUS','The great darkness knows all!','',26124),
(130872,'enUS','Such power... I will show you!','',26124),
(130873,'enUS','It calls to us. Listen, listen!','',26124),
(130874,'enUS','All that is must be undone!','',26124),
(130875,'enUS','Darkness commands me. Heed its call!','',26124),
(130876,'enUS','Quiet... quiet!','',26124),
(130877,'enUS','Make it stop!','',26124),
(130878,'enUS','Please, just leave me alone!','',26124),
(130879,'enUS','Light, help me...','',26124),
(130880,'enUS','No... No!','',26124),
(130881,'enUS','Make the whispers end!','',26124),
(130882,'enUS','The Light... will fail.','',26124),
(130883,'enUS','The darkness takes me.','',26124),
(130884,'enUS','I rejoin the void!','',26124),
(130885,'enUS','It all makes sense...','',26124),
(130886,'enUS','Even the naaru will fall... as I have...','',26124),
(130887,'enUS','Death embraces me.','',26124),
(130888,'enUS','It is... over.','',26124),
(130889,'enUS','The whispers are gone.','',26124),
(130890,'enUS','Shadows fade.','',26124),
(130891,'enUS','Naaru be praised. I am free.','',26124),
(130892,'enUS','It was so dark.','',26124),
(130893,'enUS','The Light forgives.','',26124),
(130908,'enUS','Alleria and I will protect you.','Alleria and I will protect you.',26124),
(130909,'enUS','They will hunt us. The shadows know we resist them. Turn back, turn back!','',26124),
(130910,'enUS','Who calls to Arkhaan? Name yourself!','',26124),
(130911,'enUS','Quiet, quiet! Arkhaan listens...','',26124),
(130912,'enUS','Wait. There is... a voice.','',26124),
(130961,'enUS','Arkhaan finally understands...','',26124),
(130962,'enUS','What has Arkhaan... done?','',26124),
(130963,'enUS','Fragile mortals. Bow before the might of the Burning Legion!','',26124),
(130965,'enUS','Subject identified: ally of Speaker. Annihilation protocols suspended.','',26124),
(130966,'enUS','Subject vitals within normal parameters. The Speaker awaits you.','',26124),
(130971,'enUS','','What are you talking about?',26124),
(130972,'enUS','Why, your mate of course. How does he feel about your choices?','',26124),
(130973,'enUS','','Turalyon trusts me to make hard decisions, and I him.',26124),
(130974,'enUS','I am not talking about trust.','',26124),
(130975,'enUS','How can you expect to embrace the Shadow with the Light shining so brightly at your side?','',26124),
(130976,'enUS','','Without the Light there is no Shadow, teacher.',26124),
(130980,'enUS','Ahh... The shadow comes!','',26124),
(130981,'enUS','Do you hear that? The whispers demand your death!','',26124),
(130982,'enUS','The Void welcomes you!','',26124),
(130983,'enUS','Your death pleases the Dark Masters!','',26124),
(130984,'enUS','You are out of your depth, fleshling.','',26124),
(130985,'enUS','Embrace the end of all things!','',26124),
(130986,'enUS','','Succumb!',26124),
(130987,'enUS','','The Dark Ones demand your end.',26124),
(130988,'enUS','','You will know the Void!',26124),
(130989,'enUS','','Embrace the Void.',26124),
(130990,'enUS','','I see your soul, and it is black!',26124),
(130991,'enUS','','None may resist the will of the shadow.',26124),
(130992,'enUS','Understand... this changes... nothing.','',26124),
(130993,'enUS','Oblivion... calls.','',26124),
(130994,'enUS','I return to the Void.','',26124),
(130995,'enUS','I come, Dark Masters.','',26124),
(130996,'enUS','Their will be done.','',26124),
(130997,'enUS','I serve the end of all things.','',26124),
(130998,'enUS','At last.','',26124),
(131001,'enUS','Well, Windrunner? What say you?','',26124),
(131002,'enUS','','Show me the path. I am ready to walk it.',26124),
(131003,'enUS','Right this way.','',26124),
(131006,'enUS','All right, I got everythin\' set up on this end. Activate the power conduits and the pad\'ll be operational!','',26124),
(131011,'enUS','Ah! Right on time, fleshling.','',26124),
(131012,'enUS','Prepare yourself, Alleria. Your friend here will hold its attention.','',26124),
(131013,'enUS','','That thing... it\'s... calling to me!',26124),
(131014,'enUS','How do you feel?','',26124),
(131015,'enUS','','My head is... swimming.',26124),
(131016,'enUS','Remember... So long as your mind is your own, you command this power. It does not command you.','',26124),
(131017,'enUS','Yes, this specimen will do.','',26124),
(131018,'enUS','','How did you do it by yourself?',26124),
(131019,'enUS','Ah, well. Perhaps I will tell you one day. Until then, I will be keeping an eye on your progress.','',26124),
(131020,'enUS','Until then, I will be keeping an eye on your progress.','',26124),
(131026,'enUS','','You should return to the Vindicaar and share what we have learned.',26124),
(131027,'enUS','','My path takes me into the Seat of the Triumvirate... to whatever fate awaits me there.',26124),
(131028,'enUS','','I am certain Velen will understand.',26124),
(131031,'enUS','You do know the city has another auction house, don\'t you?','You do know the city has another auction house, don\'t you?',26124),
(131034,'enUS','','This is your city, humans. Show us your pride!',26124),
(131035,'enUS','','I heard a rumor that humans can\'t dance. Prove me wrong!',26124),
(131036,'enUS','','Look at those dwarven feet move! And they can do it all without spilling their ale!',26124),
(131037,'enUS','','It\'s time for the dwarves to show us how they party!',26124),
(131038,'enUS','','Feast your eyes on the shapely, confident night elves! I might start panting soon...',26124),
(131039,'enUS','','Night elves! Show us how you get down up in Teldrassil!',26124),
(131040,'enUS','','Let\'s get those gnomes up on the stage so everyone can see them!',26124),
(131041,'enUS','','Gnomes! Aren\'t they adorable?',26124),
(131042,'enUS','','Let\'s get the draenei up here on stage!',26124),
(131043,'enUS','','Their dance moves are out of this world. Let\'s hear it for the draenei!',26124),
(131044,'enUS','','Come on up, worgen brothers and sisters! Let\'s show them how it\'s done!',26124),
(131045,'enUS','','Awwoooooo! Worgen, get down with your bad selves!',26124),
(131046,'enUS','','I love watching those pandaren throw their weight around. Time to dance!',26124),
(131047,'enUS','','Come on up, pandaren!',26124),
(131051,'enUS','','Looks like they showed up after all.',26124),
(131052,'enUS','Stay strong, brothers and sisters. We must keep them at bay until the rest of our forces arrive. For Azeroth!','',26124),
(131053,'enUS','','Your world is forfeit. The way to Argus is open. The endless legions of Sargeras descend upon you!',26124),
(131058,'enUS','Come, champion. Let the Light guide your path!','',26124),
(131059,'enUS','The Legion grows desperate. We should strike now while their attention remains focused on Azeroth.','',26124),
(131060,'enUS','','PH',26124),
(131061,'enUS','','How are you liking the form of the Lunarwing Owl, Archdruid?',26124),
(131062,'enUS','I no longer wish to use the Lunarwing Owl form.','I no longer wish to use the Lunarwing Owl form.',26124),
(131063,'enUS','I wish to use the Lunarwing Owl form.','I wish to use the Lunarwing Owl form.',26124),
(131064,'enUS','','If you would like to return to using the traditional flight form, I can assist with that, Archdruid.',26124),
(131066,'enUS','PH','',26124),
(131067,'enUS','PH','',26124),
(131068,'enUS','I... will... return...','',26124),
(131069,'enUS','Break them!','',26124),
(131070,'enUS','I will flay the flesh from your bones!','',26124),
(131071,'enUS','The master will mend my flesh again and again. You have not won. You cannot win. We are endless! We are Legion!','',26124),
(131072,'enUS','We cannot wait any longer, lest the way to Argus be reinforced.','',26124),
(131073,'enUS','You are right, Illidan. This may be our best chance to gain the upper hand.','',26124),
(131074,'enUS','We will not let this world fall to darkness.','',26124),
(131075,'enUS','Divinius, ensure the safety of our people in my absence. It is time I paid a visit to our former home.','',26124),
(131076,'enUS','We will join you in the Vault of Lights.','',26124),
(131083,'enUS','Activating Conduit','Activating Conduit',26124),
(131084,'enUS','Prophet Velen is just ahead, champions.','Prophet Velen is just ahead, champions.',26124),
(131095,'enUS','Greetings.','',26124),
(131099,'enUS','Welcome to the Moonkin Festival!','',26124),
(131100,'enUS','Please, make yourself at home.','',26124),
(131116,'enUS','Where you been? There\'s more grog to drink!','Where you been? There\'s more grog to drink!',26124),
(131117,'enUS','When you\'re a Bloodsail, every day is Pirates\' Day!','When you\'re a Bloodsail, every day is Pirates\' Day!',26124),
(131118,'enUS','I\'m a mighty pirate!','I\'m a mighty pirate!',26124),
(131119,'enUS','Welcome to the parrrty!','Welcome to the parrrty!',26124),
(131120,'enUS','Dread Crew... More like Dead Crew, am I right?','Dread Crew... More like Dead Crew, am I right?',26124),
(131121,'enUS','I love dancing!','',26124),
(131122,'enUS','Everybody dance... NOW!','',26124),
(131123,'enUS','Dance like nobody\'s watching!','',26124),
(131124,'enUS','Dance! Dance! Dance!','',26124),
(131125,'enUS','Can you feel the rhythm?','',26124),
(131126,'enUS','Move to the beat!','',26124),
(131136,'enUS','Ya ever seen the ocean burn?','You ever seen the ocean burn?',26124),
(131137,'enUS','Booty Bay will burn!','Booty Bay will burn!',26124),
(131138,'enUS','What do you know about lifting voodoo curses?','What do you know about lifting voodoo curses?',26124),
(131139,'enUS','Booze is mana, if you\'re tough enough.','Booze is mana, if you\'re tough enough.',26124),
(131140,'enUS','A cutlass, a spell, a bottle of booze. What more could a Bloodsail want?','A cutlass, a spell, a bottle of booze. What more could a Bloodsail want?',26124),
(131153,'enUS','Today, we all be pirates. But tomorrow, ya got ta earn dese colors.','',26124),
(131154,'enUS','BOOM!','',26124),
(131155,'enUS','Boom! Boom! Boom!','',26124),
(131156,'enUS','Boom! Boom!','',26124),
(131159,'enUS','You haven\'t lived until you\'ve sang shanties at sunrise in the salty mists of the sea.','',26124),
(131161,'enUS','I haven\'t trained at any of the famous academies, but I\'ve sacked all of \'em!','',26124),
(131163,'enUS','When the Bloodsail raided my family\'s fishing boat, they didn\'t just kill everyone I\'ve ever loved.\n\nThey rescued me from a mundane life severely lacking in treasure and grog! A pirate\'s life for me!','',26124),
(131256,'enUS','It\'s good to finally meet the famous $p! Me crew tell tales of your legendary sackings of Booty Bay.\n\nEveryone likes to pretend to be a Bloodsail today, but you\'re the real deal. Fly the Black with pride, matey.','',26124),
(131257,'enUS','I will reach Booty Bay just after nightfall. Then, under the cover of darkness, I will make them feel the full wrath of the Bloodsail!','',26124),
(131258,'enUS','<Rear Admiral Giggleplanks kicks frantically, but his feet don\'t reach the water.>','',26124),
(131259,'enUS','Curse this briny stallion to the depths! It won\'t obey my orders. Forward, beast, or I\'ll keelhaul you!','',26124),
(131260,'enUS','All of Booty Bay fears my arrival! It has been foretold in the ancient legends!','',26124),
(131261,'enUS','Beware the unbridled wrath of Rear Admiral Giggleplanks! Not even the unusually large rats of Booty Bay will be spared!','',26124),
(131262,'enUS','Chaaarge!\n\n<Rear Admiral Giggleplanks waits for a few moments and then pouts.>\n\nFine, we\'ll wait until the tide pulls us in. That\'ll make it more dramatic anyways.','',26124),
(131263,'enUS','This is the one day all year that the Fleet Admiral lets me off the leash.\n\nThe one day that all of Azeroth fears.\n\nI\'m a wild pirate with wild pirate intentions! Booty Bay will burn... wildly!','',26124),
(131264,'enUS','Hurry up, steed! We must reach Booty Bay by nightfall!\n\nI swear you\'re not even trying.','',26124),
(131265,'enUS','Don\'t judge me. Not on Pirates\' Day!','Don\'t judge me. Not on Pirates\' Day!',26124),
(131266,'enUS','Where be ye ocean steed, matey?','Where be ye ocean steed, matey?',26124),
(131267,'enUS','Avast! Stop poking me inflatable or I be keelhaulin\' ya!','Avast! Stop poking me inflatable or I be keelhaulin\' ya!',26124),
(131268,'enUS','They were all out of the red ones.','They were all out of the red ones.',26124),
(131269,'enUS','Does this make me look fearsome?','Does this make me look fearsome?',26124),
(131270,'enUS','Look at this landlubber without a sea pony! Ha!','Look at this landlubber without a sea pony! Ha!',26124),
(131271,'enUS','Push me towards Booty Bay so I can shout more profanities at \'em!','Push me towards Booty Bay so I can shout more profanities at \'em!',26124),
(131272,'enUS','I\'ve never felt so free!','I\'ve never felt so free!',26124),
(131273,'enUS','If ya need a pig cooked for the barbecue later, just let me know. I do a perfect searing flame.','If ya need a pig cooked for the barbecue later, just let me know. I do a perfect searing flame.',26124),
(131274,'enUS','Cowardly Crosby deserves what\'s comin\' to him.','Cowardly Crosby deserves what\'s comin\' to him.',26124),
(131275,'enUS','Everyone wants to be a Bloodsail, but only a few got the guts to do what it takes.','Everyone wants to be a Bloodsail, but only a few got the guts to do what it takes.',26124),
(131276,'enUS','Haven\'t I seen you below deck before? Or maybe it\'s just the grog talkin...','Haven\'t I seen you below deck before? Or maybe it\'s just the grog talkin...',26124),
(131277,'enUS','Ya like treasure, landlubber? Too bad! It\'s all ours!','Ya like treasure, landlubber? Too bad! It\'s all ours!',26124),
(131278,'enUS','You look familiar... Didn\'t I ransack your coastal villa once?\n\nHa, yeah! I\'m sure it was you! Your servants all ran screaming into the vineyards, right? And then we burnt the whole place to the ground?\n\nGood times.','You look familiar... Didn\'t I ransack your coastal villa once?\n\nHa, yeah! I\'m sure it was you! Your servants all ran screaming into the vineyards, right? And then we burnt the whole place to the ground?\n\nGood times.',26124),
(131279,'enUS','No landlubbers!','No landlubbers!',26124),
(131280,'enUS','Let\'s put the blood in Bloodsail!','Let\'s put the blood in Bloodsail!',26124),
(131281,'enUS','Bloodsail or no sail!','Bloodsail or no sail!',26124),
(131282,'enUS','No one messes with the Bloodsail!','No one messes with the Bloodsail!',26124),
(131283,'enUS','The Bloodsail party\'s never gonna end!','The Bloodsail party\'s never gonna end!',26124),
(131284,'enUS','Hands off the treasure, scallywag.','Hands off the treasure, scallywag.',26124),
(131285,'enUS','No splashing in the water!','No splashing in the water!',26124),
(131286,'enUS','You\'re in Bloodsail territory now.','You\'re in Bloodsail territory now.',26124),
(131287,'enUS','The last vestiges of life in our city are succumbing to the void. The power in this crystal will release them from its grasp.','',26124),
(131288,'enUS','Thank you for freeing those creatures. I remember the days when our children used to play with them. It pains me to see what has happened since.','',26124),
(131301,'enUS','As I was a-walking down  Booty Bay\'s planks...','',26124),
(131307,'enUS','A pretty young lass I chanced to meet...','',26124),
(131308,'enUS','She was round in the counter and bluff in the bow...','',26124),
(131309,'enUS','So I took in all sail and cried, \"Way enough now!\"','',26124),
(131310,'enUS','I hailed her in dwarvish, she answered me clear...','',26124),
(131311,'enUS','\"I\'m from Ironforge, bound to Bronzebeard!\"','',26124),
(131312,'enUS','To me way, aye, blow the man down!','',26124),
(131313,'enUS','Give me some time to blow the man down!','',26124),
(131314,'enUS','Look ahead, look astern, look the weather and the lee...','',26124),
(131315,'enUS','I see a wreck to windward and a lofty ship to lee...','',26124),
(131316,'enUS','\"Oh, are you a pirate or a royal fleet?\" cried he...','',26124),
(131317,'enUS','We be pirates! Bloodsail!','',26124),
(131319,'enUS','Blow high, blow low, and so sailed we!','',26124),
(131320,'enUS','A-sailing down the coasts to Booty!','',26124),
(131321,'enUS','Give us your treasure and your ale!','',26124),
(131323,'enUS','We\'ll rant and we\'ll roar, like true Bloodsail pirates!','',26124),
(131324,'enUS','We\'ll rant and we\'ll rave, across the salt seas!','',26124),
(131326,'enUS','\'Til we strike soundings in the Cape o\' Stranglethorn!','',26124),
(131328,'enUS','From Arathi to Booty Bay is too far indeed!','',26124),
(131335,'enUS','So it\'s cheer up, my lads. Let your hearts never sink!','',26124),
(131336,'enUS','While the bonny ship, Crimson Whirl, goes a-fishing for the drink.','',26124),
(131337,'enUS','Here\'s a health to the Red Whale...','',26124),
(131338,'enUS','Here\'s a health to the Battler of Westfall...','',26124),
(131339,'enUS','We wear the shirts o\' the white...','',26124),
(131340,'enUS','When we return to Stranglethorn, we\'ll have sweethearts \'til dead!','',26124),
(131341,'enUS','Likewise, the Pippy Swan!','',26124),
(131342,'enUS','And the Ruby, ship of fame!','',26124),
(131343,'enUS','And the pants o\' the red!','',26124),
(131344,'enUS','The keg is empty in the morn...','',26124),
(131345,'enUS','And it\'s mighty drafty around Stranglethorn...','',26124),
(131346,'enUS','Oh, ya pirates and scoundrels...','',26124),
(131347,'enUS','It\'s \'round the Cape we\'ve got to go...','',26124),
(131348,'enUS','Oh, it\'s one more pull and that will do...','',26124),
(131349,'enUS','For we\'re the mateys to kick her through!','',26124),
(131350,'enUS','Go down, ya Bloodsail pirates, go down!','',26124),
(131351,'enUS','Chasing ships wherever we go!','',26124),
(131352,'enUS','He says heave, we say ho!','',26124),
(131353,'enUS','Shhhhhhhhhhh.','',26124),
(131354,'enUS','Please be quiet. Don\'t wake up the moonkin hatchlings!','',26124),
(131355,'enUS','Rest is vital for moonkin hatchlings.','',26124),
(131356,'enUS','After a long day of dancing and Moonfiring, moonkin hatchlings need a break to recharge.','',26124),
(131357,'enUS','begins to snore.','',26124),
(131358,'enUS','Fleet Admiral Tethys says it\'s time to go...','',26124),
(131359,'enUS','Moonfiring is essential to being a moonkin.','',26124),
(131360,'enUS','It takes great concentration to be able to Moonfire many times in a row.','',26124),
(131361,'enUS','Look at some of these hatchlings. They just can\'t focus long enough to moonfire indefinitely.','',26124),
(131362,'enUS','By the time I\'m finished with these hatchlings, they\'ll be masters at Moonfiring!','',26124),
(131363,'enUS','BOOM!','',26124),
(131364,'enUS','Okay everybody, let\'s get loose!','',26124),
(131365,'enUS','Alright everybody, put your hands up!','',26124),
(131366,'enUS','Dance like nobody is watching!','',26124),
(131367,'enUS','Are you all ready for this?','',26124),
(131368,'enUS','Now everybody screeeeeeeeammm!','',26124),
(131373,'enUS','Select a destination.','',26124),
(131374,'enUS','Exodus Point','Exodus Point',26124),
(131375,'enUS','Triumvirate\'s End','Triumvirate\'s End',26124),
(131376,'enUS','Shadowguard Incursion','Shadowguard Incursion',26124),
(131378,'enUS','The Vindicaar','The Vindicaar',26124),
(131380,'enUS','Repairing','Repairing',26124),
(131390,'enUS','Calling','Calling',26124),
(131393,'enUS','Make way for the Admiral!','',26124),
(131394,'enUS','Welcome back, Admiral $p. We\'ve been expectin\' ya.','',26124),
(131395,'enUS','Happy Pirates\' Day, Admiral $p! You\'ve earned the right to raise the Black.','',26124),
(131397,'enUS','Already done sackin\' Booty Bay, Admiral? Ha, those mollusks don\'t stand a chance with you at the helm!','',26124),
(131398,'enUS','Three cheers for Admiral $p, a true Bloodsail! One of us!','',26124),
(131400,'enUS','Admiral $p! You\'re a welcome sight from the wannabe pirates that always come crawlin\' around this day.','',26124),
(131401,'enUS','Someone get the Admiral a grog! And a floaty!','',26124),
(131402,'enUS','Hail to the conqueror of Booty Bay, the scourge of Stranglethorn, Bloodsail Admiral $p!','',26124),
(131409,'enUS','Beacon inbound. Be careful, Prophet.','',26124),
(131410,'enUS','Hungry!','',26124),
(131411,'enUS','Berries!','',26124),
(131412,'enUS','<The moonkin hatchling\'s stomach grumbles as it motions toward the Stormrage Barrow Dens.>','',26124),
(131417,'enUS','Fall back!','',26124),
(131421,'enUS','Son, there is so much more we have to say, but our allies at the Xenedar will soon be overrun.','',26124),
(131422,'enUS','I... understand. Light be with you both.','',26124),
(131423,'enUS','','Stay safe. We will gather the others and prepare for the battle to come.',26124),
(131432,'enUS','Keep your distance. Those things sting!','Keep your distance. Those things sting!',26124),
(131433,'enUS','I admit it is impressive that the sentinels still patrol after all this time.','I admit it is impressive that the sentinels still patrol after all this time.',26124),
(131436,'enUS','You attack it first.','You attack it first.',26124),
(131437,'enUS','Destroy this thing without delay. The Legion needs the High Inquisitor!','Destroy this thing without delay. The Legion needs the High Inquisitor!',26124),
(131438,'enUS','We must destroy this sentinel without delay. The Legion needs the High Inquisitor!','We must destroy this sentinel without delay. The Legion needs the High Inquisitor!',26124),
(131441,'enUS','Would you please send me to the Deadmines?','Would you please send me to the Deadmines?',26124),
(131462,'enUS','Xavinox scary!','',26124),
(131463,'enUS','<The moonkin hatchling is crying at the thought of Xavinox.>','',26124),
(131464,'enUS','Jadefire bad!','',26124),
(131480,'enUS','It\'s very dangerous, sisters. Maintain control!','It\'s very dangerous, sisters. Maintain control!',26124),
(131481,'enUS','It is not worth our death to fight these sentinels. Keep it subdued until the High Inquisitor is free!','It is not worth our death to fight these sentinels. Keep it subdued until the High Inquisitor is free!',26124),
(131482,'enUS','Keep it back from us! Use your magic!','Keep it back from us! Use your magic!',26124),
(131483,'enUS','This is taking too long! We have more important things to do than play with this thing.','This is taking too long! We have more important things to do than play with this thing.',26124),
(131488,'enUS','It pains me to see them go, Aunt Vereesa. I could not bear to lose them now, not after waiting all these years.','',26124),
(131495,'enUS','The Legion will only fall if we stand together, chieftain. And right now, we have friends facing grave peril.','',26124),
(131498,'enUS','There is a way. We will use what power we have to help you.','',26124),
(131499,'enUS','A tunnel! So this is how you have survived...','',26124),
(131500,'enUS','Thank you, chieftain. We will gladly take whatever help we can get.','',26124),
(131501,'enUS','We have hidden. We have adapted. In our hour of need, this land still listens to our pleas.','',26124),
(131502,'enUS','Yes, you will... Walk in the Light.','',26124),
(131506,'enUS','The Overlook will be active soon.','',26124),
(131507,'enUS','The Overlook is now active.','',26124),
(131508,'enUS','The Overlook will be deactivating soon.','',26124),
(131509,'enUS','The Overlook is no longer active.','',26124),
(131510,'enUS','The Coast will be active soon.','',26124),
(131511,'enUS','The Coast is now active.','',26124),
(131512,'enUS','The Coast will be deactivating soon.','',26124),
(131513,'enUS','The Coast is no longer active.','',26124),
(131514,'enUS','The Crossroad will be active soon.','',26124),
(131515,'enUS','The Crossroad is now active.','',26124),
(131516,'enUS','The Crossroad will be deactivating soon.','',26124),
(131517,'enUS','The Crossroad is no longer active.','',26124),
(131518,'enUS','The Waterworks will be active soon.','',26124),
(131519,'enUS','The Waterworks is now active.','',26124),
(131520,'enUS','The Waterworks will be deactivating soon.','',26124),
(131521,'enUS','The Waterworks is no longer active.','',26124),
(131522,'enUS','The Bridge will be active soon.','',26124),
(131523,'enUS','The Bridge is now active.','',26124),
(131524,'enUS','The Bridge will be deactivating soon.','',26124),
(131525,'enUS','The Bridge is no longer active.','',26124),
(131526,'enUS','The Lighthouse will be active soon.','',26124),
(131527,'enUS','The Lighthouse is now active.','',26124),
(131528,'enUS','The Lighthouse will be deactivating soon.','',26124),
(131529,'enUS','The Lighthouse is no longer active.','',26124),
(131530,'enUS','The Ledge will be active soon.','',26124),
(131531,'enUS','The Ledge is now active.','',26124),
(131532,'enUS','The Ledge will be deactivating soon.','',26124),
(131533,'enUS','The Ledge is no longer active.','',26124),
(131534,'enUS','The Mines will be active soon.','',26124),
(131535,'enUS','The Mines is now active.','',26124),
(131536,'enUS','The Mines will be deactivating soon.','',26124),
(131537,'enUS','The Mines is no longer active.','',26124),
(131538,'enUS','|TInterface\\Icons\\ability_priest_pathofthedevout:20|t%s begins to cast |cFFFF0000|Hspell:244509|h[Sorority of the Sargerei]|h|r.','|TInterface\\Icons\\ability_priest_pathofthedevout:20|t%s begins to cast |cFFFF0000|Hspell:244509|h[Sorority of the Sargerei]|h|r.',26124),
(131545,'enUS','Ugh...','',26124),
(131546,'enUS','Help...','',26124),
(131547,'enUS','Please help.','',26124),
(131548,'enUS','Help me.','',26124),
(131549,'enUS','...','',26124),
(131550,'enUS','Administer the antidote.','Administer the antidote.',26124),
(131551,'enUS','<The moonkin hatchling seems to be very happy with you.>','',26124),
(131552,'enUS','I love you.','',26124),
(131553,'enUS','Thank you!','',26124),
(131554,'enUS','Yay!','',26124),
(131555,'enUS','Hooray!','',26124),
(131556,'enUS','You are amazing.','',26124),
(131557,'enUS','You are the best!','',26124),
(131559,'enUS','Jadefire have antidote!','',26124),
(131561,'enUS','Help Clookle!','',26124),
(131563,'enUS','Find Clookle!','',26124),
(131564,'enUS','Save Clookle!','',26124),
(131565,'enUS','Clookle underground!','',26124),
(131566,'enUS','Kill Jadefire!','',26124),
(131567,'enUS','Thank you.','',26124),
(131568,'enUS','Thank you for saving me.','',26124),
(131569,'enUS','Kill the one responsible for all of this!','',26124),
(131570,'enUS','The Alliance has gained control of the Overlook.','',26124),
(131571,'enUS','The Alliance has lost control of the Overlook.','',26124),
(131572,'enUS','The Horde has gained control of the Overlook.','',26124),
(131573,'enUS','The Horde has lost control of the Overlook.','',26124),
(131574,'enUS','The Alliance has gained control of the Coast.','',26124),
(131575,'enUS','The Alliance has lost control of the Coast.','',26124),
(131576,'enUS','The Horde has gained control of the Coast.','',26124),
(131577,'enUS','The Horde has lost control of the Coast.','',26124),
(131578,'enUS','The Alliance has gained control of the Crossroad.','',26124),
(131579,'enUS','The Alliance has lost control of the Crossroad.','',26124),
(131580,'enUS','The Horde has gained control of the Crossroad.','',26124),
(131581,'enUS','The Horde has lost control of the Crossroad.','',26124),
(131582,'enUS','The Alliance has gained control of the Waterworks.','',26124),
(131583,'enUS','The Alliance has lost control of the Waterworks.','',26124),
(131584,'enUS','The Horde has gained control of the Waterworks.','',26124),
(131585,'enUS','The Horde has lost control of the Waterworks.','',26124),
(131586,'enUS','The Alliance has gained control of the Bridge.','',26124),
(131587,'enUS','The Alliance has lost control of the Bridge.','',26124),
(131588,'enUS','The Horde has gained control of the Bridge.','',26124),
(131589,'enUS','The Horde has lost control of the Bridge.','',26124),
(131590,'enUS','The Alliance has gained control of the Lighthouse.','',26124),
(131591,'enUS','The Alliance has lost control of the Lighthouse.','',26124),
(131592,'enUS','The Horde has gained control of the Lighthouse.','',26124),
(131593,'enUS','The Horde has lost control of the Lighthouse.','',26124),
(131594,'enUS','The Alliance has gained control of the Ledge.','',26124),
(131595,'enUS','The Alliance has lost control of the Ledge.','',26124),
(131596,'enUS','The Horde has gained control of the Ledge.','',26124),
(131597,'enUS','The Horde has lost control of the Ledge.','',26124),
(131598,'enUS','The Alliance has gained control of the Mines.','',26124),
(131599,'enUS','The Alliance has lost control of the Mines.','',26124),
(131600,'enUS','The Horde has gained control of the Mines.','',26124),
(131601,'enUS','The Horde has lost control of the Mines.','',26124),
(131647,'enUS','|TInterface\\Icons\\TRADE_ARCHAEOLOGY_SHARK JAWS:20|tBring |cFFFF0000|Hspell:232913|h[Befouling Ink]|h|r to Sarukel to end his |cFFFF0000|Hspell:234621|h[Devouring Maw]|h|r!','',26124),
(131669,'enUS','','The beast weakens. Strike true!',26124),
(131673,'enUS','|TInterface\\Icons\\SPELL_FEL_ELEMENTALDEVASTATION.BLP:20|tYou have been affected by  |cFFFF0000|Hspell:236329|h[Star Burn]|h|r. Hide behind infernal pillars when targeted by Shattering Star!','',26124),
(131740,'enUS','','Let\'s not keep our son waiting.',26124),
(131753,'enUS','Without the Crest of Knowledge, we cannot prevail.','',26124),
(131756,'enUS','','There is a familiar presence here. I hear it calling to me.',26124),
(131757,'enUS','','Forces beyond our reckoning are at work here. Be on guard.',26124),
(131758,'enUS','','Keep your eyes open and your steps soft, $n.',26124),
(131759,'enUS','','Darkness creeps in on us from all sides. Keep your wits about you.',26124),
(131760,'enUS','','I need to show you what I have seen.',26124),
(131762,'enUS','Show me.','Show me.',26124),
(131767,'enUS','Stay still!','Stay still!',26124),
(131768,'enUS','We are trying to help you, creature!','We are trying to help you, creature!',26124),
(131769,'enUS','I thought I was going to catch that one.','I thought I was going to catch that one.',26124),
(131770,'enUS','Curse the void for infesting these poor creatures!','Curse the void for infesting these poor creatures!',26124),
(131772,'enUS','This is not how I thought I would spend my time in Mac\'Aree.','This is not how I thought I would spend my time in Mac\'Aree.',26124),
(131773,'enUS','This is maddening!','This is maddening!',26124),
(131778,'enUS','|TInterface\\ICONS\\Spell_Deathknight_Necroticplague.blp:20|t You are afflicted with |cFFF00000|Hspell:244093|h[Necrotic Embrace]|h|r!','',26124),
(131817,'enUS','Do not let the long, dark night break you. Accept its gift.','',26124),
(131820,'enUS','','I found a survivor. Come to me.',26124),
(131821,'enUS','','Come on out. We mean you no harm.',26124),
(131822,'enUS','A voice! Arkhaan has never heard this one before.','',26124),
(131823,'enUS','','We found your messages.',26124),
(131833,'enUS','No want sleep!','',26124),
(131834,'enUS','No sleep!','',26124),
(131835,'enUS','Not tired!','',26124),
(131837,'enUS','Wake up!','',26124),
(131846,'enUS','','I will meet you in the ruins below, $n. We will begin where the darkness ends.',26124),
(131856,'enUS','Aiiii!','',26124),
(131857,'enUS','Aaaaaaaaaaaahhhhhhhh!','',26124),
(131858,'enUS','Yeeeeeeeeeee!','',26124),
(131859,'enUS','Aiiiiiiyaaaaahhhhhhh!','',26124),
(131860,'enUS','Ooooooooooooooooh!','',26124),
(131861,'enUS','Wooooooooooo!','',26124),
(131866,'enUS','Yes, Arkhaan did call... but he was not expecting...','',26124),
(131871,'enUS','I always knew I would see Argus again. Our homecoming appeared time and again in my visions.\n\nBut I never imagined this.\n\nThere can be no doubt that the fates of my world and yours are intertwined. Can Argus be saved, or must it be sacrificed to stop Sargeras? My visions are clouded, uncertain.\n\nIt seems we must forge our own destiny. Light save us all, $n.','',26124),
(131872,'enUS','The Sargerite Keystone tore through the fabric of reality. Now the homeworld of the Legion looms before us, its armies poised to strike.\n\nTuralyon is out there somewhere. Alleria too, I hope. If we can find my old friends, perhaps the Army of the Light can help us end this war.','',26124),
(131873,'enUS','Argus. Throne of the Burning Legion. Its infernal machines provide Sargeras with an infinite army.\n\nTime to deprive the Dark Titan of his prize.\n\nOur course is clear. We must take the fight to Argus and bring the Legion to its knees.','',26124),
(131876,'enUS','<Light\'s Judgment is smashed into the side of the cliffs. It is intact, but clearly not operational. $b$bYou should be able to activate the security countermeasures to teleport it to the Vindicaar.>','',26124),
(131877,'enUS','<Activate the teleportation sequence.>','<Activate the teleportation sequence.>',26124),
(131889,'enUS','But... couldn\'t you have reached out to us? To your people? To me?','',26124),
(131890,'enUS','Arator... not a day passed that your mother and I didn\'t--','',26124),
(131891,'enUS','','Every choice we made was to keep you safe. It broke our hearts to be apart from you.',26124),
(131898,'enUS','','Hold onto your helmet... we\'re traveling through TIME!',26124),
(131899,'enUS','','Alright... let\'s see here. I think we\'re at the right time, give or take a minute. Am I dead yet?',26124),
(131900,'enUS','','Oh, good. There I am over there. Hi, me!',26124),
(131901,'enUS','','Oh, hi! What are you doing here?',26124),
(131902,'enUS','','Here we go... again!',26124),
(131903,'enUS','','I bought us a few more seconds this time, but we have to move quickly.',26124),
(131904,'enUS','','Hey! Chromie!',26124),
(131905,'enUS','','Oh, hi! What am I doing here?',26124),
(131906,'enUS','','Follow me! We don\'t have much time!',26124),
(131907,'enUS','','Oh! Well, alright. You\'ve never steered me wrong in the past. Or in the future.',26124),
(131908,'enUS','','So, where are we going? Why are we leaving Wyrmrest?',26124),
(131909,'enUS','','Somebody is trying to kill you. In fact, it should happen any second now...',26124),
(131910,'enUS','','Alright, I\'m chronoporting us to a point four hours before the attack happens. That\'ll give us PLENTY of time to untangle this mess.',26124),
(131911,'enUS','','Huh! That\'s weird. Something\'s blocking me from accessing that particular moment.',26124),
(131912,'enUS','','No worries! Four hours was probably too early anyways. Let\'s try one hour.',26124),
(131913,'enUS','','Now I\'m starting to get worried, $n. Whoever orchestrated this attack really did their homework. They\'ve found a way to block my chronoports!',26124),
(131914,'enUS','','Let\'s give this one last try...',26124),
(131915,'enUS','','There, that did it!',26124),
(131916,'enUS','','We are now at a time 15 minutes before my death.',26124),
(131917,'enUS','','That probably won\'t be enough time to save me, but it\'s the best I can do for now.',26124),
(131918,'enUS','','Let\'s ask around and see if we can figure out where those shadowy bolts were coming from.',26124),
(131919,'enUS','','Undead attacks at the Ruby Dragonshrine? We\'ll take a look. Thanks, Allie.',26124),
(131920,'enUS','','Strange? Let me think... Oh! I did see that black dragon earlier today. What was his name? Deathwing? No, no, no, not him... the other one. The one with the hat.',26124),
(131921,'enUS','','Pretty sure he was headed to the Obsidian Dragonshrine.',26124),
(131922,'enUS','','We\'ll check it out. Thanks!',26124),
(131923,'enUS','','Thank you, Lord Itharius. We\'ll take a look, and will let you know if we find anything.',26124),
(131924,'enUS','','Ley line disturbances? Pshh... typical blue dragon problems.',26124),
(131925,'enUS','','Sounds like we\'ve got some dragonshrines to investigate. Let\'s go, uh... investigate some dragonshrines!',26124),
(131926,'enUS','','Come on, $n. Let\'s go clear out the undead leaders. Maybe they\'ll know something about the upcoming attack.',26124),
(131927,'enUS','','A lich! Argh! I figured as much... though it\'s odd I couldn\'t see this in any future timeline.',26124),
(131928,'enUS','','He\'s inside the tree, right? Let\'s go get him then. His time has come!',26124),
(131929,'enUS','','We can go straight for that lich, $n. If he\'s really orchestrating this attack, then killing him should scatter their forces.',26124),
(131930,'enUS','','That\'s one threat taken care of in a timely manner!',26124),
(131932,'enUS','','Huh? What\'s this? Some kind of chronoshard? I\'ll have to bring it back to Wyrmrest to investigate.',26124),
(131933,'enUS','','He makes a fair point. Let\'s poke around that spooky cavern for clues.',26124),
(131934,'enUS','','A dreadlord? And a bronze dragon... Wait, is he talking about me?',26124),
(131935,'enUS','','And it sounds like he gave away his position. Ha! Let\'s go to the entrance of the Obsidian Dragonshrine and snuff him out!',26124),
(131936,'enUS','','Luckily for us, we already know about the dreadlord mastermind pulling the strings. Let\'s kill him before he can kill me!',26124),
(131937,'enUS','','Huh! I wonder what the Legion wants with little ol\' me.',26124),
(131938,'enUS','','Hmm... a chronoshard. Let\'s bring this back to Wyrmrest. I wonder when and where it goes.',26124),
(131940,'enUS','','We can help with that!',26124),
(131941,'enUS','','We can help with that, right?',26124),
(131942,'enUS','','The dreamers gave us three clues... great nightmare, by the water, dragon\'s palm. We just need to figure out what they mean.',26124),
(131943,'enUS','','Let\'s go!',26124),
(131944,'enUS','','Remember, the satyr is down in that bone claw by the water. Let\'s take him out!',26124),
(131945,'enUS','','Odd. I don\'t remember getting on the satyrs\' bad side, either now OR in the future.',26124),
(131946,'enUS','','Look at this! A chronoshard. We should bring it back with us to Wyrmrest.',26124),
(131947,'enUS','','Let\'s get down there and look for clues. Maybe the disturbances are coming from whoever wants to kill me.',26124),
(131948,'enUS','','Let\'s skip the ley lines and go straight to that void lord. Time is of the essence!',26124),
(131949,'enUS','','I never expected to be on the bad side of a VOID LORD, of all things. Sheesh.',26124),
(131950,'enUS','','And looky here... it was carrying a chronoshard. I need to bring this to Wyrmrest to find out where it goes.',26124),
(131951,'enUS','','I have a sneaking suspicion that the enemy is planning a cross-synchronous attack. Why else would they be using chronoshards, right?',26124),
(131952,'enUS','','I can tell you\'re a little foggy on what that means. Basically, they\'re attacking me at multiple points in time simultaneously.',26124),
(131953,'enUS','','These guys really know what they\'re doing! I wouldn\'t be surprised if they had a bronze dragon on their side.',26124),
(131954,'enUS','','Interesting... a portal to Andorhal. That\'s one of my favorite places of any when! Let\'s see if I\'m in trouble.',26124),
(131955,'enUS','','Aha! A portal to Mount Hyjal. I\'ve been there a time or tree. THREE. I meant to say three.',26124),
(131956,'enUS','','I see... a portal to Stratholme, back in the days of the Third War.',26124),
(131957,'enUS','','Wow... an oldie but a goodie! This portal points to the Well of Eternity.',26124),
(131958,'enUS','','Andorhal, a few months after the Cataclysm. We\'re in the middle of a battle between the Horde and the Alliance.',26124),
(131959,'enUS','There it is! You have your orders. Slay the dragon!','',26124),
(131960,'enUS','','See, this is one of the problems with being a gnome. Sometimes Horde soldiers just get the urge to KICK you.',26124),
(131961,'enUS','Soldiers of the Alliance! Hold your ground! She can\'t hide forever.','',26124),
(131962,'enUS','','The ALLIANCE wants me too? What\'s going on right now?',26124),
(131963,'enUS','','I can hold my own here, but I can\'t fly away with that cannon pointed at the skies.',26124),
(131964,'enUS','','The cannon is down. Can you make it out?',26124),
(131965,'enUS','','I think so. See you next time!',26124),
(131966,'enUS','','Stratholme, during the Third War. I remember this day. Not exactly Prince Arthas\' finest moment.',26124),
(131967,'enUS','Chromie! Thank the sands you\'ve arrived. They\'ve taken you into the city!','',26124),
(131968,'enUS','I couldn\'t fight them off. They\'ve taken you into the city!','',26124),
(131969,'enUS','','I guess we\'re headed into Stratholme! Let\'s get a move on, we don\'t have much time!',26124),
(131970,'enUS','','Yikes! That\'s one nasty-looking creature. Well, there\'s no getting past her. Looks like we\'re going to have to take her on.',26124),
(131971,'enUS','','Thank you so much for saving me, me!',26124),
(131972,'enUS','','Any time!',26124),
(131973,'enUS','','Let\'s see... we\'re in Mount Hyjal, shortly after the time of the Cataclysm.',26124),
(131974,'enUS','','I remember this! I should be just up ahead.',26124),
(131975,'enUS','','I sure don\'t recall there being so many fire elementals around here...',26124),
(131976,'enUS','','There I am!',26124),
(131977,'enUS','','Aww, I\'m wounded! I can heal this... I just need a little bit more time.',26124),
(131978,'enUS','','Don\'t worry. We\'ll protect you!',26124),
(131979,'enUS','','Feeling better?',26124),
(131980,'enUS','','I\'ll be fine, I think. Thanks for the help!',26124),
(131981,'enUS','','The Well of Eternity, just prior to the War of the Ancients. About ten thousand years before your time, $n. Give or take.',26124),
(131982,'enUS','','Oh no! There I am!',26124),
(131983,'enUS','','These fel wounds are bad. We need to get me back to Wyrmrest.',26124),
(131984,'enUS','','There should be a time portal up on the other side of the Well. I know the way. Follow me!',26124),
(131985,'enUS','','There\'s the portal! Let\'s move!',26124),
(131986,'enUS','','Whew! I should be safe now.',26124),
(131987,'enUS','','Everything seems... back to normal. The timelines are clearer. I don\'t see myself dying anymore.',26124),
(131988,'enUS','','That\'s good!',26124),
(131989,'enUS','','There ARE a few things still bothering me, though...',26124),
(131990,'enUS','','A whole lot of people seemed very intent on killing me. Demons, elementals, undead, void lords... even the Horde and the Alliance!',26124),
(131991,'enUS','','Why\'s everybody so mad at me? I think we should probably figure that out, eventually.',26124),
(131992,'enUS','','But that\'s a problem for future us! Well, future you and past me. Aw, don\'t worry about it. Time is complicated.',26124),
(131993,'enUS','','See you next time, $n!',26124),
(132005,'enUS','','Is that a Stratholme gate key? Ha! This must be our lucky day!',26124),
(132006,'enUS','','Keep that handy for the next time we visit Stratholme.',26124),
(132007,'enUS','','A Brimstone Beacon... fascinating!',26124),
(132008,'enUS','','I think we can use this to rile up the fire elementals in Mount Hyjal.',26124),
(132011,'enUS','','Tyrande\'s Moonstone? How did you find THIS?',26124),
(132012,'enUS','','It\'s not much use to us here, but maybe in the Well of Eternity...',26124),
(132013,'enUS','','Interesting... these documents mark the bearer as some sort of higher-up in the Cenarion Circle.',26124),
(132014,'enUS','','Maybe we can use them to grease some wheels in Andorhal.',26124),
(132018,'enUS','I am one with the Light. The Light is with me.','',26124),
(132021,'enUS','','Umm... sorry about this.',26124),
(132022,'enUS','','Alright... now I attack THIS one...',26124),
(132023,'enUS','','Time to take matters into my own hands!',26124),
(132024,'enUS','','The timestream won\'t repair itself!',26124),
(132025,'enUS','','Here we go!',26124),
(132026,'enUS','','I\'m more powerful than I appear, you know...',26124),
(132027,'enUS','','Ooh! Your time just ran out!',26124),
(132028,'enUS','','Sorry, but... that\'s how it goes!',26124),
(132029,'enUS','','Oh, wonderful! Everything worked out!',26124),
(132030,'enUS','','Yay! I did it!',26124),
(132031,'enUS','','No... it\'s not supposed to happen this way...',26124),
(132032,'enUS','','Maybe next time...',26124),
(132033,'enUS','','Looks like it\'s my time... to...',26124),
(132034,'enUS','','This isn\'t what happens...',26124),
(132035,'enUS','','Sorry...',26124),
(132036,'enUS','','Time heals all wounds... except for... the fatal ones...',26124),
(132051,'enUS','','Arkhaan, was it? Can you tell us what happened to your people?',26124),
(132052,'enUS','Arkhaan knows, yes.','',26124),
(132062,'enUS','','Hello again!',26124),
(132063,'enUS','I\'m ready. Let\'s go!','I\'m ready. Let\'s go!',26124),
(132064,'enUS','','You ready?  There\'s no time like the present... trust me.',26124),
(132065,'enUS','','Let\'s try that again. We\'ll give ourselves a SMIDGE more time before my murder.\n\nYou ready?',26124),
(132069,'enUS','Look. The way is closed. How will we go to Isolon now?','',26124),
(132071,'enUS','','I\'m sure we can figure this out. Let me know when you\'re ready.',26124),
(132072,'enUS','This water is cursed. Do not give in to thirst.','',26124),
(132073,'enUS','Let\'s go try to save you again!','Let\'s go try to save you again!',26124),
(132074,'enUS','The man\'ari torment my kind with their fel magic rituals. Let their dark words be purged... in fire!','',26124),
(132075,'enUS','The scorched parchment you left behind will remind the Legion that our resistance cannot be silenced. Thank you.','',26124),
(132077,'enUS','<You can see the corner of a missive tucked into the courier\'s bracers.>','',26124),
(132078,'enUS','<Take the Missive>','<Take the Missive>',26124),
(132080,'enUS','<Pick up the code book.>','<Pick up the code book.>',26124),
(132082,'enUS','<The codebreaker\'s lifeless eyes stare into the sky. A thin tome rests beneath her body.>','',26124),
(132083,'enUS','','Welcome to Wyrmrest, time-traveler. The council is at your disposal, should you need us.',26124),
(132084,'enUS','','Am... am I in trouble?',26124),
(132085,'enUS','I see you are accompanied by Chronormu. Might I ask... are you here from the future, or the past?\n\nOn second thought, do not bother answering that. Such matters are best left to the bronze.','',26124),
(132086,'enUS','Something is strange about your aura, $r. Your presence seems... otherworldly, as if you do not belong here.\n\n<Kalecgos looks down at Chromie.>\n\nAh, I see. Time traveling. That... that might explain it.\n\n<Kalecgos eyes you warily.>','',26124),
(132087,'enUS','Seen anything strange lately?','Seen anything strange lately?',26124),
(132088,'enUS','','The dead walk once more.\n\nThe Ruby Dragonshrine has a history of conflict with the undead. Most of that struggle subsided with the fall of the Lich King. But as of late, such incidents have been on the rise.',26124),
(132089,'enUS','Actually, yes. The Garden Keeper at the Emerald Dragonshrine has been struggling to keep the dreamers asleep. Several of the ancients have unexpectedly awakened from the Dream, and we have yet to find out why.','',26124),
(132090,'enUS','Not particularly. The ley lines have been acting up again, but that is normal in this part of the world.','',26124),
(132091,'enUS','I see. Thank you.','I see. Thank you.',26124),
(132097,'enUS','','That sounded way better in my head than it did out loud!',26124),
(132098,'enUS','','I hope that you can find this Raalgar before the Legion does. Someone on the Vindicaar will help you.',26124),
(132099,'enUS','Did you hear that?','',26124),
(132100,'enUS','No, no... no.','',26124),
(132101,'enUS','Nnghh... Stay with us!','',26124),
(132102,'enUS','Stop! Do not listen!','',26124),
(132103,'enUS','Ah!','',26124),
(132104,'enUS','Shhh.','',26124),
(132108,'enUS','Even when tortured by the Legion, my people rebel against their accursed crusade. The demons may break their bodies, but never their wills. Go, release their spirits so that they may find peace.','',26124),
(132109,'enUS','The spirits of those who resist the Legion inspire us all.','',26124),
(132110,'enUS','','Hello again!',26124),
(132115,'enUS','<Adjust Chromie\'s talents>','<Adjust Chromie\'s talents>',26124),
(132116,'enUS','Let\'s adjust our strategy.\n|cFF0000FF(Change Chromie\'s talents).|r','Let\'s adjust our strategy.\n|cFF0000FF(Change Chromie\'s talents).|r',26124),
(132118,'enUS','I will prove once and for all that only a knight from the grave can rule heavy metal.','',26124),
(132119,'enUS','Fight though you might, your bodies will freeze and shatter!','',26124),
(132120,'enUS','Darkness falls, and with it Banshees form these Wailing Walls!','',26124),
(132121,'enUS','I summon ghouls out every tomb.  Fight as you might, they will seal your doom!','',26124),
(132122,'enUS','Another soul for my music!','',26124),
(132123,'enUS','Another soul for my armies!','',26124),
(132124,'enUS','You have failed, Blight Boar.  Your fans now serve my armies of the dead!','',26124),
(132125,'enUS','What is this?! I can\'t be beaten!','',26124),
(132126,'enUS','|TInterface\\Icons\\INV_Axe_2H_UndeadGuitar_C_01.blp:20|tPower Chords rain down, use them to |cFFFF0000|Hspell:245034|h[Blow the Mind]|h|r of your enemies!','|TInterface\\Icons\\INV_Axe_2H_UndeadGuitar_C_01.blp:20|tPower Chords rain down, use them to |cFFFF0000|Hspell:245034|h[Blow the Mind]|h|r of your enemies!',26124),
(132127,'enUS','Once you\'ve reached the Arcatraz, I will remain in contact.','',26124),
(132153,'enUS','Thank you! Thank you!','',26124),
(132154,'enUS','It will all be undone! There is nothing... but the Void.','',26124),
(132155,'enUS','You must know the truth!','',26124),
(132156,'enUS','Arkhaan will make you understand!','',26124),
(132157,'enUS','Why... they not... listen?','',26124),
(132158,'enUS','','I am sorry you had to learn this way. Rest now.',26124),
(132159,'enUS','I will go on ahead and clear a path. The bridge leading to the Xenedar seems to be the least guarded. Light be with us.','',26124),
(132160,'enUS','','Who is that?',26124),
(132161,'enUS','You will not delay me, demon!','',26124),
(132162,'enUS','Fareeya! You survived!','',26124),
(132163,'enUS','','Resist their call, Arkhaan!',26124),
(132164,'enUS','','No! What you have seen is a lie!',26124),
(132165,'enUS','','He cannot hear us! We must end his suffering.',26124),
(132166,'enUS','','We are losing him!',26124),
(132167,'enUS','','Do you feel that? Something is pulling us back...',26124),
(132170,'enUS','','Locus-Walker?',26124),
(132172,'enUS','','Not today, monster! The Light prevails!',26124),
(132175,'enUS','','You know that I refuse to die while the Legion still stands, High Exarch. Follow me. We\'ve set up a perimeter.',26124),
(132176,'enUS','You\'re not going anywhere, \"champion.\" The master has plans for you!','',26124),
(132181,'enUS','Zereketh\'s void magic still lingers here.','Zereketh\'s void magic still lingers here.',26124),
(132182,'enUS','It is ours for the taking, sister.','It is ours for the taking, sister.',26124),
(132202,'enUS','','Minions! To me!',26124),
(132204,'enUS','','A futile effort, worm!',26124),
(132206,'enUS','I am free!','',26124),
(132207,'enUS','Be cleansed, demons!','',26124),
(132208,'enUS','You will pay for your crimes, foul demons!','',26124),
(132209,'enUS','You will befoul this world no longer!','',26124),
(132210,'enUS','The devastators are no more. Surge forward!','',26124),
(132211,'enUS','What was that?','',26124),
(132212,'enUS','Show yourself!','',26124),
(132213,'enUS','An intruder?','',26124),
(132214,'enUS','Hmmm... hahahaha','',26124),
(132215,'enUS','My, my... What is this?','',26124),
(132216,'enUS','','I will find you, interloper.',26124),
(132217,'enUS','','You cannot hide.',26124),
(132218,'enUS','','I see you.',26124),
(132219,'enUS','','This is our realm, fleshling.',26124),
(132220,'enUS','','How very arrogant of you.',26124),
(132222,'enUS','','You dare enter our realm!',26124),
(132223,'enUS','','You cannot hide in this darkness!',26124),
(132224,'enUS','','Die, fleshling!',26124),
(132225,'enUS','','Their will be done!',26124),
(132226,'enUS','','Ha! Pathetic fleshling.',26124),
(132227,'enUS','','Did you think you would escape?',26124),
(132228,'enUS','','By their will.',26124),
(132229,'enUS','','Your flesh betrays you, intruder.',26124),
(132230,'enUS','','A dissimulation? What are you concealing?',26124),
(132231,'enUS','At long last, I will return home and prepare to attack. You can remain here... and die!','',26124),
(132232,'enUS','30 seconds remaining!','',26124),
(132233,'enUS','10 seconds remaining!','',26124),
(132234,'enUS','','I\'ve got you. Try again--we are safe for the moment.',26124),
(132238,'enUS','','It will be done, High Inquisitor!',26124),
(132239,'enUS','','Seekers, cover the High Inquisitor\'s departure. I will deal with this interruption!',26124),
(132241,'enUS','Today\'s MY day! I\'m a pirate... Yeah, I\'m AAAAALL the pirates!\n\nTake that, Dread Crew!','',26124),
(132242,'enUS','Ya throw this party just for me, $pr? ... Ya should have... Have a grog!','',26124),
(132244,'enUS','','The coast is clear. Try again.',26124),
(132245,'enUS','','Nearly there!',26124),
(132246,'enUS','','How did you manage that?',26124),
(132247,'enUS','I come... party... but Dread Crew parties worse than... SHADO-PAN PARTIES!\n\nHa!','',26124),
(132248,'enUS','...and I don\'t care who hears me!\n\nTake that, De Mooza... DeMeeezey... Da Foolsya!\n\nHa... Got her good...','',26124),
(132249,'enUS','If ya think THIS party doesn\'t chum bilgewater, wait\'ll ya see MY party...\n\nYa like ponies?','',26124),
(132250,'enUS','Grog, grog... I love grog!\nGrog, grog... Don\'t eat a log!\nGreg, greg... Get me some grog!\nAnd don\'t lose ya leg...\n\nCan ya believe I just made that up?','',26124),
(132251,'enUS','Stupid Giggleplanks send me... secret spynapping... never show up... I got a life too!','',26124),
(132252,'enUS','Ya pop one teeny pony and ya get thrown outta party forever... thass fine. I don\'t need pony partiess...\n\nPoniess aren\'t even real piratess... They can\'t shoot cannonss... They don\'t even have handss... Whoa...','',26124),
(132253,'enUS','Where\'d you get that pool pony?','Where\'d you get that pool pony?',26124),
(132255,'enUS','It\'s Pirates\' Day, and that means it\'s time to party!\n\nWhen ya get bored with this Dread Crew snoozefest, head south to the beach... Where REAL pirates celebrate.\n\nMe mighty Bloodsail Buccaneers be down there. Tell \'em ol\' Whiskers sent ya, and maybe they\'ll let me back in...','',26124),
(132256,'enUS','doesn\'t feel too good...','',26124),
(132257,'enUS','is feeling full...','',26124),
(132258,'enUS','is stuffed!','',26124),
(132259,'enUS','All of the power in this place now belongs to the Legion.','All of the power in this place now belongs to the Legion.',26124),
(132268,'enUS','Jump into the pit when you have |TINTERFACE\\ICONS\\SPELL_FEL_INCINERATE.BLP:20|t |cFFFF0000|Hspell:240209|h[Unstable Soul]|h|r!','Jump into the pit when you have |TINTERFACE\\ICONS\\SPELL_FEL_INCINERATE.BLP:20|t |cFFFF0000|Hspell:240209|h[Unstable Soul]|h|r!',26124),
(132277,'enUS','Overloading the weapon will draw the demons to us.','',26124),
(132278,'enUS','I\'m with you.','I\'m with you.',26124),
(132283,'enUS','Soon the entire Legion will descend upon us.','',26124),
(132284,'enUS','We will hold our ground. I only pray there are survivors among the Army of the Light.','',26124),
(132285,'enUS','It is resisting my spell. This is no mere siege weapon...','',26124),
(132286,'enUS','By the Light...','',26124),
(132295,'enUS','It\'s alive!','',26124),
(132298,'enUS','Keep its attention, Illidan. We have not come this far to fall now!','',26124),
(132299,'enUS','I\'ll do far more than that.','',26124),
(132300,'enUS','The Xenedar\'s fall shall not have been in vain!','',26124),
(132301,'enUS','Feel the hatred of ten thousand years!','',26124),
(132302,'enUS','It is not my destiny to fall at your hands, monster. I have unfinished business with your master.','',26124),
(132303,'enUS','Hold fast, $p. The goliath wavers!','',26124),
(132304,'enUS','Seize the power of the portals, Alleria! It can become your weapon!','',26124),
(132305,'enUS','','If we can trap this fiend, I can siphon his energy to keep him in check. Champions, I\'ll provide the traps; you deal with capturing him.',26124),
(132348,'enUS','Hey, that\'s ours! We saw it first!','',26124),
(132349,'enUS','Quickly, quickly! Someone tell the quartermaster!','',26124),
(132350,'enUS','This is quite a find. We\'ll be taking it from here!','',26124),
(132352,'enUS','Focus your mind. Remember your training.','',26124),
(132353,'enUS','','Arator! Turalyon!?',26124),
(132354,'enUS','The Void shows only half truths. Trust your instincts.','',26124),
(132355,'enUS','','I can\'t-- I-- Argh!',26124),
(132356,'enUS','','I won\'t let you! I am not yours to claim!',26124),
(132357,'enUS','','Begone, wretched darkness.',26124),
(132358,'enUS','Fight, curse you!','',26124),
(132359,'enUS','Be sure to collect our prize, fleshling. I will tend to Alleria.','',26124),
(132360,'enUS','The heart of a demigod. This is no mere token, Alleria.','',26124),
(132361,'enUS','Take it, and you will be one step closer to your destiny.','',26124),
(132362,'enUS','','I understand. Thank you. Both of you.',26124),
(132363,'enUS','','It\'s... cold.',26124),
(132366,'enUS','Need gold? Here\'s 50,000 coins worth.','Need gold? Here\'s 50,000 coins worth.',26124),
(132367,'enUS','They are closing in. Ready yourself, $p.','',26124),
(132368,'enUS','50,000 Gold','50,000 Gold',26124),
(132369,'enUS','Ah, you\'re alive! A beacon is inbound.','',26124),
(132370,'enUS','Hatuun\'s people saved me from the Xenedar\'s fall.','',26124),
(132371,'enUS','Many others were not so fortunate. They hold the ground around the crash site, fighting for their lives.','',26124),
(132372,'enUS','Farewell for now.','',26124),
(132373,'enUS','','Greetings, $n. You probably don\'t remember me, we met next week. Would you like to revisit the Black Temple?',26124),
(132375,'enUS','Send me into the Black Temple. (Timewalking Raid)','Send me into the Black Temple.',26124),
(132378,'enUS','Greetings, and welcome to the Mythic Invitational!\n\nI can teleport you directly into any Legion dungeon instance.\n\nMake sure you have Mythic difficulty selected before teleporting.','',26124),
(132379,'enUS','I agree. I noticed Legion slaves fleeing as we pressed our attack.','',26124),
(132380,'enUS','They could be valuable allies in our fight.','',26124),
(132381,'enUS','I want to go to Karazhan (Dungeon).','I want to go to Karazhan (Dungeon).',26124),
(132382,'enUS','You assume much of their loyalties. Risk your life if you must. I will prepare our forces for the inevitable counterattack.','',26124),
(132383,'enUS','As you wish. Come, $p. I can feel their presence not far from here.','',26124),
(132384,'enUS','Not all of my people left Argus when Archimonde and Kil\'jaeden made their pact with the Dark Titan.','',26124),
(132385,'enUS','Many joined the Legion willingly, giving in to Sargeras\' false promises of power and glory.','',26124),
(132386,'enUS','Those who realized the truth sought escape, but found themselves trapped in this nightmare. How they have survived this long I do not know.','',26124),
(132387,'enUS','Return the talbuk to the Krokul at the entrance to the forest!','Return the talbuk to the Krokul at the entrance to the forest!',26124),
(132388,'enUS','Place the beacon at my location. We\'re coming home.','',26124),
(132389,'enUS','Our troops will finish securing the Xenedar. Though we retrieved its most precious cargo, we cannot let the vessel fall into the Legion\'s hands.','',26124),
(132390,'enUS','','<Insert neat RP moment where she absorbs the Heart of Nhal\'atoth here.>',26124),
(132409,'enUS','','The greatest wound imaginable is that our people would betray us so. It still festers, so many years later.$b$bWounds such as these must be cleansed, purified. The rot must be excised and destroyed before true healing can begin.',26124),
(132410,'enUS','','Did somebody call for the doctor? Too bad, there are Legion to fight!',26124),
(132411,'enUS','','Are you wounded? You seem fine. I\'m sure a fine meal will bring you back to fighting shape in no time.',26124),
(132412,'enUS','','These traitors will never defeat us, for we walk in the Light.',26124),
(132413,'enUS','Their next blast will decimate us--unless we strike first.','',26124),
(132414,'enUS','We must destroy the weapon while it is still recharging! Romuul, deploy a beacon below!','',26124),
(132417,'enUS','Beacon deployed, Prophet!','',26124),
(132418,'enUS','','Have you come to give us reprieve from the ceaseless tide?',26124),
(132419,'enUS','Activating transport array.','',26124),
(132420,'enUS','On your mark, $p.','',26124),
(132421,'enUS','','Few among us still wield true magic after we saw what tempted our brethren. I will take any advantage I can get.',26124),
(132422,'enUS','','By blade and spell, we make our stand against our enemies. We cannot rely too heavily on one or the other.',26124),
(132423,'enUS','','Bormos over there has a great saying for times like this: \"Give me a hundred Lightforged. Barring that, a thousand regular troops.\"',26124),
(132424,'enUS','Enemy contact. Deploying arsenal.','',26124),
(132425,'enUS','','Our people were greedy, lusting for power. I have faith in the Light, and I have all the power I need to show them the error of their ways.',26124),
(132426,'enUS','Enemy combatants detected. Threat level nominal.','',26124),
(132427,'enUS','Targets cleared.','',26124),
(132428,'enUS','Critical system failure...','',26124),
(132429,'enUS','Targets acquired for decimation.','',26124),
(132430,'enUS','Cannon primed for annihilation.','',26124),
(132431,'enUS','Weapon system primed, target locked.','',26124),
(132432,'enUS','Leave none alive.','',26124),
(132433,'enUS','Apocalypse drive engaged.','',26124),
(132434,'enUS','Systems re-engaged, rerouting power. Weapons primed.','',26124),
(132435,'enUS','One shot, one kill.','',26124),
(132436,'enUS','While vile demons still draw breath, there can be no peace.$b$bWhile faithless traitors still live, there can be no forgiveness.','',26124),
(132437,'enUS','I understand it when my quarry runs. However, they are only going to die tired.','',26124),
(132438,'enUS','They\'ve got us surrounded again. Poor fools.','',26124),
(132439,'enUS','','Take off yer shoes, grab a grog, and share a joke with me!',26124),
(132440,'enUS','Sure, tell me a joke.','Sure, tell me a joke.',26124),
(132441,'enUS','Your jokes are the best!','Your jokes are the best!',26124),
(132442,'enUS','Your jokes are terrible!','Your jokes are terrible!',26124),
(132443,'enUS','The Light guides my arrow. There is nowhere the darkness can hide when exposed to its glorious incandescence.','',26124),
(132445,'enUS','','Yeah? Well yer face is terrible... and so is yer mother!',26124),
(132446,'enUS','','Ha! I\'d like to see ye do better, scallywag!',26124),
(132447,'enUS','','Go keelhaul yerself, ye bilge-sucking carouser.',26124),
(132448,'enUS','','I\'ll cleave ye to the brisket!',26124),
(132449,'enUS','','Shut yer trap or I\'ll run ye through, ye pathetic pirate wannabe!',26124),
(132451,'enUS','','Shut yer squiffy grog hole and walk the plank, ye son of a biscuit eater!',26124),
(132452,'enUS','','Go dance with Jack Ketch, and leave the jokes to the old salt.',26124),
(132454,'enUS','','A black spot upon ye and all yer cockroach friends!',26124),
(132455,'enUS','','Thank ye kindly, ye old sea dog.',26124),
(132456,'enUS','','I\'ll cut ye fer... Oh wait, ye liked em? Thank ye. Nobody ever says they like \'em.',26124),
(132457,'enUS','','I\'ve trained over countless oceans and pillages. This be authentic pirate humor!',26124),
(132458,'enUS','','Yarrr! Splice the mainbrace!',26124),
(132459,'enUS','','No hornswaggle? I thank ye kindly for that, friend.',26124),
(132460,'enUS','','Aye, then buy me a clap of thunder, would ye?',26124),
(132461,'enUS','','Spread the word. Tell \'em ol\' Bad News ain\'t so bad afterall.',26124),
(132462,'enUS','','Thank ye, matey. Treasure ain\'t always found in chests.',26124),
(132463,'enUS','','Alright, batten down yer hatches, mateys. This one\'ll blow yer rudder off...',26124),
(132464,'enUS','','Ha, now someone get me a grog.',26124),
(132465,'enUS','','I was drinkin\' with a Dread Crew gunner in Booty Bay last week...',26124),
(132466,'enUS','','After a few drinks, he looked me in the eyes and asked how the Bloodsail got to be so great...',26124),
(132467,'enUS','','I raised my mug and told him we just ARRR!',26124),
(132468,'enUS','Come, let us show Sargeras\' ilk what they have brought upon themselves.','',26124),
(132469,'enUS','Hold your ground! We must protect the Vindicaar with our lives!','',26124),
(132470,'enUS','Hello, $p! Come learn about Moonkin at the Moonkin Festival in Moonglade!','',26124),
(132471,'enUS','The Moonkin Festival is soon! Come to Moonglade when it starts to find out what it\'s all about!','',26124),
(132472,'enUS','The Moonkin Festival begins soon! Be sure to visit Moonglade when it starts to learn more!','',26124),
(132473,'enUS','Learn the ways of the Moonkin at the Moonkin Festival in Moonglade!','',26124),
(132474,'enUS','','So I was gettin\' me ears pierced by Pretty Boy Duncan on the Brashtide yesterday...',26124),
(132475,'enUS','','Ye know how he is. Always a perfectionist. Took two hours, and at the end of it I asked him how much I owed. He said...',26124),
(132476,'enUS','','Just a buccaneer!',26124),
(132477,'enUS','','So Captain Salthoof got his first ship pretty quickly, right?',26124),
(132478,'enUS','','I asked him how much he had to bribe the admiral with to make that happen, and he told me his secret...',26124),
(132479,'enUS','','He got it on sail!',26124),
(132480,'enUS','','This is one of \'em brain puzzles...',26124),
(132481,'enUS','','What has six legs, six hands, and six eyes?',26124),
(132482,'enUS','','Six pirates!',26124),
(132483,'enUS','','Ye all know crazy Rear Admiral Giggleplanks, right?',26124),
(132484,'enUS','','Did ye know he once used his gnomish gizmos to combine a parrot and shark into the ultimate pirate companion?',26124),
(132485,'enUS','','It worked great... until it talked his ear off!',26124),
(132486,'enUS','','So what\'s the deal with treasure chests nowadays? They\'re so expensive and shiny...',26124),
(132487,'enUS','','It\'s like we want people to find \'em! All that shiny gold edging and gem-encrusted locks...',26124),
(132488,'enUS','','It\'s like, are we storing treasure on the OUTside or the INside? Right?',26124),
(132489,'enUS','Your mother and father yet live, Arator. I am sure of it. But for now, stay focused on the fight to come.','',26124),
(132496,'enUS','We are legion!','We are legion!',26124),
(132497,'enUS','I am the fury of a thousand conquered worlds.','I am the fury of a thousand conquered worlds.',26124),
(132498,'enUS','You have seen but a fraction of our might.','You have seen but a fraction of our might.',26124),
(132499,'enUS','I will be heralded for your demise.','I will be heralded for your demise.',26124),
(132500,'enUS','Azeroth will fall!','Azeroth will fall!',26124),
(132501,'enUS','You dare set foot in our world?','You dare set foot in our world?',26124),
(132502,'enUS','Bow before the master\'s armies!','Bow before the master\'s armies!',26124),
(132503,'enUS','You will know true pain!','You will know true pain!',26124),
(132504,'enUS','','We are legion!',26124),
(132505,'enUS','','I am the fury of a thousand conquered worlds.',26124),
(132506,'enUS','','You have seen but a fraction of our might.',26124),
(132507,'enUS','','I will be heralded for your demise.',26124),
(132508,'enUS','','Azeroth will fall!',26124),
(132509,'enUS','','You dare set foot in our world?',26124),
(132510,'enUS','','Bow before the master\'s armies!',26124),
(132511,'enUS','','You will know true pain!',26124),
(132512,'enUS','Burn in the flames of Sargeras!','Burn in the flames of Sargeras!',26124),
(132513,'enUS','Fuel for the fel.','Fuel for the fel.',26124),
(132514,'enUS','None can stop our crusade!','None can stop our crusade!',26124),
(132515,'enUS','Azeroth will be ours.','Azeroth will be ours.',26124),
(132516,'enUS','Bare your soul to me.','Bare your soul to me.',26124),
(132517,'enUS','Chaos reigns.','Chaos reigns.',26124),
(132518,'enUS','All will bow before the Destroyer.','All will bow before the Destroyer.',26124),
(132519,'enUS','You are doomed.','You are doomed.',26124),
(132520,'enUS','','Burn in the flames of Sargeras!',26124),
(132521,'enUS','','Fuel for the fel.',26124),
(132522,'enUS','','None can stop our crusade!',26124),
(132523,'enUS','','Azeroth will be ours.',26124),
(132524,'enUS','','Bare your soul to me.',26124),
(132525,'enUS','','Chaos reigns.',26124),
(132526,'enUS','','All will bow before the Destroyer.',26124),
(132527,'enUS','','You are doomed.',26124),
(132528,'enUS','Lend me your strength, $p. We will finish this together!','',26124),
(132529,'enUS','Aardon\'sha, kir kah\'los!','',26124),
(132530,'enUS','','Now it says here that their leader is up on one of those floating discs above us. Time to go take him out!',26124),
(132535,'enUS','We will join you at the weapon, $p.','',26124),
(132538,'enUS','You must stop... the great nightmare...','',26124),
(132539,'enUS','Seek your answer... by the water...','',26124),
(132540,'enUS','Your attacker lies... within the dragon\'s palm...','',26124),
(132542,'enUS','Say the word when you are ready to begin. No doubt we will soon have company.','',26124),
(132543,'enUS','','<The essence of Eonar hovers before you. Though her beauty and purity is palpable, you can sense her sorrow and dread.>',26124),
(132546,'enUS','We will defend you, Lifebinder.','We will defend you, Lifebinder.',26124),
(132551,'enUS','I am ready to go to the Arcatraz.','I am ready to go to the Arcatraz.',26124),
(132552,'enUS','Greetings.','',26124),
(132553,'enUS','Get your outfits ready! The Trial of Style starts soon!','',26124),
(132554,'enUS','Hey, $p. You need to step up your style game. The Trial of Style begins soon!','',26124),
(132555,'enUS','Visit Warpweaver Tuviss in Dalaran or any other Transmogrifier to enter the Trial of Style!','',26124),
(132556,'enUS','Think you\'re a trend setter? Visit Warpweaver Tuviss or any Transmogrifier to enter the Trial of Style!','',26124),
(132557,'enUS','Help me...','',26124),
(132558,'enUS','Stop this torment...','',26124),
(132559,'enUS','The enemy... they\'re... in the dream...','',26124),
(132561,'enUS','What was it you said again?','What was it you said again?',26124),
(132567,'enUS','','You\'ve got to work on your moves, $p! We\'re going to be hosting dance parties in the Stormwind and Orgrimmar auction houses!',26124),
(132568,'enUS','','We\'re going to be taking over the Stormwind and Orgrimmar auction houses for a dance party! I better see you there!',26124),
(132569,'enUS','','Everybody dance now! We\'ve taken over the Stormwind and Orgrimmar auction houses for a dance party!',26124),
(132570,'enUS','','Come and bring your good vibes to our dance parties at the Stormwind and Orgrimmar auction houses!',26124),
(132577,'enUS','Ready when you are.','Ready when you are.',26124),
(132578,'enUS','','I think we should start our investigation by talking to a bronze dragon of some sort.',26124),
(132582,'enUS','The Kirin Tor will be sponsoring a Tavern Crawl soon! Come to the Legerdemain Lounge when it starts and try some tasty drinks and food!','',26124),
(132583,'enUS','I know this shrine has been abandoned for a few years now, but... really? Shambling skeletal remains? Father would never have approved of this.','',26124),
(132584,'enUS','Me? Why does everyone always suspect the black dragon? I\'m ashamed, Chronormu.$b$bNo, I know nothing about an attack. I was simply visiting Northrend for... my own amusement, let\'s say. I was, however, surprised to see this skeletal infestation here in our beloved dragonshrine. If you\'re looking for someone who might take umbrage at a dragon, you might start with these undead, and whomever might be controlling them.','',26124),
(132585,'enUS','','How can I help you?',26124),
(132586,'enUS','','We are. Usually only one or two stray ghouls trickle in each day, but today they\'ve attacked in numbers we haven\'t seen in nearly ten years.',26124),
(132587,'enUS','','Yes? What is it I can do for you?',26124),
(132588,'enUS','','We have. The dreamers have been restless. It\'s been... overwhelming.',26124),
(132589,'enUS','Yes? What does the bronze dragonflight want here?','',26124),
(132590,'enUS','Honestly, I\'m not sure. It\'s quite possible. The ley lines have always been fussy in this part of the world, but today, they\'re acting particularly strange. There\'s something interfering with them.','',26124),
(132591,'enUS','We\'re trying to find out who\'s about to attack Chromie. We thought you might know something.','We\'re trying to find out who\'s about to attack Chromie. We thought you might know something.',26124),
(132592,'enUS','Understood.','Understood.',26124),
(132593,'enUS','We\'re trying to find out who\'s about to attack Chromie. We heard you were having problems with the undead.','We\'re trying to find out who\'s about to attack Chromie. We heard you were having problems with the undead.',26124),
(132594,'enUS','We will help you defend the dragonshrine.','We will help you defend the dragonshrine.',26124),
(132595,'enUS','We\'re trying to find out who\'s about to attack Chromie. Seen anything strange?','We\'re trying to find out who\'s about to attack Chromie. Seen anything strange?',26124),
(132596,'enUS','We can help.','We can help.',26124),
(132597,'enUS','We\'re trying to find out who\'s about to attack Chromie. We\'ve heard you\'re having trouble with the ley lines - do you think that could be related?','We\'re trying to find out who\'s about to attack Chromie. We\'ve heard you\'re having trouble with the ley lines - do you think that could be related?',26124),
(132598,'enUS','We can help.','We can help.',26124),
(132610,'enUS','The source of Raalgar\'s immortality is gone. At long last you can kill him and retrieve the Fel Heart of Argus.','',26124),
(132612,'enUS','I hope you\'re thirsty, $p! Visit Anebria Sunwine in the Legerdemain Lounge to join the others on the Kirin Tor Tavern Crawl!','',26124),
(132618,'enUS','Drink and be merry during the Kirin Tor Tavern Crawl! Go find Anebria Sunwine at the Legerdemain Lounge to join the others!','',26124),
(132630,'enUS','|TInterface\\ICONS\\ABILITY_HUNTER_SNIPERSHOT.BLP:20|t You are targeted for |cFFF00000|Hspell:244536|h[Fel Bombardment]|h|r!','',26124),
(132631,'enUS','|TInterface\\ICONS\\Ability_BossFelMagnaron_HandEmpowered.blp:20|t %s is powering the |cFFF00000|Hspell:244152|h[Apocalypse Drive]|h|r!','',26124),
(132632,'enUS','','You must go to their aid, Turalyon. I will scout behind enemy lines and provide a distraction. We will return soon, Arator.',26124),
(132633,'enUS','','And what then? I was locked in a cell for delving into the Void against her wishes. Will she make me a prisoner again? Or worse?',26124),
(132637,'enUS','What is it, Romuul?','What is it, Romuul?',26124),
(132638,'enUS','For a new vessel, the Vindicaar\'s list of repairs is endless. How can I help you?','',26124),
(132639,'enUS','What will happen if the Legion get\'s the Stone before we do?','What will happen if the Legion get\'s the Stone before we do?',26124),
(132640,'enUS','REUSE ME','',26124),
(132641,'enUS','REUSE ME','',26124),
(132642,'enUS','Can you tell me where to look?','Can you tell me where to look?',26124),
(132643,'enUS','REUSE ME','',26124),
(132644,'enUS','Thank you, Romuul.','Thank you, Romuul.',26124),
(132647,'enUS','REUSE ME','',26124),
(132649,'enUS','Make quick work of this intruder. Lah\'zaruun needs time to get the High Inquisitor to Argus!','Make quick work of this intruder. Lah\'zaruun needs time to get the High Inquisitor to Argus!',26124),
(132652,'enUS','Ah, the hero comes too late. Our mistress will have freed the High Inquisitor by now.','Ah, the hero comes too late. Our mistress will have freed the High Inquisitor by now.',26124),
(132658,'enUS','','|TInterface\\Icons\\INV_Misc_Herb_Arrowbloom.blp:20|tCaptain Yathae Moonstrike is aiming |cFFFF0000|Hspell:236304|h[Incorporeal Shot]|h|r!',26124),
(132659,'enUS','','|TInterface\\Icons\\ABILITY_DRUID_ECLIPSE.BLP:20|tPriestess Lunaspyre has cast |cFFFF0000|Hspell:233263|h[Embrace of the Eclipse]|h|r!',26124),
(132660,'enUS','','|TInterface\\Icons\\ABILITY_UPGRADEMOONGLAIVE.BLP:20|tHuntress Kasparian is casting |cFFFF0000|Hspell:236480|h[Glaive Storm]|h|r!',26124),
(132664,'enUS','A swarm of demons threaten the Vindicaar once more. Send their fetid souls screaming back to the halls of Antorus.','',26124),
(132665,'enUS','Well fought. Should the Legion ever bring down the Vindicaar, Argus will be our grave.','',26124),
(132666,'enUS','The High Inquisitor\'s return bodes well for us. Argus will soon be rid of this vermin.','The High Inquisitor\'s return bodes well for us. Argus will soon be rid of this vermin.',26124),
(132685,'enUS','Good work. Velen and I will meet you at the Crown of Destruction to stop the antaen while we still can.','',26124),
(132686,'enUS','Prepare yourselves to board the Vindicaar. Raalgar will be ready soon.','Prepare yourselves to board the Vindicaar. Raalgar will be ready soon.',26124),
(132687,'enUS','Yes, captain!','Yes, captain!',26124),
(132689,'enUS','I was so close! You are not worthy to stop me, worm!','',26124),
(132694,'enUS','','And what then? She had me locked in a cell for harnessing the power of the Void. Will she put me in chains for my defiance? Or worse?',26124),
(132695,'enUS','I sense Xe\'ra in the central chamber. Thank the Light! We are not too late.','',26124),
(132697,'enUS','Xe\'ra will see that you risked your life to save her. Her faith in you will be restored--I know it!','',26124),
(132698,'enUS','Come, champion. Help me guide her to the Vindicaar. Then we can get out of here!','',26124),
(132699,'enUS','Xe\'ra! Don\'t worry, you are safe now.','',26124),
(132700,'enUS','','The upper deck of the ship is this way. Xe\'ra will have much to say... to all of us.',26124),
(132701,'enUS','','Oh, but I was just getting started. She will make a fine ornament for the Burning Throne!',26124),
(132702,'enUS','','No! This trophy is mine! A gift for our great master!',26124),
(132703,'enUS','','You will lose in the end. The Sisters will see...',26124),
(132704,'enUS','Look out!','',26124),
(132705,'enUS','Whatever that thing was, I doubt that was the only one in Sargeras\' arsenal.','',26124),
(132708,'enUS','I will bear the brunt of its attacks for as long as I can, but you must destroy it while we still stand!','',26124),
(132709,'enUS','Then let us see it done. We stand together.','',26124),
(132715,'enUS','','Archenon poros, Prophet. The Army of the Light stands with you.',26124),
(132716,'enUS','We seek the Sigil of Awakening. Archimonde may have left it in the Conservatory.','',26124),
(132717,'enUS','','Understood. I have just the person for the job: Y\'mera.',26124),
(132718,'enUS','','Right away, Captain.',26124),
(132719,'enUS','','Enaara, see that these spirits remain under control.',26124),
(132720,'enUS','One minute till Blight Boar takes the stage! Join us in the Cauldron of Rock on the east side of the island.','',26124),
(132721,'enUS','','The rest of you, secure the area.',26124),
(132722,'enUS','|TInterface\\Icons\\WARRIOR_DISRUPTINGSHOUT.BLP:20|tDevlynn Styx leaps down to unleash her |cFFFF0000|Hspell:245150|h[Screams]|h|r at the Death Metal Knight!','|TInterface\\Icons\\WARRIOR_DISRUPTINGSHOUT.BLP:20|tDevlynn Styx leaps down to unleash her |cFFFF0000|Hspell:245150|h[Screams]|h|r at the Death Metal Knight!',26124),
(132723,'enUS','|TInterface\\Icons\\SPELL_DEATHKNIGHT_ARMYOFTHEDEAD.BLP:20|tThe Metal Knight summons an |cFFFF0000|Hspell:245162|h[Army of the Dead]|h|r to attack Devlynn Styx!','|TInterface\\Icons\\SPELL_DEATHKNIGHT_ARMYOFTHEDEAD.BLP:20|tThe Metal Knight summons an |cFFFF0000|Hspell:245162|h[Army of the Dead]|h|r to attack Devlynn Styx!',26124),
(132726,'enUS','The dragon comes! Felstalkers, hunt her down!','',26124),
(132728,'enUS','','Hmm. The Gatekeeper is inactive.',26124),
(132729,'enUS','','With the power of the seal we can travel directly to the Chamber of the Avatar.',26124),
(132730,'enUS','Teleport to the Chamber of the Avatar.','Teleport to the Chamber of the Avatar.',26124),
(132731,'enUS','The legion must be stopped!','',26124),
(132732,'enUS','Return to The Breach.','Return to The Breach.',26124),
(132738,'enUS','','Would you look at the time! Only about ten minutes left...',26124),
(132739,'enUS','','There\'s five minutes left. You think we\'ll finish in time?',26124),
(132740,'enUS','','One minute remaining. Cutting it a little close, aren\'t we?',26124),
(132741,'enUS','','I sense treasure nearby.',26124),
(132742,'enUS','','Can you feel it? There\'s treasure somewhere around here.',26124),
(132743,'enUS','','Freeze!',26124),
(132744,'enUS','','Stop right there!',26124),
(132745,'enUS','In the other corner, a golem with a magnetic personality. Watch out, this golem\'s gonna Klunk you up!','',26124),
(132746,'enUS','','In the other corner, a golem with a magnetic personality. Watch out, this golem\'s gonna Klunk you up!',26124),
(132747,'enUS','The way is clear. Fire!','',26124),
(132748,'enUS','Be purged by the Light!','',26124),
(132749,'enUS','Behold the might of the Vindicaar!','',26124),
(132750,'enUS','Legion Devastators are pummeling our forces. Lower their protective barriers and we will show them the power of the Vindicaar!','',26124),
(132751,'enUS','Excellent work. The Vindicaar is safe once more.','',26124),
(132793,'enUS','Once we prevent it from firing, the antaen will surely turn its attack upon us.','',26124),
(132798,'enUS','Prepare yourselves. It rises!','',26124),
(132799,'enUS','We cannot handle another attack from these creatures. We must end this now.','',26124),
(132800,'enUS','I will overwhelm it with energy before it can fire. I need only a moment.','',26124),
(132801,'enUS','It... is... working!','',26124),
(132802,'enUS','','I will defend Argus to my dying breath!',26124),
(132803,'enUS','','The armies of a thousand worlds will rise against you. You are damned!',26124),
(132804,'enUS','','Do you think me a fool? Fiends, to me!',26124),
(132805,'enUS','','I will be reborn by Argus\' flame! I will never... stop... fighting.',26124),
(132806,'enUS','Somethin\' smell off about this grain to you?','Somethin\' smell off about this grain to you?',26124),
(132807,'enUS','A bit, I guess. Not my problem.','A bit, I guess. Not my problem.',26124),
(132808,'enUS','Easy there, Pepper. What\'s gotten into you?','Easy there, Pepper. What\'s gotten into you?',26124),
(132809,'enUS','is looking for an opponent!','is looking for an opponent!',26124),
(132810,'enUS','So much grain! The farmers really outdid themselves this week.','So much grain! The farmers really outdid themselves this week.',26124),
(132811,'enUS','Better start distributing it to the rest of the townsfolk. People need to eat.','Better start distributing it to the rest of the townsfolk. People need to eat.',26124),
(132812,'enUS','','What on earth was that?',26124),
(132813,'enUS','$n wins the match!','$n wins the match!',26124),
(132814,'enUS','','Champions! The forces of the Legion seek to capture my essence for their infernal master!',26124),
(132815,'enUS','','Defeat them before they reach me, or all is lost.',26124),
(132816,'enUS','','My resistance wanes. Should Sargeras prevail, all life will fall to darkness.',26124),
(132817,'enUS','','The last of my strength... ebbs away. I will not... be able to stop them...',26124),
(132818,'enUS','','It ends. My life... forever bound... to Sargeras...',26124),
(132822,'enUS','|TINTERFACE\\ICONS\\WARLOCK_CURSE_SHADOW_AURA.BLP:20|t Void-Blade Zedaat begins to cast |cFFFF0404|Hspell:246340|h[Nether Eruption]|h|r! Run!','|TINTERFACE\\ICONS\\WARLOCK_CURSE_SHADOW_AURA.BLP:20|t Void-Blade Zedaat begins to cast |cFFFF0404|Hspell:246340|h[Nether Eruption]|h|r! Run!',26124),
(132828,'enUS','Use this key to go through the Town Hall. You can get to the back roads of Stratholme through there.','',26124),
(132829,'enUS','|TINTERFACE\\ICONS\\INV_KNIFE_1H_FIRELANDSRAID_D_01.BLP:20|t Aggramar begins a |cFFFF0404|Hspell:244688|h[Taeshalach Technique]|h|r!','|TINTERFACE\\ICONS\\INV_KNIFE_1H_FIRELANDSRAID_D_01.BLP:20|t Aggramar begins a |cFFFF0404|Hspell:244688|h[Taeshalach Technique]|h|r!',26124),
(132850,'enUS','Argus Volcano is erupting.','',26124),
(132851,'enUS','The power of the Guardian\'s Seal fades.','The power of the Guardian\'s Seal fades.',26124),
(132852,'enUS','|TInterface\\Icons\\SPELL_SHADOW_PAINSPIKE:20|tA\'nutsu starts casting |cFFFF0404|Hspell:245164|h[Fragment of Despair]|h|r','',26124),
(132853,'enUS','|TINTERFACE\\ICONS\\ability_fixated_state_red.blp:20|t Zuraal the Ascended has fixated on you!','',26124),
(132854,'enUS','|TInterface\\Icons\\spell_shadow_painspike:20|tYou are afflicted by  |cFFFF0000|Hspell:233983|h[Echoing Anguish]|h|r!','|TInterface\\Icons\\spell_shadow_painspike:20|tYou are afflicted by  |cFFFF0000|Hspell:233983|h[Echoing Anguish]|h|r!',26124),
(132855,'enUS','|TInterface\\Icons\\SPELL_FIRE_ELEMENTALDEVASTATION:20|tArmageddon impacted the platform, causing an |cFFFF0000|Hspell:240908|h[Armageddon Blast]|h|r!','|TInterface\\Icons\\SPELL_FIRE_ELEMENTALDEVASTATION:20|tArmageddon impacted the platform, causing an |cFFFF0000|Hspell:|h[Armageddon Blast]|h|r!',26124),
(132856,'enUS','','I know who you will be fighting.$b$bArchimonde gave them each a title to acknowledge their substantial knowledge of their craft.$b$bSadly, all of them sided with the Legion. This is a rare opportunity to see them as they once were.',26124),
(132857,'enUS','Tell me about Grand Vizier Jarasum.','Tell me about Grand Vizier Jarasum.',26124),
(132858,'enUS','Tell me about High Wakener Aargon.','Tell me about High Wakener Aargon.',26124),
(132859,'enUS','Tell me about Arc-Consul Velara.','Tell me about Arc-Consul Velara.',26124),
(132860,'enUS','','Ah, the Grand Vizier.\n\nHe acted as the Arc-Consul\'s second and oversaw much of the day to day operations in the Conservatory.\n\nWhen discipline was needed, it was often his voice that would ring out. He was not well liked, but he was respected nonetheless.\n\nIt is my understanding that he changed his name to Jaraxxus when he took the Legion\'s fel magics for his own.\n\nBeyond that, I know nothing of his fate.',26124),
(132861,'enUS','Tell me about the others.','Tell me about the others.',26124),
(132862,'enUS','','Arc-Consul Velara answered only to Archimonde himself.\n\nShe was a focused and quiet individual, as I recall. Parallel to the Wakener\'s guild, she led the Consulate in the pursuit of the powers of creation.\n\nUnder her tutelage we vastly expanded our ability to summon creatures of the arcane. The familiars that linger here still bear marks of her expertise. She was also largely responsible for cultivating the shield technology that we use even now.\n\nShe took the name Velysra and the title of Archmage when she joined the Legion.\n\nI hope you shall never meet her, $n.',26124),
(132863,'enUS','','High Wakener Aargon. Where to start?\n\nHe ascended to his position only after his predecessor Thal\'kiel was banished. That is a story for another time, if you are not familiar with it. \n\nNeedless to say he was... an opportunist.\n\nUnder his influence we delved deeply into the mysteries of soulbinding. The constructs that roam these streets are his doing. They represent but a fraction of what the Wakeners could do.\n\nUnder the Legion he became Aargoss. \n\nTo the Army of the Light he was known as the Soulcleaver. Where soul engines operated, Aargoss was never far away.',26124),
(132864,'enUS','Speak, stranger.','',26124),
(132865,'enUS','I challenge you to a duel.','I challenge you to a duel.',26124),
(132866,'enUS','You will bow when addressing the High Wakener.','',26124),
(132867,'enUS','','<Velara looks you over impassively.>\n\nYes?',26124),
(132868,'enUS','You face Jarasum, Grand Vizier of the Conservatory!','',26124),
(132869,'enUS','','I will not restrain myself. Let us begin.',26124),
(132870,'enUS','A fool\'s errand, but I will indulge you.','',26124),
(132871,'enUS','I suppose that qualifies as a victory.','',26124),
(132872,'enUS','Hmph. It is finished then.','',26124),
(132873,'enUS','','Enough. You have proven your worth.',26124),
(132874,'enUS','With Light\'s Heart, we can restore Xe\'ra to her full glory.$b$bThe sooner we do this, the sooner we grow stronger against the Legion.','',26124),
(132875,'enUS','Let us begin, Turalyon.','Let us begin, Turalyon.',26124),
(132892,'enUS','The Legion has built up stores of ammunition to use against us. Thin out their forces and mark the stockpiles as targets for the Vindicaar\'s guns. Then... get out of the way!','',26124),
(132894,'enUS','ph','',26124),
(132895,'enUS','The Legion\'s cannons have gone silent, thanks to you.','',26124),
(132898,'enUS','|TINTERFACE\\ICONS\\INV_ENCHANT_VOIDSPHERE.BLP:20|t Slay the Void Images before they can cast |cFFFF0404|Hspell:246483|h[Oblivion Tear]|h|r!','|TINTERFACE\\ICONS\\INV_ENCHANT_VOIDSPHERE.BLP:20|t Slay the Void Images before they can cast |cFFFF0404|Hspell:246483|h[Oblivion Tear]|h|r!',26124),
(132899,'enUS','','Follow me!',26124),
(132900,'enUS','','Take out each of their reinforcement points!',26124),
(132901,'enUS','|TInterface\\ICONS\\ABILITY_MAGE_FIRESTARTER.BLP:20|t You are targeted for |cFFF00000|Hspell:244410|h[Decimation]|h|r!','',26124),
(132925,'enUS','|TINTERFACE\\ICONS\\SPELL_FEL_INCINERATE.BLP:20|t A legion cruiser prepares to fire a |cFFFF0000|Hspell:244627|h[Fusillade]|h|r!','|TINTERFACE\\ICONS\\SPELL_FEL_INCINERATE.BLP:20|t A legion cruiser prepares to fire a |cFFFF0000|Hspell:244627|h[Fusillade]|h|r!',26124),
(132929,'enUS','Are you ready to begin the Trial of Tenacity?','',26124),
(132934,'enUS','I am ready.','I am ready.',26124),
(132936,'enUS','This challenge is very simple. Enter, and proceed until you reach the other side of the structure.','',26124),
(132946,'enUS','Sorry, I missed that. Can you go back a step?','Sorry, I missed that. Can you go back a step?',26124),
(132950,'enUS','It is designed to kill you. Best of luck.','',26124),
(132951,'enUS','I\'m confused. What did you say before this?','I\'m confused. What did you say before this?',26124),
(132953,'enUS','Try not to let the beams touch you. I imagine it is quite painful.','',26124),
(132958,'enUS','I hear you...','',26124),
(132959,'enUS','There you are...','',26124),
(132960,'enUS','Keep the Ruby Shrinewardens occupied. I shall carry out our master\'s attack from within the great tree itself.','',26124),
(132962,'enUS','Mind the stairs.','',26124),
(132970,'enUS','If it interests you to know, I was once the keeper of the Conservatory\'s keys, custodian to all of its locks and gates.$b$bTo halt the ravages of time, I placed my soul inside this construct. And so it is that I watch over the Conservatory for all eternity.$b$bIt will forever be my burden to deal with the likes of you.','',26124),
(132971,'enUS','I see that you are either very fast or very persistent. But is it enough to prove your tenacity I wonder?$b$b<Quoram makes a noise akin to humming.>','',26124),
(132972,'enUS','Please.','Please.',26124),
(132973,'enUS','Fine. This trial is complete. Merely because I seem to have run out of space in which to test you.','',26124),
(132995,'enUS','Fools! We shall push you back. Our mission will not be jeopardized!','',26124),
(132996,'enUS','We will not be pushed out! Bring in more forces from the Void to deal with these intruders!','',26124),
(132997,'enUS','We are being overrun! Get in there and deal with this incursion!','',26124),
(132998,'enUS','It seems this nuisance requires a more personal touch. I shall handle you myself!','',26124),
(133000,'enUS','Your help is most welcome, Fareeya.','',26124),
(133010,'enUS','Yes, master. It shall be done, at the exact time that you specified. The bronze dragon will see nothing. One shot from outside the Obsidian Dragonshrine is all I require.','',26124),
(133015,'enUS','Oh, you made it. Wonderful.','',26124),
(133016,'enUS','I suppose you would like me to return you to the Conservatory entrance.','',26124),
(133017,'enUS','Is the trial complete?','Is the trial complete?',26124),
(133018,'enUS','Your interference will not impede our progress. All will serve the void, or fall to it.','',26124),
(133019,'enUS','Now you shall see firsthand the fruits of our labor. Behold, Zuraal the Ascended! The first to embrace the void in its entirety!','',26124),
(133020,'enUS','','You found it! Such power... I can feel it from here.',26124),
(133021,'enUS','','Bring it to me--quickly. We have established a safe perimeter below.',26124),
(133022,'enUS','The Necrodark... I thought those vile cultists had been wiped out long ago.\n\nNo time like the present to finish the job. I can take us into Neltharion\'s Vault.','',26124),
(133027,'enUS','Chromie has died.','Chromie has died.',26124),
(133028,'enUS','|TInterface\\ICONS\\SPELL_WARLOCK_DEMONICPORTAL_PURPLE:20|tA void tear has appeared at the Crumbling Ruins!','',26124),
(133029,'enUS','|TInterface\\ICONS\\SPELL_WARLOCK_DEMONICPORTAL_PURPLE:20|tA void tear has appeared at the Lower Nether Gate!','',26124),
(133030,'enUS','|TInterface\\ICONS\\SPELL_WARLOCK_DEMONICPORTAL_PURPLE:20|tA void tear has appeared at the Upper Void Breach!','',26124),
(133031,'enUS','|TInterface\\ICONS\\SPELL_WARLOCK_DEMONICPORTAL_PURPLE:20|tA void tear has appeared at the Lower Void Breach!','',26124),
(133032,'enUS','|TInterface\\ICONS\\SPELL_WARLOCK_DEMONICPORTAL_PURPLE:20|tA void tear has appeared at the Ruined Overlook!','',26124),
(133033,'enUS','|TInterface\\ICONS\\SPELL_WARLOCK_DEMONICPORTAL_PURPLE:20|tA void tear has appeared at the Temple Foundation!','',26124),
(133034,'enUS','Time is of the essence. We must not let the Legion capture the Prophet.','',26124),
(133035,'enUS','We might already be too late! This is dark news. I hear the ritual chant nearby.','',26124),
(133049,'enUS','Tell me what you know about the stone.','Tell me what you know about the stone.',26124),
(133050,'enUS','Our people are being used as fodder for vile rituals. Destroy these monstrous creations and help us honor the remains of our dead.','',26124),
(133051,'enUS','Those fiends capture my people and subject them to heinous rituals. We will no longer be hunted. Help us bring the fight to the Legion!','',26124),
(133052,'enUS','As the Legion encroaches upon the hunting grounds of the panthara, the starving beasts have grown more aggressive. Thin their numbers, before they wipe out our talbuk herds.','',26124),
(133056,'enUS','The console displays a number 2.','',26124),
(133057,'enUS','The console displays a number 3.','',26124),
(133058,'enUS','The console displays a number 4.','',26124),
(133059,'enUS','The console displays a number 5.','',26124),
(133060,'enUS','The console displays a number 6.','',26124),
(133061,'enUS','The console displays a number 7.','',26124),
(133062,'enUS','The console displays a number 8.','',26124),
(133063,'enUS','The console displays a number 9.','',26124),
(133067,'enUS','<Push the lever up.>','<Push the lever up.>',26124),
(133068,'enUS','<Pull the lever down.>','<Pull the lever down.>',26124),
(133072,'enUS','Do not worry about the attack from the Azure Dragonshrine. I shall dispatch of the void gargantuan.','',26124),
(133073,'enUS','Do not worry about the attack from the Obsidian Dragonshrine. I shall dispatch of the dreadlord.','',26124),
(133074,'enUS','Do not worry about the attack from the Emerald Dragonshrine. I shall dispatch of the satyr.','',26124),
(133075,'enUS','Do not worry about the attack from the Ruby Dragonshrine. I shall dispatch of the lich.','',26124),
(133076,'enUS','I see you have already taken care of the dragonshrines. Please accept this blessing from the Bronze Dragonflight.','',26124),
(133077,'enUS','|TInterface\\Icons\\TRADE_ARCHAEOLOGY_SHARK JAWS:20|tStraying too close to |cFFFF0000|Hspell:234621|h[Devouring Maw]|h|r will cause |cFFFF0000|Hspell:232885|h[Devour Whole]|h|r!','',26124),
(133078,'enUS','A Legion troop carrier materializes above the main entrance.','A Legion troop carrier materializes above the main entrance.',26124),
(133079,'enUS','A Legion troop carrier materializes above the lower entrance.','A Legion troop carrier materializes above the lower entrance.',26124),
(133080,'enUS','A Legion troop carrier materializes above the high temple entrance.','A Legion troop carrier materializes above the high temple entrance.',26124),
(133081,'enUS','A Legion cruiser materializes above the main entrance.','A Legion cruiser materializes above the main entrance.',26124),
(133082,'enUS','A Legion cruiser materializes above the lower entrance.','A Legion cruiser materializes above the lower entrance.',26124),
(133083,'enUS','A Legion cruiser materializes above the high temple entrance.','A Legion cruiser materializes above the high temple entrance.',26124),
(133086,'enUS','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t',26124),
(133087,'enUS','|TInterface\\Icons\\spell_shadow_summonfelhunter.BLP:24|t','|TInterface\\Icons\\spell_shadow_summonfelhunter.BLP:24|t',26124),
(133088,'enUS','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t',26124),
(133089,'enUS','|TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t','|TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t',26124),
(133090,'enUS','|TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',26124),
(133091,'enUS','|TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t','|TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t',26124),
(133092,'enUS','|TInterface\\Icons\\INV_FelbatMount.blp:24|t','|TInterface\\Icons\\INV_FelbatMount.blp:24|t',26124),
(133093,'enUS','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t',26124),
(133094,'enUS','We have many unanswered questions about my brethren\'s fall to madness here in Mac\'Aree. Bring me any memory crystals you find and I will continue my research.','',26124),
(133095,'enUS','It is grim work, reliving the last sane moments of their troubled lives. But it is the best and only way to honor them. Thank you for your help.','',26124),
(133096,'enUS','A Legion troop carrier and cruiser materialize above the main entrance.','A Legion troop carrier and cruiser materialize above the main entrance.',26124),
(133097,'enUS','A Legion troop carrier and cruiser materialize above the lower entrance.','A Legion troop carrier and cruiser materialize above the lower entrance.',26124),
(133098,'enUS','A Legion troop carrier and cruiser materialize above the high temple entrance.','A Legion troop carrier and cruiser materialize above the high temple entrance.',26124),
(133105,'enUS','I\'m ready. Let\'s save your life!\n|cFF0000FF(Start the scenario).|r','I\'m ready. Let\'s save your life!\n|cFF0000FF(Start the scenario).|r',26124),
(133106,'enUS','A demon dares lead a vanguard on the Vindicaar. A quick death will make clear its master\'s folly.','',26124),
(133107,'enUS','The Legion will stop at nothing to destroy our world. They would do well to remember this defeat.','',26124),
(133109,'enUS','The man\'ari doommaiden Talestra toils to fashion an army of fiends. See to it that she fails.','',26124),
(133110,'enUS','If only we could gaze upon her torment when she returns to Antorus. Sargeras does not take kindly to failure.','',26124),
(133116,'enUS','','The Cenarion Circle cannot sit idly by while Horde and Alliance soldiers mindlessly slay one another. If I can give some solace to some wounded soldiers, I am content.',26124),
(133117,'enUS','<Present the Cenarion Circle documents.>','<Present the Cenarion Circle documents.>',26124),
(133118,'enUS','','This - this says that you come bearing orders from Keeper Remulos himself! Very well, what are your orders, $n?',26124),
(133119,'enUS','We need the druids to distract the cannons outside so that a bronze dragon can escape Andorhal.','We need the druids to distract the cannons outside so that a bronze dragon can escape Andorhal.',26124),
(133121,'enUS','','Chromie needs our help? Of course. We will distract the cannons so she can fly away safely..',26124),
(133135,'enUS','Inserting mind larva','Inserting mind larva',26124),
(133145,'enUS','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t',26124),
(133146,'enUS','|TInterface\\ICONS\\ABILITY_WARLOCK_BACKDRAFTGREEN.BLP:20|t Stand within the impact areas of |cFFF00000|Hspell:244761|h[Annihilate]|h|r to avoid raid damage!','',26124),
(133160,'enUS','','The Legion devastates all who oppose us!',26124),
(133162,'enUS','','Is this the best you could muster? Hah. Pathetic.',26124),
(133163,'enUS','','I\'ve slowed down time significantly so we can prepare without wasting any valuable time.$b$bLet me know when you\'re ready to go!',26124),
(133164,'enUS','','Your war ends here.',26124),
(133165,'enUS','','Witness the fate of all who oppose us.',26124),
(133166,'enUS','','Every world in our path has fallen. Yours is next.',26124),
(133167,'enUS','','Witness the power to destroy worlds!',26124),
(133168,'enUS','','Strike them down!',26124),
(133169,'enUS','','Leave none alive!',26124),
(133170,'enUS','','Rend their flesh!',26124),
(133171,'enUS','','Witness Xoroth, a world of infernal heat and scorched bones!',26124),
(133172,'enUS','','Gaze upon Rancora, a landscape of festering pools and skittering death!',26124),
(133173,'enUS','','Nathreza... once a world of magic and knowledge, now a twisted landscape from which none escape.',26124),
(133174,'enUS','','The portals... must... endure...',26124),
(133175,'enUS','','It... cannot... be so...',26124),
(133176,'enUS','','Your world will fall...',26124),
(133177,'enUS','','Know your place!',26124),
(133178,'enUS','','More bones for the pile.',26124),
(133179,'enUS','','So easily broken.',26124),
(133180,'enUS','','Was this truly the best Azeroth had to offer?',26124),
(133181,'enUS','','As you have fallen, so shall Azeroth.',26124),
(133182,'enUS','','The Legion has laid waste to a thousand worlds. Yours will be no different.',26124),
(133183,'enUS','','Your resistance is at an end!',26124),
(133184,'enUS','','The Legion\'s forces throughout the cosmos are mine to command!',26124),
(133185,'enUS','','Our forces are infinite!',26124),
(133186,'enUS','','The wrath of the Legion will overwhelm you!',26124),
(133187,'enUS','<A fissure in the ground, barely wide enough to squeeze through. It\'s too dark to see anything, but you can tell that it is very deep.>','',26124),
(133188,'enUS','<Drop into the fissure.>','<Drop into the fissure.>',26124),
(133189,'enUS','WARNING: You are about to fall into a dark fissure. You may not be able to climb back out again. Are you very sure you want to do this?','',26124),
(133190,'enUS','|TInterface\\Icons\\spell_shadow_summonfelhunter.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t','|TInterface\\Icons\\spell_shadow_summonfelhunter.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t',26124),
(133191,'enUS','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',26124),
(133192,'enUS','','Despite our best efforts, the void continues to seep in through the cracks. Seek out the Army of the Light and use their blessings to banish the darkness once again.',26124),
(133193,'enUS','','We may not be able to restore their sanity, but at least we can prevent more from succumbing.',26124),
(133194,'enUS','','<Enaara offers a gold-wrought crystal to you.>$b$bBanish the darkness, $n. Let the Light prevail.',26124),
(133195,'enUS','<Accept the crystal.>','<Accept the crystal.>',26124),
(133196,'enUS','','This place is cursed. Let us shed a little Light on these poor souls.',26124),
(133202,'enUS','|TINTERFACE\\ICONS\\SPELL_FIRE_LAVASPAWN.BLP:20|t An Ember of Taeshalach overloads causing a |cFFFF0404|Hspell:244912|h[Blazing Eruption]|h|r!','|TINTERFACE\\ICONS\\SPELL_FIRE_LAVASPAWN.BLP:20|t An Ember of Taeshalach overloads causing a |cFFFF0404|Hspell:244912|h[Blazing Eruption]|h|r!',26124),
(133203,'enUS','|TInterface\\Icons\\SPELL_WARLOCK_SUMMONWRATHGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\SPELL_WARLOCK_SUMMONWRATHGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',26124),
(133205,'enUS','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t',26124),
(133206,'enUS','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t',26124),
(133208,'enUS','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',26124),
(133209,'enUS','Fel Bats start flying down to Eonar\'s platform!','Fel Bats start flying down to Eonar\'s platform!',26124),
(133210,'enUS','The rift collapses, heroes! You must hurry before the entrance closes forever!','',26124),
(133215,'enUS','AL\'KSH SYR IIR AWAN? IILTH SYTHN AGEV.','AL\'KSH SYR IIR AWAN? IILTH SYTHN AGEV.',26124),
(133216,'enUS','<Recall Kil\'Jaeden\'s attack on Dalaran>','<Recall Kil\'Jaeden\'s attack on Dalaran>',26124),
(133217,'enUS','<Recall the opening of the Tomb of Sargeras>','<Recall the opening of the Tomb of Sargeras>',26124),
(133218,'enUS','<Recall Anduin reclaiming Shalamayne>','<Recall Anduin reclaiming Shalamayne>',26124),
(133219,'enUS','<Recall Kil\'Jaeden\'s defeat>','<Recall Kil\'Jaeden\'s defeat>',26124),
(133220,'enUS','','Together we will see to it that the Legion finally meets their end.',26124),
(133221,'enUS','','The Legion has run rampant on Azeroth for too long. It is time to see this done.',26124),
(133222,'enUS','Prophet Velen will be pleased that you answered his call. We draenei have long awaited this day.','',26124),
(133225,'enUS','','Impressive. The Legion won\'t expect a force this strong.',26124),
(133226,'enUS','Festerbloat eat puny dragon!','',26124),
(133227,'enUS','','Death comes for you, little dragon...',26124),
(133228,'enUS','Surrender your life, wyrm!','',26124),
(133229,'enUS','The dragon comes! Kill the dragon!','',26124),
(133230,'enUS','Strange. What are YOU doing here?','',26124),
(133231,'enUS','Now know your demise, whelpling. Your timewalking ends here.','',26124),
(133232,'enUS','The fingers of death coil around your scaly neck, dragonling.','',26124),
(133233,'enUS','Your time-twisting days are at an end, whelp!','',26124),
(133234,'enUS','Open the portals! Destroy the bronze dragon! Don\'t let it escape!','',26124),
(133235,'enUS','','Clever dragon. I\'ve captured you once, and I\'ll do it again!',26124),
(133236,'enUS','Destroy the dragon whelp! In the name of the Alliance!','Destroy the dragon whelp! In the name of the Alliance!',26124),
(133237,'enUS','Destroy the dragon whelp! For the Horde!','Destroy the dragon whelp! For the Horde!',26124),
(133238,'enUS','|TInterface\\Icons\\ABILITY_ROGUE_SHADOWSTEP:20|tSaprish prepares to strike you with |cFFFF0000|Hspell:247246|h[Umbral Flanking]|h|r!','|TInterface\\Icons\\ABILITY_ROGUE_SHADOWSTEP:20|tSaprish prepares to strike you with |cFFFF0000|Hspell:247246|h[Umbral Flanking]|h|r!',26124),
(133241,'enUS','Your minds are so easily clouded!','',26124),
(133242,'enUS','The Light will not save you...','',26124),
(133243,'enUS','','Come closer, heroes, so I can watch the flesh drip from your bones!',26124),
(133244,'enUS','','Oh, to taste... your... liquefying flesh...',26124),
(133245,'enUS','Your ashes will be blown across the cosmos!','',26124),
(133246,'enUS','My embers will never burn out...','',26124),
(133255,'enUS','Lothraxion is in charge if we don\'t come back. Stay sharp, Fareeya.','',26124),
(133256,'enUS','','We have faced worse odds. I will hold this position.',26124),
(133257,'enUS','We will do our best.','',26124),
(133268,'enUS','The Legion has opened portals to invade the Arcatraz. Shut them down... before you find yourself outflanked.','',26124),
(133280,'enUS','Infusing','Infusing',26124),
(133285,'enUS','Runes on this urn indicate that it contains some of the remains of a powerful mogu spirit-binder. Many of the markings appear to be warnings.','',26124),
(133286,'enUS','<Consume the ashes.>','<Consume the ashes.>',26124),
(133287,'enUS','WARNING: You are about to consume the ashes of an evil sorcerer. There is no way to tell what will happen. Are you VERY sure you want to do this?','',26124),
(133288,'enUS','','Have you been training? The Great Gnomeregan Run is starting soon!',26124),
(133289,'enUS','','Be sure to hydrate and rest up for The Great Gnomeregan Run! It\'ll be kicking off in New Tinkertown very soon!',26124),
(133290,'enUS','','The Great Gnomeregan Run is happening in New Tinkertown right now! Think you can accomplish a new personal record?!',26124),
(133291,'enUS','','The Great Gnomeregan Run is happening right now in New Tinkertown!',26124),
(133292,'enUS','','The Alliance is celebrating The Great Gnomeregan Run in New Tinkertown!',26124),
(133293,'enUS','','The Alliance will be holding The Great Gnomeregan Run in New Tinkertown very soon!',26124),
(133296,'enUS','I lost the antidote. Did you pick it up?','I lost the antidote. Did you pick it up?',26124),
(133299,'enUS','The enemy seeks to close our rift! To arms!','The enemy seeks to close our rift! To arms!',26124),
(133307,'enUS','I am restored.','',26124),
(133308,'enUS','','Oh no... I know that voice.',26124),
(133309,'enUS','Exile Y\'mera. Why have you returned?','',26124),
(133313,'enUS','Let us begin.','',26124),
(133320,'enUS','','We need to--',26124),
(133322,'enUS','State your purpose or remove yourself from the premises.','',26124),
(133323,'enUS','I seek the Sigil of Awakening.','I seek the Sigil of Awakening.',26124),
(133324,'enUS','My robots and I are going to clean up Gnomeregan!\n\nI don\'t quite have the technology figured out, though. Right now I can get the little guys to soak up the toxic fumes, but all they produce is more toxic fumes.\n\nAlso, everything\'s getting green and hazy. It\'s kind of nice, actually, helps me focus on my work.\n\nSo what can I do for you today, my fine trogg friend?\n\n<Bert cocks his head and looks slightly to the left of you.>','',26124),
(133326,'enUS','Environmental justice!','',26124),
(133327,'enUS','Bert\'s bot beats baddie!','',26124),
(133328,'enUS','The code clearly missing a semicolon!','',26124),
(133330,'enUS','Bert\'s bots bested!','',26124),
(133331,'enUS','Main power turn on!','',26124),
(133332,'enUS','Code review successful!','',26124),
(133334,'enUS','','I can feel the power in the air. It lingers, even after all this time.',26124),
(133335,'enUS','','Great. We will be on our way, then.',26124),
(133347,'enUS','|TINTERFACE\\ICONS\\SPELL_FIRE_LAVASPAWN.BLP:20|t Mistress Alluradel begins to cast |cFFFF0404|Hspell:247551|h[Beguiling Charm]|h|r. Look away!','|TINTERFACE\\ICONS\\SPELL_FIRE_LAVASPAWN.BLP:20|t Mistress Alluradel begins to cast |cFFFF0404|Hspell:247551|h[Beguiling Charm]|h|r. Look away!',26124),
(133352,'enUS','I am afraid I cannot allow that, $n.','',26124),
(133358,'enUS','Lah\'zaruun, my loyal servant. Stay here and kill these fools. I have much to do.','',26124),
(133362,'enUS','','I cannot step hoof in the Praetorium. But you knew that, didn\'t you?',26124),
(133363,'enUS','Perhaps.','',26124),
(133366,'enUS','','I have complete faith in you, $n. I will be nearby when you are finished.',26124),
(133367,'enUS','','This construct should hold information to help us locate the Sigil of Awakening. We need to wake it up.',26124),
(133373,'enUS','I must confess, these trials do provide endless amusement... for me.','',26124),
(133375,'enUS','So many come before me, and so many fail.','',26124),
(133376,'enUS','You think yourself clever for getting this far. But I know how it will end.','',26124),
(133377,'enUS','Tenacity means nothing against my will. I will break you.','',26124),
(133378,'enUS','Ha! A worthy tribute to my Conservatory\'s teachings.','',26124),
(133381,'enUS','','Champions! Over Here!',26124),
(133382,'enUS','Another world defiled by the Legion. Destroy their forces and seal this rift before they can join the fight on Argus!','',26124),
(133383,'enUS','Every rift closed buys time for our advance. The light is with you, Champion.','',26124),
(133384,'enUS','The Legion fleet gathers. Disrupt their preparations and seal the rift before they can reach Argus!','',26124),
(133385,'enUS','Reinforcements have ceased from that world, for now.','',26124),
(133386,'enUS','Mortals. I wasted millennia fighting to spare you from corruption. Until at last my eyes were opened to the truth.','',26124),
(133388,'enUS','The Legion\'s cruelty applies even to its own. Destroy this abomination, and seal the rift between our worlds.','',26124),
(133390,'enUS','That is all of the rifts for now, though they are certain to return!','',26124),
(133391,'enUS','You are the corruption. We will save the universe by wiping all memory of you from existence.','',26124),
(133394,'enUS','You will burn!','',26124),
(133397,'enUS','You will get this object from a TBD quest chain. For now, you get it from the ground!','',26124),
(133398,'enUS','Pick up a Depleted Riftstone.','Pick up a Depleted Riftstone.',26124),
(133399,'enUS','|TINTERFACE\\ICONS\\INV_STONE_05.BLP:20|t Your Depleted Riftstone has become a |cFFFF0000|Hitem:151702|h[Charged Riftstone]|h|r!','|TINTERFACE\\ICONS\\INV_STONE_05.BLP:20|t Your Depleted Riftstone has become a |cFFFF0000|Hitem:151702|h[Charged Riftstone]|h|r!',26124),
(133408,'enUS','Fall, frail mortal!','',26124),
(133414,'enUS','Such a worthless opponent.','',26124),
(133416,'enUS','You had no hope of victory. Nothing can stop our crusade!','',26124),
(133417,'enUS','It may be... too late to stop him...','',26124),
(133418,'enUS','None can stand against Taeshalach!','',26124),
(133419,'enUS','Burn!','',26124),
(133420,'enUS','','I had hoped that would work. The lights are on but no one is home.',26124),
(133422,'enUS','Drown in flames!','',26124),
(133424,'enUS','All will die in my wake!','',26124),
(133425,'enUS','Stand and die!','',26124),
(133426,'enUS','There is no escape.','',26124),
(133427,'enUS','The flames will consume you!','',26124),
(133431,'enUS','Let the flesh be seared from your bones!','',26124),
(133433,'enUS','Taeshalach\'s power is unleashed!','',26124),
(133434,'enUS','The power of Taeshalach will consume you!','',26124),
(133435,'enUS','You may have withstood the flames, but you will not withstand my fury.','',26124),
(133436,'enUS','Your modicum of skill will be insufficient to save you.','',26124),
(133440,'enUS','','Enough! Your intrusion ends now, mortals!',26124),
(133442,'enUS','Time has run out.','Time has run out.',26124),
(133451,'enUS','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\SPELL_WARLOCK_SUMMONWRATHGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\SPELL_WARLOCK_SUMMONWRATHGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t',26124),
(133452,'enUS','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\SPELL_WARLOCK_SUMMONWRATHGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\SPELL_WARLOCK_SUMMONWRATHGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',26124),
(133453,'enUS','|TInterface\\Icons\\SPELL_WARLOCK_SUMMONWRATHGUARD.BLP:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t','|TInterface\\Icons\\SPELL_WARLOCK_SUMMONWRATHGUARD.BLP:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t',26124),
(133454,'enUS','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t',26124),
(133482,'enUS','','|TInterface\\Icons\\INV_MISC_AMMO_ARROW_03:20|t%s targets enemies with |cFFFF0000|Hspell:230139|h[Hydra Shot]|h|r!',26124),
(133483,'enUS','Now the ones we\'ve lost can find rest.','',26124),
(133484,'enUS','The lives and souls of my people are safer, thanks to you.','',26124),
(133485,'enUS','Those steeds are vital in our battle against the demons. You have my thanks for safeguarding them.','',26124),
(133486,'enUS','You are now using |TInterface\\ICONS\\Achievement_ChallengeMode_Auchindoun_Hourglass.blp:32|t [Stolen Time]!','You are now using |TInterface\\ICONS\\Achievement_ChallengeMode_Auchindoun_Hourglass.blp:32|t [Stolen Time]!',26124),
(133508,'enUS','','I am going to need your help. Jostle it a bit, won\'t you?',26124),
(133517,'enUS','It is not safe here!','',26124),
(133518,'enUS','The darkness shrouds the Light.','',26124),
(133519,'enUS','Many thanks. I will find my way.','',26124),
(133520,'enUS','Be swift before the pits consume you!','',26124),
(133521,'enUS','We must leave before it is too late!','',26124),
(133522,'enUS','Our fight does not end here!','',26124),
(133523,'enUS','I... I must return to my people at once.','',26124),
(133524,'enUS','Conservatory resources are not available to one of your... status.','',26124),
(133525,'enUS','','Of all people to become Gatekeeper... $n, perhaps you had better do the talking.',26124),
(133528,'enUS','The Sigil is the Conservatory\'s highest honor. Only Archimonde\'s chosen may pursue this accolade.','',26124),
(133529,'enUS','I am obligated to inform you that the master created trials specifically for this purpose.','',26124),
(133531,'enUS','I am also required to allow the uninitiated to participate.','',26124),
(133533,'enUS','','Quoram and I have... a history.$b$bLet it suffice to say that I did not depart the Conservatory on the best terms.',26124),
(133535,'enUS','','<Y\'mera handles the Sigil warily.>$b$bI feel very exposed, holding such a relic.',26124),
(133541,'enUS','You, Y\'mera, will have no part in this. But I will not deny you the opportunity to watch $n fail.','',26124),
(133542,'enUS','','So generous of you.',26124),
(133549,'enUS','','I may not be able to assist you directly, but I have information that could be of interest.',26124),
(133577,'enUS','Allow me to introduce myself. I am the Magnificent Al\'Abas. I find myself temporarily indisposed in this rather decrepit vessel. Perhaps you\'d be so kind as to listen to my tale.','',26124),
(133583,'enUS','Many thanks, $n.','',26124),
(133584,'enUS','May the Light guide us.','',26124),
(133585,'enUS','You have helped ensure the future of our people.','',26124),
(133586,'enUS','Be at peace.','',26124),
(133587,'enUS','We must stand together.','',26124),
(133588,'enUS','Acheon kor.','',26124),
(133589,'enUS','Golad niton acalah.','',26124),
(133590,'enUS','Krona ki cristorr!','',26124),
(133592,'enUS','','We are doing all we can to hold the line here. Go, find Y\'mera, and turn the tide in our favor!',26124),
(133593,'enUS','','The Light prevails.',26124),
(133594,'enUS','','We will win this war.',26124),
(133595,'enUS','','Do you have something to report?',26124),
(133596,'enUS','','Greetings.',26124),
(133597,'enUS','','Be on your guard.',26124),
(133598,'enUS','','We will defeat the Legion.',26124),
(133599,'enUS','','Archenon poros.',26124),
(133600,'enUS','','You! You\'re not a demon. Come here and help us kill some!',26124),
(133601,'enUS','','Get to those batteries and start shooting down those bats! We\'re counting on you!',26124),
(133602,'enUS','','Anything can be a weapon with the right mindset.',26124),
(133603,'enUS','','Blade and spell, ready to serve the Light.',26124),
(133604,'enUS','','We will redeem our home.',26124),
(133611,'enUS','Why have you come?','Why have you come?',26124),
(133612,'enUS','You do not belong here!','You do not belong here!',26124),
(133613,'enUS','Do not mock my suffering!','Do not mock my suffering!',26124),
(133614,'enUS','This is our home! Begone!','This is our home! Begone!',26124),
(133615,'enUS','Why can\'t you let us rest?','Why can\'t you let us rest?',26124),
(133616,'enUS','You will not torment me!','You will not torment me!',26124),
(133617,'enUS','When will it end?','When will it end?',26124),
(133618,'enUS','I wish I had... fled...','I wish I had... fled...',26124),
(133619,'enUS','We could not escape.','We could not escape.',26124),
(133620,'enUS','Velen... why?','Velen... why?',26124),
(133621,'enUS','Such darkness... I had hoped...the light...','Such darkness... I had hoped...',26124),
(133622,'enUS','I am so tired.','I am so tired.',26124),
(133623,'enUS','I will direct our forces to establish a foothold outside the Legion stronghold while you speak with Magni.','',26124),
(133624,'enUS','This is the song that never ends. It just goes on and on, my friend. Some people started singing, not knowing what it was, and now they\'re still singing it. No reason... just because!','',26124),
(133625,'enUS','I\'m ready. Let\'s try this again!','I\'m ready. Let\'s try this again!',26124),
(133626,'enUS','Ready when you are!','Ready when you are!',26124),
(133627,'enUS','You will do Argus proud. Claim your prize.','',26124),
(133628,'enUS','The stone\'s whispers steady my people\'s hearts. It is curious that you hear them as well, outsider.','',26124),
(133629,'enUS','When Azeroth\'s spirit speaks ta me, it\'s like a song. There\'s beauty in it, even when her message ain\'t exactly clear.','',26124),
(133630,'enUS','Argus\'s soul ain\'t like that. He\'s tormented... broken. Careful, or his pain\'ll overwhelm ye!','',26124),
(133631,'enUS','He... he needs us ta see somethin\'...','',26124),
(133634,'enUS','You will pay for your actions.','',26124),
(133635,'enUS','From the shadows we strike.','',26124),
(133636,'enUS','For our people!','',26124),
(133637,'enUS','For the fallen!','',26124),
(133639,'enUS','Acalah pek ecta!','',26124),
(133640,'enUS','Krypta!','',26124),
(133641,'enUS','Pheta vi acahachi!','',26124),
(133642,'enUS','To battle!','',26124),
(133647,'enUS','Pa-caw chee-chawchee-chaw','',26124),
(133649,'enUS','Coodle chee-chaw','',26124),
(133650,'enUS','Ca-caw chee-chaw','',26124),
(133651,'enUS','Pa-cawcaw','',26124),
(133652,'enUS','Witnessing','Witnessing',26124),
(133653,'enUS','','It is as I thought.',26124),
(133654,'enUS','Trifling outsider. Your arrogance was your undoing.','',26124),
(133655,'enUS','You are unworthy.','',26124),
(133671,'enUS','Our forces have established a foothold at the citadel, High Exarch.','',26124),
(133673,'enUS','Good. It is time we seized our fate.','',26124),
(133677,'enUS','Teleporting','Teleporting',26124),
(133733,'enUS','<Fel Heart of Argus>','<Fel Heart of Argus>',26124),
(133734,'enUS','<Light\'s Judgment Trigger>','<Light\'s Judgment Trigger>',26124),
(133735,'enUS','','I would have words with you, Huntmaster.',26124),
(133736,'enUS','','Vereesa told me you accompanied her on the mission to Niskara. That you risked your own life to rescue me, and prevented her from falling into the inquisitor\'s trap.',26124),
(133737,'enUS','','It is clear you wield Thas\'dorah with skill and finesse. You bring honor to the bow, and to the memory of those who carried it before you.',26124),
(133738,'enUS','','There may come a day when I will have need of my family weapon once again. But for now, at least, I have a different path to follow.',26124),
(133739,'enUS','','Hold Thas\'dorah proudly, champion. Know that you have proven worthy of it.',26124),
(133740,'enUS','','Impossible! I refuse to believe she now leads the Horde. Not after all they did to our people during the war.',26124),
(133743,'enUS','','There is more. I\'m... I am not sure how to explain the rest. Or if this is even the time or place to--',26124),
(133744,'enUS','','I must know, Vereesa. What fate befell our sister?',26124),
(133746,'enUS','','Give me a moment. I will do my best to explain...',26124),
(133747,'enUS','Another demon awaits your disposal. Find it and bring it to an end.','',26124),
(133748,'enUS','One by one, we will teach them the folly of their crusade.','',26124),
(133749,'enUS','A burning fiend terrorizes our allies at the pits. Extinguish the threat at once.','',26124),
(133750,'enUS','Another foe reduced to ashes.','',26124),
(133751,'enUS','Another Legion lackey comes forth to challenge us. Put a swift end to its misguided ambitions.','',26124),
(133753,'enUS','The Legion will not relent. Neither will we.','',26124),
(133761,'enUS','','Have patience, Arator. It may take time, but your family will be whole again. I know it.',26124),
(133762,'enUS','My scouts found the remains of Aggonar. We are in your debt, High Exarch. And yours, outlander.','',26124),
(133767,'enUS','','One of the Legion\'s masters has fallen at last, yet this war is far from over.\n\nWas this the true plan of Sargeras all along? His ultimate endgame? Or perhaps this is another\'s doing. Someone who has betrayed this world before.\n\n<Maiev narrows her eyes as she looks toward the sky.>\n\nI will be watching... and ready.',26124),
(133770,'enUS','It appears you need a lesson in pain. Allow me to instruct you.','',26124),
(133771,'enUS','','This is one engagement you will not walk away from.',26124),
(133772,'enUS','Your front lines cannot withstand my attack!','',26124),
(133773,'enUS','','Was this your plan?',26124),
(133774,'enUS','What result were you expecting?','',26124),
(133776,'enUS','You have no place on my battlefield.','',26124),
(133777,'enUS','The drake cleared the Azure Dragonshrine for you!','The drake cleared the Azure Dragonshrine for you!',26124),
(133778,'enUS','The drake cleared the Obsidian Dragonshrine for you!','The drake cleared the Obsidian Dragonshrine for you!',26124),
(133779,'enUS','The drake cleared the Emerald Dragonshrine for you!','The drake cleared the Emerald Dragonshrine for you!',26124),
(133780,'enUS','The drake cleared the Ruby Dragonshrine for you!','The drake cleared the Ruby Dragonshrine for you!',26124),
(133781,'enUS','The drake granted you a powerful blessing!','The drake granted you a powerful blessing!',26124),
(133782,'enUS','I was looking for higher ground to scout a path for Velen when the Legion descended upon us.$b$bI covered his retreat but I was separated from the others.$b$bDo you bring news?','',26124),
(133783,'enUS','<Relay Fareeya\'s orders.>','<Relay Fareeya\'s orders.>',26124),
(133787,'enUS','No mercy!','',26124),
(133789,'enUS','Pathetic.','',26124),
(133791,'enUS','','You\'ve left your flanks exposed.',26124),
(133792,'enUS','My name will be remembered!','',26124),
(133795,'enUS','Inconceivable!','',26124),
(133796,'enUS','','How was I outmatched...',26124),
(133797,'enUS','I am the Wisdom Cube.','',26124),
(133800,'enUS','Harvest faster! The master will not tolerate laziness.','Harvest faster! The master will not tolerate laziness.',26124),
(133807,'enUS','Baraat the Longshot salutes you.','',26124),
(133808,'enUS','What wisdom do you hold?','What wisdom do you hold?',26124),
(133809,'enUS','<The Vindicator breathes heavily as ichor drips from his mace and shield.>$b$bWhat is it?','',26124),
(133810,'enUS','I have been imparted with the knowledge of the timeless ones.','',26124),
(133811,'enUS','What is your purpose?','What is your purpose?',26124),
(133812,'enUS','I am capable of granting the sign of the first.','',26124),
(133813,'enUS','What do you require?','What do you require?',26124),
(133814,'enUS','Grand Vindicator Sorvos grunts in confirmation.','',26124),
(133815,'enUS','My creators seek a most amusing heir.','',26124),
(133816,'enUS','These spores will make you stronger, whelps! Get back to work or I\'ll kill you myself!','',26124),
(133817,'enUS','<The cube rapidly reconfigures itself.>\n\nPlease place your arm beneath the cube.','',26124),
(133818,'enUS','<Place arm beneath cube.>','<Place arm beneath cube.>',26124),
(133821,'enUS','A strange stone sits before you. A glowing hole in the center is the main identifying feature.\n\nThe hole in the stone is at about arm height.','',26124),
(133822,'enUS','<Place arm in hole.>','<Place arm in hole.>',26124),
(133823,'enUS','Your arm looks quite small in the hole, but nothing else of note happens.','',26124),
(133824,'enUS','Your arm better fits the size of the hole, but still doesn\'t quite fill the space precisely.','',26124),
(133825,'enUS','No doubt my mother will soon ask about Sylvanas. What are you going to tell her?','',26124),
(133826,'enUS','','It is a conversation I know we must have, but the thought of it fills me with dread. How can I explain to Alleria what our sister has become? The truth will break her heart.',26124),
(133836,'enUS','You hope to topple my machines with those pathetic weapons?','',26124),
(133837,'enUS','Sending you back to the drawing board... in pieces!','',26124),
(133838,'enUS','Your construction appears shoddy.','',26124),
(133839,'enUS','Now I\'m just... extra parts.','',26124),
(133840,'enUS','Your heads will adorn my trophy room.','',26124),
(133841,'enUS','I get paid double if you scream.','',26124),
(133842,'enUS','caw','',26124),
(133843,'enUS','ca-caw','',26124),
(133844,'enUS','chaw','',26124),
(133845,'enUS','chee','',26124),
(133846,'enUS','Extracting','Extracting',26124),
(133847,'enUS','chee-chaw','',26124),
(133848,'enUS','a','',26124),
(133849,'enUS','coodle','',26124),
(133850,'enUS','doodle','',26124),
(133851,'enUS','do','',26124),
(133852,'enUS','coo','',26124),
(133853,'enUS','ca','',26124),
(133854,'enUS','cluck','',26124),
(133855,'enUS','cluck-ahhh','',26124),
(133856,'enUS','pa','',26124),
(133857,'enUS','quaw','',26124),
(133858,'enUS','pa-caw','',26124),
(133859,'enUS','bock','',26124),
(133860,'enUS','block','',26124),
(133861,'enUS','Guess I should scrape up the pieces and collect my fee.','',26124),
(133862,'enUS','<Telaamon lowers his blade and peers at you expectantly.>','',26124),
(133863,'enUS','Blademaster Telaamon offers a curt nod.','',26124),
(133864,'enUS','I regret... taking... this job...','',26124),
(133866,'enUS','Be calm. It is only the wind.','',26124),
(133867,'enUS','Hold still, little one. We are safe here.','',26124),
(133868,'enUS','Hold! These winds that tease our senses create unease in the wildlife.','',26124),
(133869,'enUS','Be still. The village masks our presence. No harm will come to us here.','',26124),
(133870,'enUS','Hold, young one! Be still!','',26124),
(133871,'enUS','I be branchin\' out, mon. All sorts of tings available in. So much opportunity.','',26124),
(133873,'enUS','Come, then. We will trade pain for pain!','',26124),
(133874,'enUS','So easily broken!','',26124),
(133875,'enUS','Better that you died here, where she cannot claim you.','',26124),
(133876,'enUS','Death... claims... us all.','',26124),
(133877,'enUS','','I am the chill running down your spine.',26124),
(133878,'enUS','','I can\'t wait to hear your flesh sizzle.',26124),
(133879,'enUS','','You cannot escape the shadows.',26124),
(133880,'enUS','','Your corpses will be frozen in eternal agony.',26124),
(133881,'enUS','','Burned and blackened.',26124),
(133882,'enUS','','There is no light that can pierce my shadow.',26124),
(133884,'enUS','Kil\'jaeden\'s ship. Even after its destruction, its presence vexes us. Clear the surrounding area of its blight.','',26124),
(133885,'enUS','A pity the memory of Kil\'jaeden\'s existence cannot be purged as easily as you cleansed these grounds.','',26124),
(133886,'enUS','The Legion is arming a devastator to fire on the Xenedar! We need you to commandeer it.','',26124),
(133887,'enUS','Nice shooting! With that cursed ship out of commission, we can focus on other fronts.','',26124),
(133888,'enUS','','Your pieces will make a fine trophy.',26124),
(133889,'enUS','','Another body for the fire!',26124),
(133890,'enUS','','You were right to fear the dark.',26124),
(133891,'enUS','Forgive me, my son.','',26124),
(133892,'enUS','Velen?','',26124),
(133894,'enUS','','So cold...',26124),
(133895,'enUS','','I sense great despair emanating from within. L\'ura...',26124),
(133896,'enUS','Yes, the naaru. We must get inside. Alleria, the skills you have learned can open the way.','',26124),
(133897,'enUS','Are you hurt?','',26124),
(133898,'enUS','','Understood. Champions, once the door is open, clear the way to L\'ura. We will be right behind you.',26124),
(133900,'enUS','I am unharmed.','',26124),
(133901,'enUS','Your arrival is timely. We must find the Crest of Knowledge before Talgath takes it beyond our reach.','',26124),
(133902,'enUS','','I will never burn out...',26124),
(133903,'enUS','','I welcome oblivion...',26124),
(133905,'enUS','So he is here, then. I was afraid of this.','',26124),
(133906,'enUS','Death! Death and pain!','',26124),
(133907,'enUS','Ended!','',26124),
(133908,'enUS','All life ends.','',26124),
(133909,'enUS','We will escort Velen safely to the Crest.','',26124),
(133910,'enUS','My torment... ends...','',26124),
(133914,'enUS','Lead the way, Prophet.','',26124),
(133920,'enUS','The way is clear. The Light Mother awaits.$b$bWe should hurry. There is nothing blocking the Legion from her now.','',26124),
(133921,'enUS','Even though we are surrounded by enemies on all sides, it is good to be with my soldiers again.','',26124),
(133922,'enUS','If you cover our retreat, we may just see this through.','',26124),
(133927,'enUS','','The way is open! Hurry, heroes!',26124),
(133930,'enUS','The Light is with us.','',26124),
(133931,'enUS','Such loss... we will need to grow our ranks.','',26124),
(133932,'enUS','We will win this fight.','',26124),
(133937,'enUS','I did not escape the Arcatraz to die at your hands!','',26124),
(133940,'enUS','You have stolen my power! Argus no longer calls to me!','',26124),
(133948,'enUS','The Fel Heart fills with the energies of Argus. Soon I will be unstoppable!','',26124),
(133949,'enUS','You are too late! My power grows... soon you will fall before me!','',26124),
(133954,'enUS','Why are we here in Stratholme?','Why are we here in Stratholme?',26124),
(133955,'enUS','Why are we here in Andorhal?','Why are we here in Andorhal?',26124),
(133956,'enUS','Why are we here at Mount Hyjal?','Why are we here at Mount Hyjal?',26124),
(133957,'enUS','Why are we here at the Well of Eternity?','Why are we here at the Well of Eternity?',26124),
(133967,'enUS','Yes! They flee to the terrace! We have them right where we want them.','',26124),
(133972,'enUS','Siphon the portal energy! The naaru\'s weakness will become your strength!','',26124),
(133973,'enUS','Take her shadow for your own, Alleria! Do as I trained you!','',26124),
(133976,'enUS','','Heroes, the naaru has been weakened!',26124),
(133977,'enUS','','Attack now, champions! The naaru is momentarily weakened!',26124),
(133978,'enUS','','Quickly, heroes! The naaru is stunned, but won\'t be for long!',26124),
(134004,'enUS','Even in such a mire the Legion cannot mask their scent. Rip them apart!','',26124),
(134005,'enUS','The demons have spliced spores into their own flesh to mask their attacks. Show them they cannot hide from death!','',26124),
(134006,'enUS','Their commander approaches! Make him regret defiling this world.','',26124),
(134008,'enUS','The Legion here are finished, for now. Our war continues on Argus.','',26124),
(134019,'enUS','Your screams will echo through Antorus if they escape!','',26124),
(134020,'enUS','Make way. I will deal with this myself.','',26124),
(134024,'enUS','Blademaster Telaamon salutes you.','',26124),
(134025,'enUS','Grand Vindicator Sorvos nods to you.','',26124),
(134026,'enUS','<Velen\'s unmoving gaze is rooted on the statue before him.>','',26124),
(134027,'enUS','Let me show you what I have done. Perhaps, then, I can make peace with it at long last.','',26124),
(134028,'enUS','Show me.','Show me.',26124),
(134029,'enUS','IGC: Sargeras Appears to the Triumvirate','IGC: Sargeras Appears to the Triumvirate',26124),
(134030,'enUS','He\'s here.','',26124),
(134031,'enUS','How unlike you, Velen, to stand your ground.','',26124),
(134032,'enUS','A welcome change of pace, to be certain.','',26124),
(134033,'enUS','After all I have endured at his hand... after all my people have suffered... it comes to this.$b$b<Velen grips his staff tightly.>$b$bWhen you are ready, we will finish this together.','',26124),
(134034,'enUS','I am ready.','I am ready.',26124),
(134039,'enUS','Let the hunt be finished! You are mine, Prophet!','',26124),
(134040,'enUS','We are with you, Velen.','',26124),
(134041,'enUS','Pheta thones gamera. Light, guide our path.','',26124),
(134044,'enUS','Oh, how Kil\'jaeden mourned for you! Do you know how deeply your departure wounded him?','',26124),
(134045,'enUS','I lost a beloved brother that day as well.','',26124),
(134046,'enUS','You did not lose him. You gave it up--all of it! Your people, your planet... even your family!','',26124),
(134047,'enUS','I have not forgotten your betrayal!','',26124),
(134050,'enUS','I only hoped they would give you a reason to stay. How cold of you, leaving without your mate and child.','',26124),
(134051,'enUS','Silence! You dare speak of them!','',26124),
(134052,'enUS','Struck a nerve, did I?','',26124),
(134053,'enUS','Sheet-sah, you hide behind your allies... as usual.','',26124),
(134054,'enUS','We will finish this another ti--','',26124),
(134055,'enUS','No. This ends now.','',26124),
(134056,'enUS','I see. Safe journey, Talgath.','',26124),
(134057,'enUS','AAAaaahhh!','',26124),
(134058,'enUS','Der\'ek... manul...','',26124),
(134071,'enUS','Before you are remnants of memories past, echoes of what our people were before the Dark Titan came.$B$BWhen one of our kind breaks away from the Legion\'s grasp, sometimes they return with a memento of our old way of life.$b$bThese relics symbolize all we have lost... and serve as a reminder of what we fight for.','',26124),
(134080,'enUS','You cannot kill me so easily! The Fel Heart will protect me!','',26124),
(134081,'enUS','You think you are winning? I am immortal!','',26124),
(134082,'enUS','Many have tried to kill me. They are all dead and gone, yet I remain!','',26124),
(134083,'enUS','This was not supposed to happen! I was to live forever!','',26124),
(134097,'enUS','Azerite fissures begin to erupt!','',26124),
(134102,'enUS','|TInterface\\ICONS\\SPELL_FIRE_TWILIGHTNOVA:20|tViceroy Nezhar starts to cast |cFFFF0000|Hspell:248736|h[Eternal Twilight]|h|r!','',26124),
(134103,'enUS','','What news, hero? I sense that darkness has descended upon the bluff.',26124),
(134104,'enUS','An ally\'s mind is under assault by the Old Gods. Can he be saved?','An ally\'s mind is under assault by the Old Gods. Can he be saved?',26124),
(134105,'enUS','','Sometimes we must walk in the land of dreams to seek the truth.',26124),
(134106,'enUS','','I wish I could offer better news. In my experience, once the Old Gods take hold, hope is all but lost.',26124),
(134107,'enUS','The spirits are restless. A shadow looms over this place. The very earth feels... wrong.','',26124),
(134108,'enUS','It takes powerful wards to keep the Old Gods at bay.\n\nPerhaps a place heavily warded against void magic could prove useful.','',26124),
(134113,'enUS','$n has collected Azerite!','',26124),
(134114,'enUS','$n has collected Azerite!','',26124),
(134117,'enUS','This is your end. If there is a shred of goodness left in you, you will help us find the Crest of Knowledge.','',26124),
(134118,'enUS','','I sense you bring ill news.',26124),
(134119,'enUS','Hah! You are far too late. Nothing will escape the temple. Not even the Light itself.','',26124),
(134120,'enUS','INTERFACE\\ICONS\\SPELL_BURNINGSOUL.BLP:20|t You have been targeted by |cFFFF0000|Hspell:240209|h[Spontaneous Fragmentation]|h|r!','INTERFACE\\ICONS\\SPELL_BURNINGSOUL.BLP:20|t You have been targeted by |cFFFF0000|Hspell:240209|h[Spontaneous Fragmentation]|h|r!',26124),
(134121,'enUS','|TINTERFACE\\ICONS\\SPELL_BURNINGSOUL.BLP:20|t You are targeted by |cFFFF0000|Hspell:239153|h[Spontaneous Fragmentation]|h|r!','|TINTERFACE\\ICONS\\SPELL_BURNINGSOUL.BLP:20|t You are targeted by |cFFFF0000|Hspell:239153|h[Spontaneous Fragmentation]|h|r!',26124),
(134122,'enUS','','If the Light is with you, then you have a chance to save your friend.$b$bBut do not tarry. Unless the Old Gods\' influence is countered quickly, his mind will be lost to madness.',26124),
(134124,'enUS','','Another assault! Be on your guard!',26124),
(134126,'enUS','','The Light shall be seared into your souls!',26124),
(134127,'enUS','','To my side, noble warriors!',26124),
(134128,'enUS','','My glaive will cut you down like grain.',26124),
(134129,'enUS','','I have sacrified too much to lose!',26124),
(134130,'enUS','','Shall you die to my magic or my blade?',26124),
(134131,'enUS','','We will destroy you, no matter the cost!',26124),
(134133,'enUS','','Arkonos vi acahachi!',26124),
(134134,'enUS','','You will find no salvation, traitors!',26124),
(134135,'enUS','','By Light be purged.',26124),
(134136,'enUS','','You are beyond redemption!',26124),
(134137,'enUS','','Wretched souls! Your defeat shall come swiftly.',26124),
(134138,'enUS','','Bring me the injured. I shall heal their wounds and purge this filth with a single prayer!',26124),
(134139,'enUS','','Pheta thones gamera.',26124),
(134140,'enUS','','If you can walk, you can fight.',26124),
(134141,'enUS','','You can rest when we\'ve killed them all! Keep fighting!',26124),
(134142,'enUS','','Hurt? Bah! You\'re still on your feet. Fight more and then we\'ll talk.',26124),
(134143,'enUS','','Do you require assistance in exterminating our foes?',26124),
(134144,'enUS','','Keep an eye out for anything useful.',26124),
(134145,'enUS','','Dioniss aca.',26124),
(134146,'enUS','','The Legion will stop at nothing. Be careful.',26124),
(134147,'enUS','','Stay safe, and slay many demons.',26124),
(134148,'enUS','','Each demon you slay is one fewer we must face.',26124),
(134153,'enUS','','Killing demons makes you feel good. Killing demons makes you feel all right.',26124),
(134154,'enUS','The loss of the Xenedar was tragic. But this is a fine ship. Perhaps we still have a chance against the Legion.','',26124),
(134160,'enUS','','I say what\'s wrong with blood? We all need it. Except the traitors. That\'s why we take theirs.',26124),
(134165,'enUS','Always good to see another $c in the ranks. We need all the help we can get.','',26124),
(134166,'enUS','','I hear the rumors, you know. That I am bloodthirsty, and conduct myself in a manner unbecoming of a priestess.',26124),
(134167,'enUS','Keep an eye out for fel-encrusted herbs. The astral glory still resides within.','',26124),
(134168,'enUS','I have identified a safe extraction point northwest of your current location.','',26124),
(134169,'enUS','There is a teleporter inbound.','',26124),
(134170,'enUS','Come. I dare not tarry here.','',26124),
(134171,'enUS','Talgath\'s last words... Not even the Light can escape. What did he mean?','',26124),
(134172,'enUS','The darkness that lingers in the temple... the shadow that looms over all of Mac\'Aree... is L\'ura.','',26124),
(134173,'enUS','I am one with the Light. The Light is with me.','',26124),
(134174,'enUS','','The fel beasts that roam these desolate lands produce some of the foulest-smelling hides I\'ve ever encountered.$b$bHopefully we can leave this place someday and find a home with nicer-smelling creatures.',26124),
(134175,'enUS','Embrace tranquility.','',26124),
(134176,'enUS','','Greetings, $n. How goes the battle against the legion?',26124),
(134177,'enUS','Feed the flame, combat the darkness.','',26124),
(134178,'enUS','Walk your path with confidence.','',26124),
(134179,'enUS','Dioniss aca.','',26124),
(134180,'enUS','When defeat is impossible, victory becomes inevitable.','',26124),
(134181,'enUS','You are no match for my blade.','',26124),
(134182,'enUS','Bend, or you shall break.','',26124),
(134183,'enUS','Your defeat is certain.','',26124),
(134184,'enUS','Two Talbuks Clashing Horns.','',26124),
(134185,'enUS','Dawn Rises.','',26124),
(134187,'enUS','|TInterface\\Icons\\SPELL_FIRE_FELFLAMEBREATH.BLP:20|tKin\'garoth has empowered |cFFFF0000|Hspell:246840|h[Ruiner]|h|r!','',26124),
(134188,'enUS','|TInterface\\Icons\\SPELL_FIRE_FLAMETOUNGE.BLP:20|tKin\'garoth has empowered |cFFFF0000|Hspell:248475|h[Reverberating Strike]|h|r!','',26124),
(134189,'enUS','|TInterface\\Icons\\SPELL_FIRE_FELFLAMERING.BLP:20|tKin\'garoth has empowered |cFFFF0000|Hspell:246779|h[Diabolic Bomb]|h|r!','',26124),
(134190,'enUS','','Hmm... one of our winners seems to have left the building. Their loss!',26124),
(134191,'enUS','Placing','Placing',26124),
(134192,'enUS','The Void consumes the weak!','',26124),
(134193,'enUS','Pathetic!','',26124),
(134194,'enUS','Such... strength.','',26124),
(134195,'enUS','Clarity... comes to me. The Void... was weak.','',26124),
(134196,'enUS','Darkness give me strength!','',26124),
(134197,'enUS','I will end you!','',26124),
(134198,'enUS','The Void calls to me!','',26124),
(134199,'enUS','I shall bring you to your twilight!','',26124),
(134200,'enUS','No! The darkness... was to be mine...','',26124),
(134201,'enUS','My death... cannot stop it. The Void... will consume all.','',26124),
(134202,'enUS','Your life ends now!','',26124),
(134203,'enUS','Stare in to the abyss, and know despair!','',26124),
(134204,'enUS','Your light fades.','',26124),
(134205,'enUS','The darkness takes you!','',26124),
(134206,'enUS','Our efforts will not be interrupted!','',26124),
(134207,'enUS','My pets hunger.','',26124),
(134210,'enUS','A simple... tactical error...','',26124),
(134212,'enUS','I did not... foresee this.','',26124),
(134213,'enUS','Strike hard and fast!','',26124),
(134214,'enUS','I shall always be one step ahead!','',26124),
(134215,'enUS','More fodder for my beauties.','',26124),
(134216,'enUS','So easily outclassed.','',26124),
(134217,'enUS','To the Void with you!','',26124),
(134218,'enUS','I shall send you to the darkness!','',26124),
(134220,'enUS','Not enough players.','',26124),
(134221,'enUS','','Every day for a thousand years, I\'ve thought about what I wanted to say to him. Now, though... words fail me.',26124),
(134222,'enUS','I know, my love. I feel the same. But once we see our son, our hearts will speak for us.','',26124),
(134238,'enUS','','You will not torment me!',26124),
(134239,'enUS','','Why can\'t you let us rest?',26124),
(134240,'enUS','','This is our home! Begone!',26124),
(134241,'enUS','','Do not mock my suffering!',26124),
(134242,'enUS','','You do not belong here!',26124),
(134244,'enUS','Embrace Sargeras!','Embrace Sargeras!',26124),
(134245,'enUS','Yes! Flee! Flee!','Yes! Flee! Flee!',26124),
(134246,'enUS','You flee to the abyss, coward!','You flee to the abyss, coward!',26124),
(134247,'enUS','Suffer for your folly!','Suffer for your folly!',26124),
(134248,'enUS','This will be the last gift you reject!','This will be the last gift you reject!',26124),
(134249,'enUS','Sargeras cannot be denied!','Sargeras cannot be denied!',26124),
(134250,'enUS','','I am so tired.',26124),
(134251,'enUS','','Such darkness... I had hoped...',26124),
(134253,'enUS','','Velen... why?',26124),
(134254,'enUS','','We could not escape.',26124),
(134255,'enUS','','I wish I had... fled...',26124),
(134256,'enUS','','When will it end?',26124),
(134257,'enUS','Run... while you can.','Run... while you can.',26124),
(134258,'enUS','The eredar... reign...','The eredar... reign...',26124),
(134259,'enUS','Why is it... dark?','Why is it... dark?',26124),
(134260,'enUS','Argus will... rise...','Argus will... rise...',26124),
(134261,'enUS','There is nowhere to run.','There is nowhere to run.',26124),
(134262,'enUS','You... will never... escape...','You... will never... escape...',26124),
(134280,'enUS','I have given our plight much thought. As it currently stands, we will be destroyed if we challenge Antorus.','',26124),
(134281,'enUS','There is one hope, one treasure that may give us the edge we need.','',26124),
(134282,'enUS','We called it the Crown of the Triumvirate.','',26124),
(134283,'enUS','A lifetime ago, my brothers and I crafted a relic designed to bring prosperity to all.','',26124),
(134284,'enUS','The beacon hums with energy.','',26124),
(134285,'enUS','Return to the entrance.','Return to the entrance.',26124),
(134286,'enUS','I still possess a third of the whole. I carry it with me always. This is the Eye of Prophecy.','',26124),
(134287,'enUS','The remaining fragments may still be here, on Argus. We must go to Mac\'Aree where my brothers and I once ruled.','',26124),
(134301,'enUS','Krona ki cristorr!','',26124),
(134302,'enUS','The Light welcomes you, champion.','',26124),
(134303,'enUS','The Army of the Light stands ready.','',26124),
(134304,'enUS','My faith is my shield.','',26124),
(134305,'enUS','We stand together.','',26124),
(134306,'enUS','Walk in the Light.','',26124),
(134307,'enUS','Dioniss aca.','',26124),
(134308,'enUS','We didn\'t come this far to falter now.','',26124),
(134311,'enUS','Light guide us.','',26124),
(134312,'enUS','We fight for home... for family.','',26124),
(134313,'enUS','I spent so long away from my home. Away from my son.','',26124),
(134314,'enUS','Fighting the Legion every step of the way. Savoring every victory, mourning every bitter defeat.','',26124),
(134315,'enUS','But for Azeroth, and for those we love, it was all worth it.','',26124),
(134316,'enUS','','Keep your gaze fixed on your target.',26124),
(134317,'enUS','','We do what we must for those we love.',26124),
(134318,'enUS','','Aim true.',26124),
(134319,'enUS','','Farewell.',26124),
(134320,'enUS','','The shadows can be an ally... if controlled.',26124),
(134321,'enUS','','Greetings.',26124),
(134322,'enUS','','We each walk a line. Choose yours.',26124),
(134323,'enUS','','Your corpse will make a fine trophy for the master!',26124),
(134324,'enUS','','Your Light will not save you. Not here!',26124),
(134325,'enUS','','What news?',26124),
(134326,'enUS','','Use every weapon at your disposal.',26124),
(134327,'enUS','','It is a good day for a hunt.',26124),
(134331,'enUS','Fascinating. Simply fascinating.','',26124),
(134332,'enUS','Do go on.','',26124),
(134333,'enUS','I represent... an alternative.','',26124),
(134335,'enUS','It is all about perspective.','',26124),
(134336,'enUS','Flesh is fickle. Power endures.','',26124),
(134337,'enUS','','You dare set foot on his world? You will die!',26124),
(134338,'enUS','Try not to waste my time.','',26124),
(134342,'enUS','','I\'m busy, $r. What do you need?',26124),
(134343,'enUS','I have your felslate shipment.','I have your felslate shipment.',26124),
(134344,'enUS','','It\'s about time. We\'ve been running low on this stuff.$b$bTell Vridiel he needs to gets his couriers working faster.',26124),
(134345,'enUS','How\'s it going, $n? Is there something I can help you with?','',26124),
(134346,'enUS','Excellent timing, $n. We just used the last of that stuff and thought we\'d have to wait longer for more. Thanks!','',26124),
(134347,'enUS','Arkhaan listens.','',26124),
(134348,'enUS','Ah! Oh. Yes?','',26124),
(134349,'enUS','You speak?','',26124),
(134350,'enUS','Stranger speaks strangely.','',26124),
(134351,'enUS','Shhh... did you hear that?','',26124),
(134352,'enUS','Close your ears to the whispers.','',26124),
(134353,'enUS','I am required to provide a greeting. Hello.','',26124),
(134354,'enUS','State your purpose.','',26124),
(134355,'enUS','I am obligated to serve.','',26124),
(134356,'enUS','Protocol dictates that I bid you farewell.','',26124),
(134357,'enUS','That gave me no pleasure either.','',26124),
(134358,'enUS','Rules are rules.','',26124),
(134359,'enUS','','I have broken countless mortals. What chance do you think you have?',26124),
(134360,'enUS','','My life for the Legion!',26124),
(134361,'enUS','','You will not... escape your fate...',26124),
(134362,'enUS','','This pain is nothing...',26124),
(134363,'enUS','','Defiance will not be tolerated!',26124),
(134364,'enUS','','Don\'t you see? This is the only way. I will make you understand!',26124),
(134365,'enUS','','Nothing can stop the master!',26124),
(134366,'enUS','','A stubborn one... I see.',26124),
(134367,'enUS','','You are blind... to the truth!',26124),
(134368,'enUS','Tremble before the true might of the Legion!','',26124),
(134369,'enUS','That world of yours hanging in the sky... is doomed!','',26124),
(134370,'enUS','Argus will be your tomb.','',26124),
(134371,'enUS','The true power of the fel courses through me!','',26124),
(134372,'enUS','You were foolish to come here!','',26124),
(134373,'enUS','Your pathetic resistance ends here!','',26124),
(134374,'enUS','No... not after all we gave...','',26124),
(134375,'enUS','Impossible! Not here!','',26124),
(134376,'enUS','My life for Argus!','',26124),
(134377,'enUS','No! Our... destiny...','',26124),
(134378,'enUS','Was this... the vision he saw?','',26124),
(134379,'enUS','I told him of my plan to leave Argus. I asked him to bring my family and join me. Instead, he went to Kil\'jaeden.','',26124),
(134380,'enUS','The rest, you know.','',26124),
(134381,'enUS','You... insignificant...','',26124),
(134382,'enUS','My people will never know how I mourned for them... the depths of my regret.','',26124),
(134383,'enUS','As Argus grew smaller and smaller in the distance, I begged the naaru to go back.','',26124),
(134384,'enUS','\"That is not your path,\" they told me. Is this what they intended?','',26124),
(134385,'enUS','Archimonde was disdainful of the Sigil\'s limitations. Without the rest of the Crown, it gave him little power. And power was all he ever craved.','',26124),
(134386,'enUS','This disdain is what allowed us to recover the Sigil. Had he anticipated its value to us, heh, he most certainly would have destroyed it.','',26124),
(134387,'enUS','I do wonder what he hoped to prove with his trials. Was the Sigil itself the test, perhaps?','',26124),
(134388,'enUS','We are one step closer to unlocking the Vindicaar\'s true potential. All that remains is the Crest of Knowledge. Then the Crown will once more be whole.','',26124),
(134389,'enUS','Make haste, my friends. Something dark and terrible stirs... and it is not Talgath.','',26124),
(134390,'enUS','Worthless. The Crest alone is powerless.','',26124),
(134391,'enUS','This relic\'s time has passed. Throw it in the temple with the naaru. Let them rot together.','',26124),
(134392,'enUS','At least we know where it is.','',26124),
(134393,'enUS','It is hidden in the Seat of the Triumvirate, then. I sense only darkness within.','',26124),
(134396,'enUS','We have no time to celebrate our victory over Talgath. L\'ura\'s dark song echoes in my mind.','',26124),
(134399,'enUS','You have faced perils rivaling any the Legion has wrought. Please, do me the honor of placing the Crest.','',26124),
(134400,'enUS','The Crown is whole once more!','',26124),
(134401,'enUS','Now we take the fight to the Burning Throne itself. Ready yourselves. Antorus awaits!','',26124),
(134402,'enUS','Sweet dreams.','',26124),
(134403,'enUS','Stay down!','',26124),
(134404,'enUS','I\'ll collect you later.','',26124),
(134405,'enUS','Keep up, if you can.','',26124),
(134406,'enUS','Time for a little carnage!','',26124),
(134407,'enUS','You\'ve got to be faster than that, mortals!','',26124),
(134408,'enUS','Don\'t need a complete corpse to collect the bounty. A few pieces will do.','',26124),
(134409,'enUS','Try to keep your identifiable parts intact.','',26124),
(134410,'enUS','I am afraid our continued presence on Mac\'Aree has awoken more angry spirits. Help them find peace.','',26124),
(134411,'enUS','I look forward to the day when we leave this shattered place behind. Perhaps then they will find their rest.','',26124),
(134412,'enUS','I have need of a very specific type of crystal to maintain the Vindicaar\'s defenses. The constructs lingering here share this technology. Extract their cores. Use whatever manner you see fit.','',26124),
(134413,'enUS','Those constructs certainly have not aged well, have they? I guess nothing is immune to obsolescence in the end.','',26124),
(134414,'enUS','The Legion\'s forces occupy the estates of Mac\'Aree. Activate the nobles\' vigilants to help with the battle. No doubt their power crystals have been stolen by the eredar.','',26124),
(134415,'enUS','The activated constructs will serve as an excellent distraction. My thanks!','',26124),
(134416,'enUS','The Legion seeks to claim a foothold on Mac\'Aree. Disrupt their forces any way you can. Give them a mess to clean up.','',26124),
(134417,'enUS','That ought to keep them busy. For now, at least.','',26124),
(134418,'enUS','','The formidable creatures here are prey worthy of any hunter, yet the Shadowguard seeks to empower them further with the void. Stop the ethereals and release these beasts back into the wilds.',26124),
(134419,'enUS','','I hope they can be soothed after their ordeal. Good work, but our struggle against the Shadowguard continues.',26124),
(134420,'enUS','My brethren are as industrious as they are clever. I fear the incursion point needs another round of cleansing. You know what to do.','',26124),
(134421,'enUS','Amusing how they continue to underestimate you fleshlings, is it not?','',26124),
(134422,'enUS','Forces from Antorus are using the remains of Talgath\'s portals to stage another invasion on Mac\'Aree. Stop their advance before we are overrun.','',26124),
(134423,'enUS','You bought us valuable time, but we must remain vigilant. So long as the Legion knows we have a foothold on Mac\'Aree, they will not relent.','',26124),
(134424,'enUS','Strange... Spirits have congregated to hear Kil\'jaeden speak, yet all is not as it seems. I sense a demonic presence. Find it amongst the crowd before it can stage an ambush.','',26124),
(134425,'enUS','An unusual tactic, to be certain. The Legion cannot be allowed to use these defenseless spirits for their machinations.','',26124),
(134426,'enUS','','This place is churning out darkness, manifesting into crystals of pure void. The Shadowguard covets this resource. We must claim it before they do.',26124),
(134427,'enUS','','That is one less arrow in their quiver. Perhaps I can find a use for these crystals that will benefit our cause.',26124),
(134428,'enUS','I have devised a modification on a previous trial. Should you be equal to the challenge, you may once again prove your cunning.','',26124),
(134429,'enUS','Hmph. I was certain you would not complete the trial this time. I must, per the rules, acknowledge your success. Congratulations.','',26124),
(134430,'enUS','','Panthara are feasting on Conservatory spirits. Bring me samples of their scales. Perhaps I can devise a deterrent.',26124),
(134431,'enUS','','Fascinating! Their scales are covered in mana-sensitive particulate. I am certain we can find a use for this knowledge.',26124),
(134432,'enUS','You are overdue for remedial lessons. Report to the Hall of Enlightenment for an exam.','',26124),
(134433,'enUS','I will allow you to retain your credentials. For now.','',26124),
(134434,'enUS','','There are many unanswered questions about the spirits lingering in this place. Why do they stay? What makes them rebuff our presence? Perhaps studying their essences will yield an answer.',26124),
(134435,'enUS','','I will not waste this opportunity to learn from my former peers. Thank you for your help.',26124),
(134436,'enUS','My brethren have taken it upon themselves to hasten this area\'s fall to darkness. Disrupt their activities. Or don\'t. The Void will have its due either way.','',26124),
(134437,'enUS','You know what they say. Fool me once, shame on you. Fool me twice...','',26124),
(134440,'enUS','You\'ve got nowhere to run.','',26124),
(134441,'enUS','Looks like I\'ll have to call in the big guns.','',26124),
(134443,'enUS','<Shroud of Arcane Echoes>','<Shroud of Arcane Echoes>',26124),
(134444,'enUS','<Vindicaar Teleport Beacon>','<Vindicaar Teleport Beacon>',26124),
(134445,'enUS','<Lightforged Champion>','<Lightforged Champion>',26124),
(134446,'enUS','<Lightforged Warframe>','<Lightforged Warframe>',26124),
(134452,'enUS','What of the other captains? I pray that they are safe as well.','',26124),
(134454,'enUS','','Do not worry, High Exarch. Enaara and Sorvos have taken up positions at our main camp. The rest are scattered, but I am sure they survived.',26124),
(134455,'enUS','Fire on my position!','',26124),
(134456,'enUS','Bombard this area!','',26124),
(134457,'enUS','The more you fight, the higher the bounty!','',26124),
(134458,'enUS','Light\'s Judgment... she is magnificent. I should have it operational shortly!','',26124),
(134459,'enUS','You\'re beginning to outlive your worth.','',26124),
(134461,'enUS','You\'re not going to make it out of this alive!','',26124),
(134462,'enUS','I\'ll cut you in two and collect twice the bounty!','',26124),
(134466,'enUS','','Antorus will know your screams!',26124),
(134467,'enUS','','Witness the might of the Burning Throne!',26124),
(134468,'enUS','','A fatal mistake.',26124),
(134469,'enUS','','You think you can defeat us? Here? Hah!',26124),
(134470,'enUS','','I want to see your limbs roasting!',26124),
(134472,'enUS','','Antorus sends its regards!',26124),
(134473,'enUS','','You look so vulnerable, trembling in the dark.',26124),
(134477,'enUS','You\'ve done it, champion! Come, let us enter the Xenedar and rescue Xe\'ra!','',26124),
(134478,'enUS','','Enjoy my icy caress before you are frozen solid.',26124),
(134479,'enUS','','I will be reborn again... and again...',26124),
(134480,'enUS','','I am one... of many...',26124),
(134481,'enUS','','Antorus, I return...',26124),
(134482,'enUS','','By Argus\' flame I will be renewed.',26124),
(134483,'enUS','','This changes nothing.',26124),
(134484,'enUS','Run... while you can.','Run... while you can.',26124),
(134485,'enUS','The eredar... reign...','The eredar... reign...',26124),
(134486,'enUS','Why is it... dark?','Why is it... dark?',26124),
(134487,'enUS','Argus will... rise...','Argus will... rise...',26124),
(134488,'enUS','There is nowhere to run.','There is nowhere to run.',26124),
(134489,'enUS','You... will never... escape...','You... will never... escape...',26124),
(134491,'enUS','Run... while you can.','',26124),
(134493,'enUS','The Eredar... reign...','',26124),
(134494,'enUS','Why is it... dark?','',26124),
(134495,'enUS','Argus will... rise...','',26124),
(134496,'enUS','There is nowhere to run.','',26124),
(134497,'enUS','You... will never... escape...','',26124),
(134498,'enUS','Embrace Sargeras!','',26124),
(134499,'enUS','Yes! Flee! Flee!','',26124),
(134500,'enUS','You flee to the abyss, coward!','',26124),
(134501,'enUS','Suffer your folly!','',26124),
(134502,'enUS','Khaz\'goroth\'s will is bein\' twisted. He can\'t control his flame!','',26124),
(134503,'enUS','This will be the last gift you reject!','',26124),
(134504,'enUS','Sargeras cannot be denied!','',26124),
(134505,'enUS','Suffer for your folly!','Suffer for your folly!',26124),
(134506,'enUS','You flee to the abyss, coward!','You flee to the abyss, coward!',26124),
(134507,'enUS','Yes! Flee! Flee!','Yes! Flee! Flee!',26124),
(134508,'enUS','Embrace Sargeras!','Embrace Sargeras!',26124),
(134509,'enUS','Sargeras cannot be denied!','Sargeras cannot be denied!',26124),
(134510,'enUS','This will be the last gift you reject!','This will be the last gift you reject!',26124),
(134511,'enUS','You will not torment me!','',26124),
(134512,'enUS','Why can\'t you let us rest?','',26124),
(134513,'enUS','This is our home! Begone!','',26124),
(134514,'enUS','Do not mock my suffering!','',26124),
(134515,'enUS','You do not belong here!','',26124),
(134516,'enUS','Why have you come?','',26124),
(134517,'enUS','Why have you come?','Why have you come?',26124),
(134518,'enUS','You do not belong here!','You do not belong here!',26124),
(134519,'enUS','Do not mock my suffering!','Do not mock my suffering!',26124),
(134520,'enUS','This is our home! Begone!','This is our home! Begone!',26124),
(134521,'enUS','Why can\'t you let us rest?','Why can\'t you let us rest?',26124),
(134522,'enUS','You will not torment me!','You will not torment me!',26124),
(134523,'enUS','I am so tired.','',26124),
(134524,'enUS','Such darkness... I had hoped...','',26124),
(134525,'enUS','Velen... why?','',26124),
(134526,'enUS','We could not escape.','',26124),
(134527,'enUS','I wish I had... fled...','',26124),
(134528,'enUS','When will it end?','',26124),
(134529,'enUS','When will it end?','When will it end?',26124),
(134530,'enUS','I wish I had... fled...','I wish I had... fled...',26124),
(134531,'enUS','We could not escape.','We could not escape.',26124),
(134532,'enUS','Velen... why?','Velen... why?',26124),
(134533,'enUS','Such darkness... I had hoped...','Such darkness... I had hoped...',26124),
(134534,'enUS','I am so tired.','I am so tired.',26124),
(134535,'enUS','I waited so long...','',26124),
(134536,'enUS','Is this... all there is?','',26124),
(134537,'enUS','Is this... all there is?','Is this... all there is?',26124),
(134538,'enUS','I waited so long...','I waited so long...',26124),
(134539,'enUS','Is this... all there is?','Is this... all there is?',26124),
(134540,'enUS','I waited so long...','I waited so long...',26124),
(134541,'enUS','','Is this... all there is?',26124),
(134542,'enUS','','I waited so long...',26124),
(134543,'enUS','They\'re tearin\' Norgannon\'s mind ta pieces!','',26124),
(134544,'enUS','Golganneth... he\'s lost in a storm o\' agony!','',26124),
(134545,'enUS','','Leave us alone!',26124),
(134546,'enUS','','You are not welcome here!',26124),
(134547,'enUS','You are not welcome here!','You are not welcome here!',26124),
(134548,'enUS','Leave us alone!','Leave us alone!',26124),
(134549,'enUS','You are not welcome here!','You are not welcome here!',26124),
(134550,'enUS','Leave us alone!','Leave us alone!',26124),
(134551,'enUS','You are not welcome here!','',26124),
(134552,'enUS','Leave us alone!','',26124),
(134553,'enUS','It is good to see you again, my friends. When I couldn\'t find you after the devastation of Draenor, I wasn\'t sure what to think.','',26124),
(134554,'enUS','','You rush to your death. Allow me to oblige you.',26124),
(134555,'enUS','We feared for you as well, Khadgar. But I think part of me knew it would take more than the explosion of a planet to slow you down.','',26124),
(134556,'enUS','','More souls to fuel the fel!',26124),
(134557,'enUS','','Kurdran and Danath are safe as well?',26124),
(134558,'enUS','','Argus will know your pain!',26124),
(134559,'enUS','There is nowhere to run!','There is nowhere to run!',26124),
(134560,'enUS','Indeed, though I don\'t get to see them as often as I\'d like. When this is all behind us, perhaps the Sons of Lothar should share a reunion feast!','',26124),
(134561,'enUS','You will pay for your cowardice!','You will pay for your cowardice!',26124),
(134562,'enUS','You will pay for your cowardice!','',26124),
(134563,'enUS','There is nowhere to run!','',26124),
(134564,'enUS','You will pay for your cowardice!','You will pay for your cowardice!',26124),
(134565,'enUS','There is nowhere to run!','There is nowhere to run!',26124),
(134566,'enUS','You will pay for your cowardice!','',26124),
(134567,'enUS','There is nowhere to run!','',26124),
(134568,'enUS','I agree. It\'s been a long time, but as I recall it was your turn to buy the drinks, Khadgar.','',26124),
(134569,'enUS','They\'re usin\' Aman\'Thul\'s mastery o\' time against ye!','',26124),
(134570,'enUS','Well, I don\'t know about that...','',26124),
(134571,'enUS','We will never stop...','We will never stop...',26124),
(134572,'enUS','','Definitely your turn. Never question an elf\'s memory... even after a thousand years.',26124),
(134573,'enUS','The Destroyer will find you...','The Destroyer will find you...',26124),
(134574,'enUS','The Destroyer will find you...','',26124),
(134575,'enUS','Your cowardice marks you. We will never stop...','',26124),
(134576,'enUS','The Destroyer will find you...','The Destroyer will find you...',26124),
(134577,'enUS','We will never stop...','We will never stop...',26124),
(134578,'enUS','The Destroyer will find you...','',26124),
(134579,'enUS','Your cowardice marks you. We will never stop...','',26124),
(134600,'enUS','','Find the Prophet! Slaughter his allies!',26124),
(134601,'enUS','','Mark my words! Velen must not escape!',26124),
(134602,'enUS','','Leave no stone unturned. Find him!',26124),
(134603,'enUS','','Failure will be rewarded with torment! The Prophet must not escape!',26124),
(134604,'enUS','','The eyes of Antorus are upon you. Find the Prophet or suffer the consequences!',26124),
(134605,'enUS','','Get back to work... or you will know the lash!',26124),
(134606,'enUS','','Double your efforts! This land has been useless long enough.',26124),
(134607,'enUS','','You can rest when this rock is ours!',26124),
(134608,'enUS','','Antorus demands its prize! Mac\'Aree will be ours!',26124),
(134609,'enUS','','Your lives are forfeit, should we fail. Secure Mac\'Aree!',26124),
(134611,'enUS','I won\'t risk our forces on the spire without that warframe backing us.','',26124),
(134612,'enUS','It will be ready, High Exarch. You have my word.','',26124),
(134623,'enUS','Was I supposed to energize the projection before I stabilized the effusion? Oh...','',26124),
(134625,'enUS','Maybe if I just invert the core matrix to expel... wait, no. That is how explosions happen.','',26124),
(134626,'enUS','I should have started studying sooner.','',26124),
(134627,'enUS','Krono-ka lith\'tor agnos... or was it lith\'nos agtor? Bah! I will never get this spell right!','',26124),
(134628,'enUS','','Perhaps we had best discuss the matter in private.',26124),
(134634,'enUS','Maybe I should have listened to my parents and come a jewelcrafter instead...','',26124),
(134635,'enUS','I will never reach Arc-Consul at this rate.','',26124),
(134636,'enUS','Archimonde learned to do this as an acolyte. How hard could it be?','',26124),
(134640,'enUS','The demons came into our world, their only desire to extinguish all life.','',26124),
(134641,'enUS','Now we will prey upon them!','',26124),
(134642,'enUS','Already their ranks crumble. We must press the attack.','',26124),
(134643,'enUS','','I go missing for all those years and this is how you treat me?',26124),
(134644,'enUS','','Yes, of course I still love him. Must you be so nosey?',26124),
(134645,'enUS','','Sisters are complicated. Especially the undead ones.',26124),
(134653,'enUS','I lend you my strength.','',26124),
(134654,'enUS','','My void will consume you... if you ask nicely.',26124),
(134655,'enUS','Come, speak with me.','',26124),
(134657,'enUS','Our time is now, hero.','',26124),
(134658,'enUS','The Vindicaar is at your disposal.','',26124),
(134659,'enUS','We will endure.','',26124),
(134660,'enUS','May the Legion fall before you.','',26124),
(134662,'enUS','Remember, even number of facets, no occlusions. It has to be just so!','',26124),
(134677,'enUS','I have your coordinates, champion. It will take some time to calibrate the teleportation matrices. Keep it out of the Legion\'s hands until then!','',26124),
(134679,'enUS','We\'ve breached the wall!','',26124),
(134680,'enUS','Lightforged, secure this position!','',26124),
(134681,'enUS','The Vindicaar will draw all the fire we can, Turalyon, but we cannot hold out long. You must disable their defenses!','',26124),
(134682,'enUS','We will not fail you, Prophet.','',26124),
(134683,'enUS','Champions, we\'ll keep these winged beasts occupied while you clear a path.','',26124),
(134684,'enUS','','Make them suffer.',26124),
(134685,'enUS','Careful. I dabble in powers beyond your comprehension.','',26124),
(134686,'enUS','Yes, I do have a \"real\" name. It\'s none of your business.','',26124),
(134687,'enUS','Were I to speak it aloud, a thousand void portals would rip open and some very unpleasant entities would come looking to collect on old debts.','',26124),
(134688,'enUS','But by all means, if you want to see reality itself torn asunder, keep asking about my name.','',26124),
(134689,'enUS','Here\'s a hint: it\'s an ancient word of power. If I whisper it in your ear, your mind will fall into madness. Still want to play?','',26124),
(134690,'enUS','We\'re gaining ground! Press the attack!','',26124),
(134691,'enUS','Lightforged, fall back!','',26124),
(134692,'enUS','Champions, bring that monstrosity down!','',26124),
(134694,'enUS','Once the spires are out of the way, we will make our move.','',26124),
(134700,'enUS','','Turalyon, I\'ve started my assault on the northern front. I\'ll keep their forces occupied so you can hit the priority targets.',26124),
(134701,'enUS','Our forces are moving towards Legion high command. Buy us all the time you can, Alleria.','',26124),
(134702,'enUS','','Use my portals to take the fight to the enemy. Make haste!',26124),
(134703,'enUS','Champions, there is a disturbance close to your location the likes of which I haven\'t felt since the opening of the Dark Portal.','',26124),
(134704,'enUS','|TInterface\\Icons\\ABILITY_CREATURE_CURSED_05.BLP:20|tThe Paraxis charges its weapons to bring about Eonar\'s |cFFFF0000|Hspell:249121|h[Final Doom]|h|r!','|TInterface\\Icons\\ABILITY_CREATURE_CURSED_05.BLP:20|tThe Paraxis charges its weapons to bring about Eonar\'s |cFFFF0000|Hspell:249121|h[Final Doom]|h|r !',26124),
(134705,'enUS','If the Legion is using that hub to gather reinforcements, then it must be destroyed before we are overwhelmed.','',26124),
(134706,'enUS','|TInterface\\Icons\\PRIEST_ICON_CHAKRA.BLP:20|tDiseased energy infects you.','|TInterface\\Icons\\PRIEST_ICON_CHAKRA.BLP:20|tDiseased energy infects you.',26124),
(134707,'enUS','|TInterface\\Icons\\PRIEST_ICON_CHAKRA_RED.BLP:20|tFirey energy burns through you.','|TInterface\\Icons\\PRIEST_ICON_CHAKRA_RED.BLP:20|tFirey energy burns through you.',26124),
(134708,'enUS','|TInterface\\Icons\\PRIEST_ICON_CHAKRA_GREEN.BLP:20|tFel energy courses through you.','|TInterface\\Icons\\PRIEST_ICON_CHAKRA_GREEN.BLP:20|tFel energy courses through you.',26124),
(134709,'enUS','|TInterface\\Icons\\PRIEST_ICON_CHAKRA_BLUE.BLP:20|tArcane energies crackle around you.','|TInterface\\Icons\\PRIEST_ICON_CHAKRA_BLUE.BLP:20|tArcane energies crackle around you.',26124),
(134711,'enUS','Diseased energy infects a nearby crystal.','Diseased energy infects a nearby crystal.',26124),
(134712,'enUS','A nearby crystal burns with Fiery energy.','A nearby crystal burns with Fiery energy.',26124),
(134713,'enUS','Fel energy courses through a nearby crystal.','Fel energy courses through a nearby crystal.',26124),
(134714,'enUS','A nearby crystal crackles with Arcane energy.','A nearby crystal crackles with Arcane energy.',26124),
(134716,'enUS','Without their portals, the Legion is cut off from reinforcements. Now is the time to press our attack!','',26124),
(134717,'enUS','Sargeras has left us a few of his favorite pets to play with. Remove these abominations from the battlefield.','',26124),
(134718,'enUS','That\'s two demons down, but countless more await the attention of your blade.','',26124),
(134719,'enUS','I recognize the trappings of the generals commanding the Legion\'s forces. Before Sargeras took our world, these generals martialed our armies and brought peace to Argus.','',26124),
(134720,'enUS','They betrayed everything we stood for when they accepted his bargain. There can be no redemption... only retribution.','',26124),
(134721,'enUS','The war council has finally paid for their treachery. Without their leadership, the Legion will fall into chaos.','',26124),
(134723,'enUS','Champions! I heard a familiar voice callin\', so I fought me way inside this accursed place.','',26124),
(134724,'enUS','','Champions, hear me.  The Legion has breached my sanctuary, and my defenses will soon be overrun. Stand with me now, lest Sargeras claim his prize.',26124),
(134730,'enUS','It\'s Eonar, the Life-Binder! This portal leads ta her sanctuary. Go. I\'ll stay here and cover yer backs!','',26124),
(134731,'enUS','','The tormented cries of the Pantheon ring out from deep within the core of Argus.',26124),
(134732,'enUS','','Release them, champions, or your struggle will be for naught.',26124),
(134733,'enUS','The Legion\'s ranks are crumbling, but they still outnumber us. My forces will keep them engaged here.','',26124),
(134734,'enUS','','You will not be fighting alone, Turalyon. The demons will pay for every step... with their blood.',26124),
(134735,'enUS','Well done, champions. For the first time in millennia, a blow has been struck against the denizens of the Burning Throne.','',26124),
(134736,'enUS','Sargeras seeks ta corrupt the other titans! If we don\'t stop \'im, the Pantheon will be reborn in darkness. There\'s no time ta waste!','',26124),
(134737,'enUS','Striking at the heart of the Legion is futile until we take out their war machines. Unchecked, they would soon overwhelm us.','',26124),
(134738,'enUS','Agreed. We must cripple those infernal engines of destruction. Champions, use this teleporter to board the Vindicaar. On to our next target!','',26124),
(134742,'enUS','The Legion is in its death throes. Time to put our boot to their throats. Return to the Vindicaar and prepare to strike the killing blow.','',26124),
(134744,'enUS','Good, good, I was hoping you\'d find your way here. I\'m always in need of test subjects. You should do nicely!','',26124),
(134761,'enUS','Who ordered the chicken?','',26124),
(134767,'enUS','There was barely any warnin\'. De Kor\'kron mounted an attack on Sen\'jin in force. We were lucky Vol\'jin was there to help us.','',26124),
(134768,'enUS','He gave such an inspirin\' speech!','',26124),
(134769,'enUS','Razor Hill was already lost when we got der.','',26124),
(134770,'enUS','Dey didn\'t know we was comin\'!','',26124),
(134771,'enUS','I miss da Warchief. I tink we all do.','',26124),
(134772,'enUS','Welcome to my inn!','',26124),
(134773,'enUS','Busy night... but there\'s always room for another!','',26124),
(134774,'enUS','Boys and girls, look who it is!','',26124),
(134775,'enUS','Pull up a chair by the hearth!','',26124),
(134776,'enUS','Welcome back!','',26124),
(134777,'enUS','Ohohoho, it\'s good to see you again!','',26124),
(134778,'enUS','Ha, find a seat if you can!','',26124),
(134779,'enUS','Think I\'ll keep a few of your parts as a trophy.','',26124),
(134780,'enUS','Your bones will be my biggest payday.','',26124),
(134785,'enUS','Ha! Killed by the best!','',26124),
(134787,'enUS','Barely enough left to collect!','',26124),
(134788,'enUS','Easiest money I ever made.','',26124),
(134791,'enUS','Seems my employer overestimated your threat. But who am I to question a payday?','',26124),
(134795,'enUS','An orb of Diseased energy lies on the ground near the $n.','An orb of Diseased energy lies on the ground near the $n.',26124),
(134796,'enUS','An orb of Firey energy lies on the ground near the $n.','An orb of Firey energy lies on the ground near the $n.',26124),
(134797,'enUS','An orb of Fel energy lies on the ground near the $n.','An orb of Fel energy lies on the ground near the $n.',26124),
(134798,'enUS','An orb of Arcane energy lies on the ground near the $n.','An orb of Arcane energy lies on the ground near the $n.',26124),
(134821,'enUS','','If Sargeras breaks them as he did Aggramar, no power in this universe will stop him.',26124),
(134839,'enUS','There\'s nothing more I can do, commander. They\'re with the Light now.','There\'s nothing more I can do, commander. They\'re with the Light now.',26124),
(134840,'enUS','They gave everything to this war. We must honor that sacrifice.','They gave everything to this war. We must honor that sacrifice.',26124),
(134868,'enUS','You\'ll go no further, mortal scum. There\'s a bounty on your heads, and I mean to collect.','',26124),
(134870,'enUS','Beyond these blast doors lies the heart of the Legion\'s war machine. Eliminating this threat will cripple the demons\' arsenal.','',26124),
(134878,'enUS','Time for my pawns to thin your ranks!','',26124),
(134879,'enUS','','All vessels, converge on my position!',26124),
(134880,'enUS','I tire of this labor! It will be more satisfying to have my machines tear you apart.','',26124),
(134881,'enUS','I can no longer resist the call to battle!','',26124),
(134882,'enUS','','Why let my vessels blast you apart when I can dispatch you myself?',26124),
(134883,'enUS','It appears I need to take a more hands-on approach!','',26124),
(134884,'enUS','','Cannons, begin firing on my mark!',26124),
(134885,'enUS','Demons! Charge!','',26124),
(134886,'enUS','Leave no one alive!','',26124),
(134887,'enUS','Legion, show these weaklings why we are the dominant force in the cosmos!','',26124),
(134888,'enUS','I hope you enjoy my inventions.','',26124),
(134889,'enUS','Watch your step!','',26124),
(134892,'enUS','I have calculated your odds of survival--zero!','',26124),
(134900,'enUS','','The Man\'ari will never defile the armor!',26124),
(134901,'enUS','','No! I cannot fail...',26124),
(134902,'enUS','','Death to the Man\'ari!',26124),
(134903,'enUS','','Who dares to defile this sacred armory?',26124),
(134912,'enUS','The Vindicaar awaits your orders, $n. Where do we take the fight next?','The Vindicaar awaits your orders, $n. Where do we take the fight next?',26124),
(134913,'enUS','The Exhaust','The Exhaust',26124),
(134914,'enUS','','Your faith is weak.',26124),
(134915,'enUS','','Your existence was meaningless.',26124),
(134916,'enUS','','I have walked the spaces between stars. What hope did you have against me?',26124),
(134917,'enUS','','My essence... returns... to the Nether.',26124),
(134918,'enUS','','I wield the power of the cosmos!',26124),
(134919,'enUS','Broken Cliffs','Broken Cliffs',26124),
(134920,'enUS','The Burning Throne','The Burning Throne',26124),
(134926,'enUS','Yet this battle is far from over. A great power roils in torment at this world\'s core.','',26124),
(134928,'enUS','Rendezvous with the Vindicaar so we can prepare for the final attack.','',26124),
(134981,'enUS','Many gave their lives to hold this ground. Honor their sacrifice and drive these demons back into the abyss!','Many gave their lives to hold this ground. Honor their sacrifice and drive these demons back into the abyss!',26124),
(135004,'enUS','Some disassembly required.','',26124),
(135005,'enUS','Send in the next test subject!','',26124),
(135006,'enUS','Allow me to demonstrate my newest invention.','',26124),
(135007,'enUS','Let\'s see how fast you can run.','',26124),
(135008,'enUS','There is no escape!','',26124),
(135010,'enUS','Witness true power!','',26124),
(135011,'enUS','Die!','',26124),
(135012,'enUS','I will turn you to ash!','',26124),
(135013,'enUS','Such an honor! You will be test subjects for my ultimate weapon!','',26124),
(135014,'enUS','It appears adjustments still need to be made.','',26124),
(135015,'enUS','You have outlived your usefulness!','',26124),
(135016,'enUS','May the Light hasten you to Magni. I hope he has good news.','',26124),
(135017,'enUS','The short one of diamonds awaits you in the stone\'s resting chamber. He is... distressed.','',26124),
(135019,'enUS','I feel Argus\'s soul callin\' ta me again. He\'s frantic, desperate... and sad, so bloody sad. It breaks me heart!','',26124),
(135020,'enUS','Place yer hand upon the stone when yer ready.','',26124),
(135021,'enUS','The stone thrums with energy.','',26124),
(135022,'enUS','<Place your hand on the stone.>','<Place your hand on the stone.>',26124),
(135023,'enUS','Sargeras is building some kind o\' Dark Pantheon! We gotta find Eonar\'s spirit before Aggramar does!','',26124),
(135026,'enUS','So be it. We will do all we can to ensure Eonar does not fall like the others.','',26124),
(135027,'enUS','I only hope we are not too late.','',26124),
(135058,'enUS','Halt!','',26124),
(135085,'enUS','','Such potential here, but all of it wasted on a doomed crusade.',26124),
(135086,'enUS','','Can you taste it on the air? The sweet nectar of madness? Mmm... this place is swollen with it.',26124),
(135087,'enUS','','This one shows promise. The whispers lure her toward her fate.',26124),
(135088,'enUS','','The caterpillar has become the butterfly. She is all but ours now.',26124),
(135089,'enUS','','He flaunts his defiance of the shadows. Arrogance will be his undoing.',26124),
(135090,'enUS','','Watch now as a weak mind gives way to darkness.',26124),
(135091,'enUS','','While I relish a healthy lust for power, this one fumbles for it like an amateur.',26124),
(135092,'enUS','','Now this is true beauty! At least one of the mortals in your midst can appreciate what it offers.',26124),
(135093,'enUS','','So much effort, so much bluster, only to delay the inevitable victory of their betters.',26124),
(135094,'enUS','','Imagine this machinery infused with our power. Interesting...',26124),
(135095,'enUS','','What a disappointment. He squandered his potential by backing the wrong side.',26124),
(135096,'enUS','','These pretenders play at whispering madness. Amateurs! I should demonstrate proper technique.',26124),
(135097,'enUS','','This one would make an excellent champion for our cause. Perhaps he can yet be turned.',26124),
(135098,'enUS','','Long have we sought entry to this realm! To think we have a mortal to thank for giving us our foothold. Your service will be remembered!',26124),
(135099,'enUS','Draw your blades! I will show you torment!','',26124),
(135100,'enUS','Your torment... is only... beginning.','',26124),
(135101,'enUS','Is that all you can take?','',26124),
(135102,'enUS','Pathetic and weak!','',26124),
(135103,'enUS','Weaklings! You surrender to the merest taste of what I have suffered.','',26124),
(135104,'enUS','Time to put an end to this!','',26124),
(135105,'enUS','Behold the might of the nathrezim!','',26124),
(135106,'enUS','So, your Alliance still endures. Longer than I expected, though she has already planted the seeds of its downfall. She is patient, that one.','',26124),
(135107,'enUS','When your thrones run red with betrayal... when your holy places burn and the shattered mask hangs above your hearth... only then you will know. And it will be too late.','',26124),
(135108,'enUS','It matters not. You are blind to the true darkness closing in around you.','',26124),
(135109,'enUS','So, she found me at last. Sent her underlings to finish the job.','',26124),
(135110,'enUS','Tell me, when she seized your throne of hides and bones, was your allegiance forced? No... I\'d wager you surrendered it willingly... or were convinced you did.','',26124),
(135111,'enUS','It matters not. You are blind to the darkness in your midst.','',26124),
(135112,'enUS','Easy prey!','',26124),
(135113,'enUS','You are mine!','',26124),
(135114,'enUS','Pain awaits in the darkness!','',26124),
(135115,'enUS','Ah, the agony of shadows!','',26124),
(135116,'enUS','Back, cur!','',26124),
(135117,'enUS','Away!','',26124),
(135118,'enUS','Share your suffering!','',26124),
(135119,'enUS','Let pain embrace you!','',26124),
(135120,'enUS','Behold! Pain given form!','',26124),
(135121,'enUS','A gift born of agony!','',26124),
(135122,'enUS','Grah! Damnable witches!','',26124),
(135123,'enUS','You cannot break me!','',26124),
(135124,'enUS','I... will... kill you all!','',26124),
(135125,'enUS','Arrrrraaaaagghhhh!','',26124),
(135126,'enUS','','Look! The wretch struggles against the mortal intruders.',26124),
(135127,'enUS','','Then watch the icy grip of despair drain his will!',26124),
(135128,'enUS','','We cannot allow this wretch to savor victory.',26124),
(135129,'enUS','','Pathetic! Let them all burn!',26124),
(135130,'enUS','','The prisoner weakens. He is close to surrender.',26124),
(135131,'enUS','','The mortals falter!',26124),
(135132,'enUS','','Perhaps the nathrezim has grown too familiar with the torment of flames, my sisters.',26124),
(135133,'enUS','','Lack of faith is his undoing. The fel will consume the unworthy.',26124),
(135134,'enUS','','Enough of this. Let the shadows claim them all.',26124),
(135135,'enUS','A titan... the Legion must have harnessed the power of its soul to regenerate its armies in the Nether! If we can destroy it, the infinite army...','',26124),
(135136,'enUS','','His fate was ours to decide. You will pay for your insolence, mortals!',26124),
(135142,'enUS','Mac\'Aree... this is all that is left.','',26124),
(135143,'enUS','Using','Using',26124),
(135144,'enUS','|TInterface\\ICONS\\SPELL_SHADOW_PAINSPIKE:20|tA Greater Rift Warden starts to cast |cFFFF0000|Hspell:245164|h[Fragment of Despair]|h|r!','',26124),
(135146,'enUS','I am not the last. The eredar... will rise...','',26124),
(135148,'enUS','This is the power you rejected!','',26124),
(135149,'enUS','You are unworthy of the name eredar!','',26124),
(135150,'enUS','You will not bow? Then die!','',26124),
(135151,'enUS','Look upon perfection. This is the last gift you will reject!','',26124),
(135152,'enUS','Weaklings. I will show you the gravity of your mistake.','',26124),
(135153,'enUS','So many were left behind... They linger, forced to relive their final moments over and over again.','',26124),
(135154,'enUS','Perhaps the only way to end their torment is to finish what I started so very long ago.','',26124),
(135155,'enUS','We must let these spirits finally realize their escape.','',26124),
(135156,'enUS','It is good that you have returned. Something has... changed with the stone.','',26124),
(135157,'enUS','The Life-Binder! Somehow, she\'s the key to Sargeras\'s plan.','',26124),
(135158,'enUS','We must find her soul. I just don\'t know how.','',26124),
(135159,'enUS','Leave that to me.','',26124),
(135160,'enUS','This soul fragment calls ta me again, but somethin\'s different this time. It ain\'t Argus speakin\'. It\'s... another.','',26124),
(135161,'enUS','This is the turning point. If we can activate the arena\'s defenses, this battle will be finished.','',26124),
(135162,'enUS','It is time to forge our own path, my friend.','',26124),
(135163,'enUS','Our forces are prepared to assault the Burning Throne, but we cannot move until we find Eonar\'s spirit.','',26124),
(135164,'enUS','','Would become finite. Taking away the Legion\'s advantage would give us our best chance to save Azeroth!',26124),
(135165,'enUS','It is time we repay the favor.','',26124),
(135166,'enUS','','The Shadowguard is building up its presence near the temple.',26124),
(135167,'enUS','Disrupting their efforts would benefit us all. Also, their commander here has a particular item that would be useful to me.','',26124),
(135168,'enUS','','Just give the word, heroes, and we can begin the assault.',26124),
(135169,'enUS','Thank you for removing the obstacles between me and this staff, heroes.','',26124),
(135170,'enUS','Yes, this will do nicely. You\'ll find their viceroy near the entrance to the temple, feebly trying to break in.','',26124),
(135171,'enUS','Eliminating him will give us an opportunity to get in ourselves.','',26124),
(135172,'enUS','I\'ll see to opening the way once he\'s taken care of.','',26124),
(135180,'enUS','Diseased energy coalesces around the $n.','Diseased energy coalesces around the $n.',26124),
(135181,'enUS','Fiery energy coalesces around the $n.','Fiery energy coalesces around the $n.',26124),
(135182,'enUS','Fel energy coalesces around the $n.','Fel energy coalesces around the $n.',26124),
(135183,'enUS','Arcane energy coalesces around the $n.','Arcane energy coalesces around the $n.',26124),
(135186,'enUS','|TInterface\\Icons\\SPELL_SHADOW_CURSEOFTOUNGES.BLP:20|tThe Paraxis starts to |cFFFF0000|Hspell:249934|h[Purge]|h|r itself of all enemies!','|TInterface\\Icons\\SPELL_SHADOW_CURSEOFTOUNGES.BLP:20|tThe Paraxis starts to |cFFFF0000|Hspell:249934|h[Purge]|h|r itself of all enemies!',26124),
(135191,'enUS','','I\'ve sent scouts to gauge the extent of the Legion\'s incursion into Mac\'Aree, but they have not returned. Please find them and give aid... if they yet live.',26124),
(135192,'enUS','','The scouts are safe now, thanks to your help.',26124),
(135193,'enUS','','Your timing is fortuitous, champions. Members of the Shadowguard are nearby, infusing the natives with void energy. To what end, I do not know.',26124),
(135194,'enUS','','Figure out their motives... and put a stop to their efforts.',26124),
(135195,'enUS','','Such chaos... such anguish. I have never sensed anything like it before.',26124),
(135196,'enUS','It is rare that a naaru falls into Void this way. The few cases I know of have occurred when mortals were involved. What fascinating implications...','',26124),
(135197,'enUS','Such musings can wait, though. This entity must die.','',26124),
(135198,'enUS','','How did a being of the Light become a creature of Shadow?',26124),
(135199,'enUS','The Void is a force of change... of transformation. Shadows are fluid, ever shifting.','',26124),
(135200,'enUS','','I feel the fallen naaru\'s power. It... beckons me.',26124),
(135201,'enUS','You stand on the cusp of destiny, Alleria. There will be choices to make... and consequences to face.','',26124),
(135202,'enUS','','Even defeated, the darkened naaru surges with power. I hear the shadows calling to me.',26124),
(135203,'enUS','Claim its essence, Alleria Windrunner. Make its chaos your own.','',26124),
(135204,'enUS','You survived... interesting! How do you feel?','',26124),
(135205,'enUS','','The voices are louder now. More insistent. But they do not control me.',26124),
(135206,'enUS','You asked me to teach you to use the Void as a weapon. Now that weapon is you.','',26124),
(135207,'enUS','','It seems my training is complete.',26124),
(135208,'enUS','Let\'s not get ahead of ourselves. We need to test the limits of this newfound power. Come.','',26124),
(135210,'enUS','Everyone, the time has come to take the central spire. Prepare for battle!','',26124),
(135211,'enUS','Rendezvous in the central courtyard once he has fallen. Good luck.','',26124),
(135212,'enUS','We will advance on the citadel on the ground while you clear the way ahead.','',26124),
(135213,'enUS','Expect heavy resistance. Nath\'raxas will not go down without a fight.','',26124),
(135214,'enUS','Incoming Legion ships! Take cover!','Incoming Legion ships! Take cover!',26124),
(135215,'enUS','Your anguished cries will be a testament to all who dare assault the Legion.','Your anguished cries will be a testament to all who dare assault the Legion.',26124),
(135216,'enUS','The enemy has breached the spire gates. To arms!','The enemy has breached the spire gates. To arms!',26124),
(135217,'enUS','Press the defense. This incursion ends here!','Press the defense. This incursion ends here!',26124),
(135218,'enUS','','Are you ready to strike?',26124),
(135219,'enUS','We are ready.','We are ready.',26124),
(135222,'enUS','In spite of everything, we must exercise caution. Ensure safe passage down to the surface, and we can continue the assault.','',26124),
(135223,'enUS','The Legion has assembled a sizable force by those siege cannons. Illidan should already be there, weakening their positions.','',26124),
(135227,'enUS','Lord Nath\'raxas lies in the spire ahead. Take him down!','',26124),
(135228,'enUS','Lend what assistance you can. Alleria is leading the forces there and will be able to direct your efforts.','',26124),
(135229,'enUS','Nothing you have done here matters, mortal. We are infinite. We are Legion.','Nothing you have done here matters, mortal. We are infinite. We are Legion.',26124),
(135230,'enUS','We must take out those guns if we are to assault the citadel. Your mission is critical, champion.','',26124),
(135231,'enUS','This is it, champion. Now we assault the heart of the Legion itself.','',26124),
(135232,'enUS','The Legion has invaded your world. Now look upon theirs.','',26124),
(135233,'enUS','By the Light... what have they done to my world?','',26124),
(135234,'enUS','These explosives have been modified to amplify fel energies. The results should be quite... dramatic.','',26124),
(135235,'enUS','The beating heart of the Legion... soon I shall tear it out.','',26124),
(135236,'enUS','He thinks I require help? Against the Legion? Very well... try to keep up.','',26124),
(135237,'enUS','Continue the mission while I distract their forces. Perhaps they shall help me prepare for the real challenge...','',26124),
(135238,'enUS','The tiniest crack in the armor, allowing a blade to slip in...','',26124),
(135239,'enUS','At long last, we have turned the tables on the Legion. Let them cower before our invasion!','',26124),
(135240,'enUS','Come, we must brave the darkness.','',26124),
(135241,'enUS','','Hold, Prophet. I have scouted the area. The shadows grip Mac\'Aree more tightly than you know.',26124),
(135242,'enUS','Your hubris overcomes you.','Your hubris overcomes you.',26124),
(135243,'enUS','It is far worse than I feared. Do we have the strength to face such a foe?','',26124),
(135244,'enUS','','There may be another way. I will require a second set of hands, however.',26124),
(135246,'enUS','Prepare to be deconstructed.','',26124),
(135247,'enUS','Time to work.','',26124),
(135248,'enUS','This was not in the instructions...','',26124),
(135249,'enUS','I\'m a broken... toy...','',26124),
(135250,'enUS','I\'ll use your bones for spare parts.','',26124),
(135251,'enUS','','I am certain it had help. Take a look around. Call for me if you find anything of interest.',26124),
(135252,'enUS','','It is as I thought. The Void\'s corruption has reached them here.',26124),
(135253,'enUS','This weapon\'s test was a resounding success.','',26124),
(135254,'enUS','The day is ours! We await you outside, $p.','',26124),
(135255,'enUS','This hold is but an echo of the grandeur of Antorus.','This hold is but an echo of the grandeur of Antorus.',26124),
(135256,'enUS','I eagerly await your agonized screams resonating through its halls.','I eagerly await your agonized screams resonating through its halls.',26124),
(135257,'enUS','You ally yourselves with the traitorous draenei and their Light, yet it leaves you so weak.','You ally yourselves with the traitorous draenei and their Light, yet it leaves you so weak.',26124),
(135258,'enUS','It matters not. I will end this.','It matters not. I will end this.',26124),
(135259,'enUS','With my death, he will come...','With my death, he will come...',26124),
(135262,'enUS','The Paraxis warps in.','The Paraxis warps in.',26124),
(135266,'enUS','Suppression systems engaged.','',26124),
(135267,'enUS','Targets aquired.','',26124),
(135268,'enUS','Power core... rupturing...','',26124),
(135269,'enUS','Termination imminent...','',26124),
(135270,'enUS','Enemy combatants neutralized.','',26124),
(135271,'enUS','No hostile targets remaining. Continuing patrol.','',26124),
(135273,'enUS','Exterminated.','',26124),
(135274,'enUS','Threat terminated.','',26124),
(135275,'enUS','Hostile destroyed.','',26124),
(135276,'enUS','Fall before my blade!','',26124),
(135277,'enUS','For Sargeras!','',26124),
(135278,'enUS','Return to dust.','',26124),
(135279,'enUS','Sargeras will be pleased.','',26124),
(135280,'enUS','All worlds shall fall.','',26124),
(135282,'enUS','','The troops are insisting that I spend some time tending to their wounds. You will have to slay the enemy in my stead.',26124),
(135283,'enUS','','Excellent work. Our soldiers are refreshed, I have done my job, and the enemies are weakened! Everyone benefits.',26124),
(135284,'enUS','','The bats are swarming the battlefield once more. Man one of our batteries and blast them out of the sky!',26124),
(135285,'enUS','','Most of our air support was lost when the Xenedar crashed. Those bats would have caused real trouble for our troops on the ground.',26124),
(135287,'enUS','','You dare set foot in the sacred pools? Suffer!',26124),
(135288,'enUS','Ah, home... I almost missed it.','',26124),
(135289,'enUS','','Do you not see? Without the fel, the shadow will prevail!',26124),
(135290,'enUS','Turn the cannon on Kil\'jaeden\'s ship!','',26124),
(135291,'enUS','','Our crusade is the only path to redemption. All will be reborn by the master\'s flame!',26124),
(135292,'enUS','','You lack... vision.',26124),
(135293,'enUS','','We must all embrace the inevitable abyss.',26124),
(135294,'enUS','','You will not disrupt the rebirth. They will be whole again!',26124),
(135295,'enUS','','All will be remade. All will be undone!',26124),
(135296,'enUS','','You are too late.',26124),
(135297,'enUS','','Logistics and supplies are often forgotten in the heat of battle, but are critical to maintaining our presence here. Collect what you can from the field to strengthen our defenses.',26124),
(135298,'enUS','','Thank you. These crystals can be adapted to power our defenses. They are a valuable resource.',26124),
(135299,'enUS','Eredar summoners are trying to establish new structures down in the Shattered Fields. Disrupt their plans and help our soldiers!','',26124),
(135300,'enUS','Good! That should keep the enemy from sending in more reinforcements.','',26124),
(135302,'enUS','This city was once the greatest of Argus. Look how it has fallen! The once-mighty houses are now mere pawns of the Legion. Soon, they will serve us as well.','',26124),
(135303,'enUS','Break this thing, bend it to our will. If this is beyond you, destroy it.','',26124),
(135304,'enUS','This one has the necessary ambition, but lacks talent.','',26124),
(135305,'enUS','How pathetic this creature is. Watch and learn why your will must always be stronger than the powers you control.','',26124),
(135306,'enUS','She meddles with power she does not understand. One slip and she will lose herself to it.','',26124),
(135307,'enUS','This one has long been a thorn in the Legion\'s side. I never imagined we would become allies.','',26124),
(135308,'enUS','Gaze upon the weapons of the Legion. Soon, they shall be used at my... our... beck and call!','',26124),
(135309,'enUS','The essence of chaos is infused within these weapons. Soon, they shall be lifted in praise to us!','',26124),
(135310,'enUS','He had so much potential. A pity he refused to submit to his betters.','',26124),
(135311,'enUS','The sisters have the right idea, but they lack the power to see their will enforced.','',26124),
(135312,'enUS','The power of this one... it is incredible! Perhaps we can bind it to us instead?','',26124),
(135313,'enUS','Witness the fate of the great makers. Oblivion shall be their destiny.','',26124),
(135314,'enUS','The Diseased energy dissipates, leaving $W13953 more |4zone:zones; to deactivate.','The Diseased energy dissipates, leaving $W13953 more |4zone:zones; to deactivate.',26124),
(135315,'enUS','The Fiery energy dissipates, leaving $W13953 more |4zone:zones; to deactivate.','The Fiery energy dissipates, leaving $W13953 more |4zone:zones; to deactivate.',26124),
(135316,'enUS','The Fel energy dissipates, leaving $W13953 more |4zone:zones; to deactivate.','The Fel energy dissipates, leaving $W13953 more |4zone:zones; to deactivate.',26124),
(135317,'enUS','The Arcane energy dissipates, leaving $W13953 more |4zone:zones; to deactivate.','The Arcane energy dissipates, leaving $W13953 more |4zone:zones; to deactivate.',26124),
(135318,'enUS','Weapons, built to destroy forces beyond reckoning. A pity that such power was not funneled into more productive pursuits.','',26124),
(135319,'enUS','The master of these machines conceals their true strength. Be on your guard.','',26124),
(135320,'enUS','The Legion drains the blood of a colossal creature that slumbers beneath the surface. They must be stopped!','',26124),
(135321,'enUS','Stop them! The magic of the titans must not fall into the Legion\'s hands!','',26124),
(135322,'enUS','I never thought I\'d have to slay a titan. This grieves me, but we do what must be done.','',26124),
(135323,'enUS','Without these machines, the Legion will be unable to drain this creature. Now it\'s their turn to bleed.','',26124),
(135324,'enUS','There is power here... power beyond comprehension!','',26124),
(135325,'enUS','You\'ve gotten the attention of the Legion\'s commander. Defeat them, and the remaining demons will flee.','',26124),
(135326,'enUS','So what Magni saw was true. Aggramar lives once more... in the service of Sargeras.','',26124),
(135327,'enUS','Well done, heroes. You\'ve driven the Legion from this world.','',26124),
(135329,'enUS','','The power at their command is immeasurable. The Vindicaar cannot withstand their assault.',26124),
(135389,'enUS','I am told power comes from unlikely places.','',26124),
(135390,'enUS','The Legion\'s thirst for blood is unquenchable. Remove their filth from this world.','',26124),
(135391,'enUS','These demons seek to bleed a creature that lies dormant beneath the surface. Put an end to their plans.','',26124),
(135392,'enUS','Your efforts thus far are... lacking.','',26124),
(135393,'enUS','Continue like this and you may well scrape by.','',26124),
(135394,'enUS','Your arrogance will be your undoing.','',26124),
(135395,'enUS','I am unimpressed.','',26124),
(135396,'enUS','','Bear in mind that your performance reflects upon all of us.',26124),
(135397,'enUS','','You could stand to do better.',26124),
(135398,'enUS','Ah, yes. It has been too long since I have humbled a pupil. Come. Face me.','',26124),
(135401,'enUS','Krona ki cristorr!','Krona ki cristorr!',26124),
(135402,'enUS','I serve the Light.','I serve the Light.',26124),
(135403,'enUS','Greetings, traveler.','Greetings, traveler.',26124),
(135404,'enUS','I will return to the Vindicaar. There I will determine the location of the Crest of Knowledge. Be safe, my friend.','',26124),
(135406,'enUS','In darkest night, we still shine with hope.','In darkest night, we still shine with hope.',26124),
(135407,'enUS','Pheta voros.','Pheta voros.',26124),
(135408,'enUS','Our cause is just. Our purpose, noble.','Our cause is just. Our purpose, noble.',26124),
(135409,'enUS','Light be with you.','Light be with you.',26124),
(135410,'enUS','Have faith in the Light.','Have faith in the Light.',26124),
(135411,'enUS','Acore palemos corta.','Acore palemos corta.',26124),
(135412,'enUS','Fight well, traveler.','Fight well, traveler.',26124),
(135413,'enUS','We shall see the Legion\'s end.','We shall see the Legion\'s end.',26124),
(135414,'enUS','Dioniss aca.','Dioniss aca.',26124),
(135415,'enUS','','Dioniss aca.',26124),
(135416,'enUS','','We shall see the Legion\'s end.',26124),
(135417,'enUS','','Fight well, traveler.',26124),
(135418,'enUS','','Acore palemos corta.',26124),
(135419,'enUS','','Have faith in the Light.',26124),
(135420,'enUS','','Light be with you.',26124),
(135421,'enUS','','Our cause is just. Our purpose, noble.',26124),
(135422,'enUS','Please, you have to reach our captain! She\'s across the way to the west, defending our last remaining artillery batteries!','Please, you have to reach our captain! She\'s across the way to the west, defending our last remaining artillery batteries!',26124),
(135423,'enUS','','In darkest night, we still shine with hope.',26124),
(135424,'enUS','','Greetings, traveler.',26124),
(135425,'enUS','','I serve the Light.',26124),
(135426,'enUS','','Krona ki cristorr!',26124),
(135427,'enUS','The titan soul of Argus is the key to breaking the Legion. Our defenses must hold long enough to destroy it... or Sargeras wins.','',26124),
(135428,'enUS','Perhaps this world\'s past can aid us. I will scour my memory for what may yet remain.','',26124),
(135433,'enUS','The Legion must learn that no matter the realm, we will always defeat them.','',26124),
(135434,'enUS','Another victory, heroes. These demons are running out of places to hide.','',26124),
(135435,'enUS','Well done, champions. News of this victory will spread throughout the Dark Beyond.','',26124),
(135436,'enUS','With every victory we weaken the Legion\'s grip on these worlds.','',26124),
(135437,'enUS','You\'ve crushed their ranks. These demons surely realize they are not the greatest power in the cosmos.','',26124),
(135438,'enUS','Well fought, champions. No matter where their filth spreads, we will be there to stop them.','',26124),
(135447,'enUS','You\'ve driven them back! Now press the attack!','',26124),
(135449,'enUS','The Legion is reeling from your onslaught. Cut them down!','',26124),
(135450,'enUS','Now is your chance. Finish this fight!','',26124),
(135451,'enUS','These fools should\'ve run when they had the chance. Leave none standing.','',26124),
(135452,'enUS','These demons are stripping the forests of their resources. This cannot be allowed to continue.','',26124),
(135453,'enUS','The Legion has laid claim to these forests. Drive them out.','',26124),
(135454,'enUS','The Legion seeks to control this forest. Crush them.','',26124),
(135458,'enUS','These frozen wastes conceal hidden power. Wrest it from the Legion\'s control.','',26124),
(135459,'enUS','This frozen world holds dangerous power. Ensure the Legion cannot claim it.','',26124),
(135460,'enUS','This frozen world  has claimed the bones of many who came here seeking power. Ensure these demons are added to the collection.','',26124),
(135461,'enUS','The Legion seeks to control this island. Put an end to their efforts.','',26124),
(135462,'enUS','The Legion wants to claim these islands. Drive them out.','',26124),
(135463,'enUS','The Legion believes these islands are under their control. Teach this filth there is nothing we cannot take from them.','',26124),
(135467,'enUS','These burning sands conceal wells of power. Ensure the Legion cannot claim them.','',26124),
(135468,'enUS','These sands conceal a font of limitless power. Wrest it from the Legion\'s control.','',26124),
(135470,'enUS','These sands have claimed the bones of many who came here seeking power. Ensure these demons are added to the collection.','',26124),
(135473,'enUS','Fareeya. Status report.','',26124),
(135474,'enUS','','Baraat sent up a signal flare a short time ago. He is alive, at least. I have heard nothing from the others.',26124),
(135475,'enUS','Then let us waste no time.','',26124),
(135476,'enUS','','Bring back my men, Turalyon.',26124),
(135477,'enUS','The Light rejects you, demon!','',26124),
(135478,'enUS','This day will be your last!','',26124),
(135479,'enUS','You cannot stand against the Light!','',26124),
(135480,'enUS','I am the Light\'s blade!','',26124),
(135481,'enUS','The Light strikes you down!','',26124),
(135482,'enUS','Fall before me!','',26124),
(135483,'enUS','You will not bar my way.','',26124),
(135484,'enUS','Taste my blade, demon filth!','',26124),
(135485,'enUS','The Light prevails.','',26124),
(135487,'enUS','One less foe to contend with.','',26124),
(135488,'enUS','On to the next.','',26124),
(135489,'enUS','They have not yet had a chance to fortify this area.','',26124),
(135490,'enUS','It seems they haven\'t located Velen... and not for lack of trying.','',26124),
(135491,'enUS','There\'s Baraat.','',26124),
(135493,'enUS','I sense an ally nearby.','',26124),
(135494,'enUS','Telaamon must be nearby. Just follow the trail of corpses.','',26124),
(135495,'enUS','This is it.','',26124),
(135497,'enUS','I have seen these tactics before. Let us hope our foe is not who I think it is.','',26124),
(135498,'enUS','The Legion seeks to claim the power of this burning world. They must not succeed.','',26124),
(135499,'enUS','If the Legion harnesses the power of this realm, they will be unstoppable. Drive them out.','',26124),
(135500,'enUS','The power lying dormant on this world could bolster the Legion\'s strength. Reduce these demons to ash before they can claim it.','',26124),
(135501,'enUS','The Legion believes they control this world. Prove to them that they do not.','',26124),
(135502,'enUS','This world holds a power that the Legion must not possess. Prevent them from claiming it.','',26124),
(135503,'enUS','The Legion seeks to claim this world for their own. Break their grip.','',26124),
(135504,'enUS','Talgath. We need not come to blows. I offer you one chance: Stand down.','',26124),
(135505,'enUS','Still the pacifist, I see. Face me!','',26124),
(135506,'enUS','Impossible. She is a naaru! A being of the Light!','',26124),
(135507,'enUS','There is much Xe\'ra did not want you to know.','',26124),
(135508,'enUS','If the Crest of Knowledge truly rests within the temple... we stand against the Void itself.','',26124),
(135509,'enUS','Light help us.','',26124),
(135510,'enUS','It\'s fainter than the breath o\' the wind, but it feels so familiar ta me. It\'s like Azeroth\'s call, only... it ain\'t her.','',26124),
(135512,'enUS','','Look out!',26124),
(135513,'enUS','','Over here!',26124),
(135514,'enUS','','No!',26124),
(135515,'enUS','By the Light... No!','',26124),
(135516,'enUS','Over here!','',26124),
(135517,'enUS','Look out!','',26124),
(135518,'enUS','By the Light... No!','',26124),
(135519,'enUS','Over here!','',26124),
(135520,'enUS','Look out!','',26124),
(135521,'enUS','','This way!',26124),
(135522,'enUS','This way!','',26124),
(135523,'enUS','This way!','',26124),
(135524,'enUS','','Incoming!',26124),
(135525,'enUS','Incoming!','',26124),
(135526,'enUS','Stand ready!','',26124),
(135527,'enUS','I hear you. Speak.','',26124),
(135528,'enUS','We fight. We survive.','',26124),
(135529,'enUS','The Darkfallen will not give up.','',26124),
(135530,'enUS','Argus will always be ours.','',26124),
(135531,'enUS','Beware the Legion\'s wrath.','',26124),
(135532,'enUS','Walk in the shadows of the earth.','',26124),
(135533,'enUS','We will never give up.','',26124),
(135534,'enUS','Our time has come.','',26124),
(135535,'enUS','Yes, outsider?','',26124),
(135536,'enUS','What is it?','',26124),
(135537,'enUS','I greet you.','',26124),
(135538,'enUS','We will not fall.','',26124),
(135540,'enUS','Take caution.','',26124),
(135541,'enUS','Farewell.','',26124),
(135542,'enUS','The Legion will pay.','',26124),
(135543,'enUS','We will endure.','',26124),
(135544,'enUS','Legion forces swarm this area. Drive them out and strike a blow for the Light!','',26124),
(135545,'enUS','We need to force the demons back before we\'re overrun. To arms!','',26124),
(135546,'enUS','The Legion considers this location unassailable. I say we prove them wrong!','',26124),
(135547,'enUS','Supplies from the Xenedar have fallen into Legion hands. Take back what is ours, champion!','',26124),
(135548,'enUS','The Army of the Light has need of you, hero. I know we can rely on you to get the job done.','',26124),
(135549,'enUS','Some of our troops have been captured by Legion forces. The demons will torture them... or worse. You must lead a rescue!','',26124),
(135550,'enUS','A crucial target lies ahead. Strike it down in the name of the Light!','',26124),
(135551,'enUS','I sense a great darkness is near. Be on your guard!','',26124),
(135552,'enUS','The demons rally behind one of their champions. Bring it down!','',26124),
(135553,'enUS','Up ahead... a great evil prepares to strike. Stand ready!','',26124),
(135554,'enUS','Argus provides us no shortage of targets. Another is at hand, champion.','',26124),
(135556,'enUS','A demon lurks just ahead. Bring it down in the name of Azeroth!','',26124),
(135557,'enUS','My scouts have spotted a prime target. To arms!','',26124),
(135558,'enUS','The Legion believes this brute can intimidate us. Prove them wrong!','',26124),
(135559,'enUS','When they push us, we push back harder. To victory!','',26124),
(135560,'enUS','Thanks to your help, our forces have rallied and the Legion is on the run.','',26124),
(135561,'enUS','Now the Burning Legion sees the truth... that we will drive them from the heart of Argus!','',26124),
(135562,'enUS','That cargo belongs to the Army of the Light, not the minions of Sargeras. Well done.','',26124),
(135563,'enUS','My faith was well placed. You have aided the Light this day, friend.','',26124),
(135564,'enUS','Thanks to your quick and decisive action, the Army\'s soldiers are safe. You have my gratitude.','',26124),
(135566,'enUS','Well fought. In our long struggle against the demons, we must savor every victory.','',26124),
(135567,'enUS','A well-earned victory. The Legion will fall!','',26124),
(135568,'enUS','Bit by bit we chip away at the backbone of the Legion.','',26124),
(135569,'enUS','You fight like you\'ve been crusading against the Legion for a thousand years.','',26124),
(135570,'enUS','It is good to know that during my long absence from Azeroth, our world was protected by heroes like you.','',26124),
(135571,'enUS','Impressive tactics. No wonder the Legion has learned to fear you.','',26124),
(135572,'enUS','The Army of the Light is proud to call you an ally, champion.','',26124),
(135573,'enUS','Every victory is satisfying, but when a foe like that is brought down... I must admit, I savor it even more.','',26124),
(135575,'enUS','What was once a sacred site for my people has been desecrated by the Legion. Drive them out!','',26124),
(135580,'enUS','The Legion\'s grip on this land must be broken. Now is our time! Push back against the darkness!','',26124),
(135581,'enUS','An insidious champion of darkness draws near. Strike it down!','',26124),
(135582,'enUS','This villain profanes the homeworld I lost so long ago. Put an end to this atrocity!','',26124),
(135583,'enUS','Prepare yourself, champion. Wickedness lurks nearby...','',26124),
(135584,'enUS','An agent of the Dark Titan rises to attack. Strike first! Strike true!','',26124),
(135585,'enUS','Just when the Light gains a foothold here, another vessel of evil rises to battle us. Your might is needed once again, champion.','',26124),
(135587,'enUS','A disciple of Kil\'jaeden seeks to avenge its master. Be ready for its assault!','',26124),
(135588,'enUS','I sense a foul presence... an evil that seeks to blot out the Light. Take up arms and bring down this foe!','',26124),
(135589,'enUS','The air hangs heavy with fel corruption. Bring down this vile aberration!','',26124),
(135590,'enUS','We can never reclaim what we once had, but we will make them pay for what they did to Argus.','',26124),
(135591,'enUS','We may be vastly outnumbered, but the Light is with us. Victory will yet be ours!','',26124),
(135592,'enUS','Never doubt that, in the end, the Light will emerge victorious.','',26124),
(135593,'enUS','In the name of all the noble souls lost here to the Legion, I thank you.','',26124),
(135594,'enUS','With every such foe you bring down, our ultimate victory draws nearer.','',26124),
(135595,'enUS','Sargeras took so much from my world. Now it is his turn to lose!','',26124),
(135596,'enUS','Though the Legion is relentless, the demons cannot outlast the Light.','',26124),
(135597,'enUS','Word of your victory will spread across Argus. Those who cling to the memory of the Deceiver are doomed to fall!','',26124),
(135598,'enUS','The Light cannot win unless we fight for it. You have done your part this day, champion.','',26124),
(135599,'enUS','Every demon that walks this world is a perversion of the Argus that was. You struck a blow for the Light this day.','',26124),
(135600,'enUS','Demon filth pervades this broken land. Take no prisoners. Strike down every fiend you see!','',26124),
(135601,'enUS','Demons everywhere. Go. Fight. Spare none of them.','',26124),
(135602,'enUS','The Legion believes itself entrenched on Argus. Untouchable. Reward their arrogance with suffering!','',26124),
(135603,'enUS','Another champion of the Legion is near. End its existence.','',26124),
(135605,'enUS','A brutish fiend looms just ahead. Send it back to the hell that spawned it.','',26124),
(135606,'enUS','The demons rally around a brutish menace. Teach them that their faith is misplaced.','',26124),
(135607,'enUS','Another demon champion boasts and blusters. Silence its cacophony.','',26124),
(135608,'enUS','Be on your guard. A threat looms, thirsty for mortal blood.','',26124),
(135609,'enUS','This demon looks to rise within the Legion\'s ranks by ending our invasion. Demonstrate its folly.','',26124),
(135611,'enUS','Behold, a vile menace eager to prove its might. Put an end to its ambitions.','',26124),
(135612,'enUS','So many draenei traditions were lost during our long journey. The spirits of Mac\'Aree have not forgotten. They practice the ritual combat of Jed\'hin even now. Perhaps they will welcome a new challenger!','',26124),
(135613,'enUS','It brings me great joy to see the old ways honored like this. Thank you.','',26124),
(135614,'enUS','My people, I have called you here to share a revelation.','',26124),
(135615,'enUS','For so long, we eredar have been alone in the universe.','',26124),
(135616,'enUS','We need not endure this solitude any longer.','',26124),
(135617,'enUS','He has shown us the path to a new future.','',26124),
(135618,'enUS','In partnership with our new ally, the light of the eredar will shine bright across the cosmos!','',26124),
(135619,'enUS','I ask you, now, to raise your voices in praise. Praise Sargeras!','',26124),
(135620,'enUS','The beacon of our civilization shining bright... upon what we feared was an empty void.','',26124),
(135621,'enUS','The Triumvirate has received a visitor from another world!','',26124),
(135622,'enUS','He offers us power unlike any we have known before.','',26124),
(135623,'enUS','A threat closes in. Bring it down, and show the demons they cannot stand against us.','',26124),
(135624,'enUS','I will lead my people through any darkness.','',26124),
(135625,'enUS','Our enemies will suffer as we have.','',26124),
(135626,'enUS','Yes... you have them reeling. Well fought.','',26124),
(135627,'enUS','These foes have earned no mercy... and we have shown them none.','',26124),
(135628,'enUS','Now they know the truth... that we will never relent. Their crusade will soon face oblivion.','',26124),
(135629,'enUS','Each target we bring down is another failure for the Dark Titan\'s crusade.','',26124),
(135630,'enUS','No matter how many monstrosities they send at us, we will cut them down.','',26124),
(135631,'enUS','The Legion\'s morale crumbles... as does their hold on Argus.','',26124),
(135632,'enUS','That one has nothing more to brag about, other than the quick death it earned.','',26124),
(135633,'enUS','A decisive victory. I expected no less of you.','',26124),
(135634,'enUS','You brought a quick end to that fiend\'s ambitions. But do not doubt that others will seek a similar path to infamy.','',26124),
(135635,'enUS','The demon\'s cries of failure ring out across Argus. A sound that never grows tiresome.','',26124),
(135636,'enUS','A convincing victory. You have demonstrated the futility of the Legion\'s existence.','',26124),
(135637,'enUS','The Vindicaar will be the instrument of our retribution. As with any weapon, you should know it well before we charge into battle once more.','',26124),
(135639,'enUS','Argus is a world saturated with power. The Legion has made use of it... now it is our turn!','',26124),
(135640,'enUS','I sense an entity that wields potent forces with great malevolence. This fiend must be brought down!','',26124),
(135641,'enUS','Power is power. It is what we do with it that matters. By using the Legion\'s own resources against them, we turn the tide in our favor.','',26124),
(135642,'enUS','A worthy victory. No minion of the Legion can be allowed to toy with such forces.','',26124),
(135643,'enUS','I have never seen anything like this place, Khadgar. The powers at play here...','',26124),
(135644,'enUS','I know, archmage. It can be... overwhelming at times. Difficult to focus.','',26124),
(135645,'enUS','I confess I am relieved to hear you say that. I feared I was the only one experiencing such sensations.','',26124),
(135646,'enUS','We can still breach Antorus and dismantle the Legion\'s resurrection engine, but we\'ll need Xe\'ra and the Army of the Light by our side.','',26124),
(135647,'enUS','Nonsense. We are in the presence of primal powers that shaped the very cosmos. The fact that you feel the tug of their influence is not a sign of weakness. It shows that you are highly attuned to them.','',26124),
(135648,'enUS','Then I shall relish the experience while I have it. Thank you for your counsel, Khadgar.','',26124),
(135653,'enUS','Evil draws close.','',26124),
(135654,'enUS','There is no sacrifice too great.','',26124),
(135655,'enUS','The Legion will stop at nothing to destroy our world.','',26124),
(135656,'enUS','The hour has come at last.','',26124),
(135657,'enUS','A timely arrival.','',26124),
(135658,'enUS','Do not sit idle.','',26124),
(135659,'enUS','The Legion\'s fury pales before mine.','',26124),
(135660,'enUS','I will finish my hunt.','',26124),
(135661,'enUS','I will see this to the end.','',26124),
(135662,'enUS','See it done.','',26124),
(135663,'enUS','The Legion will meet its end.','',26124),
(135664,'enUS','My hunt is eternal.','',26124),
(135665,'enUS','IGC: Velen escapes Argus','IGC: Velen escapes Argus',26124),
(135666,'enUS','Your persistence is hardly surprising.','',26124),
(135667,'enUS','You are not prepared.','',26124),
(135668,'enUS','I will not be touched by rabble such as you.','',26124),
(135669,'enUS','YOU ARE NOT PRE-- <pause> What\'s that? Am I denying you something? Bah. You know nothing of true longing.','',26124),
(135671,'enUS','The fate of our world hangs in the balance.','',26124),
(135672,'enUS','The Light\'s army endures.','',26124),
(135675,'enUS','My people have so little, yet the demons steal our relics in hopes of cutting us off from our past. Help take back what is ours, outsider.','',26124),
(135676,'enUS','More of my people have been taken by the Legion. They seek to break our bonds of kinship, to turn brother against brother. Please, free them!','',26124),
(135677,'enUS','Though we can never thrive here as we once did, Argus is our home. You have eased our struggle, outsider, at least for today.','',26124),
(135678,'enUS','The Legion will not break our spirits. By recovering these mementos of our past, you have given my people faith that we can endure this. I am grateful.','',26124),
(135681,'enUS','','Sometimes subtlety is more effective than a direct assault. I believe such a strategy is needed here.',26124),
(135682,'enUS','','We have a target in this area that must be brought down. The choice of weapon is up to you.',26124),
(135684,'enUS','','To cripple the Legion\'s offensive, we need to take out their infrastructure. Strike a blow for Azeroth!',26124),
(135685,'enUS','','There is more than one way to deliver a blow to the Legion. Well done!',26124),
(135686,'enUS','','With results like that, I am confident our victory will come.',26124),
(135687,'enUS','','Nicely done. That will have the demons reeling!',26124),
(135688,'enUS','That should be it! Just activate the console one last time to complete the transfer. I will handle the rest!','',26124),
(135689,'enUS','It was merciful to free these creatures from the grip of shadows. It saddens me to see the city like this.','',26124),
(135690,'enUS','The younger animals in the city are particularly susceptible to void energy. Use this crystal to release them from its grasp.','',26124),
(135691,'enUS','','We have devised a plan to strike against the Legion. This is an operation that calls for your special skills, champion.',26124),
(135692,'enUS','','I have hunted demons throughout the Twisting Nether for a thousand years. I think I can leave this one to you.',26124),
(135693,'enUS','A demon dares lead a vanguard on the Vindicaar. Its death will send a powerful message to the enemy.','',26124),
(135695,'enUS','The Legion is relentless in its assault. We must remain ever vigilant.','',26124),
(135696,'enUS','A doommaiden attempts to fashion an army of fiends right under our noses. She must not succeed.','',26124),
(135697,'enUS','Her soul will return to Antorus to be reborn, but not without punishment. Sargeras does not take kindly to failure.','',26124),
(135698,'enUS','A dreadlord that once served me in the Black Temple has cast his lot with the Legion. He will regret opposing me.','',26124),
(135700,'enUS','First Maiev\'s blade, now yours. His punishment in Antorus will be severe.','',26124),
(135702,'enUS','I will meet you at our staging ground near Nath\'raxas. The Vindicaar must be ready to help us secure the hold at a moment\'s notice.','',26124),
(135703,'enUS','Taking this hold will buy us valuable time to prepare for a full assault on Antorus.','',26124),
(135704,'enUS','None deserve the fate that awaits souls claimed by the Legion.','',26124),
(135705,'enUS','Thank you, $n. May their souls finally find peace.','',26124),
(135706,'enUS','High Exarch, our warframe is fully operational. Behold!','',26124),
(135707,'enUS','','This beast of darkness must be put down. No need for mercy, but do be swift.',26124),
(135708,'enUS','','Light and shadow are both means to an end. For the foe before you, feel free to pick whatever weapon you favor.',26124),
(135709,'enUS','','Most effective. Every blow dealt to the Legion is a boon to our cause.',26124),
(135710,'enUS','','Impressive skill. Though I believe my arrows would have brought that demon to an even quicker end.',26124),
(135711,'enUS','','A necessary end for such an enemy. Well done.',26124),
(135712,'enUS','','It seems you have chosen your weapon. As have I.',26124),
(135713,'enUS','We will be upon the courtyard shortly to finish them off. For Azeroth!','',26124),
(135714,'enUS','','The invaders are charging their weapons. Quickly! Use these portals to board their vessel. Stop their attack!',26124),
(135715,'enUS','','Welcome, mortals, to my sanctuary.',26124),
(135716,'enUS','','For countless ages my spirit has lingered here, safe from the Dark Titan\'s grasp. But he has found me at last, and comes to claim my power.',26124),
(135717,'enUS','','I implore you, stand with me. Together we can drive back this onslaught and deprive Sargeras of victory.',26124),
(135718,'enUS','','Time grows short. The enemy closes in. Approach me and stand ready, my children. The final battle is at hand.',26124),
(135720,'enUS','','A powerful demon is close... very close. Make an example of it!',26124),
(135721,'enUS','','The enemy draws near. Stand ready. We fight for the future of our world.',26124),
(135722,'enUS','','Even here on this bleak world, we fight for Azeroth!',26124),
(135723,'enUS','','Well fought. This tide of demons will break upon our blades!',26124),
(135724,'enUS','In my entire lifetime, I never left the borders of Suramar. To see this place is to understand the fate that almost befell my people.','',26124),
(135725,'enUS','','And nearly mine as well. The sin\'dorei also had a leader who struck a bargain with the Legion, poisoning us in the process.',26124),
(135727,'enUS','An unbridled thirst for power is the most terrible corruption of all. How did your people find their path forward?','',26124),
(135728,'enUS','','We banded together to fight for our place on Azeroth. And we realized we needed allies to stand with us.',26124),
(135729,'enUS','And has the Horde served that purpose for you?','',26124),
(135730,'enUS','','It has. Make no mistake, ours has not been an easy road, and we have struggled through dark times. But together we face a world that has often turned its back on us. Together, we find strength.',26124),
(135731,'enUS','A valuable perspective, Lady Liadrin. You have given me much to ponder.','',26124),
(135734,'enUS','It seems our victory on Argus was a hollow one. With his final blow, Sargeras has done much more than bury his blade in the heart of our world.','',26124),
(135735,'enUS','As the life essence of Azeroth bleeds out, the leaders of the Alliance and Horde scramble to claim it as a resource. Blades are drawn, and the tides of war are rising once again.','',26124),
(135736,'enUS','I had hoped that after the war against the Legion, the people of Azeroth would build a new future together. But now the unity we forged has been shattered.','',26124),
(135737,'enUS','But I will not take up arms against heroes on either side. Not after all we\'ve been through.','',26124),
(135738,'enUS','Instead, I will go to Karazhan and confer with my old mentor, Medivh. Perhaps somewhere in his ancient texts lies the knowledge needed to heal this world.','',26124),
(135739,'enUS','I had best be going. Until next we meet... fare well, champion.','',26124),
(135742,'enUS','Champion... I need a word.','',26124),
(135743,'enUS','Such devastation...','',26124),
(135744,'enUS','Once the transmitter is linked to Light\'s Judgment, we can use it to deploy a warframe to your location. I think you know what to do from there.','',26124),
(135745,'enUS','Take caution, for it requires a great deal of power to deploy a warframe. You wouldn\'t want to find yourself in need of one while it is recharging!','',26124),
(135746,'enUS','This mountain belongs to us, mortals. You will soon become vessels for this world\'s true power!','',26124),
(135747,'enUS','These heroes do not stand alone.','',26124),
(135748,'enUS','Together, we will banish your darkness!','',26124),
(135749,'enUS','Fascinating! The ancient trees here have pockets of fossilized resin with unusual properties. Say... you wouldn\'t mind securing some samples for me, would you, my friend?','',26124),
(135750,'enUS','I have many experiments in mind for these fossils. Acquiring them was no small feat. Thank you.','',26124),
(135751,'enUS','You will serve us, dragon, just as Neltharion did! Your kind always bends to the whispers.','',26124),
(135752,'enUS','Let them feel your fury!','',26124),
(135753,'enUS','Warframe deployed!','',26124),
(135754,'enUS','For Azeroth!','',26124),
(135755,'enUS','The Light embraces you! Revel in its power!','',26124),
(135756,'enUS','I did not realize that I had invited a dragon to feast with us at Thunder Bluff. Had I known, I might have set a bigger table!','',26124),
(135757,'enUS','Once it is complete, this crucible will be able focus the fundamental forces of the cosmos into your weapon! Just... not yet.','',26124),
(135758,'enUS','Only Mayla and our champion knew my secret before. Now I entrust it to you as well, chieftain.','',26124),
(135759,'enUS','I see no reason for anyone else to know, spiritwalker. Let it be a matter kept... between friends.','',26124),
(135760,'enUS','The Light does not die with the Prime Naaru. It shines within each of us!','',26124),
(135761,'enUS','We still have our purpose. We still have a world to save. We must press on!','',26124),
(135762,'enUS','We must continue our mission. The Legion must be destroyed.','',26124),
(135763,'enUS','It is nearly complete, but it lacks a power source. We need something quite potent indeed.','',26124),
(135764,'enUS','The Light still shines within me. Within you all. We will triumph!','',26124),
(135765,'enUS','Not to worry, there is still great power on Argus\' shattered surface. We just need to find it!','',26124),
(135766,'enUS','You are right, Prophet. The mission still stands.','',26124),
(135767,'enUS','Though her form has shattered, her Light has not left us. Not yet.','',26124),
(135773,'enUS','No more! The matter is done. Our mission remains, with or without the Light Mother.','',26124),
(135775,'enUS','Her Light can not be allowed to fall into darkness. We must safeguard what we can within the crucible.','',26124),
(135778,'enUS','The Light burns brightly within the crucible, but it is still not functional!','',26124),
(135779,'enUS','I wonder if... no, it could not be...','',26124),
(135780,'enUS','The Light and Shadow depend upon one another. If we hone the power of a great being of shadow, the crucible may be complete!','',26124),
(135781,'enUS','Her long years of service to the Light will not be in vain!','',26124),
(135782,'enUS','We cannot let this loss stop us. Light\'s Judgment is the key to our victory.','',26124),
(135783,'enUS','We will travel to the heart of Argus and deliver the final blow to the Legion!','',26124),
(135784,'enUS','With the crucible fully functional, our weapons will shine like the stars themselves! Come, I will show you.','',26124),
(135785,'enUS','That should do it! I am adding the coordinates to our beacon matrix.','',26124),
(135786,'enUS','Once you destroy the generators, we should be able to target their defenses with the Vindicaar. We are almost there!','',26124),
(135787,'enUS','Weaken their forces! We will aim the Vindicaar\'s weapon for the final strike!','',26124),
(135788,'enUS','This is the Legion\'s heart, and is fortified as such. An assault now would be madness. We will need additional preparation to tip the balance.','',26124),
(135789,'enUS','It is ready. Quickly, fire the main cannon!','',26124),
(135790,'enUS','We are operational. Prepare to fire!','',26124),
(135791,'enUS','Now, fire the gun! For Argus! For our people!','',26124),
(135792,'enUS','Ah, yes, it is working even better than I thought! Most excellent.','',26124),
(135793,'enUS','The Legion\'s forces are unprepared for your arrival! Put an end to them!','',26124),
(135794,'enUS','We will purge the Legion from every world they defile. This is only the beginning!','',26124),
(135796,'enUS','','Good of you to show up. There are more targets here than even I can shoot.',26124),
(135797,'enUS','So be it. The Legion\'s armies are scattered across their conquered worlds. We must ensure they do not come to Argus\'s defense before our work is done.','',26124),
(135798,'enUS','Make no mistake, each world is infested with countless armies of demons. We have much to do.','',26124),
(135799,'enUS','Eredar sorcerers twist the fel blood of this world into weapons to use against us. They must be dismantled.','',26124),
(135800,'enUS','We will see the Legion\'s end, even if we must tear Argus itself asunder.','',26124),
(135801,'enUS','Legion portals have opened near Nath\'raxas Spire to reclaim it. Use one of our warframes to see that their effort fails.','',26124),
(135802,'enUS','Such power! These fiends must learn that we will not be defeated so easily.','',26124),
(135803,'enUS','A group of Lightforged are trapped behind enemy lines. We must save them.','',26124),
(135804,'enUS','I commend your heroism. Every soldier on the field of battle counts.','',26124),
(135805,'enUS','Come, I will show you to the Vault of Lights. The others await our arrival.','',26124),
(135806,'enUS','','I\'ve never seen the draenei assemble a force of this magnitude.',26124),
(135807,'enUS','Argus is our ancestral home. We will not see it in the Legion\'s hands any longer.','',26124),
(135808,'enUS','Then my parents can finally return home.','',26124),
(135809,'enUS','You will be crushed beneath me!','',26124),
(135810,'enUS','Our crusade is eternal!','',26124),
(135811,'enUS','Your world is forfeit!','',26124),
(135812,'enUS','Behold the might of the Burning Legion!','',26124),
(135813,'enUS','The apocalypse is upon you!','',26124),
(135814,'enUS','You can never defeat us!','',26124),
(135815,'enUS','Antorus calls to me.','',26124),
(135816,'enUS','I have... failed...','',26124),
(135817,'enUS','The crusade... must...','',26124),
(135818,'enUS','You are too late.','',26124),
(135819,'enUS','We have already won.','',26124),
(135820,'enUS','Impossible...','',26124),
(135821,'enUS','','I sense a surge of void energy in this area. Find the source and destroy it.',26124),
(135822,'enUS','','An entity from the Void has emerged into our world. It must not be allowed to spread its corruption.',26124),
(135823,'enUS','Fellow draenei... champions of Azeroth... the time has come to invade Argus.','',26124),
(135824,'enUS','We will save our world and put a stop to the Burning Legion... once and for all.','',26124),
(135825,'enUS','','Something foul is stalking these grounds, heroes. Hunt it down and destroy it.',26124),
(135826,'enUS','','The void energy here is spreading out of control. Stem this dark tide before we are overrun.',26124),
(135827,'enUS','','Dark portals are tearing open reality, allowing shadow energy to pour into our realm. Put a stop to this, heroes!',26124),
(135828,'enUS','','Well done, heroes.',26124),
(135830,'enUS','','The beast has been defeated. Well done, champions.',26124),
(135831,'enUS','','A fine hunt, heroes.',26124),
(135833,'enUS','','You have quelled the void presence in this area. Well done.',26124),
(135834,'enUS','','The forces of the Void are always looking to claim footholds in our world. Your resistance is crucial for preserving balance.',26124),
(135835,'enUS','Lend me your strength, $p. We will open the way together.','',26124),
(135838,'enUS','The Exodar has long been crippled by the crash that brought us to this world many years ago.','',26124),
(135839,'enUS','Every spare moment, every resource, has gone toward the birth of a new vessel. Our instrument of retribution.','',26124),
(135840,'enUS','The way is open. Come, children of Argus, allies, champions. The Vindicaar awaits!','',26124),
(135841,'enUS','But... couldn\'t you have returned out to us? To your people? To me?','',26124),
(135844,'enUS','You will pay with your life!','',26124),
(135845,'enUS','My brethren in the Army of the Light await our arrival. Only together will we achieve victory.','',26124),
(135846,'enUS','For the master!','',26124),
(135847,'enUS','Your kind will fall.','',26124),
(135848,'enUS','Kneel or meet your end.','',26124),
(135849,'enUS','Your end draws near.','',26124),
(135850,'enUS','For the Legion!','',26124),
(135851,'enUS','Krypta!','',26124),
(135852,'enUS','Acalah pek ecta!','',26124),
(135853,'enUS','Forgive me...','',26124),
(135854,'enUS','I am released...','',26124),
(135855,'enUS','Death awaits.','',26124),
(135856,'enUS','The Light fades.','',26124),
(135857,'enUS','Master... I have failed you.','',26124),
(135858,'enUS','My service... ends...','',26124),
(135859,'enUS','Your ruined world... will adorn... our skies...','',26124),
(135860,'enUS','Golad niton acalah.','',26124),
(135862,'enUS','The Light will guide us to them. Romuul, begin final preparations and ensure our forces are accounted for. It is time.','',26124),
(135863,'enUS','Yes, Prophet. Right away.','',26124),
(135864,'enUS','Aggramar! The fallen titan now serves Sargeras! This is bad... VERY bad!','',26124),
(135867,'enUS','','Is there something I can help you with, $c?',26124),
(135870,'enUS','Let me know when you are ready to depart.','',26124),
(135871,'enUS','We must destroy the weapon while it is still recharging! Romuul, deploy a bunker below!','',26124),
(135872,'enUS','Bunker deployed, Prophet!','',26124),
(135873,'enUS','Romuul, send our vanguard to establish a front.','',26124),
(135876,'enUS','$p, we will descend together once you are prepared.','',26124),
(135877,'enUS','The Vindicaar cannot fire upon the devastators until the barriers are disabled. Hurry!','',26124),
(135878,'enUS','These are some of the eredar\'s greatest warriors. Do not underestimate them.','',26124),
(135879,'enUS','Take caution that you do not engage the conquerors alone. I can sense their power from here.','',26124),
(135880,'enUS','The Legion\'s bodies overflow with fel energy. The Legion has not been idle here during their crusade.','',26124),
(135881,'enUS','Help...Help... me...','',26124),
(135882,'enUS','','The darkened naaru pulses with Void energy.',26124),
(135883,'enUS','','It has become a beacon...',26124),
(135884,'enUS','You have my thanks, outsider. May our paths cross again.','',26124),
(135885,'enUS','','...calling those who would use this power for their own ends.',26124),
(135886,'enUS','Our souls fuel their magic. Even death has no solace.','',26124),
(135887,'enUS','There is no fighting them. With each death they return!','',26124),
(135888,'enUS','They will not find us all. Not in the shadows.','',26124),
(135889,'enUS','I can assist you, $c, with any repairs your equipment may need.','',26124),
(135890,'enUS','Those who disobey are sent to the forest. None return.','',26124),
(135891,'enUS','The Light cannot be found here. Only death.','',26124),
(135892,'enUS','Must resist. Must fight. Must survive.','',26124),
(135893,'enUS','The earth writhes in agony. All life fuel for the fel.','',26124),
(135894,'enUS','Do not go near. You too will perish.','',26124),
(135895,'enUS','Is it... over?','',26124),
(135896,'enUS','Free... free...','',26124),
(135897,'enUS','End it all!','',26124),
(135899,'enUS','You cannot stop him! Cannot stop me!','',26124),
(135902,'enUS','Thank the Light! We are not too late.','',26124),
(135905,'enUS','Let us destroy this foul machine while we still have the chance.','',26124),
(135906,'enUS','|TInterface\\Icons\\SPELL_FIRE_FELFLAMESTRIKE.BLP:20|tThe Paraxis charges up its |cFFFF0000|Hspell:248861|h[Spear of Doom]|h|r!','|TInterface\\Icons\\SPELL_FIRE_FELFLAMESTRIKE.BLP:20|tThe Paraxis charges up its |cFFFF0000|Hspell:248861|h[Spear of Doom]|h|r!',26124),
(135907,'enUS','|TInterface\\Icons\\SPELL_FEL_INCINERATE.BLP:20|tThe Paraxis fires orbs of Fel energy to|cFFFF0000|Hspell:248925|h [Annihilate]|h|r you!','|TInterface\\Icons\\SPELL_FEL_INCINERATE.BLP:20|tThe Paraxis fires orbs of Fel energy to|cFFFF0000|Hspell:248925|h [Annihilate]|h|r you!',26124),
(135908,'enUS','|TInterface\\Icons\\SPELL_FIRE_FELFLAMEBOLT.BLP:20|tThe Paraxis|cFFFF0000|Hspell:248326|h [Rains Fel]|h|r down on you!','|TInterface\\Icons\\SPELL_FIRE_FELFLAMEBOLT.BLP:20|tThe Paraxis|cFFFF0000|Hspell:248326|h [Rains Fel]|h|r down on you!',26124),
(135909,'enUS','There are no guards this close to their weapon?','',26124),
(135910,'enUS','Something is wrong.','',26124),
(135911,'enUS','This is no mere siege weapon...','',26124),
(135913,'enUS','','Leaders of the Horde, I summoned you here--along with one of our greatest champions--because our enemies are gathering their strength.',26124),
(135914,'enUS','','War is coming. We need fresh blood added to the ranks of the Horde. What say you?',26124),
(135915,'enUS','Warchief, the tauren of Highmountain fought boldly alongside us in our campaign against the Burning Legion, just as our ancestors did long ago.','',26124),
(135916,'enUS','I have invited their leaders to a great feast in Mulgore. This could be a chance to bring them to our side.','',26124),
(135917,'enUS','','A simple people, but strong. They would be a boon on the battlefield.',26124),
(135918,'enUS','','I too have a suggestion, Warchief. The sin\'dorei have maintained diplomatic ties with the nightborne since we helped liberate Suramar from the Legion.',26124),
(135919,'enUS','','The regent lord and I agree that our kingdoms have much in common. We believe the nightborne would make valuable allies.',26124),
(135920,'enUS','','Even without the Nightwell, Suramar holds vast arcane resources. A most useful arrow added to my quiver.',26124),
(135921,'enUS','','Each option would have its uses. I believe $n knows both these peoples. Which potential ally do you suggest we pursue first?',26124),
(135922,'enUS','','Chieftain Bloodhoof, have our champion join you for your feast in Thunder Bluff. By the time dessert is served, I want their oath of loyalty to the Horde.',26124),
(135923,'enUS','It shall be so, Warchief.','',26124),
(135924,'enUS','','The Alliance is scouring the far corners of Azeroth in search of every advantage against us. We must do the same.',26124),
(135925,'enUS','Somethin\' ain\'t right with this place. A presence calls ta me from somewhere deep inside the earth.','',26124),
(135926,'enUS','We must stand together. For Azeroth!','',26124),
(135930,'enUS','Legion summoners are calling forth a massive infernal to rain terror upon our allies. Put an end to their ritual!','',26124),
(135931,'enUS','The Legion\'s plans shatter as its Burning Crusade crumbles to dust.','',26124),
(135932,'enUS','My soldiers speak of demonic brews that melt armor and disfigure flesh. Find the source of this insidious alchemy and destroy it!','',26124),
(135933,'enUS','To think Legion soldiers drink that swill... disgusting to the last!','',26124),
(135934,'enUS','Inquisitors emerge from darkness and abduct our patrols. Find these captives and spare them from their fate.','',26124),
(135935,'enUS','The torment these soldiers endured... You arrived just in time.','',26124),
(135936,'enUS','So many of my kinsmen\'s souls endure torment at the hands of the Legion. Free them, that they may rest.','',26124),
(135937,'enUS','I hope my brothers and sisters will know some measure of peace.','',26124),
(135938,'enUS','One of our scouting parties has gone missing. The Legion may have them pinned down--or worse. Find our soldiers... before it\'s too late!','',26124),
(135939,'enUS','','Begone, intruders! Back to your master!',26124),
(135940,'enUS','Saved from a grisly fate. My soldiers send their thanks.','',26124),
(135941,'enUS','Demon beasts and deadly traps slow our advance. Deal with these impediments!','',26124),
(135942,'enUS','The way forward is clear. Our campaign to bring down the Legion carries on!','',26124),
(135943,'enUS','The courage of our troops has never faltered, but even an experienced soldier can grow weary. A show of force on the front lines would be a welcome inspiration!','',26124),
(135944,'enUS','You have stoked the fire in the hearts of our soldiers. There is no doubt we will win this war!','',26124),
(135945,'enUS','','Feel the potency of life! Fear its power!',26124),
(135946,'enUS','','Minions of darkness! You will know the might of a titan!',26124),
(135947,'enUS','Legion hounds harry our troops as they try to pull back. Rescue as many of our forces as you can!','',26124),
(135948,'enUS','The death howls of those vile beasts will be remembered by the soldiers you saved, even as they march on the gates of Antorus.','',26124),
(135949,'enUS','We identified an area crucial to getting our troops to the front lines, only to find the place infested with demon spiders. Burn out those nests!','',26124),
(135950,'enUS','You scorched the hovels of those Legion pests and cleared the way for our troops. Well done!','',26124),
(135951,'enUS','','Victory is nigh, champions! Dispatch their remaining forces. I will see to their vessel myself.',26124),
(135952,'enUS','Our scouts have pinpointed a gathering of some of the Legion\'s most skilled pilots. This would be a perfect opportunity to take them out!','',26124),
(135953,'enUS','Every ship grounded without a pilot means one less enemy firing on the Vindicaar\'s shields. Excellent work!','',26124),
(135954,'enUS','','Your master has failed, demons. To the abyss with you!',26124),
(135955,'enUS','Legion artificers are reckless, and I have found a weakness in their ordnance. Shorten their fuses and destroy their stockpiles!','',26124),
(135957,'enUS','A glorious blast! The Light\'s advance will not be stopped!','',26124),
(135958,'enUS','Powerful eredar are held in stasis as their bodies are being twisted into an even more brutal form. Cut the fiends down while they slumber!','',26124),
(135959,'enUS','And so the Legion is deprived of yet another weapon.','',26124),
(135960,'enUS','The krokul slaves fled somewhere further down the ridge as they were freed. They could not have gone far.','',26124),
(135961,'enUS','Forces inside Antorus must see they are not safe from our attacks. Take a warframe and hit targets of opportunity behind their lines!','',26124),
(135962,'enUS','A successful strike and a warframe returned to me in one piece? It truly is a miracle!','',26124),
(135963,'enUS','An infernal has crashed down, killing the very masters who spawned it. Destroy this monstrosity before it jeopardizes our advance!','',26124),
(135964,'enUS','The Legion grow reckless. They reek of desperation!','',26124),
(135965,'enUS','Brutal eredar have been awakened from their stasis. Cut them down where they stand!','',26124),
(135966,'enUS','You brought down the brutes and cost the Legion another victory. Their downfall is at hand.','',26124),
(135967,'enUS','The shadows hunger!','',26124),
(135968,'enUS','Darkness... will... claim you...','',26124),
(135969,'enUS','Come, small ones. Die by my hand!','',26124),
(135970,'enUS','Im... impossible...','',26124),
(135971,'enUS','All worlds will burn in felfire!','',26124),
(135972,'enUS','The flames... will... claim you...','',26124),
(135973,'enUS','Here! They are nearby, I am certain.','',26124),
(135974,'enUS','I see the weakness in your soul!','',26124),
(135975,'enUS','My sight fails me...','',26124),
(135976,'enUS','','New playthings? How irresistible!',26124),
(135977,'enUS','','You left me... wanting...',26124),
(135978,'enUS','','Yes... come closer, little ones!',26124),
(135979,'enUS','','The master... will be... your end.',26124),
(135980,'enUS','Your presence is an infestation. Infestations must be purged!','',26124),
(135981,'enUS','My watch... ends.','',26124),
(135982,'enUS','But your ally saved many of us from the Legion\'s grasp. Perhaps you have changed.','',26124),
(135983,'enUS','Know the darkness!','',26124),
(135984,'enUS','A merciful release!','',26124),
(135985,'enUS','The master demands your doom!','',26124),
(135986,'enUS','Master! I go to claim your prize!','',26124),
(135987,'enUS','No hope. Just pain. Only pain!','',26124),
(135988,'enUS','We seek you as allies. We came to Argus at the call of the Army of the Light to bring an end to the Legion. Stand with us once more!','',26124),
(135989,'enUS','An end? Pah! Their numbers are beyond measure. It is an impossible task. A death wish!','',26124),
(135990,'enUS','My top commander, Lothraxion, was sent to defend Azeroth alongside the Silver Hand... and to guide you here.','',26124),
(135991,'enUS','The Legion brazenly advances on worlds beyond Argus, spreading its forces thin. Find their portals and kill the demons on the other side!','',26124),
(135992,'enUS','The Legion\'s arrogance is clear. Pursue them to every world they infest. Show them that they cannot escape our wrath.','',26124),
(135993,'enUS','A new invasion point harbors a Legion commander. Go and deliver vengeance!','',26124),
(135994,'enUS','The Legion\'s fanatical crusade falters. We will purge their stench from every world they have defiled.','',26124),
(135995,'enUS','It is as I thought... the stone is depleted, but intact. It shall still prove useful to us.','',26124),
(135996,'enUS','Even as we march upon the heart of Argus, the Legion continues its crusade on other worlds.','',26124),
(135997,'enUS','We will punish their hubris by hunting them any place they dare to tread.','',26124),
(135998,'enUS','Use the keystone to pass through the rift. Bring the fight to the Legion!','',26124),
(135999,'enUS','The demons will be caught off guard, assuming all our attention to be focused on Argus.','',26124),
(136000,'enUS','Show them the price of their arrogance!','',26124),
(136001,'enUS','The keystone continues to gain strength. Interesting... Perhaps we can use it to tear open more powerful rifts.','',26124),
(136002,'enUS','The Legion\'s hold will be broken at every turn! Do not let them rest! Do not relent!','',26124),
(136004,'enUS','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t',26124),
(136005,'enUS','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t',26124),
(136006,'enUS','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',26124),
(136007,'enUS','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t',26124),
(136008,'enUS','|TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',26124),
(136009,'enUS','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t',26124),
(136010,'enUS','||TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t','||TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t',26124),
(136011,'enUS','A bit worn, but still functional. These will do nicely.','',26124),
(136012,'enUS','Armaments from one of our past assaults litter the ridge on the eastern side of the hold. Their recovery would aid our war effort.','',26124),
(136013,'enUS','We will put these to use immediately. Thank you for recovering them.','',26124),
(136014,'enUS','T\'uure, free from the Legion\'s grasp at last? I welcome your presence, torchbearer.','',26124),
(136016,'enUS','I see the Alliance answered the call as well.','',26124),
(136017,'enUS','Sound effect for troops','',26124),
(136018,'enUS','Sound effect for troops','',26124),
(136019,'enUS','Sound effect for troops','Sound effect for troops',26124),
(136020,'enUS','|TInterface\\Icons\\Spell_Warlock_DemonicEmpowerment.blp:20|tKin\'garoth casts |cFFFF0000|Hspell:249740|h[Overcharge]|h|r!','',26124),
(136021,'enUS','Soon comes the awakening of my brother, Argus. Together, our new Pantheon will join the master in breaking your fetid world. But you will not live to see it.','',26124),
(136022,'enUS','I have heard all the prattling I can bear. Let us show this lackey of Sargeras that he has no claim to our world!','',26124),
(136023,'enUS','This may be the one place in the universe sacred to the Legion. Demons would pluck out their eyes sooner than gaze upon it.','',26124),
(136024,'enUS','Who could ever imagine such a sacrifice?','',26124),
(136025,'enUS','The souls of the Pantheon are free, but they endured so much sufferin\'. Let me bide with \'em fer a time. Offer a bit o\' comfort.','',26124),
(136026,'enUS','Remain here, Magni. The rest of us will go on.','',26124),
(136027,'enUS','So close now to the end...','',26124),
(136028,'enUS','The heart of Antorus lies before us. The power behind the Legion\'s infinite army.','',26124),
(136029,'enUS','So much agony here... so many voices. It\'s... it\'s nearly overwhelmin\'! But I can feel Eonar urgin\' us forward.','',26124),
(136030,'enUS','At long last, the end is upon us. Press on, my friends.','',26124),
(136031,'enUS','Aaaarggh! Witches! You call that torment? I have endured far worse!','',26124),
(136032,'enUS','','I tire of that worm\'s babbling! Let me scorch the flesh from his miserable bones!',26124),
(136033,'enUS','A faint glow emanates from the object.','',26124),
(136034,'enUS','','Ignore him, sister! Focus on your duty. These souls are nearly ready to join Aggramar in the master\'s service.',26124),
(136035,'enUS','I feel those demons twistin\' the spirits o\' the titans! Forcin\' \'em ta use their might ta serve the Legion!','',26124),
(136036,'enUS','Should they fall to darkness, Sargeras will have the power he needs to claim the final titan.','',26124),
(136037,'enUS','Azeroth!','',26124),
(136038,'enUS','Azerite fissures begin to erupt nearby!','',26124),
(136040,'enUS','What is your bidding, master?','',26124),
(136041,'enUS','The circle nears completion. The mortals must not disrupt the rebirth.','',26124),
(136042,'enUS','Those who will not serve shall be destroyed. It is the only way.','',26124),
(136043,'enUS','Become the instrument of my wrath once again, Aggramar. End this incursion of the Light.','',26124),
(136044,'enUS','The hour of rebirth draws near. Are the souls prepared?','',26124),
(136045,'enUS','Our kin still resist the true path, master. But they will soon be broken.','',26124),
(136046,'enUS','One still eludes us. Her essence is needed to ensure the victory of my crusade.','',26124),
(136047,'enUS','The Life-Binder will soon reveal herself. She will not escape me, master!','',26124),
(136048,'enUS','When my new Pantheon rises, no power in the universe will stand against the Legion!','',26124),
(136049,'enUS','','I remember the awakening... how life sprang forth all around us.',26124),
(136050,'enUS','','I remember unity... until it was shattered by betrayal.',26124),
(136051,'enUS','','I remember fleeing... to keep him from his prize.',26124),
(136052,'enUS','','The time for hiding is over. Aid me... or everything ends.',26124),
(136053,'enUS','Talgath has turned against us!','',26124),
(136054,'enUS','No...','',26124),
(136055,'enUS','It cannot end like this. Take the others and go, Prophet. We will buy you time.','',26124),
(136056,'enUS','Hatuun! You do not have to do this!','',26124),
(136057,'enUS','Please... keep my family safe.','',26124),
(136058,'enUS','K\'ure! Help us!','',26124),
(136059,'enUS','I will hunt you across the stars, traitor! Even if it takes a thousand years!','',26124),
(136061,'enUS','Swear loyalty to me, pledge the hearts of your people to my cause.','',26124),
(136062,'enUS','Together, we will become Legion, and defeat the hungering void that would consume us all.','',26124),
(136063,'enUS','It is little enough to ask, for what he offers us.','',26124),
(136064,'enUS','Such power... And he speaks the truth.','',26124),
(136065,'enUS','I had hoped the others would sense the darkness behind Sargeras\'s words.','',26124),
(136066,'enUS','The ata\'mal crystal soon showed me the horrible truth of what would come to pass if we accepted the titan\'s offer.','',26124),
(136073,'enUS','You see an empty space where a labradorite could fit.','',26124),
(136074,'enUS','You see an empty space where a florid malachite could fit.','',26124),
(136075,'enUS','You see an empty space where a chemirine could fit.','',26124),
(136076,'enUS','You see an empty space where an argulite could fit.','',26124),
(136077,'enUS','You see an empty space where a hesselian could fit.','',26124),
(136078,'enUS','You see an empty space where a lightsphene could fit.','',26124),
(136079,'enUS','Place a labradorite in the space.','Place a labradorite in the space.',26124),
(136080,'enUS','Place a chemirine in the space.','Place a chemirine in the space.',26124),
(136081,'enUS','Place a florid malachite in the space.','Place a florid malachite in the space.',26124),
(136082,'enUS','Place an argulite in the space.','Place an argulite in the space.',26124),
(136083,'enUS','Place a hesselian in the space.','Place a hesselian in the space.',26124),
(136084,'enUS','Place a lightsphene in the space.','Place a lightsphene in the space.',26124),
(136087,'enUS','The southern skies swell with chaotic energy.','The southern skies swell with chaotic energy.',26124),
(136088,'enUS','Careful! Mortals ain\'t meant ta walk the Dreamweaver\'s path!','',26124),
(136089,'enUS','The demons are turnin\' the Shaper\'s flames against ye!','',26124),
(136090,'enUS','The coven strikes at ye through the storms o\' Golganneth!','',26124),
(136091,'enUS','The coven\'s torments o\' the Highfather have taken form!','',26124),
(136097,'enUS','I\'ll do what I can ta ease the titan spirits while you put an end ta their torturers!','',26124),
(136098,'enUS','','Archmage Y\'mera waves for you to follow her.',26124),
(136117,'enUS','Ye did it! Aggramar\'s essence is free! He can stand beside his brethren once more.','',26124),
(136118,'enUS','The very cradle of creation!','',26124),
(136119,'enUS','The titans can sever that connection... but not here. They need ta bring the soul o\' Argus ta their place o\' power... the Seat o\' the Pantheon.','',26124),
(136120,'enUS','Our victories mean nothing. So long as Sargeras has the soul of Argus to fuel his infinite army, Azeroth remains in grave peril.','',26124),
(136121,'enUS','Their final act will harness the last o\' Argus\'s power, to imprison Sargeras... once and for all.','',26124),
(136122,'enUS','Heroes, I can signal the titans ta begin. Once they start their ritual... there\'s no turnin\' back!','',26124),
(136123,'enUS','The tortured soul of Argus has been put ta rest.','',26124),
(136124,'enUS','It matters not. We have lost. Look to the skies!','',26124),
(136125,'enUS','Sargeras will soon undo all we have fought for.','',26124),
(136126,'enUS','No.','',26124),
(136127,'enUS','We will use the last glimmer of Argus\'s power to bind him here. The Seat of the Pantheon shall become Sargeras\'s prison... and ours as well.','',26124),
(136128,'enUS','You would condemn yourselves to stop him?','',26124),
(136129,'enUS','Our world must survive... no matter the cost!','',26124),
(136130,'enUS','A sacrifice must be made.','',26124),
(136131,'enUS','Return home, children of Azeroth. Protect the final titan.','',26124),
(136132,'enUS','Prophet... what happened out there?','',26124),
(136133,'enUS','Illidan serves as the Dark Titan\'s jailer. His sacrifice has ended the Legion. At long last, the Burning Crusade... is over.','',26124),
(136134,'enUS','Magni? Are you alright? Magni?','',26124),
(136135,'enUS','A sword... in the darkness... sands... soaked in pain.','',26124),
(136136,'enUS','The wound... burning... burning...','',26124),
(136137,'enUS','Take me to the surface.','Take me to the surface.',26124),
(136138,'enUS','The Vindicaar is yours to command.','',26124),
(136139,'enUS','','Our home... what has it become?',26124),
(136142,'enUS','A Pacing Quest Goes Here.','A Pacing Quest Goes Here.',26124),
(136143,'enUS','No, Light please. Not after we have come this far!','',26124),
(136154,'enUS','At last, the corruption ceases!','',26124),
(136155,'enUS','They will not stop their efforts to corrupt me and my bretheren. But, maybe your arrival can turn the tide.','',26124),
(136157,'enUS','Bring me spheres of coalesced flame, that I may empower myself for battle!','',26124),
(136158,'enUS','They are upon us once more! Bring the flame to me!','',26124),
(136171,'enUS','','Xakaar, what is this delay?!',26124),
(136172,'enUS','Client Scene: Alleria Peers Into the Void','Client Scene: Alleria Peers Into the Void',26124),
(136173,'enUS','','Here we go.',26124),
(136174,'enUS','','The key is now reforged. Take it and secure the Armory.',26124),
(136175,'enUS','As the machine erupts, something stirs beneath the surface.','',26124),
(136180,'enUS','','At last.',26124),
(136181,'enUS','','I serve the end of all things.',26124),
(136182,'enUS','','Their will be done.',26124),
(136183,'enUS','','I come, Dark Masters.',26124),
(136184,'enUS','','I return to the Void.',26124),
(136185,'enUS','','Oblivion... calls.',26124),
(136186,'enUS','','Understand... this changes... nothing.',26124),
(136208,'enUS','The intruders are proving to be more resilient than we expected Admiral.','',26124),
(136209,'enUS','The Legion ship has seen you. Escape to avoid being targeted.','',26124),
(136216,'enUS','<PH> Intro to Island 3 goes here! For now, just turn in the quest! <PH>','<PH> Intro to Island 3 goes here! For now, just turn in the quest! <PH>',26124),
(136244,'enUS','','Behind me rests the Netherlight Crucible. It is an ancient remnant of this world that once served as a source of considerable magic.$B$BThough its potential power is thought by many to be a gift, empowering it would require great sacrifice... as well as a delicate balance of Light and Shadow.',26124),
(136245,'enUS','That? Why that\'s just a portal I\'ve conjured to allow safe passage to and from Dalaran.$B$BNever know when we\'re gonna need reinforcements!','',26124),
(136246,'enUS','','Hello, $n. Everyone aboard has been quite active. You look like you\'ve been busy yourself! If you ever need a place to rest I\'m always here for you.',26124),
(136247,'enUS','','Greetings.',26124),
(136294,'enUS','Client Scene: The Vindicaar goes Gold','Client Scene: The Vindicaar goes Gold',26124),
(136300,'enUS','This place is full of magic and mystery.','',26124),
(136301,'enUS','What is that portal doing here?','What is that portal doing here?',26124),
(136302,'enUS','What is that behind you?','What is that behind you?',26124),
(136303,'enUS','Interesting... And why aren\'t you wearing any shoes?','Interesting... And why aren\'t you wearing any shoes?',26124),
(136304,'enUS','The cold flooring beneath my feet helps me maintain my concentration.','',26124),
(136305,'enUS','I am wearing shoes.','I am wearing shoes.',26124),
(136333,'enUS','Don\'t worry about me, I\'ll find a way down... Eventually.','',26124),
(136334,'enUS','','Oh, look! Another pet has come to play.',26124),
(136335,'enUS','','How fortuitous, my pets were getting hungry.',26124),
(136336,'enUS','','I can make you immortal. However, you first have to die!',26124),
(136337,'enUS','You will be first.','',26124),
(136338,'enUS','So eager to die?','',26124),
(136339,'enUS','I must select one of the countless ways to kill you.','',26124),
(136342,'enUS','From Fel... to Fel.','',26124),
(136343,'enUS','Believe you\'re free? We all serve a master.','',26124),
(136344,'enUS','Reborn in Fel!','',26124),
(136389,'enUS','It is good to see you, Ishanah. How are you?','It is good to see you, Ishanah. How are you?',26124),
(136390,'enUS','','I am well, $n. Thank you for asking.$B$BBefore you venture out to the fields of battle I wanted to make sure you know that my services are always available should you need a place to rest.$B$BBe well.',26124),
(136391,'enUS','But you\'re sitting down.','But you\'re sitting down.',26124),
(136392,'enUS','Yes, well you got me there. Still comfortable regardless.$B$BNow if you\'ll excuse me, I\'ve got quite a bit of reading to do.','',26124),
(136412,'enUS','I need repairs, Durael.','I need repairs, Durael.',26124),
(136416,'enUS','Choose the Vindicaar power that you want to use on Argus. Only one power can be active at a time.','',26124),
(136433,'enUS','Thank you, hero!','Thank you, hero!',26124),
(136496,'enUS','$n prepares a Feast of the Fishes!','$n prepares a Feast of the Fishes!',26124),
(136499,'enUS','%s\'s pet Corbyn bites your ears, searching for shiny baubles.','%s\'s pet Corbyn bites your ears, searching for shiny baubles.',26124),
(136500,'enUS','%s\'s pet Corbyn searches your hair for shiny baubles.','%s\'s pet Corbyn searches your hair for shiny baubles.',26124),
(136501,'enUS','%s\'s pet Corbyn caws loudly in your ears.','%s\'s pet Corbyn caws loudly in your ears.',26124),
(136502,'enUS','%s\'s pet Corbyn attempts to poke you in the eyes.','%s\'s pet Corbyn attempts to poke you in the eyes.',26124),
(136503,'enUS','%s\'s pet Corbyn circles your head.','%s\'s pet Corbyn circles your head.',26124),
(136504,'enUS','%s\'s pet Corbyn pokes around in your bags.','%s\'s pet Corbyn pokes around in your bags.',26124),
(136505,'enUS','Corbyn stole a copper coin from %s!','Corbyn stole a copper coin from %s!',26124),
(136506,'enUS','Corbyn couldn\'t find anything shiny on %s.','Corbyn couldn\'t find anything shiny on %s.',26124),
(136540,'enUS','|TINTERFACE\\ICONS\\SPELL_FIRE_FELFLAMERING.BLP:20|t Antaen Light-Breaker is casting |cFFFF0000|Hspell:250880|h[Felshock Bombardment]|h|r! Stay in Light\'s Protection!','|TINTERFACE\\ICONS\\SPELL_FIRE_FELFLAMERING.BLP:20|t Antaen Light-Breaker is casting |cFFFF0000|Hspell:250880|h[Felshock Bombardment]|h|r! Stay in Light\'s Protection!',26124),
(136541,'enUS','','I will not be broken.',26124),
(136542,'enUS','What happened to you in the Seat of the Triumvirate?','What happened to you in the Seat of the Triumvirate?',26124),
(136543,'enUS','','As the naaru lay dying, L\'ura\'s essence called to me. A being born of the Light had turned to shadow.\n\nIt was a familiar sensation.\n\nThe transformation you witnessed is under my control, to be used when I see fit. I am the same person I was... and yet, something more.\n\nThe use of such power makes some... uneasy. But shadow is a force to be harnessed, not feared.\n\nAs with any weapon, one must maintain constant control when wielding it.',26124),
(136544,'enUS','I see.','I see.',26124),
(136580,'enUS','I heard the Viceroy finally took care of that meddling priest.','',26124),
(136582,'enUS','A pity he did not kill the elf and her ally, too.','',26124),
(136583,'enUS','','There is plenty material for the harvest, here. Let none of it go to waste!',26124),
(136584,'enUS','I will not give Locus-Walker the satisfaction of disrupting our efforts. Capture him at all costs.','',26124),
(136585,'enUS','Do what you like with the fleshling and her ally. They are of no concern.','',26124),
(136586,'enUS','','Our work is nearly complete. Soon all of Argus will fall to darkness!',26124),
(136593,'enUS','He\'s fightin\' through the pain... to let us see...','',26124),
(136594,'enUS','The voice is alone... weak... but so beautiful!','',26124),
(136595,'enUS','Light.','Light.',26124),
(136596,'enUS','Shadow.','Shadow.',26124),
(136597,'enUS','|TINTERFACE\\ICONS\\Item_HolySpark.blp:20|t [Place the Essence of Light within the Netherlight Crucible].','|TINTERFACE\\ICONS\\Item_HolySpark.blp:20|t [Place the Essence of Light within the Netherlight Crucible].',26124),
(136598,'enUS','|TINTERFACE\\ICONS\\Inv_Elemental_Primal_Shadow.blp:20|t [Place the Essence of Shadow within the Netherlight Crucible].','|TINTERFACE\\ICONS\\Inv_Elemental_Primal_Shadow.blp:20|t [Place the Essence of Shadow within the Netherlight Crucible].',26124),
(136606,'enUS','I\'ve heard this tale before... <Skip the scenario and begin your journey on Broken Shore.>','I\'ve heard this tale before... <Skip the scenario and begin your journey on Broken Shore.>',26124),
(136612,'enUS','PH Activate Choice UI','PH Activate Choice UI',26124),
(136616,'enUS','Thank you for joining us, champion. These are dire times indeed.','',26124),
(136617,'enUS','We all know the Alliance incurred heavy losses in the war against the Legion. And even now, the world bleeds in the aftermath of Sargeras\'s final strike.','',26124),
(136618,'enUS','Meanwhile, the Horde musters its forces and arms for war. Their aggression must not go unanswered.','',26124),
(136619,'enUS','Our future depends on bringing other like-minded allies into the fold. I call upon those of you gathered here for your suggestions.','',26124),
(136620,'enUS','Victory on Argus was only possible because the heroes of Azeroth fought side-by-side with the Army of the Light.','',26124),
(136621,'enUS','Many of our bravest soldiers gave their lives for the cause. Those who remain would be proud to join the Alliance.','',26124),
(136622,'enUS','Among our number are brave initiates about to undertake the arduous path of becoming Lightforged.','',26124),
(136623,'enUS','Thank you, High Exarch. Lightforged soldiers would indeed bring strength to our numbers.','',26124),
(136624,'enUS','','High King, I remember the days when my people and yours fought together against the Horde.',26124),
(136625,'enUS','','I reached out to them in hopes of seeing Silvermoon return to the Alliance. My efforts proved... futile.',26124),
(136626,'enUS','','But I did learn of a group of sin\'dorei who have been exiled for studying the void as I have. If I could locate them, their knowledge might aid our cause.',26124),
(136627,'enUS','Stormwind has suffered at the hands of those who succumbed to the shadow\'s whispers. But if others could master its power as you have, they would make formidable allies.','',26124),
(136628,'enUS','Thank you both for your counsel. I would like to hear our champion\'s perspective on which of these potential allies we should reach out to first.','',26124),
(136629,'enUS','Lady Windrunner, please begin the search for your exiled kin. Perhaps our champion here can assist you.','',26124),
(136630,'enUS','','We will do our best to locate them, High King.',26124),
(136631,'enUS','','This way, champion.',26124),
(136656,'enUS','This stuff isn\'t bad, but it\'s a bleedin\' shame just letting the beans sit in water and callin\' that a proper beverage. I need to bring some of this coffee back to the famed Thunderbrew clan and let them have a go at it. Just imagine a good stout, aged with a batch of these beans....','',26124),
(136658,'enUS','We\'ve been working for years to comprehend the powers the void might provide. Now, we are on the cusp of understanding.','',26124),
(136659,'enUS','What is this place?','What is this place?',26124),
(136661,'enUS','|TInterface\\Icons\\ABILITY_MAGE_DEEPFREEZE.BLP:20|tGet to a Brazier! |cFFFF0000|Hspell:251709|h[Flash Freeze]|h|ris coming!','',26124),
(136682,'enUS','You are not... prepared.','',26124),
(136701,'enUS','We have accomplished our mission. Let us return to the Vindicaar. Much work remains to be done.','',26124),
(136714,'enUS','I thought I was done for... thank you!','',26124),
(136715,'enUS','Please, save the others!','',26124),
(136716,'enUS','Thank you, Champion... I was sure this was the end.','',26124),
(136733,'enUS','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',26124),
(136734,'enUS','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',26124),
(136735,'enUS','|TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',26124),
(136736,'enUS','|TInterface\\Icons\\spell_shadow_summonfelhunter.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\spell_shadow_summonfelhunter.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',26124),
(136737,'enUS','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t','|TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t',26124),
(136743,'enUS','','It is time.',26124),
(136748,'enUS','Purple Team gain the Gift of the Emperor!','',26124),
(136749,'enUS','Gold Team gains the Gift of the Emperor!','',26124),
(136781,'enUS','','There is much prey to be had here.',26124),
(136782,'enUS','','Even here, I can hear it calling to me. Its hunger...',26124),
(136783,'enUS','','Welcome to the heart of Argus.',26124),
(136784,'enUS','','They are truly endless. We must find a way to bring a final end to them.',26124),
(136785,'enUS','What information have you been able to gather, Alleria?','What information have you been able to gather, Alleria?',26124),
(136786,'enUS','Turalyon wants to know the situation down here.','Turalyon wants to know the situation down here.',26124),
(136787,'enUS','','The outlook is grim.$b$bMounting a direct assault from this location would prove far too costly. What is more, those cannons atop the wall may well be powerful enough to bring down the Vindicaar.$b$bI suggest using this foothold to launch guerilla strikes. Assassinate key members of their leadership and wreak havoc within their ranks.$b$bI know this is not what you or Turalyon were hoping to hear, but a patient hunter must know when to strike.',26124),
(136790,'enUS','Here at last. It has been so long...','',26124),
(136791,'enUS','They are in full force here. They truly are Legion.$b$bPerfect.','',26124),
(136792,'enUS','My glaives hunger for the blood of demons.','',26124),
(136793,'enUS','I shall put an end to the Legion in this accursed place.','',26124),
(136794,'enUS','You ask the obvious.$b$bA direct assault on Antorus would be folly. The Legion\'s forces vastly outnumber us, and they are replacing fallen soldiers at unnatural speed. Some of these brutes are even strong enough to slow me down... slightly.$b$bBreaching their stronghold will require a different plan. In the meantime, there is a sea of demons to slay.$b$bGo back to your High Exarch and let him strategize. I have an enemy to destroy.','',26124),
(136817,'enUS','The Marsh Shambler becomes Fel Enraged and breaks free from the corrupters!','The Marsh Shambler becomes Fel Enraged and breaks free from the corrupters!',26124),
(136826,'enUS','','We must continue to fight until the Legion is no more.',26124),
(136833,'enUS','','The power of the Netherlight Crucible is yours, $n.',26124),
(136834,'enUS','','The sacrifices made to empower the Netherlight Crucible must never be forgotten.',26124),
(136839,'enUS','Argus will never belong to the Legion so long as we stand.','',26124),
(136847,'enUS','|TINTERFACE\\ICONS\\SPELL_FIRE_FELFLAMESTRIKE.BLP:20|t This area is targeted for |cFFF00000|Hspell:250249|h[Obliteration]|h|r!','',26124),
(136873,'enUS','Kor\'vas, what is the status of the Sargerite Keystone?','Kor\'vas, what is the status of the Sargerite Keystone?',26124),
(136875,'enUS','','Lord Illidan has taken it. His plan is in motion, Slayer.',26124),
(136890,'enUS','<The warframe hisses with energy, ready to be taken into battle.>','',26124),
(136891,'enUS','Begin attack run on Antorus.','Begin attack run on Antorus.',26124),
(136897,'enUS','|cFFFF0000|Hspell:252508|h[The Paraxis]|h|r is arriving soon!','',26124),
(136898,'enUS','|cFFFF0000|Hspell:252508|h[The Paraxis]|h|r has arrived! Run for cover!','',26124),
(136924,'enUS','I want to go to the Seat of the Triumvirate (Dungeon).','I want to go to the Seat of the Triumvirate (Dungeon).',26124),
(136926,'enUS','Purple Team gains Gift of the Emperor!','',26124),
(136930,'enUS','','The Paraxis is returning soon! Army of the Light, set up your shields!',26124),
(136932,'enUS','','The Paraxis is here! Take cover under the shields!',26124),
(136933,'enUS','The Gift of the Emperor is placed within the arena!','',26124),
(136970,'enUS','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Ability_FelArakkoa_EyeofTerrok.blp:24|t',26124),
(136971,'enUS','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t',26124),
(137042,'enUS','I have not had to create something like this in a millennium; bear with me.','',26124),
(137043,'enUS','Ah, yes, it is coming together nicely.','',26124),
(137044,'enUS','It is once again whole!','',26124),
(137081,'enUS','We have acquired many goods and curios over the course of this war.','',26124),
(137102,'enUS','|TInterface\\Icons\\ABILITY_DEATHKNIGHT_DEATHSIPHON2.BLP:20|t %s begins to cast |cFFFF0000|Hspell:244056|h[Siphon Corruption]|h|r.','|TInterface\\Icons\\ABILITY_DEATHKNIGHT_DEATHSIPHON2.BLP:20|t %s begins to cast |cFFFF0000|Hspell:244056|h[Siphon Corruption]|h|r.',26124),
(137103,'enUS','|TInterface\\Icons\\SPELL_FIRE_MOLTENBLOOD.BLP:20|t %s begins to cast |cFFFF0000|Hspell:244057|h[Enflame Corruption]|h|r.','|TInterface\\Icons\\SPELL_FIRE_MOLTENBLOOD.BLP:20|t %s begins to cast |cFFFF0000|Hspell:244057|h[Enflame Corruption]|h|r.',26124),
(137111,'enUS','|TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\spell_shadow_summonfelhunter:20|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',26124),
(137112,'enUS','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',26124),
(137114,'enUS','|TInterface\\Icons\\spell_shadow_summonfelhunter.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\spell_shadow_summonfelhunter.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelLord.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',26124),
(137115,'enUS','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t','|TInterface\\Icons\\SPELL_SHADOW_SUMMONFELGUARD.BLP:24|t |TInterface\\Icons\\spell_shadow_summonfelhunter.BLP:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_FelReaver.blp:24|t |TInterface\\Icons\\Achievement_Boss_HellFire_Socrethar.blp:24|t',26124),
(137123,'enUS','We found this place almost by chance. A rift appeared as I performed experiments in my tower.','',26124),
(137124,'enUS','Since we were first cast out of Blood Elf society, others have joined in the research.','',26124),
(137125,'enUS','This cube is the most puzzling of the... wait.  The energy pulses at your approach. This is... unprecedented.','',26124),
(137126,'enUS','I can see the flow of void energy forming. Perhaps... Yes, that is it!','',26124),
(137136,'enUS','|TInterface\\Icons\\INV_OFFHAND_1H_ULDUARRAID_D_01:20|tThe Coven has unleashed the |cFFFF0000|Hspell:250095|h[Machinations of Aman\'Thul]|h|r!','|TInterface\\Icons\\INV_OFFHAND_1H_ULDUARRAID_D_01:20|tThe Coven has unleashed the  |cFFFF0000|Hspell:250095|h[Machinations of Aman\'Thul]|h|r!',26124),
(137145,'enUS','|TInterface\\Icons\\ABILITY_THUNDERKING_LIGHTNINGWHIP:20|tThe Coven prepares to unleash the  |cFFFF0000|Hspell:246763|h[Fury of Golganneth]|h|r!','|TInterface\\Icons\\ABILITY_THUNDERKING_LIGHTNINGWHIP:20|tThe Coven prepares to unleash the  |cFFFF0000|Hspell:246763|h[Fury of Golganneth]|h|r!',26124),
(137146,'enUS','|TInterface\\Icons\\ABILITY_MONK_BREATHOFFIRE:20|tThe Coven prepares to unleash the  |cFFFF0000|Hspell:245671|h[Flames of Khaz\'goroth]|h|r!','|TInterface\\Icons\\ABILITY_MONK_BREATHOFFIRE:20|tThe Coven prepares to unleash the  |cFFFF0000|Hspell:245671|h[Flames of Khaz\'goroth]|h|r!',26124),
(137147,'enUS','|TInterface\\Icons\\ABILITY_MAGE_POTENTSPIRIT:20|tThe Coven prepares to unleash the  |cFFFF0000|Hspell:245910|h[Spectral Army of Norgannon]|h|r!','|TInterface\\Icons\\ABILITY_MAGE_POTENTSPIRIT:20|tThe Coven prepares to unleash the  |cFFFF0000|Hspell:245910|h[Spectral Army of Norgannon]|h|r!',26124),
(137149,'enUS','Greetings, and thank you for helping to test Antorus, the Burning Throne!\n\nI can teleport you directly to any bosses that are currently available for testing.','',26124),
(137150,'enUS','|TInterface\\Icons\\ABILITY_WARLOCK_MOLTENCORE.BLP:20|t You are afflicted by |cFFFF0000|Hspell:244768|h[Desolate Gaze]|h|r!','|TInterface\\Icons\\ABILITY_WARLOCK_MOLTENCORE.BLP:20|t You are afflicted by |cFFFF0000|Hspell:244768|h[Desolate Gaze]|h|r!',26124),
(137158,'enUS','Who has awoken me?','',26124),
(137159,'enUS','I emerge stronger than ever! Prepare mortal.','',26124),
(137160,'enUS','In my dreams I saw your world... destroyed!','',26124),
(137164,'enUS','I want to teleport to Felhounds of Sargeras.','I want to teleport to Felhounds of Sargeras.',26124),
(137165,'enUS','I want to teleport to the Antoran High Command.','I want to teleport to the Antoran High Command.',26124),
(137166,'enUS','I want to teleport to Portal Keeper Hasabel.','I want to teleport to Portal Keeper Hasabel.',26124),
(137167,'enUS','I want to teleport to Eonar.','I want to teleport to Eonar.',26124),
(137168,'enUS','I want to teleport to Imonar the Soulhunter.','I want to teleport to Imonar the Soulhunter.',26124),
(137169,'enUS','I want to teleport to Kin\'garoth.','I want to teleport to Kin\'garoth.',26124),
(137170,'enUS','I want to teleport to Varimathras.','I want to teleport to Varimathras.',26124),
(137171,'enUS','I want to teleport to the Coven of Shivarra.','I want to teleport to the Coven of Shivarra.',26124),
(137172,'enUS','I want to teleport to Aggramar.','I want to teleport to Aggramar.',26124),
(137173,'enUS','I want to teleport to Argus the Unmaker.','I want to teleport to Argus the Unmaker.',26124),
(137176,'enUS','','Light and shadow are both means to an end. For the foe before you, feel free to pick whatever weapon you favor.',26124),
(137177,'enUS','','It seems you have chosen your weapon. As have I.',26124),
(137178,'enUS','Champion! The Light has need of you!','',26124),
(137179,'enUS','The Legion cannot stand against the power of the Light. Not when it has champions like you!','',26124),
(137180,'enUS','Prepare yourself, champion. Wickedness lurks nearby...','',26124),
(137181,'enUS','With every such foe you bring down, our ultimate victory draws nearer.','',26124),
(137182,'enUS','Champion! Your expertise is needed! Prepare for battle!','',26124),
(137183,'enUS','You and your comrades fought well. Such determination will be crucial in the battles to come.','',26124),
(137184,'enUS','Our scouts report the presence of a deadly enemy nearby. Time to go on the offensive!','',26124),
(137185,'enUS','Your work today has saved lives, champion. Take pride in that!','',26124),
(137186,'enUS','I sense an entity that wields potent forces with great malevolence. This fiend must be brought down!','',26124),
(137187,'enUS','A worthy victory. No minion of the Legion can be allowed to toy with such forces.','',26124),
(137188,'enUS','Well done! The way you took that target down reminds me of myself in my younger days. My much, much younger days.','',26124),
(137189,'enUS','Gather your allies, champion. A grave threat is at hand, and heroes are needed!','',26124),
(137190,'enUS','Once again, I owe you a debt of thanks. I\'d say you\'re making quite a habit of this!','',26124),
(137191,'enUS','This way, champion!','',26124),
(137192,'enUS','You and your allies are needed, champion. Gather your forces!','',26124),
(137193,'enUS','No matter how many monstrosities they send at us, we will cut them down.','',26124),
(137194,'enUS','','The enemy draws near. Stand ready. We fight for the future of our world.',26124),
(137195,'enUS','','Even here on this bleak world, we fight for Azeroth!',26124),
(137196,'enUS','Gather your allies, hero. The threat you are about to face will put all your skills to the test!','',26124),
(137197,'enUS','The way you and your allies persevered is an inspiration to our forces. Proof that together we can save Azeroth!','',26124),
(137198,'enUS','An insidious champion of darkness draws near. Strike it down!','',26124),
(137199,'enUS','Never doubt that, in the end, the Light will emerge victorious.','',26124),
(137200,'enUS','We can never reclaim what we once had, but we will make them pay for what they did to Argus.','',26124),
(137201,'enUS','What was once a sacred site for my people has been desecrated by the Legion. Drive them out!','',26124),
(137202,'enUS','This way! Come at once!','',26124),
(137203,'enUS','You and your comrades fought well. Such determination will be crucial in the battles to come.','',26124),
(137204,'enUS','It\'s important to listen, even when yer lot in life is speakin\'.','',26124),
(137205,'enUS','This villain profanes the homeworld I lost so long ago. Put an end to this atrocity!','',26124),
(137206,'enUS','I am ready to go to the stone.','I am ready to go to the stone.',26124),
(137207,'enUS','We can never reclaim what we once had, but we will make them pay for what they did to Argus.','',26124),
(137208,'enUS','A disciple of Kil\'jaeden seeks to avenge its master. Be ready for its assault!','',26124),
(137209,'enUS','Word of your victory will spread across Argus. Those who cling to the memory of the Deceiver are doomed to fall!','',26124),
(137210,'enUS','Just when the Light gains a foothold here, another vessel of evil rises to battle us. Your might is needed once again, champion.','',26124),
(137211,'enUS','The Light cannot win unless we fight for it. You have done your part this day, champion.','',26124),
(137213,'enUS','I sense a foul presence... an evil that seeks to blot out the Light. Take up arms and bring down this foe!','',26124),
(137214,'enUS','With every such foe you bring down, our ultimate victory draws nearer.','',26124),
(137215,'enUS','No matter how many monstrosities they send at us, we will cut them down.','',26124),
(137216,'enUS','This way! Come at once!','',26124),
(137217,'enUS','','Light and shadow are both means to an end. For the foe before you, feel free to pick whatever weapon you favor.',26124),
(137218,'enUS','','It seems you have chosen your weapon. As have I.',26124),
(137219,'enUS','','I have hunted demons throughout the Twisting Nether for a thousand years. I think I can leave this one to you.',26124),
(137220,'enUS','','Most effective. Every blow dealt to the Legion is a boon to our cause.',26124),
(137221,'enUS','Well done! We have pushed the Legion back... for now, at least.','',26124),
(137222,'enUS','Reports say there is a particularly powerful demon at this location. We should eliminate it quickly!','',26124),
(137224,'enUS','A well-earned victory. The Legion will fall!','',26124),
(137225,'enUS','The Legion considers this location unassailable. I say we prove them wrong!','',26124),
(137227,'enUS','','Well fought. This tide of demons will break upon our blades!',26124),
(137228,'enUS','','A powerful demon is close... very close. Make an example of it!',26124),
(137229,'enUS','Our patrol has spotted a powerful foe in this area. Its downfall would set back the Legion\'s presence here significantly.','',26124),
(137230,'enUS','The Legion cannot stand against the power of the Light. Not when it has champions like you!','',26124),
(137231,'enUS','I want to go to Antorus, the Burning Throne (Raid).','I want to go to Antorus, the Burning Throne (Raid).',26124),
(137232,'enUS','|TInterface\\Icons\\SPELL_SHADOW_GRIMWARD.BLP:20|tThe Marsh Shamblers break free from their Corrupters; but are |cFFFF0000|Hspell:253552|h[Drained]|h|r in the process.','|TInterface\\Icons\\SPELL_SHADOW_GRIMWARD.BLP:20|tThe Marsh Shamblers break free from their Corrupters; but are |cFFFF0000|Hspell:253552|h[Drained]|h|r in the process.',26124),
(137236,'enUS','The invaders approach. Crush them lest you be used as target practice for the fleet!','',26124),
(137237,'enUS','Such arrogance! You approach the Antoran High Command!','',26124),
(137238,'enUS','Fall to your knees and I promise you a swift death.','',26124),
(137285,'enUS','Our ground forces have secured the area and the Vindicaar awaits your arrival. We can give you an escort. Are you ready to leave?','',26124),
(137286,'enUS','I\'m ready.','I\'m ready.',26124),
(137297,'enUS','Nonsense! The crowd is simply spirited!','Nonsense! The crowd is simply spirited!',26124),
(137298,'enUS','I have not noticed anything.','I have not noticed anything.',26124),
(137299,'enUS','Hmmm... no, I have not noticed anything in particular.','Hmmm... no, I have not noticed anything in particular.',26124),
(137302,'enUS','Look, it\'s the Tri-- trum... The three!','Look, it\'s the Tri-- trum... The three!',26124),
(137303,'enUS','Mother says I should not talk to strangers.','Mother says I should not talk to strangers.',26124),
(137304,'enUS','I feel an unsettling presence near me. What do you think it could be?','I feel an unsettling presence near me. What do you think it could be?',26124),
(137305,'enUS','Hmmm... I think you may be on to something. The air is heavy with ill intent, though I could not say where it comes from.','Hmmm... I think you may be on to something. The air is heavy with ill intent, though I could not say where it comes from.',26124),
(137306,'enUS','Yes, but I cannot be certain where it comes from. It could be nothing.','Yes, but I cannot be certain where it comes from. It could be nothing.',26124),
(137309,'enUS','<The child fidgets nervously.>$b$bI don\'t know... Maybe?','<The child fidgets nervously.>$b$bI don\'t know... Maybe?',26124),
(137310,'enUS','Maybe it\'s a panthara! They like to hide in the shadows....$b$b<The child glances over his shoulder nervously.>','Maybe it\'s a panthara! They like to hide in the shadows....$b$b<The child glances over his shoulder nervously.>',26124),
(137311,'enUS','Do you feel it gripping your heart, too?  Please stop this, whatever it is.','Do you feel it gripping your heart, too?  Please stop this, whatever it is.',26124),
(137313,'enUS','Yes! I noticed it the instant I arrived. It makes my skin crawl!','Yes! I noticed it the instant I arrived. It makes my skin crawl!',26124),
(137314,'enUS','<He looks to either side.>$b$bSomething is very wrong. I want to run but my legs will not move.','<She looks to either side.>$b$bSomething is very wrong. I want to run but my legs will not move.',26124),
(137318,'enUS','<The child sobs loudly at you in response to your question.>','<The child sobs loudly at you in response to your question.>',26124),
(137319,'enUS','I\'m scared. I want to go home.','I\'m scared. I want to go home.',26124),
(137320,'enUS','Perhaps, but it is nothing Kil\'jaeden cannot handle.','',26124),
(137321,'enUS','No, why would I? Get out of the way, I am trying to listen to our leader speak.','',26124),
(137322,'enUS','<Crystalsmith Netrius clutches his hammer.>$b$bAbsolutely. Whatever it is, it cannot be allowed to harm Kil\'jaeden.','',26124),
(137323,'enUS','All appears to be well, stranger.','',26124),
(137324,'enUS','I sense something is intensely wrong, but I could not hope to explain how! What is this awful feeling?','',26124),
(137325,'enUS','There is something strange, yes, but I am uncertain what it might be. It could be nothing.','',26124),
(137326,'enUS','All is well, stranger.','',26124),
(137327,'enUS','<Hatuun clenches his fists.>$b$bSomething is very wrong here.','',26124),
(137328,'enUS','I thought I felt something amiss, but it is likely nothing. Worry not.','',26124),
(137329,'enUS','Nothing comes to mind, stranger.','',26124),
(137330,'enUS','Yes. I am certain of it. Something dark and terrible stands among us.','',26124),
(137331,'enUS','Funny you should mention it. I thought it was merely my imagination, but perhaps not.','',26124),
(137332,'enUS','I have not noticed anything out of the ordinary, stranger.','',26124),
(137333,'enUS','<Restalaan shifts his weight nervously.>$b$bWhatever it is, it is close.','',26124),
(137334,'enUS','You may be on to something, stranger. Stay sharp.','',26124),
(137335,'enUS','You waste my time with such a suggestion. Begone.','',26124),
(137336,'enUS','The Triumvirate may be in imminent danger! Be on your guard!','',26124),
(137337,'enUS','Strange is not the word I would have used, but something is amiss, yes.','',26124),
(137338,'enUS','I do not feel anything unusual, no.','',26124),
(137339,'enUS','Without a doubt. We should be wary, stranger.','',26124),
(137340,'enUS','Could be, could be. The air is thick with emotion.','',26124),
(137341,'enUS','The Legion is defeated, its master imprisoned. But in his final, spiteful act, Sargeras may have doomed us all.','',26124),
(137342,'enUS','Our world is wounded, champion. Its life essence seeps out into the sands... just as Magni foresaw.','',26124),
(137343,'enUS','This mere drop of Argus\'s blood surges with incredible power. The might of a titan.','',26124),
(137344,'enUS','If the blood of Azeroth also proves to be a source of such strength... those who seek to rule this world will stop at nothing to possess it.','',26124),
(137345,'enUS','The days ahead may be dark indeed. For now... go to Silithus. Gaze upon the wound in the world with your own eyes.','',26124),
(137346,'enUS','We will find a way to save Azeroth, $n. I know it.','',26124),
(137347,'enUS','I am not certain what will come of this, but I feel in my bones that this day is one to remember.','I am not certain what will come of this, but I feel in my bones that this day is one to remember.',26124),
(137348,'enUS','It is good to see so many familiar faces. Many have come to hear Kil\'jaeden speak.','It is good to see so many familiar faces. Many have come to hear Kil\'jaeden speak.',26124),
(137349,'enUS','Quite a gathering, isn\'t it?','Quite a gathering, isn\'t it?',26124),
(137350,'enUS','The Triumvirate\'s wisdom has brought us to this point. I hope they know what they are doing, or this could end poorly...','The Triumvirate\'s wisdom has brought us to this point. I hope they know what they are doing, or this could end poorly...',26124),
(137351,'enUS','What do you think Archimonde and Velen are arguing about?','What do you think Archimonde and Velen are arguing about?',26124),
(137352,'enUS','I am not at all sure about this pronouncement.','I am not at all sure about this pronouncement.',26124),
(137353,'enUS','What a joyous day for the Eredar! We will soon ascend to our rightful place!','What a joyous day for the Eredar! We will soon ascend to our rightful place!',26124),
(137354,'enUS','Praise Kil\'jaeden! Praise Sargeras!','Praise Kil\'jaeden! Praise Sargeras!',26124),
(137355,'enUS','Finally we will know our true destiny! Glory to the Eredar!','Finally we will know our true destiny! Glory to the Eredar!',26124),
(137356,'enUS','Change is coming. This is a very important moment for our people.','',26124),
(137357,'enUS','<Hatuun impassively watches Kil\'jaeden speak.>','',26124),
(137358,'enUS','It has been some time since Kil\'jaeden last addressed his people. This must be an important occasion.','',26124),
(137359,'enUS','Kil\'jaeden will usher in a new era of prosperity for all Eredar. He will be remembered as our greatest leader!','',26124),
(137360,'enUS','What does Kil\'jaeden have planned for us, I wonder?','',26124),
(137361,'enUS','<Talgath watches Archimonde and Velen, only occasionally glancing to Kil\'jaeden.>$b$bHmm.','',26124),
(137362,'enUS','The Triumvirate have guided us for so very long. What does this stranger bring that we did not already have?','',26124),
(137363,'enUS','Have you noticed anything strange about this gathering?','Have you noticed anything strange about this gathering?',26124),
(137364,'enUS','Reveal yourself, demon.','Reveal yourself, demon.',26124),
(137365,'enUS','I am trying to listen. Go away!','I am trying to listen. Go away!',26124),
(137366,'enUS','Preposterous! Begone!','Preposterous! Begone!',26124),
(137367,'enUS','How dare you suggest such a thing!','How dare you suggest such a thing!',26124),
(137368,'enUS','Ah, you caught me. Now die!','Ah, you caught me. Now die!',26124),
(137369,'enUS','No, YOU\'RE a demon!','No, YOU\'RE a demon!',26124),
(137370,'enUS','Very clever. Who would ever suspect a child?','Very clever. Who would ever suspect a child?',26124),
(137371,'enUS','Look how many people there are! Are we going to have a party?','Look how many people there are! Are we going to have a party?',26124),
(137372,'enUS','<The child seems to be crying inconsolably.>','<The child seems to be crying inconsolably.>',26124),
(137415,'enUS','It\'s rough out there for my riders.','',26124),
(137433,'enUS','The weaklings press their assault! Immortal Squadron, attack!','',26124),
(137439,'enUS','N..No! Ahh! Get back! Mine!','',26124),
(137440,'enUS','ow! OW! OW OW OW!!!','',26124),
(137441,'enUS','Err.. no! Back! Back! Away with you!','',26124),
(137442,'enUS','Must get... freeeeeeeeeee!','',26124),
(137443,'enUS','Ah he he he! All mine! Allllllll mine!','',26124),
(137445,'enUS','My things! Must... warn... the others...','',26124),
(137467,'enUS','My people lost their world to the void years ago and were scattered to the winds. I have a feeling some old friends are soon to show their faces on Argus.$b$bNot literally, of course.','',26124),
(137468,'enUS','Why is an ethereal traveling on a ship full of draenei?','Why is an ethereal traveling on a ship full of draenei?',26124),
(137469,'enUS','You should know something, friend $r. T\'paartos did not choose $n because of your puniness.','',26124),
(137470,'enUS','T\'paartos saw $n\'s heart on the field of battle. You are the bravest $c T\'paartos has ever seen.','',26124),
(137471,'enUS','Other children were... not always kind to T\'paartos.','',26124),
(137473,'enUS','Without enough power, I had to make a few... improvisations. They did not make me the grand artificer for no reason! Overloading the matrix core, refactoring the...$b$bIt matters not. What does matter is that the cannon will do its job. We will destroy the gates of Antorus and defeat the Legion.$b$bAre you ready, $n?','',26124),
(137474,'enUS','Fire!','Fire!',26124),
(137481,'enUS','Ah he he he! What a lovely day for meeeeeee!','',26124),
(137503,'enUS','','<It would seem her watch has finally ended.>',26124),
(137507,'enUS','Curse your soul!','Curse your soul!',26124),
(137510,'enUS','Kill you! Take your things!','Kill you! Take your things!',26124),
(137511,'enUS','Yes, yes more trinkets, give them to me!','Yes, yes more trinkets, give them to me!',26124),
(137512,'enUS','T\'paartos remembers a place like this...','',26124),
(137513,'enUS','T\'paartos was lost for days.','',26124),
(137514,'enUS','Come. T\'paartos thinks he knows what little T\'paartos might do.','',26124),
(137518,'enUS','','How\'d a runt like you get so FAT, T\'paartos?',26124),
(137519,'enUS','Fatty probably doesn\'t understand the question \'cause he\'s so STUPID!','',26124),
(137520,'enUS','','Aww, the fat runt is crying!',26124),
(137521,'enUS','Hahahaha! What a BABY!','',26124),
(137522,'enUS','Should we go after him?','',26124),
(137524,'enUS','','Nah. Let tubby go play with his frogs.',26124),
(137539,'enUS','','How delightful... a snack before my main course!',26124),
(137564,'enUS','The Orders are sharing their resources, and you are no longer required to research Artifact Knowledge. Together, we have researched all possible Artifact Knowledge.','The Orders are sharing their resources, and you are no longer required to research Artifact Knowledge. Together, we have researched all possible Artifact Knowledge.',26124),
(137565,'enUS','<View Aggramar\'s Rise.>','<View Aggramar\'s Rise.>',26124),
(137566,'enUS','<View the Breaking of the Pantheon.>','<View the Breaking of the Pantheon.>',26124),
(137567,'enUS','<View the Life-Binder\'s Plea.>','<View the Life-Binder\'s Plea.>',26124),
(137598,'enUS','The Orders are sharing their resources, and you are no longer required to research Artifact Knowledge. Together, we have researched all possible Artifact Knowledge.','The Orders are sharing their resources, and you are no longer required to research Artifact Knowledge. Together, we have researched all possible Artifact Knowledge.',26124),
(137599,'enUS','','This land has gone through many hardships in the past but the final story of this grand temple has yet to be revealed. $B$BIf you wish to relive days gone by, I can allow you to visit the past for a short time.',26124),
(137600,'enUS','Show me the Peak of Serenity before the Legion attacked.','Show me the Peak of Serenity before the Legion attacked.',26124),
(137611,'enUS','I will transform you, granting you knowledge beyond imagining and might beyond measure.','',26124),
(137612,'enUS','But they were blinded by their vanity... their hunger for power.','',26124),
(137613,'enUS','We would be transformed not into wise leaders, but into hateful monsters.','',26124),
(137617,'enUS','|TInterface\\Icons\\warrior_talent_icon_mastercleaver.blp:20|tSotanathor\'s axe sends out |cFFFF0000|Hspell:181498|h[Wakes of Destruction]|h|r!','|TInterface\\Icons\\warrior_talent_icon_mastercleaver.blp:20|tSotanathor\'s axe sends out |cFFFF0000|Hspell:181498|h[Wakes of Destruction]|h|r!',26124),
(137644,'enUS','Do you know anyone by the name \"Locus-Walker\"?','Do you know anyone by the name \"Locus-Walker\"?',26124),
(137645,'enUS','<Vashreen makes a noise that is certainly not complimentary.>$b$bI know that a disreputable individual by that name sought me out as a financier of a project that sounded profitable, and has never repaid my investment.','',26124),
(137648,'enUS','','<The essence of Eonar hovers before you. You sense both relief and gratitude; but a sense of urgency and purpose cuts short the joy of victory.>',26124),
(137650,'enUS','Send me back to Antorus.','Send me back to Antorus.',26124),
(137679,'enUS','T\'paartos loved to talk to animals. They listened and liked him.','',26124),
(137680,'enUS','When T\'paartos was scared, he found a place to hide.','',26124),
(137681,'enUS','T\'paartos loved to dig and find things.','',26124),
(137682,'enUS','T\'paartos remembers a place like this one. A time he dug too deep.','',26124),
(137683,'enUS','T\'paartos ran and ran. Got lost for days.','',26124),
(137684,'enUS','Even shadows looked like monsters to T\'paartos.','',26124),
(137685,'enUS','Finally, T\'paartos decided to stop being so afraid of dark and left cave.','',26124),
(137686,'enUS','This place reminds T\'paartos of another time he went where he wasn\'t supposed to.','',26124),
(137687,'enUS','Not all flowers were just flowers.','',26124),
(137688,'enUS','But moving flowers not always bad! They just want to eat bugs.','',26124),
(137698,'enUS','Yes, I want to test myself against the toughest that Argus has to offer.','Yes, I want to test myself against the toughest that Argus has to offer.',26124),
(137717,'enUS','|TInterface\\Icons\\SPELL_NATURE_SLEEP:20|t%s targets you with a |cFFFF0000|Hspell:254244|h[Sleep Canister]|h|r!','',26124),
(137723,'enUS','Bring me the eyes of every demon you can, off-worlder. I shall reward you handsomely.','',26124),
(137724,'enUS','Another agent pledges to serve? More eyes, more visions for the All-Seer.','',26124),
(137725,'enUS','Scoop the eyes from demon skulls, off-worlder. I would see what they see.','',26124),
(137726,'enUS','Are ye ready, $p?','',26124),
(137727,'enUS','Every demon\'s eyes have seen a thousand worlds. Fetch them for me, that I too may see.','',26124),
(137729,'enUS','I\'m ready.','I\'m ready.',26124),
(137735,'enUS','You may not enter while disguised!','You may not enter while disguised!',26124),
(137738,'enUS','Intruder!','Intruder!',26124),
(137739,'enUS','Heretic!','Heretic!',26124),
(137740,'enUS','Interloper!','Interloper!',26124),
(137741,'enUS','Traitor!','Traitor!',26124),
(137786,'enUS','<Stay awhile and listen.>','<Stay awhile and listen.>',26124),
(137791,'enUS','This is what the Legion does to its \"allies\"...$b$bWe were right to reject their offer.','',26124),
(137792,'enUS','If only Oculeth were here. He would have had a field day studying this ship.$b$b...$b$bAnd probably have figured out a way to destroy it by now. You are right, probably for the best that he did not come with us.','',26124),
(137793,'enUS','I do hope that Arluelle is keeping up her lessons. I gave her a small list of exercises to do every day.$b$bInterested? It\'s quite simple. One hundred push ups. One hundred sit ups. One hundred squats. A ten thousand, nine hundred thirty-six yard run.','',26124),
(137794,'enUS','The treasure is guarded by powerful magic. Only one shrouded in the right sort of power can access it.','The treasure is guarded by powerful magic. Only one shrouded in the right sort of power can access it.',26124),
(137795,'enUS','The spell guarding the treasure falls away as the Shroud of Arcane Echoes covers you.','The spell guarding the treasure falls away as the Shroud of Arcane Echoes covers you.',26124),
(137796,'enUS','Only the chosen of the Shroud may have this treasure.','Only the chosen of the Shroud may have this treasure.',26124),
(137797,'enUS','I wonder how everyone is doing back in Suramar. I am sure they have everything under control.$b$bI do miss sparring with Victoire, though. She is a worthy opponent.','',26124),
(137798,'enUS','These lightforged draenei have spent lifetimes fighting the Legion. Perhaps even I could learn a thing or two from them.$b$bPerhaps.','',26124),
(137799,'enUS','<Silgryn seems to be deep in thought, as he is even more stoic and silent than usual.>','',26124),
(137800,'enUS','','The Legion will meet its end here. The Light is with us.',26124),
(137801,'enUS','','Look at this, $c. A ship, powered by the Light. An army of soldiers, empowered and as long-lived as the elves. Truly a worthy force for this crusade.',26124),
(137802,'enUS','','Would that I could have brought more of our blood knights. We could learn much from these warriors.',26124),
(137803,'enUS','','We have sworn to defeat the Legion. One battlefield is much like any other, even if it is on a completely different world.',26124),
(137804,'enUS','','I cannot believe I set foot on a different world yet again. From the worlds of Draenor and Outland to the one overtaken by the Legion where we chased down Gul\'dan and Teron\'gor, it still takes my breath away. Argus is a grim lesson that we cannot lose to the Legion.',26124),
(137809,'enUS','They are growing well, considering how close we are to the Conservatory. Give it a month and they will be powerful enough to light a home for a lifetime. Another year and they can act as a sentry.$b$b<He rests a hand on a nearby crystal\'s surface. The crystal glows gently as a result.>$b$bI grow the finest crystals anywhere.','They are growing well, considering how close we are to the Conservatory. Give it a month and they will be powerful enough to light a home for a lifetime. Another year and they can act as a sentry.$b$b<She rests a hand on a nearby crystal\'s surface. The crystal glows gently as a result.>$b$bI grow the finest crystals anywhere.',26124),
(137811,'enUS','I named it Flapper!','I named it Flapper!',26124),
(137812,'enUS','Take him down!','Take him down!',26124),
(137813,'enUS','What a move!','What a move!',26124),
(137814,'enUS','Did you see that?','Did you see that?',26124),
(137815,'enUS','That had to hurt.','That had to hurt.',26124),
(137816,'enUS','Who do you think will win?','Who do you think will win?',26124),
(137817,'enUS','Excellent!','Excellent!',26124),
(137818,'enUS','What a clash!','What a clash!',26124),
(137819,'enUS','The competition is fierce this year. The victor will have much to be proud of.','',26124),
(137820,'enUS','I would not worry too much about their heads. Only males with the thickest crests choose to compete, and these are the best Mac\'Aree has to offer.','I would not worry too much about their heads. Only males with the thickest crests choose to compete, and these are the best Mac\'Aree has to offer.',26124),
(137821,'enUS','I had a hand in picking the trophy for this tournament. I think our winner will be very pleased with their prize.','I had a hand in picking the trophy for this tournament. I think our winner will be very pleased with their prize.',26124),
(137822,'enUS','I have participated in a round or two of Jed\'hin in my life, but these competitors are far better than I could ever hope to be. I must admit, I am envious! Haha!','',26124),
(137823,'enUS','One of my men is competing. A fine fighter! He is no Champion Vorusk, but a worthy combatant in this tournament nonetheless.','',26124),
(137824,'enUS','They\'re so big! Boom! Crash! Pow!\n\n<Naielle animatedly mimics their motions.>','They\'re so big! Boom! Crash! Pow!\n\n<Naielle animatedly mimics their motions.>',26124),
(137825,'enUS','Charming little game, is it not? I like to think we must practice such a basic ritual to remind ourselves how far we have come. Argus has much to be proud of.','',26124),
(137831,'enUS','<He appears to be talking to himself.>\n\nPerhaps if I invert the pulse rate and direct it into a vertical pylon, I can... What am I saying? That makes no sense.','<She appears to be talking to herself.>\n\nPerhaps if I invert the pulse rate and direct it into a vertical pylon, I can... What am I saying? That makes no sense.',26124),
(137832,'enUS','<He frantically turns pages in a massive tome.>\n\nHow am I ever going to memorize all of this?','<She frantically turns pages in a massive tome.>\n\nHow am I ever going to memorize all of this?',26124),
(137833,'enUS','I should have become an Artificer like my mother wanted.','I should have become an Artificer like my mother wanted.',26124),
(137834,'enUS','I hope I am selected to be a Wakener. Soulbinding is fascinating magic, and I get to work with Vigilants. Perhaps I can even inhabit one myself some day, like Quoram.\n\nThen again, I do like eating food... Maybe not...','I hope I am selected to be a Wakener. Soulbinding is fascinating magic, and I get to work with Vigilants. Perhaps I can even inhabit one myself some day, like Quoram.\n\nThen again, I do like eating food... Maybe not...',26124),
(137835,'enUS','Do you think Aargon will let me switch to Consular? I don\'t think I\'m very good at this at all. Surely I can manage a familiar or two at least!','Do you think Aargon will let me switch to Consular? I don\'t think I\'m very good at this at all. Surely I can manage a familiar or two at least!',26124),
(137836,'enUS','I am home. I have been lost for so long, stranded on a strange world with strange people... There are no words for this moment.','',26124),
(137837,'enUS','Long ago, the withering slaves of the Annihilan Pits held their ground in a rebellious effort to free the people of Krokuun from their bonds.$B$BThese shackles remind the inhabitants of Krokuun of the struggles endured to retain what semblance of freedom remains.','',26124),
(137838,'enUS','Crafted by an ancient Krokul smith, the scythe\'s markings reveal a strenuous history of battle between the Burning Legion and the Krokul.$B$BIts foggy, shale-colored blade is chipped, speckled with a darkened, dried liquid around the blade\'s edge.$B$BThe taut handle crafted from talbuk hide is well-worn, with a slight imprint of where its owner\'s grip once wielded this magnificent tool-turned-weapon into battle.','',26124),
(137839,'enUS','Most of the flora on Argus has long succumbed to its inevitable demise, though a once-journeyed cavern, whose location was never truly revealed, yielded this magnificent specimen.$B$BSince its arrival, the aura surrounding this mysterious plant has yet to dim below the level of a radiantly glowing crystal, once a prominent fixture among the Argussian landscape, but now only a memory of stories past.','',26124),
(137840,'enUS','The ink is marred from endless eons of weathering, rendering the text illegible.','',26124),
(137841,'enUS','Tales often echo throughout the hovel\'s porous, rocky surroundings. Whispers of brave krokul scouts - those responsible for locating survivors after the Burning Legion made their mark upon this world.$B$BOne such tale speaks of an encounter with one of the Dark One\'s fel-emblazoned demon lords whose size was only surpassed by its power to wield destruction.$B$BThis monstrous, horned skull cap is all that remains. A reminder to the Krokul people that tales often begin with eager exploration in search of hope, and often end in grievous distress and suffering, but sometimes... victory.','',26124),
(137842,'enUS','I cannot believe what has befallen our world.$b$bLooking out there, I see nothing but hatred. Nothing but desolation.$b$bPart of me is glad that I must stay here aboard the Vindicaar. I would not want to set hoof on that accursed ground.$b$bI have locked in coordinates below our position, close enough for you to establish the teleporter. Let me know when you have finished your preparations.','',26124),
(137843,'enUS','Mac\'Aree... it looks just like how I remember it. The forests, the hills, the herds of talbuk...$b$bI wonder if my old workshop is still down there. Do you think if you had a moment, you could ...?$b$bForgive me. You have much more important things to do. Let me know when you are ready to go to the surface.','',26124),
(137844,'enUS','I am ready, Romuul.','I am ready, Romuul.',26124),
(137845,'enUS','Long after the emerald flame took our home, the Legion took to open a gate to a new world. Never had they lusted for any conquest as much as this lush, primitive land.\n\nJust as their armies set forth, a green-skinned warrior stepped through the gate. He wielded a single blade -- and roared a single cry for battle.\n\nMountains of flesh and bone grew as he carved through the demons\' ranks. His defiance drew the attention of the Dark One -- who came to see his end.\n\nThe warrior struck but one blow before he fell, but it was never forgotten.','',26124),
(137846,'enUS','A new world, if it can be called that.$b$bSo this is what the Legion wishes to do to Azeroth...','',26124),
(137847,'enUS','We are here to provide what support we can. Good luck out there, champion.','',26124),
(137848,'enUS','What a remarkable vessel. It seems to use the crystals the draenei are so fond of to stay afloat. Perhaps we can use these crystals to store arcane powers as well?','',26124),
(137849,'enUS','Fel magic has permeated this entire world. It is difficult to say if there is any part of it that isn\'t corrupted.','',26124),
(137850,'enUS','<Aethas seems to be bothered by something.>','',26124),
(137852,'enUS','After Illidan opened the way to Argus, I was sure that we had made a grave mistake. Now, I believe there is hope.$b$bI must believe there is hope.','',26124),
(137854,'enUS','The lightforged appear to be infused with the very essence of the Light. It is no wonder they have been such a powerful force against the Legion.','',26124),
(137855,'enUS','One by one, we have defeated the mightiest agents of the Legion. But now we must face their true power...','',26124),
(137856,'enUS','I do hope the other members of the Council of Six are all right. I mean, of course they\'re going to be fine. They are all powerful archmagi! Yes. This is fine.','',26124),
(137858,'enUS','I have faced the Legion on Azeroth and Draenor, even witnessed their corruption seeping through the timeways.\n\nBut until the rift to Argus opened, I could never have conceived the true depths of their evil. To see how they have twisted this world...\n\nThey will do the same to Azeroth unless we stop them.','',26124),
(137863,'enUS','','So many demons, so many targets...',26124),
(137864,'enUS','','It is truly remarkable how much time has passed, even for an elf. Surely much has changed on Azeroth in our absence.',26124),
(137870,'enUS','','The Vindicaar is truly a marvel of the Light, a symbol of what the eredar were. What the draenei still are. Although, do take note that not all of the rooms are as magnificent as this. Some of them are quite confining.',26124),
(137871,'enUS','','<Alleria gives you a wry smile.>$b$bAnother beautiful day on Argus.$b$bAlthough, now that I can see our home in the sky, I am filled with hope. Returning home is no longer a dream. It is a certainty.',26124),
(137872,'enUS','It is nice to see new, friendly faces. It has been so long since I have seen another $Gman:woman; from Azeroth!','',26124),
(137873,'enUS','The Army of the Light will not rest until we have destroyed the Burning Legion.','',26124),
(137874,'enUS','It is a joy beyond words to look up in the sky and see Azeroth once more. Home, so close that I feel like I can reach up and touch it.$b$bBut within the grasp of the Legion. We must stop them before we can plan on returning.','',26124),
(137875,'enUS','I have seen you taking an interest in our warframes, champion. They are truly fearsome instruments of war, capable of dealing and withstanding much damage. They are even capable of flight, although we need to keep a low profile to avoid attracting the attention of the Legion.','',26124),
(137876,'enUS','I am glad that Khadgar chose to accompany you. His is the only face among your cohort that I recognize. Has it truly been so long?$b$b<Turalyon\'s gaze shifts away from you.>$b$bHah! I can see he still hasn\'t changed. Speak his name and...','',26124),
(137877,'enUS','','<You catch Alleria out of the corner of your eye. She\'s looking at your bow.>',26124),
(137904,'enUS','Watch your step, mortal.','',26124),
(137914,'enUS','I wouldn\'t go that way if I were you...','',26124),
(137915,'enUS','Some demons enjoy standing in the fire... you should try it sometime.','',26124),
(137916,'enUS','Don\'t mind me, just watching your every move.','',26124),
(137917,'enUS','Don\'t stop what you\'re doing on my account. I\'ll be right here.','',26124),
(137918,'enUS','So this is what passes for skill among mortals? Interesting...','',26124),
(137919,'enUS','Ah, I\'ve seen this before. It didn\'t work out for the last guy.','',26124),
(137920,'enUS','Why wait for your friends? You are a strong, powerful mortal!','',26124),
(137921,'enUS','Oh finally, something worth watching! Go on then, entertain me.','',26124),
(137922,'enUS','A fresh set of eyes... just what I needed.','',26124),
(137934,'enUS','It has been so very long since I have laid eyes on this place. The memories... overwhelm me.','',26124),
(137935,'enUS','What happened here, Prophet?','What happened here, Prophet?',26124),
(137936,'enUS','Did you mean to do that?','',26124),
(137937,'enUS','Where did Thaumaturge Vashreen go with the Relinquished items?','Where did Thaumaturge Vashreen go with the Relinquished items?',26124),
(137938,'enUS','','Vashreen? He mentioned something about procuring new items and relocating to the Vindicaar on Argus.',26124),
(137939,'enUS','','What just happened? Did he... kill her?',26124),
(137940,'enUS','I cannot believe my eyes...','',26124),
(137941,'enUS','','That was... unexpected. To think he had enough power to destroy her...',26124),
(137942,'enUS','What will we do now?','',26124),
(137943,'enUS','By the Light...','',26124),
(137944,'enUS','<Turalyon is staring grimly at Illidan.>','',26124),
(137945,'enUS','','Thank you for coming. I have my suspicions about these spirits here, but I will need some of their essence to learn the truth.$b$bTake this attuning crystal and use it near any spirits that seem more solid than others.$b$bBe careful, though-- they may become angered by the attuning.',26124),
(137946,'enUS','<Take the Attuning Crystal.>','<Take the Attuning Crystal.>',26124),
(137947,'enUS','Everyone to the Vindicaar at once!','Everyone to the Vindicaar at once!',26124),
(137948,'enUS','Fall back! We are no longer safe here.','Fall back! We are no longer safe here.',26124),
(137949,'enUS','By the Light... The demons come again! We must evacuate.','By the Light... The demons come again! We must evacuate.',26124),
(137950,'enUS','The camp is about to be overrun. We must get to safety!','The camp is about to be overrun. We must get to safety!',26124),
(137951,'enUS','The demons approach! Everyone to the Vindicaar. Quickly!','The demons approach! Everyone to the Vindicaar. Quickly!',26124),
(137952,'enUS','Demons! Inbound! Get to safety at once!','Demons! Inbound! Get to safety at once!',26124),
(137953,'enUS','The Legion approaches! Seek cover!','The Legion approaches! Seek cover!',26124),
(137954,'enUS','The demons come! Make haste for the Vindicaar!','The demons come! Make haste for the Vindicaar!',26124),
(137955,'enUS','Weapons at the ready!','Weapons at the ready!',26124),
(137956,'enUS','The demons fast approach! Prepare for battle!','The demons fast approach! Prepare for battle!',26124),
(137957,'enUS','Light guide us... The demons come!','Light guide us... The demons come!',26124),
(137958,'enUS','Pheta thones gamera. Here they come!','Pheta thones gamera. Here they come!',26124),
(137959,'enUS','The skies will be swarming soon enough. Ready your blades!','The skies will be swarming soon enough. Ready your blades!',26124),
(137960,'enUS','Defensive positions! The Legion approaches!','Defensive positions! The Legion approaches!',26124),
(137961,'enUS','Demons incoming! Prepare yourselves!','Demons incoming! Prepare yourselves!',26124),
(137962,'enUS','The demons approach. Hold them off as long as we can!','The demons approach. Hold them off as long as we can!',26124),
(137963,'enUS','The northern skies swell with chaotic energy.','The northern skies swell with chaotic energy.',26124),
(137964,'enUS','The demons approach. Ready your glaives!','The demons approach. Ready your glaives!',26124),
(137965,'enUS','The Burning Legion approaches. Prepare yourselves.','The Burning Legion approaches. Prepare yourselves.',26124),
(137966,'enUS','Stand your ground, Illidari! The demons come.','Stand your ground, Illidari! The demons come.',26124),
(137967,'enUS','The demons come. Ready your blades.','The demons come. Ready your blades.',26124),
(137968,'enUS','Illidari! The Burning Legion\'s presence grows near!','Illidari! The Burning Legion\'s presence grows near!',26124),
(137969,'enUS','The demons swarm the skies, poised to attack. Ready yourselves for battle.','The demons swarm the skies, poised to attack. Ready yourselves for battle.',26124),
(137970,'enUS','%s shimmers as it fades into its surroundings.','',26124),
(137971,'enUS','The Burning Legion encroaches upon our camp. Be ready.','The Burning Legion encroaches upon our camp. Be ready.',26124),
(137972,'enUS','The Burning Legion comes. Ready your glaives.','The Burning Legion comes. Ready your glaives.',26124),
(137973,'enUS','Illidari! Show these demons a quick death.','Illidari! Show these demons a quick death.',26124),
(137974,'enUS','Help these demons meet their end.','Help these demons meet their end.',26124),
(137975,'enUS','Illidari! Stand your ground! The demons will meet their end.','Illidari! Stand your ground! The demons will meet their end.',26124),
(137976,'enUS','Show these demons no mercy!','Show these demons no mercy!',26124),
(137977,'enUS','Give these demons a swift death.','Give these demons a swift death.',26124),
(137978,'enUS','Bring these demons down!','Bring these demons down!',26124),
(137979,'enUS','Strike true! Show these demons no mercy!','Strike true! Show these demons no mercy!',26124),
(137980,'enUS','Relieve these demons of their existence!','Relieve these demons of their existence!',26124),
(137989,'enUS','<Recall the events before the arrival of the Legion>','<Recall the events before the arrival of the Legion>',26124),
(137990,'enUS','<Recall the events on the Broken Isles>','<Recall the events on the Broken Isles>',26124),
(137991,'enUS','<Recall the events of the Tomb of Sargeras>','<Recall the events of the Tomb of Sargeras>',26124),
(137992,'enUS','<Recall the events of Argus>','<Recall the events of Argus>',26124),
(137994,'enUS','<Recall the journey to Argus>','<Recall the journey to Argus>',26124),
(137995,'enUS','<Recall the resurrection of Xe\'ra>','<Recall the resurrection of Xe\'ra>',26124),
(137996,'enUS','<Recall Alleria\'s encounter with the Dark Naruu>','<Recall Alleria\'s encounter with the Dark Naruu>',26124),
(137998,'enUS','<Think back to another time>','<Think back to another time>',26124),
(138000,'enUS','You take Hakmud home and abandon him. Hakmud sees how it is!','',26124),
(138001,'enUS','It is not like Hakmud wanted to see his namesake or anything. Goodbye!','',26124),
(138002,'enUS','Now everybody of Argus. Hakmud did not want to be special anyways!','',26124),
(138003,'enUS','Hakmud never get time to relax. Not even on his own world!','',26124),
(138004,'enUS','Are you going to just leave Hakmud here?','',26124),
(138005,'enUS','The so-called All-Seer sends his pawns to kill me? Hah!','',26124),
(138006,'enUS','My brethren hate me much as they hate you. How... convenient. Bring me their eyes that I may feast on their visions.','',26124),
(138007,'enUS','|TINTERFACE\\ICONS\\INV_GIZMO_FELIRONBOMB.BLP:20|t A |cFFFF0000|Hspell:244722|h[Shock Grenade]|h|r is attached to you!','|TINTERFACE\\ICONS\\INV_GIZMO_FELIRONBOMB.BLP:20|t A |cFFFF0000|Hspell:244722|h[Shock Grenade]|h|r is attached to you!',26124),
(138010,'enUS','All right, everybody... Hold on!','',26124),
(138076,'enUS','','Well done.',26124),
(138077,'enUS','','Most impressive.',26124),
(138078,'enUS','','Congratulations are in order.',26124),
(138079,'enUS','','Attack my enemy!',26124),
(138080,'enUS','','Assist me!',26124),
(138081,'enUS','','Strike my target!',26124),
(138082,'enUS','','This way.',26124),
(138083,'enUS','','I will lead you.',26124),
(138084,'enUS','','Follow me.',26124),
(138085,'enUS','','Heal me!',26124),
(138086,'enUS','','I am in need of healing!',26124),
(138087,'enUS','','Greetings.',26124),
(138088,'enUS','','The Void calls to us.',26124),
(138089,'enUS','','The path to power is clear.',26124),
(138090,'enUS','','We do not fear the unknown.',26124),
(138091,'enUS','','Retreat!',26124),
(138092,'enUS','','Get back!',26124),
(138093,'enUS','','Recede into shadow!',26124),
(138094,'enUS','','Aid me!',26124),
(138095,'enUS','','Your assistance, please!',26124),
(138096,'enUS','','Danger approaches!',26124),
(138097,'enUS','','My mana is low.',26124),
(138098,'enUS','','I need more mana.',26124),
(138099,'enUS','','Hold nothing back!',26124),
(138100,'enUS','','Fire upon them!',26124),
(138101,'enUS','','They say the Void hungers. Let\'s start off with a bit of nibbling.',26124),
(138102,'enUS','','Get nice and close. Whispers are kinda my thing.',26124),
(138103,'enUS','','Are you checking out my void form?',26124),
(138104,'enUS','','There is a void in my heart. Have you come to fill it?',26124),
(138105,'enUS','','Who needs the Light? It\'s so much more fun in the dark.',26124),
(138106,'enUS','','You cannot a-void my charms.',26124),
(138107,'enUS','','The Void isn\'t the only thing that\'s insatiable.',26124),
(138108,'enUS','','Always remain focused.',26124),
(138109,'enUS','','Resist the whispers.',26124),
(138110,'enUS','','Walk in shadow.',26124),
(138111,'enUS','','Remember Alleria\'s teachings.',26124),
(138112,'enUS','','I do not agree.',26124),
(138113,'enUS','','Never!',26124),
(138114,'enUS','','No.',26124),
(138115,'enUS','','No, we do not drink blood--that\'s the San\'layn. Totally different emo elf.',26124),
(138116,'enUS','','First was high, then blood, and now void. Get the order right.',26124),
(138117,'enUS','','Who does my hair? You might have heard of my stylist. It\'s called THE VOID.',26124),
(138124,'enUS','','Gloomy? I\'m not gloomy. I just dress that way... and talk that way... and act that way.',26124),
(138125,'enUS','','You think YOU have a dark side? Elf, please.',26124),
(138126,'enUS','','Well, yes, technically the Void does want to consume the entire cosmos. But I\'ll settle for a smaller bite... for now.',26124),
(138127,'enUS','','No matter how much you plead, I will not sprout tentacles or turn into a giant eyeball. Well, I might. But not because you asked.',26124),
(138128,'enUS','','I am most grateful.',26124),
(138129,'enUS','','Many thanks.',26124),
(138130,'enUS','','I am in your debt.',26124),
(138131,'enUS','','Remain here.',26124),
(138132,'enUS','','Do not move.',26124),
(138133,'enUS','','Yes.',26124),
(138134,'enUS','','Correct.',26124),
(138135,'enUS','','Acknowledged.',26124),
(138136,'enUS','','My pleasure.',26124),
(138137,'enUS','','Glad to help.',26124),
(138138,'enUS','','Of course.',26124),
(138139,'enUS','','My weapon requires both hands.',26124),
(138140,'enUS','','I do not have that ability yet.',26124),
(138141,'enUS','','I cannot wield that yet.',26124),
(138142,'enUS','','That ability is not ready.',26124),
(138143,'enUS','','I cannot do that yet.',26124),
(138144,'enUS','','Not ready yet.',26124),
(138145,'enUS','','That one cannot join this group.',26124),
(138146,'enUS','','I cannot put that there.',26124),
(138147,'enUS','','That bag is full.',26124),
(138148,'enUS','','I cannot do that here.',26124),
(138149,'enUS','','I cannot drop that.',26124),
(138150,'enUS','','That is bound to me.',26124),
(138151,'enUS','','I will never be able to equip that.',26124),
(138152,'enUS','','I am not high enough level to use that.',26124),
(138153,'enUS','','I cannot use that yet.',26124),
(138154,'enUS','','My skill level is not high enough to equip that.',26124),
(138155,'enUS','','I cannot learn that spell.',26124),
(138156,'enUS','','I cannot trade that.',26124),
(138157,'enUS','','I cannot use that.',26124),
(138158,'enUS','','I cannot loot that right now.',26124),
(138159,'enUS','','I do not have a target.',26124),
(138160,'enUS','','I need to target something first.',26124),
(138161,'enUS','','I require a target.',26124),
(138162,'enUS','','I cannot do that.',26124),
(138163,'enUS','','I need permission first.',26124),
(138164,'enUS','','I cannot attack that target.',26124),
(138165,'enUS','','I cannot attack that.',26124),
(138166,'enUS','','My inventory is full.',26124),
(138167,'enUS','','I cannot carry more.',26124),
(138168,'enUS','','I cannot use that item yet.',26124),
(138169,'enUS','','It is not ready yet.',26124),
(138170,'enUS','','That item is still recharging.',26124),
(138171,'enUS','','That is locked.',26124),
(138172,'enUS','','I am unable to carry more of those.',26124),
(138173,'enUS','','I cannot loot that.',26124),
(138174,'enUS','','That is not mine to take.',26124),
(138175,'enUS','','I need to get closer.',26124),
(138176,'enUS','','It is too far away.',26124),
(138177,'enUS','','I cannot reach that.',26124),
(138178,'enUS','','That is not equipped.',26124),
(138179,'enUS','','That must be equipped first.',26124),
(138180,'enUS','','I am out of ammunition.',26124),
(138181,'enUS','Not enough energy.','',26124),
(138182,'enUS','','I lack sufficient energy.',26124),
(138183,'enUS','','I need mana first.',26124),
(138184,'enUS','','My mana is low.',26124),
(138185,'enUS','','Mana is needed.',26124),
(138186,'enUS','','Not enough rage.',26124),
(138187,'enUS','','I must have more rage.',26124),
(138188,'enUS','','That is not a bag.',26124),
(138189,'enUS','','I lack the required funds.',26124),
(138190,'enUS','','That is beyond my means.',26124),
(138191,'enUS','','Too expensive.',26124),
(138192,'enUS','','I cannot equip that.',26124),
(138193,'enUS','','Too far away.',26124),
(138194,'enUS','','I am out of range.',26124),
(138195,'enUS','','I must get closer.',26124),
(138196,'enUS','','We cannot invite anyone else.',26124),
(138197,'enUS','','I cannot drink more at this time.',26124),
(138198,'enUS','','That spell is not yet ready.',26124),
(138199,'enUS','','I cannot cast that yet.',26124),
(138201,'enUS','','That is recharging.',26124),
(138215,'enUS','','<Applause sounds>',26124),
(138216,'enUS','','Please!',26124),
(138217,'enUS','','<Chicken sounds>',26124),
(138218,'enUS','','<Crying sounds>',26124),
(138219,'enUS','','<Kiss sound>',26124),
(138220,'enUS','','<Laughing sounds>',26124),
(138221,'enUS','','Right.',26124),
(138222,'enUS','','A sound idea.',26124),
(138223,'enUS','','Agreed.',26124),
(138225,'enUS','','<Making a raspberry sound--Pfffthblth!>',26124),
(138226,'enUS','','<Train noises--chugga chugga choo choo!>',26124),
(138227,'enUS','','<Short cheer--Wooooo!>',26124),
(138228,'enUS','','<Slightly longer cheer--Woohoo!>',26124),
(138229,'enUS','','To battle!',26124),
(138230,'enUS','','For Alleria!',26124),
(138231,'enUS','','In shadow find strength!',26124),
(138236,'enUS','','Our foes will fall!',26124),
(138237,'enUS','','The whispers cannot claim us!',26124),
(138239,'enUS','','<Roar of dominance>',26124),
(138241,'enUS','','<Variant roar>',26124),
(138243,'enUS','','Not enough fury.',26124),
(138244,'enUS','','My fury is low.',26124),
(138245,'enUS','','Not enough pain.',26124),
(138246,'enUS','','My pain is low.',26124),
(138251,'enUS','','For the Alliance!',26124),
(138252,'enUS','','<Jumping off ground: Total 3>',26124),
(138253,'enUS','','<Breathe as if you are running: Total 3>',26124),
(138254,'enUS','','<Convey summoning power. Energy buildup: Total 5-7>',26124),
(138255,'enUS','','<Release spell, throwing energy: Total 3-5>',26124),
(138256,'enUS','','<Laughing>',26124),
(138257,'enUS','','<Deep breath before focusing magic: Total 3>',26124),
(138258,'enUS','','<Release after expending magic: Total 3>',26124),
(138259,'enUS','','<Vocalized cheer: Total 3>',26124),
(138260,'enUS','','<Distressed cry: Total 3>',26124),
(138261,'enUS','','<Falling from high terrain. Impending injury or death: Total 1>',26124),
(138262,'enUS','<Falling from high terrain. Impending injury or death: Total 1>','',26124),
(138265,'enUS','','<Long attack with wind up. Jump attacks: Total 5-7>',26124),
(138267,'enUS','','<Charging to attack enemy: Total 5-7>',26124),
(138268,'enUS','','<Standard attack: Total 10>',26124),
(138270,'enUS','','<Big attack: Total 5>',26124),
(138271,'enUS','','<Player takes significant wound: Total 5>',26124),
(138272,'enUS','','<Player takes a wound: Total 10>',26124),
(138274,'enUS','','<Dying sounds: Total 5>',26124),
(138277,'enUS','','<Convey releasing power or charging enemy: Total 4-6>',26124),
(138284,'enUS','','<Crying sounds, variant>',26124),
(138285,'enUS','','<Crying sounds, variant.>',26124),
(138286,'enUS','','I ask for kindness!',26124),
(138287,'enUS','','Have mercy!',26124),
(138289,'enUS','','<Yawning sound>',26124),
(138290,'enUS','','<Sighing sound>',26124),
(138318,'enUS','Of course.','',26124),
(138319,'enUS','Glad to help.','',26124),
(138320,'enUS','My pleasure.','',26124),
(138322,'enUS','Correct.','',26124),
(138323,'enUS','Yes.','',26124),
(138325,'enUS','Do not move.','',26124),
(138326,'enUS','Remain here.','',26124),
(138327,'enUS','<Train noises--chugga chugga choo choo!>','',26124),
(138328,'enUS','I am in your debt.','',26124),
(138329,'enUS','Many thanks.','',26124),
(138330,'enUS','I am most grateful.','',26124),
(138331,'enUS','<Sighing sound>','',26124),
(138332,'enUS','<Making a raspberry sound--Pfffthblth!>','',26124),
(138333,'enUS','I need mana.','',26124),
(138334,'enUS','I must gain mana.','',26124),
(138335,'enUS','Fire upon them!','',26124),
(138336,'enUS','Hold nothing back!','',26124),
(138337,'enUS','Agreed.','',26124),
(138338,'enUS','A sound idea.','',26124),
(138339,'enUS','Right.','',26124),
(138340,'enUS','Not possible.','',26124),
(138341,'enUS','Of course not.','',26124),
(138342,'enUS','I disagree.','',26124),
(138343,'enUS','<Laughing>','',26124),
(138344,'enUS','<Laughing sounds>','',26124),
(138345,'enUS','<Kiss sound>','',26124),
(138346,'enUS','Danger is near.','',26124),
(138347,'enUS','Aid me at once!','',26124),
(138348,'enUS','I need help!','',26124),
(138349,'enUS','The shadows are all around us.','',26124),
(138350,'enUS','Do you come seeking power?','',26124),
(138351,'enUS','I serve in darkness.','',26124),
(138352,'enUS','Well met.','',26124),
(138353,'enUS','I need healing!','',26124),
(138354,'enUS','My wounds are great!','',26124),
(138355,'enUS','Alleria will show us the way.','',26124),
(138356,'enUS','May the shadows conceal you.','',26124),
(138357,'enUS','Do not surrender your will.','',26124),
(138358,'enUS','Do not stray from the path.','',26124),
(138359,'enUS','<Applause sounds>','',26124),
(138360,'enUS','Attack this target!','',26124),
(138361,'enUS','On my target!','',26124),
(138362,'enUS','Focus your strikes!','',26124),
(138363,'enUS','Please!','',26124),
(138364,'enUS','I beg you!','',26124),
(138365,'enUS','Mercy... Mercy!','',26124),
(138366,'enUS','<Yawning sound>','',26124),
(138367,'enUS','To battle!','',26124),
(138368,'enUS','For Alleria!','',26124),
(138369,'enUS','Strike from the shadows!','',26124),
(138370,'enUS','Bring down our foes!','',26124),
(138371,'enUS','Our rivals will fall!','',26124),
(138372,'enUS','<Short cheer--Wooooo!>','',26124),
(138374,'enUS','<Slightly longer cheer--Woohoo!>','',26124),
(138375,'enUS','<Chicken sounds>','',26124),
(138376,'enUS','A fine job.','',26124),
(138377,'enUS','Impressive indeed.','',26124),
(138378,'enUS','Congratulations.','',26124),
(138379,'enUS','<Crying sounds>','',26124),
(138380,'enUS','<Crying sounds, variant>','',26124),
(138381,'enUS','<Crying sounds, variant.>','',26124),
(138382,'enUS','<Distressed cry: Total 3>','',26124),
(138384,'enUS','My weapon requires both hands.','',26124),
(138385,'enUS','That ability is not ready.','',26124),
(138386,'enUS','I cannot do that yet.','',26124),
(138387,'enUS','Not ready yet.','',26124),
(138388,'enUS','I cannot put that there.','',26124),
(138389,'enUS','That bag is full.','',26124),
(138390,'enUS','I cannot do that here.','',26124),
(138391,'enUS','I cannot drop that.','',26124),
(138392,'enUS','That is bound to me.','',26124),
(138393,'enUS','I cannot equip that.','',26124),
(138394,'enUS','I am not high enough level to use that.','',26124),
(138395,'enUS','I cannot use that yet.','',26124),
(138396,'enUS','My skill level is not high enough to equip that.','',26124),
(138397,'enUS','I will never be able to equip that.','',26124),
(138398,'enUS','I cannot learn that spell.','',26124),
(138399,'enUS','I cannot loot that.','',26124),
(138400,'enUS','That is not mine to take.','',26124),
(138401,'enUS','I need to get closer.','',26124),
(138402,'enUS','It is too far away.','',26124),
(138403,'enUS','I cannot reach that.','',26124),
(138404,'enUS','I cannot trade that.','',26124),
(138405,'enUS','I cannot use that.','',26124),
(138406,'enUS','That is not equipped.','',26124),
(138407,'enUS','That must be equipped first.','',26124),
(138408,'enUS','I cannot loot that right now.','',26124),
(138409,'enUS','I do not have a target.','',26124),
(138410,'enUS','I need to target something first.','',26124),
(138411,'enUS','I require a target.','',26124),
(138412,'enUS','I cannot do that.','',26124),
(138413,'enUS','I need permission first.','',26124),
(138414,'enUS','I cannot attack that target.','',26124),
(138415,'enUS','I cannot attack that.','',26124),
(138416,'enUS','My inventory is full.','',26124),
(138417,'enUS','I cannot carry more.','',26124),
(138418,'enUS','That is locked.','',26124),
(138419,'enUS','I am unable to carry more of those.','',26124),
(138420,'enUS','I cannot use that item yet.','',26124),
(138421,'enUS','It is not ready yet.','',26124),
(138422,'enUS','For the Alliance!','',26124),
(138423,'enUS','Follow.','',26124),
(138424,'enUS','I will take the lead.','',26124),
(138425,'enUS','Come this way.','',26124),
(138440,'enUS','Acknowledged.','',26124),
(138441,'enUS','I know what you\'re thinking... \"Oh goody, another elf.\" Well... I bet you weren\'t expecting a VOID elf, now were you?','',26124),
(138442,'enUS','If you\'re looking for tall dark, and brooding, that\'s me. Well, dark and brooding, at least.','',26124),
(138443,'enUS','Say what you will about the tenets of the Void. At least it\'s an ethos!','',26124),
(138444,'enUS','Would you believe purple has always been my favorite color? Even before I went void, I mean.','',26124),
(138445,'enUS','Alleria is my favorite Windrunner sister. Edgier than Vereesa, but slightly less homicidal than the dead one.','',26124),
(138446,'enUS','The fact that I wield void energies doesn\'t mean I plan to consume everything I see. After all, I have a figure to maintain.','',26124),
(138447,'enUS','Old Gods... I mean, really? Some have mouths for eyes, others have eyes for mouths. Talk about a hot mess...','',26124),
(138452,'enUS','That item is still recharging.','',26124),
(138453,'enUS','Not enough fury.','',26124),
(138454,'enUS','My fury is low.','',26124),
(138455,'enUS','Not enough pain.','',26124),
(138456,'enUS','My pain is low.','',26124),
(138457,'enUS','That is not a bag.','',26124),
(138458,'enUS','I lack the required funds.','',26124),
(138459,'enUS','That is beyond my means.','',26124),
(138460,'enUS','Too expensive.','',26124),
(138461,'enUS','That one cannot join this group.','',26124),
(138462,'enUS','I am out of ammunition.','',26124),
(138463,'enUS','I lack sufficient energy.','',26124),
(138464,'enUS','I need mana first.','',26124),
(138465,'enUS','My mana is low.','',26124),
(138466,'enUS','Mana is needed.','',26124),
(138467,'enUS','Not enough rage.','',26124),
(138468,'enUS','I must have more rage.','',26124),
(138469,'enUS','Too far away.','',26124),
(138470,'enUS','I am out of range.','',26124),
(138471,'enUS','I must get closer.','',26124),
(138472,'enUS','We cannot invite anyone else.','',26124),
(138473,'enUS','I cannot drink more at this time.','',26124),
(138474,'enUS','I do not have that ability yet.','',26124),
(138475,'enUS','I cannot wield that yet.','',26124),
(138476,'enUS','That spell is not yet ready.','',26124),
(138477,'enUS','I cannot cast that yet.','',26124),
(138478,'enUS','That is recharging.','',26124),
(138479,'enUS','<Release after expending magic: Total 3>','',26124),
(138480,'enUS','<Deep breath before focusing magic: Total 3>','',26124),
(138481,'enUS','<Jumping off ground: Total 3>','',26124),
(138482,'enUS','<Breathe as if you are running: Total 3>','',26124),
(138483,'enUS','<Vocalized cheer: Total 3>','',26124),
(138484,'enUS','Fall back!','',26124),
(138485,'enUS','We must retreat!','',26124),
(138486,'enUS','Withdraw!','',26124),
(138487,'enUS','What am I into? Let\'s just say some of my proclivities can run a bit... dark.','',26124),
(138488,'enUS','I do my best work in the shadows. Allow me to demonstrate.','',26124),
(138489,'enUS','The Void has taught me many secrets. Some of them can be most... satisfying.','',26124),
(138491,'enUS','As a rule, I don\'t sprout tentacles. But in your case, I\'ll make an exception.','',26124),
(138492,'enUS','When studying shadow magic, one learns to be flexible. Very... flexible.','',26124),
(138493,'enUS','You sate my hunger... and I\'ll sate yours.','',26124),
(138522,'enUS','','Silithus has ever been a magnet for ancient, malevolent powers.\n\nI could open a timeway to reveal how the Black Empire once sprawled across these sands. Or show you wars waged between mighty armies.\n\nSo much history. So much pain.\n\nBut that can wait. I believe you are here for another purpose.',26124),
(138523,'enUS','','Silithus was a sickened land before Sargeras struck, but at least there was life within the sands.\n\nIs your business in the past complete, champion?',26124),
(138524,'enUS','Can you show me what Silithus was like before the Wound in the World?','Can you show me what Silithus was like before the Wound in the World?',26124),
(138525,'enUS','Can you return me to the present time?','Can you return me to the present time?',26124),
(138536,'enUS','|TInterface\\ICONS\\ABILITY_WARRIOR_COLOSSUSSMASH.BLP:20|t The Garothi Worldbreaker rears back for |cFFF00000|Hspell:244969|h[Eradication]|h|r! Run away!','',26124),
(138554,'enUS','T\'paartos made friends with critters. Frogs, elekk, bugs... but not snakes. Never snakes!','',26124),
(138557,'enUS','Hmm... There...','',26124),
(138558,'enUS','T\'paartos!','',26124),
(138559,'enUS','We have to fight!','',26124),
(138560,'enUS','For the Light!','',26124),
(138561,'enUS','Face the fists of T\'paartos!','',26124),
(138562,'enUS','You cannot stop T\'paartos!','',26124),
(138563,'enUS','You cannot be real!','',26124),
(138564,'enUS','T\'paartos must see this through!','',26124),
(138565,'enUS','Time to fight!','',26124),
(138569,'enUS','<Standard attack: Total 10>','',26124),
(138579,'enUS','<Big attack: Total 5>','',26124),
(138586,'enUS','<Convey releasing power or charging enemy: Total 4-6>','',26124),
(138590,'enUS','<Release spell, throwing energy: Total 3-5>','',26124),
(138591,'enUS','<Convey summoning power. Energy buildup: Total 5-7>','',26124),
(138592,'enUS','<Charging to attack enemy: Total 5-7>','',26124),
(138593,'enUS','<Dying sounds: Total 5>','',26124),
(138598,'enUS','<Long attack with wind up. Jump attacks: Total 5-7>','',26124),
(138600,'enUS','<Roar of dominance>','',26124),
(138601,'enUS','<Variant roar>','',26124),
(138602,'enUS','<Player takes a wound: Total 10>','',26124),
(138611,'enUS','<Player takes significant wound: Total 5>','',26124),
(138614,'enUS','','Not enough energy.',26124),
(138616,'enUS','','<Changes from normal skin into cosmic purple power skin. Should sound like a forbidden incantation, chant/murmur invoking dark powers. Not painful or stressful: Total 3-5>',26124),
(138617,'enUS','<Changes from normal skin into cosmic purple power skin. Should sound like a forbidden incantation, chant/murmur invoking dark powers. Not painful or stressful: Total 3-5>','',26124),
(138708,'enUS','','Mama? Mama! Why is it so dark? It\'s scary here...',26124),
(138710,'enUS','','C-c-cold...',26124),
(138711,'enUS','','Can anybody hear me?',26124),
(138712,'enUS','','Hello? Who\'s there? I heard you!',26124),
(138713,'enUS','','Ack! A monster!',26124),
(138714,'enUS','','Are you sad too? Are you lost like me?',26124),
(138726,'enUS','I fear this may be the end of me...','',26124),
(138778,'enUS','|TInterface\\Icons\\SPELL_FIRE_FELFIREWARD.BLP:20|tKin\'garoth begins to channel  |cFFFF0000|Hspell:246516|h[Apocalypse Protocol]|h|r!','',26124),
(138780,'enUS','|TInterface\\Icons\\SPELL_FIRE_FELIMMOLATION.BLP:20|tKin\'garoth is about to activate |cFFFF0000|Hspell:248061|h[Purging Protocol]|h|r! Get out!','',26124),
(138835,'enUS','','When you wish to return to Silithus as it appears in the present, you have but to ask.',26124),
(138838,'enUS','','We must continue to stand together, $n. We must not let the dark times divide us.',26124),
(138839,'enUS','','Though I cannot abide the actions of your warchief, $r, we must fight together to save our world.',26124),
(138840,'enUS','Illidan requested that I bring this crystal to you.','Illidan requested that I bring this crystal to you.',26124),
(138842,'enUS','The world cries out to us, $n. We must fight to save it.','',26124),
(138871,'enUS','','I cannot wield that yet.',26124),
(138872,'enUS','','I do not have that ability yet.',26124),
(138873,'enUS','','My weapon requires both hands.',26124),
(138874,'enUS','','Not ready yet.',26124),
(138875,'enUS','','I cannot do that yet.',26124),
(138876,'enUS','','That ability is not ready.',26124),
(138877,'enUS','','I cannot do that here.',26124),
(138878,'enUS','','That bag is full.',26124),
(138879,'enUS','','I cannot put that there.',26124),
(138880,'enUS','','That one cannot join this group.',26124),
(138881,'enUS','','I cannot use that yet.',26124),
(138882,'enUS','','I am not high enough level to use that.',26124),
(138883,'enUS','','I will never be able to equip that.',26124),
(138884,'enUS','','That is bound to me.',26124),
(138885,'enUS','','I cannot drop that.',26124),
(138886,'enUS','','I cannot use that.',26124),
(138887,'enUS','','I cannot trade that.',26124),
(138888,'enUS','','I cannot learn that spell.',26124),
(138889,'enUS','','My skill level is not high enough to equip that.',26124),
(138890,'enUS','','I require a target.',26124),
(138891,'enUS','','I need to target something first.',26124),
(138892,'enUS','','I do not have a target.',26124),
(138893,'enUS','','I cannot loot that right now.',26124),
(138894,'enUS','','I cannot attack that.',26124),
(138895,'enUS','','I cannot attack that target.',26124),
(138896,'enUS','','I need permission first.',26124),
(138897,'enUS','','I cannot do that.',26124),
(138898,'enUS','','That item is still recharging.',26124),
(138899,'enUS','','It is not ready yet.',26124),
(138900,'enUS','','I cannot use that item yet.',26124),
(138901,'enUS','','I cannot carry more.',26124),
(138902,'enUS','','My inventory is full.',26124),
(138903,'enUS','','That is not mine to take.',26124),
(138904,'enUS','','I cannot loot that.',26124),
(138905,'enUS','','I am unable to carry more of those.',26124),
(138906,'enUS','','That is locked.',26124),
(138907,'enUS','','That must be equipped first.',26124),
(138908,'enUS','','That is not equipped.',26124),
(138909,'enUS','','I cannot reach that.',26124),
(138910,'enUS','','It is too far away.',26124),
(138911,'enUS','','I need to get closer.',26124),
(138912,'enUS','','Mana is needed.',26124),
(138913,'enUS','','My mana is low.',26124),
(138914,'enUS','','I need mana first.',26124),
(138915,'enUS','','I lack sufficient energy.',26124),
(138916,'enUS','','I am out of ammunition.',26124),
(138917,'enUS','','That is not a bag.',26124),
(138918,'enUS','','I must have more rage.',26124),
(138919,'enUS','','Not enough rage.',26124),
(138920,'enUS','','I cannot equip that.',26124),
(138921,'enUS','','Too expensive.',26124),
(138922,'enUS','','That is beyond my means.',26124),
(138923,'enUS','','I lack the required funds.',26124),
(138924,'enUS','','Not enough energy.',26124),
(138925,'enUS','','Too far away.',26124),
(138926,'enUS','','I cannot drink more at this time.',26124),
(138927,'enUS','','We cannot invite anyone else.',26124),
(138928,'enUS','','I must get closer.',26124),
(138929,'enUS','','I am out of range.',26124),
(138930,'enUS','','That is recharging.',26124),
(138931,'enUS','','I cannot cast that yet.',26124),
(138932,'enUS','','That spell is not yet ready.',26124),
(138933,'enUS','','<Laughing sounds>',26124),
(138934,'enUS','','<Kiss sound>',26124),
(138935,'enUS','','<Crying sounds>',26124),
(138936,'enUS','','<Chicken sounds>',26124),
(138937,'enUS','','Please!',26124),
(138938,'enUS','','<Applause sounds>',26124),
(138939,'enUS','','Indeed.',26124),
(138940,'enUS','','Just so.',26124),
(138941,'enUS','','Right.',26124),
(138942,'enUS','','<Slightly longer cheer--Woohoo!>',26124),
(138943,'enUS','','<Short cheer--Wooooo!>',26124),
(138944,'enUS','','<Train noises--chugga chugga choo choo!>',26124),
(138945,'enUS','','<Making a raspberry sound--Pfffthblth!>',26124),
(138946,'enUS','','For Highmountain!',26124),
(138948,'enUS','','To victory!',26124),
(138949,'enUS','','For river! For sky! For earth!',26124),
(138950,'enUS','','Attack!',26124),
(138951,'enUS','','To arms!',26124),
(138952,'enUS','','<Variant roar>',26124),
(138953,'enUS','','<Roar of dominance>',26124),
(138954,'enUS','','My pain is low.',26124),
(138955,'enUS','','Not enough pain.',26124),
(138956,'enUS','','My fury is low.',26124),
(138957,'enUS','','Not enough fury.',26124),
(138960,'enUS','','For the Horde!',26124),
(138961,'enUS','','<Laughing>',26124),
(138962,'enUS','','<Release spell, throwing energy: Total 3-5>',26124),
(138963,'enUS','','<Convey summoning power. Energy buildup: Total 5-7>',26124),
(138964,'enUS','','<Breathe as if you are running: Total 3>',26124),
(138965,'enUS','','<Jumping off ground: Total 3>',26124),
(138966,'enUS','','<Falling from high terrain. Impending injury or death: Total 1>',26124),
(138967,'enUS','','<Distressed cry: Total 3>',26124),
(138968,'enUS','','<Vocalized cheer: Total 3>',26124),
(138969,'enUS','','<Release after expending magic: Total 3>',26124),
(138970,'enUS','','<Deep breath before focusing magic: Total 3>',26124),
(138972,'enUS','','<Standard attack: Total 10>',26124),
(138973,'enUS','','<Charging to attack enemy: Total 5-7>',26124),
(138975,'enUS','','<Long attack with wind up. Jump attacks: Total 5-7>',26124),
(138977,'enUS','','<Player takes a wound: Total 10>',26124),
(138978,'enUS','','<Player takes significant wound: Total 5>',26124),
(138979,'enUS','','<Big attack: Total 5>',26124),
(138980,'enUS','','<Convey releasing power or charging enemy: Total 4-6>',26124),
(138983,'enUS','','<Dying sounds: Total 5>',26124),
(138984,'enUS','','<Crying sounds, variant.>',26124),
(138985,'enUS','','<Crying sounds, variant>',26124),
(138986,'enUS','','Show mercy!',26124),
(138987,'enUS','','Won\'t you help?',26124),
(138992,'enUS','','<Sighing sound>',26124),
(138993,'enUS','','<Yawning sound>',26124),
(139019,'enUS','','Attack my enemy!',26124),
(139020,'enUS','','Strike this one!',26124),
(139021,'enUS','','On my target!',26124),
(139022,'enUS','','Nicely done.',26124),
(139023,'enUS','','Impressive indeed.',26124),
(139024,'enUS','','You deserve praise.',26124),
(139028,'enUS','','Get to safety!',26124),
(139030,'enUS','','Get out of here!',26124),
(139031,'enUS','','Seek cover!',26124),
(139032,'enUS','','Follow.',26124),
(139033,'enUS','','Let me lead.',26124),
(139034,'enUS','You are with me.','',26124),
(139035,'enUS','','Sun and moon light your way.',26124),
(139036,'enUS','','Go with blessings.',26124),
(139037,'enUS','','May you hunt well.',26124),
(139038,'enUS','','Remember the Earthmother\'s lessons.',26124),
(139039,'enUS','','Heal me!',26124),
(139040,'enUS','','I need healing!',26124),
(139041,'enUS','','I am honored to greet you.',26124),
(139042,'enUS','','Warm greetings to you.',26124),
(139044,'enUS','','Peace and patience, friend.',26124),
(139045,'enUS','','We will not fear the darkness.',26124),
(139046,'enUS','','Help!',26124),
(139047,'enUS','','I require aid!',26124),
(139048,'enUS','','The enemy comes!',26124),
(139049,'enUS','','I must disagree.',26124),
(139050,'enUS','','No chance!',26124),
(139051,'enUS','','Just... no.',26124),
(139052,'enUS','Fire all weapons!','',26124),
(139053,'enUS','','Bombard them!',26124),
(139054,'enUS','','Mana is needed.',26124),
(139055,'enUS','','I require mana.',26124),
(139057,'enUS','','Do not leave.',26124),
(139059,'enUS','','Hold this spot.',26124),
(139074,'enUS','','A thousand thanks.',26124),
(139075,'enUS','','I am grateful.',26124),
(139076,'enUS','','I owe you a debt.',26124),
(139081,'enUS','','Yes.',26124),
(139082,'enUS','','Correct.',26124),
(139083,'enUS','','It is so.',26124),
(139084,'enUS','','You are welcome.',26124),
(139085,'enUS','','A pleasure.',26124),
(139086,'enUS','','But of course.',26124),
(139087,'enUS','<Applause sounds>','',26124),
(139089,'enUS','Strike at my enemy!','',26124),
(139090,'enUS','Here! This target!','',26124),
(139092,'enUS','Focus on this target!','',26124),
(139094,'enUS','Please!','',26124),
(139095,'enUS','I implore you!','',26124),
(139096,'enUS','Mercy, great one!','',26124),
(139098,'enUS','<Yawning sound>','',26124),
(139099,'enUS','The battle begins!','',26124),
(139100,'enUS','Now! Attack!','',26124),
(139101,'enUS','For the mountain!','',26124),
(139102,'enUS','Never yield!','',26124),
(139103,'enUS','Charge!','',26124),
(139104,'enUS','<Short cheer--Wooooo!>','',26124),
(139105,'enUS','<Slightly longer cheer--Woohoo!>','',26124),
(139106,'enUS','<Chicken sounds>','',26124),
(139107,'enUS','Job well done.','',26124),
(139108,'enUS','I am impressed.','',26124),
(139109,'enUS','Well deserved.','',26124),
(139110,'enUS','<Crying sounds>','',26124),
(139111,'enUS','<Crying sounds, variant>','',26124),
(139112,'enUS','<Crying sounds, variant.>','',26124),
(139114,'enUS','My weapon requires both hands.','',26124),
(139115,'enUS','That ability is not ready.','',26124),
(139116,'enUS','I cannot do that yet.','',26124),
(139117,'enUS','Not ready yet.','',26124),
(139118,'enUS','I cannot put that there.','',26124),
(139119,'enUS','That bag is full.','',26124),
(139120,'enUS','I cannot do that here.','',26124),
(139121,'enUS','I cannot drop that.','',26124),
(139122,'enUS','That is bound to me.','',26124),
(139123,'enUS','I cannot equip that.','',26124),
(139124,'enUS','I am not high enough level to use that.','',26124),
(139125,'enUS','I cannot use that yet.','',26124),
(139126,'enUS','My skill level is not high enough to equip that.','',26124),
(139127,'enUS','I will never be able to equip that.','',26124),
(139128,'enUS','I cannot learn that spell.','',26124),
(139129,'enUS','I cannot loot that.','',26124),
(139130,'enUS','That is not mine to take.','',26124),
(139131,'enUS','I need to get closer.','',26124),
(139132,'enUS','It is too far away.','',26124),
(139133,'enUS','I cannot reach that.','',26124),
(139134,'enUS','I cannot trade that.','',26124),
(139135,'enUS','I cannot use that.','',26124),
(139136,'enUS','That is not equipped.','',26124),
(139137,'enUS','That must be equipped first.','',26124),
(139138,'enUS','I cannot loot that right now.','',26124),
(139139,'enUS','I do not have a target.','',26124),
(139140,'enUS','I need to target something first.','',26124),
(139141,'enUS','I require a target.','',26124),
(139142,'enUS','I cannot do that.','',26124),
(139143,'enUS','I need permission first.','',26124),
(139144,'enUS','I cannot attack that target.','',26124),
(139145,'enUS','I cannot attack that.','',26124),
(139146,'enUS','My inventory is full.','',26124),
(139147,'enUS','I cannot carry more.','',26124),
(139148,'enUS','That is locked.','',26124),
(139149,'enUS','I am unable to carry more of those.','',26124),
(139150,'enUS','I cannot use that item yet.','',26124),
(139151,'enUS','It is not ready yet.','',26124),
(139152,'enUS','That item is still recharging.','',26124),
(139153,'enUS','Not enough fury.','',26124),
(139154,'enUS','My fury is low.','',26124),
(139155,'enUS','Not enough pain.','',26124),
(139156,'enUS','My pain is low.','',26124),
(139157,'enUS','That is not a bag.','',26124),
(139158,'enUS','I lack the required funds.','',26124),
(139159,'enUS','That is beyond my means.','',26124),
(139160,'enUS','Too expensive.','',26124),
(139161,'enUS','That one cannot join this group.','',26124),
(139170,'enUS','I am out of ammunition.','',26124),
(139171,'enUS','Not enough energy.','',26124),
(139172,'enUS','I lack sufficient energy.','',26124),
(139173,'enUS','I need mana first.','',26124),
(139174,'enUS','My mana is low.','',26124),
(139175,'enUS','Mana is needed.','',26124),
(139176,'enUS','Not enough rage.','',26124),
(139177,'enUS','I must have more rage.','',26124),
(139178,'enUS','Too far away.','',26124),
(139179,'enUS','I am out of range.','',26124),
(139180,'enUS','I must get closer.','',26124),
(139181,'enUS','We cannot invite anyone else.','',26124),
(139182,'enUS','I cannot drink more at this time.','',26124),
(139183,'enUS','I do not have that ability yet.','',26124),
(139184,'enUS','I cannot wield that yet.','',26124),
(139185,'enUS','That spell is not yet ready.','',26124),
(139186,'enUS','I cannot cast that yet.','',26124),
(139187,'enUS','That is recharging.','',26124),
(139188,'enUS','<Standard attack: Total 10>','',26124),
(139199,'enUS','<Big attack: Total 5>','',26124),
(139208,'enUS','<Convey releasing power or charging enemy: Total 4-6>','',26124),
(139211,'enUS','<Convey summoning power. Energy buildup: Total 3-5>','',26124),
(139212,'enUS','<Charging to attack enemy: Total 5-7>','',26124),
(139213,'enUS','<Dying sounds: Total 5>','',26124),
(139218,'enUS','<Release after expending magic: Total 3>','',26124),
(139219,'enUS','<Falling from high terrain. Impending injury or death: Total 1>','',26124),
(139220,'enUS','<Deep breath before focusing magic: Total 3>','',26124),
(139221,'enUS','<Jumping off ground: Total 3>','',26124),
(139222,'enUS','<Long attack with wind up. Jump attacks: Total 5-7>','',26124),
(139224,'enUS','<Roar of dominance>','',26124),
(139225,'enUS','<Variant roar>','',26124),
(139226,'enUS','<Breathe as if you are running: Total 3>','',26124),
(139227,'enUS','<Vocalized cheer: Total 3>','',26124),
(139228,'enUS','<Player takes a wound: Total 10>','',26124),
(139237,'enUS','<Player takes significant wound: Total 5>','',26124),
(139242,'enUS','Time to flee!','',26124),
(139243,'enUS','Sound the retreat!','',26124),
(139244,'enUS','We must escape!','',26124),
(139245,'enUS','Follow me.','',26124),
(139246,'enUS','I will take the lead.','',26124),
(139256,'enUS','Tyrande... Long ago, you trusted me enough to defy Malfurion\'s wishes and free me from my prison.','',26124),
(139257,'enUS','But over time, that faith was lost. And like my brother, you came to believe that the choices I made had driven me to darkness.','',26124),
(139258,'enUS','Know that every path I took led toward a single purpose: saving our world. I could abide no half measures. No compromise.','',26124),
(139259,'enUS','At those times when I faced doubt, I held true to one constant. One anchor. You.','',26124),
(139260,'enUS','You have always embodied the best of Azeroth, Tyrande. Your faith. Your devotion. Through the darkest times, my belief in you never wavered.','',26124),
(139261,'enUS','My fate, my duty, are now clear to me. I leave Azeroth\'s defense to you... and to my brother.','',26124),
(139262,'enUS','Take care of him, Tyrande. Though at times I wished your heart had made a different choice, in the end... I know it made the right one.','',26124),
(139263,'enUS','Malfurion... Even in the womb, we grappled with one another. Struggle has followed us all our lives.','',26124),
(139264,'enUS','The teachings of Cenarius were always your path. I felt... another calling.','',26124),
(139265,'enUS','It was power I sought... but not to conquer or rule. It was a means to an end... to save Azeroth from an unstoppable foe.','',26124),
(139266,'enUS','You never trusted my intentions... though I suppose I did not make it easy for you.','',26124),
(139267,'enUS','But now, as my fate becomes clear, I wish to quiet the strife that has long divided us.','',26124),
(139268,'enUS','Even when the Legion is gone, new threats will arise. There is no one I trust to face them more than you, brother.','',26124),
(139269,'enUS','You have spent a lifetime fighting for the dream of what Azeroth could be. Now you must fight for what it is.','',26124),
(139270,'enUS','Take care of Tyrande. Listen to her counsel. She was always the best of us.','',26124),
(139271,'enUS','The road ahead will be long. Whatever comes, bring honor to the name... Stormrage.','',26124),
(139273,'enUS','','In my lifetime, I have twice witnessed a sundering of the world. Mother Moon, I pray I do not see a third.',26124),
(139274,'enUS','','I sense a sorcerer\'s touch upon this crystal.',26124),
(139275,'enUS','','When I learned that he was alive, leading the fight against the Legion on the Broken Shore... I could not bring myself to speak to him.',26124),
(139276,'enUS','','The time for talk has passed. It seems he has a duty to fulfill... as do we. Let us be about it, champion.',26124),
(139277,'enUS','My brother made selfish choices. Caused pain to so many. His transgressions are... difficult to forgive.','',26124),
(139278,'enUS','And yet... there were times when we fought for a common cause. A shared purpose. Those were good days.','',26124),
(139279,'enUS','But now is not the time to ponder personal regrets. We must see to healing the world, champion.','',26124),
(139280,'enUS','The soul of our world is in agony...','',26124),
(139296,'enUS','You have witnessed echoes of my past, hero. I ask your help to put these final matters to rest.','',26124),
(139297,'enUS','Champion... I would have a word.','',26124),
(139299,'enUS','But enough dwelling on the past. The crystal I left for you to find holds not two messages, but three. The last is for you, champion.','',26124),
(139300,'enUS','The Well of Eternity. I am not one for sentiment... but if anything embodies my commitment to Azeroth, it is the font of power I created so long ago.','',26124),
(139301,'enUS','You have proven your commitment to Azeroth. Your dedication, your sacrifice, rivals my own. But more will be asked of you. So much more.','',26124),
(139302,'enUS','Even now, enemies gather... and the shadows grow darker. From this day forward, the defense of our world... of all we hold dear... rests with you.','',26124),
(139349,'enUS','The crystal... it rings out with a familiar voice.','',26124),
(139352,'enUS','','After Illidan faced defeat atop the Black Temple, I tried to let go of my feelings... my distrust and bitterness.',26124),
(139359,'enUS','','Contrite words. Yet I must wonder whether he truly meant them.',26124),
(139392,'enUS','','<Applause sounds>',26124),
(139393,'enUS','<Applause sounds>','',26124),
(139394,'enUS','','<Applause sounds>',26124),
(139395,'enUS','<Applause sounds>','',26124),
(139396,'enUS','Attack my enemy!','',26124),
(139398,'enUS','','On my target!',26124),
(139399,'enUS','','Here! This target!',26124),
(139400,'enUS','Focus your strikes!','',26124),
(139402,'enUS','','Target my foe!',26124),
(139403,'enUS','Target my enemy!','',26124),
(139404,'enUS','','Strike my foe!',26124),
(139405,'enUS','On this target!','',26124),
(139407,'enUS','','Strike at my enemy!',26124),
(139409,'enUS','Target this one!','',26124),
(139411,'enUS','','This one!',26124),
(139412,'enUS','Focus your strikes!','',26124),
(139413,'enUS','Please!','',26124),
(139414,'enUS','','Please!',26124),
(139415,'enUS','Please!','',26124),
(139416,'enUS','','Please!',26124),
(139417,'enUS','','Show me kindness... please!',26124),
(139418,'enUS','I beg of you!','',26124),
(139419,'enUS','','I implore you!',26124),
(139420,'enUS','Will you not help?','',26124),
(139421,'enUS','Show mercy!','',26124),
(139422,'enUS','','Mercy, please!',26124),
(139423,'enUS','Have mercy!','',26124),
(139424,'enUS','','Mercy... Mercy!',26124),
(139425,'enUS','','<Yawning sound>',26124),
(139426,'enUS','<Yawning sound>','',26124),
(139427,'enUS','','<Yawning sound>',26124),
(139428,'enUS','<Yawning sound>','',26124),
(139429,'enUS','To arms!','',26124),
(139430,'enUS','','Fight!',26124),
(139431,'enUS','For Suramar!','',26124),
(139432,'enUS','','Let the battle commence!',26124),
(139433,'enUS','','By the Light be purged!',26124),
(139434,'enUS','By the Light be purged!','',26124),
(139435,'enUS','','For Suramar!',26124),
(139436,'enUS','For the arcan\'dor!','',26124),
(139437,'enUS','Strike down our enemies!','',26124),
(139438,'enUS','','Let none stand against us!',26124),
(139439,'enUS','','Fight for the Light!',26124),
(139440,'enUS','Light guide our blades!','',26124),
(139441,'enUS','','On to victory!',26124),
(139442,'enUS','We fight together!','',26124),
(139444,'enUS','','Fight as one!',26124),
(139445,'enUS','Remember the Nightwell!','',26124),
(139446,'enUS','','For the Argus that was!',26124),
(139447,'enUS','The Light will never yield!','',26124),
(139448,'enUS','','For Thalyssra!',26124),
(139449,'enUS','Attack!','',26124),
(139450,'enUS','<Short cheer--Wooooo!>','',26124),
(139451,'enUS','','<Short cheer--Wooooo!>',26124),
(139452,'enUS','<Short cheer--Wooooo!>','',26124),
(139453,'enUS','','<Short cheer--Wooooo!>',26124),
(139454,'enUS','','<Slightly longer cheer--Woohoo!>',26124),
(139455,'enUS','<Slightly longer cheer--Woohoo!>','',26124),
(139456,'enUS','','<Slightly longer cheer--Woohoo!>',26124),
(139457,'enUS','<Slightly longer cheer--Woohoo!>','',26124),
(139458,'enUS','<Chicken sounds>','',26124),
(139459,'enUS','','<Chicken sounds>',26124),
(139460,'enUS','<Chicken sounds>','',26124),
(139461,'enUS','','<Chicken sounds>',26124),
(139462,'enUS','','Impressive!',26124),
(139463,'enUS','I congratulate you.','',26124),
(139464,'enUS','','You should be proud.',26124),
(139465,'enUS','Job well done.','',26124),
(139466,'enUS','I must congratulate you.','',26124),
(139467,'enUS','','Outstanding!',26124),
(139468,'enUS','The Light favors you.','',26124),
(139469,'enUS','','You are most blessed.',26124),
(139470,'enUS','','Well done indeed!',26124),
(139471,'enUS','Well done.','',26124),
(139472,'enUS','','Well earned.',26124),
(139473,'enUS','Fortune favors you.','',26124),
(139474,'enUS','<Crying sounds>','',26124),
(139475,'enUS','','<Crying sounds>',26124),
(139476,'enUS','<Crying sounds>','',26124),
(139477,'enUS','','<Crying sounds>',26124),
(139478,'enUS','','<Crying sounds, variant>',26124),
(139479,'enUS','<Crying sounds, variant>','',26124),
(139480,'enUS','','<Crying sounds, variant>',26124),
(139481,'enUS','<Crying sounds, variant>','',26124),
(139483,'enUS','<Crying sounds, variant.>','',26124),
(139484,'enUS','','<Crying sounds, variant.>',26124),
(139485,'enUS','<Crying sounds, variant.>','',26124),
(139486,'enUS','','<Crying sounds, variant.>',26124),
(139487,'enUS','','<Distressed cry: Total 3>',26124),
(139488,'enUS','<Distressed cry: Total 3>','',26124),
(139489,'enUS','','<Distressed cry: Total 3>',26124),
(139490,'enUS','<Distressed cry: Total 3>','',26124),
(139491,'enUS','My weapon requires both hands.','',26124),
(139492,'enUS','','My weapon requires both hands.',26124),
(139493,'enUS','My weapon requires both hands.','',26124),
(139494,'enUS','','My weapon requires both hands.',26124),
(139495,'enUS','','That ability is not ready.',26124),
(139496,'enUS','That ability is not ready.','',26124),
(139497,'enUS','','That ability is not ready.',26124),
(139498,'enUS','That ability is not ready.','',26124),
(139503,'enUS','','I cannot do that yet.',26124),
(139504,'enUS','I cannot do that yet.','',26124),
(139505,'enUS','','I cannot do that yet.',26124),
(139506,'enUS','I cannot do that yet.','',26124),
(139507,'enUS','Not ready yet.','',26124),
(139508,'enUS','','Not ready yet.',26124),
(139509,'enUS','Not ready yet.','',26124),
(139510,'enUS','','Not ready yet.',26124),
(139511,'enUS','','I cannot put that there.',26124),
(139512,'enUS','I cannot put that there.','',26124),
(139513,'enUS','','I cannot put that there.',26124),
(139514,'enUS','I cannot put that there.','',26124),
(139515,'enUS','That bag is full.','',26124),
(139516,'enUS','','That bag is full.',26124),
(139517,'enUS','That bag is full.','',26124),
(139518,'enUS','','That bag is full.',26124),
(139519,'enUS','','I cannot do that here.',26124),
(139520,'enUS','I cannot do that here.','',26124),
(139521,'enUS','','I cannot do that here.',26124),
(139522,'enUS','I cannot do that here.','',26124),
(139526,'enUS','','I cannot drop that.',26124),
(139528,'enUS','I cannot drop that.','',26124),
(139529,'enUS','','I cannot drop that.',26124),
(139530,'enUS','I cannot drop that.','',26124),
(139531,'enUS','That is bound to me.','',26124),
(139532,'enUS','','That is bound to me.',26124),
(139533,'enUS','That is bound to me.','',26124),
(139534,'enUS','','That is bound to me.',26124),
(139535,'enUS','','I cannot equip that.',26124),
(139536,'enUS','I cannot equip that.','',26124),
(139537,'enUS','','I cannot equip that.',26124),
(139538,'enUS','I cannot equip that.','',26124),
(139539,'enUS','I am not high enough level to use that.','',26124),
(139540,'enUS','','I am not high enough level to use that.',26124),
(139541,'enUS','I am not high enough level to use that.','',26124),
(139542,'enUS','','I am not high enough level to use that.',26124),
(139543,'enUS','','I cannot use that yet.',26124),
(139544,'enUS','I cannot use that yet.','',26124),
(139545,'enUS','','I cannot use that yet.',26124),
(139546,'enUS','I cannot use that yet.','',26124),
(139547,'enUS','My skill level is not high enough to equip that.','',26124),
(139548,'enUS','','My skill level is not high enough to equip that.',26124),
(139549,'enUS','My skill level is not high enough to equip that.','',26124),
(139550,'enUS','','My skill level is not high enough to equip that.',26124),
(139551,'enUS','','I will never be able to equip that.',26124),
(139552,'enUS','I will never be able to equip that.','',26124),
(139553,'enUS','','I will never be able to equip that.',26124),
(139554,'enUS','I will never be able to equip that.','',26124),
(139555,'enUS','I cannot learn that spell.','',26124),
(139556,'enUS','','I cannot learn that spell.',26124),
(139557,'enUS','I cannot learn that spell.','',26124),
(139558,'enUS','','I cannot learn that spell.',26124),
(139559,'enUS','','I cannot loot that.',26124),
(139560,'enUS','I cannot loot that.','',26124),
(139561,'enUS','','I cannot loot that.',26124),
(139562,'enUS','I cannot loot that.','',26124),
(139563,'enUS','That is not mine to take.','',26124),
(139564,'enUS','','That is not mine to take.',26124),
(139565,'enUS','That is not mine to take.','',26124),
(139566,'enUS','','That is not mine to take.',26124),
(139568,'enUS','','I need to get closer.',26124),
(139569,'enUS','I need to get closer.','',26124),
(139570,'enUS','','I need to get closer.',26124),
(139571,'enUS','I need to get closer.','',26124),
(139572,'enUS','It is too far away.','',26124),
(139573,'enUS','','It is too far away.',26124),
(139574,'enUS','It is too far away.','',26124),
(139575,'enUS','','It is too far away.',26124),
(139576,'enUS','','I cannot reach that.',26124),
(139577,'enUS','I cannot reach that.','',26124),
(139578,'enUS','','I cannot reach that.',26124),
(139579,'enUS','I cannot reach that.','',26124),
(139580,'enUS','I cannot trade that.','',26124),
(139581,'enUS','','I cannot trade that.',26124),
(139582,'enUS','I cannot trade that.','',26124),
(139583,'enUS','','I cannot trade that.',26124),
(139584,'enUS','','I cannot use that.',26124),
(139585,'enUS','I cannot use that.','',26124),
(139586,'enUS','','I cannot use that.',26124),
(139587,'enUS','I cannot use that.','',26124),
(139588,'enUS','That is not equipped.','',26124),
(139589,'enUS','','That is not equipped.',26124),
(139590,'enUS','That is not equipped.','',26124),
(139591,'enUS','','That is not equipped.',26124),
(139593,'enUS','','That must be equipped first.',26124),
(139594,'enUS','That must be equipped first.','',26124),
(139595,'enUS','','That must be equipped first.',26124),
(139596,'enUS','That must be equipped first.','',26124),
(139597,'enUS','I cannot loot that right now.','',26124),
(139598,'enUS','','I cannot loot that right now.',26124),
(139599,'enUS','I cannot loot that right now.','',26124),
(139600,'enUS','','I cannot loot that right now.',26124),
(139601,'enUS','','I do not have a target.',26124),
(139602,'enUS','I do not have a target.','',26124),
(139603,'enUS','','I do not have a target.',26124),
(139604,'enUS','I do not have a target.','',26124),
(139605,'enUS','I need to target something first.','',26124),
(139606,'enUS','','I need to target something first.',26124),
(139607,'enUS','I need to target something first.','',26124),
(139608,'enUS','','I need to target something first.',26124),
(139609,'enUS','','I require a target.',26124),
(139610,'enUS','I require a target.','',26124),
(139611,'enUS','','I require a target.',26124),
(139612,'enUS','I require a target.','',26124),
(139613,'enUS','I cannot do that.','',26124),
(139614,'enUS','','I cannot do that.',26124),
(139615,'enUS','I cannot do that.','',26124),
(139616,'enUS','','I cannot do that.',26124),
(139617,'enUS','','I need permission first.',26124),
(139618,'enUS','I need permission first.','',26124),
(139619,'enUS','','I need permission first.',26124),
(139620,'enUS','I need permission first.','',26124),
(139621,'enUS','I cannot attack that target.','',26124),
(139622,'enUS','','I cannot attack that target.',26124),
(139623,'enUS','I cannot attack that target.','',26124),
(139624,'enUS','','I cannot attack that target.',26124),
(139625,'enUS','','I cannot attack that.',26124),
(139626,'enUS','','I cannot attack that.',26124),
(139627,'enUS','I cannot attack that.','',26124),
(139628,'enUS','I cannot attack that.','',26124),
(139629,'enUS','My inventory is full.','',26124),
(139630,'enUS','My inventory is full.','',26124),
(139631,'enUS','','My inventory is full.',26124),
(139632,'enUS','','My inventory is full.',26124),
(139633,'enUS','','I cannot carry more.',26124),
(139634,'enUS','I cannot carry more.','',26124),
(139635,'enUS','','I cannot carry more.',26124),
(139636,'enUS','I cannot carry more.','',26124),
(139637,'enUS','That is locked.','',26124),
(139638,'enUS','','That is locked.',26124),
(139639,'enUS','That is locked.','',26124),
(139640,'enUS','','That is locked.',26124),
(139641,'enUS','','I am unable to carry more of those.',26124),
(139642,'enUS','I am unable to carry more of those.','',26124),
(139643,'enUS','','I am unable to carry more of those.',26124),
(139644,'enUS','I am unable to carry more of those.','',26124),
(139645,'enUS','I cannot use that item yet.','',26124),
(139646,'enUS','','I cannot use that item yet.',26124),
(139647,'enUS','I cannot use that item yet.','',26124),
(139648,'enUS','','I cannot use that item yet.',26124),
(139649,'enUS','','It is not ready yet.',26124),
(139650,'enUS','It is not ready yet.','',26124),
(139651,'enUS','','It is not ready yet.',26124),
(139652,'enUS','It is not ready yet.','',26124),
(139653,'enUS','That item is still recharging.','',26124),
(139654,'enUS','','That item is still recharging.',26124),
(139655,'enUS','That item is still recharging.','',26124),
(139656,'enUS','','That item is still recharging.',26124),
(139657,'enUS','','Not enough fury.',26124),
(139658,'enUS','Not enough fury.','',26124),
(139659,'enUS','','Not enough fury.',26124),
(139660,'enUS','Not enough fury.','',26124),
(139661,'enUS','My fury is low.','',26124),
(139662,'enUS','','My fury is low.',26124),
(139663,'enUS','My fury is low.','',26124),
(139664,'enUS','','My fury is low.',26124),
(139665,'enUS','','Not enough pain.',26124),
(139666,'enUS','Not enough pain.','',26124),
(139667,'enUS','','Not enough pain.',26124),
(139668,'enUS','Not enough pain.','',26124),
(139669,'enUS','My pain is low.','',26124),
(139670,'enUS','','My pain is low.',26124),
(139671,'enUS','My pain is low.','',26124),
(139672,'enUS','','My pain is low.',26124),
(139673,'enUS','','That is not a bag.',26124),
(139674,'enUS','That is not a bag.','',26124),
(139675,'enUS','','That is not a bag.',26124),
(139676,'enUS','That is not a bag.','',26124),
(139677,'enUS','I lack the required funds.','',26124),
(139678,'enUS','','I lack the required funds.',26124),
(139679,'enUS','I lack the required funds.','',26124),
(139680,'enUS','','I lack the required funds.',26124),
(139681,'enUS','','That is beyond my means.',26124),
(139682,'enUS','That is beyond my means.','',26124),
(139683,'enUS','','That is beyond my means.',26124),
(139684,'enUS','That is beyond my means.','',26124),
(139685,'enUS','Too expensive.','',26124),
(139686,'enUS','','Too expensive.',26124),
(139687,'enUS','Too expensive.','',26124),
(139688,'enUS','','Too expensive.',26124),
(139689,'enUS','','That one cannot join this group.',26124),
(139690,'enUS','That one cannot join this group.','',26124),
(139691,'enUS','','That one cannot join this group.',26124),
(139692,'enUS','That one cannot join this group.','',26124),
(139693,'enUS','I am out of ammunition.','',26124),
(139694,'enUS','','I am out of ammunition.',26124),
(139695,'enUS','I am out of ammunition.','',26124),
(139696,'enUS','','I am out of ammunition.',26124),
(139697,'enUS','','Not enough energy.',26124),
(139698,'enUS','Not enough energy.','',26124),
(139699,'enUS','','Not enough energy.',26124),
(139700,'enUS','Not enough energy.','',26124),
(139701,'enUS','I lack sufficient energy.','',26124),
(139702,'enUS','','I lack sufficient energy.',26124),
(139703,'enUS','I lack sufficient energy.','',26124),
(139704,'enUS','','I lack sufficient energy.',26124),
(139705,'enUS','','I need mana first.',26124),
(139706,'enUS','I need mana first.','',26124),
(139707,'enUS','','I need mana first.',26124),
(139708,'enUS','I need mana first.','',26124),
(139709,'enUS','My mana is low.','',26124),
(139710,'enUS','','My mana is low.',26124),
(139711,'enUS','My mana is low.','',26124),
(139712,'enUS','','My mana is low.',26124),
(139713,'enUS','','Mana is needed.',26124),
(139714,'enUS','Mana is needed.','',26124),
(139715,'enUS','','Mana is needed.',26124),
(139716,'enUS','Mana is needed.','',26124),
(139717,'enUS','Not enough rage.','',26124),
(139718,'enUS','','Not enough rage.',26124),
(139719,'enUS','Not enough rage.','',26124),
(139720,'enUS','','Not enough rage.',26124),
(139721,'enUS','','I must have more rage.',26124),
(139722,'enUS','I must have more rage.','',26124),
(139723,'enUS','','I must have more rage.',26124),
(139724,'enUS','I must have more rage.','',26124),
(139728,'enUS','Too far away.','',26124),
(139729,'enUS','','Too far away.',26124),
(139730,'enUS','Too far away.','',26124),
(139731,'enUS','','Too far away.',26124),
(139732,'enUS','','I am out of range.',26124),
(139733,'enUS','I am out of range.','',26124),
(139734,'enUS','','I am out of range.',26124),
(139735,'enUS','I am out of range.','',26124),
(139736,'enUS','I must get closer.','',26124),
(139737,'enUS','','I must get closer.',26124),
(139738,'enUS','I must get closer.','',26124),
(139739,'enUS','','I must get closer.',26124),
(139740,'enUS','','We cannot invite anyone else.',26124),
(139741,'enUS','We cannot invite anyone else.','',26124),
(139742,'enUS','','We cannot invite anyone else.',26124),
(139743,'enUS','We cannot invite anyone else.','',26124),
(139744,'enUS','I cannot drink more at this time.','',26124),
(139745,'enUS','','I cannot drink more at this time.',26124),
(139746,'enUS','I cannot drink more at this time.','',26124),
(139747,'enUS','','I cannot drink more at this time.',26124),
(139748,'enUS','','I do not have that ability yet.',26124),
(139749,'enUS','I do not have that ability yet.','',26124),
(139750,'enUS','','I do not have that ability yet.',26124),
(139751,'enUS','I do not have that ability yet.','',26124),
(139752,'enUS','I cannot wield that yet.','',26124),
(139753,'enUS','','I cannot wield that yet.',26124),
(139754,'enUS','I cannot wield that yet.','',26124),
(139755,'enUS','','I cannot wield that yet.',26124),
(139756,'enUS','','That spell is not yet ready.',26124),
(139757,'enUS','That spell is not yet ready.','',26124),
(139758,'enUS','','That spell is not yet ready.',26124),
(139759,'enUS','That spell is not yet ready.','',26124),
(139760,'enUS','I cannot cast that yet.','',26124),
(139761,'enUS','','I cannot cast that yet.',26124),
(139762,'enUS','I cannot cast that yet.','',26124),
(139763,'enUS','','I cannot cast that yet.',26124),
(139764,'enUS','','That is recharging.',26124),
(139765,'enUS','That is recharging.','',26124),
(139766,'enUS','','That is recharging.',26124),
(139767,'enUS','That is recharging.','',26124),
(139768,'enUS','<Standard attack: Total 10>','',26124),
(139769,'enUS','','<Standard attack: Total 10>',26124),
(139770,'enUS','<Standard attack: Total 10>','',26124),
(139771,'enUS','','<Standard attack: Total 10>',26124),
(139808,'enUS','<Big attack: Total 5>','',26124),
(139809,'enUS','','<Big attack: Total 5>',26124),
(139810,'enUS','<Big attack: Total 5>','',26124),
(139811,'enUS','','<Big attack: Total 5>',26124),
(139836,'enUS','','<Convey releasing power or charging enemy: Total 4-6>',26124),
(139837,'enUS','<Convey releasing power or charging enemy: Total 4-6>','',26124),
(139838,'enUS','','<Convey releasing power or charging enemy: Total 4-6>',26124),
(139839,'enUS','<Convey releasing power or charging enemy: Total 4-6>','',26124),
(139848,'enUS','<Release spell, throwing energy: Total 3-5>','',26124),
(139849,'enUS','','<Release spell, throwing energy: Total 3-5>',26124),
(139850,'enUS','<Release spell, throwing energy: Total 3-5>','',26124),
(139851,'enUS','','<Release spell, throwing energy: Total 3-5>',26124),
(139852,'enUS','','<Convey summoning power. Energy buildup: Total 5-7>',26124),
(139853,'enUS','<Convey summoning power. Energy buildup: Total 5-7>','',26124),
(139854,'enUS','','<Convey summoning power. Energy buildup: Total 5-7>',26124),
(139855,'enUS','<Convey summoning power. Energy buildup: Total 5-7>','',26124),
(139856,'enUS','<Charging to attack enemy: Total 5-7>','',26124),
(139857,'enUS','','<Charging to attack enemy: Total 5-7>',26124),
(139858,'enUS','<Charging to attack enemy: Total 5-7>','',26124),
(139859,'enUS','','<Charging to attack enemy: Total 5-7>',26124),
(139860,'enUS','','<Dying sounds: Total 5>',26124),
(139861,'enUS','<Dying sounds: Total 5>','',26124),
(139862,'enUS','','<Dying sounds: Total 5>',26124),
(139863,'enUS','<Dying sounds: Total 5>','',26124),
(139882,'enUS','','<Release after expending magic: Total 3>',26124),
(139883,'enUS','<Release after expending magic: Total 3>','',26124),
(139884,'enUS','<Release after expending magic: Total 3>','',26124),
(139885,'enUS','','<Release after expending magic: Total 3>',26124),
(139886,'enUS','','<Falling from high terrain. Impending injury or death: Total 1>',26124),
(139887,'enUS','<Falling from high terrain. Impending injury or death: Total 1>','',26124),
(139888,'enUS','<Falling from high terrain. Impending injury or death: Total 1>','',26124),
(139889,'enUS','','<Falling from high terrain. Impending injury or death: Total 1>',26124),
(139890,'enUS','','<Deep breath before focusing magic: Total 3>',26124),
(139891,'enUS','<Deep breath before focusing magic: Total 3>','',26124),
(139892,'enUS','<Deep breath before focusing magic: Total 3>','',26124),
(139893,'enUS','','<Deep breath before focusing magic: Total 3>',26124),
(139894,'enUS','','<Jumping off ground: Total 3>',26124),
(139895,'enUS','<Jumping off ground: Total 3>','',26124),
(139896,'enUS','<Jumping off ground: Total 3>','',26124),
(139897,'enUS','','<Jumping off ground: Total 3>',26124),
(139898,'enUS','','<Long attack with wind up. Jump attacks: Total 5-7>',26124),
(139899,'enUS','<Long attack with wind up. Jump attacks: Total 5-7>','',26124),
(139900,'enUS','<Long attack with wind up. Jump attacks: Total 5-7>','',26124),
(139901,'enUS','','<Long attack with wind up. Jump attacks: Total 5-7>',26124),
(139906,'enUS','','<Roar of dominance>',26124),
(139907,'enUS','<Roar of dominance>','',26124),
(139908,'enUS','<Roar of dominance>','',26124),
(139909,'enUS','','<Roar of dominance>',26124),
(139910,'enUS','','<Variant roar>',26124),
(139911,'enUS','<Variant roar>','',26124),
(139912,'enUS','<Variant roar>','',26124),
(139913,'enUS','','<Variant roar>',26124),
(139914,'enUS','','<Breathe as if you are running: Total 3>',26124),
(139915,'enUS','<Breathe as if you are running: Total 3>','',26124),
(139916,'enUS','<Breathe as if you are running: Total 3>','',26124),
(139917,'enUS','','<Breathe as if you are running: Total 3>',26124),
(139918,'enUS','','<Vocalized cheer: Total 3>',26124),
(139919,'enUS','<Vocalized cheer: Total 3>','',26124),
(139920,'enUS','<Vocalized cheer: Total 3>','',26124),
(139921,'enUS','','<Vocalized cheer: Total 3>',26124),
(139926,'enUS','','<Player takes a wound: Total 10>',26124),
(139927,'enUS','<Player takes a wound: Total 10>','',26124),
(139928,'enUS','<Player takes a wound: Total 10>','',26124),
(139929,'enUS','','<Player takes a wound: Total 10>',26124),
(139962,'enUS','','<Player takes significant wound: Total 5>',26124),
(139963,'enUS','<Player takes significant wound: Total 5>','',26124),
(139964,'enUS','<Player takes significant wound: Total 5>','',26124),
(139965,'enUS','','<Player takes significant wound: Total 5>',26124),
(140008,'enUS','Yes.','',26124),
(140009,'enUS','Correct.','',26124),
(140010,'enUS','It is so.','',26124),
(140011,'enUS','Do not leave.','',26124),
(140012,'enUS','Hold this spot.','',26124),
(140013,'enUS','<Train noises--chugga chugga choo choo!>','',26124),
(140014,'enUS','I owe you a debt.','',26124),
(140015,'enUS','I cannot thank you enough.','',26124),
(140016,'enUS','A thousand thanks.','',26124),
(140017,'enUS','You are welcome.','',26124),
(140018,'enUS','A pleasure.','',26124),
(140019,'enUS','But of course.','',26124),
(140020,'enUS','<Sighing sound>','',26124),
(140021,'enUS','<Making a raspberry sound--Pfffthblth!>','',26124),
(140022,'enUS','I require mana.','',26124),
(140023,'enUS','Mana is needed.','',26124),
(140024,'enUS','Bombard them!','',26124),
(140025,'enUS','Open fire!','',26124),
(140026,'enUS','Right.','',26124),
(140028,'enUS','Just so.','',26124),
(140029,'enUS','Indeed.','',26124),
(140032,'enUS','No.','',26124),
(140033,'enUS','I think not.','',26124),
(140034,'enUS','Impermissible.','',26124),
(140035,'enUS','<Laughing>','',26124),
(140036,'enUS','<Laughing sounds>','',26124),
(140037,'enUS','<Kiss sound>','',26124),
(140038,'enUS','An incoming threat!','',26124),
(140039,'enUS','I need assistance!','',26124),
(140040,'enUS','Help me!','',26124),
(140041,'enUS','','Come along.',26124),
(140042,'enUS','For the Horde!','',26124),
(140043,'enUS','','For the Alliance!',26124),
(140044,'enUS','For the Alliance!','',26124),
(140045,'enUS','','For the Horde!',26124),
(140046,'enUS','For the Horde!','',26124),
(140047,'enUS','Goodbye.','',26124),
(140048,'enUS','Earthmother guide your path.','',26124),
(140049,'enUS','May your journey grant wisdom.','',26124),
(140050,'enUS','May the mountain grant you shade and comfort.','',26124),
(140051,'enUS','Heal me!','',26124),
(140052,'enUS','My wounds need tending!','',26124),
(140053,'enUS','Hello.','',26124),
(140054,'enUS','I offer greetings.','',26124),
(140055,'enUS','You are welcome here.','',26124),
(140056,'enUS','We will not fear the darkness.','',26124),
(140057,'enUS','<Kiss sound>','',26124),
(140058,'enUS','','<Kiss sound>',26124),
(140059,'enUS','<Kiss sound>','',26124),
(140060,'enUS','','<Kiss sound>',26124),
(140061,'enUS','','<Laughing sounds>',26124),
(140062,'enUS','<Laughing sounds>','',26124),
(140063,'enUS','','<Laughing sounds>',26124),
(140064,'enUS','<Laughing sounds>','',26124),
(140065,'enUS','<Laughing>','',26124),
(140066,'enUS','','<Laughing>',26124),
(140067,'enUS','<Laughing>','',26124),
(140068,'enUS','','<Laughing>',26124),
(140069,'enUS','','<Making a raspberry sound--Pfffthblth!>',26124),
(140070,'enUS','<Making a raspberry sound--Pfffthblth!>','',26124),
(140071,'enUS','','<Making a raspberry sound--Pfffthblth!>',26124),
(140072,'enUS','<Making a raspberry sound--Pfffthblth!>','',26124),
(140073,'enUS','<Sighing sound>','',26124),
(140074,'enUS','','<Sighing sound>',26124),
(140075,'enUS','<Sighing sound>','',26124),
(140076,'enUS','','<Sighing sound>',26124),
(140077,'enUS','','<Train noises--chugga chugga choo choo!>',26124),
(140078,'enUS','<Train noises--chugga chugga choo choo!>','',26124),
(140079,'enUS','','<Train noises--chugga chugga choo choo!>',26124),
(140080,'enUS','<Train noises--chugga chugga choo choo!>','',26124),
(140086,'enUS','','Yes.',26124),
(140087,'enUS','Yes.','',26124),
(140088,'enUS','','Yes.',26124),
(140089,'enUS','Yes.','',26124),
(140092,'enUS','','Retreat!',26124),
(140093,'enUS','Retreat!','',26124),
(140094,'enUS','','Retreat!',26124),
(140095,'enUS','Retreat!','',26124),
(140096,'enUS','Take cover!','',26124),
(140097,'enUS','','Take cover!',26124),
(140098,'enUS','Find cover!','',26124),
(140099,'enUS','','Take cover!',26124),
(140100,'enUS','','Get out of here!',26124),
(140101,'enUS','Get back!','',26124),
(140102,'enUS','','Get back!',26124),
(140103,'enUS','Get back!','',26124),
(140110,'enUS','Follow me.','',26124),
(140111,'enUS','Follow me.','',26124),
(140112,'enUS','','This way.',26124),
(140113,'enUS','','This way.',26124),
(140114,'enUS','Let me lead.','',26124),
(140115,'enUS','Follow my lead.','',26124),
(140116,'enUS','','I will take the lead.',26124),
(140117,'enUS','','Follow my lead.',26124),
(140118,'enUS','','Come along.',26124),
(140119,'enUS','','Come.',26124),
(140120,'enUS','You are with me.','',26124),
(140121,'enUS','We go this way.','',26124),
(140122,'enUS','','Farewell.',26124),
(140123,'enUS','Farewell.','',26124),
(140124,'enUS','Walk always in the Light.','',26124),
(140125,'enUS','','Walk always in the Light.',26124),
(140126,'enUS','Suramar remembers its champions.','',26124),
(140127,'enUS','','Suramar remembers its champions.',26124),
(140128,'enUS','','May the arcan\'dor\'s gift sustain you.',26124),
(140129,'enUS','May the arcan\'dor\'s gift sustain you.','',26124),
(140130,'enUS','','We will make our place in this world.',26124),
(140131,'enUS','We will make our place in this world.','',26124),
(140132,'enUS','','Serve with valor and humility.',26124),
(140133,'enUS','Serve with valor and humility.','',26124),
(140134,'enUS','Strive for peace, but stand ready for war.','',26124),
(140135,'enUS','','Strive for peace, but stand ready for war.',26124),
(140136,'enUS','Farewell.','',26124),
(140137,'enUS','','Farewell.',26124),
(140138,'enUS','','Heal me!',26124),
(140139,'enUS','Heal me!','',26124),
(140140,'enUS','','Heal me!',26124),
(140141,'enUS','Heal me!','',26124),
(140142,'enUS','I need healing!','',26124),
(140143,'enUS','','I need healing!',26124),
(140144,'enUS','I am in need of healing!','',26124),
(140145,'enUS','','I am in need of healing!',26124),
(140146,'enUS','','Greetings.',26124),
(140147,'enUS','Greetings.','',26124),
(140148,'enUS','','Greetings.',26124),
(140149,'enUS','Greetings.','',26124),
(140150,'enUS','Tenu\'balah.','',26124),
(140151,'enUS','','Tenu\'balah.',26124),
(140152,'enUS','Archenon poros.','',26124),
(140153,'enUS','','Archenon poros.',26124),
(140154,'enUS','','Acheon kor.',26124),
(140155,'enUS','Acheon kor.','',26124),
(140165,'enUS','','Well met.',26124),
(140166,'enUS','Well met.','',26124),
(140167,'enUS','We stand against the darkness.','',26124),
(140168,'enUS','','We stand against the darkness.',26124),
(140169,'enUS','','Suramar stands proud... and free.',26124),
(140170,'enUS','Suramar stands proud... and free.','',26124),
(140171,'enUS','','Help me!',26124),
(140172,'enUS','Help me!','',26124),
(140173,'enUS','Aid me!','',26124),
(140174,'enUS','','Aid me!',26124),
(140175,'enUS','','I need help!',26124),
(140176,'enUS','I need help!','',26124),
(140177,'enUS','','Please help!',26124),
(140178,'enUS','Please help!','',26124),
(140179,'enUS','Danger approaches!','',26124),
(140180,'enUS','','Danger approaches!',26124),
(140182,'enUS','','Danger is near.',26124),
(140183,'enUS','The enemy comes!','',26124),
(140189,'enUS','No.','',26124),
(140190,'enUS','','No.',26124),
(140191,'enUS','','No.',26124),
(140192,'enUS','No.','',26124),
(140193,'enUS','','Of course not.',26124),
(140194,'enUS','Never!','',26124),
(140195,'enUS','I think not.','',26124),
(140196,'enUS','','I think not.',26124),
(140198,'enUS','','Unacceptable.',26124),
(140199,'enUS','Unacceptable.','',26124),
(140201,'enUS','Denied.','',26124),
(140202,'enUS','','Denied.',26124),
(140203,'enUS','','Right.',26124),
(140204,'enUS','Right.','',26124),
(140205,'enUS','Right.','',26124),
(140206,'enUS','','Right.',26124),
(140208,'enUS','','So be it.',26124),
(140209,'enUS','So be it.','',26124),
(140211,'enUS','','Verily.',26124),
(140212,'enUS','Verily.','',26124),
(140214,'enUS','Agreed.','',26124),
(140215,'enUS','','Agreed.',26124),
(140216,'enUS','','Open fire!',26124),
(140219,'enUS','','Fire all weapons!',26124),
(140220,'enUS','','Unleash fury!',26124),
(140221,'enUS','Unleash fury!','',26124),
(140224,'enUS','','Commence bombardment!',26124),
(140225,'enUS','Commence bombardment!','',26124),
(140226,'enUS','Bombard the enemy!','',26124),
(140227,'enUS','','Bombard the enemy!',26124),
(140229,'enUS','','I must gain mana.',26124),
(140230,'enUS','My mana is low.','',26124),
(140231,'enUS','Mana is needed.','',26124),
(140232,'enUS','','Mana is needed.',26124),
(140233,'enUS','','I need mana.',26124),
(140234,'enUS','I need more mana.','',26124),
(140235,'enUS','I require mana.','',26124),
(140236,'enUS','','I require mana.',26124),
(140237,'enUS','','You have my gratitude.',26124),
(140238,'enUS','You have my gratitude.','',26124),
(140239,'enUS','The Light thanks you.','',26124),
(140240,'enUS','','The Light thanks you.',26124),
(140241,'enUS','You have my thanks.','',26124),
(140242,'enUS','','You have my thanks.',26124),
(140243,'enUS','','Thank you, friend.',26124),
(140244,'enUS','Thank you, friend.','',26124),
(140245,'enUS','I am indebted to you.','',26124),
(140246,'enUS','','I am indebted to you.',26124),
(140248,'enUS','','Most generous.',26124),
(140249,'enUS','Most generous.','',26124),
(140250,'enUS','Stay here.','',26124),
(140251,'enUS','','Stay here.',26124),
(140252,'enUS','','Stay right here.',26124),
(140253,'enUS','Stay right here.','',26124),
(140254,'enUS','Maintain this position.','',26124),
(140255,'enUS','','Maintain this position.',26124),
(140256,'enUS','','Wait here.',26124),
(140257,'enUS','Wait here.','',26124),
(140258,'enUS','Without question.','',26124),
(140259,'enUS','','Without question.',26124),
(140260,'enUS','','Affirmative.',26124),
(140261,'enUS','Affirmative.','',26124),
(140263,'enUS','','That is correct.',26124),
(140265,'enUS','That is correct.','',26124),
(140266,'enUS','Unquestionably.','',26124),
(140267,'enUS','','Unquestionably.',26124),
(140268,'enUS','','The pleasure was mine.',26124),
(140269,'enUS','The pleasure was mine.','',26124),
(140270,'enUS','It was my pleasure.','',26124),
(140271,'enUS','','It was my pleasure.',26124),
(140272,'enUS','Think nothing of it.','',26124),
(140273,'enUS','','Think nothing of it.',26124),
(140274,'enUS','','I am honored to serve.',26124),
(140275,'enUS','I am honored to serve.','',26124),
(140276,'enUS','','You are welcome.',26124),
(140277,'enUS','You are welcome.','',26124),
(140278,'enUS','Thanks are not required.','',26124),
(140279,'enUS','','Thanks are not required.',26124),
(140472,'enUS','The moment that the way to Argus opened... the instant my gaze fell upon the Legion\'s home world... I knew I would not be returning from it.','',26124),
(140473,'enUS','I will face my destiny, whatever it may hold. Yet... I have left certain matters unsettled... old wounds that I would see mended.','',26124),
(140474,'enUS','This crystal bears two messages. One is for my brother Malfurion, the other for Tyrande. I am trusting you to deliver them on my behalf, champion.','',26124),
(140475,'enUS','When they have heard my words, leave the crystal atop Mount Hyjal, upon the shores of the Well of Eternity.','',26124),
(140483,'enUS','Thank you for coming, Mayla. It is my honor to welcome you to Mulgore.','',26124),
(140484,'enUS','','Your invitation was most kind, Baine. It is time for our two peoples to renew our bonds of kinship.',26124),
(140485,'enUS','It is of kinship that I wish to speak. I hope that--','',26124),
(140486,'enUS','I should never... have left... the mountain...','',26124),
(140487,'enUS','','Ebonhorn! What dark force grips you?',26124),
(140488,'enUS','I know this power all too well. Champion! We need your help!','',26124),
(140489,'enUS','','I must get Ebonhorn back to Highmountain at once!',26124),
(140490,'enUS','Until we discover what\'s behind this attack, Mulgore will never be safe. I will come with you, Mayla. Let us face this darkness together.','',26124),
(140491,'enUS','','Ebonhorn is not well. We must find a way to bring him back from the brink. Speak with Spiritwalker Graysky. I believe he can help.',26124),
(140492,'enUS','The whispers... they have stopped. Thank you, champion, Graysky.','',26124),
(140494,'enUS','','Today was very nearly a dark day for Azeroth.',26124),
(140495,'enUS','','Had Uul\'gyneth\'s plan succeeded, we all would have been made into servants of the Old Gods... including Ebonhorn.',26124),
(140496,'enUS','I shudder at the thought, Mayla. Without the swift action of Baine and this champion, all would have been lost.','',26124),
(140497,'enUS','','Baine Bloodhoof, you have demonstrated courage, honor, and loyalty. I believe it is time for your people and mine to renew our bonds of kinship.',26124),
(140498,'enUS','','If you will have us, the tauren of Highmountain would be proud to join your Horde.',26124),
(140499,'enUS','The Horde will be honored to welcome you! Let us travel to Orgrimmar and share the good news with our Warchief.','',26124),
(140500,'enUS','','What have you to say, chieftain?',26124),
(140501,'enUS','','Warchief, the strength and courage of the Horde has been demonstrated by Baine Bloodhoof, as well as your champion.',26124),
(140502,'enUS','','I accept your oath of loyalty. The Horde offers its protection... and expects your obedience.',26124),
(140503,'enUS','','From this day forth, Highmountain vows to stand with you against all foes.',26124),
(140504,'enUS','','For the Horde!',26124),
(140505,'enUS','For the Horde!','',26124),
(140506,'enUS','','For the Horde!',26124),
(140644,'enUS','|TInterface\\Icons\\Shaman_PVP_RipplingWaters:20|t%s begins to cast |cFFFF0000|Hspell:255594|h[Sky and Sea]|h|r!','|TInterface\\Icons\\Shaman_PVP_RipplingWaters:20|t%s begins to cast |cFFFF0000|Hspell:255594|h[Sky and Sea]|h|r!',26124),
(140708,'enUS','The might of sea and sky must aid our champions, Golganneth!','',26124),
(140709,'enUS','Let the fury of the sea wash away this corruption!','',26124),
(140710,'enUS','Aggramar! Lend these mortals your strength, brother.','',26124),
(140711,'enUS','One among them shall serve as the vessel for my power, Highfather.','',26124),
(140712,'enUS','Norgannon! Your keen mind may expose our enemy\'s weakness!','',26124),
(140730,'enUS','The rage of the Unmaker surges! Quickly, heroes! Strike down these constructs!','',26124),
(140731,'enUS','The mortals have fallen. The final titan... cannot be saved.','',26124),
(140732,'enUS','Time answers to me, Unmaker! The one force that can bind your relentless fury!','',26124),
(140733,'enUS','No! After all we have endured... It must not end this way!','',26124),
(140734,'enUS','','Hope is not lost, Highfather. The spark of life still flickers within these mortals.',26124),
(140735,'enUS','','Arise, champions! Fight to save your world!',26124),
(140736,'enUS','Khaz\'goroth! Forge these heroes in our image!','',26124),
(140760,'enUS','Using their power, I shall bend the strands of time to aid our cause.','',26124),
(140795,'enUS','Our champions have fallen. Nothing can stop the end of all things.','',26124),
(140797,'enUS','Our cause is lost. The Burning Crusade will consume us all.','',26124),
(140917,'enUS','','|TInterface\\Icons\\SPELL_MAGE_FLAMEORB:20|tA fiery portal to Xoroth opens up!',26124),
(140918,'enUS','','|TInterface\\Icons\\SPELL_HOLY_CONSUMEMAGIC:20|tA shadowy portal to Nathreza opens up!',26124),
(140919,'enUS','','|TInterface\\Icons\\ABILITY_CREATURE_POISON_02:20|tA fel portal to Rancora opens up!',26124),
(140942,'enUS','Admiral Svirax exits her command pod!','Admiral Svirax exits her command pod!',26124),
(140944,'enUS','Chief Engineer Ishkar exits his command pod!','Chief Engineer Ishkar exits his command pod!',26124),
(140945,'enUS','General Erodus exits his command pod!','General Erodus exits his command pod!',26124),
(140952,'enUS','','You must be descended from the naaru... \'cause you\'ve got a heavenly body.',26124),
(140953,'enUS','','Let\'s go back to my ship and twist our nethers.',26124),
(140954,'enUS','I like it with the lights on. Not that I really have a choice...','',26124),
(140968,'enUS','|TINTERFACE\\ICONS\\SPELL_ARCANE_MINDMASTERY.BLP:20|t Your mind is about to succumb to |cFFFF0000|Hspell:244172|h[Psychic Assault]|h|r!','|TINTERFACE\\ICONS\\SPELL_ARCANE_MINDMASTERY.BLP:20|t Your mind is about to succumb to |cFFFF0000|Hspell:244172|h[Psychic Assault]|h|r!',26124),
(140970,'enUS','Has it gotten brighter in here? Because you just turned me on.','',26124),
(140971,'enUS','','When in doubt... touch anything that glows.',26124),
(140972,'enUS','I thought my tattoo said \"Light\'s Defender\" in naaru. I found out it actually says \"glowing goat\".','',26124),
(140973,'enUS','This world of yours is very strange. Talking bears who practice kung fu? On Argus, we call that a circus.','',26124),
(140974,'enUS','After being aboard a ship for so long, it is nice to walk on solid ground again. All those hard surfaces were murder on my hooves!','',26124),
(140975,'enUS','My life for Aiur... <cough> Argus. My life for ARGUS!','',26124),
(140976,'enUS','','No, I do not have a glowing stamp above my tail.',26124),
(140977,'enUS','','Have you met my dog? His name is Barkenon Puppos.',26124),
(140978,'enUS','','Toes are overrated. Hooves make pedicures go sooooo much faster.',26124),
(140979,'enUS','','I don\'t recommend walking barehoof on the Vindicaar. We keep finding tiny shards of crystal that didn\'t get swept up.',26124),
(140980,'enUS','','We haven\'t crashed the Vindicaar yet... but given our track record, it\'s only a matter of time.',26124),
(140981,'enUS','','One downside of being Lightforged is that my S.E.L.F.I.E.S. are always overexposed.',26124),
(140982,'enUS','','Turalyon was the only human I saw for a thousand years. I assumed all of them were grizzled and scarred.',26124),
(140983,'enUS','Your body must be a font of magic, because I\'m irresistibly drawn to it.','',26124),
(140984,'enUS','You must know magic too, because you just made everyone else in the room disappear.','',26124),
(140985,'enUS','You\'ve found the Arcway to my heart.','',26124),
(140986,'enUS','Mmmm, I wanna tap that ley line.','',26124),
(140987,'enUS','I think I\'ve night-fallen for you.','',26124),
(140988,'enUS','I\'ve got a feeling we were night-born for each other.','',26124),
(140989,'enUS','The stars have judged you, and found you... smokin\' hot.','',26124),
(140990,'enUS','Were you picked from the Arcan\'dor? Because you\'re the apple of my eye.','',26124),
(140991,'enUS','','Is that an illusion in your pocket, or are you just happy to see me?',26124),
(140992,'enUS','','No illusions here. Everything you see is real... very real.',26124),
(140994,'enUS','','My Nightwell brings all the boys to the yard.',26124),
(140995,'enUS','','Animate? Detonate? I suggest we skip straight to replicate.',26124),
(140996,'enUS','','I\'ll show you my ley lines if you show me yours.',26124),
(140997,'enUS','','I\'ve been trapped in a bubble with the same guys for 10,000 years. You could say I\'m ready for a little... variety.',26124),
(140998,'enUS','','There\'s no area denial in this raid.',26124),
(140999,'enUS','To be honest, most of the time something was quite right.','',26124),
(141000,'enUS','Why does everyone keep asking me to say that? Ughhhhh. Fine. An Illusion. What are you hiding.','',26124),
(141001,'enUS','My name is Roy, and I\'m a mana addict.','',26124),
(141002,'enUS','It\'s what I do. I drink arcwine... and I know things.','',26124),
(141003,'enUS','Back in my day, there was only one kind of elf. ONE.','',26124),
(141004,'enUS','I don\'t know why they call it the Court of Stars. I hang out there all the time and I never see anyone famous.','',26124),
(141005,'enUS','Let\'s be honest. Keeping a giant, angry dinosaur caged up in a zoo was bound to end badly.','',26124),
(141006,'enUS','','An allusion! What are you implying?',26124),
(141007,'enUS','','Roses are red, our city is fair. Is that a disguise? WHO GOES THERE?',26124),
(141008,'enUS','','Care for a glass of arcwine? I jumped on the berries myself.',26124),
(141009,'enUS','','Tyrande still looks good after all these years. Know if she\'s seeing anyone?',26124),
(141010,'enUS','','I met this kal\'dorei who told me my dress was the pinnacle of fashion... 10,000 years ago. Ouch! Those night elves really know how to throw shade!',26124),
(141011,'enUS','','Night elves? More like country elves! They live in trees, sleep in dens... sometimes even grow antlers. They\'re not cut out for life in a REAL city.',26124),
(141012,'enUS','','You really must attend one of our parties in the Court of Stars. I\'ve never met anyone more in need of a mask.',26124),
(141013,'enUS','Have you ever seen the bunks on the Vindicaar? I can arrange a private tour.','',26124),
(141014,'enUS','Trust me... I have experience at exploring deep places.','',26124),
(141015,'enUS','My totem thunders. All. Night. Long.','',26124),
(141016,'enUS','Beware the deep places... of my heart.','',26124),
(141017,'enUS','Get as rough as you like. I\'ve got a thick hide.','',26124),
(141018,'enUS','You must be an alchemist, because we\'ve got great chemistry.','',26124),
(141020,'enUS','','So... wanna knock antlers?',26124),
(141022,'enUS','','Are you staring at my rack?',26124),
(141023,'enUS','','It\'s not the size of the antlers. It\'s the motion of the totem.',26124),
(141024,'enUS','Why does that draenei couple keep asking me where Rocky is?','',26124),
(141025,'enUS','Let\'s play a game. We take a drink every time a harpy screeches about earth and stone.','',26124),
(141026,'enUS','I may be a simple tauren from the mountains, but at least I don\'t dig through worm dung for loot.','',26124),
(141027,'enUS','Ha! A buddy of mine convinced this epic-geared adventurer to kick fish into the river! Oh wait... that wasn\'t you, was it?','',26124),
(141028,'enUS','A tauren, a yaungol, and a taunka walk into a bar. This isn\'t a joke--it\'s my family reunion.','',26124),
(141029,'enUS','What smells worse than a drogbar? Two drogbar. What smells worse than two drogbar? Nobody knows, because the stench will kill you.','',26124),
(141030,'enUS','Did you just try to hang your hat on my antlers? What do I look like, a coat rack?','',26124),
(141031,'enUS','','What do you get when you feed cocoa to a Highmountain tauren? Chocolate moose!',26124),
(141032,'enUS','','Why are the Rivermane always so calm? Because they\'ve learned to go with the flow.',26124),
(141033,'enUS','','Brrrrr, it\'s cold in here. In the mood for some ice cream?',26124),
(141034,'enUS','','Tauren make the best poets. Their verse is so moooooving.',26124),
(141035,'enUS','','You know the way to a woman\'s heart? Hoof rubs. Trust me on this one, darling.',26124),
(141050,'enUS','Why settle for horns when you could have a rack like this?','',26124),
(141051,'enUS','','He said my eyes were \"milky\". Talk about a mood killer...',26124),
(141052,'enUS','At last... the future I foresaw has come to pass. Thank you for opening the way.','',26124),
(141053,'enUS','','Show yourself! Who are you?',26124),
(141054,'enUS','','Resist the whispers, Umbric! This \"gift\" you are offered is little more than enslavement.',26124),
(141055,'enUS','Rrrrurgaaghh! I feel the power... calling to me... changing me...','',26124),
(141056,'enUS','','Come, $p. We must stop this transformation before my people are lost!',26124),
(141057,'enUS','Names are of little consequence. A more interesting question is... What shall you become?','',26124),
(141058,'enUS','','Now, now... no antler stroking on the first date.',26124),
(141059,'enUS','We are on the same side, Windrunner... no matter what that traitor has taught you.','',26124),
(141060,'enUS','','Your masters will not enslave me, ethereal... nor will they claim my brothers and sisters!',26124),
(141061,'enUS','','This void storm is a conduit... a doorway that must be closed.',26124),
(141062,'enUS','Why do you resist? You stand on the threshold of a grand destiny.','',26124),
(141063,'enUS','','I see through your lies, Durzaan. So will the others.',26124),
(141064,'enUS','Nooooooooooo...','',26124),
(141065,'enUS','','No. These people are not yours. They are not lost.',26124),
(141066,'enUS','Alleria... $p... My people are free, but we have been... changed. And the voices...','',26124),
(141067,'enUS','','Durzaan tried to tear away your mortality. To make you like him--a slave to his hunger.',26124),
(141068,'enUS','','But your fate is still your own, Umbric. I can teach you to quiet the whispers. To make the shadows serve you, instead of you serving them.',26124),
(141069,'enUS','|TInterface\\Icons\\INV_ELEMENTAL_MOTE_SHADOW01:20|tYou are afflicted with |cFFFF0000|Hspell:250669|h[Soulburst]|h|r!','|TInterface\\Icons\\INV_ELEMENTAL_MOTE_SHADOW01:20|tYou are afflicted with |cFFFF0000|Hspell:250669|h[Soulburst]|h|r!',26124),
(141070,'enUS','|TInterface\\Icons\\INV_ELEMENTAL_PRIMAL_SHADOW:20|tYou are afflicted with |cFFFF0000|Hspell:251570|h[Soulbomb]|h|r!','|TInterface\\Icons\\INV_ELEMENTAL_PRIMAL_SHADOW:20|tYou are afflicted with |cFFFF0000|Hspell:251570|h[Soulbomb]|h|r!',26124),
(141091,'enUS','','I\'m not usually into drogbar, but when I see them working out in that brul gym... well, let\'s just say the deep places of the earth get a little steamy.',26124),
(141092,'enUS','If one more of you natives calls me a walking chandelier, I swear I\'ll...','',26124),
(141097,'enUS','At long last, the war is over.\n\nPart of me never expected to survive to see this day. So many battles. So much loss.\n\n<Turalyon sighs, his eyes brimming with a flood of emotions.>\n\nNow we return home to a world I haven\'t walked in a thousand years.\n\nMy old life is long past. It is time to build a new one, and get to know the son who embodies everything I fought for.','',26124),
(141098,'enUS','','My heart soars to return to Azeroth alongside Arator and Turalyon. To see the forests of my homeland once again.\n\nAnd yet...\n\nVereesa told me what has befallen Sylvanas. Though I dread the meeting, I must see with my own eyes what she has become.\n\nIs she even my sister anymore? Or some Light-forsaken monster?\n\nBut of course, I have changed as well. The powers at my command may cause some to question my loyalties.\n\n<Alleria draws in a long breath.>\n\nI must remain calm, focused. There is much to ponder...',26124),
(141099,'enUS','Countless nights I dreamt of returning to Argus. Of seeing what became of my home. Of saving it.\n\n<Velen is quiet for a long moment.>\n\nThere was no salvation to be had. But we did find victory.\n\nWhat comes next, I cannot say. But I will not wait for visions to guide me. I will do all I can to support King Anduin, and to ensure he is prepared to face the threat that looms in the darkness.','',26124),
(141101,'enUS','The campaign against the Legion has been long and wearying. We have traversed entire worlds, spanned the Twisting Nether itself to finally achieve victory.\n\nI am tired, $n. Yet we cannot rest.\n\nMagni\'s visions of doom shake me to my very core. Only one titan remains, champion, and we must defend it.','',26124),
(141102,'enUS','','You\'re still here?\n\n<Ishanah looks at you quizzically.>\n\nIt\'s over. Go home.\n\n<Ishanah waves you away.>\n\nGo!',26124),
(141103,'enUS','','Alleria has changed. She wields powers I do not fully comprehend. But in her heart, she remains my beloved sister. I know it.\n\nThe news of Sylvanas weighs heavily upon her. There are matters to be settled... face to face.\n\nThe Windrunner sisters must meet. And there is only one place it can be done.',26124),
(141104,'enUS','I found them! At long last, I found them.\n\n<Arator\'s smile gives way to a look of uncertainty.>\n\nThe two people who gave me life... have been absent for all of it. I know they fought to keep me safe, that they sacrificed so much. And yet...\n\nWe cannot suddenly become a happy family. They know next to nothing about me, and I know only legends of them. We have much to learn about one another, and many wounds to heal.\n\nBut at least we will do it together.','',26124),
(141105,'enUS','The Vindicaar may have been untested when we set out on this campaign, but she saw us safely home.\n\nAll those ship upgrades were worth it, yes?\n\nDo not answer. It would only break my heart.\n\nA ship\'s engineer\'s work is always underappreciated.','',26124),
(141110,'enUS','','My fellow soldiers, the trials you have endured are proof that the Light shines bright within your hearts.',26124),
(141111,'enUS','','One final test remains--and it is the most daunting of all.',26124),
(141112,'enUS','','It will force you to peer into the very core of what you are. Of what you believe yourself to be.',26124),
(141113,'enUS','','Many worthy draenei have undergone this trial, only to return broken... or worse.',26124),
(141114,'enUS','','Should you feel the slightest doubt, turn back now. It will be counted as wisdom, not cowardice.',26124),
(141115,'enUS','','But if you are truly ready, step forward and embrace your fate.',26124),
(141116,'enUS','','T\'paartos... we have discussed this. Each initiate must be accompanied by a second. Where is yours?',26124),
(141117,'enUS','T\'paartos needs no one to aid him!','',26124),
(141118,'enUS','','The last initiate who attempted the trial alone came back in pieces. Choose a second, or head back to the barracks.',26124),
(141119,'enUS','So be it! T\'paartos shall bring... this puny one!','',26124),
(141120,'enUS','','An unorthodox choice, but... technically within the rules. I have never known $p to back down from a challenge.',26124),
(141121,'enUS','','Let the trial begin. Light be with you both.',26124),
(141122,'enUS','T\'paartos!','',26124),
(141126,'enUS','When the High Exarch ordered me to Azeroth, I was reluctant to leave his side. I felt someone else would be better suited to the task.\n\nNow, though, I understand why he did it. He wanted to give me a glimpse of what he and Lady Alleria have been fighting for.\n\nOur war may be over, but many battles lie ahead. Just because the Legion is defeated doesn\'t mean every demon in existence has surrendered.\n\n<Lothraxion clenches his fist and smiles.>\n\nNot yet, at least.','',26124),
(141128,'enUS','Dalaran above the Broken Isles','Dalaran above the Broken Isles',26124),
(141131,'enUS','','I know Ethel. She\'s actually a very fast walker. She just thinks it\'s funny to mess with tourists.',26124),
(141132,'enUS','','You know, high-altitude living does wonders for one\'s stamina. Allow me to demonstrate...',26124),
(141133,'enUS','','You don\'t need to be from the Skyhorn tribe to join the mile high club.',26124),
(141134,'enUS','','My turn-ons include my eyes, my tattoos, my armor... I mean, what doesn\'t turn on?',26124),
(141135,'enUS','','I may be forged in the Light, but I know how to have fun in the dark.',26124),
(141141,'enUS','<View Aggramar\'s Arrival.>','<View Aggramar\'s Arrival.>',26124),
(141145,'enUS','<View the Escape from Argus.>','<View the Escape from Argus.>',26124),
(141146,'enUS','<View the Triumvirate\'s Decision.>','<View the Triumvirate\'s Decision.>',26124),
(141148,'enUS','<View Light\'s Judgment.>','<View Light\'s Judgment.>',26124),
(141150,'enUS','<View Windrunner\'s Sight.>','<View Windrunner\'s Sight.>',26124),
(141151,'enUS','<View the Crown\'s Blessing.>','<View the Crown\'s Blessing.>',26124),
(141156,'enUS','Sorry if my tattoos look a little dim. I forgot to charge my battery last night.','',26124),
(141157,'enUS','Face tentacles?! We do NOT have face tentacles! If we did, that would mean draenei are secretly emissaries of the Void, gaining your trust as we infiltrate your society so that we can bring about its end. And I\'m certain you\'re not implying THAT... are you?','',26124),
(141158,'enUS','Spiritwalker?!','',26124),
(141159,'enUS','I bring the Light... and also the heat.','',26124),
(141160,'enUS','<Recall your arrival at the Seat of the Pantheon>','<Recall your arrival at the Seat of the Pantheon>',26124),
(141161,'enUS','<Recall the imprisoning of Sargeras>','<Recall the imprisoning of Sargeras>',26124),
(141163,'enUS','I\'m a draenei on the streets... but an eredar in the sheets.','',26124),
(141173,'enUS','','Have you seen Prophet Velen\'s new dance? He calls it the Mac\'Areena.',26124),
(141174,'enUS','','We are Highmountain. Unless you\'re leaving. Then we\'re Goodbye Mountain.',26124),
(141175,'enUS','The Vindicaar is a fast ship. You could say it travels at Light speed.','',26124),
(141176,'enUS','I\'m forming a group of tauren demon hunters. We\'re called the Illi-dairy.','',26124),
(141305,'enUS','|TInterface\\Icons\\SPELL_NATURE_ABOLISHMAGIC.BLP:20|tEonar unleashes her |cFFFF0000|Hspell:250048|h[Life Force]|h|r!','|TInterface\\Icons\\SPELL_NATURE_ABOLISHMAGIC.BLP:20|tEonar unleashes her |cFFFF0000|Hspell:250048|h[Life Force]|h|r !',26124),
(141355,'enUS','','The Void. A force of infinite hunger.',26124),
(141356,'enUS','','Sages and scholars fear the Void.',26124),
(141357,'enUS','','But we understand a truth that they do not.',26124),
(141358,'enUS','','The Void has shaped us... changed us. But you will become its master.',26124),
(141359,'enUS','','We are soldiers.',26124),
(141360,'enUS','','Through millennia of struggle, the Light has shown us the true path.',26124),
(141361,'enUS','','At long last, our enemy has fallen. The Legion is no more. Yet our war is far from over. New threats gather in the shadows, awaiting their moment to strike.',26124),
(141362,'enUS','','You are Lightforged. You must stand as a beacon of hope against the darkness.',26124),
(141363,'enUS','','For ten-thousand years, Suramar was the only world we knew.',26124),
(141364,'enUS','','As the ages passed, Azeroth changed around us... and fell into the Legion\'s grasp.',26124),
(141365,'enUS','','Our leaders betrayed us, striking a bargain with the demons. But we rose up against tyranny... and drove the devils out. Suramar is ours once more, and we will never again let it fall into darkness.',26124),
(141366,'enUS','','To secure our people\'s future, you must help reclaim our place in Azeroth.',26124),
(141369,'enUS','','The regent lord invited the nightborne to Silvermoon. I am to travel to Suramar and escort Lady Thalyssra to the meeting.',26124),
(141370,'enUS','','I am counting on you both. Do not return until Suramar\'s strength is pledged to the Horde.',26124),
(141371,'enUS','','As you command, Warchief. I will meet you at Lady Thalyssra\'s estate in Suramar, $p.',26124),
(141372,'enUS','Lady Liadrin... champion. You are most welcome. As you can see, we have an... unexpected visitor.','',26124),
(141373,'enUS','','Hello again, Liadrin. Champion. Lor\'themar, I am here concerning a matter that might be best addressed in private.',26124),
(141374,'enUS','I see no need to keep secrets from allies, Alleria. In fact, some new friends of ours are just arriving.','',26124),
(141375,'enUS','','First Arcanist Thalyssra and honored guests. Welcome to Silvermoon.',26124),
(141376,'enUS','','It is a pleasure to visit your fine city at last. Thank you for extending the invitation, Regent Lord.',26124),
(141379,'enUS','Please, call me Lor\'themar. But where are my manners? Allow me to introduce another guest: Lady Alleria Windrunner, a hero of Silvermoon\'s past.','',26124),
(141380,'enUS','','An unexpected honor, Lady Windrunner. Silgryn told me of your courage during the campaign on Argus.',26124),
(141381,'enUS','','The honor is mine, First Arcanist. I do not mean to intrude upon your visit. Perhaps I should return another time.',26124),
(141382,'enUS','Nonsense. Whatever you came to say, you may say in front of our guests.','',26124),
(141383,'enUS','','As you wish. I come bearing an offer from High King Anduin Wr--',26124),
(141384,'enUS','I had hoped your visit was motivated by a love for Silvermoon. Instead, you come at the behest of the Alliance\'s boy-king. How disappointing.','',26124),
(141387,'enUS','','Cutting words, Lor\'themar. Are they yours, I wonder, or has the dutiful ranger I knew become the mouthpiece of your warchief?',26124),
(141388,'enUS','You doubt my words, yet how can we trust your own? Do you deny that the lords of the Void whisper to you? Did you not surrender yourself to the shadows on Argus?','',26124),
(141389,'enUS','','It seems the offer I bring has been anticipated... and spurned. Very well. But before I leave, I have one request.',26124),
(141391,'enUS','','It has been a thousand years since I set eyes upon the Sunwell. May I visit it once again?',26124),
(141392,'enUS','I advise against it. We cannot trust that she will not--','',26124),
(141393,'enUS','Whatever she has become, Alleria is a daughter of Quel\'Thalas. I will not deny her pilgrimage to our most sacred site. First Arcanist, you and your retinue would be welcome to join us.','',26124),
(141394,'enUS','','I would consider it an honor to see the Sunwell, Lor\'themar. And I prefer that my friends call me Thalyssra.',26124),
(141395,'enUS','Rommath, kindly open the way for us.','',26124),
(141396,'enUS','Please follow me.','',26124),
(141397,'enUS','','The sense of power is palpable. As potent as the Nightwell, but of a different nature.',26124),
(141398,'enUS','','The Sunwell was corrupted by our enemies, but a naaru\'s sacrifice purified its waters. Now the essence of the Light sustains us.',26124),
(141399,'enUS','','The Sunwell has changed... but its beauty remains. It has been so long.',26124),
(141400,'enUS','Stay back!','',26124),
(141401,'enUS','What is happening?','',26124),
(141402,'enUS','This is why I demanded that Umbric and his radicals be exiled. Anyone who treats with the Void is a danger to the Sunwell!','',26124),
(141403,'enUS','','I did not intend for my presence to...',26124),
(141404,'enUS','Enough! We need to cleanse this corruption before the well is lost!','',26124),
(141405,'enUS','','Silgryn! Valtrois! Aid the regent lord!',26124),
(141407,'enUS','','Highmountain stands.',26124),
(141408,'enUS','','These words speak of more than earth and stone. They tell the history of our people, enduring hardship and conflict to unite against common foes.',26124),
(141409,'enUS','','At times we were divided. At times we lost our way. But the spirits of our ancestors reminded us that we are bound together by earth, river, and sky. That we are family, and family is worth fighting for.',26124),
(141410,'enUS','','The time has come for you to venture beyond our sacred peaks.',26124),
(141464,'enUS','|TInterface\\Icons\\SPELL_FIRE_FELRAINOFFIRE.BLP:20|t|cFFFF0000|Hspell:248333|h[Meteor Storm]|h|r can be avoided, be sure to avoid its impact.','|TInterface\\Icons\\SPELL_FIRE_FELRAINOFFIRE.BLP:20|t|cFFFF0000|Hspell:248333|h[Meteor Storm]|h|r can be avoided, be sure to avoid its impact.',26124),
(141465,'enUS','This creature will turn and attack players, be sure it\'s attacking a tank before you attack it!','This creature will turn and attack players, be sure it\'s attacking a tank before you attack it!',26124),
(141466,'enUS','|TInterface\\Icons\\SPELL_FIRE_FELFLAMESTRIKE.BLP:20|tFel-Infused Destructors damage Eonar with their |cFFFF0000|Hspell:246305|h[Artillery Strike]|h|r, be sure to dispatch them quickly.','|TInterface\\Icons\\SPELL_FIRE_FELFLAMESTRIKE.BLP:20|tFel-Infused Destructors damage Eonar with their |cFFFF0000|Hspell:246305|h[Artillery Strike]|h|r, be sure to dispatch them quickly.',26124),
(141467,'enUS','|TInterface\\ICONS\\spell_shadow_shadesofdarkness.blp:20|t Move near allies to avoid |cFFF00000|Hspell:243963|h[Alone in the Darkness]|h|r!','',26124),
(141468,'enUS','|TInterface\\ICONS\\ABILITY_HUNTER_SNIPERSHOT.BLP:20|t Run away from the boss during |cFFF00000|Hspell:246220|h[Fel Bombardment]|h|r to avoid damage!','',26124),
(141469,'enUS','|TInterface\\Icons\\SPELL_FIRE_IMMOLATION.BLP:20|tLeave construction bays during  |cFFFF0000|Hspell:248061|h[Purging Protocol]|h|r to avoid being killed!','|TInterface\\Icons\\SPELL_FIRE_IMMOLATION.BLP:20|tLeave construction bays during  |cFFFF0000|Hspell:248061|h[Purging Protocol]|h|r to avoid being killed!',26124),
(141480,'enUS','The only way is forward.','',26124),
(141481,'enUS','Pain is the architect of memories.','',26124),
(141482,'enUS','There is no kindness here.','',26124),
(141483,'enUS','Anguish and hurt... the search for solace.','',26124),
(141484,'enUS','Even amidst hopelessness, there is respite.','',26124),
(141485,'enUS','Is there no comfort? No relief?','',26124),
(141486,'enUS','Retreat deeper... find safety... find comfort...','',26124),
(141487,'enUS','Distraction provides escape.','',26124),
(141488,'enUS','Unfair! Unjust! Nothing is ever what it seems!','',26124),
(141489,'enUS','Enemies lurk within every shadow. Can this darkness be stopped?','',26124),
(141490,'enUS','Is solitude the answer? No one can hurt you if you remain alone.','',26124),
(141491,'enUS','Safe. Secure. Away from everyone. Everything.','',26124),
(141492,'enUS','Fear is relentless. Unyielding. A foe to be defeated.','',26124),
(141493,'enUS','Perhaps to overcome fear of the darkness, one must embrace it.','',26124),
(141494,'enUS','An offer refuted... and yet the fear remains.','',26124),
(141495,'enUS','Within one soul exist many truths. Some noble. Others...','',26124),
(141496,'enUS','Does the path lead to greatness? Glory? Or obliteration?','',26124),
(141501,'enUS','|TInterface\\Icons\\Sha_Ability_Rogue_BloodyEye_nightmare:20|t|cFFFF0000|Hspell:258068|h[Sargeras\' Gaze]|h|r is cast upon the battle...','|TInterface\\Icons\\Sha_Ability_Rogue_BloodyEye_nightmare:20|t|cFFFF0000|Hspell:258068|h[Sargeras\' Gaze]|h|r is cast upon the battle...',26124),
(141518,'enUS','This T\'paartos is pledged to the Light, yet... treats with the darkness? This cannot be T\'paartos\' fate!','',26124),
(141554,'enUS','','I cannot let the Darkness possess my father\'s body!',26124),
(141555,'enUS','Mayla! We must stand together!','',26124),
(141556,'enUS','I am free from the Old Gods\' grip. Thank you, my friends.','',26124),
(141575,'enUS','Serve your true masters, drogbar! Your defiance means death!','',26124),
(141576,'enUS','The Skyhorn shall serve my masters! You will become the shadow that darkens the skies!','',26124),
(141577,'enUS','The Legion was nothing compared to our power! Surrender!','',26124),
(141578,'enUS','You have failed! The Darkness rises... and Highmountain shall fall!','',26124),
(141579,'enUS','The wards have weakened! He will be ours!','',26124),
(141585,'enUS','Follow me, champion.','',26124),
(141586,'enUS','Long ago, the Old Gods sought to lay claim to Highmountain. Their campaign was led by a terrible general... Uul\'gyneth the Darkness.','',26124),
(141587,'enUS','Huln gathered heroes from among the tribes to stand together. They fought against Uul\'gyneth\'s servants, the Necrodark... but the forces of shadow were too great to overcome.','',26124),
(141588,'enUS','So Huln devised another plan. Wards were placed to lock away the Old Gods\' influence. Though the general survived, Uul\'gyneth\'s essence was trapped.','',26124),
(141589,'enUS','','So the Necrodark have been lurking in the shadows, waiting to call forth their master.',26124),
(141590,'enUS','Indeed. And when I left the mountain to visit Mulgore, the wards weakened just enough to let the Darkness take hold.','',26124),
(141591,'enUS','The last ward was placed at Highmountain Summit. That is where we must go. Just as Huln stood with his allies, so we must band together.','',26124),
(141596,'enUS','Warchief Sylvanas Windrunner, I present Chieftain Mayla Highmountain.','',26124),
(141628,'enUS','Was T\'paartos meant to walk this path? Is T\'paartos worthy to become Lightforged?','',26124),
(141629,'enUS','No! The darkness will not claim T\'paartos!','',26124),
(141630,'enUS','Ahh, Ika. T\'paartos raised this elekk when its mother was killed.','',26124),
(141631,'enUS','T\'paartos has faced many such fiends in the Army of the Light.','',26124),
(141632,'enUS','T\'paartos can lift mountains!','',26124),
(141633,'enUS','This is... slightly embarrassing for T\'paartos.','',26124),
(141634,'enUS','Ugh! Can $p make the snakes go away?','',26124),
(141635,'enUS','No... this is not real. This cannot be the true T\'paartos!','',26124),
(141636,'enUS','No...','',26124),
(141637,'enUS','ENOUGH!!!','',26124),
(141638,'enUS','The Light has always been with T\'paartos! He will NEVER abandon the Light!','',26124),
(141639,'enUS','Such power awaits us, T\'paartos.','',26124),
(141640,'enUS','The Light is not the way to true strength.','',26124),
(141641,'enUS','Shrug off the chains the Light has used to bind you.','',26124),
(141642,'enUS','Yes... give in, T\'paartos. Embrace true power!','',26124),
(141677,'enUS','','Welcome back, T\'paartos.',26124),
(141678,'enUS','','T\'paartos... You confronted your fears... your failings... and have been reborn.',26124),
(141679,'enUS','We all have darkness inside us. It is no easy thing to face.','',26124),
(141680,'enUS','T\'paartos realizes this now.','',26124),
(141681,'enUS','','This is an official ceremony. Do not interrupt.',26124),
(141712,'enUS','','Greetings, $n. You probably don\'t remember me--we met next week.$b$bWould you care to revisit Ulduar?',26124),
(141713,'enUS','Send me into Ulduar. (Timewalking Raid)','Send me into Ulduar. (Timewalking Raid)',26124),
(141731,'enUS','Can you believe there are cities out there that aren\'t encased in a magic bubble? I mean, how do those people keep the dust out? Savages.','',26124),
(141732,'enUS','','I like bubbles. They make me feel safe!',26124),
(141775,'enUS','|TInterface\\Icons\\INV_ELEMENTAL_PRIMAL_AIR:20|tGolganneth has chosen you to deliver the |cFFFF0000|Hspell:257313|h[Gift of the Sky]|h|r!','|TInterface\\Icons\\INV_ELEMENTAL_PRIMAL_AIR:20|tGolganneth has chosen you to deliver the |cFFFF0000|Hspell:257313|h[Gift of the Sky]|h|r!',26124),
(141776,'enUS','|TInterface\\Icons\\ACHIEVEMENT_ZONE_VASHJIR:20|tGolganneth has chosen you to deliver the |cFFFF0000|Hspell:257306|h[Gift of the Sea]|h|r!','|TInterface\\Icons\\ACHIEVEMENT_ZONE_VASHJIR:20|tGolganneth has chosen you to deliver the |cFFFF0000|Hspell:257306|h[Gift of the Sea]|h|r!',26124),
(141784,'enUS','The wards have weakened! He will be ours!','',26124),
(141790,'enUS','Mayla... the pools...','',26124),
(141791,'enUS','','I understand, my friend. Baine, I must get Ebonhorn back to Highmountain.',26124),
(141792,'enUS','Very well. We will drive this Old God filth from Thunder Bluff.','',26124),
(141795,'enUS','Destroy them! They must not hinder my return!','',26124),
(141796,'enUS','Your masters will not take my city, monster!','',26124),
(141797,'enUS','I must be certain the Old Gods\' minions are driven from Mulgore.','',26124),
(141798,'enUS','Go to Highmountain and aid Mayla, champion. I will join you soon.','',26124),
(141799,'enUS','','The waters have soothed Ebonhorn, but I fear he is slipping away.',26124),
(141800,'enUS','','I will remain here while Graysky aids you. Pray that restoring the wards will mend Ebonhorn\'s mind.',26124),
(141802,'enUS','My mind is my own again. Return to Thunder Totem, champion. Let us gather strength for what is to come.','',26124),
(141803,'enUS','Champion! Graysky told me of your courage.','',26124),
(141804,'enUS','','But our work is not done yet. Ebonhorn, we must know what this Darkness wants.',26124),
(141805,'enUS','Long ago, the Old Gods sought to claim Highmountain. Their campaign was led by a terrible creature of nightmare... Uul\'gyneth the Darkness.','',26124),
(141806,'enUS','Huln gathered heroes from among the tribes. They fought against Uul\'gyneth\'s servants, the Necrodark... but the forces of shadow were too great to overcome.','',26124),
(141807,'enUS','So Huln devised another plan. Wards were placed to lock away the Old Gods\' influence. Though the general survived, Uul\'gyneth\'s essence was trapped.','',26124),
(141808,'enUS','','All this time, the Necrodark have been lurking in the shadows, waiting to call forth their master.',26124),
(141809,'enUS','Indeed. And when I left the mountain to visit Mulgore, the wards weakened just enough to let the Darkness seep through.','',26124),
(141810,'enUS','The last ward was placed at Highmountain Summit. That is where we must go. Just as Huln stood with his allies, so we must band together.','',26124),
(141811,'enUS','Yes... come! Your strength will become ours, child of darkness!','',26124),
(141812,'enUS','Child of... What does he mean?','',26124),
(141813,'enUS','I... cannot say. Mayla, you and I must go on ahead. Baine, you and our champion gather the others and meet us at the summit.','',26124),
(141829,'enUS','','Oh, hi! Did you want to take a S.E.L.F.I.E. with me?',26124),
(141830,'enUS','What does S.E.L.F.I.E. stand for?','What does S.E.L.F.I.E. stand for?',26124),
(141831,'enUS','','Self-Enabling Low Focus Image Extractor.',26124),
(141832,'enUS','I lost my camera. Can you make me another one?','I lost my camera. Can you make me another one?',26124),
(141833,'enUS','Can this camera do anything else?','Can this camera do anything else?',26124),
(141834,'enUS','','You know, I\'m not quite sure! It\'s infused with some powerful engineering... there\'s probably a hidden feature or two.$B$BYou might want to try taking it near some sources of great power. That always seems to kick-start things!',26124),
(141835,'enUS','','Niko, more light! Oh, hey gorgeous! Didn\'t see ya there. What can I do for ya?',26124),
(141836,'enUS','','I like ya. Never satisfied, just like me. That\'s the pursuit of perfection in ya.$B$BYa know, I\'m not really sure. This thing\'s got the best in goblin engineering all crammed into a tiny box. That\'s a recipe for untapped potential, right there.$B$BMaybe find yourself a source of great power and... see what happens? No promises.',26124),
(141837,'enUS','I am eager for the Lightforged to join the Alliance. Turalyon, bring our champion with you to the Vindicaar so that you may address your troops together.','',26124),
(141838,'enUS','It will be done, High King.','',26124),
(141839,'enUS','This way, champion.','',26124),
(141840,'enUS','Fareeya, I need a beacon to the Vindicaar.','',26124),
(141841,'enUS','','At once, High Exarch.',26124),
(141846,'enUS','This way!','',26124),
(141847,'enUS','Over here!','',26124),
(141848,'enUS','Look out!','',26124),
(141849,'enUS','Here, friend!','',26124),
(141850,'enUS','T\'paartos does not know fear!','',26124),
(141851,'enUS','T\'paartos regrets calling $p puny.','',26124),
(141852,'enUS','The fear... it followed T\'paartos everywhere!','',26124),
(141870,'enUS','T\'paartos is sorry.','',26124),
(141871,'enUS','From this day forth, you are Lightforged.','',26124),
(141872,'enUS','','Pheta thones gamera. Light guide our path!',26124),
(141873,'enUS','T\'paartos!','',26124),
(141874,'enUS','T\'paartos is a bit... unconventional. But he will serve our cause well.','',26124),
(141875,'enUS','Champion, it is time for us to return to Stormwind. Fareeya, spread the word. The Lightforged now fight for the Alliance.','',26124),
(141876,'enUS','','With pleasure, High Exarch.',26124),
(141892,'enUS','High King Wrynn. The Army of the Light is pledged to defend the Alliance.','',26124),
(141893,'enUS','The strength of the Lightforged is most welcome in our ranks, High Exarch.','',26124),
(141894,'enUS','I have fought beside these draenei in the Twisting Nether for a thousand years. You will find no soldiers who are more skilled, or more loyal.','',26124),
(141895,'enUS','Both these qualities will be needed in the days to come. And thank you for your part in bringing them to our cause, $p.','',26124),
(141897,'enUS','For the Alliance!','',26124),
(141898,'enUS','For the Alliance!','',26124),
(141899,'enUS','We will drive your shadow from Mulgore!','',26124),
(141900,'enUS','Hahahaha! It feels good to swing my mace again!','',26124),
(141901,'enUS','Thunder Bluff will be free of you!','',26124),
(141902,'enUS','Go back to the void that spawned you!','',26124),
(141908,'enUS','','I did not expect you back so soon, High Exarch. I assume your meeting with the king went well?',26124),
(141909,'enUS','Indeed. He is eager to have the Army of the Light fighting on the side of the Alliance. Assemble our forces, captain, and I will make the announcement.','',26124),
(141910,'enUS','','You know how fond I am of your speeches, but can it wait? We were just about to send these initiates to undertake the trials.',26124),
(141911,'enUS','Ah, this is excellent timing, champion. You can see firsthand what it means for a soldier to become Lightforged. Proceed, Fareeya.','',26124),
(141912,'enUS','','For thousands of years, the Lightforged fought demons in the Twisting Nether. The Xenedar was the only home we knew.',26124),
(141913,'enUS','','Now, for the first time in ages, we can walk beneath a sky not befouled by the Legion\'s madness... and feel the earth under our hooves again.',26124),
(141914,'enUS','','But we must not grow complacent. One war ends, the next begins. Such is the life of a soldier.',26124),
(141915,'enUS','','Your duty begins in Stormwind. Explore this world of Azeroth. Get to know the people and places we have sworn to defend.',26124),
(141916,'enUS','','And always walk in the Light, $p.',26124),
(141918,'enUS','','For many ages, our people have called the Broken Isles home. We know little about the Azeroth that exists beyond our shores.',26124),
(141919,'enUS','','It is time we changed that.',26124),
(141920,'enUS','','Today you begin a new journey, $p. You will be our voice in the lands beyond the mountain.',26124),
(141921,'enUS','','Go to Orgrimmar. Meet our new allies and learn what it is they care about... what they fight for.',26124),
(141922,'enUS','','Stay true to who you are. And should you ever miss your home, know that Highmountain is here for you. Always.',26124),
(141927,'enUS','|TInterface\\Icons\\Ability_Argus_WastingPlague:20|tYou are afflicted with |cFFFF0000|Hspell:248396|h[Soulblight]|h|r!','|TInterface\\Icons\\Ability_Argus_WastingPlague:20|tYou are afflicted with |cFFFF0000|Hspell:248396|h[Soulblight]|h|r!',26124),
(141931,'enUS','S.E.L.F.I.E. Camera captures Twilight Filter!','S.E.L.F.I.E. Camera captures Twilight Filter!',26124),
(141932,'enUS','S.E.L.F.I.E. Camera captures Firelands Filter!','S.E.L.F.I.E. Camera captures Firelands Filter!',26124),
(141933,'enUS','S.E.L.F.I.E. Camera captures Sha Filter!','S.E.L.F.I.E. Camera captures Sha Filter!',26124),
(141934,'enUS','S.E.L.F.I.E. Camera captures Frostmourne Filter!','S.E.L.F.I.E. Camera captures Frostmourne Filter!',26124),
(141935,'enUS','S.E.L.F.I.E. Camera captures Argus Filter!','S.E.L.F.I.E. Camera captures Argus Filter!',26124),
(141940,'enUS','','Your sojourn through Azeroth has been long, $p. And through it all, you have brought honor to Highmountain.',26124),
(141941,'enUS','','Now Thunder Totem calls you home. It is time we thank you for all that you have done for us.',26124),
(141943,'enUS','','Through the darkest times, you have been strong, brave, unyielding. Thanks to you, $p, the Horde knows what it means to be Highmountain.',26124),
(141944,'enUS','','It is my honor to present you with the armor of our people. No matter where your journey takes you, it will serve as a reminder of where you came from.',26124),
(141947,'enUS','','Your service to the Alliance has been most impressive, $p. I could not have done better myself. Well, I could... but not by much.',26124),
(141948,'enUS','','Come, meet with me at the Vindicaar. It is time that we reward your diligence.',26124),
(141949,'enUS','','Throughout your journeys, you have been a beacon of Light in the darkness. You have shown the Alliance what it means to be Lightforged.',26124),
(141950,'enUS','','Wear these vestments with pride, $p. The Army of the Light will always be honored to count you in its ranks.',26124),
(141951,'enUS','This way!','',26124),
(141952,'enUS','Over here!','',26124),
(141953,'enUS','Look out!','',26124),
(141954,'enUS','The enemy is all around us!','',26124),
(142029,'enUS','Highmountain stands.','',26124),
(142033,'enUS','Greetings, traveler.','',26124),
(142034,'enUS','The river provides.','',26124),
(142035,'enUS','What has the wind brought?','',26124),
(142054,'enUS','We will not fear the darkness.','',26124),
(142055,'enUS','Peace and patience, friend.','',26124),
(142056,'enUS','We defend this world together.','',26124),
(142057,'enUS','Beware the deep places of the earth.','',26124),
(142058,'enUS','Together, we are Highmountain.','',26124),
(142059,'enUS','An\'she guide you.','',26124),
(142060,'enUS','May your rivers be ever bountiful.','',26124),
(142061,'enUS','Ride the winds.','',26124),
(142062,'enUS','Sun and moon light your way.','',26124),
(142063,'enUS','Remember the Earthmother\'s lessons.','',26124),
(142064,'enUS','Annoy me and you\'ll get the rack.','',26124),
(142065,'enUS','Those who offend Highmountain are in for a fall. A loooooong fall.','',26124),
(142066,'enUS','Keep it up and you\'ll get a swift hoof to the backside.','',26124),
(142067,'enUS','Find yourself a deep place of the earth and get lost.','',26124),
(142068,'enUS','Have you come to trade?','',26124),
(142069,'enUS','I have just the thing for you.','',26124),
(142070,'enUS','Feel free to browse.','',26124),
(142071,'enUS','I offer Highmountain\'s finest.','',26124),
(142072,'enUS','Come back again.','',26124),
(142073,'enUS','Pleasure doing business.','',26124),
(142074,'enUS','See you soon.','',26124),
(142075,'enUS','We replenish stock daily.','',26124),
(142078,'enUS','','We replenish stock daily.',26124),
(142079,'enUS','','See you soon.',26124),
(142083,'enUS','','Pleasure doing business.',26124),
(142084,'enUS','','Come back again.',26124),
(142085,'enUS','','I offer Highmountain\'s finest.',26124),
(142086,'enUS','','Feel free to browse.',26124),
(142087,'enUS','','I have just the thing for you.',26124),
(142088,'enUS','','Have you come to trade?',26124),
(142089,'enUS','','Find yourself a deep place of the earth and get lost.',26124),
(142090,'enUS','','Keep it up and you\'ll get a swift hoof to the backside.',26124),
(142091,'enUS','','Those who offend Highmountain are in for a fall. A loooooong fall.',26124),
(142092,'enUS','','Annoy me and you\'ll get the rack.',26124),
(142093,'enUS','','Remember the Earthmother\'s lessons.',26124),
(142094,'enUS','','Sun and moon light your way.',26124),
(142095,'enUS','','Ride the winds.',26124),
(142096,'enUS','','May your rivers be ever bountiful.',26124),
(142097,'enUS','','An\'she guide you.',26124),
(142098,'enUS','','Together, we are Highmountain.',26124),
(142099,'enUS','','Beware the deep places of the earth.',26124),
(142100,'enUS','','We defend this world together.',26124),
(142101,'enUS','','Peace and patience, friend.',26124),
(142102,'enUS','','We will not fear the darkness.',26124),
(142103,'enUS','','What has the wind brought?',26124),
(142104,'enUS','','The river provides.',26124),
(142105,'enUS','','Greetings, traveler.',26124),
(142106,'enUS','','Highmountain stands.',26124),
(142107,'enUS','We replenish our stock daily.','',26124),
(142108,'enUS','See you soon.','',26124),
(142109,'enUS','Pleasure doing business.','',26124),
(142110,'enUS','Come back again.','',26124),
(142111,'enUS','I offer Highmountain\'s finest.','',26124),
(142112,'enUS','Feel free to browse.','',26124),
(142113,'enUS','I have just the thing for you.','',26124),
(142114,'enUS','Have you come to trade?','',26124),
(142115,'enUS','Find yourself a deep place of the earth and get lost.','',26124),
(142116,'enUS','Keep it up and you\'ll get a swift hoof to the backside.','',26124),
(142117,'enUS','Those who offend Highmountain are in for a fall. A loooooong fall.','',26124),
(142118,'enUS','Annoy me and you\'ll get the rack.','',26124),
(142119,'enUS','Remember the Earthmother\'s lessons.','',26124),
(142120,'enUS','Sun and moon light your way.','',26124),
(142121,'enUS','Ride the winds.','',26124),
(142122,'enUS','May your rivers be ever bountiful.','',26124),
(142123,'enUS','An\'she guide you.','',26124),
(142124,'enUS','Together, we are Highmountain.','',26124),
(142125,'enUS','I do not fear the deep places of the earth.','',26124),
(142126,'enUS','We defend this world together.','',26124),
(142127,'enUS','Remain vigilant.','',26124),
(142128,'enUS','We defend against the darkness.','',26124),
(142129,'enUS','What has the wind brought?','',26124),
(142130,'enUS','The river provides.','',26124),
(142131,'enUS','Keep to the roads, traveler.','',26124),
(142132,'enUS','We defend Highmountain.','',26124),
(142133,'enUS','','We defend Highmountain.',26124),
(142134,'enUS','','Keep to the roads, traveler.',26124),
(142135,'enUS','','The river provides.',26124),
(142136,'enUS','','What has the wind brought?',26124),
(142137,'enUS','','We defend against the darkness.',26124),
(142138,'enUS','','Remain vigilant.',26124),
(142139,'enUS','','We defend this world together.',26124),
(142140,'enUS','','I do not fear the deep places of the earth.',26124),
(142141,'enUS','','Together, we are Highmountain.',26124),
(142142,'enUS','','An\'she guide you.',26124),
(142143,'enUS','','May your rivers be ever bountiful.',26124),
(142144,'enUS','','Ride the winds.',26124),
(142145,'enUS','','Sun and moon light your way.',26124),
(142146,'enUS','','Remember the Earthmother\'s lessons.',26124),
(142147,'enUS','','Annoy me and you\'ll get the rack.',26124),
(142148,'enUS','','Those who offend Highmountain are in for a fall. A loooooong fall.',26124),
(142149,'enUS','','Keep it up and you\'ll get a swift hoof to the backside.',26124),
(142150,'enUS','','Find yourself a deep place of the earth and get lost.',26124),
(142151,'enUS','','Have you come to trade?',26124),
(142152,'enUS','','I have just the thing for you.',26124),
(142153,'enUS','','Feel free to browse.',26124),
(142154,'enUS','','I offer Highmountain\'s finest.',26124),
(142155,'enUS','','Come back again.',26124),
(142156,'enUS','','Pleasure doing business.',26124),
(142157,'enUS','','See you soon.',26124),
(142158,'enUS','','We replenish stock daily.',26124),
(142159,'enUS','','We defend Highmountain.',26124),
(142160,'enUS','','Greetings, traveler.',26124),
(142161,'enUS','','The river provides.',26124),
(142162,'enUS','','What has the wind brought?',26124),
(142163,'enUS','','We will not fear the darkness.',26124),
(142164,'enUS','','Peace and patience, friend.',26124),
(142165,'enUS','','We defend this world together.',26124),
(142166,'enUS','','I do not fear the deep places of the earth.',26124),
(142167,'enUS','','Together, we are Highmountain.',26124),
(142168,'enUS','','An\'she guide you.',26124),
(142169,'enUS','','May your rivers be ever bountiful.',26124),
(142170,'enUS','','Ride the winds.',26124),
(142171,'enUS','','Sun and moon light your way.',26124),
(142172,'enUS','','Remember the Earthmother\'s lessons.',26124),
(142173,'enUS','','Annoy me and you\'ll get the rack.',26124),
(142174,'enUS','','Those who offend Highmountain are in for a fall. A loooooong fall.',26124),
(142175,'enUS','','Keep it up and you\'ll get a swift hoof to the backside.',26124),
(142176,'enUS','','Find yourself a deep place of the earth and get lost.',26124),
(142177,'enUS','','Have you come to trade?',26124),
(142178,'enUS','','I have just the thing for you.',26124),
(142179,'enUS','','Feel free to browse.',26124),
(142180,'enUS','','I offer Highmountain\'s finest.',26124),
(142181,'enUS','','Come back again.',26124),
(142182,'enUS','','Pleasure doing business.',26124),
(142183,'enUS','','See you soon.',26124),
(142184,'enUS','','We replenish stock daily.',26124),
(142186,'enUS','I do not fear the deep places of the earth.','',26124),
(142187,'enUS','Together, we are Highmountain.','',26124),
(142188,'enUS','An\'she guide you.','',26124),
(142189,'enUS','May your rivers be ever bountiful.','',26124),
(142190,'enUS','Ride the winds.','',26124),
(142191,'enUS','Sun and moon light your way.','',26124),
(142192,'enUS','Remember the Earthmother\'s lessons.','',26124),
(142193,'enUS','Annoy me and you\'ll get the rack.','',26124),
(142194,'enUS','Those who offend Highmountain are in for a fall. A loooooong fall.','',26124),
(142195,'enUS','Keep it up and you\'ll get a swift hoof to the backside.','',26124),
(142196,'enUS','Find yourself a deep place of the earth and get lost.','',26124),
(142197,'enUS','Have you come to trade?','',26124),
(142198,'enUS','I have just the thing for you.','',26124),
(142199,'enUS','Feel free to browse.','',26124),
(142200,'enUS','I offer Highmountain\'s finest.','',26124),
(142201,'enUS','Come back again.','',26124),
(142202,'enUS','Pleasure doing business.','',26124),
(142203,'enUS','See you soon.','',26124),
(142205,'enUS','We replenish stock daily.','',26124),
(142208,'enUS','We defend Highmountain.','',26124),
(142209,'enUS','Keep to the roads, traveler.','',26124),
(142210,'enUS','The river provides.','',26124),
(142211,'enUS','What has the wind brought?','',26124),
(142212,'enUS','We defend against the darkness.','',26124),
(142213,'enUS','Remain vigilant.','',26124),
(142214,'enUS','We defend this world together.','',26124),
(142229,'enUS','','I\'d like to offer you a tour of our ship... starting with the airlock.',26124),
(142230,'enUS','','Regulations require me to tolerate your behavior... for a time.',26124),
(142231,'enUS','','Are you looking for a one-way trip to the Nether?',26124),
(142232,'enUS','','You test a soldier\'s patience.',26124),
(142233,'enUS','','May I be of service?',26124),
(142234,'enUS','','We have reasonable prices.',26124),
(142235,'enUS','','I hope you find something useful.',26124),
(142236,'enUS','','Browse at  your leisure, friend.',26124),
(142237,'enUS','','Your coin is always welcome.',26124),
(142238,'enUS','','My goods will serve you well.',26124),
(142239,'enUS','','Enjoy your purchases.',26124),
(142240,'enUS','','Thank you for browsing.',26124),
(142247,'enUS','','Archenon poros.',26124),
(142248,'enUS','','Destiny is ours to forge.',26124),
(142249,'enUS','','Argus will always be remembered in our hearts.',26124),
(142250,'enUS','','We are reborn in the Light.',26124),
(142251,'enUS','','Remain vigilant.',26124),
(142252,'enUS','','Dioniss aca.',26124),
(142253,'enUS','','Light guide your footsteps.',26124),
(142254,'enUS','','Remember the lessons of the past.',26124),
(142258,'enUS','','Good fortune to the Alliance.',26124),
(142259,'enUS','','The Light will not forget us.',26124),
(142260,'enUS','','One war ends, the next begins.',26124),
(142261,'enUS','','Achal hecta.',26124),
(142262,'enUS','','May the Light embrace you.',26124),
(142263,'enUS','','It is our duty to serve.',26124),
(142264,'enUS','I\'d like to offer you a tour of our ship... starting with the airlock.','',26124),
(142265,'enUS','Regulations require me to tolerate your behavior... for a time.','',26124),
(142266,'enUS','Are you looking for a one-way trip to the Nether?','',26124),
(142267,'enUS','You test a soldier\'s patience.','',26124),
(142268,'enUS','May I be of service?','',26124),
(142269,'enUS','We have reasonable prices.','',26124),
(142270,'enUS','I hope you find something useful.','',26124),
(142271,'enUS','Browse at  your leisure, friend.','',26124),
(142273,'enUS','Your coin is always welcome.','',26124),
(142274,'enUS','My goods will serve you well.','',26124),
(142275,'enUS','Enjoy your purchases.','',26124),
(142276,'enUS','Thank you for browsing.','',26124),
(142277,'enUS','It is our duty to serve.','',26124),
(142278,'enUS','May the Light embrace you.','',26124),
(142279,'enUS','Achal hecta.','',26124),
(142280,'enUS','One war ends, the next begins.','',26124),
(142281,'enUS','The Light will not forget us.','',26124),
(142282,'enUS','Good fortune to the Alliance.','',26124),
(142283,'enUS','Archenon poros.','',26124),
(142284,'enUS','Destiny is ours to forge.','',26124),
(142285,'enUS','Argus will always be remembered in our hearts.','',26124),
(142286,'enUS','We are reborn in the Light.','',26124),
(142287,'enUS','Remain vigilant.','',26124),
(142288,'enUS','Dioniss aca.','',26124),
(142289,'enUS','Light guide your footsteps.','',26124),
(142290,'enUS','Remember the lessons of the past.','',26124),
(142292,'enUS','','I\'d like to offer you a tour of our ship... starting with the airlock.',26124),
(142293,'enUS','','Regulations require me to tolerate your behavior... for a time.',26124),
(142294,'enUS','','Are you looking for a one-way trip to the Nether?',26124),
(142296,'enUS','','You test a soldier\'s patience.',26124),
(142297,'enUS','','May I be of service?',26124),
(142298,'enUS','','We have reasonable prices.',26124),
(142299,'enUS','','I hope you find something useful.',26124),
(142300,'enUS','','Browse at  your leisure, friend.',26124),
(142301,'enUS','','Your coin is always welcome.',26124),
(142302,'enUS','','My goods will serve you well.',26124),
(142303,'enUS','','Enjoy your purchases.',26124),
(142304,'enUS','','Thank you for browsing.',26124),
(142305,'enUS','','It is our duty to serve.',26124),
(142306,'enUS','','May the Light protect you.',26124),
(142307,'enUS','','Achal hecta.',26124),
(142308,'enUS','','One war ends, the next begins.',26124),
(142309,'enUS','','The Light will not forget our sacrifice.',26124),
(142310,'enUS','','We stand with the Alliance.',26124),
(142311,'enUS','','Archenon poros.',26124),
(142312,'enUS','','Destiny is ours to forge.',26124),
(142313,'enUS','','Argus will always be remembered.',26124),
(142315,'enUS','','We are made strong in the Light.',26124),
(142316,'enUS','','Remain vigilant.',26124),
(142317,'enUS','','Dioniss aca.',26124),
(142318,'enUS','','Light guide us to victory.',26124),
(142319,'enUS','','Our enemies lack our conviction.',26124),
(142320,'enUS','I\'d like to offer you a tour of our ship... starting with the airlock.','',26124),
(142321,'enUS','Regulations require me to tolerate your behavior... for a time.','',26124),
(142322,'enUS','Are you looking for a one-way trip to the Nether?','',26124),
(142323,'enUS','You test a soldier\'s patience.','',26124),
(142325,'enUS','May I be of service?','',26124),
(142326,'enUS','We have reasonable prices.','',26124),
(142327,'enUS','I hope you find something useful.','',26124),
(142328,'enUS','Browse at  your leisure, friend.','',26124),
(142329,'enUS','Your coin is always welcome.','',26124),
(142330,'enUS','My goods will serve you well.','',26124),
(142331,'enUS','Enjoy your purchases.','',26124),
(142332,'enUS','Thank you for browsing.','',26124),
(142333,'enUS','It is our duty to serve.','',26124),
(142334,'enUS','May the Light protect you.','',26124),
(142335,'enUS','Achal hecta.','',26124),
(142336,'enUS','One war ends, the next begins.','',26124),
(142337,'enUS','The Light will not forget our sacrifice.','',26124),
(142338,'enUS','We stand with the Alliance.','',26124),
(142339,'enUS','Archenon poros.','',26124),
(142340,'enUS','Destiny is ours to forge.','',26124),
(142341,'enUS','Argus will always be remembered.','',26124),
(142342,'enUS','We are made strong in the Light.','',26124),
(142343,'enUS','Remain vigilant.','',26124),
(142344,'enUS','Dioniss aca.','',26124),
(142345,'enUS','Light guide us to victory.','',26124),
(142346,'enUS','Our enemies lack our conviction.','',26124),
(142348,'enUS','Our enemies lack our conviction.','',26124),
(142349,'enUS','The Light will guide us to victory.','',26124),
(142350,'enUS','Dioniss aca.','',26124),
(142351,'enUS','Always be on guard.','',26124),
(142352,'enUS','We are one with the Light.','',26124),
(142353,'enUS','Together, we can bring down any foe.','',26124),
(142354,'enUS','Let us forge our destiny.','',26124),
(142355,'enUS','Archenon poros.','',26124),
(142356,'enUS','We stand with the Alliance.','',26124),
(142357,'enUS','The Light demands vigilance and sacrifice.','',26124),
(142358,'enUS','One war ends, the next begins.','',26124),
(142359,'enUS','Achal hecta.','',26124),
(142360,'enUS','Light defend us all.','',26124),
(142361,'enUS','It is our honor to serve.','',26124),
(142362,'enUS','Thank you for browsing.','',26124),
(142363,'enUS','Enjoy your purchases.','',26124),
(142364,'enUS','My goods will serve you well.','',26124),
(142365,'enUS','Your coin is always welcome.','',26124),
(142366,'enUS','Browse at  your leisure, friend.','',26124),
(142367,'enUS','I hope you find something useful.','',26124),
(142368,'enUS','We have reasonable prices.','',26124),
(142369,'enUS','May I be of service?','',26124),
(142370,'enUS','You test a soldier\'s patience.','',26124),
(142371,'enUS','Are you looking for a one-way trip to the Nether?','',26124),
(142372,'enUS','Regulations require me to tolerate your behavior... for a time.','',26124),
(142373,'enUS','I\'d like to offer you a tour of our ship... starting with the airlock.','',26124),
(142374,'enUS','','I\'d like to offer you a tour of our ship... starting with the airlock.',26124),
(142375,'enUS','','Regulations require me to tolerate your behavior... for a time.',26124),
(142376,'enUS','','Are you looking for a one-way trip to the Nether?',26124),
(142377,'enUS','','You test a soldier\'s patience.',26124),
(142378,'enUS','','May I be of service?',26124),
(142379,'enUS','','We have reasonable prices.',26124),
(142380,'enUS','','I hope you find something useful.',26124),
(142381,'enUS','','Browse at  your leisure, friend.',26124),
(142382,'enUS','','Your coin is always welcome.',26124),
(142383,'enUS','','My goods will serve you well.',26124),
(142384,'enUS','','Enjoy your purchases.',26124),
(142385,'enUS','','Thank you for browsing.',26124),
(142386,'enUS','','It is our honor to serve.',26124),
(142387,'enUS','','Light defend us all.',26124),
(142388,'enUS','','Achal hecta.',26124),
(142389,'enUS','','One war ends, the next begins.',26124),
(142390,'enUS','','The Light demands vigilance and sacrifice.',26124),
(142391,'enUS','','We stand with the Alliance.',26124),
(142392,'enUS','','Archenon poros.',26124),
(142393,'enUS','','Let us forge our destiny.',26124),
(142394,'enUS','','Together, we can bring down any foe.',26124),
(142395,'enUS','','We are one with the Light.',26124),
(142396,'enUS','','Always be on guard.',26124),
(142397,'enUS','','Dioniss aca.',26124),
(142398,'enUS','','The Light will guide us to victory.',26124),
(142399,'enUS','','Our enemies lack our conviction.',26124),
(142416,'enUS','','Fare well.',26124),
(142417,'enUS','','Kal\'theros maldin.',26124),
(142418,'enUS','','Nor\'bethos Suramar.',26124),
(142419,'enUS','','Our era has come.',26124),
(142420,'enUS','','Stars guide you.',26124),
(142421,'enUS','','Walk in starlight.',26124),
(142422,'enUS','','Ash\'thoras denil.',26124),
(142423,'enUS','','Greetings.',26124),
(142424,'enUS','','May I help you?',26124),
(142425,'enUS','','Tenu\'balah.',26124),
(142426,'enUS','','We see the stars once more.',26124),
(142427,'enUS','','My goods are exquisite.',26124),
(142428,'enUS','','Take a look, I sell all manner of wares.',26124),
(142429,'enUS','','What is your pleasure?',26124),
(142430,'enUS','','Do come again.',26124),
(142431,'enUS','','Pleasure doing business.',26124),
(142432,'enUS','','You will not find a better bargain!',26124),
(142433,'enUS','','I bought this off of a scout patrol. He called it a \"S.E.L.F.I.E. Camera?\" Any idea what that is?',26124),
(142434,'enUS','','Suramar is still a shining jewel in the rubble of the Sundering.',26124),
(142435,'enUS','','We will explore the rest of the world and show them that we are still relevant!',26124),
(142436,'enUS','','You look young enough to use this fancy thing. Can you make it work for me?',26124),
(142437,'enUS','Be well.','',26124),
(142438,'enUS','I know I can count on you.','',26124),
(142439,'enUS','Kal\'theros maldin.','',26124),
(142440,'enUS','Nor\'bethos Suramar.','',26124),
(142441,'enUS','Walk in the moonlight.','',26124),
(142443,'enUS','We rejoin the world.','',26124),
(142444,'enUS','Ash\'thoras denil.','',26124),
(142445,'enUS','Greetings.','',26124),
(142446,'enUS','Our destiny is at hand.','',26124),
(142447,'enUS','Tenu\'balah.','',26124),
(142448,'enUS','We no longer hide.','',26124),
(142449,'enUS','What is your wish?','',26124),
(142450,'enUS','Do come again.','',26124),
(142451,'enUS','Pleasure doing business.','',26124),
(142452,'enUS','You will not find a better bargain!','',26124),
(142453,'enUS','My goods are exquisite.','',26124),
(142454,'enUS','Take a look, I sell all manner of wares.','',26124),
(142455,'enUS','What is your pleasure?','',26124),
(142459,'enUS','You look young enough to use this fancy thing. Can you make it work for me?','',26124),
(142460,'enUS','We will explore the rest of the world and show them that we are still relevant!','',26124),
(142461,'enUS','Suramar is still a shining jewel in the rubble of the Sundering.','',26124),
(142462,'enUS','I bought this off of a scout patrol. He called it a \"S.E.L.F.I.E. Camera?\" Any idea what that is?','',26124),
(142463,'enUS','','Kal\'theros maldin.',26124),
(142464,'enUS','','Night guide you.',26124),
(142465,'enUS','','Nor\'bethos Suramar.',26124),
(142466,'enUS','','These times are troubling. Watch your back.',26124),
(142467,'enUS','','Walk in the moonlight.',26124),
(142468,'enUS','','We rejoin the world.',26124),
(142469,'enUS','','We shall endure.',26124),
(142470,'enUS','','Ash\'thoras denil.',26124),
(142471,'enUS','','Greetings.',26124),
(142472,'enUS','','Ishnal to\'reth.',26124),
(142473,'enUS','','Our destiny is at hand.',26124),
(142474,'enUS','','Tenu\'balah.',26124),
(142475,'enUS','','We have hidden too long.',26124),
(142476,'enUS','','You wish to speak?',26124),
(142477,'enUS','','Is there somewhere else you could be right now?',26124),
(142478,'enUS','','As in, anywhere but here?',26124),
(142479,'enUS','','Excuse me, I have things to do.',26124),
(142480,'enUS','','You are really a night-thorn in my side.',26124),
(142481,'enUS','By night\'s grace.','',26124),
(142482,'enUS','Kal\'theros maldin.','',26124),
(142483,'enUS','Nor\'bethos Suramar.','',26124),
(142484,'enUS','Safe travels.','',26124),
(142485,'enUS','The Nightborne have returned.','',26124),
(142486,'enUS','This is our age now.','',26124),
(142487,'enUS','Travel in starlight, friend.','',26124),
(142488,'enUS','Ash\'thoras denil.','',26124),
(142489,'enUS','Greetings.','',26124),
(142490,'enUS','Ishnal to\'reth.','',26124),
(142491,'enUS','Tenu\'balah.','',26124),
(142492,'enUS','The shal\'dorei are eternal.','',26124),
(142493,'enUS','What do you wish of me?','',26124),
(142494,'enUS','Come now, I have things to do.','',26124),
(142495,'enUS','Why do you insist on pestering me?','',26124),
(142496,'enUS','Move along!','',26124),
(142497,'enUS','Are you sure you\'re not a night-bore?','',26124),
(142507,'enUS','','Stars guide you.',26124),
(142508,'enUS','','May you ever walk in moonlight.',26124),
(142509,'enUS','','We will make our place in this world.',26124),
(142510,'enUS','','Kal\'theros maldin.',26124),
(142511,'enUS','','Stay strong for Suramar.',26124),
(142512,'enUS','','The shal\'dorei will never be oppressed again.',26124),
(142513,'enUS','','Together we are stronger.',26124),
(142514,'enUS','','Ash\'thoras denil.',26124),
(142516,'enUS','','The shal\'dorei stand strong.',26124),
(142517,'enUS','','Our destiny is upon us.',26124),
(142526,'enUS','','The future is ours to forge.',26124),
(142527,'enUS','','Tenu\'balah.',26124),
(142529,'enUS','','Well met.',26124),
(142531,'enUS','','We are the defenders of Suramar.',26124),
(142532,'enUS','','After 10,000 years of isolation, I was looking forward to some company. But this was not what I had in mind.',26124),
(142534,'enUS','','Azeroth has certainly gone downhill since we\'ve been away. This planet could use a makeover.',26124),
(142535,'enUS','','No, I will not blow magic bubbles. Stop asking.',26124),
(142542,'enUS','','I thought withering was the worst suffering I\'d ever endure. Then I met you.',26124),
(142543,'enUS','','Another satisfied customer.',26124),
(142544,'enUS','','I am confident you will be back.',26124),
(142545,'enUS','','Enjoy your purchase.',26124),
(142546,'enUS','','We only sell the finest quality goods.',26124),
(142547,'enUS','','What is your pleasure?',26124),
(142548,'enUS','','If you break it, you shall buy it.',26124),
(142549,'enUS','If you break it, you shall buy it.','',26124),
(142550,'enUS','What is your pleasure?','',26124),
(142551,'enUS','We only sell the finest quality goods.','',26124),
(142552,'enUS','Enjoy your purchase.','',26124),
(142553,'enUS','I am confident you will be back.','',26124),
(142554,'enUS','Another satisfied customer.','',26124),
(142555,'enUS','I thought withering was the worst suffering I\'d ever endure. Then I met you.','',26124),
(142556,'enUS','No, I will not blow magic bubbles. Stop asking.','',26124),
(142557,'enUS','Azeroth has certainly gone downhill since we\'ve been away. This planet could use a makeover.','',26124),
(142558,'enUS','After 10,000 years of isolation, I was looking forward to some company. But this was not what I had in mind.','',26124),
(142559,'enUS','We are the defenders of Suramar.','',26124),
(142560,'enUS','Well met.','',26124),
(142561,'enUS','Tenu\'balah.','',26124),
(142562,'enUS','The future is ours to forge.','',26124),
(142563,'enUS','Our destiny is upon us.','',26124),
(142564,'enUS','The shal\'dorei stand strong.','',26124),
(142565,'enUS','Ash\'thoras denil.','',26124),
(142566,'enUS','Together we are stronger.','',26124),
(142567,'enUS','The shal\'dorei will never be oppressed again.','',26124),
(142568,'enUS','Stay strong for Suramar.','',26124),
(142569,'enUS','Kal\'theros maldin.','',26124),
(142570,'enUS','We will make our place in this world.','',26124),
(142571,'enUS','May you ever walk in moonlight.','',26124),
(142572,'enUS','Stars guide you.','',26124),
(142578,'enUS','','Bal\'a dash, malanore.',26124),
(142579,'enUS','','Walk your own path.',26124),
(142580,'enUS','','We embrace a new future.',26124),
(142581,'enUS','','Question everything.',26124),
(142582,'enUS','','The universe is full of mystery.',26124),
(142583,'enUS','','I greet you.',26124),
(142585,'enUS','','New doorways have opened to us.',26124),
(142586,'enUS','','Shorel\'aran.',26124),
(142587,'enUS','','Do not fear the shadows.',26124),
(142588,'enUS','','My fate is my own.',26124),
(142589,'enUS','','The whispers do not control me.',26124),
(142590,'enUS','','Unchecked emotion leads to ruin.',26124),
(142591,'enUS','','Power is to be wielded, not feared.',26124),
(142592,'enUS','','The Void offers endless possibilities.',26124),
(142593,'enUS','','Your infantile behavior will not provoke me.',26124),
(142594,'enUS','','This sanctum was once a testament to my people\'s mastery of the arcane. Now it is but a ruin.',26124),
(142595,'enUS','','The Ghostlands. This was once Eversong Forest... a place of unbridled beauty. Windrunner Spire, my family home, stands not far from here.',26124),
(142596,'enUS','','This place looks like it has been ransacked. But perhaps Umbric left behind a clue.',26124),
(142597,'enUS','','This place resonates with power. Tread carefully, $n.',26124),
(142598,'enUS','','Umbric is a dedicated scholar... but his tenacity turned him and his followers into exiles.',26124),
(142599,'enUS','','We are ready to proceed. Stay on your guard, $p. We do not know what we might find inside.',26124),
(142600,'enUS','','\"Remember the Sunwell\"? Please. I am so over it.',26124),
(142604,'enUS','','The Andilien Estate... yes, I remember it. Come, $p.',26124),
(142605,'enUS','','Umbric risks much. He follows in the footsteps of treachery. Let us hope this obsession has not led to his downfall.',26124),
(142621,'enUS','|TInterface\\Icons\\SPELL_HOLY_PROCLAIMCHAMPION:20|tMove to the |cFFFF0000|Hspell:255199|h[Avatar of Aggramar]|h|rto avoid being killed by |TInterface\\Icons\\SPELL_SHADOW_SHADOWFURY:20|t |cFFFF0000|Hspell:|h[Soulbomb Detonation]|h|r!','|TInterface\\Icons\\SPELL_HOLY_PROCLAIMCHAMPION:20|tMove to the |cFFFF0000|Hspell:255199|h[Avatar of Aggramar]|h|rto avoid being killed by |TInterface\\Icons\\SPELL_SHADOW_SHADOWFURY:20|t |cFFFF0000|Hspell:|h[Soulbomb Detonation]|h|r!',26124),
(142628,'enUS','I suppse you are wondering what I am doing here.$b$bSuffice it to say that I have been given a new prime directive. Apparently standing watch over the Conservatory was not an efficient use of my time.$b$b<Sigh> Tenure no longer means what it once did.$b$bDo you require something? As you can see, I am quite busy.','',26124),
(142629,'enUS','Hello, Vigilant Quoram. We met before on Argus.','Hello, Vigilant Quoram. We met before on Argus.',26124),
(142630,'enUS','I passed my trial!','I passed my trial!',26124),
(142631,'enUS','What do you know about becoming Lightforged?','What do you know about becoming Lightforged?',26124),
(142632,'enUS','Do you plan on staying with the draenei?','Do you plan on staying with the draenei?',26124),
(142633,'enUS','How do you like being on the Vindicaar?','How do you like being on the Vindicaar?',26124),
(142634,'enUS','Can you teleport me back up to the bridge?','Can you teleport me back up to the bridge?',26124),
(142639,'enUS','The vessel has been found!','',26124),
(142640,'enUS','It wants the Sunwell!','',26124),
(142659,'enUS','A pity you remain defiant. The patience of the masters is vast... but not infinite.','',26124),
(142660,'enUS','A minor setback. What is in motion cannot be undone. Surely you see this.','',26124),
(142666,'enUS','The void will transform you... awaken what you were meant to be.','',26124),
(142667,'enUS','Do you not see what we offer? The majesty of chaos... the glory of infinite hunger!','',26124),
(142668,'enUS','Why do you fight your destiny, Windrunner? Join me and rule by my side!','',26124),
(142670,'enUS','So be it. Your death is regrettable... but necessary.','',26124),
(142672,'enUS','My people were reshaped by the void. Stripped of the limitations of flesh. We offer you the same gift.','',26124),
(142674,'enUS','Even shattered as it is, this place echoes with the whispers of the great ones who were slain... and the hatred of he who broke this world.','',26124),
(142686,'enUS','','Dark forces surge through these ashen stones. No wonder the ethereals were drawn here.',26124),
(142688,'enUS','','That vortex up ahead pulses with power. Let us investigate, $p.',26124),
(142689,'enUS','','There! Durzaan is using those forges to draw in power. We must break his hold on Umbric\'s people.',26124),
(142691,'enUS','I offer freedom. I offer strength. Cast off your mortal shackles.','',26124),
(142692,'enUS','','Our destiny is our own, Durzaan! You will not define our future!',26124),
(142696,'enUS','The transformation... incomplete... must... be... finished...','',26124),
(142697,'enUS','','The only thing that will be finished here... is you.',26124),
(142723,'enUS','','If a portal leading into endless nothingness were to open under your feet and consume you in my presence, rest assured it would be entirely coincidental. Accidents do happen, after all.',26124),
(142725,'enUS','','Oh sure, I get physically transformed by a cosmic force known to induce madness and suddenly I\'m considered \"suspicious\". Talk about profiling...',26124),
(142727,'enUS','','What do you seek?',26124),
(142728,'enUS','','I offer rare goods from distant realms.',26124),
(142729,'enUS','','Everything has a price... if you are willing to pay it.',26124),
(142732,'enUS','','I hope you find your purchase to be satisfying.',26124),
(142733,'enUS','','Thank you for browsing.',26124),
(142734,'enUS','','Come back anytime.',26124),
(142736,'enUS','Come back anytime.','',26124),
(142737,'enUS','Thank you for browsing.','',26124),
(142738,'enUS','I hope you find your purchase to be satisfying.','',26124),
(142740,'enUS','Everything has a price... if you are willing to pay it.','',26124),
(142741,'enUS','I offer rare goods from distant realms.','',26124),
(142742,'enUS','What do you seek?','',26124),
(142743,'enUS','Oh sure, I get physically transformed by a cosmic force known to induce madness and suddenly I\'m considered \"suspicious\". Talk about profiling...','',26124),
(142744,'enUS','If a portal leading into endless nothingness were to open under your feet and consume you in my presence, rest assured it would be entirely coincidental. Accidents do happen, after all.','',26124),
(142745,'enUS','\"Remember the Sunwell\"? Please. I am so over it.','',26124),
(142746,'enUS','Your infantile behavior will not provoke me.','',26124),
(142747,'enUS','The Void offers endless possibilities.','',26124),
(142748,'enUS','Power is to be wielded, not feared.','',26124),
(142749,'enUS','Unchecked emotion leads to ruin.','',26124),
(142750,'enUS','The whispers do not control me.','',26124),
(142751,'enUS','My fate is my own.','',26124),
(142752,'enUS','Do not fear the shadows.','',26124),
(142753,'enUS','Shorel\'aran.','',26124),
(142754,'enUS','New doorways have opened to us.','',26124),
(142755,'enUS','I greet you.','',26124),
(142756,'enUS','The universe is full of mystery.','',26124),
(142757,'enUS','Question everything.','',26124),
(142758,'enUS','We embrace a new future.','',26124),
(142759,'enUS','Walk your own path.','',26124),
(142760,'enUS','Bal\'a dash, malanore.','',26124),
(142762,'enUS','','Bal\'a dash, malanore.',26124),
(142763,'enUS','','Walk your own path.',26124),
(142764,'enUS','','We fight for a new future.',26124),
(142765,'enUS','','Question everything.',26124),
(142767,'enUS','','The universe is full of mystery.',26124),
(142769,'enUS','','I greet you.',26124),
(142770,'enUS','','New doorways have opened to us.',26124),
(142771,'enUS','','Shorel\'aran.',26124),
(142773,'enUS','','There is strength in shadow.',26124),
(142774,'enUS','','Fate is ours to decide.',26124),
(142775,'enUS','','The whispers do not control me.',26124),
(142776,'enUS','','Maintain control. Always.',26124),
(142777,'enUS','','Power is to be wielded, not feared.',26124),
(142778,'enUS','','The Void offers endless possibilities.',26124),
(142779,'enUS','','Your infantile behavior will not provoke me.',26124),
(142780,'enUS','','\"Remember the Sunwell\"? Please. I am so over it.',26124),
(142781,'enUS','','If a portal leading into endless nothingness were to open under your feet and consume you in my presence, rest assured it would be entirely coincidental. Accidents do happen, after all.',26124),
(142782,'enUS','','Oh sure, I get physically transformed by a cosmic force known to induce madness and suddenly I\'m considered \"suspicious\". Talk about profiling...',26124),
(142783,'enUS','','What do you seek?',26124),
(142785,'enUS','','I offer rare goods from distant realms.',26124),
(142786,'enUS','','Everything has a price... if you are willing to pay it.',26124),
(142787,'enUS','','I hope you find your purchase to be satisfying.',26124),
(142788,'enUS','','Thank you for browsing.',26124),
(142789,'enUS','','Come back anytime.',26124),
(142791,'enUS','Come back anytime.','',26124),
(142792,'enUS','Thank you for browsing.','',26124),
(142793,'enUS','I hope you find your purchase to be satisfying.','',26124),
(142794,'enUS','Everything has a price... if you are willing to pay it.','',26124),
(142795,'enUS','I offer rare goods from distant realms.','',26124),
(142796,'enUS','What do you seek?','',26124),
(142797,'enUS','Oh sure, I get physically transformed by a cosmic force known to induce madness and suddenly I\'m considered \"suspicious\". Talk about profiling...','',26124),
(142798,'enUS','If a portal leading into endless nothingness were to open under your feet and consume you in my presence, rest assured it would be entirely coincidental. Accidents do happen, after all.','',26124),
(142799,'enUS','\"Remember the Sunwell\"? Please. I am so over it.','',26124),
(142800,'enUS','Your infantile behavior will not provoke me.','',26124),
(142801,'enUS','The Void offers endless possibilities.','',26124),
(142803,'enUS','Power is to be wielded, not feared.','',26124),
(142804,'enUS','Maintain control. Always.','',26124),
(142805,'enUS','The whispers do not control me.','',26124),
(142806,'enUS','Fate is ours to decide.','',26124),
(142807,'enUS','There is strength in shadow.','',26124),
(142808,'enUS','Shorel\'aran.','',26124),
(142809,'enUS','New doorways have opened to us.','',26124),
(142810,'enUS','I greet you.','',26124),
(142811,'enUS','The universe is full of mystery.','',26124),
(142812,'enUS','Question everything.','',26124),
(142813,'enUS','We fight for a new future.','',26124),
(142814,'enUS','Walk your own path.','',26124),
(142815,'enUS','Bal\'a dash, malanore.','',26124),
(142820,'enUS','','Bal\'a dash, malanore.',26124),
(142821,'enUS','','We must each walk our own path.',26124),
(142822,'enUS','','Our people represent a new future.',26124),
(142823,'enUS','','Take no truth for granted.',26124),
(142824,'enUS','','The universe is full of mystery.',26124),
(142825,'enUS','','New opportunities lay before us.',26124),
(142826,'enUS','','The past is written. The future is not.',26124),
(142827,'enUS','','Shorel\'aran.',26124),
(142828,'enUS','','Our people do not fear the shadows.',26124),
(142829,'enUS','','There is no single truth.',26124),
(142830,'enUS','','The whispers do not control us.',26124),
(142831,'enUS','','Every impulse must be held in check.',26124),
(142832,'enUS','','Do not fear power. Control it.',26124),
(142833,'enUS','','Consider all possibilities.',26124),
(142834,'enUS','','Your infantile behavior will not provoke me.',26124),
(142835,'enUS','','\"Remember the Sunwell\"? Please. I am so over it.',26124),
(142836,'enUS','','If a portal leading into endless nothingness were to open under your feet and consume you in my presence, rest assured it would be entirely coincidental. Accidents do happen, after all.',26124),
(142837,'enUS','','Oh sure, I get physically transformed by a cosmic force known to induce madness and suddenly I\'m considered \"suspicious\". Talk about profiling...',26124),
(142838,'enUS','','What do you seek?',26124),
(142839,'enUS','','I offer rare goods from distant realms.',26124),
(142840,'enUS','','Everything has a price... if you are willing to pay it.',26124),
(142841,'enUS','','I hope you find your purchase to be satisfying.',26124),
(142842,'enUS','','Thank you for browsing.',26124),
(142843,'enUS','','Come back anytime.',26124),
(142844,'enUS','Come back anytime.','',26124),
(142845,'enUS','Thank you for browsing.','',26124),
(142846,'enUS','I hope you find your purchase to be satisfying.','',26124),
(142847,'enUS','Everything has a price... if you are willing to pay it.','',26124),
(142848,'enUS','I offer rare goods from distant realms.','',26124),
(142849,'enUS','What do you seek?','',26124),
(142850,'enUS','Oh sure, I get physically transformed by a cosmic force known to induce madness and suddenly I\'m considered \"suspicious\". Talk about profiling...','',26124),
(142851,'enUS','If a portal leading into endless nothingness were to open under your feet and consume you in my presence, rest assured it would be entirely coincidental. Accidents do happen, after all.','',26124),
(142852,'enUS','\"Remember the Sunwell\"? Please. I am so over it.','',26124),
(142853,'enUS','Your infantile behavior will not provoke me.','',26124),
(142854,'enUS','Consider all possibilities.','',26124),
(142855,'enUS','Do not fear power. Control it.','',26124),
(142856,'enUS','Every impulse must be held in check.','',26124),
(142857,'enUS','The whispers do not control us.','',26124),
(142858,'enUS','There is no single truth.','',26124),
(142859,'enUS','Our people do not fear the shadows.','',26124),
(142860,'enUS','Shorel\'aran.','',26124),
(142861,'enUS','The past is written. The future is not.','',26124),
(142862,'enUS','New opportunities lay before us.','',26124),
(142863,'enUS','The universe is full of mystery.','',26124),
(142864,'enUS','Take no truth for granted.','',26124),
(142865,'enUS','Our people represent a new future.','',26124),
(142866,'enUS','We must each walk our own path.','',26124),
(142867,'enUS','Bal\'a dash, malanore.','',26124),
(142872,'enUS','Something seeks to open a rift into the chamber. If it comes through, we may lose the Sunwell.','',26124),
(142873,'enUS','','I can close the rift--but I will need help.',26124),
(142874,'enUS','','Tell us what to do, and we will lend our strength.',26124),
(142875,'enUS','The door opens. Yes... this should suit our needs.','',26124),
(142876,'enUS','','Now! Focus your power with mine!',26124),
(142877,'enUS','You only delay the inevitable! I will yet have my prize.','',26124),
(142878,'enUS','The Sunwell is secure. Your aid was invaluable, Thalyssra. And yours, champion.','',26124),
(142879,'enUS','Guards! Seize this saboteur.','',26124),
(142880,'enUS','','I will not be taken prisoner in my own homeland.',26124),
(142881,'enUS','Enough! You will leave at once, Alleria. Accident or no, your presence poses a danger to Quel\'Thalas. Go back to Stormwind. Silvermoon is no longer your home.','',26124),
(142882,'enUS','','As you command, Regent Lord. For now.',26124),
(142883,'enUS','I regret you had to witness that exchange, Thalyssra. This is not how I planned your visit to unfold.','',26124),
(142884,'enUS','','On the contrary. This conflict has demonstrated your dedication to your people. I can see that the Horde has allowed you to uphold your traditions--something that is very important to us.',26124),
(142885,'enUS','','We gain strength from our allies... but we have not lost who we are.',26124),
(142886,'enUS','','Suramar will always be our home. But some among my people wish to venture out into the world, to claim our place in Azeroth once again. To do that, we need allies.',26124),
(142887,'enUS','The Horde offers that to you, First Arcanist. Join us. The gates of Silvermoon stand open to you.','',26124),
(142888,'enUS','','On behalf of the nightborne, I accept your proposal. From this day forth, Suramar fights for the Horde.',26124),
(142889,'enUS','Excellent! Lady Liadrin, please return to Orgrimmar and tell the warchief the good news.','',26124),
(142890,'enUS','','It will be my pleasure, Regent Lord. I will meet you in Silvermoon, champion.',26124),
(142910,'enUS','','Alleria tenses defiantly.',26124),
(142986,'enUS','Good luck, $p. As for me, I am going to test my skill in Ashenvale. For the Horde!','',26124),
(142999,'enUS','Champion... \'tis good ta see a familiar face in these dark times.','',26124),
(143000,'enUS','Since returnin\' from Argus, the cries o\' Azeroth have been... overwhelmin\'. Such pain...','',26124),
(143001,'enUS','I don\'t know how ta fix this. Not sure anyone does. But we\'ve gotta keep tryin\'.','',26124),
(143002,'enUS','The storm\'s gatherin\', $p. If we don\'t find a way ta heal Azeroth... nothin\' else is gonna matter.','',26124),
(143013,'enUS','You\'re anxious. You hide it well... but I know you.','',26124),
(143014,'enUS','','Like no other, my love.',26124),
(143015,'enUS','You don\'t have to go. You don\'t have to see her.','',26124),
(143016,'enUS','Each of you has a path to follow. If the Light wills that those paths intersect, they will. There\'s no need to force the hand of fate.','',26124),
(143017,'enUS','','It is time, Turalyon. I must see my homeland again with my own eyes... and hear from Sylvanas how she could ever wear the mantle of warchief.',26124),
(143018,'enUS','It is unsettling to look upon these memorials to our passing.','',26124),
(143019,'enUS','','Indeed. Sometimes I feel that I have already died twice. Once when we were presumed lost on Draenor, and again when gripped by the shadow of the fallen naaru.',26124),
(143020,'enUS','','Perhaps death is the true legacy of the Windrunners.',26124),
(143078,'enUS','Come, friend $p.','',26124),
(143124,'enUS','','Warchief Sylvanas Windrunner, this is First Arcanist Thalyssra of Suramar.',26124),
(143144,'enUS','','An honor, Warchief. I have fought alongside both Lady Liadrin and the regent lord. Their courage is a credit to your Horde.',26124),
(143145,'enUS','','Indeed, First Arcanist.',26124),
(143146,'enUS','','The Horde embodies strength. Determination. Individuality. Traits we shal\'dorei value as well.',26124),
(143147,'enUS','','It is time for the nightborne to find allies among the kingdoms of Azeroth. If you will have us, we would be proud to pledge our forces to your cause.',26124),
(143148,'enUS','','For millennia Suramar stood alone. This day, you become part of something greater. I accept your oath of service, Thalyssra.',26124),
(143149,'enUS','','Suramar stands with the Horde!',26124),
(143150,'enUS','','For the Horde!',26124),
(143151,'enUS','','For the Horde!',26124),
(143172,'enUS','','High King Wrynn, $p and I found the sin\'dorei exiles. Like me, they have been changed by the void--but their hearts and minds remain their own.',26124),
(143173,'enUS','','I will be their guide. I will train them to control the whispers of shadow. In return, they will fight for the Alliance against all its foes.',26124),
(143175,'enUS','It may take time for these void elves to earn the trust of some in our ranks. But so long as they adhere to your teachings, they are welcome in the Alliance.','',26124),
(143176,'enUS','You have done us a great service this day, Lady Windrunner, $p. You have my thanks.','',26124),
(143178,'enUS','','It is an honor to serve once more, High King. For the Alliance!',26124),
(143179,'enUS','For the Alliance!','',26124),
(143203,'enUS','','Some will tell you that the Light is the only path. The one weapon that can stop the enemies of Azeroth.',26124),
(143204,'enUS','','But we see alternatives. Many roads--many possibilities--that are open to us.',26124),
(143205,'enUS','There will be those who doubt you. Who question your resolve, your ability to harness powers that have caused the downfall of weaker wills.','',26124),
(143206,'enUS','','Use the lessons I have taught you to maintain control. Become a weapon for the Alliance... even as you skirt the edge of darkness.',26124),
(143228,'enUS','','Throughout your journeys across Azeroth, you have achieved mastery over the forces that constantly seek to control you.',26124),
(143234,'enUS','','You have become a formidable weapon of the Alliance, $p. Return to the void rift so that we may honor your accomplishment.',26124),
(143236,'enUS','','Many doubted that the ren\'dorei could harness the power of the void without falling prey to its influence. You have proven them wrong.',26124),
(143241,'enUS','','Let this armor remind you of all you have achieved, $p. Accept it with my thanks.',26124),
(143270,'enUS','','You are among the first shal\'dorei to venture forth and explore the wilds of Azeroth. But now it is time to come home.',26124),
(143271,'enUS','','Return to Suramar so that we may thank you for helping our people reclaim a place in this world.',26124),
(143273,'enUS','','You have shown the Horde--and all the people of Azeroth--that the nightborne possess the will and the courage to defend our world.',26124),
(143275,'enUS','','I present you with the traditional garb of Suramar. Wear it as a reminder of our ancient past... and the new future we will forge alongside our allies.',26124),
(143276,'enUS','','When our city faced its darkest hour, the heroes of Azeroth fought with us to drive out the Legion. Some did so reluctantly.',26124),
(143277,'enUS','','But the sin\'dorei--the blood elves--showed us respect and understanding. Their kinship proved there were others in Azeroth who share our values.',26124),
(143284,'enUS','','Stars guide you, $p. I have heard intriguing talk of the Hillsbrad Foothills. I will likely journey there.',26124),
(143287,'enUS','We share much with the Highmountain tauren. It is my belief that they would make ideal allies in the time to come.','',26124),
(143288,'enUS','','Now it is our turn to demonstrate the strength and honor we bring to the Horde.',26124),
(143289,'enUS','What do we know about the Highmountain tauren?','What do we know about the Highmountain tauren?',26124),
(143290,'enUS','','$n, I am glad you are here. We must convince the warchief to pursue an allegiance with the nightborne.',26124),
(143291,'enUS','What do we know about the nightborne?','What do we know about the nightborne?',26124),
(143292,'enUS','','As you travel the roads of Azeroth, tell those you meet of the nightborne\'s proud history... and show them that we live in seclusion no longer.',26124),
(143293,'enUS','','Go to Orgrimmar. Join with our allies and forge a new future together.',26124),
(143327,'enUS','Light be with you, $n. I plan to  seek the Legion upon Azeroth to continue our eternal battle.','',26124),
(143328,'enUS','','I have only heard stories of Stormwind before now. I will explore its streets and the wonders it holds. May the shadows guide you, $n.',26124),
(143468,'enUS','','Greetings, Lady Liadrin, $p. Welcome back to Suramar. I am pleased to receive you under more pleasant circumstances.',26124),
(143469,'enUS','','It is good to see your city free, First Arcanist.',26124),
(143470,'enUS','','For that, we owe you both a great debt. You proved instrumental to our cause.',26124),
(143471,'enUS','','The Horde was proud to fight by your side against the Burning Legion, my lady.',26124),
(143472,'enUS','','I must admit, when I first learned of the Horde, I was skeptical that we would share common ground.',26124),
(143473,'enUS','','I thought our kin from Kalimdor would make obvious allies. But their arrogance and mistrust soon proved otherwise.',26124),
(143474,'enUS','','Arcanist Thalyssra. I remember where your order stood in the War of the Ancients. How do we know you won\'t betray us and become the next Elisande... the next Azshara?',26124),
(143475,'enUS','','We do not intend to be slaves to the Nightwell. We seek to drive the Legion from Suramar and put an end to Elisande\'s oppression.',26124),
(143476,'enUS','','The kaldorei will fight to see the Legion defeated and the Nightwell destroyed. Beyond that... we shall see where Elune\'s wisdom guides us.',26124),
(143477,'enUS','','It would seem \"Elune\'s wisdom\" guided her away from the bond we once shared. So be it.',26124),
(143478,'enUS','','The sin\'dorei are also scorned by Tyrande and her prideful lot. Yet for many ages her people slept in dens or hid in trees while my people fought to save this world.',26124),
(143479,'enUS','','The Alliance feels too walled off... too cloistered. My people will never endure such stagnation again.',26124),
(143480,'enUS','','That is why I am grateful for your invitation to Silvermoon. I would like to inquire whether there could be a place for the nightborne in your Horde.',26124),
(143481,'enUS','','I am sure the regent lord will be pleased to learn of your interest. Are you ready to depart?',26124),
(143482,'enUS','','It would be an honor, Lady Liadrin. Oculeth has the coordinates to your capital. I will gather Silgryn and Valtrois, and meet you in Silvermoon.',26124),
(143483,'enUS','Champions, azerite deposits have been located on an island off the coast of Feralas. We must secure them before the Horde does.','',26124),
(143484,'enUS','We\'ve brought our ship around to the center of the island. Collect as much azerite as you can. It is the key to victory!','',26124),
(143485,'enUS','Horde vessel incoming! No doubt that scum followed us here. Battle stations!','',26124),
(143486,'enUS','There\'s a rich azerite deposit below us, heroes. Get down there and collect all you can. And if those Horde marauders gets in your way... put them down!','',26124),
(143487,'enUS','We have spotted more azerite eruptions around the island! The locations are marked on your map.','',26124),
(143488,'enUS','Heroes! We\'re dropping supplies down to you. Don\'t let the Horde get their hands on them!','',26124),
(143489,'enUS','You\'re doing well so far, heroes. But we need more azerite!','',26124),
(143490,'enUS','You kept that azerite out of the Horde\'s hands. Well done!','',26124),
(143491,'enUS','You\'re doing good work. Just a bit more azerite and the day is ours!','',26124),
(143492,'enUS','More azerite eruptions! Locate them on your map and secure those sites!','',26124),
(143493,'enUS','Supplies incoming! Grab them, champions!','',26124),
(143494,'enUS','Nicely done, champions! King Wrynn will be pleased to learn of your victory. For the Alliance!','',26124),
(143495,'enUS','Damn! The Horde got the upper hand this time. But I swear upon Lion\'s Rest that we will yet claim victory!','',26124),
(143496,'enUS','You all look like a sturdy lot. Hmm... could use another rogue or two, I\'d say... but you\'ll do!','',26124),
(143497,'enUS','Fire! Take out those healers!','',26124),
(143498,'enUS','These Horde think they\'re clever. Teach them a lesson!','',26124),
(143499,'enUS','Fight for the king! Fight for the Alliance!','',26124),
(143500,'enUS','Drive them out! This island is ours!','',26124),
(143501,'enUS','Champions of the Horde! We have found Azerite deposits on some wretched island off the Feralas coast. It is your duty to secure it in the name of the Dark Lady!','',26124),
(143502,'enUS','Your mission here is simple. Collect every bit of azerite and leave nothing for the Alliance to find. I trust that isn\'t too hard to grasp.','',26124),
(143503,'enUS','Alliance vessel incoming! Those curs are lapping at our heels. Well, get to battle stations!','',26124),
(143504,'enUS','Let me have a look at you. Ugh... pathetic! Why aren\'t there any dark rangers in your ranks? Well, you\'ll have to do.','',26124),
(143505,'enUS','Down there... azerite! Take it for our warchief. And should those Alliance get in your way, litter the beach with their corpses. Move!','',26124),
(143506,'enUS','Supplies are on the way. I better not see the Alliance getting them before you do!','',26124),
(143507,'enUS','Grab these supplies, if you need them. But don\'t lose sight of the Banshee Queen\'s prize!','',26124),
(143508,'enUS','An acceptable first effort, but we need more azerite!','',26124),
(143509,'enUS','Ha! Snatched it out of the Alliance\'s hands! Well struck!','',26124),
(143510,'enUS','Almost there. Do not relent. More azerite!','',26124),
(143511,'enUS','There are more azerite eruptions around this blasted island! Check your map to find them.','',26124),
(143512,'enUS','Zounds! There\'s even more azerite to be had. Follow your map and lock down those sites!','',26124),
(143513,'enUS','Fire! Don\'t leave one of those bastards breathing!','',26124),
(143514,'enUS','The Alliance calls those soldiers? Miserable! That one can barely swing a sword!','',26124),
(143515,'enUS','Take them down! You do NOT want to disappoint your warchief!','',26124),
(143516,'enUS','Is that... worgen I smell? It\'s hard to be sure over the overwhelming stench of Alliance self-righteousness.','',26124),
(143517,'enUS','That was far from what I\'d call an elegant victory, but at least you put those Alliance dogs in their place. For the Horde!','',26124),
(143518,'enUS','You... lost? To them? Pathetic! Report to the Undercity for remedial training. Apparently I have to start at square one with you...','',26124),
(143583,'enUS','Welcome, friend $p. I am King Anduin Wrynn. As a new member of the Alliance, I wished to greet you personally.','',26124),
(143584,'enUS','The Lightforged may be a recent addition to our ranks, but I know the draenei well. I am confident you will embody the dedication and courage of the Army of the Light.','',26124),
(143585,'enUS','These are troubled times for Azeroth. In the days to come, you will face many trials... fight many foes. Know that you are never alone against the darkness, for the Alliance stands with you.','',26124),
(143586,'enUS','I look forward to hearing of your progress. Something tells me we will speak again soon.','',26124),
(143587,'enUS','Safe travels, $p. Though you walk among the shadows, you are a beacon of hope to us all.','',26124),
(143589,'enUS','The void elves may be a recent addition to our ranks, but Alleria Windrunner is one of our greatest heroes. Under her tutelage, the powers you wield will aid our cause.','',26124),
(143590,'enUS','Safe travels, $p. May the Light be with you always.','',26124),
(143591,'enUS','','Ah, the young hero $p comes before me. I am told you show great promise. Let us hope these reports prove true.',26124),
(143592,'enUS','','The Highmountain tauren possess strength and courage. We will have need of such qualities in the days to come.',26124),
(143593,'enUS','','The Horde has many rivals in this world. Some call us enemies... others call us outcasts. But we find strength in unity... and in defiance of those who would challenge our freedom.',26124),
(143594,'enUS','','Rest assured, I will be taking note of your progress. As warchief, I expect much of you... and I reward those who serve me well.',26124),
(143595,'enUS','','Enough of these pleasantries. You have much to prove, hero. Wherever your path takes you, know that you fight... for the Horde!',26124),
(143596,'enUS','','The nightborne are a wise and powerful people. The ancient knowledge you possess will prove a great boon to our cause.',26124),
(143598,'enUS','$p, High King Wrynn requests that you rendezvous with me at Stormwind.','',26124),
(143599,'enUS','We\'ve uncovered certain... sensitive information that he insists you be made aware of.','',26124),
(143600,'enUS','Find me at Lion\'s Rest. And needless to say, keep the details of this meeting between us.','',26124),
(143601,'enUS','$p! The Dark Lady instructs you to meet me in Orgrimmar.','',26124),
(143602,'enUS','Information has come to light crucial to the interests of the Horde. It is imperative we remain a step ahead of our rivals.','',26124),
(143603,'enUS','Meet me outside Grommash Hold. Keep this quiet... or the consequences will be swift and severe.','',26124),
(143604,'enUS','You have seen the devastation in Silithus with your own eyes, $p. You know what is at stake.','',26124),
(143605,'enUS','The Horde will stop at nothing to claim the lifeblood of Azeroth. I fear that after the war against the Legion, our ranks are too depleted to stave off their aggression.','',26124),
(143606,'enUS','It is time for the Alliance to bring in new members to join our cause. We have established an embassy in Stormwind to spearhead these efforts. Meet me there.','',26124),
(143607,'enUS','','You have observed our operations in Silithus, $p. Clearly the Alliance is doing everything in its power to undermine our efforts.',26124),
(143608,'enUS','','The Horde\'s selfless leadership in the war against the Legion has left our ranks depleted. Our enemies slaver at the thought of stealing what is ours. We will not let them.',26124),
(143609,'enUS','','I\'ve authorized the building of an embassy in Orgrimmar. From it, we will win others to our cause. Meet me there at once.',26124),
(143610,'enUS','My arrogance was nearly our undoing. I dabbled with powers far beyond my control. If you will train us, Alleria, we will follow where you lead.','',26124),
(143611,'enUS','','I sense the powers at your command. They are... considerable. You would make valuable allies of the Alliance.',26124),
(143612,'enUS','Silvermoon turned its back on us long ago. Today we are reborn... and it is fitting that we walk a new path. From this day forth, the Alliance has our loyalty.','',26124),
(143613,'enUS','','And in turn, I pledge to aid you on your journey. $p and I will inform High King Wrynn of this news. Then I will return, so that we can begin your training.',26124),
(143614,'enUS','It will take some time for us to adjust to our new forms. We look forward to your return, Lady Windrunner. And $p... you have our deepest thanks.','',26124),
(143615,'enUS','Together, we will prove them wrong.','',26124),
(143616,'enUS','','These woods once brought such joy to me and my sisters. To see them like this... fills my heart with sorrow.',26124),
(143617,'enUS','','<Landing from jump: Total 3>',26124),
(143620,'enUS','<Landing from jump: Total 3>','',26124),
(143621,'enUS','<Distressed cry: Total 3>','',26124),
(143622,'enUS','','<Landing from jump: Total 3>',26124),
(143623,'enUS','<Landing from jump: Total 3>','',26124),
(143624,'enUS','Our void experiments are proceeding well. I am certain we are on the cusp of a breakthrough... despite Rommath\'s smallminded protests.','',26124),
(143625,'enUS','The grand magister must understand that this power is crucial to the defense of Silvermoon. Never again shall the sin\'dorei fall prey to our enemies!','',26124),
(143626,'enUS','Unfortunately, it seems our research has reached an impasse. I believe there is knowledge at the Andilien Estate that will springboard us forward.','',26124),
(143627,'enUS','','<Landing from jump: Total 3>',26124),
(143628,'enUS','','It seems we have found some notes.',26124),
(143629,'enUS','<Landing from jump: Total 3>','',26124),
(143630,'enUS','It seems we are not the first of our people seeking to harness the void. I have found notebooks belonging to one whose very name is a curse... Dar\'Khan Drathir.','',26124),
(143631,'enUS','It was Drathir\'s betrayal that allowed Arthas to corrupt the Sunwell... and left our kingdom in ruins. For the first time, I see why Rommath opposes our course of study.','',26124),
(143632,'enUS','Nevertheless, I believe this knowledge can be used for good. The bulk of Drathir\'s research was conducted at Dawnstar Spire. That is where we must go.','',26124),
(143633,'enUS','','Come. We must make our way to Dawnstar Spire.',26124),
(143634,'enUS','<Landing from jump: Total 3>','',26124),
(143635,'enUS','Drathir\'s quest for power led him to seek the fragments of an ancient world, one teetering on the brink of the Void itself.','',26124),
(143636,'enUS','His notes said it existed within a rift in the very fabric of reality. He never found this place... but I have succeeded where he failed. The way will soon be open to us!','',26124),
(143637,'enUS','Drathir believed this rift held an ancient object of unspeakable might. Perhaps this will be the key that allows us to gain control over the shadows.','',26124),
(143638,'enUS','','<Landing from jump: Total 3>',26124),
(143639,'enUS','','Based on these notes, I believe I can reopen the passage to this world he spoke of. Let me see...',26124),
(143640,'enUS','','There, up ahead. That must be Umbric.',26124),
(143641,'enUS','','Magister Umbric! I am Alleria Windrunner.',26124),
(143642,'enUS','Alleria Windrunner!? How did... My, what an unexpected honor!','',26124),
(143643,'enUS','My people and I heard tales of what transpired on Argus. As you might imagine, we have a keen interest in your interaction with the darkened naaru.','',26124),
(143644,'enUS','','Another time, perhaps. This champion and I have been searching for you. We know of your exile from Silvermoon and felt we shared common ground.',26124),
(143645,'enUS','Indeed! Like you, we believe the void can be used to defend life rather than consume it. We have made great progress, Lady Windrunner, but many mysteries remain.','',26124),
(143646,'enUS','Take this cube, for instance. It is an ancient device, perhaps even predating life on Azeroth. It seems to have been locked, and we cannot yet open it.','',26124),
(143647,'enUS','','Careful, Umbric. Answers to such mysteries often come at a price.',26124),
(143662,'enUS','I greet you on behalf of Silvermoon.','',26124),
(143663,'enUS','Bal\'a dash, malanore.','',26124),
(143664,'enUS','I proudly serve as regent lord.','',26124),
(143665,'enUS','We have made many sacrifices.','',26124),
(143666,'enUS','The rebuilding continues.','',26124),
(143667,'enUS','The eternal sun still guides us.','',26124),
(143668,'enUS','The beauty of Eversong endures.','',26124),
(143669,'enUS','Silvermoon will know prosperity again.','',26124),
(143670,'enUS','The Light of the Sunwell be with you.','',26124),
(143671,'enUS','What I do, I do for Quel\'Thalas.','',26124),
(143672,'enUS','We find strength in the Horde.','',26124),
(143673,'enUS','Al diel shala.','',26124),
(143674,'enUS','We are a nation on the rise.','',26124),
(143675,'enUS','Never again shall a king reign in Silvermoon.','',26124),
(143676,'enUS','Hair like this does not just happen on its own. It requires constant attention.','',26124),
(143677,'enUS','Queen\'s champion or no, I can out-shoot Nathanos any day of the week.','',26124),
(143678,'enUS','Working for Sylvanas has its... challenges. Being dead has made her even bossier. But, uh... do not tell her I said that.','',26124),
(143679,'enUS','My eye patch has never switched sides! I mean... who would mix up something like that?','',26124),
(143680,'enUS','Greetings, traveler.','',26124),
(143681,'enUS','Bal\'a dash, malanore.','',26124),
(143682,'enUS','The shadows serve us.','',26124),
(143683,'enUS','We embrace power. We do not fear it.','',26124),
(143684,'enUS','All paths are possible.','',26124),
(143685,'enUS','Come with an open mind.','',26124),
(143686,'enUS','I have much to teach you.','',26124),
(143687,'enUS','The ren\'dorei shall prove our worth.','',26124),
(143688,'enUS','The Light is not the only path.','',26124),
(143689,'enUS','We serve the Alliance.','',26124),
(143690,'enUS','Shadows watch over you.','',26124),
(143691,'enUS','Be open to possibilities.','',26124),
(143692,'enUS','Do not bend to the whispers.','',26124),
(143693,'enUS','Maintain focus and control.','',26124),
(143694,'enUS','High elf? Please. Why would you want to be a high elf when you can look all tragic and brooding?','',26124),
(143695,'enUS','I admit, purple was never my favorite color. But lately it\'s growing on me. Literally.','',26124),
(143696,'enUS','I suppose I can forgive you for not being a fan of elves. After all, half of us dislike the other half rather intensely.','',26124),
(143697,'enUS','Alleria and Turalyon? No chance. I mean... not that I am rooting against them or anything, but... Uh, do we have to keep talking about this?','',26124),
(143699,'enUS','We established a makeshift base in Silithus. Check in with our operatives there--and keep your eyes open for Horde aggression.','',26124),
(143700,'enUS','Gallywix has operations underway in Silithus. Get there at once. And if you see any Alliance skulking about, make quick work of them.','',26124),
(143712,'enUS','','At long last, the ceaseless posturing between the Horde and the Alliance is coming to an end.$b$bThe time for war is at hand.',26124),
(143713,'enUS','I am ready to pursue our next ally.','I am ready to pursue our next ally.',26124),
(143726,'enUS','','State your business to your Warchief.',26124),
(143727,'enUS','','I trust you will not waste my time.',26124),
(143728,'enUS','','Come forward.',26124),
(143729,'enUS','','Greetings, champion.',26124),
(143730,'enUS','','Our true work is just beginning.',26124),
(143731,'enUS','','There will be a new future for the Horde.',26124),
(143732,'enUS','','Serve me well, and you will be rewarded.',26124),
(143733,'enUS','','Go. I have much to do.',26124),
(143735,'enUS','','Serve the Horde. Serve me.',26124),
(143736,'enUS','','We will bring the Alliance to its knees.',26124),
(143737,'enUS','','I will grow the ranks of the Forsaken. One way... or another.',26124),
(143738,'enUS','','All will serve the Horde in time.',26124),
(143739,'enUS','','We will claim what is ours.',26124),
(143741,'enUS','','The lifeblood of Azeroth belongs to the Horde.',26124),
(143742,'enUS','','No doubt I am your favorite Windrunner sister... right? Right?',26124),
(143743,'enUS','','I have taken note of your progress. It seems I may have to send you to Nathanos for remedial training.',26124),
(143744,'enUS','','Did you think I would not notice the way you leer at my dark rangers? I suggest you keep your eyes--and thoughts--to yourself.',26124),
(143745,'enUS','','Plans? Little old me? What sort of plans could I possibly have?',26124),
(143747,'enUS','The Sunwell must be protected.','',26124),
(143748,'enUS','What is it?','',26124),
(143749,'enUS','Do not squander resources.','',26124),
(143750,'enUS','I am rather busy.','',26124),
(143751,'enUS','I serve Silvermoon.','',26124),
(143752,'enUS','What would you ask of me?','',26124),
(143753,'enUS','The eternal sun still guides us.','',26124),
(143754,'enUS','Respect our customs.','',26124),
(143755,'enUS','Do not let outsiders interfere.','',26124),
(143756,'enUS','Be about your work.','',26124),
(143757,'enUS','We build our future upon the backbone of tradition.','',26124),
(143758,'enUS','We have overcome much.','',26124),
(143759,'enUS','For Quel\'Thalas.','',26124),
(143760,'enUS','It would be unwise to oppose us.','',26124),
(143761,'enUS','If you would all just do what I say instead of attempting to think for yourselves, Azeroth would be much better off.','',26124),
(143762,'enUS','Kirin Tor? More like Kirin Snore. Am I right?','',26124),
(143763,'enUS','Khadgar? More like Badghar. Am I right?','',26124),
(143764,'enUS','Jaina? More like Paina. Modera? More like... uh... look, you cannot expect me to hit gold every time, okay?','',26124),
(143767,'enUS','T\'paartos!','',26124),
(143768,'enUS','T\'paartos?','',26124),
(143769,'enUS','T\'paartos greets puny one.','',26124),
(143770,'enUS','Puny one needs something of T\'paartos?','',26124),
(143771,'enUS','Danger? T\'paartos scoffs at danger!','',26124),
(143772,'enUS','Light be with you, friend.','',26124),
(143773,'enUS','T\'paartos is ready!','',26124),
(143775,'enUS','T\'paartos.','',26124),
(143776,'enUS','T\'paartos will see you soon.','',26124),
(143777,'enUS','T\'paartos has much to do.','',26124),
(143778,'enUS','T\'paartos must get back to work now.','',26124),
(143779,'enUS','Come back to T\'paartos anytime.','',26124),
(143780,'enUS','T\'paartos is proud to be Lightforged!','',26124),
(143781,'enUS','T\'paartos is still slightly afraid of snakes.','',26124),
(143782,'enUS','Puny one is not trying to take advantage of T\'paartos\' good nature... are you?','',26124),
(143783,'enUS','Sure, T\'paartos has read books. Books with few words and many pictures... but they still count.','',26124),
(143784,'enUS','List of things T\'paartos does not like: snakes, mean children, snakes, dark caves, snakes... and puny ones who pester T\'paartos.','',26124),
(143785,'enUS','They appear to have all fallen for my act! I find it extraordinary that they believe I could be so simple-minded as to... Wait, you mean they can hear me? I, uh... T\'paartos!','',26124),
(143786,'enUS','Two pairs of toes. Two pairs o\' toes. T\'pairs o\'toes. T\'pair o\'toes. T\'paar o\'toes. T\'paartoes. T\'paartos. T\'paartos!','',26124),
(143881,'enUS','You. Over here.','',26124),
(143882,'enUS','Over here!','',26124),
(143883,'enUS','Look out!','',26124),
(143884,'enUS','This way.','',26124),
(143885,'enUS','This way.','',26124),
(143886,'enUS','Look out!','',26124),
(143887,'enUS','Over here!','',26124),
(143888,'enUS','Champion. Over here.','',26124),
(144262,'enUS','','<Alleria\'s eyes drift from the statue\'s cold stone visage down to the plaque engraved with her epitaph.>',26124),
(144263,'enUS','<Stay awhile and listen.>','<Stay awhile and listen.>',26124),
(144264,'enUS','','Alleria sighs, her brow furrowed.',26124),
(144269,'enUS','Good. Good! Once more!','',26124),
(144301,'enUS','Now, focus your chi. Push the energy away from you.','',26124),
(144305,'enUS','I still cannot believe my brothers and sisters succumbed to the fel.','I still cannot believe my brothers and sisters succumbed to the fel.',26124),
(144308,'enUS','ZZZzzz...','ZZZzzz...',26124),
(144309,'enUS','<The sleeping Tauren snores loudly and rolls over.>','<The sleeping Tauren snores loudly and rolls over.>',26124),
(144310,'enUS','Thank you for dealing with Torok. He refused to see the dangers behind the power he sought.','Thank you for dealing with Torok. He refused to see the dangers behind the power he sought.',26124),
(144321,'enUS','Our corrupted brothers and sisters still wander in the wilds.','Our corrupted brothers and sisters still wander in the wilds.',26124),
(144322,'enUS','I\'m glad I did not have to give EVERYTHING.','I\'m glad I did not have to give EVERYTHING.',26124),
(144323,'enUS','When healing, you must gather your inner strength and pass it along to another.','',26124),
(144324,'enUS','Focused chi is extremely potent. Master Tau Li will guide you once you are ready.','',26124),
(144325,'enUS','Expending too much energy at once is dangerous. Pace yourselves, students.','',26124),
(144326,'enUS','Excellent! Again, from the beginning.','',26124),
(144365,'enUS','','What\'s that? A light in the darkness! It\'s so bright...',26124),
(144366,'enUS','','It\'s gotten a little brighter! I can see... sorta.',26124),
(144367,'enUS','','Nuu-Nuu! I was scared I\'d never see you again! How did you get here?',26124),
(144368,'enUS','','A crown! So pretty!',26124),
(144369,'enUS','','I used to have a wand like that! Lost it a long time ago.',26124),
(144370,'enUS','','It\'s dark again! Where did you go? Don\'t leave me!',26124),
(144371,'enUS','','No! Let me go! Help, friend! HELP!',26124),
(144383,'enUS','These portals are incredibly tedious to sustain and, more importantly, they take attention away from valuable research!$B$BI am certain that telemancy will allow us to achieve a more stable solution.','',26124),
(144384,'enUS','I hear Dalaran has an entire floor dedicated to magical transportation. $B$BImagine the possibilities!','',26124),
(144386,'enUS','You can use the Orgrimmar portal to meet our Horde allies in their capital city on Kalimdor.','',26124),
(144394,'enUS','Some of our vintners have given up tending their vines and have taken up other forms of botany.','',26124),
(144395,'enUS','I brought samples to dispel the unfounded rumors that our wine tastes too footy... I mean too fruity!','',26124),
(144396,'enUS','','The nightborne are truly free. We no longer need the Nightwell, nor its power.$B$BWe can forge our own destiny.',26124),
(144397,'enUS','','The business with Elisande is over, but there is still much to be done for the city.',26124),
(144399,'enUS','','It\'s so dark! I can\'t see a thing!',26124),
(144400,'enUS','','Who are you? Can you help me?',26124),
(144401,'enUS','','Help! HELP!',26124),
(144402,'enUS','','At least we\'re together now. We just... don\'t know where we are.',26124),
(144403,'enUS','','But you\'re my friend, and I know it\'s gonna be okay.',26124),
(144404,'enUS','','I wish I could see better. It\'s always so dark here!',26124),
(144442,'enUS','','It\'s too bright! Too bright! Owww!',26124),
(144444,'enUS','','Oh, hi! Who are you? I\'m Uuna. Wanna be friends? Maybe together we can get outta this place.',26124),
(144445,'enUS','','I wish Nuu were here. He\'d know what to do.',26124),
(144563,'enUS','','Directing chi energy at a target can be difficult at first.\n\nYou, at the front! Try to hit that training dummy over there.',26124),
(144564,'enUS','','Very good! I\'m quite impressed!',26124),
(144565,'enUS','I will keep watch over him. He seems happy enough to wander around the gardens.','I will keep watch over him. He seems happy enough to wander around the gardens.',26124),
(144566,'enUS','There is persisting structural damage and unstable energy in the aqueducts. The gate will remain closed for the moment.','There is persisting structural damage and unstable energy in the aqueducts. The gate will remain closed for the moment.',26124),
(144567,'enUS','','Nuu is here to help us, friend. I knew you\'d find us, Nuu!',26124),
(144568,'enUS','Argus the Unmaker is deploying Reorigination Modules!','Argus the Unmaker is deploying Reorigination Modules!',26124),
(144575,'enUS','','I\'ll hold onto him so he doesn\'t get lost again.',26124),
(144621,'enUS','','Greetings, $p! New lands and allies await us across Azeroth.$B$BOculeth has portals prepared downstairs when you are ready.',26124),
(144672,'enUS','I am glad to see that Arluelle continues her training. She appears stronger already.$B$BPerhaps I should measure her improvement.','',26124),
(144674,'enUS','The Duskwatch will do well having Victoire in its ranks once more.','',26124),
(144676,'enUS','It is a pity the Lightforged could not be convinced to join our side. Their martial prowess is formidable.','',26124),
(144677,'enUS','','I have a feeling our city will be called upon soon. I plan to be ready when the time comes.',26124),
(144678,'enUS','','<Arluelle has a faraway look in her eyes.>$B$BIf only my brother could see the city now...',26124),
(144712,'enUS','','It shoots stars! Bad guys really hate that.',26124),
(144713,'enUS','','You can\'t fight the dark without a crown, friend. It\'s the rules.',26124),
(144714,'enUS','T\'PAARTOS!','',26124),
(144715,'enUS','','I feel a lot better now.',26124),
(144716,'enUS','T\'paartos is here!','',26124),
(144721,'enUS','The Darkness comes...','The Darkness comes...',26124),
(144722,'enUS','MAKE IT STOP!','MAKE IT STOP!',26124),
(144723,'enUS','Your death is necessary.','Your death is necessary.',26124),
(144725,'enUS','The shadows will consume you.','The shadows will consume you.',26124),
(144726,'enUS','Listen to the whispers. They are beautiful.','Listen to the whispers. They are beautiful.',26124),
(144745,'enUS','','Again, T\'paartos? How many times have you...',26124),
(144749,'enUS','Not enough times to stop T\'paartos!','',26124),
(144750,'enUS','T\'paartos offers gratitude to Lysara. T\'paartos feels ready to fight again!','',26124),
(144751,'enUS','','Even the finest weapon will dull with too much use. Take some time to fully heal, T\'paartos.',26124),
(144752,'enUS','Thank you, champion.','Thank you, champion.',26124),
(144753,'enUS','The whispers... they were driving me mad!','The whispers... they were driving me mad!',26124),
(144754,'enUS','I must... My mind... Must get away from this place!','I must... My mind... Must get away from this place!',26124),
(144755,'enUS','It was horrible, $r.','It was horrible, $r.',26124),
(144756,'enUS','Earthmother bless you!','Earthmother bless you!',26124),
(144757,'enUS','I believed my mind was forfeit.','I believed my mind was forfeit.',26124),
(144758,'enUS','The Lightforged Vindicator groans.','The Lightforged Vindicator groans.',26124),
(144759,'enUS','Light preserve me... he\'s back.','Light preserve me... he\'s back.',26124),
(144760,'enUS','Shh! Don\'t move! His vision is based on movement.','Shh! Don\'t move! His vision is based on movement.',26124),
(144770,'enUS','I am fresh out of materials for the moment. My apologies.','',26124),
(144772,'enUS','It is good to rest once in a while.$B$BEspecially after a profitable venture!','',26124),
(144799,'enUS','My agents have secured this area, but we should still keep our voices down lest our conversation is overheard...','',26124),
(144800,'enUS','Tell me what happened at Lion\'s Rest.','Tell me what happened at Lion\'s Rest.',26124),
(144804,'enUS','He is in high spirits today, no?','',26124),
(144806,'enUS','','Oh yes, just like yesterday, the day before... and the day before that!',26124),
(144807,'enUS','','An admirable quality, I quite like that about him.',26124),
(144825,'enUS','Our agents have already infiltrated the goblin mining operation below. We\'ll know what they\'re up to soon enough...','',26124),
(144826,'enUS','','Friend? Is that you?',26124),
(144827,'enUS','','I won\'t give up, friend! I promise!',26124),
(144828,'enUS','','I\'m just so cold, and it\'s very dark here. I don\'t know what to do!',26124),
(144833,'enUS','Haha! T\'paartos is glad to see you are well! T\'paartos also brought a present. This little one was in Val\'sharah.','',26124),
(144834,'enUS','','There you are! That\'s much better.',26124),
(144835,'enUS','','They\'re gonna be here, soon, friend.',26124),
(144836,'enUS','','I keep running and running... but they always find me.',26124),
(144837,'enUS','','But now you\'re here. Together we can fight them! I think...',26124),
(144838,'enUS','','Promise you won\'t leave me, friend. Even when it gets dark...',26124),
(144839,'enUS','','T\'paartos!',26124),
(144840,'enUS','The Dark Lady has an important job for you, $c. I hope that you are ready...','',26124),
(144841,'enUS','Tell me what happened at the feast.','Tell me what happened at the feast.',26124),
(144842,'enUS','','Aww!',26124),
(144845,'enUS','T\'paartos must return this little one now. Say farewell, children.','',26124),
(144846,'enUS','Do not worry! T\'paartos will return with more stories... and perhaps another friend.','',26124),
(144847,'enUS','','It\'s T\'paartos!',26124),
(144848,'enUS','','He\'s back!',26124),
(144849,'enUS','','No! Stay and tell us adventure stories, T\'paartos!',26124),
(144850,'enUS','','Can I keep it?',26124),
(144851,'enUS','','The tail is so fluffy!',26124),
(144853,'enUS','Our bravest warriors are often in the vanguard. It is the least I can do to watch over their families until they return.','Our bravest warriors are often in the vanguard. It is the least I can do to watch over their families until they return.',26124),
(144862,'enUS','','T\'paartos showed us how to play boulder, parchment, blade... but I forgot the rules.',26124),
(144863,'enUS','I\'m looking for a little girl named Uuna, have you seen her?','I\'m looking for a little girl named Uuna, have you seen her?',26124),
(144864,'enUS','Light be with you.','Light be with you.',26124),
(144866,'enUS','','I have heard the cries of the child you speak of.\n\nI shall mark you, that you may pass into this realm and seek her out.\n\nShe resides in a place where the barrier between the realms of life and death are thin, and spill over into your world.\n\nBe warned, you have no power in this place, its denizens cannot be harmed by mortals.\n\nTry as you might, you may not be able to aid your friend.',26124),
(144873,'enUS','<A green dragon\'s tear, cast in shadow by unknown forces.>','',26124),
(144875,'enUS','<Touch the tear.>','<Touch the tear.>',26124),
(144895,'enUS','','They\'re here...',26124),
(144896,'enUS','','You have missed your payment one too many times, Mr. Stonebrow. I am repossessing the goods, per our contract.',26124),
(144897,'enUS','I mailed ye the check this morning, I swear! Ye can\'t leave me high and dry!','',26124),
(144898,'enUS','','Mister Chu, please see this dwarf out. Ms. Xiulan, re-list the armor.',26124),
(144899,'enUS','%s nods.','',26124),
(144900,'enUS','','Go away! We\'re not afraid of you!',26124),
(144901,'enUS','','Yes, madam.',26124),
(144902,'enUS','Keep yer paws off me, fuzzball!','',26124),
(144903,'enUS','','It seems you are in luck today, Mr. Stonebrow. You may take back the goods.',26124),
(144904,'enUS','Yer damn right I will! I bought this armor fair and square, even if I ain\'t done payin\' for it.','',26124),
(144905,'enUS','Ahh, that\'s better. Armor befitting a mighty hero! One whose legendary deeds shake the very foundations of Azeroth!','',26124),
(144906,'enUS','Welp, I\'m off to the tavern.','',26124),
(144907,'enUS','Thanks for yer help, $Glad:lass;! I owe ye one!','',26124),
(144908,'enUS','The Vindicaar awaits its next voyage.\n\nAs do I.','',26124),
(144921,'enUS','','Light take this table! I may never be able to use this workshop again.$B$BThe taint of those beast hides from Argus lingers, no matter how many times I scrub the surface.',26124),
(144923,'enUS','If it is Maela you\'re looking for, she is assisting on the front lines.$B$BStormwind is home to various competent tailors that can teach you a thing or two.','',26124),
(144924,'enUS','','<Fareeya greets you with a warm smile.>$B$BYou have done well in passing the trials, $c. But I feel your tale is just beginning.',26124),
(144925,'enUS','','Always carry with you what it means to be pledged to the Light.',26124),
(144926,'enUS','','Greetings, $c.',26124),
(144994,'enUS','','Yes, of course I still love him. Must you be so nosey?',26124),
(145018,'enUS','','Sisters are complicated. Especially the undead ones.',26124),
(145022,'enUS','','My void will consume you... if you ask nicely.',26124),
(145026,'enUS','','I go missing for all those years and this is how you treat me?',26124),
(145027,'enUS','','It is a good day for a hunt.',26124),
(145028,'enUS','','Use every weapon at your disposal.',26124),
(145031,'enUS','','What news?',26124),
(145036,'enUS','','We each walk a line. Choose yours.',26124),
(145038,'enUS','','Greetings.',26124),
(145039,'enUS','','The shadows can be an ally... if controlled.',26124),
(145040,'enUS','','Farewell.',26124),
(145041,'enUS','','Aim true.',26124),
(145042,'enUS','','We do what we must for those we love.',26124),
(145043,'enUS','','Keep your gaze fixed on your target.',26124),
(145102,'enUS','Curious.','Curious.',26124),
(145140,'enUS','','Friend? Are you still there? I\'m scared!',26124),
(145141,'enUS','','I--I can\'t do it! I just wanna go home!',26124),
(145142,'enUS','','Uuna wraps her arms around herself and begins to cry.',26124),
(145154,'enUS','','F-friend, you\'re here! You didn\'t leave me!',26124),
(145155,'enUS','','Mama told me the Light would always find me. That\'s you, friend. You\'re my light!',26124),
(145156,'enUS','','And as long as my light is with me, there\'s no way the darkness can win!',26124),
(145158,'enUS','','My light is super strong!',26124),
(145159,'enUS','','I\'M NOT GONNA BE AFRAID ANYMORE!',26124),
(145171,'enUS','I can hear the cries of the world beneath my feet. Azeroth trembles in pain! I must find a way to ease the suffering...','',26124),
(145172,'enUS','I am ready. Let us begin the ritual.','I am ready. Let us begin the ritual.',26124),
(145185,'enUS','','The darkness is gone! I can see!',26124),
(145186,'enUS','','Oh, friend! We did it! We beat them!',26124),
(145187,'enUS','','What... what\'s happening?',26124),
(145188,'enUS','','The light... it\'s telling me to follow it...',26124),
(145189,'enUS','','Mama! Papa! They\'re waiting for me!',26124),
(145190,'enUS','','Wait a sec...',26124),
(145191,'enUS','','There\'s so much I never got to do. So many places I never got to see...',26124),
(145192,'enUS','','Is it okay if I stay with my friend? For just a little while longer?',26124),
(145193,'enUS','','Friend! The Light says I can stay! Woo-hoo!',26124),
(145194,'enUS','','Tell Mama and Papa I miss them, and... and I\'ll see them soon!',26124),
(145195,'enUS','','Okay, friend, let\'s get outta here! We have so many places to go!',26124),
(145197,'enUS','','Uuna hugs you.',26124),
(145199,'enUS','','Wow! That\'s the biggest wall I\'ve ever seen!',26124),
(145200,'enUS','','What do you suppose they wanted to keep out?',26124),
(145201,'enUS','','Is it bugs? I bet it\'s bugs. Yuck! I hate bugs!',26124),
(145202,'enUS','','Ewwwww!!',26124),
(145203,'enUS','','Wow! That\'s gotta be the prettiest house ever!',26124),
(145204,'enUS','','Do you know who lives here? I bet it\'s a princess.',26124),
(145205,'enUS','','Do you wanna play princesses with me?',26124),
(145206,'enUS','','Whoa... a flying city! Are you serious?!',26124),
(145207,'enUS','','How does it do that?',26124),
(145208,'enUS','','Do you live here?',26124),
(145209,'enUS','','Come to think of it... do you live ANYwhere?',26124),
(145210,'enUS','','Hey, what are those flying things? They\'re so pretty!',26124),
(145211,'enUS','','That\'s a big tower. It\'s like a... giant birdhouse!',26124),
(145212,'enUS','','But for lizard birds.',26124),
(145213,'enUS','','Can I have one for a pet?',26124),
(145218,'enUS','','Friend, look! We\'re under a giant tree!',26124),
(145221,'enUS','','I wonder how many birds live in that tree. Must be so many!',26124),
(145225,'enUS','','Like... TEN birds!',26124),
(145237,'enUS','','Caw caw caw caw caw!',26124),
(145240,'enUS','','I can see everything from here!',26124),
(145241,'enUS','','I didn\'t know mountains could go this high!',26124),
(145243,'enUS','','Don\'t fall off, friend! I\'ll be okay if I fall, but you\'d go SPLAT!',26124),
(145245,'enUS','','So be careful, okay?',26124),
(145246,'enUS','','Where are we? Why is it so smoky?',26124),
(145247,'enUS','','Look down there. It\'s all glowing!',26124),
(145253,'enUS','','But it\'s moving like water... it\'s a glowing lake?',26124),
(145254,'enUS','','That\'s really silly, friend.',26124),
(145255,'enUS','','It\'s... so beautiful...',26124),
(145256,'enUS','','My people are here! They survived!',26124),
(145257,'enUS','','They didn\'t all die on Argus?',26124),
(145258,'enUS','','Thank you SO MUCH for showing me this, friend!',26124),
(145263,'enUS','','You\'ve shown me so many neat things. You really are the best friend ever!',26124),
(145265,'enUS','','I know someday I\'ll have to go back to Mama and Papa.',26124),
(145266,'enUS','','But... not yet.',26124),
(145275,'enUS','','Gaaahhh! No! Help!',26124),
(145276,'enUS','Uuna is swallowed by darkness.','Uuna is swallowed by darkness.',26124),
(145721,'enUS','','The evolutionary biology of the silithid species is extraordinarily fascinating!',26124),
(145890,'enUS','We\'re a bit busy right now, as you can see.','We\'re a bit busy right now, as you can see.',26124),
(145891,'enUS','Open fire!','Open fire!',26124),
(145892,'enUS','<The elf\'s concentration wavers momentarily and he gives you a withering look.>','<The elf\'s concentration wavers momentarily and she gives you a withering look.>',26124),
(145893,'enUS','With Alleria\'s teaching, we can avoid the fate suffered by those on Mac\'Aree.','',26124),
(145895,'enUS','','The voices never stop. They push, they bully, they plead. They will not relent, not even for a moment.\n\nBut you are stronger than the voices. You can glean their secrets and draw upon their strength.',26124),
(145896,'enUS','Fascinating.\n\nI sensed that change was destined to find Alleria Windrunner, but I did not anticipate that her kin would undergo a similar transformation.\n\nThe implications are many. These events have given me much to ponder.','',26124),
(145897,'enUS','We need no longer fear exile for the pursuit of knowledge.','We need no longer fear exile for the pursuit of knowledge.',26124),
(145898,'enUS','A path long denied to us is open at last.','A path long denied to us is open at last.',26124),
(145977,'enUS','Find us a wee bit o\' cloth and I\'ll be good to go!','',26124),
(146006,'enUS','Be wary of unstable void rifts and their spawn. This place is not entirely safe.','Be wary of unstable void rifts and their spawn. This place is not entirely safe.',26124),
(146007,'enUS','Oh, you made it.','',26124),
(146008,'enUS','Wonderful.','',26124),
(146009,'enUS','Why have you returned?','',26124),
(146010,'enUS','Congratulations.','',26124),
(146011,'enUS','It is designed to kill you.','',26124),
(146012,'enUS','I imagine it is quite painful.','',26124),
(146013,'enUS','I am told power comes from unlikely places.','',26124),
(146014,'enUS','For now.','',26124),
(146015,'enUS','Perhaps.','',26124),
(146016,'enUS','Fine.','',26124),
(146017,'enUS','I am afraid I cannot allow that.','',26124),
(146018,'enUS','When mixed with natural gas, liquid Azerite can harden quickly making it easy for us to obtain. Keep your eyes peeled down below for unstable activity on the surface. With these tremors happening recently... its bound to spout out of cracks or fissures you find.','',26124),
(146019,'enUS','We\'ve observed strong geothermal energy readings around this uncharted island. \n\nAzerite, for sure!','',26124),
(146020,'enUS','What can you tell me about the Lightforged draenei?','What can you tell me about the Lightforged draenei?',26124),
(146021,'enUS','What do we know about the void elves?','What do we know about the void elves?',26124),
(146022,'enUS','War is coming to Azeroth, $n. It is time for us to bring in new allies to join our cause.','',26124),
(146023,'enUS','Ahh... this silk feels better than rain on a summer morning...','',26124),
(146024,'enUS','I am ready to pursue our next ally.','I am ready to pursue our next ally.',26124),
(146025,'enUS','Now, I\'ll just light a wee match to take care of the fumes...','',26124),
(146026,'enUS','FIRE!!','',26124),
(146027,'enUS','AAAAHHHHHHHHHHHH!!','',26124),
(146029,'enUS','That was a close one! I\'d better take inventory. Eyebrows... check. Beard... check. Pants...','',26124),
(146030,'enUS','No time for pants, then! I need to see if there\'s a burn clinic nearby...','',26124),
(146031,'enUS','Oohhh...','',26124),
(146032,'enUS','Ouch!','',26124),
(146033,'enUS','Eeek...','',26124),
(146044,'enUS','','Salutations! How can I help you?',26124),
(146045,'enUS','I\'d like to check my mail.','I\'d like to check my mail.',26124),
(146049,'enUS','Incoming!','Incoming!',26124),
(146050,'enUS','Void outbreak! Take them down!','Void outbreak! Take them down!',26124),
(146064,'enUS','','Looks like the Postmaster needs me right away. Toodles!',26124),
(146067,'enUS','','The mail must go through! \'Til next time!',26124),
(146068,'enUS','','Oh my, I\'m late! Those letters won\'t sort themselves!',26124),
(146069,'enUS','','I\'m afraid my time is up. See you later!',26124),
(146070,'enUS','','You rang?',26124),
(146071,'enUS','','Katy Stampwhistle, reporting for duty!',26124),
(146072,'enUS','','When there\'s mail to declare, you bet I\'ll be there!',26124),
(146073,'enUS','','The mail must flow!',26124),
(146080,'enUS','Thanks again, $n. I\'ll be seein\' ye! I\'m off to find some pants...','',26124),
(146083,'enUS','Och! I forgot mah pants!','',26124),
(146090,'enUS','Pristine void energy is soaked into this space... Magnificent.','Pristine void energy is soaked into this space... Magnificent.',26124),
(146098,'enUS','The Voidstorm is growing. It might even consume the big island entirely.','The Voidstorm is growing. It might even consume the big island entirely.',26124),
(146099,'enUS','Unchecked void energies ravage the other islands. It remains too dangerous to navigate.','Unchecked void energies ravage the other islands. It remains too dangerous to navigate.',26124),
(146105,'enUS','','Voila!',26124),
(146117,'enUS','My, my, what do we have here?','',26124),
(146118,'enUS','How did you know we were here, I wonder?','',26124),
(146119,'enUS','You mortals are all the same. Fighting, but not knowing what for.','',26124),
(146120,'enUS','Pity. You would have made an excellent servant.','',26124),
(146122,'enUS','Meddling where we shouldn\'t, I see. Understandable.','',26124),
(146148,'enUS','Maintain your focus.','Maintain your focus.',26124),
(146149,'enUS','Yeah? Whaddya want?','Yeah? Whaddya want?',26124),
(146150,'enUS','Hey! Mind yah business!','Hey! Mind yah business!',26124),
(146151,'enUS','I ain\'t got time for this. Spit it out already!','I ain\'t got time for this. Spit it out already!',26124),
(146152,'enUS','Time is money!','Time is money!',26124),
(146153,'enUS','Hand over all of the azerite you\'ve pocketed!','Hand over all of the azerite you\'ve pocketed!',26124),
(146154,'enUS','','One portal, coming up!',26124),
(146159,'enUS','You have learned basic control. Mastery, however, can only be attained through practical application.','',26124),
(146165,'enUS','Thankfully, this place is well suited for--','',26124),
(146178,'enUS','I ain\'t gonna let you take my azerite!','I ain\'t gonna let you take my azerite!',26124),
(146179,'enUS','I stole it fair and square! It\'s mine!','I stole it fair and square! It\'s mine!',26124),
(146180,'enUS','Oohh... Now you\'re gonna pay!','Oohh... Now you\'re gonna pay!',26124),
(146181,'enUS','You\'re messin wit\' the wrong goblin, bub!','You\'re messin wit\' the wrong goblin, bub!',26124),
(146182,'enUS','It\'s mine! MINE!','It\'s mine! MINE!',26124),
(146183,'enUS','Ow! Enough! You can keep it!','Ow! Enough! You can keep it!',26124),
(146184,'enUS','I give up! Here, take it!','I give up! Here, take it!',26124),
(146185,'enUS','I give, I give!!','I give, I give!!',26124),
(146186,'enUS','Mercy! Here take it, I didn\'t want it anyway!','Mercy! Here take it, I didn\'t want it anyway!',26124),
(146187,'enUS','Do hurry, $nistine or whatever you said it was, or I shall find another plebeian upon whom to bestow this great honor!','',26124),
(146188,'enUS','Uncle! Take all of it! I don\'t want it anymore!','Uncle! Take all of it! I don\'t want it anymore!',26124),
(146189,'enUS','Behind you!','Behind you!',26124),
(146191,'enUS','How convenient! I could not have timed this better myself.','',26124),
(146192,'enUS','What are you waiting for? Concentrate and banish this creature!','',26124),
(146194,'enUS','R-right!','R-right!',26124),
(146195,'enUS','Pathetic.','',26124),
(146200,'enUS','I don\'t feel so good...','I don\'t feel so good...',26124),
(146201,'enUS','Calm yourself and it will pass.','',26124),
(146202,'enUS','Your emotions expose weakness. The Void will exploit that if you let it.','',26124),
(146212,'enUS','For the Alliance!','For the Alliance!',26124),
(146213,'enUS','','Don\'t worry about the airship, I\'ll keep an eye out for any... unwanted guests.',26124),
(146214,'enUS','Any alliance get aboard this ship, they\'ll be incinerated.','',26124),
(146231,'enUS','Although broken and scattered, this rift holds many secrets. It will teach us much about the nature of the shadows.','',26124),
(146233,'enUS','Open fire!','',26124),
(146237,'enUS','The mail must go through!','',26124),
(146238,'enUS','I want to sort letters!','I want to sort letters!',26124),
(146239,'enUS','I need help sorting these letters!','',26124),
(146350,'enUS','','We\'ve barely finished fighting the Burning Legion and the Horde is already up to no good!',26124),
(146351,'enUS','Alright! Alright! I\'ll get back to work!','Alright! Alright! I\'ll get back to work!',26124),
(146352,'enUS','I was just taking a break!','I was just taking a break!',26124),
(146353,'enUS','Back to work! I get it!','Back to work! I get it!',26124),
(146354,'enUS','You don\'t have to get physical! I\'ll get back to work!','You don\'t have to get physical! I\'ll get back to work!',26124),
(146355,'enUS','I was just resting my eyes!','I was just resting my eyes!',26124),
(146356,'enUS','They sent in the muscle! Run for it!','They sent in the muscle! Run for it!',26124),
(146357,'enUS','It isn\'t often one gets the opportunity to study a new mineral!$b$bWho knows what mysteries the azerite holds!','',26124),
(146358,'enUS','I won\'t be staying long, so we must speak quickly.','',26124),
(146359,'enUS','We will take this land for the glory of the Horde!','',26124),
(146360,'enUS','','Dissecting giant bugs ain\'t an easy way to make a living, but it sure does pay well!',26124),
(146361,'enUS','ODYN\'S BEARD! I\'M BURNIN\' UP!','',26124),
(146362,'enUS','Remain in control of your thoughts. The void cannot sway that which is immutable.','',26124),
(146367,'enUS','Now you\'re gonna get it!','Now you\'re gonna get it!',26124),
(146368,'enUS','I\'m gonna teach you a lesson!','I\'m gonna teach you a lesson!',26124),
(146369,'enUS','Don\'t mess with the cartel!','Don\'t mess with the cartel!',26124),
(146370,'enUS','You\'re gonna regret pickin\' a fight with me!','You\'re gonna regret pickin\' a fight with me!',26124),
(146371,'enUS','No trespassing!','No trespassing!',26124),
(146372,'enUS','I hope you like bloody noses!','I hope you like bloody noses!',26124),
(146373,'enUS','The reckoning has come early for you!','',26124),
(146374,'enUS','Ogmot gonna eat your soul! HAHAHA!','',26124),
(146375,'enUS','Filthy $r, I\'ll make you bleed!','Filthy $r, I\'ll make you bleed!',26124),
(146376,'enUS','You\'re going to pay for your crimes against the Alliance!','You\'re going to pay for your crimes against the Alliance!',26124),
(146377,'enUS','Death is upon you!','Death is upon you!',26124),
(146378,'enUS','Don\'t die too quickly! I want to enjoy this!','Don\'t die too quickly! I want to enjoy this!',26124),
(146379,'enUS','Now you see me, but soon you won\'t!','Now you see me, but soon you won\'t!',26124),
(146380,'enUS','Horde scum! Die!','Horde scum! Die!',26124),
(146422,'enUS','','Welcome! Now where are the chairs?$B$BOh. Feel free to pull up that... block of wood and sit...down?',26124),
(146423,'enUS','','Honestly, if the local cuisine wasn\'t absolutely mouthwatering I wouldn\'t know what to do with myself.',26124),
(146431,'enUS','Incredible! The surrounding area alone houses at least forty species of plants I am unfamiliar with.','',26124),
(146432,'enUS','Give me a challenge! I want to sort the letters with partial addresses.','Give me a challenge! I want to sort the letters with partial addresses.',26124),
(146433,'enUS','Still plenty of letters to sort, if you\'re up to it!$B$BOr how about something more challenging? We also receive letters without a full address on them.$B$BThink you can handle it?','',26124),
(146434,'enUS','Excellent work, $n! You might be ready for something more challenging... Speak with me if you\'re interested!','',26124),
(146448,'enUS','','This workshop is a bit \"rustic\" for my tastes.',26124),
(146449,'enUS','','Non-magical devices are for mana-starved whelps, they said. Non-magical devices serve no purpose, they said. $B$BOrgrimmar practically runs on such creations!$B$BTime for me to show those palanquin-addled wretches back home the perfection of machinery!',26124),
(146461,'enUS','','Walk the path that Huln took so very long ago, and bring honor to the name... Highmountain.',26124),
(146462,'enUS','','And in turn, we have been reborn as instruments of its power.',26124),
(146463,'enUS','','But to those who would threaten this world... or attack our allies... you will embody the Light\'s wrath.',26124),
(146471,'enUS','','Have you gathered the information I require?',26124),
(146472,'enUS','','Yes, here are the results.',26124),
(146473,'enUS','','...you have done well. My master shall be pleased to see this.',26124),
(146475,'enUS','','Venture forth alongside new allies and show the world that the legacy of the nightborne is one of nobility... and strength.',26124),
(146476,'enUS','','Its whispers have broken the will of dragons... and lured even the titans\' own children into madness.',26124),
(146477,'enUS','','That the Void is a power to be harnessed... to be bent by a will strong enough to command it.',26124),
(146482,'enUS','','Wield the shadows as a weapon to save our world... and defend the Alliance!',26124),
(146516,'enUS','The void energy released when the ethereals attacked left the other islands unstable. No one is allowed beyond this point.','The void energy released when the ethereals attacked left the other islands unstable. No one is allowed beyond this point.',26124),
(146517,'enUS','The last people who ventured beyond this space were consumed by the shadows.','The last people who ventured beyond this space were consumed by the shadows.',26124),
(146522,'enUS','Come to have your equipment repaired?$B$BOr would you like some quality tools of your own?','',26124),
(146543,'enUS','','Looking for a lift? Going someplace special I hope!',26124),
(146544,'enUS','I need a flight to Staghelm Point.','I need a flight to Staghelm Point.',26124),
(146552,'enUS','Your connection to the spirits begins to fade...','Your connection to the spirits begins to fade...',26124),
(146561,'enUS','Time heals all wounds... especially when you can travel back in time, to before the wound occurred!','',26124),
(146562,'enUS','Show me Silithus before it was pierced.','Show me Silithus before it was pierced.',26124),
(146563,'enUS','Take me back to the present.','Take me back to the present.',26124),
(146605,'enUS','','All our attention is focused on foiling the Horde\'s efforts. We can\'t spare resources to make this flight network fully functional.\n\nIf you need to fly away from this wretched desert, you\'ll have to manage it yourself.\n\nShould you be facing a dire emergency, I suppose I could cobble together resources for a single flight...',26124),
(146606,'enUS','I need to meet with Magni Bronzebeard at once.','I need to meet with Magni Bronzebeard at once.',26124),
(146636,'enUS','Our orders are to obtain this mysterious ore by any means necessary.','',26124),
(146637,'enUS','','I can\'t wait to see the looks on their greedy faces when all of their shredders are blown to bits!',26124),
(146638,'enUS','','We must find out how the silithid survived the blade of Sargeras!',26124),
(146641,'enUS','We cannot afford a resurgence of the Twilight\'s Hammer. Voidstrider must die!','',26124),
(146736,'enUS','Turn back! You\'re entering uncharted territory','Turn back! You\'re entering uncharted territory',26124),
(146737,'enUS','Your ancestry is rich with stories. Fascinating! I look forward to learning more, $r. Perhaps I should fetch some stronger incense!','',26124),
(146745,'enUS','These goblins are so busy with their extraction equipment that they haven\'t set up a proper flight station.\n\n<Urok grumbles and kicks the dirt.>\n\nIf you\'re lookin\' for a flight outta this place, you\'re on your own.\n\nI guess if the world\'s ending I might be able to figure somethin\' out...','',26124),
(146755,'enUS','','Fools squabble over lands below, while those with vision rule the skies above!',26124),
(146757,'enUS','I need a flight to Southwind Village.','I need a flight to Southwind Village.',26124),
(146851,'enUS','','Don\'t be afraid to get your hands dirty crackin\' those silithid skulls!',26124),
(146854,'enUS','','This research is gonna help us understand the power of that giant blade!',26124),
(146857,'enUS','You gotta take out those dirty SI:7 spies before they ruin the whole operation!','',26124),
(146861,'enUS','Get out there and put those lazy prospectors in their place!','',26124),
(146863,'enUS','We cannot let this fanatic rally the remaining survivors to action! Bring me his head!','',26124),
(146918,'enUS','','Another perfect batch! It smells so tasty!',26124),
(146920,'enUS','This is a very old place. Broken by rage, yet sculpted by the threads of fate. \n\nThere is much to be learned here. I believe I might linger a while.\n\nBe seeing you.','',26124),
(146922,'enUS','What do you know of Telogrus?','What do you know of Telogrus?',26124),
(146958,'enUS','We have a forsaken ambassador, which makes sense given our Warchief, of course.\n\nBut I can\'t help asking myself, \"what has it cost us?\"\n\nIf you have a moment, can you please tell me of your experience with Ambassador Blackguard?','',26124),
(146959,'enUS','Thank you for taking my survey, $n.\n\nI shall present the petition after I have enough signatures.\n\nGood day to you, $r.','',26124),
(146960,'enUS','He was rude and blatantly offensive.','He was rude and blatantly offensive.',26124),
(146961,'enUS','His appearance was off-putting.','His appearance was off-putting.',26124),
(146962,'enUS','He should be replaced immediately!','He should be replaced immediately!',26124),
(147039,'enUS','','The Legion nearly took everything from us... while I blindly trusted Elisande.\n\nI am relieved that Suramar is back in our hands.',26124),
(147040,'enUS','','I suppose I should thank you.$B$B<Anarys dips her head slightly at you.>',26124),
(147041,'enUS','','I stood by and watched as Elisande led us astray.\n\nI was wrong... about everything.',26124),
(147042,'enUS','I suppose I should thank you.$B$B<Anarys dips his head slightly at you.>','',26124),
(147043,'enUS','I stood by and watched as Elisande led us astray.\n\nI was wrong... about everything.','',26124),
(147044,'enUS','Come to gloat, have you?','Come to gloat, have you?',26124),
(147047,'enUS','Oh, goodness me! Did you slip?','',26124),
(147048,'enUS','Best be careful close to the edge, $n.','',26124),
(147049,'enUS','Did you fall, or was that a graceful jump designed to look like a clumsy fall?','',26124),
(147050,'enUS','Watch your step! I can\'t do this all day! Actually, I suppose I can.','',26124),
(147051,'enUS','Are you conducting some kind of dangerous experiment? I like it!','',26124),
(147052,'enUS','If you\'re going to fall to your death, do it somewhere else.','',26124),
(147053,'enUS','Mind the gap.','',26124),
(147084,'enUS','Oh! Hello there... fellow member of the Alliance.\n\nI mean no disrespect, but... I\'m just not entirely sure the cathedral is the most... appropriate place for... for...\n\nFor someone who indulges such... unique proclivities.','',26124),
(147098,'enUS','The Light does not treat with the Void, elf. You should leave this place.','The Light does not treat with the Void, elf. You should leave this place.',26124),
(147100,'enUS','This place is not meant for you.','This place is not meant for you.',26124),
(147104,'enUS','I can sense the shadow in you. Though it is diminished in the presence of the Light.','I can sense the shadow in you. Though it is diminished in the presence of the Light.',26124),
(147109,'enUS','Thank you, but I do not require your aid.','Thank you, but I do not require your aid.',26124),
(147130,'enUS','Have you come to supplicate yourself before the Light? $b$bIf you are here to speak with Archbishop Benedictus, I am sorry to inform you that he has left on a mission.','',26124),
(147153,'enUS','I will help in whatever way I can, but I suggest you do not linger too long here.','I will help in whatever way I can, but I suggest you do not linger too long here.',26124),
(147159,'enUS','I commend your dedication. However, I fear you walk a dangerous path.$B$BYou would best serve the Alliance away from the cathedral.','I commend your dedication. However, I fear you walk a dangerous path.$B$BYou would best serve the Alliance away from the cathedral.',26124),
(147169,'enUS','Tread carefully, $c. Lady Alleria\'s name will only carry you so far.','',26124),
(147173,'enUS','Perhaps is it as Alleria Windrunner says, and the whispers of shadow can be controlled.\n\nBe on your guard, friend, and may the Ligh--\n\nHrm. Well... May fortune favor you.','',26124),
(147183,'enUS','I\'ve spent enough time with clumsy fingers here that I\'ve picked up a thing or two about treating injuries. Perhaps I can offer you some training?','',26124),
(147187,'enUS','I will admit, it took some time to grow accustomed to our transformation. At first, my usual dexterity felt... impeded.$B$BHowever, I can guarantee the techniques themselves have in no way been affected.','',26124),
(147188,'enUS','These machines are fantastic! How could they operate with no anomalies or chance of failure?$B$BOh, excuse me. Did you need something?','',26124),
(147191,'enUS','We have learned much from our fight against the Legion. In truth, these warframes are the culmination of many years of research.$B$BIf you wish, I can train you to craft similar devices.','',26124),
(147192,'enUS','Hmm. Nice try, but you are missing a touch of darkness in that outfit.','',26124),
(147193,'enUS','This is an invitation-only gathering. Did you bring an invitation? No?$B$BI thought not.','',26124),
(147196,'enUS','','What can I do for you?',26124),
(147197,'enUS','Aye, I have a moment. What do ye want?','',26124),
(147200,'enUS','','Do you need something magically enhanced, or have you come to learn?',26124),
(147205,'enUS','I used to be a famous pirate!\n\nThey dig me up, hand me this tophat, then tell me I have to greet all of you newcomers with a smile on my face...','',26124),
(147206,'enUS','Do you have any idea how much it hurts to try to crack a smile?\n\nThis is ridiculous!','',26124),
(147207,'enUS','What do I have to do to get myself out of this job?\n\nI try to leave, some orc picks me up and plops me right back down here.','',26124),
(147208,'enUS','Psst... Yeah, you, $r.\n\nHey, can you put in a bad word for me with the Warchief? I need to get fired. Being a jerk to everyone isn\'t working!','',26124),
(147209,'enUS','I really hated this tophat at first. What does a guy have to do for a good tricorne?\n\nBut I must say... this fits real nicely on my skull.','',26124),
(147210,'enUS','Greetings, Lightforged! Know that you are always welcome here in the Cathedral of Light.','',26124),
(147211,'enUS','To have given yourself wholly to the Light... you are an example to us all.','To have given yourself wholly to the Light... you are an example to us all.',26124),
(147212,'enUS','You will always have steadfast allies here.','You will always have steadfast allies here.',26124),
(147213,'enUS','Should you ever need my assistance, you know where to find me.','Should you ever need my assistance, you know where to find me.',26124),
(147214,'enUS','May the Light ever guide you, $n.','May the Light ever guide you, $n.',26124),
(147217,'enUS','I got the axe.$B$BSee? I brought it with me.','I got the axe.$B$BSee? I brought it with me.',26124),
(147218,'enUS','Downsized? I\'m already about as downsized as you can get!','Downsized? I\'m already about as downsized as you can get!',26124),
(147219,'enUS','Boss Mida says I\'m bein\' discharged. The only things that oughta be discharged are guns and explosives!','Boss Mida says I\'m bein\' discharged. The only things that oughta be discharged are guns and explosives!',26124),
(147220,'enUS','I\'ve been downwardly promoted.','I\'ve been downwardly promoted.',26124),
(147221,'enUS','We\'re here as part of a \"workforce adjustment.\"','We\'re here as part of a \"workforce adjustment.\"',26124),
(147222,'enUS','','The Alliance needs strength. Unity. The king\'s plan to bring in fresh blood is a good one.\n\nBut I can\'t help thinking of my own Dark Iron clan. Of the fractures that divide us.',26124),
(147223,'enUS','','One day Silvermoon will stand again on the side of the Alliance. I know it.',26124),
(147224,'enUS','Much about Azeroth has changed in the years I was absent. But the Alliance remains an ideal worth fighting for.\n\nI will do everything in my power to make it stronger.','',26124),
(147225,'enUS','I used to have a cushy office job in Orgrimmar.','I used to have a cushy office job in Orgrimmar.',26124),
(147226,'enUS','The campaign on Argus was costly, but necessary. Now we must focus on defending our own lands.\n\nWe cannot sit idle while those Horde monsters build their forces.','',26124),
(147227,'enUS','My position has been eliminated... feels like early retirement.','My position has been eliminated... feels like early retirement.',26124),
(147228,'enUS','The young king reminds me so much of his father. More than he realizes, I think.\n\nHe\'s the right person to lead this effort and bring new faces into the Alliance.','',26124),
(147229,'enUS','','It seems like only yesterday that those of us who follow the way of the Tushui pledged to fight for the Alliance. \n\nThough I have great respect for King Anduin, I must confess that I found his father a more capable sparring partner.\n\nPlease do not tell him this.\n\n<Aysa bows.>',26124),
(147231,'enUS','','<Tyrande says nothing. Her brow is furrowed, as if deep in thought.>',26124),
(147233,'enUS','I have spent too long depending on visions to guide me.\n\nIt is time we forge our own fate. Part of that is finding new allies to stand beside us.','',26124),
(147234,'enUS','<Ji Firepaw meditates in silence.>','',26124),
(147235,'enUS','The spirit of Ol\' Vol\'jin still be strong in dis city, mon. Da work ya be doin\' honors his memory.','',26124),
(147236,'enUS','Well, well... the illustrious $ct. Still basking in the glory of your victory over the Legion, no doubt.$B$B<Nathanos rolls his eyes.>$B$BThe Dark Lady has entrusted you with securing new allies for the Horde. For your sake, let us hope her faith has not been misplaced.','',26124),
(147237,'enUS','The local cuisine has some... interesting spice to it.','The local cuisine has some... interesting spice to it.',26124),
(147238,'enUS','Yeah, sure. Allies. I get it.\n\nBut I got a business to run, see. And a rather delicate operation in the works.\n\nSo how about you handle your end and I\'ll handle mine.','',26124),
(147239,'enUS','Diplomacy has never been my strong suit.\n\nThis work is best left in your hands.','',26124),
(147240,'enUS','The Horde needs allies. This is true.\n\nBut to be worthy of a place here, those we recruit must have honor in their hearts. If they lack it, their presence only diminishes us.','',26124),
(147241,'enUS','This drink is green! Why is it green?','This drink is green! Why is it green?',26124),
(147250,'enUS','There are no heroes in oblivion!','There are no heroes in oblivion!',26124),
(147251,'enUS','None shall oppose the Twilight\'s Hammer!','None shall oppose the Twilight\'s Hammer!',26124),
(147252,'enUS','We are the harbingers of destruction!','We are the harbingers of destruction!',26124),
(147253,'enUS','Cry for help... none shall answer you!','Cry for help... none shall answer you!',26124),
(147254,'enUS','The twilight is upon you!','The twilight is upon you!',26124),
(147255,'enUS','None shall withstand the power of our master!','None shall withstand the power of our master!',26124),
(147256,'enUS','I am your destruction!','I am your destruction!',26124),
(147257,'enUS','You will kneel before our master!','You will kneel before our master!',26124),
(147263,'enUS','','They may come from Highmountain, but they sure can get low. It\'s the Highmountain tauren!',26124),
(147264,'enUS','','The moose is loose! Highmountain tauren, GO!',26124),
(147265,'enUS','','Adventurers by day, dancers by night... borne. It\'s time to cheer for the nightborne!',26124),
(147266,'enUS','','An illusion!? Nope... it\'s just the dancing nightborne!',26124),
(147267,'enUS','','Just because you\'re an avatar of darkness doesn\'t mean you can\'t get funky. Hit it, void elves!',26124),
(147268,'enUS','','Get down with your bad self, void elf!',26124),
(147269,'enUS','','Turn off the disco ball and these lightforged draenei will still light up the stage!',26124),
(147270,'enUS','','The lightforged draenei came here to dance and kill demons. And we\'re all out of demons!',26124),
(147271,'enUS','','Remember, control demands sacrifice. Power never comes without a price. You risk losing those closest to you in order to save them.\n\nThis is the bargain we have made.\n\n<Alleria looks away.>',26124),
(147272,'enUS','','Studying this rift has value, but we cannot neglect our duty.\n\nAzeroth must be defended. Our place is out there, fighting for our world.\n\nThe power that flows through us is a weapon. And weapons must be wielded.',26124),
(147276,'enUS','Locus-Walker is an intriguing fellow.\n\nAlleria seems to trust him... to a point.\n\nI think we can learn much from him, so long as we remain wary of his true intentions.','',26124),
(147298,'enUS',':',':',26124),
(147299,'enUS','Khadgar asked me to deliver this letter.','Khadgar asked me to deliver this letter.',26124),
(147304,'enUS','The situation in Silithus is now under our control. I will see to the rest of the operation. Go with honor, $n.','',26124),
(147308,'enUS','','Thanks to you, we are now one step closer to understanding the effect that the blade is having on Silithus!',26124),
(147309,'enUS','I\'ve never seen anythin\' like this in all my years! What can it be?','',26124),
(147310,'enUS','I think we\'ve got the situation in Silithus under control. SI:7 can take the operation from here. Thanks again, $n.','',26124),
(147341,'enUS','The Horde has gathered over 1200 Azerite and is near victory!','',26124),
(147342,'enUS','The Alliance has gathered over 1200 Azerite and is near victory!','',26124),
(147378,'enUS','I\'ve been staring up at that sword all day. Still can\'t believe it\'s real.','I\'ve been staring up at that sword all day. Still can\'t believe it\'s real.',26124),
(147379,'enUS','The world\'s bleeding out. Can you stop it, hero?','The world\'s bleeding out. Can you stop it, hero?',26124),
(147380,'enUS','No way we\'re survivin\' this.','No way we\'re survivin\' this.',26124),
(147381,'enUS','Maybe this is the end of days.','Maybe this is the end of days.',26124),
(147382,'enUS','The doomsayers were right. Azeroth is dying.','The doomsayers were right. Azeroth is dying.',26124),
(147384,'enUS','I should be at home with my family...','I should be at home with my family...',26124),
(147385,'enUS','Sure hope you can do something to save us, hero.','Sure hope you can do something to save us, hero.',26124),
(147387,'enUS','Where are all the other heroes who are supposed to protect us?','Where are all the other heroes who are supposed to protect us?',26124),
(147388,'enUS','Been staring up at that sword all day. Still can\'t believe it\'s real.','Been staring up at that sword all day. Still can\'t believe it\'s real.',26124),
(147389,'enUS','The world\'s bleedin\' out. Hope you can stop it, hero.','The world\'s bleedin\' out. Hope you can stop it, hero.',26124),
(147390,'enUS','Even the Dark Lady can\'t save us now...','Even the Dark Lady can\'t save us now...',26124),
(147391,'enUS','Sure hope the boss knows what he\'s doin\'.','Sure hope the boss knows what he\'s doin\'.',26124),
(147392,'enUS','Ain\'t easy ta meet my quota with that giant sword loomin\' overhead!','Ain\'t easy ta meet my quota with that giant sword loomin\' overhead!',26124),
(147393,'enUS','You\'re in the world savin\' business, ain\'t ya? Maybe you should get ta work!','You\'re in the world savin\' business, ain\'t ya? Maybe you should get ta work!',26124),
(147394,'enUS','Should be earnin\' hazard pay for this!','Should be earnin\' hazard pay for this!',26124),
(147414,'enUS','<Recall the events following Argus>','<Recall the events following Argus>',26124),
(147415,'enUS','<Recall the fallout of the wound in Silithus>','<Recall the fallout of the wound in Silithus>',26124),
(147416,'enUS','<Recall the fallout of the wound in Silithus>','<Recall the fallout of the wound in Silithus>',26124),
(147680,'enUS','This island is ripe with thermal activity. After a geyser plumes, azerite is sure to spill out of the fissures. This has got to be worth a fortune!','This island is ripe with thermal activity. After a geyser plumes, azerite is sure to spill out of the fissures. This has got to be worth a fortune!',26124),
(143003,'enUS','Champions, ye unified yer orders and fought together ta drive the Legion from Azeroth.','',26972),
(143004,'enUS','I know tensions are risin\'... but I\'m callin\' on ye ta stand together once more.','',26972),
(143005,'enUS','Come ta Silithus... while we still have a world left ta fight for!','',26972),
(143006,'enUS','The sword of Sargeras is poisonin\' the very lifeblood of the world.','',26972),
(143007,'enUS','The only vessels capable o\' containin\' that kind o\' power... are the mighty weapons you wield.','',26972),
(143008,'enUS','Raise them up as one.... draw out the corruption from the Dark Titan\'s blade!','',26972),
(143009,'enUS','Together, champions! For Azeroth!','',26972),
(143010,'enUS','Ye did it! Sargeras\' sword has gone dormant. Now, Azeroth\'s not yet healed... but your actions bought us precious time.','',26972),
(143011,'enUS','The energy coursin\' through that weapon o\' yers... I ain\'t seen nothin\' like it! But remember, all power comes with a price.','',26972),
(143012,'enUS','I know there\'s much ta face in the days ahead. But no matter what comes... never forget our duty ta Azeroth!','',26972);

/*Table structure for table `camera_effect` */

DROP TABLE IF EXISTS `camera_effect`;

CREATE TABLE `camera_effect` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `camera_effect` */

/*Table structure for table `camera_effect_entry` */

DROP TABLE IF EXISTS `camera_effect_entry`;

CREATE TABLE `camera_effect_entry` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Duration` float NOT NULL DEFAULT '0',
  `Delay` float NOT NULL DEFAULT '0',
  `Phase` float NOT NULL DEFAULT '0',
  `Amplitude` float NOT NULL DEFAULT '0',
  `AmplitudeB` float NOT NULL DEFAULT '0',
  `Frequency` float NOT NULL DEFAULT '0',
  `RadiusMin` float NOT NULL DEFAULT '0',
  `RadiusMax` float NOT NULL DEFAULT '0',
  `AmplitudeCurveID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EffectType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DirectionType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MovementType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AttenuationType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `camera_effect_entry` */

/*Table structure for table `camera_mode` */

DROP TABLE IF EXISTS `camera_mode`;

CREATE TABLE `camera_mode` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `PositionOffset1` float NOT NULL DEFAULT '0',
  `PositionOffset2` float NOT NULL DEFAULT '0',
  `PositionOffset3` float NOT NULL DEFAULT '0',
  `TargetOffset1` float NOT NULL DEFAULT '0',
  `TargetOffset2` float NOT NULL DEFAULT '0',
  `TargetOffset3` float NOT NULL DEFAULT '0',
  `PositionSmoothing` float NOT NULL DEFAULT '0',
  `RotationSmoothing` float NOT NULL DEFAULT '0',
  `FieldOfView` float NOT NULL DEFAULT '0',
  `Flags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LockedPositionOffsetBase` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LockedPositionOffsetDirection` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LockedTargetOffsetBase` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LockedTargetOffsetDirection` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `camera_mode` */

/*Table structure for table `castable_raid_buffs` */

DROP TABLE IF EXISTS `castable_raid_buffs`;

CREATE TABLE `castable_raid_buffs` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `CastingSpellID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `castable_raid_buffs` */

/*Table structure for table `celestial_body` */

DROP TABLE IF EXISTS `celestial_body`;

CREATE TABLE `celestial_body` (
  `BaseFileDataID` int(11) NOT NULL DEFAULT '0',
  `LightMaskFileDataID` int(11) NOT NULL DEFAULT '0',
  `GlowMaskFileDataID1` int(11) NOT NULL DEFAULT '0',
  `GlowMaskFileDataID2` int(11) NOT NULL DEFAULT '0',
  `AtmosphericMaskFileDataID` int(11) NOT NULL DEFAULT '0',
  `AtmosphericModifiedFileDataID` int(11) NOT NULL DEFAULT '0',
  `GlowModifiedFileDataID1` int(11) NOT NULL DEFAULT '0',
  `GlowModifiedFileDataID2` int(11) NOT NULL DEFAULT '0',
  `ScrollURate1` float NOT NULL DEFAULT '0',
  `ScrollURate2` float NOT NULL DEFAULT '0',
  `ScrollVRate1` float NOT NULL DEFAULT '0',
  `ScrollVRate2` float NOT NULL DEFAULT '0',
  `RotateRate` float NOT NULL DEFAULT '0',
  `GlowMaskScale1` float NOT NULL DEFAULT '0',
  `GlowMaskScale2` float NOT NULL DEFAULT '0',
  `AtmosphericMaskScale` float NOT NULL DEFAULT '0',
  `Position1` float NOT NULL DEFAULT '0',
  `Position2` float NOT NULL DEFAULT '0',
  `Position3` float NOT NULL DEFAULT '0',
  `BodyBaseScale` float NOT NULL DEFAULT '0',
  `SkyArrayBand` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `celestial_body` */

/*Table structure for table `cfg__categories` */

DROP TABLE IF EXISTS `cfg__categories`;

CREATE TABLE `cfg__categories` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `LocaleMask` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CreateCharsetMask` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ExistingCharsetMask` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `cfg__categories` */

/*Table structure for table `cfg__categories_locale` */

DROP TABLE IF EXISTS `cfg__categories_locale`;

CREATE TABLE `cfg__categories_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `cfg__categories_locale` */

/*Table structure for table `cfg__configs` */

DROP TABLE IF EXISTS `cfg__configs`;

CREATE TABLE `cfg__configs` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `MaxDamageReductionPctPhysical` float NOT NULL DEFAULT '0',
  `PlayerAttackSpeedBase` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PlayerKillingAllowed` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Roleplaying` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `cfg__configs` */

/*Table structure for table `cfg__regions` */

DROP TABLE IF EXISTS `cfg__regions`;

CREATE TABLE `cfg__regions` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Tag` text,
  `Raidorigin` int(11) NOT NULL DEFAULT '0',
  `ChallengeOrigin` int(11) NOT NULL DEFAULT '0',
  `RegionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RegionGroup_mask` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `cfg__regions` */

/*Table structure for table `cfg__regions_locale` */

DROP TABLE IF EXISTS `cfg__regions_locale`;

CREATE TABLE `cfg__regions_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Tag_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `cfg__regions_locale` */

/*Table structure for table `char_base_info` */

DROP TABLE IF EXISTS `char_base_info`;

CREATE TABLE `char_base_info` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `RaceID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ClassID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `char_base_info` */

/*Table structure for table `char_base_section` */

DROP TABLE IF EXISTS `char_base_section`;

CREATE TABLE `char_base_section` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `VariationEnum` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ResolutionVariationEnum` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LayoutResType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `char_base_section` */

/*Table structure for table `char_component_texture_layouts` */

DROP TABLE IF EXISTS `char_component_texture_layouts`;

CREATE TABLE `char_component_texture_layouts` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Width` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Height` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `char_component_texture_layouts` */

/*Table structure for table `char_component_texture_sections` */

DROP TABLE IF EXISTS `char_component_texture_sections`;

CREATE TABLE `char_component_texture_sections` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `OverlapSectionMask` int(11) NOT NULL DEFAULT '0',
  `X` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Y` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Width` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Height` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CharComponentTextureLayoutID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SectionType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `char_component_texture_sections` */

/*Table structure for table `char_hair_geosets` */

DROP TABLE IF EXISTS `char_hair_geosets`;

CREATE TABLE `char_hair_geosets` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `HdCustomGeoFileDataID` int(11) NOT NULL DEFAULT '0',
  `RaceID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SexID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VariationID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VariationType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GeosetID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GeosetType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Showscalp` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ColorIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CustomGeoFileDataID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `char_hair_geosets` */

/*Table structure for table `char_sections` */

DROP TABLE IF EXISTS `char_sections`;

CREATE TABLE `char_sections` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `MaterialResourcesID1` int(11) NOT NULL DEFAULT '0',
  `MaterialResourcesID2` int(11) NOT NULL DEFAULT '0',
  `MaterialResourcesID3` int(11) NOT NULL DEFAULT '0',
  `Flags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RaceID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SexID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `BaseSection` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VariationIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ColorIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `char_sections` */

/*Table structure for table `char_shipment` */

DROP TABLE IF EXISTS `char_shipment`;

CREATE TABLE `char_shipment` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `TreasureID` int(11) NOT NULL DEFAULT '0',
  `Duration` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `DummyItemID` int(11) NOT NULL DEFAULT '0',
  `OnCompleteSpellID` int(11) NOT NULL DEFAULT '0',
  `ContainerID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `GarrFollowerID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MaxShipments` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `char_shipment` */

/*Table structure for table `char_shipment_container` */

DROP TABLE IF EXISTS `char_shipment_container`;

CREATE TABLE `char_shipment_container` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `PendingText` text,
  `Description` text,
  `WorkingSpellVisualID` int(11) NOT NULL DEFAULT '0',
  `UiTextureKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WorkingDisplayInfoID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SmallDisplayInfoID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MediumDisplayInfoID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LargeDisplayInfoID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CrossFactionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `BaseCapacity` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GarrBuildingType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GarrTypeID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MediumThreshold` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LargeThreshold` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Faction` tinyint(4) NOT NULL DEFAULT '0',
  `CompleteSpellVisualID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `char_shipment_container` */

/*Table structure for table `char_shipment_container_locale` */

DROP TABLE IF EXISTS `char_shipment_container_locale`;

CREATE TABLE `char_shipment_container_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `PendingText_lang` text,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `char_shipment_container_locale` */

/*Table structure for table `char_start_outfit` */

DROP TABLE IF EXISTS `char_start_outfit`;

CREATE TABLE `char_start_outfit` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ItemID1` int(11) NOT NULL DEFAULT '0',
  `ItemID2` int(11) NOT NULL DEFAULT '0',
  `ItemID3` int(11) NOT NULL DEFAULT '0',
  `ItemID4` int(11) NOT NULL DEFAULT '0',
  `ItemID5` int(11) NOT NULL DEFAULT '0',
  `ItemID6` int(11) NOT NULL DEFAULT '0',
  `ItemID7` int(11) NOT NULL DEFAULT '0',
  `ItemID8` int(11) NOT NULL DEFAULT '0',
  `ItemID9` int(11) NOT NULL DEFAULT '0',
  `ItemID10` int(11) NOT NULL DEFAULT '0',
  `ItemID11` int(11) NOT NULL DEFAULT '0',
  `ItemID12` int(11) NOT NULL DEFAULT '0',
  `ItemID13` int(11) NOT NULL DEFAULT '0',
  `ItemID14` int(11) NOT NULL DEFAULT '0',
  `ItemID15` int(11) NOT NULL DEFAULT '0',
  `ItemID16` int(11) NOT NULL DEFAULT '0',
  `ItemID17` int(11) NOT NULL DEFAULT '0',
  `ItemID18` int(11) NOT NULL DEFAULT '0',
  `ItemID19` int(11) NOT NULL DEFAULT '0',
  `ItemID20` int(11) NOT NULL DEFAULT '0',
  `ItemID21` int(11) NOT NULL DEFAULT '0',
  `ItemID22` int(11) NOT NULL DEFAULT '0',
  `ItemID23` int(11) NOT NULL DEFAULT '0',
  `ItemID24` int(11) NOT NULL DEFAULT '0',
  `PetDisplayID` int(11) NOT NULL DEFAULT '0',
  `ClassID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SexID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `OutfitID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PetFamilyID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RaceID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `char_start_outfit` */

/*Table structure for table `char_titles` */

DROP TABLE IF EXISTS `char_titles`;

CREATE TABLE `char_titles` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Name1` text,
  `MaskID` smallint(6) NOT NULL DEFAULT '0',
  `Flags` tinyint(4) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `char_titles` */

insert  into `char_titles`(`ID`,`Name`,`Name1`,`MaskID`,`Flags`,`VerifiedBuild`) values 
(523,'ВрЕдНаЯ ПеЧеНьКа %s ','ВрЕдНаЯ ПеЧеНьКа %s',374,0,0),
(524,'Valorous %s ','Valorous %s',375,0,0),
(525,'%s, Conqueror of Ice','%s, Conqueror of Ice',376,0,0),
(526,'%s, the Maddening','%s, the Maddening',377,0,0);

/*Table structure for table `char_titles_locale` */

DROP TABLE IF EXISTS `char_titles_locale`;

CREATE TABLE `char_titles_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Name1_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `char_titles_locale` */

/*Table structure for table `character_face_bone_set` */

DROP TABLE IF EXISTS `character_face_bone_set`;

CREATE TABLE `character_face_bone_set` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `BoneSetFileDataID` int(11) NOT NULL DEFAULT '0',
  `SexID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FaceVariationIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Resolution` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `character_face_bone_set` */

/*Table structure for table `character_facial_hair_styles` */

DROP TABLE IF EXISTS `character_facial_hair_styles`;

CREATE TABLE `character_facial_hair_styles` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Geoset1` int(10) unsigned NOT NULL DEFAULT '0',
  `Geoset2` int(10) unsigned NOT NULL DEFAULT '0',
  `Geoset3` int(10) unsigned NOT NULL DEFAULT '0',
  `Geoset4` int(10) unsigned NOT NULL DEFAULT '0',
  `Geoset5` int(10) unsigned NOT NULL DEFAULT '0',
  `RaceID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SexID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VariationID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `character_facial_hair_styles` */

/*Table structure for table `character_loadout` */

DROP TABLE IF EXISTS `character_loadout`;

CREATE TABLE `character_loadout` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `RaceMask` bigint(20) NOT NULL DEFAULT '0',
  `ChrClassID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Purpose` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `character_loadout` */

/*Table structure for table `character_loadout_item` */

DROP TABLE IF EXISTS `character_loadout_item`;

CREATE TABLE `character_loadout_item` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ItemID` int(11) NOT NULL DEFAULT '0',
  `CharacterLoadoutID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `character_loadout_item` */

/*Table structure for table `character_service_info` */

DROP TABLE IF EXISTS `character_service_info`;

CREATE TABLE `character_service_info` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `FlowTitle` text,
  `PopupTitle` text,
  `PopupDescription` text,
  `BoostType` int(11) NOT NULL DEFAULT '0',
  `IconFileDataID` int(11) NOT NULL DEFAULT '0',
  `Priority` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `ProfessionLevel` int(11) NOT NULL DEFAULT '0',
  `BoostLevel` int(11) NOT NULL DEFAULT '0',
  `Expansion` int(11) NOT NULL DEFAULT '0',
  `PopupUITextureKitID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `character_service_info` */

/*Table structure for table `character_service_info_locale` */

DROP TABLE IF EXISTS `character_service_info_locale`;

CREATE TABLE `character_service_info_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `FlowTitle_lang` text,
  `PopupTitle_lang` text,
  `PopupDescription_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `character_service_info_locale` */

/*Table structure for table `chat_channels` */

DROP TABLE IF EXISTS `chat_channels`;

CREATE TABLE `chat_channels` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Shortcut` text,
  `Flags` int(11) NOT NULL DEFAULT '0',
  `FactionGroup` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `chat_channels` */

/*Table structure for table `chat_channels_locale` */

DROP TABLE IF EXISTS `chat_channels_locale`;

CREATE TABLE `chat_channels_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Shortcut_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `chat_channels_locale` */

/*Table structure for table `chat_profanity` */

DROP TABLE IF EXISTS `chat_profanity`;

CREATE TABLE `chat_profanity` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Text` text,
  `Language` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `chat_profanity` */

/*Table structure for table `chat_profanity_locale` */

DROP TABLE IF EXISTS `chat_profanity_locale`;

CREATE TABLE `chat_profanity_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Text_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `chat_profanity_locale` */

/*Table structure for table `chr_class_race_sex` */

DROP TABLE IF EXISTS `chr_class_race_sex`;

CREATE TABLE `chr_class_race_sex` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ClassID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RaceID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Sex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `SoundID` int(11) NOT NULL DEFAULT '0',
  `VoiceSoundFilterID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `chr_class_race_sex` */

/*Table structure for table `chr_class_title` */

DROP TABLE IF EXISTS `chr_class_title`;

CREATE TABLE `chr_class_title` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `NameMale` text,
  `NameFemale` text,
  `ChrClassID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `chr_class_title` */

/*Table structure for table `chr_class_title_locale` */

DROP TABLE IF EXISTS `chr_class_title_locale`;

CREATE TABLE `chr_class_title_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `NameMale_lang` text,
  `NameFemale_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `chr_class_title_locale` */

/*Table structure for table `chr_class_u_i_display` */

DROP TABLE IF EXISTS `chr_class_u_i_display`;

CREATE TABLE `chr_class_u_i_display` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ChrClassesID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AdvGuidePlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `SplashPlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `chr_class_u_i_display` */

/*Table structure for table `chr_class_villain` */

DROP TABLE IF EXISTS `chr_class_villain`;

CREATE TABLE `chr_class_villain` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `ChrClassID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Gender` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `chr_class_villain` */

/*Table structure for table `chr_class_villain_locale` */

DROP TABLE IF EXISTS `chr_class_villain_locale`;

CREATE TABLE `chr_class_villain_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `chr_class_villain_locale` */

/*Table structure for table `chr_classes` */

DROP TABLE IF EXISTS `chr_classes`;

CREATE TABLE `chr_classes` (
  `PetNameToken` text,
  `Name` text,
  `NameFemale` text,
  `NameMale` text,
  `Filename` text,
  `CreateScreenFileDataID` int(11) NOT NULL DEFAULT '0',
  `SelectScreenFileDataID` int(11) NOT NULL DEFAULT '0',
  `LowResScreenFileDataID` int(11) NOT NULL DEFAULT '0',
  `IconFileDataID` int(11) NOT NULL DEFAULT '0',
  `StartingLevel` int(11) NOT NULL DEFAULT '0',
  `Flags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CinematicSequenceID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DefaultSpec` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DisplayPower` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SpellClassSet` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AttackPowerPerStrength` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AttackPowerPerAgility` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RangedAttackPowerPerAgility` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PrimaryStatPriority` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `chr_classes` */

/*Table structure for table `chr_classes_locale` */

DROP TABLE IF EXISTS `chr_classes_locale`;

CREATE TABLE `chr_classes_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `PetNameToken_lang` text,
  `Name_lang` text,
  `NameFemale_lang` text,
  `NameMale_lang` text,
  `Filename_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `chr_classes_locale` */

/*Table structure for table `chr_classes_x_power_types` */

DROP TABLE IF EXISTS `chr_classes_x_power_types`;

CREATE TABLE `chr_classes_x_power_types` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `PowerType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ClassID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `chr_classes_x_power_types` */

/*Table structure for table `chr_customization` */

DROP TABLE IF EXISTS `chr_customization`;

CREATE TABLE `chr_customization` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Sex` int(11) NOT NULL DEFAULT '0',
  `BaseSection` int(11) NOT NULL DEFAULT '0',
  `UiCustomizationType` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `ComponentSection1` int(11) NOT NULL DEFAULT '0',
  `ComponentSection2` int(11) NOT NULL DEFAULT '0',
  `ComponentSection3` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `chr_customization` */

/*Table structure for table `chr_customization_locale` */

DROP TABLE IF EXISTS `chr_customization_locale`;

CREATE TABLE `chr_customization_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `chr_customization_locale` */

/*Table structure for table `chr_races` */

DROP TABLE IF EXISTS `chr_races`;

CREATE TABLE `chr_races` (
  `ClientPrefix` text,
  `ClientFileString` text,
  `Name` text,
  `NameFemale` text,
  `NameLowercase` text,
  `NameFemale_lowercase` text,
  `Flags` int(11) NOT NULL DEFAULT '0',
  `MaleDisplayID` int(11) NOT NULL DEFAULT '0',
  `FemaleDisplayID` int(11) NOT NULL DEFAULT '0',
  `CreateScreenFileDataID` int(11) NOT NULL DEFAULT '0',
  `SelectScreenFileDataID` int(11) NOT NULL DEFAULT '0',
  `MaleCustomizeOffset1` float NOT NULL DEFAULT '0',
  `MaleCustomizeOffset2` float NOT NULL DEFAULT '0',
  `MaleCustomizeOffset3` float NOT NULL DEFAULT '0',
  `FemaleCustomizeOffset1` float NOT NULL DEFAULT '0',
  `FemaleCustomizeOffset2` float NOT NULL DEFAULT '0',
  `FemaleCustomizeOffset3` float NOT NULL DEFAULT '0',
  `LowResScreenFileDataID` int(11) NOT NULL DEFAULT '0',
  `StartingLevel` int(11) NOT NULL DEFAULT '0',
  `UiDisplayOrder` int(11) NOT NULL DEFAULT '0',
  `FactionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ResSicknessSpellID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SplashSoundID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CinematicSequenceID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `BaseLanguage` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CreatureType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Alliance` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RaceRelated` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `UnalteredVisualRaceID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CharComponentTextureLayoutID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DefaultClassID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `NeutralRaceID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DisplayRaceID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CharComponentTexLayoutHiResID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `HighResMaleDisplayID` int(11) NOT NULL DEFAULT '0',
  `HighResFemaleDisplayID` int(11) NOT NULL DEFAULT '0',
  `HeritageArmorAchievementID` int(11) NOT NULL DEFAULT '0',
  `MaleSkeletonFileDataID` int(11) NOT NULL DEFAULT '0',
  `FemaleSkeletonFileDataID` int(11) NOT NULL DEFAULT '0',
  `AlteredFormStartVisualKitID1` int(11) NOT NULL DEFAULT '0',
  `AlteredFormStartVisualKitID2` int(11) NOT NULL DEFAULT '0',
  `AlteredFormStartVisualKitID3` int(11) NOT NULL DEFAULT '0',
  `AlteredFormFinishVisualKitID1` int(11) NOT NULL DEFAULT '0',
  `AlteredFormFinishVisualKitID2` int(11) NOT NULL DEFAULT '0',
  `AlteredFormFinishVisualKitID3` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `chr_races` */

/*Table structure for table `chr_races_locale` */

DROP TABLE IF EXISTS `chr_races_locale`;

CREATE TABLE `chr_races_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `ClientPrefix_lang` text,
  `ClientFileString_lang` text,
  `Name_lang` text,
  `NameFemale_lang` text,
  `NameLowercase_lang` text,
  `NameFemale_lowercase_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `chr_races_locale` */

/*Table structure for table `chr_specialization` */

DROP TABLE IF EXISTS `chr_specialization`;

CREATE TABLE `chr_specialization` (
  `Name` text,
  `FemaleName` text,
  `Description` text,
  `MasterySpellID1` int(11) NOT NULL DEFAULT '0',
  `MasterySpellID2` int(11) NOT NULL DEFAULT '0',
  `ClassID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PetTalentType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Role` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PrimaryStatPriority` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellIconFileID` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `AnimReplacements` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `chr_specialization` */

/*Table structure for table `chr_specialization_locale` */

DROP TABLE IF EXISTS `chr_specialization_locale`;

CREATE TABLE `chr_specialization_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `FemaleName_lang` text,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `chr_specialization_locale` */

/*Table structure for table `chr_upgrade_bucket` */

DROP TABLE IF EXISTS `chr_upgrade_bucket`;

CREATE TABLE `chr_upgrade_bucket` (
  `ChrSpecializationID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `chr_upgrade_bucket` */

/*Table structure for table `chr_upgrade_bucket_spell` */

DROP TABLE IF EXISTS `chr_upgrade_bucket_spell`;

CREATE TABLE `chr_upgrade_bucket_spell` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `chr_upgrade_bucket_spell` */

/*Table structure for table `chr_upgrade_tier` */

DROP TABLE IF EXISTS `chr_upgrade_tier`;

CREATE TABLE `chr_upgrade_tier` (
  `DisplayName` text,
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `NumTalents` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `chr_upgrade_tier` */

/*Table structure for table `chr_upgrade_tier_locale` */

DROP TABLE IF EXISTS `chr_upgrade_tier_locale`;

CREATE TABLE `chr_upgrade_tier_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `DisplayName_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `chr_upgrade_tier_locale` */

/*Table structure for table `cinematic_camera` */

DROP TABLE IF EXISTS `cinematic_camera`;

CREATE TABLE `cinematic_camera` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SoundID` int(11) NOT NULL DEFAULT '0',
  `Origin1` float NOT NULL DEFAULT '0',
  `Origin2` float NOT NULL DEFAULT '0',
  `Origin3` float NOT NULL DEFAULT '0',
  `OriginFacing` float NOT NULL DEFAULT '0',
  `FileDataID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `cinematic_camera` */

/*Table structure for table `cinematic_sequences` */

DROP TABLE IF EXISTS `cinematic_sequences`;

CREATE TABLE `cinematic_sequences` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SoundID` int(11) NOT NULL DEFAULT '0',
  `Camera1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Camera2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Camera3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Camera4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Camera5` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Camera6` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Camera7` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Camera8` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `cinematic_sequences` */

/*Table structure for table `cloak_dampening` */

DROP TABLE IF EXISTS `cloak_dampening`;

CREATE TABLE `cloak_dampening` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Angle1` float NOT NULL DEFAULT '0',
  `Angle2` float NOT NULL DEFAULT '0',
  `Angle3` float NOT NULL DEFAULT '0',
  `Angle4` float NOT NULL DEFAULT '0',
  `Angle5` float NOT NULL DEFAULT '0',
  `Dampening1` float NOT NULL DEFAULT '0',
  `Dampening2` float NOT NULL DEFAULT '0',
  `Dampening3` float NOT NULL DEFAULT '0',
  `Dampening4` float NOT NULL DEFAULT '0',
  `Dampening5` float NOT NULL DEFAULT '0',
  `TailAngle1` float NOT NULL DEFAULT '0',
  `TailAngle2` float NOT NULL DEFAULT '0',
  `TailDampening1` float NOT NULL DEFAULT '0',
  `TailDampening2` float NOT NULL DEFAULT '0',
  `TabardAngle` float NOT NULL DEFAULT '0',
  `TabardDampening` float NOT NULL DEFAULT '0',
  `ExpectedWeaponSize` float NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `cloak_dampening` */

/*Table structure for table `combat_condition` */

DROP TABLE IF EXISTS `combat_condition`;

CREATE TABLE `combat_condition` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `WorldStateExpressionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SelfConditionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `TargetConditionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FriendConditionID1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FriendConditionID2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EnemyConditionID1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EnemyConditionID2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FriendConditionOp1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FriendConditionOp2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FriendConditionCount1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FriendConditionCount2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FriendConditionLogic` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EnemyConditionOp1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EnemyConditionOp2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EnemyConditionCount1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EnemyConditionCount2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EnemyConditionLogic` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `combat_condition` */

/*Table structure for table `commentator_start_location` */

DROP TABLE IF EXISTS `commentator_start_location`;

CREATE TABLE `commentator_start_location` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Pos1` float NOT NULL DEFAULT '0',
  `Pos2` float NOT NULL DEFAULT '0',
  `Pos3` float NOT NULL DEFAULT '0',
  `MapID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `commentator_start_location` */

/*Table structure for table `commentator_tracked_cooldown` */

DROP TABLE IF EXISTS `commentator_tracked_cooldown`;

CREATE TABLE `commentator_tracked_cooldown` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Priority` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `commentator_tracked_cooldown` */

/*Table structure for table `component_model_file_data` */

DROP TABLE IF EXISTS `component_model_file_data`;

CREATE TABLE `component_model_file_data` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `GenderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ClassID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RaceID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PositionIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `component_model_file_data` */

/*Table structure for table `component_texture_file_data` */

DROP TABLE IF EXISTS `component_texture_file_data`;

CREATE TABLE `component_texture_file_data` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `GenderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ClassID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RaceID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `component_texture_file_data` */

/*Table structure for table `configuration_warning` */

DROP TABLE IF EXISTS `configuration_warning`;

CREATE TABLE `configuration_warning` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Warning` text,
  `Type` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `configuration_warning` */

/*Table structure for table `configuration_warning_locale` */

DROP TABLE IF EXISTS `configuration_warning_locale`;

CREATE TABLE `configuration_warning_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Warning_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `configuration_warning_locale` */

/*Table structure for table `contribution` */

DROP TABLE IF EXISTS `contribution`;

CREATE TABLE `contribution` (
  `Description` text,
  `Name` text,
  `ID` int(11) NOT NULL DEFAULT '0',
  `ManagedWorldStateInputID` int(11) NOT NULL DEFAULT '0',
  `UiTextureAtlasMemberID1` int(11) NOT NULL DEFAULT '0',
  `UiTextureAtlasMemberID2` int(11) NOT NULL DEFAULT '0',
  `UiTextureAtlasMemberID3` int(11) NOT NULL DEFAULT '0',
  `UiTextureAtlasMemberID4` int(11) NOT NULL DEFAULT '0',
  `OrderIndex` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `contribution` */

/*Table structure for table `contribution_locale` */

DROP TABLE IF EXISTS `contribution_locale`;

CREATE TABLE `contribution_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Description_lang` text,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `contribution_locale` */

/*Table structure for table `conversation_line` */

DROP TABLE IF EXISTS `conversation_line`;

CREATE TABLE `conversation_line` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `BroadcastTextID` int(11) NOT NULL DEFAULT '0',
  `SpellVisualKitID` int(11) NOT NULL DEFAULT '0',
  `AdditionalDuration` int(10) unsigned NOT NULL DEFAULT '0',
  `NextConversationLineID` smallint(6) NOT NULL DEFAULT '0',
  `AnimKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SpeechType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `StartAnimation` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EndAnimation` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `conversation_line` */

/*Table structure for table `creature` */

DROP TABLE IF EXISTS `creature`;

CREATE TABLE `creature` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `NameAlt` text,
  `Title` text,
  `TitleAlt` text,
  `AlwaysItem1` int(11) NOT NULL DEFAULT '0',
  `AlwaysItem2` int(11) NOT NULL DEFAULT '0',
  `AlwaysItem3` int(11) NOT NULL DEFAULT '0',
  `MountCreatureID` int(11) NOT NULL DEFAULT '0',
  `DisplayID1` int(11) NOT NULL DEFAULT '0',
  `DisplayID2` int(11) NOT NULL DEFAULT '0',
  `DisplayID3` int(11) NOT NULL DEFAULT '0',
  `DisplayID4` int(11) NOT NULL DEFAULT '0',
  `DisplayProbability1` float NOT NULL DEFAULT '0',
  `DisplayProbability2` float NOT NULL DEFAULT '0',
  `DisplayProbability3` float NOT NULL DEFAULT '0',
  `DisplayProbability4` float NOT NULL DEFAULT '0',
  `CreatureType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CreatureFamily` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Classification` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `StartAnimState` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `creature` */

/*Table structure for table `creature_difficulty` */

DROP TABLE IF EXISTS `creature_difficulty`;

CREATE TABLE `creature_difficulty` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Flags1` int(10) unsigned NOT NULL DEFAULT '0',
  `Flags2` int(10) unsigned NOT NULL DEFAULT '0',
  `Flags3` int(10) unsigned NOT NULL DEFAULT '0',
  `Flags4` int(10) unsigned NOT NULL DEFAULT '0',
  `Flags5` int(10) unsigned NOT NULL DEFAULT '0',
  `Flags6` int(10) unsigned NOT NULL DEFAULT '0',
  `Flags7` int(10) unsigned NOT NULL DEFAULT '0',
  `FactionID` smallint(6) NOT NULL DEFAULT '0',
  `ExpansionID` tinyint(4) NOT NULL DEFAULT '0',
  `MinLevel` tinyint(4) NOT NULL DEFAULT '0',
  `MaxLevel` tinyint(4) NOT NULL DEFAULT '0',
  `CreatureID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `creature_difficulty` */

/*Table structure for table `creature_disp_x_ui_camera` */

DROP TABLE IF EXISTS `creature_disp_x_ui_camera`;

CREATE TABLE `creature_disp_x_ui_camera` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `CreatureDisplayInfoID` int(11) NOT NULL DEFAULT '0',
  `UiCameraID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `creature_disp_x_ui_camera` */

/*Table structure for table `creature_display_info` */

DROP TABLE IF EXISTS `creature_display_info`;

CREATE TABLE `creature_display_info` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `CreatureModelScale` float NOT NULL DEFAULT '0',
  `ModelID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `NPCSoundID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SizeClass` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Gender` tinyint(4) NOT NULL DEFAULT '0',
  `ExtendedDisplayInfoID` int(11) NOT NULL DEFAULT '0',
  `PortraitTextureFileDataID` int(11) NOT NULL DEFAULT '0',
  `CreatureModelAlpha` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SoundID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PlayerOverrideScale` float NOT NULL DEFAULT '0',
  `PortraitCreatureDisplayInfoID` int(11) NOT NULL DEFAULT '0',
  `BloodID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ParticleColorID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DissolveEffectID` int(10) unsigned NOT NULL DEFAULT '0',
  `ObjectEffectPackageID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AnimReplacementSetID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `UnarmedWeaponType` tinyint(4) NOT NULL DEFAULT '0',
  `StateSpellVisualKitID` int(11) NOT NULL DEFAULT '0',
  `PetInstanceScale` float NOT NULL DEFAULT '0',
  `MountPoofSpellVisualKitID` int(11) NOT NULL DEFAULT '0',
  `TextureVariationFileDataID1` int(11) NOT NULL DEFAULT '0',
  `TextureVariationFileDataID2` int(11) NOT NULL DEFAULT '0',
  `TextureVariationFileDataID3` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `creature_display_info` */

insert  into `creature_display_info`(`ID`,`CreatureModelScale`,`ModelID`,`NPCSoundID`,`SizeClass`,`Flags`,`Gender`,`ExtendedDisplayInfoID`,`PortraitTextureFileDataID`,`CreatureModelAlpha`,`SoundID`,`PlayerOverrideScale`,`PortraitCreatureDisplayInfoID`,`BloodID`,`ParticleColorID`,`DissolveEffectID`,`ObjectEffectPackageID`,`AnimReplacementSetID`,`UnarmedWeaponType`,`StateSpellVisualKitID`,`PetInstanceScale`,`MountPoofSpellVisualKitID`,`TextureVariationFileDataID1`,`TextureVariationFileDataID2`,`TextureVariationFileDataID3`,`VerifiedBuild`) values 
(83283,1,4039,0,255,0,2,0,0,255,4612,0,0,0,0,0,0,0,-1,83366,1,0,526602,526600,526602,0),
(83284,1,4039,0,255,0,2,0,0,255,4612,0,0,0,0,0,0,0,-1,83366,1,0,526602,526600,526602,0),
(83285,1,3797,0,1,0,2,0,0,255,0,0,0,0,0,0,0,0,-1,78133,1,0,0,0,0,0),
(83286,1.5,3011,0,1,0,2,0,0,255,4196,0,0,0,0,0,0,0,-1,0,1,0,0,0,0,0),
(83287,1,3797,0,1,0,2,0,0,255,0,0,0,0,0,0,0,0,-1,78123,1,0,0,0,0,0),
(83288,1.4,4835,0,1,0,2,0,0,255,4196,0,0,0,0,0,0,0,-1,0,1,0,0,0,0,0),
(83281,1,3797,0,1,0,2,0,0,255,0,0,0,0,0,0,0,0,-1,88879,1,0,0,0,0,0),
(83289,1,8939,0,0,0,2,0,0,255,0,0,0,0,0,0,0,0,-1,0,1,0,1601792,0,0,0),
(83291,0.75,8805,0,1,0,2,0,0,255,0,0,0,0,0,0,0,0,-1,0,1,0,1321549,1321552,1321548,0),
(83292,0.9,3957,0,1,0,1,0,0,255,3958,0,0,0,334,0,0,0,-1,0,1,0,520914,520914,520914,0);

/*Table structure for table `creature_display_info_cond` */

DROP TABLE IF EXISTS `creature_display_info_cond`;

CREATE TABLE `creature_display_info_cond` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `RaceMask` bigint(20) unsigned NOT NULL DEFAULT '0',
  `CustomOption0Mask1` int(10) unsigned NOT NULL DEFAULT '0',
  `CustomOption0Mask2` int(10) unsigned NOT NULL DEFAULT '0',
  `CustomOption1Mask1` int(11) NOT NULL DEFAULT '0',
  `CustomOption1Mask2` int(11) NOT NULL DEFAULT '0',
  `CustomOption2Mask1` int(11) NOT NULL DEFAULT '0',
  `CustomOption2Mask2` int(11) NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Gender` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ClassMask` int(11) NOT NULL DEFAULT '0',
  `SkinColorMask` int(11) NOT NULL DEFAULT '0',
  `HairColorMask` int(11) NOT NULL DEFAULT '0',
  `HairStyleMask` int(11) NOT NULL DEFAULT '0',
  `FaceStyleMask` int(11) NOT NULL DEFAULT '0',
  `FacialHairStyleMask` int(11) NOT NULL DEFAULT '0',
  `CreatureModelDataID` int(11) NOT NULL DEFAULT '0',
  `TextureVariationFileDataID1` int(11) NOT NULL DEFAULT '0',
  `TextureVariationFileDataID2` int(11) NOT NULL DEFAULT '0',
  `TextureVariationFileDataID3` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `creature_display_info_cond` */

/*Table structure for table `creature_display_info_evt` */

DROP TABLE IF EXISTS `creature_display_info_evt`;

CREATE TABLE `creature_display_info_evt` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Fourcc` int(11) NOT NULL DEFAULT '0',
  `SpellVisualKitID` int(11) NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `creature_display_info_evt` */

/*Table structure for table `creature_display_info_extra` */

DROP TABLE IF EXISTS `creature_display_info_extra`;

CREATE TABLE `creature_display_info_extra` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `BakeMaterialResourcesID` int(11) NOT NULL DEFAULT '0',
  `HDBakeMaterialResourcesID` int(11) NOT NULL DEFAULT '0',
  `DisplayRaceID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DisplaySexID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DisplayClassID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SkinID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FaceID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `HairStyleID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `HairColorID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FacialHairID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CustomDisplayOption1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CustomDisplayOption2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CustomDisplayOption3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `creature_display_info_extra` */

/*Table structure for table `creature_display_info_trn` */

DROP TABLE IF EXISTS `creature_display_info_trn`;

CREATE TABLE `creature_display_info_trn` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `DstCreatureDisplayInfoID` int(11) NOT NULL DEFAULT '0',
  `MaxTime` float NOT NULL DEFAULT '0',
  `DissolveEffectID` int(11) NOT NULL DEFAULT '0',
  `StartVisualKitID` int(11) NOT NULL DEFAULT '0',
  `FinishVisualKitID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `creature_display_info_trn` */

/*Table structure for table `creature_family` */

DROP TABLE IF EXISTS `creature_family`;

CREATE TABLE `creature_family` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `MinScale` float NOT NULL DEFAULT '0',
  `MaxScale` float NOT NULL DEFAULT '0',
  `IconFileID` int(11) NOT NULL DEFAULT '0',
  `SkillLine1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SkillLine2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PetFoodMask` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MinScaleLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxScaleLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PetTalentType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `creature_family` */

/*Table structure for table `creature_family_locale` */

DROP TABLE IF EXISTS `creature_family_locale`;

CREATE TABLE `creature_family_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `creature_family_locale` */

/*Table structure for table `creature_immunities` */

DROP TABLE IF EXISTS `creature_immunities`;

CREATE TABLE `creature_immunities` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Mechanic1` int(11) NOT NULL DEFAULT '0',
  `Mechanic2` int(11) NOT NULL DEFAULT '0',
  `School` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MechanicsAllowed` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EffectsAllowed` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `StatesAllowed` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DispelType` int(11) NOT NULL DEFAULT '0',
  `Effect1` int(11) NOT NULL DEFAULT '0',
  `Effect2` int(11) NOT NULL DEFAULT '0',
  `Effect3` int(11) NOT NULL DEFAULT '0',
  `Effect4` int(11) NOT NULL DEFAULT '0',
  `Effect5` int(11) NOT NULL DEFAULT '0',
  `Effect6` int(11) NOT NULL DEFAULT '0',
  `Effect7` int(11) NOT NULL DEFAULT '0',
  `Effect8` int(11) NOT NULL DEFAULT '0',
  `Effect9` int(11) NOT NULL DEFAULT '0',
  `State1` int(11) NOT NULL DEFAULT '0',
  `State2` int(11) NOT NULL DEFAULT '0',
  `State3` int(11) NOT NULL DEFAULT '0',
  `State4` int(11) NOT NULL DEFAULT '0',
  `State5` int(11) NOT NULL DEFAULT '0',
  `State6` int(11) NOT NULL DEFAULT '0',
  `State7` int(11) NOT NULL DEFAULT '0',
  `State8` int(11) NOT NULL DEFAULT '0',
  `State9` int(11) NOT NULL DEFAULT '0',
  `State10` int(11) NOT NULL DEFAULT '0',
  `State11` int(11) NOT NULL DEFAULT '0',
  `State12` int(11) NOT NULL DEFAULT '0',
  `State13` int(11) NOT NULL DEFAULT '0',
  `State14` int(11) NOT NULL DEFAULT '0',
  `State15` int(11) NOT NULL DEFAULT '0',
  `State16` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `creature_immunities` */

/*Table structure for table `creature_locale` */

DROP TABLE IF EXISTS `creature_locale`;

CREATE TABLE `creature_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `NameAlt_lang` text,
  `Title_lang` text,
  `TitleAlt_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `creature_locale` */

/*Table structure for table `creature_model_data` */

DROP TABLE IF EXISTS `creature_model_data`;

CREATE TABLE `creature_model_data` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ModelScale` float NOT NULL DEFAULT '0',
  `FootprintTextureLength` float NOT NULL DEFAULT '0',
  `FootprintTextureWidth` float NOT NULL DEFAULT '0',
  `FootprintParticleScale` float NOT NULL DEFAULT '0',
  `CollisionWidth` float NOT NULL DEFAULT '0',
  `CollisionHeight` float NOT NULL DEFAULT '0',
  `MountHeight` float NOT NULL DEFAULT '0',
  `GeoBox1` float NOT NULL DEFAULT '0',
  `GeoBox2` float NOT NULL DEFAULT '0',
  `GeoBox3` float NOT NULL DEFAULT '0',
  `GeoBox4` float NOT NULL DEFAULT '0',
  `GeoBox5` float NOT NULL DEFAULT '0',
  `GeoBox6` float NOT NULL DEFAULT '0',
  `WorldEffectScale` float NOT NULL DEFAULT '0',
  `AttachedEffectScale` float NOT NULL DEFAULT '0',
  `MissileCollisionRadius` float NOT NULL DEFAULT '0',
  `MissileCollisionPush` float NOT NULL DEFAULT '0',
  `MissileCollisionRaise` float NOT NULL DEFAULT '0',
  `OverrideLootEffectScale` float NOT NULL DEFAULT '0',
  `OverrideNameScale` float NOT NULL DEFAULT '0',
  `OverrideSelectionRadius` float NOT NULL DEFAULT '0',
  `TamedPetBaseScale` float NOT NULL DEFAULT '0',
  `HoverHeight` float NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `FileDataID` int(11) NOT NULL DEFAULT '0',
  `SizeClass` int(11) NOT NULL DEFAULT '0',
  `BloodID` int(11) NOT NULL DEFAULT '0',
  `FootprintTextureID` int(11) NOT NULL DEFAULT '0',
  `FoleyMaterialID` int(11) NOT NULL DEFAULT '0',
  `FootstepCameraEffectID` int(11) NOT NULL DEFAULT '0',
  `DeathThudCameraEffectID` int(11) NOT NULL DEFAULT '0',
  `SoundID` int(11) NOT NULL DEFAULT '0',
  `CreatureGeosetDataID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `creature_model_data` */

/*Table structure for table `creature_movement_info` */

DROP TABLE IF EXISTS `creature_movement_info`;

CREATE TABLE `creature_movement_info` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SmoothFacingChaseRate` float NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `creature_movement_info` */

/*Table structure for table `creature_sound_data` */

DROP TABLE IF EXISTS `creature_sound_data`;

CREATE TABLE `creature_sound_data` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `FidgetDelaySecondsMin` float NOT NULL DEFAULT '0',
  `FidgetDelaySecondsMax` float NOT NULL DEFAULT '0',
  `CreatureImpactType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SoundExertionID` int(11) NOT NULL DEFAULT '0',
  `SoundExertionCriticalID` int(11) NOT NULL DEFAULT '0',
  `SoundInjuryID` int(11) NOT NULL DEFAULT '0',
  `SoundInjuryCriticalID` int(11) NOT NULL DEFAULT '0',
  `SoundInjuryCrushingBlowID` int(11) NOT NULL DEFAULT '0',
  `SoundDeathID` int(11) NOT NULL DEFAULT '0',
  `SoundStunID` int(11) NOT NULL DEFAULT '0',
  `SoundStandID` int(11) NOT NULL DEFAULT '0',
  `SoundFootstepID` int(11) NOT NULL DEFAULT '0',
  `SoundAggroID` int(11) NOT NULL DEFAULT '0',
  `SoundWingFlapID` int(11) NOT NULL DEFAULT '0',
  `SoundWingGlideID` int(11) NOT NULL DEFAULT '0',
  `SoundAlertID` int(11) NOT NULL DEFAULT '0',
  `NPCSoundID` int(11) NOT NULL DEFAULT '0',
  `LoopSoundID` int(11) NOT NULL DEFAULT '0',
  `SoundJumpStartID` int(11) NOT NULL DEFAULT '0',
  `SoundJumpEndID` int(11) NOT NULL DEFAULT '0',
  `SoundPetAttackID` int(11) NOT NULL DEFAULT '0',
  `SoundPetOrderID` int(11) NOT NULL DEFAULT '0',
  `SoundPetDismissID` int(11) NOT NULL DEFAULT '0',
  `BirthSoundID` int(11) NOT NULL DEFAULT '0',
  `SpellCastDirectedSoundID` int(11) NOT NULL DEFAULT '0',
  `SubmergeSoundID` int(11) NOT NULL DEFAULT '0',
  `SubmergedSoundID` int(11) NOT NULL DEFAULT '0',
  `CreatureSoundDataIDPet` int(11) NOT NULL DEFAULT '0',
  `WindupSoundID` int(11) NOT NULL DEFAULT '0',
  `WindupCriticalSoundID` int(11) NOT NULL DEFAULT '0',
  `ChargeSoundID` int(11) NOT NULL DEFAULT '0',
  `ChargeCriticalSoundID` int(11) NOT NULL DEFAULT '0',
  `BattleShoutSoundID` int(11) NOT NULL DEFAULT '0',
  `BattleShoutCriticalSoundID` int(11) NOT NULL DEFAULT '0',
  `TauntSoundID` int(11) NOT NULL DEFAULT '0',
  `SoundFidget1` int(11) NOT NULL DEFAULT '0',
  `SoundFidget2` int(11) NOT NULL DEFAULT '0',
  `SoundFidget3` int(11) NOT NULL DEFAULT '0',
  `SoundFidget4` int(11) NOT NULL DEFAULT '0',
  `SoundFidget5` int(11) NOT NULL DEFAULT '0',
  `CustomAttack1` int(11) NOT NULL DEFAULT '0',
  `CustomAttack2` int(11) NOT NULL DEFAULT '0',
  `CustomAttack3` int(11) NOT NULL DEFAULT '0',
  `CustomAttack4` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `creature_sound_data` */

/*Table structure for table `creature_type` */

DROP TABLE IF EXISTS `creature_type`;

CREATE TABLE `creature_type` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `creature_type` */

/*Table structure for table `creature_type_locale` */

DROP TABLE IF EXISTS `creature_type_locale`;

CREATE TABLE `creature_type_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `creature_type_locale` */

/*Table structure for table `creature_x_contribution` */

DROP TABLE IF EXISTS `creature_x_contribution`;

CREATE TABLE `creature_x_contribution` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ContributionID` int(11) NOT NULL DEFAULT '0',
  `CreatureId` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `creature_x_contribution` */

/*Table structure for table `criteria` */

DROP TABLE IF EXISTS `criteria`;

CREATE TABLE `criteria` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Asset` int(11) NOT NULL DEFAULT '0',
  `StartAsset` int(11) NOT NULL DEFAULT '0',
  `FailAsset` int(10) unsigned NOT NULL DEFAULT '0',
  `ModifierTreeId` int(11) NOT NULL DEFAULT '0',
  `StartTimer` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EligibilityWorldStateId` smallint(6) NOT NULL DEFAULT '0',
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `StartEvent` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FailEvent` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EligibilityWorldStateValue` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `criteria` */

insert  into `criteria`(`ID`,`Asset`,`StartAsset`,`FailAsset`,`ModifierTreeId`,`StartTimer`,`EligibilityWorldStateId`,`Type`,`StartEvent`,`FailEvent`,`Flags`,`EligibilityWorldStateValue`,`VerifiedBuild`) values 
(28097,91349,0,0,0,0,0,165,0,0,0,0,0),
(28013,90316,0,0,0,0,0,165,0,0,0,0,0),
(28052,186489,0,0,0,0,0,28,0,0,0,0,0),
(27992,1786,0,0,0,0,0,165,0,0,0,0,0),
(28084,187045,0,0,0,0,0,28,0,0,0,0,0),
(28189,92144,0,0,0,0,0,165,0,0,0,0,0),
(28289,91331,0,0,0,0,0,165,0,0,0,0,0),
(28053,186493,0,0,0,0,0,28,0,0,0,0,0),
(16259,42180,0,0,0,0,0,165,0,0,0,0,0),
(16258,42180,0,0,0,0,0,165,0,0,0,0,0),
(24639,77404,0,0,0,0,0,165,0,0,0,0,0),
(24652,1719,0,0,0,0,0,165,0,0,0,0,0),
(24627,76814,0,0,0,0,0,165,0,0,0,0,0),
(19913,60999,0,0,0,0,0,0,0,0,0,0,1),
(6629,34753,0,0,0,0,0,41,0,0,0,0,0),
(6626,34753,0,0,0,0,0,41,0,0,0,0,0),
(6628,34753,0,0,0,0,0,41,0,0,0,0,0),
(6630,34753,0,0,0,0,0,41,0,0,0,0,0),
(6627,34753,0,0,0,0,0,41,0,0,0,0,0),
(24536,577,0,0,0,0,0,46,0,0,0,0,0),
(24535,21,0,0,0,0,0,46,0,0,0,0,0),
(24537,369,0,0,0,0,0,46,0,0,0,0,0),
(24534,87,0,0,0,0,0,46,0,0,0,0,0),
(24538,470,0,0,0,0,0,46,0,0,0,0,0),
(15651,42178,0,0,0,0,0,28,0,0,0,0,0),
(15652,42178,0,0,0,0,0,28,0,0,0,0,0),
(15653,42178,0,0,0,0,0,28,0,0,0,0,0),
(15654,42178,0,0,0,0,0,28,0,0,0,0,0),
(22844,22844,0,0,0,0,0,28,0,0,0,0,0),
(22845,22845,0,0,0,0,0,28,0,0,0,0,0),
(22929,139681,0,0,0,0,0,28,0,0,0,0,0),
(16540,28390,0,81319,0,0,0,27,0,9,0,0,0),
(20487,31113,0,0,0,0,0,27,0,0,0,0,0),
(20488,31114,0,0,0,0,0,27,0,0,0,0,0),
(20489,31118,0,0,0,0,0,27,0,0,0,0,0),
(20490,31116,0,0,0,0,0,27,0,0,0,0,0),
(21208,31119,0,0,0,0,0,27,0,0,0,0,0),
(20492,31117,0,0,0,0,0,27,0,0,0,0,0),
(20493,31120,0,0,0,0,0,27,0,0,0,0,0),
(19408,1463,0,0,0,0,0,165,0,0,0,0,0),
(14097,45870,0,0,0,0,0,28,0,0,0,0,0),
(16290,45872,0,0,0,0,0,28,0,0,0,0,0),
(16291,45872,0,0,0,0,0,28,0,0,0,0,0),
(16011,46753,0,0,0,0,0,28,0,0,0,0,0),
(23904,71504,0,0,0,0,0,28,0,0,0,0,0),
(23907,71504,0,0,0,0,0,28,0,0,0,0,0),
(23908,71504,0,0,0,0,0,28,0,0,0,0,0),
(23909,71504,0,0,0,0,0,28,0,0,0,0,0),
(23910,71504,0,0,0,0,0,28,0,0,0,0,0),
(23911,71504,0,0,0,0,0,28,0,0,0,0,0),
(23912,71504,0,0,0,0,0,28,0,0,0,0,0),
(23913,71504,0,0,0,0,0,28,0,0,0,0,0),
(23914,71504,0,0,0,0,0,28,0,0,0,0,0),
(23772,71504,0,0,0,0,0,0,0,0,0,0,0),
(23773,71504,0,0,0,0,0,0,0,0,0,0,0),
(23774,71504,0,0,0,0,0,0,0,0,0,0,0),
(23775,71504,0,0,0,0,0,0,0,0,0,0,0),
(33104,600028,0,0,0,0,0,28,0,0,0,0,0),
(33105,600029,0,0,0,0,0,28,0,0,0,0,0),
(10461,65074,0,0,0,0,0,28,0,0,0,0,0),
(10449,65074,0,0,0,0,0,28,0,0,0,0,0),
(17418,99763,0,0,0,0,0,28,0,0,0,0,0),
(17576,53691,0,0,0,0,0,0,0,0,0,0,0),
(17775,17775,0,0,0,0,0,28,0,0,0,0,0),
(17776,17776,0,0,0,0,0,28,0,0,0,0,0),
(17777,17777,0,0,0,0,0,28,0,0,0,0,0),
(17778,17778,0,0,0,0,0,28,0,0,0,0,0),
(17779,17779,0,0,0,0,0,28,0,0,0,0,0),
(17542,52498,0,0,0,0,0,0,0,0,0,0,0),
(17533,52530,0,0,0,0,0,0,0,0,0,0,0),
(17535,52530,0,0,0,0,0,0,0,0,0,0,0),
(17536,52530,0,0,0,0,0,0,0,0,0,0,0),
(17538,52530,0,0,0,0,0,0,0,0,0,0,0),
(17577,53494,0,0,0,0,0,0,0,0,0,0,0),
(18494,55308,0,0,0,0,0,28,0,0,0,0,0),
(18502,104574,0,0,0,0,0,28,0,0,0,0,0),
(23732,145538,0,0,0,0,0,28,0,0,0,0,0),
(23741,146880,0,0,0,0,0,69,0,0,0,0,0),
(23733,72249,0,0,0,0,0,28,0,0,0,0,0),
(23722,71466,0,0,0,0,0,0,0,0,0,0,0),
(23650,71859,0,0,0,0,0,28,0,0,0,0,0),
(23649,71515,0,0,0,0,0,28,0,0,0,0,0),
(23905,148503,0,0,0,0,0,28,0,0,0,0,0),
(23894,148348,0,0,0,0,0,28,0,0,0,0,0),
(13138,36597,0,0,0,0,0,0,0,0,0,0,0),
(13245,36597,0,0,0,0,0,0,0,0,0,0,0),
(13244,36597,0,0,0,0,0,0,0,0,0,0,0),
(13246,36597,0,0,0,0,0,0,0,0,0,0,0),
(13247,36597,0,0,0,0,0,0,0,0,0,0,0),
(13011,37955,0,0,0,0,0,0,0,0,0,0,0),
(13013,37955,0,0,0,0,0,0,0,0,0,0,0),
(12980,72706,0,0,0,0,0,28,0,0,0,0,0),
(12971,72706,0,0,0,0,0,28,0,0,0,0,0),
(12978,72707,0,0,0,0,0,28,0,0,0,0,0),
(12979,72707,0,0,0,0,0,28,0,0,0,0,0),
(25539,305053,0,0,0,0,0,28,0,0,0,0,0),
(25540,305054,0,0,0,0,0,28,0,0,0,0,0),
(25541,305055,0,0,0,0,0,28,0,0,0,0,0),
(31555,1792,0,0,0,0,0,165,0,0,0,0,0),
(29699,101995,0,0,0,0,0,0,0,0,0,0,0),
(29681,207766,0,0,0,0,0,28,0,0,0,0,0),
(36211,116407,0,0,0,0,0,0,0,0,0,0,0),
(36337,115844,0,0,0,0,0,0,0,0,0,0,0),
(31307,99200,0,0,0,0,0,0,0,0,0,0,0),
(15947,39698,0,0,0,0,0,0,0,0,0,0,0),
(15993,44819,0,0,0,0,0,0,0,0,0,0,0),
(16209,51462,0,0,0,0,0,0,0,0,0,0,0),
(31372,1827,0,0,0,0,0,165,0,0,0,0,0),
(20244,125986,0,0,0,0,0,28,0,0,0,0,0),
(7144,28923,20384,0,0,0,0,0,13,0,0,0,0),
(34396,0,0,0,0,0,0,203,0,0,0,0,0),
(37930,0,0,0,0,0,0,78,0,0,0,0,0),
(36173,240536,0,0,0,0,0,28,0,0,0,0,0),
(36514,118523,0,0,0,0,0,0,0,0,0,0,0),
(24823,0,0,0,0,0,0,24,0,0,0,0,0),
(20007,125782,0,0,0,0,0,69,0,0,0,0,0),
(17836,53085,0,0,0,0,0,0,0,0,0,0,0),
(14146,45870,0,0,783,0,0,0,0,0,0,0,0),
(32385,1832,0,0,0,0,0,165,0,0,0,0,0),
(32384,1833,0,0,0,0,0,165,0,0,0,0,0),
(29680,1822,0,0,0,0,0,165,0,0,0,0,0),
(29683,1823,0,0,0,0,0,165,0,0,0,0,0),
(31344,99192,0,0,0,0,0,0,0,0,0,0,0),
(29405,96028,0,0,0,0,0,0,0,0,0,0,0),
(19979,125724,0,0,0,0,0,28,0,0,0,0,0),
(39859,0,0,0,0,0,0,203,0,0,0,0,0),
(39759,542185,0,0,0,0,0,0,0,0,0,0,0),
(39760,542191,0,0,0,0,0,0,0,0,0,0,0),
(22677,68476,0,0,0,0,0,0,0,0,0,0,0),
(22791,139065,0,0,0,0,0,28,0,0,0,0,0),
(22792,139064,0,0,0,0,0,28,0,0,0,0,0),
(22793,139061,0,0,0,0,0,28,0,0,0,0,0),
(22794,139062,0,0,0,0,0,28,0,0,0,0,0),
(22795,139063,0,0,0,0,0,28,0,0,0,0,0),
(22800,139163,0,0,0,0,0,28,0,0,0,0,0),
(39860,305195,0,0,0,0,0,34,0,0,0,0,0),
(20832,63391,0,0,0,0,0,41,0,0,0,0,0);

/*Table structure for table `criteria_tree` */

DROP TABLE IF EXISTS `criteria_tree`;

CREATE TABLE `criteria_tree` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Description` text,
  `Amount` int(11) NOT NULL DEFAULT '0',
  `Flags` smallint(6) NOT NULL DEFAULT '0',
  `Operator` tinyint(4) NOT NULL DEFAULT '0',
  `CriteriaID` int(11) NOT NULL DEFAULT '0',
  `Parent` int(11) NOT NULL DEFAULT '0',
  `OrderIndex` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `criteria_tree` */

insert  into `criteria_tree`(`ID`,`Description`,`Amount`,`Flags`,`Operator`,`CriteriaID`,`Parent`,`OrderIndex`,`VerifiedBuild`) values 
(10688,'Превознесение в Круговзоре',42000,2,0,24536,10687,2,0),
(10689,'Превознесение в Пиратской Бухте',42000,2,0,24535,10687,1,0),
(10692,'Превознесение в Прибамбасске',42000,2,0,24537,10687,3,0),
(10693,'Уважение среди Пиратов Кровавого Паруса',9000,2,0,24534,10687,0,0),
(10694,'Превознесение в Кабестане',42000,2,0,24538,10687,4,0),
(16800,'Одержать победу на боевом корабле',0,0,0,13114,16797,3,0),
(13910,'Одержать победу на боевом корабле',0,0,0,12946,13907,3,0),
(12589,'Одержать победу на боевом корабле',0,0,0,12772,12587,3,0),
(14547,'Одержать победу на боевом корабле',0,0,0,13113,14544,3,0),
(16655,'Битва на боевом корабле',1,2,0,12946,16654,1,0),
(16656,'Битва на боевом корабле',1,2,0,12946,16654,2,0),
(16624,'Битва на боевом корабле',1,2,0,12772,16623,2,0),
(16625,'Битва на боевом корабле',1,2,0,12772,16623,1,0),
(58946,NULL,1,2,0,36566,58945,0,0),
(58945,'pvp-потасовка выиграна',1,4096,5,0,0,0,0),
(7378,'Fall 65 yards without dying while wearing Synthebrew Goggles',6500,2,0,24823,7377,0,0),
(43515,'',1,2,0,23250,39832,0,0),
(64278,'Defeat Thorim while Sif is present in 10-player mode',0,0,4,0,0,0,0),
(64279,'Force Thorim to enter the arena while Sif is present',1,2,0,10440,64278,0,0),
(7897,'Champion of the Exodar',1,0,0,11321,7896,0,0),
(7898,'Exalted with Exodar',42000,0,0,11321,5332,0,1),
(1,'',350,0,4,0,0,0,1),
(4,'Dalaran defeat',300,0,9,0,1,0,1),
(7,'',1,0,0,30122,4,0,1),
(48090,NULL,1,0,4,0,0,0,1),
(61002,'Complete 3 lfd',1,0,4,0,0,0,0),
(61003,'Complete 3 lfd',0,0,0,13029,61002,0,0),
(65600,'Complete 10 world quests',10,0,5,0,0,0,0),
(65601,'Complete 10 wq',0,0,0,39859,65600,0,0),
(65602,'Win 3 random battlegrounds',3,0,5,0,0,0,0),
(65603,'win 3 bg',0,0,0,34741,65602,0,0),
(65605,'Kill new year bosses',5,1,5,0,65607,0,0),
(65606,'Kill new year bosses',5,1,5,0,65607,0,1),
(65607,'Defeat bosses',1,0,4,0,0,0,0),
(65608,'new year boss 1',5,1,0,39759,65605,0,0),
(65609,'new year boss 2',5,1,0,39760,65606,0,0),
(43516,'',1,2,0,23250,39849,0,0),
(65610,NULL,1,0,8,0,0,0,0),
(65611,NULL,0,2,0,39860,65610,0,0);

/*Table structure for table `criteria_tree_locale` */

DROP TABLE IF EXISTS `criteria_tree_locale`;

CREATE TABLE `criteria_tree_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `criteria_tree_locale` */

/*Table structure for table `criteria_tree_x_effect` */

DROP TABLE IF EXISTS `criteria_tree_x_effect`;

CREATE TABLE `criteria_tree_x_effect` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `WorldEffectID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `criteria_tree_x_effect` */

/*Table structure for table `currency_category` */

DROP TABLE IF EXISTS `currency_category`;

CREATE TABLE `currency_category` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ExpansionID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `currency_category` */

/*Table structure for table `currency_category_locale` */

DROP TABLE IF EXISTS `currency_category_locale`;

CREATE TABLE `currency_category_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `currency_category_locale` */

/*Table structure for table `currency_types` */

DROP TABLE IF EXISTS `currency_types`;

CREATE TABLE `currency_types` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Description` text,
  `MaxQty` int(11) NOT NULL DEFAULT '0',
  `MaxEarnablePerWeek` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `CategoryID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SpellCategory` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Quality` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `InventoryIconFileID` int(11) NOT NULL DEFAULT '0',
  `SpellWeight` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `currency_types` */

insert  into `currency_types`(`ID`,`Name`,`Description`,`MaxQty`,`MaxEarnablePerWeek`,`Flags`,`CategoryID`,`SpellCategory`,`Quality`,`InventoryIconFileID`,`SpellWeight`,`VerifiedBuild`) values 
(1160,'Gold coin of valor','You can get it for ingame challenges. And can exchange this coins for some special server rewards in Dalaran.',0,0,0,141,0,5,1416740,0,0),
(1161,'Decency','Mutes and bans \"reward\"',0,0,1572864,142,0,0,0,0,0),
(1162,'Icy Coin','You can get it for kill New Year event bosses. This coins can be exchanged in Dalaran. Find Biggie in Dalaran and he show what reward you can get for this coins.',0,0,0,141,0,5,133283,0,0);

/*Table structure for table `currency_types_locale` */

DROP TABLE IF EXISTS `currency_types_locale`;

CREATE TABLE `currency_types_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `currency_types_locale` */

/*Table structure for table `curve` */

DROP TABLE IF EXISTS `curve`;

CREATE TABLE `curve` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `curve` */

/*Table structure for table `curve_point` */

DROP TABLE IF EXISTS `curve_point`;

CREATE TABLE `curve_point` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `PosX` float NOT NULL DEFAULT '0',
  `PosY` float NOT NULL DEFAULT '0',
  `CurveID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `curve_point` */

/*Table structure for table `death_thud_lookups` */

DROP TABLE IF EXISTS `death_thud_lookups`;

CREATE TABLE `death_thud_lookups` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SizeClass` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TerrainTypeSoundID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SoundEntryID` int(11) NOT NULL DEFAULT '0',
  `SoundEntryIDWater` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `death_thud_lookups` */

/*Table structure for table `decal_properties` */

DROP TABLE IF EXISTS `decal_properties`;

CREATE TABLE `decal_properties` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `FileDataID` int(11) NOT NULL DEFAULT '0',
  `InnerRadius` float NOT NULL DEFAULT '0',
  `OuterRadius` float NOT NULL DEFAULT '0',
  `Rim` float NOT NULL DEFAULT '0',
  `Gain` float NOT NULL DEFAULT '0',
  `ModX` float NOT NULL DEFAULT '0',
  `Scale` float NOT NULL DEFAULT '0',
  `FadeIn` float NOT NULL DEFAULT '0',
  `FadeOut` float NOT NULL DEFAULT '0',
  `Priority` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `BlendMode` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TopTextureBlendSetID` int(11) NOT NULL DEFAULT '0',
  `BotTextureBlendSetID` int(11) NOT NULL DEFAULT '0',
  `GameFlags` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `CasterDecalPropertiesID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `decal_properties` */

/*Table structure for table `declined_word` */

DROP TABLE IF EXISTS `declined_word`;

CREATE TABLE `declined_word` (
  `Word` text,
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `declined_word` */

/*Table structure for table `declined_word_cases` */

DROP TABLE IF EXISTS `declined_word_cases`;

CREATE TABLE `declined_word_cases` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `DeclinedWord` text,
  `CaseIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `declined_word_cases` */

/*Table structure for table `declined_word_cases_locale` */

DROP TABLE IF EXISTS `declined_word_cases_locale`;

CREATE TABLE `declined_word_cases_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `DeclinedWord_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `declined_word_cases_locale` */

/*Table structure for table `declined_word_locale` */

DROP TABLE IF EXISTS `declined_word_locale`;

CREATE TABLE `declined_word_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Word_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `declined_word_locale` */

/*Table structure for table `destructible_model_data` */

DROP TABLE IF EXISTS `destructible_model_data`;

CREATE TABLE `destructible_model_data` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `State0Wmo` smallint(5) unsigned NOT NULL DEFAULT '0',
  `State1Wmo` smallint(5) unsigned NOT NULL DEFAULT '0',
  `State2Wmo` smallint(5) unsigned NOT NULL DEFAULT '0',
  `State3Wmo` smallint(5) unsigned NOT NULL DEFAULT '0',
  `HealEffectSpeed` smallint(5) unsigned NOT NULL DEFAULT '0',
  `State0ImpactEffectDoodadSet` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `State0AmbientDoodadSet` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `State0NameSet` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `State1DestructionDoodadSet` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `State1ImpactEffectDoodadSet` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `State1AmbientDoodadSet` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `State1NameSet` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `State2DestructionDoodadSet` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `State2ImpactEffectDoodadSet` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `State2AmbientDoodadSet` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `State2NameSet` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `State3InitDoodadSet` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `State3AmbientDoodadSet` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `State3NameSet` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EjectDirection` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DoNotHighlight` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `HealEffect` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `destructible_model_data` */

/*Table structure for table `device_blacklist` */

DROP TABLE IF EXISTS `device_blacklist`;

CREATE TABLE `device_blacklist` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `VendorID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DeviceID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `device_blacklist` */

/*Table structure for table `device_default_settings` */

DROP TABLE IF EXISTS `device_default_settings`;

CREATE TABLE `device_default_settings` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `VendorID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DeviceID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DefaultSetting` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `device_default_settings` */

/*Table structure for table `difficulty` */

DROP TABLE IF EXISTS `difficulty`;

CREATE TABLE `difficulty` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `GroupSizeHealthCurveID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `GroupSizeDmgCurveID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `GroupSizeSpellPointsCurveID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FallbackDifficultyID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `InstanceType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MinPlayers` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxPlayers` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `OldEnumValue` tinyint(4) NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ToggleDifficultyID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ItemContext` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `difficulty` */

/*Table structure for table `difficulty_locale` */

DROP TABLE IF EXISTS `difficulty_locale`;

CREATE TABLE `difficulty_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `difficulty_locale` */

/*Table structure for table `dissolve_effect` */

DROP TABLE IF EXISTS `dissolve_effect`;

CREATE TABLE `dissolve_effect` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Ramp` float NOT NULL DEFAULT '0',
  `StartValue` float NOT NULL DEFAULT '0',
  `EndValue` float NOT NULL DEFAULT '0',
  `FadeInTime` float NOT NULL DEFAULT '0',
  `FadeOutTime` float NOT NULL DEFAULT '0',
  `Duration` float NOT NULL DEFAULT '0',
  `Scale` float NOT NULL DEFAULT '0',
  `FresnelIntensity` float NOT NULL DEFAULT '0',
  `AttachID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ProjectionType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TextureBlendSetID` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `CurveID` int(11) NOT NULL DEFAULT '0',
  `Priority` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `dissolve_effect` */

/*Table structure for table `driver_blacklist` */

DROP TABLE IF EXISTS `driver_blacklist`;

CREATE TABLE `driver_blacklist` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `DriverVersionHi` int(11) NOT NULL DEFAULT '0',
  `DriverVersionLow` int(11) NOT NULL DEFAULT '0',
  `VendorID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DeviceID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `OsVersion` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `OsBits` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `driver_blacklist` */

/*Table structure for table `dungeon_encounter` */

DROP TABLE IF EXISTS `dungeon_encounter`;

CREATE TABLE `dungeon_encounter` (
  `Name` text,
  `CreatureDisplayID` int(11) NOT NULL DEFAULT '0',
  `MapID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DifficultyID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Bit` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `OrderIndex` int(11) NOT NULL DEFAULT '0',
  `SpellIconFileID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `dungeon_encounter` */

/*Table structure for table `dungeon_encounter_locale` */

DROP TABLE IF EXISTS `dungeon_encounter_locale`;

CREATE TABLE `dungeon_encounter_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `dungeon_encounter_locale` */

/*Table structure for table `dungeon_map` */

DROP TABLE IF EXISTS `dungeon_map`;

CREATE TABLE `dungeon_map` (
  `Min1` float NOT NULL DEFAULT '0',
  `Min2` float NOT NULL DEFAULT '0',
  `Max1` float NOT NULL DEFAULT '0',
  `Max2` float NOT NULL DEFAULT '0',
  `MapID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ParentWorldMapID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FloorIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RelativeHeightIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `dungeon_map` */

/*Table structure for table `dungeon_map_chunk` */

DROP TABLE IF EXISTS `dungeon_map_chunk`;

CREATE TABLE `dungeon_map_chunk` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `MinZ` float NOT NULL DEFAULT '0',
  `DoodadPlacementID` int(11) NOT NULL DEFAULT '0',
  `MapID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WmoGroupID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DungeonMapID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `dungeon_map_chunk` */

/*Table structure for table `durability_costs` */

DROP TABLE IF EXISTS `durability_costs`;

CREATE TABLE `durability_costs` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `WeaponSubClassCost1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WeaponSubClassCost2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WeaponSubClassCost3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WeaponSubClassCost4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WeaponSubClassCost5` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WeaponSubClassCost6` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WeaponSubClassCost7` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WeaponSubClassCost8` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WeaponSubClassCost9` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WeaponSubClassCost10` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WeaponSubClassCost11` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WeaponSubClassCost12` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WeaponSubClassCost13` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WeaponSubClassCost14` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WeaponSubClassCost15` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WeaponSubClassCost16` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WeaponSubClassCost17` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WeaponSubClassCost18` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WeaponSubClassCost19` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WeaponSubClassCost20` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WeaponSubClassCost21` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ArmorSubClassCost1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ArmorSubClassCost2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ArmorSubClassCost3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ArmorSubClassCost4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ArmorSubClassCost5` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ArmorSubClassCost6` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ArmorSubClassCost7` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ArmorSubClassCost8` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `durability_costs` */

/*Table structure for table `durability_quality` */

DROP TABLE IF EXISTS `durability_quality`;

CREATE TABLE `durability_quality` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Data` float NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `durability_quality` */

/*Table structure for table `edge_glow_effect` */

DROP TABLE IF EXISTS `edge_glow_effect`;

CREATE TABLE `edge_glow_effect` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Duration` float NOT NULL DEFAULT '0',
  `FadeIn` float NOT NULL DEFAULT '0',
  `FadeOut` float NOT NULL DEFAULT '0',
  `FresnelCoefficient` float NOT NULL DEFAULT '0',
  `GlowRed` float NOT NULL DEFAULT '0',
  `GlowGreen` float NOT NULL DEFAULT '0',
  `GlowBlue` float NOT NULL DEFAULT '0',
  `GlowAlpha` float NOT NULL DEFAULT '0',
  `GlowMultiplier` float NOT NULL DEFAULT '0',
  `InitialDelay` float NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CurveID` int(11) NOT NULL DEFAULT '0',
  `Priority` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `edge_glow_effect` */

/*Table structure for table `emotes` */

DROP TABLE IF EXISTS `emotes`;

CREATE TABLE `emotes` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `RaceMask` bigint(20) NOT NULL DEFAULT '0',
  `EmoteSlashCommand` text,
  `EmoteFlags` int(11) NOT NULL DEFAULT '0',
  `SpellVisualKitID` int(11) NOT NULL DEFAULT '0',
  `AnimID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EmoteSpecProc` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ClassMask` int(11) NOT NULL DEFAULT '0',
  `EmoteSpecProcParam` int(11) NOT NULL DEFAULT '0',
  `EventSoundID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `emotes` */

/*Table structure for table `emotes_locale` */

DROP TABLE IF EXISTS `emotes_locale`;

CREATE TABLE `emotes_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `EmoteSlashCommand_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `emotes_locale` */

/*Table structure for table `emotes_text` */

DROP TABLE IF EXISTS `emotes_text`;

CREATE TABLE `emotes_text` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `EmoteID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `emotes_text` */

/*Table structure for table `emotes_text_data` */

DROP TABLE IF EXISTS `emotes_text_data`;

CREATE TABLE `emotes_text_data` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Text` text,
  `RelationshipFlags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `emotes_text_data` */

/*Table structure for table `emotes_text_data_locale` */

DROP TABLE IF EXISTS `emotes_text_data_locale`;

CREATE TABLE `emotes_text_data_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Text_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `emotes_text_data_locale` */

/*Table structure for table `emotes_text_locale` */

DROP TABLE IF EXISTS `emotes_text_locale`;

CREATE TABLE `emotes_text_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `emotes_text_locale` */

/*Table structure for table `emotes_text_sound` */

DROP TABLE IF EXISTS `emotes_text_sound`;

CREATE TABLE `emotes_text_sound` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `RaceID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SexID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ClassID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SoundID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `emotes_text_sound` */

/*Table structure for table `environmental_damage` */

DROP TABLE IF EXISTS `environmental_damage`;

CREATE TABLE `environmental_damage` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `VisualKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EnumID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `environmental_damage` */

/*Table structure for table `exhaustion` */

DROP TABLE IF EXISTS `exhaustion`;

CREATE TABLE `exhaustion` (
  `Name` text,
  `CombatLogText` text,
  `Xp` int(10) unsigned NOT NULL DEFAULT '0',
  `Factor` float NOT NULL DEFAULT '0',
  `OutdoorHours` float NOT NULL DEFAULT '0',
  `InnHours` float NOT NULL DEFAULT '0',
  `Threshold` float NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `exhaustion` */

/*Table structure for table `exhaustion_locale` */

DROP TABLE IF EXISTS `exhaustion_locale`;

CREATE TABLE `exhaustion_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `CombatLogText_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `exhaustion_locale` */

/*Table structure for table `faction` */

DROP TABLE IF EXISTS `faction`;

CREATE TABLE `faction` (
  `ReputationRaceMask1` bigint(20) NOT NULL DEFAULT '0',
  `ReputationRaceMask2` bigint(20) NOT NULL DEFAULT '0',
  `ReputationRaceMask3` bigint(20) NOT NULL DEFAULT '0',
  `ReputationRaceMask4` bigint(20) NOT NULL DEFAULT '0',
  `Name` text,
  `Description` text,
  `ID` int(11) NOT NULL DEFAULT '0',
  `ReputationBase1` int(11) NOT NULL DEFAULT '0',
  `ReputationBase2` int(11) NOT NULL DEFAULT '0',
  `ReputationBase3` int(11) NOT NULL DEFAULT '0',
  `ReputationBase4` int(11) NOT NULL DEFAULT '0',
  `ParentFactionMod1` float NOT NULL DEFAULT '0',
  `ParentFactionMod2` float NOT NULL DEFAULT '0',
  `ReputationMax1` int(10) unsigned NOT NULL DEFAULT '0',
  `ReputationMax2` int(10) unsigned NOT NULL DEFAULT '0',
  `ReputationMax3` int(10) unsigned NOT NULL DEFAULT '0',
  `ReputationMax4` int(10) unsigned NOT NULL DEFAULT '0',
  `ReputationIndex` smallint(6) NOT NULL DEFAULT '0',
  `ReputationClassMask1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ReputationClassMask2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ReputationClassMask3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ReputationClassMask4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ReputationFlags1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ReputationFlags2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ReputationFlags3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ReputationFlags4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ParentFactionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ParagonFactionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ParentFactionCap1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ParentFactionCap2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Expansion` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FriendshipRepID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `faction` */

insert  into `faction`(`ReputationRaceMask1`,`ReputationRaceMask2`,`ReputationRaceMask3`,`ReputationRaceMask4`,`Name`,`Description`,`ID`,`ReputationBase1`,`ReputationBase2`,`ReputationBase3`,`ReputationBase4`,`ParentFactionMod1`,`ParentFactionMod2`,`ReputationMax1`,`ReputationMax2`,`ReputationMax3`,`ReputationMax4`,`ReputationIndex`,`ReputationClassMask1`,`ReputationClassMask2`,`ReputationClassMask3`,`ReputationClassMask4`,`ReputationFlags1`,`ReputationFlags2`,`ReputationFlags3`,`ReputationFlags4`,`ParentFactionID`,`ParagonFactionID`,`ParentFactionCap1`,`ParentFactionCap2`,`Expansion`,`Flags`,`FriendshipRepID`,`VerifiedBuild`) values 
(0,0,0,0,'Крылья Пустоты','Необычный вид черных драконов, произошедший от потомков Смертокрыла, яйца которых были подвержены влиянию энергии Пустоты. Сейчас они ищут себя, пытаясь избавиться от мрачного наследия своего отца.',1015,-42000,0,0,0,0,0,42000,0,0,0,71,0,0,0,0,2,0,0,0,980,0,0,0,0,0,0,0);

/*Table structure for table `faction_group` */

DROP TABLE IF EXISTS `faction_group`;

CREATE TABLE `faction_group` (
  `InternalName` text,
  `Name` text,
  `ID` int(11) NOT NULL DEFAULT '0',
  `MaskID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `HonorCurrencyTextureFileID` int(11) NOT NULL DEFAULT '0',
  `ConquestCurrencyTextureFileID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `faction_group` */

/*Table structure for table `faction_group_locale` */

DROP TABLE IF EXISTS `faction_group_locale`;

CREATE TABLE `faction_group_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `InternalName_lang` text,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `faction_group_locale` */

/*Table structure for table `faction_locale` */

DROP TABLE IF EXISTS `faction_locale`;

CREATE TABLE `faction_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `faction_locale` */

/*Table structure for table `faction_template` */

DROP TABLE IF EXISTS `faction_template`;

CREATE TABLE `faction_template` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Faction` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Flags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Enemies1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Enemies2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Enemies3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Enemies4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Friend1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Friend2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Friend3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Friend4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FactionGroup` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FriendGroup` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EnemyGroup` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `faction_template` */

/*Table structure for table `footprint_textures` */

DROP TABLE IF EXISTS `footprint_textures`;

CREATE TABLE `footprint_textures` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `TextureBlendsetID` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `FileDataID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `footprint_textures` */

/*Table structure for table `footstep_terrain_lookup` */

DROP TABLE IF EXISTS `footstep_terrain_lookup`;

CREATE TABLE `footstep_terrain_lookup` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `CreatureFootstepID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `TerrainSoundID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SoundID` int(11) NOT NULL DEFAULT '0',
  `SoundIDSplash` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `footstep_terrain_lookup` */

/*Table structure for table `friendship_rep_reaction` */

DROP TABLE IF EXISTS `friendship_rep_reaction`;

CREATE TABLE `friendship_rep_reaction` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Reaction` text,
  `ReactionThreshold` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FriendshipRepID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `friendship_rep_reaction` */

/*Table structure for table `friendship_rep_reaction_locale` */

DROP TABLE IF EXISTS `friendship_rep_reaction_locale`;

CREATE TABLE `friendship_rep_reaction_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Reaction_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `friendship_rep_reaction_locale` */

/*Table structure for table `friendship_reputation` */

DROP TABLE IF EXISTS `friendship_reputation`;

CREATE TABLE `friendship_reputation` (
  `Description` text,
  `TextureFileID` int(11) NOT NULL DEFAULT '0',
  `FactionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `friendship_reputation` */

/*Table structure for table `friendship_reputation_locale` */

DROP TABLE IF EXISTS `friendship_reputation_locale`;

CREATE TABLE `friendship_reputation_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `friendship_reputation_locale` */

/*Table structure for table `full_screen_effect` */

DROP TABLE IF EXISTS `full_screen_effect`;

CREATE TABLE `full_screen_effect` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Saturation` float NOT NULL DEFAULT '0',
  `GammaRed` float NOT NULL DEFAULT '0',
  `GammaGreen` float NOT NULL DEFAULT '0',
  `GammaBlue` float NOT NULL DEFAULT '0',
  `MaskOffsetY` float NOT NULL DEFAULT '0',
  `MaskSizeMultiplier` float NOT NULL DEFAULT '0',
  `MaskPower` float NOT NULL DEFAULT '0',
  `ColorMultiplyRed` float NOT NULL DEFAULT '0',
  `ColorMultiplyGreen` float NOT NULL DEFAULT '0',
  `ColorMultiplyBlue` float NOT NULL DEFAULT '0',
  `ColorMultiplyOffsetY` float NOT NULL DEFAULT '0',
  `ColorMultiplyMultiplier` float NOT NULL DEFAULT '0',
  `ColorMultiplyPower` float NOT NULL DEFAULT '0',
  `ColorAdditionRed` float NOT NULL DEFAULT '0',
  `ColorAdditionGreen` float NOT NULL DEFAULT '0',
  `ColorAdditionBlue` float NOT NULL DEFAULT '0',
  `ColorAdditionOffsetY` float NOT NULL DEFAULT '0',
  `ColorAdditionMultiplier` float NOT NULL DEFAULT '0',
  `ColorAdditionPower` float NOT NULL DEFAULT '0',
  `BlurIntensity` float NOT NULL DEFAULT '0',
  `BlurOffsetY` float NOT NULL DEFAULT '0',
  `BlurMultiplier` float NOT NULL DEFAULT '0',
  `BlurPower` float NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `TextureBlendSetID` int(11) NOT NULL DEFAULT '0',
  `EffectFadeInMs` int(11) NOT NULL DEFAULT '0',
  `EffectFadeOutMs` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `full_screen_effect` */

/*Table structure for table `g_m_survey_answers` */

DROP TABLE IF EXISTS `g_m_survey_answers`;

CREATE TABLE `g_m_survey_answers` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Answer` text,
  `SortIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `g_m_survey_answers` */

/*Table structure for table `g_m_survey_answers_locale` */

DROP TABLE IF EXISTS `g_m_survey_answers_locale`;

CREATE TABLE `g_m_survey_answers_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Answer_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `g_m_survey_answers_locale` */

/*Table structure for table `g_m_survey_current_survey` */

DROP TABLE IF EXISTS `g_m_survey_current_survey`;

CREATE TABLE `g_m_survey_current_survey` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `GmsurveyID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `g_m_survey_current_survey` */

/*Table structure for table `g_m_survey_questions` */

DROP TABLE IF EXISTS `g_m_survey_questions`;

CREATE TABLE `g_m_survey_questions` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Question` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `g_m_survey_questions` */

/*Table structure for table `g_m_survey_questions_locale` */

DROP TABLE IF EXISTS `g_m_survey_questions_locale`;

CREATE TABLE `g_m_survey_questions_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Question_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `g_m_survey_questions_locale` */

/*Table structure for table `g_m_survey_surveys` */

DROP TABLE IF EXISTS `g_m_survey_surveys`;

CREATE TABLE `g_m_survey_surveys` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Q1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Q2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Q3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Q4` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Q5` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Q6` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Q7` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Q8` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Q9` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Q10` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Q11` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Q12` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Q13` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Q14` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Q15` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `g_m_survey_surveys` */

/*Table structure for table `game_tips` */

DROP TABLE IF EXISTS `game_tips`;

CREATE TABLE `game_tips` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Text` text,
  `MinLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MaxLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SortIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `game_tips` */

/*Table structure for table `game_tips_locale` */

DROP TABLE IF EXISTS `game_tips_locale`;

CREATE TABLE `game_tips_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Text_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `game_tips_locale` */

/*Table structure for table `gameobject_art_kit` */

DROP TABLE IF EXISTS `gameobject_art_kit`;

CREATE TABLE `gameobject_art_kit` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `AttachModelFileID` int(11) NOT NULL DEFAULT '0',
  `TextureVariationFileID1` int(11) NOT NULL DEFAULT '0',
  `TextureVariationFileID2` int(11) NOT NULL DEFAULT '0',
  `TextureVariationFileID3` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `gameobject_art_kit` */

/*Table structure for table `gameobject_diff_anim_map` */

DROP TABLE IF EXISTS `gameobject_diff_anim_map`;

CREATE TABLE `gameobject_diff_anim_map` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `AttachmentDisplayID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DifficultyID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Animation` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `gameobject_diff_anim_map` */

/*Table structure for table `gameobject_display_info` */

DROP TABLE IF EXISTS `gameobject_display_info`;

CREATE TABLE `gameobject_display_info` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `FileDataID` int(11) NOT NULL DEFAULT '0',
  `GeoBoxMinX` float NOT NULL DEFAULT '0',
  `GeoBoxMinY` float NOT NULL DEFAULT '0',
  `GeoBoxMinZ` float NOT NULL DEFAULT '0',
  `GeoBoxMaxX` float NOT NULL DEFAULT '0',
  `GeoBoxMaxY` float NOT NULL DEFAULT '0',
  `GeoBoxMaxZ` float NOT NULL DEFAULT '0',
  `OverrideLootEffectScale` float NOT NULL DEFAULT '0',
  `OverrideNameScale` float NOT NULL DEFAULT '0',
  `ObjectEffectPackageID` smallint(6) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `gameobject_display_info` */

/*Table structure for table `gameobject_display_info_x_sound_kit` */

DROP TABLE IF EXISTS `gameobject_display_info_x_sound_kit`;

CREATE TABLE `gameobject_display_info_x_sound_kit` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `EventIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SoundKitID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `gameobject_display_info_x_sound_kit` */

/*Table structure for table `gameobjects` */

DROP TABLE IF EXISTS `gameobjects`;

CREATE TABLE `gameobjects` (
  `Name` text,
  `PositionX` float NOT NULL DEFAULT '0',
  `PositionY` float NOT NULL DEFAULT '0',
  `PositionZ` float NOT NULL DEFAULT '0',
  `RotationX` float NOT NULL DEFAULT '0',
  `RotationY` float NOT NULL DEFAULT '0',
  `RotationZ` float NOT NULL DEFAULT '0',
  `RotationO` float NOT NULL DEFAULT '0',
  `Scale` float NOT NULL DEFAULT '0',
  `PropValue1` int(10) unsigned NOT NULL DEFAULT '0',
  `PropValue2` int(10) unsigned NOT NULL DEFAULT '0',
  `PropValue3` int(10) unsigned NOT NULL DEFAULT '0',
  `PropValue4` int(10) unsigned NOT NULL DEFAULT '0',
  `PropValue5` int(10) unsigned NOT NULL DEFAULT '0',
  `PropValue6` int(10) unsigned NOT NULL DEFAULT '0',
  `PropValue7` int(10) unsigned NOT NULL DEFAULT '0',
  `PropValue8` int(10) unsigned NOT NULL DEFAULT '0',
  `OwnerID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DisplayID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PhaseID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PhaseGroupID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PhaseUseFlags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TypeID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `gameobjects` */

/*Table structure for table `gameobjects_locale` */

DROP TABLE IF EXISTS `gameobjects_locale`;

CREATE TABLE `gameobjects_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `gameobjects_locale` */

/*Table structure for table `garr_ability` */

DROP TABLE IF EXISTS `garr_ability`;

CREATE TABLE `garr_ability` (
  `Name` text,
  `Description` text,
  `IconFileDataID` int(11) NOT NULL DEFAULT '0',
  `Flags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FactionChangeGarrAbilityID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `GarrAbilityCategoryID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GarrFollowerTypeID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_ability` */

/*Table structure for table `garr_ability_category` */

DROP TABLE IF EXISTS `garr_ability_category`;

CREATE TABLE `garr_ability_category` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_ability_category` */

/*Table structure for table `garr_ability_category_locale` */

DROP TABLE IF EXISTS `garr_ability_category_locale`;

CREATE TABLE `garr_ability_category_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_ability_category_locale` */

/*Table structure for table `garr_ability_effect` */

DROP TABLE IF EXISTS `garr_ability_effect`;

CREATE TABLE `garr_ability_effect` (
  `CombatWeightBase` float NOT NULL DEFAULT '0',
  `CombatWeightMax` float NOT NULL DEFAULT '0',
  `ActionValueFlat` float NOT NULL DEFAULT '0',
  `ActionRecordID` int(11) NOT NULL DEFAULT '0',
  `GarrAbilityID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AbilityAction` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AbilityTargetType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GarrMechanicTypeID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ActionRace` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ActionHours` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_ability_effect` */

/*Table structure for table `garr_ability_locale` */

DROP TABLE IF EXISTS `garr_ability_locale`;

CREATE TABLE `garr_ability_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_ability_locale` */

/*Table structure for table `garr_building` */

DROP TABLE IF EXISTS `garr_building`;

CREATE TABLE `garr_building` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `AllianceName` text,
  `HordeName` text,
  `Description` text,
  `Tooltip` text,
  `HordeGameObjectID` int(11) NOT NULL DEFAULT '0',
  `AllianceGameObjectID` int(11) NOT NULL DEFAULT '0',
  `IconFileDataID` int(11) NOT NULL DEFAULT '0',
  `CurrencyTypeID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `HordeUiTextureKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AllianceUiTextureKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AllianceSceneScriptPackageID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `HordeSceneScriptPackageID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `GarrAbilityID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `BonusGarrAbilityID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `GoldCost` smallint(6) NOT NULL DEFAULT '0',
  `GarrSiteID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `BuildingType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `UpgradeLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ShipmentCapacity` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GarrTypeID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `BuildSeconds` int(11) NOT NULL DEFAULT '0',
  `CurrencyQty` int(11) NOT NULL DEFAULT '0',
  `MaxAssignments` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_building` */

/*Table structure for table `garr_building_doodad_set` */

DROP TABLE IF EXISTS `garr_building_doodad_set`;

CREATE TABLE `garr_building_doodad_set` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `GarrBuildingID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AllianceDoodadSet` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `HordeDoodadSet` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SpecializationID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_building_doodad_set` */

/*Table structure for table `garr_building_locale` */

DROP TABLE IF EXISTS `garr_building_locale`;

CREATE TABLE `garr_building_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `AllianceName_lang` text,
  `HordeName_lang` text,
  `Description_lang` text,
  `Tooltip_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_building_locale` */

/*Table structure for table `garr_building_plot_inst` */

DROP TABLE IF EXISTS `garr_building_plot_inst`;

CREATE TABLE `garr_building_plot_inst` (
  `MapOffsetX` float NOT NULL DEFAULT '0',
  `MapOffsetY` float NOT NULL DEFAULT '0',
  `UiTextureAtlasMemberID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `GarrSiteLevelPlotInstID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `GarrBuildingID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_building_plot_inst` */

/*Table structure for table `garr_class_spec` */

DROP TABLE IF EXISTS `garr_class_spec`;

CREATE TABLE `garr_class_spec` (
  `ClassSpec` text,
  `ClassSpecMale` text,
  `ClassSpecFemale` text,
  `UiTextureAtlasMemberID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `GarrFollItemSetID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FollowerClassLimit` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_class_spec` */

/*Table structure for table `garr_class_spec_locale` */

DROP TABLE IF EXISTS `garr_class_spec_locale`;

CREATE TABLE `garr_class_spec_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `ClassSpec_lang` text,
  `ClassSpecMale_lang` text,
  `ClassSpecFemale_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_class_spec_locale` */

/*Table structure for table `garr_class_spec_player_cond` */

DROP TABLE IF EXISTS `garr_class_spec_player_cond`;

CREATE TABLE `garr_class_spec_player_cond` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `IconFileDataID` int(11) NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GarrClassSpecID` int(11) NOT NULL DEFAULT '0',
  `PlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `FlavorGarrStringID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_class_spec_player_cond` */

/*Table structure for table `garr_class_spec_player_cond_locale` */

DROP TABLE IF EXISTS `garr_class_spec_player_cond_locale`;

CREATE TABLE `garr_class_spec_player_cond_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_class_spec_player_cond_locale` */

/*Table structure for table `garr_encounter` */

DROP TABLE IF EXISTS `garr_encounter`;

CREATE TABLE `garr_encounter` (
  `Name` text,
  `CreatureID` int(11) NOT NULL DEFAULT '0',
  `UiAnimScale` float NOT NULL DEFAULT '0',
  `UiAnimHeight` float NOT NULL DEFAULT '0',
  `PortraitFileDataID` int(11) NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `UiTextureKitID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_encounter` */

/*Table structure for table `garr_encounter_locale` */

DROP TABLE IF EXISTS `garr_encounter_locale`;

CREATE TABLE `garr_encounter_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_encounter_locale` */

/*Table structure for table `garr_encounter_set_x_encounter` */

DROP TABLE IF EXISTS `garr_encounter_set_x_encounter`;

CREATE TABLE `garr_encounter_set_x_encounter` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `xEncounter` int(10) unsigned NOT NULL DEFAULT '0',
  `Encounter` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_encounter_set_x_encounter` */

/*Table structure for table `garr_encounter_x_mechanic` */

DROP TABLE IF EXISTS `garr_encounter_x_mechanic`;

CREATE TABLE `garr_encounter_x_mechanic` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `GarrMechanicID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GarrMechanicSetID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GarrEncounterID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_encounter_x_mechanic` */

/*Table structure for table `garr_foll_item_set_member` */

DROP TABLE IF EXISTS `garr_foll_item_set_member`;

CREATE TABLE `garr_foll_item_set_member` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ItemID` int(11) NOT NULL DEFAULT '0',
  `MinItemLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemSlot` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GarrFollItemSetID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_foll_item_set_member` */

/*Table structure for table `garr_foll_support_spell` */

DROP TABLE IF EXISTS `garr_foll_support_spell`;

CREATE TABLE `garr_foll_support_spell` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `AllianceSpellID` int(11) NOT NULL DEFAULT '0',
  `HordeSpellID` int(11) NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GarrFollowerID` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_foll_support_spell` */

/*Table structure for table `garr_follower` */

DROP TABLE IF EXISTS `garr_follower`;

CREATE TABLE `garr_follower` (
  `HordeSourceText` text,
  `AllianceSourceText` text,
  `TitleName` text,
  `HordeCreatureID` int(11) NOT NULL DEFAULT '0',
  `AllianceCreatureID` int(11) NOT NULL DEFAULT '0',
  `HordeIconFileDataID` int(11) NOT NULL DEFAULT '0',
  `AllianceIconFileDataID` int(11) NOT NULL DEFAULT '0',
  `HordeSlottingBroadcastTextID` int(11) NOT NULL DEFAULT '0',
  `AllySlottingBroadcastTextID` int(11) NOT NULL DEFAULT '0',
  `HordeGarrFollItemSetID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AllianceGarrFollItemSetID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemLevelWeapon` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemLevelArmor` smallint(5) unsigned NOT NULL DEFAULT '0',
  `HordeUITextureKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AllianceUITextureKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `GarrFollowerTypeID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `HordeGarrFollRaceID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AllianceGarrFollRaceID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Quality` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `HordeGarrClassSpecID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AllianceGarrClassSpecID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FollowerLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Gender` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `HordeSourceTypeEnum` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AllianceSourceTypeEnum` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GarrTypeID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Vitality` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ChrClassID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `HordeFlavorGarrStringID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AllianceFlavorGarrStringID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_follower` */

/*Table structure for table `garr_follower_level_x_p` */

DROP TABLE IF EXISTS `garr_follower_level_x_p`;

CREATE TABLE `garr_follower_level_x_p` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `XpToNextLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ShipmentXP` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FollowerLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GarrFollowerTypeID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_follower_level_x_p` */

/*Table structure for table `garr_follower_locale` */

DROP TABLE IF EXISTS `garr_follower_locale`;

CREATE TABLE `garr_follower_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `HordeSourceText_lang` text,
  `AllianceSourceText_lang` text,
  `TitleName_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_follower_locale` */

/*Table structure for table `garr_follower_quality` */

DROP TABLE IF EXISTS `garr_follower_quality`;

CREATE TABLE `garr_follower_quality` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `XpToNextQuality` int(11) NOT NULL DEFAULT '0',
  `ShipmentXP` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Quality` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AbilityCount` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TraitCount` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GarrFollowerTypeID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ClassSpecID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_follower_quality` */

/*Table structure for table `garr_follower_set_x_follower` */

DROP TABLE IF EXISTS `garr_follower_set_x_follower`;

CREATE TABLE `garr_follower_set_x_follower` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `GarrFollowerID` int(11) NOT NULL DEFAULT '0',
  `GarrFollowerSetID` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_follower_set_x_follower` */

/*Table structure for table `garr_follower_type` */

DROP TABLE IF EXISTS `garr_follower_type`;

CREATE TABLE `garr_follower_type` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `MaxItemLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MaxFollowers` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxFollowerBuildingType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GarrTypeID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LevelRangeBias` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ItemLevelRangeBias` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_follower_type` */

/*Table structure for table `garr_follower_u_i_creature` */

DROP TABLE IF EXISTS `garr_follower_u_i_creature`;

CREATE TABLE `garr_follower_u_i_creature` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `CreatureID` int(11) NOT NULL DEFAULT '0',
  `Scale` float NOT NULL DEFAULT '0',
  `FactionIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_follower_u_i_creature` */

/*Table structure for table `garr_follower_x_ability` */

DROP TABLE IF EXISTS `garr_follower_x_ability`;

CREATE TABLE `garr_follower_x_ability` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `GarrAbilityID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FactionIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GarrFollowerID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_follower_x_ability` */

/*Table structure for table `garr_item_level_upgrade_data` */

DROP TABLE IF EXISTS `garr_item_level_upgrade_data`;

CREATE TABLE `garr_item_level_upgrade_data` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Operation` int(11) NOT NULL DEFAULT '0',
  `MinItemLevel` int(11) NOT NULL DEFAULT '0',
  `MaxItemLevel` int(11) NOT NULL DEFAULT '0',
  `FollowerTypeID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_item_level_upgrade_data` */

/*Table structure for table `garr_mechanic` */

DROP TABLE IF EXISTS `garr_mechanic`;

CREATE TABLE `garr_mechanic` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Factor` float NOT NULL DEFAULT '0',
  `GarrMechanicTypeID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GarrAbilityID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_mechanic` */

/*Table structure for table `garr_mechanic_set_x_mechanic` */

DROP TABLE IF EXISTS `garr_mechanic_set_x_mechanic`;

CREATE TABLE `garr_mechanic_set_x_mechanic` (
  `GarrMechanicID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `GarrMechanicSetId` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_mechanic_set_x_mechanic` */

/*Table structure for table `garr_mechanic_type` */

DROP TABLE IF EXISTS `garr_mechanic_type`;

CREATE TABLE `garr_mechanic_type` (
  `Name` text,
  `Description` text,
  `IconFileDataID` int(11) NOT NULL DEFAULT '0',
  `Category` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_mechanic_type` */

/*Table structure for table `garr_mechanic_type_locale` */

DROP TABLE IF EXISTS `garr_mechanic_type_locale`;

CREATE TABLE `garr_mechanic_type_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_mechanic_type_locale` */

/*Table structure for table `garr_mission` */

DROP TABLE IF EXISTS `garr_mission`;

CREATE TABLE `garr_mission` (
  `Name` text,
  `Description` text,
  `Location` text,
  `MissionDuration` int(11) NOT NULL DEFAULT '0',
  `OfferDuration` int(11) NOT NULL DEFAULT '0',
  `MapPos_1` float NOT NULL DEFAULT '0',
  `MapPos_2` float NOT NULL DEFAULT '0',
  `WorldPos1` float NOT NULL DEFAULT '0',
  `WorldPos2` float NOT NULL DEFAULT '0',
  `TargetItemLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `UiTextureKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MissionCostCurrencyTypesID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `TargetLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EnvGarrMechanicTypeID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxFollowers` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `OfferedGarrMissionTextureID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GarrMissionTypeID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GarrFollowerTypeID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `BaseCompletionChance` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FollowerDeathChance` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GarrTypeID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `TravelDuration` int(11) NOT NULL DEFAULT '0',
  `CriteriaID` int(11) NOT NULL DEFAULT '0',
  `PlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `MissionCost` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `BaseFollowerXP` int(11) NOT NULL DEFAULT '0',
  `AreaID` int(11) NOT NULL DEFAULT '0',
  `OvermaxRewardPackID` int(11) NOT NULL DEFAULT '0',
  `EnvGarrMechanicID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_mission` */

/*Table structure for table `garr_mission_locale` */

DROP TABLE IF EXISTS `garr_mission_locale`;

CREATE TABLE `garr_mission_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Description_lang` text,
  `Location_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_mission_locale` */

/*Table structure for table `garr_mission_texture` */

DROP TABLE IF EXISTS `garr_mission_texture`;

CREATE TABLE `garr_mission_texture` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Pos1` float NOT NULL DEFAULT '0',
  `Pos2` float NOT NULL DEFAULT '0',
  `UiTextureKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_mission_texture` */

/*Table structure for table `garr_mission_type` */

DROP TABLE IF EXISTS `garr_mission_type`;

CREATE TABLE `garr_mission_type` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `UiTextureAtlasMemberID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `UiTextureKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_mission_type` */

/*Table structure for table `garr_mission_type_locale` */

DROP TABLE IF EXISTS `garr_mission_type_locale`;

CREATE TABLE `garr_mission_type_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_mission_type_locale` */

/*Table structure for table `garr_mission_x_encounter` */

DROP TABLE IF EXISTS `garr_mission_x_encounter`;

CREATE TABLE `garr_mission_x_encounter` (
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `GarrMissionID` int(10) unsigned NOT NULL DEFAULT '0',
  `GarrEncounterID` int(11) NOT NULL DEFAULT '0',
  `GarrEncounterSetID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_mission_x_encounter` */

/*Table structure for table `garr_mission_x_follower` */

DROP TABLE IF EXISTS `garr_mission_x_follower`;

CREATE TABLE `garr_mission_x_follower` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `GarrFollowerID` int(11) NOT NULL DEFAULT '0',
  `GarrFollowerSetID` int(11) NOT NULL DEFAULT '0',
  `GarrMissionID` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_mission_x_follower` */

/*Table structure for table `garr_mssn_bonus_ability` */

DROP TABLE IF EXISTS `garr_mssn_bonus_ability`;

CREATE TABLE `garr_mssn_bonus_ability` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Radius` float NOT NULL DEFAULT '0',
  `DurationSecs` int(11) NOT NULL DEFAULT '0',
  `GarrAbilityID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `GarrFollowerTypeID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GarrMissionTextureID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_mssn_bonus_ability` */

/*Table structure for table `garr_plot` */

DROP TABLE IF EXISTS `garr_plot`;

CREATE TABLE `garr_plot` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `AllianceConstructObjID` int(11) NOT NULL DEFAULT '0',
  `HordeConstructObjID` int(11) NOT NULL DEFAULT '0',
  `UiCategoryID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PlotType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `UpgradeRequirement1` int(11) NOT NULL DEFAULT '0',
  `UpgradeRequirement2` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_plot` */

/*Table structure for table `garr_plot_building` */

DROP TABLE IF EXISTS `garr_plot_building`;

CREATE TABLE `garr_plot_building` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `GarrPlotID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GarrBuildingID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_plot_building` */

/*Table structure for table `garr_plot_instance` */

DROP TABLE IF EXISTS `garr_plot_instance`;

CREATE TABLE `garr_plot_instance` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `GarrPlotID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_plot_instance` */

/*Table structure for table `garr_plot_instance_locale` */

DROP TABLE IF EXISTS `garr_plot_instance_locale`;

CREATE TABLE `garr_plot_instance_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_plot_instance_locale` */

/*Table structure for table `garr_plot_locale` */

DROP TABLE IF EXISTS `garr_plot_locale`;

CREATE TABLE `garr_plot_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_plot_locale` */

/*Table structure for table `garr_plot_u_i_category` */

DROP TABLE IF EXISTS `garr_plot_u_i_category`;

CREATE TABLE `garr_plot_u_i_category` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `CategoryName` text,
  `PlotType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_plot_u_i_category` */

/*Table structure for table `garr_plot_u_i_category_locale` */

DROP TABLE IF EXISTS `garr_plot_u_i_category_locale`;

CREATE TABLE `garr_plot_u_i_category_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `CategoryName_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_plot_u_i_category_locale` */

/*Table structure for table `garr_site_level` */

DROP TABLE IF EXISTS `garr_site_level`;

CREATE TABLE `garr_site_level` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `TownHallUiPos1` float NOT NULL DEFAULT '0',
  `TownHallUiPos2` float NOT NULL DEFAULT '0',
  `MapID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `UiTextureKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `UpgradeMovieID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `UpgradeCost` smallint(5) unsigned NOT NULL DEFAULT '0',
  `UpgradeGoldCost` smallint(5) unsigned NOT NULL DEFAULT '0',
  `GarrLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GarrSiteID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxBuildingLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_site_level` */

/*Table structure for table `garr_site_level_plot_inst` */

DROP TABLE IF EXISTS `garr_site_level_plot_inst`;

CREATE TABLE `garr_site_level_plot_inst` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `UiMarkerPos1` float NOT NULL DEFAULT '0',
  `UiMarkerPos2` float NOT NULL DEFAULT '0',
  `GarrSiteLevelID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `GarrPlotInstanceID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `UiMarkerSize` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_site_level_plot_inst` */

/*Table structure for table `garr_specialization` */

DROP TABLE IF EXISTS `garr_specialization`;

CREATE TABLE `garr_specialization` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Tooltip` text,
  `IconFileDataID` int(11) NOT NULL DEFAULT '0',
  `Param1` float NOT NULL DEFAULT '0',
  `Param2` float NOT NULL DEFAULT '0',
  `BuildingType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SpecType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RequiredUpgradeLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_specialization` */

/*Table structure for table `garr_specialization_locale` */

DROP TABLE IF EXISTS `garr_specialization_locale`;

CREATE TABLE `garr_specialization_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Tooltip_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_specialization_locale` */

/*Table structure for table `garr_string` */

DROP TABLE IF EXISTS `garr_string`;

CREATE TABLE `garr_string` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Text` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_string` */

/*Table structure for table `garr_string_locale` */

DROP TABLE IF EXISTS `garr_string_locale`;

CREATE TABLE `garr_string_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Text_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_string_locale` */

/*Table structure for table `garr_talent` */

DROP TABLE IF EXISTS `garr_talent`;

CREATE TABLE `garr_talent` (
  `Name` text,
  `Description` text,
  `IconFileDataID` int(11) NOT NULL DEFAULT '0',
  `ResearchDurationSecs` int(11) NOT NULL DEFAULT '0',
  `Tier` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `UiOrder` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `GarrTalentTreeID` int(11) NOT NULL DEFAULT '0',
  `GarrAbilityID` int(11) NOT NULL DEFAULT '0',
  `PlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `ResearchCost` int(11) NOT NULL DEFAULT '0',
  `ResearchCostCurrencyTypesID` int(11) NOT NULL DEFAULT '0',
  `ResearchGoldCost` int(11) NOT NULL DEFAULT '0',
  `PerkSpellID` int(11) NOT NULL DEFAULT '0',
  `PerkPlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `RespecCost` int(11) NOT NULL DEFAULT '0',
  `RespecCostCurrencyTypesID` int(11) NOT NULL DEFAULT '0',
  `RespecDurationSecs` int(11) NOT NULL DEFAULT '0',
  `RespecGoldCost` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_talent` */

/*Table structure for table `garr_talent_locale` */

DROP TABLE IF EXISTS `garr_talent_locale`;

CREATE TABLE `garr_talent_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_talent_locale` */

/*Table structure for table `garr_talent_tree` */

DROP TABLE IF EXISTS `garr_talent_tree`;

CREATE TABLE `garr_talent_tree` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `UiTextureKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MaxTiers` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `UiOrder` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ClassID` int(11) NOT NULL DEFAULT '0',
  `GarrTypeID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_talent_tree` */

/*Table structure for table `garr_type` */

DROP TABLE IF EXISTS `garr_type`;

CREATE TABLE `garr_type` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `PrimaryCurrencyTypeID` int(11) NOT NULL DEFAULT '0',
  `SecondaryCurrencyTypeID` int(11) NOT NULL DEFAULT '0',
  `ExpansionID` int(11) NOT NULL DEFAULT '0',
  `MapIDs1` int(11) NOT NULL DEFAULT '0',
  `MapIDs2` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_type` */

/*Table structure for table `garr_ui_anim_class_info` */

DROP TABLE IF EXISTS `garr_ui_anim_class_info`;

CREATE TABLE `garr_ui_anim_class_info` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ImpactDelaySecs` float NOT NULL DEFAULT '0',
  `GarrClassSpecID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MovementType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CastKit` int(11) NOT NULL DEFAULT '0',
  `ImpactKit` int(11) NOT NULL DEFAULT '0',
  `TargetImpactKit` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_ui_anim_class_info` */

/*Table structure for table `garr_ui_anim_race_info` */

DROP TABLE IF EXISTS `garr_ui_anim_race_info`;

CREATE TABLE `garr_ui_anim_race_info` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `MaleScale` float NOT NULL DEFAULT '0',
  `MaleHeight` float NOT NULL DEFAULT '0',
  `MaleSingleModelScale` float NOT NULL DEFAULT '0',
  `MaleSingleModelHeight` float NOT NULL DEFAULT '0',
  `MaleFollowerPageScale` float NOT NULL DEFAULT '0',
  `MaleFollowerPageHeight` float NOT NULL DEFAULT '0',
  `FemaleScale` float NOT NULL DEFAULT '0',
  `FemaleHeight` float NOT NULL DEFAULT '0',
  `FemaleSingleModelScale` float NOT NULL DEFAULT '0',
  `FemaleSingleModelHeight` float NOT NULL DEFAULT '0',
  `FemaleFollowerPageScale` float NOT NULL DEFAULT '0',
  `FemaleFollowerPageHeight` float NOT NULL DEFAULT '0',
  `GarrFollRaceID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `garr_ui_anim_race_info` */

/*Table structure for table `gem_properties` */

DROP TABLE IF EXISTS `gem_properties`;

CREATE TABLE `gem_properties` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Type` int(11) NOT NULL DEFAULT '0',
  `EnchantID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MinItemLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `gem_properties` */

/*Table structure for table `global_strings` */

DROP TABLE IF EXISTS `global_strings`;

CREATE TABLE `global_strings` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `BaseTag` text,
  `TagText` text,
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `global_strings` */

/*Table structure for table `global_strings_locale` */

DROP TABLE IF EXISTS `global_strings_locale`;

CREATE TABLE `global_strings_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `BaseTag_lang` text,
  `TagText_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `global_strings_locale` */

/*Table structure for table `glyph_bindable_spell` */

DROP TABLE IF EXISTS `glyph_bindable_spell`;

CREATE TABLE `glyph_bindable_spell` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(10) unsigned NOT NULL DEFAULT '0',
  `GlyphPropertiesID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `glyph_bindable_spell` */

/*Table structure for table `glyph_exclusive_category` */

DROP TABLE IF EXISTS `glyph_exclusive_category`;

CREATE TABLE `glyph_exclusive_category` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `glyph_exclusive_category` */

/*Table structure for table `glyph_exclusive_category_locale` */

DROP TABLE IF EXISTS `glyph_exclusive_category_locale`;

CREATE TABLE `glyph_exclusive_category_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `glyph_exclusive_category_locale` */

/*Table structure for table `glyph_properties` */

DROP TABLE IF EXISTS `glyph_properties`;

CREATE TABLE `glyph_properties` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `SpellIconID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `GlyphType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GlyphExclusiveCategoryID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `glyph_properties` */

/*Table structure for table `glyph_required_spec` */

DROP TABLE IF EXISTS `glyph_required_spec`;

CREATE TABLE `glyph_required_spec` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ChrSpecializationID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `GlyphPropertiesID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `glyph_required_spec` */

/*Table structure for table `ground_effect_doodad` */

DROP TABLE IF EXISTS `ground_effect_doodad`;

CREATE TABLE `ground_effect_doodad` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Animscale` float NOT NULL DEFAULT '0',
  `PushScale` float NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ModelFileID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `ground_effect_doodad` */

/*Table structure for table `ground_effect_texture` */

DROP TABLE IF EXISTS `ground_effect_texture`;

CREATE TABLE `ground_effect_texture` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `DoodadID1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DoodadID2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DoodadID3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DoodadID4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DoodadWeight1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DoodadWeight2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DoodadWeight3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DoodadWeight4` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Sound` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Density` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `ground_effect_texture` */

/*Table structure for table `group_finder_activity` */

DROP TABLE IF EXISTS `group_finder_activity`;

CREATE TABLE `group_finder_activity` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `FullName` text,
  `ShortName` text,
  `MinGearLevelSuggestion` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MapID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AreaID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `GroupFinderCategoryID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GroupFinderActivityGrpID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MinLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxLevelSuggestion` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DifficultyID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DisplayType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxPlayers` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `group_finder_activity` */

/*Table structure for table `group_finder_activity_grp` */

DROP TABLE IF EXISTS `group_finder_activity_grp`;

CREATE TABLE `group_finder_activity_grp` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `group_finder_activity_grp` */

/*Table structure for table `group_finder_activity_grp_locale` */

DROP TABLE IF EXISTS `group_finder_activity_grp_locale`;

CREATE TABLE `group_finder_activity_grp_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `group_finder_activity_grp_locale` */

/*Table structure for table `group_finder_activity_locale` */

DROP TABLE IF EXISTS `group_finder_activity_locale`;

CREATE TABLE `group_finder_activity_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `FullName_lang` text,
  `ShortName_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `group_finder_activity_locale` */

/*Table structure for table `group_finder_category` */

DROP TABLE IF EXISTS `group_finder_category`;

CREATE TABLE `group_finder_category` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `group_finder_category` */

/*Table structure for table `group_finder_category_locale` */

DROP TABLE IF EXISTS `group_finder_category_locale`;

CREATE TABLE `group_finder_category_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `group_finder_category_locale` */

/*Table structure for table `guild_color_background` */

DROP TABLE IF EXISTS `guild_color_background`;

CREATE TABLE `guild_color_background` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Red` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Green` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Blue` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `guild_color_background` */

/*Table structure for table `guild_color_border` */

DROP TABLE IF EXISTS `guild_color_border`;

CREATE TABLE `guild_color_border` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Red` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Green` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Blue` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `guild_color_border` */

/*Table structure for table `guild_color_emblem` */

DROP TABLE IF EXISTS `guild_color_emblem`;

CREATE TABLE `guild_color_emblem` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Red` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Green` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Blue` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `guild_color_emblem` */

/*Table structure for table `guild_perk_spells` */

DROP TABLE IF EXISTS `guild_perk_spells`;

CREATE TABLE `guild_perk_spells` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `guild_perk_spells` */

/*Table structure for table `heirloom` */

DROP TABLE IF EXISTS `heirloom`;

CREATE TABLE `heirloom` (
  `SourceText` text,
  `ItemID` int(11) NOT NULL DEFAULT '0',
  `LegacyItemID` int(11) NOT NULL DEFAULT '0',
  `LegacyUpgradedItemID` int(11) NOT NULL DEFAULT '0',
  `StaticUpgradedItemID` int(11) NOT NULL DEFAULT '0',
  `UpgradeItemID1` int(11) NOT NULL DEFAULT '0',
  `UpgradeItemID2` int(11) NOT NULL DEFAULT '0',
  `UpgradeItemID3` int(11) NOT NULL DEFAULT '0',
  `UpgradeItemBonusListID1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `UpgradeItemBonusListID2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `UpgradeItemBonusListID3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SourceTypeEnum` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `heirloom` */

/*Table structure for table `heirloom_locale` */

DROP TABLE IF EXISTS `heirloom_locale`;

CREATE TABLE `heirloom_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `SourceText_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `heirloom_locale` */

/*Table structure for table `helmet_anim_scaling` */

DROP TABLE IF EXISTS `helmet_anim_scaling`;

CREATE TABLE `helmet_anim_scaling` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Amount` float NOT NULL DEFAULT '0',
  `RaceID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `helmet_anim_scaling` */

/*Table structure for table `helmet_geoset_vis_data` */

DROP TABLE IF EXISTS `helmet_geoset_vis_data`;

CREATE TABLE `helmet_geoset_vis_data` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `HideGeoset1` int(10) unsigned NOT NULL DEFAULT '0',
  `HideGeoset2` int(10) unsigned NOT NULL DEFAULT '0',
  `HideGeoset3` int(10) unsigned NOT NULL DEFAULT '0',
  `HideGeoset4` int(10) unsigned NOT NULL DEFAULT '0',
  `HideGeoset5` int(10) unsigned NOT NULL DEFAULT '0',
  `HideGeoset6` int(10) unsigned NOT NULL DEFAULT '0',
  `HideGeoset7` int(10) unsigned NOT NULL DEFAULT '0',
  `HideGeoset8` int(10) unsigned NOT NULL DEFAULT '0',
  `HideGeoset9` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `helmet_geoset_vis_data` */

/*Table structure for table `highlight_color` */

DROP TABLE IF EXISTS `highlight_color`;

CREATE TABLE `highlight_color` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `StartColor` int(10) unsigned NOT NULL DEFAULT '0',
  `MidColor` int(10) unsigned NOT NULL DEFAULT '0',
  `EndColor` int(10) unsigned NOT NULL DEFAULT '0',
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `highlight_color` */

/*Table structure for table `holiday_descriptions` */

DROP TABLE IF EXISTS `holiday_descriptions`;

CREATE TABLE `holiday_descriptions` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Description` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `holiday_descriptions` */

/*Table structure for table `holiday_descriptions_locale` */

DROP TABLE IF EXISTS `holiday_descriptions_locale`;

CREATE TABLE `holiday_descriptions_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `holiday_descriptions_locale` */

/*Table structure for table `holiday_names` */

DROP TABLE IF EXISTS `holiday_names`;

CREATE TABLE `holiday_names` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `holiday_names` */

/*Table structure for table `holiday_names_locale` */

DROP TABLE IF EXISTS `holiday_names_locale`;

CREATE TABLE `holiday_names_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `holiday_names_locale` */

/*Table structure for table `holidays` */

DROP TABLE IF EXISTS `holidays`;

CREATE TABLE `holidays` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Date1` int(11) NOT NULL DEFAULT '0',
  `Date2` int(11) NOT NULL DEFAULT '0',
  `Date3` int(11) NOT NULL DEFAULT '0',
  `Date4` int(11) NOT NULL DEFAULT '0',
  `Date5` int(11) NOT NULL DEFAULT '0',
  `Date6` int(11) NOT NULL DEFAULT '0',
  `Date7` int(11) NOT NULL DEFAULT '0',
  `Date8` int(11) NOT NULL DEFAULT '0',
  `Date9` int(11) NOT NULL DEFAULT '0',
  `Date10` int(11) NOT NULL DEFAULT '0',
  `Date11` int(11) NOT NULL DEFAULT '0',
  `Date12` int(11) NOT NULL DEFAULT '0',
  `Date13` int(11) NOT NULL DEFAULT '0',
  `Date14` int(11) NOT NULL DEFAULT '0',
  `Date15` int(11) NOT NULL DEFAULT '0',
  `Date16` int(11) NOT NULL DEFAULT '0',
  `Duration1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Duration2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Duration3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Duration4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Duration5` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Duration6` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Duration7` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Duration8` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Duration9` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Duration10` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Region` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Looping` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CalendarFlags1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CalendarFlags2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CalendarFlags3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CalendarFlags4` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CalendarFlags5` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CalendarFlags6` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CalendarFlags7` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CalendarFlags8` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CalendarFlags9` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CalendarFlags10` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Priority` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CalendarFilterType` tinyint(4) NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `HolidayNameID` int(11) NOT NULL DEFAULT '0',
  `HolidayDescriptionID` int(11) NOT NULL DEFAULT '0',
  `TextureFileDataID1` int(11) NOT NULL DEFAULT '0',
  `TextureFileDataID2` int(11) NOT NULL DEFAULT '0',
  `TextureFileDataID3` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `holidays` */

/*Table structure for table `hotfix` */

DROP TABLE IF EXISTS `hotfix`;

CREATE TABLE `hotfix` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Tablename` text,
  `ObjectID` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `hotfix` */

/*Table structure for table `hotfix_data` */

DROP TABLE IF EXISTS `hotfix_data`;

CREATE TABLE `hotfix_data` (
  `Id` int(10) unsigned NOT NULL DEFAULT '0',
  `TableHash` int(10) unsigned NOT NULL DEFAULT '0',
  `RecordID` int(10) NOT NULL,
  `Timestamp` int(10) unsigned NOT NULL DEFAULT '0',
  `Deleted` tinyint(3) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`Id`,`TableHash`,`RecordID`,`Timestamp`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `hotfix_data` */

insert  into `hotfix_data`(`Id`,`TableHash`,`RecordID`,`Timestamp`,`Deleted`) values 
(159998,1435332686,894,0,0),
(1,1073915313,35197,0,0),
(160050,1109793673,65483,0,0),
(160050,3834752085,160050,0,0),
(160050,2442913102,160050,0,0),
(160050,1344507586,160050,0,0),
(161051,1109793673,65482,0,0),
(161051,3834752085,160051,0,0),
(161051,2442913102,160051,0,0),
(161051,1344507586,160051,0,0),
(161052,1109793673,65481,0,0),
(161052,3834752085,160052,0,0),
(161052,2442913102,160052,0,0),
(161052,1344507586,160052,0,0),
(160053,1109793673,65480,0,0),
(160053,3834752085,160053,0,0),
(160053,2442913102,160053,0,0),
(160053,1344507586,160053,0,0),
(160053,1073915313,35036,0,0),
(160054,1109793673,65479,0,0),
(160054,3834752085,160054,0,0),
(160054,2442913102,160054,0,0),
(160054,1344507586,160054,0,0),
(160055,1109793673,65478,0,0),
(160055,3834752085,160055,0,0),
(160055,2442913102,160055,0,0),
(160055,1344507586,160055,0,0),
(161047,1109793673,65486,0,0),
(161047,1344507586,160047,0,0),
(161047,2442913102,160047,0,0),
(161047,3834752085,160047,0,0),
(161046,1344507586,160046,0,0),
(161046,2442913102,160046,0,0),
(161046,3834752085,160046,0,0),
(161046,1109793673,65487,0,0),
(161037,1344507586,160037,0,0),
(161037,2442913102,160037,0,0),
(161037,3834752085,160037,0,0),
(161037,1109793673,65496,0,0),
(161036,1344507586,160036,0,0),
(161036,2442913102,160036,0,0),
(161036,3834752085,160036,0,0),
(161036,1109793673,65497,0,0),
(161035,1344507586,160035,0,0),
(161035,2442913102,160035,0,0),
(161035,3834752085,160035,0,0),
(161035,1109793673,65498,0,0),
(161034,1344507586,160034,0,0),
(161034,2442913102,160034,0,0),
(161034,3834752085,160034,0,0),
(161034,1109793673,65499,0,0),
(161029,1344507586,160029,0,0),
(161029,2442913102,160029,0,0),
(161028,1344507586,160028,0,0),
(161028,2442913102,160028,0,0),
(160049,1344507586,160049,0,0),
(160049,2442913102,160049,0,0),
(160049,3834752085,160049,0,0),
(160049,1109793673,65484,0,0),
(160048,1344507586,160048,0,0),
(160048,2442913102,160048,0,0),
(160048,3834752085,160048,0,0),
(160048,1109793673,65485,0,0),
(160045,1344507586,160045,0,0),
(160045,2442913102,160045,0,0),
(160045,3834752085,160045,0,0),
(160045,1109793673,65488,0,0),
(160044,1344507586,160044,0,0),
(160044,2442913102,160044,0,0),
(160044,3834752085,160044,0,0),
(160044,1109793673,65489,0,0),
(160043,1344507586,160043,0,0),
(160043,2442913102,160043,0,0),
(160043,3834752085,160043,0,0),
(160043,1109793673,65490,0,0),
(160042,1344507586,160042,0,0),
(160042,2442913102,160042,0,0),
(160042,3834752085,160042,0,0),
(160042,1109793673,65491,0,0),
(160041,1344507586,160041,0,0),
(160041,2442913102,160041,0,0),
(160041,3834752085,160041,0,0),
(160041,1109793673,65492,0,0),
(160040,1344507586,160040,0,0),
(160040,2442913102,160040,0,0),
(160040,3834752085,160040,0,0),
(160040,1109793673,65493,0,0),
(160039,1344507586,160039,0,0),
(160039,2442913102,160039,0,0),
(160039,3834752085,160039,0,0),
(160039,1109793673,65494,0,0),
(160038,1344507586,160038,0,0),
(160038,2442913102,160038,0,0),
(160038,3834752085,160038,0,0),
(160038,1109793673,65495,0,0),
(160034,2442913102,140395,0,0),
(160033,1344507586,160033,0,0),
(160033,2442913102,160033,0,0),
(160033,3834752085,160033,0,0),
(160033,1109793673,65500,0,0),
(160033,2442913102,139380,0,0),
(160032,1344507586,160032,0,0),
(160032,2442913102,160032,0,0),
(160032,3834752085,160032,0,0),
(160032,1109793673,65501,0,0),
(160032,2442913102,138205,0,0),
(160031,1344507586,160031,0,0),
(160031,2442913102,160031,0,0),
(160031,3834752085,160031,0,0),
(160031,1109793673,65502,0,0),
(160031,2442913102,139501,0,0),
(160030,1344507586,160030,0,0),
(160030,2442913102,160030,0,0),
(160030,3834752085,160030,0,0),
(160030,1109793673,65503,0,0),
(160030,2442913102,138204,0,0),
(160029,1109793673,65504,0,0),
(160029,3834752085,160029,0,0),
(160029,2442913102,137184,0,0),
(160028,1109793673,65505,0,0),
(160028,3834752085,160028,0,0),
(160028,2442913102,137183,0,0),
(160027,1344507586,160027,0,0),
(160027,2442913102,160027,0,0),
(160027,3834752085,160027,0,0),
(160027,1109793673,65506,0,0),
(160027,2442913102,137182,0,0),
(160026,1344507586,160026,0,0),
(160026,2442913102,160026,0,0),
(160026,3834752085,160026,0,0),
(160026,1109793673,65507,0,0),
(160026,2442913102,133995,0,0),
(160025,1344507586,160025,0,0),
(160025,2442913102,160025,0,0),
(160025,3834752085,160025,0,0),
(160025,1109793673,65508,0,0),
(160025,2442913102,134005,0,0),
(160024,1344507586,160024,0,0),
(160024,2442913102,160024,0,0),
(160024,3834752085,160024,0,0),
(160024,1109793673,65509,0,0),
(160023,1344507586,160023,0,0),
(160023,2442913102,160023,0,0),
(160023,3834752085,160023,0,0),
(160023,1109793673,65510,0,0),
(160022,1344507586,160022,0,0),
(160022,2442913102,160022,0,0),
(160022,3834752085,160022,0,0),
(160022,1109793673,65511,0,0),
(160021,1344507586,160021,0,0),
(160021,2442913102,160021,0,0),
(160021,3834752085,160021,0,0),
(160021,1109793673,65513,0,0),
(160021,1109793673,65523,0,0),
(160020,1109793673,65514,0,0),
(160020,1344507586,160020,0,0),
(160020,2442913102,160020,0,0),
(160020,3834752085,160020,0,0),
(160019,1344507586,160019,0,0),
(160019,2442913102,160019,0,0),
(160019,3834752085,160019,0,0),
(160019,1109793673,65515,0,0),
(160018,1344507586,160018,0,0),
(160018,2442913102,160018,0,0),
(160018,3834752085,160018,0,0),
(160018,1109793673,65516,0,0),
(160017,1344507586,160017,0,0),
(160017,2442913102,160017,0,0),
(160017,3834752085,160017,0,0),
(160017,1109793673,65517,0,0),
(160016,1344507586,160016,0,0),
(160016,2442913102,160016,0,0),
(160016,3834752085,160016,0,0),
(160016,1109793673,65518,0,0),
(160015,1344507586,160015,0,0),
(160015,2442913102,160015,0,0),
(160015,3834752085,160015,0,0),
(160015,1109793673,65519,0,0),
(160014,1344507586,160014,0,0),
(160014,2442913102,160014,0,0),
(160014,3834752085,160014,0,0),
(160014,1109793673,65520,0,0),
(160013,1344507586,160013,0,0),
(160013,2442913102,160013,0,0),
(160013,3834752085,160013,0,0),
(160013,1109793673,65521,0,0),
(160012,1344507586,160012,0,0),
(160012,2442913102,160012,0,0),
(160012,3834752085,160012,0,0),
(160012,1109793673,65522,0,0),
(160011,1344507586,160011,0,0),
(160011,2442913102,160011,0,0),
(160011,3834752085,160011,0,0),
(160011,1109793673,65524,0,0),
(160009,1344507586,160009,0,0),
(160009,2442913102,160009,0,0),
(160009,3834752085,160009,0,0),
(160009,1109793673,65526,0,0),
(160008,1344507586,160008,0,0),
(160008,2442913102,160008,0,0),
(160008,3834752085,160008,0,0),
(160008,1109793673,65527,0,0),
(160007,1344507586,160007,0,0),
(160007,2442913102,160007,0,0),
(160007,3834752085,160007,0,0),
(160007,1109793673,65528,0,0),
(160006,1344507586,160006,0,0),
(160006,2442913102,160006,0,0),
(160006,3834752085,160006,0,0),
(160006,1109793673,65529,0,0),
(160005,1344507586,160005,0,0),
(160005,2442913102,160005,0,0),
(160005,3834752085,160005,0,0),
(160005,1109793673,65530,0,0),
(160004,1344507586,160004,0,0),
(160004,2442913102,160004,0,0),
(160004,3834752085,160004,0,0),
(160004,1109793673,65531,0,0),
(160003,1344507586,160003,0,0),
(160003,2442913102,160003,0,0),
(160003,3834752085,160003,0,0),
(160003,1109793673,65532,0,0),
(160002,1344507586,160002,0,0),
(160002,2442913102,160002,0,0),
(160002,3834752085,160002,0,0),
(160002,1109793673,65533,0,0),
(160001,1344507586,160001,0,0),
(160001,2442913102,160001,0,0),
(160001,3834752085,160001,0,0),
(160001,1109793673,65534,0,0),
(160000,1344507586,160000,0,0),
(160000,2442913102,160000,0,0),
(160000,3834752085,160000,0,0),
(160000,1109793673,65535,0,0),
(150000,3146089301,20001,0,0),
(150001,3146089301,20002,0,0),
(150002,3146089301,20003,0,0),
(150003,3146089301,20004,0,0),
(150004,3146089301,20005,0,0),
(150005,3146089301,20006,0,0),
(150006,3146089301,20007,0,0),
(150007,3146089301,20008,0,0),
(150008,3146089301,20009,0,0),
(150009,3146089301,20010,0,0),
(150010,3146089301,20011,0,0),
(150011,3146089301,20012,0,0),
(150011,3146089301,20013,0,0),
(150011,3146089301,20014,0,0),
(150012,3146089301,20015,0,0),
(150013,3146089301,20016,0,0),
(150014,3146089301,20017,0,0),
(150015,3146089301,20018,0,0),
(150016,3146089301,20019,0,0),
(5000,2524150337,305002,0,0),
(305002,2524150337,5000,0,0),
(5000,4134404214,5000,0,0),
(3000,2030087241,53450,0,0),
(53450,2030087241,3000,0,0),
(305011,3776013982,305011,0,0),
(305011,3322146344,400011,0,0),
(305012,3776013982,305012,0,0),
(305012,3322146344,400012,0,0),
(305013,3776013982,305013,0,0),
(305013,3322146344,400013,0,0),
(305000,3776013982,305000,0,0),
(305000,3322146344,400000,0,0),
(305001,3776013982,305001,0,0),
(305001,3322146344,400001,0,0),
(305002,3776013982,305002,0,0),
(305002,3322146344,400002,0,0),
(305002,1720692227,75000,0,0),
(305003,3776013982,305003,0,0),
(305003,3322146344,400003,0,0),
(305003,666345498,400003,0,0),
(305003,666345498,120000,0,0),
(22493,666345498,120000,0,0),
(305004,3776013982,305004,0,0),
(305004,3322146344,400004,0,0),
(305004,214333198,400004,0,0),
(156333,3776013982,156333,0,0),
(156333,3322146344,400014,0,0),
(156333,666345498,120004,0,0),
(156333,1720692227,75005,0,0),
(156333,1720692227,75007,0,0),
(305144,4012104832,19913,0,0),
(305015,3776013982,305015,0,0),
(305015,3322146344,400020,0,0),
(305015,1073915313,139665,0,0),
(305015,1073915313,133738,0,0),
(305021,3776013982,305021,0,0),
(305021,3322146344,400021,0,0),
(305016,3776013982,305016,0,0),
(305016,3322146344,400016,0,0),
(49480,3322146344,49480,0,0),
(199648,3322146344,199648,0,0),
(199649,3322146344,199649,0,0),
(199646,3322146344,199646,0,0),
(199645,3322146344,199645,0,0),
(199642,3322146344,199642,0,0),
(199640,3322146344,199640,0,0),
(199641,3322146344,199641,0,0),
(199643,3322146344,199643,0,0),
(199644,3322146344,199644,0,0),
(76629,4012104832,6629,0,0),
(76626,4012104832,6626,0,0),
(76628,4012104832,6628,0,0),
(76630,4012104832,6630,0,0),
(76627,4012104832,6627,0,0),
(2408,2523372402,408,0,0),
(2410,2523372402,410,0,0),
(2413,2523372402,413,0,0),
(2414,2523372402,414,0,0),
(2416,2523372402,416,0,0),
(2415,2523372402,415,0,0),
(2417,2523372402,417,0,0),
(2409,2523372402,409,0,1),
(2675,2456155917,2675,0,0),
(12003,2120822102,245,0,0),
(10688,1255424668,10688,0,0),
(10689,1255424668,10689,0,0),
(10692,1255424668,10692,0,0),
(10693,1255424668,10693,0,0),
(10694,1255424668,10694,0,0),
(24536,4012104832,24536,0,0),
(24535,4012104832,24535,0,0),
(24537,4012104832,24537,0,0),
(24534,4012104832,24534,0,0),
(24538,4012104832,24538,0,0),
(2344523,4021368146,6,0,0),
(305078,3776013982,305078,0,0),
(305078,3322146344,400078,0,0),
(305078,4030871717,410078,0,0),
(305076,214333198,400076,0,0),
(305076,3776013982,305076,0,0),
(305076,3322146344,400076,0,0),
(305076,4030871717,410076,0,0),
(5816,157446066,5816,0,0),
(11800,157446066,11800,0,0),
(11801,157446066,11801,0,0),
(15651,4012104832,15651,0,0),
(15652,4012104832,15652,0,0),
(15653,4012104832,15653,0,0),
(15654,4012104832,15654,0,0),
(305075,3776013982,305075,0,0),
(305075,3322146344,400075,0,0),
(305075,4030871717,410075,0,0),
(305075,214333198,400075,0,0),
(305074,3776013982,305074,0,0),
(305074,3322146344,400074,0,0),
(305074,4030871717,410074,0,0),
(305074,214333198,400074,0,0),
(305073,3776013982,305073,0,0),
(305073,3322146344,400073,0,0),
(305073,4030871717,410073,0,0),
(305073,214333198,400073,0,0),
(22844,4012104832,22844,0,0),
(22845,4012104832,22845,0,0),
(22929,4012104832,22929,0,0),
(16540,4012104832,16540,0,0),
(20487,4012104832,20487,0,0),
(20488,4012104832,20488,0,0),
(20489,4012104832,20489,0,0),
(20490,4012104832,20490,0,0),
(21208,4012104832,21208,0,0),
(20492,4012104832,20492,0,0),
(20493,4012104832,20493,0,0),
(7378,1255424668,7897,0,0),
(14097,4012104832,14097,0,0),
(16290,4012104832,16290,0,0),
(16291,4012104832,16291,0,0),
(305072,3776013982,305072,0,0),
(305072,3322146344,400072,0,0),
(305072,4030871717,410072,0,0),
(16011,4012104832,16011,0,0),
(23904,4012104832,13138,0,0),
(23907,4012104832,13138,0,0),
(23908,4012104832,13138,0,0),
(23909,4012104832,13138,0,0),
(23910,4012104832,13138,0,0),
(23911,4012104832,13138,0,0),
(23912,4012104832,13138,0,0),
(23913,4012104832,13138,0,0),
(23914,4012104832,13138,0,0),
(23772,4012104832,13138,0,0),
(23773,4012104832,13138,0,0),
(23774,4012104832,13138,0,0),
(23775,4012104832,13138,0,0),
(41859,1720692227,41859,0,0),
(33104,4012104832,33104,0,0),
(33105,4012104832,33105,0,0),
(28000,4096770149,28000,0,0),
(28001,4096770149,28001,0,0),
(10461,4012104832,10461,0,0),
(10449,4012104832,10449,0,0),
(17418,4012104832,17418,0,0),
(17576,4012104832,17576,0,0),
(17775,4012104832,17775,0,0),
(17776,4012104832,17776,0,0),
(17777,4012104832,17777,0,0),
(17778,4012104832,17778,0,0),
(17779,4012104832,17779,0,0),
(17542,4012104832,17542,0,0),
(17533,4012104832,17533,0,0),
(17535,4012104832,17535,0,0),
(17536,4012104832,17536,0,0),
(17538,4012104832,17538,0,0),
(17577,4012104832,17577,0,0),
(18494,4012104832,18494,0,0),
(18502,4012104832,18502,0,0),
(23732,4012104832,23732,0,0),
(23741,4012104832,23741,0,0),
(23733,4012104832,23733,0,0),
(23722,4012104832,23722,0,0),
(23650,4012104832,23650,0,0),
(23649,4012104832,23649,0,0),
(23905,4012104832,23905,0,0),
(23894,4012104832,23894,0,0),
(13138,4012104832,13138,0,0),
(305070,3776013982,305070,0,0),
(305070,3322146344,400070,0,0),
(305070,4030871717,410070,0,0),
(305071,3776013982,305071,0,0),
(305071,3322146344,400071,0,0),
(305071,4030871717,410071,0,0),
(13245,4012104832,13245,0,0),
(13244,4012104832,13244,0,0),
(13246,4012104832,13246,0,0),
(13247,4012104832,13247,0,0),
(13011,4012104832,13011,0,0),
(13013,4012104832,13013,0,0),
(12980,4012104832,12980,0,0),
(12971,4012104832,12971,0,0),
(12978,4012104832,12978,0,0),
(12979,4012104832,12979,0,0),
(16800,1255424668,16800,0,0),
(13910,1255424668,13910,0,0),
(14547,1255424668,14547,0,0),
(12589,1255424668,12589,0,0),
(16655,1255424668,16655,0,0),
(16656,1255424668,16656,0,0),
(16624,1255424668,16624,0,0),
(16625,1255424668,16625,0,0),
(305069,3776013982,305069,0,0),
(305069,3322146344,400069,0,0),
(305069,4030871717,410069,0,0),
(363547,4030871717,363547,0,0),
(363563,4030871717,363563,0,0),
(9074,157446066,9074,0,0),
(9078,157446066,9078,0,0),
(305068,3776013982,305068,0,0),
(305068,3322146344,400068,0,0),
(305068,4030871717,410068,0,0),
(305067,3776013982,305067,0,0),
(305067,3322146344,400067,0,0),
(305067,4030871717,410067,0,0),
(25274,4030871717,25274,0,0),
(145484,3322146344,145484,0,0),
(305057,3776013982,305057,0,0),
(305057,3322146344,400057,0,0),
(305057,4030871717,410057,0,0),
(305058,3776013982,305058,0,0),
(305058,3322146344,400058,0,0),
(305058,4030871717,410058,0,0),
(305059,3776013982,305059,0,0),
(305059,3322146344,400059,0,0),
(305059,4030871717,410059,0,0),
(305060,3776013982,305060,0,0),
(305060,3322146344,400060,0,0),
(305060,4030871717,410060,0,0),
(305061,3776013982,305061,0,0),
(305061,3322146344,400061,0,0),
(305061,4030871717,410061,0,0),
(305062,3776013982,305062,0,0),
(305062,3322146344,400062,0,0),
(305062,4030871717,410062,0,0),
(305063,3776013982,305063,0,0),
(305063,3322146344,400063,0,0),
(305063,4030871717,410063,0,0),
(305064,3776013982,305064,0,0),
(305064,3322146344,400064,0,0),
(305064,4030871717,410064,0,0),
(305065,3776013982,305065,0,0),
(305065,3322146344,400065,0,0),
(305065,4030871717,410065,0,0),
(305066,3776013982,305066,0,0),
(305066,3322146344,400066,0,0),
(305066,4030871717,410066,0,0),
(305056,3776013982,305056,0,0),
(305056,3322146344,400056,0,0),
(305056,4030871717,410056,0,0),
(305053,3776013982,305053,0,0),
(305053,3322146344,400053,0,0),
(305053,4030871717,410053,0,0),
(305054,3776013982,305054,0,0),
(305054,3322146344,400054,0,0),
(305054,4030871717,410054,0,0),
(305055,3776013982,305055,0,0),
(305055,3322146344,400055,0,0),
(305055,4030871717,410055,0,0),
(25539,4012104832,25539,0,0),
(25540,4012104832,25540,0,0),
(25541,4012104832,25541,0,0),
(305053,214333198,400053,0,0),
(305054,214333198,400054,0,0),
(305055,214333198,400055,0,0),
(305000,214333198,400000,0,0),
(305001,214333198,400001,0,0),
(305002,214333198,400002,0,0),
(305003,214333198,400003,0,0),
(305008,214333198,400008,0,0),
(305008,666345498,400008,0,0),
(59841,666345498,120002,0,0),
(305005,666345498,400005,0,0),
(305005,666345498,120001,0,0),
(31223,666345498,120001,0,0),
(42602,666345498,120003,0,0),
(128340,3834752085,128340,0,0),
(128340,1109793673,63010,0,0),
(128340,2442913102,128340,0,0),
(305011,4030871717,410011,0,0),
(305012,4030871717,410012,0,0),
(305013,4030871717,410013,0,0),
(305000,4030871717,410000,0,0),
(305001,4030871717,410001,0,0),
(305002,4030871717,410002,0,0),
(305003,4030871717,410003,0,0),
(305004,4030871717,410004,0,0),
(156333,4030871717,410014,0,0),
(156333,4030871717,410015,0,0),
(305015,4030871717,410021,0,0),
(305021,4030871717,410020,0,0),
(305016,4030871717,410016,0,0),
(305017,4030871717,410017,0,0),
(305025,4030871717,410025,0,0),
(305026,4030871717,410026,0,0),
(305027,4030871717,410027,0,0),
(305028,4030871717,410028,0,0),
(305029,4030871717,410029,0,0),
(305030,4030871717,410030,0,0),
(305031,4030871717,410031,0,0),
(305032,4030871717,410032,0,0),
(305033,4030871717,410033,0,0),
(305034,4030871717,410034,0,0),
(305035,4030871717,410035,0,0),
(305036,4030871717,410036,0,0),
(305037,4030871717,410037,0,0),
(305038,4030871717,410038,0,0),
(305039,4030871717,410039,0,0),
(305040,4030871717,410040,0,0),
(305041,4030871717,410041,0,0),
(305042,4030871717,410042,0,0),
(305043,4030871717,410043,0,0),
(305044,4030871717,410044,0,0),
(305045,4030871717,410045,0,0),
(305046,4030871717,410046,0,0),
(305047,4030871717,410047,0,0),
(305048,4030871717,410048,0,0),
(305049,4030871717,410049,0,0),
(305050,4030871717,410050,0,0),
(305051,4030871717,410051,0,0),
(305052,4030871717,410052,0,0),
(305005,4030871717,410005,0,0),
(305005,4030871717,410007,0,0),
(305006,4030871717,410006,0,0),
(305008,4030871717,410008,0,0),
(305009,4030871717,410009,0,0),
(128340,1344507586,128340,0,0),
(166001,1109793673,63001,0,0),
(166001,3834752085,166001,0,0),
(166001,2442913102,166001,0,0),
(166001,1344507586,166001,0,0),
(166001,1073915313,166001,0,0),
(166000,1109793673,63000,0,0),
(166000,3834752085,166000,0,0),
(166000,2442913102,166000,0,0),
(166000,1344507586,166000,0,0),
(166000,1073915313,166000,0,0),
(166002,1109793673,63002,0,0),
(166002,3834752085,166002,0,0),
(166002,2442913102,166002,0,0),
(166002,1344507586,166002,0,0),
(166002,1073915313,166002,0,0),
(166003,1109793673,63003,0,0),
(166003,3834752085,166003,0,0),
(166003,2442913102,166003,0,0),
(166003,1344507586,166003,0,0),
(166003,1073915313,166003,0,0),
(166004,1109793673,63004,0,0),
(166004,3834752085,166004,0,0),
(166004,2442913102,166004,0,0),
(166004,1344507586,166004,0,0),
(166004,1073915313,166004,0,0),
(166005,1109793673,63005,0,0),
(166005,3834752085,166005,0,0),
(166005,2442913102,166005,0,0),
(166005,1344507586,166005,0,0),
(166005,1073915313,166005,0,0),
(376114,4030871717,376114,0,0),
(31441,2120822102,31441,0,0),
(381500,4030871717,381500,0,0),
(381501,4030871717,381501,0,0),
(20517,4096770149,20517,0,0),
(114168,3322146344,114168,0,0),
(185272,4030871717,185272,0,0),
(151000,3146089301,20001,0,0),
(151001,3146089301,20002,0,0),
(151002,3146089301,20003,0,0),
(151003,3146089301,20004,0,0),
(151004,3146089301,20005,0,0),
(151005,3146089301,20006,0,0),
(151006,3146089301,20007,0,0),
(151007,3146089301,20008,0,0),
(151008,3146089301,20009,0,0),
(151009,3146089301,20010,0,0),
(151010,3146089301,20011,0,0),
(151011,3146089301,20012,0,0),
(151011,3146089301,20013,0,0),
(151011,3146089301,20014,0,0),
(151012,3146089301,20015,0,0),
(151013,3146089301,20016,0,0),
(151014,3146089301,20017,0,0),
(151015,3146089301,20018,0,0),
(151016,3146089301,20019,0,0),
(31555,4012104832,31555,0,0),
(29681,4012104832,29681,0,0),
(29699,4012104832,29699,0,0),
(300000,3776013982,300000,0,0),
(300000,214333198,230000,0,0),
(300000,3322146344,230000,0,0),
(300000,4030871717,707841,0,0),
(300000,1720692227,116729,0,0),
(300000,4193483863,56293,0,0),
(300001,3776013982,300001,0,0),
(300001,214333198,230001,0,0),
(300001,3322146344,230001,0,0),
(300001,4030871717,707842,0,0),
(300001,1720692227,116730,0,0),
(300001,4193483863,56294,0,0),
(300000,214333198,400079,0,0),
(300000,3322146344,400079,0,0),
(300001,214333198,400080,0,0),
(300001,3322146344,400080,0,0),
(160056,1109793673,65477,0,0),
(160056,3834752085,160056,0,0),
(160056,2442913102,160056,0,0),
(160056,1344507586,160056,0,0),
(160057,1109793673,65476,0,0),
(160057,3834752085,160057,0,0),
(160057,2442913102,160057,0,0),
(160057,1344507586,160057,0,0),
(36211,4012104832,36211,0,0),
(36337,4012104832,36337,0,0),
(31307,4012104832,31307,0,0),
(15947,4012104832,15947,0,0),
(15993,4012104832,15993,0,0),
(16209,4012104832,16209,0,0),
(31372,4012104832,31372,0,0),
(67308,1720692227,67308,0,0),
(20906,2120822102,319,0,0),
(20906,2120822102,5909,0,0),
(20906,2120822102,3506,0,0),
(20906,2120822102,20893,0,0),
(20906,2120822102,20906,0,0),
(20906,2120822102,20911,0,0),
(20906,2120822102,20915,0,0),
(20906,2120822102,20922,0,0),
(20906,2120822102,21044,0,0),
(20906,2120822102,21045,0,0),
(20906,2120822102,20939,0,0),
(20906,2120822102,4278,0,0),
(20906,2120822102,4286,0,0),
(3646,441483745,3646,0,0),
(3647,441483745,3647,0,0),
(101500,116794583,1015,0,0),
(464376,4030871717,464376,0,0),
(122097,666345498,122097,0,0),
(20244,4012104832,20244,0,0),
(14424,2442913102,124640,0,0),
(20518,3163679255,4756,0,0),
(20519,3163679255,45,0,0),
(305080,3776013982,305080,0,0),
(305080,3322146344,450080,0,0),
(305080,4030871717,410080,0,0),
(305081,3776013982,305081,0,0),
(305081,3322146344,450081,0,0),
(305081,4030871717,410081,0,0),
(410079,4030871717,410079,0,0),
(20520,4030871717,299412,0,0),
(20521,4030871717,299449,0,0),
(305082,3776013982,305082,0,0),
(305082,3322146344,450082,0,0),
(305082,4030871717,410082,0,0),
(305083,3776013982,305083,0,0),
(305083,3322146344,450083,0,0),
(305083,4030871717,410083,0,0),
(305084,3776013982,305084,0,0),
(305084,3322146344,450084,0,0),
(305084,4030871717,410084,0,0),
(166006,1344507586,166006,0,0),
(166006,2442913102,166006,0,0),
(166006,1073915313,37008,0,0),
(166006,3834752085,166006,0,0),
(166006,1109793673,63006,0,0),
(166007,1344507586,166007,0,0),
(166007,2442913102,166007,0,0),
(166007,1073915313,37009,0,0),
(166007,3834752085,166007,0,0),
(166007,1109793673,63007,0,0),
(160058,1109793673,65475,0,0),
(160058,3834752085,160058,0,0),
(160058,2442913102,160058,0,0),
(160058,1344507586,160058,0,0),
(160059,1109793673,65474,0,0),
(160059,3834752085,160059,0,0),
(160059,2442913102,160059,0,0),
(160059,1344507586,160059,0,0),
(376718,666345498,376718,0,0),
(305085,3776013982,305085,0,0),
(305085,3322146344,450085,0,0),
(305085,4030871717,410085,0,0),
(164726,4030871717,164726,0,0),
(164726,4030871717,164725,0,0),
(164726,4030871717,164724,0,0),
(164726,4030871717,164723,0,0),
(164726,4030871717,164689,0,0),
(305086,3776013982,305086,0,0),
(305086,3322146344,450086,0,0),
(305086,4030871717,410086,0,0),
(305086,3776013982,305087,0,0),
(305086,3322146344,450087,0,0),
(305086,4030871717,410087,0,0),
(305086,3776013982,305088,0,0),
(305086,3322146344,450088,0,0),
(305086,4030871717,410088,0,0),
(305086,3776013982,305089,0,0),
(305086,3322146344,450089,0,0),
(305086,4030871717,410089,0,0),
(305086,3776013982,305090,0,0),
(305086,3322146344,450090,0,0),
(305086,4030871717,410090,0,0),
(305086,3776013982,305091,0,0),
(305086,3322146344,450091,0,0),
(305086,4030871717,410091,0,0),
(305086,3776013982,305092,0,0),
(305086,3322146344,450092,0,0),
(305086,4030871717,410092,0,0),
(305086,3776013982,305093,0,0),
(305086,3322146344,450093,0,0),
(305086,4030871717,410093,0,0),
(305086,3776013982,305095,0,0),
(305086,3322146344,450095,0,0),
(305086,4030871717,410095,0,0),
(305086,3776013982,305096,0,0),
(305086,3322146344,450096,0,0),
(305086,4030871717,410096,0,0),
(305086,3776013982,305097,0,0),
(305086,3322146344,450097,0,0),
(305086,4030871717,410097,0,0),
(305086,3776013982,305098,0,0),
(305086,3322146344,450098,0,0),
(305086,4030871717,410098,0,0),
(305086,3776013982,305099,0,0),
(305086,3322146344,450099,0,0),
(305086,4030871717,410099,0,0),
(305086,3776013982,305100,0,0),
(305086,3322146344,450100,0,0),
(305086,4030871717,410100,0,0),
(305086,3776013982,305101,0,0),
(305086,3322146344,450101,0,0),
(305086,4030871717,410101,0,0),
(305086,3776013982,305102,0,0),
(305086,3322146344,450102,0,0),
(305086,4030871717,410102,0,0),
(305094,3776013982,305094,0,0),
(305094,3322146344,450094,0,0),
(305094,4030871717,410094,0,0),
(5001,2524150337,5001,0,0),
(20522,3689412649,51114,0,0),
(20523,4193483863,22915,0,0),
(232494,3322146344,232494,0,0),
(466599,4030871717,466599,0,0),
(219203,3322146344,219203,0,0),
(20105,4030871717,20105,0,0),
(7144,4012104832,7144,0,0),
(22620,3322146344,22620,0,0),
(200000,35137211,200000,0,0),
(557160,4030871717,55716,0,0),
(1165,3080893373,1165,0,1),
(1166,3080893373,1166,0,1),
(161061,1109793673,65473,0,0),
(160060,1109793673,65473,0,0),
(160060,3834752085,160060,0,0),
(160060,2442913102,160060,0,0),
(160060,1344507586,160060,0,0),
(161060,1109793673,65473,0,0),
(161060,3834752085,160060,0,0),
(161060,2442913102,160060,0,0),
(161060,1344507586,160060,0,0),
(101538,1344507586,101538,0,0),
(101538,2442913102,101538,0,0),
(101538,1073915313,17735,0,0),
(101538,3834752085,101538,0,0),
(101538,1109793673,63100,0,0),
(161061,3834752085,160060,0,0),
(161061,2442913102,160060,0,0),
(161061,1344507586,160060,0,0),
(1164,3080893373,1164,0,1),
(1133,3080893373,1133,0,1),
(1134,3080893373,1134,0,1),
(1135,3080893373,1135,0,1),
(305103,3776013982,305103,0,0),
(305103,3322146344,450103,0,0),
(305103,4030871717,410103,0,0),
(166008,1344507586,166008,0,0),
(166008,2442913102,166008,0,0),
(166008,3834752085,166008,0,0),
(166008,1109793673,56008,0,0),
(20524,4096770149,25689,0,0),
(20525,4096770149,25765,0,0),
(20526,4096770149,25766,0,0),
(20527,4096770149,25767,0,0),
(20528,4096770149,25768,0,0),
(20529,4096770149,25769,0,0),
(20530,4096770149,25770,0,0),
(742,825311328,742,0,0),
(743,825311328,742,0,0),
(20531,4096770149,22971,0,0),
(93947,3834752085,93947,0,0),
(200001,35137211,200000,0,0),
(37930,4012104832,37930,0,0),
(293005,4030871717,293005,0,0),
(160061,1109793673,65472,0,0),
(160061,3834752085,160061,0,0),
(160061,2442913102,160061,0,0),
(160061,1344507586,160061,0,0),
(160062,1109793673,65471,0,0),
(160062,3834752085,160062,0,0),
(160062,2442913102,160062,0,0),
(160062,1344507586,160062,0,0),
(160063,1109793673,65470,0,0),
(160063,3834752085,160063,0,0),
(160063,2442913102,160063,0,0),
(160063,1344507586,160063,0,0),
(305104,3776013982,305104,0,0),
(305104,3322146344,450104,0,0),
(305104,4030871717,410104,0,0),
(65774,2120822102,65774,0,1),
(65774,2120822102,65775,0,1),
(65774,2120822102,67364,0,1),
(65775,2120822102,65774,0,0),
(65775,2120822102,65775,0,0),
(65775,2120822102,67364,0,0),
(160064,1109793673,65469,0,0),
(160064,3834752085,160064,0,0),
(160064,2442913102,160064,0,0),
(160064,1344507586,160064,0,0),
(20532,4096770149,12458,0,0),
(20533,4030871717,321944,0,0),
(20534,4030871717,321952,0,0),
(58945,1255424668,58945,0,0),
(58946,1255424668,58946,0,0),
(34398,4012104832,34396,0,0),
(305999,3776013982,305080,0,0),
(305999,3322146344,450080,0,0),
(305999,4030871717,410080,0,0),
(305998,3776013982,305103,0,0),
(305998,3322146344,450103,0,0),
(305998,4030871717,410103,0,0),
(20535,4096770149,22664,0,0),
(160065,1109793673,65468,0,0),
(160065,3834752085,160065,0,0),
(160065,2442913102,160065,0,0),
(160065,1344507586,160065,0,0),
(166009,2442913102,166008,0,0),
(36173,4012104832,36173,0,0),
(36514,4012104832,36514,0,0),
(24823,4012104832,24823,0,0),
(7378,1255424668,7378,0,0),
(7378,1255424668,7898,0,0),
(64278,1255424668,64278,0,0),
(64279,1255424668,64279,0,0),
(64279,1255424668,43515,0,1),
(12352,3538824359,12352,0,0),
(305105,666345498,80235,0,0),
(305105,3776013982,305105,0,0),
(305105,3322146344,450105,0,0),
(305105,4030871717,410104,0,0),
(19408,4012104832,19408,0,0),
(20007,4012104832,20007,0,0),
(20536,4193483863,27169,0,0),
(7390,1255424668,7897,0,0),
(7390,1255424668,7898,0,0),
(160066,1109793673,65467,0,0),
(160066,3834752085,160066,0,0),
(160066,2442913102,160066,0,0),
(160066,1344507586,160066,0,0),
(17836,4012104832,17836,0,0),
(161065,1109793673,65468,0,0),
(161065,3834752085,160065,0,0),
(161065,2442913102,160065,0,0),
(161065,1344507586,160065,0,0),
(160067,1109793673,65466,0,0),
(160067,3834752085,160067,0,0),
(160067,2442913102,160067,0,0),
(160067,1344507586,160067,0,0),
(160068,1109793673,65465,0,0),
(160068,3834752085,160068,0,0),
(160068,2442913102,160068,0,0),
(160068,1344507586,160068,0,0),
(160069,1109793673,65464,0,0),
(160069,3834752085,160069,0,0),
(160069,2442913102,160069,0,0),
(160069,1344507586,160069,0,0),
(20537,4030871717,288648,0,0),
(161069,1109793673,65464,0,0),
(161069,3834752085,160069,0,0),
(161069,2442913102,160069,0,0),
(161069,1344507586,160069,0,0),
(160070,1109793673,65463,0,0),
(160070,3834752085,160070,0,0),
(160070,2442913102,160070,0,0),
(160070,1344507586,160070,0,0),
(160071,1109793673,65462,0,0),
(160071,3834752085,160071,0,0),
(160071,2442913102,160071,0,0),
(160071,1344507586,160071,0,0),
(35038,1073915313,35038,0,0),
(161071,1109793673,65462,0,0),
(161071,3834752085,160071,0,0),
(161071,2442913102,160071,0,0),
(161071,1344507586,160071,0,0),
(181361,4030871717,181361,0,0),
(14146,4012104832,14146,0,0),
(32385,4012104832,32385,0,0),
(32384,4012104832,32384,0,0),
(29680,4012104832,29680,0,0),
(29683,4012104832,29683,0,0),
(5003,2524150337,5001,0,0),
(5003,2524150337,5002,0,0),
(31344,4012104832,31344,0,0),
(29405,4012104832,29405,0,0),
(33333,1821637041,2158,0,0),
(33334,1821637041,1061,0,0),
(33336,1821637041,1642,0,0),
(33337,1821637041,1428,0,0),
(33335,1821637041,1511,0,0),
(160072,1109793673,65461,0,0),
(160072,3834752085,160072,0,0),
(160072,2442913102,160072,0,0),
(160072,1344507586,160072,0,0),
(3,2523372402,1,0,0),
(4,2523372402,2,0,0),
(5,2523372402,3,0,0),
(6,2523372402,4,0,0),
(7,1255424668,1,0,0),
(8,1255424668,4,0,0),
(9,1255424668,7,0,0),
(2,2198813286,1,0,0),
(160073,1109793673,65460,0,0),
(160073,3834752085,160073,0,0),
(160073,2442913102,160073,0,0),
(160073,1344507586,160073,0,0),
(20538,3776013982,199424,0,0),
(20538,4030871717,293472,0,0),
(20538,4030871717,293473,0,0),
(160074,1109793673,65459,0,0),
(160074,3834752085,160074,0,0),
(160074,2442913102,160074,0,0),
(160074,1344507586,160074,0,0),
(160075,1109793673,65458,0,0),
(160075,3834752085,160075,0,0),
(160075,2442913102,160075,0,0),
(160075,1344507586,160075,0,0),
(161076,1109793673,65457,0,0),
(161076,3834752085,160076,0,0),
(161076,2442913102,160076,0,0),
(161076,1344507586,160076,0,0),
(35040,1073915313,35040,0,0),
(2294,4021368146,2294,0,0),
(33338,1821637041,1395,0,0),
(19979,4012104832,19979,0,0),
(557170,4030871717,55717,0,0),
(557180,4030871717,55718,0,0),
(557190,4030871717,55719,0,0),
(557200,4030871717,55720,0,0),
(20539,4030871717,344184,0,0),
(20539,4030871717,344185,0,0),
(7,4021368146,7,0,0),
(2800,4021368146,2800,0,0),
(2801,4021368146,2801,0,0),
(2802,4021368146,2802,0,0),
(42034,4012104832,39859,0,0),
(61002,1255424668,61002,0,0),
(61003,1255424668,61003,0,0),
(65600,1255424668,65600,0,0),
(65601,1255424668,65601,0,0),
(65602,1255424668,65602,0,0),
(65603,1255424668,65603,0,0),
(2100,3179597154,2100,0,0),
(1156,3179597154,1156,0,0),
(12006,1918102339,12002,0,0),
(12007,1918102339,12003,0,0),
(4017,2456155917,4017,0,0),
(4016,2456155917,4016,0,0),
(191,2769561834,191,0,0),
(2903,3921595171,2900,0,0),
(1300,3921595171,1300,0,0),
(25250,3146089301,25250,0,0),
(526,2246024846,526,0,0),
(12460,3538824359,12460,0,0),
(1160,793851790,1160,0,0),
(1161,793851790,1161,0,0),
(25000,3146089301,25000,0,0),
(25001,3146089301,25001,0,0),
(25002,3146089301,25002,0,0),
(25003,3146089301,25003,0,0),
(25004,3146089301,25004,0,0),
(25005,3146089301,25005,0,0),
(25006,3146089301,25006,0,0),
(25007,3146089301,25007,0,0),
(25008,3146089301,25008,0,0),
(25009,3146089301,25009,0,0),
(25010,3146089301,25010,0,0),
(25011,3146089301,25011,0,0),
(25012,3146089301,25012,0,0),
(25013,3146089301,25013,0,0),
(25014,3146089301,25014,0,0),
(25015,3146089301,25015,0,0),
(25016,3146089301,25016,0,0),
(25017,3146089301,25017,0,0),
(25018,3146089301,25018,0,0),
(25019,3146089301,25019,0,0),
(25020,3146089301,25020,0,0),
(25021,3146089301,25021,0,0),
(25022,3146089301,25022,0,0),
(25023,3146089301,25023,0,0),
(25024,3146089301,25024,0,0),
(25025,3146089301,25025,0,0),
(25026,3146089301,25026,0,0),
(25027,3146089301,25027,0,0),
(25028,3146089301,25028,0,0),
(25029,3146089301,25029,0,0),
(25030,3146089301,25030,0,0),
(25031,3146089301,25031,0,0),
(83283,3218799089,83283,0,0),
(83284,3218799089,83284,0,0),
(83281,3218799089,83281,0,0),
(83285,3218799089,83285,0,0),
(83286,3218799089,83286,0,0),
(83287,3218799089,83287,0,0),
(83288,3218799089,83288,0,0),
(5010,2524150337,5010,0,0),
(5010,2030087241,3010,0,0),
(5010,4134404214,5010,0,0),
(5011,2524150337,5011,0,0),
(5011,2030087241,3011,0,0),
(5011,4134404214,5011,0,0),
(5012,2524150337,5012,0,0),
(5012,2030087241,3012,0,0),
(5012,4134404214,5012,0,0),
(5013,2524150337,5013,0,0),
(5013,2030087241,3013,0,0),
(5013,4134404214,5013,0,0),
(5014,2524150337,5014,0,0),
(5014,2030087241,3014,0,0),
(5014,4134404214,5014,0,0),
(5015,2524150337,5015,0,0),
(5015,2030087241,3015,0,0),
(5015,4134404214,5015,0,0),
(5016,2524150337,5016,0,0),
(5016,2030087241,3016,0,0),
(5016,4134404214,5016,0,0),
(5017,2524150337,5017,0,0),
(5017,2030087241,3017,0,0),
(5017,4134404214,5017,0,0),
(5018,2524150337,5018,0,0),
(5018,2030087241,3018,0,0),
(5018,4134404214,5018,0,0),
(5019,2524150337,5019,0,0),
(5019,2030087241,3019,0,0),
(5019,4134404214,5019,0,0),
(5020,2524150337,5020,0,0),
(5020,2030087241,3020,0,0),
(5020,4134404214,5020,0,0),
(5021,2524150337,5021,0,0),
(5021,2030087241,3021,0,0),
(5021,4134404214,5021,0,0),
(166500,1344507586,166500,0,0),
(166500,2442913102,166500,0,0),
(166500,1073915313,79000,0,0),
(166500,3834752085,166500,0,0),
(166500,1109793673,40000,0,0),
(166501,1344507586,166501,0,0),
(166501,2442913102,166501,0,0),
(166501,3834752085,166501,0,0),
(166501,1109793673,40001,0,0),
(166502,1344507586,166502,0,0),
(166502,2442913102,166502,0,0),
(166502,3834752085,166502,0,0),
(166502,1109793673,40002,0,0),
(166503,1344507586,166503,0,0),
(166503,2442913102,166503,0,0),
(166503,3834752085,166503,0,0),
(166503,1109793673,40003,0,0),
(166504,1344507586,166504,0,0),
(166504,2442913102,166504,0,0),
(166504,3834752085,166504,0,0),
(166504,1109793673,40004,0,0),
(166505,1344507586,166505,0,0),
(166505,2442913102,166505,0,0),
(166505,3834752085,166505,0,0),
(166505,1109793673,40005,0,0),
(166506,1344507586,166506,0,0),
(166506,2442913102,166506,0,0),
(166506,3834752085,166506,0,0),
(166506,1109793673,40006,0,0),
(166507,1344507586,166507,0,0),
(166507,2442913102,166507,0,0),
(166507,3834752085,166507,0,0),
(166507,1109793673,40007,0,0),
(166507,1073915313,79001,0,0),
(166508,1344507586,166508,0,0),
(166508,2442913102,166508,0,0),
(166508,3834752085,166508,0,0),
(166508,1109793673,40008,0,0),
(166508,1073915313,79002,0,0),
(166509,1344507586,166509,0,0),
(166509,2442913102,166509,0,0),
(166509,3834752085,166509,0,0),
(166509,1109793673,40009,0,0),
(166509,1073915313,79009,0,0),
(166510,1344507586,166510,0,0),
(166510,2442913102,166510,0,0),
(166510,3834752085,166510,0,0),
(166510,1109793673,40010,0,0),
(166510,1073915313,79010,0,0),
(166511,1344507586,166511,0,0),
(166511,2442913102,166511,0,0),
(166511,3834752085,166511,0,0),
(166511,1109793673,40011,0,0),
(166511,1073915313,79011,0,0),
(166512,1344507586,166512,0,0),
(166512,2442913102,166512,0,0),
(166512,3834752085,166512,0,0),
(166512,1109793673,40012,0,0),
(166512,1073915313,79012,0,0),
(166513,1344507586,166513,0,0),
(166513,2442913102,166513,0,0),
(166513,3834752085,166513,0,0),
(166513,1109793673,40013,0,0),
(166513,1073915313,79013,0,0),
(166514,1344507586,166514,0,0),
(166514,2442913102,166514,0,0),
(166514,3834752085,166514,0,0),
(166514,1109793673,40014,0,0),
(166514,1073915313,79014,0,0),
(166515,1344507586,166515,0,0),
(166515,2442913102,166515,0,0),
(166515,3834752085,166515,0,0),
(166515,1109793673,40015,0,0),
(166515,1073915313,79015,0,0),
(166516,1344507586,166516,0,0),
(166516,2442913102,166516,0,0),
(166516,3834752085,166516,0,0),
(166516,1109793673,40016,0,0),
(166516,1073915313,79016,0,0),
(166517,1344507586,166517,0,0),
(166517,2442913102,166517,0,0),
(166517,3834752085,166517,0,0),
(166517,1109793673,40017,0,0),
(166517,1073915313,79017,0,0),
(166518,1344507586,166518,0,0),
(166518,2442913102,166518,0,0),
(166518,3834752085,166518,0,0),
(166518,1109793673,40018,0,0),
(166518,1073915313,79018,0,0),
(166519,1344507586,166519,0,0),
(166519,2442913102,166519,0,0),
(166519,3834752085,166519,0,0),
(166519,1109793673,40019,0,0),
(166519,1073915313,79019,0,0),
(166520,1344507586,166520,0,0),
(166520,2442913102,166520,0,0),
(166520,3834752085,166520,0,0),
(166520,1109793673,40020,0,0),
(166520,1073915313,79020,0,0),
(166521,1344507586,166521,0,0),
(166521,2442913102,166521,0,0),
(166521,3834752085,166521,0,0),
(166521,1109793673,40021,0,0),
(166521,1073915313,79021,0,0),
(166522,1344507586,166522,0,0),
(166522,2442913102,166522,0,0),
(166522,3834752085,166522,0,0),
(166522,1109793673,40022,0,0),
(166522,1073915313,79022,0,0),
(166523,1344507586,166523,0,0),
(166523,2442913102,166523,0,0),
(166523,3834752085,166523,0,0),
(166523,1109793673,40023,0,0),
(166523,1073915313,79023,0,0),
(166524,1344507586,166524,0,0),
(166524,2442913102,166524,0,0),
(166524,3834752085,166524,0,0),
(166524,1109793673,40024,0,0),
(166524,1073915313,79024,0,0),
(166525,1344507586,166525,0,0),
(166525,2442913102,166525,0,0),
(166525,3834752085,166525,0,0),
(166525,1109793673,40025,0,0),
(166525,1073915313,79025,0,0),
(166526,1344507586,166526,0,0),
(166526,2442913102,166526,0,0),
(166526,3834752085,166526,0,0),
(166526,1109793673,40026,0,0),
(166526,1073915313,79026,0,0),
(166527,1344507586,166527,0,0),
(166527,2442913102,166527,0,0),
(166527,3834752085,166527,0,0),
(166527,1109793673,40027,0,0),
(166527,1073915313,79027,0,0),
(166528,1344507586,166528,0,0),
(166528,2442913102,166528,0,0),
(166528,3834752085,166528,0,0),
(166528,1109793673,40028,0,0),
(166528,1073915313,79028,0,0),
(166529,1344507586,166529,0,0),
(166529,2442913102,166529,0,0),
(166529,3834752085,166529,0,0),
(166529,1109793673,40029,0,0),
(166529,1073915313,79029,0,0),
(166530,1344507586,166530,0,0),
(166530,2442913102,166530,0,0),
(166530,3834752085,166530,0,0),
(166530,1109793673,40030,0,0),
(166530,1073915313,79030,0,0),
(166531,1344507586,166531,0,0),
(166531,2442913102,166531,0,0),
(166531,3834752085,166531,0,0),
(166531,1109793673,40031,0,0),
(305160,3776013982,305160,0,0),
(305160,3322146344,450160,0,0),
(305160,4030871717,410160,0,0),
(305161,3776013982,305161,0,0),
(305161,3322146344,450161,0,0),
(305161,4030871717,410161,0,0),
(305162,666345498,210162,0,0),
(305162,3776013982,305162,0,0),
(305162,3322146344,450162,0,0),
(305162,4030871717,410162,0,0),
(305163,666345498,210163,0,0),
(305163,3776013982,305163,0,0),
(305163,3322146344,450163,0,0),
(305163,4030871717,410163,0,0),
(305164,3776013982,305164,0,0),
(305164,3322146344,450164,0,0),
(305164,4030871717,410164,0,0),
(305165,666345498,210165,0,0),
(305165,3776013982,305165,0,0),
(305165,3322146344,450165,0,0),
(305165,4030871717,410165,0,0),
(305166,3776013982,305166,0,0),
(305166,3322146344,450166,0,0),
(305166,4030871717,410166,0,0),
(305167,666345498,210167,0,0),
(305167,3776013982,305167,0,0),
(305167,3322146344,450167,0,0),
(305167,4030871717,410167,0,0),
(305168,3776013982,305168,0,0),
(305168,3322146344,450168,0,0),
(305168,4030871717,410168,0,0),
(305169,666345498,210169,0,0),
(305169,3776013982,305169,0,0),
(305169,3322146344,450169,0,0),
(305169,4030871717,410169,0,0),
(305170,3776013982,305170,0,0),
(305170,3322146344,450170,0,0),
(305170,4030871717,410170,0,0),
(305171,666345498,210171,0,0),
(305171,3776013982,305171,0,0),
(305171,3322146344,450171,0,0),
(305171,4030871717,410171,0,0),
(305172,666345498,210172,0,0),
(305172,3776013982,305172,0,0),
(305172,3322146344,450172,0,0),
(305172,4030871717,410172,0,0),
(305173,666345498,210173,0,0),
(305173,3776013982,305173,0,0),
(305173,3322146344,450173,0,0),
(305173,4030871717,410173,0,0),
(305174,666345498,210174,0,0),
(305174,3776013982,305174,0,0),
(305174,3322146344,450174,0,0),
(305174,4030871717,410174,0,0),
(305175,666345498,210175,0,0),
(305175,3776013982,305175,0,0),
(305175,3322146344,450175,0,0),
(305175,4030871717,410175,0,0),
(305176,666345498,210176,0,0),
(305176,3776013982,305176,0,0),
(305176,3322146344,450176,0,0),
(305176,4030871717,410176,0,0),
(305177,666345498,210177,0,0),
(305177,3776013982,305177,0,0),
(305177,3322146344,450177,0,0),
(305177,4030871717,410177,0,0),
(305177,3764692828,70177,0,0),
(305178,666345498,210178,0,0),
(305178,3776013982,305178,0,0),
(305178,3322146344,450178,0,0),
(305178,4030871717,410178,0,0),
(305179,666345498,210179,0,0),
(305179,3776013982,305179,0,0),
(305179,3322146344,450179,0,0),
(305179,4030871717,410179,0,0),
(305180,3776013982,305180,0,0),
(305180,3322146344,450180,0,0),
(305180,4030871717,410180,0,0),
(305181,3776013982,305181,0,0),
(305181,3322146344,450181,0,0),
(305181,4030871717,410181,0,0),
(305182,3776013982,305182,0,0),
(305182,3322146344,450182,0,0),
(305182,4030871717,410182,0,0),
(305182,4030871717,410183,0,0),
(305184,666345498,210184,0,0),
(305184,3776013982,305184,0,0),
(305184,3322146344,450184,0,0),
(305184,4030871717,410184,0,0),
(305184,1720692227,75020,0,0),
(305184,3689412649,75020,0,0),
(305185,666345498,210185,0,0),
(305185,3776013982,305185,0,0),
(305185,3322146344,450185,0,0),
(305185,4030871717,410185,0,0),
(305185,1720692227,75021,0,0),
(305185,3689412649,75021,0,0),
(305186,666345498,210186,0,0),
(305186,3776013982,305186,0,0),
(305186,3322146344,450186,0,0),
(305186,4030871717,410186,0,0),
(305186,1720692227,75022,0,0),
(305186,3689412649,75022,0,0),
(305187,666345498,210187,0,0),
(305187,3776013982,305187,0,0),
(305187,3322146344,450187,0,0),
(305187,4030871717,410187,0,0),
(305187,1720692227,75023,0,0),
(305187,3689412649,75023,0,0),
(305188,666345498,210188,0,0),
(305188,3776013982,305188,0,0),
(305188,3322146344,450188,0,0),
(305188,4030871717,410188,0,0),
(305188,1720692227,75028,0,0),
(305188,3689412649,75028,0,0),
(305189,666345498,210189,0,0),
(305189,3776013982,305189,0,0),
(305189,3322146344,450189,0,0),
(305189,4030871717,410189,0,0),
(305189,1720692227,75029,0,0),
(305189,3689412649,75029,0,0),
(305190,666345498,210190,0,0),
(305190,3776013982,305190,0,0),
(305190,3322146344,450190,0,0),
(305190,4030871717,410190,0,0),
(305190,1720692227,75030,0,0),
(305190,3689412649,75030,0,0),
(305191,666345498,210191,0,0),
(305191,3776013982,305191,0,0),
(305191,3322146344,450191,0,0),
(305191,4030871717,410191,0,0),
(305191,1720692227,75031,0,0),
(305191,3689412649,75031,0,0),
(305192,666345498,210192,0,0),
(305192,3776013982,305192,0,0),
(305192,3322146344,450192,0,0),
(305192,4030871717,410192,0,0),
(305192,1720692227,75032,0,0),
(305192,3689412649,75032,0,0),
(305193,666345498,210193,0,0),
(305193,3776013982,305193,0,0),
(305193,3322146344,450193,0,0),
(305193,4030871717,410193,0,0),
(305193,1720692227,75033,0,0),
(305193,3689412649,75033,0,0),
(305194,666345498,210194,0,0),
(305194,3776013982,305194,0,0),
(305194,3322146344,450194,0,0),
(305194,4030871717,410194,0,0),
(305194,1720692227,75034,0,0),
(305194,3689412649,75034,0,0),
(305195,666345498,210195,0,0),
(305195,3776013982,305195,0,0),
(305195,3322146344,450195,0,0),
(305195,4030871717,410195,0,0),
(305195,1720692227,75035,0,0),
(305195,3689412649,75035,0,0),
(305196,3776013982,305196,0,0),
(305196,3322146344,450196,0,0),
(305196,4030871717,410196,0,0),
(305197,3776013982,305197,0,0),
(305197,3322146344,450197,0,0),
(305197,4030871717,410197,0,0),
(305198,3776013982,305198,0,0),
(305198,3322146344,450198,0,0),
(305198,4030871717,410198,0,0),
(305199,3776013982,305199,0,0),
(305199,3322146344,450199,0,0),
(305199,4030871717,410199,0,0),
(305200,3776013982,305200,0,0),
(305200,3322146344,450200,0,0),
(305200,4030871717,410200,0,0),
(305201,3776013982,305201,0,0),
(305201,3322146344,450201,0,0),
(305201,4030871717,410201,0,0),
(305202,3776013982,305202,0,0),
(305202,3322146344,450202,0,0),
(305202,4030871717,410202,0,0),
(305203,3776013982,305203,0,0),
(305203,3322146344,450203,0,0),
(305203,4030871717,410203,0,0),
(305204,3776013982,305204,0,0),
(305204,3322146344,450204,0,0),
(305204,4030871717,410204,0,0),
(305205,3776013982,305205,0,0),
(305205,3322146344,450205,0,0),
(305205,4030871717,410205,0,0),
(305206,3776013982,305206,0,0),
(305206,3322146344,450206,0,0),
(305206,4030871717,410206,0,0),
(305207,3776013982,305207,0,0),
(305207,3322146344,450207,0,0),
(305207,4030871717,410207,0,0),
(305208,666345498,210208,0,0),
(305208,3776013982,305208,0,0),
(305208,3322146344,450208,0,0),
(305208,4030871717,410208,0,0),
(305209,666345498,210209,0,0),
(305209,3776013982,305209,0,0),
(305209,3322146344,450209,0,0),
(305209,4030871717,410209,0,0),
(305210,666345498,210210,0,0),
(305210,3776013982,305210,0,0),
(305210,3322146344,450210,0,0),
(305210,4030871717,410210,0,0),
(305211,666345498,210211,0,0),
(305211,3776013982,305211,0,0),
(305211,3322146344,450211,0,0),
(305211,4030871717,410211,0,0),
(305212,666345498,210212,0,0),
(305212,3776013982,305212,0,0),
(305212,3322146344,450212,0,0),
(305212,4030871717,410212,0,0),
(305213,666345498,210213,0,0),
(305213,3776013982,305213,0,0),
(305213,3322146344,450213,0,0),
(305213,4030871717,410213,0,0),
(305214,666345498,210214,0,0),
(305214,3776013982,305214,0,0),
(305214,3322146344,450214,0,0),
(305214,4030871717,410214,0,0),
(305215,666345498,210215,0,0),
(305215,3776013982,305215,0,0),
(305215,3322146344,450215,0,0),
(305215,4030871717,410215,0,0),
(305216,666345498,210216,0,0),
(305216,3776013982,305216,0,0),
(305216,3322146344,450216,0,0),
(305216,4030871717,410216,0,0),
(305216,4193483863,50000,0,0),
(305217,666345498,210217,0,0),
(305217,3776013982,305217,0,0),
(305217,3322146344,450217,0,0),
(305217,4030871717,410217,0,0),
(305217,4193483863,50001,0,0),
(305218,666345498,210218,0,0),
(305218,3776013982,305218,0,0),
(305218,3322146344,450218,0,0),
(305218,4030871717,410218,0,0),
(305218,4193483863,50002,0,0),
(305219,666345498,210219,0,0),
(305219,3776013982,305219,0,0),
(305219,3322146344,450219,0,0),
(305219,4030871717,410219,0,0),
(305219,4193483863,50003,0,0),
(305220,666345498,210220,0,0),
(305220,3776013982,305220,0,0),
(305220,3322146344,450220,0,0),
(305220,4030871717,410220,0,0),
(305220,4193483863,50004,0,0),
(305221,3776013982,305221,0,0),
(305221,3322146344,450221,0,0),
(305221,4030871717,410221,0,0),
(305222,666345498,210222,0,0),
(305222,3776013982,305222,0,0),
(305222,3322146344,450222,0,0),
(305222,4030871717,410222,0,0),
(305223,3776013982,305223,0,0),
(305223,3322146344,450223,0,0),
(305223,4030871717,410223,0,0),
(305224,3776013982,305224,0,0),
(305224,3322146344,450224,0,0),
(305224,4030871717,410224,0,0),
(305224,4193483863,50006,0,0),
(305225,3776013982,305225,0,0),
(305225,3322146344,450225,0,0),
(305225,4030871717,410225,0,0),
(305225,4096770149,28025,0,0),
(305226,3776013982,305226,0,0),
(305226,3322146344,450226,0,0),
(305226,4030871717,410226,0,0),
(305227,3776013982,305227,0,0),
(305227,3322146344,450227,0,0),
(305227,4030871717,410227,0,0),
(305228,3776013982,305228,0,0),
(305228,3322146344,450228,0,0),
(305228,4030871717,410228,0,0),
(305229,666345498,210229,0,0),
(305229,3776013982,305229,0,0),
(305229,3322146344,450229,0,0),
(305229,4030871717,410229,0,0),
(305230,3776013982,305230,0,0),
(305230,3322146344,450230,0,0),
(305230,4030871717,410230,0,0),
(305231,666345498,210231,0,0),
(305231,3776013982,305231,0,0),
(305231,3322146344,450231,0,0),
(305231,4030871717,410231,0,0),
(305232,3776013982,305232,0,0),
(305232,3322146344,450232,0,0),
(305232,4030871717,410232,0,0),
(305233,666345498,210233,0,0),
(305233,3776013982,305233,0,0),
(305233,3322146344,450233,0,0),
(305233,4030871717,410233,0,0),
(305234,666345498,210234,0,0),
(305234,3776013982,305234,0,0),
(305234,3322146344,450234,0,0),
(305234,4030871717,410234,0,0),
(305235,666345498,210235,0,0),
(305235,3776013982,305235,0,0),
(305235,3322146344,450235,0,0),
(305235,4030871717,410235,0,0),
(305236,666345498,210236,0,0),
(305236,3776013982,305236,0,0),
(305236,3322146344,450236,0,0),
(305236,4030871717,410236,0,0),
(305237,3776013982,305237,0,0),
(305237,3322146344,450237,0,0),
(305237,4030871717,410237,0,0),
(305238,3776013982,305238,0,0),
(305238,3322146344,450238,0,0),
(305238,4030871717,410238,0,0),
(1178,3179597154,1178,0,0),
(25032,3146089301,25032,0,0),
(25033,3146089301,25033,0,0),
(42775,2442913102,42775,0,0),
(4570,3689412649,4570,0,0),
(4551,3689412649,4551,0,0),
(4571,3689412649,4571,0,0),
(4572,3689412649,4572,0,0),
(4570,234224168,4570,0,0),
(2803,4021368146,2803,0,0),
(160077,1109793673,65456,0,0),
(160077,3834752085,160077,0,0),
(160077,2442913102,160077,0,0),
(160077,1344507586,160077,0,0),
(160078,3834752085,160078,0,0),
(160078,2442913102,160078,0,0),
(160078,1344507586,160078,0,0),
(160079,1109793673,65455,0,0),
(160079,3834752085,160079,0,0),
(160079,2442913102,160079,0,0),
(160079,1344507586,160079,0,0),
(160080,1109793673,65454,0,0),
(160080,3834752085,160080,0,0),
(160080,2442913102,160080,0,0),
(160080,1344507586,160080,0,0),
(160081,1109793673,65453,0,0),
(160081,3834752085,160081,0,0),
(160081,2442913102,160081,0,0),
(160081,1344507586,160081,0,0),
(2804,4021368146,2804,0,0),
(39759,4012104832,39759,0,0),
(39760,4012104832,39760,0,0),
(65609,1255424668,65609,0,0),
(65608,1255424668,65608,0,0),
(65607,1255424668,65607,0,0),
(65605,1255424668,65605,0,0),
(65606,1255424668,65606,0,0),
(1678,3179597154,1678,0,0),
(12004,1918102339,12004,0,0),
(12005,1918102339,12005,0,0),
(4018,2456155917,4018,0,0),
(525,2246024846,525,0,0),
(12461,3538824359,12461,0,0),
(1162,793851790,1162,0,0),
(25100,3146089301,25100,0,0),
(25101,3146089301,25101,0,0),
(25102,3146089301,25102,0,0),
(25103,3146089301,25103,0,0),
(25104,3146089301,25104,0,0),
(25105,3146089301,25105,0,0),
(25106,3146089301,25106,0,0),
(25107,3146089301,25107,0,0),
(25108,3146089301,25108,0,0),
(25109,3146089301,25109,0,0),
(25110,3146089301,25110,0,0),
(25111,3146089301,25111,0,0),
(25112,3146089301,25112,0,0),
(25113,3146089301,25113,0,0),
(25114,3146089301,25114,0,0),
(25115,3146089301,25115,0,0),
(25116,3146089301,25116,0,0),
(25117,3146089301,25117,0,0),
(25118,3146089301,25118,0,0),
(25119,3146089301,25119,0,0),
(25120,3146089301,25120,0,0),
(25121,3146089301,25121,0,0),
(83289,3218799089,83289,0,0),
(83291,3218799089,83291,0,0),
(5022,2524150337,5022,0,0),
(5022,2030087241,3022,0,0),
(5022,4134404214,5022,0,0),
(5023,2524150337,5023,0,0),
(5023,2030087241,3023,0,0),
(5023,4134404214,5023,0,0),
(166532,1344507586,166532,0,0),
(166532,2442913102,166532,0,0),
(166532,3834752085,166532,0,0),
(166532,1109793673,40032,0,0),
(166532,1073915313,79032,0,0),
(166533,1344507586,166533,0,0),
(166533,2442913102,166533,0,0),
(166533,3834752085,166533,0,0),
(166533,1109793673,40033,0,0),
(166533,1073915313,79033,0,0),
(166534,1344507586,166534,0,0),
(166534,2442913102,166534,0,0),
(166534,3834752085,166534,0,0),
(166534,1109793673,40034,0,0),
(166534,1073915313,79034,0,0),
(166535,1344507586,166535,0,0),
(166535,2442913102,166535,0,0),
(166535,3834752085,166535,0,0),
(166535,1109793673,40035,0,0),
(166535,1073915313,79035,0,0),
(166536,1344507586,166536,0,0),
(166536,2442913102,166536,0,0),
(166536,3834752085,166536,0,0),
(166536,1109793673,40036,0,0),
(166536,1073915313,79036,0,0),
(305162,3764692828,70123,0,0),
(305239,3776013982,305239,0,0),
(305239,3322146344,450239,0,0),
(305239,4030871717,410239,0,0),
(305240,3776013982,305240,0,0),
(305240,3322146344,450240,0,0),
(305240,4030871717,410240,0,0),
(305240,4096770149,28240,0,0),
(305241,666345498,210241,0,0),
(305241,3776013982,305241,0,0),
(305241,3322146344,450241,0,0),
(305241,4030871717,410241,0,0),
(305241,4030871717,410242,0,0),
(305243,666345498,210243,0,0),
(305243,3776013982,305243,0,0),
(305243,3322146344,450243,0,0),
(305243,4030871717,410243,0,0),
(305243,4030871717,410244,0,0),
(305243,3764692828,70244,0,0),
(305245,666345498,210245,0,0),
(305245,3776013982,305245,0,0),
(305245,3322146344,450245,0,0),
(305245,4030871717,410245,0,0),
(305246,666345498,210246,0,0),
(305246,3776013982,305246,0,0),
(305246,3322146344,450246,0,0),
(305246,4030871717,410246,0,0),
(305247,666345498,210247,0,0),
(305247,3776013982,305247,0,0),
(305247,3322146344,450247,0,0),
(305247,4030871717,410247,0,0),
(305248,3776013982,305248,0,0),
(305248,3322146344,450248,0,0),
(305248,4030871717,410248,0,0),
(305249,666345498,210249,0,0),
(305249,3776013982,305249,0,0),
(305249,3322146344,450249,0,0),
(305249,4030871717,410249,0,0),
(305249,3689412649,70249,0,0),
(305250,666345498,210250,0,0),
(305250,3776013982,305250,0,0),
(305250,3322146344,450250,0,0),
(305250,4030871717,410250,0,0),
(305251,3776013982,305251,0,0),
(305251,3322146344,450251,0,0),
(305251,4030871717,410251,0,0),
(305252,3776013982,305252,0,0),
(305252,3322146344,450252,0,0),
(305252,4030871717,410252,0,0),
(305252,3764692828,70252,0,0),
(305253,3776013982,305253,0,0),
(305253,3322146344,450253,0,0),
(305253,4030871717,410253,0,0),
(305254,3776013982,305254,0,0),
(305254,3322146344,450254,0,0),
(305254,4030871717,410254,0,0),
(305255,666345498,210255,0,0),
(305255,3776013982,305255,0,0),
(305255,3322146344,450255,0,0),
(305255,4030871717,410255,0,0),
(305256,666345498,210256,0,0),
(305256,3776013982,305256,0,0),
(305256,3322146344,450256,0,0),
(305256,4030871717,410256,0,0),
(305257,666345498,210257,0,0),
(305257,3776013982,305257,0,0),
(305257,3322146344,450257,0,0),
(305257,4030871717,410257,0,0),
(305257,3764692828,70257,0,0),
(305258,666345498,210258,0,0),
(305258,3776013982,305258,0,0),
(305258,3322146344,450258,0,0),
(305258,4030871717,410258,0,0),
(305259,666345498,210259,0,0),
(305259,3776013982,305259,0,0),
(305259,3322146344,450259,0,0),
(305259,4030871717,410259,0,0),
(305260,666345498,210260,0,0),
(305260,3776013982,305260,0,0),
(305260,3322146344,450260,0,0),
(305260,4030871717,410260,0,0),
(305261,666345498,210261,0,0),
(305261,3776013982,305261,0,0),
(305261,3322146344,450261,0,0),
(305261,4030871717,410261,0,0),
(305262,3776013982,305262,0,0),
(305262,3322146344,450262,0,0),
(305262,4030871717,410262,0,0),
(305262,1720692227,75262,0,0),
(305263,3776013982,305263,0,0),
(305263,3322146344,450263,0,0),
(305263,4030871717,410263,0,0),
(305264,3776013982,305264,0,0),
(305264,3322146344,450264,0,0),
(305264,4030871717,410264,0,0),
(305264,1720692227,75264,0,0),
(305265,3776013982,305265,0,0),
(305265,3322146344,450265,0,0),
(305265,4030871717,410265,0,0),
(305266,3776013982,305266,0,0),
(305266,3322146344,450266,0,0),
(305266,4030871717,410266,0,0),
(305267,666345498,210267,0,0),
(305267,3776013982,305267,0,0),
(305267,3322146344,450267,0,0),
(305267,4030871717,410267,0,0),
(305268,666345498,210268,0,0),
(305268,3776013982,305268,0,0),
(305268,3322146344,450268,0,0),
(305268,4030871717,410268,0,0),
(305269,666345498,210269,0,0),
(305269,3776013982,305269,0,0),
(305269,3322146344,450269,0,0),
(305269,4030871717,410269,0,0),
(305270,666345498,210270,0,0),
(305270,3776013982,305270,0,0),
(305270,3322146344,450270,0,0),
(305270,4030871717,410270,0,0),
(305271,3776013982,305271,0,0),
(305271,3322146344,450271,0,0),
(305271,4030871717,410271,0,0),
(305272,666345498,210272,0,0),
(305272,3776013982,305272,0,0),
(305272,3322146344,450272,0,0),
(305272,4030871717,410272,0,0),
(305273,666345498,210273,0,0),
(305273,3776013982,305273,0,0),
(305273,3322146344,450273,0,0),
(305273,4030871717,410273,0,0),
(305274,666345498,210274,0,0),
(305274,3776013982,305274,0,0),
(305274,3322146344,450274,0,0),
(305274,4030871717,410274,0,0),
(305275,3776013982,305275,0,0),
(305275,3322146344,450275,0,0),
(305275,4030871717,410275,0,0),
(305276,666345498,210276,0,0),
(305276,3776013982,305276,0,0),
(305276,3322146344,450276,0,0),
(305276,4030871717,410276,0,0),
(305277,666345498,210277,0,0),
(305277,3776013982,305277,0,0),
(305277,3322146344,450277,0,0),
(305277,4030871717,410277,0,0),
(305278,666345498,210278,0,0),
(305278,3776013982,305278,0,0),
(305278,3322146344,450278,0,0),
(305278,4030871717,410278,0,0),
(305278,3764692828,70278,0,0),
(305279,3776013982,305279,0,0),
(305279,3322146344,450279,0,0),
(305279,4030871717,410279,0,0),
(305280,3776013982,305280,0,0),
(305280,3322146344,450280,0,0),
(305280,4030871717,410280,0,0),
(305280,3764692828,70280,0,0),
(305281,3776013982,305281,0,0),
(305281,3322146344,450281,0,0),
(305281,4030871717,410281,0,0),
(305281,3764692828,70281,0,0),
(305281,666345498,210281,0,0),
(305282,666345498,210282,0,0),
(305282,3776013982,305282,0,0),
(305282,3322146344,450282,0,0),
(305282,4030871717,410282,0,0),
(305283,3776013982,305283,0,0),
(305283,3322146344,450283,0,0),
(305283,4030871717,410283,0,0),
(305284,3776013982,305284,0,0),
(305284,3322146344,450284,0,0),
(305284,4030871717,410284,0,0),
(305285,3776013982,305285,0,0),
(305285,3322146344,450285,0,0),
(305285,4030871717,410285,0,0),
(305286,666345498,210286,0,0),
(305286,3776013982,305286,0,0),
(305286,3322146344,450286,0,0),
(305286,4030871717,410286,0,0),
(305286,1720692227,75286,0,0),
(305286,3689412649,75286,0,0),
(305287,3776013982,305287,0,0),
(305287,3322146344,450287,0,0),
(305287,4030871717,410287,0,0),
(305288,666345498,210288,0,0),
(305288,3776013982,305288,0,0),
(305288,3322146344,450288,0,0),
(305288,4030871717,410288,0,0),
(305288,1720692227,75288,0,0),
(305288,3689412649,75288,0,0),
(305289,3776013982,305289,0,0),
(305289,3322146344,450289,0,0),
(305289,4030871717,410289,0,0),
(305290,666345498,210290,0,0),
(305290,3776013982,305290,0,0),
(305290,3322146344,450290,0,0),
(305290,4030871717,410290,0,0),
(305291,666345498,210291,0,0),
(305291,3776013982,305291,0,0),
(305291,3322146344,450291,0,0),
(305291,4030871717,410291,0,0),
(3117,1627543382,3117,0,0),
(160082,1109793673,65452,0,0),
(160082,3834752085,160082,0,0),
(160082,2442913102,160082,0,0),
(160082,1344507586,160082,0,0),
(160083,1109793673,65451,0,0),
(160083,3834752085,160083,0,0),
(160083,2442913102,160083,0,0),
(160083,1344507586,160083,0,0),
(35002,1073915313,35002,0,0),
(35004,1073915313,35004,0,0),
(35006,1073915313,35006,0,0),
(35008,1073915313,35008,0,0),
(35010,1073915313,35010,0,0),
(35012,1073915313,35012,0,0),
(35014,1073915313,35014,0,0),
(35016,1073915313,35016,0,0),
(35018,1073915313,35018,0,0),
(35020,1073915313,35020,0,0),
(35022,1073915313,35022,0,0),
(35024,1073915313,35024,0,0),
(35026,1073915313,35026,0,0),
(35028,1073915313,35028,0,0),
(35030,1073915313,35030,0,0),
(35032,1073915313,35032,0,0),
(35034,1073915313,35034,0,0),
(35036,1073915313,35036,0,0),
(20542,4030871717,279996,0,0),
(20541,4030871717,279997,0,0),
(20540,4030871717,279992,0,0),
(305292,4096770149,28292,0,0),
(305292,666345498,210291,0,0),
(305292,3776013982,305292,0,0),
(305292,3322146344,450292,0,0),
(305292,4030871717,410292,0,0),
(305293,666345498,210293,0,0),
(305293,3776013982,305293,0,0),
(305293,3322146344,450293,0,0),
(305293,4030871717,410293,0,0),
(160084,1109793673,65450,0,0),
(160084,3834752085,160084,0,0),
(160084,2442913102,160084,0,0),
(160084,1344507586,160084,0,0),
(305294,3776013982,305294,0,0),
(305294,3322146344,450294,0,0),
(305294,4030871717,410294,0,0),
(305294,3764692828,70281,0,0),
(1180,3179597154,1180,0,0),
(4019,2456155917,4019,0,0),
(305295,666345498,210295,0,0),
(305295,3776013982,305295,0,0),
(305295,3322146344,450295,0,0),
(305295,4030871717,410295,0,0),
(305296,3776013982,305296,0,0),
(305296,3322146344,450296,0,0),
(305296,4030871717,410296,0,0),
(166537,1344507586,166537,0,0),
(166537,2442913102,166537,0,0),
(166537,3834752085,166537,0,0),
(166537,1109793673,40037,0,0),
(166538,1344507586,166538,0,0),
(166538,2442913102,166538,0,0),
(166538,3834752085,166538,0,0),
(166538,1109793673,40038,0,0),
(22677,4012104832,22677,0,0),
(22791,4012104832,22791,0,0),
(22792,4012104832,22792,0,0),
(22793,4012104832,22793,0,0),
(22794,4012104832,22794,0,0),
(22795,4012104832,22795,0,0),
(83292,3218799089,83292,0,0),
(305297,666345498,210297,0,0),
(305297,3776013982,305297,0,0),
(305297,3322146344,450297,0,0),
(305297,4030871717,410297,0,0),
(305297,1720692227,75297,0,0),
(305297,3689412649,75297,0,0),
(305298,3776013982,305298,0,0),
(305298,3322146344,450298,0,0),
(305298,4030871717,410298,0,0),
(97065,4030871717,97065,0,0),
(22800,4012104832,22800,0,0),
(210636,3776013982,210636,0,0),
(210636,4030871717,210636,0,0),
(119655,666345498,119655,0,0),
(166009,1344507586,166009,0,0),
(166010,2442913102,166009,0,0),
(166009,3834752085,166009,0,0),
(166009,1109793673,56009,0,0),
(43517,1255424668,43516,0,1),
(30000,157446066,30000,0,0),
(30001,157446066,30001,0,0),
(30002,157446066,30002,0,0),
(30003,157446066,30003,0,0),
(30004,157446066,30004,0,0),
(30005,157446066,30005,0,0),
(30006,157446066,30006,0,0),
(143931,2442913102,143931,0,0),
(524,2246024846,524,0,0),
(365,2075795121,365,0,0),
(65610,1255424668,65610,0,0),
(65611,1255424668,65611,0,0),
(166539,1344507586,166539,0,0),
(166539,2442913102,166539,0,0),
(166539,3834752085,166539,0,0),
(166539,1109793673,40039,0,0),
(166539,1073915313,79039,0,0),
(166540,1344507586,166540,0,0),
(166540,2442913102,166540,0,0),
(166540,3834752085,166540,0,0),
(166540,1109793673,40040,0,0),
(166540,1073915313,79040,0,0),
(305299,3776013982,305299,0,0),
(305299,3322146344,450299,0,0),
(305299,4030871717,410299,0,0),
(305300,666345498,210300,0,0),
(305300,3776013982,305300,0,0),
(305300,3322146344,450300,0,0),
(305300,4030871717,410300,0,0),
(305301,3776013982,305301,0,0),
(305301,3322146344,450301,0,0),
(305301,4030871717,410301,0,0),
(12462,3538824359,12462,0,0),
(5025,2524150337,5025,0,0),
(5025,2030087241,3025,0,0),
(5025,4134404214,5025,0,0),
(166542,1344507586,166542,0,0),
(166542,2442913102,166542,0,0),
(166542,1073915313,79042,0,0),
(166542,3834752085,166542,0,0),
(166542,1109793673,40042,0,0),
(166543,1344507586,166543,0,0),
(166543,2442913102,166543,0,0),
(166543,3834752085,166543,0,0),
(166543,1109793673,40043,0,0),
(166543,1073915313,79043,0,0),
(166010,1344507586,166010,0,0),
(166011,2442913102,166010,0,0),
(166010,3834752085,166010,0,0),
(166010,1109793673,56010,0,0),
(166011,1344507586,166011,0,0),
(166012,2442913102,166011,0,0),
(166011,3834752085,166011,0,0),
(166011,1109793673,56011,0,0),
(166012,1344507586,166012,0,0),
(166013,2442913102,166012,0,0),
(166012,3834752085,166012,0,0),
(166012,1109793673,56012,0,0),
(305297,4030871717,410303,0,0),
(305301,1720692227,75301,0,0),
(305302,666345498,210302,0,0),
(305302,3776013982,305302,0,0),
(305302,3322146344,450235,0,0),
(305302,4030871717,410302,0,0),
(305305,3776013982,305305,0,0),
(305305,3322146344,450305,0,0),
(305305,4030871717,410305,0,0),
(5004,2524150337,5001,0,0),
(523,2246024846,523,0,0),
(25251,3146089301,25251,0,0),
(179602,3834752085,179602,0,0),
(179602,1344507586,179602,0,0),
(179602,1109793673,29602,0,0),
(179602,1073915313,79602,0,0),
(179602,2442913102,179602,0,0);

/*Table structure for table `hotfix_locale` */

DROP TABLE IF EXISTS `hotfix_locale`;

CREATE TABLE `hotfix_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Tablename_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `hotfix_locale` */

/*Table structure for table `import_price_armor` */

DROP TABLE IF EXISTS `import_price_armor`;

CREATE TABLE `import_price_armor` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ClothModifier` float NOT NULL DEFAULT '0',
  `LeatherModifier` float NOT NULL DEFAULT '0',
  `ChainModifier` float NOT NULL DEFAULT '0',
  `PlateModifier` float NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `import_price_armor` */

/*Table structure for table `import_price_quality` */

DROP TABLE IF EXISTS `import_price_quality`;

CREATE TABLE `import_price_quality` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Data` float NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `import_price_quality` */

/*Table structure for table `import_price_shield` */

DROP TABLE IF EXISTS `import_price_shield`;

CREATE TABLE `import_price_shield` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Data` float NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `import_price_shield` */

/*Table structure for table `import_price_weapon` */

DROP TABLE IF EXISTS `import_price_weapon`;

CREATE TABLE `import_price_weapon` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Data` float NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `import_price_weapon` */

/*Table structure for table `invasion_client_data` */

DROP TABLE IF EXISTS `invasion_client_data`;

CREATE TABLE `invasion_client_data` (
  `Name` text,
  `IconLocation1` float NOT NULL DEFAULT '0',
  `IconLocation2` float NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `WorldStateID` int(11) NOT NULL DEFAULT '0',
  `UiTextureAtlasMemberID` int(11) NOT NULL DEFAULT '0',
  `ScenarioID` int(11) NOT NULL DEFAULT '0',
  `WorldQuestID` int(11) NOT NULL DEFAULT '0',
  `WorldStateValue` int(11) NOT NULL DEFAULT '0',
  `InvasionEnabledWorldStateID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `invasion_client_data` */

/*Table structure for table `invasion_client_data_locale` */

DROP TABLE IF EXISTS `invasion_client_data_locale`;

CREATE TABLE `invasion_client_data_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `invasion_client_data_locale` */

/*Table structure for table `item` */

DROP TABLE IF EXISTS `item`;

CREATE TABLE `item` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `IconFileDataID` int(11) NOT NULL DEFAULT '0',
  `ClassID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SubclassID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SoundOverrideSubclass` tinyint(4) NOT NULL DEFAULT '0',
  `Material` tinyint(4) NOT NULL DEFAULT '0',
  `InventoryType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SheatheType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ItemGroupSoundsID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item` */

insert  into `item`(`ID`,`IconFileDataID`,`ClassID`,`SubclassID`,`SoundOverrideSubclass`,`Material`,`InventoryType`,`SheatheType`,`ItemGroupSoundsID`,`VerifiedBuild`) values 
(144228,134874,0,1,-1,0,0,0,17,23911),
(147211,237281,12,0,-1,0,0,0,24,23911),
(139467,133659,15,4,-1,7,0,0,18,23911),
(143606,133659,15,4,-1,7,0,0,18,23911),
(143607,1518638,15,4,-1,7,0,0,18,23911),
(138885,516338,0,8,-1,4,0,0,14,23911),
(140310,134450,0,8,-1,4,0,0,14,23911),
(138783,646678,0,8,-1,4,0,0,14,23911),
(138117,0,4,3,-1,5,8,0,10,23911),
(141185,1135365,12,0,-1,0,0,0,22,23911),
(141186,1135365,12,0,-1,0,0,0,22,23911),
(140163,132145,12,0,-1,0,0,0,23,23911),
(140164,132378,12,0,-1,0,0,0,17,23911),
(140165,132145,12,0,-1,0,0,0,23,23911),
(127878,413575,12,0,-1,0,0,0,14,23911),
(140167,132145,12,0,-1,0,0,0,23,23911),
(140168,132378,12,0,-1,0,0,0,17,23911),
(140169,132145,12,0,-1,0,0,0,23,23911),
(140170,132378,12,0,-1,0,0,0,17,23911),
(140171,1029739,12,0,-1,0,0,0,23,23911),
(140172,442732,12,0,-1,0,0,0,19,23911),
(140173,134516,12,0,-1,0,0,0,7,23911),
(140174,1029739,12,0,-1,0,0,0,23,23911),
(140175,442732,12,0,-1,0,0,0,19,23911),
(141200,1373904,12,0,-1,0,0,0,20,23911),
(140177,134516,12,0,-1,0,0,0,7,23911),
(140178,1029739,12,0,-1,0,0,0,23,23911),
(141187,1387709,12,0,-1,0,0,0,20,23911),
(140180,134516,12,0,-1,0,0,0,7,23911),
(140181,1029739,12,0,-1,0,0,0,23,23911),
(140182,442732,12,0,-1,0,0,0,19,23911),
(140183,134516,12,0,-1,0,0,0,7,23911),
(129177,237170,12,0,-1,0,0,0,20,23911),
(141204,1392955,12,0,-1,0,0,0,20,23911),
(141199,1373904,12,0,-1,0,0,0,20,23911),
(141189,512902,12,0,-1,0,0,0,20,23911),
(140166,132378,12,0,-1,0,0,0,17,23911),
(147505,135864,12,0,-1,0,0,0,22,23911),
(147497,1526617,12,0,-1,0,0,0,7,23911),
(147498,1526617,12,0,-1,0,0,0,7,23911),
(141191,377271,12,0,-1,0,0,0,20,23911),
(147500,1526617,12,0,-1,0,0,0,7,23911),
(147501,1505957,12,0,-1,0,0,0,19,23911),
(147502,1505957,12,0,-1,0,0,0,19,23911),
(147503,1505957,12,0,-1,0,0,0,19,23911),
(147504,1505957,12,0,-1,0,0,0,19,23911),
(141192,377271,12,0,-1,0,0,0,20,23911),
(147506,135864,12,0,-1,0,0,0,22,23911),
(147507,135864,12,0,-1,0,0,0,22,23911),
(147508,135864,12,0,-1,0,0,0,22,23911),
(147509,135824,12,0,-1,0,0,0,8,23911),
(147510,135824,12,0,-1,0,0,0,8,23911),
(141193,133473,12,0,-1,0,0,0,20,23911),
(140472,442732,12,0,-1,0,0,0,19,23911),
(141188,1387709,12,0,-1,0,0,0,20,23911),
(141194,133473,12,0,-1,0,0,0,20,23911),
(142339,1103069,12,0,-1,0,0,0,20,23911),
(139457,1103069,12,0,-1,0,0,0,20,23911),
(141195,1103069,12,0,-1,0,0,0,20,23911),
(141197,133797,12,0,-1,0,0,0,20,23911),
(141196,1103069,12,0,-1,0,0,0,20,23911),
(147511,135824,12,0,-1,0,0,0,8,23911),
(139471,1392955,12,0,-1,0,0,0,20,23911),
(139472,237249,12,0,-1,0,0,0,20,23911),
(139473,1373904,12,0,-1,0,0,0,20,23911),
(139474,133797,12,0,-1,0,0,0,20,23911),
(139475,133473,12,0,-1,0,0,0,20,23911),
(139476,377271,12,0,-1,0,0,0,20,23911),
(139477,512902,12,0,-1,0,0,0,20,23911),
(139478,1387709,12,0,-1,0,0,0,20,23911),
(139479,1135365,12,0,-1,0,0,0,22,23911),
(139480,516864,12,0,-1,0,0,0,15,23911),
(139481,516864,12,0,-1,0,0,0,15,23911),
(139482,516864,12,0,-1,0,0,0,15,23911),
(139483,516864,12,0,-1,0,0,0,15,23911),
(142340,237275,12,0,-1,0,0,0,15,23911),
(141198,133797,12,0,-1,0,0,0,20,23911),
(141201,237249,12,0,-1,0,0,0,20,23911),
(141202,237249,12,0,-1,0,0,0,20,23911),
(147499,1526617,12,0,-1,0,0,0,7,23911),
(140147,134880,12,0,-1,0,0,0,8,23911),
(140149,134880,12,0,-1,0,0,0,8,23911),
(141190,512902,12,0,-1,0,0,0,20,23911),
(140151,134880,12,0,-1,0,0,0,8,23911),
(140153,134880,12,0,-1,0,0,0,8,23911),
(141203,1392955,12,0,-1,0,0,0,20,23911),
(147512,135824,12,0,-1,0,0,0,8,23911),
(96256,660752,4,3,-1,5,1,0,10,23911),
(96257,660753,4,3,-1,5,7,0,10,23911),
(96258,660754,4,3,-1,5,3,0,10,23911),
(96262,795962,4,1,-1,7,10,0,7,23911),
(96263,795963,4,1,-1,7,1,0,7,23911),
(96264,795965,4,1,-1,7,7,0,7,23911),
(96265,795961,4,1,-1,7,20,0,7,23911),
(96266,795966,4,1,-1,7,3,0,7,23911),
(96267,796428,4,2,-1,8,5,0,7,23911),
(96268,796429,4,2,-1,8,10,0,7,23911),
(96269,796430,4,2,-1,8,1,0,7,23911),
(96270,796431,4,2,-1,8,7,0,7,23911),
(96271,796433,4,2,-1,8,3,0,7,23911),
(96272,796429,4,2,-1,8,10,0,7,23911),
(96273,796430,4,2,-1,8,1,0,7,23911),
(96274,796431,4,2,-1,8,7,0,7,23911),
(96275,796428,4,2,-1,8,5,0,7,23911),
(96276,796433,4,2,-1,8,3,0,7,23911),
(96277,796428,4,2,-1,8,5,0,7,23911),
(96278,796429,4,2,-1,8,10,0,7,23911),
(96279,796430,4,2,-1,8,1,0,7,23911),
(96280,796431,4,2,-1,8,7,0,7,23911),
(96281,796433,4,2,-1,8,3,0,7,23911),
(96282,661379,4,4,-1,6,5,0,11,23911),
(96283,661380,4,4,-1,6,10,0,11,23911),
(96284,661381,4,4,-1,6,1,0,11,23911),
(96285,661382,4,4,-1,6,7,0,11,23911),
(96286,661383,4,4,-1,6,3,0,11,23911),
(96287,661379,4,4,-1,6,5,0,11,23911),
(96288,661380,4,4,-1,1,10,0,11,23911),
(96289,661381,4,4,-1,6,1,0,11,23911),
(96290,661382,4,4,-1,6,7,0,11,23911),
(96291,661383,4,4,-1,6,3,0,11,23911),
(96292,661379,4,4,-1,6,5,0,11,23911),
(96293,661380,4,4,-1,6,10,0,11,23911),
(96294,661381,4,4,-1,6,1,0,11,23911),
(96295,661382,4,4,-1,6,7,0,11,23911),
(96296,661383,4,4,-1,6,3,0,11,23911),
(96297,773258,4,1,-1,7,10,0,7,23911),
(96298,773259,4,1,-1,7,1,0,7,23911),
(96299,773260,4,1,-1,7,7,0,7,23911),
(96300,773261,4,1,-1,7,20,0,7,23911),
(96301,773262,4,1,-1,7,3,0,7,23911),
(96302,773258,4,1,-1,7,10,0,7,23911),
(96303,773259,4,1,-1,7,1,0,7,23911),
(96304,773260,4,1,-1,7,7,0,7,23911),
(96305,773261,4,1,-1,7,20,0,7,23911),
(96306,773262,4,1,-1,7,3,0,7,23911),
(96307,774567,4,2,-1,8,5,0,7,23911),
(96308,774568,4,2,-1,8,10,0,7,23911),
(96309,774569,4,2,-1,8,1,0,7,23911),
(96310,774570,4,2,-1,8,7,0,7,23911),
(96311,774571,4,2,-1,8,3,0,7,23911),
(96312,801136,4,3,-1,5,20,0,10,23911),
(96313,801137,4,3,-1,5,10,0,10,23911),
(96314,801138,4,3,-1,5,1,0,10,23911),
(96315,801140,4,3,-1,5,7,0,10,23911),
(96316,801141,4,3,-1,5,3,0,10,23911),
(96317,801136,4,3,-1,5,5,0,10,23911),
(96318,801137,4,3,-1,5,10,0,10,23911),
(96319,801138,4,3,-1,5,1,0,10,23911),
(96320,801140,4,3,-1,5,7,0,10,23911),
(96321,801141,4,3,-1,5,3,0,10,23911),
(96322,801136,4,3,-1,5,20,0,10,23911),
(96323,801137,4,3,-1,5,10,0,10,23911),
(96324,801138,4,3,-1,5,1,0,10,23911),
(96325,801140,4,3,-1,5,7,0,10,23911),
(96326,801141,4,3,-1,5,3,0,10,23911),
(96331,774565,4,2,-1,8,8,0,7,23911),
(96332,801134,4,3,-1,5,8,0,10,23911),
(96333,795958,4,1,-1,8,6,0,7,23911),
(96334,773255,4,1,-1,7,6,0,7,23911),
(96335,666646,4,1,-1,7,8,0,7,23911),
(96337,773256,4,1,-1,7,8,0,7,23911),
(96338,660456,4,2,-1,8,8,0,7,23911),
(96339,801134,4,3,-1,5,8,0,10,23911),
(96340,661377,4,4,-1,6,8,0,11,23911),
(96342,660455,4,2,-1,8,6,0,7,23911),
(96343,796425,4,2,-1,8,6,0,7,23911),
(96344,660748,4,3,-1,5,6,0,10,23911),
(96345,801133,4,3,-1,5,6,0,10,23911),
(96346,661376,4,4,-1,6,6,0,11,23911),
(96347,793150,4,4,-1,6,6,0,11,23911),
(96348,793151,4,4,-1,6,6,0,11,23911),
(96350,793153,4,4,-1,6,8,0,11,23911),
(96351,793152,4,4,-1,6,8,0,11,23911),
(96353,666649,4,1,-1,7,10,0,7,23911),
(96354,666650,4,1,-1,7,1,0,7,23911),
(96355,666651,4,1,-1,7,7,0,7,23911),
(96356,666652,4,1,-1,7,20,0,7,23911),
(96357,666653,4,1,-1,7,3,0,7,23911),
(96358,793161,4,4,-1,6,1,0,11,23911),
(96359,793157,4,4,-1,6,5,0,11,23911),
(96360,793159,4,4,-1,6,10,0,11,23911),
(96361,793163,4,4,-1,6,7,0,11,23911),
(96362,793165,4,4,-1,6,3,0,11,23911),
(96363,793157,4,4,-1,6,5,0,11,23911),
(96364,793159,4,4,-1,6,10,0,11,23911),
(96365,793161,4,4,-1,6,1,0,11,23911),
(96366,793163,4,4,-1,6,7,0,11,23911),
(96367,793165,4,4,-1,6,3,0,11,23911),
(96742,774569,4,2,-1,8,1,0,7,23911),
(96743,660753,4,3,-1,5,7,0,10,23911),
(96744,660754,4,3,-1,5,3,0,10,23911),
(96745,793151,4,4,-1,6,6,0,11,23911),
(96746,793156,4,4,-1,6,5,0,11,23911),
(96747,793155,4,4,-1,6,9,0,11,23911),
(96748,804512,2,0,-1,1,13,3,8,23911),
(96750,795962,4,1,-1,7,10,0,7,23911),
(96751,666651,4,1,-1,7,7,0,7,23911),
(96752,666653,4,1,-1,7,3,0,7,23911),
(96753,773261,4,1,-1,7,20,0,7,23911),
(96755,628277,4,1,-1,7,16,0,7,23911),
(96756,840734,2,7,-1,1,13,3,9,23911),
(96758,796427,4,2,-1,8,9,0,7,23911),
(96759,801134,4,3,-1,5,8,0,10,23911),
(96760,661379,4,4,-1,6,5,0,11,23911),
(96761,628676,4,1,-1,7,16,0,7,23911),
(96763,768650,2,10,-1,2,17,2,13,23911),
(96764,660457,4,2,-1,8,9,0,7,23911),
(96765,801136,4,3,-1,5,5,0,10,23911),
(96766,793155,4,4,-1,6,9,0,11,23911),
(96767,793162,4,4,-1,6,7,0,11,23911),
(96768,793161,4,4,-1,6,1,0,11,23911),
(96769,630617,4,1,-1,7,16,0,7,23911),
(96771,795963,4,1,-1,7,1,0,7,23911),
(96772,773257,4,1,-1,7,9,0,7,23911),
(96773,796788,2,10,-1,2,17,2,13,23911),
(96776,803764,2,19,-1,2,26,3,21,23911),
(96777,796431,4,2,-1,8,7,0,7,23911),
(96778,660461,4,2,-1,8,3,0,7,23911),
(96779,801140,4,3,-1,5,7,0,10,23911),
(96780,661378,4,4,-1,6,9,0,11,23911),
(96782,799996,2,0,-1,1,13,3,8,23911),
(96783,773256,4,1,-1,7,8,0,7,23911),
(96784,666652,4,1,-1,7,20,0,7,23911),
(96786,792975,2,13,-1,1,13,7,8,23911),
(96787,660460,4,2,-1,8,20,0,7,23911),
(96788,660752,4,3,-1,5,1,0,10,23911),
(96789,801135,4,3,-1,8,9,0,10,23911),
(96790,793157,4,4,-1,6,5,0,11,23911),
(96791,668828,2,8,-1,1,17,1,9,23911),
(96794,775504,2,2,-1,2,15,4,13,23911),
(96795,796428,4,2,-1,8,5,0,7,23911),
(96796,774568,4,2,-1,8,10,0,7,23911),
(96797,660750,4,3,-1,5,9,0,10,23911),
(96798,660749,4,3,-1,5,8,0,10,23911),
(96799,793164,4,4,-1,6,3,0,11,23911),
(96800,793154,4,4,-1,6,9,0,11,23911),
(96802,666408,2,0,-1,1,13,3,8,23911),
(96803,630617,4,1,-1,7,16,0,7,23911),
(96804,795960,4,1,-1,7,9,0,7,23911),
(96805,773259,4,1,-1,7,1,0,7,23911),
(96806,795962,4,1,-1,7,10,0,7,23911),
(96807,629630,4,1,-1,7,16,0,7,23911),
(96808,774421,4,6,-1,6,14,4,13,23911),
(96809,660457,4,2,-1,8,9,0,7,23911),
(96810,796432,4,2,-1,8,20,0,7,23911),
(96811,801141,4,3,-1,5,3,0,10,23911),
(96812,661376,4,4,-1,6,6,0,11,23911),
(96813,661380,4,4,-1,1,10,0,11,23911),
(96814,660663,2,15,-1,1,13,3,8,23911),
(96816,774571,4,2,-1,8,3,0,7,23911),
(96817,801137,4,3,-1,5,10,0,10,23911),
(96818,793150,4,4,-1,6,6,0,11,23911),
(96819,793156,4,4,-1,6,5,0,11,23911),
(96822,795959,4,1,-1,7,8,0,7,23911),
(96823,773262,4,1,-1,7,3,0,7,23911),
(96824,666647,4,1,-1,7,9,0,7,23911),
(96826,795964,4,0,-1,1,23,0,10,23911),
(96829,796430,4,2,-1,8,1,0,7,23911),
(96830,801133,4,3,-1,5,6,0,10,23911),
(96831,801136,4,3,-1,5,5,0,10,23911),
(96832,661377,4,4,-1,6,8,0,11,23911),
(96833,628676,4,1,-1,7,16,0,7,23911),
(96834,666645,4,1,-1,8,6,0,7,23911),
(96835,795961,4,1,-1,7,20,0,7,23911),
(96836,667146,2,10,-1,2,17,2,13,23911),
(96837,774564,4,2,-1,8,6,0,7,23911),
(96838,801137,4,3,-1,5,10,0,10,23911),
(96839,661381,4,4,-1,6,1,0,11,23911),
(96840,793157,4,4,-1,6,5,0,11,23911),
(96841,793159,4,4,-1,6,10,0,11,23911),
(96844,792562,2,18,-1,2,26,5,15,23911),
(96845,774570,4,2,-1,8,7,0,7,23911),
(96846,801133,4,3,-1,5,6,0,10,23911),
(96847,660751,4,3,-1,5,5,0,10,23911),
(96848,793154,4,4,-1,6,9,0,11,23911),
(96849,793163,4,4,-1,6,7,0,11,23911),
(96850,793153,4,4,-1,6,8,0,11,23911),
(96851,793159,4,4,-1,6,10,0,11,23911),
(96852,630617,4,1,-1,7,16,0,7,23911),
(96854,666649,4,1,-1,7,10,0,7,23911),
(96855,666651,4,1,-1,7,7,0,7,23911),
(96856,795966,4,1,-1,7,3,0,7,23911),
(96857,629630,4,1,-1,7,16,0,7,23911),
(96859,800881,2,15,-1,1,13,3,8,23911),
(96860,796426,4,2,-1,8,8,0,7,23911),
(96861,801135,4,3,-1,8,9,0,10,23911),
(96862,661380,4,4,-1,1,10,0,11,23911),
(96863,661382,4,4,-1,6,7,0,11,23911),
(96865,796429,4,2,-1,8,10,0,7,23911),
(96866,660750,4,3,-1,5,9,0,10,23911),
(96867,773175,4,3,-1,5,10,0,10,23911),
(96868,793158,4,4,-1,6,10,0,11,23911),
(96869,793162,4,4,-1,6,7,0,11,23911),
(96870,793164,4,4,-1,6,3,0,11,23911),
(96871,630617,4,1,-1,7,16,0,7,23911),
(96874,667145,2,4,-1,1,13,3,8,23911),
(96875,666652,4,1,-1,7,20,0,7,23911),
(96876,773258,4,1,-1,7,10,0,7,23911),
(96877,773260,4,1,-1,7,7,0,7,23911),
(96878,666647,4,1,-1,7,9,0,7,23911),
(96880,660459,4,2,-1,8,7,0,7,23911),
(96881,801138,4,3,-1,5,1,0,10,23911),
(96882,661378,4,4,-1,6,9,0,11,23911),
(96883,661383,4,4,-1,6,3,0,11,23911),
(96884,794910,4,6,-1,6,14,4,13,23911),
(96886,794752,2,4,-1,1,13,3,8,23911),
(96887,666650,4,1,-1,7,1,0,7,23911),
(96889,628277,4,1,-1,7,16,0,7,23911),
(96890,796140,2,15,-1,1,13,3,8,23911),
(96891,660459,4,2,-1,8,7,0,7,23911),
(96892,660458,4,2,-1,8,10,0,7,23911),
(96893,661382,4,4,-1,6,7,0,11,23911),
(96894,793160,4,4,-1,6,1,0,11,23911),
(96896,803781,2,15,-1,1,13,3,8,23911),
(96897,775199,2,3,-1,1,26,1,8,23911),
(96898,773255,4,1,-1,8,6,0,7,23911),
(96899,773260,4,1,-1,7,7,0,7,23911),
(96900,795959,4,1,-1,7,8,0,7,23911),
(96902,797889,4,0,-1,1,23,0,10,23911),
(96903,796426,4,2,-1,8,8,0,7,23911),
(96904,801136,4,3,-1,5,5,0,10,23911),
(96905,793158,4,4,-1,6,10,0,11,23911),
(96906,661287,2,7,-1,1,13,3,9,23911),
(96907,794468,2,13,-1,1,13,7,8,23911),
(96908,773261,4,1,-1,7,20,0,7,23911),
(96910,801009,4,6,-1,6,14,4,13,23911),
(96911,796704,2,10,-1,2,17,2,13,23911),
(96912,774566,4,2,-1,8,9,0,7,23911),
(96913,660455,4,2,-1,8,6,0,7,23911),
(96914,793152,4,4,-1,6,8,0,11,23911),
(96917,801137,4,3,-1,5,10,0,10,23911),
(96919,667697,2,6,-1,1,17,2,9,23911),
(96920,774567,4,2,-1,8,5,0,7,23911),
(96921,801140,4,3,-1,5,7,0,10,23911),
(96922,840303,4,4,-1,6,1,0,11,23911),
(96923,793163,4,4,-1,6,7,0,11,23911),
(96924,793162,4,4,-1,6,7,0,11,23911),
(96925,803800,2,1,-1,1,17,1,9,23911),
(96926,801008,4,6,-1,6,14,4,9,23911),
(96928,795965,4,1,-1,7,7,0,7,23911),
(96929,773258,4,1,-1,7,10,0,7,23911),
(96931,797791,2,4,-1,1,13,3,8,23911),
(96934,797889,4,0,-1,1,23,0,10,23911),
(96935,796429,4,2,-1,8,10,0,7,23911),
(96936,801140,4,3,-1,5,7,0,10,23911),
(96937,661379,4,4,-1,6,5,0,11,23911),
(96941,793156,4,4,-1,6,20,0,11,23911),
(96942,793158,4,4,-1,6,10,0,11,23911),
(96943,793160,4,4,-1,6,1,0,11,23911),
(96944,793162,4,4,-1,6,7,0,11,23911),
(96945,793164,4,4,-1,6,3,0,11,23911),
(96946,793156,4,4,-1,6,20,0,11,23911),
(96947,793158,4,4,-1,6,10,0,11,23911),
(96948,793160,4,4,-1,6,1,0,11,23911),
(96949,793162,4,4,-1,6,7,0,11,23911),
(96950,793164,4,4,-1,6,3,0,11,23911),
(96951,660460,4,2,-1,8,20,0,7,23911),
(96952,660458,4,2,-1,8,10,0,7,23911),
(96953,660454,4,2,-1,8,1,0,7,23911),
(96954,660459,4,2,-1,8,7,0,7,23911),
(96955,660461,4,2,-1,8,3,0,7,23911),
(96956,660458,4,2,-1,8,10,0,7,23911),
(96957,660454,4,2,-1,8,1,0,7,23911),
(96958,660459,4,2,-1,8,7,0,7,23911),
(96959,660460,4,2,-1,8,20,0,7,23911),
(96960,660461,4,2,-1,8,3,0,7,23911),
(96961,660458,4,2,-1,8,10,0,7,23911),
(96962,660454,4,2,-1,8,1,0,7,23911),
(96963,660459,4,2,-1,8,7,0,7,23911),
(96964,660460,4,2,-1,8,20,0,7,23911),
(96965,660461,4,2,-1,8,3,0,7,23911),
(96966,660460,4,2,-1,8,20,0,7,23911),
(96967,660458,4,2,-1,8,10,0,7,23911),
(96968,660454,4,2,-1,8,1,0,7,23911),
(96969,660459,4,2,-1,8,7,0,7,23911),
(96970,660461,4,2,-1,8,3,0,7,23911),
(96974,801006,2,5,-1,1,17,1,13,23911),
(96975,800999,2,2,-1,2,15,4,13,23911),
(96976,800881,2,15,-1,1,13,3,8,23911),
(96977,133492,2,4,-1,1,13,3,8,23911),
(96978,801014,2,10,-1,2,17,2,13,23911),
(96979,795966,4,1,-1,7,3,0,7,23911),
(96980,773262,4,1,-1,7,3,0,7,23911),
(96981,666653,4,1,-1,7,3,0,7,23911),
(96982,633140,2,15,-1,1,13,3,8,23911),
(96983,801005,2,4,-1,1,13,3,8,23911),
(96984,796433,4,2,-1,8,3,0,7,23911),
(96985,796433,4,2,-1,8,3,0,7,23911),
(96986,801141,4,3,-1,5,3,0,10,23911),
(96987,801141,4,3,-1,5,3,0,10,23911),
(96988,661383,4,4,-1,6,3,0,11,23911),
(96989,793165,4,4,-1,6,3,0,11,23911),
(96990,793164,4,4,-1,6,3,0,11,23911),
(96991,801016,2,8,-1,1,17,1,9,23911),
(96992,801015,2,7,-1,1,13,3,8,23911),
(96993,801007,2,6,-1,1,17,2,9,23911),
(96994,797509,4,6,-1,6,14,4,9,23911),
(96998,660751,4,3,-1,5,5,0,10,23911),
(96999,773175,4,3,-1,5,10,0,10,23911),
(97000,660752,4,3,-1,5,1,0,10,23911),
(97001,660753,4,3,-1,5,7,0,10,23911),
(97002,660754,4,3,-1,5,3,0,10,23911),
(97006,795962,4,1,-1,7,10,0,7,23911),
(97007,795963,4,1,-1,7,1,0,7,23911),
(97008,795965,4,1,-1,7,7,0,7,23911),
(97009,795961,4,1,-1,7,20,0,7,23911),
(97010,795966,4,1,-1,7,3,0,7,23911),
(97011,796428,4,2,-1,8,5,0,7,23911),
(97012,796429,4,2,-1,8,10,0,7,23911),
(97013,796430,4,2,-1,8,1,0,7,23911),
(97014,796431,4,2,-1,8,7,0,7,23911),
(97015,796433,4,2,-1,8,3,0,7,23911),
(97016,796429,4,2,-1,8,10,0,7,23911),
(97017,796430,4,2,-1,8,1,0,7,23911),
(97018,796431,4,2,-1,8,7,0,7,23911),
(97019,796428,4,2,-1,8,5,0,7,23911),
(97020,796433,4,2,-1,8,3,0,7,23911),
(97021,796428,4,2,-1,8,5,0,7,23911),
(97022,796429,4,2,-1,8,10,0,7,23911),
(97023,796430,4,2,-1,8,1,0,7,23911),
(97024,796431,4,2,-1,8,7,0,7,23911),
(97025,796433,4,2,-1,8,3,0,7,23911),
(97026,661379,4,4,-1,6,5,0,11,23911),
(97027,661380,4,4,-1,6,10,0,11,23911),
(97028,661381,4,4,-1,6,1,0,11,23911),
(97029,661382,4,4,-1,6,7,0,11,23911),
(97030,661383,4,4,-1,6,3,0,11,23911),
(97031,661379,4,4,-1,6,5,0,11,23911),
(97032,661380,4,4,-1,1,10,0,11,23911),
(97033,661381,4,4,-1,6,1,0,11,23911),
(97034,661382,4,4,-1,6,7,0,11,23911),
(97035,661383,4,4,-1,6,3,0,11,23911),
(97036,661379,4,4,-1,6,5,0,11,23911),
(97037,661380,4,4,-1,6,10,0,11,23911),
(97038,661381,4,4,-1,6,1,0,11,23911),
(97039,661382,4,4,-1,6,7,0,11,23911),
(97040,661383,4,4,-1,6,3,0,11,23911),
(97041,773258,4,1,-1,7,10,0,7,23911),
(97042,773259,4,1,-1,7,1,0,7,23911),
(97043,773260,4,1,-1,7,7,0,7,23911),
(97044,773261,4,1,-1,7,20,0,7,23911),
(97045,773262,4,1,-1,7,3,0,7,23911),
(97046,773258,4,1,-1,7,10,0,7,23911),
(97047,773259,4,1,-1,7,1,0,7,23911),
(97048,773260,4,1,-1,7,7,0,7,23911),
(97049,773261,4,1,-1,7,20,0,7,23911),
(97050,773262,4,1,-1,7,3,0,7,23911),
(97051,774567,4,2,-1,8,5,0,7,23911),
(97052,774568,4,2,-1,8,10,0,7,23911),
(97053,774569,4,2,-1,8,1,0,7,23911),
(97054,774570,4,2,-1,8,7,0,7,23911),
(97055,774571,4,2,-1,8,3,0,7,23911),
(97056,801136,4,3,-1,5,20,0,10,23911),
(97057,801137,4,3,-1,5,10,0,10,23911),
(97058,801138,4,3,-1,5,1,0,10,23911),
(97059,801140,4,3,-1,5,7,0,10,23911),
(97060,801141,4,3,-1,5,3,0,10,23911),
(97061,801136,4,3,-1,5,5,0,10,23911),
(97062,801137,4,3,-1,5,10,0,10,23911),
(97063,801138,4,3,-1,5,1,0,10,23911),
(97064,801140,4,3,-1,5,7,0,10,23911),
(97065,801141,4,3,-1,5,3,0,10,23911),
(97066,801136,4,3,-1,5,20,0,10,23911),
(97067,801137,4,3,-1,5,10,0,10,23911),
(97068,801138,4,3,-1,5,1,0,10,23911),
(97069,801140,4,3,-1,5,7,0,10,23911),
(97070,801141,4,3,-1,5,3,0,10,23911),
(97075,774565,4,2,-1,8,8,0,7,23911),
(97076,801134,4,3,-1,5,8,0,10,23911),
(97077,795958,4,1,-1,8,6,0,7,23911),
(97078,773255,4,1,-1,7,6,0,7,23911),
(97079,666646,4,1,-1,7,8,0,7,23911),
(97081,773256,4,1,-1,7,8,0,7,23911),
(97082,660456,4,2,-1,8,8,0,7,23911),
(97083,801134,4,3,-1,5,8,0,10,23911),
(97084,661377,4,4,-1,6,8,0,11,23911),
(97086,660455,4,2,-1,8,6,0,7,23911),
(97087,796425,4,2,-1,8,6,0,7,23911),
(97088,660748,4,3,-1,5,6,0,10,23911),
(97089,801133,4,3,-1,5,6,0,10,23911),
(97090,661376,4,4,-1,6,6,0,11,23911),
(97091,793150,4,4,-1,6,6,0,11,23911),
(97092,793151,4,4,-1,6,6,0,11,23911),
(97094,793153,4,4,-1,6,8,0,11,23911),
(97095,793152,4,4,-1,6,8,0,11,23911),
(97097,666649,4,1,-1,7,10,0,7,23911),
(97098,666650,4,1,-1,7,1,0,7,23911),
(97099,666651,4,1,-1,7,7,0,7,23911),
(97100,666652,4,1,-1,7,20,0,7,23911),
(97101,666653,4,1,-1,7,3,0,7,23911),
(97102,793161,4,4,-1,6,1,0,11,23911),
(97103,793157,4,4,-1,6,5,0,11,23911),
(97104,793159,4,4,-1,6,10,0,11,23911),
(97105,793163,4,4,-1,6,7,0,11,23911),
(97106,793165,4,4,-1,6,3,0,11,23911),
(97107,793157,4,4,-1,6,5,0,11,23911),
(97108,793159,4,4,-1,6,10,0,11,23911),
(97109,793161,4,4,-1,6,1,0,11,23911),
(97110,793163,4,4,-1,6,7,0,11,23911),
(97111,793165,4,4,-1,6,3,0,11,23911),
(97128,838513,2,13,-1,1,13,7,8,23911),
(97130,838513,2,13,-1,1,13,7,8,23911),
(95998,774569,4,2,-1,8,1,0,7,23911),
(95999,660753,4,3,-1,5,7,0,10,23911),
(96000,660754,4,3,-1,5,3,0,10,23911),
(96001,793151,4,4,-1,6,6,0,11,23911),
(96002,793156,4,4,-1,6,5,0,11,23911),
(96003,793155,4,4,-1,6,9,0,11,23911),
(96004,804512,2,0,-1,1,13,3,8,23911),
(96006,795962,4,1,-1,7,10,0,7,23911),
(96007,666651,4,1,-1,7,7,0,7,23911),
(96008,666653,4,1,-1,7,3,0,7,23911),
(96009,773261,4,1,-1,7,20,0,7,23911),
(96011,628277,4,1,-1,7,16,0,7,23911),
(96012,840732,2,7,-1,1,13,3,9,23911),
(96014,796427,4,2,-1,8,9,0,7,23911),
(96015,801134,4,3,-1,5,8,0,10,23911),
(96016,661379,4,4,-1,6,5,0,11,23911),
(96017,628676,4,1,-1,7,16,0,7,23911),
(96019,768650,2,10,-1,2,17,2,13,23911),
(96020,660457,4,2,-1,8,9,0,7,23911),
(96021,801136,4,3,-1,5,5,0,10,23911),
(96022,793155,4,4,-1,6,9,0,11,23911),
(96023,793162,4,4,-1,6,7,0,11,23911),
(96024,793161,4,4,-1,6,1,0,11,23911),
(96025,630617,4,1,-1,7,16,0,7,23911),
(96027,795963,4,1,-1,7,1,0,7,23911),
(96028,773257,4,1,-1,7,9,0,7,23911),
(96029,796788,2,10,-1,2,17,2,13,23911),
(96032,803764,2,19,-1,2,26,3,21,23911),
(96033,796431,4,2,-1,8,7,0,7,23911),
(96034,660461,4,2,-1,8,3,0,7,23911),
(96035,801140,4,3,-1,5,7,0,10,23911),
(96036,661378,4,4,-1,6,9,0,11,23911),
(96038,799996,2,0,-1,1,13,3,8,23911),
(96039,773256,4,1,-1,7,8,0,7,23911),
(96040,666652,4,1,-1,7,20,0,7,23911),
(96042,792975,2,13,-1,1,13,7,8,23911),
(96043,660460,4,2,-1,8,20,0,7,23911),
(96044,660752,4,3,-1,5,1,0,10,23911),
(96045,801135,4,3,-1,8,9,0,10,23911),
(96046,793157,4,4,-1,6,5,0,11,23911),
(96047,668828,2,8,-1,1,17,1,9,23911),
(96050,775504,2,2,-1,2,15,4,13,23911),
(96051,796428,4,2,-1,8,5,0,7,23911),
(96052,774568,4,2,-1,8,10,0,7,23911),
(96053,660750,4,3,-1,5,9,0,10,23911),
(96054,660749,4,3,-1,5,8,0,10,23911),
(96055,793164,4,4,-1,6,3,0,11,23911),
(96056,793154,4,4,-1,6,9,0,11,23911),
(96058,666408,2,0,-1,1,13,3,8,23911),
(96059,630617,4,1,-1,7,16,0,7,23911),
(96060,795960,4,1,-1,7,9,0,7,23911),
(96061,773259,4,1,-1,7,1,0,7,23911),
(96062,795962,4,1,-1,7,10,0,7,23911),
(96063,629630,4,1,-1,7,16,0,7,23911),
(96064,774421,4,6,-1,6,14,4,13,23911),
(96065,660457,4,2,-1,8,9,0,7,23911),
(96066,796432,4,2,-1,8,20,0,7,23911),
(96067,801141,4,3,-1,5,3,0,10,23911),
(96068,661376,4,4,-1,6,6,0,11,23911),
(96069,661380,4,4,-1,1,10,0,11,23911),
(96070,660663,2,15,-1,1,13,3,8,23911),
(96072,774571,4,2,-1,8,3,0,7,23911),
(96073,801137,4,3,-1,5,10,0,10,23911),
(96074,793150,4,4,-1,6,6,0,11,23911),
(96075,793156,4,4,-1,6,5,0,11,23911),
(96078,795959,4,1,-1,7,8,0,7,23911),
(96079,773262,4,1,-1,7,3,0,7,23911),
(96080,666647,4,1,-1,7,9,0,7,23911),
(96082,795964,4,0,-1,1,23,0,10,23911),
(96085,796430,4,2,-1,8,1,0,7,23911),
(96086,801133,4,3,-1,5,6,0,10,23911),
(96087,801136,4,3,-1,5,5,0,10,23911),
(96088,661377,4,4,-1,6,8,0,11,23911),
(96089,628676,4,1,-1,7,16,0,7,23911),
(96090,666645,4,1,-1,8,6,0,7,23911),
(96091,795961,4,1,-1,7,20,0,7,23911),
(96092,667146,2,10,-1,2,17,2,13,23911),
(96093,774564,4,2,-1,8,6,0,7,23911),
(96094,801137,4,3,-1,5,10,0,10,23911),
(96095,661381,4,4,-1,6,1,0,11,23911),
(96096,793157,4,4,-1,6,5,0,11,23911),
(96097,793159,4,4,-1,6,10,0,11,23911),
(96100,792562,2,18,-1,2,26,5,15,23911),
(96101,774570,4,2,-1,8,7,0,7,23911),
(96102,801133,4,3,-1,5,6,0,10,23911),
(96103,660751,4,3,-1,5,5,0,10,23911),
(96104,793154,4,4,-1,6,9,0,11,23911),
(96105,793163,4,4,-1,6,7,0,11,23911),
(96106,793153,4,4,-1,6,8,0,11,23911),
(96107,793159,4,4,-1,6,10,0,11,23911),
(96108,630617,4,1,-1,7,16,0,7,23911),
(96110,666649,4,1,-1,7,10,0,7,23911),
(96111,666651,4,1,-1,7,7,0,7,23911),
(96112,795966,4,1,-1,7,3,0,7,23911),
(96113,629630,4,1,-1,7,16,0,7,23911),
(96115,800881,2,15,-1,1,13,3,8,23911),
(96116,796426,4,2,-1,8,8,0,7,23911),
(96117,801135,4,3,-1,8,9,0,10,23911),
(96118,661380,4,4,-1,1,10,0,11,23911),
(96119,661382,4,4,-1,6,7,0,11,23911),
(96121,796429,4,2,-1,8,10,0,7,23911),
(96122,660750,4,3,-1,5,9,0,10,23911),
(96123,773175,4,3,-1,5,10,0,10,23911),
(96124,793158,4,4,-1,6,10,0,11,23911),
(96125,793162,4,4,-1,6,7,0,11,23911),
(96126,793164,4,4,-1,6,3,0,11,23911),
(96127,630617,4,1,-1,7,16,0,7,23911),
(96130,667145,2,4,-1,1,13,3,8,23911),
(96131,666652,4,1,-1,7,20,0,7,23911),
(96132,773258,4,1,-1,7,10,0,7,23911),
(96133,773260,4,1,-1,7,7,0,7,23911),
(96134,666647,4,1,-1,7,9,0,7,23911),
(96136,660459,4,2,-1,8,7,0,7,23911),
(96137,801138,4,3,-1,5,1,0,10,23911),
(96138,661378,4,4,-1,6,9,0,11,23911),
(96139,661383,4,4,-1,6,3,0,11,23911),
(96140,794910,4,6,-1,6,14,4,13,23911),
(96142,794752,2,4,-1,1,13,3,8,23911),
(96143,666650,4,1,-1,7,1,0,7,23911),
(96145,628277,4,1,-1,7,16,0,7,23911),
(96146,796140,2,15,-1,1,13,3,8,23911),
(96147,660459,4,2,-1,8,7,0,7,23911),
(96148,660458,4,2,-1,8,10,0,7,23911),
(96149,661382,4,4,-1,6,7,0,11,23911),
(96150,793160,4,4,-1,6,1,0,11,23911),
(96152,803781,2,15,-1,1,13,3,8,23911),
(96153,775199,2,3,-1,1,26,1,8,23911),
(96154,773255,4,1,-1,8,6,0,7,23911),
(96155,773260,4,1,-1,7,7,0,7,23911),
(96156,795959,4,1,-1,7,8,0,7,23911),
(96158,797889,4,0,-1,1,23,0,10,23911),
(96159,796426,4,2,-1,8,8,0,7,23911),
(96160,801136,4,3,-1,5,5,0,10,23911),
(96161,793158,4,4,-1,6,10,0,11,23911),
(96162,661287,2,7,-1,1,13,3,9,23911),
(96163,794468,2,13,-1,1,13,7,8,23911),
(96164,773261,4,1,-1,7,20,0,7,23911),
(96166,801009,4,6,-1,6,14,4,13,23911),
(96167,796704,2,10,-1,2,17,2,13,23911),
(96168,774566,4,2,-1,8,9,0,7,23911),
(96169,660455,4,2,-1,8,6,0,7,23911),
(96170,793152,4,4,-1,6,8,0,11,23911),
(96173,801137,4,3,-1,5,10,0,10,23911),
(96175,667697,2,6,-1,1,17,2,9,23911),
(96176,774567,4,2,-1,8,5,0,7,23911),
(96177,801140,4,3,-1,5,7,0,10,23911),
(96178,840303,4,4,-1,6,1,0,11,23911),
(96179,793163,4,4,-1,6,7,0,11,23911),
(96180,793162,4,4,-1,6,7,0,11,23911),
(96181,803800,2,1,-1,1,17,1,9,23911),
(96182,801008,4,6,-1,6,14,4,9,23911),
(96184,795965,4,1,-1,7,7,0,7,23911),
(96185,773258,4,1,-1,7,10,0,7,23911),
(96187,797791,2,4,-1,1,13,3,8,23911),
(96190,797889,4,0,-1,1,23,0,10,23911),
(96191,796429,4,2,-1,8,10,0,7,23911),
(96192,801140,4,3,-1,5,7,0,10,23911),
(96193,661379,4,4,-1,6,5,0,11,23911),
(96197,793156,4,4,-1,6,20,0,11,23911),
(96198,793158,4,4,-1,6,10,0,11,23911),
(96199,793160,4,4,-1,6,1,0,11,23911),
(96200,793162,4,4,-1,6,7,0,11,23911),
(96201,793164,4,4,-1,6,3,0,11,23911),
(96202,793156,4,4,-1,6,20,0,11,23911),
(96203,793158,4,4,-1,6,10,0,11,23911),
(96204,793160,4,4,-1,6,1,0,11,23911),
(96205,793162,4,4,-1,6,7,0,11,23911),
(96206,793164,4,4,-1,6,3,0,11,23911),
(96207,660460,4,2,-1,8,20,0,7,23911),
(96208,660458,4,2,-1,8,10,0,7,23911),
(96209,660454,4,2,-1,8,1,0,7,23911),
(96210,660459,4,2,-1,8,7,0,7,23911),
(96211,660461,4,2,-1,8,3,0,7,23911),
(96212,660458,4,2,-1,8,10,0,7,23911),
(96213,660454,4,2,-1,8,1,0,7,23911),
(96214,660459,4,2,-1,8,7,0,7,23911),
(96215,660460,4,2,-1,8,20,0,7,23911),
(96216,660461,4,2,-1,8,3,0,7,23911),
(96217,660458,4,2,-1,8,10,0,7,23911),
(96218,660454,4,2,-1,8,1,0,7,23911),
(96219,660459,4,2,-1,8,7,0,7,23911),
(96220,660460,4,2,-1,8,20,0,7,23911),
(96221,660461,4,2,-1,8,3,0,7,23911),
(96222,660460,4,2,-1,8,20,0,7,23911),
(96223,660458,4,2,-1,8,10,0,7,23911),
(96224,660454,4,2,-1,8,1,0,7,23911),
(96225,660459,4,2,-1,8,7,0,7,23911),
(96226,660461,4,2,-1,8,3,0,7,23911),
(96230,801006,2,5,-1,1,17,1,13,23911),
(96231,800999,2,2,-1,2,15,4,13,23911),
(96232,800881,2,15,-1,1,13,3,8,23911),
(96233,133492,2,4,-1,1,13,3,8,23911),
(96234,801014,2,10,-1,2,17,2,13,23911),
(96235,795966,4,1,-1,7,3,0,7,23911),
(96236,773262,4,1,-1,7,3,0,7,23911),
(96237,666653,4,1,-1,7,3,0,7,23911),
(96238,659672,2,15,-1,1,13,3,8,23911),
(96239,801005,2,4,-1,1,13,3,8,23911),
(96240,796433,4,2,-1,8,3,0,7,23911),
(96241,796433,4,2,-1,8,3,0,7,23911),
(96242,801141,4,3,-1,5,3,0,10,23911),
(96243,801141,4,3,-1,5,3,0,10,23911),
(96244,661383,4,4,-1,6,3,0,11,23911),
(96245,793165,4,4,-1,6,3,0,11,23911),
(96246,793164,4,4,-1,6,3,0,11,23911),
(96247,801016,2,8,-1,1,17,1,9,23911),
(96248,801015,2,7,-1,1,13,3,8,23911),
(96249,801007,2,6,-1,1,17,2,9,23911),
(96250,797509,4,6,-1,6,14,4,9,23911),
(96254,660751,4,3,-1,5,5,0,10,23911),
(96255,773175,4,3,-1,5,10,0,10,23911),
(147860,134544,0,8,-1,7,0,0,19,23911),
(147384,1519426,15,4,-1,0,0,0,7,23911),
(144362,1397649,12,0,-1,0,0,0,7,23911),
(147417,133762,12,0,-1,7,0,0,7,23911),
(146975,133762,12,0,-1,7,0,0,7,23911),
(143648,1537157,15,5,-1,8,0,0,16,23911),
(143649,1537157,15,5,-1,8,0,0,16,23911),
(142437,1522940,15,5,-1,8,0,0,16,23911),
(142234,1499689,15,5,-1,8,0,0,16,23911),
(142235,1499690,15,5,-1,8,0,0,16,23911),
(142237,1517168,15,5,-1,8,0,0,16,23911),
(146433,414306,0,8,-1,0,0,0,7,23911),
(146435,463013,0,8,-1,0,0,0,9,23911),
(146437,426398,0,8,-1,0,0,0,7,23911),
(146439,531764,0,8,-1,0,0,0,11,23911),
(146441,536784,0,8,-1,0,0,0,11,23911),
(146443,532280,0,8,-1,0,0,0,9,23911),
(146445,530827,0,8,-1,0,0,0,7,23911),
(146447,535823,0,8,-1,0,0,0,7,23911),
(146449,529879,0,8,-1,0,0,0,9,23911),
(147661,1550417,0,8,-1,0,0,0,11,23911),
(146451,532749,0,8,-1,0,0,0,11,23911),
(146453,531785,0,8,-1,0,0,0,7,23911),
(146455,538050,0,8,-1,0,0,0,9,23911),
(146457,532333,0,8,-1,0,0,0,7,23911),
(147631,1538697,0,8,-1,0,0,0,11,23911),
(147646,1529800,0,8,-1,0,0,0,11,23911),
(146642,325906,0,8,-1,0,0,0,11,23911),
(147632,1538697,0,8,-1,0,0,0,11,23911),
(147629,1511484,0,8,-1,0,0,0,7,23911),
(147633,1549277,0,8,-1,0,0,0,7,23911),
(147667,1533501,0,8,-1,0,0,0,7,23911),
(147645,1529800,0,8,-1,0,0,0,11,23911),
(147628,1531504,0,8,-1,0,0,0,7,23911),
(147636,1518787,0,8,-1,0,0,0,9,23911),
(147637,1551576,0,8,-1,0,0,0,11,23911),
(146499,468712,0,8,-1,0,0,0,11,23911),
(146501,469629,0,8,-1,0,0,0,11,23911),
(146503,512470,0,8,-1,0,0,0,9,23911),
(146505,510996,0,8,-1,0,0,0,7,23911),
(146507,469521,0,8,-1,0,0,0,7,23911),
(146509,431762,0,8,-1,0,0,0,9,23911),
(147663,1518071,0,8,-1,0,0,0,7,23911),
(146511,469162,0,8,-1,0,0,0,11,23911),
(146513,469163,0,8,-1,0,0,0,7,23911),
(146515,468860,0,8,-1,0,0,0,9,23911),
(146517,468859,0,8,-1,0,0,0,7,23911),
(146519,463003,0,8,-1,0,0,0,11,23911),
(146521,459038,0,8,-1,0,0,0,11,23911),
(147643,1581054,0,8,-1,0,0,0,7,23911),
(146523,367597,0,8,-1,0,0,0,9,23911),
(146525,367301,0,8,-1,0,0,0,7,23911),
(146527,346948,0,8,-1,0,0,0,7,23911),
(146529,436748,0,8,-1,0,0,0,9,23911),
(147650,1551051,0,8,-1,0,0,0,9,23911),
(146531,464191,0,8,-1,0,0,0,11,23911),
(146644,236892,0,8,-1,0,0,0,11,23911),
(146533,414285,0,8,-1,0,0,0,7,23911),
(146535,463004,0,8,-1,0,0,0,9,23911),
(146537,426394,0,8,-1,0,0,0,7,23911),
(146538,132732,0,8,-1,0,0,0,11,23911),
(146539,132727,0,8,-1,0,0,0,11,23911),
(146540,132757,0,8,-1,0,0,0,9,23911),
(146541,132704,0,8,-1,0,0,0,7,23911),
(146542,132728,0,8,-1,0,0,0,7,23911),
(146543,132757,0,8,-1,0,0,0,9,23911),
(146544,132732,0,8,-1,0,0,0,11,23911),
(146545,132704,0,8,-1,0,0,0,7,23911),
(146546,132757,0,8,-1,0,0,0,9,23911),
(146547,132704,0,8,-1,0,0,0,7,23911),
(146548,132732,0,8,-1,0,0,0,11,23911),
(146549,132711,0,8,-1,0,0,0,11,23911),
(146550,132757,0,8,-1,0,0,0,9,23911),
(146551,132704,0,8,-1,0,0,0,7,23911),
(146552,132731,0,8,-1,0,0,0,7,23911),
(146553,236993,0,8,-1,0,0,0,9,23911),
(146554,132638,0,8,-1,0,0,0,11,23911),
(146555,132704,0,8,-1,0,0,0,7,23911),
(146556,236993,0,8,-1,0,0,0,9,23911),
(146557,132702,0,8,-1,0,0,0,7,23911),
(146558,237459,0,8,-1,0,0,0,11,23911),
(146559,237465,0,8,-1,0,0,0,11,23911),
(146560,237466,0,8,-1,0,0,0,9,23911),
(146561,237466,0,8,-1,0,0,0,7,23911),
(146562,135120,0,8,-1,0,0,0,7,23911),
(146563,135087,0,8,-1,0,0,0,9,23911),
(146564,237462,0,8,-1,0,0,0,11,23911),
(146565,237458,0,8,-1,0,0,0,7,23911),
(146566,135087,0,8,-1,0,0,0,9,23911),
(146567,237461,0,8,-1,0,0,0,7,23911),
(146568,132732,0,8,-1,0,0,0,11,23911),
(146569,132731,0,8,-1,0,0,0,11,23911),
(146570,236993,0,8,-1,0,0,0,9,23911),
(146571,307701,0,8,-1,0,0,0,7,23911),
(146572,132731,0,8,-1,0,0,0,7,23911),
(146573,236993,0,8,-1,0,0,0,9,23911),
(146574,132732,0,8,-1,0,0,0,11,23911),
(146575,307701,0,8,-1,0,0,0,7,23911),
(146576,132757,0,8,-1,0,0,0,9,23911),
(146577,307701,0,8,-1,0,0,0,7,23911),
(146578,237459,0,8,-1,0,0,0,11,23911),
(146579,237465,0,8,-1,0,0,0,11,23911),
(146580,237466,0,8,-1,0,0,0,9,23911),
(146581,237466,0,8,-1,0,0,0,7,23911),
(146582,135120,0,8,-1,0,0,0,7,23911),
(146583,135087,0,8,-1,0,0,0,9,23911),
(146584,237462,0,8,-1,0,0,0,11,23911),
(146585,237458,0,8,-1,0,0,0,7,23911),
(146586,135087,0,8,-1,0,0,0,9,23911),
(146587,237461,0,8,-1,0,0,0,7,23911),
(146588,344558,0,8,-1,0,0,0,11,23911),
(146589,348768,0,8,-1,0,0,0,11,23911),
(146590,236993,0,8,-1,0,0,0,9,23911),
(146591,351030,0,8,-1,0,0,0,7,23911),
(146592,346948,0,8,-1,0,0,0,7,23911),
(146593,346948,0,8,-1,0,0,0,9,23911),
(146594,132732,0,8,-1,0,0,0,11,23911),
(146595,347852,0,8,-1,0,0,0,7,23911),
(146596,347738,0,8,-1,0,0,0,9,23911),
(146597,344542,0,8,-1,0,0,0,7,23911),
(146598,132629,0,8,-1,0,0,0,11,23911),
(146599,132646,0,8,-1,0,0,0,11,23911),
(146600,132757,0,8,-1,0,0,0,9,23911),
(146601,132702,0,8,-1,0,0,0,7,23911),
(146602,132718,0,8,-1,0,0,0,7,23911),
(146603,132757,0,8,-1,0,0,0,9,23911),
(146604,132638,0,8,-1,0,0,0,11,23911),
(146605,132701,0,8,-1,0,0,0,7,23911),
(146606,132756,0,8,-1,0,0,0,9,23911),
(146607,132703,0,8,-1,0,0,0,7,23911),
(146608,132633,0,8,-1,0,0,0,11,23911),
(146609,132726,0,8,-1,0,0,0,11,23911),
(147634,1549277,0,8,-1,0,0,0,7,23911),
(146611,132703,0,8,-1,0,0,0,7,23911),
(146612,132718,0,8,-1,0,0,0,7,23911),
(146613,132754,0,8,-1,0,0,0,9,23911),
(146614,132633,0,8,-1,0,0,0,11,23911),
(146615,132705,0,8,-1,0,0,0,7,23911),
(146616,132752,0,8,-1,0,0,0,9,23911),
(146617,132701,0,8,-1,0,0,0,7,23911),
(146618,132633,0,8,-1,0,0,0,11,23911),
(146619,132727,0,8,-1,0,0,0,11,23911),
(147630,1511484,0,8,-1,0,0,0,7,23911),
(146621,132704,0,8,-1,0,0,0,7,23911),
(146622,132728,0,8,-1,0,0,0,7,23911),
(146623,132755,0,8,-1,0,0,0,9,23911),
(146624,132633,0,8,-1,0,0,0,11,23911),
(146625,132706,0,8,-1,0,0,0,7,23911),
(146626,132753,0,8,-1,0,0,0,9,23911),
(146627,132702,0,8,-1,0,0,0,7,23911),
(146628,132733,0,8,-1,0,0,0,11,23911),
(146629,132730,0,8,-1,0,0,0,11,23911),
(147654,1511490,0,8,-1,0,0,0,7,23911),
(146631,132709,0,8,-1,0,0,0,7,23911),
(146632,132731,0,8,-1,0,0,0,7,23911),
(146633,132757,0,8,-1,0,0,0,9,23911),
(146634,132734,0,8,-1,0,0,0,11,23911),
(146635,132707,0,8,-1,0,0,0,7,23911),
(146636,132756,0,8,-1,0,0,0,9,23911),
(146637,132708,0,8,-1,0,0,0,7,23911),
(147662,1550417,0,8,-1,0,0,0,11,23911),
(146639,532989,0,8,-1,0,0,0,11,23911),
(146640,514845,0,8,-1,0,0,0,11,23911),
(146641,467623,0,8,-1,0,0,0,11,23911),
(146130,1357446,0,8,-1,0,0,0,9,23911),
(146131,1357446,0,8,-1,0,0,0,9,23911),
(146132,1320040,0,8,-1,0,0,0,9,23911),
(146133,1320040,0,8,-1,0,0,0,9,23911),
(146134,1316217,0,8,-1,0,0,0,9,23911),
(146135,1316217,0,8,-1,0,0,0,9,23911),
(146136,1339437,0,8,-1,0,0,0,11,23911),
(146137,1339437,0,8,-1,0,0,0,11,23911),
(146138,1318379,0,8,-1,0,0,0,11,23911),
(146139,1318379,0,8,-1,0,0,0,11,23911),
(146140,1339048,0,8,-1,0,0,0,11,23911),
(146141,1339048,0,8,-1,0,0,0,11,23911),
(146142,1335532,0,8,-1,0,0,0,11,23911),
(146143,1335532,0,8,-1,0,0,0,11,23911),
(146144,1308710,0,8,-1,0,0,0,7,23911),
(146145,1308710,0,8,-1,0,0,0,7,23911),
(146146,1345980,0,8,-1,0,0,0,7,23911),
(146147,1345980,0,8,-1,0,0,0,7,23911),
(146148,1336644,0,8,-1,0,0,0,7,23911),
(146149,1336644,0,8,-1,0,0,0,7,23911),
(146150,1306775,0,8,-1,0,0,0,7,23911),
(146151,1306775,0,8,-1,0,0,0,7,23911),
(146152,1248340,0,8,-1,0,0,0,11,23911),
(146153,1248340,0,8,-1,0,0,0,11,23911),
(146154,1248340,0,8,-1,0,0,0,11,23911),
(146155,1248340,0,8,-1,0,0,0,11,23911),
(146156,1267788,0,8,-1,0,0,0,7,23911),
(146157,1267788,0,8,-1,0,0,0,7,23911),
(146158,1267788,0,8,-1,0,0,0,7,23911),
(146159,1267788,0,8,-1,0,0,0,7,23911),
(146160,1267788,0,8,-1,0,0,0,7,23911),
(146161,1267788,0,8,-1,0,0,0,7,23911),
(146162,1131914,0,8,-1,0,0,0,9,23911),
(146163,1131914,0,8,-1,0,0,0,9,23911),
(146164,1131914,0,8,-1,0,0,0,9,23911),
(146165,1131914,0,8,-1,0,0,0,9,23911),
(146166,1131914,0,8,-1,0,0,0,9,23911),
(146167,1131914,0,8,-1,0,0,0,9,23911),
(146168,1261053,0,8,-1,0,0,0,7,23911),
(146169,1261053,0,8,-1,0,0,0,7,23911),
(146170,1261053,0,8,-1,0,0,0,7,23911),
(146171,1261053,0,8,-1,0,0,0,7,23911),
(146172,1261053,0,8,-1,0,0,0,7,23911),
(146173,1261053,0,8,-1,0,0,0,7,23911),
(146645,236892,0,8,-1,0,0,0,11,23911),
(147635,1518787,0,8,-1,0,0,0,9,23911),
(147652,1531505,0,8,-1,0,0,0,7,23911),
(146646,236892,0,8,-1,0,0,0,11,23911),
(146647,236892,0,8,-1,0,0,0,11,23911),
(147651,1531505,0,8,-1,0,0,0,7,23911),
(146648,132460,0,8,-1,0,0,0,11,23911),
(146649,132447,0,8,-1,0,0,0,11,23911),
(146650,132455,0,8,-1,0,0,0,11,23911),
(147668,1533501,0,8,-1,0,0,0,7,23911),
(147653,1511490,0,8,-1,0,0,0,7,23911),
(146651,132455,0,8,-1,0,0,0,11,23911),
(147658,1549275,0,8,-1,0,0,0,7,23911),
(146218,1357387,0,8,-1,0,0,0,9,23911),
(146219,1357387,0,8,-1,0,0,0,9,23911),
(146220,1346146,0,8,-1,0,0,0,9,23911),
(146221,1346146,0,8,-1,0,0,0,9,23911),
(146222,1316219,0,8,-1,0,0,0,9,23911),
(146223,1316219,0,8,-1,0,0,0,9,23911),
(146224,1339448,0,8,-1,0,0,0,11,23911),
(146225,1339448,0,8,-1,0,0,0,11,23911),
(146226,1318373,0,8,-1,0,0,0,11,23911),
(146227,1318373,0,8,-1,0,0,0,11,23911),
(146228,1337285,0,8,-1,0,0,0,11,23911),
(146229,1337285,0,8,-1,0,0,0,11,23911),
(146230,1335526,0,8,-1,0,0,0,11,23911),
(146231,1335526,0,8,-1,0,0,0,11,23911),
(146232,1309133,0,8,-1,0,0,0,7,23911),
(146233,1309133,0,8,-1,0,0,0,7,23911),
(146234,1345987,0,8,-1,0,0,0,7,23911),
(146235,1345987,0,8,-1,0,0,0,7,23911),
(146236,1321257,0,8,-1,0,0,0,7,23911),
(146237,1321257,0,8,-1,0,0,0,7,23911),
(146238,1311203,0,8,-1,0,0,0,7,23911),
(146239,1311203,0,8,-1,0,0,0,7,23911),
(147666,1512750,0,8,-1,0,0,0,9,23911),
(147665,1512750,0,8,-1,0,0,0,9,23911),
(147648,1550783,0,8,-1,0,0,0,11,23911),
(146262,1408494,0,8,-1,0,0,0,7,23911),
(146263,1408494,0,8,-1,0,0,0,7,23911),
(146264,1261053,0,8,-1,0,0,0,7,23911),
(146265,1261053,0,8,-1,0,0,0,7,23911),
(146270,1408496,0,8,-1,0,0,0,7,23911),
(146271,1408496,0,8,-1,0,0,0,7,23911),
(147664,1518071,0,8,-1,0,0,0,7,23911),
(147655,1536485,0,8,-1,0,0,0,11,23911),
(147638,1551576,0,8,-1,0,0,0,11,23911),
(147656,1536485,0,8,-1,0,0,0,11,23911),
(147639,1601100,0,8,-1,0,0,0,7,23911),
(147647,1550783,0,8,-1,0,0,0,11,23911),
(147644,1581054,0,8,-1,0,0,0,7,23911),
(147641,1581161,0,8,-1,0,0,0,9,23911),
(147657,1549275,0,8,-1,0,0,0,7,23911),
(147640,1601100,0,8,-1,0,0,0,7,23911),
(139167,973451,0,8,-1,0,0,0,9,23911),
(139168,973896,0,8,-1,0,0,0,9,23911),
(139169,973548,0,8,-1,0,0,0,9,23911),
(139170,973193,0,8,-1,0,0,0,9,23911),
(138152,0,4,4,-1,6,5,0,11,23911),
(138153,0,4,4,-1,6,10,0,11,23911),
(138154,0,4,4,-1,6,6,0,11,23911),
(138155,0,4,4,-1,6,1,0,11,23911),
(138156,0,4,4,-1,6,7,0,11,23911),
(138157,0,4,4,-1,6,3,0,11,23911),
(138158,0,4,4,-1,6,8,0,11,23911),
(138159,0,4,4,-1,6,9,0,11,23911),
(138163,0,4,2,-1,8,9,0,7,23911),
(138164,0,4,2,-1,8,8,0,7,23911),
(138165,0,4,2,-1,8,7,0,7,23911),
(138166,0,4,2,-1,8,10,0,7,23911),
(138167,0,4,2,-1,8,1,0,7,23911),
(138168,0,4,2,-1,8,3,0,7,23911),
(138169,0,4,2,-1,8,6,0,7,23911),
(138172,0,4,3,-1,5,6,0,10,23911),
(138173,0,4,3,-1,5,9,0,10,23911),
(138174,0,4,3,-1,5,10,0,10,23911),
(138175,0,4,3,-1,5,8,0,10,23911),
(138176,0,4,3,-1,5,1,0,10,23911),
(138177,0,4,3,-1,5,7,0,10,23911),
(138178,0,4,3,-1,5,3,0,10,23911),
(138179,0,4,3,-1,5,5,0,10,23911),
(138180,0,4,1,-1,7,6,0,7,23911),
(138181,0,4,1,-1,7,9,0,7,23911),
(138182,0,4,1,-1,7,10,0,7,23911),
(138183,0,4,1,-1,7,8,0,7,23911),
(138184,0,4,1,-1,7,1,0,7,23911),
(138185,0,4,1,-1,7,7,0,7,23911),
(138186,0,4,1,-1,7,3,0,7,23911),
(138187,0,4,1,-1,7,5,0,7,23911),
(146643,305964,0,8,-1,0,0,0,11,23911),
(138192,0,4,2,-1,8,5,0,7,23911),
(147659,1518777,0,8,-1,0,0,0,9,23911),
(147642,1581161,0,8,-1,0,0,0,9,23911),
(147625,1551056,0,8,-1,0,0,0,9,23911),
(147626,1551056,0,8,-1,0,0,0,9,23911),
(147621,1529810,0,8,-1,0,0,0,11,23911),
(147649,1551051,0,8,-1,0,0,0,9,23911),
(147622,1529810,0,8,-1,0,0,0,11,23911),
(147627,1531504,0,8,-1,0,0,0,7,23911),
(147623,1544254,0,8,-1,0,0,0,11,23911),
(147624,1544254,0,8,-1,0,0,0,11,23911),
(146419,463012,0,8,-1,0,0,0,11,23911),
(147660,1518777,0,8,-1,0,0,0,9,23911),
(146421,459043,0,8,-1,0,0,0,11,23911),
(146423,367602,0,8,-1,0,0,0,9,23911),
(146425,464980,0,8,-1,0,0,0,7,23911),
(146427,436842,0,8,-1,0,0,0,7,23911),
(146429,436752,0,8,-1,0,0,0,9,23911),
(146431,464195,0,8,-1,0,0,0,11,23911),
(147718,255347,0,8,-1,4,0,0,14,23911),
(147719,255347,0,8,-1,4,0,0,14,23911),
(147720,255347,0,8,-1,4,0,0,14,23911),
(147721,255347,0,8,-1,4,0,0,14,23911),
(147398,255347,0,8,-1,4,0,0,14,23911),
(147399,255347,0,8,-1,4,0,0,14,23911),
(147400,255347,0,8,-1,4,0,0,14,23911),
(147401,255347,0,8,-1,4,0,0,14,23911),
(147402,255347,0,8,-1,4,0,0,14,23911),
(147403,255347,0,8,-1,4,0,0,14,23911),
(147404,255347,0,8,-1,4,0,0,14,23911),
(147405,255347,0,8,-1,4,0,0,14,23911),
(147406,255347,0,8,-1,4,0,0,14,23911),
(147407,255347,0,8,-1,4,0,0,14,23911),
(147408,255347,0,8,-1,4,0,0,14,23911),
(147409,255347,0,8,-1,4,0,0,14,23911),
(147548,255347,0,8,-1,4,0,0,14,23911),
(147549,255347,0,8,-1,4,0,0,14,23911),
(147550,255347,0,8,-1,4,0,0,14,23911),
(147551,255347,0,8,-1,4,0,0,14,23911),
(147808,255345,0,8,-1,4,0,0,14,23911),
(147809,255345,0,8,-1,4,0,0,14,23911),
(147810,255345,0,8,-1,4,0,0,14,23911),
(147811,255346,0,8,-1,4,0,0,14,23911),
(147812,255346,0,8,-1,4,0,0,14,23911),
(147814,255346,0,8,-1,4,0,0,14,23911),
(147818,255347,0,8,-1,4,0,0,14,23911),
(147819,255347,0,8,-1,4,0,0,14,23911),
(147212,391126,0,8,-1,7,0,0,7,23911),
(147213,323419,0,8,-1,7,0,0,7,23911),
(147214,309793,0,8,-1,7,0,0,7,23911),
(147215,947377,0,8,-1,7,0,0,7,23911),
(147216,457922,0,8,-1,7,0,0,7,23911),
(147217,309802,0,8,-1,7,0,0,7,23911),
(147218,366048,0,8,-1,7,0,0,7,23911),
(147219,359725,0,8,-1,7,0,0,7,23911),
(147220,1391731,0,8,-1,3,0,0,14,23911),
(147221,1360024,0,8,-1,3,0,0,14,23911),
(147222,1029326,0,8,-1,7,0,0,7,23911),
(147223,1120357,0,8,-1,3,0,0,14,23911),
(147786,391126,0,8,-1,7,0,0,7,23911),
(147791,359725,0,8,-1,7,0,0,7,23911),
(147792,309793,0,8,-1,7,0,0,7,23911),
(147793,323419,0,8,-1,7,0,0,7,23911),
(147794,1029326,0,8,-1,7,0,0,7,23911),
(147795,947377,0,8,-1,7,0,0,7,23911),
(147796,457922,0,8,-1,7,0,0,7,23911),
(147797,309802,0,8,-1,7,0,0,7,23911),
(147798,1360024,0,8,-1,7,0,0,7,23911),
(147799,1391731,0,8,-1,7,0,0,7,23911),
(147800,366048,0,8,-1,7,0,0,7,23911),
(147801,1120357,0,8,-1,7,0,0,7,23911),
(147837,134903,0,8,-1,7,0,0,7,23911),
(141376,0,2,8,-1,1,17,1,9,23911),
(141377,0,2,7,-1,1,13,3,8,23911),
(141378,0,2,7,-1,1,13,3,8,23911),
(141379,0,2,7,-1,1,13,3,8,23911),
(141380,0,2,7,-1,1,13,3,8,23911),
(141381,0,2,1,-1,1,17,1,9,23911),
(141382,0,2,1,-1,1,17,1,9,23911),
(141653,0,2,5,-1,1,17,1,9,23911),
(141362,0,2,7,-1,1,13,3,8,23911),
(141363,0,2,7,-1,1,13,3,8,23911),
(141364,0,2,8,-1,1,17,1,9,23911),
(141365,0,2,1,-1,1,17,1,9,23911),
(141366,0,2,6,-1,1,17,1,9,23911),
(141367,0,2,4,-1,1,13,3,8,23911),
(141368,0,2,5,-1,1,17,1,9,23911),
(141370,0,4,6,-1,1,14,4,9,23911),
(141654,0,4,6,-1,1,14,4,9,23911),
(141373,0,2,6,-1,1,17,1,9,23911),
(141374,0,2,6,-1,1,17,1,9,23911),
(141375,0,2,8,-1,1,17,1,9,23911),
(139712,0,4,3,-1,5,3,0,10,23911),
(139744,0,4,2,-1,8,3,0,7,23911),
(139768,0,4,1,-1,7,3,0,7,23911),
(139686,0,4,4,-1,6,3,0,11,23911),
(139720,0,4,2,-1,8,3,0,7,23911),
(139695,0,4,4,-1,6,3,0,11,23911),
(139728,0,4,2,-1,8,3,0,7,23911),
(139752,0,4,1,-1,7,3,0,7,23911),
(139760,0,4,1,-1,7,3,0,7,23911),
(139703,0,4,3,-1,5,3,0,10,23911),
(139736,0,4,2,-1,8,3,0,7,23911),
(139678,0,4,4,-1,6,3,0,11,23911),
(141968,136213,0,8,-1,3,0,0,24,23911),
(141964,135812,0,8,-1,3,0,0,24,23911),
(141965,136197,0,8,-1,3,0,0,24,23911),
(141966,136217,0,8,-1,3,0,0,24,23911),
(141967,136201,0,8,-1,3,0,0,24,23911),
(140256,132814,0,5,-1,3,0,0,17,23911),
(140288,512902,0,5,-1,3,0,0,17,23911),
(140290,132830,0,5,-1,3,0,0,17,23911),
(140291,132803,0,5,-1,3,0,0,17,23911),
(140292,132812,0,5,-1,3,0,0,17,23911),
(140293,132621,0,0,-1,3,0,0,17,23911),
(140289,132821,0,5,-1,3,0,0,17,23911),
(140295,132807,0,5,-1,3,0,0,17,23911),
(140253,839394,0,5,-1,3,0,0,17,23911),
(140287,132804,0,5,-1,3,0,0,17,23911),
(160000,135724,4,5,-1,1,4,0,9,0),
(160001,135724,4,5,-1,1,4,0,9,0),
(160002,0,4,5,-1,1,4,0,9,0),
(160003,0,4,5,-1,1,4,0,9,0),
(160004,0,4,5,-1,1,4,0,9,0),
(160005,0,4,5,-1,1,4,0,9,0),
(160006,0,4,5,-1,1,4,0,9,0),
(160007,0,4,5,-1,1,4,0,9,0),
(160008,0,4,5,-1,1,4,0,9,0),
(160009,0,4,5,-1,1,4,0,9,0),
(160011,0,4,5,-1,1,4,0,9,0),
(160020,0,2,7,-1,1,13,1,9,0),
(160012,0,2,8,-1,1,17,1,9,0),
(160013,0,2,8,-1,1,17,1,9,0),
(160014,0,2,7,-1,1,13,1,9,0),
(160015,0,4,5,-1,1,3,0,9,0),
(160016,0,4,6,-1,1,14,4,9,0),
(160017,0,4,5,-1,1,5,0,9,0),
(160018,0,2,8,-1,1,17,1,9,0),
(160019,0,2,7,-1,1,13,1,9,0),
(160021,135724,4,5,-1,1,4,0,9,0),
(160022,0,2,7,-1,1,13,1,9,0),
(160023,0,2,7,-1,1,13,1,9,0),
(160024,0,4,5,-1,1,10,0,9,0),
(160025,0,4,5,-1,1,7,0,9,0),
(160026,135724,4,5,-1,1,19,0,9,0),
(160027,0,2,7,-1,1,13,3,9,0),
(160028,0,2,7,-1,1,13,1,9,0),
(160029,0,2,7,-1,1,13,1,9,0),
(160030,0,2,8,-1,1,17,1,9,0),
(160031,0,2,8,-1,1,17,1,9,0),
(160032,135724,4,5,-1,1,19,0,9,0),
(160033,0,4,5,-1,1,5,0,9,0),
(160034,0,2,7,-1,1,13,3,9,0),
(160035,135724,4,5,-1,1,19,0,9,0),
(160036,0,4,5,-1,1,1,0,9,0),
(160037,0,4,5,-1,1,3,0,9,0),
(166000,0,4,0,-1,1,19,0,9,0),
(160038,0,4,6,-1,1,14,0,9,0),
(166001,0,4,1,-1,1,4,0,9,0),
(166002,0,4,0,-1,1,19,0,9,0),
(166003,0,4,1,-1,1,4,0,9,0),
(166004,0,4,0,-1,1,19,0,9,0),
(166005,0,4,1,-1,1,4,0,9,0),
(160039,0,2,2,-1,1,15,2,9,0),
(160040,0,4,5,-1,1,3,0,9,0),
(160041,0,4,5,-1,1,1,0,9,0),
(160042,0,4,5,-1,1,10,0,9,0),
(160043,0,2,10,-1,1,17,2,9,0),
(160044,0,4,5,-1,1,1,0,9,0),
(160045,0,4,5,-1,1,3,0,9,0),
(160046,0,2,7,-1,1,13,0,9,0),
(160047,0,4,5,-1,1,9,0,9,0),
(128340,133306,12,0,-1,0,0,0,14,23911),
(160048,0,2,7,-1,1,13,0,9,0),
(160049,236279,4,5,-1,1,4,0,9,0),
(160050,134613,4,5,-1,1,7,0,9,0),
(160051,1581162,4,5,-1,1,7,0,9,0),
(160052,1581160,4,5,-1,1,10,0,9,0),
(160053,236279,4,5,-1,1,4,0,9,0),
(160054,0,4,7,-1,1,22,2,9,0),
(160055,0,4,7,-1,1,22,2,9,0),
(160056,132679,4,5,-1,1,5,0,9,0),
(160057,1512752,4,5,-1,1,1,0,9,0),
(166006,0,4,0,-1,1,19,0,9,0),
(166007,0,4,1,-1,1,4,0,9,0),
(160058,135349,2,8,-1,1,17,1,9,0),
(160059,135349,2,7,-1,1,13,1,9,0),
(160060,389199,4,7,-1,1,22,6,9,0),
(101538,348554,13,0,-1,0,0,0,17,-1),
(166008,349114,1,0,-1,0,18,0,17,23911),
(160061,1692685,2,7,-1,1,13,2,9,0),
(160062,1692685,2,8,-1,1,17,2,9,0),
(160063,1600299,2,8,-1,1,17,1,9,0),
(160064,1692685,2,8,-1,1,17,2,9,0),
(160065,1600299,2,8,-1,1,17,1,9,0),
(160066,1728724,4,5,-1,1,5,0,9,0),
(160067,1692685,2,13,-1,1,13,2,9,0),
(160068,132667,4,5,-1,1,5,0,9,0),
(160069,135603,2,7,-1,1,13,0,9,0),
(160070,132645,4,5,-1,1,5,0,9,0),
(160071,135724,4,5,-1,1,19,0,9,0),
(160072,1692685,2,10,-1,1,17,2,9,0),
(160073,1726412,4,5,-1,1,5,0,9,0),
(160074,132742,4,5,-1,1,5,0,9,0),
(160075,134585,4,5,-1,1,7,0,9,0),
(160076,135724,4,5,-1,1,19,0,9,0),
(166500,979574,15,4,-1,0,0,0,17,23911),
(166501,357813,4,5,-1,0,1,0,17,23911),
(166502,357813,4,5,-1,0,1,0,17,23911),
(166503,357813,4,5,-1,0,1,0,17,23911),
(166504,357813,4,5,-1,0,1,0,17,23911),
(166505,357813,4,5,-1,0,1,0,17,23911),
(166506,133649,15,0,-1,0,0,0,17,23911),
(166507,237379,13,0,-1,0,0,0,17,23911),
(166508,237379,13,0,-1,0,0,0,17,23911),
(166509,1418621,13,0,-1,0,0,0,17,23911),
(166510,1418621,13,0,-1,0,0,0,17,23911),
(166511,1418621,13,0,-1,0,0,0,17,23911),
(166512,1418621,13,0,-1,0,0,0,17,23911),
(166513,1418621,13,0,-1,0,0,0,17,23911),
(166514,1418621,13,0,-1,0,0,0,17,23911),
(166515,1418621,13,0,-1,0,0,0,17,23911),
(166516,1418621,13,0,-1,0,0,0,17,23911),
(166517,1418621,13,0,-1,0,0,0,17,23911),
(166518,1418621,13,0,-1,0,0,0,17,23911),
(166519,1418621,13,0,-1,0,0,0,17,23911),
(166520,1418621,13,0,-1,0,0,0,17,23911),
(166521,135724,4,0,-1,0,19,0,17,23911),
(166522,135724,4,1,-1,0,4,0,17,23911),
(166523,135724,4,0,-1,0,19,0,17,23911),
(166524,135724,4,1,-1,0,4,0,17,23911),
(166525,135731,15,4,-1,0,0,0,17,23911),
(166526,135731,15,4,-1,0,0,0,17,23911),
(166527,133785,15,4,-1,0,0,0,17,23911),
(166528,133785,15,4,-1,0,0,0,17,23911),
(166529,236700,15,4,-1,0,0,0,17,23911),
(166530,236700,15,4,-1,0,0,0,17,23911),
(166531,413587,15,4,-1,0,0,0,17,23911),
(160077,1544254,4,5,-1,1,1,0,9,0),
(160078,135496,2,2,-1,2,15,4,12,0),
(160079,135022,4,5,-1,1,5,0,9,0),
(160080,134581,4,5,-1,1,7,0,9,0),
(160081,132539,4,5,-1,1,8,0,9,0),
(166532,135724,4,0,-1,0,19,0,17,23911),
(166533,135724,4,1,-1,0,4,0,17,23911),
(166534,1418621,13,0,-1,0,0,0,17,23911),
(166535,1418621,13,0,-1,0,0,0,17,23911),
(166536,1535371,15,4,-1,0,0,0,17,23911),
(160082,1600299,2,7,-1,1,13,1,9,0),
(160083,1658610,4,5,-1,1,1,0,9,0),
(160084,135496,2,2,-1,1,17,1,9,0),
(166537,236266,12,0,-1,0,0,0,17,23911),
(166538,255347,12,0,-1,0,0,0,17,23911),
(166009,349114,1,0,-1,0,18,0,17,23911),
(166539,237540,4,0,-1,0,19,0,17,23911),
(166540,237540,4,1,-1,0,4,0,17,23911),
(166542,1394948,15,4,-1,0,0,0,17,23911),
(166543,524050,13,0,-1,0,0,0,17,23911),
(166010,1029751,1,0,-1,0,18,0,17,23911),
(166011,133646,1,0,-1,0,18,0,17,23911),
(166012,133647,1,0,-1,0,18,0,17,23911),
(228700,133974,0,5,127,0,0,0,15,0);

/*Table structure for table `item_appearance` */

DROP TABLE IF EXISTS `item_appearance`;

CREATE TABLE `item_appearance` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ItemDisplayInfoID` int(11) NOT NULL DEFAULT '0',
  `DefaultIconFileDataID` int(11) NOT NULL DEFAULT '0',
  `UiOrder` int(11) NOT NULL DEFAULT '0',
  `DisplayType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_appearance` */

insert  into `item_appearance`(`ID`,`ItemDisplayInfoID`,`DefaultIconFileDataID`,`UiOrder`,`DisplayType`,`VerifiedBuild`) values 
(65535,224,135724,2526900,11,0),
(65534,224,135724,2526900,11,0),
(65533,224,135724,2526900,11,0),
(65532,224,135724,2526900,11,0),
(65531,224,135724,2526900,11,0),
(65530,224,135724,2526900,11,0),
(65529,224,135724,2526900,11,0),
(65528,224,135724,2526900,11,0),
(65527,224,135724,2526900,11,0),
(65526,224,135724,2526900,11,0),
(65524,224,0,2526900,11,0),
(65522,46609,135402,2526900,11,0),
(65521,58617,135370,2526900,11,0),
(65520,143118,1112519,2526900,11,0),
(65519,109128,591939,2526900,11,0),
(65523,140736,1062744,2526900,11,0),
(65518,137270,1027788,2526900,11,0),
(65517,17671,132743,2526900,11,0),
(65516,153970,135349,2526900,11,0),
(65515,64030,135358,2526900,11,0),
(65514,64073,135289,2526900,11,0),
(65513,224,135724,2526900,11,0),
(65511,153970,135349,2526900,11,0),
(65510,58617,135370,2526900,11,0),
(65509,44286,135028,2526900,11,0),
(65508,20405,134589,2526900,11,0),
(65507,224,135724,2526900,11,0),
(65506,58617,135370,2526900,11,0),
(65505,45146,132395,2526900,11,0),
(65504,45150,132395,2526900,11,0),
(65503,137512,1030156,2526900,11,0),
(65502,137509,1030156,2526900,11,0),
(65501,224,135724,2526900,11,0),
(65500,30675,132746,2526900,11,0),
(65499,61655,253399,2526900,11,0),
(65498,224,135724,2526900,11,0),
(65497,161645,1581161,2526900,11,0),
(65496,161644,1581163,2526900,11,0),
(63000,31434,134154,2526900,11,0),
(65495,137270,1027788,2526900,11,0),
(63001,31434,134154,2526900,11,0),
(63002,26551,461790,2526900,11,0),
(63003,26551,461790,2526900,11,0),
(63004,26551,514340,2526900,11,0),
(63005,26551,514340,2526900,11,0),
(65494,43383,135501,2526900,11,0),
(65493,159728,1581056,2526900,11,0),
(65492,159726,1581054,2526900,11,0),
(65491,159725,1581053,2526900,11,0),
(65490,99788,523897,2526900,11,0),
(65489,97238,133081,2526900,11,0),
(65488,43004,135066,2526900,11,0),
(65487,44850,132395,2526900,11,0),
(65486,42996,132612,2526900,11,0),
(63010,133306,0,2526900,11,0),
(65485,144269,389199,2526900,11,0),
(65484,224,236279,2526900,11,0),
(65483,29744,134613,2526900,11,0),
(65482,158626,1581162,2526900,11,0),
(65481,158615,1581160,2526900,11,0),
(65480,224,236279,2526900,11,0),
(65479,99788,523897,2526900,11,0),
(65478,35632,135226,2526900,11,0),
(65477,117230,132679,2526900,11,0),
(65476,161643,1512752,2526900,11,0),
(63006,26551,514340,2526900,11,0),
(63007,26551,514340,2526900,11,0),
(65475,30606,135349,2526900,11,0),
(65474,30606,135349,2526900,11,0),
(65473,144269,389199,2526900,11,0),
(63100,348554,0,2526900,11,0),
(56008,349114,0,2526900,11,0),
(65472,166774,1692685,2526900,11,0),
(65471,166774,1692685,2526900,11,0),
(65470,164948,1600299,2526900,11,0),
(65469,166470,1692685,2526900,11,0),
(65468,164948,1600299,2526900,11,0),
(65467,165414,1728724,2526900,11,0),
(65466,166774,1692685,2526900,11,0),
(65465,34294,132667,2526900,11,0),
(65464,117746,135603,2526900,11,0),
(65463,30824,132645,2526900,11,0),
(65462,224,135724,2526900,11,0),
(65461,166774,1692685,2526900,11,0),
(65460,165333,1726412,2526900,11,0),
(65459,26795,132742,2526900,11,0),
(65458,26800,134585,2526900,11,0),
(65457,224,135724,2526900,11,0),
(40000,979574,0,2526900,11,0),
(40001,111086,0,1281600,0,0),
(40002,70798,0,2526900,11,0),
(40003,45944,0,2526900,11,0),
(40004,28268,0,2526900,11,0),
(40005,102457,0,2526900,11,0),
(40006,133649,0,2526900,11,0),
(40007,237379,0,2526900,11,0),
(40008,237379,0,2526900,11,0),
(40009,1418621,0,2526900,11,0),
(40010,1418621,0,2526900,11,0),
(40011,1418621,0,2526900,11,0),
(40012,1418621,0,2526900,11,0),
(40013,1418621,0,2526900,11,0),
(40014,1418621,0,2526900,11,0),
(40015,1418621,0,2526900,11,0),
(40016,1418621,0,2526900,11,0),
(40017,1418621,0,2526900,11,0),
(40018,1418621,0,2526900,11,0),
(40019,1418621,0,2526900,11,0),
(40020,1418621,0,2526900,11,0),
(40021,135724,0,2526900,11,0),
(40022,135724,0,2526900,11,0),
(40023,135724,0,2526900,11,0),
(40024,135724,0,2526900,11,0),
(40025,135731,0,2526900,11,0),
(40026,135731,0,2526900,11,0),
(40027,133785,0,2526900,11,0),
(40028,133785,0,2526900,11,0),
(40029,236700,0,2526900,11,0),
(40030,236700,0,2526900,11,0),
(40031,413587,0,2526900,11,0),
(65456,159773,1544254,2526900,11,0),
(65455,11646,135022,2526900,11,0),
(65454,11308,134581,2526900,11,0),
(65453,11782,132539,2526900,11,0),
(40032,135724,0,2526900,11,0),
(40033,135724,0,2526900,11,0),
(40034,1418621,0,2526900,11,0),
(40035,1418621,0,2526900,11,0),
(40036,1535371,0,2526900,11,0),
(65452,164948,1600299,2526900,11,0),
(65451,161830,1658610,2526900,11,0),
(65450,145875,135496,2526900,11,0),
(40037,236266,0,2526900,11,0),
(40038,255347,0,2526900,11,0),
(56009,349114,0,2526900,11,0),
(40039,237540,0,2526900,11,0),
(40040,237540,0,2526900,11,0),
(40042,1394948,0,2526900,11,0),
(40043,524050,0,2526900,11,0),
(56010,1029751,0,2526900,11,0),
(56011,133646,0,2526900,11,0),
(56012,133647,0,2526900,11,0),
(29602,133785,0,2526900,11,0);

/*Table structure for table `item_appearance_x_ui_camera` */

DROP TABLE IF EXISTS `item_appearance_x_ui_camera`;

CREATE TABLE `item_appearance_x_ui_camera` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ItemAppearanceID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `UiCameraID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_appearance_x_ui_camera` */

/*Table structure for table `item_armor_quality` */

DROP TABLE IF EXISTS `item_armor_quality`;

CREATE TABLE `item_armor_quality` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Qualitymod1` float NOT NULL DEFAULT '0',
  `Qualitymod2` float NOT NULL DEFAULT '0',
  `Qualitymod3` float NOT NULL DEFAULT '0',
  `Qualitymod4` float NOT NULL DEFAULT '0',
  `Qualitymod5` float NOT NULL DEFAULT '0',
  `Qualitymod6` float NOT NULL DEFAULT '0',
  `Qualitymod7` float NOT NULL DEFAULT '0',
  `ItemLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_armor_quality` */

/*Table structure for table `item_armor_shield` */

DROP TABLE IF EXISTS `item_armor_shield`;

CREATE TABLE `item_armor_shield` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Quality1` float NOT NULL DEFAULT '0',
  `Quality2` float NOT NULL DEFAULT '0',
  `Quality3` float NOT NULL DEFAULT '0',
  `Quality4` float NOT NULL DEFAULT '0',
  `Quality5` float NOT NULL DEFAULT '0',
  `Quality6` float NOT NULL DEFAULT '0',
  `Quality7` float NOT NULL DEFAULT '0',
  `ItemLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_armor_shield` */

/*Table structure for table `item_armor_total` */

DROP TABLE IF EXISTS `item_armor_total`;

CREATE TABLE `item_armor_total` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Cloth` float NOT NULL DEFAULT '0',
  `Leather` float NOT NULL DEFAULT '0',
  `Mail` float NOT NULL DEFAULT '0',
  `Plate` float NOT NULL DEFAULT '0',
  `ItemLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_armor_total` */

/*Table structure for table `item_bag_family` */

DROP TABLE IF EXISTS `item_bag_family`;

CREATE TABLE `item_bag_family` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_bag_family` */

/*Table structure for table `item_bag_family_locale` */

DROP TABLE IF EXISTS `item_bag_family_locale`;

CREATE TABLE `item_bag_family_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_bag_family_locale` */

/*Table structure for table `item_bonus` */

DROP TABLE IF EXISTS `item_bonus`;

CREATE TABLE `item_bonus` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Value1` int(11) NOT NULL DEFAULT '0',
  `Value2` int(11) NOT NULL DEFAULT '0',
  `Value3` int(11) NOT NULL DEFAULT '0',
  `ParentItemBonusListID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_bonus` */

/*Table structure for table `item_bonus_list_level_delta` */

DROP TABLE IF EXISTS `item_bonus_list_level_delta`;

CREATE TABLE `item_bonus_list_level_delta` (
  `ItemLevelDelta` smallint(6) NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_bonus_list_level_delta` */

/*Table structure for table `item_bonus_tree_node` */

DROP TABLE IF EXISTS `item_bonus_tree_node`;

CREATE TABLE `item_bonus_tree_node` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ChildItemBonusTreeID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ChildItemBonusListID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ChildItemLevelSelectorID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemContext` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `BonusTreeID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_bonus_tree_node` */

insert  into `item_bonus_tree_node`(`ID`,`ChildItemBonusTreeID`,`ChildItemBonusListID`,`ChildItemLevelSelectorID`,`ItemContext`,`BonusTreeID`,`VerifiedBuild`) values 
(1834,0,3408,0,13,524,26124);

/*Table structure for table `item_child_equipment` */

DROP TABLE IF EXISTS `item_child_equipment`;

CREATE TABLE `item_child_equipment` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ChildItemID` int(11) NOT NULL DEFAULT '0',
  `ChildItemEquipSlot` tinyint(4) NOT NULL DEFAULT '0',
  `ItemID` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_child_equipment` */

/*Table structure for table `item_class` */

DROP TABLE IF EXISTS `item_class`;

CREATE TABLE `item_class` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ClassName` text,
  `PriceModifier` float NOT NULL DEFAULT '0',
  `OldEnumValue` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Class` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_class` */

/*Table structure for table `item_class_locale` */

DROP TABLE IF EXISTS `item_class_locale`;

CREATE TABLE `item_class_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `ClassName_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_class_locale` */

/*Table structure for table `item_currency_cost` */

DROP TABLE IF EXISTS `item_currency_cost`;

CREATE TABLE `item_currency_cost` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ItemID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_currency_cost` */

/*Table structure for table `item_damage_ammo` */

DROP TABLE IF EXISTS `item_damage_ammo`;

CREATE TABLE `item_damage_ammo` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Quality1` float NOT NULL DEFAULT '0',
  `Quality2` float NOT NULL DEFAULT '0',
  `Quality3` float NOT NULL DEFAULT '0',
  `Quality4` float NOT NULL DEFAULT '0',
  `Quality5` float NOT NULL DEFAULT '0',
  `Quality6` float NOT NULL DEFAULT '0',
  `Quality7` float NOT NULL DEFAULT '0',
  `ItemLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_damage_ammo` */

/*Table structure for table `item_damage_one_hand` */

DROP TABLE IF EXISTS `item_damage_one_hand`;

CREATE TABLE `item_damage_one_hand` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Quality1` float NOT NULL DEFAULT '0',
  `Quality2` float NOT NULL DEFAULT '0',
  `Quality3` float NOT NULL DEFAULT '0',
  `Quality4` float NOT NULL DEFAULT '0',
  `Quality5` float NOT NULL DEFAULT '0',
  `Quality6` float NOT NULL DEFAULT '0',
  `Quality7` float NOT NULL DEFAULT '0',
  `ItemLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_damage_one_hand` */

/*Table structure for table `item_damage_one_hand_caster` */

DROP TABLE IF EXISTS `item_damage_one_hand_caster`;

CREATE TABLE `item_damage_one_hand_caster` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Quality1` float NOT NULL DEFAULT '0',
  `Quality2` float NOT NULL DEFAULT '0',
  `Quality3` float NOT NULL DEFAULT '0',
  `Quality4` float NOT NULL DEFAULT '0',
  `Quality5` float NOT NULL DEFAULT '0',
  `Quality6` float NOT NULL DEFAULT '0',
  `Quality7` float NOT NULL DEFAULT '0',
  `ItemLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_damage_one_hand_caster` */

/*Table structure for table `item_damage_two_hand` */

DROP TABLE IF EXISTS `item_damage_two_hand`;

CREATE TABLE `item_damage_two_hand` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Quality1` float NOT NULL DEFAULT '0',
  `Quality2` float NOT NULL DEFAULT '0',
  `Quality3` float NOT NULL DEFAULT '0',
  `Quality4` float NOT NULL DEFAULT '0',
  `Quality5` float NOT NULL DEFAULT '0',
  `Quality6` float NOT NULL DEFAULT '0',
  `Quality7` float NOT NULL DEFAULT '0',
  `ItemLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_damage_two_hand` */

/*Table structure for table `item_damage_two_hand_caster` */

DROP TABLE IF EXISTS `item_damage_two_hand_caster`;

CREATE TABLE `item_damage_two_hand_caster` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Quality1` float NOT NULL DEFAULT '0',
  `Quality2` float NOT NULL DEFAULT '0',
  `Quality3` float NOT NULL DEFAULT '0',
  `Quality4` float NOT NULL DEFAULT '0',
  `Quality5` float NOT NULL DEFAULT '0',
  `Quality6` float NOT NULL DEFAULT '0',
  `Quality7` float NOT NULL DEFAULT '0',
  `ItemLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_damage_two_hand_caster` */

/*Table structure for table `item_disenchant_loot` */

DROP TABLE IF EXISTS `item_disenchant_loot`;

CREATE TABLE `item_disenchant_loot` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `MinLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MaxLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SkillRequired` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Subclass` tinyint(4) NOT NULL DEFAULT '0',
  `Quality` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ExpansionID` tinyint(4) NOT NULL DEFAULT '0',
  `ItemClass` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_disenchant_loot` */

/*Table structure for table `item_display_info` */

DROP TABLE IF EXISTS `item_display_info`;

CREATE TABLE `item_display_info` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `ItemRangedDisplayInfoID` int(11) NOT NULL DEFAULT '0',
  `ItemVisual` int(11) NOT NULL DEFAULT '0',
  `ParticleColorID` int(11) NOT NULL DEFAULT '0',
  `OverrideSwooshSoundKitID` int(11) NOT NULL DEFAULT '0',
  `SheatheTransformMatrixID` int(11) NOT NULL DEFAULT '0',
  `ModelType1` int(11) NOT NULL DEFAULT '0',
  `StateSpellVisualKitID` int(11) NOT NULL DEFAULT '0',
  `SheathedSpellVisualKitID` int(11) NOT NULL DEFAULT '0',
  `UnsheathedSpellVisualKitID` int(11) NOT NULL DEFAULT '0',
  `ModelResourcesID1` int(11) NOT NULL DEFAULT '0',
  `ModelResourcesID2` int(11) NOT NULL DEFAULT '0',
  `ModelMaterialResourcesID1` int(11) NOT NULL DEFAULT '0',
  `ModelMaterialResourcesID2` int(11) NOT NULL DEFAULT '0',
  `GeosetGroup1` int(11) NOT NULL DEFAULT '0',
  `GeosetGroup2` int(11) NOT NULL DEFAULT '0',
  `GeosetGroup3` int(11) NOT NULL DEFAULT '0',
  `GeosetGroup4` int(11) NOT NULL DEFAULT '0',
  `AttachmentGeosetGroup1` int(11) NOT NULL DEFAULT '0',
  `AttachmentGeosetGroup2` int(11) NOT NULL DEFAULT '0',
  `AttachmentGeosetGroup3` int(11) NOT NULL DEFAULT '0',
  `AttachmentGeosetGroup4` int(11) NOT NULL DEFAULT '0',
  `HelmetGeosetVis1` int(11) NOT NULL DEFAULT '0',
  `HelmetGeosetVis2` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_display_info` */

/*Table structure for table `item_display_info_material_res` */

DROP TABLE IF EXISTS `item_display_info_material_res`;

CREATE TABLE `item_display_info_material_res` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `MaterialResourcesID` int(11) NOT NULL DEFAULT '0',
  `ComponentSection` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_display_info_material_res` */

/*Table structure for table `item_display_x_ui_camera` */

DROP TABLE IF EXISTS `item_display_x_ui_camera`;

CREATE TABLE `item_display_x_ui_camera` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ItemDisplayInfoID` int(11) NOT NULL DEFAULT '0',
  `UiCameraID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_display_x_ui_camera` */

/*Table structure for table `item_effect` */

DROP TABLE IF EXISTS `item_effect`;

CREATE TABLE `item_effect` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `CoolDownMSec` int(11) NOT NULL DEFAULT '0',
  `CategoryCoolDownMSec` int(11) NOT NULL DEFAULT '0',
  `Charges` smallint(6) NOT NULL DEFAULT '0',
  `SpellCategoryID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ChrSpecializationID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LegacySlotIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TriggerType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ItemID` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_effect` */

insert  into `item_effect`(`ID`,`SpellID`,`CoolDownMSec`,`CategoryCoolDownMSec`,`Charges`,`SpellCategoryID`,`ChrSpecializationID`,`LegacySlotIndex`,`TriggerType`,`ItemID`,`VerifiedBuild`) values 
(35001,89733,-1,-1,0,0,0,0,1,160000,0),
(35002,89733,-1,-1,0,0,0,1,0,160000,0),
(35003,147375,-1,-1,0,0,0,0,1,160001,0),
(35004,147375,-1,-1,0,0,0,1,0,160001,0),
(35005,147376,-1,-1,0,0,0,0,1,160002,0),
(35006,147376,-1,-1,0,0,0,1,0,160002,0),
(35007,147377,-1,-1,0,0,0,0,1,160003,0),
(35008,147377,-1,-1,0,0,0,1,0,160003,0),
(35009,147378,-1,-1,0,0,0,0,1,160004,0),
(35010,147378,-1,-1,0,0,0,1,0,160004,0),
(35011,72521,-1,-1,0,0,0,0,1,160005,0),
(35012,48083,-1,-1,0,0,0,0,1,160006,0),
(35013,48083,-1,-1,0,0,0,1,0,160006,0),
(37007,305015,-1,-1,0,0,0,1,5,133738,0),
(37006,305015,-1,-1,0,0,0,1,5,139665,0),
(35016,114302,-1,-1,0,0,0,0,1,160007,0),
(35017,114302,-1,-1,0,0,0,1,0,160007,0),
(35018,48795,-1,-1,0,0,0,0,1,160008,0),
(35019,72523,-1,-1,0,0,0,0,1,160009,0),
(35020,72523,-1,-1,0,0,0,1,0,160009,0),
(35023,70544,-1,-1,0,0,0,0,1,160011,0),
(35024,70544,-1,-1,0,0,0,1,0,160011,0),
(35025,62011,-1,-1,0,0,0,0,1,160021,0),
(35026,62011,-1,-1,0,0,0,1,0,160021,0),
(35027,223143,-1,-1,0,0,0,0,1,160026,0),
(35028,223143,-1,-1,0,0,0,1,0,160026,0),
(35029,89733,-1,-1,0,0,0,0,1,160032,0),
(35030,89733,-1,-1,0,0,0,1,0,160032,0),
(37001,305006,-1,-1,0,0,0,0,1,166001,0),
(37000,305006,-1,-1,0,0,0,0,1,166000,0),
(35032,54717,-1,-1,0,0,0,1,0,160035,0),
(35031,54717,-1,-1,0,0,0,0,1,160035,0),
(37002,305008,-1,-1,0,0,0,0,1,166002,0),
(37003,305008,-1,-1,0,0,0,0,1,166003,0),
(37004,305009,-1,-1,0,0,0,0,1,166004,0),
(37005,305009,-1,-1,0,0,0,0,1,166005,0),
(35033,50771,-1,-1,0,0,0,0,1,160049,0),
(35034,50771,-1,-1,0,0,0,1,0,160049,0),
(35197,246747,-1,-1,-1,0,0,0,0,151423,0),
(35035,234034,-1,-1,0,0,0,0,1,160053,0),
(35036,234034,-1,-1,0,0,0,1,0,160053,0),
(37008,305082,-1,-1,0,0,0,0,1,166006,0),
(37009,305082,-1,-1,0,0,0,0,1,166007,0),
(18216,148551,-1,0,0,0,0,1,6,104166,0),
(17735,144528,1500,1500,-1,133,0,0,0,101538,0),
(35037,71986,-1,-1,0,0,0,0,1,160071,0),
(35038,71986,-1,-1,0,0,0,1,0,160071,0),
(35039,137135,-1,-1,0,0,0,0,1,160076,0),
(35040,137135,-1,-1,0,0,0,1,0,160076,0),
(79000,305229,60000,-1,-1,0,0,0,0,166500,0),
(79001,3366,1500,-1,-1,0,0,0,0,166507,0),
(79002,3366,1500,-1,-1,0,0,0,0,166508,0),
(79009,305196,1500,-1,-1,0,0,0,0,166509,0),
(79010,305197,1500,-1,-1,0,0,0,0,166510,0),
(79011,305199,1500,-1,-1,0,0,0,0,166511,0),
(79012,305200,1500,-1,-1,0,0,0,0,166512,0),
(79013,305201,1500,-1,-1,0,0,0,0,166513,0),
(79014,305202,1500,-1,-1,0,0,0,0,166514,0),
(79015,305203,1500,-1,-1,0,0,0,0,166515,0),
(79016,305204,1500,-1,-1,0,0,0,0,166516,0),
(79017,305205,1500,-1,-1,0,0,0,0,166517,0),
(79018,305206,1500,-1,-1,0,0,0,0,166518,0),
(79019,305207,1500,-1,-1,0,0,0,0,166519,0),
(79020,305198,1500,-1,-1,0,0,0,0,166520,0),
(79021,305230,1500,-1,-1,0,0,0,1,166521,0),
(79022,305230,1500,-1,-1,0,0,0,1,166522,0),
(79023,305232,1500,-1,-1,0,0,0,1,166523,0),
(79024,305232,1500,-1,-1,0,0,0,1,166524,0),
(79025,305234,900000,-1,-3,0,0,0,0,166525,0),
(79026,305234,900000,-1,0,0,0,0,0,166526,0),
(79027,305235,900000,-1,-3,0,0,0,0,166527,0),
(79028,305235,900000,-1,0,0,0,0,0,166528,0),
(79029,305236,900000,-1,-3,0,0,0,0,166529,0),
(79030,305236,900000,-1,0,0,0,0,0,166530,0),
(79032,305285,1500,-1,-1,0,0,0,1,166532,0),
(79033,305285,1500,-1,-1,0,0,0,1,166533,0),
(79034,305287,1500,-1,-1,0,0,0,0,166534,0),
(79035,305289,1500,-1,-1,0,0,0,0,166535,0),
(79036,305290,10800000,-1,0,0,0,0,0,166536,0),
(79039,305299,1500,-1,-1,0,0,0,1,166539,0),
(79040,305299,1500,-1,-1,0,0,0,1,166540,0),
(79042,305302,60000,-1,-1,0,0,0,0,166542,0),
(79043,305305,1500,-1,-1,0,0,0,0,166543,0),
(116,434,0,1000,-1,59,0,0,0,228700,0);

/*Table structure for table `item_extended_cost` */

DROP TABLE IF EXISTS `item_extended_cost`;

CREATE TABLE `item_extended_cost` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ItemID1` int(11) NOT NULL DEFAULT '0',
  `ItemID2` int(11) NOT NULL DEFAULT '0',
  `ItemID3` int(11) NOT NULL DEFAULT '0',
  `ItemID4` int(11) NOT NULL DEFAULT '0',
  `ItemID5` int(11) NOT NULL DEFAULT '0',
  `CurrencyCount1` int(11) NOT NULL DEFAULT '0',
  `CurrencyCount2` int(11) NOT NULL DEFAULT '0',
  `CurrencyCount3` int(11) NOT NULL DEFAULT '0',
  `CurrencyCount4` int(11) NOT NULL DEFAULT '0',
  `CurrencyCount5` int(11) NOT NULL DEFAULT '0',
  `ItemCount1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemCount2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemCount3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemCount4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemCount5` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RequiredArenaRating` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CurrencyID1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CurrencyID2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CurrencyID3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CurrencyID4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CurrencyID5` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ArenaBracket` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MinFactionID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MinReputation` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RequiredAchievement` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_extended_cost` */

insert  into `item_extended_cost`(`ID`,`ItemID1`,`ItemID2`,`ItemID3`,`ItemID4`,`ItemID5`,`CurrencyCount1`,`CurrencyCount2`,`CurrencyCount3`,`CurrencyCount4`,`CurrencyCount5`,`ItemCount1`,`ItemCount2`,`ItemCount3`,`ItemCount4`,`ItemCount5`,`RequiredArenaRating`,`CurrencyID1`,`CurrencyID2`,`CurrencyID3`,`CurrencyID4`,`CurrencyID5`,`ArenaBracket`,`MinFactionID`,`MinReputation`,`Flags`,`RequiredAchievement`,`VerifiedBuild`) values 
(15000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),
(20001,137642,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),
(20002,137642,0,0,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),
(20003,137642,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),
(20004,137642,0,0,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),
(20005,137642,0,0,0,0,0,0,0,0,0,6,0,0,0,0,1750,0,0,0,0,0,0,0,0,0,0,0),
(20006,137642,0,0,0,0,0,0,0,0,0,6,0,0,0,0,1850,0,0,0,0,0,0,0,0,0,0,0),
(20007,137642,0,0,0,0,0,0,0,0,0,12,0,0,0,0,1750,0,0,0,0,0,0,0,0,0,0,0),
(20008,137642,0,0,0,0,0,0,0,0,0,18,0,0,0,0,2200,0,0,0,0,0,0,0,0,0,0,0),
(20009,137642,0,0,0,0,0,0,0,0,0,24,0,0,0,0,2400,0,0,0,0,0,0,0,0,0,0,0),
(20010,137642,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),
(20011,137642,0,0,0,0,0,0,0,0,0,50,0,0,0,0,1750,0,0,0,0,0,0,0,0,0,0,0),
(20012,137642,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),
(20013,137642,0,0,0,0,0,0,0,0,0,6,0,0,0,0,2200,0,0,0,0,0,0,0,0,0,0,0),
(20014,137642,0,0,0,0,0,0,0,0,0,12,0,0,0,0,2000,0,0,0,0,0,0,0,0,0,0,0),
(20015,137642,0,0,0,0,0,0,0,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),
(20016,137642,0,0,0,0,0,0,0,0,0,55,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),
(20017,137642,0,0,0,0,0,0,0,0,0,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),
(20018,137642,0,0,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),
(20019,137642,0,0,0,0,0,0,0,0,0,50,0,0,0,0,2000,0,0,0,0,0,1,0,0,0,0,0),
(25000,0,0,0,0,0,50,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25001,0,0,0,0,0,150,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25002,0,0,0,0,0,200,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25003,0,0,0,0,0,250,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25004,0,0,0,0,0,300,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25005,0,0,0,0,0,350,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25006,0,0,0,0,0,400,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25007,0,0,0,0,0,450,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25008,0,0,0,0,0,500,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25009,0,0,0,0,0,550,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25010,0,0,0,0,0,600,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25011,0,0,0,0,0,650,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25012,0,0,0,0,0,700,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25013,0,0,0,0,0,1500,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25014,0,0,0,0,0,2000,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25015,0,0,0,0,0,2200,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25016,0,0,0,0,0,2400,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25017,0,0,0,0,0,2500,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25018,0,0,0,0,0,3000,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25019,0,0,0,0,0,3200,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25020,0,0,0,0,0,3300,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25021,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25022,0,0,0,0,0,3800,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25023,0,0,0,0,0,4000,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25024,0,0,0,0,0,4500,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25025,0,0,0,0,0,5000,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25026,0,0,0,0,0,5500,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25027,0,0,0,0,0,6000,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25028,0,0,0,0,0,6500,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25029,0,0,0,0,0,7000,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25030,0,0,0,0,0,7500,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25031,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25032,0,0,0,0,0,80,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25033,0,0,0,0,0,2700,0,0,0,0,0,0,0,0,0,0,1160,0,0,0,0,0,0,0,0,0,0),
(25100,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1162,0,0,0,0,0,0,0,0,0,0),
(25101,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,1162,0,0,0,0,0,0,0,0,0,0),
(25102,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,1162,0,0,0,0,0,0,0,0,0,0),
(25103,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,1162,0,0,0,0,0,0,0,0,0,0),
(25104,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,1162,0,0,0,0,0,0,0,0,0,0),
(25105,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,1162,0,0,0,0,0,0,0,0,0,0),
(25106,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,1162,0,0,0,0,0,0,0,0,0,0),
(25107,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,1162,0,0,0,0,0,0,0,0,0,0),
(25108,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,1162,0,0,0,0,0,0,0,0,0,0),
(25109,0,0,0,0,0,10,0,0,0,0,0,0,0,0,0,0,1162,0,0,0,0,0,0,0,0,0,0),
(25110,0,0,0,0,0,11,0,0,0,0,0,0,0,0,0,0,1162,0,0,0,0,0,0,0,0,0,0),
(25111,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,1162,0,0,0,0,0,0,0,0,0,0),
(25112,0,0,0,0,0,13,0,0,0,0,0,0,0,0,0,0,1162,0,0,0,0,0,0,0,0,0,0),
(25113,0,0,0,0,0,14,0,0,0,0,0,0,0,0,0,0,1162,0,0,0,0,0,0,0,0,0,0),
(25114,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,1162,0,0,0,0,0,0,0,0,0,0),
(25115,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,1162,0,0,0,0,0,0,0,0,0,0),
(25116,0,0,0,0,0,17,0,0,0,0,0,0,0,0,0,0,1162,0,0,0,0,0,0,0,0,0,0),
(25117,0,0,0,0,0,18,0,0,0,0,0,0,0,0,0,0,1162,0,0,0,0,0,0,0,0,0,0),
(25118,0,0,0,0,0,19,0,0,0,0,0,0,0,0,0,0,1162,0,0,0,0,0,0,0,0,0,0),
(25119,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,1162,0,0,0,0,0,0,0,0,0,0),
(25120,0,0,0,0,0,21,0,0,0,0,0,0,0,0,0,0,1162,0,0,0,0,0,0,0,0,0,0),
(25121,0,0,0,0,0,22,0,0,0,0,0,0,0,0,0,0,1162,0,0,0,0,0,0,0,0,0,0),
(25250,166532,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),
(25251,166533,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);

/*Table structure for table `item_group_sounds` */

DROP TABLE IF EXISTS `item_group_sounds`;

CREATE TABLE `item_group_sounds` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Sound1` int(11) NOT NULL DEFAULT '0',
  `Sound2` int(11) NOT NULL DEFAULT '0',
  `Sound3` int(11) NOT NULL DEFAULT '0',
  `Sound4` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_group_sounds` */

/*Table structure for table `item_level_selector` */

DROP TABLE IF EXISTS `item_level_selector`;

CREATE TABLE `item_level_selector` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `MinItemLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemLevelSelectorQualitySetID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_level_selector` */

/*Table structure for table `item_level_selector_quality` */

DROP TABLE IF EXISTS `item_level_selector_quality`;

CREATE TABLE `item_level_selector_quality` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `QualityItemBonusListID` int(11) NOT NULL DEFAULT '0',
  `Quality` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ItemLevelSelectorQualitySetID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_level_selector_quality` */

/*Table structure for table `item_level_selector_quality_set` */

DROP TABLE IF EXISTS `item_level_selector_quality_set`;

CREATE TABLE `item_level_selector_quality_set` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `IlvlRare` smallint(5) unsigned NOT NULL DEFAULT '0',
  `IlvlEpic` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_level_selector_quality_set` */

/*Table structure for table `item_limit_category` */

DROP TABLE IF EXISTS `item_limit_category`;

CREATE TABLE `item_limit_category` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Quantity` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_limit_category` */

insert  into `item_limit_category`(`ID`,`Name`,`Quantity`,`Flags`,`VerifiedBuild`) values 
(365,'special item',1,1,0);

/*Table structure for table `item_limit_category_condition` */

DROP TABLE IF EXISTS `item_limit_category_condition`;

CREATE TABLE `item_limit_category_condition` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `AddQuantity` tinyint(4) NOT NULL DEFAULT '0',
  `PlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `ParentItemLimitCategoryID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_limit_category_condition` */

/*Table structure for table `item_limit_category_locale` */

DROP TABLE IF EXISTS `item_limit_category_locale`;

CREATE TABLE `item_limit_category_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_limit_category_locale` */

/*Table structure for table `item_modified_appearance` */

DROP TABLE IF EXISTS `item_modified_appearance`;

CREATE TABLE `item_modified_appearance` (
  `ItemID` int(11) NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `ItemAppearanceModifierID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ItemAppearanceID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TransmogSourceTypeEnum` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_modified_appearance` */

insert  into `item_modified_appearance`(`ItemID`,`ID`,`ItemAppearanceModifierID`,`ItemAppearanceID`,`OrderIndex`,`TransmogSourceTypeEnum`,`VerifiedBuild`) values 
(96867,51200,0,19927,0,0,23911),
(96868,51201,0,20125,0,0,23911),
(96869,51202,0,20127,0,0,23911),
(96870,51203,0,20128,0,0,23911),
(96871,51204,0,20493,0,0,23911),
(96874,51205,0,20020,0,0,23911),
(96875,51206,0,19974,0,0,23911),
(96876,51207,0,20039,0,0,23911),
(96877,51208,0,20041,0,0,23911),
(96878,51209,0,19976,0,0,23911),
(96880,51210,0,19841,0,0,23911),
(96881,51211,0,20350,0,0,23911),
(96882,51212,0,19946,0,0,23911),
(96883,51213,0,19945,0,0,23911),
(96884,51214,0,20566,0,0,23911),
(96886,51215,0,20228,0,0,23911),
(96887,51216,0,19972,0,0,23911),
(96889,51217,0,19003,0,0,23911),
(96890,51218,0,20234,0,0,23911),
(96891,51219,0,19841,0,0,23911),
(96892,51220,0,19839,0,0,23911),
(96893,51221,0,19944,0,0,23911),
(96894,51222,0,20126,0,0,23911),
(96896,51223,0,20567,0,0,23911),
(96897,51224,0,20116,0,0,23911),
(96898,51225,0,20034,0,0,23911),
(96899,51226,0,20041,0,0,23911),
(96900,51227,0,20216,0,0,23911),
(96902,51228,0,20568,0,0,23911),
(96903,51229,0,20250,0,0,23911),
(96904,51230,0,20348,0,0,23911),
(96905,51231,0,20125,0,0,23911),
(96906,51232,0,20134,0,0,23911),
(96907,51233,0,20147,0,0,23911),
(96908,51234,0,20038,0,0,23911),
(96910,51235,0,20569,0,0,23911),
(96911,51236,0,20274,0,0,23911),
(96912,51237,0,20096,0,0,23911),
(96913,51238,0,19836,0,0,23911),
(96914,51239,0,20123,0,0,23911),
(96917,51240,0,20349,0,0,23911),
(96919,51241,0,20023,0,0,23911),
(96920,51242,0,20092,0,0,23911),
(96921,51243,0,20351,0,0,23911),
(96922,51244,0,20570,0,0,23911),
(96923,51245,0,20177,0,0,23911),
(96924,51246,0,20127,0,0,23911),
(96925,51247,0,20484,0,0,23911),
(96926,51248,0,20317,0,0,23911),
(96928,51249,0,20222,0,0,23911),
(96929,51250,0,20039,0,0,23911),
(96931,51251,0,20300,0,0,23911),
(96934,51252,0,20495,0,0,23911),
(96935,51253,0,20252,0,0,23911),
(96936,51254,0,20351,0,0,23911),
(96937,51255,0,19941,0,0,23911),
(96974,51286,0,20571,0,0,23911),
(96975,51287,0,20378,0,0,23911),
(96976,51288,0,20337,0,0,23911),
(96977,51289,0,20572,0,0,23911),
(96978,51290,0,20459,0,0,23911),
(96979,51291,0,20217,0,0,23911),
(96980,51292,0,20036,0,0,23911),
(96981,51293,0,19975,0,0,23911),
(96982,51294,0,19676,0,0,23911),
(96983,51295,0,20411,0,0,23911),
(96984,51296,0,20254,0,0,23911),
(96985,51297,0,20254,0,0,23911),
(96986,51298,0,20352,0,0,23911),
(96987,51299,0,20352,0,0,23911),
(96988,51300,0,19945,0,0,23911),
(96989,51301,0,20178,0,0,23911),
(96990,51302,0,20128,0,0,23911),
(96991,51303,0,20464,0,0,23911),
(96992,51304,0,20462,0,0,23911),
(96993,51305,0,20439,0,0,23911),
(96994,51306,0,20296,0,0,23911),
(97128,51414,0,20546,0,0,23911),
(97130,51416,0,20547,0,0,23911),
(95998,50474,0,20082,0,0,23911),
(95999,50475,0,19921,0,0,23911),
(96000,50476,0,19922,0,0,23911),
(96001,50477,0,20164,0,0,23911),
(96002,50478,0,20424,0,0,23911),
(96003,50479,0,20171,0,0,23911),
(96004,50480,0,20423,0,0,23911),
(96006,50481,0,20211,0,0,23911),
(96007,50482,0,20157,0,0,23911),
(96008,50483,0,20159,0,0,23911),
(96009,50484,0,20056,0,0,23911),
(96011,50485,0,20426,0,0,23911),
(96012,50486,0,20425,0,0,23911),
(96014,50487,0,20247,0,0,23911),
(96015,50488,0,20312,0,0,23911),
(96016,50489,0,19933,0,0,23911),
(96017,50490,0,18987,0,0,23911),
(96019,50491,0,20026,0,0,23911),
(96020,50492,0,19862,0,0,23911),
(96021,50493,0,20340,0,0,23911),
(96022,50494,0,20171,0,0,23911),
(96023,50495,0,20427,0,0,23911),
(96024,50496,0,20168,0,0,23911),
(96025,50497,0,19505,0,0,23911),
(96027,50498,0,20212,0,0,23911),
(96028,50499,0,20055,0,0,23911),
(96029,50500,0,20281,0,0,23911),
(96032,50501,0,20428,0,0,23911),
(96033,50502,0,20245,0,0,23911),
(96034,50503,0,19861,0,0,23911),
(96035,50504,0,20342,0,0,23911),
(96036,50505,0,19938,0,0,23911),
(96038,50506,0,20429,0,0,23911),
(96039,50507,0,20053,0,0,23911),
(96040,50508,0,20158,0,0,23911),
(96042,50509,0,20136,0,0,23911),
(96043,50510,0,19860,0,0,23911),
(96044,50511,0,19920,0,0,23911),
(96045,50512,0,20338,0,0,23911),
(96046,50513,0,20166,0,0,23911),
(96047,50514,0,20030,0,0,23911),
(96050,50515,0,20106,0,0,23911),
(96051,50516,0,20243,0,0,23911),
(96052,50517,0,20085,0,0,23911),
(96053,50518,0,19915,0,0,23911),
(96054,50519,0,19917,0,0,23911),
(96055,50520,0,20431,0,0,23911),
(96056,50521,0,20430,0,0,23911),
(96058,50522,0,19978,0,0,23911),
(96059,50523,0,20432,0,0,23911),
(96060,50524,0,20209,0,0,23911),
(96061,50525,0,20058,0,0,23911),
(96062,50526,0,20211,0,0,23911),
(96063,50527,0,19454,0,0,23911),
(96064,50528,0,20117,0,0,23911),
(96065,50529,0,19862,0,0,23911),
(96066,50530,0,20314,0,0,23911),
(96067,50531,0,20343,0,0,23911),
(96068,50532,0,19931,0,0,23911),
(96069,50533,0,19934,0,0,23911),
(96070,50534,0,20433,0,0,23911),
(96072,50535,0,20087,0,0,23911),
(96073,50536,0,20341,0,0,23911),
(96074,50537,0,20434,0,0,23911),
(96075,50538,0,20424,0,0,23911),
(96078,50539,0,20207,0,0,23911),
(96079,50540,0,20054,0,0,23911),
(96080,50541,0,20160,0,0,23911),
(96082,50542,0,20236,0,0,23911),
(96085,50543,0,20241,0,0,23911),
(96086,50544,0,20339,0,0,23911),
(96087,50545,0,20340,0,0,23911),
(96088,50546,0,19932,0,0,23911),
(96089,50547,0,19046,0,0,23911),
(96090,50548,0,20152,0,0,23911),
(96091,50549,0,20210,0,0,23911),
(96092,50550,0,20435,0,0,23911),
(96093,50551,0,20081,0,0,23911),
(96094,50552,0,20341,0,0,23911),
(96095,50553,0,19935,0,0,23911),
(96096,50554,0,20166,0,0,23911),
(96097,50555,0,20167,0,0,23911),
(96100,50556,0,20109,0,0,23911),
(96101,50557,0,20086,0,0,23911),
(96102,50558,0,20339,0,0,23911),
(96103,50559,0,19918,0,0,23911),
(96104,50560,0,20430,0,0,23911),
(96105,50561,0,20169,0,0,23911),
(96106,50562,0,20165,0,0,23911),
(96107,50563,0,20167,0,0,23911),
(96108,50564,0,19054,0,0,23911),
(96110,50565,0,20155,0,0,23911),
(96111,50566,0,20157,0,0,23911),
(96112,50567,0,20208,0,0,23911),
(96113,50568,0,19053,0,0,23911),
(96115,50569,0,20334,0,0,23911),
(96116,50570,0,20242,0,0,23911),
(96117,50571,0,20338,0,0,23911),
(96118,50572,0,19934,0,0,23911),
(96119,50573,0,19936,0,0,23911),
(96121,50574,0,20244,0,0,23911),
(96122,50575,0,19915,0,0,23911),
(96123,50576,0,19919,0,0,23911),
(96124,50577,0,20480,0,0,23911),
(96125,50578,0,20427,0,0,23911),
(96126,50579,0,20431,0,0,23911),
(96127,50580,0,20493,0,0,23911),
(96130,50581,0,20017,0,0,23911),
(96131,50582,0,20158,0,0,23911),
(96132,50583,0,20057,0,0,23911),
(96133,50584,0,20059,0,0,23911),
(96134,50585,0,20160,0,0,23911),
(96136,50586,0,19859,0,0,23911),
(96137,50587,0,20313,0,0,23911),
(96138,50588,0,19938,0,0,23911),
(96139,50589,0,19937,0,0,23911),
(96140,50590,0,20494,0,0,23911),
(96142,50591,0,20228,0,0,23911),
(96143,50592,0,20156,0,0,23911),
(96145,50593,0,19003,0,0,23911),
(96146,50594,0,20232,0,0,23911),
(96147,50595,0,19859,0,0,23911),
(96148,50596,0,19857,0,0,23911),
(96149,50597,0,19936,0,0,23911),
(96150,50598,0,20311,0,0,23911),
(96152,50599,0,20496,0,0,23911),
(96153,50600,0,20113,0,0,23911),
(96154,50601,0,20052,0,0,23911),
(96155,50602,0,20059,0,0,23911),
(96156,50603,0,20207,0,0,23911),
(96158,50604,0,20495,0,0,23911),
(96159,50605,0,20242,0,0,23911),
(96160,50606,0,20340,0,0,23911),
(96161,50607,0,20480,0,0,23911),
(96162,50608,0,20133,0,0,23911),
(96163,50609,0,20144,0,0,23911),
(96164,50610,0,20056,0,0,23911),
(96166,50611,0,20531,0,0,23911),
(96167,50612,0,20271,0,0,23911),
(96168,50613,0,20088,0,0,23911),
(96169,50614,0,19854,0,0,23911),
(96170,50615,0,20310,0,0,23911),
(96173,50616,0,20341,0,0,23911),
(96175,50617,0,20021,0,0,23911),
(96176,50618,0,20084,0,0,23911),
(96177,50619,0,20342,0,0,23911),
(96178,50620,0,20497,0,0,23911),
(96179,50621,0,20169,0,0,23911),
(96180,50622,0,20427,0,0,23911),
(96181,50623,0,20481,0,0,23911),
(96182,50624,0,20513,0,0,23911),
(96184,50625,0,20213,0,0,23911),
(96185,50626,0,20057,0,0,23911),
(96187,50627,0,20302,0,0,23911),
(96190,50628,0,20525,0,0,23911),
(96191,50629,0,20244,0,0,23911),
(96192,50630,0,20342,0,0,23911),
(96193,50631,0,19933,0,0,23911),
(96230,50662,0,20529,0,0,23911),
(96231,50663,0,20375,0,0,23911),
(96232,50664,0,20334,0,0,23911),
(96233,50665,0,20530,0,0,23911),
(96234,50666,0,20456,0,0,23911),
(96235,50667,0,20208,0,0,23911),
(96236,50668,0,20054,0,0,23911),
(96237,50669,0,20159,0,0,23911),
(96238,50670,0,19676,0,0,23911),
(96239,50671,0,20408,0,0,23911),
(96240,50672,0,20246,0,0,23911),
(96241,50673,0,20246,0,0,23911),
(96242,50674,0,20343,0,0,23911),
(96243,50675,0,20343,0,0,23911),
(96244,50676,0,19937,0,0,23911),
(96245,50677,0,20170,0,0,23911),
(96246,50678,0,20431,0,0,23911),
(96247,50679,0,20465,0,0,23911),
(96248,50680,0,20460,0,0,23911),
(96249,50681,0,20436,0,0,23911),
(96250,50682,0,20294,0,0,23911),
(96742,51098,0,20090,0,0,23911),
(96743,51099,0,19929,0,0,23911),
(96744,51100,0,19930,0,0,23911),
(96745,51101,0,20172,0,0,23911),
(96746,51102,0,20124,0,0,23911),
(96747,51103,0,20179,0,0,23911),
(96748,51104,0,20501,0,0,23911),
(96750,51105,0,20220,0,0,23911),
(96751,51106,0,19973,0,0,23911),
(96752,51107,0,19975,0,0,23911),
(96753,51108,0,20038,0,0,23911),
(96755,51109,0,20426,0,0,23911),
(96756,51110,0,20563,0,0,23911),
(96758,51111,0,20255,0,0,23911),
(96759,51112,0,20347,0,0,23911),
(96760,51113,0,19941,0,0,23911),
(96761,51114,0,18987,0,0,23911),
(96763,51115,0,20028,0,0,23911),
(96764,51116,0,19843,0,0,23911),
(96765,51117,0,20348,0,0,23911),
(96766,51118,0,20179,0,0,23911),
(96767,51119,0,20127,0,0,23911),
(96768,51120,0,20176,0,0,23911),
(96769,51121,0,19505,0,0,23911),
(96771,51122,0,20221,0,0,23911),
(96772,51123,0,20037,0,0,23911),
(96773,51124,0,20280,0,0,23911),
(96776,51125,0,20564,0,0,23911),
(96777,51126,0,20253,0,0,23911),
(96778,51127,0,19842,0,0,23911),
(96779,51128,0,20351,0,0,23911),
(96780,51129,0,19946,0,0,23911),
(96782,51130,0,20565,0,0,23911),
(96783,51131,0,20035,0,0,23911),
(96784,51132,0,19974,0,0,23911),
(96786,51133,0,20138,0,0,23911),
(96787,51134,0,19844,0,0,23911),
(96788,51135,0,19928,0,0,23911),
(96789,51136,0,20345,0,0,23911),
(96790,51137,0,20174,0,0,23911),
(96791,51138,0,20032,0,0,23911),
(96794,51139,0,20108,0,0,23911),
(96795,51140,0,20251,0,0,23911),
(96796,51141,0,20093,0,0,23911),
(96797,51142,0,19923,0,0,23911),
(96798,51143,0,19925,0,0,23911),
(96799,51144,0,20128,0,0,23911),
(96800,51145,0,20129,0,0,23911),
(96802,51146,0,19981,0,0,23911),
(96803,51147,0,20432,0,0,23911),
(96804,51148,0,20218,0,0,23911),
(96805,51149,0,20040,0,0,23911),
(96806,51150,0,20220,0,0,23911),
(96807,51151,0,19454,0,0,23911),
(96808,51152,0,20119,0,0,23911),
(96809,51153,0,19843,0,0,23911),
(96810,51154,0,20315,0,0,23911),
(96811,51155,0,20352,0,0,23911),
(96812,51156,0,19939,0,0,23911),
(96813,51157,0,19942,0,0,23911),
(96814,51158,0,20433,0,0,23911),
(96816,51159,0,20095,0,0,23911),
(96817,51160,0,20349,0,0,23911),
(96818,51161,0,20122,0,0,23911),
(96819,51162,0,20124,0,0,23911),
(96822,51163,0,20216,0,0,23911),
(96823,51164,0,20036,0,0,23911),
(96824,51165,0,19976,0,0,23911),
(96826,51166,0,20237,0,0,23911),
(96829,51167,0,20249,0,0,23911),
(96830,51168,0,20346,0,0,23911),
(96831,51169,0,20348,0,0,23911),
(96832,51170,0,19940,0,0,23911),
(96833,51171,0,19046,0,0,23911),
(96834,51172,0,19968,0,0,23911),
(96835,51173,0,20219,0,0,23911),
(96836,51174,0,20540,0,0,23911),
(96837,51175,0,20089,0,0,23911),
(96838,51176,0,20349,0,0,23911),
(96839,51177,0,19943,0,0,23911),
(96840,51178,0,20174,0,0,23911),
(96841,51179,0,20175,0,0,23911),
(96844,51180,0,20111,0,0,23911),
(96845,51181,0,20094,0,0,23911),
(96846,51182,0,20346,0,0,23911),
(96847,51183,0,19926,0,0,23911),
(96848,51184,0,20129,0,0,23911),
(96849,51185,0,20177,0,0,23911),
(96850,51186,0,20173,0,0,23911),
(96851,51187,0,20175,0,0,23911),
(96852,51188,0,19054,0,0,23911),
(96854,51189,0,19971,0,0,23911),
(96855,51190,0,19973,0,0,23911),
(96856,51191,0,20217,0,0,23911),
(96857,51192,0,19053,0,0,23911),
(96859,51193,0,20337,0,0,23911),
(96860,51194,0,20250,0,0,23911),
(96861,51195,0,20345,0,0,23911),
(96862,51196,0,19942,0,0,23911),
(96863,51197,0,19944,0,0,23911),
(96865,51198,0,20252,0,0,23911),
(96866,51199,0,19923,0,0,23911),
(160000,160000,0,65535,0,0,0),
(160001,160001,0,65534,0,0,0),
(160002,160002,0,65533,0,0,0),
(160003,160003,0,65532,0,0,0),
(160004,160004,0,65531,0,0,0),
(160005,160005,0,65530,0,0,0),
(160006,160006,0,65529,0,0,0),
(160007,160007,0,65528,0,0,0),
(160008,160008,0,65527,0,0,0),
(160009,160009,0,65526,0,0,0),
(160011,160011,0,65524,0,0,0),
(160020,160020,0,65514,0,0,0),
(160012,160012,0,65522,0,0,0),
(160013,160013,0,65521,0,0,0),
(160014,160014,0,65520,0,0,0),
(160015,160015,0,65519,0,0,0),
(160016,160016,0,65518,0,0,0),
(160017,160017,0,65517,0,0,0),
(160018,160018,0,65516,0,0,0),
(160019,160019,0,65515,0,0,0),
(160021,160021,0,65513,0,0,0),
(160022,160022,0,65511,0,0,0),
(160023,160023,0,65510,0,0,0),
(160024,160024,0,65509,0,0,0),
(160025,160025,0,65508,0,0,0),
(160026,160026,0,65507,0,0,0),
(160027,160027,0,65506,0,0,0),
(160028,160028,0,65505,0,0,0),
(160029,160029,0,65504,0,0,0),
(160030,160030,0,65503,0,0,0),
(160031,160031,0,65502,0,0,0),
(160032,160032,0,65501,0,0,0),
(160033,160033,0,65500,0,0,0),
(160034,160034,0,65499,0,0,0),
(160035,160035,0,65498,0,0,0),
(160036,160036,0,65497,0,0,0),
(160037,160037,0,65496,0,0,0),
(166000,166000,0,63000,0,0,0),
(160038,160038,0,65495,0,0,0),
(166001,166001,0,63001,0,0,0),
(166002,166002,0,63002,0,0,0),
(166003,166003,0,63003,0,0,0),
(166004,166004,0,63004,0,0,0),
(166005,166005,0,63005,0,0,0),
(160039,160039,0,65494,0,0,0),
(160040,160040,0,65493,0,0,0),
(160041,160041,0,65492,0,0,0),
(160042,160042,0,65491,0,0,0),
(160043,160043,0,65490,0,0,0),
(160044,160044,0,65489,0,0,0),
(160045,160045,0,65488,0,0,0),
(160046,160046,0,65487,0,0,0),
(160047,160047,0,65486,0,0,0),
(128340,128340,0,63010,0,0,0),
(160048,160048,0,65485,0,0,0),
(160049,160049,0,65484,0,0,0),
(160050,160050,0,65483,0,5,0),
(160051,160051,0,65482,0,5,0),
(160052,160052,0,65481,0,5,0),
(160053,160053,0,65480,0,5,0),
(160054,160054,0,65479,0,5,0),
(160055,160055,0,65478,0,5,0),
(160056,160056,0,65477,0,5,0),
(160057,160057,0,65476,0,5,0),
(166006,166006,0,63006,0,0,0),
(166007,166007,0,63007,0,0,0),
(160058,160058,0,65475,0,5,0),
(160059,160059,0,65474,0,5,0),
(160060,160060,0,65473,0,5,0),
(101538,101538,0,63100,0,0,-1),
(166008,166008,0,56008,0,0,-1),
(141006,93947,0,31252,0,1,0),
(160061,160061,0,65472,0,5,0),
(160062,160062,0,65471,0,5,0),
(160063,160063,0,65470,0,5,0),
(160064,160064,0,65469,0,5,0),
(160065,160065,0,65468,0,5,0),
(160066,160066,0,65467,0,5,0),
(160067,160067,0,65466,0,5,0),
(160068,160068,0,65465,0,5,0),
(160069,160069,0,65464,0,5,0),
(160070,160070,0,65463,0,5,0),
(160071,160071,0,65462,0,5,0),
(160072,160072,0,65461,0,5,0),
(160073,160073,0,65460,0,5,0),
(160074,160074,0,65459,0,5,0),
(160075,160075,0,65458,0,5,0),
(160076,160076,0,65457,0,5,0),
(166500,166500,0,40000,0,0,-1),
(166501,166501,0,40001,0,0,-1),
(166502,166502,0,40002,0,0,-1),
(166503,166503,0,40003,0,0,-1),
(166504,166504,0,40004,0,0,-1),
(166505,166505,0,40005,0,0,-1),
(166506,166506,0,40006,0,0,-1),
(166507,166507,0,40007,0,0,-1),
(166508,166508,0,40008,0,0,-1),
(166509,166509,0,40009,0,0,-1),
(166510,166510,0,40010,0,0,-1),
(166511,166511,0,40011,0,0,-1),
(166512,166512,0,40012,0,0,-1),
(166513,166513,0,40013,0,0,-1),
(166514,166514,0,40014,0,0,-1),
(166515,166515,0,40015,0,0,-1),
(166516,166516,0,40016,0,0,-1),
(166517,166517,0,40017,0,0,-1),
(166518,166518,0,40018,0,0,-1),
(166519,166519,0,40019,0,0,-1),
(166520,166520,0,40020,0,0,-1),
(166521,166521,0,40021,0,0,-1),
(166522,166522,0,40022,0,0,-1),
(166523,166523,0,40023,0,0,-1),
(166524,166524,0,40024,0,0,-1),
(166525,166525,0,40025,0,0,-1),
(166526,166526,0,40026,0,0,-1),
(166527,166527,0,40027,0,0,-1),
(166528,166528,0,40028,0,0,-1),
(166529,166529,0,40029,0,0,-1),
(166530,166530,0,40030,0,0,-1),
(166531,166531,0,40031,0,0,-1),
(160077,160077,0,65456,0,5,0),
(160078,160078,0,17445,0,2,0),
(160079,160079,0,65455,0,5,0),
(160080,160080,0,65454,0,5,0),
(160081,160081,0,65453,0,5,0),
(166532,166532,0,40032,0,0,-1),
(166533,166533,0,40033,0,0,-1),
(166534,166534,0,40034,0,0,-1),
(166535,166535,0,40035,0,0,-1),
(166536,166536,0,40036,0,0,-1),
(160082,160082,0,65452,0,5,0),
(160083,160083,0,65451,0,5,0),
(160084,160084,0,65450,0,5,0),
(166537,166537,0,40037,0,0,-1),
(166538,166538,0,40038,0,0,-1),
(166009,166009,0,56009,0,0,-1),
(166539,166539,0,40039,0,0,-1),
(166540,166540,0,40040,0,0,-1),
(166542,166542,0,40042,0,0,-1),
(166543,166543,0,40043,0,0,-1),
(166010,166010,0,56010,0,0,-1),
(166011,166011,0,56011,0,0,-1),
(166012,166012,0,56012,0,0,-1),
(179602,179602,0,29602,0,0,-1);

/*Table structure for table `item_modified_appearance_extra` */

DROP TABLE IF EXISTS `item_modified_appearance_extra`;

CREATE TABLE `item_modified_appearance_extra` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `IconFileDataID` int(11) NOT NULL DEFAULT '0',
  `UnequippedIconFileDataID` int(11) NOT NULL DEFAULT '0',
  `SheatheType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DisplayWeaponSubclassID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DisplayInventoryType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_modified_appearance_extra` */

/*Table structure for table `item_name_description` */

DROP TABLE IF EXISTS `item_name_description`;

CREATE TABLE `item_name_description` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Description` text,
  `Color` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_name_description` */

/*Table structure for table `item_name_description_locale` */

DROP TABLE IF EXISTS `item_name_description_locale`;

CREATE TABLE `item_name_description_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_name_description_locale` */

/*Table structure for table `item_pet_food` */

DROP TABLE IF EXISTS `item_pet_food`;

CREATE TABLE `item_pet_food` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_pet_food` */

/*Table structure for table `item_pet_food_locale` */

DROP TABLE IF EXISTS `item_pet_food_locale`;

CREATE TABLE `item_pet_food_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_pet_food_locale` */

/*Table structure for table `item_price_base` */

DROP TABLE IF EXISTS `item_price_base`;

CREATE TABLE `item_price_base` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Armor` float NOT NULL DEFAULT '0',
  `Weapon` float NOT NULL DEFAULT '0',
  `ItemLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_price_base` */

/*Table structure for table `item_random_properties` */

DROP TABLE IF EXISTS `item_random_properties`;

CREATE TABLE `item_random_properties` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Enchantment1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Enchantment2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Enchantment3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Enchantment4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Enchantment5` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_random_properties` */

/*Table structure for table `item_random_properties_locale` */

DROP TABLE IF EXISTS `item_random_properties_locale`;

CREATE TABLE `item_random_properties_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_random_properties_locale` */

/*Table structure for table `item_random_suffix` */

DROP TABLE IF EXISTS `item_random_suffix`;

CREATE TABLE `item_random_suffix` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Enchantment1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Enchantment2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Enchantment3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Enchantment4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Enchantment5` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AllocationPct1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AllocationPct2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AllocationPct3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AllocationPct4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AllocationPct5` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_random_suffix` */

/*Table structure for table `item_random_suffix_locale` */

DROP TABLE IF EXISTS `item_random_suffix_locale`;

CREATE TABLE `item_random_suffix_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_random_suffix_locale` */

/*Table structure for table `item_ranged_display_info` */

DROP TABLE IF EXISTS `item_ranged_display_info`;

CREATE TABLE `item_ranged_display_info` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `MissileSpellVisualEffectNameID` int(11) NOT NULL DEFAULT '0',
  `QuiverFileDataID` int(11) NOT NULL DEFAULT '0',
  `CastSpellVisualID` int(11) NOT NULL DEFAULT '0',
  `AutoAttackSpellVisualID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_ranged_display_info` */

/*Table structure for table `item_search_name` */

DROP TABLE IF EXISTS `item_search_name`;

CREATE TABLE `item_search_name` (
  `AllowableRace` bigint(20) unsigned NOT NULL DEFAULT '0',
  `Display` text,
  `ID` int(11) NOT NULL DEFAULT '0',
  `Flags1` int(10) unsigned NOT NULL DEFAULT '0',
  `Flags2` int(10) unsigned NOT NULL DEFAULT '0',
  `Flags3` int(10) unsigned NOT NULL DEFAULT '0',
  `ItemLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `OverallQualityID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ExpansionID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RequiredLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MinFactionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MinReputation` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AllowableClass` int(11) NOT NULL DEFAULT '0',
  `RequiredSkill` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RequiredSkillRank` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RequiredAbility` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_search_name` */

/*Table structure for table `item_search_name_locale` */

DROP TABLE IF EXISTS `item_search_name_locale`;

CREATE TABLE `item_search_name_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Display_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_search_name_locale` */

/*Table structure for table `item_set` */

DROP TABLE IF EXISTS `item_set`;

CREATE TABLE `item_set` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `ItemID1` int(11) NOT NULL DEFAULT '0',
  `ItemID2` int(11) NOT NULL DEFAULT '0',
  `ItemID3` int(11) NOT NULL DEFAULT '0',
  `ItemID4` int(11) NOT NULL DEFAULT '0',
  `ItemID5` int(11) NOT NULL DEFAULT '0',
  `ItemID6` int(11) NOT NULL DEFAULT '0',
  `ItemID7` int(11) NOT NULL DEFAULT '0',
  `ItemID8` int(11) NOT NULL DEFAULT '0',
  `ItemID9` int(11) NOT NULL DEFAULT '0',
  `ItemID10` int(11) NOT NULL DEFAULT '0',
  `ItemID11` int(11) NOT NULL DEFAULT '0',
  `ItemID12` int(11) NOT NULL DEFAULT '0',
  `ItemID13` int(11) NOT NULL DEFAULT '0',
  `ItemID14` int(11) NOT NULL DEFAULT '0',
  `ItemID15` int(11) NOT NULL DEFAULT '0',
  `ItemID16` int(11) NOT NULL DEFAULT '0',
  `ItemID17` int(11) NOT NULL DEFAULT '0',
  `RequiredSkillRank` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RequiredSkill` int(11) NOT NULL DEFAULT '0',
  `SetFlags` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_set` */

/*Table structure for table `item_set_locale` */

DROP TABLE IF EXISTS `item_set_locale`;

CREATE TABLE `item_set_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_set_locale` */

/*Table structure for table `item_set_spell` */

DROP TABLE IF EXISTS `item_set_spell`;

CREATE TABLE `item_set_spell` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `ChrSpecID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Threshold` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ItemSetID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_set_spell` */

/*Table structure for table `item_sparse` */

DROP TABLE IF EXISTS `item_sparse`;

CREATE TABLE `item_sparse` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `AllowableRace` bigint(20) NOT NULL DEFAULT '0',
  `Display` text,
  `Display1` text,
  `Display2` text,
  `Display3` text,
  `Description` text,
  `Flags1` int(10) unsigned NOT NULL DEFAULT '0',
  `Flags2` int(10) unsigned NOT NULL DEFAULT '0',
  `Flags3` int(10) unsigned NOT NULL DEFAULT '0',
  `Flags4` int(10) unsigned NOT NULL DEFAULT '0',
  `PriceRandomValue` float NOT NULL DEFAULT '0',
  `PriceVariance` float NOT NULL DEFAULT '0',
  `VendorStackCount` int(11) NOT NULL DEFAULT '0',
  `BuyPrice` int(11) NOT NULL DEFAULT '0',
  `SellPrice` int(11) NOT NULL DEFAULT '0',
  `RequiredAbility` int(11) NOT NULL DEFAULT '0',
  `MaxCount` int(11) NOT NULL DEFAULT '0',
  `Stackable` int(11) NOT NULL DEFAULT '0',
  `StatPercentEditor1` int(11) NOT NULL DEFAULT '0',
  `StatPercentEditor2` int(11) NOT NULL DEFAULT '0',
  `StatPercentEditor3` int(11) NOT NULL DEFAULT '0',
  `StatPercentEditor4` int(11) NOT NULL DEFAULT '0',
  `StatPercentEditor5` int(11) NOT NULL DEFAULT '0',
  `StatPercentEditor6` int(11) NOT NULL DEFAULT '0',
  `StatPercentEditor7` int(11) NOT NULL DEFAULT '0',
  `StatPercentEditor8` int(11) NOT NULL DEFAULT '0',
  `StatPercentEditor9` int(11) NOT NULL DEFAULT '0',
  `StatPercentEditor10` int(11) NOT NULL DEFAULT '0',
  `StatPercentageOfSocket1` float NOT NULL DEFAULT '0',
  `StatPercentageOfSocket2` float NOT NULL DEFAULT '0',
  `StatPercentageOfSocket3` float NOT NULL DEFAULT '0',
  `StatPercentageOfSocket4` float NOT NULL DEFAULT '0',
  `StatPercentageOfSocket5` float NOT NULL DEFAULT '0',
  `StatPercentageOfSocket6` float NOT NULL DEFAULT '0',
  `StatPercentageOfSocket7` float NOT NULL DEFAULT '0',
  `StatPercentageOfSocket8` float NOT NULL DEFAULT '0',
  `StatPercentageOfSocket9` float NOT NULL DEFAULT '0',
  `StatPercentageOfSocket10` float NOT NULL DEFAULT '0',
  `ItemRange` float NOT NULL DEFAULT '0',
  `BagFamily` int(11) NOT NULL DEFAULT '0',
  `QualityModifier` float NOT NULL DEFAULT '0',
  `DurationInInventory` int(11) NOT NULL DEFAULT '0',
  `DmgVariance` float NOT NULL DEFAULT '0',
  `AllowableClass` smallint(5) NOT NULL DEFAULT '-1',
  `ItemLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RequiredSkill` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RequiredSkillRank` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MinFactionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemStatValue1` smallint(6) NOT NULL DEFAULT '0',
  `ItemStatValue2` smallint(6) NOT NULL DEFAULT '0',
  `ItemStatValue3` smallint(6) NOT NULL DEFAULT '0',
  `ItemStatValue4` smallint(6) NOT NULL DEFAULT '0',
  `ItemStatValue5` smallint(6) NOT NULL DEFAULT '0',
  `ItemStatValue6` smallint(6) NOT NULL DEFAULT '0',
  `ItemStatValue7` smallint(6) NOT NULL DEFAULT '0',
  `ItemStatValue8` smallint(6) NOT NULL DEFAULT '0',
  `ItemStatValue9` smallint(6) NOT NULL DEFAULT '0',
  `ItemStatValue10` smallint(6) NOT NULL DEFAULT '0',
  `ScalingStatDistributionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemDelay` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PageID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `StartQuestID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LockID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RandomSelect` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemRandomSuffixGroupID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemSet` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ZoneBound` smallint(5) unsigned NOT NULL DEFAULT '0',
  `InstanceBound` smallint(5) unsigned NOT NULL DEFAULT '0',
  `TotemCategoryID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SocketMatch_enchantment_id` smallint(5) unsigned NOT NULL DEFAULT '0',
  `GemProperties` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LimitCategory` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RequiredHoliday` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RequiredTransmogHoliday` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemNameDescriptionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `OverallQualityID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `InventoryType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RequiredLevel` tinyint(4) NOT NULL DEFAULT '0',
  `RequiredPVPRank` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RequiredPVPMedal` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MinReputation` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ContainerSlots` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `StatModifierBonusStat1` tinyint(4) NOT NULL DEFAULT '0',
  `StatModifierBonusStat2` tinyint(4) NOT NULL DEFAULT '0',
  `StatModifierBonusStat3` tinyint(4) NOT NULL DEFAULT '0',
  `StatModifierBonusStat4` tinyint(4) NOT NULL DEFAULT '0',
  `StatModifierBonusStat5` tinyint(4) NOT NULL DEFAULT '0',
  `StatModifierBonusStat6` tinyint(4) NOT NULL DEFAULT '0',
  `StatModifierBonusStat7` tinyint(4) NOT NULL DEFAULT '0',
  `StatModifierBonusStat8` tinyint(4) NOT NULL DEFAULT '0',
  `StatModifierBonusStat9` tinyint(4) NOT NULL DEFAULT '0',
  `StatModifierBonusStat10` tinyint(4) NOT NULL DEFAULT '0',
  `DamageDamageType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Bonding` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LanguageID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PageMaterialID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Material` tinyint(4) NOT NULL DEFAULT '0',
  `SheatheType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SocketType1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SocketType2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SocketType3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SpellWeightCategory` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SpellWeight` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ArtifactID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ExpansionID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_sparse` */

insert  into `item_sparse`(`ID`,`AllowableRace`,`Display`,`Display1`,`Display2`,`Display3`,`Description`,`Flags1`,`Flags2`,`Flags3`,`Flags4`,`PriceRandomValue`,`PriceVariance`,`VendorStackCount`,`BuyPrice`,`SellPrice`,`RequiredAbility`,`MaxCount`,`Stackable`,`StatPercentEditor1`,`StatPercentEditor2`,`StatPercentEditor3`,`StatPercentEditor4`,`StatPercentEditor5`,`StatPercentEditor6`,`StatPercentEditor7`,`StatPercentEditor8`,`StatPercentEditor9`,`StatPercentEditor10`,`StatPercentageOfSocket1`,`StatPercentageOfSocket2`,`StatPercentageOfSocket3`,`StatPercentageOfSocket4`,`StatPercentageOfSocket5`,`StatPercentageOfSocket6`,`StatPercentageOfSocket7`,`StatPercentageOfSocket8`,`StatPercentageOfSocket9`,`StatPercentageOfSocket10`,`ItemRange`,`BagFamily`,`QualityModifier`,`DurationInInventory`,`DmgVariance`,`AllowableClass`,`ItemLevel`,`RequiredSkill`,`RequiredSkillRank`,`MinFactionID`,`ItemStatValue1`,`ItemStatValue2`,`ItemStatValue3`,`ItemStatValue4`,`ItemStatValue5`,`ItemStatValue6`,`ItemStatValue7`,`ItemStatValue8`,`ItemStatValue9`,`ItemStatValue10`,`ScalingStatDistributionID`,`ItemDelay`,`PageID`,`StartQuestID`,`LockID`,`RandomSelect`,`ItemRandomSuffixGroupID`,`ItemSet`,`ZoneBound`,`InstanceBound`,`TotemCategoryID`,`SocketMatch_enchantment_id`,`GemProperties`,`LimitCategory`,`RequiredHoliday`,`RequiredTransmogHoliday`,`ItemNameDescriptionID`,`OverallQualityID`,`InventoryType`,`RequiredLevel`,`RequiredPVPRank`,`RequiredPVPMedal`,`MinReputation`,`ContainerSlots`,`StatModifierBonusStat1`,`StatModifierBonusStat2`,`StatModifierBonusStat3`,`StatModifierBonusStat4`,`StatModifierBonusStat5`,`StatModifierBonusStat6`,`StatModifierBonusStat7`,`StatModifierBonusStat8`,`StatModifierBonusStat9`,`StatModifierBonusStat10`,`DamageDamageType`,`Bonding`,`LanguageID`,`PageMaterialID`,`Material`,`SheatheType`,`SocketType1`,`SocketType2`,`SocketType3`,`SpellWeightCategory`,`SpellWeight`,`ArtifactID`,`ExpansionID`,`VerifiedBuild`) values 
(123868,-1,'Shakama Relic','','','','Simple carvings of a cat.',65536,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,100,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,24015),
(133956,-1,'Unstable Spell Focus','','','','It buzzes radiantly, radiating energy.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(133755,-1,'Darksong Fishing Rod','','','','',98336,4198400,8388608,0,0,0,0,11155624,2231124,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32768,0,0,0,-1,750,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,17,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,4,1,0,0,0,0,0,73,6,24015),
(123286,-1,'Harmonious Handcuffs','','','','',65536,0,8388608,0,0,0,0,731462,146292,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,150,225,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,9,100,0,0,0,0,73,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,8,0,0,0,0,0,0,0,0,21491),
(123285,-1,'Harmonious combat belt','','','','',65536,0,8388608,0,0,0,0,728853,145770,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,6,100,0,0,0,0,73,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,8,0,0,0,0,0,0,0,0,21491),
(123284,-1,'Harmonious Shoulders','','','','',65536,0,8388608,0,0,0,0,1081114,216222,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,100,0,0,0,0,73,7,32,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,8,0,0,0,0,0,0,0,0,21491),
(123283,-1,'Harmonious pants','','','','',65536,0,8388608,0,0,0,0,1439189,287837,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,7,100,0,0,0,0,73,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,8,0,0,0,0,0,0,0,0,21491),
(123282,-1,'Harmonious hood','','','','',65536,0,8388608,0,0,0,0,1073452,214690,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,100,0,0,0,0,73,7,32,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,8,0,0,0,0,0,0,0,0,21491),
(123280,-1,'Harmonious shoes','','','','',65536,0,8388608,0,0,0,0,1065790,213158,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,8,100,0,0,0,0,73,7,32,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,8,0,0,0,0,0,0,0,0,21491),
(123281,-1,'Harmonious gloves','','','','',65536,0,8388608,0,0,0,0,718489,143697,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,10,100,0,0,0,0,73,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,8,0,0,0,0,0,0,0,0,21491),
(123278,-1,'Vague Wristwraps','','','','',65536,0,8388608,0,0,0,0,710733,142146,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,150,225,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,9,100,0,0,0,0,5,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123279,-1,'Harmonious Tunic','','','','',65536,0,8388608,0,0,0,0,1418577,283715,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,5,100,0,0,0,0,73,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,8,0,0,0,0,0,0,0,0,21491),
(123277,-1,'Vague Cord','','','','',65536,0,8388608,0,0,0,0,689439,137887,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,6,100,0,0,0,0,5,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123276,-1,'Vague Shoulderpads','','','','',65536,0,8388608,0,0,0,0,1022545,204509,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,100,0,0,0,0,5,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123275,-1,'Vague robe','','','','',65536,0,8388608,0,0,0,0,1360808,272161,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,20,100,0,0,0,0,5,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123274,-1,'Vague Legguards','','','','',65536,0,8388608,0,0,0,0,1355620,271124,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,7,100,0,0,0,0,5,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123272,-1,'Vague Bandages','','','','',65536,0,8388608,0,0,0,0,676536,135307,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,10,100,0,0,0,0,5,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123273,-1,'Obscure hood','','','','',65536,0,8388608,0,0,0,0,1010894,202178,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,100,0,0,0,0,5,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123318,-1,'Soul Cord','','','','',65536,0,8388608,0,0,0,0,710521,142104,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,6,100,0,0,0,0,5,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123319,-1,'Soul Wraps','','','','',65536,0,8388608,0,0,0,0,713130,142626,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,150,225,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,9,100,0,0,0,0,5,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123271,-1,'Obscure sandals','','','','',65536,0,8388608,0,0,0,0,1003232,200646,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,8,100,0,0,0,0,5,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123317,-1,'Soul Shoulderpads','','','','',65536,0,8388608,0,0,0,0,1053929,210785,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,100,0,0,0,0,5,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123316,-1,'Stranglehold clothes','','','','',65536,0,8388608,0,0,0,0,1402733,280546,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,20,100,0,0,0,0,5,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123315,-1,'Stranglehold Legguards','','','','',65536,0,8388608,0,0,0,0,1397545,279509,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,7,100,0,0,0,0,5,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123312,-1,'Stranglehold Sandals','','','','',65536,0,8388608,0,0,0,0,1034616,206923,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,8,100,0,0,0,0,5,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123313,-1,'Stranglehold bandages','','','','',65536,0,8388608,0,0,0,0,697618,139523,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,10,100,0,0,0,0,5,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123314,-1,'Stranglehold Hoodie','','','','',65536,0,8388608,0,0,0,0,1042278,208455,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,100,0,0,0,0,5,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123214,-1,'Sturdy War Bracers','','','','',65536,0,8388608,0,0,0,0,681965,136393,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,150,225,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,9,100,0,0,0,0,74,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123213,-1,'Sturdy War belt','','','','',65536,0,8388608,0,0,0,0,731251,146250,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,6,100,0,0,0,0,74,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123210,-1,'Sturdy War helmet','','','','',65536,0,8388608,0,0,0,0,1077021,215404,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,100,0,0,0,0,74,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123211,-1,'Sturdy War Legguards','','','','',65536,0,8388608,0,0,0,0,1443957,288791,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,7,100,0,0,0,0,74,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123212,-1,'Sturdy Shoulderguards','','','','',65536,0,8388608,0,0,0,0,1084788,216957,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,100,0,0,0,0,74,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123207,-1,'Sturdy Cuirass','','','','',65536,0,8388608,0,0,0,0,1423345,284669,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,5,100,0,0,0,0,74,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123208,-1,'Sturdy Boots','','','','',65536,0,8388608,0,0,0,0,1069359,213871,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,8,100,0,0,0,0,74,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123209,-1,'Sturdy Hand Gauntlets','','','','',65536,0,8388608,0,0,0,0,720886,144177,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,10,100,0,0,0,0,74,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123296,-1,'Scattering Twilight Battle Armor','','','','',65536,0,8388608,0,0,0,0,1402873,280574,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,5,100,0,0,0,0,74,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(127863,-1,'Prison keys','','','','A set of long, bone-decorated keys on a silver chain.',2048,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21287),
(123303,-1,'Sabatons of the Diffusing Twilight','','','','',65536,0,8388608,0,0,0,0,1077126,215425,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,8,100,0,0,0,0,74,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123302,-1,'Bracers of Dispersive Twilight','','','','',65536,0,8388608,0,0,0,0,721027,144205,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,150,225,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,9,100,0,0,0,0,74,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123301,-1,'Diffuse Twilight Belt','','','','',65536,0,8388608,0,0,0,0,718418,143683,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,6,100,0,0,0,0,74,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123300,-1,'Dusklight Spaulders','','','','',65536,0,8388608,0,0,0,0,1065580,213116,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,100,0,0,0,0,74,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123299,-1,'Dusklight Legguards','','','','',65536,0,8388608,0,0,0,0,1418297,283659,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,7,100,0,0,0,0,74,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123298,-1,'Scattering Twilight Headpiece','','','','',65536,0,8388608,0,0,0,0,1057918,211583,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,100,0,0,0,0,74,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123297,-1,'Dusklight Gloves','','','','',65536,0,8388608,0,0,0,0,708053,141610,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,10,100,0,0,0,0,74,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(121720,-1,'Rock Slider Ridge','','','','',16,0,8388608,0,0,0,0,614512,122902,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,225,175,324,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,7,32,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,4,0,0,0,0,0,0,0,0,21491),
(137356,-1,'','','','','',16,0,0,0,0,0,0,1568154,313630,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,820,0,0,0,552,828,446,288,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,16,98,0,0,0,0,71,7,40,49,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(134553,-1,'Helia\'s Wrath','','','','',32,4210688,0,0,0,0,0,0,0,0,1,1,5259,7889,3559,3418,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,750,0,0,0,511,766,346,332,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,17,0,0,0,0,0,4,7,32,49,-1,-1,-1,-1,-1,-1,0,1,0,0,1,1,0,0,0,0,0,0,0,20994),
(123908,-1,'','','','','I\'ll be a real treasure someday!',0,0,8388608,0,0,0,0,25,1,0,0,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,4,0,0,0,0,0,0,0,0,21154),
(134552,-1,'Fortune','','','','',32,4206592,0,0,0,0,0,9167560,1833512,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,750,0,0,0,219,328,148,142,0,0,0,0,0,0,0,2600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,22,0,0,0,0,0,3,7,32,49,-1,-1,-1,-1,-1,-1,0,1,0,0,1,3,0,0,0,0,0,0,0,21021),
(122702,-1,'Airtight container','','','','',65600,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21267),
(130213,-1,'Tracker\'s colorful jacket','','','','',65536,0,0,0,0,0,0,1581497,316299,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,660,0,0,0,331,221,147,147,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,5,0,0,0,0,0,7,73,36,49,-1,-1,-1,-1,-1,-1,0,0,0,0,8,0,0,0,0,0,0,0,0,21108),
(107457,-1,'Treasure Placeholder','','','','I\'ll be a real treasure someday!',0,0,0,0,0,0,0,25,1,0,0,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,4,0,0,0,0,0,0,0,0,21287),
(136409,-1,'Tear of Elune','','','','The hardened tear lying on your palm seems completely weightless.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,21287),
(121640,-1,'Quickfeather Cloak','','','','',16,0,0,0,0,0,0,1046057,209211,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,150,225,100,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,16,0,0,0,0,0,71,7,32,36,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(133627,-1,'Challenger Valarjar\'s Breastplate','','','','',16,0,0,0,0,0,0,2041448,408289,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,820,0,0,0,1471,981,654,654,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,5,98,0,0,0,0,7,74,36,49,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(124491,-1,'Live Leystone Sample','','','','Warm, shining stone.',65536,0,0,0,0,0,0,0,0,0,1,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,38785,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,21108),
(124498,-1,'Fel Living Shale Sample','','','','From the ore comes a gloomy, vicious rumble.',65536,0,0,0,0,0,0,0,0,0,1,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,38797,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,21108),
(139382,-1,'Keystone Container','','','','Contains a level 3 Challenge Keystone.',65540,0,131072,0,0,0,0,1000,250,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,21491),
(139381,-1,'Keystone Container','','','','Contains a level 1 Challenge Keystone.',65540,0,131072,0,0,0,0,1000,250,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,21491),
(129148,-1,'','','','','On the one hand, it’s like a bear, and on the other, it has a beak ...',65536,0,0,0,0,0,0,0,250000,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,21491),
(121718,-1,'Warrior\'s Iron Ring','','','','',16,0,8388608,0,0,0,0,871405,174281,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,225,100,399,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,11,0,0,0,0,0,7,32,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,4,0,0,0,0,0,0,0,0,21491),
(134104,-1,'Leystone Spike','','','','',0,0,0,0,0,0,0,0,0,0,0,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4195456,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,1,0,0,0,0,0,0,0,0,21108),
(139383,-1,'Keystone Container','','','','Contains a level 6 Challenge Keystone.',65540,0,131072,0,0,0,0,1000,250,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,21491),
(121645,-1,'Stoneblood Harpy Cloak','','','','',16,0,0,0,0,0,0,1065370,213074,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,150,225,100,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,16,0,0,0,0,0,71,7,32,36,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123907,-1,'','','','','I\'ll be a real treasure someday!',0,0,0,0,0,0,0,25,1,0,0,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,4,0,0,0,0,0,0,0,0,21491),
(121566,-1,'Oiled Shieldbearer Cloak','','','','',16,0,0,0,0,0,0,1041963,208392,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,150,225,100,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,16,0,0,0,0,0,71,7,32,36,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(121719,-1,'Rivermane Protective Cover','','','','',16,0,8388608,0,0,0,0,1283356,256671,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,150,225,100,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,16,0,0,0,0,0,71,7,32,36,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(130134,-1,'Sailor\'s overalls','','','','',65536,0,0,0,0,0,0,1708618,341723,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,660,0,0,0,331,221,147,147,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,7,0,0,0,0,0,7,73,36,49,-1,-1,-1,-1,-1,-1,0,0,0,0,5,0,0,0,0,0,0,0,0,21154),
(122306,-1,'Cracked power crystal','','','','It still contains a small amount of mana.',65536,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(120079,-1,'Head of the Lord of the Deeps of Zarrin','','','','He talked too much anyway.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(122095,-1,'Crackling heart of a power worm','','','','Pure crystallized mana.',65536,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(120080,-1,'Night Elf Stolen Bone','','','','A fragment of an ancient bone.',65536,0,0,0,0,0,0,0,0,0,0,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(120946,-1,'Nar\'talas Academy Spellbook','','','','\"Ice magic spells for followers.\"',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(120947,-1,'Hat of Nar\'talas Academy','','','','The most common pointed wizard hat.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(120948,-1,'Nar\'talas Academy Robe','','','','These robes are completely transparent. Are you really going to wear them?',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(120949,-1,'Rod of Nar\'talas Academy','','','','Pooh.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(120960,-1,'Tidalstone Vault Key','','','','',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(120401,-1,'Tidestone Shard','','','','The crystal is humming softly. It still has a part of its former strength.',65536,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(120169,-1,'Tidalstone Vault Key','','','','From the long years of being in the high humidity of the halls of the academy, this key completely rusted.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(122188,-1,'Dull Power Crystal','','','','The crystal, filled with magical energy, emits a quiet strum.',65536,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(122153,-1,'Charged Mana Gem','','','','Cracks from the power energy contained in it.',65536,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(139619,-1,'Ymiron\'s Broken Blade','','','','',67584,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,43604,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,21737),
(22058,-1,'Papel de Carta de Dia dos Namorados','','','','',0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,21737),
(18154,-1,'Timbre da Blizzard','','','','',0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21737),
(8164,-1,'Test Stationery','','','','',16,0,8388608,0,0,0,0,10,2,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21737),
(138019,-1,'Mythic Key','','','','Put the key in the Power Cup in the dungeon in Mythic mode.',65536,64,8388608,0,0,0,0,2000,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,1,0,0,0,0,0,0,0,0,23171),
(160000,-1,'Shirt of Illidan\'s way (Custom trans only)','','','','Like Illidan\'s henchman, you leave behind a blazing trail of fel ...',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160001,-1,'Xuen\'s Power Shirt (Custom trans only)','','','','The power of Xuan will always be with you. For this you do not need a cloak at all ...',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160002,-1,'Chi-Ji Kindness Shirt (Custom trans only)','','','','The kindness of Chi-ji will always be with you. For this you do not need a cloak at all ...',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160003,-1,'Yu-Lun Breath Shirt (Custom trans only)','','','','Yu-Long\'s breath will always be with you. For this you do not need a cloak at all ...',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160004,-1,'Strength Shirt Niuzao (Custom trans only)','','','','Nujiao\'s resilience will always be with you. For this you do not need a cloak at all ...',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160005,-1,'Shirt of Shadowmourne (Custom trans only','','','','Putting on this shirt, you feel a shiver. You feel her dark power.',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160006,-1,'Raven Lord\'s Shirt (Custom trans only)','','','','You are surrounded by raven spirits. These birds obviously know something.',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160007,-1,'Shirt of falling stars (Custom trans only)','','','','Stars are falling at your feet. Hurry up to make a wish.',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160008,-1,'Shirt of the Soaring Butterflies (Custom trans only)','','','','You look great. Your attractiveness beckons even butterflies.',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160009,-1,'Shirt of Shadowmourne (Custom trans only','','','','Putting on this shirt, you feel a shiver. You feel her dark power.',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160011,-1,'Shirt Path Cenarius (Custom trans only)','','','','Your character will leave behind a flowering trail.',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(113282,-1,'Eye of Anzu','','','','Focus of Charms from Terokk\'s Dark Past',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1),
(111850,-1,'Sita Feather','','','','Rukhmar adherents prefer cremation, while Arakkoa outcasts spend',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1),
(124640,-1,'Ink and Black Potion','','','','Mix two parts of crushed dried crickets, one part of feces ink',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1),
(160020,-1,'Shadowmourne Monster Offhand (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(138391,-1,'Arcane Amplifier','','','','Commonly used to enhance owner spells.',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1),
(160012,-1,'Frostmourne (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160013,-1,'Shalamein (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(113010,-1,'Lithium','','','','The Blessed Lithium bracelet has a special connection with Terok.',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1),
(134005,-1,'Odin\'s Cauldron','','','','A huge cauldron lined with ancient runes.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(133995,-1,'Storm Honey Recipe','','','','The recipe is a complex diagram with multiple notes and drawings.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(135558,-1,'Lush grass seed','','','','',0,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1),
(160014,-1,'Mindbender\'s Flameblade (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160015,-1,'Shoulderplate of the Holy Warrior (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(133898,-1,'Moon Guard Anthology','','','','Personal files of all members of the order of the Lunar Guardians from the moment of its foundation. This list is already very many years old.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(133899,-1,'The magic manifest of the moon','','','','A folio read to holes, in which the dependence of the effectiveness of various spells on the phases of the moon is described with all the details.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(133900,-1,'\"Consequences of the battle for the Source\"','','','','A hand-written summary of the most significant events that occurred after the split.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(133882,-1,'Rune Trap','','','','',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(133924,-1,'Stargazer key','','','','',67584,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(133999,-1,'Inert crystal','','','','',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(133675,-1,'Seal of the Moonguard','','','','Usually only the most talented possess such painted talismans.',65536,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(132371,-1,'Fin','','','','\"A piece of sun-bleached wood.\"',65536,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(138308,-1,'Manavin flask','','','','Guilt is ridiculously small, but for many, even this is the ultimate dream.',65536,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(137295,-1,'Bottle of Arcane Wine','','','','',65536,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(138389,-1,'A bottle of magic wine in a gift box','','','','',65536,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(136851,-1,'Helmet Commander Domitill','','','','',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40762,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(160016,-1,'Shield of Light (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160017,-1,'Warrior\'s Embrace (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160018,-1,'Thunderfury, Blessed Blade of the Windseeker (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160060,-1,'Glaive of Maiev (Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,6,0,0,0,0,0,0,0,0),
(160019,-1,'Ashbringer (Extra Effects) (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160021,-1,'Shirt of Big Heart (Custom trans only)','','','','The shirt is permeated with strong love!',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160022,-1,'Thunderfury, Blessed Blade of the Windseeker (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160023,-1,'Shalamein (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(142065,-1,'Сумеречная Лилия Сигил','','','','A warm piece of enchanted stone carved in the shape of a lily.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(138205,-1,'Gyallarhorn','','','','Carved from the tusk of a large beast, this impressive horn carries deep angular runes.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(139501,-1,'Frostcliff Drums','','','','',65536,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,100,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,24015),
(138204,-1,'Things of Svergan','','','','',65536,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,100,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,24015),
(104350,-1,'Swampfly Firefly Pollen','','','','Shining',0,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1),
(112386,-1,'Shard of misery','','','','',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1),
(111591,-1,'Elixir of Clear Vision','','','','',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1),
(107076,-1,'Amulet of Illusions of Silenus','','','','',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1),
(111024,-1,'Pure Star Lily','','','','A translucent and weightless flower that grows only under the light of stars.',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1),
(100899,-1,'Artifact of the Fallen Clan Orc','','','','Crafted by Frostwolf orcs, this token is an honored remembrance of its fallen owner.',0,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1),
(160024,-1,'No Belt (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(137182,-1,'Crown of the Forgotten King','','','','This simple but well-crafted crown was once worn by King Svergan Stormshroud. Dried blood on it means violent death.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(137183,-1,'Storm Veil Signet','','','','Sign of the clan of the storm.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(137184,-1,'Dragon rider medallion','','','','The wings of the Storm Dragon rest on a bright stone in the medallion.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(102463,-1,'Oath of the Keeper of Fire','','','','',268435456,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,1),
(112385,-1,'Star sky map','','','','Detailed sky map.',0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1),
(141360,-1,'[Fel-Ravaged Tome]','','','','[In spite of its current state, the tome vibrates with arcane energy.]',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1),
(141355,-1,'[Waterlogged Tome]','','','','[In spite of its current state, the tome vibrates with arcane energy.]',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1),
(141361,-1,'Cursed Tome','','','','A dark power struggles against you as you try to flip trough the pages.',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1),
(160025,-1,'Fel Infused Leggings (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(139380,-1,'Seeds of Sna','','','','',65536,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,100,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,24015),
(160026,-1,'Shirt of Rainbow (Custom trans only)','','','','There is a legend that it was worn by unicorns themselves!',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(110723,-1,'Vessel with toad mucus',NULL,NULL,NULL,'Glows.',0,0,0,0,0,0,0,0,0,0,20,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(114986,-1,'Poisonous Tenetopi Herbs',NULL,NULL,NULL,'Handle carefully.',2112,8192,0,0,0,0,0,0,0,0,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(160027,-1,'Shalamein (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,3,0,0,0,0,0,0,0,0),
(160028,-1,'Warglaive of Azzinoth (left)(Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160029,-1,'Warglaive of Azzinoth (right)(Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160030,-1,'Gar\'tash, Hammer of the Breakers (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160031,-1,'Gar\'tash, Hammer of the Breakers (fire)(Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160032,-1,'Tabard of Illidan\'s way (Custom trans only)','','','','Like Illidan\'s henchman, you leave behind a blazing trail of fel ...',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160033,-1,'Energized Chestplate (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(140395,-1,'Stylish spy glasses','','','','',65536,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,100,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,24015),
(160036,-1,'Diadem of the Highborne (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160034,-1,'Val\'anyr, Hammer of Ancient Kings (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,3,0,0,0,0,0,0,0,0),
(160035,-1,'Tabard of New Year (Custom trans only)','','','','New Year will overtake you even in Azeroth!',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160037,-1,'Radiant Lightbringer Shoulderguards (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(166000,-1,'Destroyer\'s Embrace Cape','','','','The power of this item is unlimited. From time to time, Wrathion\'s wings appear behind you.',67108864,8396800,8388864,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160038,-1,'Shield of Light (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(166001,-1,'Destroyer Embrace Shirt','','','','The power of this item is unlimited. From time to time, Wrathion\'s wings appear behind you.',67108864,8396800,8388864,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(166002,-1,'Cape of the Endless Rainbow','','','','Wherever you go, a rainbow haunts you everywhere.',67108864,8396800,8388864,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(166003,-1,'Infinite Rainbow Shirt','','','','Wherever you go, a rainbow haunts you everywhere.',67108864,8396800,8388864,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(166004,-1,'Cape of Burning Wings','','','','Having put on this cloak, you feel how you have flaming wings.',67108864,8396800,8388864,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(166005,-1,'Flaming Wings Shirt','','','','Wearing this shirt, you feel like you have flaming wings.',67108864,8396800,8388864,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160039,-1,'Bow of broken islands (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,2,0,0,0,0,0,0,0,0),
(124524,-1,'Fel Axe','','','','',0,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(143630,-1,'Fel Axe','','','','',0,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160040,-1,'Mantle of the Arcane Tempest (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160041,-1,'Crown of the Arcane Tempest (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160042,-1,'Gloves of the Arcane Tempest (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(102225,-1,'Puzzle Rolo',NULL,NULL,NULL,'The old piece of tattered parchment has barely survived the test of time.',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32974,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),
(160043,-1,'Dragonwrath, Tarecgosa\'s Rest (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,2,0,0,0,0,0,0,0,0),
(160044,-1,'Cowl of the Tempest (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160045,-1,'Vestia\'s Pauldrons of Inner Grace (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160046,-1,'Glaive of Maiev (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160047,-1,'Bracers of Divine Infusion (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(128340,-1,'Chieftain\'s Beads',NULL,NULL,NULL,'Simple wooden beads bound on a leather cord.',67584,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,38146,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(160048,-1,'Glaive of Maiev (Custom trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160049,-1,'Shirt of shadow raider (Custom trans only)','','','','Darkness itself swallows you!',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(142211,-1,'Ancient Shal\'dorei Scroll','','','','From time to time, charms run along the edges of this parchment with fire script.',65536,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(146310,-1,'Fel Liquid Flask','','','','Inside, fel energy boils, and tends to break free.',65536,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(146311,-1,'A glass of defiled blood','','','','Hot blood is full of rage.',65536,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(146312,-1,'Demonic ashes','','','','Glows dimly, radiating fel energy.',65536,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(160050,-1,'Pants of the Naaru (Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(143918,-1,'Demonic ashes','','','','When touched, emits a piercing aggressive buzz.',65536,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(160055,-1,'Atiesh, Greatstaff of the Guardian (off-hand) (Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,2,0,0,0,0,0,0,0,0),
(160054,-1,'Dragonwrath, Tarecgosa\'s Rest (off-hand) (Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,2,0,0,0,0,0,0,0,0),
(160053,-1,'Shirt of ghost raider (Custom trans only)','','',NULL,'You seemed to be half a ghost!',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160052,-1,'Radiant Lightbringer Belts (Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160051,-1,'Radiant Lightbringer Greaves (Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160081,-1,'Dress Shoes (Custom without type)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160080,-1,'Tuxedo pants (Custom without type)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160056,-1,'Robe of the Great Dark Beyond (Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160057,-1,'Diadem of the Highborne (Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(166006,-1,'Soap Bubble Cape','','','','Having put on this cloak, you begin to blow bubbles from time to time.',67108864,8396800,8388864,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(166007,-1,'Soap bubble shirt','','','','Having put on this cloak, you begin to blow bubbles from time to time.',67108864,8396800,8388864,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160058,-1,'Thunderfury, Blessed Blade of the Windseeker (Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160059,-1,'Thunderfury, Blessed Blade of the Windseeker (Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(101538,-1,'Key to Kukuru treasure','','','','',69696,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(160079,-1,'Tuxedo Jacket (Custom without type)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(166008,-1,'Father sock','','','','One has only to pick it up ... and you begin to feel freer ...',0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,18,0,0,0,0,36,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0),
(160061,-1,'Scythe of the Unmaker (One-Handed)(Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,2,0,0,0,0,0,0,0,0),
(160062,-1,'Scythe of the Unmaker (Two-Handed)(Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,2,0,0,0,0,0,0,0,0),
(160063,-1,'Taeshalach (Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160064,-1,'Scythe of the Unmaker (Two-handed)(Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,2,0,0,0,0,0,0,0,0),
(128519,-1,'Monster Hammer','','','','',0,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160065,-1,'Taeshalach (Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160066,-1,'Ren\'dorei Mantle (Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160067,-1,'Scythe of the Unmaker (Fist)(Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,2,0,0,0,0,0,0,0,0),
(160068,-1,'Robes of the Battleguard (Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160069,-1,'Claw of the Phoenix (Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160070,-1,'Mooncloth Robe (Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160071,-1,'Tabard of Red Sphere (Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160072,-1,'Scythe of the Unmaker (Two-handed staff)(Custom trans only)','','',NULL,'Only for trans by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,2,0,0,0,0,0,0,0,0),
(160073,-1,'Shal\'dorei Finery (Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160074,-1,'Jade Breastplate (Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160075,-1,'Jade Legplates (Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160076,-1,'Tabard of ghost (Custom trans only)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(166500,-1,'Scroll of summon','','','','Summon target player of your group or raid. Not usable in dungeons or areanas and battlegrounds.',67108864,0,0,0,0,0,0,0,0,0,0,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166501,-1,'Rhinestone Sunglasses','','','','',4096,24576,2048,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166502,-1,'Rhinestone Sunglasses','','','','',4096,24576,2048,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166503,-1,'Black Sunglasses','','','','',4096,24576,2048,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166504,-1,'Flaming crown','','','','',4096,24576,2048,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166505,-1,'Flaming nimb','','','','',4096,24576,2048,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166506,-1,'Cache of ...','','','','',4,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166507,-1,'Stromgarde chest key','','','','',69696,0,0,0,0,0,0,0,0,0,0,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166508,-1,'Stromgarde chest key','','','','',69696,0,0,0,0,0,0,0,0,0,0,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166509,-1,'Abyss Phoenix','','','','',69696,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166510,-1,'Blue Phoenix','','','','',69696,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166511,-1,'Flaming Phoenix','','','','',69696,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166512,-1,'Occasionally sober','','','','',69696,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166513,-1,'Xuen\'s child','','','','',69696,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166514,-1,'Reins of Loke\'nahak','','','','',69696,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166515,-1,'Illidari Badger','','','','',69696,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166516,-1,'Phantom hippogriff','','','','',69696,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166517,-1,'Kul-Tiras Horse','','','','',69696,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166518,-1,'Zuldazar\'s Lizard','','','','',69696,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166519,-1,'Shu-tsen, Divine Guardian.','','','','',69696,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166520,-1,'Lilac phoenix','','','','',69696,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166521,-1,'Tabard of thousand stars','','','','Shine of thousand stars.',67108864,8396800,8388864,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3500,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,19,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166522,-1,'Shirt of thousand stars','','','','Shine of thousand stars.',67108864,8396800,8388864,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3500,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166523,-1,'Tabard of Arcane magic','','','','Feel the power of arcane magic.',67108864,8396800,8388864,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3500,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,19,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166524,-1,'Shirt of Arcane magic','','','','Feel the power of arcane magic.',67108864,8396800,8388864,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3500,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166525,-1,'Banker call','','','','Calls the banker. Not use on arenas or myth+ dungeons.',69696,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3500,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166526,-1,'Banker call','','','','Calls the banker. Not use on arenas or myth+ dungeons.',69696,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3500,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166527,-1,'Auctioneer call','','','','Calls the auctioneer. Not use on arenas or myth+ dungeons.',69696,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3500,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166528,-1,'Auctioneer call','','','','Calls the auctioneer. Not use on arenas or myth+ dungeons.',69696,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3500,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166529,-1,'Artifact forge call','','','','Calls the Artefact forge. Not use on arenas or myth+ dungeons.',69696,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3500,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166530,-1,'Artefact forge call','','','','Calls the Artifact forge. Not use on arenas or myth+ dungeons.',69696,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3500,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166531,-1,'Abandoned treasure','','','','',69696,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3500,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(42775,-1,'Silvana\'s Custom Bow','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160077,-1,'Stormheart Headpiece','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160078,-1,'Silvana\'s Custom Bow','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(166532,-1,'Tabard of Ice Power','','','','Feel the power of ice.',67108864,8396800,8388864,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3500,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,19,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166533,-1,'Shirt of Ice Power','','','','Feel the power of ice.',67108864,8396800,8388864,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3500,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166534,-1,'Somber Dawn','','','','',69696,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166535,-1,'Red Illidari Felbat','','','','',69696,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166536,-1,'Call for Teleporter','','','','Calls your own teleporter, who can teleport you and your friends to some various places. List of teleportation points can be increased by complete some quests and achievements.',69696,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3500,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(160082,-1,'Taeshalach  (Custom one handed)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160083,-1,'Crown of Good Fortune(Custom without type)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160084,-1,'Sylvanas Bow (Custom bow)','','',NULL,'Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(166537,-1,'Frost Wyrm Trophy','','','','Need for Commander Payne.',0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166538,-1,'Val\'kyr Trophy','','','','Need for Commander Payne.',0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166009,-1,'Father sock','','','','One has only to pick it up ... and you begin to feel freer ...',0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,18,0,0,0,0,36,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0),
(143931,-1,'Small boat',NULL,NULL,NULL,NULL,65600,8192,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,604800,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,23478),
(166539,-1,'Tabard of the Eversong','','','','Where you are - there is Eversong.',67108864,8396800,8388864,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3500,0,0,0,0,0,0,0,0,0,0,0,365,0,0,0,5,19,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166540,-1,'Shirt of the Eversong','','','','Where you are - there is Eversong.',67108864,8396800,8388864,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3500,0,0,0,0,0,0,0,0,0,0,0,365,0,0,0,5,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166542,-1,'V.I.P donate box','','','','You can view what available in this box on our forum in Donate section.',67108864,0,0,0,0,0,0,0,0,0,0,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166543,-1,'Tarecgosa\'s Visage','','','','',69696,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166010,-1,'Bag of the Divine Sentinel','','','','Now there should be enough space.',0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,18,0,0,0,0,36,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166011,-1,'Big Bag of the Trophy Collector','','','','Need more, more trophies.',0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,18,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(166012,-1,'Huge Bag of the Trophy Collector','','','','Need more, more trophies.',0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,18,0,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),
(228700,-1,'Haunch of Meat',NULL,NULL,NULL,NULL,0,8192,0,0,1.0059,1,5,125,6,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65536,0,0,0,-1,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);

/*Table structure for table `item_sparse_locale` */

DROP TABLE IF EXISTS `item_sparse_locale`;

CREATE TABLE `item_sparse_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Display_lang` text,
  `Display1_lang` text,
  `Display2_lang` text,
  `Display3_lang` text,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_sparse_locale` */

insert  into `item_sparse_locale`(`ID`,`locale`,`Display_lang`,`Display1_lang`,`Display2_lang`,`Display3_lang`,`Description_lang`,`VerifiedBuild`) values 
(133755,'enUS','Underlight Angler','','','','',24015);

/*Table structure for table `item_spec` */

DROP TABLE IF EXISTS `item_spec`;

CREATE TABLE `item_spec` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpecializationID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MinLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ItemType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PrimaryStat` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SecondaryStat` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_spec` */

/*Table structure for table `item_spec_override` */

DROP TABLE IF EXISTS `item_spec_override`;

CREATE TABLE `item_spec_override` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpecID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemID` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_spec_override` */

/*Table structure for table `item_sub_class` */

DROP TABLE IF EXISTS `item_sub_class`;

CREATE TABLE `item_sub_class` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `DisplayName` text,
  `VerboseName` text,
  `Flags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ClassID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SubClassID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PrerequisiteProficiency` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PostrequisiteProficiency` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DisplayFlags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `WeaponSwingSize` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AuctionHouseSortOrder` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_sub_class` */

/*Table structure for table `item_sub_class_locale` */

DROP TABLE IF EXISTS `item_sub_class_locale`;

CREATE TABLE `item_sub_class_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `DisplayName_lang` text,
  `VerboseName_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_sub_class_locale` */

/*Table structure for table `item_sub_class_mask` */

DROP TABLE IF EXISTS `item_sub_class_mask`;

CREATE TABLE `item_sub_class_mask` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Mask` int(11) NOT NULL DEFAULT '0',
  `ClassID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_sub_class_mask` */

/*Table structure for table `item_sub_class_mask_locale` */

DROP TABLE IF EXISTS `item_sub_class_mask_locale`;

CREATE TABLE `item_sub_class_mask_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_sub_class_mask_locale` */

/*Table structure for table `item_upgrade` */

DROP TABLE IF EXISTS `item_upgrade`;

CREATE TABLE `item_upgrade` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `CurrencyAmount` int(11) NOT NULL DEFAULT '0',
  `PrerequisiteID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CurrencyType` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemUpgradePathID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ItemLevelIncrement` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_upgrade` */

/*Table structure for table `item_visuals` */

DROP TABLE IF EXISTS `item_visuals`;

CREATE TABLE `item_visuals` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ModelFileID1` int(11) NOT NULL DEFAULT '0',
  `ModelFileID2` int(11) NOT NULL DEFAULT '0',
  `ModelFileID3` int(11) NOT NULL DEFAULT '0',
  `ModelFileID4` int(11) NOT NULL DEFAULT '0',
  `ModelFileID5` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_visuals` */

/*Table structure for table `item_x_bonus_tree` */

DROP TABLE IF EXISTS `item_x_bonus_tree`;

CREATE TABLE `item_x_bonus_tree` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ItemBonusTreeID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemID` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `item_x_bonus_tree` */

/*Table structure for table `itemsparse` */

DROP TABLE IF EXISTS `itemsparse`;

CREATE TABLE `itemsparse` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `AllowableRace` bigint(20) NOT NULL DEFAULT '0',
  `Name1` text,
  `Name2` text,
  `Name3` text,
  `Name4` text,
  `Description` text,
  `Flags1` int(10) unsigned NOT NULL DEFAULT '0',
  `Flags2` int(10) unsigned NOT NULL DEFAULT '0',
  `Flags3` int(10) unsigned NOT NULL DEFAULT '0',
  `Flags4` int(10) unsigned NOT NULL DEFAULT '0',
  `PriceRandomValue` float NOT NULL DEFAULT '0',
  `PriceVariance` float NOT NULL DEFAULT '0',
  `VendorStackCount` int(10) unsigned NOT NULL DEFAULT '0',
  `BuyPrice` int(10) unsigned NOT NULL DEFAULT '0',
  `SellPrice` int(10) unsigned NOT NULL DEFAULT '0',
  `RequiredSpell` int(10) unsigned NOT NULL DEFAULT '0',
  `MaxCount` int(11) NOT NULL DEFAULT '0',
  `Stackable` int(11) NOT NULL DEFAULT '0',
  `StatPercentEditor1` int(11) NOT NULL DEFAULT '0',
  `StatPercentEditor2` int(11) NOT NULL DEFAULT '0',
  `StatPercentEditor3` int(11) NOT NULL DEFAULT '0',
  `StatPercentEditor4` int(11) NOT NULL DEFAULT '0',
  `StatPercentEditor5` int(11) NOT NULL DEFAULT '0',
  `StatPercentEditor6` int(11) NOT NULL DEFAULT '0',
  `StatPercentEditor7` int(11) NOT NULL DEFAULT '0',
  `StatPercentEditor8` int(11) NOT NULL DEFAULT '0',
  `StatPercentEditor9` int(11) NOT NULL DEFAULT '0',
  `StatPercentEditor10` int(11) NOT NULL DEFAULT '0',
  `StatPercentageOfSocket1` float NOT NULL DEFAULT '0',
  `StatPercentageOfSocket2` float NOT NULL DEFAULT '0',
  `StatPercentageOfSocket3` float NOT NULL DEFAULT '0',
  `StatPercentageOfSocket4` float NOT NULL DEFAULT '0',
  `StatPercentageOfSocket5` float NOT NULL DEFAULT '0',
  `StatPercentageOfSocket6` float NOT NULL DEFAULT '0',
  `StatPercentageOfSocket7` float NOT NULL DEFAULT '0',
  `StatPercentageOfSocket8` float NOT NULL DEFAULT '0',
  `StatPercentageOfSocket9` float NOT NULL DEFAULT '0',
  `StatPercentageOfSocket10` float NOT NULL DEFAULT '0',
  `ItemRange` float NOT NULL DEFAULT '0',
  `BagFamily` int(10) unsigned NOT NULL DEFAULT '0',
  `QualityModifier` float NOT NULL DEFAULT '0',
  `DurationInInventory` int(10) unsigned NOT NULL DEFAULT '0',
  `DmgVariance` float NOT NULL DEFAULT '0',
  `AllowableClass` smallint(6) NOT NULL DEFAULT '0',
  `ItemLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RequiredSkill` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RequiredSkillRank` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RequiredReputationFaction` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemStatValue1` smallint(6) NOT NULL DEFAULT '0',
  `ItemStatValue2` smallint(6) NOT NULL DEFAULT '0',
  `ItemStatValue3` smallint(6) NOT NULL DEFAULT '0',
  `ItemStatValue4` smallint(6) NOT NULL DEFAULT '0',
  `ItemStatValue5` smallint(6) NOT NULL DEFAULT '0',
  `ItemStatValue6` smallint(6) NOT NULL DEFAULT '0',
  `ItemStatValue7` smallint(6) NOT NULL DEFAULT '0',
  `ItemStatValue8` smallint(6) NOT NULL DEFAULT '0',
  `ItemStatValue9` smallint(6) NOT NULL DEFAULT '0',
  `ItemStatValue10` smallint(6) NOT NULL DEFAULT '0',
  `ScalingStatDistribution` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Delay` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PageText` smallint(5) unsigned NOT NULL DEFAULT '0',
  `StartQuest` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LockID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RandomProperty` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RandomSuffix` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemSet` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Area` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Map` smallint(5) unsigned NOT NULL DEFAULT '0',
  `TotemCategory` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SocketBonus` smallint(5) unsigned NOT NULL DEFAULT '0',
  `GemProperties` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemLimitCategory` smallint(5) unsigned NOT NULL DEFAULT '0',
  `HolidayID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RequiredTransmogHolidayID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemNameDescriptionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Quality` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `InventoryType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RequiredLevel` tinyint(4) NOT NULL DEFAULT '0',
  `RequiredHonorRank` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RequiredCityRank` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RequiredReputationRank` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ContainerSlots` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ItemStatType1` tinyint(4) NOT NULL DEFAULT '0',
  `ItemStatType2` tinyint(4) NOT NULL DEFAULT '0',
  `ItemStatType3` tinyint(4) NOT NULL DEFAULT '0',
  `ItemStatType4` tinyint(4) NOT NULL DEFAULT '0',
  `ItemStatType5` tinyint(4) NOT NULL DEFAULT '0',
  `ItemStatType6` tinyint(4) NOT NULL DEFAULT '0',
  `ItemStatType7` tinyint(4) NOT NULL DEFAULT '0',
  `ItemStatType8` tinyint(4) NOT NULL DEFAULT '0',
  `ItemStatType9` tinyint(4) NOT NULL DEFAULT '0',
  `ItemStatType10` tinyint(4) NOT NULL DEFAULT '0',
  `DamageType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Bonding` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LanguageID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PageMaterial` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Material` tinyint(4) NOT NULL DEFAULT '0',
  `Sheath` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SocketColor1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SocketColor2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SocketColor3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CurrencySubstitutionID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CurrencySubstitutionCount` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ArtifactID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RequiredExpansion` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `itemsparse` */

insert  into `itemsparse`(`ID`,`AllowableRace`,`Name1`,`Name2`,`Name3`,`Name4`,`Description`,`Flags1`,`Flags2`,`Flags3`,`Flags4`,`PriceRandomValue`,`PriceVariance`,`VendorStackCount`,`BuyPrice`,`SellPrice`,`RequiredSpell`,`MaxCount`,`Stackable`,`StatPercentEditor1`,`StatPercentEditor2`,`StatPercentEditor3`,`StatPercentEditor4`,`StatPercentEditor5`,`StatPercentEditor6`,`StatPercentEditor7`,`StatPercentEditor8`,`StatPercentEditor9`,`StatPercentEditor10`,`StatPercentageOfSocket1`,`StatPercentageOfSocket2`,`StatPercentageOfSocket3`,`StatPercentageOfSocket4`,`StatPercentageOfSocket5`,`StatPercentageOfSocket6`,`StatPercentageOfSocket7`,`StatPercentageOfSocket8`,`StatPercentageOfSocket9`,`StatPercentageOfSocket10`,`ItemRange`,`BagFamily`,`QualityModifier`,`DurationInInventory`,`DmgVariance`,`AllowableClass`,`ItemLevel`,`RequiredSkill`,`RequiredSkillRank`,`RequiredReputationFaction`,`ItemStatValue1`,`ItemStatValue2`,`ItemStatValue3`,`ItemStatValue4`,`ItemStatValue5`,`ItemStatValue6`,`ItemStatValue7`,`ItemStatValue8`,`ItemStatValue9`,`ItemStatValue10`,`ScalingStatDistribution`,`Delay`,`PageText`,`StartQuest`,`LockID`,`RandomProperty`,`RandomSuffix`,`ItemSet`,`Area`,`Map`,`TotemCategory`,`SocketBonus`,`GemProperties`,`ItemLimitCategory`,`HolidayID`,`RequiredTransmogHolidayID`,`ItemNameDescriptionID`,`Quality`,`InventoryType`,`RequiredLevel`,`RequiredHonorRank`,`RequiredCityRank`,`RequiredReputationRank`,`ContainerSlots`,`ItemStatType1`,`ItemStatType2`,`ItemStatType3`,`ItemStatType4`,`ItemStatType5`,`ItemStatType6`,`ItemStatType7`,`ItemStatType8`,`ItemStatType9`,`ItemStatType10`,`DamageType`,`Bonding`,`LanguageID`,`PageMaterial`,`Material`,`Sheath`,`SocketColor1`,`SocketColor2`,`SocketColor3`,`CurrencySubstitutionID`,`CurrencySubstitutionCount`,`ArtifactID`,`RequiredExpansion`,`VerifiedBuild`) values 
(123868,-1,'Реликвия Шакамы','','','','Простенькая резная фигурка кошки.',65536,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32767,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,100,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,24015),
(133956,-1,'Нестабильное средоточие заклинаний','','','','Мерно гудит, излучая энергию.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32767,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(133755,-1,'Удочка Темносвета','','','','',98336,4198400,8388608,0,0,0,0,11155624,2231124,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32768,0,0,0,32767,750,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,17,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,4,1,0,0,0,0,0,73,6,24015),
(123286,-1,'Гармоничные наручники','','','','',65536,0,8388608,0,0,0,0,731462,146292,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,512,680,0,0,0,150,225,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,9,100,0,0,0,0,73,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,8,0,0,0,0,0,0,0,0,21491),
(123285,-1,'Гармоничный боевой пояс','','','','',65536,0,8388608,0,0,0,0,728853,145770,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,512,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,6,100,0,0,0,0,73,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,8,0,0,0,0,0,0,0,0,21491),
(123284,-1,'Гармоничные наплечники','','','','',65536,0,8388608,0,0,0,0,1081114,216222,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,512,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,100,0,0,0,0,73,7,32,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,8,0,0,0,0,0,0,0,0,21491),
(123283,-1,'Гармоничные брюки','','','','',65536,0,8388608,0,0,0,0,1439189,287837,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,512,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,7,100,0,0,0,0,73,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,8,0,0,0,0,0,0,0,0,21491),
(123282,-1,'Гармоничный капюшон','','','','',65536,0,8388608,0,0,0,0,1073452,214690,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,512,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,100,0,0,0,0,73,7,32,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,8,0,0,0,0,0,0,0,0,21491),
(123280,-1,'Гармоничные туфли','','','','',65536,0,8388608,0,0,0,0,1065790,213158,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,512,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,8,100,0,0,0,0,73,7,32,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,8,0,0,0,0,0,0,0,0,21491),
(123281,-1,'Гармоничные перчатки','','','','',65536,0,8388608,0,0,0,0,718489,143697,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,512,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,10,100,0,0,0,0,73,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,8,0,0,0,0,0,0,0,0,21491),
(123278,-1,'Неясные напульсники','','','','',65536,0,8388608,0,0,0,0,710733,142146,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,680,0,0,0,150,225,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,9,100,0,0,0,0,5,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123279,-1,'Гармоничный мундир','','','','',65536,0,8388608,0,0,0,0,1418577,283715,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,512,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,5,100,0,0,0,0,73,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,8,0,0,0,0,0,0,0,0,21491),
(123277,-1,'Неясный шнурованный ремень','','','','',65536,0,8388608,0,0,0,0,689439,137887,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,6,100,0,0,0,0,5,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123276,-1,'Неясные наплечные пластины','','','','',65536,0,8388608,0,0,0,0,1022545,204509,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,100,0,0,0,0,5,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123275,-1,'Неясное одеяние','','','','',65536,0,8388608,0,0,0,0,1360808,272161,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,20,100,0,0,0,0,5,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123274,-1,'Неясные набедренники','','','','',65536,0,8388608,0,0,0,0,1355620,271124,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,7,100,0,0,0,0,5,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123272,-1,'Неясные повязки','','','','',65536,0,8388608,0,0,0,0,676536,135307,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,10,100,0,0,0,0,5,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123273,-1,'Неясный капюшон','','','','',65536,0,8388608,0,0,0,0,1010894,202178,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,100,0,0,0,0,5,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123318,-1,'Душеспасительный шнурованный ремень','','','','',65536,0,8388608,0,0,0,0,710521,142104,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,6,100,0,0,0,0,5,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123319,-1,'Душеспасительные напульсники','','','','',65536,0,8388608,0,0,0,0,713130,142626,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,680,0,0,0,150,225,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,9,100,0,0,0,0,5,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123271,-1,'Неясные сандалии','','','','',65536,0,8388608,0,0,0,0,1003232,200646,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,8,100,0,0,0,0,5,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123317,-1,'Душеспасительные наплечные пластины','','','','',65536,0,8388608,0,0,0,0,1053929,210785,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,100,0,0,0,0,5,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123316,-1,'Душеспасительные одежды','','','','',65536,0,8388608,0,0,0,0,1402733,280546,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,20,100,0,0,0,0,5,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123315,-1,'Душеспасительные набедренники','','','','',65536,0,8388608,0,0,0,0,1397545,279509,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,7,100,0,0,0,0,5,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123312,-1,'Душеспасительные сандалии','','','','',65536,0,8388608,0,0,0,0,1034616,206923,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,8,100,0,0,0,0,5,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123313,-1,'Душеспасительные повязки','','','','',65536,0,8388608,0,0,0,0,697618,139523,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,10,100,0,0,0,0,5,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123314,-1,'Душеспасительный капюшон','','','','',65536,0,8388608,0,0,0,0,1042278,208455,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,100,0,0,0,0,5,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123214,-1,'Негнущиеся боевые наручи','','','','',65536,0,8388608,0,0,0,0,681965,136393,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,680,0,0,0,150,225,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,9,100,0,0,0,0,74,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123213,-1,'Негнущийся боевой пояс','','','','',65536,0,8388608,0,0,0,0,731251,146250,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,6,100,0,0,0,0,74,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123210,-1,'Негнущийся большой шлем','','','','',65536,0,8388608,0,0,0,0,1077021,215404,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,100,0,0,0,0,74,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123211,-1,'Негнущиеся набедренники','','','','',65536,0,8388608,0,0,0,0,1443957,288791,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,7,100,0,0,0,0,74,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123212,-1,'Негнущиеся наплечные щитки','','','','',65536,0,8388608,0,0,0,0,1084788,216957,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,100,0,0,0,0,74,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123207,-1,'Негнущаяся кираса','','','','',65536,0,8388608,0,0,0,0,1423345,284669,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,5,100,0,0,0,0,74,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123208,-1,'Негнущиеся башмаки','','','','',65536,0,8388608,0,0,0,0,1069359,213871,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,8,100,0,0,0,0,74,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123209,-1,'Негнущиеся боевые рукавицы','','','','',65536,0,8388608,0,0,0,0,720886,144177,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,10,100,0,0,0,0,74,7,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123296,-1,'Боевой доспех рассеивающего сумерки','','','','',65536,0,8388608,0,0,0,0,1402873,280574,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,5,100,0,0,0,0,74,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(127863,-1,'Ключи от тюрьмы','','','','Набор длинных, украшенных костями ключей на серебряной цепочке.',2048,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21287),
(123303,-1,'Башмаки рассеивающего сумерки','','','','',65536,0,8388608,0,0,0,0,1077126,215425,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,8,100,0,0,0,0,74,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123302,-1,'Наручи рассеивающего сумерки','','','','',65536,0,8388608,0,0,0,0,721027,144205,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,680,0,0,0,150,225,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,9,100,0,0,0,0,74,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123301,-1,'Пояс рассеивающего сумерки','','','','',65536,0,8388608,0,0,0,0,718418,143683,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,6,100,0,0,0,0,74,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123300,-1,'Наплеч рассеивающего сумерки','','','','',65536,0,8388608,0,0,0,0,1065580,213116,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,100,0,0,0,0,74,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123299,-1,'Набедренники рассеивающего сумерки','','','','',65536,0,8388608,0,0,0,0,1418297,283659,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,7,100,0,0,0,0,74,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123298,-1,'Головной убор рассеивающего сумерки','','','','',65536,0,8388608,0,0,0,0,1057918,211583,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,680,0,0,0,266,399,354,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,100,0,0,0,0,74,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(123297,-1,'Перчатки рассеивающего сумерки','','','','',65536,0,8388608,0,0,0,0,708053,141610,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,680,0,0,0,200,300,266,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,10,100,0,0,0,0,74,7,49,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(121720,-1,'Хребет скального ползуна','','','','',16,0,8388608,0,0,0,0,614512,122902,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,225,175,324,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,7,32,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,4,0,0,0,0,0,0,0,0,21491),
(137356,-1,'','','','','',16,0,0,0,0,0,0,1568154,313630,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,820,0,0,0,552,828,446,288,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,16,98,0,0,0,0,71,7,40,49,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(134553,-1,'Гнев Хелии','','','','',32,4210688,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,750,0,0,0,511,766,346,332,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,17,0,0,0,0,0,4,7,32,49,-1,-1,-1,-1,-1,-1,0,1,0,0,1,1,0,0,0,0,0,0,0,20994),
(123908,-1,'','','','','I\'ll be a real treasure someday!',0,0,8388608,0,0,0,0,25,1,0,0,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,4,0,0,0,0,0,0,0,0,21154),
(134552,-1,'Fortune','','','','',32,4206592,0,0,0,0,0,9167560,1833512,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,750,0,0,0,219,328,148,142,0,0,0,0,0,0,0,2600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,22,0,0,0,0,0,3,7,32,49,-1,-1,-1,-1,-1,-1,0,1,0,0,1,3,0,0,0,0,0,0,0,21021),
(122702,-1,'Герметичный контейнер','','','','',65600,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21267),
(130213,-1,'Цветастая куртка следопыта','','','','',65536,0,0,0,0,0,0,1581497,316299,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,660,0,0,0,331,221,147,147,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,5,0,0,0,0,0,7,73,36,49,-1,-1,-1,-1,-1,-1,0,0,0,0,8,0,0,0,0,0,0,0,0,21108),
(107457,-1,'Treasure Placeholder','','','','I\'ll be a real treasure someday!',0,0,0,0,0,0,0,25,1,0,0,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,4,0,0,0,0,0,0,0,0,21287),
(136409,-1,'Слеза Элуны','','','','Затвердевшая слеза, лежащая на вашей ладони, кажется совершенно невесомой.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,21287),
(121640,-1,'Плащ быстрого пера','','','','',16,0,0,0,0,0,0,1046057,209211,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,150,225,100,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,16,0,0,0,0,0,71,7,32,36,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(133627,-1,'Кираса валарьяра-претендента','','','','',16,0,0,0,0,0,0,2041448,408289,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,820,0,0,0,1471,981,654,654,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,5,98,0,0,0,0,7,74,36,49,-1,-1,-1,-1,-1,-1,0,1,0,0,6,0,0,0,0,0,0,0,0,21491),
(124491,-1,'Образец живого силового камня','','','','Теплый, сияющий камень.',65536,0,0,0,0,0,0,0,0,0,1,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,38785,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,21108),
(124498,-1,'Образец живого сланца Скверны','','','','От руды исходит мрачный, злобный гул.',65536,0,0,0,0,0,0,0,0,0,1,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,38797,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,21108),
(139382,-1,'Keystone Container','','','','Contains a level 3 Challenge Keystone.',65540,0,131072,0,0,0,0,1000,250,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,21491),
(139381,-1,'Keystone Container','','','','Contains a level 1 Challenge Keystone.',65540,0,131072,0,0,0,0,1000,250,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,21491),
(129148,-1,'','','','','С одной стороны, вроде медведь, а с другой – у него клюв...',65536,0,0,0,0,0,0,0,250000,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,21491),
(121718,-1,'Железное кольцо воителя','','','','',16,0,8388608,0,0,0,0,871405,174281,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,225,100,399,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,11,0,0,0,0,0,7,32,36,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,4,0,0,0,0,0,0,0,0,21491),
(134104,-1,'Покрытый силовым камнем шип','','','','',0,0,0,0,0,0,0,0,0,0,0,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4195456,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,1,0,0,0,0,0,0,0,0,21108),
(139383,-1,'Keystone Container','','','','Contains a level 6 Challenge Keystone.',65540,0,131072,0,0,0,0,1000,250,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,21491),
(121645,-1,'Плащ гарпии Каменной Крови','','','','',16,0,0,0,0,0,0,1065370,213074,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,150,225,100,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,16,0,0,0,0,0,71,7,32,36,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(123907,-1,'','','','','I\'ll be a real treasure someday!',0,0,0,0,0,0,0,25,1,0,0,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,4,0,0,0,0,0,0,0,0,21491),
(121566,-1,'Промасленный плащ щитоносца','','','','',16,0,0,0,0,0,0,1041963,208392,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,150,225,100,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,16,0,0,0,0,0,71,7,32,36,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(121719,-1,'Защитное покрывало Речной Гривы','','','','',16,0,8388608,0,0,0,0,1283356,256671,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,680,0,0,0,150,225,100,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,16,0,0,0,0,0,71,7,32,36,-1,-1,-1,-1,-1,-1,0,1,0,0,7,0,0,0,0,0,0,0,0,21491),
(130134,-1,'Комбинезон моряка','','','','',65536,0,0,0,0,0,0,1708618,341723,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,660,0,0,0,331,221,147,147,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,7,0,0,0,0,0,7,73,36,49,-1,-1,-1,-1,-1,-1,0,0,0,0,5,0,0,0,0,0,0,0,0,21154),
(122306,-1,'Потрескавшийся силовой кристалл','','','','В нем все еще содержится небольшое количество маны.',65536,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(120079,-1,'Голова повелителя пучин Заррина','','','','He talked too much anyway.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(122095,-1,'Потрескивающее сердце силового червя','','','','Чистая кристаллизованная мана.',65536,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(120080,-1,'Украденная кость ночного эльфа','','','','Осколок древней кости.',65536,0,0,0,0,0,0,0,0,0,0,200,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(120946,-1,'Книга заклинаний академии Нар\'таласа','','','','\"Заклинания магии льда для продолжающих\".',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(120947,-1,'Шляпа академии Нар\'таласа','','','','Самая обычная остроконечная шляпа волшебника.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(120948,-1,'Одеяние академии Нар\'таласа','','','','Эти одеяния совершенно прозрачны. Вы действительно собираетесь их надеть?',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(120949,-1,'Жезл академии Нар\'таласа','','','','Пи-и-и-у.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(120960,-1,'Ключ от хранилища Приливного камня','','','','',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(120401,-1,'Осколок Приливного камня','','','','Кристалл тихонько гудит. В нем еще осталась часть былой силы.',65536,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(120169,-1,'Ключ от хранилища Приливного камня','','','','От долгих лет пребывания в условиях высокой влажности залов академии этот ключ совсем заржавел.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(122188,-1,'Тусклый силовой кристалл','','','','Кристалл, переполненный магической энергией, издает тихое бренчание.',65536,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(122153,-1,'Заряженный самоцвет маны','','','','Потрескивает от содержащейся в нем силовой энергии.',65536,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,21384),
(139619,-1,'Ymiron\'s Broken Blade','','','','',67584,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,43604,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,21737),
(22058,-1,'Papel de Carta de Dia dos Namorados','','','','',0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,21737),
(18154,-1,'Timbre da Blizzard','','','','',0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21737),
(8164,-1,'Test Stationery','','','','',16,0,8388608,0,0,0,0,10,2,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21737),
(138019,-1,'Эпохальный ключ','','','','Положите ключ в Чашу силы в подземелье в эпохальном режиме.',65536,64,8388608,0,0,0,0,2000,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,1,0,0,0,0,0,0,0,0,23171),
(160000,-1,'Рубашка Пути Иллидана (Постоянный эффект)','','','','Словно приспешник Иллидана, вы оставляете за собой пылающий след Скверны...',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160001,-1,'Рубашка Могущества Сюэня (Постоянный эффект)','','','','Могущество Сюэня всегда будет с вами. Для этого вам совсем не нужен плащ...',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160002,-1,'Рубашка Доброты Чи-Цзи (Постоянный эффект)','','','','Доброта Чи-Цзи будет всегда с вами. Для этого вам совсем не нужен плащ...',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160003,-1,'Рубашка Дыхания Юй-Лун (Постоянный эффект)','','','','Дыхание Юй-Лун будет всегда с вами. Для этого вам совсем не нужен плащ...',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160004,-1,'Рубашка Стойкости Нюцзао (Постоянный эффект)','','','','Стойкость Нюцзао всегда будет с вами. Для этого вам совсем не нужен плащ...',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160005,-1,'Рубашка Темной скорби (Средний эффект)','','','','Надевая эту рубашку, Вы чувствуете дрожь. Вы чувствуете ее темную силу.',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160006,-1,'Рубашка Повелителя Воронов','','','','Вас окружают духи воронов. Эти птицы явно что-то знают.',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160007,-1,'Рубашка Падающих Звезд','','','','Звезды падают к вашим ногам. Успейте загадать желание.',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160008,-1,'Рубашка Парящих Бабочек','','','','Вы выглядите превосходно. Ваша привлекательность манит даже бабочек.',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160009,-1,'Рубашка Темной скорби (Сильный эффект)','','','','Надевая эту рубашку, Вы ощущаете дрожь. Вы чувствуете ее темную силу.',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160011,-1,'Рубашка Пути Кенария (Постоянный эффект)','','','','Ваш персонаж будет оставлять за собой цветущую тропу.',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(113282,-1,'Глаз Анзу','','','','Средоточие чар из темного прошлого Терокка',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1),
(111850,-1,'Перо Сита','','','','Приверженцы Рухмар предпочитают кремацию, а араккоа-изгои проводят',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1),
(124640,-1,'Чернильно-черное зелье','','','','Смешать две части растертых сушеных сверчков, одну часть чернил кал',0,0,0,0,0,0,0,33333,8333,0,20,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1),
(160020,-1,'Shadowmourne Monster Offhand (custom one-handed)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(138391,-1,'Чародейский усилитель','','','','Обычно используется для усиления заклинаний владельца',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1),
(160012,-1,'Ледяная Скорбь (Custom Two-handed)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160013,-1,'Шаламейн (Custom Two-handed)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(113010,-1,'р Литик','','','','Благословленный Литик браслет имеет особую связь с Терокком',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1),
(134005,-1,'Котел Одина','','','','Огромный котел, облицован древними рунами.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(133995,-1,'Рецепт Штормового Меда','','','','Рецепт представляет собой сложную диаграмму со множественными примечаниями и рисунками.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(135558,-1,'Lush Grass Seed','','','','',0,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1),
(160014,-1,'Пылающий меч с демоническим эфесом (custom one-handed)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160015,-1,'Латные наплечники святого воителя (Decorative Item)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(133898,-1,'Антология Лунных стражей','','','','Личные дела всех членов ордена Лунных стражей с момента его основания. Этому списку уже очень много лет.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(133899,-1,'Магический манифест Луны','','','','Зачитанный до дыр фолиант, в котором со всеми подробностями описана зависимость эффективности различных заклинаний от фаз Луны.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(133900,-1,'\"Последствия битвы за Источник\"','','','','Написанная от руки сводка наиболее значимых событий, произошедших после Раскола.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(133882,-1,'Руна-ловушка','','','','',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(133924,-1,'Ключ звездочета','','','','',67584,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(133999,-1,'Инертный кристалл','','','','',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(133675,-1,'Печать Лунного стража','','','','Обычно такими расписными талисманами владеют лишь самые талантливы.',65536,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(132371,-1,'Плавник','','','','\"Кусок выбеленной солнцем древесины.\"',65536,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(138308,-1,'Фляжка с манавином','','','','Вина смехотворно мало, но для многих даже это предел мечтаний.',65536,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(137295,-1,'Бутылка чародейского вина','','','','',65536,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(138389,-1,'Бутылка чародейского вина в подарочной упаковке','','','','',65536,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(136851,-1,'Шлем командира Домитилль','','','','',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40762,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(160016,-1,'Щит Света (Trans for donate)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160017,-1,'Облачение воина (Trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160018,-1,'Громовая Ярость, благословенный клинок Искателя Ветра (Custom Two-handed)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160019,-1,'Испепелитель (дополнительные эффекты) (custom one-handed)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160021,-1,'Рубашка Большого Сердца (Постоянный эффект)','','','','Рубашка пронизана крепкой любовью!',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160022,-1,'Громовая Ярость, благословенный клинок Искателя Ветра (Custom one-handed)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160023,-1,'Шаламейн (Custom One-handed)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(142065,-1,'Сумеречная Лилия Сигил','','','','A warm piece of enchanted stone carved in the shape of a lily.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(138205,-1,'Гьяллархорн','','','','Вырезанный из бивня большого зверя, этот впечатляющий рог несет глубокие угловые руны.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(139501,-1,'Барабаны племени Морозных Утесов','','','','',65536,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32767,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,100,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,24015),
(138204,-1,'Вещи Свергана','','','','',65536,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32767,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,100,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,24015),
(104350,-1,'Пыльца болотного светляка','','','','Сияет.',0,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1),
(112386,-1,'Осколок страдания','','','','',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1),
(111591,-1,'Эликсир ясного видения','','','','',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1),
(107076,-1,'Амулет иллюзий Силены','','','','',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1),
(111024,-1,'Чистая звездная лилия','','','','Полупрозрачный и невесомый цветок, растет только под светом звезд.',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1),
(100899,-1,'Артефакт погибшего орка из клана','','','','Crafted by Frostwolf orcs, this token is an honored remembrance of its fallen owner.',0,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1),
(160024,-1,'Нет перчаток (Trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(137182,-1,'Корона забытого короля','','','','Эту простую, но хорошо изготовленную корону когда-то носил Король Сверган Покров Шторма. Высушенная кровь на нем означает насильственную кончину.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(137183,-1,'Печатка Покрова Шторма','','','','Знак клана бури.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(137184,-1,'Медальон наездника на драконе','','','','Крылья Штормового Дракона опираются на яркий камень в медальоне.',65536,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(102463,-1,'Клятва хранителя огня','','','','',268435456,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,1),
(112385,-1,'Карта звездного неба','','','','Подробная карта неба.',0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1),
(141360,-1,'[Fel-Ravaged Tome]','','','','[In spite of its current state, the tome vibrates with arcane energy.]',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1),
(141355,-1,'[Waterlogged Tome]','','','','[In spite of its current state, the tome vibrates with arcane energy.]',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1),
(141361,-1,'Cursed Tome','','','','A dark power struggles against you as you try to flip trough the pages.',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1),
(160025,-1,'Поножи Мучения (Trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(139380,-1,'Семена Сна','','','','',65536,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32767,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,100,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,24015),
(160026,-1,'Рубашка Радужной прелести','','','','Существует легенда, что ее носили сами единороги!',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(110723,-1,'Сосуд с жабьей слизью',NULL,NULL,NULL,'Светится.',0,0,0,0,0,0,0,0,0,0,20,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(114986,-1,'Ядовитые травы Тенетопи',NULL,NULL,NULL,'Обращаться осторожно.',2112,8192,0,0,0,0,0,0,0,0,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(160027,-1,'Шаламейн (Custom One-handed)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,3,0,0,0,0,0,0,0,0),
(160028,-1,'Иллиданка (left)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160029,-1,'Иллиданка (right)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160030,-1,'Гар\'таш, Молот Разрушителей (Custom two-handed)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160031,-1,'Гар\'таш, Молот Разрушителей (fire)(Custom two-handed)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160032,-1,'Гербовая Накидка Пути Иллидана (Постоянный эффект)','','','','Словно приспешник Иллидана, вы оставляете за собой пылающий след Скверны...',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160033,-1,'Энергетическая бригантина(Trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(140395,-1,'Стильные шпионские очки','','','','',65536,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32767,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,100,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,24015),
(160036,-1,'Сияющая корона Светоносного(Trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160034,-1,'Вал\'анир, молот древних королей (Custom One-handed)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,3,0,0,0,0,0,0,0,0),
(160035,-1,'Гербовая Накидка Нового Года (Постоянный эффект)','','','','Новый Год настигнет Вас даже в Азероте!',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160037,-1,'Сияющие наплечные щитки Светоносного(Trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(166000,-1,'Накидка Объятий Разрушителя','','','','Сила этого предмета безгранична. Время от времени у вас за спиной появляются крылья Гневиона.',67108864,8396800,8388864,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160038,-1,'Щит света (witout display) (Trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(166001,-1,'Рубашка Объятий Разрушителя','','','','Сила этого предмета безгранична. Время от времени у вас за спиной появляются крылья Гневиона.',67108864,8396800,8388864,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(166002,-1,'Накидка Бесконечной Радуги','','','','Куда бы Вы не отправились, Вас всюду преследует радуга.',67108864,8396800,8388864,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(166003,-1,'Рубашка Бесконечной Радуги','','','','Куда бы Вы не отправились, Вас всюду преследует радуга.',67108864,8396800,8388864,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(166004,-1,'Накидка пылающих крыльев','','','','Надев эту накидку, Вы ощущаете как у Вас появляются пылающие крылья.',67108864,8396800,8388864,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(166005,-1,'Рубашка пылающих крыльев','','','','Надев эту рубашку, Вы ощущаете как у Вас появляются пылающие крылья.',67108864,8396800,8388864,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160039,-1,'Лук Расколотого Острова (Trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,2,0,0,0,0,0,0,0,0),
(124524,-1,'Fel Axe','','','','',0,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(143630,-1,'Fel Axe','','','','',0,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160040,-1,'Оплечье магического урагана (Mythic) (Trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160041,-1,'Корона магического урагана (Mythic) (Trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160042,-1,'Перчатки магического урагана (Mythic) (Trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(102225,-1,'Загадка Роло',NULL,NULL,NULL,'The old piece of tattered parchment has barely survived the test of time.',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32974,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),
(160043,-1,'Гнев Дракона, вечный покой Таресгосы (Trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,2,0,0,0,0,0,0,0,0),
(160044,-1,'Клобук урагана (Trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160045,-1,'Благостное наплечье Вестии (Trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160046,-1,'Глефа Майев (Custom One-handed)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160047,-1,'Наручи божественного вливания (Trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(128340,-1,'Chieftain\'s Beads',NULL,NULL,NULL,'Simple wooden beads bound on a leather cord.',67584,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,38146,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0),
(160048,-1,'Глефа Майев (left) (Custom One-handed)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0),
(160049,-1,'Рубашка теневого рейдера (Постоянный эффект)','','','','Сама тьма поглощает вас!',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(142211,-1,'Древний свиток шал\'дорай','','','','Периодически по краям этого пергамента огненной вязью пробегают чар',65536,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(146310,-1,'Флакон жидкого пламени Скверны','','','','Внутри бурлит энергия Скверны, так и стремящаяся вырваться на волю.',65536,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(146311,-1,'Склянка оскверненной крови','','','','Горячая кровь так и пышет яростью.',65536,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(146312,-1,'Демонический пепел','','','','Тускло светится, излучая энергию Скверны.',65536,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(160050,-1,'Штаны наару(Trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(143918,-1,'Демонический пепел','','','','При прикосновении издает пронзительное агрессивное жужжание.',65536,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,1,0,0,0,0,0,0,0,0,0,0,0,24015),
(160051,-1,'Сияющие наголенники Светоносного(Trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160052,-1,'Сияющие рукавицы Светоносного(Trans only)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160053,-1,'Рубашка призрачного рейдера (Постоянный эффект)','','','','Вы будто стали наполовину призраком!',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0),
(160054,-1,'Гнев Дракона, вечный покой Таресгосы (Trans only) (Off-hand)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,2,0,0,0,0,0,0,0,0),
(160055,-1,'Атиеш, великий посох Хранителя (Trans only) (Off-hand)','','','','Only for trnas by donate',67108864,8396800,8388864,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3600,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,2,0,0,0,0,0,0,0,0),
(143931,-1,'Небольшая лодка',NULL,NULL,NULL,NULL,65600,8192,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,604800,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,1,0,0,0,0,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,23478);

/*Table structure for table `journal_encounter` */

DROP TABLE IF EXISTS `journal_encounter`;

CREATE TABLE `journal_encounter` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Description` text,
  `Map1` float NOT NULL DEFAULT '0',
  `Map2` float NOT NULL DEFAULT '0',
  `DungeonMapID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WorldMapAreaID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FirstSectionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `JournalInstanceID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DifficultyMask` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` int(11) NOT NULL DEFAULT '0',
  `MapDisplayConditionID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `journal_encounter` */

/*Table structure for table `journal_encounter_creature` */

DROP TABLE IF EXISTS `journal_encounter_creature`;

CREATE TABLE `journal_encounter_creature` (
  `Name` text,
  `Description` text,
  `CreatureDisplayInfoID` int(11) NOT NULL DEFAULT '0',
  `FileDataID` int(11) NOT NULL DEFAULT '0',
  `UiModelSceneID` int(11) NOT NULL DEFAULT '0',
  `JournalEncounterID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `journal_encounter_creature` */

/*Table structure for table `journal_encounter_creature_locale` */

DROP TABLE IF EXISTS `journal_encounter_creature_locale`;

CREATE TABLE `journal_encounter_creature_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `journal_encounter_creature_locale` */

/*Table structure for table `journal_encounter_item` */

DROP TABLE IF EXISTS `journal_encounter_item`;

CREATE TABLE `journal_encounter_item` (
  `ItemID` int(11) NOT NULL DEFAULT '0',
  `JournalEncounterID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DifficultyMask` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FactionMask` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `journal_encounter_item` */

/*Table structure for table `journal_encounter_locale` */

DROP TABLE IF EXISTS `journal_encounter_locale`;

CREATE TABLE `journal_encounter_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `journal_encounter_locale` */

/*Table structure for table `journal_encounter_section` */

DROP TABLE IF EXISTS `journal_encounter_section`;

CREATE TABLE `journal_encounter_section` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Title` text,
  `BodyText` text,
  `IconCreatureDisplayInfoID` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `IconFileDataID` int(11) NOT NULL DEFAULT '0',
  `JournalEncounterID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `NextSiblingSectionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FirstChildSectionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ParentSectionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Flags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `IconFlags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DifficultyMask` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `UiModelSceneID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `journal_encounter_section` */

/*Table structure for table `journal_encounter_section_locale` */

DROP TABLE IF EXISTS `journal_encounter_section_locale`;

CREATE TABLE `journal_encounter_section_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Title_lang` text,
  `BodyText_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `journal_encounter_section_locale` */

/*Table structure for table `journal_encounter_x_difficulty` */

DROP TABLE IF EXISTS `journal_encounter_x_difficulty`;

CREATE TABLE `journal_encounter_x_difficulty` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `DifficultyID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `journal_encounter_x_difficulty` */

/*Table structure for table `journal_encounter_x_map_loc` */

DROP TABLE IF EXISTS `journal_encounter_x_map_loc`;

CREATE TABLE `journal_encounter_x_map_loc` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Map1` float NOT NULL DEFAULT '0',
  `Map2` float NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `JournalEncounterID` int(11) NOT NULL DEFAULT '0',
  `DungeonMapID` int(11) NOT NULL DEFAULT '0',
  `MapDisplayConditionID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `journal_encounter_x_map_loc` */

/*Table structure for table `journal_instance` */

DROP TABLE IF EXISTS `journal_instance`;

CREATE TABLE `journal_instance` (
  `Name` text,
  `Description` text,
  `ButtonFileDataID` int(11) NOT NULL DEFAULT '0',
  `ButtonSmallFileDataID` int(11) NOT NULL DEFAULT '0',
  `BackgroundFileDataID` int(11) NOT NULL DEFAULT '0',
  `LoreFileDataID` int(11) NOT NULL DEFAULT '0',
  `MapID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AreaID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `journal_instance` */

/*Table structure for table `journal_instance_locale` */

DROP TABLE IF EXISTS `journal_instance_locale`;

CREATE TABLE `journal_instance_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `journal_instance_locale` */

/*Table structure for table `journal_item_x_difficulty` */

DROP TABLE IF EXISTS `journal_item_x_difficulty`;

CREATE TABLE `journal_item_x_difficulty` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `DifficultyID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `journal_item_x_difficulty` */

/*Table structure for table `journal_section_x_difficulty` */

DROP TABLE IF EXISTS `journal_section_x_difficulty`;

CREATE TABLE `journal_section_x_difficulty` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `DifficultyID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `journal_section_x_difficulty` */

/*Table structure for table `journal_tier` */

DROP TABLE IF EXISTS `journal_tier`;

CREATE TABLE `journal_tier` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `journal_tier` */

/*Table structure for table `journal_tier_locale` */

DROP TABLE IF EXISTS `journal_tier_locale`;

CREATE TABLE `journal_tier_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `journal_tier_locale` */

/*Table structure for table `journal_tier_x_instance` */

DROP TABLE IF EXISTS `journal_tier_x_instance`;

CREATE TABLE `journal_tier_x_instance` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `JournalTierID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `JournalInstanceID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `journal_tier_x_instance` */

/*Table structure for table `keychain` */

DROP TABLE IF EXISTS `keychain`;

CREATE TABLE `keychain` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Key1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key4` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key5` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key6` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key7` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key8` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key9` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key10` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key11` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key12` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key13` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key14` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key15` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key16` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key17` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key18` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key19` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key20` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key21` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key22` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key23` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key24` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key25` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key26` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key27` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key28` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key29` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key30` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key31` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key32` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `keychain` */

/*Table structure for table `keystone_affix` */

DROP TABLE IF EXISTS `keystone_affix`;

CREATE TABLE `keystone_affix` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Description` text,
  `Filedataid` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `keystone_affix` */

/*Table structure for table `keystone_affix_locale` */

DROP TABLE IF EXISTS `keystone_affix_locale`;

CREATE TABLE `keystone_affix_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `keystone_affix_locale` */

/*Table structure for table `language_words` */

DROP TABLE IF EXISTS `language_words`;

CREATE TABLE `language_words` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Word` text,
  `LanguageID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `language_words` */

/*Table structure for table `language_words_locale` */

DROP TABLE IF EXISTS `language_words_locale`;

CREATE TABLE `language_words_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Word_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `language_words_locale` */

/*Table structure for table `languages` */

DROP TABLE IF EXISTS `languages`;

CREATE TABLE `languages` (
  `Name` text,
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `languages` */

/*Table structure for table `languages_locale` */

DROP TABLE IF EXISTS `languages_locale`;

CREATE TABLE `languages_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `languages_locale` */

/*Table structure for table `lfg_dungeon_expansion` */

DROP TABLE IF EXISTS `lfg_dungeon_expansion`;

CREATE TABLE `lfg_dungeon_expansion` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `RandomID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ExpansionLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `HardLevelMin` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `HardLevelMax` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TargetLevelMin` int(11) NOT NULL DEFAULT '0',
  `TargetLevelMax` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `lfg_dungeon_expansion` */

/*Table structure for table `lfg_dungeon_group` */

DROP TABLE IF EXISTS `lfg_dungeon_group`;

CREATE TABLE `lfg_dungeon_group` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `OrderIndex` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ParentGroupId` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Typeid` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `lfg_dungeon_group` */

/*Table structure for table `lfg_dungeon_group_locale` */

DROP TABLE IF EXISTS `lfg_dungeon_group_locale`;

CREATE TABLE `lfg_dungeon_group_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `lfg_dungeon_group_locale` */

/*Table structure for table `lfg_dungeons` */

DROP TABLE IF EXISTS `lfg_dungeons`;

CREATE TABLE `lfg_dungeons` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Description` text,
  `Flags` int(10) unsigned NOT NULL DEFAULT '0',
  `MinGear` float NOT NULL DEFAULT '0',
  `MaxLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `TargetLevelMax` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MapID` smallint(6) NOT NULL DEFAULT '0',
  `RandomID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ScenarioID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FinalEncounterID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `BonusReputationAmount` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MentorItemLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RequiredPlayerConditionId` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MinLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TargetLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TargetLevelMin` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DifficultyID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TypeID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Faction` tinyint(4) NOT NULL DEFAULT '0',
  `ExpansionLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `GroupID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CountTank` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CountHealer` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CountDamage` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MinCountTank` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MinCountHealer` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MinCountDamage` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Substruct` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MentorCharLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `IconTextureFileID` int(11) NOT NULL DEFAULT '0',
  `RewardsBgTextureFileID` int(11) NOT NULL DEFAULT '0',
  `PopupBgTextureFileID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `lfg_dungeons` */

/*Table structure for table `lfg_dungeons_grouping_map` */

DROP TABLE IF EXISTS `lfg_dungeons_grouping_map`;

CREATE TABLE `lfg_dungeons_grouping_map` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `RandomLfgDungeonsID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `GroupID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `lfg_dungeons_grouping_map` */

/*Table structure for table `lfg_dungeons_locale` */

DROP TABLE IF EXISTS `lfg_dungeons_locale`;

CREATE TABLE `lfg_dungeons_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `lfg_dungeons_locale` */

/*Table structure for table `lfg_role_requirement` */

DROP TABLE IF EXISTS `lfg_role_requirement`;

CREATE TABLE `lfg_role_requirement` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `RoleType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `LfgDungeonsId` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `lfg_role_requirement` */

/*Table structure for table `light` */

DROP TABLE IF EXISTS `light`;

CREATE TABLE `light` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `GameCoordsX` float NOT NULL DEFAULT '0',
  `GameCoordsY` float NOT NULL DEFAULT '0',
  `GameCoordsZ` float NOT NULL DEFAULT '0',
  `GameFalloffStart` float NOT NULL DEFAULT '0',
  `GameFalloffEnd` float NOT NULL DEFAULT '0',
  `ContinentID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LightParamsID1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LightParamsID2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LightParamsID3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LightParamsID4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LightParamsID5` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LightParamsID6` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LightParamsID7` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LightParamsID8` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `light` */

/*Table structure for table `light_data` */

DROP TABLE IF EXISTS `light_data`;

CREATE TABLE `light_data` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `DirectColor` int(11) NOT NULL DEFAULT '0',
  `AmbientColor` int(11) NOT NULL DEFAULT '0',
  `SkyTopColor` int(10) unsigned NOT NULL DEFAULT '0',
  `SkyMiddleColor` int(11) NOT NULL DEFAULT '0',
  `SkyBand1Color` int(11) NOT NULL DEFAULT '0',
  `SkyBand2Color` int(10) unsigned NOT NULL DEFAULT '0',
  `SkySmogColor` int(11) NOT NULL DEFAULT '0',
  `SkyFogColor` int(11) NOT NULL DEFAULT '0',
  `SunColor` int(11) NOT NULL DEFAULT '0',
  `CloudSunColor` int(11) NOT NULL DEFAULT '0',
  `CloudEmissiveColor` int(11) NOT NULL DEFAULT '0',
  `CloudLayer1AmbientColor` int(11) NOT NULL DEFAULT '0',
  `CloudLayer2AmbientColor` int(11) NOT NULL DEFAULT '0',
  `OceanCloseColor` int(11) NOT NULL DEFAULT '0',
  `OceanFarColor` int(11) NOT NULL DEFAULT '0',
  `RiverCloseColor` int(11) NOT NULL DEFAULT '0',
  `RiverFarColor` int(11) NOT NULL DEFAULT '0',
  `ShadowOpacity` int(10) unsigned NOT NULL DEFAULT '0',
  `FogEnd` float NOT NULL DEFAULT '0',
  `FogScaler` float NOT NULL DEFAULT '0',
  `CloudDensity` float NOT NULL DEFAULT '0',
  `FogDensity` float NOT NULL DEFAULT '0',
  `FogHeight` float NOT NULL DEFAULT '0',
  `FogHeightScaler` float NOT NULL DEFAULT '0',
  `FogHeightDensity` float NOT NULL DEFAULT '0',
  `SunFogAngle` float NOT NULL DEFAULT '0',
  `EndFogColorDistance` float NOT NULL DEFAULT '0',
  `SunFogColor` int(11) NOT NULL DEFAULT '0',
  `EndFogColor` int(11) NOT NULL DEFAULT '0',
  `FogHeightColor` int(11) NOT NULL DEFAULT '0',
  `ColorGradingFileDataID` int(11) NOT NULL DEFAULT '0',
  `HorizonAmbientColor` int(11) NOT NULL DEFAULT '0',
  `GroundAmbientColor` int(11) NOT NULL DEFAULT '0',
  `LightParamID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Time` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `light_data` */

/*Table structure for table `light_params` */

DROP TABLE IF EXISTS `light_params`;

CREATE TABLE `light_params` (
  `Glow` float NOT NULL DEFAULT '0',
  `WaterShallowAlpha` float NOT NULL DEFAULT '0',
  `WaterDeepAlpha` float NOT NULL DEFAULT '0',
  `OceanShallowAlpha` float NOT NULL DEFAULT '0',
  `OceanDeepAlpha` float NOT NULL DEFAULT '0',
  `OverrideCelestialSphere1` float NOT NULL DEFAULT '0',
  `OverrideCelestialSphere2` float NOT NULL DEFAULT '0',
  `OverrideCelestialSphere3` float NOT NULL DEFAULT '0',
  `LightSkyboxID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `HighlightSky` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CloudTypeID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `light_params` */

/*Table structure for table `light_skybox` */

DROP TABLE IF EXISTS `light_skybox`;

CREATE TABLE `light_skybox` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `CelestialSkyboxFileDataID` int(11) NOT NULL DEFAULT '0',
  `SkyboxFileDataID` int(11) NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `light_skybox` */

/*Table structure for table `light_skybox_locale` */

DROP TABLE IF EXISTS `light_skybox_locale`;

CREATE TABLE `light_skybox_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `light_skybox_locale` */

/*Table structure for table `liquid_material` */

DROP TABLE IF EXISTS `liquid_material`;

CREATE TABLE `liquid_material` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `LVF` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `liquid_material` */

/*Table structure for table `liquid_object` */

DROP TABLE IF EXISTS `liquid_object`;

CREATE TABLE `liquid_object` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `FlowDirection` float NOT NULL DEFAULT '0',
  `FlowSpeed` float NOT NULL DEFAULT '0',
  `LiquidTypeID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Fishable` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Reflection` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `liquid_object` */

/*Table structure for table `liquid_type` */

DROP TABLE IF EXISTS `liquid_type`;

CREATE TABLE `liquid_type` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Texture1` text,
  `Texture2` text,
  `Texture3` text,
  `Texture4` text,
  `Texture5` text,
  `Texture6` text,
  `SpellID` int(10) unsigned NOT NULL DEFAULT '0',
  `MaxDarkenDepth` float NOT NULL DEFAULT '0',
  `FogDarkenIntensity` float NOT NULL DEFAULT '0',
  `AmbDarkenIntensity` float NOT NULL DEFAULT '0',
  `DirDarkenIntensity` float NOT NULL DEFAULT '0',
  `ParticleScale` float NOT NULL DEFAULT '0',
  `Color1` int(10) unsigned NOT NULL DEFAULT '0',
  `Color2` int(10) unsigned NOT NULL DEFAULT '0',
  `Float1` float NOT NULL DEFAULT '0',
  `Float2` float NOT NULL DEFAULT '0',
  `Float3` float NOT NULL DEFAULT '0',
  `Float4` float NOT NULL DEFAULT '0',
  `Float5` float NOT NULL DEFAULT '0',
  `Float6` float NOT NULL DEFAULT '0',
  `Float7` float NOT NULL DEFAULT '0',
  `Float8` float NOT NULL DEFAULT '0',
  `Float9` float NOT NULL DEFAULT '0',
  `Float10` float NOT NULL DEFAULT '0',
  `Float11` float NOT NULL DEFAULT '0',
  `Float12` float NOT NULL DEFAULT '0',
  `Float13` float NOT NULL DEFAULT '0',
  `Float14` float NOT NULL DEFAULT '0',
  `Float15` float NOT NULL DEFAULT '0',
  `Float16` float NOT NULL DEFAULT '0',
  `Float17` float NOT NULL DEFAULT '0',
  `Float18` float NOT NULL DEFAULT '0',
  `Int1` int(10) unsigned NOT NULL DEFAULT '0',
  `Int2` int(10) unsigned NOT NULL DEFAULT '0',
  `Int3` int(10) unsigned NOT NULL DEFAULT '0',
  `Int4` int(10) unsigned NOT NULL DEFAULT '0',
  `Flags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LightID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SoundBank` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ParticleMovement` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ParticleTexSlots` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaterialID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FrameCountTexture1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FrameCountTexture2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FrameCountTexture3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FrameCountTexture4` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FrameCountTexture5` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FrameCountTexture6` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SoundID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `liquid_type` */

/*Table structure for table `liquid_type_locale` */

DROP TABLE IF EXISTS `liquid_type_locale`;

CREATE TABLE `liquid_type_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `liquid_type_locale` */

/*Table structure for table `loading_screen_taxi_splines` */

DROP TABLE IF EXISTS `loading_screen_taxi_splines`;

CREATE TABLE `loading_screen_taxi_splines` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `LocX1` float NOT NULL DEFAULT '0',
  `LocX2` float NOT NULL DEFAULT '0',
  `LocX3` float NOT NULL DEFAULT '0',
  `LocX4` float NOT NULL DEFAULT '0',
  `LocX5` float NOT NULL DEFAULT '0',
  `LocX6` float NOT NULL DEFAULT '0',
  `LocX7` float NOT NULL DEFAULT '0',
  `LocX8` float NOT NULL DEFAULT '0',
  `LocX9` float NOT NULL DEFAULT '0',
  `LocX10` float NOT NULL DEFAULT '0',
  `LocY1` float NOT NULL DEFAULT '0',
  `LocY2` float NOT NULL DEFAULT '0',
  `LocY3` float NOT NULL DEFAULT '0',
  `LocY4` float NOT NULL DEFAULT '0',
  `LocY5` float NOT NULL DEFAULT '0',
  `LocY6` float NOT NULL DEFAULT '0',
  `LocY7` float NOT NULL DEFAULT '0',
  `LocY8` float NOT NULL DEFAULT '0',
  `LocY9` float NOT NULL DEFAULT '0',
  `LocY10` float NOT NULL DEFAULT '0',
  `PathID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LoadingScreenID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LegIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `loading_screen_taxi_splines` */

/*Table structure for table `loading_screens` */

DROP TABLE IF EXISTS `loading_screens`;

CREATE TABLE `loading_screens` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `NarrowScreenFileDataID` int(11) NOT NULL DEFAULT '0',
  `WideScreenFileDataID` int(11) NOT NULL DEFAULT '0',
  `WideScreen169FileDataID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `loading_screens` */

/*Table structure for table `locale` */

DROP TABLE IF EXISTS `locale`;

CREATE TABLE `locale` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `FontFileDataID` int(11) NOT NULL DEFAULT '0',
  `WowLocale` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Secondary` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ClientDisplayExpansion` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `locale` */

/*Table structure for table `location` */

DROP TABLE IF EXISTS `location`;

CREATE TABLE `location` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Pos1` float NOT NULL DEFAULT '0',
  `Pos2` float NOT NULL DEFAULT '0',
  `Pos3` float NOT NULL DEFAULT '0',
  `Rot1` float NOT NULL DEFAULT '0',
  `Rot2` float NOT NULL DEFAULT '0',
  `Rot3` float NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `location` */

/*Table structure for table `lock` */

DROP TABLE IF EXISTS `lock`;

CREATE TABLE `lock` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Index1` int(11) NOT NULL DEFAULT '0',
  `Index2` int(11) NOT NULL DEFAULT '0',
  `Index3` int(11) NOT NULL DEFAULT '0',
  `Index4` int(11) NOT NULL DEFAULT '0',
  `Index5` int(11) NOT NULL DEFAULT '0',
  `Index6` int(11) NOT NULL DEFAULT '0',
  `Index7` int(11) NOT NULL DEFAULT '0',
  `Index8` int(11) NOT NULL DEFAULT '0',
  `Skill1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Skill2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Skill3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Skill4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Skill5` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Skill6` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Skill7` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Skill8` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Type1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Type2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Type3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Type4` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Type5` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Type6` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Type7` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Type8` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Action1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Action2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Action3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Action4` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Action5` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Action6` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Action7` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Action8` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `lock` */

insert  into `lock`(`ID`,`Index1`,`Index2`,`Index3`,`Index4`,`Index5`,`Index6`,`Index7`,`Index8`,`Skill1`,`Skill2`,`Skill3`,`Skill4`,`Skill5`,`Skill6`,`Skill7`,`Skill8`,`Type1`,`Type2`,`Type3`,`Type4`,`Type5`,`Type6`,`Type7`,`Type8`,`Action1`,`Action2`,`Action3`,`Action4`,`Action5`,`Action6`,`Action7`,`Action8`,`VerifiedBuild`) values 
(2900,166508,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);

/*Table structure for table `lock_type` */

DROP TABLE IF EXISTS `lock_type`;

CREATE TABLE `lock_type` (
  `Name` text,
  `ResourceName` text,
  `Verb` text,
  `CursorName` text,
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `lock_type` */

/*Table structure for table `lock_type_locale` */

DROP TABLE IF EXISTS `lock_type_locale`;

CREATE TABLE `lock_type_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `ResourceName_lang` text,
  `Verb_lang` text,
  `CursorName_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `lock_type_locale` */

/*Table structure for table `look_at_controller` */

DROP TABLE IF EXISTS `look_at_controller`;

CREATE TABLE `look_at_controller` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ReactionEnableDistance` float NOT NULL DEFAULT '0',
  `ReactionGiveupDistance` float NOT NULL DEFAULT '0',
  `TorsoSpeedFactor` float NOT NULL DEFAULT '0',
  `HeadSpeedFactor` float NOT NULL DEFAULT '0',
  `ReactionEnableFOVDeg` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ReactionGiveupTimeMS` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ReactionIgnoreTimeMinMS` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ReactionIgnoreTimeMaxMS` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MaxTorsoYaw` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxTorsoYawWhileMoving` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxHeadYaw` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxHeadPitch` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ReactionWarmUpTimeMSMin` int(11) NOT NULL DEFAULT '0',
  `ReactionWarmUpTimeMSMax` int(11) NOT NULL DEFAULT '0',
  `ReactionGiveupFOVDeg` int(11) NOT NULL DEFAULT '0',
  `MaxTorsoPitchUp` int(11) NOT NULL DEFAULT '0',
  `MaxTorsoPitchDown` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `look_at_controller` */

/*Table structure for table `mail_template` */

DROP TABLE IF EXISTS `mail_template`;

CREATE TABLE `mail_template` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Body` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `mail_template` */

insert  into `mail_template`(`ID`,`Body`,`VerifiedBuild`) values 
(426,'$n!\r\n\r\nЯ заметил, что тебе удалось доставить потерянную посылку. Приношу свою благодарность!\r\n\r\nУ нас не хватает рук, и услуги хорошего курьера нам не помешают.\r\n\r\nЕсли тебя заинтересовало мое предложение, жду тебя в офисе за Торговой палатой волшебников.\r\n\r\n– Почтальон',26124);

/*Table structure for table `mail_template_locale` */

DROP TABLE IF EXISTS `mail_template_locale`;

CREATE TABLE `mail_template_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Body_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `mail_template_locale` */

insert  into `mail_template_locale`(`ID`,`locale`,`Body_lang`,`VerifiedBuild`) values 
(426,'enUS','$n!\r\n\r\nI noticed that you managed to deliver the lost parcel. I offer my thanks!\r\n\r\nWe do not have enough hands, and the services of a good courier will not prevent us.\r\n\r\nIf you are interested in my proposal, I\'m waiting for you at the office behind the Chamber of Wizards.\r\n\r\n- Postman',26124);

/*Table structure for table `managed_world_state` */

DROP TABLE IF EXISTS `managed_world_state`;

CREATE TABLE `managed_world_state` (
  `CurrentStageWorldStateID` int(11) NOT NULL DEFAULT '0',
  `ProgressWorldStateID` int(11) NOT NULL DEFAULT '0',
  `UpTimeSecs` int(11) NOT NULL DEFAULT '0',
  `DownTimeSecs` int(11) NOT NULL DEFAULT '0',
  `OccurrencesWorldStateID` int(11) NOT NULL DEFAULT '0',
  `AccumulationStateTargetValue` int(11) NOT NULL DEFAULT '0',
  `DepletionStateTargetValue` int(11) NOT NULL DEFAULT '0',
  `AccumulationAmountPerMinute` int(11) NOT NULL DEFAULT '0',
  `DepletionAmountPerMinute` int(11) NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `managed_world_state` */

/*Table structure for table `managed_world_state_buff` */

DROP TABLE IF EXISTS `managed_world_state_buff`;

CREATE TABLE `managed_world_state_buff` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `OccurrenceValue` int(10) unsigned NOT NULL DEFAULT '0',
  `BuffSpellID` int(11) NOT NULL DEFAULT '0',
  `PlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `ManagedWorldStateID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `managed_world_state_buff` */

/*Table structure for table `managed_world_state_input` */

DROP TABLE IF EXISTS `managed_world_state_input`;

CREATE TABLE `managed_world_state_input` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ManagedWorldStateID` int(11) NOT NULL DEFAULT '0',
  `QuestID` int(11) NOT NULL DEFAULT '0',
  `ValidInputConditionID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `managed_world_state_input` */

/*Table structure for table `manifest_interface_action_icon` */

DROP TABLE IF EXISTS `manifest_interface_action_icon`;

CREATE TABLE `manifest_interface_action_icon` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `manifest_interface_action_icon` */

/*Table structure for table `manifest_interface_data` */

DROP TABLE IF EXISTS `manifest_interface_data`;

CREATE TABLE `manifest_interface_data` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `FilePath` text,
  `FileName` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `manifest_interface_data` */

/*Table structure for table `manifest_interface_data_locale` */

DROP TABLE IF EXISTS `manifest_interface_data_locale`;

CREATE TABLE `manifest_interface_data_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `FilePath_lang` text,
  `FileName_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `manifest_interface_data_locale` */

/*Table structure for table `manifest_interface_item_icon` */

DROP TABLE IF EXISTS `manifest_interface_item_icon`;

CREATE TABLE `manifest_interface_item_icon` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `manifest_interface_item_icon` */

/*Table structure for table `manifest_interface_t_o_c_data` */

DROP TABLE IF EXISTS `manifest_interface_t_o_c_data`;

CREATE TABLE `manifest_interface_t_o_c_data` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `FilePath` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `manifest_interface_t_o_c_data` */

/*Table structure for table `manifest_interface_t_o_c_data_locale` */

DROP TABLE IF EXISTS `manifest_interface_t_o_c_data_locale`;

CREATE TABLE `manifest_interface_t_o_c_data_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `FilePath_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `manifest_interface_t_o_c_data_locale` */

/*Table structure for table `manifest_m_p3` */

DROP TABLE IF EXISTS `manifest_m_p3`;

CREATE TABLE `manifest_m_p3` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `manifest_m_p3` */

/*Table structure for table `map` */

DROP TABLE IF EXISTS `map`;

CREATE TABLE `map` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Directory` text,
  `MapName` text,
  `MapDescription0` text,
  `MapDescription1` text,
  `PvpShortDescription` text,
  `PvpLongDescription` text,
  `Flags1` int(10) unsigned NOT NULL DEFAULT '0',
  `Flags2` int(10) unsigned NOT NULL DEFAULT '0',
  `MinimapIconScale` float NOT NULL DEFAULT '0',
  `CorpsePosX` float NOT NULL DEFAULT '0',
  `CorpsePosY` float NOT NULL DEFAULT '0',
  `AreaTableID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LoadingScreenID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CorpseMapID` smallint(6) NOT NULL DEFAULT '0',
  `TimeOfDayOverride` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ParentMapID` smallint(6) NOT NULL DEFAULT '0',
  `CosmeticParentMapID` smallint(6) NOT NULL DEFAULT '0',
  `WindSettingsID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `InstanceType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MapType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ExpansionID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxPlayers` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TimeOffset` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `map` */

insert  into `map`(`ID`,`Directory`,`MapName`,`MapDescription0`,`MapDescription1`,`PvpShortDescription`,`PvpLongDescription`,`Flags1`,`Flags2`,`MinimapIconScale`,`CorpsePosX`,`CorpsePosY`,`AreaTableID`,`LoadingScreenID`,`CorpseMapID`,`TimeOfDayOverride`,`ParentMapID`,`CosmeticParentMapID`,`WindSettingsID`,`InstanceType`,`MapType`,`ExpansionID`,`MaxPlayers`,`TimeOffset`,`VerifiedBuild`) values 
(1101,'DeathMatch','DeathMatch','DeathMatch: Kill everyone','DeathMatch: Kill everyone','DeathMatch: Kill everyone','DeathMatch: Kill everyone',8396381,8,1,0,0,0,251,-1,65535,-1,-1,0,3,1,4,0,0,23911),
(1156,'Stormgarde Keep','Разлом: Крепость Стромгард',NULL,NULL,NULL,NULL,0,0,1,0,0,12002,251,1156,65535,-1,-1,0,0,1,0,0,0,0),
(2100,'PVPZone03','Поддержка Песни Войны',NULL,NULL,NULL,NULL,0,0,1,0,0,3277,122,0,65535,-1,-1,0,0,1,0,0,0,0),
(1178,'Azeroth','Разлом: Крепость Стромгард',NULL,NULL,NULL,NULL,0,0,1,0,0,12002,251,1178,65535,-1,-1,0,0,1,0,0,0,0),
(1678,'ABWinter','Зимняя Низина',NULL,NULL,NULL,NULL,0,0,1,0,0,12004,425,0,65535,-1,-1,0,0,1,0,0,0,0),
(1180,'SuramarRaid','Цитадель Ночи Quest',NULL,NULL,NULL,NULL,1553,8,1,0,0,0,412,-1,65535,-1,-1,0,5,1,0,1,0,0);

/*Table structure for table `map_celestial_body` */

DROP TABLE IF EXISTS `map_celestial_body`;

CREATE TABLE `map_celestial_body` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `CelestialBodyID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `map_celestial_body` */

/*Table structure for table `map_challenge_mode` */

DROP TABLE IF EXISTS `map_challenge_mode`;

CREATE TABLE `map_challenge_mode` (
  `Name` text,
  `ID` int(11) NOT NULL DEFAULT '0',
  `MapID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CriteriaCount1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CriteriaCount2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CriteriaCount3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `map_challenge_mode` */

/*Table structure for table `map_challenge_mode_locale` */

DROP TABLE IF EXISTS `map_challenge_mode_locale`;

CREATE TABLE `map_challenge_mode_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `map_challenge_mode_locale` */

/*Table structure for table `map_difficulty` */

DROP TABLE IF EXISTS `map_difficulty`;

CREATE TABLE `map_difficulty` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Message` text,
  `DifficultyID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ResetInterval` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxPlayers` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LockID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ItemContext` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ItemContextPickerID` int(11) NOT NULL DEFAULT '0',
  `MapID` smallint(6) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `map_difficulty` */

insert  into `map_difficulty`(`ID`,`Message`,`DifficultyID`,`ResetInterval`,`MaxPlayers`,`LockID`,`Flags`,`ItemContext`,`ItemContextPickerID`,`MapID`,`VerifiedBuild`) values 
(2675,'',12,0,1,0,0,0,0,1112,0),
(4019,NULL,1,0,1,0,0,0,0,1180,0),
(2786,'',12,0,1,0,0,0,0,1051,0),
(4017,NULL,0,0,0,0,0,0,0,2100,0),
(4016,NULL,0,0,0,0,0,0,0,1178,0),
(4018,NULL,0,0,0,0,0,0,0,1678,0);

/*Table structure for table `map_difficulty_locale` */

DROP TABLE IF EXISTS `map_difficulty_locale`;

CREATE TABLE `map_difficulty_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Message_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `map_difficulty_locale` */

/*Table structure for table `map_difficulty_x_condition` */

DROP TABLE IF EXISTS `map_difficulty_x_condition`;

CREATE TABLE `map_difficulty_x_condition` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `FailureDescription` text,
  `PlayerConditionID` int(10) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` int(11) NOT NULL DEFAULT '0',
  `MapDifficultyId` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `map_difficulty_x_condition` */

insert  into `map_difficulty_x_condition`(`ID`,`FailureDescription`,`PlayerConditionID`,`OrderIndex`,`MapDifficultyId`,`VerifiedBuild`) values 
(1166,NULL,0,0,0,0),
(1165,NULL,0,0,0,0),
(1164,NULL,0,0,0,0),
(1133,NULL,0,0,0,0),
(1134,NULL,0,0,0,0),
(1135,NULL,0,0,0,0);

/*Table structure for table `map_difficulty_x_condition_locale` */

DROP TABLE IF EXISTS `map_difficulty_x_condition_locale`;

CREATE TABLE `map_difficulty_x_condition_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `FailureDescription_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `map_difficulty_x_condition_locale` */

/*Table structure for table `map_loading_screen` */

DROP TABLE IF EXISTS `map_loading_screen`;

CREATE TABLE `map_loading_screen` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Min1` float NOT NULL DEFAULT '0',
  `Min2` float NOT NULL DEFAULT '0',
  `Max1` float NOT NULL DEFAULT '0',
  `Max2` float NOT NULL DEFAULT '0',
  `LoadingScreenID` int(11) NOT NULL DEFAULT '0',
  `OrderIndex` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `map_loading_screen` */

/*Table structure for table `map_locale` */

DROP TABLE IF EXISTS `map_locale`;

CREATE TABLE `map_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Directory_lang` text,
  `MapName_lang` text,
  `MapDescription0_lang` text,
  `MapDescription1_lang` text,
  `PvpShortDescription_lang` text,
  `PvpLongDescription_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `map_locale` */

/*Table structure for table `marketing_promotions_x_locale` */

DROP TABLE IF EXISTS `marketing_promotions_x_locale`;

CREATE TABLE `marketing_promotions_x_locale` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `AcceptURL` text,
  `AdTexture` int(11) NOT NULL DEFAULT '0',
  `LogoTexture` int(11) NOT NULL DEFAULT '0',
  `AcceptButtonTexture` int(11) NOT NULL DEFAULT '0',
  `DeclineButtonTexture` int(11) NOT NULL DEFAULT '0',
  `PromotionID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LocaleID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `marketing_promotions_x_locale` */

/*Table structure for table `marketing_promotions_x_locale_locale` */

DROP TABLE IF EXISTS `marketing_promotions_x_locale_locale`;

CREATE TABLE `marketing_promotions_x_locale_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `AcceptURL_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `marketing_promotions_x_locale_locale` */

/*Table structure for table `material` */

DROP TABLE IF EXISTS `material`;

CREATE TABLE `material` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FoleySoundID` int(11) NOT NULL DEFAULT '0',
  `SheatheSoundID` int(11) NOT NULL DEFAULT '0',
  `UnsheatheSoundID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `material` */

/*Table structure for table `missile_targeting` */

DROP TABLE IF EXISTS `missile_targeting`;

CREATE TABLE `missile_targeting` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `TurnLingering` float NOT NULL DEFAULT '0',
  `PitchLingering` float NOT NULL DEFAULT '0',
  `MouseLingering` float NOT NULL DEFAULT '0',
  `EndOpacity` float NOT NULL DEFAULT '0',
  `ArcSpeed` float NOT NULL DEFAULT '0',
  `ArcRepeat` float NOT NULL DEFAULT '0',
  `ArcWidth` float NOT NULL DEFAULT '0',
  `ImpactRadius1` float NOT NULL DEFAULT '0',
  `ImpactRadius2` float NOT NULL DEFAULT '0',
  `ImpactTexRadius` float NOT NULL DEFAULT '0',
  `ArcTextureFileID` int(11) NOT NULL DEFAULT '0',
  `ImpactTextureFileID` int(11) NOT NULL DEFAULT '0',
  `ImpactModelFileID1` int(11) NOT NULL DEFAULT '0',
  `ImpactModelFileID2` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `missile_targeting` */

/*Table structure for table `model_anim_cloak_dampening` */

DROP TABLE IF EXISTS `model_anim_cloak_dampening`;

CREATE TABLE `model_anim_cloak_dampening` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `AnimationDataID` int(11) NOT NULL DEFAULT '0',
  `CloakDampeningID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `model_anim_cloak_dampening` */

/*Table structure for table `model_file_data` */

DROP TABLE IF EXISTS `model_file_data`;

CREATE TABLE `model_file_data` (
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LodCount` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `ModelResourcesID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `model_file_data` */

/*Table structure for table `model_ribbon_quality` */

DROP TABLE IF EXISTS `model_ribbon_quality`;

CREATE TABLE `model_ribbon_quality` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `RibbonQualityID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `model_ribbon_quality` */

/*Table structure for table `modifier_tree` */

DROP TABLE IF EXISTS `modifier_tree`;

CREATE TABLE `modifier_tree` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Asset` int(10) unsigned NOT NULL DEFAULT '0',
  `SecondaryAsset` int(11) NOT NULL DEFAULT '0',
  `Parent` int(11) NOT NULL DEFAULT '0',
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TertiaryAsset` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Operator` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Amount` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `modifier_tree` */

insert  into `modifier_tree`(`ID`,`Asset`,`SecondaryAsset`,`Parent`,`Type`,`TertiaryAsset`,`Operator`,`Amount`,`VerifiedBuild`) values 
(245,1519,0,244,17,0,2,1,23911),
(31441,2,0,31440,68,0,3,1,-1),
(319,4395,0,318,17,0,2,1,-1),
(5909,5840,0,5908,17,0,2,1,-1),
(3506,3703,0,3505,17,0,2,1,-1),
(20893,5146,0,20892,17,0,2,1,-1),
(20906,493,0,20905,17,0,2,1,-1),
(20911,1941,0,20909,17,0,2,1,-1),
(20915,25,0,20912,17,0,2,1,-1),
(20922,6453,0,20920,17,0,2,1,-1),
(21044,6912,0,20935,17,0,2,1,-1),
(21045,7200,0,20935,17,0,2,1,-1),
(20939,4945,0,20937,17,0,2,1,-1),
(4278,1519,0,4277,17,0,2,1,-1),
(4286,1637,0,4285,17,0,2,1,-1),
(65774,12072,0,65773,86,0,2,1,-1),
(65775,49224,0,65773,84,0,2,1,-1),
(67364,49224,0,65773,110,0,2,1,-1);

/*Table structure for table `mount` */

DROP TABLE IF EXISTS `mount`;

CREATE TABLE `mount` (
  `Name` text,
  `Description` text,
  `SourceText` text,
  `SourceSpellID` int(11) NOT NULL DEFAULT '0',
  `MountFlyRideHeight` float NOT NULL DEFAULT '0',
  `MountTypeID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Flags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SourceTypeEnum` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `PlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `UiModelSceneID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `mount` */

insert  into `mount`(`Name`,`Description`,`SourceText`,`SourceSpellID`,`MountFlyRideHeight`,`MountTypeID`,`Flags`,`SourceTypeEnum`,`ID`,`PlayerConditionID`,`UiModelSceneID`,`VerifiedBuild`) values 
('Magmatic hound','Previously these dogs used for tracking and killing. But later they became also riding animals.','Reward for  New Year Event.',305002,0,230,0,2,5000,0,45,1),
('Tarecgosa\'s Visage','Transforms you into Tarecgosa\'s Visage, allowing you to fly very fast.','Special server rewards',101641,0,248,64,1,5001,0,4,0),
('Magic Broom',NULL,NULL,47977,0,248,64,1,5002,0,0,0),
('Affected Abyss Bird of Fire','After the connection with the abyss, the rage of these birds became even more...','Special Project Awards',305184,0,230,0,2,5010,0,4,0),
('Blue Phoenix','Birds of unprecedented beauty.','Special Project Awards',305185,0,248,0,2,5011,0,4,0),
('Lilac Phoenix','Birds of unprecedented beauty.','Special Project Awards',305186,0,248,0,2,5012,0,4,0),
('Blazing phoenix','Birds of unprecedented beauty.','Special Project Awards',305187,0,248,0,2,5013,0,4,0),
('Provinces of Bad Claws','The Blazing Legion has experimented with the desecration of many animal species. Including fire birds from volcanic worlds.','Special Project Awards',305188,0,230,0,2,5014,0,4,0),
('Xuen child','Do you like cats?','Special Project Awards',305189,0,230,0,2,5015,0,4,0),
('The Loké\'nahak Provinces','Do you like cats?','Special Project Awards',305190,0,230,0,2,5016,0,4,0),
('Illidari Badger','Illidari\'s tame badass. It\'s terrible, but you can walk.','Special Project Awards',305191,0,248,0,2,5017,0,4,0),
('Phantom hippogriff','Causes the Hippogriff\'s Spirit.','Special Project Awards',305192,0,248,0,2,5018,0,4,0),
('Kul-Tiras Horse','Kul-Tiras horses are tamed from an early age not to be afraid of the sea and are raced along the coast in a myriad of salty splashes.','Special Project Awards',305193,0,230,0,2,5019,0,4,0),
('Zuldazar\'s Lizard','A means of transportation to become High Priests and Zandalari Elders, adorned with exquisite harness and blessed by Rezan, the greatest of the devils.','Special Project Awards',305194,0,230,0,2,5020,0,4,0),
('Shu-tsen, Divine Guardian.','While the Golden Lotus pandarans struggled to restore the Eternal Blossoming Dol, one statue came to life and silently protected them from Shah attacks. Some consider Shu-tsen a symbol of luck, others a gift of light. He will be a faithful companion to any hero who dares to defend Azeroth from the mad whispering of the ancient gods.','Special Project Awards',305195,0,248,0,2,5021,0,4,0),
('Somber Dawn','','New Year event 2019',305286,0,230,0,2,5022,0,4,0),
('Red Illidari Felbat','','New Year event 2019',305288,0,248,0,2,5023,0,4,0),
('Tarecgosa\'s Visage','The power of staff doesn\'t need anymore. You can transform into Tarecgosa anytime.','Special project rewards',305297,0,248,0,2,5025,0,4,0);

/*Table structure for table `mount_capability` */

DROP TABLE IF EXISTS `mount_capability`;

CREATE TABLE `mount_capability` (
  `ReqSpellKnownID` int(11) NOT NULL DEFAULT '0',
  `ModSpellAuraID` int(11) NOT NULL DEFAULT '0',
  `ReqRidingSkill` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ReqAreaID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ReqMapID` smallint(6) NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `ReqSpellAuraID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `mount_capability` */

insert  into `mount_capability`(`ReqSpellKnownID`,`ModSpellAuraID`,`ReqRidingSkill`,`ReqAreaID`,`ReqMapID`,`Flags`,`ID`,`ReqSpellAuraID`,`VerifiedBuild`) values 
(0,0,75,0,0,0,5000,0,1),
(0,0,75,0,0,0,5010,0,1),
(0,0,75,0,0,0,5011,0,1),
(0,0,75,0,0,0,5012,0,1),
(0,0,75,0,0,0,5013,0,1),
(0,0,75,0,0,0,5014,0,1),
(0,0,75,0,0,0,5015,0,1),
(0,0,75,0,0,0,5016,0,1),
(0,0,75,0,0,0,5017,0,1),
(0,0,75,0,0,0,5018,0,1),
(0,0,75,0,0,0,5019,0,1),
(0,0,75,0,0,0,5020,0,1),
(0,0,75,0,0,0,5021,0,1),
(0,0,75,0,0,0,5022,0,1),
(0,0,75,0,0,0,5023,0,1),
(0,0,75,0,0,0,5025,0,1);

/*Table structure for table `mount_locale` */

DROP TABLE IF EXISTS `mount_locale`;

CREATE TABLE `mount_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Description_lang` text,
  `SourceText_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `mount_locale` */

/*Table structure for table `mount_type_x_capability` */

DROP TABLE IF EXISTS `mount_type_x_capability`;

CREATE TABLE `mount_type_x_capability` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `MountTypeID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MountCapabilityID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `mount_type_x_capability` */

/*Table structure for table `mount_x_display` */

DROP TABLE IF EXISTS `mount_x_display`;

CREATE TABLE `mount_x_display` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `CreatureDisplayInfoID` int(11) NOT NULL DEFAULT '0',
  `PlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `MountID` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `mount_x_display` */

insert  into `mount_x_display`(`ID`,`CreatureDisplayInfoID`,`PlayerConditionID`,`MountID`,`VerifiedBuild`) values 
(3000,53450,0,5000,1),
(3010,83283,0,5010,1),
(3011,83285,0,5011,1),
(3012,83287,0,5012,1),
(3013,83281,0,5013,1),
(3014,38784,0,5014,1),
(3015,83288,0,5015,1),
(3016,83286,0,5016,1),
(3017,68896,0,5017,1),
(3018,74425,0,5018,1),
(3019,80357,0,5019,1),
(3020,80358,0,5020,1),
(3021,81772,0,5021,1),
(3022,83289,0,5022,1),
(3023,83291,0,5023,1),
(3025,38482,0,5025,1);

/*Table structure for table `movie` */

DROP TABLE IF EXISTS `movie`;

CREATE TABLE `movie` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `AudioFileDataID` int(11) NOT NULL DEFAULT '0',
  `SubtitleFileDataID` int(11) NOT NULL DEFAULT '0',
  `Volume` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `KeyID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `movie` */

/*Table structure for table `movie_file_data` */

DROP TABLE IF EXISTS `movie_file_data`;

CREATE TABLE `movie_file_data` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Resolution` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `movie_file_data` */

/*Table structure for table `movie_variation` */

DROP TABLE IF EXISTS `movie_variation`;

CREATE TABLE `movie_variation` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `FileDataID` int(11) NOT NULL DEFAULT '0',
  `OverlayFileDataID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `movie_variation` */

/*Table structure for table `n_p_c_model_item_slot_display_info` */

DROP TABLE IF EXISTS `n_p_c_model_item_slot_display_info`;

CREATE TABLE `n_p_c_model_item_slot_display_info` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ItemDisplayInfoID` int(11) NOT NULL DEFAULT '0',
  `ItemSlot` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `n_p_c_model_item_slot_display_info` */

/*Table structure for table `n_p_c_sounds` */

DROP TABLE IF EXISTS `n_p_c_sounds`;

CREATE TABLE `n_p_c_sounds` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SoundID1` int(11) NOT NULL DEFAULT '0',
  `SoundID2` int(11) NOT NULL DEFAULT '0',
  `SoundID3` int(11) NOT NULL DEFAULT '0',
  `SoundID4` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `n_p_c_sounds` */

/*Table structure for table `name_gen` */

DROP TABLE IF EXISTS `name_gen`;

CREATE TABLE `name_gen` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `RaceID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Sex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `name_gen` */

/*Table structure for table `names_profanity` */

DROP TABLE IF EXISTS `names_profanity`;

CREATE TABLE `names_profanity` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Language` tinyint(4) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `names_profanity` */

/*Table structure for table `names_reserved` */

DROP TABLE IF EXISTS `names_reserved`;

CREATE TABLE `names_reserved` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `names_reserved` */

/*Table structure for table `names_reserved_locale` */

DROP TABLE IF EXISTS `names_reserved_locale`;

CREATE TABLE `names_reserved_locale` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `LocaleMask` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `names_reserved_locale` */

/*Table structure for table `object_effect` */

DROP TABLE IF EXISTS `object_effect`;

CREATE TABLE `object_effect` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Offset1` float NOT NULL DEFAULT '0',
  `Offset2` float NOT NULL DEFAULT '0',
  `Offset3` float NOT NULL DEFAULT '0',
  `ObjectEffectGroupID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `TriggerType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EventType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EffectRecType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Attachment` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EffectRecID` int(11) NOT NULL DEFAULT '0',
  `ObjectEffectModifierID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `object_effect` */

/*Table structure for table `object_effect_modifier` */

DROP TABLE IF EXISTS `object_effect_modifier`;

CREATE TABLE `object_effect_modifier` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Param1` float NOT NULL DEFAULT '0',
  `Param2` float NOT NULL DEFAULT '0',
  `Param3` float NOT NULL DEFAULT '0',
  `Param4` float NOT NULL DEFAULT '0',
  `InputType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MapType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `OutputType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `object_effect_modifier` */

/*Table structure for table `object_effect_package_elem` */

DROP TABLE IF EXISTS `object_effect_package_elem`;

CREATE TABLE `object_effect_package_elem` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ObjectEffectPackageID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ObjectEffectGroupID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `StateType` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `object_effect_package_elem` */

/*Table structure for table `outline_effect` */

DROP TABLE IF EXISTS `outline_effect`;

CREATE TABLE `outline_effect` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Range` float NOT NULL DEFAULT '0',
  `UnitConditionID` int(11) NOT NULL DEFAULT '0',
  `PassiveHighlightColorID` int(11) NOT NULL DEFAULT '0',
  `HighlightColorID` int(11) NOT NULL DEFAULT '0',
  `Priority` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `outline_effect` */

/*Table structure for table `override_spell_data` */

DROP TABLE IF EXISTS `override_spell_data`;

CREATE TABLE `override_spell_data` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Spells1` int(11) NOT NULL DEFAULT '0',
  `Spells2` int(11) NOT NULL DEFAULT '0',
  `Spells3` int(11) NOT NULL DEFAULT '0',
  `Spells4` int(11) NOT NULL DEFAULT '0',
  `Spells5` int(11) NOT NULL DEFAULT '0',
  `Spells6` int(11) NOT NULL DEFAULT '0',
  `Spells7` int(11) NOT NULL DEFAULT '0',
  `Spells8` int(11) NOT NULL DEFAULT '0',
  `Spells9` int(11) NOT NULL DEFAULT '0',
  `Spells10` int(11) NOT NULL DEFAULT '0',
  `PlayerActionBarFileDataID` int(10) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `override_spell_data` */

/*Table structure for table `page_text_material` */

DROP TABLE IF EXISTS `page_text_material`;

CREATE TABLE `page_text_material` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `page_text_material` */

/*Table structure for table `page_text_material_locale` */

DROP TABLE IF EXISTS `page_text_material_locale`;

CREATE TABLE `page_text_material_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `page_text_material_locale` */

/*Table structure for table `paper_doll_item_frame` */

DROP TABLE IF EXISTS `paper_doll_item_frame`;

CREATE TABLE `paper_doll_item_frame` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ItemButtonName` text,
  `SlotNumber` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SlotIconFileID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `paper_doll_item_frame` */

/*Table structure for table `paper_doll_item_frame_locale` */

DROP TABLE IF EXISTS `paper_doll_item_frame_locale`;

CREATE TABLE `paper_doll_item_frame_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `ItemButtonName_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `paper_doll_item_frame_locale` */

/*Table structure for table `paragon_reputation` */

DROP TABLE IF EXISTS `paragon_reputation`;

CREATE TABLE `paragon_reputation` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `LevelThreshold` int(11) NOT NULL DEFAULT '0',
  `QuestID` int(11) NOT NULL DEFAULT '0',
  `FactionID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `paragon_reputation` */

/*Table structure for table `particle_color` */

DROP TABLE IF EXISTS `particle_color`;

CREATE TABLE `particle_color` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Start1` int(10) unsigned NOT NULL DEFAULT '0',
  `Start2` int(10) unsigned NOT NULL DEFAULT '0',
  `Start3` int(10) unsigned NOT NULL DEFAULT '0',
  `Mid1` int(10) unsigned NOT NULL DEFAULT '0',
  `Mid2` int(10) unsigned NOT NULL DEFAULT '0',
  `Mid3` int(10) unsigned NOT NULL DEFAULT '0',
  `End1` int(10) unsigned NOT NULL DEFAULT '0',
  `End2` int(10) unsigned NOT NULL DEFAULT '0',
  `End3` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `particle_color` */

/*Table structure for table `path` */

DROP TABLE IF EXISTS `path`;

CREATE TABLE `path` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SplineType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Red` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Green` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Blue` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Alpha` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `path` */

/*Table structure for table `path_node` */

DROP TABLE IF EXISTS `path_node`;

CREATE TABLE `path_node` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `LocationID` int(11) NOT NULL DEFAULT '0',
  `PathID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Sequence` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `path_node` */

/*Table structure for table `path_node_property` */

DROP TABLE IF EXISTS `path_node_property`;

CREATE TABLE `path_node_property` (
  `PathID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Sequence` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PropertyIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `Value` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `path_node_property` */

/*Table structure for table `path_property` */

DROP TABLE IF EXISTS `path_property`;

CREATE TABLE `path_property` (
  `Value` int(11) NOT NULL DEFAULT '0',
  `PathID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PropertyIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `path_property` */

/*Table structure for table `phase` */

DROP TABLE IF EXISTS `phase`;

CREATE TABLE `phase` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Flags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `phase` */

/*Table structure for table `phase_shift_zone_sounds` */

DROP TABLE IF EXISTS `phase_shift_zone_sounds`;

CREATE TABLE `phase_shift_zone_sounds` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `AreaID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PhaseID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PhaseGroupID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SoundAmbienceID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `UwSoundAmbienceID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WmoAreaID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PhaseUseFlags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SoundProviderPreferencesID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `UwSoundProviderPreferencesID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ZoneIntroMusicID` int(11) NOT NULL DEFAULT '0',
  `ZoneMusicID` int(11) NOT NULL DEFAULT '0',
  `UwZoneIntroMusicID` int(11) NOT NULL DEFAULT '0',
  `UwZoneMusicID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `phase_shift_zone_sounds` */

/*Table structure for table `phase_x_phase_group` */

DROP TABLE IF EXISTS `phase_x_phase_group`;

CREATE TABLE `phase_x_phase_group` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `PhaseID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PhaseGroupID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `phase_x_phase_group` */

/*Table structure for table `player_condition` */

DROP TABLE IF EXISTS `player_condition`;

CREATE TABLE `player_condition` (
  `RaceMask` bigint(20) NOT NULL DEFAULT '0',
  `FailureDescription` text,
  `ID` int(11) NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MinLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MaxLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ClassMask` int(11) NOT NULL DEFAULT '0',
  `Gender` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `NativeGender` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SkillLogic` int(11) NOT NULL DEFAULT '0',
  `LanguageID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MinLanguage` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxLanguage` int(11) NOT NULL DEFAULT '0',
  `MaxFactionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MaxReputation` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ReputationLogic` int(11) NOT NULL DEFAULT '0',
  `CurrentPvpFaction` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MinPVPRank` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxPVPRank` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PvpMedal` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PrevQuestLogic` int(11) NOT NULL DEFAULT '0',
  `CurrQuestLogic` int(11) NOT NULL DEFAULT '0',
  `CurrentCompletedQuestLogic` int(11) NOT NULL DEFAULT '0',
  `SpellLogic` int(11) NOT NULL DEFAULT '0',
  `ItemLogic` int(11) NOT NULL DEFAULT '0',
  `ItemFlags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AuraSpellLogic` int(11) NOT NULL DEFAULT '0',
  `WorldStateExpressionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WeatherID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PartyStatus` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LifetimeMaxPVPRank` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AchievementLogic` int(11) NOT NULL DEFAULT '0',
  `LfgLogic` int(11) NOT NULL DEFAULT '0',
  `AreaLogic` int(11) NOT NULL DEFAULT '0',
  `CurrencyLogic` int(11) NOT NULL DEFAULT '0',
  `QuestKillID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `QuestKillLogic` int(11) NOT NULL DEFAULT '0',
  `MinExpansionLevel` tinyint(4) NOT NULL DEFAULT '0',
  `MaxExpansionLevel` tinyint(4) NOT NULL DEFAULT '0',
  `MinExpansionTier` tinyint(4) NOT NULL DEFAULT '0',
  `MaxExpansionTier` tinyint(4) NOT NULL DEFAULT '0',
  `MinGuildLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxGuildLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PhaseUseFlags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PhaseID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PhaseGroupID` int(11) NOT NULL DEFAULT '0',
  `MinAvgItemLevel` int(11) NOT NULL DEFAULT '0',
  `MaxAvgItemLevel` int(11) NOT NULL DEFAULT '0',
  `MinAvgEquippedItemLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MaxAvgEquippedItemLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ChrSpecializationIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ChrSpecializationRole` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PowerType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PowerTypeComp` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PowerTypeValue` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ModifierTreeID` int(11) NOT NULL DEFAULT '0',
  `WeaponSubclassMask` int(11) NOT NULL DEFAULT '0',
  `SkillID1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SkillID2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SkillID3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SkillID4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MinSkill1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MinSkill2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MinSkill3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MinSkill4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MaxSkill1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MaxSkill2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MaxSkill3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MaxSkill4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MinFactionID1` int(11) NOT NULL DEFAULT '0',
  `MinFactionID2` int(11) NOT NULL DEFAULT '0',
  `MinFactionID3` int(11) NOT NULL DEFAULT '0',
  `MinReputation1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MinReputation2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MinReputation3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PrevQuestID1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PrevQuestID2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PrevQuestID3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PrevQuestID4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CurrQuestID1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CurrQuestID2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CurrQuestID3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CurrQuestID4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CurrentCompletedQuestID1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CurrentCompletedQuestID2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CurrentCompletedQuestID3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CurrentCompletedQuestID4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SpellID1` int(11) NOT NULL DEFAULT '0',
  `SpellID2` int(11) NOT NULL DEFAULT '0',
  `SpellID3` int(11) NOT NULL DEFAULT '0',
  `SpellID4` int(11) NOT NULL DEFAULT '0',
  `ItemID1` int(11) NOT NULL DEFAULT '0',
  `ItemID2` int(11) NOT NULL DEFAULT '0',
  `ItemID3` int(11) NOT NULL DEFAULT '0',
  `ItemID4` int(11) NOT NULL DEFAULT '0',
  `ItemCount1` int(11) NOT NULL DEFAULT '0',
  `ItemCount2` int(11) NOT NULL DEFAULT '0',
  `ItemCount3` int(11) NOT NULL DEFAULT '0',
  `ItemCount4` int(11) NOT NULL DEFAULT '0',
  `Explored1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Explored2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Time1` int(11) NOT NULL DEFAULT '0',
  `Time2` int(11) NOT NULL DEFAULT '0',
  `AuraSpellID1` int(11) NOT NULL DEFAULT '0',
  `AuraSpellID2` int(11) NOT NULL DEFAULT '0',
  `AuraSpellID3` int(11) NOT NULL DEFAULT '0',
  `AuraSpellID4` int(11) NOT NULL DEFAULT '0',
  `AuraStacks1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AuraStacks2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AuraStacks3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AuraStacks4` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Achievement1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Achievement2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Achievement3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Achievement4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LfgStatus1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LfgStatus2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LfgStatus3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LfgStatus4` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LfgCompare1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LfgCompare2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LfgCompare3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LfgCompare4` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LfgValue1` int(11) NOT NULL DEFAULT '0',
  `LfgValue2` int(11) NOT NULL DEFAULT '0',
  `LfgValue3` int(11) NOT NULL DEFAULT '0',
  `LfgValue4` int(11) NOT NULL DEFAULT '0',
  `AreaID1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AreaID2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AreaID3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AreaID4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CurrencyID1` int(11) NOT NULL DEFAULT '0',
  `CurrencyID2` int(11) NOT NULL DEFAULT '0',
  `CurrencyID3` int(11) NOT NULL DEFAULT '0',
  `CurrencyID4` int(11) NOT NULL DEFAULT '0',
  `CurrencyCount1` int(11) NOT NULL DEFAULT '0',
  `CurrencyCount2` int(11) NOT NULL DEFAULT '0',
  `CurrencyCount3` int(11) NOT NULL DEFAULT '0',
  `CurrencyCount4` int(11) NOT NULL DEFAULT '0',
  `QuestKillMonster1` int(11) NOT NULL DEFAULT '0',
  `QuestKillMonster2` int(11) NOT NULL DEFAULT '0',
  `QuestKillMonster3` int(11) NOT NULL DEFAULT '0',
  `QuestKillMonster4` int(11) NOT NULL DEFAULT '0',
  `QuestKillMonster5` int(11) NOT NULL DEFAULT '0',
  `QuestKillMonster6` int(11) NOT NULL DEFAULT '0',
  `MovementFlags1` int(11) NOT NULL DEFAULT '0',
  `MovementFlags2` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `player_condition` */

/*Table structure for table `player_condition_locale` */

DROP TABLE IF EXISTS `player_condition_locale`;

CREATE TABLE `player_condition_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `FailureDescription_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `player_condition_locale` */

/*Table structure for table `positioner` */

DROP TABLE IF EXISTS `positioner`;

CREATE TABLE `positioner` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `StartLife` float NOT NULL DEFAULT '0',
  `FirstStateID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `StartLifePercent` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `positioner` */

/*Table structure for table `positioner_state` */

DROP TABLE IF EXISTS `positioner_state`;

CREATE TABLE `positioner_state` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `EndLife` float NOT NULL DEFAULT '0',
  `EndLifePercent` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `NextStateID` int(11) NOT NULL DEFAULT '0',
  `TransformMatrixID` int(11) NOT NULL DEFAULT '0',
  `PosEntryID` int(11) NOT NULL DEFAULT '0',
  `RotEntryID` int(11) NOT NULL DEFAULT '0',
  `ScaleEntryID` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `positioner_state` */

/*Table structure for table `positioner_state_entry` */

DROP TABLE IF EXISTS `positioner_state_entry`;

CREATE TABLE `positioner_state_entry` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ParamA` float NOT NULL DEFAULT '0',
  `ParamB` float NOT NULL DEFAULT '0',
  `SrcValType` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SrcVal` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DstValType` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DstVal` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EntryType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Style` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SrcType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DstType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CurveID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `positioner_state_entry` */

/*Table structure for table `power_display` */

DROP TABLE IF EXISTS `power_display`;

CREATE TABLE `power_display` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `GlobalStringBaseTag` text,
  `ActualType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Red` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Green` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Blue` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `power_display` */

/*Table structure for table `power_display_locale` */

DROP TABLE IF EXISTS `power_display_locale`;

CREATE TABLE `power_display_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `GlobalStringBaseTag_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `power_display_locale` */

/*Table structure for table `power_type` */

DROP TABLE IF EXISTS `power_type`;

CREATE TABLE `power_type` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `NameGlobalStringTag` text,
  `CostGlobalStringTag` text,
  `RegenPeace` float NOT NULL DEFAULT '0',
  `RegenCombat` float NOT NULL DEFAULT '0',
  `MaxBasePower` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RegenInterruptTimeMS` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Flags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PowerTypeEnum` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MinPower` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CenterPower` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DefaultPower` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DisplayModifier` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `power_type` */

/*Table structure for table `power_type_locale` */

DROP TABLE IF EXISTS `power_type_locale`;

CREATE TABLE `power_type_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `NameGlobalStringTag_lang` text,
  `CostGlobalStringTag_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `power_type_locale` */

/*Table structure for table `prestige_level_info` */

DROP TABLE IF EXISTS `prestige_level_info`;

CREATE TABLE `prestige_level_info` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `BadgeTextureFileDataID` int(11) NOT NULL DEFAULT '0',
  `PrestigeLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `prestige_level_info` */

/*Table structure for table `prestige_level_info_locale` */

DROP TABLE IF EXISTS `prestige_level_info_locale`;

CREATE TABLE `prestige_level_info_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `prestige_level_info_locale` */

/*Table structure for table `pvp_bracket_types` */

DROP TABLE IF EXISTS `pvp_bracket_types`;

CREATE TABLE `pvp_bracket_types` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `BracketID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `WeeklyQuestID1` int(11) NOT NULL DEFAULT '0',
  `WeeklyQuestID2` int(11) NOT NULL DEFAULT '0',
  `WeeklyQuestID3` int(11) NOT NULL DEFAULT '0',
  `WeeklyQuestID4` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `pvp_bracket_types` */

/*Table structure for table `pvp_difficulty` */

DROP TABLE IF EXISTS `pvp_difficulty`;

CREATE TABLE `pvp_difficulty` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `RangeIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MinLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MapID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `pvp_difficulty` */

insert  into `pvp_difficulty`(`ID`,`RangeIndex`,`MinLevel`,`MaxLevel`,`MapID`,`VerifiedBuild`) values 
(1113,0,110,110,1101,23911);

/*Table structure for table `pvp_item` */

DROP TABLE IF EXISTS `pvp_item`;

CREATE TABLE `pvp_item` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ItemID` int(11) NOT NULL DEFAULT '0',
  `ItemLevelDelta` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `pvp_item` */

/*Table structure for table `pvp_reward` */

DROP TABLE IF EXISTS `pvp_reward`;

CREATE TABLE `pvp_reward` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `HonorLevel` int(11) NOT NULL DEFAULT '0',
  `PrestigeLevel` int(11) NOT NULL DEFAULT '0',
  `RewardPackID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `pvp_reward` */

/*Table structure for table `pvp_scaling_effect` */

DROP TABLE IF EXISTS `pvp_scaling_effect`;

CREATE TABLE `pvp_scaling_effect` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Value` float NOT NULL DEFAULT '0',
  `PvpScalingEffectTypeID` int(11) NOT NULL DEFAULT '0',
  `SpecializationID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `pvp_scaling_effect` */

/*Table structure for table `pvp_scaling_effect_type` */

DROP TABLE IF EXISTS `pvp_scaling_effect_type`;

CREATE TABLE `pvp_scaling_effect_type` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `pvp_scaling_effect_type` */

/*Table structure for table `pvp_scaling_effect_type_locale` */

DROP TABLE IF EXISTS `pvp_scaling_effect_type_locale`;

CREATE TABLE `pvp_scaling_effect_type_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `pvp_scaling_effect_type_locale` */

/*Table structure for table `pvp_talent` */

DROP TABLE IF EXISTS `pvp_talent`;

CREATE TABLE `pvp_talent` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `Description` text,
  `SpellID` int(10) unsigned NOT NULL DEFAULT '0',
  `OverrideSpellID` int(10) unsigned NOT NULL DEFAULT '0',
  `ExtraSpellID` int(10) unsigned NOT NULL DEFAULT '0',
  `TierID` int(10) unsigned NOT NULL DEFAULT '0',
  `ColumnIndex` int(10) unsigned NOT NULL DEFAULT '0',
  `Flags` int(10) unsigned NOT NULL DEFAULT '0',
  `ClassID` int(10) unsigned NOT NULL DEFAULT '0',
  `SpecID` int(10) unsigned NOT NULL DEFAULT '0',
  `Role` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `pvp_talent` */

/*Table structure for table `pvp_talent_locale` */

DROP TABLE IF EXISTS `pvp_talent_locale`;

CREATE TABLE `pvp_talent_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `pvp_talent_locale` */

/*Table structure for table `pvp_talent_unlock` */

DROP TABLE IF EXISTS `pvp_talent_unlock`;

CREATE TABLE `pvp_talent_unlock` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `TierID` int(10) unsigned NOT NULL DEFAULT '0',
  `ColumnIndex` int(10) unsigned NOT NULL DEFAULT '0',
  `HonorLevel` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `pvp_talent_unlock` */

/*Table structure for table `quest_faction_reward` */

DROP TABLE IF EXISTS `quest_faction_reward`;

CREATE TABLE `quest_faction_reward` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Difficulty1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Difficulty2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Difficulty3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Difficulty4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Difficulty5` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Difficulty6` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Difficulty7` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Difficulty8` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Difficulty9` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Difficulty10` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `quest_faction_reward` */

/*Table structure for table `quest_feedback_effect` */

DROP TABLE IF EXISTS `quest_feedback_effect`;

CREATE TABLE `quest_feedback_effect` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `FileDataID` int(11) NOT NULL DEFAULT '0',
  `MinimapAtlasMemberID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AttachPoint` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PassiveHighlightColorType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Priority` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `quest_feedback_effect` */

/*Table structure for table `quest_info` */

DROP TABLE IF EXISTS `quest_info`;

CREATE TABLE `quest_info` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `InfoName` text,
  `Profession` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Modifiers` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `quest_info` */

insert  into `quest_info`(`ID`,`InfoName`,`Profession`,`Type`,`Modifiers`,`VerifiedBuild`) values 
(149,'Invasion Point World Quest',0,2,10,26124),
(150,'Greater Invasion Point World Quest',0,2,10,26124);

/*Table structure for table `quest_info_locale` */

DROP TABLE IF EXISTS `quest_info_locale`;

CREATE TABLE `quest_info_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `InfoName_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `quest_info_locale` */

/*Table structure for table `quest_line` */

DROP TABLE IF EXISTS `quest_line`;

CREATE TABLE `quest_line` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `quest_line` */

/*Table structure for table `quest_line_locale` */

DROP TABLE IF EXISTS `quest_line_locale`;

CREATE TABLE `quest_line_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `quest_line_locale` */

/*Table structure for table `quest_line_x_quest` */

DROP TABLE IF EXISTS `quest_line_x_quest`;

CREATE TABLE `quest_line_x_quest` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `QuestLineID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `QuestID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `quest_line_x_quest` */

/*Table structure for table `quest_money_reward` */

DROP TABLE IF EXISTS `quest_money_reward`;

CREATE TABLE `quest_money_reward` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Difficulty1` int(11) NOT NULL DEFAULT '0',
  `Difficulty2` int(11) NOT NULL DEFAULT '0',
  `Difficulty3` int(11) NOT NULL DEFAULT '0',
  `Difficulty4` int(11) NOT NULL DEFAULT '0',
  `Difficulty5` int(11) NOT NULL DEFAULT '0',
  `Difficulty6` int(11) NOT NULL DEFAULT '0',
  `Difficulty7` int(11) NOT NULL DEFAULT '0',
  `Difficulty8` int(11) NOT NULL DEFAULT '0',
  `Difficulty9` int(11) NOT NULL DEFAULT '0',
  `Difficulty10` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `quest_money_reward` */

/*Table structure for table `quest_objective` */

DROP TABLE IF EXISTS `quest_objective`;

CREATE TABLE `quest_objective` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Description` text,
  `Amount` int(11) NOT NULL DEFAULT '0',
  `ObjectID` int(11) NOT NULL DEFAULT '0',
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `StorageIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `QuestID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `quest_objective` */

/*Table structure for table `quest_objective_locale` */

DROP TABLE IF EXISTS `quest_objective_locale`;

CREATE TABLE `quest_objective_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `quest_objective_locale` */

/*Table structure for table `quest_p_o_i_blob` */

DROP TABLE IF EXISTS `quest_p_o_i_blob`;

CREATE TABLE `quest_p_o_i_blob` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `MapID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WorldMapAreaID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `NumPoints` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Floor` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `QuestID` int(11) NOT NULL DEFAULT '0',
  `ObjectiveIndex` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `quest_p_o_i_blob` */

/*Table structure for table `quest_p_o_i_point` */

DROP TABLE IF EXISTS `quest_p_o_i_point`;

CREATE TABLE `quest_p_o_i_point` (
  `QuestPOIBlobID` int(10) unsigned NOT NULL DEFAULT '0',
  `X` smallint(6) NOT NULL DEFAULT '0',
  `Y` smallint(6) NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `quest_p_o_i_point` */

/*Table structure for table `quest_package_item` */

DROP TABLE IF EXISTS `quest_package_item`;

CREATE TABLE `quest_package_item` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ItemID` int(11) NOT NULL DEFAULT '0',
  `PackageID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DisplayType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ItemQuantity` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `quest_package_item` */

/*Table structure for table `quest_sort` */

DROP TABLE IF EXISTS `quest_sort`;

CREATE TABLE `quest_sort` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SortName` text,
  `UiOrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `quest_sort` */

/*Table structure for table `quest_sort_locale` */

DROP TABLE IF EXISTS `quest_sort_locale`;

CREATE TABLE `quest_sort_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `SortName_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `quest_sort_locale` */

/*Table structure for table `quest_v2` */

DROP TABLE IF EXISTS `quest_v2`;

CREATE TABLE `quest_v2` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `UniqueBitFlag` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `quest_v2` */

/*Table structure for table `quest_v2_cli_task` */

DROP TABLE IF EXISTS `quest_v2_cli_task`;

CREATE TABLE `quest_v2_cli_task` (
  `FiltRaces` bigint(20) NOT NULL DEFAULT '0',
  `QuestTitle` text,
  `BulletText` text,
  `StartItem` int(11) NOT NULL DEFAULT '0',
  `UniqueBitFlag` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ConditionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FiltClasses` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FiltCompletedQuest1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FiltCompletedQuest2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FiltCompletedQuest3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FiltMinSkillID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WorldStateExpressionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FiltActiveQuest` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FiltCompletedQuestLogic` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FiltMaxFactionID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FiltMaxFactionValue` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FiltMaxLevel` tinyint(4) NOT NULL DEFAULT '0',
  `FiltMinFactionID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FiltMinFactionValue` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FiltMinLevel` tinyint(4) NOT NULL DEFAULT '0',
  `FiltMinSkillValue` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FiltNonActiveQuest` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `BreadCrumbID` int(11) NOT NULL DEFAULT '0',
  `QuestInfoID` int(11) NOT NULL DEFAULT '0',
  `SandboxScalingID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `quest_v2_cli_task` */

/*Table structure for table `quest_v2_cli_task_locale` */

DROP TABLE IF EXISTS `quest_v2_cli_task_locale`;

CREATE TABLE `quest_v2_cli_task_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `QuestTitle_lang` text,
  `BulletText_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `quest_v2_cli_task_locale` */

/*Table structure for table `quest_x_group_activity` */

DROP TABLE IF EXISTS `quest_x_group_activity`;

CREATE TABLE `quest_x_group_activity` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `QuestID` int(11) NOT NULL DEFAULT '0',
  `GroupFinderActivityID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `quest_x_group_activity` */

/*Table structure for table `quest_xp` */

DROP TABLE IF EXISTS `quest_xp`;

CREATE TABLE `quest_xp` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Difficulty1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Difficulty2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Difficulty3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Difficulty4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Difficulty5` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Difficulty6` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Difficulty7` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Difficulty8` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Difficulty9` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Difficulty10` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `quest_xp` */

/*Table structure for table `rand_prop_points` */

DROP TABLE IF EXISTS `rand_prop_points`;

CREATE TABLE `rand_prop_points` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Epic1` int(11) NOT NULL DEFAULT '0',
  `Epic2` int(11) NOT NULL DEFAULT '0',
  `Epic3` int(11) NOT NULL DEFAULT '0',
  `Epic4` int(11) NOT NULL DEFAULT '0',
  `Epic5` int(11) NOT NULL DEFAULT '0',
  `Superior1` int(11) NOT NULL DEFAULT '0',
  `Superior2` int(11) NOT NULL DEFAULT '0',
  `Superior3` int(11) NOT NULL DEFAULT '0',
  `Superior4` int(11) NOT NULL DEFAULT '0',
  `Superior5` int(11) NOT NULL DEFAULT '0',
  `Good1` int(11) NOT NULL DEFAULT '0',
  `Good2` int(11) NOT NULL DEFAULT '0',
  `Good3` int(11) NOT NULL DEFAULT '0',
  `Good4` int(11) NOT NULL DEFAULT '0',
  `Good5` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `rand_prop_points` */

/*Table structure for table `relic_slot_tier_requirement` */

DROP TABLE IF EXISTS `relic_slot_tier_requirement`;

CREATE TABLE `relic_slot_tier_requirement` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `PlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `RelicIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RelicTier` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `relic_slot_tier_requirement` */

/*Table structure for table `relic_talent` */

DROP TABLE IF EXISTS `relic_talent`;

CREATE TABLE `relic_talent` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ArtifactPowerID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ArtifactPowerLabel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Type` int(11) NOT NULL DEFAULT '0',
  `PVal` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `relic_talent` */

/*Table structure for table `research_branch` */

DROP TABLE IF EXISTS `research_branch`;

CREATE TABLE `research_branch` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `ItemID` int(11) NOT NULL DEFAULT '0',
  `CurrencyID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ResearchFieldID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TextureFileID` int(11) NOT NULL DEFAULT '0',
  `BigTextureFileID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `research_branch` */

/*Table structure for table `research_branch_locale` */

DROP TABLE IF EXISTS `research_branch_locale`;

CREATE TABLE `research_branch_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `research_branch_locale` */

/*Table structure for table `research_field` */

DROP TABLE IF EXISTS `research_field`;

CREATE TABLE `research_field` (
  `Name` text,
  `Slot` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `research_field` */

/*Table structure for table `research_field_locale` */

DROP TABLE IF EXISTS `research_field_locale`;

CREATE TABLE `research_field_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `research_field_locale` */

/*Table structure for table `research_project` */

DROP TABLE IF EXISTS `research_project`;

CREATE TABLE `research_project` (
  `Name` text,
  `Description` text,
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `ResearchBranchID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Rarity` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `NumSockets` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `TextureFileID` int(11) NOT NULL DEFAULT '0',
  `RequiredWeight` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `research_project` */

/*Table structure for table `research_project_locale` */

DROP TABLE IF EXISTS `research_project_locale`;

CREATE TABLE `research_project_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `research_project_locale` */

/*Table structure for table `research_site` */

DROP TABLE IF EXISTS `research_site`;

CREATE TABLE `research_site` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `QuestPoiBlobID` int(11) NOT NULL DEFAULT '0',
  `MapID` smallint(6) NOT NULL DEFAULT '0',
  `AreaPOIIconEnum` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `research_site` */

/*Table structure for table `research_site_locale` */

DROP TABLE IF EXISTS `research_site_locale`;

CREATE TABLE `research_site_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `research_site_locale` */

/*Table structure for table `resistances` */

DROP TABLE IF EXISTS `resistances`;

CREATE TABLE `resistances` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FizzleSoundID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `resistances` */

/*Table structure for table `resistances_locale` */

DROP TABLE IF EXISTS `resistances_locale`;

CREATE TABLE `resistances_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `resistances_locale` */

/*Table structure for table `reward_pack` */

DROP TABLE IF EXISTS `reward_pack`;

CREATE TABLE `reward_pack` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Money` int(11) NOT NULL DEFAULT '0',
  `ArtifactXPMultiplier` float NOT NULL DEFAULT '0',
  `ArtifactXPDifficulty` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ArtifactXPCategoryID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CharTitleID` int(11) NOT NULL DEFAULT '0',
  `TreasurePickerID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `reward_pack` */

/*Table structure for table `reward_pack_x_currency_type` */

DROP TABLE IF EXISTS `reward_pack_x_currency_type`;

CREATE TABLE `reward_pack_x_currency_type` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `CurrencyTypeID` int(11) NOT NULL DEFAULT '0',
  `Quantity` int(11) NOT NULL DEFAULT '0',
  `RewardPackID` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `reward_pack_x_currency_type` */

/*Table structure for table `reward_pack_x_item` */

DROP TABLE IF EXISTS `reward_pack_x_item`;

CREATE TABLE `reward_pack_x_item` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ItemID` int(11) NOT NULL DEFAULT '0',
  `ItemQuantity` int(11) NOT NULL DEFAULT '0',
  `RewardPackID` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `reward_pack_x_item` */

/*Table structure for table `ribbon_quality` */

DROP TABLE IF EXISTS `ribbon_quality`;

CREATE TABLE `ribbon_quality` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `MaxSampleTimeDelta` float NOT NULL DEFAULT '0',
  `AngleThreshold` float NOT NULL DEFAULT '0',
  `MinDistancePerSlice` float NOT NULL DEFAULT '0',
  `NumStrips` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `ribbon_quality` */

/*Table structure for table `ruleset_item_upgrade` */

DROP TABLE IF EXISTS `ruleset_item_upgrade`;

CREATE TABLE `ruleset_item_upgrade` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ItemID` int(11) NOT NULL DEFAULT '0',
  `ItemUpgradeID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `ruleset_item_upgrade` */

/*Table structure for table `s_d_replacement_model` */

DROP TABLE IF EXISTS `s_d_replacement_model`;

CREATE TABLE `s_d_replacement_model` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SdFileDataID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `s_d_replacement_model` */

/*Table structure for table `sandbox_scaling` */

DROP TABLE IF EXISTS `sandbox_scaling`;

CREATE TABLE `sandbox_scaling` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `MinLevel` int(10) unsigned NOT NULL DEFAULT '0',
  `MaxLevel` int(10) unsigned NOT NULL DEFAULT '0',
  `Flags` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `sandbox_scaling` */

/*Table structure for table `scaling_stat_distribution` */

DROP TABLE IF EXISTS `scaling_stat_distribution`;

CREATE TABLE `scaling_stat_distribution` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `PlayerLevelToItemLevelCurveID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MinLevel` int(10) unsigned NOT NULL DEFAULT '0',
  `MaxLevel` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `scaling_stat_distribution` */

/*Table structure for table `scenario` */

DROP TABLE IF EXISTS `scenario`;

CREATE TABLE `scenario` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `AreaTableID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `scenario` */

insert  into `scenario`(`ID`,`Name`,`AreaTableID`,`Flags`,`Type`,`VerifiedBuild`) values 
(1,'Вторжение: Даларан',7581,0,4,1);

/*Table structure for table `scenario_locale` */

DROP TABLE IF EXISTS `scenario_locale`;

CREATE TABLE `scenario_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `scenario_locale` */

/*Table structure for table `scenario_step` */

DROP TABLE IF EXISTS `scenario_step`;

CREATE TABLE `scenario_step` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Description` text,
  `Title` text,
  `ScenarioID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Supersedes` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RewardQuestID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Criteriatreeid` int(11) NOT NULL DEFAULT '0',
  `RelatedStep` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `scenario_step` */

insert  into `scenario_step`(`ID`,`Description`,`Title`,`ScenarioID`,`Supersedes`,`RewardQuestID`,`OrderIndex`,`Flags`,`Criteriatreeid`,`RelatedStep`,`VerifiedBuild`) values 
(408,'Проскользните мимо стражи и проникните в Святилище Теней.','Войти в Черный храм',200,0,0,0,0,31008,0,0),
(410,'Следуйте за Акамой в Святилище Потерянных Душ.','Идти за Акамой в Святилище Потерянных Душ',200,0,0,1,0,31012,0,0),
(413,'Осмотрите Святилище Потерянных Душ.','Раскрыть план Совета',200,0,0,2,0,31019,0,0),
(414,'Заберите кристалл души, брошенный советом Мрачной Жатвы.','Победить сущность порядка',200,0,0,3,0,31017,0,0),
(415,'Отбейте атаку демонов, выпущенных Реликварием, и вернитесь к Акаме в Залы Страданий.','Бежать из Святилища Потерянных Душ',200,0,0,4,0,31021,0,0),
(416,'Соберите как можно больше сокровищ, пока не истекло время.','Ограбление Приюта Земных Наслаждений',200,0,0,5,0,31023,0,0),
(417,'Отнесите заряженную сущность души в Черный Храм.','К Храмовой вершине',200,0,0,6,0,31034,0,0),
(491,'Поместите заряженную сущность души в демонический источник душ и победите Канретада.','Победить Канретада',200,0,0,7,0,31858,0,0),
(3546,'Скармливайте шляпки находящихся поблизости спорохватов ослабевшим шаркунам, чтобы вернуть их к жизни.','Ободрение',1412,0,0,0,0,61058,0,0),
(1,'Eliminate the threat of the legion in dalaran','Dalaran Defense',1,0,43293,0,0,1,0,1),
(2,'Defeat Legion Commanders Threatening Dalaran','The victory over the commanders of the legion',1,0,43243,1,0,48783,0,1),
(3,'Repel the invading forces of the Legion in Dalaran','The reflection of the onslaught of the Legion',1,0,43294,2,0,48090,0,1),
(4,'Defeat the lord of the demons, the commander of the invasion of Dalaran','Death to the Demon Lord',1,0,43244,3,0,48938,0,1);

/*Table structure for table `scenario_step_locale` */

DROP TABLE IF EXISTS `scenario_step_locale`;

CREATE TABLE `scenario_step_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Description_lang` text,
  `Title_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `scenario_step_locale` */

/*Table structure for table `scene_script` */

DROP TABLE IF EXISTS `scene_script`;

CREATE TABLE `scene_script` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `FirstSceneScriptID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `NextSceneScriptID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `scene_script` */

/*Table structure for table `scene_script_global_text` */

DROP TABLE IF EXISTS `scene_script_global_text`;

CREATE TABLE `scene_script_global_text` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Script` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `scene_script_global_text` */

/*Table structure for table `scene_script_global_text_locale` */

DROP TABLE IF EXISTS `scene_script_global_text_locale`;

CREATE TABLE `scene_script_global_text_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Script_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `scene_script_global_text_locale` */

/*Table structure for table `scene_script_package` */

DROP TABLE IF EXISTS `scene_script_package`;

CREATE TABLE `scene_script_package` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `scene_script_package` */

/*Table structure for table `scene_script_package_locale` */

DROP TABLE IF EXISTS `scene_script_package_locale`;

CREATE TABLE `scene_script_package_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `scene_script_package_locale` */

/*Table structure for table `scene_script_package_member` */

DROP TABLE IF EXISTS `scene_script_package_member`;

CREATE TABLE `scene_script_package_member` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SceneScriptPackageID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SceneScriptID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ChildSceneScriptPackageID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `scene_script_package_member` */

/*Table structure for table `scene_script_text` */

DROP TABLE IF EXISTS `scene_script_text`;

CREATE TABLE `scene_script_text` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Script` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `scene_script_text` */

/*Table structure for table `scene_script_text_locale` */

DROP TABLE IF EXISTS `scene_script_text_locale`;

CREATE TABLE `scene_script_text_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Script_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `scene_script_text_locale` */

/*Table structure for table `scheduled_interval` */

DROP TABLE IF EXISTS `scheduled_interval`;

CREATE TABLE `scheduled_interval` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `RepeatType` int(11) NOT NULL DEFAULT '0',
  `DurationSecs` int(11) NOT NULL DEFAULT '0',
  `OffsetSecs` int(11) NOT NULL DEFAULT '0',
  `DateAlignmentType` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `scheduled_interval` */

/*Table structure for table `scheduled_world_state` */

DROP TABLE IF EXISTS `scheduled_world_state`;

CREATE TABLE `scheduled_world_state` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ScheduledWorldStateGroupID` int(11) NOT NULL DEFAULT '0',
  `WorldStateID` int(11) NOT NULL DEFAULT '0',
  `Value` int(11) NOT NULL DEFAULT '0',
  `DurationSecs` int(11) NOT NULL DEFAULT '0',
  `Weight` int(11) NOT NULL DEFAULT '0',
  `UniqueCategory` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `OrderIndex` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `scheduled_world_state` */

/*Table structure for table `scheduled_world_state_group` */

DROP TABLE IF EXISTS `scheduled_world_state_group`;

CREATE TABLE `scheduled_world_state_group` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `ScheduledIntervalID` int(11) NOT NULL DEFAULT '0',
  `SelectionType` int(11) NOT NULL DEFAULT '0',
  `SelectionCount` int(11) NOT NULL DEFAULT '0',
  `Priority` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `scheduled_world_state_group` */

/*Table structure for table `scheduled_world_state_x_uniq_cat` */

DROP TABLE IF EXISTS `scheduled_world_state_x_uniq_cat`;

CREATE TABLE `scheduled_world_state_x_uniq_cat` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ScheduledUniqueCategoryID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `scheduled_world_state_x_uniq_cat` */

/*Table structure for table `screen_effect` */

DROP TABLE IF EXISTS `screen_effect`;

CREATE TABLE `screen_effect` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Param1` int(10) unsigned NOT NULL DEFAULT '0',
  `Param2` int(10) unsigned NOT NULL DEFAULT '0',
  `Param3` int(10) unsigned NOT NULL DEFAULT '0',
  `Param4` int(10) unsigned NOT NULL DEFAULT '0',
  `LightParamsID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LightParamsFadeIn` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LightParamsFadeOut` smallint(5) unsigned NOT NULL DEFAULT '0',
  `TimeOfDayOverride` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Effect` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LightFlags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EffectMask` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `FullScreenEffectID` int(11) NOT NULL DEFAULT '0',
  `SoundAmbienceID` int(11) NOT NULL DEFAULT '0',
  `ZoneMusicID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `screen_effect` */

/*Table structure for table `screen_effect_locale` */

DROP TABLE IF EXISTS `screen_effect_locale`;

CREATE TABLE `screen_effect_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `screen_effect_locale` */

/*Table structure for table `screen_location` */

DROP TABLE IF EXISTS `screen_location`;

CREATE TABLE `screen_location` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `screen_location` */

/*Table structure for table `screen_location_locale` */

DROP TABLE IF EXISTS `screen_location_locale`;

CREATE TABLE `screen_location_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `screen_location_locale` */

/*Table structure for table `seamless_site` */

DROP TABLE IF EXISTS `seamless_site`;

CREATE TABLE `seamless_site` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `MapID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `seamless_site` */

/*Table structure for table `server_messages` */

DROP TABLE IF EXISTS `server_messages`;

CREATE TABLE `server_messages` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Text` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `server_messages` */

/*Table structure for table `server_messages_locale` */

DROP TABLE IF EXISTS `server_messages_locale`;

CREATE TABLE `server_messages_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Text_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `server_messages_locale` */

/*Table structure for table `shadowy_effect` */

DROP TABLE IF EXISTS `shadowy_effect`;

CREATE TABLE `shadowy_effect` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `PrimaryColor` int(10) unsigned NOT NULL DEFAULT '0',
  `SecondaryColor` int(10) unsigned NOT NULL DEFAULT '0',
  `Duration` float NOT NULL DEFAULT '0',
  `Value` float NOT NULL DEFAULT '0',
  `FadeInTime` float NOT NULL DEFAULT '0',
  `FadeOutTime` float NOT NULL DEFAULT '0',
  `InnerStrength` float NOT NULL DEFAULT '0',
  `OuterStrength` float NOT NULL DEFAULT '0',
  `InitialDelay` float NOT NULL DEFAULT '0',
  `AttachPos` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CurveID` int(11) NOT NULL DEFAULT '0',
  `Priority` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `shadowy_effect` */

/*Table structure for table `skill_line` */

DROP TABLE IF EXISTS `skill_line`;

CREATE TABLE `skill_line` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `DisplayName` text,
  `Description` text,
  `AlternateVerb` text,
  `Flags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CategoryID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CanLink` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SpellIconFileID` int(11) NOT NULL DEFAULT '0',
  `ParentSkillLineID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `skill_line` */

/*Table structure for table `skill_line_ability` */

DROP TABLE IF EXISTS `skill_line_ability`;

CREATE TABLE `skill_line_ability` (
  `RaceMask` bigint(20) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `Spell` int(10) unsigned NOT NULL DEFAULT '0',
  `SupercedesSpell` int(10) unsigned NOT NULL DEFAULT '0',
  `SkillLine` smallint(5) unsigned NOT NULL DEFAULT '0',
  `TrivialSkillLineRankHigh` smallint(5) unsigned NOT NULL DEFAULT '0',
  `TrivialSkillLineRankLow` smallint(5) unsigned NOT NULL DEFAULT '0',
  `UniqueBit` smallint(5) unsigned NOT NULL DEFAULT '0',
  `TradeSkillCategoryID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `NumSkillUps` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ClassMask` int(11) NOT NULL DEFAULT '0',
  `MinSkillLineRank` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AcquireMethod` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `skill_line_ability` */

/*Table structure for table `skill_line_locale` */

DROP TABLE IF EXISTS `skill_line_locale`;

CREATE TABLE `skill_line_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `DisplayName_lang` text,
  `Description_lang` text,
  `AlternateVerb_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `skill_line_locale` */

/*Table structure for table `skill_race_class_info` */

DROP TABLE IF EXISTS `skill_race_class_info`;

CREATE TABLE `skill_race_class_info` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `RaceMask` bigint(20) NOT NULL DEFAULT '0',
  `SkillID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Flags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SkillTierID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Availability` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MinLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ClassMask` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `skill_race_class_info` */

/*Table structure for table `sound_ambience` */

DROP TABLE IF EXISTS `sound_ambience`;

CREATE TABLE `sound_ambience` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SoundFilterID` int(11) NOT NULL DEFAULT '0',
  `FlavorSoundFilterID` int(11) NOT NULL DEFAULT '0',
  `AmbienceID1` int(11) NOT NULL DEFAULT '0',
  `AmbienceID2` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `sound_ambience` */

/*Table structure for table `sound_ambience_flavor` */

DROP TABLE IF EXISTS `sound_ambience_flavor`;

CREATE TABLE `sound_ambience_flavor` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SoundEntriesIDDay` int(11) NOT NULL DEFAULT '0',
  `SoundEntriesIDNight` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `sound_ambience_flavor` */

/*Table structure for table `sound_bus` */

DROP TABLE IF EXISTS `sound_bus`;

CREATE TABLE `sound_bus` (
  `DefaultVolume` float NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DefaultPlaybackLimit` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DefaultPriority` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DefaultPriorityPenalty` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `BusEnumID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `sound_bus` */

/*Table structure for table `sound_bus_override` */

DROP TABLE IF EXISTS `sound_bus_override`;

CREATE TABLE `sound_bus_override` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Volume` float NOT NULL DEFAULT '0',
  `PlaybackLimit` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Priority` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PriorityPenalty` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SoundBusID` int(11) NOT NULL DEFAULT '0',
  `PlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `sound_bus_override` */

/*Table structure for table `sound_emitter_pill_points` */

DROP TABLE IF EXISTS `sound_emitter_pill_points`;

CREATE TABLE `sound_emitter_pill_points` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Position1` float NOT NULL DEFAULT '0',
  `Position2` float NOT NULL DEFAULT '0',
  `Position3` float NOT NULL DEFAULT '0',
  `SoundEmittersID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `sound_emitter_pill_points` */

/*Table structure for table `sound_emitters` */

DROP TABLE IF EXISTS `sound_emitters`;

CREATE TABLE `sound_emitters` (
  `Name` text,
  `Position1` float NOT NULL DEFAULT '0',
  `Position2` float NOT NULL DEFAULT '0',
  `Position3` float NOT NULL DEFAULT '0',
  `Direction1` float NOT NULL DEFAULT '0',
  `Direction2` float NOT NULL DEFAULT '0',
  `Direction3` float NOT NULL DEFAULT '0',
  `WorldStateExpressionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PhaseID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EmitterType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PhaseUseFlags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `SoundEntriesID` int(11) NOT NULL DEFAULT '0',
  `PhaseGroupID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `sound_emitters` */

/*Table structure for table `sound_emitters_locale` */

DROP TABLE IF EXISTS `sound_emitters_locale`;

CREATE TABLE `sound_emitters_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `sound_emitters_locale` */

/*Table structure for table `sound_envelope` */

DROP TABLE IF EXISTS `sound_envelope`;

CREATE TABLE `sound_envelope` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SoundKitID` int(11) NOT NULL DEFAULT '0',
  `CurveID` int(11) NOT NULL DEFAULT '0',
  `DecayIndex` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SustainIndex` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ReleaseIndex` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EnvelopeType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `sound_envelope` */

/*Table structure for table `sound_filter` */

DROP TABLE IF EXISTS `sound_filter`;

CREATE TABLE `sound_filter` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `sound_filter` */

/*Table structure for table `sound_filter_elem` */

DROP TABLE IF EXISTS `sound_filter_elem`;

CREATE TABLE `sound_filter_elem` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Params1` float NOT NULL DEFAULT '0',
  `Params2` float NOT NULL DEFAULT '0',
  `Params3` float NOT NULL DEFAULT '0',
  `Params4` float NOT NULL DEFAULT '0',
  `Params5` float NOT NULL DEFAULT '0',
  `Params6` float NOT NULL DEFAULT '0',
  `Params7` float NOT NULL DEFAULT '0',
  `Params8` float NOT NULL DEFAULT '0',
  `Params9` float NOT NULL DEFAULT '0',
  `FilterType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `sound_filter_elem` */

/*Table structure for table `sound_filter_locale` */

DROP TABLE IF EXISTS `sound_filter_locale`;

CREATE TABLE `sound_filter_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `sound_filter_locale` */

/*Table structure for table `sound_kit` */

DROP TABLE IF EXISTS `sound_kit`;

CREATE TABLE `sound_kit` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `VolumeFloat` float NOT NULL DEFAULT '0',
  `MinDistance` float NOT NULL DEFAULT '0',
  `DistanceCutoff` float NOT NULL DEFAULT '0',
  `Flags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SoundEntriesAdvancedID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SoundType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DialogType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EAXDef` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VolumeVariationPlus` float NOT NULL DEFAULT '0',
  `VolumeVariationMinus` float NOT NULL DEFAULT '0',
  `PitchVariationPlus` float NOT NULL DEFAULT '0',
  `PitchVariationMinus` float NOT NULL DEFAULT '0',
  `PitchAdjust` float NOT NULL DEFAULT '0',
  `BusOverwriteID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MaxInstances` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `sound_kit` */

/*Table structure for table `sound_kit_advanced` */

DROP TABLE IF EXISTS `sound_kit_advanced`;

CREATE TABLE `sound_kit_advanced` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `InnerRadius2D` float NOT NULL DEFAULT '0',
  `DuckToSFX` float NOT NULL DEFAULT '0',
  `DuckToMusic` float NOT NULL DEFAULT '0',
  `InnerRadiusOfInfluence` float NOT NULL DEFAULT '0',
  `OuterRadiusOfInfluence` float NOT NULL DEFAULT '0',
  `TimeToDuck` int(11) NOT NULL DEFAULT '0',
  `TimeToUnduck` int(11) NOT NULL DEFAULT '0',
  `OuterRadius2D` float NOT NULL DEFAULT '0',
  `Usage` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SoundKitID` int(11) NOT NULL DEFAULT '0',
  `TimeA` int(11) NOT NULL DEFAULT '0',
  `TimeB` int(11) NOT NULL DEFAULT '0',
  `TimeC` int(11) NOT NULL DEFAULT '0',
  `TimeD` int(11) NOT NULL DEFAULT '0',
  `RandomOffsetRange` int(11) NOT NULL DEFAULT '0',
  `TimeIntervalMin` int(11) NOT NULL DEFAULT '0',
  `TimeIntervalMax` int(11) NOT NULL DEFAULT '0',
  `DelayMin` int(11) NOT NULL DEFAULT '0',
  `DelayMax` int(11) NOT NULL DEFAULT '0',
  `VolumeSliderCategory` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DuckToAmbience` float NOT NULL DEFAULT '0',
  `InsideAngle` float NOT NULL DEFAULT '0',
  `OutsideAngle` float NOT NULL DEFAULT '0',
  `OutsideVolume` float NOT NULL DEFAULT '0',
  `MinRandomPosOffset` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxRandomPosOffset` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DuckToDialog` float NOT NULL DEFAULT '0',
  `DuckToSuppressors` float NOT NULL DEFAULT '0',
  `MsOffset` int(11) NOT NULL DEFAULT '0',
  `TimeCooldownMin` int(11) NOT NULL DEFAULT '0',
  `TimeCooldownMax` int(11) NOT NULL DEFAULT '0',
  `MaxInstancesBehavior` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VolumeControlType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VolumeFadeInTimeMin` int(11) NOT NULL DEFAULT '0',
  `VolumeFadeInTimeMax` int(11) NOT NULL DEFAULT '0',
  `VolumeFadeInCurveID` int(11) NOT NULL DEFAULT '0',
  `VolumeFadeOutTimeMin` int(11) NOT NULL DEFAULT '0',
  `VolumeFadeOutTimeMax` int(11) NOT NULL DEFAULT '0',
  `VolumeFadeOutCurveID` int(11) NOT NULL DEFAULT '0',
  `ChanceToPlay` float NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `sound_kit_advanced` */

/*Table structure for table `sound_kit_child` */

DROP TABLE IF EXISTS `sound_kit_child`;

CREATE TABLE `sound_kit_child` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ParentSoundKitID` int(11) NOT NULL DEFAULT '0',
  `SoundKitID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `sound_kit_child` */

/*Table structure for table `sound_kit_entry` */

DROP TABLE IF EXISTS `sound_kit_entry`;

CREATE TABLE `sound_kit_entry` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SoundKitID` int(11) NOT NULL DEFAULT '0',
  `FileDataID` int(11) NOT NULL DEFAULT '0',
  `Frequency` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Volume` float NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `sound_kit_entry` */

/*Table structure for table `sound_kit_fallback` */

DROP TABLE IF EXISTS `sound_kit_fallback`;

CREATE TABLE `sound_kit_fallback` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SoundKitID` int(11) NOT NULL DEFAULT '0',
  `FallbackSoundKitID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `sound_kit_fallback` */

/*Table structure for table `sound_kit_name` */

DROP TABLE IF EXISTS `sound_kit_name`;

CREATE TABLE `sound_kit_name` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `sound_kit_name` */

/*Table structure for table `sound_kit_name_locale` */

DROP TABLE IF EXISTS `sound_kit_name_locale`;

CREATE TABLE `sound_kit_name_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `sound_kit_name_locale` */

/*Table structure for table `sound_override` */

DROP TABLE IF EXISTS `sound_override`;

CREATE TABLE `sound_override` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ZoneIntroMusicID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ZoneMusicID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SoundAmbienceID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SoundProviderPreferencesID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `sound_override` */

/*Table structure for table `sound_provider_preferences` */

DROP TABLE IF EXISTS `sound_provider_preferences`;

CREATE TABLE `sound_provider_preferences` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Description` text,
  `EAXDecayTime` float NOT NULL DEFAULT '0',
  `EAX2EnvironmentSize` float NOT NULL DEFAULT '0',
  `EAX2EnvironmentDiffusion` float NOT NULL DEFAULT '0',
  `EAX2DecayHFRatio` float NOT NULL DEFAULT '0',
  `EAX2ReflectionsDelay` float NOT NULL DEFAULT '0',
  `EAX2ReverbDelay` float NOT NULL DEFAULT '0',
  `EAX2RoomRolloff` float NOT NULL DEFAULT '0',
  `EAX2AirAbsorption` float NOT NULL DEFAULT '0',
  `EAX3DecayLFRatio` float NOT NULL DEFAULT '0',
  `EAX3EchoTime` float NOT NULL DEFAULT '0',
  `EAX3EchoDepth` float NOT NULL DEFAULT '0',
  `EAX3ModulationTime` float NOT NULL DEFAULT '0',
  `EAX3ModulationDepth` float NOT NULL DEFAULT '0',
  `EAX3HFReference` float NOT NULL DEFAULT '0',
  `EAX3LFReference` float NOT NULL DEFAULT '0',
  `Flags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EAX2Room` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EAX2RoomHF` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EAX2Reflections` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EAX2Reverb` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EAXEnvironmentSelection` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EAX3RoomLF` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `sound_provider_preferences` */

/*Table structure for table `sound_provider_preferences_locale` */

DROP TABLE IF EXISTS `sound_provider_preferences_locale`;

CREATE TABLE `sound_provider_preferences_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `sound_provider_preferences_locale` */

/*Table structure for table `source_info` */

DROP TABLE IF EXISTS `source_info`;

CREATE TABLE `source_info` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SourceText` text,
  `SourceTypeEnum` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PvpFaction` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `source_info` */

/*Table structure for table `source_info_locale` */

DROP TABLE IF EXISTS `source_info_locale`;

CREATE TABLE `source_info_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `SourceText_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `source_info_locale` */

/*Table structure for table `spam_messages` */

DROP TABLE IF EXISTS `spam_messages`;

CREATE TABLE `spam_messages` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Text` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spam_messages` */

/*Table structure for table `spam_messages_locale` */

DROP TABLE IF EXISTS `spam_messages_locale`;

CREATE TABLE `spam_messages_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Text_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spam_messages_locale` */

/*Table structure for table `specialization_spells` */

DROP TABLE IF EXISTS `specialization_spells`;

CREATE TABLE `specialization_spells` (
  `Description` text,
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `OverridesSpellID` int(11) NOT NULL DEFAULT '0',
  `SpecID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DisplayOrder` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `specialization_spells` */

/*Table structure for table `specialization_spells_locale` */

DROP TABLE IF EXISTS `specialization_spells_locale`;

CREATE TABLE `specialization_spells_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `specialization_spells_locale` */

/*Table structure for table `spell` */

DROP TABLE IF EXISTS `spell`;

CREATE TABLE `spell` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `NameSubtext` text,
  `Description` text,
  `AuraDescription` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell` */

insert  into `spell`(`ID`,`Name`,`NameSubtext`,`Description`,`AuraDescription`,`VerifiedBuild`) values 
(305160,'Dismount Aura','','','',1),
(305161,'Dismount Effect','','','',1),
(305162,'Атака с воздуха','','Выпускает заряды, наносящие урон от сил природы.','Выпускает заряды, наносящие урон от сил природы.',1),
(305000,'Summon Ice Spike','MadFlowCustoms','Hoarus summons Ice Spike which impales enemies.','',1),
(305001,'Ice spike','MadFlowCustoms','Hoarus summons Ice Spike which impales enemies.','Stunned.',1),
(305003,'SpikeVisual','MadFlowCustoms','SpikeVisual','SpikeVisual',1),
(305002,'Magmatic hound','MadFlowCustoms','Summons and dismisses a rideable Magmatic hound.','$?j1g[Скорость передвижения по земле повышена на $j1g%. ][]$?j1f[Скорость полета повышена на $j1f%. ][]$?j1s[Скорость плавания повышена на $j1s%. ][]',1),
(305004,'Magmatic hound','MadFlowCustoms','Summons and dismisses a rideable Magmatic hound.','$?j1g[Скорость передвижения по земле повышена на $j1g%. ][]$?j1f[Скорость полета повышена на $j1f%. ][]$?j1s[Скорость плавания повышена на $j1s%. ][]',1),
(305005,'Wrathion\'s Wings','MadFlowCustoms','','',1),
(305006,'Wrathion\'s Wings','MadFlowCustoms','','',1),
(305007,'Wrathion\'s Wings dummy','MadFlowCustoms','','',1),
(305008,'Rainbow','MadFlowCustoms','','',1),
(305009,'Blazing Wings','MadFlowCustoms','','',1),
(305010,'Черный принц','EventTestSp','Hoarus summons Ice Spike which impales enemies.','',1),
(305011,'Гончая скверны','EventTestSp','Hoarus summons Ice Spike which impales enemies.','',1),
(305012,'Цель','EventTestSp','Hoarus summons Ice Spike which impales enemies.','',1),
(305013,'DemonHunterTitleQuest','','Illidari','',1),
(156333,'Stealth Field','1','1','Stealthed.',1),
(305015,'SeerspinePufferAchievement','','','',1),
(305021,'ShaOfFear','','','',1),
(305016,'CheckTar','','','',1),
(305017,'The Codex of Xerrath','','','',1),
(305025,'Mount Achievement Debug - NPC','','','',1),
(305026,'Mount Achievement Debug - NPC','','','',1),
(305027,'Mount Achievement Debug - NPC','','','',1),
(305028,'Mount Achievement Debug - NPC','','','',1),
(305029,'Mount Achievement Debug - NPC','','','',1),
(305030,'Mount Achievement Debug - NPC','','','',1),
(305031,'Mount Achievement Debug - NPC','','','',1),
(305032,'Mount Achievement Debug - NPC','','','',1),
(305033,'Mount Achievement Debug - NPC','','','',1),
(305034,'Mount Achievement Debug - NPC','','','',1),
(305035,'Mount Achievement Debug - NPC','','','',1),
(305036,'Mount Achievement Debug - NPC','','','',1),
(305037,'Mount Achievement Debug - NPC','','','',1),
(305038,'Mount Achievement Debug - NPC','','','',1),
(305039,'Mount Achievement Debug - NPC','','','',1),
(305040,'Mount Achievement Debug - NPC','','','',1),
(305041,'Mount Achievement Debug - NPC','','','',1),
(305042,'Mount Achievement Debug - NPC','','','',1),
(305043,'Mount Achievement Debug - NPC','','','',1),
(305044,'Mount Achievement Debug - NPC','','','',1),
(305045,'Mount Achievement Debug - NPC','','','',1),
(305046,'Mount Achievement Debug - NPC','','','',1),
(305047,'Mount Achievement Debug - NPC','','','',1),
(305048,'Mount Achievement Debug - NPC','','','',1),
(305049,'Mount Achievement Debug - NPC','','','',1),
(305050,'Mount Achievement Debug - NPC','','','',1),
(305051,'Mount Achievement Debug - NPC','','','',1),
(305052,'Mount Achievement Debug - NPC','','','',1),
(305053,'10 Aura Win Spell',NULL,NULL,NULL,1),
(305054,'25 Aura Win Spell',NULL,NULL,NULL,1),
(305055,'50 Aura Win Spell',NULL,NULL,NULL,1),
(305056,'NetherwingReputation','','','',1),
(305057,'Mount Achievement Debug - NPC','','','',1),
(305058,'Mount Achievement Debug - NPC','','','',1),
(305059,'Mount Achievement Debug - NPC','','','',1),
(305060,'Mount Achievement Debug - NPC','','','',1),
(305061,'Mount Achievement Debug - NPC','','','',1),
(305062,'Mount Achievement Debug - NPC','','','',1),
(305063,'Mount Achievement Debug - NPC','','','',1),
(305064,'Mount Achievement Debug - NPC','','','',1),
(305065,'Mount Achievement Debug - NPC','','','',1),
(305066,'Mount Achievement Debug - NPC','','','',1),
(305067,'Summon Tyranda','','','',1),
(305068,'Summon Danica','','','',1),
(305069,'DK Mount Scenario Data','','','',1),
(305070,'Iron Dwarf, Medium Rare 10',NULL,NULL,NULL,1),
(305071,'Iron Dwarf, Medium Rare 25',NULL,NULL,NULL,1),
(305072,'ConclaveData','','','',1),
(305073,'To Ji-Kun','','','',1),
(305074,'Out Ji-Kun','','','',1),
(305075,'Out Ji-Kun 2 next','','','',1),
(305076,'RFR_V','','','',1),
(305078,'Conteinment Full Credit',NULL,NULL,NULL,1),
(300000,'Teleport to Duel Zone','','Teleport to Duel Zone, where also you can buy actual items and others','Teleport to Duel Zone, where also you can buy actual items and others',1),
(300001,'Teleport to Duel Zone','','Teleport to Duel Zone, where also you can buy actual items and others','Teleport to Duel Zone, where also you can buy actual items and others',1),
(233020,'Infernal Spike - LOS Blocker',NULL,NULL,NULL,0),
(305080,'Armorcrafter\'s Commendation Gained',NULL,NULL,NULL,1),
(305081,'Quest Timed Phase',NULL,NULL,NULL,1),
(17940,'Agony Soul Shard Driver',NULL,NULL,NULL,0),
(62388,'Teleport UNLOCK',NULL,NULL,NULL,0),
(305082,'Bubbles Main Aura',NULL,NULL,NULL,1),
(305084,'KillCredit Pereodic',NULL,NULL,NULL,1),
(305083,'Bubbles Trigger Aura',NULL,NULL,NULL,1),
(305085,'Legion start marked',NULL,NULL,NULL,1),
(305086,'Summon cooking table','','','',1),
(305087,'Summon cooking table','','','',1),
(305088,'Summon cooking table','','','',1),
(305089,'Summon cooking table','','','',1),
(305090,'Summon cooking table','','','',1),
(305091,'Summon cooking table','','','',1),
(305092,'Summon cooking table','','','',1),
(305093,'Summon cooking table','','','',1),
(305095,'Summon cooking table','','','',1),
(305096,'Summon cooking table','','','',1),
(305097,'Summon cooking table','','','',1),
(305098,'Summon cooking table','','','',1),
(305099,'Summon cooking table','','','',1),
(305100,'Summon cooking table','','','',1),
(305101,'Summon cooking table','','','',1),
(305102,'Summon cooking table','','','',1),
(305094,'Cooking order',NULL,NULL,NULL,1),
(305103,'Armorcrafter\'s Line Complete',NULL,NULL,NULL,1),
(158950,'Level of Craven',NULL,NULL,NULL,0),
(305104,'Netherlight Crucible marked',NULL,NULL,NULL,1),
(305105,'Кушать-кушать','Кормление ворона','Кормление ворона','Кормление ворона',1),
(199424,'Pure Heart','Passive','Whenever you or allies within $m1 yards are healed from any source, they are cleansed of 1 Disease and Poison effects.','Whenever you or allies within $m1 yards are healed from any source, they are cleansed of 1 Disease and Poison effects.',25976),
(305163,'Атака с воздуха','','Выпускает заряды, наносящие $s1 ед. урона всем целям в радиусе $a1 м от точки попадания.','',1),
(305164,'Legion skybox','','','',1),
(305165,'Недавняя телепортация','','Невозможно использовать порталы.','Невозможно использовать порталы.',1),
(305166,'Катапультирование','','','',1),
(305167,'Fire aura','','','',1),
(305168,'Fire','','','',1),
(305169,'Detection aura','','','',1),
(305170,'Духовные оковы','','','Скованы',1),
(305171,'Веревка','','','',1),
(305172,'Взрыв ловушки','','','',1),
(305173,'Удар щитом','','','',1),
(305174,'Коварный удар','','','',1),
(305175,'Смертельный удар','','','',1),
(305176,'Удар грома','','','',1),
(305177,'Защитная ловушка','','','',1),
(305178,'Залп стрел Тьмы','','','',1),
(305179,'Шквал сюрикэнов','','','',1),
(305180,'Разлом','','','После окончания эффекта разлом закроется и вы вернетесь в Даларан. И даже не пытайтесь снимать этот эффект сами!',1),
(305181,'Portal Used','','','',1),
(305182,'Update phases','','','',1),
(305184,'Птица огня пораженная бездной','Позволяет призывать и отпускать пораженную бездной огненную птицу.','Позволяет призывать и отпускать пораженную бездной огненную птицу.','$?j1g[Скорость передвижения по земле повышена на $j1g%. ][]$?j1f[Скорость полета повышена на $j1f%. ][]$?j1s[Скорость плавания повышена на $j1s%. ][]',1),
(305185,'Синий феникс','Позволяет призывать и отпускать синего феникса.','Позволяет призывать и отпускать синего феникса.','$?j1g[Скорость передвижения по земле повышена на $j1g%. ][]$?j1f[Скорость полета повышена на $j1f%. ][]$?j1s[Скорость плавания повышена на $j1s%. ][]',1),
(305186,'Сиреневый феникс','Позволяет призывать и отпускать сиреневого феникса.','Позволяет призывать и отпускать сиреневого феникса.','$?j1g[Скорость передвижения по земле повышена на $j1g%. ][]$?j1f[Скорость полета повышена на $j1f%. ][]$?j1s[Скорость плавания повышена на $j1s%. ][]',1),
(305187,'Пылающий феникс','Позволяет призывать и отпускать пылающего феникса.','Позволяет призывать и отпускать пылающего феникса.','$?j1g[Скорость передвижения по земле повышена на $j1g%. ][]$?j1f[Скорость полета повышена на $j1f%. ][]$?j1s[Скорость плавания повышена на $j1s%. ][]',1),
(305188,'Поводья сквернокогтя','Позволяет призывать и отпускать оскверненную птицу.','Позволяет призывать и отпускать оскверненную птицу.','$?j1g[Скорость передвижения по земле повышена на $j1g%. ][]$?j1f[Скорость полета повышена на $j1f%. ][]$?j1s[Скорость плавания повышена на $j1s%. ][]',1),
(305189,'Дитя Сюэня','Позволяет призывать и отпускать детеныша Сюэня, белого тигра.','Позволяет призывать и отпускать детеныша Сюэня, белого тигра.','$?j1g[Скорость передвижения по земле повышена на $j1g%. ][]$?j1f[Скорость полета повышена на $j1f%. ][]$?j1s[Скорость плавания повышена на $j1s%. ][]',1),
(305190,'Поводья Локе\'нахак','Позволяет призывать и отпускать Локе\'нахак.','Позволяет призывать и отпускать Локе\'нахак.','$?j1g[Скорость передвижения по земле повышена на $j1g%. ][]$?j1f[Скорость полета повышена на $j1f%. ][]$?j1s[Скорость плавания повышена на $j1s%. ][]',1),
(305191,'Сквернотопырь Иллидари','Позволяет призывать и отпускать Сквернотопыря Иллидари.','Позволяет призывать и отпускать Сквернотопыря Иллидари.','$?j1g[Скорость передвижения по земле повышена на $j1g%. ][]$?j1f[Скорость полета повышена на $j1f%. ][]$?j1s[Скорость плавания повышена на $j1s%. ][]',1),
(305192,'Призрачный гиппогриф','Позволяет призывать и отпускать призрачного гиппогрифа.','Позволяет призывать и отпускать призрачного гиппогрифа.','$?j1g[Скорость передвижения по земле повышена на $j1g%. ][]$?j1f[Скорость полета повышена на $j1f%. ][]$?j1s[Скорость плавания повышена на $j1s%. ][]',1),
(305193,'Скакун Кул-Тираса','Позволяет призывать и отпускать скакуна Кул-Тираса.','Позволяет призывать и отпускать скакуна Кул-Тираса.','$?j1g[Скорость передвижения по земле повышена на $j1g%. ][]$?j1f[Скорость полета повышена на $j1f%. ][]$?j1s[Скорость плавания повышена на $j1s%. ][]',1),
(305194,'Ящер Зулдазара','Позволяет призывать и отпускать ящера Зулдазара.','Позволяет призывать и отпускать ящера Зулдазара.','$?j1g[Скорость передвижения по земле повышена на $j1g%. ][]$?j1f[Скорость полета повышена на $j1f%. ][]$?j1s[Скорость плавания повышена на $j1s%. ][]',1),
(305195,'Шу-цзэнь, божественный страж','Позволяет призывать и отпускать Шу-цзэня.','Позволяет призывать и отпускать Шу-цзэня.','$?j1g[Скорость передвижения по земле повышена на $j1g%. ][]$?j1f[Скорость полета повышена на $j1f%. ][]$?j1s[Скорость плавания повышена на $j1s%. ][]',1),
(305196,'Птица огня пораженная бездной','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.',1),
(305197,'Синий феникс','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.',1),
(305198,'Сиреневый феникс','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.',1),
(305199,'Пылающий феникс','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.',1),
(305200,'Поводья сквернокогтя','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.',1),
(305201,'Дитя Сюэня','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.',1),
(305202,'Поводья Локе\'нахак','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.',1),
(305203,'Сквернотопырь Иллидари','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.',1),
(305204,'Призрачный гиппогриф','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.',1),
(305205,'Скакун Кул-Тираса','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.',1),
(305206,'Ящер Зулдазара','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.',1),
(305207,'Шу-цзэнь, божественный страж','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.','Обучает управлению этим средством передвижения.',1),
(305208,'Атака с воздуха','','Выпускает заряды, наносящие урон от сил природы.','Выпускает заряды, наносящие урон от сил природы.',1),
(305209,'Атака с воздуха','','Выпускает заряды, наносящие $s1 ед. урона всем целям в радиусе $a1 м от точки попадания.','',1),
(305210,'Освящение','','Освящение земли с нанесением $o1 ед. урона от светлой магии в течение $d. противникам, которые входят на этот участок.','$s1 ед. урона раз в $t1 сек.',1),
(305211,'Щит мстителя','','Бросок в противника щитом, наносящий $s1 ед. урона от светлой магии.','$s1 ед. урона раз в $t1 сек.',1),
(305212,'Божественная буря','','Создает вихрь божественной энергии, наносящий $224239sw1 ед. урона от светлой магии всем находящимся поблизости противникам.','$s1 ед. урона раз в $t1 сек.',1),
(305213,'Флаг альянса','','','',1),
(305214,'Флаг орды','','','',1),
(305215,'Серьезное ранение','','','',1),
(305216,'Атака','','','',1),
(305217,'Замедление','','Снижает скорость передвижения противника на $s1%. ','Скорость передвижения снижена на $s1%.',1),
(305218,'Защита от атак','','Укрыться защитным щитом для уклонения от атак и заклинаний.','Невосприимчивость к атакам и заклинаниям.',1),
(305219,'Ослепляющая вспышка','','Оглушить всех противников в радиусе 20м.','Оглушение.',1),
(305220,'Ослепляющая вспышка','','Оглушить всех противников в радиусе 20м.','Оглушение.',1),
(305221,'Защитный купол','','','',1),
(305222,'Защитный купол','','','',1),
(305223,'Посадить бойца','','','',1),
(305224,'Высадить раненого бойца','','','',1),
(305225,'Спасенный боец','','Вы спасли бойца своей фракции. После завершения спасения на столе Командующего Пэйна вы найдете свою награду.','Вы спасли бойца своей фракции. После завершения спасения на столе Командующего Пэйна вы найдете свою награду.',1),
(305226,'Ускорение','','','Скорость повышена.',1),
(305227,'Бездельник','','','Вы были неактивны слишком долгое время и вас удалили с зоны игровых событий. Дождитесь окончания эффекта, чтобы отправиться туда снова.',1),
(305228,'Поддержка Песни Войны','','','Вы согласились на поддержку своей фракции.',1),
(305229,'Свиток призыва','Призыв выбранного игрока.','Призыв выбранного игрока.','Призыв выбранного игрока.',1),
(305230,'Накидка тысячи звезд','','','',1),
(305231,'Накидка тысячи звезд','','','',1),
(305232,'Накидка тайной магии','','','',1),
(305233,'Накидка тайной магии','','','',1),
(305234,'Призыв банкира','Открыть разлом для призыва банкира, который предоставит доступ к вашему банку.','Открыть разлом для призыва банкира, который предоставит доступ к вашему банку.','Открыть разлом для призыва банкира, который предоставит доступ к вашему банку.',1),
(305235,'Призыв аукциониста','Открыть разлом для призыва аукциониста, который предоставит доступ к аукциону.','Открыть разлом для призыва аукциониста, который предоставит доступ к аукциону.','Открыть разлом для призыва аукциониста, который предоставит доступ к аукциону.',1),
(305236,'Призыв кузни артефакта','Позволяет призывать кузню артефакта с помощью которой вы сможете улучшить ваш артефакт и изучить новые способности артефакта, а также изменить его облик.','Позволяет призывать кузню артефакта с помощью которой вы сможете улучшить ваш артефакт и изучить новые способности артефакта, а также изменить его облик.','Позволяет призывать кузню артефакта с помощью которой вы сможете улучшить ваш артефакт и изучить новые способности артефакта, а также изменить его облик.',1),
(305237,'Shield aura','','','',1),
(305238,'Shield Effect','','','',1),
(305239,'Cold','Brrr.. So cold.','','Brrr.. So cold.',1),
(305240,'Freezing','','','When you stop moving you start to freeze.',1),
(305241,'Blizzard','','','$s1 damage every $t1 sec. Slows movement speed by $s2%.',1),
(305243,'Tail sweep','','Inflicts $s1 damage on enemies in a cone behind the caster, knocking them back.','Inflicts $s1 damage on enemies in a cone behind the caster, knocking them back.',1),
(305245,'Arcane Barrier','','','Absorb 85% damage.',1),
(305246,'Frost explosion','','Deals $s1 damage.','Deals $s1 damage.',1),
(305247,'Frost Barrage','','Deals $s1 damage.','Deals $s1 damage.',1),
(305248,'Atray\'s Fury','','','',1),
(305249,'Death Frost','','','Inflicts $s1 damage by $t1 sec. When death frost expires, the frost energy explodes outward, inflicting $305250s1 damage to all nearby allies.',1),
(305250,'Death Frost','','Inflicts $s1 damage by $t1 sec. When death frost expires, the frost energy explodes outward, inflicting $305250s1 damage to all nearby allies.','Inflicts $s1 damage by $t1 sec. When death frost expires, the frost energy explodes outward, inflicting $305250s1 damage to all nearby allies.',1),
(305251,'Arcane Barrier','','','Absorb 85% damage.',1),
(305252,'Появление Кадгара target selector','','','',1),
(305253,'khadgar aura','','','',1),
(305254,'khadgar Effect','','','',1),
(305255,'Frost explosion','','Deals $s1 damage.','Deals $s1 damage.',1),
(305256,'Frost Strike','','Inflicts $s1 damage.','Inflicts $s1 damage.',1),
(305257,'Frost Breath','','Deals %s1 damage.','Deals %s1 damage.',1),
(305258,'test','','','',1),
(305259,'Evala Transform','','','',1),
(305260,'Negative charge','','Find other negative charge.','Find other negative charge.',1),
(305261,'Positive charge','','Slowly kills target until positive charge targets will be too far from each other.','Slowly kills target until positive charge targets will be too far from each other.',1),
(305262,'Negative charge check','','','',1),
(305263,'Negative charge eff','','','',1),
(305264,'Positive charge check','','','',1),
(305265,'Positive charge eff','','','',1),
(305266,'Phase','','','',1),
(305267,'Frost explode target visual','','','',1),
(305268,'Icy Blast','','','Creates exlosion in selected area. If the implosion does not hit an enemy, it instead explodes for $305268s1 damage to all enemies within $305268A1 m.',1),
(305269,'Icy Blast','','','Creates exlosion in selected area. If the implosion does not hit an enemy, it instead explodes for $305269s1 damage to all enemies within $305269A1 m.',1),
(305270,'Frost Armor','','','Nearby enemies taking damage.',1),
(305271,'Frost Armor','','','Nearby enemies taking damage.',1),
(305272,'Full Defence','','','Taken damage reduced by 95%.',1),
(305273,'Instability','','Нанесение $s1 ед. урона от магии льда ближайшим противникам.','Нанесение $s1 ед. урона от магии льда ближайшим противникам.',1),
(305274,'Frostbolt','','Нанесение $s1 ед. урона от магии льда.','Нанесение $s1 ед. урона от магии льда.',1),
(305275,'Frostbolt','','Нанесение $s1 ед. урона от магии льда.','Нанесение $s1 ед. урона от магии льда.',1),
(305276,'Frost Fever','','A disease that deals $s1 Frost damage over 24 sec.','A disease that deals $s1 Frost damage over 24 sec.',1),
(305277,'Frostfire Bolt','','Deals frost damage.','Deals frost damage.',1),
(305278,'Icy Tomb','','','',1),
(305279,'Icy Tomb','','Stun.','Stun.',1),
(305280,'Negative Ch target selector','','','',1),
(305281,'Shadow Crash','','','',1),
(305282,'Shadow Crash','','Получение $s1 ед. урона раз в $t сек. в течение $d.','Получение $s1 ед. урона раз в $t сек. в течение $d.',1),
(305283,'Summon Crowley','','','',1),
(305284,'Keystone complete','','','',1),
(305285,'Накидка силы льда','','','',1),
(305286,'Somber Dawn','Позволяет призывать и отпускать ящера Зулдазара.','Позволяет призывать и отпускать ящера Зулдазара.','$?j1g[Скорость передвижения по земле повышена на $j1g%. ][]$?j1f[Скорость полета повышена на $j1f%. ][]$?j1s[Скорость плавания повышена на $j1s%. ][]',1),
(305287,'Somber Dawn','Teaches you how to summon this mount.','Teaches you how to summon this mount.','Teaches you how to summon this mount.',1),
(305288,'Red Illidari Felbat','Позволяет призывать и отпускать ящера Зулдазара.','Позволяет призывать и отпускать ящера Зулдазара.','$?j1g[Скорость передвижения по земле повышена на $j1g%. ][]$?j1f[Скорость полета повышена на $j1f%. ][]$?j1s[Скорость плавания повышена на $j1s%. ][]',1),
(305289,'Red Illidari Felbat','Teaches you how to summon this mount.','Teaches you how to summon this mount.','Teaches you how to summon this mount.',1),
(305290,'Summon teleporter','Summon your own teleporter.','Summon your own teleporter.','Summon your own teleporter.',1),
(305291,'Накидка силы льда','','','',1),
(305292,'Пронзание','','Нанесение урона раз в $t1 сек.','Нанесение урона раз в $t1 сек.',1),
(305293,'Frost explosion','','Deals $s1 damage.','Deals $s1 damage.',1),
(305295,'Frostbolt','','Нанесение $s1 ед. урона от магии льда.','Нанесение $s1 ед. урона от магии льда.',1),
(305294,'Positive Ch target selector','','','',1),
(305296,'Frostbolt','','Имея малое количество участников боя, впадает в ярость и начинает применять заклинание Ледяная стрела. Нанесение $s1 ед. урона от магии льда.','Имея малое количество участников боя, впадает в ярость и начинает применять заклинание Ледяная стрела. Нанесение $s1 ед. урона от магии льда.',1),
(305299,'Накидка вечной песни','','','',1),
(305297,'Tarecgosa\'s Visage','Summon Tarecgosa, allowing you to fly very fast.','Summon Tarecgosa, allowing you to fly very fast.','$?j1g[Скорость передвижения по земле повышена на $j1g%. ][]$?j1f[Скорость полета повышена на $j1f%. ][]$?j1s[Скорость плавания повышена на $j1s%. ][]',1),
(305298,'Set neutral','','','',1),
(305300,'Накидка вечной песни','','','',1),
(210636,'Complete Achievement','','circuit game','',1),
(305301,'Activity','Бездействие в зоне во время сражения. Шансы получить добычу с боссов уменьшены на 90%.','Бездействие в зоне во время сражения. Шансы получить добычу с боссов уменьшены на 90%.','Бездействие в зоне во время сражения. Шансы получить добычу с боссов уменьшены на 90%.',1),
(305302,'Открытие','Open the container.','Open the container.','Open the container.',1),
(305305,'Tarecgosa\'s Visage','Teaches you how to summon this mount.','Teaches you how to summon this mount.','Teaches you how to summon this mount.',1),
(329610,'Super Jump 200',NULL,NULL,NULL,0),
(436975,'Sumon Volt',NULL,NULL,NULL,1),
(436974,'Sumon Newt',NULL,NULL,NULL,1),
(436973,'Sumon Patch',NULL,NULL,NULL,1),
(436972,'Sumon grit',NULL,NULL,NULL,1),
(436976,'Sumon Ticker',NULL,NULL,NULL,1),
(329609,'90 Jump 300 trigger',NULL,NULL,NULL,0),
(329608,'90 Jump 300',NULL,NULL,NULL,0),
(329607,'Super Jump 400',NULL,NULL,NULL,0),
(329605,'Troll Priest',NULL,NULL,NULL,0),
(329603,'Blood Mage ',NULL,NULL,NULL,0),
(329601,'Orgrimmar Grunt ',NULL,NULL,NULL,1),
(329662,'Summon 734362',NULL,'quest 24478 spell 68189',NULL,0);

/*Table structure for table `spell_action_bar_pref` */

DROP TABLE IF EXISTS `spell_action_bar_pref`;

CREATE TABLE `spell_action_bar_pref` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `PreferredActionBarMask` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_action_bar_pref` */

/*Table structure for table `spell_activation_overlay` */

DROP TABLE IF EXISTS `spell_activation_overlay`;

CREATE TABLE `spell_activation_overlay` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `OverlayFileDataID` int(11) NOT NULL DEFAULT '0',
  `Color` int(10) unsigned NOT NULL DEFAULT '0',
  `Scale` float NOT NULL DEFAULT '0',
  `IconHighlightSpellClassMask1` int(10) unsigned NOT NULL DEFAULT '0',
  `IconHighlightSpellClassMask2` int(10) unsigned NOT NULL DEFAULT '0',
  `IconHighlightSpellClassMask3` int(10) unsigned NOT NULL DEFAULT '0',
  `IconHighlightSpellClassMask4` int(10) unsigned NOT NULL DEFAULT '0',
  `ScreenLocationID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TriggerType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SoundEntriesID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_activation_overlay` */

/*Table structure for table `spell_aura_options` */

DROP TABLE IF EXISTS `spell_aura_options`;

CREATE TABLE `spell_aura_options` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ProcCharges` int(10) unsigned NOT NULL DEFAULT '0',
  `ProcTypeMask` int(10) unsigned NOT NULL DEFAULT '0',
  `ProcCategoryRecovery` int(11) NOT NULL DEFAULT '0',
  `CumulativeAura` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SpellProcsPerMinuteID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DifficultyID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ProcChance` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SpellID` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_aura_options` */

insert  into `spell_aura_options`(`ID`,`ProcCharges`,`ProcTypeMask`,`ProcCategoryRecovery`,`CumulativeAura`,`SpellProcsPerMinuteID`,`DifficultyID`,`ProcChance`,`SpellID`,`VerifiedBuild`) values 
(27000,0,0,0,0,0,0,100,305006,1),
(28000,0,0,0,25,0,0,0,305070,1),
(28001,0,0,0,25,0,0,0,305071,1),
(20517,3,65536,0,0,0,0,100,202425,23911),
(25689,6,327680,0,0,0,0,100,256836,1),
(25765,4,16384,500,0,0,0,100,257470,1),
(25766,4,16384,500,0,0,0,100,257471,1),
(25767,4,16384,500,0,0,0,100,257472,1),
(25768,4,16384,500,0,0,0,100,257473,1),
(25769,4,16384,500,0,0,0,100,257474,1),
(25770,4,16384,500,0,0,0,100,257475,1),
(22971,1,87040,0,1,0,0,100,69369,1),
(12458,1,16384,0,2,0,0,100,114255,1),
(22664,10,331776,500,0,0,0,100,222046,1),
(28025,0,0,0,299,0,0,0,305225,1),
(28240,0,0,0,99,0,0,0,305240,1),
(28292,0,0,0,99,0,0,0,305292,1);

/*Table structure for table `spell_aura_restrictions` */

DROP TABLE IF EXISTS `spell_aura_restrictions`;

CREATE TABLE `spell_aura_restrictions` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `CasterAuraSpell` int(11) NOT NULL DEFAULT '0',
  `TargetAuraSpell` int(11) NOT NULL DEFAULT '0',
  `ExcludeCasterAuraSpell` int(11) NOT NULL DEFAULT '0',
  `ExcludeTargetAuraSpell` int(11) NOT NULL DEFAULT '0',
  `DifficultyID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CasterAuraState` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TargetAuraState` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ExcludeCasterAuraState` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ExcludeTargetAuraState` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SpellID` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_aura_restrictions` */

/*Table structure for table `spell_aura_vis_x_chr_spec` */

DROP TABLE IF EXISTS `spell_aura_vis_x_chr_spec`;

CREATE TABLE `spell_aura_vis_x_chr_spec` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ChrSpecializationID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_aura_vis_x_chr_spec` */

/*Table structure for table `spell_aura_visibility` */

DROP TABLE IF EXISTS `spell_aura_visibility`;

CREATE TABLE `spell_aura_visibility` (
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_aura_visibility` */

/*Table structure for table `spell_cast_times` */

DROP TABLE IF EXISTS `spell_cast_times`;

CREATE TABLE `spell_cast_times` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Base` int(11) NOT NULL DEFAULT '0',
  `Minimum` int(11) NOT NULL DEFAULT '0',
  `PerLevel` smallint(6) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_cast_times` */

/*Table structure for table `spell_casting_requirements` */

DROP TABLE IF EXISTS `spell_casting_requirements`;

CREATE TABLE `spell_casting_requirements` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `MinFactionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RequiredAreasID` smallint(6) NOT NULL DEFAULT '0',
  `RequiresSpellFocus` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FacingCasterFlags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MinReputation` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RequiredAuraVision` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_casting_requirements` */

insert  into `spell_casting_requirements`(`ID`,`SpellID`,`MinFactionID`,`RequiredAreasID`,`RequiresSpellFocus`,`FacingCasterFlags`,`MinReputation`,`RequiredAuraVision`,`VerifiedBuild`) values 
(3117,54964,0,0,0,0,0,0,0),
(30988,30988,0,0,1004,0,0,0,0);

/*Table structure for table `spell_categories` */

DROP TABLE IF EXISTS `spell_categories`;

CREATE TABLE `spell_categories` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Category` smallint(5) unsigned NOT NULL DEFAULT '0',
  `StartRecoveryCategory` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ChargeCategory` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DifficultyID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DefenseType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DispelType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Mechanic` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PreventionType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SpellID` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_categories` */

insert  into `spell_categories`(`ID`,`Category`,`StartRecoveryCategory`,`ChargeCategory`,`DifficultyID`,`DefenseType`,`DispelType`,`Mechanic`,`PreventionType`,`SpellID`,`VerifiedBuild`) values 
(51114,0,133,0,0,1,0,0,1,199360,0),
(75020,0,330,0,0,0,0,21,0,305184,0),
(75021,0,330,0,0,0,0,21,0,305185,0),
(75022,0,330,0,0,0,0,21,0,305186,0),
(75023,0,330,0,0,0,0,21,0,305187,0),
(75028,0,330,0,0,0,0,21,0,305188,0),
(75029,0,330,0,0,0,0,21,0,305189,0),
(75030,0,330,0,0,0,0,21,0,305190,0),
(75031,0,330,0,0,0,0,21,0,305191,0),
(75032,0,330,0,0,0,0,21,0,305192,0),
(75033,0,330,0,0,0,0,21,0,305193,0),
(75034,0,330,0,0,0,0,21,0,305194,0),
(75035,0,330,0,0,0,0,21,0,305195,0),
(4570,0,0,0,0,0,0,0,0,26272,0),
(4551,0,0,0,0,0,0,0,0,26272,0),
(4571,0,0,0,0,0,0,0,0,26272,0),
(4572,0,0,0,0,0,0,0,0,26274,0),
(70249,0,0,0,0,0,1,0,0,305249,0),
(75286,0,330,0,0,0,0,21,0,305286,0),
(75288,0,330,0,0,0,0,21,0,305288,0),
(75297,0,330,0,0,0,0,21,0,305297,0);

/*Table structure for table `spell_category` */

DROP TABLE IF EXISTS `spell_category`;

CREATE TABLE `spell_category` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `ChargeRecoveryTime` int(11) NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `UsesPerWeek` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxCharges` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TypeMask` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_category` */

/*Table structure for table `spell_category_locale` */

DROP TABLE IF EXISTS `spell_category_locale`;

CREATE TABLE `spell_category_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_category_locale` */

/*Table structure for table `spell_chain_effects` */

DROP TABLE IF EXISTS `spell_chain_effects`;

CREATE TABLE `spell_chain_effects` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `AvgSegLen` float NOT NULL DEFAULT '0',
  `NoiseScale` float NOT NULL DEFAULT '0',
  `TexCoordScale` float NOT NULL DEFAULT '0',
  `SegDuration` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `JointOffsetRadius` float NOT NULL DEFAULT '0',
  `MinorJointScale` float NOT NULL DEFAULT '0',
  `MajorJointScale` float NOT NULL DEFAULT '0',
  `JointMoveSpeed` float NOT NULL DEFAULT '0',
  `JointSmoothness` float NOT NULL DEFAULT '0',
  `MinDurationBetweenJointJumps` float NOT NULL DEFAULT '0',
  `MaxDurationBetweenJointJumps` float NOT NULL DEFAULT '0',
  `WaveHeight` float NOT NULL DEFAULT '0',
  `WaveFreq` float NOT NULL DEFAULT '0',
  `WaveSpeed` float NOT NULL DEFAULT '0',
  `MinWaveAngle` float NOT NULL DEFAULT '0',
  `MaxWaveAngle` float NOT NULL DEFAULT '0',
  `MinWaveSpin` float NOT NULL DEFAULT '0',
  `MaxWaveSpin` float NOT NULL DEFAULT '0',
  `ArcHeight` float NOT NULL DEFAULT '0',
  `MinArcAngle` float NOT NULL DEFAULT '0',
  `MaxArcAngle` float NOT NULL DEFAULT '0',
  `MinArcSpin` float NOT NULL DEFAULT '0',
  `MaxArcSpin` float NOT NULL DEFAULT '0',
  `DelayBetweenEffects` float NOT NULL DEFAULT '0',
  `MinFlickerOnDuration` float NOT NULL DEFAULT '0',
  `MaxFlickerOnDuration` float NOT NULL DEFAULT '0',
  `MinFlickerOffDuration` float NOT NULL DEFAULT '0',
  `MaxFlickerOffDuration` float NOT NULL DEFAULT '0',
  `PulseSpeed` float NOT NULL DEFAULT '0',
  `PulseOnLength` float NOT NULL DEFAULT '0',
  `PulseFadeLength` float NOT NULL DEFAULT '0',
  `WavePhase` float NOT NULL DEFAULT '0',
  `TimePerFlipFrame` float NOT NULL DEFAULT '0',
  `VariancePerFlipFrame` float NOT NULL DEFAULT '0',
  `TextureCoordScaleU1` float NOT NULL DEFAULT '0',
  `TextureCoordScaleU2` float NOT NULL DEFAULT '0',
  `TextureCoordScaleU3` float NOT NULL DEFAULT '0',
  `TextureCoordScaleV1` float NOT NULL DEFAULT '0',
  `TextureCoordScaleV2` float NOT NULL DEFAULT '0',
  `TextureCoordScaleV3` float NOT NULL DEFAULT '0',
  `TextureRepeatLengthU1` float NOT NULL DEFAULT '0',
  `TextureRepeatLengthU2` float NOT NULL DEFAULT '0',
  `TextureRepeatLengthU3` float NOT NULL DEFAULT '0',
  `TextureRepeatLengthV1` float NOT NULL DEFAULT '0',
  `TextureRepeatLengthV2` float NOT NULL DEFAULT '0',
  `TextureRepeatLengthV3` float NOT NULL DEFAULT '0',
  `TextureParticleFileDataID` int(11) NOT NULL DEFAULT '0',
  `StartWidth` float NOT NULL DEFAULT '0',
  `EndWidth` float NOT NULL DEFAULT '0',
  `ParticleScaleMultiplier` float NOT NULL DEFAULT '0',
  `ParticleEmissionRateMultiplier` float NOT NULL DEFAULT '0',
  `SegDelay` smallint(5) unsigned NOT NULL DEFAULT '0',
  `JointCount` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SpellChainEffectID1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SpellChainEffectID2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SpellChainEffectID3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SpellChainEffectID4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SpellChainEffectID5` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SpellChainEffectID6` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SpellChainEffectID7` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SpellChainEffectID8` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SpellChainEffectID9` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SpellChainEffectID10` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SpellChainEffectID11` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WidthScaleCurveID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `JointsPerMinorJoint` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MinorJointsPerMajorJoint` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Alpha` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Red` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Green` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Blue` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `BlendMode` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RenderLayer` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `NumFlipFramesU` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `NumFlipFramesV` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SoundKitID` int(11) NOT NULL DEFAULT '0',
  `TextureFileDataID1` int(11) NOT NULL DEFAULT '0',
  `TextureFileDataID2` int(11) NOT NULL DEFAULT '0',
  `TextureFileDataID3` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_chain_effects` */

/*Table structure for table `spell_class_options` */

DROP TABLE IF EXISTS `spell_class_options`;

CREATE TABLE `spell_class_options` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `SpellClassMask1` int(10) unsigned NOT NULL DEFAULT '0',
  `SpellClassMask2` int(10) unsigned NOT NULL DEFAULT '0',
  `SpellClassMask3` int(10) unsigned NOT NULL DEFAULT '0',
  `SpellClassMask4` int(10) unsigned NOT NULL DEFAULT '0',
  `SpellClassSet` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ModalNextSpell` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_class_options` */

/*Table structure for table `spell_cooldowns` */

DROP TABLE IF EXISTS `spell_cooldowns`;

CREATE TABLE `spell_cooldowns` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `CategoryRecoveryTime` int(11) NOT NULL DEFAULT '0',
  `RecoveryTime` int(11) NOT NULL DEFAULT '0',
  `StartRecoveryTime` int(11) NOT NULL DEFAULT '0',
  `DifficultyID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SpellID` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_cooldowns` */

insert  into `spell_cooldowns`(`ID`,`CategoryRecoveryTime`,`RecoveryTime`,`StartRecoveryTime`,`DifficultyID`,`SpellID`,`VerifiedBuild`) values 
(56293,0,120000,0,0,300000,1),
(56294,0,120000,0,0,300001,1),
(22915,0,0,0,0,199360,0),
(27169,0,15000,1500,0,235963,25976),
(50000,0,12000,0,0,305216,0),
(50001,0,23000,0,0,305217,0),
(50002,0,13000,0,0,305218,0),
(50003,0,65000,0,0,305219,0),
(50004,0,0,0,0,305220,0),
(50006,0,3000,0,0,305224,0);

/*Table structure for table `spell_description_variables` */

DROP TABLE IF EXISTS `spell_description_variables`;

CREATE TABLE `spell_description_variables` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Variables` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_description_variables` */

/*Table structure for table `spell_description_variables_locale` */

DROP TABLE IF EXISTS `spell_description_variables_locale`;

CREATE TABLE `spell_description_variables_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Variables_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_description_variables_locale` */

/*Table structure for table `spell_dispel_type` */

DROP TABLE IF EXISTS `spell_dispel_type`;

CREATE TABLE `spell_dispel_type` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `InternalName` text,
  `Mask` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ImmunityPossible` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_dispel_type` */

/*Table structure for table `spell_dispel_type_locale` */

DROP TABLE IF EXISTS `spell_dispel_type_locale`;

CREATE TABLE `spell_dispel_type_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `InternalName_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_dispel_type_locale` */

/*Table structure for table `spell_duration` */

DROP TABLE IF EXISTS `spell_duration`;

CREATE TABLE `spell_duration` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Duration` int(11) NOT NULL DEFAULT '0',
  `MaxDuration` int(11) NOT NULL DEFAULT '0',
  `DurationPerLevel` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_duration` */

insert  into `spell_duration`(`ID`,`Duration`,`MaxDuration`,`DurationPerLevel`,`VerifiedBuild`) values 
(1300,2100000,2100000,0,0);

/*Table structure for table `spell_effect` */

DROP TABLE IF EXISTS `spell_effect`;

CREATE TABLE `spell_effect` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Effect` int(11) NOT NULL DEFAULT '0',
  `EffectBasePoints` int(11) NOT NULL DEFAULT '0',
  `EffectIndex` int(11) NOT NULL DEFAULT '0',
  `EffectAura` int(11) NOT NULL DEFAULT '0',
  `DifficultyID` int(11) NOT NULL DEFAULT '0',
  `EffectAmplitude` float NOT NULL DEFAULT '0',
  `EffectAuraPeriod` int(11) NOT NULL DEFAULT '0',
  `EffectBonusCoefficient` float NOT NULL DEFAULT '0',
  `EffectChainAmplitude` float NOT NULL DEFAULT '0',
  `EffectChainTargets` int(11) NOT NULL DEFAULT '0',
  `EffectDieSides` int(11) NOT NULL DEFAULT '0',
  `EffectItemType` int(11) NOT NULL DEFAULT '0',
  `EffectMechanic` int(11) NOT NULL DEFAULT '0',
  `EffectPointsPerResource` float NOT NULL DEFAULT '0',
  `EffectRealPointsPerLevel` float NOT NULL DEFAULT '0',
  `EffectTriggerSpell` int(11) NOT NULL DEFAULT '0',
  `EffectPosFacing` float NOT NULL DEFAULT '0',
  `EffectAttributes` int(11) NOT NULL DEFAULT '0',
  `BonusCoefficientFromAP` float NOT NULL DEFAULT '0',
  `PvpMultiplier` float NOT NULL DEFAULT '0',
  `Coefficient` float NOT NULL DEFAULT '0',
  `Variance` float NOT NULL DEFAULT '0',
  `ResourceCoefficient` float NOT NULL DEFAULT '0',
  `GroupSizeBasePointsCoefficient` float NOT NULL DEFAULT '0',
  `EffectSpellClassMask1` int(10) unsigned NOT NULL DEFAULT '0',
  `EffectSpellClassMask2` int(10) unsigned NOT NULL DEFAULT '0',
  `EffectSpellClassMask3` int(10) unsigned NOT NULL DEFAULT '0',
  `EffectSpellClassMask4` int(10) unsigned NOT NULL DEFAULT '0',
  `EffectMiscValue1` int(11) NOT NULL DEFAULT '0',
  `EffectMiscValue2` int(11) NOT NULL DEFAULT '0',
  `EffectRadiusIndex1` int(11) NOT NULL DEFAULT '0',
  `EffectRadiusIndex2` int(11) NOT NULL DEFAULT '0',
  `ImplicitTarget1` int(11) NOT NULL DEFAULT '0',
  `ImplicitTarget2` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_effect` */

insert  into `spell_effect`(`ID`,`Effect`,`EffectBasePoints`,`EffectIndex`,`EffectAura`,`DifficultyID`,`EffectAmplitude`,`EffectAuraPeriod`,`EffectBonusCoefficient`,`EffectChainAmplitude`,`EffectChainTargets`,`EffectDieSides`,`EffectItemType`,`EffectMechanic`,`EffectPointsPerResource`,`EffectRealPointsPerLevel`,`EffectTriggerSpell`,`EffectPosFacing`,`EffectAttributes`,`BonusCoefficientFromAP`,`PvpMultiplier`,`Coefficient`,`Variance`,`ResourceCoefficient`,`GroupSizeBasePointsCoefficient`,`EffectSpellClassMask1`,`EffectSpellClassMask2`,`EffectSpellClassMask3`,`EffectSpellClassMask4`,`EffectMiscValue1`,`EffectMiscValue2`,`EffectRadiusIndex1`,`EffectRadiusIndex2`,`ImplicitTarget1`,`ImplicitTarget2`,`SpellID`,`VerifiedBuild`) values 
(55720,6,0,0,4,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,61802,0),
(55719,6,0,0,4,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,61801,0),
(55718,6,0,0,4,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,61800,0),
(55717,6,0,0,4,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,61799,0),
(55716,6,0,0,4,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,61798,0),
(363547,6,239901,0,226,0,0,20000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,239891,0),
(363563,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120309,64,128,0,72,0,239900,0),
(363564,28,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120309,64,128,0,72,0,239900,0),
(363556,28,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120309,64,128,0,72,0,239900,0),
(410070,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305070,0),
(410071,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305071,0),
(410072,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600055,64,0,0,1,0,305072,0),
(410073,42,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,17,0,305073,0),
(410074,42,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,17,0,305074,0),
(410075,42,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,17,0,305075,0),
(410076,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600059,64,0,0,1,0,305076,0),
(410078,90,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91590,0,0,0,1,0,305078,0),
(410014,6,0,0,16,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,156333,0),
(410015,6,-50,1,33,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,156333,0),
(25274,165,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,16,0,35139,0),
(410057,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,49379,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305057,0),
(410056,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60004,0,0,0,1,0,305056,0),
(410055,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305055,0),
(410054,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305054,0),
(410053,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305053,0),
(16,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600016,64,0,0,18,87,305010,0),
(410069,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,90000,0,0,0,1,0,305069,0),
(410068,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,93823,64,0,0,1,0,305068,0),
(410067,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103022,64,0,0,1,0,305067,0),
(410066,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48025,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305066,0),
(410065,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232405,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305065,0),
(410064,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,26054,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305064,0),
(410063,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,43900,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305063,0),
(410062,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,49379,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305062,0),
(410061,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48025,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305061,0),
(410000,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600002,64,0,0,18,87,305000,0),
(410060,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232405,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305060,0),
(410059,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,26054,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305059,0),
(410058,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,43900,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305058,0),
(410001,6,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305001,0),
(410002,6,0,0,78,0,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305,230,0,0,1,0,305002,0),
(410003,6,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305003,0),
(410004,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305002,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305004,0),
(410005,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305005,0),
(410006,6,0,0,23,0,0,10000,0,0,0,0,0,0,0,0,140197,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305006,0),
(410007,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305007,0),
(410008,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305008,0),
(410009,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305009,0),
(410010,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600016,64,0,0,18,87,305010,0),
(410011,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600017,64,0,0,18,87,305011,0),
(410012,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600018,64,0,0,18,87,305012,0),
(410013,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60003,0,0,0,1,0,305013,0),
(410021,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600019,64,0,0,1,0,305015,0),
(410020,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600021,64,0,0,1,0,305021,0),
(410016,166,50000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1226,0,0,0,25,0,305016,0),
(410017,36,25,0,0,0,0,0,0,0,0,0,0,0,0,0,101508,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305017,0),
(410025,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,122708,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305025,0),
(410026,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305026,0),
(410027,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305027,0),
(410028,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,93326,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305028,0),
(410029,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,59793,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305029,0),
(410030,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,59791,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305030,0),
(410031,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,61447,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305031,0),
(410032,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,61425,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305032,0),
(410033,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,55531,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305033,0),
(410034,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60424,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305034,0),
(410035,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305035,0),
(410036,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88750,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305036,0),
(410037,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,41252,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305037,0),
(410038,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72286,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305038,0),
(410039,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,122708,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305039,0),
(410040,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305040,0),
(410041,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305041,0),
(410042,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,93326,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305042,0),
(410043,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,59793,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305043,0),
(410044,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,59791,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305044,0),
(410045,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,61447,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305045,0),
(410046,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,61425,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305046,0),
(410047,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,55531,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305047,0),
(410048,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60424,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305048,0),
(410049,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305049,0),
(410050,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88750,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305050,0),
(410051,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,41252,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305051,0),
(410052,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72286,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305052,0),
(376114,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,25,0,246922,0),
(381500,64,0,2,0,23,0,0,0,1,0,0,0,0,0,0,221315,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,87,0,200111,0),
(381501,64,0,3,0,8,0,0,0,1,0,0,0,0,0,0,221315,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,87,0,200111,0),
(185272,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,140197,0),
(707841,252,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,17,300000,0),
(707842,252,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,17,300001,0),
(680000,50,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,266938,0,0,0,18,0,233020,0),
(464376,6,0,0,4,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,247860,0),
(410080,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60005,0,0,0,1,0,305080,0),
(410081,6,0,0,261,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,170,0,0,1,0,305081,0),
(410079,169,0,1,0,0,0,0,0,1,0,0,146692,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,239186,0),
(6,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,17940,0),
(7,6,0,1,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,17940,0),
(9,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,62388,0),
(299412,6,3,0,31,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,1,0,203059,0),
(299449,6,3,1,79,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,127,0,0,0,1,0,203059,0),
(410084,6,0,0,23,0,0,1000,0,0,0,0,0,0,0,0,101149,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305084,0),
(410082,6,0,0,23,0,0,15000,0,0,0,0,0,0,0,0,305083,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305082,0),
(410083,6,0,0,23,0,0,200,0,0,0,0,0,0,0,0,168922,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305083,0),
(376718,149,0,1,0,0,2,0,0,1,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,6,0,247246,0),
(410085,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60008,0,0,0,1,0,305085,0),
(164726,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,18,86,128879,0),
(164725,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,18,86,128878,0),
(164724,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,18,86,128877,0),
(164723,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,18,86,128876,0),
(164689,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,18,86,128857,0),
(410086,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600061,64,0,0,1,17,305086,0),
(410087,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600062,64,0,0,1,17,305087,0),
(410088,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600063,64,0,0,1,17,305088,0),
(410089,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600064,64,0,0,1,17,305089,0),
(410090,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600065,64,0,0,1,17,305090,0),
(410091,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600066,64,0,0,1,17,305091,0),
(410092,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600067,64,0,0,1,17,305092,0),
(410093,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600068,64,0,0,1,17,305093,0),
(410095,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600061,64,0,0,1,17,305095,0),
(410096,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600062,64,0,0,1,17,305096,0),
(410097,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600063,64,0,0,1,17,305097,0),
(410098,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600064,64,0,0,1,17,305098,0),
(410099,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600065,64,0,0,1,17,305099,0),
(410100,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600066,64,0,0,1,17,305100,0),
(410101,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600067,64,0,0,1,17,305101,0),
(410102,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,600068,64,0,0,1,17,305102,0),
(410094,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305094,0),
(466599,32,0,0,0,0,0,0,0,1,0,0,0,0,0,0,249058,0,0,0,0,0,0,0,0,0,0,0,0,0,0,26,26,138,86,249057,0),
(20105,2,1911,0,0,0,0,0,0,1,0,677,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,22,15,30505,0),
(410103,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60006,0,0,0,1,0,305103,0),
(12,6,1,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,158950,0),
(293005,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,8,56,0,199118,0),
(410104,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305105,0),
(321944,6,30,5,143,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,8388608,32768,0,0,0,0,0,0,1,0,216331,0),
(321952,6,30,7,173,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,8388608,32768,0,0,0,0,0,0,1,0,216331,0),
(288648,6,-120000,0,107,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,2048,0,11,0,0,0,1,0,196602,0),
(181361,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,138054,0),
(293472,38,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,4,0,0,0,21,0,199427,25976),
(293473,38,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,3,0,0,0,21,0,199427,25976),
(344184,6,5,19,403,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,237867,237868,0,0,1,0,219713,0),
(344185,6,5,20,403,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,237867,237869,0,0,1,0,219744,0),
(410160,6,0,0,23,0,0,2000,0,0,0,0,0,0,0,0,305161,0,0,0,0,0,0,0,0,0,0,0,0,0,0,26,0,1,0,305160,0),
(410161,6,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,0,26,0,18,31,305161,0),
(410162,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305163,0,0,0,0,0,0,0,0,0,0,0,0,0,0,29,0,46,138,305162,0),
(410163,2,3200000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,0,16,0,305163,0),
(410164,6,0,0,260,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1265,0,0,0,1,0,305164,0),
(410165,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305165,0),
(410166,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,150,150,0,0,17,0,305166,0),
(410167,6,0,0,23,0,0,200,0,0,0,0,0,0,0,0,305168,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,1,0,305167,0),
(410168,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,18,15,305168,0),
(410169,6,0,0,23,0,0,1000,0,0,0,0,0,0,0,0,305170,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305169,0),
(410170,6,0,0,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,18,15,305170,0),
(410171,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,63,0,305171,0),
(410172,2,3700000,0,0,0,0,0,0,0,0,1345255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305172,0),
(410173,2,700000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,305173,0),
(410174,2,650000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,305174,0),
(410175,2,560000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,305175,0),
(410176,2,800000,0,0,0,0,0,0,0,0,300005,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,22,15,305176,0),
(410177,165,75,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,43,0,104,0,305177,0),
(410178,2,200,0,0,0,0,0,0,0,0,843234,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,27,0,22,15,305178,0),
(410179,2,600000,0,0,0,0,0,0,0,0,843234,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,0,22,15,305179,0),
(410180,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305180,0),
(410181,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305181,0),
(410182,167,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,23,0,22,7,305182,0),
(410183,167,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,23,0,22,7,305182,0),
(410184,6,0,0,78,0,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305,230,0,0,1,0,305184,0),
(410185,6,0,0,78,0,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18545,229,0,0,1,0,305185,0),
(410186,6,0,0,78,0,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18545,229,0,0,1,0,305186,0),
(410187,6,0,0,78,0,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18545,229,0,0,1,0,305187,0),
(410188,6,0,0,78,0,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305,230,0,0,1,0,305188,0),
(410189,6,0,0,78,0,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305,230,0,0,1,0,305189,0),
(410190,6,0,0,78,0,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305,230,0,0,1,0,305190,0),
(410191,6,0,0,78,0,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18545,229,0,0,1,0,305191,0),
(410192,6,0,0,78,0,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18545,229,0,0,1,0,305192,0),
(410193,6,0,0,78,0,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305,230,0,0,1,0,305193,0),
(410194,6,0,0,78,0,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305,230,0,0,1,0,305194,0),
(410195,6,0,0,78,0,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18545,229,0,0,1,0,305195,0),
(410196,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305184,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305196,0),
(410197,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305197,0),
(410198,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305198,0),
(410199,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305199,0),
(410200,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305188,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305200,0),
(410201,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305201,0),
(410202,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305190,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305202,0),
(410203,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305203,0),
(410204,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305204,0),
(410205,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305205,0),
(410206,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305206,0),
(410207,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305195,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305207,0),
(410208,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305209,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,46,138,305208,0),
(410209,2,2350000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,16,0,305209,0),
(410210,27,1300000,0,3,0,0,1000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,18,16,305210,0),
(410211,2,2350000,0,0,0,0,0,0,1,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,305211,0),
(410212,2,1950000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,22,15,305212,0),
(410213,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305213,0),
(410214,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305214,0),
(410215,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305215,0),
(410216,2,120000,0,0,0,0,0,0,0,0,35000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,305216,0),
(410217,6,-25,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,305217,0),
(410218,6,0,0,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,0,0,0,1,0,305218,0),
(410219,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305220,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305219,0),
(410220,6,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,18,16,305220,0),
(410221,27,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,18,31,305221,0),
(410222,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305222,0),
(410223,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305223,0),
(410224,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305224,0),
(410225,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305225,0),
(410226,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305226,0),
(410227,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305227,0),
(410228,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305228,0),
(410229,85,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305229,0),
(410230,6,0,0,23,0,0,22000,0,0,0,0,0,0,0,0,305231,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305230,0),
(410231,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305231,0),
(410232,6,0,0,23,0,0,22000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305232,0),
(410233,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305233,0),
(410234,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,542003,2181,3,0,47,0,305234,0),
(410235,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,542006,2181,3,0,47,0,305235,0),
(410236,171,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,345006,0,3,0,47,0,305236,0),
(410237,6,0,0,23,0,0,1000,0,0,0,0,0,0,0,0,305238,0,0,0,0,0,0,0,0,0,0,0,0,0,0,26,0,1,0,305237,0),
(410238,6,0,0,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,0,32,0,18,31,305238,0),
(410239,6,0,0,226,0,0,4000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305239,0),
(410240,6,158000,0,3,0,0,2000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305240,0),
(410241,27,685000,0,3,0,0,1500,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,18,28,305241,0),
(410242,27,-50,1,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,18,28,305241,0),
(410243,2,450000,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,24,0,305243,0),
(410244,98,150,1,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,300,0,10,0,24,0,305243,0),
(410245,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305245,0),
(410246,2,900000,0,0,0,0,0,0,0,0,764435,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,22,15,305246,0),
(410247,2,850000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,22,15,305247,0),
(410248,6,0,0,226,0,0,1500,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305248,0),
(410249,6,125000,0,3,0,0,2000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,305249,0),
(410250,2,2500000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,22,30,305250,0),
(410251,6,-85,0,87,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,18,31,305251,0),
(410252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,23,0,18,16,305252,0),
(410253,6,0,0,23,0,0,1000,0,0,0,0,0,0,0,0,305254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,29,0,1,0,305253,0),
(410254,6,-85,0,87,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,0,29,0,18,31,305254,0),
(410255,2,1200000,0,0,0,0,0,0,0,0,764435,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,22,15,305255,0),
(410256,2,850000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,22,30,305256,0),
(410257,2,2800000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,104,0,305257,0),
(410258,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305258,0),
(410259,6,0,0,56,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16474,1,0,0,1,0,305259,0),
(410260,6,235000,0,3,0,0,1000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305260,0),
(410261,6,235000,0,3,0,0,1000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305261,0),
(410262,6,0,0,23,0,0,1000,0,0,0,0,0,0,0,0,305263,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305262,0),
(410263,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,22,7,305263,0),
(410264,6,0,0,23,0,0,1000,0,0,0,0,0,0,0,0,305265,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305264,0),
(410265,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,22,7,305265,0),
(410266,6,0,0,261,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5436,0,0,1,0,305266,0),
(410267,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305267,0),
(410268,2,900000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,18,16,305268,0),
(410269,2,3000000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,18,16,305269,0),
(410270,6,0,0,23,0,0,2500,0,0,0,0,0,0,0,0,305271,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305270,0),
(410271,2,100000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,29,0,22,16,305271,0),
(410272,6,-95,0,87,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305272,0),
(410273,2,580000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,35,0,18,15,305273,0),
(410274,32,1,0,0,0,0,0,0,0,0,0,0,0,0,0,305275,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,305274,0),
(410275,2,900000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,305275,0),
(410276,6,165000,0,3,0,0,3000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,305276,0),
(410277,2,980000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,305277,0),
(410278,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,22,15,305278,0),
(410279,6,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305279,0),
(410280,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,35,0,22,15,305280,0),
(410281,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305282,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,53,0,305281,0),
(410282,27,350000,0,3,0,0,2000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,26,0,87,16,305282,0),
(410283,28,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,117475,3221,0,0,32,0,305283,0),
(410284,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305284,0),
(410285,6,0,0,23,0,0,22000,0,0,0,0,0,0,0,0,305291,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305285,0),
(410286,6,0,0,78,0,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305,230,0,0,1,0,305286,0),
(410287,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305286,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305287,0),
(410288,6,0,0,78,0,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305,230,0,0,1,0,305288,0),
(410289,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305288,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305289,0),
(410290,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,542007,2181,3,0,47,0,305290,0),
(410291,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305291,0),
(279996,6,50,0,108,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0.7,0,0,0,1,0,0,0,1,0,0,0,0,1,0,190931,0),
(279997,31,300,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0.7,0,0,0,1,0,0,0,0,0,0,0,0,6,0,190928,0),
(279992,121,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0.7,0,0,0,1,0,0,0,0,0,0,0,0,6,0,190928,0),
(410292,6,480000,0,3,0,0,1500,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,305292,0),
(410293,2,450000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,22,15,305293,0),
(410294,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,35,0,22,15,305294,0),
(410295,32,1,0,0,0,0,0,0,0,0,0,0,0,0,0,305296,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,305295,0),
(410296,2,11000000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,305296,0),
(410297,6,0,0,78,0,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305,230,0,0,1,0,305297,0),
(410298,6,0,0,243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,35,0,0,0,1,0,305298,0),
(97065,6,1,0,312,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,61,0,0,0,1,0,92857,0),
(210636,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,210636,0),
(410299,6,0,0,23,0,0,30000,0,0,0,0,0,0,0,0,305300,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305299,0),
(410300,6,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305300,0),
(410301,6,0,0,243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,35,0,0,0,1,0,305301,0),
(410303,6,0,1,56,0,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,54464,14,0,0,1,0,305297,0),
(410302,189,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305302,0),
(410305,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101641,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,305305,0),
(73821,28,0,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,734360,64,8,0,41,0,73817,0),
(72850,28,0,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,73436,64,8,0,41,0,72070,0),
(72849,3,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,38,0,72070,0),
(72851,63,1,2,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,13,18,8,72070,0),
(329609,42,90,0,0,0,1.5,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,300,0,0,0,46,0,329609,0),
(436981,64,0,1,0,0,0,0,0,1,0,0,0,0,0,0,45523,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,1,0,436976,0),
(436980,28,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,36976,61,0,0,87,0,436976,0),
(436979,64,0,1,0,0,0,0,0,1,0,0,0,0,0,0,45523,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,1,0,436975,0),
(436978,28,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,36975,61,0,0,87,0,436975,0),
(436977,64,0,1,0,0,0,0,0,1,0,0,0,0,0,0,45523,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,1,0,436974,0),
(436976,28,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,36974,61,0,0,87,0,436974,0),
(436975,64,0,1,0,0,0,0,0,1,0,0,0,0,0,0,45523,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,1,0,436973,0),
(436974,28,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,36973,61,0,0,87,0,436973,0),
(436973,64,0,1,0,0,0,0,0,1,0,0,0,0,0,0,45523,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,1,0,436972,0),
(436972,28,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,36972,61,0,0,87,0,436972,0),
(436983,28,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,734362,61,0,0,87,0,329662,0),
(71945,28,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,734361,64,8,0,41,0,69310,0),
(71946,3,0,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,41,0,69310,0),
(329608,140,0,0,0,0,0,0,0,1,0,0,0,0,0,0,329609,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,25,0,329608,0),
(329607,138,400,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,90,0,0,0,1,0,329607,0),
(329610,138,200,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,90,0,0,0,1,0,329610,0),
(71352,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,7,0,25,0,68242,0);

/*Table structure for table `spell_effect_emission` */

DROP TABLE IF EXISTS `spell_effect_emission`;

CREATE TABLE `spell_effect_emission` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `EmissionRate` float NOT NULL DEFAULT '0',
  `ModelScale` float NOT NULL DEFAULT '0',
  `AreaModelID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_effect_emission` */

/*Table structure for table `spell_equipped_items` */

DROP TABLE IF EXISTS `spell_equipped_items`;

CREATE TABLE `spell_equipped_items` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `EquippedItemInvTypes` int(11) NOT NULL DEFAULT '0',
  `EquippedItemSubclass` int(11) NOT NULL DEFAULT '0',
  `EquippedItemClass` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_equipped_items` */

/*Table structure for table `spell_flyout` */

DROP TABLE IF EXISTS `spell_flyout`;

CREATE TABLE `spell_flyout` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `RaceMask` bigint(20) unsigned NOT NULL DEFAULT '0',
  `Name` text,
  `Description` text,
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ClassMask` int(11) NOT NULL DEFAULT '0',
  `SpellIconFileID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_flyout` */

/*Table structure for table `spell_flyout_item` */

DROP TABLE IF EXISTS `spell_flyout_item`;

CREATE TABLE `spell_flyout_item` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `Slot` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_flyout_item` */

/*Table structure for table `spell_flyout_locale` */

DROP TABLE IF EXISTS `spell_flyout_locale`;

CREATE TABLE `spell_flyout_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_flyout_locale` */

/*Table structure for table `spell_focus_object` */

DROP TABLE IF EXISTS `spell_focus_object`;

CREATE TABLE `spell_focus_object` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_focus_object` */

/*Table structure for table `spell_focus_object_locale` */

DROP TABLE IF EXISTS `spell_focus_object_locale`;

CREATE TABLE `spell_focus_object_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_focus_object_locale` */

/*Table structure for table `spell_interrupts` */

DROP TABLE IF EXISTS `spell_interrupts`;

CREATE TABLE `spell_interrupts` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `DifficultyID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `InterruptFlags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AuraInterruptFlags1` int(11) NOT NULL DEFAULT '0',
  `AuraInterruptFlags2` int(11) NOT NULL DEFAULT '0',
  `ChannelInterruptFlags1` int(11) NOT NULL DEFAULT '0',
  `ChannelInterruptFlags2` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_interrupts` */

insert  into `spell_interrupts`(`ID`,`DifficultyID`,`InterruptFlags`,`AuraInterruptFlags1`,`AuraInterruptFlags2`,`ChannelInterruptFlags1`,`ChannelInterruptFlags2`,`SpellID`,`VerifiedBuild`) values 
(75000,0,31,0,0,0,0,305002,1),
(75007,0,0,134364164,0,0,0,156333,0),
(41859,0,0,1342181403,0,0,0,156136,1),
(116729,0,15,0,0,0,0,300000,1),
(116730,0,15,0,0,0,0,300001,1),
(67308,0,0,524288,0,0,0,233430,0),
(75020,0,31,0,0,0,0,305184,1),
(75021,0,31,0,0,0,0,305185,1),
(75022,0,31,0,0,0,0,305186,1),
(75023,0,31,0,0,0,0,305187,1),
(75028,0,31,0,0,0,0,305188,1),
(75029,0,31,0,0,0,0,305189,1),
(75030,0,31,0,0,0,0,305190,1),
(75031,0,31,0,0,0,0,305191,1),
(75032,0,31,0,0,0,0,305192,1),
(75033,0,31,0,0,0,0,305193,1),
(75034,0,31,0,0,0,0,305194,1),
(75035,0,31,0,0,0,0,305195,1),
(75262,0,0,4718592,0,0,0,305262,1),
(75264,0,0,4718592,0,0,0,305264,1),
(75286,0,31,0,0,0,0,305286,1),
(75288,0,31,0,0,0,0,305288,1),
(75297,0,31,0,0,0,0,305297,1),
(75301,0,0,524288,0,0,0,305301,1);

/*Table structure for table `spell_item_enchantment` */

DROP TABLE IF EXISTS `spell_item_enchantment`;

CREATE TABLE `spell_item_enchantment` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `EffectArg1` int(10) unsigned NOT NULL DEFAULT '0',
  `EffectArg2` int(10) unsigned NOT NULL DEFAULT '0',
  `EffectArg3` int(10) unsigned NOT NULL DEFAULT '0',
  `EffectScalingPoints1` float NOT NULL DEFAULT '0',
  `EffectScalingPoints2` float NOT NULL DEFAULT '0',
  `EffectScalingPoints3` float NOT NULL DEFAULT '0',
  `TransmogCost` int(10) unsigned NOT NULL DEFAULT '0',
  `TextureFileDataID` int(10) unsigned NOT NULL DEFAULT '0',
  `EffectPointsMin1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EffectPointsMin2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EffectPointsMin3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemVisual` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Flags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RequiredSkillID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RequiredSkillRank` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Charges` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Effect1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Effect2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Effect3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ConditionID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MinLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ScalingClass` tinyint(4) NOT NULL DEFAULT '0',
  `ScalingClassRestricted` tinyint(4) NOT NULL DEFAULT '0',
  `TransmogPlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_item_enchantment` */

/*Table structure for table `spell_item_enchantment_condition` */

DROP TABLE IF EXISTS `spell_item_enchantment_condition`;

CREATE TABLE `spell_item_enchantment_condition` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `LtOperand1` int(11) NOT NULL DEFAULT '0',
  `LtOperand2` int(11) NOT NULL DEFAULT '0',
  `LtOperand3` int(11) NOT NULL DEFAULT '0',
  `LtOperand4` int(11) NOT NULL DEFAULT '0',
  `LtOperand5` int(11) NOT NULL DEFAULT '0',
  `LtOperandType1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LtOperandType2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LtOperandType3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LtOperandType4` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LtOperandType5` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Operator1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Operator2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Operator3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Operator4` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Operator5` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RtOperandType1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RtOperandType2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RtOperandType3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RtOperandType4` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RtOperandType5` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RtOperand1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RtOperand2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RtOperand3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RtOperand4` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RtOperand5` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Logic1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Logic2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Logic3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Logic4` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Logic5` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_item_enchantment_condition` */

/*Table structure for table `spell_item_enchantment_locale` */

DROP TABLE IF EXISTS `spell_item_enchantment_locale`;

CREATE TABLE `spell_item_enchantment_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_item_enchantment_locale` */

/*Table structure for table `spell_keybound_override` */

DROP TABLE IF EXISTS `spell_keybound_override`;

CREATE TABLE `spell_keybound_override` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Function` text,
  `Data` int(11) NOT NULL DEFAULT '0',
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_keybound_override` */

/*Table structure for table `spell_keybound_override_locale` */

DROP TABLE IF EXISTS `spell_keybound_override_locale`;

CREATE TABLE `spell_keybound_override_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Function_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_keybound_override_locale` */

/*Table structure for table `spell_label` */

DROP TABLE IF EXISTS `spell_label`;

CREATE TABLE `spell_label` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `LabelID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_label` */

/*Table structure for table `spell_learn_spell` */

DROP TABLE IF EXISTS `spell_learn_spell`;

CREATE TABLE `spell_learn_spell` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `LearnSpellID` int(11) NOT NULL DEFAULT '0',
  `OverridesSpellID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_learn_spell` */

/*Table structure for table `spell_levels` */

DROP TABLE IF EXISTS `spell_levels`;

CREATE TABLE `spell_levels` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `BaseLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MaxLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SpellLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DifficultyID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxPassiveAuraLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SpellID` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_levels` */

/*Table structure for table `spell_locale` */

DROP TABLE IF EXISTS `spell_locale`;

CREATE TABLE `spell_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `NameSubtext_lang` text,
  `Description_lang` text,
  `AuraDescription_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_locale` */

/*Table structure for table `spell_mechanic` */

DROP TABLE IF EXISTS `spell_mechanic`;

CREATE TABLE `spell_mechanic` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `StateName` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_mechanic` */

/*Table structure for table `spell_mechanic_locale` */

DROP TABLE IF EXISTS `spell_mechanic_locale`;

CREATE TABLE `spell_mechanic_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `StateName_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_mechanic_locale` */

/*Table structure for table `spell_misc` */

DROP TABLE IF EXISTS `spell_misc`;

CREATE TABLE `spell_misc` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `CastingTimeIndex` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DurationIndex` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RangeIndex` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SchoolMask` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SpellIconFileDataID` int(11) NOT NULL DEFAULT '0',
  `Speed` float NOT NULL DEFAULT '0',
  `ActiveIconFileDataID` int(11) NOT NULL DEFAULT '0',
  `LaunchDelay` float NOT NULL DEFAULT '0',
  `DifficultyID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Attributes1` int(11) NOT NULL DEFAULT '0',
  `Attributes2` int(11) NOT NULL DEFAULT '0',
  `Attributes3` int(11) NOT NULL DEFAULT '0',
  `Attributes4` int(11) NOT NULL DEFAULT '0',
  `Attributes5` int(11) NOT NULL DEFAULT '0',
  `Attributes6` int(11) NOT NULL DEFAULT '0',
  `Attributes7` int(11) NOT NULL DEFAULT '0',
  `Attributes8` int(11) NOT NULL DEFAULT '0',
  `Attributes9` int(11) NOT NULL DEFAULT '0',
  `Attributes10` int(11) NOT NULL DEFAULT '0',
  `Attributes11` int(11) NOT NULL DEFAULT '0',
  `Attributes12` int(11) NOT NULL DEFAULT '0',
  `Attributes13` int(11) NOT NULL DEFAULT '0',
  `Attributes14` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_misc` */

insert  into `spell_misc`(`ID`,`CastingTimeIndex`,`DurationIndex`,`RangeIndex`,`SchoolMask`,`SpellIconFileDataID`,`Speed`,`ActiveIconFileDataID`,`LaunchDelay`,`DifficultyID`,`Attributes1`,`Attributes2`,`Attributes3`,`Attributes4`,`Attributes5`,`Attributes6`,`Attributes7`,`Attributes8`,`Attributes9`,`Attributes10`,`Attributes11`,`Attributes12`,`Attributes13`,`Attributes14`,`SpellID`,`VerifiedBuild`) values 
(400009,1,21,1,1,136243,0,136243,0,0,696254848,0,16385,1048576,0,0,0,0,0,512,0,0,0,0,305009,1),
(400008,1,21,1,1,136243,0,136243,0,0,696254848,0,16385,1048576,0,0,0,0,0,512,0,0,0,0,305008,1),
(400007,1,0,1,1,0,0,0,0,0,696254848,0,16385,1048576,0,0,0,0,0,512,0,0,0,0,305007,1),
(400006,1,0,1,1,0,0,0,0,0,64,0,16385,1048576,0,0,0,0,0,512,0,0,0,0,305006,1),
(400005,1,28,13,1,656543,0,656543,0,0,696254848,0,16385,1048576,0,0,0,0,0,512,0,0,0,0,305005,1),
(400004,1,0,1,1,1032474,0,1032474,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305004,1),
(400002,16,21,1,1,1032474,0,1032474,0,0,269844752,0,0,536870912,0,0,131072,0,4096,0,0,0,0,0,305002,1),
(400003,0,21,1,1,517161,0,517161,0,0,256,0,0,1048576,0,0,0,0,0,0,0,0,0,0,305003,1),
(400001,0,21,13,16,517161,0,517161,0,0,67108864,2048,4,0,0,0,0,0,0,0,0,0,0,0,305001,1),
(400000,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305000,1),
(400010,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305010,1),
(400011,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305011,1),
(400012,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305012,1),
(400013,0,0,1,1,132484,0,132484,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305013,1),
(400014,0,32,1,0,465877,0,465877,0,0,269811712,1040,2097168,67108864,524288,0,0,0,0,0,0,1024,0,0,156333,1),
(400020,0,32,1,0,132484,0,132484,0,0,696254848,0,0,0,0,0,0,0,0,0,0,0,0,0,305015,0),
(400021,0,32,1,0,132484,0,132484,0,0,696254848,0,0,0,0,0,0,0,0,0,0,0,0,0,305021,0),
(400016,1,0,12,1,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305016,0),
(400017,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305017,0),
(400089,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305089,1),
(400088,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305088,1),
(400087,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305087,1),
(400086,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305086,1),
(450085,0,0,1,1,132484,0,132484,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305085,1),
(450083,1,28,1,1,136243,0,136243,0,0,696254848,1056,273170437,269681152,8388736,0,0,0,0,0,0,0,0,0,305083,0),
(450084,1,566,1,1,136243,0,136243,0,0,696254848,1056,273170437,269681152,8388736,0,0,0,0,0,0,0,0,0,305084,0),
(450082,1,21,1,1,136243,0,136243,0,0,696254848,1056,273170437,269681152,8388736,0,0,0,0,0,0,0,0,0,305082,0),
(500004,1,21,0,0,136243,0,136243,0,0,536871296,0,4,196608,0,0,0,0,0,0,0,0,0,1,62388,0),
(500003,1,21,0,0,136243,0,136243,0,0,763363584,168,540677,269484032,4,393224,4096,0,0,0,0,0,0,0,17940,0),
(400025,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305025,0),
(400026,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305026,0),
(400027,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305027,0),
(400028,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305028,0),
(400029,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305029,0),
(400030,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305030,0),
(400031,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305031,0),
(400032,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305032,0),
(400033,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305033,0),
(400034,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305034,0),
(400035,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305035,0),
(400036,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305036,0),
(400037,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305039,0),
(400038,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305038,0),
(400040,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305040,0),
(400041,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305041,0),
(400042,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305042,0),
(400043,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305043,0),
(400044,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305044,0),
(400045,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305045,0),
(400046,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305046,0),
(400047,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305047,0),
(400048,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305048,0),
(400049,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305049,0),
(400050,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305050,0),
(400051,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305051,0),
(400052,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305052,0),
(400053,1,28,6,1,136243,0,136243,0,0,159973760,0,0,0,0,0,0,0,0,0,0,0,0,0,305053,0),
(400054,1,28,6,1,136243,0,136243,0,0,159973760,0,0,0,0,0,0,0,0,0,0,0,0,0,305054,0),
(400055,1,28,6,1,136243,0,136243,0,0,159973760,0,0,0,0,0,0,0,0,0,0,0,0,0,305055,0),
(450081,1,6,1,1,132484,0,132484,0,0,696254848,0,0,1073741824,0,0,0,0,0,0,0,0,0,0,305081,1),
(400056,0,0,1,1,132484,0,132484,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305056,1),
(400057,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305057,0),
(400058,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305058,0),
(400059,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305059,0),
(400060,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305060,0),
(400061,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305061,0),
(400062,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305062,0),
(400063,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305063,0),
(400064,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305064,0),
(400065,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305065,0),
(400066,1,0,6,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305066,0),
(400067,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305067,1),
(400068,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305068,1),
(450080,0,0,1,1,132484,0,132484,0,0,696254848,0,0,0,0,0,0,0,0,0,0,0,0,0,305080,1),
(400069,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305069,1),
(400070,1,5,6,1,136243,0,136243,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305070,0),
(400071,1,5,6,1,136243,0,136243,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305071,0),
(400072,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305072,1),
(400073,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305073,1),
(400074,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305074,1),
(400075,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305075,1),
(400076,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305076,1),
(400078,0,0,13,1,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305078,1),
(114168,1,28,1,1,132484,0,132484,0,0,696254848,0,0,0,0,0,0,0,0,0,0,0,0,0,140197,0),
(400080,7,0,1,0,132484,0,132484,0,0,268500992,131072,0,1073741824,0,0,0,0,8192,0,0,0,0,1,300001,1),
(400079,7,0,1,0,132484,0,132484,0,0,268500992,131072,0,1073741824,0,0,0,0,8192,0,0,0,0,1,300000,1),
(680000,1,21,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,233020,0),
(400090,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305090,1),
(400091,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305091,1),
(400092,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305092,1),
(400093,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305093,1),
(400095,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305095,1),
(400096,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305096,1),
(400097,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305097,1),
(400098,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305098,1),
(400099,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305099,1),
(400100,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305100,1),
(400101,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305101,1),
(400102,0,21,13,0,132484,0,132484,0,0,256,0,0,0,0,0,0,0,0,0,0,0,0,0,305102,1),
(450094,1,527,1,1,136243,0,136243,0,0,696254848,1056,273170437,269681152,8388736,0,0,0,0,0,0,0,0,0,305094,0),
(232494,1,21,5,32,633004,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,248804,0),
(219203,1,21,1,1,608955,0,608955,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,245393,0),
(22620,1,0,5,64,132218,0,132218,0,0,16781824,0,33554432,0,0,0,0,0,0,0,0,0,0,0,38807,0),
(450103,0,0,1,1,132484,0,132484,0,0,696254848,0,0,0,0,0,0,0,0,0,0,0,0,0,305103,1),
(230003,1,42,0,0,136243,0,0,0,0,763363584,168,540677,269484032,4,393224,0,0,0,0,0,0,0,0,158950,0),
(450104,0,0,1,1,132484,0,132484,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305104,1),
(450105,7,1,5,1,648207,0,648207,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305105,1),
(450160,1,21,13,9,134801,0,134801,0,0,16777600,0,0,0,0,0,0,0,0,0,0,0,0,0,305160,1),
(450161,1,327,13,9,134801,0,134801,0,0,16777600,33792,0,0,0,0,0,0,0,0,0,0,0,0,305161,1),
(450162,1,0,245,9,135804,16,135804,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305162,1),
(450163,1,0,152,9,135804,0,135804,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305163,1),
(450164,1,21,152,9,135804,0,135804,0,0,696254848,1056,273170437,269681152,0,393224,4608,0,0,0,0,0,0,0,305164,1),
(450165,1,8,152,9,135748,0,135748,0,0,763363328,32,0,1310720,0,0,0,0,0,0,0,0,0,0,305165,1),
(450166,1,4,13,9,135748,20,135748,0,0,763363328,32,0,1310720,0,0,0,0,0,0,0,0,0,0,305166,1),
(450167,1,28,152,9,135748,0,135748,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305167,1),
(450168,1,0,152,9,135817,0,135817,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305168,1),
(450169,1,21,152,9,135748,0,135748,0,0,384,0,0,0,0,0,0,0,0,0,0,0,0,0,305169,1),
(450170,1,32,152,9,135945,0,135945,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305170,1),
(450171,1,0,152,9,136243,0,136243,0,0,384,0,0,0,0,0,0,0,0,0,0,0,0,0,305171,1),
(450172,1,0,152,9,135826,0,135826,0,0,0,0,0,256,0,0,0,0,0,0,0,0,0,0,305172,1),
(450173,1,0,152,9,132357,0,132357,0,0,0,0,0,256,0,0,0,0,0,0,0,0,0,0,305173,1),
(450174,1,0,152,9,136189,0,136189,0,0,0,0,0,256,0,0,0,0,0,0,0,0,0,0,305174,1),
(450175,1,0,152,9,132355,0,132355,0,0,0,0,0,256,0,0,0,0,0,0,0,0,0,0,305175,1),
(450176,1,0,152,9,132355,0,132355,0,0,0,0,0,256,0,0,0,0,0,0,0,0,0,0,305176,1),
(450177,5,0,152,9,132355,0,132355,0,0,0,0,0,256,0,0,0,0,0,0,0,0,0,0,305177,1),
(450178,4,0,152,9,132355,0,132355,25,0,0,0,0,256,0,0,0,0,0,0,0,0,0,0,305178,1),
(450179,1,0,152,9,236282,0,236282,18,0,0,0,0,256,0,0,0,0,0,0,0,0,0,0,305179,1),
(450180,1,40,152,1,136201,0,136201,0,0,746586368,136,0,1048576,4,0,0,0,0,0,0,0,0,0,305180,1),
(450181,1,30,152,1,136201,0,136201,0,0,696254848,136,0,1048576,4,0,0,0,0,0,0,0,0,0,305181,1),
(450182,1,0,152,1,136201,0,136201,0,0,696254848,1056,273170437,269681408,8388736,393224,4608,0,0,0,0,0,0,0,305182,1),
(450184,16,21,1,1,526578,0,526578,0,0,269844752,0,0,536870912,0,0,131072,0,4096,0,0,0,0,0,305184,1),
(450185,16,21,1,1,657488,0,657488,0,0,269844752,0,0,536870912,0,0,131072,0,4096,0,0,0,0,0,305185,1),
(450186,16,21,1,1,657488,0,657488,0,0,269844752,0,0,536870912,0,0,131072,0,4096,0,0,0,0,0,305186,1),
(450187,16,21,1,1,657488,0,657488,0,0,269844752,0,0,536870912,0,0,131072,0,4096,0,0,0,0,0,305187,1),
(450188,16,21,1,1,840193,0,840193,0,0,269844752,0,0,536870912,0,0,131072,0,4096,0,0,0,0,0,305188,1),
(450189,16,21,1,1,877410,0,877410,0,0,269844752,0,0,536870912,0,0,131072,0,4096,0,0,0,0,0,305189,1),
(450190,16,21,1,1,132267,0,132267,0,0,269844752,0,0,536870912,0,0,131072,0,4096,0,0,0,0,0,305190,1),
(450191,16,21,1,1,132182,0,132182,0,0,269844752,0,0,536870912,0,0,131072,0,4096,0,0,0,0,0,305191,1),
(450192,16,21,1,1,132265,0,132265,0,0,269844752,0,0,536870912,0,0,131072,0,4096,0,0,0,0,0,305192,1),
(450193,16,21,1,1,577318,0,577318,0,0,269844752,0,0,536870912,0,0,131072,0,4096,0,0,0,0,0,305193,1),
(450194,16,21,1,1,1043774,0,1043774,0,0,269844752,0,0,536870912,0,0,131072,0,4096,0,0,0,0,0,305194,1),
(450195,16,21,1,1,877481,0,877481,0,0,269844752,0,0,536870912,0,0,131072,0,4096,0,0,0,0,0,305195,1),
(450196,1,0,1,1,1418621,0,1418621,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305196,1),
(450197,1,0,1,1,1418621,0,1418621,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305197,1),
(450198,1,0,1,1,1418621,0,1418621,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305198,1),
(450199,1,0,1,1,1418621,0,1418621,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305199,1),
(450200,1,0,1,1,1418621,0,1418621,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305200,1),
(450201,1,0,1,1,1418621,0,1418621,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305201,1),
(450202,1,0,1,1,1418621,0,1418621,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305202,1),
(450203,1,0,1,1,1418621,0,1418621,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305203,1),
(450204,1,0,1,1,1418621,0,1418621,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305204,1),
(450205,1,0,1,1,1418621,0,1418621,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305205,1),
(450206,1,0,1,1,1418621,0,1418621,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305206,1),
(450207,1,0,1,1,1418621,0,1418621,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305207,1),
(450208,1,0,245,9,252172,17,252172,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305208,1),
(450209,1,0,152,9,252172,0,252172,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305209,1),
(450210,1,31,152,9,135926,0,135926,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305210,1),
(450211,1,0,4,9,135874,32,135874,0,0,0,0,0,0,262144,0,0,0,0,0,0,0,0,0,305211,1),
(450212,1,0,152,9,236250,0,236250,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305212,1),
(450213,1,21,152,9,132486,0,132486,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305213,1),
(450214,1,21,152,9,132485,0,132485,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305214,1),
(450215,1,21,152,9,999950,0,999950,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305215,1),
(450216,1,0,4,9,135844,15,135844,0,0,0,0,536870912,0,0,0,0,0,0,0,0,0,0,0,305216,1),
(450217,1,32,4,9,136091,1,136091,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305217,1),
(450218,1,551,1,9,135880,0,135880,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305218,1),
(450219,1,0,1,9,135922,0,135922,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305219,1),
(450220,1,27,1,9,135922,0,135922,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305220,1),
(450221,1,21,1,9,253400,0,253400,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305221,1),
(450222,1,21,1,9,253400,0,253400,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305222,1),
(450223,3,0,2,9,132351,0,132351,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305223,1),
(450224,1,0,1,9,134149,0,134149,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305224,1),
(450225,1,548,1,1,134149,0,134149,0,0,-1459617792,136,0,1048576,4,0,0,0,0,0,0,0,0,0,305225,1),
(450226,1,35,1,1,132307,0,132307,0,0,-1459617792,136,0,1048576,4,0,0,0,0,0,0,0,0,0,305226,1),
(450227,1,347,1,1,237555,0,237555,0,0,746586368,136,0,1048576,4,0,0,0,0,0,0,0,0,0,305227,1),
(450228,1,1300,1,1,132351,0,132351,0,0,746586368,136,0,1048576,4,0,0,0,0,0,0,0,0,0,305228,1),
(450229,6,0,13,1,136223,0,136223,0,0,268435456,256,4,0,0,0,0,0,0,0,0,0,0,1,305229,1),
(450230,1,21,1,1,136243,0,136243,0,0,696254848,1056,273170437,269681152,8388736,393224,4608,0,0,0,0,0,0,1,305230,1),
(450231,1,31,1,1,136243,0,136243,0,0,696254848,1056,273170437,269681152,8388736,393224,4608,0,0,0,0,0,0,1,305231,1),
(450232,1,21,1,1,136243,0,136243,0,0,696254848,1056,273170437,269681152,8388736,393224,4608,0,0,0,0,0,0,1,305232,1),
(450233,1,31,1,1,136243,0,136243,0,0,696254848,1056,273170437,269681152,8388736,393224,4608,0,0,0,0,0,0,1,305233,1),
(450234,1,594,1,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,305234,1),
(450235,14,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,305302,1),
(450236,1,5,1,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,305236,1),
(450237,1,21,13,9,134801,0,134801,0,0,16777600,0,0,0,0,0,0,0,0,0,0,0,0,0,305237,1),
(450238,1,285,13,9,134801,0,134801,0,0,16777600,33792,0,0,0,0,0,0,0,0,0,0,0,0,305238,1),
(450239,1,21,1,16,135833,0,135833,0,0,67108864,1192,273170437,269943552,8388736,393224,4608,0,0,0,0,0,0,0,305239,1),
(450240,1,21,1,16,236208,0,236208,0,0,67108864,1192,273170437,269943552,8388736,393224,4608,0,0,0,0,0,0,0,305240,1),
(450241,1,9,1,16,135857,0,135857,0,0,0,0,0,256,0,0,0,0,0,0,0,0,0,0,305241,1),
(450243,1,0,4,16,134307,0,134307,0,0,0,0,0,256,0,0,0,0,0,0,0,0,0,0,305243,1),
(450245,1,9,4,16,1033906,0,1033906,0,0,-1459617792,0,0,0,0,0,0,0,0,0,0,0,0,0,305245,1),
(450246,5,0,1,16,236209,0,236209,0,0,0,0,0,256,0,0,0,0,0,0,0,0,0,0,305246,1),
(450247,1,0,152,16,1698699,30,1698699,0,0,0,0,0,256,0,0,0,0,0,0,0,0,0,0,305247,1),
(450248,6,63,16,16,236209,0,236209,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305248,1),
(450249,1,1,152,32,538770,48,538770,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305249,1),
(450250,1,0,152,33,538770,0,538770,0,0,0,525344,0,256,0,0,0,0,0,0,0,0,0,0,305250,1),
(450251,1,9,4,16,1033906,0,1033906,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305251,1),
(450252,1,0,13,9,132108,0,132108,0,0,0,0,0,256,0,0,0,0,0,0,0,0,0,0,305252,1),
(450253,1,21,13,9,134801,0,134801,0,0,16777600,0,0,0,0,0,0,0,0,0,0,0,0,0,305253,1),
(450254,1,65,13,9,134801,0,134801,0,0,16777600,33792,0,0,8388736,0,0,0,0,0,0,0,0,0,305254,1),
(450255,5,0,1,16,236209,0,236209,0,0,0,0,0,256,0,0,0,0,0,0,0,0,0,0,305255,1),
(450256,1,0,152,33,538770,0,538770,0,0,0,525344,0,256,0,0,0,0,0,0,0,0,0,0,305256,1),
(450257,5,39,1,9,135836,0,135836,0,0,0,268435520,0,256,0,0,0,0,0,0,0,0,0,0,305257,1),
(450258,1,21,1,9,135836,0,135836,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305258,1),
(450259,1,21,1,9,135836,0,135836,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305259,1),
(450260,1,21,1,9,135768,0,135768,0,0,746586368,136,0,1048576,0,0,0,0,0,0,0,0,0,0,305260,1),
(450261,1,21,1,9,135769,0,135769,0,0,746586368,136,0,1048576,0,0,0,0,0,0,0,0,0,0,305261,1),
(450262,1,21,1,9,135769,0,135769,0,0,698614144,525480,273170437,269943552,0,0,0,0,0,0,0,0,0,0,305262,1),
(450263,1,21,1,9,135769,0,135769,0,0,763365632,525480,0,1048576,0,0,0,0,0,0,0,0,0,0,305263,1),
(450264,1,21,1,9,135769,0,135769,0,0,698614144,525480,273170437,269943552,0,0,0,0,0,0,0,0,0,0,305264,1),
(450265,1,21,1,9,135769,0,135769,0,0,763365632,525480,0,1048576,0,0,0,0,0,0,0,0,0,0,305265,1),
(450266,1,21,1,9,135769,0,135769,0,0,384,136,0,1048576,0,0,0,0,0,0,0,0,0,0,305266,1),
(450267,1,21,1,9,135769,0,135769,0,0,746586368,136,0,1048576,0,0,0,0,0,0,0,0,0,0,305267,1),
(450268,1,0,1,9,135850,0,135850,0,0,0,0,0,256,0,0,0,0,0,0,0,0,0,0,305268,1),
(450269,1,0,1,9,135850,0,135850,0,0,0,0,0,256,0,0,0,0,0,0,0,0,0,0,305269,1),
(450270,1,21,1,9,135843,0,135843,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305270,1),
(450271,1,0,1,9,135843,0,135843,0,0,0,0,0,256,0,0,0,0,0,0,0,0,0,0,305271,1),
(450272,14,21,1,9,136051,0,136051,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305272,1),
(450273,14,0,1,9,136051,0,136051,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305273,1),
(450274,5,0,1,9,135846,25,135846,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305274,1),
(450275,5,0,1,9,135846,0,135846,0,0,0,0,1073742336,129,0,0,0,0,0,0,0,0,0,0,305275,1),
(450276,1,106,1,9,237522,0,237522,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305276,1),
(450277,14,0,1,9,237522,25,237522,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305277,1),
(450278,5,0,152,9,103252,0,103252,0,0,0,0,0,256,0,0,0,0,0,0,0,0,0,0,305278,1),
(450279,1,21,152,9,517161,0,517161,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305279,1),
(450280,1,0,152,9,103252,0,103252,0,0,0,0,0,256,0,0,0,0,0,0,0,0,0,0,305280,1),
(450281,1,0,152,9,651091,20,651091,0,0,0,0,0,256,0,0,0,0,0,0,0,0,0,0,305281,1),
(450282,1,18,152,9,651091,0,651091,0,0,0,0,0,256,0,0,0,0,0,0,0,0,0,0,305282,1),
(450283,1,21,152,9,651091,0,651091,0,0,696254848,0,0,0,0,0,0,0,0,0,0,0,0,0,305283,1),
(450284,1,4,152,1,136201,0,136201,0,0,696254848,136,0,1048576,4,0,0,0,0,0,0,0,0,0,305284,1),
(450285,1,21,1,1,136243,0,136243,0,0,696254848,1056,273170437,269681152,8388736,393224,4608,0,0,0,0,0,0,1,305285,1),
(450286,16,21,1,1,132251,0,132251,0,0,269844752,0,0,536870912,0,0,131072,0,4096,0,0,0,0,0,305286,1),
(450287,1,0,1,1,1418621,0,1418621,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305287,1),
(450288,16,21,1,1,132182,0,132182,0,0,269844752,0,0,536870912,0,0,131072,0,4096,0,0,0,0,0,305288,1),
(450289,1,0,1,1,1418621,0,1418621,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305289,1),
(450290,1,25,1,1,136243,0,136243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,305290,1),
(450291,1,31,1,1,136243,0,136243,0,0,696254848,1056,273170437,269681152,8388736,393224,4608,0,0,0,0,0,0,1,305291,1),
(450292,1,22,6,1,134294,0,134294,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305292,1),
(450293,5,0,1,16,236209,0,236209,0,0,0,0,0,256,0,0,0,0,0,0,0,0,0,0,305293,1),
(450294,1,0,152,9,103252,0,103252,0,0,0,0,0,256,0,0,0,0,0,0,0,0,0,0,305294,1),
(450295,5,0,1,9,135846,25,135846,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305295,1),
(450296,5,0,1,9,135846,0,135846,0,0,0,0,1073742336,129,0,0,0,0,0,0,0,0,0,0,305296,1),
(450297,16,21,1,1,524050,0,524050,0,0,269844752,0,0,536870912,0,0,131072,0,4096,0,0,0,0,0,305297,1),
(450298,1,21,1,16,135833,0,135833,0,0,696254848,1192,273170437,269943552,8388736,393224,4608,0,0,0,0,0,0,0,305298,1),
(450299,1,21,1,1,136243,0,136243,0,0,696254848,1056,273170437,269681152,8388736,393224,4608,0,0,0,0,0,0,1,305299,1),
(450300,1,18,1,1,136243,0,136243,0,0,696254848,1056,273170437,269681152,8388736,393224,4608,0,0,0,0,0,0,1,305300,1),
(450301,1,21,1,16,136149,0,136149,0,0,746586368,1192,273170437,269943552,8388736,393224,4608,0,0,0,0,0,0,0,305301,1),
(450305,1,0,1,1,524050,0,524050,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,305305,1);

/*Table structure for table `spell_missile` */

DROP TABLE IF EXISTS `spell_missile`;

CREATE TABLE `spell_missile` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `DefaultPitchMin` float NOT NULL DEFAULT '0',
  `DefaultPitchMax` float NOT NULL DEFAULT '0',
  `DefaultSpeedMin` float NOT NULL DEFAULT '0',
  `DefaultSpeedMax` float NOT NULL DEFAULT '0',
  `RandomizeFacingMin` float NOT NULL DEFAULT '0',
  `RandomizeFacingMax` float NOT NULL DEFAULT '0',
  `RandomizePitchMin` float NOT NULL DEFAULT '0',
  `RandomizePitchMax` float NOT NULL DEFAULT '0',
  `RandomizeSpeedMin` float NOT NULL DEFAULT '0',
  `RandomizeSpeedMax` float NOT NULL DEFAULT '0',
  `Gravity` float NOT NULL DEFAULT '0',
  `MaxDuration` float NOT NULL DEFAULT '0',
  `CollisionRadius` float NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_missile` */

/*Table structure for table `spell_missile_motion` */

DROP TABLE IF EXISTS `spell_missile_motion`;

CREATE TABLE `spell_missile_motion` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `ScriptBody` text,
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MissileCount` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_missile_motion` */

/*Table structure for table `spell_missile_motion_locale` */

DROP TABLE IF EXISTS `spell_missile_motion_locale`;

CREATE TABLE `spell_missile_motion_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `ScriptBody_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_missile_motion_locale` */

/*Table structure for table `spell_power` */

DROP TABLE IF EXISTS `spell_power`;

CREATE TABLE `spell_power` (
  `ManaCost` int(11) NOT NULL DEFAULT '0',
  `PowerCostPct` float NOT NULL DEFAULT '0',
  `PowerPctPerSecond` float NOT NULL DEFAULT '0',
  `RequiredAuraSpellID` int(11) NOT NULL DEFAULT '0',
  `PowerCostMaxPct` float NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PowerType` tinyint(4) NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `ManaCostPerLevel` int(10) unsigned NOT NULL DEFAULT '0',
  `ManaPerSecond` int(11) NOT NULL DEFAULT '0',
  `OptionalCost` int(11) NOT NULL DEFAULT '0',
  `PowerDisplayID` int(11) NOT NULL DEFAULT '0',
  `AltPowerBarID` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_power` */

/*Table structure for table `spell_power_difficulty` */

DROP TABLE IF EXISTS `spell_power_difficulty`;

CREATE TABLE `spell_power_difficulty` (
  `DifficultyID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_power_difficulty` */

/*Table structure for table `spell_procedural_effect` */

DROP TABLE IF EXISTS `spell_procedural_effect`;

CREATE TABLE `spell_procedural_effect` (
  `Value1` float NOT NULL DEFAULT '0',
  `Value2` float NOT NULL DEFAULT '0',
  `Value3` float NOT NULL DEFAULT '0',
  `Value4` float NOT NULL DEFAULT '0',
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_procedural_effect` */

/*Table structure for table `spell_procs_per_minute` */

DROP TABLE IF EXISTS `spell_procs_per_minute`;

CREATE TABLE `spell_procs_per_minute` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `BaseProcRate` float NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_procs_per_minute` */

/*Table structure for table `spell_procs_per_minute_mod` */

DROP TABLE IF EXISTS `spell_procs_per_minute_mod`;

CREATE TABLE `spell_procs_per_minute_mod` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Coeff` float NOT NULL DEFAULT '0',
  `Param` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SpellProcsPerMinuteID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_procs_per_minute_mod` */

/*Table structure for table `spell_radius` */

DROP TABLE IF EXISTS `spell_radius`;

CREATE TABLE `spell_radius` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Radius` float NOT NULL DEFAULT '0',
  `RadiusPerLevel` float NOT NULL DEFAULT '0',
  `RadiusMin` float NOT NULL DEFAULT '0',
  `RadiusMax` float NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_radius` */

/*Table structure for table `spell_range` */

DROP TABLE IF EXISTS `spell_range`;

CREATE TABLE `spell_range` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `DisplayName` text,
  `DisplayNameShort` text,
  `RangeMin1` float NOT NULL DEFAULT '0',
  `RangeMin2` float NOT NULL DEFAULT '0',
  `RangeMax1` float NOT NULL DEFAULT '0',
  `RangeMax2` float NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_range` */

/*Table structure for table `spell_range_locale` */

DROP TABLE IF EXISTS `spell_range_locale`;

CREATE TABLE `spell_range_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `DisplayName_lang` text,
  `DisplayNameShort_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_range_locale` */

/*Table structure for table `spell_reagents` */

DROP TABLE IF EXISTS `spell_reagents`;

CREATE TABLE `spell_reagents` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `Reagent1` int(11) NOT NULL DEFAULT '0',
  `Reagent2` int(11) NOT NULL DEFAULT '0',
  `Reagent3` int(11) NOT NULL DEFAULT '0',
  `Reagent4` int(11) NOT NULL DEFAULT '0',
  `Reagent5` int(11) NOT NULL DEFAULT '0',
  `Reagent6` int(11) NOT NULL DEFAULT '0',
  `Reagent7` int(11) NOT NULL DEFAULT '0',
  `Reagent8` int(11) NOT NULL DEFAULT '0',
  `ReagentCount1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ReagentCount2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ReagentCount3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ReagentCount4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ReagentCount5` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ReagentCount6` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ReagentCount7` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ReagentCount8` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_reagents` */

/*Table structure for table `spell_reagents_currency` */

DROP TABLE IF EXISTS `spell_reagents_currency`;

CREATE TABLE `spell_reagents_currency` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `CurrencyTypesID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CurrencyCount` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_reagents_currency` */

/*Table structure for table `spell_scaling` */

DROP TABLE IF EXISTS `spell_scaling`;

CREATE TABLE `spell_scaling` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `ScalesFromItemLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Class` int(11) NOT NULL DEFAULT '0',
  `MinScalingLevel` int(11) NOT NULL DEFAULT '0',
  `MaxScalingLevel` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_scaling` */

/*Table structure for table `spell_shapeshift` */

DROP TABLE IF EXISTS `spell_shapeshift`;

CREATE TABLE `spell_shapeshift` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `ShapeshiftExclude1` int(10) unsigned NOT NULL DEFAULT '0',
  `ShapeshiftExclude2` int(10) unsigned NOT NULL DEFAULT '0',
  `ShapeshiftMask1` int(10) unsigned NOT NULL DEFAULT '0',
  `ShapeshiftMask2` int(10) unsigned NOT NULL DEFAULT '0',
  `StanceBarOrder` tinyint(4) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_shapeshift` */

insert  into `spell_shapeshift`(`ID`,`SpellID`,`ShapeshiftExclude1`,`ShapeshiftExclude2`,`ShapeshiftMask1`,`ShapeshiftMask2`,`StanceBarOrder`,`VerifiedBuild`) values 
(45,2006,0,0,0,0,0,0),
(4756,213634,0,0,2147483648,0,0,0);

/*Table structure for table `spell_shapeshift_form` */

DROP TABLE IF EXISTS `spell_shapeshift_form`;

CREATE TABLE `spell_shapeshift_form` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `DamageVariance` float NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `CombatRoundTime` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MountTypeID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CreatureType` tinyint(4) NOT NULL DEFAULT '0',
  `BonusActionBar` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AttackIconFileID` int(11) NOT NULL DEFAULT '0',
  `CreatureDisplayID1` int(11) NOT NULL DEFAULT '0',
  `CreatureDisplayID2` int(11) NOT NULL DEFAULT '0',
  `CreatureDisplayID3` int(11) NOT NULL DEFAULT '0',
  `CreatureDisplayID4` int(11) NOT NULL DEFAULT '0',
  `PresetSpellID1` int(11) NOT NULL DEFAULT '0',
  `PresetSpellID2` int(11) NOT NULL DEFAULT '0',
  `PresetSpellID3` int(11) NOT NULL DEFAULT '0',
  `PresetSpellID4` int(11) NOT NULL DEFAULT '0',
  `PresetSpellID5` int(11) NOT NULL DEFAULT '0',
  `PresetSpellID6` int(11) NOT NULL DEFAULT '0',
  `PresetSpellID7` int(11) NOT NULL DEFAULT '0',
  `PresetSpellID8` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_shapeshift_form` */

/*Table structure for table `spell_shapeshift_form_locale` */

DROP TABLE IF EXISTS `spell_shapeshift_form_locale`;

CREATE TABLE `spell_shapeshift_form_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_shapeshift_form_locale` */

/*Table structure for table `spell_special_unit_effect` */

DROP TABLE IF EXISTS `spell_special_unit_effect`;

CREATE TABLE `spell_special_unit_effect` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellVisualEffectNameID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PositionerID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_special_unit_effect` */

/*Table structure for table `spell_target_restrictions` */

DROP TABLE IF EXISTS `spell_target_restrictions`;

CREATE TABLE `spell_target_restrictions` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ConeDegrees` float NOT NULL DEFAULT '0',
  `Width` float NOT NULL DEFAULT '0',
  `Targets` int(11) NOT NULL DEFAULT '0',
  `TargetCreatureType` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DifficultyID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxTargets` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxTargetLevel` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_target_restrictions` */

insert  into `spell_target_restrictions`(`ID`,`ConeDegrees`,`Width`,`Targets`,`TargetCreatureType`,`DifficultyID`,`MaxTargets`,`MaxTargetLevel`,`SpellID`,`VerifiedBuild`) values 
(70123,0,0,0,0,0,3,0,305162,0),
(70177,60,0,0,0,0,0,0,305177,0),
(70208,0,0,0,0,0,1,0,305208,0),
(70244,-82,0,0,0,0,0,0,305243,0),
(70252,0,0,0,0,0,1,0,305252,0),
(70257,20,0,0,0,0,0,0,305257,0),
(70278,0,0,0,0,0,3,0,305278,0),
(70280,0,0,0,0,0,4,0,305280,0),
(70281,0,0,0,0,0,4,0,305294,0);

/*Table structure for table `spell_totems` */

DROP TABLE IF EXISTS `spell_totems`;

CREATE TABLE `spell_totems` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `Totem1` int(11) NOT NULL DEFAULT '0',
  `Totem2` int(11) NOT NULL DEFAULT '0',
  `RequiredTotemCategoryID1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RequiredTotemCategoryID2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_totems` */

/*Table structure for table `spell_visual` */

DROP TABLE IF EXISTS `spell_visual`;

CREATE TABLE `spell_visual` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `MissileCastOffset1` float NOT NULL DEFAULT '0',
  `MissileCastOffset2` float NOT NULL DEFAULT '0',
  `MissileCastOffset3` float NOT NULL DEFAULT '0',
  `MissileImpactOffset1` float NOT NULL DEFAULT '0',
  `MissileImpactOffset2` float NOT NULL DEFAULT '0',
  `MissileImpactOffset3` float NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `SpellVisualMissileSetID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MissileDestinationAttachment` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MissileAttachment` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MissileCastPositionerID` int(11) NOT NULL DEFAULT '0',
  `MissileImpactPositionerID` int(11) NOT NULL DEFAULT '0',
  `MissileTargetingKit` int(11) NOT NULL DEFAULT '0',
  `AnimEventSoundID` int(11) NOT NULL DEFAULT '0',
  `DamageNumberDelay` smallint(5) unsigned NOT NULL DEFAULT '0',
  `HostileSpellVisualID` int(11) NOT NULL DEFAULT '0',
  `CasterSpellVisualID` int(11) NOT NULL DEFAULT '0',
  `LowViolenceSpellVisualID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_visual` */

/*Table structure for table `spell_visual_anim` */

DROP TABLE IF EXISTS `spell_visual_anim`;

CREATE TABLE `spell_visual_anim` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `InitialAnimID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LoopAnimID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AnimKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_visual_anim` */

/*Table structure for table `spell_visual_color_effect` */

DROP TABLE IF EXISTS `spell_visual_color_effect`;

CREATE TABLE `spell_visual_color_effect` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Duration` float NOT NULL DEFAULT '0',
  `Color` int(10) unsigned NOT NULL DEFAULT '0',
  `ColorMultiplier` float NOT NULL DEFAULT '0',
  `RedCurveID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `GreenCurveID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `BlueCurveID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AlphaCurveID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `OpacityCurveID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PositionerID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_visual_color_effect` */

/*Table structure for table `spell_visual_effect_name` */

DROP TABLE IF EXISTS `spell_visual_effect_name`;

CREATE TABLE `spell_visual_effect_name` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ModelFileDataID` int(11) NOT NULL DEFAULT '0',
  `EffectRadius` float NOT NULL DEFAULT '0',
  `BaseMissileSpeed` float NOT NULL DEFAULT '0',
  `Scale` float NOT NULL DEFAULT '0',
  `MinAllowedScale` float NOT NULL DEFAULT '0',
  `MaxAllowedScale` float NOT NULL DEFAULT '0',
  `Alpha` float NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `Type` int(11) NOT NULL DEFAULT '0',
  `GenericID` int(11) NOT NULL DEFAULT '0',
  `TextureFileDataID` int(11) NOT NULL DEFAULT '0',
  `RibbonQualityID` int(11) NOT NULL DEFAULT '0',
  `DissolveEffectID` int(11) NOT NULL DEFAULT '0',
  `Unknown13` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_visual_effect_name` */

/*Table structure for table `spell_visual_event` */

DROP TABLE IF EXISTS `spell_visual_event`;

CREATE TABLE `spell_visual_event` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `StartEvent` int(11) NOT NULL DEFAULT '0',
  `StartMinOffsetMs` int(11) NOT NULL DEFAULT '0',
  `StartMaxOffsetMs` int(11) NOT NULL DEFAULT '0',
  `EndEvent` int(11) NOT NULL DEFAULT '0',
  `EndMinOffsetMs` int(11) NOT NULL DEFAULT '0',
  `EndMaxOffsetMs` int(11) NOT NULL DEFAULT '0',
  `TargetType` int(11) NOT NULL DEFAULT '0',
  `SpellVisualKitID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_visual_event` */

/*Table structure for table `spell_visual_kit` */

DROP TABLE IF EXISTS `spell_visual_kit`;

CREATE TABLE `spell_visual_kit` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `FallbackPriority` float NOT NULL DEFAULT '0',
  `FallbackSpellVisualKitID` int(11) NOT NULL DEFAULT '0',
  `DelayMin` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DelayMax` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_visual_kit` */

/*Table structure for table `spell_visual_kit_area_model` */

DROP TABLE IF EXISTS `spell_visual_kit_area_model`;

CREATE TABLE `spell_visual_kit_area_model` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ModelFileDataID` int(11) NOT NULL DEFAULT '0',
  `EmissionRate` float NOT NULL DEFAULT '0',
  `Spacing` float NOT NULL DEFAULT '0',
  `ModelScale` float NOT NULL DEFAULT '0',
  `LifeTime` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_visual_kit_area_model` */

/*Table structure for table `spell_visual_kit_effect` */

DROP TABLE IF EXISTS `spell_visual_kit_effect`;

CREATE TABLE `spell_visual_kit_effect` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `EffectType` int(11) NOT NULL DEFAULT '0',
  `Effect` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_visual_kit_effect` */

/*Table structure for table `spell_visual_kit_model_attach` */

DROP TABLE IF EXISTS `spell_visual_kit_model_attach`;

CREATE TABLE `spell_visual_kit_model_attach` (
  `Offset1` float NOT NULL DEFAULT '0',
  `Offset2` float NOT NULL DEFAULT '0',
  `Offset3` float NOT NULL DEFAULT '0',
  `OffsetVariation1` float NOT NULL DEFAULT '0',
  `OffsetVariation2` float NOT NULL DEFAULT '0',
  `OffsetVariation3` float NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellVisualEffectNameID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AttachmentID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PositionerID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Yaw` float NOT NULL DEFAULT '0',
  `Pitch` float NOT NULL DEFAULT '0',
  `Roll` float NOT NULL DEFAULT '0',
  `YawVariation` float NOT NULL DEFAULT '0',
  `PitchVariation` float NOT NULL DEFAULT '0',
  `RollVariation` float NOT NULL DEFAULT '0',
  `Scale` float NOT NULL DEFAULT '0',
  `ScaleVariation` float NOT NULL DEFAULT '0',
  `StartAnimID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AnimID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EndAnimID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AnimKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LowDefModelAttachID` int(11) NOT NULL DEFAULT '0',
  `StartDelay` float NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_visual_kit_model_attach` */

/*Table structure for table `spell_visual_missile` */

DROP TABLE IF EXISTS `spell_visual_missile`;

CREATE TABLE `spell_visual_missile` (
  `FollowGroundHeight` int(10) unsigned NOT NULL DEFAULT '0',
  `FollowGroundDropSpeed` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `CastOffset1` float NOT NULL DEFAULT '0',
  `CastOffset2` float NOT NULL DEFAULT '0',
  `CastOffset3` float NOT NULL DEFAULT '0',
  `ImpactOffset1` float NOT NULL DEFAULT '0',
  `ImpactOffset2` float NOT NULL DEFAULT '0',
  `ImpactOffset3` float NOT NULL DEFAULT '0',
  `SpellVisualEffectNameID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CastPositionerID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ImpactPositionerID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FollowGroundApproach` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SpellMissileMotionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Attachment` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DestinationAttachment` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `SoundEntriesID` int(11) NOT NULL DEFAULT '0',
  `AnimKitID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_visual_missile` */

/*Table structure for table `spell_x_description_variables` */

DROP TABLE IF EXISTS `spell_x_description_variables`;

CREATE TABLE `spell_x_description_variables` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `SpellDescriptionVariablesID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_x_description_variables` */

/*Table structure for table `spell_x_spell_visual` */

DROP TABLE IF EXISTS `spell_x_spell_visual`;

CREATE TABLE `spell_x_spell_visual` (
  `SpellVisualID` int(11) NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `Probability` float NOT NULL DEFAULT '0',
  `CasterPlayerConditionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CasterUnitConditionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ViewerPlayerConditionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ViewerUnitConditionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SpellIconFileID` int(11) NOT NULL DEFAULT '0',
  `ActiveIconFileID` int(11) NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `DifficultyID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Priority` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SpellID` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `spell_x_spell_visual` */

insert  into `spell_x_spell_visual`(`SpellVisualID`,`ID`,`Probability`,`CasterPlayerConditionID`,`CasterUnitConditionID`,`ViewerPlayerConditionID`,`ViewerUnitConditionID`,`SpellIconFileID`,`ActiveIconFileID`,`Flags`,`DifficultyID`,`Priority`,`SpellID`,`VerifiedBuild`) values 
(22493,120000,0,0,0,0,0,0,0,0,0,0,305003,1),
(31223,120001,0,0,0,0,0,0,0,0,0,0,305005,1),
(59841,120002,0,0,0,0,0,0,0,0,0,0,305008,1),
(42602,120003,0,0,0,0,0,0,0,0,0,0,305009,1),
(38211,120004,0,0,0,0,0,0,0,0,0,0,156333,0),
(7723,122097,0,0,0,0,0,0,0,0,0,0,247860,0),
(2576,80235,0,0,0,0,0,0,0,0,0,0,305105,0),
(70627,210162,0,0,0,0,0,0,0,0,0,0,305162,0),
(66088,210163,0,0,0,0,0,0,0,0,0,0,305163,0),
(9226,210165,0,0,0,0,0,0,0,0,0,0,305165,0),
(47733,210167,0,0,0,0,0,0,0,0,0,0,305167,0),
(29176,210169,0,0,0,0,0,0,0,0,0,0,305169,0),
(68727,210171,0,0,0,0,0,0,0,0,0,0,305171,0),
(41023,210172,0,0,0,0,0,0,0,0,0,0,305172,0),
(1165,210173,0,0,0,0,0,0,0,0,0,0,305173,0),
(50572,210174,0,0,0,0,0,0,0,0,0,0,305174,0),
(50572,210175,0,0,0,0,0,0,0,0,0,0,305175,0),
(49190,210176,0,0,0,0,0,0,0,0,0,0,305176,0),
(70238,210177,0,0,0,0,0,0,0,0,0,0,305177,0),
(64599,210178,0,0,0,0,0,0,0,0,0,0,305178,0),
(51775,210179,0,0,0,0,0,0,0,0,0,0,305179,0),
(20711,210184,1,0,0,0,0,0,0,0,0,0,305184,0),
(20711,210185,1,0,0,0,0,0,0,0,0,0,305185,0),
(20711,210186,1,0,0,0,0,0,0,0,0,0,305186,0),
(20711,210187,1,0,0,0,0,0,0,0,0,0,305187,0),
(20711,210188,1,0,0,0,0,0,0,0,0,0,305188,0),
(20711,210189,1,0,0,0,0,0,0,0,0,0,305189,0),
(20711,210190,1,0,0,0,0,0,0,0,0,0,305190,0),
(20711,210191,1,0,0,0,0,0,0,0,0,0,305191,0),
(20711,210192,1,0,0,0,0,0,0,0,0,0,305192,0),
(20711,210193,1,0,0,0,0,0,0,0,0,0,305193,0),
(20711,210194,1,0,0,0,0,0,0,0,0,0,305194,0),
(20711,210195,1,0,0,0,0,0,0,0,0,0,305195,0),
(44107,210208,0,0,0,0,0,0,0,0,0,0,305208,0),
(44108,210209,0,0,0,0,0,0,0,0,0,0,305209,0),
(5600,210210,0,0,0,0,0,0,0,0,0,0,305210,0),
(49950,210211,0,0,0,0,0,0,0,0,0,0,305211,0),
(12006,210212,0,0,0,0,0,0,0,0,0,0,305212,0),
(6824,210213,0,0,0,0,0,0,0,0,0,0,305213,0),
(6823,210214,0,0,0,0,0,0,0,0,0,0,305214,0),
(49155,210215,0,0,0,0,0,0,0,0,0,0,305215,0),
(14555,210216,0,0,0,0,0,0,0,0,0,0,305216,0),
(68,210217,0,0,0,0,0,0,0,0,0,0,305217,0),
(46834,210218,0,0,0,0,0,0,0,0,0,0,305218,0),
(16347,210219,0,0,0,0,0,0,0,0,0,0,305219,0),
(2816,210220,0,0,0,0,0,0,0,0,0,0,305220,0),
(64091,210222,0,0,0,0,0,0,0,0,0,0,305222,0),
(73383,210229,0,0,0,0,0,0,0,0,0,0,305229,0),
(13827,210231,0,0,0,0,0,0,0,0,0,0,305231,0),
(68026,210233,0,0,0,0,0,0,0,0,0,0,305233,0),
(62253,210234,0,0,0,0,0,0,0,0,0,0,305234,0),
(62253,210235,0,0,0,0,0,0,0,0,0,0,305235,0),
(62253,210236,0,0,0,0,0,0,0,0,0,0,305236,0),
(7608,210241,0,0,0,0,0,0,0,0,0,0,305241,0),
(3879,210243,0,0,0,0,0,0,0,0,0,0,305243,0),
(50372,210245,0,0,0,0,0,0,0,0,0,0,305245,0),
(52703,210246,0,0,0,0,0,0,0,0,0,0,305246,0),
(32587,210247,0,0,0,0,0,0,0,0,0,0,305247,0),
(30796,210249,0,0,0,0,0,0,0,0,0,0,305249,0),
(53091,210250,0,0,0,0,0,0,0,0,0,0,305250,0),
(17901,210255,0,0,0,0,0,0,0,0,0,0,305255,0),
(53091,210256,0,0,0,0,0,0,0,0,0,0,305256,0),
(39154,210257,0,0,0,0,0,0,0,0,0,0,305257,0),
(65496,210258,0,0,0,0,0,0,0,0,0,0,305258,0),
(46093,210259,0,0,0,0,0,0,0,0,0,0,305259,0),
(33453,210260,0,0,0,0,0,0,0,0,0,0,305260,0),
(34429,210261,0,0,0,0,0,0,0,0,0,0,305261,0),
(33460,210267,0,0,0,0,0,0,0,0,0,0,305267,0),
(54336,210268,0,0,0,0,0,0,0,0,0,0,305268,0),
(14812,210269,0,0,0,0,0,0,0,0,0,0,305269,0),
(4302,210270,0,0,0,0,0,0,0,0,0,0,305270,0),
(13,210272,0,0,0,0,0,0,0,0,0,0,305272,0),
(53091,210273,0,0,0,0,0,0,0,0,0,0,305273,0),
(64829,210274,0,0,0,0,0,0,0,0,0,0,305274,0),
(11152,210276,0,0,0,0,0,0,0,0,0,0,305276,0),
(12253,210277,0,0,0,0,0,0,0,0,0,0,305277,0),
(56588,210278,0,0,0,0,0,0,0,0,0,0,305278,0),
(31568,210281,0,0,0,0,0,0,0,0,0,0,305281,0),
(31375,210282,0,0,0,0,0,0,0,0,0,0,305282,0),
(20711,210286,1,0,0,0,0,0,0,0,0,0,305286,0),
(62262,210288,1,0,0,0,0,0,0,0,0,0,305288,0),
(62253,210290,0,0,0,0,0,0,0,0,0,0,305290,0),
(57972,210291,0,0,0,0,0,0,0,0,0,0,305291,0),
(52703,210293,0,0,0,0,0,0,0,0,0,0,305293,0),
(64829,210295,0,0,0,0,0,0,0,0,0,0,305295,0),
(20711,210297,1,0,0,0,0,0,0,0,0,0,305297,0),
(66961,119655,1,0,0,0,0,0,0,0,0,0,243955,0),
(38987,210300,0,0,0,0,0,0,0,0,0,0,305300,0),
(62253,210302,0,0,0,0,0,0,0,0,0,0,305302,0);

/*Table structure for table `startup__strings` */

DROP TABLE IF EXISTS `startup__strings`;

CREATE TABLE `startup__strings` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Message` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `startup__strings` */

/*Table structure for table `startup__strings_locale` */

DROP TABLE IF EXISTS `startup__strings_locale`;

CREATE TABLE `startup__strings_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Message_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `startup__strings_locale` */

/*Table structure for table `startup_files` */

DROP TABLE IF EXISTS `startup_files`;

CREATE TABLE `startup_files` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `FileDataID` int(11) NOT NULL DEFAULT '0',
  `Locale` int(11) NOT NULL DEFAULT '0',
  `BytesRequired` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `startup_files` */

/*Table structure for table `stationery` */

DROP TABLE IF EXISTS `stationery`;

CREATE TABLE `stationery` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ItemID` int(11) NOT NULL DEFAULT '0',
  `TextureFileDataID1` int(11) NOT NULL DEFAULT '0',
  `TextureFileDataID2` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `stationery` */

/*Table structure for table `summon_properties` */

DROP TABLE IF EXISTS `summon_properties`;

CREATE TABLE `summon_properties` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Flags` int(10) unsigned NOT NULL DEFAULT '0',
  `Control` int(11) NOT NULL DEFAULT '0',
  `Faction` int(11) NOT NULL DEFAULT '0',
  `Title` int(11) NOT NULL DEFAULT '0',
  `Slot` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `summon_properties` */

insert  into `summon_properties`(`ID`,`Flags`,`Control`,`Faction`,`Title`,`Slot`,`VerifiedBuild`) values 
(2915,2056,1,0,2,0,0);

/*Table structure for table `tact_key` */

DROP TABLE IF EXISTS `tact_key`;

CREATE TABLE `tact_key` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Key1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key4` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key5` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key6` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key7` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key8` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key9` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key10` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key11` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key12` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key13` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key14` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key15` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Key16` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `tact_key` */

insert  into `tact_key`(`ID`,`Key1`,`Key2`,`Key3`,`Key4`,`Key5`,`Key6`,`Key7`,`Key8`,`Key9`,`Key10`,`Key11`,`Key12`,`Key13`,`Key14`,`Key15`,`Key16`,`VerifiedBuild`) values 
(58,209,172,32,253,20,149,127,171,194,113,150,233,246,231,2,74,22522),
(59,198,197,246,199,247,53,215,217,76,135,38,127,164,153,77,69,22522),
(62,194,80,26,114,101,75,150,248,99,80,197,169,39,150,47,122,22522),
(66,77,208,220,130,177,1,200,10,186,192,164,213,126,103,248,89,22522),
(69,138,206,141,177,105,226,249,138,195,106,213,44,8,142,119,193,22522),
(70,154,137,204,126,58,203,41,207,20,198,11,193,59,30,70,22,22522),
(71,151,43,110,116,66,14,197,25,230,249,217,125,89,74,163,124,22522),
(68,31,141,70,127,93,109,65,31,138,84,139,99,41,165,8,126,26124),
(15,189,197,24,98,171,237,121,178,222,72,200,231,230,108,98,0,26124),
(52,67,50,101,240,205,235,47,78,101,192,238,112,8,113,77,158,26124),
(55,218,106,252,152,158,214,202,210,121,136,89,146,192,55,168,238,26124),
(56,1,190,139,67,20,45,217,154,158,105,15,173,40,139,96,130,26124),
(57,5,252,146,123,159,79,91,5,86,129,66,145,42,5,43,15,26124),
(81,183,47,239,74,1,72,138,136,255,2,40,10,160,122,146,187,26124),
(92,229,51,187,109,101,114,122,88,50,104,13,98,11,11,193,11,26124),
(93,2,153,11,18,38,12,30,159,221,115,254,71,203,171,112,36,26124),
(94,27,120,155,135,251,60,146,56,213,40,153,123,250,180,65,134,26124),
(97,231,154,235,136,177,80,159,98,143,56,32,130,1,116,28,48,26124),
(98,167,54,251,245,141,88,123,57,114,206,21,74,134,174,69,64,26124),
(99,1,123,52,114,193,222,227,4,250,11,47,248,229,63,247,214,26124),
(100,56,195,251,57,180,151,23,96,180,185,130,254,159,9,80,20,26124),
(101,46,58,83,213,154,73,30,92,209,115,243,55,247,205,140,97,26124),
(102,41,13,39,176,232,113,248,197,177,74,20,229,20,208,240,217,26124),
(103,162,85,98,16,174,84,34,230,214,30,218,175,18,44,182,55,26124),
(105,193,78,236,141,90,238,249,63,168,17,212,80,180,228,110,145,26124),
(115,69,129,51,170,67,148,154,20,22,50,196,248,89,109,226,176,26124),
(117,87,121,14,72,211,85,0,231,13,248,18,89,79,80,123,231,26124),
(118,103,25,123,205,157,14,240,196,8,83,120,250,166,154,50,100,26124),
(119,39,183,80,24,78,83,41,196,228,69,92,189,62,31,213,171,26124),
(60,114,169,122,36,169,152,227,165,80,15,56,113,243,118,40,192,26124),
(61,56,50,215,196,42,172,146,104,240,11,231,182,180,142,201,175,26124),
(63,216,59,188,180,108,196,56,177,122,72,231,108,79,86,84,163,26124),
(64,240,253,225,210,155,39,79,110,125,189,183,255,129,95,233,16,26124),
(65,133,112,144,217,38,187,40,174,218,75,240,40,202,204,75,163,26124),
(67,118,88,59,218,205,82,87,163,247,61,21,152,162,202,45,153,26124),
(72,171,85,174,27,240,199,197,25,175,240,40,193,86,16,164,91,26124),
(74,148,109,86,89,242,250,243,39,192,183,236,130,139,116,138,219,26124),
(75,205,12,15,250,173,147,99,236,20,221,37,236,221,42,91,98,26124),
(73,123,111,163,130,225,250,209,70,92,133,30,63,71,52,161,179,24367),
(95,50,103,158,167,176,249,158,191,79,161,112,232,71,234,67,154,26124),
(104,72,148,97,35,5,11,0,167,239,177,192,41,238,108,196,56,26124);

/*Table structure for table `tact_key_lookup` */

DROP TABLE IF EXISTS `tact_key_lookup`;

CREATE TABLE `tact_key_lookup` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `TACTID1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TACTID2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TACTID3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TACTID4` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TACTID5` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TACTID6` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TACTID7` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TACTID8` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `tact_key_lookup` */

/*Table structure for table `talent` */

DROP TABLE IF EXISTS `talent`;

CREATE TABLE `talent` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Description` text,
  `SpellID` int(11) NOT NULL DEFAULT '0',
  `OverridesSpellID` int(11) NOT NULL DEFAULT '0',
  `SpecID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `TierID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ColumnIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CategoryMask1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CategoryMask2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ClassID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `talent` */

/*Table structure for table `talent_locale` */

DROP TABLE IF EXISTS `talent_locale`;

CREATE TABLE `talent_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Description_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `talent_locale` */

/*Table structure for table `taxi_nodes` */

DROP TABLE IF EXISTS `taxi_nodes`;

CREATE TABLE `taxi_nodes` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `Name` text,
  `PosX` float NOT NULL DEFAULT '0',
  `PosY` float NOT NULL DEFAULT '0',
  `PosZ` float NOT NULL DEFAULT '0',
  `MountCreatureID1` int(11) NOT NULL DEFAULT '0',
  `MountCreatureID2` int(11) NOT NULL DEFAULT '0',
  `MapOffset1` float NOT NULL DEFAULT '0',
  `MapOffset2` float NOT NULL DEFAULT '0',
  `Facing` float NOT NULL DEFAULT '0',
  `FlightMapOffset1` float NOT NULL DEFAULT '0',
  `FlightMapOffset2` float NOT NULL DEFAULT '0',
  `ContinentID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ConditionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CharacterBitNumber` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `UiTextureKitID` int(11) NOT NULL DEFAULT '0',
  `SpecialIconConditionID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `taxi_nodes` */

insert  into `taxi_nodes`(`ID`,`Name`,`PosX`,`PosY`,`PosZ`,`MountCreatureID1`,`MountCreatureID2`,`MapOffset1`,`MapOffset2`,`Facing`,`FlightMapOffset1`,`FlightMapOffset2`,`ContinentID`,`ConditionID`,`CharacterBitNumber`,`Flags`,`UiTextureKitID`,`SpecialIconConditionID`,`VerifiedBuild`) values 
(1733,'Quest Path 5286: 7.0 DH-Mardum - Illidari Foothold -> The Fel Hammer (ELM)',1452,1688,47.3,99257,99257,0,0,0,0,0,1481,0,0,0,0,0,0),
(1647,'Дозорный пункт Мало, Танаанские джунгли',4457.54,-574.693,49.3765,26164,26164,0,0,0,0,0,1464,0,423,3,0,0,0),
(1646,'Сокровищница Земли, Танаанские джунгли',3475.28,-762.552,41.3906,85796,85796,0,0,0,0,0,1464,0,417,3,0,0,0),
(1645,'Железный фронт, Танаанские джунгли',4074.97,1183.75,160.928,0,69067,0,0,0,0,0,1464,924,420,5,0,0,0),
(1644,'Железный фронт, Танаанские джунгли',3979.3,1216.62,164.197,85796,0,0,0,0,0,0,1464,923,421,2,0,0,0),
(1643,'Лагерь Актара, Танаанские джунгли',4569.44,335.054,221.197,84517,84517,0,0,0,0,0,1464,0,422,3,0,0,0),
(1621,'Вол\\\'мар, Танаанские джунгли',4307.91,-1465.31,78.9439,85796,0,0,0,0,0,0,1464,33174,414,2,0,0,0),
(1620,'Львиный дозор, Танаанские джунгли',3875.22,-1311.72,90.4673,0,69067,0,0,0,0,0,1464,33173,413,1,0,0,0),
(1648,'Убежище Ша\\\'наари, Танаанские джунгли',3728.38,157.931,56.1153,81930,81930,0,0,0,0,0,1464,0,424,3,0,0,0);

/*Table structure for table `taxi_nodes_locale` */

DROP TABLE IF EXISTS `taxi_nodes_locale`;

CREATE TABLE `taxi_nodes_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `taxi_nodes_locale` */

/*Table structure for table `taxi_path` */

DROP TABLE IF EXISTS `taxi_path`;

CREATE TABLE `taxi_path` (
  `FromTaxiNode` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ToTaxiNode` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `Cost` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `taxi_path` */

insert  into `taxi_path`(`FromTaxiNode`,`ToTaxiNode`,`ID`,`Cost`,`VerifiedBuild`) values 
(1733,1732,5286,0,0),
(1760,1760,5615,1100,0);

/*Table structure for table `taxi_path_node` */

DROP TABLE IF EXISTS `taxi_path_node`;

CREATE TABLE `taxi_path_node` (
  `LocX` float NOT NULL DEFAULT '0',
  `LocY` float NOT NULL DEFAULT '0',
  `LocZ` float NOT NULL DEFAULT '0',
  `PathID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ContinentID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `NodeIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Delay` int(11) NOT NULL DEFAULT '0',
  `ArrivalEventID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DepartureEventID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `taxi_path_node` */

/*Table structure for table `terrain_material` */

DROP TABLE IF EXISTS `terrain_material`;

CREATE TABLE `terrain_material` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Shader` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EnvMapDiffuseFileID` int(11) NOT NULL DEFAULT '0',
  `EnvMapSpecularFileID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `terrain_material` */

/*Table structure for table `terrain_type` */

DROP TABLE IF EXISTS `terrain_type`;

CREATE TABLE `terrain_type` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `TerrainDesc` text,
  `FootstepSprayRun` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FootstepSprayWalk` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SoundID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `terrain_type` */

/*Table structure for table `terrain_type_locale` */

DROP TABLE IF EXISTS `terrain_type_locale`;

CREATE TABLE `terrain_type_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `TerrainDesc_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `terrain_type_locale` */

/*Table structure for table `terrain_type_sounds` */

DROP TABLE IF EXISTS `terrain_type_sounds`;

CREATE TABLE `terrain_type_sounds` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `terrain_type_sounds` */

/*Table structure for table `terrain_type_sounds_locale` */

DROP TABLE IF EXISTS `terrain_type_sounds_locale`;

CREATE TABLE `terrain_type_sounds_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `terrain_type_sounds_locale` */

/*Table structure for table `texture_blend_set` */

DROP TABLE IF EXISTS `texture_blend_set`;

CREATE TABLE `texture_blend_set` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `TextureFileDataID1` int(11) NOT NULL DEFAULT '0',
  `TextureFileDataID2` int(11) NOT NULL DEFAULT '0',
  `TextureFileDataID3` int(11) NOT NULL DEFAULT '0',
  `TextureScrollRateU1` float NOT NULL DEFAULT '0',
  `TextureScrollRateU2` float NOT NULL DEFAULT '0',
  `TextureScrollRateU3` float NOT NULL DEFAULT '0',
  `TextureScrollRateV1` float NOT NULL DEFAULT '0',
  `TextureScrollRateV2` float NOT NULL DEFAULT '0',
  `TextureScrollRateV3` float NOT NULL DEFAULT '0',
  `TextureScaleU1` float NOT NULL DEFAULT '0',
  `TextureScaleU2` float NOT NULL DEFAULT '0',
  `TextureScaleU3` float NOT NULL DEFAULT '0',
  `TextureScaleV1` float NOT NULL DEFAULT '0',
  `TextureScaleV2` float NOT NULL DEFAULT '0',
  `TextureScaleV3` float NOT NULL DEFAULT '0',
  `ModX1` float NOT NULL DEFAULT '0',
  `ModX2` float NOT NULL DEFAULT '0',
  `ModX3` float NOT NULL DEFAULT '0',
  `ModX4` float NOT NULL DEFAULT '0',
  `SwizzleRed` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SwizzleGreen` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SwizzleBlue` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SwizzleAlpha` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `texture_blend_set` */

/*Table structure for table `texture_file_data` */

DROP TABLE IF EXISTS `texture_file_data`;

CREATE TABLE `texture_file_data` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `MaterialResourcesID` int(11) NOT NULL DEFAULT '0',
  `UsageType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `texture_file_data` */

/*Table structure for table `totem_category` */

DROP TABLE IF EXISTS `totem_category`;

CREATE TABLE `totem_category` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `TotemCategoryMask` int(10) unsigned NOT NULL DEFAULT '0',
  `TotemCategoryType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `totem_category` */

/*Table structure for table `totem_category_locale` */

DROP TABLE IF EXISTS `totem_category_locale`;

CREATE TABLE `totem_category_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `totem_category_locale` */

/*Table structure for table `toy` */

DROP TABLE IF EXISTS `toy`;

CREATE TABLE `toy` (
  `SourceText` text,
  `ItemID` int(11) NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SourceTypeEnum` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `toy` */

/*Table structure for table `toy_locale` */

DROP TABLE IF EXISTS `toy_locale`;

CREATE TABLE `toy_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `SourceText_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `toy_locale` */

/*Table structure for table `trade_skill_category` */

DROP TABLE IF EXISTS `trade_skill_category`;

CREATE TABLE `trade_skill_category` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `HordeName` text,
  `SkillLineID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ParentTradeSkillCategoryID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `trade_skill_category` */

/*Table structure for table `trade_skill_category_locale` */

DROP TABLE IF EXISTS `trade_skill_category_locale`;

CREATE TABLE `trade_skill_category_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `HordeName_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `trade_skill_category_locale` */

/*Table structure for table `trade_skill_item` */

DROP TABLE IF EXISTS `trade_skill_item`;

CREATE TABLE `trade_skill_item` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ItemLevel` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RequiredLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `trade_skill_item` */

/*Table structure for table `transform_matrix` */

DROP TABLE IF EXISTS `transform_matrix`;

CREATE TABLE `transform_matrix` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Pos1` float NOT NULL DEFAULT '0',
  `Pos2` float NOT NULL DEFAULT '0',
  `Pos3` float NOT NULL DEFAULT '0',
  `Yaw` float NOT NULL DEFAULT '0',
  `Pitch` float NOT NULL DEFAULT '0',
  `Roll` float NOT NULL DEFAULT '0',
  `Scale` float NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `transform_matrix` */

/*Table structure for table `transmog_holiday` */

DROP TABLE IF EXISTS `transmog_holiday`;

CREATE TABLE `transmog_holiday` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `RequiredTransmogHoliday` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `transmog_holiday` */

/*Table structure for table `transmog_set` */

DROP TABLE IF EXISTS `transmog_set`;

CREATE TABLE `transmog_set` (
  `Name` text,
  `ParentTransmogSetID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `UiOrder` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ExpansionID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `TrackingQuestID` int(11) NOT NULL DEFAULT '0',
  `ClassMask` int(11) NOT NULL DEFAULT '0',
  `ItemNameDescriptionID` int(11) NOT NULL DEFAULT '0',
  `TransmogSetGroupID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `transmog_set` */

/*Table structure for table `transmog_set_group` */

DROP TABLE IF EXISTS `transmog_set_group`;

CREATE TABLE `transmog_set_group` (
  `Name` text,
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `transmog_set_group` */

/*Table structure for table `transmog_set_group_locale` */

DROP TABLE IF EXISTS `transmog_set_group_locale`;

CREATE TABLE `transmog_set_group_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `transmog_set_group_locale` */

/*Table structure for table `transmog_set_item` */

DROP TABLE IF EXISTS `transmog_set_item`;

CREATE TABLE `transmog_set_item` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `TransmogSetID` int(11) NOT NULL DEFAULT '0',
  `ItemModifiedAppearanceID` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `transmog_set_item` */

/*Table structure for table `transmog_set_locale` */

DROP TABLE IF EXISTS `transmog_set_locale`;

CREATE TABLE `transmog_set_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `transmog_set_locale` */

/*Table structure for table `transport_animation` */

DROP TABLE IF EXISTS `transport_animation`;

CREATE TABLE `transport_animation` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `TimeIndex` int(11) NOT NULL DEFAULT '0',
  `PosX` float NOT NULL DEFAULT '0',
  `PosY` float NOT NULL DEFAULT '0',
  `PosZ` float NOT NULL DEFAULT '0',
  `SequenceID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TransportID` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `transport_animation` */

/*Table structure for table `transport_physics` */

DROP TABLE IF EXISTS `transport_physics`;

CREATE TABLE `transport_physics` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `WaveAmp` float NOT NULL DEFAULT '0',
  `WaveTimeScale` float NOT NULL DEFAULT '0',
  `RollAmp` float NOT NULL DEFAULT '0',
  `RollTimeScale` float NOT NULL DEFAULT '0',
  `PitchAmp` float NOT NULL DEFAULT '0',
  `PitchTimeScale` float NOT NULL DEFAULT '0',
  `MaxBank` float NOT NULL DEFAULT '0',
  `MaxBankTurnSpeed` float NOT NULL DEFAULT '0',
  `SpeedDampThresh` float NOT NULL DEFAULT '0',
  `SpeedDamp` float NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `transport_physics` */

/*Table structure for table `transport_rotation` */

DROP TABLE IF EXISTS `transport_rotation`;

CREATE TABLE `transport_rotation` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `TimeIndex` int(11) NOT NULL DEFAULT '0',
  `X` float NOT NULL DEFAULT '0',
  `Y` float NOT NULL DEFAULT '0',
  `Z` float NOT NULL DEFAULT '0',
  `W` float NOT NULL DEFAULT '0',
  `TransportID` int(10) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `transport_rotation` */

/*Table structure for table `trophy` */

DROP TABLE IF EXISTS `trophy`;

CREATE TABLE `trophy` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `GameObjectDisplayInfoID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `TrophyTypeID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `trophy` */

/*Table structure for table `trophy_locale` */

DROP TABLE IF EXISTS `trophy_locale`;

CREATE TABLE `trophy_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `trophy_locale` */

/*Table structure for table `u_i_expansion_display_info` */

DROP TABLE IF EXISTS `u_i_expansion_display_info`;

CREATE TABLE `u_i_expansion_display_info` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ExpansionLogo` int(11) NOT NULL DEFAULT '0',
  `ExpansionBanner` int(11) NOT NULL DEFAULT '0',
  `ExpansionLevel` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `u_i_expansion_display_info` */

/*Table structure for table `u_i_expansion_display_info_icon` */

DROP TABLE IF EXISTS `u_i_expansion_display_info_icon`;

CREATE TABLE `u_i_expansion_display_info_icon` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `FeatureDescription` text,
  `ParentID` int(11) NOT NULL DEFAULT '0',
  `FeatureIcon` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `u_i_expansion_display_info_icon` */

/*Table structure for table `u_i_expansion_display_info_icon_locale` */

DROP TABLE IF EXISTS `u_i_expansion_display_info_icon_locale`;

CREATE TABLE `u_i_expansion_display_info_icon_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `FeatureDescription_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `u_i_expansion_display_info_icon_locale` */

/*Table structure for table `ui_cam_fback_transmog_chr_race` */

DROP TABLE IF EXISTS `ui_cam_fback_transmog_chr_race`;

CREATE TABLE `ui_cam_fback_transmog_chr_race` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `UiCameraID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ChrRaceID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Gender` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `InventoryType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Variation` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `ui_cam_fback_transmog_chr_race` */

/*Table structure for table `ui_cam_fback_transmog_weapon` */

DROP TABLE IF EXISTS `ui_cam_fback_transmog_weapon`;

CREATE TABLE `ui_cam_fback_transmog_weapon` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `UiCameraID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ItemClass` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ItemSubclass` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `InventoryType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `ui_cam_fback_transmog_weapon` */

/*Table structure for table `ui_camera` */

DROP TABLE IF EXISTS `ui_camera`;

CREATE TABLE `ui_camera` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Pos1` float NOT NULL DEFAULT '0',
  `Pos2` float NOT NULL DEFAULT '0',
  `Pos3` float NOT NULL DEFAULT '0',
  `LookAt1` float NOT NULL DEFAULT '0',
  `LookAt2` float NOT NULL DEFAULT '0',
  `LookAt3` float NOT NULL DEFAULT '0',
  `Up1` float NOT NULL DEFAULT '0',
  `Up2` float NOT NULL DEFAULT '0',
  `Up3` float NOT NULL DEFAULT '0',
  `AnimFrame` smallint(5) unsigned NOT NULL DEFAULT '0',
  `UiCameraTypeID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AnimVariation` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AnimID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `ui_camera` */

/*Table structure for table `ui_camera_locale` */

DROP TABLE IF EXISTS `ui_camera_locale`;

CREATE TABLE `ui_camera_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `ui_camera_locale` */

/*Table structure for table `ui_camera_type` */

DROP TABLE IF EXISTS `ui_camera_type`;

CREATE TABLE `ui_camera_type` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Width` int(11) NOT NULL DEFAULT '0',
  `Height` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `ui_camera_type` */

/*Table structure for table `ui_camera_type_locale` */

DROP TABLE IF EXISTS `ui_camera_type_locale`;

CREATE TABLE `ui_camera_type_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `ui_camera_type_locale` */

/*Table structure for table `ui_map_p_o_i` */

DROP TABLE IF EXISTS `ui_map_p_o_i`;

CREATE TABLE `ui_map_p_o_i` (
  `ContinentID` int(11) NOT NULL DEFAULT '0',
  `WorldLoc1` float NOT NULL DEFAULT '0',
  `WorldLoc2` float NOT NULL DEFAULT '0',
  `WorldLoc3` float NOT NULL DEFAULT '0',
  `UiTextureAtlasMemberID` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `PoiDataType` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PoiData` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `ui_map_p_o_i` */

/*Table structure for table `ui_model_scene` */

DROP TABLE IF EXISTS `ui_model_scene`;

CREATE TABLE `ui_model_scene` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `UiSystemType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `ui_model_scene` */

/*Table structure for table `ui_model_scene_actor` */

DROP TABLE IF EXISTS `ui_model_scene_actor`;

CREATE TABLE `ui_model_scene_actor` (
  `ScriptTag` text,
  `Position1` float NOT NULL DEFAULT '0',
  `Position2` float NOT NULL DEFAULT '0',
  `Position3` float NOT NULL DEFAULT '0',
  `OrientationYaw` float NOT NULL DEFAULT '0',
  `OrientationPitch` float NOT NULL DEFAULT '0',
  `OrientationRoll` float NOT NULL DEFAULT '0',
  `NormalizedScale` float NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `UiModelSceneActorDisplayID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `ui_model_scene_actor` */

/*Table structure for table `ui_model_scene_actor_display` */

DROP TABLE IF EXISTS `ui_model_scene_actor_display`;

CREATE TABLE `ui_model_scene_actor_display` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `AnimSpeed` float NOT NULL DEFAULT '0',
  `Alpha` float NOT NULL DEFAULT '0',
  `Scale` float NOT NULL DEFAULT '0',
  `AnimationID` int(11) NOT NULL DEFAULT '0',
  `SequenceVariation` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `ui_model_scene_actor_display` */

/*Table structure for table `ui_model_scene_actor_locale` */

DROP TABLE IF EXISTS `ui_model_scene_actor_locale`;

CREATE TABLE `ui_model_scene_actor_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `ScriptTag_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `ui_model_scene_actor_locale` */

/*Table structure for table `ui_model_scene_camera` */

DROP TABLE IF EXISTS `ui_model_scene_camera`;

CREATE TABLE `ui_model_scene_camera` (
  `ScriptTag` text,
  `Target1` float NOT NULL DEFAULT '0',
  `Target2` float NOT NULL DEFAULT '0',
  `Target3` float NOT NULL DEFAULT '0',
  `ZoomedTargetOffset1` float NOT NULL DEFAULT '0',
  `ZoomedTargetOffset2` float NOT NULL DEFAULT '0',
  `ZoomedTargetOffset3` float NOT NULL DEFAULT '0',
  `Yaw` float NOT NULL DEFAULT '0',
  `Pitch` float NOT NULL DEFAULT '0',
  `Roll` float NOT NULL DEFAULT '0',
  `ZoomedYawOffset` float NOT NULL DEFAULT '0',
  `ZoomedPitchOffset` float NOT NULL DEFAULT '0',
  `ZoomedRollOffset` float NOT NULL DEFAULT '0',
  `ZoomDistance` float NOT NULL DEFAULT '0',
  `MinZoomDistance` float NOT NULL DEFAULT '0',
  `MaxZoomDistance` float NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `CameraType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `ui_model_scene_camera` */

/*Table structure for table `ui_model_scene_camera_locale` */

DROP TABLE IF EXISTS `ui_model_scene_camera_locale`;

CREATE TABLE `ui_model_scene_camera_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `ScriptTag_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `ui_model_scene_camera_locale` */

/*Table structure for table `ui_texture_atlas` */

DROP TABLE IF EXISTS `ui_texture_atlas`;

CREATE TABLE `ui_texture_atlas` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `FileDataID` int(11) NOT NULL DEFAULT '0',
  `AtlasHeight` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AtlasWidth` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `ui_texture_atlas` */

/*Table structure for table `ui_texture_atlas_member` */

DROP TABLE IF EXISTS `ui_texture_atlas_member`;

CREATE TABLE `ui_texture_atlas_member` (
  `CommittedName` text,
  `ID` int(11) NOT NULL DEFAULT '0',
  `UiTextureAtlasID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CommittedLeft` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CommittedRight` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CommittedTop` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CommittedBottom` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CommittedFlags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `ui_texture_atlas_member` */

/*Table structure for table `ui_texture_atlas_member_locale` */

DROP TABLE IF EXISTS `ui_texture_atlas_member_locale`;

CREATE TABLE `ui_texture_atlas_member_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `CommittedName_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `ui_texture_atlas_member_locale` */

/*Table structure for table `ui_texture_kit` */

DROP TABLE IF EXISTS `ui_texture_kit`;

CREATE TABLE `ui_texture_kit` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `KitPrefix` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `ui_texture_kit` */

/*Table structure for table `ui_texture_kit_locale` */

DROP TABLE IF EXISTS `ui_texture_kit_locale`;

CREATE TABLE `ui_texture_kit_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `KitPrefix_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `ui_texture_kit_locale` */

/*Table structure for table `unit_blood` */

DROP TABLE IF EXISTS `unit_blood`;

CREATE TABLE `unit_blood` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `PlayerCritBloodSpurtID` int(11) NOT NULL DEFAULT '0',
  `PlayerHitBloodSpurtID` int(11) NOT NULL DEFAULT '0',
  `DefaultBloodSpurtID` int(11) NOT NULL DEFAULT '0',
  `PlayerOmniCritBloodSpurtID` int(11) NOT NULL DEFAULT '0',
  `PlayerOmniHitBloodSpurtID` int(11) NOT NULL DEFAULT '0',
  `DefaultOmniBloodSpurtID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `unit_blood` */

/*Table structure for table `unit_blood_levels` */

DROP TABLE IF EXISTS `unit_blood_levels`;

CREATE TABLE `unit_blood_levels` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Violencelevel1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Violencelevel2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Violencelevel3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `unit_blood_levels` */

/*Table structure for table `unit_condition` */

DROP TABLE IF EXISTS `unit_condition`;

CREATE TABLE `unit_condition` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Value1` int(11) NOT NULL DEFAULT '0',
  `Value2` int(11) NOT NULL DEFAULT '0',
  `Value3` int(11) NOT NULL DEFAULT '0',
  `Value4` int(11) NOT NULL DEFAULT '0',
  `Value5` int(11) NOT NULL DEFAULT '0',
  `Value6` int(11) NOT NULL DEFAULT '0',
  `Value7` int(11) NOT NULL DEFAULT '0',
  `Value8` int(11) NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Variable1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Variable2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Variable3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Variable4` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Variable5` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Variable6` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Variable7` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Variable8` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Op1` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Op2` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Op3` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Op4` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Op5` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Op6` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Op7` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Op8` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `unit_condition` */

/*Table structure for table `unit_power_bar` */

DROP TABLE IF EXISTS `unit_power_bar`;

CREATE TABLE `unit_power_bar` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Cost` text,
  `OutOfError` text,
  `ToolTip` text,
  `RegenerationPeace` float NOT NULL DEFAULT '0',
  `RegenerationCombat` float NOT NULL DEFAULT '0',
  `FileDataID1` int(11) NOT NULL DEFAULT '0',
  `FileDataID2` int(11) NOT NULL DEFAULT '0',
  `FileDataID3` int(11) NOT NULL DEFAULT '0',
  `FileDataID4` int(11) NOT NULL DEFAULT '0',
  `FileDataID5` int(11) NOT NULL DEFAULT '0',
  `FileDataID6` int(11) NOT NULL DEFAULT '0',
  `Color1` int(10) unsigned NOT NULL DEFAULT '0',
  `Color2` int(10) unsigned NOT NULL DEFAULT '0',
  `Color3` int(10) unsigned NOT NULL DEFAULT '0',
  `Color4` int(10) unsigned NOT NULL DEFAULT '0',
  `Color5` int(10) unsigned NOT NULL DEFAULT '0',
  `Color6` int(10) unsigned NOT NULL DEFAULT '0',
  `StartInset` float NOT NULL DEFAULT '0',
  `EndInset` float NOT NULL DEFAULT '0',
  `StartPower` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Flags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CenterPower` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `BarType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MinPower` int(11) NOT NULL DEFAULT '0',
  `MaxPower` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `unit_power_bar` */

/*Table structure for table `unit_power_bar_locale` */

DROP TABLE IF EXISTS `unit_power_bar_locale`;

CREATE TABLE `unit_power_bar_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `Cost_lang` text,
  `OutOfError_lang` text,
  `ToolTip_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `unit_power_bar_locale` */

/*Table structure for table `vehicle` */

DROP TABLE IF EXISTS `vehicle`;

CREATE TABLE `vehicle` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Flags` int(10) unsigned NOT NULL DEFAULT '0',
  `TurnSpeed` float NOT NULL DEFAULT '0',
  `PitchSpeed` float NOT NULL DEFAULT '0',
  `PitchMin` float NOT NULL DEFAULT '0',
  `PitchMax` float NOT NULL DEFAULT '0',
  `MouseLookOffsetPitch` float NOT NULL DEFAULT '0',
  `CameraFadeDistScalarMin` float NOT NULL DEFAULT '0',
  `CameraFadeDistScalarMax` float NOT NULL DEFAULT '0',
  `CameraPitchOffset` float NOT NULL DEFAULT '0',
  `FacingLimitRight` float NOT NULL DEFAULT '0',
  `FacingLimitLeft` float NOT NULL DEFAULT '0',
  `CameraYawOffset` float NOT NULL DEFAULT '0',
  `SeatID1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SeatID2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SeatID3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SeatID4` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SeatID5` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SeatID6` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SeatID7` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SeatID8` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VehicleUIIndicatorID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PowerDisplayID1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PowerDisplayID2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PowerDisplayID3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `FlagsB` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `UiLocomotionType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MissileTargetingID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `vehicle` */

/*Table structure for table `vehicle_seat` */

DROP TABLE IF EXISTS `vehicle_seat`;

CREATE TABLE `vehicle_seat` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Flags` int(10) unsigned NOT NULL DEFAULT '0',
  `FlagsB` int(10) unsigned NOT NULL DEFAULT '0',
  `FlagsC` int(10) unsigned NOT NULL DEFAULT '0',
  `AttachmentOffsetX` float NOT NULL DEFAULT '0',
  `AttachmentOffsetY` float NOT NULL DEFAULT '0',
  `AttachmentOffsetZ` float NOT NULL DEFAULT '0',
  `EnterPreDelay` float NOT NULL DEFAULT '0',
  `EnterSpeed` float NOT NULL DEFAULT '0',
  `EnterGravity` float NOT NULL DEFAULT '0',
  `EnterMinDuration` float NOT NULL DEFAULT '0',
  `EnterMaxDuration` float NOT NULL DEFAULT '0',
  `EnterMinArcHeight` float NOT NULL DEFAULT '0',
  `EnterMaxArcHeight` float NOT NULL DEFAULT '0',
  `ExitPreDelay` float NOT NULL DEFAULT '0',
  `ExitSpeed` float NOT NULL DEFAULT '0',
  `ExitGravity` float NOT NULL DEFAULT '0',
  `ExitMinDuration` float NOT NULL DEFAULT '0',
  `ExitMaxDuration` float NOT NULL DEFAULT '0',
  `ExitMinArcHeight` float NOT NULL DEFAULT '0',
  `ExitMaxArcHeight` float NOT NULL DEFAULT '0',
  `PassengerYaw` float NOT NULL DEFAULT '0',
  `PassengerPitch` float NOT NULL DEFAULT '0',
  `PassengerRoll` float NOT NULL DEFAULT '0',
  `VehicleEnterAnimDelay` float NOT NULL DEFAULT '0',
  `VehicleExitAnimDelay` float NOT NULL DEFAULT '0',
  `CameraEnteringDelay` float NOT NULL DEFAULT '0',
  `CameraEnteringDuration` float NOT NULL DEFAULT '0',
  `CameraExitingDelay` float NOT NULL DEFAULT '0',
  `CameraExitingDuration` float NOT NULL DEFAULT '0',
  `CameraOffsetX` float NOT NULL DEFAULT '0',
  `CameraOffsetY` float NOT NULL DEFAULT '0',
  `CameraOffsetZ` float NOT NULL DEFAULT '0',
  `CameraPosChaseRate` float NOT NULL DEFAULT '0',
  `CameraFacingChaseRate` float NOT NULL DEFAULT '0',
  `CameraEnteringZoom` float NOT NULL DEFAULT '0',
  `CameraSeatZoomMin` float NOT NULL DEFAULT '0',
  `CameraSeatZoomMax` float NOT NULL DEFAULT '0',
  `UiSkinFileDataID` int(11) NOT NULL DEFAULT '0',
  `EnterAnimStart` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EnterAnimLoop` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RideAnimStart` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RideAnimLoop` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RideUpperAnimStart` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RideUpperAnimLoop` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ExitAnimStart` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ExitAnimLoop` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ExitAnimEnd` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VehicleEnterAnim` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VehicleExitAnim` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VehicleRideAnimLoop` smallint(5) unsigned NOT NULL DEFAULT '0',
  `EnterAnimKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RideAnimKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ExitAnimKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VehicleEnterAnimKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VehicleRideAnimKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VehicleExitAnimKitID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `CameraModeID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AttachmentID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PassengerAttachmentID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VehicleEnterAnimBone` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VehicleExitAnimBone` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VehicleRideAnimLoopBone` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VehicleAbilityDisplay` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EnterUISoundID` int(11) NOT NULL DEFAULT '0',
  `ExitUISoundID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `vehicle_seat` */

/*Table structure for table `vehicle_u_i_ind_seat` */

DROP TABLE IF EXISTS `vehicle_u_i_ind_seat`;

CREATE TABLE `vehicle_u_i_ind_seat` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `XPos` float NOT NULL DEFAULT '0',
  `YPos` float NOT NULL DEFAULT '0',
  `VirtualSeatIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `vehicle_u_i_ind_seat` */

/*Table structure for table `vehicle_u_i_indicator` */

DROP TABLE IF EXISTS `vehicle_u_i_indicator`;

CREATE TABLE `vehicle_u_i_indicator` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `BackgroundTextureFileID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `vehicle_u_i_indicator` */

/*Table structure for table `version` */

DROP TABLE IF EXISTS `version`;

CREATE TABLE `version` (
  `core_version` varchar(120) DEFAULT NULL COMMENT 'Core revision dumped at startup.',
  `core_revision` varchar(120) DEFAULT NULL,
  `db_version` varchar(120) DEFAULT NULL COMMENT 'Version of hotfixes DB.'
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ROW_FORMAT=FIXED COMMENT='Version Notes';

/*Data for the table `version` */

insert  into `version`(`core_version`,`core_revision`,`db_version`) values 
('LegionCore','','LegionCore Hotfixes Database 2020-04-03');

/*Table structure for table `vignette` */

DROP TABLE IF EXISTS `vignette`;

CREATE TABLE `vignette` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `MaxHeight` float NOT NULL DEFAULT '0',
  `MinHeight` float NOT NULL DEFAULT '0',
  `QuestFeedbackEffectID` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `PlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `VisibleTrackingQuestID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `vignette` */

insert  into `vignette`(`ID`,`Name`,`MaxHeight`,`MinHeight`,`QuestFeedbackEffectID`,`Flags`,`PlayerConditionID`,`VisibleTrackingQuestID`,`VerifiedBuild`) values 
(6,'Debug Masta: resolve some problems',30,-30,90,67,0,0,0),
(2294,'Slithon the Last',0,0,89,32,0,48965,0),
(7,'Commander Payne: Bonus rewards',100,-100,89,67,0,0,0),
(2802,'Ennera, portal keeper',100,-100,89,67,0,0,0),
(2801,'Legion commander',100,-100,89,67,0,0,0),
(2800,'Legion Invasion',0,0,253,67,0,0,0),
(2804,'Evala',100,-100,89,67,0,0,0),
(2803,'Atray',100,-100,89,67,0,0,0);

/*Table structure for table `vignette_locale` */

DROP TABLE IF EXISTS `vignette_locale`;

CREATE TABLE `vignette_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `vignette_locale` */

/*Table structure for table `virtual_attachment` */

DROP TABLE IF EXISTS `virtual_attachment`;

CREATE TABLE `virtual_attachment` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `PositionerID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `virtual_attachment` */

/*Table structure for table `virtual_attachment_customization` */

DROP TABLE IF EXISTS `virtual_attachment_customization`;

CREATE TABLE `virtual_attachment_customization` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `FileDataID` int(11) NOT NULL DEFAULT '0',
  `VirtualAttachmentID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PositionerID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `virtual_attachment_customization` */

/*Table structure for table `virtual_attachment_locale` */

DROP TABLE IF EXISTS `virtual_attachment_locale`;

CREATE TABLE `virtual_attachment_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `virtual_attachment_locale` */

/*Table structure for table `vocal_u_i_sounds` */

DROP TABLE IF EXISTS `vocal_u_i_sounds`;

CREATE TABLE `vocal_u_i_sounds` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `VocalUIEnum` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RaceID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ClassID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `NormalSoundID1` int(11) NOT NULL DEFAULT '0',
  `NormalSoundID2` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `vocal_u_i_sounds` */

/*Table structure for table `wb_access_control_list` */

DROP TABLE IF EXISTS `wb_access_control_list`;

CREATE TABLE `wb_access_control_list` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `URL` text,
  `GrantFlags` smallint(5) unsigned NOT NULL DEFAULT '0',
  `RevokeFlags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `WowEditInternal` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RegionID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `wb_access_control_list` */

/*Table structure for table `wb_access_control_list_locale` */

DROP TABLE IF EXISTS `wb_access_control_list_locale`;

CREATE TABLE `wb_access_control_list_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `URL_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `wb_access_control_list_locale` */

/*Table structure for table `wb_cert_whitelist` */

DROP TABLE IF EXISTS `wb_cert_whitelist`;

CREATE TABLE `wb_cert_whitelist` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Domain` text,
  `GrantAccess` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RevokeAccess` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `WowEditInternal` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `wb_cert_whitelist` */

/*Table structure for table `wb_cert_whitelist_locale` */

DROP TABLE IF EXISTS `wb_cert_whitelist_locale`;

CREATE TABLE `wb_cert_whitelist_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Domain_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `wb_cert_whitelist_locale` */

/*Table structure for table `weapon_impact_sounds` */

DROP TABLE IF EXISTS `weapon_impact_sounds`;

CREATE TABLE `weapon_impact_sounds` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `WeaponSubClassID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ParrySoundType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ImpactSource` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ImpactSoundID1` int(11) NOT NULL DEFAULT '0',
  `ImpactSoundID2` int(11) NOT NULL DEFAULT '0',
  `ImpactSoundID3` int(11) NOT NULL DEFAULT '0',
  `ImpactSoundID4` int(11) NOT NULL DEFAULT '0',
  `ImpactSoundID5` int(11) NOT NULL DEFAULT '0',
  `ImpactSoundID6` int(11) NOT NULL DEFAULT '0',
  `ImpactSoundID7` int(11) NOT NULL DEFAULT '0',
  `ImpactSoundID8` int(11) NOT NULL DEFAULT '0',
  `ImpactSoundID9` int(11) NOT NULL DEFAULT '0',
  `ImpactSoundID10` int(11) NOT NULL DEFAULT '0',
  `ImpactSoundID11` int(11) NOT NULL DEFAULT '0',
  `CritImpactSoundID1` int(11) NOT NULL DEFAULT '0',
  `CritImpactSoundID2` int(11) NOT NULL DEFAULT '0',
  `CritImpactSoundID3` int(11) NOT NULL DEFAULT '0',
  `CritImpactSoundID4` int(11) NOT NULL DEFAULT '0',
  `CritImpactSoundID5` int(11) NOT NULL DEFAULT '0',
  `CritImpactSoundID6` int(11) NOT NULL DEFAULT '0',
  `CritImpactSoundID7` int(11) NOT NULL DEFAULT '0',
  `CritImpactSoundID8` int(11) NOT NULL DEFAULT '0',
  `CritImpactSoundID9` int(11) NOT NULL DEFAULT '0',
  `CritImpactSoundID10` int(11) NOT NULL DEFAULT '0',
  `CritImpactSoundID11` int(11) NOT NULL DEFAULT '0',
  `PierceImpactSoundID1` int(11) NOT NULL DEFAULT '0',
  `PierceImpactSoundID2` int(11) NOT NULL DEFAULT '0',
  `PierceImpactSoundID3` int(11) NOT NULL DEFAULT '0',
  `PierceImpactSoundID4` int(11) NOT NULL DEFAULT '0',
  `PierceImpactSoundID5` int(11) NOT NULL DEFAULT '0',
  `PierceImpactSoundID6` int(11) NOT NULL DEFAULT '0',
  `PierceImpactSoundID7` int(11) NOT NULL DEFAULT '0',
  `PierceImpactSoundID8` int(11) NOT NULL DEFAULT '0',
  `PierceImpactSoundID9` int(11) NOT NULL DEFAULT '0',
  `PierceImpactSoundID10` int(11) NOT NULL DEFAULT '0',
  `PierceImpactSoundID11` int(11) NOT NULL DEFAULT '0',
  `PierceCritImpactSoundID1` int(11) NOT NULL DEFAULT '0',
  `PierceCritImpactSoundID2` int(11) NOT NULL DEFAULT '0',
  `PierceCritImpactSoundID3` int(11) NOT NULL DEFAULT '0',
  `PierceCritImpactSoundID4` int(11) NOT NULL DEFAULT '0',
  `PierceCritImpactSoundID5` int(11) NOT NULL DEFAULT '0',
  `PierceCritImpactSoundID6` int(11) NOT NULL DEFAULT '0',
  `PierceCritImpactSoundID7` int(11) NOT NULL DEFAULT '0',
  `PierceCritImpactSoundID8` int(11) NOT NULL DEFAULT '0',
  `PierceCritImpactSoundID9` int(11) NOT NULL DEFAULT '0',
  `PierceCritImpactSoundID10` int(11) NOT NULL DEFAULT '0',
  `PierceCritImpactSoundID11` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `weapon_impact_sounds` */

/*Table structure for table `weapon_swing_sounds2` */

DROP TABLE IF EXISTS `weapon_swing_sounds2`;

CREATE TABLE `weapon_swing_sounds2` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SwingType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Crit` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SoundID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `weapon_swing_sounds2` */

/*Table structure for table `weapon_trail` */

DROP TABLE IF EXISTS `weapon_trail`;

CREATE TABLE `weapon_trail` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `FileDataID` int(11) NOT NULL DEFAULT '0',
  `Yaw` float NOT NULL DEFAULT '0',
  `Pitch` float NOT NULL DEFAULT '0',
  `Roll` float NOT NULL DEFAULT '0',
  `TextureFileDataID1` int(11) NOT NULL DEFAULT '0',
  `TextureFileDataID2` int(11) NOT NULL DEFAULT '0',
  `TextureFileDataID3` int(11) NOT NULL DEFAULT '0',
  `TextureScrollRateU1` float NOT NULL DEFAULT '0',
  `TextureScrollRateU2` float NOT NULL DEFAULT '0',
  `TextureScrollRateU3` float NOT NULL DEFAULT '0',
  `TextureScrollRateV1` float NOT NULL DEFAULT '0',
  `TextureScrollRateV2` float NOT NULL DEFAULT '0',
  `TextureScrollRateV3` float NOT NULL DEFAULT '0',
  `TextureScaleU1` float NOT NULL DEFAULT '0',
  `TextureScaleU2` float NOT NULL DEFAULT '0',
  `TextureScaleU3` float NOT NULL DEFAULT '0',
  `TextureScaleV1` float NOT NULL DEFAULT '0',
  `TextureScaleV2` float NOT NULL DEFAULT '0',
  `TextureScaleV3` float NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `weapon_trail` */

/*Table structure for table `weapon_trail_model_def` */

DROP TABLE IF EXISTS `weapon_trail_model_def`;

CREATE TABLE `weapon_trail_model_def` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `LowDefFileDataID` int(11) NOT NULL DEFAULT '0',
  `WeaponTrailID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `weapon_trail_model_def` */

/*Table structure for table `weapon_trail_param` */

DROP TABLE IF EXISTS `weapon_trail_param`;

CREATE TABLE `weapon_trail_param` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Duration` float NOT NULL DEFAULT '0',
  `FadeOutTime` float NOT NULL DEFAULT '0',
  `EdgeLifeSpan` float NOT NULL DEFAULT '0',
  `InitialDelay` float NOT NULL DEFAULT '0',
  `SmoothSampleAngle` float NOT NULL DEFAULT '0',
  `Hand` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `OverrideAttachTop` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `OverrideAttachBot` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `weapon_trail_param` */

/*Table structure for table `weather` */

DROP TABLE IF EXISTS `weather`;

CREATE TABLE `weather` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Intensity1` float NOT NULL DEFAULT '0',
  `Intensity2` float NOT NULL DEFAULT '0',
  `TransitionSkyBox` float NOT NULL DEFAULT '0',
  `EffectColor1` float NOT NULL DEFAULT '0',
  `EffectColor2` float NOT NULL DEFAULT '0',
  `EffectColor3` float NOT NULL DEFAULT '0',
  `Scale` float NOT NULL DEFAULT '0',
  `Volatility` float NOT NULL DEFAULT '0',
  `TwinkleIntensity` float NOT NULL DEFAULT '0',
  `FallModifier` float NOT NULL DEFAULT '0',
  `RotationalSpeed` float NOT NULL DEFAULT '0',
  `ParticulateFileDataID` int(11) NOT NULL DEFAULT '0',
  `SoundAmbienceID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EffectType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `WindSettingsID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `AmbienceID` int(11) NOT NULL DEFAULT '0',
  `EffectTextureFileDataID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `weather` */

/*Table structure for table `wind_settings` */

DROP TABLE IF EXISTS `wind_settings`;

CREATE TABLE `wind_settings` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `BaseMag` float NOT NULL DEFAULT '0',
  `BaseDir1` float NOT NULL DEFAULT '0',
  `BaseDir2` float NOT NULL DEFAULT '0',
  `BaseDir3` float NOT NULL DEFAULT '0',
  `VarianceMagOver` float NOT NULL DEFAULT '0',
  `VarianceMagUnder` float NOT NULL DEFAULT '0',
  `VarianceDir1` float NOT NULL DEFAULT '0',
  `VarianceDir2` float NOT NULL DEFAULT '0',
  `VarianceDir3` float NOT NULL DEFAULT '0',
  `MaxStepMag` float NOT NULL DEFAULT '0',
  `MaxStepDir1` float NOT NULL DEFAULT '0',
  `MaxStepDir2` float NOT NULL DEFAULT '0',
  `MaxStepDir3` float NOT NULL DEFAULT '0',
  `Frequency` float NOT NULL DEFAULT '0',
  `Duration` float NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `wind_settings` */

/*Table structure for table `wmo_area_table` */

DROP TABLE IF EXISTS `wmo_area_table`;

CREATE TABLE `wmo_area_table` (
  `AreaName` text,
  `WmoGroupID` int(11) NOT NULL DEFAULT '0',
  `AmbienceID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ZoneMusic` smallint(5) unsigned NOT NULL DEFAULT '0',
  `IntroSound` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AreaTableID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `UwIntroSound` smallint(5) unsigned NOT NULL DEFAULT '0',
  `UwAmbience` smallint(5) unsigned NOT NULL DEFAULT '0',
  `NameSetID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SoundProviderPref` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SoundProviderPrefUnderwater` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `UwZoneMusic` int(11) NOT NULL DEFAULT '0',
  `WmoID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `wmo_area_table` */

/*Table structure for table `wmo_area_table_locale` */

DROP TABLE IF EXISTS `wmo_area_table_locale`;

CREATE TABLE `wmo_area_table_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `AreaName_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `wmo_area_table_locale` */

/*Table structure for table `wmo_minimap_texture` */

DROP TABLE IF EXISTS `wmo_minimap_texture`;

CREATE TABLE `wmo_minimap_texture` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `FileDataID` int(11) NOT NULL DEFAULT '0',
  `GroupNum` smallint(5) unsigned NOT NULL DEFAULT '0',
  `BlockX` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `BlockY` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `wmo_minimap_texture` */

/*Table structure for table `world__pvp__area` */

DROP TABLE IF EXISTS `world__pvp__area`;

CREATE TABLE `world__pvp__area` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `AreaID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `NextTimeWorldstate` smallint(5) unsigned NOT NULL DEFAULT '0',
  `GameTimeWorldstate` smallint(5) unsigned NOT NULL DEFAULT '0',
  `BattlePopulate_time` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MapID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MinLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `MaxLevel` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `world__pvp__area` */

/*Table structure for table `world_boss_lockout` */

DROP TABLE IF EXISTS `world_boss_lockout`;

CREATE TABLE `world_boss_lockout` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `TrackingQuestID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `world_boss_lockout` */

/*Table structure for table `world_boss_lockout_locale` */

DROP TABLE IF EXISTS `world_boss_lockout_locale`;

CREATE TABLE `world_boss_lockout_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `world_boss_lockout_locale` */

/*Table structure for table `world_chunk_sounds` */

DROP TABLE IF EXISTS `world_chunk_sounds`;

CREATE TABLE `world_chunk_sounds` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `MapID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ChunkX` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ChunkY` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SubChunkX` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SubChunkY` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SoundOverrideID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `world_chunk_sounds` */

/*Table structure for table `world_effect` */

DROP TABLE IF EXISTS `world_effect`;

CREATE TABLE `world_effect` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `TargetAsset` int(10) unsigned NOT NULL DEFAULT '0',
  `CombatConditionID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `TargetType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `WhenToDisplay` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `QuestFeedbackEffectID` int(11) NOT NULL DEFAULT '0',
  `PlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `world_effect` */

/*Table structure for table `world_elapsed_timer` */

DROP TABLE IF EXISTS `world_elapsed_timer`;

CREATE TABLE `world_elapsed_timer` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `world_elapsed_timer` */

/*Table structure for table `world_elapsed_timer_locale` */

DROP TABLE IF EXISTS `world_elapsed_timer_locale`;

CREATE TABLE `world_elapsed_timer_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `world_elapsed_timer_locale` */

/*Table structure for table `world_map_area` */

DROP TABLE IF EXISTS `world_map_area`;

CREATE TABLE `world_map_area` (
  `AreaName` text,
  `LocLeft` float NOT NULL DEFAULT '0',
  `LocRight` float NOT NULL DEFAULT '0',
  `LocTop` float NOT NULL DEFAULT '0',
  `LocBottom` float NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `MapID` smallint(6) NOT NULL DEFAULT '0',
  `AreaID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DisplayMapID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `DefaultDungeonFloor` smallint(6) NOT NULL DEFAULT '0',
  `ParentWorldMapID` smallint(6) NOT NULL DEFAULT '0',
  `LevelRangeMin` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `LevelRangeMax` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `BountySetID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `BountyDisplayLocation` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `VisibilityPlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `world_map_area` */

/*Table structure for table `world_map_area_locale` */

DROP TABLE IF EXISTS `world_map_area_locale`;

CREATE TABLE `world_map_area_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `AreaName_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `world_map_area_locale` */

/*Table structure for table `world_map_continent` */

DROP TABLE IF EXISTS `world_map_continent`;

CREATE TABLE `world_map_continent` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `ContinentOffset1` float NOT NULL DEFAULT '0',
  `ContinentOffset2` float NOT NULL DEFAULT '0',
  `Scale` float NOT NULL DEFAULT '0',
  `TaxiMin1` float NOT NULL DEFAULT '0',
  `TaxiMin2` float NOT NULL DEFAULT '0',
  `TaxiMax1` float NOT NULL DEFAULT '0',
  `TaxiMax2` float NOT NULL DEFAULT '0',
  `MapID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WorldMapID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LeftBoundary` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `RightBoundary` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `TopBoundary` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `BottomBoundary` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `world_map_continent` */

/*Table structure for table `world_map_overlay` */

DROP TABLE IF EXISTS `world_map_overlay`;

CREATE TABLE `world_map_overlay` (
  `TextureName` text,
  `ID` int(11) NOT NULL DEFAULT '0',
  `TextureWidth` smallint(5) unsigned NOT NULL DEFAULT '0',
  `TextureHeight` smallint(5) unsigned NOT NULL DEFAULT '0',
  `MapAreaID` int(11) NOT NULL DEFAULT '0',
  `OffsetX` int(11) NOT NULL DEFAULT '0',
  `OffsetY` int(11) NOT NULL DEFAULT '0',
  `HitRectTop` int(11) NOT NULL DEFAULT '0',
  `HitRectLeft` int(11) NOT NULL DEFAULT '0',
  `HitRectBottom` int(11) NOT NULL DEFAULT '0',
  `HitRectRight` int(11) NOT NULL DEFAULT '0',
  `PlayerConditionID` int(11) NOT NULL DEFAULT '0',
  `Flags` int(11) NOT NULL DEFAULT '0',
  `AreaID1` int(11) NOT NULL DEFAULT '0',
  `AreaID2` int(11) NOT NULL DEFAULT '0',
  `AreaID3` int(11) NOT NULL DEFAULT '0',
  `AreaID4` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `world_map_overlay` */

/*Table structure for table `world_map_overlay_locale` */

DROP TABLE IF EXISTS `world_map_overlay_locale`;

CREATE TABLE `world_map_overlay_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `TextureName_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `world_map_overlay_locale` */

/*Table structure for table `world_map_transforms` */

DROP TABLE IF EXISTS `world_map_transforms`;

CREATE TABLE `world_map_transforms` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `RegionMinX` float NOT NULL DEFAULT '0',
  `RegionMinY` float NOT NULL DEFAULT '0',
  `RegionMinZ` float NOT NULL DEFAULT '0',
  `RegionMaxX` float NOT NULL DEFAULT '0',
  `RegionMaxY` float NOT NULL DEFAULT '0',
  `RegionMaxZ` float NOT NULL DEFAULT '0',
  `RegionOffsetX` float NOT NULL DEFAULT '0',
  `RegionOffsetY` float NOT NULL DEFAULT '0',
  `RegionScale` float NOT NULL DEFAULT '0',
  `MapID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AreaID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `NewMapID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `NewDungeonMapID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `NewAreaID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Priority` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `world_map_transforms` */

/*Table structure for table `world_safe_locs` */

DROP TABLE IF EXISTS `world_safe_locs`;

CREATE TABLE `world_safe_locs` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `LocX` float NOT NULL DEFAULT '0',
  `LocY` float NOT NULL DEFAULT '0',
  `LocZ` float NOT NULL DEFAULT '0',
  `LocO` float NOT NULL DEFAULT '0',
  `MapID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `world_safe_locs` */

insert  into `world_safe_locs`(`ID`,`Name`,`LocX`,`LocY`,`LocZ`,`LocO`,`MapID`,`VerifiedBuild`) values 
(191,'Rift: Stromgard',-1496.97,-1805.58,68.07,3.11,1178,0);

/*Table structure for table `world_safe_locs_locale` */

DROP TABLE IF EXISTS `world_safe_locs_locale`;

CREATE TABLE `world_safe_locs_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `world_safe_locs_locale` */

/*Table structure for table `world_state_expression` */

DROP TABLE IF EXISTS `world_state_expression`;

CREATE TABLE `world_state_expression` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Expression` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `world_state_expression` */

/*Table structure for table `world_state_u_i` */

DROP TABLE IF EXISTS `world_state_u_i`;

CREATE TABLE `world_state_u_i` (
  `Icon` text,
  `ExtendedUI` text,
  `DynamicTooltip` text,
  `String` text,
  `Tooltip` text,
  `MapID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AreaID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PhaseID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `PhaseGroupID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `StateVariable` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ExtendedUIStateVariable1` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ExtendedUIStateVariable2` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ExtendedUIStateVariable3` smallint(5) unsigned NOT NULL DEFAULT '0',
  `OrderIndex` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `PhaseUseFlags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `Type` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ID` int(11) NOT NULL DEFAULT '0',
  `DynamicIconFileID` int(11) NOT NULL DEFAULT '0',
  `DynamicFlashIconFileID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `world_state_u_i` */

insert  into `world_state_u_i`(`Icon`,`ExtendedUI`,`DynamicTooltip`,`String`,`Tooltip`,`MapID`,`AreaID`,`PhaseID`,`PhaseGroupID`,`StateVariable`,`ExtendedUIStateVariable1`,`ExtendedUIStateVariable2`,`ExtendedUIStateVariable3`,`OrderIndex`,`PhaseUseFlags`,`Type`,`ID`,`DynamicIconFileID`,`DynamicFlashIconFileID`,`VerifiedBuild`) values 
('interface\\targetingframe\\ui-pvp-alliance',NULL,NULL,'Cобрано азерита: %13844w/%13846w','Альянс: собрано азерита',1803,0,0,0,0,0,0,0,1,0,0,742,0,0,0);

/*Table structure for table `world_state_u_i_locale` */

DROP TABLE IF EXISTS `world_state_u_i_locale`;

CREATE TABLE `world_state_u_i_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Icon_lang` text,
  `ExtendedUI_lang` text,
  `DynamicTooltip_lang` text,
  `String_lang` text,
  `Tooltip_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `world_state_u_i_locale` */

insert  into `world_state_u_i_locale`(`ID`,`locale`,`Icon_lang`,`ExtendedUI_lang`,`DynamicTooltip_lang`,`String_lang`,`Tooltip_lang`,`VerifiedBuild`) values 
(742,'enUs','interface\\targetingframe\\ui-pvp-alliance',NULL,NULL,'azerite collected: %13844w/%13846w','alliance azerite collected',1);

/*Table structure for table `world_state_zone_sounds` */

DROP TABLE IF EXISTS `world_state_zone_sounds`;

CREATE TABLE `world_state_zone_sounds` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `WmoAreaID` int(11) NOT NULL DEFAULT '0',
  `WorldStateID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `WorldStateValue` smallint(5) unsigned NOT NULL DEFAULT '0',
  `AreaID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ZoneIntroMusicID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `ZoneMusicID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SoundAmbienceID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `SoundProviderPreferencesID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `world_state_zone_sounds` */

/*Table structure for table `zone_intro_music_table` */

DROP TABLE IF EXISTS `zone_intro_music_table`;

CREATE TABLE `zone_intro_music_table` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `MinDelayMinutes` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Priority` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `SoundID` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `zone_intro_music_table` */

/*Table structure for table `zone_intro_music_table_locale` */

DROP TABLE IF EXISTS `zone_intro_music_table_locale`;

CREATE TABLE `zone_intro_music_table_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `zone_intro_music_table_locale` */

/*Table structure for table `zone_light` */

DROP TABLE IF EXISTS `zone_light`;

CREATE TABLE `zone_light` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Name` text,
  `MapID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `LightID` smallint(5) unsigned NOT NULL DEFAULT '0',
  `Flags` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `zone_light` */

/*Table structure for table `zone_light_locale` */

DROP TABLE IF EXISTS `zone_light_locale`;

CREATE TABLE `zone_light_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `Name_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `zone_light_locale` */

/*Table structure for table `zone_light_point` */

DROP TABLE IF EXISTS `zone_light_point`;

CREATE TABLE `zone_light_point` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `Pos1` float NOT NULL DEFAULT '0',
  `Pos2` float NOT NULL DEFAULT '0',
  `PointOrder` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `zone_light_point` */

/*Table structure for table `zone_music` */

DROP TABLE IF EXISTS `zone_music`;

CREATE TABLE `zone_music` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `SetName` text,
  `SilenceIntervalMin1` int(11) NOT NULL DEFAULT '0',
  `SilenceIntervalMin2` int(11) NOT NULL DEFAULT '0',
  `SilenceIntervalMax1` int(11) NOT NULL DEFAULT '0',
  `SilenceIntervalMax2` int(11) NOT NULL DEFAULT '0',
  `Sounds1` int(11) NOT NULL DEFAULT '0',
  `Sounds2` int(11) NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `zone_music` */

/*Table structure for table `zone_music_locale` */

DROP TABLE IF EXISTS `zone_music_locale`;

CREATE TABLE `zone_music_locale` (
  `ID` int(10) unsigned NOT NULL DEFAULT '0',
  `locale` varchar(4) NOT NULL,
  `SetName_lang` text,
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`,`locale`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `zone_music_locale` */

/*Table structure for table `zone_story` */

DROP TABLE IF EXISTS `zone_story`;

CREATE TABLE `zone_story` (
  `ID` int(11) NOT NULL DEFAULT '0',
  `DisplayAchievementID` int(11) NOT NULL DEFAULT '0',
  `DisplayWorldMapAreaID` int(11) NOT NULL DEFAULT '0',
  `PlayerFactionGroupID` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `VerifiedBuild` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/*Data for the table `zone_story` */

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
